/*
 * Copyright (c) 2014 - 2015, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * WARNING! DO NOT EDIT THIS FILE DIRECTLY!
 *
 * This file was generated automatically and any changes may be lost.
 */
#ifndef __HW_iMX6DP_REGISTERS_H__
#define __HW_iMX6DP_REGISTERS_H__

#include "fsl_bitaccess.h"

/*
 * iMX6DP AIPSTZ
 *
 * AIPSTZ Control Registers
 *
 * Registers defined in this header file:
 * - HW_AIPSTZ_MPR - Master Priviledge Registers
 * - HW_AIPSTZ_OPACR - Off-Platform Peripheral Access Control Registers
 * - HW_AIPSTZ_OPACR1 - Off-Platform Peripheral Access Control Registers
 * - HW_AIPSTZ_OPACR2 - Off-Platform Peripheral Access Control Registers
 * - HW_AIPSTZ_OPACR3 - Off-Platform Peripheral Access Control Registers
 * - HW_AIPSTZ_OPACR4 - Off-Platform Peripheral Access Control Registers
 *
 * - hw_aipstz_t - Struct containing all module registers.
 */

#define HW_AIPSTZ_INSTANCE_COUNT (2U) /*!< Number of instances of the AIPSTZ module. */
#define HW_AIPSTZ1 (0U) /*!< Instance number for AIPSTZ1. */
#define HW_AIPSTZ2 (1U) /*!< Instance number for AIPSTZ2. */
#define AIPSTZ1_BASE          (0x207C000U) /*!< Base address for AIPSTZ1. */
#define AIPSTZ2_BASE          (0x217C000U) /*!< Base address for AIPSTZ2. */
/*! Array initializer of AIPSTZ base addresses. */
#define AIPSTZ_BASE_ADDRS     { AIPSTZ1_BASE, AIPSTZ2_BASE }

/*******************************************************************************
 * HW_AIPSTZ_MPR - Master Priviledge Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_MPR - Master Priviledge Registers (RW)
 *
 * Reset value: 0x77000000U
 *
 * Each AIPSTZ_MPR specifies 16 4-bit fields defining the access privilege level
 * associated with a bus master in the platform, as well as specifying whether
 * write accesses from this master are bufferable shown in The registers provide
 * one field per bus master, where field 15 corresponds to master 15, field 14 to
 * master 14,... field 0 to master 0 (typically the processor core). The master
 * index allocation is shown in . MPROT Field Bit Field Description 3 MBW Master
 * Buffer Writes - This bit determines whether the AIPSTZ is enabled to buffer
 * writes from this master. 2 MTR Master Trusted for Reads - This bit determines
 * whether the master is trusted for read accesses. 1 MTW Master Trusted for Writes
 * - This bit determines whether the master is trusted for write accesses. 0 MPL
 * Master Privilege Level - This bit determines how the privilege level of the
 * master is determined. The reset value is set to 0000_0000_7700_0000, which makes
 * master 0 and master 1 (ARM CORE) the trusted masters. Trusted software can
 * change the settings after reset. Master Index Allocation Master Index Master
 * Name Comments Master 0 All masters excluding ARM core, SDMA and CAAM Share the
 * same number allocation. Master 1 ARM CORE Master 2 CAAM Master 3 SDMA Master
 * 4-15 Reserved
 */
typedef union _hw_aipstz_mpr
{
    uint32_t U;
    struct _hw_aipstz_mpr_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t MPROT3 : 4;           /*!< [19:16]  */
        uint32_t MPROT2 : 4;           /*!< [23:20]  */
        uint32_t MPROT1 : 4;           /*!< [27:24]  */
        uint32_t MPROT0 : 4;           /*!< [31:28]  */
    } B;
} hw_aipstz_mpr_t;

/*!
 * @name Constants and macros for entire AIPSTZ_MPR register
 */
/*@{*/
#define HW_AIPSTZ_MPR_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_AIPSTZ_MPR(x)         (*(__IO hw_aipstz_mpr_t *) HW_AIPSTZ_MPR_ADDR(x))
#define HW_AIPSTZ_MPR_RD(x)      (HW_AIPSTZ_MPR(x).U)
#define HW_AIPSTZ_MPR_WR(x, v)   (HW_AIPSTZ_MPR(x).U = (v))
#define HW_AIPSTZ_MPR_SET(x, v)  (HW_AIPSTZ_MPR_WR(x, HW_AIPSTZ_MPR_RD(x) |  (v)))
#define HW_AIPSTZ_MPR_CLR(x, v)  (HW_AIPSTZ_MPR_WR(x, HW_AIPSTZ_MPR_RD(x) & ~(v)))
#define HW_AIPSTZ_MPR_TOG(x, v)  (HW_AIPSTZ_MPR_WR(x, HW_AIPSTZ_MPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_MPR bitfields
 */

/*!
 * @name Register AIPSTZ_MPR, field MPROT3[19:16] (RW)
 *
 * Master 3 Priviledge, Buffer, Read, Write Control.
 *
 * Values:
 * - xxx0 - Accesses from this master are forced to user-mode
 *     (ips_supervisor_access is forced to zero) regardless of the hprot[1] access attribute.
 * - xxx1 - Accesses from this master are not forced to user-mode. The hprot[1]
 *     access attribute is used directly to determine ips_supervisor_access.
 * - xx0x - This master is not trusted for write accesses.
 * - xx1x - This master is trusted for write accesses.
 * - x0xx - This master is not trusted for read accesses.
 * - x1xx - This master is trusted for read accesses.
 * - 1xxx - Write accesses from this master are allowed to be buffered
 */
/*@{*/
#define BP_AIPSTZ_MPR_MPROT3 (16U)         /*!< Bit position for AIPSTZ_MPR_MPROT3. */
#define BM_AIPSTZ_MPR_MPROT3 (0x000F0000U) /*!< Bit mask for AIPSTZ_MPR_MPROT3. */
#define BS_AIPSTZ_MPR_MPROT3 (4U)          /*!< Bit field size in bits for AIPSTZ_MPR_MPROT3. */

/*! @brief Read current value of the AIPSTZ_MPR_MPROT3 field. */
#define BR_AIPSTZ_MPR_MPROT3(x) (HW_AIPSTZ_MPR(x).B.MPROT3)

/*! @brief Format value for bitfield AIPSTZ_MPR_MPROT3. */
#define BF_AIPSTZ_MPR_MPROT3(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_MPR_MPROT3) & BM_AIPSTZ_MPR_MPROT3)

/*! @brief Set the MPROT3 field to a new value. */
#define BW_AIPSTZ_MPR_MPROT3(x, v) (HW_AIPSTZ_MPR_WR(x, (HW_AIPSTZ_MPR_RD(x) & ~BM_AIPSTZ_MPR_MPROT3) | BF_AIPSTZ_MPR_MPROT3(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_MPR, field MPROT2[23:20] (RW)
 *
 * Master 2 Priviledge, Buffer, Read, Write Control
 *
 * Values:
 * - xxx0 - Accesses from this master are forced to user-mode
 *     (ips_supervisor_access is forced to zero) regardless of the hprot[1] access attribute.
 * - xxx1 - Accesses from this master are not forced to user-mode. The hprot[1]
 *     access attribute is used directly to determine ips_supervisor_access.
 * - xx0x - This master is not trusted for write accesses.
 * - xx1x - This master is trusted for write accesses.
 * - x0xx - This master is not trusted for read accesses.
 * - x1xx - This master is trusted for read accesses.
 * - 1xxx - Write accesses from this master are allowed to be buffered
 */
/*@{*/
#define BP_AIPSTZ_MPR_MPROT2 (20U)         /*!< Bit position for AIPSTZ_MPR_MPROT2. */
#define BM_AIPSTZ_MPR_MPROT2 (0x00F00000U) /*!< Bit mask for AIPSTZ_MPR_MPROT2. */
#define BS_AIPSTZ_MPR_MPROT2 (4U)          /*!< Bit field size in bits for AIPSTZ_MPR_MPROT2. */

/*! @brief Read current value of the AIPSTZ_MPR_MPROT2 field. */
#define BR_AIPSTZ_MPR_MPROT2(x) (HW_AIPSTZ_MPR(x).B.MPROT2)

/*! @brief Format value for bitfield AIPSTZ_MPR_MPROT2. */
#define BF_AIPSTZ_MPR_MPROT2(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_MPR_MPROT2) & BM_AIPSTZ_MPR_MPROT2)

/*! @brief Set the MPROT2 field to a new value. */
#define BW_AIPSTZ_MPR_MPROT2(x, v) (HW_AIPSTZ_MPR_WR(x, (HW_AIPSTZ_MPR_RD(x) & ~BM_AIPSTZ_MPR_MPROT2) | BF_AIPSTZ_MPR_MPROT2(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_MPR, field MPROT1[27:24] (RW)
 *
 * Master 1 Priviledge, Buffer, Read, Write Control
 *
 * Values:
 * - xxx0 - Accesses from this master are forced to user-mode
 *     (ips_supervisor_access is forced to zero) regardless of the hprot[1] access attribute.
 * - xxx1 - Accesses from this master are not forced to user-mode. The hprot[1]
 *     access attribute is used directly to determine ips_supervisor_access.
 * - xx0x - This master is not trusted for write accesses.
 * - xx1x - This master is trusted for write accesses.
 * - x0xx - This master is not trusted for read accesses.
 * - x1xx - This master is trusted for read accesses.
 * - 1xxx - Write accesses from this master are allowed to be buffered
 */
/*@{*/
#define BP_AIPSTZ_MPR_MPROT1 (24U)         /*!< Bit position for AIPSTZ_MPR_MPROT1. */
#define BM_AIPSTZ_MPR_MPROT1 (0x0F000000U) /*!< Bit mask for AIPSTZ_MPR_MPROT1. */
#define BS_AIPSTZ_MPR_MPROT1 (4U)          /*!< Bit field size in bits for AIPSTZ_MPR_MPROT1. */

/*! @brief Read current value of the AIPSTZ_MPR_MPROT1 field. */
#define BR_AIPSTZ_MPR_MPROT1(x) (HW_AIPSTZ_MPR(x).B.MPROT1)

/*! @brief Format value for bitfield AIPSTZ_MPR_MPROT1. */
#define BF_AIPSTZ_MPR_MPROT1(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_MPR_MPROT1) & BM_AIPSTZ_MPR_MPROT1)

/*! @brief Set the MPROT1 field to a new value. */
#define BW_AIPSTZ_MPR_MPROT1(x, v) (HW_AIPSTZ_MPR_WR(x, (HW_AIPSTZ_MPR_RD(x) & ~BM_AIPSTZ_MPR_MPROT1) | BF_AIPSTZ_MPR_MPROT1(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_MPR, field MPROT0[31:28] (RW)
 *
 * Master 0 Priviledge, Buffer, Read, Write Control
 *
 * Values:
 * - xxx0 - Accesses from this master are forced to user-mode
 *     (ips_supervisor_access is forced to zero) regardless of the hprot[1] access attribute.
 * - xxx1 - Accesses from this master are not forced to user-mode. The hprot[1]
 *     access attribute is used directly to determine ips_supervisor_access.
 * - xx0x - This master is not trusted for write accesses.
 * - xx1x - This master is trusted for write accesses.
 * - x0xx - This master is not trusted for read accesses.
 * - x1xx - This master is trusted for read accesses.
 * - 1xxx - Write accesses from this master are allowed to be buffered
 */
/*@{*/
#define BP_AIPSTZ_MPR_MPROT0 (28U)         /*!< Bit position for AIPSTZ_MPR_MPROT0. */
#define BM_AIPSTZ_MPR_MPROT0 (0xF0000000U) /*!< Bit mask for AIPSTZ_MPR_MPROT0. */
#define BS_AIPSTZ_MPR_MPROT0 (4U)          /*!< Bit field size in bits for AIPSTZ_MPR_MPROT0. */

/*! @brief Read current value of the AIPSTZ_MPR_MPROT0 field. */
#define BR_AIPSTZ_MPR_MPROT0(x) (HW_AIPSTZ_MPR(x).B.MPROT0)

/*! @brief Format value for bitfield AIPSTZ_MPR_MPROT0. */
#define BF_AIPSTZ_MPR_MPROT0(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_MPR_MPROT0) & BM_AIPSTZ_MPR_MPROT0)

/*! @brief Set the MPROT0 field to a new value. */
#define BW_AIPSTZ_MPR_MPROT0(x, v) (HW_AIPSTZ_MPR_WR(x, (HW_AIPSTZ_MPR_RD(x) & ~BM_AIPSTZ_MPR_MPROT0) | BF_AIPSTZ_MPR_MPROT0(v)))
/*@}*/

/*******************************************************************************
 * HW_AIPSTZ_OPACR - Off-Platform Peripheral Access Control Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_OPACR - Off-Platform Peripheral Access Control Registers (RW)
 *
 * Reset value: 0x44444444U
 *
 * Each of the off-platform peripherals have an Off-platform Peripheral Access
 * Control Register (AIPSTZ_OPACR) which defines the access levels supported by
 * the given block. Each AIPSTZ_OPACR has the following format shown in OPAC Field
 * Bit Field Description 3 BW Buffer Writes - This bit determines whether write
 * accesses to this peripheral are allowed to be buffered.Buffered writes are not
 * available for AIPSTZ. This bit should be set to '0'. 2 SP Supervisor Protect -
 * This bit determines whether the peripheral requires supervisor privilege
 * level for access. 1 WP Write Protect - This bit determines whether the peripheral
 * allows write accesses. 0 TP Trusted Protect - This bit determines whether the
 * peripheral allows accesses from an untrusted master.
 */
typedef union _hw_aipstz_opacr
{
    uint32_t U;
    struct _hw_aipstz_opacr_bitfields
    {
        uint32_t OPAC7 : 4;            /*!< [3:0]  */
        uint32_t OPAC6 : 4;            /*!< [7:4]  */
        uint32_t OPAC5 : 4;            /*!< [11:8]  */
        uint32_t OPAC4 : 4;            /*!< [15:12]  */
        uint32_t OPAC3 : 4;            /*!< [19:16]  */
        uint32_t OPAC2 : 4;            /*!< [23:20]  */
        uint32_t OPAC1 : 4;            /*!< [27:24]  */
        uint32_t OPAC0 : 4;            /*!< [31:28]  */
    } B;
} hw_aipstz_opacr_t;

/*!
 * @name Constants and macros for entire AIPSTZ_OPACR register
 */
/*@{*/
#define HW_AIPSTZ_OPACR_ADDR(x)  ((uintptr_t)(x) + 0x40U)

#define HW_AIPSTZ_OPACR(x)       (*(__IO hw_aipstz_opacr_t *) HW_AIPSTZ_OPACR_ADDR(x))
#define HW_AIPSTZ_OPACR_RD(x)    (HW_AIPSTZ_OPACR(x).U)
#define HW_AIPSTZ_OPACR_WR(x, v) (HW_AIPSTZ_OPACR(x).U = (v))
#define HW_AIPSTZ_OPACR_SET(x, v) (HW_AIPSTZ_OPACR_WR(x, HW_AIPSTZ_OPACR_RD(x) |  (v)))
#define HW_AIPSTZ_OPACR_CLR(x, v) (HW_AIPSTZ_OPACR_WR(x, HW_AIPSTZ_OPACR_RD(x) & ~(v)))
#define HW_AIPSTZ_OPACR_TOG(x, v) (HW_AIPSTZ_OPACR_WR(x, HW_AIPSTZ_OPACR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_OPACR bitfields
 */

/*!
 * @name Register AIPSTZ_OPACR, field OPAC7[3:0] (RW)
 *
 * Off-platform Peripheral Access Control 7
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC7 (0U)         /*!< Bit position for AIPSTZ_OPACR_OPAC7. */
#define BM_AIPSTZ_OPACR_OPAC7 (0x0000000FU) /*!< Bit mask for AIPSTZ_OPACR_OPAC7. */
#define BS_AIPSTZ_OPACR_OPAC7 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC7. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC7 field. */
#define BR_AIPSTZ_OPACR_OPAC7(x) (HW_AIPSTZ_OPACR(x).B.OPAC7)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC7. */
#define BF_AIPSTZ_OPACR_OPAC7(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC7) & BM_AIPSTZ_OPACR_OPAC7)

/*! @brief Set the OPAC7 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC7(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC7) | BF_AIPSTZ_OPACR_OPAC7(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC6[7:4] (RW)
 *
 * Off-platform Peripheral Access Control 6
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC6 (4U)         /*!< Bit position for AIPSTZ_OPACR_OPAC6. */
#define BM_AIPSTZ_OPACR_OPAC6 (0x000000F0U) /*!< Bit mask for AIPSTZ_OPACR_OPAC6. */
#define BS_AIPSTZ_OPACR_OPAC6 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC6. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC6 field. */
#define BR_AIPSTZ_OPACR_OPAC6(x) (HW_AIPSTZ_OPACR(x).B.OPAC6)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC6. */
#define BF_AIPSTZ_OPACR_OPAC6(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC6) & BM_AIPSTZ_OPACR_OPAC6)

/*! @brief Set the OPAC6 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC6(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC6) | BF_AIPSTZ_OPACR_OPAC6(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC5[11:8] (RW)
 *
 * Off-platform Peripheral Access Control 5
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC5 (8U)         /*!< Bit position for AIPSTZ_OPACR_OPAC5. */
#define BM_AIPSTZ_OPACR_OPAC5 (0x00000F00U) /*!< Bit mask for AIPSTZ_OPACR_OPAC5. */
#define BS_AIPSTZ_OPACR_OPAC5 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC5. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC5 field. */
#define BR_AIPSTZ_OPACR_OPAC5(x) (HW_AIPSTZ_OPACR(x).B.OPAC5)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC5. */
#define BF_AIPSTZ_OPACR_OPAC5(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC5) & BM_AIPSTZ_OPACR_OPAC5)

/*! @brief Set the OPAC5 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC5(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC5) | BF_AIPSTZ_OPACR_OPAC5(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC4[15:12] (RW)
 *
 * Off-platform Peripheral Access Control 4
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC4 (12U)        /*!< Bit position for AIPSTZ_OPACR_OPAC4. */
#define BM_AIPSTZ_OPACR_OPAC4 (0x0000F000U) /*!< Bit mask for AIPSTZ_OPACR_OPAC4. */
#define BS_AIPSTZ_OPACR_OPAC4 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC4. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC4 field. */
#define BR_AIPSTZ_OPACR_OPAC4(x) (HW_AIPSTZ_OPACR(x).B.OPAC4)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC4. */
#define BF_AIPSTZ_OPACR_OPAC4(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC4) & BM_AIPSTZ_OPACR_OPAC4)

/*! @brief Set the OPAC4 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC4(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC4) | BF_AIPSTZ_OPACR_OPAC4(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC3[19:16] (RW)
 *
 * Off-platform Peripheral Access Control 3
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC3 (16U)        /*!< Bit position for AIPSTZ_OPACR_OPAC3. */
#define BM_AIPSTZ_OPACR_OPAC3 (0x000F0000U) /*!< Bit mask for AIPSTZ_OPACR_OPAC3. */
#define BS_AIPSTZ_OPACR_OPAC3 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC3. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC3 field. */
#define BR_AIPSTZ_OPACR_OPAC3(x) (HW_AIPSTZ_OPACR(x).B.OPAC3)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC3. */
#define BF_AIPSTZ_OPACR_OPAC3(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC3) & BM_AIPSTZ_OPACR_OPAC3)

/*! @brief Set the OPAC3 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC3(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC3) | BF_AIPSTZ_OPACR_OPAC3(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC2[23:20] (RW)
 *
 * Off-platform Peripheral Access Control 2
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC2 (20U)        /*!< Bit position for AIPSTZ_OPACR_OPAC2. */
#define BM_AIPSTZ_OPACR_OPAC2 (0x00F00000U) /*!< Bit mask for AIPSTZ_OPACR_OPAC2. */
#define BS_AIPSTZ_OPACR_OPAC2 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC2. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC2 field. */
#define BR_AIPSTZ_OPACR_OPAC2(x) (HW_AIPSTZ_OPACR(x).B.OPAC2)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC2. */
#define BF_AIPSTZ_OPACR_OPAC2(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC2) & BM_AIPSTZ_OPACR_OPAC2)

/*! @brief Set the OPAC2 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC2(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC2) | BF_AIPSTZ_OPACR_OPAC2(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC1[27:24] (RW)
 *
 * Off-platform Peripheral Access Control 1
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC1 (24U)        /*!< Bit position for AIPSTZ_OPACR_OPAC1. */
#define BM_AIPSTZ_OPACR_OPAC1 (0x0F000000U) /*!< Bit mask for AIPSTZ_OPACR_OPAC1. */
#define BS_AIPSTZ_OPACR_OPAC1 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC1. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC1 field. */
#define BR_AIPSTZ_OPACR_OPAC1(x) (HW_AIPSTZ_OPACR(x).B.OPAC1)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC1. */
#define BF_AIPSTZ_OPACR_OPAC1(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC1) & BM_AIPSTZ_OPACR_OPAC1)

/*! @brief Set the OPAC1 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC1(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC1) | BF_AIPSTZ_OPACR_OPAC1(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR, field OPAC0[31:28] (RW)
 *
 * Off-platform Peripheral Access Control 0
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR_OPAC0 (28U)        /*!< Bit position for AIPSTZ_OPACR_OPAC0. */
#define BM_AIPSTZ_OPACR_OPAC0 (0xF0000000U) /*!< Bit mask for AIPSTZ_OPACR_OPAC0. */
#define BS_AIPSTZ_OPACR_OPAC0 (4U)         /*!< Bit field size in bits for AIPSTZ_OPACR_OPAC0. */

/*! @brief Read current value of the AIPSTZ_OPACR_OPAC0 field. */
#define BR_AIPSTZ_OPACR_OPAC0(x) (HW_AIPSTZ_OPACR(x).B.OPAC0)

/*! @brief Format value for bitfield AIPSTZ_OPACR_OPAC0. */
#define BF_AIPSTZ_OPACR_OPAC0(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR_OPAC0) & BM_AIPSTZ_OPACR_OPAC0)

/*! @brief Set the OPAC0 field to a new value. */
#define BW_AIPSTZ_OPACR_OPAC0(x, v) (HW_AIPSTZ_OPACR_WR(x, (HW_AIPSTZ_OPACR_RD(x) & ~BM_AIPSTZ_OPACR_OPAC0) | BF_AIPSTZ_OPACR_OPAC0(v)))
/*@}*/

/*******************************************************************************
 * HW_AIPSTZ_OPACR1 - Off-Platform Peripheral Access Control Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_OPACR1 - Off-Platform Peripheral Access Control Registers (RW)
 *
 * Reset value: 0x44444444U
 *
 * Each of the off-platform peripherals have an Off-platform Peripheral Access
 * Control Register (AIPSTZ_OPACR) which defines the access levels supported by
 * the given block. Each AIPSTZ_OPACR has the following format shown in
 */
typedef union _hw_aipstz_opacr1
{
    uint32_t U;
    struct _hw_aipstz_opacr1_bitfields
    {
        uint32_t OPAC15 : 4;           /*!< [3:0]  */
        uint32_t OPAC14 : 4;           /*!< [7:4]  */
        uint32_t OPAC13 : 4;           /*!< [11:8]  */
        uint32_t OPAC12 : 4;           /*!< [15:12]  */
        uint32_t OPAC11 : 4;           /*!< [19:16]  */
        uint32_t OPAC10 : 4;           /*!< [23:20]  */
        uint32_t OPAC9 : 4;            /*!< [27:24]  */
        uint32_t OPAC8 : 4;            /*!< [31:28]  */
    } B;
} hw_aipstz_opacr1_t;

/*!
 * @name Constants and macros for entire AIPSTZ_OPACR1 register
 */
/*@{*/
#define HW_AIPSTZ_OPACR1_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_AIPSTZ_OPACR1(x)      (*(__IO hw_aipstz_opacr1_t *) HW_AIPSTZ_OPACR1_ADDR(x))
#define HW_AIPSTZ_OPACR1_RD(x)   (HW_AIPSTZ_OPACR1(x).U)
#define HW_AIPSTZ_OPACR1_WR(x, v) (HW_AIPSTZ_OPACR1(x).U = (v))
#define HW_AIPSTZ_OPACR1_SET(x, v) (HW_AIPSTZ_OPACR1_WR(x, HW_AIPSTZ_OPACR1_RD(x) |  (v)))
#define HW_AIPSTZ_OPACR1_CLR(x, v) (HW_AIPSTZ_OPACR1_WR(x, HW_AIPSTZ_OPACR1_RD(x) & ~(v)))
#define HW_AIPSTZ_OPACR1_TOG(x, v) (HW_AIPSTZ_OPACR1_WR(x, HW_AIPSTZ_OPACR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_OPACR1 bitfields
 */

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC15[3:0] (RW)
 *
 * Off-platform Peripheral Access Control 15
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC15 (0U)       /*!< Bit position for AIPSTZ_OPACR1_OPAC15. */
#define BM_AIPSTZ_OPACR1_OPAC15 (0x0000000FU) /*!< Bit mask for AIPSTZ_OPACR1_OPAC15. */
#define BS_AIPSTZ_OPACR1_OPAC15 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC15. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC15 field. */
#define BR_AIPSTZ_OPACR1_OPAC15(x) (HW_AIPSTZ_OPACR1(x).B.OPAC15)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC15. */
#define BF_AIPSTZ_OPACR1_OPAC15(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC15) & BM_AIPSTZ_OPACR1_OPAC15)

/*! @brief Set the OPAC15 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC15(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC15) | BF_AIPSTZ_OPACR1_OPAC15(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC14[7:4] (RW)
 *
 * Off-platform Peripheral Access Control 14
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC14 (4U)       /*!< Bit position for AIPSTZ_OPACR1_OPAC14. */
#define BM_AIPSTZ_OPACR1_OPAC14 (0x000000F0U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC14. */
#define BS_AIPSTZ_OPACR1_OPAC14 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC14. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC14 field. */
#define BR_AIPSTZ_OPACR1_OPAC14(x) (HW_AIPSTZ_OPACR1(x).B.OPAC14)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC14. */
#define BF_AIPSTZ_OPACR1_OPAC14(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC14) & BM_AIPSTZ_OPACR1_OPAC14)

/*! @brief Set the OPAC14 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC14(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC14) | BF_AIPSTZ_OPACR1_OPAC14(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC13[11:8] (RW)
 *
 * Off-platform Peripheral Access Control 13
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC13 (8U)       /*!< Bit position for AIPSTZ_OPACR1_OPAC13. */
#define BM_AIPSTZ_OPACR1_OPAC13 (0x00000F00U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC13. */
#define BS_AIPSTZ_OPACR1_OPAC13 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC13. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC13 field. */
#define BR_AIPSTZ_OPACR1_OPAC13(x) (HW_AIPSTZ_OPACR1(x).B.OPAC13)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC13. */
#define BF_AIPSTZ_OPACR1_OPAC13(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC13) & BM_AIPSTZ_OPACR1_OPAC13)

/*! @brief Set the OPAC13 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC13(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC13) | BF_AIPSTZ_OPACR1_OPAC13(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC12[15:12] (RW)
 *
 * Off-platform Peripheral Access Control 12
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC12 (12U)      /*!< Bit position for AIPSTZ_OPACR1_OPAC12. */
#define BM_AIPSTZ_OPACR1_OPAC12 (0x0000F000U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC12. */
#define BS_AIPSTZ_OPACR1_OPAC12 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC12. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC12 field. */
#define BR_AIPSTZ_OPACR1_OPAC12(x) (HW_AIPSTZ_OPACR1(x).B.OPAC12)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC12. */
#define BF_AIPSTZ_OPACR1_OPAC12(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC12) & BM_AIPSTZ_OPACR1_OPAC12)

/*! @brief Set the OPAC12 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC12(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC12) | BF_AIPSTZ_OPACR1_OPAC12(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC11[19:16] (RW)
 *
 * Off-platform Peripheral Access Control 11
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC11 (16U)      /*!< Bit position for AIPSTZ_OPACR1_OPAC11. */
#define BM_AIPSTZ_OPACR1_OPAC11 (0x000F0000U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC11. */
#define BS_AIPSTZ_OPACR1_OPAC11 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC11. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC11 field. */
#define BR_AIPSTZ_OPACR1_OPAC11(x) (HW_AIPSTZ_OPACR1(x).B.OPAC11)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC11. */
#define BF_AIPSTZ_OPACR1_OPAC11(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC11) & BM_AIPSTZ_OPACR1_OPAC11)

/*! @brief Set the OPAC11 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC11(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC11) | BF_AIPSTZ_OPACR1_OPAC11(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC10[23:20] (RW)
 *
 * Off-platform Peripheral Access Control 10
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC10 (20U)      /*!< Bit position for AIPSTZ_OPACR1_OPAC10. */
#define BM_AIPSTZ_OPACR1_OPAC10 (0x00F00000U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC10. */
#define BS_AIPSTZ_OPACR1_OPAC10 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC10. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC10 field. */
#define BR_AIPSTZ_OPACR1_OPAC10(x) (HW_AIPSTZ_OPACR1(x).B.OPAC10)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC10. */
#define BF_AIPSTZ_OPACR1_OPAC10(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC10) & BM_AIPSTZ_OPACR1_OPAC10)

/*! @brief Set the OPAC10 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC10(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC10) | BF_AIPSTZ_OPACR1_OPAC10(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC9[27:24] (RW)
 *
 * Off-platform Peripheral Access Control 9
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC9 (24U)       /*!< Bit position for AIPSTZ_OPACR1_OPAC9. */
#define BM_AIPSTZ_OPACR1_OPAC9 (0x0F000000U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC9. */
#define BS_AIPSTZ_OPACR1_OPAC9 (4U)        /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC9. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC9 field. */
#define BR_AIPSTZ_OPACR1_OPAC9(x) (HW_AIPSTZ_OPACR1(x).B.OPAC9)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC9. */
#define BF_AIPSTZ_OPACR1_OPAC9(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC9) & BM_AIPSTZ_OPACR1_OPAC9)

/*! @brief Set the OPAC9 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC9(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC9) | BF_AIPSTZ_OPACR1_OPAC9(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR1, field OPAC8[31:28] (RW)
 *
 * Off-platform Peripheral Access Control 8
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR1_OPAC8 (28U)       /*!< Bit position for AIPSTZ_OPACR1_OPAC8. */
#define BM_AIPSTZ_OPACR1_OPAC8 (0xF0000000U) /*!< Bit mask for AIPSTZ_OPACR1_OPAC8. */
#define BS_AIPSTZ_OPACR1_OPAC8 (4U)        /*!< Bit field size in bits for AIPSTZ_OPACR1_OPAC8. */

/*! @brief Read current value of the AIPSTZ_OPACR1_OPAC8 field. */
#define BR_AIPSTZ_OPACR1_OPAC8(x) (HW_AIPSTZ_OPACR1(x).B.OPAC8)

/*! @brief Format value for bitfield AIPSTZ_OPACR1_OPAC8. */
#define BF_AIPSTZ_OPACR1_OPAC8(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR1_OPAC8) & BM_AIPSTZ_OPACR1_OPAC8)

/*! @brief Set the OPAC8 field to a new value. */
#define BW_AIPSTZ_OPACR1_OPAC8(x, v) (HW_AIPSTZ_OPACR1_WR(x, (HW_AIPSTZ_OPACR1_RD(x) & ~BM_AIPSTZ_OPACR1_OPAC8) | BF_AIPSTZ_OPACR1_OPAC8(v)))
/*@}*/

/*******************************************************************************
 * HW_AIPSTZ_OPACR2 - Off-Platform Peripheral Access Control Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_OPACR2 - Off-Platform Peripheral Access Control Registers (RW)
 *
 * Reset value: 0x44444444U
 *
 * Each of the off-platform peripherals have an Off-platform Peripheral Access
 * Control Register (AIPSTZ_OPACR) which defines the access levels supported by
 * the given block. Each AIPSTZ_OPACR has the following format shown in
 */
typedef union _hw_aipstz_opacr2
{
    uint32_t U;
    struct _hw_aipstz_opacr2_bitfields
    {
        uint32_t OPAC23 : 4;           /*!< [3:0]  */
        uint32_t OPAC22 : 4;           /*!< [7:4]  */
        uint32_t OPAC21 : 4;           /*!< [11:8]  */
        uint32_t OPAC20 : 4;           /*!< [15:12]  */
        uint32_t OPAC19 : 4;           /*!< [19:16]  */
        uint32_t OPAC18 : 4;           /*!< [23:20]  */
        uint32_t OPAC17 : 4;           /*!< [27:24]  */
        uint32_t OPAC16 : 4;           /*!< [31:28]  */
    } B;
} hw_aipstz_opacr2_t;

/*!
 * @name Constants and macros for entire AIPSTZ_OPACR2 register
 */
/*@{*/
#define HW_AIPSTZ_OPACR2_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_AIPSTZ_OPACR2(x)      (*(__IO hw_aipstz_opacr2_t *) HW_AIPSTZ_OPACR2_ADDR(x))
#define HW_AIPSTZ_OPACR2_RD(x)   (HW_AIPSTZ_OPACR2(x).U)
#define HW_AIPSTZ_OPACR2_WR(x, v) (HW_AIPSTZ_OPACR2(x).U = (v))
#define HW_AIPSTZ_OPACR2_SET(x, v) (HW_AIPSTZ_OPACR2_WR(x, HW_AIPSTZ_OPACR2_RD(x) |  (v)))
#define HW_AIPSTZ_OPACR2_CLR(x, v) (HW_AIPSTZ_OPACR2_WR(x, HW_AIPSTZ_OPACR2_RD(x) & ~(v)))
#define HW_AIPSTZ_OPACR2_TOG(x, v) (HW_AIPSTZ_OPACR2_WR(x, HW_AIPSTZ_OPACR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_OPACR2 bitfields
 */

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC23[3:0] (RW)
 *
 * Off-platform Peripheral Access Control 23
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC23 (0U)       /*!< Bit position for AIPSTZ_OPACR2_OPAC23. */
#define BM_AIPSTZ_OPACR2_OPAC23 (0x0000000FU) /*!< Bit mask for AIPSTZ_OPACR2_OPAC23. */
#define BS_AIPSTZ_OPACR2_OPAC23 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC23. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC23 field. */
#define BR_AIPSTZ_OPACR2_OPAC23(x) (HW_AIPSTZ_OPACR2(x).B.OPAC23)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC23. */
#define BF_AIPSTZ_OPACR2_OPAC23(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC23) & BM_AIPSTZ_OPACR2_OPAC23)

/*! @brief Set the OPAC23 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC23(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC23) | BF_AIPSTZ_OPACR2_OPAC23(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC22[7:4] (RW)
 *
 * Off-platform Peripheral Access Control 22
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC22 (4U)       /*!< Bit position for AIPSTZ_OPACR2_OPAC22. */
#define BM_AIPSTZ_OPACR2_OPAC22 (0x000000F0U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC22. */
#define BS_AIPSTZ_OPACR2_OPAC22 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC22. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC22 field. */
#define BR_AIPSTZ_OPACR2_OPAC22(x) (HW_AIPSTZ_OPACR2(x).B.OPAC22)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC22. */
#define BF_AIPSTZ_OPACR2_OPAC22(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC22) & BM_AIPSTZ_OPACR2_OPAC22)

/*! @brief Set the OPAC22 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC22(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC22) | BF_AIPSTZ_OPACR2_OPAC22(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC21[11:8] (RW)
 *
 * Off-platform Peripheral Access Control 21
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC21 (8U)       /*!< Bit position for AIPSTZ_OPACR2_OPAC21. */
#define BM_AIPSTZ_OPACR2_OPAC21 (0x00000F00U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC21. */
#define BS_AIPSTZ_OPACR2_OPAC21 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC21. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC21 field. */
#define BR_AIPSTZ_OPACR2_OPAC21(x) (HW_AIPSTZ_OPACR2(x).B.OPAC21)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC21. */
#define BF_AIPSTZ_OPACR2_OPAC21(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC21) & BM_AIPSTZ_OPACR2_OPAC21)

/*! @brief Set the OPAC21 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC21(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC21) | BF_AIPSTZ_OPACR2_OPAC21(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC20[15:12] (RW)
 *
 * Off-platform Peripheral Access Control 20
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC20 (12U)      /*!< Bit position for AIPSTZ_OPACR2_OPAC20. */
#define BM_AIPSTZ_OPACR2_OPAC20 (0x0000F000U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC20. */
#define BS_AIPSTZ_OPACR2_OPAC20 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC20. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC20 field. */
#define BR_AIPSTZ_OPACR2_OPAC20(x) (HW_AIPSTZ_OPACR2(x).B.OPAC20)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC20. */
#define BF_AIPSTZ_OPACR2_OPAC20(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC20) & BM_AIPSTZ_OPACR2_OPAC20)

/*! @brief Set the OPAC20 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC20(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC20) | BF_AIPSTZ_OPACR2_OPAC20(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC19[19:16] (RW)
 *
 * Off-platform Peripheral Access Control 19
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC19 (16U)      /*!< Bit position for AIPSTZ_OPACR2_OPAC19. */
#define BM_AIPSTZ_OPACR2_OPAC19 (0x000F0000U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC19. */
#define BS_AIPSTZ_OPACR2_OPAC19 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC19. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC19 field. */
#define BR_AIPSTZ_OPACR2_OPAC19(x) (HW_AIPSTZ_OPACR2(x).B.OPAC19)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC19. */
#define BF_AIPSTZ_OPACR2_OPAC19(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC19) & BM_AIPSTZ_OPACR2_OPAC19)

/*! @brief Set the OPAC19 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC19(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC19) | BF_AIPSTZ_OPACR2_OPAC19(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC18[23:20] (RW)
 *
 * Off-platform Peripheral Access Control 18
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC18 (20U)      /*!< Bit position for AIPSTZ_OPACR2_OPAC18. */
#define BM_AIPSTZ_OPACR2_OPAC18 (0x00F00000U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC18. */
#define BS_AIPSTZ_OPACR2_OPAC18 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC18. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC18 field. */
#define BR_AIPSTZ_OPACR2_OPAC18(x) (HW_AIPSTZ_OPACR2(x).B.OPAC18)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC18. */
#define BF_AIPSTZ_OPACR2_OPAC18(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC18) & BM_AIPSTZ_OPACR2_OPAC18)

/*! @brief Set the OPAC18 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC18(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC18) | BF_AIPSTZ_OPACR2_OPAC18(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC17[27:24] (RW)
 *
 * Off-platform Peripheral Access Control 17
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC17 (24U)      /*!< Bit position for AIPSTZ_OPACR2_OPAC17. */
#define BM_AIPSTZ_OPACR2_OPAC17 (0x0F000000U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC17. */
#define BS_AIPSTZ_OPACR2_OPAC17 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC17. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC17 field. */
#define BR_AIPSTZ_OPACR2_OPAC17(x) (HW_AIPSTZ_OPACR2(x).B.OPAC17)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC17. */
#define BF_AIPSTZ_OPACR2_OPAC17(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC17) & BM_AIPSTZ_OPACR2_OPAC17)

/*! @brief Set the OPAC17 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC17(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC17) | BF_AIPSTZ_OPACR2_OPAC17(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR2, field OPAC16[31:28] (RW)
 *
 * Off-platform Peripheral Access Control 16
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR2_OPAC16 (28U)      /*!< Bit position for AIPSTZ_OPACR2_OPAC16. */
#define BM_AIPSTZ_OPACR2_OPAC16 (0xF0000000U) /*!< Bit mask for AIPSTZ_OPACR2_OPAC16. */
#define BS_AIPSTZ_OPACR2_OPAC16 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR2_OPAC16. */

/*! @brief Read current value of the AIPSTZ_OPACR2_OPAC16 field. */
#define BR_AIPSTZ_OPACR2_OPAC16(x) (HW_AIPSTZ_OPACR2(x).B.OPAC16)

/*! @brief Format value for bitfield AIPSTZ_OPACR2_OPAC16. */
#define BF_AIPSTZ_OPACR2_OPAC16(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR2_OPAC16) & BM_AIPSTZ_OPACR2_OPAC16)

/*! @brief Set the OPAC16 field to a new value. */
#define BW_AIPSTZ_OPACR2_OPAC16(x, v) (HW_AIPSTZ_OPACR2_WR(x, (HW_AIPSTZ_OPACR2_RD(x) & ~BM_AIPSTZ_OPACR2_OPAC16) | BF_AIPSTZ_OPACR2_OPAC16(v)))
/*@}*/

/*******************************************************************************
 * HW_AIPSTZ_OPACR3 - Off-Platform Peripheral Access Control Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_OPACR3 - Off-Platform Peripheral Access Control Registers (RW)
 *
 * Reset value: 0x44444444U
 *
 * Each of the off-platform peripherals have an Off-platform Peripheral Access
 * Control Register (AIPSTZ_OPACR) which defines the access levels supported by
 * the given block. Each AIPSTZ_OPACR has the following format shown in
 */
typedef union _hw_aipstz_opacr3
{
    uint32_t U;
    struct _hw_aipstz_opacr3_bitfields
    {
        uint32_t OPAC31 : 4;           /*!< [3:0]  */
        uint32_t OPAC30 : 4;           /*!< [7:4]  */
        uint32_t OPAC29 : 4;           /*!< [11:8]  */
        uint32_t OPAC28 : 4;           /*!< [15:12]  */
        uint32_t OPAC27 : 4;           /*!< [19:16]  */
        uint32_t OPAC26 : 4;           /*!< [23:20]  */
        uint32_t OPAC25 : 4;           /*!< [27:24]  */
        uint32_t OPAC24 : 4;           /*!< [31:28]  */
    } B;
} hw_aipstz_opacr3_t;

/*!
 * @name Constants and macros for entire AIPSTZ_OPACR3 register
 */
/*@{*/
#define HW_AIPSTZ_OPACR3_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_AIPSTZ_OPACR3(x)      (*(__IO hw_aipstz_opacr3_t *) HW_AIPSTZ_OPACR3_ADDR(x))
#define HW_AIPSTZ_OPACR3_RD(x)   (HW_AIPSTZ_OPACR3(x).U)
#define HW_AIPSTZ_OPACR3_WR(x, v) (HW_AIPSTZ_OPACR3(x).U = (v))
#define HW_AIPSTZ_OPACR3_SET(x, v) (HW_AIPSTZ_OPACR3_WR(x, HW_AIPSTZ_OPACR3_RD(x) |  (v)))
#define HW_AIPSTZ_OPACR3_CLR(x, v) (HW_AIPSTZ_OPACR3_WR(x, HW_AIPSTZ_OPACR3_RD(x) & ~(v)))
#define HW_AIPSTZ_OPACR3_TOG(x, v) (HW_AIPSTZ_OPACR3_WR(x, HW_AIPSTZ_OPACR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_OPACR3 bitfields
 */

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC31[3:0] (RW)
 *
 * Off-platform Peripheral Access Control 31
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC31 (0U)       /*!< Bit position for AIPSTZ_OPACR3_OPAC31. */
#define BM_AIPSTZ_OPACR3_OPAC31 (0x0000000FU) /*!< Bit mask for AIPSTZ_OPACR3_OPAC31. */
#define BS_AIPSTZ_OPACR3_OPAC31 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC31. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC31 field. */
#define BR_AIPSTZ_OPACR3_OPAC31(x) (HW_AIPSTZ_OPACR3(x).B.OPAC31)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC31. */
#define BF_AIPSTZ_OPACR3_OPAC31(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC31) & BM_AIPSTZ_OPACR3_OPAC31)

/*! @brief Set the OPAC31 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC31(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC31) | BF_AIPSTZ_OPACR3_OPAC31(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC30[7:4] (RW)
 *
 * Off-platform Peripheral Access Control 30
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC30 (4U)       /*!< Bit position for AIPSTZ_OPACR3_OPAC30. */
#define BM_AIPSTZ_OPACR3_OPAC30 (0x000000F0U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC30. */
#define BS_AIPSTZ_OPACR3_OPAC30 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC30. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC30 field. */
#define BR_AIPSTZ_OPACR3_OPAC30(x) (HW_AIPSTZ_OPACR3(x).B.OPAC30)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC30. */
#define BF_AIPSTZ_OPACR3_OPAC30(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC30) & BM_AIPSTZ_OPACR3_OPAC30)

/*! @brief Set the OPAC30 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC30(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC30) | BF_AIPSTZ_OPACR3_OPAC30(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC29[11:8] (RW)
 *
 * Off-platform Peripheral Access Control 29
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC29 (8U)       /*!< Bit position for AIPSTZ_OPACR3_OPAC29. */
#define BM_AIPSTZ_OPACR3_OPAC29 (0x00000F00U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC29. */
#define BS_AIPSTZ_OPACR3_OPAC29 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC29. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC29 field. */
#define BR_AIPSTZ_OPACR3_OPAC29(x) (HW_AIPSTZ_OPACR3(x).B.OPAC29)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC29. */
#define BF_AIPSTZ_OPACR3_OPAC29(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC29) & BM_AIPSTZ_OPACR3_OPAC29)

/*! @brief Set the OPAC29 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC29(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC29) | BF_AIPSTZ_OPACR3_OPAC29(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC28[15:12] (RW)
 *
 * Off-platform Peripheral Access Control 28
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC28 (12U)      /*!< Bit position for AIPSTZ_OPACR3_OPAC28. */
#define BM_AIPSTZ_OPACR3_OPAC28 (0x0000F000U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC28. */
#define BS_AIPSTZ_OPACR3_OPAC28 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC28. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC28 field. */
#define BR_AIPSTZ_OPACR3_OPAC28(x) (HW_AIPSTZ_OPACR3(x).B.OPAC28)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC28. */
#define BF_AIPSTZ_OPACR3_OPAC28(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC28) & BM_AIPSTZ_OPACR3_OPAC28)

/*! @brief Set the OPAC28 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC28(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC28) | BF_AIPSTZ_OPACR3_OPAC28(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC27[19:16] (RW)
 *
 * Off-platform Peripheral Access Control 27
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC27 (16U)      /*!< Bit position for AIPSTZ_OPACR3_OPAC27. */
#define BM_AIPSTZ_OPACR3_OPAC27 (0x000F0000U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC27. */
#define BS_AIPSTZ_OPACR3_OPAC27 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC27. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC27 field. */
#define BR_AIPSTZ_OPACR3_OPAC27(x) (HW_AIPSTZ_OPACR3(x).B.OPAC27)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC27. */
#define BF_AIPSTZ_OPACR3_OPAC27(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC27) & BM_AIPSTZ_OPACR3_OPAC27)

/*! @brief Set the OPAC27 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC27(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC27) | BF_AIPSTZ_OPACR3_OPAC27(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC26[23:20] (RW)
 *
 * Off-platform Peripheral Access Control 26
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC26 (20U)      /*!< Bit position for AIPSTZ_OPACR3_OPAC26. */
#define BM_AIPSTZ_OPACR3_OPAC26 (0x00F00000U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC26. */
#define BS_AIPSTZ_OPACR3_OPAC26 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC26. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC26 field. */
#define BR_AIPSTZ_OPACR3_OPAC26(x) (HW_AIPSTZ_OPACR3(x).B.OPAC26)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC26. */
#define BF_AIPSTZ_OPACR3_OPAC26(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC26) & BM_AIPSTZ_OPACR3_OPAC26)

/*! @brief Set the OPAC26 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC26(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC26) | BF_AIPSTZ_OPACR3_OPAC26(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC25[27:24] (RW)
 *
 * Off-platform Peripheral Access Control 25
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC25 (24U)      /*!< Bit position for AIPSTZ_OPACR3_OPAC25. */
#define BM_AIPSTZ_OPACR3_OPAC25 (0x0F000000U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC25. */
#define BS_AIPSTZ_OPACR3_OPAC25 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC25. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC25 field. */
#define BR_AIPSTZ_OPACR3_OPAC25(x) (HW_AIPSTZ_OPACR3(x).B.OPAC25)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC25. */
#define BF_AIPSTZ_OPACR3_OPAC25(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC25) & BM_AIPSTZ_OPACR3_OPAC25)

/*! @brief Set the OPAC25 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC25(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC25) | BF_AIPSTZ_OPACR3_OPAC25(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR3, field OPAC24[31:28] (RW)
 *
 * Off-platform Peripheral Access Control 24
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR3_OPAC24 (28U)      /*!< Bit position for AIPSTZ_OPACR3_OPAC24. */
#define BM_AIPSTZ_OPACR3_OPAC24 (0xF0000000U) /*!< Bit mask for AIPSTZ_OPACR3_OPAC24. */
#define BS_AIPSTZ_OPACR3_OPAC24 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR3_OPAC24. */

/*! @brief Read current value of the AIPSTZ_OPACR3_OPAC24 field. */
#define BR_AIPSTZ_OPACR3_OPAC24(x) (HW_AIPSTZ_OPACR3(x).B.OPAC24)

/*! @brief Format value for bitfield AIPSTZ_OPACR3_OPAC24. */
#define BF_AIPSTZ_OPACR3_OPAC24(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR3_OPAC24) & BM_AIPSTZ_OPACR3_OPAC24)

/*! @brief Set the OPAC24 field to a new value. */
#define BW_AIPSTZ_OPACR3_OPAC24(x, v) (HW_AIPSTZ_OPACR3_WR(x, (HW_AIPSTZ_OPACR3_RD(x) & ~BM_AIPSTZ_OPACR3_OPAC24) | BF_AIPSTZ_OPACR3_OPAC24(v)))
/*@}*/

/*******************************************************************************
 * HW_AIPSTZ_OPACR4 - Off-Platform Peripheral Access Control Registers
 ******************************************************************************/

/*!
 * @brief HW_AIPSTZ_OPACR4 - Off-Platform Peripheral Access Control Registers (RW)
 *
 * Reset value: 0x44444444U
 *
 * Each of the off-platform peripherals have an Off-platform Peripheral Access
 * Control Register (AIPSTZ_OPACR) which defines the access levels supported by
 * the given block. Each AIPSTZ_OPACR has the following format shown in
 */
typedef union _hw_aipstz_opacr4
{
    uint32_t U;
    struct _hw_aipstz_opacr4_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t OPAC33 : 4;           /*!< [27:24]  */
        uint32_t OPAC32 : 4;           /*!< [31:28]  */
    } B;
} hw_aipstz_opacr4_t;

/*!
 * @name Constants and macros for entire AIPSTZ_OPACR4 register
 */
/*@{*/
#define HW_AIPSTZ_OPACR4_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_AIPSTZ_OPACR4(x)      (*(__IO hw_aipstz_opacr4_t *) HW_AIPSTZ_OPACR4_ADDR(x))
#define HW_AIPSTZ_OPACR4_RD(x)   (HW_AIPSTZ_OPACR4(x).U)
#define HW_AIPSTZ_OPACR4_WR(x, v) (HW_AIPSTZ_OPACR4(x).U = (v))
#define HW_AIPSTZ_OPACR4_SET(x, v) (HW_AIPSTZ_OPACR4_WR(x, HW_AIPSTZ_OPACR4_RD(x) |  (v)))
#define HW_AIPSTZ_OPACR4_CLR(x, v) (HW_AIPSTZ_OPACR4_WR(x, HW_AIPSTZ_OPACR4_RD(x) & ~(v)))
#define HW_AIPSTZ_OPACR4_TOG(x, v) (HW_AIPSTZ_OPACR4_WR(x, HW_AIPSTZ_OPACR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AIPSTZ_OPACR4 bitfields
 */

/*!
 * @name Register AIPSTZ_OPACR4, field OPAC33[27:24] (RW)
 *
 * Off-platform Peripheral Access Control 33
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR4_OPAC33 (24U)      /*!< Bit position for AIPSTZ_OPACR4_OPAC33. */
#define BM_AIPSTZ_OPACR4_OPAC33 (0x0F000000U) /*!< Bit mask for AIPSTZ_OPACR4_OPAC33. */
#define BS_AIPSTZ_OPACR4_OPAC33 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR4_OPAC33. */

/*! @brief Read current value of the AIPSTZ_OPACR4_OPAC33 field. */
#define BR_AIPSTZ_OPACR4_OPAC33(x) (HW_AIPSTZ_OPACR4(x).B.OPAC33)

/*! @brief Format value for bitfield AIPSTZ_OPACR4_OPAC33. */
#define BF_AIPSTZ_OPACR4_OPAC33(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR4_OPAC33) & BM_AIPSTZ_OPACR4_OPAC33)

/*! @brief Set the OPAC33 field to a new value. */
#define BW_AIPSTZ_OPACR4_OPAC33(x, v) (HW_AIPSTZ_OPACR4_WR(x, (HW_AIPSTZ_OPACR4_RD(x) & ~BM_AIPSTZ_OPACR4_OPAC33) | BF_AIPSTZ_OPACR4_OPAC33(v)))
/*@}*/

/*!
 * @name Register AIPSTZ_OPACR4, field OPAC32[31:28] (RW)
 *
 * Off-platform Peripheral Access Control 32
 *
 * Values:
 * - xxx0 - Accesses from an untrusted master are allowed.
 * - xxx1 - Accesses from an untrusted master are not allowed. If an access is
 *     attempted by an untrusted master, the access is terminated with an error
 *     response and no peripheral access is initiated on the IPS bus.
 * - xx0x - This peripheral allows write accesses.
 * - xx1x - This peripheral is write protected. If a write access is attempted,
 *     the access is terminated with an error response and no peripheral access
 *     is initiated on the IPS bus.
 * - x0xx - This peripheral does not require supervisor privilege level for
 *     accesses.
 * - x1xx - This peripheral requires supervisor privilege level for accesses.
 *     The master privilege level must indicate supervisor via the hprot[1] access
 *     attribute, and the MPROTx[MPL] control bit for the master must be set. If
 *     not, the access is terminated with an error response and no peripheral
 *     access is initiated on the IPS bus.
 * - 1xxx - Write accesses to this peripheral are allowed to be buffered by the
 *     AIPSTZ.
 */
/*@{*/
#define BP_AIPSTZ_OPACR4_OPAC32 (28U)      /*!< Bit position for AIPSTZ_OPACR4_OPAC32. */
#define BM_AIPSTZ_OPACR4_OPAC32 (0xF0000000U) /*!< Bit mask for AIPSTZ_OPACR4_OPAC32. */
#define BS_AIPSTZ_OPACR4_OPAC32 (4U)       /*!< Bit field size in bits for AIPSTZ_OPACR4_OPAC32. */

/*! @brief Read current value of the AIPSTZ_OPACR4_OPAC32 field. */
#define BR_AIPSTZ_OPACR4_OPAC32(x) (HW_AIPSTZ_OPACR4(x).B.OPAC32)

/*! @brief Format value for bitfield AIPSTZ_OPACR4_OPAC32. */
#define BF_AIPSTZ_OPACR4_OPAC32(v) ((uint32_t)((uint32_t)(v) << BP_AIPSTZ_OPACR4_OPAC32) & BM_AIPSTZ_OPACR4_OPAC32)

/*! @brief Set the OPAC32 field to a new value. */
#define BW_AIPSTZ_OPACR4_OPAC32(x, v) (HW_AIPSTZ_OPACR4_WR(x, (HW_AIPSTZ_OPACR4_RD(x) & ~BM_AIPSTZ_OPACR4_OPAC32) | BF_AIPSTZ_OPACR4_OPAC32(v)))
/*@}*/

/*******************************************************************************
 * hw_aipstz_t - module struct
 ******************************************************************************/
/*!
 * @brief All AIPSTZ module registers.
 */
#pragma pack(1)
typedef struct _hw_aipstz
{
    __IO hw_aipstz_mpr_t MPR;              /*!< [0x0] Master Priviledge Registers */
    uint8_t _reserved0[60];
    __IO hw_aipstz_opacr_t OPACR;          /*!< [0x40] Off-Platform Peripheral Access Control Registers */
    __IO hw_aipstz_opacr1_t OPACR1;        /*!< [0x44] Off-Platform Peripheral Access Control Registers */
    __IO hw_aipstz_opacr2_t OPACR2;        /*!< [0x48] Off-Platform Peripheral Access Control Registers */
    __IO hw_aipstz_opacr3_t OPACR3;        /*!< [0x4C] Off-Platform Peripheral Access Control Registers */
    __IO hw_aipstz_opacr4_t OPACR4;        /*!< [0x50] Off-Platform Peripheral Access Control Registers */
} hw_aipstz_t;
#pragma pack()

/*! @brief Macro to access all AIPSTZ registers. */
/*! @param x AIPSTZ module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_AIPSTZ_REGS(AIPSTZ1_BASE)</code>. */
#define HW_AIPSTZ_REGS(x) (*(hw_aipstz_t *)(x))

/*
 * iMX6DP APBH
 *
 * APBH Register Reference Index
 *
 * Registers defined in this header file:
 * - HW_APBH_CTRL0 - AHB to APBH Bridge Control and Status Register 0
 * - HW_APBH_CTRL1 - AHB to APBH Bridge Control and Status Register 1
 * - HW_APBH_CTRL2 - AHB to APBH Bridge Control and Status Register 2
 * - HW_APBH_CHANNEL_CTRL - AHB to APBH Bridge Channel Register
 * - HW_APBH_DEVSEL - AHB to APBH DMA Device Assignment Register
 * - HW_APBH_DMA_BURST_SIZE - AHB to APBH DMA burst size
 * - HW_APBH_DEBUG - AHB to APBH DMA Debug Register
 * - HW_APBH_CHn_CURCMDAR - APBH DMA Channel n Current Command Address Register
 * - HW_APBH_CHn_NXTCMDAR - APBH DMA Channel n Next Command Address Register
 * - HW_APBH_CHn_CMD - APBH DMA Channel n Command Register
 * - HW_APBH_CHn_BAR - APBH DMA Channel n Buffer Address Register
 * - HW_APBH_CHn_SEMA - APBH DMA Channel n Semaphore Register
 * - HW_APBH_CHn_DEBUG1 - AHB to APBH DMA Channel n Debug Information
 * - HW_APBH_CHn_DEBUG2 - AHB to APBH DMA Channel n Debug Information
 * - HW_APBH_VERSION - APBH Bridge Version Register
 *
 * - hw_apbh_t - Struct containing all module registers.
 */

#define HW_APBH_INSTANCE_COUNT (1U) /*!< Number of instances of the APBH module. */
#define HW_APBH (0U) /*!< Instance number for APBH. */
#define APBH_BASE             (0x110000U) /*!< Base address for APBH. */
/*! Array initializer of APBH base addresses. */
#define APBH_BASE_ADDRS       { APBH_BASE }

/*******************************************************************************
 * HW_APBH_CTRL0 - AHB to APBH Bridge Control and Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_APBH_CTRL0 - AHB to APBH Bridge Control and Status Register 0 (RW)
 *
 * Reset value: 0xE0000000U
 *
 * The APBH CTRL 0 provides overall control of the AHB to APBH bridge and DMA.
 * This register contains module softreset, clock gating, channel clock
 * gating/freeze bits.
 */
typedef union _hw_apbh_ctrl0
{
    uint32_t U;
    struct _hw_apbh_ctrl0_bitfields
    {
        uint32_t CLKGATE_CHANNEL : 16; /*!< [15:0]  */
        uint32_t RSVD0 : 12;           /*!< [27:16]  */
        uint32_t APB_BURST_EN : 1;     /*!< [28]  */
        uint32_t AHB_BURST8_EN : 1;    /*!< [29]  */
        uint32_t CLKGATE : 1;          /*!< [30]  */
        uint32_t SFTRST : 1;           /*!< [31]  */
    } B;
} hw_apbh_ctrl0_t;

/*!
 * @name Constants and macros for entire APBH_CTRL0 register
 */
/*@{*/
#define HW_APBH_CTRL0_ADDR(x)    ((uintptr_t)(x) + 0x0U)
#define HW_APBH_CTRL0_SET_ADDR(x) (HW_APBH_CTRL0_ADDR(x) + 0x4U)
#define HW_APBH_CTRL0_CLR_ADDR(x) (HW_APBH_CTRL0_ADDR(x) + 0x8U)
#define HW_APBH_CTRL0_TOG_ADDR(x) (HW_APBH_CTRL0_ADDR(x) + 0xCU)

#define HW_APBH_CTRL0(x)         (*(__IO hw_apbh_ctrl0_t *) HW_APBH_CTRL0_ADDR(x))
#define HW_APBH_CTRL0_RD(x)      (HW_APBH_CTRL0(x).U)
#define HW_APBH_CTRL0_WR(x, v)   (HW_APBH_CTRL0(x).U = (v))
#define HW_APBH_CTRL0_SET(x, v)  ((*(uint32_t *) HW_APBH_CTRL0_SET_ADDR(x)) = (v))
#define HW_APBH_CTRL0_CLR(x, v)  ((*(uint32_t *) HW_APBH_CTRL0_CLR_ADDR(x)) = (v))
#define HW_APBH_CTRL0_TOG(x, v)  ((*(uint32_t *) HW_APBH_CTRL0_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual APBH_CTRL0 bitfields
 */

/*!
 * @name Register APBH_CTRL0, field CLKGATE_CHANNEL[15:0] (RW)
 *
 * These bits must be set to zero for normal operation of each channel. When set
 * to one they gate off the individual clocks to the channels.
 *
 * Values:
 * - 1 -
 * - 10 -
 * - 100 -
 * - 1000 -
 * - 10000 -
 * - 100000 -
 * - 1000000 -
 * - 10000000 -
 * - 100000000 -
 */
/*@{*/
#define BP_APBH_CTRL0_CLKGATE_CHANNEL (0U) /*!< Bit position for APBH_CTRL0_CLKGATE_CHANNEL. */
#define BM_APBH_CTRL0_CLKGATE_CHANNEL (0x0000FFFFU) /*!< Bit mask for APBH_CTRL0_CLKGATE_CHANNEL. */
#define BS_APBH_CTRL0_CLKGATE_CHANNEL (16U) /*!< Bit field size in bits for APBH_CTRL0_CLKGATE_CHANNEL. */

#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND0 (0x1U)   /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND1 (0x2U)   /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND2 (0x4U)   /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND3 (0x8U)   /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND4 (0x10U)  /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND5 (0x20U)  /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND6 (0x40U)  /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_NAND7 (0x80U)  /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */
#define BV_APBH_CTRL0_CLKGATE_CHANNEL_SSP (0x100U)   /*!< Bit field value for APBH_CTRL0_CLKGATE_CHANNEL:  */

/*! @brief Read current value of the APBH_CTRL0_CLKGATE_CHANNEL field. */
#define BR_APBH_CTRL0_CLKGATE_CHANNEL(x) (HW_APBH_CTRL0(x).B.CLKGATE_CHANNEL)

/*! @brief Format value for bitfield APBH_CTRL0_CLKGATE_CHANNEL. */
#define BF_APBH_CTRL0_CLKGATE_CHANNEL(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL0_CLKGATE_CHANNEL) & BM_APBH_CTRL0_CLKGATE_CHANNEL)

/*! @brief Set the CLKGATE_CHANNEL field to a new value. */
#define BW_APBH_CTRL0_CLKGATE_CHANNEL(x, v) (HW_APBH_CTRL0_WR(x, (HW_APBH_CTRL0_RD(x) & ~BM_APBH_CTRL0_CLKGATE_CHANNEL) | BF_APBH_CTRL0_CLKGATE_CHANNEL(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL0, field RSVD0[27:16] (RU)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_APBH_CTRL0_RSVD0  (16U)         /*!< Bit position for APBH_CTRL0_RSVD0. */
#define BM_APBH_CTRL0_RSVD0  (0x0FFF0000U) /*!< Bit mask for APBH_CTRL0_RSVD0. */
#define BS_APBH_CTRL0_RSVD0  (12U)         /*!< Bit field size in bits for APBH_CTRL0_RSVD0. */
/*@}*/

/*!
 * @name Register APBH_CTRL0, field APB_BURST_EN[28] (RW)
 *
 * Set this bit to one to enable apb master do a continous transfers when a
 * device request a burst dma. Set to zero will treat a burst dma request as 4/8
 * individual requests.
 */
/*@{*/
#define BP_APBH_CTRL0_APB_BURST_EN (28U)   /*!< Bit position for APBH_CTRL0_APB_BURST_EN. */
#define BM_APBH_CTRL0_APB_BURST_EN (0x10000000U) /*!< Bit mask for APBH_CTRL0_APB_BURST_EN. */
#define BS_APBH_CTRL0_APB_BURST_EN (1U)    /*!< Bit field size in bits for APBH_CTRL0_APB_BURST_EN. */

/*! @brief Read current value of the APBH_CTRL0_APB_BURST_EN field. */
#define BR_APBH_CTRL0_APB_BURST_EN(x) (HW_APBH_CTRL0(x).B.APB_BURST_EN)

/*! @brief Format value for bitfield APBH_CTRL0_APB_BURST_EN. */
#define BF_APBH_CTRL0_APB_BURST_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL0_APB_BURST_EN) & BM_APBH_CTRL0_APB_BURST_EN)

/*! @brief Set the APB_BURST_EN field to a new value. */
#define BW_APBH_CTRL0_APB_BURST_EN(x, v) (HW_APBH_CTRL0_WR(x, (HW_APBH_CTRL0_RD(x) & ~BM_APBH_CTRL0_APB_BURST_EN) | BF_APBH_CTRL0_APB_BURST_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL0, field AHB_BURST8_EN[29] (RW)
 *
 * Set this bit to one (default) to enable AHB 8-beat burst. Set to zero to
 * disable 8-beat burst on AHB interface.
 */
/*@{*/
#define BP_APBH_CTRL0_AHB_BURST8_EN (29U)  /*!< Bit position for APBH_CTRL0_AHB_BURST8_EN. */
#define BM_APBH_CTRL0_AHB_BURST8_EN (0x20000000U) /*!< Bit mask for APBH_CTRL0_AHB_BURST8_EN. */
#define BS_APBH_CTRL0_AHB_BURST8_EN (1U)   /*!< Bit field size in bits for APBH_CTRL0_AHB_BURST8_EN. */

/*! @brief Read current value of the APBH_CTRL0_AHB_BURST8_EN field. */
#define BR_APBH_CTRL0_AHB_BURST8_EN(x) (HW_APBH_CTRL0(x).B.AHB_BURST8_EN)

/*! @brief Format value for bitfield APBH_CTRL0_AHB_BURST8_EN. */
#define BF_APBH_CTRL0_AHB_BURST8_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL0_AHB_BURST8_EN) & BM_APBH_CTRL0_AHB_BURST8_EN)

/*! @brief Set the AHB_BURST8_EN field to a new value. */
#define BW_APBH_CTRL0_AHB_BURST8_EN(x, v) (HW_APBH_CTRL0_WR(x, (HW_APBH_CTRL0_RD(x) & ~BM_APBH_CTRL0_AHB_BURST8_EN) | BF_APBH_CTRL0_AHB_BURST8_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL0, field CLKGATE[30] (RW)
 *
 * This bit must be set to zero for normal operation. When set to one it gates
 * off the clocks to the block.
 */
/*@{*/
#define BP_APBH_CTRL0_CLKGATE (30U)        /*!< Bit position for APBH_CTRL0_CLKGATE. */
#define BM_APBH_CTRL0_CLKGATE (0x40000000U) /*!< Bit mask for APBH_CTRL0_CLKGATE. */
#define BS_APBH_CTRL0_CLKGATE (1U)         /*!< Bit field size in bits for APBH_CTRL0_CLKGATE. */

/*! @brief Read current value of the APBH_CTRL0_CLKGATE field. */
#define BR_APBH_CTRL0_CLKGATE(x) (HW_APBH_CTRL0(x).B.CLKGATE)

/*! @brief Format value for bitfield APBH_CTRL0_CLKGATE. */
#define BF_APBH_CTRL0_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL0_CLKGATE) & BM_APBH_CTRL0_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_APBH_CTRL0_CLKGATE(x, v) (HW_APBH_CTRL0_WR(x, (HW_APBH_CTRL0_RD(x) & ~BM_APBH_CTRL0_CLKGATE) | BF_APBH_CTRL0_CLKGATE(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL0, field SFTRST[31] (RW)
 *
 * Set this bit to zero to enable normal APBH DMA operation. Set this bit to one
 * (default) to disable clocking with the APBH DMA and hold it in its reset
 * (lowest power) state. This bit can be turned on and then off to reset the APBH DMA
 * block to its default state.
 */
/*@{*/
#define BP_APBH_CTRL0_SFTRST (31U)         /*!< Bit position for APBH_CTRL0_SFTRST. */
#define BM_APBH_CTRL0_SFTRST (0x80000000U) /*!< Bit mask for APBH_CTRL0_SFTRST. */
#define BS_APBH_CTRL0_SFTRST (1U)          /*!< Bit field size in bits for APBH_CTRL0_SFTRST. */

/*! @brief Read current value of the APBH_CTRL0_SFTRST field. */
#define BR_APBH_CTRL0_SFTRST(x) (HW_APBH_CTRL0(x).B.SFTRST)

/*! @brief Format value for bitfield APBH_CTRL0_SFTRST. */
#define BF_APBH_CTRL0_SFTRST(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL0_SFTRST) & BM_APBH_CTRL0_SFTRST)

/*! @brief Set the SFTRST field to a new value. */
#define BW_APBH_CTRL0_SFTRST(x, v) (HW_APBH_CTRL0_WR(x, (HW_APBH_CTRL0_RD(x) & ~BM_APBH_CTRL0_SFTRST) | BF_APBH_CTRL0_SFTRST(v)))
/*@}*/




/*******************************************************************************
 * HW_APBH_CTRL1 - AHB to APBH Bridge Control and Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_APBH_CTRL1 - AHB to APBH Bridge Control and Status Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The APBH CTRL one provides overall control of the interrupts generated by the
 * AHB to APBH DMA. This register contains the per channel interrupt status bits
 * and the per channel interrupt enable bits. Each channel has a dedicated
 * interrupt vector in the vectored interrupt controller. EXAMPLE BF_WR(APBH_CTRL1,
 * CH5_CMDCMPLT_IRQ, 0); // use bitfield write macro BF_APBH_CTRL1.CH5_CMDCMPLT_IRQ
 * = 0; // or, assign to register struct's bitfield
 */
typedef union _hw_apbh_ctrl1
{
    uint32_t U;
    struct _hw_apbh_ctrl1_bitfields
    {
        uint32_t CH0_CMDCMPLT_IRQ : 1; /*!< [0]  */
        uint32_t CH1_CMDCMPLT_IRQ : 1; /*!< [1]  */
        uint32_t CH2_CMDCMPLT_IRQ : 1; /*!< [2]  */
        uint32_t CH3_CMDCMPLT_IRQ : 1; /*!< [3]  */
        uint32_t CH4_CMDCMPLT_IRQ : 1; /*!< [4]  */
        uint32_t CH5_CMDCMPLT_IRQ : 1; /*!< [5]  */
        uint32_t CH6_CMDCMPLT_IRQ : 1; /*!< [6]  */
        uint32_t CH7_CMDCMPLT_IRQ : 1; /*!< [7]  */
        uint32_t CH8_CMDCMPLT_IRQ : 1; /*!< [8]  */
        uint32_t CH9_CMDCMPLT_IRQ : 1; /*!< [9]  */
        uint32_t CH10_CMDCMPLT_IRQ : 1; /*!< [10]  */
        uint32_t CH11_CMDCMPLT_IRQ : 1; /*!< [11]  */
        uint32_t CH12_CMDCMPLT_IRQ : 1; /*!< [12]  */
        uint32_t CH13_CMDCMPLT_IRQ : 1; /*!< [13]  */
        uint32_t CH14_CMDCMPLT_IRQ : 1; /*!< [14]  */
        uint32_t CH15_CMDCMPLT_IRQ : 1; /*!< [15]  */
        uint32_t CH0_CMDCMPLT_IRQ_EN : 1; /*!< [16]  */
        uint32_t CH1_CMDCMPLT_IRQ_EN : 1; /*!< [17]  */
        uint32_t CH2_CMDCMPLT_IRQ_EN : 1; /*!< [18]  */
        uint32_t CH3_CMDCMPLT_IRQ_EN : 1; /*!< [19]  */
        uint32_t CH4_CMDCMPLT_IRQ_EN : 1; /*!< [20]  */
        uint32_t CH5_CMDCMPLT_IRQ_EN : 1; /*!< [21]  */
        uint32_t CH6_CMDCMPLT_IRQ_EN : 1; /*!< [22]  */
        uint32_t CH7_CMDCMPLT_IRQ_EN : 1; /*!< [23]  */
        uint32_t CH8_CMDCMPLT_IRQ_EN : 1; /*!< [24]  */
        uint32_t CH9_CMDCMPLT_IRQ_EN : 1; /*!< [25]  */
        uint32_t CH10_CMDCMPLT_IRQ_EN : 1; /*!< [26]  */
        uint32_t CH11_CMDCMPLT_IRQ_EN : 1; /*!< [27]  */
        uint32_t CH12_CMDCMPLT_IRQ_EN : 1; /*!< [28]  */
        uint32_t CH13_CMDCMPLT_IRQ_EN : 1; /*!< [29]  */
        uint32_t CH14_CMDCMPLT_IRQ_EN : 1; /*!< [30]  */
        uint32_t CH15_CMDCMPLT_IRQ_EN : 1; /*!< [31]  */
    } B;
} hw_apbh_ctrl1_t;

/*!
 * @name Constants and macros for entire APBH_CTRL1 register
 */
/*@{*/
#define HW_APBH_CTRL1_ADDR(x)    ((uintptr_t)(x) + 0x10U)
#define HW_APBH_CTRL1_SET_ADDR(x) (HW_APBH_CTRL1_ADDR(x) + 0x4U)
#define HW_APBH_CTRL1_CLR_ADDR(x) (HW_APBH_CTRL1_ADDR(x) + 0x8U)
#define HW_APBH_CTRL1_TOG_ADDR(x) (HW_APBH_CTRL1_ADDR(x) + 0xCU)

#define HW_APBH_CTRL1(x)         (*(__IO hw_apbh_ctrl1_t *) HW_APBH_CTRL1_ADDR(x))
#define HW_APBH_CTRL1_RD(x)      (HW_APBH_CTRL1(x).U)
#define HW_APBH_CTRL1_WR(x, v)   (HW_APBH_CTRL1(x).U = (v))
#define HW_APBH_CTRL1_SET(x, v)  ((*(uint32_t *) HW_APBH_CTRL1_SET_ADDR(x)) = (v))
#define HW_APBH_CTRL1_CLR(x, v)  ((*(uint32_t *) HW_APBH_CTRL1_CLR_ADDR(x)) = (v))
#define HW_APBH_CTRL1_TOG(x, v)  ((*(uint32_t *) HW_APBH_CTRL1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual APBH_CTRL1 bitfields
 */

/*!
 * @name Register APBH_CTRL1, field CH0_CMDCMPLT_IRQ[0] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 0. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH0_CMDCMPLT_IRQ (0U) /*!< Bit position for APBH_CTRL1_CH0_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ (0x00000001U) /*!< Bit mask for APBH_CTRL1_CH0_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH0_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH0_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH0_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH0_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH0_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH0_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH0_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH0_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ)

/*! @brief Set the CH0_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH0_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH0_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH1_CMDCMPLT_IRQ[1] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 1. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH1_CMDCMPLT_IRQ (1U) /*!< Bit position for APBH_CTRL1_CH1_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ (0x00000002U) /*!< Bit mask for APBH_CTRL1_CH1_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH1_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH1_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH1_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH1_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH1_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH1_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH1_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH1_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ)

/*! @brief Set the CH1_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH1_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH1_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH2_CMDCMPLT_IRQ[2] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 2. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH2_CMDCMPLT_IRQ (2U) /*!< Bit position for APBH_CTRL1_CH2_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ (0x00000004U) /*!< Bit mask for APBH_CTRL1_CH2_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH2_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH2_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH2_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH2_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH2_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH2_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH2_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH2_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ)

/*! @brief Set the CH2_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH2_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH2_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH3_CMDCMPLT_IRQ[3] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 3. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH3_CMDCMPLT_IRQ (3U) /*!< Bit position for APBH_CTRL1_CH3_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ (0x00000008U) /*!< Bit mask for APBH_CTRL1_CH3_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH3_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH3_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH3_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH3_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH3_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH3_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH3_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH3_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ)

/*! @brief Set the CH3_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH3_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH3_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH4_CMDCMPLT_IRQ[4] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 4. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH4_CMDCMPLT_IRQ (4U) /*!< Bit position for APBH_CTRL1_CH4_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ (0x00000010U) /*!< Bit mask for APBH_CTRL1_CH4_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH4_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH4_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH4_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH4_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH4_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH4_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH4_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH4_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ)

/*! @brief Set the CH4_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH4_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH4_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH5_CMDCMPLT_IRQ[5] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 5. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH5_CMDCMPLT_IRQ (5U) /*!< Bit position for APBH_CTRL1_CH5_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ (0x00000020U) /*!< Bit mask for APBH_CTRL1_CH5_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH5_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH5_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH5_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH5_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH5_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH5_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH5_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH5_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ)

/*! @brief Set the CH5_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH5_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH5_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH6_CMDCMPLT_IRQ[6] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 6. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH6_CMDCMPLT_IRQ (6U) /*!< Bit position for APBH_CTRL1_CH6_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ (0x00000040U) /*!< Bit mask for APBH_CTRL1_CH6_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH6_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH6_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH6_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH6_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH6_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH6_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH6_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH6_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ)

/*! @brief Set the CH6_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH6_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH6_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH7_CMDCMPLT_IRQ[7] (RW)
 *
 * Interrupt request status bit for APBH DMA channel 7. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH7_CMDCMPLT_IRQ (7U) /*!< Bit position for APBH_CTRL1_CH7_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ (0x00000080U) /*!< Bit mask for APBH_CTRL1_CH7_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH7_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH7_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH7_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH7_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH7_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH7_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH7_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH7_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ)

/*! @brief Set the CH7_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH7_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH7_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH8_CMDCMPLT_IRQ[8] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 8. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH8_CMDCMPLT_IRQ (8U) /*!< Bit position for APBH_CTRL1_CH8_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ (0x00000100U) /*!< Bit mask for APBH_CTRL1_CH8_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH8_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH8_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH8_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH8_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH8_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH8_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH8_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH8_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ)

/*! @brief Set the CH8_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH8_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH8_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH9_CMDCMPLT_IRQ[9] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 9. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH9_CMDCMPLT_IRQ (9U) /*!< Bit position for APBH_CTRL1_CH9_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ (0x00000200U) /*!< Bit mask for APBH_CTRL1_CH9_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH9_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH9_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH9_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH9_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH9_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH9_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH9_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH9_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ)

/*! @brief Set the CH9_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH9_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH9_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH10_CMDCMPLT_IRQ[10] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 10. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH10_CMDCMPLT_IRQ (10U) /*!< Bit position for APBH_CTRL1_CH10_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ (0x00000400U) /*!< Bit mask for APBH_CTRL1_CH10_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH10_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH10_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH10_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH10_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH10_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH10_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH10_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH10_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ)

/*! @brief Set the CH10_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH10_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH10_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH11_CMDCMPLT_IRQ[11] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 11. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH11_CMDCMPLT_IRQ (11U) /*!< Bit position for APBH_CTRL1_CH11_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ (0x00000800U) /*!< Bit mask for APBH_CTRL1_CH11_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH11_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH11_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH11_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH11_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH11_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH11_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH11_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH11_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ)

/*! @brief Set the CH11_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH11_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH11_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH12_CMDCMPLT_IRQ[12] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 12. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH12_CMDCMPLT_IRQ (12U) /*!< Bit position for APBH_CTRL1_CH12_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ (0x00001000U) /*!< Bit mask for APBH_CTRL1_CH12_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH12_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH12_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH12_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH12_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH12_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH12_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH12_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH12_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ)

/*! @brief Set the CH12_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH12_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH12_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH13_CMDCMPLT_IRQ[13] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 13. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH13_CMDCMPLT_IRQ (13U) /*!< Bit position for APBH_CTRL1_CH13_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ (0x00002000U) /*!< Bit mask for APBH_CTRL1_CH13_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH13_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH13_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH13_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH13_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH13_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH13_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH13_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH13_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ)

/*! @brief Set the CH13_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH13_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH13_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH14_CMDCMPLT_IRQ[14] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 14. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH14_CMDCMPLT_IRQ (14U) /*!< Bit position for APBH_CTRL1_CH14_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ (0x00004000U) /*!< Bit mask for APBH_CTRL1_CH14_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH14_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH14_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH14_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH14_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH14_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH14_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH14_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH14_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ)

/*! @brief Set the CH14_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH14_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH14_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH15_CMDCMPLT_IRQ[15] (RW)
 *
 * Interrupt request status bit for APBH DMA Channel 15. This sticky bit is set
 * by DMA hardware and reset by software. It is ANDed with its corresponding
 * enable bit to generate an interrupt.
 */
/*@{*/
#define BP_APBH_CTRL1_CH15_CMDCMPLT_IRQ (15U) /*!< Bit position for APBH_CTRL1_CH15_CMDCMPLT_IRQ. */
#define BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ (0x00008000U) /*!< Bit mask for APBH_CTRL1_CH15_CMDCMPLT_IRQ. */
#define BS_APBH_CTRL1_CH15_CMDCMPLT_IRQ (1U) /*!< Bit field size in bits for APBH_CTRL1_CH15_CMDCMPLT_IRQ. */

/*! @brief Read current value of the APBH_CTRL1_CH15_CMDCMPLT_IRQ field. */
#define BR_APBH_CTRL1_CH15_CMDCMPLT_IRQ(x) (HW_APBH_CTRL1(x).B.CH15_CMDCMPLT_IRQ)

/*! @brief Format value for bitfield APBH_CTRL1_CH15_CMDCMPLT_IRQ. */
#define BF_APBH_CTRL1_CH15_CMDCMPLT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH15_CMDCMPLT_IRQ) & BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ)

/*! @brief Set the CH15_CMDCMPLT_IRQ field to a new value. */
#define BW_APBH_CTRL1_CH15_CMDCMPLT_IRQ(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ) | BF_APBH_CTRL1_CH15_CMDCMPLT_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH0_CMDCMPLT_IRQ_EN[16] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 0.
 */
/*@{*/
#define BP_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN (16U) /*!< Bit position for APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN (0x00010000U) /*!< Bit mask for APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH0_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH0_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH0_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH1_CMDCMPLT_IRQ_EN[17] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 1.
 */
/*@{*/
#define BP_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN (17U) /*!< Bit position for APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN (0x00020000U) /*!< Bit mask for APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH1_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH1_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH1_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH2_CMDCMPLT_IRQ_EN[18] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 2.
 */
/*@{*/
#define BP_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN (18U) /*!< Bit position for APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN (0x00040000U) /*!< Bit mask for APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH2_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH2_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH2_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH3_CMDCMPLT_IRQ_EN[19] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 3.
 */
/*@{*/
#define BP_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN (19U) /*!< Bit position for APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN (0x00080000U) /*!< Bit mask for APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH3_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH3_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH3_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH4_CMDCMPLT_IRQ_EN[20] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 4.
 */
/*@{*/
#define BP_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN (20U) /*!< Bit position for APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN (0x00100000U) /*!< Bit mask for APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH4_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH4_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH4_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH5_CMDCMPLT_IRQ_EN[21] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 5.
 */
/*@{*/
#define BP_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN (21U) /*!< Bit position for APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN (0x00200000U) /*!< Bit mask for APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH5_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH5_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH5_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH6_CMDCMPLT_IRQ_EN[22] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 6.
 */
/*@{*/
#define BP_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN (22U) /*!< Bit position for APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN (0x00400000U) /*!< Bit mask for APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH6_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH6_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH6_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH7_CMDCMPLT_IRQ_EN[23] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 7.
 */
/*@{*/
#define BP_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN (23U) /*!< Bit position for APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN (0x00800000U) /*!< Bit mask for APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH7_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH7_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH7_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH8_CMDCMPLT_IRQ_EN[24] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 8.
 */
/*@{*/
#define BP_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN (24U) /*!< Bit position for APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN (0x01000000U) /*!< Bit mask for APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH8_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH8_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH8_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH9_CMDCMPLT_IRQ_EN[25] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 9.
 */
/*@{*/
#define BP_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN (25U) /*!< Bit position for APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN (0x02000000U) /*!< Bit mask for APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH9_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH9_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH9_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH10_CMDCMPLT_IRQ_EN[26] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 10.
 */
/*@{*/
#define BP_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN (26U) /*!< Bit position for APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN (0x04000000U) /*!< Bit mask for APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH10_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH10_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH10_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH11_CMDCMPLT_IRQ_EN[27] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 11.
 */
/*@{*/
#define BP_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN (27U) /*!< Bit position for APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN (0x08000000U) /*!< Bit mask for APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH11_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH11_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH11_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH12_CMDCMPLT_IRQ_EN[28] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 12.
 */
/*@{*/
#define BP_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN (28U) /*!< Bit position for APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN (0x10000000U) /*!< Bit mask for APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH12_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH12_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH12_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH13_CMDCMPLT_IRQ_EN[29] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 13.
 */
/*@{*/
#define BP_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN (29U) /*!< Bit position for APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN (0x20000000U) /*!< Bit mask for APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH13_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH13_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH13_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH14_CMDCMPLT_IRQ_EN[30] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 14.
 */
/*@{*/
#define BP_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN (30U) /*!< Bit position for APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN (0x40000000U) /*!< Bit mask for APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH14_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH14_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH14_CMDCMPLT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL1, field CH15_CMDCMPLT_IRQ_EN[31] (RW)
 *
 * Setting this bit enables the generation of an interrupt request for APBH DMA
 * channel 15.
 */
/*@{*/
#define BP_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN (31U) /*!< Bit position for APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN. */
#define BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN (0x80000000U) /*!< Bit mask for APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN. */
#define BS_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN (1U) /*!< Bit field size in bits for APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN. */

/*! @brief Read current value of the APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN field. */
#define BR_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN(x) (HW_APBH_CTRL1(x).B.CH15_CMDCMPLT_IRQ_EN)

/*! @brief Format value for bitfield APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN. */
#define BF_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN) & BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN)

/*! @brief Set the CH15_CMDCMPLT_IRQ_EN field to a new value. */
#define BW_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN(x, v) (HW_APBH_CTRL1_WR(x, (HW_APBH_CTRL1_RD(x) & ~BM_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN) | BF_APBH_CTRL1_CH15_CMDCMPLT_IRQ_EN(v)))
/*@}*/




/*******************************************************************************
 * HW_APBH_CTRL2 - AHB to APBH Bridge Control and Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_APBH_CTRL2 - AHB to APBH Bridge Control and Status Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The APBH CTRL 2 provides channel error interrupts generated by the AHB to
 * APBH DMA. This register contains the per channel interrupt status bits and the
 * per channel interrupt enable bits. Each channel has a dedicated interrupt vector
 * in the vectored interrupt controller. EXAMPLE BF_WR(APBH_CTRL1,
 * CH5_CMDCMPLT_IRQ, 0); // use bitfield write macro BF_APBH_CTRL1.CH5_CMDCMPLT_IRQ = 0; //
 * or, assign to register struct's bitfield
 */
typedef union _hw_apbh_ctrl2
{
    uint32_t U;
    struct _hw_apbh_ctrl2_bitfields
    {
        uint32_t CH0_ERROR_IRQ : 1;    /*!< [0]  */
        uint32_t CH1_ERROR_IRQ : 1;    /*!< [1]  */
        uint32_t CH2_ERROR_IRQ : 1;    /*!< [2]  */
        uint32_t CH3_ERROR_IRQ : 1;    /*!< [3]  */
        uint32_t CH4_ERROR_IRQ : 1;    /*!< [4]  */
        uint32_t CH5_ERROR_IRQ : 1;    /*!< [5]  */
        uint32_t CH6_ERROR_IRQ : 1;    /*!< [6]  */
        uint32_t CH7_ERROR_IRQ : 1;    /*!< [7]  */
        uint32_t CH8_ERROR_IRQ : 1;    /*!< [8]  */
        uint32_t CH9_ERROR_IRQ : 1;    /*!< [9]  */
        uint32_t CH10_ERROR_IRQ : 1;   /*!< [10]  */
        uint32_t CH11_ERROR_IRQ : 1;   /*!< [11]  */
        uint32_t CH12_ERROR_IRQ : 1;   /*!< [12]  */
        uint32_t CH13_ERROR_IRQ : 1;   /*!< [13]  */
        uint32_t CH14_ERROR_IRQ : 1;   /*!< [14]  */
        uint32_t CH15_ERROR_IRQ : 1;   /*!< [15]  */
        uint32_t CH0_ERROR_STATUS : 1; /*!< [16]  */
        uint32_t CH1_ERROR_STATUS : 1; /*!< [17]  */
        uint32_t CH2_ERROR_STATUS : 1; /*!< [18]  */
        uint32_t CH3_ERROR_STATUS : 1; /*!< [19]  */
        uint32_t CH4_ERROR_STATUS : 1; /*!< [20]  */
        uint32_t CH5_ERROR_STATUS : 1; /*!< [21]  */
        uint32_t CH6_ERROR_STATUS : 1; /*!< [22]  */
        uint32_t CH7_ERROR_STATUS : 1; /*!< [23]  */
        uint32_t CH8_ERROR_STATUS : 1; /*!< [24]  */
        uint32_t CH9_ERROR_STATUS : 1; /*!< [25]  */
        uint32_t CH10_ERROR_STATUS : 1; /*!< [26]  */
        uint32_t CH11_ERROR_STATUS : 1; /*!< [27]  */
        uint32_t CH12_ERROR_STATUS : 1; /*!< [28]  */
        uint32_t CH13_ERROR_STATUS : 1; /*!< [29]  */
        uint32_t CH14_ERROR_STATUS : 1; /*!< [30]  */
        uint32_t CH15_ERROR_STATUS : 1; /*!< [31]  */
    } B;
} hw_apbh_ctrl2_t;

/*!
 * @name Constants and macros for entire APBH_CTRL2 register
 */
/*@{*/
#define HW_APBH_CTRL2_ADDR(x)    ((uintptr_t)(x) + 0x20U)
#define HW_APBH_CTRL2_SET_ADDR(x) (HW_APBH_CTRL2_ADDR(x) + 0x4U)
#define HW_APBH_CTRL2_CLR_ADDR(x) (HW_APBH_CTRL2_ADDR(x) + 0x8U)
#define HW_APBH_CTRL2_TOG_ADDR(x) (HW_APBH_CTRL2_ADDR(x) + 0xCU)

#define HW_APBH_CTRL2(x)         (*(__IO hw_apbh_ctrl2_t *) HW_APBH_CTRL2_ADDR(x))
#define HW_APBH_CTRL2_RD(x)      (HW_APBH_CTRL2(x).U)
#define HW_APBH_CTRL2_WR(x, v)   (HW_APBH_CTRL2(x).U = (v))
#define HW_APBH_CTRL2_SET(x, v)  ((*(uint32_t *) HW_APBH_CTRL2_SET_ADDR(x)) = (v))
#define HW_APBH_CTRL2_CLR(x, v)  ((*(uint32_t *) HW_APBH_CTRL2_CLR_ADDR(x)) = (v))
#define HW_APBH_CTRL2_TOG(x, v)  ((*(uint32_t *) HW_APBH_CTRL2_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual APBH_CTRL2 bitfields
 */

/*!
 * @name Register APBH_CTRL2, field CH0_ERROR_IRQ[0] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 0. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH0_ERROR_IRQ (0U)   /*!< Bit position for APBH_CTRL2_CH0_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH0_ERROR_IRQ (0x00000001U) /*!< Bit mask for APBH_CTRL2_CH0_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH0_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH0_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH0_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH0_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH0_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH0_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH0_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH0_ERROR_IRQ) & BM_APBH_CTRL2_CH0_ERROR_IRQ)

/*! @brief Set the CH0_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH0_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH0_ERROR_IRQ) | BF_APBH_CTRL2_CH0_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH1_ERROR_IRQ[1] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 1. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH1_ERROR_IRQ (1U)   /*!< Bit position for APBH_CTRL2_CH1_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH1_ERROR_IRQ (0x00000002U) /*!< Bit mask for APBH_CTRL2_CH1_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH1_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH1_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH1_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH1_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH1_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH1_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH1_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH1_ERROR_IRQ) & BM_APBH_CTRL2_CH1_ERROR_IRQ)

/*! @brief Set the CH1_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH1_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH1_ERROR_IRQ) | BF_APBH_CTRL2_CH1_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH2_ERROR_IRQ[2] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 2. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH2_ERROR_IRQ (2U)   /*!< Bit position for APBH_CTRL2_CH2_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH2_ERROR_IRQ (0x00000004U) /*!< Bit mask for APBH_CTRL2_CH2_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH2_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH2_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH2_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH2_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH2_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH2_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH2_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH2_ERROR_IRQ) & BM_APBH_CTRL2_CH2_ERROR_IRQ)

/*! @brief Set the CH2_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH2_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH2_ERROR_IRQ) | BF_APBH_CTRL2_CH2_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH3_ERROR_IRQ[3] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 3. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH3_ERROR_IRQ (3U)   /*!< Bit position for APBH_CTRL2_CH3_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH3_ERROR_IRQ (0x00000008U) /*!< Bit mask for APBH_CTRL2_CH3_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH3_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH3_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH3_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH3_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH3_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH3_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH3_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH3_ERROR_IRQ) & BM_APBH_CTRL2_CH3_ERROR_IRQ)

/*! @brief Set the CH3_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH3_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH3_ERROR_IRQ) | BF_APBH_CTRL2_CH3_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH4_ERROR_IRQ[4] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 4. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH4_ERROR_IRQ (4U)   /*!< Bit position for APBH_CTRL2_CH4_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH4_ERROR_IRQ (0x00000010U) /*!< Bit mask for APBH_CTRL2_CH4_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH4_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH4_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH4_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH4_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH4_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH4_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH4_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH4_ERROR_IRQ) & BM_APBH_CTRL2_CH4_ERROR_IRQ)

/*! @brief Set the CH4_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH4_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH4_ERROR_IRQ) | BF_APBH_CTRL2_CH4_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH5_ERROR_IRQ[5] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 5. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH5_ERROR_IRQ (5U)   /*!< Bit position for APBH_CTRL2_CH5_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH5_ERROR_IRQ (0x00000020U) /*!< Bit mask for APBH_CTRL2_CH5_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH5_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH5_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH5_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH5_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH5_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH5_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH5_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH5_ERROR_IRQ) & BM_APBH_CTRL2_CH5_ERROR_IRQ)

/*! @brief Set the CH5_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH5_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH5_ERROR_IRQ) | BF_APBH_CTRL2_CH5_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH6_ERROR_IRQ[6] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 6. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH6_ERROR_IRQ (6U)   /*!< Bit position for APBH_CTRL2_CH6_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH6_ERROR_IRQ (0x00000040U) /*!< Bit mask for APBH_CTRL2_CH6_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH6_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH6_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH6_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH6_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH6_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH6_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH6_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH6_ERROR_IRQ) & BM_APBH_CTRL2_CH6_ERROR_IRQ)

/*! @brief Set the CH6_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH6_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH6_ERROR_IRQ) | BF_APBH_CTRL2_CH6_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH7_ERROR_IRQ[7] (RW)
 *
 * Error interrupt status bit for APBX DMA Channel 7. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH7_ERROR_IRQ (7U)   /*!< Bit position for APBH_CTRL2_CH7_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH7_ERROR_IRQ (0x00000080U) /*!< Bit mask for APBH_CTRL2_CH7_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH7_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH7_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH7_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH7_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH7_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH7_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH7_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH7_ERROR_IRQ) & BM_APBH_CTRL2_CH7_ERROR_IRQ)

/*! @brief Set the CH7_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH7_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH7_ERROR_IRQ) | BF_APBH_CTRL2_CH7_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH8_ERROR_IRQ[8] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 8. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH8_ERROR_IRQ (8U)   /*!< Bit position for APBH_CTRL2_CH8_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH8_ERROR_IRQ (0x00000100U) /*!< Bit mask for APBH_CTRL2_CH8_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH8_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH8_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH8_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH8_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH8_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH8_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH8_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH8_ERROR_IRQ) & BM_APBH_CTRL2_CH8_ERROR_IRQ)

/*! @brief Set the CH8_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH8_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH8_ERROR_IRQ) | BF_APBH_CTRL2_CH8_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH9_ERROR_IRQ[9] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 9. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding cmdcmplt
 * irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH9_ERROR_IRQ (9U)   /*!< Bit position for APBH_CTRL2_CH9_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH9_ERROR_IRQ (0x00000200U) /*!< Bit mask for APBH_CTRL2_CH9_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH9_ERROR_IRQ (1U)   /*!< Bit field size in bits for APBH_CTRL2_CH9_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH9_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH9_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH9_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH9_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH9_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH9_ERROR_IRQ) & BM_APBH_CTRL2_CH9_ERROR_IRQ)

/*! @brief Set the CH9_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH9_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH9_ERROR_IRQ) | BF_APBH_CTRL2_CH9_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH10_ERROR_IRQ[10] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 10. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH10_ERROR_IRQ (10U) /*!< Bit position for APBH_CTRL2_CH10_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH10_ERROR_IRQ (0x00000400U) /*!< Bit mask for APBH_CTRL2_CH10_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH10_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH10_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH10_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH10_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH10_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH10_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH10_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH10_ERROR_IRQ) & BM_APBH_CTRL2_CH10_ERROR_IRQ)

/*! @brief Set the CH10_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH10_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH10_ERROR_IRQ) | BF_APBH_CTRL2_CH10_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH11_ERROR_IRQ[11] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 11. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH11_ERROR_IRQ (11U) /*!< Bit position for APBH_CTRL2_CH11_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH11_ERROR_IRQ (0x00000800U) /*!< Bit mask for APBH_CTRL2_CH11_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH11_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH11_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH11_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH11_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH11_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH11_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH11_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH11_ERROR_IRQ) & BM_APBH_CTRL2_CH11_ERROR_IRQ)

/*! @brief Set the CH11_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH11_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH11_ERROR_IRQ) | BF_APBH_CTRL2_CH11_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH12_ERROR_IRQ[12] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 12. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH12_ERROR_IRQ (12U) /*!< Bit position for APBH_CTRL2_CH12_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH12_ERROR_IRQ (0x00001000U) /*!< Bit mask for APBH_CTRL2_CH12_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH12_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH12_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH12_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH12_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH12_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH12_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH12_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH12_ERROR_IRQ) & BM_APBH_CTRL2_CH12_ERROR_IRQ)

/*! @brief Set the CH12_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH12_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH12_ERROR_IRQ) | BF_APBH_CTRL2_CH12_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH13_ERROR_IRQ[13] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 13. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH13_ERROR_IRQ (13U) /*!< Bit position for APBH_CTRL2_CH13_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH13_ERROR_IRQ (0x00002000U) /*!< Bit mask for APBH_CTRL2_CH13_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH13_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH13_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH13_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH13_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH13_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH13_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH13_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH13_ERROR_IRQ) & BM_APBH_CTRL2_CH13_ERROR_IRQ)

/*! @brief Set the CH13_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH13_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH13_ERROR_IRQ) | BF_APBH_CTRL2_CH13_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH14_ERROR_IRQ[14] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 14. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH14_ERROR_IRQ (14U) /*!< Bit position for APBH_CTRL2_CH14_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH14_ERROR_IRQ (0x00004000U) /*!< Bit mask for APBH_CTRL2_CH14_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH14_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH14_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH14_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH14_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH14_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH14_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH14_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH14_ERROR_IRQ) & BM_APBH_CTRL2_CH14_ERROR_IRQ)

/*! @brief Set the CH14_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH14_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH14_ERROR_IRQ) | BF_APBH_CTRL2_CH14_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH15_ERROR_IRQ[15] (RW)
 *
 * Error interrupt status bit for APBH DMA Channel 15. This sticky bit is set by
 * DMA hardware and reset by software. It is ORed with the corresponding
 * cmdcmplt irq to generate an irq to ARM.
 */
/*@{*/
#define BP_APBH_CTRL2_CH15_ERROR_IRQ (15U) /*!< Bit position for APBH_CTRL2_CH15_ERROR_IRQ. */
#define BM_APBH_CTRL2_CH15_ERROR_IRQ (0x00008000U) /*!< Bit mask for APBH_CTRL2_CH15_ERROR_IRQ. */
#define BS_APBH_CTRL2_CH15_ERROR_IRQ (1U)  /*!< Bit field size in bits for APBH_CTRL2_CH15_ERROR_IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH15_ERROR_IRQ field. */
#define BR_APBH_CTRL2_CH15_ERROR_IRQ(x) (HW_APBH_CTRL2(x).B.CH15_ERROR_IRQ)

/*! @brief Format value for bitfield APBH_CTRL2_CH15_ERROR_IRQ. */
#define BF_APBH_CTRL2_CH15_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CTRL2_CH15_ERROR_IRQ) & BM_APBH_CTRL2_CH15_ERROR_IRQ)

/*! @brief Set the CH15_ERROR_IRQ field to a new value. */
#define BW_APBH_CTRL2_CH15_ERROR_IRQ(x, v) (HW_APBH_CTRL2_WR(x, (HW_APBH_CTRL2_RD(x) & ~BM_APBH_CTRL2_CH15_ERROR_IRQ) | BF_APBH_CTRL2_CH15_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH0_ERROR_STATUS[16] (RO)
 *
 * Error status bit for APBX DMA Channel 0. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH0_ERROR_STATUS (16U) /*!< Bit position for APBH_CTRL2_CH0_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH0_ERROR_STATUS (0x00010000U) /*!< Bit mask for APBH_CTRL2_CH0_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH0_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH0_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH0_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH0_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH0_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH0_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH0_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH0_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH0_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH1_ERROR_STATUS[17] (RO)
 *
 * Error status bit for APBX DMA Channel 1. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH1_ERROR_STATUS (17U) /*!< Bit position for APBH_CTRL2_CH1_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH1_ERROR_STATUS (0x00020000U) /*!< Bit mask for APBH_CTRL2_CH1_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH1_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH1_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH1_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH1_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH1_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH1_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH1_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH1_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH1_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH2_ERROR_STATUS[18] (RO)
 *
 * Error status bit for APBX DMA Channel 2. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH2_ERROR_STATUS (18U) /*!< Bit position for APBH_CTRL2_CH2_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH2_ERROR_STATUS (0x00040000U) /*!< Bit mask for APBH_CTRL2_CH2_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH2_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH2_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH2_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH2_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH2_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH2_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH2_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH2_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH2_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH3_ERROR_STATUS[19] (RO)
 *
 * Error status bit for APBX DMA Channel 3. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH3_ERROR_STATUS (19U) /*!< Bit position for APBH_CTRL2_CH3_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH3_ERROR_STATUS (0x00080000U) /*!< Bit mask for APBH_CTRL2_CH3_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH3_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH3_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH3_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH3_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH3_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH3_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH3_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH3_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH3_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH4_ERROR_STATUS[20] (RO)
 *
 * Error status bit for APBX DMA Channel 4. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH4_ERROR_STATUS (20U) /*!< Bit position for APBH_CTRL2_CH4_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH4_ERROR_STATUS (0x00100000U) /*!< Bit mask for APBH_CTRL2_CH4_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH4_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH4_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH4_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH4_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH4_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH4_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH4_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH4_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH4_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH5_ERROR_STATUS[21] (RO)
 *
 * Error status bit for APBX DMA Channel 5. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH5_ERROR_STATUS (21U) /*!< Bit position for APBH_CTRL2_CH5_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH5_ERROR_STATUS (0x00200000U) /*!< Bit mask for APBH_CTRL2_CH5_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH5_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH5_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH5_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH5_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH5_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH5_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH5_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH5_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH5_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH6_ERROR_STATUS[22] (RO)
 *
 * Error status bit for APBX DMA Channel 6. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH6_ERROR_STATUS (22U) /*!< Bit position for APBH_CTRL2_CH6_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH6_ERROR_STATUS (0x00400000U) /*!< Bit mask for APBH_CTRL2_CH6_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH6_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH6_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH6_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH6_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH6_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH6_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH6_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH6_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH6_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH7_ERROR_STATUS[23] (RO)
 *
 * Error status bit for APBX DMA Channel 7. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH7_ERROR_STATUS (23U) /*!< Bit position for APBH_CTRL2_CH7_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH7_ERROR_STATUS (0x00800000U) /*!< Bit mask for APBH_CTRL2_CH7_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH7_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH7_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH7_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH7_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH7_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH7_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH7_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH7_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH7_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH8_ERROR_STATUS[24] (RO)
 *
 * Error status bit for APBH DMA Channel 8. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH8_ERROR_STATUS (24U) /*!< Bit position for APBH_CTRL2_CH8_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH8_ERROR_STATUS (0x01000000U) /*!< Bit mask for APBH_CTRL2_CH8_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH8_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH8_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH8_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH8_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH8_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH8_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH8_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH8_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH8_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH9_ERROR_STATUS[25] (RO)
 *
 * Error status bit for APBH DMA Channel 9. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH9_ERROR_STATUS (25U) /*!< Bit position for APBH_CTRL2_CH9_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH9_ERROR_STATUS (0x02000000U) /*!< Bit mask for APBH_CTRL2_CH9_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH9_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH9_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH9_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH9_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH9_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH9_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH9_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH9_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH9_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH10_ERROR_STATUS[26] (RO)
 *
 * Error status bit for APBH DMA Channel 10. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH10_ERROR_STATUS (26U) /*!< Bit position for APBH_CTRL2_CH10_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH10_ERROR_STATUS (0x04000000U) /*!< Bit mask for APBH_CTRL2_CH10_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH10_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH10_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH10_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH10_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH10_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH10_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH10_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH10_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH10_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH11_ERROR_STATUS[27] (RO)
 *
 * Error status bit for APBH DMA Channel 11. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH11_ERROR_STATUS (27U) /*!< Bit position for APBH_CTRL2_CH11_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH11_ERROR_STATUS (0x08000000U) /*!< Bit mask for APBH_CTRL2_CH11_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH11_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH11_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH11_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH11_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH11_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH11_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH11_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH11_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH11_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH12_ERROR_STATUS[28] (RO)
 *
 * Error status bit for APBH DMA Channel 12. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH12_ERROR_STATUS (28U) /*!< Bit position for APBH_CTRL2_CH12_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH12_ERROR_STATUS (0x10000000U) /*!< Bit mask for APBH_CTRL2_CH12_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH12_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH12_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH12_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH12_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH12_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH12_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH12_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH12_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH12_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH13_ERROR_STATUS[29] (RO)
 *
 * Error status bit for APBH DMA Channel 13. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH13_ERROR_STATUS (29U) /*!< Bit position for APBH_CTRL2_CH13_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH13_ERROR_STATUS (0x20000000U) /*!< Bit mask for APBH_CTRL2_CH13_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH13_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH13_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH13_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH13_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH13_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH13_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH13_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH13_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH13_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH14_ERROR_STATUS[30] (RO)
 *
 * Error status bit for APBH DMA Channel 14. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH14_ERROR_STATUS (30U) /*!< Bit position for APBH_CTRL2_CH14_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH14_ERROR_STATUS (0x40000000U) /*!< Bit mask for APBH_CTRL2_CH14_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH14_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH14_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH14_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH14_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH14_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH14_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH14_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH14_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH14_ERROR_STATUS)
/*@}*/

/*!
 * @name Register APBH_CTRL2, field CH15_ERROR_STATUS[31] (RO)
 *
 * Error status bit for APBH DMA Channel 15. Valid when corresponding Error IRQ
 * is set. 1 - AHB bus error 0 - channel early termination.
 *
 * Values:
 * - 0 - An early termination from the device causes error IRQ.
 * - 1 - An AHB bus error causes error IRQ.
 */
/*@{*/
#define BP_APBH_CTRL2_CH15_ERROR_STATUS (31U) /*!< Bit position for APBH_CTRL2_CH15_ERROR_STATUS. */
#define BM_APBH_CTRL2_CH15_ERROR_STATUS (0x80000000U) /*!< Bit mask for APBH_CTRL2_CH15_ERROR_STATUS. */
#define BS_APBH_CTRL2_CH15_ERROR_STATUS (1U) /*!< Bit field size in bits for APBH_CTRL2_CH15_ERROR_STATUS. */

#define BV_APBH_CTRL2_CH15_ERROR_STATUS_TERMINATION (0U) /*!< Bit field value for APBH_CTRL2_CH15_ERROR_STATUS: An early termination from the device causes error IRQ. */
#define BV_APBH_CTRL2_CH15_ERROR_STATUS_BUS_ERROR (0x1U) /*!< Bit field value for APBH_CTRL2_CH15_ERROR_STATUS: An AHB bus error causes error IRQ. */

/*! @brief Read current value of the APBH_CTRL2_CH15_ERROR_STATUS field. */
#define BR_APBH_CTRL2_CH15_ERROR_STATUS(x) (HW_APBH_CTRL2(x).B.CH15_ERROR_STATUS)
/*@}*/




/*******************************************************************************
 * HW_APBH_CHANNEL_CTRL - AHB to APBH Bridge Channel Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHANNEL_CTRL - AHB to APBH Bridge Channel Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The APBH CHANNEL CTRL provides reset/freeze control of each DMA channel. This
 * register contains individual channel reset/freeze bits.
 */
typedef union _hw_apbh_channel_ctrl
{
    uint32_t U;
    struct _hw_apbh_channel_ctrl_bitfields
    {
        uint32_t FREEZE_CHANNEL : 16;  /*!< [15:0]  */
        uint32_t RESET_CHANNEL : 16;   /*!< [31:16]  */
    } B;
} hw_apbh_channel_ctrl_t;

/*!
 * @name Constants and macros for entire APBH_CHANNEL_CTRL register
 */
/*@{*/
#define HW_APBH_CHANNEL_CTRL_ADDR(x) ((uintptr_t)(x) + 0x30U)
#define HW_APBH_CHANNEL_CTRL_SET_ADDR(x) (HW_APBH_CHANNEL_CTRL_ADDR(x) + 0x4U)
#define HW_APBH_CHANNEL_CTRL_CLR_ADDR(x) (HW_APBH_CHANNEL_CTRL_ADDR(x) + 0x8U)
#define HW_APBH_CHANNEL_CTRL_TOG_ADDR(x) (HW_APBH_CHANNEL_CTRL_ADDR(x) + 0xCU)

#define HW_APBH_CHANNEL_CTRL(x)  (*(__IO hw_apbh_channel_ctrl_t *) HW_APBH_CHANNEL_CTRL_ADDR(x))
#define HW_APBH_CHANNEL_CTRL_RD(x) (HW_APBH_CHANNEL_CTRL(x).U)
#define HW_APBH_CHANNEL_CTRL_WR(x, v) (HW_APBH_CHANNEL_CTRL(x).U = (v))
#define HW_APBH_CHANNEL_CTRL_SET(x, v) ((*(uint32_t *) HW_APBH_CHANNEL_CTRL_SET_ADDR(x)) = (v))
#define HW_APBH_CHANNEL_CTRL_CLR(x, v) ((*(uint32_t *) HW_APBH_CHANNEL_CTRL_CLR_ADDR(x)) = (v))
#define HW_APBH_CHANNEL_CTRL_TOG(x, v) ((*(uint32_t *) HW_APBH_CHANNEL_CTRL_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual APBH_CHANNEL_CTRL bitfields
 */

/*!
 * @name Register APBH_CHANNEL_CTRL, field FREEZE_CHANNEL[15:0] (RW)
 *
 * Setting a bit in this field will freeze the DMA channel associated with it.
 * This field is a direct input to the DMA channel arbiter. When frozen, the
 * channel is deined access to the central DMA resources.
 *
 * Values:
 * - 1 -
 * - 10 -
 * - 100 -
 * - 1000 -
 * - 10000 -
 * - 100000 -
 * - 1000000 -
 * - 10000000 -
 * - 100000000 -
 */
/*@{*/
#define BP_APBH_CHANNEL_CTRL_FREEZE_CHANNEL (0U) /*!< Bit position for APBH_CHANNEL_CTRL_FREEZE_CHANNEL. */
#define BM_APBH_CHANNEL_CTRL_FREEZE_CHANNEL (0x0000FFFFU) /*!< Bit mask for APBH_CHANNEL_CTRL_FREEZE_CHANNEL. */
#define BS_APBH_CHANNEL_CTRL_FREEZE_CHANNEL (16U) /*!< Bit field size in bits for APBH_CHANNEL_CTRL_FREEZE_CHANNEL. */

#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND0 (0x1U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND1 (0x2U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND2 (0x4U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND3 (0x8U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND4 (0x10U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND5 (0x20U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND6 (0x40U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_NAND7 (0x80U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_FREEZE_CHANNEL_SSP (0x100U) /*!< Bit field value for APBH_CHANNEL_CTRL_FREEZE_CHANNEL:  */

/*! @brief Read current value of the APBH_CHANNEL_CTRL_FREEZE_CHANNEL field. */
#define BR_APBH_CHANNEL_CTRL_FREEZE_CHANNEL(x) (HW_APBH_CHANNEL_CTRL(x).B.FREEZE_CHANNEL)

/*! @brief Format value for bitfield APBH_CHANNEL_CTRL_FREEZE_CHANNEL. */
#define BF_APBH_CHANNEL_CTRL_FREEZE_CHANNEL(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CHANNEL_CTRL_FREEZE_CHANNEL) & BM_APBH_CHANNEL_CTRL_FREEZE_CHANNEL)

/*! @brief Set the FREEZE_CHANNEL field to a new value. */
#define BW_APBH_CHANNEL_CTRL_FREEZE_CHANNEL(x, v) (HW_APBH_CHANNEL_CTRL_WR(x, (HW_APBH_CHANNEL_CTRL_RD(x) & ~BM_APBH_CHANNEL_CTRL_FREEZE_CHANNEL) | BF_APBH_CHANNEL_CTRL_FREEZE_CHANNEL(v)))
/*@}*/

/*!
 * @name Register APBH_CHANNEL_CTRL, field RESET_CHANNEL[31:16] (RW)
 *
 * Setting a bit in this field causes the DMA controller to take the
 * corresponding channel through its reset state. The bit is reset after the channel
 * resources are cleared.
 *
 * Values:
 * - 1 -
 * - 10 -
 * - 100 -
 * - 1000 -
 * - 10000 -
 * - 100000 -
 * - 1000000 -
 * - 10000000 -
 * - 100000000 -
 */
/*@{*/
#define BP_APBH_CHANNEL_CTRL_RESET_CHANNEL (16U) /*!< Bit position for APBH_CHANNEL_CTRL_RESET_CHANNEL. */
#define BM_APBH_CHANNEL_CTRL_RESET_CHANNEL (0xFFFF0000U) /*!< Bit mask for APBH_CHANNEL_CTRL_RESET_CHANNEL. */
#define BS_APBH_CHANNEL_CTRL_RESET_CHANNEL (16U) /*!< Bit field size in bits for APBH_CHANNEL_CTRL_RESET_CHANNEL. */

#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND0 (0x1U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND1 (0x2U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND2 (0x4U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND3 (0x8U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND4 (0x10U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND5 (0x20U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND6 (0x40U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_NAND7 (0x80U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */
#define BV_APBH_CHANNEL_CTRL_RESET_CHANNEL_SSP (0x100U) /*!< Bit field value for APBH_CHANNEL_CTRL_RESET_CHANNEL:  */

/*! @brief Read current value of the APBH_CHANNEL_CTRL_RESET_CHANNEL field. */
#define BR_APBH_CHANNEL_CTRL_RESET_CHANNEL(x) (HW_APBH_CHANNEL_CTRL(x).B.RESET_CHANNEL)

/*! @brief Format value for bitfield APBH_CHANNEL_CTRL_RESET_CHANNEL. */
#define BF_APBH_CHANNEL_CTRL_RESET_CHANNEL(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CHANNEL_CTRL_RESET_CHANNEL) & BM_APBH_CHANNEL_CTRL_RESET_CHANNEL)

/*! @brief Set the RESET_CHANNEL field to a new value. */
#define BW_APBH_CHANNEL_CTRL_RESET_CHANNEL(x, v) (HW_APBH_CHANNEL_CTRL_WR(x, (HW_APBH_CHANNEL_CTRL_RD(x) & ~BM_APBH_CHANNEL_CTRL_RESET_CHANNEL) | BF_APBH_CHANNEL_CTRL_RESET_CHANNEL(v)))
/*@}*/




/*******************************************************************************
 * HW_APBH_DEVSEL - AHB to APBH DMA Device Assignment Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_DEVSEL - AHB to APBH DMA Device Assignment Register (RU)
 *
 * Reset value: 0x00000000U
 *
 * This register allows reassignment of the APBH device connected to the DMA
 * Channels. In this chip, APBH DMA channel resource is enough for high speed
 * peripherals, so this register is of no use and reserved.
 */
typedef union _hw_apbh_devsel
{
    uint32_t U;
    struct _hw_apbh_devsel_bitfields
    {
        uint32_t CH0 : 2;              /*!< [1:0]  */
        uint32_t CH1 : 2;              /*!< [3:2]  */
        uint32_t CH2 : 2;              /*!< [5:4]  */
        uint32_t CH3 : 2;              /*!< [7:6]  */
        uint32_t CH4 : 2;              /*!< [9:8]  */
        uint32_t CH5 : 2;              /*!< [11:10]  */
        uint32_t CH6 : 2;              /*!< [13:12]  */
        uint32_t CH7 : 2;              /*!< [15:14]  */
        uint32_t CH8 : 2;              /*!< [17:16]  */
        uint32_t CH9 : 2;              /*!< [19:18]  */
        uint32_t CH10 : 2;             /*!< [21:20]  */
        uint32_t CH11 : 2;             /*!< [23:22]  */
        uint32_t CH12 : 2;             /*!< [25:24]  */
        uint32_t CH13 : 2;             /*!< [27:26]  */
        uint32_t CH14 : 2;             /*!< [29:28]  */
        uint32_t CH15 : 2;             /*!< [31:30]  */
    } B;
} hw_apbh_devsel_t;

/*!
 * @name Constants and macros for entire APBH_DEVSEL register
 */
/*@{*/
#define HW_APBH_DEVSEL_ADDR(x)   ((uintptr_t)(x) + 0x40U)
#define HW_APBH_DEVSEL(x)        (*(__I hw_apbh_devsel_t *) HW_APBH_DEVSEL_ADDR(x))
/*@}*/

/*
 * Constants & macros for individual APBH_DEVSEL bitfields
 */

/*!
 * @name Register APBH_DEVSEL, field CH0[1:0] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH0   (0U)          /*!< Bit position for APBH_DEVSEL_CH0. */
#define BM_APBH_DEVSEL_CH0   (0x00000003U) /*!< Bit mask for APBH_DEVSEL_CH0. */
#define BS_APBH_DEVSEL_CH0   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH0. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH1[3:2] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH1   (2U)          /*!< Bit position for APBH_DEVSEL_CH1. */
#define BM_APBH_DEVSEL_CH1   (0x0000000CU) /*!< Bit mask for APBH_DEVSEL_CH1. */
#define BS_APBH_DEVSEL_CH1   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH1. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH2[5:4] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH2   (4U)          /*!< Bit position for APBH_DEVSEL_CH2. */
#define BM_APBH_DEVSEL_CH2   (0x00000030U) /*!< Bit mask for APBH_DEVSEL_CH2. */
#define BS_APBH_DEVSEL_CH2   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH2. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH3[7:6] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH3   (6U)          /*!< Bit position for APBH_DEVSEL_CH3. */
#define BM_APBH_DEVSEL_CH3   (0x000000C0U) /*!< Bit mask for APBH_DEVSEL_CH3. */
#define BS_APBH_DEVSEL_CH3   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH3. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH4[9:8] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH4   (8U)          /*!< Bit position for APBH_DEVSEL_CH4. */
#define BM_APBH_DEVSEL_CH4   (0x00000300U) /*!< Bit mask for APBH_DEVSEL_CH4. */
#define BS_APBH_DEVSEL_CH4   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH4. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH5[11:10] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH5   (10U)         /*!< Bit position for APBH_DEVSEL_CH5. */
#define BM_APBH_DEVSEL_CH5   (0x00000C00U) /*!< Bit mask for APBH_DEVSEL_CH5. */
#define BS_APBH_DEVSEL_CH5   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH5. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH6[13:12] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH6   (12U)         /*!< Bit position for APBH_DEVSEL_CH6. */
#define BM_APBH_DEVSEL_CH6   (0x00003000U) /*!< Bit mask for APBH_DEVSEL_CH6. */
#define BS_APBH_DEVSEL_CH6   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH6. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH7[15:14] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH7   (14U)         /*!< Bit position for APBH_DEVSEL_CH7. */
#define BM_APBH_DEVSEL_CH7   (0x0000C000U) /*!< Bit mask for APBH_DEVSEL_CH7. */
#define BS_APBH_DEVSEL_CH7   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH7. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH8[17:16] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH8   (16U)         /*!< Bit position for APBH_DEVSEL_CH8. */
#define BM_APBH_DEVSEL_CH8   (0x00030000U) /*!< Bit mask for APBH_DEVSEL_CH8. */
#define BS_APBH_DEVSEL_CH8   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH8. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH9[19:18] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH9   (18U)         /*!< Bit position for APBH_DEVSEL_CH9. */
#define BM_APBH_DEVSEL_CH9   (0x000C0000U) /*!< Bit mask for APBH_DEVSEL_CH9. */
#define BS_APBH_DEVSEL_CH9   (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH9. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH10[21:20] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH10  (20U)         /*!< Bit position for APBH_DEVSEL_CH10. */
#define BM_APBH_DEVSEL_CH10  (0x00300000U) /*!< Bit mask for APBH_DEVSEL_CH10. */
#define BS_APBH_DEVSEL_CH10  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH10. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH11[23:22] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH11  (22U)         /*!< Bit position for APBH_DEVSEL_CH11. */
#define BM_APBH_DEVSEL_CH11  (0x00C00000U) /*!< Bit mask for APBH_DEVSEL_CH11. */
#define BS_APBH_DEVSEL_CH11  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH11. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH12[25:24] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH12  (24U)         /*!< Bit position for APBH_DEVSEL_CH12. */
#define BM_APBH_DEVSEL_CH12  (0x03000000U) /*!< Bit mask for APBH_DEVSEL_CH12. */
#define BS_APBH_DEVSEL_CH12  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH12. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH13[27:26] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH13  (26U)         /*!< Bit position for APBH_DEVSEL_CH13. */
#define BM_APBH_DEVSEL_CH13  (0x0C000000U) /*!< Bit mask for APBH_DEVSEL_CH13. */
#define BS_APBH_DEVSEL_CH13  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH13. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH14[29:28] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH14  (28U)         /*!< Bit position for APBH_DEVSEL_CH14. */
#define BM_APBH_DEVSEL_CH14  (0x30000000U) /*!< Bit mask for APBH_DEVSEL_CH14. */
#define BS_APBH_DEVSEL_CH14  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH14. */
/*@}*/

/*!
 * @name Register APBH_DEVSEL, field CH15[31:30] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DEVSEL_CH15  (30U)         /*!< Bit position for APBH_DEVSEL_CH15. */
#define BM_APBH_DEVSEL_CH15  (0xC0000000U) /*!< Bit mask for APBH_DEVSEL_CH15. */
#define BS_APBH_DEVSEL_CH15  (2U)          /*!< Bit field size in bits for APBH_DEVSEL_CH15. */
/*@}*/

/*******************************************************************************
 * HW_APBH_DMA_BURST_SIZE - AHB to APBH DMA burst size
 ******************************************************************************/

/*!
 * @brief HW_APBH_DMA_BURST_SIZE - AHB to APBH DMA burst size (RW)
 *
 * Reset value: 0x00555555U
 *
 * This register programs the apbh burst size of the APBH DMA devices when a DMA
 * burst request is issued. This register provides a mechanism for assigning the
 * device.
 */
typedef union _hw_apbh_dma_burst_size
{
    uint32_t U;
    struct _hw_apbh_dma_burst_size_bitfields
    {
        uint32_t CH0 : 2;              /*!< [1:0]  */
        uint32_t CH1 : 2;              /*!< [3:2]  */
        uint32_t CH2 : 2;              /*!< [5:4]  */
        uint32_t CH3 : 2;              /*!< [7:6]  */
        uint32_t CH4 : 2;              /*!< [9:8]  */
        uint32_t CH5 : 2;              /*!< [11:10]  */
        uint32_t CH6 : 2;              /*!< [13:12]  */
        uint32_t CH7 : 2;              /*!< [15:14]  */
        uint32_t CH8 : 2;              /*!< [17:16]  */
        uint32_t CH9 : 2;              /*!< [19:18]  */
        uint32_t CH10 : 2;             /*!< [21:20]  */
        uint32_t CH11 : 2;             /*!< [23:22]  */
        uint32_t CH12 : 2;             /*!< [25:24]  */
        uint32_t CH13 : 2;             /*!< [27:26]  */
        uint32_t CH14 : 2;             /*!< [29:28]  */
        uint32_t CH15 : 2;             /*!< [31:30]  */
    } B;
} hw_apbh_dma_burst_size_t;

/*!
 * @name Constants and macros for entire APBH_DMA_BURST_SIZE register
 */
/*@{*/
#define HW_APBH_DMA_BURST_SIZE_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_APBH_DMA_BURST_SIZE(x) (*(__IO hw_apbh_dma_burst_size_t *) HW_APBH_DMA_BURST_SIZE_ADDR(x))
#define HW_APBH_DMA_BURST_SIZE_RD(x) (HW_APBH_DMA_BURST_SIZE(x).U)
#define HW_APBH_DMA_BURST_SIZE_WR(x, v) (HW_APBH_DMA_BURST_SIZE(x).U = (v))
#define HW_APBH_DMA_BURST_SIZE_SET(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, HW_APBH_DMA_BURST_SIZE_RD(x) |  (v)))
#define HW_APBH_DMA_BURST_SIZE_CLR(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, HW_APBH_DMA_BURST_SIZE_RD(x) & ~(v)))
#define HW_APBH_DMA_BURST_SIZE_TOG(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, HW_APBH_DMA_BURST_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual APBH_DMA_BURST_SIZE bitfields
 */

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH0[1:0] (RW)
 *
 * DMA burst size for GPMI channel 0. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH0 (0U)    /*!< Bit position for APBH_DMA_BURST_SIZE_CH0. */
#define BM_APBH_DMA_BURST_SIZE_CH0 (0x00000003U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH0. */
#define BS_APBH_DMA_BURST_SIZE_CH0 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH0. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH0 field. */
#define BR_APBH_DMA_BURST_SIZE_CH0(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH0)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH0. */
#define BF_APBH_DMA_BURST_SIZE_CH0(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH0) & BM_APBH_DMA_BURST_SIZE_CH0)

/*! @brief Set the CH0 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH0(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH0) | BF_APBH_DMA_BURST_SIZE_CH0(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH1[3:2] (RW)
 *
 * DMA burst size for GPMI channel 1. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH1 (2U)    /*!< Bit position for APBH_DMA_BURST_SIZE_CH1. */
#define BM_APBH_DMA_BURST_SIZE_CH1 (0x0000000CU) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH1. */
#define BS_APBH_DMA_BURST_SIZE_CH1 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH1. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH1 field. */
#define BR_APBH_DMA_BURST_SIZE_CH1(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH1)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH1. */
#define BF_APBH_DMA_BURST_SIZE_CH1(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH1) & BM_APBH_DMA_BURST_SIZE_CH1)

/*! @brief Set the CH1 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH1(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH1) | BF_APBH_DMA_BURST_SIZE_CH1(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH2[5:4] (RW)
 *
 * DMA burst size for GPMI channel 2. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH2 (4U)    /*!< Bit position for APBH_DMA_BURST_SIZE_CH2. */
#define BM_APBH_DMA_BURST_SIZE_CH2 (0x00000030U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH2. */
#define BS_APBH_DMA_BURST_SIZE_CH2 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH2. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH2 field. */
#define BR_APBH_DMA_BURST_SIZE_CH2(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH2)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH2. */
#define BF_APBH_DMA_BURST_SIZE_CH2(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH2) & BM_APBH_DMA_BURST_SIZE_CH2)

/*! @brief Set the CH2 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH2(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH2) | BF_APBH_DMA_BURST_SIZE_CH2(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH3[7:6] (RW)
 *
 * DMA burst size for GPMI channel 3. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH3 (6U)    /*!< Bit position for APBH_DMA_BURST_SIZE_CH3. */
#define BM_APBH_DMA_BURST_SIZE_CH3 (0x000000C0U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH3. */
#define BS_APBH_DMA_BURST_SIZE_CH3 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH3. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH3 field. */
#define BR_APBH_DMA_BURST_SIZE_CH3(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH3)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH3. */
#define BF_APBH_DMA_BURST_SIZE_CH3(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH3) & BM_APBH_DMA_BURST_SIZE_CH3)

/*! @brief Set the CH3 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH3(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH3) | BF_APBH_DMA_BURST_SIZE_CH3(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH4[9:8] (RW)
 *
 * DMA burst size for GPMI channel 4. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH4 (8U)    /*!< Bit position for APBH_DMA_BURST_SIZE_CH4. */
#define BM_APBH_DMA_BURST_SIZE_CH4 (0x00000300U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH4. */
#define BS_APBH_DMA_BURST_SIZE_CH4 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH4. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH4 field. */
#define BR_APBH_DMA_BURST_SIZE_CH4(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH4)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH4. */
#define BF_APBH_DMA_BURST_SIZE_CH4(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH4) & BM_APBH_DMA_BURST_SIZE_CH4)

/*! @brief Set the CH4 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH4(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH4) | BF_APBH_DMA_BURST_SIZE_CH4(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH5[11:10] (RW)
 *
 * DMA burst size for GPMI channel 5. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH5 (10U)   /*!< Bit position for APBH_DMA_BURST_SIZE_CH5. */
#define BM_APBH_DMA_BURST_SIZE_CH5 (0x00000C00U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH5. */
#define BS_APBH_DMA_BURST_SIZE_CH5 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH5. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH5 field. */
#define BR_APBH_DMA_BURST_SIZE_CH5(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH5)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH5. */
#define BF_APBH_DMA_BURST_SIZE_CH5(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH5) & BM_APBH_DMA_BURST_SIZE_CH5)

/*! @brief Set the CH5 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH5(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH5) | BF_APBH_DMA_BURST_SIZE_CH5(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH6[13:12] (RW)
 *
 * DMA burst size for GPMI channel 6. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH6 (12U)   /*!< Bit position for APBH_DMA_BURST_SIZE_CH6. */
#define BM_APBH_DMA_BURST_SIZE_CH6 (0x00003000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH6. */
#define BS_APBH_DMA_BURST_SIZE_CH6 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH6. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH6 field. */
#define BR_APBH_DMA_BURST_SIZE_CH6(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH6)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH6. */
#define BF_APBH_DMA_BURST_SIZE_CH6(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH6) & BM_APBH_DMA_BURST_SIZE_CH6)

/*! @brief Set the CH6 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH6(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH6) | BF_APBH_DMA_BURST_SIZE_CH6(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH7[15:14] (RW)
 *
 * DMA burst size for GPMI channel 7. Do not change. GPMI only support burst
 * size 4.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH7 (14U)   /*!< Bit position for APBH_DMA_BURST_SIZE_CH7. */
#define BM_APBH_DMA_BURST_SIZE_CH7 (0x0000C000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH7. */
#define BS_APBH_DMA_BURST_SIZE_CH7 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH7. */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH7 field. */
#define BR_APBH_DMA_BURST_SIZE_CH7(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH7)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH7. */
#define BF_APBH_DMA_BURST_SIZE_CH7(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH7) & BM_APBH_DMA_BURST_SIZE_CH7)

/*! @brief Set the CH7 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH7(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH7) | BF_APBH_DMA_BURST_SIZE_CH7(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH8[17:16] (RW)
 *
 * DMA burst size for SSP.
 *
 * Values:
 * - 0 -
 * - 1 -
 * - 10 -
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH8 (16U)   /*!< Bit position for APBH_DMA_BURST_SIZE_CH8. */
#define BM_APBH_DMA_BURST_SIZE_CH8 (0x00030000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH8. */
#define BS_APBH_DMA_BURST_SIZE_CH8 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH8. */

#define BV_APBH_DMA_BURST_SIZE_CH8_BURST0 (0U)       /*!< Bit field value for APBH_DMA_BURST_SIZE_CH8:  */
#define BV_APBH_DMA_BURST_SIZE_CH8_BURST4 (0x1U)     /*!< Bit field value for APBH_DMA_BURST_SIZE_CH8:  */
#define BV_APBH_DMA_BURST_SIZE_CH8_BURST8 (0x2U)     /*!< Bit field value for APBH_DMA_BURST_SIZE_CH8:  */

/*! @brief Read current value of the APBH_DMA_BURST_SIZE_CH8 field. */
#define BR_APBH_DMA_BURST_SIZE_CH8(x) (HW_APBH_DMA_BURST_SIZE(x).B.CH8)

/*! @brief Format value for bitfield APBH_DMA_BURST_SIZE_CH8. */
#define BF_APBH_DMA_BURST_SIZE_CH8(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DMA_BURST_SIZE_CH8) & BM_APBH_DMA_BURST_SIZE_CH8)

/*! @brief Set the CH8 field to a new value. */
#define BW_APBH_DMA_BURST_SIZE_CH8(x, v) (HW_APBH_DMA_BURST_SIZE_WR(x, (HW_APBH_DMA_BURST_SIZE_RD(x) & ~BM_APBH_DMA_BURST_SIZE_CH8) | BF_APBH_DMA_BURST_SIZE_CH8(v)))
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH9[19:18] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH9 (18U)   /*!< Bit position for APBH_DMA_BURST_SIZE_CH9. */
#define BM_APBH_DMA_BURST_SIZE_CH9 (0x000C0000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH9. */
#define BS_APBH_DMA_BURST_SIZE_CH9 (2U)    /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH9. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH10[21:20] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH10 (20U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH10. */
#define BM_APBH_DMA_BURST_SIZE_CH10 (0x00300000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH10. */
#define BS_APBH_DMA_BURST_SIZE_CH10 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH10. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH11[23:22] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH11 (22U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH11. */
#define BM_APBH_DMA_BURST_SIZE_CH11 (0x00C00000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH11. */
#define BS_APBH_DMA_BURST_SIZE_CH11 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH11. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH12[25:24] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH12 (24U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH12. */
#define BM_APBH_DMA_BURST_SIZE_CH12 (0x03000000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH12. */
#define BS_APBH_DMA_BURST_SIZE_CH12 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH12. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH13[27:26] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH13 (26U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH13. */
#define BM_APBH_DMA_BURST_SIZE_CH13 (0x0C000000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH13. */
#define BS_APBH_DMA_BURST_SIZE_CH13 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH13. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH14[29:28] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH14 (28U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH14. */
#define BM_APBH_DMA_BURST_SIZE_CH14 (0x30000000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH14. */
#define BS_APBH_DMA_BURST_SIZE_CH14 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH14. */
/*@}*/

/*!
 * @name Register APBH_DMA_BURST_SIZE, field CH15[31:30] (RU)
 *
 * Reserved.
 */
/*@{*/
#define BP_APBH_DMA_BURST_SIZE_CH15 (30U)  /*!< Bit position for APBH_DMA_BURST_SIZE_CH15. */
#define BM_APBH_DMA_BURST_SIZE_CH15 (0xC0000000U) /*!< Bit mask for APBH_DMA_BURST_SIZE_CH15. */
#define BS_APBH_DMA_BURST_SIZE_CH15 (2U)   /*!< Bit field size in bits for APBH_DMA_BURST_SIZE_CH15. */
/*@}*/

/*******************************************************************************
 * HW_APBH_DEBUG - AHB to APBH DMA Debug Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_DEBUG - AHB to APBH DMA Debug Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is for debug purpose. The debug register is for internal use
 * only. Not recommend for customer useage.
 */
typedef union _hw_apbh_debug
{
    uint32_t U;
    struct _hw_apbh_debug_bitfields
    {
        uint32_t GPMI_ONE_FIFO : 1;    /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_apbh_debug_t;

/*!
 * @name Constants and macros for entire APBH_DEBUG register
 */
/*@{*/
#define HW_APBH_DEBUG_ADDR(x)    ((uintptr_t)(x) + 0x60U)

#define HW_APBH_DEBUG(x)         (*(__IO hw_apbh_debug_t *) HW_APBH_DEBUG_ADDR(x))
#define HW_APBH_DEBUG_RD(x)      (HW_APBH_DEBUG(x).U)
#define HW_APBH_DEBUG_WR(x, v)   (HW_APBH_DEBUG(x).U = (v))
#define HW_APBH_DEBUG_SET(x, v)  (HW_APBH_DEBUG_WR(x, HW_APBH_DEBUG_RD(x) |  (v)))
#define HW_APBH_DEBUG_CLR(x, v)  (HW_APBH_DEBUG_WR(x, HW_APBH_DEBUG_RD(x) & ~(v)))
#define HW_APBH_DEBUG_TOG(x, v)  (HW_APBH_DEBUG_WR(x, HW_APBH_DEBUG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual APBH_DEBUG bitfields
 */

/*!
 * @name Register APBH_DEBUG, field GPMI_ONE_FIFO[0] (RW)
 *
 * Set to 0ne and the 8 GPMI channels will share the DMA FIFO, and when set to
 * zero, the 8 GPMI channels will use its own DMA FIFO.
 */
/*@{*/
#define BP_APBH_DEBUG_GPMI_ONE_FIFO (0U)   /*!< Bit position for APBH_DEBUG_GPMI_ONE_FIFO. */
#define BM_APBH_DEBUG_GPMI_ONE_FIFO (0x00000001U) /*!< Bit mask for APBH_DEBUG_GPMI_ONE_FIFO. */
#define BS_APBH_DEBUG_GPMI_ONE_FIFO (1U)   /*!< Bit field size in bits for APBH_DEBUG_GPMI_ONE_FIFO. */

/*! @brief Read current value of the APBH_DEBUG_GPMI_ONE_FIFO field. */
#define BR_APBH_DEBUG_GPMI_ONE_FIFO(x) (HW_APBH_DEBUG(x).B.GPMI_ONE_FIFO)

/*! @brief Format value for bitfield APBH_DEBUG_GPMI_ONE_FIFO. */
#define BF_APBH_DEBUG_GPMI_ONE_FIFO(v) ((uint32_t)((uint32_t)(v) << BP_APBH_DEBUG_GPMI_ONE_FIFO) & BM_APBH_DEBUG_GPMI_ONE_FIFO)

/*! @brief Set the GPMI_ONE_FIFO field to a new value. */
#define BW_APBH_DEBUG_GPMI_ONE_FIFO(x, v) (HW_APBH_DEBUG_WR(x, (HW_APBH_DEBUG_RD(x) & ~BM_APBH_DEBUG_GPMI_ONE_FIFO) | BF_APBH_DEBUG_GPMI_ONE_FIFO(v)))
/*@}*/

/*******************************************************************************
 * HW_APBH_CHn_CURCMDAR - APBH DMA Channel n Current Command Address Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_CURCMDAR - APBH DMA Channel n Current Command Address Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The APBH DMA channel n current command address register points to the
 * multiword command that is currently being executed. Commands are threaded on the
 * command address. APBH DMA Channel n is controlled by a variable sized command
 * structure. This register points to the command structure currently being executed.
 * EXAMPLE pCurCmd = (apbh_chn_cmd_t *) APBH_CHn_CURCMDAR_RD(0); // read the
 * whole register, since there is only one field pCurCmd = (apbh_chn_cmd_t *)
 * BF_RDn(APBH_CHn_CURCMDAR, 0, CMD_ADDR); // or, use multi-register bitfield read
 * macro pCurCmd = (apbh_chn_cmd_t *) APBH_CHn_CURCMDAR(0).CMD_ADDR; // or, assign
 * from bitfield of indexed register's struct
 */
typedef union _hw_apbh_chn_curcmdar
{
    uint32_t U;
    struct _hw_apbh_chn_curcmdar_bitfields
    {
        uint32_t CMD_ADDR : 32;        /*!< [31:0]  */
    } B;
} hw_apbh_chn_curcmdar_t;

/*!
 * @name Constants and macros for entire APBH_CHn_CURCMDAR register
 */
/*@{*/
#define HW_APBH_CHn_CURCMDAR_COUNT (16U)

#define HW_APBH_CHn_CURCMDAR_ADDR(x, n) ((uintptr_t)(x) + 0x100U + (0x70U * (n)))

#define HW_APBH_CHn_CURCMDAR(x, n) (*(__I hw_apbh_chn_curcmdar_t *) HW_APBH_CHn_CURCMDAR_ADDR(x, n))
#define HW_APBH_CHn_CURCMDAR_RD(x, n) (HW_APBH_CHn_CURCMDAR(x, n).U)
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_CURCMDAR bitfields
 */

/*!
 * @name Register APBH_CHn_CURCMDAR, field CMD_ADDR[31:0] (RO)
 *
 * Pointer to command structure currently being processed for channel n.
 */
/*@{*/
#define BP_APBH_CHn_CURCMDAR_CMD_ADDR (0U) /*!< Bit position for APBH_CHn_CURCMDAR_CMD_ADDR. */
#define BM_APBH_CHn_CURCMDAR_CMD_ADDR (0xFFFFFFFFU) /*!< Bit mask for APBH_CHn_CURCMDAR_CMD_ADDR. */
#define BS_APBH_CHn_CURCMDAR_CMD_ADDR (32U) /*!< Bit field size in bits for APBH_CHn_CURCMDAR_CMD_ADDR. */

/*! @brief Read current value of the APBH_CHn_CURCMDAR_CMD_ADDR field. */
#define BR_APBH_CHn_CURCMDAR_CMD_ADDR(x, n) (HW_APBH_CHn_CURCMDAR(x, n).U)
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_NXTCMDAR - APBH DMA Channel n Next Command Address Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_NXTCMDAR - APBH DMA Channel n Next Command Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The APBH DMA Channel n Next Command Address register contains the address of
 * the next multiword command to be executed. Commands are threaded on the
 * command address. Set CHAIN to 1 in the DMA command word to process command lists.
 * APBH DMA Channel n is controlled by a variable sized command structure. Software
 * loads this register with the address of the first command structure to
 * process and increments the Channel n semaphore to start processing. This register
 * points to the next command structure to be executed when the current command is
 * completed. EXAMPLE APBH_CHn_NXTCMDAR_WR(0, (reg32_t) pCommandTwoStructure); //
 * write the entire register, since there is only one field
 * BF_WRn(APBH_CHn_NXTCMDAR, 0, (reg32_t) pCommandTwoStructure); // or, use multi-register bitfield
 * write macro APBH_CHn_NXTCMDAR(0).CMD_ADDR = (reg32_t) pCommandTwoStructure; //
 * or, assign to bitfield of indexed register's struct
 */
typedef union _hw_apbh_chn_nxtcmdar
{
    uint32_t U;
    struct _hw_apbh_chn_nxtcmdar_bitfields
    {
        uint32_t CMD_ADDR : 32;        /*!< [31:0]  */
    } B;
} hw_apbh_chn_nxtcmdar_t;

/*!
 * @name Constants and macros for entire APBH_CHn_NXTCMDAR register
 */
/*@{*/
#define HW_APBH_CHn_NXTCMDAR_COUNT (16U)

#define HW_APBH_CHn_NXTCMDAR_ADDR(x, n) ((uintptr_t)(x) + 0x110U + (0x70U * (n)))

#define HW_APBH_CHn_NXTCMDAR(x, n) (*(__IO hw_apbh_chn_nxtcmdar_t *) HW_APBH_CHn_NXTCMDAR_ADDR(x, n))
#define HW_APBH_CHn_NXTCMDAR_RD(x, n) (HW_APBH_CHn_NXTCMDAR(x, n).U)
#define HW_APBH_CHn_NXTCMDAR_WR(x, n, v) (HW_APBH_CHn_NXTCMDAR(x, n).U = (v))
#define HW_APBH_CHn_NXTCMDAR_SET(x, n, v) (HW_APBH_CHn_NXTCMDAR_WR(x, n, HW_APBH_CHn_NXTCMDAR_RD(x, n) |  (v)))
#define HW_APBH_CHn_NXTCMDAR_CLR(x, n, v) (HW_APBH_CHn_NXTCMDAR_WR(x, n, HW_APBH_CHn_NXTCMDAR_RD(x, n) & ~(v)))
#define HW_APBH_CHn_NXTCMDAR_TOG(x, n, v) (HW_APBH_CHn_NXTCMDAR_WR(x, n, HW_APBH_CHn_NXTCMDAR_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_NXTCMDAR bitfields
 */

/*!
 * @name Register APBH_CHn_NXTCMDAR, field CMD_ADDR[31:0] (RW)
 *
 * Pointer to next command structure for channel n.
 */
/*@{*/
#define BP_APBH_CHn_NXTCMDAR_CMD_ADDR (0U) /*!< Bit position for APBH_CHn_NXTCMDAR_CMD_ADDR. */
#define BM_APBH_CHn_NXTCMDAR_CMD_ADDR (0xFFFFFFFFU) /*!< Bit mask for APBH_CHn_NXTCMDAR_CMD_ADDR. */
#define BS_APBH_CHn_NXTCMDAR_CMD_ADDR (32U) /*!< Bit field size in bits for APBH_CHn_NXTCMDAR_CMD_ADDR. */

/*! @brief Read current value of the APBH_CHn_NXTCMDAR_CMD_ADDR field. */
#define BR_APBH_CHn_NXTCMDAR_CMD_ADDR(x, n) (HW_APBH_CHn_NXTCMDAR(x, n).U)

/*! @brief Format value for bitfield APBH_CHn_NXTCMDAR_CMD_ADDR. */
#define BF_APBH_CHn_NXTCMDAR_CMD_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CHn_NXTCMDAR_CMD_ADDR) & BM_APBH_CHn_NXTCMDAR_CMD_ADDR)

/*! @brief Set the CMD_ADDR field to a new value. */
#define BW_APBH_CHn_NXTCMDAR_CMD_ADDR(x, n, v) (HW_APBH_CHn_NXTCMDAR_WR(x, n, v))
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_CMD - APBH DMA Channel n Command Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_CMD - APBH DMA Channel n Command Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The APBH DMA Channel n command register specifies the DMA transaction to
 * perform for the current command chain item. The command register controls the
 * overall operation of each DMA command for this channel. It includes the number of
 * bytes to transfer to or from the device, the number of APB PIO command words
 * included with this command structure, whether to interrupt at command
 * completion, whether to chain an additional command to the end of this one and whether
 * this transfer is a read or write DMA transfer. EXAMPLE apbh_chn_cmd_t dma_cmd;
 * dma_cmd.XFER_COUNT = 512; // transfer 512 bytes dma_cmd.COMMAND =
 * BV_APBH_CHn_CMD_COMMAND__DMA_WRITE; // transfer to system memory from peripheral device
 * dma_cmd.CHAIN = 1; // chain an additional command structure on to the list
 * dma_cmd.IRQONCMPLT = 1; // generate an interrupt on completion of this command
 * structure
 */
typedef union _hw_apbh_chn_cmd
{
    uint32_t U;
    struct _hw_apbh_chn_cmd_bitfields
    {
        uint32_t COMMAND : 2;          /*!< [1:0]  */
        uint32_t CHAIN : 1;            /*!< [2]  */
        uint32_t IRQONCMPLT : 1;       /*!< [3]  */
        uint32_t NANDLOCK : 1;         /*!< [4]  */
        uint32_t NANDWAIT4READY : 1;   /*!< [5]  */
        uint32_t SEMAPHORE : 1;        /*!< [6]  */
        uint32_t WAIT4ENDCMD : 1;      /*!< [7]  */
        uint32_t HALTONTERMINATE : 1;  /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t CMDWORDS : 4;         /*!< [15:12]  */
        uint32_t XFER_COUNT : 16;      /*!< [31:16]  */
    } B;
} hw_apbh_chn_cmd_t;

/*!
 * @name Constants and macros for entire APBH_CHn_CMD register
 */
/*@{*/
#define HW_APBH_CHn_CMD_COUNT (16U)

#define HW_APBH_CHn_CMD_ADDR(x, n) ((uintptr_t)(x) + 0x120U + (0x70U * (n)))

#define HW_APBH_CHn_CMD(x, n)    (*(__I hw_apbh_chn_cmd_t *) HW_APBH_CHn_CMD_ADDR(x, n))
#define HW_APBH_CHn_CMD_RD(x, n) (HW_APBH_CHn_CMD(x, n).U)
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_CMD bitfields
 */

/*!
 * @name Register APBH_CHn_CMD, field COMMAND[1:0] (RO)
 *
 * This bitfield indicates the type of current command:
 *
 * Values:
 * - 0 - Perform any requested PIO word transfers but terminate command before
 *     any DMA transfer.
 * - 1 - Perform any requested PIO word transfers and then perform a DMA
 *     transfer from the peripheral for the specified number of bytes.
 * - 10 - Perform any requested PIO word transfers and then perform a DMA
 *     transfer to the peripheral for the specified number of bytes.
 * - 11 - Perform any requested PIO word transfers and then perform a
 *     conditional branch to the next chained device. Follow the NEXCMD_ADDR pointer if the
 *     perpheral sense is true. Follow the BUFFER_ADDRESS as a chain pointer if
 *     the peripheral sense line is false.
 */
/*@{*/
#define BP_APBH_CHn_CMD_COMMAND (0U)       /*!< Bit position for APBH_CHn_CMD_COMMAND. */
#define BM_APBH_CHn_CMD_COMMAND (0x00000003U) /*!< Bit mask for APBH_CHn_CMD_COMMAND. */
#define BS_APBH_CHn_CMD_COMMAND (2U)       /*!< Bit field size in bits for APBH_CHn_CMD_COMMAND. */

#define BV_APBH_CHn_CMD_COMMAND_NO_DMA_XFER (0U)     /*!< Bit field value for APBH_CHn_CMD_COMMAND: Perform any requested PIO word transfers but terminate command before any DMA transfer. */
#define BV_APBH_CHn_CMD_COMMAND_DMA_WRITE (0x1U)     /*!< Bit field value for APBH_CHn_CMD_COMMAND: Perform any requested PIO word transfers and then perform a DMA transfer from the peripheral for the specified number of bytes. */
#define BV_APBH_CHn_CMD_COMMAND_DMA_READ (0x2U)      /*!< Bit field value for APBH_CHn_CMD_COMMAND: Perform any requested PIO word transfers and then perform a DMA transfer to the peripheral for the specified number of bytes. */
#define BV_APBH_CHn_CMD_COMMAND_DMA_SENSE (0x3U)     /*!< Bit field value for APBH_CHn_CMD_COMMAND: Perform any requested PIO word transfers and then perform a conditional branch to the next chained device. Follow the NEXCMD_ADDR pointer if the perpheral sense is true. Follow the BUFFER_ADDRESS as a chain pointer if the peripheral sense line is false. */

/*! @brief Read current value of the APBH_CHn_CMD_COMMAND field. */
#define BR_APBH_CHn_CMD_COMMAND(x, n) (HW_APBH_CHn_CMD(x, n).B.COMMAND)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field CHAIN[2] (RO)
 *
 * A value of one indicates that another command is chained onto the end of the
 * current command structure. At the completion of the current command, this
 * channel will follow the pointer in APBH_CHn_CMDAR to find the next command.
 */
/*@{*/
#define BP_APBH_CHn_CMD_CHAIN (2U)         /*!< Bit position for APBH_CHn_CMD_CHAIN. */
#define BM_APBH_CHn_CMD_CHAIN (0x00000004U) /*!< Bit mask for APBH_CHn_CMD_CHAIN. */
#define BS_APBH_CHn_CMD_CHAIN (1U)         /*!< Bit field size in bits for APBH_CHn_CMD_CHAIN. */

/*! @brief Read current value of the APBH_CHn_CMD_CHAIN field. */
#define BR_APBH_CHn_CMD_CHAIN(x, n) (HW_APBH_CHn_CMD(x, n).B.CHAIN)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field IRQONCMPLT[3] (RO)
 *
 * A value of one indicates that the channel will cause the interrupt status bit
 * to be set upon completion of the current command, i.e. after the DMA transfer
 * is complete.
 */
/*@{*/
#define BP_APBH_CHn_CMD_IRQONCMPLT (3U)    /*!< Bit position for APBH_CHn_CMD_IRQONCMPLT. */
#define BM_APBH_CHn_CMD_IRQONCMPLT (0x00000008U) /*!< Bit mask for APBH_CHn_CMD_IRQONCMPLT. */
#define BS_APBH_CHn_CMD_IRQONCMPLT (1U)    /*!< Bit field size in bits for APBH_CHn_CMD_IRQONCMPLT. */

/*! @brief Read current value of the APBH_CHn_CMD_IRQONCMPLT field. */
#define BR_APBH_CHn_CMD_IRQONCMPLT(x, n) (HW_APBH_CHn_CMD(x, n).B.IRQONCMPLT)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field NANDLOCK[4] (RO)
 *
 * A value of one indicates that the NAND DMA channel will remain "locked" in
 * the arbiter at the expense of other NAND DMA channels. It is ignored for
 * non-NAND DMA channels.
 */
/*@{*/
#define BP_APBH_CHn_CMD_NANDLOCK (4U)      /*!< Bit position for APBH_CHn_CMD_NANDLOCK. */
#define BM_APBH_CHn_CMD_NANDLOCK (0x00000010U) /*!< Bit mask for APBH_CHn_CMD_NANDLOCK. */
#define BS_APBH_CHn_CMD_NANDLOCK (1U)      /*!< Bit field size in bits for APBH_CHn_CMD_NANDLOCK. */

/*! @brief Read current value of the APBH_CHn_CMD_NANDLOCK field. */
#define BR_APBH_CHn_CMD_NANDLOCK(x, n) (HW_APBH_CHn_CMD(x, n).B.NANDLOCK)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field NANDWAIT4READY[5] (RO)
 *
 * A value of one indicates that the NAND DMA channel will will wait until the
 * NAND device reports "ready" before executing the command. It is ignored for
 * non-NAND DMA channels.
 */
/*@{*/
#define BP_APBH_CHn_CMD_NANDWAIT4READY (5U) /*!< Bit position for APBH_CHn_CMD_NANDWAIT4READY. */
#define BM_APBH_CHn_CMD_NANDWAIT4READY (0x00000020U) /*!< Bit mask for APBH_CHn_CMD_NANDWAIT4READY. */
#define BS_APBH_CHn_CMD_NANDWAIT4READY (1U) /*!< Bit field size in bits for APBH_CHn_CMD_NANDWAIT4READY. */

/*! @brief Read current value of the APBH_CHn_CMD_NANDWAIT4READY field. */
#define BR_APBH_CHn_CMD_NANDWAIT4READY(x, n) (HW_APBH_CHn_CMD(x, n).B.NANDWAIT4READY)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field SEMAPHORE[6] (RO)
 *
 * A value of one indicates that the channel will decrement its semaphore at the
 * completion of the current command structure. If the semaphore decrements to
 * zero, then this channel stalls until software increments it again.
 */
/*@{*/
#define BP_APBH_CHn_CMD_SEMAPHORE (6U)     /*!< Bit position for APBH_CHn_CMD_SEMAPHORE. */
#define BM_APBH_CHn_CMD_SEMAPHORE (0x00000040U) /*!< Bit mask for APBH_CHn_CMD_SEMAPHORE. */
#define BS_APBH_CHn_CMD_SEMAPHORE (1U)     /*!< Bit field size in bits for APBH_CHn_CMD_SEMAPHORE. */

/*! @brief Read current value of the APBH_CHn_CMD_SEMAPHORE field. */
#define BR_APBH_CHn_CMD_SEMAPHORE(x, n) (HW_APBH_CHn_CMD(x, n).B.SEMAPHORE)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field WAIT4ENDCMD[7] (RO)
 *
 * A value of one indicates that the channel will wait for the end of command
 * signal to be sent from the APBH device to the DMA before starting the next DMA
 * command.
 */
/*@{*/
#define BP_APBH_CHn_CMD_WAIT4ENDCMD (7U)   /*!< Bit position for APBH_CHn_CMD_WAIT4ENDCMD. */
#define BM_APBH_CHn_CMD_WAIT4ENDCMD (0x00000080U) /*!< Bit mask for APBH_CHn_CMD_WAIT4ENDCMD. */
#define BS_APBH_CHn_CMD_WAIT4ENDCMD (1U)   /*!< Bit field size in bits for APBH_CHn_CMD_WAIT4ENDCMD. */

/*! @brief Read current value of the APBH_CHn_CMD_WAIT4ENDCMD field. */
#define BR_APBH_CHn_CMD_WAIT4ENDCMD(x, n) (HW_APBH_CHn_CMD(x, n).B.WAIT4ENDCMD)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field HALTONTERMINATE[8] (RO)
 *
 * A value of one indicates that the channel will immeditately terminate the
 * current descriptor and halt the DMA channel if a terminate signal is set. A value
 * of 0 will still cause an immediate terminate of the channel if the terminate
 * signal is set, but the channel will continue as if the count had been
 * exhausted, meaning it will honor IRQONCMPLT, CHAIN, SEMAPHORE, and WAIT4ENDCMD.
 */
/*@{*/
#define BP_APBH_CHn_CMD_HALTONTERMINATE (8U) /*!< Bit position for APBH_CHn_CMD_HALTONTERMINATE. */
#define BM_APBH_CHn_CMD_HALTONTERMINATE (0x00000100U) /*!< Bit mask for APBH_CHn_CMD_HALTONTERMINATE. */
#define BS_APBH_CHn_CMD_HALTONTERMINATE (1U) /*!< Bit field size in bits for APBH_CHn_CMD_HALTONTERMINATE. */

/*! @brief Read current value of the APBH_CHn_CMD_HALTONTERMINATE field. */
#define BR_APBH_CHn_CMD_HALTONTERMINATE(x, n) (HW_APBH_CHn_CMD(x, n).B.HALTONTERMINATE)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field CMDWORDS[15:12] (RO)
 *
 * This field indicates the number of command words to send to the GPMI0,
 * starting with the base PIO address of the GPMI0 control register and incrementing
 * from there. Zero means transfer NO command words
 */
/*@{*/
#define BP_APBH_CHn_CMD_CMDWORDS (12U)     /*!< Bit position for APBH_CHn_CMD_CMDWORDS. */
#define BM_APBH_CHn_CMD_CMDWORDS (0x0000F000U) /*!< Bit mask for APBH_CHn_CMD_CMDWORDS. */
#define BS_APBH_CHn_CMD_CMDWORDS (4U)      /*!< Bit field size in bits for APBH_CHn_CMD_CMDWORDS. */

/*! @brief Read current value of the APBH_CHn_CMD_CMDWORDS field. */
#define BR_APBH_CHn_CMD_CMDWORDS(x, n) (HW_APBH_CHn_CMD(x, n).B.CMDWORDS)
/*@}*/

/*!
 * @name Register APBH_CHn_CMD, field XFER_COUNT[31:16] (RO)
 *
 * This field indicates the number of bytes to transfer to or from the
 * appropriate PIO register in the GPMI0 device. A value of 0 indicates a 64 KBytes
 * transfer.
 */
/*@{*/
#define BP_APBH_CHn_CMD_XFER_COUNT (16U)   /*!< Bit position for APBH_CHn_CMD_XFER_COUNT. */
#define BM_APBH_CHn_CMD_XFER_COUNT (0xFFFF0000U) /*!< Bit mask for APBH_CHn_CMD_XFER_COUNT. */
#define BS_APBH_CHn_CMD_XFER_COUNT (16U)   /*!< Bit field size in bits for APBH_CHn_CMD_XFER_COUNT. */

/*! @brief Read current value of the APBH_CHn_CMD_XFER_COUNT field. */
#define BR_APBH_CHn_CMD_XFER_COUNT(x, n) (HW_APBH_CHn_CMD(x, n).B.XFER_COUNT)
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_BAR - APBH DMA Channel n Buffer Address Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_BAR - APBH DMA Channel n Buffer Address Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The APBH DMA Channel n buffer address register contains a pointer to the data
 * buffer for the transfer. For immediate forms, the data is taken from this
 * register. This is a byte address which means transfers can start on any byte
 * boundary. This register holds a pointer to the data buffer in system memory. After
 * the command values have been read into the DMA controller and the device
 * controlled by this channel, then the DMA transfer will begin, to or from the
 * buffer pointed to by this register. EXAMPLE apbh_chn_bar_t dma_data;
 * dma_data.ADDRESS = (reg32_t) pDataBuffer;
 */
typedef union _hw_apbh_chn_bar
{
    uint32_t U;
    struct _hw_apbh_chn_bar_bitfields
    {
        uint32_t ADDRESS : 32;         /*!< [31:0]  */
    } B;
} hw_apbh_chn_bar_t;

/*!
 * @name Constants and macros for entire APBH_CHn_BAR register
 */
/*@{*/
#define HW_APBH_CHn_BAR_COUNT (16U)

#define HW_APBH_CHn_BAR_ADDR(x, n) ((uintptr_t)(x) + 0x130U + (0x70U * (n)))

#define HW_APBH_CHn_BAR(x, n)    (*(__I hw_apbh_chn_bar_t *) HW_APBH_CHn_BAR_ADDR(x, n))
#define HW_APBH_CHn_BAR_RD(x, n) (HW_APBH_CHn_BAR(x, n).U)
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_BAR bitfields
 */

/*!
 * @name Register APBH_CHn_BAR, field ADDRESS[31:0] (RO)
 *
 * Address of system memory buffer to be read or written over the AHB bus.
 */
/*@{*/
#define BP_APBH_CHn_BAR_ADDRESS (0U)       /*!< Bit position for APBH_CHn_BAR_ADDRESS. */
#define BM_APBH_CHn_BAR_ADDRESS (0xFFFFFFFFU) /*!< Bit mask for APBH_CHn_BAR_ADDRESS. */
#define BS_APBH_CHn_BAR_ADDRESS (32U)      /*!< Bit field size in bits for APBH_CHn_BAR_ADDRESS. */

/*! @brief Read current value of the APBH_CHn_BAR_ADDRESS field. */
#define BR_APBH_CHn_BAR_ADDRESS(x, n) (HW_APBH_CHn_BAR(x, n).U)
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_SEMA - APBH DMA Channel n Semaphore Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_SEMA - APBH DMA Channel n Semaphore Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The APBH DMA Channel n semaphore register is used to synchronize the ARM
 * platform instruction stream and the DMA chain processing state. Each DMA channel
 * has an 8 bit counting semaphore that is used to synchronize between the program
 * stream and and the DMA chain processing. DMA processing continues until the
 * DMA attempts to decrement a semaphore that has already reached a value of zero.
 * When the attempt is made, the DMA channel is stalled until software
 * increments the semaphore count. EXAMPLE BF_WR(APBH_CHn_SEMA, 0, INCREMENT_SEMA, 2); //
 * increment semaphore by two current_sema = BF_RD(APBH_CHn_SEMA, 0, PHORE); //
 * get instantaneous value
 */
typedef union _hw_apbh_chn_sema
{
    uint32_t U;
    struct _hw_apbh_chn_sema_bitfields
    {
        uint32_t INCREMENT_SEMA : 8;   /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t PHORE : 8;            /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_apbh_chn_sema_t;

/*!
 * @name Constants and macros for entire APBH_CHn_SEMA register
 */
/*@{*/
#define HW_APBH_CHn_SEMA_COUNT (16U)

#define HW_APBH_CHn_SEMA_ADDR(x, n) ((uintptr_t)(x) + 0x140U + (0x70U * (n)))

#define HW_APBH_CHn_SEMA(x, n)   (*(__IO hw_apbh_chn_sema_t *) HW_APBH_CHn_SEMA_ADDR(x, n))
#define HW_APBH_CHn_SEMA_RD(x, n) (HW_APBH_CHn_SEMA(x, n).U)
#define HW_APBH_CHn_SEMA_WR(x, n, v) (HW_APBH_CHn_SEMA(x, n).U = (v))
#define HW_APBH_CHn_SEMA_SET(x, n, v) (HW_APBH_CHn_SEMA_WR(x, n, HW_APBH_CHn_SEMA_RD(x, n) |  (v)))
#define HW_APBH_CHn_SEMA_CLR(x, n, v) (HW_APBH_CHn_SEMA_WR(x, n, HW_APBH_CHn_SEMA_RD(x, n) & ~(v)))
#define HW_APBH_CHn_SEMA_TOG(x, n, v) (HW_APBH_CHn_SEMA_WR(x, n, HW_APBH_CHn_SEMA_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_SEMA bitfields
 */

/*!
 * @name Register APBH_CHn_SEMA, field INCREMENT_SEMA[7:0] (RW)
 *
 * The value written to this field is added to the semaphore count in an atomic
 * way such that simultaneous software adds and DMA hardware substracts happening
 * on the same clock are protected. This bit field reads back a value of 0x00.
 * Writing a value of 0x02 increments the semaphore count by two, unless the DMA
 * channel decrements the count on the same clock, then the count is incremented
 * by a net one.
 */
/*@{*/
#define BP_APBH_CHn_SEMA_INCREMENT_SEMA (0U) /*!< Bit position for APBH_CHn_SEMA_INCREMENT_SEMA. */
#define BM_APBH_CHn_SEMA_INCREMENT_SEMA (0x000000FFU) /*!< Bit mask for APBH_CHn_SEMA_INCREMENT_SEMA. */
#define BS_APBH_CHn_SEMA_INCREMENT_SEMA (8U) /*!< Bit field size in bits for APBH_CHn_SEMA_INCREMENT_SEMA. */

/*! @brief Read current value of the APBH_CHn_SEMA_INCREMENT_SEMA field. */
#define BR_APBH_CHn_SEMA_INCREMENT_SEMA(x, n) (HW_APBH_CHn_SEMA(x, n).B.INCREMENT_SEMA)

/*! @brief Format value for bitfield APBH_CHn_SEMA_INCREMENT_SEMA. */
#define BF_APBH_CHn_SEMA_INCREMENT_SEMA(v) ((uint32_t)((uint32_t)(v) << BP_APBH_CHn_SEMA_INCREMENT_SEMA) & BM_APBH_CHn_SEMA_INCREMENT_SEMA)

/*! @brief Set the INCREMENT_SEMA field to a new value. */
#define BW_APBH_CHn_SEMA_INCREMENT_SEMA(x, n, v) (HW_APBH_CHn_SEMA_WR(x, n, (HW_APBH_CHn_SEMA_RD(x, n) & ~BM_APBH_CHn_SEMA_INCREMENT_SEMA) | BF_APBH_CHn_SEMA_INCREMENT_SEMA(v)))
/*@}*/

/*!
 * @name Register APBH_CHn_SEMA, field PHORE[23:16] (RO)
 *
 * This read-only field shows the current (instantaneous) value of the semaphore
 * counter.
 */
/*@{*/
#define BP_APBH_CHn_SEMA_PHORE (16U)       /*!< Bit position for APBH_CHn_SEMA_PHORE. */
#define BM_APBH_CHn_SEMA_PHORE (0x00FF0000U) /*!< Bit mask for APBH_CHn_SEMA_PHORE. */
#define BS_APBH_CHn_SEMA_PHORE (8U)        /*!< Bit field size in bits for APBH_CHn_SEMA_PHORE. */

/*! @brief Read current value of the APBH_CHn_SEMA_PHORE field. */
#define BR_APBH_CHn_SEMA_PHORE(x, n) (HW_APBH_CHn_SEMA(x, n).B.PHORE)
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_DEBUG1 - AHB to APBH DMA Channel n Debug Information
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_DEBUG1 - AHB to APBH DMA Channel n Debug Information (RO)
 *
 * Reset value: 0x00A00000U
 *
 * This register gives debug visibility into the APBH DMA Channel n state
 * machine and controls. This register allows debug visibility of the APBH DMA Channel
 * n.
 */
typedef union _hw_apbh_chn_debug1
{
    uint32_t U;
    struct _hw_apbh_chn_debug1_bitfields
    {
        uint32_t STATEMACHINE : 5;     /*!< [4:0]  */
        uint32_t RSVD1 : 15;           /*!< [19:5]  */
        uint32_t WR_FIFO_FULL : 1;     /*!< [20]  */
        uint32_t WR_FIFO_EMPTY : 1;    /*!< [21]  */
        uint32_t RD_FIFO_FULL : 1;     /*!< [22]  */
        uint32_t RD_FIFO_EMPTY : 1;    /*!< [23]  */
        uint32_t NEXTCMDADDRVALID : 1; /*!< [24]  */
        uint32_t LOCK : 1;             /*!< [25]  */
        uint32_t READY : 1;            /*!< [26]  */
        uint32_t SENSE : 1;            /*!< [27]  */
        uint32_t END : 1;              /*!< [28]  */
        uint32_t KICK : 1;             /*!< [29]  */
        uint32_t BURST : 1;            /*!< [30]  */
        uint32_t REQ : 1;              /*!< [31]  */
    } B;
} hw_apbh_chn_debug1_t;

/*!
 * @name Constants and macros for entire APBH_CHn_DEBUG1 register
 */
/*@{*/
#define HW_APBH_CHn_DEBUG1_COUNT (16U)

#define HW_APBH_CHn_DEBUG1_ADDR(x, n) ((uintptr_t)(x) + 0x150U + (0x70U * (n)))

#define HW_APBH_CHn_DEBUG1(x, n) (*(__I hw_apbh_chn_debug1_t *) HW_APBH_CHn_DEBUG1_ADDR(x, n))
#define HW_APBH_CHn_DEBUG1_RD(x, n) (HW_APBH_CHn_DEBUG1(x, n).U)
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_DEBUG1 bitfields
 */

/*!
 * @name Register APBH_CHn_DEBUG1, field STATEMACHINE[4:0] (RO)
 *
 * PIO Display of the DMA Channel n state machine state.
 *
 * Values:
 * - 0 - This is the idle state of the DMA state machine.
 * - 1 - State in which the DMA is waiting to receive the first word of a
 *     command.
 * - 10 - State in which the DMA is waiting to receive the third word of a
 *     command.
 * - 11 - State in which the DMA is waiting to receive the second word of a
 *     command.
 * - 100 - The state machine processes the descriptor command field in this
 *     state and branches accordingly.
 * - 101 - The state machine waits in this state for the PIO APB cycles to
 *     complete.
 * - 110 - State in which the DMA is waiting to receive the fourth word of a
 *     command, or waiting to receive the PIO words when PIO count is greater than 1.
 * - 111 - This state determines whether another PIO cycle needs to occur before
 *     starting DMA transfers.
 * - 1000 - During a read transfers, the state machine enters this state waiting
 *     for the last bytes to be pushed out on the APB.
 * - 1001 - When an AHB read request occurs, the state machine waits in this
 *     state for the AHB transfer to complete.
 * - 1100 - During DMA Write transfers, the state machine waits in this state
 *     until the AHB master arbiter accepts the request from this channel.
 * - 1101 - During DMA Read transfers, the state machine waits in this state
 *     until the AHB master arbiter accepts the request from this channel.
 * - 1110 - Upon completion of the DMA transfers, this state checks the value of
 *     the Chain bit and branches accordingly.
 * - 1111 - The state machine goes to this state after the DMA transfers are
 *     complete, and determines what step to take next.
 * - 10100 - When a terminate signal is set, the state machine enters this state
 *     until the current AHB transfer is completed.
 * - 10101 - When the Wait for Command End bit is set, the state machine enters
 *     this state until the DMA device indicates that the command is complete.
 * - 11100 - During DMA Write transfers, the state machine waits in this state
 *     until the AHB master completes the write to the AHB memory space.
 * - 11101 - If HALTONTERMINATE is set and a terminate signal is set, the state
 *     machine enters this state and effectively halts. A channel reset is
 *     required to exit this state
 * - 11110 - If the Chain bit is a 0, the state machine enters this state and
 *     effectively halts.
 * - 11111 - When the NAND Wait for Ready bit is set, the state machine enters
 *     this state until the GPMI device indicates that the external device is
 *     ready.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_STATEMACHINE (0U) /*!< Bit position for APBH_CHn_DEBUG1_STATEMACHINE. */
#define BM_APBH_CHn_DEBUG1_STATEMACHINE (0x0000001FU) /*!< Bit mask for APBH_CHn_DEBUG1_STATEMACHINE. */
#define BS_APBH_CHn_DEBUG1_STATEMACHINE (5U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_STATEMACHINE. */

#define BV_APBH_CHn_DEBUG1_STATEMACHINE_IDLE (0U)    /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: This is the idle state of the DMA state machine. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_REQ_CMD1 (0x1U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: State in which the DMA is waiting to receive the first word of a command. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_REQ_CMD3 (0x2U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: State in which the DMA is waiting to receive the third word of a command. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_REQ_CMD2 (0x3U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: State in which the DMA is waiting to receive the second word of a command. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_XFER_DECODE (0x4U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: The state machine processes the descriptor command field in this state and branches accordingly. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_REQ_WAIT (0x5U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: The state machine waits in this state for the PIO APB cycles to complete. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_REQ_CMD4 (0x6U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: State in which the DMA is waiting to receive the fourth word of a command, or waiting to receive the PIO words when PIO count is greater than 1. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_PIO_REQ (0x7U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: This state determines whether another PIO cycle needs to occur before starting DMA transfers. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_READ_FLUSH (0x8U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: During a read transfers, the state machine enters this state waiting for the last bytes to be pushed out on the APB. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_READ_WAIT (0x9U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: When an AHB read request occurs, the state machine waits in this state for the AHB transfer to complete. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_WRITE (0xCU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: During DMA Write transfers, the state machine waits in this state until the AHB master arbiter accepts the request from this channel. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_READ_REQ (0xDU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: During DMA Read transfers, the state machine waits in this state until the AHB master arbiter accepts the request from this channel. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_CHECK_CHAIN (0xEU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: Upon completion of the DMA transfers, this state checks the value of the Chain bit and branches accordingly. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_XFER_COMPLETE (0xFU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: The state machine goes to this state after the DMA transfers are complete, and determines what step to take next. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_TERMINATE (0x14U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: When a terminate signal is set, the state machine enters this state until the current AHB transfer is completed. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_WAIT_END (0x15U) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: When the Wait for Command End bit is set, the state machine enters this state until the DMA device indicates that the command is complete. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_WRITE_WAIT (0x1CU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: During DMA Write transfers, the state machine waits in this state until the AHB master completes the write to the AHB memory space. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_HALT_AFTER_TERM (0x1DU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: If HALTONTERMINATE is set and a terminate signal is set, the state machine enters this state and effectively halts. A channel reset is required to exit this state */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_CHECK_WAIT (0x1EU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: If the Chain bit is a 0, the state machine enters this state and effectively halts. */
#define BV_APBH_CHn_DEBUG1_STATEMACHINE_WAIT_READY (0x1FU) /*!< Bit field value for APBH_CHn_DEBUG1_STATEMACHINE: When the NAND Wait for Ready bit is set, the state machine enters this state until the GPMI device indicates that the external device is ready. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_STATEMACHINE field. */
#define BR_APBH_CHn_DEBUG1_STATEMACHINE(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.STATEMACHINE)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field RSVD1[19:5] (RU)
 *
 * Reserved
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_RSVD1 (5U)      /*!< Bit position for APBH_CHn_DEBUG1_RSVD1. */
#define BM_APBH_CHn_DEBUG1_RSVD1 (0x000FFFE0U) /*!< Bit mask for APBH_CHn_DEBUG1_RSVD1. */
#define BS_APBH_CHn_DEBUG1_RSVD1 (15U)     /*!< Bit field size in bits for APBH_CHn_DEBUG1_RSVD1. */
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field WR_FIFO_FULL[20] (RO)
 *
 * This bit reflects the current state of the DMA Channel's Write FIFO Full
 * signal.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_WR_FIFO_FULL (20U) /*!< Bit position for APBH_CHn_DEBUG1_WR_FIFO_FULL. */
#define BM_APBH_CHn_DEBUG1_WR_FIFO_FULL (0x00100000U) /*!< Bit mask for APBH_CHn_DEBUG1_WR_FIFO_FULL. */
#define BS_APBH_CHn_DEBUG1_WR_FIFO_FULL (1U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_WR_FIFO_FULL. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_WR_FIFO_FULL field. */
#define BR_APBH_CHn_DEBUG1_WR_FIFO_FULL(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.WR_FIFO_FULL)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field WR_FIFO_EMPTY[21] (RO)
 *
 * This bit reflects the current state of the DMA Channel's Write FIFO Empty
 * signal.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_WR_FIFO_EMPTY (21U) /*!< Bit position for APBH_CHn_DEBUG1_WR_FIFO_EMPTY. */
#define BM_APBH_CHn_DEBUG1_WR_FIFO_EMPTY (0x00200000U) /*!< Bit mask for APBH_CHn_DEBUG1_WR_FIFO_EMPTY. */
#define BS_APBH_CHn_DEBUG1_WR_FIFO_EMPTY (1U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_WR_FIFO_EMPTY. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_WR_FIFO_EMPTY field. */
#define BR_APBH_CHn_DEBUG1_WR_FIFO_EMPTY(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.WR_FIFO_EMPTY)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field RD_FIFO_FULL[22] (RO)
 *
 * This bit reflects the current state of the DMA Channel's Read FIFO Full
 * signal.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_RD_FIFO_FULL (22U) /*!< Bit position for APBH_CHn_DEBUG1_RD_FIFO_FULL. */
#define BM_APBH_CHn_DEBUG1_RD_FIFO_FULL (0x00400000U) /*!< Bit mask for APBH_CHn_DEBUG1_RD_FIFO_FULL. */
#define BS_APBH_CHn_DEBUG1_RD_FIFO_FULL (1U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_RD_FIFO_FULL. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_RD_FIFO_FULL field. */
#define BR_APBH_CHn_DEBUG1_RD_FIFO_FULL(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.RD_FIFO_FULL)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field RD_FIFO_EMPTY[23] (RO)
 *
 * This bit reflects the current state of the DMA Channel's Read FIFO Empty
 * signal.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_RD_FIFO_EMPTY (23U) /*!< Bit position for APBH_CHn_DEBUG1_RD_FIFO_EMPTY. */
#define BM_APBH_CHn_DEBUG1_RD_FIFO_EMPTY (0x00800000U) /*!< Bit mask for APBH_CHn_DEBUG1_RD_FIFO_EMPTY. */
#define BS_APBH_CHn_DEBUG1_RD_FIFO_EMPTY (1U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_RD_FIFO_EMPTY. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_RD_FIFO_EMPTY field. */
#define BR_APBH_CHn_DEBUG1_RD_FIFO_EMPTY(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.RD_FIFO_EMPTY)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field NEXTCMDADDRVALID[24] (RO)
 *
 * This bit reflects the internal bit which indicates whether the channel's next
 * command address is valid.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_NEXTCMDADDRVALID (24U) /*!< Bit position for APBH_CHn_DEBUG1_NEXTCMDADDRVALID. */
#define BM_APBH_CHn_DEBUG1_NEXTCMDADDRVALID (0x01000000U) /*!< Bit mask for APBH_CHn_DEBUG1_NEXTCMDADDRVALID. */
#define BS_APBH_CHn_DEBUG1_NEXTCMDADDRVALID (1U) /*!< Bit field size in bits for APBH_CHn_DEBUG1_NEXTCMDADDRVALID. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_NEXTCMDADDRVALID field. */
#define BR_APBH_CHn_DEBUG1_NEXTCMDADDRVALID(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.NEXTCMDADDRVALID)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field LOCK[25] (RU)
 *
 * This bit is reserved for this Channel and always reads 0.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_LOCK (25U)      /*!< Bit position for APBH_CHn_DEBUG1_LOCK. */
#define BM_APBH_CHn_DEBUG1_LOCK (0x02000000U) /*!< Bit mask for APBH_CHn_DEBUG1_LOCK. */
#define BS_APBH_CHn_DEBUG1_LOCK (1U)       /*!< Bit field size in bits for APBH_CHn_DEBUG1_LOCK. */
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field READY[26] (RO)
 *
 * This bit is reserved for this DMA Channel and always reads 0.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_READY (26U)     /*!< Bit position for APBH_CHn_DEBUG1_READY. */
#define BM_APBH_CHn_DEBUG1_READY (0x04000000U) /*!< Bit mask for APBH_CHn_DEBUG1_READY. */
#define BS_APBH_CHn_DEBUG1_READY (1U)      /*!< Bit field size in bits for APBH_CHn_DEBUG1_READY. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_READY field. */
#define BR_APBH_CHn_DEBUG1_READY(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.READY)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field SENSE[27] (RU)
 *
 * This bit is reserved for this DMA Channel and always reads 0.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_SENSE (27U)     /*!< Bit position for APBH_CHn_DEBUG1_SENSE. */
#define BM_APBH_CHn_DEBUG1_SENSE (0x08000000U) /*!< Bit mask for APBH_CHn_DEBUG1_SENSE. */
#define BS_APBH_CHn_DEBUG1_SENSE (1U)      /*!< Bit field size in bits for APBH_CHn_DEBUG1_SENSE. */
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field END[28] (RO)
 *
 * This bit reflects the current state of the DMA End Command Signal sent from
 * the APB Device
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_END (28U)       /*!< Bit position for APBH_CHn_DEBUG1_END. */
#define BM_APBH_CHn_DEBUG1_END (0x10000000U) /*!< Bit mask for APBH_CHn_DEBUG1_END. */
#define BS_APBH_CHn_DEBUG1_END (1U)        /*!< Bit field size in bits for APBH_CHn_DEBUG1_END. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_END field. */
#define BR_APBH_CHn_DEBUG1_END(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.END)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field KICK[29] (RO)
 *
 * This bit reflects the current state of the DMA Kick Signal sent to the APB
 * Device
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_KICK (29U)      /*!< Bit position for APBH_CHn_DEBUG1_KICK. */
#define BM_APBH_CHn_DEBUG1_KICK (0x20000000U) /*!< Bit mask for APBH_CHn_DEBUG1_KICK. */
#define BS_APBH_CHn_DEBUG1_KICK (1U)       /*!< Bit field size in bits for APBH_CHn_DEBUG1_KICK. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_KICK field. */
#define BR_APBH_CHn_DEBUG1_KICK(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.KICK)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field BURST[30] (RO)
 *
 * This bit reflects the current state of the DMA Burst Signal from the APB
 * device
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_BURST (30U)     /*!< Bit position for APBH_CHn_DEBUG1_BURST. */
#define BM_APBH_CHn_DEBUG1_BURST (0x40000000U) /*!< Bit mask for APBH_CHn_DEBUG1_BURST. */
#define BS_APBH_CHn_DEBUG1_BURST (1U)      /*!< Bit field size in bits for APBH_CHn_DEBUG1_BURST. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_BURST field. */
#define BR_APBH_CHn_DEBUG1_BURST(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.BURST)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG1, field REQ[31] (RO)
 *
 * This bit reflects the current state of the DMA Request Signal from the APB
 * device
 */
/*@{*/
#define BP_APBH_CHn_DEBUG1_REQ (31U)       /*!< Bit position for APBH_CHn_DEBUG1_REQ. */
#define BM_APBH_CHn_DEBUG1_REQ (0x80000000U) /*!< Bit mask for APBH_CHn_DEBUG1_REQ. */
#define BS_APBH_CHn_DEBUG1_REQ (1U)        /*!< Bit field size in bits for APBH_CHn_DEBUG1_REQ. */

/*! @brief Read current value of the APBH_CHn_DEBUG1_REQ field. */
#define BR_APBH_CHn_DEBUG1_REQ(x, n) (HW_APBH_CHn_DEBUG1(x, n).B.REQ)
/*@}*/
/*******************************************************************************
 * HW_APBH_CHn_DEBUG2 - AHB to APBH DMA Channel n Debug Information
 ******************************************************************************/

/*!
 * @brief HW_APBH_CHn_DEBUG2 - AHB to APBH DMA Channel n Debug Information (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register gives debug visibility for the APB and AHB byte counts for DMA
 * Channel n. This register allows debug visibility of the APBH DMA Channel n.
 */
typedef union _hw_apbh_chn_debug2
{
    uint32_t U;
    struct _hw_apbh_chn_debug2_bitfields
    {
        uint32_t AHB_BYTES : 16;       /*!< [15:0]  */
        uint32_t APB_BYTES : 16;       /*!< [31:16]  */
    } B;
} hw_apbh_chn_debug2_t;

/*!
 * @name Constants and macros for entire APBH_CHn_DEBUG2 register
 */
/*@{*/
#define HW_APBH_CHn_DEBUG2_COUNT (16U)

#define HW_APBH_CHn_DEBUG2_ADDR(x, n) ((uintptr_t)(x) + 0x160U + (0x70U * (n)))

#define HW_APBH_CHn_DEBUG2(x, n) (*(__I hw_apbh_chn_debug2_t *) HW_APBH_CHn_DEBUG2_ADDR(x, n))
#define HW_APBH_CHn_DEBUG2_RD(x, n) (HW_APBH_CHn_DEBUG2(x, n).U)
/*@}*/

/*
 * Constants & macros for individual APBH_CHn_DEBUG2 bitfields
 */

/*!
 * @name Register APBH_CHn_DEBUG2, field AHB_BYTES[15:0] (RO)
 *
 * This value reflects the current number of AHB bytes remaining to be
 * transfered in the current transfer.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG2_AHB_BYTES (0U)  /*!< Bit position for APBH_CHn_DEBUG2_AHB_BYTES. */
#define BM_APBH_CHn_DEBUG2_AHB_BYTES (0x0000FFFFU) /*!< Bit mask for APBH_CHn_DEBUG2_AHB_BYTES. */
#define BS_APBH_CHn_DEBUG2_AHB_BYTES (16U) /*!< Bit field size in bits for APBH_CHn_DEBUG2_AHB_BYTES. */

/*! @brief Read current value of the APBH_CHn_DEBUG2_AHB_BYTES field. */
#define BR_APBH_CHn_DEBUG2_AHB_BYTES(x, n) (HW_APBH_CHn_DEBUG2(x, n).B.AHB_BYTES)
/*@}*/

/*!
 * @name Register APBH_CHn_DEBUG2, field APB_BYTES[31:16] (RO)
 *
 * This value reflects the current number of APB bytes remaining to be
 * transfered in the current transfer.
 */
/*@{*/
#define BP_APBH_CHn_DEBUG2_APB_BYTES (16U) /*!< Bit position for APBH_CHn_DEBUG2_APB_BYTES. */
#define BM_APBH_CHn_DEBUG2_APB_BYTES (0xFFFF0000U) /*!< Bit mask for APBH_CHn_DEBUG2_APB_BYTES. */
#define BS_APBH_CHn_DEBUG2_APB_BYTES (16U) /*!< Bit field size in bits for APBH_CHn_DEBUG2_APB_BYTES. */

/*! @brief Read current value of the APBH_CHn_DEBUG2_APB_BYTES field. */
#define BR_APBH_CHn_DEBUG2_APB_BYTES(x, n) (HW_APBH_CHn_DEBUG2(x, n).B.APB_BYTES)
/*@}*/

/*******************************************************************************
 * HW_APBH_VERSION - APBH Bridge Version Register
 ******************************************************************************/

/*!
 * @brief HW_APBH_VERSION - APBH Bridge Version Register (RO)
 *
 * Reset value: 0x03010000U
 *
 * This register always returns a known read value for debug purposes it
 * indicates the version of the block. This register indicates the RTL version in use.
 * EXAMPLE if (APBH_VERSION.B.MAJOR != 3) Error();
 */
typedef union _hw_apbh_version
{
    uint32_t U;
    struct _hw_apbh_version_bitfields
    {
        uint32_t STEP : 16;            /*!< [15:0]  */
        uint32_t MINOR : 8;            /*!< [23:16]  */
        uint32_t MAJOR : 8;            /*!< [31:24]  */
    } B;
} hw_apbh_version_t;

/*!
 * @name Constants and macros for entire APBH_VERSION register
 */
/*@{*/
#define HW_APBH_VERSION_ADDR(x)  ((uintptr_t)(x) + 0x800U)

#define HW_APBH_VERSION(x)       (*(__I hw_apbh_version_t *) HW_APBH_VERSION_ADDR(x))
#define HW_APBH_VERSION_RD(x)    (HW_APBH_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual APBH_VERSION bitfields
 */

/*!
 * @name Register APBH_VERSION, field STEP[15:0] (RO)
 *
 * Fixed read-only value reflecting the stepping of the RTL version.
 */
/*@{*/
#define BP_APBH_VERSION_STEP (0U)          /*!< Bit position for APBH_VERSION_STEP. */
#define BM_APBH_VERSION_STEP (0x0000FFFFU) /*!< Bit mask for APBH_VERSION_STEP. */
#define BS_APBH_VERSION_STEP (16U)         /*!< Bit field size in bits for APBH_VERSION_STEP. */

/*! @brief Read current value of the APBH_VERSION_STEP field. */
#define BR_APBH_VERSION_STEP(x) (HW_APBH_VERSION(x).B.STEP)
/*@}*/

/*!
 * @name Register APBH_VERSION, field MINOR[23:16] (RO)
 *
 * Fixed read-only value reflecting the MINOR field of the RTL version.
 */
/*@{*/
#define BP_APBH_VERSION_MINOR (16U)        /*!< Bit position for APBH_VERSION_MINOR. */
#define BM_APBH_VERSION_MINOR (0x00FF0000U) /*!< Bit mask for APBH_VERSION_MINOR. */
#define BS_APBH_VERSION_MINOR (8U)         /*!< Bit field size in bits for APBH_VERSION_MINOR. */

/*! @brief Read current value of the APBH_VERSION_MINOR field. */
#define BR_APBH_VERSION_MINOR(x) (HW_APBH_VERSION(x).B.MINOR)
/*@}*/

/*!
 * @name Register APBH_VERSION, field MAJOR[31:24] (RO)
 *
 * Fixed read-only value reflecting the MAJOR field of the RTL version.
 */
/*@{*/
#define BP_APBH_VERSION_MAJOR (24U)        /*!< Bit position for APBH_VERSION_MAJOR. */
#define BM_APBH_VERSION_MAJOR (0xFF000000U) /*!< Bit mask for APBH_VERSION_MAJOR. */
#define BS_APBH_VERSION_MAJOR (8U)         /*!< Bit field size in bits for APBH_VERSION_MAJOR. */

/*! @brief Read current value of the APBH_VERSION_MAJOR field. */
#define BR_APBH_VERSION_MAJOR(x) (HW_APBH_VERSION(x).B.MAJOR)
/*@}*/

/*******************************************************************************
 * hw_apbh_t - module struct
 ******************************************************************************/
/*!
 * @brief All APBH module registers.
 */
#pragma pack(1)
typedef struct _hw_apbh
{
    __IO hw_apbh_ctrl0_t CTRL0;            /*!< [0x0] AHB to APBH Bridge Control and Status Register 0 */
    uint8_t _reserved0[12];
    __IO hw_apbh_ctrl1_t CTRL1;            /*!< [0x10] AHB to APBH Bridge Control and Status Register 1 */
    uint8_t _reserved1[12];
    __IO hw_apbh_ctrl2_t CTRL2;            /*!< [0x20] AHB to APBH Bridge Control and Status Register 2 */
    uint8_t _reserved2[12];
    __IO hw_apbh_channel_ctrl_t CHANNEL_CTRL; /*!< [0x30] AHB to APBH Bridge Channel Register */
    uint8_t _reserved3[12];
    __I hw_apbh_devsel_t DEVSEL;           /*!< [0x40] AHB to APBH DMA Device Assignment Register */
    uint8_t _reserved4[12];
    __IO hw_apbh_dma_burst_size_t DMA_BURST_SIZE; /*!< [0x50] AHB to APBH DMA burst size */
    uint8_t _reserved5[12];
    __IO hw_apbh_debug_t DEBUGr;           /*!< [0x60] AHB to APBH DMA Debug Register */
    uint8_t _reserved6[156];
    struct {
        __I hw_apbh_chn_curcmdar_t CHn_CURCMDAR; /*!< [0x100] APBH DMA Channel n Current Command Address Register */
        uint8_t _reserved0[12];
        __IO hw_apbh_chn_nxtcmdar_t CHn_NXTCMDAR; /*!< [0x110] APBH DMA Channel n Next Command Address Register */
        uint8_t _reserved1[12];
        __I hw_apbh_chn_cmd_t CHn_CMD;     /*!< [0x120] APBH DMA Channel n Command Register */
        uint8_t _reserved2[12];
        __I hw_apbh_chn_bar_t CHn_BAR;     /*!< [0x130] APBH DMA Channel n Buffer Address Register */
        uint8_t _reserved3[12];
        __IO hw_apbh_chn_sema_t CHn_SEMA;  /*!< [0x140] APBH DMA Channel n Semaphore Register */
        uint8_t _reserved4[12];
        __I hw_apbh_chn_debug1_t CHn_DEBUG1; /*!< [0x150] AHB to APBH DMA Channel n Debug Information */
        uint8_t _reserved5[12];
        __I hw_apbh_chn_debug2_t CHn_DEBUG2; /*!< [0x160] AHB to APBH DMA Channel n Debug Information */
        uint8_t _reserved6[12];
    } CH[16];
    __I hw_apbh_version_t VERSION;         /*!< [0x800] APBH Bridge Version Register */
} hw_apbh_t;
#pragma pack()

/*! @brief Macro to access all APBH registers. */
/*! @param x APBH module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_APBH_REGS(APBH_BASE)</code>. */
#define HW_APBH_REGS(x) (*(hw_apbh_t *)(x))

/*
 * iMX6DP ARMGLOBALTIMER
 *
 * ARM Cortex-A9 Global Timer
 *
 * Registers defined in this header file:
 * - HW_ARMGLOBALTIMER_COUNTERn - Global Timer Counter Registers
 * - HW_ARMGLOBALTIMER_CONTROL - Global Timer Control Register
 * - HW_ARMGLOBALTIMER_IRQSTATUS - Global Timer Interrupt Status Register
 * - HW_ARMGLOBALTIMER_COMPARATORn - Global Timer Comparator Value Registers
 * - HW_ARMGLOBALTIMER_AUTOINCREMENT - Global Timer Auto-increment Register
 *
 * - hw_armglobaltimer_t - Struct containing all module registers.
 */

#define HW_ARMGLOBALTIMER_INSTANCE_COUNT (1U) /*!< Number of instances of the ARMGLOBALTIMER module. */
#define HW_ARMGLOBALTIMER (0U) /*!< Instance number for ARMGLOBALTIMER. */
#define ARMGLOBALTIMER_BASE   (0xA00000U) /*!< Base address for ARMGLOBALTIMER. */
/*! Array initializer of ARMGLOBALTIMER base addresses. */
#define ARMGLOBALTIMER_BASE_ADDRS { ARMGLOBALTIMER_BASE }

/*******************************************************************************
 * HW_ARMGLOBALTIMER_COUNTERn - Global Timer Counter Registers
 ******************************************************************************/

/*!
 * @brief HW_ARMGLOBALTIMER_COUNTERn - Global Timer Counter Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * There are two timer counter registers. They are the lower 32-bit timer
 * counter at offset 0x00 and the upper 32-bit timer counter at offset 0x04.
 */
typedef union _hw_armglobaltimer_countern
{
    uint32_t U;
    struct _hw_armglobaltimer_countern_bitfields
    {
        uint32_t VALUE : 32;           /*!< [31:0]  */
    } B;
} hw_armglobaltimer_countern_t;

/*!
 * @name Constants and macros for entire ARMGLOBALTIMER_COUNTERn register
 */
/*@{*/
#define HW_ARMGLOBALTIMER_COUNTERn_COUNT (2U)

#define HW_ARMGLOBALTIMER_COUNTERn_ADDR(x, n) ((uintptr_t)(x) + 0x200U + (0x4U * (n)))

#define HW_ARMGLOBALTIMER_COUNTERn(x, n) (*(__IO hw_armglobaltimer_countern_t *) HW_ARMGLOBALTIMER_COUNTERn_ADDR(x, n))
#define HW_ARMGLOBALTIMER_COUNTERn_RD(x, n) (HW_ARMGLOBALTIMER_COUNTERn(x, n).U)
#define HW_ARMGLOBALTIMER_COUNTERn_WR(x, n, v) (HW_ARMGLOBALTIMER_COUNTERn(x, n).U = (v))
#define HW_ARMGLOBALTIMER_COUNTERn_SET(x, n, v) (HW_ARMGLOBALTIMER_COUNTERn_WR(x, n, HW_ARMGLOBALTIMER_COUNTERn_RD(x, n) |  (v)))
#define HW_ARMGLOBALTIMER_COUNTERn_CLR(x, n, v) (HW_ARMGLOBALTIMER_COUNTERn_WR(x, n, HW_ARMGLOBALTIMER_COUNTERn_RD(x, n) & ~(v)))
#define HW_ARMGLOBALTIMER_COUNTERn_TOG(x, n, v) (HW_ARMGLOBALTIMER_COUNTERn_WR(x, n, HW_ARMGLOBALTIMER_COUNTERn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ARMGLOBALTIMER_COUNTERn bitfields
 */

/*!
 * @name Register ARMGLOBALTIMER_COUNTERn, field VALUE[31:0] (RW)
 *
 * 32-bits of the counter value.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_COUNTERn_VALUE (0U) /*!< Bit position for ARMGLOBALTIMER_COUNTERn_VALUE. */
#define BM_ARMGLOBALTIMER_COUNTERn_VALUE (0xFFFFFFFFU) /*!< Bit mask for ARMGLOBALTIMER_COUNTERn_VALUE. */
#define BS_ARMGLOBALTIMER_COUNTERn_VALUE (32U) /*!< Bit field size in bits for ARMGLOBALTIMER_COUNTERn_VALUE. */

/*! @brief Read current value of the ARMGLOBALTIMER_COUNTERn_VALUE field. */
#define BR_ARMGLOBALTIMER_COUNTERn_VALUE(x, n) (HW_ARMGLOBALTIMER_COUNTERn(x, n).U)

/*! @brief Format value for bitfield ARMGLOBALTIMER_COUNTERn_VALUE. */
#define BF_ARMGLOBALTIMER_COUNTERn_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_COUNTERn_VALUE) & BM_ARMGLOBALTIMER_COUNTERn_VALUE)

/*! @brief Set the VALUE field to a new value. */
#define BW_ARMGLOBALTIMER_COUNTERn_VALUE(x, n, v) (HW_ARMGLOBALTIMER_COUNTERn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_ARMGLOBALTIMER_CONTROL - Global Timer Control Register
 ******************************************************************************/

/*!
 * @brief HW_ARMGLOBALTIMER_CONTROL - Global Timer Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Configuration and control of the Global Timer.
 */
typedef union _hw_armglobaltimer_control
{
    uint32_t U;
    struct _hw_armglobaltimer_control_bitfields
    {
        uint32_t TIMER_ENABLE : 1;     /*!< [0]  */
        uint32_t COMP_ENABLE : 1;      /*!< [1]  */
        uint32_t IRQ_ENABLE : 1;       /*!< [2]  */
        uint32_t AUTO_INCREMENT : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t PRESCALER : 8;        /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_armglobaltimer_control_t;

/*!
 * @name Constants and macros for entire ARMGLOBALTIMER_CONTROL register
 */
/*@{*/
#define HW_ARMGLOBALTIMER_CONTROL_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_ARMGLOBALTIMER_CONTROL(x) (*(__IO hw_armglobaltimer_control_t *) HW_ARMGLOBALTIMER_CONTROL_ADDR(x))
#define HW_ARMGLOBALTIMER_CONTROL_RD(x) (HW_ARMGLOBALTIMER_CONTROL(x).U)
#define HW_ARMGLOBALTIMER_CONTROL_WR(x, v) (HW_ARMGLOBALTIMER_CONTROL(x).U = (v))
#define HW_ARMGLOBALTIMER_CONTROL_SET(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, HW_ARMGLOBALTIMER_CONTROL_RD(x) |  (v)))
#define HW_ARMGLOBALTIMER_CONTROL_CLR(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~(v)))
#define HW_ARMGLOBALTIMER_CONTROL_TOG(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, HW_ARMGLOBALTIMER_CONTROL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ARMGLOBALTIMER_CONTROL bitfields
 */

/*!
 * @name Register ARMGLOBALTIMER_CONTROL, field TIMER_ENABLE[0] (RW)
 *
 * Timer enable.
 *
 * Values:
 * - 0 - Timer is disabled and the counter does not increment. All registers can
 *     still be read and written.
 * - 1 - Timer is enabled and the counter increments normally.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE (0U) /*!< Bit position for ARMGLOBALTIMER_CONTROL_TIMER_ENABLE. */
#define BM_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE (0x00000001U) /*!< Bit mask for ARMGLOBALTIMER_CONTROL_TIMER_ENABLE. */
#define BS_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE (1U) /*!< Bit field size in bits for ARMGLOBALTIMER_CONTROL_TIMER_ENABLE. */

#define BV_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE_DISABLED (0U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_TIMER_ENABLE: Timer is disabled and the counter does not increment. All registers can still be read and written. */
#define BV_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE_ENABLED (0x1U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_TIMER_ENABLE: Timer is enabled and the counter increments normally. */

/*! @brief Read current value of the ARMGLOBALTIMER_CONTROL_TIMER_ENABLE field. */
#define BR_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE(x) (HW_ARMGLOBALTIMER_CONTROL(x).B.TIMER_ENABLE)

/*! @brief Format value for bitfield ARMGLOBALTIMER_CONTROL_TIMER_ENABLE. */
#define BF_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE) & BM_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE)

/*! @brief Set the TIMER_ENABLE field to a new value. */
#define BW_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, (HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~BM_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE) | BF_ARMGLOBALTIMER_CONTROL_TIMER_ENABLE(v)))
/*@}*/

/*!
 * @name Register ARMGLOBALTIMER_CONTROL, field COMP_ENABLE[1] (RW)
 *
 * This bit is banked per Cortex-A9 processor. If set, it enables the comparison
 * between the 64-bit Timer Counter and the related 64-bit Comparator Register.
 * When the Auto-increment and Comp enable bits are set, an IRQ is generated
 * every auto-increment register value.
 *
 * Values:
 * - 0 - Comparison is disabled.
 * - 1 - Comparison is enabled.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_CONTROL_COMP_ENABLE (1U) /*!< Bit position for ARMGLOBALTIMER_CONTROL_COMP_ENABLE. */
#define BM_ARMGLOBALTIMER_CONTROL_COMP_ENABLE (0x00000002U) /*!< Bit mask for ARMGLOBALTIMER_CONTROL_COMP_ENABLE. */
#define BS_ARMGLOBALTIMER_CONTROL_COMP_ENABLE (1U) /*!< Bit field size in bits for ARMGLOBALTIMER_CONTROL_COMP_ENABLE. */

#define BV_ARMGLOBALTIMER_CONTROL_COMP_ENABLE_DISABLED (0U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_COMP_ENABLE: Comparison is disabled. */
#define BV_ARMGLOBALTIMER_CONTROL_COMP_ENABLE_ENABLED (0x1U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_COMP_ENABLE: Comparison is enabled. */

/*! @brief Read current value of the ARMGLOBALTIMER_CONTROL_COMP_ENABLE field. */
#define BR_ARMGLOBALTIMER_CONTROL_COMP_ENABLE(x) (HW_ARMGLOBALTIMER_CONTROL(x).B.COMP_ENABLE)

/*! @brief Format value for bitfield ARMGLOBALTIMER_CONTROL_COMP_ENABLE. */
#define BF_ARMGLOBALTIMER_CONTROL_COMP_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_CONTROL_COMP_ENABLE) & BM_ARMGLOBALTIMER_CONTROL_COMP_ENABLE)

/*! @brief Set the COMP_ENABLE field to a new value. */
#define BW_ARMGLOBALTIMER_CONTROL_COMP_ENABLE(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, (HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~BM_ARMGLOBALTIMER_CONTROL_COMP_ENABLE) | BF_ARMGLOBALTIMER_CONTROL_COMP_ENABLE(v)))
/*@}*/

/*!
 * @name Register ARMGLOBALTIMER_CONTROL, field IRQ_ENABLE[2] (RW)
 *
 * This bit is banked per Cortex-A9 processor. If set, the interrupt ID 27 is
 * set as pending in the Interrupt Distributor when the event flag is set in the
 * Timer Status Register.
 *
 * Values:
 * - 0 - Interrupts are disabled.
 * - 1 - Interrupts are enabled.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE (2U) /*!< Bit position for ARMGLOBALTIMER_CONTROL_IRQ_ENABLE. */
#define BM_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE (0x00000004U) /*!< Bit mask for ARMGLOBALTIMER_CONTROL_IRQ_ENABLE. */
#define BS_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE (1U) /*!< Bit field size in bits for ARMGLOBALTIMER_CONTROL_IRQ_ENABLE. */

#define BV_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE_DISABLED (0U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_IRQ_ENABLE: Interrupts are disabled. */
#define BV_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE_ENABLED (0x1U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_IRQ_ENABLE: Interrupts are enabled. */

/*! @brief Read current value of the ARMGLOBALTIMER_CONTROL_IRQ_ENABLE field. */
#define BR_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE(x) (HW_ARMGLOBALTIMER_CONTROL(x).B.IRQ_ENABLE)

/*! @brief Format value for bitfield ARMGLOBALTIMER_CONTROL_IRQ_ENABLE. */
#define BF_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE) & BM_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE)

/*! @brief Set the IRQ_ENABLE field to a new value. */
#define BW_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, (HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~BM_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE) | BF_ARMGLOBALTIMER_CONTROL_IRQ_ENABLE(v)))
/*@}*/

/*!
 * @name Register ARMGLOBALTIMER_CONTROL, field AUTO_INCREMENT[3] (RW)
 *
 * This bit is banked per Cortex-A9 processor.
 *
 * Values:
 * - 0 - When the counter reaches the comparator value, sets the event flag. It
 *     is the responsibility of software to update the comparator value to get
 *     more events.
 * - 1 - Each time the counter reaches the comparator value, the comparator
 *     register is incremented with the auto-increment register, so that more events
 *     can be set periodically without any software updates.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT (3U) /*!< Bit position for ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT. */
#define BM_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT (0x00000008U) /*!< Bit mask for ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT. */
#define BS_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT (1U) /*!< Bit field size in bits for ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT. */

#define BV_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT_SINGLE_SHOT_MODE (0U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT: When the counter reaches the comparator value, sets the event flag. It is the responsibility of software to update the comparator value to get more events. */
#define BV_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT_AUTO_INCREMENT_MODE (0x1U) /*!< Bit field value for ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT: Each time the counter reaches the comparator value, the comparator register is incremented with the auto-increment register, so that more events can be set periodically without any software updates. */

/*! @brief Read current value of the ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT field. */
#define BR_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT(x) (HW_ARMGLOBALTIMER_CONTROL(x).B.AUTO_INCREMENT)

/*! @brief Format value for bitfield ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT. */
#define BF_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT) & BM_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT)

/*! @brief Set the AUTO_INCREMENT field to a new value. */
#define BW_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, (HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~BM_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT) | BF_ARMGLOBALTIMER_CONTROL_AUTO_INCREMENT(v)))
/*@}*/

/*!
 * @name Register ARMGLOBALTIMER_CONTROL, field PRESCALER[15:8] (RW)
 *
 * The prescaler modifies the clock period for the decrementing event for the
 * Counter Register.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_CONTROL_PRESCALER (8U) /*!< Bit position for ARMGLOBALTIMER_CONTROL_PRESCALER. */
#define BM_ARMGLOBALTIMER_CONTROL_PRESCALER (0x0000FF00U) /*!< Bit mask for ARMGLOBALTIMER_CONTROL_PRESCALER. */
#define BS_ARMGLOBALTIMER_CONTROL_PRESCALER (8U) /*!< Bit field size in bits for ARMGLOBALTIMER_CONTROL_PRESCALER. */

/*! @brief Read current value of the ARMGLOBALTIMER_CONTROL_PRESCALER field. */
#define BR_ARMGLOBALTIMER_CONTROL_PRESCALER(x) (HW_ARMGLOBALTIMER_CONTROL(x).B.PRESCALER)

/*! @brief Format value for bitfield ARMGLOBALTIMER_CONTROL_PRESCALER. */
#define BF_ARMGLOBALTIMER_CONTROL_PRESCALER(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_CONTROL_PRESCALER) & BM_ARMGLOBALTIMER_CONTROL_PRESCALER)

/*! @brief Set the PRESCALER field to a new value. */
#define BW_ARMGLOBALTIMER_CONTROL_PRESCALER(x, v) (HW_ARMGLOBALTIMER_CONTROL_WR(x, (HW_ARMGLOBALTIMER_CONTROL_RD(x) & ~BM_ARMGLOBALTIMER_CONTROL_PRESCALER) | BF_ARMGLOBALTIMER_CONTROL_PRESCALER(v)))
/*@}*/

/*******************************************************************************
 * HW_ARMGLOBALTIMER_IRQSTATUS - Global Timer Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_ARMGLOBALTIMER_IRQSTATUS - Global Timer Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is a banked register for all Cortex-A9 processors present.
 */
typedef union _hw_armglobaltimer_irqstatus
{
    uint32_t U;
    struct _hw_armglobaltimer_irqstatus_bitfields
    {
        uint32_t EVENT_FLAG : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_armglobaltimer_irqstatus_t;

/*!
 * @name Constants and macros for entire ARMGLOBALTIMER_IRQSTATUS register
 */
/*@{*/
#define HW_ARMGLOBALTIMER_IRQSTATUS_ADDR(x) ((uintptr_t)(x) + 0x20CU)

#define HW_ARMGLOBALTIMER_IRQSTATUS(x) (*(__IO hw_armglobaltimer_irqstatus_t *) HW_ARMGLOBALTIMER_IRQSTATUS_ADDR(x))
#define HW_ARMGLOBALTIMER_IRQSTATUS_RD(x) (HW_ARMGLOBALTIMER_IRQSTATUS(x).U)
#define HW_ARMGLOBALTIMER_IRQSTATUS_WR(x, v) (HW_ARMGLOBALTIMER_IRQSTATUS(x).U = (v))
#define HW_ARMGLOBALTIMER_IRQSTATUS_SET(x, v) (HW_ARMGLOBALTIMER_IRQSTATUS_WR(x, HW_ARMGLOBALTIMER_IRQSTATUS_RD(x) |  (v)))
#define HW_ARMGLOBALTIMER_IRQSTATUS_CLR(x, v) (HW_ARMGLOBALTIMER_IRQSTATUS_WR(x, HW_ARMGLOBALTIMER_IRQSTATUS_RD(x) & ~(v)))
#define HW_ARMGLOBALTIMER_IRQSTATUS_TOG(x, v) (HW_ARMGLOBALTIMER_IRQSTATUS_WR(x, HW_ARMGLOBALTIMER_IRQSTATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ARMGLOBALTIMER_IRQSTATUS bitfields
 */

/*!
 * @name Register ARMGLOBALTIMER_IRQSTATUS, field EVENT_FLAG[0] (W1C)
 *
 * The event flag is a sticky bit that is automatically set when the Counter
 * Register reaches the Comparator Register value. If the timer interrupt is
 * enabled, Interrupt ID 27 is set as pending in the Interrupt Distributor after the
 * event flag is set. The event flag is cleared when written to 1.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG (0U) /*!< Bit position for ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG. */
#define BM_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG (0x00000001U) /*!< Bit mask for ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG. */
#define BS_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG (1U) /*!< Bit field size in bits for ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG. */

/*! @brief Read current value of the ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG field. */
#define BR_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG(x) (HW_ARMGLOBALTIMER_IRQSTATUS(x).B.EVENT_FLAG)

/*! @brief Format value for bitfield ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG. */
#define BF_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG) & BM_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG)

/*! @brief Set the EVENT_FLAG field to a new value. */
#define BW_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG(x, v) (HW_ARMGLOBALTIMER_IRQSTATUS_WR(x, (HW_ARMGLOBALTIMER_IRQSTATUS_RD(x) & ~BM_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG) | BF_ARMGLOBALTIMER_IRQSTATUS_EVENT_FLAG(v)))
/*@}*/

/*******************************************************************************
 * HW_ARMGLOBALTIMER_COMPARATORn - Global Timer Comparator Value Registers
 ******************************************************************************/

/*!
 * @brief HW_ARMGLOBALTIMER_COMPARATORn - Global Timer Comparator Value Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * There are two timer counter registers. They are the lower 32-bit timer
 * counter at offset 0x00 and the upper 32-bit timer counter at offset 0x04.
 */
typedef union _hw_armglobaltimer_comparatorn
{
    uint32_t U;
    struct _hw_armglobaltimer_comparatorn_bitfields
    {
        uint32_t VALUE : 32;           /*!< [31:0]  */
    } B;
} hw_armglobaltimer_comparatorn_t;

/*!
 * @name Constants and macros for entire ARMGLOBALTIMER_COMPARATORn register
 */
/*@{*/
#define HW_ARMGLOBALTIMER_COMPARATORn_COUNT (2U)

#define HW_ARMGLOBALTIMER_COMPARATORn_ADDR(x, n) ((uintptr_t)(x) + 0x210U + (0x4U * (n)))

#define HW_ARMGLOBALTIMER_COMPARATORn(x, n) (*(__IO hw_armglobaltimer_comparatorn_t *) HW_ARMGLOBALTIMER_COMPARATORn_ADDR(x, n))
#define HW_ARMGLOBALTIMER_COMPARATORn_RD(x, n) (HW_ARMGLOBALTIMER_COMPARATORn(x, n).U)
#define HW_ARMGLOBALTIMER_COMPARATORn_WR(x, n, v) (HW_ARMGLOBALTIMER_COMPARATORn(x, n).U = (v))
#define HW_ARMGLOBALTIMER_COMPARATORn_SET(x, n, v) (HW_ARMGLOBALTIMER_COMPARATORn_WR(x, n, HW_ARMGLOBALTIMER_COMPARATORn_RD(x, n) |  (v)))
#define HW_ARMGLOBALTIMER_COMPARATORn_CLR(x, n, v) (HW_ARMGLOBALTIMER_COMPARATORn_WR(x, n, HW_ARMGLOBALTIMER_COMPARATORn_RD(x, n) & ~(v)))
#define HW_ARMGLOBALTIMER_COMPARATORn_TOG(x, n, v) (HW_ARMGLOBALTIMER_COMPARATORn_WR(x, n, HW_ARMGLOBALTIMER_COMPARATORn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ARMGLOBALTIMER_COMPARATORn bitfields
 */

/*!
 * @name Register ARMGLOBALTIMER_COMPARATORn, field VALUE[31:0] (RW)
 *
 * 32-bits of the comparator value.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_COMPARATORn_VALUE (0U) /*!< Bit position for ARMGLOBALTIMER_COMPARATORn_VALUE. */
#define BM_ARMGLOBALTIMER_COMPARATORn_VALUE (0xFFFFFFFFU) /*!< Bit mask for ARMGLOBALTIMER_COMPARATORn_VALUE. */
#define BS_ARMGLOBALTIMER_COMPARATORn_VALUE (32U) /*!< Bit field size in bits for ARMGLOBALTIMER_COMPARATORn_VALUE. */

/*! @brief Read current value of the ARMGLOBALTIMER_COMPARATORn_VALUE field. */
#define BR_ARMGLOBALTIMER_COMPARATORn_VALUE(x, n) (HW_ARMGLOBALTIMER_COMPARATORn(x, n).U)

/*! @brief Format value for bitfield ARMGLOBALTIMER_COMPARATORn_VALUE. */
#define BF_ARMGLOBALTIMER_COMPARATORn_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_COMPARATORn_VALUE) & BM_ARMGLOBALTIMER_COMPARATORn_VALUE)

/*! @brief Set the VALUE field to a new value. */
#define BW_ARMGLOBALTIMER_COMPARATORn_VALUE(x, n, v) (HW_ARMGLOBALTIMER_COMPARATORn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_ARMGLOBALTIMER_AUTOINCREMENT - Global Timer Auto-increment Register
 ******************************************************************************/

/*!
 * @brief HW_ARMGLOBALTIMER_AUTOINCREMENT - Global Timer Auto-increment Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit register gives the increment value of the Comparator Register
 * when the Auto-increment bit is set in the Timer Control Register. Each Cortex-A9
 * processor present has its own Auto-increment Register. If the comp enable and
 * auto-increment bits are set when the global counter reaches the Comparator
 * Register value, the comparator is incremented by the auto-increment value, so
 * that a new event can be set periodically. The global timer is not affected and
 * goes on incrementing.
 */
typedef union _hw_armglobaltimer_autoincrement
{
    uint32_t U;
    struct _hw_armglobaltimer_autoincrement_bitfields
    {
        uint32_t VALUE : 32;           /*!< [31:0]  */
    } B;
} hw_armglobaltimer_autoincrement_t;

/*!
 * @name Constants and macros for entire ARMGLOBALTIMER_AUTOINCREMENT register
 */
/*@{*/
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_ADDR(x) ((uintptr_t)(x) + 0x218U)

#define HW_ARMGLOBALTIMER_AUTOINCREMENT(x) (*(__IO hw_armglobaltimer_autoincrement_t *) HW_ARMGLOBALTIMER_AUTOINCREMENT_ADDR(x))
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_RD(x) (HW_ARMGLOBALTIMER_AUTOINCREMENT(x).U)
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_WR(x, v) (HW_ARMGLOBALTIMER_AUTOINCREMENT(x).U = (v))
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_SET(x, v) (HW_ARMGLOBALTIMER_AUTOINCREMENT_WR(x, HW_ARMGLOBALTIMER_AUTOINCREMENT_RD(x) |  (v)))
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_CLR(x, v) (HW_ARMGLOBALTIMER_AUTOINCREMENT_WR(x, HW_ARMGLOBALTIMER_AUTOINCREMENT_RD(x) & ~(v)))
#define HW_ARMGLOBALTIMER_AUTOINCREMENT_TOG(x, v) (HW_ARMGLOBALTIMER_AUTOINCREMENT_WR(x, HW_ARMGLOBALTIMER_AUTOINCREMENT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ARMGLOBALTIMER_AUTOINCREMENT bitfields
 */

/*!
 * @name Register ARMGLOBALTIMER_AUTOINCREMENT, field VALUE[31:0] (RW)
 *
 * 32-bit auto-increment value.
 */
/*@{*/
#define BP_ARMGLOBALTIMER_AUTOINCREMENT_VALUE (0U) /*!< Bit position for ARMGLOBALTIMER_AUTOINCREMENT_VALUE. */
#define BM_ARMGLOBALTIMER_AUTOINCREMENT_VALUE (0xFFFFFFFFU) /*!< Bit mask for ARMGLOBALTIMER_AUTOINCREMENT_VALUE. */
#define BS_ARMGLOBALTIMER_AUTOINCREMENT_VALUE (32U) /*!< Bit field size in bits for ARMGLOBALTIMER_AUTOINCREMENT_VALUE. */

/*! @brief Read current value of the ARMGLOBALTIMER_AUTOINCREMENT_VALUE field. */
#define BR_ARMGLOBALTIMER_AUTOINCREMENT_VALUE(x) (HW_ARMGLOBALTIMER_AUTOINCREMENT(x).U)

/*! @brief Format value for bitfield ARMGLOBALTIMER_AUTOINCREMENT_VALUE. */
#define BF_ARMGLOBALTIMER_AUTOINCREMENT_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ARMGLOBALTIMER_AUTOINCREMENT_VALUE) & BM_ARMGLOBALTIMER_AUTOINCREMENT_VALUE)

/*! @brief Set the VALUE field to a new value. */
#define BW_ARMGLOBALTIMER_AUTOINCREMENT_VALUE(x, v) (HW_ARMGLOBALTIMER_AUTOINCREMENT_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_armglobaltimer_t - module struct
 ******************************************************************************/
/*!
 * @brief All ARMGLOBALTIMER module registers.
 */
#pragma pack(1)
typedef struct _hw_armglobaltimer
{
    uint8_t _reserved0[512];
    __IO hw_armglobaltimer_countern_t COUNTERn[2]; /*!< [0x200] Global Timer Counter Registers */
    __IO hw_armglobaltimer_control_t CONTROL; /*!< [0x208] Global Timer Control Register */
    __IO hw_armglobaltimer_irqstatus_t IRQSTATUS; /*!< [0x20C] Global Timer Interrupt Status Register */
    __IO hw_armglobaltimer_comparatorn_t COMPARATORn[2]; /*!< [0x210] Global Timer Comparator Value Registers */
    __IO hw_armglobaltimer_autoincrement_t AUTOINCREMENT; /*!< [0x218] Global Timer Auto-increment Register */
} hw_armglobaltimer_t;
#pragma pack()

/*! @brief Macro to access all ARMGLOBALTIMER registers. */
/*! @param x ARMGLOBALTIMER module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ARMGLOBALTIMER_REGS(ARMGLOBALTIMER_BASE)</code>. */
#define HW_ARMGLOBALTIMER_REGS(x) (*(hw_armglobaltimer_t *)(x))

/*
 * iMX6DP ASRC
 *
 * ASRC Registers
 *
 * Registers defined in this header file:
 * - HW_ASRC_ASRCTR - ASRC Control Register
 * - HW_ASRC_ASRIER - ASRC Interrupt Enable Register
 * - HW_ASRC_ASRCNCR - ASRC Channel Number Configuration Register
 * - HW_ASRC_ASRCFG - ASRC Filter Configuration Status Register
 * - HW_ASRC_ASRCSR - ASRC Clock Source Register
 * - HW_ASRC_ASRCDR1 - ASRC Clock Divider Register 1
 * - HW_ASRC_ASRCDR2 - ASRC Clock Divider Register 2
 * - HW_ASRC_ASRSTR - ASRC Status Register
 * - HW_ASRC_ASRPMn1 - ASRC Parameter Register n
 * - HW_ASRC_ASRPMn2 - ASRC Parameter Register n
 * - HW_ASRC_ASRPMn3 - ASRC Parameter Register n
 * - HW_ASRC_ASRPMn4 - ASRC Parameter Register n
 * - HW_ASRC_ASRPMn5 - ASRC Parameter Register n
 * - HW_ASRC_ASRTFR1 - ASRC ASRC Task Queue FIFO Register 1
 * - HW_ASRC_ASRCCR - ASRC Channel Counter Register
 * - HW_ASRC_ASRDIn - ASRC Data Input Register for Pair x
 * - HW_ASRC_ASRDOn - ASRC Data Output Register for Pair x
 * - HW_ASRC_ASRIDRHA - ASRC Ideal Ratio for Pair A-High Part
 * - HW_ASRC_ASRIDRLA - ASRC Ideal Ratio for Pair A -Low Part
 * - HW_ASRC_ASRIDRHB - ASRC Ideal Ratio for Pair B-High Part
 * - HW_ASRC_ASRIDRLB - ASRC Ideal Ratio for Pair B-Low Part
 * - HW_ASRC_ASRIDRHC - ASRC Ideal Ratio for Pair C-High Part
 * - HW_ASRC_ASRIDRLC - ASRC Ideal Ratio for Pair C-Low Part
 * - HW_ASRC_ASR76K - ASRC 76kHz Period in terms of ASRC processing clock
 * - HW_ASRC_ASR56K - ASRC 56kHz Period in terms of ASRC processing clock
 * - HW_ASRC_ASRMCRA - ASRC Misc Control Register for Pair A
 * - HW_ASRC_ASRFSTA - ASRC FIFO Status Register for Pair A
 * - HW_ASRC_ASRMCRB - ASRC Misc Control Register for Pair B
 * - HW_ASRC_ASRFSTB - ASRC FIFO Status Register for Pair B
 * - HW_ASRC_ASRMCRC - ASRC Misc Control Register for Pair C
 * - HW_ASRC_ASRFSTC - ASRC FIFO Status Register for Pair C
 * - HW_ASRC_ASRMCR1n - ASRC Misc Control Register 1 for Pair X
 *
 * - hw_asrc_t - Struct containing all module registers.
 */

#define HW_ASRC_INSTANCE_COUNT (1U) /*!< Number of instances of the ASRC module. */
#define HW_ASRC (0U) /*!< Instance number for ASRC. */
#define ASRC_BASE             (0x2034000U) /*!< Base address for ASRC. */
/*! Array initializer of ASRC base addresses. */
#define ASRC_BASE_ADDRS       { ASRC_BASE }

/*******************************************************************************
 * HW_ASRC_ASRCTR - ASRC Control Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCTR - ASRC Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC control register (ASRCTR) is a 24-bit read/write register that
 * controls the ASRC operations.
 */
typedef union _hw_asrc_asrctr
{
    uint32_t U;
    struct _hw_asrc_asrctr_bitfields
    {
        uint32_t ASRCEN : 1;           /*!< [0]  */
        uint32_t ASREA : 1;            /*!< [1]  */
        uint32_t ASREB : 1;            /*!< [2]  */
        uint32_t ASREC : 1;            /*!< [3]  */
        uint32_t SRST : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 8;        /*!< [12:5]  */
        uint32_t IDRA : 1;             /*!< [13]  */
        uint32_t USRA : 1;             /*!< [14]  */
        uint32_t IDRB : 1;             /*!< [15]  */
        uint32_t USRB : 1;             /*!< [16]  */
        uint32_t IDRC : 1;             /*!< [17]  */
        uint32_t USRC : 1;             /*!< [18]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t ATSA : 1;             /*!< [20]  */
        uint32_t ATSB : 1;             /*!< [21]  */
        uint32_t ATSC : 1;             /*!< [22]  */
        uint32_t RESERVED2 : 9;        /*!< [31:23] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrctr_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCTR register
 */
/*@{*/
#define HW_ASRC_ASRCTR_ADDR(x)   ((uintptr_t)(x) + 0x0U)

#define HW_ASRC_ASRCTR(x)        (*(__IO hw_asrc_asrctr_t *) HW_ASRC_ASRCTR_ADDR(x))
#define HW_ASRC_ASRCTR_RD(x)     (HW_ASRC_ASRCTR(x).U)
#define HW_ASRC_ASRCTR_WR(x, v)  (HW_ASRC_ASRCTR(x).U = (v))
#define HW_ASRC_ASRCTR_SET(x, v) (HW_ASRC_ASRCTR_WR(x, HW_ASRC_ASRCTR_RD(x) |  (v)))
#define HW_ASRC_ASRCTR_CLR(x, v) (HW_ASRC_ASRCTR_WR(x, HW_ASRC_ASRCTR_RD(x) & ~(v)))
#define HW_ASRC_ASRCTR_TOG(x, v) (HW_ASRC_ASRCTR_WR(x, HW_ASRC_ASRCTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCTR bitfields
 */

/*!
 * @name Register ASRC_ASRCTR, field ASRCEN[0] (RW)
 *
 * ASRC Enable Enable the operation of ASRC.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ASRCEN (0U)         /*!< Bit position for ASRC_ASRCTR_ASRCEN. */
#define BM_ASRC_ASRCTR_ASRCEN (0x00000001U) /*!< Bit mask for ASRC_ASRCTR_ASRCEN. */
#define BS_ASRC_ASRCTR_ASRCEN (1U)         /*!< Bit field size in bits for ASRC_ASRCTR_ASRCEN. */

/*! @brief Read current value of the ASRC_ASRCTR_ASRCEN field. */
#define BR_ASRC_ASRCTR_ASRCEN(x) (HW_ASRC_ASRCTR(x).B.ASRCEN)

/*! @brief Format value for bitfield ASRC_ASRCTR_ASRCEN. */
#define BF_ASRC_ASRCTR_ASRCEN(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ASRCEN) & BM_ASRC_ASRCTR_ASRCEN)

/*! @brief Set the ASRCEN field to a new value. */
#define BW_ASRC_ASRCTR_ASRCEN(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ASRCEN) | BF_ASRC_ASRCTR_ASRCEN(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ASREA[1] (RW)
 *
 * ASRC Enable A Enable the operation of the conversion A of ASRC. When ASREA is
 * cleared, operation of conversion A is disabled.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ASREA (1U)          /*!< Bit position for ASRC_ASRCTR_ASREA. */
#define BM_ASRC_ASRCTR_ASREA (0x00000002U) /*!< Bit mask for ASRC_ASRCTR_ASREA. */
#define BS_ASRC_ASRCTR_ASREA (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ASREA. */

/*! @brief Read current value of the ASRC_ASRCTR_ASREA field. */
#define BR_ASRC_ASRCTR_ASREA(x) (HW_ASRC_ASRCTR(x).B.ASREA)

/*! @brief Format value for bitfield ASRC_ASRCTR_ASREA. */
#define BF_ASRC_ASRCTR_ASREA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ASREA) & BM_ASRC_ASRCTR_ASREA)

/*! @brief Set the ASREA field to a new value. */
#define BW_ASRC_ASRCTR_ASREA(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ASREA) | BF_ASRC_ASRCTR_ASREA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ASREB[2] (RW)
 *
 * ASRC Enable B Enable the operation of the conversion B of ASRC. When ASREB is
 * cleared, operation of conversion B is disabled.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ASREB (2U)          /*!< Bit position for ASRC_ASRCTR_ASREB. */
#define BM_ASRC_ASRCTR_ASREB (0x00000004U) /*!< Bit mask for ASRC_ASRCTR_ASREB. */
#define BS_ASRC_ASRCTR_ASREB (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ASREB. */

/*! @brief Read current value of the ASRC_ASRCTR_ASREB field. */
#define BR_ASRC_ASRCTR_ASREB(x) (HW_ASRC_ASRCTR(x).B.ASREB)

/*! @brief Format value for bitfield ASRC_ASRCTR_ASREB. */
#define BF_ASRC_ASRCTR_ASREB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ASREB) & BM_ASRC_ASRCTR_ASREB)

/*! @brief Set the ASREB field to a new value. */
#define BW_ASRC_ASRCTR_ASREB(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ASREB) | BF_ASRC_ASRCTR_ASREB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ASREC[3] (RW)
 *
 * ASRC Enable C Enable the operation of the conversion C of ASRC. When ASREC is
 * cleared, operation of conversion C is disabled.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ASREC (3U)          /*!< Bit position for ASRC_ASRCTR_ASREC. */
#define BM_ASRC_ASRCTR_ASREC (0x00000008U) /*!< Bit mask for ASRC_ASRCTR_ASREC. */
#define BS_ASRC_ASRCTR_ASREC (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ASREC. */

/*! @brief Read current value of the ASRC_ASRCTR_ASREC field. */
#define BR_ASRC_ASRCTR_ASREC(x) (HW_ASRC_ASRCTR(x).B.ASREC)

/*! @brief Format value for bitfield ASRC_ASRCTR_ASREC. */
#define BF_ASRC_ASRCTR_ASREC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ASREC) & BM_ASRC_ASRCTR_ASREC)

/*! @brief Set the ASREC field to a new value. */
#define BW_ASRC_ASRCTR_ASREC(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ASREC) | BF_ASRC_ASRCTR_ASREC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field SRST[4] (WO)
 *
 * Software Reset This bit is self-clear bit. Once it is been written as 1, it
 * will generate a software reset signal inside ASRC. After 9 cycles of the ASRC
 * processing clock, this reset process will stop, and this bit will be cleared
 * automatically.
 */
/*@{*/
#define BP_ASRC_ASRCTR_SRST  (4U)          /*!< Bit position for ASRC_ASRCTR_SRST. */
#define BM_ASRC_ASRCTR_SRST  (0x00000010U) /*!< Bit mask for ASRC_ASRCTR_SRST. */
#define BS_ASRC_ASRCTR_SRST  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_SRST. */

/*! @brief Format value for bitfield ASRC_ASRCTR_SRST. */
#define BF_ASRC_ASRCTR_SRST(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_SRST) & BM_ASRC_ASRCTR_SRST)
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field IDRA[13] (RW)
 *
 * Use Ideal Ratio for Pair A When USRA=0, this bit has no usage. When USRA=1
 * and IDRA=0, ASRC internal measured ratio will be used. When USRA=1 and IDRA=1,
 * the idea ratio from the interface register ASRIDRHA, ASRIDRLA will be used. It
 * is suggested to manually set ASRCFG:POSTMODA, ASRCFG:PREMODA according to in
 * this case.
 */
/*@{*/
#define BP_ASRC_ASRCTR_IDRA  (13U)         /*!< Bit position for ASRC_ASRCTR_IDRA. */
#define BM_ASRC_ASRCTR_IDRA  (0x00002000U) /*!< Bit mask for ASRC_ASRCTR_IDRA. */
#define BS_ASRC_ASRCTR_IDRA  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_IDRA. */

/*! @brief Read current value of the ASRC_ASRCTR_IDRA field. */
#define BR_ASRC_ASRCTR_IDRA(x) (HW_ASRC_ASRCTR(x).B.IDRA)

/*! @brief Format value for bitfield ASRC_ASRCTR_IDRA. */
#define BF_ASRC_ASRCTR_IDRA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_IDRA) & BM_ASRC_ASRCTR_IDRA)

/*! @brief Set the IDRA field to a new value. */
#define BW_ASRC_ASRCTR_IDRA(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_IDRA) | BF_ASRC_ASRCTR_IDRA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field USRA[14] (RW)
 *
 * Use Ratio for Pair A Use ratio as the input to ASRC. This bit is used in
 * conjunction with IDRA control bit.
 */
/*@{*/
#define BP_ASRC_ASRCTR_USRA  (14U)         /*!< Bit position for ASRC_ASRCTR_USRA. */
#define BM_ASRC_ASRCTR_USRA  (0x00004000U) /*!< Bit mask for ASRC_ASRCTR_USRA. */
#define BS_ASRC_ASRCTR_USRA  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_USRA. */

/*! @brief Read current value of the ASRC_ASRCTR_USRA field. */
#define BR_ASRC_ASRCTR_USRA(x) (HW_ASRC_ASRCTR(x).B.USRA)

/*! @brief Format value for bitfield ASRC_ASRCTR_USRA. */
#define BF_ASRC_ASRCTR_USRA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_USRA) & BM_ASRC_ASRCTR_USRA)

/*! @brief Set the USRA field to a new value. */
#define BW_ASRC_ASRCTR_USRA(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_USRA) | BF_ASRC_ASRCTR_USRA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field IDRB[15] (RW)
 *
 * Use Ideal Ratio for Pair B When USRB=0, this bit has no usage. When USRB=1
 * and IDRB=0, ASRC internal measured ratio will be used. When USRB=1 and IDRB=1,
 * the idea ratio from the interface register ASRIDRHB, ASRIDRLB will be used.It
 * is suggested to manually set ASRCFG:POSTMODB, ASRCFG:PREMODB according to in
 * this case.
 */
/*@{*/
#define BP_ASRC_ASRCTR_IDRB  (15U)         /*!< Bit position for ASRC_ASRCTR_IDRB. */
#define BM_ASRC_ASRCTR_IDRB  (0x00008000U) /*!< Bit mask for ASRC_ASRCTR_IDRB. */
#define BS_ASRC_ASRCTR_IDRB  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_IDRB. */

/*! @brief Read current value of the ASRC_ASRCTR_IDRB field. */
#define BR_ASRC_ASRCTR_IDRB(x) (HW_ASRC_ASRCTR(x).B.IDRB)

/*! @brief Format value for bitfield ASRC_ASRCTR_IDRB. */
#define BF_ASRC_ASRCTR_IDRB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_IDRB) & BM_ASRC_ASRCTR_IDRB)

/*! @brief Set the IDRB field to a new value. */
#define BW_ASRC_ASRCTR_IDRB(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_IDRB) | BF_ASRC_ASRCTR_IDRB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field USRB[16] (RW)
 *
 * Use Ratio for Pair B Use ratio as the input to ASRC. This bit is used in
 * conjunction with IDRB control bit.
 */
/*@{*/
#define BP_ASRC_ASRCTR_USRB  (16U)         /*!< Bit position for ASRC_ASRCTR_USRB. */
#define BM_ASRC_ASRCTR_USRB  (0x00010000U) /*!< Bit mask for ASRC_ASRCTR_USRB. */
#define BS_ASRC_ASRCTR_USRB  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_USRB. */

/*! @brief Read current value of the ASRC_ASRCTR_USRB field. */
#define BR_ASRC_ASRCTR_USRB(x) (HW_ASRC_ASRCTR(x).B.USRB)

/*! @brief Format value for bitfield ASRC_ASRCTR_USRB. */
#define BF_ASRC_ASRCTR_USRB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_USRB) & BM_ASRC_ASRCTR_USRB)

/*! @brief Set the USRB field to a new value. */
#define BW_ASRC_ASRCTR_USRB(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_USRB) | BF_ASRC_ASRCTR_USRB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field IDRC[17] (RW)
 *
 * Use Ideal Ratio for Pair C When USRC=0, this bit has no usage. When USRC=1
 * and IDRC=0, ASRC internal measured ratio will be used. When USRC=1 and IDRC=1,
 * the idea ratio from the interface register ASRIDRHC, ASRIDRLC will be used. It
 * is suggested to manually set ASRCFG:POSTMODC, ASRCFG:PREMODC according to in
 * this case.
 */
/*@{*/
#define BP_ASRC_ASRCTR_IDRC  (17U)         /*!< Bit position for ASRC_ASRCTR_IDRC. */
#define BM_ASRC_ASRCTR_IDRC  (0x00020000U) /*!< Bit mask for ASRC_ASRCTR_IDRC. */
#define BS_ASRC_ASRCTR_IDRC  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_IDRC. */

/*! @brief Read current value of the ASRC_ASRCTR_IDRC field. */
#define BR_ASRC_ASRCTR_IDRC(x) (HW_ASRC_ASRCTR(x).B.IDRC)

/*! @brief Format value for bitfield ASRC_ASRCTR_IDRC. */
#define BF_ASRC_ASRCTR_IDRC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_IDRC) & BM_ASRC_ASRCTR_IDRC)

/*! @brief Set the IDRC field to a new value. */
#define BW_ASRC_ASRCTR_IDRC(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_IDRC) | BF_ASRC_ASRCTR_IDRC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field USRC[18] (RW)
 *
 * Use Ratio for Pair C Use ratio as the input to ASRC. This bit is used in
 * conjunction with IDRC control bit.
 */
/*@{*/
#define BP_ASRC_ASRCTR_USRC  (18U)         /*!< Bit position for ASRC_ASRCTR_USRC. */
#define BM_ASRC_ASRCTR_USRC  (0x00040000U) /*!< Bit mask for ASRC_ASRCTR_USRC. */
#define BS_ASRC_ASRCTR_USRC  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_USRC. */

/*! @brief Read current value of the ASRC_ASRCTR_USRC field. */
#define BR_ASRC_ASRCTR_USRC(x) (HW_ASRC_ASRCTR(x).B.USRC)

/*! @brief Format value for bitfield ASRC_ASRCTR_USRC. */
#define BF_ASRC_ASRCTR_USRC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_USRC) & BM_ASRC_ASRCTR_USRC)

/*! @brief Set the USRC field to a new value. */
#define BW_ASRC_ASRCTR_USRC(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_USRC) | BF_ASRC_ASRCTR_USRC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ATSA[20] (RW)
 *
 * ASRC Pair A Automatic Selection For Processing Options When this bit is 1,
 * pair A will automatic update its pre-processing and post-processing options
 * (ASRCFG: PREMODA, ASRCFG:POSTMODA see ASRC Misc Control Register 1 for Pair CASRC
 * Filter Configuration Status Register ) based on the frequencies it detected.
 * To use this option, the two parameter registers(ASR76K and ASR56K) should be
 * set correctly (see ASRC Misc Control Register 1 for Pair CASRC 76kHz Period in
 * terms of ASRC processing clock and ASRC Misc Control Register 1 for Pair CASRC
 * 56kHz Period in terms of ASRC processing clock ). When this bit is 0, the user
 * is responsible for choosing the proper processing options for pair A. This
 * bit should be disabled when {USRA, IDRA}={1,1}.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ATSA  (20U)         /*!< Bit position for ASRC_ASRCTR_ATSA. */
#define BM_ASRC_ASRCTR_ATSA  (0x00100000U) /*!< Bit mask for ASRC_ASRCTR_ATSA. */
#define BS_ASRC_ASRCTR_ATSA  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ATSA. */

/*! @brief Read current value of the ASRC_ASRCTR_ATSA field. */
#define BR_ASRC_ASRCTR_ATSA(x) (HW_ASRC_ASRCTR(x).B.ATSA)

/*! @brief Format value for bitfield ASRC_ASRCTR_ATSA. */
#define BF_ASRC_ASRCTR_ATSA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ATSA) & BM_ASRC_ASRCTR_ATSA)

/*! @brief Set the ATSA field to a new value. */
#define BW_ASRC_ASRCTR_ATSA(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ATSA) | BF_ASRC_ASRCTR_ATSA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ATSB[21] (RW)
 *
 * ASRC Pair B Automatic Selection For Processing Options When this bit is 1,
 * pair B will automatic update its pre-processing and post-processing options
 * (ASRCFG: PREMODB, ASRCFG:POSTMODB see ASRC Misc Control Register 1 for Pair CASRC
 * Filter Configuration Status Register ) based on the frequencies it detected.
 * To use this option, the two parameter registers(ASR76K and ASR56K) should be
 * set correctly (see ASRC Misc Control Register 1 for Pair CASRC 76kHz Period in
 * terms of ASRC processing clock and ASRC Misc Control Register 1 for Pair CASRC
 * 56kHz Period in terms of ASRC processing clock ). When this bit is 0, the user
 * is responsible for choosing the proper processing options for pair B. This
 * bit should be disabled when {USRB, IDRB}={1,1}.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ATSB  (21U)         /*!< Bit position for ASRC_ASRCTR_ATSB. */
#define BM_ASRC_ASRCTR_ATSB  (0x00200000U) /*!< Bit mask for ASRC_ASRCTR_ATSB. */
#define BS_ASRC_ASRCTR_ATSB  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ATSB. */

/*! @brief Read current value of the ASRC_ASRCTR_ATSB field. */
#define BR_ASRC_ASRCTR_ATSB(x) (HW_ASRC_ASRCTR(x).B.ATSB)

/*! @brief Format value for bitfield ASRC_ASRCTR_ATSB. */
#define BF_ASRC_ASRCTR_ATSB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ATSB) & BM_ASRC_ASRCTR_ATSB)

/*! @brief Set the ATSB field to a new value. */
#define BW_ASRC_ASRCTR_ATSB(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ATSB) | BF_ASRC_ASRCTR_ATSB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCTR, field ATSC[22] (RW)
 *
 * ASRC Pair C Automatic Selection For Processing Options When this bit is 1,
 * pair C will automatic update its pre-processing and post-processing options
 * (ASRCFG: PREMODC, ASRCFG:POSTMODC see ASRC Misc Control Register 1 for Pair CASRC
 * Filter Configuration Status Register ) based on the frequencies it detected.
 * To use this option, the two parameter registers(ASR76K and ASR56K) should be
 * set correctly (see ASRC Misc Control Register 1 for Pair CASRC 76kHz Period in
 * terms of ASRC processing clock and ASRC Misc Control Register 1 for Pair CASRC
 * 56kHz Period in terms of ASRC processing clock ). When this bit is 0, the user
 * is responsible for choosing the proper processing options for pair C. This
 * bit should be disabled when {USRC, IDRC}={1,1}.
 */
/*@{*/
#define BP_ASRC_ASRCTR_ATSC  (22U)         /*!< Bit position for ASRC_ASRCTR_ATSC. */
#define BM_ASRC_ASRCTR_ATSC  (0x00400000U) /*!< Bit mask for ASRC_ASRCTR_ATSC. */
#define BS_ASRC_ASRCTR_ATSC  (1U)          /*!< Bit field size in bits for ASRC_ASRCTR_ATSC. */

/*! @brief Read current value of the ASRC_ASRCTR_ATSC field. */
#define BR_ASRC_ASRCTR_ATSC(x) (HW_ASRC_ASRCTR(x).B.ATSC)

/*! @brief Format value for bitfield ASRC_ASRCTR_ATSC. */
#define BF_ASRC_ASRCTR_ATSC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCTR_ATSC) & BM_ASRC_ASRCTR_ATSC)

/*! @brief Set the ATSC field to a new value. */
#define BW_ASRC_ASRCTR_ATSC(x, v) (HW_ASRC_ASRCTR_WR(x, (HW_ASRC_ASRCTR_RD(x) & ~BM_ASRC_ASRCTR_ATSC) | BF_ASRC_ASRCTR_ATSC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIER - ASRC Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIER - ASRC Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_asrc_asrier
{
    uint32_t U;
    struct _hw_asrc_asrier_bitfields
    {
        uint32_t ADIEA : 1;            /*!< [0]  */
        uint32_t ADIEB : 1;            /*!< [1]  */
        uint32_t ADIEC : 1;            /*!< [2]  */
        uint32_t ADOEA : 1;            /*!< [3]  */
        uint32_t ADOEB : 1;            /*!< [4]  */
        uint32_t ADOEC : 1;            /*!< [5]  */
        uint32_t AOLIE : 1;            /*!< [6]  */
        uint32_t AFPWE : 1;            /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrier_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIER register
 */
/*@{*/
#define HW_ASRC_ASRIER_ADDR(x)   ((uintptr_t)(x) + 0x4U)

#define HW_ASRC_ASRIER(x)        (*(__IO hw_asrc_asrier_t *) HW_ASRC_ASRIER_ADDR(x))
#define HW_ASRC_ASRIER_RD(x)     (HW_ASRC_ASRIER(x).U)
#define HW_ASRC_ASRIER_WR(x, v)  (HW_ASRC_ASRIER(x).U = (v))
#define HW_ASRC_ASRIER_SET(x, v) (HW_ASRC_ASRIER_WR(x, HW_ASRC_ASRIER_RD(x) |  (v)))
#define HW_ASRC_ASRIER_CLR(x, v) (HW_ASRC_ASRIER_WR(x, HW_ASRC_ASRIER_RD(x) & ~(v)))
#define HW_ASRC_ASRIER_TOG(x, v) (HW_ASRC_ASRIER_WR(x, HW_ASRC_ASRIER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIER bitfields
 */

/*!
 * @name Register ASRC_ASRIER, field ADIEA[0] (RW)
 *
 * Data Input A Interrupt Enable Enables the data input A Interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADIEA (0U)          /*!< Bit position for ASRC_ASRIER_ADIEA. */
#define BM_ASRC_ASRIER_ADIEA (0x00000001U) /*!< Bit mask for ASRC_ASRIER_ADIEA. */
#define BS_ASRC_ASRIER_ADIEA (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADIEA. */

/*! @brief Read current value of the ASRC_ASRIER_ADIEA field. */
#define BR_ASRC_ASRIER_ADIEA(x) (HW_ASRC_ASRIER(x).B.ADIEA)

/*! @brief Format value for bitfield ASRC_ASRIER_ADIEA. */
#define BF_ASRC_ASRIER_ADIEA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADIEA) & BM_ASRC_ASRIER_ADIEA)

/*! @brief Set the ADIEA field to a new value. */
#define BW_ASRC_ASRIER_ADIEA(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADIEA) | BF_ASRC_ASRIER_ADIEA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field ADIEB[1] (RW)
 *
 * Data Input B Interrupt Enable Enables the data input B interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADIEB (1U)          /*!< Bit position for ASRC_ASRIER_ADIEB. */
#define BM_ASRC_ASRIER_ADIEB (0x00000002U) /*!< Bit mask for ASRC_ASRIER_ADIEB. */
#define BS_ASRC_ASRIER_ADIEB (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADIEB. */

/*! @brief Read current value of the ASRC_ASRIER_ADIEB field. */
#define BR_ASRC_ASRIER_ADIEB(x) (HW_ASRC_ASRIER(x).B.ADIEB)

/*! @brief Format value for bitfield ASRC_ASRIER_ADIEB. */
#define BF_ASRC_ASRIER_ADIEB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADIEB) & BM_ASRC_ASRIER_ADIEB)

/*! @brief Set the ADIEB field to a new value. */
#define BW_ASRC_ASRIER_ADIEB(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADIEB) | BF_ASRC_ASRIER_ADIEB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field ADIEC[2] (RW)
 *
 * Data Input C Interrupt Enable Enables the data input C interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADIEC (2U)          /*!< Bit position for ASRC_ASRIER_ADIEC. */
#define BM_ASRC_ASRIER_ADIEC (0x00000004U) /*!< Bit mask for ASRC_ASRIER_ADIEC. */
#define BS_ASRC_ASRIER_ADIEC (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADIEC. */

/*! @brief Read current value of the ASRC_ASRIER_ADIEC field. */
#define BR_ASRC_ASRIER_ADIEC(x) (HW_ASRC_ASRIER(x).B.ADIEC)

/*! @brief Format value for bitfield ASRC_ASRIER_ADIEC. */
#define BF_ASRC_ASRIER_ADIEC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADIEC) & BM_ASRC_ASRIER_ADIEC)

/*! @brief Set the ADIEC field to a new value. */
#define BW_ASRC_ASRIER_ADIEC(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADIEC) | BF_ASRC_ASRIER_ADIEC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field ADOEA[3] (RW)
 *
 * Data Output A Interrupt Enable Enables the data output A interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADOEA (3U)          /*!< Bit position for ASRC_ASRIER_ADOEA. */
#define BM_ASRC_ASRIER_ADOEA (0x00000008U) /*!< Bit mask for ASRC_ASRIER_ADOEA. */
#define BS_ASRC_ASRIER_ADOEA (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADOEA. */

/*! @brief Read current value of the ASRC_ASRIER_ADOEA field. */
#define BR_ASRC_ASRIER_ADOEA(x) (HW_ASRC_ASRIER(x).B.ADOEA)

/*! @brief Format value for bitfield ASRC_ASRIER_ADOEA. */
#define BF_ASRC_ASRIER_ADOEA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADOEA) & BM_ASRC_ASRIER_ADOEA)

/*! @brief Set the ADOEA field to a new value. */
#define BW_ASRC_ASRIER_ADOEA(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADOEA) | BF_ASRC_ASRIER_ADOEA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field ADOEB[4] (RW)
 *
 * Data Output B Interrupt Enable Enables the data output B interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADOEB (4U)          /*!< Bit position for ASRC_ASRIER_ADOEB. */
#define BM_ASRC_ASRIER_ADOEB (0x00000010U) /*!< Bit mask for ASRC_ASRIER_ADOEB. */
#define BS_ASRC_ASRIER_ADOEB (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADOEB. */

/*! @brief Read current value of the ASRC_ASRIER_ADOEB field. */
#define BR_ASRC_ASRIER_ADOEB(x) (HW_ASRC_ASRIER(x).B.ADOEB)

/*! @brief Format value for bitfield ASRC_ASRIER_ADOEB. */
#define BF_ASRC_ASRIER_ADOEB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADOEB) & BM_ASRC_ASRIER_ADOEB)

/*! @brief Set the ADOEB field to a new value. */
#define BW_ASRC_ASRIER_ADOEB(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADOEB) | BF_ASRC_ASRIER_ADOEB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field ADOEC[5] (RW)
 *
 * Data Output C Interrupt Enable Enables the data output C interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_ADOEC (5U)          /*!< Bit position for ASRC_ASRIER_ADOEC. */
#define BM_ASRC_ASRIER_ADOEC (0x00000020U) /*!< Bit mask for ASRC_ASRIER_ADOEC. */
#define BS_ASRC_ASRIER_ADOEC (1U)          /*!< Bit field size in bits for ASRC_ASRIER_ADOEC. */

/*! @brief Read current value of the ASRC_ASRIER_ADOEC field. */
#define BR_ASRC_ASRIER_ADOEC(x) (HW_ASRC_ASRIER(x).B.ADOEC)

/*! @brief Format value for bitfield ASRC_ASRIER_ADOEC. */
#define BF_ASRC_ASRIER_ADOEC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_ADOEC) & BM_ASRC_ASRIER_ADOEC)

/*! @brief Set the ADOEC field to a new value. */
#define BW_ASRC_ASRIER_ADOEC(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_ADOEC) | BF_ASRC_ASRIER_ADOEC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field AOLIE[6] (RW)
 *
 * Overload Interrupt Enable Enables the overload interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_AOLIE (6U)          /*!< Bit position for ASRC_ASRIER_AOLIE. */
#define BM_ASRC_ASRIER_AOLIE (0x00000040U) /*!< Bit mask for ASRC_ASRIER_AOLIE. */
#define BS_ASRC_ASRIER_AOLIE (1U)          /*!< Bit field size in bits for ASRC_ASRIER_AOLIE. */

/*! @brief Read current value of the ASRC_ASRIER_AOLIE field. */
#define BR_ASRC_ASRIER_AOLIE(x) (HW_ASRC_ASRIER(x).B.AOLIE)

/*! @brief Format value for bitfield ASRC_ASRIER_AOLIE. */
#define BF_ASRC_ASRIER_AOLIE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_AOLIE) & BM_ASRC_ASRIER_AOLIE)

/*! @brief Set the AOLIE field to a new value. */
#define BW_ASRC_ASRIER_AOLIE(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_AOLIE) | BF_ASRC_ASRIER_AOLIE(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRIER, field AFPWE[7] (RW)
 *
 * FP in Wait State Interrupt Enable Enables the FP in wait state interrupt.
 *
 * Values:
 * - 1 - interrupt enabled
 * - 0 - interrupt disabled
 */
/*@{*/
#define BP_ASRC_ASRIER_AFPWE (7U)          /*!< Bit position for ASRC_ASRIER_AFPWE. */
#define BM_ASRC_ASRIER_AFPWE (0x00000080U) /*!< Bit mask for ASRC_ASRIER_AFPWE. */
#define BS_ASRC_ASRIER_AFPWE (1U)          /*!< Bit field size in bits for ASRC_ASRIER_AFPWE. */

/*! @brief Read current value of the ASRC_ASRIER_AFPWE field. */
#define BR_ASRC_ASRIER_AFPWE(x) (HW_ASRC_ASRIER(x).B.AFPWE)

/*! @brief Format value for bitfield ASRC_ASRIER_AFPWE. */
#define BF_ASRC_ASRIER_AFPWE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIER_AFPWE) & BM_ASRC_ASRIER_AFPWE)

/*! @brief Set the AFPWE field to a new value. */
#define BW_ASRC_ASRIER_AFPWE(x, v) (HW_ASRC_ASRIER_WR(x, (HW_ASRC_ASRIER_RD(x) & ~BM_ASRC_ASRIER_AFPWE) | BF_ASRC_ASRIER_AFPWE(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCNCR - ASRC Channel Number Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCNCR - ASRC Channel Number Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC channel number configuration register (ASRCNCR) is a 24-bit
 * read/write register that sets the number of channels used by each ASRC conversion
 * pair. There are 10 channels available for distribution among 3 conversion pairs,
 * they are ordered as 0,1,...,9. The bottom [0, ANCA-1] channels are used for
 * pair A, the top [10-ANCC, 9] channels are used for pair C, and the [ANCA,
 * ANCA+ANCB-1] channels are allocated for pair B. In case that ANCA=0, then the [0,
 * ANCB-1] channels are assigned for pair B.
 */
typedef union _hw_asrc_asrcncr
{
    uint32_t U;
    struct _hw_asrc_asrcncr_bitfields
    {
        uint32_t ANCA : 4;             /*!< [3:0]  */
        uint32_t ANCB : 4;             /*!< [7:4]  */
        uint32_t ANCC : 4;             /*!< [11:8]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrcncr_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCNCR register
 */
/*@{*/
#define HW_ASRC_ASRCNCR_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_ASRC_ASRCNCR(x)       (*(__IO hw_asrc_asrcncr_t *) HW_ASRC_ASRCNCR_ADDR(x))
#define HW_ASRC_ASRCNCR_RD(x)    (HW_ASRC_ASRCNCR(x).U)
#define HW_ASRC_ASRCNCR_WR(x, v) (HW_ASRC_ASRCNCR(x).U = (v))
#define HW_ASRC_ASRCNCR_SET(x, v) (HW_ASRC_ASRCNCR_WR(x, HW_ASRC_ASRCNCR_RD(x) |  (v)))
#define HW_ASRC_ASRCNCR_CLR(x, v) (HW_ASRC_ASRCNCR_WR(x, HW_ASRC_ASRCNCR_RD(x) & ~(v)))
#define HW_ASRC_ASRCNCR_TOG(x, v) (HW_ASRC_ASRCNCR_WR(x, HW_ASRC_ASRCNCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCNCR bitfields
 */

/*!
 * @name Register ASRC_ASRCNCR, field ANCA[3:0] (RW)
 *
 * Number of A Channels
 *
 * Values:
 * - 0000 - 0 channels in A (Pair A is disabled)
 * - 0001 - 1 channel in A
 * - 0010 - 2 channels in A
 * - 0011 - 3 channels in A
 * - 0100 - 4 channels in A
 * - 0101 - 5 channels in A
 * - 0110 - 6 channels in A
 * - 0111 - 7 channels in A
 * - 1000 - 8 channels in A
 * - 1001 - 9 channels in A
 * - 1010 - 10 channels in A
 */
/*@{*/
#define BP_ASRC_ASRCNCR_ANCA (0U)          /*!< Bit position for ASRC_ASRCNCR_ANCA. */
#define BM_ASRC_ASRCNCR_ANCA (0x0000000FU) /*!< Bit mask for ASRC_ASRCNCR_ANCA. */
#define BS_ASRC_ASRCNCR_ANCA (4U)          /*!< Bit field size in bits for ASRC_ASRCNCR_ANCA. */

/*! @brief Read current value of the ASRC_ASRCNCR_ANCA field. */
#define BR_ASRC_ASRCNCR_ANCA(x) (HW_ASRC_ASRCNCR(x).B.ANCA)

/*! @brief Format value for bitfield ASRC_ASRCNCR_ANCA. */
#define BF_ASRC_ASRCNCR_ANCA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCNCR_ANCA) & BM_ASRC_ASRCNCR_ANCA)

/*! @brief Set the ANCA field to a new value. */
#define BW_ASRC_ASRCNCR_ANCA(x, v) (HW_ASRC_ASRCNCR_WR(x, (HW_ASRC_ASRCNCR_RD(x) & ~BM_ASRC_ASRCNCR_ANCA) | BF_ASRC_ASRCNCR_ANCA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCNCR, field ANCB[7:4] (RW)
 *
 * Number of B Channels
 *
 * Values:
 * - 0000 - 0 channels in B (Pair B is disabled)
 * - 0001 - 1 channel in B
 * - 0010 - 2 channels in B
 * - 0011 - 3 channels in B
 * - 0100 - 4 channels in B
 * - 0101 - 5 channels in B
 * - 0110 - 6 channels in B
 * - 0111 - 7 channels in B
 * - 1000 - 8 channels in B
 * - 1001 - 9 channels in B
 * - 1010 - 10 channels in B
 */
/*@{*/
#define BP_ASRC_ASRCNCR_ANCB (4U)          /*!< Bit position for ASRC_ASRCNCR_ANCB. */
#define BM_ASRC_ASRCNCR_ANCB (0x000000F0U) /*!< Bit mask for ASRC_ASRCNCR_ANCB. */
#define BS_ASRC_ASRCNCR_ANCB (4U)          /*!< Bit field size in bits for ASRC_ASRCNCR_ANCB. */

/*! @brief Read current value of the ASRC_ASRCNCR_ANCB field. */
#define BR_ASRC_ASRCNCR_ANCB(x) (HW_ASRC_ASRCNCR(x).B.ANCB)

/*! @brief Format value for bitfield ASRC_ASRCNCR_ANCB. */
#define BF_ASRC_ASRCNCR_ANCB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCNCR_ANCB) & BM_ASRC_ASRCNCR_ANCB)

/*! @brief Set the ANCB field to a new value. */
#define BW_ASRC_ASRCNCR_ANCB(x, v) (HW_ASRC_ASRCNCR_WR(x, (HW_ASRC_ASRCNCR_RD(x) & ~BM_ASRC_ASRCNCR_ANCB) | BF_ASRC_ASRCNCR_ANCB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCNCR, field ANCC[11:8] (RW)
 *
 * Number of C ChannelsANCC+ANCB+ANCA<=10. Hardware is not checking the
 * constraint. Programmer should take the responsibility to ensure the constraint is
 * satisfied.
 *
 * Values:
 * - 0000 - 0 channels in C (Pair C is disabled)
 * - 0001 - 1 channel in C
 * - 0010 - 2 channels in C
 * - 0011 - 3 channels in C
 * - 0100 - 4 channels in C
 * - 0101 - 5 channels in C
 * - 0110 - 6 channels in C
 * - 0111 - 7 channels in C
 * - 1000 - 8 channels in C
 * - 1001 - 9 channels in C
 * - 1010 - 10 channels in C
 */
/*@{*/
#define BP_ASRC_ASRCNCR_ANCC (8U)          /*!< Bit position for ASRC_ASRCNCR_ANCC. */
#define BM_ASRC_ASRCNCR_ANCC (0x00000F00U) /*!< Bit mask for ASRC_ASRCNCR_ANCC. */
#define BS_ASRC_ASRCNCR_ANCC (4U)          /*!< Bit field size in bits for ASRC_ASRCNCR_ANCC. */

/*! @brief Read current value of the ASRC_ASRCNCR_ANCC field. */
#define BR_ASRC_ASRCNCR_ANCC(x) (HW_ASRC_ASRCNCR(x).B.ANCC)

/*! @brief Format value for bitfield ASRC_ASRCNCR_ANCC. */
#define BF_ASRC_ASRCNCR_ANCC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCNCR_ANCC) & BM_ASRC_ASRCNCR_ANCC)

/*! @brief Set the ANCC field to a new value. */
#define BW_ASRC_ASRCNCR_ANCC(x, v) (HW_ASRC_ASRCNCR_WR(x, (HW_ASRC_ASRCNCR_RD(x) & ~BM_ASRC_ASRCNCR_ANCC) | BF_ASRC_ASRCNCR_ANCC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCFG - ASRC Filter Configuration Status Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCFG - ASRC Filter Configuration Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC configuration status register (ASRCFG) is a 24-bit read/write
 * register that sets and/or automatically senses the ASRC operations.
 */
typedef union _hw_asrc_asrcfg
{
    uint32_t U;
    struct _hw_asrc_asrcfg_bitfields
    {
        uint32_t RESERVED0 : 6;        /*!< [5:0]  */
        uint32_t PREMODA : 2;          /*!< [7:6]  */
        uint32_t POSTMODA : 2;         /*!< [9:8]  */
        uint32_t PREMODB : 2;          /*!< [11:10]  */
        uint32_t POSTMODB : 2;         /*!< [13:12]  */
        uint32_t PREMODC : 2;          /*!< [15:14]  */
        uint32_t POSTMODC : 2;         /*!< [17:16]  */
        uint32_t NDPRA : 1;            /*!< [18]  */
        uint32_t NDPRB : 1;            /*!< [19]  */
        uint32_t NDPRC : 1;            /*!< [20]  */
        uint32_t INIRQA : 1;           /*!< [21]  */
        uint32_t INIRQB : 1;           /*!< [22]  */
        uint32_t INIRQC : 1;           /*!< [23]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrcfg_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCFG register
 */
/*@{*/
#define HW_ASRC_ASRCFG_ADDR(x)   ((uintptr_t)(x) + 0x10U)

#define HW_ASRC_ASRCFG(x)        (*(__IO hw_asrc_asrcfg_t *) HW_ASRC_ASRCFG_ADDR(x))
#define HW_ASRC_ASRCFG_RD(x)     (HW_ASRC_ASRCFG(x).U)
#define HW_ASRC_ASRCFG_WR(x, v)  (HW_ASRC_ASRCFG(x).U = (v))
#define HW_ASRC_ASRCFG_SET(x, v) (HW_ASRC_ASRCFG_WR(x, HW_ASRC_ASRCFG_RD(x) |  (v)))
#define HW_ASRC_ASRCFG_CLR(x, v) (HW_ASRC_ASRCFG_WR(x, HW_ASRC_ASRCFG_RD(x) & ~(v)))
#define HW_ASRC_ASRCFG_TOG(x, v) (HW_ASRC_ASRCFG_WR(x, HW_ASRC_ASRCFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCFG bitfields
 */

/*!
 * @name Register ASRC_ASRCFG, field PREMODA[7:6] (RW)
 *
 * Pre-Processing Configuration for Conversion Pair A These bits will be
 * read/write by user if ASRCTR:ATSA=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSA=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the pre-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal processing flowBy flowing
 *     through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 01 - Select Direct-Connection as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 10 - Select Downsampling-by-2 as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 11 - Select passthrough mode. In this case, POSTMODA[1-0] have no use.
 */
/*@{*/
#define BP_ASRC_ASRCFG_PREMODA (6U)        /*!< Bit position for ASRC_ASRCFG_PREMODA. */
#define BM_ASRC_ASRCFG_PREMODA (0x000000C0U) /*!< Bit mask for ASRC_ASRCFG_PREMODA. */
#define BS_ASRC_ASRCFG_PREMODA (2U)        /*!< Bit field size in bits for ASRC_ASRCFG_PREMODA. */

/*! @brief Read current value of the ASRC_ASRCFG_PREMODA field. */
#define BR_ASRC_ASRCFG_PREMODA(x) (HW_ASRC_ASRCFG(x).B.PREMODA)

/*! @brief Format value for bitfield ASRC_ASRCFG_PREMODA. */
#define BF_ASRC_ASRCFG_PREMODA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_PREMODA) & BM_ASRC_ASRCFG_PREMODA)

/*! @brief Set the PREMODA field to a new value. */
#define BW_ASRC_ASRCFG_PREMODA(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_PREMODA) | BF_ASRC_ASRCFG_PREMODA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field POSTMODA[9:8] (RW)
 *
 * Post-Processing Configuration for Conversion Pair A These bits will be
 * read/write by user if ASRCTR:ATSA=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSA=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the post-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal processing flowBy flowing
 *     through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 01 - Select Direct-Connection as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 10 - Select Downsampling-by-2 as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 */
/*@{*/
#define BP_ASRC_ASRCFG_POSTMODA (8U)       /*!< Bit position for ASRC_ASRCFG_POSTMODA. */
#define BM_ASRC_ASRCFG_POSTMODA (0x00000300U) /*!< Bit mask for ASRC_ASRCFG_POSTMODA. */
#define BS_ASRC_ASRCFG_POSTMODA (2U)       /*!< Bit field size in bits for ASRC_ASRCFG_POSTMODA. */

/*! @brief Read current value of the ASRC_ASRCFG_POSTMODA field. */
#define BR_ASRC_ASRCFG_POSTMODA(x) (HW_ASRC_ASRCFG(x).B.POSTMODA)

/*! @brief Format value for bitfield ASRC_ASRCFG_POSTMODA. */
#define BF_ASRC_ASRCFG_POSTMODA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_POSTMODA) & BM_ASRC_ASRCFG_POSTMODA)

/*! @brief Set the POSTMODA field to a new value. */
#define BW_ASRC_ASRCFG_POSTMODA(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_POSTMODA) | BF_ASRC_ASRCFG_POSTMODA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field PREMODB[11:10] (RW)
 *
 * Pre-Processing Configuration for Conversion Pair B These bits will be
 * read/write by user if ASRCTR:ATSB=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSB=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the pre-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal processing flowBy flowing
 *     through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 01 - Select Direct-Connection as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 10 - Select Downsampling-by-2 as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 11 - Select passthrough mode. In this case, POSTMODB[1-0] have no use.
 */
/*@{*/
#define BP_ASRC_ASRCFG_PREMODB (10U)       /*!< Bit position for ASRC_ASRCFG_PREMODB. */
#define BM_ASRC_ASRCFG_PREMODB (0x00000C00U) /*!< Bit mask for ASRC_ASRCFG_PREMODB. */
#define BS_ASRC_ASRCFG_PREMODB (2U)        /*!< Bit field size in bits for ASRC_ASRCFG_PREMODB. */

/*! @brief Read current value of the ASRC_ASRCFG_PREMODB field. */
#define BR_ASRC_ASRCFG_PREMODB(x) (HW_ASRC_ASRCFG(x).B.PREMODB)

/*! @brief Format value for bitfield ASRC_ASRCFG_PREMODB. */
#define BF_ASRC_ASRCFG_PREMODB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_PREMODB) & BM_ASRC_ASRCFG_PREMODB)

/*! @brief Set the PREMODB field to a new value. */
#define BW_ASRC_ASRCFG_PREMODB(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_PREMODB) | BF_ASRC_ASRCFG_PREMODB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field POSTMODB[13:12] (RW)
 *
 * Post-Processing Configuration for Conversion Pair B These bits will be
 * read/write by user if ASRCTR:ATSB=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSB=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the post-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal processing flowBy flowing
 *     through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 01 - Select Direct-Connection as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 10 - Select Downsampling-by-2 as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 */
/*@{*/
#define BP_ASRC_ASRCFG_POSTMODB (12U)      /*!< Bit position for ASRC_ASRCFG_POSTMODB. */
#define BM_ASRC_ASRCFG_POSTMODB (0x00003000U) /*!< Bit mask for ASRC_ASRCFG_POSTMODB. */
#define BS_ASRC_ASRCFG_POSTMODB (2U)       /*!< Bit field size in bits for ASRC_ASRCFG_POSTMODB. */

/*! @brief Read current value of the ASRC_ASRCFG_POSTMODB field. */
#define BR_ASRC_ASRCFG_POSTMODB(x) (HW_ASRC_ASRCFG(x).B.POSTMODB)

/*! @brief Format value for bitfield ASRC_ASRCFG_POSTMODB. */
#define BF_ASRC_ASRCFG_POSTMODB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_POSTMODB) & BM_ASRC_ASRCFG_POSTMODB)

/*! @brief Set the POSTMODB field to a new value. */
#define BW_ASRC_ASRCFG_POSTMODB(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_POSTMODB) | BF_ASRC_ASRCFG_POSTMODB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field PREMODC[15:14] (RW)
 *
 * Pre-Processing Configuration for Conversion Pair C These bits will be
 * read/write by user if ASRCTR:ATSC=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSC=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the pre-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal processing flowBy flowing
 *     through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 01 - Select Direct-Connection as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 10 - Select Downsampling-by-2 as defined in Signal processing flowBy
 *     flowing through different processing branches and different setups of the
 *     pre-filter, this ASRC scheme can be used to handle different rate conversion
 *     requirements.
 * - 11 - Select passthrough mode. In this case, POSTMODC[1-0] have no use.
 */
/*@{*/
#define BP_ASRC_ASRCFG_PREMODC (14U)       /*!< Bit position for ASRC_ASRCFG_PREMODC. */
#define BM_ASRC_ASRCFG_PREMODC (0x0000C000U) /*!< Bit mask for ASRC_ASRCFG_PREMODC. */
#define BS_ASRC_ASRCFG_PREMODC (2U)        /*!< Bit field size in bits for ASRC_ASRCFG_PREMODC. */

/*! @brief Read current value of the ASRC_ASRCFG_PREMODC field. */
#define BR_ASRC_ASRCFG_PREMODC(x) (HW_ASRC_ASRCFG(x).B.PREMODC)

/*! @brief Format value for bitfield ASRC_ASRCFG_PREMODC. */
#define BF_ASRC_ASRCFG_PREMODC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_PREMODC) & BM_ASRC_ASRCFG_PREMODC)

/*! @brief Set the PREMODC field to a new value. */
#define BW_ASRC_ASRCFG_PREMODC(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_PREMODC) | BF_ASRC_ASRCFG_PREMODC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field POSTMODC[17:16] (RW)
 *
 * Post-Processing Configuration for Conversion Pair C These bits will be
 * read/write by user if ASRCTR:ATSC=0, and can also be automatically updated by the
 * ASRC internal logic if ASRCTR:ATSC=1 (see ASRC Misc Control Register 1 for Pair
 * CASRC Control Register ). These bits set the selection of the post-processing
 * configuration.
 *
 * Values:
 * - 00 - Select Upsampling-by-2 as defined in Signal Processing Flow.
 * - 01 - Select Direct-Connection as defined in Signal Processing Flow.
 * - 10 - Select Downsampling-by-2 as defined in Signal Processing Flow.
 */
/*@{*/
#define BP_ASRC_ASRCFG_POSTMODC (16U)      /*!< Bit position for ASRC_ASRCFG_POSTMODC. */
#define BM_ASRC_ASRCFG_POSTMODC (0x00030000U) /*!< Bit mask for ASRC_ASRCFG_POSTMODC. */
#define BS_ASRC_ASRCFG_POSTMODC (2U)       /*!< Bit field size in bits for ASRC_ASRCFG_POSTMODC. */

/*! @brief Read current value of the ASRC_ASRCFG_POSTMODC field. */
#define BR_ASRC_ASRCFG_POSTMODC(x) (HW_ASRC_ASRCFG(x).B.POSTMODC)

/*! @brief Format value for bitfield ASRC_ASRCFG_POSTMODC. */
#define BF_ASRC_ASRCFG_POSTMODC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_POSTMODC) & BM_ASRC_ASRCFG_POSTMODC)

/*! @brief Set the POSTMODC field to a new value. */
#define BW_ASRC_ASRCFG_POSTMODC(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_POSTMODC) | BF_ASRC_ASRCFG_POSTMODC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field NDPRA[18] (RW)
 *
 * Not Use Default Parameters for RAM-stored Parameters For Conversion Pair A
 *
 * Values:
 * - 0 - Use default parameters for RAM-stored parameters. Override any
 *     parameters already in RAM.
 * - 1 - Don't use default parameters for RAM-stored parameters. Use the
 *     parameters already stored in RAM.
 */
/*@{*/
#define BP_ASRC_ASRCFG_NDPRA (18U)         /*!< Bit position for ASRC_ASRCFG_NDPRA. */
#define BM_ASRC_ASRCFG_NDPRA (0x00040000U) /*!< Bit mask for ASRC_ASRCFG_NDPRA. */
#define BS_ASRC_ASRCFG_NDPRA (1U)          /*!< Bit field size in bits for ASRC_ASRCFG_NDPRA. */

/*! @brief Read current value of the ASRC_ASRCFG_NDPRA field. */
#define BR_ASRC_ASRCFG_NDPRA(x) (HW_ASRC_ASRCFG(x).B.NDPRA)

/*! @brief Format value for bitfield ASRC_ASRCFG_NDPRA. */
#define BF_ASRC_ASRCFG_NDPRA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_NDPRA) & BM_ASRC_ASRCFG_NDPRA)

/*! @brief Set the NDPRA field to a new value. */
#define BW_ASRC_ASRCFG_NDPRA(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_NDPRA) | BF_ASRC_ASRCFG_NDPRA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field NDPRB[19] (RW)
 *
 * Not Use Default Parameters for RAM-stored Parameters For Conversion Pair B
 *
 * Values:
 * - 0 - Use default parameters for RAM-stored parameters. Override any
 *     parameters already in RAM.
 * - 1 - Don't use default parameters for RAM-stored parameter. Use the
 *     parameters already stored in RAM.
 */
/*@{*/
#define BP_ASRC_ASRCFG_NDPRB (19U)         /*!< Bit position for ASRC_ASRCFG_NDPRB. */
#define BM_ASRC_ASRCFG_NDPRB (0x00080000U) /*!< Bit mask for ASRC_ASRCFG_NDPRB. */
#define BS_ASRC_ASRCFG_NDPRB (1U)          /*!< Bit field size in bits for ASRC_ASRCFG_NDPRB. */

/*! @brief Read current value of the ASRC_ASRCFG_NDPRB field. */
#define BR_ASRC_ASRCFG_NDPRB(x) (HW_ASRC_ASRCFG(x).B.NDPRB)

/*! @brief Format value for bitfield ASRC_ASRCFG_NDPRB. */
#define BF_ASRC_ASRCFG_NDPRB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_NDPRB) & BM_ASRC_ASRCFG_NDPRB)

/*! @brief Set the NDPRB field to a new value. */
#define BW_ASRC_ASRCFG_NDPRB(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_NDPRB) | BF_ASRC_ASRCFG_NDPRB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field NDPRC[20] (RW)
 *
 * Not Use Default Parameters for RAM-stored Parameters For Conversion Pair C
 *
 * Values:
 * - 0 - Use default parameters for RAM-stored parameters. Override any
 *     parameters already in RAM.
 * - 1 - Don't use default parameters for RAM-stored parameters. Use the
 *     parameters already stored in RAM.
 */
/*@{*/
#define BP_ASRC_ASRCFG_NDPRC (20U)         /*!< Bit position for ASRC_ASRCFG_NDPRC. */
#define BM_ASRC_ASRCFG_NDPRC (0x00100000U) /*!< Bit mask for ASRC_ASRCFG_NDPRC. */
#define BS_ASRC_ASRCFG_NDPRC (1U)          /*!< Bit field size in bits for ASRC_ASRCFG_NDPRC. */

/*! @brief Read current value of the ASRC_ASRCFG_NDPRC field. */
#define BR_ASRC_ASRCFG_NDPRC(x) (HW_ASRC_ASRCFG(x).B.NDPRC)

/*! @brief Format value for bitfield ASRC_ASRCFG_NDPRC. */
#define BF_ASRC_ASRCFG_NDPRC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCFG_NDPRC) & BM_ASRC_ASRCFG_NDPRC)

/*! @brief Set the NDPRC field to a new value. */
#define BW_ASRC_ASRCFG_NDPRC(x, v) (HW_ASRC_ASRCFG_WR(x, (HW_ASRC_ASRCFG_RD(x) & ~BM_ASRC_ASRCFG_NDPRC) | BF_ASRC_ASRCFG_NDPRC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field INIRQA[21] (RO)
 *
 * Initialization for Conversion Pair A is served When this bit is 1, it means
 * the initialization for conversion pair A is served. This bit is cleared by
 * disabling the ASRC conversion pair (ASRCTR:ASREA=0 or ASRCTR:ASRCEN=0).
 */
/*@{*/
#define BP_ASRC_ASRCFG_INIRQA (21U)        /*!< Bit position for ASRC_ASRCFG_INIRQA. */
#define BM_ASRC_ASRCFG_INIRQA (0x00200000U) /*!< Bit mask for ASRC_ASRCFG_INIRQA. */
#define BS_ASRC_ASRCFG_INIRQA (1U)         /*!< Bit field size in bits for ASRC_ASRCFG_INIRQA. */

/*! @brief Read current value of the ASRC_ASRCFG_INIRQA field. */
#define BR_ASRC_ASRCFG_INIRQA(x) (HW_ASRC_ASRCFG(x).B.INIRQA)
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field INIRQB[22] (RO)
 *
 * Initialization for Conversion Pair B is served When this bit is 1, it means
 * the initialization for conversion pair B is served. This bit is cleared by
 * disabling the ASRC conversion pair (ASRCTR:ASREB=0 or ASRCTR:ASRCEN=0).
 */
/*@{*/
#define BP_ASRC_ASRCFG_INIRQB (22U)        /*!< Bit position for ASRC_ASRCFG_INIRQB. */
#define BM_ASRC_ASRCFG_INIRQB (0x00400000U) /*!< Bit mask for ASRC_ASRCFG_INIRQB. */
#define BS_ASRC_ASRCFG_INIRQB (1U)         /*!< Bit field size in bits for ASRC_ASRCFG_INIRQB. */

/*! @brief Read current value of the ASRC_ASRCFG_INIRQB field. */
#define BR_ASRC_ASRCFG_INIRQB(x) (HW_ASRC_ASRCFG(x).B.INIRQB)
/*@}*/

/*!
 * @name Register ASRC_ASRCFG, field INIRQC[23] (RO)
 *
 * Initialization for Conversion Pair C is served When this bit is 1, it means
 * the initialization for conversion pair C is served. This bit is cleared by
 * disabling the ASRC conversion pair (ASRCTR:ASREC=0 or ASRCTR:ASRCEN=0).
 */
/*@{*/
#define BP_ASRC_ASRCFG_INIRQC (23U)        /*!< Bit position for ASRC_ASRCFG_INIRQC. */
#define BM_ASRC_ASRCFG_INIRQC (0x00800000U) /*!< Bit mask for ASRC_ASRCFG_INIRQC. */
#define BS_ASRC_ASRCFG_INIRQC (1U)         /*!< Bit field size in bits for ASRC_ASRCFG_INIRQC. */

/*! @brief Read current value of the ASRC_ASRCFG_INIRQC field. */
#define BR_ASRC_ASRCFG_INIRQC(x) (HW_ASRC_ASRCFG(x).B.INIRQC)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCSR - ASRC Clock Source Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCSR - ASRC Clock Source Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC clock source register (ASRCSR) is a 24-bit read/write register that
 * controls the sources of the input and output clocks of the ASRC. The clock
 * connections are shown in : Bit Clock Definitions Bit Clk Name Definitions 0 ESAI
 * RX clock 1 SSI-1 RX clock 2 SSI-2 RX clock 3 SSI-3 RX clock 4 SPDIF RX clock 5
 * MLB Bit clock 6 bit clock 6 should connect to one of the three pads:
 * KEY_ROW3,GPIO_0,GPIO_18, which is configured by register
 * IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT 7 tied to zero 8 ESAI TX clock 9 SSI-1 TX clock a SSI-2 TX clock b
 * SSI-3 TX clock c SPDIF TX clock d bit clock d is configured by spdif1_clk_pred
 * and spdif1_clk_podf in CCM_CDCDR, but it is better to describe it also in CCM
 * spec.
 */
typedef union _hw_asrc_asrcsr
{
    uint32_t U;
    struct _hw_asrc_asrcsr_bitfields
    {
        uint32_t AICSA : 4;            /*!< [3:0]  */
        uint32_t AICSB : 4;            /*!< [7:4]  */
        uint32_t AICSC : 4;            /*!< [11:8]  */
        uint32_t AOCSA : 4;            /*!< [15:12]  */
        uint32_t AOCSB : 4;            /*!< [19:16]  */
        uint32_t AOCSC : 4;            /*!< [23:20]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrcsr_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCSR register
 */
/*@{*/
#define HW_ASRC_ASRCSR_ADDR(x)   ((uintptr_t)(x) + 0x14U)

#define HW_ASRC_ASRCSR(x)        (*(__IO hw_asrc_asrcsr_t *) HW_ASRC_ASRCSR_ADDR(x))
#define HW_ASRC_ASRCSR_RD(x)     (HW_ASRC_ASRCSR(x).U)
#define HW_ASRC_ASRCSR_WR(x, v)  (HW_ASRC_ASRCSR(x).U = (v))
#define HW_ASRC_ASRCSR_SET(x, v) (HW_ASRC_ASRCSR_WR(x, HW_ASRC_ASRCSR_RD(x) |  (v)))
#define HW_ASRC_ASRCSR_CLR(x, v) (HW_ASRC_ASRCSR_WR(x, HW_ASRC_ASRCSR_RD(x) & ~(v)))
#define HW_ASRC_ASRCSR_TOG(x, v) (HW_ASRC_ASRCSR_WR(x, HW_ASRC_ASRCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCSR bitfields
 */

/*!
 * @name Register ASRC_ASRCSR, field AICSA[3:0] (RW)
 *
 * Input Clock Source A
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AICSA (0U)          /*!< Bit position for ASRC_ASRCSR_AICSA. */
#define BM_ASRC_ASRCSR_AICSA (0x0000000FU) /*!< Bit mask for ASRC_ASRCSR_AICSA. */
#define BS_ASRC_ASRCSR_AICSA (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AICSA. */

/*! @brief Read current value of the ASRC_ASRCSR_AICSA field. */
#define BR_ASRC_ASRCSR_AICSA(x) (HW_ASRC_ASRCSR(x).B.AICSA)

/*! @brief Format value for bitfield ASRC_ASRCSR_AICSA. */
#define BF_ASRC_ASRCSR_AICSA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AICSA) & BM_ASRC_ASRCSR_AICSA)

/*! @brief Set the AICSA field to a new value. */
#define BW_ASRC_ASRCSR_AICSA(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AICSA) | BF_ASRC_ASRCSR_AICSA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCSR, field AICSB[7:4] (RW)
 *
 * Input Clock Source B
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AICSB (4U)          /*!< Bit position for ASRC_ASRCSR_AICSB. */
#define BM_ASRC_ASRCSR_AICSB (0x000000F0U) /*!< Bit mask for ASRC_ASRCSR_AICSB. */
#define BS_ASRC_ASRCSR_AICSB (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AICSB. */

/*! @brief Read current value of the ASRC_ASRCSR_AICSB field. */
#define BR_ASRC_ASRCSR_AICSB(x) (HW_ASRC_ASRCSR(x).B.AICSB)

/*! @brief Format value for bitfield ASRC_ASRCSR_AICSB. */
#define BF_ASRC_ASRCSR_AICSB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AICSB) & BM_ASRC_ASRCSR_AICSB)

/*! @brief Set the AICSB field to a new value. */
#define BW_ASRC_ASRCSR_AICSB(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AICSB) | BF_ASRC_ASRCSR_AICSB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCSR, field AICSC[11:8] (RW)
 *
 * Input Clock Source C
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AICSC (8U)          /*!< Bit position for ASRC_ASRCSR_AICSC. */
#define BM_ASRC_ASRCSR_AICSC (0x00000F00U) /*!< Bit mask for ASRC_ASRCSR_AICSC. */
#define BS_ASRC_ASRCSR_AICSC (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AICSC. */

/*! @brief Read current value of the ASRC_ASRCSR_AICSC field. */
#define BR_ASRC_ASRCSR_AICSC(x) (HW_ASRC_ASRCSR(x).B.AICSC)

/*! @brief Format value for bitfield ASRC_ASRCSR_AICSC. */
#define BF_ASRC_ASRCSR_AICSC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AICSC) & BM_ASRC_ASRCSR_AICSC)

/*! @brief Set the AICSC field to a new value. */
#define BW_ASRC_ASRCSR_AICSC(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AICSC) | BF_ASRC_ASRCSR_AICSC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCSR, field AOCSA[15:12] (RW)
 *
 * Output Clock Source A
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AOCSA (12U)         /*!< Bit position for ASRC_ASRCSR_AOCSA. */
#define BM_ASRC_ASRCSR_AOCSA (0x0000F000U) /*!< Bit mask for ASRC_ASRCSR_AOCSA. */
#define BS_ASRC_ASRCSR_AOCSA (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AOCSA. */

/*! @brief Read current value of the ASRC_ASRCSR_AOCSA field. */
#define BR_ASRC_ASRCSR_AOCSA(x) (HW_ASRC_ASRCSR(x).B.AOCSA)

/*! @brief Format value for bitfield ASRC_ASRCSR_AOCSA. */
#define BF_ASRC_ASRCSR_AOCSA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AOCSA) & BM_ASRC_ASRCSR_AOCSA)

/*! @brief Set the AOCSA field to a new value. */
#define BW_ASRC_ASRCSR_AOCSA(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AOCSA) | BF_ASRC_ASRCSR_AOCSA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCSR, field AOCSB[19:16] (RW)
 *
 * Output Clock Source B
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AOCSB (16U)         /*!< Bit position for ASRC_ASRCSR_AOCSB. */
#define BM_ASRC_ASRCSR_AOCSB (0x000F0000U) /*!< Bit mask for ASRC_ASRCSR_AOCSB. */
#define BS_ASRC_ASRCSR_AOCSB (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AOCSB. */

/*! @brief Read current value of the ASRC_ASRCSR_AOCSB field. */
#define BR_ASRC_ASRCSR_AOCSB(x) (HW_ASRC_ASRCSR(x).B.AOCSB)

/*! @brief Format value for bitfield ASRC_ASRCSR_AOCSB. */
#define BF_ASRC_ASRCSR_AOCSB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AOCSB) & BM_ASRC_ASRCSR_AOCSB)

/*! @brief Set the AOCSB field to a new value. */
#define BW_ASRC_ASRCSR_AOCSB(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AOCSB) | BF_ASRC_ASRCSR_AOCSB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCSR, field AOCSC[23:20] (RW)
 *
 * Output Clock Source C
 *
 * Values:
 * - 0000 - bit clock 0
 * - 0001 - bit clock 1
 * - 0010 - bit clock 2
 * - 0011 - bit clock 3
 * - 0100 - bit clock 4
 * - 0101 - bit clock 5
 * - 0110 - bit clock 6
 * - 0111 - bit clock 7
 * - 1000 - bit clock 8
 * - 1001 - bit clock 9
 * - 1010 - bit clock A
 * - 1011 - bit clock B
 * - 1100 - bit clock C
 * - 1101 - bit clock D
 * - 1110 - bit clock E
 * - 1111 - clock disabled, connected to zero
 */
/*@{*/
#define BP_ASRC_ASRCSR_AOCSC (20U)         /*!< Bit position for ASRC_ASRCSR_AOCSC. */
#define BM_ASRC_ASRCSR_AOCSC (0x00F00000U) /*!< Bit mask for ASRC_ASRCSR_AOCSC. */
#define BS_ASRC_ASRCSR_AOCSC (4U)          /*!< Bit field size in bits for ASRC_ASRCSR_AOCSC. */

/*! @brief Read current value of the ASRC_ASRCSR_AOCSC field. */
#define BR_ASRC_ASRCSR_AOCSC(x) (HW_ASRC_ASRCSR(x).B.AOCSC)

/*! @brief Format value for bitfield ASRC_ASRCSR_AOCSC. */
#define BF_ASRC_ASRCSR_AOCSC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCSR_AOCSC) & BM_ASRC_ASRCSR_AOCSC)

/*! @brief Set the AOCSC field to a new value. */
#define BW_ASRC_ASRCSR_AOCSC(x, v) (HW_ASRC_ASRCSR_WR(x, (HW_ASRC_ASRCSR_RD(x) & ~BM_ASRC_ASRCSR_AOCSC) | BF_ASRC_ASRCSR_AOCSC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCDR1 - ASRC Clock Divider Register 1
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCDR1 - ASRC Clock Divider Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC clock divider register (ASRCDR1) is a 24-bit read/write register
 * that controls the division factors of the ASRC input and output clock sources.
 */
typedef union _hw_asrc_asrcdr1
{
    uint32_t U;
    struct _hw_asrc_asrcdr1_bitfields
    {
        uint32_t AICPA : 3;            /*!< [2:0]  */
        uint32_t AICDA : 3;            /*!< [5:3]  */
        uint32_t AICPB : 3;            /*!< [8:6]  */
        uint32_t AICDB : 3;            /*!< [11:9]  */
        uint32_t AOCPA : 3;            /*!< [14:12]  */
        uint32_t AOCDA : 3;            /*!< [17:15]  */
        uint32_t AOCPB : 3;            /*!< [20:18]  */
        uint32_t AOCDB : 3;            /*!< [23:21]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrcdr1_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCDR1 register
 */
/*@{*/
#define HW_ASRC_ASRCDR1_ADDR(x)  ((uintptr_t)(x) + 0x18U)

#define HW_ASRC_ASRCDR1(x)       (*(__IO hw_asrc_asrcdr1_t *) HW_ASRC_ASRCDR1_ADDR(x))
#define HW_ASRC_ASRCDR1_RD(x)    (HW_ASRC_ASRCDR1(x).U)
#define HW_ASRC_ASRCDR1_WR(x, v) (HW_ASRC_ASRCDR1(x).U = (v))
#define HW_ASRC_ASRCDR1_SET(x, v) (HW_ASRC_ASRCDR1_WR(x, HW_ASRC_ASRCDR1_RD(x) |  (v)))
#define HW_ASRC_ASRCDR1_CLR(x, v) (HW_ASRC_ASRCDR1_WR(x, HW_ASRC_ASRCDR1_RD(x) & ~(v)))
#define HW_ASRC_ASRCDR1_TOG(x, v) (HW_ASRC_ASRCDR1_WR(x, HW_ASRC_ASRCDR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCDR1 bitfields
 */

/*!
 * @name Register ASRC_ASRCDR1, field AICPA[2:0] (RW)
 *
 * Input Clock Prescaler A Specify the prescaling factor of the input prescaler
 * A. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AICPA (0U)         /*!< Bit position for ASRC_ASRCDR1_AICPA. */
#define BM_ASRC_ASRCDR1_AICPA (0x00000007U) /*!< Bit mask for ASRC_ASRCDR1_AICPA. */
#define BS_ASRC_ASRCDR1_AICPA (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AICPA. */

/*! @brief Read current value of the ASRC_ASRCDR1_AICPA field. */
#define BR_ASRC_ASRCDR1_AICPA(x) (HW_ASRC_ASRCDR1(x).B.AICPA)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AICPA. */
#define BF_ASRC_ASRCDR1_AICPA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AICPA) & BM_ASRC_ASRCDR1_AICPA)

/*! @brief Set the AICPA field to a new value. */
#define BW_ASRC_ASRCDR1_AICPA(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AICPA) | BF_ASRC_ASRCDR1_AICPA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AICDA[5:3] (RW)
 *
 * Input Clock Divider A Specify the divide ratio of the input clock divider A.
 * The divide ratio may range from 1 to 8 (AICDA[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AICDA (3U)         /*!< Bit position for ASRC_ASRCDR1_AICDA. */
#define BM_ASRC_ASRCDR1_AICDA (0x00000038U) /*!< Bit mask for ASRC_ASRCDR1_AICDA. */
#define BS_ASRC_ASRCDR1_AICDA (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AICDA. */

/*! @brief Read current value of the ASRC_ASRCDR1_AICDA field. */
#define BR_ASRC_ASRCDR1_AICDA(x) (HW_ASRC_ASRCDR1(x).B.AICDA)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AICDA. */
#define BF_ASRC_ASRCDR1_AICDA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AICDA) & BM_ASRC_ASRCDR1_AICDA)

/*! @brief Set the AICDA field to a new value. */
#define BW_ASRC_ASRCDR1_AICDA(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AICDA) | BF_ASRC_ASRCDR1_AICDA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AICPB[8:6] (RW)
 *
 * Input Clock Prescaler B Specify the prescaling factor of the input prescaler
 * B. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AICPB (6U)         /*!< Bit position for ASRC_ASRCDR1_AICPB. */
#define BM_ASRC_ASRCDR1_AICPB (0x000001C0U) /*!< Bit mask for ASRC_ASRCDR1_AICPB. */
#define BS_ASRC_ASRCDR1_AICPB (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AICPB. */

/*! @brief Read current value of the ASRC_ASRCDR1_AICPB field. */
#define BR_ASRC_ASRCDR1_AICPB(x) (HW_ASRC_ASRCDR1(x).B.AICPB)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AICPB. */
#define BF_ASRC_ASRCDR1_AICPB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AICPB) & BM_ASRC_ASRCDR1_AICPB)

/*! @brief Set the AICPB field to a new value. */
#define BW_ASRC_ASRCDR1_AICPB(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AICPB) | BF_ASRC_ASRCDR1_AICPB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AICDB[11:9] (RW)
 *
 * Input Clock Divider B Specify the divide ratio of the input clock divider B.
 * The divide ratio may range from 1 to 8 (AICDB[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AICDB (9U)         /*!< Bit position for ASRC_ASRCDR1_AICDB. */
#define BM_ASRC_ASRCDR1_AICDB (0x00000E00U) /*!< Bit mask for ASRC_ASRCDR1_AICDB. */
#define BS_ASRC_ASRCDR1_AICDB (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AICDB. */

/*! @brief Read current value of the ASRC_ASRCDR1_AICDB field. */
#define BR_ASRC_ASRCDR1_AICDB(x) (HW_ASRC_ASRCDR1(x).B.AICDB)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AICDB. */
#define BF_ASRC_ASRCDR1_AICDB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AICDB) & BM_ASRC_ASRCDR1_AICDB)

/*! @brief Set the AICDB field to a new value. */
#define BW_ASRC_ASRCDR1_AICDB(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AICDB) | BF_ASRC_ASRCDR1_AICDB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AOCPA[14:12] (RW)
 *
 * Output Clock Prescaler A Specify the prescaling factor of the output
 * prescaler A. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AOCPA (12U)        /*!< Bit position for ASRC_ASRCDR1_AOCPA. */
#define BM_ASRC_ASRCDR1_AOCPA (0x00007000U) /*!< Bit mask for ASRC_ASRCDR1_AOCPA. */
#define BS_ASRC_ASRCDR1_AOCPA (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AOCPA. */

/*! @brief Read current value of the ASRC_ASRCDR1_AOCPA field. */
#define BR_ASRC_ASRCDR1_AOCPA(x) (HW_ASRC_ASRCDR1(x).B.AOCPA)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AOCPA. */
#define BF_ASRC_ASRCDR1_AOCPA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AOCPA) & BM_ASRC_ASRCDR1_AOCPA)

/*! @brief Set the AOCPA field to a new value. */
#define BW_ASRC_ASRCDR1_AOCPA(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AOCPA) | BF_ASRC_ASRCDR1_AOCPA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AOCDA[17:15] (RW)
 *
 * Output Clock Divider A Specify the divide ratio of the output clock divider
 * A. The divide ratio may range from 1 to 8 (AOCDA[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AOCDA (15U)        /*!< Bit position for ASRC_ASRCDR1_AOCDA. */
#define BM_ASRC_ASRCDR1_AOCDA (0x00038000U) /*!< Bit mask for ASRC_ASRCDR1_AOCDA. */
#define BS_ASRC_ASRCDR1_AOCDA (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AOCDA. */

/*! @brief Read current value of the ASRC_ASRCDR1_AOCDA field. */
#define BR_ASRC_ASRCDR1_AOCDA(x) (HW_ASRC_ASRCDR1(x).B.AOCDA)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AOCDA. */
#define BF_ASRC_ASRCDR1_AOCDA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AOCDA) & BM_ASRC_ASRCDR1_AOCDA)

/*! @brief Set the AOCDA field to a new value. */
#define BW_ASRC_ASRCDR1_AOCDA(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AOCDA) | BF_ASRC_ASRCDR1_AOCDA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AOCPB[20:18] (RW)
 *
 * Output Clock Prescaler B Specify the prescaling factor of the output
 * prescaler B. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AOCPB (18U)        /*!< Bit position for ASRC_ASRCDR1_AOCPB. */
#define BM_ASRC_ASRCDR1_AOCPB (0x001C0000U) /*!< Bit mask for ASRC_ASRCDR1_AOCPB. */
#define BS_ASRC_ASRCDR1_AOCPB (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AOCPB. */

/*! @brief Read current value of the ASRC_ASRCDR1_AOCPB field. */
#define BR_ASRC_ASRCDR1_AOCPB(x) (HW_ASRC_ASRCDR1(x).B.AOCPB)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AOCPB. */
#define BF_ASRC_ASRCDR1_AOCPB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AOCPB) & BM_ASRC_ASRCDR1_AOCPB)

/*! @brief Set the AOCPB field to a new value. */
#define BW_ASRC_ASRCDR1_AOCPB(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AOCPB) | BF_ASRC_ASRCDR1_AOCPB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR1, field AOCDB[23:21] (RW)
 *
 * Output Clock Divider B Specify the divide ratio of the output clock divider
 * B. The divide ratio may range from 1 to 8 (AOCDB[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR1_AOCDB (21U)        /*!< Bit position for ASRC_ASRCDR1_AOCDB. */
#define BM_ASRC_ASRCDR1_AOCDB (0x00E00000U) /*!< Bit mask for ASRC_ASRCDR1_AOCDB. */
#define BS_ASRC_ASRCDR1_AOCDB (3U)         /*!< Bit field size in bits for ASRC_ASRCDR1_AOCDB. */

/*! @brief Read current value of the ASRC_ASRCDR1_AOCDB field. */
#define BR_ASRC_ASRCDR1_AOCDB(x) (HW_ASRC_ASRCDR1(x).B.AOCDB)

/*! @brief Format value for bitfield ASRC_ASRCDR1_AOCDB. */
#define BF_ASRC_ASRCDR1_AOCDB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR1_AOCDB) & BM_ASRC_ASRCDR1_AOCDB)

/*! @brief Set the AOCDB field to a new value. */
#define BW_ASRC_ASRCDR1_AOCDB(x, v) (HW_ASRC_ASRCDR1_WR(x, (HW_ASRC_ASRCDR1_RD(x) & ~BM_ASRC_ASRCDR1_AOCDB) | BF_ASRC_ASRCDR1_AOCDB(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCDR2 - ASRC Clock Divider Register 2
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCDR2 - ASRC Clock Divider Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC clock divider register (ASRCDR2) is a 24-bit read/write register
 * that controls the division factors of the ASRC input and output clock sources.
 */
typedef union _hw_asrc_asrcdr2
{
    uint32_t U;
    struct _hw_asrc_asrcdr2_bitfields
    {
        uint32_t AICPC : 3;            /*!< [2:0]  */
        uint32_t AICDC : 3;            /*!< [5:3]  */
        uint32_t AOCPC : 3;            /*!< [8:6]  */
        uint32_t AOCDC : 3;            /*!< [11:9]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrcdr2_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCDR2 register
 */
/*@{*/
#define HW_ASRC_ASRCDR2_ADDR(x)  ((uintptr_t)(x) + 0x1CU)

#define HW_ASRC_ASRCDR2(x)       (*(__IO hw_asrc_asrcdr2_t *) HW_ASRC_ASRCDR2_ADDR(x))
#define HW_ASRC_ASRCDR2_RD(x)    (HW_ASRC_ASRCDR2(x).U)
#define HW_ASRC_ASRCDR2_WR(x, v) (HW_ASRC_ASRCDR2(x).U = (v))
#define HW_ASRC_ASRCDR2_SET(x, v) (HW_ASRC_ASRCDR2_WR(x, HW_ASRC_ASRCDR2_RD(x) |  (v)))
#define HW_ASRC_ASRCDR2_CLR(x, v) (HW_ASRC_ASRCDR2_WR(x, HW_ASRC_ASRCDR2_RD(x) & ~(v)))
#define HW_ASRC_ASRCDR2_TOG(x, v) (HW_ASRC_ASRCDR2_WR(x, HW_ASRC_ASRCDR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCDR2 bitfields
 */

/*!
 * @name Register ASRC_ASRCDR2, field AICPC[2:0] (RW)
 *
 * Input Clock Prescaler C Specify the prescaling factor of the input prescaler
 * C. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR2_AICPC (0U)         /*!< Bit position for ASRC_ASRCDR2_AICPC. */
#define BM_ASRC_ASRCDR2_AICPC (0x00000007U) /*!< Bit mask for ASRC_ASRCDR2_AICPC. */
#define BS_ASRC_ASRCDR2_AICPC (3U)         /*!< Bit field size in bits for ASRC_ASRCDR2_AICPC. */

/*! @brief Read current value of the ASRC_ASRCDR2_AICPC field. */
#define BR_ASRC_ASRCDR2_AICPC(x) (HW_ASRC_ASRCDR2(x).B.AICPC)

/*! @brief Format value for bitfield ASRC_ASRCDR2_AICPC. */
#define BF_ASRC_ASRCDR2_AICPC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR2_AICPC) & BM_ASRC_ASRCDR2_AICPC)

/*! @brief Set the AICPC field to a new value. */
#define BW_ASRC_ASRCDR2_AICPC(x, v) (HW_ASRC_ASRCDR2_WR(x, (HW_ASRC_ASRCDR2_RD(x) & ~BM_ASRC_ASRCDR2_AICPC) | BF_ASRC_ASRCDR2_AICPC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR2, field AICDC[5:3] (RW)
 *
 * Input Clock Divider C Specify the divide ratio of the input clock divider C.
 * The divide ratio may range from 1 to 8 (AICDC[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR2_AICDC (3U)         /*!< Bit position for ASRC_ASRCDR2_AICDC. */
#define BM_ASRC_ASRCDR2_AICDC (0x00000038U) /*!< Bit mask for ASRC_ASRCDR2_AICDC. */
#define BS_ASRC_ASRCDR2_AICDC (3U)         /*!< Bit field size in bits for ASRC_ASRCDR2_AICDC. */

/*! @brief Read current value of the ASRC_ASRCDR2_AICDC field. */
#define BR_ASRC_ASRCDR2_AICDC(x) (HW_ASRC_ASRCDR2(x).B.AICDC)

/*! @brief Format value for bitfield ASRC_ASRCDR2_AICDC. */
#define BF_ASRC_ASRCDR2_AICDC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR2_AICDC) & BM_ASRC_ASRCDR2_AICDC)

/*! @brief Set the AICDC field to a new value. */
#define BW_ASRC_ASRCDR2_AICDC(x, v) (HW_ASRC_ASRCDR2_WR(x, (HW_ASRC_ASRCDR2_RD(x) & ~BM_ASRC_ASRCDR2_AICDC) | BF_ASRC_ASRCDR2_AICDC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR2, field AOCPC[8:6] (RW)
 *
 * Output Clock Prescaler C Specify the prescaling factor of the output
 * prescaler C. The prescaling ratio may be any power of 2 from 1 to 128.
 */
/*@{*/
#define BP_ASRC_ASRCDR2_AOCPC (6U)         /*!< Bit position for ASRC_ASRCDR2_AOCPC. */
#define BM_ASRC_ASRCDR2_AOCPC (0x000001C0U) /*!< Bit mask for ASRC_ASRCDR2_AOCPC. */
#define BS_ASRC_ASRCDR2_AOCPC (3U)         /*!< Bit field size in bits for ASRC_ASRCDR2_AOCPC. */

/*! @brief Read current value of the ASRC_ASRCDR2_AOCPC field. */
#define BR_ASRC_ASRCDR2_AOCPC(x) (HW_ASRC_ASRCDR2(x).B.AOCPC)

/*! @brief Format value for bitfield ASRC_ASRCDR2_AOCPC. */
#define BF_ASRC_ASRCDR2_AOCPC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR2_AOCPC) & BM_ASRC_ASRCDR2_AOCPC)

/*! @brief Set the AOCPC field to a new value. */
#define BW_ASRC_ASRCDR2_AOCPC(x, v) (HW_ASRC_ASRCDR2_WR(x, (HW_ASRC_ASRCDR2_RD(x) & ~BM_ASRC_ASRCDR2_AOCPC) | BF_ASRC_ASRCDR2_AOCPC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCDR2, field AOCDC[11:9] (RW)
 *
 * Output Clock Divider C Specify the divide ratio of the output clock divider
 * C. The divide ratio may range from 1 to 8 (AOCDC[2:0] = 000 to 111).
 */
/*@{*/
#define BP_ASRC_ASRCDR2_AOCDC (9U)         /*!< Bit position for ASRC_ASRCDR2_AOCDC. */
#define BM_ASRC_ASRCDR2_AOCDC (0x00000E00U) /*!< Bit mask for ASRC_ASRCDR2_AOCDC. */
#define BS_ASRC_ASRCDR2_AOCDC (3U)         /*!< Bit field size in bits for ASRC_ASRCDR2_AOCDC. */

/*! @brief Read current value of the ASRC_ASRCDR2_AOCDC field. */
#define BR_ASRC_ASRCDR2_AOCDC(x) (HW_ASRC_ASRCDR2(x).B.AOCDC)

/*! @brief Format value for bitfield ASRC_ASRCDR2_AOCDC. */
#define BF_ASRC_ASRCDR2_AOCDC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCDR2_AOCDC) & BM_ASRC_ASRCDR2_AOCDC)

/*! @brief Set the AOCDC field to a new value. */
#define BW_ASRC_ASRCDR2_AOCDC(x, v) (HW_ASRC_ASRCDR2_WR(x, (HW_ASRC_ASRCDR2_RD(x) & ~BM_ASRC_ASRCDR2_AOCDC) | BF_ASRC_ASRCDR2_AOCDC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRSTR - ASRC Status Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRSTR - ASRC Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC status register (ASRSTR) is a 24-bit read-write register used by the
 * processor core to examine the status of the ASRC block and clear the overload
 * interrupt request and AOLE flag bit. Read the status register will return the
 * current state of ASRC.
 */
typedef union _hw_asrc_asrstr
{
    uint32_t U;
    struct _hw_asrc_asrstr_bitfields
    {
        uint32_t AIDEA : 1;            /*!< [0]  */
        uint32_t AIDEB : 1;            /*!< [1]  */
        uint32_t AIDEC : 1;            /*!< [2]  */
        uint32_t AODFA : 1;            /*!< [3]  */
        uint32_t AODFB : 1;            /*!< [4]  */
        uint32_t AODFC : 1;            /*!< [5]  */
        uint32_t AOLE : 1;             /*!< [6]  */
        uint32_t FPWT : 1;             /*!< [7]  */
        uint32_t AIDUA : 1;            /*!< [8]  */
        uint32_t AIDUB : 1;            /*!< [9]  */
        uint32_t AIDUC : 1;            /*!< [10]  */
        uint32_t AODOA : 1;            /*!< [11]  */
        uint32_t AODOB : 1;            /*!< [12]  */
        uint32_t AODOC : 1;            /*!< [13]  */
        uint32_t AIOLA : 1;            /*!< [14]  */
        uint32_t AIOLB : 1;            /*!< [15]  */
        uint32_t AIOLC : 1;            /*!< [16]  */
        uint32_t AOOLA : 1;            /*!< [17]  */
        uint32_t AOOLB : 1;            /*!< [18]  */
        uint32_t AOOLC : 1;            /*!< [19]  */
        uint32_t ATQOL : 1;            /*!< [20]  */
        uint32_t DSLCNT : 1;           /*!< [21]  */
        uint32_t RESERVED0 : 10;       /*!< [31:22] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrstr_t;

/*!
 * @name Constants and macros for entire ASRC_ASRSTR register
 */
/*@{*/
#define HW_ASRC_ASRSTR_ADDR(x)   ((uintptr_t)(x) + 0x20U)

#define HW_ASRC_ASRSTR(x)        (*(__I hw_asrc_asrstr_t *) HW_ASRC_ASRSTR_ADDR(x))
#define HW_ASRC_ASRSTR_RD(x)     (HW_ASRC_ASRSTR(x).U)
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRSTR bitfields
 */

/*!
 * @name Register ASRC_ASRSTR, field AIDEA[0] (RO)
 *
 * Number of data in Input Data Buffer A is less than threshold When set, this
 * bit indicates that number of data still available in ASRDIRA is less than
 * threshold and the processor can write data to ASRDIRA. When AIDEA is set, the ASRC
 * generates data input A interrupt request to the processor, if enabled (that
 * is, ASRIER:ADIEA = 1). A DMA request is always generated when the AIDEA bit is
 * set, but a DMA transfer takes place only if a DMA channel is active and
 * triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDEA (0U)          /*!< Bit position for ASRC_ASRSTR_AIDEA. */
#define BM_ASRC_ASRSTR_AIDEA (0x00000001U) /*!< Bit mask for ASRC_ASRSTR_AIDEA. */
#define BS_ASRC_ASRSTR_AIDEA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDEA. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDEA field. */
#define BR_ASRC_ASRSTR_AIDEA(x) (HW_ASRC_ASRSTR(x).B.AIDEA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIDEB[1] (RO)
 *
 * Number of data in Input Data Buffer B is less than threshold When set, this
 * bit indicates that number of data still available in ASRDIRB is less than
 * threshold and the processor can write data to ASRDIRB. When AIDEB is set, the ASRC
 * generates data input B interrupt request to the processor, if enabled (that
 * is, ASRIER:ADIEB = 1). A DMA request is always generated when the AIDEB bit is
 * set, but a DMA transfer takes place only if a DMA channel is active and
 * triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDEB (1U)          /*!< Bit position for ASRC_ASRSTR_AIDEB. */
#define BM_ASRC_ASRSTR_AIDEB (0x00000002U) /*!< Bit mask for ASRC_ASRSTR_AIDEB. */
#define BS_ASRC_ASRSTR_AIDEB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDEB. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDEB field. */
#define BR_ASRC_ASRSTR_AIDEB(x) (HW_ASRC_ASRSTR(x).B.AIDEB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIDEC[2] (RO)
 *
 * Number of data in Input Data Buffer C is less than threshold When set, this
 * bit indicates that number of data still available in ASRDIRC is less than
 * threshold and the processor can write data to ASRDIRC. When AIDEC is set, the ASRC
 * generates data input C interrupt request to the processor, if enabled (that
 * is, ASRIER:ADIEC = 1). A DMA request is always generated when the AIDEC bit is
 * set, but a DMA transfer takes place only if a DMA channel is active and
 * triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDEC (2U)          /*!< Bit position for ASRC_ASRSTR_AIDEC. */
#define BM_ASRC_ASRSTR_AIDEC (0x00000004U) /*!< Bit mask for ASRC_ASRSTR_AIDEC. */
#define BS_ASRC_ASRSTR_AIDEC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDEC. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDEC field. */
#define BR_ASRC_ASRSTR_AIDEC(x) (HW_ASRC_ASRSTR(x).B.AIDEC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODFA[3] (RO)
 *
 * Number of data in Output Data Buffer A is greater than threshold When set,
 * this bit indicates that number of data already existing in ASRDORA is greater
 * than threshold and the processor can read data from ASRDORA. When AODFA is set,
 * the ASRC generates data output A interrupt request to the processor, if
 * enabled (that is, ASRIER:ADOEA = 1). A DMA request is always generated when the
 * AODFA bit is set, but a DMA transfer takes place only if a DMA channel is active
 * and triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODFA (3U)          /*!< Bit position for ASRC_ASRSTR_AODFA. */
#define BM_ASRC_ASRSTR_AODFA (0x00000008U) /*!< Bit mask for ASRC_ASRSTR_AODFA. */
#define BS_ASRC_ASRSTR_AODFA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODFA. */

/*! @brief Read current value of the ASRC_ASRSTR_AODFA field. */
#define BR_ASRC_ASRSTR_AODFA(x) (HW_ASRC_ASRSTR(x).B.AODFA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODFB[4] (RO)
 *
 * Number of data in Output Data Buffer B is greater than threshold When set,
 * this bit indicates that number of data already existing in ASRDORB is greater
 * than threshold and the processor can read data from ASRDORB. When AODFB is set,
 * the ASRC generates data output B interrupt request to the processor, if
 * enabled (that is, ASRIER:ADOEB = 1). A DMA request is always generated when the
 * AODFB bit is set, but a DMA transfer takes place only if a DMA channel is active
 * and triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODFB (4U)          /*!< Bit position for ASRC_ASRSTR_AODFB. */
#define BM_ASRC_ASRSTR_AODFB (0x00000010U) /*!< Bit mask for ASRC_ASRSTR_AODFB. */
#define BS_ASRC_ASRSTR_AODFB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODFB. */

/*! @brief Read current value of the ASRC_ASRSTR_AODFB field. */
#define BR_ASRC_ASRSTR_AODFB(x) (HW_ASRC_ASRSTR(x).B.AODFB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODFC[5] (RO)
 *
 * Number of data in Output Data Buffer C is greater than threshold When set,
 * this bit indicates that number of data already existing in ASRDORC is greater
 * than threshold and the processor can read data from ASRDORC. When AODFC is set,
 * the ASRC generates data output C interrupt request to the processor, if
 * enabled (that is, ASRIER:ADOEC = 1). A DMA request is always generated when the
 * AODFC bit is set, but a DMA transfer takes place only if a DMA channel is active
 * and triggered by this event.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODFC (5U)          /*!< Bit position for ASRC_ASRSTR_AODFC. */
#define BM_ASRC_ASRSTR_AODFC (0x00000020U) /*!< Bit mask for ASRC_ASRSTR_AODFC. */
#define BS_ASRC_ASRSTR_AODFC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODFC. */

/*! @brief Read current value of the ASRC_ASRSTR_AODFC field. */
#define BR_ASRC_ASRSTR_AODFC(x) (HW_ASRC_ASRSTR(x).B.AODFC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AOLE[6] (RO)
 *
 * Overload Error Flag When set, this bit indicates that the task rate is too
 * high for the ASRC to handle. The reasons for overload may be: - too high input
 * clock frequency, - too high output clock frequency, - incorrect selection of
 * the pre-filter, - low ASRC processing clock, - too many channels, - underrun, -
 * or any combination of the reasons above. Since the ASRC uses the same hardware
 * resources to perform various tasks, the real reason for the overload is not
 * straight forward, and it should be carefully analyzed by the programmer. If
 * ASRIER:AOLIE=1, an interrupt will be proposed when this bit is set. Write any
 * value with this bit set as one into the status register will clear this bit and
 * the interrupt request proposed by this bit.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AOLE  (6U)          /*!< Bit position for ASRC_ASRSTR_AOLE. */
#define BM_ASRC_ASRSTR_AOLE  (0x00000040U) /*!< Bit mask for ASRC_ASRSTR_AOLE. */
#define BS_ASRC_ASRSTR_AOLE  (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AOLE. */

/*! @brief Read current value of the ASRC_ASRSTR_AOLE field. */
#define BR_ASRC_ASRSTR_AOLE(x) (HW_ASRC_ASRSTR(x).B.AOLE)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field FPWT[7] (RO)
 *
 * FP is in wait states This bit is for debug only. When set, this bit indicates
 * that ASRC is in wait states. When clear, this bit indicates that ASRC is not
 * in wait states.
 */
/*@{*/
#define BP_ASRC_ASRSTR_FPWT  (7U)          /*!< Bit position for ASRC_ASRSTR_FPWT. */
#define BM_ASRC_ASRSTR_FPWT  (0x00000080U) /*!< Bit mask for ASRC_ASRSTR_FPWT. */
#define BS_ASRC_ASRSTR_FPWT  (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_FPWT. */

/*! @brief Read current value of the ASRC_ASRSTR_FPWT field. */
#define BR_ASRC_ASRSTR_FPWT(x) (HW_ASRC_ASRSTR(x).B.FPWT)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIDUA[8] (RO)
 *
 * Input Data Buffer A has underflowed When set, this bit indicates that input
 * data buffer A has underflowed. When clear, this bit indicates that input data
 * buffer A has not underflowed. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDUA (8U)          /*!< Bit position for ASRC_ASRSTR_AIDUA. */
#define BM_ASRC_ASRSTR_AIDUA (0x00000100U) /*!< Bit mask for ASRC_ASRSTR_AIDUA. */
#define BS_ASRC_ASRSTR_AIDUA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDUA. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDUA field. */
#define BR_ASRC_ASRSTR_AIDUA(x) (HW_ASRC_ASRSTR(x).B.AIDUA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIDUB[9] (RO)
 *
 * Input Data Buffer B has underflowed When set, this bit indicates that input
 * data buffer B has underflowed. When clear, this bit indicates that input data
 * buffer B has not underflowed. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDUB (9U)          /*!< Bit position for ASRC_ASRSTR_AIDUB. */
#define BM_ASRC_ASRSTR_AIDUB (0x00000200U) /*!< Bit mask for ASRC_ASRSTR_AIDUB. */
#define BS_ASRC_ASRSTR_AIDUB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDUB. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDUB field. */
#define BR_ASRC_ASRSTR_AIDUB(x) (HW_ASRC_ASRSTR(x).B.AIDUB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIDUC[10] (RO)
 *
 * Input Data Buffer C has underflowed When set, this bit indicates that input
 * data buffer C has underflowed. When clear, this bit indicates that input data
 * buffer C has not underflowed. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIDUC (10U)         /*!< Bit position for ASRC_ASRSTR_AIDUC. */
#define BM_ASRC_ASRSTR_AIDUC (0x00000400U) /*!< Bit mask for ASRC_ASRSTR_AIDUC. */
#define BS_ASRC_ASRSTR_AIDUC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIDUC. */

/*! @brief Read current value of the ASRC_ASRSTR_AIDUC field. */
#define BR_ASRC_ASRSTR_AIDUC(x) (HW_ASRC_ASRSTR(x).B.AIDUC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODOA[11] (RO)
 *
 * Output Data Buffer A has overflowed When set, this bit indicates that output
 * data buffer A has overflowed. When clear, this bit indicates that output data
 * buffer A has not overflowed The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODOA (11U)         /*!< Bit position for ASRC_ASRSTR_AODOA. */
#define BM_ASRC_ASRSTR_AODOA (0x00000800U) /*!< Bit mask for ASRC_ASRSTR_AODOA. */
#define BS_ASRC_ASRSTR_AODOA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODOA. */

/*! @brief Read current value of the ASRC_ASRSTR_AODOA field. */
#define BR_ASRC_ASRSTR_AODOA(x) (HW_ASRC_ASRSTR(x).B.AODOA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODOB[12] (RO)
 *
 * Output Data Buffer B has overflowed When set, this bit indicates that output
 * data buffer B has overflowed. When clear, this bit indicates that output data
 * buffer B has not overflowed The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODOB (12U)         /*!< Bit position for ASRC_ASRSTR_AODOB. */
#define BM_ASRC_ASRSTR_AODOB (0x00001000U) /*!< Bit mask for ASRC_ASRSTR_AODOB. */
#define BS_ASRC_ASRSTR_AODOB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODOB. */

/*! @brief Read current value of the ASRC_ASRSTR_AODOB field. */
#define BR_ASRC_ASRSTR_AODOB(x) (HW_ASRC_ASRSTR(x).B.AODOB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AODOC[13] (RO)
 *
 * Output Data Buffer C has overflowed When set, this bit indicates that output
 * data buffer C has overflowed. When clear, this bit indicates that output data
 * buffer C has not overflowed The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AODOC (13U)         /*!< Bit position for ASRC_ASRSTR_AODOC. */
#define BM_ASRC_ASRSTR_AODOC (0x00002000U) /*!< Bit mask for ASRC_ASRSTR_AODOC. */
#define BS_ASRC_ASRSTR_AODOC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AODOC. */

/*! @brief Read current value of the ASRC_ASRSTR_AODOC field. */
#define BR_ASRC_ASRSTR_AODOC(x) (HW_ASRC_ASRSTR(x).B.AODOC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIOLA[14] (RO)
 *
 * Pair A Input Task Overload When set, this bit indicates that pair A input
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIOLA (14U)         /*!< Bit position for ASRC_ASRSTR_AIOLA. */
#define BM_ASRC_ASRSTR_AIOLA (0x00004000U) /*!< Bit mask for ASRC_ASRSTR_AIOLA. */
#define BS_ASRC_ASRSTR_AIOLA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIOLA. */

/*! @brief Read current value of the ASRC_ASRSTR_AIOLA field. */
#define BR_ASRC_ASRSTR_AIOLA(x) (HW_ASRC_ASRSTR(x).B.AIOLA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIOLB[15] (RO)
 *
 * Pair B Input Task Overload When set, this bit indicates that pair B input
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIOLB (15U)         /*!< Bit position for ASRC_ASRSTR_AIOLB. */
#define BM_ASRC_ASRSTR_AIOLB (0x00008000U) /*!< Bit mask for ASRC_ASRSTR_AIOLB. */
#define BS_ASRC_ASRSTR_AIOLB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIOLB. */

/*! @brief Read current value of the ASRC_ASRSTR_AIOLB field. */
#define BR_ASRC_ASRSTR_AIOLB(x) (HW_ASRC_ASRSTR(x).B.AIOLB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AIOLC[16] (RO)
 *
 * Pair C Input Task Overload When set, this bit indicates that pair C input
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AIOLC (16U)         /*!< Bit position for ASRC_ASRSTR_AIOLC. */
#define BM_ASRC_ASRSTR_AIOLC (0x00010000U) /*!< Bit mask for ASRC_ASRSTR_AIOLC. */
#define BS_ASRC_ASRSTR_AIOLC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AIOLC. */

/*! @brief Read current value of the ASRC_ASRSTR_AIOLC field. */
#define BR_ASRC_ASRSTR_AIOLC(x) (HW_ASRC_ASRSTR(x).B.AIOLC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AOOLA[17] (RO)
 *
 * Pair A Output Task Overload When set, this bit indicates that pair A output
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AOOLA (17U)         /*!< Bit position for ASRC_ASRSTR_AOOLA. */
#define BM_ASRC_ASRSTR_AOOLA (0x00020000U) /*!< Bit mask for ASRC_ASRSTR_AOOLA. */
#define BS_ASRC_ASRSTR_AOOLA (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AOOLA. */

/*! @brief Read current value of the ASRC_ASRSTR_AOOLA field. */
#define BR_ASRC_ASRSTR_AOOLA(x) (HW_ASRC_ASRSTR(x).B.AOOLA)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AOOLB[18] (RO)
 *
 * Pair B Output Task Overload When set, this bit indicates that pair B output
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AOOLB (18U)         /*!< Bit position for ASRC_ASRSTR_AOOLB. */
#define BM_ASRC_ASRSTR_AOOLB (0x00040000U) /*!< Bit mask for ASRC_ASRSTR_AOOLB. */
#define BS_ASRC_ASRSTR_AOOLB (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AOOLB. */

/*! @brief Read current value of the ASRC_ASRSTR_AOOLB field. */
#define BR_ASRC_ASRSTR_AOOLB(x) (HW_ASRC_ASRSTR(x).B.AOOLB)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field AOOLC[19] (RO)
 *
 * Pair C Output Task Overload When set, this bit indicates that pair C output
 * task is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_AOOLC (19U)         /*!< Bit position for ASRC_ASRSTR_AOOLC. */
#define BM_ASRC_ASRSTR_AOOLC (0x00080000U) /*!< Bit mask for ASRC_ASRSTR_AOOLC. */
#define BS_ASRC_ASRSTR_AOOLC (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_AOOLC. */

/*! @brief Read current value of the ASRC_ASRSTR_AOOLC field. */
#define BR_ASRC_ASRSTR_AOOLC(x) (HW_ASRC_ASRSTR(x).B.AOOLC)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field ATQOL[20] (RO)
 *
 * Task Queue FIFO overload When set, this bit indicates that task queue FIFO
 * logic is oveloaded. This may help to check the reason why overload interrupt
 * happens. The bit is cleared when writing ASRSTR:AOLE as 1.
 */
/*@{*/
#define BP_ASRC_ASRSTR_ATQOL (20U)         /*!< Bit position for ASRC_ASRSTR_ATQOL. */
#define BM_ASRC_ASRSTR_ATQOL (0x00100000U) /*!< Bit mask for ASRC_ASRSTR_ATQOL. */
#define BS_ASRC_ASRSTR_ATQOL (1U)          /*!< Bit field size in bits for ASRC_ASRSTR_ATQOL. */

/*! @brief Read current value of the ASRC_ASRSTR_ATQOL field. */
#define BR_ASRC_ASRSTR_ATQOL(x) (HW_ASRC_ASRSTR(x).B.ATQOL)
/*@}*/

/*!
 * @name Register ASRC_ASRSTR, field DSLCNT[21] (RO)
 *
 * DSL Counter Input to FIFO ready When set, this bit indicates that new DSL
 * counter information is stored in the internal ASRC FIFO. When clear, this bit
 * indicates that new DSL counter information is in the process of storage into the
 * internal ASRC FIFO. When ASRIER:AFPWE=1, the rising edge of this signal will
 * propose an interrupt request. Writing any value with this bit set will clear
 * the interrupt request proposed by the rising edge of this bit.
 */
/*@{*/
#define BP_ASRC_ASRSTR_DSLCNT (21U)        /*!< Bit position for ASRC_ASRSTR_DSLCNT. */
#define BM_ASRC_ASRSTR_DSLCNT (0x00200000U) /*!< Bit mask for ASRC_ASRSTR_DSLCNT. */
#define BS_ASRC_ASRSTR_DSLCNT (1U)         /*!< Bit field size in bits for ASRC_ASRSTR_DSLCNT. */

/*! @brief Read current value of the ASRC_ASRSTR_DSLCNT field. */
#define BR_ASRC_ASRSTR_DSLCNT(x) (HW_ASRC_ASRSTR(x).B.DSLCNT)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRPMn1 - ASRC Parameter Register n
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRPMn1 - ASRC Parameter Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Parameter registers determine the performance of ASRC. The parameter
 * registers must be initialized by software before ASRC is enabled. Recommended values
 * are given in ASRC Misc Control Register 1 for Pair CASRC Parameter Register n
 * below, ASRC Parameter Registers (ASRPM1~ASRPM5) Register Offset Access Reset
 * Value Recommend Value asrcpm1 0x40 R/W 0x00_0000 0x7fffff asrcpm2 0x44 R/W
 * 0x00_0000 0x255555 asrcpm3 0x48 R/W 0x00_0000 0xff7280 asrcpm4 0x4C R/W 0x00_0000
 * 0xff7280 asrcpm5 0x50 R/W 0x00_0000 0xff7280
 */
typedef union _hw_asrc_asrpmn1
{
    uint32_t U;
    struct _hw_asrc_asrpmn1_bitfields
    {
        uint32_t PARAMETER_VALUE : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrpmn1_t;

/*!
 * @name Constants and macros for entire ASRC_ASRPMn1 register
 */
/*@{*/
#define HW_ASRC_ASRPMn1_ADDR(x)  ((uintptr_t)(x) + 0x40U)

#define HW_ASRC_ASRPMn1(x)       (*(__IO hw_asrc_asrpmn1_t *) HW_ASRC_ASRPMn1_ADDR(x))
#define HW_ASRC_ASRPMn1_RD(x)    (HW_ASRC_ASRPMn1(x).U)
#define HW_ASRC_ASRPMn1_WR(x, v) (HW_ASRC_ASRPMn1(x).U = (v))
#define HW_ASRC_ASRPMn1_SET(x, v) (HW_ASRC_ASRPMn1_WR(x, HW_ASRC_ASRPMn1_RD(x) |  (v)))
#define HW_ASRC_ASRPMn1_CLR(x, v) (HW_ASRC_ASRPMn1_WR(x, HW_ASRC_ASRPMn1_RD(x) & ~(v)))
#define HW_ASRC_ASRPMn1_TOG(x, v) (HW_ASRC_ASRPMn1_WR(x, HW_ASRC_ASRPMn1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRPMn1 bitfields
 */

/*!
 * @name Register ASRC_ASRPMn1, field PARAMETER_VALUE[23:0] (RW)
 *
 * See recommended values table.
 */
/*@{*/
#define BP_ASRC_ASRPMn1_PARAMETER_VALUE (0U) /*!< Bit position for ASRC_ASRPMn1_PARAMETER_VALUE. */
#define BM_ASRC_ASRPMn1_PARAMETER_VALUE (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRPMn1_PARAMETER_VALUE. */
#define BS_ASRC_ASRPMn1_PARAMETER_VALUE (24U) /*!< Bit field size in bits for ASRC_ASRPMn1_PARAMETER_VALUE. */

/*! @brief Read current value of the ASRC_ASRPMn1_PARAMETER_VALUE field. */
#define BR_ASRC_ASRPMn1_PARAMETER_VALUE(x) (HW_ASRC_ASRPMn1(x).B.PARAMETER_VALUE)

/*! @brief Format value for bitfield ASRC_ASRPMn1_PARAMETER_VALUE. */
#define BF_ASRC_ASRPMn1_PARAMETER_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRPMn1_PARAMETER_VALUE) & BM_ASRC_ASRPMn1_PARAMETER_VALUE)

/*! @brief Set the PARAMETER_VALUE field to a new value. */
#define BW_ASRC_ASRPMn1_PARAMETER_VALUE(x, v) (HW_ASRC_ASRPMn1_WR(x, (HW_ASRC_ASRPMn1_RD(x) & ~BM_ASRC_ASRPMn1_PARAMETER_VALUE) | BF_ASRC_ASRPMn1_PARAMETER_VALUE(v)))
/*@}*/
/*******************************************************************************
 * HW_ASRC_ASRPMn2 - ASRC Parameter Register n
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRPMn2 - ASRC Parameter Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Parameter registers determine the performance of ASRC. The parameter
 * registers must be initialized by software before ASRC is enabled. Recommended values
 * are given in ASRC Misc Control Register 1 for Pair CASRC Parameter Register n
 * below, ASRC Parameter Registers (ASRPM1~ASRPM5) Register Offset Access Reset
 * Value Recommend Value asrcpm1 0x40 R/W 0x00_0000 0x7fffff asrcpm2 0x44 R/W
 * 0x00_0000 0x255555 asrcpm3 0x48 R/W 0x00_0000 0xff7280 asrcpm4 0x4C R/W 0x00_0000
 * 0xff7280 asrcpm5 0x50 R/W 0x00_0000 0xff7280
 */
typedef union _hw_asrc_asrpmn2
{
    uint32_t U;
    struct _hw_asrc_asrpmn2_bitfields
    {
        uint32_t PARAMETER_VALUE : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrpmn2_t;

/*!
 * @name Constants and macros for entire ASRC_ASRPMn2 register
 */
/*@{*/
#define HW_ASRC_ASRPMn2_ADDR(x)  ((uintptr_t)(x) + 0x44U)

#define HW_ASRC_ASRPMn2(x)       (*(__IO hw_asrc_asrpmn2_t *) HW_ASRC_ASRPMn2_ADDR(x))
#define HW_ASRC_ASRPMn2_RD(x)    (HW_ASRC_ASRPMn2(x).U)
#define HW_ASRC_ASRPMn2_WR(x, v) (HW_ASRC_ASRPMn2(x).U = (v))
#define HW_ASRC_ASRPMn2_SET(x, v) (HW_ASRC_ASRPMn2_WR(x, HW_ASRC_ASRPMn2_RD(x) |  (v)))
#define HW_ASRC_ASRPMn2_CLR(x, v) (HW_ASRC_ASRPMn2_WR(x, HW_ASRC_ASRPMn2_RD(x) & ~(v)))
#define HW_ASRC_ASRPMn2_TOG(x, v) (HW_ASRC_ASRPMn2_WR(x, HW_ASRC_ASRPMn2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRPMn2 bitfields
 */

/*!
 * @name Register ASRC_ASRPMn2, field PARAMETER_VALUE[23:0] (RW)
 *
 * See recommended values table.
 */
/*@{*/
#define BP_ASRC_ASRPMn2_PARAMETER_VALUE (0U) /*!< Bit position for ASRC_ASRPMn2_PARAMETER_VALUE. */
#define BM_ASRC_ASRPMn2_PARAMETER_VALUE (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRPMn2_PARAMETER_VALUE. */
#define BS_ASRC_ASRPMn2_PARAMETER_VALUE (24U) /*!< Bit field size in bits for ASRC_ASRPMn2_PARAMETER_VALUE. */

/*! @brief Read current value of the ASRC_ASRPMn2_PARAMETER_VALUE field. */
#define BR_ASRC_ASRPMn2_PARAMETER_VALUE(x) (HW_ASRC_ASRPMn2(x).B.PARAMETER_VALUE)

/*! @brief Format value for bitfield ASRC_ASRPMn2_PARAMETER_VALUE. */
#define BF_ASRC_ASRPMn2_PARAMETER_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRPMn2_PARAMETER_VALUE) & BM_ASRC_ASRPMn2_PARAMETER_VALUE)

/*! @brief Set the PARAMETER_VALUE field to a new value. */
#define BW_ASRC_ASRPMn2_PARAMETER_VALUE(x, v) (HW_ASRC_ASRPMn2_WR(x, (HW_ASRC_ASRPMn2_RD(x) & ~BM_ASRC_ASRPMn2_PARAMETER_VALUE) | BF_ASRC_ASRPMn2_PARAMETER_VALUE(v)))
/*@}*/
/*******************************************************************************
 * HW_ASRC_ASRPMn3 - ASRC Parameter Register n
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRPMn3 - ASRC Parameter Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Parameter registers determine the performance of ASRC. The parameter
 * registers must be initialized by software before ASRC is enabled. Recommended values
 * are given in ASRC Misc Control Register 1 for Pair CASRC Parameter Register n
 * below, ASRC Parameter Registers (ASRPM1~ASRPM5) Register Offset Access Reset
 * Value Recommend Value asrcpm1 0x40 R/W 0x00_0000 0x7fffff asrcpm2 0x44 R/W
 * 0x00_0000 0x255555 asrcpm3 0x48 R/W 0x00_0000 0xff7280 asrcpm4 0x4C R/W 0x00_0000
 * 0xff7280 asrcpm5 0x50 R/W 0x00_0000 0xff7280
 */
typedef union _hw_asrc_asrpmn3
{
    uint32_t U;
    struct _hw_asrc_asrpmn3_bitfields
    {
        uint32_t PARAMETER_VALUE : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrpmn3_t;

/*!
 * @name Constants and macros for entire ASRC_ASRPMn3 register
 */
/*@{*/
#define HW_ASRC_ASRPMn3_ADDR(x)  ((uintptr_t)(x) + 0x48U)

#define HW_ASRC_ASRPMn3(x)       (*(__IO hw_asrc_asrpmn3_t *) HW_ASRC_ASRPMn3_ADDR(x))
#define HW_ASRC_ASRPMn3_RD(x)    (HW_ASRC_ASRPMn3(x).U)
#define HW_ASRC_ASRPMn3_WR(x, v) (HW_ASRC_ASRPMn3(x).U = (v))
#define HW_ASRC_ASRPMn3_SET(x, v) (HW_ASRC_ASRPMn3_WR(x, HW_ASRC_ASRPMn3_RD(x) |  (v)))
#define HW_ASRC_ASRPMn3_CLR(x, v) (HW_ASRC_ASRPMn3_WR(x, HW_ASRC_ASRPMn3_RD(x) & ~(v)))
#define HW_ASRC_ASRPMn3_TOG(x, v) (HW_ASRC_ASRPMn3_WR(x, HW_ASRC_ASRPMn3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRPMn3 bitfields
 */

/*!
 * @name Register ASRC_ASRPMn3, field PARAMETER_VALUE[23:0] (RW)
 *
 * See recommended values table.
 */
/*@{*/
#define BP_ASRC_ASRPMn3_PARAMETER_VALUE (0U) /*!< Bit position for ASRC_ASRPMn3_PARAMETER_VALUE. */
#define BM_ASRC_ASRPMn3_PARAMETER_VALUE (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRPMn3_PARAMETER_VALUE. */
#define BS_ASRC_ASRPMn3_PARAMETER_VALUE (24U) /*!< Bit field size in bits for ASRC_ASRPMn3_PARAMETER_VALUE. */

/*! @brief Read current value of the ASRC_ASRPMn3_PARAMETER_VALUE field. */
#define BR_ASRC_ASRPMn3_PARAMETER_VALUE(x) (HW_ASRC_ASRPMn3(x).B.PARAMETER_VALUE)

/*! @brief Format value for bitfield ASRC_ASRPMn3_PARAMETER_VALUE. */
#define BF_ASRC_ASRPMn3_PARAMETER_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRPMn3_PARAMETER_VALUE) & BM_ASRC_ASRPMn3_PARAMETER_VALUE)

/*! @brief Set the PARAMETER_VALUE field to a new value. */
#define BW_ASRC_ASRPMn3_PARAMETER_VALUE(x, v) (HW_ASRC_ASRPMn3_WR(x, (HW_ASRC_ASRPMn3_RD(x) & ~BM_ASRC_ASRPMn3_PARAMETER_VALUE) | BF_ASRC_ASRPMn3_PARAMETER_VALUE(v)))
/*@}*/
/*******************************************************************************
 * HW_ASRC_ASRPMn4 - ASRC Parameter Register n
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRPMn4 - ASRC Parameter Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Parameter registers determine the performance of ASRC. The parameter
 * registers must be initialized by software before ASRC is enabled. Recommended values
 * are given in ASRC Misc Control Register 1 for Pair CASRC Parameter Register n
 * below, ASRC Parameter Registers (ASRPM1~ASRPM5) Register Offset Access Reset
 * Value Recommend Value asrcpm1 0x40 R/W 0x00_0000 0x7fffff asrcpm2 0x44 R/W
 * 0x00_0000 0x255555 asrcpm3 0x48 R/W 0x00_0000 0xff7280 asrcpm4 0x4C R/W 0x00_0000
 * 0xff7280 asrcpm5 0x50 R/W 0x00_0000 0xff7280
 */
typedef union _hw_asrc_asrpmn4
{
    uint32_t U;
    struct _hw_asrc_asrpmn4_bitfields
    {
        uint32_t PARAMETER_VALUE : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrpmn4_t;

/*!
 * @name Constants and macros for entire ASRC_ASRPMn4 register
 */
/*@{*/
#define HW_ASRC_ASRPMn4_ADDR(x)  ((uintptr_t)(x) + 0x4CU)

#define HW_ASRC_ASRPMn4(x)       (*(__IO hw_asrc_asrpmn4_t *) HW_ASRC_ASRPMn4_ADDR(x))
#define HW_ASRC_ASRPMn4_RD(x)    (HW_ASRC_ASRPMn4(x).U)
#define HW_ASRC_ASRPMn4_WR(x, v) (HW_ASRC_ASRPMn4(x).U = (v))
#define HW_ASRC_ASRPMn4_SET(x, v) (HW_ASRC_ASRPMn4_WR(x, HW_ASRC_ASRPMn4_RD(x) |  (v)))
#define HW_ASRC_ASRPMn4_CLR(x, v) (HW_ASRC_ASRPMn4_WR(x, HW_ASRC_ASRPMn4_RD(x) & ~(v)))
#define HW_ASRC_ASRPMn4_TOG(x, v) (HW_ASRC_ASRPMn4_WR(x, HW_ASRC_ASRPMn4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRPMn4 bitfields
 */

/*!
 * @name Register ASRC_ASRPMn4, field PARAMETER_VALUE[23:0] (RW)
 *
 * See recommended values table.
 */
/*@{*/
#define BP_ASRC_ASRPMn4_PARAMETER_VALUE (0U) /*!< Bit position for ASRC_ASRPMn4_PARAMETER_VALUE. */
#define BM_ASRC_ASRPMn4_PARAMETER_VALUE (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRPMn4_PARAMETER_VALUE. */
#define BS_ASRC_ASRPMn4_PARAMETER_VALUE (24U) /*!< Bit field size in bits for ASRC_ASRPMn4_PARAMETER_VALUE. */

/*! @brief Read current value of the ASRC_ASRPMn4_PARAMETER_VALUE field. */
#define BR_ASRC_ASRPMn4_PARAMETER_VALUE(x) (HW_ASRC_ASRPMn4(x).B.PARAMETER_VALUE)

/*! @brief Format value for bitfield ASRC_ASRPMn4_PARAMETER_VALUE. */
#define BF_ASRC_ASRPMn4_PARAMETER_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRPMn4_PARAMETER_VALUE) & BM_ASRC_ASRPMn4_PARAMETER_VALUE)

/*! @brief Set the PARAMETER_VALUE field to a new value. */
#define BW_ASRC_ASRPMn4_PARAMETER_VALUE(x, v) (HW_ASRC_ASRPMn4_WR(x, (HW_ASRC_ASRPMn4_RD(x) & ~BM_ASRC_ASRPMn4_PARAMETER_VALUE) | BF_ASRC_ASRPMn4_PARAMETER_VALUE(v)))
/*@}*/
/*******************************************************************************
 * HW_ASRC_ASRPMn5 - ASRC Parameter Register n
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRPMn5 - ASRC Parameter Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Parameter registers determine the performance of ASRC. The parameter
 * registers must be initialized by software before ASRC is enabled. Recommended values
 * are given in ASRC Misc Control Register 1 for Pair CASRC Parameter Register n
 * below, ASRC Parameter Registers (ASRPM1~ASRPM5) Register Offset Access Reset
 * Value Recommend Value asrcpm1 0x40 R/W 0x00_0000 0x7fffff asrcpm2 0x44 R/W
 * 0x00_0000 0x255555 asrcpm3 0x48 R/W 0x00_0000 0xff7280 asrcpm4 0x4C R/W 0x00_0000
 * 0xff7280 asrcpm5 0x50 R/W 0x00_0000 0xff7280
 */
typedef union _hw_asrc_asrpmn5
{
    uint32_t U;
    struct _hw_asrc_asrpmn5_bitfields
    {
        uint32_t PARAMETER_VALUE : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrpmn5_t;

/*!
 * @name Constants and macros for entire ASRC_ASRPMn5 register
 */
/*@{*/
#define HW_ASRC_ASRPMn5_ADDR(x)  ((uintptr_t)(x) + 0x50U)

#define HW_ASRC_ASRPMn5(x)       (*(__IO hw_asrc_asrpmn5_t *) HW_ASRC_ASRPMn5_ADDR(x))
#define HW_ASRC_ASRPMn5_RD(x)    (HW_ASRC_ASRPMn5(x).U)
#define HW_ASRC_ASRPMn5_WR(x, v) (HW_ASRC_ASRPMn5(x).U = (v))
#define HW_ASRC_ASRPMn5_SET(x, v) (HW_ASRC_ASRPMn5_WR(x, HW_ASRC_ASRPMn5_RD(x) |  (v)))
#define HW_ASRC_ASRPMn5_CLR(x, v) (HW_ASRC_ASRPMn5_WR(x, HW_ASRC_ASRPMn5_RD(x) & ~(v)))
#define HW_ASRC_ASRPMn5_TOG(x, v) (HW_ASRC_ASRPMn5_WR(x, HW_ASRC_ASRPMn5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRPMn5 bitfields
 */

/*!
 * @name Register ASRC_ASRPMn5, field PARAMETER_VALUE[23:0] (RW)
 *
 * See recommended values table.
 */
/*@{*/
#define BP_ASRC_ASRPMn5_PARAMETER_VALUE (0U) /*!< Bit position for ASRC_ASRPMn5_PARAMETER_VALUE. */
#define BM_ASRC_ASRPMn5_PARAMETER_VALUE (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRPMn5_PARAMETER_VALUE. */
#define BS_ASRC_ASRPMn5_PARAMETER_VALUE (24U) /*!< Bit field size in bits for ASRC_ASRPMn5_PARAMETER_VALUE. */

/*! @brief Read current value of the ASRC_ASRPMn5_PARAMETER_VALUE field. */
#define BR_ASRC_ASRPMn5_PARAMETER_VALUE(x) (HW_ASRC_ASRPMn5(x).B.PARAMETER_VALUE)

/*! @brief Format value for bitfield ASRC_ASRPMn5_PARAMETER_VALUE. */
#define BF_ASRC_ASRPMn5_PARAMETER_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRPMn5_PARAMETER_VALUE) & BM_ASRC_ASRPMn5_PARAMETER_VALUE)

/*! @brief Set the PARAMETER_VALUE field to a new value. */
#define BW_ASRC_ASRPMn5_PARAMETER_VALUE(x, v) (HW_ASRC_ASRPMn5_WR(x, (HW_ASRC_ASRPMn5_RD(x) & ~BM_ASRC_ASRPMn5_PARAMETER_VALUE) | BF_ASRC_ASRPMn5_PARAMETER_VALUE(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRTFR1 - ASRC ASRC Task Queue FIFO Register 1
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRTFR1 - ASRC ASRC Task Queue FIFO Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register defines and shows the parameters for ASRC inner task queue FIFOs.
 */
typedef union _hw_asrc_asrtfr1
{
    uint32_t U;
    struct _hw_asrc_asrtfr1_bitfields
    {
        uint32_t RESERVED0 : 6;        /*!< [5:0]  */
        uint32_t TF_BASE : 7;          /*!< [12:6]  */
        uint32_t TF_FILL : 7;          /*!< [19:13]  */
        uint32_t RESERVED1 : 12;       /*!< [31:20] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrtfr1_t;

/*!
 * @name Constants and macros for entire ASRC_ASRTFR1 register
 */
/*@{*/
#define HW_ASRC_ASRTFR1_ADDR(x)  ((uintptr_t)(x) + 0x54U)

#define HW_ASRC_ASRTFR1(x)       (*(__IO hw_asrc_asrtfr1_t *) HW_ASRC_ASRTFR1_ADDR(x))
#define HW_ASRC_ASRTFR1_RD(x)    (HW_ASRC_ASRTFR1(x).U)
#define HW_ASRC_ASRTFR1_WR(x, v) (HW_ASRC_ASRTFR1(x).U = (v))
#define HW_ASRC_ASRTFR1_SET(x, v) (HW_ASRC_ASRTFR1_WR(x, HW_ASRC_ASRTFR1_RD(x) |  (v)))
#define HW_ASRC_ASRTFR1_CLR(x, v) (HW_ASRC_ASRTFR1_WR(x, HW_ASRC_ASRTFR1_RD(x) & ~(v)))
#define HW_ASRC_ASRTFR1_TOG(x, v) (HW_ASRC_ASRTFR1_WR(x, HW_ASRC_ASRTFR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRTFR1 bitfields
 */

/*!
 * @name Register ASRC_ASRTFR1, field TF_BASE[12:6] (RW)
 *
 * Base address for task queue FIFO. Set to 0x7C.
 */
/*@{*/
#define BP_ASRC_ASRTFR1_TF_BASE (6U)       /*!< Bit position for ASRC_ASRTFR1_TF_BASE. */
#define BM_ASRC_ASRTFR1_TF_BASE (0x00001FC0U) /*!< Bit mask for ASRC_ASRTFR1_TF_BASE. */
#define BS_ASRC_ASRTFR1_TF_BASE (7U)       /*!< Bit field size in bits for ASRC_ASRTFR1_TF_BASE. */

/*! @brief Read current value of the ASRC_ASRTFR1_TF_BASE field. */
#define BR_ASRC_ASRTFR1_TF_BASE(x) (HW_ASRC_ASRTFR1(x).B.TF_BASE)

/*! @brief Format value for bitfield ASRC_ASRTFR1_TF_BASE. */
#define BF_ASRC_ASRTFR1_TF_BASE(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRTFR1_TF_BASE) & BM_ASRC_ASRTFR1_TF_BASE)

/*! @brief Set the TF_BASE field to a new value. */
#define BW_ASRC_ASRTFR1_TF_BASE(x, v) (HW_ASRC_ASRTFR1_WR(x, (HW_ASRC_ASRTFR1_RD(x) & ~BM_ASRC_ASRTFR1_TF_BASE) | BF_ASRC_ASRTFR1_TF_BASE(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRTFR1, field TF_FILL[19:13] (RO)
 *
 * Current number of entries in task queue FIFO.
 */
/*@{*/
#define BP_ASRC_ASRTFR1_TF_FILL (13U)      /*!< Bit position for ASRC_ASRTFR1_TF_FILL. */
#define BM_ASRC_ASRTFR1_TF_FILL (0x000FE000U) /*!< Bit mask for ASRC_ASRTFR1_TF_FILL. */
#define BS_ASRC_ASRTFR1_TF_FILL (7U)       /*!< Bit field size in bits for ASRC_ASRTFR1_TF_FILL. */

/*! @brief Read current value of the ASRC_ASRTFR1_TF_FILL field. */
#define BR_ASRC_ASRTFR1_TF_FILL(x) (HW_ASRC_ASRTFR1(x).B.TF_FILL)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRCCR - ASRC Channel Counter Register
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRCCR - ASRC Channel Counter Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ASRC channel counter register (ASRCCR) is a 24-bit read/write register
 * that sets and reflects the current specific input/output FIFO being accessed
 * through shared peripheral bus for each ASRC conversion pair.
 */
typedef union _hw_asrc_asrccr
{
    uint32_t U;
    struct _hw_asrc_asrccr_bitfields
    {
        uint32_t ACIA : 4;             /*!< [3:0]  */
        uint32_t ACIB : 4;             /*!< [7:4]  */
        uint32_t ACIC : 4;             /*!< [11:8]  */
        uint32_t ACOA : 4;             /*!< [15:12]  */
        uint32_t ACOB : 4;             /*!< [19:16]  */
        uint32_t ACOC : 4;             /*!< [23:20]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrccr_t;

/*!
 * @name Constants and macros for entire ASRC_ASRCCR register
 */
/*@{*/
#define HW_ASRC_ASRCCR_ADDR(x)   ((uintptr_t)(x) + 0x5CU)

#define HW_ASRC_ASRCCR(x)        (*(__IO hw_asrc_asrccr_t *) HW_ASRC_ASRCCR_ADDR(x))
#define HW_ASRC_ASRCCR_RD(x)     (HW_ASRC_ASRCCR(x).U)
#define HW_ASRC_ASRCCR_WR(x, v)  (HW_ASRC_ASRCCR(x).U = (v))
#define HW_ASRC_ASRCCR_SET(x, v) (HW_ASRC_ASRCCR_WR(x, HW_ASRC_ASRCCR_RD(x) |  (v)))
#define HW_ASRC_ASRCCR_CLR(x, v) (HW_ASRC_ASRCCR_WR(x, HW_ASRC_ASRCCR_RD(x) & ~(v)))
#define HW_ASRC_ASRCCR_TOG(x, v) (HW_ASRC_ASRCCR_WR(x, HW_ASRC_ASRCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRCCR bitfields
 */

/*!
 * @name Register ASRC_ASRCCR, field ACIA[3:0] (RW)
 *
 * The channel counter for Pair A's input FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair A's input FIFO's
 * usage. The value can be any value between [0, ANCA-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACIA  (0U)          /*!< Bit position for ASRC_ASRCCR_ACIA. */
#define BM_ASRC_ASRCCR_ACIA  (0x0000000FU) /*!< Bit mask for ASRC_ASRCCR_ACIA. */
#define BS_ASRC_ASRCCR_ACIA  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACIA. */

/*! @brief Read current value of the ASRC_ASRCCR_ACIA field. */
#define BR_ASRC_ASRCCR_ACIA(x) (HW_ASRC_ASRCCR(x).B.ACIA)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACIA. */
#define BF_ASRC_ASRCCR_ACIA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACIA) & BM_ASRC_ASRCCR_ACIA)

/*! @brief Set the ACIA field to a new value. */
#define BW_ASRC_ASRCCR_ACIA(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACIA) | BF_ASRC_ASRCCR_ACIA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCCR, field ACIB[7:4] (RW)
 *
 * The channel counter for Pair B's input FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair B's input FIFO's
 * usage. The value can be any value between [0, ANCB-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACIB  (4U)          /*!< Bit position for ASRC_ASRCCR_ACIB. */
#define BM_ASRC_ASRCCR_ACIB  (0x000000F0U) /*!< Bit mask for ASRC_ASRCCR_ACIB. */
#define BS_ASRC_ASRCCR_ACIB  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACIB. */

/*! @brief Read current value of the ASRC_ASRCCR_ACIB field. */
#define BR_ASRC_ASRCCR_ACIB(x) (HW_ASRC_ASRCCR(x).B.ACIB)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACIB. */
#define BF_ASRC_ASRCCR_ACIB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACIB) & BM_ASRC_ASRCCR_ACIB)

/*! @brief Set the ACIB field to a new value. */
#define BW_ASRC_ASRCCR_ACIB(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACIB) | BF_ASRC_ASRCCR_ACIB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCCR, field ACIC[11:8] (RW)
 *
 * The channel counter for Pair C's input FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair C's input FIFO's
 * usage. The value can be any value between [0, ANCC-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACIC  (8U)          /*!< Bit position for ASRC_ASRCCR_ACIC. */
#define BM_ASRC_ASRCCR_ACIC  (0x00000F00U) /*!< Bit mask for ASRC_ASRCCR_ACIC. */
#define BS_ASRC_ASRCCR_ACIC  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACIC. */

/*! @brief Read current value of the ASRC_ASRCCR_ACIC field. */
#define BR_ASRC_ASRCCR_ACIC(x) (HW_ASRC_ASRCCR(x).B.ACIC)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACIC. */
#define BF_ASRC_ASRCCR_ACIC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACIC) & BM_ASRC_ASRCCR_ACIC)

/*! @brief Set the ACIC field to a new value. */
#define BW_ASRC_ASRCCR_ACIC(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACIC) | BF_ASRC_ASRCCR_ACIC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCCR, field ACOA[15:12] (RW)
 *
 * The channel counter for Pair A's output FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair A's output
 * FIFO's usage. The value can be any value between [0, ANCA-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACOA  (12U)         /*!< Bit position for ASRC_ASRCCR_ACOA. */
#define BM_ASRC_ASRCCR_ACOA  (0x0000F000U) /*!< Bit mask for ASRC_ASRCCR_ACOA. */
#define BS_ASRC_ASRCCR_ACOA  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACOA. */

/*! @brief Read current value of the ASRC_ASRCCR_ACOA field. */
#define BR_ASRC_ASRCCR_ACOA(x) (HW_ASRC_ASRCCR(x).B.ACOA)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACOA. */
#define BF_ASRC_ASRCCR_ACOA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACOA) & BM_ASRC_ASRCCR_ACOA)

/*! @brief Set the ACOA field to a new value. */
#define BW_ASRC_ASRCCR_ACOA(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACOA) | BF_ASRC_ASRCCR_ACOA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCCR, field ACOB[19:16] (RW)
 *
 * The channel counter for Pair B's output FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair B's output
 * FIFO's usage. The value can be any value between [0, ANCB-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACOB  (16U)         /*!< Bit position for ASRC_ASRCCR_ACOB. */
#define BM_ASRC_ASRCCR_ACOB  (0x000F0000U) /*!< Bit mask for ASRC_ASRCCR_ACOB. */
#define BS_ASRC_ASRCCR_ACOB  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACOB. */

/*! @brief Read current value of the ASRC_ASRCCR_ACOB field. */
#define BR_ASRC_ASRCCR_ACOB(x) (HW_ASRC_ASRCCR(x).B.ACOB)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACOB. */
#define BF_ASRC_ASRCCR_ACOB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACOB) & BM_ASRC_ASRCCR_ACOB)

/*! @brief Set the ACOB field to a new value. */
#define BW_ASRC_ASRCCR_ACOB(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACOB) | BF_ASRC_ASRCCR_ACOB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRCCR, field ACOC[23:20] (RW)
 *
 * The channel counter for Pair C's output FIFO These bits stand for the current
 * channel being accessed through shared peripheral bus for Pair C's output
 * FIFO's usage. The value can be any value between [0, ANCC-1]
 */
/*@{*/
#define BP_ASRC_ASRCCR_ACOC  (20U)         /*!< Bit position for ASRC_ASRCCR_ACOC. */
#define BM_ASRC_ASRCCR_ACOC  (0x00F00000U) /*!< Bit mask for ASRC_ASRCCR_ACOC. */
#define BS_ASRC_ASRCCR_ACOC  (4U)          /*!< Bit field size in bits for ASRC_ASRCCR_ACOC. */

/*! @brief Read current value of the ASRC_ASRCCR_ACOC field. */
#define BR_ASRC_ASRCCR_ACOC(x) (HW_ASRC_ASRCCR(x).B.ACOC)

/*! @brief Format value for bitfield ASRC_ASRCCR_ACOC. */
#define BF_ASRC_ASRCCR_ACOC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRCCR_ACOC) & BM_ASRC_ASRCCR_ACOC)

/*! @brief Set the ACOC field to a new value. */
#define BW_ASRC_ASRCCR_ACOC(x, v) (HW_ASRC_ASRCCR_WR(x, (HW_ASRC_ASRCCR_RD(x) & ~BM_ASRC_ASRCCR_ACOC) | BF_ASRC_ASRCCR_ACOC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRDIn - ASRC Data Input Register for Pair x
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRDIn - ASRC Data Input Register for Pair x (WO)
 *
 * Reset value: 0x00000000U
 *
 * These registers are the interface registers for the audio data input of pair
 * A,B,C respectively. They are backed by FIFOs.
 */
typedef union _hw_asrc_asrdin
{
    uint32_t U;
    struct _hw_asrc_asrdin_bitfields
    {
        uint32_t DATA : 24;            /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrdin_t;

/*!
 * @name Constants and macros for entire ASRC_ASRDIn register
 */
/*@{*/
#define HW_ASRC_ASRDIn_COUNT (3U)

#define HW_ASRC_ASRDIn_ADDR(x, n) ((uintptr_t)(x) + 0x60U + (0x8U * (n)))

#define HW_ASRC_ASRDIn(x, n)     (*(__O hw_asrc_asrdin_t *) HW_ASRC_ASRDIn_ADDR(x, n))
#define HW_ASRC_ASRDIn_WR(x, n, v) (HW_ASRC_ASRDIn(x, n).U = (v))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRDIn bitfields
 */

/*!
 * @name Register ASRC_ASRDIn, field DATA[23:0] (WO)
 *
 * Audio data input
 */
/*@{*/
#define BP_ASRC_ASRDIn_DATA  (0U)          /*!< Bit position for ASRC_ASRDIn_DATA. */
#define BM_ASRC_ASRDIn_DATA  (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRDIn_DATA. */
#define BS_ASRC_ASRDIn_DATA  (24U)         /*!< Bit field size in bits for ASRC_ASRDIn_DATA. */

/*! @brief Format value for bitfield ASRC_ASRDIn_DATA. */
#define BF_ASRC_ASRDIn_DATA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRDIn_DATA) & BM_ASRC_ASRDIn_DATA)
/*@}*/
/*******************************************************************************
 * HW_ASRC_ASRDOn - ASRC Data Output Register for Pair x
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRDOn - ASRC Data Output Register for Pair x (RO)
 *
 * Reset value: 0x00000000U
 *
 * These registers are the interface registers for the audio data output of pair
 * A,B,C respectively. They are backed by FIFOs.
 */
typedef union _hw_asrc_asrdon
{
    uint32_t U;
    struct _hw_asrc_asrdon_bitfields
    {
        uint32_t DATA : 24;            /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrdon_t;

/*!
 * @name Constants and macros for entire ASRC_ASRDOn register
 */
/*@{*/
#define HW_ASRC_ASRDOn_COUNT (3U)

#define HW_ASRC_ASRDOn_ADDR(x, n) ((uintptr_t)(x) + 0x64U + (0x8U * (n)))

#define HW_ASRC_ASRDOn(x, n)     (*(__I hw_asrc_asrdon_t *) HW_ASRC_ASRDOn_ADDR(x, n))
#define HW_ASRC_ASRDOn_RD(x, n)  (HW_ASRC_ASRDOn(x, n).U)
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRDOn bitfields
 */

/*!
 * @name Register ASRC_ASRDOn, field DATA[23:0] (RO)
 *
 * Audio data output
 */
/*@{*/
#define BP_ASRC_ASRDOn_DATA  (0U)          /*!< Bit position for ASRC_ASRDOn_DATA. */
#define BM_ASRC_ASRDOn_DATA  (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRDOn_DATA. */
#define BS_ASRC_ASRDOn_DATA  (24U)         /*!< Bit field size in bits for ASRC_ASRDOn_DATA. */

/*! @brief Read current value of the ASRC_ASRDOn_DATA field. */
#define BR_ASRC_ASRDOn_DATA(x, n) (HW_ASRC_ASRDOn(x, n).B.DATA)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRHA - ASRC Ideal Ratio for Pair A-High Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRHA - ASRC Ideal Ratio for Pair A-High Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHA, ASRIDRLA) hold the ratio value IDRATIOA.
 * IDRATIOA = FsinA/FsoutA = TsoutA/TsinA is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRA, IDRA}=2'b11.
 */
typedef union _hw_asrc_asridrha
{
    uint32_t U;
    struct _hw_asrc_asridrha_bitfields
    {
        uint32_t IDRATIOA : 8;         /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrha_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRHA register
 */
/*@{*/
#define HW_ASRC_ASRIDRHA_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_ASRC_ASRIDRHA(x)      (*(__IO hw_asrc_asridrha_t *) HW_ASRC_ASRIDRHA_ADDR(x))
#define HW_ASRC_ASRIDRHA_RD(x)   (HW_ASRC_ASRIDRHA(x).U)
#define HW_ASRC_ASRIDRHA_WR(x, v) (HW_ASRC_ASRIDRHA(x).U = (v))
#define HW_ASRC_ASRIDRHA_SET(x, v) (HW_ASRC_ASRIDRHA_WR(x, HW_ASRC_ASRIDRHA_RD(x) |  (v)))
#define HW_ASRC_ASRIDRHA_CLR(x, v) (HW_ASRC_ASRIDRHA_WR(x, HW_ASRC_ASRIDRHA_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRHA_TOG(x, v) (HW_ASRC_ASRIDRHA_WR(x, HW_ASRC_ASRIDRHA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRHA bitfields
 */

/*!
 * @name Register ASRC_ASRIDRHA, field IDRATIOA[7:0] (RW)
 *
 * IDRATIOA[31:24]. High part of ideal ratio value for pair A
 */
/*@{*/
#define BP_ASRC_ASRIDRHA_IDRATIOA (0U)     /*!< Bit position for ASRC_ASRIDRHA_IDRATIOA. */
#define BM_ASRC_ASRIDRHA_IDRATIOA (0x000000FFU) /*!< Bit mask for ASRC_ASRIDRHA_IDRATIOA. */
#define BS_ASRC_ASRIDRHA_IDRATIOA (8U)     /*!< Bit field size in bits for ASRC_ASRIDRHA_IDRATIOA. */

/*! @brief Read current value of the ASRC_ASRIDRHA_IDRATIOA field. */
#define BR_ASRC_ASRIDRHA_IDRATIOA(x) (HW_ASRC_ASRIDRHA(x).B.IDRATIOA)

/*! @brief Format value for bitfield ASRC_ASRIDRHA_IDRATIOA. */
#define BF_ASRC_ASRIDRHA_IDRATIOA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRHA_IDRATIOA) & BM_ASRC_ASRIDRHA_IDRATIOA)

/*! @brief Set the IDRATIOA field to a new value. */
#define BW_ASRC_ASRIDRHA_IDRATIOA(x, v) (HW_ASRC_ASRIDRHA_WR(x, (HW_ASRC_ASRIDRHA_RD(x) & ~BM_ASRC_ASRIDRHA_IDRATIOA) | BF_ASRC_ASRIDRHA_IDRATIOA(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRLA - ASRC Ideal Ratio for Pair A -Low Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRLA - ASRC Ideal Ratio for Pair A -Low Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHA, ASRIDRLA) hold the ratio value IDRATIOA.
 * IDRATIOA = FsinA/FsoutA = TsoutA/TsinA is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRA, IDRA}=2'b11.
 */
typedef union _hw_asrc_asridrla
{
    uint32_t U;
    struct _hw_asrc_asridrla_bitfields
    {
        uint32_t IDRATIOA : 24;        /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrla_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRLA register
 */
/*@{*/
#define HW_ASRC_ASRIDRLA_ADDR(x) ((uintptr_t)(x) + 0x84U)

#define HW_ASRC_ASRIDRLA(x)      (*(__IO hw_asrc_asridrla_t *) HW_ASRC_ASRIDRLA_ADDR(x))
#define HW_ASRC_ASRIDRLA_RD(x)   (HW_ASRC_ASRIDRLA(x).U)
#define HW_ASRC_ASRIDRLA_WR(x, v) (HW_ASRC_ASRIDRLA(x).U = (v))
#define HW_ASRC_ASRIDRLA_SET(x, v) (HW_ASRC_ASRIDRLA_WR(x, HW_ASRC_ASRIDRLA_RD(x) |  (v)))
#define HW_ASRC_ASRIDRLA_CLR(x, v) (HW_ASRC_ASRIDRLA_WR(x, HW_ASRC_ASRIDRLA_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRLA_TOG(x, v) (HW_ASRC_ASRIDRLA_WR(x, HW_ASRC_ASRIDRLA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRLA bitfields
 */

/*!
 * @name Register ASRC_ASRIDRLA, field IDRATIOA[23:0] (RW)
 *
 * IDRATIOA[23:0]. Low part of ideal ratio value for pair A
 */
/*@{*/
#define BP_ASRC_ASRIDRLA_IDRATIOA (0U)     /*!< Bit position for ASRC_ASRIDRLA_IDRATIOA. */
#define BM_ASRC_ASRIDRLA_IDRATIOA (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRIDRLA_IDRATIOA. */
#define BS_ASRC_ASRIDRLA_IDRATIOA (24U)    /*!< Bit field size in bits for ASRC_ASRIDRLA_IDRATIOA. */

/*! @brief Read current value of the ASRC_ASRIDRLA_IDRATIOA field. */
#define BR_ASRC_ASRIDRLA_IDRATIOA(x) (HW_ASRC_ASRIDRLA(x).B.IDRATIOA)

/*! @brief Format value for bitfield ASRC_ASRIDRLA_IDRATIOA. */
#define BF_ASRC_ASRIDRLA_IDRATIOA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRLA_IDRATIOA) & BM_ASRC_ASRIDRLA_IDRATIOA)

/*! @brief Set the IDRATIOA field to a new value. */
#define BW_ASRC_ASRIDRLA_IDRATIOA(x, v) (HW_ASRC_ASRIDRLA_WR(x, (HW_ASRC_ASRIDRLA_RD(x) & ~BM_ASRC_ASRIDRLA_IDRATIOA) | BF_ASRC_ASRIDRLA_IDRATIOA(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRHB - ASRC Ideal Ratio for Pair B-High Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRHB - ASRC Ideal Ratio for Pair B-High Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHB, ASRIDRLB) hold the ratio value IDRATIOB.
 * IDRATIOB = FsinB/FsoutB = TsoutB/TsinB is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRB, IDRB}=2'b11.
 */
typedef union _hw_asrc_asridrhb
{
    uint32_t U;
    struct _hw_asrc_asridrhb_bitfields
    {
        uint32_t IDRATIOB : 8;         /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrhb_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRHB register
 */
/*@{*/
#define HW_ASRC_ASRIDRHB_ADDR(x) ((uintptr_t)(x) + 0x88U)

#define HW_ASRC_ASRIDRHB(x)      (*(__IO hw_asrc_asridrhb_t *) HW_ASRC_ASRIDRHB_ADDR(x))
#define HW_ASRC_ASRIDRHB_RD(x)   (HW_ASRC_ASRIDRHB(x).U)
#define HW_ASRC_ASRIDRHB_WR(x, v) (HW_ASRC_ASRIDRHB(x).U = (v))
#define HW_ASRC_ASRIDRHB_SET(x, v) (HW_ASRC_ASRIDRHB_WR(x, HW_ASRC_ASRIDRHB_RD(x) |  (v)))
#define HW_ASRC_ASRIDRHB_CLR(x, v) (HW_ASRC_ASRIDRHB_WR(x, HW_ASRC_ASRIDRHB_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRHB_TOG(x, v) (HW_ASRC_ASRIDRHB_WR(x, HW_ASRC_ASRIDRHB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRHB bitfields
 */

/*!
 * @name Register ASRC_ASRIDRHB, field IDRATIOB[7:0] (RW)
 *
 * IDRATIOB[31:24]. High part of ideal ratio value for pair B.
 */
/*@{*/
#define BP_ASRC_ASRIDRHB_IDRATIOB (0U)     /*!< Bit position for ASRC_ASRIDRHB_IDRATIOB. */
#define BM_ASRC_ASRIDRHB_IDRATIOB (0x000000FFU) /*!< Bit mask for ASRC_ASRIDRHB_IDRATIOB. */
#define BS_ASRC_ASRIDRHB_IDRATIOB (8U)     /*!< Bit field size in bits for ASRC_ASRIDRHB_IDRATIOB. */

/*! @brief Read current value of the ASRC_ASRIDRHB_IDRATIOB field. */
#define BR_ASRC_ASRIDRHB_IDRATIOB(x) (HW_ASRC_ASRIDRHB(x).B.IDRATIOB)

/*! @brief Format value for bitfield ASRC_ASRIDRHB_IDRATIOB. */
#define BF_ASRC_ASRIDRHB_IDRATIOB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRHB_IDRATIOB) & BM_ASRC_ASRIDRHB_IDRATIOB)

/*! @brief Set the IDRATIOB field to a new value. */
#define BW_ASRC_ASRIDRHB_IDRATIOB(x, v) (HW_ASRC_ASRIDRHB_WR(x, (HW_ASRC_ASRIDRHB_RD(x) & ~BM_ASRC_ASRIDRHB_IDRATIOB) | BF_ASRC_ASRIDRHB_IDRATIOB(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRLB - ASRC Ideal Ratio for Pair B-Low Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRLB - ASRC Ideal Ratio for Pair B-Low Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHB, ASRIDRLB) hold the ratio value IDRATIOB.
 * IDRATIOB = FsinB/FsoutB = TsoutB/TsinB is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRB, IDRB}=2'b11.
 */
typedef union _hw_asrc_asridrlb
{
    uint32_t U;
    struct _hw_asrc_asridrlb_bitfields
    {
        uint32_t IDRATIOB : 24;        /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrlb_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRLB register
 */
/*@{*/
#define HW_ASRC_ASRIDRLB_ADDR(x) ((uintptr_t)(x) + 0x8CU)

#define HW_ASRC_ASRIDRLB(x)      (*(__IO hw_asrc_asridrlb_t *) HW_ASRC_ASRIDRLB_ADDR(x))
#define HW_ASRC_ASRIDRLB_RD(x)   (HW_ASRC_ASRIDRLB(x).U)
#define HW_ASRC_ASRIDRLB_WR(x, v) (HW_ASRC_ASRIDRLB(x).U = (v))
#define HW_ASRC_ASRIDRLB_SET(x, v) (HW_ASRC_ASRIDRLB_WR(x, HW_ASRC_ASRIDRLB_RD(x) |  (v)))
#define HW_ASRC_ASRIDRLB_CLR(x, v) (HW_ASRC_ASRIDRLB_WR(x, HW_ASRC_ASRIDRLB_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRLB_TOG(x, v) (HW_ASRC_ASRIDRLB_WR(x, HW_ASRC_ASRIDRLB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRLB bitfields
 */

/*!
 * @name Register ASRC_ASRIDRLB, field IDRATIOB[23:0] (RW)
 *
 * IDRATIOB[23:0]. Low part of ideal ratio value for pair B.
 */
/*@{*/
#define BP_ASRC_ASRIDRLB_IDRATIOB (0U)     /*!< Bit position for ASRC_ASRIDRLB_IDRATIOB. */
#define BM_ASRC_ASRIDRLB_IDRATIOB (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRIDRLB_IDRATIOB. */
#define BS_ASRC_ASRIDRLB_IDRATIOB (24U)    /*!< Bit field size in bits for ASRC_ASRIDRLB_IDRATIOB. */

/*! @brief Read current value of the ASRC_ASRIDRLB_IDRATIOB field. */
#define BR_ASRC_ASRIDRLB_IDRATIOB(x) (HW_ASRC_ASRIDRLB(x).B.IDRATIOB)

/*! @brief Format value for bitfield ASRC_ASRIDRLB_IDRATIOB. */
#define BF_ASRC_ASRIDRLB_IDRATIOB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRLB_IDRATIOB) & BM_ASRC_ASRIDRLB_IDRATIOB)

/*! @brief Set the IDRATIOB field to a new value. */
#define BW_ASRC_ASRIDRLB_IDRATIOB(x, v) (HW_ASRC_ASRIDRLB_WR(x, (HW_ASRC_ASRIDRLB_RD(x) & ~BM_ASRC_ASRIDRLB_IDRATIOB) | BF_ASRC_ASRIDRLB_IDRATIOB(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRHC - ASRC Ideal Ratio for Pair C-High Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRHC - ASRC Ideal Ratio for Pair C-High Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHC, ASRIDRLC) hold the ratio value IDRATIOC.
 * IDRATIOC = FsinC/FsoutC = TsoutC/TsinC is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRC, IDRC}=2'b11.
 */
typedef union _hw_asrc_asridrhc
{
    uint32_t U;
    struct _hw_asrc_asridrhc_bitfields
    {
        uint32_t IDRATIOC : 8;         /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrhc_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRHC register
 */
/*@{*/
#define HW_ASRC_ASRIDRHC_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_ASRC_ASRIDRHC(x)      (*(__IO hw_asrc_asridrhc_t *) HW_ASRC_ASRIDRHC_ADDR(x))
#define HW_ASRC_ASRIDRHC_RD(x)   (HW_ASRC_ASRIDRHC(x).U)
#define HW_ASRC_ASRIDRHC_WR(x, v) (HW_ASRC_ASRIDRHC(x).U = (v))
#define HW_ASRC_ASRIDRHC_SET(x, v) (HW_ASRC_ASRIDRHC_WR(x, HW_ASRC_ASRIDRHC_RD(x) |  (v)))
#define HW_ASRC_ASRIDRHC_CLR(x, v) (HW_ASRC_ASRIDRHC_WR(x, HW_ASRC_ASRIDRHC_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRHC_TOG(x, v) (HW_ASRC_ASRIDRHC_WR(x, HW_ASRC_ASRIDRHC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRHC bitfields
 */

/*!
 * @name Register ASRC_ASRIDRHC, field IDRATIOC[7:0] (RW)
 *
 * IDRATIOC[31:24]. High part of ideal ratio value for pair C.
 */
/*@{*/
#define BP_ASRC_ASRIDRHC_IDRATIOC (0U)     /*!< Bit position for ASRC_ASRIDRHC_IDRATIOC. */
#define BM_ASRC_ASRIDRHC_IDRATIOC (0x000000FFU) /*!< Bit mask for ASRC_ASRIDRHC_IDRATIOC. */
#define BS_ASRC_ASRIDRHC_IDRATIOC (8U)     /*!< Bit field size in bits for ASRC_ASRIDRHC_IDRATIOC. */

/*! @brief Read current value of the ASRC_ASRIDRHC_IDRATIOC field. */
#define BR_ASRC_ASRIDRHC_IDRATIOC(x) (HW_ASRC_ASRIDRHC(x).B.IDRATIOC)

/*! @brief Format value for bitfield ASRC_ASRIDRHC_IDRATIOC. */
#define BF_ASRC_ASRIDRHC_IDRATIOC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRHC_IDRATIOC) & BM_ASRC_ASRIDRHC_IDRATIOC)

/*! @brief Set the IDRATIOC field to a new value. */
#define BW_ASRC_ASRIDRHC_IDRATIOC(x, v) (HW_ASRC_ASRIDRHC_WR(x, (HW_ASRC_ASRIDRHC_RD(x) & ~BM_ASRC_ASRIDRHC_IDRATIOC) | BF_ASRC_ASRIDRHC_IDRATIOC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRIDRLC - ASRC Ideal Ratio for Pair C-Low Part
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRIDRLC - ASRC Ideal Ratio for Pair C-Low Part (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ideal ratio registers (ASRIDRHC, ASRIDRLC) hold the ratio value IDRATIOC.
 * IDRATIOC = FsinC/FsoutC = TsoutC/TsinC is a 32-bit fixed point value with 26
 * fractional bits. This value is only useful when ASRCTR:{USRC, IDRC}=2'b11.
 */
typedef union _hw_asrc_asridrlc
{
    uint32_t U;
    struct _hw_asrc_asridrlc_bitfields
    {
        uint32_t IDRATIOC : 24;        /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asridrlc_t;

/*!
 * @name Constants and macros for entire ASRC_ASRIDRLC register
 */
/*@{*/
#define HW_ASRC_ASRIDRLC_ADDR(x) ((uintptr_t)(x) + 0x94U)

#define HW_ASRC_ASRIDRLC(x)      (*(__IO hw_asrc_asridrlc_t *) HW_ASRC_ASRIDRLC_ADDR(x))
#define HW_ASRC_ASRIDRLC_RD(x)   (HW_ASRC_ASRIDRLC(x).U)
#define HW_ASRC_ASRIDRLC_WR(x, v) (HW_ASRC_ASRIDRLC(x).U = (v))
#define HW_ASRC_ASRIDRLC_SET(x, v) (HW_ASRC_ASRIDRLC_WR(x, HW_ASRC_ASRIDRLC_RD(x) |  (v)))
#define HW_ASRC_ASRIDRLC_CLR(x, v) (HW_ASRC_ASRIDRLC_WR(x, HW_ASRC_ASRIDRLC_RD(x) & ~(v)))
#define HW_ASRC_ASRIDRLC_TOG(x, v) (HW_ASRC_ASRIDRLC_WR(x, HW_ASRC_ASRIDRLC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRIDRLC bitfields
 */

/*!
 * @name Register ASRC_ASRIDRLC, field IDRATIOC[23:0] (RW)
 *
 * IDRATIOC[23:0]. Low part of ideal ratio value for pair C.
 */
/*@{*/
#define BP_ASRC_ASRIDRLC_IDRATIOC (0U)     /*!< Bit position for ASRC_ASRIDRLC_IDRATIOC. */
#define BM_ASRC_ASRIDRLC_IDRATIOC (0x00FFFFFFU) /*!< Bit mask for ASRC_ASRIDRLC_IDRATIOC. */
#define BS_ASRC_ASRIDRLC_IDRATIOC (24U)    /*!< Bit field size in bits for ASRC_ASRIDRLC_IDRATIOC. */

/*! @brief Read current value of the ASRC_ASRIDRLC_IDRATIOC field. */
#define BR_ASRC_ASRIDRLC_IDRATIOC(x) (HW_ASRC_ASRIDRLC(x).B.IDRATIOC)

/*! @brief Format value for bitfield ASRC_ASRIDRLC_IDRATIOC. */
#define BF_ASRC_ASRIDRLC_IDRATIOC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRIDRLC_IDRATIOC) & BM_ASRC_ASRIDRLC_IDRATIOC)

/*! @brief Set the IDRATIOC field to a new value. */
#define BW_ASRC_ASRIDRLC_IDRATIOC(x, v) (HW_ASRC_ASRIDRLC_WR(x, (HW_ASRC_ASRIDRLC_RD(x) & ~BM_ASRC_ASRIDRLC_IDRATIOC) | BF_ASRC_ASRIDRLC_IDRATIOC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASR76K - ASRC 76kHz Period in terms of ASRC processing clock
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASR76K - ASRC 76kHz Period in terms of ASRC processing clock (RW)
 *
 * Reset value: 0x00000A47U
 *
 * The register (ASR76K) holds the period of the 76kHz sampling clock in terms
 * of the ASRC processing clock with frequency FsASRC. ASR76K = FsASRC/Fs76k.
 * Reset value is 0x0A47 which assumes that FsASRC=200MHz. This register is used to
 * help the ASRC internal logic to decide the pre-processing and the
 * post-processing options automatically (see ASRC Misc Control Register 1 for Pair CASRC
 * Control Register and ASRC Misc Control Register 1 for Pair CASRC Filter
 * Configuration Status Register ). In a system when FsASRC=133MHz, the value should be
 * assigned explicitly as 0x06D6 in user application code.
 */
typedef union _hw_asrc_asr76k
{
    uint32_t U;
    struct _hw_asrc_asr76k_bitfields
    {
        uint32_t ASR76K : 17;          /*!< [16:0]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asr76k_t;

/*!
 * @name Constants and macros for entire ASRC_ASR76K register
 */
/*@{*/
#define HW_ASRC_ASR76K_ADDR(x)   ((uintptr_t)(x) + 0x98U)

#define HW_ASRC_ASR76K(x)        (*(__IO hw_asrc_asr76k_t *) HW_ASRC_ASR76K_ADDR(x))
#define HW_ASRC_ASR76K_RD(x)     (HW_ASRC_ASR76K(x).U)
#define HW_ASRC_ASR76K_WR(x, v)  (HW_ASRC_ASR76K(x).U = (v))
#define HW_ASRC_ASR76K_SET(x, v) (HW_ASRC_ASR76K_WR(x, HW_ASRC_ASR76K_RD(x) |  (v)))
#define HW_ASRC_ASR76K_CLR(x, v) (HW_ASRC_ASR76K_WR(x, HW_ASRC_ASR76K_RD(x) & ~(v)))
#define HW_ASRC_ASR76K_TOG(x, v) (HW_ASRC_ASR76K_WR(x, HW_ASRC_ASR76K_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASR76K bitfields
 */

/*!
 * @name Register ASRC_ASR76K, field ASR76K[16:0] (RW)
 *
 * Value for the period of the 76kHz sampling clock.
 */
/*@{*/
#define BP_ASRC_ASR76K_ASR76K (0U)         /*!< Bit position for ASRC_ASR76K_ASR76K. */
#define BM_ASRC_ASR76K_ASR76K (0x0001FFFFU) /*!< Bit mask for ASRC_ASR76K_ASR76K. */
#define BS_ASRC_ASR76K_ASR76K (17U)        /*!< Bit field size in bits for ASRC_ASR76K_ASR76K. */

/*! @brief Read current value of the ASRC_ASR76K_ASR76K field. */
#define BR_ASRC_ASR76K_ASR76K(x) (HW_ASRC_ASR76K(x).B.ASR76K)

/*! @brief Format value for bitfield ASRC_ASR76K_ASR76K. */
#define BF_ASRC_ASR76K_ASR76K(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASR76K_ASR76K) & BM_ASRC_ASR76K_ASR76K)

/*! @brief Set the ASR76K field to a new value. */
#define BW_ASRC_ASR76K_ASR76K(x, v) (HW_ASRC_ASR76K_WR(x, (HW_ASRC_ASR76K_RD(x) & ~BM_ASRC_ASR76K_ASR76K) | BF_ASRC_ASR76K_ASR76K(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASR56K - ASRC 56kHz Period in terms of ASRC processing clock
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASR56K - ASRC 56kHz Period in terms of ASRC processing clock (RW)
 *
 * Reset value: 0x00000DF3U
 *
 * The register (ASR56K) holds the period of the 56kHz sampling clock in terms
 * of the ASRC processing clock with frequency FsASRC. ASR56K = FsASRC/Fs56k.
 * Reset value is 0x0DF3 which assumes that FsASRC=200MHz. This register is used to
 * help the ASRC internal logic to decide the pre-processing and the
 * post-processing options automatically (see ASRC Misc Control Register 1 for Pair CASRC
 * Control Register and ASRC Misc Control Register 1 for Pair CASRC Filter
 * Configuration Status Register ). In a system when FsASRC=133MHz, the value should be
 * assigned explicitly as 0x0947 in user application code.
 */
typedef union _hw_asrc_asr56k
{
    uint32_t U;
    struct _hw_asrc_asr56k_bitfields
    {
        uint32_t ASR56K : 17;          /*!< [16:0]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asr56k_t;

/*!
 * @name Constants and macros for entire ASRC_ASR56K register
 */
/*@{*/
#define HW_ASRC_ASR56K_ADDR(x)   ((uintptr_t)(x) + 0x9CU)

#define HW_ASRC_ASR56K(x)        (*(__IO hw_asrc_asr56k_t *) HW_ASRC_ASR56K_ADDR(x))
#define HW_ASRC_ASR56K_RD(x)     (HW_ASRC_ASR56K(x).U)
#define HW_ASRC_ASR56K_WR(x, v)  (HW_ASRC_ASR56K(x).U = (v))
#define HW_ASRC_ASR56K_SET(x, v) (HW_ASRC_ASR56K_WR(x, HW_ASRC_ASR56K_RD(x) |  (v)))
#define HW_ASRC_ASR56K_CLR(x, v) (HW_ASRC_ASR56K_WR(x, HW_ASRC_ASR56K_RD(x) & ~(v)))
#define HW_ASRC_ASR56K_TOG(x, v) (HW_ASRC_ASR56K_WR(x, HW_ASRC_ASR56K_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASR56K bitfields
 */

/*!
 * @name Register ASRC_ASR56K, field ASR56K[16:0] (RW)
 *
 * Value for the period of the 56kHz sampling clock
 */
/*@{*/
#define BP_ASRC_ASR56K_ASR56K (0U)         /*!< Bit position for ASRC_ASR56K_ASR56K. */
#define BM_ASRC_ASR56K_ASR56K (0x0001FFFFU) /*!< Bit mask for ASRC_ASR56K_ASR56K. */
#define BS_ASRC_ASR56K_ASR56K (17U)        /*!< Bit field size in bits for ASRC_ASR56K_ASR56K. */

/*! @brief Read current value of the ASRC_ASR56K_ASR56K field. */
#define BR_ASRC_ASR56K_ASR56K(x) (HW_ASRC_ASR56K(x).B.ASR56K)

/*! @brief Format value for bitfield ASRC_ASR56K_ASR56K. */
#define BF_ASRC_ASR56K_ASR56K(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASR56K_ASR56K) & BM_ASRC_ASR56K_ASR56K)

/*! @brief Set the ASR56K field to a new value. */
#define BW_ASRC_ASR56K_ASR56K(x, v) (HW_ASRC_ASR56K_WR(x, (HW_ASRC_ASR56K_RD(x) & ~BM_ASRC_ASR56K_ASR56K) | BF_ASRC_ASR56K_ASR56K(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRMCRA - ASRC Misc Control Register for Pair A
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRMCRA - ASRC Misc Control Register for Pair A (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRMCRA) is used to control Pair A internal logic.
 */
typedef union _hw_asrc_asrmcra
{
    uint32_t U;
    struct _hw_asrc_asrmcra_bitfields
    {
        uint32_t INFIFO_THRESHOLDA : 6; /*!< [5:0]  */
        uint32_t RESERVED0 : 4;        /*!< [9:6]  */
        uint32_t RSYNOFA : 1;          /*!< [10]  */
        uint32_t RSYNIFA : 1;          /*!< [11]  */
        uint32_t OUTFIFO_THRESHOLDA : 6; /*!< [17:12]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t BYPASSPOLYA : 1;      /*!< [20]  */
        uint32_t BUFSTALLA : 1;        /*!< [21]  */
        uint32_t EXTTHRSHA : 1;        /*!< [22]  */
        uint32_t ZEROBUFA : 1;         /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrmcra_t;

/*!
 * @name Constants and macros for entire ASRC_ASRMCRA register
 */
/*@{*/
#define HW_ASRC_ASRMCRA_ADDR(x)  ((uintptr_t)(x) + 0xA0U)

#define HW_ASRC_ASRMCRA(x)       (*(__IO hw_asrc_asrmcra_t *) HW_ASRC_ASRMCRA_ADDR(x))
#define HW_ASRC_ASRMCRA_RD(x)    (HW_ASRC_ASRMCRA(x).U)
#define HW_ASRC_ASRMCRA_WR(x, v) (HW_ASRC_ASRMCRA(x).U = (v))
#define HW_ASRC_ASRMCRA_SET(x, v) (HW_ASRC_ASRMCRA_WR(x, HW_ASRC_ASRMCRA_RD(x) |  (v)))
#define HW_ASRC_ASRMCRA_CLR(x, v) (HW_ASRC_ASRMCRA_WR(x, HW_ASRC_ASRMCRA_RD(x) & ~(v)))
#define HW_ASRC_ASRMCRA_TOG(x, v) (HW_ASRC_ASRMCRA_WR(x, HW_ASRC_ASRMCRA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRMCRA bitfields
 */

/*!
 * @name Register ASRC_ASRMCRA, field INFIFO_THRESHOLDA[5:0] (RW)
 *
 * The threshold for Pair A's input FIFO per channel These bits stand for the
 * threshold for Pair A's input FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of input FIFO fillings of the
 * pair is less than n samples per channel, the input data needed flag is set; when
 * the number of input FIFO fillings of the pair is greater than or equal to n
 * samples per channel, the input data needed flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_INFIFO_THRESHOLDA (0U) /*!< Bit position for ASRC_ASRMCRA_INFIFO_THRESHOLDA. */
#define BM_ASRC_ASRMCRA_INFIFO_THRESHOLDA (0x0000003FU) /*!< Bit mask for ASRC_ASRMCRA_INFIFO_THRESHOLDA. */
#define BS_ASRC_ASRMCRA_INFIFO_THRESHOLDA (6U) /*!< Bit field size in bits for ASRC_ASRMCRA_INFIFO_THRESHOLDA. */

/*! @brief Read current value of the ASRC_ASRMCRA_INFIFO_THRESHOLDA field. */
#define BR_ASRC_ASRMCRA_INFIFO_THRESHOLDA(x) (HW_ASRC_ASRMCRA(x).B.INFIFO_THRESHOLDA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_INFIFO_THRESHOLDA. */
#define BF_ASRC_ASRMCRA_INFIFO_THRESHOLDA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_INFIFO_THRESHOLDA) & BM_ASRC_ASRMCRA_INFIFO_THRESHOLDA)

/*! @brief Set the INFIFO_THRESHOLDA field to a new value. */
#define BW_ASRC_ASRMCRA_INFIFO_THRESHOLDA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_INFIFO_THRESHOLDA) | BF_ASRC_ASRMCRA_INFIFO_THRESHOLDA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field RSYNOFA[10] (RW)
 *
 * Re-sync Output FIFO Channel Counter If bit set, force ASRCCR:ACOA=0. If bit
 * clear, untouch ASRCCR:ACOA.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_RSYNOFA (10U)      /*!< Bit position for ASRC_ASRMCRA_RSYNOFA. */
#define BM_ASRC_ASRMCRA_RSYNOFA (0x00000400U) /*!< Bit mask for ASRC_ASRMCRA_RSYNOFA. */
#define BS_ASRC_ASRMCRA_RSYNOFA (1U)       /*!< Bit field size in bits for ASRC_ASRMCRA_RSYNOFA. */

/*! @brief Read current value of the ASRC_ASRMCRA_RSYNOFA field. */
#define BR_ASRC_ASRMCRA_RSYNOFA(x) (HW_ASRC_ASRMCRA(x).B.RSYNOFA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_RSYNOFA. */
#define BF_ASRC_ASRMCRA_RSYNOFA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_RSYNOFA) & BM_ASRC_ASRMCRA_RSYNOFA)

/*! @brief Set the RSYNOFA field to a new value. */
#define BW_ASRC_ASRMCRA_RSYNOFA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_RSYNOFA) | BF_ASRC_ASRMCRA_RSYNOFA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field RSYNIFA[11] (RW)
 *
 * Re-sync Input FIFO Channel Counter If bit set, force ASRCCR:ACIA=0. If bit
 * clear, untouch ASRCCR:ACIA.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_RSYNIFA (11U)      /*!< Bit position for ASRC_ASRMCRA_RSYNIFA. */
#define BM_ASRC_ASRMCRA_RSYNIFA (0x00000800U) /*!< Bit mask for ASRC_ASRMCRA_RSYNIFA. */
#define BS_ASRC_ASRMCRA_RSYNIFA (1U)       /*!< Bit field size in bits for ASRC_ASRMCRA_RSYNIFA. */

/*! @brief Read current value of the ASRC_ASRMCRA_RSYNIFA field. */
#define BR_ASRC_ASRMCRA_RSYNIFA(x) (HW_ASRC_ASRMCRA(x).B.RSYNIFA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_RSYNIFA. */
#define BF_ASRC_ASRMCRA_RSYNIFA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_RSYNIFA) & BM_ASRC_ASRMCRA_RSYNIFA)

/*! @brief Set the RSYNIFA field to a new value. */
#define BW_ASRC_ASRMCRA_RSYNIFA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_RSYNIFA) | BF_ASRC_ASRMCRA_RSYNIFA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field OUTFIFO_THRESHOLDA[17:12] (RW)
 *
 * The threshold for Pair A's output FIFO per channel These bits stand for the
 * threshold for Pair A's output FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of output FIFO fillings of the
 * pair is greater than n samples per channel, the output data ready flag is set;
 * when the number of output FIFO fillings of the pair is less than or equal to
 * n samples per channel, the output data ready flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA (12U) /*!< Bit position for ASRC_ASRMCRA_OUTFIFO_THRESHOLDA. */
#define BM_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA (0x0003F000U) /*!< Bit mask for ASRC_ASRMCRA_OUTFIFO_THRESHOLDA. */
#define BS_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA (6U) /*!< Bit field size in bits for ASRC_ASRMCRA_OUTFIFO_THRESHOLDA. */

/*! @brief Read current value of the ASRC_ASRMCRA_OUTFIFO_THRESHOLDA field. */
#define BR_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA(x) (HW_ASRC_ASRMCRA(x).B.OUTFIFO_THRESHOLDA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_OUTFIFO_THRESHOLDA. */
#define BF_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA) & BM_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA)

/*! @brief Set the OUTFIFO_THRESHOLDA field to a new value. */
#define BW_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA) | BF_ASRC_ASRMCRA_OUTFIFO_THRESHOLDA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field BYPASSPOLYA[20] (RW)
 *
 * Bypass Polyphase Filtering for Pair A This bit will determine whether the
 * polyphase filtering part of Pair A conversion will be bypassed.
 *
 * Values:
 * - 1 - Bypass polyphase filtering.
 * - 0 - Don't bypass polyphase filtering.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_BYPASSPOLYA (20U)  /*!< Bit position for ASRC_ASRMCRA_BYPASSPOLYA. */
#define BM_ASRC_ASRMCRA_BYPASSPOLYA (0x00100000U) /*!< Bit mask for ASRC_ASRMCRA_BYPASSPOLYA. */
#define BS_ASRC_ASRMCRA_BYPASSPOLYA (1U)   /*!< Bit field size in bits for ASRC_ASRMCRA_BYPASSPOLYA. */

/*! @brief Read current value of the ASRC_ASRMCRA_BYPASSPOLYA field. */
#define BR_ASRC_ASRMCRA_BYPASSPOLYA(x) (HW_ASRC_ASRMCRA(x).B.BYPASSPOLYA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_BYPASSPOLYA. */
#define BF_ASRC_ASRMCRA_BYPASSPOLYA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_BYPASSPOLYA) & BM_ASRC_ASRMCRA_BYPASSPOLYA)

/*! @brief Set the BYPASSPOLYA field to a new value. */
#define BW_ASRC_ASRMCRA_BYPASSPOLYA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_BYPASSPOLYA) | BF_ASRC_ASRMCRA_BYPASSPOLYA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field BUFSTALLA[21] (RW)
 *
 * Stall Pair A conversion in case of Buffer Near Empty/Full Condition This bit
 * will determine whether the near empty/full FIFO condition will stall the rate
 * conversion for pair A. This option can only work when external ratio is used.
 * Near empty condition is the condition when input FIFO has less than 4 useful
 * samples per channel. Near full condition is the condition when the output FIFO
 * has less than 4 vacant sample words to fill per channel.
 *
 * Values:
 * - 1 - Stall Pair A conversion in case of near empty/full FIFO conditions.
 * - 0 - Don't stall Pair A conversion even in case of near empty/full FIFO
 *     conditions.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_BUFSTALLA (21U)    /*!< Bit position for ASRC_ASRMCRA_BUFSTALLA. */
#define BM_ASRC_ASRMCRA_BUFSTALLA (0x00200000U) /*!< Bit mask for ASRC_ASRMCRA_BUFSTALLA. */
#define BS_ASRC_ASRMCRA_BUFSTALLA (1U)     /*!< Bit field size in bits for ASRC_ASRMCRA_BUFSTALLA. */

/*! @brief Read current value of the ASRC_ASRMCRA_BUFSTALLA field. */
#define BR_ASRC_ASRMCRA_BUFSTALLA(x) (HW_ASRC_ASRMCRA(x).B.BUFSTALLA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_BUFSTALLA. */
#define BF_ASRC_ASRMCRA_BUFSTALLA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_BUFSTALLA) & BM_ASRC_ASRMCRA_BUFSTALLA)

/*! @brief Set the BUFSTALLA field to a new value. */
#define BW_ASRC_ASRMCRA_BUFSTALLA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_BUFSTALLA) | BF_ASRC_ASRMCRA_BUFSTALLA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field EXTTHRSHA[22] (RW)
 *
 * Use external thresholds for FIFO control of Pair A This bit will determine
 * whether the FIFO thresholds externally defined in this register is used to
 * control ASRC internal FIFO logic for pair A.
 *
 * Values:
 * - 1 - Use external defined thresholds.
 * - 0 - Use default thresholds.
 */
/*@{*/
#define BP_ASRC_ASRMCRA_EXTTHRSHA (22U)    /*!< Bit position for ASRC_ASRMCRA_EXTTHRSHA. */
#define BM_ASRC_ASRMCRA_EXTTHRSHA (0x00400000U) /*!< Bit mask for ASRC_ASRMCRA_EXTTHRSHA. */
#define BS_ASRC_ASRMCRA_EXTTHRSHA (1U)     /*!< Bit field size in bits for ASRC_ASRMCRA_EXTTHRSHA. */

/*! @brief Read current value of the ASRC_ASRMCRA_EXTTHRSHA field. */
#define BR_ASRC_ASRMCRA_EXTTHRSHA(x) (HW_ASRC_ASRMCRA(x).B.EXTTHRSHA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_EXTTHRSHA. */
#define BF_ASRC_ASRMCRA_EXTTHRSHA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_EXTTHRSHA) & BM_ASRC_ASRMCRA_EXTTHRSHA)

/*! @brief Set the EXTTHRSHA field to a new value. */
#define BW_ASRC_ASRMCRA_EXTTHRSHA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_EXTTHRSHA) | BF_ASRC_ASRMCRA_EXTTHRSHA(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRA, field ZEROBUFA[23] (RW)
 *
 * Initialize buf of Pair A when pair A is enabled. Always clear option. This
 * bit is used to control whether the buffer is to be zeroized when pair A is
 * enabled.
 *
 * Values:
 * - 1 - Don't zeroize the buffer
 * - 0 - Zeroize the buffer
 */
/*@{*/
#define BP_ASRC_ASRMCRA_ZEROBUFA (23U)     /*!< Bit position for ASRC_ASRMCRA_ZEROBUFA. */
#define BM_ASRC_ASRMCRA_ZEROBUFA (0x00800000U) /*!< Bit mask for ASRC_ASRMCRA_ZEROBUFA. */
#define BS_ASRC_ASRMCRA_ZEROBUFA (1U)      /*!< Bit field size in bits for ASRC_ASRMCRA_ZEROBUFA. */

/*! @brief Read current value of the ASRC_ASRMCRA_ZEROBUFA field. */
#define BR_ASRC_ASRMCRA_ZEROBUFA(x) (HW_ASRC_ASRMCRA(x).B.ZEROBUFA)

/*! @brief Format value for bitfield ASRC_ASRMCRA_ZEROBUFA. */
#define BF_ASRC_ASRMCRA_ZEROBUFA(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRA_ZEROBUFA) & BM_ASRC_ASRMCRA_ZEROBUFA)

/*! @brief Set the ZEROBUFA field to a new value. */
#define BW_ASRC_ASRMCRA_ZEROBUFA(x, v) (HW_ASRC_ASRMCRA_WR(x, (HW_ASRC_ASRMCRA_RD(x) & ~BM_ASRC_ASRMCRA_ZEROBUFA) | BF_ASRC_ASRMCRA_ZEROBUFA(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRFSTA - ASRC FIFO Status Register for Pair A
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRFSTA - ASRC FIFO Status Register for Pair A (RO)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRFSTA) is used to show Pair A internal FIFO conditions.
 */
typedef union _hw_asrc_asrfsta
{
    uint32_t U;
    struct _hw_asrc_asrfsta_bitfields
    {
        uint32_t INFIFO_FILLA : 7;     /*!< [6:0]  */
        uint32_t RESERVED0 : 4;        /*!< [10:7]  */
        uint32_t IAEA : 1;             /*!< [11]  */
        uint32_t OUTFIFO_FILLA : 7;    /*!< [18:12]  */
        uint32_t RESERVED1 : 4;        /*!< [22:19]  */
        uint32_t OAFA : 1;             /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrfsta_t;

/*!
 * @name Constants and macros for entire ASRC_ASRFSTA register
 */
/*@{*/
#define HW_ASRC_ASRFSTA_ADDR(x)  ((uintptr_t)(x) + 0xA4U)

#define HW_ASRC_ASRFSTA(x)       (*(__I hw_asrc_asrfsta_t *) HW_ASRC_ASRFSTA_ADDR(x))
#define HW_ASRC_ASRFSTA_RD(x)    (HW_ASRC_ASRFSTA(x).U)
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRFSTA bitfields
 */

/*!
 * @name Register ASRC_ASRFSTA, field INFIFO_FILLA[6:0] (RO)
 *
 * The fillings for Pair A's input FIFO per channel These bits stand for the
 * fillings for Pair A's input FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTA_INFIFO_FILLA (0U)  /*!< Bit position for ASRC_ASRFSTA_INFIFO_FILLA. */
#define BM_ASRC_ASRFSTA_INFIFO_FILLA (0x0000007FU) /*!< Bit mask for ASRC_ASRFSTA_INFIFO_FILLA. */
#define BS_ASRC_ASRFSTA_INFIFO_FILLA (7U)  /*!< Bit field size in bits for ASRC_ASRFSTA_INFIFO_FILLA. */

/*! @brief Read current value of the ASRC_ASRFSTA_INFIFO_FILLA field. */
#define BR_ASRC_ASRFSTA_INFIFO_FILLA(x) (HW_ASRC_ASRFSTA(x).B.INFIFO_FILLA)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTA, field IAEA[11] (RO)
 *
 * Input FIFO is near Empty for Pair A This bit is to indicate whether the input
 * FIFO of Pair A is near empty.
 */
/*@{*/
#define BP_ASRC_ASRFSTA_IAEA (11U)         /*!< Bit position for ASRC_ASRFSTA_IAEA. */
#define BM_ASRC_ASRFSTA_IAEA (0x00000800U) /*!< Bit mask for ASRC_ASRFSTA_IAEA. */
#define BS_ASRC_ASRFSTA_IAEA (1U)          /*!< Bit field size in bits for ASRC_ASRFSTA_IAEA. */

/*! @brief Read current value of the ASRC_ASRFSTA_IAEA field. */
#define BR_ASRC_ASRFSTA_IAEA(x) (HW_ASRC_ASRFSTA(x).B.IAEA)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTA, field OUTFIFO_FILLA[18:12] (RO)
 *
 * The fillings for Pair A's output FIFO per channel These bits stand for the
 * fillings for Pair A's output FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTA_OUTFIFO_FILLA (12U) /*!< Bit position for ASRC_ASRFSTA_OUTFIFO_FILLA. */
#define BM_ASRC_ASRFSTA_OUTFIFO_FILLA (0x0007F000U) /*!< Bit mask for ASRC_ASRFSTA_OUTFIFO_FILLA. */
#define BS_ASRC_ASRFSTA_OUTFIFO_FILLA (7U) /*!< Bit field size in bits for ASRC_ASRFSTA_OUTFIFO_FILLA. */

/*! @brief Read current value of the ASRC_ASRFSTA_OUTFIFO_FILLA field. */
#define BR_ASRC_ASRFSTA_OUTFIFO_FILLA(x) (HW_ASRC_ASRFSTA(x).B.OUTFIFO_FILLA)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTA, field OAFA[23] (RO)
 *
 * Output FIFO is near Full for Pair A This bit is to indicate whether the
 * output FIFO of Pair A is near full.
 */
/*@{*/
#define BP_ASRC_ASRFSTA_OAFA (23U)         /*!< Bit position for ASRC_ASRFSTA_OAFA. */
#define BM_ASRC_ASRFSTA_OAFA (0x00800000U) /*!< Bit mask for ASRC_ASRFSTA_OAFA. */
#define BS_ASRC_ASRFSTA_OAFA (1U)          /*!< Bit field size in bits for ASRC_ASRFSTA_OAFA. */

/*! @brief Read current value of the ASRC_ASRFSTA_OAFA field. */
#define BR_ASRC_ASRFSTA_OAFA(x) (HW_ASRC_ASRFSTA(x).B.OAFA)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRMCRB - ASRC Misc Control Register for Pair B
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRMCRB - ASRC Misc Control Register for Pair B (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRMCRB) is used to control Pair B internal logic.
 */
typedef union _hw_asrc_asrmcrb
{
    uint32_t U;
    struct _hw_asrc_asrmcrb_bitfields
    {
        uint32_t INFIFO_THRESHOLDB : 6; /*!< [5:0]  */
        uint32_t RESERVED0 : 4;        /*!< [9:6]  */
        uint32_t RSYNOFB : 1;          /*!< [10]  */
        uint32_t RSYNIFB : 1;          /*!< [11]  */
        uint32_t OUTFIFO_THRESHOLDB : 6; /*!< [17:12]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t BYPASSPOLYB : 1;      /*!< [20]  */
        uint32_t BUFSTALLB : 1;        /*!< [21]  */
        uint32_t EXTTHRSHB : 1;        /*!< [22]  */
        uint32_t ZEROBUFB : 1;         /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrmcrb_t;

/*!
 * @name Constants and macros for entire ASRC_ASRMCRB register
 */
/*@{*/
#define HW_ASRC_ASRMCRB_ADDR(x)  ((uintptr_t)(x) + 0xA8U)

#define HW_ASRC_ASRMCRB(x)       (*(__IO hw_asrc_asrmcrb_t *) HW_ASRC_ASRMCRB_ADDR(x))
#define HW_ASRC_ASRMCRB_RD(x)    (HW_ASRC_ASRMCRB(x).U)
#define HW_ASRC_ASRMCRB_WR(x, v) (HW_ASRC_ASRMCRB(x).U = (v))
#define HW_ASRC_ASRMCRB_SET(x, v) (HW_ASRC_ASRMCRB_WR(x, HW_ASRC_ASRMCRB_RD(x) |  (v)))
#define HW_ASRC_ASRMCRB_CLR(x, v) (HW_ASRC_ASRMCRB_WR(x, HW_ASRC_ASRMCRB_RD(x) & ~(v)))
#define HW_ASRC_ASRMCRB_TOG(x, v) (HW_ASRC_ASRMCRB_WR(x, HW_ASRC_ASRMCRB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRMCRB bitfields
 */

/*!
 * @name Register ASRC_ASRMCRB, field INFIFO_THRESHOLDB[5:0] (RW)
 *
 * The threshold for Pair B's input FIFO per channel These bits stand for the
 * threshold for Pair B's input FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of input FIFO fillings of the
 * pair is less than n samples per channel, the input data needed flag is set; when
 * the number of input FIFO fillings of the pair is greater than or equal to n
 * samples per channel, the input data needed flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_INFIFO_THRESHOLDB (0U) /*!< Bit position for ASRC_ASRMCRB_INFIFO_THRESHOLDB. */
#define BM_ASRC_ASRMCRB_INFIFO_THRESHOLDB (0x0000003FU) /*!< Bit mask for ASRC_ASRMCRB_INFIFO_THRESHOLDB. */
#define BS_ASRC_ASRMCRB_INFIFO_THRESHOLDB (6U) /*!< Bit field size in bits for ASRC_ASRMCRB_INFIFO_THRESHOLDB. */

/*! @brief Read current value of the ASRC_ASRMCRB_INFIFO_THRESHOLDB field. */
#define BR_ASRC_ASRMCRB_INFIFO_THRESHOLDB(x) (HW_ASRC_ASRMCRB(x).B.INFIFO_THRESHOLDB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_INFIFO_THRESHOLDB. */
#define BF_ASRC_ASRMCRB_INFIFO_THRESHOLDB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_INFIFO_THRESHOLDB) & BM_ASRC_ASRMCRB_INFIFO_THRESHOLDB)

/*! @brief Set the INFIFO_THRESHOLDB field to a new value. */
#define BW_ASRC_ASRMCRB_INFIFO_THRESHOLDB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_INFIFO_THRESHOLDB) | BF_ASRC_ASRMCRB_INFIFO_THRESHOLDB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field RSYNOFB[10] (RW)
 *
 * Re-sync Output FIFO Channel Counter If bit set, force ASRCCR:ACOB=0. If bit
 * clear, untouch ASRCCR:ACOB.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_RSYNOFB (10U)      /*!< Bit position for ASRC_ASRMCRB_RSYNOFB. */
#define BM_ASRC_ASRMCRB_RSYNOFB (0x00000400U) /*!< Bit mask for ASRC_ASRMCRB_RSYNOFB. */
#define BS_ASRC_ASRMCRB_RSYNOFB (1U)       /*!< Bit field size in bits for ASRC_ASRMCRB_RSYNOFB. */

/*! @brief Read current value of the ASRC_ASRMCRB_RSYNOFB field. */
#define BR_ASRC_ASRMCRB_RSYNOFB(x) (HW_ASRC_ASRMCRB(x).B.RSYNOFB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_RSYNOFB. */
#define BF_ASRC_ASRMCRB_RSYNOFB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_RSYNOFB) & BM_ASRC_ASRMCRB_RSYNOFB)

/*! @brief Set the RSYNOFB field to a new value. */
#define BW_ASRC_ASRMCRB_RSYNOFB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_RSYNOFB) | BF_ASRC_ASRMCRB_RSYNOFB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field RSYNIFB[11] (RW)
 *
 * Re-sync Input FIFO Channel Counter If bit set, force ASRCCR:ACIB=0. If bit
 * clear, untouch ASRCCR:ACIB.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_RSYNIFB (11U)      /*!< Bit position for ASRC_ASRMCRB_RSYNIFB. */
#define BM_ASRC_ASRMCRB_RSYNIFB (0x00000800U) /*!< Bit mask for ASRC_ASRMCRB_RSYNIFB. */
#define BS_ASRC_ASRMCRB_RSYNIFB (1U)       /*!< Bit field size in bits for ASRC_ASRMCRB_RSYNIFB. */

/*! @brief Read current value of the ASRC_ASRMCRB_RSYNIFB field. */
#define BR_ASRC_ASRMCRB_RSYNIFB(x) (HW_ASRC_ASRMCRB(x).B.RSYNIFB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_RSYNIFB. */
#define BF_ASRC_ASRMCRB_RSYNIFB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_RSYNIFB) & BM_ASRC_ASRMCRB_RSYNIFB)

/*! @brief Set the RSYNIFB field to a new value. */
#define BW_ASRC_ASRMCRB_RSYNIFB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_RSYNIFB) | BF_ASRC_ASRMCRB_RSYNIFB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field OUTFIFO_THRESHOLDB[17:12] (RW)
 *
 * The threshold for Pair B's output FIFO per channel These bits stand for the
 * threshold for Pair B's output FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of output FIFO fillings of the
 * pair is greater than n samples per channel, the output data ready flag is set;
 * when the number of output FIFO fillings of the pair is less than or equal to
 * n samples per channel, the output data ready flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB (12U) /*!< Bit position for ASRC_ASRMCRB_OUTFIFO_THRESHOLDB. */
#define BM_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB (0x0003F000U) /*!< Bit mask for ASRC_ASRMCRB_OUTFIFO_THRESHOLDB. */
#define BS_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB (6U) /*!< Bit field size in bits for ASRC_ASRMCRB_OUTFIFO_THRESHOLDB. */

/*! @brief Read current value of the ASRC_ASRMCRB_OUTFIFO_THRESHOLDB field. */
#define BR_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB(x) (HW_ASRC_ASRMCRB(x).B.OUTFIFO_THRESHOLDB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_OUTFIFO_THRESHOLDB. */
#define BF_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB) & BM_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB)

/*! @brief Set the OUTFIFO_THRESHOLDB field to a new value. */
#define BW_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB) | BF_ASRC_ASRMCRB_OUTFIFO_THRESHOLDB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field BYPASSPOLYB[20] (RW)
 *
 * Bypass Polyphase Filtering for Pair B This bit will determine whether the
 * polyphase filtering part of Pair B conversion will be bypassed.
 *
 * Values:
 * - 1 - Bypass polyphase filtering.
 * - 0 - Don't bypass polyphase filtering.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_BYPASSPOLYB (20U)  /*!< Bit position for ASRC_ASRMCRB_BYPASSPOLYB. */
#define BM_ASRC_ASRMCRB_BYPASSPOLYB (0x00100000U) /*!< Bit mask for ASRC_ASRMCRB_BYPASSPOLYB. */
#define BS_ASRC_ASRMCRB_BYPASSPOLYB (1U)   /*!< Bit field size in bits for ASRC_ASRMCRB_BYPASSPOLYB. */

/*! @brief Read current value of the ASRC_ASRMCRB_BYPASSPOLYB field. */
#define BR_ASRC_ASRMCRB_BYPASSPOLYB(x) (HW_ASRC_ASRMCRB(x).B.BYPASSPOLYB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_BYPASSPOLYB. */
#define BF_ASRC_ASRMCRB_BYPASSPOLYB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_BYPASSPOLYB) & BM_ASRC_ASRMCRB_BYPASSPOLYB)

/*! @brief Set the BYPASSPOLYB field to a new value. */
#define BW_ASRC_ASRMCRB_BYPASSPOLYB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_BYPASSPOLYB) | BF_ASRC_ASRMCRB_BYPASSPOLYB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field BUFSTALLB[21] (RW)
 *
 * Stall Pair B conversion in case of Buffer Near Empty/Full Condition This bit
 * will determine whether the near empty/full FIFO condition will stall the rate
 * conversion for pair B. This option can only work when external ratio is used.
 * Near empty condition is the condition when input FIFO has less than 4 useful
 * samples per channel. Near full condition is the condition when the output FIFO
 * has less than 4 vacant sample words to fill per channel.
 *
 * Values:
 * - 1 - Stall Pair B conversion in case of near empty/full FIFO conditions.
 * - 0 - Don't stall Pair B conversion even in case of near empty/full FIFO
 *     conditions.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_BUFSTALLB (21U)    /*!< Bit position for ASRC_ASRMCRB_BUFSTALLB. */
#define BM_ASRC_ASRMCRB_BUFSTALLB (0x00200000U) /*!< Bit mask for ASRC_ASRMCRB_BUFSTALLB. */
#define BS_ASRC_ASRMCRB_BUFSTALLB (1U)     /*!< Bit field size in bits for ASRC_ASRMCRB_BUFSTALLB. */

/*! @brief Read current value of the ASRC_ASRMCRB_BUFSTALLB field. */
#define BR_ASRC_ASRMCRB_BUFSTALLB(x) (HW_ASRC_ASRMCRB(x).B.BUFSTALLB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_BUFSTALLB. */
#define BF_ASRC_ASRMCRB_BUFSTALLB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_BUFSTALLB) & BM_ASRC_ASRMCRB_BUFSTALLB)

/*! @brief Set the BUFSTALLB field to a new value. */
#define BW_ASRC_ASRMCRB_BUFSTALLB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_BUFSTALLB) | BF_ASRC_ASRMCRB_BUFSTALLB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field EXTTHRSHB[22] (RW)
 *
 * Use external thresholds for FIFO control of Pair B This bit will determine
 * whether the FIFO thresholds externally defined in this register is used to
 * control ASRC internal FIFO logic for pair B.
 *
 * Values:
 * - 1 - Use external defined thresholds.
 * - 0 - Use default thresholds.
 */
/*@{*/
#define BP_ASRC_ASRMCRB_EXTTHRSHB (22U)    /*!< Bit position for ASRC_ASRMCRB_EXTTHRSHB. */
#define BM_ASRC_ASRMCRB_EXTTHRSHB (0x00400000U) /*!< Bit mask for ASRC_ASRMCRB_EXTTHRSHB. */
#define BS_ASRC_ASRMCRB_EXTTHRSHB (1U)     /*!< Bit field size in bits for ASRC_ASRMCRB_EXTTHRSHB. */

/*! @brief Read current value of the ASRC_ASRMCRB_EXTTHRSHB field. */
#define BR_ASRC_ASRMCRB_EXTTHRSHB(x) (HW_ASRC_ASRMCRB(x).B.EXTTHRSHB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_EXTTHRSHB. */
#define BF_ASRC_ASRMCRB_EXTTHRSHB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_EXTTHRSHB) & BM_ASRC_ASRMCRB_EXTTHRSHB)

/*! @brief Set the EXTTHRSHB field to a new value. */
#define BW_ASRC_ASRMCRB_EXTTHRSHB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_EXTTHRSHB) | BF_ASRC_ASRMCRB_EXTTHRSHB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRB, field ZEROBUFB[23] (RW)
 *
 * Initialize buf of Pair B when pair B is enabled This bit is used to control
 * whether the buffer is to be zeroized when pair B is enabled.
 *
 * Values:
 * - 1 - Don't zeroize the buffer
 * - 0 - Zeroize the buffer
 */
/*@{*/
#define BP_ASRC_ASRMCRB_ZEROBUFB (23U)     /*!< Bit position for ASRC_ASRMCRB_ZEROBUFB. */
#define BM_ASRC_ASRMCRB_ZEROBUFB (0x00800000U) /*!< Bit mask for ASRC_ASRMCRB_ZEROBUFB. */
#define BS_ASRC_ASRMCRB_ZEROBUFB (1U)      /*!< Bit field size in bits for ASRC_ASRMCRB_ZEROBUFB. */

/*! @brief Read current value of the ASRC_ASRMCRB_ZEROBUFB field. */
#define BR_ASRC_ASRMCRB_ZEROBUFB(x) (HW_ASRC_ASRMCRB(x).B.ZEROBUFB)

/*! @brief Format value for bitfield ASRC_ASRMCRB_ZEROBUFB. */
#define BF_ASRC_ASRMCRB_ZEROBUFB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRB_ZEROBUFB) & BM_ASRC_ASRMCRB_ZEROBUFB)

/*! @brief Set the ZEROBUFB field to a new value. */
#define BW_ASRC_ASRMCRB_ZEROBUFB(x, v) (HW_ASRC_ASRMCRB_WR(x, (HW_ASRC_ASRMCRB_RD(x) & ~BM_ASRC_ASRMCRB_ZEROBUFB) | BF_ASRC_ASRMCRB_ZEROBUFB(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRFSTB - ASRC FIFO Status Register for Pair B
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRFSTB - ASRC FIFO Status Register for Pair B (RO)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRFSTB) is used to show Pair B internal FIFO conditions.
 */
typedef union _hw_asrc_asrfstb
{
    uint32_t U;
    struct _hw_asrc_asrfstb_bitfields
    {
        uint32_t INFIFO_FILLB : 7;     /*!< [6:0]  */
        uint32_t RESERVED0 : 4;        /*!< [10:7]  */
        uint32_t IAEB : 1;             /*!< [11]  */
        uint32_t OUTFIFO_FILLB : 7;    /*!< [18:12]  */
        uint32_t RESERVED1 : 4;        /*!< [22:19]  */
        uint32_t OAFB : 1;             /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrfstb_t;

/*!
 * @name Constants and macros for entire ASRC_ASRFSTB register
 */
/*@{*/
#define HW_ASRC_ASRFSTB_ADDR(x)  ((uintptr_t)(x) + 0xACU)

#define HW_ASRC_ASRFSTB(x)       (*(__I hw_asrc_asrfstb_t *) HW_ASRC_ASRFSTB_ADDR(x))
#define HW_ASRC_ASRFSTB_RD(x)    (HW_ASRC_ASRFSTB(x).U)
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRFSTB bitfields
 */

/*!
 * @name Register ASRC_ASRFSTB, field INFIFO_FILLB[6:0] (RO)
 *
 * The fillings for Pair B's input FIFO per channel These bits stand for the
 * fillings for Pair B's input FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTB_INFIFO_FILLB (0U)  /*!< Bit position for ASRC_ASRFSTB_INFIFO_FILLB. */
#define BM_ASRC_ASRFSTB_INFIFO_FILLB (0x0000007FU) /*!< Bit mask for ASRC_ASRFSTB_INFIFO_FILLB. */
#define BS_ASRC_ASRFSTB_INFIFO_FILLB (7U)  /*!< Bit field size in bits for ASRC_ASRFSTB_INFIFO_FILLB. */

/*! @brief Read current value of the ASRC_ASRFSTB_INFIFO_FILLB field. */
#define BR_ASRC_ASRFSTB_INFIFO_FILLB(x) (HW_ASRC_ASRFSTB(x).B.INFIFO_FILLB)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTB, field IAEB[11] (RO)
 *
 * Input FIFO is near Empty for Pair B This bit is to indicate whether the input
 * FIFO of Pair B is near empty.
 */
/*@{*/
#define BP_ASRC_ASRFSTB_IAEB (11U)         /*!< Bit position for ASRC_ASRFSTB_IAEB. */
#define BM_ASRC_ASRFSTB_IAEB (0x00000800U) /*!< Bit mask for ASRC_ASRFSTB_IAEB. */
#define BS_ASRC_ASRFSTB_IAEB (1U)          /*!< Bit field size in bits for ASRC_ASRFSTB_IAEB. */

/*! @brief Read current value of the ASRC_ASRFSTB_IAEB field. */
#define BR_ASRC_ASRFSTB_IAEB(x) (HW_ASRC_ASRFSTB(x).B.IAEB)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTB, field OUTFIFO_FILLB[18:12] (RO)
 *
 * The fillings for Pair B's output FIFO per channel These bits stand for the
 * fillings for Pair B's output FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTB_OUTFIFO_FILLB (12U) /*!< Bit position for ASRC_ASRFSTB_OUTFIFO_FILLB. */
#define BM_ASRC_ASRFSTB_OUTFIFO_FILLB (0x0007F000U) /*!< Bit mask for ASRC_ASRFSTB_OUTFIFO_FILLB. */
#define BS_ASRC_ASRFSTB_OUTFIFO_FILLB (7U) /*!< Bit field size in bits for ASRC_ASRFSTB_OUTFIFO_FILLB. */

/*! @brief Read current value of the ASRC_ASRFSTB_OUTFIFO_FILLB field. */
#define BR_ASRC_ASRFSTB_OUTFIFO_FILLB(x) (HW_ASRC_ASRFSTB(x).B.OUTFIFO_FILLB)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTB, field OAFB[23] (RO)
 *
 * Output FIFO is near Full for Pair B This bit is to indicate whether the
 * output FIFO of Pair B is near full.
 */
/*@{*/
#define BP_ASRC_ASRFSTB_OAFB (23U)         /*!< Bit position for ASRC_ASRFSTB_OAFB. */
#define BM_ASRC_ASRFSTB_OAFB (0x00800000U) /*!< Bit mask for ASRC_ASRFSTB_OAFB. */
#define BS_ASRC_ASRFSTB_OAFB (1U)          /*!< Bit field size in bits for ASRC_ASRFSTB_OAFB. */

/*! @brief Read current value of the ASRC_ASRFSTB_OAFB field. */
#define BR_ASRC_ASRFSTB_OAFB(x) (HW_ASRC_ASRFSTB(x).B.OAFB)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRMCRC - ASRC Misc Control Register for Pair C
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRMCRC - ASRC Misc Control Register for Pair C (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRMCRC) is used to control Pair C internal logic.
 */
typedef union _hw_asrc_asrmcrc
{
    uint32_t U;
    struct _hw_asrc_asrmcrc_bitfields
    {
        uint32_t INFIFO_THRESHOLDC : 6; /*!< [5:0]  */
        uint32_t RESERVED0 : 4;        /*!< [9:6]  */
        uint32_t RSYNOFC : 1;          /*!< [10]  */
        uint32_t RSYNIFC : 1;          /*!< [11]  */
        uint32_t OUTFIFO_THRESHOLDC : 6; /*!< [17:12]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t BYPASSPOLYC : 1;      /*!< [20]  */
        uint32_t BUFSTALLC : 1;        /*!< [21]  */
        uint32_t EXTTHRSHC : 1;        /*!< [22]  */
        uint32_t ZEROBUFC : 1;         /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrmcrc_t;

/*!
 * @name Constants and macros for entire ASRC_ASRMCRC register
 */
/*@{*/
#define HW_ASRC_ASRMCRC_ADDR(x)  ((uintptr_t)(x) + 0xB0U)

#define HW_ASRC_ASRMCRC(x)       (*(__IO hw_asrc_asrmcrc_t *) HW_ASRC_ASRMCRC_ADDR(x))
#define HW_ASRC_ASRMCRC_RD(x)    (HW_ASRC_ASRMCRC(x).U)
#define HW_ASRC_ASRMCRC_WR(x, v) (HW_ASRC_ASRMCRC(x).U = (v))
#define HW_ASRC_ASRMCRC_SET(x, v) (HW_ASRC_ASRMCRC_WR(x, HW_ASRC_ASRMCRC_RD(x) |  (v)))
#define HW_ASRC_ASRMCRC_CLR(x, v) (HW_ASRC_ASRMCRC_WR(x, HW_ASRC_ASRMCRC_RD(x) & ~(v)))
#define HW_ASRC_ASRMCRC_TOG(x, v) (HW_ASRC_ASRMCRC_WR(x, HW_ASRC_ASRMCRC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRMCRC bitfields
 */

/*!
 * @name Register ASRC_ASRMCRC, field INFIFO_THRESHOLDC[5:0] (RW)
 *
 * The threshold for Pair C's input FIFO per channel These bits stand for the
 * threshold for Pair C's input FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of input FIFO fillings of the
 * pair is less than n samples per channel, the input data needed flag is set; when
 * the number of input FIFO fillings of the pair is greater than or equal to n
 * samples per channel, the input data needed flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_INFIFO_THRESHOLDC (0U) /*!< Bit position for ASRC_ASRMCRC_INFIFO_THRESHOLDC. */
#define BM_ASRC_ASRMCRC_INFIFO_THRESHOLDC (0x0000003FU) /*!< Bit mask for ASRC_ASRMCRC_INFIFO_THRESHOLDC. */
#define BS_ASRC_ASRMCRC_INFIFO_THRESHOLDC (6U) /*!< Bit field size in bits for ASRC_ASRMCRC_INFIFO_THRESHOLDC. */

/*! @brief Read current value of the ASRC_ASRMCRC_INFIFO_THRESHOLDC field. */
#define BR_ASRC_ASRMCRC_INFIFO_THRESHOLDC(x) (HW_ASRC_ASRMCRC(x).B.INFIFO_THRESHOLDC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_INFIFO_THRESHOLDC. */
#define BF_ASRC_ASRMCRC_INFIFO_THRESHOLDC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_INFIFO_THRESHOLDC) & BM_ASRC_ASRMCRC_INFIFO_THRESHOLDC)

/*! @brief Set the INFIFO_THRESHOLDC field to a new value. */
#define BW_ASRC_ASRMCRC_INFIFO_THRESHOLDC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_INFIFO_THRESHOLDC) | BF_ASRC_ASRMCRC_INFIFO_THRESHOLDC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field RSYNOFC[10] (RW)
 *
 * Re-sync Output FIFO Channel Counter If bit set, force ASRCCR:ACOC=0. If bit
 * clear, untouch ASRCCR:ACOC.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_RSYNOFC (10U)      /*!< Bit position for ASRC_ASRMCRC_RSYNOFC. */
#define BM_ASRC_ASRMCRC_RSYNOFC (0x00000400U) /*!< Bit mask for ASRC_ASRMCRC_RSYNOFC. */
#define BS_ASRC_ASRMCRC_RSYNOFC (1U)       /*!< Bit field size in bits for ASRC_ASRMCRC_RSYNOFC. */

/*! @brief Read current value of the ASRC_ASRMCRC_RSYNOFC field. */
#define BR_ASRC_ASRMCRC_RSYNOFC(x) (HW_ASRC_ASRMCRC(x).B.RSYNOFC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_RSYNOFC. */
#define BF_ASRC_ASRMCRC_RSYNOFC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_RSYNOFC) & BM_ASRC_ASRMCRC_RSYNOFC)

/*! @brief Set the RSYNOFC field to a new value. */
#define BW_ASRC_ASRMCRC_RSYNOFC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_RSYNOFC) | BF_ASRC_ASRMCRC_RSYNOFC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field RSYNIFC[11] (RW)
 *
 * Re-sync Input FIFO Channel Counter If bit set, force ASRCCR:ACIC=0. If bit
 * clear, untouch ASRCCR:ACIC.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_RSYNIFC (11U)      /*!< Bit position for ASRC_ASRMCRC_RSYNIFC. */
#define BM_ASRC_ASRMCRC_RSYNIFC (0x00000800U) /*!< Bit mask for ASRC_ASRMCRC_RSYNIFC. */
#define BS_ASRC_ASRMCRC_RSYNIFC (1U)       /*!< Bit field size in bits for ASRC_ASRMCRC_RSYNIFC. */

/*! @brief Read current value of the ASRC_ASRMCRC_RSYNIFC field. */
#define BR_ASRC_ASRMCRC_RSYNIFC(x) (HW_ASRC_ASRMCRC(x).B.RSYNIFC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_RSYNIFC. */
#define BF_ASRC_ASRMCRC_RSYNIFC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_RSYNIFC) & BM_ASRC_ASRMCRC_RSYNIFC)

/*! @brief Set the RSYNIFC field to a new value. */
#define BW_ASRC_ASRMCRC_RSYNIFC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_RSYNIFC) | BF_ASRC_ASRMCRC_RSYNIFC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field OUTFIFO_THRESHOLDC[17:12] (RW)
 *
 * The threshold for Pair C's output FIFO per channel These bits stand for the
 * threshold for Pair C's output FIFO per channel. Possible range is [0,63]. When
 * the value is n, it means that: when the number of output FIFO fillings of the
 * pair is greater than n samples per channel, the output data ready flag is set;
 * when the number of output FIFO fillings of the pair is less than or equal to
 * n samples per channel, the output data ready flag is automatically cleared.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC (12U) /*!< Bit position for ASRC_ASRMCRC_OUTFIFO_THRESHOLDC. */
#define BM_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC (0x0003F000U) /*!< Bit mask for ASRC_ASRMCRC_OUTFIFO_THRESHOLDC. */
#define BS_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC (6U) /*!< Bit field size in bits for ASRC_ASRMCRC_OUTFIFO_THRESHOLDC. */

/*! @brief Read current value of the ASRC_ASRMCRC_OUTFIFO_THRESHOLDC field. */
#define BR_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC(x) (HW_ASRC_ASRMCRC(x).B.OUTFIFO_THRESHOLDC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_OUTFIFO_THRESHOLDC. */
#define BF_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC) & BM_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC)

/*! @brief Set the OUTFIFO_THRESHOLDC field to a new value. */
#define BW_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC) | BF_ASRC_ASRMCRC_OUTFIFO_THRESHOLDC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field BYPASSPOLYC[20] (RW)
 *
 * Bypass Polyphase Filtering for Pair C This bit will determine whether the
 * polyphase filtering part of Pair C conversion will be bypassed.
 *
 * Values:
 * - 1 - Bypass polyphase filtering.
 * - 0 - Don't bypass polyphase filtering.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_BYPASSPOLYC (20U)  /*!< Bit position for ASRC_ASRMCRC_BYPASSPOLYC. */
#define BM_ASRC_ASRMCRC_BYPASSPOLYC (0x00100000U) /*!< Bit mask for ASRC_ASRMCRC_BYPASSPOLYC. */
#define BS_ASRC_ASRMCRC_BYPASSPOLYC (1U)   /*!< Bit field size in bits for ASRC_ASRMCRC_BYPASSPOLYC. */

/*! @brief Read current value of the ASRC_ASRMCRC_BYPASSPOLYC field. */
#define BR_ASRC_ASRMCRC_BYPASSPOLYC(x) (HW_ASRC_ASRMCRC(x).B.BYPASSPOLYC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_BYPASSPOLYC. */
#define BF_ASRC_ASRMCRC_BYPASSPOLYC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_BYPASSPOLYC) & BM_ASRC_ASRMCRC_BYPASSPOLYC)

/*! @brief Set the BYPASSPOLYC field to a new value. */
#define BW_ASRC_ASRMCRC_BYPASSPOLYC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_BYPASSPOLYC) | BF_ASRC_ASRMCRC_BYPASSPOLYC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field BUFSTALLC[21] (RW)
 *
 * Stall Pair C conversion in case of Buffer Near Empty/Full Condition This bit
 * will determine whether the near empty/full FIFO condition will stall the rate
 * conversion for pair C. This option can only work when external ratio is used.
 * Near empty condition is the condition when input FIFO has less than 4 useful
 * samples per channel. Near full condition is the condition when the output FIFO
 * has less than 4 vacant sample words to fill per channel.
 *
 * Values:
 * - 1 - Stall Pair C conversion in case of near empty/full FIFO conditions.
 * - 0 - Don't stall Pair C conversion even in case of near empty/full FIFO
 *     conditions.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_BUFSTALLC (21U)    /*!< Bit position for ASRC_ASRMCRC_BUFSTALLC. */
#define BM_ASRC_ASRMCRC_BUFSTALLC (0x00200000U) /*!< Bit mask for ASRC_ASRMCRC_BUFSTALLC. */
#define BS_ASRC_ASRMCRC_BUFSTALLC (1U)     /*!< Bit field size in bits for ASRC_ASRMCRC_BUFSTALLC. */

/*! @brief Read current value of the ASRC_ASRMCRC_BUFSTALLC field. */
#define BR_ASRC_ASRMCRC_BUFSTALLC(x) (HW_ASRC_ASRMCRC(x).B.BUFSTALLC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_BUFSTALLC. */
#define BF_ASRC_ASRMCRC_BUFSTALLC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_BUFSTALLC) & BM_ASRC_ASRMCRC_BUFSTALLC)

/*! @brief Set the BUFSTALLC field to a new value. */
#define BW_ASRC_ASRMCRC_BUFSTALLC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_BUFSTALLC) | BF_ASRC_ASRMCRC_BUFSTALLC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field EXTTHRSHC[22] (RW)
 *
 * Use external thresholds for FIFO control of Pair C This bit will determine
 * whether the FIFO thresholds externally defined in this register is used to
 * control ASRC internal FIFO logic for pair C.
 *
 * Values:
 * - 1 - Use external defined thresholds.
 * - 0 - Use default thresholds.
 */
/*@{*/
#define BP_ASRC_ASRMCRC_EXTTHRSHC (22U)    /*!< Bit position for ASRC_ASRMCRC_EXTTHRSHC. */
#define BM_ASRC_ASRMCRC_EXTTHRSHC (0x00400000U) /*!< Bit mask for ASRC_ASRMCRC_EXTTHRSHC. */
#define BS_ASRC_ASRMCRC_EXTTHRSHC (1U)     /*!< Bit field size in bits for ASRC_ASRMCRC_EXTTHRSHC. */

/*! @brief Read current value of the ASRC_ASRMCRC_EXTTHRSHC field. */
#define BR_ASRC_ASRMCRC_EXTTHRSHC(x) (HW_ASRC_ASRMCRC(x).B.EXTTHRSHC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_EXTTHRSHC. */
#define BF_ASRC_ASRMCRC_EXTTHRSHC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_EXTTHRSHC) & BM_ASRC_ASRMCRC_EXTTHRSHC)

/*! @brief Set the EXTTHRSHC field to a new value. */
#define BW_ASRC_ASRMCRC_EXTTHRSHC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_EXTTHRSHC) | BF_ASRC_ASRMCRC_EXTTHRSHC(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCRC, field ZEROBUFC[23] (RW)
 *
 * Initialize buf of Pair C when pair C is enabled This bit is used to control
 * whether the buffer is to be zeroized when pair C is enabled.
 *
 * Values:
 * - 1 - Don't zeroize the buffer
 * - 0 - Zeroize the buffer
 */
/*@{*/
#define BP_ASRC_ASRMCRC_ZEROBUFC (23U)     /*!< Bit position for ASRC_ASRMCRC_ZEROBUFC. */
#define BM_ASRC_ASRMCRC_ZEROBUFC (0x00800000U) /*!< Bit mask for ASRC_ASRMCRC_ZEROBUFC. */
#define BS_ASRC_ASRMCRC_ZEROBUFC (1U)      /*!< Bit field size in bits for ASRC_ASRMCRC_ZEROBUFC. */

/*! @brief Read current value of the ASRC_ASRMCRC_ZEROBUFC field. */
#define BR_ASRC_ASRMCRC_ZEROBUFC(x) (HW_ASRC_ASRMCRC(x).B.ZEROBUFC)

/*! @brief Format value for bitfield ASRC_ASRMCRC_ZEROBUFC. */
#define BF_ASRC_ASRMCRC_ZEROBUFC(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCRC_ZEROBUFC) & BM_ASRC_ASRMCRC_ZEROBUFC)

/*! @brief Set the ZEROBUFC field to a new value. */
#define BW_ASRC_ASRMCRC_ZEROBUFC(x, v) (HW_ASRC_ASRMCRC_WR(x, (HW_ASRC_ASRMCRC_RD(x) & ~BM_ASRC_ASRMCRC_ZEROBUFC) | BF_ASRC_ASRMCRC_ZEROBUFC(v)))
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRFSTC - ASRC FIFO Status Register for Pair C
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRFSTC - ASRC FIFO Status Register for Pair C (RO)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRFSTC) is used to show Pair C internal FIFO conditions.
 */
typedef union _hw_asrc_asrfstc
{
    uint32_t U;
    struct _hw_asrc_asrfstc_bitfields
    {
        uint32_t INFIFO_FILLC : 7;     /*!< [6:0]  */
        uint32_t RESERVED0 : 4;        /*!< [10:7]  */
        uint32_t IAEC : 1;             /*!< [11]  */
        uint32_t OUTFIFO_FILLC : 7;    /*!< [18:12]  */
        uint32_t RESERVED1 : 4;        /*!< [22:19]  */
        uint32_t OAFC : 1;             /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrfstc_t;

/*!
 * @name Constants and macros for entire ASRC_ASRFSTC register
 */
/*@{*/
#define HW_ASRC_ASRFSTC_ADDR(x)  ((uintptr_t)(x) + 0xB4U)

#define HW_ASRC_ASRFSTC(x)       (*(__I hw_asrc_asrfstc_t *) HW_ASRC_ASRFSTC_ADDR(x))
#define HW_ASRC_ASRFSTC_RD(x)    (HW_ASRC_ASRFSTC(x).U)
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRFSTC bitfields
 */

/*!
 * @name Register ASRC_ASRFSTC, field INFIFO_FILLC[6:0] (RO)
 *
 * The fillings for Pair C's input FIFO per channel These bits stand for the
 * fillings for Pair C's input FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTC_INFIFO_FILLC (0U)  /*!< Bit position for ASRC_ASRFSTC_INFIFO_FILLC. */
#define BM_ASRC_ASRFSTC_INFIFO_FILLC (0x0000007FU) /*!< Bit mask for ASRC_ASRFSTC_INFIFO_FILLC. */
#define BS_ASRC_ASRFSTC_INFIFO_FILLC (7U)  /*!< Bit field size in bits for ASRC_ASRFSTC_INFIFO_FILLC. */

/*! @brief Read current value of the ASRC_ASRFSTC_INFIFO_FILLC field. */
#define BR_ASRC_ASRFSTC_INFIFO_FILLC(x) (HW_ASRC_ASRFSTC(x).B.INFIFO_FILLC)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTC, field IAEC[11] (RO)
 *
 * Input FIFO is near Empty for Pair C This bit is to indicate whether the input
 * FIFO of Pair C is near empty.
 */
/*@{*/
#define BP_ASRC_ASRFSTC_IAEC (11U)         /*!< Bit position for ASRC_ASRFSTC_IAEC. */
#define BM_ASRC_ASRFSTC_IAEC (0x00000800U) /*!< Bit mask for ASRC_ASRFSTC_IAEC. */
#define BS_ASRC_ASRFSTC_IAEC (1U)          /*!< Bit field size in bits for ASRC_ASRFSTC_IAEC. */

/*! @brief Read current value of the ASRC_ASRFSTC_IAEC field. */
#define BR_ASRC_ASRFSTC_IAEC(x) (HW_ASRC_ASRFSTC(x).B.IAEC)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTC, field OUTFIFO_FILLC[18:12] (RO)
 *
 * The fillings for Pair C's output FIFO per channel These bits stand for the
 * fillings for Pair C's output FIFO per channel. Possible range is [0,64].
 */
/*@{*/
#define BP_ASRC_ASRFSTC_OUTFIFO_FILLC (12U) /*!< Bit position for ASRC_ASRFSTC_OUTFIFO_FILLC. */
#define BM_ASRC_ASRFSTC_OUTFIFO_FILLC (0x0007F000U) /*!< Bit mask for ASRC_ASRFSTC_OUTFIFO_FILLC. */
#define BS_ASRC_ASRFSTC_OUTFIFO_FILLC (7U) /*!< Bit field size in bits for ASRC_ASRFSTC_OUTFIFO_FILLC. */

/*! @brief Read current value of the ASRC_ASRFSTC_OUTFIFO_FILLC field. */
#define BR_ASRC_ASRFSTC_OUTFIFO_FILLC(x) (HW_ASRC_ASRFSTC(x).B.OUTFIFO_FILLC)
/*@}*/

/*!
 * @name Register ASRC_ASRFSTC, field OAFC[23] (RO)
 *
 * Output FIFO is near Full for Pair C This bit is to indicate whether the
 * output FIFO of Pair C is near full.
 */
/*@{*/
#define BP_ASRC_ASRFSTC_OAFC (23U)         /*!< Bit position for ASRC_ASRFSTC_OAFC. */
#define BM_ASRC_ASRFSTC_OAFC (0x00800000U) /*!< Bit mask for ASRC_ASRFSTC_OAFC. */
#define BS_ASRC_ASRFSTC_OAFC (1U)          /*!< Bit field size in bits for ASRC_ASRFSTC_OAFC. */

/*! @brief Read current value of the ASRC_ASRFSTC_OAFC field. */
#define BR_ASRC_ASRFSTC_OAFC(x) (HW_ASRC_ASRFSTC(x).B.OAFC)
/*@}*/

/*******************************************************************************
 * HW_ASRC_ASRMCR1n - ASRC Misc Control Register 1 for Pair X
 ******************************************************************************/

/*!
 * @brief HW_ASRC_ASRMCR1n - ASRC Misc Control Register 1 for Pair X (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register (ASRMCR1x) is used to control Pair x internal logic (for data
 * alignment etc.). The bit assignment for all the input data formats is the same
 * as that supported by the SSI.
 */
typedef union _hw_asrc_asrmcr1n
{
    uint32_t U;
    struct _hw_asrc_asrmcr1n_bitfields
    {
        uint32_t OW16 : 1;             /*!< [0]  */
        uint32_t OSGN : 1;             /*!< [1]  */
        uint32_t OMSB : 1;             /*!< [2]  */
        uint32_t RESERVED0 : 5;        /*!< [7:3]  */
        uint32_t IMSB : 1;             /*!< [8]  */
        uint32_t IWD : 3;              /*!< [11:9]  */
        uint32_t RESERVED1 : 20;       /*!< [31:12] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_asrc_asrmcr1n_t;

/*!
 * @name Constants and macros for entire ASRC_ASRMCR1n register
 */
/*@{*/
#define HW_ASRC_ASRMCR1n_COUNT (3U)

#define HW_ASRC_ASRMCR1n_ADDR(x, n) ((uintptr_t)(x) + 0xC0U + (0x4U * (n)))

#define HW_ASRC_ASRMCR1n(x, n)   (*(__IO hw_asrc_asrmcr1n_t *) HW_ASRC_ASRMCR1n_ADDR(x, n))
#define HW_ASRC_ASRMCR1n_RD(x, n) (HW_ASRC_ASRMCR1n(x, n).U)
#define HW_ASRC_ASRMCR1n_WR(x, n, v) (HW_ASRC_ASRMCR1n(x, n).U = (v))
#define HW_ASRC_ASRMCR1n_SET(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, HW_ASRC_ASRMCR1n_RD(x, n) |  (v)))
#define HW_ASRC_ASRMCR1n_CLR(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, HW_ASRC_ASRMCR1n_RD(x, n) & ~(v)))
#define HW_ASRC_ASRMCR1n_TOG(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, HW_ASRC_ASRMCR1n_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ASRC_ASRMCR1n bitfields
 */

/*!
 * @name Register ASRC_ASRMCR1n, field OW16[0] (RW)
 *
 * Bit Width Option of the output FIFO This bit will determine the bit width
 * option of the output FIFO.
 *
 * Values:
 * - 1 - 16-bit output data
 * - 0 - 24-bit output data.
 */
/*@{*/
#define BP_ASRC_ASRMCR1n_OW16 (0U)         /*!< Bit position for ASRC_ASRMCR1n_OW16. */
#define BM_ASRC_ASRMCR1n_OW16 (0x00000001U) /*!< Bit mask for ASRC_ASRMCR1n_OW16. */
#define BS_ASRC_ASRMCR1n_OW16 (1U)         /*!< Bit field size in bits for ASRC_ASRMCR1n_OW16. */

/*! @brief Read current value of the ASRC_ASRMCR1n_OW16 field. */
#define BR_ASRC_ASRMCR1n_OW16(x, n) (HW_ASRC_ASRMCR1n(x, n).B.OW16)

/*! @brief Format value for bitfield ASRC_ASRMCR1n_OW16. */
#define BF_ASRC_ASRMCR1n_OW16(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCR1n_OW16) & BM_ASRC_ASRMCR1n_OW16)

/*! @brief Set the OW16 field to a new value. */
#define BW_ASRC_ASRMCR1n_OW16(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, (HW_ASRC_ASRMCR1n_RD(x, n) & ~BM_ASRC_ASRMCR1n_OW16) | BF_ASRC_ASRMCR1n_OW16(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCR1n, field OSGN[1] (RW)
 *
 * Sign Extension Option of the output FIFO This bit will determine the sign
 * extension option of the output FIFO.
 *
 * Values:
 * - 1 - Sign extension.
 * - 0 - No sign extension.
 */
/*@{*/
#define BP_ASRC_ASRMCR1n_OSGN (1U)         /*!< Bit position for ASRC_ASRMCR1n_OSGN. */
#define BM_ASRC_ASRMCR1n_OSGN (0x00000002U) /*!< Bit mask for ASRC_ASRMCR1n_OSGN. */
#define BS_ASRC_ASRMCR1n_OSGN (1U)         /*!< Bit field size in bits for ASRC_ASRMCR1n_OSGN. */

/*! @brief Read current value of the ASRC_ASRMCR1n_OSGN field. */
#define BR_ASRC_ASRMCR1n_OSGN(x, n) (HW_ASRC_ASRMCR1n(x, n).B.OSGN)

/*! @brief Format value for bitfield ASRC_ASRMCR1n_OSGN. */
#define BF_ASRC_ASRMCR1n_OSGN(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCR1n_OSGN) & BM_ASRC_ASRMCR1n_OSGN)

/*! @brief Set the OSGN field to a new value. */
#define BW_ASRC_ASRMCR1n_OSGN(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, (HW_ASRC_ASRMCR1n_RD(x, n) & ~BM_ASRC_ASRMCR1n_OSGN) | BF_ASRC_ASRMCR1n_OSGN(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCR1n, field OMSB[2] (RW)
 *
 * Data Alignment of the output FIFO This bit will determine the data alignment
 * of the output FIFO.
 *
 * Values:
 * - 1 - MSB aligned.
 * - 0 - LSB aligned.
 */
/*@{*/
#define BP_ASRC_ASRMCR1n_OMSB (2U)         /*!< Bit position for ASRC_ASRMCR1n_OMSB. */
#define BM_ASRC_ASRMCR1n_OMSB (0x00000004U) /*!< Bit mask for ASRC_ASRMCR1n_OMSB. */
#define BS_ASRC_ASRMCR1n_OMSB (1U)         /*!< Bit field size in bits for ASRC_ASRMCR1n_OMSB. */

/*! @brief Read current value of the ASRC_ASRMCR1n_OMSB field. */
#define BR_ASRC_ASRMCR1n_OMSB(x, n) (HW_ASRC_ASRMCR1n(x, n).B.OMSB)

/*! @brief Format value for bitfield ASRC_ASRMCR1n_OMSB. */
#define BF_ASRC_ASRMCR1n_OMSB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCR1n_OMSB) & BM_ASRC_ASRMCR1n_OMSB)

/*! @brief Set the OMSB field to a new value. */
#define BW_ASRC_ASRMCR1n_OMSB(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, (HW_ASRC_ASRMCR1n_RD(x, n) & ~BM_ASRC_ASRMCR1n_OMSB) | BF_ASRC_ASRMCR1n_OMSB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCR1n, field IMSB[8] (RW)
 *
 * Data Alignment of the input FIFO This bit will determine the data alignment
 * of the input FIFO.
 *
 * Values:
 * - 1 - MSB aligned.
 * - 0 - LSB aligned.
 */
/*@{*/
#define BP_ASRC_ASRMCR1n_IMSB (8U)         /*!< Bit position for ASRC_ASRMCR1n_IMSB. */
#define BM_ASRC_ASRMCR1n_IMSB (0x00000100U) /*!< Bit mask for ASRC_ASRMCR1n_IMSB. */
#define BS_ASRC_ASRMCR1n_IMSB (1U)         /*!< Bit field size in bits for ASRC_ASRMCR1n_IMSB. */

/*! @brief Read current value of the ASRC_ASRMCR1n_IMSB field. */
#define BR_ASRC_ASRMCR1n_IMSB(x, n) (HW_ASRC_ASRMCR1n(x, n).B.IMSB)

/*! @brief Format value for bitfield ASRC_ASRMCR1n_IMSB. */
#define BF_ASRC_ASRMCR1n_IMSB(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCR1n_IMSB) & BM_ASRC_ASRMCR1n_IMSB)

/*! @brief Set the IMSB field to a new value. */
#define BW_ASRC_ASRMCR1n_IMSB(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, (HW_ASRC_ASRMCR1n_RD(x, n) & ~BM_ASRC_ASRMCR1n_IMSB) | BF_ASRC_ASRMCR1n_IMSB(v)))
/*@}*/

/*!
 * @name Register ASRC_ASRMCR1n, field IWD[11:9] (RW)
 *
 * Data Width of the input FIFO These three bits will determine the bitwidth for
 * the audio data into ASRC All other settings not shown are reserved. 3'b000
 * 24-bit audio data. 3'b001 16-bit audio data. 3'b010 8-bit audio data.
 */
/*@{*/
#define BP_ASRC_ASRMCR1n_IWD (9U)          /*!< Bit position for ASRC_ASRMCR1n_IWD. */
#define BM_ASRC_ASRMCR1n_IWD (0x00000E00U) /*!< Bit mask for ASRC_ASRMCR1n_IWD. */
#define BS_ASRC_ASRMCR1n_IWD (3U)          /*!< Bit field size in bits for ASRC_ASRMCR1n_IWD. */

/*! @brief Read current value of the ASRC_ASRMCR1n_IWD field. */
#define BR_ASRC_ASRMCR1n_IWD(x, n) (HW_ASRC_ASRMCR1n(x, n).B.IWD)

/*! @brief Format value for bitfield ASRC_ASRMCR1n_IWD. */
#define BF_ASRC_ASRMCR1n_IWD(v) ((uint32_t)((uint32_t)(v) << BP_ASRC_ASRMCR1n_IWD) & BM_ASRC_ASRMCR1n_IWD)

/*! @brief Set the IWD field to a new value. */
#define BW_ASRC_ASRMCR1n_IWD(x, n, v) (HW_ASRC_ASRMCR1n_WR(x, n, (HW_ASRC_ASRMCR1n_RD(x, n) & ~BM_ASRC_ASRMCR1n_IWD) | BF_ASRC_ASRMCR1n_IWD(v)))
/*@}*/

/*******************************************************************************
 * hw_asrc_t - module struct
 ******************************************************************************/
/*!
 * @brief All ASRC module registers.
 */
#pragma pack(1)
typedef struct _hw_asrc
{
    __IO hw_asrc_asrctr_t ASRCTR;          /*!< [0x0] ASRC Control Register */
    __IO hw_asrc_asrier_t ASRIER;          /*!< [0x4] ASRC Interrupt Enable Register */
    uint8_t _reserved0[4];
    __IO hw_asrc_asrcncr_t ASRCNCR;        /*!< [0xC] ASRC Channel Number Configuration Register */
    __IO hw_asrc_asrcfg_t ASRCFG;          /*!< [0x10] ASRC Filter Configuration Status Register */
    __IO hw_asrc_asrcsr_t ASRCSR;          /*!< [0x14] ASRC Clock Source Register */
    __IO hw_asrc_asrcdr1_t ASRCDR1;        /*!< [0x18] ASRC Clock Divider Register 1 */
    __IO hw_asrc_asrcdr2_t ASRCDR2;        /*!< [0x1C] ASRC Clock Divider Register 2 */
    __I hw_asrc_asrstr_t ASRSTR;           /*!< [0x20] ASRC Status Register */
    uint8_t _reserved1[28];
    __IO hw_asrc_asrpmn1_t ASRPMn1;        /*!< [0x40] ASRC Parameter Register n */
    __IO hw_asrc_asrpmn2_t ASRPMn2;        /*!< [0x44] ASRC Parameter Register n */
    __IO hw_asrc_asrpmn3_t ASRPMn3;        /*!< [0x48] ASRC Parameter Register n */
    __IO hw_asrc_asrpmn4_t ASRPMn4;        /*!< [0x4C] ASRC Parameter Register n */
    __IO hw_asrc_asrpmn5_t ASRPMn5;        /*!< [0x50] ASRC Parameter Register n */
    __IO hw_asrc_asrtfr1_t ASRTFR1;        /*!< [0x54] ASRC ASRC Task Queue FIFO Register 1 */
    uint8_t _reserved2[4];
    __IO hw_asrc_asrccr_t ASRCCR;          /*!< [0x5C] ASRC Channel Counter Register */
    struct {
        __O hw_asrc_asrdin_t ASRDIn;       /*!< [0x60] ASRC Data Input Register for Pair x */
        __I hw_asrc_asrdon_t ASRDOn;       /*!< [0x64] ASRC Data Output Register for Pair x */
    } ASRD[3];
    uint8_t _reserved3[8];
    __IO hw_asrc_asridrha_t ASRIDRHA;      /*!< [0x80] ASRC Ideal Ratio for Pair A-High Part */
    __IO hw_asrc_asridrla_t ASRIDRLA;      /*!< [0x84] ASRC Ideal Ratio for Pair A -Low Part */
    __IO hw_asrc_asridrhb_t ASRIDRHB;      /*!< [0x88] ASRC Ideal Ratio for Pair B-High Part */
    __IO hw_asrc_asridrlb_t ASRIDRLB;      /*!< [0x8C] ASRC Ideal Ratio for Pair B-Low Part */
    __IO hw_asrc_asridrhc_t ASRIDRHC;      /*!< [0x90] ASRC Ideal Ratio for Pair C-High Part */
    __IO hw_asrc_asridrlc_t ASRIDRLC;      /*!< [0x94] ASRC Ideal Ratio for Pair C-Low Part */
    __IO hw_asrc_asr76k_t ASR76K;          /*!< [0x98] ASRC 76kHz Period in terms of ASRC processing clock */
    __IO hw_asrc_asr56k_t ASR56K;          /*!< [0x9C] ASRC 56kHz Period in terms of ASRC processing clock */
    __IO hw_asrc_asrmcra_t ASRMCRA;        /*!< [0xA0] ASRC Misc Control Register for Pair A */
    __I hw_asrc_asrfsta_t ASRFSTA;         /*!< [0xA4] ASRC FIFO Status Register for Pair A */
    __IO hw_asrc_asrmcrb_t ASRMCRB;        /*!< [0xA8] ASRC Misc Control Register for Pair B */
    __I hw_asrc_asrfstb_t ASRFSTB;         /*!< [0xAC] ASRC FIFO Status Register for Pair B */
    __IO hw_asrc_asrmcrc_t ASRMCRC;        /*!< [0xB0] ASRC Misc Control Register for Pair C */
    __I hw_asrc_asrfstc_t ASRFSTC;         /*!< [0xB4] ASRC FIFO Status Register for Pair C */
    uint8_t _reserved4[8];
    __IO hw_asrc_asrmcr1n_t ASRMCR1n[3];   /*!< [0xC0] ASRC Misc Control Register 1 for Pair X */
} hw_asrc_t;
#pragma pack()

/*! @brief Macro to access all ASRC registers. */
/*! @param x ASRC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ASRC_REGS(ASRC_BASE)</code>. */
#define HW_ASRC_REGS(x) (*(hw_asrc_t *)(x))

/*
 * iMX6DP AUDMUX
 *
 * AUDMUX Registers
 *
 * Registers defined in this header file:
 * - HW_AUDMUX_PTCR1 - Port Timing Control Register 1
 * - HW_AUDMUX_PDCR1 - Port Data Control Register 1
 * - HW_AUDMUX_PTCR2 - Port Timing Control Register 2
 * - HW_AUDMUX_PDCR2 - Port Data Control Register 2
 * - HW_AUDMUX_PTCR3 - Port Timing Control Register 3
 * - HW_AUDMUX_PDCR3 - Port Data Control Register 3
 * - HW_AUDMUX_PTCR4 - Port Timing Control Register 4
 * - HW_AUDMUX_PDCR4 - Port Data Control Register 4
 * - HW_AUDMUX_PTCR5 - Port Timing Control Register 5
 * - HW_AUDMUX_PDCR5 - Port Data Control Register 5
 * - HW_AUDMUX_PTCR6 - Port Timing Control Register 6
 * - HW_AUDMUX_PDCR6 - Port Data Control Register 6
 * - HW_AUDMUX_PTCR7 - Port Timing Control Register 7
 * - HW_AUDMUX_PDCR7 - Port Data Control Register 7
 *
 * - hw_audmux_t - Struct containing all module registers.
 */

#define HW_AUDMUX_INSTANCE_COUNT (1U) /*!< Number of instances of the AUDMUX module. */
#define HW_AUDMUX (0U) /*!< Instance number for AUDMUX. */
#define AUDMUX_BASE           (0x21D8000U) /*!< Base address for AUDMUX. */
/*! Array initializer of AUDMUX base addresses. */
#define AUDMUX_BASE_ADDRS     { AUDMUX_BASE }

/*******************************************************************************
 * HW_AUDMUX_PTCR1 - Port Timing Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR1 - Port Timing Control Register 1 (RW)
 *
 * Reset value: 0xAD400800U
 *
 * PTCR1 is the Port Timing Control Register for Port 1.
 */
typedef union _hw_audmux_ptcr1
{
    uint32_t U;
    struct _hw_audmux_ptcr1_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr1_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR1 register
 */
/*@{*/
#define HW_AUDMUX_PTCR1_ADDR(x)  ((uintptr_t)(x) + 0x0U)

#define HW_AUDMUX_PTCR1(x)       (*(__IO hw_audmux_ptcr1_t *) HW_AUDMUX_PTCR1_ADDR(x))
#define HW_AUDMUX_PTCR1_RD(x)    (HW_AUDMUX_PTCR1(x).U)
#define HW_AUDMUX_PTCR1_WR(x, v) (HW_AUDMUX_PTCR1(x).U = (v))
#define HW_AUDMUX_PTCR1_SET(x, v) (HW_AUDMUX_PTCR1_WR(x, HW_AUDMUX_PTCR1_RD(x) |  (v)))
#define HW_AUDMUX_PTCR1_CLR(x, v) (HW_AUDMUX_PTCR1_WR(x, HW_AUDMUX_PTCR1_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR1_TOG(x, v) (HW_AUDMUX_PTCR1_WR(x, HW_AUDMUX_PTCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR1 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR1, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR1_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR1_SYN. */
#define BM_AUDMUX_PTCR1_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR1_SYN. */
#define BS_AUDMUX_PTCR1_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR1_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR1_SYN field. */
#define BR_AUDMUX_PTCR1_SYN(x) (HW_AUDMUX_PTCR1(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR1_SYN. */
#define BF_AUDMUX_PTCR1_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_SYN) & BM_AUDMUX_PTCR1_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR1_SYN(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_SYN) | BF_AUDMUX_PTCR1_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR1_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR1_RCSEL. */
#define BM_AUDMUX_PTCR1_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR1_RCSEL. */
#define BS_AUDMUX_PTCR1_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR1_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR1_RCSEL field. */
#define BR_AUDMUX_PTCR1_RCSEL(x) (HW_AUDMUX_PTCR1(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR1_RCSEL. */
#define BF_AUDMUX_PTCR1_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_RCSEL) & BM_AUDMUX_PTCR1_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR1_RCSEL(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_RCSEL) | BF_AUDMUX_PTCR1_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR1_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR1_RCLKDIR. */
#define BM_AUDMUX_PTCR1_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR1_RCLKDIR. */
#define BS_AUDMUX_PTCR1_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR1_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR1_RCLKDIR field. */
#define BR_AUDMUX_PTCR1_RCLKDIR(x) (HW_AUDMUX_PTCR1(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR1_RCLKDIR. */
#define BF_AUDMUX_PTCR1_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_RCLKDIR) & BM_AUDMUX_PTCR1_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR1_RCLKDIR(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_RCLKDIR) | BF_AUDMUX_PTCR1_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR1_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR1_RFSEL. */
#define BM_AUDMUX_PTCR1_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR1_RFSEL. */
#define BS_AUDMUX_PTCR1_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR1_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR1_RFSEL field. */
#define BR_AUDMUX_PTCR1_RFSEL(x) (HW_AUDMUX_PTCR1(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR1_RFSEL. */
#define BF_AUDMUX_PTCR1_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_RFSEL) & BM_AUDMUX_PTCR1_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR1_RFSEL(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_RFSEL) | BF_AUDMUX_PTCR1_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR1_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR1_RFS_DIR. */
#define BM_AUDMUX_PTCR1_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR1_RFS_DIR. */
#define BS_AUDMUX_PTCR1_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR1_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR1_RFS_DIR field. */
#define BR_AUDMUX_PTCR1_RFS_DIR(x) (HW_AUDMUX_PTCR1(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR1_RFS_DIR. */
#define BF_AUDMUX_PTCR1_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_RFS_DIR) & BM_AUDMUX_PTCR1_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR1_RFS_DIR(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_RFS_DIR) | BF_AUDMUX_PTCR1_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR1_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR1_TCSEL. */
#define BM_AUDMUX_PTCR1_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR1_TCSEL. */
#define BS_AUDMUX_PTCR1_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR1_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR1_TCSEL field. */
#define BR_AUDMUX_PTCR1_TCSEL(x) (HW_AUDMUX_PTCR1(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR1_TCSEL. */
#define BF_AUDMUX_PTCR1_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_TCSEL) & BM_AUDMUX_PTCR1_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR1_TCSEL(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_TCSEL) | BF_AUDMUX_PTCR1_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR1_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR1_TCLKDIR. */
#define BM_AUDMUX_PTCR1_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR1_TCLKDIR. */
#define BS_AUDMUX_PTCR1_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR1_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR1_TCLKDIR field. */
#define BR_AUDMUX_PTCR1_TCLKDIR(x) (HW_AUDMUX_PTCR1(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR1_TCLKDIR. */
#define BF_AUDMUX_PTCR1_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_TCLKDIR) & BM_AUDMUX_PTCR1_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR1_TCLKDIR(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_TCLKDIR) | BF_AUDMUX_PTCR1_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR1_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR1_TFSEL. */
#define BM_AUDMUX_PTCR1_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR1_TFSEL. */
#define BS_AUDMUX_PTCR1_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR1_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR1_TFSEL field. */
#define BR_AUDMUX_PTCR1_TFSEL(x) (HW_AUDMUX_PTCR1(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR1_TFSEL. */
#define BF_AUDMUX_PTCR1_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_TFSEL) & BM_AUDMUX_PTCR1_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR1_TFSEL(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_TFSEL) | BF_AUDMUX_PTCR1_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR1, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR1_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR1_TFS_DIR. */
#define BM_AUDMUX_PTCR1_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR1_TFS_DIR. */
#define BS_AUDMUX_PTCR1_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR1_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR1_TFS_DIR field. */
#define BR_AUDMUX_PTCR1_TFS_DIR(x) (HW_AUDMUX_PTCR1(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR1_TFS_DIR. */
#define BF_AUDMUX_PTCR1_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR1_TFS_DIR) & BM_AUDMUX_PTCR1_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR1_TFS_DIR(x, v) (HW_AUDMUX_PTCR1_WR(x, (HW_AUDMUX_PTCR1_RD(x) & ~BM_AUDMUX_PTCR1_TFS_DIR) | BF_AUDMUX_PTCR1_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR1 - Port Data Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR1 - Port Data Control Register 1 (RW)
 *
 * Reset value: 0x0000A000U
 *
 * PDCR1 is the Port Data Control Register for Port 1.
 */
typedef union _hw_audmux_pdcr1
{
    uint32_t U;
    struct _hw_audmux_pdcr1_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr1_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR1 register
 */
/*@{*/
#define HW_AUDMUX_PDCR1_ADDR(x)  ((uintptr_t)(x) + 0x4U)

#define HW_AUDMUX_PDCR1(x)       (*(__IO hw_audmux_pdcr1_t *) HW_AUDMUX_PDCR1_ADDR(x))
#define HW_AUDMUX_PDCR1_RD(x)    (HW_AUDMUX_PDCR1(x).U)
#define HW_AUDMUX_PDCR1_WR(x, v) (HW_AUDMUX_PDCR1(x).U = (v))
#define HW_AUDMUX_PDCR1_SET(x, v) (HW_AUDMUX_PDCR1_WR(x, HW_AUDMUX_PDCR1_RD(x) |  (v)))
#define HW_AUDMUX_PDCR1_CLR(x, v) (HW_AUDMUX_PDCR1_WR(x, HW_AUDMUX_PDCR1_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR1_TOG(x, v) (HW_AUDMUX_PDCR1_WR(x, HW_AUDMUX_PDCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR1 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR1, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR1_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR1_INMMASK. */
#define BM_AUDMUX_PDCR1_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR1_INMMASK. */
#define BS_AUDMUX_PDCR1_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR1_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR1_INMMASK field. */
#define BR_AUDMUX_PDCR1_INMMASK(x) (HW_AUDMUX_PDCR1(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR1_INMMASK. */
#define BF_AUDMUX_PDCR1_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR1_INMMASK) & BM_AUDMUX_PDCR1_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR1_INMMASK(x, v) (HW_AUDMUX_PDCR1_WR(x, (HW_AUDMUX_PDCR1_RD(x) & ~BM_AUDMUX_PDCR1_INMMASK) | BF_AUDMUX_PDCR1_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR1, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR1_MODE (8U)          /*!< Bit position for AUDMUX_PDCR1_MODE. */
#define BM_AUDMUX_PDCR1_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR1_MODE. */
#define BS_AUDMUX_PDCR1_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR1_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR1_MODE field. */
#define BR_AUDMUX_PDCR1_MODE(x) (HW_AUDMUX_PDCR1(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR1_MODE. */
#define BF_AUDMUX_PDCR1_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR1_MODE) & BM_AUDMUX_PDCR1_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR1_MODE(x, v) (HW_AUDMUX_PDCR1_WR(x, (HW_AUDMUX_PDCR1_RD(x) & ~BM_AUDMUX_PDCR1_MODE) | BF_AUDMUX_PDCR1_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR1, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR1_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR1_TXRXEN. */
#define BM_AUDMUX_PDCR1_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR1_TXRXEN. */
#define BS_AUDMUX_PDCR1_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR1_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR1_TXRXEN field. */
#define BR_AUDMUX_PDCR1_TXRXEN(x) (HW_AUDMUX_PDCR1(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR1_TXRXEN. */
#define BF_AUDMUX_PDCR1_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR1_TXRXEN) & BM_AUDMUX_PDCR1_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR1_TXRXEN(x, v) (HW_AUDMUX_PDCR1_WR(x, (HW_AUDMUX_PDCR1_RD(x) & ~BM_AUDMUX_PDCR1_TXRXEN) | BF_AUDMUX_PDCR1_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR1, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR1_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR1_RXDSEL. */
#define BM_AUDMUX_PDCR1_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR1_RXDSEL. */
#define BS_AUDMUX_PDCR1_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR1_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR1_RXDSEL field. */
#define BR_AUDMUX_PDCR1_RXDSEL(x) (HW_AUDMUX_PDCR1(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR1_RXDSEL. */
#define BF_AUDMUX_PDCR1_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR1_RXDSEL) & BM_AUDMUX_PDCR1_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR1_RXDSEL(x, v) (HW_AUDMUX_PDCR1_WR(x, (HW_AUDMUX_PDCR1_RD(x) & ~BM_AUDMUX_PDCR1_RXDSEL) | BF_AUDMUX_PDCR1_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR2 - Port Timing Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR2 - Port Timing Control Register 2 (RW)
 *
 * Reset value: 0xA5000800U
 *
 * PTCR2 is the Port Timing Control Register for Port 2.
 */
typedef union _hw_audmux_ptcr2
{
    uint32_t U;
    struct _hw_audmux_ptcr2_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr2_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR2 register
 */
/*@{*/
#define HW_AUDMUX_PTCR2_ADDR(x)  ((uintptr_t)(x) + 0x8U)

#define HW_AUDMUX_PTCR2(x)       (*(__IO hw_audmux_ptcr2_t *) HW_AUDMUX_PTCR2_ADDR(x))
#define HW_AUDMUX_PTCR2_RD(x)    (HW_AUDMUX_PTCR2(x).U)
#define HW_AUDMUX_PTCR2_WR(x, v) (HW_AUDMUX_PTCR2(x).U = (v))
#define HW_AUDMUX_PTCR2_SET(x, v) (HW_AUDMUX_PTCR2_WR(x, HW_AUDMUX_PTCR2_RD(x) |  (v)))
#define HW_AUDMUX_PTCR2_CLR(x, v) (HW_AUDMUX_PTCR2_WR(x, HW_AUDMUX_PTCR2_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR2_TOG(x, v) (HW_AUDMUX_PTCR2_WR(x, HW_AUDMUX_PTCR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR2 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR2, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR2_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR2_SYN. */
#define BM_AUDMUX_PTCR2_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR2_SYN. */
#define BS_AUDMUX_PTCR2_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR2_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR2_SYN field. */
#define BR_AUDMUX_PTCR2_SYN(x) (HW_AUDMUX_PTCR2(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR2_SYN. */
#define BF_AUDMUX_PTCR2_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_SYN) & BM_AUDMUX_PTCR2_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR2_SYN(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_SYN) | BF_AUDMUX_PTCR2_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR2_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR2_RCSEL. */
#define BM_AUDMUX_PTCR2_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR2_RCSEL. */
#define BS_AUDMUX_PTCR2_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR2_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR2_RCSEL field. */
#define BR_AUDMUX_PTCR2_RCSEL(x) (HW_AUDMUX_PTCR2(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR2_RCSEL. */
#define BF_AUDMUX_PTCR2_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_RCSEL) & BM_AUDMUX_PTCR2_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR2_RCSEL(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_RCSEL) | BF_AUDMUX_PTCR2_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR2_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR2_RCLKDIR. */
#define BM_AUDMUX_PTCR2_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR2_RCLKDIR. */
#define BS_AUDMUX_PTCR2_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR2_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR2_RCLKDIR field. */
#define BR_AUDMUX_PTCR2_RCLKDIR(x) (HW_AUDMUX_PTCR2(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR2_RCLKDIR. */
#define BF_AUDMUX_PTCR2_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_RCLKDIR) & BM_AUDMUX_PTCR2_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR2_RCLKDIR(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_RCLKDIR) | BF_AUDMUX_PTCR2_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR2_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR2_RFSEL. */
#define BM_AUDMUX_PTCR2_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR2_RFSEL. */
#define BS_AUDMUX_PTCR2_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR2_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR2_RFSEL field. */
#define BR_AUDMUX_PTCR2_RFSEL(x) (HW_AUDMUX_PTCR2(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR2_RFSEL. */
#define BF_AUDMUX_PTCR2_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_RFSEL) & BM_AUDMUX_PTCR2_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR2_RFSEL(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_RFSEL) | BF_AUDMUX_PTCR2_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR2_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR2_RFS_DIR. */
#define BM_AUDMUX_PTCR2_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR2_RFS_DIR. */
#define BS_AUDMUX_PTCR2_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR2_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR2_RFS_DIR field. */
#define BR_AUDMUX_PTCR2_RFS_DIR(x) (HW_AUDMUX_PTCR2(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR2_RFS_DIR. */
#define BF_AUDMUX_PTCR2_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_RFS_DIR) & BM_AUDMUX_PTCR2_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR2_RFS_DIR(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_RFS_DIR) | BF_AUDMUX_PTCR2_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR2_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR2_TCSEL. */
#define BM_AUDMUX_PTCR2_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR2_TCSEL. */
#define BS_AUDMUX_PTCR2_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR2_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR2_TCSEL field. */
#define BR_AUDMUX_PTCR2_TCSEL(x) (HW_AUDMUX_PTCR2(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR2_TCSEL. */
#define BF_AUDMUX_PTCR2_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_TCSEL) & BM_AUDMUX_PTCR2_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR2_TCSEL(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_TCSEL) | BF_AUDMUX_PTCR2_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR2_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR2_TCLKDIR. */
#define BM_AUDMUX_PTCR2_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR2_TCLKDIR. */
#define BS_AUDMUX_PTCR2_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR2_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR2_TCLKDIR field. */
#define BR_AUDMUX_PTCR2_TCLKDIR(x) (HW_AUDMUX_PTCR2(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR2_TCLKDIR. */
#define BF_AUDMUX_PTCR2_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_TCLKDIR) & BM_AUDMUX_PTCR2_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR2_TCLKDIR(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_TCLKDIR) | BF_AUDMUX_PTCR2_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR2_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR2_TFSEL. */
#define BM_AUDMUX_PTCR2_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR2_TFSEL. */
#define BS_AUDMUX_PTCR2_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR2_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR2_TFSEL field. */
#define BR_AUDMUX_PTCR2_TFSEL(x) (HW_AUDMUX_PTCR2(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR2_TFSEL. */
#define BF_AUDMUX_PTCR2_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_TFSEL) & BM_AUDMUX_PTCR2_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR2_TFSEL(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_TFSEL) | BF_AUDMUX_PTCR2_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR2, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR2_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR2_TFS_DIR. */
#define BM_AUDMUX_PTCR2_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR2_TFS_DIR. */
#define BS_AUDMUX_PTCR2_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR2_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR2_TFS_DIR field. */
#define BR_AUDMUX_PTCR2_TFS_DIR(x) (HW_AUDMUX_PTCR2(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR2_TFS_DIR. */
#define BF_AUDMUX_PTCR2_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR2_TFS_DIR) & BM_AUDMUX_PTCR2_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR2_TFS_DIR(x, v) (HW_AUDMUX_PTCR2_WR(x, (HW_AUDMUX_PTCR2_RD(x) & ~BM_AUDMUX_PTCR2_TFS_DIR) | BF_AUDMUX_PTCR2_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR2 - Port Data Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR2 - Port Data Control Register 2 (RW)
 *
 * Reset value: 0x00008000U
 *
 * PDCR2 is the Port Data Control Register for Port 2.
 */
typedef union _hw_audmux_pdcr2
{
    uint32_t U;
    struct _hw_audmux_pdcr2_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr2_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR2 register
 */
/*@{*/
#define HW_AUDMUX_PDCR2_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_AUDMUX_PDCR2(x)       (*(__IO hw_audmux_pdcr2_t *) HW_AUDMUX_PDCR2_ADDR(x))
#define HW_AUDMUX_PDCR2_RD(x)    (HW_AUDMUX_PDCR2(x).U)
#define HW_AUDMUX_PDCR2_WR(x, v) (HW_AUDMUX_PDCR2(x).U = (v))
#define HW_AUDMUX_PDCR2_SET(x, v) (HW_AUDMUX_PDCR2_WR(x, HW_AUDMUX_PDCR2_RD(x) |  (v)))
#define HW_AUDMUX_PDCR2_CLR(x, v) (HW_AUDMUX_PDCR2_WR(x, HW_AUDMUX_PDCR2_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR2_TOG(x, v) (HW_AUDMUX_PDCR2_WR(x, HW_AUDMUX_PDCR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR2 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR2, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR2_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR2_INMMASK. */
#define BM_AUDMUX_PDCR2_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR2_INMMASK. */
#define BS_AUDMUX_PDCR2_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR2_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR2_INMMASK field. */
#define BR_AUDMUX_PDCR2_INMMASK(x) (HW_AUDMUX_PDCR2(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR2_INMMASK. */
#define BF_AUDMUX_PDCR2_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR2_INMMASK) & BM_AUDMUX_PDCR2_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR2_INMMASK(x, v) (HW_AUDMUX_PDCR2_WR(x, (HW_AUDMUX_PDCR2_RD(x) & ~BM_AUDMUX_PDCR2_INMMASK) | BF_AUDMUX_PDCR2_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR2, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR2_MODE (8U)          /*!< Bit position for AUDMUX_PDCR2_MODE. */
#define BM_AUDMUX_PDCR2_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR2_MODE. */
#define BS_AUDMUX_PDCR2_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR2_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR2_MODE field. */
#define BR_AUDMUX_PDCR2_MODE(x) (HW_AUDMUX_PDCR2(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR2_MODE. */
#define BF_AUDMUX_PDCR2_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR2_MODE) & BM_AUDMUX_PDCR2_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR2_MODE(x, v) (HW_AUDMUX_PDCR2_WR(x, (HW_AUDMUX_PDCR2_RD(x) & ~BM_AUDMUX_PDCR2_MODE) | BF_AUDMUX_PDCR2_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR2, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR2_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR2_TXRXEN. */
#define BM_AUDMUX_PDCR2_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR2_TXRXEN. */
#define BS_AUDMUX_PDCR2_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR2_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR2_TXRXEN field. */
#define BR_AUDMUX_PDCR2_TXRXEN(x) (HW_AUDMUX_PDCR2(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR2_TXRXEN. */
#define BF_AUDMUX_PDCR2_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR2_TXRXEN) & BM_AUDMUX_PDCR2_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR2_TXRXEN(x, v) (HW_AUDMUX_PDCR2_WR(x, (HW_AUDMUX_PDCR2_RD(x) & ~BM_AUDMUX_PDCR2_TXRXEN) | BF_AUDMUX_PDCR2_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR2, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR2_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR2_RXDSEL. */
#define BM_AUDMUX_PDCR2_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR2_RXDSEL. */
#define BS_AUDMUX_PDCR2_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR2_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR2_RXDSEL field. */
#define BR_AUDMUX_PDCR2_RXDSEL(x) (HW_AUDMUX_PDCR2(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR2_RXDSEL. */
#define BF_AUDMUX_PDCR2_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR2_RXDSEL) & BM_AUDMUX_PDCR2_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR2_RXDSEL(x, v) (HW_AUDMUX_PDCR2_WR(x, (HW_AUDMUX_PDCR2_RD(x) & ~BM_AUDMUX_PDCR2_RXDSEL) | BF_AUDMUX_PDCR2_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR3 - Port Timing Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR3 - Port Timing Control Register 3 (RW)
 *
 * Reset value: 0x9CC00800U
 *
 * PTCR3 is the Port Timing Control Register for Port 3.
 */
typedef union _hw_audmux_ptcr3
{
    uint32_t U;
    struct _hw_audmux_ptcr3_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr3_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR3 register
 */
/*@{*/
#define HW_AUDMUX_PTCR3_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_AUDMUX_PTCR3(x)       (*(__IO hw_audmux_ptcr3_t *) HW_AUDMUX_PTCR3_ADDR(x))
#define HW_AUDMUX_PTCR3_RD(x)    (HW_AUDMUX_PTCR3(x).U)
#define HW_AUDMUX_PTCR3_WR(x, v) (HW_AUDMUX_PTCR3(x).U = (v))
#define HW_AUDMUX_PTCR3_SET(x, v) (HW_AUDMUX_PTCR3_WR(x, HW_AUDMUX_PTCR3_RD(x) |  (v)))
#define HW_AUDMUX_PTCR3_CLR(x, v) (HW_AUDMUX_PTCR3_WR(x, HW_AUDMUX_PTCR3_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR3_TOG(x, v) (HW_AUDMUX_PTCR3_WR(x, HW_AUDMUX_PTCR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR3 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR3, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR3_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR3_SYN. */
#define BM_AUDMUX_PTCR3_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR3_SYN. */
#define BS_AUDMUX_PTCR3_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR3_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR3_SYN field. */
#define BR_AUDMUX_PTCR3_SYN(x) (HW_AUDMUX_PTCR3(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR3_SYN. */
#define BF_AUDMUX_PTCR3_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_SYN) & BM_AUDMUX_PTCR3_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR3_SYN(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_SYN) | BF_AUDMUX_PTCR3_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR3_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR3_RCSEL. */
#define BM_AUDMUX_PTCR3_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR3_RCSEL. */
#define BS_AUDMUX_PTCR3_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR3_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR3_RCSEL field. */
#define BR_AUDMUX_PTCR3_RCSEL(x) (HW_AUDMUX_PTCR3(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR3_RCSEL. */
#define BF_AUDMUX_PTCR3_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_RCSEL) & BM_AUDMUX_PTCR3_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR3_RCSEL(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_RCSEL) | BF_AUDMUX_PTCR3_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR3_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR3_RCLKDIR. */
#define BM_AUDMUX_PTCR3_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR3_RCLKDIR. */
#define BS_AUDMUX_PTCR3_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR3_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR3_RCLKDIR field. */
#define BR_AUDMUX_PTCR3_RCLKDIR(x) (HW_AUDMUX_PTCR3(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR3_RCLKDIR. */
#define BF_AUDMUX_PTCR3_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_RCLKDIR) & BM_AUDMUX_PTCR3_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR3_RCLKDIR(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_RCLKDIR) | BF_AUDMUX_PTCR3_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR3_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR3_RFSEL. */
#define BM_AUDMUX_PTCR3_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR3_RFSEL. */
#define BS_AUDMUX_PTCR3_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR3_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR3_RFSEL field. */
#define BR_AUDMUX_PTCR3_RFSEL(x) (HW_AUDMUX_PTCR3(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR3_RFSEL. */
#define BF_AUDMUX_PTCR3_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_RFSEL) & BM_AUDMUX_PTCR3_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR3_RFSEL(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_RFSEL) | BF_AUDMUX_PTCR3_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR3_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR3_RFS_DIR. */
#define BM_AUDMUX_PTCR3_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR3_RFS_DIR. */
#define BS_AUDMUX_PTCR3_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR3_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR3_RFS_DIR field. */
#define BR_AUDMUX_PTCR3_RFS_DIR(x) (HW_AUDMUX_PTCR3(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR3_RFS_DIR. */
#define BF_AUDMUX_PTCR3_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_RFS_DIR) & BM_AUDMUX_PTCR3_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR3_RFS_DIR(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_RFS_DIR) | BF_AUDMUX_PTCR3_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR3_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR3_TCSEL. */
#define BM_AUDMUX_PTCR3_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR3_TCSEL. */
#define BS_AUDMUX_PTCR3_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR3_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR3_TCSEL field. */
#define BR_AUDMUX_PTCR3_TCSEL(x) (HW_AUDMUX_PTCR3(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR3_TCSEL. */
#define BF_AUDMUX_PTCR3_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_TCSEL) & BM_AUDMUX_PTCR3_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR3_TCSEL(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_TCSEL) | BF_AUDMUX_PTCR3_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR3_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR3_TCLKDIR. */
#define BM_AUDMUX_PTCR3_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR3_TCLKDIR. */
#define BS_AUDMUX_PTCR3_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR3_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR3_TCLKDIR field. */
#define BR_AUDMUX_PTCR3_TCLKDIR(x) (HW_AUDMUX_PTCR3(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR3_TCLKDIR. */
#define BF_AUDMUX_PTCR3_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_TCLKDIR) & BM_AUDMUX_PTCR3_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR3_TCLKDIR(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_TCLKDIR) | BF_AUDMUX_PTCR3_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR3_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR3_TFSEL. */
#define BM_AUDMUX_PTCR3_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR3_TFSEL. */
#define BS_AUDMUX_PTCR3_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR3_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR3_TFSEL field. */
#define BR_AUDMUX_PTCR3_TFSEL(x) (HW_AUDMUX_PTCR3(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR3_TFSEL. */
#define BF_AUDMUX_PTCR3_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_TFSEL) & BM_AUDMUX_PTCR3_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR3_TFSEL(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_TFSEL) | BF_AUDMUX_PTCR3_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR3, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR3_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR3_TFS_DIR. */
#define BM_AUDMUX_PTCR3_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR3_TFS_DIR. */
#define BS_AUDMUX_PTCR3_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR3_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR3_TFS_DIR field. */
#define BR_AUDMUX_PTCR3_TFS_DIR(x) (HW_AUDMUX_PTCR3(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR3_TFS_DIR. */
#define BF_AUDMUX_PTCR3_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR3_TFS_DIR) & BM_AUDMUX_PTCR3_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR3_TFS_DIR(x, v) (HW_AUDMUX_PTCR3_WR(x, (HW_AUDMUX_PTCR3_RD(x) & ~BM_AUDMUX_PTCR3_TFS_DIR) | BF_AUDMUX_PTCR3_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR3 - Port Data Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR3 - Port Data Control Register 3 (RW)
 *
 * Reset value: 0x00006000U
 *
 * PDCR3 is the Port Data Control Register for Port 3.
 */
typedef union _hw_audmux_pdcr3
{
    uint32_t U;
    struct _hw_audmux_pdcr3_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr3_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR3 register
 */
/*@{*/
#define HW_AUDMUX_PDCR3_ADDR(x)  ((uintptr_t)(x) + 0x14U)

#define HW_AUDMUX_PDCR3(x)       (*(__IO hw_audmux_pdcr3_t *) HW_AUDMUX_PDCR3_ADDR(x))
#define HW_AUDMUX_PDCR3_RD(x)    (HW_AUDMUX_PDCR3(x).U)
#define HW_AUDMUX_PDCR3_WR(x, v) (HW_AUDMUX_PDCR3(x).U = (v))
#define HW_AUDMUX_PDCR3_SET(x, v) (HW_AUDMUX_PDCR3_WR(x, HW_AUDMUX_PDCR3_RD(x) |  (v)))
#define HW_AUDMUX_PDCR3_CLR(x, v) (HW_AUDMUX_PDCR3_WR(x, HW_AUDMUX_PDCR3_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR3_TOG(x, v) (HW_AUDMUX_PDCR3_WR(x, HW_AUDMUX_PDCR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR3 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR3, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR3_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR3_INMMASK. */
#define BM_AUDMUX_PDCR3_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR3_INMMASK. */
#define BS_AUDMUX_PDCR3_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR3_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR3_INMMASK field. */
#define BR_AUDMUX_PDCR3_INMMASK(x) (HW_AUDMUX_PDCR3(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR3_INMMASK. */
#define BF_AUDMUX_PDCR3_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR3_INMMASK) & BM_AUDMUX_PDCR3_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR3_INMMASK(x, v) (HW_AUDMUX_PDCR3_WR(x, (HW_AUDMUX_PDCR3_RD(x) & ~BM_AUDMUX_PDCR3_INMMASK) | BF_AUDMUX_PDCR3_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR3, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR3_MODE (8U)          /*!< Bit position for AUDMUX_PDCR3_MODE. */
#define BM_AUDMUX_PDCR3_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR3_MODE. */
#define BS_AUDMUX_PDCR3_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR3_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR3_MODE field. */
#define BR_AUDMUX_PDCR3_MODE(x) (HW_AUDMUX_PDCR3(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR3_MODE. */
#define BF_AUDMUX_PDCR3_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR3_MODE) & BM_AUDMUX_PDCR3_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR3_MODE(x, v) (HW_AUDMUX_PDCR3_WR(x, (HW_AUDMUX_PDCR3_RD(x) & ~BM_AUDMUX_PDCR3_MODE) | BF_AUDMUX_PDCR3_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR3, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR3_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR3_TXRXEN. */
#define BM_AUDMUX_PDCR3_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR3_TXRXEN. */
#define BS_AUDMUX_PDCR3_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR3_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR3_TXRXEN field. */
#define BR_AUDMUX_PDCR3_TXRXEN(x) (HW_AUDMUX_PDCR3(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR3_TXRXEN. */
#define BF_AUDMUX_PDCR3_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR3_TXRXEN) & BM_AUDMUX_PDCR3_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR3_TXRXEN(x, v) (HW_AUDMUX_PDCR3_WR(x, (HW_AUDMUX_PDCR3_RD(x) & ~BM_AUDMUX_PDCR3_TXRXEN) | BF_AUDMUX_PDCR3_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR3, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR3_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR3_RXDSEL. */
#define BM_AUDMUX_PDCR3_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR3_RXDSEL. */
#define BS_AUDMUX_PDCR3_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR3_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR3_RXDSEL field. */
#define BR_AUDMUX_PDCR3_RXDSEL(x) (HW_AUDMUX_PDCR3(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR3_RXDSEL. */
#define BF_AUDMUX_PDCR3_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR3_RXDSEL) & BM_AUDMUX_PDCR3_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR3_RXDSEL(x, v) (HW_AUDMUX_PDCR3_WR(x, (HW_AUDMUX_PDCR3_RD(x) & ~BM_AUDMUX_PDCR3_RXDSEL) | BF_AUDMUX_PDCR3_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR4 - Port Timing Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR4 - Port Timing Control Register 4 (RW)
 *
 * Reset value: 0x00000800U
 *
 * Port Timing Control Register for Port 4
 */
typedef union _hw_audmux_ptcr4
{
    uint32_t U;
    struct _hw_audmux_ptcr4_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr4_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR4 register
 */
/*@{*/
#define HW_AUDMUX_PTCR4_ADDR(x)  ((uintptr_t)(x) + 0x18U)

#define HW_AUDMUX_PTCR4(x)       (*(__IO hw_audmux_ptcr4_t *) HW_AUDMUX_PTCR4_ADDR(x))
#define HW_AUDMUX_PTCR4_RD(x)    (HW_AUDMUX_PTCR4(x).U)
#define HW_AUDMUX_PTCR4_WR(x, v) (HW_AUDMUX_PTCR4(x).U = (v))
#define HW_AUDMUX_PTCR4_SET(x, v) (HW_AUDMUX_PTCR4_WR(x, HW_AUDMUX_PTCR4_RD(x) |  (v)))
#define HW_AUDMUX_PTCR4_CLR(x, v) (HW_AUDMUX_PTCR4_WR(x, HW_AUDMUX_PTCR4_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR4_TOG(x, v) (HW_AUDMUX_PTCR4_WR(x, HW_AUDMUX_PTCR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR4 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR4, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR4_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR4_SYN. */
#define BM_AUDMUX_PTCR4_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR4_SYN. */
#define BS_AUDMUX_PTCR4_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR4_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR4_SYN field. */
#define BR_AUDMUX_PTCR4_SYN(x) (HW_AUDMUX_PTCR4(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR4_SYN. */
#define BF_AUDMUX_PTCR4_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_SYN) & BM_AUDMUX_PTCR4_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR4_SYN(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_SYN) | BF_AUDMUX_PTCR4_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR4_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR4_RCSEL. */
#define BM_AUDMUX_PTCR4_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR4_RCSEL. */
#define BS_AUDMUX_PTCR4_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR4_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR4_RCSEL field. */
#define BR_AUDMUX_PTCR4_RCSEL(x) (HW_AUDMUX_PTCR4(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR4_RCSEL. */
#define BF_AUDMUX_PTCR4_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_RCSEL) & BM_AUDMUX_PTCR4_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR4_RCSEL(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_RCSEL) | BF_AUDMUX_PTCR4_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR4_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR4_RCLKDIR. */
#define BM_AUDMUX_PTCR4_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR4_RCLKDIR. */
#define BS_AUDMUX_PTCR4_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR4_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR4_RCLKDIR field. */
#define BR_AUDMUX_PTCR4_RCLKDIR(x) (HW_AUDMUX_PTCR4(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR4_RCLKDIR. */
#define BF_AUDMUX_PTCR4_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_RCLKDIR) & BM_AUDMUX_PTCR4_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR4_RCLKDIR(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_RCLKDIR) | BF_AUDMUX_PTCR4_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR4_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR4_RFSEL. */
#define BM_AUDMUX_PTCR4_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR4_RFSEL. */
#define BS_AUDMUX_PTCR4_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR4_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR4_RFSEL field. */
#define BR_AUDMUX_PTCR4_RFSEL(x) (HW_AUDMUX_PTCR4(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR4_RFSEL. */
#define BF_AUDMUX_PTCR4_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_RFSEL) & BM_AUDMUX_PTCR4_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR4_RFSEL(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_RFSEL) | BF_AUDMUX_PTCR4_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR4_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR4_RFS_DIR. */
#define BM_AUDMUX_PTCR4_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR4_RFS_DIR. */
#define BS_AUDMUX_PTCR4_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR4_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR4_RFS_DIR field. */
#define BR_AUDMUX_PTCR4_RFS_DIR(x) (HW_AUDMUX_PTCR4(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR4_RFS_DIR. */
#define BF_AUDMUX_PTCR4_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_RFS_DIR) & BM_AUDMUX_PTCR4_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR4_RFS_DIR(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_RFS_DIR) | BF_AUDMUX_PTCR4_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR4_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR4_TCSEL. */
#define BM_AUDMUX_PTCR4_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR4_TCSEL. */
#define BS_AUDMUX_PTCR4_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR4_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR4_TCSEL field. */
#define BR_AUDMUX_PTCR4_TCSEL(x) (HW_AUDMUX_PTCR4(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR4_TCSEL. */
#define BF_AUDMUX_PTCR4_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_TCSEL) & BM_AUDMUX_PTCR4_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR4_TCSEL(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_TCSEL) | BF_AUDMUX_PTCR4_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR4_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR4_TCLKDIR. */
#define BM_AUDMUX_PTCR4_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR4_TCLKDIR. */
#define BS_AUDMUX_PTCR4_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR4_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR4_TCLKDIR field. */
#define BR_AUDMUX_PTCR4_TCLKDIR(x) (HW_AUDMUX_PTCR4(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR4_TCLKDIR. */
#define BF_AUDMUX_PTCR4_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_TCLKDIR) & BM_AUDMUX_PTCR4_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR4_TCLKDIR(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_TCLKDIR) | BF_AUDMUX_PTCR4_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR4_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR4_TFSEL. */
#define BM_AUDMUX_PTCR4_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR4_TFSEL. */
#define BS_AUDMUX_PTCR4_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR4_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR4_TFSEL field. */
#define BR_AUDMUX_PTCR4_TFSEL(x) (HW_AUDMUX_PTCR4(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR4_TFSEL. */
#define BF_AUDMUX_PTCR4_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_TFSEL) & BM_AUDMUX_PTCR4_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR4_TFSEL(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_TFSEL) | BF_AUDMUX_PTCR4_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR4, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR4_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR4_TFS_DIR. */
#define BM_AUDMUX_PTCR4_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR4_TFS_DIR. */
#define BS_AUDMUX_PTCR4_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR4_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR4_TFS_DIR field. */
#define BR_AUDMUX_PTCR4_TFS_DIR(x) (HW_AUDMUX_PTCR4(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR4_TFS_DIR. */
#define BF_AUDMUX_PTCR4_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR4_TFS_DIR) & BM_AUDMUX_PTCR4_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR4_TFS_DIR(x, v) (HW_AUDMUX_PTCR4_WR(x, (HW_AUDMUX_PTCR4_RD(x) & ~BM_AUDMUX_PTCR4_TFS_DIR) | BF_AUDMUX_PTCR4_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR4 - Port Data Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR4 - Port Data Control Register 4 (RW)
 *
 * Reset value: 0x00004000U
 *
 * PDCR4 is the Port Data Control Register for Port 4.
 */
typedef union _hw_audmux_pdcr4
{
    uint32_t U;
    struct _hw_audmux_pdcr4_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr4_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR4 register
 */
/*@{*/
#define HW_AUDMUX_PDCR4_ADDR(x)  ((uintptr_t)(x) + 0x1CU)

#define HW_AUDMUX_PDCR4(x)       (*(__IO hw_audmux_pdcr4_t *) HW_AUDMUX_PDCR4_ADDR(x))
#define HW_AUDMUX_PDCR4_RD(x)    (HW_AUDMUX_PDCR4(x).U)
#define HW_AUDMUX_PDCR4_WR(x, v) (HW_AUDMUX_PDCR4(x).U = (v))
#define HW_AUDMUX_PDCR4_SET(x, v) (HW_AUDMUX_PDCR4_WR(x, HW_AUDMUX_PDCR4_RD(x) |  (v)))
#define HW_AUDMUX_PDCR4_CLR(x, v) (HW_AUDMUX_PDCR4_WR(x, HW_AUDMUX_PDCR4_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR4_TOG(x, v) (HW_AUDMUX_PDCR4_WR(x, HW_AUDMUX_PDCR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR4 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR4, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR4_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR4_INMMASK. */
#define BM_AUDMUX_PDCR4_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR4_INMMASK. */
#define BS_AUDMUX_PDCR4_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR4_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR4_INMMASK field. */
#define BR_AUDMUX_PDCR4_INMMASK(x) (HW_AUDMUX_PDCR4(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR4_INMMASK. */
#define BF_AUDMUX_PDCR4_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR4_INMMASK) & BM_AUDMUX_PDCR4_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR4_INMMASK(x, v) (HW_AUDMUX_PDCR4_WR(x, (HW_AUDMUX_PDCR4_RD(x) & ~BM_AUDMUX_PDCR4_INMMASK) | BF_AUDMUX_PDCR4_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR4, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR4_MODE (8U)          /*!< Bit position for AUDMUX_PDCR4_MODE. */
#define BM_AUDMUX_PDCR4_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR4_MODE. */
#define BS_AUDMUX_PDCR4_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR4_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR4_MODE field. */
#define BR_AUDMUX_PDCR4_MODE(x) (HW_AUDMUX_PDCR4(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR4_MODE. */
#define BF_AUDMUX_PDCR4_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR4_MODE) & BM_AUDMUX_PDCR4_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR4_MODE(x, v) (HW_AUDMUX_PDCR4_WR(x, (HW_AUDMUX_PDCR4_RD(x) & ~BM_AUDMUX_PDCR4_MODE) | BF_AUDMUX_PDCR4_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR4, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR4_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR4_TXRXEN. */
#define BM_AUDMUX_PDCR4_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR4_TXRXEN. */
#define BS_AUDMUX_PDCR4_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR4_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR4_TXRXEN field. */
#define BR_AUDMUX_PDCR4_TXRXEN(x) (HW_AUDMUX_PDCR4(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR4_TXRXEN. */
#define BF_AUDMUX_PDCR4_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR4_TXRXEN) & BM_AUDMUX_PDCR4_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR4_TXRXEN(x, v) (HW_AUDMUX_PDCR4_WR(x, (HW_AUDMUX_PDCR4_RD(x) & ~BM_AUDMUX_PDCR4_TXRXEN) | BF_AUDMUX_PDCR4_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR4, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR4_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR4_RXDSEL. */
#define BM_AUDMUX_PDCR4_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR4_RXDSEL. */
#define BS_AUDMUX_PDCR4_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR4_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR4_RXDSEL field. */
#define BR_AUDMUX_PDCR4_RXDSEL(x) (HW_AUDMUX_PDCR4(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR4_RXDSEL. */
#define BF_AUDMUX_PDCR4_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR4_RXDSEL) & BM_AUDMUX_PDCR4_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR4_RXDSEL(x, v) (HW_AUDMUX_PDCR4_WR(x, (HW_AUDMUX_PDCR4_RD(x) & ~BM_AUDMUX_PDCR4_RXDSEL) | BF_AUDMUX_PDCR4_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR5 - Port Timing Control Register 5
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR5 - Port Timing Control Register 5 (RW)
 *
 * Reset value: 0x00000800U
 *
 * Port Timing Control Register for Port 5
 */
typedef union _hw_audmux_ptcr5
{
    uint32_t U;
    struct _hw_audmux_ptcr5_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr5_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR5 register
 */
/*@{*/
#define HW_AUDMUX_PTCR5_ADDR(x)  ((uintptr_t)(x) + 0x20U)

#define HW_AUDMUX_PTCR5(x)       (*(__IO hw_audmux_ptcr5_t *) HW_AUDMUX_PTCR5_ADDR(x))
#define HW_AUDMUX_PTCR5_RD(x)    (HW_AUDMUX_PTCR5(x).U)
#define HW_AUDMUX_PTCR5_WR(x, v) (HW_AUDMUX_PTCR5(x).U = (v))
#define HW_AUDMUX_PTCR5_SET(x, v) (HW_AUDMUX_PTCR5_WR(x, HW_AUDMUX_PTCR5_RD(x) |  (v)))
#define HW_AUDMUX_PTCR5_CLR(x, v) (HW_AUDMUX_PTCR5_WR(x, HW_AUDMUX_PTCR5_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR5_TOG(x, v) (HW_AUDMUX_PTCR5_WR(x, HW_AUDMUX_PTCR5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR5 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR5, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR5_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR5_SYN. */
#define BM_AUDMUX_PTCR5_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR5_SYN. */
#define BS_AUDMUX_PTCR5_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR5_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR5_SYN field. */
#define BR_AUDMUX_PTCR5_SYN(x) (HW_AUDMUX_PTCR5(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR5_SYN. */
#define BF_AUDMUX_PTCR5_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_SYN) & BM_AUDMUX_PTCR5_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR5_SYN(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_SYN) | BF_AUDMUX_PTCR5_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR5_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR5_RCSEL. */
#define BM_AUDMUX_PTCR5_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR5_RCSEL. */
#define BS_AUDMUX_PTCR5_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR5_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR5_RCSEL field. */
#define BR_AUDMUX_PTCR5_RCSEL(x) (HW_AUDMUX_PTCR5(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR5_RCSEL. */
#define BF_AUDMUX_PTCR5_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_RCSEL) & BM_AUDMUX_PTCR5_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR5_RCSEL(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_RCSEL) | BF_AUDMUX_PTCR5_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR5_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR5_RCLKDIR. */
#define BM_AUDMUX_PTCR5_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR5_RCLKDIR. */
#define BS_AUDMUX_PTCR5_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR5_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR5_RCLKDIR field. */
#define BR_AUDMUX_PTCR5_RCLKDIR(x) (HW_AUDMUX_PTCR5(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR5_RCLKDIR. */
#define BF_AUDMUX_PTCR5_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_RCLKDIR) & BM_AUDMUX_PTCR5_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR5_RCLKDIR(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_RCLKDIR) | BF_AUDMUX_PTCR5_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR5_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR5_RFSEL. */
#define BM_AUDMUX_PTCR5_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR5_RFSEL. */
#define BS_AUDMUX_PTCR5_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR5_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR5_RFSEL field. */
#define BR_AUDMUX_PTCR5_RFSEL(x) (HW_AUDMUX_PTCR5(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR5_RFSEL. */
#define BF_AUDMUX_PTCR5_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_RFSEL) & BM_AUDMUX_PTCR5_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR5_RFSEL(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_RFSEL) | BF_AUDMUX_PTCR5_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR5_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR5_RFS_DIR. */
#define BM_AUDMUX_PTCR5_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR5_RFS_DIR. */
#define BS_AUDMUX_PTCR5_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR5_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR5_RFS_DIR field. */
#define BR_AUDMUX_PTCR5_RFS_DIR(x) (HW_AUDMUX_PTCR5(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR5_RFS_DIR. */
#define BF_AUDMUX_PTCR5_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_RFS_DIR) & BM_AUDMUX_PTCR5_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR5_RFS_DIR(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_RFS_DIR) | BF_AUDMUX_PTCR5_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR5_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR5_TCSEL. */
#define BM_AUDMUX_PTCR5_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR5_TCSEL. */
#define BS_AUDMUX_PTCR5_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR5_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR5_TCSEL field. */
#define BR_AUDMUX_PTCR5_TCSEL(x) (HW_AUDMUX_PTCR5(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR5_TCSEL. */
#define BF_AUDMUX_PTCR5_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_TCSEL) & BM_AUDMUX_PTCR5_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR5_TCSEL(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_TCSEL) | BF_AUDMUX_PTCR5_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR5_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR5_TCLKDIR. */
#define BM_AUDMUX_PTCR5_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR5_TCLKDIR. */
#define BS_AUDMUX_PTCR5_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR5_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR5_TCLKDIR field. */
#define BR_AUDMUX_PTCR5_TCLKDIR(x) (HW_AUDMUX_PTCR5(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR5_TCLKDIR. */
#define BF_AUDMUX_PTCR5_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_TCLKDIR) & BM_AUDMUX_PTCR5_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR5_TCLKDIR(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_TCLKDIR) | BF_AUDMUX_PTCR5_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR5_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR5_TFSEL. */
#define BM_AUDMUX_PTCR5_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR5_TFSEL. */
#define BS_AUDMUX_PTCR5_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR5_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR5_TFSEL field. */
#define BR_AUDMUX_PTCR5_TFSEL(x) (HW_AUDMUX_PTCR5(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR5_TFSEL. */
#define BF_AUDMUX_PTCR5_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_TFSEL) & BM_AUDMUX_PTCR5_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR5_TFSEL(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_TFSEL) | BF_AUDMUX_PTCR5_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR5, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR5_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR5_TFS_DIR. */
#define BM_AUDMUX_PTCR5_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR5_TFS_DIR. */
#define BS_AUDMUX_PTCR5_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR5_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR5_TFS_DIR field. */
#define BR_AUDMUX_PTCR5_TFS_DIR(x) (HW_AUDMUX_PTCR5(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR5_TFS_DIR. */
#define BF_AUDMUX_PTCR5_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR5_TFS_DIR) & BM_AUDMUX_PTCR5_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR5_TFS_DIR(x, v) (HW_AUDMUX_PTCR5_WR(x, (HW_AUDMUX_PTCR5_RD(x) & ~BM_AUDMUX_PTCR5_TFS_DIR) | BF_AUDMUX_PTCR5_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR5 - Port Data Control Register 5
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR5 - Port Data Control Register 5 (RW)
 *
 * Reset value: 0x00002000U
 *
 * PDCR5 is the Port Data Control Register for Port 5.
 */
typedef union _hw_audmux_pdcr5
{
    uint32_t U;
    struct _hw_audmux_pdcr5_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr5_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR5 register
 */
/*@{*/
#define HW_AUDMUX_PDCR5_ADDR(x)  ((uintptr_t)(x) + 0x24U)

#define HW_AUDMUX_PDCR5(x)       (*(__IO hw_audmux_pdcr5_t *) HW_AUDMUX_PDCR5_ADDR(x))
#define HW_AUDMUX_PDCR5_RD(x)    (HW_AUDMUX_PDCR5(x).U)
#define HW_AUDMUX_PDCR5_WR(x, v) (HW_AUDMUX_PDCR5(x).U = (v))
#define HW_AUDMUX_PDCR5_SET(x, v) (HW_AUDMUX_PDCR5_WR(x, HW_AUDMUX_PDCR5_RD(x) |  (v)))
#define HW_AUDMUX_PDCR5_CLR(x, v) (HW_AUDMUX_PDCR5_WR(x, HW_AUDMUX_PDCR5_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR5_TOG(x, v) (HW_AUDMUX_PDCR5_WR(x, HW_AUDMUX_PDCR5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR5 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR5, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR5_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR5_INMMASK. */
#define BM_AUDMUX_PDCR5_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR5_INMMASK. */
#define BS_AUDMUX_PDCR5_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR5_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR5_INMMASK field. */
#define BR_AUDMUX_PDCR5_INMMASK(x) (HW_AUDMUX_PDCR5(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR5_INMMASK. */
#define BF_AUDMUX_PDCR5_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR5_INMMASK) & BM_AUDMUX_PDCR5_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR5_INMMASK(x, v) (HW_AUDMUX_PDCR5_WR(x, (HW_AUDMUX_PDCR5_RD(x) & ~BM_AUDMUX_PDCR5_INMMASK) | BF_AUDMUX_PDCR5_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR5, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR5_MODE (8U)          /*!< Bit position for AUDMUX_PDCR5_MODE. */
#define BM_AUDMUX_PDCR5_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR5_MODE. */
#define BS_AUDMUX_PDCR5_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR5_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR5_MODE field. */
#define BR_AUDMUX_PDCR5_MODE(x) (HW_AUDMUX_PDCR5(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR5_MODE. */
#define BF_AUDMUX_PDCR5_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR5_MODE) & BM_AUDMUX_PDCR5_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR5_MODE(x, v) (HW_AUDMUX_PDCR5_WR(x, (HW_AUDMUX_PDCR5_RD(x) & ~BM_AUDMUX_PDCR5_MODE) | BF_AUDMUX_PDCR5_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR5, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR5_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR5_TXRXEN. */
#define BM_AUDMUX_PDCR5_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR5_TXRXEN. */
#define BS_AUDMUX_PDCR5_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR5_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR5_TXRXEN field. */
#define BR_AUDMUX_PDCR5_TXRXEN(x) (HW_AUDMUX_PDCR5(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR5_TXRXEN. */
#define BF_AUDMUX_PDCR5_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR5_TXRXEN) & BM_AUDMUX_PDCR5_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR5_TXRXEN(x, v) (HW_AUDMUX_PDCR5_WR(x, (HW_AUDMUX_PDCR5_RD(x) & ~BM_AUDMUX_PDCR5_TXRXEN) | BF_AUDMUX_PDCR5_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR5, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR5_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR5_RXDSEL. */
#define BM_AUDMUX_PDCR5_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR5_RXDSEL. */
#define BS_AUDMUX_PDCR5_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR5_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR5_RXDSEL field. */
#define BR_AUDMUX_PDCR5_RXDSEL(x) (HW_AUDMUX_PDCR5(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR5_RXDSEL. */
#define BF_AUDMUX_PDCR5_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR5_RXDSEL) & BM_AUDMUX_PDCR5_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR5_RXDSEL(x, v) (HW_AUDMUX_PDCR5_WR(x, (HW_AUDMUX_PDCR5_RD(x) & ~BM_AUDMUX_PDCR5_RXDSEL) | BF_AUDMUX_PDCR5_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR6 - Port Timing Control Register 6
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR6 - Port Timing Control Register 6 (RW)
 *
 * Reset value: 0x00000800U
 *
 * Port Timing Control Register for Port 6
 */
typedef union _hw_audmux_ptcr6
{
    uint32_t U;
    struct _hw_audmux_ptcr6_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr6_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR6 register
 */
/*@{*/
#define HW_AUDMUX_PTCR6_ADDR(x)  ((uintptr_t)(x) + 0x28U)

#define HW_AUDMUX_PTCR6(x)       (*(__IO hw_audmux_ptcr6_t *) HW_AUDMUX_PTCR6_ADDR(x))
#define HW_AUDMUX_PTCR6_RD(x)    (HW_AUDMUX_PTCR6(x).U)
#define HW_AUDMUX_PTCR6_WR(x, v) (HW_AUDMUX_PTCR6(x).U = (v))
#define HW_AUDMUX_PTCR6_SET(x, v) (HW_AUDMUX_PTCR6_WR(x, HW_AUDMUX_PTCR6_RD(x) |  (v)))
#define HW_AUDMUX_PTCR6_CLR(x, v) (HW_AUDMUX_PTCR6_WR(x, HW_AUDMUX_PTCR6_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR6_TOG(x, v) (HW_AUDMUX_PTCR6_WR(x, HW_AUDMUX_PTCR6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR6 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR6, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR6_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR6_SYN. */
#define BM_AUDMUX_PTCR6_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR6_SYN. */
#define BS_AUDMUX_PTCR6_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR6_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR6_SYN field. */
#define BR_AUDMUX_PTCR6_SYN(x) (HW_AUDMUX_PTCR6(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR6_SYN. */
#define BF_AUDMUX_PTCR6_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_SYN) & BM_AUDMUX_PTCR6_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR6_SYN(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_SYN) | BF_AUDMUX_PTCR6_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR6_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR6_RCSEL. */
#define BM_AUDMUX_PTCR6_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR6_RCSEL. */
#define BS_AUDMUX_PTCR6_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR6_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR6_RCSEL field. */
#define BR_AUDMUX_PTCR6_RCSEL(x) (HW_AUDMUX_PTCR6(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR6_RCSEL. */
#define BF_AUDMUX_PTCR6_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_RCSEL) & BM_AUDMUX_PTCR6_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR6_RCSEL(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_RCSEL) | BF_AUDMUX_PTCR6_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR6_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR6_RCLKDIR. */
#define BM_AUDMUX_PTCR6_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR6_RCLKDIR. */
#define BS_AUDMUX_PTCR6_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR6_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR6_RCLKDIR field. */
#define BR_AUDMUX_PTCR6_RCLKDIR(x) (HW_AUDMUX_PTCR6(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR6_RCLKDIR. */
#define BF_AUDMUX_PTCR6_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_RCLKDIR) & BM_AUDMUX_PTCR6_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR6_RCLKDIR(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_RCLKDIR) | BF_AUDMUX_PTCR6_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR6_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR6_RFSEL. */
#define BM_AUDMUX_PTCR6_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR6_RFSEL. */
#define BS_AUDMUX_PTCR6_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR6_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR6_RFSEL field. */
#define BR_AUDMUX_PTCR6_RFSEL(x) (HW_AUDMUX_PTCR6(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR6_RFSEL. */
#define BF_AUDMUX_PTCR6_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_RFSEL) & BM_AUDMUX_PTCR6_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR6_RFSEL(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_RFSEL) | BF_AUDMUX_PTCR6_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR6_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR6_RFS_DIR. */
#define BM_AUDMUX_PTCR6_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR6_RFS_DIR. */
#define BS_AUDMUX_PTCR6_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR6_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR6_RFS_DIR field. */
#define BR_AUDMUX_PTCR6_RFS_DIR(x) (HW_AUDMUX_PTCR6(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR6_RFS_DIR. */
#define BF_AUDMUX_PTCR6_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_RFS_DIR) & BM_AUDMUX_PTCR6_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR6_RFS_DIR(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_RFS_DIR) | BF_AUDMUX_PTCR6_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR6_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR6_TCSEL. */
#define BM_AUDMUX_PTCR6_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR6_TCSEL. */
#define BS_AUDMUX_PTCR6_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR6_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR6_TCSEL field. */
#define BR_AUDMUX_PTCR6_TCSEL(x) (HW_AUDMUX_PTCR6(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR6_TCSEL. */
#define BF_AUDMUX_PTCR6_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_TCSEL) & BM_AUDMUX_PTCR6_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR6_TCSEL(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_TCSEL) | BF_AUDMUX_PTCR6_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR6_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR6_TCLKDIR. */
#define BM_AUDMUX_PTCR6_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR6_TCLKDIR. */
#define BS_AUDMUX_PTCR6_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR6_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR6_TCLKDIR field. */
#define BR_AUDMUX_PTCR6_TCLKDIR(x) (HW_AUDMUX_PTCR6(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR6_TCLKDIR. */
#define BF_AUDMUX_PTCR6_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_TCLKDIR) & BM_AUDMUX_PTCR6_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR6_TCLKDIR(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_TCLKDIR) | BF_AUDMUX_PTCR6_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR6_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR6_TFSEL. */
#define BM_AUDMUX_PTCR6_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR6_TFSEL. */
#define BS_AUDMUX_PTCR6_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR6_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR6_TFSEL field. */
#define BR_AUDMUX_PTCR6_TFSEL(x) (HW_AUDMUX_PTCR6(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR6_TFSEL. */
#define BF_AUDMUX_PTCR6_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_TFSEL) & BM_AUDMUX_PTCR6_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR6_TFSEL(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_TFSEL) | BF_AUDMUX_PTCR6_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR6, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR6_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR6_TFS_DIR. */
#define BM_AUDMUX_PTCR6_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR6_TFS_DIR. */
#define BS_AUDMUX_PTCR6_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR6_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR6_TFS_DIR field. */
#define BR_AUDMUX_PTCR6_TFS_DIR(x) (HW_AUDMUX_PTCR6(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR6_TFS_DIR. */
#define BF_AUDMUX_PTCR6_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR6_TFS_DIR) & BM_AUDMUX_PTCR6_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR6_TFS_DIR(x, v) (HW_AUDMUX_PTCR6_WR(x, (HW_AUDMUX_PTCR6_RD(x) & ~BM_AUDMUX_PTCR6_TFS_DIR) | BF_AUDMUX_PTCR6_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR6 - Port Data Control Register 6
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR6 - Port Data Control Register 6 (RW)
 *
 * Reset value: 0x00000000U
 *
 * PDCR6 is the Port Data Control Register for Port 6.
 */
typedef union _hw_audmux_pdcr6
{
    uint32_t U;
    struct _hw_audmux_pdcr6_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr6_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR6 register
 */
/*@{*/
#define HW_AUDMUX_PDCR6_ADDR(x)  ((uintptr_t)(x) + 0x2CU)

#define HW_AUDMUX_PDCR6(x)       (*(__IO hw_audmux_pdcr6_t *) HW_AUDMUX_PDCR6_ADDR(x))
#define HW_AUDMUX_PDCR6_RD(x)    (HW_AUDMUX_PDCR6(x).U)
#define HW_AUDMUX_PDCR6_WR(x, v) (HW_AUDMUX_PDCR6(x).U = (v))
#define HW_AUDMUX_PDCR6_SET(x, v) (HW_AUDMUX_PDCR6_WR(x, HW_AUDMUX_PDCR6_RD(x) |  (v)))
#define HW_AUDMUX_PDCR6_CLR(x, v) (HW_AUDMUX_PDCR6_WR(x, HW_AUDMUX_PDCR6_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR6_TOG(x, v) (HW_AUDMUX_PDCR6_WR(x, HW_AUDMUX_PDCR6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR6 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR6, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR6_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR6_INMMASK. */
#define BM_AUDMUX_PDCR6_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR6_INMMASK. */
#define BS_AUDMUX_PDCR6_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR6_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR6_INMMASK field. */
#define BR_AUDMUX_PDCR6_INMMASK(x) (HW_AUDMUX_PDCR6(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR6_INMMASK. */
#define BF_AUDMUX_PDCR6_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR6_INMMASK) & BM_AUDMUX_PDCR6_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR6_INMMASK(x, v) (HW_AUDMUX_PDCR6_WR(x, (HW_AUDMUX_PDCR6_RD(x) & ~BM_AUDMUX_PDCR6_INMMASK) | BF_AUDMUX_PDCR6_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR6, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR6_MODE (8U)          /*!< Bit position for AUDMUX_PDCR6_MODE. */
#define BM_AUDMUX_PDCR6_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR6_MODE. */
#define BS_AUDMUX_PDCR6_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR6_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR6_MODE field. */
#define BR_AUDMUX_PDCR6_MODE(x) (HW_AUDMUX_PDCR6(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR6_MODE. */
#define BF_AUDMUX_PDCR6_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR6_MODE) & BM_AUDMUX_PDCR6_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR6_MODE(x, v) (HW_AUDMUX_PDCR6_WR(x, (HW_AUDMUX_PDCR6_RD(x) & ~BM_AUDMUX_PDCR6_MODE) | BF_AUDMUX_PDCR6_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR6, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR6_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR6_TXRXEN. */
#define BM_AUDMUX_PDCR6_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR6_TXRXEN. */
#define BS_AUDMUX_PDCR6_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR6_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR6_TXRXEN field. */
#define BR_AUDMUX_PDCR6_TXRXEN(x) (HW_AUDMUX_PDCR6(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR6_TXRXEN. */
#define BF_AUDMUX_PDCR6_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR6_TXRXEN) & BM_AUDMUX_PDCR6_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR6_TXRXEN(x, v) (HW_AUDMUX_PDCR6_WR(x, (HW_AUDMUX_PDCR6_RD(x) & ~BM_AUDMUX_PDCR6_TXRXEN) | BF_AUDMUX_PDCR6_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR6, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR6_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR6_RXDSEL. */
#define BM_AUDMUX_PDCR6_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR6_RXDSEL. */
#define BS_AUDMUX_PDCR6_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR6_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR6_RXDSEL field. */
#define BR_AUDMUX_PDCR6_RXDSEL(x) (HW_AUDMUX_PDCR6(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR6_RXDSEL. */
#define BF_AUDMUX_PDCR6_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR6_RXDSEL) & BM_AUDMUX_PDCR6_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR6_RXDSEL(x, v) (HW_AUDMUX_PDCR6_WR(x, (HW_AUDMUX_PDCR6_RD(x) & ~BM_AUDMUX_PDCR6_RXDSEL) | BF_AUDMUX_PDCR6_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PTCR7 - Port Timing Control Register 7
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PTCR7 - Port Timing Control Register 7 (RW)
 *
 * Reset value: 0x00000800U
 *
 * Port Timing Control Register for Port 7
 */
typedef union _hw_audmux_ptcr7
{
    uint32_t U;
    struct _hw_audmux_ptcr7_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t SYN : 1;              /*!< [11]  */
        uint32_t RCSEL : 4;            /*!< [15:12]  */
        uint32_t RCLKDIR : 1;          /*!< [16]  */
        uint32_t RFSEL : 4;            /*!< [20:17]  */
        uint32_t RFS_DIR : 1;          /*!< [21]  */
        uint32_t TCSEL : 4;            /*!< [25:22]  */
        uint32_t TCLKDIR : 1;          /*!< [26]  */
        uint32_t TFSEL : 4;            /*!< [30:27]  */
        uint32_t TFS_DIR : 1;          /*!< [31]  */
    } B;
} hw_audmux_ptcr7_t;

/*!
 * @name Constants and macros for entire AUDMUX_PTCR7 register
 */
/*@{*/
#define HW_AUDMUX_PTCR7_ADDR(x)  ((uintptr_t)(x) + 0x30U)

#define HW_AUDMUX_PTCR7(x)       (*(__IO hw_audmux_ptcr7_t *) HW_AUDMUX_PTCR7_ADDR(x))
#define HW_AUDMUX_PTCR7_RD(x)    (HW_AUDMUX_PTCR7(x).U)
#define HW_AUDMUX_PTCR7_WR(x, v) (HW_AUDMUX_PTCR7(x).U = (v))
#define HW_AUDMUX_PTCR7_SET(x, v) (HW_AUDMUX_PTCR7_WR(x, HW_AUDMUX_PTCR7_RD(x) |  (v)))
#define HW_AUDMUX_PTCR7_CLR(x, v) (HW_AUDMUX_PTCR7_WR(x, HW_AUDMUX_PTCR7_RD(x) & ~(v)))
#define HW_AUDMUX_PTCR7_TOG(x, v) (HW_AUDMUX_PTCR7_WR(x, HW_AUDMUX_PTCR7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PTCR7 bitfields
 */

/*!
 * @name Register AUDMUX_PTCR7, field SYN[11] (RW)
 *
 * Synchronous/Asynchronous Select. When SYN is set, synchronous mode is chosen
 * and the transmit and receive sections use common clock and frame sync signals
 * (that is, the port is a 4-wire interface). When SYN is cleared, asynchronous
 * mode is chosen and separate clock and frame sync signals are used for the
 * transmit and receive sections (that is, the port is a 6-wire interface). RCLKDIR
 * and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - Asynchronous mode
 * - 1 - Synchronous mode (default)
 */
/*@{*/
#define BP_AUDMUX_PTCR7_SYN  (11U)         /*!< Bit position for AUDMUX_PTCR7_SYN. */
#define BM_AUDMUX_PTCR7_SYN  (0x00000800U) /*!< Bit mask for AUDMUX_PTCR7_SYN. */
#define BS_AUDMUX_PTCR7_SYN  (1U)          /*!< Bit field size in bits for AUDMUX_PTCR7_SYN. */

/*! @brief Read current value of the AUDMUX_PTCR7_SYN field. */
#define BR_AUDMUX_PTCR7_SYN(x) (HW_AUDMUX_PTCR7(x).B.SYN)

/*! @brief Format value for bitfield AUDMUX_PTCR7_SYN. */
#define BF_AUDMUX_PTCR7_SYN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_SYN) & BM_AUDMUX_PTCR7_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_AUDMUX_PTCR7_SYN(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_SYN) | BF_AUDMUX_PTCR7_SYN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field RCSEL[15:12] (RW)
 *
 * Receive Clock Select. Selects the source port from which RXC is sourced. RXC
 * can be sourced from TXC and RXC from other ports.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR7_RCSEL (12U)        /*!< Bit position for AUDMUX_PTCR7_RCSEL. */
#define BM_AUDMUX_PTCR7_RCSEL (0x0000F000U) /*!< Bit mask for AUDMUX_PTCR7_RCSEL. */
#define BS_AUDMUX_PTCR7_RCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR7_RCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR7_RCSEL field. */
#define BR_AUDMUX_PTCR7_RCSEL(x) (HW_AUDMUX_PTCR7(x).B.RCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR7_RCSEL. */
#define BF_AUDMUX_PTCR7_RCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_RCSEL) & BM_AUDMUX_PTCR7_RCSEL)

/*! @brief Set the RCSEL field to a new value. */
#define BW_AUDMUX_PTCR7_RCSEL(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_RCSEL) | BF_AUDMUX_PTCR7_RCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field RCLKDIR[16] (RW)
 *
 * Receive Clock Direction Control. This bit sets the direction of the RXC pin
 * of the interface as an output or input. When set as an input, the RCSEL
 * settings are ignored. When set as an output, the RCSEL settings determine the source
 * port of the clock. RCLKDIR and SYN should not be changed at the same time.
 *
 * Values:
 * - 0 - RXC is an input.
 * - 1 - RXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR7_RCLKDIR (16U)      /*!< Bit position for AUDMUX_PTCR7_RCLKDIR. */
#define BM_AUDMUX_PTCR7_RCLKDIR (0x00010000U) /*!< Bit mask for AUDMUX_PTCR7_RCLKDIR. */
#define BS_AUDMUX_PTCR7_RCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR7_RCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR7_RCLKDIR field. */
#define BR_AUDMUX_PTCR7_RCLKDIR(x) (HW_AUDMUX_PTCR7(x).B.RCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR7_RCLKDIR. */
#define BF_AUDMUX_PTCR7_RCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_RCLKDIR) & BM_AUDMUX_PTCR7_RCLKDIR)

/*! @brief Set the RCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR7_RCLKDIR(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_RCLKDIR) | BF_AUDMUX_PTCR7_RCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field RFSEL[20:17] (RW)
 *
 * Receive Frame Sync Select. Selects the source port from which RXFS is
 * sourced. RXFS can be sourced from TXFS and RXFS from other ports.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR7_RFSEL (17U)        /*!< Bit position for AUDMUX_PTCR7_RFSEL. */
#define BM_AUDMUX_PTCR7_RFSEL (0x001E0000U) /*!< Bit mask for AUDMUX_PTCR7_RFSEL. */
#define BS_AUDMUX_PTCR7_RFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR7_RFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR7_RFSEL field. */
#define BR_AUDMUX_PTCR7_RFSEL(x) (HW_AUDMUX_PTCR7(x).B.RFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR7_RFSEL. */
#define BF_AUDMUX_PTCR7_RFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_RFSEL) & BM_AUDMUX_PTCR7_RFSEL)

/*! @brief Set the RFSEL field to a new value. */
#define BW_AUDMUX_PTCR7_RFSEL(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_RFSEL) | BF_AUDMUX_PTCR7_RFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field RFS_DIR[21] (RW)
 *
 * Receive Frame Sync Direction Control. This bit sets the direction of the RXFS
 * pin of the interface as an output or input. When set as an input, the RFSEL
 * settings are ignored. When set as an output, the RFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - RXFS is an input.
 * - 1 - RXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR7_RFS_DIR (21U)      /*!< Bit position for AUDMUX_PTCR7_RFS_DIR. */
#define BM_AUDMUX_PTCR7_RFS_DIR (0x00200000U) /*!< Bit mask for AUDMUX_PTCR7_RFS_DIR. */
#define BS_AUDMUX_PTCR7_RFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR7_RFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR7_RFS_DIR field. */
#define BR_AUDMUX_PTCR7_RFS_DIR(x) (HW_AUDMUX_PTCR7(x).B.RFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR7_RFS_DIR. */
#define BF_AUDMUX_PTCR7_RFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_RFS_DIR) & BM_AUDMUX_PTCR7_RFS_DIR)

/*! @brief Set the RFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR7_RFS_DIR(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_RFS_DIR) | BF_AUDMUX_PTCR7_RFS_DIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field TCSEL[25:22] (RW)
 *
 * Transmit Clock Select. Selects the source port from which TXC is sourced.
 *
 * Values:
 * - 1xxx - Selects RXC from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR7_TCSEL (22U)        /*!< Bit position for AUDMUX_PTCR7_TCSEL. */
#define BM_AUDMUX_PTCR7_TCSEL (0x03C00000U) /*!< Bit mask for AUDMUX_PTCR7_TCSEL. */
#define BS_AUDMUX_PTCR7_TCSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR7_TCSEL. */

/*! @brief Read current value of the AUDMUX_PTCR7_TCSEL field. */
#define BR_AUDMUX_PTCR7_TCSEL(x) (HW_AUDMUX_PTCR7(x).B.TCSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR7_TCSEL. */
#define BF_AUDMUX_PTCR7_TCSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_TCSEL) & BM_AUDMUX_PTCR7_TCSEL)

/*! @brief Set the TCSEL field to a new value. */
#define BW_AUDMUX_PTCR7_TCSEL(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_TCSEL) | BF_AUDMUX_PTCR7_TCSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field TCLKDIR[26] (RW)
 *
 * Transmit Clock Direction Control. This bit sets the direction of the TXC pin
 * of the interface as an output or input. When set as an input, the TCSEL
 * settings are ignored. When set as an output, the TCSEL settings determine the source
 * port of the clock.
 *
 * Values:
 * - 0 - TXC is an input.
 * - 1 - TXC is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR7_TCLKDIR (26U)      /*!< Bit position for AUDMUX_PTCR7_TCLKDIR. */
#define BM_AUDMUX_PTCR7_TCLKDIR (0x04000000U) /*!< Bit mask for AUDMUX_PTCR7_TCLKDIR. */
#define BS_AUDMUX_PTCR7_TCLKDIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR7_TCLKDIR. */

/*! @brief Read current value of the AUDMUX_PTCR7_TCLKDIR field. */
#define BR_AUDMUX_PTCR7_TCLKDIR(x) (HW_AUDMUX_PTCR7(x).B.TCLKDIR)

/*! @brief Format value for bitfield AUDMUX_PTCR7_TCLKDIR. */
#define BF_AUDMUX_PTCR7_TCLKDIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_TCLKDIR) & BM_AUDMUX_PTCR7_TCLKDIR)

/*! @brief Set the TCLKDIR field to a new value. */
#define BW_AUDMUX_PTCR7_TCLKDIR(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_TCLKDIR) | BF_AUDMUX_PTCR7_TCLKDIR(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field TFSEL[30:27] (RW)
 *
 * Transmit Frame Sync Select. Selects the source port from which TXFS is
 * sourced.
 *
 * Values:
 * - 1xxx - Selects RXFS from port.
 * - x000 - Port 1
 * - x110 - Port 7
 * - x111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PTCR7_TFSEL (27U)        /*!< Bit position for AUDMUX_PTCR7_TFSEL. */
#define BM_AUDMUX_PTCR7_TFSEL (0x78000000U) /*!< Bit mask for AUDMUX_PTCR7_TFSEL. */
#define BS_AUDMUX_PTCR7_TFSEL (4U)         /*!< Bit field size in bits for AUDMUX_PTCR7_TFSEL. */

/*! @brief Read current value of the AUDMUX_PTCR7_TFSEL field. */
#define BR_AUDMUX_PTCR7_TFSEL(x) (HW_AUDMUX_PTCR7(x).B.TFSEL)

/*! @brief Format value for bitfield AUDMUX_PTCR7_TFSEL. */
#define BF_AUDMUX_PTCR7_TFSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_TFSEL) & BM_AUDMUX_PTCR7_TFSEL)

/*! @brief Set the TFSEL field to a new value. */
#define BW_AUDMUX_PTCR7_TFSEL(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_TFSEL) | BF_AUDMUX_PTCR7_TFSEL(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PTCR7, field TFS_DIR[31] (RW)
 *
 * Transmit Frame Sync Direction Control. This bit sets the direction of the
 * TXFS pin of the interface as an output or input. When set as an input, the TFSEL
 * settings are ignored. When set as an output, the TFSEL settings determine the
 * source port of the frame sync.
 *
 * Values:
 * - 0 - TXFS is an input.
 * - 1 - TXFS is an output.
 */
/*@{*/
#define BP_AUDMUX_PTCR7_TFS_DIR (31U)      /*!< Bit position for AUDMUX_PTCR7_TFS_DIR. */
#define BM_AUDMUX_PTCR7_TFS_DIR (0x80000000U) /*!< Bit mask for AUDMUX_PTCR7_TFS_DIR. */
#define BS_AUDMUX_PTCR7_TFS_DIR (1U)       /*!< Bit field size in bits for AUDMUX_PTCR7_TFS_DIR. */

/*! @brief Read current value of the AUDMUX_PTCR7_TFS_DIR field. */
#define BR_AUDMUX_PTCR7_TFS_DIR(x) (HW_AUDMUX_PTCR7(x).B.TFS_DIR)

/*! @brief Format value for bitfield AUDMUX_PTCR7_TFS_DIR. */
#define BF_AUDMUX_PTCR7_TFS_DIR(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PTCR7_TFS_DIR) & BM_AUDMUX_PTCR7_TFS_DIR)

/*! @brief Set the TFS_DIR field to a new value. */
#define BW_AUDMUX_PTCR7_TFS_DIR(x, v) (HW_AUDMUX_PTCR7_WR(x, (HW_AUDMUX_PTCR7_RD(x) & ~BM_AUDMUX_PTCR7_TFS_DIR) | BF_AUDMUX_PTCR7_TFS_DIR(v)))
/*@}*/

/*******************************************************************************
 * HW_AUDMUX_PDCR7 - Port Data Control Register 7
 ******************************************************************************/

/*!
 * @brief HW_AUDMUX_PDCR7 - Port Data Control Register 7 (RW)
 *
 * Reset value: 0x0000C000U
 *
 * PDCR7 is the Port Data Control Register for Port 7.
 */
typedef union _hw_audmux_pdcr7
{
    uint32_t U;
    struct _hw_audmux_pdcr7_bitfields
    {
        uint32_t INMMASK : 8;          /*!< [7:0]  */
        uint32_t MODE : 1;             /*!< [8]  */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t TXRXEN : 1;           /*!< [12]  */
        uint32_t RXDSEL : 3;           /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_audmux_pdcr7_t;

/*!
 * @name Constants and macros for entire AUDMUX_PDCR7 register
 */
/*@{*/
#define HW_AUDMUX_PDCR7_ADDR(x)  ((uintptr_t)(x) + 0x34U)

#define HW_AUDMUX_PDCR7(x)       (*(__IO hw_audmux_pdcr7_t *) HW_AUDMUX_PDCR7_ADDR(x))
#define HW_AUDMUX_PDCR7_RD(x)    (HW_AUDMUX_PDCR7(x).U)
#define HW_AUDMUX_PDCR7_WR(x, v) (HW_AUDMUX_PDCR7(x).U = (v))
#define HW_AUDMUX_PDCR7_SET(x, v) (HW_AUDMUX_PDCR7_WR(x, HW_AUDMUX_PDCR7_RD(x) |  (v)))
#define HW_AUDMUX_PDCR7_CLR(x, v) (HW_AUDMUX_PDCR7_WR(x, HW_AUDMUX_PDCR7_RD(x) & ~(v)))
#define HW_AUDMUX_PDCR7_TOG(x, v) (HW_AUDMUX_PDCR7_WR(x, HW_AUDMUX_PDCR7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual AUDMUX_PDCR7 bitfields
 */

/*!
 * @name Register AUDMUX_PDCR7, field INMMASK[7:0] (RW)
 *
 * Internal Network Mode Mask. Bit mask that selects the ports from which the
 * RXD signals are to be ANDed together for internal network mode. Bit 6 represents
 * RXD from Port 7 and bit0 represents RXD from Port 1.
 *
 * Values:
 * - 0 - Includes RXDn for ANDing
 * - 1 - Excludes RXDn from ANDing
 */
/*@{*/
#define BP_AUDMUX_PDCR7_INMMASK (0U)       /*!< Bit position for AUDMUX_PDCR7_INMMASK. */
#define BM_AUDMUX_PDCR7_INMMASK (0x000000FFU) /*!< Bit mask for AUDMUX_PDCR7_INMMASK. */
#define BS_AUDMUX_PDCR7_INMMASK (8U)       /*!< Bit field size in bits for AUDMUX_PDCR7_INMMASK. */

/*! @brief Read current value of the AUDMUX_PDCR7_INMMASK field. */
#define BR_AUDMUX_PDCR7_INMMASK(x) (HW_AUDMUX_PDCR7(x).B.INMMASK)

/*! @brief Format value for bitfield AUDMUX_PDCR7_INMMASK. */
#define BF_AUDMUX_PDCR7_INMMASK(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR7_INMMASK) & BM_AUDMUX_PDCR7_INMMASK)

/*! @brief Set the INMMASK field to a new value. */
#define BW_AUDMUX_PDCR7_INMMASK(x, v) (HW_AUDMUX_PDCR7_WR(x, (HW_AUDMUX_PDCR7_RD(x) & ~BM_AUDMUX_PDCR7_INMMASK) | BF_AUDMUX_PDCR7_INMMASK(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR7, field MODE[8] (RW)
 *
 * Mode Select. This field selects the mode in which the port is to operate. The
 * modes of operation include the following: Normal mode, in which the RXD from
 * the port selected by RXDSEL is routed to the port. Internal Network mode in
 * which RXD from other ports are ANDed together. RXDSEL is ignored. INMMASK
 * determines which RXD signals are ANDed together.
 *
 * Values:
 * - 0 - Normal mode
 * - 1 - Internal Network mode
 */
/*@{*/
#define BP_AUDMUX_PDCR7_MODE (8U)          /*!< Bit position for AUDMUX_PDCR7_MODE. */
#define BM_AUDMUX_PDCR7_MODE (0x00000100U) /*!< Bit mask for AUDMUX_PDCR7_MODE. */
#define BS_AUDMUX_PDCR7_MODE (1U)          /*!< Bit field size in bits for AUDMUX_PDCR7_MODE. */

/*! @brief Read current value of the AUDMUX_PDCR7_MODE field. */
#define BR_AUDMUX_PDCR7_MODE(x) (HW_AUDMUX_PDCR7(x).B.MODE)

/*! @brief Format value for bitfield AUDMUX_PDCR7_MODE. */
#define BF_AUDMUX_PDCR7_MODE(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR7_MODE) & BM_AUDMUX_PDCR7_MODE)

/*! @brief Set the MODE field to a new value. */
#define BW_AUDMUX_PDCR7_MODE(x, v) (HW_AUDMUX_PDCR7_WR(x, (HW_AUDMUX_PDCR7_RD(x) & ~BM_AUDMUX_PDCR7_MODE) | BF_AUDMUX_PDCR7_MODE(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR7, field TXRXEN[12] (RW)
 *
 * Transmit/Receive Switch Enable. Swaps the transmit and receive signals.
 *
 * Values:
 * - 0 - No switch (Transmit Pin = Transmit, Receive Pin = Receive)
 * - 1 - Switch (Transmit Pin = Receive, Receive Pin = Transmit)
 */
/*@{*/
#define BP_AUDMUX_PDCR7_TXRXEN (12U)       /*!< Bit position for AUDMUX_PDCR7_TXRXEN. */
#define BM_AUDMUX_PDCR7_TXRXEN (0x00001000U) /*!< Bit mask for AUDMUX_PDCR7_TXRXEN. */
#define BS_AUDMUX_PDCR7_TXRXEN (1U)        /*!< Bit field size in bits for AUDMUX_PDCR7_TXRXEN. */

/*! @brief Read current value of the AUDMUX_PDCR7_TXRXEN field. */
#define BR_AUDMUX_PDCR7_TXRXEN(x) (HW_AUDMUX_PDCR7(x).B.TXRXEN)

/*! @brief Format value for bitfield AUDMUX_PDCR7_TXRXEN. */
#define BF_AUDMUX_PDCR7_TXRXEN(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR7_TXRXEN) & BM_AUDMUX_PDCR7_TXRXEN)

/*! @brief Set the TXRXEN field to a new value. */
#define BW_AUDMUX_PDCR7_TXRXEN(x, v) (HW_AUDMUX_PDCR7_WR(x, (HW_AUDMUX_PDCR7_RD(x) & ~BM_AUDMUX_PDCR7_TXRXEN) | BF_AUDMUX_PDCR7_TXRXEN(v)))
/*@}*/

/*!
 * @name Register AUDMUX_PDCR7, field RXDSEL[15:13] (RW)
 *
 * Receive Data Select. Selects the source port for the RXD data. RXDSEL is
 * ignored if MODE = 1 (that is, Internal Network Mode is enabled).
 *
 * Values:
 * - xxx - Port number for RXD
 * - 000 - Port 1
 * - 110 - Port 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_AUDMUX_PDCR7_RXDSEL (13U)       /*!< Bit position for AUDMUX_PDCR7_RXDSEL. */
#define BM_AUDMUX_PDCR7_RXDSEL (0x0000E000U) /*!< Bit mask for AUDMUX_PDCR7_RXDSEL. */
#define BS_AUDMUX_PDCR7_RXDSEL (3U)        /*!< Bit field size in bits for AUDMUX_PDCR7_RXDSEL. */

/*! @brief Read current value of the AUDMUX_PDCR7_RXDSEL field. */
#define BR_AUDMUX_PDCR7_RXDSEL(x) (HW_AUDMUX_PDCR7(x).B.RXDSEL)

/*! @brief Format value for bitfield AUDMUX_PDCR7_RXDSEL. */
#define BF_AUDMUX_PDCR7_RXDSEL(v) ((uint32_t)((uint32_t)(v) << BP_AUDMUX_PDCR7_RXDSEL) & BM_AUDMUX_PDCR7_RXDSEL)

/*! @brief Set the RXDSEL field to a new value. */
#define BW_AUDMUX_PDCR7_RXDSEL(x, v) (HW_AUDMUX_PDCR7_WR(x, (HW_AUDMUX_PDCR7_RD(x) & ~BM_AUDMUX_PDCR7_RXDSEL) | BF_AUDMUX_PDCR7_RXDSEL(v)))
/*@}*/

/*******************************************************************************
 * hw_audmux_t - module struct
 ******************************************************************************/
/*!
 * @brief All AUDMUX module registers.
 */
#pragma pack(1)
typedef struct _hw_audmux
{
    __IO hw_audmux_ptcr1_t PTCR1;          /*!< [0x0] Port Timing Control Register 1 */
    __IO hw_audmux_pdcr1_t PDCR1;          /*!< [0x4] Port Data Control Register 1 */
    __IO hw_audmux_ptcr2_t PTCR2;          /*!< [0x8] Port Timing Control Register 2 */
    __IO hw_audmux_pdcr2_t PDCR2;          /*!< [0xC] Port Data Control Register 2 */
    __IO hw_audmux_ptcr3_t PTCR3;          /*!< [0x10] Port Timing Control Register 3 */
    __IO hw_audmux_pdcr3_t PDCR3;          /*!< [0x14] Port Data Control Register 3 */
    __IO hw_audmux_ptcr4_t PTCR4;          /*!< [0x18] Port Timing Control Register 4 */
    __IO hw_audmux_pdcr4_t PDCR4;          /*!< [0x1C] Port Data Control Register 4 */
    __IO hw_audmux_ptcr5_t PTCR5;          /*!< [0x20] Port Timing Control Register 5 */
    __IO hw_audmux_pdcr5_t PDCR5;          /*!< [0x24] Port Data Control Register 5 */
    __IO hw_audmux_ptcr6_t PTCR6;          /*!< [0x28] Port Timing Control Register 6 */
    __IO hw_audmux_pdcr6_t PDCR6;          /*!< [0x2C] Port Data Control Register 6 */
    __IO hw_audmux_ptcr7_t PTCR7;          /*!< [0x30] Port Timing Control Register 7 */
    __IO hw_audmux_pdcr7_t PDCR7;          /*!< [0x34] Port Data Control Register 7 */
} hw_audmux_t;
#pragma pack()

/*! @brief Macro to access all AUDMUX registers. */
/*! @param x AUDMUX module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_AUDMUX_REGS(AUDMUX_BASE)</code>. */
#define HW_AUDMUX_REGS(x) (*(hw_audmux_t *)(x))

/*
 * iMX6DP CAN
 *
 * FLEXCAN
 *
 * Registers defined in this header file:
 * - HW_CAN_MCR - Module Configuration Register
 * - HW_CAN_CTRL1 - Control 1 Register
 * - HW_CAN_TIMER - Free Running Timer Register
 * - HW_CAN_RXMGMASK - Rx Mailboxes Global Mask Register
 * - HW_CAN_RX14MASK - Rx Buffer 14 Mask Register
 * - HW_CAN_RX15MASK - Rx Buffer 15 Mask Register
 * - HW_CAN_ECR - Error Counter Register
 * - HW_CAN_ESR1 - Error and Status 1 Register
 * - HW_CAN_IMASK2 - Interrupt Masks 2 Register
 * - HW_CAN_IMASK1 - Interrupt Masks 1 Register
 * - HW_CAN_IFLAG2 - Interrupt Flags 2 Register
 * - HW_CAN_IFLAG1 - Interrupt Flags 1 Register
 * - HW_CAN_CTRL2 - Control 2 Register
 * - HW_CAN_ESR2 - Error and Status 2 Register
 * - HW_CAN_CRCR - CRC Register
 * - HW_CAN_RXFGMASK - Rx FIFO Global Mask Register
 * - HW_CAN_RXFIR - Rx FIFO Information Register
 * - HW_CAN_CSn - Message Buffer 0 CS Register
 * - HW_CAN_IDn - Message Buffer 0 ID Register
 * - HW_CAN_WORD0n - Message Buffer 0 WORD0 Register
 * - HW_CAN_WORD1n - Message Buffer 0 WORD1 Register
 * - HW_CAN_RXIMRn - RXIMR
 * - HW_CAN_GFWR - Glitch Filter Width Registers
 *
 * - hw_can_t - Struct containing all module registers.
 */

#define HW_CAN_INSTANCE_COUNT (2U) /*!< Number of instances of the CAN module. */
#define HW_CAN1 (0U) /*!< Instance number for CAN1. */
#define HW_CAN2 (1U) /*!< Instance number for CAN2. */
#define CAN1_BASE             (0x2090000U) /*!< Base address for CAN1. */
#define CAN2_BASE             (0x2094000U) /*!< Base address for CAN2. */
/*! Array initializer of CAN base addresses. */
#define CAN_BASE_ADDRS        { CAN1_BASE, CAN2_BASE }

/*******************************************************************************
 * HW_CAN_MCR - Module Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_MCR - Module Configuration Register (RW)
 *
 * Reset value: 0x5980000FU
 *
 * This register defines global system configurations, such as the module
 * operation mode (e.g., low power) and maximum message buffer configuration.
 */
typedef union _hw_can_mcr
{
    uint32_t U;
    struct _hw_can_mcr_bitfields
    {
        uint32_t MAXMB : 7;            /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t IDAM : 2;             /*!< [9:8]  */
        uint32_t RESERVED1 : 2;        /*!< [11:10]  */
        uint32_t AEN : 1;              /*!< [12]  */
        uint32_t LPRIO_EN : 1;         /*!< [13]  */
        uint32_t RESERVED2 : 2;        /*!< [15:14]  */
        uint32_t IRMQ : 1;             /*!< [16]  */
        uint32_t SRX_DIS : 1;          /*!< [17]  */
        uint32_t RESERVED3 : 1;        /*!< [18]  */
        uint32_t WAK_SRC : 1;          /*!< [19]  */
        uint32_t LPM_ACK : 1;          /*!< [20]  */
        uint32_t WRN_EN : 1;           /*!< [21]  */
        uint32_t SLF_WAK : 1;          /*!< [22]  */
        uint32_t SUPV : 1;             /*!< [23]  */
        uint32_t FRZ_ACK : 1;          /*!< [24]  */
        uint32_t SOFT_RST : 1;         /*!< [25]  */
        uint32_t WAK_MSK : 1;          /*!< [26]  */
        uint32_t NOT_RDY : 1;          /*!< [27]  */
        uint32_t HALT : 1;             /*!< [28]  */
        uint32_t RFEN : 1;             /*!< [29]  */
        uint32_t FRZ : 1;              /*!< [30]  */
        uint32_t MDIS : 1;             /*!< [31]  */
    } B;
} hw_can_mcr_t;

/*!
 * @name Constants and macros for entire CAN_MCR register
 */
/*@{*/
#define HW_CAN_MCR_ADDR(x)       ((uintptr_t)(x) + 0x0U)

#define HW_CAN_MCR(x)            (*(__IO hw_can_mcr_t *) HW_CAN_MCR_ADDR(x))
#define HW_CAN_MCR_RD(x)         (HW_CAN_MCR(x).U)
#define HW_CAN_MCR_WR(x, v)      (HW_CAN_MCR(x).U = (v))
#define HW_CAN_MCR_SET(x, v)     (HW_CAN_MCR_WR(x, HW_CAN_MCR_RD(x) |  (v)))
#define HW_CAN_MCR_CLR(x, v)     (HW_CAN_MCR_WR(x, HW_CAN_MCR_RD(x) & ~(v)))
#define HW_CAN_MCR_TOG(x, v)     (HW_CAN_MCR_WR(x, HW_CAN_MCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_MCR bitfields
 */

/*!
 * @name Register CAN_MCR, field MAXMB[6:0] (RW)
 *
 * This 7-bit field defines the number of the last Message Buffers that will
 * take part in the matching and arbitration processes. The reset value (0x0F) is
 * equivalent to 16 MB configuration. This field can only be written in Freeze Mode
 * as it is blocked by hardware in other modes Number of the last MB = MAXMB.
 * Additionally, the value of MAXMB must encompass the FIFO size defined by
 * CTRL2[RFFN] MAXMB also impacts the definition of the minimum number of peripheral
 * clocks per CAN bit as described in (see Arbitration and Matching Timing).
 */
/*@{*/
#define BP_CAN_MCR_MAXMB     (0U)          /*!< Bit position for CAN_MCR_MAXMB. */
#define BM_CAN_MCR_MAXMB     (0x0000007FU) /*!< Bit mask for CAN_MCR_MAXMB. */
#define BS_CAN_MCR_MAXMB     (7U)          /*!< Bit field size in bits for CAN_MCR_MAXMB. */

/*! @brief Read current value of the CAN_MCR_MAXMB field. */
#define BR_CAN_MCR_MAXMB(x)  (HW_CAN_MCR(x).B.MAXMB)

/*! @brief Format value for bitfield CAN_MCR_MAXMB. */
#define BF_CAN_MCR_MAXMB(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_MAXMB) & BM_CAN_MCR_MAXMB)

/*! @brief Set the MAXMB field to a new value. */
#define BW_CAN_MCR_MAXMB(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_MAXMB) | BF_CAN_MCR_MAXMB(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field IDAM[9:8] (RW)
 *
 * This 2-bit field identifies the format of the elements of the Rx FIFO filter
 * table, as shown below. Note that all elements of the table are configured at
 * the same time by this field (they are all the same format). See Rx FIFO
 * StructureWhen the MCR[RFEN] bit is set, the memory area from $80 to $DC (which is
 * normally occupied by MBs 0 to 5) is used by the reception FIFO engine. . This bit
 * can only be written in Freeze mode as it is blocked by hardware in other
 * modes.
 *
 * Values:
 * - 00 - Format A One full ID (standard or extended) per ID filter Table
 *     element.
 * - 01 - Format B Two full standard IDs or two partial 14-bit extended IDs per
 *     ID filter Table element.
 * - 10 - Format C Four partial 8-bit IDs (standard or extended) per ID filter
 *     Table element.
 * - 11 - Format D All frames rejected.
 */
/*@{*/
#define BP_CAN_MCR_IDAM      (8U)          /*!< Bit position for CAN_MCR_IDAM. */
#define BM_CAN_MCR_IDAM      (0x00000300U) /*!< Bit mask for CAN_MCR_IDAM. */
#define BS_CAN_MCR_IDAM      (2U)          /*!< Bit field size in bits for CAN_MCR_IDAM. */

/*! @brief Read current value of the CAN_MCR_IDAM field. */
#define BR_CAN_MCR_IDAM(x)   (HW_CAN_MCR(x).B.IDAM)

/*! @brief Format value for bitfield CAN_MCR_IDAM. */
#define BF_CAN_MCR_IDAM(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_IDAM) & BM_CAN_MCR_IDAM)

/*! @brief Set the IDAM field to a new value. */
#define BW_CAN_MCR_IDAM(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_IDAM) | BF_CAN_MCR_IDAM(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field AEN[12] (RW)
 *
 * This bit is supplied for backwards compatibility reasons. When asserted, it
 * enables the Tx abort feature. This feature guarantees a safe procedure for
 * aborting a pending transmission, so that no frame is sent in the CAN bus without
 * notification. This bit can only be written in Freeze mode as it is blocked by
 * hardware in other modes.Write Abort code into Rx Mailboxes can cause
 * unpredictable results when the MCR[AEN] is asserted.
 *
 * Values:
 * - 1 - Abort enabled
 * - 0 - Abort disabled
 */
/*@{*/
#define BP_CAN_MCR_AEN       (12U)         /*!< Bit position for CAN_MCR_AEN. */
#define BM_CAN_MCR_AEN       (0x00001000U) /*!< Bit mask for CAN_MCR_AEN. */
#define BS_CAN_MCR_AEN       (1U)          /*!< Bit field size in bits for CAN_MCR_AEN. */

/*! @brief Read current value of the CAN_MCR_AEN field. */
#define BR_CAN_MCR_AEN(x)    (HW_CAN_MCR(x).B.AEN)

/*! @brief Format value for bitfield CAN_MCR_AEN. */
#define BF_CAN_MCR_AEN(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_AEN) & BM_CAN_MCR_AEN)

/*! @brief Set the AEN field to a new value. */
#define BW_CAN_MCR_AEN(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_AEN) | BF_CAN_MCR_AEN(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field LPRIO_EN[13] (RW)
 *
 * This bit is provided for backwards compatibility reasons. It controls whether
 * the local priority feature is enabled or not. It is used to extend the ID
 * used during the arbitration process. With this extended ID concept, the
 * arbitration process is done based on the full 32-bit word, but the actual transmitted
 * ID still has 11-bit for standard frames and 29-bit for extended frames.This bit
 * can only be written in Freeze mode as it is blocked by hardware in other
 * modes.
 *
 * Values:
 * - 1 - Local Priority enabled
 * - 0 - Local Priority disabled
 */
/*@{*/
#define BP_CAN_MCR_LPRIO_EN  (13U)         /*!< Bit position for CAN_MCR_LPRIO_EN. */
#define BM_CAN_MCR_LPRIO_EN  (0x00002000U) /*!< Bit mask for CAN_MCR_LPRIO_EN. */
#define BS_CAN_MCR_LPRIO_EN  (1U)          /*!< Bit field size in bits for CAN_MCR_LPRIO_EN. */

/*! @brief Read current value of the CAN_MCR_LPRIO_EN field. */
#define BR_CAN_MCR_LPRIO_EN(x) (HW_CAN_MCR(x).B.LPRIO_EN)

/*! @brief Format value for bitfield CAN_MCR_LPRIO_EN. */
#define BF_CAN_MCR_LPRIO_EN(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_LPRIO_EN) & BM_CAN_MCR_LPRIO_EN)

/*! @brief Set the LPRIO_EN field to a new value. */
#define BW_CAN_MCR_LPRIO_EN(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_LPRIO_EN) | BF_CAN_MCR_LPRIO_EN(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field IRMQ[16] (RW)
 *
 * This bit indicates whether Rx matching process will be based either on
 * individual masking and queue or on masking scheme with RXMGMASK, RX14MASK and
 * RX15MASK, RXFGMASK. This bit can only be written in Freeze mode as it is blocked by
 * hardware in other modes.
 *
 * Values:
 * - 1 - Individual Rx masking and queue feature are enabled.
 * - 0 - Individual Rx masking and queue feature are disabled.For backward
 *     compatibility, the reading of C/S word locks the MB even if it is EMPTY.
 */
/*@{*/
#define BP_CAN_MCR_IRMQ      (16U)         /*!< Bit position for CAN_MCR_IRMQ. */
#define BM_CAN_MCR_IRMQ      (0x00010000U) /*!< Bit mask for CAN_MCR_IRMQ. */
#define BS_CAN_MCR_IRMQ      (1U)          /*!< Bit field size in bits for CAN_MCR_IRMQ. */

/*! @brief Read current value of the CAN_MCR_IRMQ field. */
#define BR_CAN_MCR_IRMQ(x)   (HW_CAN_MCR(x).B.IRMQ)

/*! @brief Format value for bitfield CAN_MCR_IRMQ. */
#define BF_CAN_MCR_IRMQ(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_IRMQ) & BM_CAN_MCR_IRMQ)

/*! @brief Set the IRMQ field to a new value. */
#define BW_CAN_MCR_IRMQ(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_IRMQ) | BF_CAN_MCR_IRMQ(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field SRX_DIS[17] (RW)
 *
 * This bit defines whether FlexCAN is allowed to receive frames transmitted by
 * itself. If this bit is asserted, frames transmitted by the module will not be
 * stored in any MB, regardless if the MB is programmed with an ID that matches
 * the transmitted frame, and no interrupt flag or interrupt signal will be
 * generated due to the frame reception. This bit can only be written in Freeze mode as
 * it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Self reception disabled
 * - 0 - Self reception enabled
 */
/*@{*/
#define BP_CAN_MCR_SRX_DIS   (17U)         /*!< Bit position for CAN_MCR_SRX_DIS. */
#define BM_CAN_MCR_SRX_DIS   (0x00020000U) /*!< Bit mask for CAN_MCR_SRX_DIS. */
#define BS_CAN_MCR_SRX_DIS   (1U)          /*!< Bit field size in bits for CAN_MCR_SRX_DIS. */

/*! @brief Read current value of the CAN_MCR_SRX_DIS field. */
#define BR_CAN_MCR_SRX_DIS(x) (HW_CAN_MCR(x).B.SRX_DIS)

/*! @brief Format value for bitfield CAN_MCR_SRX_DIS. */
#define BF_CAN_MCR_SRX_DIS(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_SRX_DIS) & BM_CAN_MCR_SRX_DIS)

/*! @brief Set the SRX_DIS field to a new value. */
#define BW_CAN_MCR_SRX_DIS(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_SRX_DIS) | BF_CAN_MCR_SRX_DIS(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field WAK_SRC[19] (RW)
 *
 * This bit defines whether the integrated low-pass filter is applied to protect
 * the FLEXCAN_RX input from spurious wake up. See Stop ModeThis is a system low
 * power mode in which system clocks can be stopped for maximum power savings..
 * To enter stop mode, the CPU should manually assert a global Stop Mode request
 * (see the CAN1_STOP_REQ and CAN2_STOP_REQ bit in the register IOMUXC_GPR4)and
 * check the acknowledgement asserted by the FlexCAN (see the CAN1_STOP_ACK and
 * CAN2_STOP_ACK in the register IOMUXC_GPR4) . The CPU must only consider the
 * FlexCAN in Stop Mode when both request and acknowledgement conditions are
 * satisfied. for more information. This bit can only be written in Freeze mode as it is
 * blocked by hardware in other modes.
 *
 * Values:
 * - 1 - FLEXCAN uses the filtered FLEXCAN_RX input to detect recessive to
 *     dominant edges on the CAN bus
 * - 0 - FLEXCAN uses the unfiltered FLEXCAN_RX input to detect recessive to
 *     dominant edges on the CAN bus.
 */
/*@{*/
#define BP_CAN_MCR_WAK_SRC   (19U)         /*!< Bit position for CAN_MCR_WAK_SRC. */
#define BM_CAN_MCR_WAK_SRC   (0x00080000U) /*!< Bit mask for CAN_MCR_WAK_SRC. */
#define BS_CAN_MCR_WAK_SRC   (1U)          /*!< Bit field size in bits for CAN_MCR_WAK_SRC. */

/*! @brief Read current value of the CAN_MCR_WAK_SRC field. */
#define BR_CAN_MCR_WAK_SRC(x) (HW_CAN_MCR(x).B.WAK_SRC)

/*! @brief Format value for bitfield CAN_MCR_WAK_SRC. */
#define BF_CAN_MCR_WAK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_WAK_SRC) & BM_CAN_MCR_WAK_SRC)

/*! @brief Set the WAK_SRC field to a new value. */
#define BW_CAN_MCR_WAK_SRC(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_WAK_SRC) | BF_CAN_MCR_WAK_SRC(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field LPM_ACK[20] (RO)
 *
 * This read-only bit indicates that FLEXCAN is either in Disable Mode or Stop
 * Mode. Either of these low power modes can not be entered until all current
 * transmission or reception processes have finished, so the ARM can poll the LPM_ACK
 * bit to know when FLEXCAN has actually entered low power mode. See Module
 * Disable ModeThis low power mode is normally used to temporarily disable a complete
 * FlexCAN block, with no power consumption. It is requested by the ARM through
 * the assertion of the MDIS bit in the MCR Register and the acknowledgement is
 * obtained through the assertion by the FlexCAN of the LPM_ACK bit in the same
 * register. The ARM must only consider the FlexCAN in Disable Mode when both
 * request and acknowledgement conditions are satisfied. , and Stop ModeThis is a
 * system low power mode in which system clocks can be stopped for maximum power
 * savings.. To enter stop mode, the CPU should manually assert a global Stop Mode
 * request (see the CAN1_STOP_REQ and CAN2_STOP_REQ bit in the register
 * IOMUXC_GPR4)and check the acknowledgement asserted by the FlexCAN (see the CAN1_STOP_ACK
 * and CAN2_STOP_ACK in the register IOMUXC_GPR4) . The CPU must only consider
 * the FlexCAN in Stop Mode when both request and acknowledgement conditions are
 * satisfied. for more information
 *
 * Values:
 * - 1 - FLEXCAN is either in Disable Mode, or Stop mode
 * - 0 - FLEXCAN not in any of the low power modes
 */
/*@{*/
#define BP_CAN_MCR_LPM_ACK   (20U)         /*!< Bit position for CAN_MCR_LPM_ACK. */
#define BM_CAN_MCR_LPM_ACK   (0x00100000U) /*!< Bit mask for CAN_MCR_LPM_ACK. */
#define BS_CAN_MCR_LPM_ACK   (1U)          /*!< Bit field size in bits for CAN_MCR_LPM_ACK. */

/*! @brief Read current value of the CAN_MCR_LPM_ACK field. */
#define BR_CAN_MCR_LPM_ACK(x) (HW_CAN_MCR(x).B.LPM_ACK)
/*@}*/

/*!
 * @name Register CAN_MCR, field WRN_EN[21] (RW)
 *
 * When asserted, this bit enables the generation of the TWRN_INT and RWRN_INT
 * flags in the Error and Status Register. If WRN_EN is negated, the TWRN_INT and
 * RWRN_INT flags will always be zero, independent of the values of the error
 * counters, and no warning interrupt will ever be generated.This bit can only be
 * written in Freeze mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - TWRN_INT and RWRN_INT bits are set when the respective error counter
 *     transition from <96 to >= 96.
 * - 0 - TWRN_INT and RWRN_INT bits are zero, independent of the values in the
 *     error counters.
 */
/*@{*/
#define BP_CAN_MCR_WRN_EN    (21U)         /*!< Bit position for CAN_MCR_WRN_EN. */
#define BM_CAN_MCR_WRN_EN    (0x00200000U) /*!< Bit mask for CAN_MCR_WRN_EN. */
#define BS_CAN_MCR_WRN_EN    (1U)          /*!< Bit field size in bits for CAN_MCR_WRN_EN. */

/*! @brief Read current value of the CAN_MCR_WRN_EN field. */
#define BR_CAN_MCR_WRN_EN(x) (HW_CAN_MCR(x).B.WRN_EN)

/*! @brief Format value for bitfield CAN_MCR_WRN_EN. */
#define BF_CAN_MCR_WRN_EN(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_WRN_EN) & BM_CAN_MCR_WRN_EN)

/*! @brief Set the WRN_EN field to a new value. */
#define BW_CAN_MCR_WRN_EN(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_WRN_EN) | BF_CAN_MCR_WRN_EN(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field SLF_WAK[22] (RW)
 *
 * This bit enables the Self Wake Up feature when FLEXCAN is in Stop Mode. If
 * this bit had been asserted by the time FLEXCAN entered Stop Mode, then FLEXCAN
 * will look for a recessive to dominant transition on the bus during these modes.
 * If a transition from recessive to dominant is detected during Stop Mode, then
 * FLEXCAN generates, if enabled to do so, a Wake Up interrupt to the ARM so
 * that it can resume the clocks globally and FlexCAN can request to resume the
 * clocks. This bit can not be written while the module is in Stop Mode.
 *
 * Values:
 * - 1 - FLEXCAN Self Wake Up feature is enabled
 * - 0 - FLEXCAN Self Wake Up feature is disabled
 */
/*@{*/
#define BP_CAN_MCR_SLF_WAK   (22U)         /*!< Bit position for CAN_MCR_SLF_WAK. */
#define BM_CAN_MCR_SLF_WAK   (0x00400000U) /*!< Bit mask for CAN_MCR_SLF_WAK. */
#define BS_CAN_MCR_SLF_WAK   (1U)          /*!< Bit field size in bits for CAN_MCR_SLF_WAK. */

/*! @brief Read current value of the CAN_MCR_SLF_WAK field. */
#define BR_CAN_MCR_SLF_WAK(x) (HW_CAN_MCR(x).B.SLF_WAK)

/*! @brief Format value for bitfield CAN_MCR_SLF_WAK. */
#define BF_CAN_MCR_SLF_WAK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_SLF_WAK) & BM_CAN_MCR_SLF_WAK)

/*! @brief Set the SLF_WAK field to a new value. */
#define BW_CAN_MCR_SLF_WAK(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_SLF_WAK) | BF_CAN_MCR_SLF_WAK(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field SUPV[23] (RW)
 *
 * This bit configures some of the FLEXCAN registers to be either in Supervisor
 * or User Mode. Reset value of this bit is '1', so the affected registers start
 * with Supervisor access allowance only. This bit can only be written in Freeze
 * mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - FlexCAN is in Supervisor Mode. Affected registers allow only Supervisor
 *     access. Unrestricted access behaves as though the access was done to an
 *     unimplemented register location
 * - 0 - FlexCAN is in User Mode. Affected registers allow both Supervisor and
 *     Unrestricted accesses
 */
/*@{*/
#define BP_CAN_MCR_SUPV      (23U)         /*!< Bit position for CAN_MCR_SUPV. */
#define BM_CAN_MCR_SUPV      (0x00800000U) /*!< Bit mask for CAN_MCR_SUPV. */
#define BS_CAN_MCR_SUPV      (1U)          /*!< Bit field size in bits for CAN_MCR_SUPV. */

/*! @brief Read current value of the CAN_MCR_SUPV field. */
#define BR_CAN_MCR_SUPV(x)   (HW_CAN_MCR(x).B.SUPV)

/*! @brief Format value for bitfield CAN_MCR_SUPV. */
#define BF_CAN_MCR_SUPV(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_SUPV) & BM_CAN_MCR_SUPV)

/*! @brief Set the SUPV field to a new value. */
#define BW_CAN_MCR_SUPV(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_SUPV) | BF_CAN_MCR_SUPV(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field FRZ_ACK[24] (RO)
 *
 * This read-only bit indicates that FLEXCAN is in Freeze Mode and its prescaler
 * is stopped. The Freeze Mode request cannot be granted until current
 * transmission or reception processes have finished. Therefore the software can poll the
 * FRZ_ACK bit to know when FLEXCAN has actually entered Freeze Mode. If Freeze
 * Mode request is negated, then this bit is negated once the FLEXCAN prescaler is
 * running again. If Freeze Mode is requested while FLEXCAN is in any of the low
 * power modes, then the FRZ_ACK bit will only be set when the low power mode is
 * exited. See Freeze ModeThis mode is requested by ARM through the assertion of
 * the HALT bit in the MCR Register or when the MCU is put into Debug Mode . In
 * both cases it is also necessary that the FRZ bit is asserted in the MCR
 * Register and the module is not in any of the low power modes (Disable, Stop). The
 * acknowledgement is obtained through the assertion by the FlexCAN of FRZ_ACK bit
 * in the same register. The ARM must only consider the FlexCAN in Freeze Mode
 * when both request and acknowledgement conditions are satisfied. for more
 * information
 *
 * Values:
 * - 1 - FLEXCAN in Freeze Mode, prescaler stopped
 * - 0 - FLEXCAN not in Freeze Mode, prescaler running
 */
/*@{*/
#define BP_CAN_MCR_FRZ_ACK   (24U)         /*!< Bit position for CAN_MCR_FRZ_ACK. */
#define BM_CAN_MCR_FRZ_ACK   (0x01000000U) /*!< Bit mask for CAN_MCR_FRZ_ACK. */
#define BS_CAN_MCR_FRZ_ACK   (1U)          /*!< Bit field size in bits for CAN_MCR_FRZ_ACK. */

/*! @brief Read current value of the CAN_MCR_FRZ_ACK field. */
#define BR_CAN_MCR_FRZ_ACK(x) (HW_CAN_MCR(x).B.FRZ_ACK)
/*@}*/

/*!
 * @name Register CAN_MCR, field SOFT_RST[25] (RW)
 *
 * When this bit is asserted, FlexCAN resets its internal state machines and
 * some of the memory mapped registers. The following registers are reset: MCR
 * (except the MDIS bit), TIMER, ECR, ESR1, ESR2, IMASK1, IMASK2, IFLAG1, IFLAG2 and
 * CRCR. Configuration registers that control the interface to the CAN bus are not
 * affected by soft reset. The following registers are unaffected: CTRL1, CTRL2,
 * RXIMR0_RXIMR63, RXGMASK, RX14MASK, RX15MASK, RXFGMASK, RXFIR and all Message
 * Buffers The SOFT_RST bit can be asserted directly by the ARM when it writes to
 * the MCR Register. It may take some time to fully propagate its effect. The
 * SOFT_RST bit remains asserted while reset is pending, and is automatically
 * negated when reset completes. Therefore, software can poll this bit to know when
 * the soft reset has completed. Soft reset cannot be applied while clocks are shut
 * down in any of the low power modes. The module should be first removed from
 * low power mode, and then soft reset can be applied.
 *
 * Values:
 * - 1 - Reset the registers
 * - 0 - No reset request
 */
/*@{*/
#define BP_CAN_MCR_SOFT_RST  (25U)         /*!< Bit position for CAN_MCR_SOFT_RST. */
#define BM_CAN_MCR_SOFT_RST  (0x02000000U) /*!< Bit mask for CAN_MCR_SOFT_RST. */
#define BS_CAN_MCR_SOFT_RST  (1U)          /*!< Bit field size in bits for CAN_MCR_SOFT_RST. */

/*! @brief Read current value of the CAN_MCR_SOFT_RST field. */
#define BR_CAN_MCR_SOFT_RST(x) (HW_CAN_MCR(x).B.SOFT_RST)

/*! @brief Format value for bitfield CAN_MCR_SOFT_RST. */
#define BF_CAN_MCR_SOFT_RST(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_SOFT_RST) & BM_CAN_MCR_SOFT_RST)

/*! @brief Set the SOFT_RST field to a new value. */
#define BW_CAN_MCR_SOFT_RST(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_SOFT_RST) | BF_CAN_MCR_SOFT_RST(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field WAK_MSK[26] (RW)
 *
 * This bit enables the Wake Up Interrupt generation.
 *
 * Values:
 * - 1 - Wake Up Interrupt is enabled
 * - 0 - Wake Up Interrupt is disabled
 */
/*@{*/
#define BP_CAN_MCR_WAK_MSK   (26U)         /*!< Bit position for CAN_MCR_WAK_MSK. */
#define BM_CAN_MCR_WAK_MSK   (0x04000000U) /*!< Bit mask for CAN_MCR_WAK_MSK. */
#define BS_CAN_MCR_WAK_MSK   (1U)          /*!< Bit field size in bits for CAN_MCR_WAK_MSK. */

/*! @brief Read current value of the CAN_MCR_WAK_MSK field. */
#define BR_CAN_MCR_WAK_MSK(x) (HW_CAN_MCR(x).B.WAK_MSK)

/*! @brief Format value for bitfield CAN_MCR_WAK_MSK. */
#define BF_CAN_MCR_WAK_MSK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_WAK_MSK) & BM_CAN_MCR_WAK_MSK)

/*! @brief Set the WAK_MSK field to a new value. */
#define BW_CAN_MCR_WAK_MSK(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_WAK_MSK) | BF_CAN_MCR_WAK_MSK(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field NOT_RDY[27] (RO)
 *
 * This read-only bit indicates that FLEXCAN is either in Disable Mode, Stop
 * Mode or Freeze Mode. It is negated once FLEXCAN has exited these modes.
 *
 * Values:
 * - 1 - FLEXCAN module is either in Disable Mode, Stop Mode or Freeze Mode
 * - 0 - FLEXCAN module is either in Normal Mode, Listen-Only Mode or Loop-Back
 *     Mode
 */
/*@{*/
#define BP_CAN_MCR_NOT_RDY   (27U)         /*!< Bit position for CAN_MCR_NOT_RDY. */
#define BM_CAN_MCR_NOT_RDY   (0x08000000U) /*!< Bit mask for CAN_MCR_NOT_RDY. */
#define BS_CAN_MCR_NOT_RDY   (1U)          /*!< Bit field size in bits for CAN_MCR_NOT_RDY. */

/*! @brief Read current value of the CAN_MCR_NOT_RDY field. */
#define BR_CAN_MCR_NOT_RDY(x) (HW_CAN_MCR(x).B.NOT_RDY)
/*@}*/

/*!
 * @name Register CAN_MCR, field HALT[28] (RW)
 *
 * Assertion of this bit puts the FLEXCAN module into Freeze Mode. The ARM
 * should clear it after initializing the Message Buffers and Control Register. No
 * reception or transmission is performed by FLEXCAN before this bit is cleared.
 * Freeze Mode can not be entered while FLEXCAN is in any of the low power modes.See
 * Freeze ModeThis mode is requested by ARM through the assertion of the HALT
 * bit in the MCR Register or when the MCU is put into Debug Mode . In both cases
 * it is also necessary that the FRZ bit is asserted in the MCR Register and the
 * module is not in any of the low power modes (Disable, Stop). The
 * acknowledgement is obtained through the assertion by the FlexCAN of FRZ_ACK bit in the same
 * register. The ARM must only consider the FlexCAN in Freeze Mode when both
 * request and acknowledgement conditions are satisfied. for more information
 *
 * Values:
 * - 1 - Enters Freeze Mode if the FRZ bit is asserted.
 * - 0 - No Freeze Mode request.
 */
/*@{*/
#define BP_CAN_MCR_HALT      (28U)         /*!< Bit position for CAN_MCR_HALT. */
#define BM_CAN_MCR_HALT      (0x10000000U) /*!< Bit mask for CAN_MCR_HALT. */
#define BS_CAN_MCR_HALT      (1U)          /*!< Bit field size in bits for CAN_MCR_HALT. */

/*! @brief Read current value of the CAN_MCR_HALT field. */
#define BR_CAN_MCR_HALT(x)   (HW_CAN_MCR(x).B.HALT)

/*! @brief Format value for bitfield CAN_MCR_HALT. */
#define BF_CAN_MCR_HALT(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_HALT) & BM_CAN_MCR_HALT)

/*! @brief Set the HALT field to a new value. */
#define BW_CAN_MCR_HALT(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_HALT) | BF_CAN_MCR_HALT(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field RFEN[29] (RW)
 *
 * This bit controls whether the Rx FIFO feature is enabled or not. When RFEN is
 * set, MBs 0 to 5 cannot be used for normal reception and transmission because
 * the corresponding memory region (0x80-0xDC) is used by the FIFO engine as well
 * as additional MBs (up to 32, depending on CTRL2[RFFN] setting) which are used
 * as Rx FIFO ID Filter Table elements.RFEN also impacts the definition of the
 * minimum number of peripheral clocks per CAN bit as described in (see
 * Arbitration and Matching Timing).This bit can only be written in Freeze mode as it is
 * blocked by hardware in other modes.
 *
 * Values:
 * - 1 - FIFO enabled
 * - 0 - FIFO not enabled
 */
/*@{*/
#define BP_CAN_MCR_RFEN      (29U)         /*!< Bit position for CAN_MCR_RFEN. */
#define BM_CAN_MCR_RFEN      (0x20000000U) /*!< Bit mask for CAN_MCR_RFEN. */
#define BS_CAN_MCR_RFEN      (1U)          /*!< Bit field size in bits for CAN_MCR_RFEN. */

/*! @brief Read current value of the CAN_MCR_RFEN field. */
#define BR_CAN_MCR_RFEN(x)   (HW_CAN_MCR(x).B.RFEN)

/*! @brief Format value for bitfield CAN_MCR_RFEN. */
#define BF_CAN_MCR_RFEN(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_RFEN) & BM_CAN_MCR_RFEN)

/*! @brief Set the RFEN field to a new value. */
#define BW_CAN_MCR_RFEN(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_RFEN) | BF_CAN_MCR_RFEN(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field FRZ[30] (RW)
 *
 * The FRZ bit specifies the FLEXCAN behavior when the HALT bit in the MCR
 * Register is set or when Debug Mode is requested at ARM level. When FRZ is asserted,
 * FLEXCAN is enabled to enter Freeze Mode. Negation of this bit field causes
 * FLEXCAN to exit from Freeze Mode.
 *
 * Values:
 * - 1 - Enabled to enter Freeze Mode
 * - 0 - Not enabled to enter Freeze Mode
 */
/*@{*/
#define BP_CAN_MCR_FRZ       (30U)         /*!< Bit position for CAN_MCR_FRZ. */
#define BM_CAN_MCR_FRZ       (0x40000000U) /*!< Bit mask for CAN_MCR_FRZ. */
#define BS_CAN_MCR_FRZ       (1U)          /*!< Bit field size in bits for CAN_MCR_FRZ. */

/*! @brief Read current value of the CAN_MCR_FRZ field. */
#define BR_CAN_MCR_FRZ(x)    (HW_CAN_MCR(x).B.FRZ)

/*! @brief Format value for bitfield CAN_MCR_FRZ. */
#define BF_CAN_MCR_FRZ(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_FRZ) & BM_CAN_MCR_FRZ)

/*! @brief Set the FRZ field to a new value. */
#define BW_CAN_MCR_FRZ(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_FRZ) | BF_CAN_MCR_FRZ(v)))
/*@}*/

/*!
 * @name Register CAN_MCR, field MDIS[31] (RW)
 *
 * This bit controls whether FLEXCAN is enabled or not. When disabled, FLEXCAN
 * shuts down the clocks to the CAN Protocol Interface and Message Buffer
 * Management sub-modules. This is the only bit in MCR not affected by soft reset. See
 * Module Disable ModeThis low power mode is normally used to temporarily disable a
 * complete FlexCAN block, with no power consumption. It is requested by the ARM
 * through the assertion of the MDIS bit in the MCR Register and the
 * acknowledgement is obtained through the assertion by the FlexCAN of the LPM_ACK bit in
 * the same register. The ARM must only consider the FlexCAN in Disable Mode when
 * both request and acknowledgement conditions are satisfied. for more information.
 *
 * Values:
 * - 1 - Disable the FLEXCAN module
 * - 0 - Enable the FLEXCAN module
 */
/*@{*/
#define BP_CAN_MCR_MDIS      (31U)         /*!< Bit position for CAN_MCR_MDIS. */
#define BM_CAN_MCR_MDIS      (0x80000000U) /*!< Bit mask for CAN_MCR_MDIS. */
#define BS_CAN_MCR_MDIS      (1U)          /*!< Bit field size in bits for CAN_MCR_MDIS. */

/*! @brief Read current value of the CAN_MCR_MDIS field. */
#define BR_CAN_MCR_MDIS(x)   (HW_CAN_MCR(x).B.MDIS)

/*! @brief Format value for bitfield CAN_MCR_MDIS. */
#define BF_CAN_MCR_MDIS(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_MCR_MDIS) & BM_CAN_MCR_MDIS)

/*! @brief Set the MDIS field to a new value. */
#define BW_CAN_MCR_MDIS(x, v) (HW_CAN_MCR_WR(x, (HW_CAN_MCR_RD(x) & ~BM_CAN_MCR_MDIS) | BF_CAN_MCR_MDIS(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_CTRL1 - Control 1 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_CTRL1 - Control 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is defined for specific FLEXCAN control features related to the
 * CAN bus, such as bit-rate, programmable sampling point within an Rx bit, Loop
 * Back Mode, Listen Only Mode, Bus Off recovery behavior and interrupt enabling
 * (Bus-Off, Error, Warning). It also determines the Division Factor for the
 * clock prescaler.
 */
typedef union _hw_can_ctrl1
{
    uint32_t U;
    struct _hw_can_ctrl1_bitfields
    {
        uint32_t PROP_SEG : 3;         /*!< [2:0]  */
        uint32_t LOM : 1;              /*!< [3]  */
        uint32_t LBUF : 1;             /*!< [4]  */
        uint32_t TSYN : 1;             /*!< [5]  */
        uint32_t BOFF_REC : 1;         /*!< [6]  */
        uint32_t SMP : 1;              /*!< [7]  */
        uint32_t RESERVED0 : 2;        /*!< [9:8]  */
        uint32_t RWRN_MSK : 1;         /*!< [10]  */
        uint32_t TWRN_MSK : 1;         /*!< [11]  */
        uint32_t LPB : 1;              /*!< [12]  */
        uint32_t RESERVED1 : 1;        /*!< [13]  */
        uint32_t ERR_MSK : 1;          /*!< [14]  */
        uint32_t BOFF_MSK : 1;         /*!< [15]  */
        uint32_t PSEG2 : 3;            /*!< [18:16]  */
        uint32_t PSEG1 : 3;            /*!< [21:19]  */
        uint32_t RJW : 2;              /*!< [23:22]  */
        uint32_t PRESDIV : 8;          /*!< [31:24]  */
    } B;
} hw_can_ctrl1_t;

/*!
 * @name Constants and macros for entire CAN_CTRL1 register
 */
/*@{*/
#define HW_CAN_CTRL1_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_CAN_CTRL1(x)          (*(__IO hw_can_ctrl1_t *) HW_CAN_CTRL1_ADDR(x))
#define HW_CAN_CTRL1_RD(x)       (HW_CAN_CTRL1(x).U)
#define HW_CAN_CTRL1_WR(x, v)    (HW_CAN_CTRL1(x).U = (v))
#define HW_CAN_CTRL1_SET(x, v)   (HW_CAN_CTRL1_WR(x, HW_CAN_CTRL1_RD(x) |  (v)))
#define HW_CAN_CTRL1_CLR(x, v)   (HW_CAN_CTRL1_WR(x, HW_CAN_CTRL1_RD(x) & ~(v)))
#define HW_CAN_CTRL1_TOG(x, v)   (HW_CAN_CTRL1_WR(x, HW_CAN_CTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_CTRL1 bitfields
 */

/*!
 * @name Register CAN_CTRL1, field PROP_SEG[2:0] (RW)
 *
 * This 3-bit field defines the length of the Propagation Segment in the bit
 * time. The valid programmable values are 0-7. This field can only be written in
 * Freeze mode as it is blocked by hardware in other modes Propagation Segment Time
 * = (PROPSEG + 1) * Time-Quanta. Time-Quantum = one Sclock period.
 */
/*@{*/
#define BP_CAN_CTRL1_PROP_SEG (0U)         /*!< Bit position for CAN_CTRL1_PROP_SEG. */
#define BM_CAN_CTRL1_PROP_SEG (0x00000007U) /*!< Bit mask for CAN_CTRL1_PROP_SEG. */
#define BS_CAN_CTRL1_PROP_SEG (3U)         /*!< Bit field size in bits for CAN_CTRL1_PROP_SEG. */

/*! @brief Read current value of the CAN_CTRL1_PROP_SEG field. */
#define BR_CAN_CTRL1_PROP_SEG(x) (HW_CAN_CTRL1(x).B.PROP_SEG)

/*! @brief Format value for bitfield CAN_CTRL1_PROP_SEG. */
#define BF_CAN_CTRL1_PROP_SEG(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_PROP_SEG) & BM_CAN_CTRL1_PROP_SEG)

/*! @brief Set the PROP_SEG field to a new value. */
#define BW_CAN_CTRL1_PROP_SEG(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_PROP_SEG) | BF_CAN_CTRL1_PROP_SEG(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field LOM[3] (RW)
 *
 * This bit configures FLEXCAN to operate in Listen Only Mode. In this mode,
 * transmission is disabled, all error counters are frozen and the module operates
 * in a CAN Error Passive mode. Only messages acknowledged by another CAN station
 * will be received. If FLEXCAN detects a message that has not been acknowledged,
 * it will flag a BIT0 error (without changing the REC), as if it was trying to
 * acknowledge the message. Listen-Only Mode acknowledgement can be obtained by
 * the state of ESR1[FLT_CONF] field which is Passive Error when Listen-Only Mode
 * is entered. There can be some delay between the Listen-Only Mode request and
 * acknowledge. This bit can only be written in Freeze mode as it is blocked by
 * hardware in other modes.
 *
 * Values:
 * - 1 - FLEXCAN module operates in Listen Only Mode
 * - 0 - Listen Only Mode is deactivated
 */
/*@{*/
#define BP_CAN_CTRL1_LOM     (3U)          /*!< Bit position for CAN_CTRL1_LOM. */
#define BM_CAN_CTRL1_LOM     (0x00000008U) /*!< Bit mask for CAN_CTRL1_LOM. */
#define BS_CAN_CTRL1_LOM     (1U)          /*!< Bit field size in bits for CAN_CTRL1_LOM. */

/*! @brief Read current value of the CAN_CTRL1_LOM field. */
#define BR_CAN_CTRL1_LOM(x)  (HW_CAN_CTRL1(x).B.LOM)

/*! @brief Format value for bitfield CAN_CTRL1_LOM. */
#define BF_CAN_CTRL1_LOM(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_LOM) & BM_CAN_CTRL1_LOM)

/*! @brief Set the LOM field to a new value. */
#define BW_CAN_CTRL1_LOM(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_LOM) | BF_CAN_CTRL1_LOM(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field LBUF[4] (RW)
 *
 * This bit defines the ordering mechanism for Message Buffer transmission. When
 * asserted, the LPRIO_EN bit does not affect the priority arbitration.This bit
 * can only be written in Freeze mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Lowest number buffer is transmitted first
 * - 0 - Buffer with highest priority is transmitted first
 */
/*@{*/
#define BP_CAN_CTRL1_LBUF    (4U)          /*!< Bit position for CAN_CTRL1_LBUF. */
#define BM_CAN_CTRL1_LBUF    (0x00000010U) /*!< Bit mask for CAN_CTRL1_LBUF. */
#define BS_CAN_CTRL1_LBUF    (1U)          /*!< Bit field size in bits for CAN_CTRL1_LBUF. */

/*! @brief Read current value of the CAN_CTRL1_LBUF field. */
#define BR_CAN_CTRL1_LBUF(x) (HW_CAN_CTRL1(x).B.LBUF)

/*! @brief Format value for bitfield CAN_CTRL1_LBUF. */
#define BF_CAN_CTRL1_LBUF(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_LBUF) & BM_CAN_CTRL1_LBUF)

/*! @brief Set the LBUF field to a new value. */
#define BW_CAN_CTRL1_LBUF(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_LBUF) | BF_CAN_CTRL1_LBUF(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field TSYN[5] (RW)
 *
 * This bit enables a mechanism that resets the free-running timer each time a
 * message is received in Message Buffer 0. This feature provides means to
 * synchronize multiple FLEXCAN stations with a special "SYNC" message (i.e., global
 * network time). If the RFEN bit in MCR is set (FIFO enabled), the first available
 * Mailbox, according to CTRL2[RFFN] setting, is used for timer synchronization
 * instead of MB0.This bit can only be written in Freeze mode as it is blocked by
 * hardware in other modes.
 *
 * Values:
 * - 1 - Timer Sync feature enabled
 * - 0 - Timer Sync feature disabled
 */
/*@{*/
#define BP_CAN_CTRL1_TSYN    (5U)          /*!< Bit position for CAN_CTRL1_TSYN. */
#define BM_CAN_CTRL1_TSYN    (0x00000020U) /*!< Bit mask for CAN_CTRL1_TSYN. */
#define BS_CAN_CTRL1_TSYN    (1U)          /*!< Bit field size in bits for CAN_CTRL1_TSYN. */

/*! @brief Read current value of the CAN_CTRL1_TSYN field. */
#define BR_CAN_CTRL1_TSYN(x) (HW_CAN_CTRL1(x).B.TSYN)

/*! @brief Format value for bitfield CAN_CTRL1_TSYN. */
#define BF_CAN_CTRL1_TSYN(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_TSYN) & BM_CAN_CTRL1_TSYN)

/*! @brief Set the TSYN field to a new value. */
#define BW_CAN_CTRL1_TSYN(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_TSYN) | BF_CAN_CTRL1_TSYN(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field BOFF_REC[6] (RW)
 *
 * This bit defines how FLEXCAN recovers from Bus Off state. If this bit is
 * negated, automatic recovering from Bus Off state occurs according to the CAN
 * Specification 2.0B. If the bit is asserted, automatic recovering from Bus Off is
 * disabled and the module remains in Bus Off state until the bit is negated by the
 * user. If the negation occurs before 128 sequences of 11 recessive bits are
 * detected on the CAN bus, then Bus Off recovery happens as if the BOFF_REC bit
 * had never been asserted. If the negation occurs after 128 sequences of 11
 * recessive bits occurred, then FLEXCAN will re-synchronize to the bus by waiting for
 * 11 recessive bits before joining the bus. After negation, the BOFF_REC bit can
 * be re-asserted again during Bus Off, but it will only be effective the next
 * time the module enters Bus Off. If BOFF_REC was negated when the module entered
 * Bus Off, asserting it during Bus Off will not be effective for the current
 * Bus Off recovery.
 *
 * Values:
 * - 1 - Automatic recovering from Bus Off state disabled
 * - 0 - Automatic recovering from Bus Off state enabled, according to CAN Spec
 *     2.0 part B
 */
/*@{*/
#define BP_CAN_CTRL1_BOFF_REC (6U)         /*!< Bit position for CAN_CTRL1_BOFF_REC. */
#define BM_CAN_CTRL1_BOFF_REC (0x00000040U) /*!< Bit mask for CAN_CTRL1_BOFF_REC. */
#define BS_CAN_CTRL1_BOFF_REC (1U)         /*!< Bit field size in bits for CAN_CTRL1_BOFF_REC. */

/*! @brief Read current value of the CAN_CTRL1_BOFF_REC field. */
#define BR_CAN_CTRL1_BOFF_REC(x) (HW_CAN_CTRL1(x).B.BOFF_REC)

/*! @brief Format value for bitfield CAN_CTRL1_BOFF_REC. */
#define BF_CAN_CTRL1_BOFF_REC(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_BOFF_REC) & BM_CAN_CTRL1_BOFF_REC)

/*! @brief Set the BOFF_REC field to a new value. */
#define BW_CAN_CTRL1_BOFF_REC(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_BOFF_REC) | BF_CAN_CTRL1_BOFF_REC(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field SMP[7] (RW)
 *
 * This bit defines the sampling mode of CAN bits at the FLEXCAN_RX. This bit
 * can only be written in Freeze mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Three samples are used to determine the value of the received bit: the
 *     regular one (sample point) and 2 preceding samples, a majority rule is used
 * - 0 - Just one sample is used to determine the bit value
 */
/*@{*/
#define BP_CAN_CTRL1_SMP     (7U)          /*!< Bit position for CAN_CTRL1_SMP. */
#define BM_CAN_CTRL1_SMP     (0x00000080U) /*!< Bit mask for CAN_CTRL1_SMP. */
#define BS_CAN_CTRL1_SMP     (1U)          /*!< Bit field size in bits for CAN_CTRL1_SMP. */

/*! @brief Read current value of the CAN_CTRL1_SMP field. */
#define BR_CAN_CTRL1_SMP(x)  (HW_CAN_CTRL1(x).B.SMP)

/*! @brief Format value for bitfield CAN_CTRL1_SMP. */
#define BF_CAN_CTRL1_SMP(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_SMP) & BM_CAN_CTRL1_SMP)

/*! @brief Set the SMP field to a new value. */
#define BW_CAN_CTRL1_SMP(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_SMP) | BF_CAN_CTRL1_SMP(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field RWRN_MSK[10] (RW)
 *
 * This bit provides a mask for the Rx Warning Interrupt associated with the
 * RWRN_INT flag in the Error and Status Register. This bit is read as zero when
 * MCR[WRN_EN] bit is negated. This bit can only be written if MCR[WRN_EN] bit is
 * asserted.
 *
 * Values:
 * - 1 - Rx Warning Interrupt enabled
 * - 0 - Rx Warning Interrupt disabled
 */
/*@{*/
#define BP_CAN_CTRL1_RWRN_MSK (10U)        /*!< Bit position for CAN_CTRL1_RWRN_MSK. */
#define BM_CAN_CTRL1_RWRN_MSK (0x00000400U) /*!< Bit mask for CAN_CTRL1_RWRN_MSK. */
#define BS_CAN_CTRL1_RWRN_MSK (1U)         /*!< Bit field size in bits for CAN_CTRL1_RWRN_MSK. */

/*! @brief Read current value of the CAN_CTRL1_RWRN_MSK field. */
#define BR_CAN_CTRL1_RWRN_MSK(x) (HW_CAN_CTRL1(x).B.RWRN_MSK)

/*! @brief Format value for bitfield CAN_CTRL1_RWRN_MSK. */
#define BF_CAN_CTRL1_RWRN_MSK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_RWRN_MSK) & BM_CAN_CTRL1_RWRN_MSK)

/*! @brief Set the RWRN_MSK field to a new value. */
#define BW_CAN_CTRL1_RWRN_MSK(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_RWRN_MSK) | BF_CAN_CTRL1_RWRN_MSK(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field TWRN_MSK[11] (RW)
 *
 * This bit provides a mask for the Tx Warning Interrupt associated with the
 * TWRN_INT flag in the Error and Status Register. This bit is read as zero when
 * MCR[WRN_EN] bit is negated. This bit can only be written if MCR[WRN_EN] bit is
 * asserted.
 *
 * Values:
 * - 1 - Tx Warning Interrupt enabled
 * - 0 - Tx Warning Interrupt disabled
 */
/*@{*/
#define BP_CAN_CTRL1_TWRN_MSK (11U)        /*!< Bit position for CAN_CTRL1_TWRN_MSK. */
#define BM_CAN_CTRL1_TWRN_MSK (0x00000800U) /*!< Bit mask for CAN_CTRL1_TWRN_MSK. */
#define BS_CAN_CTRL1_TWRN_MSK (1U)         /*!< Bit field size in bits for CAN_CTRL1_TWRN_MSK. */

/*! @brief Read current value of the CAN_CTRL1_TWRN_MSK field. */
#define BR_CAN_CTRL1_TWRN_MSK(x) (HW_CAN_CTRL1(x).B.TWRN_MSK)

/*! @brief Format value for bitfield CAN_CTRL1_TWRN_MSK. */
#define BF_CAN_CTRL1_TWRN_MSK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_TWRN_MSK) & BM_CAN_CTRL1_TWRN_MSK)

/*! @brief Set the TWRN_MSK field to a new value. */
#define BW_CAN_CTRL1_TWRN_MSK(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_TWRN_MSK) | BF_CAN_CTRL1_TWRN_MSK(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field LPB[12] (RW)
 *
 * This bit configures FlexCAN to operate in Loop-Back Mode. In this mode,
 * FlexCAN performs an internal loop back that can be used for self test operation.
 * The bit stream output of the transmitter is fed back internally to the receiver
 * input. The FLEXCAN_RX input pin is ignored and the FLEXCAN_TX output goes to
 * the recessive state (logic '1'). FlexCAN behaves as it normally does when
 * transmitting, and treats its own transmitted message as a message received from a
 * remote node. In this mode, FlexCAN ignores the bit sent during the ACK slot in
 * the CAN frame acknowledge field, generating an internal acknowledge bit to
 * ensure proper reception of its own message. Both transmit and receive interrupts
 * are generated. This bit can only be written in Freeze mode as it is blocked by
 * hardware in other modes.
 *
 * Values:
 * - 1 - Loop Back enabled
 * - 0 - Loop Back disabled
 */
/*@{*/
#define BP_CAN_CTRL1_LPB     (12U)         /*!< Bit position for CAN_CTRL1_LPB. */
#define BM_CAN_CTRL1_LPB     (0x00001000U) /*!< Bit mask for CAN_CTRL1_LPB. */
#define BS_CAN_CTRL1_LPB     (1U)          /*!< Bit field size in bits for CAN_CTRL1_LPB. */

/*! @brief Read current value of the CAN_CTRL1_LPB field. */
#define BR_CAN_CTRL1_LPB(x)  (HW_CAN_CTRL1(x).B.LPB)

/*! @brief Format value for bitfield CAN_CTRL1_LPB. */
#define BF_CAN_CTRL1_LPB(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_LPB) & BM_CAN_CTRL1_LPB)

/*! @brief Set the LPB field to a new value. */
#define BW_CAN_CTRL1_LPB(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_LPB) | BF_CAN_CTRL1_LPB(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field ERR_MSK[14] (RW)
 *
 * This bit provides a mask for the Error Interrupt.
 *
 * Values:
 * - 1 - Error interrupt enabled
 * - 0 - Error interrupt disabled
 */
/*@{*/
#define BP_CAN_CTRL1_ERR_MSK (14U)         /*!< Bit position for CAN_CTRL1_ERR_MSK. */
#define BM_CAN_CTRL1_ERR_MSK (0x00004000U) /*!< Bit mask for CAN_CTRL1_ERR_MSK. */
#define BS_CAN_CTRL1_ERR_MSK (1U)          /*!< Bit field size in bits for CAN_CTRL1_ERR_MSK. */

/*! @brief Read current value of the CAN_CTRL1_ERR_MSK field. */
#define BR_CAN_CTRL1_ERR_MSK(x) (HW_CAN_CTRL1(x).B.ERR_MSK)

/*! @brief Format value for bitfield CAN_CTRL1_ERR_MSK. */
#define BF_CAN_CTRL1_ERR_MSK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_ERR_MSK) & BM_CAN_CTRL1_ERR_MSK)

/*! @brief Set the ERR_MSK field to a new value. */
#define BW_CAN_CTRL1_ERR_MSK(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_ERR_MSK) | BF_CAN_CTRL1_ERR_MSK(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field BOFF_MSK[15] (RW)
 *
 * This bit provides a mask for the Bus Off Interrupt.
 *
 * Values:
 * - 1 - Bus Off interrupt enabled
 * - 0 - Bus Off interrupt disabled
 */
/*@{*/
#define BP_CAN_CTRL1_BOFF_MSK (15U)        /*!< Bit position for CAN_CTRL1_BOFF_MSK. */
#define BM_CAN_CTRL1_BOFF_MSK (0x00008000U) /*!< Bit mask for CAN_CTRL1_BOFF_MSK. */
#define BS_CAN_CTRL1_BOFF_MSK (1U)         /*!< Bit field size in bits for CAN_CTRL1_BOFF_MSK. */

/*! @brief Read current value of the CAN_CTRL1_BOFF_MSK field. */
#define BR_CAN_CTRL1_BOFF_MSK(x) (HW_CAN_CTRL1(x).B.BOFF_MSK)

/*! @brief Format value for bitfield CAN_CTRL1_BOFF_MSK. */
#define BF_CAN_CTRL1_BOFF_MSK(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_BOFF_MSK) & BM_CAN_CTRL1_BOFF_MSK)

/*! @brief Set the BOFF_MSK field to a new value. */
#define BW_CAN_CTRL1_BOFF_MSK(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_BOFF_MSK) | BF_CAN_CTRL1_BOFF_MSK(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field PSEG2[18:16] (RW)
 *
 * This 3-bit field defines the length of Phase Buffer Segment 2 in the bit
 * time. The valid programmable values are 1-7. This field can only be written in
 * Freeze mode as it is blocked by hardware in other modes Phase Buffer Segment 2 =
 * (PSEG2 + 1) x Time-Quanta.
 */
/*@{*/
#define BP_CAN_CTRL1_PSEG2   (16U)         /*!< Bit position for CAN_CTRL1_PSEG2. */
#define BM_CAN_CTRL1_PSEG2   (0x00070000U) /*!< Bit mask for CAN_CTRL1_PSEG2. */
#define BS_CAN_CTRL1_PSEG2   (3U)          /*!< Bit field size in bits for CAN_CTRL1_PSEG2. */

/*! @brief Read current value of the CAN_CTRL1_PSEG2 field. */
#define BR_CAN_CTRL1_PSEG2(x) (HW_CAN_CTRL1(x).B.PSEG2)

/*! @brief Format value for bitfield CAN_CTRL1_PSEG2. */
#define BF_CAN_CTRL1_PSEG2(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_PSEG2) & BM_CAN_CTRL1_PSEG2)

/*! @brief Set the PSEG2 field to a new value. */
#define BW_CAN_CTRL1_PSEG2(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_PSEG2) | BF_CAN_CTRL1_PSEG2(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field PSEG1[21:19] (RW)
 *
 * This 3-bit field defines the length of Phase Buffer Segment 1 in the bit
 * time. The valid programmable values are 0-7. This field can only be written in
 * Freeze mode as it is blocked by hardware in other modes Phase Buffer Segment 1 =
 * (PSEG1 + 1) x Time-Quanta.
 */
/*@{*/
#define BP_CAN_CTRL1_PSEG1   (19U)         /*!< Bit position for CAN_CTRL1_PSEG1. */
#define BM_CAN_CTRL1_PSEG1   (0x00380000U) /*!< Bit mask for CAN_CTRL1_PSEG1. */
#define BS_CAN_CTRL1_PSEG1   (3U)          /*!< Bit field size in bits for CAN_CTRL1_PSEG1. */

/*! @brief Read current value of the CAN_CTRL1_PSEG1 field. */
#define BR_CAN_CTRL1_PSEG1(x) (HW_CAN_CTRL1(x).B.PSEG1)

/*! @brief Format value for bitfield CAN_CTRL1_PSEG1. */
#define BF_CAN_CTRL1_PSEG1(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_PSEG1) & BM_CAN_CTRL1_PSEG1)

/*! @brief Set the PSEG1 field to a new value. */
#define BW_CAN_CTRL1_PSEG1(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_PSEG1) | BF_CAN_CTRL1_PSEG1(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field RJW[23:22] (RW)
 *
 * This 2-bit field defines the maximum number of time quanta One time quantum
 * is equal to the Sclock period. that a bit time can be changed by one
 * re-synchronization. The valid programmable values are 0-3. This field can only be
 * written in Freeze mode as it is blocked by hardware in other modes Resync Jump Width
 * = RJW + 1.
 */
/*@{*/
#define BP_CAN_CTRL1_RJW     (22U)         /*!< Bit position for CAN_CTRL1_RJW. */
#define BM_CAN_CTRL1_RJW     (0x00C00000U) /*!< Bit mask for CAN_CTRL1_RJW. */
#define BS_CAN_CTRL1_RJW     (2U)          /*!< Bit field size in bits for CAN_CTRL1_RJW. */

/*! @brief Read current value of the CAN_CTRL1_RJW field. */
#define BR_CAN_CTRL1_RJW(x)  (HW_CAN_CTRL1(x).B.RJW)

/*! @brief Format value for bitfield CAN_CTRL1_RJW. */
#define BF_CAN_CTRL1_RJW(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_RJW) & BM_CAN_CTRL1_RJW)

/*! @brief Set the RJW field to a new value. */
#define BW_CAN_CTRL1_RJW(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_RJW) | BF_CAN_CTRL1_RJW(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL1, field PRESDIV[31:24] (RW)
 *
 * This 8-bit field defines the ratio between the PE clock frequency and the
 * Serial Clock (Sclock) frequency. The Sclock period defines the time quantum of
 * the CAN protocol. For the reset value, the Sclock frequency is equal to the PE
 * clock frequency. The Maximum value of this register is 0xFF, that gives a
 * minimum Sclock frequency equal to the PE clock frequency divided by 256.For more
 * information refer to Protocol Timing. This field can only be written in Freeze
 * mode as it is blocked by hardware in other modes. Sclock frequency = CPI clock
 * frequency / (PRESDIV+1)
 */
/*@{*/
#define BP_CAN_CTRL1_PRESDIV (24U)         /*!< Bit position for CAN_CTRL1_PRESDIV. */
#define BM_CAN_CTRL1_PRESDIV (0xFF000000U) /*!< Bit mask for CAN_CTRL1_PRESDIV. */
#define BS_CAN_CTRL1_PRESDIV (8U)          /*!< Bit field size in bits for CAN_CTRL1_PRESDIV. */

/*! @brief Read current value of the CAN_CTRL1_PRESDIV field. */
#define BR_CAN_CTRL1_PRESDIV(x) (HW_CAN_CTRL1(x).B.PRESDIV)

/*! @brief Format value for bitfield CAN_CTRL1_PRESDIV. */
#define BF_CAN_CTRL1_PRESDIV(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL1_PRESDIV) & BM_CAN_CTRL1_PRESDIV)

/*! @brief Set the PRESDIV field to a new value. */
#define BW_CAN_CTRL1_PRESDIV(x, v) (HW_CAN_CTRL1_WR(x, (HW_CAN_CTRL1_RD(x) & ~BM_CAN_CTRL1_PRESDIV) | BF_CAN_CTRL1_PRESDIV(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_TIMER - Free Running Timer Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_TIMER - Free Running Timer Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register represents a 16-bit free running counter that can be read and
 * written by the ARM. The timer starts from $0000 after Reset, counts linearly to
 * $FFFF, and wraps around. The timer is clocked by the FLEXCAN bit-clock (which
 * defines the baud rate on the CAN bus). During a message
 * transmission/reception, it increments by one for each bit that is received or transmitted. When
 * there is no message on the bus, it counts using the previously programmed baud
 * rate. During Freeze Mode, disable, and stop mode, the timer is not incremented.
 * The timer value is captured at the beginning of the identifier field of any
 * frame on the CAN bus. This captured value is written into the Time Stamp entry
 * in a message buffer after a successful reception or transmission of a message.
 * If bit CTRL1[TSYN] is asserted the Timer is reset whenever a message is
 * received in the first available Mailbox, according to CTRL2[RFFN] setting. ARM can
 * write to this register anytime. However, if the write occurs at the same time
 * that the Timer is being reset by a reception in the first Mailbox, then the
 * write value is discarded. Reading this register affects the Mailbox Unlocking
 * procedure. For additional details, refer to Message Buffer Lock MechanismBesides
 * MB inactivation, FlexCAN has another data coherence mechanism for the receive
 * process. When ARM reads the Control and Status word of an Rx MB with codes
 * FULL or OVERRUN, FlexCAN assumes that ARM wants to read the whole MB in an atomic
 * operation, and thus it sets an internal lock flag for that MB. The lock is
 * released when ARM reads the Free Running Timer (global unlock operation), or
 * when it reads the Control and Status word of another MB regardless of its code or
 * when ARM writes into C/S word from locked MB. The MB locking is done to
 * prevent a new frame to be written into the MB while ARM is reading it. .
 */
typedef union _hw_can_timer
{
    uint32_t U;
    struct _hw_can_timer_bitfields
    {
        uint32_t TIMER : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_can_timer_t;

/*!
 * @name Constants and macros for entire CAN_TIMER register
 */
/*@{*/
#define HW_CAN_TIMER_ADDR(x)     ((uintptr_t)(x) + 0x8U)

#define HW_CAN_TIMER(x)          (*(__IO hw_can_timer_t *) HW_CAN_TIMER_ADDR(x))
#define HW_CAN_TIMER_RD(x)       (HW_CAN_TIMER(x).U)
#define HW_CAN_TIMER_WR(x, v)    (HW_CAN_TIMER(x).U = (v))
#define HW_CAN_TIMER_SET(x, v)   (HW_CAN_TIMER_WR(x, HW_CAN_TIMER_RD(x) |  (v)))
#define HW_CAN_TIMER_CLR(x, v)   (HW_CAN_TIMER_WR(x, HW_CAN_TIMER_RD(x) & ~(v)))
#define HW_CAN_TIMER_TOG(x, v)   (HW_CAN_TIMER_WR(x, HW_CAN_TIMER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_TIMER bitfields
 */

/*!
 * @name Register CAN_TIMER, field TIMER[15:0] (RW)
 *
 * TIMER
 */
/*@{*/
#define BP_CAN_TIMER_TIMER   (0U)          /*!< Bit position for CAN_TIMER_TIMER. */
#define BM_CAN_TIMER_TIMER   (0x0000FFFFU) /*!< Bit mask for CAN_TIMER_TIMER. */
#define BS_CAN_TIMER_TIMER   (16U)         /*!< Bit field size in bits for CAN_TIMER_TIMER. */

/*! @brief Read current value of the CAN_TIMER_TIMER field. */
#define BR_CAN_TIMER_TIMER(x) (HW_CAN_TIMER(x).B.TIMER)

/*! @brief Format value for bitfield CAN_TIMER_TIMER. */
#define BF_CAN_TIMER_TIMER(v) ((uint32_t)((uint32_t)(v) << BP_CAN_TIMER_TIMER) & BM_CAN_TIMER_TIMER)

/*! @brief Set the TIMER field to a new value. */
#define BW_CAN_TIMER_TIMER(x, v) (HW_CAN_TIMER_WR(x, (HW_CAN_TIMER_RD(x) & ~BM_CAN_TIMER_TIMER) | BF_CAN_TIMER_TIMER(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_RXMGMASK - Rx Mailboxes Global Mask Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_RXMGMASK - Rx Mailboxes Global Mask Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * RXMGMASK is provided for legacy support. Asserting the MCR[IRMQ] bit causes
 * the RXMGMASK Register to have no effect on the module operation. RXMGMASK is
 * used to mask the filter fields of all Rx MBs, excluding MBs 14-15, which have
 * individual mask registers. This register can only be written in Freeze mode as
 * it is blocked by hardware in other modes. Rx Mailboxes Global Mask usage
 * SMB[RTR]RTR bit of the Incoming Frame. It is saved into an auxiliary MB called Rx
 * Serial Message Buffer (Rx SMB). CTRL2[RRS] CTRL2[EACEN] Mailbox filter fields
 * MB[RTR] MB[IDE] MB[ID] reserved 0 - 0 - NoteIf CTRL2[EACEN] bit is negated the
 * RTR bit of Mailbox is never compared with the RTR bit of the Incoming Frame (Rx
 * SMB[RTR]). - NoteIf CTRL2[EACEN] bit is negated the IDE bit of Mailbox is
 * always compared with the IDE bit of the Incoming Frame (Rx SMB[IDE]). MG[28:0]
 * MG[31:29] 0 - 1 MG[31] MG[30] MG[28:0] MG[29] 1 0 - - - - MG[31:0] 1 1 0 - -
 * MG[28:0] MG[31:29] 1 1 1 MG[31] MG[30] MG[28:0] MG[29]
 */
typedef union _hw_can_rxmgmask
{
    uint32_t U;
    struct _hw_can_rxmgmask_bitfields
    {
        uint32_t MG31_MG0 : 32;        /*!< [31:0]  */
    } B;
} hw_can_rxmgmask_t;

/*!
 * @name Constants and macros for entire CAN_RXMGMASK register
 */
/*@{*/
#define HW_CAN_RXMGMASK_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_CAN_RXMGMASK(x)       (*(__IO hw_can_rxmgmask_t *) HW_CAN_RXMGMASK_ADDR(x))
#define HW_CAN_RXMGMASK_RD(x)    (HW_CAN_RXMGMASK(x).U)
#define HW_CAN_RXMGMASK_WR(x, v) (HW_CAN_RXMGMASK(x).U = (v))
#define HW_CAN_RXMGMASK_SET(x, v) (HW_CAN_RXMGMASK_WR(x, HW_CAN_RXMGMASK_RD(x) |  (v)))
#define HW_CAN_RXMGMASK_CLR(x, v) (HW_CAN_RXMGMASK_WR(x, HW_CAN_RXMGMASK_RD(x) & ~(v)))
#define HW_CAN_RXMGMASK_TOG(x, v) (HW_CAN_RXMGMASK_WR(x, HW_CAN_RXMGMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_RXMGMASK bitfields
 */

/*!
 * @name Register CAN_RXMGMASK, field MG31_MG0[31:0] (RW)
 *
 * These bits mask the Mailbox filter bits as shown in the figure above. Note
 * that the alignment with the ID word of the Mailbox is not perfect as the two
 * most significant MG bits affect the fields RTR and IDE which are located in the
 * Control and Status word of the Mailbox. RXMGMASKRx Mailboxes Global Mask
 * Register shows in detail which MG bits mask each Mailbox filter field.
 *
 * Values:
 * - 1 - The corresponding bit in the filter is checked against the one received
 * - 0 - the corresponding bit in the filter is "don't care"
 */
/*@{*/
#define BP_CAN_RXMGMASK_MG31_MG0 (0U)      /*!< Bit position for CAN_RXMGMASK_MG31_MG0. */
#define BM_CAN_RXMGMASK_MG31_MG0 (0xFFFFFFFFU) /*!< Bit mask for CAN_RXMGMASK_MG31_MG0. */
#define BS_CAN_RXMGMASK_MG31_MG0 (32U)     /*!< Bit field size in bits for CAN_RXMGMASK_MG31_MG0. */

/*! @brief Read current value of the CAN_RXMGMASK_MG31_MG0 field. */
#define BR_CAN_RXMGMASK_MG31_MG0(x) (HW_CAN_RXMGMASK(x).U)

/*! @brief Format value for bitfield CAN_RXMGMASK_MG31_MG0. */
#define BF_CAN_RXMGMASK_MG31_MG0(v) ((uint32_t)((uint32_t)(v) << BP_CAN_RXMGMASK_MG31_MG0) & BM_CAN_RXMGMASK_MG31_MG0)

/*! @brief Set the MG31_MG0 field to a new value. */
#define BW_CAN_RXMGMASK_MG31_MG0(x, v) (HW_CAN_RXMGMASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_RX14MASK - Rx Buffer 14 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_RX14MASK - Rx Buffer 14 Mask Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * RX14MASK is provided for legacy support, asserting the MCR[IRMQ] bit causes
 * the RX14MASK to have no effect on the module operation. RX14MASK is used to
 * mask the filter fields of Message Buffer 14. This register can only be programmed
 * while the module is in Freeze Mode as it is blocked by hardware in other
 * modes.
 */
typedef union _hw_can_rx14mask
{
    uint32_t U;
    struct _hw_can_rx14mask_bitfields
    {
        uint32_t RX14M31_RX14M0 : 32;  /*!< [31:0]  */
    } B;
} hw_can_rx14mask_t;

/*!
 * @name Constants and macros for entire CAN_RX14MASK register
 */
/*@{*/
#define HW_CAN_RX14MASK_ADDR(x)  ((uintptr_t)(x) + 0x14U)

#define HW_CAN_RX14MASK(x)       (*(__IO hw_can_rx14mask_t *) HW_CAN_RX14MASK_ADDR(x))
#define HW_CAN_RX14MASK_RD(x)    (HW_CAN_RX14MASK(x).U)
#define HW_CAN_RX14MASK_WR(x, v) (HW_CAN_RX14MASK(x).U = (v))
#define HW_CAN_RX14MASK_SET(x, v) (HW_CAN_RX14MASK_WR(x, HW_CAN_RX14MASK_RD(x) |  (v)))
#define HW_CAN_RX14MASK_CLR(x, v) (HW_CAN_RX14MASK_WR(x, HW_CAN_RX14MASK_RD(x) & ~(v)))
#define HW_CAN_RX14MASK_TOG(x, v) (HW_CAN_RX14MASK_WR(x, HW_CAN_RX14MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_RX14MASK bitfields
 */

/*!
 * @name Register CAN_RX14MASK, field RX14M31_RX14M0[31:0] (RW)
 *
 * These bits mask Mailbox 14 filter bits in the same fashion as RXMGMASK masks
 * other Mailboxes filters (see RXMGMASKRx Mailboxes Global Mask Register )
 *
 * Values:
 * - 1 - The corresponding bit in the filter is checked
 * - 0 - the corresponding bit in the filter is "don't care"
 */
/*@{*/
#define BP_CAN_RX14MASK_RX14M31_RX14M0 (0U) /*!< Bit position for CAN_RX14MASK_RX14M31_RX14M0. */
#define BM_CAN_RX14MASK_RX14M31_RX14M0 (0xFFFFFFFFU) /*!< Bit mask for CAN_RX14MASK_RX14M31_RX14M0. */
#define BS_CAN_RX14MASK_RX14M31_RX14M0 (32U) /*!< Bit field size in bits for CAN_RX14MASK_RX14M31_RX14M0. */

/*! @brief Read current value of the CAN_RX14MASK_RX14M31_RX14M0 field. */
#define BR_CAN_RX14MASK_RX14M31_RX14M0(x) (HW_CAN_RX14MASK(x).U)

/*! @brief Format value for bitfield CAN_RX14MASK_RX14M31_RX14M0. */
#define BF_CAN_RX14MASK_RX14M31_RX14M0(v) ((uint32_t)((uint32_t)(v) << BP_CAN_RX14MASK_RX14M31_RX14M0) & BM_CAN_RX14MASK_RX14M31_RX14M0)

/*! @brief Set the RX14M31_RX14M0 field to a new value. */
#define BW_CAN_RX14MASK_RX14M31_RX14M0(x, v) (HW_CAN_RX14MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_RX15MASK - Rx Buffer 15 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_RX15MASK - Rx Buffer 15 Mask Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * RX15MASK is provided for legacy support, asserting the MCR[IRMQ] bit causes
 * the RX15MASK Register to have no effect on the module operation. RX15MASK is
 * used to mask the filter fields of Message Buffer 15. This register can only be
 * programmed while the module is in Freeze Mode as it is blocked by hardware in
 * other modes.
 */
typedef union _hw_can_rx15mask
{
    uint32_t U;
    struct _hw_can_rx15mask_bitfields
    {
        uint32_t RX15M31_RX15M0 : 32;  /*!< [31:0]  */
    } B;
} hw_can_rx15mask_t;

/*!
 * @name Constants and macros for entire CAN_RX15MASK register
 */
/*@{*/
#define HW_CAN_RX15MASK_ADDR(x)  ((uintptr_t)(x) + 0x18U)

#define HW_CAN_RX15MASK(x)       (*(__IO hw_can_rx15mask_t *) HW_CAN_RX15MASK_ADDR(x))
#define HW_CAN_RX15MASK_RD(x)    (HW_CAN_RX15MASK(x).U)
#define HW_CAN_RX15MASK_WR(x, v) (HW_CAN_RX15MASK(x).U = (v))
#define HW_CAN_RX15MASK_SET(x, v) (HW_CAN_RX15MASK_WR(x, HW_CAN_RX15MASK_RD(x) |  (v)))
#define HW_CAN_RX15MASK_CLR(x, v) (HW_CAN_RX15MASK_WR(x, HW_CAN_RX15MASK_RD(x) & ~(v)))
#define HW_CAN_RX15MASK_TOG(x, v) (HW_CAN_RX15MASK_WR(x, HW_CAN_RX15MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_RX15MASK bitfields
 */

/*!
 * @name Register CAN_RX15MASK, field RX15M31_RX15M0[31:0] (RW)
 *
 * These bits mask Mailbox 15 filter bits in the same fashion as RXMGMASK masks
 * other Mailboxes filters (see RXMGMASKRx Mailboxes Global Mask Register ).
 *
 * Values:
 * - 1 - The corresponding bit in the filter is checked
 * - 0 - the corresponding bit in the filter is "don't care"
 */
/*@{*/
#define BP_CAN_RX15MASK_RX15M31_RX15M0 (0U) /*!< Bit position for CAN_RX15MASK_RX15M31_RX15M0. */
#define BM_CAN_RX15MASK_RX15M31_RX15M0 (0xFFFFFFFFU) /*!< Bit mask for CAN_RX15MASK_RX15M31_RX15M0. */
#define BS_CAN_RX15MASK_RX15M31_RX15M0 (32U) /*!< Bit field size in bits for CAN_RX15MASK_RX15M31_RX15M0. */

/*! @brief Read current value of the CAN_RX15MASK_RX15M31_RX15M0 field. */
#define BR_CAN_RX15MASK_RX15M31_RX15M0(x) (HW_CAN_RX15MASK(x).U)

/*! @brief Format value for bitfield CAN_RX15MASK_RX15M31_RX15M0. */
#define BF_CAN_RX15MASK_RX15M31_RX15M0(v) ((uint32_t)((uint32_t)(v) << BP_CAN_RX15MASK_RX15M31_RX15M0) & BM_CAN_RX15MASK_RX15M31_RX15M0)

/*! @brief Set the RX15M31_RX15M0 field to a new value. */
#define BW_CAN_RX15MASK_RX15M31_RX15M0(x, v) (HW_CAN_RX15MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_ECR - Error Counter Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_ECR - Error Counter Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register has 2 8-bit fields reflecting the value of two FLEXCAN error
 * counters: Transmit Error Counter (Tx_Err_Counter field) and Receive Error
 * Counter (Rx_Err_Counter field). The rules for increasing and decreasing these
 * counters are described in the CAN protocol and are completely implemented in the
 * FLEXCAN module. Both counters are read only except in Freeze Mode, where they can
 * be written by the ARM. FLEXCAN responds to any bus state as described in the
 * protocol, e.g. transmit 'Error Active' or 'Error Passive' flag, delay its
 * transmission start time ('Error Passive') and avoid any influence on the bus when
 * in 'Bus Off' state. The following are the basic rules for FLEXCAN bus state
 * transitions. If the value of Tx_Err_Counter or Rx_Err_Counter increases to be
 * greater than or equal to 128, the FLT_CONF field in the Error and Status
 * Register is updated to reflect 'Error Passive' state. If the FLEXCAN state is 'Error
 * Passive', and either Tx_Err_Counter or Rx_Err_Counter decrements to a value
 * less than or equal to 127 while the other already satisfies this condition, the
 * FLT_CONF field in the Error and Status Register is updated to reflect 'Error
 * Active' state. If the value of Tx_Err_Counter increases to be greater than 255,
 * the FLT_CONF field in the Error and Status Register is updated to reflect
 * 'Bus Off' state, and an interrupt may be issued. The value of Tx_Err_Counter is
 * then reset to zero. If FLEXCAN is in 'Bus Off' state, then Tx_Err_Counter is
 * cascaded together with another internal counter to count the 128th occurrences
 * of 11 consecutive recessive bits on the bus. Hence, Tx_Err_Counter is reset to
 * zero and counts in a manner where the internal counter counts 11 such bits and
 * then wraps around while incrementing the Tx_Err_Counter. When Tx_Err_Counter
 * reaches the value of 128, the FLT_CONF field in the Error and Status Register
 * is updated to be 'Error Active' and both error counters are reset to zero. At
 * any instance of dominant bit following a stream of less than 11 consecutive
 * recessive bits, the internal counter resets itself to zero without affecting the
 * Tx_Err_Counter value. If during system start-up, only one node is operating,
 * then its Tx_Err_Counter increases in each message it is trying to transmit, as
 * a result of acknowledge errors (indicated by the ACK_ERR bit in the Error and
 * Status Register). After the transition to 'Error Passive' state, the
 * Tx_Err_Counter does not increment anymore by acknowledge errors. Therefore the device
 * never goes to the 'Bus Off' state. If the Rx_Err_Counter increases to a value
 * greater than 127, it is not incremented further, even if more errors are
 * detected while being a receiver. At the next successful message reception, the
 * counter is set to a value between 119 and 127 to resume to 'Error Active' state.
 */
typedef union _hw_can_ecr
{
    uint32_t U;
    struct _hw_can_ecr_bitfields
    {
        uint32_t Tx_Err_Counter : 8;   /*!< [7:0]  */
        uint32_t Rx_Err_Counter : 8;   /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_can_ecr_t;

/*!
 * @name Constants and macros for entire CAN_ECR register
 */
/*@{*/
#define HW_CAN_ECR_ADDR(x)       ((uintptr_t)(x) + 0x1CU)

#define HW_CAN_ECR(x)            (*(__IO hw_can_ecr_t *) HW_CAN_ECR_ADDR(x))
#define HW_CAN_ECR_RD(x)         (HW_CAN_ECR(x).U)
#define HW_CAN_ECR_WR(x, v)      (HW_CAN_ECR(x).U = (v))
#define HW_CAN_ECR_SET(x, v)     (HW_CAN_ECR_WR(x, HW_CAN_ECR_RD(x) |  (v)))
#define HW_CAN_ECR_CLR(x, v)     (HW_CAN_ECR_WR(x, HW_CAN_ECR_RD(x) & ~(v)))
#define HW_CAN_ECR_TOG(x, v)     (HW_CAN_ECR_WR(x, HW_CAN_ECR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_ECR bitfields
 */

/*!
 * @name Register CAN_ECR, field Tx_Err_Counter[7:0] (RW)
 *
 * Tx_Err_Counter
 */
/*@{*/
#define BP_CAN_ECR_Tx_Err_Counter (0U)     /*!< Bit position for CAN_ECR_Tx_Err_Counter. */
#define BM_CAN_ECR_Tx_Err_Counter (0x000000FFU) /*!< Bit mask for CAN_ECR_Tx_Err_Counter. */
#define BS_CAN_ECR_Tx_Err_Counter (8U)     /*!< Bit field size in bits for CAN_ECR_Tx_Err_Counter. */

/*! @brief Read current value of the CAN_ECR_Tx_Err_Counter field. */
#define BR_CAN_ECR_Tx_Err_Counter(x) (HW_CAN_ECR(x).B.Tx_Err_Counter)

/*! @brief Format value for bitfield CAN_ECR_Tx_Err_Counter. */
#define BF_CAN_ECR_Tx_Err_Counter(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ECR_Tx_Err_Counter) & BM_CAN_ECR_Tx_Err_Counter)

/*! @brief Set the Tx_Err_Counter field to a new value. */
#define BW_CAN_ECR_Tx_Err_Counter(x, v) (HW_CAN_ECR_WR(x, (HW_CAN_ECR_RD(x) & ~BM_CAN_ECR_Tx_Err_Counter) | BF_CAN_ECR_Tx_Err_Counter(v)))
/*@}*/

/*!
 * @name Register CAN_ECR, field Rx_Err_Counter[15:8] (RW)
 *
 * Rx_Err_Counter
 */
/*@{*/
#define BP_CAN_ECR_Rx_Err_Counter (8U)     /*!< Bit position for CAN_ECR_Rx_Err_Counter. */
#define BM_CAN_ECR_Rx_Err_Counter (0x0000FF00U) /*!< Bit mask for CAN_ECR_Rx_Err_Counter. */
#define BS_CAN_ECR_Rx_Err_Counter (8U)     /*!< Bit field size in bits for CAN_ECR_Rx_Err_Counter. */

/*! @brief Read current value of the CAN_ECR_Rx_Err_Counter field. */
#define BR_CAN_ECR_Rx_Err_Counter(x) (HW_CAN_ECR(x).B.Rx_Err_Counter)

/*! @brief Format value for bitfield CAN_ECR_Rx_Err_Counter. */
#define BF_CAN_ECR_Rx_Err_Counter(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ECR_Rx_Err_Counter) & BM_CAN_ECR_Rx_Err_Counter)

/*! @brief Set the Rx_Err_Counter field to a new value. */
#define BW_CAN_ECR_Rx_Err_Counter(x, v) (HW_CAN_ECR_WR(x, (HW_CAN_ECR_RD(x) & ~BM_CAN_ECR_Rx_Err_Counter) | BF_CAN_ECR_Rx_Err_Counter(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_ESR1 - Error and Status 1 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_ESR1 - Error and Status 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects various error conditions, some general status of the
 * device and it is the source of four interrupts to the ARM. The ARM read action
 * clears bits 15-10, therefore the reported error conditions (bits 15-10) are
 * those that occurred since the last time the ARM read this register. Bits 9-3 are
 * status bits. Some bits in this register are read-only and some are not.
 * FlexCAN State SYNCH IDLE TX RX FlexCAN state 0 0 0 0 Not synchronized to CAN bus 1
 * 1 x x Idle 1 0 1 0 Transmitting 1 0 0 1 Receiving other combinations Reserved
 */
typedef union _hw_can_esr1
{
    uint32_t U;
    struct _hw_can_esr1_bitfields
    {
        uint32_t WAK_INT : 1;          /*!< [0]  */
        uint32_t ERR_INT : 1;          /*!< [1]  */
        uint32_t BOFF_INT : 1;         /*!< [2]  */
        uint32_t RX : 1;               /*!< [3]  */
        uint32_t FLT_CONF : 2;         /*!< [5:4]  */
        uint32_t TX : 1;               /*!< [6]  */
        uint32_t IDLE : 1;             /*!< [7]  */
        uint32_t RX_WRN : 1;           /*!< [8]  */
        uint32_t TX_WRN : 1;           /*!< [9]  */
        uint32_t STF_ERR : 1;          /*!< [10]  */
        uint32_t FRM_ERR : 1;          /*!< [11]  */
        uint32_t CRC_ERR : 1;          /*!< [12]  */
        uint32_t ACK_ERR : 1;          /*!< [13]  */
        uint32_t BIT0_ERR : 1;         /*!< [14]  */
        uint32_t BIT1_ERR : 1;         /*!< [15]  */
        uint32_t RWRN_INT : 1;         /*!< [16]  */
        uint32_t TWRN_INT : 1;         /*!< [17]  */
        uint32_t SYNCH : 1;            /*!< [18]  */
        uint32_t RESERVED0 : 13;       /*!< [31:19]  */
    } B;
} hw_can_esr1_t;

/*!
 * @name Constants and macros for entire CAN_ESR1 register
 */
/*@{*/
#define HW_CAN_ESR1_ADDR(x)      ((uintptr_t)(x) + 0x20U)

#define HW_CAN_ESR1(x)           (*(__IO hw_can_esr1_t *) HW_CAN_ESR1_ADDR(x))
#define HW_CAN_ESR1_RD(x)        (HW_CAN_ESR1(x).U)
#define HW_CAN_ESR1_WR(x, v)     (HW_CAN_ESR1(x).U = (v))
#define HW_CAN_ESR1_SET(x, v)    (HW_CAN_ESR1_WR(x, HW_CAN_ESR1_RD(x) |  (v)))
#define HW_CAN_ESR1_CLR(x, v)    (HW_CAN_ESR1_WR(x, HW_CAN_ESR1_RD(x) & ~(v)))
#define HW_CAN_ESR1_TOG(x, v)    (HW_CAN_ESR1_WR(x, HW_CAN_ESR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_ESR1 bitfields
 */

/*!
 * @name Register CAN_ESR1, field WAK_INT[0] (RW)
 *
 * When FLEXCAN is Stop Mode and a recessive to dominant transition is detected
 * on the CAN bus and if the WAK_MSK bit in the MCR Register is set, an interrupt
 * is generated to the ARM. This bit is cleared by writing it to '1'. When
 * SLF_WAK is negated, this flag is masked. ARM must clear this flag before disabling
 * the bit. Otherwise it will be set when the SLF_WAK is set again. Writing '0'
 * has no effect
 *
 * Values:
 * - 1 - Indicates a recessive to dominant transition received on the CAN bus
 *     when the FLEXCAN module is in Stop Mode
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_WAK_INT  (0U)          /*!< Bit position for CAN_ESR1_WAK_INT. */
#define BM_CAN_ESR1_WAK_INT  (0x00000001U) /*!< Bit mask for CAN_ESR1_WAK_INT. */
#define BS_CAN_ESR1_WAK_INT  (1U)          /*!< Bit field size in bits for CAN_ESR1_WAK_INT. */

/*! @brief Read current value of the CAN_ESR1_WAK_INT field. */
#define BR_CAN_ESR1_WAK_INT(x) (HW_CAN_ESR1(x).B.WAK_INT)

/*! @brief Format value for bitfield CAN_ESR1_WAK_INT. */
#define BF_CAN_ESR1_WAK_INT(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ESR1_WAK_INT) & BM_CAN_ESR1_WAK_INT)

/*! @brief Set the WAK_INT field to a new value. */
#define BW_CAN_ESR1_WAK_INT(x, v) (HW_CAN_ESR1_WR(x, (HW_CAN_ESR1_RD(x) & ~BM_CAN_ESR1_WAK_INT) | BF_CAN_ESR1_WAK_INT(v)))
/*@}*/

/*!
 * @name Register CAN_ESR1, field ERR_INT[1] (RW)
 *
 * This bit indicates that at least one of the Error Bits (bits 15-10) is set.
 * If the corresponding mask bit in the Control Register (ERR_MSK) is set, an
 * interrupt is generated to the ARM. This bit is cleared by writing it to
 * '1'.Writing '0' has no effect.
 *
 * Values:
 * - 1 - Indicates setting of any Error Bit in the Error and Status Register
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_ERR_INT  (1U)          /*!< Bit position for CAN_ESR1_ERR_INT. */
#define BM_CAN_ESR1_ERR_INT  (0x00000002U) /*!< Bit mask for CAN_ESR1_ERR_INT. */
#define BS_CAN_ESR1_ERR_INT  (1U)          /*!< Bit field size in bits for CAN_ESR1_ERR_INT. */

/*! @brief Read current value of the CAN_ESR1_ERR_INT field. */
#define BR_CAN_ESR1_ERR_INT(x) (HW_CAN_ESR1(x).B.ERR_INT)

/*! @brief Format value for bitfield CAN_ESR1_ERR_INT. */
#define BF_CAN_ESR1_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ESR1_ERR_INT) & BM_CAN_ESR1_ERR_INT)

/*! @brief Set the ERR_INT field to a new value. */
#define BW_CAN_ESR1_ERR_INT(x, v) (HW_CAN_ESR1_WR(x, (HW_CAN_ESR1_RD(x) & ~BM_CAN_ESR1_ERR_INT) | BF_CAN_ESR1_ERR_INT(v)))
/*@}*/

/*!
 * @name Register CAN_ESR1, field BOFF_INT[2] (RW)
 *
 * This bit is set when FLEXCAN enters 'Bus Off' state. If the corresponding
 * mask bit in the Control Register (BOFF_MSK) is set, an interrupt is generated to
 * the ARM. This bit is cleared by writing it to '1'. Writing '0' has no effect.
 *
 * Values:
 * - 1 - FLEXCAN module entered 'Bus Off' state
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_BOFF_INT (2U)          /*!< Bit position for CAN_ESR1_BOFF_INT. */
#define BM_CAN_ESR1_BOFF_INT (0x00000004U) /*!< Bit mask for CAN_ESR1_BOFF_INT. */
#define BS_CAN_ESR1_BOFF_INT (1U)          /*!< Bit field size in bits for CAN_ESR1_BOFF_INT. */

/*! @brief Read current value of the CAN_ESR1_BOFF_INT field. */
#define BR_CAN_ESR1_BOFF_INT(x) (HW_CAN_ESR1(x).B.BOFF_INT)

/*! @brief Format value for bitfield CAN_ESR1_BOFF_INT. */
#define BF_CAN_ESR1_BOFF_INT(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ESR1_BOFF_INT) & BM_CAN_ESR1_BOFF_INT)

/*! @brief Set the BOFF_INT field to a new value. */
#define BW_CAN_ESR1_BOFF_INT(x, v) (HW_CAN_ESR1_WR(x, (HW_CAN_ESR1_RD(x) & ~BM_CAN_ESR1_BOFF_INT) | BF_CAN_ESR1_BOFF_INT(v)))
/*@}*/

/*!
 * @name Register CAN_ESR1, field RX[3] (RO)
 *
 * This bit indicates if FlexCAN is receiving a message. Refer to .
 *
 * Values:
 * - 1 - FLEXCAN is transmitting a message
 * - 0 - FLEXCAN is receiving a message
 */
/*@{*/
#define BP_CAN_ESR1_RX       (3U)          /*!< Bit position for CAN_ESR1_RX. */
#define BM_CAN_ESR1_RX       (0x00000008U) /*!< Bit mask for CAN_ESR1_RX. */
#define BS_CAN_ESR1_RX       (1U)          /*!< Bit field size in bits for CAN_ESR1_RX. */

/*! @brief Read current value of the CAN_ESR1_RX field. */
#define BR_CAN_ESR1_RX(x)    (HW_CAN_ESR1(x).B.RX)
/*@}*/

/*!
 * @name Register CAN_ESR1, field FLT_CONF[5:4] (RO)
 *
 * If the LOM bit in the Control Register is asserted, after some delay that
 * depends on the CAN bit timing the FLT_CONF field will indicate "Error Passive".
 * The very same delay affects the way how FLT_CONF reflects an update to ECR
 * register by the ARM. It may be necessary up to one CAN bit time to get them
 * coherent again. Since the Control Register is not affected by soft reset, the
 * FLT_CONF field will not be affected by soft reset if the LOM bit is asserted. This
 * 2-bit field indicates the Confinement State of the FLEXCAN module, as shown in
 * below:
 *
 * Values:
 * - 00 - Error Active
 * - 01 - Error Passive
 * - 1x - Bus off
 */
/*@{*/
#define BP_CAN_ESR1_FLT_CONF (4U)          /*!< Bit position for CAN_ESR1_FLT_CONF. */
#define BM_CAN_ESR1_FLT_CONF (0x00000030U) /*!< Bit mask for CAN_ESR1_FLT_CONF. */
#define BS_CAN_ESR1_FLT_CONF (2U)          /*!< Bit field size in bits for CAN_ESR1_FLT_CONF. */

/*! @brief Read current value of the CAN_ESR1_FLT_CONF field. */
#define BR_CAN_ESR1_FLT_CONF(x) (HW_CAN_ESR1(x).B.FLT_CONF)
/*@}*/

/*!
 * @name Register CAN_ESR1, field TX[6] (RO)
 *
 * This bit indicates if FLEXCAN is transmitting a message.Refer to .
 *
 * Values:
 * - 1 - FLEXCAN is transmitting a message
 * - 0 - FLEXCAN is receiving a message
 */
/*@{*/
#define BP_CAN_ESR1_TX       (6U)          /*!< Bit position for CAN_ESR1_TX. */
#define BM_CAN_ESR1_TX       (0x00000040U) /*!< Bit mask for CAN_ESR1_TX. */
#define BS_CAN_ESR1_TX       (1U)          /*!< Bit field size in bits for CAN_ESR1_TX. */

/*! @brief Read current value of the CAN_ESR1_TX field. */
#define BR_CAN_ESR1_TX(x)    (HW_CAN_ESR1(x).B.TX)
/*@}*/

/*!
 * @name Register CAN_ESR1, field IDLE[7] (RO)
 *
 * This bit indicates when CAN bus is in IDLE state.Refer to .
 *
 * Values:
 * - 1 - CAN bus is now IDLE
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_IDLE     (7U)          /*!< Bit position for CAN_ESR1_IDLE. */
#define BM_CAN_ESR1_IDLE     (0x00000080U) /*!< Bit mask for CAN_ESR1_IDLE. */
#define BS_CAN_ESR1_IDLE     (1U)          /*!< Bit field size in bits for CAN_ESR1_IDLE. */

/*! @brief Read current value of the CAN_ESR1_IDLE field. */
#define BR_CAN_ESR1_IDLE(x)  (HW_CAN_ESR1(x).B.IDLE)
/*@}*/

/*!
 * @name Register CAN_ESR1, field RX_WRN[8] (RO)
 *
 * This bit indicates when repetitive errors are occurring during message
 * reception.
 *
 * Values:
 * - 1 - Rx_Err_Counter >= 96
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_RX_WRN   (8U)          /*!< Bit position for CAN_ESR1_RX_WRN. */
#define BM_CAN_ESR1_RX_WRN   (0x00000100U) /*!< Bit mask for CAN_ESR1_RX_WRN. */
#define BS_CAN_ESR1_RX_WRN   (1U)          /*!< Bit field size in bits for CAN_ESR1_RX_WRN. */

/*! @brief Read current value of the CAN_ESR1_RX_WRN field. */
#define BR_CAN_ESR1_RX_WRN(x) (HW_CAN_ESR1(x).B.RX_WRN)
/*@}*/

/*!
 * @name Register CAN_ESR1, field TX_WRN[9] (RO)
 *
 * This bit indicates when repetitive errors are occurring during message
 * transmission.
 *
 * Values:
 * - 1 - TX_Err_Counter >= 96
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_TX_WRN   (9U)          /*!< Bit position for CAN_ESR1_TX_WRN. */
#define BM_CAN_ESR1_TX_WRN   (0x00000200U) /*!< Bit mask for CAN_ESR1_TX_WRN. */
#define BS_CAN_ESR1_TX_WRN   (1U)          /*!< Bit field size in bits for CAN_ESR1_TX_WRN. */

/*! @brief Read current value of the CAN_ESR1_TX_WRN field. */
#define BR_CAN_ESR1_TX_WRN(x) (HW_CAN_ESR1(x).B.TX_WRN)
/*@}*/

/*!
 * @name Register CAN_ESR1, field STF_ERR[10] (RO)
 *
 * This bit indicates that a Stuffing Error has been detected.
 *
 * Values:
 * - 1 - A Stuffing Error occurred since last read of this register.
 * - 0 - No such occurrence.
 */
/*@{*/
#define BP_CAN_ESR1_STF_ERR  (10U)         /*!< Bit position for CAN_ESR1_STF_ERR. */
#define BM_CAN_ESR1_STF_ERR  (0x00000400U) /*!< Bit mask for CAN_ESR1_STF_ERR. */
#define BS_CAN_ESR1_STF_ERR  (1U)          /*!< Bit field size in bits for CAN_ESR1_STF_ERR. */

/*! @brief Read current value of the CAN_ESR1_STF_ERR field. */
#define BR_CAN_ESR1_STF_ERR(x) (HW_CAN_ESR1(x).B.STF_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field FRM_ERR[11] (RO)
 *
 * This bit indicates that a Form Error has been detected by the receiver node,
 * i.e., a fixed-form bit field contains at least one illegal bit.
 *
 * Values:
 * - 1 - A Form Error occurred since last read of this register
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_FRM_ERR  (11U)         /*!< Bit position for CAN_ESR1_FRM_ERR. */
#define BM_CAN_ESR1_FRM_ERR  (0x00000800U) /*!< Bit mask for CAN_ESR1_FRM_ERR. */
#define BS_CAN_ESR1_FRM_ERR  (1U)          /*!< Bit field size in bits for CAN_ESR1_FRM_ERR. */

/*! @brief Read current value of the CAN_ESR1_FRM_ERR field. */
#define BR_CAN_ESR1_FRM_ERR(x) (HW_CAN_ESR1(x).B.FRM_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field CRC_ERR[12] (RO)
 *
 * This bit indicates that a CRC Error has been detected by the receiver node,
 * i.e., the calculated CRC is different from the received.
 *
 * Values:
 * - 1 - A CRC error occurred since last read of this register.
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_CRC_ERR  (12U)         /*!< Bit position for CAN_ESR1_CRC_ERR. */
#define BM_CAN_ESR1_CRC_ERR  (0x00001000U) /*!< Bit mask for CAN_ESR1_CRC_ERR. */
#define BS_CAN_ESR1_CRC_ERR  (1U)          /*!< Bit field size in bits for CAN_ESR1_CRC_ERR. */

/*! @brief Read current value of the CAN_ESR1_CRC_ERR field. */
#define BR_CAN_ESR1_CRC_ERR(x) (HW_CAN_ESR1(x).B.CRC_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field ACK_ERR[13] (RO)
 *
 * This bit indicates that an Acknowledge Error has been detected by the
 * transmitter node, i.e., a dominant bit has not been detected during the ACK SLOT.
 *
 * Values:
 * - 1 - An ACK error occurred since last read of this register
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_ACK_ERR  (13U)         /*!< Bit position for CAN_ESR1_ACK_ERR. */
#define BM_CAN_ESR1_ACK_ERR  (0x00002000U) /*!< Bit mask for CAN_ESR1_ACK_ERR. */
#define BS_CAN_ESR1_ACK_ERR  (1U)          /*!< Bit field size in bits for CAN_ESR1_ACK_ERR. */

/*! @brief Read current value of the CAN_ESR1_ACK_ERR field. */
#define BR_CAN_ESR1_ACK_ERR(x) (HW_CAN_ESR1(x).B.ACK_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field BIT0_ERR[14] (RO)
 *
 * This bit indicates when an inconsistency occurs between the transmitted and
 * the received bit in a message.
 *
 * Values:
 * - 1 - At least one bit sent as dominant is received as recessive
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_BIT0_ERR (14U)         /*!< Bit position for CAN_ESR1_BIT0_ERR. */
#define BM_CAN_ESR1_BIT0_ERR (0x00004000U) /*!< Bit mask for CAN_ESR1_BIT0_ERR. */
#define BS_CAN_ESR1_BIT0_ERR (1U)          /*!< Bit field size in bits for CAN_ESR1_BIT0_ERR. */

/*! @brief Read current value of the CAN_ESR1_BIT0_ERR field. */
#define BR_CAN_ESR1_BIT0_ERR(x) (HW_CAN_ESR1(x).B.BIT0_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field BIT1_ERR[15] (RO)
 *
 * This bit indicates when an inconsistency occurs between the transmitted and
 * the received bit in a message. This bit is not set by a transmitter in case of
 * arbitration field or ACK slot, or in case of a node sending a passive error
 * flag that detects dominant bits.
 *
 * Values:
 * - 1 - At least one bit sent as recessive is received as dominant
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_BIT1_ERR (15U)         /*!< Bit position for CAN_ESR1_BIT1_ERR. */
#define BM_CAN_ESR1_BIT1_ERR (0x00008000U) /*!< Bit mask for CAN_ESR1_BIT1_ERR. */
#define BS_CAN_ESR1_BIT1_ERR (1U)          /*!< Bit field size in bits for CAN_ESR1_BIT1_ERR. */

/*! @brief Read current value of the CAN_ESR1_BIT1_ERR field. */
#define BR_CAN_ESR1_BIT1_ERR(x) (HW_CAN_ESR1(x).B.BIT1_ERR)
/*@}*/

/*!
 * @name Register CAN_ESR1, field RWRN_INT[16] (RW)
 *
 * If the WRN_EN bit in MCR is asserted, the RWRN_INT bit is set when the RX_WRN
 * flag transition from '0' to '1', meaning that the Rx error counters reached
 * 96. If the corresponding mask bit in the Control Register (RWRN_MSK) is set, an
 * interrupt is generated to the ARM. This bit is cleared by writing it to '1'.
 * When WRN_EN is negated, this flag is masked. ARM must clear this flag before
 * disabling the bit. Otherwise it will be set when the WRN_EN is set again.
 * Writing '0' has no effect. This bit is not updated during Freeze mode.
 *
 * Values:
 * - 1 - The Rx error counter transition from < 96 to >= 96
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_RWRN_INT (16U)         /*!< Bit position for CAN_ESR1_RWRN_INT. */
#define BM_CAN_ESR1_RWRN_INT (0x00010000U) /*!< Bit mask for CAN_ESR1_RWRN_INT. */
#define BS_CAN_ESR1_RWRN_INT (1U)          /*!< Bit field size in bits for CAN_ESR1_RWRN_INT. */

/*! @brief Read current value of the CAN_ESR1_RWRN_INT field. */
#define BR_CAN_ESR1_RWRN_INT(x) (HW_CAN_ESR1(x).B.RWRN_INT)

/*! @brief Format value for bitfield CAN_ESR1_RWRN_INT. */
#define BF_CAN_ESR1_RWRN_INT(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ESR1_RWRN_INT) & BM_CAN_ESR1_RWRN_INT)

/*! @brief Set the RWRN_INT field to a new value. */
#define BW_CAN_ESR1_RWRN_INT(x, v) (HW_CAN_ESR1_WR(x, (HW_CAN_ESR1_RD(x) & ~BM_CAN_ESR1_RWRN_INT) | BF_CAN_ESR1_RWRN_INT(v)))
/*@}*/

/*!
 * @name Register CAN_ESR1, field TWRN_INT[17] (RW)
 *
 * If the WRN_EN bit in MCR is asserted, the TWRN_INT bit is set when the TX_WRN
 * flag transition from '0' to '1', meaning that the Tx error counter reached
 * 96. If the corresponding mask bit in the Control Register (TWRN_MSK) is set, an
 * interrupt is generated to the ARM. This bit is cleared by writing it to '1'.
 * When WRN_EN is negated, this flag is masked. ARM must clear this flag before
 * disabling the bit. Otherwise it will be set when the WRN_EN is set again.
 * Writing '0' has no effect. This flag is not generated during "Bus Off" state. This
 * bit is not updated during Freeze mode.
 *
 * Values:
 * - 1 - The Tx error counter transition from < 96 to >= 96
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_ESR1_TWRN_INT (17U)         /*!< Bit position for CAN_ESR1_TWRN_INT. */
#define BM_CAN_ESR1_TWRN_INT (0x00020000U) /*!< Bit mask for CAN_ESR1_TWRN_INT. */
#define BS_CAN_ESR1_TWRN_INT (1U)          /*!< Bit field size in bits for CAN_ESR1_TWRN_INT. */

/*! @brief Read current value of the CAN_ESR1_TWRN_INT field. */
#define BR_CAN_ESR1_TWRN_INT(x) (HW_CAN_ESR1(x).B.TWRN_INT)

/*! @brief Format value for bitfield CAN_ESR1_TWRN_INT. */
#define BF_CAN_ESR1_TWRN_INT(v) ((uint32_t)((uint32_t)(v) << BP_CAN_ESR1_TWRN_INT) & BM_CAN_ESR1_TWRN_INT)

/*! @brief Set the TWRN_INT field to a new value. */
#define BW_CAN_ESR1_TWRN_INT(x, v) (HW_CAN_ESR1_WR(x, (HW_CAN_ESR1_RD(x) & ~BM_CAN_ESR1_TWRN_INT) | BF_CAN_ESR1_TWRN_INT(v)))
/*@}*/

/*!
 * @name Register CAN_ESR1, field SYNCH[18] (RO)
 *
 * This read-only flag indicates whether the FlexCAN is synchronized to the CAN
 * bus and able to participate in the communication process. It is set and
 * cleared by the FlexCAN. Refer to
 *
 * Values:
 * - 1 - FlexCAN is synchronized to the CAN bus
 * - 0 - FlexCAN is not synchronized to the CAN bus
 */
/*@{*/
#define BP_CAN_ESR1_SYNCH    (18U)         /*!< Bit position for CAN_ESR1_SYNCH. */
#define BM_CAN_ESR1_SYNCH    (0x00040000U) /*!< Bit mask for CAN_ESR1_SYNCH. */
#define BS_CAN_ESR1_SYNCH    (1U)          /*!< Bit field size in bits for CAN_ESR1_SYNCH. */

/*! @brief Read current value of the CAN_ESR1_SYNCH field. */
#define BR_CAN_ESR1_SYNCH(x) (HW_CAN_ESR1(x).B.SYNCH)
/*@}*/

/*******************************************************************************
 * HW_CAN_IMASK2 - Interrupt Masks 2 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_IMASK2 - Interrupt Masks 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register allows any number of a range of 32 Message Buffer Interrupts to
 * be enabled or disabled. It contains one interrupt mask bit per buffer,
 * enabling the ARM to determine which buffer generates an interrupt after a successful
 * transmission or reception (i.e. when the corresponding IFLAG2 bit is set).
 */
typedef union _hw_can_imask2
{
    uint32_t U;
    struct _hw_can_imask2_bitfields
    {
        uint32_t BUF63M_BUF32M : 32;   /*!< [31:0]  */
    } B;
} hw_can_imask2_t;

/*!
 * @name Constants and macros for entire CAN_IMASK2 register
 */
/*@{*/
#define HW_CAN_IMASK2_ADDR(x)    ((uintptr_t)(x) + 0x24U)

#define HW_CAN_IMASK2(x)         (*(__IO hw_can_imask2_t *) HW_CAN_IMASK2_ADDR(x))
#define HW_CAN_IMASK2_RD(x)      (HW_CAN_IMASK2(x).U)
#define HW_CAN_IMASK2_WR(x, v)   (HW_CAN_IMASK2(x).U = (v))
#define HW_CAN_IMASK2_SET(x, v)  (HW_CAN_IMASK2_WR(x, HW_CAN_IMASK2_RD(x) |  (v)))
#define HW_CAN_IMASK2_CLR(x, v)  (HW_CAN_IMASK2_WR(x, HW_CAN_IMASK2_RD(x) & ~(v)))
#define HW_CAN_IMASK2_TOG(x, v)  (HW_CAN_IMASK2_WR(x, HW_CAN_IMASK2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_IMASK2 bitfields
 */

/*!
 * @name Register CAN_IMASK2, field BUF63M_BUF32M[31:0] (RW)
 *
 * Each bit enables or disables the respective FLEXCAN Message Buffer (MB32 to
 * MB63) Interrupt. Setting or clearing a bit in the IMASK2 Register can assert or
 * negate an interrupt request, if the corresponding IFLAG2 bit is set.
 *
 * Values:
 * - 1 - The corresponding buffer Interrupt is enabled
 * - 0 - The corresponding buffer Interrupt is disabled
 */
/*@{*/
#define BP_CAN_IMASK2_BUF63M_BUF32M (0U)   /*!< Bit position for CAN_IMASK2_BUF63M_BUF32M. */
#define BM_CAN_IMASK2_BUF63M_BUF32M (0xFFFFFFFFU) /*!< Bit mask for CAN_IMASK2_BUF63M_BUF32M. */
#define BS_CAN_IMASK2_BUF63M_BUF32M (32U)  /*!< Bit field size in bits for CAN_IMASK2_BUF63M_BUF32M. */

/*! @brief Read current value of the CAN_IMASK2_BUF63M_BUF32M field. */
#define BR_CAN_IMASK2_BUF63M_BUF32M(x) (HW_CAN_IMASK2(x).U)

/*! @brief Format value for bitfield CAN_IMASK2_BUF63M_BUF32M. */
#define BF_CAN_IMASK2_BUF63M_BUF32M(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IMASK2_BUF63M_BUF32M) & BM_CAN_IMASK2_BUF63M_BUF32M)

/*! @brief Set the BUF63M_BUF32M field to a new value. */
#define BW_CAN_IMASK2_BUF63M_BUF32M(x, v) (HW_CAN_IMASK2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_IMASK1 - Interrupt Masks 1 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_IMASK1 - Interrupt Masks 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register allows to enable or disable any number of a range of 32 Message
 * Buffer Interrupts. It contains one interrupt mask bit per buffer, enabling
 * the ARM to determine which buffer generates an interrupt after a successful
 * transmission or reception (i.e., when the corresponding IFLAG1 bit is set).
 */
typedef union _hw_can_imask1
{
    uint32_t U;
    struct _hw_can_imask1_bitfields
    {
        uint32_t BUF31M_BUF0M : 32;    /*!< [31:0]  */
    } B;
} hw_can_imask1_t;

/*!
 * @name Constants and macros for entire CAN_IMASK1 register
 */
/*@{*/
#define HW_CAN_IMASK1_ADDR(x)    ((uintptr_t)(x) + 0x28U)

#define HW_CAN_IMASK1(x)         (*(__IO hw_can_imask1_t *) HW_CAN_IMASK1_ADDR(x))
#define HW_CAN_IMASK1_RD(x)      (HW_CAN_IMASK1(x).U)
#define HW_CAN_IMASK1_WR(x, v)   (HW_CAN_IMASK1(x).U = (v))
#define HW_CAN_IMASK1_SET(x, v)  (HW_CAN_IMASK1_WR(x, HW_CAN_IMASK1_RD(x) |  (v)))
#define HW_CAN_IMASK1_CLR(x, v)  (HW_CAN_IMASK1_WR(x, HW_CAN_IMASK1_RD(x) & ~(v)))
#define HW_CAN_IMASK1_TOG(x, v)  (HW_CAN_IMASK1_WR(x, HW_CAN_IMASK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_IMASK1 bitfields
 */

/*!
 * @name Register CAN_IMASK1, field BUF31M_BUF0M[31:0] (RW)
 *
 * Each bit enables or disables the respective FLEXCAN Message Buffer (MB0 to
 * MB31) Interrupt. Setting or clearing a bit in the IMASK1 Register can assert or
 * negate an interrupt request, if the corresponding IFLAG1 bit is set
 *
 * Values:
 * - 1 - The corresponding buffer Interrupt is enabled
 * - 0 - The corresponding buffer Interrupt is disabled
 */
/*@{*/
#define BP_CAN_IMASK1_BUF31M_BUF0M (0U)    /*!< Bit position for CAN_IMASK1_BUF31M_BUF0M. */
#define BM_CAN_IMASK1_BUF31M_BUF0M (0xFFFFFFFFU) /*!< Bit mask for CAN_IMASK1_BUF31M_BUF0M. */
#define BS_CAN_IMASK1_BUF31M_BUF0M (32U)   /*!< Bit field size in bits for CAN_IMASK1_BUF31M_BUF0M. */

/*! @brief Read current value of the CAN_IMASK1_BUF31M_BUF0M field. */
#define BR_CAN_IMASK1_BUF31M_BUF0M(x) (HW_CAN_IMASK1(x).U)

/*! @brief Format value for bitfield CAN_IMASK1_BUF31M_BUF0M. */
#define BF_CAN_IMASK1_BUF31M_BUF0M(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IMASK1_BUF31M_BUF0M) & BM_CAN_IMASK1_BUF31M_BUF0M)

/*! @brief Set the BUF31M_BUF0M field to a new value. */
#define BW_CAN_IMASK1_BUF31M_BUF0M(x, v) (HW_CAN_IMASK1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_IFLAG2 - Interrupt Flags 2 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_IFLAG2 - Interrupt Flags 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the flags for 32 Message Buffer interrupts. It contains
 * one interrupt flag bit per buffer. Each successful transmission or reception
 * sets the corresponding IFLAG2 bit. If the corresponding IMASK2 bit is set, an
 * interrupt will be generated. The interrupt flag must be cleared by writing it
 * to '1'. Writing '0' has no effect.Before updating MCR[MAXMB] field, ARM must
 * treat the IFLAG2 bits which MB value is greater than the MCR[MAXMB] to be
 * updated, otherwise they will keep set and be inconsistent with the amount of MBs
 * available.
 */
typedef union _hw_can_iflag2
{
    uint32_t U;
    struct _hw_can_iflag2_bitfields
    {
        uint32_t BUF63I_BUF32I : 32;   /*!< [31:0]  */
    } B;
} hw_can_iflag2_t;

/*!
 * @name Constants and macros for entire CAN_IFLAG2 register
 */
/*@{*/
#define HW_CAN_IFLAG2_ADDR(x)    ((uintptr_t)(x) + 0x2CU)

#define HW_CAN_IFLAG2(x)         (*(__IO hw_can_iflag2_t *) HW_CAN_IFLAG2_ADDR(x))
#define HW_CAN_IFLAG2_RD(x)      (HW_CAN_IFLAG2(x).U)
#define HW_CAN_IFLAG2_WR(x, v)   (HW_CAN_IFLAG2(x).U = (v))
#define HW_CAN_IFLAG2_SET(x, v)  (HW_CAN_IFLAG2_WR(x, HW_CAN_IFLAG2_RD(x) |  (v)))
#define HW_CAN_IFLAG2_CLR(x, v)  (HW_CAN_IFLAG2_WR(x, HW_CAN_IFLAG2_RD(x) & ~(v)))
#define HW_CAN_IFLAG2_TOG(x, v)  (HW_CAN_IFLAG2_WR(x, HW_CAN_IFLAG2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_IFLAG2 bitfields
 */

/*!
 * @name Register CAN_IFLAG2, field BUF63I_BUF32I[31:0] (RW)
 *
 * Each bit flags the respective FLEXCAN Message Buffer (MB32 to MB63) interrupt.
 *
 * Values:
 * - 1 - The corresponding buffer has successfully completed transmission or
 *     reception
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG2_BUF63I_BUF32I (0U)   /*!< Bit position for CAN_IFLAG2_BUF63I_BUF32I. */
#define BM_CAN_IFLAG2_BUF63I_BUF32I (0xFFFFFFFFU) /*!< Bit mask for CAN_IFLAG2_BUF63I_BUF32I. */
#define BS_CAN_IFLAG2_BUF63I_BUF32I (32U)  /*!< Bit field size in bits for CAN_IFLAG2_BUF63I_BUF32I. */

/*! @brief Read current value of the CAN_IFLAG2_BUF63I_BUF32I field. */
#define BR_CAN_IFLAG2_BUF63I_BUF32I(x) (HW_CAN_IFLAG2(x).U)

/*! @brief Format value for bitfield CAN_IFLAG2_BUF63I_BUF32I. */
#define BF_CAN_IFLAG2_BUF63I_BUF32I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG2_BUF63I_BUF32I) & BM_CAN_IFLAG2_BUF63I_BUF32I)

/*! @brief Set the BUF63I_BUF32I field to a new value. */
#define BW_CAN_IFLAG2_BUF63I_BUF32I(x, v) (HW_CAN_IFLAG2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_IFLAG1 - Interrupt Flags 1 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_IFLAG1 - Interrupt Flags 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the flags for 32 Message Buffer interrupts and FIFO
 * interrupts. It contains one interrupt flag bit per buffer. Each successful
 * transmission or reception sets the corresponding IFLAG1 bit. If the corresponding
 * IMASK1 bit is set, an interrupt will be generated. The Interrupt flag must be
 * cleared by writing it to '1'. Writing '0' has no effect. When the RFEN bit in
 * the MCR is set (Rx FIFO enabled), the function of the 8 least significant
 * interrupt flags (BUF7I - BUF0I) is changed to support the FIFO operation. BUF7I,
 * BUF6I and BUF5I indicate operating conditions of the FIFO, while BUF4I to BUF0I
 * are not used. Before enabling the RFEN, ARM must service the IFLAGS asserted in
 * the Rx FIFO region (see Rx FIFOThe receive-only FIFO is enabled by asserting
 * the RFEN bit in the MCR. ). Otherwise, these IFLAGS will mistakenly show the
 * related MBs now belonging to FIFO as having contents to be serviced. When the
 * RFEN is negated, the FIFO flags must be cleared. The same care must be taken
 * when a RFFN value is selected extending Rx FIFO filters beyond MB7 (see
 * CTRL2Control 2 Register ). For example, when RFFN is 0x8, the MB0-23 range is occupied
 * by Rx FIFO filters and related IFLAGS must be cleared. Before updating
 * MCR[MAXMB] field, ARM must service the IFLAG1 which MB value is greater than the
 * MCR[MAXMB] to be updated, otherwise they will keep set and be inconsistent with
 * the amount of MBs available.
 */
typedef union _hw_can_iflag1
{
    uint32_t U;
    struct _hw_can_iflag1_bitfields
    {
        uint32_t BUF4I_BUF0I : 5;      /*!< [4:0]  */
        uint32_t BUF5I : 1;            /*!< [5]  */
        uint32_t BUF6I : 1;            /*!< [6]  */
        uint32_t BUF7I : 1;            /*!< [7]  */
        uint32_t BUF31I_BUF8I : 24;    /*!< [31:8]  */
    } B;
} hw_can_iflag1_t;

/*!
 * @name Constants and macros for entire CAN_IFLAG1 register
 */
/*@{*/
#define HW_CAN_IFLAG1_ADDR(x)    ((uintptr_t)(x) + 0x30U)

#define HW_CAN_IFLAG1(x)         (*(__IO hw_can_iflag1_t *) HW_CAN_IFLAG1_ADDR(x))
#define HW_CAN_IFLAG1_RD(x)      (HW_CAN_IFLAG1(x).U)
#define HW_CAN_IFLAG1_WR(x, v)   (HW_CAN_IFLAG1(x).U = (v))
#define HW_CAN_IFLAG1_SET(x, v)  (HW_CAN_IFLAG1_WR(x, HW_CAN_IFLAG1_RD(x) |  (v)))
#define HW_CAN_IFLAG1_CLR(x, v)  (HW_CAN_IFLAG1_WR(x, HW_CAN_IFLAG1_RD(x) & ~(v)))
#define HW_CAN_IFLAG1_TOG(x, v)  (HW_CAN_IFLAG1_WR(x, HW_CAN_IFLAG1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_IFLAG1 bitfields
 */

/*!
 * @name Register CAN_IFLAG1, field BUF4I_BUF0I[4:0] (RW)
 *
 * If the Rx FIFO is not enabled, these bits flag the interrupts for MB0 to MB4.
 * If the Rx FIFO is enabled, these flags are not used and must be considered as
 * reserved locations. These flags are cleared by the FlexCAN whenever the bit
 * MCR[RFEN] is changed by ARM writes.
 *
 * Values:
 * - 1 - Corresponding MB completed transmission/reception
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG1_BUF4I_BUF0I (0U)     /*!< Bit position for CAN_IFLAG1_BUF4I_BUF0I. */
#define BM_CAN_IFLAG1_BUF4I_BUF0I (0x0000001FU) /*!< Bit mask for CAN_IFLAG1_BUF4I_BUF0I. */
#define BS_CAN_IFLAG1_BUF4I_BUF0I (5U)     /*!< Bit field size in bits for CAN_IFLAG1_BUF4I_BUF0I. */

/*! @brief Read current value of the CAN_IFLAG1_BUF4I_BUF0I field. */
#define BR_CAN_IFLAG1_BUF4I_BUF0I(x) (HW_CAN_IFLAG1(x).B.BUF4I_BUF0I)

/*! @brief Format value for bitfield CAN_IFLAG1_BUF4I_BUF0I. */
#define BF_CAN_IFLAG1_BUF4I_BUF0I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG1_BUF4I_BUF0I) & BM_CAN_IFLAG1_BUF4I_BUF0I)

/*! @brief Set the BUF4I_BUF0I field to a new value. */
#define BW_CAN_IFLAG1_BUF4I_BUF0I(x, v) (HW_CAN_IFLAG1_WR(x, (HW_CAN_IFLAG1_RD(x) & ~BM_CAN_IFLAG1_BUF4I_BUF0I) | BF_CAN_IFLAG1_BUF4I_BUF0I(v)))
/*@}*/

/*!
 * @name Register CAN_IFLAG1, field BUF5I[5] (RW)
 *
 * If the Rx FIFO is not enabled, this bit flags the interrupt for MB5. If the
 * Rx FIFO is enabled, this flag indicates that at least one frame is available to
 * be read from the Rx FIFO. This flag is cleared by the FlexCAN whenever the
 * bit MCR[RFEN] is changed by ARM writes.
 *
 * Values:
 * - 1 - MB5 completed transmission/reception or frames available in the FIFO
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG1_BUF5I  (5U)          /*!< Bit position for CAN_IFLAG1_BUF5I. */
#define BM_CAN_IFLAG1_BUF5I  (0x00000020U) /*!< Bit mask for CAN_IFLAG1_BUF5I. */
#define BS_CAN_IFLAG1_BUF5I  (1U)          /*!< Bit field size in bits for CAN_IFLAG1_BUF5I. */

/*! @brief Read current value of the CAN_IFLAG1_BUF5I field. */
#define BR_CAN_IFLAG1_BUF5I(x) (HW_CAN_IFLAG1(x).B.BUF5I)

/*! @brief Format value for bitfield CAN_IFLAG1_BUF5I. */
#define BF_CAN_IFLAG1_BUF5I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG1_BUF5I) & BM_CAN_IFLAG1_BUF5I)

/*! @brief Set the BUF5I field to a new value. */
#define BW_CAN_IFLAG1_BUF5I(x, v) (HW_CAN_IFLAG1_WR(x, (HW_CAN_IFLAG1_RD(x) & ~BM_CAN_IFLAG1_BUF5I) | BF_CAN_IFLAG1_BUF5I(v)))
/*@}*/

/*!
 * @name Register CAN_IFLAG1, field BUF6I[6] (RW)
 *
 * If the Rx FIFO is not enabled, this bit flags the interrupt for MB6. If the
 * MCR[RFEN] bit is asserted, this flag indicates when the number of unread
 * messages within the Rx FIFO is increased to 5 from 4 due to the reception of a new
 * one, meaning that the Rx FIFO is almost full. Note that if the flag is cleared
 * while the number of unread messages is greater than 4 it will not assert again
 * until the number of unread messages within the Rx FIFO is decreased to equal
 * or less than 4. This flag is cleared by the FlexCAN whenever the bit MCR[RFEN]
 * is changed by ARM writes.
 *
 * Values:
 * - 1 - MB6 completed transmission/reception or FIFO almost full
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG1_BUF6I  (6U)          /*!< Bit position for CAN_IFLAG1_BUF6I. */
#define BM_CAN_IFLAG1_BUF6I  (0x00000040U) /*!< Bit mask for CAN_IFLAG1_BUF6I. */
#define BS_CAN_IFLAG1_BUF6I  (1U)          /*!< Bit field size in bits for CAN_IFLAG1_BUF6I. */

/*! @brief Read current value of the CAN_IFLAG1_BUF6I field. */
#define BR_CAN_IFLAG1_BUF6I(x) (HW_CAN_IFLAG1(x).B.BUF6I)

/*! @brief Format value for bitfield CAN_IFLAG1_BUF6I. */
#define BF_CAN_IFLAG1_BUF6I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG1_BUF6I) & BM_CAN_IFLAG1_BUF6I)

/*! @brief Set the BUF6I field to a new value. */
#define BW_CAN_IFLAG1_BUF6I(x, v) (HW_CAN_IFLAG1_WR(x, (HW_CAN_IFLAG1_RD(x) & ~BM_CAN_IFLAG1_BUF6I) | BF_CAN_IFLAG1_BUF6I(v)))
/*@}*/

/*!
 * @name Register CAN_IFLAG1, field BUF7I[7] (RW)
 *
 * If the Rx FIFO is not enabled, this bit flags the interrupt for MB7. If the
 * MCR[RFEN] bit is asserted, this flag indicates that a message was lost because
 * Rx FIFO is full. Note that the flag will not be asserted when the Rx FIFO is
 * full and the message was captured by a Mailbox. This flag is cleared by the
 * FlexCAN whenever the bit MCR[RFEN] is changed by ARM writes.
 *
 * Values:
 * - 1 - MB7 completed transmission/reception or FIFO overflow
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG1_BUF7I  (7U)          /*!< Bit position for CAN_IFLAG1_BUF7I. */
#define BM_CAN_IFLAG1_BUF7I  (0x00000080U) /*!< Bit mask for CAN_IFLAG1_BUF7I. */
#define BS_CAN_IFLAG1_BUF7I  (1U)          /*!< Bit field size in bits for CAN_IFLAG1_BUF7I. */

/*! @brief Read current value of the CAN_IFLAG1_BUF7I field. */
#define BR_CAN_IFLAG1_BUF7I(x) (HW_CAN_IFLAG1(x).B.BUF7I)

/*! @brief Format value for bitfield CAN_IFLAG1_BUF7I. */
#define BF_CAN_IFLAG1_BUF7I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG1_BUF7I) & BM_CAN_IFLAG1_BUF7I)

/*! @brief Set the BUF7I field to a new value. */
#define BW_CAN_IFLAG1_BUF7I(x, v) (HW_CAN_IFLAG1_WR(x, (HW_CAN_IFLAG1_RD(x) & ~BM_CAN_IFLAG1_BUF7I) | BF_CAN_IFLAG1_BUF7I(v)))
/*@}*/

/*!
 * @name Register CAN_IFLAG1, field BUF31I_BUF8I[31:8] (RW)
 *
 * Each bit flags the respective FLEXCAN Message Buffer (MB8 to MB31) interrupt.
 *
 * Values:
 * - 1 - The corresponding MB has successfully completed transmission or
 *     reception
 * - 0 - No such occurrence
 */
/*@{*/
#define BP_CAN_IFLAG1_BUF31I_BUF8I (8U)    /*!< Bit position for CAN_IFLAG1_BUF31I_BUF8I. */
#define BM_CAN_IFLAG1_BUF31I_BUF8I (0xFFFFFF00U) /*!< Bit mask for CAN_IFLAG1_BUF31I_BUF8I. */
#define BS_CAN_IFLAG1_BUF31I_BUF8I (24U)   /*!< Bit field size in bits for CAN_IFLAG1_BUF31I_BUF8I. */

/*! @brief Read current value of the CAN_IFLAG1_BUF31I_BUF8I field. */
#define BR_CAN_IFLAG1_BUF31I_BUF8I(x) (HW_CAN_IFLAG1(x).B.BUF31I_BUF8I)

/*! @brief Format value for bitfield CAN_IFLAG1_BUF31I_BUF8I. */
#define BF_CAN_IFLAG1_BUF31I_BUF8I(v) ((uint32_t)((uint32_t)(v) << BP_CAN_IFLAG1_BUF31I_BUF8I) & BM_CAN_IFLAG1_BUF31I_BUF8I)

/*! @brief Set the BUF31I_BUF8I field to a new value. */
#define BW_CAN_IFLAG1_BUF31I_BUF8I(x, v) (HW_CAN_IFLAG1_WR(x, (HW_CAN_IFLAG1_RD(x) & ~BM_CAN_IFLAG1_BUF31I_BUF8I) | BF_CAN_IFLAG1_BUF31I_BUF8I(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_CTRL2 - Control 2 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_CTRL2 - Control 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains control bits for CAN errors, FIFO features and mode
 * selection. Rx FIFO Filters RFFN[3:0] Number of Rx FIFO filters Message Buffers
 * occupied by Rx FIFO and ID Filter Table Remaining Available Mailboxes The
 * number of the last remaining available mailboxes is defined by the MCR[MAXMB]
 * field. Rx FIFO ID Filter Table Elements Affected by Rx Individual Masks If Rx
 * Individual Mask Registers are not enabled then all Rx FIFO filters are affected by
 * the Rx FIFO Global Mask. Rx FIFO ID Filter Table Elements Affected by Rx FIFO
 * Global Mask 0x0 8 MB 0-7 MB 8-63 Elements 0-7 none 0x1 16 MB 0-9 MB 10-63
 * Elements 0-9 Elements 10-15 0x2 24 MB 0-11 MB 12-63 Elements 0-11 Elements 12-23
 * 0x3 32 MB 0-13 MB 14-63 Elements 0-13 Elements 14-31 0x4 40 MB 0-15 MB 16-63
 * Elements 0-15 Elements 16-39 0x5 48 MB 0-17 MB 18-63 Elements 0-17 Elements
 * 18-47 0x6 56 MB 0-19 MB 20-63 Elements 0-19 Elements 20-55 0x7 64 MB 0-21 MB 22-63
 * Elements 0-21 Elements 22-63 0x8 72 MB 0-23 MB 24-63 Elements 0-23 Elements
 * 24-71 0x9 80 MB 0-25 MB 26-63 Elements 0-25 Elements 26-79 0xA 88 MB 0-27 MB
 * 28-63 Elements 0-27 Elements 28-87 0xB 96 MB 0-29 MB 30-63 Elements 0-29
 * Elements 30-95 0xC 104 MB 0-31 MB 32-63 Elements 0-31 Elements 32-103 0xD 112 MB 0-33
 * MB 34-63 Elements 0-31 Elements 32-111 0xE 120 MB 0-35 MB 36-63 Elements 0-31
 * Elements 32-119 0xF 128 MB 0-37 MB 38-63 Elements 0-31 Elements 32-127 Each
 * group of eight filters occupies a memory space equivalent to two Message
 * Buffers which means that the more filters are implemented the less Mailboxes will be
 * available. Considering that the Rx FIFO occupies the memory space originally
 * reserved for MB0-5, RFFN should be programmed with a value corresponding to a
 * number of filters not greater than the number of available memory words which
 * can be calculated as follows: where SETUP_MB is MAXMB. The number of remaining
 * Mailboxes available will be: If the Number of Rx FIFO Filters programmed
 * through RFFN exceeds the SETUP_MB value, the exceeding ones will not be
 * functional.Unshaded regions in indicate the valid combinations of MAXMB, RFEN and RFFN,
 * shaded regions are not functional. Valid Combinations of MAXMB, RFEN and RFFN
 * RFFN 0 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 RFEN 0 1 1 1 1 1 1 1 1 1 1 1 1 1
 * 1 1 1 MAXMB 0 - 6 7 - 8 9 - 10 11 - 12 13 -14 15 - 16 17 -18 19 - 20 21 - 22
 * 23 - 24 25 - 26 27 - 28 29 -30 31 - 32 33 - 34 35 - 36 37 - 63
 */
typedef union _hw_can_ctrl2
{
    uint32_t U;
    struct _hw_can_ctrl2_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t EACEN : 1;            /*!< [16]  */
        uint32_t RRS : 1;              /*!< [17]  */
        uint32_t MRP : 1;              /*!< [18]  */
        uint32_t TASD : 5;             /*!< [23:19]  */
        uint32_t RFFN : 4;             /*!< [27:24]  */
        uint32_t WRMFRZ : 1;           /*!< [28]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_can_ctrl2_t;

/*!
 * @name Constants and macros for entire CAN_CTRL2 register
 */
/*@{*/
#define HW_CAN_CTRL2_ADDR(x)     ((uintptr_t)(x) + 0x34U)

#define HW_CAN_CTRL2(x)          (*(__IO hw_can_ctrl2_t *) HW_CAN_CTRL2_ADDR(x))
#define HW_CAN_CTRL2_RD(x)       (HW_CAN_CTRL2(x).U)
#define HW_CAN_CTRL2_WR(x, v)    (HW_CAN_CTRL2(x).U = (v))
#define HW_CAN_CTRL2_SET(x, v)   (HW_CAN_CTRL2_WR(x, HW_CAN_CTRL2_RD(x) |  (v)))
#define HW_CAN_CTRL2_CLR(x, v)   (HW_CAN_CTRL2_WR(x, HW_CAN_CTRL2_RD(x) & ~(v)))
#define HW_CAN_CTRL2_TOG(x, v)   (HW_CAN_CTRL2_WR(x, HW_CAN_CTRL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_CTRL2 bitfields
 */

/*!
 * @name Register CAN_CTRL2, field EACEN[16] (RW)
 *
 * This bit controls the comparison of IDE and RTR bits within Rx Mailboxes
 * filters with their corresponding bits in the incoming frame by the matching
 * process. This bit does not affect matching for Rx FIFO. This bit can only be written
 * in Freeze mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with
 *     their corresponding bits within the incoming frame. Mask bits do apply.
 * - 0 - Rx Mailbox filter's IDE bit is always compared and RTR is never
 *     compared despite mask bits.
 */
/*@{*/
#define BP_CAN_CTRL2_EACEN   (16U)         /*!< Bit position for CAN_CTRL2_EACEN. */
#define BM_CAN_CTRL2_EACEN   (0x00010000U) /*!< Bit mask for CAN_CTRL2_EACEN. */
#define BS_CAN_CTRL2_EACEN   (1U)          /*!< Bit field size in bits for CAN_CTRL2_EACEN. */

/*! @brief Read current value of the CAN_CTRL2_EACEN field. */
#define BR_CAN_CTRL2_EACEN(x) (HW_CAN_CTRL2(x).B.EACEN)

/*! @brief Format value for bitfield CAN_CTRL2_EACEN. */
#define BF_CAN_CTRL2_EACEN(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_EACEN) & BM_CAN_CTRL2_EACEN)

/*! @brief Set the EACEN field to a new value. */
#define BW_CAN_CTRL2_EACEN(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_EACEN) | BF_CAN_CTRL2_EACEN(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL2, field RRS[17] (RW)
 *
 * If this bit is asserted Remote Request Frame is submitted to a matching
 * process and stored in the corresponding Message Buffer in the same fashion of a
 * Data Frame. No automatic Remote Response Frame will be generated. If this bit is
 * negated the Remote Request Frame is submitted to a matching process and an
 * automatic Remote Response Frame is generated if a Message Buffer with CODE=0b1010
 * is found with the same ID. This bit can only be written in Freeze mode as it
 * is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Remote Request Frame is stored
 * - 0 - Remote Response Frame is generated
 */
/*@{*/
#define BP_CAN_CTRL2_RRS     (17U)         /*!< Bit position for CAN_CTRL2_RRS. */
#define BM_CAN_CTRL2_RRS     (0x00020000U) /*!< Bit mask for CAN_CTRL2_RRS. */
#define BS_CAN_CTRL2_RRS     (1U)          /*!< Bit field size in bits for CAN_CTRL2_RRS. */

/*! @brief Read current value of the CAN_CTRL2_RRS field. */
#define BR_CAN_CTRL2_RRS(x)  (HW_CAN_CTRL2(x).B.RRS)

/*! @brief Format value for bitfield CAN_CTRL2_RRS. */
#define BF_CAN_CTRL2_RRS(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_RRS) & BM_CAN_CTRL2_RRS)

/*! @brief Set the RRS field to a new value. */
#define BW_CAN_CTRL2_RRS(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_RRS) | BF_CAN_CTRL2_RRS(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL2, field MRP[18] (RW)
 *
 * If this bit is set the matching process starts from the Mailboxes and if no
 * match occurs the matching continues on the Rx FIFO. This bit can only be
 * written in Freeze mode as it is blocked by hardware in other modes.
 *
 * Values:
 * - 1 - Matching starts from Mailboxes and continues on Rx FIFO
 * - 0 - Matching starts from Rx FIFO and continues on Mailboxes
 */
/*@{*/
#define BP_CAN_CTRL2_MRP     (18U)         /*!< Bit position for CAN_CTRL2_MRP. */
#define BM_CAN_CTRL2_MRP     (0x00040000U) /*!< Bit mask for CAN_CTRL2_MRP. */
#define BS_CAN_CTRL2_MRP     (1U)          /*!< Bit field size in bits for CAN_CTRL2_MRP. */

/*! @brief Read current value of the CAN_CTRL2_MRP field. */
#define BR_CAN_CTRL2_MRP(x)  (HW_CAN_CTRL2(x).B.MRP)

/*! @brief Format value for bitfield CAN_CTRL2_MRP. */
#define BF_CAN_CTRL2_MRP(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_MRP) & BM_CAN_CTRL2_MRP)

/*! @brief Set the MRP field to a new value. */
#define BW_CAN_CTRL2_MRP(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_MRP) | BF_CAN_CTRL2_MRP(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL2, field TASD[23:19] (RW)
 *
 * This 5-bit field indicates how many CAN bits the Tx arbitration process start
 * point can be delayed from the first bit of CRC field on CAN bus. This field
 * can only be written in Freeze mode as it is blocked by hardware in other modes.
 * This field is useful to optimize the transmit performance based on factors
 * such as: peripheral/serial clock ratio, CAN bit timing and number of MBs. The
 * duration of an arbitration process, in terms of CAN bits, is directly
 * proportional to the number of available MBs and CAN baud rate and inversely proportional
 * to the peripheral clock frequency. The optimal arbitration timing is that in
 * which the last MB is scanned right before the first bit of the Intermission
 * field of a CAN frame. Therefore, if there are few MBs and the system/serial
 * clock ratio is high and the CAN baud rate is low then the arbitration can be
 * delayed and vice-versa. If TASD is 0 then the arbitration start is not delayed,
 * thus ARM has less time to configure a Tx MB for the next arbitration, but more
 * time is reserved for arbitration. In the other hand, if TASD is 24 then ARM can
 * configure a Tx MB later and less time is reserved for arbitration. If too
 * little time is reserved for arbitration the FlexCAN may be not able to find winner
 * MBs in time to compete with other nodes for the CAN bus. If the arbitration
 * ends too much time before the first bit of Intermission field then there is a
 * chance that ARM reconfigure some Tx MBs and the winner MB is not the best to be
 * transmitted. The reset value is different on various platforms, according to
 * their peripheral clock frequency, number of MBs and target CAN baud rate. The
 * optimal configuration for TASD can be calculated as: where: fCANCLK is the
 * Protocol Engine (PE) Clock in Hz; PE clock is derrived from CAN_CLK_ROOT in CCM.
 * See Clock Root GeneratorThe Clock Root Generator (CCM_CLK_ROOT_GEN) sub-module
 * generates the root clocks to be delivered to LPCG. fSYS is the peripheral
 * clock in Hz; MAXMB is the value in CTRL1[MAXMB] field; RFEN is the value in
 * CTRL1[RFEN] bit; RFFN is the value in CTRL2[RFFN] field; PSEG1 is the value in
 * CTRL1[PSEG1] field; PSEG2 is the value in CTRL1[PSEG2] field; PROPSEG is the value
 * in CTRL1[PROPSEG] field; PRESDIV is the value in CTRL1[PRESDIV] field. Please
 * refer to Arbitration processThe arbitration process scans the Mailboxes
 * searching the Tx one that holds the message to be sent in the next opportunity.
 * This Mailbox is called the arbitration winner. and Protocol Timing for more
 * details.
 */
/*@{*/
#define BP_CAN_CTRL2_TASD    (19U)         /*!< Bit position for CAN_CTRL2_TASD. */
#define BM_CAN_CTRL2_TASD    (0x00F80000U) /*!< Bit mask for CAN_CTRL2_TASD. */
#define BS_CAN_CTRL2_TASD    (5U)          /*!< Bit field size in bits for CAN_CTRL2_TASD. */

/*! @brief Read current value of the CAN_CTRL2_TASD field. */
#define BR_CAN_CTRL2_TASD(x) (HW_CAN_CTRL2(x).B.TASD)

/*! @brief Format value for bitfield CAN_CTRL2_TASD. */
#define BF_CAN_CTRL2_TASD(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_TASD) & BM_CAN_CTRL2_TASD)

/*! @brief Set the TASD field to a new value. */
#define BW_CAN_CTRL2_TASD(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_TASD) | BF_CAN_CTRL2_TASD(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL2, field RFFN[27:24] (RW)
 *
 * This 4-bit field defines the number of Rx FIFO filters according to . The
 * maximum selectable number of filters is determined by the ARM. This field can
 * only be written in Freeze mode as it is blocked by hardware in other modes. RFFN
 * defines a number of Message Buffers occupied by Rx FIFO and ID Filter (see )
 * that may not e xceed the number of available Mailboxes present in module,
 * defined by MCR[MAXMB].Default RFFN value is 0x0, which leads to a total of 8 Rx
 * FIFO filters, occupies the first 8 Message Buffers (MB 0-7) and makes available
 * the next Message Buffers (MB 8-63) for Mailboxes. As a second example, when
 * RFFN is set to 0xD, there will be 112 Rx FIFO filters, located in MB 0-33, and MB
 * 34-63 are available for Mailboxes. Notice that, in this case, individual
 * masks (RXIMR) will just cover Rx FIFO filters in 0-31 range, and filters 32-111
 * will use RXFGMASK. In case of reducing the number of last Message Buffers,
 * MCR[MAXMB] (see MCRModule Configuration Register ) can be adjusted by the
 * application to minimum of 33, in order to give room to the Rx FIFO and its ID Filter
 * Table defined by RFFN. On the contrary, if the application sets MCR[MAXMB] to
 * 16, for instance, the maximum RFFN is limited to 0x4. RFFN also impacts the
 * definition of the minimum number of peripheral clocks per CAN bit as described in
 * (see Arbitration and Matching Timing).
 */
/*@{*/
#define BP_CAN_CTRL2_RFFN    (24U)         /*!< Bit position for CAN_CTRL2_RFFN. */
#define BM_CAN_CTRL2_RFFN    (0x0F000000U) /*!< Bit mask for CAN_CTRL2_RFFN. */
#define BS_CAN_CTRL2_RFFN    (4U)          /*!< Bit field size in bits for CAN_CTRL2_RFFN. */

/*! @brief Read current value of the CAN_CTRL2_RFFN field. */
#define BR_CAN_CTRL2_RFFN(x) (HW_CAN_CTRL2(x).B.RFFN)

/*! @brief Format value for bitfield CAN_CTRL2_RFFN. */
#define BF_CAN_CTRL2_RFFN(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_RFFN) & BM_CAN_CTRL2_RFFN)

/*! @brief Set the RFFN field to a new value. */
#define BW_CAN_CTRL2_RFFN(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_RFFN) | BF_CAN_CTRL2_RFFN(v)))
/*@}*/

/*!
 * @name Register CAN_CTRL2, field WRMFRZ[28] (RW)
 *
 * Enable unrestricted write access to FlexCAN memory in Freeze mode. This bit
 * can only be written in Freeze mode and has no effect out of Freeze mode.
 *
 * Values:
 * - 1 - Enable unrestricted write access to FlexCAN memory
 * - 0 - Keep the write access restricted in some regions of FlexCAN memory
 */
/*@{*/
#define BP_CAN_CTRL2_WRMFRZ  (28U)         /*!< Bit position for CAN_CTRL2_WRMFRZ. */
#define BM_CAN_CTRL2_WRMFRZ  (0x10000000U) /*!< Bit mask for CAN_CTRL2_WRMFRZ. */
#define BS_CAN_CTRL2_WRMFRZ  (1U)          /*!< Bit field size in bits for CAN_CTRL2_WRMFRZ. */

/*! @brief Read current value of the CAN_CTRL2_WRMFRZ field. */
#define BR_CAN_CTRL2_WRMFRZ(x) (HW_CAN_CTRL2(x).B.WRMFRZ)

/*! @brief Format value for bitfield CAN_CTRL2_WRMFRZ. */
#define BF_CAN_CTRL2_WRMFRZ(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CTRL2_WRMFRZ) & BM_CAN_CTRL2_WRMFRZ)

/*! @brief Set the WRMFRZ field to a new value. */
#define BW_CAN_CTRL2_WRMFRZ(x, v) (HW_CAN_CTRL2_WR(x, (HW_CAN_CTRL2_RD(x) & ~BM_CAN_CTRL2_WRMFRZ) | BF_CAN_CTRL2_WRMFRZ(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_ESR2 - Error and Status 2 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_ESR2 - Error and Status 2 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects various interrupt flags and some general status.
 */
typedef union _hw_can_esr2
{
    uint32_t U;
    struct _hw_can_esr2_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t IMB : 1;              /*!< [13]  */
        uint32_t VPS : 1;              /*!< [14]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t LPTM : 7;             /*!< [22:16]  */
        uint32_t RESERVED2 : 9;        /*!< [31:23]  */
    } B;
} hw_can_esr2_t;

/*!
 * @name Constants and macros for entire CAN_ESR2 register
 */
/*@{*/
#define HW_CAN_ESR2_ADDR(x)      ((uintptr_t)(x) + 0x38U)

#define HW_CAN_ESR2(x)           (*(__I hw_can_esr2_t *) HW_CAN_ESR2_ADDR(x))
#define HW_CAN_ESR2_RD(x)        (HW_CAN_ESR2(x).U)
/*@}*/

/*
 * Constants & macros for individual CAN_ESR2 bitfields
 */

/*!
 * @name Register CAN_ESR2, field IMB[13] (RO)
 *
 * If ESR2[VPS] is asserted, this bit indicates whether there is any inactive
 * Mailbox (CODE field is either 0b1000 or 0b0000). This bit is asserted in the
 * following cases: (1) During arbitration, if a LPTM is found and it is inactive.
 * (2) If IMB is not asserted and a frame is transmitted successfully. (3) This
 * bit is cleared in all start of arbitration (see Arbitration processThe
 * arbitration process scans the Mailboxes searching the Tx one that holds the message to
 * be sent in the next opportunity. This Mailbox is called the arbitration
 * winner. ). LPTM mechanism have the following behavior: if a MB is successfully
 * transmitted and ESR2[IMB]=0 (no inactive Mailbox), then ESR2[VPS] and ESR2[IMB] are
 * asserted and the index related to the MB just transmitted is loaded into
 * ESR2[LPTM].
 *
 * Values:
 * - 1 - If ESR2[VPS] is asserted, there is at least one inactive Mailbox. LPTM
 *     content is the number of the first one.
 * - 0 - If ESR2[VPS] is asserted, the ESR2[LPTM] is not an inactive Mailbox.
 */
/*@{*/
#define BP_CAN_ESR2_IMB      (13U)         /*!< Bit position for CAN_ESR2_IMB. */
#define BM_CAN_ESR2_IMB      (0x00002000U) /*!< Bit mask for CAN_ESR2_IMB. */
#define BS_CAN_ESR2_IMB      (1U)          /*!< Bit field size in bits for CAN_ESR2_IMB. */

/*! @brief Read current value of the CAN_ESR2_IMB field. */
#define BR_CAN_ESR2_IMB(x)   (HW_CAN_ESR2(x).B.IMB)
/*@}*/

/*!
 * @name Register CAN_ESR2, field VPS[14] (RO)
 *
 * This bit indicates whether IMB and LPTM contents are currently valid or not.
 * VPS is asserted upon every complete Tx arbitration process unless the ARM
 * writes to Control and Status word of a Mailbox that has already been scanned (i.e.
 * it is behind Tx Arbitration Pointer) during the Tx arbitration process. If
 * there is no inactive Mailbox and only one Tx Mailbox which is being transmitted
 * then VPS is not asserted. VPS is negated upon the start of every Tx
 * arbitration process or upon a write to Control and Status word of any Mailbox.ESR2[VPS]
 * is not affected by any ARM write into Control Status (C/S) of a MB which is
 * blocked by abort mechanism. When MCR[AEN] is asserted, the abort code write in
 * C/S of a MB that is been transmitted (pending abort), or any write attempt into
 * a Tx MB with IFLAG set is blocked.
 *
 * Values:
 * - 1 - Contents of IMB and LPTM are valid
 * - 0 - Contents of IMB and LPTM are invalid
 */
/*@{*/
#define BP_CAN_ESR2_VPS      (14U)         /*!< Bit position for CAN_ESR2_VPS. */
#define BM_CAN_ESR2_VPS      (0x00004000U) /*!< Bit mask for CAN_ESR2_VPS. */
#define BS_CAN_ESR2_VPS      (1U)          /*!< Bit field size in bits for CAN_ESR2_VPS. */

/*! @brief Read current value of the CAN_ESR2_VPS field. */
#define BR_CAN_ESR2_VPS(x)   (HW_CAN_ESR2(x).B.VPS)
/*@}*/

/*!
 * @name Register CAN_ESR2, field LPTM[22:16] (RO)
 *
 * If ESR2[VPS] is asserted, his 7-bit field indicates the lowest number
 * inactive Mailbox (refer to IMB bit description). If there is no inactive Mailbox then
 * the Mailbox indicated depends on CTRL1[LBUF] bit value. If CTRL1[LBUF] bit is
 * negated then the Mailbox indicated is the one which has the greatest
 * arbitration value (see Highest Mailbox priority firstIf CTRL1[LBUF] bit is negated
 * then the arbitration process searches the active Tx Mailbox with the highest
 * priority, and this Mailbox would have a higher probability to win the arbitration
 * on CAN bus. ). If CTRL1[LBUF] bit is asserted then the Mailbox indicated is
 * the highest number active Tx Mailbox. If a Tx Mailbox is being transmitted it is
 * not considered in LPTM calculation. If ESR2[IMB] is not asserted and a frame
 * is transmitted successfully, LPTM is updated with its Mailbox number.
 */
/*@{*/
#define BP_CAN_ESR2_LPTM     (16U)         /*!< Bit position for CAN_ESR2_LPTM. */
#define BM_CAN_ESR2_LPTM     (0x007F0000U) /*!< Bit mask for CAN_ESR2_LPTM. */
#define BS_CAN_ESR2_LPTM     (7U)          /*!< Bit field size in bits for CAN_ESR2_LPTM. */

/*! @brief Read current value of the CAN_ESR2_LPTM field. */
#define BR_CAN_ESR2_LPTM(x)  (HW_CAN_ESR2(x).B.LPTM)
/*@}*/

/*******************************************************************************
 * HW_CAN_CRCR - CRC Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_CRCR - CRC Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register provides information about the CRC of transmitted messages
 */
typedef union _hw_can_crcr
{
    uint32_t U;
    struct _hw_can_crcr_bitfields
    {
        uint32_t TXCRC : 15;           /*!< [14:0]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MBCRC : 7;            /*!< [22:16]  */
        uint32_t RESERVED1 : 9;        /*!< [31:23]  */
    } B;
} hw_can_crcr_t;

/*!
 * @name Constants and macros for entire CAN_CRCR register
 */
/*@{*/
#define HW_CAN_CRCR_ADDR(x)      ((uintptr_t)(x) + 0x44U)

#define HW_CAN_CRCR(x)           (*(__I hw_can_crcr_t *) HW_CAN_CRCR_ADDR(x))
#define HW_CAN_CRCR_RD(x)        (HW_CAN_CRCR(x).U)
/*@}*/

/*
 * Constants & macros for individual CAN_CRCR bitfields
 */

/*!
 * @name Register CAN_CRCR, field TXCRC[14:0] (RO)
 *
 * This field indicates the CRC value of the last message transmitted. This
 * field is updated at the same time the Tx Interrupt Flag is asserted.
 */
/*@{*/
#define BP_CAN_CRCR_TXCRC    (0U)          /*!< Bit position for CAN_CRCR_TXCRC. */
#define BM_CAN_CRCR_TXCRC    (0x00007FFFU) /*!< Bit mask for CAN_CRCR_TXCRC. */
#define BS_CAN_CRCR_TXCRC    (15U)         /*!< Bit field size in bits for CAN_CRCR_TXCRC. */

/*! @brief Read current value of the CAN_CRCR_TXCRC field. */
#define BR_CAN_CRCR_TXCRC(x) (HW_CAN_CRCR(x).B.TXCRC)
/*@}*/

/*!
 * @name Register CAN_CRCR, field MBCRC[22:16] (RO)
 *
 * This field indicates the number of the Mailbox corresponding to the value in
 * TXCRC field.
 */
/*@{*/
#define BP_CAN_CRCR_MBCRC    (16U)         /*!< Bit position for CAN_CRCR_MBCRC. */
#define BM_CAN_CRCR_MBCRC    (0x007F0000U) /*!< Bit mask for CAN_CRCR_MBCRC. */
#define BS_CAN_CRCR_MBCRC    (7U)          /*!< Bit field size in bits for CAN_CRCR_MBCRC. */

/*! @brief Read current value of the CAN_CRCR_MBCRC field. */
#define BR_CAN_CRCR_MBCRC(x) (HW_CAN_CRCR(x).B.MBCRC)
/*@}*/

/*******************************************************************************
 * HW_CAN_RXFGMASK - Rx FIFO Global Mask Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_RXFGMASK - Rx FIFO Global Mask Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * If Rx FIFO is enabled RXFGMASK is used to mask the Rx FIFO ID Filter Table
 * elements that do not have a corresponding RXIMR according to CTRL2[RFFN] field
 * setting. This register can only be written in Freeze Mode as it is blocked by
 * hardware in other modes. Rx FIFO Global Mask usage Rx FIFO ID Filter Table
 * Elements Format (MCR[IDAM]) Identifier Acceptance Filter fields RTR IDE RXIDA
 * RXIDB RXIDC reserved A FGM[31] FGM[30] FGM[29:1] - - FGM[0] B FGM[31] FGM[15]
 * FGM[30] FGM[14] - FGM[29:16] FGM[13:0] If MCR[IDAM] field is equivalent to the
 * format B only the fourteen most significant bits of the Identifier of the
 * incoming frame are compared with the Rx FIFO filter. - C - - - FGM[31:24] FGM[23:16]
 * FGM[15:8] FGM[7:0] If MCR[IDAM] field is equivalent to the format C only the
 * eight most significant bits of the Identifier of the incoming frame are
 * compared with the Rx FIFO filter.
 */
typedef union _hw_can_rxfgmask
{
    uint32_t U;
    struct _hw_can_rxfgmask_bitfields
    {
        uint32_t FGM31_FGM0 : 32;      /*!< [31:0]  */
    } B;
} hw_can_rxfgmask_t;

/*!
 * @name Constants and macros for entire CAN_RXFGMASK register
 */
/*@{*/
#define HW_CAN_RXFGMASK_ADDR(x)  ((uintptr_t)(x) + 0x48U)

#define HW_CAN_RXFGMASK(x)       (*(__IO hw_can_rxfgmask_t *) HW_CAN_RXFGMASK_ADDR(x))
#define HW_CAN_RXFGMASK_RD(x)    (HW_CAN_RXFGMASK(x).U)
#define HW_CAN_RXFGMASK_WR(x, v) (HW_CAN_RXFGMASK(x).U = (v))
#define HW_CAN_RXFGMASK_SET(x, v) (HW_CAN_RXFGMASK_WR(x, HW_CAN_RXFGMASK_RD(x) |  (v)))
#define HW_CAN_RXFGMASK_CLR(x, v) (HW_CAN_RXFGMASK_WR(x, HW_CAN_RXFGMASK_RD(x) & ~(v)))
#define HW_CAN_RXFGMASK_TOG(x, v) (HW_CAN_RXFGMASK_WR(x, HW_CAN_RXFGMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_RXFGMASK bitfields
 */

/*!
 * @name Register CAN_RXFGMASK, field FGM31_FGM0[31:0] (RW)
 *
 * These bits mask the ID Filter Table elements bits in a perfect
 * alignment.RXFGMASKRx FIFO Global Mask Register shows in detail which FGM bits mask each IDAF
 * field. Clear this register has the effect of disabling the ID Filter.
 *
 * Values:
 * - 1 - The corresponding bit in the filter is checked
 * - 0 - The corresponding bit in the filter is "don't care"
 */
/*@{*/
#define BP_CAN_RXFGMASK_FGM31_FGM0 (0U)    /*!< Bit position for CAN_RXFGMASK_FGM31_FGM0. */
#define BM_CAN_RXFGMASK_FGM31_FGM0 (0xFFFFFFFFU) /*!< Bit mask for CAN_RXFGMASK_FGM31_FGM0. */
#define BS_CAN_RXFGMASK_FGM31_FGM0 (32U)   /*!< Bit field size in bits for CAN_RXFGMASK_FGM31_FGM0. */

/*! @brief Read current value of the CAN_RXFGMASK_FGM31_FGM0 field. */
#define BR_CAN_RXFGMASK_FGM31_FGM0(x) (HW_CAN_RXFGMASK(x).U)

/*! @brief Format value for bitfield CAN_RXFGMASK_FGM31_FGM0. */
#define BF_CAN_RXFGMASK_FGM31_FGM0(v) ((uint32_t)((uint32_t)(v) << BP_CAN_RXFGMASK_FGM31_FGM0) & BM_CAN_RXFGMASK_FGM31_FGM0)

/*! @brief Set the FGM31_FGM0 field to a new value. */
#define BW_CAN_RXFGMASK_FGM31_FGM0(x, v) (HW_CAN_RXFGMASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_RXFIR - Rx FIFO Information Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_RXFIR - Rx FIFO Information Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * RXFIR provides information on Rx FIFO. This register is the port through
 * which ARM accesses the output of the RXFIR FIFO located in RAM. The RXFIR FIFO is
 * written by the FlexCAN whenever a new message is moved into the Rx FIFO as
 * well as its output is updated whenever the output of the Rx FIFO is updated with
 * the next message. Refer to Rx FIFOThe receive-only FIFO is enabled by
 * asserting the RFEN bit in the MCR. to find instructions on reading this register.
 */
typedef union _hw_can_rxfir
{
    uint32_t U;
    struct _hw_can_rxfir_bitfields
    {
        uint32_t IDHIT : 9;            /*!< [8:0]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_can_rxfir_t;

/*!
 * @name Constants and macros for entire CAN_RXFIR register
 */
/*@{*/
#define HW_CAN_RXFIR_ADDR(x)     ((uintptr_t)(x) + 0x4CU)

#define HW_CAN_RXFIR(x)          (*(__I hw_can_rxfir_t *) HW_CAN_RXFIR_ADDR(x))
#define HW_CAN_RXFIR_RD(x)       (HW_CAN_RXFIR(x).U)
/*@}*/

/*
 * Constants & macros for individual CAN_RXFIR bitfields
 */

/*!
 * @name Register CAN_RXFIR, field IDHIT[8:0] (RO)
 *
 * This 9-bit field indicates which Identifier Acceptance Filter (see Rx FIFO
 * StructureWhen the MCR[RFEN] bit is set, the memory area from $80 to $DC (which
 * is normally occupied by MBs 0 to 5) is used by the reception FIFO engine. ) was
 * hit by the received message that is in the output of the Rx FIFO. (refer to
 * Rx FIFOThe receive-only FIFO is enabled by asserting the RFEN bit in the MCR.
 * for details) If multiple filters match the incoming message ID then the first
 * matching IDAF found (lowest number) by the matching process is indicated. This
 * field is valid only while the IFLAG[BUF5I] is asserted.
 */
/*@{*/
#define BP_CAN_RXFIR_IDHIT   (0U)          /*!< Bit position for CAN_RXFIR_IDHIT. */
#define BM_CAN_RXFIR_IDHIT   (0x000001FFU) /*!< Bit mask for CAN_RXFIR_IDHIT. */
#define BS_CAN_RXFIR_IDHIT   (9U)          /*!< Bit field size in bits for CAN_RXFIR_IDHIT. */

/*! @brief Read current value of the CAN_RXFIR_IDHIT field. */
#define BR_CAN_RXFIR_IDHIT(x) (HW_CAN_RXFIR(x).B.IDHIT)
/*@}*/

/*******************************************************************************
 * HW_CAN_CSn - Message Buffer 0 CS Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_CSn - Message Buffer 0 CS Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_can_csn
{
    uint32_t U;
    struct _hw_can_csn_bitfields
    {
        uint32_t TIME_STAMP : 16;      /*!< [15:0] Free-Running Counter Time
                                        * stamp. This 16-bit field is a copy of the Free-Running Timer, captured for Tx
                                        * and Rx frames at the time when the beginning of the Identifier field
                                        * appears on the CAN bus. */
        uint32_t DLC : 4;              /*!< [19:16] Length of the data to be
                                        * stored/transmitted. */
        uint32_t RTR : 1;              /*!< [20] Remote Transmission Request. One/zero for
                                        * remote/data frame. */
        uint32_t IDE : 1;              /*!< [21] ID Extended. One/zero for
                                        * extended/standard format frame. */
        uint32_t SRR : 1;              /*!< [22] Substitute Remote Request. Contains a
                                        * fixed recessive bit. */
        uint32_t RESERVED0 : 1;        /*!< [23] Reserved */
        uint32_t CODE : 4;             /*!< [27:24] Reserved */
        uint32_t RESERVED1 : 4;        /*!< [31:28] Reserved */
    } B;
} hw_can_csn_t;

/*!
 * @name Constants and macros for entire CAN_CSn register
 */
/*@{*/
#define HW_CAN_CSn_COUNT (64U)

#define HW_CAN_CSn_ADDR(x, n)    ((uintptr_t)(x) + 0x80U + (0x10U * (n)))

#define HW_CAN_CSn(x, n)         (*(__IO hw_can_csn_t *) HW_CAN_CSn_ADDR(x, n))
#define HW_CAN_CSn_RD(x, n)      (HW_CAN_CSn(x, n).U)
#define HW_CAN_CSn_WR(x, n, v)   (HW_CAN_CSn(x, n).U = (v))
#define HW_CAN_CSn_SET(x, n, v)  (HW_CAN_CSn_WR(x, n, HW_CAN_CSn_RD(x, n) |  (v)))
#define HW_CAN_CSn_CLR(x, n, v)  (HW_CAN_CSn_WR(x, n, HW_CAN_CSn_RD(x, n) & ~(v)))
#define HW_CAN_CSn_TOG(x, n, v)  (HW_CAN_CSn_WR(x, n, HW_CAN_CSn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_CSn bitfields
 */

/*!
 * @name Register CAN_CSn, field TIME_STAMP[15:0] (RW)
 */
/*@{*/
#define BP_CAN_CSn_TIME_STAMP (0U)         /*!< Bit position for CAN_CSn_TIME_STAMP. */
#define BM_CAN_CSn_TIME_STAMP (0x0000FFFFU) /*!< Bit mask for CAN_CSn_TIME_STAMP. */
#define BS_CAN_CSn_TIME_STAMP (16U)        /*!< Bit field size in bits for CAN_CSn_TIME_STAMP. */

/*! @brief Read current value of the CAN_CSn_TIME_STAMP field. */
#define BR_CAN_CSn_TIME_STAMP(x, n) (HW_CAN_CSn(x, n).B.TIME_STAMP)

/*! @brief Format value for bitfield CAN_CSn_TIME_STAMP. */
#define BF_CAN_CSn_TIME_STAMP(v) ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_TIME_STAMP) & BM_CAN_CSn_TIME_STAMP)

/*! @brief Set the TIME_STAMP field to a new value. */
#define BW_CAN_CSn_TIME_STAMP(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_TIME_STAMP) | BF_CAN_CSn_TIME_STAMP(v)))
/*@}*/

/*!
 * @name Register CAN_CSn, field DLC[19:16] (RW)
 */
/*@{*/
#define BP_CAN_CSn_DLC       (16U)         /*!< Bit position for CAN_CSn_DLC. */
#define BM_CAN_CSn_DLC       (0x000F0000U) /*!< Bit mask for CAN_CSn_DLC. */
#define BS_CAN_CSn_DLC       (4U)          /*!< Bit field size in bits for CAN_CSn_DLC. */

/*! @brief Read current value of the CAN_CSn_DLC field. */
#define BR_CAN_CSn_DLC(x, n) (HW_CAN_CSn(x, n).B.DLC)

/*! @brief Format value for bitfield CAN_CSn_DLC. */
#define BF_CAN_CSn_DLC(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_DLC) & BM_CAN_CSn_DLC)

/*! @brief Set the DLC field to a new value. */
#define BW_CAN_CSn_DLC(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_DLC) | BF_CAN_CSn_DLC(v)))
/*@}*/

/*!
 * @name Register CAN_CSn, field RTR[20] (RW)
 */
/*@{*/
#define BP_CAN_CSn_RTR       (20U)         /*!< Bit position for CAN_CSn_RTR. */
#define BM_CAN_CSn_RTR       (0x00100000U) /*!< Bit mask for CAN_CSn_RTR. */
#define BS_CAN_CSn_RTR       (1U)          /*!< Bit field size in bits for CAN_CSn_RTR. */

/*! @brief Read current value of the CAN_CSn_RTR field. */
#define BR_CAN_CSn_RTR(x, n) (HW_CAN_CSn(x, n).B.RTR)

/*! @brief Format value for bitfield CAN_CSn_RTR. */
#define BF_CAN_CSn_RTR(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_RTR) & BM_CAN_CSn_RTR)

/*! @brief Set the RTR field to a new value. */
#define BW_CAN_CSn_RTR(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_RTR) | BF_CAN_CSn_RTR(v)))
/*@}*/

/*!
 * @name Register CAN_CSn, field IDE[21] (RW)
 */
/*@{*/
#define BP_CAN_CSn_IDE       (21U)         /*!< Bit position for CAN_CSn_IDE. */
#define BM_CAN_CSn_IDE       (0x00200000U) /*!< Bit mask for CAN_CSn_IDE. */
#define BS_CAN_CSn_IDE       (1U)          /*!< Bit field size in bits for CAN_CSn_IDE. */

/*! @brief Read current value of the CAN_CSn_IDE field. */
#define BR_CAN_CSn_IDE(x, n) (HW_CAN_CSn(x, n).B.IDE)

/*! @brief Format value for bitfield CAN_CSn_IDE. */
#define BF_CAN_CSn_IDE(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_IDE) & BM_CAN_CSn_IDE)

/*! @brief Set the IDE field to a new value. */
#define BW_CAN_CSn_IDE(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_IDE) | BF_CAN_CSn_IDE(v)))
/*@}*/

/*!
 * @name Register CAN_CSn, field SRR[22] (RW)
 */
/*@{*/
#define BP_CAN_CSn_SRR       (22U)         /*!< Bit position for CAN_CSn_SRR. */
#define BM_CAN_CSn_SRR       (0x00400000U) /*!< Bit mask for CAN_CSn_SRR. */
#define BS_CAN_CSn_SRR       (1U)          /*!< Bit field size in bits for CAN_CSn_SRR. */

/*! @brief Read current value of the CAN_CSn_SRR field. */
#define BR_CAN_CSn_SRR(x, n) (HW_CAN_CSn(x, n).B.SRR)

/*! @brief Format value for bitfield CAN_CSn_SRR. */
#define BF_CAN_CSn_SRR(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_SRR) & BM_CAN_CSn_SRR)

/*! @brief Set the SRR field to a new value. */
#define BW_CAN_CSn_SRR(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_SRR) | BF_CAN_CSn_SRR(v)))
/*@}*/

/*!
 * @name Register CAN_CSn, field CODE[27:24] (RW)
 */
/*@{*/
#define BP_CAN_CSn_CODE      (24U)         /*!< Bit position for CAN_CSn_CODE. */
#define BM_CAN_CSn_CODE      (0x0F000000U) /*!< Bit mask for CAN_CSn_CODE. */
#define BS_CAN_CSn_CODE      (4U)          /*!< Bit field size in bits for CAN_CSn_CODE. */

/*! @brief Read current value of the CAN_CSn_CODE field. */
#define BR_CAN_CSn_CODE(x, n) (HW_CAN_CSn(x, n).B.CODE)

/*! @brief Format value for bitfield CAN_CSn_CODE. */
#define BF_CAN_CSn_CODE(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_CSn_CODE) & BM_CAN_CSn_CODE)

/*! @brief Set the CODE field to a new value. */
#define BW_CAN_CSn_CODE(x, n, v) (HW_CAN_CSn_WR(x, n, (HW_CAN_CSn_RD(x, n) & ~BM_CAN_CSn_CODE) | BF_CAN_CSn_CODE(v)))
/*@}*/
/*******************************************************************************
 * HW_CAN_IDn - Message Buffer 0 ID Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_IDn - Message Buffer 0 ID Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_can_idn
{
    uint32_t U;
    struct _hw_can_idn_bitfields
    {
        uint32_t EXT : 18;             /*!< [17:0] Contains extended (LOW word)
                                        * identifier of message buffer. */
        uint32_t STD : 11;             /*!< [28:18] Contains standard/extended (HIGH
                                        * word) identifier of message buffer. */
        uint32_t PRIO : 3;             /*!< [31:29] Local priority. This 3-bit fieldis
                                        * only used when LPRIO_EN bit is set in MCR and it only makes sense for Tx
                                        * buffers. These bits are not transmitted. They are appended to the regular
                                        * ID to define the transmission priority. */
    } B;
} hw_can_idn_t;

/*!
 * @name Constants and macros for entire CAN_IDn register
 */
/*@{*/
#define HW_CAN_IDn_COUNT (64U)

#define HW_CAN_IDn_ADDR(x, n)    ((uintptr_t)(x) + 0x84U + (0x10U * (n)))

#define HW_CAN_IDn(x, n)         (*(__IO hw_can_idn_t *) HW_CAN_IDn_ADDR(x, n))
#define HW_CAN_IDn_RD(x, n)      (HW_CAN_IDn(x, n).U)
#define HW_CAN_IDn_WR(x, n, v)   (HW_CAN_IDn(x, n).U = (v))
#define HW_CAN_IDn_SET(x, n, v)  (HW_CAN_IDn_WR(x, n, HW_CAN_IDn_RD(x, n) |  (v)))
#define HW_CAN_IDn_CLR(x, n, v)  (HW_CAN_IDn_WR(x, n, HW_CAN_IDn_RD(x, n) & ~(v)))
#define HW_CAN_IDn_TOG(x, n, v)  (HW_CAN_IDn_WR(x, n, HW_CAN_IDn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_IDn bitfields
 */

/*!
 * @name Register CAN_IDn, field EXT[17:0] (RW)
 */
/*@{*/
#define BP_CAN_IDn_EXT       (0U)          /*!< Bit position for CAN_IDn_EXT. */
#define BM_CAN_IDn_EXT       (0x0003FFFFU) /*!< Bit mask for CAN_IDn_EXT. */
#define BS_CAN_IDn_EXT       (18U)         /*!< Bit field size in bits for CAN_IDn_EXT. */

/*! @brief Read current value of the CAN_IDn_EXT field. */
#define BR_CAN_IDn_EXT(x, n) (HW_CAN_IDn(x, n).B.EXT)

/*! @brief Format value for bitfield CAN_IDn_EXT. */
#define BF_CAN_IDn_EXT(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_IDn_EXT) & BM_CAN_IDn_EXT)

/*! @brief Set the EXT field to a new value. */
#define BW_CAN_IDn_EXT(x, n, v) (HW_CAN_IDn_WR(x, n, (HW_CAN_IDn_RD(x, n) & ~BM_CAN_IDn_EXT) | BF_CAN_IDn_EXT(v)))
/*@}*/

/*!
 * @name Register CAN_IDn, field STD[28:18] (RW)
 */
/*@{*/
#define BP_CAN_IDn_STD       (18U)         /*!< Bit position for CAN_IDn_STD. */
#define BM_CAN_IDn_STD       (0x1FFC0000U) /*!< Bit mask for CAN_IDn_STD. */
#define BS_CAN_IDn_STD       (11U)         /*!< Bit field size in bits for CAN_IDn_STD. */

/*! @brief Read current value of the CAN_IDn_STD field. */
#define BR_CAN_IDn_STD(x, n) (HW_CAN_IDn(x, n).B.STD)

/*! @brief Format value for bitfield CAN_IDn_STD. */
#define BF_CAN_IDn_STD(v)    ((uint32_t)((uint32_t)(v) << BP_CAN_IDn_STD) & BM_CAN_IDn_STD)

/*! @brief Set the STD field to a new value. */
#define BW_CAN_IDn_STD(x, n, v) (HW_CAN_IDn_WR(x, n, (HW_CAN_IDn_RD(x, n) & ~BM_CAN_IDn_STD) | BF_CAN_IDn_STD(v)))
/*@}*/

/*!
 * @name Register CAN_IDn, field PRIO[31:29] (RW)
 */
/*@{*/
#define BP_CAN_IDn_PRIO      (29U)         /*!< Bit position for CAN_IDn_PRIO. */
#define BM_CAN_IDn_PRIO      (0xE0000000U) /*!< Bit mask for CAN_IDn_PRIO. */
#define BS_CAN_IDn_PRIO      (3U)          /*!< Bit field size in bits for CAN_IDn_PRIO. */

/*! @brief Read current value of the CAN_IDn_PRIO field. */
#define BR_CAN_IDn_PRIO(x, n) (HW_CAN_IDn(x, n).B.PRIO)

/*! @brief Format value for bitfield CAN_IDn_PRIO. */
#define BF_CAN_IDn_PRIO(v)   ((uint32_t)((uint32_t)(v) << BP_CAN_IDn_PRIO) & BM_CAN_IDn_PRIO)

/*! @brief Set the PRIO field to a new value. */
#define BW_CAN_IDn_PRIO(x, n, v) (HW_CAN_IDn_WR(x, n, (HW_CAN_IDn_RD(x, n) & ~BM_CAN_IDn_PRIO) | BF_CAN_IDn_PRIO(v)))
/*@}*/
/*******************************************************************************
 * HW_CAN_WORD0n - Message Buffer 0 WORD0 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_WORD0n - Message Buffer 0 WORD0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_can_word0n
{
    uint32_t U;
    struct _hw_can_word0n_bitfields
    {
        uint32_t DATA_BYTE_3 : 8;      /*!< [7:0] Data byte 3 of Rx/Tx frame. */
        uint32_t DATA_BYTE_2 : 8;      /*!< [15:8] Data byte 2 of Rx/Tx frame. */
        uint32_t DATA_BYTE_1 : 8;      /*!< [23:16] Data byte 1 of Rx/Tx frame. */
        uint32_t DATA_BYTE_0 : 8;      /*!< [31:24] Data byte 0 of Rx/Tx frame. */
    } B;
} hw_can_word0n_t;

/*!
 * @name Constants and macros for entire CAN_WORD0n register
 */
/*@{*/
#define HW_CAN_WORD0n_COUNT (64U)

#define HW_CAN_WORD0n_ADDR(x, n) ((uintptr_t)(x) + 0x88U + (0x10U * (n)))

#define HW_CAN_WORD0n(x, n)      (*(__IO hw_can_word0n_t *) HW_CAN_WORD0n_ADDR(x, n))
#define HW_CAN_WORD0n_RD(x, n)   (HW_CAN_WORD0n(x, n).U)
#define HW_CAN_WORD0n_WR(x, n, v) (HW_CAN_WORD0n(x, n).U = (v))
#define HW_CAN_WORD0n_SET(x, n, v) (HW_CAN_WORD0n_WR(x, n, HW_CAN_WORD0n_RD(x, n) |  (v)))
#define HW_CAN_WORD0n_CLR(x, n, v) (HW_CAN_WORD0n_WR(x, n, HW_CAN_WORD0n_RD(x, n) & ~(v)))
#define HW_CAN_WORD0n_TOG(x, n, v) (HW_CAN_WORD0n_WR(x, n, HW_CAN_WORD0n_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_WORD0n bitfields
 */

/*!
 * @name Register CAN_WORD0n, field DATA_BYTE_3[7:0] (RW)
 */
/*@{*/
#define BP_CAN_WORD0n_DATA_BYTE_3 (0U)     /*!< Bit position for CAN_WORD0n_DATA_BYTE_3. */
#define BM_CAN_WORD0n_DATA_BYTE_3 (0x000000FFU) /*!< Bit mask for CAN_WORD0n_DATA_BYTE_3. */
#define BS_CAN_WORD0n_DATA_BYTE_3 (8U)     /*!< Bit field size in bits for CAN_WORD0n_DATA_BYTE_3. */

/*! @brief Read current value of the CAN_WORD0n_DATA_BYTE_3 field. */
#define BR_CAN_WORD0n_DATA_BYTE_3(x, n) (HW_CAN_WORD0n(x, n).B.DATA_BYTE_3)

/*! @brief Format value for bitfield CAN_WORD0n_DATA_BYTE_3. */
#define BF_CAN_WORD0n_DATA_BYTE_3(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD0n_DATA_BYTE_3) & BM_CAN_WORD0n_DATA_BYTE_3)

/*! @brief Set the DATA_BYTE_3 field to a new value. */
#define BW_CAN_WORD0n_DATA_BYTE_3(x, n, v) (HW_CAN_WORD0n_WR(x, n, (HW_CAN_WORD0n_RD(x, n) & ~BM_CAN_WORD0n_DATA_BYTE_3) | BF_CAN_WORD0n_DATA_BYTE_3(v)))
/*@}*/

/*!
 * @name Register CAN_WORD0n, field DATA_BYTE_2[15:8] (RW)
 */
/*@{*/
#define BP_CAN_WORD0n_DATA_BYTE_2 (8U)     /*!< Bit position for CAN_WORD0n_DATA_BYTE_2. */
#define BM_CAN_WORD0n_DATA_BYTE_2 (0x0000FF00U) /*!< Bit mask for CAN_WORD0n_DATA_BYTE_2. */
#define BS_CAN_WORD0n_DATA_BYTE_2 (8U)     /*!< Bit field size in bits for CAN_WORD0n_DATA_BYTE_2. */

/*! @brief Read current value of the CAN_WORD0n_DATA_BYTE_2 field. */
#define BR_CAN_WORD0n_DATA_BYTE_2(x, n) (HW_CAN_WORD0n(x, n).B.DATA_BYTE_2)

/*! @brief Format value for bitfield CAN_WORD0n_DATA_BYTE_2. */
#define BF_CAN_WORD0n_DATA_BYTE_2(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD0n_DATA_BYTE_2) & BM_CAN_WORD0n_DATA_BYTE_2)

/*! @brief Set the DATA_BYTE_2 field to a new value. */
#define BW_CAN_WORD0n_DATA_BYTE_2(x, n, v) (HW_CAN_WORD0n_WR(x, n, (HW_CAN_WORD0n_RD(x, n) & ~BM_CAN_WORD0n_DATA_BYTE_2) | BF_CAN_WORD0n_DATA_BYTE_2(v)))
/*@}*/

/*!
 * @name Register CAN_WORD0n, field DATA_BYTE_1[23:16] (RW)
 */
/*@{*/
#define BP_CAN_WORD0n_DATA_BYTE_1 (16U)    /*!< Bit position for CAN_WORD0n_DATA_BYTE_1. */
#define BM_CAN_WORD0n_DATA_BYTE_1 (0x00FF0000U) /*!< Bit mask for CAN_WORD0n_DATA_BYTE_1. */
#define BS_CAN_WORD0n_DATA_BYTE_1 (8U)     /*!< Bit field size in bits for CAN_WORD0n_DATA_BYTE_1. */

/*! @brief Read current value of the CAN_WORD0n_DATA_BYTE_1 field. */
#define BR_CAN_WORD0n_DATA_BYTE_1(x, n) (HW_CAN_WORD0n(x, n).B.DATA_BYTE_1)

/*! @brief Format value for bitfield CAN_WORD0n_DATA_BYTE_1. */
#define BF_CAN_WORD0n_DATA_BYTE_1(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD0n_DATA_BYTE_1) & BM_CAN_WORD0n_DATA_BYTE_1)

/*! @brief Set the DATA_BYTE_1 field to a new value. */
#define BW_CAN_WORD0n_DATA_BYTE_1(x, n, v) (HW_CAN_WORD0n_WR(x, n, (HW_CAN_WORD0n_RD(x, n) & ~BM_CAN_WORD0n_DATA_BYTE_1) | BF_CAN_WORD0n_DATA_BYTE_1(v)))
/*@}*/

/*!
 * @name Register CAN_WORD0n, field DATA_BYTE_0[31:24] (RW)
 */
/*@{*/
#define BP_CAN_WORD0n_DATA_BYTE_0 (24U)    /*!< Bit position for CAN_WORD0n_DATA_BYTE_0. */
#define BM_CAN_WORD0n_DATA_BYTE_0 (0xFF000000U) /*!< Bit mask for CAN_WORD0n_DATA_BYTE_0. */
#define BS_CAN_WORD0n_DATA_BYTE_0 (8U)     /*!< Bit field size in bits for CAN_WORD0n_DATA_BYTE_0. */

/*! @brief Read current value of the CAN_WORD0n_DATA_BYTE_0 field. */
#define BR_CAN_WORD0n_DATA_BYTE_0(x, n) (HW_CAN_WORD0n(x, n).B.DATA_BYTE_0)

/*! @brief Format value for bitfield CAN_WORD0n_DATA_BYTE_0. */
#define BF_CAN_WORD0n_DATA_BYTE_0(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD0n_DATA_BYTE_0) & BM_CAN_WORD0n_DATA_BYTE_0)

/*! @brief Set the DATA_BYTE_0 field to a new value. */
#define BW_CAN_WORD0n_DATA_BYTE_0(x, n, v) (HW_CAN_WORD0n_WR(x, n, (HW_CAN_WORD0n_RD(x, n) & ~BM_CAN_WORD0n_DATA_BYTE_0) | BF_CAN_WORD0n_DATA_BYTE_0(v)))
/*@}*/
/*******************************************************************************
 * HW_CAN_WORD1n - Message Buffer 0 WORD1 Register
 ******************************************************************************/

/*!
 * @brief HW_CAN_WORD1n - Message Buffer 0 WORD1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_can_word1n
{
    uint32_t U;
    struct _hw_can_word1n_bitfields
    {
        uint32_t DATA_BYTE_7 : 8;      /*!< [7:0] Data byte 7 of Rx/Tx frame. */
        uint32_t DATA_BYTE_6 : 8;      /*!< [15:8] Data byte 6 of Rx/Tx frame. */
        uint32_t DATA_BYTE_5 : 8;      /*!< [23:16] Data byte 5 of Rx/Tx frame. */
        uint32_t DATA_BYTE_4 : 8;      /*!< [31:24] Data byte 4 of Rx/Tx frame. */
    } B;
} hw_can_word1n_t;

/*!
 * @name Constants and macros for entire CAN_WORD1n register
 */
/*@{*/
#define HW_CAN_WORD1n_COUNT (64U)

#define HW_CAN_WORD1n_ADDR(x, n) ((uintptr_t)(x) + 0x8CU + (0x10U * (n)))

#define HW_CAN_WORD1n(x, n)      (*(__IO hw_can_word1n_t *) HW_CAN_WORD1n_ADDR(x, n))
#define HW_CAN_WORD1n_RD(x, n)   (HW_CAN_WORD1n(x, n).U)
#define HW_CAN_WORD1n_WR(x, n, v) (HW_CAN_WORD1n(x, n).U = (v))
#define HW_CAN_WORD1n_SET(x, n, v) (HW_CAN_WORD1n_WR(x, n, HW_CAN_WORD1n_RD(x, n) |  (v)))
#define HW_CAN_WORD1n_CLR(x, n, v) (HW_CAN_WORD1n_WR(x, n, HW_CAN_WORD1n_RD(x, n) & ~(v)))
#define HW_CAN_WORD1n_TOG(x, n, v) (HW_CAN_WORD1n_WR(x, n, HW_CAN_WORD1n_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_WORD1n bitfields
 */

/*!
 * @name Register CAN_WORD1n, field DATA_BYTE_7[7:0] (RW)
 */
/*@{*/
#define BP_CAN_WORD1n_DATA_BYTE_7 (0U)     /*!< Bit position for CAN_WORD1n_DATA_BYTE_7. */
#define BM_CAN_WORD1n_DATA_BYTE_7 (0x000000FFU) /*!< Bit mask for CAN_WORD1n_DATA_BYTE_7. */
#define BS_CAN_WORD1n_DATA_BYTE_7 (8U)     /*!< Bit field size in bits for CAN_WORD1n_DATA_BYTE_7. */

/*! @brief Read current value of the CAN_WORD1n_DATA_BYTE_7 field. */
#define BR_CAN_WORD1n_DATA_BYTE_7(x, n) (HW_CAN_WORD1n(x, n).B.DATA_BYTE_7)

/*! @brief Format value for bitfield CAN_WORD1n_DATA_BYTE_7. */
#define BF_CAN_WORD1n_DATA_BYTE_7(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD1n_DATA_BYTE_7) & BM_CAN_WORD1n_DATA_BYTE_7)

/*! @brief Set the DATA_BYTE_7 field to a new value. */
#define BW_CAN_WORD1n_DATA_BYTE_7(x, n, v) (HW_CAN_WORD1n_WR(x, n, (HW_CAN_WORD1n_RD(x, n) & ~BM_CAN_WORD1n_DATA_BYTE_7) | BF_CAN_WORD1n_DATA_BYTE_7(v)))
/*@}*/

/*!
 * @name Register CAN_WORD1n, field DATA_BYTE_6[15:8] (RW)
 */
/*@{*/
#define BP_CAN_WORD1n_DATA_BYTE_6 (8U)     /*!< Bit position for CAN_WORD1n_DATA_BYTE_6. */
#define BM_CAN_WORD1n_DATA_BYTE_6 (0x0000FF00U) /*!< Bit mask for CAN_WORD1n_DATA_BYTE_6. */
#define BS_CAN_WORD1n_DATA_BYTE_6 (8U)     /*!< Bit field size in bits for CAN_WORD1n_DATA_BYTE_6. */

/*! @brief Read current value of the CAN_WORD1n_DATA_BYTE_6 field. */
#define BR_CAN_WORD1n_DATA_BYTE_6(x, n) (HW_CAN_WORD1n(x, n).B.DATA_BYTE_6)

/*! @brief Format value for bitfield CAN_WORD1n_DATA_BYTE_6. */
#define BF_CAN_WORD1n_DATA_BYTE_6(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD1n_DATA_BYTE_6) & BM_CAN_WORD1n_DATA_BYTE_6)

/*! @brief Set the DATA_BYTE_6 field to a new value. */
#define BW_CAN_WORD1n_DATA_BYTE_6(x, n, v) (HW_CAN_WORD1n_WR(x, n, (HW_CAN_WORD1n_RD(x, n) & ~BM_CAN_WORD1n_DATA_BYTE_6) | BF_CAN_WORD1n_DATA_BYTE_6(v)))
/*@}*/

/*!
 * @name Register CAN_WORD1n, field DATA_BYTE_5[23:16] (RW)
 */
/*@{*/
#define BP_CAN_WORD1n_DATA_BYTE_5 (16U)    /*!< Bit position for CAN_WORD1n_DATA_BYTE_5. */
#define BM_CAN_WORD1n_DATA_BYTE_5 (0x00FF0000U) /*!< Bit mask for CAN_WORD1n_DATA_BYTE_5. */
#define BS_CAN_WORD1n_DATA_BYTE_5 (8U)     /*!< Bit field size in bits for CAN_WORD1n_DATA_BYTE_5. */

/*! @brief Read current value of the CAN_WORD1n_DATA_BYTE_5 field. */
#define BR_CAN_WORD1n_DATA_BYTE_5(x, n) (HW_CAN_WORD1n(x, n).B.DATA_BYTE_5)

/*! @brief Format value for bitfield CAN_WORD1n_DATA_BYTE_5. */
#define BF_CAN_WORD1n_DATA_BYTE_5(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD1n_DATA_BYTE_5) & BM_CAN_WORD1n_DATA_BYTE_5)

/*! @brief Set the DATA_BYTE_5 field to a new value. */
#define BW_CAN_WORD1n_DATA_BYTE_5(x, n, v) (HW_CAN_WORD1n_WR(x, n, (HW_CAN_WORD1n_RD(x, n) & ~BM_CAN_WORD1n_DATA_BYTE_5) | BF_CAN_WORD1n_DATA_BYTE_5(v)))
/*@}*/

/*!
 * @name Register CAN_WORD1n, field DATA_BYTE_4[31:24] (RW)
 */
/*@{*/
#define BP_CAN_WORD1n_DATA_BYTE_4 (24U)    /*!< Bit position for CAN_WORD1n_DATA_BYTE_4. */
#define BM_CAN_WORD1n_DATA_BYTE_4 (0xFF000000U) /*!< Bit mask for CAN_WORD1n_DATA_BYTE_4. */
#define BS_CAN_WORD1n_DATA_BYTE_4 (8U)     /*!< Bit field size in bits for CAN_WORD1n_DATA_BYTE_4. */

/*! @brief Read current value of the CAN_WORD1n_DATA_BYTE_4 field. */
#define BR_CAN_WORD1n_DATA_BYTE_4(x, n) (HW_CAN_WORD1n(x, n).B.DATA_BYTE_4)

/*! @brief Format value for bitfield CAN_WORD1n_DATA_BYTE_4. */
#define BF_CAN_WORD1n_DATA_BYTE_4(v) ((uint32_t)((uint32_t)(v) << BP_CAN_WORD1n_DATA_BYTE_4) & BM_CAN_WORD1n_DATA_BYTE_4)

/*! @brief Set the DATA_BYTE_4 field to a new value. */
#define BW_CAN_WORD1n_DATA_BYTE_4(x, n, v) (HW_CAN_WORD1n_WR(x, n, (HW_CAN_WORD1n_RD(x, n) & ~BM_CAN_WORD1n_DATA_BYTE_4) | BF_CAN_WORD1n_DATA_BYTE_4(v)))
/*@}*/

/*******************************************************************************
 * HW_CAN_RXIMRn - RXIMR
 ******************************************************************************/

/*!
 * @brief HW_CAN_RXIMRn - RXIMR (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_can_rximrn
{
    uint32_t U;
    struct _hw_can_rximrn_bitfields
    {
        uint32_t MI : 32;              /*!< [31:0] MI */
    } B;
} hw_can_rximrn_t;

/*!
 * @name Constants and macros for entire CAN_RXIMRn register
 */
/*@{*/
#define HW_CAN_RXIMRn_COUNT (64U)

#define HW_CAN_RXIMRn_ADDR(x, n) ((uintptr_t)(x) + 0x880U + (0x4U * (n)))

#define HW_CAN_RXIMRn(x, n)      (*(__IO hw_can_rximrn_t *) HW_CAN_RXIMRn_ADDR(x, n))
#define HW_CAN_RXIMRn_RD(x, n)   (HW_CAN_RXIMRn(x, n).U)
#define HW_CAN_RXIMRn_WR(x, n, v) (HW_CAN_RXIMRn(x, n).U = (v))
#define HW_CAN_RXIMRn_SET(x, n, v) (HW_CAN_RXIMRn_WR(x, n, HW_CAN_RXIMRn_RD(x, n) |  (v)))
#define HW_CAN_RXIMRn_CLR(x, n, v) (HW_CAN_RXIMRn_WR(x, n, HW_CAN_RXIMRn_RD(x, n) & ~(v)))
#define HW_CAN_RXIMRn_TOG(x, n, v) (HW_CAN_RXIMRn_WR(x, n, HW_CAN_RXIMRn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_RXIMRn bitfields
 */

/*!
 * @name Register CAN_RXIMRn, field MI[31:0] (RW)
 */
/*@{*/
#define BP_CAN_RXIMRn_MI     (0U)          /*!< Bit position for CAN_RXIMRn_MI. */
#define BM_CAN_RXIMRn_MI     (0xFFFFFFFFU) /*!< Bit mask for CAN_RXIMRn_MI. */
#define BS_CAN_RXIMRn_MI     (32U)         /*!< Bit field size in bits for CAN_RXIMRn_MI. */

/*! @brief Read current value of the CAN_RXIMRn_MI field. */
#define BR_CAN_RXIMRn_MI(x, n) (HW_CAN_RXIMRn(x, n).U)

/*! @brief Format value for bitfield CAN_RXIMRn_MI. */
#define BF_CAN_RXIMRn_MI(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_RXIMRn_MI) & BM_CAN_RXIMRn_MI)

/*! @brief Set the MI field to a new value. */
#define BW_CAN_RXIMRn_MI(x, n, v) (HW_CAN_RXIMRn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_CAN_GFWR - Glitch Filter Width Registers
 ******************************************************************************/

/*!
 * @brief HW_CAN_GFWR - Glitch Filter Width Registers (RW)
 *
 * Reset value: 0x0000007FU
 *
 * The Glitch Filter just takes effects when FLEXCAN enters the STOP mode.
 */
typedef union _hw_can_gfwr
{
    uint32_t U;
    struct _hw_can_gfwr_bitfields
    {
        uint32_t GFWR : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_can_gfwr_t;

/*!
 * @name Constants and macros for entire CAN_GFWR register
 */
/*@{*/
#define HW_CAN_GFWR_ADDR(x)      ((uintptr_t)(x) + 0x9E0U)

#define HW_CAN_GFWR(x)           (*(__IO hw_can_gfwr_t *) HW_CAN_GFWR_ADDR(x))
#define HW_CAN_GFWR_RD(x)        (HW_CAN_GFWR(x).U)
#define HW_CAN_GFWR_WR(x, v)     (HW_CAN_GFWR(x).U = (v))
#define HW_CAN_GFWR_SET(x, v)    (HW_CAN_GFWR_WR(x, HW_CAN_GFWR_RD(x) |  (v)))
#define HW_CAN_GFWR_CLR(x, v)    (HW_CAN_GFWR_WR(x, HW_CAN_GFWR_RD(x) & ~(v)))
#define HW_CAN_GFWR_TOG(x, v)    (HW_CAN_GFWR_WR(x, HW_CAN_GFWR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CAN_GFWR bitfields
 */

/*!
 * @name Register CAN_GFWR, field GFWR[7:0] (RW)
 *
 * It determines the Glitch Filter Width. The width will be divided from
 * Oscillator clock by GFWR values. By default, it is 5.33 us when the oscillator is 24
 * MHz. Filter Pulse Width = [(GFWR FIELD + 1) x (1 / Osc. Frequency)]
 */
/*@{*/
#define BP_CAN_GFWR_GFWR     (0U)          /*!< Bit position for CAN_GFWR_GFWR. */
#define BM_CAN_GFWR_GFWR     (0x000000FFU) /*!< Bit mask for CAN_GFWR_GFWR. */
#define BS_CAN_GFWR_GFWR     (8U)          /*!< Bit field size in bits for CAN_GFWR_GFWR. */

/*! @brief Read current value of the CAN_GFWR_GFWR field. */
#define BR_CAN_GFWR_GFWR(x)  (HW_CAN_GFWR(x).B.GFWR)

/*! @brief Format value for bitfield CAN_GFWR_GFWR. */
#define BF_CAN_GFWR_GFWR(v)  ((uint32_t)((uint32_t)(v) << BP_CAN_GFWR_GFWR) & BM_CAN_GFWR_GFWR)

/*! @brief Set the GFWR field to a new value. */
#define BW_CAN_GFWR_GFWR(x, v) (HW_CAN_GFWR_WR(x, (HW_CAN_GFWR_RD(x) & ~BM_CAN_GFWR_GFWR) | BF_CAN_GFWR_GFWR(v)))
/*@}*/

/*******************************************************************************
 * hw_can_t - module struct
 ******************************************************************************/
/*!
 * @brief All CAN module registers.
 */
#pragma pack(1)
typedef struct _hw_can
{
    __IO hw_can_mcr_t MCR;                 /*!< [0x0] Module Configuration Register */
    __IO hw_can_ctrl1_t CTRL1;             /*!< [0x4] Control 1 Register */
    __IO hw_can_timer_t TIMER;             /*!< [0x8] Free Running Timer Register */
    uint8_t _reserved0[4];
    __IO hw_can_rxmgmask_t RXMGMASK;       /*!< [0x10] Rx Mailboxes Global Mask Register */
    __IO hw_can_rx14mask_t RX14MASK;       /*!< [0x14] Rx Buffer 14 Mask Register */
    __IO hw_can_rx15mask_t RX15MASK;       /*!< [0x18] Rx Buffer 15 Mask Register */
    __IO hw_can_ecr_t ECR;                 /*!< [0x1C] Error Counter Register */
    __IO hw_can_esr1_t ESR1;               /*!< [0x20] Error and Status 1 Register */
    __IO hw_can_imask2_t IMASK2;           /*!< [0x24] Interrupt Masks 2 Register */
    __IO hw_can_imask1_t IMASK1;           /*!< [0x28] Interrupt Masks 1 Register */
    __IO hw_can_iflag2_t IFLAG2;           /*!< [0x2C] Interrupt Flags 2 Register */
    __IO hw_can_iflag1_t IFLAG1;           /*!< [0x30] Interrupt Flags 1 Register */
    __IO hw_can_ctrl2_t CTRL2;             /*!< [0x34] Control 2 Register */
    __I hw_can_esr2_t ESR2;                /*!< [0x38] Error and Status 2 Register */
    uint8_t _reserved1[8];
    __I hw_can_crcr_t CRCR;                /*!< [0x44] CRC Register */
    __IO hw_can_rxfgmask_t RXFGMASK;       /*!< [0x48] Rx FIFO Global Mask Register */
    __I hw_can_rxfir_t RXFIR;              /*!< [0x4C] Rx FIFO Information Register */
    uint8_t _reserved2[48];
    struct {
        __IO hw_can_csn_t CSn;             /*!< [0x80] Message Buffer 0 CS Register */
        __IO hw_can_idn_t IDn;             /*!< [0x84] Message Buffer 0 ID Register */
        __IO hw_can_word0n_t WORD0n;       /*!< [0x88] Message Buffer 0 WORD0 Register */
        __IO hw_can_word1n_t WORD1n;       /*!< [0x8C] Message Buffer 0 WORD1 Register */
    } MB[64];
    uint8_t _reserved3[1024];
    __IO hw_can_rximrn_t RXIMRn[64];       /*!< [0x880] RXIMR */
    uint8_t _reserved4[96];
    __IO hw_can_gfwr_t GFWR;               /*!< [0x9E0] Glitch Filter Width Registers */
} hw_can_t;
#pragma pack()

/*! @brief Macro to access all CAN registers. */
/*! @param x CAN module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_CAN_REGS(CAN1_BASE)</code>. */
#define HW_CAN_REGS(x) (*(hw_can_t *)(x))

/*
 * iMX6DP CCM
 *
 * CCM ***
 *
 * Registers defined in this header file:
 * - HW_CCM_CCR - CCM Control Register
 * - HW_CCM_CCDR - CCM Control Divider Register
 * - HW_CCM_CSR - CCM Status Register
 * - HW_CCM_CCSR - CCM Clock Switcher Register
 * - HW_CCM_CACRR - CCM Arm Clock Root Register
 * - HW_CCM_CBCDR - CCM Bus Clock Divider Register
 * - HW_CCM_CBCMR - CCM Bus Clock Multiplexer Register
 * - HW_CCM_CSCMR1 - CCM Serial Clock Multiplexer Register 1
 * - HW_CCM_CSCMR2 - CCM Serial Clock Multiplexer Register 2
 * - HW_CCM_CSCDR1 - CCM Serial Clock Divider Register 1
 * - HW_CCM_CS1CDR - CCM SSI1 Clock Divider Register
 * - HW_CCM_CS2CDR - CCM SSI2 Clock Divider Register
 * - HW_CCM_CDCDR - CCM D1 Clock Divider Register
 * - HW_CCM_CHSCCDR - CCM HSC Clock Divider Register
 * - HW_CCM_CSCDR2 - CCM Serial Clock Divider Register 2
 * - HW_CCM_CSCDR3 - CCM Serial Clock Divider Register 3
 * - HW_CCM_CWDR - CCM Wakeup Detector Register
 * - HW_CCM_CDHIPR - CCM Divider Handshake In-Process Register
 * - HW_CCM_CLPCR - CCM Low Power Control Register
 * - HW_CCM_CISR - CCM Interrupt Status Register
 * - HW_CCM_CIMR - CCM Interrupt Mask Register
 * - HW_CCM_CCOSR - CCM Clock Output Source Register
 * - HW_CCM_CGPR - CCM General Purpose Register
 * - HW_CCM_CCGR0 - CCM Clock Gating Register 0
 * - HW_CCM_CCGR1 - CCM Clock Gating Register 1
 * - HW_CCM_CCGR2 - CCM Clock Gating Register 2
 * - HW_CCM_CCGR3 - CCM Clock Gating Register 3
 * - HW_CCM_CCGR4 - CCM Clock Gating Register 4
 * - HW_CCM_CCGR5 - CCM Clock Gating Register 5
 * - HW_CCM_CCGR6 - CCM Clock Gating Register 6
 * - HW_CCM_CMEOR - CCM Module Enable Overide Register
 *
 * - hw_ccm_t - Struct containing all module registers.
 */

#define HW_CCM_INSTANCE_COUNT (1U) /*!< Number of instances of the CCM module. */
#define HW_CCM (0U) /*!< Instance number for CCM. */
#define CCM_BASE              (0x20C4000U) /*!< Base address for CCM. */
/*! Array initializer of CCM base addresses. */
#define CCM_BASE_ADDRS        { CCM_BASE }

/*******************************************************************************
 * HW_CCM_CCR - CCM Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCR - CCM Control Register (RW)
 *
 * Reset value: 0x0401167FU
 *
 * The figure below represents the CCM Control Register (CCR), which contains
 * bits to control general operation of CCM. The table below provides its field
 * descriptions.
 */
typedef union _hw_ccm_ccr
{
    uint32_t U;
    struct _hw_ccm_ccr_bitfields
    {
        uint32_t OSCNT : 8;            /*!< [7:0]  */
        uint32_t RESERVED0 : 4;        /*!< [11:8]  */
        uint32_t COSC_EN : 1;          /*!< [12]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t WB_COUNT : 3;         /*!< [18:16]  */
        uint32_t RESERVED2 : 2;        /*!< [20:19]  */
        uint32_t REG_BYPASS_COUNT : 6; /*!< [26:21]  */
        uint32_t RBC_EN : 1;           /*!< [27]  */
        uint32_t RESERVED3 : 4;        /*!< [31:28]  */
    } B;
} hw_ccm_ccr_t;

/*!
 * @name Constants and macros for entire CCM_CCR register
 */
/*@{*/
#define HW_CCM_CCR_ADDR(x)       ((uintptr_t)(x) + 0x0U)

#define HW_CCM_CCR(x)            (*(__IO hw_ccm_ccr_t *) HW_CCM_CCR_ADDR(x))
#define HW_CCM_CCR_RD(x)         (HW_CCM_CCR(x).U)
#define HW_CCM_CCR_WR(x, v)      (HW_CCM_CCR(x).U = (v))
#define HW_CCM_CCR_SET(x, v)     (HW_CCM_CCR_WR(x, HW_CCM_CCR_RD(x) |  (v)))
#define HW_CCM_CCR_CLR(x, v)     (HW_CCM_CCR_WR(x, HW_CCM_CCR_RD(x) & ~(v)))
#define HW_CCM_CCR_TOG(x, v)     (HW_CCM_CCR_WR(x, HW_CCM_CCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCR bitfields
 */

/*!
 * @name Register CCM_CCR, field OSCNT[7:0] (RW)
 *
 * Oscillator ready counter value. These bits define value of 32KHz counter,
 * that serve as counter for oscillator lock time. This is used for oscillator lock
 * time. Current estimation is ~5ms. This counter will be used in ignition
 * sequence and in wake from stop sequence if sbyos bit was defined, to notify that on
 * chip oscillator output is ready for the dpll_ip to use and only then the gate
 * in dpll_ip can be opened.
 *
 * Values:
 * - 00000000 - count 1 ckil
 * - 11111111 - count 256 ckil's
 */
/*@{*/
#define BP_CCM_CCR_OSCNT     (0U)          /*!< Bit position for CCM_CCR_OSCNT. */
#define BM_CCM_CCR_OSCNT     (0x000000FFU) /*!< Bit mask for CCM_CCR_OSCNT. */
#define BS_CCM_CCR_OSCNT     (8U)          /*!< Bit field size in bits for CCM_CCR_OSCNT. */

/*! @brief Read current value of the CCM_CCR_OSCNT field. */
#define BR_CCM_CCR_OSCNT(x)  (HW_CCM_CCR(x).B.OSCNT)

/*! @brief Format value for bitfield CCM_CCR_OSCNT. */
#define BF_CCM_CCR_OSCNT(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCR_OSCNT) & BM_CCM_CCR_OSCNT)

/*! @brief Set the OSCNT field to a new value. */
#define BW_CCM_CCR_OSCNT(x, v) (HW_CCM_CCR_WR(x, (HW_CCM_CCR_RD(x) & ~BM_CCM_CCR_OSCNT) | BF_CCM_CCR_OSCNT(v)))
/*@}*/

/*!
 * @name Register CCM_CCR, field COSC_EN[12] (RW)
 *
 * On chip oscillator enable bit - this bit value is reflected on the output
 * cosc_en. The system will start with on chip oscillator enabled to supply source
 * for the PLLs. Software can change this bit if a transition to the bypass PLL
 * clocks was performed for all the PLLs. In cases that this bit is changed from
 * '0' to '1' then CCM will enable the on chip oscillator and after counting oscnt
 * ckil clock cycles it will notify that on chip oscillator is ready by a
 * interrupt cosc_ready and by status bit cosc_ready. The cosc_en bit should be changed
 * only when on chip oscillator is not chosen as the clock source.
 *
 * Values:
 * - 0 - disable on chip oscillator
 * - 1 - enable on chip oscillator
 */
/*@{*/
#define BP_CCM_CCR_COSC_EN   (12U)         /*!< Bit position for CCM_CCR_COSC_EN. */
#define BM_CCM_CCR_COSC_EN   (0x00001000U) /*!< Bit mask for CCM_CCR_COSC_EN. */
#define BS_CCM_CCR_COSC_EN   (1U)          /*!< Bit field size in bits for CCM_CCR_COSC_EN. */

/*! @brief Read current value of the CCM_CCR_COSC_EN field. */
#define BR_CCM_CCR_COSC_EN(x) (HW_CCM_CCR(x).B.COSC_EN)

/*! @brief Format value for bitfield CCM_CCR_COSC_EN. */
#define BF_CCM_CCR_COSC_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCR_COSC_EN) & BM_CCM_CCR_COSC_EN)

/*! @brief Set the COSC_EN field to a new value. */
#define BW_CCM_CCR_COSC_EN(x, v) (HW_CCM_CCR_WR(x, (HW_CCM_CCR_RD(x) & ~BM_CCM_CCR_COSC_EN) | BF_CCM_CCR_COSC_EN(v)))
/*@}*/

/*!
 * @name Register CCM_CCR, field WB_COUNT[18:16] (RW)
 *
 * Well Bias counter. Delay, defined by this value, counted by CKIL clock will
 * be applied till well bias is enabled at exit from wait or stop low power mode.
 * Counter will be used if wb_core_at_lpm or wb_per_at_lpm bits are set. Should
 * be zeroed and reconfigured after exit from low power mode.
 *
 * Values:
 * - 000 - no delay
 * - 001 - 1 CKIL clock delay
 * - 111 - 7 CKIL clocks delay
 */
/*@{*/
#define BP_CCM_CCR_WB_COUNT  (16U)         /*!< Bit position for CCM_CCR_WB_COUNT. */
#define BM_CCM_CCR_WB_COUNT  (0x00070000U) /*!< Bit mask for CCM_CCR_WB_COUNT. */
#define BS_CCM_CCR_WB_COUNT  (3U)          /*!< Bit field size in bits for CCM_CCR_WB_COUNT. */

/*! @brief Read current value of the CCM_CCR_WB_COUNT field. */
#define BR_CCM_CCR_WB_COUNT(x) (HW_CCM_CCR(x).B.WB_COUNT)

/*! @brief Format value for bitfield CCM_CCR_WB_COUNT. */
#define BF_CCM_CCR_WB_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCR_WB_COUNT) & BM_CCM_CCR_WB_COUNT)

/*! @brief Set the WB_COUNT field to a new value. */
#define BW_CCM_CCR_WB_COUNT(x, v) (HW_CCM_CCR_WR(x, (HW_CCM_CCR_RD(x) & ~BM_CCM_CCR_WB_COUNT) | BF_CCM_CCR_WB_COUNT(v)))
/*@}*/

/*!
 * @name Register CCM_CCR, field REG_BYPASS_COUNT[26:21] (RW)
 *
 * Counter for analog_reg_bypass signal assertion after standby voltage request
 * by PMIC_STBY_REQ. Should be zeroed and reconfigured after exit from low power
 * mode. REG_BYPASS_COUNT can also be used for holding off interrupts when the
 * PGC unit is sending signals to power gate the core.
 *
 * Values:
 * - 000000 - no delay
 * - 000001 - 1 CKIL clock period delay
 * - 111111 - 63 CKIL clock periods delay
 */
/*@{*/
#define BP_CCM_CCR_REG_BYPASS_COUNT (21U)  /*!< Bit position for CCM_CCR_REG_BYPASS_COUNT. */
#define BM_CCM_CCR_REG_BYPASS_COUNT (0x07E00000U) /*!< Bit mask for CCM_CCR_REG_BYPASS_COUNT. */
#define BS_CCM_CCR_REG_BYPASS_COUNT (6U)   /*!< Bit field size in bits for CCM_CCR_REG_BYPASS_COUNT. */

/*! @brief Read current value of the CCM_CCR_REG_BYPASS_COUNT field. */
#define BR_CCM_CCR_REG_BYPASS_COUNT(x) (HW_CCM_CCR(x).B.REG_BYPASS_COUNT)

/*! @brief Format value for bitfield CCM_CCR_REG_BYPASS_COUNT. */
#define BF_CCM_CCR_REG_BYPASS_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCR_REG_BYPASS_COUNT) & BM_CCM_CCR_REG_BYPASS_COUNT)

/*! @brief Set the REG_BYPASS_COUNT field to a new value. */
#define BW_CCM_CCR_REG_BYPASS_COUNT(x, v) (HW_CCM_CCR_WR(x, (HW_CCM_CCR_RD(x) & ~BM_CCM_CCR_REG_BYPASS_COUNT) | BF_CCM_CCR_REG_BYPASS_COUNT(v)))
/*@}*/

/*!
 * @name Register CCM_CCR, field RBC_EN[27] (RW)
 *
 * Enable for REG_BYPASS_COUNTER. If enabled, analog_reg_bypass signal will be
 * asserted after REG_BYPASS_COUNT clocks of CKIL, after standby voltage is
 * requested. If standby voltage is not requested analog_reg_bypass won't be asserted,
 * event if counter is enabled.
 *
 * Values:
 * - 1 - REG_BYPASS_COUNTER enabled.
 * - 0 - REG_BYPASS_COUNTER disabled
 */
/*@{*/
#define BP_CCM_CCR_RBC_EN    (27U)         /*!< Bit position for CCM_CCR_RBC_EN. */
#define BM_CCM_CCR_RBC_EN    (0x08000000U) /*!< Bit mask for CCM_CCR_RBC_EN. */
#define BS_CCM_CCR_RBC_EN    (1U)          /*!< Bit field size in bits for CCM_CCR_RBC_EN. */

/*! @brief Read current value of the CCM_CCR_RBC_EN field. */
#define BR_CCM_CCR_RBC_EN(x) (HW_CCM_CCR(x).B.RBC_EN)

/*! @brief Format value for bitfield CCM_CCR_RBC_EN. */
#define BF_CCM_CCR_RBC_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCR_RBC_EN) & BM_CCM_CCR_RBC_EN)

/*! @brief Set the RBC_EN field to a new value. */
#define BW_CCM_CCR_RBC_EN(x, v) (HW_CCM_CCR_WR(x, (HW_CCM_CCR_RD(x) & ~BM_CCM_CCR_RBC_EN) | BF_CCM_CCR_RBC_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCDR - CCM Control Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCDR - CCM Control Divider Register (RW)
 *
 * Reset value: 0x00040000U
 *
 * The figure below represents the CCM Control Divider Register (CCDR), which
 * contains bits that control the loading of the dividers that need handshake with
 * the modules they affect. The table below provides its field descriptions.
 */
typedef union _hw_ccm_ccdr
{
    uint32_t U;
    struct _hw_ccm_ccdr_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t MMDC_CH1_MASK : 1;    /*!< [16]  */
        uint32_t MMDC_CH0_MASK : 1;    /*!< [17]  */
        uint32_t MMDC_CH1_AXI_ROOT_CG : 1; /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ccm_ccdr_t;

/*!
 * @name Constants and macros for entire CCM_CCDR register
 */
/*@{*/
#define HW_CCM_CCDR_ADDR(x)      ((uintptr_t)(x) + 0x4U)

#define HW_CCM_CCDR(x)           (*(__IO hw_ccm_ccdr_t *) HW_CCM_CCDR_ADDR(x))
#define HW_CCM_CCDR_RD(x)        (HW_CCM_CCDR(x).U)
#define HW_CCM_CCDR_WR(x, v)     (HW_CCM_CCDR(x).U = (v))
#define HW_CCM_CCDR_SET(x, v)    (HW_CCM_CCDR_WR(x, HW_CCM_CCDR_RD(x) |  (v)))
#define HW_CCM_CCDR_CLR(x, v)    (HW_CCM_CCDR_WR(x, HW_CCM_CCDR_RD(x) & ~(v)))
#define HW_CCM_CCDR_TOG(x, v)    (HW_CCM_CCDR_WR(x, HW_CCM_CCDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCDR bitfields
 */

/*!
 * @name Register CCM_CCDR, field MMDC_CH1_MASK[16] (RW)
 *
 * During divider ratio mmdc_ch1_axi_podf change or sync mux periph2_clk_sel
 * change (but not jtag) or SRC request during warm reset, mask handshake with
 * mmdc_ch1 module.
 *
 * Values:
 * - 0 - allow handshake with mmdc_ch1 module
 * - 1 - mask handshake with mmdc_ch1. Request signal will not be generated.
 */
/*@{*/
#define BP_CCM_CCDR_MMDC_CH1_MASK (16U)    /*!< Bit position for CCM_CCDR_MMDC_CH1_MASK. */
#define BM_CCM_CCDR_MMDC_CH1_MASK (0x00010000U) /*!< Bit mask for CCM_CCDR_MMDC_CH1_MASK. */
#define BS_CCM_CCDR_MMDC_CH1_MASK (1U)     /*!< Bit field size in bits for CCM_CCDR_MMDC_CH1_MASK. */

/*! @brief Read current value of the CCM_CCDR_MMDC_CH1_MASK field. */
#define BR_CCM_CCDR_MMDC_CH1_MASK(x) (HW_CCM_CCDR(x).B.MMDC_CH1_MASK)

/*! @brief Format value for bitfield CCM_CCDR_MMDC_CH1_MASK. */
#define BF_CCM_CCDR_MMDC_CH1_MASK(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCDR_MMDC_CH1_MASK) & BM_CCM_CCDR_MMDC_CH1_MASK)

/*! @brief Set the MMDC_CH1_MASK field to a new value. */
#define BW_CCM_CCDR_MMDC_CH1_MASK(x, v) (HW_CCM_CCDR_WR(x, (HW_CCM_CCDR_RD(x) & ~BM_CCM_CCDR_MMDC_CH1_MASK) | BF_CCM_CCDR_MMDC_CH1_MASK(v)))
/*@}*/

/*!
 * @name Register CCM_CCDR, field MMDC_CH0_MASK[17] (RW)
 *
 * During divider ratio mmdc_ch0_axi_podf change or sync mux periph_clk_sel
 * change (but not jtag) or SRC request during warm reset, mask handshake with
 * mmdc_ch0 module.
 *
 * Values:
 * - 0 - allow handshake with mmdc_ch0 module
 * - 1 - mask handshake with mmdc_ch0. Request signal will not be generated.
 */
/*@{*/
#define BP_CCM_CCDR_MMDC_CH0_MASK (17U)    /*!< Bit position for CCM_CCDR_MMDC_CH0_MASK. */
#define BM_CCM_CCDR_MMDC_CH0_MASK (0x00020000U) /*!< Bit mask for CCM_CCDR_MMDC_CH0_MASK. */
#define BS_CCM_CCDR_MMDC_CH0_MASK (1U)     /*!< Bit field size in bits for CCM_CCDR_MMDC_CH0_MASK. */

/*! @brief Read current value of the CCM_CCDR_MMDC_CH0_MASK field. */
#define BR_CCM_CCDR_MMDC_CH0_MASK(x) (HW_CCM_CCDR(x).B.MMDC_CH0_MASK)

/*! @brief Format value for bitfield CCM_CCDR_MMDC_CH0_MASK. */
#define BF_CCM_CCDR_MMDC_CH0_MASK(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCDR_MMDC_CH0_MASK) & BM_CCM_CCDR_MMDC_CH0_MASK)

/*! @brief Set the MMDC_CH0_MASK field to a new value. */
#define BW_CCM_CCDR_MMDC_CH0_MASK(x, v) (HW_CCM_CCDR_WR(x, (HW_CCM_CCDR_RD(x) & ~BM_CCM_CCDR_MMDC_CH0_MASK) | BF_CCM_CCDR_MMDC_CH0_MASK(v)))
/*@}*/

/*!
 * @name Register CCM_CCDR, field MMDC_CH1_AXI_ROOT_CG[18] (RW)
 *
 * mmdc_ch1_axi_root cg
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG (18U) /*!< Bit position for CCM_CCDR_MMDC_CH1_AXI_ROOT_CG. */
#define BM_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG (0x00040000U) /*!< Bit mask for CCM_CCDR_MMDC_CH1_AXI_ROOT_CG. */
#define BS_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG (1U) /*!< Bit field size in bits for CCM_CCDR_MMDC_CH1_AXI_ROOT_CG. */

/*! @brief Read current value of the CCM_CCDR_MMDC_CH1_AXI_ROOT_CG field. */
#define BR_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG(x) (HW_CCM_CCDR(x).B.MMDC_CH1_AXI_ROOT_CG)

/*! @brief Format value for bitfield CCM_CCDR_MMDC_CH1_AXI_ROOT_CG. */
#define BF_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG) & BM_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG)

/*! @brief Set the MMDC_CH1_AXI_ROOT_CG field to a new value. */
#define BW_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG(x, v) (HW_CCM_CCDR_WR(x, (HW_CCM_CCDR_RD(x) & ~BM_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG) | BF_CCM_CCDR_MMDC_CH1_AXI_ROOT_CG(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSR - CCM Status Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSR - CCM Status Register (RO)
 *
 * Reset value: 0x00000010U
 *
 * The figure below represents the CCM status Register (CSR). The status bits
 * are read-only bits. The table below provides its field descriptions.
 */
typedef union _hw_ccm_csr
{
    uint32_t U;
    struct _hw_ccm_csr_bitfields
    {
        uint32_t REF_EN_B : 1;         /*!< [0]  */
        uint32_t RESERVED0 : 4;        /*!< [4:1]  */
        uint32_t COSC_READY : 1;       /*!< [5]  */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_ccm_csr_t;

/*!
 * @name Constants and macros for entire CCM_CSR register
 */
/*@{*/
#define HW_CCM_CSR_ADDR(x)       ((uintptr_t)(x) + 0x8U)

#define HW_CCM_CSR(x)            (*(__I hw_ccm_csr_t *) HW_CCM_CSR_ADDR(x))
#define HW_CCM_CSR_RD(x)         (HW_CCM_CSR(x).U)
/*@}*/

/*
 * Constants & macros for individual CCM_CSR bitfields
 */

/*!
 * @name Register CCM_CSR, field REF_EN_B[0] (RO)
 *
 * Status of the value of CCM_REF_EN_B output of ccm
 *
 * Values:
 * - 0 - value of CCM_REF_EN_B is '0'
 * - 1 - value of CCM_REF_EN_B is '1'
 */
/*@{*/
#define BP_CCM_CSR_REF_EN_B  (0U)          /*!< Bit position for CCM_CSR_REF_EN_B. */
#define BM_CCM_CSR_REF_EN_B  (0x00000001U) /*!< Bit mask for CCM_CSR_REF_EN_B. */
#define BS_CCM_CSR_REF_EN_B  (1U)          /*!< Bit field size in bits for CCM_CSR_REF_EN_B. */

/*! @brief Read current value of the CCM_CSR_REF_EN_B field. */
#define BR_CCM_CSR_REF_EN_B(x) (HW_CCM_CSR(x).B.REF_EN_B)
/*@}*/

/*!
 * @name Register CCM_CSR, field COSC_READY[5] (RO)
 *
 * Status indication of on board oscillator. This bit will be asserted if on
 * chip oscillator is enabled and on chip oscillator is not powered down, and if
 * oscnt counter has finished counting.
 *
 * Values:
 * - 0 - on board oscillator is not ready.
 * - 1 - on board oscillator is ready.
 */
/*@{*/
#define BP_CCM_CSR_COSC_READY (5U)         /*!< Bit position for CCM_CSR_COSC_READY. */
#define BM_CCM_CSR_COSC_READY (0x00000020U) /*!< Bit mask for CCM_CSR_COSC_READY. */
#define BS_CCM_CSR_COSC_READY (1U)         /*!< Bit field size in bits for CCM_CSR_COSC_READY. */

/*! @brief Read current value of the CCM_CSR_COSC_READY field. */
#define BR_CCM_CSR_COSC_READY(x) (HW_CCM_CSR(x).B.COSC_READY)
/*@}*/

/*******************************************************************************
 * HW_CCM_CCSR - CCM Clock Switcher Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCSR - CCM Clock Switcher Register (RW)
 *
 * Reset value: 0x00000100U
 *
 * The figure below represents the CCM Clock Switcher register (CCSR). The CCSR
 * register contains bits to control the switcher sub-module dividers and
 * multiplexers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_ccsr
{
    uint32_t U;
    struct _hw_ccm_ccsr_bitfields
    {
        uint32_t PLL3_SW_CLK_SEL : 1;  /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t PLL1_SW_CLK_SEL : 1;  /*!< [2]  */
        uint32_t RESERVED1 : 5;        /*!< [7:3]  */
        uint32_t STEP_SEL : 1;         /*!< [8]  */
        uint32_t pll2_pfd2_dis_mask : 1; /*!< [9]  */
        uint32_t pll2_pfd0_dis_mask : 1; /*!< [10]  */
        uint32_t pll2_pfd1_594m_dis_mask : 1; /*!< [11]  */
        uint32_t pll3_pfd2_dis_mask : 1; /*!< [12]  */
        uint32_t pll3_pfd3_dis_mask : 1; /*!< [13]  */
        uint32_t pll3_pfd0_dis_mask : 1; /*!< [14]  */
        uint32_t pll3_pfd1_dis_mask : 1; /*!< [15]  */
        uint32_t RESERVED2 : 16;       /*!< [31:16]  */
    } B;
} hw_ccm_ccsr_t;

/*!
 * @name Constants and macros for entire CCM_CCSR register
 */
/*@{*/
#define HW_CCM_CCSR_ADDR(x)      ((uintptr_t)(x) + 0xCU)

#define HW_CCM_CCSR(x)           (*(__IO hw_ccm_ccsr_t *) HW_CCM_CCSR_ADDR(x))
#define HW_CCM_CCSR_RD(x)        (HW_CCM_CCSR(x).U)
#define HW_CCM_CCSR_WR(x, v)     (HW_CCM_CCSR(x).U = (v))
#define HW_CCM_CCSR_SET(x, v)    (HW_CCM_CCSR_WR(x, HW_CCM_CCSR_RD(x) |  (v)))
#define HW_CCM_CCSR_CLR(x, v)    (HW_CCM_CCSR_WR(x, HW_CCM_CCSR_RD(x) & ~(v)))
#define HW_CCM_CCSR_TOG(x, v)    (HW_CCM_CCSR_WR(x, HW_CCM_CCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCSR bitfields
 */

/*!
 * @name Register CCM_CCSR, field PLL3_SW_CLK_SEL[0] (RW)
 *
 * Selects source to generate pll3_sw_clk. This bit should only be used for
 * testing purposes.
 *
 * Values:
 * - 0 - pll3_main_clk
 * - 1 - pll3 bypass clock
 */
/*@{*/
#define BP_CCM_CCSR_PLL3_SW_CLK_SEL (0U)   /*!< Bit position for CCM_CCSR_PLL3_SW_CLK_SEL. */
#define BM_CCM_CCSR_PLL3_SW_CLK_SEL (0x00000001U) /*!< Bit mask for CCM_CCSR_PLL3_SW_CLK_SEL. */
#define BS_CCM_CCSR_PLL3_SW_CLK_SEL (1U)   /*!< Bit field size in bits for CCM_CCSR_PLL3_SW_CLK_SEL. */

/*! @brief Read current value of the CCM_CCSR_PLL3_SW_CLK_SEL field. */
#define BR_CCM_CCSR_PLL3_SW_CLK_SEL(x) (HW_CCM_CCSR(x).B.PLL3_SW_CLK_SEL)

/*! @brief Format value for bitfield CCM_CCSR_PLL3_SW_CLK_SEL. */
#define BF_CCM_CCSR_PLL3_SW_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_PLL3_SW_CLK_SEL) & BM_CCM_CCSR_PLL3_SW_CLK_SEL)

/*! @brief Set the PLL3_SW_CLK_SEL field to a new value. */
#define BW_CCM_CCSR_PLL3_SW_CLK_SEL(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_PLL3_SW_CLK_SEL) | BF_CCM_CCSR_PLL3_SW_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field PLL1_SW_CLK_SEL[2] (RW)
 *
 * Selects source to generate pll1_sw_clk.
 *
 * Values:
 * - 0 - pll1_main_clk
 * - 1 - step_clk
 */
/*@{*/
#define BP_CCM_CCSR_PLL1_SW_CLK_SEL (2U)   /*!< Bit position for CCM_CCSR_PLL1_SW_CLK_SEL. */
#define BM_CCM_CCSR_PLL1_SW_CLK_SEL (0x00000004U) /*!< Bit mask for CCM_CCSR_PLL1_SW_CLK_SEL. */
#define BS_CCM_CCSR_PLL1_SW_CLK_SEL (1U)   /*!< Bit field size in bits for CCM_CCSR_PLL1_SW_CLK_SEL. */

/*! @brief Read current value of the CCM_CCSR_PLL1_SW_CLK_SEL field. */
#define BR_CCM_CCSR_PLL1_SW_CLK_SEL(x) (HW_CCM_CCSR(x).B.PLL1_SW_CLK_SEL)

/*! @brief Format value for bitfield CCM_CCSR_PLL1_SW_CLK_SEL. */
#define BF_CCM_CCSR_PLL1_SW_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_PLL1_SW_CLK_SEL) & BM_CCM_CCSR_PLL1_SW_CLK_SEL)

/*! @brief Set the PLL1_SW_CLK_SEL field to a new value. */
#define BW_CCM_CCSR_PLL1_SW_CLK_SEL(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_PLL1_SW_CLK_SEL) | BF_CCM_CCSR_PLL1_SW_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field STEP_SEL[8] (RW)
 *
 * Selects the option to be chosen for the step frequency when shifting ARM
 * frequency. This will control the step_clk. This mux is allowed to be changed only
 * if its output is not used, i.e. ARM uses the output of pll1, and step_clk is
 * not used.
 *
 * Values:
 * - 0 - derive clock from osc_clk (24M) - source for lp_apm.
 * - 1 - derive clock from secondary_clk
 */
/*@{*/
#define BP_CCM_CCSR_STEP_SEL (8U)          /*!< Bit position for CCM_CCSR_STEP_SEL. */
#define BM_CCM_CCSR_STEP_SEL (0x00000100U) /*!< Bit mask for CCM_CCSR_STEP_SEL. */
#define BS_CCM_CCSR_STEP_SEL (1U)          /*!< Bit field size in bits for CCM_CCSR_STEP_SEL. */

/*! @brief Read current value of the CCM_CCSR_STEP_SEL field. */
#define BR_CCM_CCSR_STEP_SEL(x) (HW_CCM_CCSR(x).B.STEP_SEL)

/*! @brief Format value for bitfield CCM_CCSR_STEP_SEL. */
#define BF_CCM_CCSR_STEP_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_STEP_SEL) & BM_CCM_CCSR_STEP_SEL)

/*! @brief Set the STEP_SEL field to a new value. */
#define BW_CCM_CCSR_STEP_SEL(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_STEP_SEL) | BF_CCM_CCSR_STEP_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll2_pfd2_dis_mask[9] (RW)
 *
 * Mask of PLL2 PFD2 auto-disable.
 *
 * Values:
 * - 0 - PLL2 PFD2 disable=0 (PFD always on)
 * - 1 - PLL2 PFD2 disable is managed by associated dividers disable. If all
 *     PLL2 PFD2-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll2_pfd2_dis_mask (9U) /*!< Bit position for CCM_CCSR_pll2_pfd2_dis_mask. */
#define BM_CCM_CCSR_pll2_pfd2_dis_mask (0x00000200U) /*!< Bit mask for CCM_CCSR_pll2_pfd2_dis_mask. */
#define BS_CCM_CCSR_pll2_pfd2_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll2_pfd2_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll2_pfd2_dis_mask field. */
#define BR_CCM_CCSR_pll2_pfd2_dis_mask(x) (HW_CCM_CCSR(x).B.pll2_pfd2_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll2_pfd2_dis_mask. */
#define BF_CCM_CCSR_pll2_pfd2_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll2_pfd2_dis_mask) & BM_CCM_CCSR_pll2_pfd2_dis_mask)

/*! @brief Set the pll2_pfd2_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll2_pfd2_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll2_pfd2_dis_mask) | BF_CCM_CCSR_pll2_pfd2_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll2_pfd0_dis_mask[10] (RW)
 *
 * Mask of PLL2 PFD0 auto-disable.
 *
 * Values:
 * - 0 - PLL2 PFD0 disable=0 (PFD always on)
 * - 1 - PLL2 PFD0 disable is managed by associated dividers disable. If all
 *     PLL2 PFD0-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll2_pfd0_dis_mask (10U) /*!< Bit position for CCM_CCSR_pll2_pfd0_dis_mask. */
#define BM_CCM_CCSR_pll2_pfd0_dis_mask (0x00000400U) /*!< Bit mask for CCM_CCSR_pll2_pfd0_dis_mask. */
#define BS_CCM_CCSR_pll2_pfd0_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll2_pfd0_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll2_pfd0_dis_mask field. */
#define BR_CCM_CCSR_pll2_pfd0_dis_mask(x) (HW_CCM_CCSR(x).B.pll2_pfd0_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll2_pfd0_dis_mask. */
#define BF_CCM_CCSR_pll2_pfd0_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll2_pfd0_dis_mask) & BM_CCM_CCSR_pll2_pfd0_dis_mask)

/*! @brief Set the pll2_pfd0_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll2_pfd0_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll2_pfd0_dis_mask) | BF_CCM_CCSR_pll2_pfd0_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll2_pfd1_594m_dis_mask[11] (RW)
 *
 * Mask of PLL2 PFD1 auto-disable.
 *
 * Values:
 * - 0 - PLL2 PFD1 disable=0 (PFD always on)
 * - 1 - PLL2 PFD1 disable is managed by associated dividers disable. If all
 *     PLL2 PFD1-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll2_pfd1_594m_dis_mask (11U) /*!< Bit position for CCM_CCSR_pll2_pfd1_594m_dis_mask. */
#define BM_CCM_CCSR_pll2_pfd1_594m_dis_mask (0x00000800U) /*!< Bit mask for CCM_CCSR_pll2_pfd1_594m_dis_mask. */
#define BS_CCM_CCSR_pll2_pfd1_594m_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll2_pfd1_594m_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll2_pfd1_594m_dis_mask field. */
#define BR_CCM_CCSR_pll2_pfd1_594m_dis_mask(x) (HW_CCM_CCSR(x).B.pll2_pfd1_594m_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll2_pfd1_594m_dis_mask. */
#define BF_CCM_CCSR_pll2_pfd1_594m_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll2_pfd1_594m_dis_mask) & BM_CCM_CCSR_pll2_pfd1_594m_dis_mask)

/*! @brief Set the pll2_pfd1_594m_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll2_pfd1_594m_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll2_pfd1_594m_dis_mask) | BF_CCM_CCSR_pll2_pfd1_594m_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll3_pfd2_dis_mask[12] (RW)
 *
 * Mask of PLL3 PFD2 auto-disable.
 *
 * Values:
 * - 0 - PLL3 PFD2 disable=0 (PFD always on)
 * - 1 - PLL3 PFD2 disable is managed by associated dividers disable. If all
 *     PLL3 PFD2-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll3_pfd2_dis_mask (12U) /*!< Bit position for CCM_CCSR_pll3_pfd2_dis_mask. */
#define BM_CCM_CCSR_pll3_pfd2_dis_mask (0x00001000U) /*!< Bit mask for CCM_CCSR_pll3_pfd2_dis_mask. */
#define BS_CCM_CCSR_pll3_pfd2_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll3_pfd2_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll3_pfd2_dis_mask field. */
#define BR_CCM_CCSR_pll3_pfd2_dis_mask(x) (HW_CCM_CCSR(x).B.pll3_pfd2_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll3_pfd2_dis_mask. */
#define BF_CCM_CCSR_pll3_pfd2_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll3_pfd2_dis_mask) & BM_CCM_CCSR_pll3_pfd2_dis_mask)

/*! @brief Set the pll3_pfd2_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll3_pfd2_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll3_pfd2_dis_mask) | BF_CCM_CCSR_pll3_pfd2_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll3_pfd3_dis_mask[13] (RW)
 *
 * Mask of PLL3 PFD3 auto-disable.
 *
 * Values:
 * - 0 - PLL3 PFD3 disable=0 (PFD always on)
 * - 1 - PLL3 PFD3 disable is managed by associated dividers disable. If all
 *     PLL3 PFD3-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll3_pfd3_dis_mask (13U) /*!< Bit position for CCM_CCSR_pll3_pfd3_dis_mask. */
#define BM_CCM_CCSR_pll3_pfd3_dis_mask (0x00002000U) /*!< Bit mask for CCM_CCSR_pll3_pfd3_dis_mask. */
#define BS_CCM_CCSR_pll3_pfd3_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll3_pfd3_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll3_pfd3_dis_mask field. */
#define BR_CCM_CCSR_pll3_pfd3_dis_mask(x) (HW_CCM_CCSR(x).B.pll3_pfd3_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll3_pfd3_dis_mask. */
#define BF_CCM_CCSR_pll3_pfd3_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll3_pfd3_dis_mask) & BM_CCM_CCSR_pll3_pfd3_dis_mask)

/*! @brief Set the pll3_pfd3_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll3_pfd3_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll3_pfd3_dis_mask) | BF_CCM_CCSR_pll3_pfd3_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll3_pfd0_dis_mask[14] (RW)
 *
 * Mask of PLL3 PFD0 auto-disable.
 *
 * Values:
 * - 0 - PLL3 PFD0 disable=0 (PFD always on)
 * - 1 - PLL3 PFD0 disable is managed by associated dividers disable. If all
 *     PLL3 PFD0-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll3_pfd0_dis_mask (14U) /*!< Bit position for CCM_CCSR_pll3_pfd0_dis_mask. */
#define BM_CCM_CCSR_pll3_pfd0_dis_mask (0x00004000U) /*!< Bit mask for CCM_CCSR_pll3_pfd0_dis_mask. */
#define BS_CCM_CCSR_pll3_pfd0_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll3_pfd0_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll3_pfd0_dis_mask field. */
#define BR_CCM_CCSR_pll3_pfd0_dis_mask(x) (HW_CCM_CCSR(x).B.pll3_pfd0_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll3_pfd0_dis_mask. */
#define BF_CCM_CCSR_pll3_pfd0_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll3_pfd0_dis_mask) & BM_CCM_CCSR_pll3_pfd0_dis_mask)

/*! @brief Set the pll3_pfd0_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll3_pfd0_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll3_pfd0_dis_mask) | BF_CCM_CCSR_pll3_pfd0_dis_mask(v)))
/*@}*/

/*!
 * @name Register CCM_CCSR, field pll3_pfd1_dis_mask[15] (RW)
 *
 * Mask of PLL3 PFD1 auto-disable.
 *
 * Values:
 * - 0 - - PLL3 PFD1 disable=0 (PFD always on)
 * - 1 - PLL3 PFD1 disable is managed by associated dividers disable. If all
 *     PLL3 PFD1-driven dividers are closed, PFD is disabled.
 */
/*@{*/
#define BP_CCM_CCSR_pll3_pfd1_dis_mask (15U) /*!< Bit position for CCM_CCSR_pll3_pfd1_dis_mask. */
#define BM_CCM_CCSR_pll3_pfd1_dis_mask (0x00008000U) /*!< Bit mask for CCM_CCSR_pll3_pfd1_dis_mask. */
#define BS_CCM_CCSR_pll3_pfd1_dis_mask (1U) /*!< Bit field size in bits for CCM_CCSR_pll3_pfd1_dis_mask. */

/*! @brief Read current value of the CCM_CCSR_pll3_pfd1_dis_mask field. */
#define BR_CCM_CCSR_pll3_pfd1_dis_mask(x) (HW_CCM_CCSR(x).B.pll3_pfd1_dis_mask)

/*! @brief Format value for bitfield CCM_CCSR_pll3_pfd1_dis_mask. */
#define BF_CCM_CCSR_pll3_pfd1_dis_mask(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCSR_pll3_pfd1_dis_mask) & BM_CCM_CCSR_pll3_pfd1_dis_mask)

/*! @brief Set the pll3_pfd1_dis_mask field to a new value. */
#define BW_CCM_CCSR_pll3_pfd1_dis_mask(x, v) (HW_CCM_CCSR_WR(x, (HW_CCM_CCSR_RD(x) & ~BM_CCM_CCSR_pll3_pfd1_dis_mask) | BF_CCM_CCSR_pll3_pfd1_dis_mask(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CACRR - CCM Arm Clock Root Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CACRR - CCM Arm Clock Root Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The figure below represents the CCM Arm Clock Root register (CACRR). The
 * CACRR register contains bits to control the ARM clock root generation. The table
 * below provides its field descriptions.
 */
typedef union _hw_ccm_cacrr
{
    uint32_t U;
    struct _hw_ccm_cacrr_bitfields
    {
        uint32_t ARM_PODF : 3;         /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_ccm_cacrr_t;

/*!
 * @name Constants and macros for entire CCM_CACRR register
 */
/*@{*/
#define HW_CCM_CACRR_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_CCM_CACRR(x)          (*(__IO hw_ccm_cacrr_t *) HW_CCM_CACRR_ADDR(x))
#define HW_CCM_CACRR_RD(x)       (HW_CCM_CACRR(x).U)
#define HW_CCM_CACRR_WR(x, v)    (HW_CCM_CACRR(x).U = (v))
#define HW_CCM_CACRR_SET(x, v)   (HW_CCM_CACRR_WR(x, HW_CCM_CACRR_RD(x) |  (v)))
#define HW_CCM_CACRR_CLR(x, v)   (HW_CCM_CACRR_WR(x, HW_CCM_CACRR_RD(x) & ~(v)))
#define HW_CCM_CACRR_TOG(x, v)   (HW_CCM_CACRR_WR(x, HW_CCM_CACRR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CACRR bitfields
 */

/*!
 * @name Register CCM_CACRR, field ARM_PODF[2:0] (RW)
 *
 * Divider for ARM clock root. If arm_freq_shift_divider is set to '1' then any
 * new write to arm_podf will be held until arm_clk_switch_req signal is asserted.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CACRR_ARM_PODF (0U)         /*!< Bit position for CCM_CACRR_ARM_PODF. */
#define BM_CCM_CACRR_ARM_PODF (0x00000007U) /*!< Bit mask for CCM_CACRR_ARM_PODF. */
#define BS_CCM_CACRR_ARM_PODF (3U)         /*!< Bit field size in bits for CCM_CACRR_ARM_PODF. */

/*! @brief Read current value of the CCM_CACRR_ARM_PODF field. */
#define BR_CCM_CACRR_ARM_PODF(x) (HW_CCM_CACRR(x).B.ARM_PODF)

/*! @brief Format value for bitfield CCM_CACRR_ARM_PODF. */
#define BF_CCM_CACRR_ARM_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CACRR_ARM_PODF) & BM_CCM_CACRR_ARM_PODF)

/*! @brief Set the ARM_PODF field to a new value. */
#define BW_CCM_CACRR_ARM_PODF(x, v) (HW_CCM_CACRR_WR(x, (HW_CCM_CACRR_RD(x) & ~BM_CCM_CACRR_ARM_PODF) | BF_CCM_CACRR_ARM_PODF(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CBCDR - CCM Bus Clock Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CBCDR - CCM Bus Clock Divider Register (RW)
 *
 * Reset value: 0x00018D00U
 *
 * The figure below represents the CCM Bus Clock Divider Register (CBCDR). The
 * CBCDR register contains bits to control the clock generation sub module
 * dividers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_cbcdr
{
    uint32_t U;
    struct _hw_ccm_cbcdr_bitfields
    {
        uint32_t PERIPH2_CLK2_PODF : 3; /*!< [2:0]  */
        uint32_t mmdc_ch1_axi_podf : 3; /*!< [5:3]  */
        uint32_t axi_sel : 1;          /*!< [6]  */
        uint32_t axi_alt_sel : 1;      /*!< [7]  */
        uint32_t IPG_PODF : 2;         /*!< [9:8]  */
        uint32_t AHB_PODF : 3;         /*!< [12:10]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t axi_podf : 3;         /*!< [18:16]  */
        uint32_t mmdc_ch0_axi_podf : 3; /*!< [21:19]  */
        uint32_t RESERVED1 : 3;        /*!< [24:22]  */
        uint32_t PERIPH_CLK_SEL : 1;   /*!< [25]  */
        uint32_t PERIPH2_CLK_SEL : 1;  /*!< [26]  */
        uint32_t PERIPH_CLK2_PODF : 3; /*!< [29:27]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_cbcdr_t;

/*!
 * @name Constants and macros for entire CCM_CBCDR register
 */
/*@{*/
#define HW_CCM_CBCDR_ADDR(x)     ((uintptr_t)(x) + 0x14U)

#define HW_CCM_CBCDR(x)          (*(__IO hw_ccm_cbcdr_t *) HW_CCM_CBCDR_ADDR(x))
#define HW_CCM_CBCDR_RD(x)       (HW_CCM_CBCDR(x).U)
#define HW_CCM_CBCDR_WR(x, v)    (HW_CCM_CBCDR(x).U = (v))
#define HW_CCM_CBCDR_SET(x, v)   (HW_CCM_CBCDR_WR(x, HW_CCM_CBCDR_RD(x) |  (v)))
#define HW_CCM_CBCDR_CLR(x, v)   (HW_CCM_CBCDR_WR(x, HW_CCM_CBCDR_RD(x) & ~(v)))
#define HW_CCM_CBCDR_TOG(x, v)   (HW_CCM_CBCDR_WR(x, HW_CCM_CBCDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CBCDR bitfields
 */

/*!
 * @name Register CCM_CBCDR, field PERIPH2_CLK2_PODF[2:0] (RW)
 *
 * Divider for periph2_clk2 podf. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_PERIPH2_CLK2_PODF (0U) /*!< Bit position for CCM_CBCDR_PERIPH2_CLK2_PODF. */
#define BM_CCM_CBCDR_PERIPH2_CLK2_PODF (0x00000007U) /*!< Bit mask for CCM_CBCDR_PERIPH2_CLK2_PODF. */
#define BS_CCM_CBCDR_PERIPH2_CLK2_PODF (3U) /*!< Bit field size in bits for CCM_CBCDR_PERIPH2_CLK2_PODF. */

/*! @brief Read current value of the CCM_CBCDR_PERIPH2_CLK2_PODF field. */
#define BR_CCM_CBCDR_PERIPH2_CLK2_PODF(x) (HW_CCM_CBCDR(x).B.PERIPH2_CLK2_PODF)

/*! @brief Format value for bitfield CCM_CBCDR_PERIPH2_CLK2_PODF. */
#define BF_CCM_CBCDR_PERIPH2_CLK2_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_PERIPH2_CLK2_PODF) & BM_CCM_CBCDR_PERIPH2_CLK2_PODF)

/*! @brief Set the PERIPH2_CLK2_PODF field to a new value. */
#define BW_CCM_CBCDR_PERIPH2_CLK2_PODF(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_PERIPH2_CLK2_PODF) | BF_CCM_CBCDR_PERIPH2_CLK2_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field mmdc_ch1_axi_podf[5:3] (RW)
 *
 * Divider for mmdc_ch1_axi podf. This design implementation does not use
 * MMDC_CH1_CLK_ROOT as a clock source to the MMDC. Only MMDC_CH0_CLK_ROOT is used.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_mmdc_ch1_axi_podf (3U) /*!< Bit position for CCM_CBCDR_mmdc_ch1_axi_podf. */
#define BM_CCM_CBCDR_mmdc_ch1_axi_podf (0x00000038U) /*!< Bit mask for CCM_CBCDR_mmdc_ch1_axi_podf. */
#define BS_CCM_CBCDR_mmdc_ch1_axi_podf (3U) /*!< Bit field size in bits for CCM_CBCDR_mmdc_ch1_axi_podf. */

/*! @brief Read current value of the CCM_CBCDR_mmdc_ch1_axi_podf field. */
#define BR_CCM_CBCDR_mmdc_ch1_axi_podf(x) (HW_CCM_CBCDR(x).B.mmdc_ch1_axi_podf)

/*! @brief Format value for bitfield CCM_CBCDR_mmdc_ch1_axi_podf. */
#define BF_CCM_CBCDR_mmdc_ch1_axi_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_mmdc_ch1_axi_podf) & BM_CCM_CBCDR_mmdc_ch1_axi_podf)

/*! @brief Set the mmdc_ch1_axi_podf field to a new value. */
#define BW_CCM_CBCDR_mmdc_ch1_axi_podf(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_mmdc_ch1_axi_podf) | BF_CCM_CBCDR_mmdc_ch1_axi_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field axi_sel[6] (RW)
 *
 * AXI clock source select
 *
 * Values:
 * - 0 - Periph_clk output will be used as AXI clock root
 * - 1 - AXI alternative clock will be used as AXI clock root
 */
/*@{*/
#define BP_CCM_CBCDR_axi_sel (6U)          /*!< Bit position for CCM_CBCDR_axi_sel. */
#define BM_CCM_CBCDR_axi_sel (0x00000040U) /*!< Bit mask for CCM_CBCDR_axi_sel. */
#define BS_CCM_CBCDR_axi_sel (1U)          /*!< Bit field size in bits for CCM_CBCDR_axi_sel. */

/*! @brief Read current value of the CCM_CBCDR_axi_sel field. */
#define BR_CCM_CBCDR_axi_sel(x) (HW_CCM_CBCDR(x).B.axi_sel)

/*! @brief Format value for bitfield CCM_CBCDR_axi_sel. */
#define BF_CCM_CBCDR_axi_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_axi_sel) & BM_CCM_CBCDR_axi_sel)

/*! @brief Set the axi_sel field to a new value. */
#define BW_CCM_CBCDR_axi_sel(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_axi_sel) | BF_CCM_CBCDR_axi_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field axi_alt_sel[7] (RW)
 *
 * AXI alternative clock select
 *
 * Values:
 * - 0 - PLL2 PFD2 will be selected as alternative clock for AXI root clock
 * - 1 - PLL3 PFD1 will be selected as alternative clock for AXI root clock
 */
/*@{*/
#define BP_CCM_CBCDR_axi_alt_sel (7U)      /*!< Bit position for CCM_CBCDR_axi_alt_sel. */
#define BM_CCM_CBCDR_axi_alt_sel (0x00000080U) /*!< Bit mask for CCM_CBCDR_axi_alt_sel. */
#define BS_CCM_CBCDR_axi_alt_sel (1U)      /*!< Bit field size in bits for CCM_CBCDR_axi_alt_sel. */

/*! @brief Read current value of the CCM_CBCDR_axi_alt_sel field. */
#define BR_CCM_CBCDR_axi_alt_sel(x) (HW_CCM_CBCDR(x).B.axi_alt_sel)

/*! @brief Format value for bitfield CCM_CBCDR_axi_alt_sel. */
#define BF_CCM_CBCDR_axi_alt_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_axi_alt_sel) & BM_CCM_CBCDR_axi_alt_sel)

/*! @brief Set the axi_alt_sel field to a new value. */
#define BW_CCM_CBCDR_axi_alt_sel(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_axi_alt_sel) | BF_CCM_CBCDR_axi_alt_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field IPG_PODF[9:8] (RW)
 *
 * Divider for ipg podf. SDMA module will not support ratio of 1:3 and 1:4 for
 * ahb_clk:ipg_clk. In case SDMA is used, then those ratios should not be used.
 *
 * Values:
 * - 00 - divide by 1
 * - 01 - divide by 2
 * - 10 - divide by 3
 * - 11 - divide by 4
 */
/*@{*/
#define BP_CCM_CBCDR_IPG_PODF (8U)         /*!< Bit position for CCM_CBCDR_IPG_PODF. */
#define BM_CCM_CBCDR_IPG_PODF (0x00000300U) /*!< Bit mask for CCM_CBCDR_IPG_PODF. */
#define BS_CCM_CBCDR_IPG_PODF (2U)         /*!< Bit field size in bits for CCM_CBCDR_IPG_PODF. */

/*! @brief Read current value of the CCM_CBCDR_IPG_PODF field. */
#define BR_CCM_CBCDR_IPG_PODF(x) (HW_CCM_CBCDR(x).B.IPG_PODF)

/*! @brief Format value for bitfield CCM_CBCDR_IPG_PODF. */
#define BF_CCM_CBCDR_IPG_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_IPG_PODF) & BM_CCM_CBCDR_IPG_PODF)

/*! @brief Set the IPG_PODF field to a new value. */
#define BW_CCM_CBCDR_IPG_PODF(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_IPG_PODF) | BF_CCM_CBCDR_IPG_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field AHB_PODF[12:10] (RW)
 *
 * Divider for AHB PODF. Any change of this divider might involve handshake with
 * EMIand IPU. See CDHIPR register for the handshake busy bits.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_AHB_PODF (10U)        /*!< Bit position for CCM_CBCDR_AHB_PODF. */
#define BM_CCM_CBCDR_AHB_PODF (0x00001C00U) /*!< Bit mask for CCM_CBCDR_AHB_PODF. */
#define BS_CCM_CBCDR_AHB_PODF (3U)         /*!< Bit field size in bits for CCM_CBCDR_AHB_PODF. */

/*! @brief Read current value of the CCM_CBCDR_AHB_PODF field. */
#define BR_CCM_CBCDR_AHB_PODF(x) (HW_CCM_CBCDR(x).B.AHB_PODF)

/*! @brief Format value for bitfield CCM_CBCDR_AHB_PODF. */
#define BF_CCM_CBCDR_AHB_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_AHB_PODF) & BM_CCM_CBCDR_AHB_PODF)

/*! @brief Set the AHB_PODF field to a new value. */
#define BW_CCM_CBCDR_AHB_PODF(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_AHB_PODF) | BF_CCM_CBCDR_AHB_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field axi_podf[18:16] (RW)
 *
 * Divider for axi podf. Any change of this divider might involve handshake with
 * EMIand IPU. See CDHIPR register for the handshake busy bits.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_axi_podf (16U)        /*!< Bit position for CCM_CBCDR_axi_podf. */
#define BM_CCM_CBCDR_axi_podf (0x00070000U) /*!< Bit mask for CCM_CBCDR_axi_podf. */
#define BS_CCM_CBCDR_axi_podf (3U)         /*!< Bit field size in bits for CCM_CBCDR_axi_podf. */

/*! @brief Read current value of the CCM_CBCDR_axi_podf field. */
#define BR_CCM_CBCDR_axi_podf(x) (HW_CCM_CBCDR(x).B.axi_podf)

/*! @brief Format value for bitfield CCM_CBCDR_axi_podf. */
#define BF_CCM_CBCDR_axi_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_axi_podf) & BM_CCM_CBCDR_axi_podf)

/*! @brief Set the axi_podf field to a new value. */
#define BW_CCM_CBCDR_axi_podf(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_axi_podf) | BF_CCM_CBCDR_axi_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field mmdc_ch0_axi_podf[21:19] (RW)
 *
 * Divider for mmdc_ch0_axi podf.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_mmdc_ch0_axi_podf (19U) /*!< Bit position for CCM_CBCDR_mmdc_ch0_axi_podf. */
#define BM_CCM_CBCDR_mmdc_ch0_axi_podf (0x00380000U) /*!< Bit mask for CCM_CBCDR_mmdc_ch0_axi_podf. */
#define BS_CCM_CBCDR_mmdc_ch0_axi_podf (3U) /*!< Bit field size in bits for CCM_CBCDR_mmdc_ch0_axi_podf. */

/*! @brief Read current value of the CCM_CBCDR_mmdc_ch0_axi_podf field. */
#define BR_CCM_CBCDR_mmdc_ch0_axi_podf(x) (HW_CCM_CBCDR(x).B.mmdc_ch0_axi_podf)

/*! @brief Format value for bitfield CCM_CBCDR_mmdc_ch0_axi_podf. */
#define BF_CCM_CBCDR_mmdc_ch0_axi_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_mmdc_ch0_axi_podf) & BM_CCM_CBCDR_mmdc_ch0_axi_podf)

/*! @brief Set the mmdc_ch0_axi_podf field to a new value. */
#define BW_CCM_CBCDR_mmdc_ch0_axi_podf(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_mmdc_ch0_axi_podf) | BF_CCM_CBCDR_mmdc_ch0_axi_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field PERIPH_CLK_SEL[25] (RW)
 *
 * Selector for peripheral main clock (source of MMDC_CH0_CLK_ROOT). Alternative
 * clock source should be used when PLL is relocked. For PLL relock procedure
 * pls refer to the PLL chapter. Any change of this sync mux select will involve
 * handshake with the MMDC. Refer to the CCDR and CDHIPR registers for the
 * handshake bypass and busy bits.
 *
 * Values:
 * - 0 - PLL2 (pll2_main_clk)
 * - 1 - derive clock from periph_clk2_clk clock source.
 */
/*@{*/
#define BP_CCM_CBCDR_PERIPH_CLK_SEL (25U)  /*!< Bit position for CCM_CBCDR_PERIPH_CLK_SEL. */
#define BM_CCM_CBCDR_PERIPH_CLK_SEL (0x02000000U) /*!< Bit mask for CCM_CBCDR_PERIPH_CLK_SEL. */
#define BS_CCM_CBCDR_PERIPH_CLK_SEL (1U)   /*!< Bit field size in bits for CCM_CBCDR_PERIPH_CLK_SEL. */

/*! @brief Read current value of the CCM_CBCDR_PERIPH_CLK_SEL field. */
#define BR_CCM_CBCDR_PERIPH_CLK_SEL(x) (HW_CCM_CBCDR(x).B.PERIPH_CLK_SEL)

/*! @brief Format value for bitfield CCM_CBCDR_PERIPH_CLK_SEL. */
#define BF_CCM_CBCDR_PERIPH_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_PERIPH_CLK_SEL) & BM_CCM_CBCDR_PERIPH_CLK_SEL)

/*! @brief Set the PERIPH_CLK_SEL field to a new value. */
#define BW_CCM_CBCDR_PERIPH_CLK_SEL(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_PERIPH_CLK_SEL) | BF_CCM_CBCDR_PERIPH_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field PERIPH2_CLK_SEL[26] (RW)
 *
 * Selector for peripheral2 main clock (source of mmdc_ch1_clk_root ). Any
 * change of this mux select will involve handshake with the MMDC. Refer to the CCDR
 * and CDHIPR registers for the handshake bypass and busy bits.
 *
 * Values:
 * - 0 - PLL2 (pll2_main_clk)
 * - 1 - derive clock from periph2_clk2_clk clock source.
 */
/*@{*/
#define BP_CCM_CBCDR_PERIPH2_CLK_SEL (26U) /*!< Bit position for CCM_CBCDR_PERIPH2_CLK_SEL. */
#define BM_CCM_CBCDR_PERIPH2_CLK_SEL (0x04000000U) /*!< Bit mask for CCM_CBCDR_PERIPH2_CLK_SEL. */
#define BS_CCM_CBCDR_PERIPH2_CLK_SEL (1U)  /*!< Bit field size in bits for CCM_CBCDR_PERIPH2_CLK_SEL. */

/*! @brief Read current value of the CCM_CBCDR_PERIPH2_CLK_SEL field. */
#define BR_CCM_CBCDR_PERIPH2_CLK_SEL(x) (HW_CCM_CBCDR(x).B.PERIPH2_CLK_SEL)

/*! @brief Format value for bitfield CCM_CBCDR_PERIPH2_CLK_SEL. */
#define BF_CCM_CBCDR_PERIPH2_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_PERIPH2_CLK_SEL) & BM_CCM_CBCDR_PERIPH2_CLK_SEL)

/*! @brief Set the PERIPH2_CLK_SEL field to a new value. */
#define BW_CCM_CBCDR_PERIPH2_CLK_SEL(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_PERIPH2_CLK_SEL) | BF_CCM_CBCDR_PERIPH2_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCDR, field PERIPH_CLK2_PODF[29:27] (RW)
 *
 * Divider for periph2 clock podf.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCDR_PERIPH_CLK2_PODF (27U) /*!< Bit position for CCM_CBCDR_PERIPH_CLK2_PODF. */
#define BM_CCM_CBCDR_PERIPH_CLK2_PODF (0x38000000U) /*!< Bit mask for CCM_CBCDR_PERIPH_CLK2_PODF. */
#define BS_CCM_CBCDR_PERIPH_CLK2_PODF (3U) /*!< Bit field size in bits for CCM_CBCDR_PERIPH_CLK2_PODF. */

/*! @brief Read current value of the CCM_CBCDR_PERIPH_CLK2_PODF field. */
#define BR_CCM_CBCDR_PERIPH_CLK2_PODF(x) (HW_CCM_CBCDR(x).B.PERIPH_CLK2_PODF)

/*! @brief Format value for bitfield CCM_CBCDR_PERIPH_CLK2_PODF. */
#define BF_CCM_CBCDR_PERIPH_CLK2_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCDR_PERIPH_CLK2_PODF) & BM_CCM_CBCDR_PERIPH_CLK2_PODF)

/*! @brief Set the PERIPH_CLK2_PODF field to a new value. */
#define BW_CCM_CBCDR_PERIPH_CLK2_PODF(x, v) (HW_CCM_CBCDR_WR(x, (HW_CCM_CBCDR_RD(x) & ~BM_CCM_CBCDR_PERIPH_CLK2_PODF) | BF_CCM_CBCDR_PERIPH_CLK2_PODF(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CBCMR - CCM Bus Clock Multiplexer Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CBCMR - CCM Bus Clock Multiplexer Register (RW)
 *
 * Reset value: 0x00030324U
 *
 * The figure below represents the CCM Bus Clock Multiplexer Register (CBCMR).
 * The CBCMR register contains bits to control the multiplexers that generate the
 * bus clocks. The table below provides its field descriptions. Any change on the
 * above multiplexer will have to be done while the module that its clock is
 * affected is not functional and the respective clock is gated in LPCG. If the
 * change will be done during operation of the module, then it is not guaranteed that
 * the modules operation will not be harmed. The change for arm_clk_sel should
 * be done through sdma so that ARM will not use this clock during the change and
 * the clock will be gated in LPCG.
 */
typedef union _hw_ccm_cbcmr
{
    uint32_t U;
    struct _hw_ccm_cbcmr_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t pre_clk_sel : 1;      /*!< [1]  */
        uint32_t RESERVED1 : 2;        /*!< [3:2]  */
        uint32_t gpu3d_core_clk_sel : 2; /*!< [5:4]  */
        uint32_t RESERVED2 : 2;        /*!< [7:6]  */
        uint32_t gpu3d_shader_clk_sel : 2; /*!< [9:8]  */
        uint32_t pcie_axi_clk_sel : 1; /*!< [10]  */
        uint32_t vdoaxi_clk_sel : 1;   /*!< [11]  */
        uint32_t PERIPH_CLK2_SEL : 2;  /*!< [13:12]  */
        uint32_t vpu_axi_clk_sel : 2;  /*!< [15:14]  */
        uint32_t gpu2d_core_clk_sel : 2; /*!< [17:16]  */
        uint32_t PRE_PERIPH_CLK_SEL : 2; /*!< [19:18]  */
        uint32_t PERIPH2_CLK2_SEL : 1; /*!< [20]  */
        uint32_t PRE_PERIPH2_CLK_SEL : 2; /*!< [22:21]  */
        uint32_t gpu2d_core_clk_podf : 3; /*!< [25:23]  */
        uint32_t gpu3d_core_podf : 3;  /*!< [28:26]  */
        uint32_t gpu3d_shader_podf : 3; /*!< [31:29]  */
    } B;
} hw_ccm_cbcmr_t;

/*!
 * @name Constants and macros for entire CCM_CBCMR register
 */
/*@{*/
#define HW_CCM_CBCMR_ADDR(x)     ((uintptr_t)(x) + 0x18U)

#define HW_CCM_CBCMR(x)          (*(__IO hw_ccm_cbcmr_t *) HW_CCM_CBCMR_ADDR(x))
#define HW_CCM_CBCMR_RD(x)       (HW_CCM_CBCMR(x).U)
#define HW_CCM_CBCMR_WR(x, v)    (HW_CCM_CBCMR(x).U = (v))
#define HW_CCM_CBCMR_SET(x, v)   (HW_CCM_CBCMR_WR(x, HW_CCM_CBCMR_RD(x) |  (v)))
#define HW_CCM_CBCMR_CLR(x, v)   (HW_CCM_CBCMR_WR(x, HW_CCM_CBCMR_RD(x) & ~(v)))
#define HW_CCM_CBCMR_TOG(x, v)   (HW_CCM_CBCMR_WR(x, HW_CCM_CBCMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CBCMR bitfields
 */

/*!
 * @name Register CCM_CBCMR, field pre_clk_sel[1] (RW)
 *
 * Selector for PRE clock multiplexer
 *
 * Values:
 * - 0 - derive clock from axi
 * - 1 - derive clock from system_133M_clk
 */
/*@{*/
#define BP_CCM_CBCMR_pre_clk_sel (1U)      /*!< Bit position for CCM_CBCMR_pre_clk_sel. */
#define BM_CCM_CBCMR_pre_clk_sel (0x00000002U) /*!< Bit mask for CCM_CBCMR_pre_clk_sel. */
#define BS_CCM_CBCMR_pre_clk_sel (1U)      /*!< Bit field size in bits for CCM_CBCMR_pre_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_pre_clk_sel field. */
#define BR_CCM_CBCMR_pre_clk_sel(x) (HW_CCM_CBCMR(x).B.pre_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_pre_clk_sel. */
#define BF_CCM_CBCMR_pre_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_pre_clk_sel) & BM_CCM_CBCMR_pre_clk_sel)

/*! @brief Set the pre_clk_sel field to a new value. */
#define BW_CCM_CBCMR_pre_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_pre_clk_sel) | BF_CCM_CBCMR_pre_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu3d_core_clk_sel[5:4] (RW)
 *
 * Selector for gpu3d_core clock multiplexer
 *
 * Values:
 * - 00 - derive clock from mmdc_ch0
 * - 01 - derive clock from pll3_sw_clk
 * - 10 - derive clock from PLL2 PFD1
 * - 11 - derive clock from PLL2 PFD2
 */
/*@{*/
#define BP_CCM_CBCMR_gpu3d_core_clk_sel (4U) /*!< Bit position for CCM_CBCMR_gpu3d_core_clk_sel. */
#define BM_CCM_CBCMR_gpu3d_core_clk_sel (0x00000030U) /*!< Bit mask for CCM_CBCMR_gpu3d_core_clk_sel. */
#define BS_CCM_CBCMR_gpu3d_core_clk_sel (2U) /*!< Bit field size in bits for CCM_CBCMR_gpu3d_core_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_gpu3d_core_clk_sel field. */
#define BR_CCM_CBCMR_gpu3d_core_clk_sel(x) (HW_CCM_CBCMR(x).B.gpu3d_core_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_gpu3d_core_clk_sel. */
#define BF_CCM_CBCMR_gpu3d_core_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu3d_core_clk_sel) & BM_CCM_CBCMR_gpu3d_core_clk_sel)

/*! @brief Set the gpu3d_core_clk_sel field to a new value. */
#define BW_CCM_CBCMR_gpu3d_core_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu3d_core_clk_sel) | BF_CCM_CBCMR_gpu3d_core_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu3d_shader_clk_sel[9:8] (RW)
 *
 * Selector for gpu3d_shader clock multiplexer
 *
 * Values:
 * - 00 - derive clock from mmdc_ch0 clk
 * - 01 - derive clock from pll3_sw_clk
 * - 10 - derive clock from PLL2 PFD1
 * - 11 - derive clock from PLL3 PFD0
 */
/*@{*/
#define BP_CCM_CBCMR_gpu3d_shader_clk_sel (8U) /*!< Bit position for CCM_CBCMR_gpu3d_shader_clk_sel. */
#define BM_CCM_CBCMR_gpu3d_shader_clk_sel (0x00000300U) /*!< Bit mask for CCM_CBCMR_gpu3d_shader_clk_sel. */
#define BS_CCM_CBCMR_gpu3d_shader_clk_sel (2U) /*!< Bit field size in bits for CCM_CBCMR_gpu3d_shader_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_gpu3d_shader_clk_sel field. */
#define BR_CCM_CBCMR_gpu3d_shader_clk_sel(x) (HW_CCM_CBCMR(x).B.gpu3d_shader_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_gpu3d_shader_clk_sel. */
#define BF_CCM_CBCMR_gpu3d_shader_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu3d_shader_clk_sel) & BM_CCM_CBCMR_gpu3d_shader_clk_sel)

/*! @brief Set the gpu3d_shader_clk_sel field to a new value. */
#define BW_CCM_CBCMR_gpu3d_shader_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu3d_shader_clk_sel) | BF_CCM_CBCMR_gpu3d_shader_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field pcie_axi_clk_sel[10] (RW)
 *
 * Selector for pcie_axi clock multiplexer
 *
 * Values:
 * - 0 - derive clock from AXI clock
 * - 1 - derive clock from AHB clock
 */
/*@{*/
#define BP_CCM_CBCMR_pcie_axi_clk_sel (10U) /*!< Bit position for CCM_CBCMR_pcie_axi_clk_sel. */
#define BM_CCM_CBCMR_pcie_axi_clk_sel (0x00000400U) /*!< Bit mask for CCM_CBCMR_pcie_axi_clk_sel. */
#define BS_CCM_CBCMR_pcie_axi_clk_sel (1U) /*!< Bit field size in bits for CCM_CBCMR_pcie_axi_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_pcie_axi_clk_sel field. */
#define BR_CCM_CBCMR_pcie_axi_clk_sel(x) (HW_CCM_CBCMR(x).B.pcie_axi_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_pcie_axi_clk_sel. */
#define BF_CCM_CBCMR_pcie_axi_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_pcie_axi_clk_sel) & BM_CCM_CBCMR_pcie_axi_clk_sel)

/*! @brief Set the pcie_axi_clk_sel field to a new value. */
#define BW_CCM_CBCMR_pcie_axi_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_pcie_axi_clk_sel) | BF_CCM_CBCMR_pcie_axi_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field vdoaxi_clk_sel[11] (RW)
 *
 * Selector for vdoaxi clock multiplexer
 *
 * Values:
 * - 0 - derive clock from AXI clock
 * - 1 - derive clock from AHB clock
 */
/*@{*/
#define BP_CCM_CBCMR_vdoaxi_clk_sel (11U)  /*!< Bit position for CCM_CBCMR_vdoaxi_clk_sel. */
#define BM_CCM_CBCMR_vdoaxi_clk_sel (0x00000800U) /*!< Bit mask for CCM_CBCMR_vdoaxi_clk_sel. */
#define BS_CCM_CBCMR_vdoaxi_clk_sel (1U)   /*!< Bit field size in bits for CCM_CBCMR_vdoaxi_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_vdoaxi_clk_sel field. */
#define BR_CCM_CBCMR_vdoaxi_clk_sel(x) (HW_CCM_CBCMR(x).B.vdoaxi_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_vdoaxi_clk_sel. */
#define BF_CCM_CBCMR_vdoaxi_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_vdoaxi_clk_sel) & BM_CCM_CBCMR_vdoaxi_clk_sel)

/*! @brief Set the vdoaxi_clk_sel field to a new value. */
#define BW_CCM_CBCMR_vdoaxi_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_vdoaxi_clk_sel) | BF_CCM_CBCMR_vdoaxi_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field PERIPH_CLK2_SEL[13:12] (RW)
 *
 * Selector for peripheral clk2 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from pll3_sw_clk
 * - 01 - derive clock from osc_clk (pll1_ref_clk)
 * - 10 - derive clock from pll2_bypass_clk
 * - 11 - reserved
 */
/*@{*/
#define BP_CCM_CBCMR_PERIPH_CLK2_SEL (12U) /*!< Bit position for CCM_CBCMR_PERIPH_CLK2_SEL. */
#define BM_CCM_CBCMR_PERIPH_CLK2_SEL (0x00003000U) /*!< Bit mask for CCM_CBCMR_PERIPH_CLK2_SEL. */
#define BS_CCM_CBCMR_PERIPH_CLK2_SEL (2U)  /*!< Bit field size in bits for CCM_CBCMR_PERIPH_CLK2_SEL. */

/*! @brief Read current value of the CCM_CBCMR_PERIPH_CLK2_SEL field. */
#define BR_CCM_CBCMR_PERIPH_CLK2_SEL(x) (HW_CCM_CBCMR(x).B.PERIPH_CLK2_SEL)

/*! @brief Format value for bitfield CCM_CBCMR_PERIPH_CLK2_SEL. */
#define BF_CCM_CBCMR_PERIPH_CLK2_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_PERIPH_CLK2_SEL) & BM_CCM_CBCMR_PERIPH_CLK2_SEL)

/*! @brief Set the PERIPH_CLK2_SEL field to a new value. */
#define BW_CCM_CBCMR_PERIPH_CLK2_SEL(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_PERIPH_CLK2_SEL) | BF_CCM_CBCMR_PERIPH_CLK2_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field vpu_axi_clk_sel[15:14] (RW)
 *
 * Selector for VPU axi clock multiplexer
 *
 * Values:
 * - 00 - derive clock from AXI
 * - 01 - derive clock from PLL2 PFD2
 * - 10 - derive clock from PLL2 PFD0
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_CBCMR_vpu_axi_clk_sel (14U) /*!< Bit position for CCM_CBCMR_vpu_axi_clk_sel. */
#define BM_CCM_CBCMR_vpu_axi_clk_sel (0x0000C000U) /*!< Bit mask for CCM_CBCMR_vpu_axi_clk_sel. */
#define BS_CCM_CBCMR_vpu_axi_clk_sel (2U)  /*!< Bit field size in bits for CCM_CBCMR_vpu_axi_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_vpu_axi_clk_sel field. */
#define BR_CCM_CBCMR_vpu_axi_clk_sel(x) (HW_CCM_CBCMR(x).B.vpu_axi_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_vpu_axi_clk_sel. */
#define BF_CCM_CBCMR_vpu_axi_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_vpu_axi_clk_sel) & BM_CCM_CBCMR_vpu_axi_clk_sel)

/*! @brief Set the vpu_axi_clk_sel field to a new value. */
#define BW_CCM_CBCMR_vpu_axi_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_vpu_axi_clk_sel) | BF_CCM_CBCMR_vpu_axi_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu2d_core_clk_sel[17:16] (RW)
 *
 * Selector for open vg (GPU2D Core) clock multiplexer
 *
 * Values:
 * - 00 - derive clock from mmdc_ch0_axi_root
 * - 01 - derive clock from pll3_sw_clk
 * - 10 - derive clock from PLL2 PFD1
 * - 11 - derive clock from PLL3 PFD0
 */
/*@{*/
#define BP_CCM_CBCMR_gpu2d_core_clk_sel (16U) /*!< Bit position for CCM_CBCMR_gpu2d_core_clk_sel. */
#define BM_CCM_CBCMR_gpu2d_core_clk_sel (0x00030000U) /*!< Bit mask for CCM_CBCMR_gpu2d_core_clk_sel. */
#define BS_CCM_CBCMR_gpu2d_core_clk_sel (2U) /*!< Bit field size in bits for CCM_CBCMR_gpu2d_core_clk_sel. */

/*! @brief Read current value of the CCM_CBCMR_gpu2d_core_clk_sel field. */
#define BR_CCM_CBCMR_gpu2d_core_clk_sel(x) (HW_CCM_CBCMR(x).B.gpu2d_core_clk_sel)

/*! @brief Format value for bitfield CCM_CBCMR_gpu2d_core_clk_sel. */
#define BF_CCM_CBCMR_gpu2d_core_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu2d_core_clk_sel) & BM_CCM_CBCMR_gpu2d_core_clk_sel)

/*! @brief Set the gpu2d_core_clk_sel field to a new value. */
#define BW_CCM_CBCMR_gpu2d_core_clk_sel(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu2d_core_clk_sel) | BF_CCM_CBCMR_gpu2d_core_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field PRE_PERIPH_CLK_SEL[19:18] (RW)
 *
 * Selector for pre_periph clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL2
 * - 01 - derive clock from PLL2 PFD2
 * - 10 - derive clock from PLL2 PFD0
 * - 11 - derive clock from divided (/2) PLL2 PFD2
 */
/*@{*/
#define BP_CCM_CBCMR_PRE_PERIPH_CLK_SEL (18U) /*!< Bit position for CCM_CBCMR_PRE_PERIPH_CLK_SEL. */
#define BM_CCM_CBCMR_PRE_PERIPH_CLK_SEL (0x000C0000U) /*!< Bit mask for CCM_CBCMR_PRE_PERIPH_CLK_SEL. */
#define BS_CCM_CBCMR_PRE_PERIPH_CLK_SEL (2U) /*!< Bit field size in bits for CCM_CBCMR_PRE_PERIPH_CLK_SEL. */

/*! @brief Read current value of the CCM_CBCMR_PRE_PERIPH_CLK_SEL field. */
#define BR_CCM_CBCMR_PRE_PERIPH_CLK_SEL(x) (HW_CCM_CBCMR(x).B.PRE_PERIPH_CLK_SEL)

/*! @brief Format value for bitfield CCM_CBCMR_PRE_PERIPH_CLK_SEL. */
#define BF_CCM_CBCMR_PRE_PERIPH_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_PRE_PERIPH_CLK_SEL) & BM_CCM_CBCMR_PRE_PERIPH_CLK_SEL)

/*! @brief Set the PRE_PERIPH_CLK_SEL field to a new value. */
#define BW_CCM_CBCMR_PRE_PERIPH_CLK_SEL(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_PRE_PERIPH_CLK_SEL) | BF_CCM_CBCMR_PRE_PERIPH_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field PERIPH2_CLK2_SEL[20] (RW)
 *
 * Selector for periph2_clk2 clock multiplexer
 *
 * Values:
 * - 0 - derive clock from pll3_sw_clk
 * - 1 - derive clock from PLL2 Main
 */
/*@{*/
#define BP_CCM_CBCMR_PERIPH2_CLK2_SEL (20U) /*!< Bit position for CCM_CBCMR_PERIPH2_CLK2_SEL. */
#define BM_CCM_CBCMR_PERIPH2_CLK2_SEL (0x00100000U) /*!< Bit mask for CCM_CBCMR_PERIPH2_CLK2_SEL. */
#define BS_CCM_CBCMR_PERIPH2_CLK2_SEL (1U) /*!< Bit field size in bits for CCM_CBCMR_PERIPH2_CLK2_SEL. */

/*! @brief Read current value of the CCM_CBCMR_PERIPH2_CLK2_SEL field. */
#define BR_CCM_CBCMR_PERIPH2_CLK2_SEL(x) (HW_CCM_CBCMR(x).B.PERIPH2_CLK2_SEL)

/*! @brief Format value for bitfield CCM_CBCMR_PERIPH2_CLK2_SEL. */
#define BF_CCM_CBCMR_PERIPH2_CLK2_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_PERIPH2_CLK2_SEL) & BM_CCM_CBCMR_PERIPH2_CLK2_SEL)

/*! @brief Set the PERIPH2_CLK2_SEL field to a new value. */
#define BW_CCM_CBCMR_PERIPH2_CLK2_SEL(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_PERIPH2_CLK2_SEL) | BF_CCM_CBCMR_PERIPH2_CLK2_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field PRE_PERIPH2_CLK_SEL[22:21] (RW)
 *
 * Selector for pre_periph2 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL2
 * - 01 - derive clock from PLL2 PFD2
 * - 10 - derive clock from PLL2 PFD0
 * - 11 - derive clock from divided (/2) PLL2 PFD2
 */
/*@{*/
#define BP_CCM_CBCMR_PRE_PERIPH2_CLK_SEL (21U) /*!< Bit position for CCM_CBCMR_PRE_PERIPH2_CLK_SEL. */
#define BM_CCM_CBCMR_PRE_PERIPH2_CLK_SEL (0x00600000U) /*!< Bit mask for CCM_CBCMR_PRE_PERIPH2_CLK_SEL. */
#define BS_CCM_CBCMR_PRE_PERIPH2_CLK_SEL (2U) /*!< Bit field size in bits for CCM_CBCMR_PRE_PERIPH2_CLK_SEL. */

/*! @brief Read current value of the CCM_CBCMR_PRE_PERIPH2_CLK_SEL field. */
#define BR_CCM_CBCMR_PRE_PERIPH2_CLK_SEL(x) (HW_CCM_CBCMR(x).B.PRE_PERIPH2_CLK_SEL)

/*! @brief Format value for bitfield CCM_CBCMR_PRE_PERIPH2_CLK_SEL. */
#define BF_CCM_CBCMR_PRE_PERIPH2_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_PRE_PERIPH2_CLK_SEL) & BM_CCM_CBCMR_PRE_PERIPH2_CLK_SEL)

/*! @brief Set the PRE_PERIPH2_CLK_SEL field to a new value. */
#define BW_CCM_CBCMR_PRE_PERIPH2_CLK_SEL(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_PRE_PERIPH2_CLK_SEL) | BF_CCM_CBCMR_PRE_PERIPH2_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu2d_core_clk_podf[25:23] (RW)
 *
 * Divider for gpu2d_core clock. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCMR_gpu2d_core_clk_podf (23U) /*!< Bit position for CCM_CBCMR_gpu2d_core_clk_podf. */
#define BM_CCM_CBCMR_gpu2d_core_clk_podf (0x03800000U) /*!< Bit mask for CCM_CBCMR_gpu2d_core_clk_podf. */
#define BS_CCM_CBCMR_gpu2d_core_clk_podf (3U) /*!< Bit field size in bits for CCM_CBCMR_gpu2d_core_clk_podf. */

/*! @brief Read current value of the CCM_CBCMR_gpu2d_core_clk_podf field. */
#define BR_CCM_CBCMR_gpu2d_core_clk_podf(x) (HW_CCM_CBCMR(x).B.gpu2d_core_clk_podf)

/*! @brief Format value for bitfield CCM_CBCMR_gpu2d_core_clk_podf. */
#define BF_CCM_CBCMR_gpu2d_core_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu2d_core_clk_podf) & BM_CCM_CBCMR_gpu2d_core_clk_podf)

/*! @brief Set the gpu2d_core_clk_podf field to a new value. */
#define BW_CCM_CBCMR_gpu2d_core_clk_podf(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu2d_core_clk_podf) | BF_CCM_CBCMR_gpu2d_core_clk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu3d_core_podf[28:26] (RW)
 *
 * Divider for gpu3d_core clock. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCMR_gpu3d_core_podf (26U) /*!< Bit position for CCM_CBCMR_gpu3d_core_podf. */
#define BM_CCM_CBCMR_gpu3d_core_podf (0x1C000000U) /*!< Bit mask for CCM_CBCMR_gpu3d_core_podf. */
#define BS_CCM_CBCMR_gpu3d_core_podf (3U)  /*!< Bit field size in bits for CCM_CBCMR_gpu3d_core_podf. */

/*! @brief Read current value of the CCM_CBCMR_gpu3d_core_podf field. */
#define BR_CCM_CBCMR_gpu3d_core_podf(x) (HW_CCM_CBCMR(x).B.gpu3d_core_podf)

/*! @brief Format value for bitfield CCM_CBCMR_gpu3d_core_podf. */
#define BF_CCM_CBCMR_gpu3d_core_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu3d_core_podf) & BM_CCM_CBCMR_gpu3d_core_podf)

/*! @brief Set the gpu3d_core_podf field to a new value. */
#define BW_CCM_CBCMR_gpu3d_core_podf(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu3d_core_podf) | BF_CCM_CBCMR_gpu3d_core_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CBCMR, field gpu3d_shader_podf[31:29] (RW)
 *
 * Divider for gpu3d_shader clock. Divider should be updated when output clock
 * is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CBCMR_gpu3d_shader_podf (29U) /*!< Bit position for CCM_CBCMR_gpu3d_shader_podf. */
#define BM_CCM_CBCMR_gpu3d_shader_podf (0xE0000000U) /*!< Bit mask for CCM_CBCMR_gpu3d_shader_podf. */
#define BS_CCM_CBCMR_gpu3d_shader_podf (3U) /*!< Bit field size in bits for CCM_CBCMR_gpu3d_shader_podf. */

/*! @brief Read current value of the CCM_CBCMR_gpu3d_shader_podf field. */
#define BR_CCM_CBCMR_gpu3d_shader_podf(x) (HW_CCM_CBCMR(x).B.gpu3d_shader_podf)

/*! @brief Format value for bitfield CCM_CBCMR_gpu3d_shader_podf. */
#define BF_CCM_CBCMR_gpu3d_shader_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CBCMR_gpu3d_shader_podf) & BM_CCM_CBCMR_gpu3d_shader_podf)

/*! @brief Set the gpu3d_shader_podf field to a new value. */
#define BW_CCM_CBCMR_gpu3d_shader_podf(x, v) (HW_CCM_CBCMR_WR(x, (HW_CCM_CBCMR_RD(x) & ~BM_CCM_CBCMR_gpu3d_shader_podf) | BF_CCM_CBCMR_gpu3d_shader_podf(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSCMR1 - CCM Serial Clock Multiplexer Register 1
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSCMR1 - CCM Serial Clock Multiplexer Register 1 (RW)
 *
 * Reset value: 0x01900000U
 *
 * The figure below represents the CCM Serial Clock Multiplexer Register 1
 * (CSCMR1). The CSCMR1 register contains bits to control the multiplexers that
 * generate the serial clocks. The table below provides its field descriptions. Any
 * change on the above multiplexer will have to be done while the module that its
 * clock is affected is not functional and the clock is gated. If the change will
 * be done during operation of the module, then it is not guaranteed that the
 * modules operation will not be harmed.
 */
typedef union _hw_ccm_cscmr1
{
    uint32_t U;
    struct _hw_ccm_cscmr1_bitfields
    {
        uint32_t PERCLK_PODF : 6;      /*!< [5:0]  */
        uint32_t perclk_clk_sel : 1;   /*!< [6]  */
        uint32_t RESERVED0 : 3;        /*!< [9:7]  */
        uint32_t ssi1_clk_sel : 2;     /*!< [11:10]  */
        uint32_t ssi2_clk_sel : 2;     /*!< [13:12]  */
        uint32_t ssi3_clk_sel : 2;     /*!< [15:14]  */
        uint32_t USDHC1_CLK_SEL : 1;   /*!< [16]  */
        uint32_t USDHC2_CLK_SEL : 1;   /*!< [17]  */
        uint32_t usdhc3_clk_sel : 1;   /*!< [18]  */
        uint32_t usdhc4_clk_sel : 1;   /*!< [19]  */
        uint32_t aclk_podf : 3;        /*!< [22:20]  */
        uint32_t ACLK_EIM_SLOW_PODF : 3; /*!< [25:23]  */
        uint32_t RESERVED1 : 1;        /*!< [26]  */
        uint32_t aclk_sel : 2;         /*!< [28:27]  */
        uint32_t ACLK_EIM_SLOW_SEL : 2; /*!< [30:29]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_ccm_cscmr1_t;

/*!
 * @name Constants and macros for entire CCM_CSCMR1 register
 */
/*@{*/
#define HW_CCM_CSCMR1_ADDR(x)    ((uintptr_t)(x) + 0x1CU)

#define HW_CCM_CSCMR1(x)         (*(__IO hw_ccm_cscmr1_t *) HW_CCM_CSCMR1_ADDR(x))
#define HW_CCM_CSCMR1_RD(x)      (HW_CCM_CSCMR1(x).U)
#define HW_CCM_CSCMR1_WR(x, v)   (HW_CCM_CSCMR1(x).U = (v))
#define HW_CCM_CSCMR1_SET(x, v)  (HW_CCM_CSCMR1_WR(x, HW_CCM_CSCMR1_RD(x) |  (v)))
#define HW_CCM_CSCMR1_CLR(x, v)  (HW_CCM_CSCMR1_WR(x, HW_CCM_CSCMR1_RD(x) & ~(v)))
#define HW_CCM_CSCMR1_TOG(x, v)  (HW_CCM_CSCMR1_WR(x, HW_CCM_CSCMR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CSCMR1 bitfields
 */

/*!
 * @name Register CCM_CSCMR1, field PERCLK_PODF[5:0] (RW)
 *
 * Divider for perclk podf.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCMR1_PERCLK_PODF (0U)     /*!< Bit position for CCM_CSCMR1_PERCLK_PODF. */
#define BM_CCM_CSCMR1_PERCLK_PODF (0x0000003FU) /*!< Bit mask for CCM_CSCMR1_PERCLK_PODF. */
#define BS_CCM_CSCMR1_PERCLK_PODF (6U)     /*!< Bit field size in bits for CCM_CSCMR1_PERCLK_PODF. */

/*! @brief Read current value of the CCM_CSCMR1_PERCLK_PODF field. */
#define BR_CCM_CSCMR1_PERCLK_PODF(x) (HW_CCM_CSCMR1(x).B.PERCLK_PODF)

/*! @brief Format value for bitfield CCM_CSCMR1_PERCLK_PODF. */
#define BF_CCM_CSCMR1_PERCLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_PERCLK_PODF) & BM_CCM_CSCMR1_PERCLK_PODF)

/*! @brief Set the PERCLK_PODF field to a new value. */
#define BW_CCM_CSCMR1_PERCLK_PODF(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_PERCLK_PODF) | BF_CCM_CSCMR1_PERCLK_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field perclk_clk_sel[6] (RW)
 *
 * Selector for the perclk clock multiplexor
 *
 * Values:
 * - 0 - derive clock from ipg clk root
 * - 1 - derive clock from osc_clk
 */
/*@{*/
#define BP_CCM_CSCMR1_perclk_clk_sel (6U)  /*!< Bit position for CCM_CSCMR1_perclk_clk_sel. */
#define BM_CCM_CSCMR1_perclk_clk_sel (0x00000040U) /*!< Bit mask for CCM_CSCMR1_perclk_clk_sel. */
#define BS_CCM_CSCMR1_perclk_clk_sel (1U)  /*!< Bit field size in bits for CCM_CSCMR1_perclk_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_perclk_clk_sel field. */
#define BR_CCM_CSCMR1_perclk_clk_sel(x) (HW_CCM_CSCMR1(x).B.perclk_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_perclk_clk_sel. */
#define BF_CCM_CSCMR1_perclk_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_perclk_clk_sel) & BM_CCM_CSCMR1_perclk_clk_sel)

/*! @brief Set the perclk_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_perclk_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_perclk_clk_sel) | BF_CCM_CSCMR1_perclk_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field ssi1_clk_sel[11:10] (RW)
 *
 * Selector for ssi1 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL3 PFD2
 * - 01 - derive clock from PLL3 PFD3
 * - 10 - derive clock from PLL4
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_CSCMR1_ssi1_clk_sel (10U)   /*!< Bit position for CCM_CSCMR1_ssi1_clk_sel. */
#define BM_CCM_CSCMR1_ssi1_clk_sel (0x00000C00U) /*!< Bit mask for CCM_CSCMR1_ssi1_clk_sel. */
#define BS_CCM_CSCMR1_ssi1_clk_sel (2U)    /*!< Bit field size in bits for CCM_CSCMR1_ssi1_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_ssi1_clk_sel field. */
#define BR_CCM_CSCMR1_ssi1_clk_sel(x) (HW_CCM_CSCMR1(x).B.ssi1_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_ssi1_clk_sel. */
#define BF_CCM_CSCMR1_ssi1_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_ssi1_clk_sel) & BM_CCM_CSCMR1_ssi1_clk_sel)

/*! @brief Set the ssi1_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_ssi1_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_ssi1_clk_sel) | BF_CCM_CSCMR1_ssi1_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field ssi2_clk_sel[13:12] (RW)
 *
 * Selector for ssi2 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL3 PFD2
 * - 01 - derive clock from PLL3 PFD3
 * - 10 - derive clock from PLL4
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_CSCMR1_ssi2_clk_sel (12U)   /*!< Bit position for CCM_CSCMR1_ssi2_clk_sel. */
#define BM_CCM_CSCMR1_ssi2_clk_sel (0x00003000U) /*!< Bit mask for CCM_CSCMR1_ssi2_clk_sel. */
#define BS_CCM_CSCMR1_ssi2_clk_sel (2U)    /*!< Bit field size in bits for CCM_CSCMR1_ssi2_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_ssi2_clk_sel field. */
#define BR_CCM_CSCMR1_ssi2_clk_sel(x) (HW_CCM_CSCMR1(x).B.ssi2_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_ssi2_clk_sel. */
#define BF_CCM_CSCMR1_ssi2_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_ssi2_clk_sel) & BM_CCM_CSCMR1_ssi2_clk_sel)

/*! @brief Set the ssi2_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_ssi2_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_ssi2_clk_sel) | BF_CCM_CSCMR1_ssi2_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field ssi3_clk_sel[15:14] (RW)
 *
 * Selector for ssi3 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL3 PFD2
 * - 01 - derive clock from PLL3 PFD3
 * - 10 - derive clock from PLL4
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_CSCMR1_ssi3_clk_sel (14U)   /*!< Bit position for CCM_CSCMR1_ssi3_clk_sel. */
#define BM_CCM_CSCMR1_ssi3_clk_sel (0x0000C000U) /*!< Bit mask for CCM_CSCMR1_ssi3_clk_sel. */
#define BS_CCM_CSCMR1_ssi3_clk_sel (2U)    /*!< Bit field size in bits for CCM_CSCMR1_ssi3_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_ssi3_clk_sel field. */
#define BR_CCM_CSCMR1_ssi3_clk_sel(x) (HW_CCM_CSCMR1(x).B.ssi3_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_ssi3_clk_sel. */
#define BF_CCM_CSCMR1_ssi3_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_ssi3_clk_sel) & BM_CCM_CSCMR1_ssi3_clk_sel)

/*! @brief Set the ssi3_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_ssi3_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_ssi3_clk_sel) | BF_CCM_CSCMR1_ssi3_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field USDHC1_CLK_SEL[16] (RW)
 *
 * Selector for usdhc1 clock multiplexer
 *
 * Values:
 * - 0 - derive clock from PLL2 PFD2
 * - 1 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_USDHC1_CLK_SEL (16U) /*!< Bit position for CCM_CSCMR1_USDHC1_CLK_SEL. */
#define BM_CCM_CSCMR1_USDHC1_CLK_SEL (0x00010000U) /*!< Bit mask for CCM_CSCMR1_USDHC1_CLK_SEL. */
#define BS_CCM_CSCMR1_USDHC1_CLK_SEL (1U)  /*!< Bit field size in bits for CCM_CSCMR1_USDHC1_CLK_SEL. */

/*! @brief Read current value of the CCM_CSCMR1_USDHC1_CLK_SEL field. */
#define BR_CCM_CSCMR1_USDHC1_CLK_SEL(x) (HW_CCM_CSCMR1(x).B.USDHC1_CLK_SEL)

/*! @brief Format value for bitfield CCM_CSCMR1_USDHC1_CLK_SEL. */
#define BF_CCM_CSCMR1_USDHC1_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_USDHC1_CLK_SEL) & BM_CCM_CSCMR1_USDHC1_CLK_SEL)

/*! @brief Set the USDHC1_CLK_SEL field to a new value. */
#define BW_CCM_CSCMR1_USDHC1_CLK_SEL(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_USDHC1_CLK_SEL) | BF_CCM_CSCMR1_USDHC1_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field USDHC2_CLK_SEL[17] (RW)
 *
 * Selector for usdhc2 clock multiplexer
 *
 * Values:
 * - 0 - derive clock from PLL2 PFD2
 * - 1 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_USDHC2_CLK_SEL (17U) /*!< Bit position for CCM_CSCMR1_USDHC2_CLK_SEL. */
#define BM_CCM_CSCMR1_USDHC2_CLK_SEL (0x00020000U) /*!< Bit mask for CCM_CSCMR1_USDHC2_CLK_SEL. */
#define BS_CCM_CSCMR1_USDHC2_CLK_SEL (1U)  /*!< Bit field size in bits for CCM_CSCMR1_USDHC2_CLK_SEL. */

/*! @brief Read current value of the CCM_CSCMR1_USDHC2_CLK_SEL field. */
#define BR_CCM_CSCMR1_USDHC2_CLK_SEL(x) (HW_CCM_CSCMR1(x).B.USDHC2_CLK_SEL)

/*! @brief Format value for bitfield CCM_CSCMR1_USDHC2_CLK_SEL. */
#define BF_CCM_CSCMR1_USDHC2_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_USDHC2_CLK_SEL) & BM_CCM_CSCMR1_USDHC2_CLK_SEL)

/*! @brief Set the USDHC2_CLK_SEL field to a new value. */
#define BW_CCM_CSCMR1_USDHC2_CLK_SEL(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_USDHC2_CLK_SEL) | BF_CCM_CSCMR1_USDHC2_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field usdhc3_clk_sel[18] (RW)
 *
 * Selector for usdhc3 clock multiplexer
 *
 * Values:
 * - 0 - derive clock from PLL2 PFD2
 * - 1 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_usdhc3_clk_sel (18U) /*!< Bit position for CCM_CSCMR1_usdhc3_clk_sel. */
#define BM_CCM_CSCMR1_usdhc3_clk_sel (0x00040000U) /*!< Bit mask for CCM_CSCMR1_usdhc3_clk_sel. */
#define BS_CCM_CSCMR1_usdhc3_clk_sel (1U)  /*!< Bit field size in bits for CCM_CSCMR1_usdhc3_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_usdhc3_clk_sel field. */
#define BR_CCM_CSCMR1_usdhc3_clk_sel(x) (HW_CCM_CSCMR1(x).B.usdhc3_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_usdhc3_clk_sel. */
#define BF_CCM_CSCMR1_usdhc3_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_usdhc3_clk_sel) & BM_CCM_CSCMR1_usdhc3_clk_sel)

/*! @brief Set the usdhc3_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_usdhc3_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_usdhc3_clk_sel) | BF_CCM_CSCMR1_usdhc3_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field usdhc4_clk_sel[19] (RW)
 *
 * Selector for usdhc4 clock multiplexer
 *
 * Values:
 * - 0 - derive clock from PLL2 PFD2
 * - 1 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_usdhc4_clk_sel (19U) /*!< Bit position for CCM_CSCMR1_usdhc4_clk_sel. */
#define BM_CCM_CSCMR1_usdhc4_clk_sel (0x00080000U) /*!< Bit mask for CCM_CSCMR1_usdhc4_clk_sel. */
#define BS_CCM_CSCMR1_usdhc4_clk_sel (1U)  /*!< Bit field size in bits for CCM_CSCMR1_usdhc4_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_usdhc4_clk_sel field. */
#define BR_CCM_CSCMR1_usdhc4_clk_sel(x) (HW_CCM_CSCMR1(x).B.usdhc4_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_usdhc4_clk_sel. */
#define BF_CCM_CSCMR1_usdhc4_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_usdhc4_clk_sel) & BM_CCM_CSCMR1_usdhc4_clk_sel)

/*! @brief Set the usdhc4_clk_sel field to a new value. */
#define BW_CCM_CSCMR1_usdhc4_clk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_usdhc4_clk_sel) | BF_CCM_CSCMR1_usdhc4_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field aclk_podf[22:20] (RW)
 *
 * Divider for aclk clock root.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCMR1_aclk_podf (20U)      /*!< Bit position for CCM_CSCMR1_aclk_podf. */
#define BM_CCM_CSCMR1_aclk_podf (0x00700000U) /*!< Bit mask for CCM_CSCMR1_aclk_podf. */
#define BS_CCM_CSCMR1_aclk_podf (3U)       /*!< Bit field size in bits for CCM_CSCMR1_aclk_podf. */

/*! @brief Read current value of the CCM_CSCMR1_aclk_podf field. */
#define BR_CCM_CSCMR1_aclk_podf(x) (HW_CCM_CSCMR1(x).B.aclk_podf)

/*! @brief Format value for bitfield CCM_CSCMR1_aclk_podf. */
#define BF_CCM_CSCMR1_aclk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_aclk_podf) & BM_CCM_CSCMR1_aclk_podf)

/*! @brief Set the aclk_podf field to a new value. */
#define BW_CCM_CSCMR1_aclk_podf(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_aclk_podf) | BF_CCM_CSCMR1_aclk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field ACLK_EIM_SLOW_PODF[25:23] (RW)
 *
 * Divider for aclk_eim_slow clock root.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCMR1_ACLK_EIM_SLOW_PODF (23U) /*!< Bit position for CCM_CSCMR1_ACLK_EIM_SLOW_PODF. */
#define BM_CCM_CSCMR1_ACLK_EIM_SLOW_PODF (0x03800000U) /*!< Bit mask for CCM_CSCMR1_ACLK_EIM_SLOW_PODF. */
#define BS_CCM_CSCMR1_ACLK_EIM_SLOW_PODF (3U) /*!< Bit field size in bits for CCM_CSCMR1_ACLK_EIM_SLOW_PODF. */

/*! @brief Read current value of the CCM_CSCMR1_ACLK_EIM_SLOW_PODF field. */
#define BR_CCM_CSCMR1_ACLK_EIM_SLOW_PODF(x) (HW_CCM_CSCMR1(x).B.ACLK_EIM_SLOW_PODF)

/*! @brief Format value for bitfield CCM_CSCMR1_ACLK_EIM_SLOW_PODF. */
#define BF_CCM_CSCMR1_ACLK_EIM_SLOW_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_ACLK_EIM_SLOW_PODF) & BM_CCM_CSCMR1_ACLK_EIM_SLOW_PODF)

/*! @brief Set the ACLK_EIM_SLOW_PODF field to a new value. */
#define BW_CCM_CSCMR1_ACLK_EIM_SLOW_PODF(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_ACLK_EIM_SLOW_PODF) | BF_CCM_CSCMR1_ACLK_EIM_SLOW_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field aclk_sel[28:27] (RW)
 *
 * Selector for aclk root clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL2 PFD2
 * - 01 - derive clock from pll3_sw_clk
 * - 10 - derive clock from AXI
 * - 11 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_aclk_sel (27U)       /*!< Bit position for CCM_CSCMR1_aclk_sel. */
#define BM_CCM_CSCMR1_aclk_sel (0x18000000U) /*!< Bit mask for CCM_CSCMR1_aclk_sel. */
#define BS_CCM_CSCMR1_aclk_sel (2U)        /*!< Bit field size in bits for CCM_CSCMR1_aclk_sel. */

/*! @brief Read current value of the CCM_CSCMR1_aclk_sel field. */
#define BR_CCM_CSCMR1_aclk_sel(x) (HW_CCM_CSCMR1(x).B.aclk_sel)

/*! @brief Format value for bitfield CCM_CSCMR1_aclk_sel. */
#define BF_CCM_CSCMR1_aclk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_aclk_sel) & BM_CCM_CSCMR1_aclk_sel)

/*! @brief Set the aclk_sel field to a new value. */
#define BW_CCM_CSCMR1_aclk_sel(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_aclk_sel) | BF_CCM_CSCMR1_aclk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR1, field ACLK_EIM_SLOW_SEL[30:29] (RW)
 *
 * Selector for aclk_eim_slow root clock multiplexer
 *
 * Values:
 * - 00 - derive clock from AXI
 * - 01 - derive clock from pll3_sw_clk
 * - 10 - derive clock from PLL2 PFD2
 * - 11 - derive clock from PLL2 PFD0
 */
/*@{*/
#define BP_CCM_CSCMR1_ACLK_EIM_SLOW_SEL (29U) /*!< Bit position for CCM_CSCMR1_ACLK_EIM_SLOW_SEL. */
#define BM_CCM_CSCMR1_ACLK_EIM_SLOW_SEL (0x60000000U) /*!< Bit mask for CCM_CSCMR1_ACLK_EIM_SLOW_SEL. */
#define BS_CCM_CSCMR1_ACLK_EIM_SLOW_SEL (2U) /*!< Bit field size in bits for CCM_CSCMR1_ACLK_EIM_SLOW_SEL. */

/*! @brief Read current value of the CCM_CSCMR1_ACLK_EIM_SLOW_SEL field. */
#define BR_CCM_CSCMR1_ACLK_EIM_SLOW_SEL(x) (HW_CCM_CSCMR1(x).B.ACLK_EIM_SLOW_SEL)

/*! @brief Format value for bitfield CCM_CSCMR1_ACLK_EIM_SLOW_SEL. */
#define BF_CCM_CSCMR1_ACLK_EIM_SLOW_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR1_ACLK_EIM_SLOW_SEL) & BM_CCM_CSCMR1_ACLK_EIM_SLOW_SEL)

/*! @brief Set the ACLK_EIM_SLOW_SEL field to a new value. */
#define BW_CCM_CSCMR1_ACLK_EIM_SLOW_SEL(x, v) (HW_CCM_CSCMR1_WR(x, (HW_CCM_CSCMR1_RD(x) & ~BM_CCM_CSCMR1_ACLK_EIM_SLOW_SEL) | BF_CCM_CSCMR1_ACLK_EIM_SLOW_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSCMR2 - CCM Serial Clock Multiplexer Register 2
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSCMR2 - CCM Serial Clock Multiplexer Register 2 (RW)
 *
 * Reset value: 0x02B92F06U
 *
 * The figure below represents the CCM Serial Clock Multiplexer Register 2
 * (CSCMR2). The CSCMR2 register contains bits to control the multiplexers that
 * generate the serial clocks. The table below provides its field descriptions. Any
 * change on the above multiplexer will have to be done while the module that its
 * clock is affected is not functional and the clock is gated. If the change will
 * be done during operation of the module, then it is not guaranteed that the
 * modules operation will not be harmed.
 */
typedef union _hw_ccm_cscmr2
{
    uint32_t U;
    struct _hw_ccm_cscmr2_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t CAN_CLK_PODF : 6;     /*!< [7:2]  */
        uint32_t can_clk_sel : 2;      /*!< [9:8]  */
        uint32_t ldb_di0_ipu_div : 1;  /*!< [10]  */
        uint32_t ldb_di1_ipu_div : 1;  /*!< [11]  */
        uint32_t RESERVED1 : 7;        /*!< [18:12]  */
        uint32_t esai_clk_sel : 2;     /*!< [20:19]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ccm_cscmr2_t;

/*!
 * @name Constants and macros for entire CCM_CSCMR2 register
 */
/*@{*/
#define HW_CCM_CSCMR2_ADDR(x)    ((uintptr_t)(x) + 0x20U)

#define HW_CCM_CSCMR2(x)         (*(__IO hw_ccm_cscmr2_t *) HW_CCM_CSCMR2_ADDR(x))
#define HW_CCM_CSCMR2_RD(x)      (HW_CCM_CSCMR2(x).U)
#define HW_CCM_CSCMR2_WR(x, v)   (HW_CCM_CSCMR2(x).U = (v))
#define HW_CCM_CSCMR2_SET(x, v)  (HW_CCM_CSCMR2_WR(x, HW_CCM_CSCMR2_RD(x) |  (v)))
#define HW_CCM_CSCMR2_CLR(x, v)  (HW_CCM_CSCMR2_WR(x, HW_CCM_CSCMR2_RD(x) & ~(v)))
#define HW_CCM_CSCMR2_TOG(x, v)  (HW_CCM_CSCMR2_WR(x, HW_CCM_CSCMR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CSCMR2 bitfields
 */

/*!
 * @name Register CCM_CSCMR2, field CAN_CLK_PODF[7:2] (RW)
 *
 * Divider for can clock podf.
 *
 * Values:
 * - 000000 - divide by 1
 * - 000111 - divide by 8
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CSCMR2_CAN_CLK_PODF (2U)    /*!< Bit position for CCM_CSCMR2_CAN_CLK_PODF. */
#define BM_CCM_CSCMR2_CAN_CLK_PODF (0x000000FCU) /*!< Bit mask for CCM_CSCMR2_CAN_CLK_PODF. */
#define BS_CCM_CSCMR2_CAN_CLK_PODF (6U)    /*!< Bit field size in bits for CCM_CSCMR2_CAN_CLK_PODF. */

/*! @brief Read current value of the CCM_CSCMR2_CAN_CLK_PODF field. */
#define BR_CCM_CSCMR2_CAN_CLK_PODF(x) (HW_CCM_CSCMR2(x).B.CAN_CLK_PODF)

/*! @brief Format value for bitfield CCM_CSCMR2_CAN_CLK_PODF. */
#define BF_CCM_CSCMR2_CAN_CLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR2_CAN_CLK_PODF) & BM_CCM_CSCMR2_CAN_CLK_PODF)

/*! @brief Set the CAN_CLK_PODF field to a new value. */
#define BW_CCM_CSCMR2_CAN_CLK_PODF(x, v) (HW_CCM_CSCMR2_WR(x, (HW_CCM_CSCMR2_RD(x) & ~BM_CCM_CSCMR2_CAN_CLK_PODF) | BF_CCM_CSCMR2_CAN_CLK_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR2, field can_clk_sel[9:8] (RW)
 *
 * Selector for FlexCAN clock multiplexer
 *
 * Values:
 * - 00 - derive clock from pll3_sw_clk divided clock (60M)
 * - 01 - derive clock from osc_clk (24M)
 * - 10 - derive clock from pll3_sw_clk divided clock (80M)
 */
/*@{*/
#define BP_CCM_CSCMR2_can_clk_sel (8U)     /*!< Bit position for CCM_CSCMR2_can_clk_sel. */
#define BM_CCM_CSCMR2_can_clk_sel (0x00000300U) /*!< Bit mask for CCM_CSCMR2_can_clk_sel. */
#define BS_CCM_CSCMR2_can_clk_sel (2U)     /*!< Bit field size in bits for CCM_CSCMR2_can_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR2_can_clk_sel field. */
#define BR_CCM_CSCMR2_can_clk_sel(x) (HW_CCM_CSCMR2(x).B.can_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR2_can_clk_sel. */
#define BF_CCM_CSCMR2_can_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR2_can_clk_sel) & BM_CCM_CSCMR2_can_clk_sel)

/*! @brief Set the can_clk_sel field to a new value. */
#define BW_CCM_CSCMR2_can_clk_sel(x, v) (HW_CCM_CSCMR2_WR(x, (HW_CCM_CSCMR2_RD(x) & ~BM_CCM_CSCMR2_can_clk_sel) | BF_CCM_CSCMR2_can_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR2, field ldb_di0_ipu_div[10] (RW)
 *
 * Control for divider of ldb clock for IPU di0
 *
 * Values:
 * - 0 - divide by 3.5
 * - 1 - divide by 7
 */
/*@{*/
#define BP_CCM_CSCMR2_ldb_di0_ipu_div (10U) /*!< Bit position for CCM_CSCMR2_ldb_di0_ipu_div. */
#define BM_CCM_CSCMR2_ldb_di0_ipu_div (0x00000400U) /*!< Bit mask for CCM_CSCMR2_ldb_di0_ipu_div. */
#define BS_CCM_CSCMR2_ldb_di0_ipu_div (1U) /*!< Bit field size in bits for CCM_CSCMR2_ldb_di0_ipu_div. */

/*! @brief Read current value of the CCM_CSCMR2_ldb_di0_ipu_div field. */
#define BR_CCM_CSCMR2_ldb_di0_ipu_div(x) (HW_CCM_CSCMR2(x).B.ldb_di0_ipu_div)

/*! @brief Format value for bitfield CCM_CSCMR2_ldb_di0_ipu_div. */
#define BF_CCM_CSCMR2_ldb_di0_ipu_div(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR2_ldb_di0_ipu_div) & BM_CCM_CSCMR2_ldb_di0_ipu_div)

/*! @brief Set the ldb_di0_ipu_div field to a new value. */
#define BW_CCM_CSCMR2_ldb_di0_ipu_div(x, v) (HW_CCM_CSCMR2_WR(x, (HW_CCM_CSCMR2_RD(x) & ~BM_CCM_CSCMR2_ldb_di0_ipu_div) | BF_CCM_CSCMR2_ldb_di0_ipu_div(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR2, field ldb_di1_ipu_div[11] (RW)
 *
 * Control for divider of ldb clock for IPU di1
 *
 * Values:
 * - 0 - divide by 3.5
 * - 1 - divide by 7
 */
/*@{*/
#define BP_CCM_CSCMR2_ldb_di1_ipu_div (11U) /*!< Bit position for CCM_CSCMR2_ldb_di1_ipu_div. */
#define BM_CCM_CSCMR2_ldb_di1_ipu_div (0x00000800U) /*!< Bit mask for CCM_CSCMR2_ldb_di1_ipu_div. */
#define BS_CCM_CSCMR2_ldb_di1_ipu_div (1U) /*!< Bit field size in bits for CCM_CSCMR2_ldb_di1_ipu_div. */

/*! @brief Read current value of the CCM_CSCMR2_ldb_di1_ipu_div field. */
#define BR_CCM_CSCMR2_ldb_di1_ipu_div(x) (HW_CCM_CSCMR2(x).B.ldb_di1_ipu_div)

/*! @brief Format value for bitfield CCM_CSCMR2_ldb_di1_ipu_div. */
#define BF_CCM_CSCMR2_ldb_di1_ipu_div(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR2_ldb_di1_ipu_div) & BM_CCM_CSCMR2_ldb_di1_ipu_div)

/*! @brief Set the ldb_di1_ipu_div field to a new value. */
#define BW_CCM_CSCMR2_ldb_di1_ipu_div(x, v) (HW_CCM_CSCMR2_WR(x, (HW_CCM_CSCMR2_RD(x) & ~BM_CCM_CSCMR2_ldb_di1_ipu_div) | BF_CCM_CSCMR2_ldb_di1_ipu_div(v)))
/*@}*/

/*!
 * @name Register CCM_CSCMR2, field esai_clk_sel[20:19] (RW)
 *
 * Selector for esai clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL4 divided clock
 * - 01 - derive clock from PLL3 PFD2 clock
 * - 10 - derive clock from PLL3 PFD3 clock
 * - 11 - derive clock from pll3_sw_clk
 */
/*@{*/
#define BP_CCM_CSCMR2_esai_clk_sel (19U)   /*!< Bit position for CCM_CSCMR2_esai_clk_sel. */
#define BM_CCM_CSCMR2_esai_clk_sel (0x00180000U) /*!< Bit mask for CCM_CSCMR2_esai_clk_sel. */
#define BS_CCM_CSCMR2_esai_clk_sel (2U)    /*!< Bit field size in bits for CCM_CSCMR2_esai_clk_sel. */

/*! @brief Read current value of the CCM_CSCMR2_esai_clk_sel field. */
#define BR_CCM_CSCMR2_esai_clk_sel(x) (HW_CCM_CSCMR2(x).B.esai_clk_sel)

/*! @brief Format value for bitfield CCM_CSCMR2_esai_clk_sel. */
#define BF_CCM_CSCMR2_esai_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCMR2_esai_clk_sel) & BM_CCM_CSCMR2_esai_clk_sel)

/*! @brief Set the esai_clk_sel field to a new value. */
#define BW_CCM_CSCMR2_esai_clk_sel(x, v) (HW_CCM_CSCMR2_WR(x, (HW_CCM_CSCMR2_RD(x) & ~BM_CCM_CSCMR2_esai_clk_sel) | BF_CCM_CSCMR2_esai_clk_sel(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSCDR1 - CCM Serial Clock Divider Register 1
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSCDR1 - CCM Serial Clock Divider Register 1 (RW)
 *
 * Reset value: 0x00490B00U
 *
 * The figure below represents the CCM Serial Clock Divider Register 1 (CSCDR1).
 * The CSCDR1 register contains bits to control the clock generation sub-module
 * dividers. The table below provides its field descriptions. Any change on the
 * above dividers will have to be done while the module that its clock is affected
 * is not functional and the affected clock is gated. If the change will be done
 * during operation of the module, then it is not guaranteed that the modules
 * operation will not be harmed.
 */
typedef union _hw_ccm_cscdr1
{
    uint32_t U;
    struct _hw_ccm_cscdr1_bitfields
    {
        uint32_t UART_CLK_PODF : 6;    /*!< [5:0]  */
        uint32_t uart_clk_sel : 1;     /*!< [6]  */
        uint32_t RESERVED0 : 4;        /*!< [10:7]  */
        uint32_t USDHC1_PODF : 3;      /*!< [13:11]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t USDHC2_PODF : 3;      /*!< [18:16]  */
        uint32_t usdhc3_podf : 3;      /*!< [21:19]  */
        uint32_t usdhc4_podf : 3;      /*!< [24:22]  */
        uint32_t vpu_axi_podf : 3;     /*!< [27:25]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_ccm_cscdr1_t;

/*!
 * @name Constants and macros for entire CCM_CSCDR1 register
 */
/*@{*/
#define HW_CCM_CSCDR1_ADDR(x)    ((uintptr_t)(x) + 0x24U)

#define HW_CCM_CSCDR1(x)         (*(__IO hw_ccm_cscdr1_t *) HW_CCM_CSCDR1_ADDR(x))
#define HW_CCM_CSCDR1_RD(x)      (HW_CCM_CSCDR1(x).U)
#define HW_CCM_CSCDR1_WR(x, v)   (HW_CCM_CSCDR1(x).U = (v))
#define HW_CCM_CSCDR1_SET(x, v)  (HW_CCM_CSCDR1_WR(x, HW_CCM_CSCDR1_RD(x) |  (v)))
#define HW_CCM_CSCDR1_CLR(x, v)  (HW_CCM_CSCDR1_WR(x, HW_CCM_CSCDR1_RD(x) & ~(v)))
#define HW_CCM_CSCDR1_TOG(x, v)  (HW_CCM_CSCDR1_WR(x, HW_CCM_CSCDR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CSCDR1 bitfields
 */

/*!
 * @name Register CCM_CSCDR1, field UART_CLK_PODF[5:0] (RW)
 *
 * Divider for uart clock podf.
 *
 * Values:
 * - 000000 - divide by 1
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CSCDR1_UART_CLK_PODF (0U)   /*!< Bit position for CCM_CSCDR1_UART_CLK_PODF. */
#define BM_CCM_CSCDR1_UART_CLK_PODF (0x0000003FU) /*!< Bit mask for CCM_CSCDR1_UART_CLK_PODF. */
#define BS_CCM_CSCDR1_UART_CLK_PODF (6U)   /*!< Bit field size in bits for CCM_CSCDR1_UART_CLK_PODF. */

/*! @brief Read current value of the CCM_CSCDR1_UART_CLK_PODF field. */
#define BR_CCM_CSCDR1_UART_CLK_PODF(x) (HW_CCM_CSCDR1(x).B.UART_CLK_PODF)

/*! @brief Format value for bitfield CCM_CSCDR1_UART_CLK_PODF. */
#define BF_CCM_CSCDR1_UART_CLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_UART_CLK_PODF) & BM_CCM_CSCDR1_UART_CLK_PODF)

/*! @brief Set the UART_CLK_PODF field to a new value. */
#define BW_CCM_CSCDR1_UART_CLK_PODF(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_UART_CLK_PODF) | BF_CCM_CSCDR1_UART_CLK_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field uart_clk_sel[6] (RW)
 *
 * Selector for the UART clock multiplexor
 *
 * Values:
 * - 0 - derive clock from pll3_80m
 * - 1 - derive clock from osc_clk
 */
/*@{*/
#define BP_CCM_CSCDR1_uart_clk_sel (6U)    /*!< Bit position for CCM_CSCDR1_uart_clk_sel. */
#define BM_CCM_CSCDR1_uart_clk_sel (0x00000040U) /*!< Bit mask for CCM_CSCDR1_uart_clk_sel. */
#define BS_CCM_CSCDR1_uart_clk_sel (1U)    /*!< Bit field size in bits for CCM_CSCDR1_uart_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR1_uart_clk_sel field. */
#define BR_CCM_CSCDR1_uart_clk_sel(x) (HW_CCM_CSCDR1(x).B.uart_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR1_uart_clk_sel. */
#define BF_CCM_CSCDR1_uart_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_uart_clk_sel) & BM_CCM_CSCDR1_uart_clk_sel)

/*! @brief Set the uart_clk_sel field to a new value. */
#define BW_CCM_CSCDR1_uart_clk_sel(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_uart_clk_sel) | BF_CCM_CSCDR1_uart_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field USDHC1_PODF[13:11] (RW)
 *
 * Divider for usdhc1 clock podf. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR1_USDHC1_PODF (11U)    /*!< Bit position for CCM_CSCDR1_USDHC1_PODF. */
#define BM_CCM_CSCDR1_USDHC1_PODF (0x00003800U) /*!< Bit mask for CCM_CSCDR1_USDHC1_PODF. */
#define BS_CCM_CSCDR1_USDHC1_PODF (3U)     /*!< Bit field size in bits for CCM_CSCDR1_USDHC1_PODF. */

/*! @brief Read current value of the CCM_CSCDR1_USDHC1_PODF field. */
#define BR_CCM_CSCDR1_USDHC1_PODF(x) (HW_CCM_CSCDR1(x).B.USDHC1_PODF)

/*! @brief Format value for bitfield CCM_CSCDR1_USDHC1_PODF. */
#define BF_CCM_CSCDR1_USDHC1_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_USDHC1_PODF) & BM_CCM_CSCDR1_USDHC1_PODF)

/*! @brief Set the USDHC1_PODF field to a new value. */
#define BW_CCM_CSCDR1_USDHC1_PODF(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_USDHC1_PODF) | BF_CCM_CSCDR1_USDHC1_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field USDHC2_PODF[18:16] (RW)
 *
 * Divider for usdhc2 clock. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR1_USDHC2_PODF (16U)    /*!< Bit position for CCM_CSCDR1_USDHC2_PODF. */
#define BM_CCM_CSCDR1_USDHC2_PODF (0x00070000U) /*!< Bit mask for CCM_CSCDR1_USDHC2_PODF. */
#define BS_CCM_CSCDR1_USDHC2_PODF (3U)     /*!< Bit field size in bits for CCM_CSCDR1_USDHC2_PODF. */

/*! @brief Read current value of the CCM_CSCDR1_USDHC2_PODF field. */
#define BR_CCM_CSCDR1_USDHC2_PODF(x) (HW_CCM_CSCDR1(x).B.USDHC2_PODF)

/*! @brief Format value for bitfield CCM_CSCDR1_USDHC2_PODF. */
#define BF_CCM_CSCDR1_USDHC2_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_USDHC2_PODF) & BM_CCM_CSCDR1_USDHC2_PODF)

/*! @brief Set the USDHC2_PODF field to a new value. */
#define BW_CCM_CSCDR1_USDHC2_PODF(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_USDHC2_PODF) | BF_CCM_CSCDR1_USDHC2_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field usdhc3_podf[21:19] (RW)
 *
 * Divider for usdhc3 clock podf. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR1_usdhc3_podf (19U)    /*!< Bit position for CCM_CSCDR1_usdhc3_podf. */
#define BM_CCM_CSCDR1_usdhc3_podf (0x00380000U) /*!< Bit mask for CCM_CSCDR1_usdhc3_podf. */
#define BS_CCM_CSCDR1_usdhc3_podf (3U)     /*!< Bit field size in bits for CCM_CSCDR1_usdhc3_podf. */

/*! @brief Read current value of the CCM_CSCDR1_usdhc3_podf field. */
#define BR_CCM_CSCDR1_usdhc3_podf(x) (HW_CCM_CSCDR1(x).B.usdhc3_podf)

/*! @brief Format value for bitfield CCM_CSCDR1_usdhc3_podf. */
#define BF_CCM_CSCDR1_usdhc3_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_usdhc3_podf) & BM_CCM_CSCDR1_usdhc3_podf)

/*! @brief Set the usdhc3_podf field to a new value. */
#define BW_CCM_CSCDR1_usdhc3_podf(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_usdhc3_podf) | BF_CCM_CSCDR1_usdhc3_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field usdhc4_podf[24:22] (RW)
 *
 * Divider for usdhc4 clock pred. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR1_usdhc4_podf (22U)    /*!< Bit position for CCM_CSCDR1_usdhc4_podf. */
#define BM_CCM_CSCDR1_usdhc4_podf (0x01C00000U) /*!< Bit mask for CCM_CSCDR1_usdhc4_podf. */
#define BS_CCM_CSCDR1_usdhc4_podf (3U)     /*!< Bit field size in bits for CCM_CSCDR1_usdhc4_podf. */

/*! @brief Read current value of the CCM_CSCDR1_usdhc4_podf field. */
#define BR_CCM_CSCDR1_usdhc4_podf(x) (HW_CCM_CSCDR1(x).B.usdhc4_podf)

/*! @brief Format value for bitfield CCM_CSCDR1_usdhc4_podf. */
#define BF_CCM_CSCDR1_usdhc4_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_usdhc4_podf) & BM_CCM_CSCDR1_usdhc4_podf)

/*! @brief Set the usdhc4_podf field to a new value. */
#define BW_CCM_CSCDR1_usdhc4_podf(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_usdhc4_podf) | BF_CCM_CSCDR1_usdhc4_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR1, field vpu_axi_podf[27:25] (RW)
 *
 * Divider for vpu axi clock podf. Divider should be updated when output clock
 * is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR1_vpu_axi_podf (25U)   /*!< Bit position for CCM_CSCDR1_vpu_axi_podf. */
#define BM_CCM_CSCDR1_vpu_axi_podf (0x0E000000U) /*!< Bit mask for CCM_CSCDR1_vpu_axi_podf. */
#define BS_CCM_CSCDR1_vpu_axi_podf (3U)    /*!< Bit field size in bits for CCM_CSCDR1_vpu_axi_podf. */

/*! @brief Read current value of the CCM_CSCDR1_vpu_axi_podf field. */
#define BR_CCM_CSCDR1_vpu_axi_podf(x) (HW_CCM_CSCDR1(x).B.vpu_axi_podf)

/*! @brief Format value for bitfield CCM_CSCDR1_vpu_axi_podf. */
#define BF_CCM_CSCDR1_vpu_axi_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR1_vpu_axi_podf) & BM_CCM_CSCDR1_vpu_axi_podf)

/*! @brief Set the vpu_axi_podf field to a new value. */
#define BW_CCM_CSCDR1_vpu_axi_podf(x, v) (HW_CCM_CSCDR1_WR(x, (HW_CCM_CSCDR1_RD(x) & ~BM_CCM_CSCDR1_vpu_axi_podf) | BF_CCM_CSCDR1_vpu_axi_podf(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CS1CDR - CCM SSI1 Clock Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CS1CDR - CCM SSI1 Clock Divider Register (RW)
 *
 * Reset value: 0x0EC102C1U
 *
 * The figure below represents the CCM ESAI, SSI1, and SSI3 Clock Divider
 * Register (CS1CDR). The CS1CDR register contains bits to control the SSI1 and SSI3
 * clock generation dividers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_cs1cdr
{
    uint32_t U;
    struct _hw_ccm_cs1cdr_bitfields
    {
        uint32_t ssi1_clk_podf : 6;    /*!< [5:0]  */
        uint32_t ssi1_clk_pred : 3;    /*!< [8:6]  */
        uint32_t esai_clk_pred : 3;    /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t ssi3_clk_podf : 6;    /*!< [21:16]  */
        uint32_t ssi3_clk_pred : 3;    /*!< [24:22]  */
        uint32_t esai_clk_podf : 3;    /*!< [27:25]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ccm_cs1cdr_t;

/*!
 * @name Constants and macros for entire CCM_CS1CDR register
 */
/*@{*/
#define HW_CCM_CS1CDR_ADDR(x)    ((uintptr_t)(x) + 0x28U)

#define HW_CCM_CS1CDR(x)         (*(__IO hw_ccm_cs1cdr_t *) HW_CCM_CS1CDR_ADDR(x))
#define HW_CCM_CS1CDR_RD(x)      (HW_CCM_CS1CDR(x).U)
#define HW_CCM_CS1CDR_WR(x, v)   (HW_CCM_CS1CDR(x).U = (v))
#define HW_CCM_CS1CDR_SET(x, v)  (HW_CCM_CS1CDR_WR(x, HW_CCM_CS1CDR_RD(x) |  (v)))
#define HW_CCM_CS1CDR_CLR(x, v)  (HW_CCM_CS1CDR_WR(x, HW_CCM_CS1CDR_RD(x) & ~(v)))
#define HW_CCM_CS1CDR_TOG(x, v)  (HW_CCM_CS1CDR_WR(x, HW_CCM_CS1CDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CS1CDR bitfields
 */

/*!
 * @name Register CCM_CS1CDR, field ssi1_clk_podf[5:0] (RW)
 *
 * Divider for ssi1 clock podf. The input clock to this divider should be lower
 * than 300Mhz, the predivider can be used to achieve this.
 *
 * Values:
 * - 000000 - divide by 1
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CS1CDR_ssi1_clk_podf (0U)   /*!< Bit position for CCM_CS1CDR_ssi1_clk_podf. */
#define BM_CCM_CS1CDR_ssi1_clk_podf (0x0000003FU) /*!< Bit mask for CCM_CS1CDR_ssi1_clk_podf. */
#define BS_CCM_CS1CDR_ssi1_clk_podf (6U)   /*!< Bit field size in bits for CCM_CS1CDR_ssi1_clk_podf. */

/*! @brief Read current value of the CCM_CS1CDR_ssi1_clk_podf field. */
#define BR_CCM_CS1CDR_ssi1_clk_podf(x) (HW_CCM_CS1CDR(x).B.ssi1_clk_podf)

/*! @brief Format value for bitfield CCM_CS1CDR_ssi1_clk_podf. */
#define BF_CCM_CS1CDR_ssi1_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_ssi1_clk_podf) & BM_CCM_CS1CDR_ssi1_clk_podf)

/*! @brief Set the ssi1_clk_podf field to a new value. */
#define BW_CCM_CS1CDR_ssi1_clk_podf(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_ssi1_clk_podf) | BF_CCM_CS1CDR_ssi1_clk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CS1CDR, field ssi1_clk_pred[8:6] (RW)
 *
 * Divider for ssi1 clock pred.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS1CDR_ssi1_clk_pred (6U)   /*!< Bit position for CCM_CS1CDR_ssi1_clk_pred. */
#define BM_CCM_CS1CDR_ssi1_clk_pred (0x000001C0U) /*!< Bit mask for CCM_CS1CDR_ssi1_clk_pred. */
#define BS_CCM_CS1CDR_ssi1_clk_pred (3U)   /*!< Bit field size in bits for CCM_CS1CDR_ssi1_clk_pred. */

/*! @brief Read current value of the CCM_CS1CDR_ssi1_clk_pred field. */
#define BR_CCM_CS1CDR_ssi1_clk_pred(x) (HW_CCM_CS1CDR(x).B.ssi1_clk_pred)

/*! @brief Format value for bitfield CCM_CS1CDR_ssi1_clk_pred. */
#define BF_CCM_CS1CDR_ssi1_clk_pred(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_ssi1_clk_pred) & BM_CCM_CS1CDR_ssi1_clk_pred)

/*! @brief Set the ssi1_clk_pred field to a new value. */
#define BW_CCM_CS1CDR_ssi1_clk_pred(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_ssi1_clk_pred) | BF_CCM_CS1CDR_ssi1_clk_pred(v)))
/*@}*/

/*!
 * @name Register CCM_CS1CDR, field esai_clk_pred[11:9] (RW)
 *
 * Divider for esai clock pred.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS1CDR_esai_clk_pred (9U)   /*!< Bit position for CCM_CS1CDR_esai_clk_pred. */
#define BM_CCM_CS1CDR_esai_clk_pred (0x00000E00U) /*!< Bit mask for CCM_CS1CDR_esai_clk_pred. */
#define BS_CCM_CS1CDR_esai_clk_pred (3U)   /*!< Bit field size in bits for CCM_CS1CDR_esai_clk_pred. */

/*! @brief Read current value of the CCM_CS1CDR_esai_clk_pred field. */
#define BR_CCM_CS1CDR_esai_clk_pred(x) (HW_CCM_CS1CDR(x).B.esai_clk_pred)

/*! @brief Format value for bitfield CCM_CS1CDR_esai_clk_pred. */
#define BF_CCM_CS1CDR_esai_clk_pred(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_esai_clk_pred) & BM_CCM_CS1CDR_esai_clk_pred)

/*! @brief Set the esai_clk_pred field to a new value. */
#define BW_CCM_CS1CDR_esai_clk_pred(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_esai_clk_pred) | BF_CCM_CS1CDR_esai_clk_pred(v)))
/*@}*/

/*!
 * @name Register CCM_CS1CDR, field ssi3_clk_podf[21:16] (RW)
 *
 * Divider for ssi3 clock podf. The input clock to this divider should be lower
 * than 300Mhz, the predivider can be used to achieve this.
 *
 * Values:
 * - 000000 - divide by 1
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CS1CDR_ssi3_clk_podf (16U)  /*!< Bit position for CCM_CS1CDR_ssi3_clk_podf. */
#define BM_CCM_CS1CDR_ssi3_clk_podf (0x003F0000U) /*!< Bit mask for CCM_CS1CDR_ssi3_clk_podf. */
#define BS_CCM_CS1CDR_ssi3_clk_podf (6U)   /*!< Bit field size in bits for CCM_CS1CDR_ssi3_clk_podf. */

/*! @brief Read current value of the CCM_CS1CDR_ssi3_clk_podf field. */
#define BR_CCM_CS1CDR_ssi3_clk_podf(x) (HW_CCM_CS1CDR(x).B.ssi3_clk_podf)

/*! @brief Format value for bitfield CCM_CS1CDR_ssi3_clk_podf. */
#define BF_CCM_CS1CDR_ssi3_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_ssi3_clk_podf) & BM_CCM_CS1CDR_ssi3_clk_podf)

/*! @brief Set the ssi3_clk_podf field to a new value. */
#define BW_CCM_CS1CDR_ssi3_clk_podf(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_ssi3_clk_podf) | BF_CCM_CS1CDR_ssi3_clk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CS1CDR, field ssi3_clk_pred[24:22] (RW)
 *
 * Divider for ssi3 clock pred.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS1CDR_ssi3_clk_pred (22U)  /*!< Bit position for CCM_CS1CDR_ssi3_clk_pred. */
#define BM_CCM_CS1CDR_ssi3_clk_pred (0x01C00000U) /*!< Bit mask for CCM_CS1CDR_ssi3_clk_pred. */
#define BS_CCM_CS1CDR_ssi3_clk_pred (3U)   /*!< Bit field size in bits for CCM_CS1CDR_ssi3_clk_pred. */

/*! @brief Read current value of the CCM_CS1CDR_ssi3_clk_pred field. */
#define BR_CCM_CS1CDR_ssi3_clk_pred(x) (HW_CCM_CS1CDR(x).B.ssi3_clk_pred)

/*! @brief Format value for bitfield CCM_CS1CDR_ssi3_clk_pred. */
#define BF_CCM_CS1CDR_ssi3_clk_pred(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_ssi3_clk_pred) & BM_CCM_CS1CDR_ssi3_clk_pred)

/*! @brief Set the ssi3_clk_pred field to a new value. */
#define BW_CCM_CS1CDR_ssi3_clk_pred(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_ssi3_clk_pred) | BF_CCM_CS1CDR_ssi3_clk_pred(v)))
/*@}*/

/*!
 * @name Register CCM_CS1CDR, field esai_clk_podf[27:25] (RW)
 *
 * Divider for esai clock podf.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS1CDR_esai_clk_podf (25U)  /*!< Bit position for CCM_CS1CDR_esai_clk_podf. */
#define BM_CCM_CS1CDR_esai_clk_podf (0x0E000000U) /*!< Bit mask for CCM_CS1CDR_esai_clk_podf. */
#define BS_CCM_CS1CDR_esai_clk_podf (3U)   /*!< Bit field size in bits for CCM_CS1CDR_esai_clk_podf. */

/*! @brief Read current value of the CCM_CS1CDR_esai_clk_podf field. */
#define BR_CCM_CS1CDR_esai_clk_podf(x) (HW_CCM_CS1CDR(x).B.esai_clk_podf)

/*! @brief Format value for bitfield CCM_CS1CDR_esai_clk_podf. */
#define BF_CCM_CS1CDR_esai_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS1CDR_esai_clk_podf) & BM_CCM_CS1CDR_esai_clk_podf)

/*! @brief Set the esai_clk_podf field to a new value. */
#define BW_CCM_CS1CDR_esai_clk_podf(x, v) (HW_CCM_CS1CDR_WR(x, (HW_CCM_CS1CDR_RD(x) & ~BM_CCM_CS1CDR_esai_clk_podf) | BF_CCM_CS1CDR_esai_clk_podf(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CS2CDR - CCM SSI2 Clock Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CS2CDR - CCM SSI2 Clock Divider Register (RW)
 *
 * Reset value: 0x000436C1U
 *
 * The figure below represents the CCM SSI2, LDB Clock Divider Register
 * (CS2CDR). The CS2CDR register contains bits to control the SSI2 clock generation
 * dividers, and ldb serial clocks select. The table below provides its field
 * descriptions.
 */
typedef union _hw_ccm_cs2cdr
{
    uint32_t U;
    struct _hw_ccm_cs2cdr_bitfields
    {
        uint32_t ssi2_clk_podf : 6;    /*!< [5:0]  */
        uint32_t ssi2_clk_pred : 3;    /*!< [8:6]  */
        uint32_t ldb_di0_clk_sel : 3;  /*!< [11:9]  */
        uint32_t ldb_di1_clk_sel : 3;  /*!< [14:12]  */
        uint32_t enfc_clk_sel : 3;     /*!< [17:15]  */
        uint32_t ENFC_CLK_PRED : 3;    /*!< [20:18]  */
        uint32_t ENFC_CLK_PODF : 6;    /*!< [26:21]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_ccm_cs2cdr_t;

/*!
 * @name Constants and macros for entire CCM_CS2CDR register
 */
/*@{*/
#define HW_CCM_CS2CDR_ADDR(x)    ((uintptr_t)(x) + 0x2CU)

#define HW_CCM_CS2CDR(x)         (*(__IO hw_ccm_cs2cdr_t *) HW_CCM_CS2CDR_ADDR(x))
#define HW_CCM_CS2CDR_RD(x)      (HW_CCM_CS2CDR(x).U)
#define HW_CCM_CS2CDR_WR(x, v)   (HW_CCM_CS2CDR(x).U = (v))
#define HW_CCM_CS2CDR_SET(x, v)  (HW_CCM_CS2CDR_WR(x, HW_CCM_CS2CDR_RD(x) |  (v)))
#define HW_CCM_CS2CDR_CLR(x, v)  (HW_CCM_CS2CDR_WR(x, HW_CCM_CS2CDR_RD(x) & ~(v)))
#define HW_CCM_CS2CDR_TOG(x, v)  (HW_CCM_CS2CDR_WR(x, HW_CCM_CS2CDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CS2CDR bitfields
 */

/*!
 * @name Register CCM_CS2CDR, field ssi2_clk_podf[5:0] (RW)
 *
 * Divider for ssi2 clock podf. The input clock to this divider should be lower
 * than 300Mhz, the predivider can be used to achieve this.Divider should be
 * updated when output clock is gated.
 *
 * Values:
 * - 000000 - divide by 1
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CS2CDR_ssi2_clk_podf (0U)   /*!< Bit position for CCM_CS2CDR_ssi2_clk_podf. */
#define BM_CCM_CS2CDR_ssi2_clk_podf (0x0000003FU) /*!< Bit mask for CCM_CS2CDR_ssi2_clk_podf. */
#define BS_CCM_CS2CDR_ssi2_clk_podf (6U)   /*!< Bit field size in bits for CCM_CS2CDR_ssi2_clk_podf. */

/*! @brief Read current value of the CCM_CS2CDR_ssi2_clk_podf field. */
#define BR_CCM_CS2CDR_ssi2_clk_podf(x) (HW_CCM_CS2CDR(x).B.ssi2_clk_podf)

/*! @brief Format value for bitfield CCM_CS2CDR_ssi2_clk_podf. */
#define BF_CCM_CS2CDR_ssi2_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ssi2_clk_podf) & BM_CCM_CS2CDR_ssi2_clk_podf)

/*! @brief Set the ssi2_clk_podf field to a new value. */
#define BW_CCM_CS2CDR_ssi2_clk_podf(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ssi2_clk_podf) | BF_CCM_CS2CDR_ssi2_clk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field ssi2_clk_pred[8:6] (RW)
 *
 * Divider for ssi2 clock pred.Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS2CDR_ssi2_clk_pred (6U)   /*!< Bit position for CCM_CS2CDR_ssi2_clk_pred. */
#define BM_CCM_CS2CDR_ssi2_clk_pred (0x000001C0U) /*!< Bit mask for CCM_CS2CDR_ssi2_clk_pred. */
#define BS_CCM_CS2CDR_ssi2_clk_pred (3U)   /*!< Bit field size in bits for CCM_CS2CDR_ssi2_clk_pred. */

/*! @brief Read current value of the CCM_CS2CDR_ssi2_clk_pred field. */
#define BR_CCM_CS2CDR_ssi2_clk_pred(x) (HW_CCM_CS2CDR(x).B.ssi2_clk_pred)

/*! @brief Format value for bitfield CCM_CS2CDR_ssi2_clk_pred. */
#define BF_CCM_CS2CDR_ssi2_clk_pred(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ssi2_clk_pred) & BM_CCM_CS2CDR_ssi2_clk_pred)

/*! @brief Set the ssi2_clk_pred field to a new value. */
#define BW_CCM_CS2CDR_ssi2_clk_pred(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ssi2_clk_pred) | BF_CCM_CS2CDR_ssi2_clk_pred(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field ldb_di0_clk_sel[11:9] (RW)
 *
 * Selector for ldb_di1 clock multiplexerMultiplexor should be updated when both
 * input and output clocks are gated.
 *
 * Values:
 * - 000 - pll5 clock
 * - 001 - derive clock from PLL2 PFD0
 * - 010 - derive clock from PLL2 PFD2
 * - 011 - derive clock from mmdc_ch1 clock
 * - 100 - derive clock from pll3_sw_clk
 */
/*@{*/
#define BP_CCM_CS2CDR_ldb_di0_clk_sel (9U) /*!< Bit position for CCM_CS2CDR_ldb_di0_clk_sel. */
#define BM_CCM_CS2CDR_ldb_di0_clk_sel (0x00000E00U) /*!< Bit mask for CCM_CS2CDR_ldb_di0_clk_sel. */
#define BS_CCM_CS2CDR_ldb_di0_clk_sel (3U) /*!< Bit field size in bits for CCM_CS2CDR_ldb_di0_clk_sel. */

/*! @brief Read current value of the CCM_CS2CDR_ldb_di0_clk_sel field. */
#define BR_CCM_CS2CDR_ldb_di0_clk_sel(x) (HW_CCM_CS2CDR(x).B.ldb_di0_clk_sel)

/*! @brief Format value for bitfield CCM_CS2CDR_ldb_di0_clk_sel. */
#define BF_CCM_CS2CDR_ldb_di0_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ldb_di0_clk_sel) & BM_CCM_CS2CDR_ldb_di0_clk_sel)

/*! @brief Set the ldb_di0_clk_sel field to a new value. */
#define BW_CCM_CS2CDR_ldb_di0_clk_sel(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ldb_di0_clk_sel) | BF_CCM_CS2CDR_ldb_di0_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field ldb_di1_clk_sel[14:12] (RW)
 *
 * Selector for ldb_di1 clock multiplexerMultiplexor should be updated when both
 * input and output clocks are gated.
 *
 * Values:
 * - 000 - pll5 clock
 * - 001 - derive clock from PLL2 PFD0
 * - 010 - derive clock from PLL2 PFD2
 * - 011 - derive clock from mmdc_ch1 clock
 * - 100 - derive clock from pll3_sw_clk
 */
/*@{*/
#define BP_CCM_CS2CDR_ldb_di1_clk_sel (12U) /*!< Bit position for CCM_CS2CDR_ldb_di1_clk_sel. */
#define BM_CCM_CS2CDR_ldb_di1_clk_sel (0x00007000U) /*!< Bit mask for CCM_CS2CDR_ldb_di1_clk_sel. */
#define BS_CCM_CS2CDR_ldb_di1_clk_sel (3U) /*!< Bit field size in bits for CCM_CS2CDR_ldb_di1_clk_sel. */

/*! @brief Read current value of the CCM_CS2CDR_ldb_di1_clk_sel field. */
#define BR_CCM_CS2CDR_ldb_di1_clk_sel(x) (HW_CCM_CS2CDR(x).B.ldb_di1_clk_sel)

/*! @brief Format value for bitfield CCM_CS2CDR_ldb_di1_clk_sel. */
#define BF_CCM_CS2CDR_ldb_di1_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ldb_di1_clk_sel) & BM_CCM_CS2CDR_ldb_di1_clk_sel)

/*! @brief Set the ldb_di1_clk_sel field to a new value. */
#define BW_CCM_CS2CDR_ldb_di1_clk_sel(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ldb_di1_clk_sel) | BF_CCM_CS2CDR_ldb_di1_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field enfc_clk_sel[17:15] (RW)
 *
 * Selector for enfc clock multiplexer Multiplexor should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - derive clock from PLL2 PFD0
 * - 001 - derive clock from PLL2
 * - 010 - derive clock from pll3_sw_clk
 * - 011 - derive clock from PLL2 PFD2
 * - 100 - derive clock from PLL3 PFD3
 */
/*@{*/
#define BP_CCM_CS2CDR_enfc_clk_sel (15U)   /*!< Bit position for CCM_CS2CDR_enfc_clk_sel. */
#define BM_CCM_CS2CDR_enfc_clk_sel (0x00038000U) /*!< Bit mask for CCM_CS2CDR_enfc_clk_sel. */
#define BS_CCM_CS2CDR_enfc_clk_sel (3U)    /*!< Bit field size in bits for CCM_CS2CDR_enfc_clk_sel. */

/*! @brief Read current value of the CCM_CS2CDR_enfc_clk_sel field. */
#define BR_CCM_CS2CDR_enfc_clk_sel(x) (HW_CCM_CS2CDR(x).B.enfc_clk_sel)

/*! @brief Format value for bitfield CCM_CS2CDR_enfc_clk_sel. */
#define BF_CCM_CS2CDR_enfc_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_enfc_clk_sel) & BM_CCM_CS2CDR_enfc_clk_sel)

/*! @brief Set the enfc_clk_sel field to a new value. */
#define BW_CCM_CS2CDR_enfc_clk_sel(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_enfc_clk_sel) | BF_CCM_CS2CDR_enfc_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field ENFC_CLK_PRED[20:18] (RW)
 *
 * Divider for enfc clock pred divider.Divider should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CS2CDR_ENFC_CLK_PRED (18U)  /*!< Bit position for CCM_CS2CDR_ENFC_CLK_PRED. */
#define BM_CCM_CS2CDR_ENFC_CLK_PRED (0x001C0000U) /*!< Bit mask for CCM_CS2CDR_ENFC_CLK_PRED. */
#define BS_CCM_CS2CDR_ENFC_CLK_PRED (3U)   /*!< Bit field size in bits for CCM_CS2CDR_ENFC_CLK_PRED. */

/*! @brief Read current value of the CCM_CS2CDR_ENFC_CLK_PRED field. */
#define BR_CCM_CS2CDR_ENFC_CLK_PRED(x) (HW_CCM_CS2CDR(x).B.ENFC_CLK_PRED)

/*! @brief Format value for bitfield CCM_CS2CDR_ENFC_CLK_PRED. */
#define BF_CCM_CS2CDR_ENFC_CLK_PRED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ENFC_CLK_PRED) & BM_CCM_CS2CDR_ENFC_CLK_PRED)

/*! @brief Set the ENFC_CLK_PRED field to a new value. */
#define BW_CCM_CS2CDR_ENFC_CLK_PRED(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ENFC_CLK_PRED) | BF_CCM_CS2CDR_ENFC_CLK_PRED(v)))
/*@}*/

/*!
 * @name Register CCM_CS2CDR, field ENFC_CLK_PODF[26:21] (RW)
 *
 * Divider for enfc clock divider.
 *
 * Values:
 * - 000000 - divide by 1
 * - 000001 - divide by 2
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CS2CDR_ENFC_CLK_PODF (21U)  /*!< Bit position for CCM_CS2CDR_ENFC_CLK_PODF. */
#define BM_CCM_CS2CDR_ENFC_CLK_PODF (0x07E00000U) /*!< Bit mask for CCM_CS2CDR_ENFC_CLK_PODF. */
#define BS_CCM_CS2CDR_ENFC_CLK_PODF (6U)   /*!< Bit field size in bits for CCM_CS2CDR_ENFC_CLK_PODF. */

/*! @brief Read current value of the CCM_CS2CDR_ENFC_CLK_PODF field. */
#define BR_CCM_CS2CDR_ENFC_CLK_PODF(x) (HW_CCM_CS2CDR(x).B.ENFC_CLK_PODF)

/*! @brief Format value for bitfield CCM_CS2CDR_ENFC_CLK_PODF. */
#define BF_CCM_CS2CDR_ENFC_CLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CS2CDR_ENFC_CLK_PODF) & BM_CCM_CS2CDR_ENFC_CLK_PODF)

/*! @brief Set the ENFC_CLK_PODF field to a new value. */
#define BW_CCM_CS2CDR_ENFC_CLK_PODF(x, v) (HW_CCM_CS2CDR_WR(x, (HW_CCM_CS2CDR_RD(x) & ~BM_CCM_CS2CDR_ENFC_CLK_PODF) | BF_CCM_CS2CDR_ENFC_CLK_PODF(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CDCDR - CCM D1 Clock Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CDCDR - CCM D1 Clock Divider Register (RW)
 *
 * Reset value: 0x33F71F92U
 *
 * The figure below represents the CCM DI Clock Divider Register (CDCDR). The
 * table below provides its field descriptions.
 */
typedef union _hw_ccm_cdcdr
{
    uint32_t U;
    struct _hw_ccm_cdcdr_bitfields
    {
        uint32_t RESERVED0 : 7;        /*!< [6:0]  */
        uint32_t spdif1_clk_sel : 2;   /*!< [8:7]  */
        uint32_t spdif1_clk_podf : 3;  /*!< [11:9]  */
        uint32_t spdif1_clk_pred : 3;  /*!< [14:12]  */
        uint32_t RESERVED1 : 5;        /*!< [19:15]  */
        uint32_t spdif0_clk_sel : 2;   /*!< [21:20]  */
        uint32_t SPDIF0_CLK_PODF : 3;  /*!< [24:22]  */
        uint32_t SPDIF0_CLK_PRED : 3;  /*!< [27:25]  */
        uint32_t hsi_tx_clk_sel : 1;   /*!< [28]  */
        uint32_t hsi_tx_podf : 3;      /*!< [31:29]  */
    } B;
} hw_ccm_cdcdr_t;

/*!
 * @name Constants and macros for entire CCM_CDCDR register
 */
/*@{*/
#define HW_CCM_CDCDR_ADDR(x)     ((uintptr_t)(x) + 0x30U)

#define HW_CCM_CDCDR(x)          (*(__IO hw_ccm_cdcdr_t *) HW_CCM_CDCDR_ADDR(x))
#define HW_CCM_CDCDR_RD(x)       (HW_CCM_CDCDR(x).U)
#define HW_CCM_CDCDR_WR(x, v)    (HW_CCM_CDCDR(x).U = (v))
#define HW_CCM_CDCDR_SET(x, v)   (HW_CCM_CDCDR_WR(x, HW_CCM_CDCDR_RD(x) |  (v)))
#define HW_CCM_CDCDR_CLR(x, v)   (HW_CCM_CDCDR_WR(x, HW_CCM_CDCDR_RD(x) & ~(v)))
#define HW_CCM_CDCDR_TOG(x, v)   (HW_CCM_CDCDR_WR(x, HW_CCM_CDCDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CDCDR bitfields
 */

/*!
 * @name Register CCM_CDCDR, field spdif1_clk_sel[8:7] (RW)
 *
 * Selector for spdif1 clock multiplexer Used for ASRC clock, not related to
 * SPDIF module
 *
 * Values:
 * - 00 - derive clock from PLL4 divided clock
 * - 01 - derive clock from PLL3 PFD2
 * - 10 - derive clock from PLL3 PFD3
 * - 11 - derive clock from pll3_sw_clk
 */
/*@{*/
#define BP_CCM_CDCDR_spdif1_clk_sel (7U)   /*!< Bit position for CCM_CDCDR_spdif1_clk_sel. */
#define BM_CCM_CDCDR_spdif1_clk_sel (0x00000180U) /*!< Bit mask for CCM_CDCDR_spdif1_clk_sel. */
#define BS_CCM_CDCDR_spdif1_clk_sel (2U)   /*!< Bit field size in bits for CCM_CDCDR_spdif1_clk_sel. */

/*! @brief Read current value of the CCM_CDCDR_spdif1_clk_sel field. */
#define BR_CCM_CDCDR_spdif1_clk_sel(x) (HW_CCM_CDCDR(x).B.spdif1_clk_sel)

/*! @brief Format value for bitfield CCM_CDCDR_spdif1_clk_sel. */
#define BF_CCM_CDCDR_spdif1_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_spdif1_clk_sel) & BM_CCM_CDCDR_spdif1_clk_sel)

/*! @brief Set the spdif1_clk_sel field to a new value. */
#define BW_CCM_CDCDR_spdif1_clk_sel(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_spdif1_clk_sel) | BF_CCM_CDCDR_spdif1_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field spdif1_clk_podf[11:9] (RW)
 *
 * Divider for spdif1 clock podf. Divider should be updated when output clock is
 * gated. Used for ASRC clock, not related to SPDIF module
 *
 * Values:
 * - 000 - divide by 1
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CDCDR_spdif1_clk_podf (9U)  /*!< Bit position for CCM_CDCDR_spdif1_clk_podf. */
#define BM_CCM_CDCDR_spdif1_clk_podf (0x00000E00U) /*!< Bit mask for CCM_CDCDR_spdif1_clk_podf. */
#define BS_CCM_CDCDR_spdif1_clk_podf (3U)  /*!< Bit field size in bits for CCM_CDCDR_spdif1_clk_podf. */

/*! @brief Read current value of the CCM_CDCDR_spdif1_clk_podf field. */
#define BR_CCM_CDCDR_spdif1_clk_podf(x) (HW_CCM_CDCDR(x).B.spdif1_clk_podf)

/*! @brief Format value for bitfield CCM_CDCDR_spdif1_clk_podf. */
#define BF_CCM_CDCDR_spdif1_clk_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_spdif1_clk_podf) & BM_CCM_CDCDR_spdif1_clk_podf)

/*! @brief Set the spdif1_clk_podf field to a new value. */
#define BW_CCM_CDCDR_spdif1_clk_podf(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_spdif1_clk_podf) | BF_CCM_CDCDR_spdif1_clk_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field spdif1_clk_pred[14:12] (RW)
 *
 * Divider for spdif1 clock pred. Divider should be updated when output clock is
 * gated. Used for ASRC clock, not related to SPDIF module
 *
 * Values:
 * - 000 - divide by 1 (do not use with high input frequencies)
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CDCDR_spdif1_clk_pred (12U) /*!< Bit position for CCM_CDCDR_spdif1_clk_pred. */
#define BM_CCM_CDCDR_spdif1_clk_pred (0x00007000U) /*!< Bit mask for CCM_CDCDR_spdif1_clk_pred. */
#define BS_CCM_CDCDR_spdif1_clk_pred (3U)  /*!< Bit field size in bits for CCM_CDCDR_spdif1_clk_pred. */

/*! @brief Read current value of the CCM_CDCDR_spdif1_clk_pred field. */
#define BR_CCM_CDCDR_spdif1_clk_pred(x) (HW_CCM_CDCDR(x).B.spdif1_clk_pred)

/*! @brief Format value for bitfield CCM_CDCDR_spdif1_clk_pred. */
#define BF_CCM_CDCDR_spdif1_clk_pred(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_spdif1_clk_pred) & BM_CCM_CDCDR_spdif1_clk_pred)

/*! @brief Set the spdif1_clk_pred field to a new value. */
#define BW_CCM_CDCDR_spdif1_clk_pred(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_spdif1_clk_pred) | BF_CCM_CDCDR_spdif1_clk_pred(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field spdif0_clk_sel[21:20] (RW)
 *
 * Selector for spdif0 clock multiplexer
 *
 * Values:
 * - 00 - derive clock from PLL4 divided clock
 * - 01 - derive clock from PLL3 PFD2
 * - 10 - derive clock from PLL3 PFD3
 * - 11 - derive clock from pll3_sw_clk
 */
/*@{*/
#define BP_CCM_CDCDR_spdif0_clk_sel (20U)  /*!< Bit position for CCM_CDCDR_spdif0_clk_sel. */
#define BM_CCM_CDCDR_spdif0_clk_sel (0x00300000U) /*!< Bit mask for CCM_CDCDR_spdif0_clk_sel. */
#define BS_CCM_CDCDR_spdif0_clk_sel (2U)   /*!< Bit field size in bits for CCM_CDCDR_spdif0_clk_sel. */

/*! @brief Read current value of the CCM_CDCDR_spdif0_clk_sel field. */
#define BR_CCM_CDCDR_spdif0_clk_sel(x) (HW_CCM_CDCDR(x).B.spdif0_clk_sel)

/*! @brief Format value for bitfield CCM_CDCDR_spdif0_clk_sel. */
#define BF_CCM_CDCDR_spdif0_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_spdif0_clk_sel) & BM_CCM_CDCDR_spdif0_clk_sel)

/*! @brief Set the spdif0_clk_sel field to a new value. */
#define BW_CCM_CDCDR_spdif0_clk_sel(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_spdif0_clk_sel) | BF_CCM_CDCDR_spdif0_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field SPDIF0_CLK_PODF[24:22] (RW)
 *
 * Divider for spdif0 clock podf. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CDCDR_SPDIF0_CLK_PODF (22U) /*!< Bit position for CCM_CDCDR_SPDIF0_CLK_PODF. */
#define BM_CCM_CDCDR_SPDIF0_CLK_PODF (0x01C00000U) /*!< Bit mask for CCM_CDCDR_SPDIF0_CLK_PODF. */
#define BS_CCM_CDCDR_SPDIF0_CLK_PODF (3U)  /*!< Bit field size in bits for CCM_CDCDR_SPDIF0_CLK_PODF. */

/*! @brief Read current value of the CCM_CDCDR_SPDIF0_CLK_PODF field. */
#define BR_CCM_CDCDR_SPDIF0_CLK_PODF(x) (HW_CCM_CDCDR(x).B.SPDIF0_CLK_PODF)

/*! @brief Format value for bitfield CCM_CDCDR_SPDIF0_CLK_PODF. */
#define BF_CCM_CDCDR_SPDIF0_CLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_SPDIF0_CLK_PODF) & BM_CCM_CDCDR_SPDIF0_CLK_PODF)

/*! @brief Set the SPDIF0_CLK_PODF field to a new value. */
#define BW_CCM_CDCDR_SPDIF0_CLK_PODF(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_SPDIF0_CLK_PODF) | BF_CCM_CDCDR_SPDIF0_CLK_PODF(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field SPDIF0_CLK_PRED[27:25] (RW)
 *
 * Divider for spdif0 clock pred. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1 (do not use with high input frequencies)
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CDCDR_SPDIF0_CLK_PRED (25U) /*!< Bit position for CCM_CDCDR_SPDIF0_CLK_PRED. */
#define BM_CCM_CDCDR_SPDIF0_CLK_PRED (0x0E000000U) /*!< Bit mask for CCM_CDCDR_SPDIF0_CLK_PRED. */
#define BS_CCM_CDCDR_SPDIF0_CLK_PRED (3U)  /*!< Bit field size in bits for CCM_CDCDR_SPDIF0_CLK_PRED. */

/*! @brief Read current value of the CCM_CDCDR_SPDIF0_CLK_PRED field. */
#define BR_CCM_CDCDR_SPDIF0_CLK_PRED(x) (HW_CCM_CDCDR(x).B.SPDIF0_CLK_PRED)

/*! @brief Format value for bitfield CCM_CDCDR_SPDIF0_CLK_PRED. */
#define BF_CCM_CDCDR_SPDIF0_CLK_PRED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_SPDIF0_CLK_PRED) & BM_CCM_CDCDR_SPDIF0_CLK_PRED)

/*! @brief Set the SPDIF0_CLK_PRED field to a new value. */
#define BW_CCM_CDCDR_SPDIF0_CLK_PRED(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_SPDIF0_CLK_PRED) | BF_CCM_CDCDR_SPDIF0_CLK_PRED(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field hsi_tx_clk_sel[28] (RW)
 *
 * Selector for hsi_tx clock multiplexer
 *
 * Values:
 * - 0 - derive from pll3_120M clock
 * - 1 - derive clock from PLL2 PFD2
 */
/*@{*/
#define BP_CCM_CDCDR_hsi_tx_clk_sel (28U)  /*!< Bit position for CCM_CDCDR_hsi_tx_clk_sel. */
#define BM_CCM_CDCDR_hsi_tx_clk_sel (0x10000000U) /*!< Bit mask for CCM_CDCDR_hsi_tx_clk_sel. */
#define BS_CCM_CDCDR_hsi_tx_clk_sel (1U)   /*!< Bit field size in bits for CCM_CDCDR_hsi_tx_clk_sel. */

/*! @brief Read current value of the CCM_CDCDR_hsi_tx_clk_sel field. */
#define BR_CCM_CDCDR_hsi_tx_clk_sel(x) (HW_CCM_CDCDR(x).B.hsi_tx_clk_sel)

/*! @brief Format value for bitfield CCM_CDCDR_hsi_tx_clk_sel. */
#define BF_CCM_CDCDR_hsi_tx_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_hsi_tx_clk_sel) & BM_CCM_CDCDR_hsi_tx_clk_sel)

/*! @brief Set the hsi_tx_clk_sel field to a new value. */
#define BW_CCM_CDCDR_hsi_tx_clk_sel(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_hsi_tx_clk_sel) | BF_CCM_CDCDR_hsi_tx_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CDCDR, field hsi_tx_podf[31:29] (RW)
 *
 * Divider for hsi_tx clock podf. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CDCDR_hsi_tx_podf (29U)     /*!< Bit position for CCM_CDCDR_hsi_tx_podf. */
#define BM_CCM_CDCDR_hsi_tx_podf (0xE0000000U) /*!< Bit mask for CCM_CDCDR_hsi_tx_podf. */
#define BS_CCM_CDCDR_hsi_tx_podf (3U)      /*!< Bit field size in bits for CCM_CDCDR_hsi_tx_podf. */

/*! @brief Read current value of the CCM_CDCDR_hsi_tx_podf field. */
#define BR_CCM_CDCDR_hsi_tx_podf(x) (HW_CCM_CDCDR(x).B.hsi_tx_podf)

/*! @brief Format value for bitfield CCM_CDCDR_hsi_tx_podf. */
#define BF_CCM_CDCDR_hsi_tx_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CDCDR_hsi_tx_podf) & BM_CCM_CDCDR_hsi_tx_podf)

/*! @brief Set the hsi_tx_podf field to a new value. */
#define BW_CCM_CDCDR_hsi_tx_podf(x, v) (HW_CCM_CDCDR_WR(x, (HW_CCM_CDCDR_RD(x) & ~BM_CCM_CDCDR_hsi_tx_podf) | BF_CCM_CDCDR_hsi_tx_podf(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CHSCCDR - CCM HSC Clock Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CHSCCDR - CCM HSC Clock Divider Register (RW)
 *
 * Reset value: 0x00029148U
 *
 * The figure below represents the CCM HSC Clock Divider Register (CHSCCDR). The
 * CHSCCDR register contains bits to control the ipu di clock generation
 * dividers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_chsccdr
{
    uint32_t U;
    struct _hw_ccm_chsccdr_bitfields
    {
        uint32_t ipu1_di0_clk_sel : 3; /*!< [2:0]  */
        uint32_t ipu1_di0_podf : 3;    /*!< [5:3]  */
        uint32_t ipu1_di0_pre_clk_sel : 3; /*!< [8:6]  */
        uint32_t ipu1_di1_clk_sel : 3; /*!< [11:9]  */
        uint32_t ipu1_di1_podf : 3;    /*!< [14:12]  */
        uint32_t ipu1_di1_pre_clk_sel : 3; /*!< [17:15]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_ccm_chsccdr_t;

/*!
 * @name Constants and macros for entire CCM_CHSCCDR register
 */
/*@{*/
#define HW_CCM_CHSCCDR_ADDR(x)   ((uintptr_t)(x) + 0x34U)

#define HW_CCM_CHSCCDR(x)        (*(__IO hw_ccm_chsccdr_t *) HW_CCM_CHSCCDR_ADDR(x))
#define HW_CCM_CHSCCDR_RD(x)     (HW_CCM_CHSCCDR(x).U)
#define HW_CCM_CHSCCDR_WR(x, v)  (HW_CCM_CHSCCDR(x).U = (v))
#define HW_CCM_CHSCCDR_SET(x, v) (HW_CCM_CHSCCDR_WR(x, HW_CCM_CHSCCDR_RD(x) |  (v)))
#define HW_CCM_CHSCCDR_CLR(x, v) (HW_CCM_CHSCCDR_WR(x, HW_CCM_CHSCCDR_RD(x) & ~(v)))
#define HW_CCM_CHSCCDR_TOG(x, v) (HW_CCM_CHSCCDR_WR(x, HW_CCM_CHSCCDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CHSCCDR bitfields
 */

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di0_clk_sel[2:0] (RW)
 *
 * Selector for ipu1 di0 root clock multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table found
 * here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from divided pre-muxed ipu1 di0 clock
 * - 001 - derive clock from ipp_di0_clk
 * - 010 - derive clock from ipp_di1_clk
 * - 011 - derive clock from ldb_di0_clk
 * - 100 - derive clock from ldb_di1_clk
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di0_clk_sel (0U) /*!< Bit position for CCM_CHSCCDR_ipu1_di0_clk_sel. */
#define BM_CCM_CHSCCDR_ipu1_di0_clk_sel (0x00000007U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di0_clk_sel. */
#define BS_CCM_CHSCCDR_ipu1_di0_clk_sel (3U) /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di0_clk_sel. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di0_clk_sel field. */
#define BR_CCM_CHSCCDR_ipu1_di0_clk_sel(x) (HW_CCM_CHSCCDR(x).B.ipu1_di0_clk_sel)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di0_clk_sel. */
#define BF_CCM_CHSCCDR_ipu1_di0_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di0_clk_sel) & BM_CCM_CHSCCDR_ipu1_di0_clk_sel)

/*! @brief Set the ipu1_di0_clk_sel field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di0_clk_sel(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di0_clk_sel) | BF_CCM_CHSCCDR_ipu1_di0_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di0_podf[5:3] (RW)
 *
 * Divider for ipu1_di0 clock divider. Divider should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di0_podf (3U)  /*!< Bit position for CCM_CHSCCDR_ipu1_di0_podf. */
#define BM_CCM_CHSCCDR_ipu1_di0_podf (0x00000038U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di0_podf. */
#define BS_CCM_CHSCCDR_ipu1_di0_podf (3U)  /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di0_podf. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di0_podf field. */
#define BR_CCM_CHSCCDR_ipu1_di0_podf(x) (HW_CCM_CHSCCDR(x).B.ipu1_di0_podf)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di0_podf. */
#define BF_CCM_CHSCCDR_ipu1_di0_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di0_podf) & BM_CCM_CHSCCDR_ipu1_di0_podf)

/*! @brief Set the ipu1_di0_podf field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di0_podf(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di0_podf) | BF_CCM_CHSCCDR_ipu1_di0_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di0_pre_clk_sel[8:6] (RW)
 *
 * Selector for ipu1 di0 root clock pre-multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table
 * found here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from mmdc_ch0 clock
 * - 001 - derive clock from pll3_sw_clk
 * - 010 - derive clock from pll5
 * - 011 - derive clock from PLL2 PFD0
 * - 100 - derive clock from PLL2 PFD2
 * - 101 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di0_pre_clk_sel (6U) /*!< Bit position for CCM_CHSCCDR_ipu1_di0_pre_clk_sel. */
#define BM_CCM_CHSCCDR_ipu1_di0_pre_clk_sel (0x000001C0U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di0_pre_clk_sel. */
#define BS_CCM_CHSCCDR_ipu1_di0_pre_clk_sel (3U) /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di0_pre_clk_sel. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di0_pre_clk_sel field. */
#define BR_CCM_CHSCCDR_ipu1_di0_pre_clk_sel(x) (HW_CCM_CHSCCDR(x).B.ipu1_di0_pre_clk_sel)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di0_pre_clk_sel. */
#define BF_CCM_CHSCCDR_ipu1_di0_pre_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di0_pre_clk_sel) & BM_CCM_CHSCCDR_ipu1_di0_pre_clk_sel)

/*! @brief Set the ipu1_di0_pre_clk_sel field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di0_pre_clk_sel(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di0_pre_clk_sel) | BF_CCM_CHSCCDR_ipu1_di0_pre_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di1_clk_sel[11:9] (RW)
 *
 * Selector for ipu1 di1 root clock multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table found
 * here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from divided pre-muxed ipu1 di1 clock
 * - 001 - derive clock from ipp_di0_clk
 * - 010 - derive clock from ipp_di1_clk
 * - 011 - derive clock from ldb_di0_clk
 * - 100 - derive clock from ldb_di1_clk
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di1_clk_sel (9U) /*!< Bit position for CCM_CHSCCDR_ipu1_di1_clk_sel. */
#define BM_CCM_CHSCCDR_ipu1_di1_clk_sel (0x00000E00U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di1_clk_sel. */
#define BS_CCM_CHSCCDR_ipu1_di1_clk_sel (3U) /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di1_clk_sel. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di1_clk_sel field. */
#define BR_CCM_CHSCCDR_ipu1_di1_clk_sel(x) (HW_CCM_CHSCCDR(x).B.ipu1_di1_clk_sel)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di1_clk_sel. */
#define BF_CCM_CHSCCDR_ipu1_di1_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di1_clk_sel) & BM_CCM_CHSCCDR_ipu1_di1_clk_sel)

/*! @brief Set the ipu1_di1_clk_sel field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di1_clk_sel(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di1_clk_sel) | BF_CCM_CHSCCDR_ipu1_di1_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di1_podf[14:12] (RW)
 *
 * Divider for ipu1_di clock divider. Divider should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di1_podf (12U) /*!< Bit position for CCM_CHSCCDR_ipu1_di1_podf. */
#define BM_CCM_CHSCCDR_ipu1_di1_podf (0x00007000U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di1_podf. */
#define BS_CCM_CHSCCDR_ipu1_di1_podf (3U)  /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di1_podf. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di1_podf field. */
#define BR_CCM_CHSCCDR_ipu1_di1_podf(x) (HW_CCM_CHSCCDR(x).B.ipu1_di1_podf)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di1_podf. */
#define BF_CCM_CHSCCDR_ipu1_di1_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di1_podf) & BM_CCM_CHSCCDR_ipu1_di1_podf)

/*! @brief Set the ipu1_di1_podf field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di1_podf(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di1_podf) | BF_CCM_CHSCCDR_ipu1_di1_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CHSCCDR, field ipu1_di1_pre_clk_sel[17:15] (RW)
 *
 * Selector for ipu1 di1 root clock pre-multiplexer Multiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table
 * found here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from mmdc_ch0 clock
 * - 001 - derive clock from pll3_sw_clk
 * - 010 - derive clock from pll5
 * - 011 - derive clock from PLL2 PFD0
 * - 100 - derive clock from PLL2 PFD2
 * - 101 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CHSCCDR_ipu1_di1_pre_clk_sel (15U) /*!< Bit position for CCM_CHSCCDR_ipu1_di1_pre_clk_sel. */
#define BM_CCM_CHSCCDR_ipu1_di1_pre_clk_sel (0x00038000U) /*!< Bit mask for CCM_CHSCCDR_ipu1_di1_pre_clk_sel. */
#define BS_CCM_CHSCCDR_ipu1_di1_pre_clk_sel (3U) /*!< Bit field size in bits for CCM_CHSCCDR_ipu1_di1_pre_clk_sel. */

/*! @brief Read current value of the CCM_CHSCCDR_ipu1_di1_pre_clk_sel field. */
#define BR_CCM_CHSCCDR_ipu1_di1_pre_clk_sel(x) (HW_CCM_CHSCCDR(x).B.ipu1_di1_pre_clk_sel)

/*! @brief Format value for bitfield CCM_CHSCCDR_ipu1_di1_pre_clk_sel. */
#define BF_CCM_CHSCCDR_ipu1_di1_pre_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CHSCCDR_ipu1_di1_pre_clk_sel) & BM_CCM_CHSCCDR_ipu1_di1_pre_clk_sel)

/*! @brief Set the ipu1_di1_pre_clk_sel field to a new value. */
#define BW_CCM_CHSCCDR_ipu1_di1_pre_clk_sel(x, v) (HW_CCM_CHSCCDR_WR(x, (HW_CCM_CHSCCDR_RD(x) & ~BM_CCM_CHSCCDR_ipu1_di1_pre_clk_sel) | BF_CCM_CHSCCDR_ipu1_di1_pre_clk_sel(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSCDR2 - CCM Serial Clock Divider Register 2
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSCDR2 - CCM Serial Clock Divider Register 2 (RW)
 *
 * Reset value: 0x00029148U
 *
 * The figure below represents the CCM Serial Clock Divider Register 2(CSCDR2).
 * The CSCDR2 register contains bits to control the clock generation sub-module
 * dividers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_cscdr2
{
    uint32_t U;
    struct _hw_ccm_cscdr2_bitfields
    {
        uint32_t ipu2_di0_clk_sel : 3; /*!< [2:0]  */
        uint32_t ipu2_di0_podf : 3;    /*!< [5:3]  */
        uint32_t ipu2_di0_pre_clk_sel : 3; /*!< [8:6]  */
        uint32_t ipu2_di1_clk_sel : 3; /*!< [11:9]  */
        uint32_t ipu2_di1_podf : 3;    /*!< [14:12]  */
        uint32_t ipu2_di1_pre_clk_sel : 3; /*!< [17:15]  */
        uint32_t ecspi_clk_sel : 1;    /*!< [18]  */
        uint32_t ECSPI_CLK_PODF : 6;   /*!< [24:19]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ccm_cscdr2_t;

/*!
 * @name Constants and macros for entire CCM_CSCDR2 register
 */
/*@{*/
#define HW_CCM_CSCDR2_ADDR(x)    ((uintptr_t)(x) + 0x38U)

#define HW_CCM_CSCDR2(x)         (*(__IO hw_ccm_cscdr2_t *) HW_CCM_CSCDR2_ADDR(x))
#define HW_CCM_CSCDR2_RD(x)      (HW_CCM_CSCDR2(x).U)
#define HW_CCM_CSCDR2_WR(x, v)   (HW_CCM_CSCDR2(x).U = (v))
#define HW_CCM_CSCDR2_SET(x, v)  (HW_CCM_CSCDR2_WR(x, HW_CCM_CSCDR2_RD(x) |  (v)))
#define HW_CCM_CSCDR2_CLR(x, v)  (HW_CCM_CSCDR2_WR(x, HW_CCM_CSCDR2_RD(x) & ~(v)))
#define HW_CCM_CSCDR2_TOG(x, v)  (HW_CCM_CSCDR2_WR(x, HW_CCM_CSCDR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CSCDR2 bitfields
 */

/*!
 * @name Register CCM_CSCDR2, field ipu2_di0_clk_sel[2:0] (RW)
 *
 * Selector for ipu2 di0 root clock multiplexerMultiplexor should be updated
 * only when the output clock is gated.
 *
 * Values:
 * - 000 - derive clock from divided pre-muxed ipu1 di0 clock
 * - 001 - derive clock from ipp_di0_clk
 * - 010 - derive clock from ipp_di1_clk
 * - 011 - derive clock from ldb_di0_clk
 * - 100 - derive clock from ldb_di1_clk
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di0_clk_sel (0U) /*!< Bit position for CCM_CSCDR2_ipu2_di0_clk_sel. */
#define BM_CCM_CSCDR2_ipu2_di0_clk_sel (0x00000007U) /*!< Bit mask for CCM_CSCDR2_ipu2_di0_clk_sel. */
#define BS_CCM_CSCDR2_ipu2_di0_clk_sel (3U) /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di0_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di0_clk_sel field. */
#define BR_CCM_CSCDR2_ipu2_di0_clk_sel(x) (HW_CCM_CSCDR2(x).B.ipu2_di0_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di0_clk_sel. */
#define BF_CCM_CSCDR2_ipu2_di0_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di0_clk_sel) & BM_CCM_CSCDR2_ipu2_di0_clk_sel)

/*! @brief Set the ipu2_di0_clk_sel field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di0_clk_sel(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di0_clk_sel) | BF_CCM_CSCDR2_ipu2_di0_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ipu2_di0_podf[5:3] (RW)
 *
 * Divider for ipu2_di0 clock divider. Divider should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di0_podf (3U)   /*!< Bit position for CCM_CSCDR2_ipu2_di0_podf. */
#define BM_CCM_CSCDR2_ipu2_di0_podf (0x00000038U) /*!< Bit mask for CCM_CSCDR2_ipu2_di0_podf. */
#define BS_CCM_CSCDR2_ipu2_di0_podf (3U)   /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di0_podf. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di0_podf field. */
#define BR_CCM_CSCDR2_ipu2_di0_podf(x) (HW_CCM_CSCDR2(x).B.ipu2_di0_podf)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di0_podf. */
#define BF_CCM_CSCDR2_ipu2_di0_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di0_podf) & BM_CCM_CSCDR2_ipu2_di0_podf)

/*! @brief Set the ipu2_di0_podf field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di0_podf(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di0_podf) | BF_CCM_CSCDR2_ipu2_di0_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ipu2_di0_pre_clk_sel[8:6] (RW)
 *
 * Selector for ipu2 di0 root clock pre-multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table
 * found here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from mmdc_ch0 clock
 * - 001 - derive clock from pll3_sw_clk
 * - 010 - derive clock from pll5
 * - 011 - derive clock from PLL2 PFD0
 * - 100 - derive clock from PLL2 PFD2
 * - 101 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di0_pre_clk_sel (6U) /*!< Bit position for CCM_CSCDR2_ipu2_di0_pre_clk_sel. */
#define BM_CCM_CSCDR2_ipu2_di0_pre_clk_sel (0x000001C0U) /*!< Bit mask for CCM_CSCDR2_ipu2_di0_pre_clk_sel. */
#define BS_CCM_CSCDR2_ipu2_di0_pre_clk_sel (3U) /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di0_pre_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di0_pre_clk_sel field. */
#define BR_CCM_CSCDR2_ipu2_di0_pre_clk_sel(x) (HW_CCM_CSCDR2(x).B.ipu2_di0_pre_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di0_pre_clk_sel. */
#define BF_CCM_CSCDR2_ipu2_di0_pre_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di0_pre_clk_sel) & BM_CCM_CSCDR2_ipu2_di0_pre_clk_sel)

/*! @brief Set the ipu2_di0_pre_clk_sel field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di0_pre_clk_sel(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di0_pre_clk_sel) | BF_CCM_CSCDR2_ipu2_di0_pre_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ipu2_di1_clk_sel[11:9] (RW)
 *
 * Selector for ipu1 di2 root clock multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table found
 * here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from divided pre-muxed ipu1 di1 clock
 * - 001 - derive clock from ipp_di0_clk
 * - 010 - derive clock from ipp_di1_clk
 * - 011 - derive clock from ldb_di0_clk
 * - 100 - derive clock from ldb_di1_clk
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di1_clk_sel (9U) /*!< Bit position for CCM_CSCDR2_ipu2_di1_clk_sel. */
#define BM_CCM_CSCDR2_ipu2_di1_clk_sel (0x00000E00U) /*!< Bit mask for CCM_CSCDR2_ipu2_di1_clk_sel. */
#define BS_CCM_CSCDR2_ipu2_di1_clk_sel (3U) /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di1_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di1_clk_sel field. */
#define BR_CCM_CSCDR2_ipu2_di1_clk_sel(x) (HW_CCM_CSCDR2(x).B.ipu2_di1_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di1_clk_sel. */
#define BF_CCM_CSCDR2_ipu2_di1_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di1_clk_sel) & BM_CCM_CSCDR2_ipu2_di1_clk_sel)

/*! @brief Set the ipu2_di1_clk_sel field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di1_clk_sel(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di1_clk_sel) | BF_CCM_CSCDR2_ipu2_di1_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ipu2_di1_podf[14:12] (RW)
 *
 * Divider for ipu2_di1 clock divider. Divider should be updated when output
 * clock is gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di1_podf (12U)  /*!< Bit position for CCM_CSCDR2_ipu2_di1_podf. */
#define BM_CCM_CSCDR2_ipu2_di1_podf (0x00007000U) /*!< Bit mask for CCM_CSCDR2_ipu2_di1_podf. */
#define BS_CCM_CSCDR2_ipu2_di1_podf (3U)   /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di1_podf. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di1_podf field. */
#define BR_CCM_CSCDR2_ipu2_di1_podf(x) (HW_CCM_CSCDR2(x).B.ipu2_di1_podf)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di1_podf. */
#define BF_CCM_CSCDR2_ipu2_di1_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di1_podf) & BM_CCM_CSCDR2_ipu2_di1_podf)

/*! @brief Set the ipu2_di1_podf field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di1_podf(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di1_podf) | BF_CCM_CSCDR2_ipu2_di1_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ipu2_di1_pre_clk_sel[17:15] (RW)
 *
 * Selector for ipu2 di1 root clock pre-multiplexerMultiplexor should only be
 * updated when the output clock is gated. Please refer to System ClocksThe table
 * found here shows the CCM output clocks' system-level connectivity. for the
 * respective output clock gating bits.
 *
 * Values:
 * - 000 - derive clock from mmdc_ch0 clock
 * - 001 - derive clock from pll3_sw_clk
 * - 010 - derive clock from PLL5
 * - 011 - derive clock from PLL2 PFD0
 * - 100 - derive clock from PLL2 PFD2
 * - 101 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CSCDR2_ipu2_di1_pre_clk_sel (15U) /*!< Bit position for CCM_CSCDR2_ipu2_di1_pre_clk_sel. */
#define BM_CCM_CSCDR2_ipu2_di1_pre_clk_sel (0x00038000U) /*!< Bit mask for CCM_CSCDR2_ipu2_di1_pre_clk_sel. */
#define BS_CCM_CSCDR2_ipu2_di1_pre_clk_sel (3U) /*!< Bit field size in bits for CCM_CSCDR2_ipu2_di1_pre_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR2_ipu2_di1_pre_clk_sel field. */
#define BR_CCM_CSCDR2_ipu2_di1_pre_clk_sel(x) (HW_CCM_CSCDR2(x).B.ipu2_di1_pre_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR2_ipu2_di1_pre_clk_sel. */
#define BF_CCM_CSCDR2_ipu2_di1_pre_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ipu2_di1_pre_clk_sel) & BM_CCM_CSCDR2_ipu2_di1_pre_clk_sel)

/*! @brief Set the ipu2_di1_pre_clk_sel field to a new value. */
#define BW_CCM_CSCDR2_ipu2_di1_pre_clk_sel(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ipu2_di1_pre_clk_sel) | BF_CCM_CSCDR2_ipu2_di1_pre_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ecspi_clk_sel[18] (RW)
 *
 * Selector for the ECSPI clock multiplexor
 *
 * Values:
 * - 0 - derive clock from pll3_60m
 * - 1 - derive clock from osc_clk
 */
/*@{*/
#define BP_CCM_CSCDR2_ecspi_clk_sel (18U)  /*!< Bit position for CCM_CSCDR2_ecspi_clk_sel. */
#define BM_CCM_CSCDR2_ecspi_clk_sel (0x00040000U) /*!< Bit mask for CCM_CSCDR2_ecspi_clk_sel. */
#define BS_CCM_CSCDR2_ecspi_clk_sel (1U)   /*!< Bit field size in bits for CCM_CSCDR2_ecspi_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR2_ecspi_clk_sel field. */
#define BR_CCM_CSCDR2_ecspi_clk_sel(x) (HW_CCM_CSCDR2(x).B.ecspi_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR2_ecspi_clk_sel. */
#define BF_CCM_CSCDR2_ecspi_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ecspi_clk_sel) & BM_CCM_CSCDR2_ecspi_clk_sel)

/*! @brief Set the ecspi_clk_sel field to a new value. */
#define BW_CCM_CSCDR2_ecspi_clk_sel(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ecspi_clk_sel) | BF_CCM_CSCDR2_ecspi_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR2, field ECSPI_CLK_PODF[24:19] (RW)
 *
 * Divider for ecspi clock podf. Divider should be updated when output clock is
 * gated. The input clock to this divider should be lower than 300Mhz, the
 * predivider can be used to achieve this.
 *
 * Values:
 * - 000000 - divide by 1
 * - 111111 - divide by 2^6
 */
/*@{*/
#define BP_CCM_CSCDR2_ECSPI_CLK_PODF (19U) /*!< Bit position for CCM_CSCDR2_ECSPI_CLK_PODF. */
#define BM_CCM_CSCDR2_ECSPI_CLK_PODF (0x01F80000U) /*!< Bit mask for CCM_CSCDR2_ECSPI_CLK_PODF. */
#define BS_CCM_CSCDR2_ECSPI_CLK_PODF (6U)  /*!< Bit field size in bits for CCM_CSCDR2_ECSPI_CLK_PODF. */

/*! @brief Read current value of the CCM_CSCDR2_ECSPI_CLK_PODF field. */
#define BR_CCM_CSCDR2_ECSPI_CLK_PODF(x) (HW_CCM_CSCDR2(x).B.ECSPI_CLK_PODF)

/*! @brief Format value for bitfield CCM_CSCDR2_ECSPI_CLK_PODF. */
#define BF_CCM_CSCDR2_ECSPI_CLK_PODF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR2_ECSPI_CLK_PODF) & BM_CCM_CSCDR2_ECSPI_CLK_PODF)

/*! @brief Set the ECSPI_CLK_PODF field to a new value. */
#define BW_CCM_CSCDR2_ECSPI_CLK_PODF(x, v) (HW_CCM_CSCDR2_WR(x, (HW_CCM_CSCDR2_RD(x) & ~BM_CCM_CSCDR2_ECSPI_CLK_PODF) | BF_CCM_CSCDR2_ECSPI_CLK_PODF(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CSCDR3 - CCM Serial Clock Divider Register 3
 ******************************************************************************/

/*!
 * @brief HW_CCM_CSCDR3 - CCM Serial Clock Divider Register 3 (RW)
 *
 * Reset value: 0x00010841U
 *
 * The figure below represents the CCM Serial Clock Divider Register 3(CSCDR3).
 * The CSCDR3 register contains bits to control the clock generation sub-module
 * dividers. The table below provides its field descriptions.
 */
typedef union _hw_ccm_cscdr3
{
    uint32_t U;
    struct _hw_ccm_cscdr3_bitfields
    {
        uint32_t RESERVED0 : 9;        /*!< [8:0]  */
        uint32_t ipu1_hsp_clk_sel : 2; /*!< [10:9]  */
        uint32_t ipu1_hsp_podf : 3;    /*!< [13:11]  */
        uint32_t ipu2_hsp_clk_sel : 2; /*!< [15:14]  */
        uint32_t ipu2_hsp_podf : 3;    /*!< [18:16]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ccm_cscdr3_t;

/*!
 * @name Constants and macros for entire CCM_CSCDR3 register
 */
/*@{*/
#define HW_CCM_CSCDR3_ADDR(x)    ((uintptr_t)(x) + 0x3CU)

#define HW_CCM_CSCDR3(x)         (*(__IO hw_ccm_cscdr3_t *) HW_CCM_CSCDR3_ADDR(x))
#define HW_CCM_CSCDR3_RD(x)      (HW_CCM_CSCDR3(x).U)
#define HW_CCM_CSCDR3_WR(x, v)   (HW_CCM_CSCDR3(x).U = (v))
#define HW_CCM_CSCDR3_SET(x, v)  (HW_CCM_CSCDR3_WR(x, HW_CCM_CSCDR3_RD(x) |  (v)))
#define HW_CCM_CSCDR3_CLR(x, v)  (HW_CCM_CSCDR3_WR(x, HW_CCM_CSCDR3_RD(x) & ~(v)))
#define HW_CCM_CSCDR3_TOG(x, v)  (HW_CCM_CSCDR3_WR(x, HW_CCM_CSCDR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CSCDR3 bitfields
 */

/*!
 * @name Register CCM_CSCDR3, field ipu1_hsp_clk_sel[10:9] (RW)
 *
 * Selector for ipu1_hsp clock multiplexer
 *
 * Values:
 * - 00 - derive clock from mmdc_ch0 clock
 * - 01 - derive clock from PLL2 PFD2
 * - 10 - derive clock from pll3_120M
 * - 11 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CSCDR3_ipu1_hsp_clk_sel (9U) /*!< Bit position for CCM_CSCDR3_ipu1_hsp_clk_sel. */
#define BM_CCM_CSCDR3_ipu1_hsp_clk_sel (0x00000600U) /*!< Bit mask for CCM_CSCDR3_ipu1_hsp_clk_sel. */
#define BS_CCM_CSCDR3_ipu1_hsp_clk_sel (2U) /*!< Bit field size in bits for CCM_CSCDR3_ipu1_hsp_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR3_ipu1_hsp_clk_sel field. */
#define BR_CCM_CSCDR3_ipu1_hsp_clk_sel(x) (HW_CCM_CSCDR3(x).B.ipu1_hsp_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR3_ipu1_hsp_clk_sel. */
#define BF_CCM_CSCDR3_ipu1_hsp_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR3_ipu1_hsp_clk_sel) & BM_CCM_CSCDR3_ipu1_hsp_clk_sel)

/*! @brief Set the ipu1_hsp_clk_sel field to a new value. */
#define BW_CCM_CSCDR3_ipu1_hsp_clk_sel(x, v) (HW_CCM_CSCDR3_WR(x, (HW_CCM_CSCDR3_RD(x) & ~BM_CCM_CSCDR3_ipu1_hsp_clk_sel) | BF_CCM_CSCDR3_ipu1_hsp_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR3, field ipu1_hsp_podf[13:11] (RW)
 *
 * Divider for ipu1_hsp clock. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR3_ipu1_hsp_podf (11U)  /*!< Bit position for CCM_CSCDR3_ipu1_hsp_podf. */
#define BM_CCM_CSCDR3_ipu1_hsp_podf (0x00003800U) /*!< Bit mask for CCM_CSCDR3_ipu1_hsp_podf. */
#define BS_CCM_CSCDR3_ipu1_hsp_podf (3U)   /*!< Bit field size in bits for CCM_CSCDR3_ipu1_hsp_podf. */

/*! @brief Read current value of the CCM_CSCDR3_ipu1_hsp_podf field. */
#define BR_CCM_CSCDR3_ipu1_hsp_podf(x) (HW_CCM_CSCDR3(x).B.ipu1_hsp_podf)

/*! @brief Format value for bitfield CCM_CSCDR3_ipu1_hsp_podf. */
#define BF_CCM_CSCDR3_ipu1_hsp_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR3_ipu1_hsp_podf) & BM_CCM_CSCDR3_ipu1_hsp_podf)

/*! @brief Set the ipu1_hsp_podf field to a new value. */
#define BW_CCM_CSCDR3_ipu1_hsp_podf(x, v) (HW_CCM_CSCDR3_WR(x, (HW_CCM_CSCDR3_RD(x) & ~BM_CCM_CSCDR3_ipu1_hsp_podf) | BF_CCM_CSCDR3_ipu1_hsp_podf(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR3, field ipu2_hsp_clk_sel[15:14] (RW)
 *
 * Selector for ipu2_hsp clock multiplexer
 *
 * Values:
 * - 00 - derive clock from mmdc_ch0 clock
 * - 01 - derive clock from PLL2 PFD2
 * - 10 - derive clock from pll3_120M
 * - 11 - derive clock from PLL3 PFD1
 */
/*@{*/
#define BP_CCM_CSCDR3_ipu2_hsp_clk_sel (14U) /*!< Bit position for CCM_CSCDR3_ipu2_hsp_clk_sel. */
#define BM_CCM_CSCDR3_ipu2_hsp_clk_sel (0x0000C000U) /*!< Bit mask for CCM_CSCDR3_ipu2_hsp_clk_sel. */
#define BS_CCM_CSCDR3_ipu2_hsp_clk_sel (2U) /*!< Bit field size in bits for CCM_CSCDR3_ipu2_hsp_clk_sel. */

/*! @brief Read current value of the CCM_CSCDR3_ipu2_hsp_clk_sel field. */
#define BR_CCM_CSCDR3_ipu2_hsp_clk_sel(x) (HW_CCM_CSCDR3(x).B.ipu2_hsp_clk_sel)

/*! @brief Format value for bitfield CCM_CSCDR3_ipu2_hsp_clk_sel. */
#define BF_CCM_CSCDR3_ipu2_hsp_clk_sel(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR3_ipu2_hsp_clk_sel) & BM_CCM_CSCDR3_ipu2_hsp_clk_sel)

/*! @brief Set the ipu2_hsp_clk_sel field to a new value. */
#define BW_CCM_CSCDR3_ipu2_hsp_clk_sel(x, v) (HW_CCM_CSCDR3_WR(x, (HW_CCM_CSCDR3_RD(x) & ~BM_CCM_CSCDR3_ipu2_hsp_clk_sel) | BF_CCM_CSCDR3_ipu2_hsp_clk_sel(v)))
/*@}*/

/*!
 * @name Register CCM_CSCDR3, field ipu2_hsp_podf[18:16] (RW)
 *
 * Divider for ipu2_hsp clock. Divider should be updated when output clock is
 * gated.
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CSCDR3_ipu2_hsp_podf (16U)  /*!< Bit position for CCM_CSCDR3_ipu2_hsp_podf. */
#define BM_CCM_CSCDR3_ipu2_hsp_podf (0x00070000U) /*!< Bit mask for CCM_CSCDR3_ipu2_hsp_podf. */
#define BS_CCM_CSCDR3_ipu2_hsp_podf (3U)   /*!< Bit field size in bits for CCM_CSCDR3_ipu2_hsp_podf. */

/*! @brief Read current value of the CCM_CSCDR3_ipu2_hsp_podf field. */
#define BR_CCM_CSCDR3_ipu2_hsp_podf(x) (HW_CCM_CSCDR3(x).B.ipu2_hsp_podf)

/*! @brief Format value for bitfield CCM_CSCDR3_ipu2_hsp_podf. */
#define BF_CCM_CSCDR3_ipu2_hsp_podf(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CSCDR3_ipu2_hsp_podf) & BM_CCM_CSCDR3_ipu2_hsp_podf)

/*! @brief Set the ipu2_hsp_podf field to a new value. */
#define BW_CCM_CSCDR3_ipu2_hsp_podf(x, v) (HW_CCM_CSCDR3_WR(x, (HW_CCM_CSCDR3_RD(x) & ~BM_CCM_CSCDR3_ipu2_hsp_podf) | BF_CCM_CSCDR3_ipu2_hsp_podf(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CWDR - CCM Wakeup Detector Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CWDR - CCM Wakeup Detector Register (ROZ)
 *
 * Reset value: 0x00000000U
 *
 * The figure below represents the CCM Wakeup Detector Register (CWDR). The CWDR
 * register contains reserved, read-only bits.The table below provides its field
 * descriptions.
 */
typedef union _hw_ccm_cwdr
{
    uint32_t U;
    struct _hw_ccm_cwdr_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_ccm_cwdr_t;

/*!
 * @name Constants and macros for entire CCM_CWDR register
 */
/*@{*/
#define HW_CCM_CWDR_ADDR(x)      ((uintptr_t)(x) + 0x44U)

#define HW_CCM_CWDR(x)           (*(__I hw_ccm_cwdr_t *) HW_CCM_CWDR_ADDR(x))
#define HW_CCM_CWDR_RD(x)        (HW_CCM_CWDR(x).U)
/*@}*/

/*
 * Constants & macros for individual CCM_CWDR bitfields
 */

/*******************************************************************************
 * HW_CCM_CDHIPR - CCM Divider Handshake In-Process Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CDHIPR - CCM Divider Handshake In-Process Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The figure below represents the CCM Divider Handshake In-Process Register
 * (CDHIPR). The CDHIPR register contains read-only bits that indicate that CCM is
 * in the process of updating dividers or muxes that might need handshake with
 * modules.
 */
typedef union _hw_ccm_cdhipr
{
    uint32_t U;
    struct _hw_ccm_cdhipr_bitfields
    {
        uint32_t AXI_PODF_BUSY : 1;    /*!< [0]  */
        uint32_t AHB_PODF_BUSY : 1;    /*!< [1]  */
        uint32_t mmdc_ch1_podf_busy : 1; /*!< [2]  */
        uint32_t PERIPH2_CLK_SEL_BUSY : 1; /*!< [3]  */
        uint32_t mmdc_ch0_podf_busy : 1; /*!< [4]  */
        uint32_t PERIPH_CLK_SEL_BUSY : 1; /*!< [5]  */
        uint32_t RESERVED0 : 10;       /*!< [15:6]  */
        uint32_t ARM_PODF_BUSY : 1;    /*!< [16]  */
        uint32_t RESERVED1 : 15;       /*!< [31:17]  */
    } B;
} hw_ccm_cdhipr_t;

/*!
 * @name Constants and macros for entire CCM_CDHIPR register
 */
/*@{*/
#define HW_CCM_CDHIPR_ADDR(x)    ((uintptr_t)(x) + 0x48U)

#define HW_CCM_CDHIPR(x)         (*(__I hw_ccm_cdhipr_t *) HW_CCM_CDHIPR_ADDR(x))
#define HW_CCM_CDHIPR_RD(x)      (HW_CCM_CDHIPR(x).U)
/*@}*/

/*
 * Constants & macros for individual CCM_CDHIPR bitfields
 */

/*!
 * @name Register CCM_CDHIPR, field AXI_PODF_BUSY[0] (RO)
 *
 * Busy indicator for axi_podf.
 *
 * Values:
 * - 0 - divider is not busy and its value represents the actual division.
 * - 1 - divider is busy with handshake process with module. The value read in
 *     the divider represents the previous value of the division factor, and after
 *     the handshake the written value of the axi_podf will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_AXI_PODF_BUSY (0U)   /*!< Bit position for CCM_CDHIPR_AXI_PODF_BUSY. */
#define BM_CCM_CDHIPR_AXI_PODF_BUSY (0x00000001U) /*!< Bit mask for CCM_CDHIPR_AXI_PODF_BUSY. */
#define BS_CCM_CDHIPR_AXI_PODF_BUSY (1U)   /*!< Bit field size in bits for CCM_CDHIPR_AXI_PODF_BUSY. */

/*! @brief Read current value of the CCM_CDHIPR_AXI_PODF_BUSY field. */
#define BR_CCM_CDHIPR_AXI_PODF_BUSY(x) (HW_CCM_CDHIPR(x).B.AXI_PODF_BUSY)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field AHB_PODF_BUSY[1] (RO)
 *
 * Busy indicator for ahb_podf.
 *
 * Values:
 * - 0 - divider is not busy and its value represents the actual division.
 * - 1 - divider is busy with handshake process with module. The value read in
 *     the divider represents the previous value of the division factor, and after
 *     the handshake the written value of the ahb_podf will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_AHB_PODF_BUSY (1U)   /*!< Bit position for CCM_CDHIPR_AHB_PODF_BUSY. */
#define BM_CCM_CDHIPR_AHB_PODF_BUSY (0x00000002U) /*!< Bit mask for CCM_CDHIPR_AHB_PODF_BUSY. */
#define BS_CCM_CDHIPR_AHB_PODF_BUSY (1U)   /*!< Bit field size in bits for CCM_CDHIPR_AHB_PODF_BUSY. */

/*! @brief Read current value of the CCM_CDHIPR_AHB_PODF_BUSY field. */
#define BR_CCM_CDHIPR_AHB_PODF_BUSY(x) (HW_CCM_CDHIPR(x).B.AHB_PODF_BUSY)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field mmdc_ch1_podf_busy[2] (RO)
 *
 * Busy indicator for mmdc_ch1_axi_podf.
 *
 * Values:
 * - 0 - divider is not busy and its value represents the actual division.
 * - 1 - divider is busy with handshake process with module. The value read in
 *     the divider represents the previous value of the division factor, and after
 *     the handshake the written value of the mmdc_ch1_axi_podf will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_mmdc_ch1_podf_busy (2U) /*!< Bit position for CCM_CDHIPR_mmdc_ch1_podf_busy. */
#define BM_CCM_CDHIPR_mmdc_ch1_podf_busy (0x00000004U) /*!< Bit mask for CCM_CDHIPR_mmdc_ch1_podf_busy. */
#define BS_CCM_CDHIPR_mmdc_ch1_podf_busy (1U) /*!< Bit field size in bits for CCM_CDHIPR_mmdc_ch1_podf_busy. */

/*! @brief Read current value of the CCM_CDHIPR_mmdc_ch1_podf_busy field. */
#define BR_CCM_CDHIPR_mmdc_ch1_podf_busy(x) (HW_CCM_CDHIPR(x).B.mmdc_ch1_podf_busy)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field PERIPH2_CLK_SEL_BUSY[3] (RO)
 *
 * Busy indicator for periph2_clk_sel mux control.
 *
 * Values:
 * - 0 - mux is not busy and its value represents the actual division.
 * - 1 - mux is busy with handshake process with module. The value read in the
 *     periph2_clk_sel represents the previous value of select, and after the
 *     handshake periph2_clk_sel value will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY (3U) /*!< Bit position for CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY. */
#define BM_CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY (0x00000008U) /*!< Bit mask for CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY. */
#define BS_CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY (1U) /*!< Bit field size in bits for CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY. */

/*! @brief Read current value of the CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY field. */
#define BR_CCM_CDHIPR_PERIPH2_CLK_SEL_BUSY(x) (HW_CCM_CDHIPR(x).B.PERIPH2_CLK_SEL_BUSY)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field mmdc_ch0_podf_busy[4] (RO)
 *
 * Busy indicator for mmdc_ch0_axi_podf.
 *
 * Values:
 * - 0 - divider is not busy and its value represents the actual division.
 * - 1 - divider is busy with handshake process with module. The value read in
 *     the divider represents the previous value of the division factor, and after
 *     the handshake the written value of the mmdc_ch0_axi_podf will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_mmdc_ch0_podf_busy (4U) /*!< Bit position for CCM_CDHIPR_mmdc_ch0_podf_busy. */
#define BM_CCM_CDHIPR_mmdc_ch0_podf_busy (0x00000010U) /*!< Bit mask for CCM_CDHIPR_mmdc_ch0_podf_busy. */
#define BS_CCM_CDHIPR_mmdc_ch0_podf_busy (1U) /*!< Bit field size in bits for CCM_CDHIPR_mmdc_ch0_podf_busy. */

/*! @brief Read current value of the CCM_CDHIPR_mmdc_ch0_podf_busy field. */
#define BR_CCM_CDHIPR_mmdc_ch0_podf_busy(x) (HW_CCM_CDHIPR(x).B.mmdc_ch0_podf_busy)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field PERIPH_CLK_SEL_BUSY[5] (RO)
 *
 * Busy indicator for periph_clk_sel mux control.
 *
 * Values:
 * - 0 - mux is not busy and its value represents the actual division.
 * - 1 - mux is busy with handshake process with module. The value read in the
 *     periph_clk_sel represents the previous value of select, and after the
 *     handshake periph_clk_sel value will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_PERIPH_CLK_SEL_BUSY (5U) /*!< Bit position for CCM_CDHIPR_PERIPH_CLK_SEL_BUSY. */
#define BM_CCM_CDHIPR_PERIPH_CLK_SEL_BUSY (0x00000020U) /*!< Bit mask for CCM_CDHIPR_PERIPH_CLK_SEL_BUSY. */
#define BS_CCM_CDHIPR_PERIPH_CLK_SEL_BUSY (1U) /*!< Bit field size in bits for CCM_CDHIPR_PERIPH_CLK_SEL_BUSY. */

/*! @brief Read current value of the CCM_CDHIPR_PERIPH_CLK_SEL_BUSY field. */
#define BR_CCM_CDHIPR_PERIPH_CLK_SEL_BUSY(x) (HW_CCM_CDHIPR(x).B.PERIPH_CLK_SEL_BUSY)
/*@}*/

/*!
 * @name Register CCM_CDHIPR, field ARM_PODF_BUSY[16] (RO)
 *
 * Busy indicator for arm_podf.
 *
 * Values:
 * - 0 - divider is not busy and its value represents the actual division.
 * - 1 - divider is busy with handshake process with module. The value read in
 *     the divider represents the previous value of the division factor, and after
 *     the handshake the written value of the arm_podf will be applied.
 */
/*@{*/
#define BP_CCM_CDHIPR_ARM_PODF_BUSY (16U)  /*!< Bit position for CCM_CDHIPR_ARM_PODF_BUSY. */
#define BM_CCM_CDHIPR_ARM_PODF_BUSY (0x00010000U) /*!< Bit mask for CCM_CDHIPR_ARM_PODF_BUSY. */
#define BS_CCM_CDHIPR_ARM_PODF_BUSY (1U)   /*!< Bit field size in bits for CCM_CDHIPR_ARM_PODF_BUSY. */

/*! @brief Read current value of the CCM_CDHIPR_ARM_PODF_BUSY field. */
#define BR_CCM_CDHIPR_ARM_PODF_BUSY(x) (HW_CCM_CDHIPR(x).B.ARM_PODF_BUSY)
/*@}*/

/*******************************************************************************
 * HW_CCM_CLPCR - CCM Low Power Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CLPCR - CCM Low Power Control Register (RW)
 *
 * Reset value: 0x00000079U
 *
 * The figure below represents the CCM Low Power Control Register (CLPCR). The
 * CLPCR register contains bits to control the low power modes operation.The table
 * below provides its field descriptions.
 */
typedef union _hw_ccm_clpcr
{
    uint32_t U;
    struct _hw_ccm_clpcr_bitfields
    {
        uint32_t LPM : 2;              /*!< [1:0]  */
        uint32_t RESERVED0 : 3;        /*!< [4:2]  */
        uint32_t ARM_CLK_DIS_ON_LPM : 1; /*!< [5]  */
        uint32_t SBYOS : 1;            /*!< [6]  */
        uint32_t DIS_REF_OSC : 1;      /*!< [7]  */
        uint32_t VSTBY : 1;            /*!< [8]  */
        uint32_t STBY_COUNT : 2;       /*!< [10:9]  */
        uint32_t COSC_PWRDOWN : 1;     /*!< [11]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t wb_per_at_lpm : 1;    /*!< [16]  */
        uint32_t RESERVED2 : 2;        /*!< [18:17]  */
        uint32_t bypass_mmdc_ch0_lpm_hs : 1; /*!< [19]  */
        uint32_t RESERVED3 : 1;        /*!< [20]  */
        uint32_t bypass_mmdc_ch1_lpm_hs : 1; /*!< [21]  */
        uint32_t MASK_CORE0_WFI : 1;   /*!< [22]  */
        uint32_t mask_core1_wfi : 1;   /*!< [23]  */
        uint32_t mask_core2_wfi : 1;   /*!< [24]  */
        uint32_t mask_core3_wfi : 1;   /*!< [25]  */
        uint32_t MASK_SCU_IDLE : 1;    /*!< [26]  */
        uint32_t MASK_L2CC_IDLE : 1;   /*!< [27]  */
        uint32_t RESERVED4 : 4;        /*!< [31:28]  */
    } B;
} hw_ccm_clpcr_t;

/*!
 * @name Constants and macros for entire CCM_CLPCR register
 */
/*@{*/
#define HW_CCM_CLPCR_ADDR(x)     ((uintptr_t)(x) + 0x54U)

#define HW_CCM_CLPCR(x)          (*(__IO hw_ccm_clpcr_t *) HW_CCM_CLPCR_ADDR(x))
#define HW_CCM_CLPCR_RD(x)       (HW_CCM_CLPCR(x).U)
#define HW_CCM_CLPCR_WR(x, v)    (HW_CCM_CLPCR(x).U = (v))
#define HW_CCM_CLPCR_SET(x, v)   (HW_CCM_CLPCR_WR(x, HW_CCM_CLPCR_RD(x) |  (v)))
#define HW_CCM_CLPCR_CLR(x, v)   (HW_CCM_CLPCR_WR(x, HW_CCM_CLPCR_RD(x) & ~(v)))
#define HW_CCM_CLPCR_TOG(x, v)   (HW_CCM_CLPCR_WR(x, HW_CCM_CLPCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CLPCR bitfields
 */

/*!
 * @name Register CCM_CLPCR, field LPM[1:0] (RW)
 *
 * Setting the low power mode that system will enter on next assertion of
 * dsm_request signal.Set CCM_CGPR[INT_MEM_CLK_LPM] and CCM_CGPR[1] bits to 1 when
 * setting CCM_CLPCR[LPM] bits to 01 (WAIT Mode) or 10 (STOP mode) without power
 * gating. CCM_CGPR[INT_MEM_CLK_LPM] and CCM_CGPR[1] bits do not have to be set for
 * STOP mode entry.
 *
 * Values:
 * - 00 - Remain in run mode
 * - 01 - Transfer to wait mode
 * - 10 - Transfer to stop mode
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_CLPCR_LPM     (0U)          /*!< Bit position for CCM_CLPCR_LPM. */
#define BM_CCM_CLPCR_LPM     (0x00000003U) /*!< Bit mask for CCM_CLPCR_LPM. */
#define BS_CCM_CLPCR_LPM     (2U)          /*!< Bit field size in bits for CCM_CLPCR_LPM. */

/*! @brief Read current value of the CCM_CLPCR_LPM field. */
#define BR_CCM_CLPCR_LPM(x)  (HW_CCM_CLPCR(x).B.LPM)

/*! @brief Format value for bitfield CCM_CLPCR_LPM. */
#define BF_CCM_CLPCR_LPM(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_LPM) & BM_CCM_CLPCR_LPM)

/*! @brief Set the LPM field to a new value. */
#define BW_CCM_CLPCR_LPM(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_LPM) | BF_CCM_CLPCR_LPM(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field ARM_CLK_DIS_ON_LPM[5] (RW)
 *
 * Define if ARM clocks (arm_clk, soc_mxclk, soc_pclk, soc_dbg_pclk, vl_wrck)
 * will be disabled on wait mode. This is useful for debug mode, when the user
 * still wants to simulate entering wait mode and still keep ARM clock functioning.
 * Software should not enable ARM power gating in wait mode if this bit is cleared.
 *
 * Values:
 * - 0 - ARM clock enabled on wait mode.
 * - 1 - ARM clock disabled on wait mode. .
 */
/*@{*/
#define BP_CCM_CLPCR_ARM_CLK_DIS_ON_LPM (5U) /*!< Bit position for CCM_CLPCR_ARM_CLK_DIS_ON_LPM. */
#define BM_CCM_CLPCR_ARM_CLK_DIS_ON_LPM (0x00000020U) /*!< Bit mask for CCM_CLPCR_ARM_CLK_DIS_ON_LPM. */
#define BS_CCM_CLPCR_ARM_CLK_DIS_ON_LPM (1U) /*!< Bit field size in bits for CCM_CLPCR_ARM_CLK_DIS_ON_LPM. */

/*! @brief Read current value of the CCM_CLPCR_ARM_CLK_DIS_ON_LPM field. */
#define BR_CCM_CLPCR_ARM_CLK_DIS_ON_LPM(x) (HW_CCM_CLPCR(x).B.ARM_CLK_DIS_ON_LPM)

/*! @brief Format value for bitfield CCM_CLPCR_ARM_CLK_DIS_ON_LPM. */
#define BF_CCM_CLPCR_ARM_CLK_DIS_ON_LPM(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_ARM_CLK_DIS_ON_LPM) & BM_CCM_CLPCR_ARM_CLK_DIS_ON_LPM)

/*! @brief Set the ARM_CLK_DIS_ON_LPM field to a new value. */
#define BW_CCM_CLPCR_ARM_CLK_DIS_ON_LPM(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_ARM_CLK_DIS_ON_LPM) | BF_CCM_CLPCR_ARM_CLK_DIS_ON_LPM(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field SBYOS[6] (RW)
 *
 * Standby clock oscillator bit. This bit defines if cosc_pwrdown, which power
 * down the on chip oscillator, will be asserted in STOP mode. This bit is
 * discarded if cosc_pwrdown='1' for the on chip oscillator.
 *
 * Values:
 * - 0 - On-chip oscillator will not be powered down, after next entrance to
 *     STOP mode. (CCM_REF_EN_B will remain asserted - '0' and cosc_pwrdown will
 *     remain de asserted - '0')
 * - 1 - On-chip oscillator will be powered down, after next entrance to STOP
 *     mode. (CCM_REF_EN_B will be deasserted - '1' and cosc_pwrdown will be
 *     asserted - '1'). When returning from STOP mode, external oscillator will be
 *     enabled again, on-chip oscillator will return to oscillator mode, and after
 *     oscnt count, CCM will continue with the exit from the STOP mode process.
 */
/*@{*/
#define BP_CCM_CLPCR_SBYOS   (6U)          /*!< Bit position for CCM_CLPCR_SBYOS. */
#define BM_CCM_CLPCR_SBYOS   (0x00000040U) /*!< Bit mask for CCM_CLPCR_SBYOS. */
#define BS_CCM_CLPCR_SBYOS   (1U)          /*!< Bit field size in bits for CCM_CLPCR_SBYOS. */

/*! @brief Read current value of the CCM_CLPCR_SBYOS field. */
#define BR_CCM_CLPCR_SBYOS(x) (HW_CCM_CLPCR(x).B.SBYOS)

/*! @brief Format value for bitfield CCM_CLPCR_SBYOS. */
#define BF_CCM_CLPCR_SBYOS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_SBYOS) & BM_CCM_CLPCR_SBYOS)

/*! @brief Set the SBYOS field to a new value. */
#define BW_CCM_CLPCR_SBYOS(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_SBYOS) | BF_CCM_CLPCR_SBYOS(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field DIS_REF_OSC[7] (RW)
 *
 * dis_ref_osc - in run mode, software can manually control closing of external
 * reference oscillator clock, i.e. generating '1' on CCM_REF_EN_B signal. If
 * software closed manually the external reference clock, then sbyos functionality
 * will be bypassed. The manual closing of external reference oscilator should be
 * performed only in case the reference oscilator is not the source of any clock
 * generation. When returning from stop mode, the PMIC_STBY_REQ will be
 * deasserted (if it was asserted when entering stop mode). See stby_count bits.
 *
 * Values:
 * - 0 - external high frequency oscillator will be enabled, i.e. CCM_REF_EN_B =
 *     '0'.
 * - 1 - external high frequency oscillator will be disabled, i.e. CCM_REF_EN_B
 *     = '1'
 */
/*@{*/
#define BP_CCM_CLPCR_DIS_REF_OSC (7U)      /*!< Bit position for CCM_CLPCR_DIS_REF_OSC. */
#define BM_CCM_CLPCR_DIS_REF_OSC (0x00000080U) /*!< Bit mask for CCM_CLPCR_DIS_REF_OSC. */
#define BS_CCM_CLPCR_DIS_REF_OSC (1U)      /*!< Bit field size in bits for CCM_CLPCR_DIS_REF_OSC. */

/*! @brief Read current value of the CCM_CLPCR_DIS_REF_OSC field. */
#define BR_CCM_CLPCR_DIS_REF_OSC(x) (HW_CCM_CLPCR(x).B.DIS_REF_OSC)

/*! @brief Format value for bitfield CCM_CLPCR_DIS_REF_OSC. */
#define BF_CCM_CLPCR_DIS_REF_OSC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_DIS_REF_OSC) & BM_CCM_CLPCR_DIS_REF_OSC)

/*! @brief Set the DIS_REF_OSC field to a new value. */
#define BW_CCM_CLPCR_DIS_REF_OSC(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_DIS_REF_OSC) | BF_CCM_CLPCR_DIS_REF_OSC(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field VSTBY[8] (RW)
 *
 * Voltage standby request bit. This bit defines if PMIC_STBY_REQ pin, which
 * notifies external power management IC to move from functional voltage to standby
 * voltage, will be asserted in STOP mode.
 *
 * Values:
 * - 0 - Voltage will not be changed to standby voltage after next entrance to
 *     STOP mode. ( PMIC_STBY_REQ will remain negated - '0')
 * - 1 - Voltage will be requested to change to standby voltage after next
 *     entrance to stop mode. ( PMIC_STBY_REQ will be asserted - '1').
 */
/*@{*/
#define BP_CCM_CLPCR_VSTBY   (8U)          /*!< Bit position for CCM_CLPCR_VSTBY. */
#define BM_CCM_CLPCR_VSTBY   (0x00000100U) /*!< Bit mask for CCM_CLPCR_VSTBY. */
#define BS_CCM_CLPCR_VSTBY   (1U)          /*!< Bit field size in bits for CCM_CLPCR_VSTBY. */

/*! @brief Read current value of the CCM_CLPCR_VSTBY field. */
#define BR_CCM_CLPCR_VSTBY(x) (HW_CCM_CLPCR(x).B.VSTBY)

/*! @brief Format value for bitfield CCM_CLPCR_VSTBY. */
#define BF_CCM_CLPCR_VSTBY(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_VSTBY) & BM_CCM_CLPCR_VSTBY)

/*! @brief Set the VSTBY field to a new value. */
#define BW_CCM_CLPCR_VSTBY(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_VSTBY) | BF_CCM_CLPCR_VSTBY(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field STBY_COUNT[10:9] (RW)
 *
 * Standby counter definition. These two bits define, in the case of stop exit
 * (if VSTBY bit was set). Clock cycles ratio depends on pmic_delay_scaler,
 * defined by CGPR[0] bit.
 *
 * Values:
 * - 00 - CCM will wait (1*pmic_delay_scaler)+1 ckil clock cycles
 * - 01 - CCM will wait (3*pmic_delay_scaler)+1 ckil clock cycles
 * - 10 - CCM will wait (7*pmic_delay_scaler)+1 ckil clock cycles
 * - 11 - CCM will wait (15*pmic_delay_scaler)+1 ckil clock cycles
 */
/*@{*/
#define BP_CCM_CLPCR_STBY_COUNT (9U)       /*!< Bit position for CCM_CLPCR_STBY_COUNT. */
#define BM_CCM_CLPCR_STBY_COUNT (0x00000600U) /*!< Bit mask for CCM_CLPCR_STBY_COUNT. */
#define BS_CCM_CLPCR_STBY_COUNT (2U)       /*!< Bit field size in bits for CCM_CLPCR_STBY_COUNT. */

/*! @brief Read current value of the CCM_CLPCR_STBY_COUNT field. */
#define BR_CCM_CLPCR_STBY_COUNT(x) (HW_CCM_CLPCR(x).B.STBY_COUNT)

/*! @brief Format value for bitfield CCM_CLPCR_STBY_COUNT. */
#define BF_CCM_CLPCR_STBY_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_STBY_COUNT) & BM_CCM_CLPCR_STBY_COUNT)

/*! @brief Set the STBY_COUNT field to a new value. */
#define BW_CCM_CLPCR_STBY_COUNT(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_STBY_COUNT) | BF_CCM_CLPCR_STBY_COUNT(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field COSC_PWRDOWN[11] (RW)
 *
 * In run mode, software can manually control powering down of on chip
 * oscillator, i.e. generating '1' on cosc_pwrdown signal. If software manually powered
 * down the on chip oscillator, then sbyos functionality for on chip oscillator
 * will be bypassed. The manual closing of onchip oscillator should be performed
 * only in case the reference oscilator is not the source of all the clocks
 * generation.
 *
 * Values:
 * - 0 - On chip oscillator will not be powered down, i.e. cosc_pwrdown = '0'.
 * - 1 - On chip oscillator will be powered down, i.e. cosc_pwrdown = '1'.
 */
/*@{*/
#define BP_CCM_CLPCR_COSC_PWRDOWN (11U)    /*!< Bit position for CCM_CLPCR_COSC_PWRDOWN. */
#define BM_CCM_CLPCR_COSC_PWRDOWN (0x00000800U) /*!< Bit mask for CCM_CLPCR_COSC_PWRDOWN. */
#define BS_CCM_CLPCR_COSC_PWRDOWN (1U)     /*!< Bit field size in bits for CCM_CLPCR_COSC_PWRDOWN. */

/*! @brief Read current value of the CCM_CLPCR_COSC_PWRDOWN field. */
#define BR_CCM_CLPCR_COSC_PWRDOWN(x) (HW_CCM_CLPCR(x).B.COSC_PWRDOWN)

/*! @brief Format value for bitfield CCM_CLPCR_COSC_PWRDOWN. */
#define BF_CCM_CLPCR_COSC_PWRDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_COSC_PWRDOWN) & BM_CCM_CLPCR_COSC_PWRDOWN)

/*! @brief Set the COSC_PWRDOWN field to a new value. */
#define BW_CCM_CLPCR_COSC_PWRDOWN(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_COSC_PWRDOWN) | BF_CCM_CLPCR_COSC_PWRDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field wb_per_at_lpm[16] (RW)
 *
 * Enable periphery charge pump for well biasing at low power mode (stop or wait)
 *
 * Values:
 * - 0 - Periphery charge pump won't be enabled at STOP or WAIT low power modes
 * - 1 - Periphery charge pump will be enabled at STOP or WAIT low power modes
 */
/*@{*/
#define BP_CCM_CLPCR_wb_per_at_lpm (16U)   /*!< Bit position for CCM_CLPCR_wb_per_at_lpm. */
#define BM_CCM_CLPCR_wb_per_at_lpm (0x00010000U) /*!< Bit mask for CCM_CLPCR_wb_per_at_lpm. */
#define BS_CCM_CLPCR_wb_per_at_lpm (1U)    /*!< Bit field size in bits for CCM_CLPCR_wb_per_at_lpm. */

/*! @brief Read current value of the CCM_CLPCR_wb_per_at_lpm field. */
#define BR_CCM_CLPCR_wb_per_at_lpm(x) (HW_CCM_CLPCR(x).B.wb_per_at_lpm)

/*! @brief Format value for bitfield CCM_CLPCR_wb_per_at_lpm. */
#define BF_CCM_CLPCR_wb_per_at_lpm(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_wb_per_at_lpm) & BM_CCM_CLPCR_wb_per_at_lpm)

/*! @brief Set the wb_per_at_lpm field to a new value. */
#define BW_CCM_CLPCR_wb_per_at_lpm(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_wb_per_at_lpm) | BF_CCM_CLPCR_wb_per_at_lpm(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field bypass_mmdc_ch0_lpm_hs[19] (RW)
 *
 * Bypass handshake with mmdc_ch0 on next entrance to low power mode (STOP or
 * WAIT). CCM doesn't wait for the module's acknowledge. Handshake will also be
 * bypassed, if CGR3 CG10 is set to gate fast mmdc_ch0 clock.
 *
 * Values:
 * - 0 - Handshake with mmdc_ch0 on next entrance to low power mode will be
 *     performed. .
 * - 1 - Handshake with mmdc_ch0 on next entrance to low power mode will be
 *     bypassed.
 */
/*@{*/
#define BP_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs (19U) /*!< Bit position for CCM_CLPCR_bypass_mmdc_ch0_lpm_hs. */
#define BM_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs (0x00080000U) /*!< Bit mask for CCM_CLPCR_bypass_mmdc_ch0_lpm_hs. */
#define BS_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs (1U) /*!< Bit field size in bits for CCM_CLPCR_bypass_mmdc_ch0_lpm_hs. */

/*! @brief Read current value of the CCM_CLPCR_bypass_mmdc_ch0_lpm_hs field. */
#define BR_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs(x) (HW_CCM_CLPCR(x).B.bypass_mmdc_ch0_lpm_hs)

/*! @brief Format value for bitfield CCM_CLPCR_bypass_mmdc_ch0_lpm_hs. */
#define BF_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs) & BM_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs)

/*! @brief Set the bypass_mmdc_ch0_lpm_hs field to a new value. */
#define BW_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs) | BF_CCM_CLPCR_bypass_mmdc_ch0_lpm_hs(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field bypass_mmdc_ch1_lpm_hs[21] (RW)
 *
 * Bypass handshake with mmdc_ch1 on next entrance to low power mode (STOP or
 * WAIT). CCM doesn't wait for the module's acknowledge.
 *
 * Values:
 * - 0 - Handshake with mmdc_ch1 on next entrance to low power mode will be
 *     performed.
 * - 1 - Handshake with mmdc_ch1 on next entrance to low power mode will be
 *     bypassed.
 */
/*@{*/
#define BP_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs (21U) /*!< Bit position for CCM_CLPCR_bypass_mmdc_ch1_lpm_hs. */
#define BM_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs (0x00200000U) /*!< Bit mask for CCM_CLPCR_bypass_mmdc_ch1_lpm_hs. */
#define BS_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs (1U) /*!< Bit field size in bits for CCM_CLPCR_bypass_mmdc_ch1_lpm_hs. */

/*! @brief Read current value of the CCM_CLPCR_bypass_mmdc_ch1_lpm_hs field. */
#define BR_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs(x) (HW_CCM_CLPCR(x).B.bypass_mmdc_ch1_lpm_hs)

/*! @brief Format value for bitfield CCM_CLPCR_bypass_mmdc_ch1_lpm_hs. */
#define BF_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs) & BM_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs)

/*! @brief Set the bypass_mmdc_ch1_lpm_hs field to a new value. */
#define BW_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs) | BF_CCM_CLPCR_bypass_mmdc_ch1_lpm_hs(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field MASK_CORE0_WFI[22] (RW)
 *
 * Mask WFI of core0 for entering low power mode Assertion of all bits[27:22]
 * will generate low power mode request
 *
 * Values:
 * - 0 - WFI of core0 is not masked
 * - 1 - WFI of core0 is masked
 */
/*@{*/
#define BP_CCM_CLPCR_MASK_CORE0_WFI (22U)  /*!< Bit position for CCM_CLPCR_MASK_CORE0_WFI. */
#define BM_CCM_CLPCR_MASK_CORE0_WFI (0x00400000U) /*!< Bit mask for CCM_CLPCR_MASK_CORE0_WFI. */
#define BS_CCM_CLPCR_MASK_CORE0_WFI (1U)   /*!< Bit field size in bits for CCM_CLPCR_MASK_CORE0_WFI. */

/*! @brief Read current value of the CCM_CLPCR_MASK_CORE0_WFI field. */
#define BR_CCM_CLPCR_MASK_CORE0_WFI(x) (HW_CCM_CLPCR(x).B.MASK_CORE0_WFI)

/*! @brief Format value for bitfield CCM_CLPCR_MASK_CORE0_WFI. */
#define BF_CCM_CLPCR_MASK_CORE0_WFI(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_MASK_CORE0_WFI) & BM_CCM_CLPCR_MASK_CORE0_WFI)

/*! @brief Set the MASK_CORE0_WFI field to a new value. */
#define BW_CCM_CLPCR_MASK_CORE0_WFI(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_MASK_CORE0_WFI) | BF_CCM_CLPCR_MASK_CORE0_WFI(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field mask_core1_wfi[23] (RW)
 *
 * Mask WFI of core1 for entering low power mode Assertion of all bits[27:22]
 * will generate low power mode request
 *
 * Values:
 * - 1 - WFI of core1 is masked
 * - 0 - WFI of core1 is not masked
 */
/*@{*/
#define BP_CCM_CLPCR_mask_core1_wfi (23U)  /*!< Bit position for CCM_CLPCR_mask_core1_wfi. */
#define BM_CCM_CLPCR_mask_core1_wfi (0x00800000U) /*!< Bit mask for CCM_CLPCR_mask_core1_wfi. */
#define BS_CCM_CLPCR_mask_core1_wfi (1U)   /*!< Bit field size in bits for CCM_CLPCR_mask_core1_wfi. */

/*! @brief Read current value of the CCM_CLPCR_mask_core1_wfi field. */
#define BR_CCM_CLPCR_mask_core1_wfi(x) (HW_CCM_CLPCR(x).B.mask_core1_wfi)

/*! @brief Format value for bitfield CCM_CLPCR_mask_core1_wfi. */
#define BF_CCM_CLPCR_mask_core1_wfi(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_mask_core1_wfi) & BM_CCM_CLPCR_mask_core1_wfi)

/*! @brief Set the mask_core1_wfi field to a new value. */
#define BW_CCM_CLPCR_mask_core1_wfi(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_mask_core1_wfi) | BF_CCM_CLPCR_mask_core1_wfi(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field mask_core2_wfi[24] (RW)
 *
 * Mask WFI of core2 for entering low power mode Assertion of all bits[27:22]
 * will generate low power mode request
 *
 * Values:
 * - 1 - WFI of core2 is masked
 * - 0 - WFI of core2 is not masked
 */
/*@{*/
#define BP_CCM_CLPCR_mask_core2_wfi (24U)  /*!< Bit position for CCM_CLPCR_mask_core2_wfi. */
#define BM_CCM_CLPCR_mask_core2_wfi (0x01000000U) /*!< Bit mask for CCM_CLPCR_mask_core2_wfi. */
#define BS_CCM_CLPCR_mask_core2_wfi (1U)   /*!< Bit field size in bits for CCM_CLPCR_mask_core2_wfi. */

/*! @brief Read current value of the CCM_CLPCR_mask_core2_wfi field. */
#define BR_CCM_CLPCR_mask_core2_wfi(x) (HW_CCM_CLPCR(x).B.mask_core2_wfi)

/*! @brief Format value for bitfield CCM_CLPCR_mask_core2_wfi. */
#define BF_CCM_CLPCR_mask_core2_wfi(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_mask_core2_wfi) & BM_CCM_CLPCR_mask_core2_wfi)

/*! @brief Set the mask_core2_wfi field to a new value. */
#define BW_CCM_CLPCR_mask_core2_wfi(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_mask_core2_wfi) | BF_CCM_CLPCR_mask_core2_wfi(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field mask_core3_wfi[25] (RW)
 *
 * Mask WFI of core3 for entering low power mode Assertion of all bits[27:22]
 * will generate low power mode request
 *
 * Values:
 * - 1 - WFI of core3 is masked
 * - 0 - WFI of core3 is not masked
 */
/*@{*/
#define BP_CCM_CLPCR_mask_core3_wfi (25U)  /*!< Bit position for CCM_CLPCR_mask_core3_wfi. */
#define BM_CCM_CLPCR_mask_core3_wfi (0x02000000U) /*!< Bit mask for CCM_CLPCR_mask_core3_wfi. */
#define BS_CCM_CLPCR_mask_core3_wfi (1U)   /*!< Bit field size in bits for CCM_CLPCR_mask_core3_wfi. */

/*! @brief Read current value of the CCM_CLPCR_mask_core3_wfi field. */
#define BR_CCM_CLPCR_mask_core3_wfi(x) (HW_CCM_CLPCR(x).B.mask_core3_wfi)

/*! @brief Format value for bitfield CCM_CLPCR_mask_core3_wfi. */
#define BF_CCM_CLPCR_mask_core3_wfi(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_mask_core3_wfi) & BM_CCM_CLPCR_mask_core3_wfi)

/*! @brief Set the mask_core3_wfi field to a new value. */
#define BW_CCM_CLPCR_mask_core3_wfi(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_mask_core3_wfi) | BF_CCM_CLPCR_mask_core3_wfi(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field MASK_SCU_IDLE[26] (RW)
 *
 * Mask SCU IDLE for entering low power mode Assertion of all bits[27:22] will
 * generate low power mode request
 *
 * Values:
 * - 1 - SCU IDLE is masked
 * - 0 - SCU IDLE is not masked
 */
/*@{*/
#define BP_CCM_CLPCR_MASK_SCU_IDLE (26U)   /*!< Bit position for CCM_CLPCR_MASK_SCU_IDLE. */
#define BM_CCM_CLPCR_MASK_SCU_IDLE (0x04000000U) /*!< Bit mask for CCM_CLPCR_MASK_SCU_IDLE. */
#define BS_CCM_CLPCR_MASK_SCU_IDLE (1U)    /*!< Bit field size in bits for CCM_CLPCR_MASK_SCU_IDLE. */

/*! @brief Read current value of the CCM_CLPCR_MASK_SCU_IDLE field. */
#define BR_CCM_CLPCR_MASK_SCU_IDLE(x) (HW_CCM_CLPCR(x).B.MASK_SCU_IDLE)

/*! @brief Format value for bitfield CCM_CLPCR_MASK_SCU_IDLE. */
#define BF_CCM_CLPCR_MASK_SCU_IDLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_MASK_SCU_IDLE) & BM_CCM_CLPCR_MASK_SCU_IDLE)

/*! @brief Set the MASK_SCU_IDLE field to a new value. */
#define BW_CCM_CLPCR_MASK_SCU_IDLE(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_MASK_SCU_IDLE) | BF_CCM_CLPCR_MASK_SCU_IDLE(v)))
/*@}*/

/*!
 * @name Register CCM_CLPCR, field MASK_L2CC_IDLE[27] (RW)
 *
 * Mask L2CC IDLE for entering low power mode. Assertion of all bits[27:22] will
 * generate low power mode request
 *
 * Values:
 * - 1 - L2CC IDLE is masked
 * - 0 - L2CC IDLE is not masked
 */
/*@{*/
#define BP_CCM_CLPCR_MASK_L2CC_IDLE (27U)  /*!< Bit position for CCM_CLPCR_MASK_L2CC_IDLE. */
#define BM_CCM_CLPCR_MASK_L2CC_IDLE (0x08000000U) /*!< Bit mask for CCM_CLPCR_MASK_L2CC_IDLE. */
#define BS_CCM_CLPCR_MASK_L2CC_IDLE (1U)   /*!< Bit field size in bits for CCM_CLPCR_MASK_L2CC_IDLE. */

/*! @brief Read current value of the CCM_CLPCR_MASK_L2CC_IDLE field. */
#define BR_CCM_CLPCR_MASK_L2CC_IDLE(x) (HW_CCM_CLPCR(x).B.MASK_L2CC_IDLE)

/*! @brief Format value for bitfield CCM_CLPCR_MASK_L2CC_IDLE. */
#define BF_CCM_CLPCR_MASK_L2CC_IDLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CLPCR_MASK_L2CC_IDLE) & BM_CCM_CLPCR_MASK_L2CC_IDLE)

/*! @brief Set the MASK_L2CC_IDLE field to a new value. */
#define BW_CCM_CLPCR_MASK_L2CC_IDLE(x, v) (HW_CCM_CLPCR_WR(x, (HW_CCM_CLPCR_RD(x) & ~BM_CCM_CLPCR_MASK_L2CC_IDLE) | BF_CCM_CLPCR_MASK_L2CC_IDLE(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CISR - CCM Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CISR - CCM Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The figure below represents the CCM Interrupt Status Register (CISR). This is
 * a write one to clear register. Once a interrupt is generated, software should
 * write one to clear it. The table below provides its field descriptions. CCM
 * interrupt request 1 can be masked by CCM interrupt request 1 mask bit. CCM
 * interrupt request 2 can be masked by CCM interrupt request 2 mask bit.
 */
typedef union _hw_ccm_cisr
{
    uint32_t U;
    struct _hw_ccm_cisr_bitfields
    {
        uint32_t LRF_PLL : 1;          /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t COSC_READY : 1;       /*!< [6]  */
        uint32_t RESERVED1 : 10;       /*!< [16:7]  */
        uint32_t AXI_PODF_LOADED : 1;  /*!< [17]  */
        uint32_t mmdc_ch0_axi_podf_loaded : 1; /*!< [18]  */
        uint32_t PERIPH2_CLK_SEL_LOADED : 1; /*!< [19]  */
        uint32_t AHB_PODF_LOADED : 1;  /*!< [20]  */
        uint32_t mmdc_ch1_podf_loaded : 1; /*!< [21]  */
        uint32_t PERIPH_CLK_SEL_LOADED : 1; /*!< [22]  */
        uint32_t mmdc_ch0_podf_loaded : 1; /*!< [23]  */
        uint32_t RESERVED2 : 2;        /*!< [25:24]  */
        uint32_t ARM_PODF_LOADED : 1;  /*!< [26]  */
        uint32_t RESERVED3 : 5;        /*!< [31:27]  */
    } B;
} hw_ccm_cisr_t;

/*!
 * @name Constants and macros for entire CCM_CISR register
 */
/*@{*/
#define HW_CCM_CISR_ADDR(x)      ((uintptr_t)(x) + 0x58U)

#define HW_CCM_CISR(x)           (*(__IO hw_ccm_cisr_t *) HW_CCM_CISR_ADDR(x))
#define HW_CCM_CISR_RD(x)        (HW_CCM_CISR(x).U)
#define HW_CCM_CISR_WR(x, v)     (HW_CCM_CISR(x).U = (v))
#define HW_CCM_CISR_SET(x, v)    (HW_CCM_CISR_WR(x, HW_CCM_CISR_RD(x) |  (v)))
#define HW_CCM_CISR_CLR(x, v)    (HW_CCM_CISR_WR(x, HW_CCM_CISR_RD(x) & ~(v)))
#define HW_CCM_CISR_TOG(x, v)    (HW_CCM_CISR_WR(x, HW_CCM_CISR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CISR bitfields
 */

/*!
 * @name Register CCM_CISR, field LRF_PLL[0] (W1C)
 *
 * CCM interrupt request 2 generated due to lock of all enabled and not bypaseed
 * PLLs
 *
 * Values:
 * - 0 - interrupt is not generated due to lock ready of all enabled and not
 *     bypaseed PLLs
 * - 1 - interrupt generated due to lock ready of all enabled and not bypaseed
 *     PLLs
 */
/*@{*/
#define BP_CCM_CISR_LRF_PLL  (0U)          /*!< Bit position for CCM_CISR_LRF_PLL. */
#define BM_CCM_CISR_LRF_PLL  (0x00000001U) /*!< Bit mask for CCM_CISR_LRF_PLL. */
#define BS_CCM_CISR_LRF_PLL  (1U)          /*!< Bit field size in bits for CCM_CISR_LRF_PLL. */

/*! @brief Read current value of the CCM_CISR_LRF_PLL field. */
#define BR_CCM_CISR_LRF_PLL(x) (HW_CCM_CISR(x).B.LRF_PLL)

/*! @brief Format value for bitfield CCM_CISR_LRF_PLL. */
#define BF_CCM_CISR_LRF_PLL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_LRF_PLL) & BM_CCM_CISR_LRF_PLL)

/*! @brief Set the LRF_PLL field to a new value. */
#define BW_CCM_CISR_LRF_PLL(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_LRF_PLL(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field COSC_READY[6] (W1C)
 *
 * CCM interrupt request 2 generated due to on board oscillator ready, i.e.
 * oscnt has finished counting.
 *
 * Values:
 * - 0 - interrupt is not generated due to on board oscillator ready
 * - 1 - interrupt generated due to on board oscillator ready
 */
/*@{*/
#define BP_CCM_CISR_COSC_READY (6U)        /*!< Bit position for CCM_CISR_COSC_READY. */
#define BM_CCM_CISR_COSC_READY (0x00000040U) /*!< Bit mask for CCM_CISR_COSC_READY. */
#define BS_CCM_CISR_COSC_READY (1U)        /*!< Bit field size in bits for CCM_CISR_COSC_READY. */

/*! @brief Read current value of the CCM_CISR_COSC_READY field. */
#define BR_CCM_CISR_COSC_READY(x) (HW_CCM_CISR(x).B.COSC_READY)

/*! @brief Format value for bitfield CCM_CISR_COSC_READY. */
#define BF_CCM_CISR_COSC_READY(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_COSC_READY) & BM_CCM_CISR_COSC_READY)

/*! @brief Set the COSC_READY field to a new value. */
#define BW_CCM_CISR_COSC_READY(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_COSC_READY | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_COSC_READY(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field AXI_PODF_LOADED[17] (W1C)
 *
 * CCM interrupt request 1 generated due to frequency change of axi_podf
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of axi_podf
 * - 1 - interrupt generated due to frequency change of axi_podf
 */
/*@{*/
#define BP_CCM_CISR_AXI_PODF_LOADED (17U)  /*!< Bit position for CCM_CISR_AXI_PODF_LOADED. */
#define BM_CCM_CISR_AXI_PODF_LOADED (0x00020000U) /*!< Bit mask for CCM_CISR_AXI_PODF_LOADED. */
#define BS_CCM_CISR_AXI_PODF_LOADED (1U)   /*!< Bit field size in bits for CCM_CISR_AXI_PODF_LOADED. */

/*! @brief Read current value of the CCM_CISR_AXI_PODF_LOADED field. */
#define BR_CCM_CISR_AXI_PODF_LOADED(x) (HW_CCM_CISR(x).B.AXI_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CISR_AXI_PODF_LOADED. */
#define BF_CCM_CISR_AXI_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_AXI_PODF_LOADED) & BM_CCM_CISR_AXI_PODF_LOADED)

/*! @brief Set the AXI_PODF_LOADED field to a new value. */
#define BW_CCM_CISR_AXI_PODF_LOADED(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_AXI_PODF_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field mmdc_ch0_axi_podf_loaded[18] (ROZ)
 *
 * CCM interrupt request 1 generated due to frequency change of mmdc_ch0_axi_podf
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of mmdc_ch0_axi_podf
 * - 1 - interrupt generated due to frequency change of mmdc_ch0_axi_podf
 */
/*@{*/
#define BP_CCM_CISR_mmdc_ch0_axi_podf_loaded (18U) /*!< Bit position for CCM_CISR_mmdc_ch0_axi_podf_loaded. */
#define BM_CCM_CISR_mmdc_ch0_axi_podf_loaded (0x00040000U) /*!< Bit mask for CCM_CISR_mmdc_ch0_axi_podf_loaded. */
#define BS_CCM_CISR_mmdc_ch0_axi_podf_loaded (1U) /*!< Bit field size in bits for CCM_CISR_mmdc_ch0_axi_podf_loaded. */

/*! @brief Read current value of the CCM_CISR_mmdc_ch0_axi_podf_loaded field. */
#define BR_CCM_CISR_mmdc_ch0_axi_podf_loaded(x) (HW_CCM_CISR(x).B.mmdc_ch0_axi_podf_loaded)
/*@}*/

/*!
 * @name Register CCM_CISR, field PERIPH2_CLK_SEL_LOADED[19] (W1C)
 *
 * CCM interrupt request 1 generated due to frequency change of periph2_clk_sel
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of periph2_clk_sel
 * - 1 - interrupt generated due to frequency change of periph2_clk_sel
 */
/*@{*/
#define BP_CCM_CISR_PERIPH2_CLK_SEL_LOADED (19U) /*!< Bit position for CCM_CISR_PERIPH2_CLK_SEL_LOADED. */
#define BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED (0x00080000U) /*!< Bit mask for CCM_CISR_PERIPH2_CLK_SEL_LOADED. */
#define BS_CCM_CISR_PERIPH2_CLK_SEL_LOADED (1U) /*!< Bit field size in bits for CCM_CISR_PERIPH2_CLK_SEL_LOADED. */

/*! @brief Read current value of the CCM_CISR_PERIPH2_CLK_SEL_LOADED field. */
#define BR_CCM_CISR_PERIPH2_CLK_SEL_LOADED(x) (HW_CCM_CISR(x).B.PERIPH2_CLK_SEL_LOADED)

/*! @brief Format value for bitfield CCM_CISR_PERIPH2_CLK_SEL_LOADED. */
#define BF_CCM_CISR_PERIPH2_CLK_SEL_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_PERIPH2_CLK_SEL_LOADED) & BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED)

/*! @brief Set the PERIPH2_CLK_SEL_LOADED field to a new value. */
#define BW_CCM_CISR_PERIPH2_CLK_SEL_LOADED(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_PERIPH2_CLK_SEL_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field AHB_PODF_LOADED[20] (W1C)
 *
 * CCM interrupt request 1 generated due to frequency change of ahb_podf
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of ahb_podf
 * - 1 - interrupt generated due to frequency change of ahb_podf
 */
/*@{*/
#define BP_CCM_CISR_AHB_PODF_LOADED (20U)  /*!< Bit position for CCM_CISR_AHB_PODF_LOADED. */
#define BM_CCM_CISR_AHB_PODF_LOADED (0x00100000U) /*!< Bit mask for CCM_CISR_AHB_PODF_LOADED. */
#define BS_CCM_CISR_AHB_PODF_LOADED (1U)   /*!< Bit field size in bits for CCM_CISR_AHB_PODF_LOADED. */

/*! @brief Read current value of the CCM_CISR_AHB_PODF_LOADED field. */
#define BR_CCM_CISR_AHB_PODF_LOADED(x) (HW_CCM_CISR(x).B.AHB_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CISR_AHB_PODF_LOADED. */
#define BF_CCM_CISR_AHB_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_AHB_PODF_LOADED) & BM_CCM_CISR_AHB_PODF_LOADED)

/*! @brief Set the AHB_PODF_LOADED field to a new value. */
#define BW_CCM_CISR_AHB_PODF_LOADED(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_AHB_PODF_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field mmdc_ch1_podf_loaded[21] (W1C)
 *
 * CCM interrupt request 1 generated due to frequency change of mmdc_ch0_podf_
 * loaded
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of mmdc_ch0_podf_
 *     loaded
 * - 1 - interrupt generated due to frequency change of mmdc_ch0_podf_ loaded
 */
/*@{*/
#define BP_CCM_CISR_mmdc_ch1_podf_loaded (21U) /*!< Bit position for CCM_CISR_mmdc_ch1_podf_loaded. */
#define BM_CCM_CISR_mmdc_ch1_podf_loaded (0x00200000U) /*!< Bit mask for CCM_CISR_mmdc_ch1_podf_loaded. */
#define BS_CCM_CISR_mmdc_ch1_podf_loaded (1U) /*!< Bit field size in bits for CCM_CISR_mmdc_ch1_podf_loaded. */

/*! @brief Read current value of the CCM_CISR_mmdc_ch1_podf_loaded field. */
#define BR_CCM_CISR_mmdc_ch1_podf_loaded(x) (HW_CCM_CISR(x).B.mmdc_ch1_podf_loaded)

/*! @brief Format value for bitfield CCM_CISR_mmdc_ch1_podf_loaded. */
#define BF_CCM_CISR_mmdc_ch1_podf_loaded(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_mmdc_ch1_podf_loaded) & BM_CCM_CISR_mmdc_ch1_podf_loaded)

/*! @brief Set the mmdc_ch1_podf_loaded field to a new value. */
#define BW_CCM_CISR_mmdc_ch1_podf_loaded(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_mmdc_ch1_podf_loaded(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field PERIPH_CLK_SEL_LOADED[22] (W1C)
 *
 * CCM interrupt request 1 generated due to update of periph_clk_sel.
 *
 * Values:
 * - 0 - interrupt is not generated due to update of periph_clk_sel.
 * - 1 - interrupt generated due to update of periph_clk_sel.
 */
/*@{*/
#define BP_CCM_CISR_PERIPH_CLK_SEL_LOADED (22U) /*!< Bit position for CCM_CISR_PERIPH_CLK_SEL_LOADED. */
#define BM_CCM_CISR_PERIPH_CLK_SEL_LOADED (0x00400000U) /*!< Bit mask for CCM_CISR_PERIPH_CLK_SEL_LOADED. */
#define BS_CCM_CISR_PERIPH_CLK_SEL_LOADED (1U) /*!< Bit field size in bits for CCM_CISR_PERIPH_CLK_SEL_LOADED. */

/*! @brief Read current value of the CCM_CISR_PERIPH_CLK_SEL_LOADED field. */
#define BR_CCM_CISR_PERIPH_CLK_SEL_LOADED(x) (HW_CCM_CISR(x).B.PERIPH_CLK_SEL_LOADED)

/*! @brief Format value for bitfield CCM_CISR_PERIPH_CLK_SEL_LOADED. */
#define BF_CCM_CISR_PERIPH_CLK_SEL_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_PERIPH_CLK_SEL_LOADED) & BM_CCM_CISR_PERIPH_CLK_SEL_LOADED)

/*! @brief Set the PERIPH_CLK_SEL_LOADED field to a new value. */
#define BW_CCM_CISR_PERIPH_CLK_SEL_LOADED(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_PERIPH_CLK_SEL_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field mmdc_ch0_podf_loaded[23] (W1C)
 *
 * CCM interrupt request 1 generated due to update of mmdc_ch0_axi_podf.
 *
 * Values:
 * - 0 - interrupt is not generated due to update of mmdc_ch0_axi_podf.
 * - 1 - interrupt generated due to update of mmdc_ch0_axi_podf*
 */
/*@{*/
#define BP_CCM_CISR_mmdc_ch0_podf_loaded (23U) /*!< Bit position for CCM_CISR_mmdc_ch0_podf_loaded. */
#define BM_CCM_CISR_mmdc_ch0_podf_loaded (0x00800000U) /*!< Bit mask for CCM_CISR_mmdc_ch0_podf_loaded. */
#define BS_CCM_CISR_mmdc_ch0_podf_loaded (1U) /*!< Bit field size in bits for CCM_CISR_mmdc_ch0_podf_loaded. */

/*! @brief Read current value of the CCM_CISR_mmdc_ch0_podf_loaded field. */
#define BR_CCM_CISR_mmdc_ch0_podf_loaded(x) (HW_CCM_CISR(x).B.mmdc_ch0_podf_loaded)

/*! @brief Format value for bitfield CCM_CISR_mmdc_ch0_podf_loaded. */
#define BF_CCM_CISR_mmdc_ch0_podf_loaded(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_mmdc_ch0_podf_loaded) & BM_CCM_CISR_mmdc_ch0_podf_loaded)

/*! @brief Set the mmdc_ch0_podf_loaded field to a new value. */
#define BW_CCM_CISR_mmdc_ch0_podf_loaded(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_mmdc_ch0_podf_loaded | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_ARM_PODF_LOADED)) | BF_CCM_CISR_mmdc_ch0_podf_loaded(v)))
/*@}*/

/*!
 * @name Register CCM_CISR, field ARM_PODF_LOADED[26] (W1C)
 *
 * CCM interrupt request 1 generated due to frequency change of arm_podf. The
 * interrupt will commence only if arm_podf is loaded during a arm dvfs operation.
 *
 * Values:
 * - 0 - interrupt is not generated due to frequency change of arm_podf
 * - 1 - interrupt generated due to frequency change of arm_podf
 */
/*@{*/
#define BP_CCM_CISR_ARM_PODF_LOADED (26U)  /*!< Bit position for CCM_CISR_ARM_PODF_LOADED. */
#define BM_CCM_CISR_ARM_PODF_LOADED (0x04000000U) /*!< Bit mask for CCM_CISR_ARM_PODF_LOADED. */
#define BS_CCM_CISR_ARM_PODF_LOADED (1U)   /*!< Bit field size in bits for CCM_CISR_ARM_PODF_LOADED. */

/*! @brief Read current value of the CCM_CISR_ARM_PODF_LOADED field. */
#define BR_CCM_CISR_ARM_PODF_LOADED(x) (HW_CCM_CISR(x).B.ARM_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CISR_ARM_PODF_LOADED. */
#define BF_CCM_CISR_ARM_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CISR_ARM_PODF_LOADED) & BM_CCM_CISR_ARM_PODF_LOADED)

/*! @brief Set the ARM_PODF_LOADED field to a new value. */
#define BW_CCM_CISR_ARM_PODF_LOADED(x, v) (HW_CCM_CISR_WR(x, (HW_CCM_CISR_RD(x) & ~(BM_CCM_CISR_ARM_PODF_LOADED | BM_CCM_CISR_LRF_PLL | BM_CCM_CISR_COSC_READY | BM_CCM_CISR_AXI_PODF_LOADED | BM_CCM_CISR_PERIPH2_CLK_SEL_LOADED | BM_CCM_CISR_AHB_PODF_LOADED | BM_CCM_CISR_mmdc_ch1_podf_loaded | BM_CCM_CISR_PERIPH_CLK_SEL_LOADED | BM_CCM_CISR_mmdc_ch0_podf_loaded)) | BF_CCM_CISR_ARM_PODF_LOADED(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CIMR - CCM Interrupt Mask Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CIMR - CCM Interrupt Mask Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Interrupt Mask Register (CIMR). The table
 * below provides its field descriptions.
 */
typedef union _hw_ccm_cimr
{
    uint32_t U;
    struct _hw_ccm_cimr_bitfields
    {
        uint32_t MASK_LRF_PLL : 1;     /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t MASK_COSC_READY : 1;  /*!< [6]  */
        uint32_t RESERVED1 : 10;       /*!< [16:7]  */
        uint32_t MASK_AXI_PODF_LOADED : 1; /*!< [17]  */
        uint32_t mask_mmdc_ch0_axi_podf_loaded : 1; /*!< [18]  */
        uint32_t MASK_PERIPH2_CLK_SEL_LOADED : 1; /*!< [19]  */
        uint32_t MASK_AHB_PODF_LOADED : 1; /*!< [20]  */
        uint32_t mask_mmdc_ch1_podf_loaded : 1; /*!< [21]  */
        uint32_t MASK_PERIPH_CLK_SEL_LOADED : 1; /*!< [22]  */
        uint32_t mask_mmdc_ch0_podf_loaded : 1; /*!< [23]  */
        uint32_t RESERVED2 : 2;        /*!< [25:24]  */
        uint32_t ARM_PODF_LOADED : 1;  /*!< [26]  */
        uint32_t RESERVED3 : 5;        /*!< [31:27]  */
    } B;
} hw_ccm_cimr_t;

/*!
 * @name Constants and macros for entire CCM_CIMR register
 */
/*@{*/
#define HW_CCM_CIMR_ADDR(x)      ((uintptr_t)(x) + 0x5CU)

#define HW_CCM_CIMR(x)           (*(__IO hw_ccm_cimr_t *) HW_CCM_CIMR_ADDR(x))
#define HW_CCM_CIMR_RD(x)        (HW_CCM_CIMR(x).U)
#define HW_CCM_CIMR_WR(x, v)     (HW_CCM_CIMR(x).U = (v))
#define HW_CCM_CIMR_SET(x, v)    (HW_CCM_CIMR_WR(x, HW_CCM_CIMR_RD(x) |  (v)))
#define HW_CCM_CIMR_CLR(x, v)    (HW_CCM_CIMR_WR(x, HW_CCM_CIMR_RD(x) & ~(v)))
#define HW_CCM_CIMR_TOG(x, v)    (HW_CCM_CIMR_WR(x, HW_CCM_CIMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CIMR bitfields
 */

/*!
 * @name Register CCM_CIMR, field MASK_LRF_PLL[0] (RW)
 *
 * mask interrupt generation due to lrf of PLLs
 *
 * Values:
 * - 0 - don't mask interrupt due to lrf of PLLs - interrupt will be created
 * - 1 - mask interrupt due to lrf of PLLs
 */
/*@{*/
#define BP_CCM_CIMR_MASK_LRF_PLL (0U)      /*!< Bit position for CCM_CIMR_MASK_LRF_PLL. */
#define BM_CCM_CIMR_MASK_LRF_PLL (0x00000001U) /*!< Bit mask for CCM_CIMR_MASK_LRF_PLL. */
#define BS_CCM_CIMR_MASK_LRF_PLL (1U)      /*!< Bit field size in bits for CCM_CIMR_MASK_LRF_PLL. */

/*! @brief Read current value of the CCM_CIMR_MASK_LRF_PLL field. */
#define BR_CCM_CIMR_MASK_LRF_PLL(x) (HW_CCM_CIMR(x).B.MASK_LRF_PLL)

/*! @brief Format value for bitfield CCM_CIMR_MASK_LRF_PLL. */
#define BF_CCM_CIMR_MASK_LRF_PLL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_LRF_PLL) & BM_CCM_CIMR_MASK_LRF_PLL)

/*! @brief Set the MASK_LRF_PLL field to a new value. */
#define BW_CCM_CIMR_MASK_LRF_PLL(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_LRF_PLL) | BF_CCM_CIMR_MASK_LRF_PLL(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field MASK_COSC_READY[6] (RW)
 *
 * mask interrupt generation due to on board oscillator ready
 *
 * Values:
 * - 0 - don't mask interrupt due to on board oscillator ready - interrupt will
 *     be created
 * - 1 - mask interrupt due to on board oscillator ready
 */
/*@{*/
#define BP_CCM_CIMR_MASK_COSC_READY (6U)   /*!< Bit position for CCM_CIMR_MASK_COSC_READY. */
#define BM_CCM_CIMR_MASK_COSC_READY (0x00000040U) /*!< Bit mask for CCM_CIMR_MASK_COSC_READY. */
#define BS_CCM_CIMR_MASK_COSC_READY (1U)   /*!< Bit field size in bits for CCM_CIMR_MASK_COSC_READY. */

/*! @brief Read current value of the CCM_CIMR_MASK_COSC_READY field. */
#define BR_CCM_CIMR_MASK_COSC_READY(x) (HW_CCM_CIMR(x).B.MASK_COSC_READY)

/*! @brief Format value for bitfield CCM_CIMR_MASK_COSC_READY. */
#define BF_CCM_CIMR_MASK_COSC_READY(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_COSC_READY) & BM_CCM_CIMR_MASK_COSC_READY)

/*! @brief Set the MASK_COSC_READY field to a new value. */
#define BW_CCM_CIMR_MASK_COSC_READY(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_COSC_READY) | BF_CCM_CIMR_MASK_COSC_READY(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field MASK_AXI_PODF_LOADED[17] (RW)
 *
 * mask interrupt generation due to frequency change of axi_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to frequency change of axi_podf - interrupt
 *     will be created
 * - 1 - mask interrupt due to frequency change of axi_podf
 */
/*@{*/
#define BP_CCM_CIMR_MASK_AXI_PODF_LOADED (17U) /*!< Bit position for CCM_CIMR_MASK_AXI_PODF_LOADED. */
#define BM_CCM_CIMR_MASK_AXI_PODF_LOADED (0x00020000U) /*!< Bit mask for CCM_CIMR_MASK_AXI_PODF_LOADED. */
#define BS_CCM_CIMR_MASK_AXI_PODF_LOADED (1U) /*!< Bit field size in bits for CCM_CIMR_MASK_AXI_PODF_LOADED. */

/*! @brief Read current value of the CCM_CIMR_MASK_AXI_PODF_LOADED field. */
#define BR_CCM_CIMR_MASK_AXI_PODF_LOADED(x) (HW_CCM_CIMR(x).B.MASK_AXI_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CIMR_MASK_AXI_PODF_LOADED. */
#define BF_CCM_CIMR_MASK_AXI_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_AXI_PODF_LOADED) & BM_CCM_CIMR_MASK_AXI_PODF_LOADED)

/*! @brief Set the MASK_AXI_PODF_LOADED field to a new value. */
#define BW_CCM_CIMR_MASK_AXI_PODF_LOADED(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_AXI_PODF_LOADED) | BF_CCM_CIMR_MASK_AXI_PODF_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field mask_mmdc_ch0_axi_podf_loaded[18] (RO)
 *
 * mask interrupt generation due to frequency change of mmdc_ch0_axi_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to frequency change of mmdc_ch0_axi_podf -
 *     interrupt will be created
 * - 1 - mask interrupt due to frequency change of mmdc_ch0_axi_podf
 */
/*@{*/
#define BP_CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded (18U) /*!< Bit position for CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded. */
#define BM_CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded (0x00040000U) /*!< Bit mask for CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded. */
#define BS_CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded (1U) /*!< Bit field size in bits for CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded. */

/*! @brief Read current value of the CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded field. */
#define BR_CCM_CIMR_mask_mmdc_ch0_axi_podf_loaded(x) (HW_CCM_CIMR(x).B.mask_mmdc_ch0_axi_podf_loaded)
/*@}*/

/*!
 * @name Register CCM_CIMR, field MASK_PERIPH2_CLK_SEL_LOADED[19] (RW)
 *
 * mask interrupt generation due to update of periph2_clk_sel.
 *
 * Values:
 * - 0 - don't mask interrupt due to update of periph2_clk_sel - interrupt will
 *     be created
 * - 1 - mask interrupt due to update of periph2_clk_sel
 */
/*@{*/
#define BP_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED (19U) /*!< Bit position for CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED. */
#define BM_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED (0x00080000U) /*!< Bit mask for CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED. */
#define BS_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED (1U) /*!< Bit field size in bits for CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED. */

/*! @brief Read current value of the CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED field. */
#define BR_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED(x) (HW_CCM_CIMR(x).B.MASK_PERIPH2_CLK_SEL_LOADED)

/*! @brief Format value for bitfield CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED. */
#define BF_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED) & BM_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED)

/*! @brief Set the MASK_PERIPH2_CLK_SEL_LOADED field to a new value. */
#define BW_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED) | BF_CCM_CIMR_MASK_PERIPH2_CLK_SEL_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field MASK_AHB_PODF_LOADED[20] (RW)
 *
 * mask interrupt generation due to frequency change of ahb_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to frequency change of ahb_podf - interrupt
 *     will be created
 * - 1 - mask interrupt due to frequency change of ahb_podf
 */
/*@{*/
#define BP_CCM_CIMR_MASK_AHB_PODF_LOADED (20U) /*!< Bit position for CCM_CIMR_MASK_AHB_PODF_LOADED. */
#define BM_CCM_CIMR_MASK_AHB_PODF_LOADED (0x00100000U) /*!< Bit mask for CCM_CIMR_MASK_AHB_PODF_LOADED. */
#define BS_CCM_CIMR_MASK_AHB_PODF_LOADED (1U) /*!< Bit field size in bits for CCM_CIMR_MASK_AHB_PODF_LOADED. */

/*! @brief Read current value of the CCM_CIMR_MASK_AHB_PODF_LOADED field. */
#define BR_CCM_CIMR_MASK_AHB_PODF_LOADED(x) (HW_CCM_CIMR(x).B.MASK_AHB_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CIMR_MASK_AHB_PODF_LOADED. */
#define BF_CCM_CIMR_MASK_AHB_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_AHB_PODF_LOADED) & BM_CCM_CIMR_MASK_AHB_PODF_LOADED)

/*! @brief Set the MASK_AHB_PODF_LOADED field to a new value. */
#define BW_CCM_CIMR_MASK_AHB_PODF_LOADED(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_AHB_PODF_LOADED) | BF_CCM_CIMR_MASK_AHB_PODF_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field mask_mmdc_ch1_podf_loaded[21] (RW)
 *
 * mask interrupt generation due to update of mask_mmdc_ch1_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to update of mask_mmdc_ch1_podf - interrupt
 *     will be created
 * - 1 - mask interrupt due to update of mask_mmdc_ch1_podf
 */
/*@{*/
#define BP_CCM_CIMR_mask_mmdc_ch1_podf_loaded (21U) /*!< Bit position for CCM_CIMR_mask_mmdc_ch1_podf_loaded. */
#define BM_CCM_CIMR_mask_mmdc_ch1_podf_loaded (0x00200000U) /*!< Bit mask for CCM_CIMR_mask_mmdc_ch1_podf_loaded. */
#define BS_CCM_CIMR_mask_mmdc_ch1_podf_loaded (1U) /*!< Bit field size in bits for CCM_CIMR_mask_mmdc_ch1_podf_loaded. */

/*! @brief Read current value of the CCM_CIMR_mask_mmdc_ch1_podf_loaded field. */
#define BR_CCM_CIMR_mask_mmdc_ch1_podf_loaded(x) (HW_CCM_CIMR(x).B.mask_mmdc_ch1_podf_loaded)

/*! @brief Format value for bitfield CCM_CIMR_mask_mmdc_ch1_podf_loaded. */
#define BF_CCM_CIMR_mask_mmdc_ch1_podf_loaded(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_mask_mmdc_ch1_podf_loaded) & BM_CCM_CIMR_mask_mmdc_ch1_podf_loaded)

/*! @brief Set the mask_mmdc_ch1_podf_loaded field to a new value. */
#define BW_CCM_CIMR_mask_mmdc_ch1_podf_loaded(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_mask_mmdc_ch1_podf_loaded) | BF_CCM_CIMR_mask_mmdc_ch1_podf_loaded(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field MASK_PERIPH_CLK_SEL_LOADED[22] (RW)
 *
 * mask interrupt generation due to update of periph_clk_sel.
 *
 * Values:
 * - 0 - don't mask interrupt due to update of periph_clk_sel - interrupt will
 *     be created
 * - 1 - mask interrupt due to update of periph_clk_sel
 */
/*@{*/
#define BP_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED (22U) /*!< Bit position for CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED. */
#define BM_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED (0x00400000U) /*!< Bit mask for CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED. */
#define BS_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED (1U) /*!< Bit field size in bits for CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED. */

/*! @brief Read current value of the CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED field. */
#define BR_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED(x) (HW_CCM_CIMR(x).B.MASK_PERIPH_CLK_SEL_LOADED)

/*! @brief Format value for bitfield CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED. */
#define BF_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED) & BM_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED)

/*! @brief Set the MASK_PERIPH_CLK_SEL_LOADED field to a new value. */
#define BW_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED) | BF_CCM_CIMR_MASK_PERIPH_CLK_SEL_LOADED(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field mask_mmdc_ch0_podf_loaded[23] (RW)
 *
 * mask interrupt generation due to update of mask_mmdc_ch0_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to update of mask_mmdc_ch0_podf - interrupt
 *     will be created
 * - 1 - mask interrupt due to update of mask_mmdc_ch0_podf
 */
/*@{*/
#define BP_CCM_CIMR_mask_mmdc_ch0_podf_loaded (23U) /*!< Bit position for CCM_CIMR_mask_mmdc_ch0_podf_loaded. */
#define BM_CCM_CIMR_mask_mmdc_ch0_podf_loaded (0x00800000U) /*!< Bit mask for CCM_CIMR_mask_mmdc_ch0_podf_loaded. */
#define BS_CCM_CIMR_mask_mmdc_ch0_podf_loaded (1U) /*!< Bit field size in bits for CCM_CIMR_mask_mmdc_ch0_podf_loaded. */

/*! @brief Read current value of the CCM_CIMR_mask_mmdc_ch0_podf_loaded field. */
#define BR_CCM_CIMR_mask_mmdc_ch0_podf_loaded(x) (HW_CCM_CIMR(x).B.mask_mmdc_ch0_podf_loaded)

/*! @brief Format value for bitfield CCM_CIMR_mask_mmdc_ch0_podf_loaded. */
#define BF_CCM_CIMR_mask_mmdc_ch0_podf_loaded(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_mask_mmdc_ch0_podf_loaded) & BM_CCM_CIMR_mask_mmdc_ch0_podf_loaded)

/*! @brief Set the mask_mmdc_ch0_podf_loaded field to a new value. */
#define BW_CCM_CIMR_mask_mmdc_ch0_podf_loaded(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_mask_mmdc_ch0_podf_loaded) | BF_CCM_CIMR_mask_mmdc_ch0_podf_loaded(v)))
/*@}*/

/*!
 * @name Register CCM_CIMR, field ARM_PODF_LOADED[26] (RW)
 *
 * mask interrupt generation due to frequency change of arm_podf
 *
 * Values:
 * - 0 - don't mask interrupt due to frequency change of arm_podf - interrupt
 *     will be created
 * - 1 - mask interrupt due to frequency change of arm_podf
 */
/*@{*/
#define BP_CCM_CIMR_ARM_PODF_LOADED (26U)  /*!< Bit position for CCM_CIMR_ARM_PODF_LOADED. */
#define BM_CCM_CIMR_ARM_PODF_LOADED (0x04000000U) /*!< Bit mask for CCM_CIMR_ARM_PODF_LOADED. */
#define BS_CCM_CIMR_ARM_PODF_LOADED (1U)   /*!< Bit field size in bits for CCM_CIMR_ARM_PODF_LOADED. */

/*! @brief Read current value of the CCM_CIMR_ARM_PODF_LOADED field. */
#define BR_CCM_CIMR_ARM_PODF_LOADED(x) (HW_CCM_CIMR(x).B.ARM_PODF_LOADED)

/*! @brief Format value for bitfield CCM_CIMR_ARM_PODF_LOADED. */
#define BF_CCM_CIMR_ARM_PODF_LOADED(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CIMR_ARM_PODF_LOADED) & BM_CCM_CIMR_ARM_PODF_LOADED)

/*! @brief Set the ARM_PODF_LOADED field to a new value. */
#define BW_CCM_CIMR_ARM_PODF_LOADED(x, v) (HW_CCM_CIMR_WR(x, (HW_CCM_CIMR_RD(x) & ~BM_CCM_CIMR_ARM_PODF_LOADED) | BF_CCM_CIMR_ARM_PODF_LOADED(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCOSR - CCM Clock Output Source Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCOSR - CCM Clock Output Source Register (RW)
 *
 * Reset value: 0x000A0001U
 *
 * The figure below represents the CCM Clock Output Source Register (CCOSR). The
 * CCOSR register contains bits to control the clocks that will be generated on
 * the output ipp_do_clko1 (CCM_CLKO1) and ipp_do_clko2 (CCM_CLKO2).The table
 * below provides its field descriptions.
 */
typedef union _hw_ccm_ccosr
{
    uint32_t U;
    struct _hw_ccm_ccosr_bitfields
    {
        uint32_t CLKO1_SEL : 4;        /*!< [3:0]  */
        uint32_t CLKO1_DIV : 3;        /*!< [6:4]  */
        uint32_t CLKO1_EN : 1;         /*!< [7]  */
        uint32_t CLK_OUT_SEL : 1;      /*!< [8]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CLKO2_SEL : 5;        /*!< [20:16]  */
        uint32_t CLKO2_DIV : 3;        /*!< [23:21]  */
        uint32_t CLKO2_EN : 1;         /*!< [24]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ccm_ccosr_t;

/*!
 * @name Constants and macros for entire CCM_CCOSR register
 */
/*@{*/
#define HW_CCM_CCOSR_ADDR(x)     ((uintptr_t)(x) + 0x60U)

#define HW_CCM_CCOSR(x)          (*(__IO hw_ccm_ccosr_t *) HW_CCM_CCOSR_ADDR(x))
#define HW_CCM_CCOSR_RD(x)       (HW_CCM_CCOSR(x).U)
#define HW_CCM_CCOSR_WR(x, v)    (HW_CCM_CCOSR(x).U = (v))
#define HW_CCM_CCOSR_SET(x, v)   (HW_CCM_CCOSR_WR(x, HW_CCM_CCOSR_RD(x) |  (v)))
#define HW_CCM_CCOSR_CLR(x, v)   (HW_CCM_CCOSR_WR(x, HW_CCM_CCOSR_RD(x) & ~(v)))
#define HW_CCM_CCOSR_TOG(x, v)   (HW_CCM_CCOSR_WR(x, HW_CCM_CCOSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCOSR bitfields
 */

/*!
 * @name Register CCM_CCOSR, field CLKO1_SEL[3:0] (RW)
 *
 * Selection of the clock to be generated on CCM_CLKO1
 *
 * Values:
 * - 0000 - pll3_sw_clk (this inputs has additional constant division /2)
 * - 0001 - pll2_main_clk (this inputs has additional constant division /2)
 * - 0010 - pll1_main_clk (this inputs has additional constant division /2)
 * - 0011 - pll5_main_clk (this inputs has additional constant division /2)
 * - 0100 - video_27M_clk_root
 * - 0101 - axi_clk_root
 * - 0110 - enfc_clk_root
 * - 0111 - ipu1_di0_clk_root
 * - 1000 - ipu1_di1_clk_root
 * - 1001 - ipu2_di0_clk_root
 * - 1010 - ipu2_di1_clk_root
 * - 1011 - ahb_clk_root
 * - 1100 - ipg_clk_root
 * - 1101 - perclk_root
 * - 1110 - ckil_sync_clk_root
 * - 1111 - pll4_main_clk
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO1_SEL (0U)        /*!< Bit position for CCM_CCOSR_CLKO1_SEL. */
#define BM_CCM_CCOSR_CLKO1_SEL (0x0000000FU) /*!< Bit mask for CCM_CCOSR_CLKO1_SEL. */
#define BS_CCM_CCOSR_CLKO1_SEL (4U)        /*!< Bit field size in bits for CCM_CCOSR_CLKO1_SEL. */

/*! @brief Read current value of the CCM_CCOSR_CLKO1_SEL field. */
#define BR_CCM_CCOSR_CLKO1_SEL(x) (HW_CCM_CCOSR(x).B.CLKO1_SEL)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO1_SEL. */
#define BF_CCM_CCOSR_CLKO1_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO1_SEL) & BM_CCM_CCOSR_CLKO1_SEL)

/*! @brief Set the CLKO1_SEL field to a new value. */
#define BW_CCM_CCOSR_CLKO1_SEL(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO1_SEL) | BF_CCM_CCOSR_CLKO1_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLKO1_DIV[6:4] (RW)
 *
 * Setting the divider of CCM_CLKO1
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO1_DIV (4U)        /*!< Bit position for CCM_CCOSR_CLKO1_DIV. */
#define BM_CCM_CCOSR_CLKO1_DIV (0x00000070U) /*!< Bit mask for CCM_CCOSR_CLKO1_DIV. */
#define BS_CCM_CCOSR_CLKO1_DIV (3U)        /*!< Bit field size in bits for CCM_CCOSR_CLKO1_DIV. */

/*! @brief Read current value of the CCM_CCOSR_CLKO1_DIV field. */
#define BR_CCM_CCOSR_CLKO1_DIV(x) (HW_CCM_CCOSR(x).B.CLKO1_DIV)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO1_DIV. */
#define BF_CCM_CCOSR_CLKO1_DIV(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO1_DIV) & BM_CCM_CCOSR_CLKO1_DIV)

/*! @brief Set the CLKO1_DIV field to a new value. */
#define BW_CCM_CCOSR_CLKO1_DIV(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO1_DIV) | BF_CCM_CCOSR_CLKO1_DIV(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLKO1_EN[7] (RW)
 *
 * Enable of CCM_CLKO1 clock
 *
 * Values:
 * - 0 - CCM_CLKO1 disabled.
 * - 1 - CCM_CLKO1 enabled.
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO1_EN (7U)         /*!< Bit position for CCM_CCOSR_CLKO1_EN. */
#define BM_CCM_CCOSR_CLKO1_EN (0x00000080U) /*!< Bit mask for CCM_CCOSR_CLKO1_EN. */
#define BS_CCM_CCOSR_CLKO1_EN (1U)         /*!< Bit field size in bits for CCM_CCOSR_CLKO1_EN. */

/*! @brief Read current value of the CCM_CCOSR_CLKO1_EN field. */
#define BR_CCM_CCOSR_CLKO1_EN(x) (HW_CCM_CCOSR(x).B.CLKO1_EN)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO1_EN. */
#define BF_CCM_CCOSR_CLKO1_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO1_EN) & BM_CCM_CCOSR_CLKO1_EN)

/*! @brief Set the CLKO1_EN field to a new value. */
#define BW_CCM_CCOSR_CLKO1_EN(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO1_EN) | BF_CCM_CCOSR_CLKO1_EN(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLK_OUT_SEL[8] (RW)
 *
 * CCM_CLKO1 output to reflect CCM_CLKO1 or CCM_CLKO2 clocks
 *
 * Values:
 * - 0 - CCM_CLKO1 output drives CCM_CLKO1 clock
 * - 1 - CCM_CLKO1 output drives CCM_CLKO2 clock
 */
/*@{*/
#define BP_CCM_CCOSR_CLK_OUT_SEL (8U)      /*!< Bit position for CCM_CCOSR_CLK_OUT_SEL. */
#define BM_CCM_CCOSR_CLK_OUT_SEL (0x00000100U) /*!< Bit mask for CCM_CCOSR_CLK_OUT_SEL. */
#define BS_CCM_CCOSR_CLK_OUT_SEL (1U)      /*!< Bit field size in bits for CCM_CCOSR_CLK_OUT_SEL. */

/*! @brief Read current value of the CCM_CCOSR_CLK_OUT_SEL field. */
#define BR_CCM_CCOSR_CLK_OUT_SEL(x) (HW_CCM_CCOSR(x).B.CLK_OUT_SEL)

/*! @brief Format value for bitfield CCM_CCOSR_CLK_OUT_SEL. */
#define BF_CCM_CCOSR_CLK_OUT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLK_OUT_SEL) & BM_CCM_CCOSR_CLK_OUT_SEL)

/*! @brief Set the CLK_OUT_SEL field to a new value. */
#define BW_CCM_CCOSR_CLK_OUT_SEL(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLK_OUT_SEL) | BF_CCM_CCOSR_CLK_OUT_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLKO2_SEL[20:16] (RW)
 *
 * Selection of the clock to be generated on CCM_CLKO2
 *
 * Values:
 * - 00000 - mmdc_ch0_clk_root
 * - 00001 - mmdc_ch1_clk_root
 * - 00010 - usdhc4_clk_root
 * - 00011 - usdhc1_clk_root
 * - 00101 - wrck_clk_root
 * - 00110 - ecspi_clk_root
 * - 00111 - pre_clk_root
 * - 01000 - usdhc3_clk_root
 * - 01001 - 125M_clk_root
 * - 01010 - arm_clk_root
 * - 01011 - ipu1_hsp_clk_root
 * - 01100 - ipu2_hsp_clk_root
 * - 01101 - vdo_axi_clk_root
 * - 01110 - osc_clk
 * - 01111 - gpu2d_core_clk_root
 * - 10000 - gpu3d_core_clk_root
 * - 10001 - usdhc2_clk_root
 * - 10010 - ssi1_clk_root
 * - 10011 - ssi2_clk_root
 * - 10100 - ssi3_clk_root
 * - 10101 - gpu3d_shader_clk_root
 * - 10110 - vpu_axi_clk_root
 * - 10111 - can_clk_root
 * - 11000 - ldb_di0_serial_clk_root
 * - 11001 - ldb_di1_serial_clk_root
 * - 11010 - esai_clk_root
 * - 11011 - aclk_eim_slow_clk_root
 * - 11100 - uart_clk_root
 * - 11101 - spdif0_clk_root
 * - 11110 - spdif1_clk_root
 * - 11111 - hsi_tx_clk_root
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO2_SEL (16U)       /*!< Bit position for CCM_CCOSR_CLKO2_SEL. */
#define BM_CCM_CCOSR_CLKO2_SEL (0x001F0000U) /*!< Bit mask for CCM_CCOSR_CLKO2_SEL. */
#define BS_CCM_CCOSR_CLKO2_SEL (5U)        /*!< Bit field size in bits for CCM_CCOSR_CLKO2_SEL. */

/*! @brief Read current value of the CCM_CCOSR_CLKO2_SEL field. */
#define BR_CCM_CCOSR_CLKO2_SEL(x) (HW_CCM_CCOSR(x).B.CLKO2_SEL)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO2_SEL. */
#define BF_CCM_CCOSR_CLKO2_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO2_SEL) & BM_CCM_CCOSR_CLKO2_SEL)

/*! @brief Set the CLKO2_SEL field to a new value. */
#define BW_CCM_CCOSR_CLKO2_SEL(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO2_SEL) | BF_CCM_CCOSR_CLKO2_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLKO2_DIV[23:21] (RW)
 *
 * Setting the divider of CCM_CLKO2
 *
 * Values:
 * - 000 - divide by 1
 * - 001 - divide by 2
 * - 010 - divide by 3
 * - 011 - divide by 4
 * - 100 - divide by 5
 * - 101 - divide by 6
 * - 110 - divide by 7
 * - 111 - divide by 8
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO2_DIV (21U)       /*!< Bit position for CCM_CCOSR_CLKO2_DIV. */
#define BM_CCM_CCOSR_CLKO2_DIV (0x00E00000U) /*!< Bit mask for CCM_CCOSR_CLKO2_DIV. */
#define BS_CCM_CCOSR_CLKO2_DIV (3U)        /*!< Bit field size in bits for CCM_CCOSR_CLKO2_DIV. */

/*! @brief Read current value of the CCM_CCOSR_CLKO2_DIV field. */
#define BR_CCM_CCOSR_CLKO2_DIV(x) (HW_CCM_CCOSR(x).B.CLKO2_DIV)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO2_DIV. */
#define BF_CCM_CCOSR_CLKO2_DIV(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO2_DIV) & BM_CCM_CCOSR_CLKO2_DIV)

/*! @brief Set the CLKO2_DIV field to a new value. */
#define BW_CCM_CCOSR_CLKO2_DIV(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO2_DIV) | BF_CCM_CCOSR_CLKO2_DIV(v)))
/*@}*/

/*!
 * @name Register CCM_CCOSR, field CLKO2_EN[24] (RW)
 *
 * Enable of CCM_CLKO2 clock
 *
 * Values:
 * - 0 - CCM_CLKO2 disabled.
 * - 1 - CCM_CLKO2 enabled.
 */
/*@{*/
#define BP_CCM_CCOSR_CLKO2_EN (24U)        /*!< Bit position for CCM_CCOSR_CLKO2_EN. */
#define BM_CCM_CCOSR_CLKO2_EN (0x01000000U) /*!< Bit mask for CCM_CCOSR_CLKO2_EN. */
#define BS_CCM_CCOSR_CLKO2_EN (1U)         /*!< Bit field size in bits for CCM_CCOSR_CLKO2_EN. */

/*! @brief Read current value of the CCM_CCOSR_CLKO2_EN field. */
#define BR_CCM_CCOSR_CLKO2_EN(x) (HW_CCM_CCOSR(x).B.CLKO2_EN)

/*! @brief Format value for bitfield CCM_CCOSR_CLKO2_EN. */
#define BF_CCM_CCOSR_CLKO2_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCOSR_CLKO2_EN) & BM_CCM_CCOSR_CLKO2_EN)

/*! @brief Set the CLKO2_EN field to a new value. */
#define BW_CCM_CCOSR_CLKO2_EN(x, v) (HW_CCM_CCOSR_WR(x, (HW_CCM_CCOSR_RD(x) & ~BM_CCM_CCOSR_CLKO2_EN) | BF_CCM_CCOSR_CLKO2_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CGPR - CCM General Purpose Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CGPR - CCM General Purpose Register (RW)
 *
 * Reset value: 0x0000FE62U
 *
 * Fast PLL enable. Can be used to engage PLL faster after STOP mode, if 24MHz
 * OSC was active
 */
typedef union _hw_ccm_cgpr
{
    uint32_t U;
    struct _hw_ccm_cgpr_bitfields
    {
        uint32_t PMIC_DELAY_SCALER : 1; /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t MMDC_EXT_CLK_DIS : 1; /*!< [2]  */
        uint32_t RESERVED1 : 1;        /*!< [3]  */
        uint32_t EFUSE_PROG_SUPPLY_GATE : 1; /*!< [4]  */
        uint32_t RESERVED2 : 11;       /*!< [15:5]  */
        uint32_t FPL : 1;              /*!< [16] Fast PLL enable. */
        uint32_t INT_MEM_CLK_LPM : 1;  /*!< [17]  */
        uint32_t RESERVED3 : 14;       /*!< [31:18]  */
    } B;
} hw_ccm_cgpr_t;

/*!
 * @name Constants and macros for entire CCM_CGPR register
 */
/*@{*/
#define HW_CCM_CGPR_ADDR(x)      ((uintptr_t)(x) + 0x64U)

#define HW_CCM_CGPR(x)           (*(__IO hw_ccm_cgpr_t *) HW_CCM_CGPR_ADDR(x))
#define HW_CCM_CGPR_RD(x)        (HW_CCM_CGPR(x).U)
#define HW_CCM_CGPR_WR(x, v)     (HW_CCM_CGPR(x).U = (v))
#define HW_CCM_CGPR_SET(x, v)    (HW_CCM_CGPR_WR(x, HW_CCM_CGPR_RD(x) |  (v)))
#define HW_CCM_CGPR_CLR(x, v)    (HW_CCM_CGPR_WR(x, HW_CCM_CGPR_RD(x) & ~(v)))
#define HW_CCM_CGPR_TOG(x, v)    (HW_CCM_CGPR_WR(x, HW_CCM_CGPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CGPR bitfields
 */

/*!
 * @name Register CCM_CGPR, field PMIC_DELAY_SCALER[0] (RW)
 *
 * Defines clock dividion of clock for stby_count (pmic delay counter)
 *
 * Values:
 * - 0 - clock is not divided
 * - 1 - clock is divided /8
 */
/*@{*/
#define BP_CCM_CGPR_PMIC_DELAY_SCALER (0U) /*!< Bit position for CCM_CGPR_PMIC_DELAY_SCALER. */
#define BM_CCM_CGPR_PMIC_DELAY_SCALER (0x00000001U) /*!< Bit mask for CCM_CGPR_PMIC_DELAY_SCALER. */
#define BS_CCM_CGPR_PMIC_DELAY_SCALER (1U) /*!< Bit field size in bits for CCM_CGPR_PMIC_DELAY_SCALER. */

/*! @brief Read current value of the CCM_CGPR_PMIC_DELAY_SCALER field. */
#define BR_CCM_CGPR_PMIC_DELAY_SCALER(x) (HW_CCM_CGPR(x).B.PMIC_DELAY_SCALER)

/*! @brief Format value for bitfield CCM_CGPR_PMIC_DELAY_SCALER. */
#define BF_CCM_CGPR_PMIC_DELAY_SCALER(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CGPR_PMIC_DELAY_SCALER) & BM_CCM_CGPR_PMIC_DELAY_SCALER)

/*! @brief Set the PMIC_DELAY_SCALER field to a new value. */
#define BW_CCM_CGPR_PMIC_DELAY_SCALER(x, v) (HW_CCM_CGPR_WR(x, (HW_CCM_CGPR_RD(x) & ~BM_CCM_CGPR_PMIC_DELAY_SCALER) | BF_CCM_CGPR_PMIC_DELAY_SCALER(v)))
/*@}*/

/*!
 * @name Register CCM_CGPR, field MMDC_EXT_CLK_DIS[2] (RW)
 *
 * Disable external clock driver of MMDC during STOP mode
 *
 * Values:
 * - 1 - disable during stop mode
 * - 0 - don't disable during stop mode.
 */
/*@{*/
#define BP_CCM_CGPR_MMDC_EXT_CLK_DIS (2U)  /*!< Bit position for CCM_CGPR_MMDC_EXT_CLK_DIS. */
#define BM_CCM_CGPR_MMDC_EXT_CLK_DIS (0x00000004U) /*!< Bit mask for CCM_CGPR_MMDC_EXT_CLK_DIS. */
#define BS_CCM_CGPR_MMDC_EXT_CLK_DIS (1U)  /*!< Bit field size in bits for CCM_CGPR_MMDC_EXT_CLK_DIS. */

/*! @brief Read current value of the CCM_CGPR_MMDC_EXT_CLK_DIS field. */
#define BR_CCM_CGPR_MMDC_EXT_CLK_DIS(x) (HW_CCM_CGPR(x).B.MMDC_EXT_CLK_DIS)

/*! @brief Format value for bitfield CCM_CGPR_MMDC_EXT_CLK_DIS. */
#define BF_CCM_CGPR_MMDC_EXT_CLK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CGPR_MMDC_EXT_CLK_DIS) & BM_CCM_CGPR_MMDC_EXT_CLK_DIS)

/*! @brief Set the MMDC_EXT_CLK_DIS field to a new value. */
#define BW_CCM_CGPR_MMDC_EXT_CLK_DIS(x, v) (HW_CCM_CGPR_WR(x, (HW_CCM_CGPR_RD(x) & ~BM_CCM_CGPR_MMDC_EXT_CLK_DIS) | BF_CCM_CGPR_MMDC_EXT_CLK_DIS(v)))
/*@}*/

/*!
 * @name Register CCM_CGPR, field EFUSE_PROG_SUPPLY_GATE[4] (RW)
 *
 * Defines the value of the output signal cgpr_dout[4]. Gate of program supply
 * for efuse programing
 *
 * Values:
 * - 0 - fuse programing supply voltage is gated off to the efuse module
 * - 1 - allow fuse programing.
 */
/*@{*/
#define BP_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE (4U) /*!< Bit position for CCM_CGPR_EFUSE_PROG_SUPPLY_GATE. */
#define BM_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE (0x00000010U) /*!< Bit mask for CCM_CGPR_EFUSE_PROG_SUPPLY_GATE. */
#define BS_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE (1U) /*!< Bit field size in bits for CCM_CGPR_EFUSE_PROG_SUPPLY_GATE. */

/*! @brief Read current value of the CCM_CGPR_EFUSE_PROG_SUPPLY_GATE field. */
#define BR_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE(x) (HW_CCM_CGPR(x).B.EFUSE_PROG_SUPPLY_GATE)

/*! @brief Format value for bitfield CCM_CGPR_EFUSE_PROG_SUPPLY_GATE. */
#define BF_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE) & BM_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE)

/*! @brief Set the EFUSE_PROG_SUPPLY_GATE field to a new value. */
#define BW_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE(x, v) (HW_CCM_CGPR_WR(x, (HW_CCM_CGPR_RD(x) & ~BM_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE) | BF_CCM_CGPR_EFUSE_PROG_SUPPLY_GATE(v)))
/*@}*/

/*!
 * @name Register CCM_CGPR, field FPL[16] (RW)
 *
 * Values:
 * - 0 - Engage PLL enable default way.
 * - 1 - Engage PLL enable 3 CKIL clocks earlier at exiting low power mode
 *     (STOP). Should be used only if 24MHz OSC was active in low power mode.
 */
/*@{*/
#define BP_CCM_CGPR_FPL      (16U)         /*!< Bit position for CCM_CGPR_FPL. */
#define BM_CCM_CGPR_FPL      (0x00010000U) /*!< Bit mask for CCM_CGPR_FPL. */
#define BS_CCM_CGPR_FPL      (1U)          /*!< Bit field size in bits for CCM_CGPR_FPL. */

/*! @brief Read current value of the CCM_CGPR_FPL field. */
#define BR_CCM_CGPR_FPL(x)   (HW_CCM_CGPR(x).B.FPL)

/*! @brief Format value for bitfield CCM_CGPR_FPL. */
#define BF_CCM_CGPR_FPL(v)   ((uint32_t)((uint32_t)(v) << BP_CCM_CGPR_FPL) & BM_CCM_CGPR_FPL)

/*! @brief Set the FPL field to a new value. */
#define BW_CCM_CGPR_FPL(x, v) (HW_CCM_CGPR_WR(x, (HW_CCM_CGPR_RD(x) & ~BM_CCM_CGPR_FPL) | BF_CCM_CGPR_FPL(v)))
/*@}*/

/*!
 * @name Register CCM_CGPR, field INT_MEM_CLK_LPM[17] (RW)
 *
 * Control for the Deep Sleep signal to the ARM Platform memories with
 * additional control logic based on the ARM WFI signal. Used to keep the ARM Platform
 * memory clocks enabled if an interrupt is pending when entering low power
 * mode.This bit should always bet set when the CCM_CLPCR_LPM bits are set to 01(WAIT
 * Mode) or 10 (STOP mode) without power gating. This bit does not have to be set
 * for STOP mode entry.
 *
 * Values:
 * - 0 - Disable the clock to the ARM platform memories when entering Low Power
 *     Mode
 * - 1 - Keep the clocks to the ARM platform memories enabled only if an
 *     interrupt is pending when entering Low Power Modes (WAIT and STOP without power
 *     gating)
 */
/*@{*/
#define BP_CCM_CGPR_INT_MEM_CLK_LPM (17U)  /*!< Bit position for CCM_CGPR_INT_MEM_CLK_LPM. */
#define BM_CCM_CGPR_INT_MEM_CLK_LPM (0x00020000U) /*!< Bit mask for CCM_CGPR_INT_MEM_CLK_LPM. */
#define BS_CCM_CGPR_INT_MEM_CLK_LPM (1U)   /*!< Bit field size in bits for CCM_CGPR_INT_MEM_CLK_LPM. */

/*! @brief Read current value of the CCM_CGPR_INT_MEM_CLK_LPM field. */
#define BR_CCM_CGPR_INT_MEM_CLK_LPM(x) (HW_CCM_CGPR(x).B.INT_MEM_CLK_LPM)

/*! @brief Format value for bitfield CCM_CGPR_INT_MEM_CLK_LPM. */
#define BF_CCM_CGPR_INT_MEM_CLK_LPM(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CGPR_INT_MEM_CLK_LPM) & BM_CCM_CGPR_INT_MEM_CLK_LPM)

/*! @brief Set the INT_MEM_CLK_LPM field to a new value. */
#define BW_CCM_CGPR_INT_MEM_CLK_LPM(x, v) (HW_CCM_CGPR_WR(x, (HW_CCM_CGPR_RD(x) & ~BM_CCM_CGPR_INT_MEM_CLK_LPM) | BF_CCM_CGPR_INT_MEM_CLK_LPM(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR0 - CCM Clock Gating Register 0
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR0 - CCM Clock Gating Register 0 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * CG(i) bits CCGR 0-6 These bits are used to turn on/off the clock to each
 * module independently. The following table details the possible clock activity
 * conditions for each module. CGR value Clock Activity Description 00 Clock is off
 * during all modes. Stop enter hardware handshake is disabled. 01 Clock is on in
 * run mode, but off in WAIT and STOP modes 10 Not applicable (Reserved). 11
 * Clock is on during all modes, except STOP mode. Module should be stopped, before
 * set its bits to "0"; clocks to the module will be stopped immediately. The
 * tables above show the register mapings for the different CGRs. The clock
 * connectivity table should be used to match the "CCM output affected" to the actual
 * clocks going into the modules. The figure below represents the CCM Clock Gating
 * Register 0 (CCM_CCGR0). The clock gating Registers define the clock gating for
 * power reduction of each clock (CG(i) bits). There are 7 CGR registers. The
 * number of registers required is according to the number of peripherals in the
 * system.
 */
typedef union _hw_ccm_ccgr0
{
    uint32_t U;
    struct _hw_ccm_ccgr0_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr0_t;

/*!
 * @name Constants and macros for entire CCM_CCGR0 register
 */
/*@{*/
#define HW_CCM_CCGR0_ADDR(x)     ((uintptr_t)(x) + 0x68U)

#define HW_CCM_CCGR0(x)          (*(__IO hw_ccm_ccgr0_t *) HW_CCM_CCGR0_ADDR(x))
#define HW_CCM_CCGR0_RD(x)       (HW_CCM_CCGR0(x).U)
#define HW_CCM_CCGR0_WR(x, v)    (HW_CCM_CCGR0(x).U = (v))
#define HW_CCM_CCGR0_SET(x, v)   (HW_CCM_CCGR0_WR(x, HW_CCM_CCGR0_RD(x) |  (v)))
#define HW_CCM_CCGR0_CLR(x, v)   (HW_CCM_CCGR0_WR(x, HW_CCM_CCGR0_RD(x) & ~(v)))
#define HW_CCM_CCGR0_TOG(x, v)   (HW_CCM_CCGR0_WR(x, HW_CCM_CCGR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR0 bitfields
 */

/*!
 * @name Register CCM_CCGR0, field CG0[1:0] (RW)
 *
 * aips_tz1 clocks (aips_tz1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG0     (0U)          /*!< Bit position for CCM_CCGR0_CG0. */
#define BM_CCM_CCGR0_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR0_CG0. */
#define BS_CCM_CCGR0_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG0. */

/*! @brief Read current value of the CCM_CCGR0_CG0 field. */
#define BR_CCM_CCGR0_CG0(x)  (HW_CCM_CCGR0(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR0_CG0. */
#define BF_CCM_CCGR0_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG0) & BM_CCM_CCGR0_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR0_CG0(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG0) | BF_CCM_CCGR0_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG1[3:2] (RW)
 *
 * aips_tz2 clocks (aips_tz2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG1     (2U)          /*!< Bit position for CCM_CCGR0_CG1. */
#define BM_CCM_CCGR0_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR0_CG1. */
#define BS_CCM_CCGR0_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG1. */

/*! @brief Read current value of the CCM_CCGR0_CG1 field. */
#define BR_CCM_CCGR0_CG1(x)  (HW_CCM_CCGR0(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR0_CG1. */
#define BF_CCM_CCGR0_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG1) & BM_CCM_CCGR0_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR0_CG1(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG1) | BF_CCM_CCGR0_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG2[5:4] (RW)
 *
 * apbhdma hclk clock (apbhdma_hclk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG2     (4U)          /*!< Bit position for CCM_CCGR0_CG2. */
#define BM_CCM_CCGR0_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR0_CG2. */
#define BS_CCM_CCGR0_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG2. */

/*! @brief Read current value of the CCM_CCGR0_CG2 field. */
#define BR_CCM_CCGR0_CG2(x)  (HW_CCM_CCGR0(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR0_CG2. */
#define BF_CCM_CCGR0_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG2) & BM_CCM_CCGR0_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR0_CG2(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG2) | BF_CCM_CCGR0_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG3[7:6] (RW)
 *
 * asrc clock (asrc_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG3     (6U)          /*!< Bit position for CCM_CCGR0_CG3. */
#define BM_CCM_CCGR0_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR0_CG3. */
#define BS_CCM_CCGR0_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG3. */

/*! @brief Read current value of the CCM_CCGR0_CG3 field. */
#define BR_CCM_CCGR0_CG3(x)  (HW_CCM_CCGR0(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR0_CG3. */
#define BF_CCM_CCGR0_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG3) & BM_CCM_CCGR0_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR0_CG3(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG3) | BF_CCM_CCGR0_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG4[9:8] (RW)
 *
 * caam_secure_mem clock (caam_secure_mem_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG4     (8U)          /*!< Bit position for CCM_CCGR0_CG4. */
#define BM_CCM_CCGR0_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR0_CG4. */
#define BS_CCM_CCGR0_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG4. */

/*! @brief Read current value of the CCM_CCGR0_CG4 field. */
#define BR_CCM_CCGR0_CG4(x)  (HW_CCM_CCGR0(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR0_CG4. */
#define BF_CCM_CCGR0_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG4) & BM_CCM_CCGR0_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR0_CG4(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG4) | BF_CCM_CCGR0_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG5[11:10] (RW)
 *
 * caam_wrapper_aclk clock (caam_wrapper_aclk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG5     (10U)         /*!< Bit position for CCM_CCGR0_CG5. */
#define BM_CCM_CCGR0_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR0_CG5. */
#define BS_CCM_CCGR0_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG5. */

/*! @brief Read current value of the CCM_CCGR0_CG5 field. */
#define BR_CCM_CCGR0_CG5(x)  (HW_CCM_CCGR0(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR0_CG5. */
#define BF_CCM_CCGR0_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG5) & BM_CCM_CCGR0_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR0_CG5(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG5) | BF_CCM_CCGR0_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG6[13:12] (RW)
 *
 * caam_wrapper_ipg clock (caam_wrapper_ipg_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG6     (12U)         /*!< Bit position for CCM_CCGR0_CG6. */
#define BM_CCM_CCGR0_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR0_CG6. */
#define BS_CCM_CCGR0_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG6. */

/*! @brief Read current value of the CCM_CCGR0_CG6 field. */
#define BR_CCM_CCGR0_CG6(x)  (HW_CCM_CCGR0(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR0_CG6. */
#define BF_CCM_CCGR0_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG6) & BM_CCM_CCGR0_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR0_CG6(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG6) | BF_CCM_CCGR0_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG7[15:14] (RW)
 *
 * can1 clock (can1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG7     (14U)         /*!< Bit position for CCM_CCGR0_CG7. */
#define BM_CCM_CCGR0_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR0_CG7. */
#define BS_CCM_CCGR0_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG7. */

/*! @brief Read current value of the CCM_CCGR0_CG7 field. */
#define BR_CCM_CCGR0_CG7(x)  (HW_CCM_CCGR0(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR0_CG7. */
#define BF_CCM_CCGR0_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG7) & BM_CCM_CCGR0_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR0_CG7(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG7) | BF_CCM_CCGR0_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG8[17:16] (RW)
 *
 * can1_serial clock (can1_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG8     (16U)         /*!< Bit position for CCM_CCGR0_CG8. */
#define BM_CCM_CCGR0_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR0_CG8. */
#define BS_CCM_CCGR0_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG8. */

/*! @brief Read current value of the CCM_CCGR0_CG8 field. */
#define BR_CCM_CCGR0_CG8(x)  (HW_CCM_CCGR0(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR0_CG8. */
#define BF_CCM_CCGR0_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG8) & BM_CCM_CCGR0_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR0_CG8(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG8) | BF_CCM_CCGR0_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG9[19:18] (RW)
 *
 * can2 clock (can2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG9     (18U)         /*!< Bit position for CCM_CCGR0_CG9. */
#define BM_CCM_CCGR0_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR0_CG9. */
#define BS_CCM_CCGR0_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG9. */

/*! @brief Read current value of the CCM_CCGR0_CG9 field. */
#define BR_CCM_CCGR0_CG9(x)  (HW_CCM_CCGR0(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR0_CG9. */
#define BF_CCM_CCGR0_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG9) & BM_CCM_CCGR0_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR0_CG9(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG9) | BF_CCM_CCGR0_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG10[21:20] (RW)
 *
 * can2_serial clock (can2_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG10    (20U)         /*!< Bit position for CCM_CCGR0_CG10. */
#define BM_CCM_CCGR0_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR0_CG10. */
#define BS_CCM_CCGR0_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG10. */

/*! @brief Read current value of the CCM_CCGR0_CG10 field. */
#define BR_CCM_CCGR0_CG10(x) (HW_CCM_CCGR0(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR0_CG10. */
#define BF_CCM_CCGR0_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG10) & BM_CCM_CCGR0_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR0_CG10(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG10) | BF_CCM_CCGR0_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG11[23:22] (RW)
 *
 * CPU debug clocks (arm_dbg_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG11    (22U)         /*!< Bit position for CCM_CCGR0_CG11. */
#define BM_CCM_CCGR0_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR0_CG11. */
#define BS_CCM_CCGR0_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG11. */

/*! @brief Read current value of the CCM_CCGR0_CG11 field. */
#define BR_CCM_CCGR0_CG11(x) (HW_CCM_CCGR0(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR0_CG11. */
#define BF_CCM_CCGR0_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG11) & BM_CCM_CCGR0_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR0_CG11(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG11) | BF_CCM_CCGR0_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG12[25:24] (RW)
 *
 * dcic1 clocks (dcic1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG12    (24U)         /*!< Bit position for CCM_CCGR0_CG12. */
#define BM_CCM_CCGR0_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR0_CG12. */
#define BS_CCM_CCGR0_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG12. */

/*! @brief Read current value of the CCM_CCGR0_CG12 field. */
#define BR_CCM_CCGR0_CG12(x) (HW_CCM_CCGR0(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR0_CG12. */
#define BF_CCM_CCGR0_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG12) & BM_CCM_CCGR0_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR0_CG12(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG12) | BF_CCM_CCGR0_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG13[27:26] (RW)
 *
 * dcic2 clocks (dcic2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG13    (26U)         /*!< Bit position for CCM_CCGR0_CG13. */
#define BM_CCM_CCGR0_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR0_CG13. */
#define BS_CCM_CCGR0_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG13. */

/*! @brief Read current value of the CCM_CCGR0_CG13 field. */
#define BR_CCM_CCGR0_CG13(x) (HW_CCM_CCGR0(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR0_CG13. */
#define BF_CCM_CCGR0_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG13) & BM_CCM_CCGR0_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR0_CG13(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG13) | BF_CCM_CCGR0_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG14[29:28] (RW)
 *
 * dtcp clocks (dtcp_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR0_CG14    (28U)         /*!< Bit position for CCM_CCGR0_CG14. */
#define BM_CCM_CCGR0_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR0_CG14. */
#define BS_CCM_CCGR0_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG14. */

/*! @brief Read current value of the CCM_CCGR0_CG14 field. */
#define BR_CCM_CCGR0_CG14(x) (HW_CCM_CCGR0(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR0_CG14. */
#define BF_CCM_CCGR0_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG14) & BM_CCM_CCGR0_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR0_CG14(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG14) | BF_CCM_CCGR0_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR0, field CG15[31:30] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR0_CG15    (30U)         /*!< Bit position for CCM_CCGR0_CG15. */
#define BM_CCM_CCGR0_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR0_CG15. */
#define BS_CCM_CCGR0_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR0_CG15. */

/*! @brief Read current value of the CCM_CCGR0_CG15 field. */
#define BR_CCM_CCGR0_CG15(x) (HW_CCM_CCGR0(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR0_CG15. */
#define BF_CCM_CCGR0_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR0_CG15) & BM_CCM_CCGR0_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR0_CG15(x, v) (HW_CCM_CCGR0_WR(x, (HW_CCM_CCGR0_RD(x) & ~BM_CCM_CCGR0_CG15) | BF_CCM_CCGR0_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR1 - CCM Clock Gating Register 1
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR1 - CCM Clock Gating Register 1 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 1(CCM_CCGR1). The
 * clock gating registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required is
 * determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr1
{
    uint32_t U;
    struct _hw_ccm_ccgr1_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr1_t;

/*!
 * @name Constants and macros for entire CCM_CCGR1 register
 */
/*@{*/
#define HW_CCM_CCGR1_ADDR(x)     ((uintptr_t)(x) + 0x6CU)

#define HW_CCM_CCGR1(x)          (*(__IO hw_ccm_ccgr1_t *) HW_CCM_CCGR1_ADDR(x))
#define HW_CCM_CCGR1_RD(x)       (HW_CCM_CCGR1(x).U)
#define HW_CCM_CCGR1_WR(x, v)    (HW_CCM_CCGR1(x).U = (v))
#define HW_CCM_CCGR1_SET(x, v)   (HW_CCM_CCGR1_WR(x, HW_CCM_CCGR1_RD(x) |  (v)))
#define HW_CCM_CCGR1_CLR(x, v)   (HW_CCM_CCGR1_WR(x, HW_CCM_CCGR1_RD(x) & ~(v)))
#define HW_CCM_CCGR1_TOG(x, v)   (HW_CCM_CCGR1_WR(x, HW_CCM_CCGR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR1 bitfields
 */

/*!
 * @name Register CCM_CCGR1, field CG0[1:0] (RW)
 *
 * ecspi1 clocks (ecspi1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG0     (0U)          /*!< Bit position for CCM_CCGR1_CG0. */
#define BM_CCM_CCGR1_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR1_CG0. */
#define BS_CCM_CCGR1_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG0. */

/*! @brief Read current value of the CCM_CCGR1_CG0 field. */
#define BR_CCM_CCGR1_CG0(x)  (HW_CCM_CCGR1(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR1_CG0. */
#define BF_CCM_CCGR1_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG0) & BM_CCM_CCGR1_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR1_CG0(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG0) | BF_CCM_CCGR1_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG1[3:2] (RW)
 *
 * ecspi2 clocks (ecspi2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG1     (2U)          /*!< Bit position for CCM_CCGR1_CG1. */
#define BM_CCM_CCGR1_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR1_CG1. */
#define BS_CCM_CCGR1_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG1. */

/*! @brief Read current value of the CCM_CCGR1_CG1 field. */
#define BR_CCM_CCGR1_CG1(x)  (HW_CCM_CCGR1(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR1_CG1. */
#define BF_CCM_CCGR1_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG1) & BM_CCM_CCGR1_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR1_CG1(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG1) | BF_CCM_CCGR1_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG2[5:4] (RW)
 *
 * ecspi3 clocks (ecspi3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG2     (4U)          /*!< Bit position for CCM_CCGR1_CG2. */
#define BM_CCM_CCGR1_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR1_CG2. */
#define BS_CCM_CCGR1_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG2. */

/*! @brief Read current value of the CCM_CCGR1_CG2 field. */
#define BR_CCM_CCGR1_CG2(x)  (HW_CCM_CCGR1(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR1_CG2. */
#define BF_CCM_CCGR1_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG2) & BM_CCM_CCGR1_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR1_CG2(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG2) | BF_CCM_CCGR1_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG3[7:6] (RW)
 *
 * ecspi4 clocks (ecspi4_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG3     (6U)          /*!< Bit position for CCM_CCGR1_CG3. */
#define BM_CCM_CCGR1_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR1_CG3. */
#define BS_CCM_CCGR1_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG3. */

/*! @brief Read current value of the CCM_CCGR1_CG3 field. */
#define BR_CCM_CCGR1_CG3(x)  (HW_CCM_CCGR1(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR1_CG3. */
#define BF_CCM_CCGR1_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG3) & BM_CCM_CCGR1_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR1_CG3(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG3) | BF_CCM_CCGR1_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG4[9:8] (RW)
 *
 * ecspi5 clocks (ecspi5_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG4     (8U)          /*!< Bit position for CCM_CCGR1_CG4. */
#define BM_CCM_CCGR1_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR1_CG4. */
#define BS_CCM_CCGR1_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG4. */

/*! @brief Read current value of the CCM_CCGR1_CG4 field. */
#define BR_CCM_CCGR1_CG4(x)  (HW_CCM_CCGR1(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR1_CG4. */
#define BF_CCM_CCGR1_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG4) & BM_CCM_CCGR1_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR1_CG4(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG4) | BF_CCM_CCGR1_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG5[11:10] (RW)
 *
 * enet clock (enet_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG5     (10U)         /*!< Bit position for CCM_CCGR1_CG5. */
#define BM_CCM_CCGR1_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR1_CG5. */
#define BS_CCM_CCGR1_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG5. */

/*! @brief Read current value of the CCM_CCGR1_CG5 field. */
#define BR_CCM_CCGR1_CG5(x)  (HW_CCM_CCGR1(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR1_CG5. */
#define BF_CCM_CCGR1_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG5) & BM_CCM_CCGR1_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR1_CG5(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG5) | BF_CCM_CCGR1_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG6[13:12] (RW)
 *
 * epit1 clocks (epit1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG6     (12U)         /*!< Bit position for CCM_CCGR1_CG6. */
#define BM_CCM_CCGR1_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR1_CG6. */
#define BS_CCM_CCGR1_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG6. */

/*! @brief Read current value of the CCM_CCGR1_CG6 field. */
#define BR_CCM_CCGR1_CG6(x)  (HW_CCM_CCGR1(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR1_CG6. */
#define BF_CCM_CCGR1_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG6) & BM_CCM_CCGR1_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR1_CG6(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG6) | BF_CCM_CCGR1_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG7[15:14] (RW)
 *
 * epit2 clocks (epit2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG7     (14U)         /*!< Bit position for CCM_CCGR1_CG7. */
#define BM_CCM_CCGR1_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR1_CG7. */
#define BS_CCM_CCGR1_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG7. */

/*! @brief Read current value of the CCM_CCGR1_CG7 field. */
#define BR_CCM_CCGR1_CG7(x)  (HW_CCM_CCGR1(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR1_CG7. */
#define BF_CCM_CCGR1_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG7) & BM_CCM_CCGR1_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR1_CG7(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG7) | BF_CCM_CCGR1_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG8[17:16] (RW)
 *
 * esai clocks (esai_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG8     (16U)         /*!< Bit position for CCM_CCGR1_CG8. */
#define BM_CCM_CCGR1_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR1_CG8. */
#define BS_CCM_CCGR1_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG8. */

/*! @brief Read current value of the CCM_CCGR1_CG8 field. */
#define BR_CCM_CCGR1_CG8(x)  (HW_CCM_CCGR1(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR1_CG8. */
#define BF_CCM_CCGR1_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG8) & BM_CCM_CCGR1_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR1_CG8(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG8) | BF_CCM_CCGR1_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG9[19:18] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR1_CG9     (18U)         /*!< Bit position for CCM_CCGR1_CG9. */
#define BM_CCM_CCGR1_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR1_CG9. */
#define BS_CCM_CCGR1_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG9. */

/*! @brief Read current value of the CCM_CCGR1_CG9 field. */
#define BR_CCM_CCGR1_CG9(x)  (HW_CCM_CCGR1(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR1_CG9. */
#define BF_CCM_CCGR1_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG9) & BM_CCM_CCGR1_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR1_CG9(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG9) | BF_CCM_CCGR1_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG10[21:20] (RW)
 *
 * gpt bus clock (gpt_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG10    (20U)         /*!< Bit position for CCM_CCGR1_CG10. */
#define BM_CCM_CCGR1_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR1_CG10. */
#define BS_CCM_CCGR1_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG10. */

/*! @brief Read current value of the CCM_CCGR1_CG10 field. */
#define BR_CCM_CCGR1_CG10(x) (HW_CCM_CCGR1(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR1_CG10. */
#define BF_CCM_CCGR1_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG10) & BM_CCM_CCGR1_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR1_CG10(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG10) | BF_CCM_CCGR1_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG11[23:22] (RW)
 *
 * gpt serial clock (gpt_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG11    (22U)         /*!< Bit position for CCM_CCGR1_CG11. */
#define BM_CCM_CCGR1_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR1_CG11. */
#define BS_CCM_CCGR1_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG11. */

/*! @brief Read current value of the CCM_CCGR1_CG11 field. */
#define BR_CCM_CCGR1_CG11(x) (HW_CCM_CCGR1(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR1_CG11. */
#define BF_CCM_CCGR1_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG11) & BM_CCM_CCGR1_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR1_CG11(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG11) | BF_CCM_CCGR1_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG12[25:24] (RW)
 *
 * gpu2d clock (gpu2d_clk_enable) GPU2D clock cannot be gated without gating
 * OPENVG clock as well. Configure both CG bits (CCM_ANALOG_CCGR1[CG12] and
 * CCM_ANALOG_CCGR3[CG15]), to gate GPU2D.
 */
/*@{*/
#define BP_CCM_CCGR1_CG12    (24U)         /*!< Bit position for CCM_CCGR1_CG12. */
#define BM_CCM_CCGR1_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR1_CG12. */
#define BS_CCM_CCGR1_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG12. */

/*! @brief Read current value of the CCM_CCGR1_CG12 field. */
#define BR_CCM_CCGR1_CG12(x) (HW_CCM_CCGR1(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR1_CG12. */
#define BF_CCM_CCGR1_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG12) & BM_CCM_CCGR1_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR1_CG12(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG12) | BF_CCM_CCGR1_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG13[27:26] (RW)
 *
 * gpu3d clock (gpu3d_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR1_CG13    (26U)         /*!< Bit position for CCM_CCGR1_CG13. */
#define BM_CCM_CCGR1_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR1_CG13. */
#define BS_CCM_CCGR1_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG13. */

/*! @brief Read current value of the CCM_CCGR1_CG13 field. */
#define BR_CCM_CCGR1_CG13(x) (HW_CCM_CCGR1(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR1_CG13. */
#define BF_CCM_CCGR1_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG13) & BM_CCM_CCGR1_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR1_CG13(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG13) | BF_CCM_CCGR1_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG14[29:28] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR1_CG14    (28U)         /*!< Bit position for CCM_CCGR1_CG14. */
#define BM_CCM_CCGR1_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR1_CG14. */
#define BS_CCM_CCGR1_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG14. */

/*! @brief Read current value of the CCM_CCGR1_CG14 field. */
#define BR_CCM_CCGR1_CG14(x) (HW_CCM_CCGR1(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR1_CG14. */
#define BF_CCM_CCGR1_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG14) & BM_CCM_CCGR1_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR1_CG14(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG14) | BF_CCM_CCGR1_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR1, field CG15[31:30] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR1_CG15    (30U)         /*!< Bit position for CCM_CCGR1_CG15. */
#define BM_CCM_CCGR1_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR1_CG15. */
#define BS_CCM_CCGR1_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR1_CG15. */

/*! @brief Read current value of the CCM_CCGR1_CG15 field. */
#define BR_CCM_CCGR1_CG15(x) (HW_CCM_CCGR1(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR1_CG15. */
#define BF_CCM_CCGR1_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR1_CG15) & BM_CCM_CCGR1_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR1_CG15(x, v) (HW_CCM_CCGR1_WR(x, (HW_CCM_CCGR1_RD(x) & ~BM_CCM_CCGR1_CG15) | BF_CCM_CCGR1_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR2 - CCM Clock Gating Register 2
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR2 - CCM Clock Gating Register 2 (RW)
 *
 * Reset value: 0xFC3FFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 2 (CCM_CCGR2). The
 * clock gating registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required
 * is determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr2
{
    uint32_t U;
    struct _hw_ccm_ccgr2_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr2_t;

/*!
 * @name Constants and macros for entire CCM_CCGR2 register
 */
/*@{*/
#define HW_CCM_CCGR2_ADDR(x)     ((uintptr_t)(x) + 0x70U)

#define HW_CCM_CCGR2(x)          (*(__IO hw_ccm_ccgr2_t *) HW_CCM_CCGR2_ADDR(x))
#define HW_CCM_CCGR2_RD(x)       (HW_CCM_CCGR2(x).U)
#define HW_CCM_CCGR2_WR(x, v)    (HW_CCM_CCGR2(x).U = (v))
#define HW_CCM_CCGR2_SET(x, v)   (HW_CCM_CCGR2_WR(x, HW_CCM_CCGR2_RD(x) |  (v)))
#define HW_CCM_CCGR2_CLR(x, v)   (HW_CCM_CCGR2_WR(x, HW_CCM_CCGR2_RD(x) & ~(v)))
#define HW_CCM_CCGR2_TOG(x, v)   (HW_CCM_CCGR2_WR(x, HW_CCM_CCGR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR2 bitfields
 */

/*!
 * @name Register CCM_CCGR2, field CG0[1:0] (RW)
 *
 * hdmi_tx_iahbclk, hdmi_tx_ihclk clock (hdmi_tx_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG0     (0U)          /*!< Bit position for CCM_CCGR2_CG0. */
#define BM_CCM_CCGR2_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR2_CG0. */
#define BS_CCM_CCGR2_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG0. */

/*! @brief Read current value of the CCM_CCGR2_CG0 field. */
#define BR_CCM_CCGR2_CG0(x)  (HW_CCM_CCGR2(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR2_CG0. */
#define BF_CCM_CCGR2_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG0) & BM_CCM_CCGR2_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR2_CG0(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG0) | BF_CCM_CCGR2_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG1[3:2] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR2_CG1     (2U)          /*!< Bit position for CCM_CCGR2_CG1. */
#define BM_CCM_CCGR2_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR2_CG1. */
#define BS_CCM_CCGR2_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG1. */

/*! @brief Read current value of the CCM_CCGR2_CG1 field. */
#define BR_CCM_CCGR2_CG1(x)  (HW_CCM_CCGR2(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR2_CG1. */
#define BF_CCM_CCGR2_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG1) & BM_CCM_CCGR2_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR2_CG1(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG1) | BF_CCM_CCGR2_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG2[5:4] (RW)
 *
 * hdmi_tx_isfrclk clock (hdmi_tx_isfrclk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG2     (4U)          /*!< Bit position for CCM_CCGR2_CG2. */
#define BM_CCM_CCGR2_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR2_CG2. */
#define BS_CCM_CCGR2_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG2. */

/*! @brief Read current value of the CCM_CCGR2_CG2 field. */
#define BR_CCM_CCGR2_CG2(x)  (HW_CCM_CCGR2(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR2_CG2. */
#define BF_CCM_CCGR2_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG2) & BM_CCM_CCGR2_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR2_CG2(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG2) | BF_CCM_CCGR2_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG3[7:6] (RW)
 *
 * i2c1_serial clock (i2c1_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG3     (6U)          /*!< Bit position for CCM_CCGR2_CG3. */
#define BM_CCM_CCGR2_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR2_CG3. */
#define BS_CCM_CCGR2_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG3. */

/*! @brief Read current value of the CCM_CCGR2_CG3 field. */
#define BR_CCM_CCGR2_CG3(x)  (HW_CCM_CCGR2(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR2_CG3. */
#define BF_CCM_CCGR2_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG3) & BM_CCM_CCGR2_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR2_CG3(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG3) | BF_CCM_CCGR2_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG4[9:8] (RW)
 *
 * i2c2_serial clock (i2c2_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG4     (8U)          /*!< Bit position for CCM_CCGR2_CG4. */
#define BM_CCM_CCGR2_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR2_CG4. */
#define BS_CCM_CCGR2_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG4. */

/*! @brief Read current value of the CCM_CCGR2_CG4 field. */
#define BR_CCM_CCGR2_CG4(x)  (HW_CCM_CCGR2(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR2_CG4. */
#define BF_CCM_CCGR2_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG4) & BM_CCM_CCGR2_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR2_CG4(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG4) | BF_CCM_CCGR2_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG5[11:10] (RW)
 *
 * i2c3_serial clock (i2c3_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG5     (10U)         /*!< Bit position for CCM_CCGR2_CG5. */
#define BM_CCM_CCGR2_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR2_CG5. */
#define BS_CCM_CCGR2_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG5. */

/*! @brief Read current value of the CCM_CCGR2_CG5 field. */
#define BR_CCM_CCGR2_CG5(x)  (HW_CCM_CCGR2(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR2_CG5. */
#define BF_CCM_CCGR2_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG5) & BM_CCM_CCGR2_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR2_CG5(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG5) | BF_CCM_CCGR2_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG6[13:12] (RW)
 *
 * OCOTP_CTRL clock (iim_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG6     (12U)         /*!< Bit position for CCM_CCGR2_CG6. */
#define BM_CCM_CCGR2_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR2_CG6. */
#define BS_CCM_CCGR2_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG6. */

/*! @brief Read current value of the CCM_CCGR2_CG6 field. */
#define BR_CCM_CCGR2_CG6(x)  (HW_CCM_CCGR2(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR2_CG6. */
#define BF_CCM_CCGR2_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG6) & BM_CCM_CCGR2_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR2_CG6(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG6) | BF_CCM_CCGR2_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG7[15:14] (RW)
 *
 * iomux_ipt_clk_io clock (iomux_ipt_clk_io_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG7     (14U)         /*!< Bit position for CCM_CCGR2_CG7. */
#define BM_CCM_CCGR2_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR2_CG7. */
#define BS_CCM_CCGR2_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG7. */

/*! @brief Read current value of the CCM_CCGR2_CG7 field. */
#define BR_CCM_CCGR2_CG7(x)  (HW_CCM_CCGR2(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR2_CG7. */
#define BF_CCM_CCGR2_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG7) & BM_CCM_CCGR2_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR2_CG7(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG7) | BF_CCM_CCGR2_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG8[17:16] (RW)
 *
 * ipmux1 clock (ipmux1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG8     (16U)         /*!< Bit position for CCM_CCGR2_CG8. */
#define BM_CCM_CCGR2_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR2_CG8. */
#define BS_CCM_CCGR2_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG8. */

/*! @brief Read current value of the CCM_CCGR2_CG8 field. */
#define BR_CCM_CCGR2_CG8(x)  (HW_CCM_CCGR2(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR2_CG8. */
#define BF_CCM_CCGR2_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG8) & BM_CCM_CCGR2_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR2_CG8(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG8) | BF_CCM_CCGR2_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG9[19:18] (RW)
 *
 * ipmux2 clock (ipmux2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG9     (18U)         /*!< Bit position for CCM_CCGR2_CG9. */
#define BM_CCM_CCGR2_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR2_CG9. */
#define BS_CCM_CCGR2_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG9. */

/*! @brief Read current value of the CCM_CCGR2_CG9 field. */
#define BR_CCM_CCGR2_CG9(x)  (HW_CCM_CCGR2(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR2_CG9. */
#define BF_CCM_CCGR2_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG9) & BM_CCM_CCGR2_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR2_CG9(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG9) | BF_CCM_CCGR2_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG10[21:20] (RW)
 *
 * ipmux3 clock (ipmux3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG10    (20U)         /*!< Bit position for CCM_CCGR2_CG10. */
#define BM_CCM_CCGR2_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR2_CG10. */
#define BS_CCM_CCGR2_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG10. */

/*! @brief Read current value of the CCM_CCGR2_CG10 field. */
#define BR_CCM_CCGR2_CG10(x) (HW_CCM_CCGR2(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR2_CG10. */
#define BF_CCM_CCGR2_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG10) & BM_CCM_CCGR2_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR2_CG10(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG10) | BF_CCM_CCGR2_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG11[23:22] (RW)
 *
 * ipsync_ip2apb_tzasc1_ipg clocks (ipsync_ip2apb_tzasc1_ipg_master_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG11    (22U)         /*!< Bit position for CCM_CCGR2_CG11. */
#define BM_CCM_CCGR2_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR2_CG11. */
#define BS_CCM_CCGR2_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG11. */

/*! @brief Read current value of the CCM_CCGR2_CG11 field. */
#define BR_CCM_CCGR2_CG11(x) (HW_CCM_CCGR2(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR2_CG11. */
#define BF_CCM_CCGR2_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG11) & BM_CCM_CCGR2_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR2_CG11(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG11) | BF_CCM_CCGR2_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG12[25:24] (RW)
 *
 * ipsync_ip2apb_tzasc2_ipg clocks (ipsync_ip2apb_tzasc2_ipg_master_clk_enable) >
 */
/*@{*/
#define BP_CCM_CCGR2_CG12    (24U)         /*!< Bit position for CCM_CCGR2_CG12. */
#define BM_CCM_CCGR2_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR2_CG12. */
#define BS_CCM_CCGR2_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG12. */

/*! @brief Read current value of the CCM_CCGR2_CG12 field. */
#define BR_CCM_CCGR2_CG12(x) (HW_CCM_CCGR2(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR2_CG12. */
#define BF_CCM_CCGR2_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG12) & BM_CCM_CCGR2_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR2_CG12(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG12) | BF_CCM_CCGR2_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG13[27:26] (RW)
 *
 * ipsync_vdoa_ipg clocks (ipsync_vdoa_ipg_master_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR2_CG13    (26U)         /*!< Bit position for CCM_CCGR2_CG13. */
#define BM_CCM_CCGR2_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR2_CG13. */
#define BS_CCM_CCGR2_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG13. */

/*! @brief Read current value of the CCM_CCGR2_CG13 field. */
#define BR_CCM_CCGR2_CG13(x) (HW_CCM_CCGR2(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR2_CG13. */
#define BF_CCM_CCGR2_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG13) & BM_CCM_CCGR2_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR2_CG13(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG13) | BF_CCM_CCGR2_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG14[29:28] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR2_CG14    (28U)         /*!< Bit position for CCM_CCGR2_CG14. */
#define BM_CCM_CCGR2_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR2_CG14. */
#define BS_CCM_CCGR2_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG14. */

/*! @brief Read current value of the CCM_CCGR2_CG14 field. */
#define BR_CCM_CCGR2_CG14(x) (HW_CCM_CCGR2(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR2_CG14. */
#define BF_CCM_CCGR2_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG14) & BM_CCM_CCGR2_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR2_CG14(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG14) | BF_CCM_CCGR2_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR2, field CG15[31:30] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR2_CG15    (30U)         /*!< Bit position for CCM_CCGR2_CG15. */
#define BM_CCM_CCGR2_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR2_CG15. */
#define BS_CCM_CCGR2_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR2_CG15. */

/*! @brief Read current value of the CCM_CCGR2_CG15 field. */
#define BR_CCM_CCGR2_CG15(x) (HW_CCM_CCGR2(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR2_CG15. */
#define BF_CCM_CCGR2_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR2_CG15) & BM_CCM_CCGR2_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR2_CG15(x, v) (HW_CCM_CCGR2_WR(x, (HW_CCM_CCGR2_RD(x) & ~BM_CCM_CCGR2_CG15) | BF_CCM_CCGR2_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR3 - CCM Clock Gating Register 3
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR3 - CCM Clock Gating Register 3 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 3 (CCM_CCGR3). The
 * clock gating Registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required
 * is determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr3
{
    uint32_t U;
    struct _hw_ccm_ccgr3_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr3_t;

/*!
 * @name Constants and macros for entire CCM_CCGR3 register
 */
/*@{*/
#define HW_CCM_CCGR3_ADDR(x)     ((uintptr_t)(x) + 0x74U)

#define HW_CCM_CCGR3(x)          (*(__IO hw_ccm_ccgr3_t *) HW_CCM_CCGR3_ADDR(x))
#define HW_CCM_CCGR3_RD(x)       (HW_CCM_CCGR3(x).U)
#define HW_CCM_CCGR3_WR(x, v)    (HW_CCM_CCGR3(x).U = (v))
#define HW_CCM_CCGR3_SET(x, v)   (HW_CCM_CCGR3_WR(x, HW_CCM_CCGR3_RD(x) |  (v)))
#define HW_CCM_CCGR3_CLR(x, v)   (HW_CCM_CCGR3_WR(x, HW_CCM_CCGR3_RD(x) & ~(v)))
#define HW_CCM_CCGR3_TOG(x, v)   (HW_CCM_CCGR3_WR(x, HW_CCM_CCGR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR3 bitfields
 */

/*!
 * @name Register CCM_CCGR3, field CG0[1:0] (RW)
 *
 * ipu1_ipu clock (ipu1_ipu_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG0     (0U)          /*!< Bit position for CCM_CCGR3_CG0. */
#define BM_CCM_CCGR3_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR3_CG0. */
#define BS_CCM_CCGR3_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG0. */

/*! @brief Read current value of the CCM_CCGR3_CG0 field. */
#define BR_CCM_CCGR3_CG0(x)  (HW_CCM_CCGR3(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR3_CG0. */
#define BF_CCM_CCGR3_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG0) & BM_CCM_CCGR3_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR3_CG0(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG0) | BF_CCM_CCGR3_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG1[3:2] (RW)
 *
 * ipu1_di0 clock and pre-clock (ipu1_ipu_di0_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG1     (2U)          /*!< Bit position for CCM_CCGR3_CG1. */
#define BM_CCM_CCGR3_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR3_CG1. */
#define BS_CCM_CCGR3_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG1. */

/*! @brief Read current value of the CCM_CCGR3_CG1 field. */
#define BR_CCM_CCGR3_CG1(x)  (HW_CCM_CCGR3(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR3_CG1. */
#define BF_CCM_CCGR3_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG1) & BM_CCM_CCGR3_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR3_CG1(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG1) | BF_CCM_CCGR3_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG2[5:4] (RW)
 *
 * ipu1_di1 clock and pre-clock (ipu1_ipu_di1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG2     (4U)          /*!< Bit position for CCM_CCGR3_CG2. */
#define BM_CCM_CCGR3_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR3_CG2. */
#define BS_CCM_CCGR3_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG2. */

/*! @brief Read current value of the CCM_CCGR3_CG2 field. */
#define BR_CCM_CCGR3_CG2(x)  (HW_CCM_CCGR3(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR3_CG2. */
#define BF_CCM_CCGR3_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG2) & BM_CCM_CCGR3_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR3_CG2(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG2) | BF_CCM_CCGR3_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG3[7:6] (RW)
 *
 * ipu2_ipu clock (ipu2_ipu_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG3     (6U)          /*!< Bit position for CCM_CCGR3_CG3. */
#define BM_CCM_CCGR3_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR3_CG3. */
#define BS_CCM_CCGR3_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG3. */

/*! @brief Read current value of the CCM_CCGR3_CG3 field. */
#define BR_CCM_CCGR3_CG3(x)  (HW_CCM_CCGR3(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR3_CG3. */
#define BF_CCM_CCGR3_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG3) & BM_CCM_CCGR3_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR3_CG3(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG3) | BF_CCM_CCGR3_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG4[9:8] (RW)
 *
 * ipu2_di0 clock and pre-clock (ipu2_ipu_di0_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG4     (8U)          /*!< Bit position for CCM_CCGR3_CG4. */
#define BM_CCM_CCGR3_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR3_CG4. */
#define BS_CCM_CCGR3_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG4. */

/*! @brief Read current value of the CCM_CCGR3_CG4 field. */
#define BR_CCM_CCGR3_CG4(x)  (HW_CCM_CCGR3(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR3_CG4. */
#define BF_CCM_CCGR3_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG4) & BM_CCM_CCGR3_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR3_CG4(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG4) | BF_CCM_CCGR3_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG5[11:10] (RW)
 *
 * ipu2_di1 clock and pre-clock (ipu2_ipu_di1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG5     (10U)         /*!< Bit position for CCM_CCGR3_CG5. */
#define BM_CCM_CCGR3_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR3_CG5. */
#define BS_CCM_CCGR3_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG5. */

/*! @brief Read current value of the CCM_CCGR3_CG5 field. */
#define BR_CCM_CCGR3_CG5(x)  (HW_CCM_CCGR3(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR3_CG5. */
#define BF_CCM_CCGR3_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG5) & BM_CCM_CCGR3_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR3_CG5(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG5) | BF_CCM_CCGR3_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG6[13:12] (RW)
 *
 * ldb_di0 clock (ldb_di0_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG6     (12U)         /*!< Bit position for CCM_CCGR3_CG6. */
#define BM_CCM_CCGR3_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR3_CG6. */
#define BS_CCM_CCGR3_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG6. */

/*! @brief Read current value of the CCM_CCGR3_CG6 field. */
#define BR_CCM_CCGR3_CG6(x)  (HW_CCM_CCGR3(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR3_CG6. */
#define BF_CCM_CCGR3_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG6) & BM_CCM_CCGR3_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR3_CG6(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG6) | BF_CCM_CCGR3_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG7[15:14] (RW)
 *
 * ldb_di1 clock (ldb_di1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG7     (14U)         /*!< Bit position for CCM_CCGR3_CG7. */
#define BM_CCM_CCGR3_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR3_CG7. */
#define BS_CCM_CCGR3_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG7. */

/*! @brief Read current value of the CCM_CCGR3_CG7 field. */
#define BR_CCM_CCGR3_CG7(x)  (HW_CCM_CCGR3(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR3_CG7. */
#define BF_CCM_CCGR3_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG7) & BM_CCM_CCGR3_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR3_CG7(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG7) | BF_CCM_CCGR3_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG8[17:16] (RW)
 *
 * mipi_core_cfg clock (mipi_core_cfg_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG8     (16U)         /*!< Bit position for CCM_CCGR3_CG8. */
#define BM_CCM_CCGR3_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR3_CG8. */
#define BS_CCM_CCGR3_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG8. */

/*! @brief Read current value of the CCM_CCGR3_CG8 field. */
#define BR_CCM_CCGR3_CG8(x)  (HW_CCM_CCGR3(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR3_CG8. */
#define BF_CCM_CCGR3_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG8) & BM_CCM_CCGR3_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR3_CG8(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG8) | BF_CCM_CCGR3_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG9[19:18] (RW)
 *
 * mlb clock (mlb_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG9     (18U)         /*!< Bit position for CCM_CCGR3_CG9. */
#define BM_CCM_CCGR3_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR3_CG9. */
#define BS_CCM_CCGR3_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG9. */

/*! @brief Read current value of the CCM_CCGR3_CG9 field. */
#define BR_CCM_CCGR3_CG9(x)  (HW_CCM_CCGR3(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR3_CG9. */
#define BF_CCM_CCGR3_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG9) & BM_CCM_CCGR3_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR3_CG9(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG9) | BF_CCM_CCGR3_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG10[21:20] (RW)
 *
 * mmdc_core_aclk_fast_core_p0 clock (mmdc_core_aclk_fast_core_p0_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG10    (20U)         /*!< Bit position for CCM_CCGR3_CG10. */
#define BM_CCM_CCGR3_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR3_CG10. */
#define BS_CCM_CCGR3_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG10. */

/*! @brief Read current value of the CCM_CCGR3_CG10 field. */
#define BR_CCM_CCGR3_CG10(x) (HW_CCM_CCGR3(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR3_CG10. */
#define BF_CCM_CCGR3_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG10) & BM_CCM_CCGR3_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR3_CG10(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG10) | BF_CCM_CCGR3_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG11[23:22] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR3_CG11    (22U)         /*!< Bit position for CCM_CCGR3_CG11. */
#define BM_CCM_CCGR3_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR3_CG11. */
#define BS_CCM_CCGR3_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG11. */

/*! @brief Read current value of the CCM_CCGR3_CG11 field. */
#define BR_CCM_CCGR3_CG11(x) (HW_CCM_CCGR3(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR3_CG11. */
#define BF_CCM_CCGR3_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG11) & BM_CCM_CCGR3_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR3_CG11(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG11) | BF_CCM_CCGR3_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG12[25:24] (RW)
 *
 * mmdc_core_ipg_clk_p0 clock (mmdc_core_ipg_clk_p0_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG12    (24U)         /*!< Bit position for CCM_CCGR3_CG12. */
#define BM_CCM_CCGR3_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR3_CG12. */
#define BS_CCM_CCGR3_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG12. */

/*! @brief Read current value of the CCM_CCGR3_CG12 field. */
#define BR_CCM_CCGR3_CG12(x) (HW_CCM_CCGR3(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR3_CG12. */
#define BF_CCM_CCGR3_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG12) & BM_CCM_CCGR3_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR3_CG12(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG12) | BF_CCM_CCGR3_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG13[27:26] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR3_CG13    (26U)         /*!< Bit position for CCM_CCGR3_CG13. */
#define BM_CCM_CCGR3_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR3_CG13. */
#define BS_CCM_CCGR3_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG13. */

/*! @brief Read current value of the CCM_CCGR3_CG13 field. */
#define BR_CCM_CCGR3_CG13(x) (HW_CCM_CCGR3(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR3_CG13. */
#define BF_CCM_CCGR3_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG13) & BM_CCM_CCGR3_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR3_CG13(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG13) | BF_CCM_CCGR3_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG14[29:28] (RW)
 *
 * ocram clock (ocram_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR3_CG14    (28U)         /*!< Bit position for CCM_CCGR3_CG14. */
#define BM_CCM_CCGR3_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR3_CG14. */
#define BS_CCM_CCGR3_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG14. */

/*! @brief Read current value of the CCM_CCGR3_CG14 field. */
#define BR_CCM_CCGR3_CG14(x) (HW_CCM_CCGR3(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR3_CG14. */
#define BF_CCM_CCGR3_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG14) & BM_CCM_CCGR3_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR3_CG14(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG14) | BF_CCM_CCGR3_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR3, field CG15[31:30] (RW)
 *
 * openvgaxiclk clock (openvgaxiclk_clk_root_enable) OPENVG clock cannot be
 * gated without gating GPU2D clock as well. Configure both CG bits
 * (CCM_ANALOG_CCGR1[CG12] and CCM_ANALOG_CCGR3[CG15]) to gate OPENVG.
 */
/*@{*/
#define BP_CCM_CCGR3_CG15    (30U)         /*!< Bit position for CCM_CCGR3_CG15. */
#define BM_CCM_CCGR3_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR3_CG15. */
#define BS_CCM_CCGR3_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR3_CG15. */

/*! @brief Read current value of the CCM_CCGR3_CG15 field. */
#define BR_CCM_CCGR3_CG15(x) (HW_CCM_CCGR3(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR3_CG15. */
#define BF_CCM_CCGR3_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR3_CG15) & BM_CCM_CCGR3_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR3_CG15(x, v) (HW_CCM_CCGR3_WR(x, (HW_CCM_CCGR3_RD(x) & ~BM_CCM_CCGR3_CG15) | BF_CCM_CCGR3_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR4 - CCM Clock Gating Register 4
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR4 - CCM Clock Gating Register 4 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 4 (CCM_CCGR4). The
 * clock gating Registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required
 * is determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr4
{
    uint32_t U;
    struct _hw_ccm_ccgr4_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr4_t;

/*!
 * @name Constants and macros for entire CCM_CCGR4 register
 */
/*@{*/
#define HW_CCM_CCGR4_ADDR(x)     ((uintptr_t)(x) + 0x78U)

#define HW_CCM_CCGR4(x)          (*(__IO hw_ccm_ccgr4_t *) HW_CCM_CCGR4_ADDR(x))
#define HW_CCM_CCGR4_RD(x)       (HW_CCM_CCGR4(x).U)
#define HW_CCM_CCGR4_WR(x, v)    (HW_CCM_CCGR4(x).U = (v))
#define HW_CCM_CCGR4_SET(x, v)   (HW_CCM_CCGR4_WR(x, HW_CCM_CCGR4_RD(x) |  (v)))
#define HW_CCM_CCGR4_CLR(x, v)   (HW_CCM_CCGR4_WR(x, HW_CCM_CCGR4_RD(x) & ~(v)))
#define HW_CCM_CCGR4_TOG(x, v)   (HW_CCM_CCGR4_WR(x, HW_CCM_CCGR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR4 bitfields
 */

/*!
 * @name Register CCM_CCGR4, field CG0[1:0] (RW)
 *
 * pcie clock (pcie_root_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG0     (0U)          /*!< Bit position for CCM_CCGR4_CG0. */
#define BM_CCM_CCGR4_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR4_CG0. */
#define BS_CCM_CCGR4_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG0. */

/*! @brief Read current value of the CCM_CCGR4_CG0 field. */
#define BR_CCM_CCGR4_CG0(x)  (HW_CCM_CCGR4(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR4_CG0. */
#define BF_CCM_CCGR4_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG0) & BM_CCM_CCGR4_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR4_CG0(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG0) | BF_CCM_CCGR4_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG1[3:2] (RW)
 *
 * Reserved.
 */
/*@{*/
#define BP_CCM_CCGR4_CG1     (2U)          /*!< Bit position for CCM_CCGR4_CG1. */
#define BM_CCM_CCGR4_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR4_CG1. */
#define BS_CCM_CCGR4_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG1. */

/*! @brief Read current value of the CCM_CCGR4_CG1 field. */
#define BR_CCM_CCGR4_CG1(x)  (HW_CCM_CCGR4(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR4_CG1. */
#define BF_CCM_CCGR4_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG1) & BM_CCM_CCGR4_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR4_CG1(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG1) | BF_CCM_CCGR4_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG2[5:4] (RW)
 *
 * Reserved.
 */
/*@{*/
#define BP_CCM_CCGR4_CG2     (4U)          /*!< Bit position for CCM_CCGR4_CG2. */
#define BM_CCM_CCGR4_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR4_CG2. */
#define BS_CCM_CCGR4_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG2. */

/*! @brief Read current value of the CCM_CCGR4_CG2 field. */
#define BR_CCM_CCGR4_CG2(x)  (HW_CCM_CCGR4(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR4_CG2. */
#define BF_CCM_CCGR4_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG2) & BM_CCM_CCGR4_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR4_CG2(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG2) | BF_CCM_CCGR4_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG3[7:6] (RW)
 */
/*@{*/
#define BP_CCM_CCGR4_CG3     (6U)          /*!< Bit position for CCM_CCGR4_CG3. */
#define BM_CCM_CCGR4_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR4_CG3. */
#define BS_CCM_CCGR4_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG3. */

/*! @brief Read current value of the CCM_CCGR4_CG3 field. */
#define BR_CCM_CCGR4_CG3(x)  (HW_CCM_CCGR4(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR4_CG3. */
#define BF_CCM_CCGR4_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG3) & BM_CCM_CCGR4_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR4_CG3(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG3) | BF_CCM_CCGR4_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG4[9:8] (RW)
 *
 * pl301_mx6qfast1_s133 clock (pl301_mx6qfast1_s133clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG4     (8U)          /*!< Bit position for CCM_CCGR4_CG4. */
#define BM_CCM_CCGR4_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR4_CG4. */
#define BS_CCM_CCGR4_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG4. */

/*! @brief Read current value of the CCM_CCGR4_CG4 field. */
#define BR_CCM_CCGR4_CG4(x)  (HW_CCM_CCGR4(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR4_CG4. */
#define BF_CCM_CCGR4_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG4) & BM_CCM_CCGR4_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR4_CG4(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG4) | BF_CCM_CCGR4_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG5[11:10] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR4_CG5     (10U)         /*!< Bit position for CCM_CCGR4_CG5. */
#define BM_CCM_CCGR4_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR4_CG5. */
#define BS_CCM_CCGR4_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG5. */

/*! @brief Read current value of the CCM_CCGR4_CG5 field. */
#define BR_CCM_CCGR4_CG5(x)  (HW_CCM_CCGR4(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR4_CG5. */
#define BF_CCM_CCGR4_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG5) & BM_CCM_CCGR4_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR4_CG5(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG5) | BF_CCM_CCGR4_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG6[13:12] (RW)
 *
 * pl301_mx6qper1_bch clocks (pl301_mx6qper1_bchclk_enable) This gates
 * bch_clk_root to sim_m fabric.
 */
/*@{*/
#define BP_CCM_CCGR4_CG6     (12U)         /*!< Bit position for CCM_CCGR4_CG6. */
#define BM_CCM_CCGR4_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR4_CG6. */
#define BS_CCM_CCGR4_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG6. */

/*! @brief Read current value of the CCM_CCGR4_CG6 field. */
#define BR_CCM_CCGR4_CG6(x)  (HW_CCM_CCGR4(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR4_CG6. */
#define BF_CCM_CCGR4_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG6) & BM_CCM_CCGR4_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR4_CG6(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG6) | BF_CCM_CCGR4_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG7[15:14] (RW)
 *
 * pl301_mx6qper2_mainclk_enable (pl301_mx6qper2_mainclk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG7     (14U)         /*!< Bit position for CCM_CCGR4_CG7. */
#define BM_CCM_CCGR4_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR4_CG7. */
#define BS_CCM_CCGR4_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG7. */

/*! @brief Read current value of the CCM_CCGR4_CG7 field. */
#define BR_CCM_CCGR4_CG7(x)  (HW_CCM_CCGR4(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR4_CG7. */
#define BF_CCM_CCGR4_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG7) & BM_CCM_CCGR4_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR4_CG7(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG7) | BF_CCM_CCGR4_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG8[17:16] (RW)
 *
 * pwm1 clocks (pwm1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG8     (16U)         /*!< Bit position for CCM_CCGR4_CG8. */
#define BM_CCM_CCGR4_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR4_CG8. */
#define BS_CCM_CCGR4_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG8. */

/*! @brief Read current value of the CCM_CCGR4_CG8 field. */
#define BR_CCM_CCGR4_CG8(x)  (HW_CCM_CCGR4(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR4_CG8. */
#define BF_CCM_CCGR4_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG8) & BM_CCM_CCGR4_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR4_CG8(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG8) | BF_CCM_CCGR4_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG9[19:18] (RW)
 *
 * pwm2 clocks (pwm2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG9     (18U)         /*!< Bit position for CCM_CCGR4_CG9. */
#define BM_CCM_CCGR4_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR4_CG9. */
#define BS_CCM_CCGR4_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG9. */

/*! @brief Read current value of the CCM_CCGR4_CG9 field. */
#define BR_CCM_CCGR4_CG9(x)  (HW_CCM_CCGR4(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR4_CG9. */
#define BF_CCM_CCGR4_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG9) & BM_CCM_CCGR4_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR4_CG9(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG9) | BF_CCM_CCGR4_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG10[21:20] (RW)
 *
 * pwm3 clocks (pwm3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG10    (20U)         /*!< Bit position for CCM_CCGR4_CG10. */
#define BM_CCM_CCGR4_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR4_CG10. */
#define BS_CCM_CCGR4_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG10. */

/*! @brief Read current value of the CCM_CCGR4_CG10 field. */
#define BR_CCM_CCGR4_CG10(x) (HW_CCM_CCGR4(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR4_CG10. */
#define BF_CCM_CCGR4_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG10) & BM_CCM_CCGR4_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR4_CG10(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG10) | BF_CCM_CCGR4_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG11[23:22] (RW)
 *
 * pwm4 clocks (pwm4_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG11    (22U)         /*!< Bit position for CCM_CCGR4_CG11. */
#define BM_CCM_CCGR4_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR4_CG11. */
#define BS_CCM_CCGR4_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG11. */

/*! @brief Read current value of the CCM_CCGR4_CG11 field. */
#define BR_CCM_CCGR4_CG11(x) (HW_CCM_CCGR4(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR4_CG11. */
#define BF_CCM_CCGR4_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG11) & BM_CCM_CCGR4_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR4_CG11(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG11) | BF_CCM_CCGR4_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG12[25:24] (RW)
 *
 * rawnand_u_bch_input_apb clock (rawnand_u_bch_input_apb_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG12    (24U)         /*!< Bit position for CCM_CCGR4_CG12. */
#define BM_CCM_CCGR4_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR4_CG12. */
#define BS_CCM_CCGR4_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG12. */

/*! @brief Read current value of the CCM_CCGR4_CG12 field. */
#define BR_CCM_CCGR4_CG12(x) (HW_CCM_CCGR4(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR4_CG12. */
#define BF_CCM_CCGR4_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG12) & BM_CCM_CCGR4_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR4_CG12(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG12) | BF_CCM_CCGR4_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG13[27:26] (RW)
 *
 * rawnand_u_gpmi_bch_input_bch clock (rawnand_u_gpmi_bch_input_bch_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG13    (26U)         /*!< Bit position for CCM_CCGR4_CG13. */
#define BM_CCM_CCGR4_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR4_CG13. */
#define BS_CCM_CCGR4_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG13. */

/*! @brief Read current value of the CCM_CCGR4_CG13 field. */
#define BR_CCM_CCGR4_CG13(x) (HW_CCM_CCGR4(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR4_CG13. */
#define BF_CCM_CCGR4_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG13) & BM_CCM_CCGR4_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR4_CG13(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG13) | BF_CCM_CCGR4_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG14[29:28] (RW)
 *
 * rawnand_u_gpmi_bch_input_gpmi_io clock
 * (rawnand_u_gpmi_bch_input_gpmi_io_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG14    (28U)         /*!< Bit position for CCM_CCGR4_CG14. */
#define BM_CCM_CCGR4_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR4_CG14. */
#define BS_CCM_CCGR4_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG14. */

/*! @brief Read current value of the CCM_CCGR4_CG14 field. */
#define BR_CCM_CCGR4_CG14(x) (HW_CCM_CCGR4(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR4_CG14. */
#define BF_CCM_CCGR4_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG14) & BM_CCM_CCGR4_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR4_CG14(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG14) | BF_CCM_CCGR4_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR4, field CG15[31:30] (RW)
 *
 * rawnand_u_gpmi_input_apb clock (rawnand_u_gpmi_input_apb_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR4_CG15    (30U)         /*!< Bit position for CCM_CCGR4_CG15. */
#define BM_CCM_CCGR4_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR4_CG15. */
#define BS_CCM_CCGR4_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR4_CG15. */

/*! @brief Read current value of the CCM_CCGR4_CG15 field. */
#define BR_CCM_CCGR4_CG15(x) (HW_CCM_CCGR4(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR4_CG15. */
#define BF_CCM_CCGR4_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR4_CG15) & BM_CCM_CCGR4_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR4_CG15(x, v) (HW_CCM_CCGR4_WR(x, (HW_CCM_CCGR4_RD(x) & ~BM_CCM_CCGR4_CG15) | BF_CCM_CCGR4_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR5 - CCM Clock Gating Register 5
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR5 - CCM Clock Gating Register 5 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 5 (CCM_CCGR5). The
 * clock gating Registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required
 * is determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr5
{
    uint32_t U;
    struct _hw_ccm_ccgr5_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr5_t;

/*!
 * @name Constants and macros for entire CCM_CCGR5 register
 */
/*@{*/
#define HW_CCM_CCGR5_ADDR(x)     ((uintptr_t)(x) + 0x7CU)

#define HW_CCM_CCGR5(x)          (*(__IO hw_ccm_ccgr5_t *) HW_CCM_CCGR5_ADDR(x))
#define HW_CCM_CCGR5_RD(x)       (HW_CCM_CCGR5(x).U)
#define HW_CCM_CCGR5_WR(x, v)    (HW_CCM_CCGR5(x).U = (v))
#define HW_CCM_CCGR5_SET(x, v)   (HW_CCM_CCGR5_WR(x, HW_CCM_CCGR5_RD(x) |  (v)))
#define HW_CCM_CCGR5_CLR(x, v)   (HW_CCM_CCGR5_WR(x, HW_CCM_CCGR5_RD(x) & ~(v)))
#define HW_CCM_CCGR5_TOG(x, v)   (HW_CCM_CCGR5_WR(x, HW_CCM_CCGR5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR5 bitfields
 */

/*!
 * @name Register CCM_CCGR5, field CG0[1:0] (RW)
 *
 * rom clock (rom_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG0     (0U)          /*!< Bit position for CCM_CCGR5_CG0. */
#define BM_CCM_CCGR5_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR5_CG0. */
#define BS_CCM_CCGR5_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG0. */

/*! @brief Read current value of the CCM_CCGR5_CG0 field. */
#define BR_CCM_CCGR5_CG0(x)  (HW_CCM_CCGR5(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR5_CG0. */
#define BF_CCM_CCGR5_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG0) & BM_CCM_CCGR5_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR5_CG0(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG0) | BF_CCM_CCGR5_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG1[3:2] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG1     (2U)          /*!< Bit position for CCM_CCGR5_CG1. */
#define BM_CCM_CCGR5_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR5_CG1. */
#define BS_CCM_CCGR5_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG1. */

/*! @brief Read current value of the CCM_CCGR5_CG1 field. */
#define BR_CCM_CCGR5_CG1(x)  (HW_CCM_CCGR5(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR5_CG1. */
#define BF_CCM_CCGR5_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG1) & BM_CCM_CCGR5_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR5_CG1(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG1) | BF_CCM_CCGR5_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG2[5:4] (RW)
 *
 * sata clock (sata_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG2     (4U)          /*!< Bit position for CCM_CCGR5_CG2. */
#define BM_CCM_CCGR5_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR5_CG2. */
#define BS_CCM_CCGR5_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG2. */

/*! @brief Read current value of the CCM_CCGR5_CG2 field. */
#define BR_CCM_CCGR5_CG2(x)  (HW_CCM_CCGR5(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR5_CG2. */
#define BF_CCM_CCGR5_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG2) & BM_CCM_CCGR5_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR5_CG2(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG2) | BF_CCM_CCGR5_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG3[7:6] (RW)
 *
 * sdma clock (sdma_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG3     (6U)          /*!< Bit position for CCM_CCGR5_CG3. */
#define BM_CCM_CCGR5_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR5_CG3. */
#define BS_CCM_CCGR5_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG3. */

/*! @brief Read current value of the CCM_CCGR5_CG3 field. */
#define BR_CCM_CCGR5_CG3(x)  (HW_CCM_CCGR5(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR5_CG3. */
#define BF_CCM_CCGR5_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG3) & BM_CCM_CCGR5_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR5_CG3(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG3) | BF_CCM_CCGR5_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG4[9:8] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG4     (8U)          /*!< Bit position for CCM_CCGR5_CG4. */
#define BM_CCM_CCGR5_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR5_CG4. */
#define BS_CCM_CCGR5_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG4. */

/*! @brief Read current value of the CCM_CCGR5_CG4 field. */
#define BR_CCM_CCGR5_CG4(x)  (HW_CCM_CCGR5(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR5_CG4. */
#define BF_CCM_CCGR5_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG4) & BM_CCM_CCGR5_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR5_CG4(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG4) | BF_CCM_CCGR5_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG5[11:10] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG5     (10U)         /*!< Bit position for CCM_CCGR5_CG5. */
#define BM_CCM_CCGR5_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR5_CG5. */
#define BS_CCM_CCGR5_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG5. */

/*! @brief Read current value of the CCM_CCGR5_CG5 field. */
#define BR_CCM_CCGR5_CG5(x)  (HW_CCM_CCGR5(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR5_CG5. */
#define BF_CCM_CCGR5_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG5) & BM_CCM_CCGR5_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR5_CG5(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG5) | BF_CCM_CCGR5_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG6[13:12] (RW)
 *
 * spba clock (spba_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG6     (12U)         /*!< Bit position for CCM_CCGR5_CG6. */
#define BM_CCM_CCGR5_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR5_CG6. */
#define BS_CCM_CCGR5_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG6. */

/*! @brief Read current value of the CCM_CCGR5_CG6 field. */
#define BR_CCM_CCGR5_CG6(x)  (HW_CCM_CCGR5(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR5_CG6. */
#define BF_CCM_CCGR5_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG6) & BM_CCM_CCGR5_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR5_CG6(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG6) | BF_CCM_CCGR5_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG7[15:14] (RW)
 *
 * spdif clock (spdif_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG7     (14U)         /*!< Bit position for CCM_CCGR5_CG7. */
#define BM_CCM_CCGR5_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR5_CG7. */
#define BS_CCM_CCGR5_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG7. */

/*! @brief Read current value of the CCM_CCGR5_CG7 field. */
#define BR_CCM_CCGR5_CG7(x)  (HW_CCM_CCGR5(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR5_CG7. */
#define BF_CCM_CCGR5_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG7) & BM_CCM_CCGR5_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR5_CG7(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG7) | BF_CCM_CCGR5_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG8[17:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG8     (16U)         /*!< Bit position for CCM_CCGR5_CG8. */
#define BM_CCM_CCGR5_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR5_CG8. */
#define BS_CCM_CCGR5_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG8. */

/*! @brief Read current value of the CCM_CCGR5_CG8 field. */
#define BR_CCM_CCGR5_CG8(x)  (HW_CCM_CCGR5(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR5_CG8. */
#define BF_CCM_CCGR5_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG8) & BM_CCM_CCGR5_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR5_CG8(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG8) | BF_CCM_CCGR5_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG9[19:18] (RW)
 *
 * ssi1 clocks (ssi1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG9     (18U)         /*!< Bit position for CCM_CCGR5_CG9. */
#define BM_CCM_CCGR5_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR5_CG9. */
#define BS_CCM_CCGR5_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG9. */

/*! @brief Read current value of the CCM_CCGR5_CG9 field. */
#define BR_CCM_CCGR5_CG9(x)  (HW_CCM_CCGR5(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR5_CG9. */
#define BF_CCM_CCGR5_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG9) & BM_CCM_CCGR5_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR5_CG9(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG9) | BF_CCM_CCGR5_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG10[21:20] (RW)
 *
 * ssi2 clocks (ssi2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG10    (20U)         /*!< Bit position for CCM_CCGR5_CG10. */
#define BM_CCM_CCGR5_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR5_CG10. */
#define BS_CCM_CCGR5_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG10. */

/*! @brief Read current value of the CCM_CCGR5_CG10 field. */
#define BR_CCM_CCGR5_CG10(x) (HW_CCM_CCGR5(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR5_CG10. */
#define BF_CCM_CCGR5_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG10) & BM_CCM_CCGR5_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR5_CG10(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG10) | BF_CCM_CCGR5_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG11[23:22] (RW)
 *
 * ssi3 clocks (ssi3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG11    (22U)         /*!< Bit position for CCM_CCGR5_CG11. */
#define BM_CCM_CCGR5_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR5_CG11. */
#define BS_CCM_CCGR5_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG11. */

/*! @brief Read current value of the CCM_CCGR5_CG11 field. */
#define BR_CCM_CCGR5_CG11(x) (HW_CCM_CCGR5(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR5_CG11. */
#define BF_CCM_CCGR5_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG11) & BM_CCM_CCGR5_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR5_CG11(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG11) | BF_CCM_CCGR5_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG12[25:24] (RW)
 *
 * uart clock (uart_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG12    (24U)         /*!< Bit position for CCM_CCGR5_CG12. */
#define BM_CCM_CCGR5_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR5_CG12. */
#define BS_CCM_CCGR5_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG12. */

/*! @brief Read current value of the CCM_CCGR5_CG12 field. */
#define BR_CCM_CCGR5_CG12(x) (HW_CCM_CCGR5(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR5_CG12. */
#define BF_CCM_CCGR5_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG12) & BM_CCM_CCGR5_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR5_CG12(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG12) | BF_CCM_CCGR5_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG13[27:26] (RW)
 *
 * uart_serial clock (uart_serial_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR5_CG13    (26U)         /*!< Bit position for CCM_CCGR5_CG13. */
#define BM_CCM_CCGR5_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR5_CG13. */
#define BS_CCM_CCGR5_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG13. */

/*! @brief Read current value of the CCM_CCGR5_CG13 field. */
#define BR_CCM_CCGR5_CG13(x) (HW_CCM_CCGR5(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR5_CG13. */
#define BF_CCM_CCGR5_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG13) & BM_CCM_CCGR5_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR5_CG13(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG13) | BF_CCM_CCGR5_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG14[29:28] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG14    (28U)         /*!< Bit position for CCM_CCGR5_CG14. */
#define BM_CCM_CCGR5_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR5_CG14. */
#define BS_CCM_CCGR5_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG14. */

/*! @brief Read current value of the CCM_CCGR5_CG14 field. */
#define BR_CCM_CCGR5_CG14(x) (HW_CCM_CCGR5(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR5_CG14. */
#define BF_CCM_CCGR5_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG14) & BM_CCM_CCGR5_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR5_CG14(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG14) | BF_CCM_CCGR5_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR5, field CG15[31:30] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR5_CG15    (30U)         /*!< Bit position for CCM_CCGR5_CG15. */
#define BM_CCM_CCGR5_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR5_CG15. */
#define BS_CCM_CCGR5_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR5_CG15. */

/*! @brief Read current value of the CCM_CCGR5_CG15 field. */
#define BR_CCM_CCGR5_CG15(x) (HW_CCM_CCGR5(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR5_CG15. */
#define BF_CCM_CCGR5_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR5_CG15) & BM_CCM_CCGR5_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR5_CG15(x, v) (HW_CCM_CCGR5_WR(x, (HW_CCM_CCGR5_RD(x) & ~BM_CCM_CCGR5_CG15) | BF_CCM_CCGR5_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CCGR6 - CCM Clock Gating Register 6
 ******************************************************************************/

/*!
 * @brief HW_CCM_CCGR6 - CCM Clock Gating Register 6 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The figure below represents the CCM Clock Gating Register 6 (CCM_CCGR6). The
 * clock gating Registers define the clock gating for power reduction of each
 * clock (CG(i) bits). There are 8 CGR registers. The number of registers required
 * is determined by the number of peripherals in the system.
 */
typedef union _hw_ccm_ccgr6
{
    uint32_t U;
    struct _hw_ccm_ccgr6_bitfields
    {
        uint32_t CG0 : 2;              /*!< [1:0]  */
        uint32_t CG1 : 2;              /*!< [3:2]  */
        uint32_t CG2 : 2;              /*!< [5:4]  */
        uint32_t CG3 : 2;              /*!< [7:6]  */
        uint32_t CG4 : 2;              /*!< [9:8]  */
        uint32_t CG5 : 2;              /*!< [11:10]  */
        uint32_t CG6 : 2;              /*!< [13:12]  */
        uint32_t CG7 : 2;              /*!< [15:14]  */
        uint32_t CG8 : 2;              /*!< [17:16]  */
        uint32_t CG9 : 2;              /*!< [19:18]  */
        uint32_t CG10 : 2;             /*!< [21:20]  */
        uint32_t CG11 : 2;             /*!< [23:22]  */
        uint32_t CG12 : 2;             /*!< [25:24]  */
        uint32_t CG13 : 2;             /*!< [27:26]  */
        uint32_t CG14 : 2;             /*!< [29:28]  */
        uint32_t CG15 : 2;             /*!< [31:30]  */
    } B;
} hw_ccm_ccgr6_t;

/*!
 * @name Constants and macros for entire CCM_CCGR6 register
 */
/*@{*/
#define HW_CCM_CCGR6_ADDR(x)     ((uintptr_t)(x) + 0x80U)

#define HW_CCM_CCGR6(x)          (*(__IO hw_ccm_ccgr6_t *) HW_CCM_CCGR6_ADDR(x))
#define HW_CCM_CCGR6_RD(x)       (HW_CCM_CCGR6(x).U)
#define HW_CCM_CCGR6_WR(x, v)    (HW_CCM_CCGR6(x).U = (v))
#define HW_CCM_CCGR6_SET(x, v)   (HW_CCM_CCGR6_WR(x, HW_CCM_CCGR6_RD(x) |  (v)))
#define HW_CCM_CCGR6_CLR(x, v)   (HW_CCM_CCGR6_WR(x, HW_CCM_CCGR6_RD(x) & ~(v)))
#define HW_CCM_CCGR6_TOG(x, v)   (HW_CCM_CCGR6_WR(x, HW_CCM_CCGR6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CCGR6 bitfields
 */

/*!
 * @name Register CCM_CCGR6, field CG0[1:0] (RW)
 *
 * usboh3 clock (usboh3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG0     (0U)          /*!< Bit position for CCM_CCGR6_CG0. */
#define BM_CCM_CCGR6_CG0     (0x00000003U) /*!< Bit mask for CCM_CCGR6_CG0. */
#define BS_CCM_CCGR6_CG0     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG0. */

/*! @brief Read current value of the CCM_CCGR6_CG0 field. */
#define BR_CCM_CCGR6_CG0(x)  (HW_CCM_CCGR6(x).B.CG0)

/*! @brief Format value for bitfield CCM_CCGR6_CG0. */
#define BF_CCM_CCGR6_CG0(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG0) & BM_CCM_CCGR6_CG0)

/*! @brief Set the CG0 field to a new value. */
#define BW_CCM_CCGR6_CG0(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG0) | BF_CCM_CCGR6_CG0(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG1[3:2] (RW)
 *
 * usdhc1 clocks (usdhc1_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG1     (2U)          /*!< Bit position for CCM_CCGR6_CG1. */
#define BM_CCM_CCGR6_CG1     (0x0000000CU) /*!< Bit mask for CCM_CCGR6_CG1. */
#define BS_CCM_CCGR6_CG1     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG1. */

/*! @brief Read current value of the CCM_CCGR6_CG1 field. */
#define BR_CCM_CCGR6_CG1(x)  (HW_CCM_CCGR6(x).B.CG1)

/*! @brief Format value for bitfield CCM_CCGR6_CG1. */
#define BF_CCM_CCGR6_CG1(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG1) & BM_CCM_CCGR6_CG1)

/*! @brief Set the CG1 field to a new value. */
#define BW_CCM_CCGR6_CG1(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG1) | BF_CCM_CCGR6_CG1(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG2[5:4] (RW)
 *
 * usdhc2 clocks (usdhc2_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG2     (4U)          /*!< Bit position for CCM_CCGR6_CG2. */
#define BM_CCM_CCGR6_CG2     (0x00000030U) /*!< Bit mask for CCM_CCGR6_CG2. */
#define BS_CCM_CCGR6_CG2     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG2. */

/*! @brief Read current value of the CCM_CCGR6_CG2 field. */
#define BR_CCM_CCGR6_CG2(x)  (HW_CCM_CCGR6(x).B.CG2)

/*! @brief Format value for bitfield CCM_CCGR6_CG2. */
#define BF_CCM_CCGR6_CG2(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG2) & BM_CCM_CCGR6_CG2)

/*! @brief Set the CG2 field to a new value. */
#define BW_CCM_CCGR6_CG2(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG2) | BF_CCM_CCGR6_CG2(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG3[7:6] (RW)
 *
 * usdhc3 clocks (usdhc3_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG3     (6U)          /*!< Bit position for CCM_CCGR6_CG3. */
#define BM_CCM_CCGR6_CG3     (0x000000C0U) /*!< Bit mask for CCM_CCGR6_CG3. */
#define BS_CCM_CCGR6_CG3     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG3. */

/*! @brief Read current value of the CCM_CCGR6_CG3 field. */
#define BR_CCM_CCGR6_CG3(x)  (HW_CCM_CCGR6(x).B.CG3)

/*! @brief Format value for bitfield CCM_CCGR6_CG3. */
#define BF_CCM_CCGR6_CG3(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG3) & BM_CCM_CCGR6_CG3)

/*! @brief Set the CG3 field to a new value. */
#define BW_CCM_CCGR6_CG3(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG3) | BF_CCM_CCGR6_CG3(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG4[9:8] (RW)
 *
 * usdhc4 clocks (usdhc4_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG4     (8U)          /*!< Bit position for CCM_CCGR6_CG4. */
#define BM_CCM_CCGR6_CG4     (0x00000300U) /*!< Bit mask for CCM_CCGR6_CG4. */
#define BS_CCM_CCGR6_CG4     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG4. */

/*! @brief Read current value of the CCM_CCGR6_CG4 field. */
#define BR_CCM_CCGR6_CG4(x)  (HW_CCM_CCGR6(x).B.CG4)

/*! @brief Format value for bitfield CCM_CCGR6_CG4. */
#define BF_CCM_CCGR6_CG4(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG4) & BM_CCM_CCGR6_CG4)

/*! @brief Set the CG4 field to a new value. */
#define BW_CCM_CCGR6_CG4(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG4) | BF_CCM_CCGR6_CG4(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG5[11:10] (RW)
 *
 * eim_slow clocks (eim_slow_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG5     (10U)         /*!< Bit position for CCM_CCGR6_CG5. */
#define BM_CCM_CCGR6_CG5     (0x00000C00U) /*!< Bit mask for CCM_CCGR6_CG5. */
#define BS_CCM_CCGR6_CG5     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG5. */

/*! @brief Read current value of the CCM_CCGR6_CG5 field. */
#define BR_CCM_CCGR6_CG5(x)  (HW_CCM_CCGR6(x).B.CG5)

/*! @brief Format value for bitfield CCM_CCGR6_CG5. */
#define BF_CCM_CCGR6_CG5(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG5) & BM_CCM_CCGR6_CG5)

/*! @brief Set the CG5 field to a new value. */
#define BW_CCM_CCGR6_CG5(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG5) | BF_CCM_CCGR6_CG5(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG6[13:12] (RW)
 *
 * vdoaxiclk root clock (vdoaxiclk_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG6     (12U)         /*!< Bit position for CCM_CCGR6_CG6. */
#define BM_CCM_CCGR6_CG6     (0x00003000U) /*!< Bit mask for CCM_CCGR6_CG6. */
#define BS_CCM_CCGR6_CG6     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG6. */

/*! @brief Read current value of the CCM_CCGR6_CG6 field. */
#define BR_CCM_CCGR6_CG6(x)  (HW_CCM_CCGR6(x).B.CG6)

/*! @brief Format value for bitfield CCM_CCGR6_CG6. */
#define BF_CCM_CCGR6_CG6(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG6) & BM_CCM_CCGR6_CG6)

/*! @brief Set the CG6 field to a new value. */
#define BW_CCM_CCGR6_CG6(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG6) | BF_CCM_CCGR6_CG6(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG7[15:14] (RW)
 *
 * vpu clocks (vpu_clk_enable)
 */
/*@{*/
#define BP_CCM_CCGR6_CG7     (14U)         /*!< Bit position for CCM_CCGR6_CG7. */
#define BM_CCM_CCGR6_CG7     (0x0000C000U) /*!< Bit mask for CCM_CCGR6_CG7. */
#define BS_CCM_CCGR6_CG7     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG7. */

/*! @brief Read current value of the CCM_CCGR6_CG7 field. */
#define BR_CCM_CCGR6_CG7(x)  (HW_CCM_CCGR6(x).B.CG7)

/*! @brief Format value for bitfield CCM_CCGR6_CG7. */
#define BF_CCM_CCGR6_CG7(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG7) & BM_CCM_CCGR6_CG7)

/*! @brief Set the CG7 field to a new value. */
#define BW_CCM_CCGR6_CG7(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG7) | BF_CCM_CCGR6_CG7(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG8[17:16] (RW)
 *
 * pre_clk_enable[0]
 */
/*@{*/
#define BP_CCM_CCGR6_CG8     (16U)         /*!< Bit position for CCM_CCGR6_CG8. */
#define BM_CCM_CCGR6_CG8     (0x00030000U) /*!< Bit mask for CCM_CCGR6_CG8. */
#define BS_CCM_CCGR6_CG8     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG8. */

/*! @brief Read current value of the CCM_CCGR6_CG8 field. */
#define BR_CCM_CCGR6_CG8(x)  (HW_CCM_CCGR6(x).B.CG8)

/*! @brief Format value for bitfield CCM_CCGR6_CG8. */
#define BF_CCM_CCGR6_CG8(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG8) & BM_CCM_CCGR6_CG8)

/*! @brief Set the CG8 field to a new value. */
#define BW_CCM_CCGR6_CG8(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG8) | BF_CCM_CCGR6_CG8(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG9[19:18] (RW)
 *
 * pre_clk_enable[1]
 */
/*@{*/
#define BP_CCM_CCGR6_CG9     (18U)         /*!< Bit position for CCM_CCGR6_CG9. */
#define BM_CCM_CCGR6_CG9     (0x000C0000U) /*!< Bit mask for CCM_CCGR6_CG9. */
#define BS_CCM_CCGR6_CG9     (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG9. */

/*! @brief Read current value of the CCM_CCGR6_CG9 field. */
#define BR_CCM_CCGR6_CG9(x)  (HW_CCM_CCGR6(x).B.CG9)

/*! @brief Format value for bitfield CCM_CCGR6_CG9. */
#define BF_CCM_CCGR6_CG9(v)  ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG9) & BM_CCM_CCGR6_CG9)

/*! @brief Set the CG9 field to a new value. */
#define BW_CCM_CCGR6_CG9(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG9) | BF_CCM_CCGR6_CG9(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG10[21:20] (RW)
 *
 * pre_clk_enable[2]
 */
/*@{*/
#define BP_CCM_CCGR6_CG10    (20U)         /*!< Bit position for CCM_CCGR6_CG10. */
#define BM_CCM_CCGR6_CG10    (0x00300000U) /*!< Bit mask for CCM_CCGR6_CG10. */
#define BS_CCM_CCGR6_CG10    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG10. */

/*! @brief Read current value of the CCM_CCGR6_CG10 field. */
#define BR_CCM_CCGR6_CG10(x) (HW_CCM_CCGR6(x).B.CG10)

/*! @brief Format value for bitfield CCM_CCGR6_CG10. */
#define BF_CCM_CCGR6_CG10(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG10) & BM_CCM_CCGR6_CG10)

/*! @brief Set the CG10 field to a new value. */
#define BW_CCM_CCGR6_CG10(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG10) | BF_CCM_CCGR6_CG10(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG11[23:22] (RW)
 *
 * pre_clk_enable[3]
 */
/*@{*/
#define BP_CCM_CCGR6_CG11    (22U)         /*!< Bit position for CCM_CCGR6_CG11. */
#define BM_CCM_CCGR6_CG11    (0x00C00000U) /*!< Bit mask for CCM_CCGR6_CG11. */
#define BS_CCM_CCGR6_CG11    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG11. */

/*! @brief Read current value of the CCM_CCGR6_CG11 field. */
#define BR_CCM_CCGR6_CG11(x) (HW_CCM_CCGR6(x).B.CG11)

/*! @brief Format value for bitfield CCM_CCGR6_CG11. */
#define BF_CCM_CCGR6_CG11(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG11) & BM_CCM_CCGR6_CG11)

/*! @brief Set the CG11 field to a new value. */
#define BW_CCM_CCGR6_CG11(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG11) | BF_CCM_CCGR6_CG11(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG12[25:24] (RW)
 *
 * prg_clk_enable[0]
 */
/*@{*/
#define BP_CCM_CCGR6_CG12    (24U)         /*!< Bit position for CCM_CCGR6_CG12. */
#define BM_CCM_CCGR6_CG12    (0x03000000U) /*!< Bit mask for CCM_CCGR6_CG12. */
#define BS_CCM_CCGR6_CG12    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG12. */

/*! @brief Read current value of the CCM_CCGR6_CG12 field. */
#define BR_CCM_CCGR6_CG12(x) (HW_CCM_CCGR6(x).B.CG12)

/*! @brief Format value for bitfield CCM_CCGR6_CG12. */
#define BF_CCM_CCGR6_CG12(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG12) & BM_CCM_CCGR6_CG12)

/*! @brief Set the CG12 field to a new value. */
#define BW_CCM_CCGR6_CG12(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG12) | BF_CCM_CCGR6_CG12(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG13[27:26] (RW)
 *
 * prg_clk_enable[1]
 */
/*@{*/
#define BP_CCM_CCGR6_CG13    (26U)         /*!< Bit position for CCM_CCGR6_CG13. */
#define BM_CCM_CCGR6_CG13    (0x0C000000U) /*!< Bit mask for CCM_CCGR6_CG13. */
#define BS_CCM_CCGR6_CG13    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG13. */

/*! @brief Read current value of the CCM_CCGR6_CG13 field. */
#define BR_CCM_CCGR6_CG13(x) (HW_CCM_CCGR6(x).B.CG13)

/*! @brief Format value for bitfield CCM_CCGR6_CG13. */
#define BF_CCM_CCGR6_CG13(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG13) & BM_CCM_CCGR6_CG13)

/*! @brief Set the CG13 field to a new value. */
#define BW_CCM_CCGR6_CG13(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG13) | BF_CCM_CCGR6_CG13(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG14[29:28] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR6_CG14    (28U)         /*!< Bit position for CCM_CCGR6_CG14. */
#define BM_CCM_CCGR6_CG14    (0x30000000U) /*!< Bit mask for CCM_CCGR6_CG14. */
#define BS_CCM_CCGR6_CG14    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG14. */

/*! @brief Read current value of the CCM_CCGR6_CG14 field. */
#define BR_CCM_CCGR6_CG14(x) (HW_CCM_CCGR6(x).B.CG14)

/*! @brief Format value for bitfield CCM_CCGR6_CG14. */
#define BF_CCM_CCGR6_CG14(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG14) & BM_CCM_CCGR6_CG14)

/*! @brief Set the CG14 field to a new value. */
#define BW_CCM_CCGR6_CG14(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG14) | BF_CCM_CCGR6_CG14(v)))
/*@}*/

/*!
 * @name Register CCM_CCGR6, field CG15[31:30] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_CCGR6_CG15    (30U)         /*!< Bit position for CCM_CCGR6_CG15. */
#define BM_CCM_CCGR6_CG15    (0xC0000000U) /*!< Bit mask for CCM_CCGR6_CG15. */
#define BS_CCM_CCGR6_CG15    (2U)          /*!< Bit field size in bits for CCM_CCGR6_CG15. */

/*! @brief Read current value of the CCM_CCGR6_CG15 field. */
#define BR_CCM_CCGR6_CG15(x) (HW_CCM_CCGR6(x).B.CG15)

/*! @brief Format value for bitfield CCM_CCGR6_CG15. */
#define BF_CCM_CCGR6_CG15(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CCGR6_CG15) & BM_CCM_CCGR6_CG15)

/*! @brief Set the CG15 field to a new value. */
#define BW_CCM_CCGR6_CG15(x, v) (HW_CCM_CCGR6_WR(x, (HW_CCM_CCGR6_RD(x) & ~BM_CCM_CCGR6_CG15) | BF_CCM_CCGR6_CG15(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_CMEOR - CCM Module Enable Overide Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_CMEOR - CCM Module Enable Overide Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The following figure represents the CCM Module Enable Override Register
 * (CMEOR). The CMEOR register contains bits to override the clock enable signal from
 * the module. This bit is applicable only for modules whose clock enable signals
 * are used. The following table provides its field descriptions.
 */
typedef union _hw_ccm_cmeor
{
    uint32_t U;
    struct _hw_ccm_cmeor_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t mod_en_ov_vdoa : 1;   /*!< [4]  */
        uint32_t mod_en_ov_gpt : 1;    /*!< [5]  */
        uint32_t mod_en_ov_epit : 1;   /*!< [6]  */
        uint32_t mod_en_usdhc : 1;     /*!< [7]  */
        uint32_t mod_en_ov_dap : 1;    /*!< [8]  */
        uint32_t mod_en_ov_vpu : 1;    /*!< [9]  */
        uint32_t mod_en_ov_gpu2d : 1;  /*!< [10]  */
        uint32_t mod_en_ov_gpu3d : 1;  /*!< [11]  */
        uint32_t RESERVED1 : 16;       /*!< [27:12]  */
        uint32_t mod_en_ov_can2_cpi : 1; /*!< [28]  */
        uint32_t RESERVED2 : 1;        /*!< [29]  */
        uint32_t mod_en_ov_can1_cpi : 1; /*!< [30]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_ccm_cmeor_t;

/*!
 * @name Constants and macros for entire CCM_CMEOR register
 */
/*@{*/
#define HW_CCM_CMEOR_ADDR(x)     ((uintptr_t)(x) + 0x88U)

#define HW_CCM_CMEOR(x)          (*(__IO hw_ccm_cmeor_t *) HW_CCM_CMEOR_ADDR(x))
#define HW_CCM_CMEOR_RD(x)       (HW_CCM_CMEOR(x).U)
#define HW_CCM_CMEOR_WR(x, v)    (HW_CCM_CMEOR(x).U = (v))
#define HW_CCM_CMEOR_SET(x, v)   (HW_CCM_CMEOR_WR(x, HW_CCM_CMEOR_RD(x) |  (v)))
#define HW_CCM_CMEOR_CLR(x, v)   (HW_CCM_CMEOR_WR(x, HW_CCM_CMEOR_RD(x) & ~(v)))
#define HW_CCM_CMEOR_TOG(x, v)   (HW_CCM_CMEOR_WR(x, HW_CCM_CMEOR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_CMEOR bitfields
 */

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_vdoa[4] (RW)
 *
 * Overide clock enable signal from vdoa - clock will not be gated based on vdoa
 * signal.
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_vdoa (4U)   /*!< Bit position for CCM_CMEOR_mod_en_ov_vdoa. */
#define BM_CCM_CMEOR_mod_en_ov_vdoa (0x00000010U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_vdoa. */
#define BS_CCM_CMEOR_mod_en_ov_vdoa (1U)   /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_vdoa. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_vdoa field. */
#define BR_CCM_CMEOR_mod_en_ov_vdoa(x) (HW_CCM_CMEOR(x).B.mod_en_ov_vdoa)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_vdoa. */
#define BF_CCM_CMEOR_mod_en_ov_vdoa(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_vdoa) & BM_CCM_CMEOR_mod_en_ov_vdoa)

/*! @brief Set the mod_en_ov_vdoa field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_vdoa(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_vdoa) | BF_CCM_CMEOR_mod_en_ov_vdoa(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_gpt[5] (RW)
 *
 * Overide clock enable signal from GPT - clock will not be gated based on GPT's
 * signal 'ipg_enable_clk' .
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_gpt (5U)    /*!< Bit position for CCM_CMEOR_mod_en_ov_gpt. */
#define BM_CCM_CMEOR_mod_en_ov_gpt (0x00000020U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_gpt. */
#define BS_CCM_CMEOR_mod_en_ov_gpt (1U)    /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_gpt. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_gpt field. */
#define BR_CCM_CMEOR_mod_en_ov_gpt(x) (HW_CCM_CMEOR(x).B.mod_en_ov_gpt)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_gpt. */
#define BF_CCM_CMEOR_mod_en_ov_gpt(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_gpt) & BM_CCM_CMEOR_mod_en_ov_gpt)

/*! @brief Set the mod_en_ov_gpt field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_gpt(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_gpt) | BF_CCM_CMEOR_mod_en_ov_gpt(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_epit[6] (RW)
 *
 * Overide clock enable signal from EPIT - clock will not be gated based on
 * EPIT's signal 'ipg_enable_clk' .
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_epit (6U)   /*!< Bit position for CCM_CMEOR_mod_en_ov_epit. */
#define BM_CCM_CMEOR_mod_en_ov_epit (0x00000040U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_epit. */
#define BS_CCM_CMEOR_mod_en_ov_epit (1U)   /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_epit. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_epit field. */
#define BR_CCM_CMEOR_mod_en_ov_epit(x) (HW_CCM_CMEOR(x).B.mod_en_ov_epit)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_epit. */
#define BF_CCM_CMEOR_mod_en_ov_epit(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_epit) & BM_CCM_CMEOR_mod_en_ov_epit)

/*! @brief Set the mod_en_ov_epit field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_epit(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_epit) | BF_CCM_CMEOR_mod_en_ov_epit(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_usdhc[7] (RW)
 *
 * Overide clock enable signal from USDHC.
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_usdhc (7U)     /*!< Bit position for CCM_CMEOR_mod_en_usdhc. */
#define BM_CCM_CMEOR_mod_en_usdhc (0x00000080U) /*!< Bit mask for CCM_CMEOR_mod_en_usdhc. */
#define BS_CCM_CMEOR_mod_en_usdhc (1U)     /*!< Bit field size in bits for CCM_CMEOR_mod_en_usdhc. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_usdhc field. */
#define BR_CCM_CMEOR_mod_en_usdhc(x) (HW_CCM_CMEOR(x).B.mod_en_usdhc)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_usdhc. */
#define BF_CCM_CMEOR_mod_en_usdhc(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_usdhc) & BM_CCM_CMEOR_mod_en_usdhc)

/*! @brief Set the mod_en_usdhc field to a new value. */
#define BW_CCM_CMEOR_mod_en_usdhc(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_usdhc) | BF_CCM_CMEOR_mod_en_usdhc(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_dap[8] (RW)
 *
 * Overide clock enable signal from DAP- clock will not be gated based on DAP's
 * signal 'dap_dbgen' .
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_dap (8U)    /*!< Bit position for CCM_CMEOR_mod_en_ov_dap. */
#define BM_CCM_CMEOR_mod_en_ov_dap (0x00000100U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_dap. */
#define BS_CCM_CMEOR_mod_en_ov_dap (1U)    /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_dap. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_dap field. */
#define BR_CCM_CMEOR_mod_en_ov_dap(x) (HW_CCM_CMEOR(x).B.mod_en_ov_dap)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_dap. */
#define BF_CCM_CMEOR_mod_en_ov_dap(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_dap) & BM_CCM_CMEOR_mod_en_ov_dap)

/*! @brief Set the mod_en_ov_dap field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_dap(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_dap) | BF_CCM_CMEOR_mod_en_ov_dap(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_vpu[9] (RW)
 *
 * Overide clock enable signal from VPU- clock will not be gated based on VPU's
 * signal 'vpu_idle' .
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_vpu (9U)    /*!< Bit position for CCM_CMEOR_mod_en_ov_vpu. */
#define BM_CCM_CMEOR_mod_en_ov_vpu (0x00000200U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_vpu. */
#define BS_CCM_CMEOR_mod_en_ov_vpu (1U)    /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_vpu. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_vpu field. */
#define BR_CCM_CMEOR_mod_en_ov_vpu(x) (HW_CCM_CMEOR(x).B.mod_en_ov_vpu)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_vpu. */
#define BF_CCM_CMEOR_mod_en_ov_vpu(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_vpu) & BM_CCM_CMEOR_mod_en_ov_vpu)

/*! @brief Set the mod_en_ov_vpu field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_vpu(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_vpu) | BF_CCM_CMEOR_mod_en_ov_vpu(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_gpu2d[10] (RW)
 *
 * Overide clock enable signal from GPU2D - clock will not be gated based on
 * GPU's signal 'gpu2d_busy' .
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_gpu2d (10U) /*!< Bit position for CCM_CMEOR_mod_en_ov_gpu2d. */
#define BM_CCM_CMEOR_mod_en_ov_gpu2d (0x00000400U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_gpu2d. */
#define BS_CCM_CMEOR_mod_en_ov_gpu2d (1U)  /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_gpu2d. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_gpu2d field. */
#define BR_CCM_CMEOR_mod_en_ov_gpu2d(x) (HW_CCM_CMEOR(x).B.mod_en_ov_gpu2d)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_gpu2d. */
#define BF_CCM_CMEOR_mod_en_ov_gpu2d(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_gpu2d) & BM_CCM_CMEOR_mod_en_ov_gpu2d)

/*! @brief Set the mod_en_ov_gpu2d field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_gpu2d(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_gpu2d) | BF_CCM_CMEOR_mod_en_ov_gpu2d(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_gpu3d[11] (RW)
 *
 * Overide clock enable signal from GPU3D - clock will not be gated based on
 * GPU3D's signal.
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_gpu3d (11U) /*!< Bit position for CCM_CMEOR_mod_en_ov_gpu3d. */
#define BM_CCM_CMEOR_mod_en_ov_gpu3d (0x00000800U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_gpu3d. */
#define BS_CCM_CMEOR_mod_en_ov_gpu3d (1U)  /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_gpu3d. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_gpu3d field. */
#define BR_CCM_CMEOR_mod_en_ov_gpu3d(x) (HW_CCM_CMEOR(x).B.mod_en_ov_gpu3d)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_gpu3d. */
#define BF_CCM_CMEOR_mod_en_ov_gpu3d(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_gpu3d) & BM_CCM_CMEOR_mod_en_ov_gpu3d)

/*! @brief Set the mod_en_ov_gpu3d field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_gpu3d(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_gpu3d) | BF_CCM_CMEOR_mod_en_ov_gpu3d(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_can2_cpi[28] (RW)
 *
 * Overide clock enable signal from CAN2 - clock will not be gated based on
 * CAN's signal 'enable_clk_cpi'.
 *
 * Values:
 * - 0 - don't override module enable signal
 * - 1 - override module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_can2_cpi (28U) /*!< Bit position for CCM_CMEOR_mod_en_ov_can2_cpi. */
#define BM_CCM_CMEOR_mod_en_ov_can2_cpi (0x10000000U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_can2_cpi. */
#define BS_CCM_CMEOR_mod_en_ov_can2_cpi (1U) /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_can2_cpi. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_can2_cpi field. */
#define BR_CCM_CMEOR_mod_en_ov_can2_cpi(x) (HW_CCM_CMEOR(x).B.mod_en_ov_can2_cpi)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_can2_cpi. */
#define BF_CCM_CMEOR_mod_en_ov_can2_cpi(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_can2_cpi) & BM_CCM_CMEOR_mod_en_ov_can2_cpi)

/*! @brief Set the mod_en_ov_can2_cpi field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_can2_cpi(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_can2_cpi) | BF_CCM_CMEOR_mod_en_ov_can2_cpi(v)))
/*@}*/

/*!
 * @name Register CCM_CMEOR, field mod_en_ov_can1_cpi[30] (RW)
 *
 * Overide clock enable signal from CAN1 - clock will not be gated based on
 * CAN's signal 'enable_clk_cpi'.
 *
 * Values:
 * - 0 - don't overide module enable signal
 * - 1 - overide module enable signal
 */
/*@{*/
#define BP_CCM_CMEOR_mod_en_ov_can1_cpi (30U) /*!< Bit position for CCM_CMEOR_mod_en_ov_can1_cpi. */
#define BM_CCM_CMEOR_mod_en_ov_can1_cpi (0x40000000U) /*!< Bit mask for CCM_CMEOR_mod_en_ov_can1_cpi. */
#define BS_CCM_CMEOR_mod_en_ov_can1_cpi (1U) /*!< Bit field size in bits for CCM_CMEOR_mod_en_ov_can1_cpi. */

/*! @brief Read current value of the CCM_CMEOR_mod_en_ov_can1_cpi field. */
#define BR_CCM_CMEOR_mod_en_ov_can1_cpi(x) (HW_CCM_CMEOR(x).B.mod_en_ov_can1_cpi)

/*! @brief Format value for bitfield CCM_CMEOR_mod_en_ov_can1_cpi. */
#define BF_CCM_CMEOR_mod_en_ov_can1_cpi(v) ((uint32_t)((uint32_t)(v) << BP_CCM_CMEOR_mod_en_ov_can1_cpi) & BM_CCM_CMEOR_mod_en_ov_can1_cpi)

/*! @brief Set the mod_en_ov_can1_cpi field to a new value. */
#define BW_CCM_CMEOR_mod_en_ov_can1_cpi(x, v) (HW_CCM_CMEOR_WR(x, (HW_CCM_CMEOR_RD(x) & ~BM_CCM_CMEOR_mod_en_ov_can1_cpi) | BF_CCM_CMEOR_mod_en_ov_can1_cpi(v)))
/*@}*/

/*******************************************************************************
 * hw_ccm_t - module struct
 ******************************************************************************/
/*!
 * @brief All CCM module registers.
 */
#pragma pack(1)
typedef struct _hw_ccm
{
    __IO hw_ccm_ccr_t CCR;                 /*!< [0x0] CCM Control Register */
    __IO hw_ccm_ccdr_t CCDR;               /*!< [0x4] CCM Control Divider Register */
    __I hw_ccm_csr_t CSR;                  /*!< [0x8] CCM Status Register */
    __IO hw_ccm_ccsr_t CCSR;               /*!< [0xC] CCM Clock Switcher Register */
    __IO hw_ccm_cacrr_t CACRR;             /*!< [0x10] CCM Arm Clock Root Register */
    __IO hw_ccm_cbcdr_t CBCDR;             /*!< [0x14] CCM Bus Clock Divider Register */
    __IO hw_ccm_cbcmr_t CBCMR;             /*!< [0x18] CCM Bus Clock Multiplexer Register */
    __IO hw_ccm_cscmr1_t CSCMR1;           /*!< [0x1C] CCM Serial Clock Multiplexer Register 1 */
    __IO hw_ccm_cscmr2_t CSCMR2;           /*!< [0x20] CCM Serial Clock Multiplexer Register 2 */
    __IO hw_ccm_cscdr1_t CSCDR1;           /*!< [0x24] CCM Serial Clock Divider Register 1 */
    __IO hw_ccm_cs1cdr_t CS1CDR;           /*!< [0x28] CCM SSI1 Clock Divider Register */
    __IO hw_ccm_cs2cdr_t CS2CDR;           /*!< [0x2C] CCM SSI2 Clock Divider Register */
    __IO hw_ccm_cdcdr_t CDCDR;             /*!< [0x30] CCM D1 Clock Divider Register */
    __IO hw_ccm_chsccdr_t CHSCCDR;         /*!< [0x34] CCM HSC Clock Divider Register */
    __IO hw_ccm_cscdr2_t CSCDR2;           /*!< [0x38] CCM Serial Clock Divider Register 2 */
    __IO hw_ccm_cscdr3_t CSCDR3;           /*!< [0x3C] CCM Serial Clock Divider Register 3 */
    uint8_t _reserved0[4];
    __I hw_ccm_cwdr_t CWDR;                /*!< [0x44] CCM Wakeup Detector Register */
    __I hw_ccm_cdhipr_t CDHIPR;            /*!< [0x48] CCM Divider Handshake In-Process Register */
    uint8_t _reserved1[8];
    __IO hw_ccm_clpcr_t CLPCR;             /*!< [0x54] CCM Low Power Control Register */
    __IO hw_ccm_cisr_t CISR;               /*!< [0x58] CCM Interrupt Status Register */
    __IO hw_ccm_cimr_t CIMR;               /*!< [0x5C] CCM Interrupt Mask Register */
    __IO hw_ccm_ccosr_t CCOSR;             /*!< [0x60] CCM Clock Output Source Register */
    __IO hw_ccm_cgpr_t CGPR;               /*!< [0x64] CCM General Purpose Register */
    __IO hw_ccm_ccgr0_t CCGR0;             /*!< [0x68] CCM Clock Gating Register 0 */
    __IO hw_ccm_ccgr1_t CCGR1;             /*!< [0x6C] CCM Clock Gating Register 1 */
    __IO hw_ccm_ccgr2_t CCGR2;             /*!< [0x70] CCM Clock Gating Register 2 */
    __IO hw_ccm_ccgr3_t CCGR3;             /*!< [0x74] CCM Clock Gating Register 3 */
    __IO hw_ccm_ccgr4_t CCGR4;             /*!< [0x78] CCM Clock Gating Register 4 */
    __IO hw_ccm_ccgr5_t CCGR5;             /*!< [0x7C] CCM Clock Gating Register 5 */
    __IO hw_ccm_ccgr6_t CCGR6;             /*!< [0x80] CCM Clock Gating Register 6 */
    uint8_t _reserved2[4];
    __IO hw_ccm_cmeor_t CMEOR;             /*!< [0x88] CCM Module Enable Overide Register */
} hw_ccm_t;
#pragma pack()

/*! @brief Macro to access all CCM registers. */
/*! @param x CCM module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_CCM_REGS(CCM_BASE)</code>. */
#define HW_CCM_REGS(x) (*(hw_ccm_t *)(x))

/*
 * iMX6DP CCM_ANALOG
 *
 * CCM_ANALOG
 *
 * Registers defined in this header file:
 * - HW_CCM_ANALOG_PLL_ARM - Analog ARM PLL control Register
 * - HW_CCM_ANALOG_PLL_USB1 - Analog USB1 480MHz PLL Control Register
 * - HW_CCM_ANALOG_PLL_USB2 - Analog USB2 480MHz PLL Control Register
 * - HW_CCM_ANALOG_PLL_SYS - Analog System PLL Control Register
 * - HW_CCM_ANALOG_PLL_SYS_SS - 528MHz System PLL Spread Spectrum Register
 * - HW_CCM_ANALOG_PLL_SYS_NUM - Numerator of 528MHz System PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_SYS_DENOM - Denominator of 528MHz System PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_AUDIO - Analog Audio PLL control Register
 * - HW_CCM_ANALOG_PLL_AUDIO_NUM - Numerator of Audio PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_AUDIO_DENOM - Denominator of Audio PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_VIDEO - Analog Video PLL control Register
 * - HW_CCM_ANALOG_PLL_VIDEO_NUM - Numerator of Video PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_VIDEO_DENOM - Denominator of Video PLL Fractional Loop Divider Register
 * - HW_CCM_ANALOG_PLL_MLB - MLB PLL Control Register
 * - HW_CCM_ANALOG_PLL_ENET - Analog ENET PLL Control Register
 * - HW_CCM_ANALOG_PFD_480 - 480MHz Clock (PLL3) Phase Fractional Divider Control Register
 * - HW_CCM_ANALOG_PFD_528 - 528MHz Clock (PLL2) Phase Fractional Divider Control Register
 * - HW_CCM_ANALOG_MISC0 - Miscellaneous Register 0
 * - HW_CCM_ANALOG_MISC1 - Miscellaneous Register 1
 * - HW_CCM_ANALOG_MISC2 - Miscellaneous Register 2
 *
 * - hw_ccm_analog_t - Struct containing all module registers.
 */

#define HW_CCM_ANALOG_INSTANCE_COUNT (1U) /*!< Number of instances of the CCM_ANALOG module. */
#define HW_CCM_ANALOG (0U) /*!< Instance number for CCM_ANALOG. */
#define CCM_ANALOG_BASE       (0x20C8000U) /*!< Base address for CCM_ANALOG. */
/*! Array initializer of CCM_ANALOG base addresses. */
#define CCM_ANALOG_BASE_ADDRS { CCM_ANALOG_BASE }

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_ARM - Analog ARM PLL control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_ARM - Analog ARM PLL control Register (RW)
 *
 * Reset value: 0x00013042U
 *
 * The control register provides control for the system PLL.
 */
typedef union _hw_ccm_analog_pll_arm
{
    uint32_t U;
    struct _hw_ccm_analog_pll_arm_bitfields
    {
        uint32_t DIV_SELECT : 7;       /*!< [6:0]  */
        uint32_t RESERVED0 : 5;        /*!< [11:7]  */
        uint32_t POWERDOWN : 1;        /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t LVDS_SEL : 1;         /*!< [17]  */
        uint32_t LVDS_24MHZ_SEL : 1;   /*!< [18]  */
        uint32_t PLL_SEL : 1;          /*!< [19]  */
        uint32_t RESERVED1 : 11;       /*!< [30:20]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_arm_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_ARM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_ARM_ADDR(x) ((uintptr_t)(x) + 0x0U)
#define HW_CCM_ANALOG_PLL_ARM_SET_ADDR(x) (HW_CCM_ANALOG_PLL_ARM_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_ARM_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_ARM_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_ARM_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_ARM_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_ARM(x) (*(__IO hw_ccm_analog_pll_arm_t *) HW_CCM_ANALOG_PLL_ARM_ADDR(x))
#define HW_CCM_ANALOG_PLL_ARM_RD(x) (HW_CCM_ANALOG_PLL_ARM(x).U)
#define HW_CCM_ANALOG_PLL_ARM_WR(x, v) (HW_CCM_ANALOG_PLL_ARM(x).U = (v))
#define HW_CCM_ANALOG_PLL_ARM_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ARM_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_ARM_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ARM_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_ARM_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ARM_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_ARM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field DIV_SELECT[6:0] (RW)
 *
 * This field controls the PLL loop divider. Valid range for divider value:
 * 54-108. Fout = Fin * div_select/2.0.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_ARM_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_ARM_DIV_SELECT (0x0000007FU) /*!< Bit mask for CCM_ANALOG_PLL_ARM_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_ARM_DIV_SELECT (7U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_ARM_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_ARM(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_ARM_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_DIV_SELECT) & BM_CCM_ANALOG_PLL_ARM_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_DIV_SELECT) | BF_CCM_ANALOG_PLL_ARM_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field POWERDOWN[12] (RW)
 *
 * Powers down the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_POWERDOWN (12U) /*!< Bit position for CCM_ANALOG_PLL_ARM_POWERDOWN. */
#define BM_CCM_ANALOG_PLL_ARM_POWERDOWN (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_POWERDOWN. */
#define BS_CCM_ANALOG_PLL_ARM_POWERDOWN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_POWERDOWN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_POWERDOWN field. */
#define BR_CCM_ANALOG_PLL_ARM_POWERDOWN(x) (HW_CCM_ANALOG_PLL_ARM(x).B.POWERDOWN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_POWERDOWN. */
#define BF_CCM_ANALOG_PLL_ARM_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_POWERDOWN) & BM_CCM_ANALOG_PLL_ARM_POWERDOWN)

/*! @brief Set the POWERDOWN field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_POWERDOWN(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_POWERDOWN) | BF_CCM_ANALOG_PLL_ARM_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field ENABLE[13] (RW)
 *
 * Enable the clock output.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_ARM_ENABLE. */
#define BM_CCM_ANALOG_PLL_ARM_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_ENABLE. */
#define BS_CCM_ANALOG_PLL_ARM_ENABLE (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_ENABLE field. */
#define BR_CCM_ANALOG_PLL_ARM_ENABLE(x) (HW_CCM_ANALOG_PLL_ARM(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_ENABLE. */
#define BF_CCM_ANALOG_PLL_ARM_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_ENABLE) & BM_CCM_ANALOG_PLL_ARM_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_ENABLE(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_ENABLE) | BF_CCM_ANALOG_PLL_ARM_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.Changing the Bypass clock source also changes
 * the PLL reference clock source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_ARM(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_ARM_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_ARM_BYPASS. */
#define BM_CCM_ANALOG_PLL_ARM_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_BYPASS. */
#define BS_CCM_ANALOG_PLL_ARM_BYPASS (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_BYPASS field. */
#define BR_CCM_ANALOG_PLL_ARM_BYPASS(x) (HW_CCM_ANALOG_PLL_ARM(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_BYPASS. */
#define BF_CCM_ANALOG_PLL_ARM_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_BYPASS) & BM_CCM_ANALOG_PLL_ARM_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_BYPASS(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_BYPASS) | BF_CCM_ANALOG_PLL_ARM_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field LVDS_SEL[17] (RW)
 *
 * Analog Debug Bit
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_LVDS_SEL (17U) /*!< Bit position for CCM_ANALOG_PLL_ARM_LVDS_SEL. */
#define BM_CCM_ANALOG_PLL_ARM_LVDS_SEL (0x00020000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_LVDS_SEL. */
#define BS_CCM_ANALOG_PLL_ARM_LVDS_SEL (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_LVDS_SEL. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_LVDS_SEL field. */
#define BR_CCM_ANALOG_PLL_ARM_LVDS_SEL(x) (HW_CCM_ANALOG_PLL_ARM(x).B.LVDS_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_LVDS_SEL. */
#define BF_CCM_ANALOG_PLL_ARM_LVDS_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_LVDS_SEL) & BM_CCM_ANALOG_PLL_ARM_LVDS_SEL)

/*! @brief Set the LVDS_SEL field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_LVDS_SEL(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_LVDS_SEL) | BF_CCM_ANALOG_PLL_ARM_LVDS_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field LVDS_24MHZ_SEL[18] (RW)
 *
 * Analog Debug Bit
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL (18U) /*!< Bit position for CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL. */
#define BM_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL (0x00040000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL. */
#define BS_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL field. */
#define BR_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL(x) (HW_CCM_ANALOG_PLL_ARM(x).B.LVDS_24MHZ_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL. */
#define BF_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL) & BM_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL)

/*! @brief Set the LVDS_24MHZ_SEL field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL) | BF_CCM_ANALOG_PLL_ARM_LVDS_24MHZ_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field PLL_SEL[19] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_PLL_SEL (19U) /*!< Bit position for CCM_ANALOG_PLL_ARM_PLL_SEL. */
#define BM_CCM_ANALOG_PLL_ARM_PLL_SEL (0x00080000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_PLL_SEL. */
#define BS_CCM_ANALOG_PLL_ARM_PLL_SEL (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_PLL_SEL. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_PLL_SEL field. */
#define BR_CCM_ANALOG_PLL_ARM_PLL_SEL(x) (HW_CCM_ANALOG_PLL_ARM(x).B.PLL_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ARM_PLL_SEL. */
#define BF_CCM_ANALOG_PLL_ARM_PLL_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ARM_PLL_SEL) & BM_CCM_ANALOG_PLL_ARM_PLL_SEL)

/*! @brief Set the PLL_SEL field to a new value. */
#define BW_CCM_ANALOG_PLL_ARM_PLL_SEL(x, v) (HW_CCM_ANALOG_PLL_ARM_WR(x, (HW_CCM_ANALOG_PLL_ARM_RD(x) & ~BM_CCM_ANALOG_PLL_ARM_PLL_SEL) | BF_CCM_ANALOG_PLL_ARM_PLL_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ARM, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked. 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ARM_LOCK (31U)   /*!< Bit position for CCM_ANALOG_PLL_ARM_LOCK. */
#define BM_CCM_ANALOG_PLL_ARM_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_ARM_LOCK. */
#define BS_CCM_ANALOG_PLL_ARM_LOCK (1U)    /*!< Bit field size in bits for CCM_ANALOG_PLL_ARM_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ARM_LOCK field. */
#define BR_CCM_ANALOG_PLL_ARM_LOCK(x) (HW_CCM_ANALOG_PLL_ARM(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_USB1 - Analog USB1 480MHz PLL Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_USB1 - Analog USB1 480MHz PLL Control Register (RW)
 *
 * Reset value: 0x00012000U
 *
 * The control register provides control for USBPHY0 480MHz PLL.
 */
typedef union _hw_ccm_analog_pll_usb1
{
    uint32_t U;
    struct _hw_ccm_analog_pll_usb1_bitfields
    {
        uint32_t DIV_SELECT : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 4;        /*!< [5:2]  */
        uint32_t EN_USB_CLKS : 1;      /*!< [6]  */
        uint32_t RESERVED1 : 5;        /*!< [11:7]  */
        uint32_t POWER : 1;            /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED2 : 14;       /*!< [30:17]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_usb1_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_USB1 register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_USB1_ADDR(x) ((uintptr_t)(x) + 0x10U)
#define HW_CCM_ANALOG_PLL_USB1_SET_ADDR(x) (HW_CCM_ANALOG_PLL_USB1_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_USB1_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_USB1_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_USB1_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_USB1_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_USB1(x) (*(__IO hw_ccm_analog_pll_usb1_t *) HW_CCM_ANALOG_PLL_USB1_ADDR(x))
#define HW_CCM_ANALOG_PLL_USB1_RD(x) (HW_CCM_ANALOG_PLL_USB1(x).U)
#define HW_CCM_ANALOG_PLL_USB1_WR(x, v) (HW_CCM_ANALOG_PLL_USB1(x).U = (v))
#define HW_CCM_ANALOG_PLL_USB1_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB1_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_USB1_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB1_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_USB1_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_USB1 bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field DIV_SELECT[1:0] (RW)
 *
 * This field controls the PLL loop divider. 0 - Fout=Fref*20; 1 - Fout=Fref*22.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_USB1_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_USB1_DIV_SELECT (0x00000003U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_USB1_DIV_SELECT (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_USB1_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_USB1(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_USB1_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_DIV_SELECT) & BM_CCM_ANALOG_PLL_USB1_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_DIV_SELECT) | BF_CCM_ANALOG_PLL_USB1_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field EN_USB_CLKS[6] (RW)
 *
 * Powers the 9-phase PLL outputs for USBPHYn. Additionally, the UTMI clock gate
 * must be deasserted in the USBPHYn to enable USBn operation (clear CLKGATE bit
 * in USBPHYn_CTRL). This bit will be set automatically when USBPHYn remote
 * wakeup event occurs.
 *
 * Values:
 * - 0 - PLL outputs for USBPHYn off.
 * - 1 - PLL outputs for USBPHYn on.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_EN_USB_CLKS (6U) /*!< Bit position for CCM_ANALOG_PLL_USB1_EN_USB_CLKS. */
#define BM_CCM_ANALOG_PLL_USB1_EN_USB_CLKS (0x00000040U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_EN_USB_CLKS. */
#define BS_CCM_ANALOG_PLL_USB1_EN_USB_CLKS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_EN_USB_CLKS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_EN_USB_CLKS field. */
#define BR_CCM_ANALOG_PLL_USB1_EN_USB_CLKS(x) (HW_CCM_ANALOG_PLL_USB1(x).B.EN_USB_CLKS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_EN_USB_CLKS. */
#define BF_CCM_ANALOG_PLL_USB1_EN_USB_CLKS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_EN_USB_CLKS) & BM_CCM_ANALOG_PLL_USB1_EN_USB_CLKS)

/*! @brief Set the EN_USB_CLKS field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_EN_USB_CLKS(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_EN_USB_CLKS) | BF_CCM_ANALOG_PLL_USB1_EN_USB_CLKS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field POWER[12] (RW)
 *
 * Powers up the PLL. This bit will be set automatically when USBPHY0 remote
 * wakeup event happens.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_POWER (12U) /*!< Bit position for CCM_ANALOG_PLL_USB1_POWER. */
#define BM_CCM_ANALOG_PLL_USB1_POWER (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_POWER. */
#define BS_CCM_ANALOG_PLL_USB1_POWER (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_POWER. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_POWER field. */
#define BR_CCM_ANALOG_PLL_USB1_POWER(x) (HW_CCM_ANALOG_PLL_USB1(x).B.POWER)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_POWER. */
#define BF_CCM_ANALOG_PLL_USB1_POWER(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_POWER) & BM_CCM_ANALOG_PLL_USB1_POWER)

/*! @brief Set the POWER field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_POWER(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_POWER) | BF_CCM_ANALOG_PLL_USB1_POWER(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field ENABLE[13] (RW)
 *
 * Enable the PLL clock output.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_USB1_ENABLE. */
#define BM_CCM_ANALOG_PLL_USB1_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_ENABLE. */
#define BS_CCM_ANALOG_PLL_USB1_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_ENABLE field. */
#define BR_CCM_ANALOG_PLL_USB1_ENABLE(x) (HW_CCM_ANALOG_PLL_USB1(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_ENABLE. */
#define BF_CCM_ANALOG_PLL_USB1_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_ENABLE) & BM_CCM_ANALOG_PLL_USB1_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_ENABLE(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_ENABLE) | BF_CCM_ANALOG_PLL_USB1_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_USB1(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_USB1_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_USB1_BYPASS. */
#define BM_CCM_ANALOG_PLL_USB1_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_BYPASS. */
#define BS_CCM_ANALOG_PLL_USB1_BYPASS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_BYPASS field. */
#define BR_CCM_ANALOG_PLL_USB1_BYPASS(x) (HW_CCM_ANALOG_PLL_USB1(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB1_BYPASS. */
#define BF_CCM_ANALOG_PLL_USB1_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB1_BYPASS) & BM_CCM_ANALOG_PLL_USB1_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_USB1_BYPASS(x, v) (HW_CCM_ANALOG_PLL_USB1_WR(x, (HW_CCM_ANALOG_PLL_USB1_RD(x) & ~BM_CCM_ANALOG_PLL_USB1_BYPASS) | BF_CCM_ANALOG_PLL_USB1_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB1, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked. 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB1_LOCK (31U)  /*!< Bit position for CCM_ANALOG_PLL_USB1_LOCK. */
#define BM_CCM_ANALOG_PLL_USB1_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_USB1_LOCK. */
#define BS_CCM_ANALOG_PLL_USB1_LOCK (1U)   /*!< Bit field size in bits for CCM_ANALOG_PLL_USB1_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB1_LOCK field. */
#define BR_CCM_ANALOG_PLL_USB1_LOCK(x) (HW_CCM_ANALOG_PLL_USB1(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_USB2 - Analog USB2 480MHz PLL Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_USB2 - Analog USB2 480MHz PLL Control Register (RW)
 *
 * Reset value: 0x00012000U
 *
 * The control register provides control for USBPHY1 480MHz PLL.
 */
typedef union _hw_ccm_analog_pll_usb2
{
    uint32_t U;
    struct _hw_ccm_analog_pll_usb2_bitfields
    {
        uint32_t DIV_SELECT : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 4;        /*!< [5:2]  */
        uint32_t EN_USB_CLKS : 1;      /*!< [6]  */
        uint32_t RESERVED1 : 5;        /*!< [11:7]  */
        uint32_t POWER : 1;            /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED2 : 14;       /*!< [30:17]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_usb2_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_USB2 register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_USB2_ADDR(x) ((uintptr_t)(x) + 0x20U)
#define HW_CCM_ANALOG_PLL_USB2_SET_ADDR(x) (HW_CCM_ANALOG_PLL_USB2_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_USB2_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_USB2_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_USB2_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_USB2_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_USB2(x) (*(__IO hw_ccm_analog_pll_usb2_t *) HW_CCM_ANALOG_PLL_USB2_ADDR(x))
#define HW_CCM_ANALOG_PLL_USB2_RD(x) (HW_CCM_ANALOG_PLL_USB2(x).U)
#define HW_CCM_ANALOG_PLL_USB2_WR(x, v) (HW_CCM_ANALOG_PLL_USB2(x).U = (v))
#define HW_CCM_ANALOG_PLL_USB2_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB2_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_USB2_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB2_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_USB2_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_USB2_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_USB2 bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field DIV_SELECT[1:0] (RW)
 *
 * This field controls the PLL loop divider. 0 - Fout=Fref*20; 1 - Fout=Fref*22.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_USB2_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_USB2_DIV_SELECT (0x00000003U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_USB2_DIV_SELECT (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_USB2_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_USB2(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_USB2_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_DIV_SELECT) & BM_CCM_ANALOG_PLL_USB2_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_DIV_SELECT) | BF_CCM_ANALOG_PLL_USB2_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field EN_USB_CLKS[6] (RW)
 *
 * 0: 8-phase PLL outputs for USBPHY1 are powered down. If set to 1, 8-phase PLL
 * outputs for USBPHY1 are powered up. Additionally, the utmi clock gate must be
 * deasserted in the USBPHY1 to enable USB0 operation (clear CLKGATE bit in
 * USBPHY1_CTRL).This bit will be set automatically when USBPHY1 remote wakeup event
 * happens.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_EN_USB_CLKS (6U) /*!< Bit position for CCM_ANALOG_PLL_USB2_EN_USB_CLKS. */
#define BM_CCM_ANALOG_PLL_USB2_EN_USB_CLKS (0x00000040U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_EN_USB_CLKS. */
#define BS_CCM_ANALOG_PLL_USB2_EN_USB_CLKS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_EN_USB_CLKS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_EN_USB_CLKS field. */
#define BR_CCM_ANALOG_PLL_USB2_EN_USB_CLKS(x) (HW_CCM_ANALOG_PLL_USB2(x).B.EN_USB_CLKS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_EN_USB_CLKS. */
#define BF_CCM_ANALOG_PLL_USB2_EN_USB_CLKS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_EN_USB_CLKS) & BM_CCM_ANALOG_PLL_USB2_EN_USB_CLKS)

/*! @brief Set the EN_USB_CLKS field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_EN_USB_CLKS(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_EN_USB_CLKS) | BF_CCM_ANALOG_PLL_USB2_EN_USB_CLKS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field POWER[12] (RW)
 *
 * Powers up the PLL. This bit will be set automatically when USBPHY1 remote
 * wakeup event happens.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_POWER (12U) /*!< Bit position for CCM_ANALOG_PLL_USB2_POWER. */
#define BM_CCM_ANALOG_PLL_USB2_POWER (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_POWER. */
#define BS_CCM_ANALOG_PLL_USB2_POWER (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_POWER. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_POWER field. */
#define BR_CCM_ANALOG_PLL_USB2_POWER(x) (HW_CCM_ANALOG_PLL_USB2(x).B.POWER)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_POWER. */
#define BF_CCM_ANALOG_PLL_USB2_POWER(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_POWER) & BM_CCM_ANALOG_PLL_USB2_POWER)

/*! @brief Set the POWER field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_POWER(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_POWER) | BF_CCM_ANALOG_PLL_USB2_POWER(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field ENABLE[13] (RW)
 *
 * Enable the PLL clock output.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_USB2_ENABLE. */
#define BM_CCM_ANALOG_PLL_USB2_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_ENABLE. */
#define BS_CCM_ANALOG_PLL_USB2_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_ENABLE field. */
#define BR_CCM_ANALOG_PLL_USB2_ENABLE(x) (HW_CCM_ANALOG_PLL_USB2(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_ENABLE. */
#define BF_CCM_ANALOG_PLL_USB2_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_ENABLE) & BM_CCM_ANALOG_PLL_USB2_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_ENABLE(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_ENABLE) | BF_CCM_ANALOG_PLL_USB2_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_USB2(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_USB2_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_USB2_BYPASS. */
#define BM_CCM_ANALOG_PLL_USB2_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_BYPASS. */
#define BS_CCM_ANALOG_PLL_USB2_BYPASS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_BYPASS field. */
#define BR_CCM_ANALOG_PLL_USB2_BYPASS(x) (HW_CCM_ANALOG_PLL_USB2(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_USB2_BYPASS. */
#define BF_CCM_ANALOG_PLL_USB2_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_USB2_BYPASS) & BM_CCM_ANALOG_PLL_USB2_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_USB2_BYPASS(x, v) (HW_CCM_ANALOG_PLL_USB2_WR(x, (HW_CCM_ANALOG_PLL_USB2_RD(x) & ~BM_CCM_ANALOG_PLL_USB2_BYPASS) | BF_CCM_ANALOG_PLL_USB2_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_USB2, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked. 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_USB2_LOCK (31U)  /*!< Bit position for CCM_ANALOG_PLL_USB2_LOCK. */
#define BM_CCM_ANALOG_PLL_USB2_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_USB2_LOCK. */
#define BS_CCM_ANALOG_PLL_USB2_LOCK (1U)   /*!< Bit field size in bits for CCM_ANALOG_PLL_USB2_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_USB2_LOCK field. */
#define BR_CCM_ANALOG_PLL_USB2_LOCK(x) (HW_CCM_ANALOG_PLL_USB2(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_SYS - Analog System PLL Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_SYS - Analog System PLL Control Register (RW)
 *
 * Reset value: 0x00013001U
 *
 * The control register provides control for the 528MHz PLL.
 */
typedef union _hw_ccm_analog_pll_sys
{
    uint32_t U;
    struct _hw_ccm_analog_pll_sys_bitfields
    {
        uint32_t DIV_SELECT : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 11;       /*!< [11:1]  */
        uint32_t POWERDOWN : 1;        /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t PFD_OFFSET_EN : 1;    /*!< [18]  */
        uint32_t RESERVED2 : 12;       /*!< [30:19]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_sys_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_SYS register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_SYS_ADDR(x) ((uintptr_t)(x) + 0x30U)
#define HW_CCM_ANALOG_PLL_SYS_SET_ADDR(x) (HW_CCM_ANALOG_PLL_SYS_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_SYS_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_SYS_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_SYS_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_SYS_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_SYS(x) (*(__IO hw_ccm_analog_pll_sys_t *) HW_CCM_ANALOG_PLL_SYS_ADDR(x))
#define HW_CCM_ANALOG_PLL_SYS_RD(x) (HW_CCM_ANALOG_PLL_SYS(x).U)
#define HW_CCM_ANALOG_PLL_SYS_WR(x, v) (HW_CCM_ANALOG_PLL_SYS(x).U = (v))
#define HW_CCM_ANALOG_PLL_SYS_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_SYS_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_SYS_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_SYS_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_SYS_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_SYS_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_SYS bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field DIV_SELECT[0] (RW)
 *
 * This field controls the PLL loop divider. 0 - Fout=Fref*20; 1 - Fout=Fref*22.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_SYS_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_SYS_DIV_SELECT (0x00000001U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_SYS_DIV_SELECT (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_SYS_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_SYS(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_SYS_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_DIV_SELECT) & BM_CCM_ANALOG_PLL_SYS_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_DIV_SELECT) | BF_CCM_ANALOG_PLL_SYS_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field POWERDOWN[12] (RW)
 *
 * Powers down the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_POWERDOWN (12U) /*!< Bit position for CCM_ANALOG_PLL_SYS_POWERDOWN. */
#define BM_CCM_ANALOG_PLL_SYS_POWERDOWN (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_POWERDOWN. */
#define BS_CCM_ANALOG_PLL_SYS_POWERDOWN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_POWERDOWN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_POWERDOWN field. */
#define BR_CCM_ANALOG_PLL_SYS_POWERDOWN(x) (HW_CCM_ANALOG_PLL_SYS(x).B.POWERDOWN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_POWERDOWN. */
#define BF_CCM_ANALOG_PLL_SYS_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_POWERDOWN) & BM_CCM_ANALOG_PLL_SYS_POWERDOWN)

/*! @brief Set the POWERDOWN field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_POWERDOWN(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_POWERDOWN) | BF_CCM_ANALOG_PLL_SYS_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field ENABLE[13] (RW)
 *
 * Enable PLL output
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_SYS_ENABLE. */
#define BM_CCM_ANALOG_PLL_SYS_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_ENABLE. */
#define BS_CCM_ANALOG_PLL_SYS_ENABLE (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_ENABLE field. */
#define BR_CCM_ANALOG_PLL_SYS_ENABLE(x) (HW_CCM_ANALOG_PLL_SYS(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_ENABLE. */
#define BF_CCM_ANALOG_PLL_SYS_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_ENABLE) & BM_CCM_ANALOG_PLL_SYS_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_ENABLE(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_ENABLE) | BF_CCM_ANALOG_PLL_SYS_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_SYS(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_SYS_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_SYS_BYPASS. */
#define BM_CCM_ANALOG_PLL_SYS_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_BYPASS. */
#define BS_CCM_ANALOG_PLL_SYS_BYPASS (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_BYPASS field. */
#define BR_CCM_ANALOG_PLL_SYS_BYPASS(x) (HW_CCM_ANALOG_PLL_SYS(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_BYPASS. */
#define BF_CCM_ANALOG_PLL_SYS_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_BYPASS) & BM_CCM_ANALOG_PLL_SYS_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_BYPASS(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_BYPASS) | BF_CCM_ANALOG_PLL_SYS_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field PFD_OFFSET_EN[18] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN (18U) /*!< Bit position for CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN. */
#define BM_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN (0x00040000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN. */
#define BS_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN field. */
#define BR_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN(x) (HW_CCM_ANALOG_PLL_SYS(x).B.PFD_OFFSET_EN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN. */
#define BF_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN) & BM_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN)

/*! @brief Set the PFD_OFFSET_EN field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN(x, v) (HW_CCM_ANALOG_PLL_SYS_WR(x, (HW_CCM_ANALOG_PLL_SYS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN) | BF_CCM_ANALOG_PLL_SYS_PFD_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked; 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_LOCK (31U)   /*!< Bit position for CCM_ANALOG_PLL_SYS_LOCK. */
#define BM_CCM_ANALOG_PLL_SYS_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_LOCK. */
#define BS_CCM_ANALOG_PLL_SYS_LOCK (1U)    /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_LOCK field. */
#define BR_CCM_ANALOG_PLL_SYS_LOCK(x) (HW_CCM_ANALOG_PLL_SYS(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_SYS_SS - 528MHz System PLL Spread Spectrum Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_SYS_SS - 528MHz System PLL Spread Spectrum Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the 528 PLL spread spectrum controls.
 */
typedef union _hw_ccm_analog_pll_sys_ss
{
    uint32_t U;
    struct _hw_ccm_analog_pll_sys_ss_bitfields
    {
        uint32_t STEP : 15;            /*!< [14:0]  */
        uint32_t ENABLE : 1;           /*!< [15]  */
        uint32_t STOP : 16;            /*!< [31:16]  */
    } B;
} hw_ccm_analog_pll_sys_ss_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_SYS_SS register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_SYS_SS_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_CCM_ANALOG_PLL_SYS_SS(x) (*(__IO hw_ccm_analog_pll_sys_ss_t *) HW_CCM_ANALOG_PLL_SYS_SS_ADDR(x))
#define HW_CCM_ANALOG_PLL_SYS_SS_RD(x) (HW_CCM_ANALOG_PLL_SYS_SS(x).U)
#define HW_CCM_ANALOG_PLL_SYS_SS_WR(x, v) (HW_CCM_ANALOG_PLL_SYS_SS(x).U = (v))
#define HW_CCM_ANALOG_PLL_SYS_SS_SET(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, HW_CCM_ANALOG_PLL_SYS_SS_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_SYS_SS_CLR(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, HW_CCM_ANALOG_PLL_SYS_SS_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_SYS_SS_TOG(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, HW_CCM_ANALOG_PLL_SYS_SS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_SYS_SS bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_SYS_SS, field STEP[14:0] (RW)
 *
 * Frequency change step = step/CCM_ANALOG_PLL_SYS_DENOM[B]*24MHz.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_SS_STEP (0U) /*!< Bit position for CCM_ANALOG_PLL_SYS_SS_STEP. */
#define BM_CCM_ANALOG_PLL_SYS_SS_STEP (0x00007FFFU) /*!< Bit mask for CCM_ANALOG_PLL_SYS_SS_STEP. */
#define BS_CCM_ANALOG_PLL_SYS_SS_STEP (15U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_SS_STEP. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_SS_STEP field. */
#define BR_CCM_ANALOG_PLL_SYS_SS_STEP(x) (HW_CCM_ANALOG_PLL_SYS_SS(x).B.STEP)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_SS_STEP. */
#define BF_CCM_ANALOG_PLL_SYS_SS_STEP(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_SS_STEP) & BM_CCM_ANALOG_PLL_SYS_SS_STEP)

/*! @brief Set the STEP field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_SS_STEP(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, (HW_CCM_ANALOG_PLL_SYS_SS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_SS_STEP) | BF_CCM_ANALOG_PLL_SYS_SS_STEP(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS_SS, field ENABLE[15] (RW)
 *
 * Values:
 * - 0 - Spread spectrum modulation disabled
 * - 1 - Soread spectrum modulation enabled
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_SS_ENABLE (15U) /*!< Bit position for CCM_ANALOG_PLL_SYS_SS_ENABLE. */
#define BM_CCM_ANALOG_PLL_SYS_SS_ENABLE (0x00008000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_SS_ENABLE. */
#define BS_CCM_ANALOG_PLL_SYS_SS_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_SS_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_SS_ENABLE field. */
#define BR_CCM_ANALOG_PLL_SYS_SS_ENABLE(x) (HW_CCM_ANALOG_PLL_SYS_SS(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_SS_ENABLE. */
#define BF_CCM_ANALOG_PLL_SYS_SS_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_SS_ENABLE) & BM_CCM_ANALOG_PLL_SYS_SS_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_SS_ENABLE(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, (HW_CCM_ANALOG_PLL_SYS_SS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_SS_ENABLE) | BF_CCM_ANALOG_PLL_SYS_SS_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_SYS_SS, field STOP[31:16] (RW)
 *
 * Frequency change = stop/CCM_ANALOG_PLL_SYS_DENOM[B]*24MHz.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_SS_STOP (16U) /*!< Bit position for CCM_ANALOG_PLL_SYS_SS_STOP. */
#define BM_CCM_ANALOG_PLL_SYS_SS_STOP (0xFFFF0000U) /*!< Bit mask for CCM_ANALOG_PLL_SYS_SS_STOP. */
#define BS_CCM_ANALOG_PLL_SYS_SS_STOP (16U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_SS_STOP. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_SS_STOP field. */
#define BR_CCM_ANALOG_PLL_SYS_SS_STOP(x) (HW_CCM_ANALOG_PLL_SYS_SS(x).B.STOP)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_SS_STOP. */
#define BF_CCM_ANALOG_PLL_SYS_SS_STOP(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_SS_STOP) & BM_CCM_ANALOG_PLL_SYS_SS_STOP)

/*! @brief Set the STOP field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_SS_STOP(x, v) (HW_CCM_ANALOG_PLL_SYS_SS_WR(x, (HW_CCM_ANALOG_PLL_SYS_SS_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_SS_STOP) | BF_CCM_ANALOG_PLL_SYS_SS_STOP(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_SYS_NUM - Numerator of 528MHz System PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_SYS_NUM - Numerator of 528MHz System PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the numerator of 528MHz PLL fractional loop divider
 * (signed number). Absoulte value should be less than denominator
 */
typedef union _hw_ccm_analog_pll_sys_num
{
    uint32_t U;
    struct _hw_ccm_analog_pll_sys_num_bitfields
    {
        uint32_t A : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_sys_num_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_SYS_NUM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_SYS_NUM_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_CCM_ANALOG_PLL_SYS_NUM(x) (*(__IO hw_ccm_analog_pll_sys_num_t *) HW_CCM_ANALOG_PLL_SYS_NUM_ADDR(x))
#define HW_CCM_ANALOG_PLL_SYS_NUM_RD(x) (HW_CCM_ANALOG_PLL_SYS_NUM(x).U)
#define HW_CCM_ANALOG_PLL_SYS_NUM_WR(x, v) (HW_CCM_ANALOG_PLL_SYS_NUM(x).U = (v))
#define HW_CCM_ANALOG_PLL_SYS_NUM_SET(x, v) (HW_CCM_ANALOG_PLL_SYS_NUM_WR(x, HW_CCM_ANALOG_PLL_SYS_NUM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_SYS_NUM_CLR(x, v) (HW_CCM_ANALOG_PLL_SYS_NUM_WR(x, HW_CCM_ANALOG_PLL_SYS_NUM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_SYS_NUM_TOG(x, v) (HW_CCM_ANALOG_PLL_SYS_NUM_WR(x, HW_CCM_ANALOG_PLL_SYS_NUM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_SYS_NUM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_SYS_NUM, field A[29:0] (RW)
 *
 * 30 bit numerator (A) of fractional loop divider (signed integer).
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_NUM_A (0U)   /*!< Bit position for CCM_ANALOG_PLL_SYS_NUM_A. */
#define BM_CCM_ANALOG_PLL_SYS_NUM_A (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_SYS_NUM_A. */
#define BS_CCM_ANALOG_PLL_SYS_NUM_A (30U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_NUM_A. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_NUM_A field. */
#define BR_CCM_ANALOG_PLL_SYS_NUM_A(x) (HW_CCM_ANALOG_PLL_SYS_NUM(x).B.A)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_NUM_A. */
#define BF_CCM_ANALOG_PLL_SYS_NUM_A(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_NUM_A) & BM_CCM_ANALOG_PLL_SYS_NUM_A)

/*! @brief Set the A field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_NUM_A(x, v) (HW_CCM_ANALOG_PLL_SYS_NUM_WR(x, (HW_CCM_ANALOG_PLL_SYS_NUM_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_NUM_A) | BF_CCM_ANALOG_PLL_SYS_NUM_A(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_SYS_DENOM - Denominator of 528MHz System PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_SYS_DENOM - Denominator of 528MHz System PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x00000012U
 *
 * This register contains the Denominator of 528MHz PLL fractional loop divider.
 */
typedef union _hw_ccm_analog_pll_sys_denom
{
    uint32_t U;
    struct _hw_ccm_analog_pll_sys_denom_bitfields
    {
        uint32_t B : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_sys_denom_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_SYS_DENOM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_SYS_DENOM_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_CCM_ANALOG_PLL_SYS_DENOM(x) (*(__IO hw_ccm_analog_pll_sys_denom_t *) HW_CCM_ANALOG_PLL_SYS_DENOM_ADDR(x))
#define HW_CCM_ANALOG_PLL_SYS_DENOM_RD(x) (HW_CCM_ANALOG_PLL_SYS_DENOM(x).U)
#define HW_CCM_ANALOG_PLL_SYS_DENOM_WR(x, v) (HW_CCM_ANALOG_PLL_SYS_DENOM(x).U = (v))
#define HW_CCM_ANALOG_PLL_SYS_DENOM_SET(x, v) (HW_CCM_ANALOG_PLL_SYS_DENOM_WR(x, HW_CCM_ANALOG_PLL_SYS_DENOM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_SYS_DENOM_CLR(x, v) (HW_CCM_ANALOG_PLL_SYS_DENOM_WR(x, HW_CCM_ANALOG_PLL_SYS_DENOM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_SYS_DENOM_TOG(x, v) (HW_CCM_ANALOG_PLL_SYS_DENOM_WR(x, HW_CCM_ANALOG_PLL_SYS_DENOM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_SYS_DENOM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_SYS_DENOM, field B[29:0] (RW)
 *
 * 30 bit Denominator (B) of fractional loop divider (unsigned integer).
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_SYS_DENOM_B (0U) /*!< Bit position for CCM_ANALOG_PLL_SYS_DENOM_B. */
#define BM_CCM_ANALOG_PLL_SYS_DENOM_B (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_SYS_DENOM_B. */
#define BS_CCM_ANALOG_PLL_SYS_DENOM_B (30U) /*!< Bit field size in bits for CCM_ANALOG_PLL_SYS_DENOM_B. */

/*! @brief Read current value of the CCM_ANALOG_PLL_SYS_DENOM_B field. */
#define BR_CCM_ANALOG_PLL_SYS_DENOM_B(x) (HW_CCM_ANALOG_PLL_SYS_DENOM(x).B.B)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_SYS_DENOM_B. */
#define BF_CCM_ANALOG_PLL_SYS_DENOM_B(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_SYS_DENOM_B) & BM_CCM_ANALOG_PLL_SYS_DENOM_B)

/*! @brief Set the B field to a new value. */
#define BW_CCM_ANALOG_PLL_SYS_DENOM_B(x, v) (HW_CCM_ANALOG_PLL_SYS_DENOM_WR(x, (HW_CCM_ANALOG_PLL_SYS_DENOM_RD(x) & ~BM_CCM_ANALOG_PLL_SYS_DENOM_B) | BF_CCM_ANALOG_PLL_SYS_DENOM_B(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_AUDIO - Analog Audio PLL control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_AUDIO - Analog Audio PLL control Register (RW)
 *
 * Reset value: 0x00011006U
 *
 * The control register provides control for the audio PLL.
 */
typedef union _hw_ccm_analog_pll_audio
{
    uint32_t U;
    struct _hw_ccm_analog_pll_audio_bitfields
    {
        uint32_t DIV_SELECT : 7;       /*!< [6:0]  */
        uint32_t RESERVED0 : 5;        /*!< [11:7]  */
        uint32_t POWERDOWN : 1;        /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t PFD_OFFSET_EN : 1;    /*!< [18]  */
        uint32_t POST_DIV_SELECT : 2;  /*!< [20:19]  */
        uint32_t RESERVED2 : 10;       /*!< [30:21]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_audio_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_AUDIO register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_AUDIO_ADDR(x) ((uintptr_t)(x) + 0x70U)
#define HW_CCM_ANALOG_PLL_AUDIO_SET_ADDR(x) (HW_CCM_ANALOG_PLL_AUDIO_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_AUDIO_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_AUDIO_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_AUDIO_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_AUDIO_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_AUDIO(x) (*(__IO hw_ccm_analog_pll_audio_t *) HW_CCM_ANALOG_PLL_AUDIO_ADDR(x))
#define HW_CCM_ANALOG_PLL_AUDIO_RD(x) (HW_CCM_ANALOG_PLL_AUDIO(x).U)
#define HW_CCM_ANALOG_PLL_AUDIO_WR(x, v) (HW_CCM_ANALOG_PLL_AUDIO(x).U = (v))
#define HW_CCM_ANALOG_PLL_AUDIO_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_AUDIO_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_AUDIO_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_AUDIO_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_AUDIO_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_AUDIO_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_AUDIO bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field DIV_SELECT[6:0] (RW)
 *
 * This field controls the PLL loop divider. Valid range for DIV_SELECT divider
 * value: 27~54.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_AUDIO_DIV_SELECT (0x0000007FU) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_AUDIO_DIV_SELECT (7U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_AUDIO_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_AUDIO_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_DIV_SELECT) & BM_CCM_ANALOG_PLL_AUDIO_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_DIV_SELECT) | BF_CCM_ANALOG_PLL_AUDIO_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field POWERDOWN[12] (RW)
 *
 * Powers down the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_POWERDOWN (12U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_POWERDOWN. */
#define BM_CCM_ANALOG_PLL_AUDIO_POWERDOWN (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_POWERDOWN. */
#define BS_CCM_ANALOG_PLL_AUDIO_POWERDOWN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_POWERDOWN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_POWERDOWN field. */
#define BR_CCM_ANALOG_PLL_AUDIO_POWERDOWN(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.POWERDOWN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_POWERDOWN. */
#define BF_CCM_ANALOG_PLL_AUDIO_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_POWERDOWN) & BM_CCM_ANALOG_PLL_AUDIO_POWERDOWN)

/*! @brief Set the POWERDOWN field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_POWERDOWN(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_POWERDOWN) | BF_CCM_ANALOG_PLL_AUDIO_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field ENABLE[13] (RW)
 *
 * Enable PLL output
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_ENABLE. */
#define BM_CCM_ANALOG_PLL_AUDIO_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_ENABLE. */
#define BS_CCM_ANALOG_PLL_AUDIO_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_ENABLE field. */
#define BR_CCM_ANALOG_PLL_AUDIO_ENABLE(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_ENABLE. */
#define BF_CCM_ANALOG_PLL_AUDIO_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_ENABLE) & BM_CCM_ANALOG_PLL_AUDIO_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_ENABLE(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_ENABLE) | BF_CCM_ANALOG_PLL_AUDIO_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_AUDIO_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_BYPASS. */
#define BM_CCM_ANALOG_PLL_AUDIO_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_BYPASS. */
#define BS_CCM_ANALOG_PLL_AUDIO_BYPASS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_BYPASS field. */
#define BR_CCM_ANALOG_PLL_AUDIO_BYPASS(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_BYPASS. */
#define BF_CCM_ANALOG_PLL_AUDIO_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_BYPASS) & BM_CCM_ANALOG_PLL_AUDIO_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_BYPASS(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_BYPASS) | BF_CCM_ANALOG_PLL_AUDIO_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field PFD_OFFSET_EN[18] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN (18U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN. */
#define BM_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN (0x00040000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN. */
#define BS_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN field. */
#define BR_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.PFD_OFFSET_EN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN. */
#define BF_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN) & BM_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN)

/*! @brief Set the PFD_OFFSET_EN field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN) | BF_CCM_ANALOG_PLL_AUDIO_PFD_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field POST_DIV_SELECT[20:19] (RW)
 *
 * These bits implement a divider after the PLL, but before the enable and
 * bypass mux.
 *
 * Values:
 * - 00 - Divide by 4.
 * - 01 - Divide by 2.
 * - 10 - Divide by 1.
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT (19U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT (0x00180000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.POST_DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT) & BM_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT)

/*! @brief Set the POST_DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_AUDIO_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT) | BF_CCM_ANALOG_PLL_AUDIO_POST_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked. 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_LOCK (31U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_LOCK. */
#define BM_CCM_ANALOG_PLL_AUDIO_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_LOCK. */
#define BS_CCM_ANALOG_PLL_AUDIO_LOCK (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_LOCK field. */
#define BR_CCM_ANALOG_PLL_AUDIO_LOCK(x) (HW_CCM_ANALOG_PLL_AUDIO(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_AUDIO_NUM - Numerator of Audio PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_AUDIO_NUM - Numerator of Audio PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x05F5E100U
 *
 * This register contains the numerator (A) of Audio PLL fractional loop
 * divider.(Signed number), absolute value should be less than denominator Absolute
 * value should be less than denominator
 */
typedef union _hw_ccm_analog_pll_audio_num
{
    uint32_t U;
    struct _hw_ccm_analog_pll_audio_num_bitfields
    {
        uint32_t A : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_audio_num_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_AUDIO_NUM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_CCM_ANALOG_PLL_AUDIO_NUM(x) (*(__IO hw_ccm_analog_pll_audio_num_t *) HW_CCM_ANALOG_PLL_AUDIO_NUM_ADDR(x))
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_RD(x) (HW_CCM_ANALOG_PLL_AUDIO_NUM(x).U)
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_WR(x, v) (HW_CCM_ANALOG_PLL_AUDIO_NUM(x).U = (v))
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_SET(x, v) (HW_CCM_ANALOG_PLL_AUDIO_NUM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_NUM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_CLR(x, v) (HW_CCM_ANALOG_PLL_AUDIO_NUM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_NUM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_AUDIO_NUM_TOG(x, v) (HW_CCM_ANALOG_PLL_AUDIO_NUM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_NUM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_AUDIO_NUM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO_NUM, field A[29:0] (RW)
 *
 * 30 bit numerator of fractional loop divider.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_NUM_A (0U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_NUM_A. */
#define BM_CCM_ANALOG_PLL_AUDIO_NUM_A (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_NUM_A. */
#define BS_CCM_ANALOG_PLL_AUDIO_NUM_A (30U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_NUM_A. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_NUM_A field. */
#define BR_CCM_ANALOG_PLL_AUDIO_NUM_A(x) (HW_CCM_ANALOG_PLL_AUDIO_NUM(x).B.A)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_NUM_A. */
#define BF_CCM_ANALOG_PLL_AUDIO_NUM_A(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_NUM_A) & BM_CCM_ANALOG_PLL_AUDIO_NUM_A)

/*! @brief Set the A field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_NUM_A(x, v) (HW_CCM_ANALOG_PLL_AUDIO_NUM_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_NUM_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_NUM_A) | BF_CCM_ANALOG_PLL_AUDIO_NUM_A(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_AUDIO_DENOM - Denominator of Audio PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_AUDIO_DENOM - Denominator of Audio PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x2964619CU
 *
 * This register contains the Denominator (B) of Audio PLL fractional loop
 * divider.(unsigned number)
 */
typedef union _hw_ccm_analog_pll_audio_denom
{
    uint32_t U;
    struct _hw_ccm_analog_pll_audio_denom_bitfields
    {
        uint32_t B : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_audio_denom_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_AUDIO_DENOM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_CCM_ANALOG_PLL_AUDIO_DENOM(x) (*(__IO hw_ccm_analog_pll_audio_denom_t *) HW_CCM_ANALOG_PLL_AUDIO_DENOM_ADDR(x))
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_RD(x) (HW_CCM_ANALOG_PLL_AUDIO_DENOM(x).U)
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_WR(x, v) (HW_CCM_ANALOG_PLL_AUDIO_DENOM(x).U = (v))
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_SET(x, v) (HW_CCM_ANALOG_PLL_AUDIO_DENOM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_DENOM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_CLR(x, v) (HW_CCM_ANALOG_PLL_AUDIO_DENOM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_DENOM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_AUDIO_DENOM_TOG(x, v) (HW_CCM_ANALOG_PLL_AUDIO_DENOM_WR(x, HW_CCM_ANALOG_PLL_AUDIO_DENOM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_AUDIO_DENOM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_AUDIO_DENOM, field B[29:0] (RW)
 *
 * 30 bit Denominator of fractional loop divider.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_AUDIO_DENOM_B (0U) /*!< Bit position for CCM_ANALOG_PLL_AUDIO_DENOM_B. */
#define BM_CCM_ANALOG_PLL_AUDIO_DENOM_B (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_AUDIO_DENOM_B. */
#define BS_CCM_ANALOG_PLL_AUDIO_DENOM_B (30U) /*!< Bit field size in bits for CCM_ANALOG_PLL_AUDIO_DENOM_B. */

/*! @brief Read current value of the CCM_ANALOG_PLL_AUDIO_DENOM_B field. */
#define BR_CCM_ANALOG_PLL_AUDIO_DENOM_B(x) (HW_CCM_ANALOG_PLL_AUDIO_DENOM(x).B.B)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_AUDIO_DENOM_B. */
#define BF_CCM_ANALOG_PLL_AUDIO_DENOM_B(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_AUDIO_DENOM_B) & BM_CCM_ANALOG_PLL_AUDIO_DENOM_B)

/*! @brief Set the B field to a new value. */
#define BW_CCM_ANALOG_PLL_AUDIO_DENOM_B(x, v) (HW_CCM_ANALOG_PLL_AUDIO_DENOM_WR(x, (HW_CCM_ANALOG_PLL_AUDIO_DENOM_RD(x) & ~BM_CCM_ANALOG_PLL_AUDIO_DENOM_B) | BF_CCM_ANALOG_PLL_AUDIO_DENOM_B(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_VIDEO - Analog Video PLL control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_VIDEO - Analog Video PLL control Register (RW)
 *
 * Reset value: 0x0001100CU
 *
 * The control register provides control for the Video PLL.
 */
typedef union _hw_ccm_analog_pll_video
{
    uint32_t U;
    struct _hw_ccm_analog_pll_video_bitfields
    {
        uint32_t DIV_SELECT : 7;       /*!< [6:0]  */
        uint32_t RESERVED0 : 5;        /*!< [11:7]  */
        uint32_t POWERDOWN : 1;        /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t PFD_OFFSET_EN : 1;    /*!< [18]  */
        uint32_t POST_DIV_SELECT : 2;  /*!< [20:19]  */
        uint32_t RESERVED2 : 10;       /*!< [30:21]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_video_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_VIDEO register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_VIDEO_ADDR(x) ((uintptr_t)(x) + 0xA0U)
#define HW_CCM_ANALOG_PLL_VIDEO_SET_ADDR(x) (HW_CCM_ANALOG_PLL_VIDEO_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_VIDEO_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_VIDEO_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_VIDEO_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_VIDEO_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_VIDEO(x) (*(__IO hw_ccm_analog_pll_video_t *) HW_CCM_ANALOG_PLL_VIDEO_ADDR(x))
#define HW_CCM_ANALOG_PLL_VIDEO_RD(x) (HW_CCM_ANALOG_PLL_VIDEO(x).U)
#define HW_CCM_ANALOG_PLL_VIDEO_WR(x, v) (HW_CCM_ANALOG_PLL_VIDEO(x).U = (v))
#define HW_CCM_ANALOG_PLL_VIDEO_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_VIDEO_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_VIDEO_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_VIDEO_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_VIDEO_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_VIDEO_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_VIDEO bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field DIV_SELECT[6:0] (RW)
 *
 * This field controls the PLL loop divider. Valid range for DIV_SELECT divider
 * value: 27~54.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_VIDEO_DIV_SELECT (0x0000007FU) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_VIDEO_DIV_SELECT (7U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_VIDEO_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_VIDEO_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_DIV_SELECT) & BM_CCM_ANALOG_PLL_VIDEO_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_DIV_SELECT) | BF_CCM_ANALOG_PLL_VIDEO_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field POWERDOWN[12] (RW)
 *
 * Powers down the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_POWERDOWN (12U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_POWERDOWN. */
#define BM_CCM_ANALOG_PLL_VIDEO_POWERDOWN (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_POWERDOWN. */
#define BS_CCM_ANALOG_PLL_VIDEO_POWERDOWN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_POWERDOWN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_POWERDOWN field. */
#define BR_CCM_ANALOG_PLL_VIDEO_POWERDOWN(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.POWERDOWN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_POWERDOWN. */
#define BF_CCM_ANALOG_PLL_VIDEO_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_POWERDOWN) & BM_CCM_ANALOG_PLL_VIDEO_POWERDOWN)

/*! @brief Set the POWERDOWN field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_POWERDOWN(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_POWERDOWN) | BF_CCM_ANALOG_PLL_VIDEO_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field ENABLE[13] (RW)
 *
 * Enalbe PLL output
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_ENABLE. */
#define BM_CCM_ANALOG_PLL_VIDEO_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_ENABLE. */
#define BS_CCM_ANALOG_PLL_VIDEO_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_ENABLE field. */
#define BR_CCM_ANALOG_PLL_VIDEO_ENABLE(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_ENABLE. */
#define BF_CCM_ANALOG_PLL_VIDEO_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_ENABLE) & BM_CCM_ANALOG_PLL_VIDEO_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_ENABLE(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_ENABLE) | BF_CCM_ANALOG_PLL_VIDEO_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_VIDEO_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_BYPASS. */
#define BM_CCM_ANALOG_PLL_VIDEO_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_BYPASS. */
#define BS_CCM_ANALOG_PLL_VIDEO_BYPASS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_BYPASS field. */
#define BR_CCM_ANALOG_PLL_VIDEO_BYPASS(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_BYPASS. */
#define BF_CCM_ANALOG_PLL_VIDEO_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_BYPASS) & BM_CCM_ANALOG_PLL_VIDEO_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_BYPASS(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_BYPASS) | BF_CCM_ANALOG_PLL_VIDEO_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field PFD_OFFSET_EN[18] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN (18U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN. */
#define BM_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN (0x00040000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN. */
#define BS_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN field. */
#define BR_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.PFD_OFFSET_EN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN. */
#define BF_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN) & BM_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN)

/*! @brief Set the PFD_OFFSET_EN field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN) | BF_CCM_ANALOG_PLL_VIDEO_PFD_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field POST_DIV_SELECT[20:19] (RW)
 *
 * These bits implement a divider after the PLL, but before the enable and
 * bypass mux.
 *
 * Values:
 * - 00 - Divide by 4.
 * - 01 - Divide by 2.
 * - 10 - Divide by 1.
 * - 11 - Reserved
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT (19U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT (0x00180000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.POST_DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT) & BM_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT)

/*! @brief Set the POST_DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_VIDEO_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT) | BF_CCM_ANALOG_PLL_VIDEO_POST_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked; 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_LOCK (31U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_LOCK. */
#define BM_CCM_ANALOG_PLL_VIDEO_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_LOCK. */
#define BS_CCM_ANALOG_PLL_VIDEO_LOCK (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_LOCK field. */
#define BR_CCM_ANALOG_PLL_VIDEO_LOCK(x) (HW_CCM_ANALOG_PLL_VIDEO(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_VIDEO_NUM - Numerator of Video PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_VIDEO_NUM - Numerator of Video PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x05F5E100U
 *
 * This register contains the numerator (A) of Video PLL fractional loop
 * divider.(Signed number) Absolute value should be less than denominator
 */
typedef union _hw_ccm_analog_pll_video_num
{
    uint32_t U;
    struct _hw_ccm_analog_pll_video_num_bitfields
    {
        uint32_t A : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_video_num_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_VIDEO_NUM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_ADDR(x) ((uintptr_t)(x) + 0xB0U)

#define HW_CCM_ANALOG_PLL_VIDEO_NUM(x) (*(__IO hw_ccm_analog_pll_video_num_t *) HW_CCM_ANALOG_PLL_VIDEO_NUM_ADDR(x))
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_RD(x) (HW_CCM_ANALOG_PLL_VIDEO_NUM(x).U)
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_WR(x, v) (HW_CCM_ANALOG_PLL_VIDEO_NUM(x).U = (v))
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_SET(x, v) (HW_CCM_ANALOG_PLL_VIDEO_NUM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_NUM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_CLR(x, v) (HW_CCM_ANALOG_PLL_VIDEO_NUM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_NUM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_VIDEO_NUM_TOG(x, v) (HW_CCM_ANALOG_PLL_VIDEO_NUM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_NUM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_VIDEO_NUM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO_NUM, field A[29:0] (RW)
 *
 * 30 bit numerator of fractional loop divider(Signed number), absolute value
 * should be less than denominator
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_NUM_A (0U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_NUM_A. */
#define BM_CCM_ANALOG_PLL_VIDEO_NUM_A (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_NUM_A. */
#define BS_CCM_ANALOG_PLL_VIDEO_NUM_A (30U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_NUM_A. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_NUM_A field. */
#define BR_CCM_ANALOG_PLL_VIDEO_NUM_A(x) (HW_CCM_ANALOG_PLL_VIDEO_NUM(x).B.A)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_NUM_A. */
#define BF_CCM_ANALOG_PLL_VIDEO_NUM_A(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_NUM_A) & BM_CCM_ANALOG_PLL_VIDEO_NUM_A)

/*! @brief Set the A field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_NUM_A(x, v) (HW_CCM_ANALOG_PLL_VIDEO_NUM_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_NUM_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_NUM_A) | BF_CCM_ANALOG_PLL_VIDEO_NUM_A(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_VIDEO_DENOM - Denominator of Video PLL Fractional Loop Divider Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_VIDEO_DENOM - Denominator of Video PLL Fractional Loop Divider Register (RW)
 *
 * Reset value: 0x10A24447U
 *
 * This register contains the Denominator (B) of Video PLL fractional loop
 * divider.(Unsigned number)
 */
typedef union _hw_ccm_analog_pll_video_denom
{
    uint32_t U;
    struct _hw_ccm_analog_pll_video_denom_bitfields
    {
        uint32_t B : 30;               /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_pll_video_denom_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_VIDEO_DENOM register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_ADDR(x) ((uintptr_t)(x) + 0xC0U)

#define HW_CCM_ANALOG_PLL_VIDEO_DENOM(x) (*(__IO hw_ccm_analog_pll_video_denom_t *) HW_CCM_ANALOG_PLL_VIDEO_DENOM_ADDR(x))
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_RD(x) (HW_CCM_ANALOG_PLL_VIDEO_DENOM(x).U)
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_WR(x, v) (HW_CCM_ANALOG_PLL_VIDEO_DENOM(x).U = (v))
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_SET(x, v) (HW_CCM_ANALOG_PLL_VIDEO_DENOM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_DENOM_RD(x) |  (v)))
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_CLR(x, v) (HW_CCM_ANALOG_PLL_VIDEO_DENOM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_DENOM_RD(x) & ~(v)))
#define HW_CCM_ANALOG_PLL_VIDEO_DENOM_TOG(x, v) (HW_CCM_ANALOG_PLL_VIDEO_DENOM_WR(x, HW_CCM_ANALOG_PLL_VIDEO_DENOM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_VIDEO_DENOM bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_VIDEO_DENOM, field B[29:0] (RW)
 *
 * 30 bit Denominator of fractional loop divider.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_VIDEO_DENOM_B (0U) /*!< Bit position for CCM_ANALOG_PLL_VIDEO_DENOM_B. */
#define BM_CCM_ANALOG_PLL_VIDEO_DENOM_B (0x3FFFFFFFU) /*!< Bit mask for CCM_ANALOG_PLL_VIDEO_DENOM_B. */
#define BS_CCM_ANALOG_PLL_VIDEO_DENOM_B (30U) /*!< Bit field size in bits for CCM_ANALOG_PLL_VIDEO_DENOM_B. */

/*! @brief Read current value of the CCM_ANALOG_PLL_VIDEO_DENOM_B field. */
#define BR_CCM_ANALOG_PLL_VIDEO_DENOM_B(x) (HW_CCM_ANALOG_PLL_VIDEO_DENOM(x).B.B)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_VIDEO_DENOM_B. */
#define BF_CCM_ANALOG_PLL_VIDEO_DENOM_B(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_VIDEO_DENOM_B) & BM_CCM_ANALOG_PLL_VIDEO_DENOM_B)

/*! @brief Set the B field to a new value. */
#define BW_CCM_ANALOG_PLL_VIDEO_DENOM_B(x, v) (HW_CCM_ANALOG_PLL_VIDEO_DENOM_WR(x, (HW_CCM_ANALOG_PLL_VIDEO_DENOM_RD(x) & ~BM_CCM_ANALOG_PLL_VIDEO_DENOM_B) | BF_CCM_ANALOG_PLL_VIDEO_DENOM_B(v)))
/*@}*/

/*******************************************************************************
 * HW_CCM_ANALOG_PLL_MLB - MLB PLL Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_MLB - MLB PLL Control Register (RW)
 *
 * Reset value: 0x00010000U
 *
 * This register defines the control bits for the MLB PLL.
 */
typedef union _hw_ccm_analog_pll_mlb
{
    uint32_t U;
    struct _hw_ccm_analog_pll_mlb_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t HOLD_RING_OFF : 1;    /*!< [11]  */
        uint32_t PHASE_SEL : 2;        /*!< [13:12]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t VDDA_DELAY_CFG : 3;   /*!< [19:17]  */
        uint32_t VDDD_DELAY_CFG : 3;   /*!< [22:20]  */
        uint32_t RX_CLK_DELAY_CFG : 3; /*!< [25:23]  */
        uint32_t MLB_FLT_RES_CFG : 3;  /*!< [28:26]  */
        uint32_t RESERVED2 : 2;        /*!< [30:29]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_mlb_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_MLB register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_MLB_ADDR(x) ((uintptr_t)(x) + 0xD0U)
#define HW_CCM_ANALOG_PLL_MLB_SET_ADDR(x) (HW_CCM_ANALOG_PLL_MLB_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_MLB_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_MLB_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_MLB_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_MLB_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_MLB(x) (*(__IO hw_ccm_analog_pll_mlb_t *) HW_CCM_ANALOG_PLL_MLB_ADDR(x))
#define HW_CCM_ANALOG_PLL_MLB_RD(x) (HW_CCM_ANALOG_PLL_MLB(x).U)
#define HW_CCM_ANALOG_PLL_MLB_WR(x, v) (HW_CCM_ANALOG_PLL_MLB(x).U = (v))
#define HW_CCM_ANALOG_PLL_MLB_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_MLB_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_MLB_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_MLB_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_MLB_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_MLB_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_MLB bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field HOLD_RING_OFF[11] (RW)
 *
 * Analog debug bit.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF (11U) /*!< Bit position for CCM_ANALOG_PLL_MLB_HOLD_RING_OFF. */
#define BM_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF (0x00000800U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_HOLD_RING_OFF. */
#define BS_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_HOLD_RING_OFF. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_HOLD_RING_OFF field. */
#define BR_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF(x) (HW_CCM_ANALOG_PLL_MLB(x).B.HOLD_RING_OFF)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_HOLD_RING_OFF. */
#define BF_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF) & BM_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF)

/*! @brief Set the HOLD_RING_OFF field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF) | BF_CCM_ANALOG_PLL_MLB_HOLD_RING_OFF(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field PHASE_SEL[13:12] (RW)
 *
 * Analog debut bit.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_PHASE_SEL (12U) /*!< Bit position for CCM_ANALOG_PLL_MLB_PHASE_SEL. */
#define BM_CCM_ANALOG_PLL_MLB_PHASE_SEL (0x00003000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_PHASE_SEL. */
#define BS_CCM_ANALOG_PLL_MLB_PHASE_SEL (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_PHASE_SEL. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_PHASE_SEL field. */
#define BR_CCM_ANALOG_PLL_MLB_PHASE_SEL(x) (HW_CCM_ANALOG_PLL_MLB(x).B.PHASE_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_PHASE_SEL. */
#define BF_CCM_ANALOG_PLL_MLB_PHASE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_PHASE_SEL) & BM_CCM_ANALOG_PLL_MLB_PHASE_SEL)

/*! @brief Set the PHASE_SEL field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_PHASE_SEL(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_PHASE_SEL) | BF_CCM_ANALOG_PLL_MLB_PHASE_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_MLB_BYPASS. */
#define BM_CCM_ANALOG_PLL_MLB_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_BYPASS. */
#define BS_CCM_ANALOG_PLL_MLB_BYPASS (1U)  /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_BYPASS field. */
#define BR_CCM_ANALOG_PLL_MLB_BYPASS(x) (HW_CCM_ANALOG_PLL_MLB(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_BYPASS. */
#define BF_CCM_ANALOG_PLL_MLB_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_BYPASS) & BM_CCM_ANALOG_PLL_MLB_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_BYPASS(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_BYPASS) | BF_CCM_ANALOG_PLL_MLB_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field VDDA_DELAY_CFG[19:17] (RW)
 *
 * Configure the phase delay of the MLB PLL by adjusting the delay line in Vddio
 * power domain.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG (17U) /*!< Bit position for CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG. */
#define BM_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG (0x000E0000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG. */
#define BS_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG (3U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG field. */
#define BR_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG(x) (HW_CCM_ANALOG_PLL_MLB(x).B.VDDA_DELAY_CFG)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG. */
#define BF_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG) & BM_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG)

/*! @brief Set the VDDA_DELAY_CFG field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG) | BF_CCM_ANALOG_PLL_MLB_VDDA_DELAY_CFG(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field VDDD_DELAY_CFG[22:20] (RW)
 *
 * Configure the phase delay of the MLB PLL by adjusting the delay line in core
 * Vdd poser domain.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG (20U) /*!< Bit position for CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG. */
#define BM_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG (0x00700000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG. */
#define BS_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG (3U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG field. */
#define BR_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG(x) (HW_CCM_ANALOG_PLL_MLB(x).B.VDDD_DELAY_CFG)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG. */
#define BF_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG) & BM_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG)

/*! @brief Set the VDDD_DELAY_CFG field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG) | BF_CCM_ANALOG_PLL_MLB_VDDD_DELAY_CFG(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field RX_CLK_DELAY_CFG[25:23] (RW)
 *
 * Configure the phase delay of the MLB PLL RX Clock.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG (23U) /*!< Bit position for CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG. */
#define BM_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG (0x03800000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG. */
#define BS_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG (3U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG field. */
#define BR_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG(x) (HW_CCM_ANALOG_PLL_MLB(x).B.RX_CLK_DELAY_CFG)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG. */
#define BF_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG) & BM_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG)

/*! @brief Set the RX_CLK_DELAY_CFG field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG) | BF_CCM_ANALOG_PLL_MLB_RX_CLK_DELAY_CFG(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field MLB_FLT_RES_CFG[28:26] (RW)
 *
 * Configure the filter resistor for different divider ratio of MLB PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG (26U) /*!< Bit position for CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG. */
#define BM_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG (0x1C000000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG. */
#define BS_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG (3U) /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG field. */
#define BR_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG(x) (HW_CCM_ANALOG_PLL_MLB(x).B.MLB_FLT_RES_CFG)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG. */
#define BF_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG) & BM_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG)

/*! @brief Set the MLB_FLT_RES_CFG field to a new value. */
#define BW_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG(x, v) (HW_CCM_ANALOG_PLL_MLB_WR(x, (HW_CCM_ANALOG_PLL_MLB_RD(x) & ~BM_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG) | BF_CCM_ANALOG_PLL_MLB_MLB_FLT_RES_CFG(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_MLB, field LOCK[31] (RO)
 *
 * Lock bit
 *
 * Values:
 * - 0 - PLL is not currently locked
 * - 1 - PLL is currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_MLB_LOCK (31U)   /*!< Bit position for CCM_ANALOG_PLL_MLB_LOCK. */
#define BM_CCM_ANALOG_PLL_MLB_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_MLB_LOCK. */
#define BS_CCM_ANALOG_PLL_MLB_LOCK (1U)    /*!< Bit field size in bits for CCM_ANALOG_PLL_MLB_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_MLB_LOCK field. */
#define BR_CCM_ANALOG_PLL_MLB_LOCK(x) (HW_CCM_ANALOG_PLL_MLB(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PLL_ENET - Analog ENET PLL Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PLL_ENET - Analog ENET PLL Control Register (RW)
 *
 * Reset value: 0x00011001U
 *
 * The control register provides control for the ENET PLL.
 */
typedef union _hw_ccm_analog_pll_enet
{
    uint32_t U;
    struct _hw_ccm_analog_pll_enet_bitfields
    {
        uint32_t DIV_SELECT : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 10;       /*!< [11:2]  */
        uint32_t POWERDOWN : 1;        /*!< [12]  */
        uint32_t ENABLE : 1;           /*!< [13]  */
        uint32_t BYPASS_CLK_SRC : 2;   /*!< [15:14]  */
        uint32_t BYPASS : 1;           /*!< [16]  */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t PFD_OFFSET_EN : 1;    /*!< [18]  */
        uint32_t ENABLE_125M : 1;      /*!< [19]  */
        uint32_t ENABLE_100M : 1;      /*!< [20]  */
        uint32_t RESERVED2 : 10;       /*!< [30:21]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ccm_analog_pll_enet_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PLL_ENET register
 */
/*@{*/
#define HW_CCM_ANALOG_PLL_ENET_ADDR(x) ((uintptr_t)(x) + 0xE0U)
#define HW_CCM_ANALOG_PLL_ENET_SET_ADDR(x) (HW_CCM_ANALOG_PLL_ENET_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PLL_ENET_CLR_ADDR(x) (HW_CCM_ANALOG_PLL_ENET_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PLL_ENET_TOG_ADDR(x) (HW_CCM_ANALOG_PLL_ENET_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PLL_ENET(x) (*(__IO hw_ccm_analog_pll_enet_t *) HW_CCM_ANALOG_PLL_ENET_ADDR(x))
#define HW_CCM_ANALOG_PLL_ENET_RD(x) (HW_CCM_ANALOG_PLL_ENET(x).U)
#define HW_CCM_ANALOG_PLL_ENET_WR(x, v) (HW_CCM_ANALOG_PLL_ENET(x).U = (v))
#define HW_CCM_ANALOG_PLL_ENET_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ENET_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_ENET_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ENET_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PLL_ENET_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PLL_ENET_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PLL_ENET bitfields
 */

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field DIV_SELECT[1:0] (RW)
 *
 * Controls the frequency of the ethernet reference clock.00 - 25MHz; 01 -
 * 50MHz; 10 - 100MHz (not 50% duty cycle); 11 - 125MHz;
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_DIV_SELECT (0U) /*!< Bit position for CCM_ANALOG_PLL_ENET_DIV_SELECT. */
#define BM_CCM_ANALOG_PLL_ENET_DIV_SELECT (0x00000003U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_DIV_SELECT. */
#define BS_CCM_ANALOG_PLL_ENET_DIV_SELECT (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_DIV_SELECT. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_DIV_SELECT field. */
#define BR_CCM_ANALOG_PLL_ENET_DIV_SELECT(x) (HW_CCM_ANALOG_PLL_ENET(x).B.DIV_SELECT)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_DIV_SELECT. */
#define BF_CCM_ANALOG_PLL_ENET_DIV_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_DIV_SELECT) & BM_CCM_ANALOG_PLL_ENET_DIV_SELECT)

/*! @brief Set the DIV_SELECT field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_DIV_SELECT(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_DIV_SELECT) | BF_CCM_ANALOG_PLL_ENET_DIV_SELECT(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field POWERDOWN[12] (RW)
 *
 * Powers down the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_POWERDOWN (12U) /*!< Bit position for CCM_ANALOG_PLL_ENET_POWERDOWN. */
#define BM_CCM_ANALOG_PLL_ENET_POWERDOWN (0x00001000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_POWERDOWN. */
#define BS_CCM_ANALOG_PLL_ENET_POWERDOWN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_POWERDOWN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_POWERDOWN field. */
#define BR_CCM_ANALOG_PLL_ENET_POWERDOWN(x) (HW_CCM_ANALOG_PLL_ENET(x).B.POWERDOWN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_POWERDOWN. */
#define BF_CCM_ANALOG_PLL_ENET_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_POWERDOWN) & BM_CCM_ANALOG_PLL_ENET_POWERDOWN)

/*! @brief Set the POWERDOWN field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_POWERDOWN(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_POWERDOWN) | BF_CCM_ANALOG_PLL_ENET_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field ENABLE[13] (RW)
 *
 * Enable the ethernet clock output.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_ENABLE (13U) /*!< Bit position for CCM_ANALOG_PLL_ENET_ENABLE. */
#define BM_CCM_ANALOG_PLL_ENET_ENABLE (0x00002000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_ENABLE. */
#define BS_CCM_ANALOG_PLL_ENET_ENABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_ENABLE. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_ENABLE field. */
#define BR_CCM_ANALOG_PLL_ENET_ENABLE(x) (HW_CCM_ANALOG_PLL_ENET(x).B.ENABLE)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_ENABLE. */
#define BF_CCM_ANALOG_PLL_ENET_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_ENABLE) & BM_CCM_ANALOG_PLL_ENET_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_ENABLE(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_ENABLE) | BF_CCM_ANALOG_PLL_ENET_ENABLE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field BYPASS_CLK_SRC[15:14] (RW)
 *
 * Determines the bypass source.
 *
 * Values:
 * - 0 - Select the 24MHz oscillator as source.
 * - 1 - Select the CLK1_N / CLK1_P as source.
 * - 10 - Select the CLK2_N / CLK2_P as source.
 * - 11 - Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC (14U) /*!< Bit position for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC. */
#define BM_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC (0x0000C000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC. */
#define BS_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC (2U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC. */

#define BV_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC_REF_CLK_24M (0U) /*!< Bit field value for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC: Select the 24MHz oscillator as source. */
#define BV_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC_CLK1 (0x1U) /*!< Bit field value for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC: Select the CLK1_N / CLK1_P as source. */
#define BV_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC_CLK2 (0x2U) /*!< Bit field value for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC: Select the CLK2_N / CLK2_P as source. */
#define BV_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC_XOR (0x3U) /*!< Bit field value for CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC: Select the XOR of CLK1_N / CLK1_P and CLK2_N / CLK2_P as source. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC field. */
#define BR_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC(x) (HW_CCM_ANALOG_PLL_ENET(x).B.BYPASS_CLK_SRC)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC. */
#define BF_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC) & BM_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC)

/*! @brief Set the BYPASS_CLK_SRC field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC) | BF_CCM_ANALOG_PLL_ENET_BYPASS_CLK_SRC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field BYPASS[16] (RW)
 *
 * Bypass the PLL.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_BYPASS (16U) /*!< Bit position for CCM_ANALOG_PLL_ENET_BYPASS. */
#define BM_CCM_ANALOG_PLL_ENET_BYPASS (0x00010000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_BYPASS. */
#define BS_CCM_ANALOG_PLL_ENET_BYPASS (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_BYPASS. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_BYPASS field. */
#define BR_CCM_ANALOG_PLL_ENET_BYPASS(x) (HW_CCM_ANALOG_PLL_ENET(x).B.BYPASS)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_BYPASS. */
#define BF_CCM_ANALOG_PLL_ENET_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_BYPASS) & BM_CCM_ANALOG_PLL_ENET_BYPASS)

/*! @brief Set the BYPASS field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_BYPASS(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_BYPASS) | BF_CCM_ANALOG_PLL_ENET_BYPASS(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field PFD_OFFSET_EN[18] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN (18U) /*!< Bit position for CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN. */
#define BM_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN (0x00040000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN. */
#define BS_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN field. */
#define BR_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN(x) (HW_CCM_ANALOG_PLL_ENET(x).B.PFD_OFFSET_EN)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN. */
#define BF_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN) & BM_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN)

/*! @brief Set the PFD_OFFSET_EN field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN) | BF_CCM_ANALOG_PLL_ENET_PFD_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field ENABLE_125M[19] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_ENABLE_125M (19U) /*!< Bit position for CCM_ANALOG_PLL_ENET_ENABLE_125M. */
#define BM_CCM_ANALOG_PLL_ENET_ENABLE_125M (0x00080000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_ENABLE_125M. */
#define BS_CCM_ANALOG_PLL_ENET_ENABLE_125M (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_ENABLE_125M. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_ENABLE_125M field. */
#define BR_CCM_ANALOG_PLL_ENET_ENABLE_125M(x) (HW_CCM_ANALOG_PLL_ENET(x).B.ENABLE_125M)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_ENABLE_125M. */
#define BF_CCM_ANALOG_PLL_ENET_ENABLE_125M(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_ENABLE_125M) & BM_CCM_ANALOG_PLL_ENET_ENABLE_125M)

/*! @brief Set the ENABLE_125M field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_ENABLE_125M(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_ENABLE_125M) | BF_CCM_ANALOG_PLL_ENET_ENABLE_125M(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field ENABLE_100M[20] (RW)
 *
 * Enables an offset in the phase frequency detector.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_ENABLE_100M (20U) /*!< Bit position for CCM_ANALOG_PLL_ENET_ENABLE_100M. */
#define BM_CCM_ANALOG_PLL_ENET_ENABLE_100M (0x00100000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_ENABLE_100M. */
#define BS_CCM_ANALOG_PLL_ENET_ENABLE_100M (1U) /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_ENABLE_100M. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_ENABLE_100M field. */
#define BR_CCM_ANALOG_PLL_ENET_ENABLE_100M(x) (HW_CCM_ANALOG_PLL_ENET(x).B.ENABLE_100M)

/*! @brief Format value for bitfield CCM_ANALOG_PLL_ENET_ENABLE_100M. */
#define BF_CCM_ANALOG_PLL_ENET_ENABLE_100M(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PLL_ENET_ENABLE_100M) & BM_CCM_ANALOG_PLL_ENET_ENABLE_100M)

/*! @brief Set the ENABLE_100M field to a new value. */
#define BW_CCM_ANALOG_PLL_ENET_ENABLE_100M(x, v) (HW_CCM_ANALOG_PLL_ENET_WR(x, (HW_CCM_ANALOG_PLL_ENET_RD(x) & ~BM_CCM_ANALOG_PLL_ENET_ENABLE_100M) | BF_CCM_ANALOG_PLL_ENET_ENABLE_100M(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PLL_ENET, field LOCK[31] (RO)
 *
 * 1 - PLL is currently locked; 0 - PLL is not currently locked.
 */
/*@{*/
#define BP_CCM_ANALOG_PLL_ENET_LOCK (31U)  /*!< Bit position for CCM_ANALOG_PLL_ENET_LOCK. */
#define BM_CCM_ANALOG_PLL_ENET_LOCK (0x80000000U) /*!< Bit mask for CCM_ANALOG_PLL_ENET_LOCK. */
#define BS_CCM_ANALOG_PLL_ENET_LOCK (1U)   /*!< Bit field size in bits for CCM_ANALOG_PLL_ENET_LOCK. */

/*! @brief Read current value of the CCM_ANALOG_PLL_ENET_LOCK field. */
#define BR_CCM_ANALOG_PLL_ENET_LOCK(x) (HW_CCM_ANALOG_PLL_ENET(x).B.LOCK)
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PFD_480 - 480MHz Clock (PLL3) Phase Fractional Divider Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PFD_480 - 480MHz Clock (PLL3) Phase Fractional Divider Control Register (RW)
 *
 * Reset value: 0x1311100CU
 *
 * The PFD_480 control register provides control for PFD clock generation. This
 * register controls the 4-phase fractional clock dividers. The fractional clock
 * frequencies are a product of the values in these registers.
 */
typedef union _hw_ccm_analog_pfd_480
{
    uint32_t U;
    struct _hw_ccm_analog_pfd_480_bitfields
    {
        uint32_t PFD0_FRAC : 6;        /*!< [5:0]  */
        uint32_t PFD0_STABLE : 1;      /*!< [6]  */
        uint32_t PFD0_CLKGATE : 1;     /*!< [7]  */
        uint32_t PFD1_FRAC : 6;        /*!< [13:8]  */
        uint32_t PFD1_STABLE : 1;      /*!< [14]  */
        uint32_t PFD1_CLKGATE : 1;     /*!< [15]  */
        uint32_t PFD2_FRAC : 6;        /*!< [21:16]  */
        uint32_t PFD2_STABLE : 1;      /*!< [22]  */
        uint32_t PFD2_CLKGATE : 1;     /*!< [23]  */
        uint32_t PFD3_FRAC : 6;        /*!< [29:24]  */
        uint32_t PFD3_STABLE : 1;      /*!< [30]  */
        uint32_t PFD3_CLKGATE : 1;     /*!< [31]  */
    } B;
} hw_ccm_analog_pfd_480_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PFD_480 register
 */
/*@{*/
#define HW_CCM_ANALOG_PFD_480_ADDR(x) ((uintptr_t)(x) + 0xF0U)
#define HW_CCM_ANALOG_PFD_480_SET_ADDR(x) (HW_CCM_ANALOG_PFD_480_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PFD_480_CLR_ADDR(x) (HW_CCM_ANALOG_PFD_480_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PFD_480_TOG_ADDR(x) (HW_CCM_ANALOG_PFD_480_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PFD_480(x) (*(__IO hw_ccm_analog_pfd_480_t *) HW_CCM_ANALOG_PFD_480_ADDR(x))
#define HW_CCM_ANALOG_PFD_480_RD(x) (HW_CCM_ANALOG_PFD_480(x).U)
#define HW_CCM_ANALOG_PFD_480_WR(x, v) (HW_CCM_ANALOG_PFD_480(x).U = (v))
#define HW_CCM_ANALOG_PFD_480_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_480_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PFD_480_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_480_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PFD_480_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_480_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PFD_480 bitfields
 */

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD0_FRAC[5:0] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 480*18/PFD0_FRAC where PFD0_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD0_FRAC (0U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD0_FRAC. */
#define BM_CCM_ANALOG_PFD_480_PFD0_FRAC (0x0000003FU) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD0_FRAC. */
#define BS_CCM_ANALOG_PFD_480_PFD0_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD0_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD0_FRAC field. */
#define BR_CCM_ANALOG_PFD_480_PFD0_FRAC(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD0_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD0_FRAC. */
#define BF_CCM_ANALOG_PFD_480_PFD0_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD0_FRAC) & BM_CCM_ANALOG_PFD_480_PFD0_FRAC)

/*! @brief Set the PFD0_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD0_FRAC(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD0_FRAC) | BF_CCM_ANALOG_PFD_480_PFD0_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD0_STABLE[6] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD0_STABLE (6U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD0_STABLE. */
#define BM_CCM_ANALOG_PFD_480_PFD0_STABLE (0x00000040U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD0_STABLE. */
#define BS_CCM_ANALOG_PFD_480_PFD0_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD0_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD0_STABLE field. */
#define BR_CCM_ANALOG_PFD_480_PFD0_STABLE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD0_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD0_CLKGATE[7] (RW)
 *
 * If set to 1, the IO fractional divider clock (reference ref_pfd0) is off
 * (power savings). 0: ref_pfd0 fractional divider clock is enabled. Need to assert
 * this bit before PLL is powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD0_CLKGATE (7U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD0_CLKGATE. */
#define BM_CCM_ANALOG_PFD_480_PFD0_CLKGATE (0x00000080U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD0_CLKGATE. */
#define BS_CCM_ANALOG_PFD_480_PFD0_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD0_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD0_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_480_PFD0_CLKGATE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD0_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD0_CLKGATE. */
#define BF_CCM_ANALOG_PFD_480_PFD0_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD0_CLKGATE) & BM_CCM_ANALOG_PFD_480_PFD0_CLKGATE)

/*! @brief Set the PFD0_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD0_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD0_CLKGATE) | BF_CCM_ANALOG_PFD_480_PFD0_CLKGATE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD1_FRAC[13:8] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 480*18/PFD1_FRAC where PFD1_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD1_FRAC (8U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD1_FRAC. */
#define BM_CCM_ANALOG_PFD_480_PFD1_FRAC (0x00003F00U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD1_FRAC. */
#define BS_CCM_ANALOG_PFD_480_PFD1_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD1_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD1_FRAC field. */
#define BR_CCM_ANALOG_PFD_480_PFD1_FRAC(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD1_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD1_FRAC. */
#define BF_CCM_ANALOG_PFD_480_PFD1_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD1_FRAC) & BM_CCM_ANALOG_PFD_480_PFD1_FRAC)

/*! @brief Set the PFD1_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD1_FRAC(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD1_FRAC) | BF_CCM_ANALOG_PFD_480_PFD1_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD1_STABLE[14] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD1_STABLE (14U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD1_STABLE. */
#define BM_CCM_ANALOG_PFD_480_PFD1_STABLE (0x00004000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD1_STABLE. */
#define BS_CCM_ANALOG_PFD_480_PFD1_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD1_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD1_STABLE field. */
#define BR_CCM_ANALOG_PFD_480_PFD1_STABLE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD1_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD1_CLKGATE[15] (RW)
 *
 * IO Clock Gate. If set to 1, the IO fractional divider clock (reference
 * ref_pfd1) is off (power savings). 0: ref_pfd1 fractional divider clock is enabled.
 * Need to assert this bit before PLL is powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD1_CLKGATE (15U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD1_CLKGATE. */
#define BM_CCM_ANALOG_PFD_480_PFD1_CLKGATE (0x00008000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD1_CLKGATE. */
#define BS_CCM_ANALOG_PFD_480_PFD1_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD1_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD1_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_480_PFD1_CLKGATE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD1_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD1_CLKGATE. */
#define BF_CCM_ANALOG_PFD_480_PFD1_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD1_CLKGATE) & BM_CCM_ANALOG_PFD_480_PFD1_CLKGATE)

/*! @brief Set the PFD1_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD1_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD1_CLKGATE) | BF_CCM_ANALOG_PFD_480_PFD1_CLKGATE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD2_FRAC[21:16] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 480*18/PFD2_FRAC where PFD2_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD2_FRAC (16U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD2_FRAC. */
#define BM_CCM_ANALOG_PFD_480_PFD2_FRAC (0x003F0000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD2_FRAC. */
#define BS_CCM_ANALOG_PFD_480_PFD2_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD2_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD2_FRAC field. */
#define BR_CCM_ANALOG_PFD_480_PFD2_FRAC(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD2_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD2_FRAC. */
#define BF_CCM_ANALOG_PFD_480_PFD2_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD2_FRAC) & BM_CCM_ANALOG_PFD_480_PFD2_FRAC)

/*! @brief Set the PFD2_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD2_FRAC(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD2_FRAC) | BF_CCM_ANALOG_PFD_480_PFD2_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD2_STABLE[22] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD2_STABLE (22U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD2_STABLE. */
#define BM_CCM_ANALOG_PFD_480_PFD2_STABLE (0x00400000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD2_STABLE. */
#define BS_CCM_ANALOG_PFD_480_PFD2_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD2_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD2_STABLE field. */
#define BR_CCM_ANALOG_PFD_480_PFD2_STABLE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD2_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD2_CLKGATE[23] (RW)
 *
 * IO Clock Gate. If set to 1, the IO fractional divider clock (reference
 * ref_pfd2) is off (power savings). 0: ref_pfd2 fractional divider clock is enabled.
 * Need to assert this bit before PLL is powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD2_CLKGATE (23U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD2_CLKGATE. */
#define BM_CCM_ANALOG_PFD_480_PFD2_CLKGATE (0x00800000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD2_CLKGATE. */
#define BS_CCM_ANALOG_PFD_480_PFD2_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD2_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD2_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_480_PFD2_CLKGATE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD2_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD2_CLKGATE. */
#define BF_CCM_ANALOG_PFD_480_PFD2_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD2_CLKGATE) & BM_CCM_ANALOG_PFD_480_PFD2_CLKGATE)

/*! @brief Set the PFD2_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD2_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD2_CLKGATE) | BF_CCM_ANALOG_PFD_480_PFD2_CLKGATE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD3_FRAC[29:24] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 480*18/PFD3_FRAC where PFD3_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD3_FRAC (24U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD3_FRAC. */
#define BM_CCM_ANALOG_PFD_480_PFD3_FRAC (0x3F000000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD3_FRAC. */
#define BS_CCM_ANALOG_PFD_480_PFD3_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD3_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD3_FRAC field. */
#define BR_CCM_ANALOG_PFD_480_PFD3_FRAC(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD3_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD3_FRAC. */
#define BF_CCM_ANALOG_PFD_480_PFD3_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD3_FRAC) & BM_CCM_ANALOG_PFD_480_PFD3_FRAC)

/*! @brief Set the PFD3_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD3_FRAC(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD3_FRAC) | BF_CCM_ANALOG_PFD_480_PFD3_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD3_STABLE[30] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD3_STABLE (30U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD3_STABLE. */
#define BM_CCM_ANALOG_PFD_480_PFD3_STABLE (0x40000000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD3_STABLE. */
#define BS_CCM_ANALOG_PFD_480_PFD3_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD3_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD3_STABLE field. */
#define BR_CCM_ANALOG_PFD_480_PFD3_STABLE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD3_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_480, field PFD3_CLKGATE[31] (RW)
 *
 * IO Clock Gate. If set to 1, the 3rd fractional divider clock (reference
 * ref_pfd3) is off (power savings). 0: ref_pfd3 fractional divider clock is enabled.
 * Need to assert this bit before PLL is powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_480_PFD3_CLKGATE (31U) /*!< Bit position for CCM_ANALOG_PFD_480_PFD3_CLKGATE. */
#define BM_CCM_ANALOG_PFD_480_PFD3_CLKGATE (0x80000000U) /*!< Bit mask for CCM_ANALOG_PFD_480_PFD3_CLKGATE. */
#define BS_CCM_ANALOG_PFD_480_PFD3_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_480_PFD3_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_480_PFD3_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_480_PFD3_CLKGATE(x) (HW_CCM_ANALOG_PFD_480(x).B.PFD3_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_480_PFD3_CLKGATE. */
#define BF_CCM_ANALOG_PFD_480_PFD3_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_480_PFD3_CLKGATE) & BM_CCM_ANALOG_PFD_480_PFD3_CLKGATE)

/*! @brief Set the PFD3_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_480_PFD3_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_480_WR(x, (HW_CCM_ANALOG_PFD_480_RD(x) & ~BM_CCM_ANALOG_PFD_480_PFD3_CLKGATE) | BF_CCM_ANALOG_PFD_480_PFD3_CLKGATE(v)))
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_PFD_528 - 528MHz Clock (PLL2) Phase Fractional Divider Control Register
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_PFD_528 - 528MHz Clock (PLL2) Phase Fractional Divider Control Register (RW)
 *
 * Reset value: 0x1018101BU
 *
 * The PFD_528 control register provides control for PFD clock generation. This
 * register controls the 3-phase fractional clock dividers. The fractional clock
 * frequencies are a product of the values in these registers.
 */
typedef union _hw_ccm_analog_pfd_528
{
    uint32_t U;
    struct _hw_ccm_analog_pfd_528_bitfields
    {
        uint32_t PFD0_FRAC : 6;        /*!< [5:0]  */
        uint32_t PFD0_STABLE : 1;      /*!< [6]  */
        uint32_t PFD0_CLKGATE : 1;     /*!< [7]  */
        uint32_t PFD1_FRAC : 6;        /*!< [13:8]  */
        uint32_t PFD1_STABLE : 1;      /*!< [14]  */
        uint32_t PFD1_CLKGATE : 1;     /*!< [15]  */
        uint32_t PFD2_FRAC : 6;        /*!< [21:16]  */
        uint32_t PFD2_STABLE : 1;      /*!< [22]  */
        uint32_t PFD2_CLKGATE : 1;     /*!< [23]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ccm_analog_pfd_528_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_PFD_528 register
 */
/*@{*/
#define HW_CCM_ANALOG_PFD_528_ADDR(x) ((uintptr_t)(x) + 0x100U)
#define HW_CCM_ANALOG_PFD_528_SET_ADDR(x) (HW_CCM_ANALOG_PFD_528_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_PFD_528_CLR_ADDR(x) (HW_CCM_ANALOG_PFD_528_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_PFD_528_TOG_ADDR(x) (HW_CCM_ANALOG_PFD_528_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_PFD_528(x) (*(__IO hw_ccm_analog_pfd_528_t *) HW_CCM_ANALOG_PFD_528_ADDR(x))
#define HW_CCM_ANALOG_PFD_528_RD(x) (HW_CCM_ANALOG_PFD_528(x).U)
#define HW_CCM_ANALOG_PFD_528_WR(x, v) (HW_CCM_ANALOG_PFD_528(x).U = (v))
#define HW_CCM_ANALOG_PFD_528_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_528_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PFD_528_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_528_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_PFD_528_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_PFD_528_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_PFD_528 bitfields
 */

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD0_FRAC[5:0] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 528*18/PFD0_FRAC where PFD0_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD0_FRAC (0U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD0_FRAC. */
#define BM_CCM_ANALOG_PFD_528_PFD0_FRAC (0x0000003FU) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD0_FRAC. */
#define BS_CCM_ANALOG_PFD_528_PFD0_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD0_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD0_FRAC field. */
#define BR_CCM_ANALOG_PFD_528_PFD0_FRAC(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD0_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD0_FRAC. */
#define BF_CCM_ANALOG_PFD_528_PFD0_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD0_FRAC) & BM_CCM_ANALOG_PFD_528_PFD0_FRAC)

/*! @brief Set the PFD0_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD0_FRAC(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD0_FRAC) | BF_CCM_ANALOG_PFD_528_PFD0_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD0_STABLE[6] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD0_STABLE (6U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD0_STABLE. */
#define BM_CCM_ANALOG_PFD_528_PFD0_STABLE (0x00000040U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD0_STABLE. */
#define BS_CCM_ANALOG_PFD_528_PFD0_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD0_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD0_STABLE field. */
#define BR_CCM_ANALOG_PFD_528_PFD0_STABLE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD0_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD0_CLKGATE[7] (RW)
 *
 * If set to 1, the IO fractional divider clock (reference ref_pfd0) is off
 * (power savings). 0: ref_pfd0 fractional divider clock is enabled. Need to assert
 * this bit before PLL powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD0_CLKGATE (7U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD0_CLKGATE. */
#define BM_CCM_ANALOG_PFD_528_PFD0_CLKGATE (0x00000080U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD0_CLKGATE. */
#define BS_CCM_ANALOG_PFD_528_PFD0_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD0_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD0_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_528_PFD0_CLKGATE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD0_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD0_CLKGATE. */
#define BF_CCM_ANALOG_PFD_528_PFD0_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD0_CLKGATE) & BM_CCM_ANALOG_PFD_528_PFD0_CLKGATE)

/*! @brief Set the PFD0_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD0_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD0_CLKGATE) | BF_CCM_ANALOG_PFD_528_PFD0_CLKGATE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD1_FRAC[13:8] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 528*18/PFD1_FRAC where PFD1_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD1_FRAC (8U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD1_FRAC. */
#define BM_CCM_ANALOG_PFD_528_PFD1_FRAC (0x00003F00U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD1_FRAC. */
#define BS_CCM_ANALOG_PFD_528_PFD1_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD1_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD1_FRAC field. */
#define BR_CCM_ANALOG_PFD_528_PFD1_FRAC(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD1_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD1_FRAC. */
#define BF_CCM_ANALOG_PFD_528_PFD1_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD1_FRAC) & BM_CCM_ANALOG_PFD_528_PFD1_FRAC)

/*! @brief Set the PFD1_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD1_FRAC(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD1_FRAC) | BF_CCM_ANALOG_PFD_528_PFD1_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD1_STABLE[14] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD1_STABLE (14U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD1_STABLE. */
#define BM_CCM_ANALOG_PFD_528_PFD1_STABLE (0x00004000U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD1_STABLE. */
#define BS_CCM_ANALOG_PFD_528_PFD1_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD1_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD1_STABLE field. */
#define BR_CCM_ANALOG_PFD_528_PFD1_STABLE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD1_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD1_CLKGATE[15] (RW)
 *
 * IO Clock Gate. If set to 1, the IO fractional divider clock (reference
 * ref_pfd1) is off (power savings). 0: ref_pfd1 fractional divider clock is enabled.
 * Need to assert this bit before PLL powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD1_CLKGATE (15U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD1_CLKGATE. */
#define BM_CCM_ANALOG_PFD_528_PFD1_CLKGATE (0x00008000U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD1_CLKGATE. */
#define BS_CCM_ANALOG_PFD_528_PFD1_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD1_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD1_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_528_PFD1_CLKGATE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD1_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD1_CLKGATE. */
#define BF_CCM_ANALOG_PFD_528_PFD1_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD1_CLKGATE) & BM_CCM_ANALOG_PFD_528_PFD1_CLKGATE)

/*! @brief Set the PFD1_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD1_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD1_CLKGATE) | BF_CCM_ANALOG_PFD_528_PFD1_CLKGATE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD2_FRAC[21:16] (RW)
 *
 * This field controls the fractional divide value. The resulting frequency
 * shall be 528*18/PFD2_FRAC where PFD2_FRAC is in the range 12-35.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD2_FRAC (16U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD2_FRAC. */
#define BM_CCM_ANALOG_PFD_528_PFD2_FRAC (0x003F0000U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD2_FRAC. */
#define BS_CCM_ANALOG_PFD_528_PFD2_FRAC (6U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD2_FRAC. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD2_FRAC field. */
#define BR_CCM_ANALOG_PFD_528_PFD2_FRAC(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD2_FRAC)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD2_FRAC. */
#define BF_CCM_ANALOG_PFD_528_PFD2_FRAC(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD2_FRAC) & BM_CCM_ANALOG_PFD_528_PFD2_FRAC)

/*! @brief Set the PFD2_FRAC field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD2_FRAC(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD2_FRAC) | BF_CCM_ANALOG_PFD_528_PFD2_FRAC(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD2_STABLE[22] (RO)
 *
 * This read-only bitfield is for DIAGNOSTIC PURPOSES ONLY since the fractional
 * divider should become stable quickly enough that this field will never need to
 * be used by either device driver or application code. The value inverts when
 * the new programmed fractional divide value has taken effect. Read this bit,
 * program the new value, and when this bit inverts, the phase divider clock output
 * is stable. Note that the value will not invert when the fractional divider is
 * taken out of or placed into clock-gated state.
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD2_STABLE (22U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD2_STABLE. */
#define BM_CCM_ANALOG_PFD_528_PFD2_STABLE (0x00400000U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD2_STABLE. */
#define BS_CCM_ANALOG_PFD_528_PFD2_STABLE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD2_STABLE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD2_STABLE field. */
#define BR_CCM_ANALOG_PFD_528_PFD2_STABLE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD2_STABLE)
/*@}*/

/*!
 * @name Register CCM_ANALOG_PFD_528, field PFD2_CLKGATE[23] (RW)
 *
 * IO Clock Gate. If set to 1, the IO fractional divider clock (reference
 * ref_pfd2) is off (power savings). 0: ref_pfd2 fractional divider clock is enabled.
 * Need to assert this bit before PLL powered down
 */
/*@{*/
#define BP_CCM_ANALOG_PFD_528_PFD2_CLKGATE (23U) /*!< Bit position for CCM_ANALOG_PFD_528_PFD2_CLKGATE. */
#define BM_CCM_ANALOG_PFD_528_PFD2_CLKGATE (0x00800000U) /*!< Bit mask for CCM_ANALOG_PFD_528_PFD2_CLKGATE. */
#define BS_CCM_ANALOG_PFD_528_PFD2_CLKGATE (1U) /*!< Bit field size in bits for CCM_ANALOG_PFD_528_PFD2_CLKGATE. */

/*! @brief Read current value of the CCM_ANALOG_PFD_528_PFD2_CLKGATE field. */
#define BR_CCM_ANALOG_PFD_528_PFD2_CLKGATE(x) (HW_CCM_ANALOG_PFD_528(x).B.PFD2_CLKGATE)

/*! @brief Format value for bitfield CCM_ANALOG_PFD_528_PFD2_CLKGATE. */
#define BF_CCM_ANALOG_PFD_528_PFD2_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_PFD_528_PFD2_CLKGATE) & BM_CCM_ANALOG_PFD_528_PFD2_CLKGATE)

/*! @brief Set the PFD2_CLKGATE field to a new value. */
#define BW_CCM_ANALOG_PFD_528_PFD2_CLKGATE(x, v) (HW_CCM_ANALOG_PFD_528_WR(x, (HW_CCM_ANALOG_PFD_528_RD(x) & ~BM_CCM_ANALOG_PFD_528_PFD2_CLKGATE) | BF_CCM_ANALOG_PFD_528_PFD2_CLKGATE(v)))
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_MISC0 - Miscellaneous Register 0
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_MISC0 - Miscellaneous Register 0 (RW)
 *
 * Reset value: 0x04000000U
 *
 * This register defines the control and status bits for miscellaneous analog
 * blocks.
 */
typedef union _hw_ccm_analog_misc0
{
    uint32_t U;
    struct _hw_ccm_analog_misc0_bitfields
    {
        uint32_t REFTOP_PWD : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t REFTOP_SELFBIASOFF : 1; /*!< [3]  */
        uint32_t REFTOP_VBGADJ : 3;    /*!< [6:4]  */
        uint32_t REFTOP_VBGUP : 1;     /*!< [7]  */
        uint32_t RESERVED1 : 4;        /*!< [11:8]  */
        uint32_t STOP_MODE_CONFIG : 1; /*!< [12]  */
        uint32_t RESERVED2 : 1;        /*!< [13]  */
        uint32_t OSC_I : 2;            /*!< [15:14]  */
        uint32_t OSC_XTALOK : 1;       /*!< [16]  */
        uint32_t OSC_XTALOK_EN : 1;    /*!< [17]  */
        uint32_t WBCP_VPW_THRESH : 2;  /*!< [19:18]  */
        uint32_t RESERVED3 : 5;        /*!< [24:20]  */
        uint32_t CLKGATE_CTRL : 1;     /*!< [25]  */
        uint32_t CLKGATE_DELAY : 3;    /*!< [28:26]  */
        uint32_t RESERVED4 : 3;        /*!< [31:29]  */
    } B;
} hw_ccm_analog_misc0_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_MISC0 register
 */
/*@{*/
#define HW_CCM_ANALOG_MISC0_ADDR(x) ((uintptr_t)(x) + 0x150U)
#define HW_CCM_ANALOG_MISC0_SET_ADDR(x) (HW_CCM_ANALOG_MISC0_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_MISC0_CLR_ADDR(x) (HW_CCM_ANALOG_MISC0_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_MISC0_TOG_ADDR(x) (HW_CCM_ANALOG_MISC0_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_MISC0(x)   (*(__IO hw_ccm_analog_misc0_t *) HW_CCM_ANALOG_MISC0_ADDR(x))
#define HW_CCM_ANALOG_MISC0_RD(x) (HW_CCM_ANALOG_MISC0(x).U)
#define HW_CCM_ANALOG_MISC0_WR(x, v) (HW_CCM_ANALOG_MISC0(x).U = (v))
#define HW_CCM_ANALOG_MISC0_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC0_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC0_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC0_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC0_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC0_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_MISC0 bitfields
 */

/*!
 * @name Register CCM_ANALOG_MISC0, field REFTOP_PWD[0] (RW)
 *
 * Control bit to power-down the analog bandgap reference circuitry. A note of
 * caution, the bandgap is necessary for correct operation of most of the LDO,
 * PLL, and other analog functions on the die. Not related to CCM. See Power
 * Management Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_REFTOP_PWD (0U) /*!< Bit position for CCM_ANALOG_MISC0_REFTOP_PWD. */
#define BM_CCM_ANALOG_MISC0_REFTOP_PWD (0x00000001U) /*!< Bit mask for CCM_ANALOG_MISC0_REFTOP_PWD. */
#define BS_CCM_ANALOG_MISC0_REFTOP_PWD (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_REFTOP_PWD. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_REFTOP_PWD field. */
#define BR_CCM_ANALOG_MISC0_REFTOP_PWD(x) (HW_CCM_ANALOG_MISC0(x).B.REFTOP_PWD)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_REFTOP_PWD. */
#define BF_CCM_ANALOG_MISC0_REFTOP_PWD(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_REFTOP_PWD) & BM_CCM_ANALOG_MISC0_REFTOP_PWD)

/*! @brief Set the REFTOP_PWD field to a new value. */
#define BW_CCM_ANALOG_MISC0_REFTOP_PWD(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_REFTOP_PWD) | BF_CCM_ANALOG_MISC0_REFTOP_PWD(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field REFTOP_SELFBIASOFF[3] (RW)
 *
 * Control bit to disable the self-bias circuit in the analog bandgap. The
 * self-bias circuit is used by the bandgap during startup. This bit should be set
 * after the bandgap has stabilized and is necessary for best noise performance of
 * analog blocks using the outputs of the bandgap. Value should be returned to
 * zero before removing vddhigh_in or asserting bit 0 of this register (REFTOP_PWD)
 * to assure proper restart of the circuit. Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 0 - Uses coarse bias currents for startup
 * - 1 - Uses bandgap-based bias currents for best performance.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF (3U) /*!< Bit position for CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF. */
#define BM_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF (0x00000008U) /*!< Bit mask for CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF. */
#define BS_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF field. */
#define BR_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF(x) (HW_CCM_ANALOG_MISC0(x).B.REFTOP_SELFBIASOFF)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF. */
#define BF_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF) & BM_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF)

/*! @brief Set the REFTOP_SELFBIASOFF field to a new value. */
#define BW_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF) | BF_CCM_ANALOG_MISC0_REFTOP_SELFBIASOFF(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field REFTOP_VBGADJ[6:4] (RW)
 *
 * Not related to CCM. See Power Management Unit (PMU)
 *
 * Values:
 * - 000 - Nominal VBG
 * - 001 - VBG+0.78%
 * - 010 - VBG+1.56%
 * - 011 - VBG+2.34%
 * - 100 - VBG-0.78%
 * - 101 - VBG-1.56%
 * - 110 - VBG-2.34%
 * - 111 - VBG-3.12%
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_REFTOP_VBGADJ (4U) /*!< Bit position for CCM_ANALOG_MISC0_REFTOP_VBGADJ. */
#define BM_CCM_ANALOG_MISC0_REFTOP_VBGADJ (0x00000070U) /*!< Bit mask for CCM_ANALOG_MISC0_REFTOP_VBGADJ. */
#define BS_CCM_ANALOG_MISC0_REFTOP_VBGADJ (3U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_REFTOP_VBGADJ. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_REFTOP_VBGADJ field. */
#define BR_CCM_ANALOG_MISC0_REFTOP_VBGADJ(x) (HW_CCM_ANALOG_MISC0(x).B.REFTOP_VBGADJ)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_REFTOP_VBGADJ. */
#define BF_CCM_ANALOG_MISC0_REFTOP_VBGADJ(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_REFTOP_VBGADJ) & BM_CCM_ANALOG_MISC0_REFTOP_VBGADJ)

/*! @brief Set the REFTOP_VBGADJ field to a new value. */
#define BW_CCM_ANALOG_MISC0_REFTOP_VBGADJ(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_REFTOP_VBGADJ) | BF_CCM_ANALOG_MISC0_REFTOP_VBGADJ(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field REFTOP_VBGUP[7] (RW)
 *
 * Status bit that signals the analog bandgap voltage is up and stable. 1 -
 * Stable.Not related to CCM. See Power Management Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_REFTOP_VBGUP (7U) /*!< Bit position for CCM_ANALOG_MISC0_REFTOP_VBGUP. */
#define BM_CCM_ANALOG_MISC0_REFTOP_VBGUP (0x00000080U) /*!< Bit mask for CCM_ANALOG_MISC0_REFTOP_VBGUP. */
#define BS_CCM_ANALOG_MISC0_REFTOP_VBGUP (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_REFTOP_VBGUP. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_REFTOP_VBGUP field. */
#define BR_CCM_ANALOG_MISC0_REFTOP_VBGUP(x) (HW_CCM_ANALOG_MISC0(x).B.REFTOP_VBGUP)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_REFTOP_VBGUP. */
#define BF_CCM_ANALOG_MISC0_REFTOP_VBGUP(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_REFTOP_VBGUP) & BM_CCM_ANALOG_MISC0_REFTOP_VBGUP)

/*! @brief Set the REFTOP_VBGUP field to a new value. */
#define BW_CCM_ANALOG_MISC0_REFTOP_VBGUP(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_REFTOP_VBGUP) | BF_CCM_ANALOG_MISC0_REFTOP_VBGUP(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field STOP_MODE_CONFIG[12] (RW)
 *
 * Configure the analog behavior in stop mode.
 *
 * Values:
 * - 0 - Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode
 *     assertion
 * - 1 - Light Stop Mode - 0x1 All the analog domain except the LDO_1P1,
 *     LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can
 *     be configured not to power down the oscillator (XTALOSC). PLL3 can be
 *     disabled with register settings if desired.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_STOP_MODE_CONFIG (12U) /*!< Bit position for CCM_ANALOG_MISC0_STOP_MODE_CONFIG. */
#define BM_CCM_ANALOG_MISC0_STOP_MODE_CONFIG (0x00001000U) /*!< Bit mask for CCM_ANALOG_MISC0_STOP_MODE_CONFIG. */
#define BS_CCM_ANALOG_MISC0_STOP_MODE_CONFIG (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_STOP_MODE_CONFIG. */

#define BV_CCM_ANALOG_MISC0_STOP_MODE_CONFIG_DEEP (0U) /*!< Bit field value for CCM_ANALOG_MISC0_STOP_MODE_CONFIG: Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode assertion */
#define BV_CCM_ANALOG_MISC0_STOP_MODE_CONFIG_LIGHT (0x1U) /*!< Bit field value for CCM_ANALOG_MISC0_STOP_MODE_CONFIG: Light Stop Mode - 0x1 All the analog domain except the LDO_1P1, LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can be configured not to power down the oscillator (XTALOSC). PLL3 can be disabled with register settings if desired. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_STOP_MODE_CONFIG field. */
#define BR_CCM_ANALOG_MISC0_STOP_MODE_CONFIG(x) (HW_CCM_ANALOG_MISC0(x).B.STOP_MODE_CONFIG)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_STOP_MODE_CONFIG. */
#define BF_CCM_ANALOG_MISC0_STOP_MODE_CONFIG(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_STOP_MODE_CONFIG) & BM_CCM_ANALOG_MISC0_STOP_MODE_CONFIG)

/*! @brief Set the STOP_MODE_CONFIG field to a new value. */
#define BW_CCM_ANALOG_MISC0_STOP_MODE_CONFIG(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_STOP_MODE_CONFIG) | BF_CCM_ANALOG_MISC0_STOP_MODE_CONFIG(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field OSC_I[15:14] (RW)
 *
 * This field determines the bias current in the 24MHz oscillator. The aim is to
 * start up with the highest bias current, which can be decreased after startup
 * if it is determined to be acceptable.Not related to CCM. See Crystal
 * Oscillator (XTALOSC)
 *
 * Values:
 * - 00 - Nominal
 * - 01 - Decrease current by 12.5%
 * - 10 - Decrease current by 25.0%
 * - 11 - Decrease current by 37.5%
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_OSC_I (14U)    /*!< Bit position for CCM_ANALOG_MISC0_OSC_I. */
#define BM_CCM_ANALOG_MISC0_OSC_I (0x0000C000U) /*!< Bit mask for CCM_ANALOG_MISC0_OSC_I. */
#define BS_CCM_ANALOG_MISC0_OSC_I (2U)     /*!< Bit field size in bits for CCM_ANALOG_MISC0_OSC_I. */

#define BV_CCM_ANALOG_MISC0_OSC_I_NOMINAL (0U)       /*!< Bit field value for CCM_ANALOG_MISC0_OSC_I: Nominal */
#define BV_CCM_ANALOG_MISC0_OSC_I_MINUS_12_5_PERCENT (0x1U) /*!< Bit field value for CCM_ANALOG_MISC0_OSC_I: Decrease current by 12.5% */
#define BV_CCM_ANALOG_MISC0_OSC_I_MINUS_25_PERCENT (0x2U) /*!< Bit field value for CCM_ANALOG_MISC0_OSC_I: Decrease current by 25.0% */
#define BV_CCM_ANALOG_MISC0_OSC_I_MINUS_37_5_PERCENT (0x3U) /*!< Bit field value for CCM_ANALOG_MISC0_OSC_I: Decrease current by 37.5% */

/*! @brief Read current value of the CCM_ANALOG_MISC0_OSC_I field. */
#define BR_CCM_ANALOG_MISC0_OSC_I(x) (HW_CCM_ANALOG_MISC0(x).B.OSC_I)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_OSC_I. */
#define BF_CCM_ANALOG_MISC0_OSC_I(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_OSC_I) & BM_CCM_ANALOG_MISC0_OSC_I)

/*! @brief Set the OSC_I field to a new value. */
#define BW_CCM_ANALOG_MISC0_OSC_I(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_OSC_I) | BF_CCM_ANALOG_MISC0_OSC_I(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field OSC_XTALOK[16] (RO)
 *
 * Status bit that signals that the output of the 24-MHz crystal oscillator is
 * stable. Generated from a timer and active detection of the actual frequency.Not
 * related to CCM. See Crystal Oscillator (XTALOSC)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_OSC_XTALOK (16U) /*!< Bit position for CCM_ANALOG_MISC0_OSC_XTALOK. */
#define BM_CCM_ANALOG_MISC0_OSC_XTALOK (0x00010000U) /*!< Bit mask for CCM_ANALOG_MISC0_OSC_XTALOK. */
#define BS_CCM_ANALOG_MISC0_OSC_XTALOK (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_OSC_XTALOK. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_OSC_XTALOK field. */
#define BR_CCM_ANALOG_MISC0_OSC_XTALOK(x) (HW_CCM_ANALOG_MISC0(x).B.OSC_XTALOK)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field OSC_XTALOK_EN[17] (RW)
 *
 * This bit enables the detector that signals when the 24MHz crystal oscillator
 * is stable.Not related to CCM. See Crystal Oscillator (XTALOSC)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_OSC_XTALOK_EN (17U) /*!< Bit position for CCM_ANALOG_MISC0_OSC_XTALOK_EN. */
#define BM_CCM_ANALOG_MISC0_OSC_XTALOK_EN (0x00020000U) /*!< Bit mask for CCM_ANALOG_MISC0_OSC_XTALOK_EN. */
#define BS_CCM_ANALOG_MISC0_OSC_XTALOK_EN (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_OSC_XTALOK_EN. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_OSC_XTALOK_EN field. */
#define BR_CCM_ANALOG_MISC0_OSC_XTALOK_EN(x) (HW_CCM_ANALOG_MISC0(x).B.OSC_XTALOK_EN)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_OSC_XTALOK_EN. */
#define BF_CCM_ANALOG_MISC0_OSC_XTALOK_EN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_OSC_XTALOK_EN) & BM_CCM_ANALOG_MISC0_OSC_XTALOK_EN)

/*! @brief Set the OSC_XTALOK_EN field to a new value. */
#define BW_CCM_ANALOG_MISC0_OSC_XTALOK_EN(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_OSC_XTALOK_EN) | BF_CCM_ANALOG_MISC0_OSC_XTALOK_EN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field WBCP_VPW_THRESH[19:18] (RW)
 *
 * This signal alters the voltage that the pwell is charged pumped to.Not
 * related to CCM. See Power Management Unit (PMU)
 *
 * Values:
 * - 00 - Nominal output pwell bias voltage.
 * - 01 - Increase pwell output voltage by 25mV.
 * - 10 - Decrease pwell output pwell voltage by 25mV.
 * - 11 - Decrease pwell output pwell voltage by 50mV.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_WBCP_VPW_THRESH (18U) /*!< Bit position for CCM_ANALOG_MISC0_WBCP_VPW_THRESH. */
#define BM_CCM_ANALOG_MISC0_WBCP_VPW_THRESH (0x000C0000U) /*!< Bit mask for CCM_ANALOG_MISC0_WBCP_VPW_THRESH. */
#define BS_CCM_ANALOG_MISC0_WBCP_VPW_THRESH (2U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_WBCP_VPW_THRESH. */

#define BV_CCM_ANALOG_MISC0_WBCP_VPW_THRESH_NOMINAL_BIAS (0U) /*!< Bit field value for CCM_ANALOG_MISC0_WBCP_VPW_THRESH: Nominal output pwell bias voltage. */
#define BV_CCM_ANALOG_MISC0_WBCP_VPW_THRESH_PLUS_25MV (0x1U) /*!< Bit field value for CCM_ANALOG_MISC0_WBCP_VPW_THRESH: Increase pwell output voltage by 25mV. */
#define BV_CCM_ANALOG_MISC0_WBCP_VPW_THRESH_MINUS_25MV (0x2U) /*!< Bit field value for CCM_ANALOG_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 25mV. */
#define BV_CCM_ANALOG_MISC0_WBCP_VPW_THRESH_MINUS_50MV (0x3U) /*!< Bit field value for CCM_ANALOG_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 50mV. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_WBCP_VPW_THRESH field. */
#define BR_CCM_ANALOG_MISC0_WBCP_VPW_THRESH(x) (HW_CCM_ANALOG_MISC0(x).B.WBCP_VPW_THRESH)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_WBCP_VPW_THRESH. */
#define BF_CCM_ANALOG_MISC0_WBCP_VPW_THRESH(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_WBCP_VPW_THRESH) & BM_CCM_ANALOG_MISC0_WBCP_VPW_THRESH)

/*! @brief Set the WBCP_VPW_THRESH field to a new value. */
#define BW_CCM_ANALOG_MISC0_WBCP_VPW_THRESH(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_WBCP_VPW_THRESH) | BF_CCM_ANALOG_MISC0_WBCP_VPW_THRESH(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field CLKGATE_CTRL[25] (RW)
 *
 * This bit allows disabling the clock gate (always ungated) for the xtal 24MHz
 * clock that clocks the digital logic in the analog block. Do not change the
 * field during a low power event. This is not a field that the user would normally
 * need to modify. Not related to CCM. See Crystal Oscillator (XTALOSC)
 *
 * Values:
 * - 0 - Allow the logic to automatically gate the clock when the XTAL is
 *     powered down.
 * - 1 - Prevent the logic from ever gating off the clock.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_CLKGATE_CTRL (25U) /*!< Bit position for CCM_ANALOG_MISC0_CLKGATE_CTRL. */
#define BM_CCM_ANALOG_MISC0_CLKGATE_CTRL (0x02000000U) /*!< Bit mask for CCM_ANALOG_MISC0_CLKGATE_CTRL. */
#define BS_CCM_ANALOG_MISC0_CLKGATE_CTRL (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_CLKGATE_CTRL. */

#define BV_CCM_ANALOG_MISC0_CLKGATE_CTRL_ALLOW_AUTO_GATE (0U) /*!< Bit field value for CCM_ANALOG_MISC0_CLKGATE_CTRL: Allow the logic to automatically gate the clock when the XTAL is powered down. */
#define BV_CCM_ANALOG_MISC0_CLKGATE_CTRL_NO_AUTO_GATE (0x1U) /*!< Bit field value for CCM_ANALOG_MISC0_CLKGATE_CTRL: Prevent the logic from ever gating off the clock. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_CLKGATE_CTRL field. */
#define BR_CCM_ANALOG_MISC0_CLKGATE_CTRL(x) (HW_CCM_ANALOG_MISC0(x).B.CLKGATE_CTRL)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_CLKGATE_CTRL. */
#define BF_CCM_ANALOG_MISC0_CLKGATE_CTRL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_CLKGATE_CTRL) & BM_CCM_ANALOG_MISC0_CLKGATE_CTRL)

/*! @brief Set the CLKGATE_CTRL field to a new value. */
#define BW_CCM_ANALOG_MISC0_CLKGATE_CTRL(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_CLKGATE_CTRL) | BF_CCM_ANALOG_MISC0_CLKGATE_CTRL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC0, field CLKGATE_DELAY[28:26] (RW)
 *
 * This field specifies the delay between powering up the XTAL 24MHz clock and
 * releasing the clock to the digital logic inside the analog block. Do not change
 * the field during a low power event. This is not a field that the user would
 * normally need to modify. Not related to CCM. See Crystal Oscillator (XTALOSC)
 *
 * Values:
 * - 000 - 0.5ms
 * - 001 - 1.0ms
 * - 010 - 2.0ms
 * - 011 - 3.0ms
 * - 100 - 4.0ms
 * - 101 - 5.0ms
 * - 110 - 6.0ms
 * - 111 - 7.0ms
 */
/*@{*/
#define BP_CCM_ANALOG_MISC0_CLKGATE_DELAY (26U) /*!< Bit position for CCM_ANALOG_MISC0_CLKGATE_DELAY. */
#define BM_CCM_ANALOG_MISC0_CLKGATE_DELAY (0x1C000000U) /*!< Bit mask for CCM_ANALOG_MISC0_CLKGATE_DELAY. */
#define BS_CCM_ANALOG_MISC0_CLKGATE_DELAY (3U) /*!< Bit field size in bits for CCM_ANALOG_MISC0_CLKGATE_DELAY. */

/*! @brief Read current value of the CCM_ANALOG_MISC0_CLKGATE_DELAY field. */
#define BR_CCM_ANALOG_MISC0_CLKGATE_DELAY(x) (HW_CCM_ANALOG_MISC0(x).B.CLKGATE_DELAY)

/*! @brief Format value for bitfield CCM_ANALOG_MISC0_CLKGATE_DELAY. */
#define BF_CCM_ANALOG_MISC0_CLKGATE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC0_CLKGATE_DELAY) & BM_CCM_ANALOG_MISC0_CLKGATE_DELAY)

/*! @brief Set the CLKGATE_DELAY field to a new value. */
#define BW_CCM_ANALOG_MISC0_CLKGATE_DELAY(x, v) (HW_CCM_ANALOG_MISC0_WR(x, (HW_CCM_ANALOG_MISC0_RD(x) & ~BM_CCM_ANALOG_MISC0_CLKGATE_DELAY) | BF_CCM_ANALOG_MISC0_CLKGATE_DELAY(v)))
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_MISC1 - Miscellaneous Register 1
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_MISC1 - Miscellaneous Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control and status bits for miscellaneous analog
 * blocks. The LVDS1 and LVDS2 controls below control the behavior of the
 * anaclk1/1b and anaclk2/2b LVDS IO's.
 */
typedef union _hw_ccm_analog_misc1
{
    uint32_t U;
    struct _hw_ccm_analog_misc1_bitfields
    {
        uint32_t LVDS1_CLK_SEL : 5;    /*!< [4:0]  */
        uint32_t LVDS2_CLK_SEL : 5;    /*!< [9:5]  */
        uint32_t LVDSCLK1_OBEN : 1;    /*!< [10]  */
        uint32_t LVDSCLK2_OBEN : 1;    /*!< [11]  */
        uint32_t LVDSCLK1_IBEN : 1;    /*!< [12]  */
        uint32_t LVDSCLK2_IBEN : 1;    /*!< [13]  */
        uint32_t RESERVED0 : 15;       /*!< [28:14]  */
        uint32_t IRQ_TEMPSENSE : 1;    /*!< [29]  */
        uint32_t IRQ_ANA_BO : 1;       /*!< [30]  */
        uint32_t IRQ_DIG_BO : 1;       /*!< [31]  */
    } B;
} hw_ccm_analog_misc1_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_MISC1 register
 */
/*@{*/
#define HW_CCM_ANALOG_MISC1_ADDR(x) ((uintptr_t)(x) + 0x160U)
#define HW_CCM_ANALOG_MISC1_SET_ADDR(x) (HW_CCM_ANALOG_MISC1_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_MISC1_CLR_ADDR(x) (HW_CCM_ANALOG_MISC1_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_MISC1_TOG_ADDR(x) (HW_CCM_ANALOG_MISC1_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_MISC1(x)   (*(__IO hw_ccm_analog_misc1_t *) HW_CCM_ANALOG_MISC1_ADDR(x))
#define HW_CCM_ANALOG_MISC1_RD(x) (HW_CCM_ANALOG_MISC1(x).U)
#define HW_CCM_ANALOG_MISC1_WR(x, v) (HW_CCM_ANALOG_MISC1(x).U = (v))
#define HW_CCM_ANALOG_MISC1_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC1_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC1_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC1_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC1_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_MISC1 bitfields
 */

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDS1_CLK_SEL[4:0] (RW)
 *
 * This field selects the clk to be routed to anaclk1/1b.
 *
 * Values:
 * - 00000 - Arm PLL
 * - 00001 - System PLL
 * - 00010 - ref_pfd4_clk == pll2_pfd0_clk
 * - 00011 - ref_pfd5_clk == pll2_pfd1_clk
 * - 00100 - ref_pfd6_clk == pll2_pfd2_clk
 * - 00101 - ref_pfd7_clk == pll2_pfd3_clk
 * - 00110 - Audio PLL
 * - 00111 - Video PLL
 * - 01000 - MLB PLL
 * - 01001 - ethernet ref clock (ENET_PLL)
 * - 01010 - PCIe ref clock (125M)
 * - 01011 - SATA ref clock (100M)
 * - 01100 - USB1 PLL clock
 * - 01101 - USB2 PLL clock
 * - 01110 - ref_pfd0_clk == pll3_pfd0_clk
 * - 01111 - ref_pfd1_clk == pll3_pfd1_clk
 * - 10000 - ref_pfd2_clk == pll3_pfd2_clk
 * - 10001 - ref_pfd3_clk == pll3_pfd3_clk
 * - 10010 - xtal (24M)
 * - 10011 - LVDS1 (loopback)
 * - 10100 - LVDS2 (not useful)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDS1_CLK_SEL (0U) /*!< Bit position for CCM_ANALOG_MISC1_LVDS1_CLK_SEL. */
#define BM_CCM_ANALOG_MISC1_LVDS1_CLK_SEL (0x0000001FU) /*!< Bit mask for CCM_ANALOG_MISC1_LVDS1_CLK_SEL. */
#define BS_CCM_ANALOG_MISC1_LVDS1_CLK_SEL (5U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDS1_CLK_SEL. */

#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_ARM_PLL (0U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: Arm PLL */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_SYS_PLL (0x1U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: System PLL */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD4 (0x2U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd4_clk == pll2_pfd0_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD5 (0x3U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd5_clk == pll2_pfd1_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD6 (0x4U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd6_clk == pll2_pfd2_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD7 (0x5U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd7_clk == pll2_pfd3_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_AUDIO_PLL (0x6U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: Audio PLL */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_VIDEO_PLL (0x7U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: Video PLL */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_MLB_PLL (0x8U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: MLB PLL */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_ETHERNET_REF (0x9U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ethernet ref clock (ENET_PLL) */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PCIE_REF (0xAU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: PCIe ref clock (125M) */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_SATA_REF (0xBU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: SATA ref clock (100M) */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_USB1_PLL (0xCU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: USB1 PLL clock */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_USB2_PLL (0xDU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: USB2 PLL clock */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD0 (0xEU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd0_clk == pll3_pfd0_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD1 (0xFU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd1_clk == pll3_pfd1_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD2 (0x10U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd2_clk == pll3_pfd2_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_PFD3 (0x11U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: ref_pfd3_clk == pll3_pfd3_clk */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_XTAL (0x12U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: xtal (24M) */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_LVDS1 (0x13U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: LVDS1 (loopback) */
#define BV_CCM_ANALOG_MISC1_LVDS1_CLK_SEL_LVDS2 (0x14U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS1_CLK_SEL: LVDS2 (not useful) */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDS1_CLK_SEL field. */
#define BR_CCM_ANALOG_MISC1_LVDS1_CLK_SEL(x) (HW_CCM_ANALOG_MISC1(x).B.LVDS1_CLK_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDS1_CLK_SEL. */
#define BF_CCM_ANALOG_MISC1_LVDS1_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDS1_CLK_SEL) & BM_CCM_ANALOG_MISC1_LVDS1_CLK_SEL)

/*! @brief Set the LVDS1_CLK_SEL field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDS1_CLK_SEL(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDS1_CLK_SEL | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDS1_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDS2_CLK_SEL[9:5] (RW)
 *
 * This field selects the clk to be routed to anaclk2/2b.
 *
 * Values:
 * - 00000 - Arm PLL
 * - 00001 - System PLL
 * - 00010 - ref_pfd4_clk == pll2_pfd0_clk
 * - 00011 - ref_pfd5_clk == pll2_pfd1_clk
 * - 00100 - ref_pfd6_clk == pll2_pfd2_clk
 * - 00101 - ref_pfd7_clk == pll2_pfd3_clk
 * - 00110 - Audio PLL
 * - 00111 - Video PLL
 * - 01000 - MLB PLL
 * - 01001 - ethernet ref clock (ENET_PLL)
 * - 01010 - PCIe ref clock (125M)
 * - 01011 - SATA ref clock (100M)
 * - 01100 - USB1 PLL clock
 * - 01101 - USB2 PLL clock
 * - 01110 - ref_pfd0_clk == pll3_pfd0_clk
 * - 01111 - ref_pfd1_clk == pll3_pfd1_clk
 * - 10000 - ref_pfd2_clk == pll3_pfd2_clk
 * - 10001 - ref_pfd3_clk == pll3_pfd3_clk
 * - 10010 - xtal (24M)
 * - 10011 - LVDS1 (loopback)
 * - 10100 - LVDS2 (not useful)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDS2_CLK_SEL (5U) /*!< Bit position for CCM_ANALOG_MISC1_LVDS2_CLK_SEL. */
#define BM_CCM_ANALOG_MISC1_LVDS2_CLK_SEL (0x000003E0U) /*!< Bit mask for CCM_ANALOG_MISC1_LVDS2_CLK_SEL. */
#define BS_CCM_ANALOG_MISC1_LVDS2_CLK_SEL (5U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDS2_CLK_SEL. */

#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_ARM_PLL (0U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: Arm PLL */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_SYS_PLL (0x1U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: System PLL */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD4 (0x2U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd4_clk == pll2_pfd0_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD5 (0x3U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd5_clk == pll2_pfd1_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD6 (0x4U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd6_clk == pll2_pfd2_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD7 (0x5U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd7_clk == pll2_pfd3_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_AUDIO_PLL (0x6U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: Audio PLL */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_VIDEO_PLL (0x7U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: Video PLL */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_MLB_PLL (0x8U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: MLB PLL */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_ETHERNET_REF (0x9U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ethernet ref clock (ENET_PLL) */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PCIE_REF (0xAU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: PCIe ref clock (125M) */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_SATA_REF (0xBU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: SATA ref clock (100M) */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_USB1_PLL (0xCU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: USB1 PLL clock */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_USB2_PLL (0xDU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: USB2 PLL clock */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD0 (0xEU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd0_clk == pll3_pfd0_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD1 (0xFU) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd1_clk == pll3_pfd1_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD2 (0x10U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd2_clk == pll3_pfd2_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_PFD3 (0x11U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: ref_pfd3_clk == pll3_pfd3_clk */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_XTAL (0x12U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: xtal (24M) */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_LVDS1 (0x13U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: LVDS1 (loopback) */
#define BV_CCM_ANALOG_MISC1_LVDS2_CLK_SEL_LVDS2 (0x14U) /*!< Bit field value for CCM_ANALOG_MISC1_LVDS2_CLK_SEL: LVDS2 (not useful) */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDS2_CLK_SEL field. */
#define BR_CCM_ANALOG_MISC1_LVDS2_CLK_SEL(x) (HW_CCM_ANALOG_MISC1(x).B.LVDS2_CLK_SEL)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDS2_CLK_SEL. */
#define BF_CCM_ANALOG_MISC1_LVDS2_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDS2_CLK_SEL) & BM_CCM_ANALOG_MISC1_LVDS2_CLK_SEL)

/*! @brief Set the LVDS2_CLK_SEL field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDS2_CLK_SEL(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDS2_CLK_SEL | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDS2_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDSCLK1_OBEN[10] (RW)
 *
 * This enables the LVDS output buffer for anaclk1/1b. Do not enable input and
 * output buffers simultaneously.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDSCLK1_OBEN (10U) /*!< Bit position for CCM_ANALOG_MISC1_LVDSCLK1_OBEN. */
#define BM_CCM_ANALOG_MISC1_LVDSCLK1_OBEN (0x00000400U) /*!< Bit mask for CCM_ANALOG_MISC1_LVDSCLK1_OBEN. */
#define BS_CCM_ANALOG_MISC1_LVDSCLK1_OBEN (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDSCLK1_OBEN. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDSCLK1_OBEN field. */
#define BR_CCM_ANALOG_MISC1_LVDSCLK1_OBEN(x) (HW_CCM_ANALOG_MISC1(x).B.LVDSCLK1_OBEN)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDSCLK1_OBEN. */
#define BF_CCM_ANALOG_MISC1_LVDSCLK1_OBEN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDSCLK1_OBEN) & BM_CCM_ANALOG_MISC1_LVDSCLK1_OBEN)

/*! @brief Set the LVDSCLK1_OBEN field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDSCLK1_OBEN(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDSCLK1_OBEN | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDSCLK1_OBEN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDSCLK2_OBEN[11] (RW)
 *
 * This enables the LVDS output buffer for anaclk2/2b. Do not enable input and
 * output buffers simultaneously.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDSCLK2_OBEN (11U) /*!< Bit position for CCM_ANALOG_MISC1_LVDSCLK2_OBEN. */
#define BM_CCM_ANALOG_MISC1_LVDSCLK2_OBEN (0x00000800U) /*!< Bit mask for CCM_ANALOG_MISC1_LVDSCLK2_OBEN. */
#define BS_CCM_ANALOG_MISC1_LVDSCLK2_OBEN (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDSCLK2_OBEN. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDSCLK2_OBEN field. */
#define BR_CCM_ANALOG_MISC1_LVDSCLK2_OBEN(x) (HW_CCM_ANALOG_MISC1(x).B.LVDSCLK2_OBEN)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDSCLK2_OBEN. */
#define BF_CCM_ANALOG_MISC1_LVDSCLK2_OBEN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDSCLK2_OBEN) & BM_CCM_ANALOG_MISC1_LVDSCLK2_OBEN)

/*! @brief Set the LVDSCLK2_OBEN field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDSCLK2_OBEN(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDSCLK2_OBEN | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDSCLK2_OBEN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDSCLK1_IBEN[12] (RW)
 *
 * This enables the LVDS input buffer for anaclk1/1b. Do not enable input and
 * output buffers simultaneously.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDSCLK1_IBEN (12U) /*!< Bit position for CCM_ANALOG_MISC1_LVDSCLK1_IBEN. */
#define BM_CCM_ANALOG_MISC1_LVDSCLK1_IBEN (0x00001000U) /*!< Bit mask for CCM_ANALOG_MISC1_LVDSCLK1_IBEN. */
#define BS_CCM_ANALOG_MISC1_LVDSCLK1_IBEN (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDSCLK1_IBEN. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDSCLK1_IBEN field. */
#define BR_CCM_ANALOG_MISC1_LVDSCLK1_IBEN(x) (HW_CCM_ANALOG_MISC1(x).B.LVDSCLK1_IBEN)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDSCLK1_IBEN. */
#define BF_CCM_ANALOG_MISC1_LVDSCLK1_IBEN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDSCLK1_IBEN) & BM_CCM_ANALOG_MISC1_LVDSCLK1_IBEN)

/*! @brief Set the LVDSCLK1_IBEN field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDSCLK1_IBEN(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDSCLK1_IBEN | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDSCLK1_IBEN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field LVDSCLK2_IBEN[13] (RW)
 *
 * This enables the LVDS input buffer for anaclk2/2b. Do not enable input and
 * output buffers simultaneously.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_LVDSCLK2_IBEN (13U) /*!< Bit position for CCM_ANALOG_MISC1_LVDSCLK2_IBEN. */
#define BM_CCM_ANALOG_MISC1_LVDSCLK2_IBEN (0x00002000U) /*!< Bit mask for CCM_ANALOG_MISC1_LVDSCLK2_IBEN. */
#define BS_CCM_ANALOG_MISC1_LVDSCLK2_IBEN (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_LVDSCLK2_IBEN. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_LVDSCLK2_IBEN field. */
#define BR_CCM_ANALOG_MISC1_LVDSCLK2_IBEN(x) (HW_CCM_ANALOG_MISC1(x).B.LVDSCLK2_IBEN)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_LVDSCLK2_IBEN. */
#define BF_CCM_ANALOG_MISC1_LVDSCLK2_IBEN(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_LVDSCLK2_IBEN) & BM_CCM_ANALOG_MISC1_LVDSCLK2_IBEN)

/*! @brief Set the LVDSCLK2_IBEN field to a new value. */
#define BW_CCM_ANALOG_MISC1_LVDSCLK2_IBEN(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_LVDSCLK2_IBEN | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_LVDSCLK2_IBEN(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field IRQ_TEMPSENSE[29] (W1C)
 *
 * This status bit is set to one when when the temperature sensor interrupt
 * asserts.Not related to CCM. See Temperature Monitor (TEMPMON)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_IRQ_TEMPSENSE (29U) /*!< Bit position for CCM_ANALOG_MISC1_IRQ_TEMPSENSE. */
#define BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE (0x20000000U) /*!< Bit mask for CCM_ANALOG_MISC1_IRQ_TEMPSENSE. */
#define BS_CCM_ANALOG_MISC1_IRQ_TEMPSENSE (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_IRQ_TEMPSENSE. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_IRQ_TEMPSENSE field. */
#define BR_CCM_ANALOG_MISC1_IRQ_TEMPSENSE(x) (HW_CCM_ANALOG_MISC1(x).B.IRQ_TEMPSENSE)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_IRQ_TEMPSENSE. */
#define BF_CCM_ANALOG_MISC1_IRQ_TEMPSENSE(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_IRQ_TEMPSENSE) & BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE)

/*! @brief Set the IRQ_TEMPSENSE field to a new value. */
#define BW_CCM_ANALOG_MISC1_IRQ_TEMPSENSE(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_IRQ_TEMPSENSE(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field IRQ_ANA_BO[30] (W1C)
 *
 * This status bit is set to one when when any of the analog regulator brownout
 * interrupts assert. Check the regulator status bits to discover which regulator
 * interrupt asserted.Not related to CCM. See Power Management Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_IRQ_ANA_BO (30U) /*!< Bit position for CCM_ANALOG_MISC1_IRQ_ANA_BO. */
#define BM_CCM_ANALOG_MISC1_IRQ_ANA_BO (0x40000000U) /*!< Bit mask for CCM_ANALOG_MISC1_IRQ_ANA_BO. */
#define BS_CCM_ANALOG_MISC1_IRQ_ANA_BO (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_IRQ_ANA_BO. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_IRQ_ANA_BO field. */
#define BR_CCM_ANALOG_MISC1_IRQ_ANA_BO(x) (HW_CCM_ANALOG_MISC1(x).B.IRQ_ANA_BO)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_IRQ_ANA_BO. */
#define BF_CCM_ANALOG_MISC1_IRQ_ANA_BO(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_IRQ_ANA_BO) & BM_CCM_ANALOG_MISC1_IRQ_ANA_BO)

/*! @brief Set the IRQ_ANA_BO field to a new value. */
#define BW_CCM_ANALOG_MISC1_IRQ_ANA_BO(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_IRQ_ANA_BO | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)) | BF_CCM_ANALOG_MISC1_IRQ_ANA_BO(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC1, field IRQ_DIG_BO[31] (W1C)
 *
 * This status bit is set to one when when any of the digital regulator brownout
 * interrupts assert. Check the regulator status bits to discover which
 * regulator interrupt asserted.Not related to CCM. See Power Management Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC1_IRQ_DIG_BO (31U) /*!< Bit position for CCM_ANALOG_MISC1_IRQ_DIG_BO. */
#define BM_CCM_ANALOG_MISC1_IRQ_DIG_BO (0x80000000U) /*!< Bit mask for CCM_ANALOG_MISC1_IRQ_DIG_BO. */
#define BS_CCM_ANALOG_MISC1_IRQ_DIG_BO (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC1_IRQ_DIG_BO. */

/*! @brief Read current value of the CCM_ANALOG_MISC1_IRQ_DIG_BO field. */
#define BR_CCM_ANALOG_MISC1_IRQ_DIG_BO(x) (HW_CCM_ANALOG_MISC1(x).B.IRQ_DIG_BO)

/*! @brief Format value for bitfield CCM_ANALOG_MISC1_IRQ_DIG_BO. */
#define BF_CCM_ANALOG_MISC1_IRQ_DIG_BO(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC1_IRQ_DIG_BO) & BM_CCM_ANALOG_MISC1_IRQ_DIG_BO)

/*! @brief Set the IRQ_DIG_BO field to a new value. */
#define BW_CCM_ANALOG_MISC1_IRQ_DIG_BO(x, v) (HW_CCM_ANALOG_MISC1_WR(x, (HW_CCM_ANALOG_MISC1_RD(x) & ~(BM_CCM_ANALOG_MISC1_IRQ_DIG_BO | BM_CCM_ANALOG_MISC1_IRQ_TEMPSENSE | BM_CCM_ANALOG_MISC1_IRQ_ANA_BO)) | BF_CCM_ANALOG_MISC1_IRQ_DIG_BO(v)))
/*@}*/




/*******************************************************************************
 * HW_CCM_ANALOG_MISC2 - Miscellaneous Register 2
 ******************************************************************************/

/*!
 * @brief HW_CCM_ANALOG_MISC2 - Miscellaneous Register 2 (RW)
 *
 * Reset value: 0x00272727U
 *
 * This register defines the control for miscellaneous analog blocks. This
 * register is shared with PMU.
 */
typedef union _hw_ccm_analog_misc2
{
    uint32_t U;
    struct _hw_ccm_analog_misc2_bitfields
    {
        uint32_t REG0_BO_OFFSET : 3;   /*!< [2:0]  */
        uint32_t REG0_BO_STATUS : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t REG0_ENABLE_BO : 1;   /*!< [5]  */
        uint32_t RESERVED1 : 1;        /*!< [6]  */
        uint32_t PLL3_disable : 1;     /*!< [7]  */
        uint32_t REG1_BO_OFFSET : 3;   /*!< [10:8]  */
        uint32_t REG1_BO_STATUS : 1;   /*!< [11]  */
        uint32_t RESERVED2 : 1;        /*!< [12]  */
        uint32_t REG1_ENABLE_BO : 1;   /*!< [13]  */
        uint32_t RESERVED3 : 1;        /*!< [14]  */
        uint32_t AUDIO_DIV_LSB : 1;    /*!< [15]  */
        uint32_t REG2_BO_OFFSET : 3;   /*!< [18:16]  */
        uint32_t REG2_BO_STATUS : 1;   /*!< [19]  */
        uint32_t RESERVED4 : 1;        /*!< [20]  */
        uint32_t REG2_ENABLE_BO : 1;   /*!< [21]  */
        uint32_t REG2_OK : 1;          /*!< [22]  */
        uint32_t AUDIO_DIV_MSB : 1;    /*!< [23]  */
        uint32_t REG0_STEP_TIME : 2;   /*!< [25:24]  */
        uint32_t REG1_STEP_TIME : 2;   /*!< [27:26]  */
        uint32_t REG2_STEP_TIME : 2;   /*!< [29:28]  */
        uint32_t VIDEO_DIV : 2;        /*!< [31:30]  */
    } B;
} hw_ccm_analog_misc2_t;

/*!
 * @name Constants and macros for entire CCM_ANALOG_MISC2 register
 */
/*@{*/
#define HW_CCM_ANALOG_MISC2_ADDR(x) ((uintptr_t)(x) + 0x170U)
#define HW_CCM_ANALOG_MISC2_SET_ADDR(x) (HW_CCM_ANALOG_MISC2_ADDR(x) + 0x4U)
#define HW_CCM_ANALOG_MISC2_CLR_ADDR(x) (HW_CCM_ANALOG_MISC2_ADDR(x) + 0x8U)
#define HW_CCM_ANALOG_MISC2_TOG_ADDR(x) (HW_CCM_ANALOG_MISC2_ADDR(x) + 0xCU)

#define HW_CCM_ANALOG_MISC2(x)   (*(__IO hw_ccm_analog_misc2_t *) HW_CCM_ANALOG_MISC2_ADDR(x))
#define HW_CCM_ANALOG_MISC2_RD(x) (HW_CCM_ANALOG_MISC2(x).U)
#define HW_CCM_ANALOG_MISC2_WR(x, v) (HW_CCM_ANALOG_MISC2(x).U = (v))
#define HW_CCM_ANALOG_MISC2_SET(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC2_SET_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC2_CLR(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC2_CLR_ADDR(x)) = (v))
#define HW_CCM_ANALOG_MISC2_TOG(x, v) ((*(uint32_t *) HW_CCM_ANALOG_MISC2_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual CCM_ANALOG_MISC2 bitfields
 */

/*!
 * @name Register CCM_ANALOG_MISC2, field REG0_BO_OFFSET[2:0] (RO)
 *
 * This field defines the brown out voltage offset for the CORE power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. Some steps may be irrelevant because of input supply limitations or
 * load operation.Not related to CCM. See Power Management Unit (PMU)
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG0_BO_OFFSET (0U) /*!< Bit position for CCM_ANALOG_MISC2_REG0_BO_OFFSET. */
#define BM_CCM_ANALOG_MISC2_REG0_BO_OFFSET (0x00000007U) /*!< Bit mask for CCM_ANALOG_MISC2_REG0_BO_OFFSET. */
#define BS_CCM_ANALOG_MISC2_REG0_BO_OFFSET (3U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG0_BO_OFFSET. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG0_BO_OFFSET field. */
#define BR_CCM_ANALOG_MISC2_REG0_BO_OFFSET(x) (HW_CCM_ANALOG_MISC2(x).B.REG0_BO_OFFSET)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG0_BO_STATUS[3] (RO)
 *
 * Reg0 brownout status bit.Not related to CCM. See Power Management Unit (PMU)
 *
 * Values:
 * - 1 - Brownout, supply is below target minus brownout offset.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG0_BO_STATUS (3U) /*!< Bit position for CCM_ANALOG_MISC2_REG0_BO_STATUS. */
#define BM_CCM_ANALOG_MISC2_REG0_BO_STATUS (0x00000008U) /*!< Bit mask for CCM_ANALOG_MISC2_REG0_BO_STATUS. */
#define BS_CCM_ANALOG_MISC2_REG0_BO_STATUS (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG0_BO_STATUS. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG0_BO_STATUS field. */
#define BR_CCM_ANALOG_MISC2_REG0_BO_STATUS(x) (HW_CCM_ANALOG_MISC2(x).B.REG0_BO_STATUS)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG0_ENABLE_BO[5] (RW)
 *
 * Enables the brownout detection.Not related to CCM. See Power Management Unit
 * (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG0_ENABLE_BO (5U) /*!< Bit position for CCM_ANALOG_MISC2_REG0_ENABLE_BO. */
#define BM_CCM_ANALOG_MISC2_REG0_ENABLE_BO (0x00000020U) /*!< Bit mask for CCM_ANALOG_MISC2_REG0_ENABLE_BO. */
#define BS_CCM_ANALOG_MISC2_REG0_ENABLE_BO (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG0_ENABLE_BO. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG0_ENABLE_BO field. */
#define BR_CCM_ANALOG_MISC2_REG0_ENABLE_BO(x) (HW_CCM_ANALOG_MISC2(x).B.REG0_ENABLE_BO)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG0_ENABLE_BO. */
#define BF_CCM_ANALOG_MISC2_REG0_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG0_ENABLE_BO) & BM_CCM_ANALOG_MISC2_REG0_ENABLE_BO)

/*! @brief Set the REG0_ENABLE_BO field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG0_ENABLE_BO(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG0_ENABLE_BO) | BF_CCM_ANALOG_MISC2_REG0_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field PLL3_disable[7] (RW)
 *
 * When USB is in low power suspend mode this Control bit is used to indicate if
 * other system peripherals require the USB PLL3 clock when the SoC is not in
 * low power mode. A user needs to set this bit if they want to optionally disable
 * PLL3 while the SoC is not in any low power mode to save power. When the system
 * does go into low power mode this bit setting would not have any affect. When
 * USB is in low power suspend mode users would need to ensure PLL3 is not being
 * used before setting this bit in RUN mode. Please refer to the correct PLL
 * disabling procedure in Disabling / Enabling PLLsPLL disabling and enabling is done
 * via analog module.
 *
 * Values:
 * - 0 - PLL3 is being used by peripherals and is enabled when SoC is not in any
 *     low power mode
 * - 1 - PLL3 can be disabled when the SoC is not in any low power mode
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_PLL3_disable (7U) /*!< Bit position for CCM_ANALOG_MISC2_PLL3_disable. */
#define BM_CCM_ANALOG_MISC2_PLL3_disable (0x00000080U) /*!< Bit mask for CCM_ANALOG_MISC2_PLL3_disable. */
#define BS_CCM_ANALOG_MISC2_PLL3_disable (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_PLL3_disable. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_PLL3_disable field. */
#define BR_CCM_ANALOG_MISC2_PLL3_disable(x) (HW_CCM_ANALOG_MISC2(x).B.PLL3_disable)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_PLL3_disable. */
#define BF_CCM_ANALOG_MISC2_PLL3_disable(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_PLL3_disable) & BM_CCM_ANALOG_MISC2_PLL3_disable)

/*! @brief Set the PLL3_disable field to a new value. */
#define BW_CCM_ANALOG_MISC2_PLL3_disable(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_PLL3_disable) | BF_CCM_ANALOG_MISC2_PLL3_disable(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG1_BO_OFFSET[10:8] (RO)
 *
 * This field defines the brown out voltage offset for the xPU power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. The reset brown-offset is 175mV below the programmed target code.
 * Brownout target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of
 * input supply limitations or load operation.Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG1_BO_OFFSET (8U) /*!< Bit position for CCM_ANALOG_MISC2_REG1_BO_OFFSET. */
#define BM_CCM_ANALOG_MISC2_REG1_BO_OFFSET (0x00000700U) /*!< Bit mask for CCM_ANALOG_MISC2_REG1_BO_OFFSET. */
#define BS_CCM_ANALOG_MISC2_REG1_BO_OFFSET (3U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG1_BO_OFFSET. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG1_BO_OFFSET field. */
#define BR_CCM_ANALOG_MISC2_REG1_BO_OFFSET(x) (HW_CCM_ANALOG_MISC2(x).B.REG1_BO_OFFSET)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG1_BO_STATUS[11] (RO)
 *
 * Reg1 brownout status bit. Not related to CCM. See Power Management Unit (PMU)
 *
 * Values:
 * - 1 - Brownout, supply is below target minus brownout offset.
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG1_BO_STATUS (11U) /*!< Bit position for CCM_ANALOG_MISC2_REG1_BO_STATUS. */
#define BM_CCM_ANALOG_MISC2_REG1_BO_STATUS (0x00000800U) /*!< Bit mask for CCM_ANALOG_MISC2_REG1_BO_STATUS. */
#define BS_CCM_ANALOG_MISC2_REG1_BO_STATUS (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG1_BO_STATUS. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG1_BO_STATUS field. */
#define BR_CCM_ANALOG_MISC2_REG1_BO_STATUS(x) (HW_CCM_ANALOG_MISC2(x).B.REG1_BO_STATUS)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG1_ENABLE_BO[13] (RW)
 *
 * Enables the brownout detection.Not related to CCM. See Power Management Unit
 * (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG1_ENABLE_BO (13U) /*!< Bit position for CCM_ANALOG_MISC2_REG1_ENABLE_BO. */
#define BM_CCM_ANALOG_MISC2_REG1_ENABLE_BO (0x00002000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG1_ENABLE_BO. */
#define BS_CCM_ANALOG_MISC2_REG1_ENABLE_BO (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG1_ENABLE_BO. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG1_ENABLE_BO field. */
#define BR_CCM_ANALOG_MISC2_REG1_ENABLE_BO(x) (HW_CCM_ANALOG_MISC2(x).B.REG1_ENABLE_BO)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG1_ENABLE_BO. */
#define BF_CCM_ANALOG_MISC2_REG1_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG1_ENABLE_BO) & BM_CCM_ANALOG_MISC2_REG1_ENABLE_BO)

/*! @brief Set the REG1_ENABLE_BO field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG1_ENABLE_BO(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG1_ENABLE_BO) | BF_CCM_ANALOG_MISC2_REG1_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field AUDIO_DIV_LSB[15] (RW)
 *
 * LSB of Post-divider for Audio PLL. The output clock of the video PLL should
 * be gated prior to changing this divider to prevent glitches. This divider is
 * feed by PLL_AUDIOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4,
 * /8, and /16. LSB bit value pertains to the last bit, please program the MSB bit
 * (bit 23) as well, to change divider value for more information.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_AUDIO_DIV_LSB (15U) /*!< Bit position for CCM_ANALOG_MISC2_AUDIO_DIV_LSB. */
#define BM_CCM_ANALOG_MISC2_AUDIO_DIV_LSB (0x00008000U) /*!< Bit mask for CCM_ANALOG_MISC2_AUDIO_DIV_LSB. */
#define BS_CCM_ANALOG_MISC2_AUDIO_DIV_LSB (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_AUDIO_DIV_LSB. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_AUDIO_DIV_LSB field. */
#define BR_CCM_ANALOG_MISC2_AUDIO_DIV_LSB(x) (HW_CCM_ANALOG_MISC2(x).B.AUDIO_DIV_LSB)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_AUDIO_DIV_LSB. */
#define BF_CCM_ANALOG_MISC2_AUDIO_DIV_LSB(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_AUDIO_DIV_LSB) & BM_CCM_ANALOG_MISC2_AUDIO_DIV_LSB)

/*! @brief Set the AUDIO_DIV_LSB field to a new value. */
#define BW_CCM_ANALOG_MISC2_AUDIO_DIV_LSB(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_AUDIO_DIV_LSB) | BF_CCM_ANALOG_MISC2_AUDIO_DIV_LSB(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG2_BO_OFFSET[18:16] (RO)
 *
 * This field defines the brown out voltage offset for the xPU power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. The reset brown-offset is 175mV below the programmed target code.
 * Brownout target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of
 * input supply limitations or load operation.Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG2_BO_OFFSET (16U) /*!< Bit position for CCM_ANALOG_MISC2_REG2_BO_OFFSET. */
#define BM_CCM_ANALOG_MISC2_REG2_BO_OFFSET (0x00070000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG2_BO_OFFSET. */
#define BS_CCM_ANALOG_MISC2_REG2_BO_OFFSET (3U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG2_BO_OFFSET. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG2_BO_OFFSET field. */
#define BR_CCM_ANALOG_MISC2_REG2_BO_OFFSET(x) (HW_CCM_ANALOG_MISC2(x).B.REG2_BO_OFFSET)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG2_BO_STATUS[19] (RO)
 *
 * Reg2 brownout status bit.Not related to CCM. See Power Management Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG2_BO_STATUS (19U) /*!< Bit position for CCM_ANALOG_MISC2_REG2_BO_STATUS. */
#define BM_CCM_ANALOG_MISC2_REG2_BO_STATUS (0x00080000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG2_BO_STATUS. */
#define BS_CCM_ANALOG_MISC2_REG2_BO_STATUS (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG2_BO_STATUS. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG2_BO_STATUS field. */
#define BR_CCM_ANALOG_MISC2_REG2_BO_STATUS(x) (HW_CCM_ANALOG_MISC2(x).B.REG2_BO_STATUS)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG2_ENABLE_BO[21] (RW)
 *
 * Enables the brownout detection.Not related to CCM. See Power Management Unit
 * (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG2_ENABLE_BO (21U) /*!< Bit position for CCM_ANALOG_MISC2_REG2_ENABLE_BO. */
#define BM_CCM_ANALOG_MISC2_REG2_ENABLE_BO (0x00200000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG2_ENABLE_BO. */
#define BS_CCM_ANALOG_MISC2_REG2_ENABLE_BO (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG2_ENABLE_BO. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG2_ENABLE_BO field. */
#define BR_CCM_ANALOG_MISC2_REG2_ENABLE_BO(x) (HW_CCM_ANALOG_MISC2(x).B.REG2_ENABLE_BO)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG2_ENABLE_BO. */
#define BF_CCM_ANALOG_MISC2_REG2_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG2_ENABLE_BO) & BM_CCM_ANALOG_MISC2_REG2_ENABLE_BO)

/*! @brief Set the REG2_ENABLE_BO field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG2_ENABLE_BO(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG2_ENABLE_BO) | BF_CCM_ANALOG_MISC2_REG2_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG2_OK[22] (RO)
 *
 * Signals that the voltage is above the brownout level for the SOC supply. 1 =
 * regulator output > brownout_target Not related to CCM. See Power Management
 * Unit (PMU)
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG2_OK (22U)  /*!< Bit position for CCM_ANALOG_MISC2_REG2_OK. */
#define BM_CCM_ANALOG_MISC2_REG2_OK (0x00400000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG2_OK. */
#define BS_CCM_ANALOG_MISC2_REG2_OK (1U)   /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG2_OK. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG2_OK field. */
#define BR_CCM_ANALOG_MISC2_REG2_OK(x) (HW_CCM_ANALOG_MISC2(x).B.REG2_OK)
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field AUDIO_DIV_MSB[23] (RW)
 *
 * MSB of Post-divider for Audio PLL. The output clock of the video PLL should
 * be gated prior to changing this divider to prevent glitches. This divider is
 * feed by PLL_AUDIOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4,
 * /8, and /16. MSB bit value pertains to the first bit, please program the LSB bit
 * (bit 15) as well to change divider value for more information.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_AUDIO_DIV_MSB (23U) /*!< Bit position for CCM_ANALOG_MISC2_AUDIO_DIV_MSB. */
#define BM_CCM_ANALOG_MISC2_AUDIO_DIV_MSB (0x00800000U) /*!< Bit mask for CCM_ANALOG_MISC2_AUDIO_DIV_MSB. */
#define BS_CCM_ANALOG_MISC2_AUDIO_DIV_MSB (1U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_AUDIO_DIV_MSB. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_AUDIO_DIV_MSB field. */
#define BR_CCM_ANALOG_MISC2_AUDIO_DIV_MSB(x) (HW_CCM_ANALOG_MISC2(x).B.AUDIO_DIV_MSB)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_AUDIO_DIV_MSB. */
#define BF_CCM_ANALOG_MISC2_AUDIO_DIV_MSB(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_AUDIO_DIV_MSB) & BM_CCM_ANALOG_MISC2_AUDIO_DIV_MSB)

/*! @brief Set the AUDIO_DIV_MSB field to a new value. */
#define BW_CCM_ANALOG_MISC2_AUDIO_DIV_MSB(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_AUDIO_DIV_MSB) | BF_CCM_ANALOG_MISC2_AUDIO_DIV_MSB(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG0_STEP_TIME[25:24] (RW)
 *
 * Number of clock periods (24MHz clock).Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG0_STEP_TIME (24U) /*!< Bit position for CCM_ANALOG_MISC2_REG0_STEP_TIME. */
#define BM_CCM_ANALOG_MISC2_REG0_STEP_TIME (0x03000000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG0_STEP_TIME. */
#define BS_CCM_ANALOG_MISC2_REG0_STEP_TIME (2U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG0_STEP_TIME. */

#define BV_CCM_ANALOG_MISC2_REG0_STEP_TIME_64_CLOCKS (0U) /*!< Bit field value for CCM_ANALOG_MISC2_REG0_STEP_TIME: 64 */
#define BV_CCM_ANALOG_MISC2_REG0_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for CCM_ANALOG_MISC2_REG0_STEP_TIME: 128 */
#define BV_CCM_ANALOG_MISC2_REG0_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for CCM_ANALOG_MISC2_REG0_STEP_TIME: 256 */
#define BV_CCM_ANALOG_MISC2_REG0_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for CCM_ANALOG_MISC2_REG0_STEP_TIME: 512 */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG0_STEP_TIME field. */
#define BR_CCM_ANALOG_MISC2_REG0_STEP_TIME(x) (HW_CCM_ANALOG_MISC2(x).B.REG0_STEP_TIME)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG0_STEP_TIME. */
#define BF_CCM_ANALOG_MISC2_REG0_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG0_STEP_TIME) & BM_CCM_ANALOG_MISC2_REG0_STEP_TIME)

/*! @brief Set the REG0_STEP_TIME field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG0_STEP_TIME(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG0_STEP_TIME) | BF_CCM_ANALOG_MISC2_REG0_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG1_STEP_TIME[27:26] (RW)
 *
 * Number of clock periods (24MHz clock).Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG1_STEP_TIME (26U) /*!< Bit position for CCM_ANALOG_MISC2_REG1_STEP_TIME. */
#define BM_CCM_ANALOG_MISC2_REG1_STEP_TIME (0x0C000000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG1_STEP_TIME. */
#define BS_CCM_ANALOG_MISC2_REG1_STEP_TIME (2U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG1_STEP_TIME. */

#define BV_CCM_ANALOG_MISC2_REG1_STEP_TIME_64_CLOCKS (0U) /*!< Bit field value for CCM_ANALOG_MISC2_REG1_STEP_TIME: 64 */
#define BV_CCM_ANALOG_MISC2_REG1_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for CCM_ANALOG_MISC2_REG1_STEP_TIME: 128 */
#define BV_CCM_ANALOG_MISC2_REG1_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for CCM_ANALOG_MISC2_REG1_STEP_TIME: 256 */
#define BV_CCM_ANALOG_MISC2_REG1_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for CCM_ANALOG_MISC2_REG1_STEP_TIME: 512 */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG1_STEP_TIME field. */
#define BR_CCM_ANALOG_MISC2_REG1_STEP_TIME(x) (HW_CCM_ANALOG_MISC2(x).B.REG1_STEP_TIME)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG1_STEP_TIME. */
#define BF_CCM_ANALOG_MISC2_REG1_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG1_STEP_TIME) & BM_CCM_ANALOG_MISC2_REG1_STEP_TIME)

/*! @brief Set the REG1_STEP_TIME field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG1_STEP_TIME(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG1_STEP_TIME) | BF_CCM_ANALOG_MISC2_REG1_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field REG2_STEP_TIME[29:28] (RW)
 *
 * Number of clock periods (24MHz clock).Not related to CCM. See Power
 * Management Unit (PMU)
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_REG2_STEP_TIME (28U) /*!< Bit position for CCM_ANALOG_MISC2_REG2_STEP_TIME. */
#define BM_CCM_ANALOG_MISC2_REG2_STEP_TIME (0x30000000U) /*!< Bit mask for CCM_ANALOG_MISC2_REG2_STEP_TIME. */
#define BS_CCM_ANALOG_MISC2_REG2_STEP_TIME (2U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_REG2_STEP_TIME. */

#define BV_CCM_ANALOG_MISC2_REG2_STEP_TIME_64_CLOCKS (0U) /*!< Bit field value for CCM_ANALOG_MISC2_REG2_STEP_TIME: 64 */
#define BV_CCM_ANALOG_MISC2_REG2_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for CCM_ANALOG_MISC2_REG2_STEP_TIME: 128 */
#define BV_CCM_ANALOG_MISC2_REG2_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for CCM_ANALOG_MISC2_REG2_STEP_TIME: 256 */
#define BV_CCM_ANALOG_MISC2_REG2_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for CCM_ANALOG_MISC2_REG2_STEP_TIME: 512 */

/*! @brief Read current value of the CCM_ANALOG_MISC2_REG2_STEP_TIME field. */
#define BR_CCM_ANALOG_MISC2_REG2_STEP_TIME(x) (HW_CCM_ANALOG_MISC2(x).B.REG2_STEP_TIME)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_REG2_STEP_TIME. */
#define BF_CCM_ANALOG_MISC2_REG2_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_REG2_STEP_TIME) & BM_CCM_ANALOG_MISC2_REG2_STEP_TIME)

/*! @brief Set the REG2_STEP_TIME field to a new value. */
#define BW_CCM_ANALOG_MISC2_REG2_STEP_TIME(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_REG2_STEP_TIME) | BF_CCM_ANALOG_MISC2_REG2_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register CCM_ANALOG_MISC2, field VIDEO_DIV[31:30] (RW)
 *
 * Post-divider for video. The output clock of the video PLL should be gated
 * prior to changing this divider to prevent glitches. This divider is feed by
 * PLL_VIDEOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4, /8, and /16.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 * - 10 - divide by 1
 * - 11 - divide by 4
 */
/*@{*/
#define BP_CCM_ANALOG_MISC2_VIDEO_DIV (30U) /*!< Bit position for CCM_ANALOG_MISC2_VIDEO_DIV. */
#define BM_CCM_ANALOG_MISC2_VIDEO_DIV (0xC0000000U) /*!< Bit mask for CCM_ANALOG_MISC2_VIDEO_DIV. */
#define BS_CCM_ANALOG_MISC2_VIDEO_DIV (2U) /*!< Bit field size in bits for CCM_ANALOG_MISC2_VIDEO_DIV. */

/*! @brief Read current value of the CCM_ANALOG_MISC2_VIDEO_DIV field. */
#define BR_CCM_ANALOG_MISC2_VIDEO_DIV(x) (HW_CCM_ANALOG_MISC2(x).B.VIDEO_DIV)

/*! @brief Format value for bitfield CCM_ANALOG_MISC2_VIDEO_DIV. */
#define BF_CCM_ANALOG_MISC2_VIDEO_DIV(v) ((uint32_t)((uint32_t)(v) << BP_CCM_ANALOG_MISC2_VIDEO_DIV) & BM_CCM_ANALOG_MISC2_VIDEO_DIV)

/*! @brief Set the VIDEO_DIV field to a new value. */
#define BW_CCM_ANALOG_MISC2_VIDEO_DIV(x, v) (HW_CCM_ANALOG_MISC2_WR(x, (HW_CCM_ANALOG_MISC2_RD(x) & ~BM_CCM_ANALOG_MISC2_VIDEO_DIV) | BF_CCM_ANALOG_MISC2_VIDEO_DIV(v)))
/*@}*/




/*******************************************************************************
 * hw_ccm_analog_t - module struct
 ******************************************************************************/
/*!
 * @brief All CCM_ANALOG module registers.
 */
#pragma pack(1)
typedef struct _hw_ccm_analog
{
    __IO hw_ccm_analog_pll_arm_t PLL_ARM;  /*!< [0x0] Analog ARM PLL control Register */
    uint8_t _reserved0[12];
    __IO hw_ccm_analog_pll_usb1_t PLL_USB1; /*!< [0x10] Analog USB1 480MHz PLL Control Register */
    uint8_t _reserved1[12];
    __IO hw_ccm_analog_pll_usb2_t PLL_USB2; /*!< [0x20] Analog USB2 480MHz PLL Control Register */
    uint8_t _reserved2[12];
    __IO hw_ccm_analog_pll_sys_t PLL_SYS;  /*!< [0x30] Analog System PLL Control Register */
    uint8_t _reserved3[12];
    __IO hw_ccm_analog_pll_sys_ss_t PLL_SYS_SS; /*!< [0x40] 528MHz System PLL Spread Spectrum Register */
    uint8_t _reserved4[12];
    __IO hw_ccm_analog_pll_sys_num_t PLL_SYS_NUM; /*!< [0x50] Numerator of 528MHz System PLL Fractional Loop Divider Register */
    uint8_t _reserved5[12];
    __IO hw_ccm_analog_pll_sys_denom_t PLL_SYS_DENOM; /*!< [0x60] Denominator of 528MHz System PLL Fractional Loop Divider Register */
    uint8_t _reserved6[12];
    __IO hw_ccm_analog_pll_audio_t PLL_AUDIO; /*!< [0x70] Analog Audio PLL control Register */
    uint8_t _reserved7[12];
    __IO hw_ccm_analog_pll_audio_num_t PLL_AUDIO_NUM; /*!< [0x80] Numerator of Audio PLL Fractional Loop Divider Register */
    uint8_t _reserved8[12];
    __IO hw_ccm_analog_pll_audio_denom_t PLL_AUDIO_DENOM; /*!< [0x90] Denominator of Audio PLL Fractional Loop Divider Register */
    uint8_t _reserved9[12];
    __IO hw_ccm_analog_pll_video_t PLL_VIDEO; /*!< [0xA0] Analog Video PLL control Register */
    uint8_t _reserved10[12];
    __IO hw_ccm_analog_pll_video_num_t PLL_VIDEO_NUM; /*!< [0xB0] Numerator of Video PLL Fractional Loop Divider Register */
    uint8_t _reserved11[12];
    __IO hw_ccm_analog_pll_video_denom_t PLL_VIDEO_DENOM; /*!< [0xC0] Denominator of Video PLL Fractional Loop Divider Register */
    uint8_t _reserved12[12];
    __IO hw_ccm_analog_pll_mlb_t PLL_MLB;  /*!< [0xD0] MLB PLL Control Register */
    uint8_t _reserved13[12];
    __IO hw_ccm_analog_pll_enet_t PLL_ENET; /*!< [0xE0] Analog ENET PLL Control Register */
    uint8_t _reserved14[12];
    __IO hw_ccm_analog_pfd_480_t PFD_480;  /*!< [0xF0] 480MHz Clock (PLL3) Phase Fractional Divider Control Register */
    uint8_t _reserved15[12];
    __IO hw_ccm_analog_pfd_528_t PFD_528;  /*!< [0x100] 528MHz Clock (PLL2) Phase Fractional Divider Control Register */
    uint8_t _reserved16[76];
    __IO hw_ccm_analog_misc0_t MISC0;      /*!< [0x150] Miscellaneous Register 0 */
    uint8_t _reserved17[12];
    __IO hw_ccm_analog_misc1_t MISC1;      /*!< [0x160] Miscellaneous Register 1 */
    uint8_t _reserved18[12];
    __IO hw_ccm_analog_misc2_t MISC2;      /*!< [0x170] Miscellaneous Register 2 */
} hw_ccm_analog_t;
#pragma pack()

/*! @brief Macro to access all CCM_ANALOG registers. */
/*! @param x CCM_ANALOG module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_CCM_ANALOG_REGS(CCM_ANALOG_BASE)</code>. */
#define HW_CCM_ANALOG_REGS(x) (*(hw_ccm_analog_t *)(x))

/*
 * iMX6DP CSI2IPU
 *
 * CSI2IPU
 *
 * Registers defined in this header file:
 * - HW_CSI2IPU_SW_RST - CSI 2 IPU Gasket Software Reset
 *
 * - hw_csi2ipu_t - Struct containing all module registers.
 */

#define HW_CSI2IPU_INSTANCE_COUNT (1U) /*!< Number of instances of the CSI2IPU module. */
#define HW_CSI2IPU (0U) /*!< Instance number for CSI2IPU. */
#define CSI2IPU_BASE          (0x21DC000U) /*!< Base address for CSI2IPU. */
/*! Array initializer of CSI2IPU base addresses. */
#define CSI2IPU_BASE_ADDRS    { CSI2IPU_BASE }

/*******************************************************************************
 * HW_CSI2IPU_SW_RST - CSI 2 IPU Gasket Software Reset
 ******************************************************************************/

/*!
 * @brief HW_CSI2IPU_SW_RST - CSI 2 IPU Gasket Software Reset (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register describes the IPU interface signals.
 */
typedef union _hw_csi2ipu_sw_rst
{
    uint32_t U;
    struct _hw_csi2ipu_sw_rst_bitfields
    {
        uint32_t SW_RST : 1;           /*!< [0]  */
        uint32_t CLK_SEL : 1;          /*!< [1]  */
        uint32_t YUV422_8BIT_FM : 1;   /*!< [2]  */
        uint32_t RGB444_FM : 1;        /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_csi2ipu_sw_rst_t;

/*!
 * @name Constants and macros for entire CSI2IPU_SW_RST register
 */
/*@{*/
#define HW_CSI2IPU_SW_RST_ADDR(x) ((uintptr_t)(x) + 0xF00U)

#define HW_CSI2IPU_SW_RST(x)     (*(__IO hw_csi2ipu_sw_rst_t *) HW_CSI2IPU_SW_RST_ADDR(x))
#define HW_CSI2IPU_SW_RST_RD(x)  (HW_CSI2IPU_SW_RST(x).U)
#define HW_CSI2IPU_SW_RST_WR(x, v) (HW_CSI2IPU_SW_RST(x).U = (v))
#define HW_CSI2IPU_SW_RST_SET(x, v) (HW_CSI2IPU_SW_RST_WR(x, HW_CSI2IPU_SW_RST_RD(x) |  (v)))
#define HW_CSI2IPU_SW_RST_CLR(x, v) (HW_CSI2IPU_SW_RST_WR(x, HW_CSI2IPU_SW_RST_RD(x) & ~(v)))
#define HW_CSI2IPU_SW_RST_TOG(x, v) (HW_CSI2IPU_SW_RST_WR(x, HW_CSI2IPU_SW_RST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSI2IPU_SW_RST bitfields
 */

/*!
 * @name Register CSI2IPU_SW_RST, field SW_RST[0] (RW)
 *
 * Software Reset
 *
 * Values:
 * - 0 - Software Reset Disable
 * - 1 - Software Reset Enable
 */
/*@{*/
#define BP_CSI2IPU_SW_RST_SW_RST (0U)      /*!< Bit position for CSI2IPU_SW_RST_SW_RST. */
#define BM_CSI2IPU_SW_RST_SW_RST (0x00000001U) /*!< Bit mask for CSI2IPU_SW_RST_SW_RST. */
#define BS_CSI2IPU_SW_RST_SW_RST (1U)      /*!< Bit field size in bits for CSI2IPU_SW_RST_SW_RST. */

/*! @brief Read current value of the CSI2IPU_SW_RST_SW_RST field. */
#define BR_CSI2IPU_SW_RST_SW_RST(x) (HW_CSI2IPU_SW_RST(x).B.SW_RST)

/*! @brief Format value for bitfield CSI2IPU_SW_RST_SW_RST. */
#define BF_CSI2IPU_SW_RST_SW_RST(v) ((uint32_t)((uint32_t)(v) << BP_CSI2IPU_SW_RST_SW_RST) & BM_CSI2IPU_SW_RST_SW_RST)

/*! @brief Set the SW_RST field to a new value. */
#define BW_CSI2IPU_SW_RST_SW_RST(x, v) (HW_CSI2IPU_SW_RST_WR(x, (HW_CSI2IPU_SW_RST_RD(x) & ~BM_CSI2IPU_SW_RST_SW_RST) | BF_CSI2IPU_SW_RST_SW_RST(v)))
/*@}*/

/*!
 * @name Register CSI2IPU_SW_RST, field CLK_SEL[1] (RW)
 *
 * Clock mode selection
 *
 * Values:
 * - 0 - Gated Mode
 * - 1 - Non-Gated Mode
 */
/*@{*/
#define BP_CSI2IPU_SW_RST_CLK_SEL (1U)     /*!< Bit position for CSI2IPU_SW_RST_CLK_SEL. */
#define BM_CSI2IPU_SW_RST_CLK_SEL (0x00000002U) /*!< Bit mask for CSI2IPU_SW_RST_CLK_SEL. */
#define BS_CSI2IPU_SW_RST_CLK_SEL (1U)     /*!< Bit field size in bits for CSI2IPU_SW_RST_CLK_SEL. */

/*! @brief Read current value of the CSI2IPU_SW_RST_CLK_SEL field. */
#define BR_CSI2IPU_SW_RST_CLK_SEL(x) (HW_CSI2IPU_SW_RST(x).B.CLK_SEL)

/*! @brief Format value for bitfield CSI2IPU_SW_RST_CLK_SEL. */
#define BF_CSI2IPU_SW_RST_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_CSI2IPU_SW_RST_CLK_SEL) & BM_CSI2IPU_SW_RST_CLK_SEL)

/*! @brief Set the CLK_SEL field to a new value. */
#define BW_CSI2IPU_SW_RST_CLK_SEL(x, v) (HW_CSI2IPU_SW_RST_WR(x, (HW_CSI2IPU_SW_RST_RD(x) & ~BM_CSI2IPU_SW_RST_CLK_SEL) | BF_CSI2IPU_SW_RST_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register CSI2IPU_SW_RST, field YUV422_8BIT_FM[2] (RW)
 *
 * YUV422 8-bit mode selection
 *
 * Values:
 * - 0 - YUYV
 * - 1 - UYVY
 */
/*@{*/
#define BP_CSI2IPU_SW_RST_YUV422_8BIT_FM (2U) /*!< Bit position for CSI2IPU_SW_RST_YUV422_8BIT_FM. */
#define BM_CSI2IPU_SW_RST_YUV422_8BIT_FM (0x00000004U) /*!< Bit mask for CSI2IPU_SW_RST_YUV422_8BIT_FM. */
#define BS_CSI2IPU_SW_RST_YUV422_8BIT_FM (1U) /*!< Bit field size in bits for CSI2IPU_SW_RST_YUV422_8BIT_FM. */

/*! @brief Read current value of the CSI2IPU_SW_RST_YUV422_8BIT_FM field. */
#define BR_CSI2IPU_SW_RST_YUV422_8BIT_FM(x) (HW_CSI2IPU_SW_RST(x).B.YUV422_8BIT_FM)

/*! @brief Format value for bitfield CSI2IPU_SW_RST_YUV422_8BIT_FM. */
#define BF_CSI2IPU_SW_RST_YUV422_8BIT_FM(v) ((uint32_t)((uint32_t)(v) << BP_CSI2IPU_SW_RST_YUV422_8BIT_FM) & BM_CSI2IPU_SW_RST_YUV422_8BIT_FM)

/*! @brief Set the YUV422_8BIT_FM field to a new value. */
#define BW_CSI2IPU_SW_RST_YUV422_8BIT_FM(x, v) (HW_CSI2IPU_SW_RST_WR(x, (HW_CSI2IPU_SW_RST_RD(x) & ~BM_CSI2IPU_SW_RST_YUV422_8BIT_FM) | BF_CSI2IPU_SW_RST_YUV422_8BIT_FM(v)))
/*@}*/

/*!
 * @name Register CSI2IPU_SW_RST, field RGB444_FM[3] (RW)
 *
 * rgb444 mode selection
 *
 * Values:
 * - 0 - {4'h0,r4b4g4}
 * - 1 - {r4,1'b0,g4,2'b00,b4,1'b0}
 */
/*@{*/
#define BP_CSI2IPU_SW_RST_RGB444_FM (3U)   /*!< Bit position for CSI2IPU_SW_RST_RGB444_FM. */
#define BM_CSI2IPU_SW_RST_RGB444_FM (0x00000008U) /*!< Bit mask for CSI2IPU_SW_RST_RGB444_FM. */
#define BS_CSI2IPU_SW_RST_RGB444_FM (1U)   /*!< Bit field size in bits for CSI2IPU_SW_RST_RGB444_FM. */

/*! @brief Read current value of the CSI2IPU_SW_RST_RGB444_FM field. */
#define BR_CSI2IPU_SW_RST_RGB444_FM(x) (HW_CSI2IPU_SW_RST(x).B.RGB444_FM)

/*! @brief Format value for bitfield CSI2IPU_SW_RST_RGB444_FM. */
#define BF_CSI2IPU_SW_RST_RGB444_FM(v) ((uint32_t)((uint32_t)(v) << BP_CSI2IPU_SW_RST_RGB444_FM) & BM_CSI2IPU_SW_RST_RGB444_FM)

/*! @brief Set the RGB444_FM field to a new value. */
#define BW_CSI2IPU_SW_RST_RGB444_FM(x, v) (HW_CSI2IPU_SW_RST_WR(x, (HW_CSI2IPU_SW_RST_RD(x) & ~BM_CSI2IPU_SW_RST_RGB444_FM) | BF_CSI2IPU_SW_RST_RGB444_FM(v)))
/*@}*/

/*******************************************************************************
 * hw_csi2ipu_t - module struct
 ******************************************************************************/
/*!
 * @brief All CSI2IPU module registers.
 */
#pragma pack(1)
typedef struct _hw_csi2ipu
{
    uint8_t _reserved0[3840];
    __IO hw_csi2ipu_sw_rst_t SW_RST;       /*!< [0xF00] CSI 2 IPU Gasket Software Reset */
} hw_csi2ipu_t;
#pragma pack()

/*! @brief Macro to access all CSI2IPU registers. */
/*! @param x CSI2IPU module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_CSI2IPU_REGS(CSI2IPU_BASE)</code>. */
#define HW_CSI2IPU_REGS(x) (*(hw_csi2ipu_t *)(x))

/*
 * iMX6DP CSU
 *
 * CSU Registers
 *
 * Registers defined in this header file:
 * - HW_CSU_CSLn - Config security level register
 * - HW_CSU_HP0 - HP0 register
 * - HW_CSU_HP1 - HP1 register
 * - HW_CSU_SA - Secure access register
 * - HW_CSU_HPCONTROL0 - HPCONTROL0 register
 * - HW_CSU_HPCONTROL1 - HPCONTROL1 register
 *
 * - hw_csu_t - Struct containing all module registers.
 */

#define HW_CSU_INSTANCE_COUNT (1U) /*!< Number of instances of the CSU module. */
#define HW_CSU (0U) /*!< Instance number for CSU. */
#define CSU_BASE              (0x21C0000U) /*!< Base address for CSU. */
/*! Array initializer of CSU base addresses. */
#define CSU_BASE_ADDRS        { CSU_BASE }

/*******************************************************************************
 * HW_CSU_CSLn - Config security level register
 ******************************************************************************/

/*!
 * @brief HW_CSU_CSLn - Config security level register (RW)
 *
 * Reset value: 0x00330033U
 *
 * There are 40 Config Security Level (CSU_CSL0-CSU_CSL39) registers. Each
 * CSU_CSL is comprised of two fields, each field used to determine the read and write
 * access permissions for a slave peripheral. These 8-bit fields for the first
 * and second slaves are in the locations b23-b16 and bits b7-b0, respectively.
 * Permission Access Table shows security levels and csu_sec_level signal levels
 * corresponding to different values of the 8-bit CSU_CSL field for a given slave.
 * Most slaves have unique CSL registers. Some slaves are grouped together in
 * USB, Timers, PowerUp and Audio groups. The following table shows allocation of
 * CSL register per slave or group of slave modules. CSL Slave Modules Mapping
 * Slave Module Corresponding CSL register and bit field Comments PWM1 PWM2 PWM3 PWM4
 * PWM5 PWM6 PWM7 PWM8 CSL0 [7:0] Audio group shared control CAN1 CSL0 [23:16]
 * CAN2 CSL1 [7:0] GPT EPIT1 EPIT2 CSL1 [23:16] Timers group GPIO1 GPIO2 CSL2
 * [7:0] GPIO1 and GPIO2 group GPIO3 GPIO4 CSL2 [23:16] GPIO3 and GPIO4 group GPIO5
 * GPIO6 CSL3 [7:0] GPIO5 and GPIO6 group GPIO7 CSL3 [23:16] KPP CSL4 [7:0] WDOG1
 * CSL4 [23:16] WDOG2 CSL5 [7:0] CCM SNVS_HP SRC GPC CSL5 [23:16] Power group
 * IP2APB_ANATOP CSL6 [7:0] IOMUXC CSL6 [23:16] DCIC1 DCIC2 CSL7 [7:0] SDMA (port
 * IPS_HOST) CSL7 [23:16] USBOH 3 (port PL301) USBOH 3 (port USB) CSL8 [7:0] ENET1,
 * ENET2 CSL8 [23:16] MLB150 CSL9 [7:0] USDHC1 CSL9 [23:16] USDHC2 CSL10 [7:0]
 * USDHC3 CSL10 [23:16] USDHC4 CSL11 [7:0] I2C1 CSL11 [23:16] I2C2 CSL12 [7:0]
 * I2C3 CSL12 [23:16] ROMCP CSL13[7:0] VPU MMDC_CORE (port IPS_P0) CSL13 [23:16]
 * MMDC Group WEIM CSL14 [7:0] OCOTP_CTRL CSL14 [23:16] Reserved CSL15 [7:0]
 * PERFMON1 PERFMON2 PERFMON3 CSL15 [23:16] PerfMon group TZASC1 CSL16 [7:0] TZASC2
 * CSL16 [23:16] AUDMUX CSL17 [7:0] CAAM CSL17 [23:16] SPDIF CSL18 [7:0] eCSPI1 CSL18
 * [23:16] eCSPI2 CSL19 [7:0] eCSPI3 CSL19 [23:16] eCSPI4 CSL20 [7:0] eCSPI5
 * CSL20 [23:16] UART1 CSL21 [7:0] ESAI1 CSL21 [23:16] SSI1 CSL22 [7:0] SSI2 CSL22
 * [23:16] SSI3 CSL23 [7:0] ASRC (VIA IPSYNC) CSL23 [23:16] Reserved CSL24 [7:0]
 * ROMCP CSL24 [23:16] Reserved CSL25 [7:0] Reserved CSL25 [23:16] Reserved CSL26
 * [7:0] Reserved CSL26 [23:16] APBH_DMA CSL27 [7:0] HDMI CSL27 [23:16] GPU3D
 * CSL28[7:0] SATA CSL28 [23:16] OPENVG CSL29 [7:0] ARM core platform DAP and
 * platform controller CSL29 [23:16] HSI CSL30 [7:0] IPU1 CSL30 [23:16] IPU2 CSL31
 * [7:0] EIM CSL31 [23:16] PCIE CSL32 [7:0] GPU2D CSL32 [23:16] MIPI_CORE_CSI CSL33
 * [7:0] MIPI_CORE_HSI CSL33 [23:16] VDOA CSL34 [7:0] UART2 CSL34 [23:16] UART3
 * CSL35 [7:0] UART4 CSL35 [23:16] UART5 CSL36 [7:0] DTCP CSL36 [23:16] Reserved
 * CSL37 [7:0] Reserved CSL37 [23:16] Reserved CSL38 [7:0] Reserved CSL38 [23:16]
 * SPBA CSL39 [7:0] Reserved CSL39 [23:16] Do not modify the following
 * peripherals' CSL register bits while they are being accessed through the AHB/AXI slave
 * bus: EIM, IPU, APBHDMA and PCIe.
 */
typedef union _hw_csu_csln
{
    uint32_t U;
    struct _hw_csu_csln_bitfields
    {
        uint32_t SUR_S2 : 1;           /*!< [0]  */
        uint32_t SSR_S2 : 1;           /*!< [1]  */
        uint32_t NUR_S2 : 1;           /*!< [2]  */
        uint32_t NSR_S2 : 1;           /*!< [3]  */
        uint32_t SUW_S2 : 1;           /*!< [4]  */
        uint32_t SSW_S2 : 1;           /*!< [5]  */
        uint32_t NUW_S2 : 1;           /*!< [6]  */
        uint32_t NSW_S2 : 1;           /*!< [7]  */
        uint32_t LOCK_S2 : 1;          /*!< [8]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t SUR_S1 : 1;           /*!< [16]  */
        uint32_t SSR_S1 : 1;           /*!< [17]  */
        uint32_t NUR_S1 : 1;           /*!< [18]  */
        uint32_t NSR_S1 : 1;           /*!< [19]  */
        uint32_t SUW_S1 : 1;           /*!< [20]  */
        uint32_t SSW_S1 : 1;           /*!< [21]  */
        uint32_t NUW_S1 : 1;           /*!< [22]  */
        uint32_t NSW_S1 : 1;           /*!< [23]  */
        uint32_t LOCK_S1 : 1;          /*!< [24]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_csu_csln_t;

/*!
 * @name Constants and macros for entire CSU_CSLn register
 */
/*@{*/
#define HW_CSU_CSLn_COUNT (40U)

#define HW_CSU_CSLn_ADDR(x, n)   ((uintptr_t)(x) + 0x0U + (0x4U * (n)))

#define HW_CSU_CSLn(x, n)        (*(__IO hw_csu_csln_t *) HW_CSU_CSLn_ADDR(x, n))
#define HW_CSU_CSLn_RD(x, n)     (HW_CSU_CSLn(x, n).U)
#define HW_CSU_CSLn_WR(x, n, v)  (HW_CSU_CSLn(x, n).U = (v))
#define HW_CSU_CSLn_SET(x, n, v) (HW_CSU_CSLn_WR(x, n, HW_CSU_CSLn_RD(x, n) |  (v)))
#define HW_CSU_CSLn_CLR(x, n, v) (HW_CSU_CSLn_WR(x, n, HW_CSU_CSLn_RD(x, n) & ~(v)))
#define HW_CSU_CSLn_TOG(x, n, v) (HW_CSU_CSLn_WR(x, n, HW_CSU_CSLn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_CSLn bitfields
 */

/*!
 * @name Register CSU_CSLn, field SUR_S2[0] (RW)
 *
 * Secure user read access control for the second slave
 *
 * Values:
 * - 0 - Secure user read access disabled for the second slave.
 * - 1 - Secure user read access enabled for the second slave
 */
/*@{*/
#define BP_CSU_CSLn_SUR_S2   (0U)          /*!< Bit position for CSU_CSLn_SUR_S2. */
#define BM_CSU_CSLn_SUR_S2   (0x00000001U) /*!< Bit mask for CSU_CSLn_SUR_S2. */
#define BS_CSU_CSLn_SUR_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_SUR_S2. */

/*! @brief Read current value of the CSU_CSLn_SUR_S2 field. */
#define BR_CSU_CSLn_SUR_S2(x, n) (HW_CSU_CSLn(x, n).B.SUR_S2)

/*! @brief Format value for bitfield CSU_CSLn_SUR_S2. */
#define BF_CSU_CSLn_SUR_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SUR_S2) & BM_CSU_CSLn_SUR_S2)

/*! @brief Set the SUR_S2 field to a new value. */
#define BW_CSU_CSLn_SUR_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SUR_S2) | BF_CSU_CSLn_SUR_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SSR_S2[1] (RW)
 *
 * Secure supervisor read access control for the second slave
 *
 * Values:
 * - 0 - Secure supervisor read access disabled for the second slave.
 * - 1 - Secure supervisor read access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_SSR_S2   (1U)          /*!< Bit position for CSU_CSLn_SSR_S2. */
#define BM_CSU_CSLn_SSR_S2   (0x00000002U) /*!< Bit mask for CSU_CSLn_SSR_S2. */
#define BS_CSU_CSLn_SSR_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_SSR_S2. */

/*! @brief Read current value of the CSU_CSLn_SSR_S2 field. */
#define BR_CSU_CSLn_SSR_S2(x, n) (HW_CSU_CSLn(x, n).B.SSR_S2)

/*! @brief Format value for bitfield CSU_CSLn_SSR_S2. */
#define BF_CSU_CSLn_SSR_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SSR_S2) & BM_CSU_CSLn_SSR_S2)

/*! @brief Set the SSR_S2 field to a new value. */
#define BW_CSU_CSLn_SSR_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SSR_S2) | BF_CSU_CSLn_SSR_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NUR_S2[2] (RW)
 *
 * Non-secure user read access control for the second slave
 *
 * Values:
 * - 0 - Non-secure user read access disabled for the second slave.
 * - 1 - Non-secure user read access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_NUR_S2   (2U)          /*!< Bit position for CSU_CSLn_NUR_S2. */
#define BM_CSU_CSLn_NUR_S2   (0x00000004U) /*!< Bit mask for CSU_CSLn_NUR_S2. */
#define BS_CSU_CSLn_NUR_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_NUR_S2. */

/*! @brief Read current value of the CSU_CSLn_NUR_S2 field. */
#define BR_CSU_CSLn_NUR_S2(x, n) (HW_CSU_CSLn(x, n).B.NUR_S2)

/*! @brief Format value for bitfield CSU_CSLn_NUR_S2. */
#define BF_CSU_CSLn_NUR_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NUR_S2) & BM_CSU_CSLn_NUR_S2)

/*! @brief Set the NUR_S2 field to a new value. */
#define BW_CSU_CSLn_NUR_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NUR_S2) | BF_CSU_CSLn_NUR_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NSR_S2[3] (RW)
 *
 * Non-secure supervisor read access control for the second slave
 *
 * Values:
 * - 0 - Non-secure supervisor read access disabled for the second slave.
 * - 1 - Non-secure supervisor read access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_NSR_S2   (3U)          /*!< Bit position for CSU_CSLn_NSR_S2. */
#define BM_CSU_CSLn_NSR_S2   (0x00000008U) /*!< Bit mask for CSU_CSLn_NSR_S2. */
#define BS_CSU_CSLn_NSR_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_NSR_S2. */

/*! @brief Read current value of the CSU_CSLn_NSR_S2 field. */
#define BR_CSU_CSLn_NSR_S2(x, n) (HW_CSU_CSLn(x, n).B.NSR_S2)

/*! @brief Format value for bitfield CSU_CSLn_NSR_S2. */
#define BF_CSU_CSLn_NSR_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NSR_S2) & BM_CSU_CSLn_NSR_S2)

/*! @brief Set the NSR_S2 field to a new value. */
#define BW_CSU_CSLn_NSR_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NSR_S2) | BF_CSU_CSLn_NSR_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SUW_S2[4] (RW)
 *
 * Secure user write access control for the second slave
 *
 * Values:
 * - 0 - Secure user write access disabled for the second slave.
 * - 1 - Secure user write access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_SUW_S2   (4U)          /*!< Bit position for CSU_CSLn_SUW_S2. */
#define BM_CSU_CSLn_SUW_S2   (0x00000010U) /*!< Bit mask for CSU_CSLn_SUW_S2. */
#define BS_CSU_CSLn_SUW_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_SUW_S2. */

/*! @brief Read current value of the CSU_CSLn_SUW_S2 field. */
#define BR_CSU_CSLn_SUW_S2(x, n) (HW_CSU_CSLn(x, n).B.SUW_S2)

/*! @brief Format value for bitfield CSU_CSLn_SUW_S2. */
#define BF_CSU_CSLn_SUW_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SUW_S2) & BM_CSU_CSLn_SUW_S2)

/*! @brief Set the SUW_S2 field to a new value. */
#define BW_CSU_CSLn_SUW_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SUW_S2) | BF_CSU_CSLn_SUW_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SSW_S2[5] (RW)
 *
 * Secure supervisor write access control for the second slave
 *
 * Values:
 * - 0 - Secure supervisor write access disabled for the second slave.
 * - 1 - Secure supervisor write access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_SSW_S2   (5U)          /*!< Bit position for CSU_CSLn_SSW_S2. */
#define BM_CSU_CSLn_SSW_S2   (0x00000020U) /*!< Bit mask for CSU_CSLn_SSW_S2. */
#define BS_CSU_CSLn_SSW_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_SSW_S2. */

/*! @brief Read current value of the CSU_CSLn_SSW_S2 field. */
#define BR_CSU_CSLn_SSW_S2(x, n) (HW_CSU_CSLn(x, n).B.SSW_S2)

/*! @brief Format value for bitfield CSU_CSLn_SSW_S2. */
#define BF_CSU_CSLn_SSW_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SSW_S2) & BM_CSU_CSLn_SSW_S2)

/*! @brief Set the SSW_S2 field to a new value. */
#define BW_CSU_CSLn_SSW_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SSW_S2) | BF_CSU_CSLn_SSW_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NUW_S2[6] (RW)
 *
 * Non-secure user write access control for the second slave
 *
 * Values:
 * - 0 - Non-secure user write access disabled for the second slave.
 * - 1 - Non-secure user write access enabled for the second slave.
 */
/*@{*/
#define BP_CSU_CSLn_NUW_S2   (6U)          /*!< Bit position for CSU_CSLn_NUW_S2. */
#define BM_CSU_CSLn_NUW_S2   (0x00000040U) /*!< Bit mask for CSU_CSLn_NUW_S2. */
#define BS_CSU_CSLn_NUW_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_NUW_S2. */

/*! @brief Read current value of the CSU_CSLn_NUW_S2 field. */
#define BR_CSU_CSLn_NUW_S2(x, n) (HW_CSU_CSLn(x, n).B.NUW_S2)

/*! @brief Format value for bitfield CSU_CSLn_NUW_S2. */
#define BF_CSU_CSLn_NUW_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NUW_S2) & BM_CSU_CSLn_NUW_S2)

/*! @brief Set the NUW_S2 field to a new value. */
#define BW_CSU_CSLn_NUW_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NUW_S2) | BF_CSU_CSLn_NUW_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NSW_S2[7] (RW)
 *
 * Non-secure supervisor write access control for the second slave
 *
 * Values:
 * - 0 - Non-secure supervisor write access disabled for the second slave.
 * - 1 - Non-secure supervisor write access enabled for the second slave
 */
/*@{*/
#define BP_CSU_CSLn_NSW_S2   (7U)          /*!< Bit position for CSU_CSLn_NSW_S2. */
#define BM_CSU_CSLn_NSW_S2   (0x00000080U) /*!< Bit mask for CSU_CSLn_NSW_S2. */
#define BS_CSU_CSLn_NSW_S2   (1U)          /*!< Bit field size in bits for CSU_CSLn_NSW_S2. */

/*! @brief Read current value of the CSU_CSLn_NSW_S2 field. */
#define BR_CSU_CSLn_NSW_S2(x, n) (HW_CSU_CSLn(x, n).B.NSW_S2)

/*! @brief Format value for bitfield CSU_CSLn_NSW_S2. */
#define BF_CSU_CSLn_NSW_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NSW_S2) & BM_CSU_CSLn_NSW_S2)

/*! @brief Set the NSW_S2 field to a new value. */
#define BW_CSU_CSLn_NSW_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NSW_S2) | BF_CSU_CSLn_NSW_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field LOCK_S2[8] (RW)
 *
 * Lock bit corresponding to the second slave. Written by secure software.
 *
 * Values:
 * - 0 - Not locked. Bits 7-0 may be written by software
 * - 1 - Bits 7-0 locked and cannot be written by software
 */
/*@{*/
#define BP_CSU_CSLn_LOCK_S2  (8U)          /*!< Bit position for CSU_CSLn_LOCK_S2. */
#define BM_CSU_CSLn_LOCK_S2  (0x00000100U) /*!< Bit mask for CSU_CSLn_LOCK_S2. */
#define BS_CSU_CSLn_LOCK_S2  (1U)          /*!< Bit field size in bits for CSU_CSLn_LOCK_S2. */

/*! @brief Read current value of the CSU_CSLn_LOCK_S2 field. */
#define BR_CSU_CSLn_LOCK_S2(x, n) (HW_CSU_CSLn(x, n).B.LOCK_S2)

/*! @brief Format value for bitfield CSU_CSLn_LOCK_S2. */
#define BF_CSU_CSLn_LOCK_S2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_LOCK_S2) & BM_CSU_CSLn_LOCK_S2)

/*! @brief Set the LOCK_S2 field to a new value. */
#define BW_CSU_CSLn_LOCK_S2(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_LOCK_S2) | BF_CSU_CSLn_LOCK_S2(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SUR_S1[16] (RW)
 *
 * Secure user read access control for the first slave
 *
 * Values:
 * - 0 - Secure user read access disabled for the first slave.
 * - 1 - Secure user read access enabled for the first slave
 */
/*@{*/
#define BP_CSU_CSLn_SUR_S1   (16U)         /*!< Bit position for CSU_CSLn_SUR_S1. */
#define BM_CSU_CSLn_SUR_S1   (0x00010000U) /*!< Bit mask for CSU_CSLn_SUR_S1. */
#define BS_CSU_CSLn_SUR_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_SUR_S1. */

/*! @brief Read current value of the CSU_CSLn_SUR_S1 field. */
#define BR_CSU_CSLn_SUR_S1(x, n) (HW_CSU_CSLn(x, n).B.SUR_S1)

/*! @brief Format value for bitfield CSU_CSLn_SUR_S1. */
#define BF_CSU_CSLn_SUR_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SUR_S1) & BM_CSU_CSLn_SUR_S1)

/*! @brief Set the SUR_S1 field to a new value. */
#define BW_CSU_CSLn_SUR_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SUR_S1) | BF_CSU_CSLn_SUR_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SSR_S1[17] (RW)
 *
 * Secure supervisor read access control for the first slave
 *
 * Values:
 * - 0 - Secure supervisor read access disabled for the first slave.
 * - 1 - Secure supervisor read access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_SSR_S1   (17U)         /*!< Bit position for CSU_CSLn_SSR_S1. */
#define BM_CSU_CSLn_SSR_S1   (0x00020000U) /*!< Bit mask for CSU_CSLn_SSR_S1. */
#define BS_CSU_CSLn_SSR_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_SSR_S1. */

/*! @brief Read current value of the CSU_CSLn_SSR_S1 field. */
#define BR_CSU_CSLn_SSR_S1(x, n) (HW_CSU_CSLn(x, n).B.SSR_S1)

/*! @brief Format value for bitfield CSU_CSLn_SSR_S1. */
#define BF_CSU_CSLn_SSR_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SSR_S1) & BM_CSU_CSLn_SSR_S1)

/*! @brief Set the SSR_S1 field to a new value. */
#define BW_CSU_CSLn_SSR_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SSR_S1) | BF_CSU_CSLn_SSR_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NUR_S1[18] (RW)
 *
 * Non-secure user read access control for the first slave
 *
 * Values:
 * - 0 - Non-secure user read access disabled for the first slave.
 * - 1 - Non-secure user read access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_NUR_S1   (18U)         /*!< Bit position for CSU_CSLn_NUR_S1. */
#define BM_CSU_CSLn_NUR_S1   (0x00040000U) /*!< Bit mask for CSU_CSLn_NUR_S1. */
#define BS_CSU_CSLn_NUR_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_NUR_S1. */

/*! @brief Read current value of the CSU_CSLn_NUR_S1 field. */
#define BR_CSU_CSLn_NUR_S1(x, n) (HW_CSU_CSLn(x, n).B.NUR_S1)

/*! @brief Format value for bitfield CSU_CSLn_NUR_S1. */
#define BF_CSU_CSLn_NUR_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NUR_S1) & BM_CSU_CSLn_NUR_S1)

/*! @brief Set the NUR_S1 field to a new value. */
#define BW_CSU_CSLn_NUR_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NUR_S1) | BF_CSU_CSLn_NUR_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NSR_S1[19] (RW)
 *
 * Non-secure supervisor read access control for the first slave
 *
 * Values:
 * - 0 - Non-secure supervisor read access disabled for the first slave.
 * - 1 - Non-secure supervisor read access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_NSR_S1   (19U)         /*!< Bit position for CSU_CSLn_NSR_S1. */
#define BM_CSU_CSLn_NSR_S1   (0x00080000U) /*!< Bit mask for CSU_CSLn_NSR_S1. */
#define BS_CSU_CSLn_NSR_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_NSR_S1. */

/*! @brief Read current value of the CSU_CSLn_NSR_S1 field. */
#define BR_CSU_CSLn_NSR_S1(x, n) (HW_CSU_CSLn(x, n).B.NSR_S1)

/*! @brief Format value for bitfield CSU_CSLn_NSR_S1. */
#define BF_CSU_CSLn_NSR_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NSR_S1) & BM_CSU_CSLn_NSR_S1)

/*! @brief Set the NSR_S1 field to a new value. */
#define BW_CSU_CSLn_NSR_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NSR_S1) | BF_CSU_CSLn_NSR_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SUW_S1[20] (RW)
 *
 * Secure user write access control for the first slave
 *
 * Values:
 * - 0 - Secure user write access disabled for the first slave.
 * - 1 - Secure user write access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_SUW_S1   (20U)         /*!< Bit position for CSU_CSLn_SUW_S1. */
#define BM_CSU_CSLn_SUW_S1   (0x00100000U) /*!< Bit mask for CSU_CSLn_SUW_S1. */
#define BS_CSU_CSLn_SUW_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_SUW_S1. */

/*! @brief Read current value of the CSU_CSLn_SUW_S1 field. */
#define BR_CSU_CSLn_SUW_S1(x, n) (HW_CSU_CSLn(x, n).B.SUW_S1)

/*! @brief Format value for bitfield CSU_CSLn_SUW_S1. */
#define BF_CSU_CSLn_SUW_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SUW_S1) & BM_CSU_CSLn_SUW_S1)

/*! @brief Set the SUW_S1 field to a new value. */
#define BW_CSU_CSLn_SUW_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SUW_S1) | BF_CSU_CSLn_SUW_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field SSW_S1[21] (RW)
 *
 * Secure supervisor write access control for the first slave
 *
 * Values:
 * - 0 - Secure supervisor write access disabled for the first slave.
 * - 1 - Secure supervisor write access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_SSW_S1   (21U)         /*!< Bit position for CSU_CSLn_SSW_S1. */
#define BM_CSU_CSLn_SSW_S1   (0x00200000U) /*!< Bit mask for CSU_CSLn_SSW_S1. */
#define BS_CSU_CSLn_SSW_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_SSW_S1. */

/*! @brief Read current value of the CSU_CSLn_SSW_S1 field. */
#define BR_CSU_CSLn_SSW_S1(x, n) (HW_CSU_CSLn(x, n).B.SSW_S1)

/*! @brief Format value for bitfield CSU_CSLn_SSW_S1. */
#define BF_CSU_CSLn_SSW_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_SSW_S1) & BM_CSU_CSLn_SSW_S1)

/*! @brief Set the SSW_S1 field to a new value. */
#define BW_CSU_CSLn_SSW_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_SSW_S1) | BF_CSU_CSLn_SSW_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NUW_S1[22] (RW)
 *
 * Non-secure user write access control for the first slave
 *
 * Values:
 * - 0 - Non-secure user write access disabled for the first slave.
 * - 1 - Non-secure user write access enabled for the first slave.
 */
/*@{*/
#define BP_CSU_CSLn_NUW_S1   (22U)         /*!< Bit position for CSU_CSLn_NUW_S1. */
#define BM_CSU_CSLn_NUW_S1   (0x00400000U) /*!< Bit mask for CSU_CSLn_NUW_S1. */
#define BS_CSU_CSLn_NUW_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_NUW_S1. */

/*! @brief Read current value of the CSU_CSLn_NUW_S1 field. */
#define BR_CSU_CSLn_NUW_S1(x, n) (HW_CSU_CSLn(x, n).B.NUW_S1)

/*! @brief Format value for bitfield CSU_CSLn_NUW_S1. */
#define BF_CSU_CSLn_NUW_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NUW_S1) & BM_CSU_CSLn_NUW_S1)

/*! @brief Set the NUW_S1 field to a new value. */
#define BW_CSU_CSLn_NUW_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NUW_S1) | BF_CSU_CSLn_NUW_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field NSW_S1[23] (RW)
 *
 * Non-secure supervisor write access control for the first slave
 *
 * Values:
 * - 0 - Non-secure supervisor write access disabled for the first slave.
 * - 1 - Non-secure supervisor write access enabled for the first slave
 */
/*@{*/
#define BP_CSU_CSLn_NSW_S1   (23U)         /*!< Bit position for CSU_CSLn_NSW_S1. */
#define BM_CSU_CSLn_NSW_S1   (0x00800000U) /*!< Bit mask for CSU_CSLn_NSW_S1. */
#define BS_CSU_CSLn_NSW_S1   (1U)          /*!< Bit field size in bits for CSU_CSLn_NSW_S1. */

/*! @brief Read current value of the CSU_CSLn_NSW_S1 field. */
#define BR_CSU_CSLn_NSW_S1(x, n) (HW_CSU_CSLn(x, n).B.NSW_S1)

/*! @brief Format value for bitfield CSU_CSLn_NSW_S1. */
#define BF_CSU_CSLn_NSW_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_NSW_S1) & BM_CSU_CSLn_NSW_S1)

/*! @brief Set the NSW_S1 field to a new value. */
#define BW_CSU_CSLn_NSW_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_NSW_S1) | BF_CSU_CSLn_NSW_S1(v)))
/*@}*/

/*!
 * @name Register CSU_CSLn, field LOCK_S1[24] (RW)
 *
 * Lock bit corresponding to the first slave. Written by secure software.
 *
 * Values:
 * - 0 - Not locked. Bits 16-23 may be written by software
 * - 1 - Bits 16-23 locked and cannot be written by software
 */
/*@{*/
#define BP_CSU_CSLn_LOCK_S1  (24U)         /*!< Bit position for CSU_CSLn_LOCK_S1. */
#define BM_CSU_CSLn_LOCK_S1  (0x01000000U) /*!< Bit mask for CSU_CSLn_LOCK_S1. */
#define BS_CSU_CSLn_LOCK_S1  (1U)          /*!< Bit field size in bits for CSU_CSLn_LOCK_S1. */

/*! @brief Read current value of the CSU_CSLn_LOCK_S1 field. */
#define BR_CSU_CSLn_LOCK_S1(x, n) (HW_CSU_CSLn(x, n).B.LOCK_S1)

/*! @brief Format value for bitfield CSU_CSLn_LOCK_S1. */
#define BF_CSU_CSLn_LOCK_S1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_CSLn_LOCK_S1) & BM_CSU_CSLn_LOCK_S1)

/*! @brief Set the LOCK_S1 field to a new value. */
#define BW_CSU_CSLn_LOCK_S1(x, n, v) (HW_CSU_CSLn_WR(x, n, (HW_CSU_CSLn_RD(x, n) & ~BM_CSU_CSLn_LOCK_S1) | BF_CSU_CSLn_LOCK_S1(v)))
/*@}*/

/*******************************************************************************
 * HW_CSU_HP0 - HP0 register
 ******************************************************************************/

/*!
 * @brief HW_CSU_HP0 - HP0 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SCU_HP0 and SCU_HP1 registers may be programmed to determine the
 * privilege (either User Mode or Supervisor Mode) for seventeen different master groups.
 * The privilege of a particular master group may be overridden by muxing it
 * with the corresponding bit in this register. The even bit positions
 * (CSU_HP0[30,28,...0] and CSU_HP1[0]) in the registers hold the privilege indicator bits;
 * while the odd bit positions (CSU_HP0[31,29,...,1] and CSU_HP1[1]) contain lock
 * bits which enable/disable writing to the corresponding privilege indicator bits.
 */
typedef union _hw_csu_hp0
{
    uint32_t U;
    struct _hw_csu_hp0_bitfields
    {
        uint32_t HP_PCIE : 1;          /*!< [0]  */
        uint32_t L_PCIE : 1;           /*!< [1]  */
        uint32_t HP_SATA : 1;          /*!< [2]  */
        uint32_t L_SATA : 1;           /*!< [3]  */
        uint32_t HP_SDMA : 1;          /*!< [4]  */
        uint32_t L_SDMA : 1;           /*!< [5]  */
        uint32_t HP_PU : 1;            /*!< [6]  */
        uint32_t L_PU : 1;             /*!< [7]  */
        uint32_t HP_USB : 1;           /*!< [8]  */
        uint32_t L_USB : 1;            /*!< [9]  */
        uint32_t HP_TEST : 1;          /*!< [10]  */
        uint32_t L_TEST : 1;           /*!< [11]  */
        uint32_t HP_MLB : 1;           /*!< [12]  */
        uint32_t L_MLB : 1;            /*!< [13]  */
        uint32_t HP_CAAM : 1;          /*!< [14]  */
        uint32_t L_CAAM : 1;           /*!< [15]  */
        uint32_t HP_RAWNAND : 1;       /*!< [16]  */
        uint32_t L_RAWNAND : 1;        /*!< [17]  */
        uint32_t HP_APBHDMA : 1;       /*!< [18]  */
        uint32_t L_ABPHDMA : 1;        /*!< [19]  */
        uint32_t HP_ENET : 1;          /*!< [20]  */
        uint32_t L_ENET : 1;           /*!< [21]  */
        uint32_t HP_DAP : 1;           /*!< [22]  */
        uint32_t L_DAP : 1;            /*!< [23]  */
        uint32_t HP_USDHC1 : 1;        /*!< [24]  */
        uint32_t L_USDHC1 : 1;         /*!< [25]  */
        uint32_t HP_USDHC2 : 1;        /*!< [26]  */
        uint32_t L_USDHC2 : 1;         /*!< [27]  */
        uint32_t HP_USDHC3 : 1;        /*!< [28]  */
        uint32_t L_USDHC3 : 1;         /*!< [29]  */
        uint32_t HP_USDHC4 : 1;        /*!< [30]  */
        uint32_t L_USDHC4 : 1;         /*!< [31]  */
    } B;
} hw_csu_hp0_t;

/*!
 * @name Constants and macros for entire CSU_HP0 register
 */
/*@{*/
#define HW_CSU_HP0_ADDR(x)       ((uintptr_t)(x) + 0x200U)

#define HW_CSU_HP0(x)            (*(__IO hw_csu_hp0_t *) HW_CSU_HP0_ADDR(x))
#define HW_CSU_HP0_RD(x)         (HW_CSU_HP0(x).U)
#define HW_CSU_HP0_WR(x, v)      (HW_CSU_HP0(x).U = (v))
#define HW_CSU_HP0_SET(x, v)     (HW_CSU_HP0_WR(x, HW_CSU_HP0_RD(x) |  (v)))
#define HW_CSU_HP0_CLR(x, v)     (HW_CSU_HP0_WR(x, HW_CSU_HP0_RD(x) & ~(v)))
#define HW_CSU_HP0_TOG(x, v)     (HW_CSU_HP0_WR(x, HW_CSU_HP0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_HP0 bitfields
 */

/*!
 * @name Register CSU_HP0, field HP_PCIE[0] (RW)
 *
 * Indicates the Privilege/User Mode for PCIE
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_PCIE   (0U)          /*!< Bit position for CSU_HP0_HP_PCIE. */
#define BM_CSU_HP0_HP_PCIE   (0x00000001U) /*!< Bit mask for CSU_HP0_HP_PCIE. */
#define BS_CSU_HP0_HP_PCIE   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_PCIE. */

/*! @brief Read current value of the CSU_HP0_HP_PCIE field. */
#define BR_CSU_HP0_HP_PCIE(x) (HW_CSU_HP0(x).B.HP_PCIE)

/*! @brief Format value for bitfield CSU_HP0_HP_PCIE. */
#define BF_CSU_HP0_HP_PCIE(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_PCIE) & BM_CSU_HP0_HP_PCIE)

/*! @brief Set the HP_PCIE field to a new value. */
#define BW_CSU_HP0_HP_PCIE(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_PCIE) | BF_CSU_HP0_HP_PCIE(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_PCIE[1] (RW)
 *
 * Lock bit set by TZ software for HP_PCIE.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_PCIE    (1U)          /*!< Bit position for CSU_HP0_L_PCIE. */
#define BM_CSU_HP0_L_PCIE    (0x00000002U) /*!< Bit mask for CSU_HP0_L_PCIE. */
#define BS_CSU_HP0_L_PCIE    (1U)          /*!< Bit field size in bits for CSU_HP0_L_PCIE. */

/*! @brief Read current value of the CSU_HP0_L_PCIE field. */
#define BR_CSU_HP0_L_PCIE(x) (HW_CSU_HP0(x).B.L_PCIE)

/*! @brief Format value for bitfield CSU_HP0_L_PCIE. */
#define BF_CSU_HP0_L_PCIE(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_PCIE) & BM_CSU_HP0_L_PCIE)

/*! @brief Set the L_PCIE field to a new value. */
#define BW_CSU_HP0_L_PCIE(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_PCIE) | BF_CSU_HP0_L_PCIE(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_SATA[2] (RW)
 *
 * Indicates the Privilege/User Mode for SATA
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_SATA   (2U)          /*!< Bit position for CSU_HP0_HP_SATA. */
#define BM_CSU_HP0_HP_SATA   (0x00000004U) /*!< Bit mask for CSU_HP0_HP_SATA. */
#define BS_CSU_HP0_HP_SATA   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_SATA. */

/*! @brief Read current value of the CSU_HP0_HP_SATA field. */
#define BR_CSU_HP0_HP_SATA(x) (HW_CSU_HP0(x).B.HP_SATA)

/*! @brief Format value for bitfield CSU_HP0_HP_SATA. */
#define BF_CSU_HP0_HP_SATA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_SATA) & BM_CSU_HP0_HP_SATA)

/*! @brief Set the HP_SATA field to a new value. */
#define BW_CSU_HP0_HP_SATA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_SATA) | BF_CSU_HP0_HP_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_SATA[3] (RW)
 *
 * Lock bit set by TZ software for HP_SATA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_SATA    (3U)          /*!< Bit position for CSU_HP0_L_SATA. */
#define BM_CSU_HP0_L_SATA    (0x00000008U) /*!< Bit mask for CSU_HP0_L_SATA. */
#define BS_CSU_HP0_L_SATA    (1U)          /*!< Bit field size in bits for CSU_HP0_L_SATA. */

/*! @brief Read current value of the CSU_HP0_L_SATA field. */
#define BR_CSU_HP0_L_SATA(x) (HW_CSU_HP0(x).B.L_SATA)

/*! @brief Format value for bitfield CSU_HP0_L_SATA. */
#define BF_CSU_HP0_L_SATA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_SATA) & BM_CSU_HP0_L_SATA)

/*! @brief Set the L_SATA field to a new value. */
#define BW_CSU_HP0_L_SATA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_SATA) | BF_CSU_HP0_L_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_SDMA[4] (RW)
 *
 * Indicates the Privilege/User Mode for SDMA.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_SDMA   (4U)          /*!< Bit position for CSU_HP0_HP_SDMA. */
#define BM_CSU_HP0_HP_SDMA   (0x00000010U) /*!< Bit mask for CSU_HP0_HP_SDMA. */
#define BS_CSU_HP0_HP_SDMA   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_SDMA. */

/*! @brief Read current value of the CSU_HP0_HP_SDMA field. */
#define BR_CSU_HP0_HP_SDMA(x) (HW_CSU_HP0(x).B.HP_SDMA)

/*! @brief Format value for bitfield CSU_HP0_HP_SDMA. */
#define BF_CSU_HP0_HP_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_SDMA) & BM_CSU_HP0_HP_SDMA)

/*! @brief Set the HP_SDMA field to a new value. */
#define BW_CSU_HP0_HP_SDMA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_SDMA) | BF_CSU_HP0_HP_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_SDMA[5] (RW)
 *
 * Lock bit set by TZ software for HP_SDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_SDMA    (5U)          /*!< Bit position for CSU_HP0_L_SDMA. */
#define BM_CSU_HP0_L_SDMA    (0x00000020U) /*!< Bit mask for CSU_HP0_L_SDMA. */
#define BS_CSU_HP0_L_SDMA    (1U)          /*!< Bit field size in bits for CSU_HP0_L_SDMA. */

/*! @brief Read current value of the CSU_HP0_L_SDMA field. */
#define BR_CSU_HP0_L_SDMA(x) (HW_CSU_HP0(x).B.L_SDMA)

/*! @brief Format value for bitfield CSU_HP0_L_SDMA. */
#define BF_CSU_HP0_L_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_SDMA) & BM_CSU_HP0_L_SDMA)

/*! @brief Set the L_SDMA field to a new value. */
#define BW_CSU_HP0_L_SDMA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_SDMA) | BF_CSU_HP0_L_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_PU[6] (RW)
 *
 * Indicates the Privilege/User Mode for GPU3D, GPU2D, VPU, IPU1, IPU2, OpenVG
 * and VDOA.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_PU     (6U)          /*!< Bit position for CSU_HP0_HP_PU. */
#define BM_CSU_HP0_HP_PU     (0x00000040U) /*!< Bit mask for CSU_HP0_HP_PU. */
#define BS_CSU_HP0_HP_PU     (1U)          /*!< Bit field size in bits for CSU_HP0_HP_PU. */

/*! @brief Read current value of the CSU_HP0_HP_PU field. */
#define BR_CSU_HP0_HP_PU(x)  (HW_CSU_HP0(x).B.HP_PU)

/*! @brief Format value for bitfield CSU_HP0_HP_PU. */
#define BF_CSU_HP0_HP_PU(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_PU) & BM_CSU_HP0_HP_PU)

/*! @brief Set the HP_PU field to a new value. */
#define BW_CSU_HP0_HP_PU(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_PU) | BF_CSU_HP0_HP_PU(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_PU[7] (RW)
 *
 * Lock bit set by TZ software for HP_PU.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_PU      (7U)          /*!< Bit position for CSU_HP0_L_PU. */
#define BM_CSU_HP0_L_PU      (0x00000080U) /*!< Bit mask for CSU_HP0_L_PU. */
#define BS_CSU_HP0_L_PU      (1U)          /*!< Bit field size in bits for CSU_HP0_L_PU. */

/*! @brief Read current value of the CSU_HP0_L_PU field. */
#define BR_CSU_HP0_L_PU(x)   (HW_CSU_HP0(x).B.L_PU)

/*! @brief Format value for bitfield CSU_HP0_L_PU. */
#define BF_CSU_HP0_L_PU(v)   ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_PU) & BM_CSU_HP0_L_PU)

/*! @brief Set the L_PU field to a new value. */
#define BW_CSU_HP0_L_PU(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_PU) | BF_CSU_HP0_L_PU(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_USB[8] (RW)
 *
 * Indicates the Privilege/User Mode for USB.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_USB    (8U)          /*!< Bit position for CSU_HP0_HP_USB. */
#define BM_CSU_HP0_HP_USB    (0x00000100U) /*!< Bit mask for CSU_HP0_HP_USB. */
#define BS_CSU_HP0_HP_USB    (1U)          /*!< Bit field size in bits for CSU_HP0_HP_USB. */

/*! @brief Read current value of the CSU_HP0_HP_USB field. */
#define BR_CSU_HP0_HP_USB(x) (HW_CSU_HP0(x).B.HP_USB)

/*! @brief Format value for bitfield CSU_HP0_HP_USB. */
#define BF_CSU_HP0_HP_USB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_USB) & BM_CSU_HP0_HP_USB)

/*! @brief Set the HP_USB field to a new value. */
#define BW_CSU_HP0_HP_USB(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_USB) | BF_CSU_HP0_HP_USB(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_USB[9] (RW)
 *
 * Lock bit set by TZ software for HP_USB.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_USB     (9U)          /*!< Bit position for CSU_HP0_L_USB. */
#define BM_CSU_HP0_L_USB     (0x00000200U) /*!< Bit mask for CSU_HP0_L_USB. */
#define BS_CSU_HP0_L_USB     (1U)          /*!< Bit field size in bits for CSU_HP0_L_USB. */

/*! @brief Read current value of the CSU_HP0_L_USB field. */
#define BR_CSU_HP0_L_USB(x)  (HW_CSU_HP0(x).B.L_USB)

/*! @brief Format value for bitfield CSU_HP0_L_USB. */
#define BF_CSU_HP0_L_USB(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_USB) & BM_CSU_HP0_L_USB)

/*! @brief Set the L_USB field to a new value. */
#define BW_CSU_HP0_L_USB(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_USB) | BF_CSU_HP0_L_USB(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_TEST[10] (RW)
 *
 * Indicates the Privilege/User Mode for IOMUX Test Port.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_TEST   (10U)         /*!< Bit position for CSU_HP0_HP_TEST. */
#define BM_CSU_HP0_HP_TEST   (0x00000400U) /*!< Bit mask for CSU_HP0_HP_TEST. */
#define BS_CSU_HP0_HP_TEST   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_TEST. */

/*! @brief Read current value of the CSU_HP0_HP_TEST field. */
#define BR_CSU_HP0_HP_TEST(x) (HW_CSU_HP0(x).B.HP_TEST)

/*! @brief Format value for bitfield CSU_HP0_HP_TEST. */
#define BF_CSU_HP0_HP_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_TEST) & BM_CSU_HP0_HP_TEST)

/*! @brief Set the HP_TEST field to a new value. */
#define BW_CSU_HP0_HP_TEST(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_TEST) | BF_CSU_HP0_HP_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_TEST[11] (RW)
 *
 * Lock bit set by TZ software for HP_TEST.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_TEST    (11U)         /*!< Bit position for CSU_HP0_L_TEST. */
#define BM_CSU_HP0_L_TEST    (0x00000800U) /*!< Bit mask for CSU_HP0_L_TEST. */
#define BS_CSU_HP0_L_TEST    (1U)          /*!< Bit field size in bits for CSU_HP0_L_TEST. */

/*! @brief Read current value of the CSU_HP0_L_TEST field. */
#define BR_CSU_HP0_L_TEST(x) (HW_CSU_HP0(x).B.L_TEST)

/*! @brief Format value for bitfield CSU_HP0_L_TEST. */
#define BF_CSU_HP0_L_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_TEST) & BM_CSU_HP0_L_TEST)

/*! @brief Set the L_TEST field to a new value. */
#define BW_CSU_HP0_L_TEST(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_TEST) | BF_CSU_HP0_L_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_MLB[12] (RW)
 *
 * Indicate the mode Privilege/User Mode for MLB.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_MLB    (12U)         /*!< Bit position for CSU_HP0_HP_MLB. */
#define BM_CSU_HP0_HP_MLB    (0x00001000U) /*!< Bit mask for CSU_HP0_HP_MLB. */
#define BS_CSU_HP0_HP_MLB    (1U)          /*!< Bit field size in bits for CSU_HP0_HP_MLB. */

/*! @brief Read current value of the CSU_HP0_HP_MLB field. */
#define BR_CSU_HP0_HP_MLB(x) (HW_CSU_HP0(x).B.HP_MLB)

/*! @brief Format value for bitfield CSU_HP0_HP_MLB. */
#define BF_CSU_HP0_HP_MLB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_MLB) & BM_CSU_HP0_HP_MLB)

/*! @brief Set the HP_MLB field to a new value. */
#define BW_CSU_HP0_HP_MLB(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_MLB) | BF_CSU_HP0_HP_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_MLB[13] (RW)
 *
 * Lock bit set by TZ software for HP_MLB.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_MLB     (13U)         /*!< Bit position for CSU_HP0_L_MLB. */
#define BM_CSU_HP0_L_MLB     (0x00002000U) /*!< Bit mask for CSU_HP0_L_MLB. */
#define BS_CSU_HP0_L_MLB     (1U)          /*!< Bit field size in bits for CSU_HP0_L_MLB. */

/*! @brief Read current value of the CSU_HP0_L_MLB field. */
#define BR_CSU_HP0_L_MLB(x)  (HW_CSU_HP0(x).B.L_MLB)

/*! @brief Format value for bitfield CSU_HP0_L_MLB. */
#define BF_CSU_HP0_L_MLB(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_MLB) & BM_CSU_HP0_L_MLB)

/*! @brief Set the L_MLB field to a new value. */
#define BW_CSU_HP0_L_MLB(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_MLB) | BF_CSU_HP0_L_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_CAAM[14] (RW)
 *
 * Indicates the Privilege/User Mode for CAAM
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_CAAM   (14U)         /*!< Bit position for CSU_HP0_HP_CAAM. */
#define BM_CSU_HP0_HP_CAAM   (0x00004000U) /*!< Bit mask for CSU_HP0_HP_CAAM. */
#define BS_CSU_HP0_HP_CAAM   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_CAAM. */

/*! @brief Read current value of the CSU_HP0_HP_CAAM field. */
#define BR_CSU_HP0_HP_CAAM(x) (HW_CSU_HP0(x).B.HP_CAAM)

/*! @brief Format value for bitfield CSU_HP0_HP_CAAM. */
#define BF_CSU_HP0_HP_CAAM(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_CAAM) & BM_CSU_HP0_HP_CAAM)

/*! @brief Set the HP_CAAM field to a new value. */
#define BW_CSU_HP0_HP_CAAM(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_CAAM) | BF_CSU_HP0_HP_CAAM(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_CAAM[15] (RW)
 *
 * Lock bit set by TZ software for HP_CAAM.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_CAAM    (15U)         /*!< Bit position for CSU_HP0_L_CAAM. */
#define BM_CSU_HP0_L_CAAM    (0x00008000U) /*!< Bit mask for CSU_HP0_L_CAAM. */
#define BS_CSU_HP0_L_CAAM    (1U)          /*!< Bit field size in bits for CSU_HP0_L_CAAM. */

/*! @brief Read current value of the CSU_HP0_L_CAAM field. */
#define BR_CSU_HP0_L_CAAM(x) (HW_CSU_HP0(x).B.L_CAAM)

/*! @brief Format value for bitfield CSU_HP0_L_CAAM. */
#define BF_CSU_HP0_L_CAAM(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_CAAM) & BM_CSU_HP0_L_CAAM)

/*! @brief Set the L_CAAM field to a new value. */
#define BW_CSU_HP0_L_CAAM(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_CAAM) | BF_CSU_HP0_L_CAAM(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_RAWNAND[16] (RW)
 *
 * Indicates the Privilege/User Mode for RawNAND
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_RAWNAND (16U)        /*!< Bit position for CSU_HP0_HP_RAWNAND. */
#define BM_CSU_HP0_HP_RAWNAND (0x00010000U) /*!< Bit mask for CSU_HP0_HP_RAWNAND. */
#define BS_CSU_HP0_HP_RAWNAND (1U)         /*!< Bit field size in bits for CSU_HP0_HP_RAWNAND. */

/*! @brief Read current value of the CSU_HP0_HP_RAWNAND field. */
#define BR_CSU_HP0_HP_RAWNAND(x) (HW_CSU_HP0(x).B.HP_RAWNAND)

/*! @brief Format value for bitfield CSU_HP0_HP_RAWNAND. */
#define BF_CSU_HP0_HP_RAWNAND(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_RAWNAND) & BM_CSU_HP0_HP_RAWNAND)

/*! @brief Set the HP_RAWNAND field to a new value. */
#define BW_CSU_HP0_HP_RAWNAND(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_RAWNAND) | BF_CSU_HP0_HP_RAWNAND(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_RAWNAND[17] (RW)
 *
 * Lock bit set by TZ software for HP_RAWNAND.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_RAWNAND (17U)         /*!< Bit position for CSU_HP0_L_RAWNAND. */
#define BM_CSU_HP0_L_RAWNAND (0x00020000U) /*!< Bit mask for CSU_HP0_L_RAWNAND. */
#define BS_CSU_HP0_L_RAWNAND (1U)          /*!< Bit field size in bits for CSU_HP0_L_RAWNAND. */

/*! @brief Read current value of the CSU_HP0_L_RAWNAND field. */
#define BR_CSU_HP0_L_RAWNAND(x) (HW_CSU_HP0(x).B.L_RAWNAND)

/*! @brief Format value for bitfield CSU_HP0_L_RAWNAND. */
#define BF_CSU_HP0_L_RAWNAND(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_RAWNAND) & BM_CSU_HP0_L_RAWNAND)

/*! @brief Set the L_RAWNAND field to a new value. */
#define BW_CSU_HP0_L_RAWNAND(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_RAWNAND) | BF_CSU_HP0_L_RAWNAND(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_APBHDMA[18] (RW)
 *
 * Indicates the Privilege/User Mode for APBHDMA
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_APBHDMA (18U)        /*!< Bit position for CSU_HP0_HP_APBHDMA. */
#define BM_CSU_HP0_HP_APBHDMA (0x00040000U) /*!< Bit mask for CSU_HP0_HP_APBHDMA. */
#define BS_CSU_HP0_HP_APBHDMA (1U)         /*!< Bit field size in bits for CSU_HP0_HP_APBHDMA. */

/*! @brief Read current value of the CSU_HP0_HP_APBHDMA field. */
#define BR_CSU_HP0_HP_APBHDMA(x) (HW_CSU_HP0(x).B.HP_APBHDMA)

/*! @brief Format value for bitfield CSU_HP0_HP_APBHDMA. */
#define BF_CSU_HP0_HP_APBHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_APBHDMA) & BM_CSU_HP0_HP_APBHDMA)

/*! @brief Set the HP_APBHDMA field to a new value. */
#define BW_CSU_HP0_HP_APBHDMA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_APBHDMA) | BF_CSU_HP0_HP_APBHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_ABPHDMA[19] (RW)
 *
 * Lock bit set by TZ software for HP_APBHDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_ABPHDMA (19U)         /*!< Bit position for CSU_HP0_L_ABPHDMA. */
#define BM_CSU_HP0_L_ABPHDMA (0x00080000U) /*!< Bit mask for CSU_HP0_L_ABPHDMA. */
#define BS_CSU_HP0_L_ABPHDMA (1U)          /*!< Bit field size in bits for CSU_HP0_L_ABPHDMA. */

/*! @brief Read current value of the CSU_HP0_L_ABPHDMA field. */
#define BR_CSU_HP0_L_ABPHDMA(x) (HW_CSU_HP0(x).B.L_ABPHDMA)

/*! @brief Format value for bitfield CSU_HP0_L_ABPHDMA. */
#define BF_CSU_HP0_L_ABPHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_ABPHDMA) & BM_CSU_HP0_L_ABPHDMA)

/*! @brief Set the L_ABPHDMA field to a new value. */
#define BW_CSU_HP0_L_ABPHDMA(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_ABPHDMA) | BF_CSU_HP0_L_ABPHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_ENET[20] (RW)
 *
 * Indicates the Privilege/User Mode for ENET
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_ENET   (20U)         /*!< Bit position for CSU_HP0_HP_ENET. */
#define BM_CSU_HP0_HP_ENET   (0x00100000U) /*!< Bit mask for CSU_HP0_HP_ENET. */
#define BS_CSU_HP0_HP_ENET   (1U)          /*!< Bit field size in bits for CSU_HP0_HP_ENET. */

/*! @brief Read current value of the CSU_HP0_HP_ENET field. */
#define BR_CSU_HP0_HP_ENET(x) (HW_CSU_HP0(x).B.HP_ENET)

/*! @brief Format value for bitfield CSU_HP0_HP_ENET. */
#define BF_CSU_HP0_HP_ENET(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_ENET) & BM_CSU_HP0_HP_ENET)

/*! @brief Set the HP_ENET field to a new value. */
#define BW_CSU_HP0_HP_ENET(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_ENET) | BF_CSU_HP0_HP_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_ENET[21] (RW)
 *
 * Lock bit set by TZ software for HP_ENET.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_ENET    (21U)         /*!< Bit position for CSU_HP0_L_ENET. */
#define BM_CSU_HP0_L_ENET    (0x00200000U) /*!< Bit mask for CSU_HP0_L_ENET. */
#define BS_CSU_HP0_L_ENET    (1U)          /*!< Bit field size in bits for CSU_HP0_L_ENET. */

/*! @brief Read current value of the CSU_HP0_L_ENET field. */
#define BR_CSU_HP0_L_ENET(x) (HW_CSU_HP0(x).B.L_ENET)

/*! @brief Format value for bitfield CSU_HP0_L_ENET. */
#define BF_CSU_HP0_L_ENET(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_ENET) & BM_CSU_HP0_L_ENET)

/*! @brief Set the L_ENET field to a new value. */
#define BW_CSU_HP0_L_ENET(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_ENET) | BF_CSU_HP0_L_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_DAP[22] (RW)
 *
 * Indicates the Privilege/User Mode for DAP
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_DAP    (22U)         /*!< Bit position for CSU_HP0_HP_DAP. */
#define BM_CSU_HP0_HP_DAP    (0x00400000U) /*!< Bit mask for CSU_HP0_HP_DAP. */
#define BS_CSU_HP0_HP_DAP    (1U)          /*!< Bit field size in bits for CSU_HP0_HP_DAP. */

/*! @brief Read current value of the CSU_HP0_HP_DAP field. */
#define BR_CSU_HP0_HP_DAP(x) (HW_CSU_HP0(x).B.HP_DAP)

/*! @brief Format value for bitfield CSU_HP0_HP_DAP. */
#define BF_CSU_HP0_HP_DAP(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_DAP) & BM_CSU_HP0_HP_DAP)

/*! @brief Set the HP_DAP field to a new value. */
#define BW_CSU_HP0_HP_DAP(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_DAP) | BF_CSU_HP0_HP_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_DAP[23] (RW)
 *
 * Lock bit set by TZ software for HP_DAP.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_DAP     (23U)         /*!< Bit position for CSU_HP0_L_DAP. */
#define BM_CSU_HP0_L_DAP     (0x00800000U) /*!< Bit mask for CSU_HP0_L_DAP. */
#define BS_CSU_HP0_L_DAP     (1U)          /*!< Bit field size in bits for CSU_HP0_L_DAP. */

/*! @brief Read current value of the CSU_HP0_L_DAP field. */
#define BR_CSU_HP0_L_DAP(x)  (HW_CSU_HP0(x).B.L_DAP)

/*! @brief Format value for bitfield CSU_HP0_L_DAP. */
#define BF_CSU_HP0_L_DAP(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_DAP) & BM_CSU_HP0_L_DAP)

/*! @brief Set the L_DAP field to a new value. */
#define BW_CSU_HP0_L_DAP(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_DAP) | BF_CSU_HP0_L_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_USDHC1[24] (RW)
 *
 * Indicates the Privilege/User Mode for USDHC1
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_USDHC1 (24U)         /*!< Bit position for CSU_HP0_HP_USDHC1. */
#define BM_CSU_HP0_HP_USDHC1 (0x01000000U) /*!< Bit mask for CSU_HP0_HP_USDHC1. */
#define BS_CSU_HP0_HP_USDHC1 (1U)          /*!< Bit field size in bits for CSU_HP0_HP_USDHC1. */

/*! @brief Read current value of the CSU_HP0_HP_USDHC1 field. */
#define BR_CSU_HP0_HP_USDHC1(x) (HW_CSU_HP0(x).B.HP_USDHC1)

/*! @brief Format value for bitfield CSU_HP0_HP_USDHC1. */
#define BF_CSU_HP0_HP_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_USDHC1) & BM_CSU_HP0_HP_USDHC1)

/*! @brief Set the HP_USDHC1 field to a new value. */
#define BW_CSU_HP0_HP_USDHC1(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_USDHC1) | BF_CSU_HP0_HP_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_USDHC1[25] (RW)
 *
 * Lock bit set by TZ software for HP_USDHC1.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_USDHC1  (25U)         /*!< Bit position for CSU_HP0_L_USDHC1. */
#define BM_CSU_HP0_L_USDHC1  (0x02000000U) /*!< Bit mask for CSU_HP0_L_USDHC1. */
#define BS_CSU_HP0_L_USDHC1  (1U)          /*!< Bit field size in bits for CSU_HP0_L_USDHC1. */

/*! @brief Read current value of the CSU_HP0_L_USDHC1 field. */
#define BR_CSU_HP0_L_USDHC1(x) (HW_CSU_HP0(x).B.L_USDHC1)

/*! @brief Format value for bitfield CSU_HP0_L_USDHC1. */
#define BF_CSU_HP0_L_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_USDHC1) & BM_CSU_HP0_L_USDHC1)

/*! @brief Set the L_USDHC1 field to a new value. */
#define BW_CSU_HP0_L_USDHC1(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_USDHC1) | BF_CSU_HP0_L_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_USDHC2[26] (RW)
 *
 * Indicates the Privilege/User Mode for USDHC2
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_USDHC2 (26U)         /*!< Bit position for CSU_HP0_HP_USDHC2. */
#define BM_CSU_HP0_HP_USDHC2 (0x04000000U) /*!< Bit mask for CSU_HP0_HP_USDHC2. */
#define BS_CSU_HP0_HP_USDHC2 (1U)          /*!< Bit field size in bits for CSU_HP0_HP_USDHC2. */

/*! @brief Read current value of the CSU_HP0_HP_USDHC2 field. */
#define BR_CSU_HP0_HP_USDHC2(x) (HW_CSU_HP0(x).B.HP_USDHC2)

/*! @brief Format value for bitfield CSU_HP0_HP_USDHC2. */
#define BF_CSU_HP0_HP_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_USDHC2) & BM_CSU_HP0_HP_USDHC2)

/*! @brief Set the HP_USDHC2 field to a new value. */
#define BW_CSU_HP0_HP_USDHC2(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_USDHC2) | BF_CSU_HP0_HP_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_USDHC2[27] (RW)
 *
 * Lock bit set by TZ software for HP_USDHC2.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_USDHC2  (27U)         /*!< Bit position for CSU_HP0_L_USDHC2. */
#define BM_CSU_HP0_L_USDHC2  (0x08000000U) /*!< Bit mask for CSU_HP0_L_USDHC2. */
#define BS_CSU_HP0_L_USDHC2  (1U)          /*!< Bit field size in bits for CSU_HP0_L_USDHC2. */

/*! @brief Read current value of the CSU_HP0_L_USDHC2 field. */
#define BR_CSU_HP0_L_USDHC2(x) (HW_CSU_HP0(x).B.L_USDHC2)

/*! @brief Format value for bitfield CSU_HP0_L_USDHC2. */
#define BF_CSU_HP0_L_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_USDHC2) & BM_CSU_HP0_L_USDHC2)

/*! @brief Set the L_USDHC2 field to a new value. */
#define BW_CSU_HP0_L_USDHC2(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_USDHC2) | BF_CSU_HP0_L_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_USDHC3[28] (RW)
 *
 * Indicates the Privilege/User Mode for USDHC3
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_USDHC3 (28U)         /*!< Bit position for CSU_HP0_HP_USDHC3. */
#define BM_CSU_HP0_HP_USDHC3 (0x10000000U) /*!< Bit mask for CSU_HP0_HP_USDHC3. */
#define BS_CSU_HP0_HP_USDHC3 (1U)          /*!< Bit field size in bits for CSU_HP0_HP_USDHC3. */

/*! @brief Read current value of the CSU_HP0_HP_USDHC3 field. */
#define BR_CSU_HP0_HP_USDHC3(x) (HW_CSU_HP0(x).B.HP_USDHC3)

/*! @brief Format value for bitfield CSU_HP0_HP_USDHC3. */
#define BF_CSU_HP0_HP_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_USDHC3) & BM_CSU_HP0_HP_USDHC3)

/*! @brief Set the HP_USDHC3 field to a new value. */
#define BW_CSU_HP0_HP_USDHC3(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_USDHC3) | BF_CSU_HP0_HP_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_USDHC3[29] (RW)
 *
 * Lock bit set by TZ software for HP_USDHC3.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_USDHC3  (29U)         /*!< Bit position for CSU_HP0_L_USDHC3. */
#define BM_CSU_HP0_L_USDHC3  (0x20000000U) /*!< Bit mask for CSU_HP0_L_USDHC3. */
#define BS_CSU_HP0_L_USDHC3  (1U)          /*!< Bit field size in bits for CSU_HP0_L_USDHC3. */

/*! @brief Read current value of the CSU_HP0_L_USDHC3 field. */
#define BR_CSU_HP0_L_USDHC3(x) (HW_CSU_HP0(x).B.L_USDHC3)

/*! @brief Format value for bitfield CSU_HP0_L_USDHC3. */
#define BF_CSU_HP0_L_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_USDHC3) & BM_CSU_HP0_L_USDHC3)

/*! @brief Set the L_USDHC3 field to a new value. */
#define BW_CSU_HP0_L_USDHC3(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_USDHC3) | BF_CSU_HP0_L_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field HP_USDHC4[30] (RW)
 *
 * Indicates the Privilege/User Mode for USDHC4.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP0_HP_USDHC4 (30U)         /*!< Bit position for CSU_HP0_HP_USDHC4. */
#define BM_CSU_HP0_HP_USDHC4 (0x40000000U) /*!< Bit mask for CSU_HP0_HP_USDHC4. */
#define BS_CSU_HP0_HP_USDHC4 (1U)          /*!< Bit field size in bits for CSU_HP0_HP_USDHC4. */

/*! @brief Read current value of the CSU_HP0_HP_USDHC4 field. */
#define BR_CSU_HP0_HP_USDHC4(x) (HW_CSU_HP0(x).B.HP_USDHC4)

/*! @brief Format value for bitfield CSU_HP0_HP_USDHC4. */
#define BF_CSU_HP0_HP_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_HP_USDHC4) & BM_CSU_HP0_HP_USDHC4)

/*! @brief Set the HP_USDHC4 field to a new value. */
#define BW_CSU_HP0_HP_USDHC4(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_HP_USDHC4) | BF_CSU_HP0_HP_USDHC4(v)))
/*@}*/

/*!
 * @name Register CSU_HP0, field L_USDHC4[31] (RW)
 *
 * Lock bit set by TZ software for HP_USDHC4.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP0_L_USDHC4  (31U)         /*!< Bit position for CSU_HP0_L_USDHC4. */
#define BM_CSU_HP0_L_USDHC4  (0x80000000U) /*!< Bit mask for CSU_HP0_L_USDHC4. */
#define BS_CSU_HP0_L_USDHC4  (1U)          /*!< Bit field size in bits for CSU_HP0_L_USDHC4. */

/*! @brief Read current value of the CSU_HP0_L_USDHC4 field. */
#define BR_CSU_HP0_L_USDHC4(x) (HW_CSU_HP0(x).B.L_USDHC4)

/*! @brief Format value for bitfield CSU_HP0_L_USDHC4. */
#define BF_CSU_HP0_L_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP0_L_USDHC4) & BM_CSU_HP0_L_USDHC4)

/*! @brief Set the L_USDHC4 field to a new value. */
#define BW_CSU_HP0_L_USDHC4(x, v) (HW_CSU_HP0_WR(x, (HW_CSU_HP0_RD(x) & ~BM_CSU_HP0_L_USDHC4) | BF_CSU_HP0_L_USDHC4(v)))
/*@}*/

/*******************************************************************************
 * HW_CSU_HP1 - HP1 register
 ******************************************************************************/

/*!
 * @brief HW_CSU_HP1 - HP1 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SCU_HP1 register is an expansion of the SCU_HP0 register. See SCU_HP0
 * register definition.
 */
typedef union _hw_csu_hp1
{
    uint32_t U;
    struct _hw_csu_hp1_bitfields
    {
        uint32_t HP_HDMI_HSI : 1;      /*!< [0]  */
        uint32_t L_CAAM : 1;           /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_csu_hp1_t;

/*!
 * @name Constants and macros for entire CSU_HP1 register
 */
/*@{*/
#define HW_CSU_HP1_ADDR(x)       ((uintptr_t)(x) + 0x204U)

#define HW_CSU_HP1(x)            (*(__IO hw_csu_hp1_t *) HW_CSU_HP1_ADDR(x))
#define HW_CSU_HP1_RD(x)         (HW_CSU_HP1(x).U)
#define HW_CSU_HP1_WR(x, v)      (HW_CSU_HP1(x).U = (v))
#define HW_CSU_HP1_SET(x, v)     (HW_CSU_HP1_WR(x, HW_CSU_HP1_RD(x) |  (v)))
#define HW_CSU_HP1_CLR(x, v)     (HW_CSU_HP1_WR(x, HW_CSU_HP1_RD(x) & ~(v)))
#define HW_CSU_HP1_TOG(x, v)     (HW_CSU_HP1_WR(x, HW_CSU_HP1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_HP1 bitfields
 */

/*!
 * @name Register CSU_HP1, field HP_HDMI_HSI[0] (RW)
 *
 * Indicates the Privilege/User Mode for HDMI Tx and HSI.
 *
 * Values:
 * - 0 - User Mode for the corresponding master
 * - 1 - Supervisor Mode for the corresponding master
 */
/*@{*/
#define BP_CSU_HP1_HP_HDMI_HSI (0U)        /*!< Bit position for CSU_HP1_HP_HDMI_HSI. */
#define BM_CSU_HP1_HP_HDMI_HSI (0x00000001U) /*!< Bit mask for CSU_HP1_HP_HDMI_HSI. */
#define BS_CSU_HP1_HP_HDMI_HSI (1U)        /*!< Bit field size in bits for CSU_HP1_HP_HDMI_HSI. */

/*! @brief Read current value of the CSU_HP1_HP_HDMI_HSI field. */
#define BR_CSU_HP1_HP_HDMI_HSI(x) (HW_CSU_HP1(x).B.HP_HDMI_HSI)

/*! @brief Format value for bitfield CSU_HP1_HP_HDMI_HSI. */
#define BF_CSU_HP1_HP_HDMI_HSI(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP1_HP_HDMI_HSI) & BM_CSU_HP1_HP_HDMI_HSI)

/*! @brief Set the HP_HDMI_HSI field to a new value. */
#define BW_CSU_HP1_HP_HDMI_HSI(x, v) (HW_CSU_HP1_WR(x, (HW_CSU_HP1_RD(x) & ~BM_CSU_HP1_HP_HDMI_HSI) | BF_CSU_HP1_HP_HDMI_HSI(v)))
/*@}*/

/*!
 * @name Register CSU_HP1, field L_CAAM[1] (RW)
 *
 * Lock bit set by TZ software for CAAM.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HP1_L_CAAM    (1U)          /*!< Bit position for CSU_HP1_L_CAAM. */
#define BM_CSU_HP1_L_CAAM    (0x00000002U) /*!< Bit mask for CSU_HP1_L_CAAM. */
#define BS_CSU_HP1_L_CAAM    (1U)          /*!< Bit field size in bits for CSU_HP1_L_CAAM. */

/*! @brief Read current value of the CSU_HP1_L_CAAM field. */
#define BR_CSU_HP1_L_CAAM(x) (HW_CSU_HP1(x).B.L_CAAM)

/*! @brief Format value for bitfield CSU_HP1_L_CAAM. */
#define BF_CSU_HP1_L_CAAM(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HP1_L_CAAM) & BM_CSU_HP1_L_CAAM)

/*! @brief Set the L_CAAM field to a new value. */
#define BW_CSU_HP1_L_CAAM(x, v) (HW_CSU_HP1_WR(x, (HW_CSU_HP1_RD(x) & ~BM_CSU_HP1_L_CAAM) | BF_CSU_HP1_L_CAAM(v)))
/*@}*/

/*******************************************************************************
 * HW_CSU_SA - Secure access register
 ******************************************************************************/

/*!
 * @brief HW_CSU_SA - Secure access register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Secure Access register may be programmed to specify the access policy
 * (either Secure or Non-secure) for up to sixteen different masters. This register
 * is used to set the access policy for Type 1 masters which are incapable of
 * setting the policy by themselves. The sixteen even bit positions
 * (CSU_SA[30,28,...,0]) in the register hold the policy indicator bits; while the odd bit
 * positions (CSU_SA[31,29,...,1]) contain lock bits which enable/disable writing to
 * the corresponding policy indicator bits.
 */
typedef union _hw_csu_sa
{
    uint32_t U;
    struct _hw_csu_sa_bitfields
    {
        uint32_t NSA_CP15 : 1;         /*!< [0] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_CP15 : 1;           /*!< [1]  */
        uint32_t NSA_SATA : 1;         /*!< [2] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_SATA : 1;           /*!< [3]  */
        uint32_t NSA_SDMA : 1;         /*!< [4] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_SDMA : 1;           /*!< [5]  */
        uint32_t NSA_PU : 1;           /*!< [6] Non-Secure Access Policy indicator bit
                                        * */
        uint32_t L_PU : 1;             /*!< [7]  */
        uint32_t NSA_USB_MLB : 1;      /*!< [8] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_USB_MLB : 1;        /*!< [9]  */
        uint32_t NSA_PCIE_TEST : 1;    /*!< [10] Non-Secure Access Policy
                                        * indicator bit */
        uint32_t L_PCIE_TEST : 1;      /*!< [11]  */
        uint32_t RESERVED0 : 2;        /*!< [13:12]  */
        uint32_t NSA_RAWNAND_APBHDMA : 1; /*!< [14] Non-Secure Access Policy
                                        * indicator bit */
        uint32_t L_RAWNAND_APBHDMA : 1; /*!< [15]  */
        uint32_t NSA_ENET : 1;         /*!< [16] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_ENET : 1;           /*!< [17]  */
        uint32_t NSA_DAP : 1;          /*!< [18] Non-Secure Access Policy indicator
                                        * bit ARM core platform DAP */
        uint32_t L_DAP : 1;            /*!< [19]  */
        uint32_t NSA_USDHC1 : 1;       /*!< [20] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_USDHC1 : 1;         /*!< [21]  */
        uint32_t NSA_USDHC2 : 1;       /*!< [22] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_USDHC2 : 1;         /*!< [23]  */
        uint32_t NSA_USDHC3 : 1;       /*!< [24] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_USDHC3 : 1;         /*!< [25]  */
        uint32_t NSA_USDHC4 : 1;       /*!< [26] Non-Secure Access Policy indicator
                                        * bit */
        uint32_t L_USDHC4 : 1;         /*!< [27]  */
        uint32_t NSA_HDMI_HSI : 1;     /*!< [28] Non-Secure Access Policy
                                        * indicator bit */
        uint32_t L_HDMI_HSI : 1;       /*!< [29]  */
        uint32_t RESERVED1 : 2;        /*!< [31:30]  */
    } B;
} hw_csu_sa_t;

/*!
 * @name Constants and macros for entire CSU_SA register
 */
/*@{*/
#define HW_CSU_SA_ADDR(x)        ((uintptr_t)(x) + 0x218U)

#define HW_CSU_SA(x)             (*(__IO hw_csu_sa_t *) HW_CSU_SA_ADDR(x))
#define HW_CSU_SA_RD(x)          (HW_CSU_SA(x).U)
#define HW_CSU_SA_WR(x, v)       (HW_CSU_SA(x).U = (v))
#define HW_CSU_SA_SET(x, v)      (HW_CSU_SA_WR(x, HW_CSU_SA_RD(x) |  (v)))
#define HW_CSU_SA_CLR(x, v)      (HW_CSU_SA_WR(x, HW_CSU_SA_RD(x) & ~(v)))
#define HW_CSU_SA_TOG(x, v)      (HW_CSU_SA_WR(x, HW_CSU_SA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_SA bitfields
 */

/*!
 * @name Register CSU_SA, field NSA_CP15[0] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access to ARM CP15 register.
 *
 * Values:
 * - 0 - ARM CP15 register is accesible
 * - 1 - ARM CP15 register is not accesible
 */
/*@{*/
#define BP_CSU_SA_NSA_CP15   (0U)          /*!< Bit position for CSU_SA_NSA_CP15. */
#define BM_CSU_SA_NSA_CP15   (0x00000001U) /*!< Bit mask for CSU_SA_NSA_CP15. */
#define BS_CSU_SA_NSA_CP15   (1U)          /*!< Bit field size in bits for CSU_SA_NSA_CP15. */

/*! @brief Read current value of the CSU_SA_NSA_CP15 field. */
#define BR_CSU_SA_NSA_CP15(x) (HW_CSU_SA(x).B.NSA_CP15)

/*! @brief Format value for bitfield CSU_SA_NSA_CP15. */
#define BF_CSU_SA_NSA_CP15(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_CP15) & BM_CSU_SA_NSA_CP15)

/*! @brief Set the NSA_CP15 field to a new value. */
#define BW_CSU_SA_NSA_CP15(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_CP15) | BF_CSU_SA_NSA_CP15(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_CP15[1] (RW)
 *
 * Lock bit set by TZ software for NSA_CP15.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_CP15     (1U)          /*!< Bit position for CSU_SA_L_CP15. */
#define BM_CSU_SA_L_CP15     (0x00000002U) /*!< Bit mask for CSU_SA_L_CP15. */
#define BS_CSU_SA_L_CP15     (1U)          /*!< Bit field size in bits for CSU_SA_L_CP15. */

/*! @brief Read current value of the CSU_SA_L_CP15 field. */
#define BR_CSU_SA_L_CP15(x)  (HW_CSU_SA(x).B.L_CP15)

/*! @brief Format value for bitfield CSU_SA_L_CP15. */
#define BF_CSU_SA_L_CP15(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_CP15) & BM_CSU_SA_L_CP15)

/*! @brief Set the L_CP15 field to a new value. */
#define BW_CSU_SA_L_CP15(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_CP15) | BF_CSU_SA_L_CP15(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_SATA[2] (RW)
 *
 * Indicates the type of access (Secured/Non-Secured) for SATA
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_SATA   (2U)          /*!< Bit position for CSU_SA_NSA_SATA. */
#define BM_CSU_SA_NSA_SATA   (0x00000004U) /*!< Bit mask for CSU_SA_NSA_SATA. */
#define BS_CSU_SA_NSA_SATA   (1U)          /*!< Bit field size in bits for CSU_SA_NSA_SATA. */

/*! @brief Read current value of the CSU_SA_NSA_SATA field. */
#define BR_CSU_SA_NSA_SATA(x) (HW_CSU_SA(x).B.NSA_SATA)

/*! @brief Format value for bitfield CSU_SA_NSA_SATA. */
#define BF_CSU_SA_NSA_SATA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_SATA) & BM_CSU_SA_NSA_SATA)

/*! @brief Set the NSA_SATA field to a new value. */
#define BW_CSU_SA_NSA_SATA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_SATA) | BF_CSU_SA_NSA_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_SATA[3] (RW)
 *
 * Lock bit set by TZ software for NSA_SATA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_SATA     (3U)          /*!< Bit position for CSU_SA_L_SATA. */
#define BM_CSU_SA_L_SATA     (0x00000008U) /*!< Bit mask for CSU_SA_L_SATA. */
#define BS_CSU_SA_L_SATA     (1U)          /*!< Bit field size in bits for CSU_SA_L_SATA. */

/*! @brief Read current value of the CSU_SA_L_SATA field. */
#define BR_CSU_SA_L_SATA(x)  (HW_CSU_SA(x).B.L_SATA)

/*! @brief Format value for bitfield CSU_SA_L_SATA. */
#define BF_CSU_SA_L_SATA(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_SATA) & BM_CSU_SA_L_SATA)

/*! @brief Set the L_SATA field to a new value. */
#define BW_CSU_SA_L_SATA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_SATA) | BF_CSU_SA_L_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_SDMA[4] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for SDMA.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_SDMA   (4U)          /*!< Bit position for CSU_SA_NSA_SDMA. */
#define BM_CSU_SA_NSA_SDMA   (0x00000010U) /*!< Bit mask for CSU_SA_NSA_SDMA. */
#define BS_CSU_SA_NSA_SDMA   (1U)          /*!< Bit field size in bits for CSU_SA_NSA_SDMA. */

/*! @brief Read current value of the CSU_SA_NSA_SDMA field. */
#define BR_CSU_SA_NSA_SDMA(x) (HW_CSU_SA(x).B.NSA_SDMA)

/*! @brief Format value for bitfield CSU_SA_NSA_SDMA. */
#define BF_CSU_SA_NSA_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_SDMA) & BM_CSU_SA_NSA_SDMA)

/*! @brief Set the NSA_SDMA field to a new value. */
#define BW_CSU_SA_NSA_SDMA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_SDMA) | BF_CSU_SA_NSA_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_SDMA[5] (RW)
 *
 * Lock bit set by TZ software for NSA_SDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_SDMA     (5U)          /*!< Bit position for CSU_SA_L_SDMA. */
#define BM_CSU_SA_L_SDMA     (0x00000020U) /*!< Bit mask for CSU_SA_L_SDMA. */
#define BS_CSU_SA_L_SDMA     (1U)          /*!< Bit field size in bits for CSU_SA_L_SDMA. */

/*! @brief Read current value of the CSU_SA_L_SDMA field. */
#define BR_CSU_SA_L_SDMA(x)  (HW_CSU_SA(x).B.L_SDMA)

/*! @brief Format value for bitfield CSU_SA_L_SDMA. */
#define BF_CSU_SA_L_SDMA(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_SDMA) & BM_CSU_SA_L_SDMA)

/*! @brief Set the L_SDMA field to a new value. */
#define BW_CSU_SA_L_SDMA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_SDMA) | BF_CSU_SA_L_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_PU[6] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for GPU3D, VDOA, GPU2D, IPU1,
 * IPU2, OPENVG and VPU.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_PU     (6U)          /*!< Bit position for CSU_SA_NSA_PU. */
#define BM_CSU_SA_NSA_PU     (0x00000040U) /*!< Bit mask for CSU_SA_NSA_PU. */
#define BS_CSU_SA_NSA_PU     (1U)          /*!< Bit field size in bits for CSU_SA_NSA_PU. */

/*! @brief Read current value of the CSU_SA_NSA_PU field. */
#define BR_CSU_SA_NSA_PU(x)  (HW_CSU_SA(x).B.NSA_PU)

/*! @brief Format value for bitfield CSU_SA_NSA_PU. */
#define BF_CSU_SA_NSA_PU(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_PU) & BM_CSU_SA_NSA_PU)

/*! @brief Set the NSA_PU field to a new value. */
#define BW_CSU_SA_NSA_PU(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_PU) | BF_CSU_SA_NSA_PU(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_PU[7] (RW)
 *
 * Lock bit set by TZ software for NSA_PU.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_PU       (7U)          /*!< Bit position for CSU_SA_L_PU. */
#define BM_CSU_SA_L_PU       (0x00000080U) /*!< Bit mask for CSU_SA_L_PU. */
#define BS_CSU_SA_L_PU       (1U)          /*!< Bit field size in bits for CSU_SA_L_PU. */

/*! @brief Read current value of the CSU_SA_L_PU field. */
#define BR_CSU_SA_L_PU(x)    (HW_CSU_SA(x).B.L_PU)

/*! @brief Format value for bitfield CSU_SA_L_PU. */
#define BF_CSU_SA_L_PU(v)    ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_PU) & BM_CSU_SA_L_PU)

/*! @brief Set the L_PU field to a new value. */
#define BW_CSU_SA_L_PU(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_PU) | BF_CSU_SA_L_PU(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_USB_MLB[8] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for USB and MLB.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_USB_MLB (8U)         /*!< Bit position for CSU_SA_NSA_USB_MLB. */
#define BM_CSU_SA_NSA_USB_MLB (0x00000100U) /*!< Bit mask for CSU_SA_NSA_USB_MLB. */
#define BS_CSU_SA_NSA_USB_MLB (1U)         /*!< Bit field size in bits for CSU_SA_NSA_USB_MLB. */

/*! @brief Read current value of the CSU_SA_NSA_USB_MLB field. */
#define BR_CSU_SA_NSA_USB_MLB(x) (HW_CSU_SA(x).B.NSA_USB_MLB)

/*! @brief Format value for bitfield CSU_SA_NSA_USB_MLB. */
#define BF_CSU_SA_NSA_USB_MLB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_USB_MLB) & BM_CSU_SA_NSA_USB_MLB)

/*! @brief Set the NSA_USB_MLB field to a new value. */
#define BW_CSU_SA_NSA_USB_MLB(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_USB_MLB) | BF_CSU_SA_NSA_USB_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_USB_MLB[9] (RW)
 *
 * Lock bit set by TZ software for NSA_USB_MLB.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_USB_MLB  (9U)          /*!< Bit position for CSU_SA_L_USB_MLB. */
#define BM_CSU_SA_L_USB_MLB  (0x00000200U) /*!< Bit mask for CSU_SA_L_USB_MLB. */
#define BS_CSU_SA_L_USB_MLB  (1U)          /*!< Bit field size in bits for CSU_SA_L_USB_MLB. */

/*! @brief Read current value of the CSU_SA_L_USB_MLB field. */
#define BR_CSU_SA_L_USB_MLB(x) (HW_CSU_SA(x).B.L_USB_MLB)

/*! @brief Format value for bitfield CSU_SA_L_USB_MLB. */
#define BF_CSU_SA_L_USB_MLB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_USB_MLB) & BM_CSU_SA_L_USB_MLB)

/*! @brief Set the L_USB_MLB field to a new value. */
#define BW_CSU_SA_L_USB_MLB(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_USB_MLB) | BF_CSU_SA_L_USB_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_PCIE_TEST[10] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for PCIe and IOMUX Test Port.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_PCIE_TEST (10U)      /*!< Bit position for CSU_SA_NSA_PCIE_TEST. */
#define BM_CSU_SA_NSA_PCIE_TEST (0x00000400U) /*!< Bit mask for CSU_SA_NSA_PCIE_TEST. */
#define BS_CSU_SA_NSA_PCIE_TEST (1U)       /*!< Bit field size in bits for CSU_SA_NSA_PCIE_TEST. */

/*! @brief Read current value of the CSU_SA_NSA_PCIE_TEST field. */
#define BR_CSU_SA_NSA_PCIE_TEST(x) (HW_CSU_SA(x).B.NSA_PCIE_TEST)

/*! @brief Format value for bitfield CSU_SA_NSA_PCIE_TEST. */
#define BF_CSU_SA_NSA_PCIE_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_PCIE_TEST) & BM_CSU_SA_NSA_PCIE_TEST)

/*! @brief Set the NSA_PCIE_TEST field to a new value. */
#define BW_CSU_SA_NSA_PCIE_TEST(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_PCIE_TEST) | BF_CSU_SA_NSA_PCIE_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_PCIE_TEST[11] (RW)
 *
 * Lock bit set by TZ software for NSA_PCIE_TEST.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_PCIE_TEST (11U)        /*!< Bit position for CSU_SA_L_PCIE_TEST. */
#define BM_CSU_SA_L_PCIE_TEST (0x00000800U) /*!< Bit mask for CSU_SA_L_PCIE_TEST. */
#define BS_CSU_SA_L_PCIE_TEST (1U)         /*!< Bit field size in bits for CSU_SA_L_PCIE_TEST. */

/*! @brief Read current value of the CSU_SA_L_PCIE_TEST field. */
#define BR_CSU_SA_L_PCIE_TEST(x) (HW_CSU_SA(x).B.L_PCIE_TEST)

/*! @brief Format value for bitfield CSU_SA_L_PCIE_TEST. */
#define BF_CSU_SA_L_PCIE_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_PCIE_TEST) & BM_CSU_SA_L_PCIE_TEST)

/*! @brief Set the L_PCIE_TEST field to a new value. */
#define BW_CSU_SA_L_PCIE_TEST(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_PCIE_TEST) | BF_CSU_SA_L_PCIE_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_RAWNAND_APBHDMA[14] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for RawNAND and apbhdmat.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_RAWNAND_APBHDMA (14U) /*!< Bit position for CSU_SA_NSA_RAWNAND_APBHDMA. */
#define BM_CSU_SA_NSA_RAWNAND_APBHDMA (0x00004000U) /*!< Bit mask for CSU_SA_NSA_RAWNAND_APBHDMA. */
#define BS_CSU_SA_NSA_RAWNAND_APBHDMA (1U) /*!< Bit field size in bits for CSU_SA_NSA_RAWNAND_APBHDMA. */

/*! @brief Read current value of the CSU_SA_NSA_RAWNAND_APBHDMA field. */
#define BR_CSU_SA_NSA_RAWNAND_APBHDMA(x) (HW_CSU_SA(x).B.NSA_RAWNAND_APBHDMA)

/*! @brief Format value for bitfield CSU_SA_NSA_RAWNAND_APBHDMA. */
#define BF_CSU_SA_NSA_RAWNAND_APBHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_RAWNAND_APBHDMA) & BM_CSU_SA_NSA_RAWNAND_APBHDMA)

/*! @brief Set the NSA_RAWNAND_APBHDMA field to a new value. */
#define BW_CSU_SA_NSA_RAWNAND_APBHDMA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_RAWNAND_APBHDMA) | BF_CSU_SA_NSA_RAWNAND_APBHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_RAWNAND_APBHDMA[15] (RW)
 *
 * Lock bit set by TZ software for NSA_RAWNAND_APBHDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_RAWNAND_APBHDMA (15U)  /*!< Bit position for CSU_SA_L_RAWNAND_APBHDMA. */
#define BM_CSU_SA_L_RAWNAND_APBHDMA (0x00008000U) /*!< Bit mask for CSU_SA_L_RAWNAND_APBHDMA. */
#define BS_CSU_SA_L_RAWNAND_APBHDMA (1U)   /*!< Bit field size in bits for CSU_SA_L_RAWNAND_APBHDMA. */

/*! @brief Read current value of the CSU_SA_L_RAWNAND_APBHDMA field. */
#define BR_CSU_SA_L_RAWNAND_APBHDMA(x) (HW_CSU_SA(x).B.L_RAWNAND_APBHDMA)

/*! @brief Format value for bitfield CSU_SA_L_RAWNAND_APBHDMA. */
#define BF_CSU_SA_L_RAWNAND_APBHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_RAWNAND_APBHDMA) & BM_CSU_SA_L_RAWNAND_APBHDMA)

/*! @brief Set the L_RAWNAND_APBHDMA field to a new value. */
#define BW_CSU_SA_L_RAWNAND_APBHDMA(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_RAWNAND_APBHDMA) | BF_CSU_SA_L_RAWNAND_APBHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_ENET[16] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for ENET.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_ENET   (16U)         /*!< Bit position for CSU_SA_NSA_ENET. */
#define BM_CSU_SA_NSA_ENET   (0x00010000U) /*!< Bit mask for CSU_SA_NSA_ENET. */
#define BS_CSU_SA_NSA_ENET   (1U)          /*!< Bit field size in bits for CSU_SA_NSA_ENET. */

/*! @brief Read current value of the CSU_SA_NSA_ENET field. */
#define BR_CSU_SA_NSA_ENET(x) (HW_CSU_SA(x).B.NSA_ENET)

/*! @brief Format value for bitfield CSU_SA_NSA_ENET. */
#define BF_CSU_SA_NSA_ENET(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_ENET) & BM_CSU_SA_NSA_ENET)

/*! @brief Set the NSA_ENET field to a new value. */
#define BW_CSU_SA_NSA_ENET(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_ENET) | BF_CSU_SA_NSA_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_ENET[17] (RW)
 *
 * Lock bit set by TZ software for NSA_ENET.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_ENET     (17U)         /*!< Bit position for CSU_SA_L_ENET. */
#define BM_CSU_SA_L_ENET     (0x00020000U) /*!< Bit mask for CSU_SA_L_ENET. */
#define BS_CSU_SA_L_ENET     (1U)          /*!< Bit field size in bits for CSU_SA_L_ENET. */

/*! @brief Read current value of the CSU_SA_L_ENET field. */
#define BR_CSU_SA_L_ENET(x)  (HW_CSU_SA(x).B.L_ENET)

/*! @brief Format value for bitfield CSU_SA_L_ENET. */
#define BF_CSU_SA_L_ENET(v)  ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_ENET) & BM_CSU_SA_L_ENET)

/*! @brief Set the L_ENET field to a new value. */
#define BW_CSU_SA_L_ENET(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_ENET) | BF_CSU_SA_L_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_DAP[18] (RW)
 *
 * Access Policy indicator bits
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_DAP    (18U)         /*!< Bit position for CSU_SA_NSA_DAP. */
#define BM_CSU_SA_NSA_DAP    (0x00040000U) /*!< Bit mask for CSU_SA_NSA_DAP. */
#define BS_CSU_SA_NSA_DAP    (1U)          /*!< Bit field size in bits for CSU_SA_NSA_DAP. */

/*! @brief Read current value of the CSU_SA_NSA_DAP field. */
#define BR_CSU_SA_NSA_DAP(x) (HW_CSU_SA(x).B.NSA_DAP)

/*! @brief Format value for bitfield CSU_SA_NSA_DAP. */
#define BF_CSU_SA_NSA_DAP(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_DAP) & BM_CSU_SA_NSA_DAP)

/*! @brief Set the NSA_DAP field to a new value. */
#define BW_CSU_SA_NSA_DAP(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_DAP) | BF_CSU_SA_NSA_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_DAP[19] (RW)
 *
 * Lock bit set by TZ software for NSA_DAP.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_DAP      (19U)         /*!< Bit position for CSU_SA_L_DAP. */
#define BM_CSU_SA_L_DAP      (0x00080000U) /*!< Bit mask for CSU_SA_L_DAP. */
#define BS_CSU_SA_L_DAP      (1U)          /*!< Bit field size in bits for CSU_SA_L_DAP. */

/*! @brief Read current value of the CSU_SA_L_DAP field. */
#define BR_CSU_SA_L_DAP(x)   (HW_CSU_SA(x).B.L_DAP)

/*! @brief Format value for bitfield CSU_SA_L_DAP. */
#define BF_CSU_SA_L_DAP(v)   ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_DAP) & BM_CSU_SA_L_DAP)

/*! @brief Set the L_DAP field to a new value. */
#define BW_CSU_SA_L_DAP(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_DAP) | BF_CSU_SA_L_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_USDHC1[20] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for USDHC1.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_USDHC1 (20U)         /*!< Bit position for CSU_SA_NSA_USDHC1. */
#define BM_CSU_SA_NSA_USDHC1 (0x00100000U) /*!< Bit mask for CSU_SA_NSA_USDHC1. */
#define BS_CSU_SA_NSA_USDHC1 (1U)          /*!< Bit field size in bits for CSU_SA_NSA_USDHC1. */

/*! @brief Read current value of the CSU_SA_NSA_USDHC1 field. */
#define BR_CSU_SA_NSA_USDHC1(x) (HW_CSU_SA(x).B.NSA_USDHC1)

/*! @brief Format value for bitfield CSU_SA_NSA_USDHC1. */
#define BF_CSU_SA_NSA_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_USDHC1) & BM_CSU_SA_NSA_USDHC1)

/*! @brief Set the NSA_USDHC1 field to a new value. */
#define BW_CSU_SA_NSA_USDHC1(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_USDHC1) | BF_CSU_SA_NSA_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_USDHC1[21] (RW)
 *
 * Lock bit set by TZ software for NSA_USDHC1.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_USDHC1   (21U)         /*!< Bit position for CSU_SA_L_USDHC1. */
#define BM_CSU_SA_L_USDHC1   (0x00200000U) /*!< Bit mask for CSU_SA_L_USDHC1. */
#define BS_CSU_SA_L_USDHC1   (1U)          /*!< Bit field size in bits for CSU_SA_L_USDHC1. */

/*! @brief Read current value of the CSU_SA_L_USDHC1 field. */
#define BR_CSU_SA_L_USDHC1(x) (HW_CSU_SA(x).B.L_USDHC1)

/*! @brief Format value for bitfield CSU_SA_L_USDHC1. */
#define BF_CSU_SA_L_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_USDHC1) & BM_CSU_SA_L_USDHC1)

/*! @brief Set the L_USDHC1 field to a new value. */
#define BW_CSU_SA_L_USDHC1(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_USDHC1) | BF_CSU_SA_L_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_USDHC2[22] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for USDHC2.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_USDHC2 (22U)         /*!< Bit position for CSU_SA_NSA_USDHC2. */
#define BM_CSU_SA_NSA_USDHC2 (0x00400000U) /*!< Bit mask for CSU_SA_NSA_USDHC2. */
#define BS_CSU_SA_NSA_USDHC2 (1U)          /*!< Bit field size in bits for CSU_SA_NSA_USDHC2. */

/*! @brief Read current value of the CSU_SA_NSA_USDHC2 field. */
#define BR_CSU_SA_NSA_USDHC2(x) (HW_CSU_SA(x).B.NSA_USDHC2)

/*! @brief Format value for bitfield CSU_SA_NSA_USDHC2. */
#define BF_CSU_SA_NSA_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_USDHC2) & BM_CSU_SA_NSA_USDHC2)

/*! @brief Set the NSA_USDHC2 field to a new value. */
#define BW_CSU_SA_NSA_USDHC2(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_USDHC2) | BF_CSU_SA_NSA_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_USDHC2[23] (RW)
 *
 * Lock bit set by TZ software for NSA_USDHC2.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_USDHC2   (23U)         /*!< Bit position for CSU_SA_L_USDHC2. */
#define BM_CSU_SA_L_USDHC2   (0x00800000U) /*!< Bit mask for CSU_SA_L_USDHC2. */
#define BS_CSU_SA_L_USDHC2   (1U)          /*!< Bit field size in bits for CSU_SA_L_USDHC2. */

/*! @brief Read current value of the CSU_SA_L_USDHC2 field. */
#define BR_CSU_SA_L_USDHC2(x) (HW_CSU_SA(x).B.L_USDHC2)

/*! @brief Format value for bitfield CSU_SA_L_USDHC2. */
#define BF_CSU_SA_L_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_USDHC2) & BM_CSU_SA_L_USDHC2)

/*! @brief Set the L_USDHC2 field to a new value. */
#define BW_CSU_SA_L_USDHC2(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_USDHC2) | BF_CSU_SA_L_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_USDHC3[24] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for USDHC3.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_USDHC3 (24U)         /*!< Bit position for CSU_SA_NSA_USDHC3. */
#define BM_CSU_SA_NSA_USDHC3 (0x01000000U) /*!< Bit mask for CSU_SA_NSA_USDHC3. */
#define BS_CSU_SA_NSA_USDHC3 (1U)          /*!< Bit field size in bits for CSU_SA_NSA_USDHC3. */

/*! @brief Read current value of the CSU_SA_NSA_USDHC3 field. */
#define BR_CSU_SA_NSA_USDHC3(x) (HW_CSU_SA(x).B.NSA_USDHC3)

/*! @brief Format value for bitfield CSU_SA_NSA_USDHC3. */
#define BF_CSU_SA_NSA_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_USDHC3) & BM_CSU_SA_NSA_USDHC3)

/*! @brief Set the NSA_USDHC3 field to a new value. */
#define BW_CSU_SA_NSA_USDHC3(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_USDHC3) | BF_CSU_SA_NSA_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_USDHC3[25] (RW)
 *
 * Lock bit set by TZ software for NSA_USDHC3.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_USDHC3   (25U)         /*!< Bit position for CSU_SA_L_USDHC3. */
#define BM_CSU_SA_L_USDHC3   (0x02000000U) /*!< Bit mask for CSU_SA_L_USDHC3. */
#define BS_CSU_SA_L_USDHC3   (1U)          /*!< Bit field size in bits for CSU_SA_L_USDHC3. */

/*! @brief Read current value of the CSU_SA_L_USDHC3 field. */
#define BR_CSU_SA_L_USDHC3(x) (HW_CSU_SA(x).B.L_USDHC3)

/*! @brief Format value for bitfield CSU_SA_L_USDHC3. */
#define BF_CSU_SA_L_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_USDHC3) & BM_CSU_SA_L_USDHC3)

/*! @brief Set the L_USDHC3 field to a new value. */
#define BW_CSU_SA_L_USDHC3(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_USDHC3) | BF_CSU_SA_L_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_USDHC4[26] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for USDHC4.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_USDHC4 (26U)         /*!< Bit position for CSU_SA_NSA_USDHC4. */
#define BM_CSU_SA_NSA_USDHC4 (0x04000000U) /*!< Bit mask for CSU_SA_NSA_USDHC4. */
#define BS_CSU_SA_NSA_USDHC4 (1U)          /*!< Bit field size in bits for CSU_SA_NSA_USDHC4. */

/*! @brief Read current value of the CSU_SA_NSA_USDHC4 field. */
#define BR_CSU_SA_NSA_USDHC4(x) (HW_CSU_SA(x).B.NSA_USDHC4)

/*! @brief Format value for bitfield CSU_SA_NSA_USDHC4. */
#define BF_CSU_SA_NSA_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_USDHC4) & BM_CSU_SA_NSA_USDHC4)

/*! @brief Set the NSA_USDHC4 field to a new value. */
#define BW_CSU_SA_NSA_USDHC4(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_USDHC4) | BF_CSU_SA_NSA_USDHC4(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_USDHC4[27] (RW)
 *
 * Lock bit set by TZ software for NSA_USDHC14.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_USDHC4   (27U)         /*!< Bit position for CSU_SA_L_USDHC4. */
#define BM_CSU_SA_L_USDHC4   (0x08000000U) /*!< Bit mask for CSU_SA_L_USDHC4. */
#define BS_CSU_SA_L_USDHC4   (1U)          /*!< Bit field size in bits for CSU_SA_L_USDHC4. */

/*! @brief Read current value of the CSU_SA_L_USDHC4 field. */
#define BR_CSU_SA_L_USDHC4(x) (HW_CSU_SA(x).B.L_USDHC4)

/*! @brief Format value for bitfield CSU_SA_L_USDHC4. */
#define BF_CSU_SA_L_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_USDHC4) & BM_CSU_SA_L_USDHC4)

/*! @brief Set the L_USDHC4 field to a new value. */
#define BW_CSU_SA_L_USDHC4(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_USDHC4) | BF_CSU_SA_L_USDHC4(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field NSA_HDMI_HSI[28] (RW)
 *
 * Indicate the Type (Secured/Non-Secured) Access for HDMI Tx and HSI.
 *
 * Values:
 * - 0 - Secure access for the corresponding Type 1 master
 * - 1 - Non-secure access for the corresponding Type 1 master
 */
/*@{*/
#define BP_CSU_SA_NSA_HDMI_HSI (28U)       /*!< Bit position for CSU_SA_NSA_HDMI_HSI. */
#define BM_CSU_SA_NSA_HDMI_HSI (0x10000000U) /*!< Bit mask for CSU_SA_NSA_HDMI_HSI. */
#define BS_CSU_SA_NSA_HDMI_HSI (1U)        /*!< Bit field size in bits for CSU_SA_NSA_HDMI_HSI. */

/*! @brief Read current value of the CSU_SA_NSA_HDMI_HSI field. */
#define BR_CSU_SA_NSA_HDMI_HSI(x) (HW_CSU_SA(x).B.NSA_HDMI_HSI)

/*! @brief Format value for bitfield CSU_SA_NSA_HDMI_HSI. */
#define BF_CSU_SA_NSA_HDMI_HSI(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_NSA_HDMI_HSI) & BM_CSU_SA_NSA_HDMI_HSI)

/*! @brief Set the NSA_HDMI_HSI field to a new value. */
#define BW_CSU_SA_NSA_HDMI_HSI(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_NSA_HDMI_HSI) | BF_CSU_SA_NSA_HDMI_HSI(v)))
/*@}*/

/*!
 * @name Register CSU_SA, field L_HDMI_HSI[29] (RW)
 *
 * Lock bit set by TZ software for NSA_HDMI_HSI.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_SA_L_HDMI_HSI (29U)         /*!< Bit position for CSU_SA_L_HDMI_HSI. */
#define BM_CSU_SA_L_HDMI_HSI (0x20000000U) /*!< Bit mask for CSU_SA_L_HDMI_HSI. */
#define BS_CSU_SA_L_HDMI_HSI (1U)          /*!< Bit field size in bits for CSU_SA_L_HDMI_HSI. */

/*! @brief Read current value of the CSU_SA_L_HDMI_HSI field. */
#define BR_CSU_SA_L_HDMI_HSI(x) (HW_CSU_SA(x).B.L_HDMI_HSI)

/*! @brief Format value for bitfield CSU_SA_L_HDMI_HSI. */
#define BF_CSU_SA_L_HDMI_HSI(v) ((uint32_t)((uint32_t)(v) << BP_CSU_SA_L_HDMI_HSI) & BM_CSU_SA_L_HDMI_HSI)

/*! @brief Set the L_HDMI_HSI field to a new value. */
#define BW_CSU_SA_L_HDMI_HSI(x, v) (HW_CSU_SA_WR(x, (HW_CSU_SA_RD(x) & ~BM_CSU_SA_L_HDMI_HSI) | BF_CSU_SA_L_HDMI_HSI(v)))
/*@}*/

/*******************************************************************************
 * HW_CSU_HPCONTROL0 - HPCONTROL0 register
 ******************************************************************************/

/*!
 * @brief HW_CSU_HPCONTROL0 - HPCONTROL0 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The HP Control registers CSU_HPCONTROL0 and CSU_HPCONTROL1 enable CSU to
 * control the USER/SUPERVISOR mode state for the specified masters. The register
 * toggles the output signal csu_hprot1 for system masters. The two possibilities
 * sources for the csu_hprot1 output are: the hprot1 input signal, or the
 * corresponding bit in the HP register. The even bits in the registers are used for
 * locking the control bit values.
 */
typedef union _hw_csu_hpcontrol0
{
    uint32_t U;
    struct _hw_csu_hpcontrol0_bitfields
    {
        uint32_t HPC_PCIE : 1;         /*!< [0]  */
        uint32_t L_PCIE : 1;           /*!< [1]  */
        uint32_t HPC_SATA : 1;         /*!< [2]  */
        uint32_t L_SATA : 1;           /*!< [3]  */
        uint32_t HPC_SDMA : 1;         /*!< [4]  */
        uint32_t L_SDMA : 1;           /*!< [5]  */
        uint32_t HPC_PU : 1;           /*!< [6]  */
        uint32_t L_PU : 1;             /*!< [7]  */
        uint32_t HPC_USB : 1;          /*!< [8]  */
        uint32_t L_USB : 1;            /*!< [9]  */
        uint32_t HPC_TEST : 1;         /*!< [10]  */
        uint32_t L_TEST : 1;           /*!< [11]  */
        uint32_t HPC_MLB : 1;          /*!< [12]  */
        uint32_t L_MLB : 1;            /*!< [13]  */
        uint32_t HPC_CAAM : 1;         /*!< [14]  */
        uint32_t L_CAAM : 1;           /*!< [15]  */
        uint32_t HPC_RAWNAND : 1;      /*!< [16]  */
        uint32_t L_RAWNAND : 1;        /*!< [17]  */
        uint32_t HPC_APBHDMA : 1;      /*!< [18]  */
        uint32_t L_ABPHDMA : 1;        /*!< [19]  */
        uint32_t HPC_ENET : 1;         /*!< [20]  */
        uint32_t L_ENET : 1;           /*!< [21]  */
        uint32_t HPC_DAP : 1;          /*!< [22]  */
        uint32_t L_DAP : 1;            /*!< [23]  */
        uint32_t HPC_USDHC1 : 1;       /*!< [24]  */
        uint32_t L_USDHC1 : 1;         /*!< [25]  */
        uint32_t HPC_USDHC2 : 1;       /*!< [26]  */
        uint32_t L_USDHC2 : 1;         /*!< [27]  */
        uint32_t HPC_USDHC3 : 1;       /*!< [28]  */
        uint32_t L_USDHC3 : 1;         /*!< [29]  */
        uint32_t HPC_USDHC4 : 1;       /*!< [30]  */
        uint32_t L_USDHC4 : 1;         /*!< [31]  */
    } B;
} hw_csu_hpcontrol0_t;

/*!
 * @name Constants and macros for entire CSU_HPCONTROL0 register
 */
/*@{*/
#define HW_CSU_HPCONTROL0_ADDR(x) ((uintptr_t)(x) + 0x358U)

#define HW_CSU_HPCONTROL0(x)     (*(__IO hw_csu_hpcontrol0_t *) HW_CSU_HPCONTROL0_ADDR(x))
#define HW_CSU_HPCONTROL0_RD(x)  (HW_CSU_HPCONTROL0(x).U)
#define HW_CSU_HPCONTROL0_WR(x, v) (HW_CSU_HPCONTROL0(x).U = (v))
#define HW_CSU_HPCONTROL0_SET(x, v) (HW_CSU_HPCONTROL0_WR(x, HW_CSU_HPCONTROL0_RD(x) |  (v)))
#define HW_CSU_HPCONTROL0_CLR(x, v) (HW_CSU_HPCONTROL0_WR(x, HW_CSU_HPCONTROL0_RD(x) & ~(v)))
#define HW_CSU_HPCONTROL0_TOG(x, v) (HW_CSU_HPCONTROL0_WR(x, HW_CSU_HPCONTROL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_HPCONTROL0 bitfields
 */

/*!
 * @name Register CSU_HPCONTROL0, field HPC_PCIE[0] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of PCIE.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_PCIE (0U)    /*!< Bit position for CSU_HPCONTROL0_HPC_PCIE. */
#define BM_CSU_HPCONTROL0_HPC_PCIE (0x00000001U) /*!< Bit mask for CSU_HPCONTROL0_HPC_PCIE. */
#define BS_CSU_HPCONTROL0_HPC_PCIE (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_PCIE. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_PCIE field. */
#define BR_CSU_HPCONTROL0_HPC_PCIE(x) (HW_CSU_HPCONTROL0(x).B.HPC_PCIE)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_PCIE. */
#define BF_CSU_HPCONTROL0_HPC_PCIE(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_PCIE) & BM_CSU_HPCONTROL0_HPC_PCIE)

/*! @brief Set the HPC_PCIE field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_PCIE(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_PCIE) | BF_CSU_HPCONTROL0_HPC_PCIE(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_PCIE[1] (RW)
 *
 * Lock bit set by TZ software for HPC_PCIE.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_PCIE (1U)      /*!< Bit position for CSU_HPCONTROL0_L_PCIE. */
#define BM_CSU_HPCONTROL0_L_PCIE (0x00000002U) /*!< Bit mask for CSU_HPCONTROL0_L_PCIE. */
#define BS_CSU_HPCONTROL0_L_PCIE (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_PCIE. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_PCIE field. */
#define BR_CSU_HPCONTROL0_L_PCIE(x) (HW_CSU_HPCONTROL0(x).B.L_PCIE)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_PCIE. */
#define BF_CSU_HPCONTROL0_L_PCIE(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_PCIE) & BM_CSU_HPCONTROL0_L_PCIE)

/*! @brief Set the L_PCIE field to a new value. */
#define BW_CSU_HPCONTROL0_L_PCIE(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_PCIE) | BF_CSU_HPCONTROL0_L_PCIE(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_SATA[2] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of SATA.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_SATA (2U)    /*!< Bit position for CSU_HPCONTROL0_HPC_SATA. */
#define BM_CSU_HPCONTROL0_HPC_SATA (0x00000004U) /*!< Bit mask for CSU_HPCONTROL0_HPC_SATA. */
#define BS_CSU_HPCONTROL0_HPC_SATA (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_SATA. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_SATA field. */
#define BR_CSU_HPCONTROL0_HPC_SATA(x) (HW_CSU_HPCONTROL0(x).B.HPC_SATA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_SATA. */
#define BF_CSU_HPCONTROL0_HPC_SATA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_SATA) & BM_CSU_HPCONTROL0_HPC_SATA)

/*! @brief Set the HPC_SATA field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_SATA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_SATA) | BF_CSU_HPCONTROL0_HPC_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_SATA[3] (RW)
 *
 * Lock bit set by TZ software for HPC_SATA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_SATA (3U)      /*!< Bit position for CSU_HPCONTROL0_L_SATA. */
#define BM_CSU_HPCONTROL0_L_SATA (0x00000008U) /*!< Bit mask for CSU_HPCONTROL0_L_SATA. */
#define BS_CSU_HPCONTROL0_L_SATA (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_SATA. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_SATA field. */
#define BR_CSU_HPCONTROL0_L_SATA(x) (HW_CSU_HPCONTROL0(x).B.L_SATA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_SATA. */
#define BF_CSU_HPCONTROL0_L_SATA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_SATA) & BM_CSU_HPCONTROL0_L_SATA)

/*! @brief Set the L_SATA field to a new value. */
#define BW_CSU_HPCONTROL0_L_SATA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_SATA) | BF_CSU_HPCONTROL0_L_SATA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_SDMA[4] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of SDMA.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_SDMA (4U)    /*!< Bit position for CSU_HPCONTROL0_HPC_SDMA. */
#define BM_CSU_HPCONTROL0_HPC_SDMA (0x00000010U) /*!< Bit mask for CSU_HPCONTROL0_HPC_SDMA. */
#define BS_CSU_HPCONTROL0_HPC_SDMA (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_SDMA. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_SDMA field. */
#define BR_CSU_HPCONTROL0_HPC_SDMA(x) (HW_CSU_HPCONTROL0(x).B.HPC_SDMA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_SDMA. */
#define BF_CSU_HPCONTROL0_HPC_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_SDMA) & BM_CSU_HPCONTROL0_HPC_SDMA)

/*! @brief Set the HPC_SDMA field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_SDMA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_SDMA) | BF_CSU_HPCONTROL0_HPC_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_SDMA[5] (RW)
 *
 * Lock bit set by TZ software for HPC_SDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_SDMA (5U)      /*!< Bit position for CSU_HPCONTROL0_L_SDMA. */
#define BM_CSU_HPCONTROL0_L_SDMA (0x00000020U) /*!< Bit mask for CSU_HPCONTROL0_L_SDMA. */
#define BS_CSU_HPCONTROL0_L_SDMA (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_SDMA. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_SDMA field. */
#define BR_CSU_HPCONTROL0_L_SDMA(x) (HW_CSU_HPCONTROL0(x).B.L_SDMA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_SDMA. */
#define BF_CSU_HPCONTROL0_L_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_SDMA) & BM_CSU_HPCONTROL0_L_SDMA)

/*! @brief Set the L_SDMA field to a new value. */
#define BW_CSU_HPCONTROL0_L_SDMA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_SDMA) | BF_CSU_HPCONTROL0_L_SDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_PU[6] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of GPU3D, GPU2D, VPU, IPU1, IPU2, OpenVG and VDOA.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_PU (6U)      /*!< Bit position for CSU_HPCONTROL0_HPC_PU. */
#define BM_CSU_HPCONTROL0_HPC_PU (0x00000040U) /*!< Bit mask for CSU_HPCONTROL0_HPC_PU. */
#define BS_CSU_HPCONTROL0_HPC_PU (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_PU. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_PU field. */
#define BR_CSU_HPCONTROL0_HPC_PU(x) (HW_CSU_HPCONTROL0(x).B.HPC_PU)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_PU. */
#define BF_CSU_HPCONTROL0_HPC_PU(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_PU) & BM_CSU_HPCONTROL0_HPC_PU)

/*! @brief Set the HPC_PU field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_PU(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_PU) | BF_CSU_HPCONTROL0_HPC_PU(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_PU[7] (RW)
 *
 * Lock bit set by TZ software for HPC_PU.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_PU (7U)        /*!< Bit position for CSU_HPCONTROL0_L_PU. */
#define BM_CSU_HPCONTROL0_L_PU (0x00000080U) /*!< Bit mask for CSU_HPCONTROL0_L_PU. */
#define BS_CSU_HPCONTROL0_L_PU (1U)        /*!< Bit field size in bits for CSU_HPCONTROL0_L_PU. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_PU field. */
#define BR_CSU_HPCONTROL0_L_PU(x) (HW_CSU_HPCONTROL0(x).B.L_PU)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_PU. */
#define BF_CSU_HPCONTROL0_L_PU(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_PU) & BM_CSU_HPCONTROL0_L_PU)

/*! @brief Set the L_PU field to a new value. */
#define BW_CSU_HPCONTROL0_L_PU(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_PU) | BF_CSU_HPCONTROL0_L_PU(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_USB[8] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of USB.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_USB (8U)     /*!< Bit position for CSU_HPCONTROL0_HPC_USB. */
#define BM_CSU_HPCONTROL0_HPC_USB (0x00000100U) /*!< Bit mask for CSU_HPCONTROL0_HPC_USB. */
#define BS_CSU_HPCONTROL0_HPC_USB (1U)     /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_USB. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_USB field. */
#define BR_CSU_HPCONTROL0_HPC_USB(x) (HW_CSU_HPCONTROL0(x).B.HPC_USB)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_USB. */
#define BF_CSU_HPCONTROL0_HPC_USB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_USB) & BM_CSU_HPCONTROL0_HPC_USB)

/*! @brief Set the HPC_USB field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_USB(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_USB) | BF_CSU_HPCONTROL0_HPC_USB(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_USB[9] (RW)
 *
 * Lock bit set by TZ software for HPC_USB.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_USB (9U)       /*!< Bit position for CSU_HPCONTROL0_L_USB. */
#define BM_CSU_HPCONTROL0_L_USB (0x00000200U) /*!< Bit mask for CSU_HPCONTROL0_L_USB. */
#define BS_CSU_HPCONTROL0_L_USB (1U)       /*!< Bit field size in bits for CSU_HPCONTROL0_L_USB. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_USB field. */
#define BR_CSU_HPCONTROL0_L_USB(x) (HW_CSU_HPCONTROL0(x).B.L_USB)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_USB. */
#define BF_CSU_HPCONTROL0_L_USB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_USB) & BM_CSU_HPCONTROL0_L_USB)

/*! @brief Set the L_USB field to a new value. */
#define BW_CSU_HPCONTROL0_L_USB(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_USB) | BF_CSU_HPCONTROL0_L_USB(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_TEST[10] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of IOMUX Test Port.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_TEST (10U)   /*!< Bit position for CSU_HPCONTROL0_HPC_TEST. */
#define BM_CSU_HPCONTROL0_HPC_TEST (0x00000400U) /*!< Bit mask for CSU_HPCONTROL0_HPC_TEST. */
#define BS_CSU_HPCONTROL0_HPC_TEST (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_TEST. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_TEST field. */
#define BR_CSU_HPCONTROL0_HPC_TEST(x) (HW_CSU_HPCONTROL0(x).B.HPC_TEST)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_TEST. */
#define BF_CSU_HPCONTROL0_HPC_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_TEST) & BM_CSU_HPCONTROL0_HPC_TEST)

/*! @brief Set the HPC_TEST field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_TEST(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_TEST) | BF_CSU_HPCONTROL0_HPC_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_TEST[11] (RW)
 *
 * Lock bit set by TZ software for HPC_TEST.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_TEST (11U)     /*!< Bit position for CSU_HPCONTROL0_L_TEST. */
#define BM_CSU_HPCONTROL0_L_TEST (0x00000800U) /*!< Bit mask for CSU_HPCONTROL0_L_TEST. */
#define BS_CSU_HPCONTROL0_L_TEST (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_TEST. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_TEST field. */
#define BR_CSU_HPCONTROL0_L_TEST(x) (HW_CSU_HPCONTROL0(x).B.L_TEST)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_TEST. */
#define BF_CSU_HPCONTROL0_L_TEST(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_TEST) & BM_CSU_HPCONTROL0_L_TEST)

/*! @brief Set the L_TEST field to a new value. */
#define BW_CSU_HPCONTROL0_L_TEST(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_TEST) | BF_CSU_HPCONTROL0_L_TEST(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_MLB[12] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of MLB.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_MLB (12U)    /*!< Bit position for CSU_HPCONTROL0_HPC_MLB. */
#define BM_CSU_HPCONTROL0_HPC_MLB (0x00001000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_MLB. */
#define BS_CSU_HPCONTROL0_HPC_MLB (1U)     /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_MLB. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_MLB field. */
#define BR_CSU_HPCONTROL0_HPC_MLB(x) (HW_CSU_HPCONTROL0(x).B.HPC_MLB)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_MLB. */
#define BF_CSU_HPCONTROL0_HPC_MLB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_MLB) & BM_CSU_HPCONTROL0_HPC_MLB)

/*! @brief Set the HPC_MLB field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_MLB(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_MLB) | BF_CSU_HPCONTROL0_HPC_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_MLB[13] (RW)
 *
 * Lock bit set by TZ software for HPC_MLB.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_MLB (13U)      /*!< Bit position for CSU_HPCONTROL0_L_MLB. */
#define BM_CSU_HPCONTROL0_L_MLB (0x00002000U) /*!< Bit mask for CSU_HPCONTROL0_L_MLB. */
#define BS_CSU_HPCONTROL0_L_MLB (1U)       /*!< Bit field size in bits for CSU_HPCONTROL0_L_MLB. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_MLB field. */
#define BR_CSU_HPCONTROL0_L_MLB(x) (HW_CSU_HPCONTROL0(x).B.L_MLB)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_MLB. */
#define BF_CSU_HPCONTROL0_L_MLB(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_MLB) & BM_CSU_HPCONTROL0_L_MLB)

/*! @brief Set the L_MLB field to a new value. */
#define BW_CSU_HPCONTROL0_L_MLB(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_MLB) | BF_CSU_HPCONTROL0_L_MLB(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_CAAM[14] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of CAAM.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_CAAM (14U)   /*!< Bit position for CSU_HPCONTROL0_HPC_CAAM. */
#define BM_CSU_HPCONTROL0_HPC_CAAM (0x00004000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_CAAM. */
#define BS_CSU_HPCONTROL0_HPC_CAAM (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_CAAM. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_CAAM field. */
#define BR_CSU_HPCONTROL0_HPC_CAAM(x) (HW_CSU_HPCONTROL0(x).B.HPC_CAAM)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_CAAM. */
#define BF_CSU_HPCONTROL0_HPC_CAAM(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_CAAM) & BM_CSU_HPCONTROL0_HPC_CAAM)

/*! @brief Set the HPC_CAAM field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_CAAM(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_CAAM) | BF_CSU_HPCONTROL0_HPC_CAAM(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_CAAM[15] (RW)
 *
 * Lock bit set by TZ software for HPC_CAAM.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_CAAM (15U)     /*!< Bit position for CSU_HPCONTROL0_L_CAAM. */
#define BM_CSU_HPCONTROL0_L_CAAM (0x00008000U) /*!< Bit mask for CSU_HPCONTROL0_L_CAAM. */
#define BS_CSU_HPCONTROL0_L_CAAM (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_CAAM. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_CAAM field. */
#define BR_CSU_HPCONTROL0_L_CAAM(x) (HW_CSU_HPCONTROL0(x).B.L_CAAM)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_CAAM. */
#define BF_CSU_HPCONTROL0_L_CAAM(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_CAAM) & BM_CSU_HPCONTROL0_L_CAAM)

/*! @brief Set the L_CAAM field to a new value. */
#define BW_CSU_HPCONTROL0_L_CAAM(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_CAAM) | BF_CSU_HPCONTROL0_L_CAAM(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_RAWNAND[16] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of RawNAND.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_RAWNAND (16U) /*!< Bit position for CSU_HPCONTROL0_HPC_RAWNAND. */
#define BM_CSU_HPCONTROL0_HPC_RAWNAND (0x00010000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_RAWNAND. */
#define BS_CSU_HPCONTROL0_HPC_RAWNAND (1U) /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_RAWNAND. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_RAWNAND field. */
#define BR_CSU_HPCONTROL0_HPC_RAWNAND(x) (HW_CSU_HPCONTROL0(x).B.HPC_RAWNAND)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_RAWNAND. */
#define BF_CSU_HPCONTROL0_HPC_RAWNAND(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_RAWNAND) & BM_CSU_HPCONTROL0_HPC_RAWNAND)

/*! @brief Set the HPC_RAWNAND field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_RAWNAND(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_RAWNAND) | BF_CSU_HPCONTROL0_HPC_RAWNAND(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_RAWNAND[17] (RW)
 *
 * Lock bit set by TZ software for HPC_RAWNAND.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_RAWNAND (17U)  /*!< Bit position for CSU_HPCONTROL0_L_RAWNAND. */
#define BM_CSU_HPCONTROL0_L_RAWNAND (0x00020000U) /*!< Bit mask for CSU_HPCONTROL0_L_RAWNAND. */
#define BS_CSU_HPCONTROL0_L_RAWNAND (1U)   /*!< Bit field size in bits for CSU_HPCONTROL0_L_RAWNAND. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_RAWNAND field. */
#define BR_CSU_HPCONTROL0_L_RAWNAND(x) (HW_CSU_HPCONTROL0(x).B.L_RAWNAND)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_RAWNAND. */
#define BF_CSU_HPCONTROL0_L_RAWNAND(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_RAWNAND) & BM_CSU_HPCONTROL0_L_RAWNAND)

/*! @brief Set the L_RAWNAND field to a new value. */
#define BW_CSU_HPCONTROL0_L_RAWNAND(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_RAWNAND) | BF_CSU_HPCONTROL0_L_RAWNAND(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_APBHDMA[18] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of apbhdma.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_APBHDMA (18U) /*!< Bit position for CSU_HPCONTROL0_HPC_APBHDMA. */
#define BM_CSU_HPCONTROL0_HPC_APBHDMA (0x00040000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_APBHDMA. */
#define BS_CSU_HPCONTROL0_HPC_APBHDMA (1U) /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_APBHDMA. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_APBHDMA field. */
#define BR_CSU_HPCONTROL0_HPC_APBHDMA(x) (HW_CSU_HPCONTROL0(x).B.HPC_APBHDMA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_APBHDMA. */
#define BF_CSU_HPCONTROL0_HPC_APBHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_APBHDMA) & BM_CSU_HPCONTROL0_HPC_APBHDMA)

/*! @brief Set the HPC_APBHDMA field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_APBHDMA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_APBHDMA) | BF_CSU_HPCONTROL0_HPC_APBHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_ABPHDMA[19] (RW)
 *
 * Lock bit set by TZ software for HPC_APBHDMA.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_ABPHDMA (19U)  /*!< Bit position for CSU_HPCONTROL0_L_ABPHDMA. */
#define BM_CSU_HPCONTROL0_L_ABPHDMA (0x00080000U) /*!< Bit mask for CSU_HPCONTROL0_L_ABPHDMA. */
#define BS_CSU_HPCONTROL0_L_ABPHDMA (1U)   /*!< Bit field size in bits for CSU_HPCONTROL0_L_ABPHDMA. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_ABPHDMA field. */
#define BR_CSU_HPCONTROL0_L_ABPHDMA(x) (HW_CSU_HPCONTROL0(x).B.L_ABPHDMA)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_ABPHDMA. */
#define BF_CSU_HPCONTROL0_L_ABPHDMA(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_ABPHDMA) & BM_CSU_HPCONTROL0_L_ABPHDMA)

/*! @brief Set the L_ABPHDMA field to a new value. */
#define BW_CSU_HPCONTROL0_L_ABPHDMA(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_ABPHDMA) | BF_CSU_HPCONTROL0_L_ABPHDMA(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_ENET[20] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of ENET.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_ENET (20U)   /*!< Bit position for CSU_HPCONTROL0_HPC_ENET. */
#define BM_CSU_HPCONTROL0_HPC_ENET (0x00100000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_ENET. */
#define BS_CSU_HPCONTROL0_HPC_ENET (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_ENET. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_ENET field. */
#define BR_CSU_HPCONTROL0_HPC_ENET(x) (HW_CSU_HPCONTROL0(x).B.HPC_ENET)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_ENET. */
#define BF_CSU_HPCONTROL0_HPC_ENET(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_ENET) & BM_CSU_HPCONTROL0_HPC_ENET)

/*! @brief Set the HPC_ENET field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_ENET(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_ENET) | BF_CSU_HPCONTROL0_HPC_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_ENET[21] (RW)
 *
 * Lock bit set by TZ software for HPC_ENET.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_ENET (21U)     /*!< Bit position for CSU_HPCONTROL0_L_ENET. */
#define BM_CSU_HPCONTROL0_L_ENET (0x00200000U) /*!< Bit mask for CSU_HPCONTROL0_L_ENET. */
#define BS_CSU_HPCONTROL0_L_ENET (1U)      /*!< Bit field size in bits for CSU_HPCONTROL0_L_ENET. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_ENET field. */
#define BR_CSU_HPCONTROL0_L_ENET(x) (HW_CSU_HPCONTROL0(x).B.L_ENET)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_ENET. */
#define BF_CSU_HPCONTROL0_L_ENET(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_ENET) & BM_CSU_HPCONTROL0_L_ENET)

/*! @brief Set the L_ENET field to a new value. */
#define BW_CSU_HPCONTROL0_L_ENET(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_ENET) | BF_CSU_HPCONTROL0_L_ENET(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_DAP[22] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of DAP.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_DAP (22U)    /*!< Bit position for CSU_HPCONTROL0_HPC_DAP. */
#define BM_CSU_HPCONTROL0_HPC_DAP (0x00400000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_DAP. */
#define BS_CSU_HPCONTROL0_HPC_DAP (1U)     /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_DAP. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_DAP field. */
#define BR_CSU_HPCONTROL0_HPC_DAP(x) (HW_CSU_HPCONTROL0(x).B.HPC_DAP)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_DAP. */
#define BF_CSU_HPCONTROL0_HPC_DAP(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_DAP) & BM_CSU_HPCONTROL0_HPC_DAP)

/*! @brief Set the HPC_DAP field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_DAP(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_DAP) | BF_CSU_HPCONTROL0_HPC_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_DAP[23] (RW)
 *
 * Lock bit set by TZ software for HPC_DAP.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_DAP (23U)      /*!< Bit position for CSU_HPCONTROL0_L_DAP. */
#define BM_CSU_HPCONTROL0_L_DAP (0x00800000U) /*!< Bit mask for CSU_HPCONTROL0_L_DAP. */
#define BS_CSU_HPCONTROL0_L_DAP (1U)       /*!< Bit field size in bits for CSU_HPCONTROL0_L_DAP. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_DAP field. */
#define BR_CSU_HPCONTROL0_L_DAP(x) (HW_CSU_HPCONTROL0(x).B.L_DAP)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_DAP. */
#define BF_CSU_HPCONTROL0_L_DAP(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_DAP) & BM_CSU_HPCONTROL0_L_DAP)

/*! @brief Set the L_DAP field to a new value. */
#define BW_CSU_HPCONTROL0_L_DAP(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_DAP) | BF_CSU_HPCONTROL0_L_DAP(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_USDHC1[24] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of USDHC1.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_USDHC1 (24U) /*!< Bit position for CSU_HPCONTROL0_HPC_USDHC1. */
#define BM_CSU_HPCONTROL0_HPC_USDHC1 (0x01000000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_USDHC1. */
#define BS_CSU_HPCONTROL0_HPC_USDHC1 (1U)  /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_USDHC1. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_USDHC1 field. */
#define BR_CSU_HPCONTROL0_HPC_USDHC1(x) (HW_CSU_HPCONTROL0(x).B.HPC_USDHC1)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_USDHC1. */
#define BF_CSU_HPCONTROL0_HPC_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_USDHC1) & BM_CSU_HPCONTROL0_HPC_USDHC1)

/*! @brief Set the HPC_USDHC1 field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_USDHC1(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_USDHC1) | BF_CSU_HPCONTROL0_HPC_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_USDHC1[25] (RW)
 *
 * Lock bit set by TZ software for HPC_USDHC1.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_USDHC1 (25U)   /*!< Bit position for CSU_HPCONTROL0_L_USDHC1. */
#define BM_CSU_HPCONTROL0_L_USDHC1 (0x02000000U) /*!< Bit mask for CSU_HPCONTROL0_L_USDHC1. */
#define BS_CSU_HPCONTROL0_L_USDHC1 (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_L_USDHC1. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_USDHC1 field. */
#define BR_CSU_HPCONTROL0_L_USDHC1(x) (HW_CSU_HPCONTROL0(x).B.L_USDHC1)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_USDHC1. */
#define BF_CSU_HPCONTROL0_L_USDHC1(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_USDHC1) & BM_CSU_HPCONTROL0_L_USDHC1)

/*! @brief Set the L_USDHC1 field to a new value. */
#define BW_CSU_HPCONTROL0_L_USDHC1(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_USDHC1) | BF_CSU_HPCONTROL0_L_USDHC1(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_USDHC2[26] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of USDHC2.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_USDHC2 (26U) /*!< Bit position for CSU_HPCONTROL0_HPC_USDHC2. */
#define BM_CSU_HPCONTROL0_HPC_USDHC2 (0x04000000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_USDHC2. */
#define BS_CSU_HPCONTROL0_HPC_USDHC2 (1U)  /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_USDHC2. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_USDHC2 field. */
#define BR_CSU_HPCONTROL0_HPC_USDHC2(x) (HW_CSU_HPCONTROL0(x).B.HPC_USDHC2)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_USDHC2. */
#define BF_CSU_HPCONTROL0_HPC_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_USDHC2) & BM_CSU_HPCONTROL0_HPC_USDHC2)

/*! @brief Set the HPC_USDHC2 field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_USDHC2(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_USDHC2) | BF_CSU_HPCONTROL0_HPC_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_USDHC2[27] (RW)
 *
 * Lock bit set by TZ software for HPC_USDHC2.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_USDHC2 (27U)   /*!< Bit position for CSU_HPCONTROL0_L_USDHC2. */
#define BM_CSU_HPCONTROL0_L_USDHC2 (0x08000000U) /*!< Bit mask for CSU_HPCONTROL0_L_USDHC2. */
#define BS_CSU_HPCONTROL0_L_USDHC2 (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_L_USDHC2. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_USDHC2 field. */
#define BR_CSU_HPCONTROL0_L_USDHC2(x) (HW_CSU_HPCONTROL0(x).B.L_USDHC2)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_USDHC2. */
#define BF_CSU_HPCONTROL0_L_USDHC2(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_USDHC2) & BM_CSU_HPCONTROL0_L_USDHC2)

/*! @brief Set the L_USDHC2 field to a new value. */
#define BW_CSU_HPCONTROL0_L_USDHC2(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_USDHC2) | BF_CSU_HPCONTROL0_L_USDHC2(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_USDHC3[28] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of USDHC3.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_USDHC3 (28U) /*!< Bit position for CSU_HPCONTROL0_HPC_USDHC3. */
#define BM_CSU_HPCONTROL0_HPC_USDHC3 (0x10000000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_USDHC3. */
#define BS_CSU_HPCONTROL0_HPC_USDHC3 (1U)  /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_USDHC3. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_USDHC3 field. */
#define BR_CSU_HPCONTROL0_HPC_USDHC3(x) (HW_CSU_HPCONTROL0(x).B.HPC_USDHC3)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_USDHC3. */
#define BF_CSU_HPCONTROL0_HPC_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_USDHC3) & BM_CSU_HPCONTROL0_HPC_USDHC3)

/*! @brief Set the HPC_USDHC3 field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_USDHC3(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_USDHC3) | BF_CSU_HPCONTROL0_HPC_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_USDHC3[29] (RW)
 *
 * Lock bit set by TZ software for HPC_USDHC3.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_USDHC3 (29U)   /*!< Bit position for CSU_HPCONTROL0_L_USDHC3. */
#define BM_CSU_HPCONTROL0_L_USDHC3 (0x20000000U) /*!< Bit mask for CSU_HPCONTROL0_L_USDHC3. */
#define BS_CSU_HPCONTROL0_L_USDHC3 (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_L_USDHC3. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_USDHC3 field. */
#define BR_CSU_HPCONTROL0_L_USDHC3(x) (HW_CSU_HPCONTROL0(x).B.L_USDHC3)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_USDHC3. */
#define BF_CSU_HPCONTROL0_L_USDHC3(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_USDHC3) & BM_CSU_HPCONTROL0_L_USDHC3)

/*! @brief Set the L_USDHC3 field to a new value. */
#define BW_CSU_HPCONTROL0_L_USDHC3(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_USDHC3) | BF_CSU_HPCONTROL0_L_USDHC3(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field HPC_USDHC4[30] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of USDHC4.
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL0_HPC_USDHC4 (30U) /*!< Bit position for CSU_HPCONTROL0_HPC_USDHC4. */
#define BM_CSU_HPCONTROL0_HPC_USDHC4 (0x40000000U) /*!< Bit mask for CSU_HPCONTROL0_HPC_USDHC4. */
#define BS_CSU_HPCONTROL0_HPC_USDHC4 (1U)  /*!< Bit field size in bits for CSU_HPCONTROL0_HPC_USDHC4. */

/*! @brief Read current value of the CSU_HPCONTROL0_HPC_USDHC4 field. */
#define BR_CSU_HPCONTROL0_HPC_USDHC4(x) (HW_CSU_HPCONTROL0(x).B.HPC_USDHC4)

/*! @brief Format value for bitfield CSU_HPCONTROL0_HPC_USDHC4. */
#define BF_CSU_HPCONTROL0_HPC_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_HPC_USDHC4) & BM_CSU_HPCONTROL0_HPC_USDHC4)

/*! @brief Set the HPC_USDHC4 field to a new value. */
#define BW_CSU_HPCONTROL0_HPC_USDHC4(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_HPC_USDHC4) | BF_CSU_HPCONTROL0_HPC_USDHC4(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL0, field L_USDHC4[31] (RW)
 *
 * Lock bit set by TZ software for HPC_USDHC4.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL0_L_USDHC4 (31U)   /*!< Bit position for CSU_HPCONTROL0_L_USDHC4. */
#define BM_CSU_HPCONTROL0_L_USDHC4 (0x80000000U) /*!< Bit mask for CSU_HPCONTROL0_L_USDHC4. */
#define BS_CSU_HPCONTROL0_L_USDHC4 (1U)    /*!< Bit field size in bits for CSU_HPCONTROL0_L_USDHC4. */

/*! @brief Read current value of the CSU_HPCONTROL0_L_USDHC4 field. */
#define BR_CSU_HPCONTROL0_L_USDHC4(x) (HW_CSU_HPCONTROL0(x).B.L_USDHC4)

/*! @brief Format value for bitfield CSU_HPCONTROL0_L_USDHC4. */
#define BF_CSU_HPCONTROL0_L_USDHC4(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL0_L_USDHC4) & BM_CSU_HPCONTROL0_L_USDHC4)

/*! @brief Set the L_USDHC4 field to a new value. */
#define BW_CSU_HPCONTROL0_L_USDHC4(x, v) (HW_CSU_HPCONTROL0_WR(x, (HW_CSU_HPCONTROL0_RD(x) & ~BM_CSU_HPCONTROL0_L_USDHC4) | BF_CSU_HPCONTROL0_L_USDHC4(v)))
/*@}*/

/*******************************************************************************
 * HW_CSU_HPCONTROL1 - HPCONTROL1 register
 ******************************************************************************/

/*!
 * @brief HW_CSU_HPCONTROL1 - HPCONTROL1 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SCU_HPCONTROL1 register is expansion of SCU_HPCONTROL0 register. See
 * SCU_HPCONTROL0 register definition.
 */
typedef union _hw_csu_hpcontrol1
{
    uint32_t U;
    struct _hw_csu_hpcontrol1_bitfields
    {
        uint32_t HPC_HDMI_HSI : 1;     /*!< [0]  */
        uint32_t L_HDMI_HSI : 1;       /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_csu_hpcontrol1_t;

/*!
 * @name Constants and macros for entire CSU_HPCONTROL1 register
 */
/*@{*/
#define HW_CSU_HPCONTROL1_ADDR(x) ((uintptr_t)(x) + 0x35CU)

#define HW_CSU_HPCONTROL1(x)     (*(__IO hw_csu_hpcontrol1_t *) HW_CSU_HPCONTROL1_ADDR(x))
#define HW_CSU_HPCONTROL1_RD(x)  (HW_CSU_HPCONTROL1(x).U)
#define HW_CSU_HPCONTROL1_WR(x, v) (HW_CSU_HPCONTROL1(x).U = (v))
#define HW_CSU_HPCONTROL1_SET(x, v) (HW_CSU_HPCONTROL1_WR(x, HW_CSU_HPCONTROL1_RD(x) |  (v)))
#define HW_CSU_HPCONTROL1_CLR(x, v) (HW_CSU_HPCONTROL1_WR(x, HW_CSU_HPCONTROL1_RD(x) & ~(v)))
#define HW_CSU_HPCONTROL1_TOG(x, v) (HW_CSU_HPCONTROL1_WR(x, HW_CSU_HPCONTROL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual CSU_HPCONTROL1 bitfields
 */

/*!
 * @name Register CSU_HPCONTROL1, field HPC_HDMI_HSI[0] (RW)
 *
 * Determines if the Register value of the HP field corresponding will be pass
 * as the hprot[1] of HDMI Tx and HSI .
 *
 * Values:
 * - 0 - Input signal hprot1 value is routed to csu_hprot1 output for the
 *     corresponding master
 * - 1 - HP register bit is routed to csu_hprot1 output for the corresponding
 *     master
 */
/*@{*/
#define BP_CSU_HPCONTROL1_HPC_HDMI_HSI (0U) /*!< Bit position for CSU_HPCONTROL1_HPC_HDMI_HSI. */
#define BM_CSU_HPCONTROL1_HPC_HDMI_HSI (0x00000001U) /*!< Bit mask for CSU_HPCONTROL1_HPC_HDMI_HSI. */
#define BS_CSU_HPCONTROL1_HPC_HDMI_HSI (1U) /*!< Bit field size in bits for CSU_HPCONTROL1_HPC_HDMI_HSI. */

/*! @brief Read current value of the CSU_HPCONTROL1_HPC_HDMI_HSI field. */
#define BR_CSU_HPCONTROL1_HPC_HDMI_HSI(x) (HW_CSU_HPCONTROL1(x).B.HPC_HDMI_HSI)

/*! @brief Format value for bitfield CSU_HPCONTROL1_HPC_HDMI_HSI. */
#define BF_CSU_HPCONTROL1_HPC_HDMI_HSI(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL1_HPC_HDMI_HSI) & BM_CSU_HPCONTROL1_HPC_HDMI_HSI)

/*! @brief Set the HPC_HDMI_HSI field to a new value. */
#define BW_CSU_HPCONTROL1_HPC_HDMI_HSI(x, v) (HW_CSU_HPCONTROL1_WR(x, (HW_CSU_HPCONTROL1_RD(x) & ~BM_CSU_HPCONTROL1_HPC_HDMI_HSI) | BF_CSU_HPCONTROL1_HPC_HDMI_HSI(v)))
/*@}*/

/*!
 * @name Register CSU_HPCONTROL1, field L_HDMI_HSI[1] (RW)
 *
 * Lock bit set by TZ software for HPC_HDMI_HSI.
 *
 * Values:
 * - 0 - No lock -- adjacent (next lower) bit can be written by software
 * - 1 - Lock -- adjacent (next lower) bit cannot be written by software
 */
/*@{*/
#define BP_CSU_HPCONTROL1_L_HDMI_HSI (1U)  /*!< Bit position for CSU_HPCONTROL1_L_HDMI_HSI. */
#define BM_CSU_HPCONTROL1_L_HDMI_HSI (0x00000002U) /*!< Bit mask for CSU_HPCONTROL1_L_HDMI_HSI. */
#define BS_CSU_HPCONTROL1_L_HDMI_HSI (1U)  /*!< Bit field size in bits for CSU_HPCONTROL1_L_HDMI_HSI. */

/*! @brief Read current value of the CSU_HPCONTROL1_L_HDMI_HSI field. */
#define BR_CSU_HPCONTROL1_L_HDMI_HSI(x) (HW_CSU_HPCONTROL1(x).B.L_HDMI_HSI)

/*! @brief Format value for bitfield CSU_HPCONTROL1_L_HDMI_HSI. */
#define BF_CSU_HPCONTROL1_L_HDMI_HSI(v) ((uint32_t)((uint32_t)(v) << BP_CSU_HPCONTROL1_L_HDMI_HSI) & BM_CSU_HPCONTROL1_L_HDMI_HSI)

/*! @brief Set the L_HDMI_HSI field to a new value. */
#define BW_CSU_HPCONTROL1_L_HDMI_HSI(x, v) (HW_CSU_HPCONTROL1_WR(x, (HW_CSU_HPCONTROL1_RD(x) & ~BM_CSU_HPCONTROL1_L_HDMI_HSI) | BF_CSU_HPCONTROL1_L_HDMI_HSI(v)))
/*@}*/

/*******************************************************************************
 * hw_csu_t - module struct
 ******************************************************************************/
/*!
 * @brief All CSU module registers.
 */
#pragma pack(1)
typedef struct _hw_csu
{
    __IO hw_csu_csln_t CSLn[40];           /*!< [0x0] Config security level register */
    uint8_t _reserved0[352];
    __IO hw_csu_hp0_t HP0;                 /*!< [0x200] HP0 register */
    __IO hw_csu_hp1_t HP1;                 /*!< [0x204] HP1 register */
    uint8_t _reserved1[16];
    __IO hw_csu_sa_t SA;                   /*!< [0x218] Secure access register */
    uint8_t _reserved2[316];
    __IO hw_csu_hpcontrol0_t HPCONTROL0;   /*!< [0x358] HPCONTROL0 register */
    __IO hw_csu_hpcontrol1_t HPCONTROL1;   /*!< [0x35C] HPCONTROL1 register */
} hw_csu_t;
#pragma pack()

/*! @brief Macro to access all CSU registers. */
/*! @param x CSU module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_CSU_REGS(CSU_BASE)</code>. */
#define HW_CSU_REGS(x) (*(hw_csu_t *)(x))

/*
 * iMX6DP DCIC
 *
 * DCIC
 *
 * Registers defined in this header file:
 * - HW_DCIC_DCICC - DCIC Control Register
 * - HW_DCIC_DCICIC - DCIC Interrupt Control Register
 * - HW_DCIC_DCICS - DCIC Status Register
 * - HW_DCIC_DCICRC - DCIC ROI Config Register m
 * - HW_DCIC_DCICRS - DCIC ROI Size Register m
 * - HW_DCIC_DCICRRS - DCIC ROI Reference Signature Register m
 * - HW_DCIC_DCICRCS - DCIC ROI Calculated Signature m
 *
 * - hw_dcic_t - Struct containing all module registers.
 */

#define HW_DCIC_INSTANCE_COUNT (2U) /*!< Number of instances of the DCIC module. */
#define HW_DCIC1 (0U) /*!< Instance number for DCIC1. */
#define HW_DCIC2 (1U) /*!< Instance number for DCIC2. */
#define DCIC1_BASE            (0x20E4000U) /*!< Base address for DCIC1. */
#define DCIC2_BASE            (0x20E8000U) /*!< Base address for DCIC2. */
/*! Array initializer of DCIC base addresses. */
#define DCIC_BASE_ADDRS       { DCIC1_BASE, DCIC2_BASE }

/*******************************************************************************
 * HW_DCIC_DCICC - DCIC Control Register
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICC - DCIC Control Register (RW)
 *
 * Reset value: 0x00000070U
 */
typedef union _hw_dcic_dcicc
{
    uint32_t U;
    struct _hw_dcic_dcicc_bitfields
    {
        uint32_t IC_EN : 1;            /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t DE_POL : 1;           /*!< [4]  */
        uint32_t HSYNC_POL : 1;        /*!< [5]  */
        uint32_t VSYNC_POL : 1;        /*!< [6]  */
        uint32_t CLK_POL : 1;          /*!< [7]  */
        uint32_t RESERVED1 : 24;       /*!< [31:8]  */
    } B;
} hw_dcic_dcicc_t;

/*!
 * @name Constants and macros for entire DCIC_DCICC register
 */
/*@{*/
#define HW_DCIC_DCICC_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_DCIC_DCICC(x)         (*(__IO hw_dcic_dcicc_t *) HW_DCIC_DCICC_ADDR(x))
#define HW_DCIC_DCICC_RD(x)      (HW_DCIC_DCICC(x).U)
#define HW_DCIC_DCICC_WR(x, v)   (HW_DCIC_DCICC(x).U = (v))
#define HW_DCIC_DCICC_SET(x, v)  (HW_DCIC_DCICC_WR(x, HW_DCIC_DCICC_RD(x) |  (v)))
#define HW_DCIC_DCICC_CLR(x, v)  (HW_DCIC_DCICC_WR(x, HW_DCIC_DCICC_RD(x) & ~(v)))
#define HW_DCIC_DCICC_TOG(x, v)  (HW_DCIC_DCICC_WR(x, HW_DCIC_DCICC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICC bitfields
 */

/*!
 * @name Register DCIC_DCICC, field IC_EN[0] (RW)
 *
 * Integrity Check enable. Main enable switch.
 *
 * Values:
 * - 0 - Disabled
 * - 1 - Enabled
 */
/*@{*/
#define BP_DCIC_DCICC_IC_EN  (0U)          /*!< Bit position for DCIC_DCICC_IC_EN. */
#define BM_DCIC_DCICC_IC_EN  (0x00000001U) /*!< Bit mask for DCIC_DCICC_IC_EN. */
#define BS_DCIC_DCICC_IC_EN  (1U)          /*!< Bit field size in bits for DCIC_DCICC_IC_EN. */

/*! @brief Read current value of the DCIC_DCICC_IC_EN field. */
#define BR_DCIC_DCICC_IC_EN(x) (HW_DCIC_DCICC(x).B.IC_EN)

/*! @brief Format value for bitfield DCIC_DCICC_IC_EN. */
#define BF_DCIC_DCICC_IC_EN(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICC_IC_EN) & BM_DCIC_DCICC_IC_EN)

/*! @brief Set the IC_EN field to a new value. */
#define BW_DCIC_DCICC_IC_EN(x, v) (HW_DCIC_DCICC_WR(x, (HW_DCIC_DCICC_RD(x) & ~BM_DCIC_DCICC_IC_EN) | BF_DCIC_DCICC_IC_EN(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICC, field DE_POL[4] (RW)
 *
 * DATA_EN_IN signal polarity.
 *
 * Values:
 * - 0 - Active High.
 * - 1 - Active Low (default).
 */
/*@{*/
#define BP_DCIC_DCICC_DE_POL (4U)          /*!< Bit position for DCIC_DCICC_DE_POL. */
#define BM_DCIC_DCICC_DE_POL (0x00000010U) /*!< Bit mask for DCIC_DCICC_DE_POL. */
#define BS_DCIC_DCICC_DE_POL (1U)          /*!< Bit field size in bits for DCIC_DCICC_DE_POL. */

/*! @brief Read current value of the DCIC_DCICC_DE_POL field. */
#define BR_DCIC_DCICC_DE_POL(x) (HW_DCIC_DCICC(x).B.DE_POL)

/*! @brief Format value for bitfield DCIC_DCICC_DE_POL. */
#define BF_DCIC_DCICC_DE_POL(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICC_DE_POL) & BM_DCIC_DCICC_DE_POL)

/*! @brief Set the DE_POL field to a new value. */
#define BW_DCIC_DCICC_DE_POL(x, v) (HW_DCIC_DCICC_WR(x, (HW_DCIC_DCICC_RD(x) & ~BM_DCIC_DCICC_DE_POL) | BF_DCIC_DCICC_DE_POL(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICC, field HSYNC_POL[5] (RW)
 *
 * HSYNC_IN signal polarity.
 *
 * Values:
 * - 0 - Active High.
 * - 1 - Active Low (default).
 */
/*@{*/
#define BP_DCIC_DCICC_HSYNC_POL (5U)       /*!< Bit position for DCIC_DCICC_HSYNC_POL. */
#define BM_DCIC_DCICC_HSYNC_POL (0x00000020U) /*!< Bit mask for DCIC_DCICC_HSYNC_POL. */
#define BS_DCIC_DCICC_HSYNC_POL (1U)       /*!< Bit field size in bits for DCIC_DCICC_HSYNC_POL. */

/*! @brief Read current value of the DCIC_DCICC_HSYNC_POL field. */
#define BR_DCIC_DCICC_HSYNC_POL(x) (HW_DCIC_DCICC(x).B.HSYNC_POL)

/*! @brief Format value for bitfield DCIC_DCICC_HSYNC_POL. */
#define BF_DCIC_DCICC_HSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICC_HSYNC_POL) & BM_DCIC_DCICC_HSYNC_POL)

/*! @brief Set the HSYNC_POL field to a new value. */
#define BW_DCIC_DCICC_HSYNC_POL(x, v) (HW_DCIC_DCICC_WR(x, (HW_DCIC_DCICC_RD(x) & ~BM_DCIC_DCICC_HSYNC_POL) | BF_DCIC_DCICC_HSYNC_POL(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICC, field VSYNC_POL[6] (RW)
 *
 * VSYNC_IN signal polarity.
 *
 * Values:
 * - 0 - Active High.
 * - 1 - Active Low (default).
 */
/*@{*/
#define BP_DCIC_DCICC_VSYNC_POL (6U)       /*!< Bit position for DCIC_DCICC_VSYNC_POL. */
#define BM_DCIC_DCICC_VSYNC_POL (0x00000040U) /*!< Bit mask for DCIC_DCICC_VSYNC_POL. */
#define BS_DCIC_DCICC_VSYNC_POL (1U)       /*!< Bit field size in bits for DCIC_DCICC_VSYNC_POL. */

/*! @brief Read current value of the DCIC_DCICC_VSYNC_POL field. */
#define BR_DCIC_DCICC_VSYNC_POL(x) (HW_DCIC_DCICC(x).B.VSYNC_POL)

/*! @brief Format value for bitfield DCIC_DCICC_VSYNC_POL. */
#define BF_DCIC_DCICC_VSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICC_VSYNC_POL) & BM_DCIC_DCICC_VSYNC_POL)

/*! @brief Set the VSYNC_POL field to a new value. */
#define BW_DCIC_DCICC_VSYNC_POL(x, v) (HW_DCIC_DCICC_WR(x, (HW_DCIC_DCICC_RD(x) & ~BM_DCIC_DCICC_VSYNC_POL) | BF_DCIC_DCICC_VSYNC_POL(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICC, field CLK_POL[7] (RW)
 *
 * DISP_CLK signal polarity.
 *
 * Values:
 * - 0 - Not inverted (default).
 * - 1 - Inverted.
 */
/*@{*/
#define BP_DCIC_DCICC_CLK_POL (7U)         /*!< Bit position for DCIC_DCICC_CLK_POL. */
#define BM_DCIC_DCICC_CLK_POL (0x00000080U) /*!< Bit mask for DCIC_DCICC_CLK_POL. */
#define BS_DCIC_DCICC_CLK_POL (1U)         /*!< Bit field size in bits for DCIC_DCICC_CLK_POL. */

/*! @brief Read current value of the DCIC_DCICC_CLK_POL field. */
#define BR_DCIC_DCICC_CLK_POL(x) (HW_DCIC_DCICC(x).B.CLK_POL)

/*! @brief Format value for bitfield DCIC_DCICC_CLK_POL. */
#define BF_DCIC_DCICC_CLK_POL(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICC_CLK_POL) & BM_DCIC_DCICC_CLK_POL)

/*! @brief Set the CLK_POL field to a new value. */
#define BW_DCIC_DCICC_CLK_POL(x, v) (HW_DCIC_DCICC_WR(x, (HW_DCIC_DCICC_RD(x) & ~BM_DCIC_DCICC_CLK_POL) | BF_DCIC_DCICC_CLK_POL(v)))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICIC - DCIC Interrupt Control Register
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICIC - DCIC Interrupt Control Register (RW)
 *
 * Reset value: 0x00000003U
 */
typedef union _hw_dcic_dcicic
{
    uint32_t U;
    struct _hw_dcic_dcicic_bitfields
    {
        uint32_t EI_MASK : 1;          /*!< [0]  */
        uint32_t FI_MASK : 1;          /*!< [1]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t FREEZE_MASK : 1;      /*!< [3]  */
        uint32_t RESERVED1 : 12;       /*!< [15:4]  */
        uint32_t EXT_SIG_EN : 1;       /*!< [16]  */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_dcic_dcicic_t;

/*!
 * @name Constants and macros for entire DCIC_DCICIC register
 */
/*@{*/
#define HW_DCIC_DCICIC_ADDR(x)   ((uintptr_t)(x) + 0x4U)

#define HW_DCIC_DCICIC(x)        (*(__IO hw_dcic_dcicic_t *) HW_DCIC_DCICIC_ADDR(x))
#define HW_DCIC_DCICIC_RD(x)     (HW_DCIC_DCICIC(x).U)
#define HW_DCIC_DCICIC_WR(x, v)  (HW_DCIC_DCICIC(x).U = (v))
#define HW_DCIC_DCICIC_SET(x, v) (HW_DCIC_DCICIC_WR(x, HW_DCIC_DCICIC_RD(x) |  (v)))
#define HW_DCIC_DCICIC_CLR(x, v) (HW_DCIC_DCICIC_WR(x, HW_DCIC_DCICIC_RD(x) & ~(v)))
#define HW_DCIC_DCICIC_TOG(x, v) (HW_DCIC_DCICIC_WR(x, HW_DCIC_DCICIC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICIC bitfields
 */

/*!
 * @name Register DCIC_DCICIC, field EI_MASK[0] (RW)
 *
 * Error Interrupt mask. Can be changed only while FREEZE_MASK = 0.
 *
 * Values:
 * - 0 - Mask disabled - Interrupt assertion enabled
 * - 1 - Mask enabled - Interrupt assertion disabled (default)
 */
/*@{*/
#define BP_DCIC_DCICIC_EI_MASK (0U)        /*!< Bit position for DCIC_DCICIC_EI_MASK. */
#define BM_DCIC_DCICIC_EI_MASK (0x00000001U) /*!< Bit mask for DCIC_DCICIC_EI_MASK. */
#define BS_DCIC_DCICIC_EI_MASK (1U)        /*!< Bit field size in bits for DCIC_DCICIC_EI_MASK. */

/*! @brief Read current value of the DCIC_DCICIC_EI_MASK field. */
#define BR_DCIC_DCICIC_EI_MASK(x) (HW_DCIC_DCICIC(x).B.EI_MASK)

/*! @brief Format value for bitfield DCIC_DCICIC_EI_MASK. */
#define BF_DCIC_DCICIC_EI_MASK(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICIC_EI_MASK) & BM_DCIC_DCICIC_EI_MASK)

/*! @brief Set the EI_MASK field to a new value. */
#define BW_DCIC_DCICIC_EI_MASK(x, v) (HW_DCIC_DCICIC_WR(x, (HW_DCIC_DCICIC_RD(x) & ~BM_DCIC_DCICIC_EI_MASK) | BF_DCIC_DCICIC_EI_MASK(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICIC, field FI_MASK[1] (RW)
 *
 * Functional Interrupt mask. Can be changed only while FREEZE_MASK = 0.
 *
 * Values:
 * - 0 - Mask disabled - Interrupt assertion enabled
 * - 1 - Mask enabled - Interrupt assertion disabled (default)
 */
/*@{*/
#define BP_DCIC_DCICIC_FI_MASK (1U)        /*!< Bit position for DCIC_DCICIC_FI_MASK. */
#define BM_DCIC_DCICIC_FI_MASK (0x00000002U) /*!< Bit mask for DCIC_DCICIC_FI_MASK. */
#define BS_DCIC_DCICIC_FI_MASK (1U)        /*!< Bit field size in bits for DCIC_DCICIC_FI_MASK. */

/*! @brief Read current value of the DCIC_DCICIC_FI_MASK field. */
#define BR_DCIC_DCICIC_FI_MASK(x) (HW_DCIC_DCICIC(x).B.FI_MASK)

/*! @brief Format value for bitfield DCIC_DCICIC_FI_MASK. */
#define BF_DCIC_DCICIC_FI_MASK(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICIC_FI_MASK) & BM_DCIC_DCICIC_FI_MASK)

/*! @brief Set the FI_MASK field to a new value. */
#define BW_DCIC_DCICIC_FI_MASK(x, v) (HW_DCIC_DCICIC_WR(x, (HW_DCIC_DCICIC_RD(x) & ~BM_DCIC_DCICIC_FI_MASK) | BF_DCIC_DCICIC_FI_MASK(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICIC, field FREEZE_MASK[3] (RW)
 *
 * Disable change of interrupt masks. "Sticky" bit which can be set once and
 * cleared by reset only.
 *
 * Values:
 * - 0 - Masks change allowed (default)
 * - 1 - Masks are frozen
 */
/*@{*/
#define BP_DCIC_DCICIC_FREEZE_MASK (3U)    /*!< Bit position for DCIC_DCICIC_FREEZE_MASK. */
#define BM_DCIC_DCICIC_FREEZE_MASK (0x00000008U) /*!< Bit mask for DCIC_DCICIC_FREEZE_MASK. */
#define BS_DCIC_DCICIC_FREEZE_MASK (1U)    /*!< Bit field size in bits for DCIC_DCICIC_FREEZE_MASK. */

/*! @brief Read current value of the DCIC_DCICIC_FREEZE_MASK field. */
#define BR_DCIC_DCICIC_FREEZE_MASK(x) (HW_DCIC_DCICIC(x).B.FREEZE_MASK)

/*! @brief Format value for bitfield DCIC_DCICIC_FREEZE_MASK. */
#define BF_DCIC_DCICIC_FREEZE_MASK(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICIC_FREEZE_MASK) & BM_DCIC_DCICIC_FREEZE_MASK)

/*! @brief Set the FREEZE_MASK field to a new value. */
#define BW_DCIC_DCICIC_FREEZE_MASK(x, v) (HW_DCIC_DCICIC_WR(x, (HW_DCIC_DCICIC_RD(x) & ~BM_DCIC_DCICIC_FREEZE_MASK) | BF_DCIC_DCICIC_FREEZE_MASK(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICIC, field EXT_SIG_EN[16] (RW)
 *
 * External controller mismatch indication signal.
 *
 * Values:
 * - 0 - Disabled (default)
 * - 1 - Enabled
 */
/*@{*/
#define BP_DCIC_DCICIC_EXT_SIG_EN (16U)    /*!< Bit position for DCIC_DCICIC_EXT_SIG_EN. */
#define BM_DCIC_DCICIC_EXT_SIG_EN (0x00010000U) /*!< Bit mask for DCIC_DCICIC_EXT_SIG_EN. */
#define BS_DCIC_DCICIC_EXT_SIG_EN (1U)     /*!< Bit field size in bits for DCIC_DCICIC_EXT_SIG_EN. */

/*! @brief Read current value of the DCIC_DCICIC_EXT_SIG_EN field. */
#define BR_DCIC_DCICIC_EXT_SIG_EN(x) (HW_DCIC_DCICIC(x).B.EXT_SIG_EN)

/*! @brief Format value for bitfield DCIC_DCICIC_EXT_SIG_EN. */
#define BF_DCIC_DCICIC_EXT_SIG_EN(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICIC_EXT_SIG_EN) & BM_DCIC_DCICIC_EXT_SIG_EN)

/*! @brief Set the EXT_SIG_EN field to a new value. */
#define BW_DCIC_DCICIC_EXT_SIG_EN(x, v) (HW_DCIC_DCICIC_WR(x, (HW_DCIC_DCICIC_RD(x) & ~BM_DCIC_DCICIC_EXT_SIG_EN) | BF_DCIC_DCICIC_EXT_SIG_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICS - DCIC Status Register
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICS - DCIC Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dcic_dcics
{
    uint32_t U;
    struct _hw_dcic_dcics_bitfields
    {
        uint32_t ROI_MATCH_STAT : 16;  /*!< [15:0]  */
        uint32_t EI_STAT : 1;          /*!< [16]  */
        uint32_t FI_STAT : 1;          /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_dcic_dcics_t;

/*!
 * @name Constants and macros for entire DCIC_DCICS register
 */
/*@{*/
#define HW_DCIC_DCICS_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_DCIC_DCICS(x)         (*(__IO hw_dcic_dcics_t *) HW_DCIC_DCICS_ADDR(x))
#define HW_DCIC_DCICS_RD(x)      (HW_DCIC_DCICS(x).U)
#define HW_DCIC_DCICS_WR(x, v)   (HW_DCIC_DCICS(x).U = (v))
#define HW_DCIC_DCICS_SET(x, v)  (HW_DCIC_DCICS_WR(x, HW_DCIC_DCICS_RD(x) |  (v)))
#define HW_DCIC_DCICS_CLR(x, v)  (HW_DCIC_DCICS_WR(x, HW_DCIC_DCICS_RD(x) & ~(v)))
#define HW_DCIC_DCICS_TOG(x, v)  (HW_DCIC_DCICS_WR(x, HW_DCIC_DCICS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICS bitfields
 */

/*!
 * @name Register DCIC_DCICS, field ROI_MATCH_STAT[15:0] (W1C)
 *
 * Each set bit of this field indicates there was a mismatch at appropriate ROIs
 * signature during the last frame. Valid only for active ROIs. Write "1" to
 * clear.
 *
 * Values:
 * - 0 - ROI calculated CRC matches expected signature
 * - 1 - Mismatch at ROI calculated CRC
 */
/*@{*/
#define BP_DCIC_DCICS_ROI_MATCH_STAT (0U)  /*!< Bit position for DCIC_DCICS_ROI_MATCH_STAT. */
#define BM_DCIC_DCICS_ROI_MATCH_STAT (0x0000FFFFU) /*!< Bit mask for DCIC_DCICS_ROI_MATCH_STAT. */
#define BS_DCIC_DCICS_ROI_MATCH_STAT (16U) /*!< Bit field size in bits for DCIC_DCICS_ROI_MATCH_STAT. */

/*! @brief Read current value of the DCIC_DCICS_ROI_MATCH_STAT field. */
#define BR_DCIC_DCICS_ROI_MATCH_STAT(x) (HW_DCIC_DCICS(x).B.ROI_MATCH_STAT)

/*! @brief Format value for bitfield DCIC_DCICS_ROI_MATCH_STAT. */
#define BF_DCIC_DCICS_ROI_MATCH_STAT(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICS_ROI_MATCH_STAT) & BM_DCIC_DCICS_ROI_MATCH_STAT)

/*! @brief Set the ROI_MATCH_STAT field to a new value. */
#define BW_DCIC_DCICS_ROI_MATCH_STAT(x, v) (HW_DCIC_DCICS_WR(x, (HW_DCIC_DCICS_RD(x) & ~(BM_DCIC_DCICS_ROI_MATCH_STAT | BM_DCIC_DCICS_FI_STAT)) | BF_DCIC_DCICS_ROI_MATCH_STAT(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICS, field EI_STAT[16] (RO)
 *
 * Error Interrupt status. Result of "OR" operation on ROI_MATCH_STAT[15:0]
 * bits. Cleared when these bits are clear.
 *
 * Values:
 * - 0 - No pending Interrupt
 * - 1 - Pending Interrupt
 */
/*@{*/
#define BP_DCIC_DCICS_EI_STAT (16U)        /*!< Bit position for DCIC_DCICS_EI_STAT. */
#define BM_DCIC_DCICS_EI_STAT (0x00010000U) /*!< Bit mask for DCIC_DCICS_EI_STAT. */
#define BS_DCIC_DCICS_EI_STAT (1U)         /*!< Bit field size in bits for DCIC_DCICS_EI_STAT. */

/*! @brief Read current value of the DCIC_DCICS_EI_STAT field. */
#define BR_DCIC_DCICS_EI_STAT(x) (HW_DCIC_DCICS(x).B.EI_STAT)
/*@}*/

/*!
 * @name Register DCIC_DCICS, field FI_STAT[17] (W1C)
 *
 * Functional Interrupt status. Write "1" to clear.
 *
 * Values:
 * - 0 - No pending Interrupt
 * - 1 - Pending Interrupt
 */
/*@{*/
#define BP_DCIC_DCICS_FI_STAT (17U)        /*!< Bit position for DCIC_DCICS_FI_STAT. */
#define BM_DCIC_DCICS_FI_STAT (0x00020000U) /*!< Bit mask for DCIC_DCICS_FI_STAT. */
#define BS_DCIC_DCICS_FI_STAT (1U)         /*!< Bit field size in bits for DCIC_DCICS_FI_STAT. */

/*! @brief Read current value of the DCIC_DCICS_FI_STAT field. */
#define BR_DCIC_DCICS_FI_STAT(x) (HW_DCIC_DCICS(x).B.FI_STAT)

/*! @brief Format value for bitfield DCIC_DCICS_FI_STAT. */
#define BF_DCIC_DCICS_FI_STAT(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICS_FI_STAT) & BM_DCIC_DCICS_FI_STAT)

/*! @brief Set the FI_STAT field to a new value. */
#define BW_DCIC_DCICS_FI_STAT(x, v) (HW_DCIC_DCICS_WR(x, (HW_DCIC_DCICS_RD(x) & ~(BM_DCIC_DCICS_FI_STAT | BM_DCIC_DCICS_ROI_MATCH_STAT)) | BF_DCIC_DCICS_FI_STAT(v)))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICRC - DCIC ROI Config Register m
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICRC - DCIC ROI Config Register m (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dcic_dcicrc
{
    uint32_t U;
    struct _hw_dcic_dcicrc_bitfields
    {
        uint32_t START_OFFSET_X : 13;  /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t START_OFFSET_Y : 12;  /*!< [27:16]  */
        uint32_t RESERVED1 : 2;        /*!< [29:28]  */
        uint32_t ROI_FREEZE : 1;       /*!< [30]  */
        uint32_t ROI_EN : 1;           /*!< [31]  */
    } B;
} hw_dcic_dcicrc_t;

/*!
 * @name Constants and macros for entire DCIC_DCICRC register
 */
/*@{*/
#define HW_DCIC_DCICRC_ADDR(x)   ((uintptr_t)(x) + 0x10U)

#define HW_DCIC_DCICRC(x)        (*(__IO hw_dcic_dcicrc_t *) HW_DCIC_DCICRC_ADDR(x))
#define HW_DCIC_DCICRC_RD(x)     (HW_DCIC_DCICRC(x).U)
#define HW_DCIC_DCICRC_WR(x, v)  (HW_DCIC_DCICRC(x).U = (v))
#define HW_DCIC_DCICRC_SET(x, v) (HW_DCIC_DCICRC_WR(x, HW_DCIC_DCICRC_RD(x) |  (v)))
#define HW_DCIC_DCICRC_CLR(x, v) (HW_DCIC_DCICRC_WR(x, HW_DCIC_DCICRC_RD(x) & ~(v)))
#define HW_DCIC_DCICRC_TOG(x, v) (HW_DCIC_DCICRC_WR(x, HW_DCIC_DCICRC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICRC bitfields
 */

/*!
 * @name Register DCIC_DCICRC, field START_OFFSET_X[12:0] (RW)
 *
 * Column number of ROIs upper-left corner (X coordinate) Range: 0 to 2^13-1
 */
/*@{*/
#define BP_DCIC_DCICRC_START_OFFSET_X (0U) /*!< Bit position for DCIC_DCICRC_START_OFFSET_X. */
#define BM_DCIC_DCICRC_START_OFFSET_X (0x00001FFFU) /*!< Bit mask for DCIC_DCICRC_START_OFFSET_X. */
#define BS_DCIC_DCICRC_START_OFFSET_X (13U) /*!< Bit field size in bits for DCIC_DCICRC_START_OFFSET_X. */

/*! @brief Read current value of the DCIC_DCICRC_START_OFFSET_X field. */
#define BR_DCIC_DCICRC_START_OFFSET_X(x) (HW_DCIC_DCICRC(x).B.START_OFFSET_X)

/*! @brief Format value for bitfield DCIC_DCICRC_START_OFFSET_X. */
#define BF_DCIC_DCICRC_START_OFFSET_X(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRC_START_OFFSET_X) & BM_DCIC_DCICRC_START_OFFSET_X)

/*! @brief Set the START_OFFSET_X field to a new value. */
#define BW_DCIC_DCICRC_START_OFFSET_X(x, v) (HW_DCIC_DCICRC_WR(x, (HW_DCIC_DCICRC_RD(x) & ~BM_DCIC_DCICRC_START_OFFSET_X) | BF_DCIC_DCICRC_START_OFFSET_X(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICRC, field START_OFFSET_Y[27:16] (RW)
 *
 * Row number of ROIs upper-left corner (Y coordinate) Range: 0 to 2^12-1
 */
/*@{*/
#define BP_DCIC_DCICRC_START_OFFSET_Y (16U) /*!< Bit position for DCIC_DCICRC_START_OFFSET_Y. */
#define BM_DCIC_DCICRC_START_OFFSET_Y (0x0FFF0000U) /*!< Bit mask for DCIC_DCICRC_START_OFFSET_Y. */
#define BS_DCIC_DCICRC_START_OFFSET_Y (12U) /*!< Bit field size in bits for DCIC_DCICRC_START_OFFSET_Y. */

/*! @brief Read current value of the DCIC_DCICRC_START_OFFSET_Y field. */
#define BR_DCIC_DCICRC_START_OFFSET_Y(x) (HW_DCIC_DCICRC(x).B.START_OFFSET_Y)

/*! @brief Format value for bitfield DCIC_DCICRC_START_OFFSET_Y. */
#define BF_DCIC_DCICRC_START_OFFSET_Y(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRC_START_OFFSET_Y) & BM_DCIC_DCICRC_START_OFFSET_Y)

/*! @brief Set the START_OFFSET_Y field to a new value. */
#define BW_DCIC_DCICRC_START_OFFSET_Y(x, v) (HW_DCIC_DCICRC_WR(x, (HW_DCIC_DCICRC_RD(x) & ~BM_DCIC_DCICRC_START_OFFSET_Y) | BF_DCIC_DCICRC_START_OFFSET_Y(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICRC, field ROI_FREEZE[30] (RW)
 *
 * When set, the only parameter of ROI #m that can be changed is reference
 * signature. "Sticky" bit - can be set once and cleared by reset only.
 *
 * Values:
 * - 0 - ROI configuration can be changed
 * - 1 - ROI configuration is frozen
 */
/*@{*/
#define BP_DCIC_DCICRC_ROI_FREEZE (30U)    /*!< Bit position for DCIC_DCICRC_ROI_FREEZE. */
#define BM_DCIC_DCICRC_ROI_FREEZE (0x40000000U) /*!< Bit mask for DCIC_DCICRC_ROI_FREEZE. */
#define BS_DCIC_DCICRC_ROI_FREEZE (1U)     /*!< Bit field size in bits for DCIC_DCICRC_ROI_FREEZE. */

/*! @brief Read current value of the DCIC_DCICRC_ROI_FREEZE field. */
#define BR_DCIC_DCICRC_ROI_FREEZE(x) (HW_DCIC_DCICRC(x).B.ROI_FREEZE)

/*! @brief Format value for bitfield DCIC_DCICRC_ROI_FREEZE. */
#define BF_DCIC_DCICRC_ROI_FREEZE(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRC_ROI_FREEZE) & BM_DCIC_DCICRC_ROI_FREEZE)

/*! @brief Set the ROI_FREEZE field to a new value. */
#define BW_DCIC_DCICRC_ROI_FREEZE(x, v) (HW_DCIC_DCICRC_WR(x, (HW_DCIC_DCICRC_RD(x) & ~BM_DCIC_DCICRC_ROI_FREEZE) | BF_DCIC_DCICRC_ROI_FREEZE(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICRC, field ROI_EN[31] (RW)
 *
 * ROI #m tracking enable
 *
 * Values:
 * - 0 - Disabled
 * - 1 - Enabled
 */
/*@{*/
#define BP_DCIC_DCICRC_ROI_EN (31U)        /*!< Bit position for DCIC_DCICRC_ROI_EN. */
#define BM_DCIC_DCICRC_ROI_EN (0x80000000U) /*!< Bit mask for DCIC_DCICRC_ROI_EN. */
#define BS_DCIC_DCICRC_ROI_EN (1U)         /*!< Bit field size in bits for DCIC_DCICRC_ROI_EN. */

/*! @brief Read current value of the DCIC_DCICRC_ROI_EN field. */
#define BR_DCIC_DCICRC_ROI_EN(x) (HW_DCIC_DCICRC(x).B.ROI_EN)

/*! @brief Format value for bitfield DCIC_DCICRC_ROI_EN. */
#define BF_DCIC_DCICRC_ROI_EN(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRC_ROI_EN) & BM_DCIC_DCICRC_ROI_EN)

/*! @brief Set the ROI_EN field to a new value. */
#define BW_DCIC_DCICRC_ROI_EN(x, v) (HW_DCIC_DCICRC_WR(x, (HW_DCIC_DCICRC_RD(x) & ~BM_DCIC_DCICRC_ROI_EN) | BF_DCIC_DCICRC_ROI_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICRS - DCIC ROI Size Register m
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICRS - DCIC ROI Size Register m (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dcic_dcicrs
{
    uint32_t U;
    struct _hw_dcic_dcicrs_bitfields
    {
        uint32_t END_OFFSET_X : 13;    /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t END_OFFSET_Y : 12;    /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_dcic_dcicrs_t;

/*!
 * @name Constants and macros for entire DCIC_DCICRS register
 */
/*@{*/
#define HW_DCIC_DCICRS_ADDR(x)   ((uintptr_t)(x) + 0x14U)

#define HW_DCIC_DCICRS(x)        (*(__IO hw_dcic_dcicrs_t *) HW_DCIC_DCICRS_ADDR(x))
#define HW_DCIC_DCICRS_RD(x)     (HW_DCIC_DCICRS(x).U)
#define HW_DCIC_DCICRS_WR(x, v)  (HW_DCIC_DCICRS(x).U = (v))
#define HW_DCIC_DCICRS_SET(x, v) (HW_DCIC_DCICRS_WR(x, HW_DCIC_DCICRS_RD(x) |  (v)))
#define HW_DCIC_DCICRS_CLR(x, v) (HW_DCIC_DCICRS_WR(x, HW_DCIC_DCICRS_RD(x) & ~(v)))
#define HW_DCIC_DCICRS_TOG(x, v) (HW_DCIC_DCICRS_WR(x, HW_DCIC_DCICRS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICRS bitfields
 */

/*!
 * @name Register DCIC_DCICRS, field END_OFFSET_X[12:0] (RW)
 *
 * Column number of ROIs lower-right corner (X coordinate) Range: 1 to 2^13-1
 */
/*@{*/
#define BP_DCIC_DCICRS_END_OFFSET_X (0U)   /*!< Bit position for DCIC_DCICRS_END_OFFSET_X. */
#define BM_DCIC_DCICRS_END_OFFSET_X (0x00001FFFU) /*!< Bit mask for DCIC_DCICRS_END_OFFSET_X. */
#define BS_DCIC_DCICRS_END_OFFSET_X (13U)  /*!< Bit field size in bits for DCIC_DCICRS_END_OFFSET_X. */

/*! @brief Read current value of the DCIC_DCICRS_END_OFFSET_X field. */
#define BR_DCIC_DCICRS_END_OFFSET_X(x) (HW_DCIC_DCICRS(x).B.END_OFFSET_X)

/*! @brief Format value for bitfield DCIC_DCICRS_END_OFFSET_X. */
#define BF_DCIC_DCICRS_END_OFFSET_X(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRS_END_OFFSET_X) & BM_DCIC_DCICRS_END_OFFSET_X)

/*! @brief Set the END_OFFSET_X field to a new value. */
#define BW_DCIC_DCICRS_END_OFFSET_X(x, v) (HW_DCIC_DCICRS_WR(x, (HW_DCIC_DCICRS_RD(x) & ~BM_DCIC_DCICRS_END_OFFSET_X) | BF_DCIC_DCICRS_END_OFFSET_X(v)))
/*@}*/

/*!
 * @name Register DCIC_DCICRS, field END_OFFSET_Y[27:16] (RW)
 *
 * Row number of ROIs lower-right corner (Y coordinate) Range: 1 to 2^12-1
 */
/*@{*/
#define BP_DCIC_DCICRS_END_OFFSET_Y (16U)  /*!< Bit position for DCIC_DCICRS_END_OFFSET_Y. */
#define BM_DCIC_DCICRS_END_OFFSET_Y (0x0FFF0000U) /*!< Bit mask for DCIC_DCICRS_END_OFFSET_Y. */
#define BS_DCIC_DCICRS_END_OFFSET_Y (12U)  /*!< Bit field size in bits for DCIC_DCICRS_END_OFFSET_Y. */

/*! @brief Read current value of the DCIC_DCICRS_END_OFFSET_Y field. */
#define BR_DCIC_DCICRS_END_OFFSET_Y(x) (HW_DCIC_DCICRS(x).B.END_OFFSET_Y)

/*! @brief Format value for bitfield DCIC_DCICRS_END_OFFSET_Y. */
#define BF_DCIC_DCICRS_END_OFFSET_Y(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRS_END_OFFSET_Y) & BM_DCIC_DCICRS_END_OFFSET_Y)

/*! @brief Set the END_OFFSET_Y field to a new value. */
#define BW_DCIC_DCICRS_END_OFFSET_Y(x, v) (HW_DCIC_DCICRS_WR(x, (HW_DCIC_DCICRS_RD(x) & ~BM_DCIC_DCICRS_END_OFFSET_Y) | BF_DCIC_DCICRS_END_OFFSET_Y(v)))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICRRS - DCIC ROI Reference Signature Register m
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICRRS - DCIC ROI Reference Signature Register m (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dcic_dcicrrs
{
    uint32_t U;
    struct _hw_dcic_dcicrrs_bitfields
    {
        uint32_t REFERENCE_SIGNATURE : 32; /*!< [31:0]  */
    } B;
} hw_dcic_dcicrrs_t;

/*!
 * @name Constants and macros for entire DCIC_DCICRRS register
 */
/*@{*/
#define HW_DCIC_DCICRRS_ADDR(x)  ((uintptr_t)(x) + 0x18U)

#define HW_DCIC_DCICRRS(x)       (*(__IO hw_dcic_dcicrrs_t *) HW_DCIC_DCICRRS_ADDR(x))
#define HW_DCIC_DCICRRS_RD(x)    (HW_DCIC_DCICRRS(x).U)
#define HW_DCIC_DCICRRS_WR(x, v) (HW_DCIC_DCICRRS(x).U = (v))
#define HW_DCIC_DCICRRS_SET(x, v) (HW_DCIC_DCICRRS_WR(x, HW_DCIC_DCICRRS_RD(x) |  (v)))
#define HW_DCIC_DCICRRS_CLR(x, v) (HW_DCIC_DCICRRS_WR(x, HW_DCIC_DCICRRS_RD(x) & ~(v)))
#define HW_DCIC_DCICRRS_TOG(x, v) (HW_DCIC_DCICRRS_WR(x, HW_DCIC_DCICRRS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICRRS bitfields
 */

/*!
 * @name Register DCIC_DCICRRS, field REFERENCE_SIGNATURE[31:0] (RW)
 *
 * 32-bit expected signature (CRC calculation result) for ROI #m
 */
/*@{*/
#define BP_DCIC_DCICRRS_REFERENCE_SIGNATURE (0U) /*!< Bit position for DCIC_DCICRRS_REFERENCE_SIGNATURE. */
#define BM_DCIC_DCICRRS_REFERENCE_SIGNATURE (0xFFFFFFFFU) /*!< Bit mask for DCIC_DCICRRS_REFERENCE_SIGNATURE. */
#define BS_DCIC_DCICRRS_REFERENCE_SIGNATURE (32U) /*!< Bit field size in bits for DCIC_DCICRRS_REFERENCE_SIGNATURE. */

/*! @brief Read current value of the DCIC_DCICRRS_REFERENCE_SIGNATURE field. */
#define BR_DCIC_DCICRRS_REFERENCE_SIGNATURE(x) (HW_DCIC_DCICRRS(x).U)

/*! @brief Format value for bitfield DCIC_DCICRRS_REFERENCE_SIGNATURE. */
#define BF_DCIC_DCICRRS_REFERENCE_SIGNATURE(v) ((uint32_t)((uint32_t)(v) << BP_DCIC_DCICRRS_REFERENCE_SIGNATURE) & BM_DCIC_DCICRRS_REFERENCE_SIGNATURE)

/*! @brief Set the REFERENCE_SIGNATURE field to a new value. */
#define BW_DCIC_DCICRRS_REFERENCE_SIGNATURE(x, v) (HW_DCIC_DCICRRS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_DCIC_DCICRCS - DCIC ROI Calculated Signature m
 ******************************************************************************/

/*!
 * @brief HW_DCIC_DCICRCS - DCIC ROI Calculated Signature m (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dcic_dcicrcs
{
    uint32_t U;
    struct _hw_dcic_dcicrcs_bitfields
    {
        uint32_t CALCULATED_SIGNATURE : 32; /*!< [31:0]  */
    } B;
} hw_dcic_dcicrcs_t;

/*!
 * @name Constants and macros for entire DCIC_DCICRCS register
 */
/*@{*/
#define HW_DCIC_DCICRCS_ADDR(x)  ((uintptr_t)(x) + 0x1CU)

#define HW_DCIC_DCICRCS(x)       (*(__I hw_dcic_dcicrcs_t *) HW_DCIC_DCICRCS_ADDR(x))
#define HW_DCIC_DCICRCS_RD(x)    (HW_DCIC_DCICRCS(x).U)
/*@}*/

/*
 * Constants & macros for individual DCIC_DCICRCS bitfields
 */

/*!
 * @name Register DCIC_DCICRCS, field CALCULATED_SIGNATURE[31:0] (RO)
 *
 * 32-bit actual signature (CRC calculation result) for ROI #m during the last
 * frame. Updated automatically at the beginning of a next frame.
 */
/*@{*/
#define BP_DCIC_DCICRCS_CALCULATED_SIGNATURE (0U) /*!< Bit position for DCIC_DCICRCS_CALCULATED_SIGNATURE. */
#define BM_DCIC_DCICRCS_CALCULATED_SIGNATURE (0xFFFFFFFFU) /*!< Bit mask for DCIC_DCICRCS_CALCULATED_SIGNATURE. */
#define BS_DCIC_DCICRCS_CALCULATED_SIGNATURE (32U) /*!< Bit field size in bits for DCIC_DCICRCS_CALCULATED_SIGNATURE. */

/*! @brief Read current value of the DCIC_DCICRCS_CALCULATED_SIGNATURE field. */
#define BR_DCIC_DCICRCS_CALCULATED_SIGNATURE(x) (HW_DCIC_DCICRCS(x).U)
/*@}*/

/*******************************************************************************
 * hw_dcic_t - module struct
 ******************************************************************************/
/*!
 * @brief All DCIC module registers.
 */
#pragma pack(1)
typedef struct _hw_dcic
{
    __IO hw_dcic_dcicc_t DCICC;            /*!< [0x0] DCIC Control Register */
    __IO hw_dcic_dcicic_t DCICIC;          /*!< [0x4] DCIC Interrupt Control Register */
    __IO hw_dcic_dcics_t DCICS;            /*!< [0x8] DCIC Status Register */
    uint8_t _reserved0[4];
    __IO hw_dcic_dcicrc_t DCICRC;          /*!< [0x10] DCIC ROI Config Register m */
    __IO hw_dcic_dcicrs_t DCICRS;          /*!< [0x14] DCIC ROI Size Register m */
    __IO hw_dcic_dcicrrs_t DCICRRS;        /*!< [0x18] DCIC ROI Reference Signature Register m */
    __I hw_dcic_dcicrcs_t DCICRCS;         /*!< [0x1C] DCIC ROI Calculated Signature m */
} hw_dcic_t;
#pragma pack()

/*! @brief Macro to access all DCIC registers. */
/*! @param x DCIC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_DCIC_REGS(DCIC1_BASE)</code>. */
#define HW_DCIC_REGS(x) (*(hw_dcic_t *)(x))

/*
 * iMX6DP DVFSC
 *
 * DVFSC
 *
 * Registers defined in this header file:
 * - HW_DVFSC_THRS - DVFS Thresholds
 * - HW_DVFSC_COUN - DVFS Counters thresholds
 * - HW_DVFSC_SIG1 - DVFS general purpose bits weight
 * - HW_DVFSC_DVFSSIG0 - DVFS general purpose bits weight
 * - HW_DVFSC_DVFSGPC0 - DVFS general purpose bit 0 weight counter
 * - HW_DVFSC_DVFSGPC1 - DVFS general purpose bit 1 weight counter
 * - HW_DVFSC_DVFSGPBT - DVFS general purpose bits enables
 * - HW_DVFSC_DVFSEMAC - DVFS EMAC settings
 * - HW_DVFSC_CNTR - DVFS Control
 * - HW_DVFSC_DVFSLTR0_0 - DVFS Load Tracking Register 0, portion 0
 * - HW_DVFSC_DVFSLTR0_1 - DVFS Load Tracking Register 0, portion 1
 * - HW_DVFSC_DVFSLTR1_0 - DVFS Load Tracking Register 1, portion 0
 * - HW_DVFSC_DVFSLTR1_1 - DVFS Load Tracking Register 3, portion 1
 * - HW_DVFSC_DVFSPT0 - DVFS pattern 0 length
 * - HW_DVFSC_DVFSPT1 - DVFS pattern 1 length
 * - HW_DVFSC_DVFSPT2 - DVFS pattern 2 length
 * - HW_DVFSC_DVFSPT3 - DVFS pattern 3 length
 *
 * - hw_dvfsc_t - Struct containing all module registers.
 */

#define HW_DVFSC_INSTANCE_COUNT (1U) /*!< Number of instances of the DVFSC module. */
#define HW_DVFSC (0U) /*!< Instance number for DVFSC. */
#define DVFSC_BASE            (0x20DC180U) /*!< Base address for DVFSC. */
/*! Array initializer of DVFSC base addresses. */
#define DVFSC_BASE_ADDRS      { DVFSC_BASE }

/*******************************************************************************
 * HW_DVFSC_THRS - DVFS Thresholds
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_THRS - DVFS Thresholds (RW)
 *
 * Reset value: 0x0FAF003EU
 */
typedef union _hw_dvfsc_thrs
{
    uint32_t U;
    struct _hw_dvfsc_thrs_bitfields
    {
        uint32_t PNCTHR : 6;           /*!< [5:0]  */
        uint32_t RESERVED0 : 10;       /*!< [15:6]  */
        uint32_t DWTHR : 6;            /*!< [21:16]  */
        uint32_t UPTHR : 6;            /*!< [27:22]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_dvfsc_thrs_t;

/*!
 * @name Constants and macros for entire DVFSC_THRS register
 */
/*@{*/
#define HW_DVFSC_THRS_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_DVFSC_THRS(x)         (*(__IO hw_dvfsc_thrs_t *) HW_DVFSC_THRS_ADDR(x))
#define HW_DVFSC_THRS_RD(x)      (HW_DVFSC_THRS(x).U)
#define HW_DVFSC_THRS_WR(x, v)   (HW_DVFSC_THRS(x).U = (v))
#define HW_DVFSC_THRS_SET(x, v)  (HW_DVFSC_THRS_WR(x, HW_DVFSC_THRS_RD(x) |  (v)))
#define HW_DVFSC_THRS_CLR(x, v)  (HW_DVFSC_THRS_WR(x, HW_DVFSC_THRS_RD(x) & ~(v)))
#define HW_DVFSC_THRS_TOG(x, v)  (HW_DVFSC_THRS_WR(x, HW_DVFSC_THRS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_THRS bitfields
 */

/*!
 * @name Register DVFSC_THRS, field PNCTHR[5:0] (RW)
 *
 * Panic threshold for load tracking
 */
/*@{*/
#define BP_DVFSC_THRS_PNCTHR (0U)          /*!< Bit position for DVFSC_THRS_PNCTHR. */
#define BM_DVFSC_THRS_PNCTHR (0x0000003FU) /*!< Bit mask for DVFSC_THRS_PNCTHR. */
#define BS_DVFSC_THRS_PNCTHR (6U)          /*!< Bit field size in bits for DVFSC_THRS_PNCTHR. */

/*! @brief Read current value of the DVFSC_THRS_PNCTHR field. */
#define BR_DVFSC_THRS_PNCTHR(x) (HW_DVFSC_THRS(x).B.PNCTHR)

/*! @brief Format value for bitfield DVFSC_THRS_PNCTHR. */
#define BF_DVFSC_THRS_PNCTHR(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_THRS_PNCTHR) & BM_DVFSC_THRS_PNCTHR)

/*! @brief Set the PNCTHR field to a new value. */
#define BW_DVFSC_THRS_PNCTHR(x, v) (HW_DVFSC_THRS_WR(x, (HW_DVFSC_THRS_RD(x) & ~BM_DVFSC_THRS_PNCTHR) | BF_DVFSC_THRS_PNCTHR(v)))
/*@}*/

/*!
 * @name Register DVFSC_THRS, field DWTHR[21:16] (RW)
 *
 * Down threshold for load tracking
 */
/*@{*/
#define BP_DVFSC_THRS_DWTHR  (16U)         /*!< Bit position for DVFSC_THRS_DWTHR. */
#define BM_DVFSC_THRS_DWTHR  (0x003F0000U) /*!< Bit mask for DVFSC_THRS_DWTHR. */
#define BS_DVFSC_THRS_DWTHR  (6U)          /*!< Bit field size in bits for DVFSC_THRS_DWTHR. */

/*! @brief Read current value of the DVFSC_THRS_DWTHR field. */
#define BR_DVFSC_THRS_DWTHR(x) (HW_DVFSC_THRS(x).B.DWTHR)

/*! @brief Format value for bitfield DVFSC_THRS_DWTHR. */
#define BF_DVFSC_THRS_DWTHR(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_THRS_DWTHR) & BM_DVFSC_THRS_DWTHR)

/*! @brief Set the DWTHR field to a new value. */
#define BW_DVFSC_THRS_DWTHR(x, v) (HW_DVFSC_THRS_WR(x, (HW_DVFSC_THRS_RD(x) & ~BM_DVFSC_THRS_DWTHR) | BF_DVFSC_THRS_DWTHR(v)))
/*@}*/

/*!
 * @name Register DVFSC_THRS, field UPTHR[27:22] (RW)
 *
 * Upper threshold for load tracking
 */
/*@{*/
#define BP_DVFSC_THRS_UPTHR  (22U)         /*!< Bit position for DVFSC_THRS_UPTHR. */
#define BM_DVFSC_THRS_UPTHR  (0x0FC00000U) /*!< Bit mask for DVFSC_THRS_UPTHR. */
#define BS_DVFSC_THRS_UPTHR  (6U)          /*!< Bit field size in bits for DVFSC_THRS_UPTHR. */

/*! @brief Read current value of the DVFSC_THRS_UPTHR field. */
#define BR_DVFSC_THRS_UPTHR(x) (HW_DVFSC_THRS(x).B.UPTHR)

/*! @brief Format value for bitfield DVFSC_THRS_UPTHR. */
#define BF_DVFSC_THRS_UPTHR(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_THRS_UPTHR) & BM_DVFSC_THRS_UPTHR)

/*! @brief Set the UPTHR field to a new value. */
#define BW_DVFSC_THRS_UPTHR(x, v) (HW_DVFSC_THRS_WR(x, (HW_DVFSC_THRS_RD(x) & ~BM_DVFSC_THRS_UPTHR) | BF_DVFSC_THRS_UPTHR(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_COUN - DVFS Counters thresholds
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_COUN - DVFS Counters thresholds (RW)
 *
 * Reset value: 0x00070020U
 */
typedef union _hw_dvfsc_coun
{
    uint32_t U;
    struct _hw_dvfsc_coun_bitfields
    {
        uint32_t UPCNT : 8;            /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t DN_CNT : 8;           /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_dvfsc_coun_t;

/*!
 * @name Constants and macros for entire DVFSC_COUN register
 */
/*@{*/
#define HW_DVFSC_COUN_ADDR(x)    ((uintptr_t)(x) + 0x4U)

#define HW_DVFSC_COUN(x)         (*(__IO hw_dvfsc_coun_t *) HW_DVFSC_COUN_ADDR(x))
#define HW_DVFSC_COUN_RD(x)      (HW_DVFSC_COUN(x).U)
#define HW_DVFSC_COUN_WR(x, v)   (HW_DVFSC_COUN(x).U = (v))
#define HW_DVFSC_COUN_SET(x, v)  (HW_DVFSC_COUN_WR(x, HW_DVFSC_COUN_RD(x) |  (v)))
#define HW_DVFSC_COUN_CLR(x, v)  (HW_DVFSC_COUN_WR(x, HW_DVFSC_COUN_RD(x) & ~(v)))
#define HW_DVFSC_COUN_TOG(x, v)  (HW_DVFSC_COUN_WR(x, HW_DVFSC_COUN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_COUN bitfields
 */

/*!
 * @name Register DVFSC_COUN, field UPCNT[7:0] (RW)
 *
 * UP counter threshold value
 */
/*@{*/
#define BP_DVFSC_COUN_UPCNT  (0U)          /*!< Bit position for DVFSC_COUN_UPCNT. */
#define BM_DVFSC_COUN_UPCNT  (0x000000FFU) /*!< Bit mask for DVFSC_COUN_UPCNT. */
#define BS_DVFSC_COUN_UPCNT  (8U)          /*!< Bit field size in bits for DVFSC_COUN_UPCNT. */

/*! @brief Read current value of the DVFSC_COUN_UPCNT field. */
#define BR_DVFSC_COUN_UPCNT(x) (HW_DVFSC_COUN(x).B.UPCNT)

/*! @brief Format value for bitfield DVFSC_COUN_UPCNT. */
#define BF_DVFSC_COUN_UPCNT(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_COUN_UPCNT) & BM_DVFSC_COUN_UPCNT)

/*! @brief Set the UPCNT field to a new value. */
#define BW_DVFSC_COUN_UPCNT(x, v) (HW_DVFSC_COUN_WR(x, (HW_DVFSC_COUN_RD(x) & ~BM_DVFSC_COUN_UPCNT) | BF_DVFSC_COUN_UPCNT(v)))
/*@}*/

/*!
 * @name Register DVFSC_COUN, field DN_CNT[23:16] (RW)
 *
 * Down counter threshold value
 */
/*@{*/
#define BP_DVFSC_COUN_DN_CNT (16U)         /*!< Bit position for DVFSC_COUN_DN_CNT. */
#define BM_DVFSC_COUN_DN_CNT (0x00FF0000U) /*!< Bit mask for DVFSC_COUN_DN_CNT. */
#define BS_DVFSC_COUN_DN_CNT (8U)          /*!< Bit field size in bits for DVFSC_COUN_DN_CNT. */

/*! @brief Read current value of the DVFSC_COUN_DN_CNT field. */
#define BR_DVFSC_COUN_DN_CNT(x) (HW_DVFSC_COUN(x).B.DN_CNT)

/*! @brief Format value for bitfield DVFSC_COUN_DN_CNT. */
#define BF_DVFSC_COUN_DN_CNT(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_COUN_DN_CNT) & BM_DVFSC_COUN_DN_CNT)

/*! @brief Set the DN_CNT field to a new value. */
#define BW_DVFSC_COUN_DN_CNT(x, v) (HW_DVFSC_COUN_WR(x, (HW_DVFSC_COUN_RD(x) & ~BM_DVFSC_COUN_DN_CNT) | BF_DVFSC_COUN_DN_CNT(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_SIG1 - DVFS general purpose bits weight
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_SIG1 - DVFS general purpose bits weight (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_sig1
{
    uint32_t U;
    struct _hw_dvfsc_sig1_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t WSW6 : 3;             /*!< [4:2]  */
        uint32_t WSW7 : 3;             /*!< [7:5]  */
        uint32_t WSW8 : 3;             /*!< [10:8]  */
        uint32_t WSW9 : 3;             /*!< [13:11]  */
        uint32_t WSW10 : 3;            /*!< [16:14]  */
        uint32_t WSW11 : 3;            /*!< [19:17]  */
        uint32_t WSW12 : 3;            /*!< [22:20]  */
        uint32_t WSW13 : 3;            /*!< [25:23]  */
        uint32_t WSW14 : 3;            /*!< [28:26]  */
        uint32_t WSW15 : 3;            /*!< [31:29]  */
    } B;
} hw_dvfsc_sig1_t;

/*!
 * @name Constants and macros for entire DVFSC_SIG1 register
 */
/*@{*/
#define HW_DVFSC_SIG1_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_DVFSC_SIG1(x)         (*(__IO hw_dvfsc_sig1_t *) HW_DVFSC_SIG1_ADDR(x))
#define HW_DVFSC_SIG1_RD(x)      (HW_DVFSC_SIG1(x).U)
#define HW_DVFSC_SIG1_WR(x, v)   (HW_DVFSC_SIG1(x).U = (v))
#define HW_DVFSC_SIG1_SET(x, v)  (HW_DVFSC_SIG1_WR(x, HW_DVFSC_SIG1_RD(x) |  (v)))
#define HW_DVFSC_SIG1_CLR(x, v)  (HW_DVFSC_SIG1_WR(x, HW_DVFSC_SIG1_RD(x) & ~(v)))
#define HW_DVFSC_SIG1_TOG(x, v)  (HW_DVFSC_SIG1_WR(x, HW_DVFSC_SIG1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_SIG1 bitfields
 */

/*!
 * @name Register DVFSC_SIG1, field WSW6[4:2] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[6]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW6   (2U)          /*!< Bit position for DVFSC_SIG1_WSW6. */
#define BM_DVFSC_SIG1_WSW6   (0x0000001CU) /*!< Bit mask for DVFSC_SIG1_WSW6. */
#define BS_DVFSC_SIG1_WSW6   (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW6. */

/*! @brief Read current value of the DVFSC_SIG1_WSW6 field. */
#define BR_DVFSC_SIG1_WSW6(x) (HW_DVFSC_SIG1(x).B.WSW6)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW6. */
#define BF_DVFSC_SIG1_WSW6(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW6) & BM_DVFSC_SIG1_WSW6)

/*! @brief Set the WSW6 field to a new value. */
#define BW_DVFSC_SIG1_WSW6(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW6) | BF_DVFSC_SIG1_WSW6(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW7[7:5] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[7]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW7   (5U)          /*!< Bit position for DVFSC_SIG1_WSW7. */
#define BM_DVFSC_SIG1_WSW7   (0x000000E0U) /*!< Bit mask for DVFSC_SIG1_WSW7. */
#define BS_DVFSC_SIG1_WSW7   (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW7. */

/*! @brief Read current value of the DVFSC_SIG1_WSW7 field. */
#define BR_DVFSC_SIG1_WSW7(x) (HW_DVFSC_SIG1(x).B.WSW7)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW7. */
#define BF_DVFSC_SIG1_WSW7(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW7) & BM_DVFSC_SIG1_WSW7)

/*! @brief Set the WSW7 field to a new value. */
#define BW_DVFSC_SIG1_WSW7(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW7) | BF_DVFSC_SIG1_WSW7(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW8[10:8] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[8]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW8   (8U)          /*!< Bit position for DVFSC_SIG1_WSW8. */
#define BM_DVFSC_SIG1_WSW8   (0x00000700U) /*!< Bit mask for DVFSC_SIG1_WSW8. */
#define BS_DVFSC_SIG1_WSW8   (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW8. */

/*! @brief Read current value of the DVFSC_SIG1_WSW8 field. */
#define BR_DVFSC_SIG1_WSW8(x) (HW_DVFSC_SIG1(x).B.WSW8)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW8. */
#define BF_DVFSC_SIG1_WSW8(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW8) & BM_DVFSC_SIG1_WSW8)

/*! @brief Set the WSW8 field to a new value. */
#define BW_DVFSC_SIG1_WSW8(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW8) | BF_DVFSC_SIG1_WSW8(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW9[13:11] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[9]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW9   (11U)         /*!< Bit position for DVFSC_SIG1_WSW9. */
#define BM_DVFSC_SIG1_WSW9   (0x00003800U) /*!< Bit mask for DVFSC_SIG1_WSW9. */
#define BS_DVFSC_SIG1_WSW9   (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW9. */

/*! @brief Read current value of the DVFSC_SIG1_WSW9 field. */
#define BR_DVFSC_SIG1_WSW9(x) (HW_DVFSC_SIG1(x).B.WSW9)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW9. */
#define BF_DVFSC_SIG1_WSW9(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW9) & BM_DVFSC_SIG1_WSW9)

/*! @brief Set the WSW9 field to a new value. */
#define BW_DVFSC_SIG1_WSW9(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW9) | BF_DVFSC_SIG1_WSW9(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW10[16:14] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[10]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW10  (14U)         /*!< Bit position for DVFSC_SIG1_WSW10. */
#define BM_DVFSC_SIG1_WSW10  (0x0001C000U) /*!< Bit mask for DVFSC_SIG1_WSW10. */
#define BS_DVFSC_SIG1_WSW10  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW10. */

/*! @brief Read current value of the DVFSC_SIG1_WSW10 field. */
#define BR_DVFSC_SIG1_WSW10(x) (HW_DVFSC_SIG1(x).B.WSW10)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW10. */
#define BF_DVFSC_SIG1_WSW10(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW10) & BM_DVFSC_SIG1_WSW10)

/*! @brief Set the WSW10 field to a new value. */
#define BW_DVFSC_SIG1_WSW10(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW10) | BF_DVFSC_SIG1_WSW10(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW11[19:17] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[11]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW11  (17U)         /*!< Bit position for DVFSC_SIG1_WSW11. */
#define BM_DVFSC_SIG1_WSW11  (0x000E0000U) /*!< Bit mask for DVFSC_SIG1_WSW11. */
#define BS_DVFSC_SIG1_WSW11  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW11. */

/*! @brief Read current value of the DVFSC_SIG1_WSW11 field. */
#define BR_DVFSC_SIG1_WSW11(x) (HW_DVFSC_SIG1(x).B.WSW11)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW11. */
#define BF_DVFSC_SIG1_WSW11(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW11) & BM_DVFSC_SIG1_WSW11)

/*! @brief Set the WSW11 field to a new value. */
#define BW_DVFSC_SIG1_WSW11(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW11) | BF_DVFSC_SIG1_WSW11(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW12[22:20] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[12]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW12  (20U)         /*!< Bit position for DVFSC_SIG1_WSW12. */
#define BM_DVFSC_SIG1_WSW12  (0x00700000U) /*!< Bit mask for DVFSC_SIG1_WSW12. */
#define BS_DVFSC_SIG1_WSW12  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW12. */

/*! @brief Read current value of the DVFSC_SIG1_WSW12 field. */
#define BR_DVFSC_SIG1_WSW12(x) (HW_DVFSC_SIG1(x).B.WSW12)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW12. */
#define BF_DVFSC_SIG1_WSW12(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW12) & BM_DVFSC_SIG1_WSW12)

/*! @brief Set the WSW12 field to a new value. */
#define BW_DVFSC_SIG1_WSW12(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW12) | BF_DVFSC_SIG1_WSW12(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW13[25:23] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[13]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW13  (23U)         /*!< Bit position for DVFSC_SIG1_WSW13. */
#define BM_DVFSC_SIG1_WSW13  (0x03800000U) /*!< Bit mask for DVFSC_SIG1_WSW13. */
#define BS_DVFSC_SIG1_WSW13  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW13. */

/*! @brief Read current value of the DVFSC_SIG1_WSW13 field. */
#define BR_DVFSC_SIG1_WSW13(x) (HW_DVFSC_SIG1(x).B.WSW13)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW13. */
#define BF_DVFSC_SIG1_WSW13(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW13) & BM_DVFSC_SIG1_WSW13)

/*! @brief Set the WSW13 field to a new value. */
#define BW_DVFSC_SIG1_WSW13(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW13) | BF_DVFSC_SIG1_WSW13(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW14[28:26] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[14]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW14  (26U)         /*!< Bit position for DVFSC_SIG1_WSW14. */
#define BM_DVFSC_SIG1_WSW14  (0x1C000000U) /*!< Bit mask for DVFSC_SIG1_WSW14. */
#define BS_DVFSC_SIG1_WSW14  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW14. */

/*! @brief Read current value of the DVFSC_SIG1_WSW14 field. */
#define BR_DVFSC_SIG1_WSW14(x) (HW_DVFSC_SIG1(x).B.WSW14)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW14. */
#define BF_DVFSC_SIG1_WSW14(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW14) & BM_DVFSC_SIG1_WSW14)

/*! @brief Set the WSW14 field to a new value. */
#define BW_DVFSC_SIG1_WSW14(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW14) | BF_DVFSC_SIG1_WSW14(v)))
/*@}*/

/*!
 * @name Register DVFSC_SIG1, field WSW15[31:29] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[15]
 */
/*@{*/
#define BP_DVFSC_SIG1_WSW15  (29U)         /*!< Bit position for DVFSC_SIG1_WSW15. */
#define BM_DVFSC_SIG1_WSW15  (0xE0000000U) /*!< Bit mask for DVFSC_SIG1_WSW15. */
#define BS_DVFSC_SIG1_WSW15  (3U)          /*!< Bit field size in bits for DVFSC_SIG1_WSW15. */

/*! @brief Read current value of the DVFSC_SIG1_WSW15 field. */
#define BR_DVFSC_SIG1_WSW15(x) (HW_DVFSC_SIG1(x).B.WSW15)

/*! @brief Format value for bitfield DVFSC_SIG1_WSW15. */
#define BF_DVFSC_SIG1_WSW15(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_SIG1_WSW15) & BM_DVFSC_SIG1_WSW15)

/*! @brief Set the WSW15 field to a new value. */
#define BW_DVFSC_SIG1_WSW15(x, v) (HW_DVFSC_SIG1_WR(x, (HW_DVFSC_SIG1_RD(x) & ~BM_DVFSC_SIG1_WSW15) | BF_DVFSC_SIG1_WSW15(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSSIG0 - DVFS general purpose bits weight
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSSIG0 - DVFS general purpose bits weight (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfssig0
{
    uint32_t U;
    struct _hw_dvfsc_dvfssig0_bitfields
    {
        uint32_t WSW0 : 6;             /*!< [5:0]  */
        uint32_t WSW1 : 6;             /*!< [11:6]  */
        uint32_t RESERVED0 : 8;        /*!< [19:12]  */
        uint32_t WSW2 : 3;             /*!< [22:20]  */
        uint32_t WSW3 : 3;             /*!< [25:23]  */
        uint32_t WSW4 : 3;             /*!< [28:26]  */
        uint32_t WSW5 : 3;             /*!< [31:29]  */
    } B;
} hw_dvfsc_dvfssig0_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSSIG0 register
 */
/*@{*/
#define HW_DVFSC_DVFSSIG0_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_DVFSC_DVFSSIG0(x)     (*(__IO hw_dvfsc_dvfssig0_t *) HW_DVFSC_DVFSSIG0_ADDR(x))
#define HW_DVFSC_DVFSSIG0_RD(x)  (HW_DVFSC_DVFSSIG0(x).U)
#define HW_DVFSC_DVFSSIG0_WR(x, v) (HW_DVFSC_DVFSSIG0(x).U = (v))
#define HW_DVFSC_DVFSSIG0_SET(x, v) (HW_DVFSC_DVFSSIG0_WR(x, HW_DVFSC_DVFSSIG0_RD(x) |  (v)))
#define HW_DVFSC_DVFSSIG0_CLR(x, v) (HW_DVFSC_DVFSSIG0_WR(x, HW_DVFSC_DVFSSIG0_RD(x) & ~(v)))
#define HW_DVFSC_DVFSSIG0_TOG(x, v) (HW_DVFSC_DVFSSIG0_WR(x, HW_DVFSC_DVFSSIG0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSSIG0 bitfields
 */

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW0[5:0] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[0]. This value is
 * relevant during GPC0 counting period or when GPB0 is set.
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW0 (0U)        /*!< Bit position for DVFSC_DVFSSIG0_WSW0. */
#define BM_DVFSC_DVFSSIG0_WSW0 (0x0000003FU) /*!< Bit mask for DVFSC_DVFSSIG0_WSW0. */
#define BS_DVFSC_DVFSSIG0_WSW0 (6U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW0. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW0 field. */
#define BR_DVFSC_DVFSSIG0_WSW0(x) (HW_DVFSC_DVFSSIG0(x).B.WSW0)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW0. */
#define BF_DVFSC_DVFSSIG0_WSW0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW0) & BM_DVFSC_DVFSSIG0_WSW0)

/*! @brief Set the WSW0 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW0(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW0) | BF_DVFSC_DVFSSIG0_WSW0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW1[11:6] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[1]. This value is
 * relevant during GPC1 counting period or when GPB1 is set.
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW1 (6U)        /*!< Bit position for DVFSC_DVFSSIG0_WSW1. */
#define BM_DVFSC_DVFSSIG0_WSW1 (0x00000FC0U) /*!< Bit mask for DVFSC_DVFSSIG0_WSW1. */
#define BS_DVFSC_DVFSSIG0_WSW1 (6U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW1. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW1 field. */
#define BR_DVFSC_DVFSSIG0_WSW1(x) (HW_DVFSC_DVFSSIG0(x).B.WSW1)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW1. */
#define BF_DVFSC_DVFSSIG0_WSW1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW1) & BM_DVFSC_DVFSSIG0_WSW1)

/*! @brief Set the WSW1 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW1(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW1) | BF_DVFSC_DVFSSIG0_WSW1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW2[22:20] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[2]
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW2 (20U)       /*!< Bit position for DVFSC_DVFSSIG0_WSW2. */
#define BM_DVFSC_DVFSSIG0_WSW2 (0x00700000U) /*!< Bit mask for DVFSC_DVFSSIG0_WSW2. */
#define BS_DVFSC_DVFSSIG0_WSW2 (3U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW2. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW2 field. */
#define BR_DVFSC_DVFSSIG0_WSW2(x) (HW_DVFSC_DVFSSIG0(x).B.WSW2)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW2. */
#define BF_DVFSC_DVFSSIG0_WSW2(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW2) & BM_DVFSC_DVFSSIG0_WSW2)

/*! @brief Set the WSW2 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW2(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW2) | BF_DVFSC_DVFSSIG0_WSW2(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW3[25:23] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[3]
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW3 (23U)       /*!< Bit position for DVFSC_DVFSSIG0_WSW3. */
#define BM_DVFSC_DVFSSIG0_WSW3 (0x03800000U) /*!< Bit mask for DVFSC_DVFSSIG0_WSW3. */
#define BS_DVFSC_DVFSSIG0_WSW3 (3U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW3. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW3 field. */
#define BR_DVFSC_DVFSSIG0_WSW3(x) (HW_DVFSC_DVFSSIG0(x).B.WSW3)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW3. */
#define BF_DVFSC_DVFSSIG0_WSW3(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW3) & BM_DVFSC_DVFSSIG0_WSW3)

/*! @brief Set the WSW3 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW3(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW3) | BF_DVFSC_DVFSSIG0_WSW3(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW4[28:26] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[4]
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW4 (26U)       /*!< Bit position for DVFSC_DVFSSIG0_WSW4. */
#define BM_DVFSC_DVFSSIG0_WSW4 (0x1C000000U) /*!< Bit mask for DVFSC_DVFSSIG0_WSW4. */
#define BS_DVFSC_DVFSSIG0_WSW4 (3U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW4. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW4 field. */
#define BR_DVFSC_DVFSSIG0_WSW4(x) (HW_DVFSC_DVFSSIG0(x).B.WSW4)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW4. */
#define BF_DVFSC_DVFSSIG0_WSW4(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW4) & BM_DVFSC_DVFSSIG0_WSW4)

/*! @brief Set the WSW4 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW4(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW4) | BF_DVFSC_DVFSSIG0_WSW4(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSSIG0, field WSW5[31:29] (RW)
 *
 * General purpose load tracking signal weight dvfs_w_sig[5]
 */
/*@{*/
#define BP_DVFSC_DVFSSIG0_WSW5 (29U)       /*!< Bit position for DVFSC_DVFSSIG0_WSW5. */
#define BM_DVFSC_DVFSSIG0_WSW5 (0xE0000000U) /*!< Bit mask for DVFSC_DVFSSIG0_WSW5. */
#define BS_DVFSC_DVFSSIG0_WSW5 (3U)        /*!< Bit field size in bits for DVFSC_DVFSSIG0_WSW5. */

/*! @brief Read current value of the DVFSC_DVFSSIG0_WSW5 field. */
#define BR_DVFSC_DVFSSIG0_WSW5(x) (HW_DVFSC_DVFSSIG0(x).B.WSW5)

/*! @brief Format value for bitfield DVFSC_DVFSSIG0_WSW5. */
#define BF_DVFSC_DVFSSIG0_WSW5(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSSIG0_WSW5) & BM_DVFSC_DVFSSIG0_WSW5)

/*! @brief Set the WSW5 field to a new value. */
#define BW_DVFSC_DVFSSIG0_WSW5(x, v) (HW_DVFSC_DVFSSIG0_WR(x, (HW_DVFSC_DVFSSIG0_RD(x) & ~BM_DVFSC_DVFSSIG0_WSW5) | BF_DVFSC_DVFSSIG0_WSW5(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSGPC0 - DVFS general purpose bit 0 weight counter
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSGPC0 - DVFS general purpose bit 0 weight counter (RW)
 *
 * Reset value: 0x00000000U
 *
 * DVFS general purpose bits weight counter.
 */
typedef union _hw_dvfsc_dvfsgpc0
{
    uint32_t U;
    struct _hw_dvfsc_dvfsgpc0_bitfields
    {
        uint32_t GPBC0 : 17;           /*!< [16:0]  */
        uint32_t RESERVED0 : 13;       /*!< [29:17]  */
        uint32_t C0ACT : 1;            /*!< [30]  */
        uint32_t C0STRT : 1;           /*!< [31]  */
    } B;
} hw_dvfsc_dvfsgpc0_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSGPC0 register
 */
/*@{*/
#define HW_DVFSC_DVFSGPC0_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_DVFSC_DVFSGPC0(x)     (*(__IO hw_dvfsc_dvfsgpc0_t *) HW_DVFSC_DVFSGPC0_ADDR(x))
#define HW_DVFSC_DVFSGPC0_RD(x)  (HW_DVFSC_DVFSGPC0(x).U)
#define HW_DVFSC_DVFSGPC0_WR(x, v) (HW_DVFSC_DVFSGPC0(x).U = (v))
#define HW_DVFSC_DVFSGPC0_SET(x, v) (HW_DVFSC_DVFSGPC0_WR(x, HW_DVFSC_DVFSGPC0_RD(x) |  (v)))
#define HW_DVFSC_DVFSGPC0_CLR(x, v) (HW_DVFSC_DVFSGPC0_WR(x, HW_DVFSC_DVFSGPC0_RD(x) & ~(v)))
#define HW_DVFSC_DVFSGPC0_TOG(x, v) (HW_DVFSC_DVFSGPC0_WR(x, HW_DVFSC_DVFSGPC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSGPC0 bitfields
 */

/*!
 * @name Register DVFSC_DVFSGPC0, field GPBC0[16:0] (RW)
 *
 * GPBC0 - General Purpose bits Counter 0 During period of this counter the GeP
 * bit 0 will be set and WSW0 will be added to the calculations.
 */
/*@{*/
#define BP_DVFSC_DVFSGPC0_GPBC0 (0U)       /*!< Bit position for DVFSC_DVFSGPC0_GPBC0. */
#define BM_DVFSC_DVFSGPC0_GPBC0 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSGPC0_GPBC0. */
#define BS_DVFSC_DVFSGPC0_GPBC0 (17U)      /*!< Bit field size in bits for DVFSC_DVFSGPC0_GPBC0. */

/*! @brief Read current value of the DVFSC_DVFSGPC0_GPBC0 field. */
#define BR_DVFSC_DVFSGPC0_GPBC0(x) (HW_DVFSC_DVFSGPC0(x).B.GPBC0)

/*! @brief Format value for bitfield DVFSC_DVFSGPC0_GPBC0. */
#define BF_DVFSC_DVFSGPC0_GPBC0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPC0_GPBC0) & BM_DVFSC_DVFSGPC0_GPBC0)

/*! @brief Set the GPBC0 field to a new value. */
#define BW_DVFSC_DVFSGPC0_GPBC0(x, v) (HW_DVFSC_DVFSGPC0_WR(x, (HW_DVFSC_DVFSGPC0_RD(x) & ~BM_DVFSC_DVFSGPC0_GPBC0) | BF_DVFSC_DVFSGPC0_GPBC0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPC0, field C0ACT[30] (RO)
 *
 * C0ACT - Counter 0 active indicator
 *
 * Values:
 * - 1 - General Purpose bit0 counter didn't reach value of "0" - the WSW0 is
 *     provided to DVFS calculation
 * - 0 - General Purpose bit0 counter reached value of "0" - the instead of
 *     WSW0, "0" (zero) is provided to DVFS calculation
 */
/*@{*/
#define BP_DVFSC_DVFSGPC0_C0ACT (30U)      /*!< Bit position for DVFSC_DVFSGPC0_C0ACT. */
#define BM_DVFSC_DVFSGPC0_C0ACT (0x40000000U) /*!< Bit mask for DVFSC_DVFSGPC0_C0ACT. */
#define BS_DVFSC_DVFSGPC0_C0ACT (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPC0_C0ACT. */

/*! @brief Read current value of the DVFSC_DVFSGPC0_C0ACT field. */
#define BR_DVFSC_DVFSGPC0_C0ACT(x) (HW_DVFSC_DVFSGPC0(x).B.C0ACT)
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPC0, field C0STRT[31] (RW)
 *
 * C0STRT - Counter 0 start Setting of this bit will initialize down counting of
 * the GPC0 value. Bit is self-cleared next cycle after setting. Any setting of
 * this bit will re-start GPC0 counter to the GPC0 value. GPB0 bit disables
 * (overrides) GPC0 counter - WSW0 weight is applicable continuously
 */
/*@{*/
#define BP_DVFSC_DVFSGPC0_C0STRT (31U)     /*!< Bit position for DVFSC_DVFSGPC0_C0STRT. */
#define BM_DVFSC_DVFSGPC0_C0STRT (0x80000000U) /*!< Bit mask for DVFSC_DVFSGPC0_C0STRT. */
#define BS_DVFSC_DVFSGPC0_C0STRT (1U)      /*!< Bit field size in bits for DVFSC_DVFSGPC0_C0STRT. */

/*! @brief Read current value of the DVFSC_DVFSGPC0_C0STRT field. */
#define BR_DVFSC_DVFSGPC0_C0STRT(x) (HW_DVFSC_DVFSGPC0(x).B.C0STRT)

/*! @brief Format value for bitfield DVFSC_DVFSGPC0_C0STRT. */
#define BF_DVFSC_DVFSGPC0_C0STRT(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPC0_C0STRT) & BM_DVFSC_DVFSGPC0_C0STRT)

/*! @brief Set the C0STRT field to a new value. */
#define BW_DVFSC_DVFSGPC0_C0STRT(x, v) (HW_DVFSC_DVFSGPC0_WR(x, (HW_DVFSC_DVFSGPC0_RD(x) & ~BM_DVFSC_DVFSGPC0_C0STRT) | BF_DVFSC_DVFSGPC0_C0STRT(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSGPC1 - DVFS general purpose bit 1 weight counter
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSGPC1 - DVFS general purpose bit 1 weight counter (RW)
 *
 * Reset value: 0x00000000U
 *
 * DVFS general purpose bits weight counter1.
 */
typedef union _hw_dvfsc_dvfsgpc1
{
    uint32_t U;
    struct _hw_dvfsc_dvfsgpc1_bitfields
    {
        uint32_t GPBC1 : 17;           /*!< [16:0]  */
        uint32_t RESERVED0 : 13;       /*!< [29:17]  */
        uint32_t C1ACT : 1;            /*!< [30]  */
        uint32_t C1STRT : 1;           /*!< [31]  */
    } B;
} hw_dvfsc_dvfsgpc1_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSGPC1 register
 */
/*@{*/
#define HW_DVFSC_DVFSGPC1_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_DVFSC_DVFSGPC1(x)     (*(__IO hw_dvfsc_dvfsgpc1_t *) HW_DVFSC_DVFSGPC1_ADDR(x))
#define HW_DVFSC_DVFSGPC1_RD(x)  (HW_DVFSC_DVFSGPC1(x).U)
#define HW_DVFSC_DVFSGPC1_WR(x, v) (HW_DVFSC_DVFSGPC1(x).U = (v))
#define HW_DVFSC_DVFSGPC1_SET(x, v) (HW_DVFSC_DVFSGPC1_WR(x, HW_DVFSC_DVFSGPC1_RD(x) |  (v)))
#define HW_DVFSC_DVFSGPC1_CLR(x, v) (HW_DVFSC_DVFSGPC1_WR(x, HW_DVFSC_DVFSGPC1_RD(x) & ~(v)))
#define HW_DVFSC_DVFSGPC1_TOG(x, v) (HW_DVFSC_DVFSGPC1_WR(x, HW_DVFSC_DVFSGPC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSGPC1 bitfields
 */

/*!
 * @name Register DVFSC_DVFSGPC1, field GPBC1[16:0] (RW)
 *
 * GPBC1 - General Purpose bits Counter 1 During period of this counter the GeP
 * bit 1 will be set and WSW1 will be added to the calculations.
 */
/*@{*/
#define BP_DVFSC_DVFSGPC1_GPBC1 (0U)       /*!< Bit position for DVFSC_DVFSGPC1_GPBC1. */
#define BM_DVFSC_DVFSGPC1_GPBC1 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSGPC1_GPBC1. */
#define BS_DVFSC_DVFSGPC1_GPBC1 (17U)      /*!< Bit field size in bits for DVFSC_DVFSGPC1_GPBC1. */

/*! @brief Read current value of the DVFSC_DVFSGPC1_GPBC1 field. */
#define BR_DVFSC_DVFSGPC1_GPBC1(x) (HW_DVFSC_DVFSGPC1(x).B.GPBC1)

/*! @brief Format value for bitfield DVFSC_DVFSGPC1_GPBC1. */
#define BF_DVFSC_DVFSGPC1_GPBC1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPC1_GPBC1) & BM_DVFSC_DVFSGPC1_GPBC1)

/*! @brief Set the GPBC1 field to a new value. */
#define BW_DVFSC_DVFSGPC1_GPBC1(x, v) (HW_DVFSC_DVFSGPC1_WR(x, (HW_DVFSC_DVFSGPC1_RD(x) & ~BM_DVFSC_DVFSGPC1_GPBC1) | BF_DVFSC_DVFSGPC1_GPBC1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPC1, field C1ACT[30] (RO)
 *
 * C1ACT - Counter 1 active indicator
 *
 * Values:
 * - 1 - General Purpose bit1 counter didn't reach value of "0" - the WSW1 is
 *     provided to DVFS calculation
 * - 0 - General Purpose bit1 counter reached value of "0" - the instead of
 *     WSW1, "0" (zero) is provided to DVFS calculation
 */
/*@{*/
#define BP_DVFSC_DVFSGPC1_C1ACT (30U)      /*!< Bit position for DVFSC_DVFSGPC1_C1ACT. */
#define BM_DVFSC_DVFSGPC1_C1ACT (0x40000000U) /*!< Bit mask for DVFSC_DVFSGPC1_C1ACT. */
#define BS_DVFSC_DVFSGPC1_C1ACT (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPC1_C1ACT. */

/*! @brief Read current value of the DVFSC_DVFSGPC1_C1ACT field. */
#define BR_DVFSC_DVFSGPC1_C1ACT(x) (HW_DVFSC_DVFSGPC1(x).B.C1ACT)
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPC1, field C1STRT[31] (RW)
 *
 * C1STRT - Counter 1start Setting of this bit will initialize down counting of
 * the GPC1 value. Bit is self-cleared next cycle after setting. Any setting of
 * this bit will re-start GPC1 counter to the GPC1 value. GPB1 bit disables
 * (overrides) GPC1 counter - WSW1 weight is applicable continuously
 */
/*@{*/
#define BP_DVFSC_DVFSGPC1_C1STRT (31U)     /*!< Bit position for DVFSC_DVFSGPC1_C1STRT. */
#define BM_DVFSC_DVFSGPC1_C1STRT (0x80000000U) /*!< Bit mask for DVFSC_DVFSGPC1_C1STRT. */
#define BS_DVFSC_DVFSGPC1_C1STRT (1U)      /*!< Bit field size in bits for DVFSC_DVFSGPC1_C1STRT. */

/*! @brief Read current value of the DVFSC_DVFSGPC1_C1STRT field. */
#define BR_DVFSC_DVFSGPC1_C1STRT(x) (HW_DVFSC_DVFSGPC1(x).B.C1STRT)

/*! @brief Format value for bitfield DVFSC_DVFSGPC1_C1STRT. */
#define BF_DVFSC_DVFSGPC1_C1STRT(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPC1_C1STRT) & BM_DVFSC_DVFSGPC1_C1STRT)

/*! @brief Set the C1STRT field to a new value. */
#define BW_DVFSC_DVFSGPC1_C1STRT(x, v) (HW_DVFSC_DVFSGPC1_WR(x, (HW_DVFSC_DVFSGPC1_RD(x) & ~BM_DVFSC_DVFSGPC1_C1STRT) | BF_DVFSC_DVFSGPC1_C1STRT(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSGPBT - DVFS general purpose bits enables
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSGPBT - DVFS general purpose bits enables (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfsgpbt
{
    uint32_t U;
    struct _hw_dvfsc_dvfsgpbt_bitfields
    {
        uint32_t GPB0 : 1;             /*!< [0]  */
        uint32_t GPB1 : 1;             /*!< [1]  */
        uint32_t GPB2 : 1;             /*!< [2]  */
        uint32_t GPB3 : 1;             /*!< [3]  */
        uint32_t GPB4 : 1;             /*!< [4]  */
        uint32_t GPB5 : 1;             /*!< [5]  */
        uint32_t GPB6 : 1;             /*!< [6]  */
        uint32_t GPB7 : 1;             /*!< [7]  */
        uint32_t GPB8 : 1;             /*!< [8]  */
        uint32_t GPB9 : 1;             /*!< [9]  */
        uint32_t GPB10 : 1;            /*!< [10]  */
        uint32_t GPB11 : 1;            /*!< [11]  */
        uint32_t GPB12 : 1;            /*!< [12]  */
        uint32_t GPB13 : 1;            /*!< [13]  */
        uint32_t GPB14 : 1;            /*!< [14]  */
        uint32_t GPB15 : 1;            /*!< [15]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_dvfsc_dvfsgpbt_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSGPBT register
 */
/*@{*/
#define HW_DVFSC_DVFSGPBT_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_DVFSC_DVFSGPBT(x)     (*(__IO hw_dvfsc_dvfsgpbt_t *) HW_DVFSC_DVFSGPBT_ADDR(x))
#define HW_DVFSC_DVFSGPBT_RD(x)  (HW_DVFSC_DVFSGPBT(x).U)
#define HW_DVFSC_DVFSGPBT_WR(x, v) (HW_DVFSC_DVFSGPBT(x).U = (v))
#define HW_DVFSC_DVFSGPBT_SET(x, v) (HW_DVFSC_DVFSGPBT_WR(x, HW_DVFSC_DVFSGPBT_RD(x) |  (v)))
#define HW_DVFSC_DVFSGPBT_CLR(x, v) (HW_DVFSC_DVFSGPBT_WR(x, HW_DVFSC_DVFSGPBT_RD(x) & ~(v)))
#define HW_DVFSC_DVFSGPBT_TOG(x, v) (HW_DVFSC_DVFSGPBT_WR(x, HW_DVFSC_DVFSGPBT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSGPBT bitfields
 */

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB0[0] (RW)
 *
 * General purpose bit 0. Its weight is set by WSW0 value. IF set (1), the GPBC0
 * operation is disregarded, WSW0 value is applied continuously.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB0 (0U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB0. */
#define BM_DVFSC_DVFSGPBT_GPB0 (0x00000001U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB0. */
#define BS_DVFSC_DVFSGPBT_GPB0 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB0. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB0 field. */
#define BR_DVFSC_DVFSGPBT_GPB0(x) (HW_DVFSC_DVFSGPBT(x).B.GPB0)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB0. */
#define BF_DVFSC_DVFSGPBT_GPB0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB0) & BM_DVFSC_DVFSGPBT_GPB0)

/*! @brief Set the GPB0 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB0(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB0) | BF_DVFSC_DVFSGPBT_GPB0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB1[1] (RW)
 *
 * General purpose bit 1. Its weight is set by WSW1 value. IF set (1), the GPBC1
 * operation is disregarded, WSW1 value is applied continuously.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB1 (1U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB1. */
#define BM_DVFSC_DVFSGPBT_GPB1 (0x00000002U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB1. */
#define BS_DVFSC_DVFSGPBT_GPB1 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB1. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB1 field. */
#define BR_DVFSC_DVFSGPBT_GPB1(x) (HW_DVFSC_DVFSGPBT(x).B.GPB1)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB1. */
#define BF_DVFSC_DVFSGPBT_GPB1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB1) & BM_DVFSC_DVFSGPBT_GPB1)

/*! @brief Set the GPB1 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB1(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB1) | BF_DVFSC_DVFSGPBT_GPB1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB2[2] (RW)
 *
 * General purpose bit 2. Its weight is set by WSW2 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB2 (2U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB2. */
#define BM_DVFSC_DVFSGPBT_GPB2 (0x00000004U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB2. */
#define BS_DVFSC_DVFSGPBT_GPB2 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB2. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB2 field. */
#define BR_DVFSC_DVFSGPBT_GPB2(x) (HW_DVFSC_DVFSGPBT(x).B.GPB2)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB2. */
#define BF_DVFSC_DVFSGPBT_GPB2(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB2) & BM_DVFSC_DVFSGPBT_GPB2)

/*! @brief Set the GPB2 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB2(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB2) | BF_DVFSC_DVFSGPBT_GPB2(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB3[3] (RW)
 *
 * General purpose bit 3. Its weight is set by WSW3 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB3 (3U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB3. */
#define BM_DVFSC_DVFSGPBT_GPB3 (0x00000008U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB3. */
#define BS_DVFSC_DVFSGPBT_GPB3 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB3. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB3 field. */
#define BR_DVFSC_DVFSGPBT_GPB3(x) (HW_DVFSC_DVFSGPBT(x).B.GPB3)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB3. */
#define BF_DVFSC_DVFSGPBT_GPB3(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB3) & BM_DVFSC_DVFSGPBT_GPB3)

/*! @brief Set the GPB3 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB3(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB3) | BF_DVFSC_DVFSGPBT_GPB3(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB4[4] (RW)
 *
 * General purpose bit 4. Its weight is set by WSW4 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB4 (4U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB4. */
#define BM_DVFSC_DVFSGPBT_GPB4 (0x00000010U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB4. */
#define BS_DVFSC_DVFSGPBT_GPB4 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB4. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB4 field. */
#define BR_DVFSC_DVFSGPBT_GPB4(x) (HW_DVFSC_DVFSGPBT(x).B.GPB4)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB4. */
#define BF_DVFSC_DVFSGPBT_GPB4(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB4) & BM_DVFSC_DVFSGPBT_GPB4)

/*! @brief Set the GPB4 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB4(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB4) | BF_DVFSC_DVFSGPBT_GPB4(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB5[5] (RW)
 *
 * General purpose bit 5. Its weight is set by WSW5 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB5 (5U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB5. */
#define BM_DVFSC_DVFSGPBT_GPB5 (0x00000020U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB5. */
#define BS_DVFSC_DVFSGPBT_GPB5 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB5. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB5 field. */
#define BR_DVFSC_DVFSGPBT_GPB5(x) (HW_DVFSC_DVFSGPBT(x).B.GPB5)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB5. */
#define BF_DVFSC_DVFSGPBT_GPB5(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB5) & BM_DVFSC_DVFSGPBT_GPB5)

/*! @brief Set the GPB5 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB5(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB5) | BF_DVFSC_DVFSGPBT_GPB5(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB6[6] (RW)
 *
 * General purpose bit 6. Its weight is set by WSW6 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB6 (6U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB6. */
#define BM_DVFSC_DVFSGPBT_GPB6 (0x00000040U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB6. */
#define BS_DVFSC_DVFSGPBT_GPB6 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB6. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB6 field. */
#define BR_DVFSC_DVFSGPBT_GPB6(x) (HW_DVFSC_DVFSGPBT(x).B.GPB6)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB6. */
#define BF_DVFSC_DVFSGPBT_GPB6(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB6) & BM_DVFSC_DVFSGPBT_GPB6)

/*! @brief Set the GPB6 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB6(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB6) | BF_DVFSC_DVFSGPBT_GPB6(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB7[7] (RW)
 *
 * General purpose bit 7. Its weight is set by WSW7 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB7 (7U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB7. */
#define BM_DVFSC_DVFSGPBT_GPB7 (0x00000080U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB7. */
#define BS_DVFSC_DVFSGPBT_GPB7 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB7. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB7 field. */
#define BR_DVFSC_DVFSGPBT_GPB7(x) (HW_DVFSC_DVFSGPBT(x).B.GPB7)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB7. */
#define BF_DVFSC_DVFSGPBT_GPB7(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB7) & BM_DVFSC_DVFSGPBT_GPB7)

/*! @brief Set the GPB7 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB7(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB7) | BF_DVFSC_DVFSGPBT_GPB7(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB8[8] (RW)
 *
 * General purpose bit 8. Its weight is set by WSW8 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB8 (8U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB8. */
#define BM_DVFSC_DVFSGPBT_GPB8 (0x00000100U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB8. */
#define BS_DVFSC_DVFSGPBT_GPB8 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB8. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB8 field. */
#define BR_DVFSC_DVFSGPBT_GPB8(x) (HW_DVFSC_DVFSGPBT(x).B.GPB8)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB8. */
#define BF_DVFSC_DVFSGPBT_GPB8(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB8) & BM_DVFSC_DVFSGPBT_GPB8)

/*! @brief Set the GPB8 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB8(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB8) | BF_DVFSC_DVFSGPBT_GPB8(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB9[9] (RW)
 *
 * General purpose bit 9. Its weight is set by WSW9 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB9 (9U)        /*!< Bit position for DVFSC_DVFSGPBT_GPB9. */
#define BM_DVFSC_DVFSGPBT_GPB9 (0x00000200U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB9. */
#define BS_DVFSC_DVFSGPBT_GPB9 (1U)        /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB9. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB9 field. */
#define BR_DVFSC_DVFSGPBT_GPB9(x) (HW_DVFSC_DVFSGPBT(x).B.GPB9)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB9. */
#define BF_DVFSC_DVFSGPBT_GPB9(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB9) & BM_DVFSC_DVFSGPBT_GPB9)

/*! @brief Set the GPB9 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB9(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB9) | BF_DVFSC_DVFSGPBT_GPB9(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB10[10] (RW)
 *
 * General purpose bit 10. Its weight is set by WSW10 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB10 (10U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB10. */
#define BM_DVFSC_DVFSGPBT_GPB10 (0x00000400U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB10. */
#define BS_DVFSC_DVFSGPBT_GPB10 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB10. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB10 field. */
#define BR_DVFSC_DVFSGPBT_GPB10(x) (HW_DVFSC_DVFSGPBT(x).B.GPB10)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB10. */
#define BF_DVFSC_DVFSGPBT_GPB10(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB10) & BM_DVFSC_DVFSGPBT_GPB10)

/*! @brief Set the GPB10 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB10(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB10) | BF_DVFSC_DVFSGPBT_GPB10(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB11[11] (RW)
 *
 * General purpose bit 11. Its weight is set by WSW11 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB11 (11U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB11. */
#define BM_DVFSC_DVFSGPBT_GPB11 (0x00000800U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB11. */
#define BS_DVFSC_DVFSGPBT_GPB11 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB11. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB11 field. */
#define BR_DVFSC_DVFSGPBT_GPB11(x) (HW_DVFSC_DVFSGPBT(x).B.GPB11)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB11. */
#define BF_DVFSC_DVFSGPBT_GPB11(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB11) & BM_DVFSC_DVFSGPBT_GPB11)

/*! @brief Set the GPB11 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB11(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB11) | BF_DVFSC_DVFSGPBT_GPB11(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB12[12] (RW)
 *
 * General purpose bit 12. Its weight is set by WSW12 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB12 (12U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB12. */
#define BM_DVFSC_DVFSGPBT_GPB12 (0x00001000U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB12. */
#define BS_DVFSC_DVFSGPBT_GPB12 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB12. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB12 field. */
#define BR_DVFSC_DVFSGPBT_GPB12(x) (HW_DVFSC_DVFSGPBT(x).B.GPB12)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB12. */
#define BF_DVFSC_DVFSGPBT_GPB12(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB12) & BM_DVFSC_DVFSGPBT_GPB12)

/*! @brief Set the GPB12 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB12(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB12) | BF_DVFSC_DVFSGPBT_GPB12(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB13[13] (RW)
 *
 * General purpose bit 13. Its weight is set by WSW13 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB13 (13U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB13. */
#define BM_DVFSC_DVFSGPBT_GPB13 (0x00002000U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB13. */
#define BS_DVFSC_DVFSGPBT_GPB13 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB13. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB13 field. */
#define BR_DVFSC_DVFSGPBT_GPB13(x) (HW_DVFSC_DVFSGPBT(x).B.GPB13)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB13. */
#define BF_DVFSC_DVFSGPBT_GPB13(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB13) & BM_DVFSC_DVFSGPBT_GPB13)

/*! @brief Set the GPB13 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB13(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB13) | BF_DVFSC_DVFSGPBT_GPB13(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB14[14] (RW)
 *
 * General purpose bit 14. Its weight is set by WSW14 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB14 (14U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB14. */
#define BM_DVFSC_DVFSGPBT_GPB14 (0x00004000U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB14. */
#define BS_DVFSC_DVFSGPBT_GPB14 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB14. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB14 field. */
#define BR_DVFSC_DVFSGPBT_GPB14(x) (HW_DVFSC_DVFSGPBT(x).B.GPB14)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB14. */
#define BF_DVFSC_DVFSGPBT_GPB14(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB14) & BM_DVFSC_DVFSGPBT_GPB14)

/*! @brief Set the GPB14 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB14(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB14) | BF_DVFSC_DVFSGPBT_GPB14(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSGPBT, field GPB15[15] (RW)
 *
 * General purpose bit 15. Its weight is set by WSW15 value.
 */
/*@{*/
#define BP_DVFSC_DVFSGPBT_GPB15 (15U)      /*!< Bit position for DVFSC_DVFSGPBT_GPB15. */
#define BM_DVFSC_DVFSGPBT_GPB15 (0x00008000U) /*!< Bit mask for DVFSC_DVFSGPBT_GPB15. */
#define BS_DVFSC_DVFSGPBT_GPB15 (1U)       /*!< Bit field size in bits for DVFSC_DVFSGPBT_GPB15. */

/*! @brief Read current value of the DVFSC_DVFSGPBT_GPB15 field. */
#define BR_DVFSC_DVFSGPBT_GPB15(x) (HW_DVFSC_DVFSGPBT(x).B.GPB15)

/*! @brief Format value for bitfield DVFSC_DVFSGPBT_GPB15. */
#define BF_DVFSC_DVFSGPBT_GPB15(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSGPBT_GPB15) & BM_DVFSC_DVFSGPBT_GPB15)

/*! @brief Set the GPB15 field to a new value. */
#define BW_DVFSC_DVFSGPBT_GPB15(x, v) (HW_DVFSC_DVFSGPBT_WR(x, (HW_DVFSC_DVFSGPBT_RD(x) & ~BM_DVFSC_DVFSGPBT_GPB15) | BF_DVFSC_DVFSGPBT_GPB15(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSEMAC - DVFS EMAC settings
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSEMAC - DVFS EMAC settings (RW)
 *
 * Reset value: 0x00000004U
 */
typedef union _hw_dvfsc_dvfsemac
{
    uint32_t U;
    struct _hw_dvfsc_dvfsemac_bitfields
    {
        uint32_t EMAC : 9;             /*!< [8:0]  */
        uint32_t DVFEN0 : 1;           /*!< [9]  */
        uint32_t DVFEN1 : 1;           /*!< [10]  */
        uint32_t DVFEN2 : 1;           /*!< [11]  */
        uint32_t DVFEN3 : 1;           /*!< [12]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t FSVAI0 : 2;           /*!< [17:16]  */
        uint32_t FSVAI1 : 2;           /*!< [19:18]  */
        uint32_t FSVAI2 : 2;           /*!< [21:20]  */
        uint32_t FSVAI3 : 2;           /*!< [23:22]  */
        uint32_t WFIM0 : 1;            /*!< [24]  */
        uint32_t WFIM1 : 1;            /*!< [25]  */
        uint32_t WFIM2 : 1;            /*!< [26]  */
        uint32_t WFIM3 : 1;            /*!< [27]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_dvfsc_dvfsemac_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSEMAC register
 */
/*@{*/
#define HW_DVFSC_DVFSEMAC_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_DVFSC_DVFSEMAC(x)     (*(__IO hw_dvfsc_dvfsemac_t *) HW_DVFSC_DVFSEMAC_ADDR(x))
#define HW_DVFSC_DVFSEMAC_RD(x)  (HW_DVFSC_DVFSEMAC(x).U)
#define HW_DVFSC_DVFSEMAC_WR(x, v) (HW_DVFSC_DVFSEMAC(x).U = (v))
#define HW_DVFSC_DVFSEMAC_SET(x, v) (HW_DVFSC_DVFSEMAC_WR(x, HW_DVFSC_DVFSEMAC_RD(x) |  (v)))
#define HW_DVFSC_DVFSEMAC_CLR(x, v) (HW_DVFSC_DVFSEMAC_WR(x, HW_DVFSC_DVFSEMAC_RD(x) & ~(v)))
#define HW_DVFSC_DVFSEMAC_TOG(x, v) (HW_DVFSC_DVFSEMAC_WR(x, HW_DVFSC_DVFSEMAC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSEMAC bitfields
 */

/*!
 * @name Register DVFSC_DVFSEMAC, field EMAC[8:0] (RW)
 *
 * EMAC - EMA control value
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_EMAC (0U)        /*!< Bit position for DVFSC_DVFSEMAC_EMAC. */
#define BM_DVFSC_DVFSEMAC_EMAC (0x000001FFU) /*!< Bit mask for DVFSC_DVFSEMAC_EMAC. */
#define BS_DVFSC_DVFSEMAC_EMAC (9U)        /*!< Bit field size in bits for DVFSC_DVFSEMAC_EMAC. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_EMAC field. */
#define BR_DVFSC_DVFSEMAC_EMAC(x) (HW_DVFSC_DVFSEMAC(x).B.EMAC)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_EMAC. */
#define BF_DVFSC_DVFSEMAC_EMAC(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_EMAC) & BM_DVFSC_DVFSEMAC_EMAC)

/*! @brief Set the EMAC field to a new value. */
#define BW_DVFSC_DVFSEMAC_EMAC(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_EMAC) | BF_DVFSC_DVFSEMAC_EMAC(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field DVFEN0[9] (RW)
 *
 * DVFS tracking for core0 enable.
 *
 * Values:
 * - 1 - DVFS enabled.
 * - 0 - DVFS disabled.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_DVFEN0 (9U)      /*!< Bit position for DVFSC_DVFSEMAC_DVFEN0. */
#define BM_DVFSC_DVFSEMAC_DVFEN0 (0x00000200U) /*!< Bit mask for DVFSC_DVFSEMAC_DVFEN0. */
#define BS_DVFSC_DVFSEMAC_DVFEN0 (1U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_DVFEN0. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_DVFEN0 field. */
#define BR_DVFSC_DVFSEMAC_DVFEN0(x) (HW_DVFSC_DVFSEMAC(x).B.DVFEN0)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_DVFEN0. */
#define BF_DVFSC_DVFSEMAC_DVFEN0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_DVFEN0) & BM_DVFSC_DVFSEMAC_DVFEN0)

/*! @brief Set the DVFEN0 field to a new value. */
#define BW_DVFSC_DVFSEMAC_DVFEN0(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_DVFEN0) | BF_DVFSC_DVFSEMAC_DVFEN0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field DVFEN1[10] (RW)
 *
 * DVFS tracking for core1 enable.
 *
 * Values:
 * - 1 - DVFS enabled.
 * - 0 - DVFS disabled.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_DVFEN1 (10U)     /*!< Bit position for DVFSC_DVFSEMAC_DVFEN1. */
#define BM_DVFSC_DVFSEMAC_DVFEN1 (0x00000400U) /*!< Bit mask for DVFSC_DVFSEMAC_DVFEN1. */
#define BS_DVFSC_DVFSEMAC_DVFEN1 (1U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_DVFEN1. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_DVFEN1 field. */
#define BR_DVFSC_DVFSEMAC_DVFEN1(x) (HW_DVFSC_DVFSEMAC(x).B.DVFEN1)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_DVFEN1. */
#define BF_DVFSC_DVFSEMAC_DVFEN1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_DVFEN1) & BM_DVFSC_DVFSEMAC_DVFEN1)

/*! @brief Set the DVFEN1 field to a new value. */
#define BW_DVFSC_DVFSEMAC_DVFEN1(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_DVFEN1) | BF_DVFSC_DVFSEMAC_DVFEN1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field DVFEN2[11] (RW)
 *
 * DVFS tracking for core2 enable.
 *
 * Values:
 * - 1 - DVFS enabled.
 * - 0 - DVFS disabled.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_DVFEN2 (11U)     /*!< Bit position for DVFSC_DVFSEMAC_DVFEN2. */
#define BM_DVFSC_DVFSEMAC_DVFEN2 (0x00000800U) /*!< Bit mask for DVFSC_DVFSEMAC_DVFEN2. */
#define BS_DVFSC_DVFSEMAC_DVFEN2 (1U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_DVFEN2. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_DVFEN2 field. */
#define BR_DVFSC_DVFSEMAC_DVFEN2(x) (HW_DVFSC_DVFSEMAC(x).B.DVFEN2)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_DVFEN2. */
#define BF_DVFSC_DVFSEMAC_DVFEN2(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_DVFEN2) & BM_DVFSC_DVFSEMAC_DVFEN2)

/*! @brief Set the DVFEN2 field to a new value. */
#define BW_DVFSC_DVFSEMAC_DVFEN2(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_DVFEN2) | BF_DVFSC_DVFSEMAC_DVFEN2(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field DVFEN3[12] (RW)
 *
 * DVFS tracking for core3 enable.
 *
 * Values:
 * - 1 - DVFS enabled.
 * - 0 - DVFS disabled.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_DVFEN3 (12U)     /*!< Bit position for DVFSC_DVFSEMAC_DVFEN3. */
#define BM_DVFSC_DVFSEMAC_DVFEN3 (0x00001000U) /*!< Bit mask for DVFSC_DVFSEMAC_DVFEN3. */
#define BS_DVFSC_DVFSEMAC_DVFEN3 (1U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_DVFEN3. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_DVFEN3 field. */
#define BR_DVFSC_DVFSEMAC_DVFEN3(x) (HW_DVFSC_DVFSEMAC(x).B.DVFEN3)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_DVFEN3. */
#define BF_DVFSC_DVFSEMAC_DVFEN3(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_DVFEN3) & BM_DVFSC_DVFSEMAC_DVFEN3)

/*! @brief Set the DVFEN3 field to a new value. */
#define BW_DVFSC_DVFSEMAC_DVFEN3(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_DVFEN3) | BF_DVFSC_DVFSEMAC_DVFEN3(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field FSVAI0[17:16] (RO)
 *
 * DVFS Frequency adjustment status of core 0. These status bits indicate that
 * frequency should be changed, following load of core 0.
 *
 * Values:
 * - 00 - no change
 * - 01 - frequency should be increased. Low priority source for interrupt.
 *     Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest
 *     frequency).
 * - 10 - frequency should be decreased. Interrupt is asserted, if FSVAIM=0.
 *     Interrupt is masked if MINF= 1 (lowest frequency).
 * - 11 - frequency should be increased immediately. High priority source of
 *     interrupt. Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF =
 *     1 (highest frequency).
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_FSVAI0 (16U)     /*!< Bit position for DVFSC_DVFSEMAC_FSVAI0. */
#define BM_DVFSC_DVFSEMAC_FSVAI0 (0x00030000U) /*!< Bit mask for DVFSC_DVFSEMAC_FSVAI0. */
#define BS_DVFSC_DVFSEMAC_FSVAI0 (2U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_FSVAI0. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_FSVAI0 field. */
#define BR_DVFSC_DVFSEMAC_FSVAI0(x) (HW_DVFSC_DVFSEMAC(x).B.FSVAI0)
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field FSVAI1[19:18] (RO)
 *
 * DVFS Frequency adjustment status of core 1. These status bits indicate that
 * frequency should be changed, following load of core 1.
 *
 * Values:
 * - 00 - no change
 * - 01 - frequency should be increased. Low priority source for interrupt.
 *     Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest
 *     frequency).
 * - 10 - frequency should be decreased. Interrupt is asserted, if FSVAIM=0.
 *     Interrupt is masked if MINF= 1 (lowest frequency).
 * - 11 - frequency should be increased immediately. High priority source of
 *     interrupt. Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF =
 *     1 (highest frequency).
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_FSVAI1 (18U)     /*!< Bit position for DVFSC_DVFSEMAC_FSVAI1. */
#define BM_DVFSC_DVFSEMAC_FSVAI1 (0x000C0000U) /*!< Bit mask for DVFSC_DVFSEMAC_FSVAI1. */
#define BS_DVFSC_DVFSEMAC_FSVAI1 (2U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_FSVAI1. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_FSVAI1 field. */
#define BR_DVFSC_DVFSEMAC_FSVAI1(x) (HW_DVFSC_DVFSEMAC(x).B.FSVAI1)
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field FSVAI2[21:20] (RO)
 *
 * DVFS Frequency adjustment status of core 2. These status bits indicate that
 * frequency should be changed, following load of core 2.
 *
 * Values:
 * - 00 - no change
 * - 01 - frequency should be increased. Low priority source for interrupt.
 *     Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest
 *     frequency).
 * - 10 - frequency should be decreased. Interrupt is asserted, if FSVAIM=0.
 *     Interrupt is masked if MINF= 1 (lowest frequency).
 * - 11 - frequency should be increased immediately. High priority source of
 *     interrupt. Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF =
 *     1 (highest frequency).
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_FSVAI2 (20U)     /*!< Bit position for DVFSC_DVFSEMAC_FSVAI2. */
#define BM_DVFSC_DVFSEMAC_FSVAI2 (0x00300000U) /*!< Bit mask for DVFSC_DVFSEMAC_FSVAI2. */
#define BS_DVFSC_DVFSEMAC_FSVAI2 (2U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_FSVAI2. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_FSVAI2 field. */
#define BR_DVFSC_DVFSEMAC_FSVAI2(x) (HW_DVFSC_DVFSEMAC(x).B.FSVAI2)
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field FSVAI3[23:22] (RO)
 *
 * DVFS Frequency adjustment status of core 3. These status bits indicate that
 * frequency should be changed, following load of core 3.
 *
 * Values:
 * - 00 - no change
 * - 01 - frequency should be increased. Low priority source for interrupt.
 *     Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest
 *     frequency).
 * - 10 - frequency should be decreased. Interrupt is asserted, if FSVAIM=0.
 *     Interrupt is masked if MINF= 1 (lowest frequency).
 * - 11 - frequency should be increased immediately. High priority source of
 *     interrupt. Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF =
 *     1 (highest frequency).
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_FSVAI3 (22U)     /*!< Bit position for DVFSC_DVFSEMAC_FSVAI3. */
#define BM_DVFSC_DVFSEMAC_FSVAI3 (0x00C00000U) /*!< Bit mask for DVFSC_DVFSEMAC_FSVAI3. */
#define BS_DVFSC_DVFSEMAC_FSVAI3 (2U)      /*!< Bit field size in bits for DVFSC_DVFSEMAC_FSVAI3. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_FSVAI3 field. */
#define BR_DVFSC_DVFSEMAC_FSVAI3(x) (HW_DVFSC_DVFSEMAC(x).B.FSVAI3)
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field WFIM0[24] (RW)
 *
 * DVFS Wait for Interrupt of core 0 mask bit
 *
 * Values:
 * - 0 - Wait for interrupt of core 0 isn't masked
 * - 1 - Wait for interrupt of core 0 is masked.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_WFIM0 (24U)      /*!< Bit position for DVFSC_DVFSEMAC_WFIM0. */
#define BM_DVFSC_DVFSEMAC_WFIM0 (0x01000000U) /*!< Bit mask for DVFSC_DVFSEMAC_WFIM0. */
#define BS_DVFSC_DVFSEMAC_WFIM0 (1U)       /*!< Bit field size in bits for DVFSC_DVFSEMAC_WFIM0. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_WFIM0 field. */
#define BR_DVFSC_DVFSEMAC_WFIM0(x) (HW_DVFSC_DVFSEMAC(x).B.WFIM0)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_WFIM0. */
#define BF_DVFSC_DVFSEMAC_WFIM0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_WFIM0) & BM_DVFSC_DVFSEMAC_WFIM0)

/*! @brief Set the WFIM0 field to a new value. */
#define BW_DVFSC_DVFSEMAC_WFIM0(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_WFIM0) | BF_DVFSC_DVFSEMAC_WFIM0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field WFIM1[25] (RW)
 *
 * DVFS Wait for Interrupt of core 1 mask bit
 *
 * Values:
 * - 0 - Wait for interrupt of core 1 isn't masked
 * - 1 - Wait for interrupt of core 1 is masked.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_WFIM1 (25U)      /*!< Bit position for DVFSC_DVFSEMAC_WFIM1. */
#define BM_DVFSC_DVFSEMAC_WFIM1 (0x02000000U) /*!< Bit mask for DVFSC_DVFSEMAC_WFIM1. */
#define BS_DVFSC_DVFSEMAC_WFIM1 (1U)       /*!< Bit field size in bits for DVFSC_DVFSEMAC_WFIM1. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_WFIM1 field. */
#define BR_DVFSC_DVFSEMAC_WFIM1(x) (HW_DVFSC_DVFSEMAC(x).B.WFIM1)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_WFIM1. */
#define BF_DVFSC_DVFSEMAC_WFIM1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_WFIM1) & BM_DVFSC_DVFSEMAC_WFIM1)

/*! @brief Set the WFIM1 field to a new value. */
#define BW_DVFSC_DVFSEMAC_WFIM1(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_WFIM1) | BF_DVFSC_DVFSEMAC_WFIM1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field WFIM2[26] (RW)
 *
 * DVFS Wait for Interrupt of core 2mask bit
 *
 * Values:
 * - 0 - Wait for interrupt of core 2 isn't masked
 * - 1 - Wait for interrupt of core 2 is masked.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_WFIM2 (26U)      /*!< Bit position for DVFSC_DVFSEMAC_WFIM2. */
#define BM_DVFSC_DVFSEMAC_WFIM2 (0x04000000U) /*!< Bit mask for DVFSC_DVFSEMAC_WFIM2. */
#define BS_DVFSC_DVFSEMAC_WFIM2 (1U)       /*!< Bit field size in bits for DVFSC_DVFSEMAC_WFIM2. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_WFIM2 field. */
#define BR_DVFSC_DVFSEMAC_WFIM2(x) (HW_DVFSC_DVFSEMAC(x).B.WFIM2)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_WFIM2. */
#define BF_DVFSC_DVFSEMAC_WFIM2(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_WFIM2) & BM_DVFSC_DVFSEMAC_WFIM2)

/*! @brief Set the WFIM2 field to a new value. */
#define BW_DVFSC_DVFSEMAC_WFIM2(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_WFIM2) | BF_DVFSC_DVFSEMAC_WFIM2(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSEMAC, field WFIM3[27] (RW)
 *
 * DVFS Wait for Interrupt of core 3 mask bit
 *
 * Values:
 * - 0 - Wait for interrupt of core 3 isn't masked
 * - 1 - Wait for interrupt of core 3 is masked.
 */
/*@{*/
#define BP_DVFSC_DVFSEMAC_WFIM3 (27U)      /*!< Bit position for DVFSC_DVFSEMAC_WFIM3. */
#define BM_DVFSC_DVFSEMAC_WFIM3 (0x08000000U) /*!< Bit mask for DVFSC_DVFSEMAC_WFIM3. */
#define BS_DVFSC_DVFSEMAC_WFIM3 (1U)       /*!< Bit field size in bits for DVFSC_DVFSEMAC_WFIM3. */

/*! @brief Read current value of the DVFSC_DVFSEMAC_WFIM3 field. */
#define BR_DVFSC_DVFSEMAC_WFIM3(x) (HW_DVFSC_DVFSEMAC(x).B.WFIM3)

/*! @brief Format value for bitfield DVFSC_DVFSEMAC_WFIM3. */
#define BF_DVFSC_DVFSEMAC_WFIM3(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSEMAC_WFIM3) & BM_DVFSC_DVFSEMAC_WFIM3)

/*! @brief Set the WFIM3 field to a new value. */
#define BW_DVFSC_DVFSEMAC_WFIM3(x, v) (HW_DVFSC_DVFSEMAC_WR(x, (HW_DVFSC_DVFSEMAC_RD(x) & ~BM_DVFSC_DVFSEMAC_WFIM3) | BF_DVFSC_DVFSEMAC_WFIM3(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_CNTR - DVFS Control
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_CNTR - DVFS Control (RW)
 *
 * Reset value: 0x0900000EU
 *
 * DIV3CK division DIV3CK setting dividing ratio sum_3 passing bits div_1_clk
 * cumulative divider 00 1 4-0 1*512=512 001 4 6-2 4*512=2048 010 16 8-4
 * 16*512=8192 011 64 10-6 64*512=32768 100 256 12-8 256*512=131072 101 1024 16-10
 * 1024*512=524288 Preliminary Divider definition DIV_RATIO value ARM clk division ratio
 * 000000 1 000001 2 000010 3 ... ...
 */
typedef union _hw_dvfsc_cntr
{
    uint32_t U;
    struct _hw_dvfsc_cntr_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t LTBRSR : 2;           /*!< [4:3]  */
        uint32_t LTBRSH : 1;           /*!< [5]  */
        uint32_t PFUS : 3;             /*!< [8:6]  */
        uint32_t PFUE : 1;             /*!< [9]  */
        uint32_t RESERVED1 : 1;        /*!< [10]  */
        uint32_t DIV_RATIO : 6;        /*!< [16:11]  */
        uint32_t MINF : 1;             /*!< [17]  */
        uint32_t MAXF : 1;             /*!< [18]  */
        uint32_t RESERVED2 : 1;        /*!< [19]  */
        uint32_t FSVAI : 2;            /*!< [21:20]  */
        uint32_t FSVAIM : 1;           /*!< [22]  */
        uint32_t PIRQS : 1;            /*!< [23]  */
        uint32_t DVFIS : 1;            /*!< [24]  */
        uint32_t LBFL0 : 1;            /*!< [25]  */
        uint32_t LBFL1 : 1;            /*!< [26]  */
        uint32_t LBMI : 1;             /*!< [27]  */
        uint32_t DVFEV : 1;            /*!< [28]  */
        uint32_t DIV3CK : 3;           /*!< [31:29]  */
    } B;
} hw_dvfsc_cntr_t;

/*!
 * @name Constants and macros for entire DVFSC_CNTR register
 */
/*@{*/
#define HW_DVFSC_CNTR_ADDR(x)    ((uintptr_t)(x) + 0x20U)

#define HW_DVFSC_CNTR(x)         (*(__IO hw_dvfsc_cntr_t *) HW_DVFSC_CNTR_ADDR(x))
#define HW_DVFSC_CNTR_RD(x)      (HW_DVFSC_CNTR(x).U)
#define HW_DVFSC_CNTR_WR(x, v)   (HW_DVFSC_CNTR(x).U = (v))
#define HW_DVFSC_CNTR_SET(x, v)  (HW_DVFSC_CNTR_WR(x, HW_DVFSC_CNTR_RD(x) |  (v)))
#define HW_DVFSC_CNTR_CLR(x, v)  (HW_DVFSC_CNTR_WR(x, HW_DVFSC_CNTR_RD(x) & ~(v)))
#define HW_DVFSC_CNTR_TOG(x, v)  (HW_DVFSC_CNTR_WR(x, HW_DVFSC_CNTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_CNTR bitfields
 */

/*!
 * @name Register DVFSC_CNTR, field LTBRSR[4:3] (RW)
 *
 * LTBRSR - Load Tracking Buffer Register Source:
 *
 * Values:
 * - 00 - pre_ld_add
 * - 01 - ld_add
 * - 10 - ema_ld
 * - 11 - reserved
 */
/*@{*/
#define BP_DVFSC_CNTR_LTBRSR (3U)          /*!< Bit position for DVFSC_CNTR_LTBRSR. */
#define BM_DVFSC_CNTR_LTBRSR (0x00000018U) /*!< Bit mask for DVFSC_CNTR_LTBRSR. */
#define BS_DVFSC_CNTR_LTBRSR (2U)          /*!< Bit field size in bits for DVFSC_CNTR_LTBRSR. */

/*! @brief Read current value of the DVFSC_CNTR_LTBRSR field. */
#define BR_DVFSC_CNTR_LTBRSR(x) (HW_DVFSC_CNTR(x).B.LTBRSR)

/*! @brief Format value for bitfield DVFSC_CNTR_LTBRSR. */
#define BF_DVFSC_CNTR_LTBRSR(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_LTBRSR) & BM_DVFSC_CNTR_LTBRSR)

/*! @brief Set the LTBRSR field to a new value. */
#define BW_DVFSC_CNTR_LTBRSR(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_LTBRSR) | BF_DVFSC_CNTR_LTBRSR(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field LTBRSH[5] (RW)
 *
 * LTBRSH - Load Tracking Buffer Register Shift:
 *
 * Values:
 * - 0 - values of [5:2] of the selected input are saving in Load Tracking Buffer
 * - 1 - values of [4:1] of the selected input are saving in Load Tracking Buffer
 */
/*@{*/
#define BP_DVFSC_CNTR_LTBRSH (5U)          /*!< Bit position for DVFSC_CNTR_LTBRSH. */
#define BM_DVFSC_CNTR_LTBRSH (0x00000020U) /*!< Bit mask for DVFSC_CNTR_LTBRSH. */
#define BS_DVFSC_CNTR_LTBRSH (1U)          /*!< Bit field size in bits for DVFSC_CNTR_LTBRSH. */

/*! @brief Read current value of the DVFSC_CNTR_LTBRSH field. */
#define BR_DVFSC_CNTR_LTBRSH(x) (HW_DVFSC_CNTR(x).B.LTBRSH)

/*! @brief Format value for bitfield DVFSC_CNTR_LTBRSH. */
#define BF_DVFSC_CNTR_LTBRSH(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_LTBRSH) & BM_DVFSC_CNTR_LTBRSH)

/*! @brief Set the LTBRSH field to a new value. */
#define BW_DVFSC_CNTR_LTBRSH(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_LTBRSH) | BF_DVFSC_CNTR_LTBRSH(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field PFUS[8:6] (RO)
 *
 * PFUS - Periodic Frequency Update Status
 *
 * Values:
 * - 000 - no update
 * - 100 - DVFSPT0 period, previous finished(can be performance level decrease)
 * - 101 - DVFSPT1 period, previous finished(can be EMA-detected performance
 *     level)
 * - 110 - DVFSPT2 period, previous finished(can be performance level increase)
 * - 111 - DVFSPT3 period, previous finished (can be EMA-detected performance
 *     level)
 */
/*@{*/
#define BP_DVFSC_CNTR_PFUS   (6U)          /*!< Bit position for DVFSC_CNTR_PFUS. */
#define BM_DVFSC_CNTR_PFUS   (0x000001C0U) /*!< Bit mask for DVFSC_CNTR_PFUS. */
#define BS_DVFSC_CNTR_PFUS   (3U)          /*!< Bit field size in bits for DVFSC_CNTR_PFUS. */

/*! @brief Read current value of the DVFSC_CNTR_PFUS field. */
#define BR_DVFSC_CNTR_PFUS(x) (HW_DVFSC_CNTR(x).B.PFUS)
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field PFUE[9] (RW)
 *
 * PFUE - Period Frequency Update Enable
 *
 * Values:
 * - 1 - enabled
 * - 0 - disabled
 */
/*@{*/
#define BP_DVFSC_CNTR_PFUE   (9U)          /*!< Bit position for DVFSC_CNTR_PFUE. */
#define BM_DVFSC_CNTR_PFUE   (0x00000200U) /*!< Bit mask for DVFSC_CNTR_PFUE. */
#define BS_DVFSC_CNTR_PFUE   (1U)          /*!< Bit field size in bits for DVFSC_CNTR_PFUE. */

/*! @brief Read current value of the DVFSC_CNTR_PFUE field. */
#define BR_DVFSC_CNTR_PFUE(x) (HW_DVFSC_CNTR(x).B.PFUE)

/*! @brief Format value for bitfield DVFSC_CNTR_PFUE. */
#define BF_DVFSC_CNTR_PFUE(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_PFUE) & BM_DVFSC_CNTR_PFUE)

/*! @brief Set the PFUE field to a new value. */
#define BW_DVFSC_CNTR_PFUE(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_PFUE) | BF_DVFSC_CNTR_PFUE(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field DIV_RATIO[16:11] (RW)
 *
 * DIV_RATIO - Divider value. Divider divides the input ARM clock, following the
 * table
 */
/*@{*/
#define BP_DVFSC_CNTR_DIV_RATIO (11U)      /*!< Bit position for DVFSC_CNTR_DIV_RATIO. */
#define BM_DVFSC_CNTR_DIV_RATIO (0x0001F800U) /*!< Bit mask for DVFSC_CNTR_DIV_RATIO. */
#define BS_DVFSC_CNTR_DIV_RATIO (6U)       /*!< Bit field size in bits for DVFSC_CNTR_DIV_RATIO. */

/*! @brief Read current value of the DVFSC_CNTR_DIV_RATIO field. */
#define BR_DVFSC_CNTR_DIV_RATIO(x) (HW_DVFSC_CNTR(x).B.DIV_RATIO)

/*! @brief Format value for bitfield DVFSC_CNTR_DIV_RATIO. */
#define BF_DVFSC_CNTR_DIV_RATIO(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_DIV_RATIO) & BM_DVFSC_CNTR_DIV_RATIO)

/*! @brief Set the DIV_RATIO field to a new value. */
#define BW_DVFSC_CNTR_DIV_RATIO(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_DIV_RATIO) | BF_DVFSC_CNTR_DIV_RATIO(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field MINF[17] (RW)
 *
 * Minimum frequency reached. Interrupt will not be created in minimum frequency
 * reached and frequency decrease required.
 *
 * Values:
 * - 1 - min frequency reached
 * - 0 - min frequency not reached
 */
/*@{*/
#define BP_DVFSC_CNTR_MINF   (17U)         /*!< Bit position for DVFSC_CNTR_MINF. */
#define BM_DVFSC_CNTR_MINF   (0x00020000U) /*!< Bit mask for DVFSC_CNTR_MINF. */
#define BS_DVFSC_CNTR_MINF   (1U)          /*!< Bit field size in bits for DVFSC_CNTR_MINF. */

/*! @brief Read current value of the DVFSC_CNTR_MINF field. */
#define BR_DVFSC_CNTR_MINF(x) (HW_DVFSC_CNTR(x).B.MINF)

/*! @brief Format value for bitfield DVFSC_CNTR_MINF. */
#define BF_DVFSC_CNTR_MINF(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_MINF) & BM_DVFSC_CNTR_MINF)

/*! @brief Set the MINF field to a new value. */
#define BW_DVFSC_CNTR_MINF(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_MINF) | BF_DVFSC_CNTR_MINF(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field MAXF[18] (RW)
 *
 * Maximum frequency reached. Interrupt will not be created in maximum frequency
 * reached and frequency increase required.
 *
 * Values:
 * - 1 - max frequency reached
 * - 0 - max frequency not reached
 */
/*@{*/
#define BP_DVFSC_CNTR_MAXF   (18U)         /*!< Bit position for DVFSC_CNTR_MAXF. */
#define BM_DVFSC_CNTR_MAXF   (0x00040000U) /*!< Bit mask for DVFSC_CNTR_MAXF. */
#define BS_DVFSC_CNTR_MAXF   (1U)          /*!< Bit field size in bits for DVFSC_CNTR_MAXF. */

/*! @brief Read current value of the DVFSC_CNTR_MAXF field. */
#define BR_DVFSC_CNTR_MAXF(x) (HW_DVFSC_CNTR(x).B.MAXF)

/*! @brief Format value for bitfield DVFSC_CNTR_MAXF. */
#define BF_DVFSC_CNTR_MAXF(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_MAXF) & BM_DVFSC_CNTR_MAXF)

/*! @brief Set the MAXF field to a new value. */
#define BW_DVFSC_CNTR_MAXF(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_MAXF) | BF_DVFSC_CNTR_MAXF(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field FSVAI[21:20] (RO)
 *
 * FSVAI DVFS Frequency adjustment interrupt. These status bits indicate that
 * the system frequency should be changed.
 *
 * Values:
 * - 00 - no interrupt
 * - 01 - frequency should be increased. Low priority interrupt. Interrupt is
 *     asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest frequency).
 * - 10 - frequency should be decreased. Interrupt is asserted, if FSVAIM=0.
 *     Interrupt is masked if MINF= 1 (lowest frequency).
 * - 11 - frequency should be increased immediately. High priority interrupt.
 *     Interrupt is asserted, if FSVAIM=0. Interrupt is masked if MAXF = 1 (highest
 *     frequency).
 */
/*@{*/
#define BP_DVFSC_CNTR_FSVAI  (20U)         /*!< Bit position for DVFSC_CNTR_FSVAI. */
#define BM_DVFSC_CNTR_FSVAI  (0x00300000U) /*!< Bit mask for DVFSC_CNTR_FSVAI. */
#define BS_DVFSC_CNTR_FSVAI  (2U)          /*!< Bit field size in bits for DVFSC_CNTR_FSVAI. */

/*! @brief Read current value of the DVFSC_CNTR_FSVAI field. */
#define BR_DVFSC_CNTR_FSVAI(x) (HW_DVFSC_CNTR(x).B.FSVAI)
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field FSVAIM[22] (RW)
 *
 * DVFS Frequency adjustment interrupt mask. This bit masks the DVFS frequency
 * adjustment interrupt. FSVAI status bits will be still asserted in relevant
 * cases.
 *
 * Values:
 * - 1 - interrupt is masked.
 * - 0 - interrupt is enabled.
 */
/*@{*/
#define BP_DVFSC_CNTR_FSVAIM (22U)         /*!< Bit position for DVFSC_CNTR_FSVAIM. */
#define BM_DVFSC_CNTR_FSVAIM (0x00400000U) /*!< Bit mask for DVFSC_CNTR_FSVAIM. */
#define BS_DVFSC_CNTR_FSVAIM (1U)          /*!< Bit field size in bits for DVFSC_CNTR_FSVAIM. */

/*! @brief Read current value of the DVFSC_CNTR_FSVAIM field. */
#define BR_DVFSC_CNTR_FSVAIM(x) (HW_DVFSC_CNTR(x).B.FSVAIM)

/*! @brief Format value for bitfield DVFSC_CNTR_FSVAIM. */
#define BF_DVFSC_CNTR_FSVAIM(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_FSVAIM) & BM_DVFSC_CNTR_FSVAIM)

/*! @brief Set the FSVAIM field to a new value. */
#define BW_DVFSC_CNTR_FSVAIM(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_FSVAIM) | BF_DVFSC_CNTR_FSVAIM(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field PIRQS[23] (RW)
 *
 * PIRQS - Pattern IRQ Source * write '1' to clear. Writing '1' will clear
 * interrupt if interrupt was from pattern
 *
 * Values:
 * - 1 - DVFS IRQ source was from pattern
 * - 0 - DVFS IRQ source was not from pattern
 */
/*@{*/
#define BP_DVFSC_CNTR_PIRQS  (23U)         /*!< Bit position for DVFSC_CNTR_PIRQS. */
#define BM_DVFSC_CNTR_PIRQS  (0x00800000U) /*!< Bit mask for DVFSC_CNTR_PIRQS. */
#define BS_DVFSC_CNTR_PIRQS  (1U)          /*!< Bit field size in bits for DVFSC_CNTR_PIRQS. */

/*! @brief Read current value of the DVFSC_CNTR_PIRQS field. */
#define BR_DVFSC_CNTR_PIRQS(x) (HW_DVFSC_CNTR(x).B.PIRQS)

/*! @brief Format value for bitfield DVFSC_CNTR_PIRQS. */
#define BF_DVFSC_CNTR_PIRQS(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_PIRQS) & BM_DVFSC_CNTR_PIRQS)

/*! @brief Set the PIRQS field to a new value. */
#define BW_DVFSC_CNTR_PIRQS(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_PIRQS) | BF_DVFSC_CNTR_PIRQS(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field DVFIS[24] (RW)
 *
 * DVFS Interrupt select. These bits define destination of DVFS interrupts.
 *
 * Values:
 * - 1 - MCU interrupt will be generated for DVFS events.
 * - 0 - SDMA interrupt will be generated for DVFS events.
 */
/*@{*/
#define BP_DVFSC_CNTR_DVFIS  (24U)         /*!< Bit position for DVFSC_CNTR_DVFIS. */
#define BM_DVFSC_CNTR_DVFIS  (0x01000000U) /*!< Bit mask for DVFSC_CNTR_DVFIS. */
#define BS_DVFSC_CNTR_DVFIS  (1U)          /*!< Bit field size in bits for DVFSC_CNTR_DVFIS. */

/*! @brief Read current value of the DVFSC_CNTR_DVFIS field. */
#define BR_DVFSC_CNTR_DVFIS(x) (HW_DVFSC_CNTR(x).B.DVFIS)

/*! @brief Format value for bitfield DVFSC_CNTR_DVFIS. */
#define BF_DVFSC_CNTR_DVFIS(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_DVFIS) & BM_DVFSC_CNTR_DVFIS)

/*! @brief Set the DVFIS field to a new value. */
#define BW_DVFSC_CNTR_DVFIS(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_DVFIS) | BF_DVFSC_CNTR_DVFIS(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field LBFL0[25] (RW)
 *
 * Load buffer 0 - full status bit. This bit indicates that log buffer registers
 * are full. The bit is set to 1 automatically. An interrupt will be generated
 * if LBMI bit is set to "0" Write '1' to clear. (write '0' leaves bit unchanged)
 *
 * Values:
 * - 1 - Load buffer1 is full.
 * - 0 - Load buffer1 is not full.
 */
/*@{*/
#define BP_DVFSC_CNTR_LBFL0  (25U)         /*!< Bit position for DVFSC_CNTR_LBFL0. */
#define BM_DVFSC_CNTR_LBFL0  (0x02000000U) /*!< Bit mask for DVFSC_CNTR_LBFL0. */
#define BS_DVFSC_CNTR_LBFL0  (1U)          /*!< Bit field size in bits for DVFSC_CNTR_LBFL0. */

/*! @brief Read current value of the DVFSC_CNTR_LBFL0 field. */
#define BR_DVFSC_CNTR_LBFL0(x) (HW_DVFSC_CNTR(x).B.LBFL0)

/*! @brief Format value for bitfield DVFSC_CNTR_LBFL0. */
#define BF_DVFSC_CNTR_LBFL0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_LBFL0) & BM_DVFSC_CNTR_LBFL0)

/*! @brief Set the LBFL0 field to a new value. */
#define BW_DVFSC_CNTR_LBFL0(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_LBFL0) | BF_DVFSC_CNTR_LBFL0(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field LBFL1[26] (RW)
 *
 * Load buffer 1 - full status bit. This bit indicates that log buffer registers
 * are full. The bit is set to 1 automatically. An interrupt will be generated
 * if LBMI bit is set to "0" Write '1' to clear. (write '0' leaves bit unchanged)
 *
 * Values:
 * - 1 - Load buffer0 is full.
 * - 0 - Load buffer0 is not full.
 */
/*@{*/
#define BP_DVFSC_CNTR_LBFL1  (26U)         /*!< Bit position for DVFSC_CNTR_LBFL1. */
#define BM_DVFSC_CNTR_LBFL1  (0x04000000U) /*!< Bit mask for DVFSC_CNTR_LBFL1. */
#define BS_DVFSC_CNTR_LBFL1  (1U)          /*!< Bit field size in bits for DVFSC_CNTR_LBFL1. */

/*! @brief Read current value of the DVFSC_CNTR_LBFL1 field. */
#define BR_DVFSC_CNTR_LBFL1(x) (HW_DVFSC_CNTR(x).B.LBFL1)

/*! @brief Format value for bitfield DVFSC_CNTR_LBFL1. */
#define BF_DVFSC_CNTR_LBFL1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_LBFL1) & BM_DVFSC_CNTR_LBFL1)

/*! @brief Set the LBFL1 field to a new value. */
#define BW_DVFSC_CNTR_LBFL1(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_LBFL1) | BF_DVFSC_CNTR_LBFL1(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field LBMI[27] (RW)
 *
 * Load buffer full mask interrupt. This bit masks the generation of this
 * interrupt. Load buffer full interrupt is masked (LBFL0 and LBFL1 bits still will be
 * updated, but interrupt won't be generated) Load buffer full interrupt is
 * enabled.
 */
/*@{*/
#define BP_DVFSC_CNTR_LBMI   (27U)         /*!< Bit position for DVFSC_CNTR_LBMI. */
#define BM_DVFSC_CNTR_LBMI   (0x08000000U) /*!< Bit mask for DVFSC_CNTR_LBMI. */
#define BS_DVFSC_CNTR_LBMI   (1U)          /*!< Bit field size in bits for DVFSC_CNTR_LBMI. */

/*! @brief Read current value of the DVFSC_CNTR_LBMI field. */
#define BR_DVFSC_CNTR_LBMI(x) (HW_DVFSC_CNTR(x).B.LBMI)

/*! @brief Format value for bitfield DVFSC_CNTR_LBMI. */
#define BF_DVFSC_CNTR_LBMI(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_LBMI) & BM_DVFSC_CNTR_LBMI)

/*! @brief Set the LBMI field to a new value. */
#define BW_DVFSC_CNTR_LBMI(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_LBMI) | BF_DVFSC_CNTR_LBMI(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field DVFEV[28] (RW)
 *
 * Always give a DVFS event.
 *
 * Values:
 * - 0 - Do not give an event always.
 * - 1 - Always give event.
 */
/*@{*/
#define BP_DVFSC_CNTR_DVFEV  (28U)         /*!< Bit position for DVFSC_CNTR_DVFEV. */
#define BM_DVFSC_CNTR_DVFEV  (0x10000000U) /*!< Bit mask for DVFSC_CNTR_DVFEV. */
#define BS_DVFSC_CNTR_DVFEV  (1U)          /*!< Bit field size in bits for DVFSC_CNTR_DVFEV. */

/*! @brief Read current value of the DVFSC_CNTR_DVFEV field. */
#define BR_DVFSC_CNTR_DVFEV(x) (HW_DVFSC_CNTR(x).B.DVFEV)

/*! @brief Format value for bitfield DVFSC_CNTR_DVFEV. */
#define BF_DVFSC_CNTR_DVFEV(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_DVFEV) & BM_DVFSC_CNTR_DVFEV)

/*! @brief Set the DVFEV field to a new value. */
#define BW_DVFSC_CNTR_DVFEV(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_DVFEV) | BF_DVFSC_CNTR_DVFEV(v)))
/*@}*/

/*!
 * @name Register DVFSC_CNTR, field DIV3CK[31:29] (RW)
 *
 * DIV3CK - div_3_clk division ratio inside the DVFS module. According to the
 */
/*@{*/
#define BP_DVFSC_CNTR_DIV3CK (29U)         /*!< Bit position for DVFSC_CNTR_DIV3CK. */
#define BM_DVFSC_CNTR_DIV3CK (0xE0000000U) /*!< Bit mask for DVFSC_CNTR_DIV3CK. */
#define BS_DVFSC_CNTR_DIV3CK (3U)          /*!< Bit field size in bits for DVFSC_CNTR_DIV3CK. */

/*! @brief Read current value of the DVFSC_CNTR_DIV3CK field. */
#define BR_DVFSC_CNTR_DIV3CK(x) (HW_DVFSC_CNTR(x).B.DIV3CK)

/*! @brief Format value for bitfield DVFSC_CNTR_DIV3CK. */
#define BF_DVFSC_CNTR_DIV3CK(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_CNTR_DIV3CK) & BM_DVFSC_CNTR_DIV3CK)

/*! @brief Set the DIV3CK field to a new value. */
#define BW_DVFSC_CNTR_DIV3CK(x, v) (HW_DVFSC_CNTR_WR(x, (HW_DVFSC_CNTR_RD(x) & ~BM_DVFSC_CNTR_DIV3CK) | BF_DVFSC_CNTR_DIV3CK(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSLTR0_0 - DVFS Load Tracking Register 0, portion 0
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSLTR0_0 - DVFS Load Tracking Register 0, portion 0 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfsltr0_0
{
    uint32_t U;
    struct _hw_dvfsc_dvfsltr0_0_bitfields
    {
        uint32_t LTS0_0 : 4;           /*!< [3:0]  */
        uint32_t LTS0_1 : 4;           /*!< [7:4]  */
        uint32_t LTS0_2 : 4;           /*!< [11:8]  */
        uint32_t LTS0_3 : 4;           /*!< [15:12]  */
        uint32_t LTS0_4 : 4;           /*!< [19:16]  */
        uint32_t LTS0_5 : 4;           /*!< [23:20]  */
        uint32_t LTS0_6 : 4;           /*!< [27:24]  */
        uint32_t LTS0_7 : 4;           /*!< [31:28]  */
    } B;
} hw_dvfsc_dvfsltr0_0_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSLTR0_0 register
 */
/*@{*/
#define HW_DVFSC_DVFSLTR0_0_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_DVFSC_DVFSLTR0_0(x)   (*(__I hw_dvfsc_dvfsltr0_0_t *) HW_DVFSC_DVFSLTR0_0_ADDR(x))
#define HW_DVFSC_DVFSLTR0_0_RD(x) (HW_DVFSC_DVFSLTR0_0(x).U)
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSLTR0_0 bitfields
 */

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_0[3:0] (RO)
 *
 * core 0 Load Tracking Sample 0
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_0 (0U)    /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_0. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_0 (0x0000000FU) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_0. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_0 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_0. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_0 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_0(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_0)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_1[7:4] (RO)
 *
 * core 0 Load Tracking Sample 1
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_1 (4U)    /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_1. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_1 (0x000000F0U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_1. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_1 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_1. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_1 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_1(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_1)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_2[11:8] (RO)
 *
 * core 0 Load Tracking Sample 2
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_2 (8U)    /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_2. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_2 (0x00000F00U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_2. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_2 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_2. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_2 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_2(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_2)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_3[15:12] (RO)
 *
 * core 0 Load Tracking Sample 3
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_3 (12U)   /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_3. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_3 (0x0000F000U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_3. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_3 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_3. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_3 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_3(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_3)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_4[19:16] (RO)
 *
 * core 0 Load Tracking Sample 4
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_4 (16U)   /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_4. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_4 (0x000F0000U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_4. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_4 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_4. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_4 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_4(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_4)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_5[23:20] (RO)
 *
 * core 0 Load Tracking Sample 5
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_5 (20U)   /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_5. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_5 (0x00F00000U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_5. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_5 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_5. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_5 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_5(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_5)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_6[27:24] (RO)
 *
 * core 0 Load Tracking Sample 6
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_6 (24U)   /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_6. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_6 (0x0F000000U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_6. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_6 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_6. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_6 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_6(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_6)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_0, field LTS0_7[31:28] (RO)
 *
 * core 0 Load Tracking Sample 7
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_0_LTS0_7 (28U)   /*!< Bit position for DVFSC_DVFSLTR0_0_LTS0_7. */
#define BM_DVFSC_DVFSLTR0_0_LTS0_7 (0xF0000000U) /*!< Bit mask for DVFSC_DVFSLTR0_0_LTS0_7. */
#define BS_DVFSC_DVFSLTR0_0_LTS0_7 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_0_LTS0_7. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_0_LTS0_7 field. */
#define BR_DVFSC_DVFSLTR0_0_LTS0_7(x) (HW_DVFSC_DVFSLTR0_0(x).B.LTS0_7)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSLTR0_1 - DVFS Load Tracking Register 0, portion 1
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSLTR0_1 - DVFS Load Tracking Register 0, portion 1 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfsltr0_1
{
    uint32_t U;
    struct _hw_dvfsc_dvfsltr0_1_bitfields
    {
        uint32_t LTS0_8 : 4;           /*!< [3:0]  */
        uint32_t LTS0_9 : 4;           /*!< [7:4]  */
        uint32_t LTS0_10 : 4;          /*!< [11:8]  */
        uint32_t LTS0_11 : 4;          /*!< [15:12]  */
        uint32_t LTS0_12 : 4;          /*!< [19:16]  */
        uint32_t LTS0_13 : 4;          /*!< [23:20]  */
        uint32_t LTS0_14 : 4;          /*!< [27:24]  */
        uint32_t LTS0_15 : 4;          /*!< [31:28]  */
    } B;
} hw_dvfsc_dvfsltr0_1_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSLTR0_1 register
 */
/*@{*/
#define HW_DVFSC_DVFSLTR0_1_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_DVFSC_DVFSLTR0_1(x)   (*(__I hw_dvfsc_dvfsltr0_1_t *) HW_DVFSC_DVFSLTR0_1_ADDR(x))
#define HW_DVFSC_DVFSLTR0_1_RD(x) (HW_DVFSC_DVFSLTR0_1(x).U)
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSLTR0_1 bitfields
 */

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_8[3:0] (RO)
 *
 * core 0 Load Tracking Sample 8
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_8 (0U)    /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_8. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_8 (0x0000000FU) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_8. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_8 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_8. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_8 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_8(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_8)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_9[7:4] (RO)
 *
 * core 0 Load Tracking Sample 9
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_9 (4U)    /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_9. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_9 (0x000000F0U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_9. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_9 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_9. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_9 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_9(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_9)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_10[11:8] (RO)
 *
 * core 0 Load Tracking Sample 10
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_10 (8U)   /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_10. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_10 (0x00000F00U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_10. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_10 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_10. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_10 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_10(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_10)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_11[15:12] (RO)
 *
 * core 0 Load Tracking Sample 11
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_11 (12U)  /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_11. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_11 (0x0000F000U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_11. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_11 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_11. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_11 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_11(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_11)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_12[19:16] (RO)
 *
 * core 0 Load Tracking Sample 12
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_12 (16U)  /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_12. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_12 (0x000F0000U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_12. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_12 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_12. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_12 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_12(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_12)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_13[23:20] (RO)
 *
 * core 0 Load Tracking Sample 13
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_13 (20U)  /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_13. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_13 (0x00F00000U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_13. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_13 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_13. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_13 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_13(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_13)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_14[27:24] (RO)
 *
 * core 0 Load Tracking Sample 14
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_14 (24U)  /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_14. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_14 (0x0F000000U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_14. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_14 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_14. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_14 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_14(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_14)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR0_1, field LTS0_15[31:28] (RO)
 *
 * core 0 Load Tracking Sample 15
 */
/*@{*/
#define BP_DVFSC_DVFSLTR0_1_LTS0_15 (28U)  /*!< Bit position for DVFSC_DVFSLTR0_1_LTS0_15. */
#define BM_DVFSC_DVFSLTR0_1_LTS0_15 (0xF0000000U) /*!< Bit mask for DVFSC_DVFSLTR0_1_LTS0_15. */
#define BS_DVFSC_DVFSLTR0_1_LTS0_15 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR0_1_LTS0_15. */

/*! @brief Read current value of the DVFSC_DVFSLTR0_1_LTS0_15 field. */
#define BR_DVFSC_DVFSLTR0_1_LTS0_15(x) (HW_DVFSC_DVFSLTR0_1(x).B.LTS0_15)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSLTR1_0 - DVFS Load Tracking Register 1, portion 0
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSLTR1_0 - DVFS Load Tracking Register 1, portion 0 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfsltr1_0
{
    uint32_t U;
    struct _hw_dvfsc_dvfsltr1_0_bitfields
    {
        uint32_t LTS1_0 : 4;           /*!< [3:0]  */
        uint32_t LTS1_1 : 4;           /*!< [7:4]  */
        uint32_t LTS1_2 : 4;           /*!< [11:8]  */
        uint32_t LTS1_3 : 4;           /*!< [15:12]  */
        uint32_t LTS1_4 : 4;           /*!< [19:16]  */
        uint32_t LTS1_5 : 4;           /*!< [23:20]  */
        uint32_t LTS1_6 : 4;           /*!< [27:24]  */
        uint32_t LTS1_7 : 4;           /*!< [31:28]  */
    } B;
} hw_dvfsc_dvfsltr1_0_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSLTR1_0 register
 */
/*@{*/
#define HW_DVFSC_DVFSLTR1_0_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_DVFSC_DVFSLTR1_0(x)   (*(__I hw_dvfsc_dvfsltr1_0_t *) HW_DVFSC_DVFSLTR1_0_ADDR(x))
#define HW_DVFSC_DVFSLTR1_0_RD(x) (HW_DVFSC_DVFSLTR1_0(x).U)
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSLTR1_0 bitfields
 */

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_0[3:0] (RO)
 *
 * core 0 Load Tracking Sample 0
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_0 (0U)    /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_0. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_0 (0x0000000FU) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_0. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_0 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_0. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_0 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_0(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_0)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_1[7:4] (RO)
 *
 * core 0 Load Tracking Sample 1
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_1 (4U)    /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_1. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_1 (0x000000F0U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_1. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_1 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_1. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_1 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_1(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_1)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_2[11:8] (RO)
 *
 * core 0 Load Tracking Sample 2
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_2 (8U)    /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_2. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_2 (0x00000F00U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_2. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_2 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_2. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_2 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_2(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_2)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_3[15:12] (RO)
 *
 * core 0 Load Tracking Sample 3
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_3 (12U)   /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_3. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_3 (0x0000F000U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_3. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_3 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_3. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_3 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_3(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_3)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_4[19:16] (RO)
 *
 * core 0 Load Tracking Sample 4
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_4 (16U)   /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_4. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_4 (0x000F0000U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_4. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_4 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_4. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_4 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_4(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_4)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_5[23:20] (RO)
 *
 * core 0 Load Tracking Sample 5
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_5 (20U)   /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_5. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_5 (0x00F00000U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_5. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_5 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_5. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_5 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_5(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_5)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_6[27:24] (RO)
 *
 * core 0 Load Tracking Sample 6
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_6 (24U)   /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_6. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_6 (0x0F000000U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_6. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_6 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_6. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_6 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_6(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_6)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_0, field LTS1_7[31:28] (RO)
 *
 * core 0 Load Tracking Sample 7
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_0_LTS1_7 (28U)   /*!< Bit position for DVFSC_DVFSLTR1_0_LTS1_7. */
#define BM_DVFSC_DVFSLTR1_0_LTS1_7 (0xF0000000U) /*!< Bit mask for DVFSC_DVFSLTR1_0_LTS1_7. */
#define BS_DVFSC_DVFSLTR1_0_LTS1_7 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_0_LTS1_7. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_0_LTS1_7 field. */
#define BR_DVFSC_DVFSLTR1_0_LTS1_7(x) (HW_DVFSC_DVFSLTR1_0(x).B.LTS1_7)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSLTR1_1 - DVFS Load Tracking Register 3, portion 1
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSLTR1_1 - DVFS Load Tracking Register 3, portion 1 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_dvfsc_dvfsltr1_1
{
    uint32_t U;
    struct _hw_dvfsc_dvfsltr1_1_bitfields
    {
        uint32_t LTS1_8 : 4;           /*!< [3:0]  */
        uint32_t LTS1_9 : 4;           /*!< [7:4]  */
        uint32_t LTS1_10 : 4;          /*!< [11:8]  */
        uint32_t LTS1_11 : 4;          /*!< [15:12]  */
        uint32_t LTS1_12 : 4;          /*!< [19:16]  */
        uint32_t LTS1_13 : 4;          /*!< [23:20]  */
        uint32_t LTS1_14 : 4;          /*!< [27:24]  */
        uint32_t LTS1_15 : 4;          /*!< [31:28]  */
    } B;
} hw_dvfsc_dvfsltr1_1_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSLTR1_1 register
 */
/*@{*/
#define HW_DVFSC_DVFSLTR1_1_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_DVFSC_DVFSLTR1_1(x)   (*(__I hw_dvfsc_dvfsltr1_1_t *) HW_DVFSC_DVFSLTR1_1_ADDR(x))
#define HW_DVFSC_DVFSLTR1_1_RD(x) (HW_DVFSC_DVFSLTR1_1(x).U)
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSLTR1_1 bitfields
 */

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_8[3:0] (RO)
 *
 * core 0 Load Tracking Sample 8
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_8 (0U)    /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_8. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_8 (0x0000000FU) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_8. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_8 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_8. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_8 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_8(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_8)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_9[7:4] (RO)
 *
 * core 0 Load Tracking Sample 9
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_9 (4U)    /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_9. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_9 (0x000000F0U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_9. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_9 (4U)    /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_9. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_9 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_9(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_9)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_10[11:8] (RO)
 *
 * core 0 Load Tracking Sample 10
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_10 (8U)   /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_10. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_10 (0x00000F00U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_10. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_10 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_10. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_10 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_10(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_10)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_11[15:12] (RO)
 *
 * core 0 Load Tracking Sample 11
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_11 (12U)  /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_11. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_11 (0x0000F000U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_11. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_11 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_11. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_11 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_11(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_11)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_12[19:16] (RO)
 *
 * core 0 Load Tracking Sample 12
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_12 (16U)  /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_12. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_12 (0x000F0000U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_12. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_12 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_12. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_12 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_12(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_12)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_13[23:20] (RO)
 *
 * core 0 Load Tracking Sample 13
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_13 (20U)  /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_13. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_13 (0x00F00000U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_13. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_13 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_13. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_13 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_13(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_13)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_14[27:24] (RO)
 *
 * core 0 Load Tracking Sample 14
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_14 (24U)  /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_14. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_14 (0x0F000000U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_14. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_14 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_14. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_14 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_14(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_14)
/*@}*/

/*!
 * @name Register DVFSC_DVFSLTR1_1, field LTS1_15[31:28] (RO)
 *
 * core 0 Load Tracking Sample 15
 */
/*@{*/
#define BP_DVFSC_DVFSLTR1_1_LTS1_15 (28U)  /*!< Bit position for DVFSC_DVFSLTR1_1_LTS1_15. */
#define BM_DVFSC_DVFSLTR1_1_LTS1_15 (0xF0000000U) /*!< Bit mask for DVFSC_DVFSLTR1_1_LTS1_15. */
#define BS_DVFSC_DVFSLTR1_1_LTS1_15 (4U)   /*!< Bit field size in bits for DVFSC_DVFSLTR1_1_LTS1_15. */

/*! @brief Read current value of the DVFSC_DVFSLTR1_1_LTS1_15 field. */
#define BR_DVFSC_DVFSLTR1_1_LTS1_15(x) (HW_DVFSC_DVFSLTR1_1(x).B.LTS1_15)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSPT0 - DVFS pattern 0 length
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSPT0 - DVFS pattern 0 length (RW)
 *
 * Reset value: 0x00000010U
 */
typedef union _hw_dvfsc_dvfspt0
{
    uint32_t U;
    struct _hw_dvfsc_dvfspt0_bitfields
    {
        uint32_t FPTN0 : 17;           /*!< [16:0]  */
        uint32_t PT0A : 1;             /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_dvfsc_dvfspt0_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSPT0 register
 */
/*@{*/
#define HW_DVFSC_DVFSPT0_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_DVFSC_DVFSPT0(x)      (*(__IO hw_dvfsc_dvfspt0_t *) HW_DVFSC_DVFSPT0_ADDR(x))
#define HW_DVFSC_DVFSPT0_RD(x)   (HW_DVFSC_DVFSPT0(x).U)
#define HW_DVFSC_DVFSPT0_WR(x, v) (HW_DVFSC_DVFSPT0(x).U = (v))
#define HW_DVFSC_DVFSPT0_SET(x, v) (HW_DVFSC_DVFSPT0_WR(x, HW_DVFSC_DVFSPT0_RD(x) |  (v)))
#define HW_DVFSC_DVFSPT0_CLR(x, v) (HW_DVFSC_DVFSPT0_WR(x, HW_DVFSC_DVFSPT0_RD(x) & ~(v)))
#define HW_DVFSC_DVFSPT0_TOG(x, v) (HW_DVFSC_DVFSPT0_WR(x, HW_DVFSC_DVFSPT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSPT0 bitfields
 */

/*!
 * @name Register DVFSC_DVFSPT0, field FPTN0[16:0] (RW)
 *
 * FPTN0 - Frequency pattern 0 counter During period of this counter the
 * frequency will be reduced from the EMA-detected level.
 */
/*@{*/
#define BP_DVFSC_DVFSPT0_FPTN0 (0U)        /*!< Bit position for DVFSC_DVFSPT0_FPTN0. */
#define BM_DVFSC_DVFSPT0_FPTN0 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSPT0_FPTN0. */
#define BS_DVFSC_DVFSPT0_FPTN0 (17U)       /*!< Bit field size in bits for DVFSC_DVFSPT0_FPTN0. */

/*! @brief Read current value of the DVFSC_DVFSPT0_FPTN0 field. */
#define BR_DVFSC_DVFSPT0_FPTN0(x) (HW_DVFSC_DVFSPT0(x).B.FPTN0)

/*! @brief Format value for bitfield DVFSC_DVFSPT0_FPTN0. */
#define BF_DVFSC_DVFSPT0_FPTN0(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSPT0_FPTN0) & BM_DVFSC_DVFSPT0_FPTN0)

/*! @brief Set the FPTN0 field to a new value. */
#define BW_DVFSC_DVFSPT0_FPTN0(x, v) (HW_DVFSC_DVFSPT0_WR(x, (HW_DVFSC_DVFSPT0_RD(x) & ~BM_DVFSC_DVFSPT0_FPTN0) | BF_DVFSC_DVFSPT0_FPTN0(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSPT0, field PT0A[17] (RO)
 *
 * PT0A - Pattern 0 currently active (read-only)
 *
 * Values:
 * - 1 - active
 * - 0 - non-active
 */
/*@{*/
#define BP_DVFSC_DVFSPT0_PT0A (17U)        /*!< Bit position for DVFSC_DVFSPT0_PT0A. */
#define BM_DVFSC_DVFSPT0_PT0A (0x00020000U) /*!< Bit mask for DVFSC_DVFSPT0_PT0A. */
#define BS_DVFSC_DVFSPT0_PT0A (1U)         /*!< Bit field size in bits for DVFSC_DVFSPT0_PT0A. */

/*! @brief Read current value of the DVFSC_DVFSPT0_PT0A field. */
#define BR_DVFSC_DVFSPT0_PT0A(x) (HW_DVFSC_DVFSPT0(x).B.PT0A)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSPT1 - DVFS pattern 1 length
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSPT1 - DVFS pattern 1 length (RW)
 *
 * Reset value: 0x00000010U
 */
typedef union _hw_dvfsc_dvfspt1
{
    uint32_t U;
    struct _hw_dvfsc_dvfspt1_bitfields
    {
        uint32_t FPTN1 : 17;           /*!< [16:0]  */
        uint32_t PT1A : 1;             /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_dvfsc_dvfspt1_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSPT1 register
 */
/*@{*/
#define HW_DVFSC_DVFSPT1_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_DVFSC_DVFSPT1(x)      (*(__IO hw_dvfsc_dvfspt1_t *) HW_DVFSC_DVFSPT1_ADDR(x))
#define HW_DVFSC_DVFSPT1_RD(x)   (HW_DVFSC_DVFSPT1(x).U)
#define HW_DVFSC_DVFSPT1_WR(x, v) (HW_DVFSC_DVFSPT1(x).U = (v))
#define HW_DVFSC_DVFSPT1_SET(x, v) (HW_DVFSC_DVFSPT1_WR(x, HW_DVFSC_DVFSPT1_RD(x) |  (v)))
#define HW_DVFSC_DVFSPT1_CLR(x, v) (HW_DVFSC_DVFSPT1_WR(x, HW_DVFSC_DVFSPT1_RD(x) & ~(v)))
#define HW_DVFSC_DVFSPT1_TOG(x, v) (HW_DVFSC_DVFSPT1_WR(x, HW_DVFSC_DVFSPT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSPT1 bitfields
 */

/*!
 * @name Register DVFSC_DVFSPT1, field FPTN1[16:0] (RW)
 *
 * FPTN1 - Frequency pattern 1 counter During period of this counter the
 * frequency will be set to the EMA-detected level.
 */
/*@{*/
#define BP_DVFSC_DVFSPT1_FPTN1 (0U)        /*!< Bit position for DVFSC_DVFSPT1_FPTN1. */
#define BM_DVFSC_DVFSPT1_FPTN1 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSPT1_FPTN1. */
#define BS_DVFSC_DVFSPT1_FPTN1 (17U)       /*!< Bit field size in bits for DVFSC_DVFSPT1_FPTN1. */

/*! @brief Read current value of the DVFSC_DVFSPT1_FPTN1 field. */
#define BR_DVFSC_DVFSPT1_FPTN1(x) (HW_DVFSC_DVFSPT1(x).B.FPTN1)

/*! @brief Format value for bitfield DVFSC_DVFSPT1_FPTN1. */
#define BF_DVFSC_DVFSPT1_FPTN1(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSPT1_FPTN1) & BM_DVFSC_DVFSPT1_FPTN1)

/*! @brief Set the FPTN1 field to a new value. */
#define BW_DVFSC_DVFSPT1_FPTN1(x, v) (HW_DVFSC_DVFSPT1_WR(x, (HW_DVFSC_DVFSPT1_RD(x) & ~BM_DVFSC_DVFSPT1_FPTN1) | BF_DVFSC_DVFSPT1_FPTN1(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSPT1, field PT1A[17] (RO)
 *
 * PT1A - Pattern 1 currently active (read-only)
 *
 * Values:
 * - 1 - active
 * - 0 - non-active
 */
/*@{*/
#define BP_DVFSC_DVFSPT1_PT1A (17U)        /*!< Bit position for DVFSC_DVFSPT1_PT1A. */
#define BM_DVFSC_DVFSPT1_PT1A (0x00020000U) /*!< Bit mask for DVFSC_DVFSPT1_PT1A. */
#define BS_DVFSC_DVFSPT1_PT1A (1U)         /*!< Bit field size in bits for DVFSC_DVFSPT1_PT1A. */

/*! @brief Read current value of the DVFSC_DVFSPT1_PT1A field. */
#define BR_DVFSC_DVFSPT1_PT1A(x) (HW_DVFSC_DVFSPT1(x).B.PT1A)
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSPT2 - DVFS pattern 2 length
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSPT2 - DVFS pattern 2 length (RW)
 *
 * Reset value: 0x00000010U
 */
typedef union _hw_dvfsc_dvfspt2
{
    uint32_t U;
    struct _hw_dvfsc_dvfspt2_bitfields
    {
        uint32_t FPTN2 : 17;           /*!< [16:0]  */
        uint32_t PT2A : 1;             /*!< [17]  */
        uint32_t RESERVED0 : 8;        /*!< [25:18]  */
        uint32_t P2THR : 6;            /*!< [31:26]  */
    } B;
} hw_dvfsc_dvfspt2_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSPT2 register
 */
/*@{*/
#define HW_DVFSC_DVFSPT2_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_DVFSC_DVFSPT2(x)      (*(__IO hw_dvfsc_dvfspt2_t *) HW_DVFSC_DVFSPT2_ADDR(x))
#define HW_DVFSC_DVFSPT2_RD(x)   (HW_DVFSC_DVFSPT2(x).U)
#define HW_DVFSC_DVFSPT2_WR(x, v) (HW_DVFSC_DVFSPT2(x).U = (v))
#define HW_DVFSC_DVFSPT2_SET(x, v) (HW_DVFSC_DVFSPT2_WR(x, HW_DVFSC_DVFSPT2_RD(x) |  (v)))
#define HW_DVFSC_DVFSPT2_CLR(x, v) (HW_DVFSC_DVFSPT2_WR(x, HW_DVFSC_DVFSPT2_RD(x) & ~(v)))
#define HW_DVFSC_DVFSPT2_TOG(x, v) (HW_DVFSC_DVFSPT2_WR(x, HW_DVFSC_DVFSPT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSPT2 bitfields
 */

/*!
 * @name Register DVFSC_DVFSPT2, field FPTN2[16:0] (RW)
 *
 * FPTN2 - Frequency pattern 2 counter During period of this counter the
 * frequency will be increased to higher, than detected by the EMA-detected level.
 */
/*@{*/
#define BP_DVFSC_DVFSPT2_FPTN2 (0U)        /*!< Bit position for DVFSC_DVFSPT2_FPTN2. */
#define BM_DVFSC_DVFSPT2_FPTN2 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSPT2_FPTN2. */
#define BS_DVFSC_DVFSPT2_FPTN2 (17U)       /*!< Bit field size in bits for DVFSC_DVFSPT2_FPTN2. */

/*! @brief Read current value of the DVFSC_DVFSPT2_FPTN2 field. */
#define BR_DVFSC_DVFSPT2_FPTN2(x) (HW_DVFSC_DVFSPT2(x).B.FPTN2)

/*! @brief Format value for bitfield DVFSC_DVFSPT2_FPTN2. */
#define BF_DVFSC_DVFSPT2_FPTN2(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSPT2_FPTN2) & BM_DVFSC_DVFSPT2_FPTN2)

/*! @brief Set the FPTN2 field to a new value. */
#define BW_DVFSC_DVFSPT2_FPTN2(x, v) (HW_DVFSC_DVFSPT2_WR(x, (HW_DVFSC_DVFSPT2_RD(x) & ~BM_DVFSC_DVFSPT2_FPTN2) | BF_DVFSC_DVFSPT2_FPTN2(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSPT2, field PT2A[17] (RO)
 *
 * PT2A - Pattern 2 currently active (read-only)
 *
 * Values:
 * - 1 - active
 * - 0 - non-active
 */
/*@{*/
#define BP_DVFSC_DVFSPT2_PT2A (17U)        /*!< Bit position for DVFSC_DVFSPT2_PT2A. */
#define BM_DVFSC_DVFSPT2_PT2A (0x00020000U) /*!< Bit mask for DVFSC_DVFSPT2_PT2A. */
#define BS_DVFSC_DVFSPT2_PT2A (1U)         /*!< Bit field size in bits for DVFSC_DVFSPT2_PT2A. */

/*! @brief Read current value of the DVFSC_DVFSPT2_PT2A field. */
#define BR_DVFSC_DVFSPT2_PT2A(x) (HW_DVFSC_DVFSPT2(x).B.PT2A)
/*@}*/

/*!
 * @name Register DVFSC_DVFSPT2, field P2THR[31:26] (RW)
 *
 * P2THR - Pattern 2 Threshold Threshold of current DVFS load (after EMA), for
 * generating interrupts with PFUS indicators 110, 111. If the current performance
 * is greater than the P2THR value, the interrupts will be generated. Otherwise,
 * pattern delay will be counted, but without interrupt generation.
 */
/*@{*/
#define BP_DVFSC_DVFSPT2_P2THR (26U)       /*!< Bit position for DVFSC_DVFSPT2_P2THR. */
#define BM_DVFSC_DVFSPT2_P2THR (0xFC000000U) /*!< Bit mask for DVFSC_DVFSPT2_P2THR. */
#define BS_DVFSC_DVFSPT2_P2THR (6U)        /*!< Bit field size in bits for DVFSC_DVFSPT2_P2THR. */

/*! @brief Read current value of the DVFSC_DVFSPT2_P2THR field. */
#define BR_DVFSC_DVFSPT2_P2THR(x) (HW_DVFSC_DVFSPT2(x).B.P2THR)

/*! @brief Format value for bitfield DVFSC_DVFSPT2_P2THR. */
#define BF_DVFSC_DVFSPT2_P2THR(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSPT2_P2THR) & BM_DVFSC_DVFSPT2_P2THR)

/*! @brief Set the P2THR field to a new value. */
#define BW_DVFSC_DVFSPT2_P2THR(x, v) (HW_DVFSC_DVFSPT2_WR(x, (HW_DVFSC_DVFSPT2_RD(x) & ~BM_DVFSC_DVFSPT2_P2THR) | BF_DVFSC_DVFSPT2_P2THR(v)))
/*@}*/

/*******************************************************************************
 * HW_DVFSC_DVFSPT3 - DVFS pattern 3 length
 ******************************************************************************/

/*!
 * @brief HW_DVFSC_DVFSPT3 - DVFS pattern 3 length (RW)
 *
 * Reset value: 0x00000010U
 */
typedef union _hw_dvfsc_dvfspt3
{
    uint32_t U;
    struct _hw_dvfsc_dvfspt3_bitfields
    {
        uint32_t FPTN3 : 17;           /*!< [16:0]  */
        uint32_t PT3A : 1;             /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_dvfsc_dvfspt3_t;

/*!
 * @name Constants and macros for entire DVFSC_DVFSPT3 register
 */
/*@{*/
#define HW_DVFSC_DVFSPT3_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_DVFSC_DVFSPT3(x)      (*(__IO hw_dvfsc_dvfspt3_t *) HW_DVFSC_DVFSPT3_ADDR(x))
#define HW_DVFSC_DVFSPT3_RD(x)   (HW_DVFSC_DVFSPT3(x).U)
#define HW_DVFSC_DVFSPT3_WR(x, v) (HW_DVFSC_DVFSPT3(x).U = (v))
#define HW_DVFSC_DVFSPT3_SET(x, v) (HW_DVFSC_DVFSPT3_WR(x, HW_DVFSC_DVFSPT3_RD(x) |  (v)))
#define HW_DVFSC_DVFSPT3_CLR(x, v) (HW_DVFSC_DVFSPT3_WR(x, HW_DVFSC_DVFSPT3_RD(x) & ~(v)))
#define HW_DVFSC_DVFSPT3_TOG(x, v) (HW_DVFSC_DVFSPT3_WR(x, HW_DVFSC_DVFSPT3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual DVFSC_DVFSPT3 bitfields
 */

/*!
 * @name Register DVFSC_DVFSPT3, field FPTN3[16:0] (RW)
 *
 * FPTN3 - Frequency pattern 3 counter During period of this counter the
 * frequency will be set to the EMA-detected level.
 */
/*@{*/
#define BP_DVFSC_DVFSPT3_FPTN3 (0U)        /*!< Bit position for DVFSC_DVFSPT3_FPTN3. */
#define BM_DVFSC_DVFSPT3_FPTN3 (0x0001FFFFU) /*!< Bit mask for DVFSC_DVFSPT3_FPTN3. */
#define BS_DVFSC_DVFSPT3_FPTN3 (17U)       /*!< Bit field size in bits for DVFSC_DVFSPT3_FPTN3. */

/*! @brief Read current value of the DVFSC_DVFSPT3_FPTN3 field. */
#define BR_DVFSC_DVFSPT3_FPTN3(x) (HW_DVFSC_DVFSPT3(x).B.FPTN3)

/*! @brief Format value for bitfield DVFSC_DVFSPT3_FPTN3. */
#define BF_DVFSC_DVFSPT3_FPTN3(v) ((uint32_t)((uint32_t)(v) << BP_DVFSC_DVFSPT3_FPTN3) & BM_DVFSC_DVFSPT3_FPTN3)

/*! @brief Set the FPTN3 field to a new value. */
#define BW_DVFSC_DVFSPT3_FPTN3(x, v) (HW_DVFSC_DVFSPT3_WR(x, (HW_DVFSC_DVFSPT3_RD(x) & ~BM_DVFSC_DVFSPT3_FPTN3) | BF_DVFSC_DVFSPT3_FPTN3(v)))
/*@}*/

/*!
 * @name Register DVFSC_DVFSPT3, field PT3A[17] (RO)
 *
 * PT3A - Pattern 3 currently active (read-only)
 *
 * Values:
 * - 1 - active
 * - 0 - non-active
 */
/*@{*/
#define BP_DVFSC_DVFSPT3_PT3A (17U)        /*!< Bit position for DVFSC_DVFSPT3_PT3A. */
#define BM_DVFSC_DVFSPT3_PT3A (0x00020000U) /*!< Bit mask for DVFSC_DVFSPT3_PT3A. */
#define BS_DVFSC_DVFSPT3_PT3A (1U)         /*!< Bit field size in bits for DVFSC_DVFSPT3_PT3A. */

/*! @brief Read current value of the DVFSC_DVFSPT3_PT3A field. */
#define BR_DVFSC_DVFSPT3_PT3A(x) (HW_DVFSC_DVFSPT3(x).B.PT3A)
/*@}*/

/*******************************************************************************
 * hw_dvfsc_t - module struct
 ******************************************************************************/
/*!
 * @brief All DVFSC module registers.
 */
#pragma pack(1)
typedef struct _hw_dvfsc
{
    __IO hw_dvfsc_thrs_t THRS;             /*!< [0x0] DVFS Thresholds */
    __IO hw_dvfsc_coun_t COUN;             /*!< [0x4] DVFS Counters thresholds */
    __IO hw_dvfsc_sig1_t SIG1;             /*!< [0x8] DVFS general purpose bits weight */
    __IO hw_dvfsc_dvfssig0_t DVFSSIG0;     /*!< [0xC] DVFS general purpose bits weight */
    __IO hw_dvfsc_dvfsgpc0_t DVFSGPC0;     /*!< [0x10] DVFS general purpose bit 0 weight counter */
    __IO hw_dvfsc_dvfsgpc1_t DVFSGPC1;     /*!< [0x14] DVFS general purpose bit 1 weight counter */
    __IO hw_dvfsc_dvfsgpbt_t DVFSGPBT;     /*!< [0x18] DVFS general purpose bits enables */
    __IO hw_dvfsc_dvfsemac_t DVFSEMAC;     /*!< [0x1C] DVFS EMAC settings */
    __IO hw_dvfsc_cntr_t CNTR;             /*!< [0x20] DVFS Control */
    __I hw_dvfsc_dvfsltr0_0_t DVFSLTR0_0;  /*!< [0x24] DVFS Load Tracking Register 0, portion 0 */
    __I hw_dvfsc_dvfsltr0_1_t DVFSLTR0_1;  /*!< [0x28] DVFS Load Tracking Register 0, portion 1 */
    __I hw_dvfsc_dvfsltr1_0_t DVFSLTR1_0;  /*!< [0x2C] DVFS Load Tracking Register 1, portion 0 */
    __I hw_dvfsc_dvfsltr1_1_t DVFSLTR1_1;  /*!< [0x30] DVFS Load Tracking Register 3, portion 1 */
    __IO hw_dvfsc_dvfspt0_t DVFSPT0;       /*!< [0x34] DVFS pattern 0 length */
    __IO hw_dvfsc_dvfspt1_t DVFSPT1;       /*!< [0x38] DVFS pattern 1 length */
    __IO hw_dvfsc_dvfspt2_t DVFSPT2;       /*!< [0x3C] DVFS pattern 2 length */
    __IO hw_dvfsc_dvfspt3_t DVFSPT3;       /*!< [0x40] DVFS pattern 3 length */
} hw_dvfsc_t;
#pragma pack()

/*! @brief Macro to access all DVFSC registers. */
/*! @param x DVFSC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_DVFSC_REGS(DVFSC_BASE)</code>. */
#define HW_DVFSC_REGS(x) (*(hw_dvfsc_t *)(x))

/*
 * iMX6DP ECSPI
 *
 * ECSPI
 *
 * Registers defined in this header file:
 * - HW_ECSPI_RXDATA - Receive Data Register
 * - HW_ECSPI_TXDATA - Transmit Data Register
 * - HW_ECSPI_CONREG - Control Register
 * - HW_ECSPI_CONFIGREG - Config Register
 * - HW_ECSPI_INTREG - Interrupt Control Register
 * - HW_ECSPI_DMAREG - DMA Control Register
 * - HW_ECSPI_STATREG - Status Register
 * - HW_ECSPI_PERIODREG - Sample Period Control Register
 * - HW_ECSPI_TESTREG - Test Control Register
 * - HW_ECSPI_MSGDATA - Message Data Register
 *
 * - hw_ecspi_t - Struct containing all module registers.
 */

#define HW_ECSPI_INSTANCE_COUNT (5U) /*!< Number of instances of the ECSPI module. */
#define HW_ECSPI1 (0U) /*!< Instance number for ECSPI1. */
#define HW_ECSPI2 (1U) /*!< Instance number for ECSPI2. */
#define HW_ECSPI3 (2U) /*!< Instance number for ECSPI3. */
#define HW_ECSPI4 (3U) /*!< Instance number for ECSPI4. */
#define HW_ECSPI5 (4U) /*!< Instance number for ECSPI5. */
#define ECSPI1_BASE           (0x2008000U) /*!< Base address for ECSPI1. */
#define ECSPI2_BASE           (0x200C000U) /*!< Base address for ECSPI2. */
#define ECSPI3_BASE           (0x2010000U) /*!< Base address for ECSPI3. */
#define ECSPI4_BASE           (0x2014000U) /*!< Base address for ECSPI4. */
#define ECSPI5_BASE           (0x2018000U) /*!< Base address for ECSPI5. */
/*! Array initializer of ECSPI base addresses. */
#define ECSPI_BASE_ADDRS      { ECSPI1_BASE, ECSPI2_BASE, ECSPI3_BASE, ECSPI4_BASE, ECSPI5_BASE }

/*******************************************************************************
 * HW_ECSPI_RXDATA - Receive Data Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_RXDATA - Receive Data Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The Receive Data register (ECSPI_RXDATA) is a read-only register that forms
 * the top word of the 64 x 32 receive FIFO. This register holds the data received
 * from an external SPI device during a data transaction. Only word-sized read
 * operations are allowed.
 */
typedef union _hw_ecspi_rxdata
{
    uint32_t U;
    struct _hw_ecspi_rxdata_bitfields
    {
        uint32_t ECSPI_RXDATA : 32;    /*!< [31:0]  */
    } B;
} hw_ecspi_rxdata_t;

/*!
 * @name Constants and macros for entire ECSPI_RXDATA register
 */
/*@{*/
#define HW_ECSPI_RXDATA_ADDR(x)  ((uintptr_t)(x) + 0x0U)

#define HW_ECSPI_RXDATA(x)       (*(__I hw_ecspi_rxdata_t *) HW_ECSPI_RXDATA_ADDR(x))
#define HW_ECSPI_RXDATA_RD(x)    (HW_ECSPI_RXDATA(x).U)
/*@}*/

/*
 * Constants & macros for individual ECSPI_RXDATA bitfields
 */

/*!
 * @name Register ECSPI_RXDATA, field ECSPI_RXDATA[31:0] (RO)
 *
 * Receive Data. This register holds the top word of the receive data FIFO. The
 * FIFO is advanced for each read of this register. The data read is undefined
 * when the Receive Data Ready (RR) bit in the Interrupt Control/Status register is
 * cleared. Zeros are read when ECSPI is disabled.
 */
/*@{*/
#define BP_ECSPI_RXDATA_ECSPI_RXDATA (0U)  /*!< Bit position for ECSPI_RXDATA_ECSPI_RXDATA. */
#define BM_ECSPI_RXDATA_ECSPI_RXDATA (0xFFFFFFFFU) /*!< Bit mask for ECSPI_RXDATA_ECSPI_RXDATA. */
#define BS_ECSPI_RXDATA_ECSPI_RXDATA (32U) /*!< Bit field size in bits for ECSPI_RXDATA_ECSPI_RXDATA. */

/*! @brief Read current value of the ECSPI_RXDATA_ECSPI_RXDATA field. */
#define BR_ECSPI_RXDATA_ECSPI_RXDATA(x) (HW_ECSPI_RXDATA(x).U)
/*@}*/

/*******************************************************************************
 * HW_ECSPI_TXDATA - Transmit Data Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_TXDATA - Transmit Data Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The Transmit Data (ECSPI_TXDATA) register is a write-only data register that
 * forms the bottom word of the 64 x 32 TXFIFO. The TXFIFO can be written to as
 * long as it is not full, even when the SPI Exchange bit (XCH) in ECSPI_CONREG is
 * set. This allows software to write to the TXFIFO during a SPI data exchange
 * process. Writes to this register are ignored when the ECSPI is disabled
 * (ECSPI_CONREG[EN] bit is cleared).
 */
typedef union _hw_ecspi_txdata
{
    uint32_t U;
    struct _hw_ecspi_txdata_bitfields
    {
        uint32_t ECSPI_TXDATA : 32;    /*!< [31:0]  */
    } B;
} hw_ecspi_txdata_t;

/*!
 * @name Constants and macros for entire ECSPI_TXDATA register
 */
/*@{*/
#define HW_ECSPI_TXDATA_ADDR(x)  ((uintptr_t)(x) + 0x4U)

#define HW_ECSPI_TXDATA(x)       (*(__O hw_ecspi_txdata_t *) HW_ECSPI_TXDATA_ADDR(x))
#define HW_ECSPI_TXDATA_WR(x, v) (HW_ECSPI_TXDATA(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual ECSPI_TXDATA bitfields
 */

/*!
 * @name Register ECSPI_TXDATA, field ECSPI_TXDATA[31:0] (WO)
 *
 * Transmit Data. This register holds the top word of data loaded into the FIFO.
 * Data written to this register must be a word operation. The number of bits
 * actually transmitted is determined by the BURST_LENGTH field of the
 * corresponding SPI Control register. If this field contains more bits than the number
 * specified by BURST_LENGTH, the extra bits are ignored. For example, to transfer 10
 * bits of data, a 32-bit word must be written to this register. Bits 9-0 are
 * shifted out and bits 31-10 are ignored. When the ECSPI is operating in Slave
 * mode, zeros are shifted out when the FIFO is empty. Zeros are read when ECSPI is
 * disabled.
 */
/*@{*/
#define BP_ECSPI_TXDATA_ECSPI_TXDATA (0U)  /*!< Bit position for ECSPI_TXDATA_ECSPI_TXDATA. */
#define BM_ECSPI_TXDATA_ECSPI_TXDATA (0xFFFFFFFFU) /*!< Bit mask for ECSPI_TXDATA_ECSPI_TXDATA. */
#define BS_ECSPI_TXDATA_ECSPI_TXDATA (32U) /*!< Bit field size in bits for ECSPI_TXDATA_ECSPI_TXDATA. */

/*! @brief Format value for bitfield ECSPI_TXDATA_ECSPI_TXDATA. */
#define BF_ECSPI_TXDATA_ECSPI_TXDATA(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_TXDATA_ECSPI_TXDATA) & BM_ECSPI_TXDATA_ECSPI_TXDATA)
/*@}*/

/*******************************************************************************
 * HW_ECSPI_CONREG - Control Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_CONREG - Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Control Register (ECSPI_CONREG) allows software to enable the ECSPI ,
 * configure its operating modes, specify the divider value, and SPI_RDY control
 * signal, and define the transfer length.
 */
typedef union _hw_ecspi_conreg
{
    uint32_t U;
    struct _hw_ecspi_conreg_bitfields
    {
        uint32_t EN : 1;               /*!< [0]  */
        uint32_t HT : 1;               /*!< [1]  */
        uint32_t XCH : 1;              /*!< [2]  */
        uint32_t SMC : 1;              /*!< [3]  */
        uint32_t CHANNEL_MODE : 4;     /*!< [7:4]  */
        uint32_t POST_DIVIDER : 4;     /*!< [11:8]  */
        uint32_t PRE_DIVIDER : 4;      /*!< [15:12]  */
        uint32_t DRCTL : 2;            /*!< [17:16]  */
        uint32_t CHANNEL_SELECT : 2;   /*!< [19:18]  */
        uint32_t BURST_LENGTH : 12;    /*!< [31:20]  */
    } B;
} hw_ecspi_conreg_t;

/*!
 * @name Constants and macros for entire ECSPI_CONREG register
 */
/*@{*/
#define HW_ECSPI_CONREG_ADDR(x)  ((uintptr_t)(x) + 0x8U)

#define HW_ECSPI_CONREG(x)       (*(__IO hw_ecspi_conreg_t *) HW_ECSPI_CONREG_ADDR(x))
#define HW_ECSPI_CONREG_RD(x)    (HW_ECSPI_CONREG(x).U)
#define HW_ECSPI_CONREG_WR(x, v) (HW_ECSPI_CONREG(x).U = (v))
#define HW_ECSPI_CONREG_SET(x, v) (HW_ECSPI_CONREG_WR(x, HW_ECSPI_CONREG_RD(x) |  (v)))
#define HW_ECSPI_CONREG_CLR(x, v) (HW_ECSPI_CONREG_WR(x, HW_ECSPI_CONREG_RD(x) & ~(v)))
#define HW_ECSPI_CONREG_TOG(x, v) (HW_ECSPI_CONREG_WR(x, HW_ECSPI_CONREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_CONREG bitfields
 */

/*!
 * @name Register ECSPI_CONREG, field EN[0] (RW)
 *
 * SPI Block Enable Control. This bit enables the ECSPI. This bit must be set
 * before writing to other registers or initiating an exchange. Writing zero to
 * this bit disables the block and resets the internal logic with the exception of
 * the ECSPI_CONREG. The block's internal clocks are gated off whenever the block
 * is disabled.
 *
 * Values:
 * - 0 - Disable the block.
 * - 1 - Enable the block.
 */
/*@{*/
#define BP_ECSPI_CONREG_EN   (0U)          /*!< Bit position for ECSPI_CONREG_EN. */
#define BM_ECSPI_CONREG_EN   (0x00000001U) /*!< Bit mask for ECSPI_CONREG_EN. */
#define BS_ECSPI_CONREG_EN   (1U)          /*!< Bit field size in bits for ECSPI_CONREG_EN. */

/*! @brief Read current value of the ECSPI_CONREG_EN field. */
#define BR_ECSPI_CONREG_EN(x) (HW_ECSPI_CONREG(x).B.EN)

/*! @brief Format value for bitfield ECSPI_CONREG_EN. */
#define BF_ECSPI_CONREG_EN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_EN) & BM_ECSPI_CONREG_EN)

/*! @brief Set the EN field to a new value. */
#define BW_ECSPI_CONREG_EN(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_EN) | BF_ECSPI_CONREG_EN(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field HT[1] (RW)
 *
 * Hardware Trigger Enable. This bit is used in master mode only. It enables
 * hardware trigger (HT) mode. Note, HT mode is not supported by this product.
 *
 * Values:
 * - 0 - Disable HT mode.
 * - 1 - Enable HT mode.
 */
/*@{*/
#define BP_ECSPI_CONREG_HT   (1U)          /*!< Bit position for ECSPI_CONREG_HT. */
#define BM_ECSPI_CONREG_HT   (0x00000002U) /*!< Bit mask for ECSPI_CONREG_HT. */
#define BS_ECSPI_CONREG_HT   (1U)          /*!< Bit field size in bits for ECSPI_CONREG_HT. */

/*! @brief Read current value of the ECSPI_CONREG_HT field. */
#define BR_ECSPI_CONREG_HT(x) (HW_ECSPI_CONREG(x).B.HT)

/*! @brief Format value for bitfield ECSPI_CONREG_HT. */
#define BF_ECSPI_CONREG_HT(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_HT) & BM_ECSPI_CONREG_HT)

/*! @brief Set the HT field to a new value. */
#define BW_ECSPI_CONREG_HT(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_HT) | BF_ECSPI_CONREG_HT(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field XCH[2] (RW)
 *
 * SPI Exchange Bit. This bit applies only to channels configured in Master mode
 * (CHANNEL MODE = 1). If the Start Mode Control (SMC) bit is cleared, writing a
 * 1 to this bit starts one SPI burst or multiple SPI bursts according to the
 * SPI SS Wave Form Select (SS_CTL). The XCH bit remains set while either the data
 * exchange is in progress, or when the ECSPI is waiting for an active input if
 * SPIRDY is enabled through DRCTL. This bit is cleared automatically when all
 * data in the TXFIFO and the shift register has been shifted out.
 *
 * Values:
 * - 0 - Idle.
 * - 1 - Initiates exchange (write) or busy (read).
 */
/*@{*/
#define BP_ECSPI_CONREG_XCH  (2U)          /*!< Bit position for ECSPI_CONREG_XCH. */
#define BM_ECSPI_CONREG_XCH  (0x00000004U) /*!< Bit mask for ECSPI_CONREG_XCH. */
#define BS_ECSPI_CONREG_XCH  (1U)          /*!< Bit field size in bits for ECSPI_CONREG_XCH. */

/*! @brief Read current value of the ECSPI_CONREG_XCH field. */
#define BR_ECSPI_CONREG_XCH(x) (HW_ECSPI_CONREG(x).B.XCH)

/*! @brief Format value for bitfield ECSPI_CONREG_XCH. */
#define BF_ECSPI_CONREG_XCH(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_XCH) & BM_ECSPI_CONREG_XCH)

/*! @brief Set the XCH field to a new value. */
#define BW_ECSPI_CONREG_XCH(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_XCH) | BF_ECSPI_CONREG_XCH(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field SMC[3] (RW)
 *
 * Start Mode Control. This bit applies only to channels configured in Master
 * mode (CHANNEL MODE = 1). It controls how the ECSPI starts a SPI burst, either
 * through the SPI exchange bit, or immediately when the TXFIFO is written to.
 *
 * Values:
 * - 0 - SPI Exchange Bit (XCH) controls when a SPI burst can start. Setting the
 *     XCH bit will start a SPI burst or multiple bursts. This is controlled by
 *     the SPI SS Wave Form Select (SS_CTL). Refer to XCH and SS_CTL descriptions.
 * - 1 - Immediately starts a SPI burst when data is written in TXFIFO.
 */
/*@{*/
#define BP_ECSPI_CONREG_SMC  (3U)          /*!< Bit position for ECSPI_CONREG_SMC. */
#define BM_ECSPI_CONREG_SMC  (0x00000008U) /*!< Bit mask for ECSPI_CONREG_SMC. */
#define BS_ECSPI_CONREG_SMC  (1U)          /*!< Bit field size in bits for ECSPI_CONREG_SMC. */

/*! @brief Read current value of the ECSPI_CONREG_SMC field. */
#define BR_ECSPI_CONREG_SMC(x) (HW_ECSPI_CONREG(x).B.SMC)

/*! @brief Format value for bitfield ECSPI_CONREG_SMC. */
#define BF_ECSPI_CONREG_SMC(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_SMC) & BM_ECSPI_CONREG_SMC)

/*! @brief Set the SMC field to a new value. */
#define BW_ECSPI_CONREG_SMC(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_SMC) | BF_ECSPI_CONREG_SMC(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field CHANNEL_MODE[7:4] (RW)
 *
 * SPI CHANNEL MODE selects the mode for each SPI channel. CHANNEL MODE[3] is
 * for SPI channel 3. CHANNEL MODE[2] is for SPI channel 2. CHANNEL MODE[1] is for
 * SPI channel 1. CHANNEL MODE[0] is for SPI channel 0.
 *
 * Values:
 * - 0 - Slave mode.
 * - 1 - Master mode.
 */
/*@{*/
#define BP_ECSPI_CONREG_CHANNEL_MODE (4U)  /*!< Bit position for ECSPI_CONREG_CHANNEL_MODE. */
#define BM_ECSPI_CONREG_CHANNEL_MODE (0x000000F0U) /*!< Bit mask for ECSPI_CONREG_CHANNEL_MODE. */
#define BS_ECSPI_CONREG_CHANNEL_MODE (4U)  /*!< Bit field size in bits for ECSPI_CONREG_CHANNEL_MODE. */

/*! @brief Read current value of the ECSPI_CONREG_CHANNEL_MODE field. */
#define BR_ECSPI_CONREG_CHANNEL_MODE(x) (HW_ECSPI_CONREG(x).B.CHANNEL_MODE)

/*! @brief Format value for bitfield ECSPI_CONREG_CHANNEL_MODE. */
#define BF_ECSPI_CONREG_CHANNEL_MODE(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_CHANNEL_MODE) & BM_ECSPI_CONREG_CHANNEL_MODE)

/*! @brief Set the CHANNEL_MODE field to a new value. */
#define BW_ECSPI_CONREG_CHANNEL_MODE(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_CHANNEL_MODE) | BF_ECSPI_CONREG_CHANNEL_MODE(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field POST_DIVIDER[11:8] (RW)
 *
 * SPI Post Divider. ECSPI uses a two-stage divider to generate the SPI clock.
 * This field defines the post-divider of the reference clock using the equation:
 * 2 n .
 *
 * Values:
 * - 0000 - Divide by 1.
 * - 0001 - Divide by 2.
 * - 0010 - Divide by 4.
 * - 1110 - Divide by 2 14 .
 * - 1111 - Divide by 2 15 .
 */
/*@{*/
#define BP_ECSPI_CONREG_POST_DIVIDER (8U)  /*!< Bit position for ECSPI_CONREG_POST_DIVIDER. */
#define BM_ECSPI_CONREG_POST_DIVIDER (0x00000F00U) /*!< Bit mask for ECSPI_CONREG_POST_DIVIDER. */
#define BS_ECSPI_CONREG_POST_DIVIDER (4U)  /*!< Bit field size in bits for ECSPI_CONREG_POST_DIVIDER. */

/*! @brief Read current value of the ECSPI_CONREG_POST_DIVIDER field. */
#define BR_ECSPI_CONREG_POST_DIVIDER(x) (HW_ECSPI_CONREG(x).B.POST_DIVIDER)

/*! @brief Format value for bitfield ECSPI_CONREG_POST_DIVIDER. */
#define BF_ECSPI_CONREG_POST_DIVIDER(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_POST_DIVIDER) & BM_ECSPI_CONREG_POST_DIVIDER)

/*! @brief Set the POST_DIVIDER field to a new value. */
#define BW_ECSPI_CONREG_POST_DIVIDER(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_POST_DIVIDER) | BF_ECSPI_CONREG_POST_DIVIDER(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field PRE_DIVIDER[15:12] (RW)
 *
 * SPI Pre Divider. ECSPI uses a two-stage divider to generate the SPI clock.
 * This field defines the pre-divider of the reference clock.
 *
 * Values:
 * - 0000 - Divide by 1.
 * - 0001 - Divide by 2.
 * - 0010 - Divide by 3.
 * - 1101 - Divide by 14.
 * - 1110 - Divide by 15.
 * - 1111 - Divide by 16.
 */
/*@{*/
#define BP_ECSPI_CONREG_PRE_DIVIDER (12U)  /*!< Bit position for ECSPI_CONREG_PRE_DIVIDER. */
#define BM_ECSPI_CONREG_PRE_DIVIDER (0x0000F000U) /*!< Bit mask for ECSPI_CONREG_PRE_DIVIDER. */
#define BS_ECSPI_CONREG_PRE_DIVIDER (4U)   /*!< Bit field size in bits for ECSPI_CONREG_PRE_DIVIDER. */

/*! @brief Read current value of the ECSPI_CONREG_PRE_DIVIDER field. */
#define BR_ECSPI_CONREG_PRE_DIVIDER(x) (HW_ECSPI_CONREG(x).B.PRE_DIVIDER)

/*! @brief Format value for bitfield ECSPI_CONREG_PRE_DIVIDER. */
#define BF_ECSPI_CONREG_PRE_DIVIDER(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_PRE_DIVIDER) & BM_ECSPI_CONREG_PRE_DIVIDER)

/*! @brief Set the PRE_DIVIDER field to a new value. */
#define BW_ECSPI_CONREG_PRE_DIVIDER(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_PRE_DIVIDER) | BF_ECSPI_CONREG_PRE_DIVIDER(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field DRCTL[17:16] (RW)
 *
 * SPI Data Ready Control. This field selects the utilization of the SPI_RDY
 * signal in master mode. ECSPI checks this field before it starts an SPI burst.
 *
 * Values:
 * - 00 - The SPI_RDY signal is a don't care.
 * - 01 - Burst will be triggered by the falling edge of the SPI_RDY signal
 *     (edge-triggered).
 * - 10 - Burst will be triggered by a low level of the SPI_RDY signal
 *     (level-triggered).
 * - 11 - Reserved.
 */
/*@{*/
#define BP_ECSPI_CONREG_DRCTL (16U)        /*!< Bit position for ECSPI_CONREG_DRCTL. */
#define BM_ECSPI_CONREG_DRCTL (0x00030000U) /*!< Bit mask for ECSPI_CONREG_DRCTL. */
#define BS_ECSPI_CONREG_DRCTL (2U)         /*!< Bit field size in bits for ECSPI_CONREG_DRCTL. */

/*! @brief Read current value of the ECSPI_CONREG_DRCTL field. */
#define BR_ECSPI_CONREG_DRCTL(x) (HW_ECSPI_CONREG(x).B.DRCTL)

/*! @brief Format value for bitfield ECSPI_CONREG_DRCTL. */
#define BF_ECSPI_CONREG_DRCTL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_DRCTL) & BM_ECSPI_CONREG_DRCTL)

/*! @brief Set the DRCTL field to a new value. */
#define BW_ECSPI_CONREG_DRCTL(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_DRCTL) | BF_ECSPI_CONREG_DRCTL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field CHANNEL_SELECT[19:18] (RW)
 *
 * SPI CHANNEL SELECT bits. Select one of four external SPI Master/Slave
 * Devices. In master mode, these two bits select the external slave devices by
 * asserting the Chip Select (SSn) outputs. Only the selected Chip Select (SSn) signal
 * can be active at a given time; the remaining three signals will be negated.
 *
 * Values:
 * - 00 - Channel 0 is selected. Chip Select 0 (SS0) will be asserted.
 * - 01 - Channel 1 is selected. Chip Select 1 (SS1) will be asserted.
 * - 10 - Channel 2 is selected. Chip Select 2 (SS2) will be asserted.
 * - 11 - Channel 3 is selected. Chip Select 3 (SS3) will be asserted.
 */
/*@{*/
#define BP_ECSPI_CONREG_CHANNEL_SELECT (18U) /*!< Bit position for ECSPI_CONREG_CHANNEL_SELECT. */
#define BM_ECSPI_CONREG_CHANNEL_SELECT (0x000C0000U) /*!< Bit mask for ECSPI_CONREG_CHANNEL_SELECT. */
#define BS_ECSPI_CONREG_CHANNEL_SELECT (2U) /*!< Bit field size in bits for ECSPI_CONREG_CHANNEL_SELECT. */

/*! @brief Read current value of the ECSPI_CONREG_CHANNEL_SELECT field. */
#define BR_ECSPI_CONREG_CHANNEL_SELECT(x) (HW_ECSPI_CONREG(x).B.CHANNEL_SELECT)

/*! @brief Format value for bitfield ECSPI_CONREG_CHANNEL_SELECT. */
#define BF_ECSPI_CONREG_CHANNEL_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_CHANNEL_SELECT) & BM_ECSPI_CONREG_CHANNEL_SELECT)

/*! @brief Set the CHANNEL_SELECT field to a new value. */
#define BW_ECSPI_CONREG_CHANNEL_SELECT(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_CHANNEL_SELECT) | BF_ECSPI_CONREG_CHANNEL_SELECT(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONREG, field BURST_LENGTH[31:20] (RW)
 *
 * Burst Length. This field defines the length of a SPI burst to be transferred.
 * The Chip Select (SS) will remain asserted until all bits in a SPI burst are
 * shifted out. A maximum of 2^12 bits can be transferred in a single SPI burst.
 * In master mode, it controls the number of bits per SPI burst. Since the shift
 * register always loads 32-bit data from transmit FIFO, only the n
 * least-significant (n = BURST LENGTH + 1) will be shifted out. The remaining bits will be
 * ignored. In slave mode, only when SS_CTL is cleared, this field will take effect
 * in the transfer. Number of Valid Bits in a SPI burst.
 *
 * Values:
 * - 0 - A SPI burst contains the 1 LSB in a word.
 * - 1 - A SPI burst contains the 2 LSB in a word.
 * - 10 - A SPI burst contains the 3 LSB in a word.
 * - 11111 - A SPI burst contains all 32 bits in a word.
 * - 100000 - A SPI burst contains the 1 LSB in first word and all 32 bits in
 *     second word.
 * - 100001 - A SPI burst contains the 2 LSB in first word and all 32 bits in
 *     second word.
 * - 111111111110 - A SPI burst contains the 31 LSB in first word and 2^7 -1
 *     words.
 * - 111111111111 - A SPI burst contains 2^7 words.
 */
/*@{*/
#define BP_ECSPI_CONREG_BURST_LENGTH (20U) /*!< Bit position for ECSPI_CONREG_BURST_LENGTH. */
#define BM_ECSPI_CONREG_BURST_LENGTH (0xFFF00000U) /*!< Bit mask for ECSPI_CONREG_BURST_LENGTH. */
#define BS_ECSPI_CONREG_BURST_LENGTH (12U) /*!< Bit field size in bits for ECSPI_CONREG_BURST_LENGTH. */

/*! @brief Read current value of the ECSPI_CONREG_BURST_LENGTH field. */
#define BR_ECSPI_CONREG_BURST_LENGTH(x) (HW_ECSPI_CONREG(x).B.BURST_LENGTH)

/*! @brief Format value for bitfield ECSPI_CONREG_BURST_LENGTH. */
#define BF_ECSPI_CONREG_BURST_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONREG_BURST_LENGTH) & BM_ECSPI_CONREG_BURST_LENGTH)

/*! @brief Set the BURST_LENGTH field to a new value. */
#define BW_ECSPI_CONREG_BURST_LENGTH(x, v) (HW_ECSPI_CONREG_WR(x, (HW_ECSPI_CONREG_RD(x) & ~BM_ECSPI_CONREG_BURST_LENGTH) | BF_ECSPI_CONREG_BURST_LENGTH(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_CONFIGREG - Config Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_CONFIGREG - Config Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Config Register (ECSPI_CONFIGREG) allows software to configure each SPI
 * channel, configure its operating modes, specify the phase and polarity of the
 * clock, configure the Chip Select (SS), and define the HT transfer length. Note,
 * HT mode is not supported by this product.
 */
typedef union _hw_ecspi_configreg
{
    uint32_t U;
    struct _hw_ecspi_configreg_bitfields
    {
        uint32_t SCLK_PHA : 4;         /*!< [3:0]  */
        uint32_t SCLK_POL : 4;         /*!< [7:4]  */
        uint32_t SS_CTL : 4;           /*!< [11:8]  */
        uint32_t SS_POL : 4;           /*!< [15:12]  */
        uint32_t DATA_CTL : 4;         /*!< [19:16]  */
        uint32_t SCLK_CTL : 4;         /*!< [23:20]  */
        uint32_t HT_LENGTH : 5;        /*!< [28:24]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ecspi_configreg_t;

/*!
 * @name Constants and macros for entire ECSPI_CONFIGREG register
 */
/*@{*/
#define HW_ECSPI_CONFIGREG_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_ECSPI_CONFIGREG(x)    (*(__IO hw_ecspi_configreg_t *) HW_ECSPI_CONFIGREG_ADDR(x))
#define HW_ECSPI_CONFIGREG_RD(x) (HW_ECSPI_CONFIGREG(x).U)
#define HW_ECSPI_CONFIGREG_WR(x, v) (HW_ECSPI_CONFIGREG(x).U = (v))
#define HW_ECSPI_CONFIGREG_SET(x, v) (HW_ECSPI_CONFIGREG_WR(x, HW_ECSPI_CONFIGREG_RD(x) |  (v)))
#define HW_ECSPI_CONFIGREG_CLR(x, v) (HW_ECSPI_CONFIGREG_WR(x, HW_ECSPI_CONFIGREG_RD(x) & ~(v)))
#define HW_ECSPI_CONFIGREG_TOG(x, v) (HW_ECSPI_CONFIGREG_WR(x, HW_ECSPI_CONFIGREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_CONFIGREG bitfields
 */

/*!
 * @name Register ECSPI_CONFIGREG, field SCLK_PHA[3:0] (RW)
 *
 * SPI Clock/Data Phase Control. This field controls the clock/data phase
 * relationship. See for more information. SCLK PHA[3] is for SPI channel 3. SCLK
 * PHA[2] is for SPI channel 2. SCLK PHA[1] is for SPI channel 1. SCLK PHA[0] is for
 * SPI channel 0.
 *
 * Values:
 * - 0 - Phase 0 operation.
 * - 1 - Phase 1 operation.
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_SCLK_PHA (0U)   /*!< Bit position for ECSPI_CONFIGREG_SCLK_PHA. */
#define BM_ECSPI_CONFIGREG_SCLK_PHA (0x0000000FU) /*!< Bit mask for ECSPI_CONFIGREG_SCLK_PHA. */
#define BS_ECSPI_CONFIGREG_SCLK_PHA (4U)   /*!< Bit field size in bits for ECSPI_CONFIGREG_SCLK_PHA. */

/*! @brief Read current value of the ECSPI_CONFIGREG_SCLK_PHA field. */
#define BR_ECSPI_CONFIGREG_SCLK_PHA(x) (HW_ECSPI_CONFIGREG(x).B.SCLK_PHA)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_SCLK_PHA. */
#define BF_ECSPI_CONFIGREG_SCLK_PHA(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_SCLK_PHA) & BM_ECSPI_CONFIGREG_SCLK_PHA)

/*! @brief Set the SCLK_PHA field to a new value. */
#define BW_ECSPI_CONFIGREG_SCLK_PHA(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_SCLK_PHA) | BF_ECSPI_CONFIGREG_SCLK_PHA(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field SCLK_POL[7:4] (RW)
 *
 * SPI Clock Polarity Control. This field controls the polarity of the SCLK
 * signal. See for more information. SCLK_POL[3] is for SPI channel 3. SCLK_POL[2] is
 * for SPI channel 2. SCLK_POL[1] is for SPI channel 1. SCLK_POL[0] is for SPI
 * channel 0.
 *
 * Values:
 * - 0 - Active high polarity (0 = Idle).
 * - 1 - Active low polarity (1 = Idle).
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_SCLK_POL (4U)   /*!< Bit position for ECSPI_CONFIGREG_SCLK_POL. */
#define BM_ECSPI_CONFIGREG_SCLK_POL (0x000000F0U) /*!< Bit mask for ECSPI_CONFIGREG_SCLK_POL. */
#define BS_ECSPI_CONFIGREG_SCLK_POL (4U)   /*!< Bit field size in bits for ECSPI_CONFIGREG_SCLK_POL. */

/*! @brief Read current value of the ECSPI_CONFIGREG_SCLK_POL field. */
#define BR_ECSPI_CONFIGREG_SCLK_POL(x) (HW_ECSPI_CONFIGREG(x).B.SCLK_POL)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_SCLK_POL. */
#define BF_ECSPI_CONFIGREG_SCLK_POL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_SCLK_POL) & BM_ECSPI_CONFIGREG_SCLK_POL)

/*! @brief Set the SCLK_POL field to a new value. */
#define BW_ECSPI_CONFIGREG_SCLK_POL(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_SCLK_POL) | BF_ECSPI_CONFIGREG_SCLK_POL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field SS_CTL[11:8] (RW)
 *
 * SPI SS Wave Form Select. In master mode, this field controls the output wave
 * form of the Chip Select (SS) signal when the SMC (Start Mode Control) bit is
 * cleared. The SS_CTL are ignored if the SMC bit is set. SS CTL[3] is for SPI
 * channel 3. SS CTL[2] is for SPI channel 2. SS CTL[1] is for SPI channel 1. SS
 * CTL[0] is for SPI channel 0. In slave mode, this bit controls when the SPI burst
 * is completed. An SPI burst is completed by the Chip Select (SS) signal edges.
 * (SSPOL = 0: rising edge; SSPOL = 1: falling edge) The RXFIFO is advanced
 * whenever a Chip Select (SS) signal edge is detected or the shift register contains
 * 32-bits of valid data.
 *
 * Values:
 * - 0 - In master mode - only one SPI burst will be transmitted.
 * - 1 - In master mode - Negate Chip Select (SS) signal between SPI bursts.
 *     Multiple SPI bursts will be transmitted. The SPI transfer will automatically
 *     stop when the TXFIFO is empty.
 * - 0 - In slave mode - an SPI burst is completed when the number of bits
 *     received in the shift register is equal to (BURST LENGTH + 1). Only the n
 *     least-significant bits (n = BURST LENGTH[4:0] + 1) of the first received word
 *     are valid. All bits subsequent to the first received word in RXFIFO are
 *     valid.
 * - 1 - Reserved
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_SS_CTL (8U)     /*!< Bit position for ECSPI_CONFIGREG_SS_CTL. */
#define BM_ECSPI_CONFIGREG_SS_CTL (0x00000F00U) /*!< Bit mask for ECSPI_CONFIGREG_SS_CTL. */
#define BS_ECSPI_CONFIGREG_SS_CTL (4U)     /*!< Bit field size in bits for ECSPI_CONFIGREG_SS_CTL. */

/*! @brief Read current value of the ECSPI_CONFIGREG_SS_CTL field. */
#define BR_ECSPI_CONFIGREG_SS_CTL(x) (HW_ECSPI_CONFIGREG(x).B.SS_CTL)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_SS_CTL. */
#define BF_ECSPI_CONFIGREG_SS_CTL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_SS_CTL) & BM_ECSPI_CONFIGREG_SS_CTL)

/*! @brief Set the SS_CTL field to a new value. */
#define BW_ECSPI_CONFIGREG_SS_CTL(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_SS_CTL) | BF_ECSPI_CONFIGREG_SS_CTL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field SS_POL[15:12] (RW)
 *
 * SPI SS Polarity Select. In both Master and Slave modes, this field selects
 * the polarity of the Chip Select (SS) signal. SS POL[3] is for SPI channel 3. SS
 * POL[2] is for SPI channel 2. SS POL[1] is for SPI channel 1. SS POL[0] is for
 * SPI channel 0.
 *
 * Values:
 * - 0 - Active low.
 * - 1 - Active high.
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_SS_POL (12U)    /*!< Bit position for ECSPI_CONFIGREG_SS_POL. */
#define BM_ECSPI_CONFIGREG_SS_POL (0x0000F000U) /*!< Bit mask for ECSPI_CONFIGREG_SS_POL. */
#define BS_ECSPI_CONFIGREG_SS_POL (4U)     /*!< Bit field size in bits for ECSPI_CONFIGREG_SS_POL. */

/*! @brief Read current value of the ECSPI_CONFIGREG_SS_POL field. */
#define BR_ECSPI_CONFIGREG_SS_POL(x) (HW_ECSPI_CONFIGREG(x).B.SS_POL)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_SS_POL. */
#define BF_ECSPI_CONFIGREG_SS_POL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_SS_POL) & BM_ECSPI_CONFIGREG_SS_POL)

/*! @brief Set the SS_POL field to a new value. */
#define BW_ECSPI_CONFIGREG_SS_POL(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_SS_POL) | BF_ECSPI_CONFIGREG_SS_POL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field DATA_CTL[19:16] (RW)
 *
 * DATA CTL. This field controls inactive state of the data line for each SPI
 * channel. DATA CTL[3] is for SPI channel 3. DATA CTL[2] is for SPI channel 2.
 * DATA CTL[1] is for SPI channel 1. DATA CTL[0] is for SPI channel 0.
 *
 * Values:
 * - 0 - Stay high.
 * - 1 - Stay low.
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_DATA_CTL (16U)  /*!< Bit position for ECSPI_CONFIGREG_DATA_CTL. */
#define BM_ECSPI_CONFIGREG_DATA_CTL (0x000F0000U) /*!< Bit mask for ECSPI_CONFIGREG_DATA_CTL. */
#define BS_ECSPI_CONFIGREG_DATA_CTL (4U)   /*!< Bit field size in bits for ECSPI_CONFIGREG_DATA_CTL. */

/*! @brief Read current value of the ECSPI_CONFIGREG_DATA_CTL field. */
#define BR_ECSPI_CONFIGREG_DATA_CTL(x) (HW_ECSPI_CONFIGREG(x).B.DATA_CTL)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_DATA_CTL. */
#define BF_ECSPI_CONFIGREG_DATA_CTL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_DATA_CTL) & BM_ECSPI_CONFIGREG_DATA_CTL)

/*! @brief Set the DATA_CTL field to a new value. */
#define BW_ECSPI_CONFIGREG_DATA_CTL(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_DATA_CTL) | BF_ECSPI_CONFIGREG_DATA_CTL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field SCLK_CTL[23:20] (RW)
 *
 * SCLK CTL. This field controls the inactive state of SCLK for each SPI
 * channel. SCLK CTL[3] is for SPI channel 3. SCLK CTL[2] is for SPI channel 2. SCLK
 * CTL[1] is for SPI channel 1. SCLK CTL[0] is for SPI channel 0.
 *
 * Values:
 * - 0 - Stay low.
 * - 1 - Stay high.
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_SCLK_CTL (20U)  /*!< Bit position for ECSPI_CONFIGREG_SCLK_CTL. */
#define BM_ECSPI_CONFIGREG_SCLK_CTL (0x00F00000U) /*!< Bit mask for ECSPI_CONFIGREG_SCLK_CTL. */
#define BS_ECSPI_CONFIGREG_SCLK_CTL (4U)   /*!< Bit field size in bits for ECSPI_CONFIGREG_SCLK_CTL. */

/*! @brief Read current value of the ECSPI_CONFIGREG_SCLK_CTL field. */
#define BR_ECSPI_CONFIGREG_SCLK_CTL(x) (HW_ECSPI_CONFIGREG(x).B.SCLK_CTL)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_SCLK_CTL. */
#define BF_ECSPI_CONFIGREG_SCLK_CTL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_SCLK_CTL) & BM_ECSPI_CONFIGREG_SCLK_CTL)

/*! @brief Set the SCLK_CTL field to a new value. */
#define BW_ECSPI_CONFIGREG_SCLK_CTL(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_SCLK_CTL) | BF_ECSPI_CONFIGREG_SCLK_CTL(v)))
/*@}*/

/*!
 * @name Register ECSPI_CONFIGREG, field HT_LENGTH[28:24] (RW)
 *
 * HT LENGTH. This field defines the message length in HT Mode. Note, HT mode is
 * not supported by this product. The length in bits of one message is (HT
 * LENGTH + 1).
 */
/*@{*/
#define BP_ECSPI_CONFIGREG_HT_LENGTH (24U) /*!< Bit position for ECSPI_CONFIGREG_HT_LENGTH. */
#define BM_ECSPI_CONFIGREG_HT_LENGTH (0x1F000000U) /*!< Bit mask for ECSPI_CONFIGREG_HT_LENGTH. */
#define BS_ECSPI_CONFIGREG_HT_LENGTH (5U)  /*!< Bit field size in bits for ECSPI_CONFIGREG_HT_LENGTH. */

/*! @brief Read current value of the ECSPI_CONFIGREG_HT_LENGTH field. */
#define BR_ECSPI_CONFIGREG_HT_LENGTH(x) (HW_ECSPI_CONFIGREG(x).B.HT_LENGTH)

/*! @brief Format value for bitfield ECSPI_CONFIGREG_HT_LENGTH. */
#define BF_ECSPI_CONFIGREG_HT_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_CONFIGREG_HT_LENGTH) & BM_ECSPI_CONFIGREG_HT_LENGTH)

/*! @brief Set the HT_LENGTH field to a new value. */
#define BW_ECSPI_CONFIGREG_HT_LENGTH(x, v) (HW_ECSPI_CONFIGREG_WR(x, (HW_ECSPI_CONFIGREG_RD(x) & ~BM_ECSPI_CONFIGREG_HT_LENGTH) | BF_ECSPI_CONFIGREG_HT_LENGTH(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_INTREG - Interrupt Control Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_INTREG - Interrupt Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Interrupt Control Register (ECSPI_INTREG) enables the generation of
 * interrupts to the host processor. If the ECSPI is disabled, this register reads
 * zero.
 */
typedef union _hw_ecspi_intreg
{
    uint32_t U;
    struct _hw_ecspi_intreg_bitfields
    {
        uint32_t TEEN : 1;             /*!< [0]  */
        uint32_t TDREN : 1;            /*!< [1]  */
        uint32_t TFEN : 1;             /*!< [2]  */
        uint32_t RREN : 1;             /*!< [3]  */
        uint32_t RDREN : 1;            /*!< [4]  */
        uint32_t RFEN : 1;             /*!< [5]  */
        uint32_t ROEN : 1;             /*!< [6]  */
        uint32_t TCEN : 1;             /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ecspi_intreg_t;

/*!
 * @name Constants and macros for entire ECSPI_INTREG register
 */
/*@{*/
#define HW_ECSPI_INTREG_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_ECSPI_INTREG(x)       (*(__IO hw_ecspi_intreg_t *) HW_ECSPI_INTREG_ADDR(x))
#define HW_ECSPI_INTREG_RD(x)    (HW_ECSPI_INTREG(x).U)
#define HW_ECSPI_INTREG_WR(x, v) (HW_ECSPI_INTREG(x).U = (v))
#define HW_ECSPI_INTREG_SET(x, v) (HW_ECSPI_INTREG_WR(x, HW_ECSPI_INTREG_RD(x) |  (v)))
#define HW_ECSPI_INTREG_CLR(x, v) (HW_ECSPI_INTREG_WR(x, HW_ECSPI_INTREG_RD(x) & ~(v)))
#define HW_ECSPI_INTREG_TOG(x, v) (HW_ECSPI_INTREG_WR(x, HW_ECSPI_INTREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_INTREG bitfields
 */

/*!
 * @name Register ECSPI_INTREG, field TEEN[0] (RW)
 *
 * TXFIFO Empty Interrupt enable. This bit enables the TXFIFO Empty Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_TEEN (0U)          /*!< Bit position for ECSPI_INTREG_TEEN. */
#define BM_ECSPI_INTREG_TEEN (0x00000001U) /*!< Bit mask for ECSPI_INTREG_TEEN. */
#define BS_ECSPI_INTREG_TEEN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_TEEN. */

/*! @brief Read current value of the ECSPI_INTREG_TEEN field. */
#define BR_ECSPI_INTREG_TEEN(x) (HW_ECSPI_INTREG(x).B.TEEN)

/*! @brief Format value for bitfield ECSPI_INTREG_TEEN. */
#define BF_ECSPI_INTREG_TEEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_TEEN) & BM_ECSPI_INTREG_TEEN)

/*! @brief Set the TEEN field to a new value. */
#define BW_ECSPI_INTREG_TEEN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_TEEN) | BF_ECSPI_INTREG_TEEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field TDREN[1] (RW)
 *
 * TXFIFO Data Request Interrupt enable. This bit enables the TXFIFO Data
 * Request Interrupt when the number of data entries in the TXFIFO is less than or
 * equal to TX_THRESHOLD.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_TDREN (1U)         /*!< Bit position for ECSPI_INTREG_TDREN. */
#define BM_ECSPI_INTREG_TDREN (0x00000002U) /*!< Bit mask for ECSPI_INTREG_TDREN. */
#define BS_ECSPI_INTREG_TDREN (1U)         /*!< Bit field size in bits for ECSPI_INTREG_TDREN. */

/*! @brief Read current value of the ECSPI_INTREG_TDREN field. */
#define BR_ECSPI_INTREG_TDREN(x) (HW_ECSPI_INTREG(x).B.TDREN)

/*! @brief Format value for bitfield ECSPI_INTREG_TDREN. */
#define BF_ECSPI_INTREG_TDREN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_TDREN) & BM_ECSPI_INTREG_TDREN)

/*! @brief Set the TDREN field to a new value. */
#define BW_ECSPI_INTREG_TDREN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_TDREN) | BF_ECSPI_INTREG_TDREN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field TFEN[2] (RW)
 *
 * TXFIFO Full Interrupt enable. This bit enables the TXFIFO Full Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_TFEN (2U)          /*!< Bit position for ECSPI_INTREG_TFEN. */
#define BM_ECSPI_INTREG_TFEN (0x00000004U) /*!< Bit mask for ECSPI_INTREG_TFEN. */
#define BS_ECSPI_INTREG_TFEN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_TFEN. */

/*! @brief Read current value of the ECSPI_INTREG_TFEN field. */
#define BR_ECSPI_INTREG_TFEN(x) (HW_ECSPI_INTREG(x).B.TFEN)

/*! @brief Format value for bitfield ECSPI_INTREG_TFEN. */
#define BF_ECSPI_INTREG_TFEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_TFEN) & BM_ECSPI_INTREG_TFEN)

/*! @brief Set the TFEN field to a new value. */
#define BW_ECSPI_INTREG_TFEN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_TFEN) | BF_ECSPI_INTREG_TFEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field RREN[3] (RW)
 *
 * RXFIFO Ready Interrupt enable. This bit enables the RXFIFO Ready Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_RREN (3U)          /*!< Bit position for ECSPI_INTREG_RREN. */
#define BM_ECSPI_INTREG_RREN (0x00000008U) /*!< Bit mask for ECSPI_INTREG_RREN. */
#define BS_ECSPI_INTREG_RREN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_RREN. */

/*! @brief Read current value of the ECSPI_INTREG_RREN field. */
#define BR_ECSPI_INTREG_RREN(x) (HW_ECSPI_INTREG(x).B.RREN)

/*! @brief Format value for bitfield ECSPI_INTREG_RREN. */
#define BF_ECSPI_INTREG_RREN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_RREN) & BM_ECSPI_INTREG_RREN)

/*! @brief Set the RREN field to a new value. */
#define BW_ECSPI_INTREG_RREN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_RREN) | BF_ECSPI_INTREG_RREN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field RDREN[4] (RW)
 *
 * RXFIFO Data Request Interrupt enable. This bit enables the RXFIFO Data
 * Request Interrupt when the number of data entries in the RXFIFO is greater than
 * RX_THRESHOLD.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_RDREN (4U)         /*!< Bit position for ECSPI_INTREG_RDREN. */
#define BM_ECSPI_INTREG_RDREN (0x00000010U) /*!< Bit mask for ECSPI_INTREG_RDREN. */
#define BS_ECSPI_INTREG_RDREN (1U)         /*!< Bit field size in bits for ECSPI_INTREG_RDREN. */

/*! @brief Read current value of the ECSPI_INTREG_RDREN field. */
#define BR_ECSPI_INTREG_RDREN(x) (HW_ECSPI_INTREG(x).B.RDREN)

/*! @brief Format value for bitfield ECSPI_INTREG_RDREN. */
#define BF_ECSPI_INTREG_RDREN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_RDREN) & BM_ECSPI_INTREG_RDREN)

/*! @brief Set the RDREN field to a new value. */
#define BW_ECSPI_INTREG_RDREN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_RDREN) | BF_ECSPI_INTREG_RDREN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field RFEN[5] (RW)
 *
 * RXFIFO Full Interrupt enable. This bit enables the RXFIFO Full Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_RFEN (5U)          /*!< Bit position for ECSPI_INTREG_RFEN. */
#define BM_ECSPI_INTREG_RFEN (0x00000020U) /*!< Bit mask for ECSPI_INTREG_RFEN. */
#define BS_ECSPI_INTREG_RFEN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_RFEN. */

/*! @brief Read current value of the ECSPI_INTREG_RFEN field. */
#define BR_ECSPI_INTREG_RFEN(x) (HW_ECSPI_INTREG(x).B.RFEN)

/*! @brief Format value for bitfield ECSPI_INTREG_RFEN. */
#define BF_ECSPI_INTREG_RFEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_RFEN) & BM_ECSPI_INTREG_RFEN)

/*! @brief Set the RFEN field to a new value. */
#define BW_ECSPI_INTREG_RFEN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_RFEN) | BF_ECSPI_INTREG_RFEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field ROEN[6] (RW)
 *
 * RXFIFO Overflow Interrupt enable. This bit enables the RXFIFO Overflow
 * Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_ROEN (6U)          /*!< Bit position for ECSPI_INTREG_ROEN. */
#define BM_ECSPI_INTREG_ROEN (0x00000040U) /*!< Bit mask for ECSPI_INTREG_ROEN. */
#define BS_ECSPI_INTREG_ROEN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_ROEN. */

/*! @brief Read current value of the ECSPI_INTREG_ROEN field. */
#define BR_ECSPI_INTREG_ROEN(x) (HW_ECSPI_INTREG(x).B.ROEN)

/*! @brief Format value for bitfield ECSPI_INTREG_ROEN. */
#define BF_ECSPI_INTREG_ROEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_ROEN) & BM_ECSPI_INTREG_ROEN)

/*! @brief Set the ROEN field to a new value. */
#define BW_ECSPI_INTREG_ROEN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_ROEN) | BF_ECSPI_INTREG_ROEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_INTREG, field TCEN[7] (RW)
 *
 * Transfer Completed Interrupt enable. This bit enables the Transfer Completed
 * Interrupt.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_INTREG_TCEN (7U)          /*!< Bit position for ECSPI_INTREG_TCEN. */
#define BM_ECSPI_INTREG_TCEN (0x00000080U) /*!< Bit mask for ECSPI_INTREG_TCEN. */
#define BS_ECSPI_INTREG_TCEN (1U)          /*!< Bit field size in bits for ECSPI_INTREG_TCEN. */

/*! @brief Read current value of the ECSPI_INTREG_TCEN field. */
#define BR_ECSPI_INTREG_TCEN(x) (HW_ECSPI_INTREG(x).B.TCEN)

/*! @brief Format value for bitfield ECSPI_INTREG_TCEN. */
#define BF_ECSPI_INTREG_TCEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_INTREG_TCEN) & BM_ECSPI_INTREG_TCEN)

/*! @brief Set the TCEN field to a new value. */
#define BW_ECSPI_INTREG_TCEN(x, v) (HW_ECSPI_INTREG_WR(x, (HW_ECSPI_INTREG_RD(x) & ~BM_ECSPI_INTREG_TCEN) | BF_ECSPI_INTREG_TCEN(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_DMAREG - DMA Control Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_DMAREG - DMA Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Direct Memory Access Control Register (ECSPI_DMAREG) provides software a
 * way to use an on-chip DMA controller for ECSPI data. Internal DMA request
 * signals enable direct data transfers between the ECSPI FIFOs and system memory.
 * The ECSPI sends out DMA requests when the appropriate FIFO conditions are
 * matched. If the ECSPI is disabled, this register is read as 0.
 */
typedef union _hw_ecspi_dmareg
{
    uint32_t U;
    struct _hw_ecspi_dmareg_bitfields
    {
        uint32_t TX_THRESHOLD : 6;     /*!< [5:0]  */
        uint32_t RESERVED0 : 1;        /*!< [6]  */
        uint32_t TEDEN : 1;            /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t RX_THRESHOLD : 6;     /*!< [21:16]  */
        uint32_t RESERVED2 : 1;        /*!< [22]  */
        uint32_t RXDEN : 1;            /*!< [23]  */
        uint32_t RX_DMA_LENGTH : 6;    /*!< [29:24]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t RXTDEN : 1;           /*!< [31]  */
    } B;
} hw_ecspi_dmareg_t;

/*!
 * @name Constants and macros for entire ECSPI_DMAREG register
 */
/*@{*/
#define HW_ECSPI_DMAREG_ADDR(x)  ((uintptr_t)(x) + 0x14U)

#define HW_ECSPI_DMAREG(x)       (*(__IO hw_ecspi_dmareg_t *) HW_ECSPI_DMAREG_ADDR(x))
#define HW_ECSPI_DMAREG_RD(x)    (HW_ECSPI_DMAREG(x).U)
#define HW_ECSPI_DMAREG_WR(x, v) (HW_ECSPI_DMAREG(x).U = (v))
#define HW_ECSPI_DMAREG_SET(x, v) (HW_ECSPI_DMAREG_WR(x, HW_ECSPI_DMAREG_RD(x) |  (v)))
#define HW_ECSPI_DMAREG_CLR(x, v) (HW_ECSPI_DMAREG_WR(x, HW_ECSPI_DMAREG_RD(x) & ~(v)))
#define HW_ECSPI_DMAREG_TOG(x, v) (HW_ECSPI_DMAREG_WR(x, HW_ECSPI_DMAREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_DMAREG bitfields
 */

/*!
 * @name Register ECSPI_DMAREG, field TX_THRESHOLD[5:0] (RW)
 *
 * TX THRESHOLD. This field defines the FIFO threshold that triggers a TX
 * DMA/INT request. A TX DMA/INT request is issued when the number of data entries in
 * the TXFIFO is not greater than TX_THRESHOLD.
 */
/*@{*/
#define BP_ECSPI_DMAREG_TX_THRESHOLD (0U)  /*!< Bit position for ECSPI_DMAREG_TX_THRESHOLD. */
#define BM_ECSPI_DMAREG_TX_THRESHOLD (0x0000003FU) /*!< Bit mask for ECSPI_DMAREG_TX_THRESHOLD. */
#define BS_ECSPI_DMAREG_TX_THRESHOLD (6U)  /*!< Bit field size in bits for ECSPI_DMAREG_TX_THRESHOLD. */

/*! @brief Read current value of the ECSPI_DMAREG_TX_THRESHOLD field. */
#define BR_ECSPI_DMAREG_TX_THRESHOLD(x) (HW_ECSPI_DMAREG(x).B.TX_THRESHOLD)

/*! @brief Format value for bitfield ECSPI_DMAREG_TX_THRESHOLD. */
#define BF_ECSPI_DMAREG_TX_THRESHOLD(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_TX_THRESHOLD) & BM_ECSPI_DMAREG_TX_THRESHOLD)

/*! @brief Set the TX_THRESHOLD field to a new value. */
#define BW_ECSPI_DMAREG_TX_THRESHOLD(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_TX_THRESHOLD) | BF_ECSPI_DMAREG_TX_THRESHOLD(v)))
/*@}*/

/*!
 * @name Register ECSPI_DMAREG, field TEDEN[7] (RW)
 *
 * TXFIFO Empty DMA Request Enable. This bit enables/disables the TXFIFO Empty
 * DMA Request.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_DMAREG_TEDEN (7U)         /*!< Bit position for ECSPI_DMAREG_TEDEN. */
#define BM_ECSPI_DMAREG_TEDEN (0x00000080U) /*!< Bit mask for ECSPI_DMAREG_TEDEN. */
#define BS_ECSPI_DMAREG_TEDEN (1U)         /*!< Bit field size in bits for ECSPI_DMAREG_TEDEN. */

/*! @brief Read current value of the ECSPI_DMAREG_TEDEN field. */
#define BR_ECSPI_DMAREG_TEDEN(x) (HW_ECSPI_DMAREG(x).B.TEDEN)

/*! @brief Format value for bitfield ECSPI_DMAREG_TEDEN. */
#define BF_ECSPI_DMAREG_TEDEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_TEDEN) & BM_ECSPI_DMAREG_TEDEN)

/*! @brief Set the TEDEN field to a new value. */
#define BW_ECSPI_DMAREG_TEDEN(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_TEDEN) | BF_ECSPI_DMAREG_TEDEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_DMAREG, field RX_THRESHOLD[21:16] (RW)
 *
 * RX THRESHOLD. This field defines the FIFO threshold that triggers a RX
 * DMA/INT request. A RX DMA/INT request is issued when the number of data entries in
 * the RXFIFO is greater than RX_THRESHOLD.
 */
/*@{*/
#define BP_ECSPI_DMAREG_RX_THRESHOLD (16U) /*!< Bit position for ECSPI_DMAREG_RX_THRESHOLD. */
#define BM_ECSPI_DMAREG_RX_THRESHOLD (0x003F0000U) /*!< Bit mask for ECSPI_DMAREG_RX_THRESHOLD. */
#define BS_ECSPI_DMAREG_RX_THRESHOLD (6U)  /*!< Bit field size in bits for ECSPI_DMAREG_RX_THRESHOLD. */

/*! @brief Read current value of the ECSPI_DMAREG_RX_THRESHOLD field. */
#define BR_ECSPI_DMAREG_RX_THRESHOLD(x) (HW_ECSPI_DMAREG(x).B.RX_THRESHOLD)

/*! @brief Format value for bitfield ECSPI_DMAREG_RX_THRESHOLD. */
#define BF_ECSPI_DMAREG_RX_THRESHOLD(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_RX_THRESHOLD) & BM_ECSPI_DMAREG_RX_THRESHOLD)

/*! @brief Set the RX_THRESHOLD field to a new value. */
#define BW_ECSPI_DMAREG_RX_THRESHOLD(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_RX_THRESHOLD) | BF_ECSPI_DMAREG_RX_THRESHOLD(v)))
/*@}*/

/*!
 * @name Register ECSPI_DMAREG, field RXDEN[23] (RW)
 *
 * RXFIFO DMA Request Enable. This bit enables/disables the RXFIFO DMA Request.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_DMAREG_RXDEN (23U)        /*!< Bit position for ECSPI_DMAREG_RXDEN. */
#define BM_ECSPI_DMAREG_RXDEN (0x00800000U) /*!< Bit mask for ECSPI_DMAREG_RXDEN. */
#define BS_ECSPI_DMAREG_RXDEN (1U)         /*!< Bit field size in bits for ECSPI_DMAREG_RXDEN. */

/*! @brief Read current value of the ECSPI_DMAREG_RXDEN field. */
#define BR_ECSPI_DMAREG_RXDEN(x) (HW_ECSPI_DMAREG(x).B.RXDEN)

/*! @brief Format value for bitfield ECSPI_DMAREG_RXDEN. */
#define BF_ECSPI_DMAREG_RXDEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_RXDEN) & BM_ECSPI_DMAREG_RXDEN)

/*! @brief Set the RXDEN field to a new value. */
#define BW_ECSPI_DMAREG_RXDEN(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_RXDEN) | BF_ECSPI_DMAREG_RXDEN(v)))
/*@}*/

/*!
 * @name Register ECSPI_DMAREG, field RX_DMA_LENGTH[29:24] (RW)
 *
 * RX DMA LENGTH. This field defines the burst length of a DMA operation.
 * Applies only when RXTDEN is set.
 */
/*@{*/
#define BP_ECSPI_DMAREG_RX_DMA_LENGTH (24U) /*!< Bit position for ECSPI_DMAREG_RX_DMA_LENGTH. */
#define BM_ECSPI_DMAREG_RX_DMA_LENGTH (0x3F000000U) /*!< Bit mask for ECSPI_DMAREG_RX_DMA_LENGTH. */
#define BS_ECSPI_DMAREG_RX_DMA_LENGTH (6U) /*!< Bit field size in bits for ECSPI_DMAREG_RX_DMA_LENGTH. */

/*! @brief Read current value of the ECSPI_DMAREG_RX_DMA_LENGTH field. */
#define BR_ECSPI_DMAREG_RX_DMA_LENGTH(x) (HW_ECSPI_DMAREG(x).B.RX_DMA_LENGTH)

/*! @brief Format value for bitfield ECSPI_DMAREG_RX_DMA_LENGTH. */
#define BF_ECSPI_DMAREG_RX_DMA_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_RX_DMA_LENGTH) & BM_ECSPI_DMAREG_RX_DMA_LENGTH)

/*! @brief Set the RX_DMA_LENGTH field to a new value. */
#define BW_ECSPI_DMAREG_RX_DMA_LENGTH(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_RX_DMA_LENGTH) | BF_ECSPI_DMAREG_RX_DMA_LENGTH(v)))
/*@}*/

/*!
 * @name Register ECSPI_DMAREG, field RXTDEN[31] (RW)
 *
 * RXFIFO TAIL DMA Request Enable. This bit enables an internal counter that is
 * increased at each read of the RXFIFO. This counter is cleared automatically
 * when it reaches RX DMA LENGTH. If the number of words remaining in the RXFIFO is
 * greater than or equal to RX DMA LENGTH, a DMA request is generated even if it
 * is less than or equal to RX_THRESHOLD.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_ECSPI_DMAREG_RXTDEN (31U)       /*!< Bit position for ECSPI_DMAREG_RXTDEN. */
#define BM_ECSPI_DMAREG_RXTDEN (0x80000000U) /*!< Bit mask for ECSPI_DMAREG_RXTDEN. */
#define BS_ECSPI_DMAREG_RXTDEN (1U)        /*!< Bit field size in bits for ECSPI_DMAREG_RXTDEN. */

/*! @brief Read current value of the ECSPI_DMAREG_RXTDEN field. */
#define BR_ECSPI_DMAREG_RXTDEN(x) (HW_ECSPI_DMAREG(x).B.RXTDEN)

/*! @brief Format value for bitfield ECSPI_DMAREG_RXTDEN. */
#define BF_ECSPI_DMAREG_RXTDEN(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_DMAREG_RXTDEN) & BM_ECSPI_DMAREG_RXTDEN)

/*! @brief Set the RXTDEN field to a new value. */
#define BW_ECSPI_DMAREG_RXTDEN(x, v) (HW_ECSPI_DMAREG_WR(x, (HW_ECSPI_DMAREG_RD(x) & ~BM_ECSPI_DMAREG_RXTDEN) | BF_ECSPI_DMAREG_RXTDEN(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_STATREG - Status Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_STATREG - Status Register (RW)
 *
 * Reset value: 0x00000003U
 *
 * The ECSPI Status Register (ECSPI_STATREG) reflects the status of the ECSPI's
 * operating condition. If the ECSPI is disabled, this register reads 0x0000_0003.
 */
typedef union _hw_ecspi_statreg
{
    uint32_t U;
    struct _hw_ecspi_statreg_bitfields
    {
        uint32_t TE : 1;               /*!< [0]  */
        uint32_t TDR : 1;              /*!< [1]  */
        uint32_t TF : 1;               /*!< [2]  */
        uint32_t RR : 1;               /*!< [3]  */
        uint32_t RDR : 1;              /*!< [4]  */
        uint32_t RF : 1;               /*!< [5]  */
        uint32_t RO : 1;               /*!< [6]  */
        uint32_t TC : 1;               /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ecspi_statreg_t;

/*!
 * @name Constants and macros for entire ECSPI_STATREG register
 */
/*@{*/
#define HW_ECSPI_STATREG_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_ECSPI_STATREG(x)      (*(__IO hw_ecspi_statreg_t *) HW_ECSPI_STATREG_ADDR(x))
#define HW_ECSPI_STATREG_RD(x)   (HW_ECSPI_STATREG(x).U)
#define HW_ECSPI_STATREG_WR(x, v) (HW_ECSPI_STATREG(x).U = (v))
#define HW_ECSPI_STATREG_SET(x, v) (HW_ECSPI_STATREG_WR(x, HW_ECSPI_STATREG_RD(x) |  (v)))
#define HW_ECSPI_STATREG_CLR(x, v) (HW_ECSPI_STATREG_WR(x, HW_ECSPI_STATREG_RD(x) & ~(v)))
#define HW_ECSPI_STATREG_TOG(x, v) (HW_ECSPI_STATREG_WR(x, HW_ECSPI_STATREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_STATREG bitfields
 */

/*!
 * @name Register ECSPI_STATREG, field TE[0] (RO)
 *
 * TXFIFO Empty. This bit is set if the TXFIFO is empty.
 *
 * Values:
 * - 0 - TXFIFO contains one or more words.
 * - 1 - TXFIFO is empty.
 */
/*@{*/
#define BP_ECSPI_STATREG_TE  (0U)          /*!< Bit position for ECSPI_STATREG_TE. */
#define BM_ECSPI_STATREG_TE  (0x00000001U) /*!< Bit mask for ECSPI_STATREG_TE. */
#define BS_ECSPI_STATREG_TE  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_TE. */

/*! @brief Read current value of the ECSPI_STATREG_TE field. */
#define BR_ECSPI_STATREG_TE(x) (HW_ECSPI_STATREG(x).B.TE)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field TDR[1] (RO)
 *
 * TXFIFO Data Request.
 *
 * Values:
 * - 0 - Number of valid data slots in TXFIFO is greater than TX_THRESHOLD.
 * - 1 - Number of valid data slots in TXFIFO is not greater than TX_THRESHOLD.
 */
/*@{*/
#define BP_ECSPI_STATREG_TDR (1U)          /*!< Bit position for ECSPI_STATREG_TDR. */
#define BM_ECSPI_STATREG_TDR (0x00000002U) /*!< Bit mask for ECSPI_STATREG_TDR. */
#define BS_ECSPI_STATREG_TDR (1U)          /*!< Bit field size in bits for ECSPI_STATREG_TDR. */

/*! @brief Read current value of the ECSPI_STATREG_TDR field. */
#define BR_ECSPI_STATREG_TDR(x) (HW_ECSPI_STATREG(x).B.TDR)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field TF[2] (RO)
 *
 * TXFIFO Full. This bit is set when if the TXFIFO is full.
 *
 * Values:
 * - 0 - TXFIFO is not Full.
 * - 1 - TXFIFO is Full.
 */
/*@{*/
#define BP_ECSPI_STATREG_TF  (2U)          /*!< Bit position for ECSPI_STATREG_TF. */
#define BM_ECSPI_STATREG_TF  (0x00000004U) /*!< Bit mask for ECSPI_STATREG_TF. */
#define BS_ECSPI_STATREG_TF  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_TF. */

/*! @brief Read current value of the ECSPI_STATREG_TF field. */
#define BR_ECSPI_STATREG_TF(x) (HW_ECSPI_STATREG(x).B.TF)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field RR[3] (RO)
 *
 * RXFIFO Ready. This bit is set when one or more words are stored in the RXFIFO.
 *
 * Values:
 * - 0 - No valid data in RXFIFO.
 * - 1 - More than 1 word in RXFIFO.
 */
/*@{*/
#define BP_ECSPI_STATREG_RR  (3U)          /*!< Bit position for ECSPI_STATREG_RR. */
#define BM_ECSPI_STATREG_RR  (0x00000008U) /*!< Bit mask for ECSPI_STATREG_RR. */
#define BS_ECSPI_STATREG_RR  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_RR. */

/*! @brief Read current value of the ECSPI_STATREG_RR field. */
#define BR_ECSPI_STATREG_RR(x) (HW_ECSPI_STATREG(x).B.RR)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field RDR[4] (RO)
 *
 * RXFIFO Data Request.
 *
 * Values:
 * - 0 - When RXTDE is set - Number of data entries in the RXFIFO is not greater
 *     than RX_THRESHOLD.
 * - 1 - When RXTDE is set - Number of data entries in the RXFIFO is greater
 *     than RX_THRESHOLD or a DMA TAIL DMA condition exists.
 * - 0 - When RXTDE is clear - Number of data entries in the RXFIFO is not
 *     greater than RX_THRESHOLD.
 * - 1 - When RXTDE is clear - Number of data entries in the RXFIFO is greater
 *     than RX_THRESHOLD.
 */
/*@{*/
#define BP_ECSPI_STATREG_RDR (4U)          /*!< Bit position for ECSPI_STATREG_RDR. */
#define BM_ECSPI_STATREG_RDR (0x00000010U) /*!< Bit mask for ECSPI_STATREG_RDR. */
#define BS_ECSPI_STATREG_RDR (1U)          /*!< Bit field size in bits for ECSPI_STATREG_RDR. */

/*! @brief Read current value of the ECSPI_STATREG_RDR field. */
#define BR_ECSPI_STATREG_RDR(x) (HW_ECSPI_STATREG(x).B.RDR)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field RF[5] (RO)
 *
 * RXFIFO Full. This bit is set when the RXFIFO is full.
 *
 * Values:
 * - 0 - Not Full.
 * - 1 - Full.
 */
/*@{*/
#define BP_ECSPI_STATREG_RF  (5U)          /*!< Bit position for ECSPI_STATREG_RF. */
#define BM_ECSPI_STATREG_RF  (0x00000020U) /*!< Bit mask for ECSPI_STATREG_RF. */
#define BS_ECSPI_STATREG_RF  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_RF. */

/*! @brief Read current value of the ECSPI_STATREG_RF field. */
#define BR_ECSPI_STATREG_RF(x) (HW_ECSPI_STATREG(x).B.RF)
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field RO[6] (W1C)
 *
 * RXFIFO Overflow. When set, this bit indicates that RXFIFO has overflowed.
 * Writing 1 to this bit clears it.
 *
 * Values:
 * - 0 - RXFIFO has no overflow.
 * - 1 - RXFIFO has overflowed.
 */
/*@{*/
#define BP_ECSPI_STATREG_RO  (6U)          /*!< Bit position for ECSPI_STATREG_RO. */
#define BM_ECSPI_STATREG_RO  (0x00000040U) /*!< Bit mask for ECSPI_STATREG_RO. */
#define BS_ECSPI_STATREG_RO  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_RO. */

/*! @brief Read current value of the ECSPI_STATREG_RO field. */
#define BR_ECSPI_STATREG_RO(x) (HW_ECSPI_STATREG(x).B.RO)

/*! @brief Format value for bitfield ECSPI_STATREG_RO. */
#define BF_ECSPI_STATREG_RO(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_STATREG_RO) & BM_ECSPI_STATREG_RO)

/*! @brief Set the RO field to a new value. */
#define BW_ECSPI_STATREG_RO(x, v) (HW_ECSPI_STATREG_WR(x, (HW_ECSPI_STATREG_RD(x) & ~(BM_ECSPI_STATREG_RO | BM_ECSPI_STATREG_TC)) | BF_ECSPI_STATREG_RO(v)))
/*@}*/

/*!
 * @name Register ECSPI_STATREG, field TC[7] (W1C)
 *
 * Transfer Completed Status bit. Writing 1 to this bit clears it.
 *
 * Values:
 * - 0 - Transfer in progress.
 * - 1 - Transfer completed.
 */
/*@{*/
#define BP_ECSPI_STATREG_TC  (7U)          /*!< Bit position for ECSPI_STATREG_TC. */
#define BM_ECSPI_STATREG_TC  (0x00000080U) /*!< Bit mask for ECSPI_STATREG_TC. */
#define BS_ECSPI_STATREG_TC  (1U)          /*!< Bit field size in bits for ECSPI_STATREG_TC. */

/*! @brief Read current value of the ECSPI_STATREG_TC field. */
#define BR_ECSPI_STATREG_TC(x) (HW_ECSPI_STATREG(x).B.TC)

/*! @brief Format value for bitfield ECSPI_STATREG_TC. */
#define BF_ECSPI_STATREG_TC(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_STATREG_TC) & BM_ECSPI_STATREG_TC)

/*! @brief Set the TC field to a new value. */
#define BW_ECSPI_STATREG_TC(x, v) (HW_ECSPI_STATREG_WR(x, (HW_ECSPI_STATREG_RD(x) & ~(BM_ECSPI_STATREG_TC | BM_ECSPI_STATREG_RO)) | BF_ECSPI_STATREG_TC(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_PERIODREG - Sample Period Control Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_PERIODREG - Sample Period Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Sample Period Control Register (ECSPI_PERIODREG) provides software a way
 * to insert delays (wait states) between consecutive SPI transfers. Control bits
 * in this register select the clock source for the sample period counter and
 * the delay count indicating the number of wait states to be inserted between data
 * transfers. The delay counts apply only when the current channel is operating
 * in Master mode (ECSPI_CONREG[CHANNEL MODE] = 1).ECSPI_PERIODREG also contains
 * the CSD CTRL field used to insert a delay between the Chip Select's active
 * edge and the first SPI Clock edge.
 */
typedef union _hw_ecspi_periodreg
{
    uint32_t U;
    struct _hw_ecspi_periodreg_bitfields
    {
        uint32_t SAMPLE_PERIOD : 15;   /*!< [14:0]  */
        uint32_t CSRC : 1;             /*!< [15]  */
        uint32_t CSD_CTL : 6;          /*!< [21:16]  */
        uint32_t RESERVED0 : 10;       /*!< [31:22]  */
    } B;
} hw_ecspi_periodreg_t;

/*!
 * @name Constants and macros for entire ECSPI_PERIODREG register
 */
/*@{*/
#define HW_ECSPI_PERIODREG_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_ECSPI_PERIODREG(x)    (*(__IO hw_ecspi_periodreg_t *) HW_ECSPI_PERIODREG_ADDR(x))
#define HW_ECSPI_PERIODREG_RD(x) (HW_ECSPI_PERIODREG(x).U)
#define HW_ECSPI_PERIODREG_WR(x, v) (HW_ECSPI_PERIODREG(x).U = (v))
#define HW_ECSPI_PERIODREG_SET(x, v) (HW_ECSPI_PERIODREG_WR(x, HW_ECSPI_PERIODREG_RD(x) |  (v)))
#define HW_ECSPI_PERIODREG_CLR(x, v) (HW_ECSPI_PERIODREG_WR(x, HW_ECSPI_PERIODREG_RD(x) & ~(v)))
#define HW_ECSPI_PERIODREG_TOG(x, v) (HW_ECSPI_PERIODREG_WR(x, HW_ECSPI_PERIODREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_PERIODREG bitfields
 */

/*!
 * @name Register ECSPI_PERIODREG, field SAMPLE_PERIOD[14:0] (RW)
 *
 * Sample Period Control. These bits control the number of wait states to be
 * inserted in data transfers. During the idle clocks, the state of the SS output
 * will operate according to the SS_CTL control field in the ECSPI_CONREG register.
 *
 * Values:
 * - 0 - 0 wait states inserted
 * - 1 - 1 wait state inserted
 * - 111111111111110 - 32766 wait states inserted
 * - 111111111111111 - 32767 wait states inserted
 */
/*@{*/
#define BP_ECSPI_PERIODREG_SAMPLE_PERIOD (0U) /*!< Bit position for ECSPI_PERIODREG_SAMPLE_PERIOD. */
#define BM_ECSPI_PERIODREG_SAMPLE_PERIOD (0x00007FFFU) /*!< Bit mask for ECSPI_PERIODREG_SAMPLE_PERIOD. */
#define BS_ECSPI_PERIODREG_SAMPLE_PERIOD (15U) /*!< Bit field size in bits for ECSPI_PERIODREG_SAMPLE_PERIOD. */

/*! @brief Read current value of the ECSPI_PERIODREG_SAMPLE_PERIOD field. */
#define BR_ECSPI_PERIODREG_SAMPLE_PERIOD(x) (HW_ECSPI_PERIODREG(x).B.SAMPLE_PERIOD)

/*! @brief Format value for bitfield ECSPI_PERIODREG_SAMPLE_PERIOD. */
#define BF_ECSPI_PERIODREG_SAMPLE_PERIOD(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_PERIODREG_SAMPLE_PERIOD) & BM_ECSPI_PERIODREG_SAMPLE_PERIOD)

/*! @brief Set the SAMPLE_PERIOD field to a new value. */
#define BW_ECSPI_PERIODREG_SAMPLE_PERIOD(x, v) (HW_ECSPI_PERIODREG_WR(x, (HW_ECSPI_PERIODREG_RD(x) & ~BM_ECSPI_PERIODREG_SAMPLE_PERIOD) | BF_ECSPI_PERIODREG_SAMPLE_PERIOD(v)))
/*@}*/

/*!
 * @name Register ECSPI_PERIODREG, field CSRC[15] (RW)
 *
 * Clock Source Control. This bit selects the clock source for the sample period
 * counter.
 *
 * Values:
 * - 0 - SPI Clock (SCLK)
 * - 1 - Low-Frequency Reference Clock (32.768 KHz)
 */
/*@{*/
#define BP_ECSPI_PERIODREG_CSRC (15U)      /*!< Bit position for ECSPI_PERIODREG_CSRC. */
#define BM_ECSPI_PERIODREG_CSRC (0x00008000U) /*!< Bit mask for ECSPI_PERIODREG_CSRC. */
#define BS_ECSPI_PERIODREG_CSRC (1U)       /*!< Bit field size in bits for ECSPI_PERIODREG_CSRC. */

/*! @brief Read current value of the ECSPI_PERIODREG_CSRC field. */
#define BR_ECSPI_PERIODREG_CSRC(x) (HW_ECSPI_PERIODREG(x).B.CSRC)

/*! @brief Format value for bitfield ECSPI_PERIODREG_CSRC. */
#define BF_ECSPI_PERIODREG_CSRC(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_PERIODREG_CSRC) & BM_ECSPI_PERIODREG_CSRC)

/*! @brief Set the CSRC field to a new value. */
#define BW_ECSPI_PERIODREG_CSRC(x, v) (HW_ECSPI_PERIODREG_WR(x, (HW_ECSPI_PERIODREG_RD(x) & ~BM_ECSPI_PERIODREG_CSRC) | BF_ECSPI_PERIODREG_CSRC(v)))
/*@}*/

/*!
 * @name Register ECSPI_PERIODREG, field CSD_CTL[21:16] (RW)
 *
 * Chip Select Delay Control bits. This field defines how many SPI clocks will
 * be inserted between the chip select's active edge and the first SPI clock edge.
 * The range is from 0 to 63.
 */
/*@{*/
#define BP_ECSPI_PERIODREG_CSD_CTL (16U)   /*!< Bit position for ECSPI_PERIODREG_CSD_CTL. */
#define BM_ECSPI_PERIODREG_CSD_CTL (0x003F0000U) /*!< Bit mask for ECSPI_PERIODREG_CSD_CTL. */
#define BS_ECSPI_PERIODREG_CSD_CTL (6U)    /*!< Bit field size in bits for ECSPI_PERIODREG_CSD_CTL. */

/*! @brief Read current value of the ECSPI_PERIODREG_CSD_CTL field. */
#define BR_ECSPI_PERIODREG_CSD_CTL(x) (HW_ECSPI_PERIODREG(x).B.CSD_CTL)

/*! @brief Format value for bitfield ECSPI_PERIODREG_CSD_CTL. */
#define BF_ECSPI_PERIODREG_CSD_CTL(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_PERIODREG_CSD_CTL) & BM_ECSPI_PERIODREG_CSD_CTL)

/*! @brief Set the CSD_CTL field to a new value. */
#define BW_ECSPI_PERIODREG_CSD_CTL(x, v) (HW_ECSPI_PERIODREG_WR(x, (HW_ECSPI_PERIODREG_RD(x) & ~BM_ECSPI_PERIODREG_CSD_CTL) | BF_ECSPI_PERIODREG_CSD_CTL(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_TESTREG - Test Control Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_TESTREG - Test Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Test Control Register (ECSPI_TESTREG) provides software a mechanism to
 * internally connect the receive and transmit devices of the ECSPI , and monitor
 * the contents of the receive and transmit FIFOs.
 */
typedef union _hw_ecspi_testreg
{
    uint32_t U;
    struct _hw_ecspi_testreg_bitfields
    {
        uint32_t TXCNT : 7;            /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t RXCNT : 7;            /*!< [14:8]  */
        uint32_t RESERVED1 : 16;       /*!< [30:15]  */
        uint32_t LBC : 1;              /*!< [31]  */
    } B;
} hw_ecspi_testreg_t;

/*!
 * @name Constants and macros for entire ECSPI_TESTREG register
 */
/*@{*/
#define HW_ECSPI_TESTREG_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_ECSPI_TESTREG(x)      (*(__IO hw_ecspi_testreg_t *) HW_ECSPI_TESTREG_ADDR(x))
#define HW_ECSPI_TESTREG_RD(x)   (HW_ECSPI_TESTREG(x).U)
#define HW_ECSPI_TESTREG_WR(x, v) (HW_ECSPI_TESTREG(x).U = (v))
#define HW_ECSPI_TESTREG_SET(x, v) (HW_ECSPI_TESTREG_WR(x, HW_ECSPI_TESTREG_RD(x) |  (v)))
#define HW_ECSPI_TESTREG_CLR(x, v) (HW_ECSPI_TESTREG_WR(x, HW_ECSPI_TESTREG_RD(x) & ~(v)))
#define HW_ECSPI_TESTREG_TOG(x, v) (HW_ECSPI_TESTREG_WR(x, HW_ECSPI_TESTREG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ECSPI_TESTREG bitfields
 */

/*!
 * @name Register ECSPI_TESTREG, field TXCNT[6:0] (RW)
 *
 * TXFIFO Counter. This field indicates the number of words in the TXFIFO.
 */
/*@{*/
#define BP_ECSPI_TESTREG_TXCNT (0U)        /*!< Bit position for ECSPI_TESTREG_TXCNT. */
#define BM_ECSPI_TESTREG_TXCNT (0x0000007FU) /*!< Bit mask for ECSPI_TESTREG_TXCNT. */
#define BS_ECSPI_TESTREG_TXCNT (7U)        /*!< Bit field size in bits for ECSPI_TESTREG_TXCNT. */

/*! @brief Read current value of the ECSPI_TESTREG_TXCNT field. */
#define BR_ECSPI_TESTREG_TXCNT(x) (HW_ECSPI_TESTREG(x).B.TXCNT)

/*! @brief Format value for bitfield ECSPI_TESTREG_TXCNT. */
#define BF_ECSPI_TESTREG_TXCNT(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_TESTREG_TXCNT) & BM_ECSPI_TESTREG_TXCNT)

/*! @brief Set the TXCNT field to a new value. */
#define BW_ECSPI_TESTREG_TXCNT(x, v) (HW_ECSPI_TESTREG_WR(x, (HW_ECSPI_TESTREG_RD(x) & ~BM_ECSPI_TESTREG_TXCNT) | BF_ECSPI_TESTREG_TXCNT(v)))
/*@}*/

/*!
 * @name Register ECSPI_TESTREG, field RXCNT[14:8] (RW)
 *
 * RXFIFO Counter. This field indicates the number of words in the RXFIFO.
 */
/*@{*/
#define BP_ECSPI_TESTREG_RXCNT (8U)        /*!< Bit position for ECSPI_TESTREG_RXCNT. */
#define BM_ECSPI_TESTREG_RXCNT (0x00007F00U) /*!< Bit mask for ECSPI_TESTREG_RXCNT. */
#define BS_ECSPI_TESTREG_RXCNT (7U)        /*!< Bit field size in bits for ECSPI_TESTREG_RXCNT. */

/*! @brief Read current value of the ECSPI_TESTREG_RXCNT field. */
#define BR_ECSPI_TESTREG_RXCNT(x) (HW_ECSPI_TESTREG(x).B.RXCNT)

/*! @brief Format value for bitfield ECSPI_TESTREG_RXCNT. */
#define BF_ECSPI_TESTREG_RXCNT(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_TESTREG_RXCNT) & BM_ECSPI_TESTREG_RXCNT)

/*! @brief Set the RXCNT field to a new value. */
#define BW_ECSPI_TESTREG_RXCNT(x, v) (HW_ECSPI_TESTREG_WR(x, (HW_ECSPI_TESTREG_RD(x) & ~BM_ECSPI_TESTREG_RXCNT) | BF_ECSPI_TESTREG_RXCNT(v)))
/*@}*/

/*!
 * @name Register ECSPI_TESTREG, field LBC[31] (RW)
 *
 * Loop Back Control. This bit is used in Master mode only. When this bit is
 * set, the ECSPI connects the transmitter and receiver sections internally, and the
 * data shifted out from the most-significant bit of the shift register is
 * looped back into the least-significant bit of the Shift register. In this way, a
 * self-test of the complete transmit/receive path can be made. The output pins are
 * not affected, and the input pins are ignored.
 *
 * Values:
 * - 0 - Not connected.
 * - 1 - Transmitter and receiver sections internally connected for Loopback.
 */
/*@{*/
#define BP_ECSPI_TESTREG_LBC (31U)         /*!< Bit position for ECSPI_TESTREG_LBC. */
#define BM_ECSPI_TESTREG_LBC (0x80000000U) /*!< Bit mask for ECSPI_TESTREG_LBC. */
#define BS_ECSPI_TESTREG_LBC (1U)          /*!< Bit field size in bits for ECSPI_TESTREG_LBC. */

/*! @brief Read current value of the ECSPI_TESTREG_LBC field. */
#define BR_ECSPI_TESTREG_LBC(x) (HW_ECSPI_TESTREG(x).B.LBC)

/*! @brief Format value for bitfield ECSPI_TESTREG_LBC. */
#define BF_ECSPI_TESTREG_LBC(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_TESTREG_LBC) & BM_ECSPI_TESTREG_LBC)

/*! @brief Set the LBC field to a new value. */
#define BW_ECSPI_TESTREG_LBC(x, v) (HW_ECSPI_TESTREG_WR(x, (HW_ECSPI_TESTREG_RD(x) & ~BM_ECSPI_TESTREG_LBC) | BF_ECSPI_TESTREG_LBC(v)))
/*@}*/

/*******************************************************************************
 * HW_ECSPI_MSGDATA - Message Data Register
 ******************************************************************************/

/*!
 * @brief HW_ECSPI_MSGDATA - Message Data Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The Message Data Register (ECSPI_MSGDATA) forms the top word of the 16 x 32
 * MSG Data FIFO. Only word-size accesses are allowed for this register. Reads to
 * this register return zero, and writes to this register store data in the MSG
 * Data FIFO.
 */
typedef union _hw_ecspi_msgdata
{
    uint32_t U;
    struct _hw_ecspi_msgdata_bitfields
    {
        uint32_t ECSPI_MSGDATA : 32;   /*!< [31:0]  */
    } B;
} hw_ecspi_msgdata_t;

/*!
 * @name Constants and macros for entire ECSPI_MSGDATA register
 */
/*@{*/
#define HW_ECSPI_MSGDATA_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_ECSPI_MSGDATA(x)      (*(__O hw_ecspi_msgdata_t *) HW_ECSPI_MSGDATA_ADDR(x))
#define HW_ECSPI_MSGDATA_WR(x, v) (HW_ECSPI_MSGDATA(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual ECSPI_MSGDATA bitfields
 */

/*!
 * @name Register ECSPI_MSGDATA, field ECSPI_MSGDATA[31:0] (WO)
 *
 * ECSPI_MSGDATA holds the top word of MSG Data FIFO. The MSG Data FIFO is
 * advanced for each write of this register. The data read is zero. The data written
 * to this register is stored in the MSG Data FIFO.
 */
/*@{*/
#define BP_ECSPI_MSGDATA_ECSPI_MSGDATA (0U) /*!< Bit position for ECSPI_MSGDATA_ECSPI_MSGDATA. */
#define BM_ECSPI_MSGDATA_ECSPI_MSGDATA (0xFFFFFFFFU) /*!< Bit mask for ECSPI_MSGDATA_ECSPI_MSGDATA. */
#define BS_ECSPI_MSGDATA_ECSPI_MSGDATA (32U) /*!< Bit field size in bits for ECSPI_MSGDATA_ECSPI_MSGDATA. */

/*! @brief Format value for bitfield ECSPI_MSGDATA_ECSPI_MSGDATA. */
#define BF_ECSPI_MSGDATA_ECSPI_MSGDATA(v) ((uint32_t)((uint32_t)(v) << BP_ECSPI_MSGDATA_ECSPI_MSGDATA) & BM_ECSPI_MSGDATA_ECSPI_MSGDATA)
/*@}*/

/*******************************************************************************
 * hw_ecspi_t - module struct
 ******************************************************************************/
/*!
 * @brief All ECSPI module registers.
 */
#pragma pack(1)
typedef struct _hw_ecspi
{
    __I hw_ecspi_rxdata_t RXDATA;          /*!< [0x0] Receive Data Register */
    __O hw_ecspi_txdata_t TXDATA;          /*!< [0x4] Transmit Data Register */
    __IO hw_ecspi_conreg_t CONREG;         /*!< [0x8] Control Register */
    __IO hw_ecspi_configreg_t CONFIGREG;   /*!< [0xC] Config Register */
    __IO hw_ecspi_intreg_t INTREG;         /*!< [0x10] Interrupt Control Register */
    __IO hw_ecspi_dmareg_t DMAREG;         /*!< [0x14] DMA Control Register */
    __IO hw_ecspi_statreg_t STATREG;       /*!< [0x18] Status Register */
    __IO hw_ecspi_periodreg_t PERIODREG;   /*!< [0x1C] Sample Period Control Register */
    __IO hw_ecspi_testreg_t TESTREG;       /*!< [0x20] Test Control Register */
    uint8_t _reserved0[28];
    __O hw_ecspi_msgdata_t MSGDATA;        /*!< [0x40] Message Data Register */
} hw_ecspi_t;
#pragma pack()

/*! @brief Macro to access all ECSPI registers. */
/*! @param x ECSPI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ECSPI_REGS(ECSPI1_BASE)</code>. */
#define HW_ECSPI_REGS(x) (*(hw_ecspi_t *)(x))

/*
 * iMX6DP EIM
 *
 * EIM
 *
 * Registers defined in this header file:
 * - HW_EIM_CSnGCR1 - Chip Select n General Configuration Register 1
 * - HW_EIM_CSnGCR2 - Chip Select n General Configuration Register 2
 * - HW_EIM_CSnRCR1 - Chip Select n Read Configuration Register 1
 * - HW_EIM_CSnRCR2 - Chip Select n Read Configuration Register 2
 * - HW_EIM_CSnWCR1 - Chip Select n Write Configuration Register 1
 * - HW_EIM_CSnWCR2 - Chip Select n Write Configuration Register 2
 * - HW_EIM_WCR - EIM Configuration Register
 * - HW_EIM_WIAR - EIM IP Access Register
 * - HW_EIM_EAR - Error Address Register
 *
 * - hw_eim_t - Struct containing all module registers.
 */

#define HW_EIM_INSTANCE_COUNT (1U) /*!< Number of instances of the EIM module. */
#define HW_EIM (0U) /*!< Instance number for EIM. */
#define EIM_BASE              (0x21B8000U) /*!< Base address for EIM. */
/*! Array initializer of EIM base addresses. */
#define EIM_BASE_ADDRS        { EIM_BASE }

/*******************************************************************************
 * HW_EIM_CSnGCR1 - Chip Select n General Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnGCR1 - Chip Select n General Configuration Register 1 (RW)
 *
 * Reset value: 0x00610088U
 */
typedef union _hw_eim_csngcr1
{
    uint32_t U;
    struct _hw_eim_csngcr1_bitfields
    {
        uint32_t CSEN : 1;             /*!< [0]  */
        uint32_t SWR : 1;              /*!< [1]  */
        uint32_t SRD : 1;              /*!< [2]  */
        uint32_t MUM : 1;              /*!< [3]  */
        uint32_t WFL : 1;              /*!< [4]  */
        uint32_t RFL : 1;              /*!< [5]  */
        uint32_t CRE : 1;              /*!< [6]  */
        uint32_t CREP : 1;             /*!< [7]  */
        uint32_t BL : 3;               /*!< [10:8]  */
        uint32_t WC : 1;               /*!< [11]  */
        uint32_t BCD : 2;              /*!< [13:12]  */
        uint32_t BCS : 2;              /*!< [15:14]  */
        uint32_t DSZ : 3;              /*!< [18:16]  */
        uint32_t SP : 1;               /*!< [19]  */
        uint32_t CSREC : 3;            /*!< [22:20]  */
        uint32_t AUS : 1;              /*!< [23]  */
        uint32_t GBC : 3;              /*!< [26:24]  */
        uint32_t WP : 1;               /*!< [27]  */
        uint32_t PSZ : 4;              /*!< [31:28]  */
    } B;
} hw_eim_csngcr1_t;

/*!
 * @name Constants and macros for entire EIM_CSnGCR1 register
 */
/*@{*/
#define HW_EIM_CSnGCR1_COUNT (4U)

#define HW_EIM_CSnGCR1_ADDR(x, n) ((uintptr_t)(x) + 0x0U + (0x18U * (n)))

#define HW_EIM_CSnGCR1(x, n)     (*(__IO hw_eim_csngcr1_t *) HW_EIM_CSnGCR1_ADDR(x, n))
#define HW_EIM_CSnGCR1_RD(x, n)  (HW_EIM_CSnGCR1(x, n).U)
#define HW_EIM_CSnGCR1_WR(x, n, v) (HW_EIM_CSnGCR1(x, n).U = (v))
#define HW_EIM_CSnGCR1_SET(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, HW_EIM_CSnGCR1_RD(x, n) |  (v)))
#define HW_EIM_CSnGCR1_CLR(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, HW_EIM_CSnGCR1_RD(x, n) & ~(v)))
#define HW_EIM_CSnGCR1_TOG(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, HW_EIM_CSnGCR1_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnGCR1 bitfields
 */

/*!
 * @name Register EIM_CSnGCR1, field CSEN[0] (RW)
 *
 * CS Enable. This bit controls the operation of the chip select pin. CSEN is
 * set by a hardware reset for CSGCR0 to allow external boot operation. CSEN is
 * cleared by a hardware reset to CSGCR1-CSGCR5. Reset value for EIM_CS0GCR1 for
 * CSEN is 1. For EIM_CS1GCR1-CS1GCR5 reset value is 0.
 *
 * Values:
 * - 0 - Chip select function is disabled; attempts to access an address mapped
 *     by this chip select results in an error respond and no assertion of the
 *     chip select output
 * - 1 - Chip select is enabled, and is asserted when presented with a valid
 *     access.
 */
/*@{*/
#define BP_EIM_CSnGCR1_CSEN  (0U)          /*!< Bit position for EIM_CSnGCR1_CSEN. */
#define BM_EIM_CSnGCR1_CSEN  (0x00000001U) /*!< Bit mask for EIM_CSnGCR1_CSEN. */
#define BS_EIM_CSnGCR1_CSEN  (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_CSEN. */

/*! @brief Read current value of the EIM_CSnGCR1_CSEN field. */
#define BR_EIM_CSnGCR1_CSEN(x, n) (HW_EIM_CSnGCR1(x, n).B.CSEN)

/*! @brief Format value for bitfield EIM_CSnGCR1_CSEN. */
#define BF_EIM_CSnGCR1_CSEN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_CSEN) & BM_EIM_CSnGCR1_CSEN)

/*! @brief Set the CSEN field to a new value. */
#define BW_EIM_CSnGCR1_CSEN(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_CSEN) | BF_EIM_CSnGCR1_CSEN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field SWR[1] (RW)
 *
 * Synchronous Write Data. This bit field determine the write accesses mode to
 * the External device of the chip select. The External device should be
 * configured to the same mode as this bit implicates. SWR is cleared by a hardware reset.
 * Sync. accesses supported only for 16/32 bit port.
 *
 * Values:
 * - 0 - write accesses are in Asynchronous mode
 * - 1 - write accesses are in Synchronous mode
 */
/*@{*/
#define BP_EIM_CSnGCR1_SWR   (1U)          /*!< Bit position for EIM_CSnGCR1_SWR. */
#define BM_EIM_CSnGCR1_SWR   (0x00000002U) /*!< Bit mask for EIM_CSnGCR1_SWR. */
#define BS_EIM_CSnGCR1_SWR   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_SWR. */

/*! @brief Read current value of the EIM_CSnGCR1_SWR field. */
#define BR_EIM_CSnGCR1_SWR(x, n) (HW_EIM_CSnGCR1(x, n).B.SWR)

/*! @brief Format value for bitfield EIM_CSnGCR1_SWR. */
#define BF_EIM_CSnGCR1_SWR(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_SWR) & BM_EIM_CSnGCR1_SWR)

/*! @brief Set the SWR field to a new value. */
#define BW_EIM_CSnGCR1_SWR(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_SWR) | BF_EIM_CSnGCR1_SWR(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field SRD[2] (RW)
 *
 * Synchronous Read Data. This bit field determine the read accesses mode to the
 * External device of the chip select. The External device should be configured
 * to the same mode as this bit implicates. SRD is cleared by a hardware reset.
 * Sync. accesses supported only for 16/32 bit port.
 *
 * Values:
 * - 0 - read accesses are in Asynchronous mode
 * - 1 - read accesses are in Synchronous mode
 */
/*@{*/
#define BP_EIM_CSnGCR1_SRD   (2U)          /*!< Bit position for EIM_CSnGCR1_SRD. */
#define BM_EIM_CSnGCR1_SRD   (0x00000004U) /*!< Bit mask for EIM_CSnGCR1_SRD. */
#define BS_EIM_CSnGCR1_SRD   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_SRD. */

/*! @brief Read current value of the EIM_CSnGCR1_SRD field. */
#define BR_EIM_CSnGCR1_SRD(x, n) (HW_EIM_CSnGCR1(x, n).B.SRD)

/*! @brief Format value for bitfield EIM_CSnGCR1_SRD. */
#define BF_EIM_CSnGCR1_SRD(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_SRD) & BM_EIM_CSnGCR1_SRD)

/*! @brief Set the SRD field to a new value. */
#define BW_EIM_CSnGCR1_SRD(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_SRD) | BF_EIM_CSnGCR1_SRD(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field MUM[3] (RW)
 *
 * Multiplexed Mode. This bit determines the address/data multiplexed mode for
 * asynchronous and synchronous accesses for 8 bit, 16 bit or 32 bit devices (DSZ
 * config. dependent). The reset value for EIM_CS0GCR1[MUM] = EIM_BOOT[2]. For
 * EIM_CS1GCR1 - EIM_CS5GCR1 the reset value is 0.
 *
 * Values:
 * - 0 - Multiplexed Mode disable
 * - 1 - Multiplexed Mode enable
 */
/*@{*/
#define BP_EIM_CSnGCR1_MUM   (3U)          /*!< Bit position for EIM_CSnGCR1_MUM. */
#define BM_EIM_CSnGCR1_MUM   (0x00000008U) /*!< Bit mask for EIM_CSnGCR1_MUM. */
#define BS_EIM_CSnGCR1_MUM   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_MUM. */

/*! @brief Read current value of the EIM_CSnGCR1_MUM field. */
#define BR_EIM_CSnGCR1_MUM(x, n) (HW_EIM_CSnGCR1(x, n).B.MUM)

/*! @brief Format value for bitfield EIM_CSnGCR1_MUM. */
#define BF_EIM_CSnGCR1_MUM(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_MUM) & BM_EIM_CSnGCR1_MUM)

/*! @brief Set the MUM field to a new value. */
#define BW_EIM_CSnGCR1_MUM(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_MUM) | BF_EIM_CSnGCR1_MUM(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field WFL[4] (RW)
 *
 * Write Fix Latency. This bit field determine if the controller is monitoring
 * the WAIT signal from the External device connected to the chip select
 * (handshake mode - fix or variable data latency) or if it start data transfer according
 * to WWSC field, it only valid in synchronous mode. WFL is cleared by a hardware
 * reset. When WFL=1 Burst access is terminated on page boundary and resume on
 * the following page according to BL bit field configuration, because WAIT signal
 * is not monitored from the external device
 *
 * Values:
 * - 0 - the External device WAIT signal is being monitored, and it reflect the
 *     external data bus state
 * - 1 - the state of the External devices is determined internally (Fix latency
 *     mode only)
 */
/*@{*/
#define BP_EIM_CSnGCR1_WFL   (4U)          /*!< Bit position for EIM_CSnGCR1_WFL. */
#define BM_EIM_CSnGCR1_WFL   (0x00000010U) /*!< Bit mask for EIM_CSnGCR1_WFL. */
#define BS_EIM_CSnGCR1_WFL   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_WFL. */

/*! @brief Read current value of the EIM_CSnGCR1_WFL field. */
#define BR_EIM_CSnGCR1_WFL(x, n) (HW_EIM_CSnGCR1(x, n).B.WFL)

/*! @brief Format value for bitfield EIM_CSnGCR1_WFL. */
#define BF_EIM_CSnGCR1_WFL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_WFL) & BM_EIM_CSnGCR1_WFL)

/*! @brief Set the WFL field to a new value. */
#define BW_EIM_CSnGCR1_WFL(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_WFL) | BF_EIM_CSnGCR1_WFL(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field RFL[5] (RW)
 *
 * Read Fix Latency. This bit field determine if the controller is monitoring
 * the WAIT signal from the External device connected to the chip select (handshake
 * mode - fix or variable data latency) or if it start sampling data according
 * to RWSC field, it only valid in synchronous mode. RFL is cleared by a hardware
 * reset. When RFL=1 Burst access is terminated on page boundary and resume on
 * the following page according to BL bit field configuration, because WAIT signal
 * is not monitored from the external device.
 *
 * Values:
 * - 0 - the External device WAIT signal is being monitored, and it reflect the
 *     external data bus state
 * - 1 - the state of the External devices is determined internally (Fix latency
 *     mode only)
 */
/*@{*/
#define BP_EIM_CSnGCR1_RFL   (5U)          /*!< Bit position for EIM_CSnGCR1_RFL. */
#define BM_EIM_CSnGCR1_RFL   (0x00000020U) /*!< Bit mask for EIM_CSnGCR1_RFL. */
#define BS_EIM_CSnGCR1_RFL   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_RFL. */

/*! @brief Read current value of the EIM_CSnGCR1_RFL field. */
#define BR_EIM_CSnGCR1_RFL(x, n) (HW_EIM_CSnGCR1(x, n).B.RFL)

/*! @brief Format value for bitfield EIM_CSnGCR1_RFL. */
#define BF_EIM_CSnGCR1_RFL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_RFL) & BM_EIM_CSnGCR1_RFL)

/*! @brief Set the RFL field to a new value. */
#define BW_EIM_CSnGCR1_RFL(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_RFL) | BF_EIM_CSnGCR1_RFL(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field CRE[6] (RW)
 *
 * Configuration Register Enable. This bit indicates CRE memory pin state while
 * executing a memory register set command to PSRAM external device. CRE is
 * cleared by a hardware reset.
 *
 * Values:
 * - 0 - CRE signal use is disable
 * - 1 - CRE signal use is enable
 */
/*@{*/
#define BP_EIM_CSnGCR1_CRE   (6U)          /*!< Bit position for EIM_CSnGCR1_CRE. */
#define BM_EIM_CSnGCR1_CRE   (0x00000040U) /*!< Bit mask for EIM_CSnGCR1_CRE. */
#define BS_EIM_CSnGCR1_CRE   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_CRE. */

/*! @brief Read current value of the EIM_CSnGCR1_CRE field. */
#define BR_EIM_CSnGCR1_CRE(x, n) (HW_EIM_CSnGCR1(x, n).B.CRE)

/*! @brief Format value for bitfield EIM_CSnGCR1_CRE. */
#define BF_EIM_CSnGCR1_CRE(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_CRE) & BM_EIM_CSnGCR1_CRE)

/*! @brief Set the CRE field to a new value. */
#define BW_EIM_CSnGCR1_CRE(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_CRE) | BF_EIM_CSnGCR1_CRE(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field CREP[7] (RW)
 *
 * Configuration Register Enable Polarity. This bit indicates CRE memory pin
 * assertion state, active-low or active-high, while executing a memory register set
 * command to the external device (PSRAM memory type). CREP is set by a hardware
 * reset. Whenever PSRAM is connected the CREP value must be correct also for
 * accesses where CRE is disabled. For Non-PSRAM memory CREP value should be 1.
 *
 * Values:
 * - 0 - CRE signal is active low
 * - 1 - CRE signal is active high
 */
/*@{*/
#define BP_EIM_CSnGCR1_CREP  (7U)          /*!< Bit position for EIM_CSnGCR1_CREP. */
#define BM_EIM_CSnGCR1_CREP  (0x00000080U) /*!< Bit mask for EIM_CSnGCR1_CREP. */
#define BS_EIM_CSnGCR1_CREP  (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_CREP. */

/*! @brief Read current value of the EIM_CSnGCR1_CREP field. */
#define BR_EIM_CSnGCR1_CREP(x, n) (HW_EIM_CSnGCR1(x, n).B.CREP)

/*! @brief Format value for bitfield EIM_CSnGCR1_CREP. */
#define BF_EIM_CSnGCR1_CREP(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_CREP) & BM_EIM_CSnGCR1_CREP)

/*! @brief Set the CREP field to a new value. */
#define BW_EIM_CSnGCR1_CREP(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_CREP) | BF_EIM_CSnGCR1_CREP(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field BL[10:8] (RW)
 *
 * Burst Length. The BL bit field indicates memory burst length in words (word
 * is defined by the DSZ field) and should be properly initialized for mixed
 * wrap/increment accesses support. Continuous BL value corresponds to continuous
 * burst length setting of the external memory device. For fix memory burst size,
 * type is always wrap. In case not matching wrap boundaries in both the memory (BL
 * field) and Master access on the current address, EIM update address on the
 * external device address bus and regenerates the access. BL is cleared by a
 * hardware reset. When APR=1, Page Read Mode is applied, BL determine the number of
 * words within the read page burst. BL is cleared by a hardware reset for
 * EIM_CS0GCR1 - EIM_CS5GCR1.
 *
 * Values:
 * - 000 - 4 words Memory wrap burst length (read page burst size when APR = 1)
 * - 001 - 8 words Memory wrap burst length (read page burst size when APR = 1)
 * - 010 - 16 words Memory wrap burst length (read page burst size when APR = 1)
 * - 011 - 32 words Memory wrap burst length (read page burst size when APR = 1)
 * - 100 - Continuous burst length (2 words read page burst size when APR = 1)
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_EIM_CSnGCR1_BL    (8U)          /*!< Bit position for EIM_CSnGCR1_BL. */
#define BM_EIM_CSnGCR1_BL    (0x00000700U) /*!< Bit mask for EIM_CSnGCR1_BL. */
#define BS_EIM_CSnGCR1_BL    (3U)          /*!< Bit field size in bits for EIM_CSnGCR1_BL. */

/*! @brief Read current value of the EIM_CSnGCR1_BL field. */
#define BR_EIM_CSnGCR1_BL(x, n) (HW_EIM_CSnGCR1(x, n).B.BL)

/*! @brief Format value for bitfield EIM_CSnGCR1_BL. */
#define BF_EIM_CSnGCR1_BL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_BL) & BM_EIM_CSnGCR1_BL)

/*! @brief Set the BL field to a new value. */
#define BW_EIM_CSnGCR1_BL(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_BL) | BF_EIM_CSnGCR1_BL(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field WC[11] (RW)
 *
 * Write Continuous. The WI bit indicates that write access to the memory are
 * always continuous accesses regardless of the BL field value. WI is cleared by
 * hardware reset.
 *
 * Values:
 * - 0 - Write access burst length occurs according to BL value.
 * - 1 - Write access burst length is continuous.
 */
/*@{*/
#define BP_EIM_CSnGCR1_WC    (11U)         /*!< Bit position for EIM_CSnGCR1_WC. */
#define BM_EIM_CSnGCR1_WC    (0x00000800U) /*!< Bit mask for EIM_CSnGCR1_WC. */
#define BS_EIM_CSnGCR1_WC    (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_WC. */

/*! @brief Read current value of the EIM_CSnGCR1_WC field. */
#define BR_EIM_CSnGCR1_WC(x, n) (HW_EIM_CSnGCR1(x, n).B.WC)

/*! @brief Format value for bitfield EIM_CSnGCR1_WC. */
#define BF_EIM_CSnGCR1_WC(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_WC) & BM_EIM_CSnGCR1_WC)

/*! @brief Set the WC field to a new value. */
#define BW_EIM_CSnGCR1_WC(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_WC) | BF_EIM_CSnGCR1_WC(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field BCD[13:12] (RW)
 *
 * Burst Clock Divisor. This bit field contains the value used to program the
 * burst clock divisor for BCLK generation. It is used to divide the internal
 * EIMbus frequency. BCD is cleared by a hardware reset. For other then the mentioned
 * below frequency such as 104 MHz, EIM clock (input clock) should be adjust
 * accordingly.
 *
 * Values:
 * - 00 - Divide EIM clock by 1
 * - 01 - Divide EIM clock by 2
 * - 10 - Divide EIM clock by 3
 * - 11 - Divide EIM clock by 4
 */
/*@{*/
#define BP_EIM_CSnGCR1_BCD   (12U)         /*!< Bit position for EIM_CSnGCR1_BCD. */
#define BM_EIM_CSnGCR1_BCD   (0x00003000U) /*!< Bit mask for EIM_CSnGCR1_BCD. */
#define BS_EIM_CSnGCR1_BCD   (2U)          /*!< Bit field size in bits for EIM_CSnGCR1_BCD. */

/*! @brief Read current value of the EIM_CSnGCR1_BCD field. */
#define BR_EIM_CSnGCR1_BCD(x, n) (HW_EIM_CSnGCR1(x, n).B.BCD)

/*! @brief Format value for bitfield EIM_CSnGCR1_BCD. */
#define BF_EIM_CSnGCR1_BCD(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_BCD) & BM_EIM_CSnGCR1_BCD)

/*! @brief Set the BCD field to a new value. */
#define BW_EIM_CSnGCR1_BCD(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_BCD) | BF_EIM_CSnGCR1_BCD(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field BCS[15:14] (RW)
 *
 * Burst Clock Start. When SRD=1 or SWR=1,this bit field determines the number
 * of EIM clock cycles delay from start of access before the first rising edge of
 * BCLK is generated. When BCD=0 value of BCS=0 results in a half clock delay
 * after the start of access. For other values of BCD a one clock delay after the
 * start of access is applied, not an immediate assertion. BCS is cleared by a
 * hardware reset.
 *
 * Values:
 * - 00 - 0 EIM clock cycle additional delay
 * - 01 - 1 EIM clock cycle additional delay
 * - 10 - 2 EIM clock cycle additional delay
 * - 11 - 3 EIM clock cycle additional delay
 */
/*@{*/
#define BP_EIM_CSnGCR1_BCS   (14U)         /*!< Bit position for EIM_CSnGCR1_BCS. */
#define BM_EIM_CSnGCR1_BCS   (0x0000C000U) /*!< Bit mask for EIM_CSnGCR1_BCS. */
#define BS_EIM_CSnGCR1_BCS   (2U)          /*!< Bit field size in bits for EIM_CSnGCR1_BCS. */

/*! @brief Read current value of the EIM_CSnGCR1_BCS field. */
#define BR_EIM_CSnGCR1_BCS(x, n) (HW_EIM_CSnGCR1(x, n).B.BCS)

/*! @brief Format value for bitfield EIM_CSnGCR1_BCS. */
#define BF_EIM_CSnGCR1_BCS(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_BCS) & BM_EIM_CSnGCR1_BCS)

/*! @brief Set the BCS field to a new value. */
#define BW_EIM_CSnGCR1_BCS(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_BCS) | BF_EIM_CSnGCR1_BCS(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field DSZ[18:16] (RW)
 *
 * Data Port Size. This bit field defines the width of an external device's data
 * port as shown below. Only async. access supported for 8 bit port. The reset
 * value for EIM_CS0GCR1, DSZ[2] = 0, DSZ[1:0] = EIM_BOOT[1:0]. For EIM_CS1GCR1 -
 * EIM_CS5GCR1, the reset value is 0b001.
 *
 * Values:
 * - 000 - Reserved.
 * - 001 - 16 bit port resides on DATA[15:0]
 * - 010 - 16 bit port resides on DATA[31:16]
 * - 011 - 32 bit port resides on DATA[31:0]
 * - 100 - 8 bit port resides on DATA[7:0]
 * - 101 - 8 bit port resides on DATA[15:8]
 * - 110 - 8 bit port resides on DATA[23:16]
 * - 111 - 8 bit port resides on DATA[31:24]
 */
/*@{*/
#define BP_EIM_CSnGCR1_DSZ   (16U)         /*!< Bit position for EIM_CSnGCR1_DSZ. */
#define BM_EIM_CSnGCR1_DSZ   (0x00070000U) /*!< Bit mask for EIM_CSnGCR1_DSZ. */
#define BS_EIM_CSnGCR1_DSZ   (3U)          /*!< Bit field size in bits for EIM_CSnGCR1_DSZ. */

/*! @brief Read current value of the EIM_CSnGCR1_DSZ field. */
#define BR_EIM_CSnGCR1_DSZ(x, n) (HW_EIM_CSnGCR1(x, n).B.DSZ)

/*! @brief Format value for bitfield EIM_CSnGCR1_DSZ. */
#define BF_EIM_CSnGCR1_DSZ(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_DSZ) & BM_EIM_CSnGCR1_DSZ)

/*! @brief Set the DSZ field to a new value. */
#define BW_EIM_CSnGCR1_DSZ(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_DSZ) | BF_EIM_CSnGCR1_DSZ(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field SP[19] (RW)
 *
 * Supervisor Protect. This bit prevents accesses to the address range defined
 * by the corresponding chip select when the access is attempted in the User mode.
 * SP is cleared by a hardware reset.
 *
 * Values:
 * - 0 - User mode accesses are allowed in the memory range defined by chip
 *     select.
 * - 1 - User mode accesses are prohibited. All attempts to access an address
 *     mapped by this chip select in User mode results in an error response and no
 *     assertion of the chip select output.
 */
/*@{*/
#define BP_EIM_CSnGCR1_SP    (19U)         /*!< Bit position for EIM_CSnGCR1_SP. */
#define BM_EIM_CSnGCR1_SP    (0x00080000U) /*!< Bit mask for EIM_CSnGCR1_SP. */
#define BS_EIM_CSnGCR1_SP    (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_SP. */

/*! @brief Read current value of the EIM_CSnGCR1_SP field. */
#define BR_EIM_CSnGCR1_SP(x, n) (HW_EIM_CSnGCR1(x, n).B.SP)

/*! @brief Format value for bitfield EIM_CSnGCR1_SP. */
#define BF_EIM_CSnGCR1_SP(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_SP) & BM_EIM_CSnGCR1_SP)

/*! @brief Set the SP field to a new value. */
#define BW_EIM_CSnGCR1_SP(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_SP) | BF_EIM_CSnGCR1_SP(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field CSREC[22:20] (RW)
 *
 * CS Recovery. This bit field, according to the settings shown below,
 * determines the minimum pulse width of CS, OE, and WE control signals before executing a
 * new back to back access to the same chip select. CSREC is cleared by a
 * hardware reset. The reset value for EIM_CS0GCR1, CSREC[2:0] is 0b110. For
 * EIM_CS1GCR1 - EIM_CS5GCR, the reset value is 0b000. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles minimum width of CS, OE and WE signals (read
 *     async. mode only)
 * - 001 - 1 EIM clock cycles minimum width of CS, OE and WE signals
 * - 010 - 2 EIM clock cycles minimum width of CS, OE and WE signals
 * - 111 - 7 EIM clock cycles minimum width of CS, OE and WE signals
 */
/*@{*/
#define BP_EIM_CSnGCR1_CSREC (20U)         /*!< Bit position for EIM_CSnGCR1_CSREC. */
#define BM_EIM_CSnGCR1_CSREC (0x00700000U) /*!< Bit mask for EIM_CSnGCR1_CSREC. */
#define BS_EIM_CSnGCR1_CSREC (3U)          /*!< Bit field size in bits for EIM_CSnGCR1_CSREC. */

/*! @brief Read current value of the EIM_CSnGCR1_CSREC field. */
#define BR_EIM_CSnGCR1_CSREC(x, n) (HW_EIM_CSnGCR1(x, n).B.CSREC)

/*! @brief Format value for bitfield EIM_CSnGCR1_CSREC. */
#define BF_EIM_CSnGCR1_CSREC(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_CSREC) & BM_EIM_CSnGCR1_CSREC)

/*! @brief Set the CSREC field to a new value. */
#define BW_EIM_CSnGCR1_CSREC(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_CSREC) | BF_EIM_CSnGCR1_CSREC(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field AUS[23] (RW)
 *
 * Address UnShifted. This bit indicates an unshifted mode for address assertion
 * for the relevant chip select accesses. AUS bit is cleared by hardware reset.
 *
 * Values:
 * - 0 - Address shifted according to port size (DSZ config) (128 Mbyte maximum
 *     supported memory density).
 * - 1 - Address unshifted (32 Mbyte maximum supported memory density).
 */
/*@{*/
#define BP_EIM_CSnGCR1_AUS   (23U)         /*!< Bit position for EIM_CSnGCR1_AUS. */
#define BM_EIM_CSnGCR1_AUS   (0x00800000U) /*!< Bit mask for EIM_CSnGCR1_AUS. */
#define BS_EIM_CSnGCR1_AUS   (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_AUS. */

/*! @brief Read current value of the EIM_CSnGCR1_AUS field. */
#define BR_EIM_CSnGCR1_AUS(x, n) (HW_EIM_CSnGCR1(x, n).B.AUS)

/*! @brief Format value for bitfield EIM_CSnGCR1_AUS. */
#define BF_EIM_CSnGCR1_AUS(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_AUS) & BM_EIM_CSnGCR1_AUS)

/*! @brief Set the AUS field to a new value. */
#define BW_EIM_CSnGCR1_AUS(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_AUS) | BF_EIM_CSnGCR1_AUS(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field GBC[26:24] (RW)
 *
 * Gap Between Chip Selects. This bit field, according to the settings shown
 * below, determines the minimum time between end of access to the current chip
 * select and start of access to different chip select. GBC is cleared by a hardware
 * reset. Example settings:
 *
 * Values:
 * - 000 - minimum of 0 EIM clock cycles before next access from different chip
 *     select (async. mode only)
 * - 001 - minimum of 1 EIM clock cycles before next access from different chip
 *     select
 * - 010 - minimum of 2 EIM clock cycles before next access from different chip
 *     select
 * - 111 - minimum of 7 EIM clock cycles before next access from different chip
 *     select
 */
/*@{*/
#define BP_EIM_CSnGCR1_GBC   (24U)         /*!< Bit position for EIM_CSnGCR1_GBC. */
#define BM_EIM_CSnGCR1_GBC   (0x07000000U) /*!< Bit mask for EIM_CSnGCR1_GBC. */
#define BS_EIM_CSnGCR1_GBC   (3U)          /*!< Bit field size in bits for EIM_CSnGCR1_GBC. */

/*! @brief Read current value of the EIM_CSnGCR1_GBC field. */
#define BR_EIM_CSnGCR1_GBC(x, n) (HW_EIM_CSnGCR1(x, n).B.GBC)

/*! @brief Format value for bitfield EIM_CSnGCR1_GBC. */
#define BF_EIM_CSnGCR1_GBC(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_GBC) & BM_EIM_CSnGCR1_GBC)

/*! @brief Set the GBC field to a new value. */
#define BW_EIM_CSnGCR1_GBC(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_GBC) | BF_EIM_CSnGCR1_GBC(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field WP[27] (RW)
 *
 * Write Protect. This bit prevents writes to the address range defined by the
 * corresponding chip select. WP is cleared by a hardware reset.
 *
 * Values:
 * - 0 - Writes are allowed in the memory range defined by chip.
 * - 1 - Writes are prohibited. All attempts to write to an address mapped by
 *     this chip select result in a error response and no assertion of the chip
 *     select output.
 */
/*@{*/
#define BP_EIM_CSnGCR1_WP    (27U)         /*!< Bit position for EIM_CSnGCR1_WP. */
#define BM_EIM_CSnGCR1_WP    (0x08000000U) /*!< Bit mask for EIM_CSnGCR1_WP. */
#define BS_EIM_CSnGCR1_WP    (1U)          /*!< Bit field size in bits for EIM_CSnGCR1_WP. */

/*! @brief Read current value of the EIM_CSnGCR1_WP field. */
#define BR_EIM_CSnGCR1_WP(x, n) (HW_EIM_CSnGCR1(x, n).B.WP)

/*! @brief Format value for bitfield EIM_CSnGCR1_WP. */
#define BF_EIM_CSnGCR1_WP(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_WP) & BM_EIM_CSnGCR1_WP)

/*! @brief Set the WP field to a new value. */
#define BW_EIM_CSnGCR1_WP(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_WP) | BF_EIM_CSnGCR1_WP(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR1, field PSZ[31:28] (RW)
 *
 * Page Size. This bit field indicates memory page size in words (word is
 * defined by the DSZ field). PSZ is used when fix latency mode is applied, WFL=1 for
 * sync. write accesses, RFL=1 for sync. Read accesses. When working in fix
 * latency mode WAIT signal from the external device is not being monitored, PSZ is
 * used to determine if page boundary is reached and renewal of access is preformed.
 * This bit field is ignored when sync. Mode is disabled or fix latency mode is
 * not being used for write or read access separately. It can be valid for both
 * access type, read or write, or only for one type, according to configuration.
 * PSZ is cleared by a hardware reset.
 *
 * Values:
 * - 0000 - 8 words page size
 * - 0001 - 16 words page size
 * - 0010 - 32 words page size
 * - 0011 - 64 words page size
 * - 0100 - 128 words page size
 * - 0101 - 256 words page size
 * - 0110 - 512 words page size
 * - 0111 - 1024 (1k) words page size
 * - 1000 - 2048 (2k) words page size
 * - 1001 - - 1111 Reserved
 */
/*@{*/
#define BP_EIM_CSnGCR1_PSZ   (28U)         /*!< Bit position for EIM_CSnGCR1_PSZ. */
#define BM_EIM_CSnGCR1_PSZ   (0xF0000000U) /*!< Bit mask for EIM_CSnGCR1_PSZ. */
#define BS_EIM_CSnGCR1_PSZ   (4U)          /*!< Bit field size in bits for EIM_CSnGCR1_PSZ. */

/*! @brief Read current value of the EIM_CSnGCR1_PSZ field. */
#define BR_EIM_CSnGCR1_PSZ(x, n) (HW_EIM_CSnGCR1(x, n).B.PSZ)

/*! @brief Format value for bitfield EIM_CSnGCR1_PSZ. */
#define BF_EIM_CSnGCR1_PSZ(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR1_PSZ) & BM_EIM_CSnGCR1_PSZ)

/*! @brief Set the PSZ field to a new value. */
#define BW_EIM_CSnGCR1_PSZ(x, n, v) (HW_EIM_CSnGCR1_WR(x, n, (HW_EIM_CSnGCR1_RD(x, n) & ~BM_EIM_CSnGCR1_PSZ) | BF_EIM_CSnGCR1_PSZ(v)))
/*@}*/
/*******************************************************************************
 * HW_EIM_CSnGCR2 - Chip Select n General Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnGCR2 - Chip Select n General Configuration Register 2 (RW)
 *
 * Reset value: 0x00001010U
 */
typedef union _hw_eim_csngcr2
{
    uint32_t U;
    struct _hw_eim_csngcr2_bitfields
    {
        uint32_t ADH : 2;              /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t DAPS : 4;             /*!< [7:4]  */
        uint32_t DAE : 1;              /*!< [8]  */
        uint32_t DAP : 1;              /*!< [9]  */
        uint32_t RESERVED1 : 2;        /*!< [11:10]  */
        uint32_t MUX16_BYP_GRANT : 1;  /*!< [12]  */
        uint32_t RESERVED2 : 19;       /*!< [31:13]  */
    } B;
} hw_eim_csngcr2_t;

/*!
 * @name Constants and macros for entire EIM_CSnGCR2 register
 */
/*@{*/
#define HW_EIM_CSnGCR2_COUNT (4U)

#define HW_EIM_CSnGCR2_ADDR(x, n) ((uintptr_t)(x) + 0x4U + (0x18U * (n)))

#define HW_EIM_CSnGCR2(x, n)     (*(__IO hw_eim_csngcr2_t *) HW_EIM_CSnGCR2_ADDR(x, n))
#define HW_EIM_CSnGCR2_RD(x, n)  (HW_EIM_CSnGCR2(x, n).U)
#define HW_EIM_CSnGCR2_WR(x, n, v) (HW_EIM_CSnGCR2(x, n).U = (v))
#define HW_EIM_CSnGCR2_SET(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, HW_EIM_CSnGCR2_RD(x, n) |  (v)))
#define HW_EIM_CSnGCR2_CLR(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, HW_EIM_CSnGCR2_RD(x, n) & ~(v)))
#define HW_EIM_CSnGCR2_TOG(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, HW_EIM_CSnGCR2_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnGCR2 bitfields
 */

/*!
 * @name Register EIM_CSnGCR2, field ADH[1:0] (RW)
 *
 * Address hold time - This bit field determine the address hold time after ADV
 * negation when mum = 1 (muxed mode). When mum = 0 this bit has no effect. For
 * read accesses the field determines when the pads direction will be switched.
 * Reset value for EIM_CS0GCR2 for ADH is 0b10. For EIM_CS1GCR2-EIM_CS5GCR2 reset
 * value is 0b00.
 *
 * Values:
 * - 00 - 0 cycle after ADV negation
 * - 01 - 1 cycle after ADV negation
 * - 10 - 2 cycle after ADV negation
 * - 11 - Reserved
 */
/*@{*/
#define BP_EIM_CSnGCR2_ADH   (0U)          /*!< Bit position for EIM_CSnGCR2_ADH. */
#define BM_EIM_CSnGCR2_ADH   (0x00000003U) /*!< Bit mask for EIM_CSnGCR2_ADH. */
#define BS_EIM_CSnGCR2_ADH   (2U)          /*!< Bit field size in bits for EIM_CSnGCR2_ADH. */

/*! @brief Read current value of the EIM_CSnGCR2_ADH field. */
#define BR_EIM_CSnGCR2_ADH(x, n) (HW_EIM_CSnGCR2(x, n).B.ADH)

/*! @brief Format value for bitfield EIM_CSnGCR2_ADH. */
#define BF_EIM_CSnGCR2_ADH(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR2_ADH) & BM_EIM_CSnGCR2_ADH)

/*! @brief Set the ADH field to a new value. */
#define BW_EIM_CSnGCR2_ADH(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, (HW_EIM_CSnGCR2_RD(x, n) & ~BM_EIM_CSnGCR2_ADH) | BF_EIM_CSnGCR2_ADH(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR2, field DAPS[7:4] (RW)
 *
 * Data Acknowledge Poling Start. This bit field determine the starting point of
 * DTACK input signal polling. DAPS is used only in asynchronous single read or
 * write accesses. Since DTACK is an async. signal the start point of DTACK
 * signal polling is at least 3 cycles after the start of access. DAPS is cleared by a
 * hardware reset. Example settings:
 *
 * Values:
 * - 0000 - 3 EIM clk cycle between start of access and first DTACK check
 * - 0001 - 4 EIM clk cycles between start of access and first DTACK check
 * - 0010 - 5 EIM clk cycles between start of access and first DTACK check
 * - 0111 - 10 EIM clk cycles between start of access and first DTACK check
 * - 1011 - 14 EIM clk cycles between start of access and first DTACK check
 * - 1111 - 18 EIM clk cycles between start of access and first DTACK check
 */
/*@{*/
#define BP_EIM_CSnGCR2_DAPS  (4U)          /*!< Bit position for EIM_CSnGCR2_DAPS. */
#define BM_EIM_CSnGCR2_DAPS  (0x000000F0U) /*!< Bit mask for EIM_CSnGCR2_DAPS. */
#define BS_EIM_CSnGCR2_DAPS  (4U)          /*!< Bit field size in bits for EIM_CSnGCR2_DAPS. */

/*! @brief Read current value of the EIM_CSnGCR2_DAPS field. */
#define BR_EIM_CSnGCR2_DAPS(x, n) (HW_EIM_CSnGCR2(x, n).B.DAPS)

/*! @brief Format value for bitfield EIM_CSnGCR2_DAPS. */
#define BF_EIM_CSnGCR2_DAPS(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR2_DAPS) & BM_EIM_CSnGCR2_DAPS)

/*! @brief Set the DAPS field to a new value. */
#define BW_EIM_CSnGCR2_DAPS(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, (HW_EIM_CSnGCR2_RD(x, n) & ~BM_EIM_CSnGCR2_DAPS) | BF_EIM_CSnGCR2_DAPS(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR2, field DAE[8] (RW)
 *
 * Data Acknowledge Enable. This bit indicates external device is using DTACK
 * pin as strobe/terminator of an async. access. DTACK signal may be used only in
 * asynchronous single read (APR=0) or write accesses. DTACK poling start point is
 * set by DAPS bit field. polarity of DTACK is set by DAP bit field. DAE is
 * cleared by a hardware reset.
 *
 * Values:
 * - 0 - DTACK signal use is disable
 * - 1 - DTACK signal use is enable
 */
/*@{*/
#define BP_EIM_CSnGCR2_DAE   (8U)          /*!< Bit position for EIM_CSnGCR2_DAE. */
#define BM_EIM_CSnGCR2_DAE   (0x00000100U) /*!< Bit mask for EIM_CSnGCR2_DAE. */
#define BS_EIM_CSnGCR2_DAE   (1U)          /*!< Bit field size in bits for EIM_CSnGCR2_DAE. */

/*! @brief Read current value of the EIM_CSnGCR2_DAE field. */
#define BR_EIM_CSnGCR2_DAE(x, n) (HW_EIM_CSnGCR2(x, n).B.DAE)

/*! @brief Format value for bitfield EIM_CSnGCR2_DAE. */
#define BF_EIM_CSnGCR2_DAE(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR2_DAE) & BM_EIM_CSnGCR2_DAE)

/*! @brief Set the DAE field to a new value. */
#define BW_EIM_CSnGCR2_DAE(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, (HW_EIM_CSnGCR2_RD(x, n) & ~BM_EIM_CSnGCR2_DAE) | BF_EIM_CSnGCR2_DAE(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR2, field DAP[9] (RW)
 *
 * Data Acknowledge Polarity. This bit indicates DTACK memory pin assertion
 * state, active-low or active-high, while executing an async access using DTACK
 * signal from the external device. DAP is cleared by a hardware reset.
 *
 * Values:
 * - 0 - DTACK signal is active high
 * - 1 - DTACK signal is active low
 */
/*@{*/
#define BP_EIM_CSnGCR2_DAP   (9U)          /*!< Bit position for EIM_CSnGCR2_DAP. */
#define BM_EIM_CSnGCR2_DAP   (0x00000200U) /*!< Bit mask for EIM_CSnGCR2_DAP. */
#define BS_EIM_CSnGCR2_DAP   (1U)          /*!< Bit field size in bits for EIM_CSnGCR2_DAP. */

/*! @brief Read current value of the EIM_CSnGCR2_DAP field. */
#define BR_EIM_CSnGCR2_DAP(x, n) (HW_EIM_CSnGCR2(x, n).B.DAP)

/*! @brief Format value for bitfield EIM_CSnGCR2_DAP. */
#define BF_EIM_CSnGCR2_DAP(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR2_DAP) & BM_EIM_CSnGCR2_DAP)

/*! @brief Set the DAP field to a new value. */
#define BW_EIM_CSnGCR2_DAP(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, (HW_EIM_CSnGCR2_RD(x, n) & ~BM_EIM_CSnGCR2_DAP) | BF_EIM_CSnGCR2_DAP(v)))
/*@}*/

/*!
 * @name Register EIM_CSnGCR2, field MUX16_BYP_GRANT[12] (RW)
 *
 * Muxed 16 bypass grant. This bit when asserted causes EIM to bypass the
 * grant/ack. arbitration with NFC (only for 16 bit muxed mode accesses).
 *
 * Values:
 * - 0 - EIM waits for grant before driving a 16 bit muxed mode access to the
 *     memory.
 * - 1 - EIM ignores the grant signal and immediately drives a 16 bit muxed mode
 *     access to the memory.
 */
/*@{*/
#define BP_EIM_CSnGCR2_MUX16_BYP_GRANT (12U) /*!< Bit position for EIM_CSnGCR2_MUX16_BYP_GRANT. */
#define BM_EIM_CSnGCR2_MUX16_BYP_GRANT (0x00001000U) /*!< Bit mask for EIM_CSnGCR2_MUX16_BYP_GRANT. */
#define BS_EIM_CSnGCR2_MUX16_BYP_GRANT (1U) /*!< Bit field size in bits for EIM_CSnGCR2_MUX16_BYP_GRANT. */

/*! @brief Read current value of the EIM_CSnGCR2_MUX16_BYP_GRANT field. */
#define BR_EIM_CSnGCR2_MUX16_BYP_GRANT(x, n) (HW_EIM_CSnGCR2(x, n).B.MUX16_BYP_GRANT)

/*! @brief Format value for bitfield EIM_CSnGCR2_MUX16_BYP_GRANT. */
#define BF_EIM_CSnGCR2_MUX16_BYP_GRANT(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnGCR2_MUX16_BYP_GRANT) & BM_EIM_CSnGCR2_MUX16_BYP_GRANT)

/*! @brief Set the MUX16_BYP_GRANT field to a new value. */
#define BW_EIM_CSnGCR2_MUX16_BYP_GRANT(x, n, v) (HW_EIM_CSnGCR2_WR(x, n, (HW_EIM_CSnGCR2_RD(x, n) & ~BM_EIM_CSnGCR2_MUX16_BYP_GRANT) | BF_EIM_CSnGCR2_MUX16_BYP_GRANT(v)))
/*@}*/
/*******************************************************************************
 * HW_EIM_CSnRCR1 - Chip Select n Read Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnRCR1 - Chip Select n Read Configuration Register 1 (RW)
 *
 * Reset value: 0x1C002000U
 */
typedef union _hw_eim_csnrcr1
{
    uint32_t U;
    struct _hw_eim_csnrcr1_bitfields
    {
        uint32_t RCSN : 3;             /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t RCSA : 3;             /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t OEN : 3;              /*!< [10:8]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t OEA : 3;              /*!< [14:12]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t RADVN : 3;            /*!< [18:16]  */
        uint32_t RAL : 1;              /*!< [19]  */
        uint32_t RADVA : 3;            /*!< [22:20]  */
        uint32_t RESERVED4 : 1;        /*!< [23]  */
        uint32_t RWSC : 6;             /*!< [29:24]  */
        uint32_t RESERVED5 : 2;        /*!< [31:30]  */
    } B;
} hw_eim_csnrcr1_t;

/*!
 * @name Constants and macros for entire EIM_CSnRCR1 register
 */
/*@{*/
#define HW_EIM_CSnRCR1_COUNT (4U)

#define HW_EIM_CSnRCR1_ADDR(x, n) ((uintptr_t)(x) + 0x8U + (0x18U * (n)))

#define HW_EIM_CSnRCR1(x, n)     (*(__IO hw_eim_csnrcr1_t *) HW_EIM_CSnRCR1_ADDR(x, n))
#define HW_EIM_CSnRCR1_RD(x, n)  (HW_EIM_CSnRCR1(x, n).U)
#define HW_EIM_CSnRCR1_WR(x, n, v) (HW_EIM_CSnRCR1(x, n).U = (v))
#define HW_EIM_CSnRCR1_SET(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, HW_EIM_CSnRCR1_RD(x, n) |  (v)))
#define HW_EIM_CSnRCR1_CLR(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, HW_EIM_CSnRCR1_RD(x, n) & ~(v)))
#define HW_EIM_CSnRCR1_TOG(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, HW_EIM_CSnRCR1_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnRCR1 bitfields
 */

/*!
 * @name Register EIM_CSnRCR1, field RCSN[2:0] (RW)
 *
 * Read CS Negation. This bit field determines when CS signal is negated during
 * read cycles in asynchronous single mode only (SRD=0 & APR = 0), according to
 * the settings shown below. This bit field is ignored when SRD=1. RCSN is cleared
 * by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between end of read access and CS negation
 * - 001 - 1 EIM clock cycles between end of read access and CS negation
 * - 010 - 2 EIM clock cycles between end of read access and CS negation
 * - 111 - 7 EIM clock cycles between end of read access and CS negation
 */
/*@{*/
#define BP_EIM_CSnRCR1_RCSN  (0U)          /*!< Bit position for EIM_CSnRCR1_RCSN. */
#define BM_EIM_CSnRCR1_RCSN  (0x00000007U) /*!< Bit mask for EIM_CSnRCR1_RCSN. */
#define BS_EIM_CSnRCR1_RCSN  (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_RCSN. */

/*! @brief Read current value of the EIM_CSnRCR1_RCSN field. */
#define BR_EIM_CSnRCR1_RCSN(x, n) (HW_EIM_CSnRCR1(x, n).B.RCSN)

/*! @brief Format value for bitfield EIM_CSnRCR1_RCSN. */
#define BF_EIM_CSnRCR1_RCSN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RCSN) & BM_EIM_CSnRCR1_RCSN)

/*! @brief Set the RCSN field to a new value. */
#define BW_EIM_CSnRCR1_RCSN(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RCSN) | BF_EIM_CSnRCR1_RCSN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field RCSA[6:4] (RW)
 *
 * Read CS Assertion. This bit field determines when CS signal is asserted
 * during read cycles (synchronous or asynchronous mode), according to the settings
 * shown below. RCSA is cleared by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of read access and CS assertion
 * - 001 - 1 EIM clock cycles between beginning of read access and CS assertion
 * - 010 - 2 EIM clock cycles between beginning of read access and CS assertion
 * - 111 - 7 EIM clock cycles between beginning of read access and CS assertion
 */
/*@{*/
#define BP_EIM_CSnRCR1_RCSA  (4U)          /*!< Bit position for EIM_CSnRCR1_RCSA. */
#define BM_EIM_CSnRCR1_RCSA  (0x00000070U) /*!< Bit mask for EIM_CSnRCR1_RCSA. */
#define BS_EIM_CSnRCR1_RCSA  (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_RCSA. */

/*! @brief Read current value of the EIM_CSnRCR1_RCSA field. */
#define BR_EIM_CSnRCR1_RCSA(x, n) (HW_EIM_CSnRCR1(x, n).B.RCSA)

/*! @brief Format value for bitfield EIM_CSnRCR1_RCSA. */
#define BF_EIM_CSnRCR1_RCSA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RCSA) & BM_EIM_CSnRCR1_RCSA)

/*! @brief Set the RCSA field to a new value. */
#define BW_EIM_CSnRCR1_RCSA(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RCSA) | BF_EIM_CSnRCR1_RCSA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field OEN[10:8] (RW)
 *
 * OE Negation. This bit field determines when OE signal is negated during read
 * cycles in asynchronous single mode only (SRD=0 & APR = 0), according to the
 * settings shown below. This bit field is ignored when SRD=1. OEN is cleared by a
 * hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between end of access and OE negation
 * - 001 - 1 EIM clock cycles between end of access and OE negation
 * - 010 - 2 EIM clock cycles between end of access and OE negation
 * - 111 - 7 EIM clock cycles between end of access and OE negation
 */
/*@{*/
#define BP_EIM_CSnRCR1_OEN   (8U)          /*!< Bit position for EIM_CSnRCR1_OEN. */
#define BM_EIM_CSnRCR1_OEN   (0x00000700U) /*!< Bit mask for EIM_CSnRCR1_OEN. */
#define BS_EIM_CSnRCR1_OEN   (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_OEN. */

/*! @brief Read current value of the EIM_CSnRCR1_OEN field. */
#define BR_EIM_CSnRCR1_OEN(x, n) (HW_EIM_CSnRCR1(x, n).B.OEN)

/*! @brief Format value for bitfield EIM_CSnRCR1_OEN. */
#define BF_EIM_CSnRCR1_OEN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_OEN) & BM_EIM_CSnRCR1_OEN)

/*! @brief Set the OEN field to a new value. */
#define BW_EIM_CSnRCR1_OEN(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_OEN) | BF_EIM_CSnRCR1_OEN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field OEA[14:12] (RW)
 *
 * OE Assertion. This bit field determines when OE signal are asserted during
 * read cycles (synchronous or asynchronous mode), according to the settings shown
 * below. OEA is cleared by a hardware reset. In muxed mode OE assertion occurs
 * (OEA + RADVN + RADVA + ADH +1) EIM clock cycles from start of access. The reset
 * value for EIM_CS0RCR1[OEA] is 0b000 if EIM_BOOT[2] = 0. If EIM_BOOT[2] is 1,
 * the reset value for EIM_CS0RCR1[OEA] is 0b010. The reset value of this field
 * for EIM_CS1RCR1 - EIM_CS5RCR1 is 0b000. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and OE assertion
 * - 001 - 1 EIM clock cycles between beginning of access and OE assertion
 * - 010 - 2 EIM clock cycles between beginning of access and OE assertion
 * - 111 - 7 EIM clock cycles between beginning of access and OE assertion
 */
/*@{*/
#define BP_EIM_CSnRCR1_OEA   (12U)         /*!< Bit position for EIM_CSnRCR1_OEA. */
#define BM_EIM_CSnRCR1_OEA   (0x00007000U) /*!< Bit mask for EIM_CSnRCR1_OEA. */
#define BS_EIM_CSnRCR1_OEA   (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_OEA. */

/*! @brief Read current value of the EIM_CSnRCR1_OEA field. */
#define BR_EIM_CSnRCR1_OEA(x, n) (HW_EIM_CSnRCR1(x, n).B.OEA)

/*! @brief Format value for bitfield EIM_CSnRCR1_OEA. */
#define BF_EIM_CSnRCR1_OEA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_OEA) & BM_EIM_CSnRCR1_OEA)

/*! @brief Set the OEA field to a new value. */
#define BW_EIM_CSnRCR1_OEA(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_OEA) | BF_EIM_CSnRCR1_OEA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field RADVN[18:16] (RW)
 *
 * ADV Negation. This bit field determines when ADV signal to memory is negated
 * during read accesses. When SRD=1 (synchronous read mode), ADV negation occurs
 * according to the following formula: (RADVN + RADVA + BCD + BCS + 1) EIM clock
 * cycles from start of access. When asynchronous read mode is applied (SRD=0)
 * and RAL=0 ADV negation occurs according to the following formula: (RADVN + RADVA
 * + 1) EIM clock cycles from start of access. RADVN is cleared by a hardware
 * reset. The reset value for EIM_CS0RCR1[RADVN] = 0b010. For EIM_CS1RCR1 -
 * EIM_CS5RCR1, the reset value is 0b000. This field should be configured so ADV
 * negation will occur before the end of access. For ADV negation at the same time with
 * the end of access user should RAL bit.
 */
/*@{*/
#define BP_EIM_CSnRCR1_RADVN (16U)         /*!< Bit position for EIM_CSnRCR1_RADVN. */
#define BM_EIM_CSnRCR1_RADVN (0x00070000U) /*!< Bit mask for EIM_CSnRCR1_RADVN. */
#define BS_EIM_CSnRCR1_RADVN (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_RADVN. */

/*! @brief Read current value of the EIM_CSnRCR1_RADVN field. */
#define BR_EIM_CSnRCR1_RADVN(x, n) (HW_EIM_CSnRCR1(x, n).B.RADVN)

/*! @brief Format value for bitfield EIM_CSnRCR1_RADVN. */
#define BF_EIM_CSnRCR1_RADVN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RADVN) & BM_EIM_CSnRCR1_RADVN)

/*! @brief Set the RADVN field to a new value. */
#define BW_EIM_CSnRCR1_RADVN(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RADVN) | BF_EIM_CSnRCR1_RADVN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field RAL[19] (RW)
 *
 * Read ADV Low. This bit field determine ADV signal negation time. When RAL=1,
 * RADVN bit field is ignored and ADV signal will stay asserted until end of
 * access. When RAL=0 negation of ADV signal is according to RADVN bit field
 * configuration.
 */
/*@{*/
#define BP_EIM_CSnRCR1_RAL   (19U)         /*!< Bit position for EIM_CSnRCR1_RAL. */
#define BM_EIM_CSnRCR1_RAL   (0x00080000U) /*!< Bit mask for EIM_CSnRCR1_RAL. */
#define BS_EIM_CSnRCR1_RAL   (1U)          /*!< Bit field size in bits for EIM_CSnRCR1_RAL. */

/*! @brief Read current value of the EIM_CSnRCR1_RAL field. */
#define BR_EIM_CSnRCR1_RAL(x, n) (HW_EIM_CSnRCR1(x, n).B.RAL)

/*! @brief Format value for bitfield EIM_CSnRCR1_RAL. */
#define BF_EIM_CSnRCR1_RAL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RAL) & BM_EIM_CSnRCR1_RAL)

/*! @brief Set the RAL field to a new value. */
#define BW_EIM_CSnRCR1_RAL(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RAL) | BF_EIM_CSnRCR1_RAL(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field RADVA[22:20] (RW)
 *
 * ADV Assertion. This bit field determines when ADV signal is asserted for
 * synchronous or asynchronous read modes according to the settings shown below.
 * RADVA is cleared by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and ADV assertion
 * - 001 - 1 EIM clock cycles between beginning of access and ADV assertion
 * - 010 - 2 EIM clock cycles between beginning of access and ADV assertion
 * - 111 - 7 EIM clock cycles between beginning of access and ADV assertion
 */
/*@{*/
#define BP_EIM_CSnRCR1_RADVA (20U)         /*!< Bit position for EIM_CSnRCR1_RADVA. */
#define BM_EIM_CSnRCR1_RADVA (0x00700000U) /*!< Bit mask for EIM_CSnRCR1_RADVA. */
#define BS_EIM_CSnRCR1_RADVA (3U)          /*!< Bit field size in bits for EIM_CSnRCR1_RADVA. */

/*! @brief Read current value of the EIM_CSnRCR1_RADVA field. */
#define BR_EIM_CSnRCR1_RADVA(x, n) (HW_EIM_CSnRCR1(x, n).B.RADVA)

/*! @brief Format value for bitfield EIM_CSnRCR1_RADVA. */
#define BF_EIM_CSnRCR1_RADVA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RADVA) & BM_EIM_CSnRCR1_RADVA)

/*! @brief Set the RADVA field to a new value. */
#define BW_EIM_CSnRCR1_RADVA(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RADVA) | BF_EIM_CSnRCR1_RADVA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR1, field RWSC[29:24] (RW)
 *
 * Read Wait State Control. This bit field programs the number of wait-states,
 * according to the settings shown below, for synchronous or asynchronous read
 * access to the external device connected to the chip select. When SRD=1 and RFL=0,
 * RWSC indicates the number of burst clock (BCLK) cycles from the start of an
 * access, before the controller can start sample data.Since WAIT signal can be
 * asserted one cycle before the first data can be sampled, the controller starts
 * evaluating the WAIT signal state one cycle before, this is referred as
 * handshake mode or variable latency mode. When SRD=1 and RFL=1, RWSC indicates the
 * number of burst clock (BCLK) cycles from the start of an access, until the
 * external device is ready for data transfer, this is referred as fix latency mode.
 * When SRD=0, RFL bit is ignored, RWSC indicates the asynchronous access length and
 * the number of EIM clock cycles from the start of access until the external
 * device is ready for data transfer. RWSC is cleared by a hardware reset. The
 * reset value for EIM_CS0RCR1, RWSC[5:0] = 0b011100. For CG1RCR1 - CS1RCR5 the reset
 * value is 0b000000. Example settings:
 *
 * Values:
 * - 000000 - Reserved
 * - 000001 - RWSC value is 1
 * - 000010 - RWSC value is 2
 * - 111101 - RWSC value is 61
 * - 111110 - RWSC value is 62
 * - 111111 - RWSC value is 63
 */
/*@{*/
#define BP_EIM_CSnRCR1_RWSC  (24U)         /*!< Bit position for EIM_CSnRCR1_RWSC. */
#define BM_EIM_CSnRCR1_RWSC  (0x3F000000U) /*!< Bit mask for EIM_CSnRCR1_RWSC. */
#define BS_EIM_CSnRCR1_RWSC  (6U)          /*!< Bit field size in bits for EIM_CSnRCR1_RWSC. */

/*! @brief Read current value of the EIM_CSnRCR1_RWSC field. */
#define BR_EIM_CSnRCR1_RWSC(x, n) (HW_EIM_CSnRCR1(x, n).B.RWSC)

/*! @brief Format value for bitfield EIM_CSnRCR1_RWSC. */
#define BF_EIM_CSnRCR1_RWSC(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR1_RWSC) & BM_EIM_CSnRCR1_RWSC)

/*! @brief Set the RWSC field to a new value. */
#define BW_EIM_CSnRCR1_RWSC(x, n, v) (HW_EIM_CSnRCR1_WR(x, n, (HW_EIM_CSnRCR1_RD(x, n) & ~BM_EIM_CSnRCR1_RWSC) | BF_EIM_CSnRCR1_RWSC(v)))
/*@}*/
/*******************************************************************************
 * HW_EIM_CSnRCR2 - Chip Select n Read Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnRCR2 - Chip Select n Read Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_eim_csnrcr2
{
    uint32_t U;
    struct _hw_eim_csnrcr2_bitfields
    {
        uint32_t RBEN : 3;             /*!< [2:0]  */
        uint32_t RBE : 1;              /*!< [3]  */
        uint32_t RBEA : 3;             /*!< [6:4]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t RL : 2;               /*!< [9:8]  */
        uint32_t RESERVED1 : 2;        /*!< [11:10]  */
        uint32_t PAT : 3;              /*!< [14:12]  */
        uint32_t APR : 1;              /*!< [15]  */
        uint32_t RESERVED2 : 16;       /*!< [31:16]  */
    } B;
} hw_eim_csnrcr2_t;

/*!
 * @name Constants and macros for entire EIM_CSnRCR2 register
 */
/*@{*/
#define HW_EIM_CSnRCR2_COUNT (4U)

#define HW_EIM_CSnRCR2_ADDR(x, n) ((uintptr_t)(x) + 0xCU + (0x18U * (n)))

#define HW_EIM_CSnRCR2(x, n)     (*(__IO hw_eim_csnrcr2_t *) HW_EIM_CSnRCR2_ADDR(x, n))
#define HW_EIM_CSnRCR2_RD(x, n)  (HW_EIM_CSnRCR2(x, n).U)
#define HW_EIM_CSnRCR2_WR(x, n, v) (HW_EIM_CSnRCR2(x, n).U = (v))
#define HW_EIM_CSnRCR2_SET(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, HW_EIM_CSnRCR2_RD(x, n) |  (v)))
#define HW_EIM_CSnRCR2_CLR(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, HW_EIM_CSnRCR2_RD(x, n) & ~(v)))
#define HW_EIM_CSnRCR2_TOG(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, HW_EIM_CSnRCR2_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnRCR2 bitfields
 */

/*!
 * @name Register EIM_CSnRCR2, field RBEN[2:0] (RW)
 *
 * Read BE Negation. This bit field determines when BE signal is negated during
 * read cycles in asynchronous single mode only (SRD=0 & APR=0), according to the
 * settings shown below. This bit field is ignored when SRD=1. RBEN is cleared
 * by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between end of read access and BE negation
 * - 001 - 1 EIM clock cycles between end of read access and BE negation
 * - 010 - 2 EIM clock cycles between end of read access and BE negation
 * - 111 - 7 EIM clock cycles between end of read access and BE negation
 */
/*@{*/
#define BP_EIM_CSnRCR2_RBEN  (0U)          /*!< Bit position for EIM_CSnRCR2_RBEN. */
#define BM_EIM_CSnRCR2_RBEN  (0x00000007U) /*!< Bit mask for EIM_CSnRCR2_RBEN. */
#define BS_EIM_CSnRCR2_RBEN  (3U)          /*!< Bit field size in bits for EIM_CSnRCR2_RBEN. */

/*! @brief Read current value of the EIM_CSnRCR2_RBEN field. */
#define BR_EIM_CSnRCR2_RBEN(x, n) (HW_EIM_CSnRCR2(x, n).B.RBEN)

/*! @brief Format value for bitfield EIM_CSnRCR2_RBEN. */
#define BF_EIM_CSnRCR2_RBEN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_RBEN) & BM_EIM_CSnRCR2_RBEN)

/*! @brief Set the RBEN field to a new value. */
#define BW_EIM_CSnRCR2_RBEN(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_RBEN) | BF_EIM_CSnRCR2_RBEN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR2, field RBE[3] (RW)
 *
 * Read BE enable. This bit field determines if BE will be asserted during read
 * access.
 *
 * Values:
 * - 0 - BE are disabled during read access.
 * - 1 - BE are enable during read access according to value of RBEA & RBEN bit
 *     fields.
 */
/*@{*/
#define BP_EIM_CSnRCR2_RBE   (3U)          /*!< Bit position for EIM_CSnRCR2_RBE. */
#define BM_EIM_CSnRCR2_RBE   (0x00000008U) /*!< Bit mask for EIM_CSnRCR2_RBE. */
#define BS_EIM_CSnRCR2_RBE   (1U)          /*!< Bit field size in bits for EIM_CSnRCR2_RBE. */

/*! @brief Read current value of the EIM_CSnRCR2_RBE field. */
#define BR_EIM_CSnRCR2_RBE(x, n) (HW_EIM_CSnRCR2(x, n).B.RBE)

/*! @brief Format value for bitfield EIM_CSnRCR2_RBE. */
#define BF_EIM_CSnRCR2_RBE(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_RBE) & BM_EIM_CSnRCR2_RBE)

/*! @brief Set the RBE field to a new value. */
#define BW_EIM_CSnRCR2_RBE(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_RBE) | BF_EIM_CSnRCR2_RBE(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR2, field RBEA[6:4] (RW)
 *
 * Read BE Assertion. This bit field determines when BE signal is asserted
 * during read cycles (synchronous or asynchronous mode), according to the settings
 * shown below. RBEA is cleared by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of read access and BE assertion
 * - 001 - 1 EIM clock cycles between beginning of read access and BE assertion
 * - 010 - 2 EIM clock cycles between beginning of read access and BE assertion
 * - 111 - 7 EIM clock cycles between beginning of read access and BE assertion
 */
/*@{*/
#define BP_EIM_CSnRCR2_RBEA  (4U)          /*!< Bit position for EIM_CSnRCR2_RBEA. */
#define BM_EIM_CSnRCR2_RBEA  (0x00000070U) /*!< Bit mask for EIM_CSnRCR2_RBEA. */
#define BS_EIM_CSnRCR2_RBEA  (3U)          /*!< Bit field size in bits for EIM_CSnRCR2_RBEA. */

/*! @brief Read current value of the EIM_CSnRCR2_RBEA field. */
#define BR_EIM_CSnRCR2_RBEA(x, n) (HW_EIM_CSnRCR2(x, n).B.RBEA)

/*! @brief Format value for bitfield EIM_CSnRCR2_RBEA. */
#define BF_EIM_CSnRCR2_RBEA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_RBEA) & BM_EIM_CSnRCR2_RBEA)

/*! @brief Set the RBEA field to a new value. */
#define BW_EIM_CSnRCR2_RBEA(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_RBEA) | BF_EIM_CSnRCR2_RBEA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR2, field RL[9:8] (RW)
 *
 * Read Latency. This bit field indicates cycle latency when executing a
 * synchronous read operation. The fields holds the feedback clock loop delay in aclk
 * cycle units. This field is cleared by a hardware reset.
 *
 * Values:
 * - 00 - Feedback clock loop delay is up to 1 cycle for BCD = 0 or 1.5 cycles
 *     for BCD != 0
 * - 01 - Feedback clock loop delay is up to 2 cycles for BCD = 0 or 2.5 cycles
 *     for BCD != 0
 * - 10 - Feedback clock loop delay is up to 3 cycles for BCD = 0 or 3.5 cycles
 *     for BCD != 0
 * - 11 - Feedback clock loop delay is up to 4 cycles for BCD = 0 or 4.5 cycles
 *     for BCD != 0
 */
/*@{*/
#define BP_EIM_CSnRCR2_RL    (8U)          /*!< Bit position for EIM_CSnRCR2_RL. */
#define BM_EIM_CSnRCR2_RL    (0x00000300U) /*!< Bit mask for EIM_CSnRCR2_RL. */
#define BS_EIM_CSnRCR2_RL    (2U)          /*!< Bit field size in bits for EIM_CSnRCR2_RL. */

/*! @brief Read current value of the EIM_CSnRCR2_RL field. */
#define BR_EIM_CSnRCR2_RL(x, n) (HW_EIM_CSnRCR2(x, n).B.RL)

/*! @brief Format value for bitfield EIM_CSnRCR2_RL. */
#define BF_EIM_CSnRCR2_RL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_RL) & BM_EIM_CSnRCR2_RL)

/*! @brief Set the RL field to a new value. */
#define BW_EIM_CSnRCR2_RL(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_RL) | BF_EIM_CSnRCR2_RL(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR2, field PAT[14:12] (RW)
 *
 * Page Access Time. This bit field is used in Asynchronous Page Read mode only
 * (APR=1). the initial access is set by RWSC as in regular asynchronous mode.
 * the consecutive address assertions width determine by PAT field according to the
 * settings shown below. when APR=0 this field is ignored. PAT is cleared by a
 * hardware reset for EIM_CS1GCR1 - EIM_CS5GCR1.
 *
 * Values:
 * - 000 - Address width is 2 EIM clock cycles
 * - 001 - Address width is 3 EIM clock cycles
 * - 010 - Address width is 4 EIM clock cycles
 * - 011 - Address width is 5 EIM clock cycles
 * - 100 - Address width is 6 EIM clock cycles
 * - 101 - Address width is 7 EIM clock cycles
 * - 110 - Address width is 8 EIM clock cycles
 * - 111 - Address width is 9 EIM clock cycles
 */
/*@{*/
#define BP_EIM_CSnRCR2_PAT   (12U)         /*!< Bit position for EIM_CSnRCR2_PAT. */
#define BM_EIM_CSnRCR2_PAT   (0x00007000U) /*!< Bit mask for EIM_CSnRCR2_PAT. */
#define BS_EIM_CSnRCR2_PAT   (3U)          /*!< Bit field size in bits for EIM_CSnRCR2_PAT. */

/*! @brief Read current value of the EIM_CSnRCR2_PAT field. */
#define BR_EIM_CSnRCR2_PAT(x, n) (HW_EIM_CSnRCR2(x, n).B.PAT)

/*! @brief Format value for bitfield EIM_CSnRCR2_PAT. */
#define BF_EIM_CSnRCR2_PAT(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_PAT) & BM_EIM_CSnRCR2_PAT)

/*! @brief Set the PAT field to a new value. */
#define BW_EIM_CSnRCR2_PAT(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_PAT) | BF_EIM_CSnRCR2_PAT(v)))
/*@}*/

/*!
 * @name Register EIM_CSnRCR2, field APR[15] (RW)
 *
 * Asynchronous Page Read. This bit field determine the asynchronous read mode
 * to the external device. When APR=0, the async. read access is done as single
 * word (where word is defined by the DSZ field). when APR=1, the async. read
 * access executed as page read. page size is according to BL field config.,
 * RCSN,RBEN,OEN and RADVN are being ignored. APR is cleared by a hardware reset for
 * EIM_CS1GCR1 - EIM_CS5GCR1. SRD=0 and MUM=0 must apply when APR=1
 */
/*@{*/
#define BP_EIM_CSnRCR2_APR   (15U)         /*!< Bit position for EIM_CSnRCR2_APR. */
#define BM_EIM_CSnRCR2_APR   (0x00008000U) /*!< Bit mask for EIM_CSnRCR2_APR. */
#define BS_EIM_CSnRCR2_APR   (1U)          /*!< Bit field size in bits for EIM_CSnRCR2_APR. */

/*! @brief Read current value of the EIM_CSnRCR2_APR field. */
#define BR_EIM_CSnRCR2_APR(x, n) (HW_EIM_CSnRCR2(x, n).B.APR)

/*! @brief Format value for bitfield EIM_CSnRCR2_APR. */
#define BF_EIM_CSnRCR2_APR(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnRCR2_APR) & BM_EIM_CSnRCR2_APR)

/*! @brief Set the APR field to a new value. */
#define BW_EIM_CSnRCR2_APR(x, n, v) (HW_EIM_CSnRCR2_WR(x, n, (HW_EIM_CSnRCR2_RD(x, n) & ~BM_EIM_CSnRCR2_APR) | BF_EIM_CSnRCR2_APR(v)))
/*@}*/
/*******************************************************************************
 * HW_EIM_CSnWCR1 - Chip Select n Write Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnWCR1 - Chip Select n Write Configuration Register 1 (RW)
 *
 * Reset value: 0x1C000000U
 */
typedef union _hw_eim_csnwcr1
{
    uint32_t U;
    struct _hw_eim_csnwcr1_bitfields
    {
        uint32_t WCSN : 3;             /*!< [2:0]  */
        uint32_t WCSA : 3;             /*!< [5:3]  */
        uint32_t WEN : 3;              /*!< [8:6]  */
        uint32_t WEA : 3;              /*!< [11:9]  */
        uint32_t WBEN : 3;             /*!< [14:12]  */
        uint32_t WBEA : 3;             /*!< [17:15]  */
        uint32_t WADVN : 3;            /*!< [20:18]  */
        uint32_t WADVA : 3;            /*!< [23:21]  */
        uint32_t WWSC : 6;             /*!< [29:24]  */
        uint32_t WBED : 1;             /*!< [30]  */
        uint32_t WAL : 1;              /*!< [31]  */
    } B;
} hw_eim_csnwcr1_t;

/*!
 * @name Constants and macros for entire EIM_CSnWCR1 register
 */
/*@{*/
#define HW_EIM_CSnWCR1_COUNT (4U)

#define HW_EIM_CSnWCR1_ADDR(x, n) ((uintptr_t)(x) + 0x10U + (0x18U * (n)))

#define HW_EIM_CSnWCR1(x, n)     (*(__IO hw_eim_csnwcr1_t *) HW_EIM_CSnWCR1_ADDR(x, n))
#define HW_EIM_CSnWCR1_RD(x, n)  (HW_EIM_CSnWCR1(x, n).U)
#define HW_EIM_CSnWCR1_WR(x, n, v) (HW_EIM_CSnWCR1(x, n).U = (v))
#define HW_EIM_CSnWCR1_SET(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, HW_EIM_CSnWCR1_RD(x, n) |  (v)))
#define HW_EIM_CSnWCR1_CLR(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, HW_EIM_CSnWCR1_RD(x, n) & ~(v)))
#define HW_EIM_CSnWCR1_TOG(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, HW_EIM_CSnWCR1_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnWCR1 bitfields
 */

/*!
 * @name Register EIM_CSnWCR1, field WCSN[2:0] (RW)
 *
 * Write CS Negation. This bit field determines when CS signal is negated during
 * write cycles in asynchronous mode only (SWR=0), according to the settings
 * shown below. This bit field is ignored when SWR=1. WCSN is cleared by a hardware
 * reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between end of read access and CS negation
 * - 001 - 1 EIM clock cycles between end of read access and CS negation
 * - 010 - 2 EIM clock cycles between end of read access and CS negation
 * - 111 - 7 EIM clock cycles between end of read access and CS negation
 */
/*@{*/
#define BP_EIM_CSnWCR1_WCSN  (0U)          /*!< Bit position for EIM_CSnWCR1_WCSN. */
#define BM_EIM_CSnWCR1_WCSN  (0x00000007U) /*!< Bit mask for EIM_CSnWCR1_WCSN. */
#define BS_EIM_CSnWCR1_WCSN  (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WCSN. */

/*! @brief Read current value of the EIM_CSnWCR1_WCSN field. */
#define BR_EIM_CSnWCR1_WCSN(x, n) (HW_EIM_CSnWCR1(x, n).B.WCSN)

/*! @brief Format value for bitfield EIM_CSnWCR1_WCSN. */
#define BF_EIM_CSnWCR1_WCSN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WCSN) & BM_EIM_CSnWCR1_WCSN)

/*! @brief Set the WCSN field to a new value. */
#define BW_EIM_CSnWCR1_WCSN(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WCSN) | BF_EIM_CSnWCR1_WCSN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WCSA[5:3] (RW)
 *
 * Write CS Assertion. This bit field determines when CS signal is asserted
 * during write cycles (synchronous or asynchronous mode), according to the settings
 * shown below.this bit field is ignored when executing a read access to the
 * external device. WCSA is cleared by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of write access and CS assertion
 * - 001 - 1 EIM clock cycles between beginning of write access and CS assertion
 * - 010 - 2 EIM clock cycles between beginning of write access and CS assertion
 * - 111 - 7 EIMclock cycles between beginning of write access and CS assertion
 */
/*@{*/
#define BP_EIM_CSnWCR1_WCSA  (3U)          /*!< Bit position for EIM_CSnWCR1_WCSA. */
#define BM_EIM_CSnWCR1_WCSA  (0x00000038U) /*!< Bit mask for EIM_CSnWCR1_WCSA. */
#define BS_EIM_CSnWCR1_WCSA  (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WCSA. */

/*! @brief Read current value of the EIM_CSnWCR1_WCSA field. */
#define BR_EIM_CSnWCR1_WCSA(x, n) (HW_EIM_CSnWCR1(x, n).B.WCSA)

/*! @brief Format value for bitfield EIM_CSnWCR1_WCSA. */
#define BF_EIM_CSnWCR1_WCSA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WCSA) & BM_EIM_CSnWCR1_WCSA)

/*! @brief Set the WCSA field to a new value. */
#define BW_EIM_CSnWCR1_WCSA(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WCSA) | BF_EIM_CSnWCR1_WCSA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WEN[8:6] (RW)
 *
 * WE Negation. This bit field determines when WE signal is negated during write
 * cycles in asynchronous mode only (SWR=0), according to the settings shown
 * below. This bit field is ignored when SWR=1. WEN is cleared by a hardware reset.
 * Reset value for EIM_CS0WCR for WEN is 0b010. For EIM_CS1WCR - EIM_CS5WCR reset
 * value is 0b000. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and WE assertion
 * - 001 - 1 EIM clock cycles between beginning of access and WE assertion
 * - 010 - 2 EIM clock cycles between beginning of access and WE assertion
 * - 111 - 7 EIM clock cycles between beginning of access and WE assertion
 */
/*@{*/
#define BP_EIM_CSnWCR1_WEN   (6U)          /*!< Bit position for EIM_CSnWCR1_WEN. */
#define BM_EIM_CSnWCR1_WEN   (0x000001C0U) /*!< Bit mask for EIM_CSnWCR1_WEN. */
#define BS_EIM_CSnWCR1_WEN   (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WEN. */

/*! @brief Read current value of the EIM_CSnWCR1_WEN field. */
#define BR_EIM_CSnWCR1_WEN(x, n) (HW_EIM_CSnWCR1(x, n).B.WEN)

/*! @brief Format value for bitfield EIM_CSnWCR1_WEN. */
#define BF_EIM_CSnWCR1_WEN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WEN) & BM_EIM_CSnWCR1_WEN)

/*! @brief Set the WEN field to a new value. */
#define BW_EIM_CSnWCR1_WEN(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WEN) | BF_EIM_CSnWCR1_WEN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WEA[11:9] (RW)
 *
 * WE Assertion. This bit field determines when WE signal is asserted during
 * write cycles (synchronous or asynchronous mode), according to the settings shown
 * below. This bit field is ignored when executing a read access to the external
 * device. WEA is cleared by a hardware reset. Reset value for EIM_CS0WCR for WEA
 * is 0b010. For EIM_CS1WCR - EIM_CS5WCR reset value is 0b000. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and WE assertion
 * - 001 - 1 EIM clock cycles between beginning of access and WE assertion
 * - 010 - 2 EIM clock cycles between beginning of access and WE assertion
 * - 111 - 7 EIMclock cycles between beginning of access and WE assertion
 */
/*@{*/
#define BP_EIM_CSnWCR1_WEA   (9U)          /*!< Bit position for EIM_CSnWCR1_WEA. */
#define BM_EIM_CSnWCR1_WEA   (0x00000E00U) /*!< Bit mask for EIM_CSnWCR1_WEA. */
#define BS_EIM_CSnWCR1_WEA   (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WEA. */

/*! @brief Read current value of the EIM_CSnWCR1_WEA field. */
#define BR_EIM_CSnWCR1_WEA(x, n) (HW_EIM_CSnWCR1(x, n).B.WEA)

/*! @brief Format value for bitfield EIM_CSnWCR1_WEA. */
#define BF_EIM_CSnWCR1_WEA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WEA) & BM_EIM_CSnWCR1_WEA)

/*! @brief Set the WEA field to a new value. */
#define BW_EIM_CSnWCR1_WEA(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WEA) | BF_EIM_CSnWCR1_WEA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WBEN[14:12] (RW)
 *
 * BE[3:0] Negation. This bit field determines when BE[3:0] bus signal is
 * negated during write cycles in async. mode only (SWR=0), according to the settings
 * shown below. This bit field is ignored when SWR=1. BEN is cleared by a hardware
 * reset. Reset value for EIM_CS0WCR for WBEN is 0b010. For EIM_CS1WCR -
 * EIM_CS5WCR reset value is 0b000. Example settings: 000 0 EIM clock cycles between end
 * of access and WE negation 001 1 EIM clock cycles between end of access and WE
 * negation 010 2 EIM clock cycles between end of access and WE negation 111 7
 * EIM clock cycles between end of access and WE negation
 */
/*@{*/
#define BP_EIM_CSnWCR1_WBEN  (12U)         /*!< Bit position for EIM_CSnWCR1_WBEN. */
#define BM_EIM_CSnWCR1_WBEN  (0x00007000U) /*!< Bit mask for EIM_CSnWCR1_WBEN. */
#define BS_EIM_CSnWCR1_WBEN  (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WBEN. */

/*! @brief Read current value of the EIM_CSnWCR1_WBEN field. */
#define BR_EIM_CSnWCR1_WBEN(x, n) (HW_EIM_CSnWCR1(x, n).B.WBEN)

/*! @brief Format value for bitfield EIM_CSnWCR1_WBEN. */
#define BF_EIM_CSnWCR1_WBEN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WBEN) & BM_EIM_CSnWCR1_WBEN)

/*! @brief Set the WBEN field to a new value. */
#define BW_EIM_CSnWCR1_WBEN(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WBEN) | BF_EIM_CSnWCR1_WBEN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WBEA[17:15] (RW)
 *
 * BE Assertion. This bit field determines when BE signal is asserted during
 * write cycles in async. mode only (SWR=0), according to the settings shown below.
 * BEA is cleared by a hardware reset. Reset value for EIM_CS0WCR for WBEA is
 * 0b010. For EIM_CS1WCR - EIM_CS5WCR reset value is 0b000. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and BE assertion
 * - 001 - 1 EIM clock cycles between beginning of access and BE assertion
 * - 010 - 2 EIM clock cycles between beginning of access and BE assertion
 * - 111 - 7 EIM clock cycles between beginning of access and BE assertion
 */
/*@{*/
#define BP_EIM_CSnWCR1_WBEA  (15U)         /*!< Bit position for EIM_CSnWCR1_WBEA. */
#define BM_EIM_CSnWCR1_WBEA  (0x00038000U) /*!< Bit mask for EIM_CSnWCR1_WBEA. */
#define BS_EIM_CSnWCR1_WBEA  (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WBEA. */

/*! @brief Read current value of the EIM_CSnWCR1_WBEA field. */
#define BR_EIM_CSnWCR1_WBEA(x, n) (HW_EIM_CSnWCR1(x, n).B.WBEA)

/*! @brief Format value for bitfield EIM_CSnWCR1_WBEA. */
#define BF_EIM_CSnWCR1_WBEA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WBEA) & BM_EIM_CSnWCR1_WBEA)

/*! @brief Set the WBEA field to a new value. */
#define BW_EIM_CSnWCR1_WBEA(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WBEA) | BF_EIM_CSnWCR1_WBEA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WADVN[20:18] (RW)
 *
 * ADV Negation. This bit field determines when ADV signal to memory is negated
 * during write accesses. When SWR=1 (synchronous write mode), ADV negation
 * occurs according to the following formula: (WADVN + WADVA + BCD + BCS + 1) EIM
 * clock cycles. When asynchronous read mode is applied (SWR=0) ADV negation occurs
 * according to the following formula: (WADVN + WADVA + 1) EIM clock cycles. Reset
 * value for EIM_CS0WCR for WADVN is 0b010. For EIM_CS1WCR - EIM_CS5WCR reset
 * value is 0b000. This field should be configured so ADV negation will occur
 * before the end of access. For ADV negation at the same time as the end of access,
 * S/W should set the WAL bit.
 */
/*@{*/
#define BP_EIM_CSnWCR1_WADVN (18U)         /*!< Bit position for EIM_CSnWCR1_WADVN. */
#define BM_EIM_CSnWCR1_WADVN (0x001C0000U) /*!< Bit mask for EIM_CSnWCR1_WADVN. */
#define BS_EIM_CSnWCR1_WADVN (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WADVN. */

/*! @brief Read current value of the EIM_CSnWCR1_WADVN field. */
#define BR_EIM_CSnWCR1_WADVN(x, n) (HW_EIM_CSnWCR1(x, n).B.WADVN)

/*! @brief Format value for bitfield EIM_CSnWCR1_WADVN. */
#define BF_EIM_CSnWCR1_WADVN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WADVN) & BM_EIM_CSnWCR1_WADVN)

/*! @brief Set the WADVN field to a new value. */
#define BW_EIM_CSnWCR1_WADVN(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WADVN) | BF_EIM_CSnWCR1_WADVN(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WADVA[23:21] (RW)
 *
 * ADV Assertion. This bit field determines when ADV signal is asserted for
 * synchronous or asynchronous write modes according to the settings shown below.
 * WADVA is cleared by a hardware reset. Example settings:
 *
 * Values:
 * - 000 - 0 EIM clock cycles between beginning of access and ADV assertion
 * - 001 - 1 EIM clock cycles between beginning of access and ADV assertion
 * - 010 - 2 EIM clock cycles between beginning of access and ADV assertion
 * - 111 - 7 EIM clock cycles between beginning of access and ADV assertion
 */
/*@{*/
#define BP_EIM_CSnWCR1_WADVA (21U)         /*!< Bit position for EIM_CSnWCR1_WADVA. */
#define BM_EIM_CSnWCR1_WADVA (0x00E00000U) /*!< Bit mask for EIM_CSnWCR1_WADVA. */
#define BS_EIM_CSnWCR1_WADVA (3U)          /*!< Bit field size in bits for EIM_CSnWCR1_WADVA. */

/*! @brief Read current value of the EIM_CSnWCR1_WADVA field. */
#define BR_EIM_CSnWCR1_WADVA(x, n) (HW_EIM_CSnWCR1(x, n).B.WADVA)

/*! @brief Format value for bitfield EIM_CSnWCR1_WADVA. */
#define BF_EIM_CSnWCR1_WADVA(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WADVA) & BM_EIM_CSnWCR1_WADVA)

/*! @brief Set the WADVA field to a new value. */
#define BW_EIM_CSnWCR1_WADVA(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WADVA) | BF_EIM_CSnWCR1_WADVA(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WWSC[29:24] (RW)
 *
 * Write Wait State Control. This bit field programs the number of wait-states,
 * according to the settings shown below, for synchronous or asynchronous write
 * access to the external device connected to the chip select. When SWR=1 and
 * WFL=0, WWSC indicates the number of burst clock (BCLK) cycles from the start of an
 * access, before the memory can sample the first data.Since WAIT signal can be
 * asserted one cycle before the first data can be sampled, the controller starts
 * evaluating the WAIT signal state one cycle before, this is referred as
 * handshake mode or variable latency mode. When SWR=1 and WFL=1, WWSC indicates the
 * number of burst clock (BCLK) cycles from the start of an access, until the
 * external device is ready for data transfer, this is referred as fix latency mode.
 * When SWR=0, WFL bit is ignored, WWSC indicates the asynchronous access length
 * and the number of EIM clock cycles from the start of access until the external
 * device is ready for data transfer. WWSC is cleared by a hardware reset. The
 * reset value for EIM_CS0WCR1, WWSC[5:0] = 0b011100. For EIM_CS1WCR1 -
 * EIM_CS5WCR1, the reset value of this field is 0b000000. Example settings:
 *
 * Values:
 * - 000000 - Reserved
 * - 000001 - WWSC value is 1
 * - 000010 - WWSC value is 2
 * - 000011 - WWSC value is 3
 * - 111111 - WWSC value is 63
 */
/*@{*/
#define BP_EIM_CSnWCR1_WWSC  (24U)         /*!< Bit position for EIM_CSnWCR1_WWSC. */
#define BM_EIM_CSnWCR1_WWSC  (0x3F000000U) /*!< Bit mask for EIM_CSnWCR1_WWSC. */
#define BS_EIM_CSnWCR1_WWSC  (6U)          /*!< Bit field size in bits for EIM_CSnWCR1_WWSC. */

/*! @brief Read current value of the EIM_CSnWCR1_WWSC field. */
#define BR_EIM_CSnWCR1_WWSC(x, n) (HW_EIM_CSnWCR1(x, n).B.WWSC)

/*! @brief Format value for bitfield EIM_CSnWCR1_WWSC. */
#define BF_EIM_CSnWCR1_WWSC(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WWSC) & BM_EIM_CSnWCR1_WWSC)

/*! @brief Set the WWSC field to a new value. */
#define BW_EIM_CSnWCR1_WWSC(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WWSC) | BF_EIM_CSnWCR1_WWSC(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WBED[30] (RW)
 *
 * Write Byte Enable Disable. When asserted this bit prevent from IPP_DO_BE_B[x]
 * to be asserted during write accesses.This bit is cleared by hardware reset.
 */
/*@{*/
#define BP_EIM_CSnWCR1_WBED  (30U)         /*!< Bit position for EIM_CSnWCR1_WBED. */
#define BM_EIM_CSnWCR1_WBED  (0x40000000U) /*!< Bit mask for EIM_CSnWCR1_WBED. */
#define BS_EIM_CSnWCR1_WBED  (1U)          /*!< Bit field size in bits for EIM_CSnWCR1_WBED. */

/*! @brief Read current value of the EIM_CSnWCR1_WBED field. */
#define BR_EIM_CSnWCR1_WBED(x, n) (HW_EIM_CSnWCR1(x, n).B.WBED)

/*! @brief Format value for bitfield EIM_CSnWCR1_WBED. */
#define BF_EIM_CSnWCR1_WBED(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WBED) & BM_EIM_CSnWCR1_WBED)

/*! @brief Set the WBED field to a new value. */
#define BW_EIM_CSnWCR1_WBED(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WBED) | BF_EIM_CSnWCR1_WBED(v)))
/*@}*/

/*!
 * @name Register EIM_CSnWCR1, field WAL[31] (RW)
 *
 * Write ADV Low. This bit field determine ADV signal negation time in write
 * accesses. When WAL=1, WADVN bit field is ignored and ADV signal will stay
 * asserted until end of access. When WAL=0 negation of ADV signal is according to WADVN
 * bit field configuration.
 */
/*@{*/
#define BP_EIM_CSnWCR1_WAL   (31U)         /*!< Bit position for EIM_CSnWCR1_WAL. */
#define BM_EIM_CSnWCR1_WAL   (0x80000000U) /*!< Bit mask for EIM_CSnWCR1_WAL. */
#define BS_EIM_CSnWCR1_WAL   (1U)          /*!< Bit field size in bits for EIM_CSnWCR1_WAL. */

/*! @brief Read current value of the EIM_CSnWCR1_WAL field. */
#define BR_EIM_CSnWCR1_WAL(x, n) (HW_EIM_CSnWCR1(x, n).B.WAL)

/*! @brief Format value for bitfield EIM_CSnWCR1_WAL. */
#define BF_EIM_CSnWCR1_WAL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR1_WAL) & BM_EIM_CSnWCR1_WAL)

/*! @brief Set the WAL field to a new value. */
#define BW_EIM_CSnWCR1_WAL(x, n, v) (HW_EIM_CSnWCR1_WR(x, n, (HW_EIM_CSnWCR1_RD(x, n) & ~BM_EIM_CSnWCR1_WAL) | BF_EIM_CSnWCR1_WAL(v)))
/*@}*/
/*******************************************************************************
 * HW_EIM_CSnWCR2 - Chip Select n Write Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_EIM_CSnWCR2 - Chip Select n Write Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_eim_csnwcr2
{
    uint32_t U;
    struct _hw_eim_csnwcr2_bitfields
    {
        uint32_t WBCDD : 1;            /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_eim_csnwcr2_t;

/*!
 * @name Constants and macros for entire EIM_CSnWCR2 register
 */
/*@{*/
#define HW_EIM_CSnWCR2_COUNT (4U)

#define HW_EIM_CSnWCR2_ADDR(x, n) ((uintptr_t)(x) + 0x14U + (0x18U * (n)))

#define HW_EIM_CSnWCR2(x, n)     (*(__IO hw_eim_csnwcr2_t *) HW_EIM_CSnWCR2_ADDR(x, n))
#define HW_EIM_CSnWCR2_RD(x, n)  (HW_EIM_CSnWCR2(x, n).U)
#define HW_EIM_CSnWCR2_WR(x, n, v) (HW_EIM_CSnWCR2(x, n).U = (v))
#define HW_EIM_CSnWCR2_SET(x, n, v) (HW_EIM_CSnWCR2_WR(x, n, HW_EIM_CSnWCR2_RD(x, n) |  (v)))
#define HW_EIM_CSnWCR2_CLR(x, n, v) (HW_EIM_CSnWCR2_WR(x, n, HW_EIM_CSnWCR2_RD(x, n) & ~(v)))
#define HW_EIM_CSnWCR2_TOG(x, n, v) (HW_EIM_CSnWCR2_WR(x, n, HW_EIM_CSnWCR2_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_CSnWCR2 bitfields
 */

/*!
 * @name Register EIM_CSnWCR2, field WBCDD[0] (RW)
 *
 * Write Burst Clock Divisor Decrement. If this bit is asserted and BCD value is
 * 0 sync. write access will be preformed as if BCD value is 1.When this bit is
 * negated or BCD value is not 0 this bit has no affect. This bit is cleared by
 * hardware reset.
 */
/*@{*/
#define BP_EIM_CSnWCR2_WBCDD (0U)          /*!< Bit position for EIM_CSnWCR2_WBCDD. */
#define BM_EIM_CSnWCR2_WBCDD (0x00000001U) /*!< Bit mask for EIM_CSnWCR2_WBCDD. */
#define BS_EIM_CSnWCR2_WBCDD (1U)          /*!< Bit field size in bits for EIM_CSnWCR2_WBCDD. */

/*! @brief Read current value of the EIM_CSnWCR2_WBCDD field. */
#define BR_EIM_CSnWCR2_WBCDD(x, n) (HW_EIM_CSnWCR2(x, n).B.WBCDD)

/*! @brief Format value for bitfield EIM_CSnWCR2_WBCDD. */
#define BF_EIM_CSnWCR2_WBCDD(v) ((uint32_t)((uint32_t)(v) << BP_EIM_CSnWCR2_WBCDD) & BM_EIM_CSnWCR2_WBCDD)

/*! @brief Set the WBCDD field to a new value. */
#define BW_EIM_CSnWCR2_WBCDD(x, n, v) (HW_EIM_CSnWCR2_WR(x, n, (HW_EIM_CSnWCR2_RD(x, n) & ~BM_EIM_CSnWCR2_WBCDD) | BF_EIM_CSnWCR2_WBCDD(v)))
/*@}*/

/*******************************************************************************
 * HW_EIM_WCR - EIM Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_EIM_WCR - EIM Configuration Register (RW)
 *
 * Reset value: 0x00000020U
 */
typedef union _hw_eim_wcr
{
    uint32_t U;
    struct _hw_eim_wcr_bitfields
    {
        uint32_t BCM : 1;              /*!< [0]  */
        uint32_t GBCD : 2;             /*!< [2:1]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t INTEN : 1;            /*!< [4]  */
        uint32_t INTPOL : 1;           /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t WDOG_EN : 1;          /*!< [8]  */
        uint32_t WDOG_LIMIT : 2;       /*!< [10:9]  */
        uint32_t RESERVED2 : 21;       /*!< [31:11]  */
    } B;
} hw_eim_wcr_t;

/*!
 * @name Constants and macros for entire EIM_WCR register
 */
/*@{*/
#define HW_EIM_WCR_ADDR(x)       ((uintptr_t)(x) + 0x90U)

#define HW_EIM_WCR(x)            (*(__IO hw_eim_wcr_t *) HW_EIM_WCR_ADDR(x))
#define HW_EIM_WCR_RD(x)         (HW_EIM_WCR(x).U)
#define HW_EIM_WCR_WR(x, v)      (HW_EIM_WCR(x).U = (v))
#define HW_EIM_WCR_SET(x, v)     (HW_EIM_WCR_WR(x, HW_EIM_WCR_RD(x) |  (v)))
#define HW_EIM_WCR_CLR(x, v)     (HW_EIM_WCR_WR(x, HW_EIM_WCR_RD(x) & ~(v)))
#define HW_EIM_WCR_TOG(x, v)     (HW_EIM_WCR_WR(x, HW_EIM_WCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_WCR bitfields
 */

/*!
 * @name Register EIM_WCR, field BCM[0] (RW)
 *
 * Burst Clock Mode. This bit selects the burst clock mode of operation. It is
 * used for system debug mode. BCM is cleared by a hardware reset. The BCLK
 * frequency in this mode is according to GBCD bit field. The BCLK phase is opposite to
 * the EIM clock in this mode if GBCD is 0. This bit should be used only in
 * async. accesses. No sync access can be executed if this bit is set. When this bit
 * is set bcd field shouldn't be configured to 0.
 *
 * Values:
 * - 0 - The burst clock runs only when accessing a chip select range with the
 *     SWR/SRD bits set. When the burst clock is not running it remains in a logic
 *     0 state. When the burst clock is running it is configured by the BCD and
 *     BCS bit fields in the chip select Configuration Register.
 * - 1 - The burst clock runs whenever ACLK is active (independent of chip
 *     select configuration)
 */
/*@{*/
#define BP_EIM_WCR_BCM       (0U)          /*!< Bit position for EIM_WCR_BCM. */
#define BM_EIM_WCR_BCM       (0x00000001U) /*!< Bit mask for EIM_WCR_BCM. */
#define BS_EIM_WCR_BCM       (1U)          /*!< Bit field size in bits for EIM_WCR_BCM. */

/*! @brief Read current value of the EIM_WCR_BCM field. */
#define BR_EIM_WCR_BCM(x)    (HW_EIM_WCR(x).B.BCM)

/*! @brief Format value for bitfield EIM_WCR_BCM. */
#define BF_EIM_WCR_BCM(v)    ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_BCM) & BM_EIM_WCR_BCM)

/*! @brief Set the BCM field to a new value. */
#define BW_EIM_WCR_BCM(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_BCM) | BF_EIM_WCR_BCM(v)))
/*@}*/

/*!
 * @name Register EIM_WCR, field GBCD[2:1] (RW)
 *
 * General Burst Clock Divisor. When BCM bit is set, this bit field contains the
 * value used to program the burst clock divisor for Continuous BCLK generation.
 * The other BCD bit fields for each chip select are ignored. It is used to
 * divide the internal AXI bus frequency. When BCM=0 GBCD bit field has no influence.
 * GBCD is cleared by a hardware reset.
 *
 * Values:
 * - 00 - Divide EIM clock by 1
 * - 01 - Divide EIM clock by 2
 * - 10 - Divide EIM clock by 3
 * - 11 - Divide EIM clock by 4
 */
/*@{*/
#define BP_EIM_WCR_GBCD      (1U)          /*!< Bit position for EIM_WCR_GBCD. */
#define BM_EIM_WCR_GBCD      (0x00000006U) /*!< Bit mask for EIM_WCR_GBCD. */
#define BS_EIM_WCR_GBCD      (2U)          /*!< Bit field size in bits for EIM_WCR_GBCD. */

/*! @brief Read current value of the EIM_WCR_GBCD field. */
#define BR_EIM_WCR_GBCD(x)   (HW_EIM_WCR(x).B.GBCD)

/*! @brief Format value for bitfield EIM_WCR_GBCD. */
#define BF_EIM_WCR_GBCD(v)   ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_GBCD) & BM_EIM_WCR_GBCD)

/*! @brief Set the GBCD field to a new value. */
#define BW_EIM_WCR_GBCD(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_GBCD) | BF_EIM_WCR_GBCD(v)))
/*@}*/

/*!
 * @name Register EIM_WCR, field INTEN[4] (RW)
 *
 * Interrupt Enable. When this bit is set the External signal RDY_INT as active
 * interrupt. When interrupt occurs, INT bit at the WCR will be set and t
 * EIM_EXT_INT signal will be asserted correspondingly. This bit is cleared by a
 * hardware reset.
 *
 * Values:
 * - 0 - External interrupt Disable
 * - 1 - External interrupt Enable
 */
/*@{*/
#define BP_EIM_WCR_INTEN     (4U)          /*!< Bit position for EIM_WCR_INTEN. */
#define BM_EIM_WCR_INTEN     (0x00000010U) /*!< Bit mask for EIM_WCR_INTEN. */
#define BS_EIM_WCR_INTEN     (1U)          /*!< Bit field size in bits for EIM_WCR_INTEN. */

/*! @brief Read current value of the EIM_WCR_INTEN field. */
#define BR_EIM_WCR_INTEN(x)  (HW_EIM_WCR(x).B.INTEN)

/*! @brief Format value for bitfield EIM_WCR_INTEN. */
#define BF_EIM_WCR_INTEN(v)  ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_INTEN) & BM_EIM_WCR_INTEN)

/*! @brief Set the INTEN field to a new value. */
#define BW_EIM_WCR_INTEN(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_INTEN) | BF_EIM_WCR_INTEN(v)))
/*@}*/

/*!
 * @name Register EIM_WCR, field INTPOL[5] (RW)
 *
 * Interrupt Polarity. This bit field determines the polarity of the external
 * device interrupt.
 *
 * Values:
 * - 0 - External interrupt polarity is active low
 * - 1 - External interrupt polarity is active high
 */
/*@{*/
#define BP_EIM_WCR_INTPOL    (5U)          /*!< Bit position for EIM_WCR_INTPOL. */
#define BM_EIM_WCR_INTPOL    (0x00000020U) /*!< Bit mask for EIM_WCR_INTPOL. */
#define BS_EIM_WCR_INTPOL    (1U)          /*!< Bit field size in bits for EIM_WCR_INTPOL. */

/*! @brief Read current value of the EIM_WCR_INTPOL field. */
#define BR_EIM_WCR_INTPOL(x) (HW_EIM_WCR(x).B.INTPOL)

/*! @brief Format value for bitfield EIM_WCR_INTPOL. */
#define BF_EIM_WCR_INTPOL(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_INTPOL) & BM_EIM_WCR_INTPOL)

/*! @brief Set the INTPOL field to a new value. */
#define BW_EIM_WCR_INTPOL(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_INTPOL) | BF_EIM_WCR_INTPOL(v)))
/*@}*/

/*!
 * @name Register EIM_WCR, field WDOG_EN[8] (RW)
 *
 * Memory WDOG enable. This bit controls the operation of the wdog counter that
 * terminates the EIM access.
 *
 * Values:
 * - 0 - Memory WDOG is Disabled
 * - 1 - Memory WDOG is Enabled
 */
/*@{*/
#define BP_EIM_WCR_WDOG_EN   (8U)          /*!< Bit position for EIM_WCR_WDOG_EN. */
#define BM_EIM_WCR_WDOG_EN   (0x00000100U) /*!< Bit mask for EIM_WCR_WDOG_EN. */
#define BS_EIM_WCR_WDOG_EN   (1U)          /*!< Bit field size in bits for EIM_WCR_WDOG_EN. */

/*! @brief Read current value of the EIM_WCR_WDOG_EN field. */
#define BR_EIM_WCR_WDOG_EN(x) (HW_EIM_WCR(x).B.WDOG_EN)

/*! @brief Format value for bitfield EIM_WCR_WDOG_EN. */
#define BF_EIM_WCR_WDOG_EN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_WDOG_EN) & BM_EIM_WCR_WDOG_EN)

/*! @brief Set the WDOG_EN field to a new value. */
#define BW_EIM_WCR_WDOG_EN(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_WDOG_EN) | BF_EIM_WCR_WDOG_EN(v)))
/*@}*/

/*!
 * @name Register EIM_WCR, field WDOG_LIMIT[10:9] (RW)
 *
 * Memory Watchdog (WDOG) cycle limit. This bit field determines the number of
 * BCLK cycles (ACLK cycles in dtack mode) before the WDOG counter terminates the
 * access and send an error response to the master.
 *
 * Values:
 * - 00 - 128 BCLK cycles
 * - 01 - 256 BCLK cycles
 * - 10 - 512 BCLK cycles
 * - 11 - 1024 BCLK cycles
 */
/*@{*/
#define BP_EIM_WCR_WDOG_LIMIT (9U)         /*!< Bit position for EIM_WCR_WDOG_LIMIT. */
#define BM_EIM_WCR_WDOG_LIMIT (0x00000600U) /*!< Bit mask for EIM_WCR_WDOG_LIMIT. */
#define BS_EIM_WCR_WDOG_LIMIT (2U)         /*!< Bit field size in bits for EIM_WCR_WDOG_LIMIT. */

/*! @brief Read current value of the EIM_WCR_WDOG_LIMIT field. */
#define BR_EIM_WCR_WDOG_LIMIT(x) (HW_EIM_WCR(x).B.WDOG_LIMIT)

/*! @brief Format value for bitfield EIM_WCR_WDOG_LIMIT. */
#define BF_EIM_WCR_WDOG_LIMIT(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WCR_WDOG_LIMIT) & BM_EIM_WCR_WDOG_LIMIT)

/*! @brief Set the WDOG_LIMIT field to a new value. */
#define BW_EIM_WCR_WDOG_LIMIT(x, v) (HW_EIM_WCR_WR(x, (HW_EIM_WCR_RD(x) & ~BM_EIM_WCR_WDOG_LIMIT) | BF_EIM_WCR_WDOG_LIMIT(v)))
/*@}*/

/*******************************************************************************
 * HW_EIM_WIAR - EIM IP Access Register
 ******************************************************************************/

/*!
 * @brief HW_EIM_WIAR - EIM IP Access Register (RW)
 *
 * Reset value: 0x00000010U
 */
typedef union _hw_eim_wiar
{
    uint32_t U;
    struct _hw_eim_wiar_bitfields
    {
        uint32_t IPS_REQ : 1;          /*!< [0]  */
        uint32_t IPS_ACK : 1;          /*!< [1]  */
        uint32_t INT : 1;              /*!< [2]  */
        uint32_t ERRST : 1;            /*!< [3]  */
        uint32_t ACLK_EN : 1;          /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_eim_wiar_t;

/*!
 * @name Constants and macros for entire EIM_WIAR register
 */
/*@{*/
#define HW_EIM_WIAR_ADDR(x)      ((uintptr_t)(x) + 0x94U)

#define HW_EIM_WIAR(x)           (*(__IO hw_eim_wiar_t *) HW_EIM_WIAR_ADDR(x))
#define HW_EIM_WIAR_RD(x)        (HW_EIM_WIAR(x).U)
#define HW_EIM_WIAR_WR(x, v)     (HW_EIM_WIAR(x).U = (v))
#define HW_EIM_WIAR_SET(x, v)    (HW_EIM_WIAR_WR(x, HW_EIM_WIAR_RD(x) |  (v)))
#define HW_EIM_WIAR_CLR(x, v)    (HW_EIM_WIAR_WR(x, HW_EIM_WIAR_RD(x) & ~(v)))
#define HW_EIM_WIAR_TOG(x, v)    (HW_EIM_WIAR_WR(x, HW_EIM_WIAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_WIAR bitfields
 */

/*!
 * @name Register EIM_WIAR, field IPS_REQ[0] (RW)
 *
 * IPS request. The Master requests to access one of the IPS registers. During
 * such access the EIM should not perform any AXI/memory accesses. The EIM
 * finishes the AXI accesses that already starts and asserts the IPS_ACK bit.
 *
 * Values:
 * - 0 - No Master requests ips access
 * - 1 - Master requests ips access
 */
/*@{*/
#define BP_EIM_WIAR_IPS_REQ  (0U)          /*!< Bit position for EIM_WIAR_IPS_REQ. */
#define BM_EIM_WIAR_IPS_REQ  (0x00000001U) /*!< Bit mask for EIM_WIAR_IPS_REQ. */
#define BS_EIM_WIAR_IPS_REQ  (1U)          /*!< Bit field size in bits for EIM_WIAR_IPS_REQ. */

/*! @brief Read current value of the EIM_WIAR_IPS_REQ field. */
#define BR_EIM_WIAR_IPS_REQ(x) (HW_EIM_WIAR(x).B.IPS_REQ)

/*! @brief Format value for bitfield EIM_WIAR_IPS_REQ. */
#define BF_EIM_WIAR_IPS_REQ(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WIAR_IPS_REQ) & BM_EIM_WIAR_IPS_REQ)

/*! @brief Set the IPS_REQ field to a new value. */
#define BW_EIM_WIAR_IPS_REQ(x, v) (HW_EIM_WIAR_WR(x, (HW_EIM_WIAR_RD(x) & ~BM_EIM_WIAR_IPS_REQ) | BF_EIM_WIAR_IPS_REQ(v)))
/*@}*/

/*!
 * @name Register EIM_WIAR, field IPS_ACK[1] (RW)
 *
 * IPS ACK. The EIM is ready for ips access. There is no active AXI access and
 * no new AXI access is accepted till this bit is cleared. This bit is cleared by
 * the master after it completes the ips accesses.
 *
 * Values:
 * - 0 - Master cannot access ips.
 * - 1 - Master can access ips.
 */
/*@{*/
#define BP_EIM_WIAR_IPS_ACK  (1U)          /*!< Bit position for EIM_WIAR_IPS_ACK. */
#define BM_EIM_WIAR_IPS_ACK  (0x00000002U) /*!< Bit mask for EIM_WIAR_IPS_ACK. */
#define BS_EIM_WIAR_IPS_ACK  (1U)          /*!< Bit field size in bits for EIM_WIAR_IPS_ACK. */

/*! @brief Read current value of the EIM_WIAR_IPS_ACK field. */
#define BR_EIM_WIAR_IPS_ACK(x) (HW_EIM_WIAR(x).B.IPS_ACK)

/*! @brief Format value for bitfield EIM_WIAR_IPS_ACK. */
#define BF_EIM_WIAR_IPS_ACK(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WIAR_IPS_ACK) & BM_EIM_WIAR_IPS_ACK)

/*! @brief Set the IPS_ACK field to a new value. */
#define BW_EIM_WIAR_IPS_ACK(x, v) (HW_EIM_WIAR_WR(x, (HW_EIM_WIAR_RD(x) & ~BM_EIM_WIAR_IPS_ACK) | BF_EIM_WIAR_IPS_ACK(v)))
/*@}*/

/*!
 * @name Register EIM_WIAR, field INT[2] (RW)
 *
 * Interrupt. This bit indicates interrupt assertion by an external device
 * according to RDY_INT signal. When polling this bit, INT=0 indicates interrupt not
 * occurred and INT=1 indicates assertion of the external device interrupt. This
 * bit is cleared by a hardware reset.
 */
/*@{*/
#define BP_EIM_WIAR_INT      (2U)          /*!< Bit position for EIM_WIAR_INT. */
#define BM_EIM_WIAR_INT      (0x00000004U) /*!< Bit mask for EIM_WIAR_INT. */
#define BS_EIM_WIAR_INT      (1U)          /*!< Bit field size in bits for EIM_WIAR_INT. */

/*! @brief Read current value of the EIM_WIAR_INT field. */
#define BR_EIM_WIAR_INT(x)   (HW_EIM_WIAR(x).B.INT)

/*! @brief Format value for bitfield EIM_WIAR_INT. */
#define BF_EIM_WIAR_INT(v)   ((uint32_t)((uint32_t)(v) << BP_EIM_WIAR_INT) & BM_EIM_WIAR_INT)

/*! @brief Set the INT field to a new value. */
#define BW_EIM_WIAR_INT(x, v) (HW_EIM_WIAR_WR(x, (HW_EIM_WIAR_RD(x) & ~BM_EIM_WIAR_INT) | BF_EIM_WIAR_INT(v)))
/*@}*/

/*!
 * @name Register EIM_WIAR, field ERRST[3] (RW)
 *
 * READY After Reset. This bit controls the initial ready/busy status for
 * external devices on CS0 immediately after hardware reset. This is a sticky bit which
 * is cleared once the RDY_INT signal is asserted by the external device. When
 * ERRST = 1 the first fetch access from EIM to the external device located on CS0
 * will be pending until RDY_INT signal indicates that the external device is
 * ready, then EIM will execute the access.
 *
 * Values:
 * - 0 - RDY_INT After Reset Disable
 * - 1 - RDY_INT After Reset Enable
 */
/*@{*/
#define BP_EIM_WIAR_ERRST    (3U)          /*!< Bit position for EIM_WIAR_ERRST. */
#define BM_EIM_WIAR_ERRST    (0x00000008U) /*!< Bit mask for EIM_WIAR_ERRST. */
#define BS_EIM_WIAR_ERRST    (1U)          /*!< Bit field size in bits for EIM_WIAR_ERRST. */

/*! @brief Read current value of the EIM_WIAR_ERRST field. */
#define BR_EIM_WIAR_ERRST(x) (HW_EIM_WIAR(x).B.ERRST)

/*! @brief Format value for bitfield EIM_WIAR_ERRST. */
#define BF_EIM_WIAR_ERRST(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WIAR_ERRST) & BM_EIM_WIAR_ERRST)

/*! @brief Set the ERRST field to a new value. */
#define BW_EIM_WIAR_ERRST(x, v) (HW_EIM_WIAR_WR(x, (HW_EIM_WIAR_RD(x) & ~BM_EIM_WIAR_ERRST) | BF_EIM_WIAR_ERRST(v)))
/*@}*/

/*!
 * @name Register EIM_WIAR, field ACLK_EN[4] (RW)
 *
 * ACLK enable. This bit gates the ACLK for the EIM except from FFs that get
 * ipg_aclk_s. After reset ACLK is enabled.
 *
 * Values:
 * - 0 - ACLK is disabled
 * - 1 - ACLK is enabled
 */
/*@{*/
#define BP_EIM_WIAR_ACLK_EN  (4U)          /*!< Bit position for EIM_WIAR_ACLK_EN. */
#define BM_EIM_WIAR_ACLK_EN  (0x00000010U) /*!< Bit mask for EIM_WIAR_ACLK_EN. */
#define BS_EIM_WIAR_ACLK_EN  (1U)          /*!< Bit field size in bits for EIM_WIAR_ACLK_EN. */

/*! @brief Read current value of the EIM_WIAR_ACLK_EN field. */
#define BR_EIM_WIAR_ACLK_EN(x) (HW_EIM_WIAR(x).B.ACLK_EN)

/*! @brief Format value for bitfield EIM_WIAR_ACLK_EN. */
#define BF_EIM_WIAR_ACLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_EIM_WIAR_ACLK_EN) & BM_EIM_WIAR_ACLK_EN)

/*! @brief Set the ACLK_EN field to a new value. */
#define BW_EIM_WIAR_ACLK_EN(x, v) (HW_EIM_WIAR_WR(x, (HW_EIM_WIAR_RD(x) & ~BM_EIM_WIAR_ACLK_EN) | BF_EIM_WIAR_ACLK_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_EIM_EAR - Error Address Register
 ******************************************************************************/

/*!
 * @brief HW_EIM_EAR - Error Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_eim_ear
{
    uint32_t U;
    struct _hw_eim_ear_bitfields
    {
        uint32_t Error_ADDR : 32;      /*!< [31:0]  */
    } B;
} hw_eim_ear_t;

/*!
 * @name Constants and macros for entire EIM_EAR register
 */
/*@{*/
#define HW_EIM_EAR_ADDR(x)       ((uintptr_t)(x) + 0x98U)

#define HW_EIM_EAR(x)            (*(__IO hw_eim_ear_t *) HW_EIM_EAR_ADDR(x))
#define HW_EIM_EAR_RD(x)         (HW_EIM_EAR(x).U)
#define HW_EIM_EAR_WR(x, v)      (HW_EIM_EAR(x).U = (v))
#define HW_EIM_EAR_SET(x, v)     (HW_EIM_EAR_WR(x, HW_EIM_EAR_RD(x) |  (v)))
#define HW_EIM_EAR_CLR(x, v)     (HW_EIM_EAR_WR(x, HW_EIM_EAR_RD(x) & ~(v)))
#define HW_EIM_EAR_TOG(x, v)     (HW_EIM_EAR_WR(x, HW_EIM_EAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EIM_EAR bitfields
 */

/*!
 * @name Register EIM_EAR, field Error_ADDR[31:0] (RW)
 *
 * Error Address. This bit field holds the AXI address of the last access that
 * caused error. This register is read only register.
 */
/*@{*/
#define BP_EIM_EAR_Error_ADDR (0U)         /*!< Bit position for EIM_EAR_Error_ADDR. */
#define BM_EIM_EAR_Error_ADDR (0xFFFFFFFFU) /*!< Bit mask for EIM_EAR_Error_ADDR. */
#define BS_EIM_EAR_Error_ADDR (32U)        /*!< Bit field size in bits for EIM_EAR_Error_ADDR. */

/*! @brief Read current value of the EIM_EAR_Error_ADDR field. */
#define BR_EIM_EAR_Error_ADDR(x) (HW_EIM_EAR(x).U)

/*! @brief Format value for bitfield EIM_EAR_Error_ADDR. */
#define BF_EIM_EAR_Error_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_EIM_EAR_Error_ADDR) & BM_EIM_EAR_Error_ADDR)

/*! @brief Set the Error_ADDR field to a new value. */
#define BW_EIM_EAR_Error_ADDR(x, v) (HW_EIM_EAR_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_eim_t - module struct
 ******************************************************************************/
/*!
 * @brief All EIM module registers.
 */
#pragma pack(1)
typedef struct _hw_eim
{
    struct {
        __IO hw_eim_csngcr1_t CSnGCR1;     /*!< [0x0] Chip Select n General Configuration Register 1 */
        __IO hw_eim_csngcr2_t CSnGCR2;     /*!< [0x4] Chip Select n General Configuration Register 2 */
        __IO hw_eim_csnrcr1_t CSnRCR1;     /*!< [0x8] Chip Select n Read Configuration Register 1 */
        __IO hw_eim_csnrcr2_t CSnRCR2;     /*!< [0xC] Chip Select n Read Configuration Register 2 */
        __IO hw_eim_csnwcr1_t CSnWCR1;     /*!< [0x10] Chip Select n Write Configuration Register 1 */
        __IO hw_eim_csnwcr2_t CSnWCR2;     /*!< [0x14] Chip Select n Write Configuration Register 2 */
    } CSxCR[4];
    uint8_t _reserved0[48];
    __IO hw_eim_wcr_t WCR;                 /*!< [0x90] EIM Configuration Register */
    __IO hw_eim_wiar_t WIAR;               /*!< [0x94] EIM IP Access Register */
    __IO hw_eim_ear_t EAR;                 /*!< [0x98] Error Address Register */
} hw_eim_t;
#pragma pack()

/*! @brief Macro to access all EIM registers. */
/*! @param x EIM module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_EIM_REGS(EIM_BASE)</code>. */
#define HW_EIM_REGS(x) (*(hw_eim_t *)(x))

/*
 * iMX6DP ENET
 *
 * Ethernet MAC-NET Core
 *
 * Registers defined in this header file:
 * - HW_ENET_EIR - Interrupt Event Register
 * - HW_ENET_EIMR - Interrupt Mask Register
 * - HW_ENET_RDAR - Receive Descriptor Active Register
 * - HW_ENET_TDAR - Transmit Descriptor Active Register
 * - HW_ENET_ECR - Ethernet Control Register
 * - HW_ENET_MMFR - MII Management Frame Register
 * - HW_ENET_MSCR - MII Speed Control Register
 * - HW_ENET_MIBC - MIB Control Register
 * - HW_ENET_RCR - Receive Control Register
 * - HW_ENET_TCR - Transmit Control Register
 * - HW_ENET_PALR - Physical Address Lower Register
 * - HW_ENET_PAUR - Physical Address Upper Register
 * - HW_ENET_OPD - Opcode/Pause Duration Register
 * - HW_ENET_IAUR - Descriptor Individual Upper Address Register
 * - HW_ENET_IALR - Descriptor Individual Lower Address Register
 * - HW_ENET_GAUR - Descriptor Group Upper Address Register
 * - HW_ENET_GALR - Descriptor Group Lower Address Register
 * - HW_ENET_TFWR - Transmit FIFO Watermark Register
 * - HW_ENET_RDSR - Receive Descriptor Ring Start Register
 * - HW_ENET_TDSR - Transmit Buffer Descriptor Ring Start Register
 * - HW_ENET_MRBR - Maximum Receive Buffer Size Register
 * - HW_ENET_RSFL - Receive FIFO Section Full Threshold
 * - HW_ENET_RSEM - Receive FIFO Section Empty Threshold
 * - HW_ENET_RAEM - Receive FIFO Almost Empty Threshold
 * - HW_ENET_RAFL - Receive FIFO Almost Full Threshold
 * - HW_ENET_TSEM - Transmit FIFO Section Empty Threshold
 * - HW_ENET_TAEM - Transmit FIFO Almost Empty Threshold
 * - HW_ENET_TAFL - Transmit FIFO Almost Full Threshold
 * - HW_ENET_TIPG - Transmit Inter-Packet Gap
 * - HW_ENET_FTRL - Frame Truncation Length
 * - HW_ENET_TACC - Transmit Accelerator Function Configuration
 * - HW_ENET_RACC - Receive Accelerator Function Configuration
 * - HW_ENET_RMON_T_DROP - Reserved Statistic Register
 * - HW_ENET_RMON_T_PACKETS - Tx Packet Count Statistic Register
 * - HW_ENET_RMON_T_BC_PKT - Tx Broadcast Packets Statistic Register
 * - HW_ENET_RMON_T_MC_PKT - Tx Multicast Packets Statistic Register
 * - HW_ENET_RMON_T_CRC_ALIGN - Tx Packets with CRC/Align Error Statistic Register
 * - HW_ENET_RMON_T_UNDERSIZE - Tx Packets Less Than Bytes and Good CRC Statistic Register
 * - HW_ENET_RMON_T_OVERSIZE - Tx Packets GT MAX_FL bytes and Good CRC Statistic Register
 * - HW_ENET_RMON_T_FRAG - Tx Packets Less Than 64 Bytes and Bad CRC Statistic Register
 * - HW_ENET_RMON_T_JAB - Tx Packets Greater Than MAX_FL bytes and Bad CRC Statistic Register
 * - HW_ENET_RMON_T_COL - Tx Collision Count Statistic Register
 * - HW_ENET_RMON_T_P64 - Tx 64-Byte Packets Statistic Register
 * - HW_ENET_RMON_T_P65TO127 - Tx 65- to 127-byte Packets Statistic Register
 * - HW_ENET_RMON_T_P128TO255 - Tx 128- to 255-byte Packets Statistic Register
 * - HW_ENET_RMON_T_P256TO511 - Tx 256- to 511-byte Packets Statistic Register
 * - HW_ENET_RMON_T_P512TO1023 - Tx 512- to 1023-byte Packets Statistic Register
 * - HW_ENET_RMON_T_P1024TO2047 - Tx 1024- to 2047-byte Packets Statistic Register
 * - HW_ENET_RMON_T_P_GTE2048 - Tx Packets Greater Than 2048 Bytes Statistic Register
 * - HW_ENET_RMON_T_OCTETS - Tx Octets Statistic Register
 * - HW_ENET_IEEE_T_DROP - Reserved Statistic Register
 * - HW_ENET_IEEE_T_FRAME_OK - Frames Transmitted OK Statistic Register
 * - HW_ENET_IEEE_T_1COL - Frames Transmitted with Single Collision Statistic Register
 * - HW_ENET_IEEE_T_MCOL - Frames Transmitted with Multiple Collisions Statistic Register
 * - HW_ENET_IEEE_T_DEF - Frames Transmitted after Deferral Delay Statistic Register
 * - HW_ENET_IEEE_T_LCOL - Frames Transmitted with Late Collision Statistic Register
 * - HW_ENET_IEEE_T_EXCOL - Frames Transmitted with Excessive Collisions Statistic Register
 * - HW_ENET_IEEE_T_MACERR - Frames Transmitted with Tx FIFO Underrun Statistic Register
 * - HW_ENET_IEEE_T_CSERR - Frames Transmitted with Carrier Sense Error Statistic Register
 * - HW_ENET_IEEE_T_SQE - Reserved Statistic Register
 * - HW_ENET_IEEE_T_FDXFC - Flow Control Pause Frames Transmitted Statistic Register
 * - HW_ENET_IEEE_T_OCTETS_OK - Octet Count for Frames Transmitted w/o Error Statistic Register
 * - HW_ENET_RMON_R_PACKETS - Rx Packet Count Statistic Register
 * - HW_ENET_RMON_R_BC_PKT - Rx Broadcast Packets Statistic Register
 * - HW_ENET_RMON_R_MC_PKT - Rx Multicast Packets Statistic Register
 * - HW_ENET_RMON_R_CRC_ALIGN - Rx Packets with CRC/Align Error Statistic Register
 * - HW_ENET_RMON_R_UNDERSIZE - Rx Packets with Less Than 64 Bytes and Good CRC Statistic Register
 * - HW_ENET_RMON_R_OVERSIZE - Rx Packets Greater Than MAX_FL and Good CRC Statistic Register
 * - HW_ENET_RMON_R_FRAG - Rx Packets Less Than 64 Bytes and Bad CRC Statistic Register
 * - HW_ENET_RMON_R_JAB - Rx Packets Greater Than MAX_FL Bytes and Bad CRC Statistic Register
 * - HW_ENET_RMON_R_RESVD_0 - Reserved Statistic Register
 * - HW_ENET_RMON_R_P64 - Rx 64-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P65TO127 - Rx 65- to 127-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P128TO255 - Rx 128- to 255-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P256TO511 - Rx 256- to 511-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P512TO1023 - Rx 512- to 1023-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P1024TO2047 - Rx 1024- to 2047-Byte Packets Statistic Register
 * - HW_ENET_RMON_R_P_GTE2048 - Rx Packets Greater than 2048 Bytes Statistic Register
 * - HW_ENET_RMON_R_OCTETS - Rx Octets Statistic Register
 * - HW_ENET_IEEE_R_DROP - Frames not Counted Correctly Statistic Register
 * - HW_ENET_IEEE_R_FRAME_OK - Frames Received OK Statistic Register
 * - HW_ENET_IEEE_R_CRC - Frames Received with CRC Error Statistic Register
 * - HW_ENET_IEEE_R_ALIGN - Frames Received with Alignment Error Statistic Register
 * - HW_ENET_IEEE_R_MACERR - Receive FIFO Overflow Count Statistic Register
 * - HW_ENET_IEEE_R_FDXFC - Flow Control Pause Frames Received Statistic Register
 * - HW_ENET_IEEE_R_OCTETS_OK - Octet Count for Frames Received without Error Statistic Register
 * - HW_ENET_ATCR - Adjustable Timer Control Register
 * - HW_ENET_ATVR - Timer Value Register
 * - HW_ENET_ATOFF - Timer Offset Register
 * - HW_ENET_ATPER - Timer Period Register
 * - HW_ENET_ATCOR - Timer Correction Register
 * - HW_ENET_ATINC - Time-Stamping Clock Period Register
 * - HW_ENET_ATSTMP - Timestamp of Last Transmitted Frame
 * - HW_ENET_TGSR - Timer Global Status Register
 * - HW_ENET_TCSRn - Timer Control Status Register
 * - HW_ENET_TCCRn - Timer Compare Capture Register
 *
 * - hw_enet_t - Struct containing all module registers.
 */

#define HW_ENET_INSTANCE_COUNT (1U) /*!< Number of instances of the ENET module. */
#define HW_ENET (0U) /*!< Instance number for ENET. */
#define ENET_BASE             (0x2188000U) /*!< Base address for ENET. */
/*! Array initializer of ENET base addresses. */
#define ENET_BASE_ADDRS       { ENET_BASE }

/*******************************************************************************
 * HW_ENET_EIR - Interrupt Event Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_EIR - Interrupt Event Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * When an event occurs that sets a bit in EIR, an interrupt occurs if the
 * corresponding bit in the interrupt mask register (EIMR) is also set. Writing a 1 to
 * an EIR bit clears it; writing 0 has no effect. This register is cleared upon
 * hardware reset. TxBD[INT] and RxBD[INT] must be set to 1 to allow setting the
 * corresponding EIR register flags in enhanced mode, ENET_ECR[EN1588] = 1.
 * Legacy mode does not require these flags to be enabled.
 */
typedef union _hw_enet_eir
{
    uint32_t U;
    struct _hw_enet_eir_bitfields
    {
        uint32_t RESERVED0 : 15;       /*!< [14:0]  */
        uint32_t TS_TIMER : 1;         /*!< [15] Timestamp Timer */
        uint32_t TS_AVAIL : 1;         /*!< [16] Transmit Timestamp Available */
        uint32_t WAKEUP : 1;           /*!< [17] Node Wakeup Request Indication */
        uint32_t PLR : 1;              /*!< [18] Payload Receive Error */
        uint32_t UN : 1;               /*!< [19] Transmit FIFO Underrun */
        uint32_t RL : 1;               /*!< [20] Collision Retry Limit */
        uint32_t LC : 1;               /*!< [21] Late Collision */
        uint32_t EBERR : 1;            /*!< [22] Ethernet Bus Error */
        uint32_t MII : 1;              /*!< [23] MII Interrupt. */
        uint32_t RXB : 1;              /*!< [24] Receive Buffer Interrupt */
        uint32_t RXF : 1;              /*!< [25] Receive Frame Interrupt */
        uint32_t TXB : 1;              /*!< [26] Transmit Buffer Interrupt */
        uint32_t TXF : 1;              /*!< [27] Transmit Frame Interrupt */
        uint32_t GRA : 1;              /*!< [28] Graceful Stop Complete */
        uint32_t BABT : 1;             /*!< [29] Babbling Transmit Error */
        uint32_t BABR : 1;             /*!< [30] Babbling Receive Error */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_enet_eir_t;

/*!
 * @name Constants and macros for entire ENET_EIR register
 */
/*@{*/
#define HW_ENET_EIR_ADDR(x)      ((uintptr_t)(x) + 0x4U)

#define HW_ENET_EIR(x)           (*(__IO hw_enet_eir_t *) HW_ENET_EIR_ADDR(x))
#define HW_ENET_EIR_RD(x)        (HW_ENET_EIR(x).U)
#define HW_ENET_EIR_WR(x, v)     (HW_ENET_EIR(x).U = (v))
#define HW_ENET_EIR_SET(x, v)    (HW_ENET_EIR_WR(x, HW_ENET_EIR_RD(x) |  (v)))
#define HW_ENET_EIR_CLR(x, v)    (HW_ENET_EIR_WR(x, HW_ENET_EIR_RD(x) & ~(v)))
#define HW_ENET_EIR_TOG(x, v)    (HW_ENET_EIR_WR(x, HW_ENET_EIR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_EIR bitfields
 */

/*!
 * @name Register ENET_EIR, field TS_TIMER[15] (W1C)
 *
 * The adjustable timer reached the period event. A period event interrupt can
 * be generated if ATCR[PEREN] is set and the timer wraps according to the
 * periodic setting in the ATPER register. Set the timer period value before setting
 * ATCR[PEREN].
 */
/*@{*/
#define BP_ENET_EIR_TS_TIMER (15U)         /*!< Bit position for ENET_EIR_TS_TIMER. */
#define BM_ENET_EIR_TS_TIMER (0x00008000U) /*!< Bit mask for ENET_EIR_TS_TIMER. */
#define BS_ENET_EIR_TS_TIMER (1U)          /*!< Bit field size in bits for ENET_EIR_TS_TIMER. */

/*! @brief Read current value of the ENET_EIR_TS_TIMER field. */
#define BR_ENET_EIR_TS_TIMER(x) (HW_ENET_EIR(x).B.TS_TIMER)

/*! @brief Format value for bitfield ENET_EIR_TS_TIMER. */
#define BF_ENET_EIR_TS_TIMER(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_TS_TIMER) & BM_ENET_EIR_TS_TIMER)

/*! @brief Set the TS_TIMER field to a new value. */
#define BW_ENET_EIR_TS_TIMER(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_TS_TIMER(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field TS_AVAIL[16] (W1C)
 *
 * Indicates that the timestamp of the last transmitted timing frame is
 * available in the ATSTMP register.
 */
/*@{*/
#define BP_ENET_EIR_TS_AVAIL (16U)         /*!< Bit position for ENET_EIR_TS_AVAIL. */
#define BM_ENET_EIR_TS_AVAIL (0x00010000U) /*!< Bit mask for ENET_EIR_TS_AVAIL. */
#define BS_ENET_EIR_TS_AVAIL (1U)          /*!< Bit field size in bits for ENET_EIR_TS_AVAIL. */

/*! @brief Read current value of the ENET_EIR_TS_AVAIL field. */
#define BR_ENET_EIR_TS_AVAIL(x) (HW_ENET_EIR(x).B.TS_AVAIL)

/*! @brief Format value for bitfield ENET_EIR_TS_AVAIL. */
#define BF_ENET_EIR_TS_AVAIL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_TS_AVAIL) & BM_ENET_EIR_TS_AVAIL)

/*! @brief Set the TS_AVAIL field to a new value. */
#define BW_ENET_EIR_TS_AVAIL(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_TS_AVAIL(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field WAKEUP[17] (W1C)
 *
 * Read-only status bit to indicate that a magic packet has been detected. Will
 * act only if ECR[MAGICEN] is set.
 */
/*@{*/
#define BP_ENET_EIR_WAKEUP   (17U)         /*!< Bit position for ENET_EIR_WAKEUP. */
#define BM_ENET_EIR_WAKEUP   (0x00020000U) /*!< Bit mask for ENET_EIR_WAKEUP. */
#define BS_ENET_EIR_WAKEUP   (1U)          /*!< Bit field size in bits for ENET_EIR_WAKEUP. */

/*! @brief Read current value of the ENET_EIR_WAKEUP field. */
#define BR_ENET_EIR_WAKEUP(x) (HW_ENET_EIR(x).B.WAKEUP)

/*! @brief Format value for bitfield ENET_EIR_WAKEUP. */
#define BF_ENET_EIR_WAKEUP(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_WAKEUP) & BM_ENET_EIR_WAKEUP)

/*! @brief Set the WAKEUP field to a new value. */
#define BW_ENET_EIR_WAKEUP(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_WAKEUP | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_WAKEUP(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field PLR[18] (W1C)
 *
 * Indicates a frame was received with a payload length error. See Frame
 * Length/Type Verification: Payload Length Check for more information.
 */
/*@{*/
#define BP_ENET_EIR_PLR      (18U)         /*!< Bit position for ENET_EIR_PLR. */
#define BM_ENET_EIR_PLR      (0x00040000U) /*!< Bit mask for ENET_EIR_PLR. */
#define BS_ENET_EIR_PLR      (1U)          /*!< Bit field size in bits for ENET_EIR_PLR. */

/*! @brief Read current value of the ENET_EIR_PLR field. */
#define BR_ENET_EIR_PLR(x)   (HW_ENET_EIR(x).B.PLR)

/*! @brief Format value for bitfield ENET_EIR_PLR. */
#define BF_ENET_EIR_PLR(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_PLR) & BM_ENET_EIR_PLR)

/*! @brief Set the PLR field to a new value. */
#define BW_ENET_EIR_PLR(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_PLR | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_PLR(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field UN[19] (W1C)
 *
 * Indicates the transmit FIFO became empty before the complete frame was
 * transmitted. A bad CRC is appended to the frame fragment and the remainder of the
 * frame is discarded.
 */
/*@{*/
#define BP_ENET_EIR_UN       (19U)         /*!< Bit position for ENET_EIR_UN. */
#define BM_ENET_EIR_UN       (0x00080000U) /*!< Bit mask for ENET_EIR_UN. */
#define BS_ENET_EIR_UN       (1U)          /*!< Bit field size in bits for ENET_EIR_UN. */

/*! @brief Read current value of the ENET_EIR_UN field. */
#define BR_ENET_EIR_UN(x)    (HW_ENET_EIR(x).B.UN)

/*! @brief Format value for bitfield ENET_EIR_UN. */
#define BF_ENET_EIR_UN(v)    ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_UN) & BM_ENET_EIR_UN)

/*! @brief Set the UN field to a new value. */
#define BW_ENET_EIR_UN(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_UN | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_UN(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field RL[20] (W1C)
 *
 * Indicates a collision occurred on each of 16 successive attempts to transmit
 * the frame. The frame is discarded without being transmitted and transmission
 * of the next frame commences. This error can only occur in half-duplex mode.
 */
/*@{*/
#define BP_ENET_EIR_RL       (20U)         /*!< Bit position for ENET_EIR_RL. */
#define BM_ENET_EIR_RL       (0x00100000U) /*!< Bit mask for ENET_EIR_RL. */
#define BS_ENET_EIR_RL       (1U)          /*!< Bit field size in bits for ENET_EIR_RL. */

/*! @brief Read current value of the ENET_EIR_RL field. */
#define BR_ENET_EIR_RL(x)    (HW_ENET_EIR(x).B.RL)

/*! @brief Format value for bitfield ENET_EIR_RL. */
#define BF_ENET_EIR_RL(v)    ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_RL) & BM_ENET_EIR_RL)

/*! @brief Set the RL field to a new value. */
#define BW_ENET_EIR_RL(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_RL | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_RL(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field LC[21] (W1C)
 *
 * Indicates a collision occurred beyond the collision window (slot time) in
 * half-duplex mode. The frame truncates with a bad CRC and the remainder of the
 * frame is discarded.
 */
/*@{*/
#define BP_ENET_EIR_LC       (21U)         /*!< Bit position for ENET_EIR_LC. */
#define BM_ENET_EIR_LC       (0x00200000U) /*!< Bit mask for ENET_EIR_LC. */
#define BS_ENET_EIR_LC       (1U)          /*!< Bit field size in bits for ENET_EIR_LC. */

/*! @brief Read current value of the ENET_EIR_LC field. */
#define BR_ENET_EIR_LC(x)    (HW_ENET_EIR(x).B.LC)

/*! @brief Format value for bitfield ENET_EIR_LC. */
#define BF_ENET_EIR_LC(v)    ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_LC) & BM_ENET_EIR_LC)

/*! @brief Set the LC field to a new value. */
#define BW_ENET_EIR_LC(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_LC | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_LC(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field EBERR[22] (W1C)
 *
 * Indicates a system bus error occurred when a uDMA transaction is underway.
 * When this bit is set, ECR[ETHEREN] is cleared, halting frame processing by the
 * MAC. When this occurs, software must ensure proper actions, possibly resetting
 * the system, to resume normal operation.
 */
/*@{*/
#define BP_ENET_EIR_EBERR    (22U)         /*!< Bit position for ENET_EIR_EBERR. */
#define BM_ENET_EIR_EBERR    (0x00400000U) /*!< Bit mask for ENET_EIR_EBERR. */
#define BS_ENET_EIR_EBERR    (1U)          /*!< Bit field size in bits for ENET_EIR_EBERR. */

/*! @brief Read current value of the ENET_EIR_EBERR field. */
#define BR_ENET_EIR_EBERR(x) (HW_ENET_EIR(x).B.EBERR)

/*! @brief Format value for bitfield ENET_EIR_EBERR. */
#define BF_ENET_EIR_EBERR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_EBERR) & BM_ENET_EIR_EBERR)

/*! @brief Set the EBERR field to a new value. */
#define BW_ENET_EIR_EBERR(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_EBERR | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_EBERR(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field MII[23] (W1C)
 *
 * Indicates that the MII has completed the data transfer requested.
 */
/*@{*/
#define BP_ENET_EIR_MII      (23U)         /*!< Bit position for ENET_EIR_MII. */
#define BM_ENET_EIR_MII      (0x00800000U) /*!< Bit mask for ENET_EIR_MII. */
#define BS_ENET_EIR_MII      (1U)          /*!< Bit field size in bits for ENET_EIR_MII. */

/*! @brief Read current value of the ENET_EIR_MII field. */
#define BR_ENET_EIR_MII(x)   (HW_ENET_EIR(x).B.MII)

/*! @brief Format value for bitfield ENET_EIR_MII. */
#define BF_ENET_EIR_MII(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_MII) & BM_ENET_EIR_MII)

/*! @brief Set the MII field to a new value. */
#define BW_ENET_EIR_MII(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_MII | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_MII(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field RXB[24] (W1C)
 *
 * Indicates a receive buffer descriptor is not the last in the frame has been
 * updated.
 */
/*@{*/
#define BP_ENET_EIR_RXB      (24U)         /*!< Bit position for ENET_EIR_RXB. */
#define BM_ENET_EIR_RXB      (0x01000000U) /*!< Bit mask for ENET_EIR_RXB. */
#define BS_ENET_EIR_RXB      (1U)          /*!< Bit field size in bits for ENET_EIR_RXB. */

/*! @brief Read current value of the ENET_EIR_RXB field. */
#define BR_ENET_EIR_RXB(x)   (HW_ENET_EIR(x).B.RXB)

/*! @brief Format value for bitfield ENET_EIR_RXB. */
#define BF_ENET_EIR_RXB(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_RXB) & BM_ENET_EIR_RXB)

/*! @brief Set the RXB field to a new value. */
#define BW_ENET_EIR_RXB(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_RXB | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_RXB(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field RXF[25] (W1C)
 *
 * Indicates a frame has been received and the last corresponding buffer
 * descriptor has been updated.
 */
/*@{*/
#define BP_ENET_EIR_RXF      (25U)         /*!< Bit position for ENET_EIR_RXF. */
#define BM_ENET_EIR_RXF      (0x02000000U) /*!< Bit mask for ENET_EIR_RXF. */
#define BS_ENET_EIR_RXF      (1U)          /*!< Bit field size in bits for ENET_EIR_RXF. */

/*! @brief Read current value of the ENET_EIR_RXF field. */
#define BR_ENET_EIR_RXF(x)   (HW_ENET_EIR(x).B.RXF)

/*! @brief Format value for bitfield ENET_EIR_RXF. */
#define BF_ENET_EIR_RXF(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_RXF) & BM_ENET_EIR_RXF)

/*! @brief Set the RXF field to a new value. */
#define BW_ENET_EIR_RXF(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_RXF | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_RXF(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field TXB[26] (W1C)
 *
 * Indicates a transmit buffer descriptor has been updated.
 */
/*@{*/
#define BP_ENET_EIR_TXB      (26U)         /*!< Bit position for ENET_EIR_TXB. */
#define BM_ENET_EIR_TXB      (0x04000000U) /*!< Bit mask for ENET_EIR_TXB. */
#define BS_ENET_EIR_TXB      (1U)          /*!< Bit field size in bits for ENET_EIR_TXB. */

/*! @brief Read current value of the ENET_EIR_TXB field. */
#define BR_ENET_EIR_TXB(x)   (HW_ENET_EIR(x).B.TXB)

/*! @brief Format value for bitfield ENET_EIR_TXB. */
#define BF_ENET_EIR_TXB(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_TXB) & BM_ENET_EIR_TXB)

/*! @brief Set the TXB field to a new value. */
#define BW_ENET_EIR_TXB(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_TXB | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_TXB(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field TXF[27] (W1C)
 *
 * Indicates a frame has been transmitted and the last corresponding buffer
 * descriptor has been updated.
 */
/*@{*/
#define BP_ENET_EIR_TXF      (27U)         /*!< Bit position for ENET_EIR_TXF. */
#define BM_ENET_EIR_TXF      (0x08000000U) /*!< Bit mask for ENET_EIR_TXF. */
#define BS_ENET_EIR_TXF      (1U)          /*!< Bit field size in bits for ENET_EIR_TXF. */

/*! @brief Read current value of the ENET_EIR_TXF field. */
#define BR_ENET_EIR_TXF(x)   (HW_ENET_EIR(x).B.TXF)

/*! @brief Format value for bitfield ENET_EIR_TXF. */
#define BF_ENET_EIR_TXF(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_TXF) & BM_ENET_EIR_TXF)

/*! @brief Set the TXF field to a new value. */
#define BW_ENET_EIR_TXF(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_TXF | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_TXF(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field GRA[28] (W1C)
 *
 * This interrupt is asserted after the transmitter is put into a pause state
 * after completion of the frame currently being transmitted. See Graceful Transmit
 * Stop (GTS) for conditions that lead to graceful stop. The GRA interrupt is
 * asserted only when the TX transitions into the stopped state. If this bit is
 * cleared by writing 1 and the TX is still stopped, the bit is not set again.
 */
/*@{*/
#define BP_ENET_EIR_GRA      (28U)         /*!< Bit position for ENET_EIR_GRA. */
#define BM_ENET_EIR_GRA      (0x10000000U) /*!< Bit mask for ENET_EIR_GRA. */
#define BS_ENET_EIR_GRA      (1U)          /*!< Bit field size in bits for ENET_EIR_GRA. */

/*! @brief Read current value of the ENET_EIR_GRA field. */
#define BR_ENET_EIR_GRA(x)   (HW_ENET_EIR(x).B.GRA)

/*! @brief Format value for bitfield ENET_EIR_GRA. */
#define BF_ENET_EIR_GRA(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_GRA) & BM_ENET_EIR_GRA)

/*! @brief Set the GRA field to a new value. */
#define BW_ENET_EIR_GRA(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_GRA | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_BABT | BM_ENET_EIR_BABR)) | BF_ENET_EIR_GRA(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field BABT[29] (W1C)
 *
 * Indicates the transmitted frame length exceeds RCR[MAX_FL] bytes. Usually
 * this condition is caused when a frame that is too long is placed into the
 * transmit data buffer(s). Truncation does not occur.
 */
/*@{*/
#define BP_ENET_EIR_BABT     (29U)         /*!< Bit position for ENET_EIR_BABT. */
#define BM_ENET_EIR_BABT     (0x20000000U) /*!< Bit mask for ENET_EIR_BABT. */
#define BS_ENET_EIR_BABT     (1U)          /*!< Bit field size in bits for ENET_EIR_BABT. */

/*! @brief Read current value of the ENET_EIR_BABT field. */
#define BR_ENET_EIR_BABT(x)  (HW_ENET_EIR(x).B.BABT)

/*! @brief Format value for bitfield ENET_EIR_BABT. */
#define BF_ENET_EIR_BABT(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_BABT) & BM_ENET_EIR_BABT)

/*! @brief Set the BABT field to a new value. */
#define BW_ENET_EIR_BABT(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_BABT | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABR)) | BF_ENET_EIR_BABT(v)))
/*@}*/

/*!
 * @name Register ENET_EIR, field BABR[30] (W1C)
 *
 * Indicates a frame was received with length in excess of RCR[MAX_FL] bytes.
 */
/*@{*/
#define BP_ENET_EIR_BABR     (30U)         /*!< Bit position for ENET_EIR_BABR. */
#define BM_ENET_EIR_BABR     (0x40000000U) /*!< Bit mask for ENET_EIR_BABR. */
#define BS_ENET_EIR_BABR     (1U)          /*!< Bit field size in bits for ENET_EIR_BABR. */

/*! @brief Read current value of the ENET_EIR_BABR field. */
#define BR_ENET_EIR_BABR(x)  (HW_ENET_EIR(x).B.BABR)

/*! @brief Format value for bitfield ENET_EIR_BABR. */
#define BF_ENET_EIR_BABR(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIR_BABR) & BM_ENET_EIR_BABR)

/*! @brief Set the BABR field to a new value. */
#define BW_ENET_EIR_BABR(x, v) (HW_ENET_EIR_WR(x, (HW_ENET_EIR_RD(x) & ~(BM_ENET_EIR_BABR | BM_ENET_EIR_TS_TIMER | BM_ENET_EIR_TS_AVAIL | BM_ENET_EIR_WAKEUP | BM_ENET_EIR_PLR | BM_ENET_EIR_UN | BM_ENET_EIR_RL | BM_ENET_EIR_LC | BM_ENET_EIR_EBERR | BM_ENET_EIR_MII | BM_ENET_EIR_RXB | BM_ENET_EIR_RXF | BM_ENET_EIR_TXB | BM_ENET_EIR_TXF | BM_ENET_EIR_GRA | BM_ENET_EIR_BABT)) | BF_ENET_EIR_BABR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_EIMR - Interrupt Mask Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_EIMR - Interrupt Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * EIMR controls which interrupt events are allowed to generate actual
 * interrupts. A hardware reset clears this register. If the corresponding bits in the EIR
 * and EIMR registers are set, an interrupt is generated. The interrupt signal
 * remains asserted until a 1 is written to the EIR field (write 1 to clear) or a
 * 0 is written to the EIMR field.
 */
typedef union _hw_enet_eimr
{
    uint32_t U;
    struct _hw_enet_eimr_bitfields
    {
        uint32_t RESERVED0 : 15;       /*!< [14:0]  */
        uint32_t TS_TIMER : 1;         /*!< [15] TS_TIMER Interrupt Mask */
        uint32_t TS_AVAIL : 1;         /*!< [16] TS_AVAIL Interrupt Mask */
        uint32_t WAKEUP : 1;           /*!< [17] WAKEUP Interrupt Mask */
        uint32_t PLR : 1;              /*!< [18] PLR Interrupt Mask */
        uint32_t UN : 1;               /*!< [19] UN Interrupt Mask */
        uint32_t RL : 1;               /*!< [20] RL Interrupt Mask */
        uint32_t LC : 1;               /*!< [21] LC Interrupt Mask */
        uint32_t EBERR : 1;            /*!< [22] EBERR Interrupt Mask */
        uint32_t MII : 1;              /*!< [23] MII Interrupt Mask */
        uint32_t RXB : 1;              /*!< [24] RXB Interrupt Mask */
        uint32_t RXF : 1;              /*!< [25] RXF Interrupt Mask */
        uint32_t TXB : 1;              /*!< [26] TXB Interrupt Mask */
        uint32_t TXF : 1;              /*!< [27] TXF Interrupt Mask */
        uint32_t GRA : 1;              /*!< [28] GRA Interrupt Mask */
        uint32_t BABT : 1;             /*!< [29] BABT Interrupt Mask */
        uint32_t BABR : 1;             /*!< [30] BABR Interrupt Mask */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_enet_eimr_t;

/*!
 * @name Constants and macros for entire ENET_EIMR register
 */
/*@{*/
#define HW_ENET_EIMR_ADDR(x)     ((uintptr_t)(x) + 0x8U)

#define HW_ENET_EIMR(x)          (*(__IO hw_enet_eimr_t *) HW_ENET_EIMR_ADDR(x))
#define HW_ENET_EIMR_RD(x)       (HW_ENET_EIMR(x).U)
#define HW_ENET_EIMR_WR(x, v)    (HW_ENET_EIMR(x).U = (v))
#define HW_ENET_EIMR_SET(x, v)   (HW_ENET_EIMR_WR(x, HW_ENET_EIMR_RD(x) |  (v)))
#define HW_ENET_EIMR_CLR(x, v)   (HW_ENET_EIMR_WR(x, HW_ENET_EIMR_RD(x) & ~(v)))
#define HW_ENET_EIMR_TOG(x, v)   (HW_ENET_EIMR_WR(x, HW_ENET_EIMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_EIMR bitfields
 */

/*!
 * @name Register ENET_EIMR, field TS_TIMER[15] (RW)
 *
 * Corresponds to interrupt source EIR[TS_TIMER] register and determines whether
 * an interrupt condition can generate an interrupt. At every module clock, the
 * EIR samples the signal generated by the interrupting source. The corresponding
 * EIR TS_TIMER field reflects the state of the interrupt signal even if the
 * corresponding EIMR field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_TS_TIMER (15U)        /*!< Bit position for ENET_EIMR_TS_TIMER. */
#define BM_ENET_EIMR_TS_TIMER (0x00008000U) /*!< Bit mask for ENET_EIMR_TS_TIMER. */
#define BS_ENET_EIMR_TS_TIMER (1U)         /*!< Bit field size in bits for ENET_EIMR_TS_TIMER. */

/*! @brief Read current value of the ENET_EIMR_TS_TIMER field. */
#define BR_ENET_EIMR_TS_TIMER(x) (HW_ENET_EIMR(x).B.TS_TIMER)

/*! @brief Format value for bitfield ENET_EIMR_TS_TIMER. */
#define BF_ENET_EIMR_TS_TIMER(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_TS_TIMER) & BM_ENET_EIMR_TS_TIMER)

/*! @brief Set the TS_TIMER field to a new value. */
#define BW_ENET_EIMR_TS_TIMER(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_TS_TIMER) | BF_ENET_EIMR_TS_TIMER(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field TS_AVAIL[16] (RW)
 *
 * Corresponds to interrupt source EIR[TS_AVAIL] register and determines whether
 * an interrupt condition can generate an interrupt. At every module clock, the
 * EIR samples the signal generated by the interrupting source. The corresponding
 * EIR TS_AVAIL field reflects the state of the interrupt signal even if the
 * corresponding EIMR field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_TS_AVAIL (16U)        /*!< Bit position for ENET_EIMR_TS_AVAIL. */
#define BM_ENET_EIMR_TS_AVAIL (0x00010000U) /*!< Bit mask for ENET_EIMR_TS_AVAIL. */
#define BS_ENET_EIMR_TS_AVAIL (1U)         /*!< Bit field size in bits for ENET_EIMR_TS_AVAIL. */

/*! @brief Read current value of the ENET_EIMR_TS_AVAIL field. */
#define BR_ENET_EIMR_TS_AVAIL(x) (HW_ENET_EIMR(x).B.TS_AVAIL)

/*! @brief Format value for bitfield ENET_EIMR_TS_AVAIL. */
#define BF_ENET_EIMR_TS_AVAIL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_TS_AVAIL) & BM_ENET_EIMR_TS_AVAIL)

/*! @brief Set the TS_AVAIL field to a new value. */
#define BW_ENET_EIMR_TS_AVAIL(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_TS_AVAIL) | BF_ENET_EIMR_TS_AVAIL(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field WAKEUP[17] (RW)
 *
 * Corresponds to interrupt source EIR[WAKEUP] register and determines whether
 * an interrupt condition can generate an interrupt. At every module clock, the
 * EIR samples the signal generated by the interrupting source. The corresponding
 * EIR WAKEUP field reflects the state of the interrupt signal even if the
 * corresponding EIMR field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_WAKEUP  (17U)         /*!< Bit position for ENET_EIMR_WAKEUP. */
#define BM_ENET_EIMR_WAKEUP  (0x00020000U) /*!< Bit mask for ENET_EIMR_WAKEUP. */
#define BS_ENET_EIMR_WAKEUP  (1U)          /*!< Bit field size in bits for ENET_EIMR_WAKEUP. */

/*! @brief Read current value of the ENET_EIMR_WAKEUP field. */
#define BR_ENET_EIMR_WAKEUP(x) (HW_ENET_EIMR(x).B.WAKEUP)

/*! @brief Format value for bitfield ENET_EIMR_WAKEUP. */
#define BF_ENET_EIMR_WAKEUP(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_WAKEUP) & BM_ENET_EIMR_WAKEUP)

/*! @brief Set the WAKEUP field to a new value. */
#define BW_ENET_EIMR_WAKEUP(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_WAKEUP) | BF_ENET_EIMR_WAKEUP(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field PLR[18] (RW)
 *
 * Corresponds to interrupt source EIR[PLR] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR PLR field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_PLR     (18U)         /*!< Bit position for ENET_EIMR_PLR. */
#define BM_ENET_EIMR_PLR     (0x00040000U) /*!< Bit mask for ENET_EIMR_PLR. */
#define BS_ENET_EIMR_PLR     (1U)          /*!< Bit field size in bits for ENET_EIMR_PLR. */

/*! @brief Read current value of the ENET_EIMR_PLR field. */
#define BR_ENET_EIMR_PLR(x)  (HW_ENET_EIMR(x).B.PLR)

/*! @brief Format value for bitfield ENET_EIMR_PLR. */
#define BF_ENET_EIMR_PLR(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_PLR) & BM_ENET_EIMR_PLR)

/*! @brief Set the PLR field to a new value. */
#define BW_ENET_EIMR_PLR(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_PLR) | BF_ENET_EIMR_PLR(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field UN[19] (RW)
 *
 * Corresponds to interrupt source EIR[UN] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples the
 * signal generated by the interrupting source. The corresponding EIR UN field
 * reflects the state of the interrupt signal even if the corresponding EIMR field
 * is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_UN      (19U)         /*!< Bit position for ENET_EIMR_UN. */
#define BM_ENET_EIMR_UN      (0x00080000U) /*!< Bit mask for ENET_EIMR_UN. */
#define BS_ENET_EIMR_UN      (1U)          /*!< Bit field size in bits for ENET_EIMR_UN. */

/*! @brief Read current value of the ENET_EIMR_UN field. */
#define BR_ENET_EIMR_UN(x)   (HW_ENET_EIMR(x).B.UN)

/*! @brief Format value for bitfield ENET_EIMR_UN. */
#define BF_ENET_EIMR_UN(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_UN) & BM_ENET_EIMR_UN)

/*! @brief Set the UN field to a new value. */
#define BW_ENET_EIMR_UN(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_UN) | BF_ENET_EIMR_UN(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field RL[20] (RW)
 *
 * Corresponds to interrupt source EIR[RL] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples the
 * signal generated by the interrupting source. The corresponding EIR RL field
 * reflects the state of the interrupt signal even if the corresponding EIMR field
 * is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_RL      (20U)         /*!< Bit position for ENET_EIMR_RL. */
#define BM_ENET_EIMR_RL      (0x00100000U) /*!< Bit mask for ENET_EIMR_RL. */
#define BS_ENET_EIMR_RL      (1U)          /*!< Bit field size in bits for ENET_EIMR_RL. */

/*! @brief Read current value of the ENET_EIMR_RL field. */
#define BR_ENET_EIMR_RL(x)   (HW_ENET_EIMR(x).B.RL)

/*! @brief Format value for bitfield ENET_EIMR_RL. */
#define BF_ENET_EIMR_RL(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_RL) & BM_ENET_EIMR_RL)

/*! @brief Set the RL field to a new value. */
#define BW_ENET_EIMR_RL(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_RL) | BF_ENET_EIMR_RL(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field LC[21] (RW)
 *
 * Corresponds to interrupt source EIR[LC] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples the
 * signal generated by the interrupting source. The corresponding EIR LC field
 * reflects the state of the interrupt signal even if the corresponding EIMR field
 * is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_LC      (21U)         /*!< Bit position for ENET_EIMR_LC. */
#define BM_ENET_EIMR_LC      (0x00200000U) /*!< Bit mask for ENET_EIMR_LC. */
#define BS_ENET_EIMR_LC      (1U)          /*!< Bit field size in bits for ENET_EIMR_LC. */

/*! @brief Read current value of the ENET_EIMR_LC field. */
#define BR_ENET_EIMR_LC(x)   (HW_ENET_EIMR(x).B.LC)

/*! @brief Format value for bitfield ENET_EIMR_LC. */
#define BF_ENET_EIMR_LC(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_LC) & BM_ENET_EIMR_LC)

/*! @brief Set the LC field to a new value. */
#define BW_ENET_EIMR_LC(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_LC) | BF_ENET_EIMR_LC(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field EBERR[22] (RW)
 *
 * Corresponds to interrupt source EIR[EBERR] and determines whether an
 * interrupt condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR EBERR
 * field reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_EBERR   (22U)         /*!< Bit position for ENET_EIMR_EBERR. */
#define BM_ENET_EIMR_EBERR   (0x00400000U) /*!< Bit mask for ENET_EIMR_EBERR. */
#define BS_ENET_EIMR_EBERR   (1U)          /*!< Bit field size in bits for ENET_EIMR_EBERR. */

/*! @brief Read current value of the ENET_EIMR_EBERR field. */
#define BR_ENET_EIMR_EBERR(x) (HW_ENET_EIMR(x).B.EBERR)

/*! @brief Format value for bitfield ENET_EIMR_EBERR. */
#define BF_ENET_EIMR_EBERR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_EBERR) & BM_ENET_EIMR_EBERR)

/*! @brief Set the EBERR field to a new value. */
#define BW_ENET_EIMR_EBERR(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_EBERR) | BF_ENET_EIMR_EBERR(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field MII[23] (RW)
 *
 * Corresponds to interrupt source EIR[MII] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR MII field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_MII     (23U)         /*!< Bit position for ENET_EIMR_MII. */
#define BM_ENET_EIMR_MII     (0x00800000U) /*!< Bit mask for ENET_EIMR_MII. */
#define BS_ENET_EIMR_MII     (1U)          /*!< Bit field size in bits for ENET_EIMR_MII. */

/*! @brief Read current value of the ENET_EIMR_MII field. */
#define BR_ENET_EIMR_MII(x)  (HW_ENET_EIMR(x).B.MII)

/*! @brief Format value for bitfield ENET_EIMR_MII. */
#define BF_ENET_EIMR_MII(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_MII) & BM_ENET_EIMR_MII)

/*! @brief Set the MII field to a new value. */
#define BW_ENET_EIMR_MII(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_MII) | BF_ENET_EIMR_MII(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field RXB[24] (RW)
 *
 * Corresponds to interrupt source EIR[RXB] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR RXB field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_RXB     (24U)         /*!< Bit position for ENET_EIMR_RXB. */
#define BM_ENET_EIMR_RXB     (0x01000000U) /*!< Bit mask for ENET_EIMR_RXB. */
#define BS_ENET_EIMR_RXB     (1U)          /*!< Bit field size in bits for ENET_EIMR_RXB. */

/*! @brief Read current value of the ENET_EIMR_RXB field. */
#define BR_ENET_EIMR_RXB(x)  (HW_ENET_EIMR(x).B.RXB)

/*! @brief Format value for bitfield ENET_EIMR_RXB. */
#define BF_ENET_EIMR_RXB(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_RXB) & BM_ENET_EIMR_RXB)

/*! @brief Set the RXB field to a new value. */
#define BW_ENET_EIMR_RXB(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_RXB) | BF_ENET_EIMR_RXB(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field RXF[25] (RW)
 *
 * Corresponds to interrupt source EIR[RXF] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR RXF field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 */
/*@{*/
#define BP_ENET_EIMR_RXF     (25U)         /*!< Bit position for ENET_EIMR_RXF. */
#define BM_ENET_EIMR_RXF     (0x02000000U) /*!< Bit mask for ENET_EIMR_RXF. */
#define BS_ENET_EIMR_RXF     (1U)          /*!< Bit field size in bits for ENET_EIMR_RXF. */

/*! @brief Read current value of the ENET_EIMR_RXF field. */
#define BR_ENET_EIMR_RXF(x)  (HW_ENET_EIMR(x).B.RXF)

/*! @brief Format value for bitfield ENET_EIMR_RXF. */
#define BF_ENET_EIMR_RXF(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_RXF) & BM_ENET_EIMR_RXF)

/*! @brief Set the RXF field to a new value. */
#define BW_ENET_EIMR_RXF(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_RXF) | BF_ENET_EIMR_RXF(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field TXB[26] (RW)
 *
 * Corresponds to interrupt source EIR[TXB] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR TXF field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 *
 * Values:
 * - 0 - The corresponding interrupt source is masked.
 * - 1 - The corresponding interrupt source is not masked.
 */
/*@{*/
#define BP_ENET_EIMR_TXB     (26U)         /*!< Bit position for ENET_EIMR_TXB. */
#define BM_ENET_EIMR_TXB     (0x04000000U) /*!< Bit mask for ENET_EIMR_TXB. */
#define BS_ENET_EIMR_TXB     (1U)          /*!< Bit field size in bits for ENET_EIMR_TXB. */

/*! @brief Read current value of the ENET_EIMR_TXB field. */
#define BR_ENET_EIMR_TXB(x)  (HW_ENET_EIMR(x).B.TXB)

/*! @brief Format value for bitfield ENET_EIMR_TXB. */
#define BF_ENET_EIMR_TXB(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_TXB) & BM_ENET_EIMR_TXB)

/*! @brief Set the TXB field to a new value. */
#define BW_ENET_EIMR_TXB(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_TXB) | BF_ENET_EIMR_TXB(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field TXF[27] (RW)
 *
 * Corresponds to interrupt source EIR[TXF] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR TXF field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 *
 * Values:
 * - 0 - The corresponding interrupt source is masked.
 * - 1 - The corresponding interrupt source is not masked.
 */
/*@{*/
#define BP_ENET_EIMR_TXF     (27U)         /*!< Bit position for ENET_EIMR_TXF. */
#define BM_ENET_EIMR_TXF     (0x08000000U) /*!< Bit mask for ENET_EIMR_TXF. */
#define BS_ENET_EIMR_TXF     (1U)          /*!< Bit field size in bits for ENET_EIMR_TXF. */

/*! @brief Read current value of the ENET_EIMR_TXF field. */
#define BR_ENET_EIMR_TXF(x)  (HW_ENET_EIMR(x).B.TXF)

/*! @brief Format value for bitfield ENET_EIMR_TXF. */
#define BF_ENET_EIMR_TXF(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_TXF) & BM_ENET_EIMR_TXF)

/*! @brief Set the TXF field to a new value. */
#define BW_ENET_EIMR_TXF(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_TXF) | BF_ENET_EIMR_TXF(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field GRA[28] (RW)
 *
 * Corresponds to interrupt source EIR[GRA] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR GRA field
 * reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 *
 * Values:
 * - 0 - The corresponding interrupt source is masked.
 * - 1 - The corresponding interrupt source is not masked.
 */
/*@{*/
#define BP_ENET_EIMR_GRA     (28U)         /*!< Bit position for ENET_EIMR_GRA. */
#define BM_ENET_EIMR_GRA     (0x10000000U) /*!< Bit mask for ENET_EIMR_GRA. */
#define BS_ENET_EIMR_GRA     (1U)          /*!< Bit field size in bits for ENET_EIMR_GRA. */

/*! @brief Read current value of the ENET_EIMR_GRA field. */
#define BR_ENET_EIMR_GRA(x)  (HW_ENET_EIMR(x).B.GRA)

/*! @brief Format value for bitfield ENET_EIMR_GRA. */
#define BF_ENET_EIMR_GRA(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_GRA) & BM_ENET_EIMR_GRA)

/*! @brief Set the GRA field to a new value. */
#define BW_ENET_EIMR_GRA(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_GRA) | BF_ENET_EIMR_GRA(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field BABT[29] (RW)
 *
 * Corresponds to interrupt source EIR[BABT] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR BABT
 * field reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 *
 * Values:
 * - 0 - The corresponding interrupt source is masked.
 * - 1 - The corresponding interrupt source is not masked.
 */
/*@{*/
#define BP_ENET_EIMR_BABT    (29U)         /*!< Bit position for ENET_EIMR_BABT. */
#define BM_ENET_EIMR_BABT    (0x20000000U) /*!< Bit mask for ENET_EIMR_BABT. */
#define BS_ENET_EIMR_BABT    (1U)          /*!< Bit field size in bits for ENET_EIMR_BABT. */

/*! @brief Read current value of the ENET_EIMR_BABT field. */
#define BR_ENET_EIMR_BABT(x) (HW_ENET_EIMR(x).B.BABT)

/*! @brief Format value for bitfield ENET_EIMR_BABT. */
#define BF_ENET_EIMR_BABT(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_BABT) & BM_ENET_EIMR_BABT)

/*! @brief Set the BABT field to a new value. */
#define BW_ENET_EIMR_BABT(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_BABT) | BF_ENET_EIMR_BABT(v)))
/*@}*/

/*!
 * @name Register ENET_EIMR, field BABR[30] (RW)
 *
 * Corresponds to interrupt source EIR[BABR] and determines whether an interrupt
 * condition can generate an interrupt. At every module clock, the EIR samples
 * the signal generated by the interrupting source. The corresponding EIR BABR
 * field reflects the state of the interrupt signal even if the corresponding EIMR
 * field is cleared.
 *
 * Values:
 * - 0 - The corresponding interrupt source is masked.
 * - 1 - The corresponding interrupt source is not masked.
 */
/*@{*/
#define BP_ENET_EIMR_BABR    (30U)         /*!< Bit position for ENET_EIMR_BABR. */
#define BM_ENET_EIMR_BABR    (0x40000000U) /*!< Bit mask for ENET_EIMR_BABR. */
#define BS_ENET_EIMR_BABR    (1U)          /*!< Bit field size in bits for ENET_EIMR_BABR. */

/*! @brief Read current value of the ENET_EIMR_BABR field. */
#define BR_ENET_EIMR_BABR(x) (HW_ENET_EIMR(x).B.BABR)

/*! @brief Format value for bitfield ENET_EIMR_BABR. */
#define BF_ENET_EIMR_BABR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_EIMR_BABR) & BM_ENET_EIMR_BABR)

/*! @brief Set the BABR field to a new value. */
#define BW_ENET_EIMR_BABR(x, v) (HW_ENET_EIMR_WR(x, (HW_ENET_EIMR_RD(x) & ~BM_ENET_EIMR_BABR) | BF_ENET_EIMR_BABR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RDAR - Receive Descriptor Active Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RDAR - Receive Descriptor Active Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * RDAR is a command register, written by the user, to indicate that the receive
 * descriptor ring has been updated, that is, that the driver produced empty
 * receive buffers with the empty bit set.
 */
typedef union _hw_enet_rdar
{
    uint32_t U;
    struct _hw_enet_rdar_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t RDAR : 1;             /*!< [24] Receive Descriptor Active */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_enet_rdar_t;

/*!
 * @name Constants and macros for entire ENET_RDAR register
 */
/*@{*/
#define HW_ENET_RDAR_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_ENET_RDAR(x)          (*(__IO hw_enet_rdar_t *) HW_ENET_RDAR_ADDR(x))
#define HW_ENET_RDAR_RD(x)       (HW_ENET_RDAR(x).U)
#define HW_ENET_RDAR_WR(x, v)    (HW_ENET_RDAR(x).U = (v))
#define HW_ENET_RDAR_SET(x, v)   (HW_ENET_RDAR_WR(x, HW_ENET_RDAR_RD(x) |  (v)))
#define HW_ENET_RDAR_CLR(x, v)   (HW_ENET_RDAR_WR(x, HW_ENET_RDAR_RD(x) & ~(v)))
#define HW_ENET_RDAR_TOG(x, v)   (HW_ENET_RDAR_WR(x, HW_ENET_RDAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RDAR bitfields
 */

/*!
 * @name Register ENET_RDAR, field RDAR[24] (RW)
 *
 * Always set to 1 when this register is written, regardless of the value
 * written. This field is cleared by the MAC device when no additional empty
 * descriptors remain in the receive ring. It is also cleared when ECR[ETHEREN] transitions
 * from set to cleared or when ECR[RESET] is set.
 */
/*@{*/
#define BP_ENET_RDAR_RDAR    (24U)         /*!< Bit position for ENET_RDAR_RDAR. */
#define BM_ENET_RDAR_RDAR    (0x01000000U) /*!< Bit mask for ENET_RDAR_RDAR. */
#define BS_ENET_RDAR_RDAR    (1U)          /*!< Bit field size in bits for ENET_RDAR_RDAR. */

/*! @brief Read current value of the ENET_RDAR_RDAR field. */
#define BR_ENET_RDAR_RDAR(x) (HW_ENET_RDAR(x).B.RDAR)

/*! @brief Format value for bitfield ENET_RDAR_RDAR. */
#define BF_ENET_RDAR_RDAR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RDAR_RDAR) & BM_ENET_RDAR_RDAR)

/*! @brief Set the RDAR field to a new value. */
#define BW_ENET_RDAR_RDAR(x, v) (HW_ENET_RDAR_WR(x, (HW_ENET_RDAR_RD(x) & ~BM_ENET_RDAR_RDAR) | BF_ENET_RDAR_RDAR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TDAR - Transmit Descriptor Active Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TDAR - Transmit Descriptor Active Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The TDAR is a command register that the user writes to indicate that the
 * transmit descriptor ring has been updated, that is, that transmit buffers have
 * been produced by the driver with the ready bit set in the buffer descriptor. The
 * TDAR register is cleared at reset, when ECR[ETHEREN] transitions from set to
 * cleared, or when ECR[RESET] is set.
 */
typedef union _hw_enet_tdar
{
    uint32_t U;
    struct _hw_enet_tdar_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t TDAR : 1;             /*!< [24] Transmit Descriptor Active */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_enet_tdar_t;

/*!
 * @name Constants and macros for entire ENET_TDAR register
 */
/*@{*/
#define HW_ENET_TDAR_ADDR(x)     ((uintptr_t)(x) + 0x14U)

#define HW_ENET_TDAR(x)          (*(__IO hw_enet_tdar_t *) HW_ENET_TDAR_ADDR(x))
#define HW_ENET_TDAR_RD(x)       (HW_ENET_TDAR(x).U)
#define HW_ENET_TDAR_WR(x, v)    (HW_ENET_TDAR(x).U = (v))
#define HW_ENET_TDAR_SET(x, v)   (HW_ENET_TDAR_WR(x, HW_ENET_TDAR_RD(x) |  (v)))
#define HW_ENET_TDAR_CLR(x, v)   (HW_ENET_TDAR_WR(x, HW_ENET_TDAR_RD(x) & ~(v)))
#define HW_ENET_TDAR_TOG(x, v)   (HW_ENET_TDAR_WR(x, HW_ENET_TDAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TDAR bitfields
 */

/*!
 * @name Register ENET_TDAR, field TDAR[24] (RW)
 *
 * Always set to 1 when this register is written, regardless of the value
 * written. This bit is cleared by the MAC device when no additional ready descriptors
 * remain in the transmit ring. Also cleared when ECR[ETHEREN] transitions from
 * set to cleared or when ECR[RESET] is set.
 */
/*@{*/
#define BP_ENET_TDAR_TDAR    (24U)         /*!< Bit position for ENET_TDAR_TDAR. */
#define BM_ENET_TDAR_TDAR    (0x01000000U) /*!< Bit mask for ENET_TDAR_TDAR. */
#define BS_ENET_TDAR_TDAR    (1U)          /*!< Bit field size in bits for ENET_TDAR_TDAR. */

/*! @brief Read current value of the ENET_TDAR_TDAR field. */
#define BR_ENET_TDAR_TDAR(x) (HW_ENET_TDAR(x).B.TDAR)

/*! @brief Format value for bitfield ENET_TDAR_TDAR. */
#define BF_ENET_TDAR_TDAR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TDAR_TDAR) & BM_ENET_TDAR_TDAR)

/*! @brief Set the TDAR field to a new value. */
#define BW_ENET_TDAR_TDAR(x, v) (HW_ENET_TDAR_WR(x, (HW_ENET_TDAR_RD(x) & ~BM_ENET_TDAR_TDAR) | BF_ENET_TDAR_TDAR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_ECR - Ethernet Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ECR - Ethernet Control Register (RW)
 *
 * Reset value: 0xF0000000U
 *
 * ECR is a read/write user register, though hardware may also alter fields in
 * this register. It controls many of the high level features of the Ethernet MAC,
 * including legacy FEC support through the EN1588 field.
 */
typedef union _hw_enet_ecr
{
    uint32_t U;
    struct _hw_enet_ecr_bitfields
    {
        uint32_t RESET : 1;            /*!< [0] Ethernet MAC Reset */
        uint32_t ETHEREN : 1;          /*!< [1] Ethernet Enable */
        uint32_t MAGICEN : 1;          /*!< [2] Magic Packet Detection Enable */
        uint32_t SLEEP : 1;            /*!< [3] Sleep Mode Enable */
        uint32_t EN1588 : 1;           /*!< [4] EN1588 Enable */
        uint32_t SPEED : 1;            /*!< [5]  */
        uint32_t DBGEN : 1;            /*!< [6] Debug Enable */
        uint32_t STOPEN : 1;           /*!< [7] STOPEN Signal Control */
        uint32_t DBSWP : 1;            /*!< [8] Descriptor Byte Swapping Enable */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_ecr_t;

/*!
 * @name Constants and macros for entire ENET_ECR register
 */
/*@{*/
#define HW_ENET_ECR_ADDR(x)      ((uintptr_t)(x) + 0x24U)

#define HW_ENET_ECR(x)           (*(__IO hw_enet_ecr_t *) HW_ENET_ECR_ADDR(x))
#define HW_ENET_ECR_RD(x)        (HW_ENET_ECR(x).U)
#define HW_ENET_ECR_WR(x, v)     (HW_ENET_ECR(x).U = (v))
#define HW_ENET_ECR_SET(x, v)    (HW_ENET_ECR_WR(x, HW_ENET_ECR_RD(x) |  (v)))
#define HW_ENET_ECR_CLR(x, v)    (HW_ENET_ECR_WR(x, HW_ENET_ECR_RD(x) & ~(v)))
#define HW_ENET_ECR_TOG(x, v)    (HW_ENET_ECR_WR(x, HW_ENET_ECR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ECR bitfields
 */

/*!
 * @name Register ENET_ECR, field RESET[0] (RW)
 *
 * When this field is set, it clears the ETHEREN field.
 */
/*@{*/
#define BP_ENET_ECR_RESET    (0U)          /*!< Bit position for ENET_ECR_RESET. */
#define BM_ENET_ECR_RESET    (0x00000001U) /*!< Bit mask for ENET_ECR_RESET. */
#define BS_ENET_ECR_RESET    (1U)          /*!< Bit field size in bits for ENET_ECR_RESET. */

/*! @brief Read current value of the ENET_ECR_RESET field. */
#define BR_ENET_ECR_RESET(x) (HW_ENET_ECR(x).B.RESET)

/*! @brief Format value for bitfield ENET_ECR_RESET. */
#define BF_ENET_ECR_RESET(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_RESET) & BM_ENET_ECR_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_ENET_ECR_RESET(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_RESET) | BF_ENET_ECR_RESET(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field ETHEREN[1] (RW)
 *
 * Enables/disables the Ethernet MAC. When the MAC is disabled, the buffer
 * descriptors for an aborted transmit frame are not updated. The uDMA, buffer
 * descriptor, and FIFO control logic are reset, including the buffer descriptor and
 * FIFO pointers. Hardware clears this field under the following conditions: RESET
 * is set by software An error condition causes the EBERR field to set. ETHEREN
 * must be set at the very last step during ENET
 * configuration/setup/initialization, only after all other ENET-related registers have been configured. If ETHEREN
 * is cleared to 0 by software then next time ETHEREN is set, the EIR interrupts
 * must cleared to 0 due to previous pending interrupts.
 *
 * Values:
 * - 0 - Reception immediately stops and transmission stops after a bad CRC is
 *     appended to any currently transmitted frame.
 * - 1 - MAC is enabled, and reception and transmission are possible.
 */
/*@{*/
#define BP_ENET_ECR_ETHEREN  (1U)          /*!< Bit position for ENET_ECR_ETHEREN. */
#define BM_ENET_ECR_ETHEREN  (0x00000002U) /*!< Bit mask for ENET_ECR_ETHEREN. */
#define BS_ENET_ECR_ETHEREN  (1U)          /*!< Bit field size in bits for ENET_ECR_ETHEREN. */

/*! @brief Read current value of the ENET_ECR_ETHEREN field. */
#define BR_ENET_ECR_ETHEREN(x) (HW_ENET_ECR(x).B.ETHEREN)

/*! @brief Format value for bitfield ENET_ECR_ETHEREN. */
#define BF_ENET_ECR_ETHEREN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_ETHEREN) & BM_ENET_ECR_ETHEREN)

/*! @brief Set the ETHEREN field to a new value. */
#define BW_ENET_ECR_ETHEREN(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_ETHEREN) | BF_ENET_ECR_ETHEREN(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field MAGICEN[2] (RW)
 *
 * Enables/disables magic packet detection. MAGICEN is relevant only if the
 * SLEEP field is set. If MAGICEN is set, changing the SLEEP field enables/disables
 * sleep mode and magic packet detection.
 *
 * Values:
 * - 0 - Magic detection logic disabled.
 * - 1 - The MAC core detects magic packets and asserts EIR[WAKEUP] when a frame
 *     is detected.
 */
/*@{*/
#define BP_ENET_ECR_MAGICEN  (2U)          /*!< Bit position for ENET_ECR_MAGICEN. */
#define BM_ENET_ECR_MAGICEN  (0x00000004U) /*!< Bit mask for ENET_ECR_MAGICEN. */
#define BS_ENET_ECR_MAGICEN  (1U)          /*!< Bit field size in bits for ENET_ECR_MAGICEN. */

/*! @brief Read current value of the ENET_ECR_MAGICEN field. */
#define BR_ENET_ECR_MAGICEN(x) (HW_ENET_ECR(x).B.MAGICEN)

/*! @brief Format value for bitfield ENET_ECR_MAGICEN. */
#define BF_ENET_ECR_MAGICEN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_MAGICEN) & BM_ENET_ECR_MAGICEN)

/*! @brief Set the MAGICEN field to a new value. */
#define BW_ENET_ECR_MAGICEN(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_MAGICEN) | BF_ENET_ECR_MAGICEN(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field SLEEP[3] (RW)
 *
 * Values:
 * - 0 - Normal operating mode.
 * - 1 - Sleep mode.
 */
/*@{*/
#define BP_ENET_ECR_SLEEP    (3U)          /*!< Bit position for ENET_ECR_SLEEP. */
#define BM_ENET_ECR_SLEEP    (0x00000008U) /*!< Bit mask for ENET_ECR_SLEEP. */
#define BS_ENET_ECR_SLEEP    (1U)          /*!< Bit field size in bits for ENET_ECR_SLEEP. */

/*! @brief Read current value of the ENET_ECR_SLEEP field. */
#define BR_ENET_ECR_SLEEP(x) (HW_ENET_ECR(x).B.SLEEP)

/*! @brief Format value for bitfield ENET_ECR_SLEEP. */
#define BF_ENET_ECR_SLEEP(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_SLEEP) & BM_ENET_ECR_SLEEP)

/*! @brief Set the SLEEP field to a new value. */
#define BW_ENET_ECR_SLEEP(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_SLEEP) | BF_ENET_ECR_SLEEP(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field EN1588[4] (RW)
 *
 * Enables enhanced functionality of the MAC.
 *
 * Values:
 * - 0 - Legacy FEC buffer descriptors and functions enabled.
 * - 1 - Enhanced frame time-stamping functions enabled.
 */
/*@{*/
#define BP_ENET_ECR_EN1588   (4U)          /*!< Bit position for ENET_ECR_EN1588. */
#define BM_ENET_ECR_EN1588   (0x00000010U) /*!< Bit mask for ENET_ECR_EN1588. */
#define BS_ENET_ECR_EN1588   (1U)          /*!< Bit field size in bits for ENET_ECR_EN1588. */

/*! @brief Read current value of the ENET_ECR_EN1588 field. */
#define BR_ENET_ECR_EN1588(x) (HW_ENET_ECR(x).B.EN1588)

/*! @brief Format value for bitfield ENET_ECR_EN1588. */
#define BF_ENET_ECR_EN1588(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_EN1588) & BM_ENET_ECR_EN1588)

/*! @brief Set the EN1588 field to a new value. */
#define BW_ENET_ECR_EN1588(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_EN1588) | BF_ENET_ECR_EN1588(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field SPEED[5] (RW)
 *
 * Selects between 10/100-Mbit/s and 1000-Mbit/s modes of operation.
 *
 * Values:
 * - 0 - 10/100-Mbit/s mode
 * - 1 - 1000-Mbit/s mode
 */
/*@{*/
#define BP_ENET_ECR_SPEED    (5U)          /*!< Bit position for ENET_ECR_SPEED. */
#define BM_ENET_ECR_SPEED    (0x00000020U) /*!< Bit mask for ENET_ECR_SPEED. */
#define BS_ENET_ECR_SPEED    (1U)          /*!< Bit field size in bits for ENET_ECR_SPEED. */

/*! @brief Read current value of the ENET_ECR_SPEED field. */
#define BR_ENET_ECR_SPEED(x) (HW_ENET_ECR(x).B.SPEED)

/*! @brief Format value for bitfield ENET_ECR_SPEED. */
#define BF_ENET_ECR_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_SPEED) & BM_ENET_ECR_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_ENET_ECR_SPEED(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_SPEED) | BF_ENET_ECR_SPEED(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field DBGEN[6] (RW)
 *
 * Enables the MAC to enter hardware freeze mode when the device enters debug
 * mode.
 *
 * Values:
 * - 0 - MAC continues operation in debug mode.
 * - 1 - MAC enters hardware freeze mode when the processor is in debug mode.
 */
/*@{*/
#define BP_ENET_ECR_DBGEN    (6U)          /*!< Bit position for ENET_ECR_DBGEN. */
#define BM_ENET_ECR_DBGEN    (0x00000040U) /*!< Bit mask for ENET_ECR_DBGEN. */
#define BS_ENET_ECR_DBGEN    (1U)          /*!< Bit field size in bits for ENET_ECR_DBGEN. */

/*! @brief Read current value of the ENET_ECR_DBGEN field. */
#define BR_ENET_ECR_DBGEN(x) (HW_ENET_ECR(x).B.DBGEN)

/*! @brief Format value for bitfield ENET_ECR_DBGEN. */
#define BF_ENET_ECR_DBGEN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_DBGEN) & BM_ENET_ECR_DBGEN)

/*! @brief Set the DBGEN field to a new value. */
#define BW_ENET_ECR_DBGEN(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_DBGEN) | BF_ENET_ECR_DBGEN(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field STOPEN[7] (RW)
 *
 * Controls device behavior in doze mode. In doze mode, if this field is set
 * then all the clocks of the ENET assembly are disabled, except the RMII /MII
 * clock. Doze mode is similar to a conditional stop mode entry for the ENET assembly
 * depending on ECR[STOPEN]. If module clocks are gated in this mode, the module
 * can still wake the system after receiving a magic packet in stop mode. MAGICEN
 * must be set prior to entering sleep/stop mode.
 */
/*@{*/
#define BP_ENET_ECR_STOPEN   (7U)          /*!< Bit position for ENET_ECR_STOPEN. */
#define BM_ENET_ECR_STOPEN   (0x00000080U) /*!< Bit mask for ENET_ECR_STOPEN. */
#define BS_ENET_ECR_STOPEN   (1U)          /*!< Bit field size in bits for ENET_ECR_STOPEN. */

/*! @brief Read current value of the ENET_ECR_STOPEN field. */
#define BR_ENET_ECR_STOPEN(x) (HW_ENET_ECR(x).B.STOPEN)

/*! @brief Format value for bitfield ENET_ECR_STOPEN. */
#define BF_ENET_ECR_STOPEN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_STOPEN) & BM_ENET_ECR_STOPEN)

/*! @brief Set the STOPEN field to a new value. */
#define BW_ENET_ECR_STOPEN(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_STOPEN) | BF_ENET_ECR_STOPEN(v)))
/*@}*/

/*!
 * @name Register ENET_ECR, field DBSWP[8] (RW)
 *
 * Swaps the byte locations of the buffer descriptors.
 *
 * Values:
 * - 0 - The buffer descriptor bytes are not swapped to support big-endian
 *     devices.
 * - 1 - The buffer descriptor bytes are swapped to support little-endian
 *     devices.
 */
/*@{*/
#define BP_ENET_ECR_DBSWP    (8U)          /*!< Bit position for ENET_ECR_DBSWP. */
#define BM_ENET_ECR_DBSWP    (0x00000100U) /*!< Bit mask for ENET_ECR_DBSWP. */
#define BS_ENET_ECR_DBSWP    (1U)          /*!< Bit field size in bits for ENET_ECR_DBSWP. */

/*! @brief Read current value of the ENET_ECR_DBSWP field. */
#define BR_ENET_ECR_DBSWP(x) (HW_ENET_ECR(x).B.DBSWP)

/*! @brief Format value for bitfield ENET_ECR_DBSWP. */
#define BF_ENET_ECR_DBSWP(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ECR_DBSWP) & BM_ENET_ECR_DBSWP)

/*! @brief Set the DBSWP field to a new value. */
#define BW_ENET_ECR_DBSWP(x, v) (HW_ENET_ECR_WR(x, (HW_ENET_ECR_RD(x) & ~BM_ENET_ECR_DBSWP) | BF_ENET_ECR_DBSWP(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_MMFR - MII Management Frame Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_MMFR - MII Management Frame Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Writing to MMFR triggers a management frame transaction to the PHY device
 * unless MSCR is programmed to zero. If MSCR is changed from zero to non-zero
 * during a write to MMFR, an MII frame is generated with the data previously written
 * to the MMFR. This allows MMFR and MSCR to be programmed in either order if
 * MSCR is currently zero. If the MMFR register is written while frame generation is
 * in progress, the frame contents are altered. Software must use the EIR[MII]
 * interrupt indication to avoid writing to the MMFR register while frame
 * generation is in progress.
 */
typedef union _hw_enet_mmfr
{
    uint32_t U;
    struct _hw_enet_mmfr_bitfields
    {
        uint32_t DATA : 16;            /*!< [15:0] Management Frame Data */
        uint32_t TA : 2;               /*!< [17:16] Turn Around */
        uint32_t RA : 5;               /*!< [22:18] Register Address */
        uint32_t PA : 5;               /*!< [27:23] PHY Address */
        uint32_t OP : 2;               /*!< [29:28] Operation Code */
        uint32_t ST : 2;               /*!< [31:30] Start Of Frame Delimiter */
    } B;
} hw_enet_mmfr_t;

/*!
 * @name Constants and macros for entire ENET_MMFR register
 */
/*@{*/
#define HW_ENET_MMFR_ADDR(x)     ((uintptr_t)(x) + 0x40U)

#define HW_ENET_MMFR(x)          (*(__IO hw_enet_mmfr_t *) HW_ENET_MMFR_ADDR(x))
#define HW_ENET_MMFR_RD(x)       (HW_ENET_MMFR(x).U)
#define HW_ENET_MMFR_WR(x, v)    (HW_ENET_MMFR(x).U = (v))
#define HW_ENET_MMFR_SET(x, v)   (HW_ENET_MMFR_WR(x, HW_ENET_MMFR_RD(x) |  (v)))
#define HW_ENET_MMFR_CLR(x, v)   (HW_ENET_MMFR_WR(x, HW_ENET_MMFR_RD(x) & ~(v)))
#define HW_ENET_MMFR_TOG(x, v)   (HW_ENET_MMFR_WR(x, HW_ENET_MMFR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_MMFR bitfields
 */

/*!
 * @name Register ENET_MMFR, field DATA[15:0] (RW)
 *
 * This is the field for data to be written to or read from the PHY register.
 */
/*@{*/
#define BP_ENET_MMFR_DATA    (0U)          /*!< Bit position for ENET_MMFR_DATA. */
#define BM_ENET_MMFR_DATA    (0x0000FFFFU) /*!< Bit mask for ENET_MMFR_DATA. */
#define BS_ENET_MMFR_DATA    (16U)         /*!< Bit field size in bits for ENET_MMFR_DATA. */

/*! @brief Read current value of the ENET_MMFR_DATA field. */
#define BR_ENET_MMFR_DATA(x) (HW_ENET_MMFR(x).B.DATA)

/*! @brief Format value for bitfield ENET_MMFR_DATA. */
#define BF_ENET_MMFR_DATA(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_DATA) & BM_ENET_MMFR_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_ENET_MMFR_DATA(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_DATA) | BF_ENET_MMFR_DATA(v)))
/*@}*/

/*!
 * @name Register ENET_MMFR, field TA[17:16] (RW)
 *
 * This field must be programmed to 10 to generate a valid MII management frame.
 */
/*@{*/
#define BP_ENET_MMFR_TA      (16U)         /*!< Bit position for ENET_MMFR_TA. */
#define BM_ENET_MMFR_TA      (0x00030000U) /*!< Bit mask for ENET_MMFR_TA. */
#define BS_ENET_MMFR_TA      (2U)          /*!< Bit field size in bits for ENET_MMFR_TA. */

/*! @brief Read current value of the ENET_MMFR_TA field. */
#define BR_ENET_MMFR_TA(x)   (HW_ENET_MMFR(x).B.TA)

/*! @brief Format value for bitfield ENET_MMFR_TA. */
#define BF_ENET_MMFR_TA(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_TA) & BM_ENET_MMFR_TA)

/*! @brief Set the TA field to a new value. */
#define BW_ENET_MMFR_TA(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_TA) | BF_ENET_MMFR_TA(v)))
/*@}*/

/*!
 * @name Register ENET_MMFR, field RA[22:18] (RW)
 *
 * See (Clause 22) or (Clause 45) for correct value.
 */
/*@{*/
#define BP_ENET_MMFR_RA      (18U)         /*!< Bit position for ENET_MMFR_RA. */
#define BM_ENET_MMFR_RA      (0x007C0000U) /*!< Bit mask for ENET_MMFR_RA. */
#define BS_ENET_MMFR_RA      (5U)          /*!< Bit field size in bits for ENET_MMFR_RA. */

/*! @brief Read current value of the ENET_MMFR_RA field. */
#define BR_ENET_MMFR_RA(x)   (HW_ENET_MMFR(x).B.RA)

/*! @brief Format value for bitfield ENET_MMFR_RA. */
#define BF_ENET_MMFR_RA(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_RA) & BM_ENET_MMFR_RA)

/*! @brief Set the RA field to a new value. */
#define BW_ENET_MMFR_RA(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_RA) | BF_ENET_MMFR_RA(v)))
/*@}*/

/*!
 * @name Register ENET_MMFR, field PA[27:23] (RW)
 *
 * See (Clause 22) or (Clause 45) for correct value.
 */
/*@{*/
#define BP_ENET_MMFR_PA      (23U)         /*!< Bit position for ENET_MMFR_PA. */
#define BM_ENET_MMFR_PA      (0x0F800000U) /*!< Bit mask for ENET_MMFR_PA. */
#define BS_ENET_MMFR_PA      (5U)          /*!< Bit field size in bits for ENET_MMFR_PA. */

/*! @brief Read current value of the ENET_MMFR_PA field. */
#define BR_ENET_MMFR_PA(x)   (HW_ENET_MMFR(x).B.PA)

/*! @brief Format value for bitfield ENET_MMFR_PA. */
#define BF_ENET_MMFR_PA(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_PA) & BM_ENET_MMFR_PA)

/*! @brief Set the PA field to a new value. */
#define BW_ENET_MMFR_PA(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_PA) | BF_ENET_MMFR_PA(v)))
/*@}*/

/*!
 * @name Register ENET_MMFR, field OP[29:28] (RW)
 *
 * See (Clause 22) or (Clause 45) for correct value.
 */
/*@{*/
#define BP_ENET_MMFR_OP      (28U)         /*!< Bit position for ENET_MMFR_OP. */
#define BM_ENET_MMFR_OP      (0x30000000U) /*!< Bit mask for ENET_MMFR_OP. */
#define BS_ENET_MMFR_OP      (2U)          /*!< Bit field size in bits for ENET_MMFR_OP. */

/*! @brief Read current value of the ENET_MMFR_OP field. */
#define BR_ENET_MMFR_OP(x)   (HW_ENET_MMFR(x).B.OP)

/*! @brief Format value for bitfield ENET_MMFR_OP. */
#define BF_ENET_MMFR_OP(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_OP) & BM_ENET_MMFR_OP)

/*! @brief Set the OP field to a new value. */
#define BW_ENET_MMFR_OP(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_OP) | BF_ENET_MMFR_OP(v)))
/*@}*/

/*!
 * @name Register ENET_MMFR, field ST[31:30] (RW)
 *
 * See (Clause 22) or (Clause 45) for correct value.
 */
/*@{*/
#define BP_ENET_MMFR_ST      (30U)         /*!< Bit position for ENET_MMFR_ST. */
#define BM_ENET_MMFR_ST      (0xC0000000U) /*!< Bit mask for ENET_MMFR_ST. */
#define BS_ENET_MMFR_ST      (2U)          /*!< Bit field size in bits for ENET_MMFR_ST. */

/*! @brief Read current value of the ENET_MMFR_ST field. */
#define BR_ENET_MMFR_ST(x)   (HW_ENET_MMFR(x).B.ST)

/*! @brief Format value for bitfield ENET_MMFR_ST. */
#define BF_ENET_MMFR_ST(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_MMFR_ST) & BM_ENET_MMFR_ST)

/*! @brief Set the ST field to a new value. */
#define BW_ENET_MMFR_ST(x, v) (HW_ENET_MMFR_WR(x, (HW_ENET_MMFR_RD(x) & ~BM_ENET_MMFR_ST) | BF_ENET_MMFR_ST(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_MSCR - MII Speed Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_MSCR - MII Speed Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * MSCR provides control of the MII clock (MDC pin) frequency and allows a
 * preamble drop on the MII management frame. The MII_SPEED field must be programmed
 * with a value to provide an MDC frequency of less than or equal to 2.5 MHz to be
 * compliant with the IEEE 802.3 MII specification. The MII_SPEED must be set to
 * a non-zero value to source a read or write management frame. After the
 * management frame is complete, the MSCR register may optionally be cleared to turn
 * off MDC. The MDC signal generated has a 50% duty cycle except when MII_SPEED
 * changes during operation. This change takes effect following a rising or falling
 * edge of MDC. For example, if the internal module clock (i.e., IPS bus clock)
 * is 25 MHz, programming MII_SPEED to 0x4 results in an MDC as given in the
 * following equation: MII clock frequency = 25 MHz / ((4 + 1) x 2) = 2.5 MHz The
 * following table shows the optimum values for MII_SPEED as a function of IPS bus
 * clock frequency. Programming Examples for MSCR Internal module clock frequency
 * MSCR [MII_SPEED] MDC frequency 25 MHz 0x4 2.50 MHz 33 MHz 0x6 2.36 MHz 40 MHz
 * 0x7 2.50 MHz 50 MHz 0x9 2.50 MHz 66 MHz 0xD 2.36 MHz
 */
typedef union _hw_enet_mscr
{
    uint32_t U;
    struct _hw_enet_mscr_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t MII_SPEED : 6;        /*!< [6:1] MII Speed */
        uint32_t DIS_PRE : 1;          /*!< [7] Disable Preamble */
        uint32_t HOLDTIME : 3;         /*!< [10:8] Hold time On MDIO Output */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_enet_mscr_t;

/*!
 * @name Constants and macros for entire ENET_MSCR register
 */
/*@{*/
#define HW_ENET_MSCR_ADDR(x)     ((uintptr_t)(x) + 0x44U)

#define HW_ENET_MSCR(x)          (*(__IO hw_enet_mscr_t *) HW_ENET_MSCR_ADDR(x))
#define HW_ENET_MSCR_RD(x)       (HW_ENET_MSCR(x).U)
#define HW_ENET_MSCR_WR(x, v)    (HW_ENET_MSCR(x).U = (v))
#define HW_ENET_MSCR_SET(x, v)   (HW_ENET_MSCR_WR(x, HW_ENET_MSCR_RD(x) |  (v)))
#define HW_ENET_MSCR_CLR(x, v)   (HW_ENET_MSCR_WR(x, HW_ENET_MSCR_RD(x) & ~(v)))
#define HW_ENET_MSCR_TOG(x, v)   (HW_ENET_MSCR_WR(x, HW_ENET_MSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_MSCR bitfields
 */

/*!
 * @name Register ENET_MSCR, field MII_SPEED[6:1] (RW)
 *
 * Controls the frequency of the MII management interface clock (MDC) relative
 * to the internal module clock. A value of 0 in this field turns off MDC and
 * leaves it in low voltage state. Any non-zero value results in the MDC frequency
 * of: 1/((MII_SPEED + 1) x 2) of the internal module clock frequency
 */
/*@{*/
#define BP_ENET_MSCR_MII_SPEED (1U)        /*!< Bit position for ENET_MSCR_MII_SPEED. */
#define BM_ENET_MSCR_MII_SPEED (0x0000007EU) /*!< Bit mask for ENET_MSCR_MII_SPEED. */
#define BS_ENET_MSCR_MII_SPEED (6U)        /*!< Bit field size in bits for ENET_MSCR_MII_SPEED. */

/*! @brief Read current value of the ENET_MSCR_MII_SPEED field. */
#define BR_ENET_MSCR_MII_SPEED(x) (HW_ENET_MSCR(x).B.MII_SPEED)

/*! @brief Format value for bitfield ENET_MSCR_MII_SPEED. */
#define BF_ENET_MSCR_MII_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MSCR_MII_SPEED) & BM_ENET_MSCR_MII_SPEED)

/*! @brief Set the MII_SPEED field to a new value. */
#define BW_ENET_MSCR_MII_SPEED(x, v) (HW_ENET_MSCR_WR(x, (HW_ENET_MSCR_RD(x) & ~BM_ENET_MSCR_MII_SPEED) | BF_ENET_MSCR_MII_SPEED(v)))
/*@}*/

/*!
 * @name Register ENET_MSCR, field DIS_PRE[7] (RW)
 *
 * Enables/disables prepending a preamble to the MII management frame. The MII
 * standard allows the preamble to be dropped if the attached PHY devices do not
 * require it.
 *
 * Values:
 * - 0 - Preamble enabled.
 * - 1 - Preamble (32 ones) is not prepended to the MII management frame.
 */
/*@{*/
#define BP_ENET_MSCR_DIS_PRE (7U)          /*!< Bit position for ENET_MSCR_DIS_PRE. */
#define BM_ENET_MSCR_DIS_PRE (0x00000080U) /*!< Bit mask for ENET_MSCR_DIS_PRE. */
#define BS_ENET_MSCR_DIS_PRE (1U)          /*!< Bit field size in bits for ENET_MSCR_DIS_PRE. */

/*! @brief Read current value of the ENET_MSCR_DIS_PRE field. */
#define BR_ENET_MSCR_DIS_PRE(x) (HW_ENET_MSCR(x).B.DIS_PRE)

/*! @brief Format value for bitfield ENET_MSCR_DIS_PRE. */
#define BF_ENET_MSCR_DIS_PRE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MSCR_DIS_PRE) & BM_ENET_MSCR_DIS_PRE)

/*! @brief Set the DIS_PRE field to a new value. */
#define BW_ENET_MSCR_DIS_PRE(x, v) (HW_ENET_MSCR_WR(x, (HW_ENET_MSCR_RD(x) & ~BM_ENET_MSCR_DIS_PRE) | BF_ENET_MSCR_DIS_PRE(v)))
/*@}*/

/*!
 * @name Register ENET_MSCR, field HOLDTIME[10:8] (RW)
 *
 * IEEE802.3 clause 22 defines a minimum of 10 ns for the hold time on the MDIO
 * output. Depending on the host bus frequency, the setting may need to be
 * increased.
 *
 * Values:
 * - 000 - 1 internal module clock cycle
 * - 001 - 2 internal module clock cycles
 * - 010 - 3 internal module clock cycles
 * - 111 - 8 internal module clock cycles
 */
/*@{*/
#define BP_ENET_MSCR_HOLDTIME (8U)         /*!< Bit position for ENET_MSCR_HOLDTIME. */
#define BM_ENET_MSCR_HOLDTIME (0x00000700U) /*!< Bit mask for ENET_MSCR_HOLDTIME. */
#define BS_ENET_MSCR_HOLDTIME (3U)         /*!< Bit field size in bits for ENET_MSCR_HOLDTIME. */

/*! @brief Read current value of the ENET_MSCR_HOLDTIME field. */
#define BR_ENET_MSCR_HOLDTIME(x) (HW_ENET_MSCR(x).B.HOLDTIME)

/*! @brief Format value for bitfield ENET_MSCR_HOLDTIME. */
#define BF_ENET_MSCR_HOLDTIME(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MSCR_HOLDTIME) & BM_ENET_MSCR_HOLDTIME)

/*! @brief Set the HOLDTIME field to a new value. */
#define BW_ENET_MSCR_HOLDTIME(x, v) (HW_ENET_MSCR_WR(x, (HW_ENET_MSCR_RD(x) & ~BM_ENET_MSCR_HOLDTIME) | BF_ENET_MSCR_HOLDTIME(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_MIBC - MIB Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_MIBC - MIB Control Register (RW)
 *
 * Reset value: 0xC0000000U
 *
 * MIBC is a read/write register controlling and observing the state of the MIB
 * block. Access this register to disable the MIB block operation or clear the
 * MIB counters. The MIB_DIS field resets to 1.
 */
typedef union _hw_enet_mibc
{
    uint32_t U;
    struct _hw_enet_mibc_bitfields
    {
        uint32_t RESERVED0 : 29;       /*!< [28:0]  */
        uint32_t MIB_CLEAR : 1;        /*!< [29] MIB Clear */
        uint32_t MIB_IDLE : 1;         /*!< [30] MIB Idle */
        uint32_t MIB_DIS : 1;          /*!< [31] Disable MIB Logic */
    } B;
} hw_enet_mibc_t;

/*!
 * @name Constants and macros for entire ENET_MIBC register
 */
/*@{*/
#define HW_ENET_MIBC_ADDR(x)     ((uintptr_t)(x) + 0x64U)

#define HW_ENET_MIBC(x)          (*(__IO hw_enet_mibc_t *) HW_ENET_MIBC_ADDR(x))
#define HW_ENET_MIBC_RD(x)       (HW_ENET_MIBC(x).U)
#define HW_ENET_MIBC_WR(x, v)    (HW_ENET_MIBC(x).U = (v))
#define HW_ENET_MIBC_SET(x, v)   (HW_ENET_MIBC_WR(x, HW_ENET_MIBC_RD(x) |  (v)))
#define HW_ENET_MIBC_CLR(x, v)   (HW_ENET_MIBC_WR(x, HW_ENET_MIBC_RD(x) & ~(v)))
#define HW_ENET_MIBC_TOG(x, v)   (HW_ENET_MIBC_WR(x, HW_ENET_MIBC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_MIBC bitfields
 */

/*!
 * @name Register ENET_MIBC, field MIB_CLEAR[29] (RW)
 *
 * This field is not self-clearing. To clear the MIB counters set and then clear
 * this field.
 *
 * Values:
 * - 0 - See note above.
 * - 1 - All statistics counters are reset to 0.
 */
/*@{*/
#define BP_ENET_MIBC_MIB_CLEAR (29U)       /*!< Bit position for ENET_MIBC_MIB_CLEAR. */
#define BM_ENET_MIBC_MIB_CLEAR (0x20000000U) /*!< Bit mask for ENET_MIBC_MIB_CLEAR. */
#define BS_ENET_MIBC_MIB_CLEAR (1U)        /*!< Bit field size in bits for ENET_MIBC_MIB_CLEAR. */

/*! @brief Read current value of the ENET_MIBC_MIB_CLEAR field. */
#define BR_ENET_MIBC_MIB_CLEAR(x) (HW_ENET_MIBC(x).B.MIB_CLEAR)

/*! @brief Format value for bitfield ENET_MIBC_MIB_CLEAR. */
#define BF_ENET_MIBC_MIB_CLEAR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MIBC_MIB_CLEAR) & BM_ENET_MIBC_MIB_CLEAR)

/*! @brief Set the MIB_CLEAR field to a new value. */
#define BW_ENET_MIBC_MIB_CLEAR(x, v) (HW_ENET_MIBC_WR(x, (HW_ENET_MIBC_RD(x) & ~BM_ENET_MIBC_MIB_CLEAR) | BF_ENET_MIBC_MIB_CLEAR(v)))
/*@}*/

/*!
 * @name Register ENET_MIBC, field MIB_IDLE[30] (RO)
 *
 * Values:
 * - 0 - The MIB block is updating MIB counters.
 * - 1 - The MIB block is not currently updating any MIB counters.
 */
/*@{*/
#define BP_ENET_MIBC_MIB_IDLE (30U)        /*!< Bit position for ENET_MIBC_MIB_IDLE. */
#define BM_ENET_MIBC_MIB_IDLE (0x40000000U) /*!< Bit mask for ENET_MIBC_MIB_IDLE. */
#define BS_ENET_MIBC_MIB_IDLE (1U)         /*!< Bit field size in bits for ENET_MIBC_MIB_IDLE. */

/*! @brief Read current value of the ENET_MIBC_MIB_IDLE field. */
#define BR_ENET_MIBC_MIB_IDLE(x) (HW_ENET_MIBC(x).B.MIB_IDLE)
/*@}*/

/*!
 * @name Register ENET_MIBC, field MIB_DIS[31] (RW)
 *
 * If this control field is set,
 *
 * Values:
 * - 0 - MIB logic is enabled.
 * - 1 - MIB logic is disabled. The MIB logic halts and does not update any MIB
 *     counters.
 */
/*@{*/
#define BP_ENET_MIBC_MIB_DIS (31U)         /*!< Bit position for ENET_MIBC_MIB_DIS. */
#define BM_ENET_MIBC_MIB_DIS (0x80000000U) /*!< Bit mask for ENET_MIBC_MIB_DIS. */
#define BS_ENET_MIBC_MIB_DIS (1U)          /*!< Bit field size in bits for ENET_MIBC_MIB_DIS. */

/*! @brief Read current value of the ENET_MIBC_MIB_DIS field. */
#define BR_ENET_MIBC_MIB_DIS(x) (HW_ENET_MIBC(x).B.MIB_DIS)

/*! @brief Format value for bitfield ENET_MIBC_MIB_DIS. */
#define BF_ENET_MIBC_MIB_DIS(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MIBC_MIB_DIS) & BM_ENET_MIBC_MIB_DIS)

/*! @brief Set the MIB_DIS field to a new value. */
#define BW_ENET_MIBC_MIB_DIS(x, v) (HW_ENET_MIBC_WR(x, (HW_ENET_MIBC_RD(x) & ~BM_ENET_MIBC_MIB_DIS) | BF_ENET_MIBC_MIB_DIS(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RCR - Receive Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RCR - Receive Control Register (RW)
 *
 * Reset value: 0x05EE0001U
 */
typedef union _hw_enet_rcr
{
    uint32_t U;
    struct _hw_enet_rcr_bitfields
    {
        uint32_t LOOP : 1;             /*!< [0] Internal Loopback */
        uint32_t DRT : 1;              /*!< [1] Disable Receive On Transmit */
        uint32_t MII_MODE : 1;         /*!< [2] Media Independent Interface Mode */
        uint32_t PROM : 1;             /*!< [3] Promiscuous Mode */
        uint32_t BC_REJ : 1;           /*!< [4] Broadcast Frame Reject */
        uint32_t FCE : 1;              /*!< [5] Flow Control Enable */
        uint32_t RGMII_EN : 1;         /*!< [6] RGMII Mode Enable */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t RMII_MODE : 1;        /*!< [8] RMII Mode Enable */
        uint32_t RMII_10T : 1;         /*!< [9]  */
        uint32_t RESERVED1 : 2;        /*!< [11:10]  */
        uint32_t PADEN : 1;            /*!< [12] Enable Frame Padding Remove On Receive
                                        * */
        uint32_t PAUFWD : 1;           /*!< [13] Terminate/Forward Pause Frames */
        uint32_t CRCFWD : 1;           /*!< [14] Terminate/Forward Received CRC */
        uint32_t CFEN : 1;             /*!< [15] MAC Control Frame Enable */
        uint32_t MAX_FL : 14;          /*!< [29:16] Maximum Frame Length */
        uint32_t NLC : 1;              /*!< [30] Payload Length Check Disable */
        uint32_t GRS : 1;              /*!< [31] Graceful Receive Stopped */
    } B;
} hw_enet_rcr_t;

/*!
 * @name Constants and macros for entire ENET_RCR register
 */
/*@{*/
#define HW_ENET_RCR_ADDR(x)      ((uintptr_t)(x) + 0x84U)

#define HW_ENET_RCR(x)           (*(__IO hw_enet_rcr_t *) HW_ENET_RCR_ADDR(x))
#define HW_ENET_RCR_RD(x)        (HW_ENET_RCR(x).U)
#define HW_ENET_RCR_WR(x, v)     (HW_ENET_RCR(x).U = (v))
#define HW_ENET_RCR_SET(x, v)    (HW_ENET_RCR_WR(x, HW_ENET_RCR_RD(x) |  (v)))
#define HW_ENET_RCR_CLR(x, v)    (HW_ENET_RCR_WR(x, HW_ENET_RCR_RD(x) & ~(v)))
#define HW_ENET_RCR_TOG(x, v)    (HW_ENET_RCR_WR(x, HW_ENET_RCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RCR bitfields
 */

/*!
 * @name Register ENET_RCR, field LOOP[0] (RW)
 *
 * This is an MII internal loopback, therefore MII_MODE must be written to 1 and
 * RMII_MODE must be written to 0.
 *
 * Values:
 * - 0 - Loopback disabled.
 * - 1 - Transmitted frames are looped back internal to the device and transmit
 *     MII output signals are not asserted. DRT must be cleared.
 */
/*@{*/
#define BP_ENET_RCR_LOOP     (0U)          /*!< Bit position for ENET_RCR_LOOP. */
#define BM_ENET_RCR_LOOP     (0x00000001U) /*!< Bit mask for ENET_RCR_LOOP. */
#define BS_ENET_RCR_LOOP     (1U)          /*!< Bit field size in bits for ENET_RCR_LOOP. */

/*! @brief Read current value of the ENET_RCR_LOOP field. */
#define BR_ENET_RCR_LOOP(x)  (HW_ENET_RCR(x).B.LOOP)

/*! @brief Format value for bitfield ENET_RCR_LOOP. */
#define BF_ENET_RCR_LOOP(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_LOOP) & BM_ENET_RCR_LOOP)

/*! @brief Set the LOOP field to a new value. */
#define BW_ENET_RCR_LOOP(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_LOOP) | BF_ENET_RCR_LOOP(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field DRT[1] (RW)
 *
 * Values:
 * - 0 - Receive path operates independently of transmit. Used for full-duplex
 *     or to monitor transmit activity in half-duplex mode.
 * - 1 - Disable reception of frames while transmitting. Normally used for
 *     half-duplex mode.
 */
/*@{*/
#define BP_ENET_RCR_DRT      (1U)          /*!< Bit position for ENET_RCR_DRT. */
#define BM_ENET_RCR_DRT      (0x00000002U) /*!< Bit mask for ENET_RCR_DRT. */
#define BS_ENET_RCR_DRT      (1U)          /*!< Bit field size in bits for ENET_RCR_DRT. */

/*! @brief Read current value of the ENET_RCR_DRT field. */
#define BR_ENET_RCR_DRT(x)   (HW_ENET_RCR(x).B.DRT)

/*! @brief Format value for bitfield ENET_RCR_DRT. */
#define BF_ENET_RCR_DRT(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_DRT) & BM_ENET_RCR_DRT)

/*! @brief Set the DRT field to a new value. */
#define BW_ENET_RCR_DRT(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_DRT) | BF_ENET_RCR_DRT(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field MII_MODE[2] (RW)
 *
 * This field must always be set.
 *
 * Values:
 * - 0 - Reserved.
 * - 1 - MII or RMII mode, as indicated by the RMII_MODE field.
 */
/*@{*/
#define BP_ENET_RCR_MII_MODE (2U)          /*!< Bit position for ENET_RCR_MII_MODE. */
#define BM_ENET_RCR_MII_MODE (0x00000004U) /*!< Bit mask for ENET_RCR_MII_MODE. */
#define BS_ENET_RCR_MII_MODE (1U)          /*!< Bit field size in bits for ENET_RCR_MII_MODE. */

/*! @brief Read current value of the ENET_RCR_MII_MODE field. */
#define BR_ENET_RCR_MII_MODE(x) (HW_ENET_RCR(x).B.MII_MODE)

/*! @brief Format value for bitfield ENET_RCR_MII_MODE. */
#define BF_ENET_RCR_MII_MODE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_MII_MODE) & BM_ENET_RCR_MII_MODE)

/*! @brief Set the MII_MODE field to a new value. */
#define BW_ENET_RCR_MII_MODE(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_MII_MODE) | BF_ENET_RCR_MII_MODE(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field PROM[3] (RW)
 *
 * All frames are accepted regardless of address matching.
 *
 * Values:
 * - 0 - Disabled.
 * - 1 - Enabled.
 */
/*@{*/
#define BP_ENET_RCR_PROM     (3U)          /*!< Bit position for ENET_RCR_PROM. */
#define BM_ENET_RCR_PROM     (0x00000008U) /*!< Bit mask for ENET_RCR_PROM. */
#define BS_ENET_RCR_PROM     (1U)          /*!< Bit field size in bits for ENET_RCR_PROM. */

/*! @brief Read current value of the ENET_RCR_PROM field. */
#define BR_ENET_RCR_PROM(x)  (HW_ENET_RCR(x).B.PROM)

/*! @brief Format value for bitfield ENET_RCR_PROM. */
#define BF_ENET_RCR_PROM(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_PROM) & BM_ENET_RCR_PROM)

/*! @brief Set the PROM field to a new value. */
#define BW_ENET_RCR_PROM(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_PROM) | BF_ENET_RCR_PROM(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field BC_REJ[4] (RW)
 *
 * If set, frames with destination address (DA) equal to 0xFFFF_FFFF_FFFF are
 * rejected unless the PROM field is set. If BC_REJ and PROM are set, frames with
 * broadcast DA are accepted and the MISS (M) is set in the receive buffer
 * descriptor.
 */
/*@{*/
#define BP_ENET_RCR_BC_REJ   (4U)          /*!< Bit position for ENET_RCR_BC_REJ. */
#define BM_ENET_RCR_BC_REJ   (0x00000010U) /*!< Bit mask for ENET_RCR_BC_REJ. */
#define BS_ENET_RCR_BC_REJ   (1U)          /*!< Bit field size in bits for ENET_RCR_BC_REJ. */

/*! @brief Read current value of the ENET_RCR_BC_REJ field. */
#define BR_ENET_RCR_BC_REJ(x) (HW_ENET_RCR(x).B.BC_REJ)

/*! @brief Format value for bitfield ENET_RCR_BC_REJ. */
#define BF_ENET_RCR_BC_REJ(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_BC_REJ) & BM_ENET_RCR_BC_REJ)

/*! @brief Set the BC_REJ field to a new value. */
#define BW_ENET_RCR_BC_REJ(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_BC_REJ) | BF_ENET_RCR_BC_REJ(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field FCE[5] (RW)
 *
 * If set, the receiver detects PAUSE frames. Upon PAUSE frame detection, the
 * transmitter stops transmitting data frames for a given duration.
 */
/*@{*/
#define BP_ENET_RCR_FCE      (5U)          /*!< Bit position for ENET_RCR_FCE. */
#define BM_ENET_RCR_FCE      (0x00000020U) /*!< Bit mask for ENET_RCR_FCE. */
#define BS_ENET_RCR_FCE      (1U)          /*!< Bit field size in bits for ENET_RCR_FCE. */

/*! @brief Read current value of the ENET_RCR_FCE field. */
#define BR_ENET_RCR_FCE(x)   (HW_ENET_RCR(x).B.FCE)

/*! @brief Format value for bitfield ENET_RCR_FCE. */
#define BF_ENET_RCR_FCE(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_FCE) & BM_ENET_RCR_FCE)

/*! @brief Set the FCE field to a new value. */
#define BW_ENET_RCR_FCE(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_FCE) | BF_ENET_RCR_FCE(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field RGMII_EN[6] (RW)
 *
 * Do not set both RCR[RGMII_EN] and RCR[RMII_MODE].
 *
 * Values:
 * - 0 - MAC configured for non-RGMII operation
 * - 1 - MAC configured for RGMII operation. If ECR[SPEED] is set, the MAC is in
 *     RGMII 1000-Mbit/s mode. If ECR[SPEED] is cleared, the MAC is in RGMII
 *     10/100-Mbit/s mode.
 */
/*@{*/
#define BP_ENET_RCR_RGMII_EN (6U)          /*!< Bit position for ENET_RCR_RGMII_EN. */
#define BM_ENET_RCR_RGMII_EN (0x00000040U) /*!< Bit mask for ENET_RCR_RGMII_EN. */
#define BS_ENET_RCR_RGMII_EN (1U)          /*!< Bit field size in bits for ENET_RCR_RGMII_EN. */

/*! @brief Read current value of the ENET_RCR_RGMII_EN field. */
#define BR_ENET_RCR_RGMII_EN(x) (HW_ENET_RCR(x).B.RGMII_EN)

/*! @brief Format value for bitfield ENET_RCR_RGMII_EN. */
#define BF_ENET_RCR_RGMII_EN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_RGMII_EN) & BM_ENET_RCR_RGMII_EN)

/*! @brief Set the RGMII_EN field to a new value. */
#define BW_ENET_RCR_RGMII_EN(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_RGMII_EN) | BF_ENET_RCR_RGMII_EN(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field RMII_MODE[8] (RW)
 *
 * Specifies whether the MAC is configured for MII mode or RMII operation , when
 * ECR[SPEED] is cleared . Do not set both RCR[RGMII_EN] and RCR[RMII_MODE].
 *
 * Values:
 * - 0 - MAC configured for MII mode.
 * - 1 - MAC configured for RMII operation.
 */
/*@{*/
#define BP_ENET_RCR_RMII_MODE (8U)         /*!< Bit position for ENET_RCR_RMII_MODE. */
#define BM_ENET_RCR_RMII_MODE (0x00000100U) /*!< Bit mask for ENET_RCR_RMII_MODE. */
#define BS_ENET_RCR_RMII_MODE (1U)         /*!< Bit field size in bits for ENET_RCR_RMII_MODE. */

/*! @brief Read current value of the ENET_RCR_RMII_MODE field. */
#define BR_ENET_RCR_RMII_MODE(x) (HW_ENET_RCR(x).B.RMII_MODE)

/*! @brief Format value for bitfield ENET_RCR_RMII_MODE. */
#define BF_ENET_RCR_RMII_MODE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_RMII_MODE) & BM_ENET_RCR_RMII_MODE)

/*! @brief Set the RMII_MODE field to a new value. */
#define BW_ENET_RCR_RMII_MODE(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_RMII_MODE) | BF_ENET_RCR_RMII_MODE(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field RMII_10T[9] (RW)
 *
 * Enables 10-Mbit/s mode of the RMII or RGMII .
 *
 * Values:
 * - 0 - 100-Mbit/s operation.
 * - 1 - 10-Mbit/s operation.
 */
/*@{*/
#define BP_ENET_RCR_RMII_10T (9U)          /*!< Bit position for ENET_RCR_RMII_10T. */
#define BM_ENET_RCR_RMII_10T (0x00000200U) /*!< Bit mask for ENET_RCR_RMII_10T. */
#define BS_ENET_RCR_RMII_10T (1U)          /*!< Bit field size in bits for ENET_RCR_RMII_10T. */

/*! @brief Read current value of the ENET_RCR_RMII_10T field. */
#define BR_ENET_RCR_RMII_10T(x) (HW_ENET_RCR(x).B.RMII_10T)

/*! @brief Format value for bitfield ENET_RCR_RMII_10T. */
#define BF_ENET_RCR_RMII_10T(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_RMII_10T) & BM_ENET_RCR_RMII_10T)

/*! @brief Set the RMII_10T field to a new value. */
#define BW_ENET_RCR_RMII_10T(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_RMII_10T) | BF_ENET_RCR_RMII_10T(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field PADEN[12] (RW)
 *
 * Specifies whether the MAC removes padding from received frames.
 *
 * Values:
 * - 0 - No padding is removed on receive by the MAC.
 * - 1 - Padding is removed from received frames.
 */
/*@{*/
#define BP_ENET_RCR_PADEN    (12U)         /*!< Bit position for ENET_RCR_PADEN. */
#define BM_ENET_RCR_PADEN    (0x00001000U) /*!< Bit mask for ENET_RCR_PADEN. */
#define BS_ENET_RCR_PADEN    (1U)          /*!< Bit field size in bits for ENET_RCR_PADEN. */

/*! @brief Read current value of the ENET_RCR_PADEN field. */
#define BR_ENET_RCR_PADEN(x) (HW_ENET_RCR(x).B.PADEN)

/*! @brief Format value for bitfield ENET_RCR_PADEN. */
#define BF_ENET_RCR_PADEN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_PADEN) & BM_ENET_RCR_PADEN)

/*! @brief Set the PADEN field to a new value. */
#define BW_ENET_RCR_PADEN(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_PADEN) | BF_ENET_RCR_PADEN(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field PAUFWD[13] (RW)
 *
 * Specifies whether pause frames are terminated or forwarded.
 *
 * Values:
 * - 0 - Pause frames are terminated and discarded in the MAC.
 * - 1 - Pause frames are forwarded to the user application.
 */
/*@{*/
#define BP_ENET_RCR_PAUFWD   (13U)         /*!< Bit position for ENET_RCR_PAUFWD. */
#define BM_ENET_RCR_PAUFWD   (0x00002000U) /*!< Bit mask for ENET_RCR_PAUFWD. */
#define BS_ENET_RCR_PAUFWD   (1U)          /*!< Bit field size in bits for ENET_RCR_PAUFWD. */

/*! @brief Read current value of the ENET_RCR_PAUFWD field. */
#define BR_ENET_RCR_PAUFWD(x) (HW_ENET_RCR(x).B.PAUFWD)

/*! @brief Format value for bitfield ENET_RCR_PAUFWD. */
#define BF_ENET_RCR_PAUFWD(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_PAUFWD) & BM_ENET_RCR_PAUFWD)

/*! @brief Set the PAUFWD field to a new value. */
#define BW_ENET_RCR_PAUFWD(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_PAUFWD) | BF_ENET_RCR_PAUFWD(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field CRCFWD[14] (RW)
 *
 * Specifies whether the CRC field of received frames is transmitted or
 * stripped. If padding function is enabled (PADEN = 1), CRCFWD is ignored and the CRC
 * field is checked and always terminated and removed.
 *
 * Values:
 * - 0 - The CRC field of received frames is transmitted to the user application.
 * - 1 - The CRC field is stripped from the frame.
 */
/*@{*/
#define BP_ENET_RCR_CRCFWD   (14U)         /*!< Bit position for ENET_RCR_CRCFWD. */
#define BM_ENET_RCR_CRCFWD   (0x00004000U) /*!< Bit mask for ENET_RCR_CRCFWD. */
#define BS_ENET_RCR_CRCFWD   (1U)          /*!< Bit field size in bits for ENET_RCR_CRCFWD. */

/*! @brief Read current value of the ENET_RCR_CRCFWD field. */
#define BR_ENET_RCR_CRCFWD(x) (HW_ENET_RCR(x).B.CRCFWD)

/*! @brief Format value for bitfield ENET_RCR_CRCFWD. */
#define BF_ENET_RCR_CRCFWD(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_CRCFWD) & BM_ENET_RCR_CRCFWD)

/*! @brief Set the CRCFWD field to a new value. */
#define BW_ENET_RCR_CRCFWD(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_CRCFWD) | BF_ENET_RCR_CRCFWD(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field CFEN[15] (RW)
 *
 * Enables/disables the MAC control frame.
 *
 * Values:
 * - 0 - MAC control frames with any opcode other than 0x0001 (pause frame) are
 *     accepted and forwarded to the client interface.
 * - 1 - MAC control frames with any opcode other than 0x0001 (pause frame) are
 *     silently discarded.
 */
/*@{*/
#define BP_ENET_RCR_CFEN     (15U)         /*!< Bit position for ENET_RCR_CFEN. */
#define BM_ENET_RCR_CFEN     (0x00008000U) /*!< Bit mask for ENET_RCR_CFEN. */
#define BS_ENET_RCR_CFEN     (1U)          /*!< Bit field size in bits for ENET_RCR_CFEN. */

/*! @brief Read current value of the ENET_RCR_CFEN field. */
#define BR_ENET_RCR_CFEN(x)  (HW_ENET_RCR(x).B.CFEN)

/*! @brief Format value for bitfield ENET_RCR_CFEN. */
#define BF_ENET_RCR_CFEN(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_CFEN) & BM_ENET_RCR_CFEN)

/*! @brief Set the CFEN field to a new value. */
#define BW_ENET_RCR_CFEN(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_CFEN) | BF_ENET_RCR_CFEN(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field MAX_FL[29:16] (RW)
 *
 * Resets to decimal 1518. Length is measured starting at DA and includes the
 * CRC at the end of the frame. Transmit frames longer than MAX_FL cause the BABT
 * interrupt to occur. Receive frames longer than MAX_FL cause the BABR interrupt
 * to occur and set the LG field in the end of frame receive buffer descriptor.
 * The recommended default value to be programmed is 1518 or 1522 if VLAN tags are
 * supported.
 */
/*@{*/
#define BP_ENET_RCR_MAX_FL   (16U)         /*!< Bit position for ENET_RCR_MAX_FL. */
#define BM_ENET_RCR_MAX_FL   (0x3FFF0000U) /*!< Bit mask for ENET_RCR_MAX_FL. */
#define BS_ENET_RCR_MAX_FL   (14U)         /*!< Bit field size in bits for ENET_RCR_MAX_FL. */

/*! @brief Read current value of the ENET_RCR_MAX_FL field. */
#define BR_ENET_RCR_MAX_FL(x) (HW_ENET_RCR(x).B.MAX_FL)

/*! @brief Format value for bitfield ENET_RCR_MAX_FL. */
#define BF_ENET_RCR_MAX_FL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_MAX_FL) & BM_ENET_RCR_MAX_FL)

/*! @brief Set the MAX_FL field to a new value. */
#define BW_ENET_RCR_MAX_FL(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_MAX_FL) | BF_ENET_RCR_MAX_FL(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field NLC[30] (RW)
 *
 * Enables/disables a payload length check.
 *
 * Values:
 * - 0 - The payload length check is disabled.
 * - 1 - The core checks the frame's payload length with the frame length/type
 *     field. Errors are indicated in the EIR[PLC] field.
 */
/*@{*/
#define BP_ENET_RCR_NLC      (30U)         /*!< Bit position for ENET_RCR_NLC. */
#define BM_ENET_RCR_NLC      (0x40000000U) /*!< Bit mask for ENET_RCR_NLC. */
#define BS_ENET_RCR_NLC      (1U)          /*!< Bit field size in bits for ENET_RCR_NLC. */

/*! @brief Read current value of the ENET_RCR_NLC field. */
#define BR_ENET_RCR_NLC(x)   (HW_ENET_RCR(x).B.NLC)

/*! @brief Format value for bitfield ENET_RCR_NLC. */
#define BF_ENET_RCR_NLC(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_RCR_NLC) & BM_ENET_RCR_NLC)

/*! @brief Set the NLC field to a new value. */
#define BW_ENET_RCR_NLC(x, v) (HW_ENET_RCR_WR(x, (HW_ENET_RCR_RD(x) & ~BM_ENET_RCR_NLC) | BF_ENET_RCR_NLC(v)))
/*@}*/

/*!
 * @name Register ENET_RCR, field GRS[31] (RO)
 *
 * Read-only status indicating that the MAC receive datapath is stopped.
 */
/*@{*/
#define BP_ENET_RCR_GRS      (31U)         /*!< Bit position for ENET_RCR_GRS. */
#define BM_ENET_RCR_GRS      (0x80000000U) /*!< Bit mask for ENET_RCR_GRS. */
#define BS_ENET_RCR_GRS      (1U)          /*!< Bit field size in bits for ENET_RCR_GRS. */

/*! @brief Read current value of the ENET_RCR_GRS field. */
#define BR_ENET_RCR_GRS(x)   (HW_ENET_RCR(x).B.GRS)
/*@}*/

/*******************************************************************************
 * HW_ENET_TCR - Transmit Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TCR - Transmit Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * TCR is read/write and configures the transmit block. This register is cleared
 * at system reset. FDEN can only be modified when ECR[ETHEREN] is cleared.
 */
typedef union _hw_enet_tcr
{
    uint32_t U;
    struct _hw_enet_tcr_bitfields
    {
        uint32_t GTS : 1;              /*!< [0] Graceful Transmit Stop */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t FDEN : 1;             /*!< [2] Full-Duplex Enable */
        uint32_t TFC_PAUSE : 1;        /*!< [3] Transmit Frame Control Pause */
        uint32_t RFC_PAUSE : 1;        /*!< [4] Receive Frame Control Pause */
        uint32_t ADDSEL : 3;           /*!< [7:5] Source MAC Address Select On Transmit
                                        * */
        uint32_t ADDINS : 1;           /*!< [8] Set MAC Address On Transmit */
        uint32_t CRCFWD : 1;           /*!< [9] Forward Frame From Application With CRC
                                        * */
        uint32_t RESERVED1 : 22;       /*!< [31:10]  */
    } B;
} hw_enet_tcr_t;

/*!
 * @name Constants and macros for entire ENET_TCR register
 */
/*@{*/
#define HW_ENET_TCR_ADDR(x)      ((uintptr_t)(x) + 0xC4U)

#define HW_ENET_TCR(x)           (*(__IO hw_enet_tcr_t *) HW_ENET_TCR_ADDR(x))
#define HW_ENET_TCR_RD(x)        (HW_ENET_TCR(x).U)
#define HW_ENET_TCR_WR(x, v)     (HW_ENET_TCR(x).U = (v))
#define HW_ENET_TCR_SET(x, v)    (HW_ENET_TCR_WR(x, HW_ENET_TCR_RD(x) |  (v)))
#define HW_ENET_TCR_CLR(x, v)    (HW_ENET_TCR_WR(x, HW_ENET_TCR_RD(x) & ~(v)))
#define HW_ENET_TCR_TOG(x, v)    (HW_ENET_TCR_WR(x, HW_ENET_TCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TCR bitfields
 */

/*!
 * @name Register ENET_TCR, field GTS[0] (RW)
 *
 * When this field is set, MAC stops transmission after any frame currently
 * transmitted is complete and EIR[GRA] is set. If frame transmission is not
 * currently underway, the GRA interrupt is asserted immediately. After transmission
 * finishes, clear GTS to restart. The next frame in the transmit FIFO is then
 * transmitted. If an early collision occurs during transmission when GTS is set,
 * transmission stops after the collision. The frame is transmitted again after GTS is
 * cleared. There may be old frames in the transmit FIFO that transmit when GTS
 * is reasserted. To avoid this, clear ECR[ETHEREN] following the GRA interrupt.
 */
/*@{*/
#define BP_ENET_TCR_GTS      (0U)          /*!< Bit position for ENET_TCR_GTS. */
#define BM_ENET_TCR_GTS      (0x00000001U) /*!< Bit mask for ENET_TCR_GTS. */
#define BS_ENET_TCR_GTS      (1U)          /*!< Bit field size in bits for ENET_TCR_GTS. */

/*! @brief Read current value of the ENET_TCR_GTS field. */
#define BR_ENET_TCR_GTS(x)   (HW_ENET_TCR(x).B.GTS)

/*! @brief Format value for bitfield ENET_TCR_GTS. */
#define BF_ENET_TCR_GTS(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_GTS) & BM_ENET_TCR_GTS)

/*! @brief Set the GTS field to a new value. */
#define BW_ENET_TCR_GTS(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_GTS) | BF_ENET_TCR_GTS(v)))
/*@}*/

/*!
 * @name Register ENET_TCR, field FDEN[2] (RW)
 *
 * If this field is set, frames transmit independent of carrier sense and
 * collision inputs. Only modify this bit when ECR[ETHEREN] is cleared.
 */
/*@{*/
#define BP_ENET_TCR_FDEN     (2U)          /*!< Bit position for ENET_TCR_FDEN. */
#define BM_ENET_TCR_FDEN     (0x00000004U) /*!< Bit mask for ENET_TCR_FDEN. */
#define BS_ENET_TCR_FDEN     (1U)          /*!< Bit field size in bits for ENET_TCR_FDEN. */

/*! @brief Read current value of the ENET_TCR_FDEN field. */
#define BR_ENET_TCR_FDEN(x)  (HW_ENET_TCR(x).B.FDEN)

/*! @brief Format value for bitfield ENET_TCR_FDEN. */
#define BF_ENET_TCR_FDEN(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_FDEN) & BM_ENET_TCR_FDEN)

/*! @brief Set the FDEN field to a new value. */
#define BW_ENET_TCR_FDEN(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_FDEN) | BF_ENET_TCR_FDEN(v)))
/*@}*/

/*!
 * @name Register ENET_TCR, field TFC_PAUSE[3] (RW)
 *
 * Pauses frame transmission. When this field is set, EIR[GRA] is set. With
 * transmission of data frames stopped, the MAC transmits a MAC control PAUSE frame.
 * Next, the MAC clears TFC_PAUSE and resumes transmitting data frames. If the
 * transmitter pauses due to user assertion of GTS or reception of a PAUSE frame,
 * the MAC may continue transmitting a MAC control PAUSE frame.
 *
 * Values:
 * - 0 - No PAUSE frame transmitted.
 * - 1 - The MAC stops transmission of data frames after the current
 *     transmission is complete.
 */
/*@{*/
#define BP_ENET_TCR_TFC_PAUSE (3U)         /*!< Bit position for ENET_TCR_TFC_PAUSE. */
#define BM_ENET_TCR_TFC_PAUSE (0x00000008U) /*!< Bit mask for ENET_TCR_TFC_PAUSE. */
#define BS_ENET_TCR_TFC_PAUSE (1U)         /*!< Bit field size in bits for ENET_TCR_TFC_PAUSE. */

/*! @brief Read current value of the ENET_TCR_TFC_PAUSE field. */
#define BR_ENET_TCR_TFC_PAUSE(x) (HW_ENET_TCR(x).B.TFC_PAUSE)

/*! @brief Format value for bitfield ENET_TCR_TFC_PAUSE. */
#define BF_ENET_TCR_TFC_PAUSE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_TFC_PAUSE) & BM_ENET_TCR_TFC_PAUSE)

/*! @brief Set the TFC_PAUSE field to a new value. */
#define BW_ENET_TCR_TFC_PAUSE(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_TFC_PAUSE) | BF_ENET_TCR_TFC_PAUSE(v)))
/*@}*/

/*!
 * @name Register ENET_TCR, field RFC_PAUSE[4] (RO)
 *
 * This status field is set when a full-duplex flow control pause frame is
 * received and the transmitter pauses for the duration defined in this pause frame.
 * This field automatically clears when the pause duration is complete.
 */
/*@{*/
#define BP_ENET_TCR_RFC_PAUSE (4U)         /*!< Bit position for ENET_TCR_RFC_PAUSE. */
#define BM_ENET_TCR_RFC_PAUSE (0x00000010U) /*!< Bit mask for ENET_TCR_RFC_PAUSE. */
#define BS_ENET_TCR_RFC_PAUSE (1U)         /*!< Bit field size in bits for ENET_TCR_RFC_PAUSE. */

/*! @brief Read current value of the ENET_TCR_RFC_PAUSE field. */
#define BR_ENET_TCR_RFC_PAUSE(x) (HW_ENET_TCR(x).B.RFC_PAUSE)
/*@}*/

/*!
 * @name Register ENET_TCR, field ADDSEL[7:5] (RW)
 *
 * If ADDINS is set, indicates the MAC address that overwrites the source MAC
 * address.
 *
 * Values:
 * - 000 - Node MAC address programmed on PADDR1/2 registers.
 * - 100 - Reserved.
 * - 101 - Reserved.
 * - 110 - Reserved.
 */
/*@{*/
#define BP_ENET_TCR_ADDSEL   (5U)          /*!< Bit position for ENET_TCR_ADDSEL. */
#define BM_ENET_TCR_ADDSEL   (0x000000E0U) /*!< Bit mask for ENET_TCR_ADDSEL. */
#define BS_ENET_TCR_ADDSEL   (3U)          /*!< Bit field size in bits for ENET_TCR_ADDSEL. */

/*! @brief Read current value of the ENET_TCR_ADDSEL field. */
#define BR_ENET_TCR_ADDSEL(x) (HW_ENET_TCR(x).B.ADDSEL)

/*! @brief Format value for bitfield ENET_TCR_ADDSEL. */
#define BF_ENET_TCR_ADDSEL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_ADDSEL) & BM_ENET_TCR_ADDSEL)

/*! @brief Set the ADDSEL field to a new value. */
#define BW_ENET_TCR_ADDSEL(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_ADDSEL) | BF_ENET_TCR_ADDSEL(v)))
/*@}*/

/*!
 * @name Register ENET_TCR, field ADDINS[8] (RW)
 *
 * Values:
 * - 0 - The source MAC address is not modified by the MAC.
 * - 1 - The MAC overwrites the source MAC address with the programmed MAC
 *     address according to ADDSEL.
 */
/*@{*/
#define BP_ENET_TCR_ADDINS   (8U)          /*!< Bit position for ENET_TCR_ADDINS. */
#define BM_ENET_TCR_ADDINS   (0x00000100U) /*!< Bit mask for ENET_TCR_ADDINS. */
#define BS_ENET_TCR_ADDINS   (1U)          /*!< Bit field size in bits for ENET_TCR_ADDINS. */

/*! @brief Read current value of the ENET_TCR_ADDINS field. */
#define BR_ENET_TCR_ADDINS(x) (HW_ENET_TCR(x).B.ADDINS)

/*! @brief Format value for bitfield ENET_TCR_ADDINS. */
#define BF_ENET_TCR_ADDINS(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_ADDINS) & BM_ENET_TCR_ADDINS)

/*! @brief Set the ADDINS field to a new value. */
#define BW_ENET_TCR_ADDINS(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_ADDINS) | BF_ENET_TCR_ADDINS(v)))
/*@}*/

/*!
 * @name Register ENET_TCR, field CRCFWD[9] (RW)
 *
 * Values:
 * - 0 - TxBD[TC] controls whether the frame has a CRC from the application.
 * - 1 - The transmitter does not append any CRC to transmitted frames, as it is
 *     expecting a frame with CRC from the application.
 */
/*@{*/
#define BP_ENET_TCR_CRCFWD   (9U)          /*!< Bit position for ENET_TCR_CRCFWD. */
#define BM_ENET_TCR_CRCFWD   (0x00000200U) /*!< Bit mask for ENET_TCR_CRCFWD. */
#define BS_ENET_TCR_CRCFWD   (1U)          /*!< Bit field size in bits for ENET_TCR_CRCFWD. */

/*! @brief Read current value of the ENET_TCR_CRCFWD field. */
#define BR_ENET_TCR_CRCFWD(x) (HW_ENET_TCR(x).B.CRCFWD)

/*! @brief Format value for bitfield ENET_TCR_CRCFWD. */
#define BF_ENET_TCR_CRCFWD(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCR_CRCFWD) & BM_ENET_TCR_CRCFWD)

/*! @brief Set the CRCFWD field to a new value. */
#define BW_ENET_TCR_CRCFWD(x, v) (HW_ENET_TCR_WR(x, (HW_ENET_TCR_RD(x) & ~BM_ENET_TCR_CRCFWD) | BF_ENET_TCR_CRCFWD(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_PALR - Physical Address Lower Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_PALR - Physical Address Lower Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * PALR contains the lower 32 bits (bytes 0, 1, 2, 3) of the 48-bit address used
 * in the address recognition process to compare with the destination address
 * (DA) field of receive frames with an individual DA. In addition, this register
 * is used in bytes 0 through 3 of the six-byte source address field when
 * transmitting PAUSE frames.
 */
typedef union _hw_enet_palr
{
    uint32_t U;
    struct _hw_enet_palr_bitfields
    {
        uint32_t PADDR1 : 32;          /*!< [31:0] Pause Address */
    } B;
} hw_enet_palr_t;

/*!
 * @name Constants and macros for entire ENET_PALR register
 */
/*@{*/
#define HW_ENET_PALR_ADDR(x)     ((uintptr_t)(x) + 0xE4U)

#define HW_ENET_PALR(x)          (*(__IO hw_enet_palr_t *) HW_ENET_PALR_ADDR(x))
#define HW_ENET_PALR_RD(x)       (HW_ENET_PALR(x).U)
#define HW_ENET_PALR_WR(x, v)    (HW_ENET_PALR(x).U = (v))
#define HW_ENET_PALR_SET(x, v)   (HW_ENET_PALR_WR(x, HW_ENET_PALR_RD(x) |  (v)))
#define HW_ENET_PALR_CLR(x, v)   (HW_ENET_PALR_WR(x, HW_ENET_PALR_RD(x) & ~(v)))
#define HW_ENET_PALR_TOG(x, v)   (HW_ENET_PALR_WR(x, HW_ENET_PALR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_PALR bitfields
 */

/*!
 * @name Register ENET_PALR, field PADDR1[31:0] (RW)
 *
 * Bytes 0 (bits 31:24), 1 (bits 23:16), 2 (bits 15:8), and 3 (bits 7:0) of the
 * 6-byte individual address are used for exact match and the source address
 * field in PAUSE frames.
 */
/*@{*/
#define BP_ENET_PALR_PADDR1  (0U)          /*!< Bit position for ENET_PALR_PADDR1. */
#define BM_ENET_PALR_PADDR1  (0xFFFFFFFFU) /*!< Bit mask for ENET_PALR_PADDR1. */
#define BS_ENET_PALR_PADDR1  (32U)         /*!< Bit field size in bits for ENET_PALR_PADDR1. */

/*! @brief Read current value of the ENET_PALR_PADDR1 field. */
#define BR_ENET_PALR_PADDR1(x) (HW_ENET_PALR(x).U)

/*! @brief Format value for bitfield ENET_PALR_PADDR1. */
#define BF_ENET_PALR_PADDR1(v) ((uint32_t)((uint32_t)(v) << BP_ENET_PALR_PADDR1) & BM_ENET_PALR_PADDR1)

/*! @brief Set the PADDR1 field to a new value. */
#define BW_ENET_PALR_PADDR1(x, v) (HW_ENET_PALR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_PAUR - Physical Address Upper Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_PAUR - Physical Address Upper Register (RW)
 *
 * Reset value: 0x00008808U
 *
 * PAUR contains the upper 16 bits (bytes 4 and 5) of the 48-bit address used in
 * the address recognition process to compare with the destination address (DA)
 * field of receive frames with an individual DA. In addition, this register is
 * used in bytes 4 and 5 of the six-byte source address field when transmitting
 * PAUSE frames. Bits 15:0 of PAUR contain a constant type field (0x8808) for
 * transmission of PAUSE frames.
 */
typedef union _hw_enet_paur
{
    uint32_t U;
    struct _hw_enet_paur_bitfields
    {
        uint32_t TYPE : 16;            /*!< [15:0] Type Field In PAUSE Frames */
        uint32_t PADDR2 : 16;          /*!< [31:16]  */
    } B;
} hw_enet_paur_t;

/*!
 * @name Constants and macros for entire ENET_PAUR register
 */
/*@{*/
#define HW_ENET_PAUR_ADDR(x)     ((uintptr_t)(x) + 0xE8U)

#define HW_ENET_PAUR(x)          (*(__IO hw_enet_paur_t *) HW_ENET_PAUR_ADDR(x))
#define HW_ENET_PAUR_RD(x)       (HW_ENET_PAUR(x).U)
#define HW_ENET_PAUR_WR(x, v)    (HW_ENET_PAUR(x).U = (v))
#define HW_ENET_PAUR_SET(x, v)   (HW_ENET_PAUR_WR(x, HW_ENET_PAUR_RD(x) |  (v)))
#define HW_ENET_PAUR_CLR(x, v)   (HW_ENET_PAUR_WR(x, HW_ENET_PAUR_RD(x) & ~(v)))
#define HW_ENET_PAUR_TOG(x, v)   (HW_ENET_PAUR_WR(x, HW_ENET_PAUR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_PAUR bitfields
 */

/*!
 * @name Register ENET_PAUR, field TYPE[15:0] (RO)
 *
 * These fields have a constant value of 0x8808.
 */
/*@{*/
#define BP_ENET_PAUR_TYPE    (0U)          /*!< Bit position for ENET_PAUR_TYPE. */
#define BM_ENET_PAUR_TYPE    (0x0000FFFFU) /*!< Bit mask for ENET_PAUR_TYPE. */
#define BS_ENET_PAUR_TYPE    (16U)         /*!< Bit field size in bits for ENET_PAUR_TYPE. */

/*! @brief Read current value of the ENET_PAUR_TYPE field. */
#define BR_ENET_PAUR_TYPE(x) (HW_ENET_PAUR(x).B.TYPE)
/*@}*/

/*!
 * @name Register ENET_PAUR, field PADDR2[31:16] (RW)
 *
 * Bytes 4 (bits 31:24) and 5 (bits 23:16) of the 6-byte individual address used
 * for exact match, and the source address field in PAUSE frames.
 */
/*@{*/
#define BP_ENET_PAUR_PADDR2  (16U)         /*!< Bit position for ENET_PAUR_PADDR2. */
#define BM_ENET_PAUR_PADDR2  (0xFFFF0000U) /*!< Bit mask for ENET_PAUR_PADDR2. */
#define BS_ENET_PAUR_PADDR2  (16U)         /*!< Bit field size in bits for ENET_PAUR_PADDR2. */

/*! @brief Read current value of the ENET_PAUR_PADDR2 field. */
#define BR_ENET_PAUR_PADDR2(x) (HW_ENET_PAUR(x).B.PADDR2)

/*! @brief Format value for bitfield ENET_PAUR_PADDR2. */
#define BF_ENET_PAUR_PADDR2(v) ((uint32_t)((uint32_t)(v) << BP_ENET_PAUR_PADDR2) & BM_ENET_PAUR_PADDR2)

/*! @brief Set the PADDR2 field to a new value. */
#define BW_ENET_PAUR_PADDR2(x, v) (HW_ENET_PAUR_WR(x, (HW_ENET_PAUR_RD(x) & ~BM_ENET_PAUR_PADDR2) | BF_ENET_PAUR_PADDR2(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_OPD - Opcode/Pause Duration Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_OPD - Opcode/Pause Duration Register (RW)
 *
 * Reset value: 0x00010000U
 *
 * OPD is read/write accessible. This register contains the 16-bit opcode and
 * 16-bit pause duration fields used in transmission of a PAUSE frame. The opcode
 * field is a constant value, 0x0001. When another node detects a PAUSE frame,
 * that node pauses transmission for the duration specified in the pause duration
 * field. The lower 16 bits of this register are not reset and you must initialize
 * it.
 */
typedef union _hw_enet_opd
{
    uint32_t U;
    struct _hw_enet_opd_bitfields
    {
        uint32_t PAUSE_DUR : 16;       /*!< [15:0] Pause Duration */
        uint32_t OPCODE : 16;          /*!< [31:16] Opcode Field In PAUSE Frames */
    } B;
} hw_enet_opd_t;

/*!
 * @name Constants and macros for entire ENET_OPD register
 */
/*@{*/
#define HW_ENET_OPD_ADDR(x)      ((uintptr_t)(x) + 0xECU)

#define HW_ENET_OPD(x)           (*(__IO hw_enet_opd_t *) HW_ENET_OPD_ADDR(x))
#define HW_ENET_OPD_RD(x)        (HW_ENET_OPD(x).U)
#define HW_ENET_OPD_WR(x, v)     (HW_ENET_OPD(x).U = (v))
#define HW_ENET_OPD_SET(x, v)    (HW_ENET_OPD_WR(x, HW_ENET_OPD_RD(x) |  (v)))
#define HW_ENET_OPD_CLR(x, v)    (HW_ENET_OPD_WR(x, HW_ENET_OPD_RD(x) & ~(v)))
#define HW_ENET_OPD_TOG(x, v)    (HW_ENET_OPD_WR(x, HW_ENET_OPD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_OPD bitfields
 */

/*!
 * @name Register ENET_OPD, field PAUSE_DUR[15:0] (RW)
 *
 * Pause duration field used in PAUSE frames.
 */
/*@{*/
#define BP_ENET_OPD_PAUSE_DUR (0U)         /*!< Bit position for ENET_OPD_PAUSE_DUR. */
#define BM_ENET_OPD_PAUSE_DUR (0x0000FFFFU) /*!< Bit mask for ENET_OPD_PAUSE_DUR. */
#define BS_ENET_OPD_PAUSE_DUR (16U)        /*!< Bit field size in bits for ENET_OPD_PAUSE_DUR. */

/*! @brief Read current value of the ENET_OPD_PAUSE_DUR field. */
#define BR_ENET_OPD_PAUSE_DUR(x) (HW_ENET_OPD(x).B.PAUSE_DUR)

/*! @brief Format value for bitfield ENET_OPD_PAUSE_DUR. */
#define BF_ENET_OPD_PAUSE_DUR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_OPD_PAUSE_DUR) & BM_ENET_OPD_PAUSE_DUR)

/*! @brief Set the PAUSE_DUR field to a new value. */
#define BW_ENET_OPD_PAUSE_DUR(x, v) (HW_ENET_OPD_WR(x, (HW_ENET_OPD_RD(x) & ~BM_ENET_OPD_PAUSE_DUR) | BF_ENET_OPD_PAUSE_DUR(v)))
/*@}*/

/*!
 * @name Register ENET_OPD, field OPCODE[31:16] (RO)
 *
 * These fields have a constant value of 0x0001.
 */
/*@{*/
#define BP_ENET_OPD_OPCODE   (16U)         /*!< Bit position for ENET_OPD_OPCODE. */
#define BM_ENET_OPD_OPCODE   (0xFFFF0000U) /*!< Bit mask for ENET_OPD_OPCODE. */
#define BS_ENET_OPD_OPCODE   (16U)         /*!< Bit field size in bits for ENET_OPD_OPCODE. */

/*! @brief Read current value of the ENET_OPD_OPCODE field. */
#define BR_ENET_OPD_OPCODE(x) (HW_ENET_OPD(x).B.OPCODE)
/*@}*/

/*******************************************************************************
 * HW_ENET_IAUR - Descriptor Individual Upper Address Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IAUR - Descriptor Individual Upper Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * IAUR contains the upper 32 bits of the 64-bit individual address hash table.
 * The address recognition process uses this table to check for a possible match
 * with the destination address (DA) field of receive frames with an individual
 * DA. This register is not reset and you must initialize it.
 */
typedef union _hw_enet_iaur
{
    uint32_t U;
    struct _hw_enet_iaur_bitfields
    {
        uint32_t IADDR1 : 32;          /*!< [31:0]  */
    } B;
} hw_enet_iaur_t;

/*!
 * @name Constants and macros for entire ENET_IAUR register
 */
/*@{*/
#define HW_ENET_IAUR_ADDR(x)     ((uintptr_t)(x) + 0x118U)

#define HW_ENET_IAUR(x)          (*(__IO hw_enet_iaur_t *) HW_ENET_IAUR_ADDR(x))
#define HW_ENET_IAUR_RD(x)       (HW_ENET_IAUR(x).U)
#define HW_ENET_IAUR_WR(x, v)    (HW_ENET_IAUR(x).U = (v))
#define HW_ENET_IAUR_SET(x, v)   (HW_ENET_IAUR_WR(x, HW_ENET_IAUR_RD(x) |  (v)))
#define HW_ENET_IAUR_CLR(x, v)   (HW_ENET_IAUR_WR(x, HW_ENET_IAUR_RD(x) & ~(v)))
#define HW_ENET_IAUR_TOG(x, v)   (HW_ENET_IAUR_WR(x, HW_ENET_IAUR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_IAUR bitfields
 */

/*!
 * @name Register ENET_IAUR, field IADDR1[31:0] (RW)
 *
 * Contains the upper 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a unicast address. Bit 31 of IADDR1
 * contains hash index bit 63. Bit 0 of IADDR1 contains hash index bit 32.
 */
/*@{*/
#define BP_ENET_IAUR_IADDR1  (0U)          /*!< Bit position for ENET_IAUR_IADDR1. */
#define BM_ENET_IAUR_IADDR1  (0xFFFFFFFFU) /*!< Bit mask for ENET_IAUR_IADDR1. */
#define BS_ENET_IAUR_IADDR1  (32U)         /*!< Bit field size in bits for ENET_IAUR_IADDR1. */

/*! @brief Read current value of the ENET_IAUR_IADDR1 field. */
#define BR_ENET_IAUR_IADDR1(x) (HW_ENET_IAUR(x).U)

/*! @brief Format value for bitfield ENET_IAUR_IADDR1. */
#define BF_ENET_IAUR_IADDR1(v) ((uint32_t)((uint32_t)(v) << BP_ENET_IAUR_IADDR1) & BM_ENET_IAUR_IADDR1)

/*! @brief Set the IADDR1 field to a new value. */
#define BW_ENET_IAUR_IADDR1(x, v) (HW_ENET_IAUR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_IALR - Descriptor Individual Lower Address Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IALR - Descriptor Individual Lower Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * IALR contains the lower 32 bits of the 64-bit individual address hash table.
 * The address recognition process uses this table to check for a possible match
 * with the DA field of receive frames with an individual DA. This register is
 * not reset and you must initialize it.
 */
typedef union _hw_enet_ialr
{
    uint32_t U;
    struct _hw_enet_ialr_bitfields
    {
        uint32_t IADDR2 : 32;          /*!< [31:0]  */
    } B;
} hw_enet_ialr_t;

/*!
 * @name Constants and macros for entire ENET_IALR register
 */
/*@{*/
#define HW_ENET_IALR_ADDR(x)     ((uintptr_t)(x) + 0x11CU)

#define HW_ENET_IALR(x)          (*(__IO hw_enet_ialr_t *) HW_ENET_IALR_ADDR(x))
#define HW_ENET_IALR_RD(x)       (HW_ENET_IALR(x).U)
#define HW_ENET_IALR_WR(x, v)    (HW_ENET_IALR(x).U = (v))
#define HW_ENET_IALR_SET(x, v)   (HW_ENET_IALR_WR(x, HW_ENET_IALR_RD(x) |  (v)))
#define HW_ENET_IALR_CLR(x, v)   (HW_ENET_IALR_WR(x, HW_ENET_IALR_RD(x) & ~(v)))
#define HW_ENET_IALR_TOG(x, v)   (HW_ENET_IALR_WR(x, HW_ENET_IALR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_IALR bitfields
 */

/*!
 * @name Register ENET_IALR, field IADDR2[31:0] (RW)
 *
 * Contains the lower 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a unicast address. Bit 31 of IADDR2
 * contains hash index bit 31. Bit 0 of IADDR2 contains hash index bit 0.
 */
/*@{*/
#define BP_ENET_IALR_IADDR2  (0U)          /*!< Bit position for ENET_IALR_IADDR2. */
#define BM_ENET_IALR_IADDR2  (0xFFFFFFFFU) /*!< Bit mask for ENET_IALR_IADDR2. */
#define BS_ENET_IALR_IADDR2  (32U)         /*!< Bit field size in bits for ENET_IALR_IADDR2. */

/*! @brief Read current value of the ENET_IALR_IADDR2 field. */
#define BR_ENET_IALR_IADDR2(x) (HW_ENET_IALR(x).U)

/*! @brief Format value for bitfield ENET_IALR_IADDR2. */
#define BF_ENET_IALR_IADDR2(v) ((uint32_t)((uint32_t)(v) << BP_ENET_IALR_IADDR2) & BM_ENET_IALR_IADDR2)

/*! @brief Set the IADDR2 field to a new value. */
#define BW_ENET_IALR_IADDR2(x, v) (HW_ENET_IALR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_GAUR - Descriptor Group Upper Address Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_GAUR - Descriptor Group Upper Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * GAUR contains the upper 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a multicast address. You must
 * initialize this register.
 */
typedef union _hw_enet_gaur
{
    uint32_t U;
    struct _hw_enet_gaur_bitfields
    {
        uint32_t GADDR1 : 32;          /*!< [31:0]  */
    } B;
} hw_enet_gaur_t;

/*!
 * @name Constants and macros for entire ENET_GAUR register
 */
/*@{*/
#define HW_ENET_GAUR_ADDR(x)     ((uintptr_t)(x) + 0x120U)

#define HW_ENET_GAUR(x)          (*(__IO hw_enet_gaur_t *) HW_ENET_GAUR_ADDR(x))
#define HW_ENET_GAUR_RD(x)       (HW_ENET_GAUR(x).U)
#define HW_ENET_GAUR_WR(x, v)    (HW_ENET_GAUR(x).U = (v))
#define HW_ENET_GAUR_SET(x, v)   (HW_ENET_GAUR_WR(x, HW_ENET_GAUR_RD(x) |  (v)))
#define HW_ENET_GAUR_CLR(x, v)   (HW_ENET_GAUR_WR(x, HW_ENET_GAUR_RD(x) & ~(v)))
#define HW_ENET_GAUR_TOG(x, v)   (HW_ENET_GAUR_WR(x, HW_ENET_GAUR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_GAUR bitfields
 */

/*!
 * @name Register ENET_GAUR, field GADDR1[31:0] (RW)
 *
 * Contains the upper 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a multicast address. Bit 31 of GADDR1
 * contains hash index bit 63. Bit 0 of GADDR1 contains hash index bit 32.
 */
/*@{*/
#define BP_ENET_GAUR_GADDR1  (0U)          /*!< Bit position for ENET_GAUR_GADDR1. */
#define BM_ENET_GAUR_GADDR1  (0xFFFFFFFFU) /*!< Bit mask for ENET_GAUR_GADDR1. */
#define BS_ENET_GAUR_GADDR1  (32U)         /*!< Bit field size in bits for ENET_GAUR_GADDR1. */

/*! @brief Read current value of the ENET_GAUR_GADDR1 field. */
#define BR_ENET_GAUR_GADDR1(x) (HW_ENET_GAUR(x).U)

/*! @brief Format value for bitfield ENET_GAUR_GADDR1. */
#define BF_ENET_GAUR_GADDR1(v) ((uint32_t)((uint32_t)(v) << BP_ENET_GAUR_GADDR1) & BM_ENET_GAUR_GADDR1)

/*! @brief Set the GADDR1 field to a new value. */
#define BW_ENET_GAUR_GADDR1(x, v) (HW_ENET_GAUR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_GALR - Descriptor Group Lower Address Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_GALR - Descriptor Group Lower Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * GALR contains the lower 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a multicast address. You must
 * initialize this register.
 */
typedef union _hw_enet_galr
{
    uint32_t U;
    struct _hw_enet_galr_bitfields
    {
        uint32_t GADDR2 : 32;          /*!< [31:0]  */
    } B;
} hw_enet_galr_t;

/*!
 * @name Constants and macros for entire ENET_GALR register
 */
/*@{*/
#define HW_ENET_GALR_ADDR(x)     ((uintptr_t)(x) + 0x124U)

#define HW_ENET_GALR(x)          (*(__IO hw_enet_galr_t *) HW_ENET_GALR_ADDR(x))
#define HW_ENET_GALR_RD(x)       (HW_ENET_GALR(x).U)
#define HW_ENET_GALR_WR(x, v)    (HW_ENET_GALR(x).U = (v))
#define HW_ENET_GALR_SET(x, v)   (HW_ENET_GALR_WR(x, HW_ENET_GALR_RD(x) |  (v)))
#define HW_ENET_GALR_CLR(x, v)   (HW_ENET_GALR_WR(x, HW_ENET_GALR_RD(x) & ~(v)))
#define HW_ENET_GALR_TOG(x, v)   (HW_ENET_GALR_WR(x, HW_ENET_GALR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_GALR bitfields
 */

/*!
 * @name Register ENET_GALR, field GADDR2[31:0] (RW)
 *
 * Contains the lower 32 bits of the 64-bit hash table used in the address
 * recognition process for receive frames with a multicast address. Bit 31 of GADDR2
 * contains hash index bit 31. Bit 0 of GADDR2 contains hash index bit 0.
 */
/*@{*/
#define BP_ENET_GALR_GADDR2  (0U)          /*!< Bit position for ENET_GALR_GADDR2. */
#define BM_ENET_GALR_GADDR2  (0xFFFFFFFFU) /*!< Bit mask for ENET_GALR_GADDR2. */
#define BS_ENET_GALR_GADDR2  (32U)         /*!< Bit field size in bits for ENET_GALR_GADDR2. */

/*! @brief Read current value of the ENET_GALR_GADDR2 field. */
#define BR_ENET_GALR_GADDR2(x) (HW_ENET_GALR(x).U)

/*! @brief Format value for bitfield ENET_GALR_GADDR2. */
#define BF_ENET_GALR_GADDR2(v) ((uint32_t)((uint32_t)(v) << BP_ENET_GALR_GADDR2) & BM_ENET_GALR_GADDR2)

/*! @brief Set the GADDR2 field to a new value. */
#define BW_ENET_GALR_GADDR2(x, v) (HW_ENET_GALR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_TFWR - Transmit FIFO Watermark Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TFWR - Transmit FIFO Watermark Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * If TFWR[STRFWD] is cleared, TFWR[TFWR] controls the amount of data required
 * in the transmit FIFO before transmission of a frame can begin. This allows you
 * to minimize transmit latency (TFWR = 00 or 01) or allow for larger bus access
 * latency (TFWR = 11) due to contention for the system bus. Setting the
 * watermark to a high value minimizes the risk of transmit FIFO underrun due to
 * contention for the system bus. The byte counts associated with the TFWR field may need
 * to be modified to match a given system requirement, for example, worst-case
 * bus access latency by the transmit data uDMA channel. When the FIFO level
 * reaches the value the TFWR field and when the STR_FWD is set to '0', the MAC
 * transmit control logic starts frame transmission even before the end-of-frame is
 * available in the FIFO (cut-through operation). If a complete frame has a size
 * smaller than the threshold programmed with TFWR, the MAC also transmits the Frame
 * to the line. To enable store and forward on the Transmit path, set STR_FWD to
 * '1'. In this case, the MAC starts to transmit data only when a complete frame
 * is stored in the Transmit FIFO.
 */
typedef union _hw_enet_tfwr
{
    uint32_t U;
    struct _hw_enet_tfwr_bitfields
    {
        uint32_t TFWR : 6;             /*!< [5:0] Transmit FIFO Write */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t STRFWD : 1;           /*!< [8] Store And Forward Enable */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_tfwr_t;

/*!
 * @name Constants and macros for entire ENET_TFWR register
 */
/*@{*/
#define HW_ENET_TFWR_ADDR(x)     ((uintptr_t)(x) + 0x144U)

#define HW_ENET_TFWR(x)          (*(__IO hw_enet_tfwr_t *) HW_ENET_TFWR_ADDR(x))
#define HW_ENET_TFWR_RD(x)       (HW_ENET_TFWR(x).U)
#define HW_ENET_TFWR_WR(x, v)    (HW_ENET_TFWR(x).U = (v))
#define HW_ENET_TFWR_SET(x, v)   (HW_ENET_TFWR_WR(x, HW_ENET_TFWR_RD(x) |  (v)))
#define HW_ENET_TFWR_CLR(x, v)   (HW_ENET_TFWR_WR(x, HW_ENET_TFWR_RD(x) & ~(v)))
#define HW_ENET_TFWR_TOG(x, v)   (HW_ENET_TFWR_WR(x, HW_ENET_TFWR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TFWR bitfields
 */

/*!
 * @name Register ENET_TFWR, field TFWR[5:0] (RW)
 *
 * If TFWR[STRFWD] is cleared, this field indicates the number of bytes, in
 * steps of 64 bytes, written to the transmit FIFO before transmission of a frame
 * begins. If a frame with less than the threshold is written, it is still sent
 * independently of this threshold setting. The threshold is relevant only if the
 * frame is larger than the threshold given.
 *
 * Values:
 * - 000000 - 64 bytes written.
 * - 000001 - 64 bytes written.
 * - 000010 - 128 bytes written.
 * - 000011 - 192 bytes written.
 * - 111111 - 4032 bytes written.
 */
/*@{*/
#define BP_ENET_TFWR_TFWR    (0U)          /*!< Bit position for ENET_TFWR_TFWR. */
#define BM_ENET_TFWR_TFWR    (0x0000003FU) /*!< Bit mask for ENET_TFWR_TFWR. */
#define BS_ENET_TFWR_TFWR    (6U)          /*!< Bit field size in bits for ENET_TFWR_TFWR. */

/*! @brief Read current value of the ENET_TFWR_TFWR field. */
#define BR_ENET_TFWR_TFWR(x) (HW_ENET_TFWR(x).B.TFWR)

/*! @brief Format value for bitfield ENET_TFWR_TFWR. */
#define BF_ENET_TFWR_TFWR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TFWR_TFWR) & BM_ENET_TFWR_TFWR)

/*! @brief Set the TFWR field to a new value. */
#define BW_ENET_TFWR_TFWR(x, v) (HW_ENET_TFWR_WR(x, (HW_ENET_TFWR_RD(x) & ~BM_ENET_TFWR_TFWR) | BF_ENET_TFWR_TFWR(v)))
/*@}*/

/*!
 * @name Register ENET_TFWR, field STRFWD[8] (RW)
 *
 * Values:
 * - 0 - Reset. The transmission start threshold is programmed in TFWR[TFWR].
 * - 1 - Enabled.
 */
/*@{*/
#define BP_ENET_TFWR_STRFWD  (8U)          /*!< Bit position for ENET_TFWR_STRFWD. */
#define BM_ENET_TFWR_STRFWD  (0x00000100U) /*!< Bit mask for ENET_TFWR_STRFWD. */
#define BS_ENET_TFWR_STRFWD  (1U)          /*!< Bit field size in bits for ENET_TFWR_STRFWD. */

/*! @brief Read current value of the ENET_TFWR_STRFWD field. */
#define BR_ENET_TFWR_STRFWD(x) (HW_ENET_TFWR(x).B.STRFWD)

/*! @brief Format value for bitfield ENET_TFWR_STRFWD. */
#define BF_ENET_TFWR_STRFWD(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TFWR_STRFWD) & BM_ENET_TFWR_STRFWD)

/*! @brief Set the STRFWD field to a new value. */
#define BW_ENET_TFWR_STRFWD(x, v) (HW_ENET_TFWR_WR(x, (HW_ENET_TFWR_RD(x) & ~BM_ENET_TFWR_STRFWD) | BF_ENET_TFWR_STRFWD(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RDSR - Receive Descriptor Ring Start Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RDSR - Receive Descriptor Ring Start Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * RDSR points to the beginning of the circular receive buffer descriptor queue
 * in external memory. This pointer must be 64-bit aligned (bits 2-0 must be
 * zero); however, it is recommended to be 128-bit aligned, that is, evenly divisible
 * by 16. This register must be initialized prior to operation
 */
typedef union _hw_enet_rdsr
{
    uint32_t U;
    struct _hw_enet_rdsr_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t R_DES_START : 29;     /*!< [31:3]  */
    } B;
} hw_enet_rdsr_t;

/*!
 * @name Constants and macros for entire ENET_RDSR register
 */
/*@{*/
#define HW_ENET_RDSR_ADDR(x)     ((uintptr_t)(x) + 0x180U)

#define HW_ENET_RDSR(x)          (*(__IO hw_enet_rdsr_t *) HW_ENET_RDSR_ADDR(x))
#define HW_ENET_RDSR_RD(x)       (HW_ENET_RDSR(x).U)
#define HW_ENET_RDSR_WR(x, v)    (HW_ENET_RDSR(x).U = (v))
#define HW_ENET_RDSR_SET(x, v)   (HW_ENET_RDSR_WR(x, HW_ENET_RDSR_RD(x) |  (v)))
#define HW_ENET_RDSR_CLR(x, v)   (HW_ENET_RDSR_WR(x, HW_ENET_RDSR_RD(x) & ~(v)))
#define HW_ENET_RDSR_TOG(x, v)   (HW_ENET_RDSR_WR(x, HW_ENET_RDSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RDSR bitfields
 */

/*!
 * @name Register ENET_RDSR, field R_DES_START[31:3] (RW)
 *
 * Pointer to the beginning of the receive buffer descriptor queue.
 */
/*@{*/
#define BP_ENET_RDSR_R_DES_START (3U)      /*!< Bit position for ENET_RDSR_R_DES_START. */
#define BM_ENET_RDSR_R_DES_START (0xFFFFFFF8U) /*!< Bit mask for ENET_RDSR_R_DES_START. */
#define BS_ENET_RDSR_R_DES_START (29U)     /*!< Bit field size in bits for ENET_RDSR_R_DES_START. */

/*! @brief Read current value of the ENET_RDSR_R_DES_START field. */
#define BR_ENET_RDSR_R_DES_START(x) (HW_ENET_RDSR(x).B.R_DES_START)

/*! @brief Format value for bitfield ENET_RDSR_R_DES_START. */
#define BF_ENET_RDSR_R_DES_START(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RDSR_R_DES_START) & BM_ENET_RDSR_R_DES_START)

/*! @brief Set the R_DES_START field to a new value. */
#define BW_ENET_RDSR_R_DES_START(x, v) (HW_ENET_RDSR_WR(x, (HW_ENET_RDSR_RD(x) & ~BM_ENET_RDSR_R_DES_START) | BF_ENET_RDSR_R_DES_START(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TDSR - Transmit Buffer Descriptor Ring Start Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TDSR - Transmit Buffer Descriptor Ring Start Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * TDSR provides a pointer to the beginning of the circular transmit buffer
 * descriptor queue in external memory. This pointer must be 64-bit aligned (bits 2-0
 * must be zero); however, it is recommended to be 128-bit aligned, that is,
 * evenly divisible by 16. This register must be initialized prior to operation.
 */
typedef union _hw_enet_tdsr
{
    uint32_t U;
    struct _hw_enet_tdsr_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t X_DES_START : 29;     /*!< [31:3]  */
    } B;
} hw_enet_tdsr_t;

/*!
 * @name Constants and macros for entire ENET_TDSR register
 */
/*@{*/
#define HW_ENET_TDSR_ADDR(x)     ((uintptr_t)(x) + 0x184U)

#define HW_ENET_TDSR(x)          (*(__IO hw_enet_tdsr_t *) HW_ENET_TDSR_ADDR(x))
#define HW_ENET_TDSR_RD(x)       (HW_ENET_TDSR(x).U)
#define HW_ENET_TDSR_WR(x, v)    (HW_ENET_TDSR(x).U = (v))
#define HW_ENET_TDSR_SET(x, v)   (HW_ENET_TDSR_WR(x, HW_ENET_TDSR_RD(x) |  (v)))
#define HW_ENET_TDSR_CLR(x, v)   (HW_ENET_TDSR_WR(x, HW_ENET_TDSR_RD(x) & ~(v)))
#define HW_ENET_TDSR_TOG(x, v)   (HW_ENET_TDSR_WR(x, HW_ENET_TDSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TDSR bitfields
 */

/*!
 * @name Register ENET_TDSR, field X_DES_START[31:3] (RW)
 *
 * Pointer to the beginning of the transmit buffer descriptor queue.
 */
/*@{*/
#define BP_ENET_TDSR_X_DES_START (3U)      /*!< Bit position for ENET_TDSR_X_DES_START. */
#define BM_ENET_TDSR_X_DES_START (0xFFFFFFF8U) /*!< Bit mask for ENET_TDSR_X_DES_START. */
#define BS_ENET_TDSR_X_DES_START (29U)     /*!< Bit field size in bits for ENET_TDSR_X_DES_START. */

/*! @brief Read current value of the ENET_TDSR_X_DES_START field. */
#define BR_ENET_TDSR_X_DES_START(x) (HW_ENET_TDSR(x).B.X_DES_START)

/*! @brief Format value for bitfield ENET_TDSR_X_DES_START. */
#define BF_ENET_TDSR_X_DES_START(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TDSR_X_DES_START) & BM_ENET_TDSR_X_DES_START)

/*! @brief Set the X_DES_START field to a new value. */
#define BW_ENET_TDSR_X_DES_START(x, v) (HW_ENET_TDSR_WR(x, (HW_ENET_TDSR_RD(x) & ~BM_ENET_TDSR_X_DES_START) | BF_ENET_TDSR_X_DES_START(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_MRBR - Maximum Receive Buffer Size Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_MRBR - Maximum Receive Buffer Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The MRBR is a user-programmable register that dictates the maximum size of
 * all receive buffers. This value should take into consideration that the receive
 * CRC is always written into the last receive buffer. R_BUF_SIZE is
 * concatentated with the four least-significant bits of this register and are used as the
 * maximum receive buffer size. To allow one maximum size frame per buffer, MRBR
 * must be set to RCR[MAX_FL] or larger. To properly align the buffer, MRBR must be
 * evenly divisible by 16. To ensure this, the lower four bits are set to zero
 * by the device. To minimize bus usage (descriptor fetches), set MRBR greater
 * than or equal to 256 bytes. This register must be initialized before operation.
 */
typedef union _hw_enet_mrbr
{
    uint32_t U;
    struct _hw_enet_mrbr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0] This field, which is always zero,
                                        * is the four least-significant bits of the maximum receive buffer size. */
        uint32_t R_BUF_SIZE : 7;       /*!< [10:4]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_enet_mrbr_t;

/*!
 * @name Constants and macros for entire ENET_MRBR register
 */
/*@{*/
#define HW_ENET_MRBR_ADDR(x)     ((uintptr_t)(x) + 0x188U)

#define HW_ENET_MRBR(x)          (*(__IO hw_enet_mrbr_t *) HW_ENET_MRBR_ADDR(x))
#define HW_ENET_MRBR_RD(x)       (HW_ENET_MRBR(x).U)
#define HW_ENET_MRBR_WR(x, v)    (HW_ENET_MRBR(x).U = (v))
#define HW_ENET_MRBR_SET(x, v)   (HW_ENET_MRBR_WR(x, HW_ENET_MRBR_RD(x) |  (v)))
#define HW_ENET_MRBR_CLR(x, v)   (HW_ENET_MRBR_WR(x, HW_ENET_MRBR_RD(x) & ~(v)))
#define HW_ENET_MRBR_TOG(x, v)   (HW_ENET_MRBR_WR(x, HW_ENET_MRBR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_MRBR bitfields
 */

/*!
 * @name Register ENET_MRBR, field R_BUF_SIZE[10:4] (RW)
 *
 * Receive buffer size in bytes. This value, concatenated with the four
 * least-significant bits of this register (which are always zero), is the effective
 * maximum receive buffer size.
 */
/*@{*/
#define BP_ENET_MRBR_R_BUF_SIZE (4U)       /*!< Bit position for ENET_MRBR_R_BUF_SIZE. */
#define BM_ENET_MRBR_R_BUF_SIZE (0x000007F0U) /*!< Bit mask for ENET_MRBR_R_BUF_SIZE. */
#define BS_ENET_MRBR_R_BUF_SIZE (7U)       /*!< Bit field size in bits for ENET_MRBR_R_BUF_SIZE. */

/*! @brief Read current value of the ENET_MRBR_R_BUF_SIZE field. */
#define BR_ENET_MRBR_R_BUF_SIZE(x) (HW_ENET_MRBR(x).B.R_BUF_SIZE)

/*! @brief Format value for bitfield ENET_MRBR_R_BUF_SIZE. */
#define BF_ENET_MRBR_R_BUF_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_MRBR_R_BUF_SIZE) & BM_ENET_MRBR_R_BUF_SIZE)

/*! @brief Set the R_BUF_SIZE field to a new value. */
#define BW_ENET_MRBR_R_BUF_SIZE(x, v) (HW_ENET_MRBR_WR(x, (HW_ENET_MRBR_RD(x) & ~BM_ENET_MRBR_R_BUF_SIZE) | BF_ENET_MRBR_R_BUF_SIZE(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RSFL - Receive FIFO Section Full Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_RSFL - Receive FIFO Section Full Threshold (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rsfl
{
    uint32_t U;
    struct _hw_enet_rsfl_bitfields
    {
        uint32_t RX_SECTION_FULL : 9;  /*!< [8:0] Value Of Receive FIFO
                                        * Section Full Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_rsfl_t;

/*!
 * @name Constants and macros for entire ENET_RSFL register
 */
/*@{*/
#define HW_ENET_RSFL_ADDR(x)     ((uintptr_t)(x) + 0x190U)

#define HW_ENET_RSFL(x)          (*(__IO hw_enet_rsfl_t *) HW_ENET_RSFL_ADDR(x))
#define HW_ENET_RSFL_RD(x)       (HW_ENET_RSFL(x).U)
#define HW_ENET_RSFL_WR(x, v)    (HW_ENET_RSFL(x).U = (v))
#define HW_ENET_RSFL_SET(x, v)   (HW_ENET_RSFL_WR(x, HW_ENET_RSFL_RD(x) |  (v)))
#define HW_ENET_RSFL_CLR(x, v)   (HW_ENET_RSFL_WR(x, HW_ENET_RSFL_RD(x) & ~(v)))
#define HW_ENET_RSFL_TOG(x, v)   (HW_ENET_RSFL_WR(x, HW_ENET_RSFL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RSFL bitfields
 */

/*!
 * @name Register ENET_RSFL, field RX_SECTION_FULL[8:0] (RW)
 *
 * Value, in 64-bit words, of the receive FIFO section full threshold. Clear
 * this field to enable store and forward on the RX FIFO. When programming a value
 * greater than 0 (cut-through operation), it must be greater than
 * RAEM[RX_ALMOST_EMPTY]. When the FIFO level reaches the value in this field, data is available
 * in the Receive FIFO (cut-through operation).
 */
/*@{*/
#define BP_ENET_RSFL_RX_SECTION_FULL (0U)  /*!< Bit position for ENET_RSFL_RX_SECTION_FULL. */
#define BM_ENET_RSFL_RX_SECTION_FULL (0x000001FFU) /*!< Bit mask for ENET_RSFL_RX_SECTION_FULL. */
#define BS_ENET_RSFL_RX_SECTION_FULL (9U)  /*!< Bit field size in bits for ENET_RSFL_RX_SECTION_FULL. */

/*! @brief Read current value of the ENET_RSFL_RX_SECTION_FULL field. */
#define BR_ENET_RSFL_RX_SECTION_FULL(x) (HW_ENET_RSFL(x).B.RX_SECTION_FULL)

/*! @brief Format value for bitfield ENET_RSFL_RX_SECTION_FULL. */
#define BF_ENET_RSFL_RX_SECTION_FULL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RSFL_RX_SECTION_FULL) & BM_ENET_RSFL_RX_SECTION_FULL)

/*! @brief Set the RX_SECTION_FULL field to a new value. */
#define BW_ENET_RSFL_RX_SECTION_FULL(x, v) (HW_ENET_RSFL_WR(x, (HW_ENET_RSFL_RD(x) & ~BM_ENET_RSFL_RX_SECTION_FULL) | BF_ENET_RSFL_RX_SECTION_FULL(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RSEM - Receive FIFO Section Empty Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_RSEM - Receive FIFO Section Empty Threshold (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rsem
{
    uint32_t U;
    struct _hw_enet_rsem_bitfields
    {
        uint32_t RX_SECTION_EMPTY : 9; /*!< [8:0] Value Of The Receive FIFO
                                        * Section Empty Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_rsem_t;

/*!
 * @name Constants and macros for entire ENET_RSEM register
 */
/*@{*/
#define HW_ENET_RSEM_ADDR(x)     ((uintptr_t)(x) + 0x194U)

#define HW_ENET_RSEM(x)          (*(__IO hw_enet_rsem_t *) HW_ENET_RSEM_ADDR(x))
#define HW_ENET_RSEM_RD(x)       (HW_ENET_RSEM(x).U)
#define HW_ENET_RSEM_WR(x, v)    (HW_ENET_RSEM(x).U = (v))
#define HW_ENET_RSEM_SET(x, v)   (HW_ENET_RSEM_WR(x, HW_ENET_RSEM_RD(x) |  (v)))
#define HW_ENET_RSEM_CLR(x, v)   (HW_ENET_RSEM_WR(x, HW_ENET_RSEM_RD(x) & ~(v)))
#define HW_ENET_RSEM_TOG(x, v)   (HW_ENET_RSEM_WR(x, HW_ENET_RSEM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RSEM bitfields
 */

/*!
 * @name Register ENET_RSEM, field RX_SECTION_EMPTY[8:0] (RW)
 *
 * Value, in 64-bit words, of the receive FIFO section empty threshold. When the
 * FIFO has reached this level, a pause frame will be issued. A value of 0
 * disables automatic pause frame generation. When the FIFO level goes below the value
 * programmed in this field, an XON pause frame is issued to indicate the FIFO
 * congestion is cleared to the remote Ethernet client. The section-empty
 * threshold indications from both FIFOs are OR'ed to cause XOFF pause frame generation.
 */
/*@{*/
#define BP_ENET_RSEM_RX_SECTION_EMPTY (0U) /*!< Bit position for ENET_RSEM_RX_SECTION_EMPTY. */
#define BM_ENET_RSEM_RX_SECTION_EMPTY (0x000001FFU) /*!< Bit mask for ENET_RSEM_RX_SECTION_EMPTY. */
#define BS_ENET_RSEM_RX_SECTION_EMPTY (9U) /*!< Bit field size in bits for ENET_RSEM_RX_SECTION_EMPTY. */

/*! @brief Read current value of the ENET_RSEM_RX_SECTION_EMPTY field. */
#define BR_ENET_RSEM_RX_SECTION_EMPTY(x) (HW_ENET_RSEM(x).B.RX_SECTION_EMPTY)

/*! @brief Format value for bitfield ENET_RSEM_RX_SECTION_EMPTY. */
#define BF_ENET_RSEM_RX_SECTION_EMPTY(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RSEM_RX_SECTION_EMPTY) & BM_ENET_RSEM_RX_SECTION_EMPTY)

/*! @brief Set the RX_SECTION_EMPTY field to a new value. */
#define BW_ENET_RSEM_RX_SECTION_EMPTY(x, v) (HW_ENET_RSEM_WR(x, (HW_ENET_RSEM_RD(x) & ~BM_ENET_RSEM_RX_SECTION_EMPTY) | BF_ENET_RSEM_RX_SECTION_EMPTY(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RAEM - Receive FIFO Almost Empty Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_RAEM - Receive FIFO Almost Empty Threshold (RW)
 *
 * Reset value: 0x00000004U
 */
typedef union _hw_enet_raem
{
    uint32_t U;
    struct _hw_enet_raem_bitfields
    {
        uint32_t RX_ALMOST_EMPTY : 9;  /*!< [8:0] Value Of The Receive FIFO
                                        * Almost Empty Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_raem_t;

/*!
 * @name Constants and macros for entire ENET_RAEM register
 */
/*@{*/
#define HW_ENET_RAEM_ADDR(x)     ((uintptr_t)(x) + 0x198U)

#define HW_ENET_RAEM(x)          (*(__IO hw_enet_raem_t *) HW_ENET_RAEM_ADDR(x))
#define HW_ENET_RAEM_RD(x)       (HW_ENET_RAEM(x).U)
#define HW_ENET_RAEM_WR(x, v)    (HW_ENET_RAEM(x).U = (v))
#define HW_ENET_RAEM_SET(x, v)   (HW_ENET_RAEM_WR(x, HW_ENET_RAEM_RD(x) |  (v)))
#define HW_ENET_RAEM_CLR(x, v)   (HW_ENET_RAEM_WR(x, HW_ENET_RAEM_RD(x) & ~(v)))
#define HW_ENET_RAEM_TOG(x, v)   (HW_ENET_RAEM_WR(x, HW_ENET_RAEM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RAEM bitfields
 */

/*!
 * @name Register ENET_RAEM, field RX_ALMOST_EMPTY[8:0] (RW)
 *
 * Value, in 64-bit words, of the receive FIFO almost empty threshold. When the
 * FIFO level reaches the value programmed in this field and the end-of-frame has
 * not been received for the frame yet, the core receive read control stops FIFO
 * read (and subsequently stops transferring data to the MAC client
 * application). It continues to deliver the frame, if again more data than the threshold or
 * the end-of-frame is available in the FIFO. A minimum value of 4 should be set.
 */
/*@{*/
#define BP_ENET_RAEM_RX_ALMOST_EMPTY (0U)  /*!< Bit position for ENET_RAEM_RX_ALMOST_EMPTY. */
#define BM_ENET_RAEM_RX_ALMOST_EMPTY (0x000001FFU) /*!< Bit mask for ENET_RAEM_RX_ALMOST_EMPTY. */
#define BS_ENET_RAEM_RX_ALMOST_EMPTY (9U)  /*!< Bit field size in bits for ENET_RAEM_RX_ALMOST_EMPTY. */

/*! @brief Read current value of the ENET_RAEM_RX_ALMOST_EMPTY field. */
#define BR_ENET_RAEM_RX_ALMOST_EMPTY(x) (HW_ENET_RAEM(x).B.RX_ALMOST_EMPTY)

/*! @brief Format value for bitfield ENET_RAEM_RX_ALMOST_EMPTY. */
#define BF_ENET_RAEM_RX_ALMOST_EMPTY(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RAEM_RX_ALMOST_EMPTY) & BM_ENET_RAEM_RX_ALMOST_EMPTY)

/*! @brief Set the RX_ALMOST_EMPTY field to a new value. */
#define BW_ENET_RAEM_RX_ALMOST_EMPTY(x, v) (HW_ENET_RAEM_WR(x, (HW_ENET_RAEM_RD(x) & ~BM_ENET_RAEM_RX_ALMOST_EMPTY) | BF_ENET_RAEM_RX_ALMOST_EMPTY(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RAFL - Receive FIFO Almost Full Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_RAFL - Receive FIFO Almost Full Threshold (RW)
 *
 * Reset value: 0x00000004U
 */
typedef union _hw_enet_rafl
{
    uint32_t U;
    struct _hw_enet_rafl_bitfields
    {
        uint32_t RX_ALMOST_FULL : 9;   /*!< [8:0] Value Of The Receive FIFO
                                        * Almost Full Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_rafl_t;

/*!
 * @name Constants and macros for entire ENET_RAFL register
 */
/*@{*/
#define HW_ENET_RAFL_ADDR(x)     ((uintptr_t)(x) + 0x19CU)

#define HW_ENET_RAFL(x)          (*(__IO hw_enet_rafl_t *) HW_ENET_RAFL_ADDR(x))
#define HW_ENET_RAFL_RD(x)       (HW_ENET_RAFL(x).U)
#define HW_ENET_RAFL_WR(x, v)    (HW_ENET_RAFL(x).U = (v))
#define HW_ENET_RAFL_SET(x, v)   (HW_ENET_RAFL_WR(x, HW_ENET_RAFL_RD(x) |  (v)))
#define HW_ENET_RAFL_CLR(x, v)   (HW_ENET_RAFL_WR(x, HW_ENET_RAFL_RD(x) & ~(v)))
#define HW_ENET_RAFL_TOG(x, v)   (HW_ENET_RAFL_WR(x, HW_ENET_RAFL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RAFL bitfields
 */

/*!
 * @name Register ENET_RAFL, field RX_ALMOST_FULL[8:0] (RW)
 *
 * Value, in 64-bit words, of the receive FIFO almost full threshold. When the
 * FIFO level comes close to the maximum, so that there is no more space for at
 * least RX_ALMOST_FULL number of words, the MAC stops writing data in the FIFO and
 * truncates the received frame to avoid FIFO overflow. The corresponding error
 * status will be set when the frame is delivered to the application. A minimum
 * value of 4 should be set.
 */
/*@{*/
#define BP_ENET_RAFL_RX_ALMOST_FULL (0U)   /*!< Bit position for ENET_RAFL_RX_ALMOST_FULL. */
#define BM_ENET_RAFL_RX_ALMOST_FULL (0x000001FFU) /*!< Bit mask for ENET_RAFL_RX_ALMOST_FULL. */
#define BS_ENET_RAFL_RX_ALMOST_FULL (9U)   /*!< Bit field size in bits for ENET_RAFL_RX_ALMOST_FULL. */

/*! @brief Read current value of the ENET_RAFL_RX_ALMOST_FULL field. */
#define BR_ENET_RAFL_RX_ALMOST_FULL(x) (HW_ENET_RAFL(x).B.RX_ALMOST_FULL)

/*! @brief Format value for bitfield ENET_RAFL_RX_ALMOST_FULL. */
#define BF_ENET_RAFL_RX_ALMOST_FULL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RAFL_RX_ALMOST_FULL) & BM_ENET_RAFL_RX_ALMOST_FULL)

/*! @brief Set the RX_ALMOST_FULL field to a new value. */
#define BW_ENET_RAFL_RX_ALMOST_FULL(x, v) (HW_ENET_RAFL_WR(x, (HW_ENET_RAFL_RD(x) & ~BM_ENET_RAFL_RX_ALMOST_FULL) | BF_ENET_RAFL_RX_ALMOST_FULL(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TSEM - Transmit FIFO Section Empty Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_TSEM - Transmit FIFO Section Empty Threshold (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_tsem
{
    uint32_t U;
    struct _hw_enet_tsem_bitfields
    {
        uint32_t TX_SECTION_EMPTY : 9; /*!< [8:0] Value Of The Transmit FIFO
                                        * Section Empty Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_tsem_t;

/*!
 * @name Constants and macros for entire ENET_TSEM register
 */
/*@{*/
#define HW_ENET_TSEM_ADDR(x)     ((uintptr_t)(x) + 0x1A0U)

#define HW_ENET_TSEM(x)          (*(__IO hw_enet_tsem_t *) HW_ENET_TSEM_ADDR(x))
#define HW_ENET_TSEM_RD(x)       (HW_ENET_TSEM(x).U)
#define HW_ENET_TSEM_WR(x, v)    (HW_ENET_TSEM(x).U = (v))
#define HW_ENET_TSEM_SET(x, v)   (HW_ENET_TSEM_WR(x, HW_ENET_TSEM_RD(x) |  (v)))
#define HW_ENET_TSEM_CLR(x, v)   (HW_ENET_TSEM_WR(x, HW_ENET_TSEM_RD(x) & ~(v)))
#define HW_ENET_TSEM_TOG(x, v)   (HW_ENET_TSEM_WR(x, HW_ENET_TSEM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TSEM bitfields
 */

/*!
 * @name Register ENET_TSEM, field TX_SECTION_EMPTY[8:0] (RW)
 *
 * Value, in 64-bit words, of the transmit FIFO section empty threshold. See
 * Transmit FIFO for more information.
 */
/*@{*/
#define BP_ENET_TSEM_TX_SECTION_EMPTY (0U) /*!< Bit position for ENET_TSEM_TX_SECTION_EMPTY. */
#define BM_ENET_TSEM_TX_SECTION_EMPTY (0x000001FFU) /*!< Bit mask for ENET_TSEM_TX_SECTION_EMPTY. */
#define BS_ENET_TSEM_TX_SECTION_EMPTY (9U) /*!< Bit field size in bits for ENET_TSEM_TX_SECTION_EMPTY. */

/*! @brief Read current value of the ENET_TSEM_TX_SECTION_EMPTY field. */
#define BR_ENET_TSEM_TX_SECTION_EMPTY(x) (HW_ENET_TSEM(x).B.TX_SECTION_EMPTY)

/*! @brief Format value for bitfield ENET_TSEM_TX_SECTION_EMPTY. */
#define BF_ENET_TSEM_TX_SECTION_EMPTY(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TSEM_TX_SECTION_EMPTY) & BM_ENET_TSEM_TX_SECTION_EMPTY)

/*! @brief Set the TX_SECTION_EMPTY field to a new value. */
#define BW_ENET_TSEM_TX_SECTION_EMPTY(x, v) (HW_ENET_TSEM_WR(x, (HW_ENET_TSEM_RD(x) & ~BM_ENET_TSEM_TX_SECTION_EMPTY) | BF_ENET_TSEM_TX_SECTION_EMPTY(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TAEM - Transmit FIFO Almost Empty Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_TAEM - Transmit FIFO Almost Empty Threshold (RW)
 *
 * Reset value: 0x00000004U
 */
typedef union _hw_enet_taem
{
    uint32_t U;
    struct _hw_enet_taem_bitfields
    {
        uint32_t TX_ALMOST_EMPTY : 9;  /*!< [8:0] Value of Transmit FIFO
                                        * Almost Empty Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_taem_t;

/*!
 * @name Constants and macros for entire ENET_TAEM register
 */
/*@{*/
#define HW_ENET_TAEM_ADDR(x)     ((uintptr_t)(x) + 0x1A4U)

#define HW_ENET_TAEM(x)          (*(__IO hw_enet_taem_t *) HW_ENET_TAEM_ADDR(x))
#define HW_ENET_TAEM_RD(x)       (HW_ENET_TAEM(x).U)
#define HW_ENET_TAEM_WR(x, v)    (HW_ENET_TAEM(x).U = (v))
#define HW_ENET_TAEM_SET(x, v)   (HW_ENET_TAEM_WR(x, HW_ENET_TAEM_RD(x) |  (v)))
#define HW_ENET_TAEM_CLR(x, v)   (HW_ENET_TAEM_WR(x, HW_ENET_TAEM_RD(x) & ~(v)))
#define HW_ENET_TAEM_TOG(x, v)   (HW_ENET_TAEM_WR(x, HW_ENET_TAEM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TAEM bitfields
 */

/*!
 * @name Register ENET_TAEM, field TX_ALMOST_EMPTY[8:0] (RW)
 *
 * Value, in 64-bit words, of the transmit FIFO almost empty threshold. When the
 * FIFO level reaches the value programmed in this field, and no end-of-frame is
 * available for the frame, the MAC transmit logic, to avoid FIFO underflow,
 * stops reading the FIFO and transmits a frame with an MII error indication. See
 * Transmit FIFO for more information. A minimum value of 4 should be set.
 */
/*@{*/
#define BP_ENET_TAEM_TX_ALMOST_EMPTY (0U)  /*!< Bit position for ENET_TAEM_TX_ALMOST_EMPTY. */
#define BM_ENET_TAEM_TX_ALMOST_EMPTY (0x000001FFU) /*!< Bit mask for ENET_TAEM_TX_ALMOST_EMPTY. */
#define BS_ENET_TAEM_TX_ALMOST_EMPTY (9U)  /*!< Bit field size in bits for ENET_TAEM_TX_ALMOST_EMPTY. */

/*! @brief Read current value of the ENET_TAEM_TX_ALMOST_EMPTY field. */
#define BR_ENET_TAEM_TX_ALMOST_EMPTY(x) (HW_ENET_TAEM(x).B.TX_ALMOST_EMPTY)

/*! @brief Format value for bitfield ENET_TAEM_TX_ALMOST_EMPTY. */
#define BF_ENET_TAEM_TX_ALMOST_EMPTY(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TAEM_TX_ALMOST_EMPTY) & BM_ENET_TAEM_TX_ALMOST_EMPTY)

/*! @brief Set the TX_ALMOST_EMPTY field to a new value. */
#define BW_ENET_TAEM_TX_ALMOST_EMPTY(x, v) (HW_ENET_TAEM_WR(x, (HW_ENET_TAEM_RD(x) & ~BM_ENET_TAEM_TX_ALMOST_EMPTY) | BF_ENET_TAEM_TX_ALMOST_EMPTY(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TAFL - Transmit FIFO Almost Full Threshold
 ******************************************************************************/

/*!
 * @brief HW_ENET_TAFL - Transmit FIFO Almost Full Threshold (RW)
 *
 * Reset value: 0x00000008U
 */
typedef union _hw_enet_tafl
{
    uint32_t U;
    struct _hw_enet_tafl_bitfields
    {
        uint32_t TX_ALMOST_FULL : 9;   /*!< [8:0] Value Of The Transmit FIFO
                                        * Almost Full Threshold */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_enet_tafl_t;

/*!
 * @name Constants and macros for entire ENET_TAFL register
 */
/*@{*/
#define HW_ENET_TAFL_ADDR(x)     ((uintptr_t)(x) + 0x1A8U)

#define HW_ENET_TAFL(x)          (*(__IO hw_enet_tafl_t *) HW_ENET_TAFL_ADDR(x))
#define HW_ENET_TAFL_RD(x)       (HW_ENET_TAFL(x).U)
#define HW_ENET_TAFL_WR(x, v)    (HW_ENET_TAFL(x).U = (v))
#define HW_ENET_TAFL_SET(x, v)   (HW_ENET_TAFL_WR(x, HW_ENET_TAFL_RD(x) |  (v)))
#define HW_ENET_TAFL_CLR(x, v)   (HW_ENET_TAFL_WR(x, HW_ENET_TAFL_RD(x) & ~(v)))
#define HW_ENET_TAFL_TOG(x, v)   (HW_ENET_TAFL_WR(x, HW_ENET_TAFL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TAFL bitfields
 */

/*!
 * @name Register ENET_TAFL, field TX_ALMOST_FULL[8:0] (RW)
 *
 * Value, in 64-bit words, of the transmit FIFO almost full threshold. A minimum
 * value of six is required . A recommended value of at least 8 should be set
 * allowing a latency of two clock cycles to the application. If more latency is
 * required the value can be increased as necessary (latency = TAFL - 5). When the
 * FIFO level comes close to the maximum, so that there is no more space for at
 * least TX_ALMOST_FULL number of words, the pin ff_tx_rdy is deasserted. If the
 * application does not react on this signal, the FIFO write control logic, to
 * avoid FIFO overflow, truncates the current frame and sets the error status. As a
 * result, the frame will be transmitted with an GMII/MII error indication. See
 * Transmit FIFO for more information. A FIFO overflow is a fatal error and
 * requires a global reset on the transmit datapath or at least deassertion of ETHEREN.
 */
/*@{*/
#define BP_ENET_TAFL_TX_ALMOST_FULL (0U)   /*!< Bit position for ENET_TAFL_TX_ALMOST_FULL. */
#define BM_ENET_TAFL_TX_ALMOST_FULL (0x000001FFU) /*!< Bit mask for ENET_TAFL_TX_ALMOST_FULL. */
#define BS_ENET_TAFL_TX_ALMOST_FULL (9U)   /*!< Bit field size in bits for ENET_TAFL_TX_ALMOST_FULL. */

/*! @brief Read current value of the ENET_TAFL_TX_ALMOST_FULL field. */
#define BR_ENET_TAFL_TX_ALMOST_FULL(x) (HW_ENET_TAFL(x).B.TX_ALMOST_FULL)

/*! @brief Format value for bitfield ENET_TAFL_TX_ALMOST_FULL. */
#define BF_ENET_TAFL_TX_ALMOST_FULL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TAFL_TX_ALMOST_FULL) & BM_ENET_TAFL_TX_ALMOST_FULL)

/*! @brief Set the TX_ALMOST_FULL field to a new value. */
#define BW_ENET_TAFL_TX_ALMOST_FULL(x, v) (HW_ENET_TAFL_WR(x, (HW_ENET_TAFL_RD(x) & ~BM_ENET_TAFL_TX_ALMOST_FULL) | BF_ENET_TAFL_TX_ALMOST_FULL(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TIPG - Transmit Inter-Packet Gap
 ******************************************************************************/

/*!
 * @brief HW_ENET_TIPG - Transmit Inter-Packet Gap (RW)
 *
 * Reset value: 0x0000000CU
 */
typedef union _hw_enet_tipg
{
    uint32_t U;
    struct _hw_enet_tipg_bitfields
    {
        uint32_t IPG : 5;              /*!< [4:0] Transmit Inter-Packet Gap */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_enet_tipg_t;

/*!
 * @name Constants and macros for entire ENET_TIPG register
 */
/*@{*/
#define HW_ENET_TIPG_ADDR(x)     ((uintptr_t)(x) + 0x1ACU)

#define HW_ENET_TIPG(x)          (*(__IO hw_enet_tipg_t *) HW_ENET_TIPG_ADDR(x))
#define HW_ENET_TIPG_RD(x)       (HW_ENET_TIPG(x).U)
#define HW_ENET_TIPG_WR(x, v)    (HW_ENET_TIPG(x).U = (v))
#define HW_ENET_TIPG_SET(x, v)   (HW_ENET_TIPG_WR(x, HW_ENET_TIPG_RD(x) |  (v)))
#define HW_ENET_TIPG_CLR(x, v)   (HW_ENET_TIPG_WR(x, HW_ENET_TIPG_RD(x) & ~(v)))
#define HW_ENET_TIPG_TOG(x, v)   (HW_ENET_TIPG_WR(x, HW_ENET_TIPG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TIPG bitfields
 */

/*!
 * @name Register ENET_TIPG, field IPG[4:0] (RW)
 *
 * Indicates the IPG, in bytes, between transmitted frames. Valid values range
 * from 8 to 26. If the written value is less than 8 or greater than 26, the
 * internal (effective) IPG is 12. The IPG value read will be the value that was
 * written, even if it is out of range.
 */
/*@{*/
#define BP_ENET_TIPG_IPG     (0U)          /*!< Bit position for ENET_TIPG_IPG. */
#define BM_ENET_TIPG_IPG     (0x0000001FU) /*!< Bit mask for ENET_TIPG_IPG. */
#define BS_ENET_TIPG_IPG     (5U)          /*!< Bit field size in bits for ENET_TIPG_IPG. */

/*! @brief Read current value of the ENET_TIPG_IPG field. */
#define BR_ENET_TIPG_IPG(x)  (HW_ENET_TIPG(x).B.IPG)

/*! @brief Format value for bitfield ENET_TIPG_IPG. */
#define BF_ENET_TIPG_IPG(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TIPG_IPG) & BM_ENET_TIPG_IPG)

/*! @brief Set the IPG field to a new value. */
#define BW_ENET_TIPG_IPG(x, v) (HW_ENET_TIPG_WR(x, (HW_ENET_TIPG_RD(x) & ~BM_ENET_TIPG_IPG) | BF_ENET_TIPG_IPG(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_FTRL - Frame Truncation Length
 ******************************************************************************/

/*!
 * @brief HW_ENET_FTRL - Frame Truncation Length (RW)
 *
 * Reset value: 0x000007FFU
 */
typedef union _hw_enet_ftrl
{
    uint32_t U;
    struct _hw_enet_ftrl_bitfields
    {
        uint32_t TRUNC_FL : 14;        /*!< [13:0] Frame Truncation Length */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_enet_ftrl_t;

/*!
 * @name Constants and macros for entire ENET_FTRL register
 */
/*@{*/
#define HW_ENET_FTRL_ADDR(x)     ((uintptr_t)(x) + 0x1B0U)

#define HW_ENET_FTRL(x)          (*(__IO hw_enet_ftrl_t *) HW_ENET_FTRL_ADDR(x))
#define HW_ENET_FTRL_RD(x)       (HW_ENET_FTRL(x).U)
#define HW_ENET_FTRL_WR(x, v)    (HW_ENET_FTRL(x).U = (v))
#define HW_ENET_FTRL_SET(x, v)   (HW_ENET_FTRL_WR(x, HW_ENET_FTRL_RD(x) |  (v)))
#define HW_ENET_FTRL_CLR(x, v)   (HW_ENET_FTRL_WR(x, HW_ENET_FTRL_RD(x) & ~(v)))
#define HW_ENET_FTRL_TOG(x, v)   (HW_ENET_FTRL_WR(x, HW_ENET_FTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_FTRL bitfields
 */

/*!
 * @name Register ENET_FTRL, field TRUNC_FL[13:0] (RW)
 *
 * Indicates the value a receive frame is truncated, if it is greater than this
 * value. Must be greater than or equal to RCR[MAX_FL]. Truncation happens at
 * TRUNC_FL. However, when truncation occurs, the application (FIFO) may receive
 * less data, guaranteeing that it never receives more than the set limit.
 */
/*@{*/
#define BP_ENET_FTRL_TRUNC_FL (0U)         /*!< Bit position for ENET_FTRL_TRUNC_FL. */
#define BM_ENET_FTRL_TRUNC_FL (0x00003FFFU) /*!< Bit mask for ENET_FTRL_TRUNC_FL. */
#define BS_ENET_FTRL_TRUNC_FL (14U)        /*!< Bit field size in bits for ENET_FTRL_TRUNC_FL. */

/*! @brief Read current value of the ENET_FTRL_TRUNC_FL field. */
#define BR_ENET_FTRL_TRUNC_FL(x) (HW_ENET_FTRL(x).B.TRUNC_FL)

/*! @brief Format value for bitfield ENET_FTRL_TRUNC_FL. */
#define BF_ENET_FTRL_TRUNC_FL(v) ((uint32_t)((uint32_t)(v) << BP_ENET_FTRL_TRUNC_FL) & BM_ENET_FTRL_TRUNC_FL)

/*! @brief Set the TRUNC_FL field to a new value. */
#define BW_ENET_FTRL_TRUNC_FL(x, v) (HW_ENET_FTRL_WR(x, (HW_ENET_FTRL_RD(x) & ~BM_ENET_FTRL_TRUNC_FL) | BF_ENET_FTRL_TRUNC_FL(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TACC - Transmit Accelerator Function Configuration
 ******************************************************************************/

/*!
 * @brief HW_ENET_TACC - Transmit Accelerator Function Configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * TACC controls accelerator actions when sending frames. The register can be
 * changed before or after each frame, but it must remain unmodified during frame
 * writes into the transmit FIFO. The TFWR[STRFWD] field must be set to use the
 * checksum feature.
 */
typedef union _hw_enet_tacc
{
    uint32_t U;
    struct _hw_enet_tacc_bitfields
    {
        uint32_t SHIFT16 : 1;          /*!< [0] TX FIFO Shift-16 */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t IPCHK : 1;            /*!< [3]  */
        uint32_t PROCHK : 1;           /*!< [4]  */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_enet_tacc_t;

/*!
 * @name Constants and macros for entire ENET_TACC register
 */
/*@{*/
#define HW_ENET_TACC_ADDR(x)     ((uintptr_t)(x) + 0x1C0U)

#define HW_ENET_TACC(x)          (*(__IO hw_enet_tacc_t *) HW_ENET_TACC_ADDR(x))
#define HW_ENET_TACC_RD(x)       (HW_ENET_TACC(x).U)
#define HW_ENET_TACC_WR(x, v)    (HW_ENET_TACC(x).U = (v))
#define HW_ENET_TACC_SET(x, v)   (HW_ENET_TACC_WR(x, HW_ENET_TACC_RD(x) |  (v)))
#define HW_ENET_TACC_CLR(x, v)   (HW_ENET_TACC_WR(x, HW_ENET_TACC_RD(x) & ~(v)))
#define HW_ENET_TACC_TOG(x, v)   (HW_ENET_TACC_WR(x, HW_ENET_TACC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TACC bitfields
 */

/*!
 * @name Register ENET_TACC, field SHIFT16[0] (RW)
 *
 * Values:
 * - 0 - Disabled.
 * - 1 - Indicates to the transmit data FIFO that the written frames contain two
 *     additional octets before the frame data. This means the actual frame
 *     begins at bit 16 of the first word written into the FIFO. This function allows
 *     putting the frame payload on a 32-bit boundary in memory, as the 14-byte
 *     Ethernet header is extended to a 16-byte header.
 */
/*@{*/
#define BP_ENET_TACC_SHIFT16 (0U)          /*!< Bit position for ENET_TACC_SHIFT16. */
#define BM_ENET_TACC_SHIFT16 (0x00000001U) /*!< Bit mask for ENET_TACC_SHIFT16. */
#define BS_ENET_TACC_SHIFT16 (1U)          /*!< Bit field size in bits for ENET_TACC_SHIFT16. */

/*! @brief Read current value of the ENET_TACC_SHIFT16 field. */
#define BR_ENET_TACC_SHIFT16(x) (HW_ENET_TACC(x).B.SHIFT16)

/*! @brief Format value for bitfield ENET_TACC_SHIFT16. */
#define BF_ENET_TACC_SHIFT16(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TACC_SHIFT16) & BM_ENET_TACC_SHIFT16)

/*! @brief Set the SHIFT16 field to a new value. */
#define BW_ENET_TACC_SHIFT16(x, v) (HW_ENET_TACC_WR(x, (HW_ENET_TACC_RD(x) & ~BM_ENET_TACC_SHIFT16) | BF_ENET_TACC_SHIFT16(v)))
/*@}*/

/*!
 * @name Register ENET_TACC, field IPCHK[3] (RW)
 *
 * Enables insertion of IP header checksum.
 *
 * Values:
 * - 0 - Checksum is not inserted.
 * - 1 - If an IP frame is transmitted, the checksum is inserted automatically.
 *     The IP header checksum field must be cleared. If a non-IP frame is
 *     transmitted the frame is not modified.
 */
/*@{*/
#define BP_ENET_TACC_IPCHK   (3U)          /*!< Bit position for ENET_TACC_IPCHK. */
#define BM_ENET_TACC_IPCHK   (0x00000008U) /*!< Bit mask for ENET_TACC_IPCHK. */
#define BS_ENET_TACC_IPCHK   (1U)          /*!< Bit field size in bits for ENET_TACC_IPCHK. */

/*! @brief Read current value of the ENET_TACC_IPCHK field. */
#define BR_ENET_TACC_IPCHK(x) (HW_ENET_TACC(x).B.IPCHK)

/*! @brief Format value for bitfield ENET_TACC_IPCHK. */
#define BF_ENET_TACC_IPCHK(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TACC_IPCHK) & BM_ENET_TACC_IPCHK)

/*! @brief Set the IPCHK field to a new value. */
#define BW_ENET_TACC_IPCHK(x, v) (HW_ENET_TACC_WR(x, (HW_ENET_TACC_RD(x) & ~BM_ENET_TACC_IPCHK) | BF_ENET_TACC_IPCHK(v)))
/*@}*/

/*!
 * @name Register ENET_TACC, field PROCHK[4] (RW)
 *
 * Enables insertion of protocol checksum.
 *
 * Values:
 * - 0 - Checksum not inserted.
 * - 1 - If an IP frame with a known protocol is transmitted, the checksum is
 *     inserted automatically into the frame. The checksum field must be cleared.
 *     The other frames are not modified.
 */
/*@{*/
#define BP_ENET_TACC_PROCHK  (4U)          /*!< Bit position for ENET_TACC_PROCHK. */
#define BM_ENET_TACC_PROCHK  (0x00000010U) /*!< Bit mask for ENET_TACC_PROCHK. */
#define BS_ENET_TACC_PROCHK  (1U)          /*!< Bit field size in bits for ENET_TACC_PROCHK. */

/*! @brief Read current value of the ENET_TACC_PROCHK field. */
#define BR_ENET_TACC_PROCHK(x) (HW_ENET_TACC(x).B.PROCHK)

/*! @brief Format value for bitfield ENET_TACC_PROCHK. */
#define BF_ENET_TACC_PROCHK(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TACC_PROCHK) & BM_ENET_TACC_PROCHK)

/*! @brief Set the PROCHK field to a new value. */
#define BW_ENET_TACC_PROCHK(x, v) (HW_ENET_TACC_WR(x, (HW_ENET_TACC_RD(x) & ~BM_ENET_TACC_PROCHK) | BF_ENET_TACC_PROCHK(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RACC - Receive Accelerator Function Configuration
 ******************************************************************************/

/*!
 * @brief HW_ENET_RACC - Receive Accelerator Function Configuration (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_racc
{
    uint32_t U;
    struct _hw_enet_racc_bitfields
    {
        uint32_t PADREM : 1;           /*!< [0] Enable Padding Removal For Short IP
                                        * Frames */
        uint32_t IPDIS : 1;            /*!< [1] Enable Discard Of Frames With Wrong IPv4
                                        * Header Checksum */
        uint32_t PRODIS : 1;           /*!< [2] Enable Discard Of Frames With Wrong
                                        * Protocol Checksum */
        uint32_t RESERVED0 : 3;        /*!< [5:3]  */
        uint32_t LINEDIS : 1;          /*!< [6] Enable Discard Of Frames With MAC
                                        * Layer Errors */
        uint32_t SHIFT16 : 1;          /*!< [7] RX FIFO Shift-16 */
        uint32_t RESERVED1 : 24;       /*!< [31:8]  */
    } B;
} hw_enet_racc_t;

/*!
 * @name Constants and macros for entire ENET_RACC register
 */
/*@{*/
#define HW_ENET_RACC_ADDR(x)     ((uintptr_t)(x) + 0x1C4U)

#define HW_ENET_RACC(x)          (*(__IO hw_enet_racc_t *) HW_ENET_RACC_ADDR(x))
#define HW_ENET_RACC_RD(x)       (HW_ENET_RACC(x).U)
#define HW_ENET_RACC_WR(x, v)    (HW_ENET_RACC(x).U = (v))
#define HW_ENET_RACC_SET(x, v)   (HW_ENET_RACC_WR(x, HW_ENET_RACC_RD(x) |  (v)))
#define HW_ENET_RACC_CLR(x, v)   (HW_ENET_RACC_WR(x, HW_ENET_RACC_RD(x) & ~(v)))
#define HW_ENET_RACC_TOG(x, v)   (HW_ENET_RACC_WR(x, HW_ENET_RACC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_RACC bitfields
 */

/*!
 * @name Register ENET_RACC, field PADREM[0] (RW)
 *
 * Values:
 * - 0 - Padding not removed.
 * - 1 - Any bytes following the IP payload section of the frame are removed
 *     from the frame.
 */
/*@{*/
#define BP_ENET_RACC_PADREM  (0U)          /*!< Bit position for ENET_RACC_PADREM. */
#define BM_ENET_RACC_PADREM  (0x00000001U) /*!< Bit mask for ENET_RACC_PADREM. */
#define BS_ENET_RACC_PADREM  (1U)          /*!< Bit field size in bits for ENET_RACC_PADREM. */

/*! @brief Read current value of the ENET_RACC_PADREM field. */
#define BR_ENET_RACC_PADREM(x) (HW_ENET_RACC(x).B.PADREM)

/*! @brief Format value for bitfield ENET_RACC_PADREM. */
#define BF_ENET_RACC_PADREM(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RACC_PADREM) & BM_ENET_RACC_PADREM)

/*! @brief Set the PADREM field to a new value. */
#define BW_ENET_RACC_PADREM(x, v) (HW_ENET_RACC_WR(x, (HW_ENET_RACC_RD(x) & ~BM_ENET_RACC_PADREM) | BF_ENET_RACC_PADREM(v)))
/*@}*/

/*!
 * @name Register ENET_RACC, field IPDIS[1] (RW)
 *
 * Values:
 * - 0 - Frames with wrong IPv4 header checksum are not discarded.
 * - 1 - If an IPv4 frame is received with a mismatching header checksum, the
 *     frame is discarded. IPv6 has no header checksum and is not affected by this
 *     setting. Discarding is only available when the RX FIFO operates in store
 *     and forward mode (RSFL cleared).
 */
/*@{*/
#define BP_ENET_RACC_IPDIS   (1U)          /*!< Bit position for ENET_RACC_IPDIS. */
#define BM_ENET_RACC_IPDIS   (0x00000002U) /*!< Bit mask for ENET_RACC_IPDIS. */
#define BS_ENET_RACC_IPDIS   (1U)          /*!< Bit field size in bits for ENET_RACC_IPDIS. */

/*! @brief Read current value of the ENET_RACC_IPDIS field. */
#define BR_ENET_RACC_IPDIS(x) (HW_ENET_RACC(x).B.IPDIS)

/*! @brief Format value for bitfield ENET_RACC_IPDIS. */
#define BF_ENET_RACC_IPDIS(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RACC_IPDIS) & BM_ENET_RACC_IPDIS)

/*! @brief Set the IPDIS field to a new value. */
#define BW_ENET_RACC_IPDIS(x, v) (HW_ENET_RACC_WR(x, (HW_ENET_RACC_RD(x) & ~BM_ENET_RACC_IPDIS) | BF_ENET_RACC_IPDIS(v)))
/*@}*/

/*!
 * @name Register ENET_RACC, field PRODIS[2] (RW)
 *
 * Values:
 * - 0 - Frames with wrong checksum are not discarded.
 * - 1 - If a TCP/IP, UDP/IP, or ICMP/IP frame is received that has a wrong TCP,
 *     UDP, or ICMP checksum, the frame is discarded. Discarding is only
 *     available when the RX FIFO operates in store and forward mode (RSFL cleared).
 */
/*@{*/
#define BP_ENET_RACC_PRODIS  (2U)          /*!< Bit position for ENET_RACC_PRODIS. */
#define BM_ENET_RACC_PRODIS  (0x00000004U) /*!< Bit mask for ENET_RACC_PRODIS. */
#define BS_ENET_RACC_PRODIS  (1U)          /*!< Bit field size in bits for ENET_RACC_PRODIS. */

/*! @brief Read current value of the ENET_RACC_PRODIS field. */
#define BR_ENET_RACC_PRODIS(x) (HW_ENET_RACC(x).B.PRODIS)

/*! @brief Format value for bitfield ENET_RACC_PRODIS. */
#define BF_ENET_RACC_PRODIS(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RACC_PRODIS) & BM_ENET_RACC_PRODIS)

/*! @brief Set the PRODIS field to a new value. */
#define BW_ENET_RACC_PRODIS(x, v) (HW_ENET_RACC_WR(x, (HW_ENET_RACC_RD(x) & ~BM_ENET_RACC_PRODIS) | BF_ENET_RACC_PRODIS(v)))
/*@}*/

/*!
 * @name Register ENET_RACC, field LINEDIS[6] (RW)
 *
 * Values:
 * - 0 - Frames with errors are not discarded.
 * - 1 - Any frame received with a CRC, length, or PHY error is automatically
 *     discarded and not forwarded to the user application interface.
 */
/*@{*/
#define BP_ENET_RACC_LINEDIS (6U)          /*!< Bit position for ENET_RACC_LINEDIS. */
#define BM_ENET_RACC_LINEDIS (0x00000040U) /*!< Bit mask for ENET_RACC_LINEDIS. */
#define BS_ENET_RACC_LINEDIS (1U)          /*!< Bit field size in bits for ENET_RACC_LINEDIS. */

/*! @brief Read current value of the ENET_RACC_LINEDIS field. */
#define BR_ENET_RACC_LINEDIS(x) (HW_ENET_RACC(x).B.LINEDIS)

/*! @brief Format value for bitfield ENET_RACC_LINEDIS. */
#define BF_ENET_RACC_LINEDIS(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RACC_LINEDIS) & BM_ENET_RACC_LINEDIS)

/*! @brief Set the LINEDIS field to a new value. */
#define BW_ENET_RACC_LINEDIS(x, v) (HW_ENET_RACC_WR(x, (HW_ENET_RACC_RD(x) & ~BM_ENET_RACC_LINEDIS) | BF_ENET_RACC_LINEDIS(v)))
/*@}*/

/*!
 * @name Register ENET_RACC, field SHIFT16[7] (RW)
 *
 * When this field is set, the actual frame data starts at bit 16 of the first
 * word read from the RX FIFO aligning the Ethernet payload on a 32-bit boundary.
 * This function only affects the FIFO storage and has no influence on the
 * statistics, which use the actual length of the frame received.
 *
 * Values:
 * - 0 - Disabled.
 * - 1 - Instructs the MAC to write two additional bytes in front of each frame
 *     received into the RX FIFO.
 */
/*@{*/
#define BP_ENET_RACC_SHIFT16 (7U)          /*!< Bit position for ENET_RACC_SHIFT16. */
#define BM_ENET_RACC_SHIFT16 (0x00000080U) /*!< Bit mask for ENET_RACC_SHIFT16. */
#define BS_ENET_RACC_SHIFT16 (1U)          /*!< Bit field size in bits for ENET_RACC_SHIFT16. */

/*! @brief Read current value of the ENET_RACC_SHIFT16 field. */
#define BR_ENET_RACC_SHIFT16(x) (HW_ENET_RACC(x).B.SHIFT16)

/*! @brief Format value for bitfield ENET_RACC_SHIFT16. */
#define BF_ENET_RACC_SHIFT16(v) ((uint32_t)((uint32_t)(v) << BP_ENET_RACC_SHIFT16) & BM_ENET_RACC_SHIFT16)

/*! @brief Set the SHIFT16 field to a new value. */
#define BW_ENET_RACC_SHIFT16(x, v) (HW_ENET_RACC_WR(x, (HW_ENET_RACC_RD(x) & ~BM_ENET_RACC_SHIFT16) | BF_ENET_RACC_SHIFT16(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_DROP - Reserved Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_DROP - Reserved Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_drop
{
    uint32_t U;
    struct _hw_enet_rmon_t_drop_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0] This read-only field always has
                                        * the value 0. */
    } B;
} hw_enet_rmon_t_drop_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_DROP register
 */
/*@{*/
#define HW_ENET_RMON_T_DROP_ADDR(x) ((uintptr_t)(x) + 0x200U)

#define HW_ENET_RMON_T_DROP(x)   (*(__I hw_enet_rmon_t_drop_t *) HW_ENET_RMON_T_DROP_ADDR(x))
#define HW_ENET_RMON_T_DROP_RD(x) (HW_ENET_RMON_T_DROP(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_DROP bitfields
 */

/*******************************************************************************
 * HW_ENET_RMON_T_PACKETS - Tx Packet Count Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_PACKETS - Tx Packet Count Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_packets
{
    uint32_t U;
    struct _hw_enet_rmon_t_packets_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Packet count */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_packets_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_PACKETS register
 */
/*@{*/
#define HW_ENET_RMON_T_PACKETS_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_ENET_RMON_T_PACKETS(x) (*(__I hw_enet_rmon_t_packets_t *) HW_ENET_RMON_T_PACKETS_ADDR(x))
#define HW_ENET_RMON_T_PACKETS_RD(x) (HW_ENET_RMON_T_PACKETS(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_PACKETS bitfields
 */

/*!
 * @name Register ENET_RMON_T_PACKETS, field TXPKTS[15:0] (RO)
 *
 * Transmit packet count
 */
/*@{*/
#define BP_ENET_RMON_T_PACKETS_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_PACKETS_TXPKTS. */
#define BM_ENET_RMON_T_PACKETS_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_PACKETS_TXPKTS. */
#define BS_ENET_RMON_T_PACKETS_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_PACKETS_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_PACKETS_TXPKTS field. */
#define BR_ENET_RMON_T_PACKETS_TXPKTS(x) (HW_ENET_RMON_T_PACKETS(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_BC_PKT - Tx Broadcast Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_BC_PKT - Tx Broadcast Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * RMON Tx Broadcast Packets
 */
typedef union _hw_enet_rmon_t_bc_pkt
{
    uint32_t U;
    struct _hw_enet_rmon_t_bc_pkt_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Broadcast packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_bc_pkt_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_BC_PKT register
 */
/*@{*/
#define HW_ENET_RMON_T_BC_PKT_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_ENET_RMON_T_BC_PKT(x) (*(__I hw_enet_rmon_t_bc_pkt_t *) HW_ENET_RMON_T_BC_PKT_ADDR(x))
#define HW_ENET_RMON_T_BC_PKT_RD(x) (HW_ENET_RMON_T_BC_PKT(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_BC_PKT bitfields
 */

/*!
 * @name Register ENET_RMON_T_BC_PKT, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_BC_PKT_TXPKTS (0U)  /*!< Bit position for ENET_RMON_T_BC_PKT_TXPKTS. */
#define BM_ENET_RMON_T_BC_PKT_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_BC_PKT_TXPKTS. */
#define BS_ENET_RMON_T_BC_PKT_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_BC_PKT_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_BC_PKT_TXPKTS field. */
#define BR_ENET_RMON_T_BC_PKT_TXPKTS(x) (HW_ENET_RMON_T_BC_PKT(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_MC_PKT - Tx Multicast Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_MC_PKT - Tx Multicast Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_mc_pkt
{
    uint32_t U;
    struct _hw_enet_rmon_t_mc_pkt_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Multicast packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_mc_pkt_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_MC_PKT register
 */
/*@{*/
#define HW_ENET_RMON_T_MC_PKT_ADDR(x) ((uintptr_t)(x) + 0x20CU)

#define HW_ENET_RMON_T_MC_PKT(x) (*(__I hw_enet_rmon_t_mc_pkt_t *) HW_ENET_RMON_T_MC_PKT_ADDR(x))
#define HW_ENET_RMON_T_MC_PKT_RD(x) (HW_ENET_RMON_T_MC_PKT(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_MC_PKT bitfields
 */

/*!
 * @name Register ENET_RMON_T_MC_PKT, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_MC_PKT_TXPKTS (0U)  /*!< Bit position for ENET_RMON_T_MC_PKT_TXPKTS. */
#define BM_ENET_RMON_T_MC_PKT_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_MC_PKT_TXPKTS. */
#define BS_ENET_RMON_T_MC_PKT_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_MC_PKT_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_MC_PKT_TXPKTS field. */
#define BR_ENET_RMON_T_MC_PKT_TXPKTS(x) (HW_ENET_RMON_T_MC_PKT(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_CRC_ALIGN - Tx Packets with CRC/Align Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_CRC_ALIGN - Tx Packets with CRC/Align Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_crc_align
{
    uint32_t U;
    struct _hw_enet_rmon_t_crc_align_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Packets with CRC/align error */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_crc_align_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_CRC_ALIGN register
 */
/*@{*/
#define HW_ENET_RMON_T_CRC_ALIGN_ADDR(x) ((uintptr_t)(x) + 0x210U)

#define HW_ENET_RMON_T_CRC_ALIGN(x) (*(__I hw_enet_rmon_t_crc_align_t *) HW_ENET_RMON_T_CRC_ALIGN_ADDR(x))
#define HW_ENET_RMON_T_CRC_ALIGN_RD(x) (HW_ENET_RMON_T_CRC_ALIGN(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_CRC_ALIGN bitfields
 */

/*!
 * @name Register ENET_RMON_T_CRC_ALIGN, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_CRC_ALIGN_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_CRC_ALIGN_TXPKTS. */
#define BM_ENET_RMON_T_CRC_ALIGN_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_CRC_ALIGN_TXPKTS. */
#define BS_ENET_RMON_T_CRC_ALIGN_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_CRC_ALIGN_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_CRC_ALIGN_TXPKTS field. */
#define BR_ENET_RMON_T_CRC_ALIGN_TXPKTS(x) (HW_ENET_RMON_T_CRC_ALIGN(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_UNDERSIZE - Tx Packets Less Than Bytes and Good CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_UNDERSIZE - Tx Packets Less Than Bytes and Good CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_undersize
{
    uint32_t U;
    struct _hw_enet_rmon_t_undersize_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of transmit packets less
                                        * than 64 bytes with good CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_undersize_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_UNDERSIZE register
 */
/*@{*/
#define HW_ENET_RMON_T_UNDERSIZE_ADDR(x) ((uintptr_t)(x) + 0x214U)

#define HW_ENET_RMON_T_UNDERSIZE(x) (*(__I hw_enet_rmon_t_undersize_t *) HW_ENET_RMON_T_UNDERSIZE_ADDR(x))
#define HW_ENET_RMON_T_UNDERSIZE_RD(x) (HW_ENET_RMON_T_UNDERSIZE(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_UNDERSIZE bitfields
 */

/*!
 * @name Register ENET_RMON_T_UNDERSIZE, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_UNDERSIZE_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_UNDERSIZE_TXPKTS. */
#define BM_ENET_RMON_T_UNDERSIZE_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_UNDERSIZE_TXPKTS. */
#define BS_ENET_RMON_T_UNDERSIZE_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_UNDERSIZE_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_UNDERSIZE_TXPKTS field. */
#define BR_ENET_RMON_T_UNDERSIZE_TXPKTS(x) (HW_ENET_RMON_T_UNDERSIZE(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_OVERSIZE - Tx Packets GT MAX_FL bytes and Good CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_OVERSIZE - Tx Packets GT MAX_FL bytes and Good CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_oversize
{
    uint32_t U;
    struct _hw_enet_rmon_t_oversize_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of transmit packets greater
                                        * than MAX_FL bytes with good CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_oversize_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_OVERSIZE register
 */
/*@{*/
#define HW_ENET_RMON_T_OVERSIZE_ADDR(x) ((uintptr_t)(x) + 0x218U)

#define HW_ENET_RMON_T_OVERSIZE(x) (*(__I hw_enet_rmon_t_oversize_t *) HW_ENET_RMON_T_OVERSIZE_ADDR(x))
#define HW_ENET_RMON_T_OVERSIZE_RD(x) (HW_ENET_RMON_T_OVERSIZE(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_OVERSIZE bitfields
 */

/*!
 * @name Register ENET_RMON_T_OVERSIZE, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_OVERSIZE_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_OVERSIZE_TXPKTS. */
#define BM_ENET_RMON_T_OVERSIZE_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_OVERSIZE_TXPKTS. */
#define BS_ENET_RMON_T_OVERSIZE_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_OVERSIZE_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_OVERSIZE_TXPKTS field. */
#define BR_ENET_RMON_T_OVERSIZE_TXPKTS(x) (HW_ENET_RMON_T_OVERSIZE(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_FRAG - Tx Packets Less Than 64 Bytes and Bad CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_FRAG - Tx Packets Less Than 64 Bytes and Bad CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * .
 */
typedef union _hw_enet_rmon_t_frag
{
    uint32_t U;
    struct _hw_enet_rmon_t_frag_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of packets less than 64
                                        * bytes with bad CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_frag_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_FRAG register
 */
/*@{*/
#define HW_ENET_RMON_T_FRAG_ADDR(x) ((uintptr_t)(x) + 0x21CU)

#define HW_ENET_RMON_T_FRAG(x)   (*(__I hw_enet_rmon_t_frag_t *) HW_ENET_RMON_T_FRAG_ADDR(x))
#define HW_ENET_RMON_T_FRAG_RD(x) (HW_ENET_RMON_T_FRAG(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_FRAG bitfields
 */

/*!
 * @name Register ENET_RMON_T_FRAG, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_FRAG_TXPKTS (0U)    /*!< Bit position for ENET_RMON_T_FRAG_TXPKTS. */
#define BM_ENET_RMON_T_FRAG_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_FRAG_TXPKTS. */
#define BS_ENET_RMON_T_FRAG_TXPKTS (16U)   /*!< Bit field size in bits for ENET_RMON_T_FRAG_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_FRAG_TXPKTS field. */
#define BR_ENET_RMON_T_FRAG_TXPKTS(x) (HW_ENET_RMON_T_FRAG(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_JAB - Tx Packets Greater Than MAX_FL bytes and Bad CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_JAB - Tx Packets Greater Than MAX_FL bytes and Bad CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_jab
{
    uint32_t U;
    struct _hw_enet_rmon_t_jab_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of transmit packets greater
                                        * than MAX_FL bytes and bad CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_jab_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_JAB register
 */
/*@{*/
#define HW_ENET_RMON_T_JAB_ADDR(x) ((uintptr_t)(x) + 0x220U)

#define HW_ENET_RMON_T_JAB(x)    (*(__I hw_enet_rmon_t_jab_t *) HW_ENET_RMON_T_JAB_ADDR(x))
#define HW_ENET_RMON_T_JAB_RD(x) (HW_ENET_RMON_T_JAB(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_JAB bitfields
 */

/*!
 * @name Register ENET_RMON_T_JAB, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_JAB_TXPKTS (0U)     /*!< Bit position for ENET_RMON_T_JAB_TXPKTS. */
#define BM_ENET_RMON_T_JAB_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_JAB_TXPKTS. */
#define BS_ENET_RMON_T_JAB_TXPKTS (16U)    /*!< Bit field size in bits for ENET_RMON_T_JAB_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_JAB_TXPKTS field. */
#define BR_ENET_RMON_T_JAB_TXPKTS(x) (HW_ENET_RMON_T_JAB(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_COL - Tx Collision Count Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_COL - Tx Collision Count Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_col
{
    uint32_t U;
    struct _hw_enet_rmon_t_col_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of transmit collisions */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_col_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_COL register
 */
/*@{*/
#define HW_ENET_RMON_T_COL_ADDR(x) ((uintptr_t)(x) + 0x224U)

#define HW_ENET_RMON_T_COL(x)    (*(__I hw_enet_rmon_t_col_t *) HW_ENET_RMON_T_COL_ADDR(x))
#define HW_ENET_RMON_T_COL_RD(x) (HW_ENET_RMON_T_COL(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_COL bitfields
 */

/*!
 * @name Register ENET_RMON_T_COL, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_COL_TXPKTS (0U)     /*!< Bit position for ENET_RMON_T_COL_TXPKTS. */
#define BM_ENET_RMON_T_COL_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_COL_TXPKTS. */
#define BS_ENET_RMON_T_COL_TXPKTS (16U)    /*!< Bit field size in bits for ENET_RMON_T_COL_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_COL_TXPKTS field. */
#define BR_ENET_RMON_T_COL_TXPKTS(x) (HW_ENET_RMON_T_COL(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P64 - Tx 64-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P64 - Tx 64-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * .
 */
typedef union _hw_enet_rmon_t_p64
{
    uint32_t U;
    struct _hw_enet_rmon_t_p64_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 64-byte transmit packets
                                        * */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p64_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P64 register
 */
/*@{*/
#define HW_ENET_RMON_T_P64_ADDR(x) ((uintptr_t)(x) + 0x228U)

#define HW_ENET_RMON_T_P64(x)    (*(__I hw_enet_rmon_t_p64_t *) HW_ENET_RMON_T_P64_ADDR(x))
#define HW_ENET_RMON_T_P64_RD(x) (HW_ENET_RMON_T_P64(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P64 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P64, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P64_TXPKTS (0U)     /*!< Bit position for ENET_RMON_T_P64_TXPKTS. */
#define BM_ENET_RMON_T_P64_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P64_TXPKTS. */
#define BS_ENET_RMON_T_P64_TXPKTS (16U)    /*!< Bit field size in bits for ENET_RMON_T_P64_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P64_TXPKTS field. */
#define BR_ENET_RMON_T_P64_TXPKTS(x) (HW_ENET_RMON_T_P64(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P65TO127 - Tx 65- to 127-byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P65TO127 - Tx 65- to 127-byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_p65to127
{
    uint32_t U;
    struct _hw_enet_rmon_t_p65to127_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 65- to 127-byte transmit
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p65to127_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P65TO127 register
 */
/*@{*/
#define HW_ENET_RMON_T_P65TO127_ADDR(x) ((uintptr_t)(x) + 0x22CU)

#define HW_ENET_RMON_T_P65TO127(x) (*(__I hw_enet_rmon_t_p65to127_t *) HW_ENET_RMON_T_P65TO127_ADDR(x))
#define HW_ENET_RMON_T_P65TO127_RD(x) (HW_ENET_RMON_T_P65TO127(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P65TO127 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P65TO127, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P65TO127_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P65TO127_TXPKTS. */
#define BM_ENET_RMON_T_P65TO127_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P65TO127_TXPKTS. */
#define BS_ENET_RMON_T_P65TO127_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P65TO127_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P65TO127_TXPKTS field. */
#define BR_ENET_RMON_T_P65TO127_TXPKTS(x) (HW_ENET_RMON_T_P65TO127(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P128TO255 - Tx 128- to 255-byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P128TO255 - Tx 128- to 255-byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_p128to255
{
    uint32_t U;
    struct _hw_enet_rmon_t_p128to255_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 128- to 255-byte transmit
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p128to255_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P128TO255 register
 */
/*@{*/
#define HW_ENET_RMON_T_P128TO255_ADDR(x) ((uintptr_t)(x) + 0x230U)

#define HW_ENET_RMON_T_P128TO255(x) (*(__I hw_enet_rmon_t_p128to255_t *) HW_ENET_RMON_T_P128TO255_ADDR(x))
#define HW_ENET_RMON_T_P128TO255_RD(x) (HW_ENET_RMON_T_P128TO255(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P128TO255 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P128TO255, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P128TO255_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P128TO255_TXPKTS. */
#define BM_ENET_RMON_T_P128TO255_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P128TO255_TXPKTS. */
#define BS_ENET_RMON_T_P128TO255_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P128TO255_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P128TO255_TXPKTS field. */
#define BR_ENET_RMON_T_P128TO255_TXPKTS(x) (HW_ENET_RMON_T_P128TO255(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P256TO511 - Tx 256- to 511-byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P256TO511 - Tx 256- to 511-byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_p256to511
{
    uint32_t U;
    struct _hw_enet_rmon_t_p256to511_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 256- to 511-byte transmit
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p256to511_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P256TO511 register
 */
/*@{*/
#define HW_ENET_RMON_T_P256TO511_ADDR(x) ((uintptr_t)(x) + 0x234U)

#define HW_ENET_RMON_T_P256TO511(x) (*(__I hw_enet_rmon_t_p256to511_t *) HW_ENET_RMON_T_P256TO511_ADDR(x))
#define HW_ENET_RMON_T_P256TO511_RD(x) (HW_ENET_RMON_T_P256TO511(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P256TO511 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P256TO511, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P256TO511_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P256TO511_TXPKTS. */
#define BM_ENET_RMON_T_P256TO511_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P256TO511_TXPKTS. */
#define BS_ENET_RMON_T_P256TO511_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P256TO511_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P256TO511_TXPKTS field. */
#define BR_ENET_RMON_T_P256TO511_TXPKTS(x) (HW_ENET_RMON_T_P256TO511(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P512TO1023 - Tx 512- to 1023-byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P512TO1023 - Tx 512- to 1023-byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * .
 */
typedef union _hw_enet_rmon_t_p512to1023
{
    uint32_t U;
    struct _hw_enet_rmon_t_p512to1023_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 512- to 1023-byte
                                        * transmit packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p512to1023_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P512TO1023 register
 */
/*@{*/
#define HW_ENET_RMON_T_P512TO1023_ADDR(x) ((uintptr_t)(x) + 0x238U)

#define HW_ENET_RMON_T_P512TO1023(x) (*(__I hw_enet_rmon_t_p512to1023_t *) HW_ENET_RMON_T_P512TO1023_ADDR(x))
#define HW_ENET_RMON_T_P512TO1023_RD(x) (HW_ENET_RMON_T_P512TO1023(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P512TO1023 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P512TO1023, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P512TO1023_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P512TO1023_TXPKTS. */
#define BM_ENET_RMON_T_P512TO1023_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P512TO1023_TXPKTS. */
#define BS_ENET_RMON_T_P512TO1023_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P512TO1023_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P512TO1023_TXPKTS field. */
#define BR_ENET_RMON_T_P512TO1023_TXPKTS(x) (HW_ENET_RMON_T_P512TO1023(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P1024TO2047 - Tx 1024- to 2047-byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P1024TO2047 - Tx 1024- to 2047-byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_p1024to2047
{
    uint32_t U;
    struct _hw_enet_rmon_t_p1024to2047_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of 1024- to 2047-byte
                                        * transmit packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p1024to2047_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P1024TO2047 register
 */
/*@{*/
#define HW_ENET_RMON_T_P1024TO2047_ADDR(x) ((uintptr_t)(x) + 0x23CU)

#define HW_ENET_RMON_T_P1024TO2047(x) (*(__I hw_enet_rmon_t_p1024to2047_t *) HW_ENET_RMON_T_P1024TO2047_ADDR(x))
#define HW_ENET_RMON_T_P1024TO2047_RD(x) (HW_ENET_RMON_T_P1024TO2047(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P1024TO2047 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P1024TO2047, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P1024TO2047_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P1024TO2047_TXPKTS. */
#define BM_ENET_RMON_T_P1024TO2047_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P1024TO2047_TXPKTS. */
#define BS_ENET_RMON_T_P1024TO2047_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P1024TO2047_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P1024TO2047_TXPKTS field. */
#define BR_ENET_RMON_T_P1024TO2047_TXPKTS(x) (HW_ENET_RMON_T_P1024TO2047(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_P_GTE2048 - Tx Packets Greater Than 2048 Bytes Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_P_GTE2048 - Tx Packets Greater Than 2048 Bytes Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_p_gte2048
{
    uint32_t U;
    struct _hw_enet_rmon_t_p_gte2048_bitfields
    {
        uint32_t TXPKTS : 16;          /*!< [15:0] Number of transmit packets greater
                                        * than 2048 bytes */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_t_p_gte2048_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_P_GTE2048 register
 */
/*@{*/
#define HW_ENET_RMON_T_P_GTE2048_ADDR(x) ((uintptr_t)(x) + 0x240U)

#define HW_ENET_RMON_T_P_GTE2048(x) (*(__I hw_enet_rmon_t_p_gte2048_t *) HW_ENET_RMON_T_P_GTE2048_ADDR(x))
#define HW_ENET_RMON_T_P_GTE2048_RD(x) (HW_ENET_RMON_T_P_GTE2048(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_P_GTE2048 bitfields
 */

/*!
 * @name Register ENET_RMON_T_P_GTE2048, field TXPKTS[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_P_GTE2048_TXPKTS (0U) /*!< Bit position for ENET_RMON_T_P_GTE2048_TXPKTS. */
#define BM_ENET_RMON_T_P_GTE2048_TXPKTS (0x0000FFFFU) /*!< Bit mask for ENET_RMON_T_P_GTE2048_TXPKTS. */
#define BS_ENET_RMON_T_P_GTE2048_TXPKTS (16U) /*!< Bit field size in bits for ENET_RMON_T_P_GTE2048_TXPKTS. */

/*! @brief Read current value of the ENET_RMON_T_P_GTE2048_TXPKTS field. */
#define BR_ENET_RMON_T_P_GTE2048_TXPKTS(x) (HW_ENET_RMON_T_P_GTE2048(x).B.TXPKTS)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_T_OCTETS - Tx Octets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_T_OCTETS - Tx Octets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_t_octets
{
    uint32_t U;
    struct _hw_enet_rmon_t_octets_bitfields
    {
        uint32_t TXOCTS : 32;          /*!< [31:0] Number of transmit octets */
    } B;
} hw_enet_rmon_t_octets_t;

/*!
 * @name Constants and macros for entire ENET_RMON_T_OCTETS register
 */
/*@{*/
#define HW_ENET_RMON_T_OCTETS_ADDR(x) ((uintptr_t)(x) + 0x244U)

#define HW_ENET_RMON_T_OCTETS(x) (*(__I hw_enet_rmon_t_octets_t *) HW_ENET_RMON_T_OCTETS_ADDR(x))
#define HW_ENET_RMON_T_OCTETS_RD(x) (HW_ENET_RMON_T_OCTETS(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_T_OCTETS bitfields
 */

/*!
 * @name Register ENET_RMON_T_OCTETS, field TXOCTS[31:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_T_OCTETS_TXOCTS (0U)  /*!< Bit position for ENET_RMON_T_OCTETS_TXOCTS. */
#define BM_ENET_RMON_T_OCTETS_TXOCTS (0xFFFFFFFFU) /*!< Bit mask for ENET_RMON_T_OCTETS_TXOCTS. */
#define BS_ENET_RMON_T_OCTETS_TXOCTS (32U) /*!< Bit field size in bits for ENET_RMON_T_OCTETS_TXOCTS. */

/*! @brief Read current value of the ENET_RMON_T_OCTETS_TXOCTS field. */
#define BR_ENET_RMON_T_OCTETS_TXOCTS(x) (HW_ENET_RMON_T_OCTETS(x).U)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_DROP - Reserved Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_DROP - Reserved Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_drop
{
    uint32_t U;
    struct _hw_enet_ieee_t_drop_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0] This read-only field always has
                                        * the value 0. */
    } B;
} hw_enet_ieee_t_drop_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_DROP register
 */
/*@{*/
#define HW_ENET_IEEE_T_DROP_ADDR(x) ((uintptr_t)(x) + 0x248U)

#define HW_ENET_IEEE_T_DROP(x)   (*(__I hw_enet_ieee_t_drop_t *) HW_ENET_IEEE_T_DROP_ADDR(x))
#define HW_ENET_IEEE_T_DROP_RD(x) (HW_ENET_IEEE_T_DROP(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_DROP bitfields
 */

/*******************************************************************************
 * HW_ENET_IEEE_T_FRAME_OK - Frames Transmitted OK Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_FRAME_OK - Frames Transmitted OK Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_frame_ok
{
    uint32_t U;
    struct _hw_enet_ieee_t_frame_ok_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted OK */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_frame_ok_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_FRAME_OK register
 */
/*@{*/
#define HW_ENET_IEEE_T_FRAME_OK_ADDR(x) ((uintptr_t)(x) + 0x24CU)

#define HW_ENET_IEEE_T_FRAME_OK(x) (*(__I hw_enet_ieee_t_frame_ok_t *) HW_ENET_IEEE_T_FRAME_OK_ADDR(x))
#define HW_ENET_IEEE_T_FRAME_OK_RD(x) (HW_ENET_IEEE_T_FRAME_OK(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_FRAME_OK bitfields
 */

/*!
 * @name Register ENET_IEEE_T_FRAME_OK, field COUNT[15:0] (RO)
 *
 * Does not increment for the broadcast frames when broadcast reject is enabled
 * and promiscuous mode is disabled within the receive control register (RCR).
 */
/*@{*/
#define BP_ENET_IEEE_T_FRAME_OK_COUNT (0U) /*!< Bit position for ENET_IEEE_T_FRAME_OK_COUNT. */
#define BM_ENET_IEEE_T_FRAME_OK_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_FRAME_OK_COUNT. */
#define BS_ENET_IEEE_T_FRAME_OK_COUNT (16U) /*!< Bit field size in bits for ENET_IEEE_T_FRAME_OK_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_FRAME_OK_COUNT field. */
#define BR_ENET_IEEE_T_FRAME_OK_COUNT(x) (HW_ENET_IEEE_T_FRAME_OK(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_1COL - Frames Transmitted with Single Collision Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_1COL - Frames Transmitted with Single Collision Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_1col
{
    uint32_t U;
    struct _hw_enet_ieee_t_1col_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * one collision */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_1col_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_1COL register
 */
/*@{*/
#define HW_ENET_IEEE_T_1COL_ADDR(x) ((uintptr_t)(x) + 0x250U)

#define HW_ENET_IEEE_T_1COL(x)   (*(__I hw_enet_ieee_t_1col_t *) HW_ENET_IEEE_T_1COL_ADDR(x))
#define HW_ENET_IEEE_T_1COL_RD(x) (HW_ENET_IEEE_T_1COL(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_1COL bitfields
 */

/*!
 * @name Register ENET_IEEE_T_1COL, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_1COL_COUNT (0U)     /*!< Bit position for ENET_IEEE_T_1COL_COUNT. */
#define BM_ENET_IEEE_T_1COL_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_1COL_COUNT. */
#define BS_ENET_IEEE_T_1COL_COUNT (16U)    /*!< Bit field size in bits for ENET_IEEE_T_1COL_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_1COL_COUNT field. */
#define BR_ENET_IEEE_T_1COL_COUNT(x) (HW_ENET_IEEE_T_1COL(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_MCOL - Frames Transmitted with Multiple Collisions Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_MCOL - Frames Transmitted with Multiple Collisions Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_mcol
{
    uint32_t U;
    struct _hw_enet_ieee_t_mcol_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * multiple collisions */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_mcol_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_MCOL register
 */
/*@{*/
#define HW_ENET_IEEE_T_MCOL_ADDR(x) ((uintptr_t)(x) + 0x254U)

#define HW_ENET_IEEE_T_MCOL(x)   (*(__I hw_enet_ieee_t_mcol_t *) HW_ENET_IEEE_T_MCOL_ADDR(x))
#define HW_ENET_IEEE_T_MCOL_RD(x) (HW_ENET_IEEE_T_MCOL(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_MCOL bitfields
 */

/*!
 * @name Register ENET_IEEE_T_MCOL, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_MCOL_COUNT (0U)     /*!< Bit position for ENET_IEEE_T_MCOL_COUNT. */
#define BM_ENET_IEEE_T_MCOL_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_MCOL_COUNT. */
#define BS_ENET_IEEE_T_MCOL_COUNT (16U)    /*!< Bit field size in bits for ENET_IEEE_T_MCOL_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_MCOL_COUNT field. */
#define BR_ENET_IEEE_T_MCOL_COUNT(x) (HW_ENET_IEEE_T_MCOL(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_DEF - Frames Transmitted after Deferral Delay Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_DEF - Frames Transmitted after Deferral Delay Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_def
{
    uint32_t U;
    struct _hw_enet_ieee_t_def_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * deferral delay */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_def_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_DEF register
 */
/*@{*/
#define HW_ENET_IEEE_T_DEF_ADDR(x) ((uintptr_t)(x) + 0x258U)

#define HW_ENET_IEEE_T_DEF(x)    (*(__I hw_enet_ieee_t_def_t *) HW_ENET_IEEE_T_DEF_ADDR(x))
#define HW_ENET_IEEE_T_DEF_RD(x) (HW_ENET_IEEE_T_DEF(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_DEF bitfields
 */

/*!
 * @name Register ENET_IEEE_T_DEF, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_DEF_COUNT (0U)      /*!< Bit position for ENET_IEEE_T_DEF_COUNT. */
#define BM_ENET_IEEE_T_DEF_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_DEF_COUNT. */
#define BS_ENET_IEEE_T_DEF_COUNT (16U)     /*!< Bit field size in bits for ENET_IEEE_T_DEF_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_DEF_COUNT field. */
#define BR_ENET_IEEE_T_DEF_COUNT(x) (HW_ENET_IEEE_T_DEF(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_LCOL - Frames Transmitted with Late Collision Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_LCOL - Frames Transmitted with Late Collision Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_lcol
{
    uint32_t U;
    struct _hw_enet_ieee_t_lcol_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * late collision */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_lcol_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_LCOL register
 */
/*@{*/
#define HW_ENET_IEEE_T_LCOL_ADDR(x) ((uintptr_t)(x) + 0x25CU)

#define HW_ENET_IEEE_T_LCOL(x)   (*(__I hw_enet_ieee_t_lcol_t *) HW_ENET_IEEE_T_LCOL_ADDR(x))
#define HW_ENET_IEEE_T_LCOL_RD(x) (HW_ENET_IEEE_T_LCOL(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_LCOL bitfields
 */

/*!
 * @name Register ENET_IEEE_T_LCOL, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_LCOL_COUNT (0U)     /*!< Bit position for ENET_IEEE_T_LCOL_COUNT. */
#define BM_ENET_IEEE_T_LCOL_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_LCOL_COUNT. */
#define BS_ENET_IEEE_T_LCOL_COUNT (16U)    /*!< Bit field size in bits for ENET_IEEE_T_LCOL_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_LCOL_COUNT field. */
#define BR_ENET_IEEE_T_LCOL_COUNT(x) (HW_ENET_IEEE_T_LCOL(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_EXCOL - Frames Transmitted with Excessive Collisions Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_EXCOL - Frames Transmitted with Excessive Collisions Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_excol
{
    uint32_t U;
    struct _hw_enet_ieee_t_excol_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * excessive collisions */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_excol_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_EXCOL register
 */
/*@{*/
#define HW_ENET_IEEE_T_EXCOL_ADDR(x) ((uintptr_t)(x) + 0x260U)

#define HW_ENET_IEEE_T_EXCOL(x)  (*(__I hw_enet_ieee_t_excol_t *) HW_ENET_IEEE_T_EXCOL_ADDR(x))
#define HW_ENET_IEEE_T_EXCOL_RD(x) (HW_ENET_IEEE_T_EXCOL(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_EXCOL bitfields
 */

/*!
 * @name Register ENET_IEEE_T_EXCOL, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_EXCOL_COUNT (0U)    /*!< Bit position for ENET_IEEE_T_EXCOL_COUNT. */
#define BM_ENET_IEEE_T_EXCOL_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_EXCOL_COUNT. */
#define BS_ENET_IEEE_T_EXCOL_COUNT (16U)   /*!< Bit field size in bits for ENET_IEEE_T_EXCOL_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_EXCOL_COUNT field. */
#define BR_ENET_IEEE_T_EXCOL_COUNT(x) (HW_ENET_IEEE_T_EXCOL(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_MACERR - Frames Transmitted with Tx FIFO Underrun Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_MACERR - Frames Transmitted with Tx FIFO Underrun Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_macerr
{
    uint32_t U;
    struct _hw_enet_ieee_t_macerr_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * transmit FIFO underrun */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_macerr_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_MACERR register
 */
/*@{*/
#define HW_ENET_IEEE_T_MACERR_ADDR(x) ((uintptr_t)(x) + 0x264U)

#define HW_ENET_IEEE_T_MACERR(x) (*(__I hw_enet_ieee_t_macerr_t *) HW_ENET_IEEE_T_MACERR_ADDR(x))
#define HW_ENET_IEEE_T_MACERR_RD(x) (HW_ENET_IEEE_T_MACERR(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_MACERR bitfields
 */

/*!
 * @name Register ENET_IEEE_T_MACERR, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_MACERR_COUNT (0U)   /*!< Bit position for ENET_IEEE_T_MACERR_COUNT. */
#define BM_ENET_IEEE_T_MACERR_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_MACERR_COUNT. */
#define BS_ENET_IEEE_T_MACERR_COUNT (16U)  /*!< Bit field size in bits for ENET_IEEE_T_MACERR_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_MACERR_COUNT field. */
#define BR_ENET_IEEE_T_MACERR_COUNT(x) (HW_ENET_IEEE_T_MACERR(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_CSERR - Frames Transmitted with Carrier Sense Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_CSERR - Frames Transmitted with Carrier Sense Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_cserr
{
    uint32_t U;
    struct _hw_enet_ieee_t_cserr_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames transmitted with
                                        * carrier sense error */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_cserr_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_CSERR register
 */
/*@{*/
#define HW_ENET_IEEE_T_CSERR_ADDR(x) ((uintptr_t)(x) + 0x268U)

#define HW_ENET_IEEE_T_CSERR(x)  (*(__I hw_enet_ieee_t_cserr_t *) HW_ENET_IEEE_T_CSERR_ADDR(x))
#define HW_ENET_IEEE_T_CSERR_RD(x) (HW_ENET_IEEE_T_CSERR(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_CSERR bitfields
 */

/*!
 * @name Register ENET_IEEE_T_CSERR, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_CSERR_COUNT (0U)    /*!< Bit position for ENET_IEEE_T_CSERR_COUNT. */
#define BM_ENET_IEEE_T_CSERR_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_CSERR_COUNT. */
#define BS_ENET_IEEE_T_CSERR_COUNT (16U)   /*!< Bit field size in bits for ENET_IEEE_T_CSERR_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_CSERR_COUNT field. */
#define BR_ENET_IEEE_T_CSERR_COUNT(x) (HW_ENET_IEEE_T_CSERR(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_SQE - Reserved Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_SQE - Reserved Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_sqe
{
    uint32_t U;
    struct _hw_enet_ieee_t_sqe_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_sqe_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_SQE register
 */
/*@{*/
#define HW_ENET_IEEE_T_SQE_ADDR(x) ((uintptr_t)(x) + 0x26CU)

#define HW_ENET_IEEE_T_SQE(x)    (*(__I hw_enet_ieee_t_sqe_t *) HW_ENET_IEEE_T_SQE_ADDR(x))
#define HW_ENET_IEEE_T_SQE_RD(x) (HW_ENET_IEEE_T_SQE(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_SQE bitfields
 */

/*!
 * @name Register ENET_IEEE_T_SQE, field COUNT[15:0] (RO)
 *
 * This read-only field is reserved and always has the value 0. Counter not
 * implemented as no SQE information is available.
 */
/*@{*/
#define BP_ENET_IEEE_T_SQE_COUNT (0U)      /*!< Bit position for ENET_IEEE_T_SQE_COUNT. */
#define BM_ENET_IEEE_T_SQE_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_SQE_COUNT. */
#define BS_ENET_IEEE_T_SQE_COUNT (16U)     /*!< Bit field size in bits for ENET_IEEE_T_SQE_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_SQE_COUNT field. */
#define BR_ENET_IEEE_T_SQE_COUNT(x) (HW_ENET_IEEE_T_SQE(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_FDXFC - Flow Control Pause Frames Transmitted Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_FDXFC - Flow Control Pause Frames Transmitted Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_fdxfc
{
    uint32_t U;
    struct _hw_enet_ieee_t_fdxfc_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of flow-control pause frames
                                        * transmitted */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_t_fdxfc_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_FDXFC register
 */
/*@{*/
#define HW_ENET_IEEE_T_FDXFC_ADDR(x) ((uintptr_t)(x) + 0x270U)

#define HW_ENET_IEEE_T_FDXFC(x)  (*(__I hw_enet_ieee_t_fdxfc_t *) HW_ENET_IEEE_T_FDXFC_ADDR(x))
#define HW_ENET_IEEE_T_FDXFC_RD(x) (HW_ENET_IEEE_T_FDXFC(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_FDXFC bitfields
 */

/*!
 * @name Register ENET_IEEE_T_FDXFC, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_FDXFC_COUNT (0U)    /*!< Bit position for ENET_IEEE_T_FDXFC_COUNT. */
#define BM_ENET_IEEE_T_FDXFC_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_T_FDXFC_COUNT. */
#define BS_ENET_IEEE_T_FDXFC_COUNT (16U)   /*!< Bit field size in bits for ENET_IEEE_T_FDXFC_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_FDXFC_COUNT field. */
#define BR_ENET_IEEE_T_FDXFC_COUNT(x) (HW_ENET_IEEE_T_FDXFC(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_T_OCTETS_OK - Octet Count for Frames Transmitted w/o Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_T_OCTETS_OK - Octet Count for Frames Transmitted w/o Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_t_octets_ok
{
    uint32_t U;
    struct _hw_enet_ieee_t_octets_ok_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0] Octet count for frames transmitted
                                        * without error Counts total octets (includes header and FCS fields). */
    } B;
} hw_enet_ieee_t_octets_ok_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_T_OCTETS_OK register
 */
/*@{*/
#define HW_ENET_IEEE_T_OCTETS_OK_ADDR(x) ((uintptr_t)(x) + 0x274U)

#define HW_ENET_IEEE_T_OCTETS_OK(x) (*(__I hw_enet_ieee_t_octets_ok_t *) HW_ENET_IEEE_T_OCTETS_OK_ADDR(x))
#define HW_ENET_IEEE_T_OCTETS_OK_RD(x) (HW_ENET_IEEE_T_OCTETS_OK(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_T_OCTETS_OK bitfields
 */

/*!
 * @name Register ENET_IEEE_T_OCTETS_OK, field COUNT[31:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_T_OCTETS_OK_COUNT (0U) /*!< Bit position for ENET_IEEE_T_OCTETS_OK_COUNT. */
#define BM_ENET_IEEE_T_OCTETS_OK_COUNT (0xFFFFFFFFU) /*!< Bit mask for ENET_IEEE_T_OCTETS_OK_COUNT. */
#define BS_ENET_IEEE_T_OCTETS_OK_COUNT (32U) /*!< Bit field size in bits for ENET_IEEE_T_OCTETS_OK_COUNT. */

/*! @brief Read current value of the ENET_IEEE_T_OCTETS_OK_COUNT field. */
#define BR_ENET_IEEE_T_OCTETS_OK_COUNT(x) (HW_ENET_IEEE_T_OCTETS_OK(x).U)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_PACKETS - Rx Packet Count Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_PACKETS - Rx Packet Count Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_packets
{
    uint32_t U;
    struct _hw_enet_rmon_r_packets_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of packets received */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_packets_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_PACKETS register
 */
/*@{*/
#define HW_ENET_RMON_R_PACKETS_ADDR(x) ((uintptr_t)(x) + 0x284U)

#define HW_ENET_RMON_R_PACKETS(x) (*(__I hw_enet_rmon_r_packets_t *) HW_ENET_RMON_R_PACKETS_ADDR(x))
#define HW_ENET_RMON_R_PACKETS_RD(x) (HW_ENET_RMON_R_PACKETS(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_PACKETS bitfields
 */

/*!
 * @name Register ENET_RMON_R_PACKETS, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_PACKETS_COUNT (0U)  /*!< Bit position for ENET_RMON_R_PACKETS_COUNT. */
#define BM_ENET_RMON_R_PACKETS_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_PACKETS_COUNT. */
#define BS_ENET_RMON_R_PACKETS_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_PACKETS_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_PACKETS_COUNT field. */
#define BR_ENET_RMON_R_PACKETS_COUNT(x) (HW_ENET_RMON_R_PACKETS(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_BC_PKT - Rx Broadcast Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_BC_PKT - Rx Broadcast Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_bc_pkt
{
    uint32_t U;
    struct _hw_enet_rmon_r_bc_pkt_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive broadcast packets
                                        * */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_bc_pkt_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_BC_PKT register
 */
/*@{*/
#define HW_ENET_RMON_R_BC_PKT_ADDR(x) ((uintptr_t)(x) + 0x288U)

#define HW_ENET_RMON_R_BC_PKT(x) (*(__I hw_enet_rmon_r_bc_pkt_t *) HW_ENET_RMON_R_BC_PKT_ADDR(x))
#define HW_ENET_RMON_R_BC_PKT_RD(x) (HW_ENET_RMON_R_BC_PKT(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_BC_PKT bitfields
 */

/*!
 * @name Register ENET_RMON_R_BC_PKT, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_BC_PKT_COUNT (0U)   /*!< Bit position for ENET_RMON_R_BC_PKT_COUNT. */
#define BM_ENET_RMON_R_BC_PKT_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_BC_PKT_COUNT. */
#define BS_ENET_RMON_R_BC_PKT_COUNT (16U)  /*!< Bit field size in bits for ENET_RMON_R_BC_PKT_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_BC_PKT_COUNT field. */
#define BR_ENET_RMON_R_BC_PKT_COUNT(x) (HW_ENET_RMON_R_BC_PKT(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_MC_PKT - Rx Multicast Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_MC_PKT - Rx Multicast Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_mc_pkt
{
    uint32_t U;
    struct _hw_enet_rmon_r_mc_pkt_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive multicast packets
                                        * */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_mc_pkt_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_MC_PKT register
 */
/*@{*/
#define HW_ENET_RMON_R_MC_PKT_ADDR(x) ((uintptr_t)(x) + 0x28CU)

#define HW_ENET_RMON_R_MC_PKT(x) (*(__I hw_enet_rmon_r_mc_pkt_t *) HW_ENET_RMON_R_MC_PKT_ADDR(x))
#define HW_ENET_RMON_R_MC_PKT_RD(x) (HW_ENET_RMON_R_MC_PKT(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_MC_PKT bitfields
 */

/*!
 * @name Register ENET_RMON_R_MC_PKT, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_MC_PKT_COUNT (0U)   /*!< Bit position for ENET_RMON_R_MC_PKT_COUNT. */
#define BM_ENET_RMON_R_MC_PKT_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_MC_PKT_COUNT. */
#define BS_ENET_RMON_R_MC_PKT_COUNT (16U)  /*!< Bit field size in bits for ENET_RMON_R_MC_PKT_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_MC_PKT_COUNT field. */
#define BR_ENET_RMON_R_MC_PKT_COUNT(x) (HW_ENET_RMON_R_MC_PKT(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_CRC_ALIGN - Rx Packets with CRC/Align Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_CRC_ALIGN - Rx Packets with CRC/Align Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_crc_align
{
    uint32_t U;
    struct _hw_enet_rmon_r_crc_align_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive packets with CRC
                                        * or align error */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_crc_align_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_CRC_ALIGN register
 */
/*@{*/
#define HW_ENET_RMON_R_CRC_ALIGN_ADDR(x) ((uintptr_t)(x) + 0x290U)

#define HW_ENET_RMON_R_CRC_ALIGN(x) (*(__I hw_enet_rmon_r_crc_align_t *) HW_ENET_RMON_R_CRC_ALIGN_ADDR(x))
#define HW_ENET_RMON_R_CRC_ALIGN_RD(x) (HW_ENET_RMON_R_CRC_ALIGN(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_CRC_ALIGN bitfields
 */

/*!
 * @name Register ENET_RMON_R_CRC_ALIGN, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_CRC_ALIGN_COUNT (0U) /*!< Bit position for ENET_RMON_R_CRC_ALIGN_COUNT. */
#define BM_ENET_RMON_R_CRC_ALIGN_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_CRC_ALIGN_COUNT. */
#define BS_ENET_RMON_R_CRC_ALIGN_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_CRC_ALIGN_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_CRC_ALIGN_COUNT field. */
#define BR_ENET_RMON_R_CRC_ALIGN_COUNT(x) (HW_ENET_RMON_R_CRC_ALIGN(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_UNDERSIZE - Rx Packets with Less Than 64 Bytes and Good CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_UNDERSIZE - Rx Packets with Less Than 64 Bytes and Good CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_undersize
{
    uint32_t U;
    struct _hw_enet_rmon_r_undersize_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive packets with less
                                        * than 64 bytes and good CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_undersize_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_UNDERSIZE register
 */
/*@{*/
#define HW_ENET_RMON_R_UNDERSIZE_ADDR(x) ((uintptr_t)(x) + 0x294U)

#define HW_ENET_RMON_R_UNDERSIZE(x) (*(__I hw_enet_rmon_r_undersize_t *) HW_ENET_RMON_R_UNDERSIZE_ADDR(x))
#define HW_ENET_RMON_R_UNDERSIZE_RD(x) (HW_ENET_RMON_R_UNDERSIZE(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_UNDERSIZE bitfields
 */

/*!
 * @name Register ENET_RMON_R_UNDERSIZE, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_UNDERSIZE_COUNT (0U) /*!< Bit position for ENET_RMON_R_UNDERSIZE_COUNT. */
#define BM_ENET_RMON_R_UNDERSIZE_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_UNDERSIZE_COUNT. */
#define BS_ENET_RMON_R_UNDERSIZE_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_UNDERSIZE_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_UNDERSIZE_COUNT field. */
#define BR_ENET_RMON_R_UNDERSIZE_COUNT(x) (HW_ENET_RMON_R_UNDERSIZE(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_OVERSIZE - Rx Packets Greater Than MAX_FL and Good CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_OVERSIZE - Rx Packets Greater Than MAX_FL and Good CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_oversize
{
    uint32_t U;
    struct _hw_enet_rmon_r_oversize_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive packets greater
                                        * than MAX_FL and good CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_oversize_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_OVERSIZE register
 */
/*@{*/
#define HW_ENET_RMON_R_OVERSIZE_ADDR(x) ((uintptr_t)(x) + 0x298U)

#define HW_ENET_RMON_R_OVERSIZE(x) (*(__I hw_enet_rmon_r_oversize_t *) HW_ENET_RMON_R_OVERSIZE_ADDR(x))
#define HW_ENET_RMON_R_OVERSIZE_RD(x) (HW_ENET_RMON_R_OVERSIZE(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_OVERSIZE bitfields
 */

/*!
 * @name Register ENET_RMON_R_OVERSIZE, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_OVERSIZE_COUNT (0U) /*!< Bit position for ENET_RMON_R_OVERSIZE_COUNT. */
#define BM_ENET_RMON_R_OVERSIZE_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_OVERSIZE_COUNT. */
#define BS_ENET_RMON_R_OVERSIZE_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_OVERSIZE_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_OVERSIZE_COUNT field. */
#define BR_ENET_RMON_R_OVERSIZE_COUNT(x) (HW_ENET_RMON_R_OVERSIZE(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_FRAG - Rx Packets Less Than 64 Bytes and Bad CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_FRAG - Rx Packets Less Than 64 Bytes and Bad CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_frag
{
    uint32_t U;
    struct _hw_enet_rmon_r_frag_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive packets with less
                                        * than 64 bytes and bad CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_frag_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_FRAG register
 */
/*@{*/
#define HW_ENET_RMON_R_FRAG_ADDR(x) ((uintptr_t)(x) + 0x29CU)

#define HW_ENET_RMON_R_FRAG(x)   (*(__I hw_enet_rmon_r_frag_t *) HW_ENET_RMON_R_FRAG_ADDR(x))
#define HW_ENET_RMON_R_FRAG_RD(x) (HW_ENET_RMON_R_FRAG(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_FRAG bitfields
 */

/*!
 * @name Register ENET_RMON_R_FRAG, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_FRAG_COUNT (0U)     /*!< Bit position for ENET_RMON_R_FRAG_COUNT. */
#define BM_ENET_RMON_R_FRAG_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_FRAG_COUNT. */
#define BS_ENET_RMON_R_FRAG_COUNT (16U)    /*!< Bit field size in bits for ENET_RMON_R_FRAG_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_FRAG_COUNT field. */
#define BR_ENET_RMON_R_FRAG_COUNT(x) (HW_ENET_RMON_R_FRAG(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_JAB - Rx Packets Greater Than MAX_FL Bytes and Bad CRC Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_JAB - Rx Packets Greater Than MAX_FL Bytes and Bad CRC Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_jab
{
    uint32_t U;
    struct _hw_enet_rmon_r_jab_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of receive packets greater
                                        * than MAX_FL and bad CRC */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_jab_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_JAB register
 */
/*@{*/
#define HW_ENET_RMON_R_JAB_ADDR(x) ((uintptr_t)(x) + 0x2A0U)

#define HW_ENET_RMON_R_JAB(x)    (*(__I hw_enet_rmon_r_jab_t *) HW_ENET_RMON_R_JAB_ADDR(x))
#define HW_ENET_RMON_R_JAB_RD(x) (HW_ENET_RMON_R_JAB(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_JAB bitfields
 */

/*!
 * @name Register ENET_RMON_R_JAB, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_JAB_COUNT (0U)      /*!< Bit position for ENET_RMON_R_JAB_COUNT. */
#define BM_ENET_RMON_R_JAB_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_JAB_COUNT. */
#define BS_ENET_RMON_R_JAB_COUNT (16U)     /*!< Bit field size in bits for ENET_RMON_R_JAB_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_JAB_COUNT field. */
#define BR_ENET_RMON_R_JAB_COUNT(x) (HW_ENET_RMON_R_JAB(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_RESVD_0 - Reserved Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_RESVD_0 - Reserved Statistic Register (ROZ)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_resvd_0
{
    uint32_t U;
    struct _hw_enet_rmon_r_resvd_0_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_enet_rmon_r_resvd_0_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_RESVD_0 register
 */
/*@{*/
#define HW_ENET_RMON_R_RESVD_0_ADDR(x) ((uintptr_t)(x) + 0x2A4U)

#define HW_ENET_RMON_R_RESVD_0(x) (*(__I hw_enet_rmon_r_resvd_0_t *) HW_ENET_RMON_R_RESVD_0_ADDR(x))
#define HW_ENET_RMON_R_RESVD_0_RD(x) (HW_ENET_RMON_R_RESVD_0(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_RESVD_0 bitfields
 */

/*******************************************************************************
 * HW_ENET_RMON_R_P64 - Rx 64-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P64 - Rx 64-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p64
{
    uint32_t U;
    struct _hw_enet_rmon_r_p64_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 64-byte receive packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p64_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P64 register
 */
/*@{*/
#define HW_ENET_RMON_R_P64_ADDR(x) ((uintptr_t)(x) + 0x2A8U)

#define HW_ENET_RMON_R_P64(x)    (*(__I hw_enet_rmon_r_p64_t *) HW_ENET_RMON_R_P64_ADDR(x))
#define HW_ENET_RMON_R_P64_RD(x) (HW_ENET_RMON_R_P64(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P64 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P64, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P64_COUNT (0U)      /*!< Bit position for ENET_RMON_R_P64_COUNT. */
#define BM_ENET_RMON_R_P64_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P64_COUNT. */
#define BS_ENET_RMON_R_P64_COUNT (16U)     /*!< Bit field size in bits for ENET_RMON_R_P64_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P64_COUNT field. */
#define BR_ENET_RMON_R_P64_COUNT(x) (HW_ENET_RMON_R_P64(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P65TO127 - Rx 65- to 127-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P65TO127 - Rx 65- to 127-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p65to127
{
    uint32_t U;
    struct _hw_enet_rmon_r_p65to127_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 65- to 127-byte recieve
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p65to127_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P65TO127 register
 */
/*@{*/
#define HW_ENET_RMON_R_P65TO127_ADDR(x) ((uintptr_t)(x) + 0x2ACU)

#define HW_ENET_RMON_R_P65TO127(x) (*(__I hw_enet_rmon_r_p65to127_t *) HW_ENET_RMON_R_P65TO127_ADDR(x))
#define HW_ENET_RMON_R_P65TO127_RD(x) (HW_ENET_RMON_R_P65TO127(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P65TO127 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P65TO127, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P65TO127_COUNT (0U) /*!< Bit position for ENET_RMON_R_P65TO127_COUNT. */
#define BM_ENET_RMON_R_P65TO127_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P65TO127_COUNT. */
#define BS_ENET_RMON_R_P65TO127_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P65TO127_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P65TO127_COUNT field. */
#define BR_ENET_RMON_R_P65TO127_COUNT(x) (HW_ENET_RMON_R_P65TO127(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P128TO255 - Rx 128- to 255-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P128TO255 - Rx 128- to 255-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p128to255
{
    uint32_t U;
    struct _hw_enet_rmon_r_p128to255_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 128- to 255-byte recieve
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p128to255_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P128TO255 register
 */
/*@{*/
#define HW_ENET_RMON_R_P128TO255_ADDR(x) ((uintptr_t)(x) + 0x2B0U)

#define HW_ENET_RMON_R_P128TO255(x) (*(__I hw_enet_rmon_r_p128to255_t *) HW_ENET_RMON_R_P128TO255_ADDR(x))
#define HW_ENET_RMON_R_P128TO255_RD(x) (HW_ENET_RMON_R_P128TO255(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P128TO255 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P128TO255, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P128TO255_COUNT (0U) /*!< Bit position for ENET_RMON_R_P128TO255_COUNT. */
#define BM_ENET_RMON_R_P128TO255_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P128TO255_COUNT. */
#define BS_ENET_RMON_R_P128TO255_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P128TO255_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P128TO255_COUNT field. */
#define BR_ENET_RMON_R_P128TO255_COUNT(x) (HW_ENET_RMON_R_P128TO255(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P256TO511 - Rx 256- to 511-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P256TO511 - Rx 256- to 511-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p256to511
{
    uint32_t U;
    struct _hw_enet_rmon_r_p256to511_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 256- to 511-byte recieve
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p256to511_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P256TO511 register
 */
/*@{*/
#define HW_ENET_RMON_R_P256TO511_ADDR(x) ((uintptr_t)(x) + 0x2B4U)

#define HW_ENET_RMON_R_P256TO511(x) (*(__I hw_enet_rmon_r_p256to511_t *) HW_ENET_RMON_R_P256TO511_ADDR(x))
#define HW_ENET_RMON_R_P256TO511_RD(x) (HW_ENET_RMON_R_P256TO511(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P256TO511 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P256TO511, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P256TO511_COUNT (0U) /*!< Bit position for ENET_RMON_R_P256TO511_COUNT. */
#define BM_ENET_RMON_R_P256TO511_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P256TO511_COUNT. */
#define BS_ENET_RMON_R_P256TO511_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P256TO511_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P256TO511_COUNT field. */
#define BR_ENET_RMON_R_P256TO511_COUNT(x) (HW_ENET_RMON_R_P256TO511(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P512TO1023 - Rx 512- to 1023-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P512TO1023 - Rx 512- to 1023-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p512to1023
{
    uint32_t U;
    struct _hw_enet_rmon_r_p512to1023_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 512- to 1023-byte recieve
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p512to1023_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P512TO1023 register
 */
/*@{*/
#define HW_ENET_RMON_R_P512TO1023_ADDR(x) ((uintptr_t)(x) + 0x2B8U)

#define HW_ENET_RMON_R_P512TO1023(x) (*(__I hw_enet_rmon_r_p512to1023_t *) HW_ENET_RMON_R_P512TO1023_ADDR(x))
#define HW_ENET_RMON_R_P512TO1023_RD(x) (HW_ENET_RMON_R_P512TO1023(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P512TO1023 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P512TO1023, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P512TO1023_COUNT (0U) /*!< Bit position for ENET_RMON_R_P512TO1023_COUNT. */
#define BM_ENET_RMON_R_P512TO1023_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P512TO1023_COUNT. */
#define BS_ENET_RMON_R_P512TO1023_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P512TO1023_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P512TO1023_COUNT field. */
#define BR_ENET_RMON_R_P512TO1023_COUNT(x) (HW_ENET_RMON_R_P512TO1023(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P1024TO2047 - Rx 1024- to 2047-Byte Packets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P1024TO2047 - Rx 1024- to 2047-Byte Packets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p1024to2047
{
    uint32_t U;
    struct _hw_enet_rmon_r_p1024to2047_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of 1024- to 2047-byte recieve
                                        * packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p1024to2047_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P1024TO2047 register
 */
/*@{*/
#define HW_ENET_RMON_R_P1024TO2047_ADDR(x) ((uintptr_t)(x) + 0x2BCU)

#define HW_ENET_RMON_R_P1024TO2047(x) (*(__I hw_enet_rmon_r_p1024to2047_t *) HW_ENET_RMON_R_P1024TO2047_ADDR(x))
#define HW_ENET_RMON_R_P1024TO2047_RD(x) (HW_ENET_RMON_R_P1024TO2047(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P1024TO2047 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P1024TO2047, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P1024TO2047_COUNT (0U) /*!< Bit position for ENET_RMON_R_P1024TO2047_COUNT. */
#define BM_ENET_RMON_R_P1024TO2047_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P1024TO2047_COUNT. */
#define BS_ENET_RMON_R_P1024TO2047_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P1024TO2047_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P1024TO2047_COUNT field. */
#define BR_ENET_RMON_R_P1024TO2047_COUNT(x) (HW_ENET_RMON_R_P1024TO2047(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_P_GTE2048 - Rx Packets Greater than 2048 Bytes Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_P_GTE2048 - Rx Packets Greater than 2048 Bytes Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_p_gte2048
{
    uint32_t U;
    struct _hw_enet_rmon_r_p_gte2048_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of greater-than-2048-byte
                                        * recieve packets */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_rmon_r_p_gte2048_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_P_GTE2048 register
 */
/*@{*/
#define HW_ENET_RMON_R_P_GTE2048_ADDR(x) ((uintptr_t)(x) + 0x2C0U)

#define HW_ENET_RMON_R_P_GTE2048(x) (*(__I hw_enet_rmon_r_p_gte2048_t *) HW_ENET_RMON_R_P_GTE2048_ADDR(x))
#define HW_ENET_RMON_R_P_GTE2048_RD(x) (HW_ENET_RMON_R_P_GTE2048(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_P_GTE2048 bitfields
 */

/*!
 * @name Register ENET_RMON_R_P_GTE2048, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_P_GTE2048_COUNT (0U) /*!< Bit position for ENET_RMON_R_P_GTE2048_COUNT. */
#define BM_ENET_RMON_R_P_GTE2048_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_RMON_R_P_GTE2048_COUNT. */
#define BS_ENET_RMON_R_P_GTE2048_COUNT (16U) /*!< Bit field size in bits for ENET_RMON_R_P_GTE2048_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_P_GTE2048_COUNT field. */
#define BR_ENET_RMON_R_P_GTE2048_COUNT(x) (HW_ENET_RMON_R_P_GTE2048(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_RMON_R_OCTETS - Rx Octets Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_RMON_R_OCTETS - Rx Octets Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_rmon_r_octets
{
    uint32_t U;
    struct _hw_enet_rmon_r_octets_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0] Number of receive octets */
    } B;
} hw_enet_rmon_r_octets_t;

/*!
 * @name Constants and macros for entire ENET_RMON_R_OCTETS register
 */
/*@{*/
#define HW_ENET_RMON_R_OCTETS_ADDR(x) ((uintptr_t)(x) + 0x2C4U)

#define HW_ENET_RMON_R_OCTETS(x) (*(__I hw_enet_rmon_r_octets_t *) HW_ENET_RMON_R_OCTETS_ADDR(x))
#define HW_ENET_RMON_R_OCTETS_RD(x) (HW_ENET_RMON_R_OCTETS(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_RMON_R_OCTETS bitfields
 */

/*!
 * @name Register ENET_RMON_R_OCTETS, field COUNT[31:0] (RO)
 */
/*@{*/
#define BP_ENET_RMON_R_OCTETS_COUNT (0U)   /*!< Bit position for ENET_RMON_R_OCTETS_COUNT. */
#define BM_ENET_RMON_R_OCTETS_COUNT (0xFFFFFFFFU) /*!< Bit mask for ENET_RMON_R_OCTETS_COUNT. */
#define BS_ENET_RMON_R_OCTETS_COUNT (32U)  /*!< Bit field size in bits for ENET_RMON_R_OCTETS_COUNT. */

/*! @brief Read current value of the ENET_RMON_R_OCTETS_COUNT field. */
#define BR_ENET_RMON_R_OCTETS_COUNT(x) (HW_ENET_RMON_R_OCTETS(x).U)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_DROP - Frames not Counted Correctly Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_DROP - Frames not Counted Correctly Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Counter increments if a frame with invalid or missing SFD character is
 * detected and has been dropped. None of the other counters increments if this counter
 * increments.
 */
typedef union _hw_enet_ieee_r_drop
{
    uint32_t U;
    struct _hw_enet_ieee_r_drop_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Frame count */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_drop_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_DROP register
 */
/*@{*/
#define HW_ENET_IEEE_R_DROP_ADDR(x) ((uintptr_t)(x) + 0x2C8U)

#define HW_ENET_IEEE_R_DROP(x)   (*(__I hw_enet_ieee_r_drop_t *) HW_ENET_IEEE_R_DROP_ADDR(x))
#define HW_ENET_IEEE_R_DROP_RD(x) (HW_ENET_IEEE_R_DROP(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_DROP bitfields
 */

/*!
 * @name Register ENET_IEEE_R_DROP, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_DROP_COUNT (0U)     /*!< Bit position for ENET_IEEE_R_DROP_COUNT. */
#define BM_ENET_IEEE_R_DROP_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_DROP_COUNT. */
#define BS_ENET_IEEE_R_DROP_COUNT (16U)    /*!< Bit field size in bits for ENET_IEEE_R_DROP_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_DROP_COUNT field. */
#define BR_ENET_IEEE_R_DROP_COUNT(x) (HW_ENET_IEEE_R_DROP(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_FRAME_OK - Frames Received OK Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_FRAME_OK - Frames Received OK Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_frame_ok
{
    uint32_t U;
    struct _hw_enet_ieee_r_frame_ok_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames received OK */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_frame_ok_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_FRAME_OK register
 */
/*@{*/
#define HW_ENET_IEEE_R_FRAME_OK_ADDR(x) ((uintptr_t)(x) + 0x2CCU)

#define HW_ENET_IEEE_R_FRAME_OK(x) (*(__I hw_enet_ieee_r_frame_ok_t *) HW_ENET_IEEE_R_FRAME_OK_ADDR(x))
#define HW_ENET_IEEE_R_FRAME_OK_RD(x) (HW_ENET_IEEE_R_FRAME_OK(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_FRAME_OK bitfields
 */

/*!
 * @name Register ENET_IEEE_R_FRAME_OK, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_FRAME_OK_COUNT (0U) /*!< Bit position for ENET_IEEE_R_FRAME_OK_COUNT. */
#define BM_ENET_IEEE_R_FRAME_OK_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_FRAME_OK_COUNT. */
#define BS_ENET_IEEE_R_FRAME_OK_COUNT (16U) /*!< Bit field size in bits for ENET_IEEE_R_FRAME_OK_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_FRAME_OK_COUNT field. */
#define BR_ENET_IEEE_R_FRAME_OK_COUNT(x) (HW_ENET_IEEE_R_FRAME_OK(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_CRC - Frames Received with CRC Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_CRC - Frames Received with CRC Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_crc
{
    uint32_t U;
    struct _hw_enet_ieee_r_crc_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames received with CRC
                                        * error */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_crc_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_CRC register
 */
/*@{*/
#define HW_ENET_IEEE_R_CRC_ADDR(x) ((uintptr_t)(x) + 0x2D0U)

#define HW_ENET_IEEE_R_CRC(x)    (*(__I hw_enet_ieee_r_crc_t *) HW_ENET_IEEE_R_CRC_ADDR(x))
#define HW_ENET_IEEE_R_CRC_RD(x) (HW_ENET_IEEE_R_CRC(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_CRC bitfields
 */

/*!
 * @name Register ENET_IEEE_R_CRC, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_CRC_COUNT (0U)      /*!< Bit position for ENET_IEEE_R_CRC_COUNT. */
#define BM_ENET_IEEE_R_CRC_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_CRC_COUNT. */
#define BS_ENET_IEEE_R_CRC_COUNT (16U)     /*!< Bit field size in bits for ENET_IEEE_R_CRC_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_CRC_COUNT field. */
#define BR_ENET_IEEE_R_CRC_COUNT(x) (HW_ENET_IEEE_R_CRC(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_ALIGN - Frames Received with Alignment Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_ALIGN - Frames Received with Alignment Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_align
{
    uint32_t U;
    struct _hw_enet_ieee_r_align_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of frames received with
                                        * alignment error */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_align_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_ALIGN register
 */
/*@{*/
#define HW_ENET_IEEE_R_ALIGN_ADDR(x) ((uintptr_t)(x) + 0x2D4U)

#define HW_ENET_IEEE_R_ALIGN(x)  (*(__I hw_enet_ieee_r_align_t *) HW_ENET_IEEE_R_ALIGN_ADDR(x))
#define HW_ENET_IEEE_R_ALIGN_RD(x) (HW_ENET_IEEE_R_ALIGN(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_ALIGN bitfields
 */

/*!
 * @name Register ENET_IEEE_R_ALIGN, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_ALIGN_COUNT (0U)    /*!< Bit position for ENET_IEEE_R_ALIGN_COUNT. */
#define BM_ENET_IEEE_R_ALIGN_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_ALIGN_COUNT. */
#define BS_ENET_IEEE_R_ALIGN_COUNT (16U)   /*!< Bit field size in bits for ENET_IEEE_R_ALIGN_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_ALIGN_COUNT field. */
#define BR_ENET_IEEE_R_ALIGN_COUNT(x) (HW_ENET_IEEE_R_ALIGN(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_MACERR - Receive FIFO Overflow Count Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_MACERR - Receive FIFO Overflow Count Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_macerr
{
    uint32_t U;
    struct _hw_enet_ieee_r_macerr_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Receive FIFO overflow count */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_macerr_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_MACERR register
 */
/*@{*/
#define HW_ENET_IEEE_R_MACERR_ADDR(x) ((uintptr_t)(x) + 0x2D8U)

#define HW_ENET_IEEE_R_MACERR(x) (*(__I hw_enet_ieee_r_macerr_t *) HW_ENET_IEEE_R_MACERR_ADDR(x))
#define HW_ENET_IEEE_R_MACERR_RD(x) (HW_ENET_IEEE_R_MACERR(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_MACERR bitfields
 */

/*!
 * @name Register ENET_IEEE_R_MACERR, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_MACERR_COUNT (0U)   /*!< Bit position for ENET_IEEE_R_MACERR_COUNT. */
#define BM_ENET_IEEE_R_MACERR_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_MACERR_COUNT. */
#define BS_ENET_IEEE_R_MACERR_COUNT (16U)  /*!< Bit field size in bits for ENET_IEEE_R_MACERR_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_MACERR_COUNT field. */
#define BR_ENET_IEEE_R_MACERR_COUNT(x) (HW_ENET_IEEE_R_MACERR(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_FDXFC - Flow Control Pause Frames Received Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_FDXFC - Flow Control Pause Frames Received Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_fdxfc
{
    uint32_t U;
    struct _hw_enet_ieee_r_fdxfc_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0] Number of flow-control pause frames
                                        * received */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_enet_ieee_r_fdxfc_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_FDXFC register
 */
/*@{*/
#define HW_ENET_IEEE_R_FDXFC_ADDR(x) ((uintptr_t)(x) + 0x2DCU)

#define HW_ENET_IEEE_R_FDXFC(x)  (*(__I hw_enet_ieee_r_fdxfc_t *) HW_ENET_IEEE_R_FDXFC_ADDR(x))
#define HW_ENET_IEEE_R_FDXFC_RD(x) (HW_ENET_IEEE_R_FDXFC(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_FDXFC bitfields
 */

/*!
 * @name Register ENET_IEEE_R_FDXFC, field COUNT[15:0] (RO)
 */
/*@{*/
#define BP_ENET_IEEE_R_FDXFC_COUNT (0U)    /*!< Bit position for ENET_IEEE_R_FDXFC_COUNT. */
#define BM_ENET_IEEE_R_FDXFC_COUNT (0x0000FFFFU) /*!< Bit mask for ENET_IEEE_R_FDXFC_COUNT. */
#define BS_ENET_IEEE_R_FDXFC_COUNT (16U)   /*!< Bit field size in bits for ENET_IEEE_R_FDXFC_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_FDXFC_COUNT field. */
#define BR_ENET_IEEE_R_FDXFC_COUNT(x) (HW_ENET_IEEE_R_FDXFC(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * HW_ENET_IEEE_R_OCTETS_OK - Octet Count for Frames Received without Error Statistic Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_IEEE_R_OCTETS_OK - Octet Count for Frames Received without Error Statistic Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_ieee_r_octets_ok
{
    uint32_t U;
    struct _hw_enet_ieee_r_octets_ok_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0] Number of octets for frames received
                                        * without error */
    } B;
} hw_enet_ieee_r_octets_ok_t;

/*!
 * @name Constants and macros for entire ENET_IEEE_R_OCTETS_OK register
 */
/*@{*/
#define HW_ENET_IEEE_R_OCTETS_OK_ADDR(x) ((uintptr_t)(x) + 0x2E0U)

#define HW_ENET_IEEE_R_OCTETS_OK(x) (*(__I hw_enet_ieee_r_octets_ok_t *) HW_ENET_IEEE_R_OCTETS_OK_ADDR(x))
#define HW_ENET_IEEE_R_OCTETS_OK_RD(x) (HW_ENET_IEEE_R_OCTETS_OK(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_IEEE_R_OCTETS_OK bitfields
 */

/*!
 * @name Register ENET_IEEE_R_OCTETS_OK, field COUNT[31:0] (RO)
 *
 * Counts total octets (includes header and FCS fields). Does not increment for
 * the broadcast frames when broadcast reject is enabled and promiscuous mode is
 * disabled within the receive control register (RCR).
 */
/*@{*/
#define BP_ENET_IEEE_R_OCTETS_OK_COUNT (0U) /*!< Bit position for ENET_IEEE_R_OCTETS_OK_COUNT. */
#define BM_ENET_IEEE_R_OCTETS_OK_COUNT (0xFFFFFFFFU) /*!< Bit mask for ENET_IEEE_R_OCTETS_OK_COUNT. */
#define BS_ENET_IEEE_R_OCTETS_OK_COUNT (32U) /*!< Bit field size in bits for ENET_IEEE_R_OCTETS_OK_COUNT. */

/*! @brief Read current value of the ENET_IEEE_R_OCTETS_OK_COUNT field. */
#define BR_ENET_IEEE_R_OCTETS_OK_COUNT(x) (HW_ENET_IEEE_R_OCTETS_OK(x).U)
/*@}*/

/*******************************************************************************
 * HW_ENET_ATCR - Adjustable Timer Control Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATCR - Adjustable Timer Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * ATCR command fields can trigger the corresponding events directly. It is not
 * necessary to preserve any of the configuration fields when a command field is
 * set in the register, that is, no read-modify-write is required.
 */
typedef union _hw_enet_atcr
{
    uint32_t U;
    struct _hw_enet_atcr_bitfields
    {
        uint32_t EN : 1;               /*!< [0] Enable Timer */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t OFFEN : 1;            /*!< [2] Enable One-Shot Offset Event */
        uint32_t OFFRST : 1;           /*!< [3] Reset Timer On Offset Event */
        uint32_t PEREN : 1;            /*!< [4] Enable Periodical Event */
        uint32_t RESERVED1 : 2;        /*!< [6:5]  */
        uint32_t PINPER : 1;           /*!< [7]  */
        uint32_t RESERVED2 : 1;        /*!< [8]  */
        uint32_t RESTART : 1;          /*!< [9] Reset Timer */
        uint32_t RESERVED3 : 1;        /*!< [10]  */
        uint32_t CAPTURE : 1;          /*!< [11] Capture Timer Value */
        uint32_t RESERVED4 : 1;        /*!< [12]  */
        uint32_t SLAVE : 1;            /*!< [13] Enable Timer Slave Mode */
        uint32_t RESERVED5 : 18;       /*!< [31:14]  */
    } B;
} hw_enet_atcr_t;

/*!
 * @name Constants and macros for entire ENET_ATCR register
 */
/*@{*/
#define HW_ENET_ATCR_ADDR(x)     ((uintptr_t)(x) + 0x400U)

#define HW_ENET_ATCR(x)          (*(__IO hw_enet_atcr_t *) HW_ENET_ATCR_ADDR(x))
#define HW_ENET_ATCR_RD(x)       (HW_ENET_ATCR(x).U)
#define HW_ENET_ATCR_WR(x, v)    (HW_ENET_ATCR(x).U = (v))
#define HW_ENET_ATCR_SET(x, v)   (HW_ENET_ATCR_WR(x, HW_ENET_ATCR_RD(x) |  (v)))
#define HW_ENET_ATCR_CLR(x, v)   (HW_ENET_ATCR_WR(x, HW_ENET_ATCR_RD(x) & ~(v)))
#define HW_ENET_ATCR_TOG(x, v)   (HW_ENET_ATCR_WR(x, HW_ENET_ATCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATCR bitfields
 */

/*!
 * @name Register ENET_ATCR, field EN[0] (RW)
 *
 * Values:
 * - 0 - The timer stops at the current value.
 * - 1 - The timer starts incrementing.
 */
/*@{*/
#define BP_ENET_ATCR_EN      (0U)          /*!< Bit position for ENET_ATCR_EN. */
#define BM_ENET_ATCR_EN      (0x00000001U) /*!< Bit mask for ENET_ATCR_EN. */
#define BS_ENET_ATCR_EN      (1U)          /*!< Bit field size in bits for ENET_ATCR_EN. */

/*! @brief Read current value of the ENET_ATCR_EN field. */
#define BR_ENET_ATCR_EN(x)   (HW_ENET_ATCR(x).B.EN)

/*! @brief Format value for bitfield ENET_ATCR_EN. */
#define BF_ENET_ATCR_EN(v)   ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_EN) & BM_ENET_ATCR_EN)

/*! @brief Set the EN field to a new value. */
#define BW_ENET_ATCR_EN(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_EN) | BF_ENET_ATCR_EN(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field OFFEN[2] (RW)
 *
 * Values:
 * - 0 - Disable.
 * - 1 - The timer can be reset to zero when the given offset time is reached
 *     (offset event). The field is cleared when the offset event is reached, so no
 *     further event occurs until the field is set again. The timer offset value
 *     must be set before setting this field.
 */
/*@{*/
#define BP_ENET_ATCR_OFFEN   (2U)          /*!< Bit position for ENET_ATCR_OFFEN. */
#define BM_ENET_ATCR_OFFEN   (0x00000004U) /*!< Bit mask for ENET_ATCR_OFFEN. */
#define BS_ENET_ATCR_OFFEN   (1U)          /*!< Bit field size in bits for ENET_ATCR_OFFEN. */

/*! @brief Read current value of the ENET_ATCR_OFFEN field. */
#define BR_ENET_ATCR_OFFEN(x) (HW_ENET_ATCR(x).B.OFFEN)

/*! @brief Format value for bitfield ENET_ATCR_OFFEN. */
#define BF_ENET_ATCR_OFFEN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_OFFEN) & BM_ENET_ATCR_OFFEN)

/*! @brief Set the OFFEN field to a new value. */
#define BW_ENET_ATCR_OFFEN(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_OFFEN) | BF_ENET_ATCR_OFFEN(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field OFFRST[3] (RW)
 *
 * Values:
 * - 0 - The timer is not affected and no action occurs, besides clearing OFFEN,
 *     when the offset is reached.
 * - 1 - If OFFEN is set, the timer resets to zero when the offset setting is
 *     reached. The offset event does not cause a timer interrupt.
 */
/*@{*/
#define BP_ENET_ATCR_OFFRST  (3U)          /*!< Bit position for ENET_ATCR_OFFRST. */
#define BM_ENET_ATCR_OFFRST  (0x00000008U) /*!< Bit mask for ENET_ATCR_OFFRST. */
#define BS_ENET_ATCR_OFFRST  (1U)          /*!< Bit field size in bits for ENET_ATCR_OFFRST. */

/*! @brief Read current value of the ENET_ATCR_OFFRST field. */
#define BR_ENET_ATCR_OFFRST(x) (HW_ENET_ATCR(x).B.OFFRST)

/*! @brief Format value for bitfield ENET_ATCR_OFFRST. */
#define BF_ENET_ATCR_OFFRST(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_OFFRST) & BM_ENET_ATCR_OFFRST)

/*! @brief Set the OFFRST field to a new value. */
#define BW_ENET_ATCR_OFFRST(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_OFFRST) | BF_ENET_ATCR_OFFRST(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field PEREN[4] (RW)
 *
 * Values:
 * - 0 - Disable.
 * - 1 - A period event interrupt can be generated (EIR[TS_TIMER]) and the event
 *     signal output is asserted when the timer wraps around according to the
 *     periodic setting ATPER. The timer period value must be set before setting
 *     this bit. Not all devices contain the event signal output. See the chip
 *     configuration details.
 */
/*@{*/
#define BP_ENET_ATCR_PEREN   (4U)          /*!< Bit position for ENET_ATCR_PEREN. */
#define BM_ENET_ATCR_PEREN   (0x00000010U) /*!< Bit mask for ENET_ATCR_PEREN. */
#define BS_ENET_ATCR_PEREN   (1U)          /*!< Bit field size in bits for ENET_ATCR_PEREN. */

/*! @brief Read current value of the ENET_ATCR_PEREN field. */
#define BR_ENET_ATCR_PEREN(x) (HW_ENET_ATCR(x).B.PEREN)

/*! @brief Format value for bitfield ENET_ATCR_PEREN. */
#define BF_ENET_ATCR_PEREN(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_PEREN) & BM_ENET_ATCR_PEREN)

/*! @brief Set the PEREN field to a new value. */
#define BW_ENET_ATCR_PEREN(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_PEREN) | BF_ENET_ATCR_PEREN(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field PINPER[7] (RW)
 *
 * Enables event signal output assertion on period event. Not all devices
 * contain the event signal output. See the chip configuration details.
 *
 * Values:
 * - 0 - Disable.
 * - 1 - Enable.
 */
/*@{*/
#define BP_ENET_ATCR_PINPER  (7U)          /*!< Bit position for ENET_ATCR_PINPER. */
#define BM_ENET_ATCR_PINPER  (0x00000080U) /*!< Bit mask for ENET_ATCR_PINPER. */
#define BS_ENET_ATCR_PINPER  (1U)          /*!< Bit field size in bits for ENET_ATCR_PINPER. */

/*! @brief Read current value of the ENET_ATCR_PINPER field. */
#define BR_ENET_ATCR_PINPER(x) (HW_ENET_ATCR(x).B.PINPER)

/*! @brief Format value for bitfield ENET_ATCR_PINPER. */
#define BF_ENET_ATCR_PINPER(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_PINPER) & BM_ENET_ATCR_PINPER)

/*! @brief Set the PINPER field to a new value. */
#define BW_ENET_ATCR_PINPER(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_PINPER) | BF_ENET_ATCR_PINPER(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field RESTART[9] (RW)
 *
 * Resets the timer to zero. This has no effect on the counter enable. If the
 * counter is enabled when this field is set, the timer is reset to zero and starts
 * counting from there. When set, all other fields are ignored during a write.
 * This field automatically clears to 0 after the command completes. The Reset
 * Timer command requires at least 6 clock cycles of either the register clock or
 * the 1588/timestamp clock, whichever is greater, to complete.
 */
/*@{*/
#define BP_ENET_ATCR_RESTART (9U)          /*!< Bit position for ENET_ATCR_RESTART. */
#define BM_ENET_ATCR_RESTART (0x00000200U) /*!< Bit mask for ENET_ATCR_RESTART. */
#define BS_ENET_ATCR_RESTART (1U)          /*!< Bit field size in bits for ENET_ATCR_RESTART. */

/*! @brief Read current value of the ENET_ATCR_RESTART field. */
#define BR_ENET_ATCR_RESTART(x) (HW_ENET_ATCR(x).B.RESTART)

/*! @brief Format value for bitfield ENET_ATCR_RESTART. */
#define BF_ENET_ATCR_RESTART(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_RESTART) & BM_ENET_ATCR_RESTART)

/*! @brief Set the RESTART field to a new value. */
#define BW_ENET_ATCR_RESTART(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_RESTART) | BF_ENET_ATCR_RESTART(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field CAPTURE[11] (RW)
 *
 * When this field is set, all other fields are ignored during a write. This
 * field automatically clears to 0 after the command completes. To ensure that the
 * correct time value is read from the ATVR register, a minimum amount of time
 * must elapse from issuing this command to reading the ATVR register. This minimum
 * time is defined by the greater of either six register clock cycles or six
 * 1588/timestamp clock cycles.
 *
 * Values:
 * - 0 - No effect.
 * - 1 - The current time is captured and can be read from the ATVR register.
 */
/*@{*/
#define BP_ENET_ATCR_CAPTURE (11U)         /*!< Bit position for ENET_ATCR_CAPTURE. */
#define BM_ENET_ATCR_CAPTURE (0x00000800U) /*!< Bit mask for ENET_ATCR_CAPTURE. */
#define BS_ENET_ATCR_CAPTURE (1U)          /*!< Bit field size in bits for ENET_ATCR_CAPTURE. */

/*! @brief Read current value of the ENET_ATCR_CAPTURE field. */
#define BR_ENET_ATCR_CAPTURE(x) (HW_ENET_ATCR(x).B.CAPTURE)

/*! @brief Format value for bitfield ENET_ATCR_CAPTURE. */
#define BF_ENET_ATCR_CAPTURE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_CAPTURE) & BM_ENET_ATCR_CAPTURE)

/*! @brief Set the CAPTURE field to a new value. */
#define BW_ENET_ATCR_CAPTURE(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_CAPTURE) | BF_ENET_ATCR_CAPTURE(v)))
/*@}*/

/*!
 * @name Register ENET_ATCR, field SLAVE[13] (RW)
 *
 * Values:
 * - 0 - The timer is active and all configuration fields in this register are
 *     relevant.
 * - 1 - The internal timer is disabled and the externally provided timer value
 *     is used. All other fields, except CAPTURE, in this register have no
 *     effect. CAPTURE can still be used to capture the current timer value.
 */
/*@{*/
#define BP_ENET_ATCR_SLAVE   (13U)         /*!< Bit position for ENET_ATCR_SLAVE. */
#define BM_ENET_ATCR_SLAVE   (0x00002000U) /*!< Bit mask for ENET_ATCR_SLAVE. */
#define BS_ENET_ATCR_SLAVE   (1U)          /*!< Bit field size in bits for ENET_ATCR_SLAVE. */

/*! @brief Read current value of the ENET_ATCR_SLAVE field. */
#define BR_ENET_ATCR_SLAVE(x) (HW_ENET_ATCR(x).B.SLAVE)

/*! @brief Format value for bitfield ENET_ATCR_SLAVE. */
#define BF_ENET_ATCR_SLAVE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCR_SLAVE) & BM_ENET_ATCR_SLAVE)

/*! @brief Set the SLAVE field to a new value. */
#define BW_ENET_ATCR_SLAVE(x, v) (HW_ENET_ATCR_WR(x, (HW_ENET_ATCR_RD(x) & ~BM_ENET_ATCR_SLAVE) | BF_ENET_ATCR_SLAVE(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATVR - Timer Value Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATVR - Timer Value Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_atvr
{
    uint32_t U;
    struct _hw_enet_atvr_bitfields
    {
        uint32_t ATIME : 32;           /*!< [31:0]  */
    } B;
} hw_enet_atvr_t;

/*!
 * @name Constants and macros for entire ENET_ATVR register
 */
/*@{*/
#define HW_ENET_ATVR_ADDR(x)     ((uintptr_t)(x) + 0x404U)

#define HW_ENET_ATVR(x)          (*(__IO hw_enet_atvr_t *) HW_ENET_ATVR_ADDR(x))
#define HW_ENET_ATVR_RD(x)       (HW_ENET_ATVR(x).U)
#define HW_ENET_ATVR_WR(x, v)    (HW_ENET_ATVR(x).U = (v))
#define HW_ENET_ATVR_SET(x, v)   (HW_ENET_ATVR_WR(x, HW_ENET_ATVR_RD(x) |  (v)))
#define HW_ENET_ATVR_CLR(x, v)   (HW_ENET_ATVR_WR(x, HW_ENET_ATVR_RD(x) & ~(v)))
#define HW_ENET_ATVR_TOG(x, v)   (HW_ENET_ATVR_WR(x, HW_ENET_ATVR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATVR bitfields
 */

/*!
 * @name Register ENET_ATVR, field ATIME[31:0] (RW)
 *
 * A write sets the timer. A read returns the last captured value. To read the
 * current value, issue a capture command (i.e., set ATCR[CAPTURE]) prior to
 * reading this register.
 */
/*@{*/
#define BP_ENET_ATVR_ATIME   (0U)          /*!< Bit position for ENET_ATVR_ATIME. */
#define BM_ENET_ATVR_ATIME   (0xFFFFFFFFU) /*!< Bit mask for ENET_ATVR_ATIME. */
#define BS_ENET_ATVR_ATIME   (32U)         /*!< Bit field size in bits for ENET_ATVR_ATIME. */

/*! @brief Read current value of the ENET_ATVR_ATIME field. */
#define BR_ENET_ATVR_ATIME(x) (HW_ENET_ATVR(x).U)

/*! @brief Format value for bitfield ENET_ATVR_ATIME. */
#define BF_ENET_ATVR_ATIME(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATVR_ATIME) & BM_ENET_ATVR_ATIME)

/*! @brief Set the ATIME field to a new value. */
#define BW_ENET_ATVR_ATIME(x, v) (HW_ENET_ATVR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATOFF - Timer Offset Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATOFF - Timer Offset Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_atoff
{
    uint32_t U;
    struct _hw_enet_atoff_bitfields
    {
        uint32_t OFFSET : 32;          /*!< [31:0]  */
    } B;
} hw_enet_atoff_t;

/*!
 * @name Constants and macros for entire ENET_ATOFF register
 */
/*@{*/
#define HW_ENET_ATOFF_ADDR(x)    ((uintptr_t)(x) + 0x408U)

#define HW_ENET_ATOFF(x)         (*(__IO hw_enet_atoff_t *) HW_ENET_ATOFF_ADDR(x))
#define HW_ENET_ATOFF_RD(x)      (HW_ENET_ATOFF(x).U)
#define HW_ENET_ATOFF_WR(x, v)   (HW_ENET_ATOFF(x).U = (v))
#define HW_ENET_ATOFF_SET(x, v)  (HW_ENET_ATOFF_WR(x, HW_ENET_ATOFF_RD(x) |  (v)))
#define HW_ENET_ATOFF_CLR(x, v)  (HW_ENET_ATOFF_WR(x, HW_ENET_ATOFF_RD(x) & ~(v)))
#define HW_ENET_ATOFF_TOG(x, v)  (HW_ENET_ATOFF_WR(x, HW_ENET_ATOFF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATOFF bitfields
 */

/*!
 * @name Register ENET_ATOFF, field OFFSET[31:0] (RW)
 *
 * Offset value for one-shot event generation. When the timer reaches the value,
 * an event can be generated to reset the counter. If the increment value in
 * ATINC is given in true nanoseconds, this value is also given in true nanoseconds.
 */
/*@{*/
#define BP_ENET_ATOFF_OFFSET (0U)          /*!< Bit position for ENET_ATOFF_OFFSET. */
#define BM_ENET_ATOFF_OFFSET (0xFFFFFFFFU) /*!< Bit mask for ENET_ATOFF_OFFSET. */
#define BS_ENET_ATOFF_OFFSET (32U)         /*!< Bit field size in bits for ENET_ATOFF_OFFSET. */

/*! @brief Read current value of the ENET_ATOFF_OFFSET field. */
#define BR_ENET_ATOFF_OFFSET(x) (HW_ENET_ATOFF(x).U)

/*! @brief Format value for bitfield ENET_ATOFF_OFFSET. */
#define BF_ENET_ATOFF_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATOFF_OFFSET) & BM_ENET_ATOFF_OFFSET)

/*! @brief Set the OFFSET field to a new value. */
#define BW_ENET_ATOFF_OFFSET(x, v) (HW_ENET_ATOFF_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATPER - Timer Period Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATPER - Timer Period Register (RW)
 *
 * Reset value: 0x3B9ACA00U
 */
typedef union _hw_enet_atper
{
    uint32_t U;
    struct _hw_enet_atper_bitfields
    {
        uint32_t PERIOD : 32;          /*!< [31:0]  */
    } B;
} hw_enet_atper_t;

/*!
 * @name Constants and macros for entire ENET_ATPER register
 */
/*@{*/
#define HW_ENET_ATPER_ADDR(x)    ((uintptr_t)(x) + 0x40CU)

#define HW_ENET_ATPER(x)         (*(__IO hw_enet_atper_t *) HW_ENET_ATPER_ADDR(x))
#define HW_ENET_ATPER_RD(x)      (HW_ENET_ATPER(x).U)
#define HW_ENET_ATPER_WR(x, v)   (HW_ENET_ATPER(x).U = (v))
#define HW_ENET_ATPER_SET(x, v)  (HW_ENET_ATPER_WR(x, HW_ENET_ATPER_RD(x) |  (v)))
#define HW_ENET_ATPER_CLR(x, v)  (HW_ENET_ATPER_WR(x, HW_ENET_ATPER_RD(x) & ~(v)))
#define HW_ENET_ATPER_TOG(x, v)  (HW_ENET_ATPER_WR(x, HW_ENET_ATPER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATPER bitfields
 */

/*!
 * @name Register ENET_ATPER, field PERIOD[31:0] (RW)
 *
 * Value for generating periodic events. Each instance the timer reaches this
 * value, the period event occurs and the timer restarts. If the increment value in
 * ATINC is given in true nanoseconds, this value is also given in true
 * nanoseconds. The value should be initialized to 1,000,000,000 (1✕109) to represent a
 * timer wrap around of one second. The increment value set in ATINC should be
 * set to the true nanoseconds of the period of clock ts_clk, hence implementing a
 * true 1 second counter. The value of PERIOD has the following constraint: 232
 * − ENET_ATINC[INC_COR] − 3✕ENET_ATINC[INC] >= PERIOD > 0.
 */
/*@{*/
#define BP_ENET_ATPER_PERIOD (0U)          /*!< Bit position for ENET_ATPER_PERIOD. */
#define BM_ENET_ATPER_PERIOD (0xFFFFFFFFU) /*!< Bit mask for ENET_ATPER_PERIOD. */
#define BS_ENET_ATPER_PERIOD (32U)         /*!< Bit field size in bits for ENET_ATPER_PERIOD. */

/*! @brief Read current value of the ENET_ATPER_PERIOD field. */
#define BR_ENET_ATPER_PERIOD(x) (HW_ENET_ATPER(x).U)

/*! @brief Format value for bitfield ENET_ATPER_PERIOD. */
#define BF_ENET_ATPER_PERIOD(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATPER_PERIOD) & BM_ENET_ATPER_PERIOD)

/*! @brief Set the PERIOD field to a new value. */
#define BW_ENET_ATPER_PERIOD(x, v) (HW_ENET_ATPER_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATCOR - Timer Correction Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATCOR - Timer Correction Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_atcor
{
    uint32_t U;
    struct _hw_enet_atcor_bitfields
    {
        uint32_t COR : 31;             /*!< [30:0] Correction Counter Wrap-Around Value */
        uint32_t RESERVED0 : 1;        /*!< [31]  */
    } B;
} hw_enet_atcor_t;

/*!
 * @name Constants and macros for entire ENET_ATCOR register
 */
/*@{*/
#define HW_ENET_ATCOR_ADDR(x)    ((uintptr_t)(x) + 0x410U)

#define HW_ENET_ATCOR(x)         (*(__IO hw_enet_atcor_t *) HW_ENET_ATCOR_ADDR(x))
#define HW_ENET_ATCOR_RD(x)      (HW_ENET_ATCOR(x).U)
#define HW_ENET_ATCOR_WR(x, v)   (HW_ENET_ATCOR(x).U = (v))
#define HW_ENET_ATCOR_SET(x, v)  (HW_ENET_ATCOR_WR(x, HW_ENET_ATCOR_RD(x) |  (v)))
#define HW_ENET_ATCOR_CLR(x, v)  (HW_ENET_ATCOR_WR(x, HW_ENET_ATCOR_RD(x) & ~(v)))
#define HW_ENET_ATCOR_TOG(x, v)  (HW_ENET_ATCOR_WR(x, HW_ENET_ATCOR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATCOR bitfields
 */

/*!
 * @name Register ENET_ATCOR, field COR[30:0] (RW)
 *
 * Defines after how many timer clock cycles (ts_clk) the correction counter
 * should be reset and trigger a correction increment on the timer. The amount of
 * correction is defined in ATINC[INC_CORR]. A value of 0 disables the correction
 * counter and no corrections occur. This value is given in clock cycles, not in
 * nanoseconds as all other values.
 */
/*@{*/
#define BP_ENET_ATCOR_COR    (0U)          /*!< Bit position for ENET_ATCOR_COR. */
#define BM_ENET_ATCOR_COR    (0x7FFFFFFFU) /*!< Bit mask for ENET_ATCOR_COR. */
#define BS_ENET_ATCOR_COR    (31U)         /*!< Bit field size in bits for ENET_ATCOR_COR. */

/*! @brief Read current value of the ENET_ATCOR_COR field. */
#define BR_ENET_ATCOR_COR(x) (HW_ENET_ATCOR(x).B.COR)

/*! @brief Format value for bitfield ENET_ATCOR_COR. */
#define BF_ENET_ATCOR_COR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATCOR_COR) & BM_ENET_ATCOR_COR)

/*! @brief Set the COR field to a new value. */
#define BW_ENET_ATCOR_COR(x, v) (HW_ENET_ATCOR_WR(x, (HW_ENET_ATCOR_RD(x) & ~BM_ENET_ATCOR_COR) | BF_ENET_ATCOR_COR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATINC - Time-Stamping Clock Period Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATINC - Time-Stamping Clock Period Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_atinc
{
    uint32_t U;
    struct _hw_enet_atinc_bitfields
    {
        uint32_t INC : 7;              /*!< [6:0] Clock Period Of The Timestamping Clock
                                        * (ts_clk) In Nanoseconds */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t INC_CORR : 7;         /*!< [14:8] Correction Increment Value */
        uint32_t RESERVED1 : 17;       /*!< [31:15]  */
    } B;
} hw_enet_atinc_t;

/*!
 * @name Constants and macros for entire ENET_ATINC register
 */
/*@{*/
#define HW_ENET_ATINC_ADDR(x)    ((uintptr_t)(x) + 0x414U)

#define HW_ENET_ATINC(x)         (*(__IO hw_enet_atinc_t *) HW_ENET_ATINC_ADDR(x))
#define HW_ENET_ATINC_RD(x)      (HW_ENET_ATINC(x).U)
#define HW_ENET_ATINC_WR(x, v)   (HW_ENET_ATINC(x).U = (v))
#define HW_ENET_ATINC_SET(x, v)  (HW_ENET_ATINC_WR(x, HW_ENET_ATINC_RD(x) |  (v)))
#define HW_ENET_ATINC_CLR(x, v)  (HW_ENET_ATINC_WR(x, HW_ENET_ATINC_RD(x) & ~(v)))
#define HW_ENET_ATINC_TOG(x, v)  (HW_ENET_ATINC_WR(x, HW_ENET_ATINC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_ATINC bitfields
 */

/*!
 * @name Register ENET_ATINC, field INC[6:0] (RW)
 *
 * The timer increments by this amount each clock cycle. For example, set to 10
 * for 100 MHz, 8 for 125 MHz, 5 for 200 MHz. For highest precision, use a value
 * that is an integer fraction of the period set in ATPER.
 */
/*@{*/
#define BP_ENET_ATINC_INC    (0U)          /*!< Bit position for ENET_ATINC_INC. */
#define BM_ENET_ATINC_INC    (0x0000007FU) /*!< Bit mask for ENET_ATINC_INC. */
#define BS_ENET_ATINC_INC    (7U)          /*!< Bit field size in bits for ENET_ATINC_INC. */

/*! @brief Read current value of the ENET_ATINC_INC field. */
#define BR_ENET_ATINC_INC(x) (HW_ENET_ATINC(x).B.INC)

/*! @brief Format value for bitfield ENET_ATINC_INC. */
#define BF_ENET_ATINC_INC(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATINC_INC) & BM_ENET_ATINC_INC)

/*! @brief Set the INC field to a new value. */
#define BW_ENET_ATINC_INC(x, v) (HW_ENET_ATINC_WR(x, (HW_ENET_ATINC_RD(x) & ~BM_ENET_ATINC_INC) | BF_ENET_ATINC_INC(v)))
/*@}*/

/*!
 * @name Register ENET_ATINC, field INC_CORR[14:8] (RW)
 *
 * This value is added every time the correction timer expires (every clock
 * cycle given in ATCOR). A value less than INC slows down the timer. A value greater
 * than INC speeds up the timer.
 */
/*@{*/
#define BP_ENET_ATINC_INC_CORR (8U)        /*!< Bit position for ENET_ATINC_INC_CORR. */
#define BM_ENET_ATINC_INC_CORR (0x00007F00U) /*!< Bit mask for ENET_ATINC_INC_CORR. */
#define BS_ENET_ATINC_INC_CORR (7U)        /*!< Bit field size in bits for ENET_ATINC_INC_CORR. */

/*! @brief Read current value of the ENET_ATINC_INC_CORR field. */
#define BR_ENET_ATINC_INC_CORR(x) (HW_ENET_ATINC(x).B.INC_CORR)

/*! @brief Format value for bitfield ENET_ATINC_INC_CORR. */
#define BF_ENET_ATINC_INC_CORR(v) ((uint32_t)((uint32_t)(v) << BP_ENET_ATINC_INC_CORR) & BM_ENET_ATINC_INC_CORR)

/*! @brief Set the INC_CORR field to a new value. */
#define BW_ENET_ATINC_INC_CORR(x, v) (HW_ENET_ATINC_WR(x, (HW_ENET_ATINC_RD(x) & ~BM_ENET_ATINC_INC_CORR) | BF_ENET_ATINC_INC_CORR(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_ATSTMP - Timestamp of Last Transmitted Frame
 ******************************************************************************/

/*!
 * @brief HW_ENET_ATSTMP - Timestamp of Last Transmitted Frame (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_atstmp
{
    uint32_t U;
    struct _hw_enet_atstmp_bitfields
    {
        uint32_t TIMESTAMP : 32;       /*!< [31:0]  */
    } B;
} hw_enet_atstmp_t;

/*!
 * @name Constants and macros for entire ENET_ATSTMP register
 */
/*@{*/
#define HW_ENET_ATSTMP_ADDR(x)   ((uintptr_t)(x) + 0x418U)

#define HW_ENET_ATSTMP(x)        (*(__I hw_enet_atstmp_t *) HW_ENET_ATSTMP_ADDR(x))
#define HW_ENET_ATSTMP_RD(x)     (HW_ENET_ATSTMP(x).U)
/*@}*/

/*
 * Constants & macros for individual ENET_ATSTMP bitfields
 */

/*!
 * @name Register ENET_ATSTMP, field TIMESTAMP[31:0] (RO)
 *
 * Timestamp of the last frame transmitted by the core that had TxBD[TS] set .
 * This register is only valid when EIR[TS_AVAIL] is set.
 */
/*@{*/
#define BP_ENET_ATSTMP_TIMESTAMP (0U)      /*!< Bit position for ENET_ATSTMP_TIMESTAMP. */
#define BM_ENET_ATSTMP_TIMESTAMP (0xFFFFFFFFU) /*!< Bit mask for ENET_ATSTMP_TIMESTAMP. */
#define BS_ENET_ATSTMP_TIMESTAMP (32U)     /*!< Bit field size in bits for ENET_ATSTMP_TIMESTAMP. */

/*! @brief Read current value of the ENET_ATSTMP_TIMESTAMP field. */
#define BR_ENET_ATSTMP_TIMESTAMP(x) (HW_ENET_ATSTMP(x).U)
/*@}*/

/*******************************************************************************
 * HW_ENET_TGSR - Timer Global Status Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TGSR - Timer Global Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_tgsr
{
    uint32_t U;
    struct _hw_enet_tgsr_bitfields
    {
        uint32_t TF0 : 1;              /*!< [0] Copy Of Timer Flag For Channel 0 */
        uint32_t TF1 : 1;              /*!< [1] Copy Of Timer Flag For Channel 1 */
        uint32_t TF2 : 1;              /*!< [2] Copy Of Timer Flag For Channel 2 */
        uint32_t TF3 : 1;              /*!< [3] Copy Of Timer Flag For Channel 3 */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_enet_tgsr_t;

/*!
 * @name Constants and macros for entire ENET_TGSR register
 */
/*@{*/
#define HW_ENET_TGSR_ADDR(x)     ((uintptr_t)(x) + 0x604U)

#define HW_ENET_TGSR(x)          (*(__IO hw_enet_tgsr_t *) HW_ENET_TGSR_ADDR(x))
#define HW_ENET_TGSR_RD(x)       (HW_ENET_TGSR(x).U)
#define HW_ENET_TGSR_WR(x, v)    (HW_ENET_TGSR(x).U = (v))
#define HW_ENET_TGSR_SET(x, v)   (HW_ENET_TGSR_WR(x, HW_ENET_TGSR_RD(x) |  (v)))
#define HW_ENET_TGSR_CLR(x, v)   (HW_ENET_TGSR_WR(x, HW_ENET_TGSR_RD(x) & ~(v)))
#define HW_ENET_TGSR_TOG(x, v)   (HW_ENET_TGSR_WR(x, HW_ENET_TGSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TGSR bitfields
 */

/*!
 * @name Register ENET_TGSR, field TF0[0] (W1C)
 *
 * Values:
 * - 0 - Timer Flag for Channel 0 is clear
 * - 1 - Timer Flag for Channel 0 is set
 */
/*@{*/
#define BP_ENET_TGSR_TF0     (0U)          /*!< Bit position for ENET_TGSR_TF0. */
#define BM_ENET_TGSR_TF0     (0x00000001U) /*!< Bit mask for ENET_TGSR_TF0. */
#define BS_ENET_TGSR_TF0     (1U)          /*!< Bit field size in bits for ENET_TGSR_TF0. */

/*! @brief Read current value of the ENET_TGSR_TF0 field. */
#define BR_ENET_TGSR_TF0(x)  (HW_ENET_TGSR(x).B.TF0)

/*! @brief Format value for bitfield ENET_TGSR_TF0. */
#define BF_ENET_TGSR_TF0(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TGSR_TF0) & BM_ENET_TGSR_TF0)

/*! @brief Set the TF0 field to a new value. */
#define BW_ENET_TGSR_TF0(x, v) (HW_ENET_TGSR_WR(x, (HW_ENET_TGSR_RD(x) & ~(BM_ENET_TGSR_TF0 | BM_ENET_TGSR_TF1 | BM_ENET_TGSR_TF2 | BM_ENET_TGSR_TF3)) | BF_ENET_TGSR_TF0(v)))
/*@}*/

/*!
 * @name Register ENET_TGSR, field TF1[1] (W1C)
 *
 * Values:
 * - 0 - Timer Flag for Channel 1 is clear
 * - 1 - Timer Flag for Channel 1 is set
 */
/*@{*/
#define BP_ENET_TGSR_TF1     (1U)          /*!< Bit position for ENET_TGSR_TF1. */
#define BM_ENET_TGSR_TF1     (0x00000002U) /*!< Bit mask for ENET_TGSR_TF1. */
#define BS_ENET_TGSR_TF1     (1U)          /*!< Bit field size in bits for ENET_TGSR_TF1. */

/*! @brief Read current value of the ENET_TGSR_TF1 field. */
#define BR_ENET_TGSR_TF1(x)  (HW_ENET_TGSR(x).B.TF1)

/*! @brief Format value for bitfield ENET_TGSR_TF1. */
#define BF_ENET_TGSR_TF1(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TGSR_TF1) & BM_ENET_TGSR_TF1)

/*! @brief Set the TF1 field to a new value. */
#define BW_ENET_TGSR_TF1(x, v) (HW_ENET_TGSR_WR(x, (HW_ENET_TGSR_RD(x) & ~(BM_ENET_TGSR_TF1 | BM_ENET_TGSR_TF0 | BM_ENET_TGSR_TF2 | BM_ENET_TGSR_TF3)) | BF_ENET_TGSR_TF1(v)))
/*@}*/

/*!
 * @name Register ENET_TGSR, field TF2[2] (W1C)
 *
 * Values:
 * - 0 - Timer Flag for Channel 2 is clear
 * - 1 - Timer Flag for Channel 2 is set
 */
/*@{*/
#define BP_ENET_TGSR_TF2     (2U)          /*!< Bit position for ENET_TGSR_TF2. */
#define BM_ENET_TGSR_TF2     (0x00000004U) /*!< Bit mask for ENET_TGSR_TF2. */
#define BS_ENET_TGSR_TF2     (1U)          /*!< Bit field size in bits for ENET_TGSR_TF2. */

/*! @brief Read current value of the ENET_TGSR_TF2 field. */
#define BR_ENET_TGSR_TF2(x)  (HW_ENET_TGSR(x).B.TF2)

/*! @brief Format value for bitfield ENET_TGSR_TF2. */
#define BF_ENET_TGSR_TF2(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TGSR_TF2) & BM_ENET_TGSR_TF2)

/*! @brief Set the TF2 field to a new value. */
#define BW_ENET_TGSR_TF2(x, v) (HW_ENET_TGSR_WR(x, (HW_ENET_TGSR_RD(x) & ~(BM_ENET_TGSR_TF2 | BM_ENET_TGSR_TF0 | BM_ENET_TGSR_TF1 | BM_ENET_TGSR_TF3)) | BF_ENET_TGSR_TF2(v)))
/*@}*/

/*!
 * @name Register ENET_TGSR, field TF3[3] (W1C)
 *
 * Values:
 * - 0 - Timer Flag for Channel 3 is clear
 * - 1 - Timer Flag for Channel 3 is set
 */
/*@{*/
#define BP_ENET_TGSR_TF3     (3U)          /*!< Bit position for ENET_TGSR_TF3. */
#define BM_ENET_TGSR_TF3     (0x00000008U) /*!< Bit mask for ENET_TGSR_TF3. */
#define BS_ENET_TGSR_TF3     (1U)          /*!< Bit field size in bits for ENET_TGSR_TF3. */

/*! @brief Read current value of the ENET_TGSR_TF3 field. */
#define BR_ENET_TGSR_TF3(x)  (HW_ENET_TGSR(x).B.TF3)

/*! @brief Format value for bitfield ENET_TGSR_TF3. */
#define BF_ENET_TGSR_TF3(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TGSR_TF3) & BM_ENET_TGSR_TF3)

/*! @brief Set the TF3 field to a new value. */
#define BW_ENET_TGSR_TF3(x, v) (HW_ENET_TGSR_WR(x, (HW_ENET_TGSR_RD(x) & ~(BM_ENET_TGSR_TF3 | BM_ENET_TGSR_TF0 | BM_ENET_TGSR_TF1 | BM_ENET_TGSR_TF2)) | BF_ENET_TGSR_TF3(v)))
/*@}*/

/*******************************************************************************
 * HW_ENET_TCSRn - Timer Control Status Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TCSRn - Timer Control Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_tcsrn
{
    uint32_t U;
    struct _hw_enet_tcsrn_bitfields
    {
        uint32_t TDRE : 1;             /*!< [0] Timer DMA Request Enable */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t TMODE : 4;            /*!< [5:2] Timer Mode */
        uint32_t TIE : 1;              /*!< [6] Timer Interrupt Enable */
        uint32_t TF : 1;               /*!< [7] Timer Flag */
        uint32_t RESERVED1 : 24;       /*!< [31:8]  */
    } B;
} hw_enet_tcsrn_t;

/*!
 * @name Constants and macros for entire ENET_TCSRn register
 */
/*@{*/
#define HW_ENET_TCSRn_COUNT (4U)

#define HW_ENET_TCSRn_ADDR(x, n) ((uintptr_t)(x) + 0x608U + (0x8U * (n)))

#define HW_ENET_TCSRn(x, n)      (*(__IO hw_enet_tcsrn_t *) HW_ENET_TCSRn_ADDR(x, n))
#define HW_ENET_TCSRn_RD(x, n)   (HW_ENET_TCSRn(x, n).U)
#define HW_ENET_TCSRn_WR(x, n, v) (HW_ENET_TCSRn(x, n).U = (v))
#define HW_ENET_TCSRn_SET(x, n, v) (HW_ENET_TCSRn_WR(x, n, HW_ENET_TCSRn_RD(x, n) |  (v)))
#define HW_ENET_TCSRn_CLR(x, n, v) (HW_ENET_TCSRn_WR(x, n, HW_ENET_TCSRn_RD(x, n) & ~(v)))
#define HW_ENET_TCSRn_TOG(x, n, v) (HW_ENET_TCSRn_WR(x, n, HW_ENET_TCSRn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TCSRn bitfields
 */

/*!
 * @name Register ENET_TCSRn, field TDRE[0] (RW)
 *
 * Values:
 * - 0 - DMA request is disabled
 * - 1 - DMA request is enabled
 */
/*@{*/
#define BP_ENET_TCSRn_TDRE   (0U)          /*!< Bit position for ENET_TCSRn_TDRE. */
#define BM_ENET_TCSRn_TDRE   (0x00000001U) /*!< Bit mask for ENET_TCSRn_TDRE. */
#define BS_ENET_TCSRn_TDRE   (1U)          /*!< Bit field size in bits for ENET_TCSRn_TDRE. */

/*! @brief Read current value of the ENET_TCSRn_TDRE field. */
#define BR_ENET_TCSRn_TDRE(x, n) (HW_ENET_TCSRn(x, n).B.TDRE)

/*! @brief Format value for bitfield ENET_TCSRn_TDRE. */
#define BF_ENET_TCSRn_TDRE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCSRn_TDRE) & BM_ENET_TCSRn_TDRE)

/*! @brief Set the TDRE field to a new value. */
#define BW_ENET_TCSRn_TDRE(x, n, v) (HW_ENET_TCSRn_WR(x, n, (HW_ENET_TCSRn_RD(x, n) & ~(BM_ENET_TCSRn_TDRE | BM_ENET_TCSRn_TF)) | BF_ENET_TCSRn_TDRE(v)))
/*@}*/

/*!
 * @name Register ENET_TCSRn, field TMODE[5:2] (RW)
 *
 * Updating the Timer Mode field takes a few cycles to register because it is
 * synchronized to the 1588 clock. The version of Timer Mode returned on a read is
 * from the 1588 clock domain. When changing Timer Mode, always disable the
 * channel and read this register to verify the channel is disabled first.
 *
 * Values:
 * - 0000 - Timer Channel is disabled.
 * - 0001 - Timer Channel is configured for Input Capture on rising edge.
 * - 0010 - Timer Channel is configured for Input Capture on falling edge.
 * - 0011 - Timer Channel is configured for Input Capture on both edges.
 * - 0100 - Timer Channel is configured for Output Compare - software only.
 * - 0101 - Timer Channel is configured for Output Compare - toggle output on
 *     compare.
 * - 0110 - Timer Channel is configured for Output Compare - clear output on
 *     compare.
 * - 0111 - Timer Channel is configured for Output Compare - set output on
 *     compare.
 * - 1000 - Reserved
 * - 1010 - Timer Channel is configured for Output Compare - clear output on
 *     compare, set output on overflow.
 * - 1110 - Timer Channel is configured for Output Compare - pulse output low on
 *     compare for one 1588-clock cycle.
 * - 1111 - Timer Channel is configured for Output Compare - pulse output high
 *     on compare for one 1588-clock cycle.
 */
/*@{*/
#define BP_ENET_TCSRn_TMODE  (2U)          /*!< Bit position for ENET_TCSRn_TMODE. */
#define BM_ENET_TCSRn_TMODE  (0x0000003CU) /*!< Bit mask for ENET_TCSRn_TMODE. */
#define BS_ENET_TCSRn_TMODE  (4U)          /*!< Bit field size in bits for ENET_TCSRn_TMODE. */

/*! @brief Read current value of the ENET_TCSRn_TMODE field. */
#define BR_ENET_TCSRn_TMODE(x, n) (HW_ENET_TCSRn(x, n).B.TMODE)

/*! @brief Format value for bitfield ENET_TCSRn_TMODE. */
#define BF_ENET_TCSRn_TMODE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCSRn_TMODE) & BM_ENET_TCSRn_TMODE)

/*! @brief Set the TMODE field to a new value. */
#define BW_ENET_TCSRn_TMODE(x, n, v) (HW_ENET_TCSRn_WR(x, n, (HW_ENET_TCSRn_RD(x, n) & ~(BM_ENET_TCSRn_TMODE | BM_ENET_TCSRn_TF)) | BF_ENET_TCSRn_TMODE(v)))
/*@}*/

/*!
 * @name Register ENET_TCSRn, field TIE[6] (RW)
 *
 * Values:
 * - 0 - Interrupt is disabled
 * - 1 - Interrupt is enabled
 */
/*@{*/
#define BP_ENET_TCSRn_TIE    (6U)          /*!< Bit position for ENET_TCSRn_TIE. */
#define BM_ENET_TCSRn_TIE    (0x00000040U) /*!< Bit mask for ENET_TCSRn_TIE. */
#define BS_ENET_TCSRn_TIE    (1U)          /*!< Bit field size in bits for ENET_TCSRn_TIE. */

/*! @brief Read current value of the ENET_TCSRn_TIE field. */
#define BR_ENET_TCSRn_TIE(x, n) (HW_ENET_TCSRn(x, n).B.TIE)

/*! @brief Format value for bitfield ENET_TCSRn_TIE. */
#define BF_ENET_TCSRn_TIE(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCSRn_TIE) & BM_ENET_TCSRn_TIE)

/*! @brief Set the TIE field to a new value. */
#define BW_ENET_TCSRn_TIE(x, n, v) (HW_ENET_TCSRn_WR(x, n, (HW_ENET_TCSRn_RD(x, n) & ~(BM_ENET_TCSRn_TIE | BM_ENET_TCSRn_TF)) | BF_ENET_TCSRn_TIE(v)))
/*@}*/

/*!
 * @name Register ENET_TCSRn, field TF[7] (W1C)
 *
 * Sets when input capture or output compare occurs. This flag is double
 * buffered between the module clock and 1588 clock domains. When this field is 1, it
 * can be cleared to 0 by writing 1 to it.
 *
 * Values:
 * - 0 - Input Capture or Output Compare has not occurred.
 * - 1 - Input Capture or Output Compare has occurred.
 */
/*@{*/
#define BP_ENET_TCSRn_TF     (7U)          /*!< Bit position for ENET_TCSRn_TF. */
#define BM_ENET_TCSRn_TF     (0x00000080U) /*!< Bit mask for ENET_TCSRn_TF. */
#define BS_ENET_TCSRn_TF     (1U)          /*!< Bit field size in bits for ENET_TCSRn_TF. */

/*! @brief Read current value of the ENET_TCSRn_TF field. */
#define BR_ENET_TCSRn_TF(x, n) (HW_ENET_TCSRn(x, n).B.TF)

/*! @brief Format value for bitfield ENET_TCSRn_TF. */
#define BF_ENET_TCSRn_TF(v)  ((uint32_t)((uint32_t)(v) << BP_ENET_TCSRn_TF) & BM_ENET_TCSRn_TF)

/*! @brief Set the TF field to a new value. */
#define BW_ENET_TCSRn_TF(x, n, v) (HW_ENET_TCSRn_WR(x, n, (HW_ENET_TCSRn_RD(x, n) & ~BM_ENET_TCSRn_TF) | BF_ENET_TCSRn_TF(v)))
/*@}*/
/*******************************************************************************
 * HW_ENET_TCCRn - Timer Compare Capture Register
 ******************************************************************************/

/*!
 * @brief HW_ENET_TCCRn - Timer Compare Capture Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_enet_tccrn
{
    uint32_t U;
    struct _hw_enet_tccrn_bitfields
    {
        uint32_t TCC : 32;             /*!< [31:0] Timer Capture Compare */
    } B;
} hw_enet_tccrn_t;

/*!
 * @name Constants and macros for entire ENET_TCCRn register
 */
/*@{*/
#define HW_ENET_TCCRn_COUNT (4U)

#define HW_ENET_TCCRn_ADDR(x, n) ((uintptr_t)(x) + 0x60CU + (0x8U * (n)))

#define HW_ENET_TCCRn(x, n)      (*(__IO hw_enet_tccrn_t *) HW_ENET_TCCRn_ADDR(x, n))
#define HW_ENET_TCCRn_RD(x, n)   (HW_ENET_TCCRn(x, n).U)
#define HW_ENET_TCCRn_WR(x, n, v) (HW_ENET_TCCRn(x, n).U = (v))
#define HW_ENET_TCCRn_SET(x, n, v) (HW_ENET_TCCRn_WR(x, n, HW_ENET_TCCRn_RD(x, n) |  (v)))
#define HW_ENET_TCCRn_CLR(x, n, v) (HW_ENET_TCCRn_WR(x, n, HW_ENET_TCCRn_RD(x, n) & ~(v)))
#define HW_ENET_TCCRn_TOG(x, n, v) (HW_ENET_TCCRn_WR(x, n, HW_ENET_TCCRn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ENET_TCCRn bitfields
 */

/*!
 * @name Register ENET_TCCRn, field TCC[31:0] (RW)
 *
 * This register is double buffered between the module clock and 1588 clock
 * domains. When configured for compare, the 1588 clock domain updates with the value
 * in the module clock domain whenever the Timer Channel is first enabled and on
 * each subsequent compare. Write to this register with the first compare value
 * before enabling the Timer Channel. When the Timer Channel is enabled, write
 * the second compare value either immediately, or at least before the first
 * compare occurs. After each compare, write the next compare value before the previous
 * compare occurs and before clearing the Timer Flag. The compare occurs one
 * 1588 clock cycle after the IEEE 1588 Counter increments past the compare value in
 * the 1588 clock domain. If the compare value is less than the value of the
 * 1588 Counter when the Timer Channel is first enabled, then the compare does not
 * occur until following the next overflow of the 1588 Counter. If the compare
 * value is greater than the IEEE 1588 Counter when the 1588 Counter overflows, or
 * the compare value is less than the value of the IEEE 1588 Counter after the
 * overflow, then the compare occurs one 1588 clock cycle following the overflow.
 * When configured for capture, the value of the IEEE 1588 Counter is captured into
 * the 1588 clock domain and then updated into the module clock domain, provided
 * the Timer Flag is clear. Always read the capture value before clearing the
 * Timer Flag.
 */
/*@{*/
#define BP_ENET_TCCRn_TCC    (0U)          /*!< Bit position for ENET_TCCRn_TCC. */
#define BM_ENET_TCCRn_TCC    (0xFFFFFFFFU) /*!< Bit mask for ENET_TCCRn_TCC. */
#define BS_ENET_TCCRn_TCC    (32U)         /*!< Bit field size in bits for ENET_TCCRn_TCC. */

/*! @brief Read current value of the ENET_TCCRn_TCC field. */
#define BR_ENET_TCCRn_TCC(x, n) (HW_ENET_TCCRn(x, n).U)

/*! @brief Format value for bitfield ENET_TCCRn_TCC. */
#define BF_ENET_TCCRn_TCC(v) ((uint32_t)((uint32_t)(v) << BP_ENET_TCCRn_TCC) & BM_ENET_TCCRn_TCC)

/*! @brief Set the TCC field to a new value. */
#define BW_ENET_TCCRn_TCC(x, n, v) (HW_ENET_TCCRn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * hw_enet_t - module struct
 ******************************************************************************/
/*!
 * @brief All ENET module registers.
 */
#pragma pack(1)
typedef struct _hw_enet
{
    uint8_t _reserved0[4];
    __IO hw_enet_eir_t EIR;                /*!< [0x4] Interrupt Event Register */
    __IO hw_enet_eimr_t EIMR;              /*!< [0x8] Interrupt Mask Register */
    uint8_t _reserved1[4];
    __IO hw_enet_rdar_t RDAR;              /*!< [0x10] Receive Descriptor Active Register */
    __IO hw_enet_tdar_t TDAR;              /*!< [0x14] Transmit Descriptor Active Register */
    uint8_t _reserved2[12];
    __IO hw_enet_ecr_t ECR;                /*!< [0x24] Ethernet Control Register */
    uint8_t _reserved3[24];
    __IO hw_enet_mmfr_t MMFR;              /*!< [0x40] MII Management Frame Register */
    __IO hw_enet_mscr_t MSCR;              /*!< [0x44] MII Speed Control Register */
    uint8_t _reserved4[28];
    __IO hw_enet_mibc_t MIBC;              /*!< [0x64] MIB Control Register */
    uint8_t _reserved5[28];
    __IO hw_enet_rcr_t RCR;                /*!< [0x84] Receive Control Register */
    uint8_t _reserved6[60];
    __IO hw_enet_tcr_t TCR;                /*!< [0xC4] Transmit Control Register */
    uint8_t _reserved7[28];
    __IO hw_enet_palr_t PALR;              /*!< [0xE4] Physical Address Lower Register */
    __IO hw_enet_paur_t PAUR;              /*!< [0xE8] Physical Address Upper Register */
    __IO hw_enet_opd_t OPD;                /*!< [0xEC] Opcode/Pause Duration Register */
    uint8_t _reserved8[40];
    __IO hw_enet_iaur_t IAUR;              /*!< [0x118] Descriptor Individual Upper Address Register */
    __IO hw_enet_ialr_t IALR;              /*!< [0x11C] Descriptor Individual Lower Address Register */
    __IO hw_enet_gaur_t GAUR;              /*!< [0x120] Descriptor Group Upper Address Register */
    __IO hw_enet_galr_t GALR;              /*!< [0x124] Descriptor Group Lower Address Register */
    uint8_t _reserved9[28];
    __IO hw_enet_tfwr_t TFWR;              /*!< [0x144] Transmit FIFO Watermark Register */
    uint8_t _reserved10[56];
    __IO hw_enet_rdsr_t RDSR;              /*!< [0x180] Receive Descriptor Ring Start Register */
    __IO hw_enet_tdsr_t TDSR;              /*!< [0x184] Transmit Buffer Descriptor Ring Start Register */
    __IO hw_enet_mrbr_t MRBR;              /*!< [0x188] Maximum Receive Buffer Size Register */
    uint8_t _reserved11[4];
    __IO hw_enet_rsfl_t RSFL;              /*!< [0x190] Receive FIFO Section Full Threshold */
    __IO hw_enet_rsem_t RSEM;              /*!< [0x194] Receive FIFO Section Empty Threshold */
    __IO hw_enet_raem_t RAEM;              /*!< [0x198] Receive FIFO Almost Empty Threshold */
    __IO hw_enet_rafl_t RAFL;              /*!< [0x19C] Receive FIFO Almost Full Threshold */
    __IO hw_enet_tsem_t TSEM;              /*!< [0x1A0] Transmit FIFO Section Empty Threshold */
    __IO hw_enet_taem_t TAEM;              /*!< [0x1A4] Transmit FIFO Almost Empty Threshold */
    __IO hw_enet_tafl_t TAFL;              /*!< [0x1A8] Transmit FIFO Almost Full Threshold */
    __IO hw_enet_tipg_t TIPG;              /*!< [0x1AC] Transmit Inter-Packet Gap */
    __IO hw_enet_ftrl_t FTRL;              /*!< [0x1B0] Frame Truncation Length */
    uint8_t _reserved12[12];
    __IO hw_enet_tacc_t TACC;              /*!< [0x1C0] Transmit Accelerator Function Configuration */
    __IO hw_enet_racc_t RACC;              /*!< [0x1C4] Receive Accelerator Function Configuration */
    uint8_t _reserved13[56];
    __I hw_enet_rmon_t_drop_t RMON_T_DROP; /*!< [0x200] Reserved Statistic Register */
    __I hw_enet_rmon_t_packets_t RMON_T_PACKETS; /*!< [0x204] Tx Packet Count Statistic Register */
    __I hw_enet_rmon_t_bc_pkt_t RMON_T_BC_PKT; /*!< [0x208] Tx Broadcast Packets Statistic Register */
    __I hw_enet_rmon_t_mc_pkt_t RMON_T_MC_PKT; /*!< [0x20C] Tx Multicast Packets Statistic Register */
    __I hw_enet_rmon_t_crc_align_t RMON_T_CRC_ALIGN; /*!< [0x210] Tx Packets with CRC/Align Error Statistic Register */
    __I hw_enet_rmon_t_undersize_t RMON_T_UNDERSIZE; /*!< [0x214] Tx Packets Less Than Bytes and Good CRC Statistic Register */
    __I hw_enet_rmon_t_oversize_t RMON_T_OVERSIZE; /*!< [0x218] Tx Packets GT MAX_FL bytes and Good CRC Statistic Register */
    __I hw_enet_rmon_t_frag_t RMON_T_FRAG; /*!< [0x21C] Tx Packets Less Than 64 Bytes and Bad CRC Statistic Register */
    __I hw_enet_rmon_t_jab_t RMON_T_JAB;   /*!< [0x220] Tx Packets Greater Than MAX_FL bytes and Bad CRC Statistic Register */
    __I hw_enet_rmon_t_col_t RMON_T_COL;   /*!< [0x224] Tx Collision Count Statistic Register */
    __I hw_enet_rmon_t_p64_t RMON_T_P64;   /*!< [0x228] Tx 64-Byte Packets Statistic Register */
    __I hw_enet_rmon_t_p65to127_t RMON_T_P65TO127; /*!< [0x22C] Tx 65- to 127-byte Packets Statistic Register */
    __I hw_enet_rmon_t_p128to255_t RMON_T_P128TO255; /*!< [0x230] Tx 128- to 255-byte Packets Statistic Register */
    __I hw_enet_rmon_t_p256to511_t RMON_T_P256TO511; /*!< [0x234] Tx 256- to 511-byte Packets Statistic Register */
    __I hw_enet_rmon_t_p512to1023_t RMON_T_P512TO1023; /*!< [0x238] Tx 512- to 1023-byte Packets Statistic Register */
    __I hw_enet_rmon_t_p1024to2047_t RMON_T_P1024TO2047; /*!< [0x23C] Tx 1024- to 2047-byte Packets Statistic Register */
    __I hw_enet_rmon_t_p_gte2048_t RMON_T_P_GTE2048; /*!< [0x240] Tx Packets Greater Than 2048 Bytes Statistic Register */
    __I hw_enet_rmon_t_octets_t RMON_T_OCTETS; /*!< [0x244] Tx Octets Statistic Register */
    __I hw_enet_ieee_t_drop_t IEEE_T_DROP; /*!< [0x248] Reserved Statistic Register */
    __I hw_enet_ieee_t_frame_ok_t IEEE_T_FRAME_OK; /*!< [0x24C] Frames Transmitted OK Statistic Register */
    __I hw_enet_ieee_t_1col_t IEEE_T_1COL; /*!< [0x250] Frames Transmitted with Single Collision Statistic Register */
    __I hw_enet_ieee_t_mcol_t IEEE_T_MCOL; /*!< [0x254] Frames Transmitted with Multiple Collisions Statistic Register */
    __I hw_enet_ieee_t_def_t IEEE_T_DEF;   /*!< [0x258] Frames Transmitted after Deferral Delay Statistic Register */
    __I hw_enet_ieee_t_lcol_t IEEE_T_LCOL; /*!< [0x25C] Frames Transmitted with Late Collision Statistic Register */
    __I hw_enet_ieee_t_excol_t IEEE_T_EXCOL; /*!< [0x260] Frames Transmitted with Excessive Collisions Statistic Register */
    __I hw_enet_ieee_t_macerr_t IEEE_T_MACERR; /*!< [0x264] Frames Transmitted with Tx FIFO Underrun Statistic Register */
    __I hw_enet_ieee_t_cserr_t IEEE_T_CSERR; /*!< [0x268] Frames Transmitted with Carrier Sense Error Statistic Register */
    __I hw_enet_ieee_t_sqe_t IEEE_T_SQE;   /*!< [0x26C] Reserved Statistic Register */
    __I hw_enet_ieee_t_fdxfc_t IEEE_T_FDXFC; /*!< [0x270] Flow Control Pause Frames Transmitted Statistic Register */
    __I hw_enet_ieee_t_octets_ok_t IEEE_T_OCTETS_OK; /*!< [0x274] Octet Count for Frames Transmitted w/o Error Statistic Register */
    uint8_t _reserved14[12];
    __I hw_enet_rmon_r_packets_t RMON_R_PACKETS; /*!< [0x284] Rx Packet Count Statistic Register */
    __I hw_enet_rmon_r_bc_pkt_t RMON_R_BC_PKT; /*!< [0x288] Rx Broadcast Packets Statistic Register */
    __I hw_enet_rmon_r_mc_pkt_t RMON_R_MC_PKT; /*!< [0x28C] Rx Multicast Packets Statistic Register */
    __I hw_enet_rmon_r_crc_align_t RMON_R_CRC_ALIGN; /*!< [0x290] Rx Packets with CRC/Align Error Statistic Register */
    __I hw_enet_rmon_r_undersize_t RMON_R_UNDERSIZE; /*!< [0x294] Rx Packets with Less Than 64 Bytes and Good CRC Statistic Register */
    __I hw_enet_rmon_r_oversize_t RMON_R_OVERSIZE; /*!< [0x298] Rx Packets Greater Than MAX_FL and Good CRC Statistic Register */
    __I hw_enet_rmon_r_frag_t RMON_R_FRAG; /*!< [0x29C] Rx Packets Less Than 64 Bytes and Bad CRC Statistic Register */
    __I hw_enet_rmon_r_jab_t RMON_R_JAB;   /*!< [0x2A0] Rx Packets Greater Than MAX_FL Bytes and Bad CRC Statistic Register */
    __I hw_enet_rmon_r_resvd_0_t RMON_R_RESVD_0; /*!< [0x2A4] Reserved Statistic Register */
    __I hw_enet_rmon_r_p64_t RMON_R_P64;   /*!< [0x2A8] Rx 64-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p65to127_t RMON_R_P65TO127; /*!< [0x2AC] Rx 65- to 127-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p128to255_t RMON_R_P128TO255; /*!< [0x2B0] Rx 128- to 255-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p256to511_t RMON_R_P256TO511; /*!< [0x2B4] Rx 256- to 511-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p512to1023_t RMON_R_P512TO1023; /*!< [0x2B8] Rx 512- to 1023-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p1024to2047_t RMON_R_P1024TO2047; /*!< [0x2BC] Rx 1024- to 2047-Byte Packets Statistic Register */
    __I hw_enet_rmon_r_p_gte2048_t RMON_R_P_GTE2048; /*!< [0x2C0] Rx Packets Greater than 2048 Bytes Statistic Register */
    __I hw_enet_rmon_r_octets_t RMON_R_OCTETS; /*!< [0x2C4] Rx Octets Statistic Register */
    __I hw_enet_ieee_r_drop_t IEEE_R_DROP; /*!< [0x2C8] Frames not Counted Correctly Statistic Register */
    __I hw_enet_ieee_r_frame_ok_t IEEE_R_FRAME_OK; /*!< [0x2CC] Frames Received OK Statistic Register */
    __I hw_enet_ieee_r_crc_t IEEE_R_CRC;   /*!< [0x2D0] Frames Received with CRC Error Statistic Register */
    __I hw_enet_ieee_r_align_t IEEE_R_ALIGN; /*!< [0x2D4] Frames Received with Alignment Error Statistic Register */
    __I hw_enet_ieee_r_macerr_t IEEE_R_MACERR; /*!< [0x2D8] Receive FIFO Overflow Count Statistic Register */
    __I hw_enet_ieee_r_fdxfc_t IEEE_R_FDXFC; /*!< [0x2DC] Flow Control Pause Frames Received Statistic Register */
    __I hw_enet_ieee_r_octets_ok_t IEEE_R_OCTETS_OK; /*!< [0x2E0] Octet Count for Frames Received without Error Statistic Register */
    uint8_t _reserved15[284];
    __IO hw_enet_atcr_t ATCR;              /*!< [0x400] Adjustable Timer Control Register */
    __IO hw_enet_atvr_t ATVR;              /*!< [0x404] Timer Value Register */
    __IO hw_enet_atoff_t ATOFF;            /*!< [0x408] Timer Offset Register */
    __IO hw_enet_atper_t ATPER;            /*!< [0x40C] Timer Period Register */
    __IO hw_enet_atcor_t ATCOR;            /*!< [0x410] Timer Correction Register */
    __IO hw_enet_atinc_t ATINC;            /*!< [0x414] Time-Stamping Clock Period Register */
    __I hw_enet_atstmp_t ATSTMP;           /*!< [0x418] Timestamp of Last Transmitted Frame */
    uint8_t _reserved16[488];
    __IO hw_enet_tgsr_t TGSR;              /*!< [0x604] Timer Global Status Register */
    struct {
        __IO hw_enet_tcsrn_t TCSRn;        /*!< [0x608] Timer Control Status Register */
        __IO hw_enet_tccrn_t TCCRn;        /*!< [0x60C] Timer Compare Capture Register */
    } TCxR[4];
} hw_enet_t;
#pragma pack()

/*! @brief Macro to access all ENET registers. */
/*! @param x ENET module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ENET_REGS(ENET_BASE)</code>. */
#define HW_ENET_REGS(x) (*(hw_enet_t *)(x))

/*
 * iMX6DP EPIT
 *
 * EPIT
 *
 * Registers defined in this header file:
 * - HW_EPIT_CR - Control register
 * - HW_EPIT_SR - Status register
 * - HW_EPIT_LR - Load register
 * - HW_EPIT_CMPR - Compare register
 * - HW_EPIT_CNR - Counter register
 *
 * - hw_epit_t - Struct containing all module registers.
 */

#define HW_EPIT_INSTANCE_COUNT (2U) /*!< Number of instances of the EPIT module. */
#define HW_EPIT1 (0U) /*!< Instance number for EPIT1. */
#define HW_EPIT2 (1U) /*!< Instance number for EPIT2. */
#define EPIT1_BASE            (0x20D0000U) /*!< Base address for EPIT1. */
#define EPIT2_BASE            (0x20D4000U) /*!< Base address for EPIT2. */
/*! Array initializer of EPIT base addresses. */
#define EPIT_BASE_ADDRS       { EPIT1_BASE, EPIT2_BASE }

/*******************************************************************************
 * HW_EPIT_CR - Control register
 ******************************************************************************/

/*!
 * @brief HW_EPIT_CR - Control register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The EPIT control register (EPIT_CR) is used to configure the operating
 * settings of the EPIT. It contains the clock division prescaler value and also the
 * interrupt enable bit. Additionally, it contains other control bits which are
 * described below. Peripheral Bus Write access to EPIT Control Register (EPIT_CR)
 * results in one cycle of the wait state, while other valid peripheral bus
 * accesses are with 0 wait state.
 */
typedef union _hw_epit_cr
{
    uint32_t U;
    struct _hw_epit_cr_bitfields
    {
        uint32_t EN : 1;               /*!< [0]  */
        uint32_t ENMOD : 1;            /*!< [1]  */
        uint32_t OCIEN : 1;            /*!< [2]  */
        uint32_t RLD : 1;              /*!< [3]  */
        uint32_t PRESCALAR : 12;       /*!< [15:4]  */
        uint32_t SWR : 1;              /*!< [16]  */
        uint32_t IOVW : 1;             /*!< [17]  */
        uint32_t DBGEN : 1;            /*!< [18]  */
        uint32_t WAITEN : 1;           /*!< [19]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t STOPEN : 1;           /*!< [21]  */
        uint32_t OM : 2;               /*!< [23:22]  */
        uint32_t CLKSRC : 2;           /*!< [25:24]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_epit_cr_t;

/*!
 * @name Constants and macros for entire EPIT_CR register
 */
/*@{*/
#define HW_EPIT_CR_ADDR(x)       ((uintptr_t)(x) + 0x0U)

#define HW_EPIT_CR(x)            (*(__IO hw_epit_cr_t *) HW_EPIT_CR_ADDR(x))
#define HW_EPIT_CR_RD(x)         (HW_EPIT_CR(x).U)
#define HW_EPIT_CR_WR(x, v)      (HW_EPIT_CR(x).U = (v))
#define HW_EPIT_CR_SET(x, v)     (HW_EPIT_CR_WR(x, HW_EPIT_CR_RD(x) |  (v)))
#define HW_EPIT_CR_CLR(x, v)     (HW_EPIT_CR_WR(x, HW_EPIT_CR_RD(x) & ~(v)))
#define HW_EPIT_CR_TOG(x, v)     (HW_EPIT_CR_WR(x, HW_EPIT_CR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EPIT_CR bitfields
 */

/*!
 * @name Register EPIT_CR, field EN[0] (RW)
 *
 * This bit enables the EPIT. EPIT counter and prescaler value when EPIT is
 * enabled (EN = 1), is dependent upon ENMOD and RLD bit as described for ENMOD bit.
 * It is recommended that all registers be properly programmed before setting
 * this bit. This bit is reset by a hardware reset. A software reset does not affect
 * this bit.
 *
 * Values:
 * - 0 - EPIT is disabled
 * - 1 - EPIT is enabled
 */
/*@{*/
#define BP_EPIT_CR_EN        (0U)          /*!< Bit position for EPIT_CR_EN. */
#define BM_EPIT_CR_EN        (0x00000001U) /*!< Bit mask for EPIT_CR_EN. */
#define BS_EPIT_CR_EN        (1U)          /*!< Bit field size in bits for EPIT_CR_EN. */

/*! @brief Read current value of the EPIT_CR_EN field. */
#define BR_EPIT_CR_EN(x)     (HW_EPIT_CR(x).B.EN)

/*! @brief Format value for bitfield EPIT_CR_EN. */
#define BF_EPIT_CR_EN(v)     ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_EN) & BM_EPIT_CR_EN)

/*! @brief Set the EN field to a new value. */
#define BW_EPIT_CR_EN(x, v)  (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_EN) | BF_EPIT_CR_EN(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field ENMOD[1] (RW)
 *
 * EPIT enable mode. When EPIT is disabled (EN=0), both main counter and
 * prescaler counter freeze their count at current count values. ENMOD bit is a r/w bit
 * that determines the counter value when the EPIT is enabled again by setting EN
 * bit. If ENMOD bit is set, then main counter is loaded with the load value (If
 * RLD=1)/ 0xFFFF_FFFF (If RLD=0) and prescaler counter is reset, when EPIT is
 * enabled (EN=1). If ENMOD is programmed to 0 then both main counter and
 * prescaler counter restart counting from their frozen values when EPIT is enabled
 * (EN=1). If EPIT is programmed to be disabled in a low-power mode (STOP/WAIT/DEBUG),
 * then both the main counter and the prescaler counter freeze at their current
 * count values when EPIT enters low-power mode. When EPIT exits the low-power
 * mode, both main counter and prescaler counter start counting from their frozen
 * values irrespective of the ENMOD bit. This bit is reset by a hardware reset. A
 * software reset does not affect this bit.
 *
 * Values:
 * - 0 - Counter starts counting from the value it had when it was disabled.
 * - 1 - Counter starts count from load value (RLD=1) or 0xFFFF_FFFF (If RLD=0)
 */
/*@{*/
#define BP_EPIT_CR_ENMOD     (1U)          /*!< Bit position for EPIT_CR_ENMOD. */
#define BM_EPIT_CR_ENMOD     (0x00000002U) /*!< Bit mask for EPIT_CR_ENMOD. */
#define BS_EPIT_CR_ENMOD     (1U)          /*!< Bit field size in bits for EPIT_CR_ENMOD. */

/*! @brief Read current value of the EPIT_CR_ENMOD field. */
#define BR_EPIT_CR_ENMOD(x)  (HW_EPIT_CR(x).B.ENMOD)

/*! @brief Format value for bitfield EPIT_CR_ENMOD. */
#define BF_EPIT_CR_ENMOD(v)  ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_ENMOD) & BM_EPIT_CR_ENMOD)

/*! @brief Set the ENMOD field to a new value. */
#define BW_EPIT_CR_ENMOD(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_ENMOD) | BF_EPIT_CR_ENMOD(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field OCIEN[2] (RW)
 *
 * Output compare interrupt enable. This bit enables the generation of interrupt
 * on occurrence of compare event.
 *
 * Values:
 * - 0 - Compare interrupt disabled
 * - 1 - Compare interrupt enabled
 */
/*@{*/
#define BP_EPIT_CR_OCIEN     (2U)          /*!< Bit position for EPIT_CR_OCIEN. */
#define BM_EPIT_CR_OCIEN     (0x00000004U) /*!< Bit mask for EPIT_CR_OCIEN. */
#define BS_EPIT_CR_OCIEN     (1U)          /*!< Bit field size in bits for EPIT_CR_OCIEN. */

/*! @brief Read current value of the EPIT_CR_OCIEN field. */
#define BR_EPIT_CR_OCIEN(x)  (HW_EPIT_CR(x).B.OCIEN)

/*! @brief Format value for bitfield EPIT_CR_OCIEN. */
#define BF_EPIT_CR_OCIEN(v)  ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_OCIEN) & BM_EPIT_CR_OCIEN)

/*! @brief Set the OCIEN field to a new value. */
#define BW_EPIT_CR_OCIEN(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_OCIEN) | BF_EPIT_CR_OCIEN(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field RLD[3] (RW)
 *
 * Counter reload control. This bit is cleared by hardware reset. It decides the
 * counter functionality, whether to run in free-running mode or set-and-forget
 * mode.
 *
 * Values:
 * - 0 - When the counter reaches zero it rolls over to 0xFFFF_FFFF
 *     (free-running mode)
 * - 1 - When the counter reaches zero it reloads from the modulus register
 *     (set-and-forget mode)
 */
/*@{*/
#define BP_EPIT_CR_RLD       (3U)          /*!< Bit position for EPIT_CR_RLD. */
#define BM_EPIT_CR_RLD       (0x00000008U) /*!< Bit mask for EPIT_CR_RLD. */
#define BS_EPIT_CR_RLD       (1U)          /*!< Bit field size in bits for EPIT_CR_RLD. */

/*! @brief Read current value of the EPIT_CR_RLD field. */
#define BR_EPIT_CR_RLD(x)    (HW_EPIT_CR(x).B.RLD)

/*! @brief Format value for bitfield EPIT_CR_RLD. */
#define BF_EPIT_CR_RLD(v)    ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_RLD) & BM_EPIT_CR_RLD)

/*! @brief Set the RLD field to a new value. */
#define BW_EPIT_CR_RLD(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_RLD) | BF_EPIT_CR_RLD(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field PRESCALAR[15:4] (RW)
 *
 * Counter clock prescaler value. This bit field determines the prescaler value
 * by which the clock is divided before it goes to the counter
 *
 * Values:
 * - 0 - Divide by 1
 * - 1 - Divide by 2...
 * - 111111111111 - Divide by 4096
 */
/*@{*/
#define BP_EPIT_CR_PRESCALAR (4U)          /*!< Bit position for EPIT_CR_PRESCALAR. */
#define BM_EPIT_CR_PRESCALAR (0x0000FFF0U) /*!< Bit mask for EPIT_CR_PRESCALAR. */
#define BS_EPIT_CR_PRESCALAR (12U)         /*!< Bit field size in bits for EPIT_CR_PRESCALAR. */

/*! @brief Read current value of the EPIT_CR_PRESCALAR field. */
#define BR_EPIT_CR_PRESCALAR(x) (HW_EPIT_CR(x).B.PRESCALAR)

/*! @brief Format value for bitfield EPIT_CR_PRESCALAR. */
#define BF_EPIT_CR_PRESCALAR(v) ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_PRESCALAR) & BM_EPIT_CR_PRESCALAR)

/*! @brief Set the PRESCALAR field to a new value. */
#define BW_EPIT_CR_PRESCALAR(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_PRESCALAR) | BF_EPIT_CR_PRESCALAR(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field SWR[16] (RW)
 *
 * Software reset. The EPIT is reset when this bit is set to 1. It is a self
 * clearing bit. This bit is set when the block is in reset state and is cleared
 * when the reset procedure is over. Setting this bit resets all the registers to
 * their reset values, except for the EN, ENMOD, STOPEN, WAITEN and DBGEN bits in
 * this control register
 *
 * Values:
 * - 0 - EPIT is out of reset
 * - 1 - EPIT is undergoing reset
 */
/*@{*/
#define BP_EPIT_CR_SWR       (16U)         /*!< Bit position for EPIT_CR_SWR. */
#define BM_EPIT_CR_SWR       (0x00010000U) /*!< Bit mask for EPIT_CR_SWR. */
#define BS_EPIT_CR_SWR       (1U)          /*!< Bit field size in bits for EPIT_CR_SWR. */

/*! @brief Read current value of the EPIT_CR_SWR field. */
#define BR_EPIT_CR_SWR(x)    (HW_EPIT_CR(x).B.SWR)

/*! @brief Format value for bitfield EPIT_CR_SWR. */
#define BF_EPIT_CR_SWR(v)    ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_SWR) & BM_EPIT_CR_SWR)

/*! @brief Set the SWR field to a new value. */
#define BW_EPIT_CR_SWR(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_SWR) | BF_EPIT_CR_SWR(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field IOVW[17] (RW)
 *
 * EPIT counter overwrite enable. This bit controls the counter data when the
 * modulus register is written. When this bit is set, all writes to the load
 * register overwrites the counter contents and the counter starts subsequently
 * counting down from the programmed value.
 *
 * Values:
 * - 0 - Write to load register does not result in counter value being
 *     overwritten.
 * - 1 - Write to load register results in immediate overwriting of counter
 *     value.
 */
/*@{*/
#define BP_EPIT_CR_IOVW      (17U)         /*!< Bit position for EPIT_CR_IOVW. */
#define BM_EPIT_CR_IOVW      (0x00020000U) /*!< Bit mask for EPIT_CR_IOVW. */
#define BS_EPIT_CR_IOVW      (1U)          /*!< Bit field size in bits for EPIT_CR_IOVW. */

/*! @brief Read current value of the EPIT_CR_IOVW field. */
#define BR_EPIT_CR_IOVW(x)   (HW_EPIT_CR(x).B.IOVW)

/*! @brief Format value for bitfield EPIT_CR_IOVW. */
#define BF_EPIT_CR_IOVW(v)   ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_IOVW) & BM_EPIT_CR_IOVW)

/*! @brief Set the IOVW field to a new value. */
#define BW_EPIT_CR_IOVW(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_IOVW) | BF_EPIT_CR_IOVW(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field DBGEN[18] (RW)
 *
 * This bit is used to keep the EPIT functional in debug mode. When this bit is
 * cleared, the input clock is gated off in debug mode.This bit is reset by
 * hardware reset. A software reset does not affect this bit.
 *
 * Values:
 * - 0 - Inactive in debug mode
 * - 1 - Active in debug mode
 */
/*@{*/
#define BP_EPIT_CR_DBGEN     (18U)         /*!< Bit position for EPIT_CR_DBGEN. */
#define BM_EPIT_CR_DBGEN     (0x00040000U) /*!< Bit mask for EPIT_CR_DBGEN. */
#define BS_EPIT_CR_DBGEN     (1U)          /*!< Bit field size in bits for EPIT_CR_DBGEN. */

/*! @brief Read current value of the EPIT_CR_DBGEN field. */
#define BR_EPIT_CR_DBGEN(x)  (HW_EPIT_CR(x).B.DBGEN)

/*! @brief Format value for bitfield EPIT_CR_DBGEN. */
#define BF_EPIT_CR_DBGEN(v)  ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_DBGEN) & BM_EPIT_CR_DBGEN)

/*! @brief Set the DBGEN field to a new value. */
#define BW_EPIT_CR_DBGEN(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_DBGEN) | BF_EPIT_CR_DBGEN(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field WAITEN[19] (RW)
 *
 * This read/write control bit enables the operation of the EPIT during wait
 * mode. This bit is reset by a hardware reset. A software reset does not affect
 * this bit.
 *
 * Values:
 * - 0 - EPIT is disabled in wait mode
 * - 1 - EPIT is enabled in wait mode
 */
/*@{*/
#define BP_EPIT_CR_WAITEN    (19U)         /*!< Bit position for EPIT_CR_WAITEN. */
#define BM_EPIT_CR_WAITEN    (0x00080000U) /*!< Bit mask for EPIT_CR_WAITEN. */
#define BS_EPIT_CR_WAITEN    (1U)          /*!< Bit field size in bits for EPIT_CR_WAITEN. */

/*! @brief Read current value of the EPIT_CR_WAITEN field. */
#define BR_EPIT_CR_WAITEN(x) (HW_EPIT_CR(x).B.WAITEN)

/*! @brief Format value for bitfield EPIT_CR_WAITEN. */
#define BF_EPIT_CR_WAITEN(v) ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_WAITEN) & BM_EPIT_CR_WAITEN)

/*! @brief Set the WAITEN field to a new value. */
#define BW_EPIT_CR_WAITEN(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_WAITEN) | BF_EPIT_CR_WAITEN(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field STOPEN[21] (RW)
 *
 * EPIT stop mode enable. This read/write control bit enables the operation of
 * the EPIT during stop mode. This bit is reset by a hardware reset and unaffected
 * by software reset.
 *
 * Values:
 * - 0 - EPIT is disabled in stop mode
 * - 1 - EPIT is enabled in stop mode
 */
/*@{*/
#define BP_EPIT_CR_STOPEN    (21U)         /*!< Bit position for EPIT_CR_STOPEN. */
#define BM_EPIT_CR_STOPEN    (0x00200000U) /*!< Bit mask for EPIT_CR_STOPEN. */
#define BS_EPIT_CR_STOPEN    (1U)          /*!< Bit field size in bits for EPIT_CR_STOPEN. */

/*! @brief Read current value of the EPIT_CR_STOPEN field. */
#define BR_EPIT_CR_STOPEN(x) (HW_EPIT_CR(x).B.STOPEN)

/*! @brief Format value for bitfield EPIT_CR_STOPEN. */
#define BF_EPIT_CR_STOPEN(v) ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_STOPEN) & BM_EPIT_CR_STOPEN)

/*! @brief Set the STOPEN field to a new value. */
#define BW_EPIT_CR_STOPEN(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_STOPEN) | BF_EPIT_CR_STOPEN(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field OM[23:22] (RW)
 *
 * EPIT output mode.This bit field determines the mode of EPIT output on the
 * output pin.
 *
 * Values:
 * - 00 - EPIT output is disconnected from pad
 * - 01 - Toggle output pin
 * - 10 - Clear output pin
 * - 11 - Set output pin
 */
/*@{*/
#define BP_EPIT_CR_OM        (22U)         /*!< Bit position for EPIT_CR_OM. */
#define BM_EPIT_CR_OM        (0x00C00000U) /*!< Bit mask for EPIT_CR_OM. */
#define BS_EPIT_CR_OM        (2U)          /*!< Bit field size in bits for EPIT_CR_OM. */

/*! @brief Read current value of the EPIT_CR_OM field. */
#define BR_EPIT_CR_OM(x)     (HW_EPIT_CR(x).B.OM)

/*! @brief Format value for bitfield EPIT_CR_OM. */
#define BF_EPIT_CR_OM(v)     ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_OM) & BM_EPIT_CR_OM)

/*! @brief Set the OM field to a new value. */
#define BW_EPIT_CR_OM(x, v)  (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_OM) | BF_EPIT_CR_OM(v)))
/*@}*/

/*!
 * @name Register EPIT_CR, field CLKSRC[25:24] (RW)
 *
 * Select clock source These bits determine which clock input is to be selected
 * for running the counter. This field value should only be changed when the EPIT
 * is disabled by clearing the EN bit in this register. For other programming
 * requirements while changing clock source, refer to Change of Clock SourceThe
 * CLKSRC field in EPIT_EPITCR determines the clock source. This field value should
 * be changed only after disabling the EPIT (EN = 0). .
 *
 * Values:
 * - 00 - Clock is off
 * - 01 - Peripheral clock
 * - 10 - High-frequency reference clock
 * - 11 - Low-frequency reference clock
 */
/*@{*/
#define BP_EPIT_CR_CLKSRC    (24U)         /*!< Bit position for EPIT_CR_CLKSRC. */
#define BM_EPIT_CR_CLKSRC    (0x03000000U) /*!< Bit mask for EPIT_CR_CLKSRC. */
#define BS_EPIT_CR_CLKSRC    (2U)          /*!< Bit field size in bits for EPIT_CR_CLKSRC. */

/*! @brief Read current value of the EPIT_CR_CLKSRC field. */
#define BR_EPIT_CR_CLKSRC(x) (HW_EPIT_CR(x).B.CLKSRC)

/*! @brief Format value for bitfield EPIT_CR_CLKSRC. */
#define BF_EPIT_CR_CLKSRC(v) ((uint32_t)((uint32_t)(v) << BP_EPIT_CR_CLKSRC) & BM_EPIT_CR_CLKSRC)

/*! @brief Set the CLKSRC field to a new value. */
#define BW_EPIT_CR_CLKSRC(x, v) (HW_EPIT_CR_WR(x, (HW_EPIT_CR_RD(x) & ~BM_EPIT_CR_CLKSRC) | BF_EPIT_CR_CLKSRC(v)))
/*@}*/

/*******************************************************************************
 * HW_EPIT_SR - Status register
 ******************************************************************************/

/*!
 * @brief HW_EPIT_SR - Status register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The EPIT status register (EPIT_SR) has a single status bit for the output
 * compare event. The bit is a write 1 to clear bit.
 */
typedef union _hw_epit_sr
{
    uint32_t U;
    struct _hw_epit_sr_bitfields
    {
        uint32_t OCIF : 1;             /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_epit_sr_t;

/*!
 * @name Constants and macros for entire EPIT_SR register
 */
/*@{*/
#define HW_EPIT_SR_ADDR(x)       ((uintptr_t)(x) + 0x4U)

#define HW_EPIT_SR(x)            (*(__IO hw_epit_sr_t *) HW_EPIT_SR_ADDR(x))
#define HW_EPIT_SR_RD(x)         (HW_EPIT_SR(x).U)
#define HW_EPIT_SR_WR(x, v)      (HW_EPIT_SR(x).U = (v))
#define HW_EPIT_SR_SET(x, v)     (HW_EPIT_SR_WR(x, HW_EPIT_SR_RD(x) |  (v)))
#define HW_EPIT_SR_CLR(x, v)     (HW_EPIT_SR_WR(x, HW_EPIT_SR_RD(x) & ~(v)))
#define HW_EPIT_SR_TOG(x, v)     (HW_EPIT_SR_WR(x, HW_EPIT_SR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EPIT_SR bitfields
 */

/*!
 * @name Register EPIT_SR, field OCIF[0] (W1C)
 *
 * Output compare interrupt flag. This bit is the interrupt flag that is set
 * when the content of counter equals the content of the compare register
 * (EPIT_CMPR). The bit is a write 1 to clear bit.
 *
 * Values:
 * - 0 - Compare event has not occurred
 * - 1 - Compare event occurred
 */
/*@{*/
#define BP_EPIT_SR_OCIF      (0U)          /*!< Bit position for EPIT_SR_OCIF. */
#define BM_EPIT_SR_OCIF      (0x00000001U) /*!< Bit mask for EPIT_SR_OCIF. */
#define BS_EPIT_SR_OCIF      (1U)          /*!< Bit field size in bits for EPIT_SR_OCIF. */

/*! @brief Read current value of the EPIT_SR_OCIF field. */
#define BR_EPIT_SR_OCIF(x)   (HW_EPIT_SR(x).B.OCIF)

/*! @brief Format value for bitfield EPIT_SR_OCIF. */
#define BF_EPIT_SR_OCIF(v)   ((uint32_t)((uint32_t)(v) << BP_EPIT_SR_OCIF) & BM_EPIT_SR_OCIF)

/*! @brief Set the OCIF field to a new value. */
#define BW_EPIT_SR_OCIF(x, v) (HW_EPIT_SR_WR(x, (HW_EPIT_SR_RD(x) & ~BM_EPIT_SR_OCIF) | BF_EPIT_SR_OCIF(v)))
/*@}*/

/*******************************************************************************
 * HW_EPIT_LR - Load register
 ******************************************************************************/

/*!
 * @brief HW_EPIT_LR - Load register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The EPIT load register (EPIT_LR) contains the value that is to be loaded into
 * the counter when EPIT counter reaches zero if the RLD bit in EPIT_CR is set.
 * If the IOVW bit in the EPIT_CR is set then a write to this register overwrites
 * the value of the EPIT counter register in addition to updating this registers
 * value. This overwrite feature is active even if the RLD bit is not set.
 */
typedef union _hw_epit_lr
{
    uint32_t U;
    struct _hw_epit_lr_bitfields
    {
        uint32_t LOAD : 32;            /*!< [31:0]  */
    } B;
} hw_epit_lr_t;

/*!
 * @name Constants and macros for entire EPIT_LR register
 */
/*@{*/
#define HW_EPIT_LR_ADDR(x)       ((uintptr_t)(x) + 0x8U)

#define HW_EPIT_LR(x)            (*(__IO hw_epit_lr_t *) HW_EPIT_LR_ADDR(x))
#define HW_EPIT_LR_RD(x)         (HW_EPIT_LR(x).U)
#define HW_EPIT_LR_WR(x, v)      (HW_EPIT_LR(x).U = (v))
#define HW_EPIT_LR_SET(x, v)     (HW_EPIT_LR_WR(x, HW_EPIT_LR_RD(x) |  (v)))
#define HW_EPIT_LR_CLR(x, v)     (HW_EPIT_LR_WR(x, HW_EPIT_LR_RD(x) & ~(v)))
#define HW_EPIT_LR_TOG(x, v)     (HW_EPIT_LR_WR(x, HW_EPIT_LR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EPIT_LR bitfields
 */

/*!
 * @name Register EPIT_LR, field LOAD[31:0] (RW)
 *
 * Load value. Value that is loaded into the counter at the start of each count
 * cycle.
 */
/*@{*/
#define BP_EPIT_LR_LOAD      (0U)          /*!< Bit position for EPIT_LR_LOAD. */
#define BM_EPIT_LR_LOAD      (0xFFFFFFFFU) /*!< Bit mask for EPIT_LR_LOAD. */
#define BS_EPIT_LR_LOAD      (32U)         /*!< Bit field size in bits for EPIT_LR_LOAD. */

/*! @brief Read current value of the EPIT_LR_LOAD field. */
#define BR_EPIT_LR_LOAD(x)   (HW_EPIT_LR(x).U)

/*! @brief Format value for bitfield EPIT_LR_LOAD. */
#define BF_EPIT_LR_LOAD(v)   ((uint32_t)((uint32_t)(v) << BP_EPIT_LR_LOAD) & BM_EPIT_LR_LOAD)

/*! @brief Set the LOAD field to a new value. */
#define BW_EPIT_LR_LOAD(x, v) (HW_EPIT_LR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_EPIT_CMPR - Compare register
 ******************************************************************************/

/*!
 * @brief HW_EPIT_CMPR - Compare register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The EPIT compare register (EPIT_CMPR) holds the value that determines when a
 * compare event is generated.
 */
typedef union _hw_epit_cmpr
{
    uint32_t U;
    struct _hw_epit_cmpr_bitfields
    {
        uint32_t COMPARE : 32;         /*!< [31:0]  */
    } B;
} hw_epit_cmpr_t;

/*!
 * @name Constants and macros for entire EPIT_CMPR register
 */
/*@{*/
#define HW_EPIT_CMPR_ADDR(x)     ((uintptr_t)(x) + 0xCU)

#define HW_EPIT_CMPR(x)          (*(__IO hw_epit_cmpr_t *) HW_EPIT_CMPR_ADDR(x))
#define HW_EPIT_CMPR_RD(x)       (HW_EPIT_CMPR(x).U)
#define HW_EPIT_CMPR_WR(x, v)    (HW_EPIT_CMPR(x).U = (v))
#define HW_EPIT_CMPR_SET(x, v)   (HW_EPIT_CMPR_WR(x, HW_EPIT_CMPR_RD(x) |  (v)))
#define HW_EPIT_CMPR_CLR(x, v)   (HW_EPIT_CMPR_WR(x, HW_EPIT_CMPR_RD(x) & ~(v)))
#define HW_EPIT_CMPR_TOG(x, v)   (HW_EPIT_CMPR_WR(x, HW_EPIT_CMPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual EPIT_CMPR bitfields
 */

/*!
 * @name Register EPIT_CMPR, field COMPARE[31:0] (RW)
 *
 * Compare Value. When the counter value equals this bit field value a compare
 * event is generated.
 */
/*@{*/
#define BP_EPIT_CMPR_COMPARE (0U)          /*!< Bit position for EPIT_CMPR_COMPARE. */
#define BM_EPIT_CMPR_COMPARE (0xFFFFFFFFU) /*!< Bit mask for EPIT_CMPR_COMPARE. */
#define BS_EPIT_CMPR_COMPARE (32U)         /*!< Bit field size in bits for EPIT_CMPR_COMPARE. */

/*! @brief Read current value of the EPIT_CMPR_COMPARE field. */
#define BR_EPIT_CMPR_COMPARE(x) (HW_EPIT_CMPR(x).U)

/*! @brief Format value for bitfield EPIT_CMPR_COMPARE. */
#define BF_EPIT_CMPR_COMPARE(v) ((uint32_t)((uint32_t)(v) << BP_EPIT_CMPR_COMPARE) & BM_EPIT_CMPR_COMPARE)

/*! @brief Set the COMPARE field to a new value. */
#define BW_EPIT_CMPR_COMPARE(x, v) (HW_EPIT_CMPR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_EPIT_CNR - Counter register
 ******************************************************************************/

/*!
 * @brief HW_EPIT_CNR - Counter register (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The EPIT counter register (EPIT_CNR) contains the current count value and can
 * be read at any time without disturbing the counter. This is a read-only
 * register and any attempt to write into it generates a transfer error. But if the
 * IOVW bit in EPIT_CR is set, the value of this register can be overwritten with a
 * write to EPIT_LR. This change is reflected when this register is subsequently
 * read.
 */
typedef union _hw_epit_cnr
{
    uint32_t U;
    struct _hw_epit_cnr_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_epit_cnr_t;

/*!
 * @name Constants and macros for entire EPIT_CNR register
 */
/*@{*/
#define HW_EPIT_CNR_ADDR(x)      ((uintptr_t)(x) + 0x10U)

#define HW_EPIT_CNR(x)           (*(__I hw_epit_cnr_t *) HW_EPIT_CNR_ADDR(x))
#define HW_EPIT_CNR_RD(x)        (HW_EPIT_CNR(x).U)
/*@}*/

/*
 * Constants & macros for individual EPIT_CNR bitfields
 */

/*!
 * @name Register EPIT_CNR, field COUNT[31:0] (RO)
 *
 * Counter value. This contains the current value of the counter.
 */
/*@{*/
#define BP_EPIT_CNR_COUNT    (0U)          /*!< Bit position for EPIT_CNR_COUNT. */
#define BM_EPIT_CNR_COUNT    (0xFFFFFFFFU) /*!< Bit mask for EPIT_CNR_COUNT. */
#define BS_EPIT_CNR_COUNT    (32U)         /*!< Bit field size in bits for EPIT_CNR_COUNT. */

/*! @brief Read current value of the EPIT_CNR_COUNT field. */
#define BR_EPIT_CNR_COUNT(x) (HW_EPIT_CNR(x).U)
/*@}*/

/*******************************************************************************
 * hw_epit_t - module struct
 ******************************************************************************/
/*!
 * @brief All EPIT module registers.
 */
#pragma pack(1)
typedef struct _hw_epit
{
    __IO hw_epit_cr_t CR;                  /*!< [0x0] Control register */
    __IO hw_epit_sr_t SR;                  /*!< [0x4] Status register */
    __IO hw_epit_lr_t LR;                  /*!< [0x8] Load register */
    __IO hw_epit_cmpr_t CMPR;              /*!< [0xC] Compare register */
    __I hw_epit_cnr_t CNR;                 /*!< [0x10] Counter register */
} hw_epit_t;
#pragma pack()

/*! @brief Macro to access all EPIT registers. */
/*! @param x EPIT module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_EPIT_REGS(EPIT1_BASE)</code>. */
#define HW_EPIT_REGS(x) (*(hw_epit_t *)(x))

/*
 * iMX6DP ESAI
 *
 * Enhanced Serial Audio Interface
 *
 * Registers defined in this header file:
 * - HW_ESAI_ETDR - ESAI Transmit Data Register
 * - HW_ESAI_ERDR - ESAI Receive Data Register
 * - HW_ESAI_ECR - ESAI Control Register
 * - HW_ESAI_ESR - ESAI Status Register
 * - HW_ESAI_TFCR - Transmit FIFO Configuration Register
 * - HW_ESAI_TFSR - Transmit FIFO Status Register
 * - HW_ESAI_RFCR - Receive FIFO Configuration Register
 * - HW_ESAI_RFSR - Receive FIFO Status Register
 * - HW_ESAI_TXn - Transmit Data Register n
 * - HW_ESAI_TSR - ESAI Transmit Slot Register
 * - HW_ESAI_RXn - Receive Data Register n
 * - HW_ESAI_SAISR - Serial Audio Interface Status Register
 * - HW_ESAI_SAICR - Serial Audio Interface Control Register
 * - HW_ESAI_TCR - Transmit Control Register
 * - HW_ESAI_TCCR - Transmit Clock Control Register
 * - HW_ESAI_RCR - Receive Control Register
 * - HW_ESAI_RCCR - Receive Clock Control Register
 * - HW_ESAI_TSMA - Transmit Slot Mask Register A
 * - HW_ESAI_TSMB - Transmit Slot Mask Register B
 * - HW_ESAI_RSMA - Receive Slot Mask Register A
 * - HW_ESAI_RSMB - Receive Slot Mask Register B
 * - HW_ESAI_PRRC - Port C Direction Register
 * - HW_ESAI_PCRC - Port C Control Register
 *
 * - hw_esai_t - Struct containing all module registers.
 */

#define HW_ESAI_INSTANCE_COUNT (1U) /*!< Number of instances of the ESAI module. */
#define HW_ESAI (0U) /*!< Instance number for ESAI. */
#define ESAI_BASE             (0x2024000U) /*!< Base address for ESAI. */
/*! Array initializer of ESAI base addresses. */
#define ESAI_BASE_ADDRS       { ESAI_BASE }

/*******************************************************************************
 * HW_ESAI_ETDR - ESAI Transmit Data Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_ETDR - ESAI Transmit Data Register (WORZ)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_etdr
{
    uint32_t U;
    struct _hw_esai_etdr_bitfields
    {
        uint32_t ETDR : 32;            /*!< [31:0]  */
    } B;
} hw_esai_etdr_t;

/*!
 * @name Constants and macros for entire ESAI_ETDR register
 */
/*@{*/
#define HW_ESAI_ETDR_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_ESAI_ETDR(x)          (*(__O hw_esai_etdr_t *) HW_ESAI_ETDR_ADDR(x))
#define HW_ESAI_ETDR_RD(x)       (HW_ESAI_ETDR(x).U)
#define HW_ESAI_ETDR_WR(x, v)    (HW_ESAI_ETDR(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual ESAI_ETDR bitfields
 */

/*!
 * @name Register ESAI_ETDR, field ETDR[31:0] (WORZ)
 *
 * ESAI Transmit Data Register. Writing to this register stores the data written
 * into the ESAI Transmit FIFO. Writing to this register when the Transmit FIFO
 * is full causes the data written to be lost (the existing data within the FIFO
 * is not overwritten). When multiple ESAI transmitters are enabled, the data for
 * each transmitter must be interleaved from lowest transmitter to highest
 * transmitter (for example, if transmitters 0, 2 and 3 are enabled then data must be
 * written as follows: transmitter #0, transmitter #2, transmitter #3,
 * transmitter #0, transmitter #2, transmitter #3, transmitter #0, etc). Data within the
 * ESAI Transmit FIFO is passed to the ESAI transmit shifter registers as defined
 * by the Transmit Word Alignment configuration bits.
 */
/*@{*/
#define BP_ESAI_ETDR_ETDR    (0U)          /*!< Bit position for ESAI_ETDR_ETDR. */
#define BM_ESAI_ETDR_ETDR    (0xFFFFFFFFU) /*!< Bit mask for ESAI_ETDR_ETDR. */
#define BS_ESAI_ETDR_ETDR    (32U)         /*!< Bit field size in bits for ESAI_ETDR_ETDR. */

/*! @brief Format value for bitfield ESAI_ETDR_ETDR. */
#define BF_ESAI_ETDR_ETDR(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_ETDR_ETDR) & BM_ESAI_ETDR_ETDR)

/*! @brief Set the ETDR field to a new value. */
#define BW_ESAI_ETDR_ETDR(x, v) (HW_ESAI_ETDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_ESAI_ERDR - ESAI Receive Data Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_ERDR - ESAI Receive Data Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_erdr
{
    uint32_t U;
    struct _hw_esai_erdr_bitfields
    {
        uint32_t ERDR : 32;            /*!< [31:0]  */
    } B;
} hw_esai_erdr_t;

/*!
 * @name Constants and macros for entire ESAI_ERDR register
 */
/*@{*/
#define HW_ESAI_ERDR_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_ESAI_ERDR(x)          (*(__I hw_esai_erdr_t *) HW_ESAI_ERDR_ADDR(x))
#define HW_ESAI_ERDR_RD(x)       (HW_ESAI_ERDR(x).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_ERDR bitfields
 */

/*!
 * @name Register ESAI_ERDR, field ERDR[31:0] (RO)
 *
 * ESAI Receive Data Register. Reading this register returns the data within the
 * ESAI Receive FIFO. Reading this register when the Receive FIFO is empty
 * returns the last valid data word. When multiple ESAI receivers are enabled, the
 * data for each receiver is interleaved from lowest receiver to highest receiver
 * (for example, if receivers 0, 2 and 3 are enabled then data is returned as
 * follows: receiver #0, receiver #2, receiver #3, receiver #0, receiver #2, receiver
 * #3, receiver #0, etc). Data is passed from the ESAI receive shift registers to
 * the ESAI Receive FIFO as defined by the Receiver Word Alignment configuration
 * bits either zero or sign-extended based on the Receive Extension control bit.
 */
/*@{*/
#define BP_ESAI_ERDR_ERDR    (0U)          /*!< Bit position for ESAI_ERDR_ERDR. */
#define BM_ESAI_ERDR_ERDR    (0xFFFFFFFFU) /*!< Bit mask for ESAI_ERDR_ERDR. */
#define BS_ESAI_ERDR_ERDR    (32U)         /*!< Bit field size in bits for ESAI_ERDR_ERDR. */

/*! @brief Read current value of the ESAI_ERDR_ERDR field. */
#define BR_ESAI_ERDR_ERDR(x) (HW_ESAI_ERDR(x).U)
/*@}*/

/*******************************************************************************
 * HW_ESAI_ECR - ESAI Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_ECR - ESAI Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_ecr
{
    uint32_t U;
    struct _hw_esai_ecr_bitfields
    {
        uint32_t ESAIEN : 1;           /*!< [0]  */
        uint32_t ERST : 1;             /*!< [1]  */
        uint32_t RESERVED0 : 14;       /*!< [15:2]  */
        uint32_t ERO : 1;              /*!< [16]  */
        uint32_t ERI : 1;              /*!< [17]  */
        uint32_t ETO : 1;              /*!< [18]  */
        uint32_t ETI : 1;              /*!< [19]  */
        uint32_t RESERVED1 : 12;       /*!< [31:20]  */
    } B;
} hw_esai_ecr_t;

/*!
 * @name Constants and macros for entire ESAI_ECR register
 */
/*@{*/
#define HW_ESAI_ECR_ADDR(x)      ((uintptr_t)(x) + 0x8U)

#define HW_ESAI_ECR(x)           (*(__IO hw_esai_ecr_t *) HW_ESAI_ECR_ADDR(x))
#define HW_ESAI_ECR_RD(x)        (HW_ESAI_ECR(x).U)
#define HW_ESAI_ECR_WR(x, v)     (HW_ESAI_ECR(x).U = (v))
#define HW_ESAI_ECR_SET(x, v)    (HW_ESAI_ECR_WR(x, HW_ESAI_ECR_RD(x) |  (v)))
#define HW_ESAI_ECR_CLR(x, v)    (HW_ESAI_ECR_WR(x, HW_ESAI_ECR_RD(x) & ~(v)))
#define HW_ESAI_ECR_TOG(x, v)    (HW_ESAI_ECR_WR(x, HW_ESAI_ECR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_ECR bitfields
 */

/*!
 * @name Register ESAI_ECR, field ESAIEN[0] (RW)
 *
 * ESAI Enable. Enables/disables the ESAI logic clock. Enable the ESAI before
 * reading or writing other ESAI registers.
 *
 * Values:
 * - 0 - ESAI disabled.
 * - 1 - ESAI enabled.
 */
/*@{*/
#define BP_ESAI_ECR_ESAIEN   (0U)          /*!< Bit position for ESAI_ECR_ESAIEN. */
#define BM_ESAI_ECR_ESAIEN   (0x00000001U) /*!< Bit mask for ESAI_ECR_ESAIEN. */
#define BS_ESAI_ECR_ESAIEN   (1U)          /*!< Bit field size in bits for ESAI_ECR_ESAIEN. */

/*! @brief Read current value of the ESAI_ECR_ESAIEN field. */
#define BR_ESAI_ECR_ESAIEN(x) (HW_ESAI_ECR(x).B.ESAIEN)

/*! @brief Format value for bitfield ESAI_ECR_ESAIEN. */
#define BF_ESAI_ECR_ESAIEN(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ESAIEN) & BM_ESAI_ECR_ESAIEN)

/*! @brief Set the ESAIEN field to a new value. */
#define BW_ESAI_ECR_ESAIEN(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ESAIEN) | BF_ESAI_ECR_ESAIEN(v)))
/*@}*/

/*!
 * @name Register ESAI_ECR, field ERST[1] (RW)
 *
 * ESAI Reset. Reset the ESAI core logic (including configuration registers) but
 * not the ESAI FIFOs.
 *
 * Values:
 * - 0 - ESAI not reset.
 * - 1 - ESAI reset.
 */
/*@{*/
#define BP_ESAI_ECR_ERST     (1U)          /*!< Bit position for ESAI_ECR_ERST. */
#define BM_ESAI_ECR_ERST     (0x00000002U) /*!< Bit mask for ESAI_ECR_ERST. */
#define BS_ESAI_ECR_ERST     (1U)          /*!< Bit field size in bits for ESAI_ECR_ERST. */

/*! @brief Read current value of the ESAI_ECR_ERST field. */
#define BR_ESAI_ECR_ERST(x)  (HW_ESAI_ECR(x).B.ERST)

/*! @brief Format value for bitfield ESAI_ECR_ERST. */
#define BF_ESAI_ECR_ERST(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ERST) & BM_ESAI_ECR_ERST)

/*! @brief Set the ERST field to a new value. */
#define BW_ESAI_ECR_ERST(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ERST) | BF_ESAI_ECR_ERST(v)))
/*@}*/

/*!
 * @name Register ESAI_ECR, field ERO[16] (RW)
 *
 * EXTAL Receiver Out. Drive the EXTAL input on the High Frequency Receiver
 * Clock pin.
 *
 * Values:
 * - 0 - HCKR pin has normal function.
 * - 1 - EXTAL driven onto HCKR pin.
 */
/*@{*/
#define BP_ESAI_ECR_ERO      (16U)         /*!< Bit position for ESAI_ECR_ERO. */
#define BM_ESAI_ECR_ERO      (0x00010000U) /*!< Bit mask for ESAI_ECR_ERO. */
#define BS_ESAI_ECR_ERO      (1U)          /*!< Bit field size in bits for ESAI_ECR_ERO. */

/*! @brief Read current value of the ESAI_ECR_ERO field. */
#define BR_ESAI_ECR_ERO(x)   (HW_ESAI_ECR(x).B.ERO)

/*! @brief Format value for bitfield ESAI_ECR_ERO. */
#define BF_ESAI_ECR_ERO(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ERO) & BM_ESAI_ECR_ERO)

/*! @brief Set the ERO field to a new value. */
#define BW_ESAI_ECR_ERO(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ERO) | BF_ESAI_ECR_ERO(v)))
/*@}*/

/*!
 * @name Register ESAI_ECR, field ERI[17] (RW)
 *
 * EXTAL Receiver In. Mux EXTAL in place of the High Frequency Receiver Clock
 * input pin. HCKR can still be used to drive a divided down EXTAL or as GPIO.
 *
 * Values:
 * - 0 - HCKR pin has normal function.
 * - 1 - EXTAL muxed into HCKR input.
 */
/*@{*/
#define BP_ESAI_ECR_ERI      (17U)         /*!< Bit position for ESAI_ECR_ERI. */
#define BM_ESAI_ECR_ERI      (0x00020000U) /*!< Bit mask for ESAI_ECR_ERI. */
#define BS_ESAI_ECR_ERI      (1U)          /*!< Bit field size in bits for ESAI_ECR_ERI. */

/*! @brief Read current value of the ESAI_ECR_ERI field. */
#define BR_ESAI_ECR_ERI(x)   (HW_ESAI_ECR(x).B.ERI)

/*! @brief Format value for bitfield ESAI_ECR_ERI. */
#define BF_ESAI_ECR_ERI(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ERI) & BM_ESAI_ECR_ERI)

/*! @brief Set the ERI field to a new value. */
#define BW_ESAI_ECR_ERI(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ERI) | BF_ESAI_ECR_ERI(v)))
/*@}*/

/*!
 * @name Register ESAI_ECR, field ETO[18] (RW)
 *
 * EXTAL Transmitter Out. Drive the EXTAL input on the High Frequency
 * Transmitter Clock pin.
 *
 * Values:
 * - 0 - HCKT pin has normal function.
 * - 1 - EXTAL driven onto HCKT pin.
 */
/*@{*/
#define BP_ESAI_ECR_ETO      (18U)         /*!< Bit position for ESAI_ECR_ETO. */
#define BM_ESAI_ECR_ETO      (0x00040000U) /*!< Bit mask for ESAI_ECR_ETO. */
#define BS_ESAI_ECR_ETO      (1U)          /*!< Bit field size in bits for ESAI_ECR_ETO. */

/*! @brief Read current value of the ESAI_ECR_ETO field. */
#define BR_ESAI_ECR_ETO(x)   (HW_ESAI_ECR(x).B.ETO)

/*! @brief Format value for bitfield ESAI_ECR_ETO. */
#define BF_ESAI_ECR_ETO(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ETO) & BM_ESAI_ECR_ETO)

/*! @brief Set the ETO field to a new value. */
#define BW_ESAI_ECR_ETO(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ETO) | BF_ESAI_ECR_ETO(v)))
/*@}*/

/*!
 * @name Register ESAI_ECR, field ETI[19] (RW)
 *
 * EXTAL Transmitter In. Mux EXTAL in place of the High Frequency Transmitter
 * Clock input pin. HCKT can still be used to drive a divided down EXTAL or as GPIO.
 *
 * Values:
 * - 0 - HCKT pin has normal function.
 * - 1 - EXTAL muxed into HCKT input.
 */
/*@{*/
#define BP_ESAI_ECR_ETI      (19U)         /*!< Bit position for ESAI_ECR_ETI. */
#define BM_ESAI_ECR_ETI      (0x00080000U) /*!< Bit mask for ESAI_ECR_ETI. */
#define BS_ESAI_ECR_ETI      (1U)          /*!< Bit field size in bits for ESAI_ECR_ETI. */

/*! @brief Read current value of the ESAI_ECR_ETI field. */
#define BR_ESAI_ECR_ETI(x)   (HW_ESAI_ECR(x).B.ETI)

/*! @brief Format value for bitfield ESAI_ECR_ETI. */
#define BF_ESAI_ECR_ETI(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_ECR_ETI) & BM_ESAI_ECR_ETI)

/*! @brief Set the ETI field to a new value. */
#define BW_ESAI_ECR_ETI(x, v) (HW_ESAI_ECR_WR(x, (HW_ESAI_ECR_RD(x) & ~BM_ESAI_ECR_ETI) | BF_ESAI_ECR_ETI(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_ESR - ESAI Status Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_ESR - ESAI Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_esr
{
    uint32_t U;
    struct _hw_esai_esr_bitfields
    {
        uint32_t RD : 1;               /*!< [0]  */
        uint32_t RED : 1;              /*!< [1]  */
        uint32_t RDE : 1;              /*!< [2]  */
        uint32_t RLS : 1;              /*!< [3]  */
        uint32_t TD : 1;               /*!< [4]  */
        uint32_t TED : 1;              /*!< [5]  */
        uint32_t TDE : 1;              /*!< [6]  */
        uint32_t TLS : 1;              /*!< [7]  */
        uint32_t TFE : 1;              /*!< [8]  */
        uint32_t RFF : 1;              /*!< [9]  */
        uint32_t TINIT : 1;            /*!< [10]  */
        uint32_t RESERVED0 : 21;       /*!< [31:11]  */
    } B;
} hw_esai_esr_t;

/*!
 * @name Constants and macros for entire ESAI_ESR register
 */
/*@{*/
#define HW_ESAI_ESR_ADDR(x)      ((uintptr_t)(x) + 0xCU)

#define HW_ESAI_ESR(x)           (*(__I hw_esai_esr_t *) HW_ESAI_ESR_ADDR(x))
#define HW_ESAI_ESR_RD(x)        (HW_ESAI_ESR(x).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_ESR bitfields
 */

/*!
 * @name Register ESAI_ESR, field RD[0] (RO)
 *
 * Receive Data.
 *
 * Values:
 * - 0 - RD is not the highest priority active interrupt.
 * - 1 - RD is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_RD       (0U)          /*!< Bit position for ESAI_ESR_RD. */
#define BM_ESAI_ESR_RD       (0x00000001U) /*!< Bit mask for ESAI_ESR_RD. */
#define BS_ESAI_ESR_RD       (1U)          /*!< Bit field size in bits for ESAI_ESR_RD. */

/*! @brief Read current value of the ESAI_ESR_RD field. */
#define BR_ESAI_ESR_RD(x)    (HW_ESAI_ESR(x).B.RD)
/*@}*/

/*!
 * @name Register ESAI_ESR, field RED[1] (RO)
 *
 * Receive Even Data.
 *
 * Values:
 * - 0 - RED is not the highest priority active interrupt.
 * - 1 - RED is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_RED      (1U)          /*!< Bit position for ESAI_ESR_RED. */
#define BM_ESAI_ESR_RED      (0x00000002U) /*!< Bit mask for ESAI_ESR_RED. */
#define BS_ESAI_ESR_RED      (1U)          /*!< Bit field size in bits for ESAI_ESR_RED. */

/*! @brief Read current value of the ESAI_ESR_RED field. */
#define BR_ESAI_ESR_RED(x)   (HW_ESAI_ESR(x).B.RED)
/*@}*/

/*!
 * @name Register ESAI_ESR, field RDE[2] (RO)
 *
 * Receive Data Exception.
 *
 * Values:
 * - 0 - RDE is not the highest priority active interrupt.
 * - 1 - RDE is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_RDE      (2U)          /*!< Bit position for ESAI_ESR_RDE. */
#define BM_ESAI_ESR_RDE      (0x00000004U) /*!< Bit mask for ESAI_ESR_RDE. */
#define BS_ESAI_ESR_RDE      (1U)          /*!< Bit field size in bits for ESAI_ESR_RDE. */

/*! @brief Read current value of the ESAI_ESR_RDE field. */
#define BR_ESAI_ESR_RDE(x)   (HW_ESAI_ESR(x).B.RDE)
/*@}*/

/*!
 * @name Register ESAI_ESR, field RLS[3] (RO)
 *
 * Receive Last Slot. Reading this register when RLS is set will negate the
 * Receive Last Slot interrupt.
 *
 * Values:
 * - 0 - RLS is not the highest priority active interrupt.
 * - 1 - RLS is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_RLS      (3U)          /*!< Bit position for ESAI_ESR_RLS. */
#define BM_ESAI_ESR_RLS      (0x00000008U) /*!< Bit mask for ESAI_ESR_RLS. */
#define BS_ESAI_ESR_RLS      (1U)          /*!< Bit field size in bits for ESAI_ESR_RLS. */

/*! @brief Read current value of the ESAI_ESR_RLS field. */
#define BR_ESAI_ESR_RLS(x)   (HW_ESAI_ESR(x).B.RLS)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TD[4] (RO)
 *
 * Transmit Data.
 *
 * Values:
 * - 0 - TD is not the highest priority active interrupt.
 * - 1 - TD is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_TD       (4U)          /*!< Bit position for ESAI_ESR_TD. */
#define BM_ESAI_ESR_TD       (0x00000010U) /*!< Bit mask for ESAI_ESR_TD. */
#define BS_ESAI_ESR_TD       (1U)          /*!< Bit field size in bits for ESAI_ESR_TD. */

/*! @brief Read current value of the ESAI_ESR_TD field. */
#define BR_ESAI_ESR_TD(x)    (HW_ESAI_ESR(x).B.TD)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TED[5] (RO)
 *
 * Transmit Even Data.
 *
 * Values:
 * - 0 - TED is not the highest priority active interrupt.
 * - 1 - TED is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_TED      (5U)          /*!< Bit position for ESAI_ESR_TED. */
#define BM_ESAI_ESR_TED      (0x00000020U) /*!< Bit mask for ESAI_ESR_TED. */
#define BS_ESAI_ESR_TED      (1U)          /*!< Bit field size in bits for ESAI_ESR_TED. */

/*! @brief Read current value of the ESAI_ESR_TED field. */
#define BR_ESAI_ESR_TED(x)   (HW_ESAI_ESR(x).B.TED)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TDE[6] (RO)
 *
 * Transmit Data Exception.
 *
 * Values:
 * - 0 - TDE is not the highest priority active interrupt.
 * - 1 - TDE is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_TDE      (6U)          /*!< Bit position for ESAI_ESR_TDE. */
#define BM_ESAI_ESR_TDE      (0x00000040U) /*!< Bit mask for ESAI_ESR_TDE. */
#define BS_ESAI_ESR_TDE      (1U)          /*!< Bit field size in bits for ESAI_ESR_TDE. */

/*! @brief Read current value of the ESAI_ESR_TDE field. */
#define BR_ESAI_ESR_TDE(x)   (HW_ESAI_ESR(x).B.TDE)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TLS[7] (RO)
 *
 * Transmit Last Slot. Reading this register when TLS is set will negate the
 * Transmit Last Slot interrupt.
 *
 * Values:
 * - 0 - TLS is not the highest priority active interrupt.
 * - 1 - TLS is the highest priority active interrupt.
 */
/*@{*/
#define BP_ESAI_ESR_TLS      (7U)          /*!< Bit position for ESAI_ESR_TLS. */
#define BM_ESAI_ESR_TLS      (0x00000080U) /*!< Bit mask for ESAI_ESR_TLS. */
#define BS_ESAI_ESR_TLS      (1U)          /*!< Bit field size in bits for ESAI_ESR_TLS. */

/*! @brief Read current value of the ESAI_ESR_TLS field. */
#define BR_ESAI_ESR_TLS(x)   (HW_ESAI_ESR(x).B.TLS)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TFE[8] (RO)
 *
 * Transmit FIFO Empty. Indicates that the number of empty slots in the Transmit
 * FIFO has met or exceeded the Transmit FIFO Watermark. This flag also drives
 * the ESAI Transmitter DMA request line. ESAI FIFO DMA request see ESAI DMA
 * Requests from the FIFOs.
 *
 * Values:
 * - 0 - Number of empty slots in Transmit FIFO less than Transmit FIFO
 *     watermark.
 * - 1 - Number of empty slots in Transmit FIFO is equal to or greater than
 *     Transmit FIFO watermark.
 */
/*@{*/
#define BP_ESAI_ESR_TFE      (8U)          /*!< Bit position for ESAI_ESR_TFE. */
#define BM_ESAI_ESR_TFE      (0x00000100U) /*!< Bit mask for ESAI_ESR_TFE. */
#define BS_ESAI_ESR_TFE      (1U)          /*!< Bit field size in bits for ESAI_ESR_TFE. */

/*! @brief Read current value of the ESAI_ESR_TFE field. */
#define BR_ESAI_ESR_TFE(x)   (HW_ESAI_ESR(x).B.TFE)
/*@}*/

/*!
 * @name Register ESAI_ESR, field RFF[9] (RO)
 *
 * Receive FIFO Full. Indicates that the number of data words in the Receive
 * FIFO has equaled or exceeded the Receive FIFO Watermark. This flag also drives
 * the ESAI Receiver DMA request line. ESAI FIFO DMA requests see ESAI DMA Requests
 * from the FIFOs.
 *
 * Values:
 * - 0 - Number of words in Receive FIFO less than Receive FIFO watermark.
 * - 1 - Number of words in Receive FIFO is equal to or greater than Receive
 *     FIFO watermark.
 */
/*@{*/
#define BP_ESAI_ESR_RFF      (9U)          /*!< Bit position for ESAI_ESR_RFF. */
#define BM_ESAI_ESR_RFF      (0x00000200U) /*!< Bit mask for ESAI_ESR_RFF. */
#define BS_ESAI_ESR_RFF      (1U)          /*!< Bit field size in bits for ESAI_ESR_RFF. */

/*! @brief Read current value of the ESAI_ESR_RFF field. */
#define BR_ESAI_ESR_RFF(x)   (HW_ESAI_ESR(x).B.RFF)
/*@}*/

/*!
 * @name Register ESAI_ESR, field TINIT[10] (RO)
 *
 * Transmit Initialization. Indicates that the Transmit FIFO is writing the
 * first word for each enabled transmitter into the Transmit Data Registers. This bit
 * sets when the Transmit FIFO is enabled (provided Transmit Initialization is
 * enabled) and clears after the Transmit Data Registers have been initialized.
 * The Transmit Enable bits in the Transmit Control Register should not be set
 * until this flag has cleared.
 *
 * Values:
 * - 0 - Transmitter has finished initializing the Transmit Data Registers (or
 *     Transmit FIFO is not enabled or Transmit Initialization is not enabled).
 * - 1 - Transmitter has not finished initializing the Transmit Data Registers.
 */
/*@{*/
#define BP_ESAI_ESR_TINIT    (10U)         /*!< Bit position for ESAI_ESR_TINIT. */
#define BM_ESAI_ESR_TINIT    (0x00000400U) /*!< Bit mask for ESAI_ESR_TINIT. */
#define BS_ESAI_ESR_TINIT    (1U)          /*!< Bit field size in bits for ESAI_ESR_TINIT. */

/*! @brief Read current value of the ESAI_ESR_TINIT field. */
#define BR_ESAI_ESR_TINIT(x) (HW_ESAI_ESR(x).B.TINIT)
/*@}*/

/*******************************************************************************
 * HW_ESAI_TFCR - Transmit FIFO Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TFCR - Transmit FIFO Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_tfcr
{
    uint32_t U;
    struct _hw_esai_tfcr_bitfields
    {
        uint32_t TFE : 1;              /*!< [0]  */
        uint32_t TFR : 1;              /*!< [1]  */
        uint32_t TE0 : 1;              /*!< [2]  */
        uint32_t TE1 : 1;              /*!< [3]  */
        uint32_t TE2 : 1;              /*!< [4]  */
        uint32_t TE3 : 1;              /*!< [5]  */
        uint32_t TE4 : 1;              /*!< [6]  */
        uint32_t TE5 : 1;              /*!< [7]  */
        uint32_t TFWM : 8;             /*!< [15:8]  */
        uint32_t TWA : 3;              /*!< [18:16]  */
        uint32_t TIEN : 1;             /*!< [19]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_esai_tfcr_t;

/*!
 * @name Constants and macros for entire ESAI_TFCR register
 */
/*@{*/
#define HW_ESAI_TFCR_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_ESAI_TFCR(x)          (*(__IO hw_esai_tfcr_t *) HW_ESAI_TFCR_ADDR(x))
#define HW_ESAI_TFCR_RD(x)       (HW_ESAI_TFCR(x).U)
#define HW_ESAI_TFCR_WR(x, v)    (HW_ESAI_TFCR(x).U = (v))
#define HW_ESAI_TFCR_SET(x, v)   (HW_ESAI_TFCR_WR(x, HW_ESAI_TFCR_RD(x) |  (v)))
#define HW_ESAI_TFCR_CLR(x, v)   (HW_ESAI_TFCR_WR(x, HW_ESAI_TFCR_RD(x) & ~(v)))
#define HW_ESAI_TFCR_TOG(x, v)   (HW_ESAI_TFCR_WR(x, HW_ESAI_TFCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TFCR bitfields
 */

/*!
 * @name Register ESAI_TFCR, field TFE[0] (RW)
 *
 * Transmit FIFO Enable. This bit enables the use of the Transmit FIFO.
 *
 * Values:
 * - 0 - Transmit FIFO disabled.
 * - 1 - Transmit FIFO enabled.
 */
/*@{*/
#define BP_ESAI_TFCR_TFE     (0U)          /*!< Bit position for ESAI_TFCR_TFE. */
#define BM_ESAI_TFCR_TFE     (0x00000001U) /*!< Bit mask for ESAI_TFCR_TFE. */
#define BS_ESAI_TFCR_TFE     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TFE. */

/*! @brief Read current value of the ESAI_TFCR_TFE field. */
#define BR_ESAI_TFCR_TFE(x)  (HW_ESAI_TFCR(x).B.TFE)

/*! @brief Format value for bitfield ESAI_TFCR_TFE. */
#define BF_ESAI_TFCR_TFE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TFE) & BM_ESAI_TFCR_TFE)

/*! @brief Set the TFE field to a new value. */
#define BW_ESAI_TFCR_TFE(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TFE) | BF_ESAI_TFCR_TFE(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TFR[1] (RW)
 *
 * Transmit FIFO Reset. This bit resets the Transmit FIFO pointers.
 *
 * Values:
 * - 0 - Transmit FIFO not reset.
 * - 1 - Transmit FIFO reset.
 */
/*@{*/
#define BP_ESAI_TFCR_TFR     (1U)          /*!< Bit position for ESAI_TFCR_TFR. */
#define BM_ESAI_TFCR_TFR     (0x00000002U) /*!< Bit mask for ESAI_TFCR_TFR. */
#define BS_ESAI_TFCR_TFR     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TFR. */

/*! @brief Read current value of the ESAI_TFCR_TFR field. */
#define BR_ESAI_TFCR_TFR(x)  (HW_ESAI_TFCR(x).B.TFR)

/*! @brief Format value for bitfield ESAI_TFCR_TFR. */
#define BF_ESAI_TFCR_TFR(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TFR) & BM_ESAI_TFCR_TFR)

/*! @brief Set the TFR field to a new value. */
#define BW_ESAI_TFCR_TFR(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TFR) | BF_ESAI_TFCR_TFR(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE0[2] (RW)
 *
 * Transmitter #0 FIFO Enable. This bit enables transmitter #0 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #0 is not using the Transmit FIFO.
 * - 1 - Transmitter #0 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE0     (2U)          /*!< Bit position for ESAI_TFCR_TE0. */
#define BM_ESAI_TFCR_TE0     (0x00000004U) /*!< Bit mask for ESAI_TFCR_TE0. */
#define BS_ESAI_TFCR_TE0     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE0. */

/*! @brief Read current value of the ESAI_TFCR_TE0 field. */
#define BR_ESAI_TFCR_TE0(x)  (HW_ESAI_TFCR(x).B.TE0)

/*! @brief Format value for bitfield ESAI_TFCR_TE0. */
#define BF_ESAI_TFCR_TE0(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE0) & BM_ESAI_TFCR_TE0)

/*! @brief Set the TE0 field to a new value. */
#define BW_ESAI_TFCR_TE0(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE0) | BF_ESAI_TFCR_TE0(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE1[3] (RW)
 *
 * Transmitter #1 FIFO Enable. This bit enables transmitter #1 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #1 is not using the Transmit FIFO.
 * - 1 - Transmitter #1 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE1     (3U)          /*!< Bit position for ESAI_TFCR_TE1. */
#define BM_ESAI_TFCR_TE1     (0x00000008U) /*!< Bit mask for ESAI_TFCR_TE1. */
#define BS_ESAI_TFCR_TE1     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE1. */

/*! @brief Read current value of the ESAI_TFCR_TE1 field. */
#define BR_ESAI_TFCR_TE1(x)  (HW_ESAI_TFCR(x).B.TE1)

/*! @brief Format value for bitfield ESAI_TFCR_TE1. */
#define BF_ESAI_TFCR_TE1(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE1) & BM_ESAI_TFCR_TE1)

/*! @brief Set the TE1 field to a new value. */
#define BW_ESAI_TFCR_TE1(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE1) | BF_ESAI_TFCR_TE1(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE2[4] (RW)
 *
 * Transmitter #2 FIFO Enable. This bit enables transmitter #2 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #2 is not using the Transmit FIFO.
 * - 1 - Transmitter #2 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE2     (4U)          /*!< Bit position for ESAI_TFCR_TE2. */
#define BM_ESAI_TFCR_TE2     (0x00000010U) /*!< Bit mask for ESAI_TFCR_TE2. */
#define BS_ESAI_TFCR_TE2     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE2. */

/*! @brief Read current value of the ESAI_TFCR_TE2 field. */
#define BR_ESAI_TFCR_TE2(x)  (HW_ESAI_TFCR(x).B.TE2)

/*! @brief Format value for bitfield ESAI_TFCR_TE2. */
#define BF_ESAI_TFCR_TE2(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE2) & BM_ESAI_TFCR_TE2)

/*! @brief Set the TE2 field to a new value. */
#define BW_ESAI_TFCR_TE2(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE2) | BF_ESAI_TFCR_TE2(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE3[5] (RW)
 *
 * Transmitter #3 FIFO Enable. This bit enables transmitter #3 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #3 is not using the Transmit FIFO.
 * - 1 - Transmitter #3 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE3     (5U)          /*!< Bit position for ESAI_TFCR_TE3. */
#define BM_ESAI_TFCR_TE3     (0x00000020U) /*!< Bit mask for ESAI_TFCR_TE3. */
#define BS_ESAI_TFCR_TE3     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE3. */

/*! @brief Read current value of the ESAI_TFCR_TE3 field. */
#define BR_ESAI_TFCR_TE3(x)  (HW_ESAI_TFCR(x).B.TE3)

/*! @brief Format value for bitfield ESAI_TFCR_TE3. */
#define BF_ESAI_TFCR_TE3(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE3) & BM_ESAI_TFCR_TE3)

/*! @brief Set the TE3 field to a new value. */
#define BW_ESAI_TFCR_TE3(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE3) | BF_ESAI_TFCR_TE3(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE4[6] (RW)
 *
 * Transmitter #4 FIFO Enable. This bit enables transmitter #4 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #4 is not using the Transmit FIFO.
 * - 1 - Transmitter #4 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE4     (6U)          /*!< Bit position for ESAI_TFCR_TE4. */
#define BM_ESAI_TFCR_TE4     (0x00000040U) /*!< Bit mask for ESAI_TFCR_TE4. */
#define BS_ESAI_TFCR_TE4     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE4. */

/*! @brief Read current value of the ESAI_TFCR_TE4 field. */
#define BR_ESAI_TFCR_TE4(x)  (HW_ESAI_TFCR(x).B.TE4)

/*! @brief Format value for bitfield ESAI_TFCR_TE4. */
#define BF_ESAI_TFCR_TE4(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE4) & BM_ESAI_TFCR_TE4)

/*! @brief Set the TE4 field to a new value. */
#define BW_ESAI_TFCR_TE4(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE4) | BF_ESAI_TFCR_TE4(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TE5[7] (RW)
 *
 * Transmitter #5 FIFO Enable. This bit enables transmitter #5 to use the
 * Transmit FIFO. Do not change this bit when the Transmitter FIFO is enabled.
 *
 * Values:
 * - 0 - Transmitter #5 is not using the Transmit FIFO.
 * - 1 - Transmitter #5 is using the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFCR_TE5     (7U)          /*!< Bit position for ESAI_TFCR_TE5. */
#define BM_ESAI_TFCR_TE5     (0x00000080U) /*!< Bit mask for ESAI_TFCR_TE5. */
#define BS_ESAI_TFCR_TE5     (1U)          /*!< Bit field size in bits for ESAI_TFCR_TE5. */

/*! @brief Read current value of the ESAI_TFCR_TE5 field. */
#define BR_ESAI_TFCR_TE5(x)  (HW_ESAI_TFCR(x).B.TE5)

/*! @brief Format value for bitfield ESAI_TFCR_TE5. */
#define BF_ESAI_TFCR_TE5(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TE5) & BM_ESAI_TFCR_TE5)

/*! @brief Set the TE5 field to a new value. */
#define BW_ESAI_TFCR_TE5(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TE5) | BF_ESAI_TFCR_TE5(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TFWM[15:8] (RW)
 *
 * Transmit FIFO Watermark. These bits configure the threshold at which the
 * Transmit FIFO Empty flag will set. The TFE is set when the number of empty slots
 * in the Transmit FIFO equal or exceed the selected threshold.
 */
/*@{*/
#define BP_ESAI_TFCR_TFWM    (8U)          /*!< Bit position for ESAI_TFCR_TFWM. */
#define BM_ESAI_TFCR_TFWM    (0x0000FF00U) /*!< Bit mask for ESAI_TFCR_TFWM. */
#define BS_ESAI_TFCR_TFWM    (8U)          /*!< Bit field size in bits for ESAI_TFCR_TFWM. */

/*! @brief Read current value of the ESAI_TFCR_TFWM field. */
#define BR_ESAI_TFCR_TFWM(x) (HW_ESAI_TFCR(x).B.TFWM)

/*! @brief Format value for bitfield ESAI_TFCR_TFWM. */
#define BF_ESAI_TFCR_TFWM(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TFWM) & BM_ESAI_TFCR_TFWM)

/*! @brief Set the TFWM field to a new value. */
#define BW_ESAI_TFCR_TFWM(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TFWM) | BF_ESAI_TFCR_TFWM(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TWA[18:16] (RW)
 *
 * Transmit Word Alignment. Configures the alignment of the data written into
 * the ESAI Transmit Data Register and then passed to the relevant 24 bit Transmit
 * shift register.
 *
 * Values:
 * - 000 - MSB of data is bit 31. Data bits 7-0 are ignored when passed to
 *     transmit shift register.
 * - 001 - MSB of data is bit 27. Data bits 3-0 are ignored when passed to
 *     transmit shift register.
 * - 010 - MSB of data is bit 23.
 * - 011 - MSB of data is bit 19. Bottom 4 bits of transmit shift register are
 *     zeroed.
 * - 100 - MSB of data is bit 15. Bottom 8 bits of transmit shift register are
 *     zeroed.
 * - 101 - MSB of data is bit 11. Bottom 12 bits of transmit shift register are
 *     zeroed.
 * - 110 - MSB of data is bit 7. Bottom 16 bits of transmit shift register are
 *     zeroed.
 * - 111 - MSB of data is bit 3. Bottom 20 bits of transmit shift register are
 *     zeroed.
 */
/*@{*/
#define BP_ESAI_TFCR_TWA     (16U)         /*!< Bit position for ESAI_TFCR_TWA. */
#define BM_ESAI_TFCR_TWA     (0x00070000U) /*!< Bit mask for ESAI_TFCR_TWA. */
#define BS_ESAI_TFCR_TWA     (3U)          /*!< Bit field size in bits for ESAI_TFCR_TWA. */

/*! @brief Read current value of the ESAI_TFCR_TWA field. */
#define BR_ESAI_TFCR_TWA(x)  (HW_ESAI_TFCR(x).B.TWA)

/*! @brief Format value for bitfield ESAI_TFCR_TWA. */
#define BF_ESAI_TFCR_TWA(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TWA) & BM_ESAI_TFCR_TWA)

/*! @brief Set the TWA field to a new value. */
#define BW_ESAI_TFCR_TWA(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TWA) | BF_ESAI_TFCR_TWA(v)))
/*@}*/

/*!
 * @name Register ESAI_TFCR, field TIEN[19] (RW)
 *
 * Transmitter Initialization Enable. Enables the initialization of the Transmit
 * Data Registers when the Transmitter FIFO is enabled. TIEN=1 is recommended.
 *
 * Values:
 * - 0 - Transmit Data Registers are not initialized from the FIFO once the
 *     Transmit FIFO is enabled. Software must manually initialize the Transmit Data
 *     Registers separately.
 * - 1 - Transmit Data Registers are initialized from the FIFO once the Transmit
 *     FIFO is enabled.
 */
/*@{*/
#define BP_ESAI_TFCR_TIEN    (19U)         /*!< Bit position for ESAI_TFCR_TIEN. */
#define BM_ESAI_TFCR_TIEN    (0x00080000U) /*!< Bit mask for ESAI_TFCR_TIEN. */
#define BS_ESAI_TFCR_TIEN    (1U)          /*!< Bit field size in bits for ESAI_TFCR_TIEN. */

/*! @brief Read current value of the ESAI_TFCR_TIEN field. */
#define BR_ESAI_TFCR_TIEN(x) (HW_ESAI_TFCR(x).B.TIEN)

/*! @brief Format value for bitfield ESAI_TFCR_TIEN. */
#define BF_ESAI_TFCR_TIEN(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TFCR_TIEN) & BM_ESAI_TFCR_TIEN)

/*! @brief Set the TIEN field to a new value. */
#define BW_ESAI_TFCR_TIEN(x, v) (HW_ESAI_TFCR_WR(x, (HW_ESAI_TFCR_RD(x) & ~BM_ESAI_TFCR_TIEN) | BF_ESAI_TFCR_TIEN(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TFSR - Transmit FIFO Status Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TFSR - Transmit FIFO Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_tfsr
{
    uint32_t U;
    struct _hw_esai_tfsr_bitfields
    {
        uint32_t TFCNT : 8;            /*!< [7:0]  */
        uint32_t NTFI : 3;             /*!< [10:8]  */
        uint32_t RESERVED0 : 1;        /*!< [11]  */
        uint32_t NTFO : 3;             /*!< [14:12]  */
        uint32_t RESERVED1 : 17;       /*!< [31:15]  */
    } B;
} hw_esai_tfsr_t;

/*!
 * @name Constants and macros for entire ESAI_TFSR register
 */
/*@{*/
#define HW_ESAI_TFSR_ADDR(x)     ((uintptr_t)(x) + 0x14U)

#define HW_ESAI_TFSR(x)          (*(__I hw_esai_tfsr_t *) HW_ESAI_TFSR_ADDR(x))
#define HW_ESAI_TFSR_RD(x)       (HW_ESAI_TFSR(x).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_TFSR bitfields
 */

/*!
 * @name Register ESAI_TFSR, field TFCNT[7:0] (RO)
 *
 * Transmit FIFO Counter. These bits indicate the number of data words stored in
 * the Transmit FIFO.
 */
/*@{*/
#define BP_ESAI_TFSR_TFCNT   (0U)          /*!< Bit position for ESAI_TFSR_TFCNT. */
#define BM_ESAI_TFSR_TFCNT   (0x000000FFU) /*!< Bit mask for ESAI_TFSR_TFCNT. */
#define BS_ESAI_TFSR_TFCNT   (8U)          /*!< Bit field size in bits for ESAI_TFSR_TFCNT. */

/*! @brief Read current value of the ESAI_TFSR_TFCNT field. */
#define BR_ESAI_TFSR_TFCNT(x) (HW_ESAI_TFSR(x).B.TFCNT)
/*@}*/

/*!
 * @name Register ESAI_TFSR, field NTFI[10:8] (RO)
 *
 * Next Transmitter FIFO In. Indicates which transmitter receives the next word
 * written to the FIFO.
 *
 * Values:
 * - 000 - Transmitter #0 receives next word written to the Transmit FIFO.
 * - 001 - Transmitter #1 receives next word written to the Transmit FIFO.
 * - 010 - Transmitter #2 receives next word written to the Transmit FIFO.
 * - 011 - Transmitter #3 receives next word written to the Transmit FIFO.
 * - 100 - Transmitter #4 receives next word written to the Transmit FIFO.
 * - 101 - Transmitter #5 receives next word written to the Transmit FIFO.
 * - 110 - Reserved.
 * - 111 - Reserved.
 */
/*@{*/
#define BP_ESAI_TFSR_NTFI    (8U)          /*!< Bit position for ESAI_TFSR_NTFI. */
#define BM_ESAI_TFSR_NTFI    (0x00000700U) /*!< Bit mask for ESAI_TFSR_NTFI. */
#define BS_ESAI_TFSR_NTFI    (3U)          /*!< Bit field size in bits for ESAI_TFSR_NTFI. */

/*! @brief Read current value of the ESAI_TFSR_NTFI field. */
#define BR_ESAI_TFSR_NTFI(x) (HW_ESAI_TFSR(x).B.NTFI)
/*@}*/

/*!
 * @name Register ESAI_TFSR, field NTFO[14:12] (RO)
 *
 * Next Transmitter FIFO Out. Indicates which Transmit Data Register receives
 * the top word of the Transmit FIFO. This will usually equal the lowest enabled
 * transmitter, unless the transmit FIFO is empty.
 *
 * Values:
 * - 000 - Transmitter #0 receives next word from the Transmit FIFO.
 * - 001 - Transmitter #1 receives next word from the Transmit FIFO.
 * - 010 - Transmitter #2 receives next word from the Transmit FIFO.
 * - 011 - Transmitter #3 receives next word from the Transmit FIFO.
 * - 100 - Transmitter #4 receives next word from the Transmit FIFO.
 * - 101 - Transmitter #5 receives next word from the Transmit FIFO.
 * - 110 - Reserved.
 * - 111 - Reserved.
 */
/*@{*/
#define BP_ESAI_TFSR_NTFO    (12U)         /*!< Bit position for ESAI_TFSR_NTFO. */
#define BM_ESAI_TFSR_NTFO    (0x00007000U) /*!< Bit mask for ESAI_TFSR_NTFO. */
#define BS_ESAI_TFSR_NTFO    (3U)          /*!< Bit field size in bits for ESAI_TFSR_NTFO. */

/*! @brief Read current value of the ESAI_TFSR_NTFO field. */
#define BR_ESAI_TFSR_NTFO(x) (HW_ESAI_TFSR(x).B.NTFO)
/*@}*/

/*******************************************************************************
 * HW_ESAI_RFCR - Receive FIFO Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RFCR - Receive FIFO Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_rfcr
{
    uint32_t U;
    struct _hw_esai_rfcr_bitfields
    {
        uint32_t RFE : 1;              /*!< [0]  */
        uint32_t RFR : 1;              /*!< [1]  */
        uint32_t RE0 : 1;              /*!< [2]  */
        uint32_t RE1 : 1;              /*!< [3]  */
        uint32_t RE2 : 1;              /*!< [4]  */
        uint32_t RE3 : 1;              /*!< [5]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t RFWM : 8;             /*!< [15:8]  */
        uint32_t RWA : 3;              /*!< [18:16]  */
        uint32_t REXT : 1;             /*!< [19]  */
        uint32_t RESERVED1 : 12;       /*!< [31:20]  */
    } B;
} hw_esai_rfcr_t;

/*!
 * @name Constants and macros for entire ESAI_RFCR register
 */
/*@{*/
#define HW_ESAI_RFCR_ADDR(x)     ((uintptr_t)(x) + 0x18U)

#define HW_ESAI_RFCR(x)          (*(__IO hw_esai_rfcr_t *) HW_ESAI_RFCR_ADDR(x))
#define HW_ESAI_RFCR_RD(x)       (HW_ESAI_RFCR(x).U)
#define HW_ESAI_RFCR_WR(x, v)    (HW_ESAI_RFCR(x).U = (v))
#define HW_ESAI_RFCR_SET(x, v)   (HW_ESAI_RFCR_WR(x, HW_ESAI_RFCR_RD(x) |  (v)))
#define HW_ESAI_RFCR_CLR(x, v)   (HW_ESAI_RFCR_WR(x, HW_ESAI_RFCR_RD(x) & ~(v)))
#define HW_ESAI_RFCR_TOG(x, v)   (HW_ESAI_RFCR_WR(x, HW_ESAI_RFCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_RFCR bitfields
 */

/*!
 * @name Register ESAI_RFCR, field RFE[0] (RW)
 *
 * Receive FIFO Enable. This bit enables the use of the Receive FIFO.
 *
 * Values:
 * - 0 - Receive FIFO disabled.
 * - 1 - Receive FIFO enabled.
 */
/*@{*/
#define BP_ESAI_RFCR_RFE     (0U)          /*!< Bit position for ESAI_RFCR_RFE. */
#define BM_ESAI_RFCR_RFE     (0x00000001U) /*!< Bit mask for ESAI_RFCR_RFE. */
#define BS_ESAI_RFCR_RFE     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RFE. */

/*! @brief Read current value of the ESAI_RFCR_RFE field. */
#define BR_ESAI_RFCR_RFE(x)  (HW_ESAI_RFCR(x).B.RFE)

/*! @brief Format value for bitfield ESAI_RFCR_RFE. */
#define BF_ESAI_RFCR_RFE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RFE) & BM_ESAI_RFCR_RFE)

/*! @brief Set the RFE field to a new value. */
#define BW_ESAI_RFCR_RFE(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RFE) | BF_ESAI_RFCR_RFE(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RFR[1] (RW)
 *
 * Receive FIFO Reset. This bit resets the Receive FIFO pointers.
 *
 * Values:
 * - 0 - Receive FIFO not reset.
 * - 1 - Receive FIFO reset.
 */
/*@{*/
#define BP_ESAI_RFCR_RFR     (1U)          /*!< Bit position for ESAI_RFCR_RFR. */
#define BM_ESAI_RFCR_RFR     (0x00000002U) /*!< Bit mask for ESAI_RFCR_RFR. */
#define BS_ESAI_RFCR_RFR     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RFR. */

/*! @brief Read current value of the ESAI_RFCR_RFR field. */
#define BR_ESAI_RFCR_RFR(x)  (HW_ESAI_RFCR(x).B.RFR)

/*! @brief Format value for bitfield ESAI_RFCR_RFR. */
#define BF_ESAI_RFCR_RFR(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RFR) & BM_ESAI_RFCR_RFR)

/*! @brief Set the RFR field to a new value. */
#define BW_ESAI_RFCR_RFR(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RFR) | BF_ESAI_RFCR_RFR(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RE0[2] (RW)
 *
 * Receiver #0 FIFO Enable. This bit enables receiver #0 to use the Receive
 * FIFO. Do not change this bit when the Receiver FIFO is enabled.
 *
 * Values:
 * - 0 - Receiver #0 is not using the Receive FIFO.
 * - 1 - Receiver #0 is using the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFCR_RE0     (2U)          /*!< Bit position for ESAI_RFCR_RE0. */
#define BM_ESAI_RFCR_RE0     (0x00000004U) /*!< Bit mask for ESAI_RFCR_RE0. */
#define BS_ESAI_RFCR_RE0     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RE0. */

/*! @brief Read current value of the ESAI_RFCR_RE0 field. */
#define BR_ESAI_RFCR_RE0(x)  (HW_ESAI_RFCR(x).B.RE0)

/*! @brief Format value for bitfield ESAI_RFCR_RE0. */
#define BF_ESAI_RFCR_RE0(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RE0) & BM_ESAI_RFCR_RE0)

/*! @brief Set the RE0 field to a new value. */
#define BW_ESAI_RFCR_RE0(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RE0) | BF_ESAI_RFCR_RE0(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RE1[3] (RW)
 *
 * Receiver #1 FIFO Enable. This bit enables receiver #1 to use the Receive
 * FIFO. Do not change this bit when the Receiver FIFO is enabled.
 *
 * Values:
 * - 0 - Receiver #1 is not using the Receive FIFO.
 * - 1 - Receiver #1 is using the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFCR_RE1     (3U)          /*!< Bit position for ESAI_RFCR_RE1. */
#define BM_ESAI_RFCR_RE1     (0x00000008U) /*!< Bit mask for ESAI_RFCR_RE1. */
#define BS_ESAI_RFCR_RE1     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RE1. */

/*! @brief Read current value of the ESAI_RFCR_RE1 field. */
#define BR_ESAI_RFCR_RE1(x)  (HW_ESAI_RFCR(x).B.RE1)

/*! @brief Format value for bitfield ESAI_RFCR_RE1. */
#define BF_ESAI_RFCR_RE1(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RE1) & BM_ESAI_RFCR_RE1)

/*! @brief Set the RE1 field to a new value. */
#define BW_ESAI_RFCR_RE1(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RE1) | BF_ESAI_RFCR_RE1(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RE2[4] (RW)
 *
 * Receiver #2 FIFO Enable. This bit enables receiver #2 to use the Receive
 * FIFO. Do not change this bit when the Receiver FIFO is enabled.
 *
 * Values:
 * - 0 - Receiver #2 is not using the Receive FIFO.
 * - 1 - Receiver #2 is using the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFCR_RE2     (4U)          /*!< Bit position for ESAI_RFCR_RE2. */
#define BM_ESAI_RFCR_RE2     (0x00000010U) /*!< Bit mask for ESAI_RFCR_RE2. */
#define BS_ESAI_RFCR_RE2     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RE2. */

/*! @brief Read current value of the ESAI_RFCR_RE2 field. */
#define BR_ESAI_RFCR_RE2(x)  (HW_ESAI_RFCR(x).B.RE2)

/*! @brief Format value for bitfield ESAI_RFCR_RE2. */
#define BF_ESAI_RFCR_RE2(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RE2) & BM_ESAI_RFCR_RE2)

/*! @brief Set the RE2 field to a new value. */
#define BW_ESAI_RFCR_RE2(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RE2) | BF_ESAI_RFCR_RE2(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RE3[5] (RW)
 *
 * Receiver #3 FIFO Enable. This bit enables receiver #3 to use the Receive
 * FIFO. Do not change this bit when the Receiver FIFO is enabled.
 *
 * Values:
 * - 0 - Receiver #3 is not using the Receive FIFO.
 * - 1 - Receiver #3 is using the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFCR_RE3     (5U)          /*!< Bit position for ESAI_RFCR_RE3. */
#define BM_ESAI_RFCR_RE3     (0x00000020U) /*!< Bit mask for ESAI_RFCR_RE3. */
#define BS_ESAI_RFCR_RE3     (1U)          /*!< Bit field size in bits for ESAI_RFCR_RE3. */

/*! @brief Read current value of the ESAI_RFCR_RE3 field. */
#define BR_ESAI_RFCR_RE3(x)  (HW_ESAI_RFCR(x).B.RE3)

/*! @brief Format value for bitfield ESAI_RFCR_RE3. */
#define BF_ESAI_RFCR_RE3(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RE3) & BM_ESAI_RFCR_RE3)

/*! @brief Set the RE3 field to a new value. */
#define BW_ESAI_RFCR_RE3(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RE3) | BF_ESAI_RFCR_RE3(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RFWM[15:8] (RW)
 *
 * Receive FIFO Watermark. These bits configure the threshold at which the
 * Receive FIFO Full flag will set. The RFF is set when the number of words in the
 * Receive FIFO equal or exceed the selected threshold. It can be set to a non-zero
 * value.
 */
/*@{*/
#define BP_ESAI_RFCR_RFWM    (8U)          /*!< Bit position for ESAI_RFCR_RFWM. */
#define BM_ESAI_RFCR_RFWM    (0x0000FF00U) /*!< Bit mask for ESAI_RFCR_RFWM. */
#define BS_ESAI_RFCR_RFWM    (8U)          /*!< Bit field size in bits for ESAI_RFCR_RFWM. */

/*! @brief Read current value of the ESAI_RFCR_RFWM field. */
#define BR_ESAI_RFCR_RFWM(x) (HW_ESAI_RFCR(x).B.RFWM)

/*! @brief Format value for bitfield ESAI_RFCR_RFWM. */
#define BF_ESAI_RFCR_RFWM(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RFWM) & BM_ESAI_RFCR_RFWM)

/*! @brief Set the RFWM field to a new value. */
#define BW_ESAI_RFCR_RFWM(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RFWM) | BF_ESAI_RFCR_RFWM(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field RWA[18:16] (RW)
 *
 * Receive Word Alignment. Configures the alignment of the data passed from the
 * relevant 24 bit Receive shift register and read out the ESAI Receive Data
 * Register.
 *
 * Values:
 * - 000 - MSB of data is at bit 31. Data bits 7-0 are zeroed.
 * - 001 - MSB of data is at bit 27. Data bits 3-0 are zeroed.
 * - 010 - MSB of data is at bit 23.
 * - 011 - MSB of data is at bit 19. Data bits 3-0 from receive shift register
 *     are ignored.
 * - 100 - MSB of data is at bit 15. Data bits 7-0 from receive shift register
 *     are ignored.
 * - 101 - MSB of data is at bit 11. Data bits 11-0 from receive shift register
 *     are ignored.
 * - 110 - MSB of data is at bit 7. Data bits 15-0 from receive shift register
 *     are ignored.
 * - 111 - MSB of data is at bit 3. Data bits 19-0 from receive shift register
 *     are ignored.
 */
/*@{*/
#define BP_ESAI_RFCR_RWA     (16U)         /*!< Bit position for ESAI_RFCR_RWA. */
#define BM_ESAI_RFCR_RWA     (0x00070000U) /*!< Bit mask for ESAI_RFCR_RWA. */
#define BS_ESAI_RFCR_RWA     (3U)          /*!< Bit field size in bits for ESAI_RFCR_RWA. */

/*! @brief Read current value of the ESAI_RFCR_RWA field. */
#define BR_ESAI_RFCR_RWA(x)  (HW_ESAI_RFCR(x).B.RWA)

/*! @brief Format value for bitfield ESAI_RFCR_RWA. */
#define BF_ESAI_RFCR_RWA(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_RWA) & BM_ESAI_RFCR_RWA)

/*! @brief Set the RWA field to a new value. */
#define BW_ESAI_RFCR_RWA(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_RWA) | BF_ESAI_RFCR_RWA(v)))
/*@}*/

/*!
 * @name Register ESAI_RFCR, field REXT[19] (RW)
 *
 * Receive Extension. Enables the receive data to be returned sign extended when
 * the Receive Word Alignment is configured to return data where the MSB is not
 * aligned with bit 31.
 *
 * Values:
 * - 0 - Receive data is zero extended.
 * - 1 - Receive data is sign extended.
 */
/*@{*/
#define BP_ESAI_RFCR_REXT    (19U)         /*!< Bit position for ESAI_RFCR_REXT. */
#define BM_ESAI_RFCR_REXT    (0x00080000U) /*!< Bit mask for ESAI_RFCR_REXT. */
#define BS_ESAI_RFCR_REXT    (1U)          /*!< Bit field size in bits for ESAI_RFCR_REXT. */

/*! @brief Read current value of the ESAI_RFCR_REXT field. */
#define BR_ESAI_RFCR_REXT(x) (HW_ESAI_RFCR(x).B.REXT)

/*! @brief Format value for bitfield ESAI_RFCR_REXT. */
#define BF_ESAI_RFCR_REXT(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RFCR_REXT) & BM_ESAI_RFCR_REXT)

/*! @brief Set the REXT field to a new value. */
#define BW_ESAI_RFCR_REXT(x, v) (HW_ESAI_RFCR_WR(x, (HW_ESAI_RFCR_RD(x) & ~BM_ESAI_RFCR_REXT) | BF_ESAI_RFCR_REXT(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RFSR - Receive FIFO Status Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RFSR - Receive FIFO Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_rfsr
{
    uint32_t U;
    struct _hw_esai_rfsr_bitfields
    {
        uint32_t RFCNT : 8;            /*!< [7:0]  */
        uint32_t NRFO : 2;             /*!< [9:8]  */
        uint32_t RESERVED0 : 2;        /*!< [11:10]  */
        uint32_t NRFI : 2;             /*!< [13:12]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_esai_rfsr_t;

/*!
 * @name Constants and macros for entire ESAI_RFSR register
 */
/*@{*/
#define HW_ESAI_RFSR_ADDR(x)     ((uintptr_t)(x) + 0x1CU)

#define HW_ESAI_RFSR(x)          (*(__I hw_esai_rfsr_t *) HW_ESAI_RFSR_ADDR(x))
#define HW_ESAI_RFSR_RD(x)       (HW_ESAI_RFSR(x).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_RFSR bitfields
 */

/*!
 * @name Register ESAI_RFSR, field RFCNT[7:0] (RO)
 *
 * Receive FIFO Counter. These bits indicate the number of data words stored in
 * the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFSR_RFCNT   (0U)          /*!< Bit position for ESAI_RFSR_RFCNT. */
#define BM_ESAI_RFSR_RFCNT   (0x000000FFU) /*!< Bit mask for ESAI_RFSR_RFCNT. */
#define BS_ESAI_RFSR_RFCNT   (8U)          /*!< Bit field size in bits for ESAI_RFSR_RFCNT. */

/*! @brief Read current value of the ESAI_RFSR_RFCNT field. */
#define BR_ESAI_RFSR_RFCNT(x) (HW_ESAI_RFSR(x).B.RFCNT)
/*@}*/

/*!
 * @name Register ESAI_RFSR, field NRFO[9:8] (RO)
 *
 * Next Receiver FIFO Out. Indicates which receiver returns the top word of the
 * Receive FIFO.
 *
 * Values:
 * - 00 - Receiver #0 returns next word from the Receive FIFO.
 * - 01 - Receiver #1 returns next word from the Receive FIFO.
 * - 10 - Receiver #2 returns next word from the Receive FIFO.
 * - 11 - Receiver #3 returns next word from the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFSR_NRFO    (8U)          /*!< Bit position for ESAI_RFSR_NRFO. */
#define BM_ESAI_RFSR_NRFO    (0x00000300U) /*!< Bit mask for ESAI_RFSR_NRFO. */
#define BS_ESAI_RFSR_NRFO    (2U)          /*!< Bit field size in bits for ESAI_RFSR_NRFO. */

/*! @brief Read current value of the ESAI_RFSR_NRFO field. */
#define BR_ESAI_RFSR_NRFO(x) (HW_ESAI_RFSR(x).B.NRFO)
/*@}*/

/*!
 * @name Register ESAI_RFSR, field NRFI[13:12] (RO)
 *
 * Next Receiver FIFO In. Indicates which Receiver Data Register the Receive
 * FIFO will load next. This will usually equal the lowest enabled receiver, unless
 * the receive FIFO is full.
 *
 * Values:
 * - 00 - Receiver #0 returns next word to the Receive FIFO.
 * - 01 - Receiver #1 returns next word to the Receive FIFO.
 * - 10 - Receiver #2 returns next word to the Receive FIFO.
 * - 11 - Receiver #3 returns next word to the Receive FIFO.
 */
/*@{*/
#define BP_ESAI_RFSR_NRFI    (12U)         /*!< Bit position for ESAI_RFSR_NRFI. */
#define BM_ESAI_RFSR_NRFI    (0x00003000U) /*!< Bit mask for ESAI_RFSR_NRFI. */
#define BS_ESAI_RFSR_NRFI    (2U)          /*!< Bit field size in bits for ESAI_RFSR_NRFI. */

/*! @brief Read current value of the ESAI_RFSR_NRFI field. */
#define BR_ESAI_RFSR_NRFI(x) (HW_ESAI_RFSR(x).B.NRFI)
/*@}*/

/*******************************************************************************
 * HW_ESAI_TXn - Transmit Data Register n
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TXn - Transmit Data Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * ESAI_TX5, ESAI_TX4, ESAI_TX3, ESAI_TX2, ESAI_TX1 and ESAI_TX0 are 32-bit
 * write-only registers. Data to be transmitted is written into these registers and
 * is automatically transferred to the transmit shift registers ( and ). The data
 * written (8, 12, 16, 20, or 24 bits) should occupy the most significant portion
 * of the TXn according to the ALC control bit setting. The unused bits (least
 * significant portion and the 8 most significant bits when ALC=1) of the TXn are
 * don't care bits. The Core is interrupted whenever the TXn becomes empty if the
 * transmit data register empty interrupt has been enabled.
 */
typedef union _hw_esai_txn
{
    uint32_t U;
    struct _hw_esai_txn_bitfields
    {
        uint32_t TXn : 24;             /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_txn_t;

/*!
 * @name Constants and macros for entire ESAI_TXn register
 */
/*@{*/
#define HW_ESAI_TXn_COUNT (6U)

#define HW_ESAI_TXn_ADDR(x, n)   ((uintptr_t)(x) + 0x80U + (0x4U * (n)))

#define HW_ESAI_TXn(x, n)        (*(__IO hw_esai_txn_t *) HW_ESAI_TXn_ADDR(x, n))
#define HW_ESAI_TXn_RD(x, n)     (HW_ESAI_TXn(x, n).U)
#define HW_ESAI_TXn_WR(x, n, v)  (HW_ESAI_TXn(x, n).U = (v))
#define HW_ESAI_TXn_SET(x, n, v) (HW_ESAI_TXn_WR(x, n, HW_ESAI_TXn_RD(x, n) |  (v)))
#define HW_ESAI_TXn_CLR(x, n, v) (HW_ESAI_TXn_WR(x, n, HW_ESAI_TXn_RD(x, n) & ~(v)))
#define HW_ESAI_TXn_TOG(x, n, v) (HW_ESAI_TXn_WR(x, n, HW_ESAI_TXn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TXn bitfields
 */

/*!
 * @name Register ESAI_TXn, field TXn[23:0] (WORZ)
 *
 * Stores the data to be transmitted and is automatically transferred to the
 * transmit shift registers. See ESAI Transmit Shift RegistersThe transmit shift
 * registers contain the data being transmitted Data is shifted out to the serial
 * transmit data pins by the selected (internal/external) bit clock when the
 * associated frame sync I/O is asserted. .
 */
/*@{*/
#define BP_ESAI_TXn_TXn      (0U)          /*!< Bit position for ESAI_TXn_TXn. */
#define BM_ESAI_TXn_TXn      (0x00FFFFFFU) /*!< Bit mask for ESAI_TXn_TXn. */
#define BS_ESAI_TXn_TXn      (24U)         /*!< Bit field size in bits for ESAI_TXn_TXn. */

/*! @brief Format value for bitfield ESAI_TXn_TXn. */
#define BF_ESAI_TXn_TXn(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TXn_TXn) & BM_ESAI_TXn_TXn)

/*! @brief Set the TXn field to a new value. */
#define BW_ESAI_TXn_TXn(x, n, v) (HW_ESAI_TXn_WR(x, n, (HW_ESAI_TXn_RD(x, n) & ~BM_ESAI_TXn_TXn) | BF_ESAI_TXn_TXn(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TSR - ESAI Transmit Slot Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TSR - ESAI Transmit Slot Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_esai_tsr
{
    uint32_t U;
    struct _hw_esai_tsr_bitfields
    {
        uint32_t TSR : 24;             /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_tsr_t;

/*!
 * @name Constants and macros for entire ESAI_TSR register
 */
/*@{*/
#define HW_ESAI_TSR_ADDR(x)      ((uintptr_t)(x) + 0x98U)

#define HW_ESAI_TSR(x)           (*(__IO hw_esai_tsr_t *) HW_ESAI_TSR_ADDR(x))
#define HW_ESAI_TSR_RD(x)        (HW_ESAI_TSR(x).U)
#define HW_ESAI_TSR_WR(x, v)     (HW_ESAI_TSR(x).U = (v))
#define HW_ESAI_TSR_SET(x, v)    (HW_ESAI_TSR_WR(x, HW_ESAI_TSR_RD(x) |  (v)))
#define HW_ESAI_TSR_CLR(x, v)    (HW_ESAI_TSR_WR(x, HW_ESAI_TSR_RD(x) & ~(v)))
#define HW_ESAI_TSR_TOG(x, v)    (HW_ESAI_TSR_WR(x, HW_ESAI_TSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TSR bitfields
 */

/*!
 * @name Register ESAI_TSR, field TSR[23:0] (WORZ)
 *
 * The write-only Transmit Slot Register (ESAI_TSR) is effectively a null data
 * register that is used when the data is not to be transmitted in the available
 * transmit time slot. The transmit data pins of all the enabled transmitters are
 * in the high-impedance state for the respective time slot where TSR has been
 * written. The Transmitter External Buffer Enable pin (FSR pin when SYN=1, TEBE=1,
 * RFSD=1) disables the external buffers during the slot when the ESAI_TSR
 * register has been written.
 */
/*@{*/
#define BP_ESAI_TSR_TSR      (0U)          /*!< Bit position for ESAI_TSR_TSR. */
#define BM_ESAI_TSR_TSR      (0x00FFFFFFU) /*!< Bit mask for ESAI_TSR_TSR. */
#define BS_ESAI_TSR_TSR      (24U)         /*!< Bit field size in bits for ESAI_TSR_TSR. */

/*! @brief Format value for bitfield ESAI_TSR_TSR. */
#define BF_ESAI_TSR_TSR(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TSR_TSR) & BM_ESAI_TSR_TSR)

/*! @brief Set the TSR field to a new value. */
#define BW_ESAI_TSR_TSR(x, v) (HW_ESAI_TSR_WR(x, (HW_ESAI_TSR_RD(x) & ~BM_ESAI_TSR_TSR) | BF_ESAI_TSR_TSR(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RXn - Receive Data Register n
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RXn - Receive Data Register n (RO)
 *
 * Reset value: 0x00000000U
 *
 * ESAI_RX3, ESAI_RX2, ESAI_RX1, and ESAI_RX0 are 32-bit read-only registers
 * that accept data from the receive shift registers when they become full ( and ).
 * The data occupies the most significant portion of the receive data registers,
 * according to the ALC control bit setting. The unused bits (least significant
 * portion and 8 most significant bits when ALC=1) read as zeros. The Core is
 * interrupted whenever RXn becomes full if the associated interrupt is enabled.
 */
typedef union _hw_esai_rxn
{
    uint32_t U;
    struct _hw_esai_rxn_bitfields
    {
        uint32_t RXn : 24;             /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_rxn_t;

/*!
 * @name Constants and macros for entire ESAI_RXn register
 */
/*@{*/
#define HW_ESAI_RXn_COUNT (4U)

#define HW_ESAI_RXn_ADDR(x, n)   ((uintptr_t)(x) + 0xA0U + (0x4U * (n)))

#define HW_ESAI_RXn(x, n)        (*(__I hw_esai_rxn_t *) HW_ESAI_RXn_ADDR(x, n))
#define HW_ESAI_RXn_RD(x, n)     (HW_ESAI_RXn(x, n).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_RXn bitfields
 */

/*!
 * @name Register ESAI_RXn, field RXn[23:0] (RO)
 *
 * Accept data from the receive shift registers when they become full See ESAI
 * Receive Shift Registers
 */
/*@{*/
#define BP_ESAI_RXn_RXn      (0U)          /*!< Bit position for ESAI_RXn_RXn. */
#define BM_ESAI_RXn_RXn      (0x00FFFFFFU) /*!< Bit mask for ESAI_RXn_RXn. */
#define BS_ESAI_RXn_RXn      (24U)         /*!< Bit field size in bits for ESAI_RXn_RXn. */

/*! @brief Read current value of the ESAI_RXn_RXn field. */
#define BR_ESAI_RXn_RXn(x, n) (HW_ESAI_RXn(x, n).B.RXn)
/*@}*/

/*******************************************************************************
 * HW_ESAI_SAISR - Serial Audio Interface Status Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_SAISR - Serial Audio Interface Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The Status Register (ESAI_SAISR) is a read-only status register used by the
 * ARM Core to read the status and serial input flags of the ESAI.
 */
typedef union _hw_esai_saisr
{
    uint32_t U;
    struct _hw_esai_saisr_bitfields
    {
        uint32_t IF0 : 1;              /*!< [0]  */
        uint32_t IF1 : 1;              /*!< [1]  */
        uint32_t IF2 : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 3;        /*!< [5:3]  */
        uint32_t RFS : 1;              /*!< [6]  */
        uint32_t ROE : 1;              /*!< [7]  */
        uint32_t RDF : 1;              /*!< [8]  */
        uint32_t REDF : 1;             /*!< [9]  */
        uint32_t RODF : 1;             /*!< [10]  */
        uint32_t RESERVED1 : 2;        /*!< [12:11]  */
        uint32_t TFS : 1;              /*!< [13]  */
        uint32_t TUE : 1;              /*!< [14]  */
        uint32_t TDE : 1;              /*!< [15]  */
        uint32_t TEDE : 1;             /*!< [16]  */
        uint32_t TODFE : 1;            /*!< [17]  */
        uint32_t RESERVED2 : 14;       /*!< [31:18]  */
    } B;
} hw_esai_saisr_t;

/*!
 * @name Constants and macros for entire ESAI_SAISR register
 */
/*@{*/
#define HW_ESAI_SAISR_ADDR(x)    ((uintptr_t)(x) + 0xCCU)

#define HW_ESAI_SAISR(x)         (*(__I hw_esai_saisr_t *) HW_ESAI_SAISR_ADDR(x))
#define HW_ESAI_SAISR_RD(x)      (HW_ESAI_SAISR(x).U)
/*@}*/

/*
 * Constants & macros for individual ESAI_SAISR bitfields
 */

/*!
 * @name Register ESAI_SAISR, field IF0[0] (RO)
 *
 * ESAI_SAISR Serial Input Flag 0. The IF0 bit is enabled only when the SCKR pin
 * is defined as ESAI in the Port Control Register, SYN=1 and RCKD=0, indicating
 * that SCKR is an input flag and the synchronous mode is selected. Data present
 * on the SCKR pin is latched during reception of the first received data bit
 * after frame sync is detected. The IF0 bit is updated with this data when the
 * receiver shift registers are transferred into the receiver data registers. IF0
 * reads as a zero when it is not enabled. Hardware, software, ESAI individual
 * reset clear IF0.
 */
/*@{*/
#define BP_ESAI_SAISR_IF0    (0U)          /*!< Bit position for ESAI_SAISR_IF0. */
#define BM_ESAI_SAISR_IF0    (0x00000001U) /*!< Bit mask for ESAI_SAISR_IF0. */
#define BS_ESAI_SAISR_IF0    (1U)          /*!< Bit field size in bits for ESAI_SAISR_IF0. */

/*! @brief Read current value of the ESAI_SAISR_IF0 field. */
#define BR_ESAI_SAISR_IF0(x) (HW_ESAI_SAISR(x).B.IF0)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field IF1[1] (RO)
 *
 * ESAI_SAISR Serial Inout Flag 1. The IF1 bit is enabled only when the FSR pin
 * is defined as ESAI in the Port Control Register, SYN =1, RFSD=0 and TEBE=0,
 * indicating that FSR is an input flag and the synchronous mode is selected. Data
 * present on the FSR pin is latched during reception of the first received data
 * bit after frame sync is detected. The IF1 bit is updated with this data when
 * the receiver shift registers are transferred into the receiver data registers.
 * IF1 reads as a zero when it is not enabled. Hardware, software, ESAI
 * individual reset clear IF1.
 */
/*@{*/
#define BP_ESAI_SAISR_IF1    (1U)          /*!< Bit position for ESAI_SAISR_IF1. */
#define BM_ESAI_SAISR_IF1    (0x00000002U) /*!< Bit mask for ESAI_SAISR_IF1. */
#define BS_ESAI_SAISR_IF1    (1U)          /*!< Bit field size in bits for ESAI_SAISR_IF1. */

/*! @brief Read current value of the ESAI_SAISR_IF1 field. */
#define BR_ESAI_SAISR_IF1(x) (HW_ESAI_SAISR(x).B.IF1)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field IF2[2] (RO)
 *
 * ESAI_SAISR Serial Input Flag 2. The IF2 bit is enabled only when the HCKR pin
 * is defined as ESAI in the Port Control Register, SYN=1 and RHCKD=0,
 * indicating that HCKR is an input flag and the synchronous mode is selected. Data
 * present on the HCKR pin is latched during reception of the first received data bit
 * after frame sync is detected. The IF2 bit is updated with this data when the
 * receive shift registers are transferred into the receiver data registers. IF2
 * reads as a zero when it is not enabled. Hardware, software, ESAI individual
 * reset clear IF2.
 */
/*@{*/
#define BP_ESAI_SAISR_IF2    (2U)          /*!< Bit position for ESAI_SAISR_IF2. */
#define BM_ESAI_SAISR_IF2    (0x00000004U) /*!< Bit mask for ESAI_SAISR_IF2. */
#define BS_ESAI_SAISR_IF2    (1U)          /*!< Bit field size in bits for ESAI_SAISR_IF2. */

/*! @brief Read current value of the ESAI_SAISR_IF2 field. */
#define BR_ESAI_SAISR_IF2(x) (HW_ESAI_SAISR(x).B.IF2)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field RFS[6] (RO)
 *
 * ESAI_SAISR Receive Frame Sync Flag. When set, RFS indicates that a receive
 * frame sync occurred during reception of the words in the receiver data
 * registers. This indicates that the data words are from the first slot in the frame.
 * When RFS is clear and a word is received, it indicates (only in the network mode)
 * that the frame sync did not occur during reception of that word. RFS is
 * cleared by hardware, software, ESAI individual reset. RFS is valid only if at least
 * one of the receivers is enabled (REx=1). (In normal mode, RFS always reads as
 * a one when reading data because there is only one time slot per frame - the
 * "frame sync" time slot)
 */
/*@{*/
#define BP_ESAI_SAISR_RFS    (6U)          /*!< Bit position for ESAI_SAISR_RFS. */
#define BM_ESAI_SAISR_RFS    (0x00000040U) /*!< Bit mask for ESAI_SAISR_RFS. */
#define BS_ESAI_SAISR_RFS    (1U)          /*!< Bit field size in bits for ESAI_SAISR_RFS. */

/*! @brief Read current value of the ESAI_SAISR_RFS field. */
#define BR_ESAI_SAISR_RFS(x) (HW_ESAI_SAISR(x).B.RFS)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field ROE[7] (RO)
 *
 * ESAI_SAISR Receive Overrun Error Flag. The ROE flag is set when the serial
 * receive shift register of an enabled receiver is full and ready to transfer to
 * its receiver data register (RXn) and the register is already full (RDF=1). If
 * REIE is set, an ESAI receive data with exception (overrun error) interrupt
 * request is issued when ROE is set. Hardware, software, ESAI individual reset clear
 * ROE. ROE is also cleared by reading the SAISR with ROE set, followed by
 * reading all the enabled receive data registers.
 */
/*@{*/
#define BP_ESAI_SAISR_ROE    (7U)          /*!< Bit position for ESAI_SAISR_ROE. */
#define BM_ESAI_SAISR_ROE    (0x00000080U) /*!< Bit mask for ESAI_SAISR_ROE. */
#define BS_ESAI_SAISR_ROE    (1U)          /*!< Bit field size in bits for ESAI_SAISR_ROE. */

/*! @brief Read current value of the ESAI_SAISR_ROE field. */
#define BR_ESAI_SAISR_ROE(x) (HW_ESAI_SAISR(x).B.ROE)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field RDF[8] (RO)
 *
 * ESAI_SAISR Receive Data Register Full. RDF is set when the contents of the
 * receive shift register of an enabled receiver is transferred to the respective
 * receive data register. RDF is cleared when the Core reads the receive data
 * register of all enabled receivers or cleared by hardware, software, ESAI
 * individual reset. If RIE is set, an ESAI receive data interrupt request is issued when
 * RDF is set.
 */
/*@{*/
#define BP_ESAI_SAISR_RDF    (8U)          /*!< Bit position for ESAI_SAISR_RDF. */
#define BM_ESAI_SAISR_RDF    (0x00000100U) /*!< Bit mask for ESAI_SAISR_RDF. */
#define BS_ESAI_SAISR_RDF    (1U)          /*!< Bit field size in bits for ESAI_SAISR_RDF. */

/*! @brief Read current value of the ESAI_SAISR_RDF field. */
#define BR_ESAI_SAISR_RDF(x) (HW_ESAI_SAISR(x).B.RDF)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field REDF[9] (RO)
 *
 * ESAI_SAISR Receive Even-Data Register Full. When set, REDF indicates that the
 * received data in the receive data registers of the enabled receivers have
 * arrived during an even time slot when operating in the network mode. Even time
 * slots are all even-numbered slots (0, 2, 4, 6, and so on). Time slots are
 * numbered from zero to N-1, where N is the number of time slots in the frame. The
 * zero time slot is considered even. REDF is set when the contents of the receive
 * shift registers are transferred to the receive data registers. REDF is cleared
 * when the Core reads all the enabled receive data registers or cleared by
 * hardware, software, ESAI individual resets. If REDIE is set, an ESAI receive even
 * slot data interrupt request is issued when REDF is set.
 */
/*@{*/
#define BP_ESAI_SAISR_REDF   (9U)          /*!< Bit position for ESAI_SAISR_REDF. */
#define BM_ESAI_SAISR_REDF   (0x00000200U) /*!< Bit mask for ESAI_SAISR_REDF. */
#define BS_ESAI_SAISR_REDF   (1U)          /*!< Bit field size in bits for ESAI_SAISR_REDF. */

/*! @brief Read current value of the ESAI_SAISR_REDF field. */
#define BR_ESAI_SAISR_REDF(x) (HW_ESAI_SAISR(x).B.REDF)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field RODF[10] (RO)
 *
 * ESAI_SAISR Receive Odd-Data Register Full. When set, RODF indicates that the
 * received data in the receive data registers of the enabled receivers have
 * arrived during an odd time slot when operating in the network mode. Odd time slots
 * are all odd-numbered slots (1, 3, 5, and so on). Time slots are numbered from
 * zero to N-1, where N is the number of time slots in the frame. RODF is set
 * when the contents of the receive shift registers are transferred to the receive
 * data registers. RODF is cleared when the Core reads all the enabled receive
 * data registers or cleared by hardware, software, ESAI individual resets.
 */
/*@{*/
#define BP_ESAI_SAISR_RODF   (10U)         /*!< Bit position for ESAI_SAISR_RODF. */
#define BM_ESAI_SAISR_RODF   (0x00000400U) /*!< Bit mask for ESAI_SAISR_RODF. */
#define BS_ESAI_SAISR_RODF   (1U)          /*!< Bit field size in bits for ESAI_SAISR_RODF. */

/*! @brief Read current value of the ESAI_SAISR_RODF field. */
#define BR_ESAI_SAISR_RODF(x) (HW_ESAI_SAISR(x).B.RODF)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field TFS[13] (RO)
 *
 * ESAI_SAISR Transmit Frame Sync Flag. When set, TFS indicates that a transmit
 * frame sync occurred in the current time slot. TFS is set at the start of the
 * first time slot in the frame and cleared during all other time slots. Data
 * written to a transmit data register during the time slot when TFS is set is
 * transmitted (in network mode), if the transmitter is enabled, during the second time
 * slot in the frame. TFS is useful in network mode to identify the start of a
 * frame. TFS is cleared by hardware, software, ESAI individual reset. TFS is
 * valid only if at least one transmitter is enabled, that is, one or more of TE0,
 * TE1, TE2, TE3, TE4 and TE5 are set. (In normal mode, TFS always reads as a one
 * when transmitting data because there is only one time slot per frame - the
 * "frame sync" time slot)
 */
/*@{*/
#define BP_ESAI_SAISR_TFS    (13U)         /*!< Bit position for ESAI_SAISR_TFS. */
#define BM_ESAI_SAISR_TFS    (0x00002000U) /*!< Bit mask for ESAI_SAISR_TFS. */
#define BS_ESAI_SAISR_TFS    (1U)          /*!< Bit field size in bits for ESAI_SAISR_TFS. */

/*! @brief Read current value of the ESAI_SAISR_TFS field. */
#define BR_ESAI_SAISR_TFS(x) (HW_ESAI_SAISR(x).B.TFS)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field TUE[14] (RO)
 *
 * ESAI_SAISR Transmit Underrun Error Flag. TUE is set when at least one of the
 * enabled serial transmit shift registers is empty (no new data to be
 * transmitted) and a transmit time slot occurs. When a transmit underrun error occurs, the
 * previous data (which is still present in the TX registers that were not
 * written) is retransmitted. If TEIE is set, an ESAI transmit data with exception
 * (underrun error) interrupt request is issued when TUE is set. Hardware, software,
 * ESAI individual reset clear TUE. TUE is also cleared by reading the
 * ESAI_SAISR with TUE set, followed by writing to all the enabled transmit data registers
 * or to ESAI_TSR.
 */
/*@{*/
#define BP_ESAI_SAISR_TUE    (14U)         /*!< Bit position for ESAI_SAISR_TUE. */
#define BM_ESAI_SAISR_TUE    (0x00004000U) /*!< Bit mask for ESAI_SAISR_TUE. */
#define BS_ESAI_SAISR_TUE    (1U)          /*!< Bit field size in bits for ESAI_SAISR_TUE. */

/*! @brief Read current value of the ESAI_SAISR_TUE field. */
#define BR_ESAI_SAISR_TUE(x) (HW_ESAI_SAISR(x).B.TUE)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field TDE[15] (RO)
 *
 * ESAI_SAISR Transmit Data Register Empty. TDE is set when the contents of the
 * transmit data register of all the enabled transmitters are transferred to the
 * transmit shift registers; it is also set for a TSR disabled time slot period
 * in network mode (as if data were being transmitted after the TSR was written).
 * When set, TDE indicates that data should be written to all the TX registers of
 * the enabled transmitters or to the transmit slot register (ESAI_TSR). TDE is
 * cleared when the Core writes to all the transmit data registers of the enabled
 * transmitters, or when the Core writes to the TSR to disable transmission of
 * the next time slot. If TIE is set, an ESAI transmit data interrupt request is
 * issued when TDE is set. Hardware, software, ESAI individual reset clear TDE.
 */
/*@{*/
#define BP_ESAI_SAISR_TDE    (15U)         /*!< Bit position for ESAI_SAISR_TDE. */
#define BM_ESAI_SAISR_TDE    (0x00008000U) /*!< Bit mask for ESAI_SAISR_TDE. */
#define BS_ESAI_SAISR_TDE    (1U)          /*!< Bit field size in bits for ESAI_SAISR_TDE. */

/*! @brief Read current value of the ESAI_SAISR_TDE field. */
#define BR_ESAI_SAISR_TDE(x) (HW_ESAI_SAISR(x).B.TDE)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field TEDE[16] (RO)
 *
 * ESAI_SAISR Transmit Even-DataRegister Empty. When set, TEDE indicates that
 * the enabled transmitter data registers became empty at the beginning of an even
 * time slot. Even time slots are all even-numbered slots (0, 2, 4, 6, etc.).
 * Time slots are numbered from zero to N-1, where N is the number of time slots in
 * the frame. The zero time slot is considered even. This flag is set when the
 * contents of the transmit data register of all the enabled transmitters are
 * transferred to the transmit shift registers; it is also set for a TSR disabled time
 * slot period in network mode (as if data were being transmitted after the TSR
 * was written). When set, TEDE indicates that data should be written to all the
 * TX registers of the enabled transmitters or to the transmit slot register
 * (ESAI_TSR). TEDE is cleared when the Core writes to all the transmit data
 * registers of the enabled transmitters, or when the Core writes to the TSR to disable
 * transmission of the next time slot. If TIE is set, an ESAI transmit data
 * interrupt request is issued when TEDE is set. Hardware, software, ESAI individual
 * reset clear TEDE.
 */
/*@{*/
#define BP_ESAI_SAISR_TEDE   (16U)         /*!< Bit position for ESAI_SAISR_TEDE. */
#define BM_ESAI_SAISR_TEDE   (0x00010000U) /*!< Bit mask for ESAI_SAISR_TEDE. */
#define BS_ESAI_SAISR_TEDE   (1U)          /*!< Bit field size in bits for ESAI_SAISR_TEDE. */

/*! @brief Read current value of the ESAI_SAISR_TEDE field. */
#define BR_ESAI_SAISR_TEDE(x) (HW_ESAI_SAISR(x).B.TEDE)
/*@}*/

/*!
 * @name Register ESAI_SAISR, field TODFE[17] (RO)
 *
 * ESAI_SAISR Transmit Odd-Data Register Empty. When set, TODFE indicates that
 * the enabled transmitter data registers became empty at the beginning of an odd
 * time slot. Odd time slots are all odd-numbered slots (1, 3, 5, and so on).
 * Time slots are numbered from zero to N-1, where N is the number of time slots in
 * the frame. This flag is set when the contents of the transmit data register of
 * all the enabled transmitters are transferred to the transmit shift registers;
 * it is also set for a TSR disabled time slot period in network mode (as if
 * data were being transmitted after the TSR was written). When set, TODFE indicates
 * that data should be written to all the TX registers of the enabled
 * transmitters or to the transmit slot register (ESAI_TSR). TODE is cleared when the Core
 * writes to all the transmit data registers of the enabled transmitters, or when
 * the Core writes to the TSR to disable transmission of the next time slot. If
 * TIE is set, an ESAI transmit data interrupt request is issued when TODFE is
 * set. Hardware, software, ESAI individual reset clear TODFE.
 */
/*@{*/
#define BP_ESAI_SAISR_TODFE  (17U)         /*!< Bit position for ESAI_SAISR_TODFE. */
#define BM_ESAI_SAISR_TODFE  (0x00020000U) /*!< Bit mask for ESAI_SAISR_TODFE. */
#define BS_ESAI_SAISR_TODFE  (1U)          /*!< Bit field size in bits for ESAI_SAISR_TODFE. */

/*! @brief Read current value of the ESAI_SAISR_TODFE field. */
#define BR_ESAI_SAISR_TODFE(x) (HW_ESAI_SAISR(x).B.TODFE)
/*@}*/

/*******************************************************************************
 * HW_ESAI_SAICR - Serial Audio Interface Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_SAICR - Serial Audio Interface Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write Common Control Register (ESAI_SAICR) contains control bits for
 * functions that affect both the receive and transmit sections of the ESAI.
 * SAICR SYN Bit Operation
 */
typedef union _hw_esai_saicr
{
    uint32_t U;
    struct _hw_esai_saicr_bitfields
    {
        uint32_t OF0 : 1;              /*!< [0]  */
        uint32_t OF1 : 1;              /*!< [1]  */
        uint32_t OF2 : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 3;        /*!< [5:3]  */
        uint32_t SYN : 1;              /*!< [6]  */
        uint32_t TEBE : 1;             /*!< [7]  */
        uint32_t ALC : 1;              /*!< [8]  */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_esai_saicr_t;

/*!
 * @name Constants and macros for entire ESAI_SAICR register
 */
/*@{*/
#define HW_ESAI_SAICR_ADDR(x)    ((uintptr_t)(x) + 0xD0U)

#define HW_ESAI_SAICR(x)         (*(__IO hw_esai_saicr_t *) HW_ESAI_SAICR_ADDR(x))
#define HW_ESAI_SAICR_RD(x)      (HW_ESAI_SAICR(x).U)
#define HW_ESAI_SAICR_WR(x, v)   (HW_ESAI_SAICR(x).U = (v))
#define HW_ESAI_SAICR_SET(x, v)  (HW_ESAI_SAICR_WR(x, HW_ESAI_SAICR_RD(x) |  (v)))
#define HW_ESAI_SAICR_CLR(x, v)  (HW_ESAI_SAICR_WR(x, HW_ESAI_SAICR_RD(x) & ~(v)))
#define HW_ESAI_SAICR_TOG(x, v)  (HW_ESAI_SAICR_WR(x, HW_ESAI_SAICR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_SAICR bitfields
 */

/*!
 * @name Register ESAI_SAICR, field OF0[0] (RW)
 *
 * ESAI_SAICR Serial Output Flag 0. The Serial Output Flag 0 (OF0) is a data bit
 * used to hold data to be send to the OF0 pin. When the ESAI is in the
 * synchronous clock mode (SYN=1), the SCKR pin is configured as the ESAI flag 0. If the
 * receiver serial clock direction bit (RCKD) is set, the SCKR pin is the output
 * flag OF0, and data present in the OF0 bit is written to the OF0 pin at the
 * beginning of the frame in normal mode or at the beginning of the next time slot
 * in network mode.
 */
/*@{*/
#define BP_ESAI_SAICR_OF0    (0U)          /*!< Bit position for ESAI_SAICR_OF0. */
#define BM_ESAI_SAICR_OF0    (0x00000001U) /*!< Bit mask for ESAI_SAICR_OF0. */
#define BS_ESAI_SAICR_OF0    (1U)          /*!< Bit field size in bits for ESAI_SAICR_OF0. */

/*! @brief Read current value of the ESAI_SAICR_OF0 field. */
#define BR_ESAI_SAICR_OF0(x) (HW_ESAI_SAICR(x).B.OF0)

/*! @brief Format value for bitfield ESAI_SAICR_OF0. */
#define BF_ESAI_SAICR_OF0(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_OF0) & BM_ESAI_SAICR_OF0)

/*! @brief Set the OF0 field to a new value. */
#define BW_ESAI_SAICR_OF0(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_OF0) | BF_ESAI_SAICR_OF0(v)))
/*@}*/

/*!
 * @name Register ESAI_SAICR, field OF1[1] (RW)
 *
 * ESAI_SAICR Serial Output Flag 1. The Serial Output Flag 1 (OF1) is a data bit
 * used to hold data to be send to the OF1 pin. When the ESAI is in the
 * synchronous clock mode (SYN=1), the FSR pin is configured as the ESAI flag 1. If the
 * receiver frame sync direction bit (RFSD) is set and the TEBE bit is cleared,
 * the FSR pin is the output flag OF1, and data present in the OF1 bit is written
 * to the OF1 pin at the beginning of the frame in normal mode or at the beginning
 * of the next time slot in network mode.
 */
/*@{*/
#define BP_ESAI_SAICR_OF1    (1U)          /*!< Bit position for ESAI_SAICR_OF1. */
#define BM_ESAI_SAICR_OF1    (0x00000002U) /*!< Bit mask for ESAI_SAICR_OF1. */
#define BS_ESAI_SAICR_OF1    (1U)          /*!< Bit field size in bits for ESAI_SAICR_OF1. */

/*! @brief Read current value of the ESAI_SAICR_OF1 field. */
#define BR_ESAI_SAICR_OF1(x) (HW_ESAI_SAICR(x).B.OF1)

/*! @brief Format value for bitfield ESAI_SAICR_OF1. */
#define BF_ESAI_SAICR_OF1(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_OF1) & BM_ESAI_SAICR_OF1)

/*! @brief Set the OF1 field to a new value. */
#define BW_ESAI_SAICR_OF1(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_OF1) | BF_ESAI_SAICR_OF1(v)))
/*@}*/

/*!
 * @name Register ESAI_SAICR, field OF2[2] (RW)
 *
 * ESAI_SAICR Serial Output Flag 2. The Serial Output Flag 2 (OF2) is a data bit
 * used to hold data to be send to the OF2 pin. When the ESAI is in the
 * synchronous clock mode (SYN=1), the HCKR pin is configured as the ESAI flag 2. If the
 * receiver high frequency clock direction bit (RHCKD) is set, the HCKR pin is
 * the output flag OF2, and data present in the OF2 bit is written to the OF2 pin
 * at the beginning of the frame in normal mode or at the beginning of the next
 * time slot in network mode.
 */
/*@{*/
#define BP_ESAI_SAICR_OF2    (2U)          /*!< Bit position for ESAI_SAICR_OF2. */
#define BM_ESAI_SAICR_OF2    (0x00000004U) /*!< Bit mask for ESAI_SAICR_OF2. */
#define BS_ESAI_SAICR_OF2    (1U)          /*!< Bit field size in bits for ESAI_SAICR_OF2. */

/*! @brief Read current value of the ESAI_SAICR_OF2 field. */
#define BR_ESAI_SAICR_OF2(x) (HW_ESAI_SAICR(x).B.OF2)

/*! @brief Format value for bitfield ESAI_SAICR_OF2. */
#define BF_ESAI_SAICR_OF2(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_OF2) & BM_ESAI_SAICR_OF2)

/*! @brief Set the OF2 field to a new value. */
#define BW_ESAI_SAICR_OF2(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_OF2) | BF_ESAI_SAICR_OF2(v)))
/*@}*/

/*!
 * @name Register ESAI_SAICR, field SYN[6] (RW)
 *
 * ESAI_SAICR Synchronous Mode Selection. The Synchronous Mode Selection (SYN)
 * bit controls whether the receiver and transmitter sections of the ESAI operate
 * synchronously or asynchronously with respect to each other (see Port C Control
 * Register Serial Audio Interface Control Register ). When SYN is cleared, the
 * asynchronous mode is chosen and independent clock and frame sync signals are
 * used for the transmit and receive sections. When SYN is set, the synchronous
 * mode is chosen and the transmit and receive sections use common clock and frame
 * sync signals. When in the synchronous mode (SYN=1), the transmit and receive
 * sections use the transmitter section clock generator as the source of the clock
 * and frame sync for both sections. Also, the receiver clock pins SCKR, FSR and
 * HCKR now operate as I/O flags. Refer to , , and for the effects of SYN on the
 * receiver clock pins.
 */
/*@{*/
#define BP_ESAI_SAICR_SYN    (6U)          /*!< Bit position for ESAI_SAICR_SYN. */
#define BM_ESAI_SAICR_SYN    (0x00000040U) /*!< Bit mask for ESAI_SAICR_SYN. */
#define BS_ESAI_SAICR_SYN    (1U)          /*!< Bit field size in bits for ESAI_SAICR_SYN. */

/*! @brief Read current value of the ESAI_SAICR_SYN field. */
#define BR_ESAI_SAICR_SYN(x) (HW_ESAI_SAICR(x).B.SYN)

/*! @brief Format value for bitfield ESAI_SAICR_SYN. */
#define BF_ESAI_SAICR_SYN(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_SYN) & BM_ESAI_SAICR_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_ESAI_SAICR_SYN(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_SYN) | BF_ESAI_SAICR_SYN(v)))
/*@}*/

/*!
 * @name Register ESAI_SAICR, field TEBE[7] (RW)
 *
 * ESAI_SAICR Transmit External Buffer Enable. The Transmitter External Buffer
 * Enable (TEBE) bit controls the function of the FSR pin when in the synchronous
 * mode. If the ESAI is configured for operation in the synchronous mode (SYN=1),
 * and TEBE is set while FSR pin is configured as an output (RFSD=1), the FSR
 * pin functions as the transmitter external buffer enable control to enable the
 * use of an external buffers on the transmitter outputs. If TEBE is cleared, the
 * FSR pin functions as the serial I/O flag 1. See Port C Control Register Receive
 * Clock Control Register for a summary of the effects of TEBE on the FSR pin.
 */
/*@{*/
#define BP_ESAI_SAICR_TEBE   (7U)          /*!< Bit position for ESAI_SAICR_TEBE. */
#define BM_ESAI_SAICR_TEBE   (0x00000080U) /*!< Bit mask for ESAI_SAICR_TEBE. */
#define BS_ESAI_SAICR_TEBE   (1U)          /*!< Bit field size in bits for ESAI_SAICR_TEBE. */

/*! @brief Read current value of the ESAI_SAICR_TEBE field. */
#define BR_ESAI_SAICR_TEBE(x) (HW_ESAI_SAICR(x).B.TEBE)

/*! @brief Format value for bitfield ESAI_SAICR_TEBE. */
#define BF_ESAI_SAICR_TEBE(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_TEBE) & BM_ESAI_SAICR_TEBE)

/*! @brief Set the TEBE field to a new value. */
#define BW_ESAI_SAICR_TEBE(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_TEBE) | BF_ESAI_SAICR_TEBE(v)))
/*@}*/

/*!
 * @name Register ESAI_SAICR, field ALC[8] (RW)
 *
 * ESAI_SAICR Alignment Control. The ESAI is designed for 24-bit fractional
 * data, thus shorter data words are left aligned to the MSB (bit 23). Some
 * applications use 16-bit fractional data. In those cases, shorter data words may be left
 * aligned to bit 15. The Alignment Control (ALC) bit supports these
 * applications. If ALC is set, transmitted and received words are left aligned to bit 15 in
 * the transmit and receive shift registers. If ALC is cleared, transmitted and
 * received word are left aligned to bit 23 in the transmit and receive shift
 * registers. While ALC is set, 20-bit and 24-bit words may not be used, and word
 * length control should specify 8-, 12-, or 16-bit words; otherwise, results are
 * unpredictable.
 */
/*@{*/
#define BP_ESAI_SAICR_ALC    (8U)          /*!< Bit position for ESAI_SAICR_ALC. */
#define BM_ESAI_SAICR_ALC    (0x00000100U) /*!< Bit mask for ESAI_SAICR_ALC. */
#define BS_ESAI_SAICR_ALC    (1U)          /*!< Bit field size in bits for ESAI_SAICR_ALC. */

/*! @brief Read current value of the ESAI_SAICR_ALC field. */
#define BR_ESAI_SAICR_ALC(x) (HW_ESAI_SAICR(x).B.ALC)

/*! @brief Format value for bitfield ESAI_SAICR_ALC. */
#define BF_ESAI_SAICR_ALC(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_SAICR_ALC) & BM_ESAI_SAICR_ALC)

/*! @brief Set the ALC field to a new value. */
#define BW_ESAI_SAICR_ALC(x, v) (HW_ESAI_SAICR_WR(x, (HW_ESAI_SAICR_RD(x) & ~BM_ESAI_SAICR_ALC) | BF_ESAI_SAICR_ALC(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TCR - Transmit Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TCR - Transmit Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write Transmit Control Register (ESAI_TCR) controls the ESAI
 * transmitter section. Interrupt enable bits for the transmitter section are provided
 * in this control register. Operating modes are also selected in this register.
 * Transmit Network Mode Selection TMOD1 TMOD0 TDC4-TDC0 Transmitter Network Mode
 * 0 0 0x0-0x1F Normal Mode 0 1 0x0 On-Demand Mode 0 1 0x1-0x1F Network Mode 1 0
 * X Reserved 1 1 0x0C AC97 Normal and Network Operation ESAI Transmit Slot and
 * Word Length Selection TSWS4 TSWS3 TSWS2 TSWS1 TSWS0 SLOT LENGTH WORD LENGTH 0 0
 * 0 0 0 8 8 0 0 1 0 0 12 8 0 0 0 0 1 12 0 1 0 0 0 16 8 0 0 1 0 1 12 0 0 0 1 0
 * 16 0 1 1 0 0 20 8 0 1 0 0 1 12 0 0 1 1 0 16 0 0 0 1 1 20 1 0 0 0 0 24 8 0 1 1 0
 * 1 12 0 1 0 1 0 16 0 0 1 1 1 20 1 1 1 1 0 24 1 1 0 0 0 32 8 1 0 1 0 1 12 1 0 0
 * 1 0 16 0 1 1 1 1 20 1 1 1 1 1 24 0 1 0 1 1 Reserved 0 1 1 1 0 1 0 0 0 1 1 0 0
 * 1 1 1 0 1 0 0 1 0 1 1 0 1 0 1 1 1 1 1 0 0 1 1 1 0 1 0 1 1 0 1 1 1 1 1 0 0 1 1
 * 1 0 1 Frame Length Selection
 */
typedef union _hw_esai_tcr
{
    uint32_t U;
    struct _hw_esai_tcr_bitfields
    {
        uint32_t TE0 : 1;              /*!< [0]  */
        uint32_t TE1 : 1;              /*!< [1]  */
        uint32_t TE2 : 1;              /*!< [2]  */
        uint32_t TE3 : 1;              /*!< [3]  */
        uint32_t TE4 : 1;              /*!< [4]  */
        uint32_t TE5 : 1;              /*!< [5]  */
        uint32_t TSHFD : 1;            /*!< [6]  */
        uint32_t TWA : 1;              /*!< [7]  */
        uint32_t TMOD : 2;             /*!< [9:8]  */
        uint32_t TSWS : 5;             /*!< [14:10]  */
        uint32_t TFSL : 1;             /*!< [15]  */
        uint32_t TFSR : 1;             /*!< [16]  */
        uint32_t PADC : 1;             /*!< [17]  */
        uint32_t RESERVED0 : 1;        /*!< [18]  */
        uint32_t TPR : 1;              /*!< [19]  */
        uint32_t TEIE : 1;             /*!< [20]  */
        uint32_t TEDIE : 1;            /*!< [21]  */
        uint32_t TIE : 1;              /*!< [22]  */
        uint32_t TLIE : 1;             /*!< [23]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_tcr_t;

/*!
 * @name Constants and macros for entire ESAI_TCR register
 */
/*@{*/
#define HW_ESAI_TCR_ADDR(x)      ((uintptr_t)(x) + 0xD4U)

#define HW_ESAI_TCR(x)           (*(__IO hw_esai_tcr_t *) HW_ESAI_TCR_ADDR(x))
#define HW_ESAI_TCR_RD(x)        (HW_ESAI_TCR(x).U)
#define HW_ESAI_TCR_WR(x, v)     (HW_ESAI_TCR(x).U = (v))
#define HW_ESAI_TCR_SET(x, v)    (HW_ESAI_TCR_WR(x, HW_ESAI_TCR_RD(x) |  (v)))
#define HW_ESAI_TCR_CLR(x, v)    (HW_ESAI_TCR_WR(x, HW_ESAI_TCR_RD(x) & ~(v)))
#define HW_ESAI_TCR_TOG(x, v)    (HW_ESAI_TCR_WR(x, HW_ESAI_TCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TCR bitfields
 */

/*!
 * @name Register ESAI_TCR, field TE0[0] (RW)
 *
 * ESAI_TCR ESAI Transmit 0 Enable. TE0 enables the transfer of data from
 * ESAI_TX0 to the transmit shift register #0. When TE0 is set and a frame sync is
 * detected, the transmit #0 portion of the ESAI is enabled for that frame. When TE0
 * is cleared, the transmitter #0 is disabled after completing transmission of
 * data currently in the ESAI transmit shift register. The SDO0 output is
 * tri-stated, and any data present in ESAI_TX0 is not transmitted, that is, data can be
 * written to ESAI_TX0 with TE0 cleared, but data is not transferred to the
 * transmit shift register #0. The normal mode transmit enable sequence is to write
 * data to one or more transmit data registers before setting TEx. The normal
 * transmit disable sequence is to clear TEx, TIE and TEIE after TDE equals one. In the
 * network mode, the operation of clearing TE0 and setting it again disables the
 * transmitter #0 after completing transmission of the current data word until
 * the beginning of the next frame. During that time period, the SDO0 pin remains
 * in the high-impedance state.The on-demand mode transmit enable sequence can be
 * the same as the normal mode, or TE0 can be left enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE0      (0U)          /*!< Bit position for ESAI_TCR_TE0. */
#define BM_ESAI_TCR_TE0      (0x00000001U) /*!< Bit mask for ESAI_TCR_TE0. */
#define BS_ESAI_TCR_TE0      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE0. */

/*! @brief Read current value of the ESAI_TCR_TE0 field. */
#define BR_ESAI_TCR_TE0(x)   (HW_ESAI_TCR(x).B.TE0)

/*! @brief Format value for bitfield ESAI_TCR_TE0. */
#define BF_ESAI_TCR_TE0(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE0) & BM_ESAI_TCR_TE0)

/*! @brief Set the TE0 field to a new value. */
#define BW_ESAI_TCR_TE0(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE0) | BF_ESAI_TCR_TE0(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TE1[1] (RW)
 *
 * ESAI_TCR ESAI Transmit 1 Enable. TE1 enables the transfer of data from TX1 to
 * the transmit shift register #1. When TE1 is set and a frame sync is detected,
 * the transmit #1 portion of the ESAI is enabled for that frame. When TE1 is
 * cleared, the transmitter #1 is disabled after completing transmission of data
 * currently in the ESAI transmit shift register. The SDO1 output is tri-stated,
 * and any data present in TX1 is not transmitted, that is, data can be written to
 * TX1 with TE1 cleared, but data is not transferred to the transmit shift
 * register #1. The normal mode transmit enable sequence is to write data to one or
 * more transmit data registers before setting TEx. The normal transmit disable
 * sequence is to clear TEx, TIE and TEIE after TDE equals one. In the network mode,
 * the operation of clearing TE1 and setting it again disables the transmitter #1
 * after completing transmission of the current data word until the beginning of
 * the next frame. During that time period, the SDO1 pin remains in the
 * high-impedance state. The on-demand mode transmit enable sequence can be the same as
 * the normal mode, or TE1 can be left enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE1      (1U)          /*!< Bit position for ESAI_TCR_TE1. */
#define BM_ESAI_TCR_TE1      (0x00000002U) /*!< Bit mask for ESAI_TCR_TE1. */
#define BS_ESAI_TCR_TE1      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE1. */

/*! @brief Read current value of the ESAI_TCR_TE1 field. */
#define BR_ESAI_TCR_TE1(x)   (HW_ESAI_TCR(x).B.TE1)

/*! @brief Format value for bitfield ESAI_TCR_TE1. */
#define BF_ESAI_TCR_TE1(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE1) & BM_ESAI_TCR_TE1)

/*! @brief Set the TE1 field to a new value. */
#define BW_ESAI_TCR_TE1(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE1) | BF_ESAI_TCR_TE1(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TE2[2] (RW)
 *
 * ESAI_TCR ESAI Transmit 2 Enable. TE2 enables the transfer of data from
 * ESAI_TX2 to the transmit shift register #2. When TE2 is set and a frame sync is
 * detected, the transmit #2 portion of the ESAI is enabled for that frame. When TE2
 * is cleared, the transmitter #2 is disabled after completing transmission of
 * data currently in the ESAI transmit shift register. Data can be written to
 * ESAI_TX2 when TE2 is cleared but the data is not transferred to the transmit shift
 * register #2. The SDO2/SDI3 pin is the data input pin for ESAI_RX3 if TE2 is
 * cleared and RE3 in the ESAI_RCR register is set. If both RE3 and TE2 are
 * cleared, the transmitter and receiver are disabled, and the pin is tri-stated. Both
 * RE3 and TE2 should not be set at the same time. The normal mode transmit enable
 * sequence is to write data to one or more transmit data registers before
 * setting TEx. The normal transmit disable sequence is to clear TEx, TIE and TEIE
 * after TDE equals one. In the network mode, the operation of clearing TE2 and
 * setting it again disables the transmitter #2 after completing transmission of the
 * current data word until the beginning of the next frame. During that time
 * period, the SDO2/SDI3 pin remains in the high-impedance state. The on-demand mode
 * transmit enable sequence can be the same as the normal mode, or TE2 can be
 * left enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE2      (2U)          /*!< Bit position for ESAI_TCR_TE2. */
#define BM_ESAI_TCR_TE2      (0x00000004U) /*!< Bit mask for ESAI_TCR_TE2. */
#define BS_ESAI_TCR_TE2      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE2. */

/*! @brief Read current value of the ESAI_TCR_TE2 field. */
#define BR_ESAI_TCR_TE2(x)   (HW_ESAI_TCR(x).B.TE2)

/*! @brief Format value for bitfield ESAI_TCR_TE2. */
#define BF_ESAI_TCR_TE2(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE2) & BM_ESAI_TCR_TE2)

/*! @brief Set the TE2 field to a new value. */
#define BW_ESAI_TCR_TE2(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE2) | BF_ESAI_TCR_TE2(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TE3[3] (RW)
 *
 * ESAI_TCR ESAI Transmit 3 Enable. TE3 enables the transfer of data from
 * ESAI_TX3 to the transmit shift register #3. When TE3 is set and a frame sync is
 * detected, the transmit #3 portion of the ESAI is enabled for that frame. When TE3
 * is cleared, the transmitter #3 is disabled after completing transmission of
 * data currently in the ESAI transmit shift register. Data can be written to
 * ESAI_TX3 when TE3 is cleared but the data is not transferred to the transmit shift
 * register #3. The SDO3/SDI2 pin is the data input pin for ESAI_RX2 if TE3 is
 * cleared and RE2 in the ESAI_RCR register is set. If both RE2 and TE3 are
 * cleared, the transmitter and receiver are disabled, and the pin is tri-stated. Both
 * RE2 and TE3 should not be set at the same time. The normal mode transmit enable
 * sequence is to write data to one or more transmit data registers before
 * setting TEx. The normal transmit disable sequence is to clear TEx, TIE and TEIE
 * after TDE equals one. In the network mode, the operation of clearing TE3 and
 * setting it again disables the transmitter #3 after completing transmission of the
 * current data word until the beginning of the next frame. During that time
 * period, the SDO3/SDI2 pin remains in the high-impedance state. The on-demand mode
 * transmit enable sequence can be the same as the normal mode, or TE3 can be
 * left enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE3      (3U)          /*!< Bit position for ESAI_TCR_TE3. */
#define BM_ESAI_TCR_TE3      (0x00000008U) /*!< Bit mask for ESAI_TCR_TE3. */
#define BS_ESAI_TCR_TE3      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE3. */

/*! @brief Read current value of the ESAI_TCR_TE3 field. */
#define BR_ESAI_TCR_TE3(x)   (HW_ESAI_TCR(x).B.TE3)

/*! @brief Format value for bitfield ESAI_TCR_TE3. */
#define BF_ESAI_TCR_TE3(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE3) & BM_ESAI_TCR_TE3)

/*! @brief Set the TE3 field to a new value. */
#define BW_ESAI_TCR_TE3(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE3) | BF_ESAI_TCR_TE3(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TE4[4] (RW)
 *
 * ESAI_TCR ESAI Transmit 4 Enable. TE4 enables the transfer of data from
 * ESAI_TX4 to the transmit shift register #4. When TE4 is set and a frame sync is
 * detected, the transmit #4 portion of the ESAI is enabled for that frame. When TE4
 * is cleared, the transmitter #4 is disabled after completing transmission of
 * data currently in the ESAI transmit shift register. Data can be written to
 * ESAI_TX4 when TE4 is cleared but the data is not transferred to the transmit shift
 * register #4. The SDO4/SDI1 pin is the data input pin for ESAI_RX1 if TE4 is
 * cleared and RE1 in the RCR register is set. If both RE1 and TE4 are cleared, the
 * transmitter and receiver are disabled, and the pin is tri-stated. Both RE1
 * and TE4 should not be set at the same time. The normal mode transmit enable
 * sequence is to write data to one or more transmit data registers before setting
 * TEx. The normal transmit disable sequence is to clear TEx, TIE and TEIE after
 * TDE equals one. In the network mode, the operation of clearing TE4 and setting
 * it again disables the transmitter #4 after completing transmission of the
 * current data word until the beginning of the next frame. During that time period,
 * the SDO4/SDI1 pin remains in the high-impedance state. The on-demand mode
 * transmit enable sequence can be the same as the normal mode, or TE4 can be left
 * enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE4      (4U)          /*!< Bit position for ESAI_TCR_TE4. */
#define BM_ESAI_TCR_TE4      (0x00000010U) /*!< Bit mask for ESAI_TCR_TE4. */
#define BS_ESAI_TCR_TE4      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE4. */

/*! @brief Read current value of the ESAI_TCR_TE4 field. */
#define BR_ESAI_TCR_TE4(x)   (HW_ESAI_TCR(x).B.TE4)

/*! @brief Format value for bitfield ESAI_TCR_TE4. */
#define BF_ESAI_TCR_TE4(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE4) & BM_ESAI_TCR_TE4)

/*! @brief Set the TE4 field to a new value. */
#define BW_ESAI_TCR_TE4(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE4) | BF_ESAI_TCR_TE4(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TE5[5] (RW)
 *
 * ESAI_TCR ESAI Transmit 5 Enable. TE5 enables the transfer of data from
 * ESAI_TX5 to the transmit shift register #5. When TE5 is set and a frame sync is
 * detected, the transmit #5 portion of the ESAI is enabled for that frame. When TE5
 * is cleared, the transmitter #5 is disabled after completing transmission of
 * data currently in the ESAI transmit shift register. Data can be written to
 * ESAI_TX5 when TE5 is cleared but the data is not transferred to the transmit shift
 * register #5. The SDO5/SDI0 pin is the data input pin for ESAI_RX0 if TE5 is
 * cleared and RE0 in the ESAI_RCR register is set. If both RE0 and TE5 are
 * cleared, the transmitter and receiver are disabled, and the pin is tri-stated. Both
 * RE0 and TE5 should not be set at the same time. The normal mode transmit enable
 * sequence is to write data to one or more transmit data registers before
 * setting TEx. The normal transmit disable sequence is to clear TEx, TIE and TEIE
 * after TDE equals one. In the network mode, the operation of clearing TE5 and
 * setting it again disables the transmitter #5 after completing transmission of the
 * current data word until the beginning of the next frame. During that time
 * period, the SDO5/SDI0 pin remains in the high-impedance state. The on-demand mode
 * transmit enable sequence can be the same as the normal mode, or TE5 can be
 * left enabled.
 */
/*@{*/
#define BP_ESAI_TCR_TE5      (5U)          /*!< Bit position for ESAI_TCR_TE5. */
#define BM_ESAI_TCR_TE5      (0x00000020U) /*!< Bit mask for ESAI_TCR_TE5. */
#define BS_ESAI_TCR_TE5      (1U)          /*!< Bit field size in bits for ESAI_TCR_TE5. */

/*! @brief Read current value of the ESAI_TCR_TE5 field. */
#define BR_ESAI_TCR_TE5(x)   (HW_ESAI_TCR(x).B.TE5)

/*! @brief Format value for bitfield ESAI_TCR_TE5. */
#define BF_ESAI_TCR_TE5(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TE5) & BM_ESAI_TCR_TE5)

/*! @brief Set the TE5 field to a new value. */
#define BW_ESAI_TCR_TE5(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TE5) | BF_ESAI_TCR_TE5(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TSHFD[6] (RW)
 *
 * ESAI_TCR Transmit Shift Direction. The TSHFD bit causes the transmit shift
 * registers to shift data out MSB first when TSHFD equals zero or LSB first when
 * TSHFD equals one (see and .
 */
/*@{*/
#define BP_ESAI_TCR_TSHFD    (6U)          /*!< Bit position for ESAI_TCR_TSHFD. */
#define BM_ESAI_TCR_TSHFD    (0x00000040U) /*!< Bit mask for ESAI_TCR_TSHFD. */
#define BS_ESAI_TCR_TSHFD    (1U)          /*!< Bit field size in bits for ESAI_TCR_TSHFD. */

/*! @brief Read current value of the ESAI_TCR_TSHFD field. */
#define BR_ESAI_TCR_TSHFD(x) (HW_ESAI_TCR(x).B.TSHFD)

/*! @brief Format value for bitfield ESAI_TCR_TSHFD. */
#define BF_ESAI_TCR_TSHFD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TSHFD) & BM_ESAI_TCR_TSHFD)

/*! @brief Set the TSHFD field to a new value. */
#define BW_ESAI_TCR_TSHFD(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TSHFD) | BF_ESAI_TCR_TSHFD(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TWA[7] (RW)
 *
 * ESAI_TCR Transmit Word Alignment Control. The Transmitter Word Alignment
 * Control (TWA) bit defines the alignment of the data word in relation to the slot.
 * This is relevant for the cases where the word length is shorter than the slot
 * length. If TWA is cleared, the data word is left-aligned in the slot frame
 * during transmission. If TWA is set, the data word is right-aligned in the slot
 * frame during transmission. Because the data word is shorter than the slot
 * length, the data word is extended until achieving the slot length, according to the
 * following rule: If the data word is left-aligned (TWA=0), and zero padding is
 * disabled (PADC=0), the last data bit is repeated after the data word has been
 * transmitted. If zero padding is enabled (PADC=1), zeroes are transmitted after
 * the data word has been transmitted. If the data word is right-aligned
 * (TWA=1), and zero padding is disabled (PADC=0), the first data bit is repeated before
 * the transmission of the data word. If zero padding is enabled (PADC=1),
 * zeroes are transmitted before the transmission of the data word.
 */
/*@{*/
#define BP_ESAI_TCR_TWA      (7U)          /*!< Bit position for ESAI_TCR_TWA. */
#define BM_ESAI_TCR_TWA      (0x00000080U) /*!< Bit mask for ESAI_TCR_TWA. */
#define BS_ESAI_TCR_TWA      (1U)          /*!< Bit field size in bits for ESAI_TCR_TWA. */

/*! @brief Read current value of the ESAI_TCR_TWA field. */
#define BR_ESAI_TCR_TWA(x)   (HW_ESAI_TCR(x).B.TWA)

/*! @brief Format value for bitfield ESAI_TCR_TWA. */
#define BF_ESAI_TCR_TWA(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TWA) & BM_ESAI_TCR_TWA)

/*! @brief Set the TWA field to a new value. */
#define BW_ESAI_TCR_TWA(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TWA) | BF_ESAI_TCR_TWA(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TMOD[9:8] (RW)
 *
 * ESAI_TCR Transmit Network Mode Control (TMOD1-TMOD0). The TMOD1 and TMOD0
 * bits are used to define the network mode of ESAI transmitters, as shown in Port C
 * Control Register . In the normal mode, the frame rate divider determines the
 * word transfer rate - one word is transferred per frame sync during the frame
 * sync time slot, as shown in . In network mode, it is possible to transfer a
 * word for every time slot, as shown in . For further details, refer to Modes of
 * OperationESAI has three basic operating modes and many data/operation formats.
 * In order to comply with AC-97 specifications, TSWS4-TSWS0 should be set to
 * 00011 (20-bit slot, 20-bit word length), TFSL and TFSR should be cleared, and
 * TDC4-TDC0 should be set to 0x0C (13 words in frame). If TMOD[1:0]=0b11 and the
 * above recommendations are followed, the first slot and word will be 16 bits long,
 * and the next 12 slots and words will be 20 bits long, as required by the AC97
 * protocol.
 */
/*@{*/
#define BP_ESAI_TCR_TMOD     (8U)          /*!< Bit position for ESAI_TCR_TMOD. */
#define BM_ESAI_TCR_TMOD     (0x00000300U) /*!< Bit mask for ESAI_TCR_TMOD. */
#define BS_ESAI_TCR_TMOD     (2U)          /*!< Bit field size in bits for ESAI_TCR_TMOD. */

/*! @brief Read current value of the ESAI_TCR_TMOD field. */
#define BR_ESAI_TCR_TMOD(x)  (HW_ESAI_TCR(x).B.TMOD)

/*! @brief Format value for bitfield ESAI_TCR_TMOD. */
#define BF_ESAI_TCR_TMOD(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TMOD) & BM_ESAI_TCR_TMOD)

/*! @brief Set the TMOD field to a new value. */
#define BW_ESAI_TCR_TMOD(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TMOD) | BF_ESAI_TCR_TMOD(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TSWS[14:10] (RW)
 *
 * ESAI_TCR Tx Slot and Word Length Select (TSWS4-TSWS0). The TSWS4-TSWS0 bits
 * are used to select the length of the slot and the length of the data words
 * being transferred through the ESAI. The word length must be equal to or shorter
 * than the slot length. The possible combinations are shown in . See also the ESAI
 * data path programming model in and .
 */
/*@{*/
#define BP_ESAI_TCR_TSWS     (10U)         /*!< Bit position for ESAI_TCR_TSWS. */
#define BM_ESAI_TCR_TSWS     (0x00007C00U) /*!< Bit mask for ESAI_TCR_TSWS. */
#define BS_ESAI_TCR_TSWS     (5U)          /*!< Bit field size in bits for ESAI_TCR_TSWS. */

/*! @brief Read current value of the ESAI_TCR_TSWS field. */
#define BR_ESAI_TCR_TSWS(x)  (HW_ESAI_TCR(x).B.TSWS)

/*! @brief Format value for bitfield ESAI_TCR_TSWS. */
#define BF_ESAI_TCR_TSWS(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TSWS) & BM_ESAI_TCR_TSWS)

/*! @brief Set the TSWS field to a new value. */
#define BW_ESAI_TCR_TSWS(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TSWS) | BF_ESAI_TCR_TSWS(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TFSL[15] (RW)
 *
 * ESAI_TCR Transmit Frame Sync Length. The TFSL bit selects the length of frame
 * sync to be generated or recognized. If TFSL is cleared, a word-length frame
 * sync is selected. If TFSL is set, a 1-bit clock period frame sync is selected.
 * See Figure 1-21 for examples of frame length selection.
 */
/*@{*/
#define BP_ESAI_TCR_TFSL     (15U)         /*!< Bit position for ESAI_TCR_TFSL. */
#define BM_ESAI_TCR_TFSL     (0x00008000U) /*!< Bit mask for ESAI_TCR_TFSL. */
#define BS_ESAI_TCR_TFSL     (1U)          /*!< Bit field size in bits for ESAI_TCR_TFSL. */

/*! @brief Read current value of the ESAI_TCR_TFSL field. */
#define BR_ESAI_TCR_TFSL(x)  (HW_ESAI_TCR(x).B.TFSL)

/*! @brief Format value for bitfield ESAI_TCR_TFSL. */
#define BF_ESAI_TCR_TFSL(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TFSL) & BM_ESAI_TCR_TFSL)

/*! @brief Set the TFSL field to a new value. */
#define BW_ESAI_TCR_TFSL(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TFSL) | BF_ESAI_TCR_TFSL(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TFSR[16] (RW)
 *
 * ESAI_TCR Transmit Frame Sync Relative Timing. TFSR determines the relative
 * timing of the transmit frame sync signal as referred to the serial data lines,
 * for a word length frame sync only (TFSL=0). When TFSR is cleared the word
 * length frame sync occurs together with the first bit of the data word of the first
 * slot. When TFSR is set the word length frame sync starts one serial clock
 * cycle earlier, that is, together with the last bit of the previous data word.
 */
/*@{*/
#define BP_ESAI_TCR_TFSR     (16U)         /*!< Bit position for ESAI_TCR_TFSR. */
#define BM_ESAI_TCR_TFSR     (0x00010000U) /*!< Bit mask for ESAI_TCR_TFSR. */
#define BS_ESAI_TCR_TFSR     (1U)          /*!< Bit field size in bits for ESAI_TCR_TFSR. */

/*! @brief Read current value of the ESAI_TCR_TFSR field. */
#define BR_ESAI_TCR_TFSR(x)  (HW_ESAI_TCR(x).B.TFSR)

/*! @brief Format value for bitfield ESAI_TCR_TFSR. */
#define BF_ESAI_TCR_TFSR(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TFSR) & BM_ESAI_TCR_TFSR)

/*! @brief Set the TFSR field to a new value. */
#define BW_ESAI_TCR_TFSR(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TFSR) | BF_ESAI_TCR_TFSR(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field PADC[17] (RW)
 *
 * ESAI_TCR Transmit Zero Padding Control. When PADC is cleared, zero padding is
 * disabled. When PADC is set, zero padding is enabled. PADC, in conjunction
 * with the TWA control bit, determines the way that padding is done for operating
 * modes where the word length is less than the slot length. See the TWA bit
 * description in bit 7 for more details. Because the data word is shorter than the
 * slot length, the data word is extended until achieving the slot length,
 * according to the following rule: If the data word is left-aligned (TWA=0), and zero
 * padding is disabled (PADC=0), the last data bit is repeated after the data word
 * has been transmitted. If zero padding is enabled (PADC=1), zeroes are
 * transmitted after the data word has been transmitted. If the data word is
 * right-aligned (TWA=1), and zero padding is disabled (PADC=0), the first data bit is
 * repeated before the transmission of the data word. If zero padding is enabled
 * (PADC=1), zeroes are transmitted before the transmission of the data word.
 */
/*@{*/
#define BP_ESAI_TCR_PADC     (17U)         /*!< Bit position for ESAI_TCR_PADC. */
#define BM_ESAI_TCR_PADC     (0x00020000U) /*!< Bit mask for ESAI_TCR_PADC. */
#define BS_ESAI_TCR_PADC     (1U)          /*!< Bit field size in bits for ESAI_TCR_PADC. */

/*! @brief Read current value of the ESAI_TCR_PADC field. */
#define BR_ESAI_TCR_PADC(x)  (HW_ESAI_TCR(x).B.PADC)

/*! @brief Format value for bitfield ESAI_TCR_PADC. */
#define BF_ESAI_TCR_PADC(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_PADC) & BM_ESAI_TCR_PADC)

/*! @brief Set the PADC field to a new value. */
#define BW_ESAI_TCR_PADC(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_PADC) | BF_ESAI_TCR_PADC(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TPR[19] (RW)
 *
 * ESAI_TCR Transmit Section Personal Reset. The TPR control bit is used to put
 * the transmitter section of the ESAI in the personal reset state. The receiver
 * section is not affected. When TPR is cleared, the transmitter section may
 * operate normally. When TPR is set, the transmitter section enters the personal
 * reset state immediately. When in the personal reset state, the status bits are
 * reset to the same state as after hardware reset. The control bits are not
 * affected by the personal reset state. The transmitter data pins are tri-stated while
 * in the personal reset state; if a stable logic level is desired, the
 * transmitter data pins should be defined as GPIO outputs, or external pull-up or
 * pull-down resistors should be used. The transmitter clock outputs drive zeroes while
 * in the personal reset state. Note that to leave the personal reset state by
 * clearing TPR, the procedure described in ESAI Initialization Examples should be
 * followed.
 */
/*@{*/
#define BP_ESAI_TCR_TPR      (19U)         /*!< Bit position for ESAI_TCR_TPR. */
#define BM_ESAI_TCR_TPR      (0x00080000U) /*!< Bit mask for ESAI_TCR_TPR. */
#define BS_ESAI_TCR_TPR      (1U)          /*!< Bit field size in bits for ESAI_TCR_TPR. */

/*! @brief Read current value of the ESAI_TCR_TPR field. */
#define BR_ESAI_TCR_TPR(x)   (HW_ESAI_TCR(x).B.TPR)

/*! @brief Format value for bitfield ESAI_TCR_TPR. */
#define BF_ESAI_TCR_TPR(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TPR) & BM_ESAI_TCR_TPR)

/*! @brief Set the TPR field to a new value. */
#define BW_ESAI_TCR_TPR(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TPR) | BF_ESAI_TCR_TPR(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TEIE[20] (RW)
 *
 * ESAI_TCR Transmit Exception Interrupt Enable. When TEIE is set, the Core is
 * interrupted when both TDE and TUE in the ESAI_SAISR status register are set.
 * When TEIE is cleared, this interrupt is disabled. Reading the ESAI_SAISR status
 * register followed by writing to all the data registers of the enabled
 * transmitters clears TUE, thus clearing the pending interrupt.
 */
/*@{*/
#define BP_ESAI_TCR_TEIE     (20U)         /*!< Bit position for ESAI_TCR_TEIE. */
#define BM_ESAI_TCR_TEIE     (0x00100000U) /*!< Bit mask for ESAI_TCR_TEIE. */
#define BS_ESAI_TCR_TEIE     (1U)          /*!< Bit field size in bits for ESAI_TCR_TEIE. */

/*! @brief Read current value of the ESAI_TCR_TEIE field. */
#define BR_ESAI_TCR_TEIE(x)  (HW_ESAI_TCR(x).B.TEIE)

/*! @brief Format value for bitfield ESAI_TCR_TEIE. */
#define BF_ESAI_TCR_TEIE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TEIE) & BM_ESAI_TCR_TEIE)

/*! @brief Set the TEIE field to a new value. */
#define BW_ESAI_TCR_TEIE(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TEIE) | BF_ESAI_TCR_TEIE(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TEDIE[21] (RW)
 *
 * ESAI_TCR Transmit Even Slot Data Interrupt Enable. The TEDIE control bit is
 * used to enable the transmit even slot data interrupts. If TEDIE is set, the
 * transmit even slot data interrupts are enabled. If TEDIE is cleared, the transmit
 * even slot data interrupts are disabled. A transmit even slot data interrupt
 * request is generated if TEDIE is set and the TEDE status flag in the ESAI_SAISR
 * status register is set. Even time slots are all even-numbered time slots (0,
 * 2, 4, etc.) when operating in network mode. The zero time slot in the frame is
 * marked by the frame sync signal and is considered to be even. Writing data to
 * all the data registers of the enabled transmitters or to ESAI_TSR clears the
 * TEDE flag, thus servicing the interrupt. Transmit interrupts with exception
 * have higher priority than transmit even slot data interrupts, therefore if
 * exception occurs (TUE is set) and TEIE is set, the ESAI requests an ESAI transmit
 * data with exception interrupt from the interrupt controller.
 */
/*@{*/
#define BP_ESAI_TCR_TEDIE    (21U)         /*!< Bit position for ESAI_TCR_TEDIE. */
#define BM_ESAI_TCR_TEDIE    (0x00200000U) /*!< Bit mask for ESAI_TCR_TEDIE. */
#define BS_ESAI_TCR_TEDIE    (1U)          /*!< Bit field size in bits for ESAI_TCR_TEDIE. */

/*! @brief Read current value of the ESAI_TCR_TEDIE field. */
#define BR_ESAI_TCR_TEDIE(x) (HW_ESAI_TCR(x).B.TEDIE)

/*! @brief Format value for bitfield ESAI_TCR_TEDIE. */
#define BF_ESAI_TCR_TEDIE(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TEDIE) & BM_ESAI_TCR_TEDIE)

/*! @brief Set the TEDIE field to a new value. */
#define BW_ESAI_TCR_TEDIE(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TEDIE) | BF_ESAI_TCR_TEDIE(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TIE[22] (RW)
 *
 * ESAI_TCR Transmit Interrupt Enable. The Core is interrupted when TIE and the
 * TDE flag in the ESAI_SAISR status register are set. When TIE is cleared, this
 * interrupt is disabled. Writing data to all the data registers of the enabled
 * transmitters or to ESAI_TSR clears TDE, thus clearing the interrupt. Transmit
 * interrupts with exception have higher priority than normal transmit data
 * interrupts, therefore if exception occurs (TUE is set) and TEIE is set, the ESAI
 * requests an ESAI transmit data with exception interrupt from the interrupt
 * controller.
 */
/*@{*/
#define BP_ESAI_TCR_TIE      (22U)         /*!< Bit position for ESAI_TCR_TIE. */
#define BM_ESAI_TCR_TIE      (0x00400000U) /*!< Bit mask for ESAI_TCR_TIE. */
#define BS_ESAI_TCR_TIE      (1U)          /*!< Bit field size in bits for ESAI_TCR_TIE. */

/*! @brief Read current value of the ESAI_TCR_TIE field. */
#define BR_ESAI_TCR_TIE(x)   (HW_ESAI_TCR(x).B.TIE)

/*! @brief Format value for bitfield ESAI_TCR_TIE. */
#define BF_ESAI_TCR_TIE(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TIE) & BM_ESAI_TCR_TIE)

/*! @brief Set the TIE field to a new value. */
#define BW_ESAI_TCR_TIE(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TIE) | BF_ESAI_TCR_TIE(v)))
/*@}*/

/*!
 * @name Register ESAI_TCR, field TLIE[23] (RW)
 *
 * ESAI_TCR Transmit Last Slot Interrupt Enable. TLIE enables an interrupt at
 * the beginning of last slot of a frame in network mode. When TLIE is set the Core
 * is interrupted at the start of the last slot in a frame in network mode
 * regardless of the transmit mask register setting. When TLIE is cleared the transmit
 * last slot interrupt is disabled. TLIE is disabled when TDC[4:0]=0x00000
 * (on-demand mode). The use of the transmit last slot interrupt is described in ESAI
 * Interrupt RequestsThe ESAI can generate eight different interrupt requests .
 */
/*@{*/
#define BP_ESAI_TCR_TLIE     (23U)         /*!< Bit position for ESAI_TCR_TLIE. */
#define BM_ESAI_TCR_TLIE     (0x00800000U) /*!< Bit mask for ESAI_TCR_TLIE. */
#define BS_ESAI_TCR_TLIE     (1U)          /*!< Bit field size in bits for ESAI_TCR_TLIE. */

/*! @brief Read current value of the ESAI_TCR_TLIE field. */
#define BR_ESAI_TCR_TLIE(x)  (HW_ESAI_TCR(x).B.TLIE)

/*! @brief Format value for bitfield ESAI_TCR_TLIE. */
#define BF_ESAI_TCR_TLIE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCR_TLIE) & BM_ESAI_TCR_TLIE)

/*! @brief Set the TLIE field to a new value. */
#define BW_ESAI_TCR_TLIE(x, v) (HW_ESAI_TCR_WR(x, (HW_ESAI_TCR_RD(x) & ~BM_ESAI_TCR_TLIE) | BF_ESAI_TCR_TLIE(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TCCR - Transmit Clock Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TCCR - Transmit Clock Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write Transmitter Clock Control Register (ESAI_TCCR) controls the
 * ESAI transmitter clock generator bit and frame sync rates, the bit clock and
 * high frequency clock sources and the directions of the HCKT, FST and SCKT
 * signals. In the synchronous mode (SYN=1), the bit clock defined for the transmitter
 * determines the receiver bit clock as well. ESAI_TCCR also controls the number
 * of words per frame for the serial data. Hardware and software reset clear all
 * the bits of the ESAI_TCCR register. Care should be taken in asynchronous mode
 * whenever the frame sync clock (FSR, FST) is not sourced directly from its
 * associated bit clock (SCKR, SCKT). Proper phase relationships must be maintained
 * between these clocks in order to guarantee proper operation of the ESAI. ARM
 * Core clock is ipg_clk_esai in block ESAI which is from CCM's ahb_clk_root. ESAI
 * Clock Generator Functional Block Diagram 1. ETI, ETO, ERI and ERO bit
 * descriptions are covered in ECRESAI Control Register . 2. Fsys is the ESAI system 133
 * MHz clock. 3. EXTAL is the on-chip clock sources other than ESAI system 133MHz
 * clock. ESAI Frame Sync Generator Functional Block Diagram Transmitter High
 * Frequency Clock Divider TFP3-TFP0 Divide Ratio 0x0 1 0x1 2 0x2 3 0x3 4 ... ...
 * 0xF 16
 */
typedef union _hw_esai_tccr
{
    uint32_t U;
    struct _hw_esai_tccr_bitfields
    {
        uint32_t TPM : 8;              /*!< [7:0]  */
        uint32_t TPSR : 1;             /*!< [8]  */
        uint32_t TDC : 5;              /*!< [13:9]  */
        uint32_t TFP : 4;              /*!< [17:14]  */
        uint32_t TCKP : 1;             /*!< [18]  */
        uint32_t TFSP : 1;             /*!< [19]  */
        uint32_t THCKP : 1;            /*!< [20]  */
        uint32_t TCKD : 1;             /*!< [21]  */
        uint32_t TFSD : 1;             /*!< [22]  */
        uint32_t THCKD : 1;            /*!< [23]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_tccr_t;

/*!
 * @name Constants and macros for entire ESAI_TCCR register
 */
/*@{*/
#define HW_ESAI_TCCR_ADDR(x)     ((uintptr_t)(x) + 0xD8U)

#define HW_ESAI_TCCR(x)          (*(__IO hw_esai_tccr_t *) HW_ESAI_TCCR_ADDR(x))
#define HW_ESAI_TCCR_RD(x)       (HW_ESAI_TCCR(x).U)
#define HW_ESAI_TCCR_WR(x, v)    (HW_ESAI_TCCR(x).U = (v))
#define HW_ESAI_TCCR_SET(x, v)   (HW_ESAI_TCCR_WR(x, HW_ESAI_TCCR_RD(x) |  (v)))
#define HW_ESAI_TCCR_CLR(x, v)   (HW_ESAI_TCCR_WR(x, HW_ESAI_TCCR_RD(x) & ~(v)))
#define HW_ESAI_TCCR_TOG(x, v)   (HW_ESAI_TCCR_WR(x, HW_ESAI_TCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TCCR bitfields
 */

/*!
 * @name Register ESAI_TCCR, field TPM[7:0] (RW)
 *
 * ESAI_TCCR Transmit Prescale Modulus Select. The TPM7-TPM0 bits specify the
 * divide ratio of the prescale divider in the ESAI transmitter clock generator. A
 * divide ratio from 1 to 256 (TPM[7:0]=0x00 to 0xFF) may be selected. The bit
 * clock output is available at the transmit serial bit clock (SCKT) pin. The bit
 * clock output is also available internally for use as the bit clock to shift the
 * transmit and receive shift registers. The ESAI transmit clock generator
 * functional diagram is shown in .
 */
/*@{*/
#define BP_ESAI_TCCR_TPM     (0U)          /*!< Bit position for ESAI_TCCR_TPM. */
#define BM_ESAI_TCCR_TPM     (0x000000FFU) /*!< Bit mask for ESAI_TCCR_TPM. */
#define BS_ESAI_TCCR_TPM     (8U)          /*!< Bit field size in bits for ESAI_TCCR_TPM. */

/*! @brief Read current value of the ESAI_TCCR_TPM field. */
#define BR_ESAI_TCCR_TPM(x)  (HW_ESAI_TCCR(x).B.TPM)

/*! @brief Format value for bitfield ESAI_TCCR_TPM. */
#define BF_ESAI_TCCR_TPM(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TPM) & BM_ESAI_TCCR_TPM)

/*! @brief Set the TPM field to a new value. */
#define BW_ESAI_TCCR_TPM(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TPM) | BF_ESAI_TCCR_TPM(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TPSR[8] (RW)
 *
 * ESAI_TCCR Transmit Prescaler Range. The TPSR bit controls a fixed
 * divide-by-eight prescaler in series with the variable prescaler. This bit is used to
 * extend the range of the prescaler for those cases where a slower bit clock is
 * desired. When TPSR is set, the fixed prescaler is bypassed. When TPSR is cleared,
 * the fixed divide-by-eight prescaler is operational (see ). The maximum
 * internally generated bit clock frequency is Fsys/4; the minimum internally generated
 * bit clock frequency is Fsys/(2 x 8 x 256 x 16)=Fsys/65536.
 */
/*@{*/
#define BP_ESAI_TCCR_TPSR    (8U)          /*!< Bit position for ESAI_TCCR_TPSR. */
#define BM_ESAI_TCCR_TPSR    (0x00000100U) /*!< Bit mask for ESAI_TCCR_TPSR. */
#define BS_ESAI_TCCR_TPSR    (1U)          /*!< Bit field size in bits for ESAI_TCCR_TPSR. */

/*! @brief Read current value of the ESAI_TCCR_TPSR field. */
#define BR_ESAI_TCCR_TPSR(x) (HW_ESAI_TCCR(x).B.TPSR)

/*! @brief Format value for bitfield ESAI_TCCR_TPSR. */
#define BF_ESAI_TCCR_TPSR(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TPSR) & BM_ESAI_TCCR_TPSR)

/*! @brief Set the TPSR field to a new value. */
#define BW_ESAI_TCCR_TPSR(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TPSR) | BF_ESAI_TCCR_TPSR(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TDC[13:9] (RW)
 *
 * ESAI_TCCR Tx Frame Rate Divider Control. The TDC4-TDC0 bits control the
 * divide ratio for the programmable frame rate dividers used to generate the
 * transmitter frame clocks. In network mode, this ratio may be interpreted as the number
 * of words per frame minus one. The divide ratio may range from 2 to 32
 * (TDC[4:0]=0x00001 to 0x11111) for network mode. A divide ratio of one
 * (TDC[4:0]=0x00000) in network mode is a special case (on-demand mode). In normal mode, this
 * ratio determines the word transfer rate. The divide ratio may range from 1 to
 * 32 (TDC[4:0]=0x00000 to 0x11111) for normal mode. In normal mode, a divide
 * ratio of 1 (TDC[4:0]=0x00000) provides continuous periodic data word transfers. A
 * bit-length frame sync (TFSL=1) must be used in this case. The ESAI frame sync
 * generator functional diagram is shown in
 */
/*@{*/
#define BP_ESAI_TCCR_TDC     (9U)          /*!< Bit position for ESAI_TCCR_TDC. */
#define BM_ESAI_TCCR_TDC     (0x00003E00U) /*!< Bit mask for ESAI_TCCR_TDC. */
#define BS_ESAI_TCCR_TDC     (5U)          /*!< Bit field size in bits for ESAI_TCCR_TDC. */

/*! @brief Read current value of the ESAI_TCCR_TDC field. */
#define BR_ESAI_TCCR_TDC(x)  (HW_ESAI_TCCR(x).B.TDC)

/*! @brief Format value for bitfield ESAI_TCCR_TDC. */
#define BF_ESAI_TCCR_TDC(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TDC) & BM_ESAI_TCCR_TDC)

/*! @brief Set the TDC field to a new value. */
#define BW_ESAI_TCCR_TDC(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TDC) | BF_ESAI_TCCR_TDC(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TFP[17:14] (RW)
 *
 * ESAI_TCCR Tx High Frequency Clock Divider. The TFP3-TFP0 bits control the
 * divide ratio of the transmitter high frequency clock to the transmitter serial
 * bit clock when the source of the high frequency clock and the bit clock is the
 * internal ARM Core clock. When the HCKT input is being driven from an external
 * high frequency clock, the TFP3-TFP0 bits specify an additional division ratio
 * in the clock divider chain. shows the specification for the divide ratio. shows
 * the ESAI high frequency clock generator functional diagram.
 */
/*@{*/
#define BP_ESAI_TCCR_TFP     (14U)         /*!< Bit position for ESAI_TCCR_TFP. */
#define BM_ESAI_TCCR_TFP     (0x0003C000U) /*!< Bit mask for ESAI_TCCR_TFP. */
#define BS_ESAI_TCCR_TFP     (4U)          /*!< Bit field size in bits for ESAI_TCCR_TFP. */

/*! @brief Read current value of the ESAI_TCCR_TFP field. */
#define BR_ESAI_TCCR_TFP(x)  (HW_ESAI_TCCR(x).B.TFP)

/*! @brief Format value for bitfield ESAI_TCCR_TFP. */
#define BF_ESAI_TCCR_TFP(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TFP) & BM_ESAI_TCCR_TFP)

/*! @brief Set the TFP field to a new value. */
#define BW_ESAI_TCCR_TFP(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TFP) | BF_ESAI_TCCR_TFP(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TCKP[18] (RW)
 *
 * ESAI_TCCR Transmit Clock Polarity. The Transmitter Clock Polarity (TCKP) bit
 * controls on which bit clock edge data and frame sync are clocked out and
 * latched in. If TCKP is cleared the data and the frame sync are clocked out on the
 * rising edge of the transmit bit clock and latched in on the falling edge of the
 * transmit bit clock. If TCKP is set the falling edge of the transmit clock is
 * used to clock the data out and frame sync and the rising edge of the transmit
 * clock is used to latch the data and frame sync in.
 */
/*@{*/
#define BP_ESAI_TCCR_TCKP    (18U)         /*!< Bit position for ESAI_TCCR_TCKP. */
#define BM_ESAI_TCCR_TCKP    (0x00040000U) /*!< Bit mask for ESAI_TCCR_TCKP. */
#define BS_ESAI_TCCR_TCKP    (1U)          /*!< Bit field size in bits for ESAI_TCCR_TCKP. */

/*! @brief Read current value of the ESAI_TCCR_TCKP field. */
#define BR_ESAI_TCCR_TCKP(x) (HW_ESAI_TCCR(x).B.TCKP)

/*! @brief Format value for bitfield ESAI_TCCR_TCKP. */
#define BF_ESAI_TCCR_TCKP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TCKP) & BM_ESAI_TCCR_TCKP)

/*! @brief Set the TCKP field to a new value. */
#define BW_ESAI_TCCR_TCKP(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TCKP) | BF_ESAI_TCCR_TCKP(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TFSP[19] (RW)
 *
 * ESAI_TCCR Transmit Frame Sync Polarity. The Transmitter Frame Sync Polarity
 * (TFSP) bit determines the polarity of the transmit frame sync signal. When TFSP
 * is cleared, the frame sync signal polarity is positive, that is, the frame
 * start is indicated by a high level on the frame sync pin. When TFSP is set, the
 * frame sync signal polarity is negative, that is, the frame start is indicated
 * by a low level on the frame sync pin.
 */
/*@{*/
#define BP_ESAI_TCCR_TFSP    (19U)         /*!< Bit position for ESAI_TCCR_TFSP. */
#define BM_ESAI_TCCR_TFSP    (0x00080000U) /*!< Bit mask for ESAI_TCCR_TFSP. */
#define BS_ESAI_TCCR_TFSP    (1U)          /*!< Bit field size in bits for ESAI_TCCR_TFSP. */

/*! @brief Read current value of the ESAI_TCCR_TFSP field. */
#define BR_ESAI_TCCR_TFSP(x) (HW_ESAI_TCCR(x).B.TFSP)

/*! @brief Format value for bitfield ESAI_TCCR_TFSP. */
#define BF_ESAI_TCCR_TFSP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TFSP) & BM_ESAI_TCCR_TFSP)

/*! @brief Set the TFSP field to a new value. */
#define BW_ESAI_TCCR_TFSP(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TFSP) | BF_ESAI_TCCR_TFSP(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field THCKP[20] (RW)
 *
 * ESAI_TCCR Transmit High Frequency Clock Polarity The Transmitter High
 * Frequency Clock Polarity (THCKP) bit controls the polarity of the HCKT. 0 - Normal
 * polarity 1 - Inverted polarity
 */
/*@{*/
#define BP_ESAI_TCCR_THCKP   (20U)         /*!< Bit position for ESAI_TCCR_THCKP. */
#define BM_ESAI_TCCR_THCKP   (0x00100000U) /*!< Bit mask for ESAI_TCCR_THCKP. */
#define BS_ESAI_TCCR_THCKP   (1U)          /*!< Bit field size in bits for ESAI_TCCR_THCKP. */

/*! @brief Read current value of the ESAI_TCCR_THCKP field. */
#define BR_ESAI_TCCR_THCKP(x) (HW_ESAI_TCCR(x).B.THCKP)

/*! @brief Format value for bitfield ESAI_TCCR_THCKP. */
#define BF_ESAI_TCCR_THCKP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_THCKP) & BM_ESAI_TCCR_THCKP)

/*! @brief Set the THCKP field to a new value. */
#define BW_ESAI_TCCR_THCKP(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_THCKP) | BF_ESAI_TCCR_THCKP(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TCKD[21] (RW)
 *
 * ESAI_TCCR Transmit Clock Source Direction. The Transmitter Clock Source
 * Direction (TCKD) bit selects the source of the clock signal used to clock the
 * transmit shift registers in the asynchronous mode (SYN=0) and the transmit shift
 * registers and the receive shift registers in the synchronous mode (SYN=1). When
 * TCKD is set, the internal clock source becomes the bit clock for the transmit
 * shift registers and word length divider and is the output on the SCKT pin.
 * When TCKD is cleared, the clock source is external; the internal clock generator
 * is disconnected from the SCKT pin, and an external clock source may drive this
 * pin (see ).
 */
/*@{*/
#define BP_ESAI_TCCR_TCKD    (21U)         /*!< Bit position for ESAI_TCCR_TCKD. */
#define BM_ESAI_TCCR_TCKD    (0x00200000U) /*!< Bit mask for ESAI_TCCR_TCKD. */
#define BS_ESAI_TCCR_TCKD    (1U)          /*!< Bit field size in bits for ESAI_TCCR_TCKD. */

/*! @brief Read current value of the ESAI_TCCR_TCKD field. */
#define BR_ESAI_TCCR_TCKD(x) (HW_ESAI_TCCR(x).B.TCKD)

/*! @brief Format value for bitfield ESAI_TCCR_TCKD. */
#define BF_ESAI_TCCR_TCKD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TCKD) & BM_ESAI_TCCR_TCKD)

/*! @brief Set the TCKD field to a new value. */
#define BW_ESAI_TCCR_TCKD(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TCKD) | BF_ESAI_TCCR_TCKD(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field TFSD[22] (RW)
 *
 * ESAI_TCCR Transmit Frame Sync Signal Direction. TFSD controls the direction
 * of the FST pin. When TFSD is cleared, FST is an input; when TFSD is set, FST is
 * an output (see ).
 */
/*@{*/
#define BP_ESAI_TCCR_TFSD    (22U)         /*!< Bit position for ESAI_TCCR_TFSD. */
#define BM_ESAI_TCCR_TFSD    (0x00400000U) /*!< Bit mask for ESAI_TCCR_TFSD. */
#define BS_ESAI_TCCR_TFSD    (1U)          /*!< Bit field size in bits for ESAI_TCCR_TFSD. */

/*! @brief Read current value of the ESAI_TCCR_TFSD field. */
#define BR_ESAI_TCCR_TFSD(x) (HW_ESAI_TCCR(x).B.TFSD)

/*! @brief Format value for bitfield ESAI_TCCR_TFSD. */
#define BF_ESAI_TCCR_TFSD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_TFSD) & BM_ESAI_TCCR_TFSD)

/*! @brief Set the TFSD field to a new value. */
#define BW_ESAI_TCCR_TFSD(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_TFSD) | BF_ESAI_TCCR_TFSD(v)))
/*@}*/

/*!
 * @name Register ESAI_TCCR, field THCKD[23] (RW)
 *
 * ESAI_TCCR Transmit High Frequency Clock Direction. THCKD controls the
 * direction of the HCKT pin. When THCKD is cleared, HCKT is an input; when THCKD is
 * set, HCKT is an output (see ).
 */
/*@{*/
#define BP_ESAI_TCCR_THCKD   (23U)         /*!< Bit position for ESAI_TCCR_THCKD. */
#define BM_ESAI_TCCR_THCKD   (0x00800000U) /*!< Bit mask for ESAI_TCCR_THCKD. */
#define BS_ESAI_TCCR_THCKD   (1U)          /*!< Bit field size in bits for ESAI_TCCR_THCKD. */

/*! @brief Read current value of the ESAI_TCCR_THCKD field. */
#define BR_ESAI_TCCR_THCKD(x) (HW_ESAI_TCCR(x).B.THCKD)

/*! @brief Format value for bitfield ESAI_TCCR_THCKD. */
#define BF_ESAI_TCCR_THCKD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_TCCR_THCKD) & BM_ESAI_TCCR_THCKD)

/*! @brief Set the THCKD field to a new value. */
#define BW_ESAI_TCCR_THCKD(x, v) (HW_ESAI_TCCR_WR(x, (HW_ESAI_TCCR_RD(x) & ~BM_ESAI_TCCR_THCKD) | BF_ESAI_TCCR_THCKD(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RCR - Receive Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RCR - Receive Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write Receive Control Register (ESAI_RCR) controls the ESAI receiver
 * section. Interrupt enable bits for the receivers are provided in this control
 * register. The receivers are enabled in this register (0,1,2 or 3 receivers
 * can be enabled) if the input data pin is not used by a transmitter. Operating
 * modes are also selected in this register. ESAI Receive Network Mode Selection
 * RMOD1 RMOD0 RDC4-RDC0 Receiver Network Mode 0 0 0x0-0x1F Normal Mode 0 1 0x0
 * On-Demand Mode 0 1 0x1-0x1F Network Mode 1 0 X Reserved 1 1 0x0C AC97 ESAI
 * Receive Slot and Word Length Selection RSWS4 RSWS3 RSWS2 RSWS1 RSWS0 SLOT LENGTH
 * WORD LENGTH 0 0 0 0 0 8 8 0 0 1 0 0 12 8 0 0 0 0 1 12 0 1 0 0 0 16 8 0 0 1 0 1 12
 * 0 0 0 1 0 16 0 1 1 0 0 20 8 0 1 0 0 1 12 0 0 1 1 0 16 0 0 0 1 1 20 1 0 0 0 0
 * 24 8 0 1 1 0 1 12 0 1 0 1 0 16 0 0 1 1 1 20 1 1 1 1 0 24 1 1 0 0 0 32 8 1 0 1
 * 0 1 12 1 0 0 1 0 16 0 1 1 1 1 20 1 1 1 1 1 24 0 1 0 1 1 Reserved 0 1 1 1 0 1 0
 * 0 0 1 1 0 0 1 1 1 0 1 0 0 1 0 1 1 0 1 0 1 1 1 1 1 0 0 1 1 1 0 1 0 1 1 0 1 1 1
 * 1 1 0 0 1 1 1 0 1
 */
typedef union _hw_esai_rcr
{
    uint32_t U;
    struct _hw_esai_rcr_bitfields
    {
        uint32_t RE0 : 1;              /*!< [0]  */
        uint32_t RE1 : 1;              /*!< [1]  */
        uint32_t RE2 : 1;              /*!< [2]  */
        uint32_t RE3 : 1;              /*!< [3]  */
        uint32_t RESERVED0 : 2;        /*!< [5:4]  */
        uint32_t RSHFD : 1;            /*!< [6]  */
        uint32_t RWA : 1;              /*!< [7]  */
        uint32_t RMOD : 2;             /*!< [9:8]  */
        uint32_t RSWS : 5;             /*!< [14:10]  */
        uint32_t RFSL : 1;             /*!< [15]  */
        uint32_t RFSR : 1;             /*!< [16]  */
        uint32_t RESERVED1 : 2;        /*!< [18:17]  */
        uint32_t RPR : 1;              /*!< [19]  */
        uint32_t REIE : 1;             /*!< [20]  */
        uint32_t REDIE : 1;            /*!< [21]  */
        uint32_t RIE : 1;              /*!< [22]  */
        uint32_t RLIE : 1;             /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_rcr_t;

/*!
 * @name Constants and macros for entire ESAI_RCR register
 */
/*@{*/
#define HW_ESAI_RCR_ADDR(x)      ((uintptr_t)(x) + 0xDCU)

#define HW_ESAI_RCR(x)           (*(__IO hw_esai_rcr_t *) HW_ESAI_RCR_ADDR(x))
#define HW_ESAI_RCR_RD(x)        (HW_ESAI_RCR(x).U)
#define HW_ESAI_RCR_WR(x, v)     (HW_ESAI_RCR(x).U = (v))
#define HW_ESAI_RCR_SET(x, v)    (HW_ESAI_RCR_WR(x, HW_ESAI_RCR_RD(x) |  (v)))
#define HW_ESAI_RCR_CLR(x, v)    (HW_ESAI_RCR_WR(x, HW_ESAI_RCR_RD(x) & ~(v)))
#define HW_ESAI_RCR_TOG(x, v)    (HW_ESAI_RCR_WR(x, HW_ESAI_RCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_RCR bitfields
 */

/*!
 * @name Register ESAI_RCR, field RE0[0] (RW)
 *
 * ESAI_RCR ESAI Receiver 0 Enable. When RE0 is set and TE5 is cleared, the ESAI
 * receiver 0 is enabled and samples data at the SDO5/SDI0 pin. ESAI_TX5 and
 * ESAI_RX0 should not be enabled at the same time (RE0=1 and TE5=1). When RE0 is
 * cleared, receiver 0 is disabled by inhibiting data transfer into ESAI_RX0. If
 * this bit is cleared while receiving a data word, the remainder of the word is
 * shifted in and transferred to the ESAI_RX0 data register. If RE0 is set while
 * some of the other receivers are already in operation, the first data word
 * received in ESAI_RX0 will be invalid and must be discarded.
 */
/*@{*/
#define BP_ESAI_RCR_RE0      (0U)          /*!< Bit position for ESAI_RCR_RE0. */
#define BM_ESAI_RCR_RE0      (0x00000001U) /*!< Bit mask for ESAI_RCR_RE0. */
#define BS_ESAI_RCR_RE0      (1U)          /*!< Bit field size in bits for ESAI_RCR_RE0. */

/*! @brief Read current value of the ESAI_RCR_RE0 field. */
#define BR_ESAI_RCR_RE0(x)   (HW_ESAI_RCR(x).B.RE0)

/*! @brief Format value for bitfield ESAI_RCR_RE0. */
#define BF_ESAI_RCR_RE0(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RE0) & BM_ESAI_RCR_RE0)

/*! @brief Set the RE0 field to a new value. */
#define BW_ESAI_RCR_RE0(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RE0) | BF_ESAI_RCR_RE0(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RE1[1] (RW)
 *
 * ESAI_RCR ESAI Receiver 1 Enable. When RE1 is set and TE4 is cleared, the ESAI
 * receiver 1 is enabled and samples data at the SDO4/SDI1 pin. ESAI_TX4 and
 * ESAI_RX1 should not be enabled at the same time (RE1=1 and TE4=1). When RE1 is
 * cleared, receiver 1 is disabled by inhibiting data transfer into ESAI_RX1. If
 * this bit is cleared while receiving a data word, the remainder of the word is
 * shifted in and transferred to the ESAI_RX1 data register. If RE1 is set while
 * some of the other receivers are already in operation, the first data word
 * received in ESAI_RX1 will be invalid and must be discarded.
 */
/*@{*/
#define BP_ESAI_RCR_RE1      (1U)          /*!< Bit position for ESAI_RCR_RE1. */
#define BM_ESAI_RCR_RE1      (0x00000002U) /*!< Bit mask for ESAI_RCR_RE1. */
#define BS_ESAI_RCR_RE1      (1U)          /*!< Bit field size in bits for ESAI_RCR_RE1. */

/*! @brief Read current value of the ESAI_RCR_RE1 field. */
#define BR_ESAI_RCR_RE1(x)   (HW_ESAI_RCR(x).B.RE1)

/*! @brief Format value for bitfield ESAI_RCR_RE1. */
#define BF_ESAI_RCR_RE1(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RE1) & BM_ESAI_RCR_RE1)

/*! @brief Set the RE1 field to a new value. */
#define BW_ESAI_RCR_RE1(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RE1) | BF_ESAI_RCR_RE1(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RE2[2] (RW)
 *
 * ESAI_RCR ESAI Receiver 2 Enable. When RE2 is set and TE3 is cleared, the ESAI
 * receiver 2 is enabled and samples data at the SDO3/SDI2 pin. ESAI_TX3 and
 * ESAI_RX2 should not be enabled at the same time (RE2=1 and TE3=1). When RE2 is
 * cleared, receiver 2 is disabled by inhibiting data transfer into ESAI_RX2. If
 * this bit is cleared while receiving a data word, the remainder of the word is
 * shifted in and transferred to the ESAI_RX2 data register. If RE2 is set while
 * some of the other receivers are already in operation, the first data word
 * received in ESAI_RX2 will be invalid and must be discarded.
 */
/*@{*/
#define BP_ESAI_RCR_RE2      (2U)          /*!< Bit position for ESAI_RCR_RE2. */
#define BM_ESAI_RCR_RE2      (0x00000004U) /*!< Bit mask for ESAI_RCR_RE2. */
#define BS_ESAI_RCR_RE2      (1U)          /*!< Bit field size in bits for ESAI_RCR_RE2. */

/*! @brief Read current value of the ESAI_RCR_RE2 field. */
#define BR_ESAI_RCR_RE2(x)   (HW_ESAI_RCR(x).B.RE2)

/*! @brief Format value for bitfield ESAI_RCR_RE2. */
#define BF_ESAI_RCR_RE2(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RE2) & BM_ESAI_RCR_RE2)

/*! @brief Set the RE2 field to a new value. */
#define BW_ESAI_RCR_RE2(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RE2) | BF_ESAI_RCR_RE2(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RE3[3] (RW)
 *
 * ESAI_RCR ESAI Receiver 3 Enable. When RE3 is set and TE2 is cleared, the ESAI
 * receiver 3 is enabled and samples data at the SDO2/SDI3 pin. ESAI_TX2 and
 * ESAI_RX3 should not be enabled at the same time (RE3=1 and TE2=1). When RE3 is
 * cleared, receiver 3 is disabled by inhibiting data transfer into ESAI_RX3. If
 * this bit is cleared while receiving a data word, the remainder of the word is
 * shifted in and transferred to the ESAI_RX3 data register. If RE3 is set while
 * some of the other receivers are already in operation, the first data word
 * received in ESAI_RX3 will be invalid and must be discarded.
 */
/*@{*/
#define BP_ESAI_RCR_RE3      (3U)          /*!< Bit position for ESAI_RCR_RE3. */
#define BM_ESAI_RCR_RE3      (0x00000008U) /*!< Bit mask for ESAI_RCR_RE3. */
#define BS_ESAI_RCR_RE3      (1U)          /*!< Bit field size in bits for ESAI_RCR_RE3. */

/*! @brief Read current value of the ESAI_RCR_RE3 field. */
#define BR_ESAI_RCR_RE3(x)   (HW_ESAI_RCR(x).B.RE3)

/*! @brief Format value for bitfield ESAI_RCR_RE3. */
#define BF_ESAI_RCR_RE3(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RE3) & BM_ESAI_RCR_RE3)

/*! @brief Set the RE3 field to a new value. */
#define BW_ESAI_RCR_RE3(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RE3) | BF_ESAI_RCR_RE3(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RSHFD[6] (RW)
 *
 * ESAI_RCR Receiver Shift Direction. The RSHFD bit causes the receiver shift
 * registers to shift data in MSB first when RSHFD is cleared or LSB first when
 * RSHFD is set (see and ).
 */
/*@{*/
#define BP_ESAI_RCR_RSHFD    (6U)          /*!< Bit position for ESAI_RCR_RSHFD. */
#define BM_ESAI_RCR_RSHFD    (0x00000040U) /*!< Bit mask for ESAI_RCR_RSHFD. */
#define BS_ESAI_RCR_RSHFD    (1U)          /*!< Bit field size in bits for ESAI_RCR_RSHFD. */

/*! @brief Read current value of the ESAI_RCR_RSHFD field. */
#define BR_ESAI_RCR_RSHFD(x) (HW_ESAI_RCR(x).B.RSHFD)

/*! @brief Format value for bitfield ESAI_RCR_RSHFD. */
#define BF_ESAI_RCR_RSHFD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RSHFD) & BM_ESAI_RCR_RSHFD)

/*! @brief Set the RSHFD field to a new value. */
#define BW_ESAI_RCR_RSHFD(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RSHFD) | BF_ESAI_RCR_RSHFD(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RWA[7] (RW)
 *
 * ESAI_RCR Receiver Word Alignment Control. The Receiver Word Alignment Control
 * (RWA) bit defines the alignment of the data word in relation to the slot.
 * This is relevant for the cases where the word length is shorter than the slot
 * length. If RWA is cleared, the data word is assumed to be left-aligned in the
 * slot frame. If RWA is set, the data word is assumed to be right-aligned in the
 * slot frame. If the data word is shorter than the slot length, the data bits
 * which are not in the data word field are ignored. For data word lengths of less
 * than 24 bits, the data word is right-extended with zeroes before being stored in
 * the receive data registers.
 */
/*@{*/
#define BP_ESAI_RCR_RWA      (7U)          /*!< Bit position for ESAI_RCR_RWA. */
#define BM_ESAI_RCR_RWA      (0x00000080U) /*!< Bit mask for ESAI_RCR_RWA. */
#define BS_ESAI_RCR_RWA      (1U)          /*!< Bit field size in bits for ESAI_RCR_RWA. */

/*! @brief Read current value of the ESAI_RCR_RWA field. */
#define BR_ESAI_RCR_RWA(x)   (HW_ESAI_RCR(x).B.RWA)

/*! @brief Format value for bitfield ESAI_RCR_RWA. */
#define BF_ESAI_RCR_RWA(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RWA) & BM_ESAI_RCR_RWA)

/*! @brief Set the RWA field to a new value. */
#define BW_ESAI_RCR_RWA(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RWA) | BF_ESAI_RCR_RWA(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RMOD[9:8] (RW)
 *
 * ESAI_RCR Receiver Network Mode Control. The RMOD1 and RMOD0 bits are used to
 * define the network mode of the ESAI receivers, as shown in . In the normal
 * mode, the frame rate divider determines the word transfer rate - one word is
 * transferred per frame sync during the frame sync time slot, as shown in . In
 * network mode, it is possible to transfer a word for every time slot, as shown in .
 * For more details, see Modes of OperationESAI has three basic operating modes
 * and many data/operation formats. . In order to comply with AC-97
 * specifications, RSWS4-RSWS0 should be set to 0x00011 (20-bit slot, 20-bit word); RFSL and
 * RFSR should be cleared, and RDC4-RDC0 should be set to 0x0C (13 words in frame).
 */
/*@{*/
#define BP_ESAI_RCR_RMOD     (8U)          /*!< Bit position for ESAI_RCR_RMOD. */
#define BM_ESAI_RCR_RMOD     (0x00000300U) /*!< Bit mask for ESAI_RCR_RMOD. */
#define BS_ESAI_RCR_RMOD     (2U)          /*!< Bit field size in bits for ESAI_RCR_RMOD. */

/*! @brief Read current value of the ESAI_RCR_RMOD field. */
#define BR_ESAI_RCR_RMOD(x)  (HW_ESAI_RCR(x).B.RMOD)

/*! @brief Format value for bitfield ESAI_RCR_RMOD. */
#define BF_ESAI_RCR_RMOD(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RMOD) & BM_ESAI_RCR_RMOD)

/*! @brief Set the RMOD field to a new value. */
#define BW_ESAI_RCR_RMOD(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RMOD) | BF_ESAI_RCR_RMOD(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RSWS[14:10] (RW)
 *
 * ESAI_RCR Receiver Slot and Word Select. The RSWS4-RSWS0 bits are used to
 * select the length of the slot and the length of the data words being received
 * through the ESAI. The word length must be equal to or shorter than the slot
 * length. The possible combinations are shown in . See also the ESAI data path
 * programming model in and .
 */
/*@{*/
#define BP_ESAI_RCR_RSWS     (10U)         /*!< Bit position for ESAI_RCR_RSWS. */
#define BM_ESAI_RCR_RSWS     (0x00007C00U) /*!< Bit mask for ESAI_RCR_RSWS. */
#define BS_ESAI_RCR_RSWS     (5U)          /*!< Bit field size in bits for ESAI_RCR_RSWS. */

/*! @brief Read current value of the ESAI_RCR_RSWS field. */
#define BR_ESAI_RCR_RSWS(x)  (HW_ESAI_RCR(x).B.RSWS)

/*! @brief Format value for bitfield ESAI_RCR_RSWS. */
#define BF_ESAI_RCR_RSWS(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RSWS) & BM_ESAI_RCR_RSWS)

/*! @brief Set the RSWS field to a new value. */
#define BW_ESAI_RCR_RSWS(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RSWS) | BF_ESAI_RCR_RSWS(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RFSL[15] (RW)
 *
 * ESAI_RCR Receiver Frame Sync Length. The RFSL bit selects the length of the
 * receive frame sync to be generated or recognized. If RFSL is cleared, a
 * word-length frame sync is selected. If RFSL is set, a 1-bit clock period frame sync
 * is selected. Refer to for examples of frame length selection.
 */
/*@{*/
#define BP_ESAI_RCR_RFSL     (15U)         /*!< Bit position for ESAI_RCR_RFSL. */
#define BM_ESAI_RCR_RFSL     (0x00008000U) /*!< Bit mask for ESAI_RCR_RFSL. */
#define BS_ESAI_RCR_RFSL     (1U)          /*!< Bit field size in bits for ESAI_RCR_RFSL. */

/*! @brief Read current value of the ESAI_RCR_RFSL field. */
#define BR_ESAI_RCR_RFSL(x)  (HW_ESAI_RCR(x).B.RFSL)

/*! @brief Format value for bitfield ESAI_RCR_RFSL. */
#define BF_ESAI_RCR_RFSL(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RFSL) & BM_ESAI_RCR_RFSL)

/*! @brief Set the RFSL field to a new value. */
#define BW_ESAI_RCR_RFSL(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RFSL) | BF_ESAI_RCR_RFSL(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RFSR[16] (RW)
 *
 * ESAI_RCR Receiver Frame Sync Relative Timing. RFSR determines the relative
 * timing of the receive frame sync signal as referred to the serial data lines,
 * for a word length frame sync only. When RFSR is cleared the word length frame
 * sync occurs together with the first bit of the data word of the first slot. When
 * RFSR is set the word length frame sync starts one serial clock cycle earlier,
 * that is, together with the last bit of the previous data word.
 */
/*@{*/
#define BP_ESAI_RCR_RFSR     (16U)         /*!< Bit position for ESAI_RCR_RFSR. */
#define BM_ESAI_RCR_RFSR     (0x00010000U) /*!< Bit mask for ESAI_RCR_RFSR. */
#define BS_ESAI_RCR_RFSR     (1U)          /*!< Bit field size in bits for ESAI_RCR_RFSR. */

/*! @brief Read current value of the ESAI_RCR_RFSR field. */
#define BR_ESAI_RCR_RFSR(x)  (HW_ESAI_RCR(x).B.RFSR)

/*! @brief Format value for bitfield ESAI_RCR_RFSR. */
#define BF_ESAI_RCR_RFSR(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RFSR) & BM_ESAI_RCR_RFSR)

/*! @brief Set the RFSR field to a new value. */
#define BW_ESAI_RCR_RFSR(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RFSR) | BF_ESAI_RCR_RFSR(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RPR[19] (RW)
 *
 * ESAI_RCR Receiver Section Personal Reset. The RPR control bit is used to put
 * the receiver section of the ESAI in the personal reset state. The transmitter
 * section is not affected. When RPR is cleared, the receiver section may operate
 * normally. When RPR is set, the receiver section enters the personal reset
 * state immediately. When in the personal reset state, the status bits are reset to
 * the same state as after hardware reset.The control bits are not affected by
 * the personal reset state.The receiver data pins are disconnected while in the
 * personal reset state. To leave the personal reset state by clearing RPR, the
 * procedure described in ESAI Initialization Examples should be followed.
 */
/*@{*/
#define BP_ESAI_RCR_RPR      (19U)         /*!< Bit position for ESAI_RCR_RPR. */
#define BM_ESAI_RCR_RPR      (0x00080000U) /*!< Bit mask for ESAI_RCR_RPR. */
#define BS_ESAI_RCR_RPR      (1U)          /*!< Bit field size in bits for ESAI_RCR_RPR. */

/*! @brief Read current value of the ESAI_RCR_RPR field. */
#define BR_ESAI_RCR_RPR(x)   (HW_ESAI_RCR(x).B.RPR)

/*! @brief Format value for bitfield ESAI_RCR_RPR. */
#define BF_ESAI_RCR_RPR(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RPR) & BM_ESAI_RCR_RPR)

/*! @brief Set the RPR field to a new value. */
#define BW_ESAI_RCR_RPR(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RPR) | BF_ESAI_RCR_RPR(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field REIE[20] (RW)
 *
 * ESAI_RCR Receive Exception Interrupt Enable. When REIE is set, the Core is
 * interrupted when both RDF and ROE in the ESAI_SAISR status register are set.
 * When REIE is cleared, this interrupt is disabled. Reading the ESAI_SAISR status
 * register followed by reading the enabled receivers data registers clears ROE,
 * thus clearing the pending interrupt.
 */
/*@{*/
#define BP_ESAI_RCR_REIE     (20U)         /*!< Bit position for ESAI_RCR_REIE. */
#define BM_ESAI_RCR_REIE     (0x00100000U) /*!< Bit mask for ESAI_RCR_REIE. */
#define BS_ESAI_RCR_REIE     (1U)          /*!< Bit field size in bits for ESAI_RCR_REIE. */

/*! @brief Read current value of the ESAI_RCR_REIE field. */
#define BR_ESAI_RCR_REIE(x)  (HW_ESAI_RCR(x).B.REIE)

/*! @brief Format value for bitfield ESAI_RCR_REIE. */
#define BF_ESAI_RCR_REIE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_REIE) & BM_ESAI_RCR_REIE)

/*! @brief Set the REIE field to a new value. */
#define BW_ESAI_RCR_REIE(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_REIE) | BF_ESAI_RCR_REIE(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field REDIE[21] (RW)
 *
 * ESAI_RCR Receive Even Slot Data Interrupt Enable. The REDIE control bit is
 * used to enable the receive even slot data interrupts. If REDIE is set, the
 * receive even slot data interrupts are enabled. If REDIE is cleared, the receive
 * even slot data interrupts are disabled. A receive even slot data interrupt
 * request is generated if REDIE is set and the REDF status flag in the ESAI_SAISR
 * status register is set. Even time slots are all even-numbered time slots (0, 2, 4,
 * etc.) when operating in network mode. The zero time slot is marked by the
 * frame sync signal and is considered to be even. Reading all the data registers of
 * the enabled receivers clears the REDF flag, thus servicing the interrupt.
 * Receive interrupts with exception have higher priority than receive even slot
 * data interrupts, therefore if exception occurs (ROE is set) and REIE is set, the
 * ESAI requests an ESAI receive data with exception interrupt from the interrupt
 * controller.
 */
/*@{*/
#define BP_ESAI_RCR_REDIE    (21U)         /*!< Bit position for ESAI_RCR_REDIE. */
#define BM_ESAI_RCR_REDIE    (0x00200000U) /*!< Bit mask for ESAI_RCR_REDIE. */
#define BS_ESAI_RCR_REDIE    (1U)          /*!< Bit field size in bits for ESAI_RCR_REDIE. */

/*! @brief Read current value of the ESAI_RCR_REDIE field. */
#define BR_ESAI_RCR_REDIE(x) (HW_ESAI_RCR(x).B.REDIE)

/*! @brief Format value for bitfield ESAI_RCR_REDIE. */
#define BF_ESAI_RCR_REDIE(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_REDIE) & BM_ESAI_RCR_REDIE)

/*! @brief Set the REDIE field to a new value. */
#define BW_ESAI_RCR_REDIE(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_REDIE) | BF_ESAI_RCR_REDIE(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RIE[22] (RW)
 *
 * ESAI_RCR Receive Interrupt Enable. The Core is interrupted when RIE and the
 * RDF flag in the ESAI_SAISR status register are set. When RIE is cleared, this
 * interrupt is disabled. Reading the receive data registers of the enabled
 * receivers clears RDF, thus clearing the interrupt. Receive interrupts with exception
 * have higher priority than normal receive data interrupts, therefore if
 * exception occurs (ROE is set) and REIE is set, the ESAI requests an ESAI receive
 * data with exception interrupt from the interrupt controller.
 */
/*@{*/
#define BP_ESAI_RCR_RIE      (22U)         /*!< Bit position for ESAI_RCR_RIE. */
#define BM_ESAI_RCR_RIE      (0x00400000U) /*!< Bit mask for ESAI_RCR_RIE. */
#define BS_ESAI_RCR_RIE      (1U)          /*!< Bit field size in bits for ESAI_RCR_RIE. */

/*! @brief Read current value of the ESAI_RCR_RIE field. */
#define BR_ESAI_RCR_RIE(x)   (HW_ESAI_RCR(x).B.RIE)

/*! @brief Format value for bitfield ESAI_RCR_RIE. */
#define BF_ESAI_RCR_RIE(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RIE) & BM_ESAI_RCR_RIE)

/*! @brief Set the RIE field to a new value. */
#define BW_ESAI_RCR_RIE(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RIE) | BF_ESAI_RCR_RIE(v)))
/*@}*/

/*!
 * @name Register ESAI_RCR, field RLIE[23] (RW)
 *
 * ESAI_RCR Receive Last Slot Interrupt Enable. RLIE enables an interrupt after
 * the last slot of a frame ended in network mode only. When RLIE is set the Core
 * is interrupted after the last slot in a frame ended regardless of the receive
 * mask register setting. When RLIE is cleared the receive last slot interrupt
 * is disabled. Hardware and software reset clear RLIE. RLIE is disabled when
 * RDC[4:0]=00000 (on-demand mode). The use of the receive last slot interrupt is
 * described in ESAI Interrupt RequestsThe ESAI can generate eight different
 * interrupt requests .
 */
/*@{*/
#define BP_ESAI_RCR_RLIE     (23U)         /*!< Bit position for ESAI_RCR_RLIE. */
#define BM_ESAI_RCR_RLIE     (0x00800000U) /*!< Bit mask for ESAI_RCR_RLIE. */
#define BS_ESAI_RCR_RLIE     (1U)          /*!< Bit field size in bits for ESAI_RCR_RLIE. */

/*! @brief Read current value of the ESAI_RCR_RLIE field. */
#define BR_ESAI_RCR_RLIE(x)  (HW_ESAI_RCR(x).B.RLIE)

/*! @brief Format value for bitfield ESAI_RCR_RLIE. */
#define BF_ESAI_RCR_RLIE(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCR_RLIE) & BM_ESAI_RCR_RLIE)

/*! @brief Set the RLIE field to a new value. */
#define BW_ESAI_RCR_RLIE(x, v) (HW_ESAI_RCR_WR(x, (HW_ESAI_RCR_RD(x) & ~BM_ESAI_RCR_RLIE) | BF_ESAI_RCR_RLIE(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RCCR - Receive Clock Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RCCR - Receive Clock Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write Receiver Clock Control Register (ESAI_RCCR) controls the ESAI
 * receiver clock generator bit and frame sync rates, word length, and number of
 * words per frame for the serial data. The ESAI_RCCR control bits are described
 * in the following paragraphs. ARM Core clock is ipg_clk_esai in block ESAI
 * which is from CCM's ahb_clk_root. Receiver High Frequency Clock Divider RFP3-RFP0
 * Divide Ratio 0x0 1 0x1 2 0x2 3 0x3 4 ... ... 0xF 16 SCKR Pin Definition Table
 * Control Bits SCKR PIN SYN RCKD 0 0 SCKR input 0 1 SCKR output 1 0 IF0 1 1 OF0
 * FSR Pin Definition Table Control Bits FSR Pin SYN TEBE RFSD 0 X 0 FSR input 0
 * X 1 FSR output 1 0 0 IF1 1 0 1 OF1 1 1 0 reserved 1 1 1 Transmitter Buffer
 * Enable HCKR Pin Definition Table Control Bits HCKR PIN SYN RHCKD 0 0 HCKR input 0
 * 1 HCKR output 1 0 IF2 1 1 OF2
 */
typedef union _hw_esai_rccr
{
    uint32_t U;
    struct _hw_esai_rccr_bitfields
    {
        uint32_t RPM : 8;              /*!< [7:0]  */
        uint32_t RPSR : 1;             /*!< [8]  */
        uint32_t RDC : 5;              /*!< [13:9]  */
        uint32_t RFP : 4;              /*!< [17:14]  */
        uint32_t RCKP : 1;             /*!< [18]  */
        uint32_t RFSP : 1;             /*!< [19]  */
        uint32_t RHCKP : 1;            /*!< [20]  */
        uint32_t RCKD : 1;             /*!< [21]  */
        uint32_t RFSD : 1;             /*!< [22]  */
        uint32_t RHCKD : 1;            /*!< [23]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_esai_rccr_t;

/*!
 * @name Constants and macros for entire ESAI_RCCR register
 */
/*@{*/
#define HW_ESAI_RCCR_ADDR(x)     ((uintptr_t)(x) + 0xE0U)

#define HW_ESAI_RCCR(x)          (*(__IO hw_esai_rccr_t *) HW_ESAI_RCCR_ADDR(x))
#define HW_ESAI_RCCR_RD(x)       (HW_ESAI_RCCR(x).U)
#define HW_ESAI_RCCR_WR(x, v)    (HW_ESAI_RCCR(x).U = (v))
#define HW_ESAI_RCCR_SET(x, v)   (HW_ESAI_RCCR_WR(x, HW_ESAI_RCCR_RD(x) |  (v)))
#define HW_ESAI_RCCR_CLR(x, v)   (HW_ESAI_RCCR_WR(x, HW_ESAI_RCCR_RD(x) & ~(v)))
#define HW_ESAI_RCCR_TOG(x, v)   (HW_ESAI_RCCR_WR(x, HW_ESAI_RCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_RCCR bitfields
 */

/*!
 * @name Register ESAI_RCCR, field RPM[7:0] (RW)
 *
 * ESAI_RCCR Receiver Prescale Modulus Select. The RPM7-RPM0 bits specify the
 * divide ratio of the prescale divider in the ESAI receiver clock generator. A
 * divide ratio from 1 to 256 (RPM[7:0]=0x00 to 0xFF) may be selected. The bit clock
 * output is available at the receiver serial bit clock (SCKR) pin. The bit
 * clock output is also available internally for use as the bit clock to shift the
 * receive shift registers. The ESAI receive clock generator functional diagram is
 * shown in .
 */
/*@{*/
#define BP_ESAI_RCCR_RPM     (0U)          /*!< Bit position for ESAI_RCCR_RPM. */
#define BM_ESAI_RCCR_RPM     (0x000000FFU) /*!< Bit mask for ESAI_RCCR_RPM. */
#define BS_ESAI_RCCR_RPM     (8U)          /*!< Bit field size in bits for ESAI_RCCR_RPM. */

/*! @brief Read current value of the ESAI_RCCR_RPM field. */
#define BR_ESAI_RCCR_RPM(x)  (HW_ESAI_RCCR(x).B.RPM)

/*! @brief Format value for bitfield ESAI_RCCR_RPM. */
#define BF_ESAI_RCCR_RPM(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RPM) & BM_ESAI_RCCR_RPM)

/*! @brief Set the RPM field to a new value. */
#define BW_ESAI_RCCR_RPM(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RPM) | BF_ESAI_RCCR_RPM(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RPSR[8] (RW)
 *
 * ESAI_RCCR Receiver Prescaler Range. The RPSR controls a fixed divide-by-eight
 * prescaler in series with the variable prescaler. This bit is used to extend
 * the range of the prescaler for those cases where a slower bit clock is desired.
 * When RPSR is set, the fixed prescaler is bypassed. When RPSR is cleared, the
 * fixed divide-by-eight prescaler is operational (see ). The maximum internally
 * generated bit clock frequency is Fsys/4, the minimum internally generated bit
 * clock frequency is Fsys/(2 x 8 x 256 x 16)=Fsys/65536. (Do not use the
 * combination RPSR=1 and RPM7-RPM0 =0x00, which causes synchronization problems when
 * using the internal Core clock as source (RHCKD=1 or RCKD=1))
 */
/*@{*/
#define BP_ESAI_RCCR_RPSR    (8U)          /*!< Bit position for ESAI_RCCR_RPSR. */
#define BM_ESAI_RCCR_RPSR    (0x00000100U) /*!< Bit mask for ESAI_RCCR_RPSR. */
#define BS_ESAI_RCCR_RPSR    (1U)          /*!< Bit field size in bits for ESAI_RCCR_RPSR. */

/*! @brief Read current value of the ESAI_RCCR_RPSR field. */
#define BR_ESAI_RCCR_RPSR(x) (HW_ESAI_RCCR(x).B.RPSR)

/*! @brief Format value for bitfield ESAI_RCCR_RPSR. */
#define BF_ESAI_RCCR_RPSR(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RPSR) & BM_ESAI_RCCR_RPSR)

/*! @brief Set the RPSR field to a new value. */
#define BW_ESAI_RCCR_RPSR(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RPSR) | BF_ESAI_RCCR_RPSR(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RDC[13:9] (RW)
 *
 * ESAI_RCCR Rx Frame Rate Divider Control. The RDC4-RDC0 bits control the
 * divide ratio for the programmable frame rate dividers used to generate the receiver
 * frame clocks. In network mode, this ratio may be interpreted as the number of
 * words per frame minus one. The divide ratio may range from 2 to 32
 * (RDC[4:0]=0x00001 to 0x11111) for network mode. A divide ratio of one (RDC[4:0]=0x00000)
 * in network mode is a special case (on-demand mode). In normal mode, this
 * ratio determines the word transfer rate. The divide ratio may range from 1 to 32
 * (RDC[4:0]=0x00000 to 0x11111) for normal mode. In normal mode, a divide ratio
 * of one (RDC[4:0]=0x00000) provides continuous periodic data word transfers. A
 * bit-length frame sync (RFSL=1) must be used in this case. The ESAI frame sync
 * generator functional diagram is shown in .
 */
/*@{*/
#define BP_ESAI_RCCR_RDC     (9U)          /*!< Bit position for ESAI_RCCR_RDC. */
#define BM_ESAI_RCCR_RDC     (0x00003E00U) /*!< Bit mask for ESAI_RCCR_RDC. */
#define BS_ESAI_RCCR_RDC     (5U)          /*!< Bit field size in bits for ESAI_RCCR_RDC. */

/*! @brief Read current value of the ESAI_RCCR_RDC field. */
#define BR_ESAI_RCCR_RDC(x)  (HW_ESAI_RCCR(x).B.RDC)

/*! @brief Format value for bitfield ESAI_RCCR_RDC. */
#define BF_ESAI_RCCR_RDC(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RDC) & BM_ESAI_RCCR_RDC)

/*! @brief Set the RDC field to a new value. */
#define BW_ESAI_RCCR_RDC(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RDC) | BF_ESAI_RCCR_RDC(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RFP[17:14] (RW)
 *
 * ESAI_RCCR Rx High Frequency Clock Divider. The RFP3-RFP0 bits control the
 * divide ratio of the receiver high frequency clock to the receiver serial bit
 * clock when the source of the receiver high frequency clock and the bit clock is
 * the internal Arm Core clock. When the HCKR input is being driven from an
 * external high frequency clock, the RFP3-RFP0 bits specify an additional division
 * ration in the clock divider chain. provides the specification of the divide ratio.
 * shows the ESAI high frequency generator functional diagram.
 */
/*@{*/
#define BP_ESAI_RCCR_RFP     (14U)         /*!< Bit position for ESAI_RCCR_RFP. */
#define BM_ESAI_RCCR_RFP     (0x0003C000U) /*!< Bit mask for ESAI_RCCR_RFP. */
#define BS_ESAI_RCCR_RFP     (4U)          /*!< Bit field size in bits for ESAI_RCCR_RFP. */

/*! @brief Read current value of the ESAI_RCCR_RFP field. */
#define BR_ESAI_RCCR_RFP(x)  (HW_ESAI_RCCR(x).B.RFP)

/*! @brief Format value for bitfield ESAI_RCCR_RFP. */
#define BF_ESAI_RCCR_RFP(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RFP) & BM_ESAI_RCCR_RFP)

/*! @brief Set the RFP field to a new value. */
#define BW_ESAI_RCCR_RFP(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RFP) | BF_ESAI_RCCR_RFP(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RCKP[18] (RW)
 *
 * The Receiver Clock Polarity (RCKP) bit controls on which bit clock edge data
 * and frame sync are clocked out and latched in. If RCKP is cleared the data and
 * the frame sync are clocked out on the rising edge of the receive bit clock
 * and the frame sync is latched in on the falling edge of the receive bit clock.
 * If RCKP is set the falling edge of the receive clock is used to clock the data
 * and frame sync out and the rising edge of the receive clock is used to latch
 * the frame sync in.
 */
/*@{*/
#define BP_ESAI_RCCR_RCKP    (18U)         /*!< Bit position for ESAI_RCCR_RCKP. */
#define BM_ESAI_RCCR_RCKP    (0x00040000U) /*!< Bit mask for ESAI_RCCR_RCKP. */
#define BS_ESAI_RCCR_RCKP    (1U)          /*!< Bit field size in bits for ESAI_RCCR_RCKP. */

/*! @brief Read current value of the ESAI_RCCR_RCKP field. */
#define BR_ESAI_RCCR_RCKP(x) (HW_ESAI_RCCR(x).B.RCKP)

/*! @brief Format value for bitfield ESAI_RCCR_RCKP. */
#define BF_ESAI_RCCR_RCKP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RCKP) & BM_ESAI_RCCR_RCKP)

/*! @brief Set the RCKP field to a new value. */
#define BW_ESAI_RCCR_RCKP(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RCKP) | BF_ESAI_RCCR_RCKP(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RFSP[19] (RW)
 *
 * ESAI_RCCR Receiver Frame Sync Polarity. The Receiver Frame Sync Polarity
 * (RFSP) determines the polarity of the receive frame sync signal. When RFSP is
 * cleared the frame sync signal polarity is positive, that is, the frame start is
 * indicated by a high level on the frame sync pin. When RFSP is set the frame sync
 * signal polarity is negative, that is, the frame start is indicated by a low
 * level on the frame sync pin.
 */
/*@{*/
#define BP_ESAI_RCCR_RFSP    (19U)         /*!< Bit position for ESAI_RCCR_RFSP. */
#define BM_ESAI_RCCR_RFSP    (0x00080000U) /*!< Bit mask for ESAI_RCCR_RFSP. */
#define BS_ESAI_RCCR_RFSP    (1U)          /*!< Bit field size in bits for ESAI_RCCR_RFSP. */

/*! @brief Read current value of the ESAI_RCCR_RFSP field. */
#define BR_ESAI_RCCR_RFSP(x) (HW_ESAI_RCCR(x).B.RFSP)

/*! @brief Format value for bitfield ESAI_RCCR_RFSP. */
#define BF_ESAI_RCCR_RFSP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RFSP) & BM_ESAI_RCCR_RFSP)

/*! @brief Set the RFSP field to a new value. */
#define BW_ESAI_RCCR_RFSP(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RFSP) | BF_ESAI_RCCR_RFSP(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RHCKP[20] (RW)
 *
 * ESAI_RCCR Receiver High Frequency Clock Polarity. The Receiver High Frequency
 * Clock Polarity (RHCKP) bit controls on which bit clock edge data and frame
 * sync are clocked out and latched in. If RHCKP is cleared the data and the frame
 * sync are clocked out on the rising edge of the receive high frequency bit
 * clock and the frame sync is latched in on the falling edge of the receive bit
 * clock. If RHCKP is set the falling edge of the receive clock is used to clock the
 * data and frame sync out and the rising edge of the receive clock is used to
 * latch the frame sync in.
 */
/*@{*/
#define BP_ESAI_RCCR_RHCKP   (20U)         /*!< Bit position for ESAI_RCCR_RHCKP. */
#define BM_ESAI_RCCR_RHCKP   (0x00100000U) /*!< Bit mask for ESAI_RCCR_RHCKP. */
#define BS_ESAI_RCCR_RHCKP   (1U)          /*!< Bit field size in bits for ESAI_RCCR_RHCKP. */

/*! @brief Read current value of the ESAI_RCCR_RHCKP field. */
#define BR_ESAI_RCCR_RHCKP(x) (HW_ESAI_RCCR(x).B.RHCKP)

/*! @brief Format value for bitfield ESAI_RCCR_RHCKP. */
#define BF_ESAI_RCCR_RHCKP(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RHCKP) & BM_ESAI_RCCR_RHCKP)

/*! @brief Set the RHCKP field to a new value. */
#define BW_ESAI_RCCR_RHCKP(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RHCKP) | BF_ESAI_RCCR_RHCKP(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RCKD[21] (RW)
 *
 * ESAI_RCCR Receiver Clock Source Direction. The Receiver Clock Source
 * Direction (RCKD) bit selects the source of the clock signal used to clock the receive
 * shift register in the asynchronous mode (SYN=0) and the IF0/OF0 flag direction
 * in the synchronous mode (SYN=1). In the asynchronous mode, when RCKD is set,
 * the internal clock source becomes the bit clock for the receive shift
 * registers and word length divider and is the output on the SCKR pin. In the
 * asynchronous mode when RCKD is cleared, the clock source is external; the internal clock
 * generator is disconnected from the SCKR pin, and an external clock source may
 * drive this pin. In the synchronous mode when RCKD is set, the SCKR pin
 * becomes the OF0 output flag. If RCKD is cleared, the SCKR pin becomes the IF0 input
 * flag. Refer to and .
 */
/*@{*/
#define BP_ESAI_RCCR_RCKD    (21U)         /*!< Bit position for ESAI_RCCR_RCKD. */
#define BM_ESAI_RCCR_RCKD    (0x00200000U) /*!< Bit mask for ESAI_RCCR_RCKD. */
#define BS_ESAI_RCCR_RCKD    (1U)          /*!< Bit field size in bits for ESAI_RCCR_RCKD. */

/*! @brief Read current value of the ESAI_RCCR_RCKD field. */
#define BR_ESAI_RCCR_RCKD(x) (HW_ESAI_RCCR(x).B.RCKD)

/*! @brief Format value for bitfield ESAI_RCCR_RCKD. */
#define BF_ESAI_RCCR_RCKD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RCKD) & BM_ESAI_RCCR_RCKD)

/*! @brief Set the RCKD field to a new value. */
#define BW_ESAI_RCCR_RCKD(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RCKD) | BF_ESAI_RCCR_RCKD(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RFSD[22] (RW)
 *
 * ESAI_RCCR Receiver Frame Sync Signal Direction. The Receiver Frame Sync
 * Signal Direction (RFSD) bit selects the source of the receiver frame sync signal
 * when in the asynchronous mode (SYN=0) and the IF1/OF1/Transmitter Buffer Enable
 * flag direction in the synchronous mode (SYN=1). In the asynchronous mode, when
 * RFSD is set, the internal clock generator becomes the source of the receiver
 * frame sync and is the output on the FSR pin. In the asynchronous mode, when
 * RFSD is cleared, the receiver frame sync source is external; the internal clock
 * generator is disconnected from the FSR pin, and an external clock source may
 * drive this pin. In the synchronous mode when RFSD is set, the FSR pin becomes
 * the OF1 output flag or the Transmitter Buffer Enable, according to the TEBE
 * control bit. If RFSD is cleared, the FSR pin becomes the IF1 input flag. Refer to
 * and .
 */
/*@{*/
#define BP_ESAI_RCCR_RFSD    (22U)         /*!< Bit position for ESAI_RCCR_RFSD. */
#define BM_ESAI_RCCR_RFSD    (0x00400000U) /*!< Bit mask for ESAI_RCCR_RFSD. */
#define BS_ESAI_RCCR_RFSD    (1U)          /*!< Bit field size in bits for ESAI_RCCR_RFSD. */

/*! @brief Read current value of the ESAI_RCCR_RFSD field. */
#define BR_ESAI_RCCR_RFSD(x) (HW_ESAI_RCCR(x).B.RFSD)

/*! @brief Format value for bitfield ESAI_RCCR_RFSD. */
#define BF_ESAI_RCCR_RFSD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RFSD) & BM_ESAI_RCCR_RFSD)

/*! @brief Set the RFSD field to a new value. */
#define BW_ESAI_RCCR_RFSD(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RFSD) | BF_ESAI_RCCR_RFSD(v)))
/*@}*/

/*!
 * @name Register ESAI_RCCR, field RHCKD[23] (RW)
 *
 * ESAI_RCCR Receiver High Frequency Clock Direction. The Receiver High
 * Frequency Clock Direction (RHCKD) bit selects the source of the receiver high
 * frequency clock when in the asynchronous mode (SYN=0) and the IF2/OF2 flag direction
 * in the synchronous mode (SYN=1). In the asynchronous mode, when RHCKD is set,
 * the internal clock generator becomes the source of the receiver high frequency
 * clock and is the output on the HCKR pin. In the asynchronous mode, when RHCKD
 * is cleared, the receiver high frequency clock source is external; the internal
 * clock generator is disconnected from the HCKR pin, and an external clock
 * source may drive this pin. When RHCKD is cleared, HCKR is an input; when RHCKD is
 * set, HCKR is an output. In the synchronous mode when RHCKD is set, the HCKR
 * pin becomes the OF2 output flag. If RHCKD is cleared, the HCKR pin becomes the
 * IF2 input flag. Refer to and .
 */
/*@{*/
#define BP_ESAI_RCCR_RHCKD   (23U)         /*!< Bit position for ESAI_RCCR_RHCKD. */
#define BM_ESAI_RCCR_RHCKD   (0x00800000U) /*!< Bit mask for ESAI_RCCR_RHCKD. */
#define BS_ESAI_RCCR_RHCKD   (1U)          /*!< Bit field size in bits for ESAI_RCCR_RHCKD. */

/*! @brief Read current value of the ESAI_RCCR_RHCKD field. */
#define BR_ESAI_RCCR_RHCKD(x) (HW_ESAI_RCCR(x).B.RHCKD)

/*! @brief Format value for bitfield ESAI_RCCR_RHCKD. */
#define BF_ESAI_RCCR_RHCKD(v) ((uint32_t)((uint32_t)(v) << BP_ESAI_RCCR_RHCKD) & BM_ESAI_RCCR_RHCKD)

/*! @brief Set the RHCKD field to a new value. */
#define BW_ESAI_RCCR_RHCKD(x, v) (HW_ESAI_RCCR_WR(x, (HW_ESAI_RCCR_RD(x) & ~BM_ESAI_RCCR_RHCKD) | BF_ESAI_RCCR_RHCKD(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TSMA - Transmit Slot Mask Register A
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TSMA - Transmit Slot Mask Register A (RW)
 *
 * Reset value: 0x0000FFFFU
 *
 * The Transmit Slot Mask Register A together with Transmit Slot Mask Register B
 * (ESAI_TSMA and ESAI_TSMB) are two read/write registers used by the
 * transmitters in network mode to determine for each slot whether to transmit a data word
 * and generate a transmitter empty condition (TDE=1), or to tri-state the
 * transmitter data pins. Fields ESAI_TSMA [TS[15:0]] and ESAI_TSMB [TS[31:16]] are
 * concatenated to form the 32-bit field TS[31:0]. Bit number n in TS[31:0] is the
 * enable/disable control bit for transmission in slot number n.
 */
typedef union _hw_esai_tsma
{
    uint32_t U;
    struct _hw_esai_tsma_bitfields
    {
        uint32_t TS : 16;              /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_esai_tsma_t;

/*!
 * @name Constants and macros for entire ESAI_TSMA register
 */
/*@{*/
#define HW_ESAI_TSMA_ADDR(x)     ((uintptr_t)(x) + 0xE4U)

#define HW_ESAI_TSMA(x)          (*(__IO hw_esai_tsma_t *) HW_ESAI_TSMA_ADDR(x))
#define HW_ESAI_TSMA_RD(x)       (HW_ESAI_TSMA(x).U)
#define HW_ESAI_TSMA_WR(x, v)    (HW_ESAI_TSMA(x).U = (v))
#define HW_ESAI_TSMA_SET(x, v)   (HW_ESAI_TSMA_WR(x, HW_ESAI_TSMA_RD(x) |  (v)))
#define HW_ESAI_TSMA_CLR(x, v)   (HW_ESAI_TSMA_WR(x, HW_ESAI_TSMA_RD(x) & ~(v)))
#define HW_ESAI_TSMA_TOG(x, v)   (HW_ESAI_TSMA_WR(x, HW_ESAI_TSMA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TSMA bitfields
 */

/*!
 * @name Register ESAI_TSMA, field TS[15:0] (RW)
 *
 * When bit number N in ESAI_TSMA is cleared, all the transmit data pins of the
 * enabled transmitters are tri-stated during transmit time slot number N. The
 * data is still transferred from the transmit data registers to the transmit shift
 * registers but neither the TDE nor the TUE flags are set. This means that
 * during a disabled slot, no transmitter empty interrupt is generated. The Core is
 * interrupted only for enabled slots. Data that is written to the transmit data
 * registers when servicing this request is transmitted in the next enabled
 * transmit time slot. When bit number N in ESAI_TSMA register is set, the transmit
 * sequence is as usual: data is transferred from the TX registers to the shift
 * registers and transmitted during slot number N, and the TDE flag is set. Using the
 * slot mask in ESAI_TSMA does not conflict with using TSR. Even if a slot is
 * enabled in ESAI_TSMA, the user may choose to write to TSR instead of writing to
 * the transmit data registers TXn. This causes all the transmit data pins of the
 * enabled transmitters to be tri-stated during the next slot. Data written to
 * the ESAI_TSMA affects the next frame transmission. The frame being transmitted
 * is not affected by this data and would comply to the last ESAI_TSMA setting.
 * Data read from ESAI_TSMA returns the last written data. After hardware or
 * software reset, the ESAI_TSMA register is preset to 0x0000FFFF, which means that
 * all 16 possible slots are enabled for data transmission. When operating in
 * normal mode, bit 0 of the ESAI_TSMA register must be set, otherwise no output is
 * generated.
 */
/*@{*/
#define BP_ESAI_TSMA_TS      (0U)          /*!< Bit position for ESAI_TSMA_TS. */
#define BM_ESAI_TSMA_TS      (0x0000FFFFU) /*!< Bit mask for ESAI_TSMA_TS. */
#define BS_ESAI_TSMA_TS      (16U)         /*!< Bit field size in bits for ESAI_TSMA_TS. */

/*! @brief Read current value of the ESAI_TSMA_TS field. */
#define BR_ESAI_TSMA_TS(x)   (HW_ESAI_TSMA(x).B.TS)

/*! @brief Format value for bitfield ESAI_TSMA_TS. */
#define BF_ESAI_TSMA_TS(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TSMA_TS) & BM_ESAI_TSMA_TS)

/*! @brief Set the TS field to a new value. */
#define BW_ESAI_TSMA_TS(x, v) (HW_ESAI_TSMA_WR(x, (HW_ESAI_TSMA_RD(x) & ~BM_ESAI_TSMA_TS) | BF_ESAI_TSMA_TS(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_TSMB - Transmit Slot Mask Register B
 ******************************************************************************/

/*!
 * @brief HW_ESAI_TSMB - Transmit Slot Mask Register B (RW)
 *
 * Reset value: 0x0000FFFFU
 *
 * The Transmit Slot Mask Register B together with Transmit Slot Mask Register A
 * (ESAI_TSMA and ESAI_TSMB) are two read/write registers used by the
 * transmitters in network mode to determine for each slot whether to transmit a data word
 * and generate a transmitter empty condition (TDE=1), or to tri-state the
 * transmitter data pins. Fields ESAI_TSMA [TS[15:0]] and ESAI_TSMB [TS[31:16]] are
 * concatenated to form the 32-bit field TS[31:0]. Bit number n in TS[31:0] is the
 * enable/disable control bit for transmission in slot number n.
 */
typedef union _hw_esai_tsmb
{
    uint32_t U;
    struct _hw_esai_tsmb_bitfields
    {
        uint32_t TS : 16;              /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_esai_tsmb_t;

/*!
 * @name Constants and macros for entire ESAI_TSMB register
 */
/*@{*/
#define HW_ESAI_TSMB_ADDR(x)     ((uintptr_t)(x) + 0xE8U)

#define HW_ESAI_TSMB(x)          (*(__IO hw_esai_tsmb_t *) HW_ESAI_TSMB_ADDR(x))
#define HW_ESAI_TSMB_RD(x)       (HW_ESAI_TSMB(x).U)
#define HW_ESAI_TSMB_WR(x, v)    (HW_ESAI_TSMB(x).U = (v))
#define HW_ESAI_TSMB_SET(x, v)   (HW_ESAI_TSMB_WR(x, HW_ESAI_TSMB_RD(x) |  (v)))
#define HW_ESAI_TSMB_CLR(x, v)   (HW_ESAI_TSMB_WR(x, HW_ESAI_TSMB_RD(x) & ~(v)))
#define HW_ESAI_TSMB_TOG(x, v)   (HW_ESAI_TSMB_WR(x, HW_ESAI_TSMB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_TSMB bitfields
 */

/*!
 * @name Register ESAI_TSMB, field TS[15:0] (RW)
 *
 * When bit number N in ESAI_TSMB is cleared, all the transmit data pins of the
 * enabled transmitters are tri-stated during transmit time slot number N. The
 * data is still transferred from the transmit data registers to the transmit shift
 * registers but neither the TDE nor the TUE flags are set. This means that
 * during a disabled slot, no transmitter empty interrupt is generated. The Core is
 * interrupted only for enabled slots. Data that is written to the transmit data
 * registers when servicing this request is transmitted in the next enabled
 * transmit time slot. When bit number N in ESAI_TSMB register is set, the transmit
 * sequence is as usual: data is transferred from the TX registers to the shift
 * registers and transmitted during slot number N, and the TDE flag is set. Using the
 * slot mask in ESAI_TSMB does not conflict with using TSR. Even if a slot is
 * enabled in TSMB, the user may chose to write to TSR instead of writing to the
 * transmit data registers TXn. This causes all the transmit data pins of the
 * enabled transmitters to be tri-stated during the next slot. Data written to the
 * ESAI_TSMB affects the next frame transmission. The frame being transmitted is not
 * affected by this data and would comply to the last ESAI_TSMB setting. Data
 * read from ESAI_TSMB returns the last written data. After hardware or software
 * reset, the ESAI_TSMB register is preset to 0x0000FFFF, which means that all 16
 * possible slots are enabled for data transmission.
 */
/*@{*/
#define BP_ESAI_TSMB_TS      (0U)          /*!< Bit position for ESAI_TSMB_TS. */
#define BM_ESAI_TSMB_TS      (0x0000FFFFU) /*!< Bit mask for ESAI_TSMB_TS. */
#define BS_ESAI_TSMB_TS      (16U)         /*!< Bit field size in bits for ESAI_TSMB_TS. */

/*! @brief Read current value of the ESAI_TSMB_TS field. */
#define BR_ESAI_TSMB_TS(x)   (HW_ESAI_TSMB(x).B.TS)

/*! @brief Format value for bitfield ESAI_TSMB_TS. */
#define BF_ESAI_TSMB_TS(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_TSMB_TS) & BM_ESAI_TSMB_TS)

/*! @brief Set the TS field to a new value. */
#define BW_ESAI_TSMB_TS(x, v) (HW_ESAI_TSMB_WR(x, (HW_ESAI_TSMB_RD(x) & ~BM_ESAI_TSMB_TS) | BF_ESAI_TSMB_TS(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RSMA - Receive Slot Mask Register A
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RSMA - Receive Slot Mask Register A (RW)
 *
 * Reset value: 0x0000FFFFU
 *
 * The Receive Slot Mask Register A together with Receive Slot Mask Register B
 * (ESAI_RSMA and ESAI_RSMB) are two read/write registers used by the receiver in
 * network mode to determine for each slot whether to receive a data word and
 * generate a receiver full condition (RDF=1), or to ignore the received data.
 * Fields ESAI_RSMA [RS[15:0]] and ESAI_RSMB [RS31:16]] are concatenated to form the
 * 32-bit field RS[31:0]. Bit number n in RS[31:0] is an enable/disable control
 * bit for receiving data in slot number n.
 */
typedef union _hw_esai_rsma
{
    uint32_t U;
    struct _hw_esai_rsma_bitfields
    {
        uint32_t RS : 16;              /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_esai_rsma_t;

/*!
 * @name Constants and macros for entire ESAI_RSMA register
 */
/*@{*/
#define HW_ESAI_RSMA_ADDR(x)     ((uintptr_t)(x) + 0xECU)

#define HW_ESAI_RSMA(x)          (*(__IO hw_esai_rsma_t *) HW_ESAI_RSMA_ADDR(x))
#define HW_ESAI_RSMA_RD(x)       (HW_ESAI_RSMA(x).U)
#define HW_ESAI_RSMA_WR(x, v)    (HW_ESAI_RSMA(x).U = (v))
#define HW_ESAI_RSMA_SET(x, v)   (HW_ESAI_RSMA_WR(x, HW_ESAI_RSMA_RD(x) |  (v)))
#define HW_ESAI_RSMA_CLR(x, v)   (HW_ESAI_RSMA_WR(x, HW_ESAI_RSMA_RD(x) & ~(v)))
#define HW_ESAI_RSMA_TOG(x, v)   (HW_ESAI_RSMA_WR(x, HW_ESAI_RSMA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_RSMA bitfields
 */

/*!
 * @name Register ESAI_RSMA, field RS[15:0] (RW)
 *
 * When bit number N in the ESAI_RSMA register is cleared, the data from the
 * enabled receivers input pins are shifted into their receive shift registers
 * during slot number N. The data is not transferred from the receive shift registers
 * to the receive data registers, and neither the RDF nor the ROE flag is set.
 * This means that during a disabled slot, no receiver full interrupt is generated.
 * The Core is interrupted only for enabled slots. When bit number N in the
 * ESAI_RSMA is set, the receive sequence is as usual: data which is shifted into the
 * enabled receivers shift registers is transferred to the receive data
 * registers and the RDF flag is set. Data written to the ESAI_RSMA affects the next
 * received frame. The frame being received is not affected by this data and would
 * comply to the last ESAI_RSMA setting. Data read from ESAI_RSMA returns the last
 * written data. After hardware or software reset, the ESAI_RSMA register is
 * preset to 0x0000FFFF, which means that all 16 possible slots are enabled for data
 * reception. When operating in normal mode, bit 0 of the ESAI_RSMA register must
 * be set to one, otherwise no input is received.
 */
/*@{*/
#define BP_ESAI_RSMA_RS      (0U)          /*!< Bit position for ESAI_RSMA_RS. */
#define BM_ESAI_RSMA_RS      (0x0000FFFFU) /*!< Bit mask for ESAI_RSMA_RS. */
#define BS_ESAI_RSMA_RS      (16U)         /*!< Bit field size in bits for ESAI_RSMA_RS. */

/*! @brief Read current value of the ESAI_RSMA_RS field. */
#define BR_ESAI_RSMA_RS(x)   (HW_ESAI_RSMA(x).B.RS)

/*! @brief Format value for bitfield ESAI_RSMA_RS. */
#define BF_ESAI_RSMA_RS(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RSMA_RS) & BM_ESAI_RSMA_RS)

/*! @brief Set the RS field to a new value. */
#define BW_ESAI_RSMA_RS(x, v) (HW_ESAI_RSMA_WR(x, (HW_ESAI_RSMA_RD(x) & ~BM_ESAI_RSMA_RS) | BF_ESAI_RSMA_RS(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_RSMB - Receive Slot Mask Register B
 ******************************************************************************/

/*!
 * @brief HW_ESAI_RSMB - Receive Slot Mask Register B (RW)
 *
 * Reset value: 0x0000FFFFU
 *
 * The Receive Slot Mask Register B together with Receive Slot Mask Register A
 * (ESAI_RSMA and ESAI_RSMB) are two read/write registers used by the receiver in
 * network mode to determine for each slot whether to receive a data word and
 * generate a receiver full condition (RDF=1), or to ignore the received data.
 * Fields ESAI_RSMA [RS[15:0]] and ESAI_RSMB [RS31:16]] are concatenated to form the
 * 32-bit field RS[31:0]. Bit number n in RS[31:0] is an enable/disable control
 * bit for receiving data in slot number n.
 */
typedef union _hw_esai_rsmb
{
    uint32_t U;
    struct _hw_esai_rsmb_bitfields
    {
        uint32_t RS : 16;              /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_esai_rsmb_t;

/*!
 * @name Constants and macros for entire ESAI_RSMB register
 */
/*@{*/
#define HW_ESAI_RSMB_ADDR(x)     ((uintptr_t)(x) + 0xF0U)

#define HW_ESAI_RSMB(x)          (*(__IO hw_esai_rsmb_t *) HW_ESAI_RSMB_ADDR(x))
#define HW_ESAI_RSMB_RD(x)       (HW_ESAI_RSMB(x).U)
#define HW_ESAI_RSMB_WR(x, v)    (HW_ESAI_RSMB(x).U = (v))
#define HW_ESAI_RSMB_SET(x, v)   (HW_ESAI_RSMB_WR(x, HW_ESAI_RSMB_RD(x) |  (v)))
#define HW_ESAI_RSMB_CLR(x, v)   (HW_ESAI_RSMB_WR(x, HW_ESAI_RSMB_RD(x) & ~(v)))
#define HW_ESAI_RSMB_TOG(x, v)   (HW_ESAI_RSMB_WR(x, HW_ESAI_RSMB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_RSMB bitfields
 */

/*!
 * @name Register ESAI_RSMB, field RS[15:0] (RW)
 *
 * When bit number N in the ESAI_RSMB register is cleared, the data from the
 * enabled receivers input pins are shifted into their receive shift registers
 * during slot number N. The data is not transferred from the receive shift registers
 * to the receive data registers, and neither the RDF nor the ROE flag is set.
 * This means that during a disabled slot, no receiver full interrupt is generated.
 * The Core is interrupted only for enabled slots. When bit number N in the
 * ESAI_RSMB is set, the receive sequence is as usual: data which is shifted into the
 * enabled receivers shift registers is transferred to the receive data
 * registers and the RDF flag is set. Data written to the ESAI_RSMB affects the next
 * received frame. The frame being received is not affected by this data and would
 * comply to the last ESAI_RSMB setting. Data read from ESAI_RSMB returns the last
 * written data. After hardware or software reset, the ESAI_RSMB register is
 * preset to 0x0000FFFF, which means that all 16 possible slots are enabled for data
 * reception.
 */
/*@{*/
#define BP_ESAI_RSMB_RS      (0U)          /*!< Bit position for ESAI_RSMB_RS. */
#define BM_ESAI_RSMB_RS      (0x0000FFFFU) /*!< Bit mask for ESAI_RSMB_RS. */
#define BS_ESAI_RSMB_RS      (16U)         /*!< Bit field size in bits for ESAI_RSMB_RS. */

/*! @brief Read current value of the ESAI_RSMB_RS field. */
#define BR_ESAI_RSMB_RS(x)   (HW_ESAI_RSMB(x).B.RS)

/*! @brief Format value for bitfield ESAI_RSMB_RS. */
#define BF_ESAI_RSMB_RS(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_RSMB_RS) & BM_ESAI_RSMB_RS)

/*! @brief Set the RS field to a new value. */
#define BW_ESAI_RSMB_RS(x, v) (HW_ESAI_RSMB_WR(x, (HW_ESAI_RSMB_RD(x) & ~BM_ESAI_RSMB_RS) | BF_ESAI_RSMB_RS(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_PRRC - Port C Direction Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_PRRC - Port C Direction Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * There are two registers to control the ESAI personal reset status: Port C
 * Direction Register (ESAI_PRRC) and Port C Control Register (ESAI_PCRC). The
 * read/write 32-bit Port C Direction Register (ESAI_PRRC) in conjunction with the
 * Port C Control Register (ESAI_PCRC) controls the functionality of the ESAI
 * personal reset state. provides the port pin configurations. Hardware and software
 * reset clear all ESAI_PRRC bits.
 */
typedef union _hw_esai_prrc
{
    uint32_t U;
    struct _hw_esai_prrc_bitfields
    {
        uint32_t PDC : 12;             /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_esai_prrc_t;

/*!
 * @name Constants and macros for entire ESAI_PRRC register
 */
/*@{*/
#define HW_ESAI_PRRC_ADDR(x)     ((uintptr_t)(x) + 0xF8U)

#define HW_ESAI_PRRC(x)          (*(__IO hw_esai_prrc_t *) HW_ESAI_PRRC_ADDR(x))
#define HW_ESAI_PRRC_RD(x)       (HW_ESAI_PRRC(x).U)
#define HW_ESAI_PRRC_WR(x, v)    (HW_ESAI_PRRC(x).U = (v))
#define HW_ESAI_PRRC_SET(x, v)   (HW_ESAI_PRRC_WR(x, HW_ESAI_PRRC_RD(x) |  (v)))
#define HW_ESAI_PRRC_CLR(x, v)   (HW_ESAI_PRRC_WR(x, HW_ESAI_PRRC_RD(x) & ~(v)))
#define HW_ESAI_PRRC_TOG(x, v)   (HW_ESAI_PRRC_WR(x, HW_ESAI_PRRC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_PRRC bitfields
 */

/*!
 * @name Register ESAI_PRRC, field PDC[11:0] (RW)
 *
 * See .
 */
/*@{*/
#define BP_ESAI_PRRC_PDC     (0U)          /*!< Bit position for ESAI_PRRC_PDC. */
#define BM_ESAI_PRRC_PDC     (0x00000FFFU) /*!< Bit mask for ESAI_PRRC_PDC. */
#define BS_ESAI_PRRC_PDC     (12U)         /*!< Bit field size in bits for ESAI_PRRC_PDC. */

/*! @brief Read current value of the ESAI_PRRC_PDC field. */
#define BR_ESAI_PRRC_PDC(x)  (HW_ESAI_PRRC(x).B.PDC)

/*! @brief Format value for bitfield ESAI_PRRC_PDC. */
#define BF_ESAI_PRRC_PDC(v)  ((uint32_t)((uint32_t)(v) << BP_ESAI_PRRC_PDC) & BM_ESAI_PRRC_PDC)

/*! @brief Set the PDC field to a new value. */
#define BW_ESAI_PRRC_PDC(x, v) (HW_ESAI_PRRC_WR(x, (HW_ESAI_PRRC_RD(x) & ~BM_ESAI_PRRC_PDC) | BF_ESAI_PRRC_PDC(v)))
/*@}*/

/*******************************************************************************
 * HW_ESAI_PCRC - Port C Control Register
 ******************************************************************************/

/*!
 * @brief HW_ESAI_PCRC - Port C Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The read/write 32-bit Port C Control Register (ESAI_PCRC) in conjunction with
 * the Port C Direction Register (ESAI_PRRC) controls the functionality of the
 * ESAI personal reset state. Each of the PC(11:0) bits controls the functionality
 * of the corresponding port pin. provides the port pin configurations. Hardware
 * and software reset clear all ESAI_PCRC bits. PCRC and PRRC Bits Functionality
 * PDC[i] PC[i] Port Pin[i] Function 0 0 Disconnected 1 1 ESAI
 */
typedef union _hw_esai_pcrc
{
    uint32_t U;
    struct _hw_esai_pcrc_bitfields
    {
        uint32_t PC : 12;              /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_esai_pcrc_t;

/*!
 * @name Constants and macros for entire ESAI_PCRC register
 */
/*@{*/
#define HW_ESAI_PCRC_ADDR(x)     ((uintptr_t)(x) + 0xFCU)

#define HW_ESAI_PCRC(x)          (*(__IO hw_esai_pcrc_t *) HW_ESAI_PCRC_ADDR(x))
#define HW_ESAI_PCRC_RD(x)       (HW_ESAI_PCRC(x).U)
#define HW_ESAI_PCRC_WR(x, v)    (HW_ESAI_PCRC(x).U = (v))
#define HW_ESAI_PCRC_SET(x, v)   (HW_ESAI_PCRC_WR(x, HW_ESAI_PCRC_RD(x) |  (v)))
#define HW_ESAI_PCRC_CLR(x, v)   (HW_ESAI_PCRC_WR(x, HW_ESAI_PCRC_RD(x) & ~(v)))
#define HW_ESAI_PCRC_TOG(x, v)   (HW_ESAI_PCRC_WR(x, HW_ESAI_PCRC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ESAI_PCRC bitfields
 */

/*!
 * @name Register ESAI_PCRC, field PC[11:0] (RW)
 *
 * See .
 */
/*@{*/
#define BP_ESAI_PCRC_PC      (0U)          /*!< Bit position for ESAI_PCRC_PC. */
#define BM_ESAI_PCRC_PC      (0x00000FFFU) /*!< Bit mask for ESAI_PCRC_PC. */
#define BS_ESAI_PCRC_PC      (12U)         /*!< Bit field size in bits for ESAI_PCRC_PC. */

/*! @brief Read current value of the ESAI_PCRC_PC field. */
#define BR_ESAI_PCRC_PC(x)   (HW_ESAI_PCRC(x).B.PC)

/*! @brief Format value for bitfield ESAI_PCRC_PC. */
#define BF_ESAI_PCRC_PC(v)   ((uint32_t)((uint32_t)(v) << BP_ESAI_PCRC_PC) & BM_ESAI_PCRC_PC)

/*! @brief Set the PC field to a new value. */
#define BW_ESAI_PCRC_PC(x, v) (HW_ESAI_PCRC_WR(x, (HW_ESAI_PCRC_RD(x) & ~BM_ESAI_PCRC_PC) | BF_ESAI_PCRC_PC(v)))
/*@}*/

/*******************************************************************************
 * hw_esai_t - module struct
 ******************************************************************************/
/*!
 * @brief All ESAI module registers.
 */
#pragma pack(1)
typedef struct _hw_esai
{
    __O hw_esai_etdr_t ETDR;               /*!< [0x0] ESAI Transmit Data Register */
    __I hw_esai_erdr_t ERDR;               /*!< [0x4] ESAI Receive Data Register */
    __IO hw_esai_ecr_t ECR;                /*!< [0x8] ESAI Control Register */
    __I hw_esai_esr_t ESR;                 /*!< [0xC] ESAI Status Register */
    __IO hw_esai_tfcr_t TFCR;              /*!< [0x10] Transmit FIFO Configuration Register */
    __I hw_esai_tfsr_t TFSR;               /*!< [0x14] Transmit FIFO Status Register */
    __IO hw_esai_rfcr_t RFCR;              /*!< [0x18] Receive FIFO Configuration Register */
    __I hw_esai_rfsr_t RFSR;               /*!< [0x1C] Receive FIFO Status Register */
    uint8_t _reserved0[96];
    __IO hw_esai_txn_t TXn[6];             /*!< [0x80] Transmit Data Register n */
    __IO hw_esai_tsr_t TSR;                /*!< [0x98] ESAI Transmit Slot Register */
    uint8_t _reserved1[4];
    __I hw_esai_rxn_t RXn[4];              /*!< [0xA0] Receive Data Register n */
    uint8_t _reserved2[28];
    __I hw_esai_saisr_t SAISR;             /*!< [0xCC] Serial Audio Interface Status Register */
    __IO hw_esai_saicr_t SAICR;            /*!< [0xD0] Serial Audio Interface Control Register */
    __IO hw_esai_tcr_t TCR;                /*!< [0xD4] Transmit Control Register */
    __IO hw_esai_tccr_t TCCR;              /*!< [0xD8] Transmit Clock Control Register */
    __IO hw_esai_rcr_t RCR;                /*!< [0xDC] Receive Control Register */
    __IO hw_esai_rccr_t RCCR;              /*!< [0xE0] Receive Clock Control Register */
    __IO hw_esai_tsma_t TSMA;              /*!< [0xE4] Transmit Slot Mask Register A */
    __IO hw_esai_tsmb_t TSMB;              /*!< [0xE8] Transmit Slot Mask Register B */
    __IO hw_esai_rsma_t RSMA;              /*!< [0xEC] Receive Slot Mask Register A */
    __IO hw_esai_rsmb_t RSMB;              /*!< [0xF0] Receive Slot Mask Register B */
    uint8_t _reserved3[4];
    __IO hw_esai_prrc_t PRRC;              /*!< [0xF8] Port C Direction Register */
    __IO hw_esai_pcrc_t PCRC;              /*!< [0xFC] Port C Control Register */
} hw_esai_t;
#pragma pack()

/*! @brief Macro to access all ESAI registers. */
/*! @param x ESAI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ESAI_REGS(ESAI_BASE)</code>. */
#define HW_ESAI_REGS(x) (*(hw_esai_t *)(x))

/*
 * iMX6DP GPC
 *
 * GPC
 *
 * Registers defined in this header file:
 * - HW_GPC_CNTR - GPC Interface control register
 * - HW_GPC_PGR - GPC Power Gating Register
 * - HW_GPC_IMR1 - IRQ masking register 1
 * - HW_GPC_IMR2 - IRQ masking register 2
 * - HW_GPC_IMR3 - IRQ masking register 3
 * - HW_GPC_IMR4 - IRQ masking register 4
 * - HW_GPC_ISR1 - IRQ status resister 1
 * - HW_GPC_ISR2 - IRQ status resister 2
 * - HW_GPC_ISR3 - IRQ status resister 3
 * - HW_GPC_ISR4 - IRQ status resister 4
 *
 * - hw_gpc_t - Struct containing all module registers.
 */

#define HW_GPC_INSTANCE_COUNT (1U) /*!< Number of instances of the GPC module. */
#define HW_GPC (0U) /*!< Instance number for GPC. */
#define GPC_BASE              (0x20DC000U) /*!< Base address for GPC. */
/*! Array initializer of GPC base addresses. */
#define GPC_BASE_ADDRS        { GPC_BASE }

/*******************************************************************************
 * HW_GPC_CNTR - GPC Interface control register
 ******************************************************************************/

/*!
 * @brief HW_GPC_CNTR - GPC Interface control register (RW)
 *
 * Reset value: 0x00100000U
 */
typedef union _hw_gpc_cntr
{
    uint32_t U;
    struct _hw_gpc_cntr_bitfields
    {
        uint32_t gpu_vpu_pdn_req : 1;  /*!< [0]  */
        uint32_t gpu_vpu_pup_req : 1;  /*!< [1]  */
        uint32_t RESERVED0 : 14;       /*!< [15:2]  */
        uint32_t DVFS0CR : 1;          /*!< [16]  */
        uint32_t RESERVED1 : 4;        /*!< [20:17]  */
        uint32_t GPCIRQM : 1;          /*!< [21]  */
        uint32_t RESERVED2 : 10;       /*!< [31:22]  */
    } B;
} hw_gpc_cntr_t;

/*!
 * @name Constants and macros for entire GPC_CNTR register
 */
/*@{*/
#define HW_GPC_CNTR_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_GPC_CNTR(x)           (*(__IO hw_gpc_cntr_t *) HW_GPC_CNTR_ADDR(x))
#define HW_GPC_CNTR_RD(x)        (HW_GPC_CNTR(x).U)
#define HW_GPC_CNTR_WR(x, v)     (HW_GPC_CNTR(x).U = (v))
#define HW_GPC_CNTR_SET(x, v)    (HW_GPC_CNTR_WR(x, HW_GPC_CNTR_RD(x) |  (v)))
#define HW_GPC_CNTR_CLR(x, v)    (HW_GPC_CNTR_WR(x, HW_GPC_CNTR_RD(x) & ~(v)))
#define HW_GPC_CNTR_TOG(x, v)    (HW_GPC_CNTR_WR(x, HW_GPC_CNTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_CNTR bitfields
 */

/*!
 * @name Register GPC_CNTR, field gpu_vpu_pdn_req[0] (RW)
 *
 * GPU/VPU Power Down request. Self-cleared bit. * Note: Power switch for
 * GPU/VPU power domain is controlled by ANALOG configuration, not GPU/VPU PGC signals
 *
 * Values:
 * - 1 - Request Power Down sequence to start for GPU/VPU
 * - 0 - no request
 */
/*@{*/
#define BP_GPC_CNTR_gpu_vpu_pdn_req (0U)   /*!< Bit position for GPC_CNTR_gpu_vpu_pdn_req. */
#define BM_GPC_CNTR_gpu_vpu_pdn_req (0x00000001U) /*!< Bit mask for GPC_CNTR_gpu_vpu_pdn_req. */
#define BS_GPC_CNTR_gpu_vpu_pdn_req (1U)   /*!< Bit field size in bits for GPC_CNTR_gpu_vpu_pdn_req. */

/*! @brief Read current value of the GPC_CNTR_gpu_vpu_pdn_req field. */
#define BR_GPC_CNTR_gpu_vpu_pdn_req(x) (HW_GPC_CNTR(x).B.gpu_vpu_pdn_req)

/*! @brief Format value for bitfield GPC_CNTR_gpu_vpu_pdn_req. */
#define BF_GPC_CNTR_gpu_vpu_pdn_req(v) ((uint32_t)((uint32_t)(v) << BP_GPC_CNTR_gpu_vpu_pdn_req) & BM_GPC_CNTR_gpu_vpu_pdn_req)

/*! @brief Set the gpu_vpu_pdn_req field to a new value. */
#define BW_GPC_CNTR_gpu_vpu_pdn_req(x, v) (HW_GPC_CNTR_WR(x, (HW_GPC_CNTR_RD(x) & ~BM_GPC_CNTR_gpu_vpu_pdn_req) | BF_GPC_CNTR_gpu_vpu_pdn_req(v)))
/*@}*/

/*!
 * @name Register GPC_CNTR, field gpu_vpu_pup_req[1] (RW)
 *
 * GPU/VPU Power Up request. Self-cleared bit. * Note: Power switch for GPU/VPU
 * power domain is controlled by ANALOG configuration, not GPU/VPU PGC signals
 *
 * Values:
 * - 1 - Request Power Up sequence to start for GPU/VPU
 * - 0 - no request
 */
/*@{*/
#define BP_GPC_CNTR_gpu_vpu_pup_req (1U)   /*!< Bit position for GPC_CNTR_gpu_vpu_pup_req. */
#define BM_GPC_CNTR_gpu_vpu_pup_req (0x00000002U) /*!< Bit mask for GPC_CNTR_gpu_vpu_pup_req. */
#define BS_GPC_CNTR_gpu_vpu_pup_req (1U)   /*!< Bit field size in bits for GPC_CNTR_gpu_vpu_pup_req. */

/*! @brief Read current value of the GPC_CNTR_gpu_vpu_pup_req field. */
#define BR_GPC_CNTR_gpu_vpu_pup_req(x) (HW_GPC_CNTR(x).B.gpu_vpu_pup_req)

/*! @brief Format value for bitfield GPC_CNTR_gpu_vpu_pup_req. */
#define BF_GPC_CNTR_gpu_vpu_pup_req(v) ((uint32_t)((uint32_t)(v) << BP_GPC_CNTR_gpu_vpu_pup_req) & BM_GPC_CNTR_gpu_vpu_pup_req)

/*! @brief Set the gpu_vpu_pup_req field to a new value. */
#define BW_GPC_CNTR_gpu_vpu_pup_req(x, v) (HW_GPC_CNTR_WR(x, (HW_GPC_CNTR_RD(x) & ~BM_GPC_CNTR_gpu_vpu_pup_req) | BF_GPC_CNTR_gpu_vpu_pup_req(v)))
/*@}*/

/*!
 * @name Register GPC_CNTR, field DVFS0CR[16] (RO)
 *
 * DVFS0 (ARM) Change request (bit is read-only)
 *
 * Values:
 * - 1 - DVFS0 is requesting for frequency/voltage update
 * - 0 - DVFS0 has no request
 */
/*@{*/
#define BP_GPC_CNTR_DVFS0CR  (16U)         /*!< Bit position for GPC_CNTR_DVFS0CR. */
#define BM_GPC_CNTR_DVFS0CR  (0x00010000U) /*!< Bit mask for GPC_CNTR_DVFS0CR. */
#define BS_GPC_CNTR_DVFS0CR  (1U)          /*!< Bit field size in bits for GPC_CNTR_DVFS0CR. */

/*! @brief Read current value of the GPC_CNTR_DVFS0CR field. */
#define BR_GPC_CNTR_DVFS0CR(x) (HW_GPC_CNTR(x).B.DVFS0CR)
/*@}*/

/*!
 * @name Register GPC_CNTR, field GPCIRQM[21] (RW)
 *
 * GPC interrupt/event masking
 *
 * Values:
 * - 1 - interrupt/event is masked
 * - 0 - not masked
 */
/*@{*/
#define BP_GPC_CNTR_GPCIRQM  (21U)         /*!< Bit position for GPC_CNTR_GPCIRQM. */
#define BM_GPC_CNTR_GPCIRQM  (0x00200000U) /*!< Bit mask for GPC_CNTR_GPCIRQM. */
#define BS_GPC_CNTR_GPCIRQM  (1U)          /*!< Bit field size in bits for GPC_CNTR_GPCIRQM. */

/*! @brief Read current value of the GPC_CNTR_GPCIRQM field. */
#define BR_GPC_CNTR_GPCIRQM(x) (HW_GPC_CNTR(x).B.GPCIRQM)

/*! @brief Format value for bitfield GPC_CNTR_GPCIRQM. */
#define BF_GPC_CNTR_GPCIRQM(v) ((uint32_t)((uint32_t)(v) << BP_GPC_CNTR_GPCIRQM) & BM_GPC_CNTR_GPCIRQM)

/*! @brief Set the GPCIRQM field to a new value. */
#define BW_GPC_CNTR_GPCIRQM(x, v) (HW_GPC_CNTR_WR(x, (HW_GPC_CNTR_RD(x) & ~BM_GPC_CNTR_GPCIRQM) | BF_GPC_CNTR_GPCIRQM(v)))
/*@}*/

/*******************************************************************************
 * HW_GPC_PGR - GPC Power Gating Register
 ******************************************************************************/

/*!
 * @brief HW_GPC_PGR - GPC Power Gating Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpc_pgr
{
    uint32_t U;
    struct _hw_gpc_pgr_bitfields
    {
        uint32_t RESERVED0 : 29;       /*!< [28:0]  */
        uint32_t DRCIC : 2;            /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_gpc_pgr_t;

/*!
 * @name Constants and macros for entire GPC_PGR register
 */
/*@{*/
#define HW_GPC_PGR_ADDR(x)       ((uintptr_t)(x) + 0x4U)

#define HW_GPC_PGR(x)            (*(__IO hw_gpc_pgr_t *) HW_GPC_PGR_ADDR(x))
#define HW_GPC_PGR_RD(x)         (HW_GPC_PGR(x).U)
#define HW_GPC_PGR_WR(x, v)      (HW_GPC_PGR(x).U = (v))
#define HW_GPC_PGR_SET(x, v)     (HW_GPC_PGR_WR(x, HW_GPC_PGR_RD(x) |  (v)))
#define HW_GPC_PGR_CLR(x, v)     (HW_GPC_PGR_WR(x, HW_GPC_PGR_RD(x) & ~(v)))
#define HW_GPC_PGR_TOG(x, v)     (HW_GPC_PGR_WR(x, HW_GPC_PGR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_PGR bitfields
 */

/*!
 * @name Register GPC_PGR, field DRCIC[30:29] (RW)
 *
 * Debug ref cir in mux control
 *
 * Values:
 * - 00 - ccm_cosr_1_clk_in
 * - 01 - ccm_cosr_2_clk_in
 * - 10 - restricted
 * - 11 - restricted
 */
/*@{*/
#define BP_GPC_PGR_DRCIC     (29U)         /*!< Bit position for GPC_PGR_DRCIC. */
#define BM_GPC_PGR_DRCIC     (0x60000000U) /*!< Bit mask for GPC_PGR_DRCIC. */
#define BS_GPC_PGR_DRCIC     (2U)          /*!< Bit field size in bits for GPC_PGR_DRCIC. */

/*! @brief Read current value of the GPC_PGR_DRCIC field. */
#define BR_GPC_PGR_DRCIC(x)  (HW_GPC_PGR(x).B.DRCIC)

/*! @brief Format value for bitfield GPC_PGR_DRCIC. */
#define BF_GPC_PGR_DRCIC(v)  ((uint32_t)((uint32_t)(v) << BP_GPC_PGR_DRCIC) & BM_GPC_PGR_DRCIC)

/*! @brief Set the DRCIC field to a new value. */
#define BW_GPC_PGR_DRCIC(x, v) (HW_GPC_PGR_WR(x, (HW_GPC_PGR_RD(x) & ~BM_GPC_PGR_DRCIC) | BF_GPC_PGR_DRCIC(v)))
/*@}*/

/*******************************************************************************
 * HW_GPC_IMR1 - IRQ masking register 1
 ******************************************************************************/

/*!
 * @brief HW_GPC_IMR1 - IRQ masking register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IMR1 Register - masking of irq[63:32].
 */
typedef union _hw_gpc_imr1
{
    uint32_t U;
    struct _hw_gpc_imr1_bitfields
    {
        uint32_t IMR1 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_imr1_t;

/*!
 * @name Constants and macros for entire GPC_IMR1 register
 */
/*@{*/
#define HW_GPC_IMR1_ADDR(x)      ((uintptr_t)(x) + 0x8U)

#define HW_GPC_IMR1(x)           (*(__IO hw_gpc_imr1_t *) HW_GPC_IMR1_ADDR(x))
#define HW_GPC_IMR1_RD(x)        (HW_GPC_IMR1(x).U)
#define HW_GPC_IMR1_WR(x, v)     (HW_GPC_IMR1(x).U = (v))
#define HW_GPC_IMR1_SET(x, v)    (HW_GPC_IMR1_WR(x, HW_GPC_IMR1_RD(x) |  (v)))
#define HW_GPC_IMR1_CLR(x, v)    (HW_GPC_IMR1_WR(x, HW_GPC_IMR1_RD(x) & ~(v)))
#define HW_GPC_IMR1_TOG(x, v)    (HW_GPC_IMR1_WR(x, HW_GPC_IMR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_IMR1 bitfields
 */

/*!
 * @name Register GPC_IMR1, field IMR1[31:0] (RW)
 *
 * IRQ[63:32] masking bits: 1-irq masked, 0-irq is not masked
 */
/*@{*/
#define BP_GPC_IMR1_IMR1     (0U)          /*!< Bit position for GPC_IMR1_IMR1. */
#define BM_GPC_IMR1_IMR1     (0xFFFFFFFFU) /*!< Bit mask for GPC_IMR1_IMR1. */
#define BS_GPC_IMR1_IMR1     (32U)         /*!< Bit field size in bits for GPC_IMR1_IMR1. */

/*! @brief Read current value of the GPC_IMR1_IMR1 field. */
#define BR_GPC_IMR1_IMR1(x)  (HW_GPC_IMR1(x).U)

/*! @brief Format value for bitfield GPC_IMR1_IMR1. */
#define BF_GPC_IMR1_IMR1(v)  ((uint32_t)((uint32_t)(v) << BP_GPC_IMR1_IMR1) & BM_GPC_IMR1_IMR1)

/*! @brief Set the IMR1 field to a new value. */
#define BW_GPC_IMR1_IMR1(x, v) (HW_GPC_IMR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPC_IMR2 - IRQ masking register 2
 ******************************************************************************/

/*!
 * @brief HW_GPC_IMR2 - IRQ masking register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IMR2 Register - masking of irq[95:64].
 */
typedef union _hw_gpc_imr2
{
    uint32_t U;
    struct _hw_gpc_imr2_bitfields
    {
        uint32_t IMR2 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_imr2_t;

/*!
 * @name Constants and macros for entire GPC_IMR2 register
 */
/*@{*/
#define HW_GPC_IMR2_ADDR(x)      ((uintptr_t)(x) + 0xCU)

#define HW_GPC_IMR2(x)           (*(__IO hw_gpc_imr2_t *) HW_GPC_IMR2_ADDR(x))
#define HW_GPC_IMR2_RD(x)        (HW_GPC_IMR2(x).U)
#define HW_GPC_IMR2_WR(x, v)     (HW_GPC_IMR2(x).U = (v))
#define HW_GPC_IMR2_SET(x, v)    (HW_GPC_IMR2_WR(x, HW_GPC_IMR2_RD(x) |  (v)))
#define HW_GPC_IMR2_CLR(x, v)    (HW_GPC_IMR2_WR(x, HW_GPC_IMR2_RD(x) & ~(v)))
#define HW_GPC_IMR2_TOG(x, v)    (HW_GPC_IMR2_WR(x, HW_GPC_IMR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_IMR2 bitfields
 */

/*!
 * @name Register GPC_IMR2, field IMR2[31:0] (RW)
 *
 * IRQ[95:64] masking bits: 1-irq masked, 0-irq is not masked
 */
/*@{*/
#define BP_GPC_IMR2_IMR2     (0U)          /*!< Bit position for GPC_IMR2_IMR2. */
#define BM_GPC_IMR2_IMR2     (0xFFFFFFFFU) /*!< Bit mask for GPC_IMR2_IMR2. */
#define BS_GPC_IMR2_IMR2     (32U)         /*!< Bit field size in bits for GPC_IMR2_IMR2. */

/*! @brief Read current value of the GPC_IMR2_IMR2 field. */
#define BR_GPC_IMR2_IMR2(x)  (HW_GPC_IMR2(x).U)

/*! @brief Format value for bitfield GPC_IMR2_IMR2. */
#define BF_GPC_IMR2_IMR2(v)  ((uint32_t)((uint32_t)(v) << BP_GPC_IMR2_IMR2) & BM_GPC_IMR2_IMR2)

/*! @brief Set the IMR2 field to a new value. */
#define BW_GPC_IMR2_IMR2(x, v) (HW_GPC_IMR2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPC_IMR3 - IRQ masking register 3
 ******************************************************************************/

/*!
 * @brief HW_GPC_IMR3 - IRQ masking register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IMR3 Register - masking of irq[127:96].
 */
typedef union _hw_gpc_imr3
{
    uint32_t U;
    struct _hw_gpc_imr3_bitfields
    {
        uint32_t IMR3 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_imr3_t;

/*!
 * @name Constants and macros for entire GPC_IMR3 register
 */
/*@{*/
#define HW_GPC_IMR3_ADDR(x)      ((uintptr_t)(x) + 0x10U)

#define HW_GPC_IMR3(x)           (*(__IO hw_gpc_imr3_t *) HW_GPC_IMR3_ADDR(x))
#define HW_GPC_IMR3_RD(x)        (HW_GPC_IMR3(x).U)
#define HW_GPC_IMR3_WR(x, v)     (HW_GPC_IMR3(x).U = (v))
#define HW_GPC_IMR3_SET(x, v)    (HW_GPC_IMR3_WR(x, HW_GPC_IMR3_RD(x) |  (v)))
#define HW_GPC_IMR3_CLR(x, v)    (HW_GPC_IMR3_WR(x, HW_GPC_IMR3_RD(x) & ~(v)))
#define HW_GPC_IMR3_TOG(x, v)    (HW_GPC_IMR3_WR(x, HW_GPC_IMR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_IMR3 bitfields
 */

/*!
 * @name Register GPC_IMR3, field IMR3[31:0] (RW)
 *
 * IRQ[127:96] masking bits: 1-irq masked, 0-irq is not masked
 */
/*@{*/
#define BP_GPC_IMR3_IMR3     (0U)          /*!< Bit position for GPC_IMR3_IMR3. */
#define BM_GPC_IMR3_IMR3     (0xFFFFFFFFU) /*!< Bit mask for GPC_IMR3_IMR3. */
#define BS_GPC_IMR3_IMR3     (32U)         /*!< Bit field size in bits for GPC_IMR3_IMR3. */

/*! @brief Read current value of the GPC_IMR3_IMR3 field. */
#define BR_GPC_IMR3_IMR3(x)  (HW_GPC_IMR3(x).U)

/*! @brief Format value for bitfield GPC_IMR3_IMR3. */
#define BF_GPC_IMR3_IMR3(v)  ((uint32_t)((uint32_t)(v) << BP_GPC_IMR3_IMR3) & BM_GPC_IMR3_IMR3)

/*! @brief Set the IMR3 field to a new value. */
#define BW_GPC_IMR3_IMR3(x, v) (HW_GPC_IMR3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPC_IMR4 - IRQ masking register 4
 ******************************************************************************/

/*!
 * @brief HW_GPC_IMR4 - IRQ masking register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IMR4 Register - masking of irq[159:128].
 */
typedef union _hw_gpc_imr4
{
    uint32_t U;
    struct _hw_gpc_imr4_bitfields
    {
        uint32_t IMR4 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_imr4_t;

/*!
 * @name Constants and macros for entire GPC_IMR4 register
 */
/*@{*/
#define HW_GPC_IMR4_ADDR(x)      ((uintptr_t)(x) + 0x14U)

#define HW_GPC_IMR4(x)           (*(__IO hw_gpc_imr4_t *) HW_GPC_IMR4_ADDR(x))
#define HW_GPC_IMR4_RD(x)        (HW_GPC_IMR4(x).U)
#define HW_GPC_IMR4_WR(x, v)     (HW_GPC_IMR4(x).U = (v))
#define HW_GPC_IMR4_SET(x, v)    (HW_GPC_IMR4_WR(x, HW_GPC_IMR4_RD(x) |  (v)))
#define HW_GPC_IMR4_CLR(x, v)    (HW_GPC_IMR4_WR(x, HW_GPC_IMR4_RD(x) & ~(v)))
#define HW_GPC_IMR4_TOG(x, v)    (HW_GPC_IMR4_WR(x, HW_GPC_IMR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPC_IMR4 bitfields
 */

/*!
 * @name Register GPC_IMR4, field IMR4[31:0] (RW)
 *
 * IRQ[159:128] masking bits: 1-irq masked, 0-irq is not masked
 */
/*@{*/
#define BP_GPC_IMR4_IMR4     (0U)          /*!< Bit position for GPC_IMR4_IMR4. */
#define BM_GPC_IMR4_IMR4     (0xFFFFFFFFU) /*!< Bit mask for GPC_IMR4_IMR4. */
#define BS_GPC_IMR4_IMR4     (32U)         /*!< Bit field size in bits for GPC_IMR4_IMR4. */

/*! @brief Read current value of the GPC_IMR4_IMR4 field. */
#define BR_GPC_IMR4_IMR4(x)  (HW_GPC_IMR4(x).U)

/*! @brief Format value for bitfield GPC_IMR4_IMR4. */
#define BF_GPC_IMR4_IMR4(v)  ((uint32_t)((uint32_t)(v) << BP_GPC_IMR4_IMR4) & BM_GPC_IMR4_IMR4)

/*! @brief Set the IMR4 field to a new value. */
#define BW_GPC_IMR4_IMR4(x, v) (HW_GPC_IMR4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPC_ISR1 - IRQ status resister 1
 ******************************************************************************/

/*!
 * @brief HW_GPC_ISR1 - IRQ status resister 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * ISR1 Register - status of irq [63:32].
 */
typedef union _hw_gpc_isr1
{
    uint32_t U;
    struct _hw_gpc_isr1_bitfields
    {
        uint32_t ISR1 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_isr1_t;

/*!
 * @name Constants and macros for entire GPC_ISR1 register
 */
/*@{*/
#define HW_GPC_ISR1_ADDR(x)      ((uintptr_t)(x) + 0x18U)

#define HW_GPC_ISR1(x)           (*(__I hw_gpc_isr1_t *) HW_GPC_ISR1_ADDR(x))
#define HW_GPC_ISR1_RD(x)        (HW_GPC_ISR1(x).U)
/*@}*/

/*
 * Constants & macros for individual GPC_ISR1 bitfields
 */

/*!
 * @name Register GPC_ISR1, field ISR1[31:0] (RO)
 *
 * IRQ[63:32] status, read only
 */
/*@{*/
#define BP_GPC_ISR1_ISR1     (0U)          /*!< Bit position for GPC_ISR1_ISR1. */
#define BM_GPC_ISR1_ISR1     (0xFFFFFFFFU) /*!< Bit mask for GPC_ISR1_ISR1. */
#define BS_GPC_ISR1_ISR1     (32U)         /*!< Bit field size in bits for GPC_ISR1_ISR1. */

/*! @brief Read current value of the GPC_ISR1_ISR1 field. */
#define BR_GPC_ISR1_ISR1(x)  (HW_GPC_ISR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPC_ISR2 - IRQ status resister 2
 ******************************************************************************/

/*!
 * @brief HW_GPC_ISR2 - IRQ status resister 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * ISR2 Register - status of irq [95:64].
 */
typedef union _hw_gpc_isr2
{
    uint32_t U;
    struct _hw_gpc_isr2_bitfields
    {
        uint32_t ISR2 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_isr2_t;

/*!
 * @name Constants and macros for entire GPC_ISR2 register
 */
/*@{*/
#define HW_GPC_ISR2_ADDR(x)      ((uintptr_t)(x) + 0x1CU)

#define HW_GPC_ISR2(x)           (*(__I hw_gpc_isr2_t *) HW_GPC_ISR2_ADDR(x))
#define HW_GPC_ISR2_RD(x)        (HW_GPC_ISR2(x).U)
/*@}*/

/*
 * Constants & macros for individual GPC_ISR2 bitfields
 */

/*!
 * @name Register GPC_ISR2, field ISR2[31:0] (RO)
 *
 * IRQ[95:64] status, read only
 */
/*@{*/
#define BP_GPC_ISR2_ISR2     (0U)          /*!< Bit position for GPC_ISR2_ISR2. */
#define BM_GPC_ISR2_ISR2     (0xFFFFFFFFU) /*!< Bit mask for GPC_ISR2_ISR2. */
#define BS_GPC_ISR2_ISR2     (32U)         /*!< Bit field size in bits for GPC_ISR2_ISR2. */

/*! @brief Read current value of the GPC_ISR2_ISR2 field. */
#define BR_GPC_ISR2_ISR2(x)  (HW_GPC_ISR2(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPC_ISR3 - IRQ status resister 3
 ******************************************************************************/

/*!
 * @brief HW_GPC_ISR3 - IRQ status resister 3 (RO)
 *
 * Reset value: 0x00000000U
 *
 * ISR3 Register - status of irq [127:96].
 */
typedef union _hw_gpc_isr3
{
    uint32_t U;
    struct _hw_gpc_isr3_bitfields
    {
        uint32_t ISR3 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_isr3_t;

/*!
 * @name Constants and macros for entire GPC_ISR3 register
 */
/*@{*/
#define HW_GPC_ISR3_ADDR(x)      ((uintptr_t)(x) + 0x20U)

#define HW_GPC_ISR3(x)           (*(__I hw_gpc_isr3_t *) HW_GPC_ISR3_ADDR(x))
#define HW_GPC_ISR3_RD(x)        (HW_GPC_ISR3(x).U)
/*@}*/

/*
 * Constants & macros for individual GPC_ISR3 bitfields
 */

/*!
 * @name Register GPC_ISR3, field ISR3[31:0] (RO)
 *
 * IRQ[127:96] status, read only
 */
/*@{*/
#define BP_GPC_ISR3_ISR3     (0U)          /*!< Bit position for GPC_ISR3_ISR3. */
#define BM_GPC_ISR3_ISR3     (0xFFFFFFFFU) /*!< Bit mask for GPC_ISR3_ISR3. */
#define BS_GPC_ISR3_ISR3     (32U)         /*!< Bit field size in bits for GPC_ISR3_ISR3. */

/*! @brief Read current value of the GPC_ISR3_ISR3 field. */
#define BR_GPC_ISR3_ISR3(x)  (HW_GPC_ISR3(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPC_ISR4 - IRQ status resister 4
 ******************************************************************************/

/*!
 * @brief HW_GPC_ISR4 - IRQ status resister 4 (RO)
 *
 * Reset value: 0x00000000U
 *
 * ISR4 Register - status of irq [159:128].
 */
typedef union _hw_gpc_isr4
{
    uint32_t U;
    struct _hw_gpc_isr4_bitfields
    {
        uint32_t ISR4 : 32;            /*!< [31:0]  */
    } B;
} hw_gpc_isr4_t;

/*!
 * @name Constants and macros for entire GPC_ISR4 register
 */
/*@{*/
#define HW_GPC_ISR4_ADDR(x)      ((uintptr_t)(x) + 0x24U)

#define HW_GPC_ISR4(x)           (*(__I hw_gpc_isr4_t *) HW_GPC_ISR4_ADDR(x))
#define HW_GPC_ISR4_RD(x)        (HW_GPC_ISR4(x).U)
/*@}*/

/*
 * Constants & macros for individual GPC_ISR4 bitfields
 */

/*!
 * @name Register GPC_ISR4, field ISR4[31:0] (RO)
 *
 * IRQ[159:128] status, read only
 */
/*@{*/
#define BP_GPC_ISR4_ISR4     (0U)          /*!< Bit position for GPC_ISR4_ISR4. */
#define BM_GPC_ISR4_ISR4     (0xFFFFFFFFU) /*!< Bit mask for GPC_ISR4_ISR4. */
#define BS_GPC_ISR4_ISR4     (32U)         /*!< Bit field size in bits for GPC_ISR4_ISR4. */

/*! @brief Read current value of the GPC_ISR4_ISR4 field. */
#define BR_GPC_ISR4_ISR4(x)  (HW_GPC_ISR4(x).U)
/*@}*/

/*******************************************************************************
 * hw_gpc_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPC module registers.
 */
#pragma pack(1)
typedef struct _hw_gpc
{
    __IO hw_gpc_cntr_t CNTR;               /*!< [0x0] GPC Interface control register */
    __IO hw_gpc_pgr_t PGR;                 /*!< [0x4] GPC Power Gating Register */
    __IO hw_gpc_imr1_t IMR1;               /*!< [0x8] IRQ masking register 1 */
    __IO hw_gpc_imr2_t IMR2;               /*!< [0xC] IRQ masking register 2 */
    __IO hw_gpc_imr3_t IMR3;               /*!< [0x10] IRQ masking register 3 */
    __IO hw_gpc_imr4_t IMR4;               /*!< [0x14] IRQ masking register 4 */
    __I hw_gpc_isr1_t ISR1;                /*!< [0x18] IRQ status resister 1 */
    __I hw_gpc_isr2_t ISR2;                /*!< [0x1C] IRQ status resister 2 */
    __I hw_gpc_isr3_t ISR3;                /*!< [0x20] IRQ status resister 3 */
    __I hw_gpc_isr4_t ISR4;                /*!< [0x24] IRQ status resister 4 */
} hw_gpc_t;
#pragma pack()

/*! @brief Macro to access all GPC registers. */
/*! @param x GPC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPC_REGS(GPC_BASE)</code>. */
#define HW_GPC_REGS(x) (*(hw_gpc_t *)(x))

/*
 * iMX6DP GPIO
 *
 * GPIO
 *
 * Registers defined in this header file:
 * - HW_GPIO_DR - GPIO data register
 * - HW_GPIO_GDIR - GPIO direction register
 * - HW_GPIO_PSR - GPIO pad status register
 * - HW_GPIO_ICR1 - GPIO interrupt configuration register1
 * - HW_GPIO_ICR2 - GPIO interrupt configuration register2
 * - HW_GPIO_IMR - GPIO interrupt mask register
 * - HW_GPIO_ISR - GPIO interrupt status register
 * - HW_GPIO_EDGE_SEL - GPIO edge select register
 *
 * - hw_gpio_t - Struct containing all module registers.
 */

#define HW_GPIO_INSTANCE_COUNT (7U) /*!< Number of instances of the GPIO module. */
#define HW_GPIO1 (0U) /*!< Instance number for GPIO1. */
#define HW_GPIO2 (1U) /*!< Instance number for GPIO2. */
#define HW_GPIO3 (2U) /*!< Instance number for GPIO3. */
#define HW_GPIO4 (3U) /*!< Instance number for GPIO4. */
#define HW_GPIO5 (4U) /*!< Instance number for GPIO5. */
#define HW_GPIO6 (5U) /*!< Instance number for GPIO6. */
#define HW_GPIO7 (6U) /*!< Instance number for GPIO7. */
#define GPIO1_BASE            (0x209C000U) /*!< Base address for GPIO1. */
#define GPIO2_BASE            (0x20A0000U) /*!< Base address for GPIO2. */
#define GPIO3_BASE            (0x20A4000U) /*!< Base address for GPIO3. */
#define GPIO4_BASE            (0x20A8000U) /*!< Base address for GPIO4. */
#define GPIO5_BASE            (0x20AC000U) /*!< Base address for GPIO5. */
#define GPIO6_BASE            (0x20B0000U) /*!< Base address for GPIO6. */
#define GPIO7_BASE            (0x20B4000U) /*!< Base address for GPIO7. */
/*! Array initializer of GPIO base addresses. */
#define GPIO_BASE_ADDRS       { GPIO1_BASE, GPIO2_BASE, GPIO3_BASE, GPIO4_BASE, GPIO5_BASE, GPIO6_BASE, GPIO7_BASE }

/*******************************************************************************
 * HW_GPIO_DR - GPIO data register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_DR - GPIO data register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The 32-bit GPIO_DR register stores data that is ready to be driven to the
 * output lines. If the IOMUXC is in GPIO mode and a given GPIO direction bit is
 * set, then the corresponding DR bit is driven to the output. If a given GPIO
 * direction bit is cleared, then a read of GPIO_DR reflects the value of the
 * corresponding signal.Two wait states are required in read access for synchronization.
 * The results of a read of a DR bit depends on the IOMUXC input mode settings
 * and the corresponding GDIR bit as follows: If GDIR[n] is set and IOMUXC input
 * mode is GPIO, then reading DR[n] returns the contents of DR[n]. If GDIR[n] is
 * cleared and IOMUXC input mode is GPIO, then reading DR[n] returns the
 * corresponding input signal's value. If GDIR[n] is set and IOMUXC input mode is not GPIO,
 * then reading DR[n] returns the contents of DR[n]. If GDIR[n] is cleared and
 * IOMUXC input mode is not GPIO, then reading DR[n] always returns zero.
 */
typedef union _hw_gpio_dr
{
    uint32_t U;
    struct _hw_gpio_dr_bitfields
    {
        uint32_t DR : 32;              /*!< [31:0]  */
    } B;
} hw_gpio_dr_t;

/*!
 * @name Constants and macros for entire GPIO_DR register
 */
/*@{*/
#define HW_GPIO_DR_ADDR(x)       ((uintptr_t)(x) + 0x0U)

#define HW_GPIO_DR(x)            (*(__IO hw_gpio_dr_t *) HW_GPIO_DR_ADDR(x))
#define HW_GPIO_DR_RD(x)         (HW_GPIO_DR(x).U)
#define HW_GPIO_DR_WR(x, v)      (HW_GPIO_DR(x).U = (v))
#define HW_GPIO_DR_SET(x, v)     (HW_GPIO_DR_WR(x, HW_GPIO_DR_RD(x) |  (v)))
#define HW_GPIO_DR_CLR(x, v)     (HW_GPIO_DR_WR(x, HW_GPIO_DR_RD(x) & ~(v)))
#define HW_GPIO_DR_TOG(x, v)     (HW_GPIO_DR_WR(x, HW_GPIO_DR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_DR bitfields
 */

/*!
 * @name Register GPIO_DR, field DR[31:0] (RW)
 *
 * Data bits. This register defines the value of the GPIO output when the signal
 * is configured as an output (GDIR[n]=1). Writes to this register are stored in
 * a register. Reading GPIO_DR returns the value stored in the register if the
 * signal is configured as an output (GDIR[n]=1), or the input signal's value if
 * configured as an input (GDIR[n]=0). The I/O multiplexer must be configured to
 * GPIO mode for the GPIO_DR value to connect with the signal. Reading the data
 * register with the input path disabled always returns a zero value.
 */
/*@{*/
#define BP_GPIO_DR_DR        (0U)          /*!< Bit position for GPIO_DR_DR. */
#define BM_GPIO_DR_DR        (0xFFFFFFFFU) /*!< Bit mask for GPIO_DR_DR. */
#define BS_GPIO_DR_DR        (32U)         /*!< Bit field size in bits for GPIO_DR_DR. */

/*! @brief Read current value of the GPIO_DR_DR field. */
#define BR_GPIO_DR_DR(x)     (HW_GPIO_DR(x).U)

/*! @brief Format value for bitfield GPIO_DR_DR. */
#define BF_GPIO_DR_DR(v)     ((uint32_t)((uint32_t)(v) << BP_GPIO_DR_DR) & BM_GPIO_DR_DR)

/*! @brief Set the DR field to a new value. */
#define BW_GPIO_DR_DR(x, v)  (HW_GPIO_DR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPIO_GDIR - GPIO direction register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_GDIR - GPIO direction register (RW)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_GDIR functions as direction control when the IOMUXC is in GPIO mode.
 * Each bit specifies the direction of a one-bit signal. The mapping of each DIR bit
 * to a corresponding SoC signal is determined by the SoC's pin assignment and
 * the IOMUX table. For more details consult the IOMUXC chapter.
 */
typedef union _hw_gpio_gdir
{
    uint32_t U;
    struct _hw_gpio_gdir_bitfields
    {
        uint32_t GDIR : 32;            /*!< [31:0]  */
    } B;
} hw_gpio_gdir_t;

/*!
 * @name Constants and macros for entire GPIO_GDIR register
 */
/*@{*/
#define HW_GPIO_GDIR_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_GPIO_GDIR(x)          (*(__IO hw_gpio_gdir_t *) HW_GPIO_GDIR_ADDR(x))
#define HW_GPIO_GDIR_RD(x)       (HW_GPIO_GDIR(x).U)
#define HW_GPIO_GDIR_WR(x, v)    (HW_GPIO_GDIR(x).U = (v))
#define HW_GPIO_GDIR_SET(x, v)   (HW_GPIO_GDIR_WR(x, HW_GPIO_GDIR_RD(x) |  (v)))
#define HW_GPIO_GDIR_CLR(x, v)   (HW_GPIO_GDIR_WR(x, HW_GPIO_GDIR_RD(x) & ~(v)))
#define HW_GPIO_GDIR_TOG(x, v)   (HW_GPIO_GDIR_WR(x, HW_GPIO_GDIR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_GDIR bitfields
 */

/*!
 * @name Register GPIO_GDIR, field GDIR[31:0] (RW)
 *
 * GPIO direction bits. Bit n of this register defines the direction of the
 * GPIO[n] signal. GPIO_GDIR affects only the direction of the I/O signal when the
 * corresponding bit in the I/O MUX is configured for GPIO.
 *
 * Values:
 * - 0 - GPIO is configured as input.
 * - 1 - GPIO is configured as output.
 */
/*@{*/
#define BP_GPIO_GDIR_GDIR    (0U)          /*!< Bit position for GPIO_GDIR_GDIR. */
#define BM_GPIO_GDIR_GDIR    (0xFFFFFFFFU) /*!< Bit mask for GPIO_GDIR_GDIR. */
#define BS_GPIO_GDIR_GDIR    (32U)         /*!< Bit field size in bits for GPIO_GDIR_GDIR. */

#define BV_GPIO_GDIR_GDIR_INPUT        (0U)          /*!< Bit field value for GPIO_GDIR_GDIR: GPIO is configured as input. */
#define BV_GPIO_GDIR_GDIR_OUTPUT       (0x1U)        /*!< Bit field value for GPIO_GDIR_GDIR: GPIO is configured as output. */

/*! @brief Read current value of the GPIO_GDIR_GDIR field. */
#define BR_GPIO_GDIR_GDIR(x) (HW_GPIO_GDIR(x).U)

/*! @brief Format value for bitfield GPIO_GDIR_GDIR. */
#define BF_GPIO_GDIR_GDIR(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_GDIR_GDIR) & BM_GPIO_GDIR_GDIR)

/*! @brief Set the GDIR field to a new value. */
#define BW_GPIO_GDIR_GDIR(x, v) (HW_GPIO_GDIR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPIO_PSR - GPIO pad status register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_PSR - GPIO pad status register (RO)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_PSR is a read-only register. Each bit stores the value of the
 * corresponding input signal (as configured in the IOMUX). This register is clocked with
 * the ipg_clk_s clock, meaning that the input signal is sampled only when
 * accessing this location. Two wait states are required any time this register is
 * accessed for synchronization.
 */
typedef union _hw_gpio_psr
{
    uint32_t U;
    struct _hw_gpio_psr_bitfields
    {
        uint32_t PSR : 32;             /*!< [31:0]  */
    } B;
} hw_gpio_psr_t;

/*!
 * @name Constants and macros for entire GPIO_PSR register
 */
/*@{*/
#define HW_GPIO_PSR_ADDR(x)      ((uintptr_t)(x) + 0x8U)

#define HW_GPIO_PSR(x)           (*(__I hw_gpio_psr_t *) HW_GPIO_PSR_ADDR(x))
#define HW_GPIO_PSR_RD(x)        (HW_GPIO_PSR(x).U)
/*@}*/

/*
 * Constants & macros for individual GPIO_PSR bitfields
 */

/*!
 * @name Register GPIO_PSR, field PSR[31:0] (RO)
 *
 * GPIO pad status bits (status bits). Reading GPIO_PSR returns the state of the
 * corresponding input signal. Settings: The IOMUXC must be configured to GPIO
 * mode for GPIO_PSR to reflect the state of the corresponding signal.
 */
/*@{*/
#define BP_GPIO_PSR_PSR      (0U)          /*!< Bit position for GPIO_PSR_PSR. */
#define BM_GPIO_PSR_PSR      (0xFFFFFFFFU) /*!< Bit mask for GPIO_PSR_PSR. */
#define BS_GPIO_PSR_PSR      (32U)         /*!< Bit field size in bits for GPIO_PSR_PSR. */

/*! @brief Read current value of the GPIO_PSR_PSR field. */
#define BR_GPIO_PSR_PSR(x)   (HW_GPIO_PSR(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPIO_ICR1 - GPIO interrupt configuration register1
 ******************************************************************************/

/*!
 * @brief HW_GPIO_ICR1 - GPIO interrupt configuration register1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_ICR1 contains 16 two-bit fields, where each field specifies the
 * interrupt configuration for a different input signal.
 */
typedef union _hw_gpio_icr1
{
    uint32_t U;
    struct _hw_gpio_icr1_bitfields
    {
        uint32_t ICR0 : 2;             /*!< [1:0]  */
        uint32_t ICR1 : 2;             /*!< [3:2]  */
        uint32_t ICR2 : 2;             /*!< [5:4]  */
        uint32_t ICR3 : 2;             /*!< [7:6]  */
        uint32_t ICR4 : 2;             /*!< [9:8]  */
        uint32_t ICR5 : 2;             /*!< [11:10]  */
        uint32_t ICR6 : 2;             /*!< [13:12]  */
        uint32_t ICR7 : 2;             /*!< [15:14]  */
        uint32_t ICR8 : 2;             /*!< [17:16]  */
        uint32_t ICR9 : 2;             /*!< [19:18]  */
        uint32_t ICR10 : 2;            /*!< [21:20]  */
        uint32_t ICR11 : 2;            /*!< [23:22]  */
        uint32_t ICR12 : 2;            /*!< [25:24]  */
        uint32_t ICR13 : 2;            /*!< [27:26]  */
        uint32_t ICR14 : 2;            /*!< [29:28]  */
        uint32_t ICR15 : 2;            /*!< [31:30]  */
    } B;
} hw_gpio_icr1_t;

/*!
 * @name Constants and macros for entire GPIO_ICR1 register
 */
/*@{*/
#define HW_GPIO_ICR1_ADDR(x)     ((uintptr_t)(x) + 0xCU)

#define HW_GPIO_ICR1(x)          (*(__IO hw_gpio_icr1_t *) HW_GPIO_ICR1_ADDR(x))
#define HW_GPIO_ICR1_RD(x)       (HW_GPIO_ICR1(x).U)
#define HW_GPIO_ICR1_WR(x, v)    (HW_GPIO_ICR1(x).U = (v))
#define HW_GPIO_ICR1_SET(x, v)   (HW_GPIO_ICR1_WR(x, HW_GPIO_ICR1_RD(x) |  (v)))
#define HW_GPIO_ICR1_CLR(x, v)   (HW_GPIO_ICR1_WR(x, HW_GPIO_ICR1_RD(x) & ~(v)))
#define HW_GPIO_ICR1_TOG(x, v)   (HW_GPIO_ICR1_WR(x, HW_GPIO_ICR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_ICR1 bitfields
 */

/*!
 * @name Register GPIO_ICR1, field ICR0[1:0] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 0. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR0    (0U)          /*!< Bit position for GPIO_ICR1_ICR0. */
#define BM_GPIO_ICR1_ICR0    (0x00000003U) /*!< Bit mask for GPIO_ICR1_ICR0. */
#define BS_GPIO_ICR1_ICR0    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR0. */

#define BV_GPIO_ICR1_ICR0_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR0: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR0_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR0: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR0_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR0: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR0_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR0: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR0 field. */
#define BR_GPIO_ICR1_ICR0(x) (HW_GPIO_ICR1(x).B.ICR0)

/*! @brief Format value for bitfield GPIO_ICR1_ICR0. */
#define BF_GPIO_ICR1_ICR0(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR0) & BM_GPIO_ICR1_ICR0)

/*! @brief Set the ICR0 field to a new value. */
#define BW_GPIO_ICR1_ICR0(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR0) | BF_GPIO_ICR1_ICR0(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR1[3:2] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 1. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR1    (2U)          /*!< Bit position for GPIO_ICR1_ICR1. */
#define BM_GPIO_ICR1_ICR1    (0x0000000CU) /*!< Bit mask for GPIO_ICR1_ICR1. */
#define BS_GPIO_ICR1_ICR1    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR1. */

#define BV_GPIO_ICR1_ICR1_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR1: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR1_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR1: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR1_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR1: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR1_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR1: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR1 field. */
#define BR_GPIO_ICR1_ICR1(x) (HW_GPIO_ICR1(x).B.ICR1)

/*! @brief Format value for bitfield GPIO_ICR1_ICR1. */
#define BF_GPIO_ICR1_ICR1(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR1) & BM_GPIO_ICR1_ICR1)

/*! @brief Set the ICR1 field to a new value. */
#define BW_GPIO_ICR1_ICR1(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR1) | BF_GPIO_ICR1_ICR1(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR2[5:4] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 2. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR2    (4U)          /*!< Bit position for GPIO_ICR1_ICR2. */
#define BM_GPIO_ICR1_ICR2    (0x00000030U) /*!< Bit mask for GPIO_ICR1_ICR2. */
#define BS_GPIO_ICR1_ICR2    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR2. */

#define BV_GPIO_ICR1_ICR2_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR2: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR2_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR2: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR2_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR2: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR2_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR2: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR2 field. */
#define BR_GPIO_ICR1_ICR2(x) (HW_GPIO_ICR1(x).B.ICR2)

/*! @brief Format value for bitfield GPIO_ICR1_ICR2. */
#define BF_GPIO_ICR1_ICR2(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR2) & BM_GPIO_ICR1_ICR2)

/*! @brief Set the ICR2 field to a new value. */
#define BW_GPIO_ICR1_ICR2(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR2) | BF_GPIO_ICR1_ICR2(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR3[7:6] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 3. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR3    (6U)          /*!< Bit position for GPIO_ICR1_ICR3. */
#define BM_GPIO_ICR1_ICR3    (0x000000C0U) /*!< Bit mask for GPIO_ICR1_ICR3. */
#define BS_GPIO_ICR1_ICR3    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR3. */

#define BV_GPIO_ICR1_ICR3_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR3: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR3_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR3: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR3_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR3: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR3_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR3: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR3 field. */
#define BR_GPIO_ICR1_ICR3(x) (HW_GPIO_ICR1(x).B.ICR3)

/*! @brief Format value for bitfield GPIO_ICR1_ICR3. */
#define BF_GPIO_ICR1_ICR3(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR3) & BM_GPIO_ICR1_ICR3)

/*! @brief Set the ICR3 field to a new value. */
#define BW_GPIO_ICR1_ICR3(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR3) | BF_GPIO_ICR1_ICR3(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR4[9:8] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 4. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR4    (8U)          /*!< Bit position for GPIO_ICR1_ICR4. */
#define BM_GPIO_ICR1_ICR4    (0x00000300U) /*!< Bit mask for GPIO_ICR1_ICR4. */
#define BS_GPIO_ICR1_ICR4    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR4. */

#define BV_GPIO_ICR1_ICR4_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR4: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR4_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR4: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR4_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR4: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR4_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR4: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR4 field. */
#define BR_GPIO_ICR1_ICR4(x) (HW_GPIO_ICR1(x).B.ICR4)

/*! @brief Format value for bitfield GPIO_ICR1_ICR4. */
#define BF_GPIO_ICR1_ICR4(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR4) & BM_GPIO_ICR1_ICR4)

/*! @brief Set the ICR4 field to a new value. */
#define BW_GPIO_ICR1_ICR4(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR4) | BF_GPIO_ICR1_ICR4(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR5[11:10] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 5. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR5    (10U)         /*!< Bit position for GPIO_ICR1_ICR5. */
#define BM_GPIO_ICR1_ICR5    (0x00000C00U) /*!< Bit mask for GPIO_ICR1_ICR5. */
#define BS_GPIO_ICR1_ICR5    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR5. */

#define BV_GPIO_ICR1_ICR5_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR5: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR5_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR5: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR5_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR5: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR5_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR5: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR5 field. */
#define BR_GPIO_ICR1_ICR5(x) (HW_GPIO_ICR1(x).B.ICR5)

/*! @brief Format value for bitfield GPIO_ICR1_ICR5. */
#define BF_GPIO_ICR1_ICR5(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR5) & BM_GPIO_ICR1_ICR5)

/*! @brief Set the ICR5 field to a new value. */
#define BW_GPIO_ICR1_ICR5(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR5) | BF_GPIO_ICR1_ICR5(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR6[13:12] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 6. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR6    (12U)         /*!< Bit position for GPIO_ICR1_ICR6. */
#define BM_GPIO_ICR1_ICR6    (0x00003000U) /*!< Bit mask for GPIO_ICR1_ICR6. */
#define BS_GPIO_ICR1_ICR6    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR6. */

#define BV_GPIO_ICR1_ICR6_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR6: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR6_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR6: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR6_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR6: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR6_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR6: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR6 field. */
#define BR_GPIO_ICR1_ICR6(x) (HW_GPIO_ICR1(x).B.ICR6)

/*! @brief Format value for bitfield GPIO_ICR1_ICR6. */
#define BF_GPIO_ICR1_ICR6(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR6) & BM_GPIO_ICR1_ICR6)

/*! @brief Set the ICR6 field to a new value. */
#define BW_GPIO_ICR1_ICR6(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR6) | BF_GPIO_ICR1_ICR6(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR7[15:14] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 7. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR7    (14U)         /*!< Bit position for GPIO_ICR1_ICR7. */
#define BM_GPIO_ICR1_ICR7    (0x0000C000U) /*!< Bit mask for GPIO_ICR1_ICR7. */
#define BS_GPIO_ICR1_ICR7    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR7. */

#define BV_GPIO_ICR1_ICR7_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR7: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR7_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR7: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR7_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR7: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR7_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR7: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR7 field. */
#define BR_GPIO_ICR1_ICR7(x) (HW_GPIO_ICR1(x).B.ICR7)

/*! @brief Format value for bitfield GPIO_ICR1_ICR7. */
#define BF_GPIO_ICR1_ICR7(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR7) & BM_GPIO_ICR1_ICR7)

/*! @brief Set the ICR7 field to a new value. */
#define BW_GPIO_ICR1_ICR7(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR7) | BF_GPIO_ICR1_ICR7(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR8[17:16] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 8. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR8    (16U)         /*!< Bit position for GPIO_ICR1_ICR8. */
#define BM_GPIO_ICR1_ICR8    (0x00030000U) /*!< Bit mask for GPIO_ICR1_ICR8. */
#define BS_GPIO_ICR1_ICR8    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR8. */

#define BV_GPIO_ICR1_ICR8_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR8: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR8_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR8: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR8_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR8: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR8_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR8: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR8 field. */
#define BR_GPIO_ICR1_ICR8(x) (HW_GPIO_ICR1(x).B.ICR8)

/*! @brief Format value for bitfield GPIO_ICR1_ICR8. */
#define BF_GPIO_ICR1_ICR8(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR8) & BM_GPIO_ICR1_ICR8)

/*! @brief Set the ICR8 field to a new value. */
#define BW_GPIO_ICR1_ICR8(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR8) | BF_GPIO_ICR1_ICR8(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR9[19:18] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 9. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR9    (18U)         /*!< Bit position for GPIO_ICR1_ICR9. */
#define BM_GPIO_ICR1_ICR9    (0x000C0000U) /*!< Bit mask for GPIO_ICR1_ICR9. */
#define BS_GPIO_ICR1_ICR9    (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR9. */

#define BV_GPIO_ICR1_ICR9_LOW_LEVEL    (0U)          /*!< Bit field value for GPIO_ICR1_ICR9: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR9_HIGH_LEVEL   (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR9: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR9_RISING_EDGE  (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR9: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR9_FALLING_EDGE (0x3U)        /*!< Bit field value for GPIO_ICR1_ICR9: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR9 field. */
#define BR_GPIO_ICR1_ICR9(x) (HW_GPIO_ICR1(x).B.ICR9)

/*! @brief Format value for bitfield GPIO_ICR1_ICR9. */
#define BF_GPIO_ICR1_ICR9(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR9) & BM_GPIO_ICR1_ICR9)

/*! @brief Set the ICR9 field to a new value. */
#define BW_GPIO_ICR1_ICR9(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR9) | BF_GPIO_ICR1_ICR9(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR10[21:20] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 10. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR10   (20U)         /*!< Bit position for GPIO_ICR1_ICR10. */
#define BM_GPIO_ICR1_ICR10   (0x00300000U) /*!< Bit mask for GPIO_ICR1_ICR10. */
#define BS_GPIO_ICR1_ICR10   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR10. */

#define BV_GPIO_ICR1_ICR10_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR10: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR10_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR10: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR10_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR10: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR10_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR10: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR10 field. */
#define BR_GPIO_ICR1_ICR10(x) (HW_GPIO_ICR1(x).B.ICR10)

/*! @brief Format value for bitfield GPIO_ICR1_ICR10. */
#define BF_GPIO_ICR1_ICR10(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR10) & BM_GPIO_ICR1_ICR10)

/*! @brief Set the ICR10 field to a new value. */
#define BW_GPIO_ICR1_ICR10(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR10) | BF_GPIO_ICR1_ICR10(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR11[23:22] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 11. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR11   (22U)         /*!< Bit position for GPIO_ICR1_ICR11. */
#define BM_GPIO_ICR1_ICR11   (0x00C00000U) /*!< Bit mask for GPIO_ICR1_ICR11. */
#define BS_GPIO_ICR1_ICR11   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR11. */

#define BV_GPIO_ICR1_ICR11_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR11: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR11_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR11: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR11_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR11: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR11_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR11: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR11 field. */
#define BR_GPIO_ICR1_ICR11(x) (HW_GPIO_ICR1(x).B.ICR11)

/*! @brief Format value for bitfield GPIO_ICR1_ICR11. */
#define BF_GPIO_ICR1_ICR11(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR11) & BM_GPIO_ICR1_ICR11)

/*! @brief Set the ICR11 field to a new value. */
#define BW_GPIO_ICR1_ICR11(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR11) | BF_GPIO_ICR1_ICR11(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR12[25:24] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 12. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR12   (24U)         /*!< Bit position for GPIO_ICR1_ICR12. */
#define BM_GPIO_ICR1_ICR12   (0x03000000U) /*!< Bit mask for GPIO_ICR1_ICR12. */
#define BS_GPIO_ICR1_ICR12   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR12. */

#define BV_GPIO_ICR1_ICR12_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR12: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR12_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR12: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR12_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR12: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR12_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR12: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR12 field. */
#define BR_GPIO_ICR1_ICR12(x) (HW_GPIO_ICR1(x).B.ICR12)

/*! @brief Format value for bitfield GPIO_ICR1_ICR12. */
#define BF_GPIO_ICR1_ICR12(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR12) & BM_GPIO_ICR1_ICR12)

/*! @brief Set the ICR12 field to a new value. */
#define BW_GPIO_ICR1_ICR12(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR12) | BF_GPIO_ICR1_ICR12(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR13[27:26] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 13. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR13   (26U)         /*!< Bit position for GPIO_ICR1_ICR13. */
#define BM_GPIO_ICR1_ICR13   (0x0C000000U) /*!< Bit mask for GPIO_ICR1_ICR13. */
#define BS_GPIO_ICR1_ICR13   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR13. */

#define BV_GPIO_ICR1_ICR13_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR13: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR13_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR13: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR13_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR13: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR13_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR13: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR13 field. */
#define BR_GPIO_ICR1_ICR13(x) (HW_GPIO_ICR1(x).B.ICR13)

/*! @brief Format value for bitfield GPIO_ICR1_ICR13. */
#define BF_GPIO_ICR1_ICR13(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR13) & BM_GPIO_ICR1_ICR13)

/*! @brief Set the ICR13 field to a new value. */
#define BW_GPIO_ICR1_ICR13(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR13) | BF_GPIO_ICR1_ICR13(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR14[29:28] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 14. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR14   (28U)         /*!< Bit position for GPIO_ICR1_ICR14. */
#define BM_GPIO_ICR1_ICR14   (0x30000000U) /*!< Bit mask for GPIO_ICR1_ICR14. */
#define BS_GPIO_ICR1_ICR14   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR14. */

#define BV_GPIO_ICR1_ICR14_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR14: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR14_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR14: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR14_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR14: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR14_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR14: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR14 field. */
#define BR_GPIO_ICR1_ICR14(x) (HW_GPIO_ICR1(x).B.ICR14)

/*! @brief Format value for bitfield GPIO_ICR1_ICR14. */
#define BF_GPIO_ICR1_ICR14(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR14) & BM_GPIO_ICR1_ICR14)

/*! @brief Set the ICR14 field to a new value. */
#define BW_GPIO_ICR1_ICR14(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR14) | BF_GPIO_ICR1_ICR14(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR1, field ICR15[31:30] (RW)
 *
 * Interrupt configuration 1 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 15. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR1_ICR15   (30U)         /*!< Bit position for GPIO_ICR1_ICR15. */
#define BM_GPIO_ICR1_ICR15   (0xC0000000U) /*!< Bit mask for GPIO_ICR1_ICR15. */
#define BS_GPIO_ICR1_ICR15   (2U)          /*!< Bit field size in bits for GPIO_ICR1_ICR15. */

#define BV_GPIO_ICR1_ICR15_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR1_ICR15: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR1_ICR15_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR1_ICR15: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR1_ICR15_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR1_ICR15: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR1_ICR15_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR1_ICR15: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR1_ICR15 field. */
#define BR_GPIO_ICR1_ICR15(x) (HW_GPIO_ICR1(x).B.ICR15)

/*! @brief Format value for bitfield GPIO_ICR1_ICR15. */
#define BF_GPIO_ICR1_ICR15(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR1_ICR15) & BM_GPIO_ICR1_ICR15)

/*! @brief Set the ICR15 field to a new value. */
#define BW_GPIO_ICR1_ICR15(x, v) (HW_GPIO_ICR1_WR(x, (HW_GPIO_ICR1_RD(x) & ~BM_GPIO_ICR1_ICR15) | BF_GPIO_ICR1_ICR15(v)))
/*@}*/

/*******************************************************************************
 * HW_GPIO_ICR2 - GPIO interrupt configuration register2
 ******************************************************************************/

/*!
 * @brief HW_GPIO_ICR2 - GPIO interrupt configuration register2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_ICR2 contains 16 two-bit fields, where each field specifies the
 * interrupt configuration for a different input signal.
 */
typedef union _hw_gpio_icr2
{
    uint32_t U;
    struct _hw_gpio_icr2_bitfields
    {
        uint32_t ICR16 : 2;            /*!< [1:0]  */
        uint32_t ICR17 : 2;            /*!< [3:2]  */
        uint32_t ICR18 : 2;            /*!< [5:4]  */
        uint32_t ICR19 : 2;            /*!< [7:6]  */
        uint32_t ICR20 : 2;            /*!< [9:8]  */
        uint32_t ICR21 : 2;            /*!< [11:10]  */
        uint32_t ICR22 : 2;            /*!< [13:12]  */
        uint32_t ICR23 : 2;            /*!< [15:14]  */
        uint32_t ICR24 : 2;            /*!< [17:16]  */
        uint32_t ICR25 : 2;            /*!< [19:18]  */
        uint32_t ICR26 : 2;            /*!< [21:20]  */
        uint32_t ICR27 : 2;            /*!< [23:22]  */
        uint32_t ICR28 : 2;            /*!< [25:24]  */
        uint32_t ICR29 : 2;            /*!< [27:26]  */
        uint32_t ICR30 : 2;            /*!< [29:28]  */
        uint32_t ICR31 : 2;            /*!< [31:30]  */
    } B;
} hw_gpio_icr2_t;

/*!
 * @name Constants and macros for entire GPIO_ICR2 register
 */
/*@{*/
#define HW_GPIO_ICR2_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_GPIO_ICR2(x)          (*(__IO hw_gpio_icr2_t *) HW_GPIO_ICR2_ADDR(x))
#define HW_GPIO_ICR2_RD(x)       (HW_GPIO_ICR2(x).U)
#define HW_GPIO_ICR2_WR(x, v)    (HW_GPIO_ICR2(x).U = (v))
#define HW_GPIO_ICR2_SET(x, v)   (HW_GPIO_ICR2_WR(x, HW_GPIO_ICR2_RD(x) |  (v)))
#define HW_GPIO_ICR2_CLR(x, v)   (HW_GPIO_ICR2_WR(x, HW_GPIO_ICR2_RD(x) & ~(v)))
#define HW_GPIO_ICR2_TOG(x, v)   (HW_GPIO_ICR2_WR(x, HW_GPIO_ICR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_ICR2 bitfields
 */

/*!
 * @name Register GPIO_ICR2, field ICR16[1:0] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 16. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR16   (0U)          /*!< Bit position for GPIO_ICR2_ICR16. */
#define BM_GPIO_ICR2_ICR16   (0x00000003U) /*!< Bit mask for GPIO_ICR2_ICR16. */
#define BS_GPIO_ICR2_ICR16   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR16. */

#define BV_GPIO_ICR2_ICR16_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR16: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR16_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR16: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR16_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR16: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR16_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR16: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR16 field. */
#define BR_GPIO_ICR2_ICR16(x) (HW_GPIO_ICR2(x).B.ICR16)

/*! @brief Format value for bitfield GPIO_ICR2_ICR16. */
#define BF_GPIO_ICR2_ICR16(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR16) & BM_GPIO_ICR2_ICR16)

/*! @brief Set the ICR16 field to a new value. */
#define BW_GPIO_ICR2_ICR16(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR16) | BF_GPIO_ICR2_ICR16(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR17[3:2] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 17. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR17   (2U)          /*!< Bit position for GPIO_ICR2_ICR17. */
#define BM_GPIO_ICR2_ICR17   (0x0000000CU) /*!< Bit mask for GPIO_ICR2_ICR17. */
#define BS_GPIO_ICR2_ICR17   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR17. */

#define BV_GPIO_ICR2_ICR17_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR17: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR17_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR17: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR17_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR17: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR17_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR17: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR17 field. */
#define BR_GPIO_ICR2_ICR17(x) (HW_GPIO_ICR2(x).B.ICR17)

/*! @brief Format value for bitfield GPIO_ICR2_ICR17. */
#define BF_GPIO_ICR2_ICR17(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR17) & BM_GPIO_ICR2_ICR17)

/*! @brief Set the ICR17 field to a new value. */
#define BW_GPIO_ICR2_ICR17(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR17) | BF_GPIO_ICR2_ICR17(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR18[5:4] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 18. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR18   (4U)          /*!< Bit position for GPIO_ICR2_ICR18. */
#define BM_GPIO_ICR2_ICR18   (0x00000030U) /*!< Bit mask for GPIO_ICR2_ICR18. */
#define BS_GPIO_ICR2_ICR18   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR18. */

#define BV_GPIO_ICR2_ICR18_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR18: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR18_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR18: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR18_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR18: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR18_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR18: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR18 field. */
#define BR_GPIO_ICR2_ICR18(x) (HW_GPIO_ICR2(x).B.ICR18)

/*! @brief Format value for bitfield GPIO_ICR2_ICR18. */
#define BF_GPIO_ICR2_ICR18(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR18) & BM_GPIO_ICR2_ICR18)

/*! @brief Set the ICR18 field to a new value. */
#define BW_GPIO_ICR2_ICR18(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR18) | BF_GPIO_ICR2_ICR18(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR19[7:6] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 19. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR19   (6U)          /*!< Bit position for GPIO_ICR2_ICR19. */
#define BM_GPIO_ICR2_ICR19   (0x000000C0U) /*!< Bit mask for GPIO_ICR2_ICR19. */
#define BS_GPIO_ICR2_ICR19   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR19. */

#define BV_GPIO_ICR2_ICR19_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR19: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR19_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR19: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR19_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR19: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR19_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR19: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR19 field. */
#define BR_GPIO_ICR2_ICR19(x) (HW_GPIO_ICR2(x).B.ICR19)

/*! @brief Format value for bitfield GPIO_ICR2_ICR19. */
#define BF_GPIO_ICR2_ICR19(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR19) & BM_GPIO_ICR2_ICR19)

/*! @brief Set the ICR19 field to a new value. */
#define BW_GPIO_ICR2_ICR19(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR19) | BF_GPIO_ICR2_ICR19(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR20[9:8] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 20. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR20   (8U)          /*!< Bit position for GPIO_ICR2_ICR20. */
#define BM_GPIO_ICR2_ICR20   (0x00000300U) /*!< Bit mask for GPIO_ICR2_ICR20. */
#define BS_GPIO_ICR2_ICR20   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR20. */

#define BV_GPIO_ICR2_ICR20_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR20: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR20_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR20: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR20_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR20: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR20_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR20: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR20 field. */
#define BR_GPIO_ICR2_ICR20(x) (HW_GPIO_ICR2(x).B.ICR20)

/*! @brief Format value for bitfield GPIO_ICR2_ICR20. */
#define BF_GPIO_ICR2_ICR20(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR20) & BM_GPIO_ICR2_ICR20)

/*! @brief Set the ICR20 field to a new value. */
#define BW_GPIO_ICR2_ICR20(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR20) | BF_GPIO_ICR2_ICR20(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR21[11:10] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 21. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR21   (10U)         /*!< Bit position for GPIO_ICR2_ICR21. */
#define BM_GPIO_ICR2_ICR21   (0x00000C00U) /*!< Bit mask for GPIO_ICR2_ICR21. */
#define BS_GPIO_ICR2_ICR21   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR21. */

#define BV_GPIO_ICR2_ICR21_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR21: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR21_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR21: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR21_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR21: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR21_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR21: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR21 field. */
#define BR_GPIO_ICR2_ICR21(x) (HW_GPIO_ICR2(x).B.ICR21)

/*! @brief Format value for bitfield GPIO_ICR2_ICR21. */
#define BF_GPIO_ICR2_ICR21(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR21) & BM_GPIO_ICR2_ICR21)

/*! @brief Set the ICR21 field to a new value. */
#define BW_GPIO_ICR2_ICR21(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR21) | BF_GPIO_ICR2_ICR21(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR22[13:12] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 22. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR22   (12U)         /*!< Bit position for GPIO_ICR2_ICR22. */
#define BM_GPIO_ICR2_ICR22   (0x00003000U) /*!< Bit mask for GPIO_ICR2_ICR22. */
#define BS_GPIO_ICR2_ICR22   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR22. */

#define BV_GPIO_ICR2_ICR22_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR22: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR22_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR22: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR22_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR22: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR22_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR22: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR22 field. */
#define BR_GPIO_ICR2_ICR22(x) (HW_GPIO_ICR2(x).B.ICR22)

/*! @brief Format value for bitfield GPIO_ICR2_ICR22. */
#define BF_GPIO_ICR2_ICR22(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR22) & BM_GPIO_ICR2_ICR22)

/*! @brief Set the ICR22 field to a new value. */
#define BW_GPIO_ICR2_ICR22(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR22) | BF_GPIO_ICR2_ICR22(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR23[15:14] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 23. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR23   (14U)         /*!< Bit position for GPIO_ICR2_ICR23. */
#define BM_GPIO_ICR2_ICR23   (0x0000C000U) /*!< Bit mask for GPIO_ICR2_ICR23. */
#define BS_GPIO_ICR2_ICR23   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR23. */

#define BV_GPIO_ICR2_ICR23_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR23: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR23_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR23: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR23_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR23: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR23_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR23: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR23 field. */
#define BR_GPIO_ICR2_ICR23(x) (HW_GPIO_ICR2(x).B.ICR23)

/*! @brief Format value for bitfield GPIO_ICR2_ICR23. */
#define BF_GPIO_ICR2_ICR23(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR23) & BM_GPIO_ICR2_ICR23)

/*! @brief Set the ICR23 field to a new value. */
#define BW_GPIO_ICR2_ICR23(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR23) | BF_GPIO_ICR2_ICR23(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR24[17:16] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 24. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR24   (16U)         /*!< Bit position for GPIO_ICR2_ICR24. */
#define BM_GPIO_ICR2_ICR24   (0x00030000U) /*!< Bit mask for GPIO_ICR2_ICR24. */
#define BS_GPIO_ICR2_ICR24   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR24. */

#define BV_GPIO_ICR2_ICR24_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR24: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR24_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR24: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR24_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR24: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR24_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR24: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR24 field. */
#define BR_GPIO_ICR2_ICR24(x) (HW_GPIO_ICR2(x).B.ICR24)

/*! @brief Format value for bitfield GPIO_ICR2_ICR24. */
#define BF_GPIO_ICR2_ICR24(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR24) & BM_GPIO_ICR2_ICR24)

/*! @brief Set the ICR24 field to a new value. */
#define BW_GPIO_ICR2_ICR24(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR24) | BF_GPIO_ICR2_ICR24(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR25[19:18] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 25. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR25   (18U)         /*!< Bit position for GPIO_ICR2_ICR25. */
#define BM_GPIO_ICR2_ICR25   (0x000C0000U) /*!< Bit mask for GPIO_ICR2_ICR25. */
#define BS_GPIO_ICR2_ICR25   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR25. */

#define BV_GPIO_ICR2_ICR25_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR25: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR25_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR25: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR25_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR25: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR25_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR25: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR25 field. */
#define BR_GPIO_ICR2_ICR25(x) (HW_GPIO_ICR2(x).B.ICR25)

/*! @brief Format value for bitfield GPIO_ICR2_ICR25. */
#define BF_GPIO_ICR2_ICR25(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR25) & BM_GPIO_ICR2_ICR25)

/*! @brief Set the ICR25 field to a new value. */
#define BW_GPIO_ICR2_ICR25(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR25) | BF_GPIO_ICR2_ICR25(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR26[21:20] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 26. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR26   (20U)         /*!< Bit position for GPIO_ICR2_ICR26. */
#define BM_GPIO_ICR2_ICR26   (0x00300000U) /*!< Bit mask for GPIO_ICR2_ICR26. */
#define BS_GPIO_ICR2_ICR26   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR26. */

#define BV_GPIO_ICR2_ICR26_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR26: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR26_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR26: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR26_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR26: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR26_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR26: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR26 field. */
#define BR_GPIO_ICR2_ICR26(x) (HW_GPIO_ICR2(x).B.ICR26)

/*! @brief Format value for bitfield GPIO_ICR2_ICR26. */
#define BF_GPIO_ICR2_ICR26(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR26) & BM_GPIO_ICR2_ICR26)

/*! @brief Set the ICR26 field to a new value. */
#define BW_GPIO_ICR2_ICR26(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR26) | BF_GPIO_ICR2_ICR26(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR27[23:22] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 27. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR27   (22U)         /*!< Bit position for GPIO_ICR2_ICR27. */
#define BM_GPIO_ICR2_ICR27   (0x00C00000U) /*!< Bit mask for GPIO_ICR2_ICR27. */
#define BS_GPIO_ICR2_ICR27   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR27. */

#define BV_GPIO_ICR2_ICR27_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR27: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR27_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR27: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR27_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR27: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR27_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR27: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR27 field. */
#define BR_GPIO_ICR2_ICR27(x) (HW_GPIO_ICR2(x).B.ICR27)

/*! @brief Format value for bitfield GPIO_ICR2_ICR27. */
#define BF_GPIO_ICR2_ICR27(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR27) & BM_GPIO_ICR2_ICR27)

/*! @brief Set the ICR27 field to a new value. */
#define BW_GPIO_ICR2_ICR27(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR27) | BF_GPIO_ICR2_ICR27(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR28[25:24] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 28. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR28   (24U)         /*!< Bit position for GPIO_ICR2_ICR28. */
#define BM_GPIO_ICR2_ICR28   (0x03000000U) /*!< Bit mask for GPIO_ICR2_ICR28. */
#define BS_GPIO_ICR2_ICR28   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR28. */

#define BV_GPIO_ICR2_ICR28_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR28: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR28_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR28: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR28_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR28: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR28_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR28: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR28 field. */
#define BR_GPIO_ICR2_ICR28(x) (HW_GPIO_ICR2(x).B.ICR28)

/*! @brief Format value for bitfield GPIO_ICR2_ICR28. */
#define BF_GPIO_ICR2_ICR28(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR28) & BM_GPIO_ICR2_ICR28)

/*! @brief Set the ICR28 field to a new value. */
#define BW_GPIO_ICR2_ICR28(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR28) | BF_GPIO_ICR2_ICR28(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR29[27:26] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 29. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR29   (26U)         /*!< Bit position for GPIO_ICR2_ICR29. */
#define BM_GPIO_ICR2_ICR29   (0x0C000000U) /*!< Bit mask for GPIO_ICR2_ICR29. */
#define BS_GPIO_ICR2_ICR29   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR29. */

#define BV_GPIO_ICR2_ICR29_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR29: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR29_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR29: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR29_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR29: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR29_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR29: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR29 field. */
#define BR_GPIO_ICR2_ICR29(x) (HW_GPIO_ICR2(x).B.ICR29)

/*! @brief Format value for bitfield GPIO_ICR2_ICR29. */
#define BF_GPIO_ICR2_ICR29(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR29) & BM_GPIO_ICR2_ICR29)

/*! @brief Set the ICR29 field to a new value. */
#define BW_GPIO_ICR2_ICR29(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR29) | BF_GPIO_ICR2_ICR29(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR30[29:28] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 30. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR30   (28U)         /*!< Bit position for GPIO_ICR2_ICR30. */
#define BM_GPIO_ICR2_ICR30   (0x30000000U) /*!< Bit mask for GPIO_ICR2_ICR30. */
#define BS_GPIO_ICR2_ICR30   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR30. */

#define BV_GPIO_ICR2_ICR30_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR30: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR30_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR30: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR30_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR30: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR30_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR30: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR30 field. */
#define BR_GPIO_ICR2_ICR30(x) (HW_GPIO_ICR2(x).B.ICR30)

/*! @brief Format value for bitfield GPIO_ICR2_ICR30. */
#define BF_GPIO_ICR2_ICR30(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR30) & BM_GPIO_ICR2_ICR30)

/*! @brief Set the ICR30 field to a new value. */
#define BW_GPIO_ICR2_ICR30(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR30) | BF_GPIO_ICR2_ICR30(v)))
/*@}*/

/*!
 * @name Register GPIO_ICR2, field ICR31[31:30] (RW)
 *
 * Interrupt configuration 2 fields. This register controls the active condition
 * of the interrupt function for GPIO interrupt 31. Settings: Bits ICRn[1:0]
 * determine the interrupt condition for signal n as follows:
 *
 * Values:
 * - 00 - Interrupt n is low-level sensitive.
 * - 01 - Interrupt n is high-level sensitive.
 * - 10 - Interrupt n is rising-edge sensitive.
 * - 11 - Interrupt n is falling-edge sensitive.
 */
/*@{*/
#define BP_GPIO_ICR2_ICR31   (30U)         /*!< Bit position for GPIO_ICR2_ICR31. */
#define BM_GPIO_ICR2_ICR31   (0xC0000000U) /*!< Bit mask for GPIO_ICR2_ICR31. */
#define BS_GPIO_ICR2_ICR31   (2U)          /*!< Bit field size in bits for GPIO_ICR2_ICR31. */

#define BV_GPIO_ICR2_ICR31_LOW_LEVEL   (0U)          /*!< Bit field value for GPIO_ICR2_ICR31: Interrupt n is low-level sensitive. */
#define BV_GPIO_ICR2_ICR31_HIGH_LEVEL  (0x1U)        /*!< Bit field value for GPIO_ICR2_ICR31: Interrupt n is high-level sensitive. */
#define BV_GPIO_ICR2_ICR31_RISING_EDGE (0x2U)        /*!< Bit field value for GPIO_ICR2_ICR31: Interrupt n is rising-edge sensitive. */
#define BV_GPIO_ICR2_ICR31_FALLING_EDGE (0x3U)       /*!< Bit field value for GPIO_ICR2_ICR31: Interrupt n is falling-edge sensitive. */

/*! @brief Read current value of the GPIO_ICR2_ICR31 field. */
#define BR_GPIO_ICR2_ICR31(x) (HW_GPIO_ICR2(x).B.ICR31)

/*! @brief Format value for bitfield GPIO_ICR2_ICR31. */
#define BF_GPIO_ICR2_ICR31(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_ICR2_ICR31) & BM_GPIO_ICR2_ICR31)

/*! @brief Set the ICR31 field to a new value. */
#define BW_GPIO_ICR2_ICR31(x, v) (HW_GPIO_ICR2_WR(x, (HW_GPIO_ICR2_RD(x) & ~BM_GPIO_ICR2_ICR31) | BF_GPIO_ICR2_ICR31(v)))
/*@}*/

/*******************************************************************************
 * HW_GPIO_IMR - GPIO interrupt mask register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_IMR - GPIO interrupt mask register (RW)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_IMR contains masking bits for each interrupt line.
 */
typedef union _hw_gpio_imr
{
    uint32_t U;
    struct _hw_gpio_imr_bitfields
    {
        uint32_t IMR : 32;             /*!< [31:0]  */
    } B;
} hw_gpio_imr_t;

/*!
 * @name Constants and macros for entire GPIO_IMR register
 */
/*@{*/
#define HW_GPIO_IMR_ADDR(x)      ((uintptr_t)(x) + 0x14U)

#define HW_GPIO_IMR(x)           (*(__IO hw_gpio_imr_t *) HW_GPIO_IMR_ADDR(x))
#define HW_GPIO_IMR_RD(x)        (HW_GPIO_IMR(x).U)
#define HW_GPIO_IMR_WR(x, v)     (HW_GPIO_IMR(x).U = (v))
#define HW_GPIO_IMR_SET(x, v)    (HW_GPIO_IMR_WR(x, HW_GPIO_IMR_RD(x) |  (v)))
#define HW_GPIO_IMR_CLR(x, v)    (HW_GPIO_IMR_WR(x, HW_GPIO_IMR_RD(x) & ~(v)))
#define HW_GPIO_IMR_TOG(x, v)    (HW_GPIO_IMR_WR(x, HW_GPIO_IMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_IMR bitfields
 */

/*!
 * @name Register GPIO_IMR, field IMR[31:0] (RW)
 *
 * Interrupt Mask bits. This register is used to enable or disable the interrupt
 * function on each of the 32 GPIO signals. Settings: Bit IMR[n] (n=0...31)
 * controls interrupt n as follows:
 *
 * Values:
 * - 0 - Interrupt n is disabled.
 * - 1 - Interrupt n is enabled.
 */
/*@{*/
#define BP_GPIO_IMR_IMR      (0U)          /*!< Bit position for GPIO_IMR_IMR. */
#define BM_GPIO_IMR_IMR      (0xFFFFFFFFU) /*!< Bit mask for GPIO_IMR_IMR. */
#define BS_GPIO_IMR_IMR      (32U)         /*!< Bit field size in bits for GPIO_IMR_IMR. */

#define BV_GPIO_IMR_IMR_UNMASKED       (0U)          /*!< Bit field value for GPIO_IMR_IMR: Interrupt n is disabled. */
#define BV_GPIO_IMR_IMR_MASKED         (0x1U)        /*!< Bit field value for GPIO_IMR_IMR: Interrupt n is enabled. */

/*! @brief Read current value of the GPIO_IMR_IMR field. */
#define BR_GPIO_IMR_IMR(x)   (HW_GPIO_IMR(x).U)

/*! @brief Format value for bitfield GPIO_IMR_IMR. */
#define BF_GPIO_IMR_IMR(v)   ((uint32_t)((uint32_t)(v) << BP_GPIO_IMR_IMR) & BM_GPIO_IMR_IMR)

/*! @brief Set the IMR field to a new value. */
#define BW_GPIO_IMR_IMR(x, v) (HW_GPIO_IMR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPIO_ISR - GPIO interrupt status register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_ISR - GPIO interrupt status register (W1C)
 *
 * Reset value: 0x00000000U
 *
 * The GPIO_ISR functions as an interrupt status indicator. Each bit indicates
 * whether an interrupt condition has been met for the corresponding input signal.
 * When an interrupt condition is met (as determined by the corresponding
 * interrupt condition register field), the corresponding bit in this register is set.
 * Two wait states are required in read access for synchronization. One wait
 * state is required for reset.
 */
typedef union _hw_gpio_isr
{
    uint32_t U;
    struct _hw_gpio_isr_bitfields
    {
        uint32_t ISR : 32;             /*!< [31:0]  */
    } B;
} hw_gpio_isr_t;

/*!
 * @name Constants and macros for entire GPIO_ISR register
 */
/*@{*/
#define HW_GPIO_ISR_ADDR(x)      ((uintptr_t)(x) + 0x18U)

#define HW_GPIO_ISR(x)           (*(__IO hw_gpio_isr_t *) HW_GPIO_ISR_ADDR(x))
#define HW_GPIO_ISR_RD(x)        (HW_GPIO_ISR(x).U)
#define HW_GPIO_ISR_WR(x, v)     (HW_GPIO_ISR(x).U = (v))
#define HW_GPIO_ISR_SET(x, v)    (HW_GPIO_ISR_WR(x, HW_GPIO_ISR_RD(x) |  (v)))
#define HW_GPIO_ISR_CLR(x, v)    (HW_GPIO_ISR_WR(x, HW_GPIO_ISR_RD(x) & ~(v)))
#define HW_GPIO_ISR_TOG(x, v)    (HW_GPIO_ISR_WR(x, HW_GPIO_ISR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_ISR bitfields
 */

/*!
 * @name Register GPIO_ISR, field ISR[31:0] (W1C)
 *
 * Interrupt status bits - Bit n of this register is asserted (active high) when
 * the active condition (as determined by the corresponding ICR bit) is detected
 * on the GPIO input and is waiting for service. The value of this register is
 * independent of the value in GPIO_IMR. When the active condition has been
 * detected, the corresponding bit remains set until cleared by software. Status flags
 * are cleared by writing a 1 to the corresponding bit position.
 */
/*@{*/
#define BP_GPIO_ISR_ISR      (0U)          /*!< Bit position for GPIO_ISR_ISR. */
#define BM_GPIO_ISR_ISR      (0xFFFFFFFFU) /*!< Bit mask for GPIO_ISR_ISR. */
#define BS_GPIO_ISR_ISR      (32U)         /*!< Bit field size in bits for GPIO_ISR_ISR. */

/*! @brief Read current value of the GPIO_ISR_ISR field. */
#define BR_GPIO_ISR_ISR(x)   (HW_GPIO_ISR(x).U)

/*! @brief Format value for bitfield GPIO_ISR_ISR. */
#define BF_GPIO_ISR_ISR(v)   ((uint32_t)((uint32_t)(v) << BP_GPIO_ISR_ISR) & BM_GPIO_ISR_ISR)

/*! @brief Set the ISR field to a new value. */
#define BW_GPIO_ISR_ISR(x, v) (HW_GPIO_ISR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPIO_EDGE_SEL - GPIO edge select register
 ******************************************************************************/

/*!
 * @brief HW_GPIO_EDGE_SEL - GPIO edge select register (RW)
 *
 * Reset value: 0x00000000U
 *
 * GPIO_EDGE_SEL may be used to override the ICR registers' configuration. If
 * the GPIO_EDGE_SEL bit is set, then a rising edge or falling edge in the
 * corresponding signal generates an interrupt. This register provides backward
 * compatibility. On reset all bits are cleared (ICR is not overridden).
 */
typedef union _hw_gpio_edge_sel
{
    uint32_t U;
    struct _hw_gpio_edge_sel_bitfields
    {
        uint32_t GPIO_EDGE_SEL : 32;   /*!< [31:0]  */
    } B;
} hw_gpio_edge_sel_t;

/*!
 * @name Constants and macros for entire GPIO_EDGE_SEL register
 */
/*@{*/
#define HW_GPIO_EDGE_SEL_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_GPIO_EDGE_SEL(x)      (*(__IO hw_gpio_edge_sel_t *) HW_GPIO_EDGE_SEL_ADDR(x))
#define HW_GPIO_EDGE_SEL_RD(x)   (HW_GPIO_EDGE_SEL(x).U)
#define HW_GPIO_EDGE_SEL_WR(x, v) (HW_GPIO_EDGE_SEL(x).U = (v))
#define HW_GPIO_EDGE_SEL_SET(x, v) (HW_GPIO_EDGE_SEL_WR(x, HW_GPIO_EDGE_SEL_RD(x) |  (v)))
#define HW_GPIO_EDGE_SEL_CLR(x, v) (HW_GPIO_EDGE_SEL_WR(x, HW_GPIO_EDGE_SEL_RD(x) & ~(v)))
#define HW_GPIO_EDGE_SEL_TOG(x, v) (HW_GPIO_EDGE_SEL_WR(x, HW_GPIO_EDGE_SEL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPIO_EDGE_SEL bitfields
 */

/*!
 * @name Register GPIO_EDGE_SEL, field GPIO_EDGE_SEL[31:0] (RW)
 *
 * Edge select. When GPIO_EDGE_SEL[n] is set, the GPIO disregards the ICR[n]
 * setting, and detects any edge on the corresponding input signal.
 */
/*@{*/
#define BP_GPIO_EDGE_SEL_GPIO_EDGE_SEL (0U) /*!< Bit position for GPIO_EDGE_SEL_GPIO_EDGE_SEL. */
#define BM_GPIO_EDGE_SEL_GPIO_EDGE_SEL (0xFFFFFFFFU) /*!< Bit mask for GPIO_EDGE_SEL_GPIO_EDGE_SEL. */
#define BS_GPIO_EDGE_SEL_GPIO_EDGE_SEL (32U) /*!< Bit field size in bits for GPIO_EDGE_SEL_GPIO_EDGE_SEL. */

/*! @brief Read current value of the GPIO_EDGE_SEL_GPIO_EDGE_SEL field. */
#define BR_GPIO_EDGE_SEL_GPIO_EDGE_SEL(x) (HW_GPIO_EDGE_SEL(x).U)

/*! @brief Format value for bitfield GPIO_EDGE_SEL_GPIO_EDGE_SEL. */
#define BF_GPIO_EDGE_SEL_GPIO_EDGE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_GPIO_EDGE_SEL_GPIO_EDGE_SEL) & BM_GPIO_EDGE_SEL_GPIO_EDGE_SEL)

/*! @brief Set the GPIO_EDGE_SEL field to a new value. */
#define BW_GPIO_EDGE_SEL_GPIO_EDGE_SEL(x, v) (HW_GPIO_EDGE_SEL_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_gpio_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPIO module registers.
 */
#pragma pack(1)
typedef struct _hw_gpio
{
    __IO hw_gpio_dr_t DR;                  /*!< [0x0] GPIO data register */
    __IO hw_gpio_gdir_t GDIR;              /*!< [0x4] GPIO direction register */
    __I hw_gpio_psr_t PSR;                 /*!< [0x8] GPIO pad status register */
    __IO hw_gpio_icr1_t ICR1;              /*!< [0xC] GPIO interrupt configuration register1 */
    __IO hw_gpio_icr2_t ICR2;              /*!< [0x10] GPIO interrupt configuration register2 */
    __IO hw_gpio_imr_t IMR;                /*!< [0x14] GPIO interrupt mask register */
    __IO hw_gpio_isr_t ISR;                /*!< [0x18] GPIO interrupt status register */
    __IO hw_gpio_edge_sel_t EDGE_SEL;      /*!< [0x1C] GPIO edge select register */
} hw_gpio_t;
#pragma pack()

/*! @brief Macro to access all GPIO registers. */
/*! @param x GPIO module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPIO_REGS(GPIO1_BASE)</code>. */
#define HW_GPIO_REGS(x) (*(hw_gpio_t *)(x))

/*
 * iMX6DP GPMI
 *
 * GPMI
 *
 * Registers defined in this header file:
 * - HW_GPMI_CTRL0 - GPMI Control Register 0 Description
 * - HW_GPMI_COMPARE - GPMI Compare Register Description
 * - HW_GPMI_ECCCTRL - GPMI Integrated ECC Control Register Description
 * - HW_GPMI_ECCCOUNT - GPMI Integrated ECC Transfer Count Register Description
 * - HW_GPMI_PAYLOAD - GPMI Payload Address Register Description
 * - HW_GPMI_AUXILIARY - GPMI Auxiliary Address Register Description
 * - HW_GPMI_CTRL1 - GPMI Control Register 1 Description
 * - HW_GPMI_TIMING0 - GPMI Timing Register 0 Description
 * - HW_GPMI_TIMING1 - GPMI Timing Register 1 Description
 * - HW_GPMI_TIMING2 - GPMI Timing Register 2 Description
 * - HW_GPMI_DATA - GPMI DMA Data Transfer Register Description
 * - HW_GPMI_STAT - GPMI Status Register Description
 * - HW_GPMI_DEBUG - GPMI Debug Information Register Description
 * - HW_GPMI_VERSION - GPMI Version Register Description
 * - HW_GPMI_DEBUG2 - GPMI Debug2 Information Register Description
 * - HW_GPMI_DEBUG3 - GPMI Debug3 Information Register Description
 * - HW_GPMI_READ_DDR_DLL_CTRL - GPMI Double Rate Read DLL Control Register Description
 * - HW_GPMI_WRITE_DDR_DLL_CTRL - GPMI Double Rate Write DLL Control Register Description
 * - HW_GPMI_READ_DDR_DLL_STS - GPMI Double Rate Read DLL Status Register Description
 * - HW_GPMI_WRITE_DDR_DLL_STS - GPMI Double Rate Write DLL Status Register Description
 *
 * - hw_gpmi_t - Struct containing all module registers.
 */

#define HW_GPMI_INSTANCE_COUNT (1U) /*!< Number of instances of the GPMI module. */
#define HW_GPMI (0U) /*!< Instance number for GPMI. */
#define GPMI_BASE             (0x112000U) /*!< Base address for GPMI. */
/*! Array initializer of GPMI base addresses. */
#define GPMI_BASE_ADDRS       { GPMI_BASE }

/*******************************************************************************
 * HW_GPMI_CTRL0 - GPMI Control Register 0 Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_CTRL0 - GPMI Control Register 0 Description (RW)
 *
 * Reset value: 0xC0000000U
 *
 * The GPMI control register 0 specifies the GPMI transaction to perform for the
 * current command chain item.
 */
typedef union _hw_gpmi_ctrl0
{
    uint32_t U;
    struct _hw_gpmi_ctrl0_bitfields
    {
        uint32_t XFER_COUNT : 16;      /*!< [15:0]  */
        uint32_t ADDRESS_INCREMENT : 1; /*!< [16]  */
        uint32_t ADDRESS : 3;          /*!< [19:17]  */
        uint32_t CS : 3;               /*!< [22:20]  */
        uint32_t WORD_LENGTH : 1;      /*!< [23]  */
        uint32_t COMMAND_MODE : 2;     /*!< [25:24]  */
        uint32_t UDMA : 1;             /*!< [26]  */
        uint32_t LOCK_CS : 1;          /*!< [27]  */
        uint32_t DEV_IRQ_EN : 1;       /*!< [28]  */
        uint32_t RUN : 1;              /*!< [29]  */
        uint32_t CLKGATE : 1;          /*!< [30]  */
        uint32_t SFTRST : 1;           /*!< [31]  */
    } B;
} hw_gpmi_ctrl0_t;

/*!
 * @name Constants and macros for entire GPMI_CTRL0 register
 */
/*@{*/
#define HW_GPMI_CTRL0_ADDR(x)    ((uintptr_t)(x) + 0x0U)
#define HW_GPMI_CTRL0_SET_ADDR(x) (HW_GPMI_CTRL0_ADDR(x) + 0x4U)
#define HW_GPMI_CTRL0_CLR_ADDR(x) (HW_GPMI_CTRL0_ADDR(x) + 0x8U)
#define HW_GPMI_CTRL0_TOG_ADDR(x) (HW_GPMI_CTRL0_ADDR(x) + 0xCU)

#define HW_GPMI_CTRL0(x)         (*(__IO hw_gpmi_ctrl0_t *) HW_GPMI_CTRL0_ADDR(x))
#define HW_GPMI_CTRL0_RD(x)      (HW_GPMI_CTRL0(x).U)
#define HW_GPMI_CTRL0_WR(x, v)   (HW_GPMI_CTRL0(x).U = (v))
#define HW_GPMI_CTRL0_SET(x, v)  ((*(uint32_t *) HW_GPMI_CTRL0_SET_ADDR(x)) = (v))
#define HW_GPMI_CTRL0_CLR(x, v)  ((*(uint32_t *) HW_GPMI_CTRL0_CLR_ADDR(x)) = (v))
#define HW_GPMI_CTRL0_TOG(x, v)  ((*(uint32_t *) HW_GPMI_CTRL0_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual GPMI_CTRL0 bitfields
 */

/*!
 * @name Register GPMI_CTRL0, field XFER_COUNT[15:0] (RW)
 *
 * Number of bytes to transfer for this command. A value of zero will transfer
 * 64K bytes.
 */
/*@{*/
#define BP_GPMI_CTRL0_XFER_COUNT (0U)      /*!< Bit position for GPMI_CTRL0_XFER_COUNT. */
#define BM_GPMI_CTRL0_XFER_COUNT (0x0000FFFFU) /*!< Bit mask for GPMI_CTRL0_XFER_COUNT. */
#define BS_GPMI_CTRL0_XFER_COUNT (16U)     /*!< Bit field size in bits for GPMI_CTRL0_XFER_COUNT. */

/*! @brief Read current value of the GPMI_CTRL0_XFER_COUNT field. */
#define BR_GPMI_CTRL0_XFER_COUNT(x) (HW_GPMI_CTRL0(x).B.XFER_COUNT)

/*! @brief Format value for bitfield GPMI_CTRL0_XFER_COUNT. */
#define BF_GPMI_CTRL0_XFER_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_XFER_COUNT) & BM_GPMI_CTRL0_XFER_COUNT)

/*! @brief Set the XFER_COUNT field to a new value. */
#define BW_GPMI_CTRL0_XFER_COUNT(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_XFER_COUNT) | BF_GPMI_CTRL0_XFER_COUNT(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field ADDRESS_INCREMENT[16] (RW)
 *
 * In ATA mode, the address will increment with each cycle. In NAND mode, the
 * address will increment once, after the first cycle (going from CLE to ALE).
 * DISABLED = 0x0 Address does not increment. ENABLED = 0x1 Increment address.
 *
 * Values:
 * - 0 - Address does not increment.
 * - 1 - Increment address.
 */
/*@{*/
#define BP_GPMI_CTRL0_ADDRESS_INCREMENT (16U) /*!< Bit position for GPMI_CTRL0_ADDRESS_INCREMENT. */
#define BM_GPMI_CTRL0_ADDRESS_INCREMENT (0x00010000U) /*!< Bit mask for GPMI_CTRL0_ADDRESS_INCREMENT. */
#define BS_GPMI_CTRL0_ADDRESS_INCREMENT (1U) /*!< Bit field size in bits for GPMI_CTRL0_ADDRESS_INCREMENT. */

/*! @brief Read current value of the GPMI_CTRL0_ADDRESS_INCREMENT field. */
#define BR_GPMI_CTRL0_ADDRESS_INCREMENT(x) (HW_GPMI_CTRL0(x).B.ADDRESS_INCREMENT)

/*! @brief Format value for bitfield GPMI_CTRL0_ADDRESS_INCREMENT. */
#define BF_GPMI_CTRL0_ADDRESS_INCREMENT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_ADDRESS_INCREMENT) & BM_GPMI_CTRL0_ADDRESS_INCREMENT)

/*! @brief Set the ADDRESS_INCREMENT field to a new value. */
#define BW_GPMI_CTRL0_ADDRESS_INCREMENT(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_ADDRESS_INCREMENT) | BF_GPMI_CTRL0_ADDRESS_INCREMENT(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field ADDRESS[19:17] (RW)
 *
 * Specifies the three address lines for ATA mode. In NAND mode, use A0 for CLE
 * and A1 for ALE. NAND_DATA = 0x0 In NAND mode, this address is used to read and
 * write data bytes. NAND_CLE = 0x1 In NAND mode, this address is used to write
 * command bytes. NAND_ALE = 0x2 In NAND mode, this address is used to write
 * address bytes.
 */
/*@{*/
#define BP_GPMI_CTRL0_ADDRESS (17U)        /*!< Bit position for GPMI_CTRL0_ADDRESS. */
#define BM_GPMI_CTRL0_ADDRESS (0x000E0000U) /*!< Bit mask for GPMI_CTRL0_ADDRESS. */
#define BS_GPMI_CTRL0_ADDRESS (3U)         /*!< Bit field size in bits for GPMI_CTRL0_ADDRESS. */

/*! @brief Read current value of the GPMI_CTRL0_ADDRESS field. */
#define BR_GPMI_CTRL0_ADDRESS(x) (HW_GPMI_CTRL0(x).B.ADDRESS)

/*! @brief Format value for bitfield GPMI_CTRL0_ADDRESS. */
#define BF_GPMI_CTRL0_ADDRESS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_ADDRESS) & BM_GPMI_CTRL0_ADDRESS)

/*! @brief Set the ADDRESS field to a new value. */
#define BW_GPMI_CTRL0_ADDRESS(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_ADDRESS) | BF_GPMI_CTRL0_ADDRESS(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field CS[22:20] (RW)
 *
 * Selects which chip select is active for this command. For ATA WAIT_FOR_READY
 * command, this must be set to b01.
 */
/*@{*/
#define BP_GPMI_CTRL0_CS     (20U)         /*!< Bit position for GPMI_CTRL0_CS. */
#define BM_GPMI_CTRL0_CS     (0x00700000U) /*!< Bit mask for GPMI_CTRL0_CS. */
#define BS_GPMI_CTRL0_CS     (3U)          /*!< Bit field size in bits for GPMI_CTRL0_CS. */

/*! @brief Read current value of the GPMI_CTRL0_CS field. */
#define BR_GPMI_CTRL0_CS(x)  (HW_GPMI_CTRL0(x).B.CS)

/*! @brief Format value for bitfield GPMI_CTRL0_CS. */
#define BF_GPMI_CTRL0_CS(v)  ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_CS) & BM_GPMI_CTRL0_CS)

/*! @brief Set the CS field to a new value. */
#define BW_GPMI_CTRL0_CS(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_CS) | BF_GPMI_CTRL0_CS(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field WORD_LENGTH[23] (RW)
 *
 * This bit should only be changed when RUN==0. Reserve = 0x0 Reserved. 8_BIT =
 * 0x1 8-bit Data Bus mode.
 *
 * Values:
 * - 0 - Reserved.
 * - 1 - 8-bit Data Bus mode.
 */
/*@{*/
#define BP_GPMI_CTRL0_WORD_LENGTH (23U)    /*!< Bit position for GPMI_CTRL0_WORD_LENGTH. */
#define BM_GPMI_CTRL0_WORD_LENGTH (0x00800000U) /*!< Bit mask for GPMI_CTRL0_WORD_LENGTH. */
#define BS_GPMI_CTRL0_WORD_LENGTH (1U)     /*!< Bit field size in bits for GPMI_CTRL0_WORD_LENGTH. */

/*! @brief Read current value of the GPMI_CTRL0_WORD_LENGTH field. */
#define BR_GPMI_CTRL0_WORD_LENGTH(x) (HW_GPMI_CTRL0(x).B.WORD_LENGTH)

/*! @brief Format value for bitfield GPMI_CTRL0_WORD_LENGTH. */
#define BF_GPMI_CTRL0_WORD_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_WORD_LENGTH) & BM_GPMI_CTRL0_WORD_LENGTH)

/*! @brief Set the WORD_LENGTH field to a new value. */
#define BW_GPMI_CTRL0_WORD_LENGTH(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_WORD_LENGTH) | BF_GPMI_CTRL0_WORD_LENGTH(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field COMMAND_MODE[25:24] (RW)
 *
 * WRITE = 0x0 Write mode. READ = 0x1 Read mode. READ_AND_COMPARE = 0x2 Read and
 * Compare mode (setting sense flop). WAIT_FOR_READY = 0x3 Wait for Ready mode.
 * For ATA WAIT_FOR_READY command set CS=01.
 *
 * Values:
 * - 00 - Write mode.
 * - 01 - Read Mode.
 * - 10 - Read and Compare Mode (setting sense flop).
 * - 11 - Wait for Ready.
 */
/*@{*/
#define BP_GPMI_CTRL0_COMMAND_MODE (24U)   /*!< Bit position for GPMI_CTRL0_COMMAND_MODE. */
#define BM_GPMI_CTRL0_COMMAND_MODE (0x03000000U) /*!< Bit mask for GPMI_CTRL0_COMMAND_MODE. */
#define BS_GPMI_CTRL0_COMMAND_MODE (2U)    /*!< Bit field size in bits for GPMI_CTRL0_COMMAND_MODE. */

/*! @brief Read current value of the GPMI_CTRL0_COMMAND_MODE field. */
#define BR_GPMI_CTRL0_COMMAND_MODE(x) (HW_GPMI_CTRL0(x).B.COMMAND_MODE)

/*! @brief Format value for bitfield GPMI_CTRL0_COMMAND_MODE. */
#define BF_GPMI_CTRL0_COMMAND_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_COMMAND_MODE) & BM_GPMI_CTRL0_COMMAND_MODE)

/*! @brief Set the COMMAND_MODE field to a new value. */
#define BW_GPMI_CTRL0_COMMAND_MODE(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_COMMAND_MODE) | BF_GPMI_CTRL0_COMMAND_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field UDMA[26] (RW)
 *
 * DISABLED = 0x0 Use ATA-PIO mode on the external bus. ENABLED = 0x1 Use
 * ATA-Ultra DMA mode on the external bus.
 *
 * Values:
 * - 0 - Use ATA-PIO mode on the external bus.
 * - 1 - Use ATA-Ultra DMA mode on the external bus.
 */
/*@{*/
#define BP_GPMI_CTRL0_UDMA   (26U)         /*!< Bit position for GPMI_CTRL0_UDMA. */
#define BM_GPMI_CTRL0_UDMA   (0x04000000U) /*!< Bit mask for GPMI_CTRL0_UDMA. */
#define BS_GPMI_CTRL0_UDMA   (1U)          /*!< Bit field size in bits for GPMI_CTRL0_UDMA. */

/*! @brief Read current value of the GPMI_CTRL0_UDMA field. */
#define BR_GPMI_CTRL0_UDMA(x) (HW_GPMI_CTRL0(x).B.UDMA)

/*! @brief Format value for bitfield GPMI_CTRL0_UDMA. */
#define BF_GPMI_CTRL0_UDMA(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_UDMA) & BM_GPMI_CTRL0_UDMA)

/*! @brief Set the UDMA field to a new value. */
#define BW_GPMI_CTRL0_UDMA(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_UDMA) | BF_GPMI_CTRL0_UDMA(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field LOCK_CS[27] (RW)
 *
 * For ATA/NAND mode: 0= Deassert chip select (CS) after RUN is complete. 1=
 * Continue to assert chip select (CS) after RUN is complete. For Camera Mode: 0=
 * Dont wait for VSYNC rising edge before capturing data. 1= Wait for VSYNC rising
 * edge before capturing data (Camera mode only). DISABLED = 0x0 Deassert chip
 * select (CS) after RUN is complete. ENABLED = 0x1 Continue to assert chip select
 * (CS) after RUN is complete.
 */
/*@{*/
#define BP_GPMI_CTRL0_LOCK_CS (27U)        /*!< Bit position for GPMI_CTRL0_LOCK_CS. */
#define BM_GPMI_CTRL0_LOCK_CS (0x08000000U) /*!< Bit mask for GPMI_CTRL0_LOCK_CS. */
#define BS_GPMI_CTRL0_LOCK_CS (1U)         /*!< Bit field size in bits for GPMI_CTRL0_LOCK_CS. */

/*! @brief Read current value of the GPMI_CTRL0_LOCK_CS field. */
#define BR_GPMI_CTRL0_LOCK_CS(x) (HW_GPMI_CTRL0(x).B.LOCK_CS)

/*! @brief Format value for bitfield GPMI_CTRL0_LOCK_CS. */
#define BF_GPMI_CTRL0_LOCK_CS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_LOCK_CS) & BM_GPMI_CTRL0_LOCK_CS)

/*! @brief Set the LOCK_CS field to a new value. */
#define BW_GPMI_CTRL0_LOCK_CS(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_LOCK_CS) | BF_GPMI_CTRL0_LOCK_CS(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field DEV_IRQ_EN[28] (RW)
 *
 * When set to '1' and ATA_IRQ pin is asserted, the GPMI_IRQ output will assert.
 */
/*@{*/
#define BP_GPMI_CTRL0_DEV_IRQ_EN (28U)     /*!< Bit position for GPMI_CTRL0_DEV_IRQ_EN. */
#define BM_GPMI_CTRL0_DEV_IRQ_EN (0x10000000U) /*!< Bit mask for GPMI_CTRL0_DEV_IRQ_EN. */
#define BS_GPMI_CTRL0_DEV_IRQ_EN (1U)      /*!< Bit field size in bits for GPMI_CTRL0_DEV_IRQ_EN. */

/*! @brief Read current value of the GPMI_CTRL0_DEV_IRQ_EN field. */
#define BR_GPMI_CTRL0_DEV_IRQ_EN(x) (HW_GPMI_CTRL0(x).B.DEV_IRQ_EN)

/*! @brief Format value for bitfield GPMI_CTRL0_DEV_IRQ_EN. */
#define BF_GPMI_CTRL0_DEV_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_DEV_IRQ_EN) & BM_GPMI_CTRL0_DEV_IRQ_EN)

/*! @brief Set the DEV_IRQ_EN field to a new value. */
#define BW_GPMI_CTRL0_DEV_IRQ_EN(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_DEV_IRQ_EN) | BF_GPMI_CTRL0_DEV_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field RUN[29] (RW)
 *
 * The GPMI is busy running a command whenever this bit is set to '1'. The GPMI
 * is idle whenever this bit set to zero. This can be set to one by a CPU write.
 * In addition, the DMA sets this bit each time a DMA command has finished its
 * PIO transfer phase. IDLE = 0x0 The GPMI is idle. BUSY = 0x1 The GPMI is busy
 * running a command.
 */
/*@{*/
#define BP_GPMI_CTRL0_RUN    (29U)         /*!< Bit position for GPMI_CTRL0_RUN. */
#define BM_GPMI_CTRL0_RUN    (0x20000000U) /*!< Bit mask for GPMI_CTRL0_RUN. */
#define BS_GPMI_CTRL0_RUN    (1U)          /*!< Bit field size in bits for GPMI_CTRL0_RUN. */

/*! @brief Read current value of the GPMI_CTRL0_RUN field. */
#define BR_GPMI_CTRL0_RUN(x) (HW_GPMI_CTRL0(x).B.RUN)

/*! @brief Format value for bitfield GPMI_CTRL0_RUN. */
#define BF_GPMI_CTRL0_RUN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_RUN) & BM_GPMI_CTRL0_RUN)

/*! @brief Set the RUN field to a new value. */
#define BW_GPMI_CTRL0_RUN(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_RUN) | BF_GPMI_CTRL0_RUN(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field CLKGATE[30] (RW)
 *
 * Set this bit zero for normal operation. Setting this bit to one (default),
 * gates all of the block level clocks off for miniminizing AC energy consumption.
 * RUN = 0x0 Allow GPMI to operate normally. NO_CLKS = 0x1 Do not clock GPMI
 * gates in order to minimize power consumption.
 */
/*@{*/
#define BP_GPMI_CTRL0_CLKGATE (30U)        /*!< Bit position for GPMI_CTRL0_CLKGATE. */
#define BM_GPMI_CTRL0_CLKGATE (0x40000000U) /*!< Bit mask for GPMI_CTRL0_CLKGATE. */
#define BS_GPMI_CTRL0_CLKGATE (1U)         /*!< Bit field size in bits for GPMI_CTRL0_CLKGATE. */

/*! @brief Read current value of the GPMI_CTRL0_CLKGATE field. */
#define BR_GPMI_CTRL0_CLKGATE(x) (HW_GPMI_CTRL0(x).B.CLKGATE)

/*! @brief Format value for bitfield GPMI_CTRL0_CLKGATE. */
#define BF_GPMI_CTRL0_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_CLKGATE) & BM_GPMI_CTRL0_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_GPMI_CTRL0_CLKGATE(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_CLKGATE) | BF_GPMI_CTRL0_CLKGATE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL0, field SFTRST[31] (RW)
 *
 * Set to zero for normal operation. When this bit is set to one (default), then
 * the entire block is held in its reset state. This will not work if the
 * CLKGATE bit is already set to '1'. CLKGATE must be cleared to '0' before issuing a
 * soft reset. Also the GPMICLK must be running for this to work properly. RUN =
 * 0x0 Allow GPMI to operate normally. RESET = 0x1 Hold GPMI in reset.
 */
/*@{*/
#define BP_GPMI_CTRL0_SFTRST (31U)         /*!< Bit position for GPMI_CTRL0_SFTRST. */
#define BM_GPMI_CTRL0_SFTRST (0x80000000U) /*!< Bit mask for GPMI_CTRL0_SFTRST. */
#define BS_GPMI_CTRL0_SFTRST (1U)          /*!< Bit field size in bits for GPMI_CTRL0_SFTRST. */

/*! @brief Read current value of the GPMI_CTRL0_SFTRST field. */
#define BR_GPMI_CTRL0_SFTRST(x) (HW_GPMI_CTRL0(x).B.SFTRST)

/*! @brief Format value for bitfield GPMI_CTRL0_SFTRST. */
#define BF_GPMI_CTRL0_SFTRST(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL0_SFTRST) & BM_GPMI_CTRL0_SFTRST)

/*! @brief Set the SFTRST field to a new value. */
#define BW_GPMI_CTRL0_SFTRST(x, v) (HW_GPMI_CTRL0_WR(x, (HW_GPMI_CTRL0_RD(x) & ~BM_GPMI_CTRL0_SFTRST) | BF_GPMI_CTRL0_SFTRST(v)))
/*@}*/




/*******************************************************************************
 * HW_GPMI_COMPARE - GPMI Compare Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_COMPARE - GPMI Compare Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI compare register specifies the expect data and the xor mask for
 * comparing to the status values read from the device. This register is used by the
 * Read and Compare command. GPMI_COMPARE 0x010
 */
typedef union _hw_gpmi_compare
{
    uint32_t U;
    struct _hw_gpmi_compare_bitfields
    {
        uint32_t REFERENCE : 16;       /*!< [15:0]  */
        uint32_t MASK : 16;            /*!< [31:16]  */
    } B;
} hw_gpmi_compare_t;

/*!
 * @name Constants and macros for entire GPMI_COMPARE register
 */
/*@{*/
#define HW_GPMI_COMPARE_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_GPMI_COMPARE(x)       (*(__IO hw_gpmi_compare_t *) HW_GPMI_COMPARE_ADDR(x))
#define HW_GPMI_COMPARE_RD(x)    (HW_GPMI_COMPARE(x).U)
#define HW_GPMI_COMPARE_WR(x, v) (HW_GPMI_COMPARE(x).U = (v))
#define HW_GPMI_COMPARE_SET(x, v) (HW_GPMI_COMPARE_WR(x, HW_GPMI_COMPARE_RD(x) |  (v)))
#define HW_GPMI_COMPARE_CLR(x, v) (HW_GPMI_COMPARE_WR(x, HW_GPMI_COMPARE_RD(x) & ~(v)))
#define HW_GPMI_COMPARE_TOG(x, v) (HW_GPMI_COMPARE_WR(x, HW_GPMI_COMPARE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_COMPARE bitfields
 */

/*!
 * @name Register GPMI_COMPARE, field REFERENCE[15:0] (RW)
 *
 * 16-bit value which is XORed with data read from the NAND device.
 */
/*@{*/
#define BP_GPMI_COMPARE_REFERENCE (0U)     /*!< Bit position for GPMI_COMPARE_REFERENCE. */
#define BM_GPMI_COMPARE_REFERENCE (0x0000FFFFU) /*!< Bit mask for GPMI_COMPARE_REFERENCE. */
#define BS_GPMI_COMPARE_REFERENCE (16U)    /*!< Bit field size in bits for GPMI_COMPARE_REFERENCE. */

/*! @brief Read current value of the GPMI_COMPARE_REFERENCE field. */
#define BR_GPMI_COMPARE_REFERENCE(x) (HW_GPMI_COMPARE(x).B.REFERENCE)

/*! @brief Format value for bitfield GPMI_COMPARE_REFERENCE. */
#define BF_GPMI_COMPARE_REFERENCE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_COMPARE_REFERENCE) & BM_GPMI_COMPARE_REFERENCE)

/*! @brief Set the REFERENCE field to a new value. */
#define BW_GPMI_COMPARE_REFERENCE(x, v) (HW_GPMI_COMPARE_WR(x, (HW_GPMI_COMPARE_RD(x) & ~BM_GPMI_COMPARE_REFERENCE) | BF_GPMI_COMPARE_REFERENCE(v)))
/*@}*/

/*!
 * @name Register GPMI_COMPARE, field MASK[31:16] (RW)
 *
 * 16-bit mask which is applied after the read data is XORed with the REFERENCE
 * bit field.
 */
/*@{*/
#define BP_GPMI_COMPARE_MASK (16U)         /*!< Bit position for GPMI_COMPARE_MASK. */
#define BM_GPMI_COMPARE_MASK (0xFFFF0000U) /*!< Bit mask for GPMI_COMPARE_MASK. */
#define BS_GPMI_COMPARE_MASK (16U)         /*!< Bit field size in bits for GPMI_COMPARE_MASK. */

/*! @brief Read current value of the GPMI_COMPARE_MASK field. */
#define BR_GPMI_COMPARE_MASK(x) (HW_GPMI_COMPARE(x).B.MASK)

/*! @brief Format value for bitfield GPMI_COMPARE_MASK. */
#define BF_GPMI_COMPARE_MASK(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_COMPARE_MASK) & BM_GPMI_COMPARE_MASK)

/*! @brief Set the MASK field to a new value. */
#define BW_GPMI_COMPARE_MASK(x, v) (HW_GPMI_COMPARE_WR(x, (HW_GPMI_COMPARE_RD(x) & ~BM_GPMI_COMPARE_MASK) | BF_GPMI_COMPARE_MASK(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_ECCCTRL - GPMI Integrated ECC Control Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_ECCCTRL - GPMI Integrated ECC Control Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI ECC control register handles configuration of the integrated ECC
 * accelerator.
 */
typedef union _hw_gpmi_eccctrl
{
    uint32_t U;
    struct _hw_gpmi_eccctrl_bitfields
    {
        uint32_t BUFFER_MASK : 9;      /*!< [8:0]  */
        uint32_t RSVD1 : 3;            /*!< [11:9]  */
        uint32_t ENABLE_ECC : 1;       /*!< [12]  */
        uint32_t ECC_CMD : 2;          /*!< [14:13]  */
        uint32_t RSVD2 : 1;            /*!< [15]  */
        uint32_t HANDLE : 16;          /*!< [31:16]  */
    } B;
} hw_gpmi_eccctrl_t;

/*!
 * @name Constants and macros for entire GPMI_ECCCTRL register
 */
/*@{*/
#define HW_GPMI_ECCCTRL_ADDR(x)  ((uintptr_t)(x) + 0x20U)
#define HW_GPMI_ECCCTRL_SET_ADDR(x) (HW_GPMI_ECCCTRL_ADDR(x) + 0x4U)
#define HW_GPMI_ECCCTRL_CLR_ADDR(x) (HW_GPMI_ECCCTRL_ADDR(x) + 0x8U)
#define HW_GPMI_ECCCTRL_TOG_ADDR(x) (HW_GPMI_ECCCTRL_ADDR(x) + 0xCU)

#define HW_GPMI_ECCCTRL(x)       (*(__IO hw_gpmi_eccctrl_t *) HW_GPMI_ECCCTRL_ADDR(x))
#define HW_GPMI_ECCCTRL_RD(x)    (HW_GPMI_ECCCTRL(x).U)
#define HW_GPMI_ECCCTRL_WR(x, v) (HW_GPMI_ECCCTRL(x).U = (v))
#define HW_GPMI_ECCCTRL_SET(x, v) ((*(uint32_t *) HW_GPMI_ECCCTRL_SET_ADDR(x)) = (v))
#define HW_GPMI_ECCCTRL_CLR(x, v) ((*(uint32_t *) HW_GPMI_ECCCTRL_CLR_ADDR(x)) = (v))
#define HW_GPMI_ECCCTRL_TOG(x, v) ((*(uint32_t *) HW_GPMI_ECCCTRL_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual GPMI_ECCCTRL bitfields
 */

/*!
 * @name Register GPMI_ECCCTRL, field BUFFER_MASK[8:0] (RW)
 *
 * ECC buffer information. The BCH error correction only allows two
 * configurations of the buffer mask - software may either read just the first block on the
 * flash page or the entire flash page. Write operations must be for the entire
 * flash page. Invalid buffer mask values will cause the DMA descriptor command to
 * be terminated. BCH_AUXONLY = 0x100 Set to request transfer from only the
 * auxiliary buffer (block 0 on flash). BCH_PAGE = 0x1FF Set to request transfer
 * to/from the entire page.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_BUFFER_MASK (0U)   /*!< Bit position for GPMI_ECCCTRL_BUFFER_MASK. */
#define BM_GPMI_ECCCTRL_BUFFER_MASK (0x000001FFU) /*!< Bit mask for GPMI_ECCCTRL_BUFFER_MASK. */
#define BS_GPMI_ECCCTRL_BUFFER_MASK (9U)   /*!< Bit field size in bits for GPMI_ECCCTRL_BUFFER_MASK. */

/*! @brief Read current value of the GPMI_ECCCTRL_BUFFER_MASK field. */
#define BR_GPMI_ECCCTRL_BUFFER_MASK(x) (HW_GPMI_ECCCTRL(x).B.BUFFER_MASK)

/*! @brief Format value for bitfield GPMI_ECCCTRL_BUFFER_MASK. */
#define BF_GPMI_ECCCTRL_BUFFER_MASK(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCTRL_BUFFER_MASK) & BM_GPMI_ECCCTRL_BUFFER_MASK)

/*! @brief Set the BUFFER_MASK field to a new value. */
#define BW_GPMI_ECCCTRL_BUFFER_MASK(x, v) (HW_GPMI_ECCCTRL_WR(x, (HW_GPMI_ECCCTRL_RD(x) & ~BM_GPMI_ECCCTRL_BUFFER_MASK) | BF_GPMI_ECCCTRL_BUFFER_MASK(v)))
/*@}*/

/*!
 * @name Register GPMI_ECCCTRL, field RSVD1[11:9] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_RSVD1 (9U)         /*!< Bit position for GPMI_ECCCTRL_RSVD1. */
#define BM_GPMI_ECCCTRL_RSVD1 (0x00000E00U) /*!< Bit mask for GPMI_ECCCTRL_RSVD1. */
#define BS_GPMI_ECCCTRL_RSVD1 (3U)         /*!< Bit field size in bits for GPMI_ECCCTRL_RSVD1. */

/*! @brief Read current value of the GPMI_ECCCTRL_RSVD1 field. */
#define BR_GPMI_ECCCTRL_RSVD1(x) (HW_GPMI_ECCCTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_ECCCTRL, field ENABLE_ECC[12] (RW)
 *
 * Enable ECC processing of GPMI transfers. ENABLE = 0x1 Use integrated ECC for
 * read and write transfers. DISABLE = 0x0 Integrated ECC remains in idle.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_ENABLE_ECC (12U)   /*!< Bit position for GPMI_ECCCTRL_ENABLE_ECC. */
#define BM_GPMI_ECCCTRL_ENABLE_ECC (0x00001000U) /*!< Bit mask for GPMI_ECCCTRL_ENABLE_ECC. */
#define BS_GPMI_ECCCTRL_ENABLE_ECC (1U)    /*!< Bit field size in bits for GPMI_ECCCTRL_ENABLE_ECC. */

/*! @brief Read current value of the GPMI_ECCCTRL_ENABLE_ECC field. */
#define BR_GPMI_ECCCTRL_ENABLE_ECC(x) (HW_GPMI_ECCCTRL(x).B.ENABLE_ECC)

/*! @brief Format value for bitfield GPMI_ECCCTRL_ENABLE_ECC. */
#define BF_GPMI_ECCCTRL_ENABLE_ECC(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCTRL_ENABLE_ECC) & BM_GPMI_ECCCTRL_ENABLE_ECC)

/*! @brief Set the ENABLE_ECC field to a new value. */
#define BW_GPMI_ECCCTRL_ENABLE_ECC(x, v) (HW_GPMI_ECCCTRL_WR(x, (HW_GPMI_ECCCTRL_RD(x) & ~BM_GPMI_ECCCTRL_ENABLE_ECC) | BF_GPMI_ECCCTRL_ENABLE_ECC(v)))
/*@}*/

/*!
 * @name Register GPMI_ECCCTRL, field ECC_CMD[14:13] (RW)
 *
 * ECC Command information. DECODE = 0x0 Decode. ENCODE = 0x1 Encode. RESERVE2 =
 * 0x2 Reserved. RESERVE3 = 0x3 Reserved.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_ECC_CMD (13U)      /*!< Bit position for GPMI_ECCCTRL_ECC_CMD. */
#define BM_GPMI_ECCCTRL_ECC_CMD (0x00006000U) /*!< Bit mask for GPMI_ECCCTRL_ECC_CMD. */
#define BS_GPMI_ECCCTRL_ECC_CMD (2U)       /*!< Bit field size in bits for GPMI_ECCCTRL_ECC_CMD. */

/*! @brief Read current value of the GPMI_ECCCTRL_ECC_CMD field. */
#define BR_GPMI_ECCCTRL_ECC_CMD(x) (HW_GPMI_ECCCTRL(x).B.ECC_CMD)

/*! @brief Format value for bitfield GPMI_ECCCTRL_ECC_CMD. */
#define BF_GPMI_ECCCTRL_ECC_CMD(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCTRL_ECC_CMD) & BM_GPMI_ECCCTRL_ECC_CMD)

/*! @brief Set the ECC_CMD field to a new value. */
#define BW_GPMI_ECCCTRL_ECC_CMD(x, v) (HW_GPMI_ECCCTRL_WR(x, (HW_GPMI_ECCCTRL_RD(x) & ~BM_GPMI_ECCCTRL_ECC_CMD) | BF_GPMI_ECCCTRL_ECC_CMD(v)))
/*@}*/

/*!
 * @name Register GPMI_ECCCTRL, field RSVD2[15] (RW)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_RSVD2 (15U)        /*!< Bit position for GPMI_ECCCTRL_RSVD2. */
#define BM_GPMI_ECCCTRL_RSVD2 (0x00008000U) /*!< Bit mask for GPMI_ECCCTRL_RSVD2. */
#define BS_GPMI_ECCCTRL_RSVD2 (1U)         /*!< Bit field size in bits for GPMI_ECCCTRL_RSVD2. */

/*! @brief Read current value of the GPMI_ECCCTRL_RSVD2 field. */
#define BR_GPMI_ECCCTRL_RSVD2(x) (HW_GPMI_ECCCTRL(x).B.RSVD2)

/*! @brief Format value for bitfield GPMI_ECCCTRL_RSVD2. */
#define BF_GPMI_ECCCTRL_RSVD2(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCTRL_RSVD2) & BM_GPMI_ECCCTRL_RSVD2)

/*! @brief Set the RSVD2 field to a new value. */
#define BW_GPMI_ECCCTRL_RSVD2(x, v) (HW_GPMI_ECCCTRL_WR(x, (HW_GPMI_ECCCTRL_RD(x) & ~BM_GPMI_ECCCTRL_RSVD2) | BF_GPMI_ECCCTRL_RSVD2(v)))
/*@}*/

/*!
 * @name Register GPMI_ECCCTRL, field HANDLE[31:16] (RW)
 *
 * This is a register available to software to attach an identifier to a
 * transaction in progress. This handle will be available from the ECC register space
 * when the completion interrupt occurs.
 */
/*@{*/
#define BP_GPMI_ECCCTRL_HANDLE (16U)       /*!< Bit position for GPMI_ECCCTRL_HANDLE. */
#define BM_GPMI_ECCCTRL_HANDLE (0xFFFF0000U) /*!< Bit mask for GPMI_ECCCTRL_HANDLE. */
#define BS_GPMI_ECCCTRL_HANDLE (16U)       /*!< Bit field size in bits for GPMI_ECCCTRL_HANDLE. */

/*! @brief Read current value of the GPMI_ECCCTRL_HANDLE field. */
#define BR_GPMI_ECCCTRL_HANDLE(x) (HW_GPMI_ECCCTRL(x).B.HANDLE)

/*! @brief Format value for bitfield GPMI_ECCCTRL_HANDLE. */
#define BF_GPMI_ECCCTRL_HANDLE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCTRL_HANDLE) & BM_GPMI_ECCCTRL_HANDLE)

/*! @brief Set the HANDLE field to a new value. */
#define BW_GPMI_ECCCTRL_HANDLE(x, v) (HW_GPMI_ECCCTRL_WR(x, (HW_GPMI_ECCCTRL_RD(x) & ~BM_GPMI_ECCCTRL_HANDLE) | BF_GPMI_ECCCTRL_HANDLE(v)))
/*@}*/




/*******************************************************************************
 * HW_GPMI_ECCCOUNT - GPMI Integrated ECC Transfer Count Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_ECCCOUNT - GPMI Integrated ECC Transfer Count Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI ECC Transfer Count Register contains the count of bytes that flow
 * through the ECC sub­system. GPMI_ECCCOUNT 0x030
 */
typedef union _hw_gpmi_ecccount
{
    uint32_t U;
    struct _hw_gpmi_ecccount_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0]  */
        uint32_t RSVD2 : 16;           /*!< [31:16]  */
    } B;
} hw_gpmi_ecccount_t;

/*!
 * @name Constants and macros for entire GPMI_ECCCOUNT register
 */
/*@{*/
#define HW_GPMI_ECCCOUNT_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_GPMI_ECCCOUNT(x)      (*(__IO hw_gpmi_ecccount_t *) HW_GPMI_ECCCOUNT_ADDR(x))
#define HW_GPMI_ECCCOUNT_RD(x)   (HW_GPMI_ECCCOUNT(x).U)
#define HW_GPMI_ECCCOUNT_WR(x, v) (HW_GPMI_ECCCOUNT(x).U = (v))
#define HW_GPMI_ECCCOUNT_SET(x, v) (HW_GPMI_ECCCOUNT_WR(x, HW_GPMI_ECCCOUNT_RD(x) |  (v)))
#define HW_GPMI_ECCCOUNT_CLR(x, v) (HW_GPMI_ECCCOUNT_WR(x, HW_GPMI_ECCCOUNT_RD(x) & ~(v)))
#define HW_GPMI_ECCCOUNT_TOG(x, v) (HW_GPMI_ECCCOUNT_WR(x, HW_GPMI_ECCCOUNT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_ECCCOUNT bitfields
 */

/*!
 * @name Register GPMI_ECCCOUNT, field COUNT[15:0] (RW)
 *
 * Number of bytes to pass through ECC. This is the GPMI transfer count plus the
 * syndrome count that will be inserted into the stream by the ECC. In
 * DMA2ECC_MODE this count must match the GPMI_CTRL0_XFER_COUNT. A value of zero will
 * transfer 64K words.
 */
/*@{*/
#define BP_GPMI_ECCCOUNT_COUNT (0U)        /*!< Bit position for GPMI_ECCCOUNT_COUNT. */
#define BM_GPMI_ECCCOUNT_COUNT (0x0000FFFFU) /*!< Bit mask for GPMI_ECCCOUNT_COUNT. */
#define BS_GPMI_ECCCOUNT_COUNT (16U)       /*!< Bit field size in bits for GPMI_ECCCOUNT_COUNT. */

/*! @brief Read current value of the GPMI_ECCCOUNT_COUNT field. */
#define BR_GPMI_ECCCOUNT_COUNT(x) (HW_GPMI_ECCCOUNT(x).B.COUNT)

/*! @brief Format value for bitfield GPMI_ECCCOUNT_COUNT. */
#define BF_GPMI_ECCCOUNT_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCOUNT_COUNT) & BM_GPMI_ECCCOUNT_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPMI_ECCCOUNT_COUNT(x, v) (HW_GPMI_ECCCOUNT_WR(x, (HW_GPMI_ECCCOUNT_RD(x) & ~BM_GPMI_ECCCOUNT_COUNT) | BF_GPMI_ECCCOUNT_COUNT(v)))
/*@}*/

/*!
 * @name Register GPMI_ECCCOUNT, field RSVD2[31:16] (RW)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_ECCCOUNT_RSVD2 (16U)       /*!< Bit position for GPMI_ECCCOUNT_RSVD2. */
#define BM_GPMI_ECCCOUNT_RSVD2 (0xFFFF0000U) /*!< Bit mask for GPMI_ECCCOUNT_RSVD2. */
#define BS_GPMI_ECCCOUNT_RSVD2 (16U)       /*!< Bit field size in bits for GPMI_ECCCOUNT_RSVD2. */

/*! @brief Read current value of the GPMI_ECCCOUNT_RSVD2 field. */
#define BR_GPMI_ECCCOUNT_RSVD2(x) (HW_GPMI_ECCCOUNT(x).B.RSVD2)

/*! @brief Format value for bitfield GPMI_ECCCOUNT_RSVD2. */
#define BF_GPMI_ECCCOUNT_RSVD2(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_ECCCOUNT_RSVD2) & BM_GPMI_ECCCOUNT_RSVD2)

/*! @brief Set the RSVD2 field to a new value. */
#define BW_GPMI_ECCCOUNT_RSVD2(x, v) (HW_GPMI_ECCCOUNT_WR(x, (HW_GPMI_ECCCOUNT_RD(x) & ~BM_GPMI_ECCCOUNT_RSVD2) | BF_GPMI_ECCCOUNT_RSVD2(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_PAYLOAD - GPMI Payload Address Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_PAYLOAD - GPMI Payload Address Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI payload address register specifies the location of the data buffers
 * in system memory. This value must be word aligned. GPMI_PAYLOAD 0x040
 */
typedef union _hw_gpmi_payload
{
    uint32_t U;
    struct _hw_gpmi_payload_bitfields
    {
        uint32_t RSVD0 : 2;            /*!< [1:0]  */
        uint32_t ADDRESS : 30;         /*!< [31:2]  */
    } B;
} hw_gpmi_payload_t;

/*!
 * @name Constants and macros for entire GPMI_PAYLOAD register
 */
/*@{*/
#define HW_GPMI_PAYLOAD_ADDR(x)  ((uintptr_t)(x) + 0x40U)

#define HW_GPMI_PAYLOAD(x)       (*(__IO hw_gpmi_payload_t *) HW_GPMI_PAYLOAD_ADDR(x))
#define HW_GPMI_PAYLOAD_RD(x)    (HW_GPMI_PAYLOAD(x).U)
#define HW_GPMI_PAYLOAD_WR(x, v) (HW_GPMI_PAYLOAD(x).U = (v))
#define HW_GPMI_PAYLOAD_SET(x, v) (HW_GPMI_PAYLOAD_WR(x, HW_GPMI_PAYLOAD_RD(x) |  (v)))
#define HW_GPMI_PAYLOAD_CLR(x, v) (HW_GPMI_PAYLOAD_WR(x, HW_GPMI_PAYLOAD_RD(x) & ~(v)))
#define HW_GPMI_PAYLOAD_TOG(x, v) (HW_GPMI_PAYLOAD_WR(x, HW_GPMI_PAYLOAD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_PAYLOAD bitfields
 */

/*!
 * @name Register GPMI_PAYLOAD, field RSVD0[1:0] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_PAYLOAD_RSVD0 (0U)         /*!< Bit position for GPMI_PAYLOAD_RSVD0. */
#define BM_GPMI_PAYLOAD_RSVD0 (0x00000003U) /*!< Bit mask for GPMI_PAYLOAD_RSVD0. */
#define BS_GPMI_PAYLOAD_RSVD0 (2U)         /*!< Bit field size in bits for GPMI_PAYLOAD_RSVD0. */

/*! @brief Read current value of the GPMI_PAYLOAD_RSVD0 field. */
#define BR_GPMI_PAYLOAD_RSVD0(x) (HW_GPMI_PAYLOAD(x).B.RSVD0)
/*@}*/

/*!
 * @name Register GPMI_PAYLOAD, field ADDRESS[31:2] (RW)
 *
 * Pointer to an array of one or more 512 byte payload buffers.
 */
/*@{*/
#define BP_GPMI_PAYLOAD_ADDRESS (2U)       /*!< Bit position for GPMI_PAYLOAD_ADDRESS. */
#define BM_GPMI_PAYLOAD_ADDRESS (0xFFFFFFFCU) /*!< Bit mask for GPMI_PAYLOAD_ADDRESS. */
#define BS_GPMI_PAYLOAD_ADDRESS (30U)      /*!< Bit field size in bits for GPMI_PAYLOAD_ADDRESS. */

/*! @brief Read current value of the GPMI_PAYLOAD_ADDRESS field. */
#define BR_GPMI_PAYLOAD_ADDRESS(x) (HW_GPMI_PAYLOAD(x).B.ADDRESS)

/*! @brief Format value for bitfield GPMI_PAYLOAD_ADDRESS. */
#define BF_GPMI_PAYLOAD_ADDRESS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_PAYLOAD_ADDRESS) & BM_GPMI_PAYLOAD_ADDRESS)

/*! @brief Set the ADDRESS field to a new value. */
#define BW_GPMI_PAYLOAD_ADDRESS(x, v) (HW_GPMI_PAYLOAD_WR(x, (HW_GPMI_PAYLOAD_RD(x) & ~BM_GPMI_PAYLOAD_ADDRESS) | BF_GPMI_PAYLOAD_ADDRESS(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_AUXILIARY - GPMI Auxiliary Address Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_AUXILIARY - GPMI Auxiliary Address Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI auxiliary address register specifies the location of the auxiliary
 * buffers in system memory. This value must be word aligned. GPMI_AUXILIARY 0x050
 */
typedef union _hw_gpmi_auxiliary
{
    uint32_t U;
    struct _hw_gpmi_auxiliary_bitfields
    {
        uint32_t RSVD0 : 2;            /*!< [1:0]  */
        uint32_t ADDRESS : 30;         /*!< [31:2]  */
    } B;
} hw_gpmi_auxiliary_t;

/*!
 * @name Constants and macros for entire GPMI_AUXILIARY register
 */
/*@{*/
#define HW_GPMI_AUXILIARY_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_GPMI_AUXILIARY(x)     (*(__IO hw_gpmi_auxiliary_t *) HW_GPMI_AUXILIARY_ADDR(x))
#define HW_GPMI_AUXILIARY_RD(x)  (HW_GPMI_AUXILIARY(x).U)
#define HW_GPMI_AUXILIARY_WR(x, v) (HW_GPMI_AUXILIARY(x).U = (v))
#define HW_GPMI_AUXILIARY_SET(x, v) (HW_GPMI_AUXILIARY_WR(x, HW_GPMI_AUXILIARY_RD(x) |  (v)))
#define HW_GPMI_AUXILIARY_CLR(x, v) (HW_GPMI_AUXILIARY_WR(x, HW_GPMI_AUXILIARY_RD(x) & ~(v)))
#define HW_GPMI_AUXILIARY_TOG(x, v) (HW_GPMI_AUXILIARY_WR(x, HW_GPMI_AUXILIARY_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_AUXILIARY bitfields
 */

/*!
 * @name Register GPMI_AUXILIARY, field RSVD0[1:0] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_AUXILIARY_RSVD0 (0U)       /*!< Bit position for GPMI_AUXILIARY_RSVD0. */
#define BM_GPMI_AUXILIARY_RSVD0 (0x00000003U) /*!< Bit mask for GPMI_AUXILIARY_RSVD0. */
#define BS_GPMI_AUXILIARY_RSVD0 (2U)       /*!< Bit field size in bits for GPMI_AUXILIARY_RSVD0. */

/*! @brief Read current value of the GPMI_AUXILIARY_RSVD0 field. */
#define BR_GPMI_AUXILIARY_RSVD0(x) (HW_GPMI_AUXILIARY(x).B.RSVD0)
/*@}*/

/*!
 * @name Register GPMI_AUXILIARY, field ADDRESS[31:2] (RW)
 *
 * Pointer to ECC control structure and meta-data storage.
 */
/*@{*/
#define BP_GPMI_AUXILIARY_ADDRESS (2U)     /*!< Bit position for GPMI_AUXILIARY_ADDRESS. */
#define BM_GPMI_AUXILIARY_ADDRESS (0xFFFFFFFCU) /*!< Bit mask for GPMI_AUXILIARY_ADDRESS. */
#define BS_GPMI_AUXILIARY_ADDRESS (30U)    /*!< Bit field size in bits for GPMI_AUXILIARY_ADDRESS. */

/*! @brief Read current value of the GPMI_AUXILIARY_ADDRESS field. */
#define BR_GPMI_AUXILIARY_ADDRESS(x) (HW_GPMI_AUXILIARY(x).B.ADDRESS)

/*! @brief Format value for bitfield GPMI_AUXILIARY_ADDRESS. */
#define BF_GPMI_AUXILIARY_ADDRESS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_AUXILIARY_ADDRESS) & BM_GPMI_AUXILIARY_ADDRESS)

/*! @brief Set the ADDRESS field to a new value. */
#define BW_GPMI_AUXILIARY_ADDRESS(x, v) (HW_GPMI_AUXILIARY_WR(x, (HW_GPMI_AUXILIARY_RD(x) & ~BM_GPMI_AUXILIARY_ADDRESS) | BF_GPMI_AUXILIARY_ADDRESS(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_CTRL1 - GPMI Control Register 1 Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_CTRL1 - GPMI Control Register 1 Description (RW)
 *
 * Reset value: 0x00040004U
 *
 * The GPMI control register 1 specifies additional control fields that are not
 * used on a per-transaction basis.
 */
typedef union _hw_gpmi_ctrl1
{
    uint32_t U;
    struct _hw_gpmi_ctrl1_bitfields
    {
        uint32_t GPMI_MODE : 1;        /*!< [0]  */
        uint32_t CAMERA_MODE : 1;      /*!< [1]  */
        uint32_t ATA_IRQRDY_POLARITY : 1; /*!< [2]  */
        uint32_t DEV_RESET : 1;        /*!< [3]  */
        uint32_t ABORT_WAIT_FOR_READY_CHANNEL : 3; /*!< [6:4]  */
        uint32_t ABORT_WAIT_REQUEST : 1; /*!< [7]  */
        uint32_t BURST_EN : 1;         /*!< [8]  */
        uint32_t TIMEOUT_IRQ : 1;      /*!< [9]  */
        uint32_t DEV_IRQ : 1;          /*!< [10]  */
        uint32_t DMA2ECC_MODE : 1;     /*!< [11]  */
        uint32_t RDN_DELAY : 4;        /*!< [15:12]  */
        uint32_t HALF_PERIOD : 1;      /*!< [16]  */
        uint32_t DLL_ENABLE : 1;       /*!< [17]  */
        uint32_t BCH_MODE : 1;         /*!< [18]  */
        uint32_t GANGED_RDYBUSY : 1;   /*!< [19]  */
        uint32_t TIMEOUT_IRQ_EN : 1;   /*!< [20]  */
        uint32_t RSVD1 : 1;            /*!< [21]  */
        uint32_t WRN_DLY_SEL : 2;      /*!< [23:22]  */
        uint32_t DECOUPLE_CS : 1;      /*!< [24]  */
        uint32_t SSYNCMODE : 1;        /*!< [25]  */
        uint32_t UPDATE_CS : 1;        /*!< [26]  */
        uint32_t GPMI_CLK_DIV2_EN : 1; /*!< [27]  */
        uint32_t TOGGLE_MODE : 1;      /*!< [28]  */
        uint32_t WRITE_CLK_STOP : 1;   /*!< [29]  */
        uint32_t SSYNC_CLK_STOP : 1;   /*!< [30]  */
        uint32_t DEV_CLK_STOP : 1;     /*!< [31]  */
    } B;
} hw_gpmi_ctrl1_t;

/*!
 * @name Constants and macros for entire GPMI_CTRL1 register
 */
/*@{*/
#define HW_GPMI_CTRL1_ADDR(x)    ((uintptr_t)(x) + 0x60U)
#define HW_GPMI_CTRL1_SET_ADDR(x) (HW_GPMI_CTRL1_ADDR(x) + 0x4U)
#define HW_GPMI_CTRL1_CLR_ADDR(x) (HW_GPMI_CTRL1_ADDR(x) + 0x8U)
#define HW_GPMI_CTRL1_TOG_ADDR(x) (HW_GPMI_CTRL1_ADDR(x) + 0xCU)

#define HW_GPMI_CTRL1(x)         (*(__IO hw_gpmi_ctrl1_t *) HW_GPMI_CTRL1_ADDR(x))
#define HW_GPMI_CTRL1_RD(x)      (HW_GPMI_CTRL1(x).U)
#define HW_GPMI_CTRL1_WR(x, v)   (HW_GPMI_CTRL1(x).U = (v))
#define HW_GPMI_CTRL1_SET(x, v)  ((*(uint32_t *) HW_GPMI_CTRL1_SET_ADDR(x)) = (v))
#define HW_GPMI_CTRL1_CLR(x, v)  ((*(uint32_t *) HW_GPMI_CTRL1_CLR_ADDR(x)) = (v))
#define HW_GPMI_CTRL1_TOG(x, v)  ((*(uint32_t *) HW_GPMI_CTRL1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual GPMI_CTRL1 bitfields
 */

/*!
 * @name Register GPMI_CTRL1, field GPMI_MODE[0] (RW)
 *
 * ATA mode is only supported on channel zero. If ATA mode is selected, then
 * only channel three is available for NAND use. NAND = 0x0 NAND mode. ATA = 0x1 ATA
 * mode.
 *
 * Values:
 * - 0 - NAND mode.
 * - 1 - ATA mode.
 */
/*@{*/
#define BP_GPMI_CTRL1_GPMI_MODE (0U)       /*!< Bit position for GPMI_CTRL1_GPMI_MODE. */
#define BM_GPMI_CTRL1_GPMI_MODE (0x00000001U) /*!< Bit mask for GPMI_CTRL1_GPMI_MODE. */
#define BS_GPMI_CTRL1_GPMI_MODE (1U)       /*!< Bit field size in bits for GPMI_CTRL1_GPMI_MODE. */

/*! @brief Read current value of the GPMI_CTRL1_GPMI_MODE field. */
#define BR_GPMI_CTRL1_GPMI_MODE(x) (HW_GPMI_CTRL1(x).B.GPMI_MODE)

/*! @brief Format value for bitfield GPMI_CTRL1_GPMI_MODE. */
#define BF_GPMI_CTRL1_GPMI_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_GPMI_MODE) & BM_GPMI_CTRL1_GPMI_MODE)

/*! @brief Set the GPMI_MODE field to a new value. */
#define BW_GPMI_CTRL1_GPMI_MODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_GPMI_MODE) | BF_GPMI_CTRL1_GPMI_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field CAMERA_MODE[1] (RW)
 *
 * When set to 1 and ATA UDMA is enabled the UDMA interface becomes a camera
 * interface.
 */
/*@{*/
#define BP_GPMI_CTRL1_CAMERA_MODE (1U)     /*!< Bit position for GPMI_CTRL1_CAMERA_MODE. */
#define BM_GPMI_CTRL1_CAMERA_MODE (0x00000002U) /*!< Bit mask for GPMI_CTRL1_CAMERA_MODE. */
#define BS_GPMI_CTRL1_CAMERA_MODE (1U)     /*!< Bit field size in bits for GPMI_CTRL1_CAMERA_MODE. */

/*! @brief Read current value of the GPMI_CTRL1_CAMERA_MODE field. */
#define BR_GPMI_CTRL1_CAMERA_MODE(x) (HW_GPMI_CTRL1(x).B.CAMERA_MODE)

/*! @brief Format value for bitfield GPMI_CTRL1_CAMERA_MODE. */
#define BF_GPMI_CTRL1_CAMERA_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_CAMERA_MODE) & BM_GPMI_CTRL1_CAMERA_MODE)

/*! @brief Set the CAMERA_MODE field to a new value. */
#define BW_GPMI_CTRL1_CAMERA_MODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_CAMERA_MODE) | BF_GPMI_CTRL1_CAMERA_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field ATA_IRQRDY_POLARITY[2] (RW)
 *
 * For ATA MODE: Note NAND_RDY_BUSY[3:2] are not affected by this bit. ACTIVELOW
 * = 0x0 ATA IORDY and IRQ are active low, or NAND_RDY_BUSY[1:0] are active low
 * ready. ACTIVEHIGH = 0x1 ATA IORDY and IRQ are active high, or
 * NAND_RDY_BUSY[1:0] are active high ready. 0 External ATA IORDY and IRQ are active low. 1
 * External ATA IORDY and IRQ are active high. For NAND MODE:
 *
 * Values:
 * - 0 - External RDY_BUSY[1] and RDY_BUSY[0] pins are ready when low and busy
 *     when high.
 * - 1 - External RDY_BUSY[1] and RDY_BUSY[0] pins are ready when high and busy
 *     when low.
 */
/*@{*/
#define BP_GPMI_CTRL1_ATA_IRQRDY_POLARITY (2U) /*!< Bit position for GPMI_CTRL1_ATA_IRQRDY_POLARITY. */
#define BM_GPMI_CTRL1_ATA_IRQRDY_POLARITY (0x00000004U) /*!< Bit mask for GPMI_CTRL1_ATA_IRQRDY_POLARITY. */
#define BS_GPMI_CTRL1_ATA_IRQRDY_POLARITY (1U) /*!< Bit field size in bits for GPMI_CTRL1_ATA_IRQRDY_POLARITY. */

/*! @brief Read current value of the GPMI_CTRL1_ATA_IRQRDY_POLARITY field. */
#define BR_GPMI_CTRL1_ATA_IRQRDY_POLARITY(x) (HW_GPMI_CTRL1(x).B.ATA_IRQRDY_POLARITY)

/*! @brief Format value for bitfield GPMI_CTRL1_ATA_IRQRDY_POLARITY. */
#define BF_GPMI_CTRL1_ATA_IRQRDY_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_ATA_IRQRDY_POLARITY) & BM_GPMI_CTRL1_ATA_IRQRDY_POLARITY)

/*! @brief Set the ATA_IRQRDY_POLARITY field to a new value. */
#define BW_GPMI_CTRL1_ATA_IRQRDY_POLARITY(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_ATA_IRQRDY_POLARITY) | BF_GPMI_CTRL1_ATA_IRQRDY_POLARITY(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DEV_RESET[3] (RW)
 *
 * ENABLED = 0x0 NANDF_WP_B(WPN) pin is held low (asserted). DISABLED = 0x1
 * NANDF_WP_B(WPN) pin is held high (de-asserted).
 *
 * Values:
 * - 0 - NANDF_WP_B pin is held low (asserted).
 * - 1 - NANDF_WP_B pin is held high (de-asserted).
 */
/*@{*/
#define BP_GPMI_CTRL1_DEV_RESET (3U)       /*!< Bit position for GPMI_CTRL1_DEV_RESET. */
#define BM_GPMI_CTRL1_DEV_RESET (0x00000008U) /*!< Bit mask for GPMI_CTRL1_DEV_RESET. */
#define BS_GPMI_CTRL1_DEV_RESET (1U)       /*!< Bit field size in bits for GPMI_CTRL1_DEV_RESET. */

/*! @brief Read current value of the GPMI_CTRL1_DEV_RESET field. */
#define BR_GPMI_CTRL1_DEV_RESET(x) (HW_GPMI_CTRL1(x).B.DEV_RESET)

/*! @brief Format value for bitfield GPMI_CTRL1_DEV_RESET. */
#define BF_GPMI_CTRL1_DEV_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DEV_RESET) & BM_GPMI_CTRL1_DEV_RESET)

/*! @brief Set the DEV_RESET field to a new value. */
#define BW_GPMI_CTRL1_DEV_RESET(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DEV_RESET) | BF_GPMI_CTRL1_DEV_RESET(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field ABORT_WAIT_FOR_READY_CHANNEL[6:4] (RW)
 *
 * Abort a wait for ready command on selected channel. Set the
 * ABORT_WAIT_REQUEST to kick of operation.
 */
/*@{*/
#define BP_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL (4U) /*!< Bit position for GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL. */
#define BM_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL (0x00000070U) /*!< Bit mask for GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL. */
#define BS_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL (3U) /*!< Bit field size in bits for GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL. */

/*! @brief Read current value of the GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL field. */
#define BR_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL(x) (HW_GPMI_CTRL1(x).B.ABORT_WAIT_FOR_READY_CHANNEL)

/*! @brief Format value for bitfield GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL. */
#define BF_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL) & BM_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL)

/*! @brief Set the ABORT_WAIT_FOR_READY_CHANNEL field to a new value. */
#define BW_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL) | BF_GPMI_CTRL1_ABORT_WAIT_FOR_READY_CHANNEL(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field ABORT_WAIT_REQUEST[7] (RW)
 *
 * Request to abort "wait for ready" command on channel indicated by
 * ABORT_WAIT_FOR_READY_CHANNEL. Hardware will clear this bit when abort is done.
 */
/*@{*/
#define BP_GPMI_CTRL1_ABORT_WAIT_REQUEST (7U) /*!< Bit position for GPMI_CTRL1_ABORT_WAIT_REQUEST. */
#define BM_GPMI_CTRL1_ABORT_WAIT_REQUEST (0x00000080U) /*!< Bit mask for GPMI_CTRL1_ABORT_WAIT_REQUEST. */
#define BS_GPMI_CTRL1_ABORT_WAIT_REQUEST (1U) /*!< Bit field size in bits for GPMI_CTRL1_ABORT_WAIT_REQUEST. */

/*! @brief Read current value of the GPMI_CTRL1_ABORT_WAIT_REQUEST field. */
#define BR_GPMI_CTRL1_ABORT_WAIT_REQUEST(x) (HW_GPMI_CTRL1(x).B.ABORT_WAIT_REQUEST)

/*! @brief Format value for bitfield GPMI_CTRL1_ABORT_WAIT_REQUEST. */
#define BF_GPMI_CTRL1_ABORT_WAIT_REQUEST(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_ABORT_WAIT_REQUEST) & BM_GPMI_CTRL1_ABORT_WAIT_REQUEST)

/*! @brief Set the ABORT_WAIT_REQUEST field to a new value. */
#define BW_GPMI_CTRL1_ABORT_WAIT_REQUEST(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_ABORT_WAIT_REQUEST) | BF_GPMI_CTRL1_ABORT_WAIT_REQUEST(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field BURST_EN[8] (RW)
 *
 * When set to 1 each DMA request will generate a 4-transfer burst on the APB
 * bus.
 */
/*@{*/
#define BP_GPMI_CTRL1_BURST_EN (8U)        /*!< Bit position for GPMI_CTRL1_BURST_EN. */
#define BM_GPMI_CTRL1_BURST_EN (0x00000100U) /*!< Bit mask for GPMI_CTRL1_BURST_EN. */
#define BS_GPMI_CTRL1_BURST_EN (1U)        /*!< Bit field size in bits for GPMI_CTRL1_BURST_EN. */

/*! @brief Read current value of the GPMI_CTRL1_BURST_EN field. */
#define BR_GPMI_CTRL1_BURST_EN(x) (HW_GPMI_CTRL1(x).B.BURST_EN)

/*! @brief Format value for bitfield GPMI_CTRL1_BURST_EN. */
#define BF_GPMI_CTRL1_BURST_EN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_BURST_EN) & BM_GPMI_CTRL1_BURST_EN)

/*! @brief Set the BURST_EN field to a new value. */
#define BW_GPMI_CTRL1_BURST_EN(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_BURST_EN) | BF_GPMI_CTRL1_BURST_EN(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field TIMEOUT_IRQ[9] (RW)
 *
 * This bit is set when a timeout occurs using the Device_Busy_Timeout value.
 * Write 0 to clear.
 */
/*@{*/
#define BP_GPMI_CTRL1_TIMEOUT_IRQ (9U)     /*!< Bit position for GPMI_CTRL1_TIMEOUT_IRQ. */
#define BM_GPMI_CTRL1_TIMEOUT_IRQ (0x00000200U) /*!< Bit mask for GPMI_CTRL1_TIMEOUT_IRQ. */
#define BS_GPMI_CTRL1_TIMEOUT_IRQ (1U)     /*!< Bit field size in bits for GPMI_CTRL1_TIMEOUT_IRQ. */

/*! @brief Read current value of the GPMI_CTRL1_TIMEOUT_IRQ field. */
#define BR_GPMI_CTRL1_TIMEOUT_IRQ(x) (HW_GPMI_CTRL1(x).B.TIMEOUT_IRQ)

/*! @brief Format value for bitfield GPMI_CTRL1_TIMEOUT_IRQ. */
#define BF_GPMI_CTRL1_TIMEOUT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_TIMEOUT_IRQ) & BM_GPMI_CTRL1_TIMEOUT_IRQ)

/*! @brief Set the TIMEOUT_IRQ field to a new value. */
#define BW_GPMI_CTRL1_TIMEOUT_IRQ(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_TIMEOUT_IRQ) | BF_GPMI_CTRL1_TIMEOUT_IRQ(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DEV_IRQ[10] (RW)
 *
 * This bit is set when an Interrupt is received from the ATA device. Write 0 to
 * clear.
 */
/*@{*/
#define BP_GPMI_CTRL1_DEV_IRQ (10U)        /*!< Bit position for GPMI_CTRL1_DEV_IRQ. */
#define BM_GPMI_CTRL1_DEV_IRQ (0x00000400U) /*!< Bit mask for GPMI_CTRL1_DEV_IRQ. */
#define BS_GPMI_CTRL1_DEV_IRQ (1U)         /*!< Bit field size in bits for GPMI_CTRL1_DEV_IRQ. */

/*! @brief Read current value of the GPMI_CTRL1_DEV_IRQ field. */
#define BR_GPMI_CTRL1_DEV_IRQ(x) (HW_GPMI_CTRL1(x).B.DEV_IRQ)

/*! @brief Format value for bitfield GPMI_CTRL1_DEV_IRQ. */
#define BF_GPMI_CTRL1_DEV_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DEV_IRQ) & BM_GPMI_CTRL1_DEV_IRQ)

/*! @brief Set the DEV_IRQ field to a new value. */
#define BW_GPMI_CTRL1_DEV_IRQ(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DEV_IRQ) | BF_GPMI_CTRL1_DEV_IRQ(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DMA2ECC_MODE[11] (RW)
 *
 * This is mainly for testing HWECC without involving the Nand device. Setting
 * this bit will cause DMA write data to redirected to HWECC module (instead of
 * Nand Device) for encoding or decoding.
 */
/*@{*/
#define BP_GPMI_CTRL1_DMA2ECC_MODE (11U)   /*!< Bit position for GPMI_CTRL1_DMA2ECC_MODE. */
#define BM_GPMI_CTRL1_DMA2ECC_MODE (0x00000800U) /*!< Bit mask for GPMI_CTRL1_DMA2ECC_MODE. */
#define BS_GPMI_CTRL1_DMA2ECC_MODE (1U)    /*!< Bit field size in bits for GPMI_CTRL1_DMA2ECC_MODE. */

/*! @brief Read current value of the GPMI_CTRL1_DMA2ECC_MODE field. */
#define BR_GPMI_CTRL1_DMA2ECC_MODE(x) (HW_GPMI_CTRL1(x).B.DMA2ECC_MODE)

/*! @brief Format value for bitfield GPMI_CTRL1_DMA2ECC_MODE. */
#define BF_GPMI_CTRL1_DMA2ECC_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DMA2ECC_MODE) & BM_GPMI_CTRL1_DMA2ECC_MODE)

/*! @brief Set the DMA2ECC_MODE field to a new value. */
#define BW_GPMI_CTRL1_DMA2ECC_MODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DMA2ECC_MODE) | BF_GPMI_CTRL1_DMA2ECC_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field RDN_DELAY[15:12] (RW)
 *
 * This variable is a factor in the calculated delay to apply to the internal
 * read strobe for correct read data sampling. The applied delay (AD) is between 0
 * and 1.875 times the reference period (RP). RP is one half of the GPMI clock
 * period if HALF_PERIOD=1 otherwise it is the full GPMI clock period. The equation
 * is: AD = RDN_DELAY x 0.125 x RP. This value must not exceed 16ns. This
 * variable is used to achieve faster NAND access. For example if the Read Strobe is
 * asserted from time 0 to 13ns but the read access time is 20ns, then choose
 * AD=12ns will cause the data to be sampled at time 25ns (13+12) giving a 5ns data
 * setup time. If RP=13ns then RDN_DELAY = 12/(0.125 x 13ns) = 7.38 (0111b).
 * DLL_ENABLE must be zero while changing this field.
 */
/*@{*/
#define BP_GPMI_CTRL1_RDN_DELAY (12U)      /*!< Bit position for GPMI_CTRL1_RDN_DELAY. */
#define BM_GPMI_CTRL1_RDN_DELAY (0x0000F000U) /*!< Bit mask for GPMI_CTRL1_RDN_DELAY. */
#define BS_GPMI_CTRL1_RDN_DELAY (4U)       /*!< Bit field size in bits for GPMI_CTRL1_RDN_DELAY. */

/*! @brief Read current value of the GPMI_CTRL1_RDN_DELAY field. */
#define BR_GPMI_CTRL1_RDN_DELAY(x) (HW_GPMI_CTRL1(x).B.RDN_DELAY)

/*! @brief Format value for bitfield GPMI_CTRL1_RDN_DELAY. */
#define BF_GPMI_CTRL1_RDN_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_RDN_DELAY) & BM_GPMI_CTRL1_RDN_DELAY)

/*! @brief Set the RDN_DELAY field to a new value. */
#define BW_GPMI_CTRL1_RDN_DELAY(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_RDN_DELAY) | BF_GPMI_CTRL1_RDN_DELAY(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field HALF_PERIOD[16] (RW)
 *
 * Set this bit to 1 if the GPMI clock period is greater than 16ns for proper
 * DLL operation. DLL_ENABLE must be zero while changing this field.
 */
/*@{*/
#define BP_GPMI_CTRL1_HALF_PERIOD (16U)    /*!< Bit position for GPMI_CTRL1_HALF_PERIOD. */
#define BM_GPMI_CTRL1_HALF_PERIOD (0x00010000U) /*!< Bit mask for GPMI_CTRL1_HALF_PERIOD. */
#define BS_GPMI_CTRL1_HALF_PERIOD (1U)     /*!< Bit field size in bits for GPMI_CTRL1_HALF_PERIOD. */

/*! @brief Read current value of the GPMI_CTRL1_HALF_PERIOD field. */
#define BR_GPMI_CTRL1_HALF_PERIOD(x) (HW_GPMI_CTRL1(x).B.HALF_PERIOD)

/*! @brief Format value for bitfield GPMI_CTRL1_HALF_PERIOD. */
#define BF_GPMI_CTRL1_HALF_PERIOD(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_HALF_PERIOD) & BM_GPMI_CTRL1_HALF_PERIOD)

/*! @brief Set the HALF_PERIOD field to a new value. */
#define BW_GPMI_CTRL1_HALF_PERIOD(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_HALF_PERIOD) | BF_GPMI_CTRL1_HALF_PERIOD(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DLL_ENABLE[17] (RW)
 *
 * Set this bit to 1 to enable the GPMI DLL. This is required for fast NAND
 * reads (above 30 MHz read strobe). After setting this bit, wait 64 GPMI clock
 * cycles for the DLL to lock before performing a NAND read.
 */
/*@{*/
#define BP_GPMI_CTRL1_DLL_ENABLE (17U)     /*!< Bit position for GPMI_CTRL1_DLL_ENABLE. */
#define BM_GPMI_CTRL1_DLL_ENABLE (0x00020000U) /*!< Bit mask for GPMI_CTRL1_DLL_ENABLE. */
#define BS_GPMI_CTRL1_DLL_ENABLE (1U)      /*!< Bit field size in bits for GPMI_CTRL1_DLL_ENABLE. */

/*! @brief Read current value of the GPMI_CTRL1_DLL_ENABLE field. */
#define BR_GPMI_CTRL1_DLL_ENABLE(x) (HW_GPMI_CTRL1(x).B.DLL_ENABLE)

/*! @brief Format value for bitfield GPMI_CTRL1_DLL_ENABLE. */
#define BF_GPMI_CTRL1_DLL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DLL_ENABLE) & BM_GPMI_CTRL1_DLL_ENABLE)

/*! @brief Set the DLL_ENABLE field to a new value. */
#define BW_GPMI_CTRL1_DLL_ENABLE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DLL_ENABLE) | BF_GPMI_CTRL1_DLL_ENABLE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field BCH_MODE[18] (RW)
 *
 * This bit selects which error correction unit will access GPMI. This bit must
 * always be set to '1', since only the BCH unit is available in this design.
 */
/*@{*/
#define BP_GPMI_CTRL1_BCH_MODE (18U)       /*!< Bit position for GPMI_CTRL1_BCH_MODE. */
#define BM_GPMI_CTRL1_BCH_MODE (0x00040000U) /*!< Bit mask for GPMI_CTRL1_BCH_MODE. */
#define BS_GPMI_CTRL1_BCH_MODE (1U)        /*!< Bit field size in bits for GPMI_CTRL1_BCH_MODE. */

/*! @brief Read current value of the GPMI_CTRL1_BCH_MODE field. */
#define BR_GPMI_CTRL1_BCH_MODE(x) (HW_GPMI_CTRL1(x).B.BCH_MODE)

/*! @brief Format value for bitfield GPMI_CTRL1_BCH_MODE. */
#define BF_GPMI_CTRL1_BCH_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_BCH_MODE) & BM_GPMI_CTRL1_BCH_MODE)

/*! @brief Set the BCH_MODE field to a new value. */
#define BW_GPMI_CTRL1_BCH_MODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_BCH_MODE) | BF_GPMI_CTRL1_BCH_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field GANGED_RDYBUSY[19] (RW)
 *
 * Set this bit to 1 will force all Nand RDY_BUSY inputs to be sourced from
 * (tied to) RDY_BUSY0. This will free up all, except one, RDY_BUSY input pins.
 */
/*@{*/
#define BP_GPMI_CTRL1_GANGED_RDYBUSY (19U) /*!< Bit position for GPMI_CTRL1_GANGED_RDYBUSY. */
#define BM_GPMI_CTRL1_GANGED_RDYBUSY (0x00080000U) /*!< Bit mask for GPMI_CTRL1_GANGED_RDYBUSY. */
#define BS_GPMI_CTRL1_GANGED_RDYBUSY (1U)  /*!< Bit field size in bits for GPMI_CTRL1_GANGED_RDYBUSY. */

/*! @brief Read current value of the GPMI_CTRL1_GANGED_RDYBUSY field. */
#define BR_GPMI_CTRL1_GANGED_RDYBUSY(x) (HW_GPMI_CTRL1(x).B.GANGED_RDYBUSY)

/*! @brief Format value for bitfield GPMI_CTRL1_GANGED_RDYBUSY. */
#define BF_GPMI_CTRL1_GANGED_RDYBUSY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_GANGED_RDYBUSY) & BM_GPMI_CTRL1_GANGED_RDYBUSY)

/*! @brief Set the GANGED_RDYBUSY field to a new value. */
#define BW_GPMI_CTRL1_GANGED_RDYBUSY(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_GANGED_RDYBUSY) | BF_GPMI_CTRL1_GANGED_RDYBUSY(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field TIMEOUT_IRQ_EN[20] (RW)
 *
 * Setting this bit to '1' will enable timeout IRQ for transfers in ATA mode
 * only, and for WAIT_FOR_READY commands in both ATA and Nand mode. The
 * Device_Busy_Timeout value is used for this timeout.
 */
/*@{*/
#define BP_GPMI_CTRL1_TIMEOUT_IRQ_EN (20U) /*!< Bit position for GPMI_CTRL1_TIMEOUT_IRQ_EN. */
#define BM_GPMI_CTRL1_TIMEOUT_IRQ_EN (0x00100000U) /*!< Bit mask for GPMI_CTRL1_TIMEOUT_IRQ_EN. */
#define BS_GPMI_CTRL1_TIMEOUT_IRQ_EN (1U)  /*!< Bit field size in bits for GPMI_CTRL1_TIMEOUT_IRQ_EN. */

/*! @brief Read current value of the GPMI_CTRL1_TIMEOUT_IRQ_EN field. */
#define BR_GPMI_CTRL1_TIMEOUT_IRQ_EN(x) (HW_GPMI_CTRL1(x).B.TIMEOUT_IRQ_EN)

/*! @brief Format value for bitfield GPMI_CTRL1_TIMEOUT_IRQ_EN. */
#define BF_GPMI_CTRL1_TIMEOUT_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_TIMEOUT_IRQ_EN) & BM_GPMI_CTRL1_TIMEOUT_IRQ_EN)

/*! @brief Set the TIMEOUT_IRQ_EN field to a new value. */
#define BW_GPMI_CTRL1_TIMEOUT_IRQ_EN(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_TIMEOUT_IRQ_EN) | BF_GPMI_CTRL1_TIMEOUT_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field RSVD1[21] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_CTRL1_RSVD1  (21U)         /*!< Bit position for GPMI_CTRL1_RSVD1. */
#define BM_GPMI_CTRL1_RSVD1  (0x00200000U) /*!< Bit mask for GPMI_CTRL1_RSVD1. */
#define BS_GPMI_CTRL1_RSVD1  (1U)          /*!< Bit field size in bits for GPMI_CTRL1_RSVD1. */

/*! @brief Read current value of the GPMI_CTRL1_RSVD1 field. */
#define BR_GPMI_CTRL1_RSVD1(x) (HW_GPMI_CTRL1(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field WRN_DLY_SEL[23:22] (RW)
 *
 * Since the GPMI write strobe (WRN) is a fast clock pin, the delay on this
 * signal can be programmed to match the load on this pin. 0 = 4ns to 8ns; 1 = 6ns to
 * 10ns; 2 = 7ns to 12ns; 3 = no delay.
 */
/*@{*/
#define BP_GPMI_CTRL1_WRN_DLY_SEL (22U)    /*!< Bit position for GPMI_CTRL1_WRN_DLY_SEL. */
#define BM_GPMI_CTRL1_WRN_DLY_SEL (0x00C00000U) /*!< Bit mask for GPMI_CTRL1_WRN_DLY_SEL. */
#define BS_GPMI_CTRL1_WRN_DLY_SEL (2U)     /*!< Bit field size in bits for GPMI_CTRL1_WRN_DLY_SEL. */

/*! @brief Read current value of the GPMI_CTRL1_WRN_DLY_SEL field. */
#define BR_GPMI_CTRL1_WRN_DLY_SEL(x) (HW_GPMI_CTRL1(x).B.WRN_DLY_SEL)

/*! @brief Format value for bitfield GPMI_CTRL1_WRN_DLY_SEL. */
#define BF_GPMI_CTRL1_WRN_DLY_SEL(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_WRN_DLY_SEL) & BM_GPMI_CTRL1_WRN_DLY_SEL)

/*! @brief Set the WRN_DLY_SEL field to a new value. */
#define BW_GPMI_CTRL1_WRN_DLY_SEL(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_WRN_DLY_SEL) | BF_GPMI_CTRL1_WRN_DLY_SEL(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DECOUPLE_CS[24] (RW)
 *
 * Decouple Chip Select from DMA Channel. Setting this bit to 1 will allow a DMA
 * channel to specify any value in the CTRL0_CS register field. Software can use
 * one DMA channel to access all 8 Nand devices.
 */
/*@{*/
#define BP_GPMI_CTRL1_DECOUPLE_CS (24U)    /*!< Bit position for GPMI_CTRL1_DECOUPLE_CS. */
#define BM_GPMI_CTRL1_DECOUPLE_CS (0x01000000U) /*!< Bit mask for GPMI_CTRL1_DECOUPLE_CS. */
#define BS_GPMI_CTRL1_DECOUPLE_CS (1U)     /*!< Bit field size in bits for GPMI_CTRL1_DECOUPLE_CS. */

/*! @brief Read current value of the GPMI_CTRL1_DECOUPLE_CS field. */
#define BR_GPMI_CTRL1_DECOUPLE_CS(x) (HW_GPMI_CTRL1(x).B.DECOUPLE_CS)

/*! @brief Format value for bitfield GPMI_CTRL1_DECOUPLE_CS. */
#define BF_GPMI_CTRL1_DECOUPLE_CS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DECOUPLE_CS) & BM_GPMI_CTRL1_DECOUPLE_CS)

/*! @brief Set the DECOUPLE_CS field to a new value. */
#define BW_GPMI_CTRL1_DECOUPLE_CS(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DECOUPLE_CS) | BF_GPMI_CTRL1_DECOUPLE_CS(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field SSYNCMODE[25] (RW)
 *
 * source synchronouse mode 1 or asynchrous mode 0. ASYNC = 0x0 Asynchronous
 * mode. SSYNC = 0x1 Source Synchronous mode.
 */
/*@{*/
#define BP_GPMI_CTRL1_SSYNCMODE (25U)      /*!< Bit position for GPMI_CTRL1_SSYNCMODE. */
#define BM_GPMI_CTRL1_SSYNCMODE (0x02000000U) /*!< Bit mask for GPMI_CTRL1_SSYNCMODE. */
#define BS_GPMI_CTRL1_SSYNCMODE (1U)       /*!< Bit field size in bits for GPMI_CTRL1_SSYNCMODE. */

/*! @brief Read current value of the GPMI_CTRL1_SSYNCMODE field. */
#define BR_GPMI_CTRL1_SSYNCMODE(x) (HW_GPMI_CTRL1(x).B.SSYNCMODE)

/*! @brief Format value for bitfield GPMI_CTRL1_SSYNCMODE. */
#define BF_GPMI_CTRL1_SSYNCMODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_SSYNCMODE) & BM_GPMI_CTRL1_SSYNCMODE)

/*! @brief Set the SSYNCMODE field to a new value. */
#define BW_GPMI_CTRL1_SSYNCMODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_SSYNCMODE) | BF_GPMI_CTRL1_SSYNCMODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field UPDATE_CS[26] (RW)
 *
 * force the CS value is be updated to external chip select pin, even GPMI is
 * idle.
 */
/*@{*/
#define BP_GPMI_CTRL1_UPDATE_CS (26U)      /*!< Bit position for GPMI_CTRL1_UPDATE_CS. */
#define BM_GPMI_CTRL1_UPDATE_CS (0x04000000U) /*!< Bit mask for GPMI_CTRL1_UPDATE_CS. */
#define BS_GPMI_CTRL1_UPDATE_CS (1U)       /*!< Bit field size in bits for GPMI_CTRL1_UPDATE_CS. */

/*! @brief Read current value of the GPMI_CTRL1_UPDATE_CS field. */
#define BR_GPMI_CTRL1_UPDATE_CS(x) (HW_GPMI_CTRL1(x).B.UPDATE_CS)

/*! @brief Format value for bitfield GPMI_CTRL1_UPDATE_CS. */
#define BF_GPMI_CTRL1_UPDATE_CS(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_UPDATE_CS) & BM_GPMI_CTRL1_UPDATE_CS)

/*! @brief Set the UPDATE_CS field to a new value. */
#define BW_GPMI_CTRL1_UPDATE_CS(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_UPDATE_CS) | BF_GPMI_CTRL1_UPDATE_CS(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field GPMI_CLK_DIV2_EN[27] (RW)
 *
 * This bit should be reset to 0 in asynchronous mode. The frequence ratio of
 * (device clock : ccm gpmi clock) will be (1 : 1). This bit should be set to 1, in
 * source synchronous mode or toggle mode. The frequence raito of (device clock
 * : ccm gpmi clock) will be (1 : 2). enable the gpmi clk divider.
 *
 * Values:
 * - 0 - internal factor-2 clock divider is disabled
 * - 1 - internal factor-2 clock divider is enabled.
 */
/*@{*/
#define BP_GPMI_CTRL1_GPMI_CLK_DIV2_EN (27U) /*!< Bit position for GPMI_CTRL1_GPMI_CLK_DIV2_EN. */
#define BM_GPMI_CTRL1_GPMI_CLK_DIV2_EN (0x08000000U) /*!< Bit mask for GPMI_CTRL1_GPMI_CLK_DIV2_EN. */
#define BS_GPMI_CTRL1_GPMI_CLK_DIV2_EN (1U) /*!< Bit field size in bits for GPMI_CTRL1_GPMI_CLK_DIV2_EN. */

/*! @brief Read current value of the GPMI_CTRL1_GPMI_CLK_DIV2_EN field. */
#define BR_GPMI_CTRL1_GPMI_CLK_DIV2_EN(x) (HW_GPMI_CTRL1(x).B.GPMI_CLK_DIV2_EN)

/*! @brief Format value for bitfield GPMI_CTRL1_GPMI_CLK_DIV2_EN. */
#define BF_GPMI_CTRL1_GPMI_CLK_DIV2_EN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_GPMI_CLK_DIV2_EN) & BM_GPMI_CTRL1_GPMI_CLK_DIV2_EN)

/*! @brief Set the GPMI_CLK_DIV2_EN field to a new value. */
#define BW_GPMI_CTRL1_GPMI_CLK_DIV2_EN(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_GPMI_CLK_DIV2_EN) | BF_GPMI_CTRL1_GPMI_CLK_DIV2_EN(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field TOGGLE_MODE[28] (RW)
 *
 * enable samsung toggle mode.
 */
/*@{*/
#define BP_GPMI_CTRL1_TOGGLE_MODE (28U)    /*!< Bit position for GPMI_CTRL1_TOGGLE_MODE. */
#define BM_GPMI_CTRL1_TOGGLE_MODE (0x10000000U) /*!< Bit mask for GPMI_CTRL1_TOGGLE_MODE. */
#define BS_GPMI_CTRL1_TOGGLE_MODE (1U)     /*!< Bit field size in bits for GPMI_CTRL1_TOGGLE_MODE. */

/*! @brief Read current value of the GPMI_CTRL1_TOGGLE_MODE field. */
#define BR_GPMI_CTRL1_TOGGLE_MODE(x) (HW_GPMI_CTRL1(x).B.TOGGLE_MODE)

/*! @brief Format value for bitfield GPMI_CTRL1_TOGGLE_MODE. */
#define BF_GPMI_CTRL1_TOGGLE_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_TOGGLE_MODE) & BM_GPMI_CTRL1_TOGGLE_MODE)

/*! @brief Set the TOGGLE_MODE field to a new value. */
#define BW_GPMI_CTRL1_TOGGLE_MODE(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_TOGGLE_MODE) | BF_GPMI_CTRL1_TOGGLE_MODE(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field WRITE_CLK_STOP[29] (RW)
 *
 * In onfi source synchronous mode, host may save power during the data write
 * cycles by holding the CLK signal high (i.e. stopping the CLK). The host may only
 * stop the CLK during data write, by setting this bit to 1, if the device
 * supports this feature as indicated in the parameter page.
 */
/*@{*/
#define BP_GPMI_CTRL1_WRITE_CLK_STOP (29U) /*!< Bit position for GPMI_CTRL1_WRITE_CLK_STOP. */
#define BM_GPMI_CTRL1_WRITE_CLK_STOP (0x20000000U) /*!< Bit mask for GPMI_CTRL1_WRITE_CLK_STOP. */
#define BS_GPMI_CTRL1_WRITE_CLK_STOP (1U)  /*!< Bit field size in bits for GPMI_CTRL1_WRITE_CLK_STOP. */

/*! @brief Read current value of the GPMI_CTRL1_WRITE_CLK_STOP field. */
#define BR_GPMI_CTRL1_WRITE_CLK_STOP(x) (HW_GPMI_CTRL1(x).B.WRITE_CLK_STOP)

/*! @brief Format value for bitfield GPMI_CTRL1_WRITE_CLK_STOP. */
#define BF_GPMI_CTRL1_WRITE_CLK_STOP(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_WRITE_CLK_STOP) & BM_GPMI_CTRL1_WRITE_CLK_STOP)

/*! @brief Set the WRITE_CLK_STOP field to a new value. */
#define BW_GPMI_CTRL1_WRITE_CLK_STOP(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_WRITE_CLK_STOP) | BF_GPMI_CTRL1_WRITE_CLK_STOP(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field SSYNC_CLK_STOP[30] (RW)
 *
 * set this bit to 1 will stop the source synchronous mode clk.
 */
/*@{*/
#define BP_GPMI_CTRL1_SSYNC_CLK_STOP (30U) /*!< Bit position for GPMI_CTRL1_SSYNC_CLK_STOP. */
#define BM_GPMI_CTRL1_SSYNC_CLK_STOP (0x40000000U) /*!< Bit mask for GPMI_CTRL1_SSYNC_CLK_STOP. */
#define BS_GPMI_CTRL1_SSYNC_CLK_STOP (1U)  /*!< Bit field size in bits for GPMI_CTRL1_SSYNC_CLK_STOP. */

/*! @brief Read current value of the GPMI_CTRL1_SSYNC_CLK_STOP field. */
#define BR_GPMI_CTRL1_SSYNC_CLK_STOP(x) (HW_GPMI_CTRL1(x).B.SSYNC_CLK_STOP)

/*! @brief Format value for bitfield GPMI_CTRL1_SSYNC_CLK_STOP. */
#define BF_GPMI_CTRL1_SSYNC_CLK_STOP(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_SSYNC_CLK_STOP) & BM_GPMI_CTRL1_SSYNC_CLK_STOP)

/*! @brief Set the SSYNC_CLK_STOP field to a new value. */
#define BW_GPMI_CTRL1_SSYNC_CLK_STOP(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_SSYNC_CLK_STOP) | BF_GPMI_CTRL1_SSYNC_CLK_STOP(v)))
/*@}*/

/*!
 * @name Register GPMI_CTRL1, field DEV_CLK_STOP[31] (RW)
 *
 * set this bit to 1 will stop gpmi io working clk.
 */
/*@{*/
#define BP_GPMI_CTRL1_DEV_CLK_STOP (31U)   /*!< Bit position for GPMI_CTRL1_DEV_CLK_STOP. */
#define BM_GPMI_CTRL1_DEV_CLK_STOP (0x80000000U) /*!< Bit mask for GPMI_CTRL1_DEV_CLK_STOP. */
#define BS_GPMI_CTRL1_DEV_CLK_STOP (1U)    /*!< Bit field size in bits for GPMI_CTRL1_DEV_CLK_STOP. */

/*! @brief Read current value of the GPMI_CTRL1_DEV_CLK_STOP field. */
#define BR_GPMI_CTRL1_DEV_CLK_STOP(x) (HW_GPMI_CTRL1(x).B.DEV_CLK_STOP)

/*! @brief Format value for bitfield GPMI_CTRL1_DEV_CLK_STOP. */
#define BF_GPMI_CTRL1_DEV_CLK_STOP(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_CTRL1_DEV_CLK_STOP) & BM_GPMI_CTRL1_DEV_CLK_STOP)

/*! @brief Set the DEV_CLK_STOP field to a new value. */
#define BW_GPMI_CTRL1_DEV_CLK_STOP(x, v) (HW_GPMI_CTRL1_WR(x, (HW_GPMI_CTRL1_RD(x) & ~BM_GPMI_CTRL1_DEV_CLK_STOP) | BF_GPMI_CTRL1_DEV_CLK_STOP(v)))
/*@}*/




/*******************************************************************************
 * HW_GPMI_TIMING0 - GPMI Timing Register 0 Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_TIMING0 - GPMI Timing Register 0 Description (RW)
 *
 * Reset value: 0x00010203U
 *
 * The GPMI timing register 0 specifies the timing parameters that are used by
 * the cycle state machine to guarantee the various setup, hold and cycle times
 * for the external media type. GPMI_TIMING0 0x070
 */
typedef union _hw_gpmi_timing0
{
    uint32_t U;
    struct _hw_gpmi_timing0_bitfields
    {
        uint32_t DATA_SETUP : 8;       /*!< [7:0]  */
        uint32_t DATA_HOLD : 8;        /*!< [15:8]  */
        uint32_t ADDRESS_SETUP : 8;    /*!< [23:16]  */
        uint32_t RSVD1 : 8;            /*!< [31:24]  */
    } B;
} hw_gpmi_timing0_t;

/*!
 * @name Constants and macros for entire GPMI_TIMING0 register
 */
/*@{*/
#define HW_GPMI_TIMING0_ADDR(x)  ((uintptr_t)(x) + 0x70U)

#define HW_GPMI_TIMING0(x)       (*(__IO hw_gpmi_timing0_t *) HW_GPMI_TIMING0_ADDR(x))
#define HW_GPMI_TIMING0_RD(x)    (HW_GPMI_TIMING0(x).U)
#define HW_GPMI_TIMING0_WR(x, v) (HW_GPMI_TIMING0(x).U = (v))
#define HW_GPMI_TIMING0_SET(x, v) (HW_GPMI_TIMING0_WR(x, HW_GPMI_TIMING0_RD(x) |  (v)))
#define HW_GPMI_TIMING0_CLR(x, v) (HW_GPMI_TIMING0_WR(x, HW_GPMI_TIMING0_RD(x) & ~(v)))
#define HW_GPMI_TIMING0_TOG(x, v) (HW_GPMI_TIMING0_WR(x, HW_GPMI_TIMING0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_TIMING0 bitfields
 */

/*!
 * @name Register GPMI_TIMING0, field DATA_SETUP[7:0] (RW)
 *
 * Data bus setup time in GPMICLK cycles. Also the time that the data strobe is
 * asserted in a cycle. This value must be greater than 2 for ATA devices that
 * use IORDY to extend transfer cycles. A value of zero is interpreted as 256. For
 * ATA PIO modes this is known in the ATA7 specification as ""DIOR-/DIOW-"
 */
/*@{*/
#define BP_GPMI_TIMING0_DATA_SETUP (0U)    /*!< Bit position for GPMI_TIMING0_DATA_SETUP. */
#define BM_GPMI_TIMING0_DATA_SETUP (0x000000FFU) /*!< Bit mask for GPMI_TIMING0_DATA_SETUP. */
#define BS_GPMI_TIMING0_DATA_SETUP (8U)    /*!< Bit field size in bits for GPMI_TIMING0_DATA_SETUP. */

/*! @brief Read current value of the GPMI_TIMING0_DATA_SETUP field. */
#define BR_GPMI_TIMING0_DATA_SETUP(x) (HW_GPMI_TIMING0(x).B.DATA_SETUP)

/*! @brief Format value for bitfield GPMI_TIMING0_DATA_SETUP. */
#define BF_GPMI_TIMING0_DATA_SETUP(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING0_DATA_SETUP) & BM_GPMI_TIMING0_DATA_SETUP)

/*! @brief Set the DATA_SETUP field to a new value. */
#define BW_GPMI_TIMING0_DATA_SETUP(x, v) (HW_GPMI_TIMING0_WR(x, (HW_GPMI_TIMING0_RD(x) & ~BM_GPMI_TIMING0_DATA_SETUP) | BF_GPMI_TIMING0_DATA_SETUP(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING0, field DATA_HOLD[15:8] (RW)
 *
 * Data bus hold time in GPMICLK cycles. Also the time that the data strobe is
 * de-asserted in a cycle. A value of zero is interpreted as 256. For ATA PIO
 * modes this is known in the ATA7 specification as "DIOR-/DIOW- recovery time"
 */
/*@{*/
#define BP_GPMI_TIMING0_DATA_HOLD (8U)     /*!< Bit position for GPMI_TIMING0_DATA_HOLD. */
#define BM_GPMI_TIMING0_DATA_HOLD (0x0000FF00U) /*!< Bit mask for GPMI_TIMING0_DATA_HOLD. */
#define BS_GPMI_TIMING0_DATA_HOLD (8U)     /*!< Bit field size in bits for GPMI_TIMING0_DATA_HOLD. */

/*! @brief Read current value of the GPMI_TIMING0_DATA_HOLD field. */
#define BR_GPMI_TIMING0_DATA_HOLD(x) (HW_GPMI_TIMING0(x).B.DATA_HOLD)

/*! @brief Format value for bitfield GPMI_TIMING0_DATA_HOLD. */
#define BF_GPMI_TIMING0_DATA_HOLD(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING0_DATA_HOLD) & BM_GPMI_TIMING0_DATA_HOLD)

/*! @brief Set the DATA_HOLD field to a new value. */
#define BW_GPMI_TIMING0_DATA_HOLD(x, v) (HW_GPMI_TIMING0_WR(x, (HW_GPMI_TIMING0_RD(x) & ~BM_GPMI_TIMING0_DATA_HOLD) | BF_GPMI_TIMING0_DATA_HOLD(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING0, field ADDRESS_SETUP[23:16] (RW)
 *
 * Number of GPMICLK cycles that the CE/ADDR signals are active before a strobe
 * is asserted. A value of zero is interpreted as 0. For ATA PIO modes this is
 * known in the ATA7 specification as "Address valid to DIOR-/DIOW- setup"
 */
/*@{*/
#define BP_GPMI_TIMING0_ADDRESS_SETUP (16U) /*!< Bit position for GPMI_TIMING0_ADDRESS_SETUP. */
#define BM_GPMI_TIMING0_ADDRESS_SETUP (0x00FF0000U) /*!< Bit mask for GPMI_TIMING0_ADDRESS_SETUP. */
#define BS_GPMI_TIMING0_ADDRESS_SETUP (8U) /*!< Bit field size in bits for GPMI_TIMING0_ADDRESS_SETUP. */

/*! @brief Read current value of the GPMI_TIMING0_ADDRESS_SETUP field. */
#define BR_GPMI_TIMING0_ADDRESS_SETUP(x) (HW_GPMI_TIMING0(x).B.ADDRESS_SETUP)

/*! @brief Format value for bitfield GPMI_TIMING0_ADDRESS_SETUP. */
#define BF_GPMI_TIMING0_ADDRESS_SETUP(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING0_ADDRESS_SETUP) & BM_GPMI_TIMING0_ADDRESS_SETUP)

/*! @brief Set the ADDRESS_SETUP field to a new value. */
#define BW_GPMI_TIMING0_ADDRESS_SETUP(x, v) (HW_GPMI_TIMING0_WR(x, (HW_GPMI_TIMING0_RD(x) & ~BM_GPMI_TIMING0_ADDRESS_SETUP) | BF_GPMI_TIMING0_ADDRESS_SETUP(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING0, field RSVD1[31:24] (WOZ)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_TIMING0_RSVD1 (24U)        /*!< Bit position for GPMI_TIMING0_RSVD1. */
#define BM_GPMI_TIMING0_RSVD1 (0xFF000000U) /*!< Bit mask for GPMI_TIMING0_RSVD1. */
#define BS_GPMI_TIMING0_RSVD1 (8U)         /*!< Bit field size in bits for GPMI_TIMING0_RSVD1. */

/*! @brief Format value for bitfield GPMI_TIMING0_RSVD1. */
#define BF_GPMI_TIMING0_RSVD1(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING0_RSVD1) & BM_GPMI_TIMING0_RSVD1)
/*@}*/

/*******************************************************************************
 * HW_GPMI_TIMING1 - GPMI Timing Register 1 Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_TIMING1 - GPMI Timing Register 1 Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI timing register 1 specifies the timeouts used when monitoring the
 * NAND READY pin or the ATA IRQ and IOWAIT signals. GPMI_TIMING1 0x080
 */
typedef union _hw_gpmi_timing1
{
    uint32_t U;
    struct _hw_gpmi_timing1_bitfields
    {
        uint32_t RSVD1 : 16;           /*!< [15:0]  */
        uint32_t DEVICE_BUSY_TIMEOUT : 16; /*!< [31:16]  */
    } B;
} hw_gpmi_timing1_t;

/*!
 * @name Constants and macros for entire GPMI_TIMING1 register
 */
/*@{*/
#define HW_GPMI_TIMING1_ADDR(x)  ((uintptr_t)(x) + 0x80U)

#define HW_GPMI_TIMING1(x)       (*(__IO hw_gpmi_timing1_t *) HW_GPMI_TIMING1_ADDR(x))
#define HW_GPMI_TIMING1_RD(x)    (HW_GPMI_TIMING1(x).U)
#define HW_GPMI_TIMING1_WR(x, v) (HW_GPMI_TIMING1(x).U = (v))
#define HW_GPMI_TIMING1_SET(x, v) (HW_GPMI_TIMING1_WR(x, HW_GPMI_TIMING1_RD(x) |  (v)))
#define HW_GPMI_TIMING1_CLR(x, v) (HW_GPMI_TIMING1_WR(x, HW_GPMI_TIMING1_RD(x) & ~(v)))
#define HW_GPMI_TIMING1_TOG(x, v) (HW_GPMI_TIMING1_WR(x, HW_GPMI_TIMING1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_TIMING1 bitfields
 */

/*!
 * @name Register GPMI_TIMING1, field RSVD1[15:0] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_TIMING1_RSVD1 (0U)         /*!< Bit position for GPMI_TIMING1_RSVD1. */
#define BM_GPMI_TIMING1_RSVD1 (0x0000FFFFU) /*!< Bit mask for GPMI_TIMING1_RSVD1. */
#define BS_GPMI_TIMING1_RSVD1 (16U)        /*!< Bit field size in bits for GPMI_TIMING1_RSVD1. */

/*! @brief Read current value of the GPMI_TIMING1_RSVD1 field. */
#define BR_GPMI_TIMING1_RSVD1(x) (HW_GPMI_TIMING1(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_TIMING1, field DEVICE_BUSY_TIMEOUT[31:16] (RW)
 *
 * Timeout waiting for NAND Ready/Busy or ATA IRQ. Used in WAIT_FOR_READY mode.
 * This value is the number of GPMI_CLK cycles multiplied by 4096.
 */
/*@{*/
#define BP_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT (16U) /*!< Bit position for GPMI_TIMING1_DEVICE_BUSY_TIMEOUT. */
#define BM_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT (0xFFFF0000U) /*!< Bit mask for GPMI_TIMING1_DEVICE_BUSY_TIMEOUT. */
#define BS_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT (16U) /*!< Bit field size in bits for GPMI_TIMING1_DEVICE_BUSY_TIMEOUT. */

/*! @brief Read current value of the GPMI_TIMING1_DEVICE_BUSY_TIMEOUT field. */
#define BR_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT(x) (HW_GPMI_TIMING1(x).B.DEVICE_BUSY_TIMEOUT)

/*! @brief Format value for bitfield GPMI_TIMING1_DEVICE_BUSY_TIMEOUT. */
#define BF_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT) & BM_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT)

/*! @brief Set the DEVICE_BUSY_TIMEOUT field to a new value. */
#define BW_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT(x, v) (HW_GPMI_TIMING1_WR(x, (HW_GPMI_TIMING1_RD(x) & ~BM_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT) | BF_GPMI_TIMING1_DEVICE_BUSY_TIMEOUT(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_TIMING2 - GPMI Timing Register 2 Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_TIMING2 - GPMI Timing Register 2 Description (RW)
 *
 * Reset value: 0x03023336U
 *
 * The GPMI timing register 2 specifies the double data rate timing parameters
 * that are used by the cycle state machine to guarantee the various cs delay,
 * pre-amble delay, post-amble delay, command/address delay, data delay, and read
 * latency cycle times for the external media type. GPMI_TIMING2 0x090
 */
typedef union _hw_gpmi_timing2
{
    uint32_t U;
    struct _hw_gpmi_timing2_bitfields
    {
        uint32_t DATA_PAUSE : 4;       /*!< [3:0]  */
        uint32_t CMDADD_PAUSE : 4;     /*!< [7:4]  */
        uint32_t POSTAMBLE_DELAY : 4;  /*!< [11:8]  */
        uint32_t PREAMBLE_DELAY : 4;   /*!< [15:12]  */
        uint32_t CE_DELAY : 5;         /*!< [20:16]  */
        uint32_t RSVD0 : 3;            /*!< [23:21]  */
        uint32_t READ_LATENCY : 3;     /*!< [26:24]  */
        uint32_t RSVD1 : 5;            /*!< [31:27]  */
    } B;
} hw_gpmi_timing2_t;

/*!
 * @name Constants and macros for entire GPMI_TIMING2 register
 */
/*@{*/
#define HW_GPMI_TIMING2_ADDR(x)  ((uintptr_t)(x) + 0x90U)

#define HW_GPMI_TIMING2(x)       (*(__IO hw_gpmi_timing2_t *) HW_GPMI_TIMING2_ADDR(x))
#define HW_GPMI_TIMING2_RD(x)    (HW_GPMI_TIMING2(x).U)
#define HW_GPMI_TIMING2_WR(x, v) (HW_GPMI_TIMING2(x).U = (v))
#define HW_GPMI_TIMING2_SET(x, v) (HW_GPMI_TIMING2_WR(x, HW_GPMI_TIMING2_RD(x) |  (v)))
#define HW_GPMI_TIMING2_CLR(x, v) (HW_GPMI_TIMING2_WR(x, HW_GPMI_TIMING2_RD(x) & ~(v)))
#define HW_GPMI_TIMING2_TOG(x, v) (HW_GPMI_TIMING2_WR(x, HW_GPMI_TIMING2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_TIMING2 bitfields
 */

/*!
 * @name Register GPMI_TIMING2, field DATA_PAUSE[3:0] (RW)
 *
 * GPMI delay time from data pause to data resume in GPMICLK cycles. A value of
 * zero is interpreted as 16.
 */
/*@{*/
#define BP_GPMI_TIMING2_DATA_PAUSE (0U)    /*!< Bit position for GPMI_TIMING2_DATA_PAUSE. */
#define BM_GPMI_TIMING2_DATA_PAUSE (0x0000000FU) /*!< Bit mask for GPMI_TIMING2_DATA_PAUSE. */
#define BS_GPMI_TIMING2_DATA_PAUSE (4U)    /*!< Bit field size in bits for GPMI_TIMING2_DATA_PAUSE. */

/*! @brief Read current value of the GPMI_TIMING2_DATA_PAUSE field. */
#define BR_GPMI_TIMING2_DATA_PAUSE(x) (HW_GPMI_TIMING2(x).B.DATA_PAUSE)

/*! @brief Format value for bitfield GPMI_TIMING2_DATA_PAUSE. */
#define BF_GPMI_TIMING2_DATA_PAUSE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_DATA_PAUSE) & BM_GPMI_TIMING2_DATA_PAUSE)

/*! @brief Set the DATA_PAUSE field to a new value. */
#define BW_GPMI_TIMING2_DATA_PAUSE(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_DATA_PAUSE) | BF_GPMI_TIMING2_DATA_PAUSE(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field CMDADD_PAUSE[7:4] (RW)
 *
 * GPMI delay time from command or addres pause to command or address resume in
 * GPMICLK cycles. A value of zero is interpreted as 16.
 */
/*@{*/
#define BP_GPMI_TIMING2_CMDADD_PAUSE (4U)  /*!< Bit position for GPMI_TIMING2_CMDADD_PAUSE. */
#define BM_GPMI_TIMING2_CMDADD_PAUSE (0x000000F0U) /*!< Bit mask for GPMI_TIMING2_CMDADD_PAUSE. */
#define BS_GPMI_TIMING2_CMDADD_PAUSE (4U)  /*!< Bit field size in bits for GPMI_TIMING2_CMDADD_PAUSE. */

/*! @brief Read current value of the GPMI_TIMING2_CMDADD_PAUSE field. */
#define BR_GPMI_TIMING2_CMDADD_PAUSE(x) (HW_GPMI_TIMING2(x).B.CMDADD_PAUSE)

/*! @brief Format value for bitfield GPMI_TIMING2_CMDADD_PAUSE. */
#define BF_GPMI_TIMING2_CMDADD_PAUSE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_CMDADD_PAUSE) & BM_GPMI_TIMING2_CMDADD_PAUSE)

/*! @brief Set the CMDADD_PAUSE field to a new value. */
#define BW_GPMI_TIMING2_CMDADD_PAUSE(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_CMDADD_PAUSE) | BF_GPMI_TIMING2_CMDADD_PAUSE(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field POSTAMBLE_DELAY[11:8] (RW)
 *
 * GPMI post-amble delay in GPMICLK cycles. A value of zero is interpreted as 16.
 */
/*@{*/
#define BP_GPMI_TIMING2_POSTAMBLE_DELAY (8U) /*!< Bit position for GPMI_TIMING2_POSTAMBLE_DELAY. */
#define BM_GPMI_TIMING2_POSTAMBLE_DELAY (0x00000F00U) /*!< Bit mask for GPMI_TIMING2_POSTAMBLE_DELAY. */
#define BS_GPMI_TIMING2_POSTAMBLE_DELAY (4U) /*!< Bit field size in bits for GPMI_TIMING2_POSTAMBLE_DELAY. */

/*! @brief Read current value of the GPMI_TIMING2_POSTAMBLE_DELAY field. */
#define BR_GPMI_TIMING2_POSTAMBLE_DELAY(x) (HW_GPMI_TIMING2(x).B.POSTAMBLE_DELAY)

/*! @brief Format value for bitfield GPMI_TIMING2_POSTAMBLE_DELAY. */
#define BF_GPMI_TIMING2_POSTAMBLE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_POSTAMBLE_DELAY) & BM_GPMI_TIMING2_POSTAMBLE_DELAY)

/*! @brief Set the POSTAMBLE_DELAY field to a new value. */
#define BW_GPMI_TIMING2_POSTAMBLE_DELAY(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_POSTAMBLE_DELAY) | BF_GPMI_TIMING2_POSTAMBLE_DELAY(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field PREAMBLE_DELAY[15:12] (RW)
 *
 * GPMI pre-amble delay in GPMICLK cycles. A value of zero is interpreted as 16.
 */
/*@{*/
#define BP_GPMI_TIMING2_PREAMBLE_DELAY (12U) /*!< Bit position for GPMI_TIMING2_PREAMBLE_DELAY. */
#define BM_GPMI_TIMING2_PREAMBLE_DELAY (0x0000F000U) /*!< Bit mask for GPMI_TIMING2_PREAMBLE_DELAY. */
#define BS_GPMI_TIMING2_PREAMBLE_DELAY (4U) /*!< Bit field size in bits for GPMI_TIMING2_PREAMBLE_DELAY. */

/*! @brief Read current value of the GPMI_TIMING2_PREAMBLE_DELAY field. */
#define BR_GPMI_TIMING2_PREAMBLE_DELAY(x) (HW_GPMI_TIMING2(x).B.PREAMBLE_DELAY)

/*! @brief Format value for bitfield GPMI_TIMING2_PREAMBLE_DELAY. */
#define BF_GPMI_TIMING2_PREAMBLE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_PREAMBLE_DELAY) & BM_GPMI_TIMING2_PREAMBLE_DELAY)

/*! @brief Set the PREAMBLE_DELAY field to a new value. */
#define BW_GPMI_TIMING2_PREAMBLE_DELAY(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_PREAMBLE_DELAY) | BF_GPMI_TIMING2_PREAMBLE_DELAY(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field CE_DELAY[20:16] (RW)
 *
 * GPMI dealy from CEn assert to W/Rn changing edge. value of zero is
 * interpreted as 32.
 */
/*@{*/
#define BP_GPMI_TIMING2_CE_DELAY (16U)     /*!< Bit position for GPMI_TIMING2_CE_DELAY. */
#define BM_GPMI_TIMING2_CE_DELAY (0x001F0000U) /*!< Bit mask for GPMI_TIMING2_CE_DELAY. */
#define BS_GPMI_TIMING2_CE_DELAY (5U)      /*!< Bit field size in bits for GPMI_TIMING2_CE_DELAY. */

/*! @brief Read current value of the GPMI_TIMING2_CE_DELAY field. */
#define BR_GPMI_TIMING2_CE_DELAY(x) (HW_GPMI_TIMING2(x).B.CE_DELAY)

/*! @brief Format value for bitfield GPMI_TIMING2_CE_DELAY. */
#define BF_GPMI_TIMING2_CE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_CE_DELAY) & BM_GPMI_TIMING2_CE_DELAY)

/*! @brief Set the CE_DELAY field to a new value. */
#define BW_GPMI_TIMING2_CE_DELAY(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_CE_DELAY) | BF_GPMI_TIMING2_CE_DELAY(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field RSVD0[23:21] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_TIMING2_RSVD0 (21U)        /*!< Bit position for GPMI_TIMING2_RSVD0. */
#define BM_GPMI_TIMING2_RSVD0 (0x00E00000U) /*!< Bit mask for GPMI_TIMING2_RSVD0. */
#define BS_GPMI_TIMING2_RSVD0 (3U)         /*!< Bit field size in bits for GPMI_TIMING2_RSVD0. */

/*! @brief Read current value of the GPMI_TIMING2_RSVD0 field. */
#define BR_GPMI_TIMING2_RSVD0(x) (HW_GPMI_TIMING2(x).B.RSVD0)
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field READ_LATENCY[26:24] (RW)
 *
 * This field is for double data rate read latency configuration. others READ
 * LATENCY is 3
 *
 * Values:
 * - 000 - READ LATENCY is 0
 * - 001 - READ LATENCY is 1
 * - 010 - READ LATENCY is 2
 * - 011 - READ LATENCY is 3
 * - 100 - READ LATENCY is 4
 * - 101 - READ LATENCY is 5
 */
/*@{*/
#define BP_GPMI_TIMING2_READ_LATENCY (24U) /*!< Bit position for GPMI_TIMING2_READ_LATENCY. */
#define BM_GPMI_TIMING2_READ_LATENCY (0x07000000U) /*!< Bit mask for GPMI_TIMING2_READ_LATENCY. */
#define BS_GPMI_TIMING2_READ_LATENCY (3U)  /*!< Bit field size in bits for GPMI_TIMING2_READ_LATENCY. */

/*! @brief Read current value of the GPMI_TIMING2_READ_LATENCY field. */
#define BR_GPMI_TIMING2_READ_LATENCY(x) (HW_GPMI_TIMING2(x).B.READ_LATENCY)

/*! @brief Format value for bitfield GPMI_TIMING2_READ_LATENCY. */
#define BF_GPMI_TIMING2_READ_LATENCY(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_TIMING2_READ_LATENCY) & BM_GPMI_TIMING2_READ_LATENCY)

/*! @brief Set the READ_LATENCY field to a new value. */
#define BW_GPMI_TIMING2_READ_LATENCY(x, v) (HW_GPMI_TIMING2_WR(x, (HW_GPMI_TIMING2_RD(x) & ~BM_GPMI_TIMING2_READ_LATENCY) | BF_GPMI_TIMING2_READ_LATENCY(v)))
/*@}*/

/*!
 * @name Register GPMI_TIMING2, field RSVD1[31:27] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_TIMING2_RSVD1 (27U)        /*!< Bit position for GPMI_TIMING2_RSVD1. */
#define BM_GPMI_TIMING2_RSVD1 (0xF8000000U) /*!< Bit mask for GPMI_TIMING2_RSVD1. */
#define BS_GPMI_TIMING2_RSVD1 (5U)         /*!< Bit field size in bits for GPMI_TIMING2_RSVD1. */

/*! @brief Read current value of the GPMI_TIMING2_RSVD1 field. */
#define BR_GPMI_TIMING2_RSVD1(x) (HW_GPMI_TIMING2(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * HW_GPMI_DATA - GPMI DMA Data Transfer Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_DATA - GPMI DMA Data Transfer Register Description (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI DMA data transfer register is used by the DMA to read or write data
 * to or from the ATA/NAND control state machine. GPMI_DATA 0x0A0
 */
typedef union _hw_gpmi_data
{
    uint32_t U;
    struct _hw_gpmi_data_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_gpmi_data_t;

/*!
 * @name Constants and macros for entire GPMI_DATA register
 */
/*@{*/
#define HW_GPMI_DATA_ADDR(x)     ((uintptr_t)(x) + 0xA0U)

#define HW_GPMI_DATA(x)          (*(__IO hw_gpmi_data_t *) HW_GPMI_DATA_ADDR(x))
#define HW_GPMI_DATA_RD(x)       (HW_GPMI_DATA(x).U)
#define HW_GPMI_DATA_WR(x, v)    (HW_GPMI_DATA(x).U = (v))
#define HW_GPMI_DATA_SET(x, v)   (HW_GPMI_DATA_WR(x, HW_GPMI_DATA_RD(x) |  (v)))
#define HW_GPMI_DATA_CLR(x, v)   (HW_GPMI_DATA_WR(x, HW_GPMI_DATA_RD(x) & ~(v)))
#define HW_GPMI_DATA_TOG(x, v)   (HW_GPMI_DATA_WR(x, HW_GPMI_DATA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_DATA bitfields
 */

/*!
 * @name Register GPMI_DATA, field DATA[31:0] (RW)
 *
 * In 8-bit mode, one, two, three or four bytes can can be accessed to send the
 * same number of bus cycles.
 */
/*@{*/
#define BP_GPMI_DATA_DATA    (0U)          /*!< Bit position for GPMI_DATA_DATA. */
#define BM_GPMI_DATA_DATA    (0xFFFFFFFFU) /*!< Bit mask for GPMI_DATA_DATA. */
#define BS_GPMI_DATA_DATA    (32U)         /*!< Bit field size in bits for GPMI_DATA_DATA. */

/*! @brief Read current value of the GPMI_DATA_DATA field. */
#define BR_GPMI_DATA_DATA(x) (HW_GPMI_DATA(x).U)

/*! @brief Format value for bitfield GPMI_DATA_DATA. */
#define BF_GPMI_DATA_DATA(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_DATA_DATA) & BM_GPMI_DATA_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_GPMI_DATA_DATA(x, v) (HW_GPMI_DATA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPMI_STAT - GPMI Status Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_STAT - GPMI Status Register Description (RO)
 *
 * Reset value: 0x00000005U
 *
 * The GPMI control and status register provides a read back path for various
 * operational states of the GPMI controller. GPMI_STAT 0x0B0
 */
typedef union _hw_gpmi_stat
{
    uint32_t U;
    struct _hw_gpmi_stat_bitfields
    {
        uint32_t PRESENT : 1;          /*!< [0]  */
        uint32_t FIFO_FULL : 1;        /*!< [1]  */
        uint32_t FIFO_EMPTY : 1;       /*!< [2]  */
        uint32_t INVALID_BUFFER_MASK : 1; /*!< [3]  */
        uint32_t ATA_IRQ : 1;          /*!< [4]  */
        uint32_t RSVD1 : 3;            /*!< [7:5]  */
        uint32_t DEV0_ERROR : 1;       /*!< [8]  */
        uint32_t DEV1_ERROR : 1;       /*!< [9]  */
        uint32_t DEV2_ERROR : 1;       /*!< [10]  */
        uint32_t DEV3_ERROR : 1;       /*!< [11]  */
        uint32_t DEV4_ERROR : 1;       /*!< [12]  */
        uint32_t DEV5_ERROR : 1;       /*!< [13]  */
        uint32_t DEV6_ERROR : 1;       /*!< [14]  */
        uint32_t DEV7_ERROR : 1;       /*!< [15]  */
        uint32_t RDY_TIMEOUT : 8;      /*!< [23:16]  */
        uint32_t READY_BUSY : 8;       /*!< [31:24]  */
    } B;
} hw_gpmi_stat_t;

/*!
 * @name Constants and macros for entire GPMI_STAT register
 */
/*@{*/
#define HW_GPMI_STAT_ADDR(x)     ((uintptr_t)(x) + 0xB0U)

#define HW_GPMI_STAT(x)          (*(__I hw_gpmi_stat_t *) HW_GPMI_STAT_ADDR(x))
#define HW_GPMI_STAT_RD(x)       (HW_GPMI_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_STAT bitfields
 */

/*!
 * @name Register GPMI_STAT, field PRESENT[0] (RO)
 *
 * UNAVAILABLE = 0x0 GPMI is not present in this product. AVAILABLE = 0x1 GPMI
 * is present in this product.
 *
 * Values:
 * - 0 - GPMI is not present in this product.
 * - 1 - GPMI is present is in this product.
 */
/*@{*/
#define BP_GPMI_STAT_PRESENT (0U)          /*!< Bit position for GPMI_STAT_PRESENT. */
#define BM_GPMI_STAT_PRESENT (0x00000001U) /*!< Bit mask for GPMI_STAT_PRESENT. */
#define BS_GPMI_STAT_PRESENT (1U)          /*!< Bit field size in bits for GPMI_STAT_PRESENT. */

/*! @brief Read current value of the GPMI_STAT_PRESENT field. */
#define BR_GPMI_STAT_PRESENT(x) (HW_GPMI_STAT(x).B.PRESENT)
/*@}*/

/*!
 * @name Register GPMI_STAT, field FIFO_FULL[1] (RO)
 *
 * NOT_FULL = 0x0 FIFO is not full. FULL = 0x1 FIFO is full.
 *
 * Values:
 * - 0 - FIFO is not full.
 * - 1 - FIFO is full.
 */
/*@{*/
#define BP_GPMI_STAT_FIFO_FULL (1U)        /*!< Bit position for GPMI_STAT_FIFO_FULL. */
#define BM_GPMI_STAT_FIFO_FULL (0x00000002U) /*!< Bit mask for GPMI_STAT_FIFO_FULL. */
#define BS_GPMI_STAT_FIFO_FULL (1U)        /*!< Bit field size in bits for GPMI_STAT_FIFO_FULL. */

/*! @brief Read current value of the GPMI_STAT_FIFO_FULL field. */
#define BR_GPMI_STAT_FIFO_FULL(x) (HW_GPMI_STAT(x).B.FIFO_FULL)
/*@}*/

/*!
 * @name Register GPMI_STAT, field FIFO_EMPTY[2] (RO)
 *
 * NOT_EMPTY = 0x0 FIFO is not empty. EMPTY = 0x1 FIFO is empty.
 *
 * Values:
 * - 0 - FIFO is not empty.
 * - 1 - FIFO is empty.
 */
/*@{*/
#define BP_GPMI_STAT_FIFO_EMPTY (2U)       /*!< Bit position for GPMI_STAT_FIFO_EMPTY. */
#define BM_GPMI_STAT_FIFO_EMPTY (0x00000004U) /*!< Bit mask for GPMI_STAT_FIFO_EMPTY. */
#define BS_GPMI_STAT_FIFO_EMPTY (1U)       /*!< Bit field size in bits for GPMI_STAT_FIFO_EMPTY. */

/*! @brief Read current value of the GPMI_STAT_FIFO_EMPTY field. */
#define BR_GPMI_STAT_FIFO_EMPTY(x) (HW_GPMI_STAT(x).B.FIFO_EMPTY)
/*@}*/

/*!
 * @name Register GPMI_STAT, field INVALID_BUFFER_MASK[3] (RO)
 *
 * Buffer Mask Validity bit.
 *
 * Values:
 * - 0 - ECC Buffer Mask is not invalid.
 * - 1 - ECC Buffer Mask is invalid.
 */
/*@{*/
#define BP_GPMI_STAT_INVALID_BUFFER_MASK (3U) /*!< Bit position for GPMI_STAT_INVALID_BUFFER_MASK. */
#define BM_GPMI_STAT_INVALID_BUFFER_MASK (0x00000008U) /*!< Bit mask for GPMI_STAT_INVALID_BUFFER_MASK. */
#define BS_GPMI_STAT_INVALID_BUFFER_MASK (1U) /*!< Bit field size in bits for GPMI_STAT_INVALID_BUFFER_MASK. */

/*! @brief Read current value of the GPMI_STAT_INVALID_BUFFER_MASK field. */
#define BR_GPMI_STAT_INVALID_BUFFER_MASK(x) (HW_GPMI_STAT(x).B.INVALID_BUFFER_MASK)
/*@}*/

/*!
 * @name Register GPMI_STAT, field ATA_IRQ[4] (RO)
 *
 * Status of the ATA_IRQ input pin.
 */
/*@{*/
#define BP_GPMI_STAT_ATA_IRQ (4U)          /*!< Bit position for GPMI_STAT_ATA_IRQ. */
#define BM_GPMI_STAT_ATA_IRQ (0x00000010U) /*!< Bit mask for GPMI_STAT_ATA_IRQ. */
#define BS_GPMI_STAT_ATA_IRQ (1U)          /*!< Bit field size in bits for GPMI_STAT_ATA_IRQ. */

/*! @brief Read current value of the GPMI_STAT_ATA_IRQ field. */
#define BR_GPMI_STAT_ATA_IRQ(x) (HW_GPMI_STAT(x).B.ATA_IRQ)
/*@}*/

/*!
 * @name Register GPMI_STAT, field RSVD1[7:5] (RO)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_STAT_RSVD1   (5U)          /*!< Bit position for GPMI_STAT_RSVD1. */
#define BM_GPMI_STAT_RSVD1   (0x000000E0U) /*!< Bit mask for GPMI_STAT_RSVD1. */
#define BS_GPMI_STAT_RSVD1   (3U)          /*!< Bit field size in bits for GPMI_STAT_RSVD1. */

/*! @brief Read current value of the GPMI_STAT_RSVD1 field. */
#define BR_GPMI_STAT_RSVD1(x) (HW_GPMI_STAT(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV0_ERROR[8] (RO)
 *
 * DMA channel 0 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 0.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV0_ERROR (8U)       /*!< Bit position for GPMI_STAT_DEV0_ERROR. */
#define BM_GPMI_STAT_DEV0_ERROR (0x00000100U) /*!< Bit mask for GPMI_STAT_DEV0_ERROR. */
#define BS_GPMI_STAT_DEV0_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV0_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV0_ERROR field. */
#define BR_GPMI_STAT_DEV0_ERROR(x) (HW_GPMI_STAT(x).B.DEV0_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV1_ERROR[9] (RO)
 *
 * DMA channel 1 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 1.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV1_ERROR (9U)       /*!< Bit position for GPMI_STAT_DEV1_ERROR. */
#define BM_GPMI_STAT_DEV1_ERROR (0x00000200U) /*!< Bit mask for GPMI_STAT_DEV1_ERROR. */
#define BS_GPMI_STAT_DEV1_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV1_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV1_ERROR field. */
#define BR_GPMI_STAT_DEV1_ERROR(x) (HW_GPMI_STAT(x).B.DEV1_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV2_ERROR[10] (RO)
 *
 * DMA channel 2 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 2.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV2_ERROR (10U)      /*!< Bit position for GPMI_STAT_DEV2_ERROR. */
#define BM_GPMI_STAT_DEV2_ERROR (0x00000400U) /*!< Bit mask for GPMI_STAT_DEV2_ERROR. */
#define BS_GPMI_STAT_DEV2_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV2_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV2_ERROR field. */
#define BR_GPMI_STAT_DEV2_ERROR(x) (HW_GPMI_STAT(x).B.DEV2_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV3_ERROR[11] (RO)
 *
 * DMA channel 3 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 3.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV3_ERROR (11U)      /*!< Bit position for GPMI_STAT_DEV3_ERROR. */
#define BM_GPMI_STAT_DEV3_ERROR (0x00000800U) /*!< Bit mask for GPMI_STAT_DEV3_ERROR. */
#define BS_GPMI_STAT_DEV3_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV3_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV3_ERROR field. */
#define BR_GPMI_STAT_DEV3_ERROR(x) (HW_GPMI_STAT(x).B.DEV3_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV4_ERROR[12] (RO)
 *
 * DMA channel 4 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 4.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV4_ERROR (12U)      /*!< Bit position for GPMI_STAT_DEV4_ERROR. */
#define BM_GPMI_STAT_DEV4_ERROR (0x00001000U) /*!< Bit mask for GPMI_STAT_DEV4_ERROR. */
#define BS_GPMI_STAT_DEV4_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV4_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV4_ERROR field. */
#define BR_GPMI_STAT_DEV4_ERROR(x) (HW_GPMI_STAT(x).B.DEV4_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV5_ERROR[13] (RO)
 *
 * DMA channel 5 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 5.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV5_ERROR (13U)      /*!< Bit position for GPMI_STAT_DEV5_ERROR. */
#define BM_GPMI_STAT_DEV5_ERROR (0x00002000U) /*!< Bit mask for GPMI_STAT_DEV5_ERROR. */
#define BS_GPMI_STAT_DEV5_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV5_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV5_ERROR field. */
#define BR_GPMI_STAT_DEV5_ERROR(x) (HW_GPMI_STAT(x).B.DEV5_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV6_ERROR[14] (RO)
 *
 * DMA channel 6 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 6.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV6_ERROR (14U)      /*!< Bit position for GPMI_STAT_DEV6_ERROR. */
#define BM_GPMI_STAT_DEV6_ERROR (0x00004000U) /*!< Bit mask for GPMI_STAT_DEV6_ERROR. */
#define BS_GPMI_STAT_DEV6_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV6_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV6_ERROR field. */
#define BR_GPMI_STAT_DEV6_ERROR(x) (HW_GPMI_STAT(x).B.DEV6_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field DEV7_ERROR[15] (RO)
 *
 * DMA channel 7 (Timeout or compare failure, depending on COMMAND_MODE).
 *
 * Values:
 * - 0 - No error condition present on ATA/NAND Device accessed by DMA channel 7.
 * - 1 - An Error has occurred on ATA/NAND Device accessed by
 */
/*@{*/
#define BP_GPMI_STAT_DEV7_ERROR (15U)      /*!< Bit position for GPMI_STAT_DEV7_ERROR. */
#define BM_GPMI_STAT_DEV7_ERROR (0x00008000U) /*!< Bit mask for GPMI_STAT_DEV7_ERROR. */
#define BS_GPMI_STAT_DEV7_ERROR (1U)       /*!< Bit field size in bits for GPMI_STAT_DEV7_ERROR. */

/*! @brief Read current value of the GPMI_STAT_DEV7_ERROR field. */
#define BR_GPMI_STAT_DEV7_ERROR(x) (HW_GPMI_STAT(x).B.DEV7_ERROR)
/*@}*/

/*!
 * @name Register GPMI_STAT, field RDY_TIMEOUT[23:16] (RO)
 *
 * State of the RDY/BUSY Timeout Flags. When any bit is set to '1' in this
 * field, it indicates that a time out has occurred while waiting for the ready state
 * of the requested NAND device. Multiple bits may be set simultaneously. When
 * GPMI_CTRL1_DECOUPLE_CS = 0, RDY_TIMEOUT[n] is associated with the NAND device on
 * chip_select[n]. When GPMI_CTRL1_DECOUPLE_CS = 1, these flags become
 * associated to a DMA channel instead of a NAND device. For example if DMA channel 6
 * sends a WAIT_FOR_READY command for NAND Device 2, and a timeout occured on
 * READY_BUSY2, then READY_TIMEOUT[6] will be set instead of READY_TIMEOUT[2].
 */
/*@{*/
#define BP_GPMI_STAT_RDY_TIMEOUT (16U)     /*!< Bit position for GPMI_STAT_RDY_TIMEOUT. */
#define BM_GPMI_STAT_RDY_TIMEOUT (0x00FF0000U) /*!< Bit mask for GPMI_STAT_RDY_TIMEOUT. */
#define BS_GPMI_STAT_RDY_TIMEOUT (8U)      /*!< Bit field size in bits for GPMI_STAT_RDY_TIMEOUT. */

/*! @brief Read current value of the GPMI_STAT_RDY_TIMEOUT field. */
#define BR_GPMI_STAT_RDY_TIMEOUT(x) (HW_GPMI_STAT(x).B.RDY_TIMEOUT)
/*@}*/

/*!
 * @name Register GPMI_STAT, field READY_BUSY[31:24] (RO)
 *
 * Read-only view of NAND Ready_Busy Input pins.
 */
/*@{*/
#define BP_GPMI_STAT_READY_BUSY (24U)      /*!< Bit position for GPMI_STAT_READY_BUSY. */
#define BM_GPMI_STAT_READY_BUSY (0xFF000000U) /*!< Bit mask for GPMI_STAT_READY_BUSY. */
#define BS_GPMI_STAT_READY_BUSY (8U)       /*!< Bit field size in bits for GPMI_STAT_READY_BUSY. */

/*! @brief Read current value of the GPMI_STAT_READY_BUSY field. */
#define BR_GPMI_STAT_READY_BUSY(x) (HW_GPMI_STAT(x).B.READY_BUSY)
/*@}*/

/*******************************************************************************
 * HW_GPMI_DEBUG - GPMI Debug Information Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_DEBUG - GPMI Debug Information Register Description (RO)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI debug information register provides a read back path for diagnostics
 * to determine the current operating state of the GPMI controller. GPMI_DEBUG
 * 0x0C0
 */
typedef union _hw_gpmi_debug
{
    uint32_t U;
    struct _hw_gpmi_debug_bitfields
    {
        uint32_t CMD_END : 8;          /*!< [7:0]  */
        uint32_t DMAREQ : 8;           /*!< [15:8]  */
        uint32_t DMA_SENSE : 8;        /*!< [23:16]  */
        uint32_t WAIT_FOR_READY_END : 8; /*!< [31:24]  */
    } B;
} hw_gpmi_debug_t;

/*!
 * @name Constants and macros for entire GPMI_DEBUG register
 */
/*@{*/
#define HW_GPMI_DEBUG_ADDR(x)    ((uintptr_t)(x) + 0xC0U)

#define HW_GPMI_DEBUG(x)         (*(__I hw_gpmi_debug_t *) HW_GPMI_DEBUG_ADDR(x))
#define HW_GPMI_DEBUG_RD(x)      (HW_GPMI_DEBUG(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_DEBUG bitfields
 */

/*!
 * @name Register GPMI_DEBUG, field CMD_END[7:0] (RO)
 *
 * Read Only view of the Command End toggle signals to DMA. One per channel
 */
/*@{*/
#define BP_GPMI_DEBUG_CMD_END (0U)         /*!< Bit position for GPMI_DEBUG_CMD_END. */
#define BM_GPMI_DEBUG_CMD_END (0x000000FFU) /*!< Bit mask for GPMI_DEBUG_CMD_END. */
#define BS_GPMI_DEBUG_CMD_END (8U)         /*!< Bit field size in bits for GPMI_DEBUG_CMD_END. */

/*! @brief Read current value of the GPMI_DEBUG_CMD_END field. */
#define BR_GPMI_DEBUG_CMD_END(x) (HW_GPMI_DEBUG(x).B.CMD_END)
/*@}*/

/*!
 * @name Register GPMI_DEBUG, field DMAREQ[15:8] (RO)
 *
 * Read-only view of DMA request line for 8 DMA channels. A toggle on any bit
 * position indicates a DMA request for the corresponding channel.
 */
/*@{*/
#define BP_GPMI_DEBUG_DMAREQ (8U)          /*!< Bit position for GPMI_DEBUG_DMAREQ. */
#define BM_GPMI_DEBUG_DMAREQ (0x0000FF00U) /*!< Bit mask for GPMI_DEBUG_DMAREQ. */
#define BS_GPMI_DEBUG_DMAREQ (8U)          /*!< Bit field size in bits for GPMI_DEBUG_DMAREQ. */

/*! @brief Read current value of the GPMI_DEBUG_DMAREQ field. */
#define BR_GPMI_DEBUG_DMAREQ(x) (HW_GPMI_DEBUG(x).B.DMAREQ)
/*@}*/

/*!
 * @name Register GPMI_DEBUG, field DMA_SENSE[23:16] (RO)
 *
 * Read-only view of sense state of the 8 DMA channels. A value of "1" in any
 * bit position indicates that a read and compare command failed or a timeout
 * occured for the corresponding channel.
 */
/*@{*/
#define BP_GPMI_DEBUG_DMA_SENSE (16U)      /*!< Bit position for GPMI_DEBUG_DMA_SENSE. */
#define BM_GPMI_DEBUG_DMA_SENSE (0x00FF0000U) /*!< Bit mask for GPMI_DEBUG_DMA_SENSE. */
#define BS_GPMI_DEBUG_DMA_SENSE (8U)       /*!< Bit field size in bits for GPMI_DEBUG_DMA_SENSE. */

/*! @brief Read current value of the GPMI_DEBUG_DMA_SENSE field. */
#define BR_GPMI_DEBUG_DMA_SENSE(x) (HW_GPMI_DEBUG(x).B.DMA_SENSE)
/*@}*/

/*!
 * @name Register GPMI_DEBUG, field WAIT_FOR_READY_END[31:24] (RO)
 *
 * Read Only view of the Wait_For_Ready End toggle signals to DMA. One per
 * channel
 */
/*@{*/
#define BP_GPMI_DEBUG_WAIT_FOR_READY_END (24U) /*!< Bit position for GPMI_DEBUG_WAIT_FOR_READY_END. */
#define BM_GPMI_DEBUG_WAIT_FOR_READY_END (0xFF000000U) /*!< Bit mask for GPMI_DEBUG_WAIT_FOR_READY_END. */
#define BS_GPMI_DEBUG_WAIT_FOR_READY_END (8U) /*!< Bit field size in bits for GPMI_DEBUG_WAIT_FOR_READY_END. */

/*! @brief Read current value of the GPMI_DEBUG_WAIT_FOR_READY_END field. */
#define BR_GPMI_DEBUG_WAIT_FOR_READY_END(x) (HW_GPMI_DEBUG(x).B.WAIT_FOR_READY_END)
/*@}*/

/*******************************************************************************
 * HW_GPMI_VERSION - GPMI Version Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_VERSION - GPMI Version Register Description (RO)
 *
 * Reset value: 0x05010000U
 *
 * This register reflects the version number for the GPMI. GPMI_VERSION 0x0D0
 */
typedef union _hw_gpmi_version
{
    uint32_t U;
    struct _hw_gpmi_version_bitfields
    {
        uint32_t STEP : 16;            /*!< [15:0]  */
        uint32_t MINOR : 8;            /*!< [23:16]  */
        uint32_t MAJOR : 8;            /*!< [31:24]  */
    } B;
} hw_gpmi_version_t;

/*!
 * @name Constants and macros for entire GPMI_VERSION register
 */
/*@{*/
#define HW_GPMI_VERSION_ADDR(x)  ((uintptr_t)(x) + 0xD0U)

#define HW_GPMI_VERSION(x)       (*(__I hw_gpmi_version_t *) HW_GPMI_VERSION_ADDR(x))
#define HW_GPMI_VERSION_RD(x)    (HW_GPMI_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_VERSION bitfields
 */

/*!
 * @name Register GPMI_VERSION, field STEP[15:0] (RO)
 *
 * Fixed read-only value reflecting the stepping of the RTL version.
 */
/*@{*/
#define BP_GPMI_VERSION_STEP (0U)          /*!< Bit position for GPMI_VERSION_STEP. */
#define BM_GPMI_VERSION_STEP (0x0000FFFFU) /*!< Bit mask for GPMI_VERSION_STEP. */
#define BS_GPMI_VERSION_STEP (16U)         /*!< Bit field size in bits for GPMI_VERSION_STEP. */

/*! @brief Read current value of the GPMI_VERSION_STEP field. */
#define BR_GPMI_VERSION_STEP(x) (HW_GPMI_VERSION(x).B.STEP)
/*@}*/

/*!
 * @name Register GPMI_VERSION, field MINOR[23:16] (RO)
 *
 * Fixed read-only value reflecting the MINOR field of the RTL version.
 */
/*@{*/
#define BP_GPMI_VERSION_MINOR (16U)        /*!< Bit position for GPMI_VERSION_MINOR. */
#define BM_GPMI_VERSION_MINOR (0x00FF0000U) /*!< Bit mask for GPMI_VERSION_MINOR. */
#define BS_GPMI_VERSION_MINOR (8U)         /*!< Bit field size in bits for GPMI_VERSION_MINOR. */

/*! @brief Read current value of the GPMI_VERSION_MINOR field. */
#define BR_GPMI_VERSION_MINOR(x) (HW_GPMI_VERSION(x).B.MINOR)
/*@}*/

/*!
 * @name Register GPMI_VERSION, field MAJOR[31:24] (RO)
 *
 * Fixed read-only value reflecting the MAJOR field of the RTL version.
 */
/*@{*/
#define BP_GPMI_VERSION_MAJOR (24U)        /*!< Bit position for GPMI_VERSION_MAJOR. */
#define BM_GPMI_VERSION_MAJOR (0xFF000000U) /*!< Bit mask for GPMI_VERSION_MAJOR. */
#define BS_GPMI_VERSION_MAJOR (8U)         /*!< Bit field size in bits for GPMI_VERSION_MAJOR. */

/*! @brief Read current value of the GPMI_VERSION_MAJOR field. */
#define BR_GPMI_VERSION_MAJOR(x) (HW_GPMI_VERSION(x).B.MAJOR)
/*@}*/

/*******************************************************************************
 * HW_GPMI_DEBUG2 - GPMI Debug2 Information Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_DEBUG2 - GPMI Debug2 Information Register Description (RW)
 *
 * Reset value: 0x0000F100U
 *
 * The GPMI Debug2 information register provides a read back path for
 * diagnostics to determine the cur­rent operating state of the GPMI controller.
 * GPMI_DEBUG2 0x0E0
 */
typedef union _hw_gpmi_debug2
{
    uint32_t U;
    struct _hw_gpmi_debug2_bitfields
    {
        uint32_t RDN_TAP : 6;          /*!< [5:0]  */
        uint32_t UPDATE_WINDOW : 1;    /*!< [6]  */
        uint32_t VIEW_DELAYED_RDN : 1; /*!< [7]  */
        uint32_t SYND2GPMI_READY : 1;  /*!< [8]  */
        uint32_t SYND2GPMI_VALID : 1;  /*!< [9]  */
        uint32_t GPMI2SYND_READY : 1;  /*!< [10]  */
        uint32_t GPMI2SYND_VALID : 1;  /*!< [11]  */
        uint32_t SYND2GPMI_BE : 4;     /*!< [15:12]  */
        uint32_t MAIN_STATE : 4;       /*!< [19:16]  */
        uint32_t PIN_STATE : 3;        /*!< [22:20]  */
        uint32_t BUSY : 1;             /*!< [23]  */
        uint32_t UDMA_STATE : 4;       /*!< [27:24]  */
        uint32_t RSVD1 : 4;            /*!< [31:28]  */
    } B;
} hw_gpmi_debug2_t;

/*!
 * @name Constants and macros for entire GPMI_DEBUG2 register
 */
/*@{*/
#define HW_GPMI_DEBUG2_ADDR(x)   ((uintptr_t)(x) + 0xE0U)

#define HW_GPMI_DEBUG2(x)        (*(__IO hw_gpmi_debug2_t *) HW_GPMI_DEBUG2_ADDR(x))
#define HW_GPMI_DEBUG2_RD(x)     (HW_GPMI_DEBUG2(x).U)
#define HW_GPMI_DEBUG2_WR(x, v)  (HW_GPMI_DEBUG2(x).U = (v))
#define HW_GPMI_DEBUG2_SET(x, v) (HW_GPMI_DEBUG2_WR(x, HW_GPMI_DEBUG2_RD(x) |  (v)))
#define HW_GPMI_DEBUG2_CLR(x, v) (HW_GPMI_DEBUG2_WR(x, HW_GPMI_DEBUG2_RD(x) & ~(v)))
#define HW_GPMI_DEBUG2_TOG(x, v) (HW_GPMI_DEBUG2_WR(x, HW_GPMI_DEBUG2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_DEBUG2 bitfields
 */

/*!
 * @name Register GPMI_DEBUG2, field RDN_TAP[5:0] (RO)
 *
 * This is the DLL tap calculated by the DLL controller. The selects the amount
 * of delay form the DLL chain.
 */
/*@{*/
#define BP_GPMI_DEBUG2_RDN_TAP (0U)        /*!< Bit position for GPMI_DEBUG2_RDN_TAP. */
#define BM_GPMI_DEBUG2_RDN_TAP (0x0000003FU) /*!< Bit mask for GPMI_DEBUG2_RDN_TAP. */
#define BS_GPMI_DEBUG2_RDN_TAP (6U)        /*!< Bit field size in bits for GPMI_DEBUG2_RDN_TAP. */

/*! @brief Read current value of the GPMI_DEBUG2_RDN_TAP field. */
#define BR_GPMI_DEBUG2_RDN_TAP(x) (HW_GPMI_DEBUG2(x).B.RDN_TAP)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field UPDATE_WINDOW[6] (RO)
 *
 * A 1 indicates that the DLL is busy generating the required delay.
 */
/*@{*/
#define BP_GPMI_DEBUG2_UPDATE_WINDOW (6U)  /*!< Bit position for GPMI_DEBUG2_UPDATE_WINDOW. */
#define BM_GPMI_DEBUG2_UPDATE_WINDOW (0x00000040U) /*!< Bit mask for GPMI_DEBUG2_UPDATE_WINDOW. */
#define BS_GPMI_DEBUG2_UPDATE_WINDOW (1U)  /*!< Bit field size in bits for GPMI_DEBUG2_UPDATE_WINDOW. */

/*! @brief Read current value of the GPMI_DEBUG2_UPDATE_WINDOW field. */
#define BR_GPMI_DEBUG2_UPDATE_WINDOW(x) (HW_GPMI_DEBUG2(x).B.UPDATE_WINDOW)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field VIEW_DELAYED_RDN[7] (RW)
 *
 * Set to a 1 to select the delayed feedback RE_B to drive the GPMI_ADDR[0]
 * (Nand CLE) pin. For debug purposes, this will allow you see if DLL is functioning
 * properly.
 */
/*@{*/
#define BP_GPMI_DEBUG2_VIEW_DELAYED_RDN (7U) /*!< Bit position for GPMI_DEBUG2_VIEW_DELAYED_RDN. */
#define BM_GPMI_DEBUG2_VIEW_DELAYED_RDN (0x00000080U) /*!< Bit mask for GPMI_DEBUG2_VIEW_DELAYED_RDN. */
#define BS_GPMI_DEBUG2_VIEW_DELAYED_RDN (1U) /*!< Bit field size in bits for GPMI_DEBUG2_VIEW_DELAYED_RDN. */

/*! @brief Read current value of the GPMI_DEBUG2_VIEW_DELAYED_RDN field. */
#define BR_GPMI_DEBUG2_VIEW_DELAYED_RDN(x) (HW_GPMI_DEBUG2(x).B.VIEW_DELAYED_RDN)

/*! @brief Format value for bitfield GPMI_DEBUG2_VIEW_DELAYED_RDN. */
#define BF_GPMI_DEBUG2_VIEW_DELAYED_RDN(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_DEBUG2_VIEW_DELAYED_RDN) & BM_GPMI_DEBUG2_VIEW_DELAYED_RDN)

/*! @brief Set the VIEW_DELAYED_RDN field to a new value. */
#define BW_GPMI_DEBUG2_VIEW_DELAYED_RDN(x, v) (HW_GPMI_DEBUG2_WR(x, (HW_GPMI_DEBUG2_RD(x) & ~BM_GPMI_DEBUG2_VIEW_DELAYED_RDN) | BF_GPMI_DEBUG2_VIEW_DELAYED_RDN(v)))
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field SYND2GPMI_READY[8] (RO)
 *
 * Data handshake Input from BCH.
 */
/*@{*/
#define BP_GPMI_DEBUG2_SYND2GPMI_READY (8U) /*!< Bit position for GPMI_DEBUG2_SYND2GPMI_READY. */
#define BM_GPMI_DEBUG2_SYND2GPMI_READY (0x00000100U) /*!< Bit mask for GPMI_DEBUG2_SYND2GPMI_READY. */
#define BS_GPMI_DEBUG2_SYND2GPMI_READY (1U) /*!< Bit field size in bits for GPMI_DEBUG2_SYND2GPMI_READY. */

/*! @brief Read current value of the GPMI_DEBUG2_SYND2GPMI_READY field. */
#define BR_GPMI_DEBUG2_SYND2GPMI_READY(x) (HW_GPMI_DEBUG2(x).B.SYND2GPMI_READY)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field SYND2GPMI_VALID[9] (RO)
 *
 * Data handshake Input from BCH.
 */
/*@{*/
#define BP_GPMI_DEBUG2_SYND2GPMI_VALID (9U) /*!< Bit position for GPMI_DEBUG2_SYND2GPMI_VALID. */
#define BM_GPMI_DEBUG2_SYND2GPMI_VALID (0x00000200U) /*!< Bit mask for GPMI_DEBUG2_SYND2GPMI_VALID. */
#define BS_GPMI_DEBUG2_SYND2GPMI_VALID (1U) /*!< Bit field size in bits for GPMI_DEBUG2_SYND2GPMI_VALID. */

/*! @brief Read current value of the GPMI_DEBUG2_SYND2GPMI_VALID field. */
#define BR_GPMI_DEBUG2_SYND2GPMI_VALID(x) (HW_GPMI_DEBUG2(x).B.SYND2GPMI_VALID)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field GPMI2SYND_READY[10] (RO)
 *
 * Data handshake output to BCH.
 */
/*@{*/
#define BP_GPMI_DEBUG2_GPMI2SYND_READY (10U) /*!< Bit position for GPMI_DEBUG2_GPMI2SYND_READY. */
#define BM_GPMI_DEBUG2_GPMI2SYND_READY (0x00000400U) /*!< Bit mask for GPMI_DEBUG2_GPMI2SYND_READY. */
#define BS_GPMI_DEBUG2_GPMI2SYND_READY (1U) /*!< Bit field size in bits for GPMI_DEBUG2_GPMI2SYND_READY. */

/*! @brief Read current value of the GPMI_DEBUG2_GPMI2SYND_READY field. */
#define BR_GPMI_DEBUG2_GPMI2SYND_READY(x) (HW_GPMI_DEBUG2(x).B.GPMI2SYND_READY)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field GPMI2SYND_VALID[11] (RO)
 *
 * Data handshake output to BCH.
 */
/*@{*/
#define BP_GPMI_DEBUG2_GPMI2SYND_VALID (11U) /*!< Bit position for GPMI_DEBUG2_GPMI2SYND_VALID. */
#define BM_GPMI_DEBUG2_GPMI2SYND_VALID (0x00000800U) /*!< Bit mask for GPMI_DEBUG2_GPMI2SYND_VALID. */
#define BS_GPMI_DEBUG2_GPMI2SYND_VALID (1U) /*!< Bit field size in bits for GPMI_DEBUG2_GPMI2SYND_VALID. */

/*! @brief Read current value of the GPMI_DEBUG2_GPMI2SYND_VALID field. */
#define BR_GPMI_DEBUG2_GPMI2SYND_VALID(x) (HW_GPMI_DEBUG2(x).B.GPMI2SYND_VALID)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field SYND2GPMI_BE[15:12] (RO)
 *
 * Data byte enable Input from BCH.
 */
/*@{*/
#define BP_GPMI_DEBUG2_SYND2GPMI_BE (12U)  /*!< Bit position for GPMI_DEBUG2_SYND2GPMI_BE. */
#define BM_GPMI_DEBUG2_SYND2GPMI_BE (0x0000F000U) /*!< Bit mask for GPMI_DEBUG2_SYND2GPMI_BE. */
#define BS_GPMI_DEBUG2_SYND2GPMI_BE (4U)   /*!< Bit field size in bits for GPMI_DEBUG2_SYND2GPMI_BE. */

/*! @brief Read current value of the GPMI_DEBUG2_SYND2GPMI_BE field. */
#define BR_GPMI_DEBUG2_SYND2GPMI_BE(x) (HW_GPMI_DEBUG2(x).B.SYND2GPMI_BE)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field MAIN_STATE[19:16] (RO)
 *
 * parameter MSM_IDLE = 4'h0, MSM_BYTCNT = 4'h1, MSM_WAITFE = 4'h2, MSM_WAITFR =
 * 4'h3, MSM_DMAREQ = 4'h4, MSM_DMAACK = 4'h5, MSM_WAITFF = 4'h6, MSM_LDFIFO =
 * 4'h7, MSM_LDDMAR = 4'h8, MSM_RDCMP = 4'h9, MSM_DONE = 4'hA. MSM_IDLE = 0x0
 * MSM_BYTCNT = 0x1 MSM_WAITFE = 0x2 MSM_WAITFR = 0x3 MSM_DMAREQ = 0x4 MSM_DMAACK =
 * 0x5 MSM_WAITFF = 0x6 MSM_LDFIFO = 0x7 MSM_LDDMAR = 0x8 MSM_RDCMP = 0x9 MSM_DONE
 * = 0xA
 */
/*@{*/
#define BP_GPMI_DEBUG2_MAIN_STATE (16U)    /*!< Bit position for GPMI_DEBUG2_MAIN_STATE. */
#define BM_GPMI_DEBUG2_MAIN_STATE (0x000F0000U) /*!< Bit mask for GPMI_DEBUG2_MAIN_STATE. */
#define BS_GPMI_DEBUG2_MAIN_STATE (4U)     /*!< Bit field size in bits for GPMI_DEBUG2_MAIN_STATE. */

/*! @brief Read current value of the GPMI_DEBUG2_MAIN_STATE field. */
#define BR_GPMI_DEBUG2_MAIN_STATE(x) (HW_GPMI_DEBUG2(x).B.MAIN_STATE)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field PIN_STATE[22:20] (RO)
 *
 * parameter PSM_IDLE = 3'h0, PSM_BYTCNT = 3'h1, PSM_ADDR = 3'h2, PSM_STALL =
 * 3'h3, PSM_STROBE = 3'h4, PSM_ATARDY = 3'h5, PSM_DHOLD = 3'h6, PSM_DONE = 3'h7.
 * PSM_IDLE = 0x0 PSM_BYTCNT = 0x1 PSM_ADDR = 0x2 PSM_STALL = 0x3 PSM_STROBE = 0x4
 * PSM_ATARDY = 0x5 PSM_DHOLD = 0x6 PSM_DONE = 0x7
 */
/*@{*/
#define BP_GPMI_DEBUG2_PIN_STATE (20U)     /*!< Bit position for GPMI_DEBUG2_PIN_STATE. */
#define BM_GPMI_DEBUG2_PIN_STATE (0x00700000U) /*!< Bit mask for GPMI_DEBUG2_PIN_STATE. */
#define BS_GPMI_DEBUG2_PIN_STATE (3U)      /*!< Bit field size in bits for GPMI_DEBUG2_PIN_STATE. */

/*! @brief Read current value of the GPMI_DEBUG2_PIN_STATE field. */
#define BR_GPMI_DEBUG2_PIN_STATE(x) (HW_GPMI_DEBUG2(x).B.PIN_STATE)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field BUSY[23] (RO)
 *
 * When asserted the GPMI is busy. Undefined results may occur if any registers
 * are written when BUSY is asserted. DISABLED = 0x0 The GPMI is not busy.
 * ENABLED = 0x1 The GPMI is busy.
 */
/*@{*/
#define BP_GPMI_DEBUG2_BUSY  (23U)         /*!< Bit position for GPMI_DEBUG2_BUSY. */
#define BM_GPMI_DEBUG2_BUSY  (0x00800000U) /*!< Bit mask for GPMI_DEBUG2_BUSY. */
#define BS_GPMI_DEBUG2_BUSY  (1U)          /*!< Bit field size in bits for GPMI_DEBUG2_BUSY. */

/*! @brief Read current value of the GPMI_DEBUG2_BUSY field. */
#define BR_GPMI_DEBUG2_BUSY(x) (HW_GPMI_DEBUG2(x).B.BUSY)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field UDMA_STATE[27:24] (RO)
 *
 * USM_IDLE = 4'h0, idle USM_DMARQ = 4'h1, DMA req USM_ACK = 4'h2, DMA ACK
 * USM_FIFO_E = 4'h3, Fifo empty USM_WPAUSE = 4'h4, WR DMA Paused by device USM_TSTRB
 * = 4'h5, Toggle HSTROBE USM_CAPTUR = 4'h6, Capture Stage, (data sampled with
 * DSTROBE is valid) USM_DATOUT = 4'h7, Change Burst DATAOUT USM_CRC = 4'h8, Source
 * CRC to Device USM_WAIT_R = 4'h9, Waiting for DDMARDY- USM_END = 4'ha; Negate
 * DMAACK (end of DMA) USM_WAIT_S = 4'hb, Waiting for DSTROBE USM_RPAUSE = 4'hc,
 * Rd DMA Paused by Host USM_RSTOP = 4'hd, Rd DMA Stopped by Host USM_WTERM =
 * 4'he, Wr DMA Termination State USM_RTERM = 4'hf, Rd DMA Termination state
 */
/*@{*/
#define BP_GPMI_DEBUG2_UDMA_STATE (24U)    /*!< Bit position for GPMI_DEBUG2_UDMA_STATE. */
#define BM_GPMI_DEBUG2_UDMA_STATE (0x0F000000U) /*!< Bit mask for GPMI_DEBUG2_UDMA_STATE. */
#define BS_GPMI_DEBUG2_UDMA_STATE (4U)     /*!< Bit field size in bits for GPMI_DEBUG2_UDMA_STATE. */

/*! @brief Read current value of the GPMI_DEBUG2_UDMA_STATE field. */
#define BR_GPMI_DEBUG2_UDMA_STATE(x) (HW_GPMI_DEBUG2(x).B.UDMA_STATE)
/*@}*/

/*!
 * @name Register GPMI_DEBUG2, field RSVD1[31:28] (RW)
 *
 * Always write zeroes to this bit field.
 */
/*@{*/
#define BP_GPMI_DEBUG2_RSVD1 (28U)         /*!< Bit position for GPMI_DEBUG2_RSVD1. */
#define BM_GPMI_DEBUG2_RSVD1 (0xF0000000U) /*!< Bit mask for GPMI_DEBUG2_RSVD1. */
#define BS_GPMI_DEBUG2_RSVD1 (4U)          /*!< Bit field size in bits for GPMI_DEBUG2_RSVD1. */

/*! @brief Read current value of the GPMI_DEBUG2_RSVD1 field. */
#define BR_GPMI_DEBUG2_RSVD1(x) (HW_GPMI_DEBUG2(x).B.RSVD1)

/*! @brief Format value for bitfield GPMI_DEBUG2_RSVD1. */
#define BF_GPMI_DEBUG2_RSVD1(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_DEBUG2_RSVD1) & BM_GPMI_DEBUG2_RSVD1)

/*! @brief Set the RSVD1 field to a new value. */
#define BW_GPMI_DEBUG2_RSVD1(x, v) (HW_GPMI_DEBUG2_WR(x, (HW_GPMI_DEBUG2_RD(x) & ~BM_GPMI_DEBUG2_RSVD1) | BF_GPMI_DEBUG2_RSVD1(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_DEBUG3 - GPMI Debug3 Information Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_DEBUG3 - GPMI Debug3 Information Register Description (RO)
 *
 * Reset value: 0x00000000U
 *
 * The GPMI Debug3 information register provides a read back path for
 * diagnostics to determine the cur­rent operating state of the GPMI controller.
 * GPMI_DEBUG3 0x0F0
 */
typedef union _hw_gpmi_debug3
{
    uint32_t U;
    struct _hw_gpmi_debug3_bitfields
    {
        uint32_t DEV_WORD_CNTR : 16;   /*!< [15:0]  */
        uint32_t APB_WORD_CNTR : 16;   /*!< [31:16]  */
    } B;
} hw_gpmi_debug3_t;

/*!
 * @name Constants and macros for entire GPMI_DEBUG3 register
 */
/*@{*/
#define HW_GPMI_DEBUG3_ADDR(x)   ((uintptr_t)(x) + 0xF0U)

#define HW_GPMI_DEBUG3(x)        (*(__I hw_gpmi_debug3_t *) HW_GPMI_DEBUG3_ADDR(x))
#define HW_GPMI_DEBUG3_RD(x)     (HW_GPMI_DEBUG3(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_DEBUG3 bitfields
 */

/*!
 * @name Register GPMI_DEBUG3, field DEV_WORD_CNTR[15:0] (RO)
 *
 * Reflects the number of bytes remains to be transferred on the ATA/Nand bus.
 */
/*@{*/
#define BP_GPMI_DEBUG3_DEV_WORD_CNTR (0U)  /*!< Bit position for GPMI_DEBUG3_DEV_WORD_CNTR. */
#define BM_GPMI_DEBUG3_DEV_WORD_CNTR (0x0000FFFFU) /*!< Bit mask for GPMI_DEBUG3_DEV_WORD_CNTR. */
#define BS_GPMI_DEBUG3_DEV_WORD_CNTR (16U) /*!< Bit field size in bits for GPMI_DEBUG3_DEV_WORD_CNTR. */

/*! @brief Read current value of the GPMI_DEBUG3_DEV_WORD_CNTR field. */
#define BR_GPMI_DEBUG3_DEV_WORD_CNTR(x) (HW_GPMI_DEBUG3(x).B.DEV_WORD_CNTR)
/*@}*/

/*!
 * @name Register GPMI_DEBUG3, field APB_WORD_CNTR[31:16] (RO)
 *
 * Reflects the number of bytes remains to be transferred on the APB bus.
 */
/*@{*/
#define BP_GPMI_DEBUG3_APB_WORD_CNTR (16U) /*!< Bit position for GPMI_DEBUG3_APB_WORD_CNTR. */
#define BM_GPMI_DEBUG3_APB_WORD_CNTR (0xFFFF0000U) /*!< Bit mask for GPMI_DEBUG3_APB_WORD_CNTR. */
#define BS_GPMI_DEBUG3_APB_WORD_CNTR (16U) /*!< Bit field size in bits for GPMI_DEBUG3_APB_WORD_CNTR. */

/*! @brief Read current value of the GPMI_DEBUG3_APB_WORD_CNTR field. */
#define BR_GPMI_DEBUG3_APB_WORD_CNTR(x) (HW_GPMI_DEBUG3(x).B.APB_WORD_CNTR)
/*@}*/

/*******************************************************************************
 * HW_GPMI_READ_DDR_DLL_CTRL - GPMI Double Rate Read DLL Control Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_READ_DDR_DLL_CTRL - GPMI Double Rate Read DLL Control Register Description (RW)
 *
 * Reset value: 0x00000038U
 *
 * GPMI DDR Read Delay Loop Lock Control Register. This register provides
 * programmability in DDR mode for data input timing and data formats.
 * GPMI_READ_DDR_DLL_CTRL 0x100
 */
typedef union _hw_gpmi_read_ddr_dll_ctrl
{
    uint32_t U;
    struct _hw_gpmi_read_ddr_dll_ctrl_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t RESET : 1;            /*!< [1]  */
        uint32_t SLV_FORCE_UPD : 1;    /*!< [2]  */
        uint32_t SLV_DLY_TARGET : 4;   /*!< [6:3]  */
        uint32_t GATE_UPDATE : 1;      /*!< [7]  */
        uint32_t REFCLK_ON : 1;        /*!< [8]  */
        uint32_t SLV_OVERRIDE : 1;     /*!< [9]  */
        uint32_t SLV_OVERRIDE_VAL : 8; /*!< [17:10]  */
        uint32_t RSVD1 : 2;            /*!< [19:18]  */
        uint32_t SLV_UPDATE_INT : 8;   /*!< [27:20]  */
        uint32_t REF_UPDATE_INT : 4;   /*!< [31:28]  */
    } B;
} hw_gpmi_read_ddr_dll_ctrl_t;

/*!
 * @name Constants and macros for entire GPMI_READ_DDR_DLL_CTRL register
 */
/*@{*/
#define HW_GPMI_READ_DDR_DLL_CTRL_ADDR(x) ((uintptr_t)(x) + 0x100U)

#define HW_GPMI_READ_DDR_DLL_CTRL(x) (*(__IO hw_gpmi_read_ddr_dll_ctrl_t *) HW_GPMI_READ_DDR_DLL_CTRL_ADDR(x))
#define HW_GPMI_READ_DDR_DLL_CTRL_RD(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).U)
#define HW_GPMI_READ_DDR_DLL_CTRL_WR(x, v) (HW_GPMI_READ_DDR_DLL_CTRL(x).U = (v))
#define HW_GPMI_READ_DDR_DLL_CTRL_SET(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, HW_GPMI_READ_DDR_DLL_CTRL_RD(x) |  (v)))
#define HW_GPMI_READ_DDR_DLL_CTRL_CLR(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~(v)))
#define HW_GPMI_READ_DDR_DLL_CTRL_TOG(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, HW_GPMI_READ_DDR_DLL_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_READ_DDR_DLL_CTRL bitfields
 */

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field ENABLE[0] (RW)
 *
 * Set this bit to 1 to enable the DLL and delay chain; otherwise; set to 0 to
 * bypasses DLL. Note that using the slave delay line override feature with
 * SLV_OVERRIDE and SLV_OVERRIDE VAL, the DLL does not need to be enabled.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_ENABLE (0U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_ENABLE. */
#define BM_GPMI_READ_DDR_DLL_CTRL_ENABLE (0x00000001U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_ENABLE. */
#define BS_GPMI_READ_DDR_DLL_CTRL_ENABLE (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_ENABLE. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_ENABLE field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_ENABLE(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.ENABLE)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_ENABLE. */
#define BF_GPMI_READ_DDR_DLL_CTRL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_ENABLE) & BM_GPMI_READ_DDR_DLL_CTRL_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_ENABLE(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_ENABLE) | BF_GPMI_READ_DDR_DLL_CTRL_ENABLE(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field RESET[1] (RW)
 *
 * Setting this bit to 1 force a reset on DLL. This will cause the DLL to lose
 * lock and re-calibrate to detect an GPMICLK half period phase shift. This signal
 * is used by the DLL as edge-sensitive, so in order to create a subsequent
 * reset, RESET must be taken low and then asserted again.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_RESET (1U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_RESET. */
#define BM_GPMI_READ_DDR_DLL_CTRL_RESET (0x00000002U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_RESET. */
#define BS_GPMI_READ_DDR_DLL_CTRL_RESET (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_RESET. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_RESET field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_RESET(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.RESET)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_RESET. */
#define BF_GPMI_READ_DDR_DLL_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_RESET) & BM_GPMI_READ_DDR_DLL_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_RESET(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_RESET) | BF_GPMI_READ_DDR_DLL_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field SLV_FORCE_UPD[2] (RW)
 *
 * Setting this bit to 1, forces the slave delay line to update to the DLL
 * calibrated value immediately. The slave delay line shall update automatically based
 * on the SLV_UPDATE_INT interval or when a DLL lock condition is sensed.
 * Subsequent forcing of the slave-line update can only occur if SLV_FORCE_UP is set
 * back to 0 and then asserted again (edge triggered).
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD (2U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BM_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD (0x00000004U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BS_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.SLV_FORCE_UPD)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BF_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD) & BM_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD)

/*! @brief Set the SLV_FORCE_UPD field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD) | BF_GPMI_READ_DDR_DLL_CTRL_SLV_FORCE_UPD(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field SLV_DLY_TARGET[6:3] (RW)
 *
 * The delay target for the read clock is can be programmed in 1/16th increments
 * of an GPMICLK half-period. So the input read-clock can be delayed relative
 * input data from (GPMICLK/2)/16 to GPMICLK/2.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET (3U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BM_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET (0x00000078U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BS_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET (4U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.SLV_DLY_TARGET)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BF_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET) & BM_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET)

/*! @brief Set the SLV_DLY_TARGET field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET) | BF_GPMI_READ_DDR_DLL_CTRL_SLV_DLY_TARGET(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field GATE_UPDATE[7] (RW)
 *
 * Setting this bit to 1, forces the slave delay line not update
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE (7U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE. */
#define BM_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE (0x00000080U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE. */
#define BS_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.GATE_UPDATE)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE. */
#define BF_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE) & BM_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE)

/*! @brief Set the GATE_UPDATE field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE) | BF_GPMI_READ_DDR_DLL_CTRL_GATE_UPDATE(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field REFCLK_ON[8] (RW)
 *
 * set this bit to 1 will turn on the reference clock
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON (8U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_REFCLK_ON. */
#define BM_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON (0x00000100U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_REFCLK_ON. */
#define BS_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_REFCLK_ON. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_REFCLK_ON field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.REFCLK_ON)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_REFCLK_ON. */
#define BF_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON) & BM_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON)

/*! @brief Set the REFCLK_ON field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON) | BF_GPMI_READ_DDR_DLL_CTRL_REFCLK_ON(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field SLV_OVERRIDE[9] (RW)
 *
 * Set this bit to 1 to Enable manual override for slave delay chain using
 * SLV_OVERRIDE_VAL; to set 0 to disable manual override. This feature does not
 * require the DLL to tbe enabled using the ENABLE bit. In fact to reduce power, if
 * SLV_OVERRIDE is used, it is recommended to disable the DLL with ENABLE=0
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE (9U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE (0x00000200U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BS_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.SLV_OVERRIDE)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BF_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE) & BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE)

/*! @brief Set the SLV_OVERRIDE field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE) | BF_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field SLV_OVERRIDE_VAL[17:10] (RW)
 *
 * When SLV_OVERRIDE=1 This field is used to select 1 of 256 physical taps
 * manually. A value of 0 selects tap 1, and a value of 0x7f selects tap 256.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (10U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (0x0003FC00U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BS_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (8U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.SLV_OVERRIDE_VAL)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BF_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL) & BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL)

/*! @brief Set the SLV_OVERRIDE_VAL field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL) | BF_GPMI_READ_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field RSVD1[19:18] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_RSVD1 (18U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_RSVD1. */
#define BM_GPMI_READ_DDR_DLL_CTRL_RSVD1 (0x000C0000U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_RSVD1. */
#define BS_GPMI_READ_DDR_DLL_CTRL_RSVD1 (2U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_RSVD1. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_RSVD1 field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_RSVD1(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field SLV_UPDATE_INT[27:20] (RW)
 *
 * Setting a value greater than 0 in this field, shall over-ride the default
 * slave delay-line update interval of 256 GPMICLK cycles. A value of 0 results in
 * an update interval of 256 GPMICLK cycles (default setting). A value of 0x0f
 * results in 15 cycles and so on. Note that software can always cause an update of
 * the slave-delay line using the SLV_FORCE_UPDATE register. Note that the slave
 * delay line will also update automatically when the reference DLL transitions
 * to a locked state (from an un-locked state).
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT (20U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BM_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT (0x0FF00000U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BS_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT (8U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.SLV_UPDATE_INT)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BF_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT) & BM_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT)

/*! @brief Set the SLV_UPDATE_INT field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT) | BF_GPMI_READ_DDR_DLL_CTRL_SLV_UPDATE_INT(v)))
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_CTRL, field REF_UPDATE_INT[31:28] (RW)
 *
 * This field allows the user to add additional delay cycles to the DLL control
 * loop (reference delay line control). By default, the DLL control loop shall
 * update every two GPMICLK cycles. Programming this field results in a DLL control
 * loop update interval of (2 + REF_UPDATE_INT) * GPMICLK. It should be noted
 * that increasing the reference delay-line update interval reduces the ability of
 * the DLL to adjust to fast changes in conditions that may effect the delay
 * (such as voltage and temperature)
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT (28U) /*!< Bit position for GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BM_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT (0xF0000000U) /*!< Bit mask for GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BS_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT (4U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT field. */
#define BR_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT(x) (HW_GPMI_READ_DDR_DLL_CTRL(x).B.REF_UPDATE_INT)

/*! @brief Format value for bitfield GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BF_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT) & BM_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT)

/*! @brief Set the REF_UPDATE_INT field to a new value. */
#define BW_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT(x, v) (HW_GPMI_READ_DDR_DLL_CTRL_WR(x, (HW_GPMI_READ_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT) | BF_GPMI_READ_DDR_DLL_CTRL_REF_UPDATE_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_WRITE_DDR_DLL_CTRL - GPMI Double Rate Write DLL Control Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_WRITE_DDR_DLL_CTRL - GPMI Double Rate Write DLL Control Register Description (RW)
 *
 * Reset value: 0x00000038U
 *
 * GPMI DDR Write Delay Loop Lock Control Register. This register provides
 * programmability in DDR mode for data output timing and data formats.
 * GPMI_WRITE_DDR_DLL_CTRL 0x110
 */
typedef union _hw_gpmi_write_ddr_dll_ctrl
{
    uint32_t U;
    struct _hw_gpmi_write_ddr_dll_ctrl_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t RESET : 1;            /*!< [1]  */
        uint32_t SLV_FORCE_UPD : 1;    /*!< [2]  */
        uint32_t SLV_DLY_TARGET : 4;   /*!< [6:3]  */
        uint32_t GATE_UPDATE : 1;      /*!< [7]  */
        uint32_t REFCLK_ON : 1;        /*!< [8]  */
        uint32_t SLV_OVERRIDE : 1;     /*!< [9]  */
        uint32_t SLV_OVERRIDE_VAL : 8; /*!< [17:10]  */
        uint32_t RSVD1 : 2;            /*!< [19:18]  */
        uint32_t SLV_UPDATE_INT : 8;   /*!< [27:20]  */
        uint32_t REF_UPDATE_INT : 4;   /*!< [31:28]  */
    } B;
} hw_gpmi_write_ddr_dll_ctrl_t;

/*!
 * @name Constants and macros for entire GPMI_WRITE_DDR_DLL_CTRL register
 */
/*@{*/
#define HW_GPMI_WRITE_DDR_DLL_CTRL_ADDR(x) ((uintptr_t)(x) + 0x110U)

#define HW_GPMI_WRITE_DDR_DLL_CTRL(x) (*(__IO hw_gpmi_write_ddr_dll_ctrl_t *) HW_GPMI_WRITE_DDR_DLL_CTRL_ADDR(x))
#define HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).U)
#define HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).U = (v))
#define HW_GPMI_WRITE_DDR_DLL_CTRL_SET(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) |  (v)))
#define HW_GPMI_WRITE_DDR_DLL_CTRL_CLR(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~(v)))
#define HW_GPMI_WRITE_DDR_DLL_CTRL_TOG(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPMI_WRITE_DDR_DLL_CTRL bitfields
 */

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field ENABLE[0] (RW)
 *
 * Set this bit to 1 to enable the DLL and delay chain; otherwise; set to 0 to
 * bypasses DLL. Note that using the slave delay line override feature with
 * SLV_OVERRIDE and SLV_OVERRIDE VAL, the DLL does not need to be enabled.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_ENABLE (0U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_ENABLE. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_ENABLE (0x00000001U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_ENABLE. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_ENABLE (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_ENABLE. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_ENABLE field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_ENABLE(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.ENABLE)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_ENABLE. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_ENABLE) & BM_GPMI_WRITE_DDR_DLL_CTRL_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_ENABLE(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_ENABLE) | BF_GPMI_WRITE_DDR_DLL_CTRL_ENABLE(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field RESET[1] (RW)
 *
 * Setting this bit to 1 force a reset on DLL. This will cause the DLL to lose
 * lock and re-calibrate to detect an GPMICLK half period phase shift. This signal
 * is used by the DLL as edge-sensitive, so in order to create a subsequent
 * reset, RESET must be taken low and then asserted again.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_RESET (1U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_RESET. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_RESET (0x00000002U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_RESET. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_RESET (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_RESET. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_RESET field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_RESET(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.RESET)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_RESET. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_RESET) & BM_GPMI_WRITE_DDR_DLL_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_RESET(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_RESET) | BF_GPMI_WRITE_DDR_DLL_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field SLV_FORCE_UPD[2] (RW)
 *
 * Setting this bit to 1, forces the slave delay line to update to the DLL
 * calibrated value immediately. The slave delay line shall update automatically based
 * on the SLV_UPDATE_INT interval or when a DLL lock condition is sensed.
 * Subsequent forcing of the slave-line update can only occur if SLV_FORCE_UP is set
 * back to 0 and then asserted again (edge triggered).
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD (2U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD (0x00000004U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.SLV_FORCE_UPD)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD) & BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD)

/*! @brief Set the SLV_FORCE_UPD field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD) | BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_FORCE_UPD(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field SLV_DLY_TARGET[6:3] (RW)
 *
 * The delay target for the read clock can be programmed in 1/16th increments of
 * an GPMICLK half-period. So the input read-clock can be delayed relative input
 * data from (GPMICLK/2)/16 to GPMICLK/2.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET (3U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET (0x00000078U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET (4U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.SLV_DLY_TARGET)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET) & BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET)

/*! @brief Set the SLV_DLY_TARGET field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET) | BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_DLY_TARGET(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field GATE_UPDATE[7] (RW)
 *
 * Setting this bit to 1, forces the slave delay line not update
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE (7U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE (0x00000080U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.GATE_UPDATE)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE) & BM_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE)

/*! @brief Set the GATE_UPDATE field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE) | BF_GPMI_WRITE_DDR_DLL_CTRL_GATE_UPDATE(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field REFCLK_ON[8] (RW)
 *
 * set this bit to 1 will turn on the reference clock
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON (8U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON (0x00000100U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.REFCLK_ON)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON) & BM_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON)

/*! @brief Set the REFCLK_ON field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON) | BF_GPMI_WRITE_DDR_DLL_CTRL_REFCLK_ON(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field SLV_OVERRIDE[9] (RW)
 *
 * Set this bit to 1 to Enable manual override for slave delay chain using
 * SLV_OVERRIDE_VAL; to set 0 to disable manual override. This feature does not
 * require the DLL to tbe enabled using the ENABLE bit. In fact to reduce power, if
 * SLV_OVERRIDE is used, it is recommended to disable the DLL with ENABLE=0
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE (9U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE (0x00000200U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.SLV_OVERRIDE)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE) & BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE)

/*! @brief Set the SLV_OVERRIDE field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE) | BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field SLV_OVERRIDE_VAL[17:10] (RW)
 *
 * When SLV_OVERRIDE=1 This field is used to select 1 of 256 physical taps
 * manually. A value of 0 selects tap 1, and a value of 0x7f selects tap 256.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (10U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (0x0003FC00U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL (8U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.SLV_OVERRIDE_VAL)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL) & BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL)

/*! @brief Set the SLV_OVERRIDE_VAL field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL) | BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_OVERRIDE_VAL(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field RSVD1[19:18] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_RSVD1 (18U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_RSVD1. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_RSVD1 (0x000C0000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_RSVD1. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_RSVD1 (2U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_RSVD1. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_RSVD1 field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_RSVD1(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field SLV_UPDATE_INT[27:20] (RW)
 *
 * Setting a value greater than 0 in this field, shall over-ride the default
 * slave delay-line update interval of 256 GPMICLK cycles. A value of 0 results in
 * an update interval of 256 GPMICLK cycles (default setting). A value of 0x0f
 * results in 15 cycles and so on. Note that software can always cause an update of
 * the slave-delay line using the SLV_FORCE_UPDATE register. Note that the slave
 * delay line will also update automatically when the reference DLL transitions
 * to a locked state (from an un-locked state).
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT (20U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT (0x0FF00000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT (8U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.SLV_UPDATE_INT)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT) & BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT)

/*! @brief Set the SLV_UPDATE_INT field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT) | BF_GPMI_WRITE_DDR_DLL_CTRL_SLV_UPDATE_INT(v)))
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_CTRL, field REF_UPDATE_INT[31:28] (RW)
 *
 * This field allows the user to add additional delay cycles to the DLL control
 * loop (reference delay line control). By default, the DLL control loop shall
 * update every two GPMICLK cycles. Programming this field results in a DLL control
 * loop update interval of (2 + REF_UPDATE_INT) * GPMICLK. It should be noted
 * that increasing the reference delay-line update interval reduces the ability of
 * the DLL to adjust to fast changes in conditions that may effect the delay
 * (such as voltage and temperature)
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT (28U) /*!< Bit position for GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BM_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT (0xF0000000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BS_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT (4U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT field. */
#define BR_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT(x) (HW_GPMI_WRITE_DDR_DLL_CTRL(x).B.REF_UPDATE_INT)

/*! @brief Format value for bitfield GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT. */
#define BF_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT) & BM_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT)

/*! @brief Set the REF_UPDATE_INT field to a new value. */
#define BW_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT(x, v) (HW_GPMI_WRITE_DDR_DLL_CTRL_WR(x, (HW_GPMI_WRITE_DDR_DLL_CTRL_RD(x) & ~BM_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT) | BF_GPMI_WRITE_DDR_DLL_CTRL_REF_UPDATE_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_GPMI_READ_DDR_DLL_STS - GPMI Double Rate Read DLL Status Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_READ_DDR_DLL_STS - GPMI Double Rate Read DLL Status Register Description (RO)
 *
 * Reset value: 0x00000000U
 *
 * GPMI Double Rate Read DLL Status Register, Read Only. GPMI DLL status fields
 * are provided in this register. GPMI_READ_DDR_DLL_STS 0x120
 */
typedef union _hw_gpmi_read_ddr_dll_sts
{
    uint32_t U;
    struct _hw_gpmi_read_ddr_dll_sts_bitfields
    {
        uint32_t SLV_LOCK : 1;         /*!< [0]  */
        uint32_t SLV_SEL : 8;          /*!< [8:1]  */
        uint32_t RSVD0 : 7;            /*!< [15:9]  */
        uint32_t REF_LOCK : 1;         /*!< [16]  */
        uint32_t REF_SEL : 8;          /*!< [24:17]  */
        uint32_t RSVD1 : 7;            /*!< [31:25]  */
    } B;
} hw_gpmi_read_ddr_dll_sts_t;

/*!
 * @name Constants and macros for entire GPMI_READ_DDR_DLL_STS register
 */
/*@{*/
#define HW_GPMI_READ_DDR_DLL_STS_ADDR(x) ((uintptr_t)(x) + 0x120U)

#define HW_GPMI_READ_DDR_DLL_STS(x) (*(__I hw_gpmi_read_ddr_dll_sts_t *) HW_GPMI_READ_DDR_DLL_STS_ADDR(x))
#define HW_GPMI_READ_DDR_DLL_STS_RD(x) (HW_GPMI_READ_DDR_DLL_STS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_READ_DDR_DLL_STS bitfields
 */

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field SLV_LOCK[0] (RO)
 *
 * Slave delay-line lock status. This signifies that a valid calibration has
 * been set to the slave-delay line and that the slave-delay line is implementing
 * the programmed delay value.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_SLV_LOCK (0U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_SLV_LOCK. */
#define BM_GPMI_READ_DDR_DLL_STS_SLV_LOCK (0x00000001U) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_SLV_LOCK. */
#define BS_GPMI_READ_DDR_DLL_STS_SLV_LOCK (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_SLV_LOCK. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_SLV_LOCK field. */
#define BR_GPMI_READ_DDR_DLL_STS_SLV_LOCK(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.SLV_LOCK)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field SLV_SEL[8:1] (RO)
 *
 * Slave delay line select status
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_SLV_SEL (1U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_SLV_SEL. */
#define BM_GPMI_READ_DDR_DLL_STS_SLV_SEL (0x000001FEU) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_SLV_SEL. */
#define BS_GPMI_READ_DDR_DLL_STS_SLV_SEL (8U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_SLV_SEL. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_SLV_SEL field. */
#define BR_GPMI_READ_DDR_DLL_STS_SLV_SEL(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.SLV_SEL)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field RSVD0[15:9] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_RSVD0 (9U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_RSVD0. */
#define BM_GPMI_READ_DDR_DLL_STS_RSVD0 (0x0000FE00U) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_RSVD0. */
#define BS_GPMI_READ_DDR_DLL_STS_RSVD0 (7U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_RSVD0. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_RSVD0 field. */
#define BR_GPMI_READ_DDR_DLL_STS_RSVD0(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.RSVD0)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field REF_LOCK[16] (RO)
 *
 * Reference DLL lock status. This signifies that the DLL has detected and
 * locked to a half-phase GPMICLK shift, allowing the slave delay-line to perform
 * programmed clock delays.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_REF_LOCK (16U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_REF_LOCK. */
#define BM_GPMI_READ_DDR_DLL_STS_REF_LOCK (0x00010000U) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_REF_LOCK. */
#define BS_GPMI_READ_DDR_DLL_STS_REF_LOCK (1U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_REF_LOCK. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_REF_LOCK field. */
#define BR_GPMI_READ_DDR_DLL_STS_REF_LOCK(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.REF_LOCK)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field REF_SEL[24:17] (RO)
 *
 * Reference delay line select status.
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_REF_SEL (17U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_REF_SEL. */
#define BM_GPMI_READ_DDR_DLL_STS_REF_SEL (0x01FE0000U) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_REF_SEL. */
#define BS_GPMI_READ_DDR_DLL_STS_REF_SEL (8U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_REF_SEL. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_REF_SEL field. */
#define BR_GPMI_READ_DDR_DLL_STS_REF_SEL(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.REF_SEL)
/*@}*/

/*!
 * @name Register GPMI_READ_DDR_DLL_STS, field RSVD1[31:25] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_READ_DDR_DLL_STS_RSVD1 (25U) /*!< Bit position for GPMI_READ_DDR_DLL_STS_RSVD1. */
#define BM_GPMI_READ_DDR_DLL_STS_RSVD1 (0xFE000000U) /*!< Bit mask for GPMI_READ_DDR_DLL_STS_RSVD1. */
#define BS_GPMI_READ_DDR_DLL_STS_RSVD1 (7U) /*!< Bit field size in bits for GPMI_READ_DDR_DLL_STS_RSVD1. */

/*! @brief Read current value of the GPMI_READ_DDR_DLL_STS_RSVD1 field. */
#define BR_GPMI_READ_DDR_DLL_STS_RSVD1(x) (HW_GPMI_READ_DDR_DLL_STS(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * HW_GPMI_WRITE_DDR_DLL_STS - GPMI Double Rate Write DLL Status Register Description
 ******************************************************************************/

/*!
 * @brief HW_GPMI_WRITE_DDR_DLL_STS - GPMI Double Rate Write DLL Status Register Description (RO)
 *
 * Reset value: 0x00000000U
 *
 * GPMI Double Rate Write DLL Status Register, Read Only. GPMI DLL status fields
 * are provided in this register. GPMI_WRITE_DDR_DLL_STS 0x130
 */
typedef union _hw_gpmi_write_ddr_dll_sts
{
    uint32_t U;
    struct _hw_gpmi_write_ddr_dll_sts_bitfields
    {
        uint32_t SLV_LOCK : 1;         /*!< [0]  */
        uint32_t SLV_SEL : 8;          /*!< [8:1]  */
        uint32_t RSVD0 : 7;            /*!< [15:9]  */
        uint32_t REF_LOCK : 1;         /*!< [16]  */
        uint32_t REF_SEL : 8;          /*!< [24:17]  */
        uint32_t RSVD1 : 7;            /*!< [31:25]  */
    } B;
} hw_gpmi_write_ddr_dll_sts_t;

/*!
 * @name Constants and macros for entire GPMI_WRITE_DDR_DLL_STS register
 */
/*@{*/
#define HW_GPMI_WRITE_DDR_DLL_STS_ADDR(x) ((uintptr_t)(x) + 0x130U)

#define HW_GPMI_WRITE_DDR_DLL_STS(x) (*(__I hw_gpmi_write_ddr_dll_sts_t *) HW_GPMI_WRITE_DDR_DLL_STS_ADDR(x))
#define HW_GPMI_WRITE_DDR_DLL_STS_RD(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPMI_WRITE_DDR_DLL_STS bitfields
 */

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field SLV_LOCK[0] (RO)
 *
 * Slave delay-line lock status. This signifies that a valid calibration has
 * been set to the slave-delay line and that the slave-delay line is implementing
 * the programmed delay value.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_SLV_LOCK (0U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_SLV_LOCK. */
#define BM_GPMI_WRITE_DDR_DLL_STS_SLV_LOCK (0x00000001U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_SLV_LOCK. */
#define BS_GPMI_WRITE_DDR_DLL_STS_SLV_LOCK (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_SLV_LOCK. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_SLV_LOCK field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_SLV_LOCK(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.SLV_LOCK)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field SLV_SEL[8:1] (RO)
 *
 * Slave delay line select status
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_SLV_SEL (1U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_SLV_SEL. */
#define BM_GPMI_WRITE_DDR_DLL_STS_SLV_SEL (0x000001FEU) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_SLV_SEL. */
#define BS_GPMI_WRITE_DDR_DLL_STS_SLV_SEL (8U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_SLV_SEL. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_SLV_SEL field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_SLV_SEL(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.SLV_SEL)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field RSVD0[15:9] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_RSVD0 (9U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_RSVD0. */
#define BM_GPMI_WRITE_DDR_DLL_STS_RSVD0 (0x0000FE00U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_RSVD0. */
#define BS_GPMI_WRITE_DDR_DLL_STS_RSVD0 (7U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_RSVD0. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_RSVD0 field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_RSVD0(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.RSVD0)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field REF_LOCK[16] (RO)
 *
 * Reference DLL lock status. This signifies that the DLL has detected and
 * locked to a half-phase GPMICLK shift, allowing the slave delay-line to perform
 * programmed clock delays.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_REF_LOCK (16U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_REF_LOCK. */
#define BM_GPMI_WRITE_DDR_DLL_STS_REF_LOCK (0x00010000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_REF_LOCK. */
#define BS_GPMI_WRITE_DDR_DLL_STS_REF_LOCK (1U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_REF_LOCK. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_REF_LOCK field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_REF_LOCK(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.REF_LOCK)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field REF_SEL[24:17] (RO)
 *
 * Reference delay line select status.
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_REF_SEL (17U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_REF_SEL. */
#define BM_GPMI_WRITE_DDR_DLL_STS_REF_SEL (0x01FE0000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_REF_SEL. */
#define BS_GPMI_WRITE_DDR_DLL_STS_REF_SEL (8U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_REF_SEL. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_REF_SEL field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_REF_SEL(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.REF_SEL)
/*@}*/

/*!
 * @name Register GPMI_WRITE_DDR_DLL_STS, field RSVD1[31:25] (RO)
 *
 * Reserved
 */
/*@{*/
#define BP_GPMI_WRITE_DDR_DLL_STS_RSVD1 (25U) /*!< Bit position for GPMI_WRITE_DDR_DLL_STS_RSVD1. */
#define BM_GPMI_WRITE_DDR_DLL_STS_RSVD1 (0xFE000000U) /*!< Bit mask for GPMI_WRITE_DDR_DLL_STS_RSVD1. */
#define BS_GPMI_WRITE_DDR_DLL_STS_RSVD1 (7U) /*!< Bit field size in bits for GPMI_WRITE_DDR_DLL_STS_RSVD1. */

/*! @brief Read current value of the GPMI_WRITE_DDR_DLL_STS_RSVD1 field. */
#define BR_GPMI_WRITE_DDR_DLL_STS_RSVD1(x) (HW_GPMI_WRITE_DDR_DLL_STS(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * hw_gpmi_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPMI module registers.
 */
#pragma pack(1)
typedef struct _hw_gpmi
{
    __IO hw_gpmi_ctrl0_t CTRL0;            /*!< [0x0] GPMI Control Register 0 Description */
    uint8_t _reserved0[12];
    __IO hw_gpmi_compare_t COMPARE;        /*!< [0x10] GPMI Compare Register Description */
    uint8_t _reserved1[12];
    __IO hw_gpmi_eccctrl_t ECCCTRL;        /*!< [0x20] GPMI Integrated ECC Control Register Description */
    uint8_t _reserved2[12];
    __IO hw_gpmi_ecccount_t ECCCOUNT;      /*!< [0x30] GPMI Integrated ECC Transfer Count Register Description */
    uint8_t _reserved3[12];
    __IO hw_gpmi_payload_t PAYLOAD;        /*!< [0x40] GPMI Payload Address Register Description */
    uint8_t _reserved4[12];
    __IO hw_gpmi_auxiliary_t AUXILIARY;    /*!< [0x50] GPMI Auxiliary Address Register Description */
    uint8_t _reserved5[12];
    __IO hw_gpmi_ctrl1_t CTRL1;            /*!< [0x60] GPMI Control Register 1 Description */
    uint8_t _reserved6[12];
    __IO hw_gpmi_timing0_t TIMING0;        /*!< [0x70] GPMI Timing Register 0 Description */
    uint8_t _reserved7[12];
    __IO hw_gpmi_timing1_t TIMING1;        /*!< [0x80] GPMI Timing Register 1 Description */
    uint8_t _reserved8[12];
    __IO hw_gpmi_timing2_t TIMING2;        /*!< [0x90] GPMI Timing Register 2 Description */
    uint8_t _reserved9[12];
    __IO hw_gpmi_data_t DATA;              /*!< [0xA0] GPMI DMA Data Transfer Register Description */
    uint8_t _reserved10[12];
    __I hw_gpmi_stat_t STAT;               /*!< [0xB0] GPMI Status Register Description */
    uint8_t _reserved11[12];
    __I hw_gpmi_debug_t DEBUGr;            /*!< [0xC0] GPMI Debug Information Register Description */
    uint8_t _reserved12[12];
    __I hw_gpmi_version_t VERSION;         /*!< [0xD0] GPMI Version Register Description */
    uint8_t _reserved13[12];
    __IO hw_gpmi_debug2_t DEBUG2;          /*!< [0xE0] GPMI Debug2 Information Register Description */
    uint8_t _reserved14[12];
    __I hw_gpmi_debug3_t DEBUG3;           /*!< [0xF0] GPMI Debug3 Information Register Description */
    uint8_t _reserved15[12];
    __IO hw_gpmi_read_ddr_dll_ctrl_t READ_DDR_DLL_CTRL; /*!< [0x100] GPMI Double Rate Read DLL Control Register Description */
    uint8_t _reserved16[12];
    __IO hw_gpmi_write_ddr_dll_ctrl_t WRITE_DDR_DLL_CTRL; /*!< [0x110] GPMI Double Rate Write DLL Control Register Description */
    uint8_t _reserved17[12];
    __I hw_gpmi_read_ddr_dll_sts_t READ_DDR_DLL_STS; /*!< [0x120] GPMI Double Rate Read DLL Status Register Description */
    uint8_t _reserved18[12];
    __I hw_gpmi_write_ddr_dll_sts_t WRITE_DDR_DLL_STS; /*!< [0x130] GPMI Double Rate Write DLL Status Register Description */
} hw_gpmi_t;
#pragma pack()

/*! @brief Macro to access all GPMI registers. */
/*! @param x GPMI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPMI_REGS(GPMI_BASE)</code>. */
#define HW_GPMI_REGS(x) (*(hw_gpmi_t *)(x))

/*
 * iMX6DP GPT
 *
 * GPT
 *
 * Registers defined in this header file:
 * - HW_GPT_CR - GPT Control Register
 * - HW_GPT_PR - GPT Prescaler Register
 * - HW_GPT_SR - GPT Status Register
 * - HW_GPT_IR - GPT Interrupt Register
 * - HW_GPT_OCR1 - GPT Output Compare Register 1
 * - HW_GPT_OCR2 - GPT Output Compare Register 2
 * - HW_GPT_OCR3 - GPT Output Compare Register 3
 * - HW_GPT_ICR1 - GPT Input Capture Register 1
 * - HW_GPT_ICR2 - GPT Input Capture Register 2
 * - HW_GPT_CNT - GPT Counter Register
 *
 * - hw_gpt_t - Struct containing all module registers.
 */

#define HW_GPT_INSTANCE_COUNT (1U) /*!< Number of instances of the GPT module. */
#define HW_GPT (0U) /*!< Instance number for GPT. */
#define GPT_BASE              (0x2098000U) /*!< Base address for GPT. */
/*! Array initializer of GPT base addresses. */
#define GPT_BASE_ADDRS        { GPT_BASE }

/*******************************************************************************
 * HW_GPT_CR - GPT Control Register
 ******************************************************************************/

/*!
 * @brief HW_GPT_CR - GPT Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Control Register (GPT_CR) is used to program and configure GPT
 * operations. An IP Bus Write to the GPT Control Register occurs after one cycle of
 * wait state, while an IP Bus Read occurs after 0 wait states.
 */
typedef union _hw_gpt_cr
{
    uint32_t U;
    struct _hw_gpt_cr_bitfields
    {
        uint32_t EN : 1;               /*!< [0]  */
        uint32_t ENMOD : 1;            /*!< [1]  */
        uint32_t DBGEN : 1;            /*!< [2]  */
        uint32_t WAITEN : 1;           /*!< [3]  */
        uint32_t DOZEEN : 1;           /*!< [4]  */
        uint32_t STOPEN : 1;           /*!< [5]  */
        uint32_t CLKSRC : 3;           /*!< [8:6]  */
        uint32_t FRR : 1;              /*!< [9]  */
        uint32_t RESERVED0 : 5;        /*!< [14:10]  */
        uint32_t SWR : 1;              /*!< [15]  */
        uint32_t IM1 : 2;              /*!< [17:16]  */
        uint32_t IM2 : 2;              /*!< [19:18]  */
        uint32_t OM1 : 3;              /*!< [22:20]  */
        uint32_t OM2 : 3;              /*!< [25:23]  */
        uint32_t OM3 : 3;              /*!< [28:26]  */
        uint32_t FO1 : 1;              /*!< [29]  */
        uint32_t FO2 : 1;              /*!< [30]  */
        uint32_t FO3 : 1;              /*!< [31]  */
    } B;
} hw_gpt_cr_t;

/*!
 * @name Constants and macros for entire GPT_CR register
 */
/*@{*/
#define HW_GPT_CR_ADDR(x)        ((uintptr_t)(x) + 0x0U)

#define HW_GPT_CR(x)             (*(__IO hw_gpt_cr_t *) HW_GPT_CR_ADDR(x))
#define HW_GPT_CR_RD(x)          (HW_GPT_CR(x).U)
#define HW_GPT_CR_WR(x, v)       (HW_GPT_CR(x).U = (v))
#define HW_GPT_CR_SET(x, v)      (HW_GPT_CR_WR(x, HW_GPT_CR_RD(x) |  (v)))
#define HW_GPT_CR_CLR(x, v)      (HW_GPT_CR_WR(x, HW_GPT_CR_RD(x) & ~(v)))
#define HW_GPT_CR_TOG(x, v)      (HW_GPT_CR_WR(x, HW_GPT_CR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_CR bitfields
 */

/*!
 * @name Register GPT_CR, field EN[0] (RW)
 *
 * GPT Enable. The EN bit is the GPT module enable bit. Before setting the EN
 * bit, we recommend that all registers be properly programmed. A hardware reset
 * resets the EN bit. A software reset does not affect the EN bit.
 *
 * Values:
 * - 0 - GPT is disabled.
 * - 1 - GPT is enabled.
 */
/*@{*/
#define BP_GPT_CR_EN         (0U)          /*!< Bit position for GPT_CR_EN. */
#define BM_GPT_CR_EN         (0x00000001U) /*!< Bit mask for GPT_CR_EN. */
#define BS_GPT_CR_EN         (1U)          /*!< Bit field size in bits for GPT_CR_EN. */

/*! @brief Read current value of the GPT_CR_EN field. */
#define BR_GPT_CR_EN(x)      (HW_GPT_CR(x).B.EN)

/*! @brief Format value for bitfield GPT_CR_EN. */
#define BF_GPT_CR_EN(v)      ((uint32_t)((uint32_t)(v) << BP_GPT_CR_EN) & BM_GPT_CR_EN)

/*! @brief Set the EN field to a new value. */
#define BW_GPT_CR_EN(x, v)   (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_EN) | BF_GPT_CR_EN(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field ENMOD[1] (RW)
 *
 * GPT Enable mode. When the GPT is disabled (EN=0), then both the Main Counter
 * and Prescaler Counter freeze their current count values. The ENMOD bit
 * determines the value of the GPT counter when Counter is enabled again (if the EN bit
 * is set). If the ENMOD bit is 1, then the Main Counter and Prescaler Counter
 * values are reset to 0 after GPT is enabled (EN=1). If the ENMOD bit is 0, then
 * the Main Counter and Prescaler Counter restart counting from their frozen
 * values after GPT is enabled (EN=1). If GPT is programmed to be disabled in a low
 * power mode (STOP/WAIT), then the Main Counter and Prescaler Counter freeze at
 * their current count values when the GPT enters low power mode. When GPT exits
 * low power mode, the Main Counter and Prescaler Counter start counting from their
 * frozen values, regardless of the ENMOD bit value. Setting the SWR bit will
 * clear the Main Counter and Prescaler Counter values, regardless of the value of
 * EN or ENMOD bits. A hardware reset resets the ENMOD bit. A software reset does
 * not affect the ENMOD bit.
 *
 * Values:
 * - 0 - GPT counter will retain its value when it is disabled.
 * - 1 - GPT counter value is reset to 0 when it is disabled.
 */
/*@{*/
#define BP_GPT_CR_ENMOD      (1U)          /*!< Bit position for GPT_CR_ENMOD. */
#define BM_GPT_CR_ENMOD      (0x00000002U) /*!< Bit mask for GPT_CR_ENMOD. */
#define BS_GPT_CR_ENMOD      (1U)          /*!< Bit field size in bits for GPT_CR_ENMOD. */

/*! @brief Read current value of the GPT_CR_ENMOD field. */
#define BR_GPT_CR_ENMOD(x)   (HW_GPT_CR(x).B.ENMOD)

/*! @brief Format value for bitfield GPT_CR_ENMOD. */
#define BF_GPT_CR_ENMOD(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_CR_ENMOD) & BM_GPT_CR_ENMOD)

/*! @brief Set the ENMOD field to a new value. */
#define BW_GPT_CR_ENMOD(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_ENMOD) | BF_GPT_CR_ENMOD(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field DBGEN[2] (RW)
 *
 * GPT debug mode enable. The DBGEN read/write control bit enables GPT operation
 * during Debug mode. A hardware reset resets the DBGEN bit. A software reset
 * does not affect the DBGEN bit.
 *
 * Values:
 * - 0 - GPT is disabled in debug mode.
 * - 1 - GPT is enabled in debug mode.
 */
/*@{*/
#define BP_GPT_CR_DBGEN      (2U)          /*!< Bit position for GPT_CR_DBGEN. */
#define BM_GPT_CR_DBGEN      (0x00000004U) /*!< Bit mask for GPT_CR_DBGEN. */
#define BS_GPT_CR_DBGEN      (1U)          /*!< Bit field size in bits for GPT_CR_DBGEN. */

/*! @brief Read current value of the GPT_CR_DBGEN field. */
#define BR_GPT_CR_DBGEN(x)   (HW_GPT_CR(x).B.DBGEN)

/*! @brief Format value for bitfield GPT_CR_DBGEN. */
#define BF_GPT_CR_DBGEN(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_CR_DBGEN) & BM_GPT_CR_DBGEN)

/*! @brief Set the DBGEN field to a new value. */
#define BW_GPT_CR_DBGEN(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_DBGEN) | BF_GPT_CR_DBGEN(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field WAITEN[3] (RW)
 *
 * GPT Wait Mode enable. The WAITEN read/write control bit enables GPT operation
 * during Wait mode. A hardware reset resets the WAITEN bit. A software reset
 * does not affect the WAITEN bit.
 *
 * Values:
 * - 0 - GPT is disabled in wait mode.
 * - 1 - GPT is enabled in wait mode.
 */
/*@{*/
#define BP_GPT_CR_WAITEN     (3U)          /*!< Bit position for GPT_CR_WAITEN. */
#define BM_GPT_CR_WAITEN     (0x00000008U) /*!< Bit mask for GPT_CR_WAITEN. */
#define BS_GPT_CR_WAITEN     (1U)          /*!< Bit field size in bits for GPT_CR_WAITEN. */

/*! @brief Read current value of the GPT_CR_WAITEN field. */
#define BR_GPT_CR_WAITEN(x)  (HW_GPT_CR(x).B.WAITEN)

/*! @brief Format value for bitfield GPT_CR_WAITEN. */
#define BF_GPT_CR_WAITEN(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_CR_WAITEN) & BM_GPT_CR_WAITEN)

/*! @brief Set the WAITEN field to a new value. */
#define BW_GPT_CR_WAITEN(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_WAITEN) | BF_GPT_CR_WAITEN(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field DOZEEN[4] (RW)
 *
 * GPT Doze Mode Enable. A hardware reset resets the DOZEEN bit. A software
 * reset does not affect the DOZEEN bit.
 *
 * Values:
 * - 0 - GPT is disabled in doze mode.
 * - 1 - GPT is enabled in doze mode.
 */
/*@{*/
#define BP_GPT_CR_DOZEEN     (4U)          /*!< Bit position for GPT_CR_DOZEEN. */
#define BM_GPT_CR_DOZEEN     (0x00000010U) /*!< Bit mask for GPT_CR_DOZEEN. */
#define BS_GPT_CR_DOZEEN     (1U)          /*!< Bit field size in bits for GPT_CR_DOZEEN. */

/*! @brief Read current value of the GPT_CR_DOZEEN field. */
#define BR_GPT_CR_DOZEEN(x)  (HW_GPT_CR(x).B.DOZEEN)

/*! @brief Format value for bitfield GPT_CR_DOZEEN. */
#define BF_GPT_CR_DOZEEN(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_CR_DOZEEN) & BM_GPT_CR_DOZEEN)

/*! @brief Set the DOZEEN field to a new value. */
#define BW_GPT_CR_DOZEEN(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_DOZEEN) | BF_GPT_CR_DOZEEN(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field STOPEN[5] (RW)
 *
 * GPT Stop Mode enable. The STOPEN read/write control bit enables GPT operation
 * during Stop mode. A hardware reset resets the STOPEN bit. A software reset
 * does not affect the STOPEN bit.
 *
 * Values:
 * - 0 - GPT is disabled in Stop mode.
 * - 1 - GPT is enabled in Stop mode.
 */
/*@{*/
#define BP_GPT_CR_STOPEN     (5U)          /*!< Bit position for GPT_CR_STOPEN. */
#define BM_GPT_CR_STOPEN     (0x00000020U) /*!< Bit mask for GPT_CR_STOPEN. */
#define BS_GPT_CR_STOPEN     (1U)          /*!< Bit field size in bits for GPT_CR_STOPEN. */

/*! @brief Read current value of the GPT_CR_STOPEN field. */
#define BR_GPT_CR_STOPEN(x)  (HW_GPT_CR(x).B.STOPEN)

/*! @brief Format value for bitfield GPT_CR_STOPEN. */
#define BF_GPT_CR_STOPEN(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_CR_STOPEN) & BM_GPT_CR_STOPEN)

/*! @brief Set the STOPEN field to a new value. */
#define BW_GPT_CR_STOPEN(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_STOPEN) | BF_GPT_CR_STOPEN(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field CLKSRC[8:6] (RW)
 *
 * Clock Source select. The CLKSRC bits select which clock will go to the
 * prescaler (and subsequently be used to run the GPT counter). The CLKSRC bit field
 * value should only be changed after disabling the GPT by clearing the EN bit in
 * this register (GPT_CR). A software reset does not affect the CLKSRC bit.
 *
 * Values:
 * - 000 - No clock
 * - 001 - Peripheral Clock
 * - 010 - High Frequency Reference Clock
 * - 011 - External Clock (CLKIN)
 * - 100 - Low Frequency Reference Clock
 * - 101 - Crystal oscillator divided by 8 as Reference Clock
 * - 111 - Crystal oscillator as Reference Clock
 */
/*@{*/
#define BP_GPT_CR_CLKSRC     (6U)          /*!< Bit position for GPT_CR_CLKSRC. */
#define BM_GPT_CR_CLKSRC     (0x000001C0U) /*!< Bit mask for GPT_CR_CLKSRC. */
#define BS_GPT_CR_CLKSRC     (3U)          /*!< Bit field size in bits for GPT_CR_CLKSRC. */

/*! @brief Read current value of the GPT_CR_CLKSRC field. */
#define BR_GPT_CR_CLKSRC(x)  (HW_GPT_CR(x).B.CLKSRC)

/*! @brief Format value for bitfield GPT_CR_CLKSRC. */
#define BF_GPT_CR_CLKSRC(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_CR_CLKSRC) & BM_GPT_CR_CLKSRC)

/*! @brief Set the CLKSRC field to a new value. */
#define BW_GPT_CR_CLKSRC(x, v) (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_CLKSRC) | BF_GPT_CR_CLKSRC(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field FRR[9] (RW)
 *
 * Free-Run or Restart mode. The FFR bit determines the behavior of the GPT when
 * a compare event in channel 1 occurs. In Restart mode, after a compare event,
 * the counter resets to 0x00000000 and resumes counting (after the occurrence of
 * a compare event). In Free-Run mode, after a compare event, the counter
 * continues counting until 0xFFFFFFFF and then rolls over to 0.
 *
 * Values:
 * - 0 - Restart mode
 * - 1 - Free-Run mode
 */
/*@{*/
#define BP_GPT_CR_FRR        (9U)          /*!< Bit position for GPT_CR_FRR. */
#define BM_GPT_CR_FRR        (0x00000200U) /*!< Bit mask for GPT_CR_FRR. */
#define BS_GPT_CR_FRR        (1U)          /*!< Bit field size in bits for GPT_CR_FRR. */

/*! @brief Read current value of the GPT_CR_FRR field. */
#define BR_GPT_CR_FRR(x)     (HW_GPT_CR(x).B.FRR)

/*! @brief Format value for bitfield GPT_CR_FRR. */
#define BF_GPT_CR_FRR(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_FRR) & BM_GPT_CR_FRR)

/*! @brief Set the FRR field to a new value. */
#define BW_GPT_CR_FRR(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_FRR) | BF_GPT_CR_FRR(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field SWR[15] (RW)
 *
 * Software reset. This is the software reset of the GPT module. It is a
 * self-clearing bit. The SWR bit is set when the module is in reset state. The SWR bit
 * is cleared when the reset procedure finishes. Setting the SWR bit resets all
 * of the registers to their default reset values, except for the CLKSRC, EN,
 * ENMOD, STOPEN, WAITEN, and DBGEN bits in the GPT Control Register (this control
 * register).
 *
 * Values:
 * - 0 - GPT is not in reset state
 * - 1 - GPT is in reset state
 */
/*@{*/
#define BP_GPT_CR_SWR        (15U)         /*!< Bit position for GPT_CR_SWR. */
#define BM_GPT_CR_SWR        (0x00008000U) /*!< Bit mask for GPT_CR_SWR. */
#define BS_GPT_CR_SWR        (1U)          /*!< Bit field size in bits for GPT_CR_SWR. */

/*! @brief Read current value of the GPT_CR_SWR field. */
#define BR_GPT_CR_SWR(x)     (HW_GPT_CR(x).B.SWR)

/*! @brief Format value for bitfield GPT_CR_SWR. */
#define BF_GPT_CR_SWR(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_SWR) & BM_GPT_CR_SWR)

/*! @brief Set the SWR field to a new value. */
#define BW_GPT_CR_SWR(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_SWR) | BF_GPT_CR_SWR(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field IM1[17:16] (RW)
 *
 * See IM2
 */
/*@{*/
#define BP_GPT_CR_IM1        (16U)         /*!< Bit position for GPT_CR_IM1. */
#define BM_GPT_CR_IM1        (0x00030000U) /*!< Bit mask for GPT_CR_IM1. */
#define BS_GPT_CR_IM1        (2U)          /*!< Bit field size in bits for GPT_CR_IM1. */

/*! @brief Read current value of the GPT_CR_IM1 field. */
#define BR_GPT_CR_IM1(x)     (HW_GPT_CR(x).B.IM1)

/*! @brief Format value for bitfield GPT_CR_IM1. */
#define BF_GPT_CR_IM1(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_IM1) & BM_GPT_CR_IM1)

/*! @brief Set the IM1 field to a new value. */
#define BW_GPT_CR_IM1(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_IM1) | BF_GPT_CR_IM1(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field IM2[19:18] (RW)
 *
 * IM2 (bits 19-18, Input Capture Channel 2 operating mode) IM1 (bits 17-16,
 * Input Capture Channel 1 operating mode) The IMn bit field determines the
 * transition on the input pin (for Input capture channel n), which will trigger a
 * capture event.
 *
 * Values:
 * - 00 - capture disabled
 * - 01 - capture on rising edge only
 * - 10 - capture on falling edge only
 * - 11 - capture on both edges
 */
/*@{*/
#define BP_GPT_CR_IM2        (18U)         /*!< Bit position for GPT_CR_IM2. */
#define BM_GPT_CR_IM2        (0x000C0000U) /*!< Bit mask for GPT_CR_IM2. */
#define BS_GPT_CR_IM2        (2U)          /*!< Bit field size in bits for GPT_CR_IM2. */

/*! @brief Read current value of the GPT_CR_IM2 field. */
#define BR_GPT_CR_IM2(x)     (HW_GPT_CR(x).B.IM2)

/*! @brief Format value for bitfield GPT_CR_IM2. */
#define BF_GPT_CR_IM2(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_IM2) & BM_GPT_CR_IM2)

/*! @brief Set the IM2 field to a new value. */
#define BW_GPT_CR_IM2(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_IM2) | BF_GPT_CR_IM2(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field OM1[22:20] (RW)
 *
 * See OM3
 */
/*@{*/
#define BP_GPT_CR_OM1        (20U)         /*!< Bit position for GPT_CR_OM1. */
#define BM_GPT_CR_OM1        (0x00700000U) /*!< Bit mask for GPT_CR_OM1. */
#define BS_GPT_CR_OM1        (3U)          /*!< Bit field size in bits for GPT_CR_OM1. */

/*! @brief Read current value of the GPT_CR_OM1 field. */
#define BR_GPT_CR_OM1(x)     (HW_GPT_CR(x).B.OM1)

/*! @brief Format value for bitfield GPT_CR_OM1. */
#define BF_GPT_CR_OM1(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_OM1) & BM_GPT_CR_OM1)

/*! @brief Set the OM1 field to a new value. */
#define BW_GPT_CR_OM1(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_OM1) | BF_GPT_CR_OM1(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field OM2[25:23] (RW)
 *
 * See OM3
 */
/*@{*/
#define BP_GPT_CR_OM2        (23U)         /*!< Bit position for GPT_CR_OM2. */
#define BM_GPT_CR_OM2        (0x03800000U) /*!< Bit mask for GPT_CR_OM2. */
#define BS_GPT_CR_OM2        (3U)          /*!< Bit field size in bits for GPT_CR_OM2. */

/*! @brief Read current value of the GPT_CR_OM2 field. */
#define BR_GPT_CR_OM2(x)     (HW_GPT_CR(x).B.OM2)

/*! @brief Format value for bitfield GPT_CR_OM2. */
#define BF_GPT_CR_OM2(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_OM2) & BM_GPT_CR_OM2)

/*! @brief Set the OM2 field to a new value. */
#define BW_GPT_CR_OM2(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_OM2) | BF_GPT_CR_OM2(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field OM3[28:26] (RW)
 *
 * OM3 (bits 28-26) controls the Output Compare Channel 3 operating mode. OM2
 * (bits 25-23) controls the Output Compare Channel 2 operating mode. OM1 (bits
 * 22-20) controls the Output Compare Channel 1 operating mode. The OMn bits specify
 * the response that a compare event will generate on the output pin of Output
 * Compare Channel n. The toggle, clear, and set options cause a change on the
 * output pin only if a compare event occurs. When OMn is programmed as 1xx (active
 * low pulse), the output pin is set to one immediately on the next input clock;
 * a low pulse (that is an input clock in width) occurs when there is a compare
 * event. Note that here, "input clock" refers to the clock selected by the CLKSRC
 * bits of the GPT Control Register.
 *
 * Values:
 * - 000 - Output disconnected. No response on pin.
 * - 001 - Toggle output pin
 * - 010 - Clear output pin
 * - 011 - Set output pin
 * - 1xx - Generate an active low pulse (that is one input clock wide) on the
 *     output pin.
 */
/*@{*/
#define BP_GPT_CR_OM3        (26U)         /*!< Bit position for GPT_CR_OM3. */
#define BM_GPT_CR_OM3        (0x1C000000U) /*!< Bit mask for GPT_CR_OM3. */
#define BS_GPT_CR_OM3        (3U)          /*!< Bit field size in bits for GPT_CR_OM3. */

/*! @brief Read current value of the GPT_CR_OM3 field. */
#define BR_GPT_CR_OM3(x)     (HW_GPT_CR(x).B.OM3)

/*! @brief Format value for bitfield GPT_CR_OM3. */
#define BF_GPT_CR_OM3(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_OM3) & BM_GPT_CR_OM3)

/*! @brief Set the OM3 field to a new value. */
#define BW_GPT_CR_OM3(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_OM3) | BF_GPT_CR_OM3(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field FO1[29] (WORZ)
 *
 * See F03
 */
/*@{*/
#define BP_GPT_CR_FO1        (29U)         /*!< Bit position for GPT_CR_FO1. */
#define BM_GPT_CR_FO1        (0x20000000U) /*!< Bit mask for GPT_CR_FO1. */
#define BS_GPT_CR_FO1        (1U)          /*!< Bit field size in bits for GPT_CR_FO1. */

/*! @brief Format value for bitfield GPT_CR_FO1. */
#define BF_GPT_CR_FO1(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_FO1) & BM_GPT_CR_FO1)

/*! @brief Set the FO1 field to a new value. */
#define BW_GPT_CR_FO1(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_FO1) | BF_GPT_CR_FO1(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field FO2[30] (WORZ)
 *
 * See F03
 */
/*@{*/
#define BP_GPT_CR_FO2        (30U)         /*!< Bit position for GPT_CR_FO2. */
#define BM_GPT_CR_FO2        (0x40000000U) /*!< Bit mask for GPT_CR_FO2. */
#define BS_GPT_CR_FO2        (1U)          /*!< Bit field size in bits for GPT_CR_FO2. */

/*! @brief Format value for bitfield GPT_CR_FO2. */
#define BF_GPT_CR_FO2(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_FO2) & BM_GPT_CR_FO2)

/*! @brief Set the FO2 field to a new value. */
#define BW_GPT_CR_FO2(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_FO2) | BF_GPT_CR_FO2(v)))
/*@}*/

/*!
 * @name Register GPT_CR, field FO3[31] (WORZ)
 *
 * FO3 Force Output Compare Channel 3 FO2 Force Output Compare Channel 2 FO1
 * Force Output Compare Channel 1 The FOn bit causes the pin action programmed for
 * the timer Output Compare n pin (according to the OMn bits in this register).
 * The OFn flag (OF3, OF2, OF1) in the status register is not affected. This bit is
 * self-negating and always read as zero.
 *
 * Values:
 * - 0 - Writing a 0 has no effect.
 * - 1 - Causes the programmed pin action on the timer Output Compare n pin; the
 *     OFn flag is not set.
 */
/*@{*/
#define BP_GPT_CR_FO3        (31U)         /*!< Bit position for GPT_CR_FO3. */
#define BM_GPT_CR_FO3        (0x80000000U) /*!< Bit mask for GPT_CR_FO3. */
#define BS_GPT_CR_FO3        (1U)          /*!< Bit field size in bits for GPT_CR_FO3. */

/*! @brief Format value for bitfield GPT_CR_FO3. */
#define BF_GPT_CR_FO3(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_CR_FO3) & BM_GPT_CR_FO3)

/*! @brief Set the FO3 field to a new value. */
#define BW_GPT_CR_FO3(x, v)  (HW_GPT_CR_WR(x, (HW_GPT_CR_RD(x) & ~BM_GPT_CR_FO3) | BF_GPT_CR_FO3(v)))
/*@}*/

/*******************************************************************************
 * HW_GPT_PR - GPT Prescaler Register
 ******************************************************************************/

/*!
 * @brief HW_GPT_PR - GPT Prescaler Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Prescaler Register (GPT_PR) contains bits that determine the divide
 * value of the clock that runs the counter.
 */
typedef union _hw_gpt_pr
{
    uint32_t U;
    struct _hw_gpt_pr_bitfields
    {
        uint32_t PRESCALER : 12;       /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_gpt_pr_t;

/*!
 * @name Constants and macros for entire GPT_PR register
 */
/*@{*/
#define HW_GPT_PR_ADDR(x)        ((uintptr_t)(x) + 0x4U)

#define HW_GPT_PR(x)             (*(__IO hw_gpt_pr_t *) HW_GPT_PR_ADDR(x))
#define HW_GPT_PR_RD(x)          (HW_GPT_PR(x).U)
#define HW_GPT_PR_WR(x, v)       (HW_GPT_PR(x).U = (v))
#define HW_GPT_PR_SET(x, v)      (HW_GPT_PR_WR(x, HW_GPT_PR_RD(x) |  (v)))
#define HW_GPT_PR_CLR(x, v)      (HW_GPT_PR_WR(x, HW_GPT_PR_RD(x) & ~(v)))
#define HW_GPT_PR_TOG(x, v)      (HW_GPT_PR_WR(x, HW_GPT_PR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_PR bitfields
 */

/*!
 * @name Register GPT_PR, field PRESCALER[11:0] (RW)
 *
 * Prescaler bits. The clock selected by the CLKSRC field is divided by
 * [PRESCALER + 1], and then used to run the counter. A change in the value of the
 * PRESCALER bits cause the Prescaler counter to reset and a new count period to start
 * immediately. See for the timing diagram.
 *
 * Values:
 * - 0 - Divide by 1
 * - 1 - Divide by 2
 * - 111111111111 - Divide by 4096
 */
/*@{*/
#define BP_GPT_PR_PRESCALER  (0U)          /*!< Bit position for GPT_PR_PRESCALER. */
#define BM_GPT_PR_PRESCALER  (0x00000FFFU) /*!< Bit mask for GPT_PR_PRESCALER. */
#define BS_GPT_PR_PRESCALER  (12U)         /*!< Bit field size in bits for GPT_PR_PRESCALER. */

/*! @brief Read current value of the GPT_PR_PRESCALER field. */
#define BR_GPT_PR_PRESCALER(x) (HW_GPT_PR(x).B.PRESCALER)

/*! @brief Format value for bitfield GPT_PR_PRESCALER. */
#define BF_GPT_PR_PRESCALER(v) ((uint32_t)((uint32_t)(v) << BP_GPT_PR_PRESCALER) & BM_GPT_PR_PRESCALER)

/*! @brief Set the PRESCALER field to a new value. */
#define BW_GPT_PR_PRESCALER(x, v) (HW_GPT_PR_WR(x, (HW_GPT_PR_RD(x) & ~BM_GPT_PR_PRESCALER) | BF_GPT_PR_PRESCALER(v)))
/*@}*/

/*******************************************************************************
 * HW_GPT_SR - GPT Status Register
 ******************************************************************************/

/*!
 * @brief HW_GPT_SR - GPT Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Status Register (GPT_SR) contains bits that indicate that a counter
 * has rolled over, and if any event has occurred on the Input Capture and Output
 * Compare channels. The bits are cleared by writing a 1 to them.
 */
typedef union _hw_gpt_sr
{
    uint32_t U;
    struct _hw_gpt_sr_bitfields
    {
        uint32_t OF1 : 1;              /*!< [0]  */
        uint32_t OF2 : 1;              /*!< [1]  */
        uint32_t OF3 : 1;              /*!< [2]  */
        uint32_t IF1 : 1;              /*!< [3]  */
        uint32_t IF2 : 1;              /*!< [4]  */
        uint32_t ROV : 1;              /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_gpt_sr_t;

/*!
 * @name Constants and macros for entire GPT_SR register
 */
/*@{*/
#define HW_GPT_SR_ADDR(x)        ((uintptr_t)(x) + 0x8U)

#define HW_GPT_SR(x)             (*(__IO hw_gpt_sr_t *) HW_GPT_SR_ADDR(x))
#define HW_GPT_SR_RD(x)          (HW_GPT_SR(x).U)
#define HW_GPT_SR_WR(x, v)       (HW_GPT_SR(x).U = (v))
#define HW_GPT_SR_SET(x, v)      (HW_GPT_SR_WR(x, HW_GPT_SR_RD(x) |  (v)))
#define HW_GPT_SR_CLR(x, v)      (HW_GPT_SR_WR(x, HW_GPT_SR_RD(x) & ~(v)))
#define HW_GPT_SR_TOG(x, v)      (HW_GPT_SR_WR(x, HW_GPT_SR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_SR bitfields
 */

/*!
 * @name Register GPT_SR, field OF1[0] (W1C)
 *
 * See OF3
 */
/*@{*/
#define BP_GPT_SR_OF1        (0U)          /*!< Bit position for GPT_SR_OF1. */
#define BM_GPT_SR_OF1        (0x00000001U) /*!< Bit mask for GPT_SR_OF1. */
#define BS_GPT_SR_OF1        (1U)          /*!< Bit field size in bits for GPT_SR_OF1. */

/*! @brief Read current value of the GPT_SR_OF1 field. */
#define BR_GPT_SR_OF1(x)     (HW_GPT_SR(x).B.OF1)

/*! @brief Format value for bitfield GPT_SR_OF1. */
#define BF_GPT_SR_OF1(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_OF1) & BM_GPT_SR_OF1)

/*! @brief Set the OF1 field to a new value. */
#define BW_GPT_SR_OF1(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_OF1 | BM_GPT_SR_OF2 | BM_GPT_SR_OF3 | BM_GPT_SR_IF1 | BM_GPT_SR_IF2 | BM_GPT_SR_ROV)) | BF_GPT_SR_OF1(v)))
/*@}*/

/*!
 * @name Register GPT_SR, field OF2[1] (W1C)
 *
 * See OF3
 */
/*@{*/
#define BP_GPT_SR_OF2        (1U)          /*!< Bit position for GPT_SR_OF2. */
#define BM_GPT_SR_OF2        (0x00000002U) /*!< Bit mask for GPT_SR_OF2. */
#define BS_GPT_SR_OF2        (1U)          /*!< Bit field size in bits for GPT_SR_OF2. */

/*! @brief Read current value of the GPT_SR_OF2 field. */
#define BR_GPT_SR_OF2(x)     (HW_GPT_SR(x).B.OF2)

/*! @brief Format value for bitfield GPT_SR_OF2. */
#define BF_GPT_SR_OF2(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_OF2) & BM_GPT_SR_OF2)

/*! @brief Set the OF2 field to a new value. */
#define BW_GPT_SR_OF2(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_OF2 | BM_GPT_SR_OF1 | BM_GPT_SR_OF3 | BM_GPT_SR_IF1 | BM_GPT_SR_IF2 | BM_GPT_SR_ROV)) | BF_GPT_SR_OF2(v)))
/*@}*/

/*!
 * @name Register GPT_SR, field OF3[2] (W1C)
 *
 * OF3 Output Compare 3 Flag OF2 Output Compare 2 Flag OF1 Output Compare 1 Flag
 * The OFn bit indicates that a compare event has occurred on Output Compare
 * channel n.
 *
 * Values:
 * - 0 - Compare event has not occurred.
 * - 1 - Compare event has occurred.
 */
/*@{*/
#define BP_GPT_SR_OF3        (2U)          /*!< Bit position for GPT_SR_OF3. */
#define BM_GPT_SR_OF3        (0x00000004U) /*!< Bit mask for GPT_SR_OF3. */
#define BS_GPT_SR_OF3        (1U)          /*!< Bit field size in bits for GPT_SR_OF3. */

/*! @brief Read current value of the GPT_SR_OF3 field. */
#define BR_GPT_SR_OF3(x)     (HW_GPT_SR(x).B.OF3)

/*! @brief Format value for bitfield GPT_SR_OF3. */
#define BF_GPT_SR_OF3(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_OF3) & BM_GPT_SR_OF3)

/*! @brief Set the OF3 field to a new value. */
#define BW_GPT_SR_OF3(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_OF3 | BM_GPT_SR_OF1 | BM_GPT_SR_OF2 | BM_GPT_SR_IF1 | BM_GPT_SR_IF2 | BM_GPT_SR_ROV)) | BF_GPT_SR_OF3(v)))
/*@}*/

/*!
 * @name Register GPT_SR, field IF1[3] (W1C)
 *
 * See IF2
 */
/*@{*/
#define BP_GPT_SR_IF1        (3U)          /*!< Bit position for GPT_SR_IF1. */
#define BM_GPT_SR_IF1        (0x00000008U) /*!< Bit mask for GPT_SR_IF1. */
#define BS_GPT_SR_IF1        (1U)          /*!< Bit field size in bits for GPT_SR_IF1. */

/*! @brief Read current value of the GPT_SR_IF1 field. */
#define BR_GPT_SR_IF1(x)     (HW_GPT_SR(x).B.IF1)

/*! @brief Format value for bitfield GPT_SR_IF1. */
#define BF_GPT_SR_IF1(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_IF1) & BM_GPT_SR_IF1)

/*! @brief Set the IF1 field to a new value. */
#define BW_GPT_SR_IF1(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_IF1 | BM_GPT_SR_OF1 | BM_GPT_SR_OF2 | BM_GPT_SR_OF3 | BM_GPT_SR_IF2 | BM_GPT_SR_ROV)) | BF_GPT_SR_IF1(v)))
/*@}*/

/*!
 * @name Register GPT_SR, field IF2[4] (W1C)
 *
 * IF2 Input capture 2 Flag IF1 Input capture 1 Flag The IFn bit indicates that
 * a capture event has occurred on Input Capture channel n.
 *
 * Values:
 * - 0 - Capture event has not occurred.
 * - 1 - Capture event has occurred.
 */
/*@{*/
#define BP_GPT_SR_IF2        (4U)          /*!< Bit position for GPT_SR_IF2. */
#define BM_GPT_SR_IF2        (0x00000010U) /*!< Bit mask for GPT_SR_IF2. */
#define BS_GPT_SR_IF2        (1U)          /*!< Bit field size in bits for GPT_SR_IF2. */

/*! @brief Read current value of the GPT_SR_IF2 field. */
#define BR_GPT_SR_IF2(x)     (HW_GPT_SR(x).B.IF2)

/*! @brief Format value for bitfield GPT_SR_IF2. */
#define BF_GPT_SR_IF2(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_IF2) & BM_GPT_SR_IF2)

/*! @brief Set the IF2 field to a new value. */
#define BW_GPT_SR_IF2(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_IF2 | BM_GPT_SR_OF1 | BM_GPT_SR_OF2 | BM_GPT_SR_OF3 | BM_GPT_SR_IF1 | BM_GPT_SR_ROV)) | BF_GPT_SR_IF2(v)))
/*@}*/

/*!
 * @name Register GPT_SR, field ROV[5] (W1C)
 *
 * Rollover Flag. The ROV bit indicates that the counter has reached its maximum
 * possible value and rolled over to 0 (from which the counter continues
 * counting). The ROV bit is only set if the counter has reached 0xFFFFFFFF in both
 * Restart and Free-Run modes.
 *
 * Values:
 * - 0 - Rollover has not occurred.
 * - 1 - Rollover has occurred.
 */
/*@{*/
#define BP_GPT_SR_ROV        (5U)          /*!< Bit position for GPT_SR_ROV. */
#define BM_GPT_SR_ROV        (0x00000020U) /*!< Bit mask for GPT_SR_ROV. */
#define BS_GPT_SR_ROV        (1U)          /*!< Bit field size in bits for GPT_SR_ROV. */

/*! @brief Read current value of the GPT_SR_ROV field. */
#define BR_GPT_SR_ROV(x)     (HW_GPT_SR(x).B.ROV)

/*! @brief Format value for bitfield GPT_SR_ROV. */
#define BF_GPT_SR_ROV(v)     ((uint32_t)((uint32_t)(v) << BP_GPT_SR_ROV) & BM_GPT_SR_ROV)

/*! @brief Set the ROV field to a new value. */
#define BW_GPT_SR_ROV(x, v)  (HW_GPT_SR_WR(x, (HW_GPT_SR_RD(x) & ~(BM_GPT_SR_ROV | BM_GPT_SR_OF1 | BM_GPT_SR_OF2 | BM_GPT_SR_OF3 | BM_GPT_SR_IF1 | BM_GPT_SR_IF2)) | BF_GPT_SR_ROV(v)))
/*@}*/

/*******************************************************************************
 * HW_GPT_IR - GPT Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_GPT_IR - GPT Interrupt Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Interrupt Register (GPT_IR) contains bits that control whether
 * interrupts are generated after rollover, input capture and output compare events.
 */
typedef union _hw_gpt_ir
{
    uint32_t U;
    struct _hw_gpt_ir_bitfields
    {
        uint32_t OF1IE : 1;            /*!< [0]  */
        uint32_t OF2IE : 1;            /*!< [1]  */
        uint32_t OF3IE : 1;            /*!< [2]  */
        uint32_t IF1IE : 1;            /*!< [3]  */
        uint32_t IF2IE : 1;            /*!< [4]  */
        uint32_t ROVIE : 1;            /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_gpt_ir_t;

/*!
 * @name Constants and macros for entire GPT_IR register
 */
/*@{*/
#define HW_GPT_IR_ADDR(x)        ((uintptr_t)(x) + 0xCU)

#define HW_GPT_IR(x)             (*(__IO hw_gpt_ir_t *) HW_GPT_IR_ADDR(x))
#define HW_GPT_IR_RD(x)          (HW_GPT_IR(x).U)
#define HW_GPT_IR_WR(x, v)       (HW_GPT_IR(x).U = (v))
#define HW_GPT_IR_SET(x, v)      (HW_GPT_IR_WR(x, HW_GPT_IR_RD(x) |  (v)))
#define HW_GPT_IR_CLR(x, v)      (HW_GPT_IR_WR(x, HW_GPT_IR_RD(x) & ~(v)))
#define HW_GPT_IR_TOG(x, v)      (HW_GPT_IR_WR(x, HW_GPT_IR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_IR bitfields
 */

/*!
 * @name Register GPT_IR, field OF1IE[0] (RW)
 *
 * See OF3IE
 */
/*@{*/
#define BP_GPT_IR_OF1IE      (0U)          /*!< Bit position for GPT_IR_OF1IE. */
#define BM_GPT_IR_OF1IE      (0x00000001U) /*!< Bit mask for GPT_IR_OF1IE. */
#define BS_GPT_IR_OF1IE      (1U)          /*!< Bit field size in bits for GPT_IR_OF1IE. */

/*! @brief Read current value of the GPT_IR_OF1IE field. */
#define BR_GPT_IR_OF1IE(x)   (HW_GPT_IR(x).B.OF1IE)

/*! @brief Format value for bitfield GPT_IR_OF1IE. */
#define BF_GPT_IR_OF1IE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_OF1IE) & BM_GPT_IR_OF1IE)

/*! @brief Set the OF1IE field to a new value. */
#define BW_GPT_IR_OF1IE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_OF1IE) | BF_GPT_IR_OF1IE(v)))
/*@}*/

/*!
 * @name Register GPT_IR, field OF2IE[1] (RW)
 *
 * See OF3IE
 */
/*@{*/
#define BP_GPT_IR_OF2IE      (1U)          /*!< Bit position for GPT_IR_OF2IE. */
#define BM_GPT_IR_OF2IE      (0x00000002U) /*!< Bit mask for GPT_IR_OF2IE. */
#define BS_GPT_IR_OF2IE      (1U)          /*!< Bit field size in bits for GPT_IR_OF2IE. */

/*! @brief Read current value of the GPT_IR_OF2IE field. */
#define BR_GPT_IR_OF2IE(x)   (HW_GPT_IR(x).B.OF2IE)

/*! @brief Format value for bitfield GPT_IR_OF2IE. */
#define BF_GPT_IR_OF2IE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_OF2IE) & BM_GPT_IR_OF2IE)

/*! @brief Set the OF2IE field to a new value. */
#define BW_GPT_IR_OF2IE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_OF2IE) | BF_GPT_IR_OF2IE(v)))
/*@}*/

/*!
 * @name Register GPT_IR, field OF3IE[2] (RW)
 *
 * OF3IE Output Compare 3 Interrupt Enable OF2IE Output Compare 2 Interrupt
 * Enable OF1IE Output Compare 1 Interrupt Enable The OFnIE bit controls the Output
 * Compare Channel n interrupt.
 *
 * Values:
 * - 0 - Output Compare Channel n interrupt is disabled.
 * - 1 - Output Compare Channel n interrupt is enabled.
 */
/*@{*/
#define BP_GPT_IR_OF3IE      (2U)          /*!< Bit position for GPT_IR_OF3IE. */
#define BM_GPT_IR_OF3IE      (0x00000004U) /*!< Bit mask for GPT_IR_OF3IE. */
#define BS_GPT_IR_OF3IE      (1U)          /*!< Bit field size in bits for GPT_IR_OF3IE. */

/*! @brief Read current value of the GPT_IR_OF3IE field. */
#define BR_GPT_IR_OF3IE(x)   (HW_GPT_IR(x).B.OF3IE)

/*! @brief Format value for bitfield GPT_IR_OF3IE. */
#define BF_GPT_IR_OF3IE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_OF3IE) & BM_GPT_IR_OF3IE)

/*! @brief Set the OF3IE field to a new value. */
#define BW_GPT_IR_OF3IE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_OF3IE) | BF_GPT_IR_OF3IE(v)))
/*@}*/

/*!
 * @name Register GPT_IR, field IF1IE[3] (RW)
 *
 * See IF2IE
 */
/*@{*/
#define BP_GPT_IR_IF1IE      (3U)          /*!< Bit position for GPT_IR_IF1IE. */
#define BM_GPT_IR_IF1IE      (0x00000008U) /*!< Bit mask for GPT_IR_IF1IE. */
#define BS_GPT_IR_IF1IE      (1U)          /*!< Bit field size in bits for GPT_IR_IF1IE. */

/*! @brief Read current value of the GPT_IR_IF1IE field. */
#define BR_GPT_IR_IF1IE(x)   (HW_GPT_IR(x).B.IF1IE)

/*! @brief Format value for bitfield GPT_IR_IF1IE. */
#define BF_GPT_IR_IF1IE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_IF1IE) & BM_GPT_IR_IF1IE)

/*! @brief Set the IF1IE field to a new value. */
#define BW_GPT_IR_IF1IE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_IF1IE) | BF_GPT_IR_IF1IE(v)))
/*@}*/

/*!
 * @name Register GPT_IR, field IF2IE[4] (RW)
 *
 * IF2IE Input capture 2 Interrupt Enable IF1IE Input capture 1 Interrupt Enable
 * The IFnIE bit controls the IFnIE Input Capture n Interrupt Enable.
 *
 * Values:
 * - 0 - IF2IE Input Capture n Interrupt Enable is disabled.
 * - 1 - IF2IE Input Capture n Interrupt Enable is enabled.
 */
/*@{*/
#define BP_GPT_IR_IF2IE      (4U)          /*!< Bit position for GPT_IR_IF2IE. */
#define BM_GPT_IR_IF2IE      (0x00000010U) /*!< Bit mask for GPT_IR_IF2IE. */
#define BS_GPT_IR_IF2IE      (1U)          /*!< Bit field size in bits for GPT_IR_IF2IE. */

/*! @brief Read current value of the GPT_IR_IF2IE field. */
#define BR_GPT_IR_IF2IE(x)   (HW_GPT_IR(x).B.IF2IE)

/*! @brief Format value for bitfield GPT_IR_IF2IE. */
#define BF_GPT_IR_IF2IE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_IF2IE) & BM_GPT_IR_IF2IE)

/*! @brief Set the IF2IE field to a new value. */
#define BW_GPT_IR_IF2IE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_IF2IE) | BF_GPT_IR_IF2IE(v)))
/*@}*/

/*!
 * @name Register GPT_IR, field ROVIE[5] (RW)
 *
 * Rollover Interrupt Enable. The ROVIE bit controls the Rollover interrupt.
 *
 * Values:
 * - 0 - Rollover interrupt is disabled.
 * - 1 - Rollover interrupt enabled.
 */
/*@{*/
#define BP_GPT_IR_ROVIE      (5U)          /*!< Bit position for GPT_IR_ROVIE. */
#define BM_GPT_IR_ROVIE      (0x00000020U) /*!< Bit mask for GPT_IR_ROVIE. */
#define BS_GPT_IR_ROVIE      (1U)          /*!< Bit field size in bits for GPT_IR_ROVIE. */

/*! @brief Read current value of the GPT_IR_ROVIE field. */
#define BR_GPT_IR_ROVIE(x)   (HW_GPT_IR(x).B.ROVIE)

/*! @brief Format value for bitfield GPT_IR_ROVIE. */
#define BF_GPT_IR_ROVIE(v)   ((uint32_t)((uint32_t)(v) << BP_GPT_IR_ROVIE) & BM_GPT_IR_ROVIE)

/*! @brief Set the ROVIE field to a new value. */
#define BW_GPT_IR_ROVIE(x, v) (HW_GPT_IR_WR(x, (HW_GPT_IR_RD(x) & ~BM_GPT_IR_ROVIE) | BF_GPT_IR_ROVIE(v)))
/*@}*/

/*******************************************************************************
 * HW_GPT_OCR1 - GPT Output Compare Register 1
 ******************************************************************************/

/*!
 * @brief HW_GPT_OCR1 - GPT Output Compare Register 1 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The GPT Compare Register 1 (GPT_OCR1) holds the value that determines when a
 * compare event will be generated on Output Compare Channel 1. Any write access
 * to the Compare register of Channel 1 while in Restart mode (FRR=0) will reset
 * the GPT counter. An IP Bus Write access to the GPT Output Compare Register1
 * (GPT_OCR1) occurs after one cycle of wait state; an IP Bus Read access occurs
 * immediately (0 wait states).
 */
typedef union _hw_gpt_ocr1
{
    uint32_t U;
    struct _hw_gpt_ocr1_bitfields
    {
        uint32_t COMP : 32;            /*!< [31:0]  */
    } B;
} hw_gpt_ocr1_t;

/*!
 * @name Constants and macros for entire GPT_OCR1 register
 */
/*@{*/
#define HW_GPT_OCR1_ADDR(x)      ((uintptr_t)(x) + 0x10U)

#define HW_GPT_OCR1(x)           (*(__IO hw_gpt_ocr1_t *) HW_GPT_OCR1_ADDR(x))
#define HW_GPT_OCR1_RD(x)        (HW_GPT_OCR1(x).U)
#define HW_GPT_OCR1_WR(x, v)     (HW_GPT_OCR1(x).U = (v))
#define HW_GPT_OCR1_SET(x, v)    (HW_GPT_OCR1_WR(x, HW_GPT_OCR1_RD(x) |  (v)))
#define HW_GPT_OCR1_CLR(x, v)    (HW_GPT_OCR1_WR(x, HW_GPT_OCR1_RD(x) & ~(v)))
#define HW_GPT_OCR1_TOG(x, v)    (HW_GPT_OCR1_WR(x, HW_GPT_OCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_OCR1 bitfields
 */

/*!
 * @name Register GPT_OCR1, field COMP[31:0] (RW)
 *
 * Compare Value. When the counter value equals the COMP bit field value, a
 * compare event is generated on Output Compare Channel 1.
 */
/*@{*/
#define BP_GPT_OCR1_COMP     (0U)          /*!< Bit position for GPT_OCR1_COMP. */
#define BM_GPT_OCR1_COMP     (0xFFFFFFFFU) /*!< Bit mask for GPT_OCR1_COMP. */
#define BS_GPT_OCR1_COMP     (32U)         /*!< Bit field size in bits for GPT_OCR1_COMP. */

/*! @brief Read current value of the GPT_OCR1_COMP field. */
#define BR_GPT_OCR1_COMP(x)  (HW_GPT_OCR1(x).U)

/*! @brief Format value for bitfield GPT_OCR1_COMP. */
#define BF_GPT_OCR1_COMP(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_OCR1_COMP) & BM_GPT_OCR1_COMP)

/*! @brief Set the COMP field to a new value. */
#define BW_GPT_OCR1_COMP(x, v) (HW_GPT_OCR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPT_OCR2 - GPT Output Compare Register 2
 ******************************************************************************/

/*!
 * @brief HW_GPT_OCR2 - GPT Output Compare Register 2 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The GPT Compare Register 2 (GPT_OCR2) holds the value that determines when a
 * compare event will be generated on Output Compare Channel 2.
 */
typedef union _hw_gpt_ocr2
{
    uint32_t U;
    struct _hw_gpt_ocr2_bitfields
    {
        uint32_t COMP : 32;            /*!< [31:0]  */
    } B;
} hw_gpt_ocr2_t;

/*!
 * @name Constants and macros for entire GPT_OCR2 register
 */
/*@{*/
#define HW_GPT_OCR2_ADDR(x)      ((uintptr_t)(x) + 0x14U)

#define HW_GPT_OCR2(x)           (*(__IO hw_gpt_ocr2_t *) HW_GPT_OCR2_ADDR(x))
#define HW_GPT_OCR2_RD(x)        (HW_GPT_OCR2(x).U)
#define HW_GPT_OCR2_WR(x, v)     (HW_GPT_OCR2(x).U = (v))
#define HW_GPT_OCR2_SET(x, v)    (HW_GPT_OCR2_WR(x, HW_GPT_OCR2_RD(x) |  (v)))
#define HW_GPT_OCR2_CLR(x, v)    (HW_GPT_OCR2_WR(x, HW_GPT_OCR2_RD(x) & ~(v)))
#define HW_GPT_OCR2_TOG(x, v)    (HW_GPT_OCR2_WR(x, HW_GPT_OCR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_OCR2 bitfields
 */

/*!
 * @name Register GPT_OCR2, field COMP[31:0] (RW)
 *
 * Compare Value. When the counter value equals the COMP bit field value, a
 * compare event is generated on Output Compare Channel 2.
 */
/*@{*/
#define BP_GPT_OCR2_COMP     (0U)          /*!< Bit position for GPT_OCR2_COMP. */
#define BM_GPT_OCR2_COMP     (0xFFFFFFFFU) /*!< Bit mask for GPT_OCR2_COMP. */
#define BS_GPT_OCR2_COMP     (32U)         /*!< Bit field size in bits for GPT_OCR2_COMP. */

/*! @brief Read current value of the GPT_OCR2_COMP field. */
#define BR_GPT_OCR2_COMP(x)  (HW_GPT_OCR2(x).U)

/*! @brief Format value for bitfield GPT_OCR2_COMP. */
#define BF_GPT_OCR2_COMP(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_OCR2_COMP) & BM_GPT_OCR2_COMP)

/*! @brief Set the COMP field to a new value. */
#define BW_GPT_OCR2_COMP(x, v) (HW_GPT_OCR2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPT_OCR3 - GPT Output Compare Register 3
 ******************************************************************************/

/*!
 * @brief HW_GPT_OCR3 - GPT Output Compare Register 3 (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * The GPT Compare Register 3 (GPT_OCR3) holds the value that determines when a
 * compare event will be generated on Output Compare Channel 3.
 */
typedef union _hw_gpt_ocr3
{
    uint32_t U;
    struct _hw_gpt_ocr3_bitfields
    {
        uint32_t COMP : 32;            /*!< [31:0]  */
    } B;
} hw_gpt_ocr3_t;

/*!
 * @name Constants and macros for entire GPT_OCR3 register
 */
/*@{*/
#define HW_GPT_OCR3_ADDR(x)      ((uintptr_t)(x) + 0x18U)

#define HW_GPT_OCR3(x)           (*(__IO hw_gpt_ocr3_t *) HW_GPT_OCR3_ADDR(x))
#define HW_GPT_OCR3_RD(x)        (HW_GPT_OCR3(x).U)
#define HW_GPT_OCR3_WR(x, v)     (HW_GPT_OCR3(x).U = (v))
#define HW_GPT_OCR3_SET(x, v)    (HW_GPT_OCR3_WR(x, HW_GPT_OCR3_RD(x) |  (v)))
#define HW_GPT_OCR3_CLR(x, v)    (HW_GPT_OCR3_WR(x, HW_GPT_OCR3_RD(x) & ~(v)))
#define HW_GPT_OCR3_TOG(x, v)    (HW_GPT_OCR3_WR(x, HW_GPT_OCR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPT_OCR3 bitfields
 */

/*!
 * @name Register GPT_OCR3, field COMP[31:0] (RW)
 *
 * Compare Value. When the counter value equals the COMP bit field value, a
 * compare event is generated on Output Compare Channel 3.
 */
/*@{*/
#define BP_GPT_OCR3_COMP     (0U)          /*!< Bit position for GPT_OCR3_COMP. */
#define BM_GPT_OCR3_COMP     (0xFFFFFFFFU) /*!< Bit mask for GPT_OCR3_COMP. */
#define BS_GPT_OCR3_COMP     (32U)         /*!< Bit field size in bits for GPT_OCR3_COMP. */

/*! @brief Read current value of the GPT_OCR3_COMP field. */
#define BR_GPT_OCR3_COMP(x)  (HW_GPT_OCR3(x).U)

/*! @brief Format value for bitfield GPT_OCR3_COMP. */
#define BF_GPT_OCR3_COMP(v)  ((uint32_t)((uint32_t)(v) << BP_GPT_OCR3_COMP) & BM_GPT_OCR3_COMP)

/*! @brief Set the COMP field to a new value. */
#define BW_GPT_OCR3_COMP(x, v) (HW_GPT_OCR3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPT_ICR1 - GPT Input Capture Register 1
 ******************************************************************************/

/*!
 * @brief HW_GPT_ICR1 - GPT Input Capture Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Input Capture Register 1 (GPT_ICR1) is a read-only register that
 * holds the value that was in the counter during the last capture event on Input
 * Capture Channel 1.
 */
typedef union _hw_gpt_icr1
{
    uint32_t U;
    struct _hw_gpt_icr1_bitfields
    {
        uint32_t CAPT : 32;            /*!< [31:0]  */
    } B;
} hw_gpt_icr1_t;

/*!
 * @name Constants and macros for entire GPT_ICR1 register
 */
/*@{*/
#define HW_GPT_ICR1_ADDR(x)      ((uintptr_t)(x) + 0x1CU)

#define HW_GPT_ICR1(x)           (*(__I hw_gpt_icr1_t *) HW_GPT_ICR1_ADDR(x))
#define HW_GPT_ICR1_RD(x)        (HW_GPT_ICR1(x).U)
/*@}*/

/*
 * Constants & macros for individual GPT_ICR1 bitfields
 */

/*!
 * @name Register GPT_ICR1, field CAPT[31:0] (RO)
 *
 * Capture Value. After a capture event on Input Capture Channel 1 occurs, the
 * current value of the counter is loaded into GPT Input Capture Register 1.
 */
/*@{*/
#define BP_GPT_ICR1_CAPT     (0U)          /*!< Bit position for GPT_ICR1_CAPT. */
#define BM_GPT_ICR1_CAPT     (0xFFFFFFFFU) /*!< Bit mask for GPT_ICR1_CAPT. */
#define BS_GPT_ICR1_CAPT     (32U)         /*!< Bit field size in bits for GPT_ICR1_CAPT. */

/*! @brief Read current value of the GPT_ICR1_CAPT field. */
#define BR_GPT_ICR1_CAPT(x)  (HW_GPT_ICR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPT_ICR2 - GPT Input Capture Register 2
 ******************************************************************************/

/*!
 * @brief HW_GPT_ICR2 - GPT Input Capture Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Input capture Register 2 (GPT_ICR2) is a read-only register which
 * holds the value that was in the counter during the last capture event on input
 * capture channel 2.
 */
typedef union _hw_gpt_icr2
{
    uint32_t U;
    struct _hw_gpt_icr2_bitfields
    {
        uint32_t CAPT : 32;            /*!< [31:0]  */
    } B;
} hw_gpt_icr2_t;

/*!
 * @name Constants and macros for entire GPT_ICR2 register
 */
/*@{*/
#define HW_GPT_ICR2_ADDR(x)      ((uintptr_t)(x) + 0x20U)

#define HW_GPT_ICR2(x)           (*(__I hw_gpt_icr2_t *) HW_GPT_ICR2_ADDR(x))
#define HW_GPT_ICR2_RD(x)        (HW_GPT_ICR2(x).U)
/*@}*/

/*
 * Constants & macros for individual GPT_ICR2 bitfields
 */

/*!
 * @name Register GPT_ICR2, field CAPT[31:0] (RO)
 *
 * Capture Value. After a capture event on Input Capture Channel 2 occurs, the
 * current value of the counter is loaded into GPT Input Capture Register 2.
 */
/*@{*/
#define BP_GPT_ICR2_CAPT     (0U)          /*!< Bit position for GPT_ICR2_CAPT. */
#define BM_GPT_ICR2_CAPT     (0xFFFFFFFFU) /*!< Bit mask for GPT_ICR2_CAPT. */
#define BS_GPT_ICR2_CAPT     (32U)         /*!< Bit field size in bits for GPT_ICR2_CAPT. */

/*! @brief Read current value of the GPT_ICR2_CAPT field. */
#define BR_GPT_ICR2_CAPT(x)  (HW_GPT_ICR2(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPT_CNT - GPT Counter Register
 ******************************************************************************/

/*!
 * @brief HW_GPT_CNT - GPT Counter Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The GPT Counter Register (GPT_CNT) is the main counter's register. GPT_CNT is
 * a read-only register and can be read without affecting the counting process
 * of the GPT.
 */
typedef union _hw_gpt_cnt
{
    uint32_t U;
    struct _hw_gpt_cnt_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpt_cnt_t;

/*!
 * @name Constants and macros for entire GPT_CNT register
 */
/*@{*/
#define HW_GPT_CNT_ADDR(x)       ((uintptr_t)(x) + 0x24U)

#define HW_GPT_CNT(x)            (*(__I hw_gpt_cnt_t *) HW_GPT_CNT_ADDR(x))
#define HW_GPT_CNT_RD(x)         (HW_GPT_CNT(x).U)
/*@}*/

/*
 * Constants & macros for individual GPT_CNT bitfields
 */

/*!
 * @name Register GPT_CNT, field COUNT[31:0] (RO)
 *
 * Counter Value. The COUNT bits show the current count value of the GPT counter.
 */
/*@{*/
#define BP_GPT_CNT_COUNT     (0U)          /*!< Bit position for GPT_CNT_COUNT. */
#define BM_GPT_CNT_COUNT     (0xFFFFFFFFU) /*!< Bit mask for GPT_CNT_COUNT. */
#define BS_GPT_CNT_COUNT     (32U)         /*!< Bit field size in bits for GPT_CNT_COUNT. */

/*! @brief Read current value of the GPT_CNT_COUNT field. */
#define BR_GPT_CNT_COUNT(x)  (HW_GPT_CNT(x).U)
/*@}*/

/*******************************************************************************
 * hw_gpt_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPT module registers.
 */
#pragma pack(1)
typedef struct _hw_gpt
{
    __IO hw_gpt_cr_t CR;                   /*!< [0x0] GPT Control Register */
    __IO hw_gpt_pr_t PR;                   /*!< [0x4] GPT Prescaler Register */
    __IO hw_gpt_sr_t SR;                   /*!< [0x8] GPT Status Register */
    __IO hw_gpt_ir_t IR;                   /*!< [0xC] GPT Interrupt Register */
    __IO hw_gpt_ocr1_t OCR1;               /*!< [0x10] GPT Output Compare Register 1 */
    __IO hw_gpt_ocr2_t OCR2;               /*!< [0x14] GPT Output Compare Register 2 */
    __IO hw_gpt_ocr3_t OCR3;               /*!< [0x18] GPT Output Compare Register 3 */
    __I hw_gpt_icr1_t ICR1;                /*!< [0x1C] GPT Input Capture Register 1 */
    __I hw_gpt_icr2_t ICR2;                /*!< [0x20] GPT Input Capture Register 2 */
    __I hw_gpt_cnt_t CNT;                  /*!< [0x24] GPT Counter Register */
} hw_gpt_t;
#pragma pack()

/*! @brief Macro to access all GPT registers. */
/*! @param x GPT module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPT_REGS(GPT_BASE)</code>. */
#define HW_GPT_REGS(x) (*(hw_gpt_t *)(x))

/*
 * iMX6DP GPU2D
 *
 * GPU2D
 *
 * Registers defined in this header file:
 * - HW_GPU2D_AQHiClockControl - Clock Control Register
 * - HW_GPU2D_AQHiIdle - Idle Status Register
 * - HW_GPU2D_AQAxiConfig - AXI Configuration Register
 * - HW_GPU2D_AQAxiStatus - AXI Status Register
 * - HW_GPU2D_AQIntrAcknowledge - Interrupt Acknowledge Register
 * - HW_GPU2D_AQIntrEnbl - Interrupt Enable Register
 * - HW_GPU2D_AQIdent - Identification Register
 * - HW_GPU2D_Features - Features Register
 * - HW_GPU2D_ChipId - Chip Identification Register
 * - HW_GPU2D_ChipRev - Chip Revision Register
 * - HW_GPU2D_ChipDate - Chip Release Date Register
 * - HW_GPU2D_ChipTime - Chip Release Time Register
 * - HW_GPU2D_ChipCustomer - Chip Customer Register
 * - HW_GPU2D_MinorFeatures0 - Minor Features Register 0
 * - HW_GPU2D_CacheControl - Cache Control Register
 * - HW_GPU2D_ResetMemCounters - Reset Mem Counters Register
 * - HW_GPU2D_TotalReads - Read Count Register
 * - HW_GPU2D_TotalWrites - Write Count Register
 * - HW_GPU2D_ChipSpecs - Chip Specification Register
 * - HW_GPU2D_TotalWriteBursts - Write Data Count Register
 * - HW_GPU2D_TotalWriteReqs - Write REQ Count Register
 * - HW_GPU2D_TotalWriteLasts - Total WLAST Count Register
 * - HW_GPU2D_TotalReadBursts - Total Read Data Count Register
 * - HW_GPU2D_TotalReadReqs - Total Read REQ Count Register
 * - HW_GPU2D_TotalReadLasts - Total RLAST Count Register
 * - HW_GPU2D_GpOut0 - General Purpose Register 0
 * - HW_GPU2D_GpOut1 - General Purpose Register 1
 * - HW_GPU2D_GpOut2 - General Purpose Register 2
 * - HW_GPU2D_AxiControl - AXI Control Register
 * - HW_GPU2D_MinorFeatures1 - Minor Features Register 1
 * - HW_GPU2D_TotalCycles - Total Cycle Counter Register
 * - HW_GPU2D_TotalIdleCyles - Total Idle Cycle Register
 * - HW_GPU2D_ChipSpecs2 - Chip Specification Register
 * - HW_GPU2D_ModulePowerControls - Power Control Register
 * - HW_GPU2D_ModulePowerModuleControl - Power Level Register
 * - HW_GPU2D_ModulePowerModuleStatus - Power Status Register
 *
 * - hw_gpu2d_t - Struct containing all module registers.
 */

#define HW_GPU2D_INSTANCE_COUNT (1U) /*!< Number of instances of the GPU2D module. */
#define HW_GPU2D (0U) /*!< Instance number for GPU2D. */
#define GPU2D_BASE            (0x134000U) /*!< Base address for GPU2D. */
/*! Array initializer of GPU2D base addresses. */
#define GPU2D_BASE_ADDRS      { GPU2D_BASE }

/*******************************************************************************
 * HW_GPU2D_AQHiClockControl - Clock Control Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQHiClockControl - Clock Control Register (RW)
 *
 * Reset value: 0x00000100U
 */
typedef union _hw_gpu2d_aqhiclockcontrol
{
    uint32_t U;
    struct _hw_gpu2d_aqhiclockcontrol_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t MULTI_PIPE_USE_SINGLE_AXI : 4; /*!< [7:4]  */
        uint32_t MULTI_PIPE_REG_SELECT : 4; /*!< [11:8]  */
        uint32_t ISOLATE_GPU : 1;      /*!< [12]  */
        uint32_t IDLE_VG : 1;          /*!< [13]  */
        uint32_t IDLE2_D : 1;          /*!< [14]  */
        uint32_t IDLE3_D : 1;          /*!< [15]  */
        uint32_t RESERVED1 : 3;        /*!< [18:16]  */
        uint32_t SOFT_RESET : 1;       /*!< [19]  */
        uint32_t DISABLE_DEBUG_REGISTERS : 1; /*!< [20]  */
        uint32_t DISABLE_RAM_CLOCK_GATING : 1; /*!< [21]  */
        uint32_t FSCALE_CMD_LOAD : 1;  /*!< [22]  */
        uint32_t FSCALE_VAL : 7;       /*!< [29:23]  */
        uint32_t CLK2D_DIS : 1;        /*!< [30]  */
        uint32_t CLK3D_DIS : 1;        /*!< [31]  */
    } B;
} hw_gpu2d_aqhiclockcontrol_t;

/*!
 * @name Constants and macros for entire GPU2D_AQHiClockControl register
 */
/*@{*/
#define HW_GPU2D_AQHiClockControl_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_GPU2D_AQHiClockControl(x) (*(__IO hw_gpu2d_aqhiclockcontrol_t *) HW_GPU2D_AQHiClockControl_ADDR(x))
#define HW_GPU2D_AQHiClockControl_RD(x) (HW_GPU2D_AQHiClockControl(x).U)
#define HW_GPU2D_AQHiClockControl_WR(x, v) (HW_GPU2D_AQHiClockControl(x).U = (v))
#define HW_GPU2D_AQHiClockControl_SET(x, v) (HW_GPU2D_AQHiClockControl_WR(x, HW_GPU2D_AQHiClockControl_RD(x) |  (v)))
#define HW_GPU2D_AQHiClockControl_CLR(x, v) (HW_GPU2D_AQHiClockControl_WR(x, HW_GPU2D_AQHiClockControl_RD(x) & ~(v)))
#define HW_GPU2D_AQHiClockControl_TOG(x, v) (HW_GPU2D_AQHiClockControl_WR(x, HW_GPU2D_AQHiClockControl_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQHiClockControl bitfields
 */

/*!
 * @name Register GPU2D_AQHiClockControl, field MULTI_PIPE_USE_SINGLE_AXI[7:4] (RW)
 *
 * Force all the transactions to go to one AXI.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI (4U) /*!< Bit position for GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI. */
#define BM_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI (0x000000F0U) /*!< Bit mask for GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI. */
#define BS_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI (4U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI field. */
#define BR_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI(x) (HW_GPU2D_AQHiClockControl(x).B.MULTI_PIPE_USE_SINGLE_AXI)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI. */
#define BF_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI) & BM_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI)

/*! @brief Set the MULTI_PIPE_USE_SINGLE_AXI field to a new value. */
#define BW_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI) | BF_GPU2D_AQHiClockControl_MULTI_PIPE_USE_SINGLE_AXI(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field MULTI_PIPE_REG_SELECT[11:8] (RW)
 *
 * Determines which HI/MC to use while reading registers.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT (8U) /*!< Bit position for GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT. */
#define BM_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT (0x00000F00U) /*!< Bit mask for GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT. */
#define BS_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT (4U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT field. */
#define BR_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT(x) (HW_GPU2D_AQHiClockControl(x).B.MULTI_PIPE_REG_SELECT)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT. */
#define BF_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT) & BM_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT)

/*! @brief Set the MULTI_PIPE_REG_SELECT field to a new value. */
#define BW_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT) | BF_GPU2D_AQHiClockControl_MULTI_PIPE_REG_SELECT(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field ISOLATE_GPU[12] (RW)
 *
 * Isolate GPU bit
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_ISOLATE_GPU (12U) /*!< Bit position for GPU2D_AQHiClockControl_ISOLATE_GPU. */
#define BM_GPU2D_AQHiClockControl_ISOLATE_GPU (0x00001000U) /*!< Bit mask for GPU2D_AQHiClockControl_ISOLATE_GPU. */
#define BS_GPU2D_AQHiClockControl_ISOLATE_GPU (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_ISOLATE_GPU. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_ISOLATE_GPU field. */
#define BR_GPU2D_AQHiClockControl_ISOLATE_GPU(x) (HW_GPU2D_AQHiClockControl(x).B.ISOLATE_GPU)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_ISOLATE_GPU. */
#define BF_GPU2D_AQHiClockControl_ISOLATE_GPU(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_ISOLATE_GPU) & BM_GPU2D_AQHiClockControl_ISOLATE_GPU)

/*! @brief Set the ISOLATE_GPU field to a new value. */
#define BW_GPU2D_AQHiClockControl_ISOLATE_GPU(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_ISOLATE_GPU) | BF_GPU2D_AQHiClockControl_ISOLATE_GPU(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field IDLE_VG[13] (RW)
 *
 * VG pipe is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_IDLE_VG (13U) /*!< Bit position for GPU2D_AQHiClockControl_IDLE_VG. */
#define BM_GPU2D_AQHiClockControl_IDLE_VG (0x00002000U) /*!< Bit mask for GPU2D_AQHiClockControl_IDLE_VG. */
#define BS_GPU2D_AQHiClockControl_IDLE_VG (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_IDLE_VG. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_IDLE_VG field. */
#define BR_GPU2D_AQHiClockControl_IDLE_VG(x) (HW_GPU2D_AQHiClockControl(x).B.IDLE_VG)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_IDLE_VG. */
#define BF_GPU2D_AQHiClockControl_IDLE_VG(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_IDLE_VG) & BM_GPU2D_AQHiClockControl_IDLE_VG)

/*! @brief Set the IDLE_VG field to a new value. */
#define BW_GPU2D_AQHiClockControl_IDLE_VG(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_IDLE_VG) | BF_GPU2D_AQHiClockControl_IDLE_VG(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field IDLE2_D[14] (RW)
 *
 * 2D pipe is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_IDLE2_D (14U) /*!< Bit position for GPU2D_AQHiClockControl_IDLE2_D. */
#define BM_GPU2D_AQHiClockControl_IDLE2_D (0x00004000U) /*!< Bit mask for GPU2D_AQHiClockControl_IDLE2_D. */
#define BS_GPU2D_AQHiClockControl_IDLE2_D (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_IDLE2_D. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_IDLE2_D field. */
#define BR_GPU2D_AQHiClockControl_IDLE2_D(x) (HW_GPU2D_AQHiClockControl(x).B.IDLE2_D)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_IDLE2_D. */
#define BF_GPU2D_AQHiClockControl_IDLE2_D(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_IDLE2_D) & BM_GPU2D_AQHiClockControl_IDLE2_D)

/*! @brief Set the IDLE2_D field to a new value. */
#define BW_GPU2D_AQHiClockControl_IDLE2_D(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_IDLE2_D) | BF_GPU2D_AQHiClockControl_IDLE2_D(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field IDLE3_D[15] (RW)
 *
 * 3D pipe is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_IDLE3_D (15U) /*!< Bit position for GPU2D_AQHiClockControl_IDLE3_D. */
#define BM_GPU2D_AQHiClockControl_IDLE3_D (0x00008000U) /*!< Bit mask for GPU2D_AQHiClockControl_IDLE3_D. */
#define BS_GPU2D_AQHiClockControl_IDLE3_D (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_IDLE3_D. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_IDLE3_D field. */
#define BR_GPU2D_AQHiClockControl_IDLE3_D(x) (HW_GPU2D_AQHiClockControl(x).B.IDLE3_D)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_IDLE3_D. */
#define BF_GPU2D_AQHiClockControl_IDLE3_D(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_IDLE3_D) & BM_GPU2D_AQHiClockControl_IDLE3_D)

/*! @brief Set the IDLE3_D field to a new value. */
#define BW_GPU2D_AQHiClockControl_IDLE3_D(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_IDLE3_D) | BF_GPU2D_AQHiClockControl_IDLE3_D(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field SOFT_RESET[19] (RW)
 *
 * Soft resets the IP.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_SOFT_RESET (19U) /*!< Bit position for GPU2D_AQHiClockControl_SOFT_RESET. */
#define BM_GPU2D_AQHiClockControl_SOFT_RESET (0x00080000U) /*!< Bit mask for GPU2D_AQHiClockControl_SOFT_RESET. */
#define BS_GPU2D_AQHiClockControl_SOFT_RESET (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_SOFT_RESET. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_SOFT_RESET field. */
#define BR_GPU2D_AQHiClockControl_SOFT_RESET(x) (HW_GPU2D_AQHiClockControl(x).B.SOFT_RESET)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_SOFT_RESET. */
#define BF_GPU2D_AQHiClockControl_SOFT_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_SOFT_RESET) & BM_GPU2D_AQHiClockControl_SOFT_RESET)

/*! @brief Set the SOFT_RESET field to a new value. */
#define BW_GPU2D_AQHiClockControl_SOFT_RESET(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_SOFT_RESET) | BF_GPU2D_AQHiClockControl_SOFT_RESET(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field DISABLE_DEBUG_REGISTERS[20] (RW)
 *
 * Disable debug registers. If this bit is 1, debug registers are clock gated.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS (20U) /*!< Bit position for GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS. */
#define BM_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS (0x00100000U) /*!< Bit mask for GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS. */
#define BS_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS field. */
#define BR_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS(x) (HW_GPU2D_AQHiClockControl(x).B.DISABLE_DEBUG_REGISTERS)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS. */
#define BF_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS) & BM_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS)

/*! @brief Set the DISABLE_DEBUG_REGISTERS field to a new value. */
#define BW_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS) | BF_GPU2D_AQHiClockControl_DISABLE_DEBUG_REGISTERS(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field DISABLE_RAM_CLOCK_GATING[21] (RW)
 *
 * Disables clock gating for rams.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING (21U) /*!< Bit position for GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING. */
#define BM_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING (0x00200000U) /*!< Bit mask for GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING. */
#define BS_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING field. */
#define BR_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING(x) (HW_GPU2D_AQHiClockControl(x).B.DISABLE_RAM_CLOCK_GATING)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING. */
#define BF_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING) & BM_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING)

/*! @brief Set the DISABLE_RAM_CLOCK_GATING field to a new value. */
#define BW_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING) | BF_GPU2D_AQHiClockControl_DISABLE_RAM_CLOCK_GATING(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field FSCALE_CMD_LOAD[22] (RW)
 *
 * FSCALE Command Load bit
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD (22U) /*!< Bit position for GPU2D_AQHiClockControl_FSCALE_CMD_LOAD. */
#define BM_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD (0x00400000U) /*!< Bit mask for GPU2D_AQHiClockControl_FSCALE_CMD_LOAD. */
#define BS_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_FSCALE_CMD_LOAD. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_FSCALE_CMD_LOAD field. */
#define BR_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD(x) (HW_GPU2D_AQHiClockControl(x).B.FSCALE_CMD_LOAD)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_FSCALE_CMD_LOAD. */
#define BF_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD) & BM_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD)

/*! @brief Set the FSCALE_CMD_LOAD field to a new value. */
#define BW_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD) | BF_GPU2D_AQHiClockControl_FSCALE_CMD_LOAD(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field FSCALE_VAL[29:23] (RW)
 *
 * FSCALE Val
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_FSCALE_VAL (23U) /*!< Bit position for GPU2D_AQHiClockControl_FSCALE_VAL. */
#define BM_GPU2D_AQHiClockControl_FSCALE_VAL (0x3F800000U) /*!< Bit mask for GPU2D_AQHiClockControl_FSCALE_VAL. */
#define BS_GPU2D_AQHiClockControl_FSCALE_VAL (7U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_FSCALE_VAL. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_FSCALE_VAL field. */
#define BR_GPU2D_AQHiClockControl_FSCALE_VAL(x) (HW_GPU2D_AQHiClockControl(x).B.FSCALE_VAL)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_FSCALE_VAL. */
#define BF_GPU2D_AQHiClockControl_FSCALE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_FSCALE_VAL) & BM_GPU2D_AQHiClockControl_FSCALE_VAL)

/*! @brief Set the FSCALE_VAL field to a new value. */
#define BW_GPU2D_AQHiClockControl_FSCALE_VAL(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_FSCALE_VAL) | BF_GPU2D_AQHiClockControl_FSCALE_VAL(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field CLK2D_DIS[30] (RW)
 *
 * Disable 2D clock.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_CLK2D_DIS (30U) /*!< Bit position for GPU2D_AQHiClockControl_CLK2D_DIS. */
#define BM_GPU2D_AQHiClockControl_CLK2D_DIS (0x40000000U) /*!< Bit mask for GPU2D_AQHiClockControl_CLK2D_DIS. */
#define BS_GPU2D_AQHiClockControl_CLK2D_DIS (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_CLK2D_DIS. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_CLK2D_DIS field. */
#define BR_GPU2D_AQHiClockControl_CLK2D_DIS(x) (HW_GPU2D_AQHiClockControl(x).B.CLK2D_DIS)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_CLK2D_DIS. */
#define BF_GPU2D_AQHiClockControl_CLK2D_DIS(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_CLK2D_DIS) & BM_GPU2D_AQHiClockControl_CLK2D_DIS)

/*! @brief Set the CLK2D_DIS field to a new value. */
#define BW_GPU2D_AQHiClockControl_CLK2D_DIS(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_CLK2D_DIS) | BF_GPU2D_AQHiClockControl_CLK2D_DIS(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQHiClockControl, field CLK3D_DIS[31] (RW)
 *
 * Disable 3D clock.
 */
/*@{*/
#define BP_GPU2D_AQHiClockControl_CLK3D_DIS (31U) /*!< Bit position for GPU2D_AQHiClockControl_CLK3D_DIS. */
#define BM_GPU2D_AQHiClockControl_CLK3D_DIS (0x80000000U) /*!< Bit mask for GPU2D_AQHiClockControl_CLK3D_DIS. */
#define BS_GPU2D_AQHiClockControl_CLK3D_DIS (1U) /*!< Bit field size in bits for GPU2D_AQHiClockControl_CLK3D_DIS. */

/*! @brief Read current value of the GPU2D_AQHiClockControl_CLK3D_DIS field. */
#define BR_GPU2D_AQHiClockControl_CLK3D_DIS(x) (HW_GPU2D_AQHiClockControl(x).B.CLK3D_DIS)

/*! @brief Format value for bitfield GPU2D_AQHiClockControl_CLK3D_DIS. */
#define BF_GPU2D_AQHiClockControl_CLK3D_DIS(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQHiClockControl_CLK3D_DIS) & BM_GPU2D_AQHiClockControl_CLK3D_DIS)

/*! @brief Set the CLK3D_DIS field to a new value. */
#define BW_GPU2D_AQHiClockControl_CLK3D_DIS(x, v) (HW_GPU2D_AQHiClockControl_WR(x, (HW_GPU2D_AQHiClockControl_RD(x) & ~BM_GPU2D_AQHiClockControl_CLK3D_DIS) | BF_GPU2D_AQHiClockControl_CLK3D_DIS(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQHiIdle - Idle Status Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQHiIdle - Idle Status Register (RO)
 *
 * Reset value: 0x7FFFFFFFU
 */
typedef union _hw_gpu2d_aqhiidle
{
    uint32_t U;
    struct _hw_gpu2d_aqhiidle_bitfields
    {
        uint32_t AXI_LP : 1;           /*!< [0]  */
        uint32_t RESERVED0 : 19;       /*!< [19:1]  */
        uint32_t IDLE_TS : 1;          /*!< [20]  */
        uint32_t IDLE_FP : 1;          /*!< [21]  */
        uint32_t IDLE_IM : 1;          /*!< [22]  */
        uint32_t IDLE_VG : 1;          /*!< [23]  */
        uint32_t IDLE_TX : 1;          /*!< [24]  */
        uint32_t IDLE_RA : 1;          /*!< [25]  */
        uint32_t IDLE_SE : 1;          /*!< [26]  */
        uint32_t IDLE_PA : 1;          /*!< [27]  */
        uint32_t IDLE_SH : 1;          /*!< [28]  */
        uint32_t IDLE_PE : 1;          /*!< [29]  */
        uint32_t IDLE_DE : 1;          /*!< [30]  */
        uint32_t IDLE_FE : 1;          /*!< [31]  */
    } B;
} hw_gpu2d_aqhiidle_t;

/*!
 * @name Constants and macros for entire GPU2D_AQHiIdle register
 */
/*@{*/
#define HW_GPU2D_AQHiIdle_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_GPU2D_AQHiIdle(x)     (*(__I hw_gpu2d_aqhiidle_t *) HW_GPU2D_AQHiIdle_ADDR(x))
#define HW_GPU2D_AQHiIdle_RD(x)  (HW_GPU2D_AQHiIdle(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQHiIdle bitfields
 */

/*!
 * @name Register GPU2D_AQHiIdle, field AXI_LP[0] (RO)
 *
 * AXI is in low power mode.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_AXI_LP (0U)      /*!< Bit position for GPU2D_AQHiIdle_AXI_LP. */
#define BM_GPU2D_AQHiIdle_AXI_LP (0x00000001U) /*!< Bit mask for GPU2D_AQHiIdle_AXI_LP. */
#define BS_GPU2D_AQHiIdle_AXI_LP (1U)      /*!< Bit field size in bits for GPU2D_AQHiIdle_AXI_LP. */

/*! @brief Read current value of the GPU2D_AQHiIdle_AXI_LP field. */
#define BR_GPU2D_AQHiIdle_AXI_LP(x) (HW_GPU2D_AQHiIdle(x).B.AXI_LP)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_TS[20] (RO)
 *
 * TS is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_TS (20U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_TS. */
#define BM_GPU2D_AQHiIdle_IDLE_TS (0x00100000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_TS. */
#define BS_GPU2D_AQHiIdle_IDLE_TS (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_TS. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_TS field. */
#define BR_GPU2D_AQHiIdle_IDLE_TS(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_TS)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_FP[21] (RO)
 *
 * FP is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_FP (21U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_FP. */
#define BM_GPU2D_AQHiIdle_IDLE_FP (0x00200000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_FP. */
#define BS_GPU2D_AQHiIdle_IDLE_FP (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_FP. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_FP field. */
#define BR_GPU2D_AQHiIdle_IDLE_FP(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_FP)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_IM[22] (RO)
 *
 * IM is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_IM (22U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_IM. */
#define BM_GPU2D_AQHiIdle_IDLE_IM (0x00400000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_IM. */
#define BS_GPU2D_AQHiIdle_IDLE_IM (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_IM. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_IM field. */
#define BR_GPU2D_AQHiIdle_IDLE_IM(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_IM)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_VG[23] (RO)
 *
 * VG is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_VG (23U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_VG. */
#define BM_GPU2D_AQHiIdle_IDLE_VG (0x00800000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_VG. */
#define BS_GPU2D_AQHiIdle_IDLE_VG (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_VG. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_VG field. */
#define BR_GPU2D_AQHiIdle_IDLE_VG(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_VG)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_TX[24] (RO)
 *
 * TX is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_TX (24U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_TX. */
#define BM_GPU2D_AQHiIdle_IDLE_TX (0x01000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_TX. */
#define BS_GPU2D_AQHiIdle_IDLE_TX (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_TX. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_TX field. */
#define BR_GPU2D_AQHiIdle_IDLE_TX(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_TX)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_RA[25] (RO)
 *
 * RA is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_RA (25U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_RA. */
#define BM_GPU2D_AQHiIdle_IDLE_RA (0x02000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_RA. */
#define BS_GPU2D_AQHiIdle_IDLE_RA (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_RA. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_RA field. */
#define BR_GPU2D_AQHiIdle_IDLE_RA(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_RA)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_SE[26] (RO)
 *
 * SE is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_SE (26U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_SE. */
#define BM_GPU2D_AQHiIdle_IDLE_SE (0x04000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_SE. */
#define BS_GPU2D_AQHiIdle_IDLE_SE (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_SE. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_SE field. */
#define BR_GPU2D_AQHiIdle_IDLE_SE(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_SE)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_PA[27] (RO)
 *
 * PA is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_PA (27U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_PA. */
#define BM_GPU2D_AQHiIdle_IDLE_PA (0x08000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_PA. */
#define BS_GPU2D_AQHiIdle_IDLE_PA (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_PA. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_PA field. */
#define BR_GPU2D_AQHiIdle_IDLE_PA(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_PA)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_SH[28] (RO)
 *
 * SH is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_SH (28U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_SH. */
#define BM_GPU2D_AQHiIdle_IDLE_SH (0x10000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_SH. */
#define BS_GPU2D_AQHiIdle_IDLE_SH (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_SH. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_SH field. */
#define BR_GPU2D_AQHiIdle_IDLE_SH(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_SH)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_PE[29] (RO)
 *
 * PE is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_PE (29U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_PE. */
#define BM_GPU2D_AQHiIdle_IDLE_PE (0x20000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_PE. */
#define BS_GPU2D_AQHiIdle_IDLE_PE (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_PE. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_PE field. */
#define BR_GPU2D_AQHiIdle_IDLE_PE(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_PE)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_DE[30] (RO)
 *
 * DE is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_DE (30U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_DE. */
#define BM_GPU2D_AQHiIdle_IDLE_DE (0x40000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_DE. */
#define BS_GPU2D_AQHiIdle_IDLE_DE (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_DE. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_DE field. */
#define BR_GPU2D_AQHiIdle_IDLE_DE(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_DE)
/*@}*/

/*!
 * @name Register GPU2D_AQHiIdle, field IDLE_FE[31] (RO)
 *
 * FE is idle.
 */
/*@{*/
#define BP_GPU2D_AQHiIdle_IDLE_FE (31U)    /*!< Bit position for GPU2D_AQHiIdle_IDLE_FE. */
#define BM_GPU2D_AQHiIdle_IDLE_FE (0x80000000U) /*!< Bit mask for GPU2D_AQHiIdle_IDLE_FE. */
#define BS_GPU2D_AQHiIdle_IDLE_FE (1U)     /*!< Bit field size in bits for GPU2D_AQHiIdle_IDLE_FE. */

/*! @brief Read current value of the GPU2D_AQHiIdle_IDLE_FE field. */
#define BR_GPU2D_AQHiIdle_IDLE_FE(x) (HW_GPU2D_AQHiIdle(x).B.IDLE_FE)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQAxiConfig - AXI Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQAxiConfig - AXI Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpu2d_aqaxiconfig
{
    uint32_t U;
    struct _hw_gpu2d_aqaxiconfig_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t ARCACHE : 4;          /*!< [19:16]  */
        uint32_t AWCACHE : 4;          /*!< [23:20]  */
        uint32_t ARID : 4;             /*!< [27:24]  */
        uint32_t AWID : 4;             /*!< [31:28]  */
    } B;
} hw_gpu2d_aqaxiconfig_t;

/*!
 * @name Constants and macros for entire GPU2D_AQAxiConfig register
 */
/*@{*/
#define HW_GPU2D_AQAxiConfig_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_GPU2D_AQAxiConfig(x)  (*(__IO hw_gpu2d_aqaxiconfig_t *) HW_GPU2D_AQAxiConfig_ADDR(x))
#define HW_GPU2D_AQAxiConfig_RD(x) (HW_GPU2D_AQAxiConfig(x).U)
#define HW_GPU2D_AQAxiConfig_WR(x, v) (HW_GPU2D_AQAxiConfig(x).U = (v))
#define HW_GPU2D_AQAxiConfig_SET(x, v) (HW_GPU2D_AQAxiConfig_WR(x, HW_GPU2D_AQAxiConfig_RD(x) |  (v)))
#define HW_GPU2D_AQAxiConfig_CLR(x, v) (HW_GPU2D_AQAxiConfig_WR(x, HW_GPU2D_AQAxiConfig_RD(x) & ~(v)))
#define HW_GPU2D_AQAxiConfig_TOG(x, v) (HW_GPU2D_AQAxiConfig_WR(x, HW_GPU2D_AQAxiConfig_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQAxiConfig bitfields
 */

/*!
 * @name Register GPU2D_AQAxiConfig, field ARCACHE[19:16] (RW)
 *
 * AR Cache
 */
/*@{*/
#define BP_GPU2D_AQAxiConfig_ARCACHE (16U) /*!< Bit position for GPU2D_AQAxiConfig_ARCACHE. */
#define BM_GPU2D_AQAxiConfig_ARCACHE (0x000F0000U) /*!< Bit mask for GPU2D_AQAxiConfig_ARCACHE. */
#define BS_GPU2D_AQAxiConfig_ARCACHE (4U)  /*!< Bit field size in bits for GPU2D_AQAxiConfig_ARCACHE. */

/*! @brief Read current value of the GPU2D_AQAxiConfig_ARCACHE field. */
#define BR_GPU2D_AQAxiConfig_ARCACHE(x) (HW_GPU2D_AQAxiConfig(x).B.ARCACHE)

/*! @brief Format value for bitfield GPU2D_AQAxiConfig_ARCACHE. */
#define BF_GPU2D_AQAxiConfig_ARCACHE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiConfig_ARCACHE) & BM_GPU2D_AQAxiConfig_ARCACHE)

/*! @brief Set the ARCACHE field to a new value. */
#define BW_GPU2D_AQAxiConfig_ARCACHE(x, v) (HW_GPU2D_AQAxiConfig_WR(x, (HW_GPU2D_AQAxiConfig_RD(x) & ~BM_GPU2D_AQAxiConfig_ARCACHE) | BF_GPU2D_AQAxiConfig_ARCACHE(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiConfig, field AWCACHE[23:20] (RW)
 *
 * AW Cache
 */
/*@{*/
#define BP_GPU2D_AQAxiConfig_AWCACHE (20U) /*!< Bit position for GPU2D_AQAxiConfig_AWCACHE. */
#define BM_GPU2D_AQAxiConfig_AWCACHE (0x00F00000U) /*!< Bit mask for GPU2D_AQAxiConfig_AWCACHE. */
#define BS_GPU2D_AQAxiConfig_AWCACHE (4U)  /*!< Bit field size in bits for GPU2D_AQAxiConfig_AWCACHE. */

/*! @brief Read current value of the GPU2D_AQAxiConfig_AWCACHE field. */
#define BR_GPU2D_AQAxiConfig_AWCACHE(x) (HW_GPU2D_AQAxiConfig(x).B.AWCACHE)

/*! @brief Format value for bitfield GPU2D_AQAxiConfig_AWCACHE. */
#define BF_GPU2D_AQAxiConfig_AWCACHE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiConfig_AWCACHE) & BM_GPU2D_AQAxiConfig_AWCACHE)

/*! @brief Set the AWCACHE field to a new value. */
#define BW_GPU2D_AQAxiConfig_AWCACHE(x, v) (HW_GPU2D_AQAxiConfig_WR(x, (HW_GPU2D_AQAxiConfig_RD(x) & ~BM_GPU2D_AQAxiConfig_AWCACHE) | BF_GPU2D_AQAxiConfig_AWCACHE(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiConfig, field ARID[27:24] (RW)
 *
 * AR ID
 */
/*@{*/
#define BP_GPU2D_AQAxiConfig_ARID (24U)    /*!< Bit position for GPU2D_AQAxiConfig_ARID. */
#define BM_GPU2D_AQAxiConfig_ARID (0x0F000000U) /*!< Bit mask for GPU2D_AQAxiConfig_ARID. */
#define BS_GPU2D_AQAxiConfig_ARID (4U)     /*!< Bit field size in bits for GPU2D_AQAxiConfig_ARID. */

/*! @brief Read current value of the GPU2D_AQAxiConfig_ARID field. */
#define BR_GPU2D_AQAxiConfig_ARID(x) (HW_GPU2D_AQAxiConfig(x).B.ARID)

/*! @brief Format value for bitfield GPU2D_AQAxiConfig_ARID. */
#define BF_GPU2D_AQAxiConfig_ARID(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiConfig_ARID) & BM_GPU2D_AQAxiConfig_ARID)

/*! @brief Set the ARID field to a new value. */
#define BW_GPU2D_AQAxiConfig_ARID(x, v) (HW_GPU2D_AQAxiConfig_WR(x, (HW_GPU2D_AQAxiConfig_RD(x) & ~BM_GPU2D_AQAxiConfig_ARID) | BF_GPU2D_AQAxiConfig_ARID(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiConfig, field AWID[31:28] (RW)
 *
 * AW ID
 */
/*@{*/
#define BP_GPU2D_AQAxiConfig_AWID (28U)    /*!< Bit position for GPU2D_AQAxiConfig_AWID. */
#define BM_GPU2D_AQAxiConfig_AWID (0xF0000000U) /*!< Bit mask for GPU2D_AQAxiConfig_AWID. */
#define BS_GPU2D_AQAxiConfig_AWID (4U)     /*!< Bit field size in bits for GPU2D_AQAxiConfig_AWID. */

/*! @brief Read current value of the GPU2D_AQAxiConfig_AWID field. */
#define BR_GPU2D_AQAxiConfig_AWID(x) (HW_GPU2D_AQAxiConfig(x).B.AWID)

/*! @brief Format value for bitfield GPU2D_AQAxiConfig_AWID. */
#define BF_GPU2D_AQAxiConfig_AWID(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiConfig_AWID) & BM_GPU2D_AQAxiConfig_AWID)

/*! @brief Set the AWID field to a new value. */
#define BW_GPU2D_AQAxiConfig_AWID(x, v) (HW_GPU2D_AQAxiConfig_WR(x, (HW_GPU2D_AQAxiConfig_RD(x) & ~BM_GPU2D_AQAxiConfig_AWID) | BF_GPU2D_AQAxiConfig_AWID(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQAxiStatus - AXI Status Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQAxiStatus - AXI Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpu2d_aqaxistatus
{
    uint32_t U;
    struct _hw_gpu2d_aqaxistatus_bitfields
    {
        uint32_t WR_ERR_ID : 4;        /*!< [3:0]  */
        uint32_t RD_ERR_ID : 4;        /*!< [7:4]  */
        uint32_t DET_WR_ERR : 1;       /*!< [8]  */
        uint32_t DET_RD_ERR : 1;       /*!< [9]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_gpu2d_aqaxistatus_t;

/*!
 * @name Constants and macros for entire GPU2D_AQAxiStatus register
 */
/*@{*/
#define HW_GPU2D_AQAxiStatus_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_GPU2D_AQAxiStatus(x)  (*(__IO hw_gpu2d_aqaxistatus_t *) HW_GPU2D_AQAxiStatus_ADDR(x))
#define HW_GPU2D_AQAxiStatus_RD(x) (HW_GPU2D_AQAxiStatus(x).U)
#define HW_GPU2D_AQAxiStatus_WR(x, v) (HW_GPU2D_AQAxiStatus(x).U = (v))
#define HW_GPU2D_AQAxiStatus_SET(x, v) (HW_GPU2D_AQAxiStatus_WR(x, HW_GPU2D_AQAxiStatus_RD(x) |  (v)))
#define HW_GPU2D_AQAxiStatus_CLR(x, v) (HW_GPU2D_AQAxiStatus_WR(x, HW_GPU2D_AQAxiStatus_RD(x) & ~(v)))
#define HW_GPU2D_AQAxiStatus_TOG(x, v) (HW_GPU2D_AQAxiStatus_WR(x, HW_GPU2D_AQAxiStatus_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQAxiStatus bitfields
 */

/*!
 * @name Register GPU2D_AQAxiStatus, field WR_ERR_ID[3:0] (RW)
 *
 * WR_ERR_ID bit
 */
/*@{*/
#define BP_GPU2D_AQAxiStatus_WR_ERR_ID (0U) /*!< Bit position for GPU2D_AQAxiStatus_WR_ERR_ID. */
#define BM_GPU2D_AQAxiStatus_WR_ERR_ID (0x0000000FU) /*!< Bit mask for GPU2D_AQAxiStatus_WR_ERR_ID. */
#define BS_GPU2D_AQAxiStatus_WR_ERR_ID (4U) /*!< Bit field size in bits for GPU2D_AQAxiStatus_WR_ERR_ID. */

/*! @brief Read current value of the GPU2D_AQAxiStatus_WR_ERR_ID field. */
#define BR_GPU2D_AQAxiStatus_WR_ERR_ID(x) (HW_GPU2D_AQAxiStatus(x).B.WR_ERR_ID)

/*! @brief Format value for bitfield GPU2D_AQAxiStatus_WR_ERR_ID. */
#define BF_GPU2D_AQAxiStatus_WR_ERR_ID(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiStatus_WR_ERR_ID) & BM_GPU2D_AQAxiStatus_WR_ERR_ID)

/*! @brief Set the WR_ERR_ID field to a new value. */
#define BW_GPU2D_AQAxiStatus_WR_ERR_ID(x, v) (HW_GPU2D_AQAxiStatus_WR(x, (HW_GPU2D_AQAxiStatus_RD(x) & ~BM_GPU2D_AQAxiStatus_WR_ERR_ID) | BF_GPU2D_AQAxiStatus_WR_ERR_ID(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiStatus, field RD_ERR_ID[7:4] (RW)
 *
 * RD_ERR_ID bit
 */
/*@{*/
#define BP_GPU2D_AQAxiStatus_RD_ERR_ID (4U) /*!< Bit position for GPU2D_AQAxiStatus_RD_ERR_ID. */
#define BM_GPU2D_AQAxiStatus_RD_ERR_ID (0x000000F0U) /*!< Bit mask for GPU2D_AQAxiStatus_RD_ERR_ID. */
#define BS_GPU2D_AQAxiStatus_RD_ERR_ID (4U) /*!< Bit field size in bits for GPU2D_AQAxiStatus_RD_ERR_ID. */

/*! @brief Read current value of the GPU2D_AQAxiStatus_RD_ERR_ID field. */
#define BR_GPU2D_AQAxiStatus_RD_ERR_ID(x) (HW_GPU2D_AQAxiStatus(x).B.RD_ERR_ID)

/*! @brief Format value for bitfield GPU2D_AQAxiStatus_RD_ERR_ID. */
#define BF_GPU2D_AQAxiStatus_RD_ERR_ID(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiStatus_RD_ERR_ID) & BM_GPU2D_AQAxiStatus_RD_ERR_ID)

/*! @brief Set the RD_ERR_ID field to a new value. */
#define BW_GPU2D_AQAxiStatus_RD_ERR_ID(x, v) (HW_GPU2D_AQAxiStatus_WR(x, (HW_GPU2D_AQAxiStatus_RD(x) & ~BM_GPU2D_AQAxiStatus_RD_ERR_ID) | BF_GPU2D_AQAxiStatus_RD_ERR_ID(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiStatus, field DET_WR_ERR[8] (RW)
 *
 * DET_WR_ERR bit
 */
/*@{*/
#define BP_GPU2D_AQAxiStatus_DET_WR_ERR (8U) /*!< Bit position for GPU2D_AQAxiStatus_DET_WR_ERR. */
#define BM_GPU2D_AQAxiStatus_DET_WR_ERR (0x00000100U) /*!< Bit mask for GPU2D_AQAxiStatus_DET_WR_ERR. */
#define BS_GPU2D_AQAxiStatus_DET_WR_ERR (1U) /*!< Bit field size in bits for GPU2D_AQAxiStatus_DET_WR_ERR. */

/*! @brief Read current value of the GPU2D_AQAxiStatus_DET_WR_ERR field. */
#define BR_GPU2D_AQAxiStatus_DET_WR_ERR(x) (HW_GPU2D_AQAxiStatus(x).B.DET_WR_ERR)

/*! @brief Format value for bitfield GPU2D_AQAxiStatus_DET_WR_ERR. */
#define BF_GPU2D_AQAxiStatus_DET_WR_ERR(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiStatus_DET_WR_ERR) & BM_GPU2D_AQAxiStatus_DET_WR_ERR)

/*! @brief Set the DET_WR_ERR field to a new value. */
#define BW_GPU2D_AQAxiStatus_DET_WR_ERR(x, v) (HW_GPU2D_AQAxiStatus_WR(x, (HW_GPU2D_AQAxiStatus_RD(x) & ~BM_GPU2D_AQAxiStatus_DET_WR_ERR) | BF_GPU2D_AQAxiStatus_DET_WR_ERR(v)))
/*@}*/

/*!
 * @name Register GPU2D_AQAxiStatus, field DET_RD_ERR[9] (RW)
 *
 * DET_RD_ERR bit
 */
/*@{*/
#define BP_GPU2D_AQAxiStatus_DET_RD_ERR (9U) /*!< Bit position for GPU2D_AQAxiStatus_DET_RD_ERR. */
#define BM_GPU2D_AQAxiStatus_DET_RD_ERR (0x00000200U) /*!< Bit mask for GPU2D_AQAxiStatus_DET_RD_ERR. */
#define BS_GPU2D_AQAxiStatus_DET_RD_ERR (1U) /*!< Bit field size in bits for GPU2D_AQAxiStatus_DET_RD_ERR. */

/*! @brief Read current value of the GPU2D_AQAxiStatus_DET_RD_ERR field. */
#define BR_GPU2D_AQAxiStatus_DET_RD_ERR(x) (HW_GPU2D_AQAxiStatus(x).B.DET_RD_ERR)

/*! @brief Format value for bitfield GPU2D_AQAxiStatus_DET_RD_ERR. */
#define BF_GPU2D_AQAxiStatus_DET_RD_ERR(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQAxiStatus_DET_RD_ERR) & BM_GPU2D_AQAxiStatus_DET_RD_ERR)

/*! @brief Set the DET_RD_ERR field to a new value. */
#define BW_GPU2D_AQAxiStatus_DET_RD_ERR(x, v) (HW_GPU2D_AQAxiStatus_WR(x, (HW_GPU2D_AQAxiStatus_RD(x) & ~BM_GPU2D_AQAxiStatus_DET_RD_ERR) | BF_GPU2D_AQAxiStatus_DET_RD_ERR(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQIntrAcknowledge - Interrupt Acknowledge Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQIntrAcknowledge - Interrupt Acknowledge Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Interrupt acknowledge register. Each bit represents a corresponding event
 * being triggered. Reading frmo this register clears the outstanding interrupt.
 */
typedef union _hw_gpu2d_aqintracknowledge
{
    uint32_t U;
    struct _hw_gpu2d_aqintracknowledge_bitfields
    {
        uint32_t INTR_VEC : 32;        /*!< [31:0]  */
    } B;
} hw_gpu2d_aqintracknowledge_t;

/*!
 * @name Constants and macros for entire GPU2D_AQIntrAcknowledge register
 */
/*@{*/
#define HW_GPU2D_AQIntrAcknowledge_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_GPU2D_AQIntrAcknowledge(x) (*(__I hw_gpu2d_aqintracknowledge_t *) HW_GPU2D_AQIntrAcknowledge_ADDR(x))
#define HW_GPU2D_AQIntrAcknowledge_RD(x) (HW_GPU2D_AQIntrAcknowledge(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQIntrAcknowledge bitfields
 */

/*!
 * @name Register GPU2D_AQIntrAcknowledge, field INTR_VEC[31:0] (RO)
 *
 * Interrupt VEC
 */
/*@{*/
#define BP_GPU2D_AQIntrAcknowledge_INTR_VEC (0U) /*!< Bit position for GPU2D_AQIntrAcknowledge_INTR_VEC. */
#define BM_GPU2D_AQIntrAcknowledge_INTR_VEC (0xFFFFFFFFU) /*!< Bit mask for GPU2D_AQIntrAcknowledge_INTR_VEC. */
#define BS_GPU2D_AQIntrAcknowledge_INTR_VEC (32U) /*!< Bit field size in bits for GPU2D_AQIntrAcknowledge_INTR_VEC. */

/*! @brief Read current value of the GPU2D_AQIntrAcknowledge_INTR_VEC field. */
#define BR_GPU2D_AQIntrAcknowledge_INTR_VEC(x) (HW_GPU2D_AQIntrAcknowledge(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQIntrEnbl - Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQIntrEnbl - Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Interrupt enable register. Each bit enables a corresponding event.
 */
typedef union _hw_gpu2d_aqintrenbl
{
    uint32_t U;
    struct _hw_gpu2d_aqintrenbl_bitfields
    {
        uint32_t INTR_ENBL_VEC : 32;   /*!< [31:0]  */
    } B;
} hw_gpu2d_aqintrenbl_t;

/*!
 * @name Constants and macros for entire GPU2D_AQIntrEnbl register
 */
/*@{*/
#define HW_GPU2D_AQIntrEnbl_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_GPU2D_AQIntrEnbl(x)   (*(__IO hw_gpu2d_aqintrenbl_t *) HW_GPU2D_AQIntrEnbl_ADDR(x))
#define HW_GPU2D_AQIntrEnbl_RD(x) (HW_GPU2D_AQIntrEnbl(x).U)
#define HW_GPU2D_AQIntrEnbl_WR(x, v) (HW_GPU2D_AQIntrEnbl(x).U = (v))
#define HW_GPU2D_AQIntrEnbl_SET(x, v) (HW_GPU2D_AQIntrEnbl_WR(x, HW_GPU2D_AQIntrEnbl_RD(x) |  (v)))
#define HW_GPU2D_AQIntrEnbl_CLR(x, v) (HW_GPU2D_AQIntrEnbl_WR(x, HW_GPU2D_AQIntrEnbl_RD(x) & ~(v)))
#define HW_GPU2D_AQIntrEnbl_TOG(x, v) (HW_GPU2D_AQIntrEnbl_WR(x, HW_GPU2D_AQIntrEnbl_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQIntrEnbl bitfields
 */

/*!
 * @name Register GPU2D_AQIntrEnbl, field INTR_ENBL_VEC[31:0] (RW)
 *
 * Interrupt enable VEC
 */
/*@{*/
#define BP_GPU2D_AQIntrEnbl_INTR_ENBL_VEC (0U) /*!< Bit position for GPU2D_AQIntrEnbl_INTR_ENBL_VEC. */
#define BM_GPU2D_AQIntrEnbl_INTR_ENBL_VEC (0xFFFFFFFFU) /*!< Bit mask for GPU2D_AQIntrEnbl_INTR_ENBL_VEC. */
#define BS_GPU2D_AQIntrEnbl_INTR_ENBL_VEC (32U) /*!< Bit field size in bits for GPU2D_AQIntrEnbl_INTR_ENBL_VEC. */

/*! @brief Read current value of the GPU2D_AQIntrEnbl_INTR_ENBL_VEC field. */
#define BR_GPU2D_AQIntrEnbl_INTR_ENBL_VEC(x) (HW_GPU2D_AQIntrEnbl(x).U)

/*! @brief Format value for bitfield GPU2D_AQIntrEnbl_INTR_ENBL_VEC. */
#define BF_GPU2D_AQIntrEnbl_INTR_ENBL_VEC(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AQIntrEnbl_INTR_ENBL_VEC) & BM_GPU2D_AQIntrEnbl_INTR_ENBL_VEC)

/*! @brief Set the INTR_ENBL_VEC field to a new value. */
#define BW_GPU2D_AQIntrEnbl_INTR_ENBL_VEC(x, v) (HW_GPU2D_AQIntrEnbl_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AQIdent - Identification Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AQIdent - Identification Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Identification register. This register has no set reset value. It varies with
 * the implementation.
 */
typedef union _hw_gpu2d_aqident
{
    uint32_t U;
    struct _hw_gpu2d_aqident_bitfields
    {
        uint32_t CUSTOMER : 8;         /*!< [7:0]  */
        uint32_t TECHNOLOGY : 4;       /*!< [11:8]  */
        uint32_t REVISION : 4;         /*!< [15:12]  */
        uint32_t PRODUCT : 8;          /*!< [23:16]  */
        uint32_t FAMILY : 8;           /*!< [31:24]  */
    } B;
} hw_gpu2d_aqident_t;

/*!
 * @name Constants and macros for entire GPU2D_AQIdent register
 */
/*@{*/
#define HW_GPU2D_AQIdent_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_GPU2D_AQIdent(x)      (*(__I hw_gpu2d_aqident_t *) HW_GPU2D_AQIdent_ADDR(x))
#define HW_GPU2D_AQIdent_RD(x)   (HW_GPU2D_AQIdent(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_AQIdent bitfields
 */

/*!
 * @name Register GPU2D_AQIdent, field CUSTOMER[7:0] (RO)
 *
 * Customer value.
 */
/*@{*/
#define BP_GPU2D_AQIdent_CUSTOMER (0U)     /*!< Bit position for GPU2D_AQIdent_CUSTOMER. */
#define BM_GPU2D_AQIdent_CUSTOMER (0x000000FFU) /*!< Bit mask for GPU2D_AQIdent_CUSTOMER. */
#define BS_GPU2D_AQIdent_CUSTOMER (8U)     /*!< Bit field size in bits for GPU2D_AQIdent_CUSTOMER. */

/*! @brief Read current value of the GPU2D_AQIdent_CUSTOMER field. */
#define BR_GPU2D_AQIdent_CUSTOMER(x) (HW_GPU2D_AQIdent(x).B.CUSTOMER)
/*@}*/

/*!
 * @name Register GPU2D_AQIdent, field TECHNOLOGY[11:8] (RO)
 *
 * Technology value.
 */
/*@{*/
#define BP_GPU2D_AQIdent_TECHNOLOGY (8U)   /*!< Bit position for GPU2D_AQIdent_TECHNOLOGY. */
#define BM_GPU2D_AQIdent_TECHNOLOGY (0x00000F00U) /*!< Bit mask for GPU2D_AQIdent_TECHNOLOGY. */
#define BS_GPU2D_AQIdent_TECHNOLOGY (4U)   /*!< Bit field size in bits for GPU2D_AQIdent_TECHNOLOGY. */

/*! @brief Read current value of the GPU2D_AQIdent_TECHNOLOGY field. */
#define BR_GPU2D_AQIdent_TECHNOLOGY(x) (HW_GPU2D_AQIdent(x).B.TECHNOLOGY)
/*@}*/

/*!
 * @name Register GPU2D_AQIdent, field REVISION[15:12] (RO)
 *
 * Revision value.
 */
/*@{*/
#define BP_GPU2D_AQIdent_REVISION (12U)    /*!< Bit position for GPU2D_AQIdent_REVISION. */
#define BM_GPU2D_AQIdent_REVISION (0x0000F000U) /*!< Bit mask for GPU2D_AQIdent_REVISION. */
#define BS_GPU2D_AQIdent_REVISION (4U)     /*!< Bit field size in bits for GPU2D_AQIdent_REVISION. */

/*! @brief Read current value of the GPU2D_AQIdent_REVISION field. */
#define BR_GPU2D_AQIdent_REVISION(x) (HW_GPU2D_AQIdent(x).B.REVISION)
/*@}*/

/*!
 * @name Register GPU2D_AQIdent, field PRODUCT[23:16] (RO)
 *
 * Product value.
 */
/*@{*/
#define BP_GPU2D_AQIdent_PRODUCT (16U)     /*!< Bit position for GPU2D_AQIdent_PRODUCT. */
#define BM_GPU2D_AQIdent_PRODUCT (0x00FF0000U) /*!< Bit mask for GPU2D_AQIdent_PRODUCT. */
#define BS_GPU2D_AQIdent_PRODUCT (8U)      /*!< Bit field size in bits for GPU2D_AQIdent_PRODUCT. */

/*! @brief Read current value of the GPU2D_AQIdent_PRODUCT field. */
#define BR_GPU2D_AQIdent_PRODUCT(x) (HW_GPU2D_AQIdent(x).B.PRODUCT)
/*@}*/

/*!
 * @name Register GPU2D_AQIdent, field FAMILY[31:24] (RO)
 *
 * Family value.
 *
 * Values:
 * - 01 - GC500
 * - 10 - GC1000
 */
/*@{*/
#define BP_GPU2D_AQIdent_FAMILY (24U)      /*!< Bit position for GPU2D_AQIdent_FAMILY. */
#define BM_GPU2D_AQIdent_FAMILY (0xFF000000U) /*!< Bit mask for GPU2D_AQIdent_FAMILY. */
#define BS_GPU2D_AQIdent_FAMILY (8U)       /*!< Bit field size in bits for GPU2D_AQIdent_FAMILY. */

/*! @brief Read current value of the GPU2D_AQIdent_FAMILY field. */
#define BR_GPU2D_AQIdent_FAMILY(x) (HW_GPU2D_AQIdent(x).B.FAMILY)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_Features - Features Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_Features - Features Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which features are enabled in this chip. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu2d_features
{
    uint32_t U;
    struct _hw_gpu2d_features_bitfields
    {
        uint32_t FE20_BIT_INDEX : 1;   /*!< [0]  */
        uint32_t RS_YUV_TARGET : 1;    /*!< [1]  */
        uint32_t BYTE_WRITE_3D : 1;    /*!< [2]  */
        uint32_t FE20 : 1;             /*!< [3]  */
        uint32_t VGTS : 1;             /*!< [4]  */
        uint32_t PIPE_VG : 1;          /*!< [5]  */
        uint32_t MEM32_BIT_SUPPORT : 1; /*!< [6]  */
        uint32_t YUY2_RENDER_TARGET : 1; /*!< [7]  */
        uint32_t HALF_TX_CACHE : 1;    /*!< [8]  */
        uint32_t HALF_PE_CACHE : 1;    /*!< [9]  */
        uint32_t YUY2_AVERAGING : 1;   /*!< [10]  */
        uint32_t NO_SCALER : 1;        /*!< [11]  */
        uint32_t BYTE_WRITE_2D : 1;    /*!< [12]  */
        uint32_t BUFFER_INTERLEAVING : 1; /*!< [13]  */
        uint32_t NO422_TEXTURE : 1;    /*!< [14]  */
        uint32_t NO_EZ : 1;            /*!< [15]  */
        uint32_t MIN_AREA : 1;         /*!< [16]  */
        uint32_t MODULE_CG : 1;        /*!< [17]  */
        uint32_t YUV420_TILER : 1;     /*!< [18]  */
        uint32_t HIGH_DYNAMIC_RANGE : 1; /*!< [19]  */
        uint32_t FAST_SCALER : 1;      /*!< [20]  */
        uint32_t ETC1_TEXTURE_COMPRESSION : 1; /*!< [21]  */
        uint32_t PIPE_2D : 1;          /*!< [22]  */
        uint32_t DC : 1;               /*!< [23]  */
        uint32_t MSAA : 1;             /*!< [24]  */
        uint32_t YUV420_FILTER : 1;    /*!< [25]  */
        uint32_t ZCOMPRESSION : 1;     /*!< [26]  */
        uint32_t DEBUG_MODE : 1;       /*!< [27]  */
        uint32_t DXT_TEXTURE_COMPRESSION : 1; /*!< [28]  */
        uint32_t PIPE_3D : 1;          /*!< [29]  */
        uint32_t SPECIAL_ANTI_ALIASING : 1; /*!< [30]  */
        uint32_t FAST_CLEAR : 1;       /*!< [31]  */
    } B;
} hw_gpu2d_features_t;

/*!
 * @name Constants and macros for entire GPU2D_Features register
 */
/*@{*/
#define HW_GPU2D_Features_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_GPU2D_Features(x)     (*(__I hw_gpu2d_features_t *) HW_GPU2D_Features_ADDR(x))
#define HW_GPU2D_Features_RD(x)  (HW_GPU2D_Features(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_Features bitfields
 */

/*!
 * @name Register GPU2D_Features, field FE20_BIT_INDEX[0] (RO)
 *
 * Supports 20 bit index.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_FE20_BIT_INDEX (0U) /*!< Bit position for GPU2D_Features_FE20_BIT_INDEX. */
#define BM_GPU2D_Features_FE20_BIT_INDEX (0x00000001U) /*!< Bit mask for GPU2D_Features_FE20_BIT_INDEX. */
#define BS_GPU2D_Features_FE20_BIT_INDEX (1U) /*!< Bit field size in bits for GPU2D_Features_FE20_BIT_INDEX. */

/*! @brief Read current value of the GPU2D_Features_FE20_BIT_INDEX field. */
#define BR_GPU2D_Features_FE20_BIT_INDEX(x) (HW_GPU2D_Features(x).B.FE20_BIT_INDEX)
/*@}*/

/*!
 * @name Register GPU2D_Features, field RS_YUV_TARGET[1] (RO)
 *
 * Supports resolving into YUV target.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_RS_YUV_TARGET (1U) /*!< Bit position for GPU2D_Features_RS_YUV_TARGET. */
#define BM_GPU2D_Features_RS_YUV_TARGET (0x00000002U) /*!< Bit mask for GPU2D_Features_RS_YUV_TARGET. */
#define BS_GPU2D_Features_RS_YUV_TARGET (1U) /*!< Bit field size in bits for GPU2D_Features_RS_YUV_TARGET. */

/*! @brief Read current value of the GPU2D_Features_RS_YUV_TARGET field. */
#define BR_GPU2D_Features_RS_YUV_TARGET(x) (HW_GPU2D_Features(x).B.RS_YUV_TARGET)
/*@}*/

/*!
 * @name Register GPU2D_Features, field BYTE_WRITE_3D[2] (RO)
 *
 * 3D PE has byte write capability.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_BYTE_WRITE_3D (2U) /*!< Bit position for GPU2D_Features_BYTE_WRITE_3D. */
#define BM_GPU2D_Features_BYTE_WRITE_3D (0x00000004U) /*!< Bit mask for GPU2D_Features_BYTE_WRITE_3D. */
#define BS_GPU2D_Features_BYTE_WRITE_3D (1U) /*!< Bit field size in bits for GPU2D_Features_BYTE_WRITE_3D. */

/*! @brief Read current value of the GPU2D_Features_BYTE_WRITE_3D field. */
#define BR_GPU2D_Features_BYTE_WRITE_3D(x) (HW_GPU2D_Features(x).B.BYTE_WRITE_3D)
/*@}*/

/*!
 * @name Register GPU2D_Features, field FE20[3] (RO)
 *
 * FE 2.0 is present.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_FE20 (3U)        /*!< Bit position for GPU2D_Features_FE20. */
#define BM_GPU2D_Features_FE20 (0x00000008U) /*!< Bit mask for GPU2D_Features_FE20. */
#define BS_GPU2D_Features_FE20 (1U)        /*!< Bit field size in bits for GPU2D_Features_FE20. */

/*! @brief Read current value of the GPU2D_Features_FE20 field. */
#define BR_GPU2D_Features_FE20(x) (HW_GPU2D_Features(x).B.FE20)
/*@}*/

/*!
 * @name Register GPU2D_Features, field VGTS[4] (RO)
 *
 * VG tessellator is present.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_VGTS (4U)        /*!< Bit position for GPU2D_Features_VGTS. */
#define BM_GPU2D_Features_VGTS (0x00000010U) /*!< Bit mask for GPU2D_Features_VGTS. */
#define BS_GPU2D_Features_VGTS (1U)        /*!< Bit field size in bits for GPU2D_Features_VGTS. */

/*! @brief Read current value of the GPU2D_Features_VGTS field. */
#define BR_GPU2D_Features_VGTS(x) (HW_GPU2D_Features(x).B.VGTS)
/*@}*/

/*!
 * @name Register GPU2D_Features, field PIPE_VG[5] (RO)
 *
 * VG pipe is present.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_PIPE_VG (5U)     /*!< Bit position for GPU2D_Features_PIPE_VG. */
#define BM_GPU2D_Features_PIPE_VG (0x00000020U) /*!< Bit mask for GPU2D_Features_PIPE_VG. */
#define BS_GPU2D_Features_PIPE_VG (1U)     /*!< Bit field size in bits for GPU2D_Features_PIPE_VG. */

/*! @brief Read current value of the GPU2D_Features_PIPE_VG field. */
#define BR_GPU2D_Features_PIPE_VG(x) (HW_GPU2D_Features(x).B.PIPE_VG)
/*@}*/

/*!
 * @name Register GPU2D_Features, field MEM32_BIT_SUPPORT[6] (RO)
 *
 * 32 bit memory address support.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_MEM32_BIT_SUPPORT (6U) /*!< Bit position for GPU2D_Features_MEM32_BIT_SUPPORT. */
#define BM_GPU2D_Features_MEM32_BIT_SUPPORT (0x00000040U) /*!< Bit mask for GPU2D_Features_MEM32_BIT_SUPPORT. */
#define BS_GPU2D_Features_MEM32_BIT_SUPPORT (1U) /*!< Bit field size in bits for GPU2D_Features_MEM32_BIT_SUPPORT. */

/*! @brief Read current value of the GPU2D_Features_MEM32_BIT_SUPPORT field. */
#define BR_GPU2D_Features_MEM32_BIT_SUPPORT(x) (HW_GPU2D_Features(x).B.MEM32_BIT_SUPPORT)
/*@}*/

/*!
 * @name Register GPU2D_Features, field YUY2_RENDER_TARGET[7] (RO)
 *
 * YUY2 support in PE and YUY2 to RGB conversion in resolve.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_YUY2_RENDER_TARGET (7U) /*!< Bit position for GPU2D_Features_YUY2_RENDER_TARGET. */
#define BM_GPU2D_Features_YUY2_RENDER_TARGET (0x00000080U) /*!< Bit mask for GPU2D_Features_YUY2_RENDER_TARGET. */
#define BS_GPU2D_Features_YUY2_RENDER_TARGET (1U) /*!< Bit field size in bits for GPU2D_Features_YUY2_RENDER_TARGET. */

/*! @brief Read current value of the GPU2D_Features_YUY2_RENDER_TARGET field. */
#define BR_GPU2D_Features_YUY2_RENDER_TARGET(x) (HW_GPU2D_Features(x).B.YUY2_RENDER_TARGET)
/*@}*/

/*!
 * @name Register GPU2D_Features, field HALF_TX_CACHE[8] (RO)
 *
 * TX cache is half.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_HALF_TX_CACHE (8U) /*!< Bit position for GPU2D_Features_HALF_TX_CACHE. */
#define BM_GPU2D_Features_HALF_TX_CACHE (0x00000100U) /*!< Bit mask for GPU2D_Features_HALF_TX_CACHE. */
#define BS_GPU2D_Features_HALF_TX_CACHE (1U) /*!< Bit field size in bits for GPU2D_Features_HALF_TX_CACHE. */

/*! @brief Read current value of the GPU2D_Features_HALF_TX_CACHE field. */
#define BR_GPU2D_Features_HALF_TX_CACHE(x) (HW_GPU2D_Features(x).B.HALF_TX_CACHE)
/*@}*/

/*!
 * @name Register GPU2D_Features, field HALF_PE_CACHE[9] (RO)
 *
 * PE cache is half.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_HALF_PE_CACHE (9U) /*!< Bit position for GPU2D_Features_HALF_PE_CACHE. */
#define BM_GPU2D_Features_HALF_PE_CACHE (0x00000200U) /*!< Bit mask for GPU2D_Features_HALF_PE_CACHE. */
#define BS_GPU2D_Features_HALF_PE_CACHE (1U) /*!< Bit field size in bits for GPU2D_Features_HALF_PE_CACHE. */

/*! @brief Read current value of the GPU2D_Features_HALF_PE_CACHE field. */
#define BR_GPU2D_Features_HALF_PE_CACHE(x) (HW_GPU2D_Features(x).B.HALF_PE_CACHE)
/*@}*/

/*!
 * @name Register GPU2D_Features, field YUY2_AVERAGING[10] (RO)
 *
 * YUY2 averaging support in resolve.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_YUY2_AVERAGING (10U) /*!< Bit position for GPU2D_Features_YUY2_AVERAGING. */
#define BM_GPU2D_Features_YUY2_AVERAGING (0x00000400U) /*!< Bit mask for GPU2D_Features_YUY2_AVERAGING. */
#define BS_GPU2D_Features_YUY2_AVERAGING (1U) /*!< Bit field size in bits for GPU2D_Features_YUY2_AVERAGING. */

/*! @brief Read current value of the GPU2D_Features_YUY2_AVERAGING field. */
#define BR_GPU2D_Features_YUY2_AVERAGING(x) (HW_GPU2D_Features(x).B.YUY2_AVERAGING)
/*@}*/

/*!
 * @name Register GPU2D_Features, field NO_SCALER[11] (RO)
 *
 * IP does not have 2D scaler.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_NO_SCALER (11U)  /*!< Bit position for GPU2D_Features_NO_SCALER. */
#define BM_GPU2D_Features_NO_SCALER (0x00000800U) /*!< Bit mask for GPU2D_Features_NO_SCALER. */
#define BS_GPU2D_Features_NO_SCALER (1U)   /*!< Bit field size in bits for GPU2D_Features_NO_SCALER. */

/*! @brief Read current value of the GPU2D_Features_NO_SCALER field. */
#define BR_GPU2D_Features_NO_SCALER(x) (HW_GPU2D_Features(x).B.NO_SCALER)
/*@}*/

/*!
 * @name Register GPU2D_Features, field BYTE_WRITE_2D[12] (RO)
 *
 * Supports byte write in 2D.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_BYTE_WRITE_2D (12U) /*!< Bit position for GPU2D_Features_BYTE_WRITE_2D. */
#define BM_GPU2D_Features_BYTE_WRITE_2D (0x00001000U) /*!< Bit mask for GPU2D_Features_BYTE_WRITE_2D. */
#define BS_GPU2D_Features_BYTE_WRITE_2D (1U) /*!< Bit field size in bits for GPU2D_Features_BYTE_WRITE_2D. */

/*! @brief Read current value of the GPU2D_Features_BYTE_WRITE_2D field. */
#define BR_GPU2D_Features_BYTE_WRITE_2D(x) (HW_GPU2D_Features(x).B.BYTE_WRITE_2D)
/*@}*/

/*!
 * @name Register GPU2D_Features, field BUFFER_INTERLEAVING[13] (RO)
 *
 * IP supports interleaving depth and color buffers.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_BUFFER_INTERLEAVING (13U) /*!< Bit position for GPU2D_Features_BUFFER_INTERLEAVING. */
#define BM_GPU2D_Features_BUFFER_INTERLEAVING (0x00002000U) /*!< Bit mask for GPU2D_Features_BUFFER_INTERLEAVING. */
#define BS_GPU2D_Features_BUFFER_INTERLEAVING (1U) /*!< Bit field size in bits for GPU2D_Features_BUFFER_INTERLEAVING. */

/*! @brief Read current value of the GPU2D_Features_BUFFER_INTERLEAVING field. */
#define BR_GPU2D_Features_BUFFER_INTERLEAVING(x) (HW_GPU2D_Features(x).B.BUFFER_INTERLEAVING)
/*@}*/

/*!
 * @name Register GPU2D_Features, field NO422_TEXTURE[14] (RO)
 *
 * IP does not have 422 texture input format.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_NO422_TEXTURE (14U) /*!< Bit position for GPU2D_Features_NO422_TEXTURE. */
#define BM_GPU2D_Features_NO422_TEXTURE (0x00004000U) /*!< Bit mask for GPU2D_Features_NO422_TEXTURE. */
#define BS_GPU2D_Features_NO422_TEXTURE (1U) /*!< Bit field size in bits for GPU2D_Features_NO422_TEXTURE. */

/*! @brief Read current value of the GPU2D_Features_NO422_TEXTURE field. */
#define BR_GPU2D_Features_NO422_TEXTURE(x) (HW_GPU2D_Features(x).B.NO422_TEXTURE)
/*@}*/

/*!
 * @name Register GPU2D_Features, field NO_EZ[15] (RO)
 *
 * IP does not have early-Z.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_NO_EZ (15U)      /*!< Bit position for GPU2D_Features_NO_EZ. */
#define BM_GPU2D_Features_NO_EZ (0x00008000U) /*!< Bit mask for GPU2D_Features_NO_EZ. */
#define BS_GPU2D_Features_NO_EZ (1U)       /*!< Bit field size in bits for GPU2D_Features_NO_EZ. */

/*! @brief Read current value of the GPU2D_Features_NO_EZ field. */
#define BR_GPU2D_Features_NO_EZ(x) (HW_GPU2D_Features(x).B.NO_EZ)
/*@}*/

/*!
 * @name Register GPU2D_Features, field MIN_AREA[16] (RO)
 *
 * IP is configured to have minimum area.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_MIN_AREA (16U)   /*!< Bit position for GPU2D_Features_MIN_AREA. */
#define BM_GPU2D_Features_MIN_AREA (0x00010000U) /*!< Bit mask for GPU2D_Features_MIN_AREA. */
#define BS_GPU2D_Features_MIN_AREA (1U)    /*!< Bit field size in bits for GPU2D_Features_MIN_AREA. */

/*! @brief Read current value of the GPU2D_Features_MIN_AREA field. */
#define BR_GPU2D_Features_MIN_AREA(x) (HW_GPU2D_Features(x).B.MIN_AREA)
/*@}*/

/*!
 * @name Register GPU2D_Features, field MODULE_CG[17] (RO)
 *
 * Second level clock gating is available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_MODULE_CG (17U)  /*!< Bit position for GPU2D_Features_MODULE_CG. */
#define BM_GPU2D_Features_MODULE_CG (0x00020000U) /*!< Bit mask for GPU2D_Features_MODULE_CG. */
#define BS_GPU2D_Features_MODULE_CG (1U)   /*!< Bit field size in bits for GPU2D_Features_MODULE_CG. */

/*! @brief Read current value of the GPU2D_Features_MODULE_CG field. */
#define BR_GPU2D_Features_MODULE_CG(x) (HW_GPU2D_Features(x).B.MODULE_CG)
/*@}*/

/*!
 * @name Register GPU2D_Features, field YUV420_TILER[18] (RO)
 *
 * YUV 4:2:0 tiler is available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_YUV420_TILER (18U) /*!< Bit position for GPU2D_Features_YUV420_TILER. */
#define BM_GPU2D_Features_YUV420_TILER (0x00040000U) /*!< Bit mask for GPU2D_Features_YUV420_TILER. */
#define BS_GPU2D_Features_YUV420_TILER (1U) /*!< Bit field size in bits for GPU2D_Features_YUV420_TILER. */

/*! @brief Read current value of the GPU2D_Features_YUV420_TILER field. */
#define BR_GPU2D_Features_YUV420_TILER(x) (HW_GPU2D_Features(x).B.YUV420_TILER)
/*@}*/

/*!
 * @name Register GPU2D_Features, field HIGH_DYNAMIC_RANGE[19] (RO)
 *
 * Shows if the IP has HDR support.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_HIGH_DYNAMIC_RANGE (19U) /*!< Bit position for GPU2D_Features_HIGH_DYNAMIC_RANGE. */
#define BM_GPU2D_Features_HIGH_DYNAMIC_RANGE (0x00080000U) /*!< Bit mask for GPU2D_Features_HIGH_DYNAMIC_RANGE. */
#define BS_GPU2D_Features_HIGH_DYNAMIC_RANGE (1U) /*!< Bit field size in bits for GPU2D_Features_HIGH_DYNAMIC_RANGE. */

/*! @brief Read current value of the GPU2D_Features_HIGH_DYNAMIC_RANGE field. */
#define BR_GPU2D_Features_HIGH_DYNAMIC_RANGE(x) (HW_GPU2D_Features(x).B.HIGH_DYNAMIC_RANGE)
/*@}*/

/*!
 * @name Register GPU2D_Features, field FAST_SCALER[20] (RO)
 *
 * Shows if the IP has HD scaler.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_FAST_SCALER (20U) /*!< Bit position for GPU2D_Features_FAST_SCALER. */
#define BM_GPU2D_Features_FAST_SCALER (0x00100000U) /*!< Bit mask for GPU2D_Features_FAST_SCALER. */
#define BS_GPU2D_Features_FAST_SCALER (1U) /*!< Bit field size in bits for GPU2D_Features_FAST_SCALER. */

/*! @brief Read current value of the GPU2D_Features_FAST_SCALER field. */
#define BR_GPU2D_Features_FAST_SCALER(x) (HW_GPU2D_Features(x).B.FAST_SCALER)
/*@}*/

/*!
 * @name Register GPU2D_Features, field ETC1_TEXTURE_COMPRESSION[21] (RO)
 *
 * ETC1 texture compression.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_ETC1_TEXTURE_COMPRESSION (21U) /*!< Bit position for GPU2D_Features_ETC1_TEXTURE_COMPRESSION. */
#define BM_GPU2D_Features_ETC1_TEXTURE_COMPRESSION (0x00200000U) /*!< Bit mask for GPU2D_Features_ETC1_TEXTURE_COMPRESSION. */
#define BS_GPU2D_Features_ETC1_TEXTURE_COMPRESSION (1U) /*!< Bit field size in bits for GPU2D_Features_ETC1_TEXTURE_COMPRESSION. */

/*! @brief Read current value of the GPU2D_Features_ETC1_TEXTURE_COMPRESSION field. */
#define BR_GPU2D_Features_ETC1_TEXTURE_COMPRESSION(x) (HW_GPU2D_Features(x).B.ETC1_TEXTURE_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU2D_Features, field PIPE_2D[22] (RO)
 *
 * Shows if there is 2D engine.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_PIPE_2D (22U)    /*!< Bit position for GPU2D_Features_PIPE_2D. */
#define BM_GPU2D_Features_PIPE_2D (0x00400000U) /*!< Bit mask for GPU2D_Features_PIPE_2D. */
#define BS_GPU2D_Features_PIPE_2D (1U)     /*!< Bit field size in bits for GPU2D_Features_PIPE_2D. */

/*! @brief Read current value of the GPU2D_Features_PIPE_2D field. */
#define BR_GPU2D_Features_PIPE_2D(x) (HW_GPU2D_Features(x).B.PIPE_2D)
/*@}*/

/*!
 * @name Register GPU2D_Features, field DC[23] (RO)
 *
 * Shows if there is a display controller in the IP.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_DC (23U)         /*!< Bit position for GPU2D_Features_DC. */
#define BM_GPU2D_Features_DC (0x00800000U) /*!< Bit mask for GPU2D_Features_DC. */
#define BS_GPU2D_Features_DC (1U)          /*!< Bit field size in bits for GPU2D_Features_DC. */

/*! @brief Read current value of the GPU2D_Features_DC field. */
#define BR_GPU2D_Features_DC(x) (HW_GPU2D_Features(x).B.DC)
/*@}*/

/*!
 * @name Register GPU2D_Features, field MSAA[24] (RO)
 *
 * MSAA support.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_MSAA (24U)       /*!< Bit position for GPU2D_Features_MSAA. */
#define BM_GPU2D_Features_MSAA (0x01000000U) /*!< Bit mask for GPU2D_Features_MSAA. */
#define BS_GPU2D_Features_MSAA (1U)        /*!< Bit field size in bits for GPU2D_Features_MSAA. */

/*! @brief Read current value of the GPU2D_Features_MSAA field. */
#define BR_GPU2D_Features_MSAA(x) (HW_GPU2D_Features(x).B.MSAA)
/*@}*/

/*!
 * @name Register GPU2D_Features, field YUV420_FILTER[25] (RO)
 *
 * YUV 4:2:0 support in filter blit.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_YUV420_FILTER (25U) /*!< Bit position for GPU2D_Features_YUV420_FILTER. */
#define BM_GPU2D_Features_YUV420_FILTER (0x02000000U) /*!< Bit mask for GPU2D_Features_YUV420_FILTER. */
#define BS_GPU2D_Features_YUV420_FILTER (1U) /*!< Bit field size in bits for GPU2D_Features_YUV420_FILTER. */

/*! @brief Read current value of the GPU2D_Features_YUV420_FILTER field. */
#define BR_GPU2D_Features_YUV420_FILTER(x) (HW_GPU2D_Features(x).B.YUV420_FILTER)
/*@}*/

/*!
 * @name Register GPU2D_Features, field ZCOMPRESSION[26] (RO)
 *
 * Depth and color compression.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_ZCOMPRESSION (26U) /*!< Bit position for GPU2D_Features_ZCOMPRESSION. */
#define BM_GPU2D_Features_ZCOMPRESSION (0x04000000U) /*!< Bit mask for GPU2D_Features_ZCOMPRESSION. */
#define BS_GPU2D_Features_ZCOMPRESSION (1U) /*!< Bit field size in bits for GPU2D_Features_ZCOMPRESSION. */

/*! @brief Read current value of the GPU2D_Features_ZCOMPRESSION field. */
#define BR_GPU2D_Features_ZCOMPRESSION(x) (HW_GPU2D_Features(x).B.ZCOMPRESSION)
/*@}*/

/*!
 * @name Register GPU2D_Features, field DEBUG_MODE[27] (RO)
 *
 * Debug registers.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_DEBUG_MODE (27U) /*!< Bit position for GPU2D_Features_DEBUG_MODE. */
#define BM_GPU2D_Features_DEBUG_MODE (0x08000000U) /*!< Bit mask for GPU2D_Features_DEBUG_MODE. */
#define BS_GPU2D_Features_DEBUG_MODE (1U)  /*!< Bit field size in bits for GPU2D_Features_DEBUG_MODE. */

/*! @brief Read current value of the GPU2D_Features_DEBUG_MODE field. */
#define BR_GPU2D_Features_DEBUG_MODE(x) (HW_GPU2D_Features(x).B.DEBUG_MODE)
/*@}*/

/*!
 * @name Register GPU2D_Features, field DXT_TEXTURE_COMPRESSION[28] (RO)
 *
 * DXT texture compression.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_DXT_TEXTURE_COMPRESSION (28U) /*!< Bit position for GPU2D_Features_DXT_TEXTURE_COMPRESSION. */
#define BM_GPU2D_Features_DXT_TEXTURE_COMPRESSION (0x10000000U) /*!< Bit mask for GPU2D_Features_DXT_TEXTURE_COMPRESSION. */
#define BS_GPU2D_Features_DXT_TEXTURE_COMPRESSION (1U) /*!< Bit field size in bits for GPU2D_Features_DXT_TEXTURE_COMPRESSION. */

/*! @brief Read current value of the GPU2D_Features_DXT_TEXTURE_COMPRESSION field. */
#define BR_GPU2D_Features_DXT_TEXTURE_COMPRESSION(x) (HW_GPU2D_Features(x).B.DXT_TEXTURE_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU2D_Features, field PIPE_3D[29] (RO)
 *
 * 3D pipe.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_PIPE_3D (29U)    /*!< Bit position for GPU2D_Features_PIPE_3D. */
#define BM_GPU2D_Features_PIPE_3D (0x20000000U) /*!< Bit mask for GPU2D_Features_PIPE_3D. */
#define BS_GPU2D_Features_PIPE_3D (1U)     /*!< Bit field size in bits for GPU2D_Features_PIPE_3D. */

/*! @brief Read current value of the GPU2D_Features_PIPE_3D field. */
#define BR_GPU2D_Features_PIPE_3D(x) (HW_GPU2D_Features(x).B.PIPE_3D)
/*@}*/

/*!
 * @name Register GPU2D_Features, field SPECIAL_ANTI_ALIASING[30] (RO)
 *
 * Full-screen anti-aliasing.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_SPECIAL_ANTI_ALIASING (30U) /*!< Bit position for GPU2D_Features_SPECIAL_ANTI_ALIASING. */
#define BM_GPU2D_Features_SPECIAL_ANTI_ALIASING (0x40000000U) /*!< Bit mask for GPU2D_Features_SPECIAL_ANTI_ALIASING. */
#define BS_GPU2D_Features_SPECIAL_ANTI_ALIASING (1U) /*!< Bit field size in bits for GPU2D_Features_SPECIAL_ANTI_ALIASING. */

/*! @brief Read current value of the GPU2D_Features_SPECIAL_ANTI_ALIASING field. */
#define BR_GPU2D_Features_SPECIAL_ANTI_ALIASING(x) (HW_GPU2D_Features(x).B.SPECIAL_ANTI_ALIASING)
/*@}*/

/*!
 * @name Register GPU2D_Features, field FAST_CLEAR[31] (RO)
 *
 * Fast clear.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_Features_FAST_CLEAR (31U) /*!< Bit position for GPU2D_Features_FAST_CLEAR. */
#define BM_GPU2D_Features_FAST_CLEAR (0x80000000U) /*!< Bit mask for GPU2D_Features_FAST_CLEAR. */
#define BS_GPU2D_Features_FAST_CLEAR (1U)  /*!< Bit field size in bits for GPU2D_Features_FAST_CLEAR. */

/*! @brief Read current value of the GPU2D_Features_FAST_CLEAR field. */
#define BR_GPU2D_Features_FAST_CLEAR(x) (HW_GPU2D_Features(x).B.FAST_CLEAR)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipId - Chip Identification Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipId - Chip Identification Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the ID for the chip in BCD. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu2d_chipid
{
    uint32_t U;
    struct _hw_gpu2d_chipid_bitfields
    {
        uint32_t ID : 32;              /*!< [31:0]  */
    } B;
} hw_gpu2d_chipid_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipId register
 */
/*@{*/
#define HW_GPU2D_ChipId_ADDR(x)  ((uintptr_t)(x) + 0x20U)

#define HW_GPU2D_ChipId(x)       (*(__I hw_gpu2d_chipid_t *) HW_GPU2D_ChipId_ADDR(x))
#define HW_GPU2D_ChipId_RD(x)    (HW_GPU2D_ChipId(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipId bitfields
 */

/*!
 * @name Register GPU2D_ChipId, field ID[31:0] (RO)
 *
 * Id.
 */
/*@{*/
#define BP_GPU2D_ChipId_ID   (0U)          /*!< Bit position for GPU2D_ChipId_ID. */
#define BM_GPU2D_ChipId_ID   (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ChipId_ID. */
#define BS_GPU2D_ChipId_ID   (32U)         /*!< Bit field size in bits for GPU2D_ChipId_ID. */

/*! @brief Read current value of the GPU2D_ChipId_ID field. */
#define BR_GPU2D_ChipId_ID(x) (HW_GPU2D_ChipId(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipRev - Chip Revision Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipRev - Chip Revision Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the revision for the chip in BCD. This register has no set reset value.
 * It varies with the implementation.
 */
typedef union _hw_gpu2d_chiprev
{
    uint32_t U;
    struct _hw_gpu2d_chiprev_bitfields
    {
        uint32_t REV : 32;             /*!< [31:0]  */
    } B;
} hw_gpu2d_chiprev_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipRev register
 */
/*@{*/
#define HW_GPU2D_ChipRev_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_GPU2D_ChipRev(x)      (*(__I hw_gpu2d_chiprev_t *) HW_GPU2D_ChipRev_ADDR(x))
#define HW_GPU2D_ChipRev_RD(x)   (HW_GPU2D_ChipRev(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipRev bitfields
 */

/*!
 * @name Register GPU2D_ChipRev, field REV[31:0] (RO)
 *
 * Revision.
 */
/*@{*/
#define BP_GPU2D_ChipRev_REV (0U)          /*!< Bit position for GPU2D_ChipRev_REV. */
#define BM_GPU2D_ChipRev_REV (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ChipRev_REV. */
#define BS_GPU2D_ChipRev_REV (32U)         /*!< Bit field size in bits for GPU2D_ChipRev_REV. */

/*! @brief Read current value of the GPU2D_ChipRev_REV field. */
#define BR_GPU2D_ChipRev_REV(x) (HW_GPU2D_ChipRev(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipDate - Chip Release Date Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipDate - Chip Release Date Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the release date for the IP. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu2d_chipdate
{
    uint32_t U;
    struct _hw_gpu2d_chipdate_bitfields
    {
        uint32_t DATE : 32;            /*!< [31:0]  */
    } B;
} hw_gpu2d_chipdate_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipDate register
 */
/*@{*/
#define HW_GPU2D_ChipDate_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_GPU2D_ChipDate(x)     (*(__I hw_gpu2d_chipdate_t *) HW_GPU2D_ChipDate_ADDR(x))
#define HW_GPU2D_ChipDate_RD(x)  (HW_GPU2D_ChipDate(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipDate bitfields
 */

/*!
 * @name Register GPU2D_ChipDate, field DATE[31:0] (RO)
 *
 * Date.
 */
/*@{*/
#define BP_GPU2D_ChipDate_DATE (0U)        /*!< Bit position for GPU2D_ChipDate_DATE. */
#define BM_GPU2D_ChipDate_DATE (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ChipDate_DATE. */
#define BS_GPU2D_ChipDate_DATE (32U)       /*!< Bit field size in bits for GPU2D_ChipDate_DATE. */

/*! @brief Read current value of the GPU2D_ChipDate_DATE field. */
#define BR_GPU2D_ChipDate_DATE(x) (HW_GPU2D_ChipDate(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipTime - Chip Release Time Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipTime - Chip Release Time Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the release time for the IP. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu2d_chiptime
{
    uint32_t U;
    struct _hw_gpu2d_chiptime_bitfields
    {
        uint32_t TIME : 32;            /*!< [31:0]  */
    } B;
} hw_gpu2d_chiptime_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipTime register
 */
/*@{*/
#define HW_GPU2D_ChipTime_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_GPU2D_ChipTime(x)     (*(__I hw_gpu2d_chiptime_t *) HW_GPU2D_ChipTime_ADDR(x))
#define HW_GPU2D_ChipTime_RD(x)  (HW_GPU2D_ChipTime(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipTime bitfields
 */

/*!
 * @name Register GPU2D_ChipTime, field TIME[31:0] (RO)
 *
 * Time.
 */
/*@{*/
#define BP_GPU2D_ChipTime_TIME (0U)        /*!< Bit position for GPU2D_ChipTime_TIME. */
#define BM_GPU2D_ChipTime_TIME (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ChipTime_TIME. */
#define BS_GPU2D_ChipTime_TIME (32U)       /*!< Bit field size in bits for GPU2D_ChipTime_TIME. */

/*! @brief Read current value of the GPU2D_ChipTime_TIME field. */
#define BR_GPU2D_ChipTime_TIME(x) (HW_GPU2D_ChipTime(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipCustomer - Chip Customer Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipCustomer - Chip Customer Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the customer and group for the IP. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu2d_chipcustomer
{
    uint32_t U;
    struct _hw_gpu2d_chipcustomer_bitfields
    {
        uint32_t GROUP : 16;           /*!< [15:0]  */
        uint32_t COMPANY : 16;         /*!< [31:16]  */
    } B;
} hw_gpu2d_chipcustomer_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipCustomer register
 */
/*@{*/
#define HW_GPU2D_ChipCustomer_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_GPU2D_ChipCustomer(x) (*(__I hw_gpu2d_chipcustomer_t *) HW_GPU2D_ChipCustomer_ADDR(x))
#define HW_GPU2D_ChipCustomer_RD(x) (HW_GPU2D_ChipCustomer(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipCustomer bitfields
 */

/*!
 * @name Register GPU2D_ChipCustomer, field GROUP[15:0] (RO)
 *
 * Group.
 */
/*@{*/
#define BP_GPU2D_ChipCustomer_GROUP (0U)   /*!< Bit position for GPU2D_ChipCustomer_GROUP. */
#define BM_GPU2D_ChipCustomer_GROUP (0x0000FFFFU) /*!< Bit mask for GPU2D_ChipCustomer_GROUP. */
#define BS_GPU2D_ChipCustomer_GROUP (16U)  /*!< Bit field size in bits for GPU2D_ChipCustomer_GROUP. */

/*! @brief Read current value of the GPU2D_ChipCustomer_GROUP field. */
#define BR_GPU2D_ChipCustomer_GROUP(x) (HW_GPU2D_ChipCustomer(x).B.GROUP)
/*@}*/

/*!
 * @name Register GPU2D_ChipCustomer, field COMPANY[31:16] (RO)
 *
 * Company.
 */
/*@{*/
#define BP_GPU2D_ChipCustomer_COMPANY (16U) /*!< Bit position for GPU2D_ChipCustomer_COMPANY. */
#define BM_GPU2D_ChipCustomer_COMPANY (0xFFFF0000U) /*!< Bit mask for GPU2D_ChipCustomer_COMPANY. */
#define BS_GPU2D_ChipCustomer_COMPANY (16U) /*!< Bit field size in bits for GPU2D_ChipCustomer_COMPANY. */

/*! @brief Read current value of the GPU2D_ChipCustomer_COMPANY field. */
#define BR_GPU2D_ChipCustomer_COMPANY(x) (HW_GPU2D_ChipCustomer(x).B.COMPANY)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_MinorFeatures0 - Minor Features Register 0
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_MinorFeatures0 - Minor Features Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which minor features are enabled in this chip. This register has no set
 * reset value. It varies with the implementation.
 */
typedef union _hw_gpu2d_minorfeatures0
{
    uint32_t U;
    struct _hw_gpu2d_minorfeatures0_bitfields
    {
        uint32_t FLIP_Y : 1;           /*!< [0]  */
        uint32_t DUAL_RETURN_BUS : 1;  /*!< [1]  */
        uint32_t ENDIANNESS_CONFIG : 1; /*!< [2]  */
        uint32_t TEXTURE8_K : 1;       /*!< [3]  */
        uint32_t CORRECT_TEXTURE_CONVERTER : 1; /*!< [4]  */
        uint32_t SPECIAL_MSAA_LOD : 1; /*!< [5]  */
        uint32_t FAST_CLEAR_FLUSH : 1; /*!< [6]  */
        uint32_t PE202D : 1;           /*!< [7]  */
        uint32_t CORRECT_AUTO_DISABLE : 1; /*!< [8]  */
        uint32_t RENDER_8K : 1;        /*!< [9]  */
        uint32_t TILE_STATUS_2BITS : 1; /*!< [10]  */
        uint32_t SEPARATE_TILE_STATUS_WHEN_INTERLEAVED : 1; /*!< [11]  */
        uint32_t SUPER_TILED_32X32 : 1; /*!< [12]  */
        uint32_t VG_20 : 1;            /*!< [13]  */
        uint32_t TS_EXTENDED_COMMANDS : 1; /*!< [14]  */
        uint32_t COMPRESSION_FIFO_FIXED : 1; /*!< [15]  */
        uint32_t EXTRA_SHADER_INSTRUCTIONS0 : 1; /*!< [16]  */
        uint32_t VG_FILTER : 1;        /*!< [17]  */
        uint32_t VG_21 : 1;            /*!< [18]  */
        uint32_t SHADER_GETS_W : 1;    /*!< [19]  */
        uint32_t EXTRA_SHADER_INSTRUCTIONS1 : 1; /*!< [20]  */
        uint32_t DEFAULT_REG0 : 1;     /*!< [21]  */
        uint32_t MC_20 : 1;            /*!< [22]  */
        uint32_t SHADER_MSAA_SIDEBAND : 1; /*!< [23]  */
        uint32_t BUG_FIXES0 : 1;       /*!< [24]  */
        uint32_t VAA : 1;              /*!< [25]  */
        uint32_t BYPASS_IN_MSAA : 1;   /*!< [26]  */
        uint32_t HIERARCHICAL_Z : 1;   /*!< [27]  */
        uint32_t NEW_TEXTURE : 1;      /*!< [28]  */
        uint32_t A8_TARGET_SUPPORT : 1; /*!< [29]  */
        uint32_t CORRECT_STENCIL : 1;  /*!< [30]  */
        uint32_t ENHANCE_VR : 1;       /*!< [31]  */
    } B;
} hw_gpu2d_minorfeatures0_t;

/*!
 * @name Constants and macros for entire GPU2D_MinorFeatures0 register
 */
/*@{*/
#define HW_GPU2D_MinorFeatures0_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_GPU2D_MinorFeatures0(x) (*(__I hw_gpu2d_minorfeatures0_t *) HW_GPU2D_MinorFeatures0_ADDR(x))
#define HW_GPU2D_MinorFeatures0_RD(x) (HW_GPU2D_MinorFeatures0(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_MinorFeatures0 bitfields
 */

/*!
 * @name Register GPU2D_MinorFeatures0, field FLIP_Y[0] (RO)
 *
 * Y flipping capability is added to resolve.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_FLIP_Y (0U) /*!< Bit position for GPU2D_MinorFeatures0_FLIP_Y. */
#define BM_GPU2D_MinorFeatures0_FLIP_Y (0x00000001U) /*!< Bit mask for GPU2D_MinorFeatures0_FLIP_Y. */
#define BS_GPU2D_MinorFeatures0_FLIP_Y (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_FLIP_Y. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_FLIP_Y field. */
#define BR_GPU2D_MinorFeatures0_FLIP_Y(x) (HW_GPU2D_MinorFeatures0(x).B.FLIP_Y)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field DUAL_RETURN_BUS[1] (RO)
 *
 * Dual Return Bus from HI to clients.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_DUAL_RETURN_BUS (1U) /*!< Bit position for GPU2D_MinorFeatures0_DUAL_RETURN_BUS. */
#define BM_GPU2D_MinorFeatures0_DUAL_RETURN_BUS (0x00000002U) /*!< Bit mask for GPU2D_MinorFeatures0_DUAL_RETURN_BUS. */
#define BS_GPU2D_MinorFeatures0_DUAL_RETURN_BUS (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_DUAL_RETURN_BUS. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_DUAL_RETURN_BUS field. */
#define BR_GPU2D_MinorFeatures0_DUAL_RETURN_BUS(x) (HW_GPU2D_MinorFeatures0(x).B.DUAL_RETURN_BUS)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field ENDIANNESS_CONFIG[2] (RO)
 *
 * Configurable endianness support.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_ENDIANNESS_CONFIG (2U) /*!< Bit position for GPU2D_MinorFeatures0_ENDIANNESS_CONFIG. */
#define BM_GPU2D_MinorFeatures0_ENDIANNESS_CONFIG (0x00000004U) /*!< Bit mask for GPU2D_MinorFeatures0_ENDIANNESS_CONFIG. */
#define BS_GPU2D_MinorFeatures0_ENDIANNESS_CONFIG (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_ENDIANNESS_CONFIG. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_ENDIANNESS_CONFIG field. */
#define BR_GPU2D_MinorFeatures0_ENDIANNESS_CONFIG(x) (HW_GPU2D_MinorFeatures0(x).B.ENDIANNESS_CONFIG)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field TEXTURE8_K[3] (RO)
 *
 * Supports 8Kx8K textures.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_TEXTURE8_K (3U) /*!< Bit position for GPU2D_MinorFeatures0_TEXTURE8_K. */
#define BM_GPU2D_MinorFeatures0_TEXTURE8_K (0x00000008U) /*!< Bit mask for GPU2D_MinorFeatures0_TEXTURE8_K. */
#define BS_GPU2D_MinorFeatures0_TEXTURE8_K (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_TEXTURE8_K. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_TEXTURE8_K field. */
#define BR_GPU2D_MinorFeatures0_TEXTURE8_K(x) (HW_GPU2D_MinorFeatures0(x).B.TEXTURE8_K)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field CORRECT_TEXTURE_CONVERTER[4] (RO)
 *
 * Driver hack is not needed.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER (4U) /*!< Bit position for GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER. */
#define BM_GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER (0x00000010U) /*!< Bit mask for GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER. */
#define BS_GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER field. */
#define BR_GPU2D_MinorFeatures0_CORRECT_TEXTURE_CONVERTER(x) (HW_GPU2D_MinorFeatures0(x).B.CORRECT_TEXTURE_CONVERTER)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field SPECIAL_MSAA_LOD[5] (RO)
 *
 * Special LOD calculation when MSAA is on.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD (5U) /*!< Bit position for GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD. */
#define BM_GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD (0x00000020U) /*!< Bit mask for GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD. */
#define BS_GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD field. */
#define BR_GPU2D_MinorFeatures0_SPECIAL_MSAA_LOD(x) (HW_GPU2D_MinorFeatures0(x).B.SPECIAL_MSAA_LOD)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field FAST_CLEAR_FLUSH[6] (RO)
 *
 * Proper flush is done in fast clear cache.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH (6U) /*!< Bit position for GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH. */
#define BM_GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH (0x00000040U) /*!< Bit mask for GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH. */
#define BS_GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH field. */
#define BR_GPU2D_MinorFeatures0_FAST_CLEAR_FLUSH(x) (HW_GPU2D_MinorFeatures0(x).B.FAST_CLEAR_FLUSH)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field PE202D[7] (RO)
 *
 * 2D PE 2.0 is present.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_PE202D (7U) /*!< Bit position for GPU2D_MinorFeatures0_PE202D. */
#define BM_GPU2D_MinorFeatures0_PE202D (0x00000080U) /*!< Bit mask for GPU2D_MinorFeatures0_PE202D. */
#define BS_GPU2D_MinorFeatures0_PE202D (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_PE202D. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_PE202D field. */
#define BR_GPU2D_MinorFeatures0_PE202D(x) (HW_GPU2D_MinorFeatures0(x).B.PE202D)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field CORRECT_AUTO_DISABLE[8] (RO)
 *
 * Auto disable in FC is correct.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE (8U) /*!< Bit position for GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE. */
#define BM_GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE (0x00000100U) /*!< Bit mask for GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE. */
#define BS_GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE field. */
#define BR_GPU2D_MinorFeatures0_CORRECT_AUTO_DISABLE(x) (HW_GPU2D_MinorFeatures0(x).B.CORRECT_AUTO_DISABLE)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field RENDER_8K[9] (RO)
 *
 * Supports 8K render target.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_RENDER_8K (9U) /*!< Bit position for GPU2D_MinorFeatures0_RENDER_8K. */
#define BM_GPU2D_MinorFeatures0_RENDER_8K (0x00000200U) /*!< Bit mask for GPU2D_MinorFeatures0_RENDER_8K. */
#define BS_GPU2D_MinorFeatures0_RENDER_8K (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_RENDER_8K. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_RENDER_8K field. */
#define BR_GPU2D_MinorFeatures0_RENDER_8K(x) (HW_GPU2D_MinorFeatures0(x).B.RENDER_8K)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field TILE_STATUS_2BITS[10] (RO)
 *
 * 2 bits are used instead of 4 bits for tile status.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_TILE_STATUS_2BITS (10U) /*!< Bit position for GPU2D_MinorFeatures0_TILE_STATUS_2BITS. */
#define BM_GPU2D_MinorFeatures0_TILE_STATUS_2BITS (0x00000400U) /*!< Bit mask for GPU2D_MinorFeatures0_TILE_STATUS_2BITS. */
#define BS_GPU2D_MinorFeatures0_TILE_STATUS_2BITS (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_TILE_STATUS_2BITS. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_TILE_STATUS_2BITS field. */
#define BR_GPU2D_MinorFeatures0_TILE_STATUS_2BITS(x) (HW_GPU2D_MinorFeatures0(x).B.TILE_STATUS_2BITS)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field SEPARATE_TILE_STATUS_WHEN_INTERLEAVED[11] (RO)
 *
 * Use 2 separate tile status buffers in interleaved mode.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (11U) /*!< Bit position for GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */
#define BM_GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (0x00000800U) /*!< Bit mask for GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */
#define BS_GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED field. */
#define BR_GPU2D_MinorFeatures0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED(x) (HW_GPU2D_MinorFeatures0(x).B.SEPARATE_TILE_STATUS_WHEN_INTERLEAVED)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field SUPER_TILED_32X32[12] (RO)
 *
 * 32x32 super tile is available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_SUPER_TILED_32X32 (12U) /*!< Bit position for GPU2D_MinorFeatures0_SUPER_TILED_32X32. */
#define BM_GPU2D_MinorFeatures0_SUPER_TILED_32X32 (0x00001000U) /*!< Bit mask for GPU2D_MinorFeatures0_SUPER_TILED_32X32. */
#define BS_GPU2D_MinorFeatures0_SUPER_TILED_32X32 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_SUPER_TILED_32X32. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_SUPER_TILED_32X32 field. */
#define BR_GPU2D_MinorFeatures0_SUPER_TILED_32X32(x) (HW_GPU2D_MinorFeatures0(x).B.SUPER_TILED_32X32)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field VG_20[13] (RO)
 *
 * Major updates to VG pipe (TS buffer tiling. State masking.).
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_VG_20 (13U) /*!< Bit position for GPU2D_MinorFeatures0_VG_20. */
#define BM_GPU2D_MinorFeatures0_VG_20 (0x00002000U) /*!< Bit mask for GPU2D_MinorFeatures0_VG_20. */
#define BS_GPU2D_MinorFeatures0_VG_20 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_VG_20. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_VG_20 field. */
#define BR_GPU2D_MinorFeatures0_VG_20(x) (HW_GPU2D_MinorFeatures0(x).B.VG_20)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field TS_EXTENDED_COMMANDS[14] (RO)
 *
 * New commands added to the tessellator.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS (14U) /*!< Bit position for GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS. */
#define BM_GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS (0x00004000U) /*!< Bit mask for GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS. */
#define BS_GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS field. */
#define BR_GPU2D_MinorFeatures0_TS_EXTENDED_COMMANDS(x) (HW_GPU2D_MinorFeatures0(x).B.TS_EXTENDED_COMMANDS)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field COMPRESSION_FIFO_FIXED[15] (RO)
 *
 * If this bit is not set, the FIFO counter should be set to 50. Else, the
 * default should remain.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED (15U) /*!< Bit position for GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED. */
#define BM_GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED (0x00008000U) /*!< Bit mask for GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED. */
#define BS_GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED field. */
#define BR_GPU2D_MinorFeatures0_COMPRESSION_FIFO_FIXED(x) (HW_GPU2D_MinorFeatures0(x).B.COMPRESSION_FIFO_FIXED)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field EXTRA_SHADER_INSTRUCTIONS0[16] (RO)
 *
 * Floor, ceil, and sign instructions are available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0 (16U) /*!< Bit position for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0. */
#define BM_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0 (0x00010000U) /*!< Bit mask for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0. */
#define BS_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0 field. */
#define BR_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS0(x) (HW_GPU2D_MinorFeatures0(x).B.EXTRA_SHADER_INSTRUCTIONS0)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field VG_FILTER[17] (RO)
 *
 * VG filter is available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_VG_FILTER (17U) /*!< Bit position for GPU2D_MinorFeatures0_VG_FILTER. */
#define BM_GPU2D_MinorFeatures0_VG_FILTER (0x00020000U) /*!< Bit mask for GPU2D_MinorFeatures0_VG_FILTER. */
#define BS_GPU2D_MinorFeatures0_VG_FILTER (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_VG_FILTER. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_VG_FILTER field. */
#define BR_GPU2D_MinorFeatures0_VG_FILTER(x) (HW_GPU2D_MinorFeatures0(x).B.VG_FILTER)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field VG_21[18] (RO)
 *
 * Minor updates to VG pipe (Event generation from VG, TS, PE). Tiled image
 * support.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_VG_21 (18U) /*!< Bit position for GPU2D_MinorFeatures0_VG_21. */
#define BM_GPU2D_MinorFeatures0_VG_21 (0x00040000U) /*!< Bit mask for GPU2D_MinorFeatures0_VG_21. */
#define BS_GPU2D_MinorFeatures0_VG_21 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_VG_21. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_VG_21 field. */
#define BR_GPU2D_MinorFeatures0_VG_21(x) (HW_GPU2D_MinorFeatures0(x).B.VG_21)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field SHADER_GETS_W[19] (RO)
 *
 * W is sent to SH from RA.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_SHADER_GETS_W (19U) /*!< Bit position for GPU2D_MinorFeatures0_SHADER_GETS_W. */
#define BM_GPU2D_MinorFeatures0_SHADER_GETS_W (0x00080000U) /*!< Bit mask for GPU2D_MinorFeatures0_SHADER_GETS_W. */
#define BS_GPU2D_MinorFeatures0_SHADER_GETS_W (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_SHADER_GETS_W. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_SHADER_GETS_W field. */
#define BR_GPU2D_MinorFeatures0_SHADER_GETS_W(x) (HW_GPU2D_MinorFeatures0(x).B.SHADER_GETS_W)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field EXTRA_SHADER_INSTRUCTIONS1[20] (RO)
 *
 * Sqrt, sin, cos instructions are available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1 (20U) /*!< Bit position for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1. */
#define BM_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1 (0x00100000U) /*!< Bit mask for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1. */
#define BS_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1 field. */
#define BR_GPU2D_MinorFeatures0_EXTRA_SHADER_INSTRUCTIONS1(x) (HW_GPU2D_MinorFeatures0(x).B.EXTRA_SHADER_INSTRUCTIONS1)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field DEFAULT_REG0[21] (RO)
 *
 * Unavailable registers will return 0.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_DEFAULT_REG0 (21U) /*!< Bit position for GPU2D_MinorFeatures0_DEFAULT_REG0. */
#define BM_GPU2D_MinorFeatures0_DEFAULT_REG0 (0x00200000U) /*!< Bit mask for GPU2D_MinorFeatures0_DEFAULT_REG0. */
#define BS_GPU2D_MinorFeatures0_DEFAULT_REG0 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_DEFAULT_REG0. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_DEFAULT_REG0 field. */
#define BR_GPU2D_MinorFeatures0_DEFAULT_REG0(x) (HW_GPU2D_MinorFeatures0(x).B.DEFAULT_REG0)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field MC_20[22] (RO)
 *
 * New style MC with separate paths for color and depth.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_MC_20 (22U) /*!< Bit position for GPU2D_MinorFeatures0_MC_20. */
#define BM_GPU2D_MinorFeatures0_MC_20 (0x00400000U) /*!< Bit mask for GPU2D_MinorFeatures0_MC_20. */
#define BS_GPU2D_MinorFeatures0_MC_20 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_MC_20. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_MC_20 field. */
#define BR_GPU2D_MinorFeatures0_MC_20(x) (HW_GPU2D_MinorFeatures0(x).B.MC_20)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field SHADER_MSAA_SIDEBAND[23] (RO)
 *
 * Put the MSAA data into sideband fifo.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND (23U) /*!< Bit position for GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND. */
#define BM_GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND (0x00800000U) /*!< Bit mask for GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND. */
#define BS_GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND field. */
#define BR_GPU2D_MinorFeatures0_SHADER_MSAA_SIDEBAND(x) (HW_GPU2D_MinorFeatures0(x).B.SHADER_MSAA_SIDEBAND)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field BUG_FIXES0[24] (RO)
 *
 * Bug fix bit 0
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_BUG_FIXES0 (24U) /*!< Bit position for GPU2D_MinorFeatures0_BUG_FIXES0. */
#define BM_GPU2D_MinorFeatures0_BUG_FIXES0 (0x01000000U) /*!< Bit mask for GPU2D_MinorFeatures0_BUG_FIXES0. */
#define BS_GPU2D_MinorFeatures0_BUG_FIXES0 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_BUG_FIXES0. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_BUG_FIXES0 field. */
#define BR_GPU2D_MinorFeatures0_BUG_FIXES0(x) (HW_GPU2D_MinorFeatures0(x).B.BUG_FIXES0)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field VAA[25] (RO)
 *
 * VAA is available or not.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_VAA (25U)  /*!< Bit position for GPU2D_MinorFeatures0_VAA. */
#define BM_GPU2D_MinorFeatures0_VAA (0x02000000U) /*!< Bit mask for GPU2D_MinorFeatures0_VAA. */
#define BS_GPU2D_MinorFeatures0_VAA (1U)   /*!< Bit field size in bits for GPU2D_MinorFeatures0_VAA. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_VAA field. */
#define BR_GPU2D_MinorFeatures0_VAA(x) (HW_GPU2D_MinorFeatures0(x).B.VAA)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field BYPASS_IN_MSAA[26] (RO)
 *
 * Shader supports bypass mode when MSAA is enabled.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_BYPASS_IN_MSAA (26U) /*!< Bit position for GPU2D_MinorFeatures0_BYPASS_IN_MSAA. */
#define BM_GPU2D_MinorFeatures0_BYPASS_IN_MSAA (0x04000000U) /*!< Bit mask for GPU2D_MinorFeatures0_BYPASS_IN_MSAA. */
#define BS_GPU2D_MinorFeatures0_BYPASS_IN_MSAA (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_BYPASS_IN_MSAA. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_BYPASS_IN_MSAA field. */
#define BR_GPU2D_MinorFeatures0_BYPASS_IN_MSAA(x) (HW_GPU2D_MinorFeatures0(x).B.BYPASS_IN_MSAA)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field HIERARCHICAL_Z[27] (RO)
 *
 * Hierarchiccal Z is supported.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_HIERARCHICAL_Z (27U) /*!< Bit position for GPU2D_MinorFeatures0_HIERARCHICAL_Z. */
#define BM_GPU2D_MinorFeatures0_HIERARCHICAL_Z (0x08000000U) /*!< Bit mask for GPU2D_MinorFeatures0_HIERARCHICAL_Z. */
#define BS_GPU2D_MinorFeatures0_HIERARCHICAL_Z (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_HIERARCHICAL_Z. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_HIERARCHICAL_Z field. */
#define BR_GPU2D_MinorFeatures0_HIERARCHICAL_Z(x) (HW_GPU2D_MinorFeatures0(x).B.HIERARCHICAL_Z)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field NEW_TEXTURE[28] (RO)
 *
 * New texture unit is available.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_NEW_TEXTURE (28U) /*!< Bit position for GPU2D_MinorFeatures0_NEW_TEXTURE. */
#define BM_GPU2D_MinorFeatures0_NEW_TEXTURE (0x10000000U) /*!< Bit mask for GPU2D_MinorFeatures0_NEW_TEXTURE. */
#define BS_GPU2D_MinorFeatures0_NEW_TEXTURE (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_NEW_TEXTURE. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_NEW_TEXTURE field. */
#define BR_GPU2D_MinorFeatures0_NEW_TEXTURE(x) (HW_GPU2D_MinorFeatures0(x).B.NEW_TEXTURE)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field A8_TARGET_SUPPORT[29] (RO)
 *
 * 2D engine supports A8 target.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_A8_TARGET_SUPPORT (29U) /*!< Bit position for GPU2D_MinorFeatures0_A8_TARGET_SUPPORT. */
#define BM_GPU2D_MinorFeatures0_A8_TARGET_SUPPORT (0x20000000U) /*!< Bit mask for GPU2D_MinorFeatures0_A8_TARGET_SUPPORT. */
#define BS_GPU2D_MinorFeatures0_A8_TARGET_SUPPORT (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_A8_TARGET_SUPPORT. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_A8_TARGET_SUPPORT field. */
#define BR_GPU2D_MinorFeatures0_A8_TARGET_SUPPORT(x) (HW_GPU2D_MinorFeatures0(x).B.A8_TARGET_SUPPORT)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field CORRECT_STENCIL[30] (RO)
 *
 * Correct stencil behavior in depth only.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_CORRECT_STENCIL (30U) /*!< Bit position for GPU2D_MinorFeatures0_CORRECT_STENCIL. */
#define BM_GPU2D_MinorFeatures0_CORRECT_STENCIL (0x40000000U) /*!< Bit mask for GPU2D_MinorFeatures0_CORRECT_STENCIL. */
#define BS_GPU2D_MinorFeatures0_CORRECT_STENCIL (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_CORRECT_STENCIL. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_CORRECT_STENCIL field. */
#define BR_GPU2D_MinorFeatures0_CORRECT_STENCIL(x) (HW_GPU2D_MinorFeatures0(x).B.CORRECT_STENCIL)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures0, field ENHANCE_VR[31] (RO)
 *
 * Enhance VR and add a mode to walk 16 pixels in 16-bit mode in Vertical pass
 * to improve $ hit rate when rotating 90/270.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures0_ENHANCE_VR (31U) /*!< Bit position for GPU2D_MinorFeatures0_ENHANCE_VR. */
#define BM_GPU2D_MinorFeatures0_ENHANCE_VR (0x80000000U) /*!< Bit mask for GPU2D_MinorFeatures0_ENHANCE_VR. */
#define BS_GPU2D_MinorFeatures0_ENHANCE_VR (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures0_ENHANCE_VR. */

/*! @brief Read current value of the GPU2D_MinorFeatures0_ENHANCE_VR field. */
#define BR_GPU2D_MinorFeatures0_ENHANCE_VR(x) (HW_GPU2D_MinorFeatures0(x).B.ENHANCE_VR)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_CacheControl - Cache Control Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_CacheControl - Cache Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpu2d_cachecontrol
{
    uint32_t U;
    struct _hw_gpu2d_cachecontrol_bitfields
    {
        uint32_t NOT_USED : 32;        /*!< [31:0]  */
    } B;
} hw_gpu2d_cachecontrol_t;

/*!
 * @name Constants and macros for entire GPU2D_CacheControl register
 */
/*@{*/
#define HW_GPU2D_CacheControl_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_GPU2D_CacheControl(x) (*(__IO hw_gpu2d_cachecontrol_t *) HW_GPU2D_CacheControl_ADDR(x))
#define HW_GPU2D_CacheControl_RD(x) (HW_GPU2D_CacheControl(x).U)
#define HW_GPU2D_CacheControl_WR(x, v) (HW_GPU2D_CacheControl(x).U = (v))
#define HW_GPU2D_CacheControl_SET(x, v) (HW_GPU2D_CacheControl_WR(x, HW_GPU2D_CacheControl_RD(x) |  (v)))
#define HW_GPU2D_CacheControl_CLR(x, v) (HW_GPU2D_CacheControl_WR(x, HW_GPU2D_CacheControl_RD(x) & ~(v)))
#define HW_GPU2D_CacheControl_TOG(x, v) (HW_GPU2D_CacheControl_WR(x, HW_GPU2D_CacheControl_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_CacheControl bitfields
 */

/*!
 * @name Register GPU2D_CacheControl, field NOT_USED[31:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_GPU2D_CacheControl_NOT_USED (0U) /*!< Bit position for GPU2D_CacheControl_NOT_USED. */
#define BM_GPU2D_CacheControl_NOT_USED (0xFFFFFFFFU) /*!< Bit mask for GPU2D_CacheControl_NOT_USED. */
#define BS_GPU2D_CacheControl_NOT_USED (32U) /*!< Bit field size in bits for GPU2D_CacheControl_NOT_USED. */

/*! @brief Read current value of the GPU2D_CacheControl_NOT_USED field. */
#define BR_GPU2D_CacheControl_NOT_USED(x) (HW_GPU2D_CacheControl(x).U)

/*! @brief Format value for bitfield GPU2D_CacheControl_NOT_USED. */
#define BF_GPU2D_CacheControl_NOT_USED(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_CacheControl_NOT_USED) & BM_GPU2D_CacheControl_NOT_USED)

/*! @brief Set the NOT_USED field to a new value. */
#define BW_GPU2D_CacheControl_NOT_USED(x, v) (HW_GPU2D_CacheControl_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ResetMemCounters - Reset Mem Counters Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ResetMemCounters - Reset Mem Counters Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * Writing 1 will reset the counters and stop counting. Write 0 to start
 * counting again. This register is write only so it has no reset value.
 */
typedef union _hw_gpu2d_resetmemcounters
{
    uint32_t U;
    struct _hw_gpu2d_resetmemcounters_bitfields
    {
        uint32_t RESET : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_resetmemcounters_t;

/*!
 * @name Constants and macros for entire GPU2D_ResetMemCounters register
 */
/*@{*/
#define HW_GPU2D_ResetMemCounters_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_GPU2D_ResetMemCounters(x) (*(__O hw_gpu2d_resetmemcounters_t *) HW_GPU2D_ResetMemCounters_ADDR(x))
#define HW_GPU2D_ResetMemCounters_WR(x, v) (HW_GPU2D_ResetMemCounters(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual GPU2D_ResetMemCounters bitfields
 */

/*!
 * @name Register GPU2D_ResetMemCounters, field RESET[31:0] (WO)
 *
 * Reset
 */
/*@{*/
#define BP_GPU2D_ResetMemCounters_RESET (0U) /*!< Bit position for GPU2D_ResetMemCounters_RESET. */
#define BM_GPU2D_ResetMemCounters_RESET (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ResetMemCounters_RESET. */
#define BS_GPU2D_ResetMemCounters_RESET (32U) /*!< Bit field size in bits for GPU2D_ResetMemCounters_RESET. */

/*! @brief Format value for bitfield GPU2D_ResetMemCounters_RESET. */
#define BF_GPU2D_ResetMemCounters_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ResetMemCounters_RESET) & BM_GPU2D_ResetMemCounters_RESET)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalReads - Read Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalReads - Read Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total reads in terms of 64bits.
 */
typedef union _hw_gpu2d_totalreads
{
    uint32_t U;
    struct _hw_gpu2d_totalreads_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalreads_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalReads register
 */
/*@{*/
#define HW_GPU2D_TotalReads_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_GPU2D_TotalReads(x)   (*(__I hw_gpu2d_totalreads_t *) HW_GPU2D_TotalReads_ADDR(x))
#define HW_GPU2D_TotalReads_RD(x) (HW_GPU2D_TotalReads(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalReads bitfields
 */

/*!
 * @name Register GPU2D_TotalReads, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalReads_COUNT (0U)     /*!< Bit position for GPU2D_TotalReads_COUNT. */
#define BM_GPU2D_TotalReads_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalReads_COUNT. */
#define BS_GPU2D_TotalReads_COUNT (32U)    /*!< Bit field size in bits for GPU2D_TotalReads_COUNT. */

/*! @brief Read current value of the GPU2D_TotalReads_COUNT field. */
#define BR_GPU2D_TotalReads_COUNT(x) (HW_GPU2D_TotalReads(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalWrites - Write Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalWrites - Write Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total writes in terms of 64bits.
 */
typedef union _hw_gpu2d_totalwrites
{
    uint32_t U;
    struct _hw_gpu2d_totalwrites_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalwrites_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalWrites register
 */
/*@{*/
#define HW_GPU2D_TotalWrites_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_GPU2D_TotalWrites(x)  (*(__I hw_gpu2d_totalwrites_t *) HW_GPU2D_TotalWrites_ADDR(x))
#define HW_GPU2D_TotalWrites_RD(x) (HW_GPU2D_TotalWrites(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalWrites bitfields
 */

/*!
 * @name Register GPU2D_TotalWrites, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalWrites_COUNT (0U)    /*!< Bit position for GPU2D_TotalWrites_COUNT. */
#define BM_GPU2D_TotalWrites_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalWrites_COUNT. */
#define BS_GPU2D_TotalWrites_COUNT (32U)   /*!< Bit field size in bits for GPU2D_TotalWrites_COUNT. */

/*! @brief Read current value of the GPU2D_TotalWrites_COUNT field. */
#define BR_GPU2D_TotalWrites_COUNT(x) (HW_GPU2D_TotalWrites(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipSpecs - Chip Specification Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipSpecs - Chip Specification Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Specs for the chip. This register has no set reset value. It varies with the
 * implementation.
 */
typedef union _hw_gpu2d_chipspecs
{
    uint32_t U;
    struct _hw_gpu2d_chipspecs_bitfields
    {
        uint32_t VERTEX_OUTPUT_BUFFER_SIZE : 4; /*!< [3:0]  */
        uint32_t NUM_PIXEL_PIPES : 3;  /*!< [6:4]  */
        uint32_t NUM_SHADER_CORES : 5; /*!< [11:7]  */
        uint32_t RESERVED0 : 3;        /*!< [14:12]  */
        uint32_t VERTEX_CACHE_SIZE : 5; /*!< [19:15]  */
        uint32_t THREAD_COUNT : 4;     /*!< [23:20]  */
        uint32_t TEMP_REGISTERS : 4;   /*!< [27:24]  */
        uint32_t STREAMS : 4;          /*!< [31:28]  */
    } B;
} hw_gpu2d_chipspecs_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipSpecs register
 */
/*@{*/
#define HW_GPU2D_ChipSpecs_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_GPU2D_ChipSpecs(x)    (*(__I hw_gpu2d_chipspecs_t *) HW_GPU2D_ChipSpecs_ADDR(x))
#define HW_GPU2D_ChipSpecs_RD(x) (HW_GPU2D_ChipSpecs(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipSpecs bitfields
 */

/*!
 * @name Register GPU2D_ChipSpecs, field VERTEX_OUTPUT_BUFFER_SIZE[3:0] (RO)
 *
 * Log2 of vertex output buffer size.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE (0U) /*!< Bit position for GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE. */
#define BM_GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE (0x0000000FU) /*!< Bit mask for GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE. */
#define BS_GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE (4U) /*!< Bit field size in bits for GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE. */

/*! @brief Read current value of the GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE field. */
#define BR_GPU2D_ChipSpecs_VERTEX_OUTPUT_BUFFER_SIZE(x) (HW_GPU2D_ChipSpecs(x).B.VERTEX_OUTPUT_BUFFER_SIZE)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field NUM_PIXEL_PIPES[6:4] (RO)
 *
 * Number of pixel pipes.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_NUM_PIXEL_PIPES (4U) /*!< Bit position for GPU2D_ChipSpecs_NUM_PIXEL_PIPES. */
#define BM_GPU2D_ChipSpecs_NUM_PIXEL_PIPES (0x00000070U) /*!< Bit mask for GPU2D_ChipSpecs_NUM_PIXEL_PIPES. */
#define BS_GPU2D_ChipSpecs_NUM_PIXEL_PIPES (3U) /*!< Bit field size in bits for GPU2D_ChipSpecs_NUM_PIXEL_PIPES. */

/*! @brief Read current value of the GPU2D_ChipSpecs_NUM_PIXEL_PIPES field. */
#define BR_GPU2D_ChipSpecs_NUM_PIXEL_PIPES(x) (HW_GPU2D_ChipSpecs(x).B.NUM_PIXEL_PIPES)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field NUM_SHADER_CORES[11:7] (RO)
 *
 * Number of shader cores.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_NUM_SHADER_CORES (7U) /*!< Bit position for GPU2D_ChipSpecs_NUM_SHADER_CORES. */
#define BM_GPU2D_ChipSpecs_NUM_SHADER_CORES (0x00000F80U) /*!< Bit mask for GPU2D_ChipSpecs_NUM_SHADER_CORES. */
#define BS_GPU2D_ChipSpecs_NUM_SHADER_CORES (5U) /*!< Bit field size in bits for GPU2D_ChipSpecs_NUM_SHADER_CORES. */

/*! @brief Read current value of the GPU2D_ChipSpecs_NUM_SHADER_CORES field. */
#define BR_GPU2D_ChipSpecs_NUM_SHADER_CORES(x) (HW_GPU2D_ChipSpecs(x).B.NUM_SHADER_CORES)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field VERTEX_CACHE_SIZE[19:15] (RO)
 *
 * Number of entries in the vertex shader cache.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_VERTEX_CACHE_SIZE (15U) /*!< Bit position for GPU2D_ChipSpecs_VERTEX_CACHE_SIZE. */
#define BM_GPU2D_ChipSpecs_VERTEX_CACHE_SIZE (0x000F8000U) /*!< Bit mask for GPU2D_ChipSpecs_VERTEX_CACHE_SIZE. */
#define BS_GPU2D_ChipSpecs_VERTEX_CACHE_SIZE (5U) /*!< Bit field size in bits for GPU2D_ChipSpecs_VERTEX_CACHE_SIZE. */

/*! @brief Read current value of the GPU2D_ChipSpecs_VERTEX_CACHE_SIZE field. */
#define BR_GPU2D_ChipSpecs_VERTEX_CACHE_SIZE(x) (HW_GPU2D_ChipSpecs(x).B.VERTEX_CACHE_SIZE)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field THREAD_COUNT[23:20] (RO)
 *
 * Log2 of thread count.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_THREAD_COUNT (20U) /*!< Bit position for GPU2D_ChipSpecs_THREAD_COUNT. */
#define BM_GPU2D_ChipSpecs_THREAD_COUNT (0x00F00000U) /*!< Bit mask for GPU2D_ChipSpecs_THREAD_COUNT. */
#define BS_GPU2D_ChipSpecs_THREAD_COUNT (4U) /*!< Bit field size in bits for GPU2D_ChipSpecs_THREAD_COUNT. */

/*! @brief Read current value of the GPU2D_ChipSpecs_THREAD_COUNT field. */
#define BR_GPU2D_ChipSpecs_THREAD_COUNT(x) (HW_GPU2D_ChipSpecs(x).B.THREAD_COUNT)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field TEMP_REGISTERS[27:24] (RO)
 *
 * Log2 of temporary registers.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_TEMP_REGISTERS (24U) /*!< Bit position for GPU2D_ChipSpecs_TEMP_REGISTERS. */
#define BM_GPU2D_ChipSpecs_TEMP_REGISTERS (0x0F000000U) /*!< Bit mask for GPU2D_ChipSpecs_TEMP_REGISTERS. */
#define BS_GPU2D_ChipSpecs_TEMP_REGISTERS (4U) /*!< Bit field size in bits for GPU2D_ChipSpecs_TEMP_REGISTERS. */

/*! @brief Read current value of the GPU2D_ChipSpecs_TEMP_REGISTERS field. */
#define BR_GPU2D_ChipSpecs_TEMP_REGISTERS(x) (HW_GPU2D_ChipSpecs(x).B.TEMP_REGISTERS)
/*@}*/

/*!
 * @name Register GPU2D_ChipSpecs, field STREAMS[31:28] (RO)
 *
 * Number of vertex streams.
 */
/*@{*/
#define BP_GPU2D_ChipSpecs_STREAMS (28U)   /*!< Bit position for GPU2D_ChipSpecs_STREAMS. */
#define BM_GPU2D_ChipSpecs_STREAMS (0xF0000000U) /*!< Bit mask for GPU2D_ChipSpecs_STREAMS. */
#define BS_GPU2D_ChipSpecs_STREAMS (4U)    /*!< Bit field size in bits for GPU2D_ChipSpecs_STREAMS. */

/*! @brief Read current value of the GPU2D_ChipSpecs_STREAMS field. */
#define BR_GPU2D_ChipSpecs_STREAMS(x) (HW_GPU2D_ChipSpecs(x).B.STREAMS)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalWriteBursts - Write Data Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalWriteBursts - Write Data Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total write Data Count in terms of 64bits. This register has no reset value.
 */
typedef union _hw_gpu2d_totalwritebursts
{
    uint32_t U;
    struct _hw_gpu2d_totalwritebursts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalwritebursts_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalWriteBursts register
 */
/*@{*/
#define HW_GPU2D_TotalWriteBursts_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_GPU2D_TotalWriteBursts(x) (*(__I hw_gpu2d_totalwritebursts_t *) HW_GPU2D_TotalWriteBursts_ADDR(x))
#define HW_GPU2D_TotalWriteBursts_RD(x) (HW_GPU2D_TotalWriteBursts(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalWriteBursts bitfields
 */

/*!
 * @name Register GPU2D_TotalWriteBursts, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalWriteBursts_COUNT (0U) /*!< Bit position for GPU2D_TotalWriteBursts_COUNT. */
#define BM_GPU2D_TotalWriteBursts_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalWriteBursts_COUNT. */
#define BS_GPU2D_TotalWriteBursts_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalWriteBursts_COUNT. */

/*! @brief Read current value of the GPU2D_TotalWriteBursts_COUNT field. */
#define BR_GPU2D_TotalWriteBursts_COUNT(x) (HW_GPU2D_TotalWriteBursts(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalWriteReqs - Write REQ Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalWriteReqs - Write REQ Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total write Request Count. This register has no reset value.
 */
typedef union _hw_gpu2d_totalwritereqs
{
    uint32_t U;
    struct _hw_gpu2d_totalwritereqs_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalwritereqs_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalWriteReqs register
 */
/*@{*/
#define HW_GPU2D_TotalWriteReqs_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_GPU2D_TotalWriteReqs(x) (*(__I hw_gpu2d_totalwritereqs_t *) HW_GPU2D_TotalWriteReqs_ADDR(x))
#define HW_GPU2D_TotalWriteReqs_RD(x) (HW_GPU2D_TotalWriteReqs(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalWriteReqs bitfields
 */

/*!
 * @name Register GPU2D_TotalWriteReqs, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalWriteReqs_COUNT (0U) /*!< Bit position for GPU2D_TotalWriteReqs_COUNT. */
#define BM_GPU2D_TotalWriteReqs_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalWriteReqs_COUNT. */
#define BS_GPU2D_TotalWriteReqs_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalWriteReqs_COUNT. */

/*! @brief Read current value of the GPU2D_TotalWriteReqs_COUNT field. */
#define BR_GPU2D_TotalWriteReqs_COUNT(x) (HW_GPU2D_TotalWriteReqs(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalWriteLasts - Total WLAST Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalWriteLasts - Total WLAST Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total WLAST Count. This is used to match with GCTotalWriteReqs. This register
 * has no reset value.
 */
typedef union _hw_gpu2d_totalwritelasts
{
    uint32_t U;
    struct _hw_gpu2d_totalwritelasts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalwritelasts_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalWriteLasts register
 */
/*@{*/
#define HW_GPU2D_TotalWriteLasts_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_GPU2D_TotalWriteLasts(x) (*(__I hw_gpu2d_totalwritelasts_t *) HW_GPU2D_TotalWriteLasts_ADDR(x))
#define HW_GPU2D_TotalWriteLasts_RD(x) (HW_GPU2D_TotalWriteLasts(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalWriteLasts bitfields
 */

/*!
 * @name Register GPU2D_TotalWriteLasts, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalWriteLasts_COUNT (0U) /*!< Bit position for GPU2D_TotalWriteLasts_COUNT. */
#define BM_GPU2D_TotalWriteLasts_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalWriteLasts_COUNT. */
#define BS_GPU2D_TotalWriteLasts_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalWriteLasts_COUNT. */

/*! @brief Read current value of the GPU2D_TotalWriteLasts_COUNT field. */
#define BR_GPU2D_TotalWriteLasts_COUNT(x) (HW_GPU2D_TotalWriteLasts(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalReadBursts - Total Read Data Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalReadBursts - Total Read Data Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total Read Data Count in terms of 64bits. This register has no reset value.
 */
typedef union _hw_gpu2d_totalreadbursts
{
    uint32_t U;
    struct _hw_gpu2d_totalreadbursts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalreadbursts_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalReadBursts register
 */
/*@{*/
#define HW_GPU2D_TotalReadBursts_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_GPU2D_TotalReadBursts(x) (*(__I hw_gpu2d_totalreadbursts_t *) HW_GPU2D_TotalReadBursts_ADDR(x))
#define HW_GPU2D_TotalReadBursts_RD(x) (HW_GPU2D_TotalReadBursts(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalReadBursts bitfields
 */

/*!
 * @name Register GPU2D_TotalReadBursts, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalReadBursts_COUNT (0U) /*!< Bit position for GPU2D_TotalReadBursts_COUNT. */
#define BM_GPU2D_TotalReadBursts_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalReadBursts_COUNT. */
#define BS_GPU2D_TotalReadBursts_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalReadBursts_COUNT. */

/*! @brief Read current value of the GPU2D_TotalReadBursts_COUNT field. */
#define BR_GPU2D_TotalReadBursts_COUNT(x) (HW_GPU2D_TotalReadBursts(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalReadReqs - Total Read REQ Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalReadReqs - Total Read REQ Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total Read Request Count. This register has no reset value.
 */
typedef union _hw_gpu2d_totalreadreqs
{
    uint32_t U;
    struct _hw_gpu2d_totalreadreqs_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalreadreqs_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalReadReqs register
 */
/*@{*/
#define HW_GPU2D_TotalReadReqs_ADDR(x) ((uintptr_t)(x) + 0x5CU)

#define HW_GPU2D_TotalReadReqs(x) (*(__I hw_gpu2d_totalreadreqs_t *) HW_GPU2D_TotalReadReqs_ADDR(x))
#define HW_GPU2D_TotalReadReqs_RD(x) (HW_GPU2D_TotalReadReqs(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalReadReqs bitfields
 */

/*!
 * @name Register GPU2D_TotalReadReqs, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalReadReqs_COUNT (0U)  /*!< Bit position for GPU2D_TotalReadReqs_COUNT. */
#define BM_GPU2D_TotalReadReqs_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalReadReqs_COUNT. */
#define BS_GPU2D_TotalReadReqs_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalReadReqs_COUNT. */

/*! @brief Read current value of the GPU2D_TotalReadReqs_COUNT field. */
#define BR_GPU2D_TotalReadReqs_COUNT(x) (HW_GPU2D_TotalReadReqs(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalReadLasts - Total RLAST Count Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalReadLasts - Total RLAST Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total RLAST Count. This is used to match with GCTotalReadReqs. This register
 * has no reset value.
 */
typedef union _hw_gpu2d_totalreadlasts
{
    uint32_t U;
    struct _hw_gpu2d_totalreadlasts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_totalreadlasts_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalReadLasts register
 */
/*@{*/
#define HW_GPU2D_TotalReadLasts_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_GPU2D_TotalReadLasts(x) (*(__I hw_gpu2d_totalreadlasts_t *) HW_GPU2D_TotalReadLasts_ADDR(x))
#define HW_GPU2D_TotalReadLasts_RD(x) (HW_GPU2D_TotalReadLasts(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalReadLasts bitfields
 */

/*!
 * @name Register GPU2D_TotalReadLasts, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_TotalReadLasts_COUNT (0U) /*!< Bit position for GPU2D_TotalReadLasts_COUNT. */
#define BM_GPU2D_TotalReadLasts_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalReadLasts_COUNT. */
#define BS_GPU2D_TotalReadLasts_COUNT (32U) /*!< Bit field size in bits for GPU2D_TotalReadLasts_COUNT. */

/*! @brief Read current value of the GPU2D_TotalReadLasts_COUNT field. */
#define BR_GPU2D_TotalReadLasts_COUNT(x) (HW_GPU2D_TotalReadLasts(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_GpOut0 - General Purpose Register 0
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_GpOut0 - General Purpose Register 0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register0. R/W but not connected to anywhere
 */
typedef union _hw_gpu2d_gpout0
{
    uint32_t U;
    struct _hw_gpu2d_gpout0_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_gpout0_t;

/*!
 * @name Constants and macros for entire GPU2D_GpOut0 register
 */
/*@{*/
#define HW_GPU2D_GpOut0_ADDR(x)  ((uintptr_t)(x) + 0x64U)

#define HW_GPU2D_GpOut0(x)       (*(__IO hw_gpu2d_gpout0_t *) HW_GPU2D_GpOut0_ADDR(x))
#define HW_GPU2D_GpOut0_RD(x)    (HW_GPU2D_GpOut0(x).U)
#define HW_GPU2D_GpOut0_WR(x, v) (HW_GPU2D_GpOut0(x).U = (v))
#define HW_GPU2D_GpOut0_SET(x, v) (HW_GPU2D_GpOut0_WR(x, HW_GPU2D_GpOut0_RD(x) |  (v)))
#define HW_GPU2D_GpOut0_CLR(x, v) (HW_GPU2D_GpOut0_WR(x, HW_GPU2D_GpOut0_RD(x) & ~(v)))
#define HW_GPU2D_GpOut0_TOG(x, v) (HW_GPU2D_GpOut0_WR(x, HW_GPU2D_GpOut0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_GpOut0 bitfields
 */

/*!
 * @name Register GPU2D_GpOut0, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_GpOut0_COUNT (0U)         /*!< Bit position for GPU2D_GpOut0_COUNT. */
#define BM_GPU2D_GpOut0_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_GpOut0_COUNT. */
#define BS_GPU2D_GpOut0_COUNT (32U)        /*!< Bit field size in bits for GPU2D_GpOut0_COUNT. */

/*! @brief Read current value of the GPU2D_GpOut0_COUNT field. */
#define BR_GPU2D_GpOut0_COUNT(x) (HW_GPU2D_GpOut0(x).U)

/*! @brief Format value for bitfield GPU2D_GpOut0_COUNT. */
#define BF_GPU2D_GpOut0_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_GpOut0_COUNT) & BM_GPU2D_GpOut0_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU2D_GpOut0_COUNT(x, v) (HW_GPU2D_GpOut0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_GpOut1 - General Purpose Register 1
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_GpOut1 - General Purpose Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register1. R/W but not connected to anywhere
 */
typedef union _hw_gpu2d_gpout1
{
    uint32_t U;
    struct _hw_gpu2d_gpout1_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_gpout1_t;

/*!
 * @name Constants and macros for entire GPU2D_GpOut1 register
 */
/*@{*/
#define HW_GPU2D_GpOut1_ADDR(x)  ((uintptr_t)(x) + 0x68U)

#define HW_GPU2D_GpOut1(x)       (*(__IO hw_gpu2d_gpout1_t *) HW_GPU2D_GpOut1_ADDR(x))
#define HW_GPU2D_GpOut1_RD(x)    (HW_GPU2D_GpOut1(x).U)
#define HW_GPU2D_GpOut1_WR(x, v) (HW_GPU2D_GpOut1(x).U = (v))
#define HW_GPU2D_GpOut1_SET(x, v) (HW_GPU2D_GpOut1_WR(x, HW_GPU2D_GpOut1_RD(x) |  (v)))
#define HW_GPU2D_GpOut1_CLR(x, v) (HW_GPU2D_GpOut1_WR(x, HW_GPU2D_GpOut1_RD(x) & ~(v)))
#define HW_GPU2D_GpOut1_TOG(x, v) (HW_GPU2D_GpOut1_WR(x, HW_GPU2D_GpOut1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_GpOut1 bitfields
 */

/*!
 * @name Register GPU2D_GpOut1, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_GpOut1_COUNT (0U)         /*!< Bit position for GPU2D_GpOut1_COUNT. */
#define BM_GPU2D_GpOut1_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_GpOut1_COUNT. */
#define BS_GPU2D_GpOut1_COUNT (32U)        /*!< Bit field size in bits for GPU2D_GpOut1_COUNT. */

/*! @brief Read current value of the GPU2D_GpOut1_COUNT field. */
#define BR_GPU2D_GpOut1_COUNT(x) (HW_GPU2D_GpOut1(x).U)

/*! @brief Format value for bitfield GPU2D_GpOut1_COUNT. */
#define BF_GPU2D_GpOut1_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_GpOut1_COUNT) & BM_GPU2D_GpOut1_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU2D_GpOut1_COUNT(x, v) (HW_GPU2D_GpOut1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_GpOut2 - General Purpose Register 2
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_GpOut2 - General Purpose Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register2. R/W but not connected to anywhere
 */
typedef union _hw_gpu2d_gpout2
{
    uint32_t U;
    struct _hw_gpu2d_gpout2_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu2d_gpout2_t;

/*!
 * @name Constants and macros for entire GPU2D_GpOut2 register
 */
/*@{*/
#define HW_GPU2D_GpOut2_ADDR(x)  ((uintptr_t)(x) + 0x6CU)

#define HW_GPU2D_GpOut2(x)       (*(__IO hw_gpu2d_gpout2_t *) HW_GPU2D_GpOut2_ADDR(x))
#define HW_GPU2D_GpOut2_RD(x)    (HW_GPU2D_GpOut2(x).U)
#define HW_GPU2D_GpOut2_WR(x, v) (HW_GPU2D_GpOut2(x).U = (v))
#define HW_GPU2D_GpOut2_SET(x, v) (HW_GPU2D_GpOut2_WR(x, HW_GPU2D_GpOut2_RD(x) |  (v)))
#define HW_GPU2D_GpOut2_CLR(x, v) (HW_GPU2D_GpOut2_WR(x, HW_GPU2D_GpOut2_RD(x) & ~(v)))
#define HW_GPU2D_GpOut2_TOG(x, v) (HW_GPU2D_GpOut2_WR(x, HW_GPU2D_GpOut2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_GpOut2 bitfields
 */

/*!
 * @name Register GPU2D_GpOut2, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU2D_GpOut2_COUNT (0U)         /*!< Bit position for GPU2D_GpOut2_COUNT. */
#define BM_GPU2D_GpOut2_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU2D_GpOut2_COUNT. */
#define BS_GPU2D_GpOut2_COUNT (32U)        /*!< Bit field size in bits for GPU2D_GpOut2_COUNT. */

/*! @brief Read current value of the GPU2D_GpOut2_COUNT field. */
#define BR_GPU2D_GpOut2_COUNT(x) (HW_GPU2D_GpOut2(x).U)

/*! @brief Format value for bitfield GPU2D_GpOut2_COUNT. */
#define BF_GPU2D_GpOut2_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_GpOut2_COUNT) & BM_GPU2D_GpOut2_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU2D_GpOut2_COUNT(x, v) (HW_GPU2D_GpOut2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_AxiControl - AXI Control Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_AxiControl - AXI Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Special Handling on AXI Bus
 */
typedef union _hw_gpu2d_axicontrol
{
    uint32_t U;
    struct _hw_gpu2d_axicontrol_bitfields
    {
        uint32_t WR_FULL_BURST_MODE : 32; /*!< [31:0]  */
    } B;
} hw_gpu2d_axicontrol_t;

/*!
 * @name Constants and macros for entire GPU2D_AxiControl register
 */
/*@{*/
#define HW_GPU2D_AxiControl_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_GPU2D_AxiControl(x)   (*(__IO hw_gpu2d_axicontrol_t *) HW_GPU2D_AxiControl_ADDR(x))
#define HW_GPU2D_AxiControl_RD(x) (HW_GPU2D_AxiControl(x).U)
#define HW_GPU2D_AxiControl_WR(x, v) (HW_GPU2D_AxiControl(x).U = (v))
#define HW_GPU2D_AxiControl_SET(x, v) (HW_GPU2D_AxiControl_WR(x, HW_GPU2D_AxiControl_RD(x) |  (v)))
#define HW_GPU2D_AxiControl_CLR(x, v) (HW_GPU2D_AxiControl_WR(x, HW_GPU2D_AxiControl_RD(x) & ~(v)))
#define HW_GPU2D_AxiControl_TOG(x, v) (HW_GPU2D_AxiControl_WR(x, HW_GPU2D_AxiControl_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_AxiControl bitfields
 */

/*!
 * @name Register GPU2D_AxiControl, field WR_FULL_BURST_MODE[31:0] (RW)
 *
 * WR_FULL_BURST_MODE
 *
 * Values:
 * - 0 - NO_BURST_RESET_VALUE
 * - 1 - BURST_RESET_VALUE
 */
/*@{*/
#define BP_GPU2D_AxiControl_WR_FULL_BURST_MODE (0U) /*!< Bit position for GPU2D_AxiControl_WR_FULL_BURST_MODE. */
#define BM_GPU2D_AxiControl_WR_FULL_BURST_MODE (0xFFFFFFFFU) /*!< Bit mask for GPU2D_AxiControl_WR_FULL_BURST_MODE. */
#define BS_GPU2D_AxiControl_WR_FULL_BURST_MODE (32U) /*!< Bit field size in bits for GPU2D_AxiControl_WR_FULL_BURST_MODE. */

/*! @brief Read current value of the GPU2D_AxiControl_WR_FULL_BURST_MODE field. */
#define BR_GPU2D_AxiControl_WR_FULL_BURST_MODE(x) (HW_GPU2D_AxiControl(x).U)

/*! @brief Format value for bitfield GPU2D_AxiControl_WR_FULL_BURST_MODE. */
#define BF_GPU2D_AxiControl_WR_FULL_BURST_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_AxiControl_WR_FULL_BURST_MODE) & BM_GPU2D_AxiControl_WR_FULL_BURST_MODE)

/*! @brief Set the WR_FULL_BURST_MODE field to a new value. */
#define BW_GPU2D_AxiControl_WR_FULL_BURST_MODE(x, v) (HW_GPU2D_AxiControl_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_MinorFeatures1 - Minor Features Register 1
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_MinorFeatures1 - Minor Features Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which features are enabled in this chip. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu2d_minorfeatures1
{
    uint32_t U;
    struct _hw_gpu2d_minorfeatures1_bitfields
    {
        uint32_t RESERVED0 : 26;       /*!< [25:0]  */
        uint32_t TEXTURE_STRIDE : 1;   /*!< [26]  */
        uint32_t BUG_FIXES2 : 1;       /*!< [27]  */
        uint32_t BUG_FIXES1 : 1;       /*!< [28]  */
        uint32_t VG_DOUBLE_BUFFER : 1; /*!< [29]  */
        uint32_t V2_COMPRESSION : 1;   /*!< [30]  */
        uint32_t RSUV_SWIZZLE : 1;     /*!< [31]  */
    } B;
} hw_gpu2d_minorfeatures1_t;

/*!
 * @name Constants and macros for entire GPU2D_MinorFeatures1 register
 */
/*@{*/
#define HW_GPU2D_MinorFeatures1_ADDR(x) ((uintptr_t)(x) + 0x74U)

#define HW_GPU2D_MinorFeatures1(x) (*(__I hw_gpu2d_minorfeatures1_t *) HW_GPU2D_MinorFeatures1_ADDR(x))
#define HW_GPU2D_MinorFeatures1_RD(x) (HW_GPU2D_MinorFeatures1(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_MinorFeatures1 bitfields
 */

/*!
 * @name Register GPU2D_MinorFeatures1, field TEXTURE_STRIDE[26] (RO)
 *
 * Texture has stride and memory addressing.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_TEXTURE_STRIDE (26U) /*!< Bit position for GPU2D_MinorFeatures1_TEXTURE_STRIDE. */
#define BM_GPU2D_MinorFeatures1_TEXTURE_STRIDE (0x04000000U) /*!< Bit mask for GPU2D_MinorFeatures1_TEXTURE_STRIDE. */
#define BS_GPU2D_MinorFeatures1_TEXTURE_STRIDE (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_TEXTURE_STRIDE. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_TEXTURE_STRIDE field. */
#define BR_GPU2D_MinorFeatures1_TEXTURE_STRIDE(x) (HW_GPU2D_MinorFeatures1(x).B.TEXTURE_STRIDE)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures1, field BUG_FIXES2[27] (RO)
 *
 * Bug fixes bit 2
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_BUG_FIXES2 (27U) /*!< Bit position for GPU2D_MinorFeatures1_BUG_FIXES2. */
#define BM_GPU2D_MinorFeatures1_BUG_FIXES2 (0x08000000U) /*!< Bit mask for GPU2D_MinorFeatures1_BUG_FIXES2. */
#define BS_GPU2D_MinorFeatures1_BUG_FIXES2 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_BUG_FIXES2. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_BUG_FIXES2 field. */
#define BR_GPU2D_MinorFeatures1_BUG_FIXES2(x) (HW_GPU2D_MinorFeatures1(x).B.BUG_FIXES2)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures1, field BUG_FIXES1[28] (RO)
 *
 * Bug fixes bit 1
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_BUG_FIXES1 (28U) /*!< Bit position for GPU2D_MinorFeatures1_BUG_FIXES1. */
#define BM_GPU2D_MinorFeatures1_BUG_FIXES1 (0x10000000U) /*!< Bit mask for GPU2D_MinorFeatures1_BUG_FIXES1. */
#define BS_GPU2D_MinorFeatures1_BUG_FIXES1 (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_BUG_FIXES1. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_BUG_FIXES1 field. */
#define BR_GPU2D_MinorFeatures1_BUG_FIXES1(x) (HW_GPU2D_MinorFeatures1(x).B.BUG_FIXES1)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures1, field VG_DOUBLE_BUFFER[29] (RO)
 *
 * Double buffering support for VG (second TS-->VG semaphore is present).
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER (29U) /*!< Bit position for GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER. */
#define BM_GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER (0x20000000U) /*!< Bit mask for GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER. */
#define BS_GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER field. */
#define BR_GPU2D_MinorFeatures1_VG_DOUBLE_BUFFER(x) (HW_GPU2D_MinorFeatures1(x).B.VG_DOUBLE_BUFFER)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures1, field V2_COMPRESSION[30] (RO)
 *
 * V2 compression.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_V2_COMPRESSION (30U) /*!< Bit position for GPU2D_MinorFeatures1_V2_COMPRESSION. */
#define BM_GPU2D_MinorFeatures1_V2_COMPRESSION (0x40000000U) /*!< Bit mask for GPU2D_MinorFeatures1_V2_COMPRESSION. */
#define BS_GPU2D_MinorFeatures1_V2_COMPRESSION (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_V2_COMPRESSION. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_V2_COMPRESSION field. */
#define BR_GPU2D_MinorFeatures1_V2_COMPRESSION(x) (HW_GPU2D_MinorFeatures1(x).B.V2_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU2D_MinorFeatures1, field RSUV_SWIZZLE[31] (RO)
 *
 * Resolve UV swizzle.
 *
 * Values:
 * - 0 - NONE
 * - 1 - AVAILABLE
 */
/*@{*/
#define BP_GPU2D_MinorFeatures1_RSUV_SWIZZLE (31U) /*!< Bit position for GPU2D_MinorFeatures1_RSUV_SWIZZLE. */
#define BM_GPU2D_MinorFeatures1_RSUV_SWIZZLE (0x80000000U) /*!< Bit mask for GPU2D_MinorFeatures1_RSUV_SWIZZLE. */
#define BS_GPU2D_MinorFeatures1_RSUV_SWIZZLE (1U) /*!< Bit field size in bits for GPU2D_MinorFeatures1_RSUV_SWIZZLE. */

/*! @brief Read current value of the GPU2D_MinorFeatures1_RSUV_SWIZZLE field. */
#define BR_GPU2D_MinorFeatures1_RSUV_SWIZZLE(x) (HW_GPU2D_MinorFeatures1(x).B.RSUV_SWIZZLE)
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalCycles - Total Cycle Counter Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalCycles - Total Cycle Counter Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Total cycles. This register is a free running counter. It can be reset by
 * writing 0 to it.
 */
typedef union _hw_gpu2d_totalcycles
{
    uint32_t U;
    struct _hw_gpu2d_totalcycles_bitfields
    {
        uint32_t CYCLES : 32;          /*!< [31:0]  */
    } B;
} hw_gpu2d_totalcycles_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalCycles register
 */
/*@{*/
#define HW_GPU2D_TotalCycles_ADDR(x) ((uintptr_t)(x) + 0x78U)

#define HW_GPU2D_TotalCycles(x)  (*(__IO hw_gpu2d_totalcycles_t *) HW_GPU2D_TotalCycles_ADDR(x))
#define HW_GPU2D_TotalCycles_RD(x) (HW_GPU2D_TotalCycles(x).U)
#define HW_GPU2D_TotalCycles_WR(x, v) (HW_GPU2D_TotalCycles(x).U = (v))
#define HW_GPU2D_TotalCycles_SET(x, v) (HW_GPU2D_TotalCycles_WR(x, HW_GPU2D_TotalCycles_RD(x) |  (v)))
#define HW_GPU2D_TotalCycles_CLR(x, v) (HW_GPU2D_TotalCycles_WR(x, HW_GPU2D_TotalCycles_RD(x) & ~(v)))
#define HW_GPU2D_TotalCycles_TOG(x, v) (HW_GPU2D_TotalCycles_WR(x, HW_GPU2D_TotalCycles_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalCycles bitfields
 */

/*!
 * @name Register GPU2D_TotalCycles, field CYCLES[31:0] (RW)
 *
 * Total cycles
 */
/*@{*/
#define BP_GPU2D_TotalCycles_CYCLES (0U)   /*!< Bit position for GPU2D_TotalCycles_CYCLES. */
#define BM_GPU2D_TotalCycles_CYCLES (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalCycles_CYCLES. */
#define BS_GPU2D_TotalCycles_CYCLES (32U)  /*!< Bit field size in bits for GPU2D_TotalCycles_CYCLES. */

/*! @brief Read current value of the GPU2D_TotalCycles_CYCLES field. */
#define BR_GPU2D_TotalCycles_CYCLES(x) (HW_GPU2D_TotalCycles(x).U)

/*! @brief Format value for bitfield GPU2D_TotalCycles_CYCLES. */
#define BF_GPU2D_TotalCycles_CYCLES(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_TotalCycles_CYCLES) & BM_GPU2D_TotalCycles_CYCLES)

/*! @brief Set the CYCLES field to a new value. */
#define BW_GPU2D_TotalCycles_CYCLES(x, v) (HW_GPU2D_TotalCycles_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_TotalIdleCyles - Total Idle Cycle Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_TotalIdleCyles - Total Idle Cycle Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Total cycles where the GPU is idle. It is reset when gcTotalCycles register
 * is written to. It looks at all the blocks but FE when determining the IP is
 * idle.
 */
typedef union _hw_gpu2d_totalidlecyles
{
    uint32_t U;
    struct _hw_gpu2d_totalidlecyles_bitfields
    {
        uint32_t CYCLES : 32;          /*!< [31:0]  */
    } B;
} hw_gpu2d_totalidlecyles_t;

/*!
 * @name Constants and macros for entire GPU2D_TotalIdleCyles register
 */
/*@{*/
#define HW_GPU2D_TotalIdleCyles_ADDR(x) ((uintptr_t)(x) + 0x7CU)

#define HW_GPU2D_TotalIdleCyles(x) (*(__IO hw_gpu2d_totalidlecyles_t *) HW_GPU2D_TotalIdleCyles_ADDR(x))
#define HW_GPU2D_TotalIdleCyles_RD(x) (HW_GPU2D_TotalIdleCyles(x).U)
#define HW_GPU2D_TotalIdleCyles_WR(x, v) (HW_GPU2D_TotalIdleCyles(x).U = (v))
#define HW_GPU2D_TotalIdleCyles_SET(x, v) (HW_GPU2D_TotalIdleCyles_WR(x, HW_GPU2D_TotalIdleCyles_RD(x) |  (v)))
#define HW_GPU2D_TotalIdleCyles_CLR(x, v) (HW_GPU2D_TotalIdleCyles_WR(x, HW_GPU2D_TotalIdleCyles_RD(x) & ~(v)))
#define HW_GPU2D_TotalIdleCyles_TOG(x, v) (HW_GPU2D_TotalIdleCyles_WR(x, HW_GPU2D_TotalIdleCyles_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_TotalIdleCyles bitfields
 */

/*!
 * @name Register GPU2D_TotalIdleCyles, field CYCLES[31:0] (RW)
 *
 * Total cycles
 */
/*@{*/
#define BP_GPU2D_TotalIdleCyles_CYCLES (0U) /*!< Bit position for GPU2D_TotalIdleCyles_CYCLES. */
#define BM_GPU2D_TotalIdleCyles_CYCLES (0xFFFFFFFFU) /*!< Bit mask for GPU2D_TotalIdleCyles_CYCLES. */
#define BS_GPU2D_TotalIdleCyles_CYCLES (32U) /*!< Bit field size in bits for GPU2D_TotalIdleCyles_CYCLES. */

/*! @brief Read current value of the GPU2D_TotalIdleCyles_CYCLES field. */
#define BR_GPU2D_TotalIdleCyles_CYCLES(x) (HW_GPU2D_TotalIdleCyles(x).U)

/*! @brief Format value for bitfield GPU2D_TotalIdleCyles_CYCLES. */
#define BF_GPU2D_TotalIdleCyles_CYCLES(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_TotalIdleCyles_CYCLES) & BM_GPU2D_TotalIdleCyles_CYCLES)

/*! @brief Set the CYCLES field to a new value. */
#define BW_GPU2D_TotalIdleCyles_CYCLES(x, v) (HW_GPU2D_TotalIdleCyles_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ChipSpecs2 - Chip Specification Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ChipSpecs2 - Chip Specification Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Specs for the chip. This register has no reset value. It varies with the
 * implementation.
 */
typedef union _hw_gpu2d_chipspecs2
{
    uint32_t U;
    struct _hw_gpu2d_chipspecs2_bitfields
    {
        uint32_t CYCLES : 32;          /*!< [31:0]  */
    } B;
} hw_gpu2d_chipspecs2_t;

/*!
 * @name Constants and macros for entire GPU2D_ChipSpecs2 register
 */
/*@{*/
#define HW_GPU2D_ChipSpecs2_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_GPU2D_ChipSpecs2(x)   (*(__IO hw_gpu2d_chipspecs2_t *) HW_GPU2D_ChipSpecs2_ADDR(x))
#define HW_GPU2D_ChipSpecs2_RD(x) (HW_GPU2D_ChipSpecs2(x).U)
#define HW_GPU2D_ChipSpecs2_WR(x, v) (HW_GPU2D_ChipSpecs2(x).U = (v))
#define HW_GPU2D_ChipSpecs2_SET(x, v) (HW_GPU2D_ChipSpecs2_WR(x, HW_GPU2D_ChipSpecs2_RD(x) |  (v)))
#define HW_GPU2D_ChipSpecs2_CLR(x, v) (HW_GPU2D_ChipSpecs2_WR(x, HW_GPU2D_ChipSpecs2_RD(x) & ~(v)))
#define HW_GPU2D_ChipSpecs2_TOG(x, v) (HW_GPU2D_ChipSpecs2_WR(x, HW_GPU2D_ChipSpecs2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_ChipSpecs2 bitfields
 */

/*!
 * @name Register GPU2D_ChipSpecs2, field CYCLES[31:0] (RW)
 *
 * Total cycles
 */
/*@{*/
#define BP_GPU2D_ChipSpecs2_CYCLES (0U)    /*!< Bit position for GPU2D_ChipSpecs2_CYCLES. */
#define BM_GPU2D_ChipSpecs2_CYCLES (0xFFFFFFFFU) /*!< Bit mask for GPU2D_ChipSpecs2_CYCLES. */
#define BS_GPU2D_ChipSpecs2_CYCLES (32U)   /*!< Bit field size in bits for GPU2D_ChipSpecs2_CYCLES. */

/*! @brief Read current value of the GPU2D_ChipSpecs2_CYCLES field. */
#define BR_GPU2D_ChipSpecs2_CYCLES(x) (HW_GPU2D_ChipSpecs2(x).U)

/*! @brief Format value for bitfield GPU2D_ChipSpecs2_CYCLES. */
#define BF_GPU2D_ChipSpecs2_CYCLES(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ChipSpecs2_CYCLES) & BM_GPU2D_ChipSpecs2_CYCLES)

/*! @brief Set the CYCLES field to a new value. */
#define BW_GPU2D_ChipSpecs2_CYCLES(x, v) (HW_GPU2D_ChipSpecs2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ModulePowerControls - Power Control Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ModulePowerControls - Power Control Register (RW)
 *
 * Reset value: 0x00140020U
 *
 * The Power Management register set has just a few registers for controlling
 * clock gating within the core. GC400 allows the user to control the clock gating
 * of each internal module independently of the other modules. Users can access
 * all of these registers via the AHB Bus. Control register for module level power
 * controls.
 */
typedef union _hw_gpu2d_modulepowercontrols
{
    uint32_t U;
    struct _hw_gpu2d_modulepowercontrols_bitfields
    {
        uint32_t TURN_OFF_COUNTER : 16; /*!< [15:0]  */
        uint32_t RESERVED0 : 8;        /*!< [23:16]  */
        uint32_t TURN_ON_COUNTER : 4;  /*!< [27:24]  */
        uint32_t RESERVED1 : 1;        /*!< [28]  */
        uint32_t DISABLE_STARVE_MODULE_CLOCK_GATING : 1; /*!< [29]  */
        uint32_t DISABLE_STALL_MODULE_CLOCK_GATING : 1; /*!< [30]  */
        uint32_t ENABLE_MODULE_CLOCK_GATING : 1; /*!< [31]  */
    } B;
} hw_gpu2d_modulepowercontrols_t;

/*!
 * @name Constants and macros for entire GPU2D_ModulePowerControls register
 */
/*@{*/
#define HW_GPU2D_ModulePowerControls_ADDR(x) ((uintptr_t)(x) + 0x84U)

#define HW_GPU2D_ModulePowerControls(x) (*(__IO hw_gpu2d_modulepowercontrols_t *) HW_GPU2D_ModulePowerControls_ADDR(x))
#define HW_GPU2D_ModulePowerControls_RD(x) (HW_GPU2D_ModulePowerControls(x).U)
#define HW_GPU2D_ModulePowerControls_WR(x, v) (HW_GPU2D_ModulePowerControls(x).U = (v))
#define HW_GPU2D_ModulePowerControls_SET(x, v) (HW_GPU2D_ModulePowerControls_WR(x, HW_GPU2D_ModulePowerControls_RD(x) |  (v)))
#define HW_GPU2D_ModulePowerControls_CLR(x, v) (HW_GPU2D_ModulePowerControls_WR(x, HW_GPU2D_ModulePowerControls_RD(x) & ~(v)))
#define HW_GPU2D_ModulePowerControls_TOG(x, v) (HW_GPU2D_ModulePowerControls_WR(x, HW_GPU2D_ModulePowerControls_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_ModulePowerControls bitfields
 */

/*!
 * @name Register GPU2D_ModulePowerControls, field TURN_OFF_COUNTER[15:0] (RW)
 *
 * Counter value for clock gating the module if the module is idle for this
 * amount of clock cycles.
 */
/*@{*/
#define BP_GPU2D_ModulePowerControls_TURN_OFF_COUNTER (0U) /*!< Bit position for GPU2D_ModulePowerControls_TURN_OFF_COUNTER. */
#define BM_GPU2D_ModulePowerControls_TURN_OFF_COUNTER (0x0000FFFFU) /*!< Bit mask for GPU2D_ModulePowerControls_TURN_OFF_COUNTER. */
#define BS_GPU2D_ModulePowerControls_TURN_OFF_COUNTER (16U) /*!< Bit field size in bits for GPU2D_ModulePowerControls_TURN_OFF_COUNTER. */

/*! @brief Read current value of the GPU2D_ModulePowerControls_TURN_OFF_COUNTER field. */
#define BR_GPU2D_ModulePowerControls_TURN_OFF_COUNTER(x) (HW_GPU2D_ModulePowerControls(x).B.TURN_OFF_COUNTER)

/*! @brief Format value for bitfield GPU2D_ModulePowerControls_TURN_OFF_COUNTER. */
#define BF_GPU2D_ModulePowerControls_TURN_OFF_COUNTER(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerControls_TURN_OFF_COUNTER) & BM_GPU2D_ModulePowerControls_TURN_OFF_COUNTER)

/*! @brief Set the TURN_OFF_COUNTER field to a new value. */
#define BW_GPU2D_ModulePowerControls_TURN_OFF_COUNTER(x, v) (HW_GPU2D_ModulePowerControls_WR(x, (HW_GPU2D_ModulePowerControls_RD(x) & ~BM_GPU2D_ModulePowerControls_TURN_OFF_COUNTER) | BF_GPU2D_ModulePowerControls_TURN_OFF_COUNTER(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerControls, field TURN_ON_COUNTER[27:24] (RW)
 *
 * Number of clock cycles to wait after turning on the clock.
 */
/*@{*/
#define BP_GPU2D_ModulePowerControls_TURN_ON_COUNTER (24U) /*!< Bit position for GPU2D_ModulePowerControls_TURN_ON_COUNTER. */
#define BM_GPU2D_ModulePowerControls_TURN_ON_COUNTER (0x0F000000U) /*!< Bit mask for GPU2D_ModulePowerControls_TURN_ON_COUNTER. */
#define BS_GPU2D_ModulePowerControls_TURN_ON_COUNTER (4U) /*!< Bit field size in bits for GPU2D_ModulePowerControls_TURN_ON_COUNTER. */

/*! @brief Read current value of the GPU2D_ModulePowerControls_TURN_ON_COUNTER field. */
#define BR_GPU2D_ModulePowerControls_TURN_ON_COUNTER(x) (HW_GPU2D_ModulePowerControls(x).B.TURN_ON_COUNTER)

/*! @brief Format value for bitfield GPU2D_ModulePowerControls_TURN_ON_COUNTER. */
#define BF_GPU2D_ModulePowerControls_TURN_ON_COUNTER(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerControls_TURN_ON_COUNTER) & BM_GPU2D_ModulePowerControls_TURN_ON_COUNTER)

/*! @brief Set the TURN_ON_COUNTER field to a new value. */
#define BW_GPU2D_ModulePowerControls_TURN_ON_COUNTER(x, v) (HW_GPU2D_ModulePowerControls_WR(x, (HW_GPU2D_ModulePowerControls_RD(x) & ~BM_GPU2D_ModulePowerControls_TURN_ON_COUNTER) | BF_GPU2D_ModulePowerControls_TURN_ON_COUNTER(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerControls, field DISABLE_STARVE_MODULE_CLOCK_GATING[29] (RW)
 *
 * Disables module level clock gating for starve/idle condition.
 */
/*@{*/
#define BP_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING (29U) /*!< Bit position for GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING. */
#define BM_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING (0x20000000U) /*!< Bit mask for GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING. */
#define BS_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING (1U) /*!< Bit field size in bits for GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING. */

/*! @brief Read current value of the GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING field. */
#define BR_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING(x) (HW_GPU2D_ModulePowerControls(x).B.DISABLE_STARVE_MODULE_CLOCK_GATING)

/*! @brief Format value for bitfield GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING. */
#define BF_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING) & BM_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING)

/*! @brief Set the DISABLE_STARVE_MODULE_CLOCK_GATING field to a new value. */
#define BW_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING(x, v) (HW_GPU2D_ModulePowerControls_WR(x, (HW_GPU2D_ModulePowerControls_RD(x) & ~BM_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING) | BF_GPU2D_ModulePowerControls_DISABLE_STARVE_MODULE_CLOCK_GATING(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerControls, field DISABLE_STALL_MODULE_CLOCK_GATING[30] (RW)
 *
 * Disables module level clock gating for stall condition.
 */
/*@{*/
#define BP_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING (30U) /*!< Bit position for GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING. */
#define BM_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING (0x40000000U) /*!< Bit mask for GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING. */
#define BS_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING (1U) /*!< Bit field size in bits for GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING. */

/*! @brief Read current value of the GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING field. */
#define BR_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING(x) (HW_GPU2D_ModulePowerControls(x).B.DISABLE_STALL_MODULE_CLOCK_GATING)

/*! @brief Format value for bitfield GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING. */
#define BF_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING) & BM_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING)

/*! @brief Set the DISABLE_STALL_MODULE_CLOCK_GATING field to a new value. */
#define BW_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING(x, v) (HW_GPU2D_ModulePowerControls_WR(x, (HW_GPU2D_ModulePowerControls_RD(x) & ~BM_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING) | BF_GPU2D_ModulePowerControls_DISABLE_STALL_MODULE_CLOCK_GATING(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerControls, field ENABLE_MODULE_CLOCK_GATING[31] (RW)
 *
 * Enables module level clock gating.
 */
/*@{*/
#define BP_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING (31U) /*!< Bit position for GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING. */
#define BM_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING (0x80000000U) /*!< Bit mask for GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING. */
#define BS_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING (1U) /*!< Bit field size in bits for GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING. */

/*! @brief Read current value of the GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING field. */
#define BR_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING(x) (HW_GPU2D_ModulePowerControls(x).B.ENABLE_MODULE_CLOCK_GATING)

/*! @brief Format value for bitfield GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING. */
#define BF_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING) & BM_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING)

/*! @brief Set the ENABLE_MODULE_CLOCK_GATING field to a new value. */
#define BW_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING(x, v) (HW_GPU2D_ModulePowerControls_WR(x, (HW_GPU2D_ModulePowerControls_RD(x) & ~BM_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING) | BF_GPU2D_ModulePowerControls_ENABLE_MODULE_CLOCK_GATING(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ModulePowerModuleControl - Power Level Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ModulePowerModuleControl - Power Level Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Module level control registers.
 */
typedef union _hw_gpu2d_modulepowermodulecontrol
{
    uint32_t U;
    struct _hw_gpu2d_modulepowermodulecontrol_bitfields
    {
        uint32_t RESERVED0 : 20;       /*!< [19:0]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_TS : 1; /*!< [20]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_FP : 1; /*!< [21]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_IM : 1; /*!< [22]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_VG : 1; /*!< [23]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_TX : 1; /*!< [24]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_RA : 1; /*!< [25]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_SE : 1; /*!< [26]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_PA : 1; /*!< [27]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_SH : 1; /*!< [28]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_PE : 1; /*!< [29]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_DE : 1; /*!< [30]  */
        uint32_t DISABLE_MODULE_CLOCK_GATING_FE : 1; /*!< [31]  */
    } B;
} hw_gpu2d_modulepowermodulecontrol_t;

/*!
 * @name Constants and macros for entire GPU2D_ModulePowerModuleControl register
 */
/*@{*/
#define HW_GPU2D_ModulePowerModuleControl_ADDR(x) ((uintptr_t)(x) + 0x88U)

#define HW_GPU2D_ModulePowerModuleControl(x) (*(__IO hw_gpu2d_modulepowermodulecontrol_t *) HW_GPU2D_ModulePowerModuleControl_ADDR(x))
#define HW_GPU2D_ModulePowerModuleControl_RD(x) (HW_GPU2D_ModulePowerModuleControl(x).U)
#define HW_GPU2D_ModulePowerModuleControl_WR(x, v) (HW_GPU2D_ModulePowerModuleControl(x).U = (v))
#define HW_GPU2D_ModulePowerModuleControl_SET(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, HW_GPU2D_ModulePowerModuleControl_RD(x) |  (v)))
#define HW_GPU2D_ModulePowerModuleControl_CLR(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, HW_GPU2D_ModulePowerModuleControl_RD(x) & ~(v)))
#define HW_GPU2D_ModulePowerModuleControl_TOG(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, HW_GPU2D_ModulePowerModuleControl_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU2D_ModulePowerModuleControl bitfields
 */

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_TS[20] (RW)
 *
 * Disables module level clock gating for TS.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS (20U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS (0x00100000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_TS)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_TS field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TS(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_FP[21] (RW)
 *
 * Disables module level clock gating for FP.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP (21U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP (0x00200000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_FP)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_FP field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FP(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_IM[22] (RW)
 *
 * Disables module level clock gating for IM.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM (22U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM (0x00400000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_IM)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_IM field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_IM(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_VG[23] (RW)
 *
 * Disables module level clock gating for VG.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG (23U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG (0x00800000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_VG)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_VG field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_VG(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_TX[24] (RW)
 *
 * Disables module level clock gating for TX.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX (24U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX (0x01000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_TX)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_TX field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_TX(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_RA[25] (RW)
 *
 * Disables module level clock gating for RA.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA (25U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA (0x02000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_RA)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_RA field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_RA(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_SE[26] (RW)
 *
 * Disables module level clock gating for SE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE (26U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE (0x04000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_SE)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_SE field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SE(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_PA[27] (RW)
 *
 * Disables module level clock gating for PA.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA (27U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA (0x08000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_PA)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_PA field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PA(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_SH[28] (RW)
 *
 * Disables module level clock gating for SH.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH (28U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH (0x10000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_SH)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_SH field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_SH(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_PE[29] (RW)
 *
 * Disables module level clock gating for PE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE (29U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE (0x20000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_PE)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_PE field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_PE(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_DE[30] (RW)
 *
 * Disables module level clock gating for DE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE (30U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE (0x40000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_DE)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_DE field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_DE(v)))
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleControl, field DISABLE_MODULE_CLOCK_GATING_FE[31] (RW)
 *
 * Disables module level clock gating for FE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE (31U) /*!< Bit position for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE. */
#define BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE (0x80000000U) /*!< Bit mask for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE. */
#define BS_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE field. */
#define BR_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE(x) (HW_GPU2D_ModulePowerModuleControl(x).B.DISABLE_MODULE_CLOCK_GATING_FE)

/*! @brief Format value for bitfield GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE. */
#define BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE(v) ((uint32_t)((uint32_t)(v) << BP_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE) & BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE)

/*! @brief Set the DISABLE_MODULE_CLOCK_GATING_FE field to a new value. */
#define BW_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE(x, v) (HW_GPU2D_ModulePowerModuleControl_WR(x, (HW_GPU2D_ModulePowerModuleControl_RD(x) & ~BM_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE) | BF_GPU2D_ModulePowerModuleControl_DISABLE_MODULE_CLOCK_GATING_FE(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU2D_ModulePowerModuleStatus - Power Status Register
 ******************************************************************************/

/*!
 * @brief HW_GPU2D_ModulePowerModuleStatus - Power Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Module level control status.
 */
typedef union _hw_gpu2d_modulepowermodulestatus
{
    uint32_t U;
    struct _hw_gpu2d_modulepowermodulestatus_bitfields
    {
        uint32_t RESERVED0 : 20;       /*!< [19:0]  */
        uint32_t MODULE_CLOCK_GATED_TS : 1; /*!< [20]  */
        uint32_t MODULE_CLOCK_GATED_FP : 1; /*!< [21]  */
        uint32_t MODULE_CLOCK_GATED_IM : 1; /*!< [22]  */
        uint32_t MODULE_CLOCK_GATED_VG : 1; /*!< [23]  */
        uint32_t MODULE_CLOCK_GATED_TX : 1; /*!< [24]  */
        uint32_t MODULE_CLOCK_GATED_RA : 1; /*!< [25]  */
        uint32_t MODULE_CLOCK_GATED_SE : 1; /*!< [26]  */
        uint32_t MODULE_CLOCK_GATED_PA : 1; /*!< [27]  */
        uint32_t MODULE_CLOCK_GATED_SH : 1; /*!< [28]  */
        uint32_t MODULE_CLOCK_GATED_PE : 1; /*!< [29]  */
        uint32_t MODULE_CLOCK_GATED_DE : 1; /*!< [30]  */
        uint32_t MODULE_CLOCK_GATED_FE : 1; /*!< [31]  */
    } B;
} hw_gpu2d_modulepowermodulestatus_t;

/*!
 * @name Constants and macros for entire GPU2D_ModulePowerModuleStatus register
 */
/*@{*/
#define HW_GPU2D_ModulePowerModuleStatus_ADDR(x) ((uintptr_t)(x) + 0x8CU)

#define HW_GPU2D_ModulePowerModuleStatus(x) (*(__I hw_gpu2d_modulepowermodulestatus_t *) HW_GPU2D_ModulePowerModuleStatus_ADDR(x))
#define HW_GPU2D_ModulePowerModuleStatus_RD(x) (HW_GPU2D_ModulePowerModuleStatus(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU2D_ModulePowerModuleStatus bitfields
 */

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_TS[20] (RO)
 *
 * Module level clock gating is ON for TS.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS (20U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS (0x00100000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TS(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_TS)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_FP[21] (RO)
 *
 * Module level clock gating is ON for FP.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP (21U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP (0x00200000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FP(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_FP)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_IM[22] (RO)
 *
 * Module level clock gating is ON for IM.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM (22U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM (0x00400000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_IM(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_IM)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_VG[23] (RO)
 *
 * Module level clock gating is ON for VG.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG (23U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG (0x00800000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_VG(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_VG)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_TX[24] (RO)
 *
 * Module level clock gating is ON for TX.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX (24U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX (0x01000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_TX(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_TX)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_RA[25] (RO)
 *
 * Module level clock gating is ON for RA.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA (25U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA (0x02000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_RA(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_RA)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_SE[26] (RO)
 *
 * Module level clock gating is ON for SE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE (26U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE (0x04000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SE(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_SE)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_PA[27] (RO)
 *
 * Module level clock gating is ON for PA.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA (27U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA (0x08000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PA(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_PA)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_SH[28] (RO)
 *
 * Module level clock gating is ON for SH.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH (28U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH (0x10000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_SH(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_SH)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_PE[29] (RO)
 *
 * Module level clock gating is ON for PE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE (29U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE (0x20000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_PE(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_PE)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_DE[30] (RO)
 *
 * Module level clock gating is ON for DE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE (30U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE (0x40000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_DE(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_DE)
/*@}*/

/*!
 * @name Register GPU2D_ModulePowerModuleStatus, field MODULE_CLOCK_GATED_FE[31] (RO)
 *
 * Module level clock gating is ON for FE.
 */
/*@{*/
#define BP_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE (31U) /*!< Bit position for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE. */
#define BM_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE (0x80000000U) /*!< Bit mask for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE. */
#define BS_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE (1U) /*!< Bit field size in bits for GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE. */

/*! @brief Read current value of the GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE field. */
#define BR_GPU2D_ModulePowerModuleStatus_MODULE_CLOCK_GATED_FE(x) (HW_GPU2D_ModulePowerModuleStatus(x).B.MODULE_CLOCK_GATED_FE)
/*@}*/

/*******************************************************************************
 * hw_gpu2d_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPU2D module registers.
 */
#pragma pack(1)
typedef struct _hw_gpu2d
{
    __IO hw_gpu2d_aqhiclockcontrol_t AQHiClockControl; /*!< [0x0] Clock Control Register */
    __I hw_gpu2d_aqhiidle_t AQHiIdle;      /*!< [0x4] Idle Status Register */
    __IO hw_gpu2d_aqaxiconfig_t AQAxiConfig; /*!< [0x8] AXI Configuration Register */
    __IO hw_gpu2d_aqaxistatus_t AQAxiStatus; /*!< [0xC] AXI Status Register */
    __I hw_gpu2d_aqintracknowledge_t AQIntrAcknowledge; /*!< [0x10] Interrupt Acknowledge Register */
    __IO hw_gpu2d_aqintrenbl_t AQIntrEnbl; /*!< [0x14] Interrupt Enable Register */
    __I hw_gpu2d_aqident_t AQIdent;        /*!< [0x18] Identification Register */
    __I hw_gpu2d_features_t Features;      /*!< [0x1C] Features Register */
    __I hw_gpu2d_chipid_t ChipId;          /*!< [0x20] Chip Identification Register */
    __I hw_gpu2d_chiprev_t ChipRev;        /*!< [0x24] Chip Revision Register */
    __I hw_gpu2d_chipdate_t ChipDate;      /*!< [0x28] Chip Release Date Register */
    __I hw_gpu2d_chiptime_t ChipTime;      /*!< [0x2C] Chip Release Time Register */
    __I hw_gpu2d_chipcustomer_t ChipCustomer; /*!< [0x30] Chip Customer Register */
    __I hw_gpu2d_minorfeatures0_t MinorFeatures0; /*!< [0x34] Minor Features Register 0 */
    __IO hw_gpu2d_cachecontrol_t CacheControl; /*!< [0x38] Cache Control Register */
    __O hw_gpu2d_resetmemcounters_t ResetMemCounters; /*!< [0x3C] Reset Mem Counters Register */
    __I hw_gpu2d_totalreads_t TotalReads;  /*!< [0x40] Read Count Register */
    __I hw_gpu2d_totalwrites_t TotalWrites; /*!< [0x44] Write Count Register */
    __I hw_gpu2d_chipspecs_t ChipSpecs;    /*!< [0x48] Chip Specification Register */
    __I hw_gpu2d_totalwritebursts_t TotalWriteBursts; /*!< [0x4C] Write Data Count Register */
    __I hw_gpu2d_totalwritereqs_t TotalWriteReqs; /*!< [0x50] Write REQ Count Register */
    __I hw_gpu2d_totalwritelasts_t TotalWriteLasts; /*!< [0x54] Total WLAST Count Register */
    __I hw_gpu2d_totalreadbursts_t TotalReadBursts; /*!< [0x58] Total Read Data Count Register */
    __I hw_gpu2d_totalreadreqs_t TotalReadReqs; /*!< [0x5C] Total Read REQ Count Register */
    __I hw_gpu2d_totalreadlasts_t TotalReadLasts; /*!< [0x60] Total RLAST Count Register */
    __IO hw_gpu2d_gpout0_t GpOut0;         /*!< [0x64] General Purpose Register 0 */
    __IO hw_gpu2d_gpout1_t GpOut1;         /*!< [0x68] General Purpose Register 1 */
    __IO hw_gpu2d_gpout2_t GpOut2;         /*!< [0x6C] General Purpose Register 2 */
    __IO hw_gpu2d_axicontrol_t AxiControl; /*!< [0x70] AXI Control Register */
    __I hw_gpu2d_minorfeatures1_t MinorFeatures1; /*!< [0x74] Minor Features Register 1 */
    __IO hw_gpu2d_totalcycles_t TotalCycles; /*!< [0x78] Total Cycle Counter Register */
    __IO hw_gpu2d_totalidlecyles_t TotalIdleCyles; /*!< [0x7C] Total Idle Cycle Register */
    __IO hw_gpu2d_chipspecs2_t ChipSpecs2; /*!< [0x80] Chip Specification Register */
    __IO hw_gpu2d_modulepowercontrols_t ModulePowerControls; /*!< [0x84] Power Control Register */
    __IO hw_gpu2d_modulepowermodulecontrol_t ModulePowerModuleControl; /*!< [0x88] Power Level Register */
    __I hw_gpu2d_modulepowermodulestatus_t ModulePowerModuleStatus; /*!< [0x8C] Power Status Register */
} hw_gpu2d_t;
#pragma pack()

/*! @brief Macro to access all GPU2D registers. */
/*! @param x GPU2D module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPU2D_REGS(GPU2D_BASE)</code>. */
#define HW_GPU2D_REGS(x) (*(hw_gpu2d_t *)(x))

/*
 * iMX6DP GPU3D
 *
 * GPU3D
 *
 * Registers defined in this header file:
 * - HW_GPU3D_AQH_CLK_CTRL - AQHiClockControl
 * - HW_GPU3D_AQH_IDLE - AQHIdle
 * - HW_GPU3D_AQA_CFG - AQAxiConfig
 * - HW_GPU3D_AQA_STATUS - AQAxiStatus
 * - HW_GPU3D_AQI_ACK - AQIntrAcknowledge
 * - HW_GPU3D_AQI_ENBL - AQIntrEnbl
 * - HW_GPU3D_AQIDENT - AQIdent
 * - HW_GPU3D_GC_FEAT - GCFeatures
 * - HW_GPU3D_GCC_ID - GCChipId
 * - HW_GPU3D_GCC_REV - GCChipRev
 * - HW_GPU3D_GCC_DATE - GCChipDate
 * - HW_GPU3D_GCC_TIME - GCChipTime
 * - HW_GPU3D_GCC_CUST - GCChipCustomer
 * - HW_GPU3D_GCM_FEAT_0 - GCMinorFeatures0
 * - HW_GPU3D_GCC_CRTL - GCCacheControl
 * - HW_GPU3D_GCR_MEM_CTRS - GCResetMemCounters
 * - HW_GPU3D_GCT_READS - gcTotalReads
 * - HW_GPU3D_GCT_WRITES - gcTotalWrites
 * - HW_GPU3D_GCC_SPECS - gcChipSpecs
 * - HW_GPU3D_GCT_WRITE_BURSTS - gcTotalWriteBursts
 * - HW_GPU3D_GCT_WRITE_REQS - gcTotalWriteReqs
 * - HW_GPU3D_GCT_WRITE_LASTS - gcTotalWriteLasts
 * - HW_GPU3D_GCT_READ_BURSTS - gcTotalReadBursts
 * - HW_GPU3D_GCT_READ_REQS - gcTotalReadReqs
 * - HW_GPU3D_GCT_READ_LASTS - gcTotalReadLasts
 * - HW_GPU3D_GCGPO_0 - gcGpOut0
 * - HW_GPU3D_GCGPO_1 - gcGpOut1
 * - HW_GPU3D_GCGPO_2 - gcGpOut2
 * - HW_GPU3D_GCA_CRTL - gcAxiControl
 * - HW_GPU3D_GCM_FEAT_1 - GCMinorFeatures1
 * - HW_GPU3D_GCT_CYCLES - gcTotalCycles
 * - HW_GPU3D_GCT_IDLE_CYCLES - gcTotalIdleCycles
 *
 * - hw_gpu3d_t - Struct containing all module registers.
 */

#define HW_GPU3D_INSTANCE_COUNT (1U) /*!< Number of instances of the GPU3D module. */
#define HW_GPU3D (0U) /*!< Instance number for GPU3D. */
#define GPU3D_BASE            (0x130000U) /*!< Base address for GPU3D. */
/*! Array initializer of GPU3D base addresses. */
#define GPU3D_BASE_ADDRS      { GPU3D_BASE }

/*******************************************************************************
 * HW_GPU3D_AQH_CLK_CTRL - AQHiClockControl
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQH_CLK_CTRL - AQHiClockControl (RW)
 *
 * Reset value: 0x00000100U
 *
 * Clock control register.
 */
typedef union _hw_gpu3d_aqh_clk_ctrl
{
    uint32_t U;
    struct _hw_gpu3d_aqh_clk_ctrl_bitfields
    {
        uint32_t CLK3D_DIS : 1;        /*!< [0]  */
        uint32_t CLK2D_DIS : 1;        /*!< [1]  */
        uint32_t FSCALE_VAL : 7;       /*!< [8:2]  */
        uint32_t FSCALE_CMD_LOAD : 1;  /*!< [9]  */
        uint32_t DISABLE_RAM_CLOCK_GATING : 1; /*!< [10]  */
        uint32_t DISABLE_DEBUG_REGISTERS : 1; /*!< [11]  */
        uint32_t SOFT_RESET : 1;       /*!< [12]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t IDLE3_D : 1;          /*!< [16]  */
        uint32_t IDLE2_D : 1;          /*!< [17]  */
        uint32_t IDLE_VG : 1;          /*!< [18]  */
        uint32_t ISOLATE_GPU : 1;      /*!< [19]  */
        uint32_t MULTI_PIPE_REG_SELECT : 4; /*!< [23:20]  */
        uint32_t MULTI_PIPE_USE_SINGLE_AXI : 4; /*!< [27:24]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_gpu3d_aqh_clk_ctrl_t;

/*!
 * @name Constants and macros for entire GPU3D_AQH_CLK_CTRL register
 */
/*@{*/
#define HW_GPU3D_AQH_CLK_CTRL_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_GPU3D_AQH_CLK_CTRL(x) (*(__IO hw_gpu3d_aqh_clk_ctrl_t *) HW_GPU3D_AQH_CLK_CTRL_ADDR(x))
#define HW_GPU3D_AQH_CLK_CTRL_RD(x) (HW_GPU3D_AQH_CLK_CTRL(x).U)
#define HW_GPU3D_AQH_CLK_CTRL_WR(x, v) (HW_GPU3D_AQH_CLK_CTRL(x).U = (v))
#define HW_GPU3D_AQH_CLK_CTRL_SET(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, HW_GPU3D_AQH_CLK_CTRL_RD(x) |  (v)))
#define HW_GPU3D_AQH_CLK_CTRL_CLR(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~(v)))
#define HW_GPU3D_AQH_CLK_CTRL_TOG(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, HW_GPU3D_AQH_CLK_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQH_CLK_CTRL bitfields
 */

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field CLK3D_DIS[0] (RW)
 *
 * Disable 3D clock.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_CLK3D_DIS (0U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_CLK3D_DIS. */
#define BM_GPU3D_AQH_CLK_CTRL_CLK3D_DIS (0x00000001U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_CLK3D_DIS. */
#define BS_GPU3D_AQH_CLK_CTRL_CLK3D_DIS (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_CLK3D_DIS. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_CLK3D_DIS field. */
#define BR_GPU3D_AQH_CLK_CTRL_CLK3D_DIS(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.CLK3D_DIS)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_CLK3D_DIS. */
#define BF_GPU3D_AQH_CLK_CTRL_CLK3D_DIS(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_CLK3D_DIS) & BM_GPU3D_AQH_CLK_CTRL_CLK3D_DIS)

/*! @brief Set the CLK3D_DIS field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_CLK3D_DIS(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_CLK3D_DIS) | BF_GPU3D_AQH_CLK_CTRL_CLK3D_DIS(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field CLK2D_DIS[1] (RW)
 *
 * Disable 2D clock.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_CLK2D_DIS (1U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_CLK2D_DIS. */
#define BM_GPU3D_AQH_CLK_CTRL_CLK2D_DIS (0x00000002U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_CLK2D_DIS. */
#define BS_GPU3D_AQH_CLK_CTRL_CLK2D_DIS (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_CLK2D_DIS. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_CLK2D_DIS field. */
#define BR_GPU3D_AQH_CLK_CTRL_CLK2D_DIS(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.CLK2D_DIS)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_CLK2D_DIS. */
#define BF_GPU3D_AQH_CLK_CTRL_CLK2D_DIS(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_CLK2D_DIS) & BM_GPU3D_AQH_CLK_CTRL_CLK2D_DIS)

/*! @brief Set the CLK2D_DIS field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_CLK2D_DIS(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_CLK2D_DIS) | BF_GPU3D_AQH_CLK_CTRL_CLK2D_DIS(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field FSCALE_VAL[8:2] (RW)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_FSCALE_VAL (2U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_FSCALE_VAL. */
#define BM_GPU3D_AQH_CLK_CTRL_FSCALE_VAL (0x000001FCU) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_FSCALE_VAL. */
#define BS_GPU3D_AQH_CLK_CTRL_FSCALE_VAL (7U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_FSCALE_VAL. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_FSCALE_VAL field. */
#define BR_GPU3D_AQH_CLK_CTRL_FSCALE_VAL(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.FSCALE_VAL)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_FSCALE_VAL. */
#define BF_GPU3D_AQH_CLK_CTRL_FSCALE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_FSCALE_VAL) & BM_GPU3D_AQH_CLK_CTRL_FSCALE_VAL)

/*! @brief Set the FSCALE_VAL field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_FSCALE_VAL(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_FSCALE_VAL) | BF_GPU3D_AQH_CLK_CTRL_FSCALE_VAL(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field FSCALE_CMD_LOAD[9] (RW)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD (9U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD. */
#define BM_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD (0x00000200U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD. */
#define BS_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD field. */
#define BR_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.FSCALE_CMD_LOAD)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD. */
#define BF_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD) & BM_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD)

/*! @brief Set the FSCALE_CMD_LOAD field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD) | BF_GPU3D_AQH_CLK_CTRL_FSCALE_CMD_LOAD(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field DISABLE_RAM_CLOCK_GATING[10] (RW)
 *
 * Disables clock gating for rams.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING (10U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING. */
#define BM_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING (0x00000400U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING. */
#define BS_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING field. */
#define BR_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.DISABLE_RAM_CLOCK_GATING)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING. */
#define BF_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING) & BM_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING)

/*! @brief Set the DISABLE_RAM_CLOCK_GATING field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING) | BF_GPU3D_AQH_CLK_CTRL_DISABLE_RAM_CLOCK_GATING(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field DISABLE_DEBUG_REGISTERS[11] (RW)
 *
 * Disable debug registers. If this bit is 1, debug registers are clock gated.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS (11U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS. */
#define BM_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS (0x00000800U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS. */
#define BS_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS field. */
#define BR_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.DISABLE_DEBUG_REGISTERS)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS. */
#define BF_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS) & BM_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS)

/*! @brief Set the DISABLE_DEBUG_REGISTERS field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS) | BF_GPU3D_AQH_CLK_CTRL_DISABLE_DEBUG_REGISTERS(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field SOFT_RESET[12] (RW)
 *
 * Soft resets the IP.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_SOFT_RESET (12U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_SOFT_RESET. */
#define BM_GPU3D_AQH_CLK_CTRL_SOFT_RESET (0x00001000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_SOFT_RESET. */
#define BS_GPU3D_AQH_CLK_CTRL_SOFT_RESET (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_SOFT_RESET. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_SOFT_RESET field. */
#define BR_GPU3D_AQH_CLK_CTRL_SOFT_RESET(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.SOFT_RESET)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_SOFT_RESET. */
#define BF_GPU3D_AQH_CLK_CTRL_SOFT_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_SOFT_RESET) & BM_GPU3D_AQH_CLK_CTRL_SOFT_RESET)

/*! @brief Set the SOFT_RESET field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_SOFT_RESET(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_SOFT_RESET) | BF_GPU3D_AQH_CLK_CTRL_SOFT_RESET(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field IDLE3_D[16] (RW)
 *
 * 3D pipe is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_IDLE3_D (16U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_IDLE3_D. */
#define BM_GPU3D_AQH_CLK_CTRL_IDLE3_D (0x00010000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_IDLE3_D. */
#define BS_GPU3D_AQH_CLK_CTRL_IDLE3_D (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_IDLE3_D. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_IDLE3_D field. */
#define BR_GPU3D_AQH_CLK_CTRL_IDLE3_D(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.IDLE3_D)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_IDLE3_D. */
#define BF_GPU3D_AQH_CLK_CTRL_IDLE3_D(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_IDLE3_D) & BM_GPU3D_AQH_CLK_CTRL_IDLE3_D)

/*! @brief Set the IDLE3_D field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_IDLE3_D(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_IDLE3_D) | BF_GPU3D_AQH_CLK_CTRL_IDLE3_D(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field IDLE2_D[17] (RW)
 *
 * 2D pipe is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_IDLE2_D (17U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_IDLE2_D. */
#define BM_GPU3D_AQH_CLK_CTRL_IDLE2_D (0x00020000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_IDLE2_D. */
#define BS_GPU3D_AQH_CLK_CTRL_IDLE2_D (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_IDLE2_D. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_IDLE2_D field. */
#define BR_GPU3D_AQH_CLK_CTRL_IDLE2_D(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.IDLE2_D)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_IDLE2_D. */
#define BF_GPU3D_AQH_CLK_CTRL_IDLE2_D(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_IDLE2_D) & BM_GPU3D_AQH_CLK_CTRL_IDLE2_D)

/*! @brief Set the IDLE2_D field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_IDLE2_D(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_IDLE2_D) | BF_GPU3D_AQH_CLK_CTRL_IDLE2_D(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field IDLE_VG[18] (RW)
 *
 * VG is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_IDLE_VG (18U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_IDLE_VG. */
#define BM_GPU3D_AQH_CLK_CTRL_IDLE_VG (0x00040000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_IDLE_VG. */
#define BS_GPU3D_AQH_CLK_CTRL_IDLE_VG (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_IDLE_VG. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_IDLE_VG field. */
#define BR_GPU3D_AQH_CLK_CTRL_IDLE_VG(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.IDLE_VG)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_IDLE_VG. */
#define BF_GPU3D_AQH_CLK_CTRL_IDLE_VG(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_IDLE_VG) & BM_GPU3D_AQH_CLK_CTRL_IDLE_VG)

/*! @brief Set the IDLE_VG field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_IDLE_VG(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_IDLE_VG) | BF_GPU3D_AQH_CLK_CTRL_IDLE_VG(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field ISOLATE_GPU[19] (RW)
 *
 * Isolate GPU bit
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU (19U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_ISOLATE_GPU. */
#define BM_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU (0x00080000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_ISOLATE_GPU. */
#define BS_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU (1U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_ISOLATE_GPU. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_ISOLATE_GPU field. */
#define BR_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.ISOLATE_GPU)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_ISOLATE_GPU. */
#define BF_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU) & BM_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU)

/*! @brief Set the ISOLATE_GPU field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU) | BF_GPU3D_AQH_CLK_CTRL_ISOLATE_GPU(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field MULTI_PIPE_REG_SELECT[23:20] (RW)
 *
 * Determines which HI/MC to use while reading registers.
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT (20U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT. */
#define BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT (0x00F00000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT. */
#define BS_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT (4U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT field. */
#define BR_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.MULTI_PIPE_REG_SELECT)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT. */
#define BF_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT) & BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT)

/*! @brief Set the MULTI_PIPE_REG_SELECT field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT) | BF_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_REG_SELECT(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQH_CLK_CTRL, field MULTI_PIPE_USE_SINGLE_AXI[27:24] (RW)
 *
 * Force all the transactions to go to one AXI
 */
/*@{*/
#define BP_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI (24U) /*!< Bit position for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI. */
#define BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI (0x0F000000U) /*!< Bit mask for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI. */
#define BS_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI (4U) /*!< Bit field size in bits for GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI. */

/*! @brief Read current value of the GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI field. */
#define BR_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI(x) (HW_GPU3D_AQH_CLK_CTRL(x).B.MULTI_PIPE_USE_SINGLE_AXI)

/*! @brief Format value for bitfield GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI. */
#define BF_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI) & BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI)

/*! @brief Set the MULTI_PIPE_USE_SINGLE_AXI field to a new value. */
#define BW_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI(x, v) (HW_GPU3D_AQH_CLK_CTRL_WR(x, (HW_GPU3D_AQH_CLK_CTRL_RD(x) & ~BM_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI) | BF_GPU3D_AQH_CLK_CTRL_MULTI_PIPE_USE_SINGLE_AXI(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQH_IDLE - AQHIdle
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQH_IDLE - AQHIdle (RO)
 *
 * Reset value: 0x7FFFFFFFU
 *
 * Idle status register.
 */
typedef union _hw_gpu3d_aqh_idle
{
    uint32_t U;
    struct _hw_gpu3d_aqh_idle_bitfields
    {
        uint32_t IDLE_FE : 1;          /*!< [0]  */
        uint32_t IDLE_DE : 1;          /*!< [1]  */
        uint32_t IDLE_PE : 1;          /*!< [2]  */
        uint32_t IDLE_SH : 1;          /*!< [3]  */
        uint32_t IDLE_PA : 1;          /*!< [4]  */
        uint32_t IDLE_SE : 1;          /*!< [5]  */
        uint32_t IDLE_RA : 1;          /*!< [6]  */
        uint32_t IDLE_TX : 1;          /*!< [7]  */
        uint32_t IDLE_VG : 1;          /*!< [8]  */
        uint32_t IDLE_IM : 1;          /*!< [9]  */
        uint32_t IDLE_FP : 1;          /*!< [10]  */
        uint32_t IDLE_TS : 1;          /*!< [11]  */
        uint32_t RESERVED0 : 19;       /*!< [30:12]  */
        uint32_t AXI_LP : 1;           /*!< [31]  */
    } B;
} hw_gpu3d_aqh_idle_t;

/*!
 * @name Constants and macros for entire GPU3D_AQH_IDLE register
 */
/*@{*/
#define HW_GPU3D_AQH_IDLE_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_GPU3D_AQH_IDLE(x)     (*(__I hw_gpu3d_aqh_idle_t *) HW_GPU3D_AQH_IDLE_ADDR(x))
#define HW_GPU3D_AQH_IDLE_RD(x)  (HW_GPU3D_AQH_IDLE(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQH_IDLE bitfields
 */

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_FE[0] (RO)
 *
 * FE is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_FE (0U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_FE. */
#define BM_GPU3D_AQH_IDLE_IDLE_FE (0x00000001U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_FE. */
#define BS_GPU3D_AQH_IDLE_IDLE_FE (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_FE. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_FE field. */
#define BR_GPU3D_AQH_IDLE_IDLE_FE(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_FE)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_DE[1] (RO)
 *
 * DE is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_DE (1U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_DE. */
#define BM_GPU3D_AQH_IDLE_IDLE_DE (0x00000002U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_DE. */
#define BS_GPU3D_AQH_IDLE_IDLE_DE (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_DE. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_DE field. */
#define BR_GPU3D_AQH_IDLE_IDLE_DE(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_DE)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_PE[2] (RO)
 *
 * PE is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_PE (2U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_PE. */
#define BM_GPU3D_AQH_IDLE_IDLE_PE (0x00000004U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_PE. */
#define BS_GPU3D_AQH_IDLE_IDLE_PE (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_PE. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_PE field. */
#define BR_GPU3D_AQH_IDLE_IDLE_PE(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_PE)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_SH[3] (RO)
 *
 * SH is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_SH (3U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_SH. */
#define BM_GPU3D_AQH_IDLE_IDLE_SH (0x00000008U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_SH. */
#define BS_GPU3D_AQH_IDLE_IDLE_SH (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_SH. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_SH field. */
#define BR_GPU3D_AQH_IDLE_IDLE_SH(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_SH)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_PA[4] (RO)
 *
 * PA is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_PA (4U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_PA. */
#define BM_GPU3D_AQH_IDLE_IDLE_PA (0x00000010U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_PA. */
#define BS_GPU3D_AQH_IDLE_IDLE_PA (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_PA. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_PA field. */
#define BR_GPU3D_AQH_IDLE_IDLE_PA(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_PA)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_SE[5] (RO)
 *
 * SE is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_SE (5U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_SE. */
#define BM_GPU3D_AQH_IDLE_IDLE_SE (0x00000020U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_SE. */
#define BS_GPU3D_AQH_IDLE_IDLE_SE (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_SE. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_SE field. */
#define BR_GPU3D_AQH_IDLE_IDLE_SE(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_SE)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_RA[6] (RO)
 *
 * RA is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_RA (6U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_RA. */
#define BM_GPU3D_AQH_IDLE_IDLE_RA (0x00000040U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_RA. */
#define BS_GPU3D_AQH_IDLE_IDLE_RA (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_RA. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_RA field. */
#define BR_GPU3D_AQH_IDLE_IDLE_RA(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_RA)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_TX[7] (RO)
 *
 * TX is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_TX (7U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_TX. */
#define BM_GPU3D_AQH_IDLE_IDLE_TX (0x00000080U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_TX. */
#define BS_GPU3D_AQH_IDLE_IDLE_TX (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_TX. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_TX field. */
#define BR_GPU3D_AQH_IDLE_IDLE_TX(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_TX)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_VG[8] (RO)
 *
 * VG is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_VG (8U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_VG. */
#define BM_GPU3D_AQH_IDLE_IDLE_VG (0x00000100U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_VG. */
#define BS_GPU3D_AQH_IDLE_IDLE_VG (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_VG. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_VG field. */
#define BR_GPU3D_AQH_IDLE_IDLE_VG(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_VG)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_IM[9] (RO)
 *
 * IM is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_IM (9U)     /*!< Bit position for GPU3D_AQH_IDLE_IDLE_IM. */
#define BM_GPU3D_AQH_IDLE_IDLE_IM (0x00000200U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_IM. */
#define BS_GPU3D_AQH_IDLE_IDLE_IM (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_IM. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_IM field. */
#define BR_GPU3D_AQH_IDLE_IDLE_IM(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_IM)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_FP[10] (RO)
 *
 * FP is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_FP (10U)    /*!< Bit position for GPU3D_AQH_IDLE_IDLE_FP. */
#define BM_GPU3D_AQH_IDLE_IDLE_FP (0x00000400U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_FP. */
#define BS_GPU3D_AQH_IDLE_IDLE_FP (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_FP. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_FP field. */
#define BR_GPU3D_AQH_IDLE_IDLE_FP(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_FP)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field IDLE_TS[11] (RO)
 *
 * TS is idle.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_IDLE_TS (11U)    /*!< Bit position for GPU3D_AQH_IDLE_IDLE_TS. */
#define BM_GPU3D_AQH_IDLE_IDLE_TS (0x00000800U) /*!< Bit mask for GPU3D_AQH_IDLE_IDLE_TS. */
#define BS_GPU3D_AQH_IDLE_IDLE_TS (1U)     /*!< Bit field size in bits for GPU3D_AQH_IDLE_IDLE_TS. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_IDLE_TS field. */
#define BR_GPU3D_AQH_IDLE_IDLE_TS(x) (HW_GPU3D_AQH_IDLE(x).B.IDLE_TS)
/*@}*/

/*!
 * @name Register GPU3D_AQH_IDLE, field AXI_LP[31] (RO)
 *
 * AXI is in low power mode.
 */
/*@{*/
#define BP_GPU3D_AQH_IDLE_AXI_LP (31U)     /*!< Bit position for GPU3D_AQH_IDLE_AXI_LP. */
#define BM_GPU3D_AQH_IDLE_AXI_LP (0x80000000U) /*!< Bit mask for GPU3D_AQH_IDLE_AXI_LP. */
#define BS_GPU3D_AQH_IDLE_AXI_LP (1U)      /*!< Bit field size in bits for GPU3D_AQH_IDLE_AXI_LP. */

/*! @brief Read current value of the GPU3D_AQH_IDLE_AXI_LP field. */
#define BR_GPU3D_AQH_IDLE_AXI_LP(x) (HW_GPU3D_AQH_IDLE(x).B.AXI_LP)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQA_CFG - AQAxiConfig
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQA_CFG - AQAxiConfig (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpu3d_aqa_cfg
{
    uint32_t U;
    struct _hw_gpu3d_aqa_cfg_bitfields
    {
        uint32_t AWID : 4;             /*!< [3:0]  */
        uint32_t ARID : 4;             /*!< [7:4]  */
        uint32_t AWCACHE : 4;          /*!< [11:8]  */
        uint32_t ARCACHE : 4;          /*!< [15:12]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_gpu3d_aqa_cfg_t;

/*!
 * @name Constants and macros for entire GPU3D_AQA_CFG register
 */
/*@{*/
#define HW_GPU3D_AQA_CFG_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_GPU3D_AQA_CFG(x)      (*(__IO hw_gpu3d_aqa_cfg_t *) HW_GPU3D_AQA_CFG_ADDR(x))
#define HW_GPU3D_AQA_CFG_RD(x)   (HW_GPU3D_AQA_CFG(x).U)
#define HW_GPU3D_AQA_CFG_WR(x, v) (HW_GPU3D_AQA_CFG(x).U = (v))
#define HW_GPU3D_AQA_CFG_SET(x, v) (HW_GPU3D_AQA_CFG_WR(x, HW_GPU3D_AQA_CFG_RD(x) |  (v)))
#define HW_GPU3D_AQA_CFG_CLR(x, v) (HW_GPU3D_AQA_CFG_WR(x, HW_GPU3D_AQA_CFG_RD(x) & ~(v)))
#define HW_GPU3D_AQA_CFG_TOG(x, v) (HW_GPU3D_AQA_CFG_WR(x, HW_GPU3D_AQA_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQA_CFG bitfields
 */

/*!
 * @name Register GPU3D_AQA_CFG, field AWID[3:0] (RW)
 *
 * AW ID
 */
/*@{*/
#define BP_GPU3D_AQA_CFG_AWID (0U)         /*!< Bit position for GPU3D_AQA_CFG_AWID. */
#define BM_GPU3D_AQA_CFG_AWID (0x0000000FU) /*!< Bit mask for GPU3D_AQA_CFG_AWID. */
#define BS_GPU3D_AQA_CFG_AWID (4U)         /*!< Bit field size in bits for GPU3D_AQA_CFG_AWID. */

/*! @brief Read current value of the GPU3D_AQA_CFG_AWID field. */
#define BR_GPU3D_AQA_CFG_AWID(x) (HW_GPU3D_AQA_CFG(x).B.AWID)

/*! @brief Format value for bitfield GPU3D_AQA_CFG_AWID. */
#define BF_GPU3D_AQA_CFG_AWID(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQA_CFG_AWID) & BM_GPU3D_AQA_CFG_AWID)

/*! @brief Set the AWID field to a new value. */
#define BW_GPU3D_AQA_CFG_AWID(x, v) (HW_GPU3D_AQA_CFG_WR(x, (HW_GPU3D_AQA_CFG_RD(x) & ~BM_GPU3D_AQA_CFG_AWID) | BF_GPU3D_AQA_CFG_AWID(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQA_CFG, field ARID[7:4] (RW)
 *
 * AR ID
 */
/*@{*/
#define BP_GPU3D_AQA_CFG_ARID (4U)         /*!< Bit position for GPU3D_AQA_CFG_ARID. */
#define BM_GPU3D_AQA_CFG_ARID (0x000000F0U) /*!< Bit mask for GPU3D_AQA_CFG_ARID. */
#define BS_GPU3D_AQA_CFG_ARID (4U)         /*!< Bit field size in bits for GPU3D_AQA_CFG_ARID. */

/*! @brief Read current value of the GPU3D_AQA_CFG_ARID field. */
#define BR_GPU3D_AQA_CFG_ARID(x) (HW_GPU3D_AQA_CFG(x).B.ARID)

/*! @brief Format value for bitfield GPU3D_AQA_CFG_ARID. */
#define BF_GPU3D_AQA_CFG_ARID(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQA_CFG_ARID) & BM_GPU3D_AQA_CFG_ARID)

/*! @brief Set the ARID field to a new value. */
#define BW_GPU3D_AQA_CFG_ARID(x, v) (HW_GPU3D_AQA_CFG_WR(x, (HW_GPU3D_AQA_CFG_RD(x) & ~BM_GPU3D_AQA_CFG_ARID) | BF_GPU3D_AQA_CFG_ARID(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQA_CFG, field AWCACHE[11:8] (RW)
 *
 * AW Cache
 */
/*@{*/
#define BP_GPU3D_AQA_CFG_AWCACHE (8U)      /*!< Bit position for GPU3D_AQA_CFG_AWCACHE. */
#define BM_GPU3D_AQA_CFG_AWCACHE (0x00000F00U) /*!< Bit mask for GPU3D_AQA_CFG_AWCACHE. */
#define BS_GPU3D_AQA_CFG_AWCACHE (4U)      /*!< Bit field size in bits for GPU3D_AQA_CFG_AWCACHE. */

/*! @brief Read current value of the GPU3D_AQA_CFG_AWCACHE field. */
#define BR_GPU3D_AQA_CFG_AWCACHE(x) (HW_GPU3D_AQA_CFG(x).B.AWCACHE)

/*! @brief Format value for bitfield GPU3D_AQA_CFG_AWCACHE. */
#define BF_GPU3D_AQA_CFG_AWCACHE(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQA_CFG_AWCACHE) & BM_GPU3D_AQA_CFG_AWCACHE)

/*! @brief Set the AWCACHE field to a new value. */
#define BW_GPU3D_AQA_CFG_AWCACHE(x, v) (HW_GPU3D_AQA_CFG_WR(x, (HW_GPU3D_AQA_CFG_RD(x) & ~BM_GPU3D_AQA_CFG_AWCACHE) | BF_GPU3D_AQA_CFG_AWCACHE(v)))
/*@}*/

/*!
 * @name Register GPU3D_AQA_CFG, field ARCACHE[15:12] (RW)
 *
 * AR Cache
 */
/*@{*/
#define BP_GPU3D_AQA_CFG_ARCACHE (12U)     /*!< Bit position for GPU3D_AQA_CFG_ARCACHE. */
#define BM_GPU3D_AQA_CFG_ARCACHE (0x0000F000U) /*!< Bit mask for GPU3D_AQA_CFG_ARCACHE. */
#define BS_GPU3D_AQA_CFG_ARCACHE (4U)      /*!< Bit field size in bits for GPU3D_AQA_CFG_ARCACHE. */

/*! @brief Read current value of the GPU3D_AQA_CFG_ARCACHE field. */
#define BR_GPU3D_AQA_CFG_ARCACHE(x) (HW_GPU3D_AQA_CFG(x).B.ARCACHE)

/*! @brief Format value for bitfield GPU3D_AQA_CFG_ARCACHE. */
#define BF_GPU3D_AQA_CFG_ARCACHE(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQA_CFG_ARCACHE) & BM_GPU3D_AQA_CFG_ARCACHE)

/*! @brief Set the ARCACHE field to a new value. */
#define BW_GPU3D_AQA_CFG_ARCACHE(x, v) (HW_GPU3D_AQA_CFG_WR(x, (HW_GPU3D_AQA_CFG_RD(x) & ~BM_GPU3D_AQA_CFG_ARCACHE) | BF_GPU3D_AQA_CFG_ARCACHE(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQA_STATUS - AQAxiStatus
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQA_STATUS - AQAxiStatus (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_gpu3d_aqa_status
{
    uint32_t U;
    struct _hw_gpu3d_aqa_status_bitfields
    {
        uint32_t WR_ERR_ID : 4;        /*!< [3:0]  */
        uint32_t RD_ERR_ID : 4;        /*!< [7:4]  */
        uint32_t DET_WR_ERR : 1;       /*!< [8]  */
        uint32_t DET_RD_ERR : 1;       /*!< [9]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_gpu3d_aqa_status_t;

/*!
 * @name Constants and macros for entire GPU3D_AQA_STATUS register
 */
/*@{*/
#define HW_GPU3D_AQA_STATUS_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_GPU3D_AQA_STATUS(x)   (*(__I hw_gpu3d_aqa_status_t *) HW_GPU3D_AQA_STATUS_ADDR(x))
#define HW_GPU3D_AQA_STATUS_RD(x) (HW_GPU3D_AQA_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQA_STATUS bitfields
 */

/*!
 * @name Register GPU3D_AQA_STATUS, field WR_ERR_ID[3:0] (RO)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQA_STATUS_WR_ERR_ID (0U) /*!< Bit position for GPU3D_AQA_STATUS_WR_ERR_ID. */
#define BM_GPU3D_AQA_STATUS_WR_ERR_ID (0x0000000FU) /*!< Bit mask for GPU3D_AQA_STATUS_WR_ERR_ID. */
#define BS_GPU3D_AQA_STATUS_WR_ERR_ID (4U) /*!< Bit field size in bits for GPU3D_AQA_STATUS_WR_ERR_ID. */

/*! @brief Read current value of the GPU3D_AQA_STATUS_WR_ERR_ID field. */
#define BR_GPU3D_AQA_STATUS_WR_ERR_ID(x) (HW_GPU3D_AQA_STATUS(x).B.WR_ERR_ID)
/*@}*/

/*!
 * @name Register GPU3D_AQA_STATUS, field RD_ERR_ID[7:4] (RO)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQA_STATUS_RD_ERR_ID (4U) /*!< Bit position for GPU3D_AQA_STATUS_RD_ERR_ID. */
#define BM_GPU3D_AQA_STATUS_RD_ERR_ID (0x000000F0U) /*!< Bit mask for GPU3D_AQA_STATUS_RD_ERR_ID. */
#define BS_GPU3D_AQA_STATUS_RD_ERR_ID (4U) /*!< Bit field size in bits for GPU3D_AQA_STATUS_RD_ERR_ID. */

/*! @brief Read current value of the GPU3D_AQA_STATUS_RD_ERR_ID field. */
#define BR_GPU3D_AQA_STATUS_RD_ERR_ID(x) (HW_GPU3D_AQA_STATUS(x).B.RD_ERR_ID)
/*@}*/

/*!
 * @name Register GPU3D_AQA_STATUS, field DET_WR_ERR[8] (RO)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQA_STATUS_DET_WR_ERR (8U) /*!< Bit position for GPU3D_AQA_STATUS_DET_WR_ERR. */
#define BM_GPU3D_AQA_STATUS_DET_WR_ERR (0x00000100U) /*!< Bit mask for GPU3D_AQA_STATUS_DET_WR_ERR. */
#define BS_GPU3D_AQA_STATUS_DET_WR_ERR (1U) /*!< Bit field size in bits for GPU3D_AQA_STATUS_DET_WR_ERR. */

/*! @brief Read current value of the GPU3D_AQA_STATUS_DET_WR_ERR field. */
#define BR_GPU3D_AQA_STATUS_DET_WR_ERR(x) (HW_GPU3D_AQA_STATUS(x).B.DET_WR_ERR)
/*@}*/

/*!
 * @name Register GPU3D_AQA_STATUS, field DET_RD_ERR[9] (RO)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQA_STATUS_DET_RD_ERR (9U) /*!< Bit position for GPU3D_AQA_STATUS_DET_RD_ERR. */
#define BM_GPU3D_AQA_STATUS_DET_RD_ERR (0x00000200U) /*!< Bit mask for GPU3D_AQA_STATUS_DET_RD_ERR. */
#define BS_GPU3D_AQA_STATUS_DET_RD_ERR (1U) /*!< Bit field size in bits for GPU3D_AQA_STATUS_DET_RD_ERR. */

/*! @brief Read current value of the GPU3D_AQA_STATUS_DET_RD_ERR field. */
#define BR_GPU3D_AQA_STATUS_DET_RD_ERR(x) (HW_GPU3D_AQA_STATUS(x).B.DET_RD_ERR)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQI_ACK - AQIntrAcknowledge
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQI_ACK - AQIntrAcknowledge (RO)
 *
 * Reset value: 0x00000000U
 *
 * Interrupt acknowledge register. Each bit represents a corresponding event
 * being triggered. Reading from this register clears the outstanding interrupt.
 */
typedef union _hw_gpu3d_aqi_ack
{
    uint32_t U;
    struct _hw_gpu3d_aqi_ack_bitfields
    {
        uint32_t INTR_VEC : 32;        /*!< [31:0]  */
    } B;
} hw_gpu3d_aqi_ack_t;

/*!
 * @name Constants and macros for entire GPU3D_AQI_ACK register
 */
/*@{*/
#define HW_GPU3D_AQI_ACK_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_GPU3D_AQI_ACK(x)      (*(__I hw_gpu3d_aqi_ack_t *) HW_GPU3D_AQI_ACK_ADDR(x))
#define HW_GPU3D_AQI_ACK_RD(x)   (HW_GPU3D_AQI_ACK(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQI_ACK bitfields
 */

/*!
 * @name Register GPU3D_AQI_ACK, field INTR_VEC[31:0] (RO)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQI_ACK_INTR_VEC (0U)     /*!< Bit position for GPU3D_AQI_ACK_INTR_VEC. */
#define BM_GPU3D_AQI_ACK_INTR_VEC (0xFFFFFFFFU) /*!< Bit mask for GPU3D_AQI_ACK_INTR_VEC. */
#define BS_GPU3D_AQI_ACK_INTR_VEC (32U)    /*!< Bit field size in bits for GPU3D_AQI_ACK_INTR_VEC. */

/*! @brief Read current value of the GPU3D_AQI_ACK_INTR_VEC field. */
#define BR_GPU3D_AQI_ACK_INTR_VEC(x) (HW_GPU3D_AQI_ACK(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQI_ENBL - AQIntrEnbl
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQI_ENBL - AQIntrEnbl (RW)
 *
 * Reset value: 0x00000000U
 *
 * Interrupt enable register. Each bit enables a corresponding event.
 */
typedef union _hw_gpu3d_aqi_enbl
{
    uint32_t U;
    struct _hw_gpu3d_aqi_enbl_bitfields
    {
        uint32_t INTR_ENBL_VEC : 32;   /*!< [31:0]  */
    } B;
} hw_gpu3d_aqi_enbl_t;

/*!
 * @name Constants and macros for entire GPU3D_AQI_ENBL register
 */
/*@{*/
#define HW_GPU3D_AQI_ENBL_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_GPU3D_AQI_ENBL(x)     (*(__IO hw_gpu3d_aqi_enbl_t *) HW_GPU3D_AQI_ENBL_ADDR(x))
#define HW_GPU3D_AQI_ENBL_RD(x)  (HW_GPU3D_AQI_ENBL(x).U)
#define HW_GPU3D_AQI_ENBL_WR(x, v) (HW_GPU3D_AQI_ENBL(x).U = (v))
#define HW_GPU3D_AQI_ENBL_SET(x, v) (HW_GPU3D_AQI_ENBL_WR(x, HW_GPU3D_AQI_ENBL_RD(x) |  (v)))
#define HW_GPU3D_AQI_ENBL_CLR(x, v) (HW_GPU3D_AQI_ENBL_WR(x, HW_GPU3D_AQI_ENBL_RD(x) & ~(v)))
#define HW_GPU3D_AQI_ENBL_TOG(x, v) (HW_GPU3D_AQI_ENBL_WR(x, HW_GPU3D_AQI_ENBL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQI_ENBL bitfields
 */

/*!
 * @name Register GPU3D_AQI_ENBL, field INTR_ENBL_VEC[31:0] (RW)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_AQI_ENBL_INTR_ENBL_VEC (0U) /*!< Bit position for GPU3D_AQI_ENBL_INTR_ENBL_VEC. */
#define BM_GPU3D_AQI_ENBL_INTR_ENBL_VEC (0xFFFFFFFFU) /*!< Bit mask for GPU3D_AQI_ENBL_INTR_ENBL_VEC. */
#define BS_GPU3D_AQI_ENBL_INTR_ENBL_VEC (32U) /*!< Bit field size in bits for GPU3D_AQI_ENBL_INTR_ENBL_VEC. */

/*! @brief Read current value of the GPU3D_AQI_ENBL_INTR_ENBL_VEC field. */
#define BR_GPU3D_AQI_ENBL_INTR_ENBL_VEC(x) (HW_GPU3D_AQI_ENBL(x).U)

/*! @brief Format value for bitfield GPU3D_AQI_ENBL_INTR_ENBL_VEC. */
#define BF_GPU3D_AQI_ENBL_INTR_ENBL_VEC(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_AQI_ENBL_INTR_ENBL_VEC) & BM_GPU3D_AQI_ENBL_INTR_ENBL_VEC)

/*! @brief Set the INTR_ENBL_VEC field to a new value. */
#define BW_GPU3D_AQI_ENBL_INTR_ENBL_VEC(x, v) (HW_GPU3D_AQI_ENBL_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_AQIDENT - AQIdent
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_AQIDENT - AQIdent (RO)
 *
 * Reset value: 0x00000000U
 *
 * Identification register. This register has no set reset value. It varies with
 * the implementation.
 */
typedef union _hw_gpu3d_aqident
{
    uint32_t U;
    struct _hw_gpu3d_aqident_bitfields
    {
        uint32_t CUSTOMER : 8;         /*!< [7:0]  */
        uint32_t TECHNOLOGY : 4;       /*!< [11:8]  */
        uint32_t REVISION : 4;         /*!< [15:12]  */
        uint32_t PRODUCT : 8;          /*!< [23:16]  */
        uint32_t FAMILY : 8;           /*!< [31:24]  */
    } B;
} hw_gpu3d_aqident_t;

/*!
 * @name Constants and macros for entire GPU3D_AQIDENT register
 */
/*@{*/
#define HW_GPU3D_AQIDENT_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_GPU3D_AQIDENT(x)      (*(__I hw_gpu3d_aqident_t *) HW_GPU3D_AQIDENT_ADDR(x))
#define HW_GPU3D_AQIDENT_RD(x)   (HW_GPU3D_AQIDENT(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_AQIDENT bitfields
 */

/*!
 * @name Register GPU3D_AQIDENT, field CUSTOMER[7:0] (RO)
 *
 * Customer value.
 */
/*@{*/
#define BP_GPU3D_AQIDENT_CUSTOMER (0U)     /*!< Bit position for GPU3D_AQIDENT_CUSTOMER. */
#define BM_GPU3D_AQIDENT_CUSTOMER (0x000000FFU) /*!< Bit mask for GPU3D_AQIDENT_CUSTOMER. */
#define BS_GPU3D_AQIDENT_CUSTOMER (8U)     /*!< Bit field size in bits for GPU3D_AQIDENT_CUSTOMER. */

/*! @brief Read current value of the GPU3D_AQIDENT_CUSTOMER field. */
#define BR_GPU3D_AQIDENT_CUSTOMER(x) (HW_GPU3D_AQIDENT(x).B.CUSTOMER)
/*@}*/

/*!
 * @name Register GPU3D_AQIDENT, field TECHNOLOGY[11:8] (RO)
 *
 * Technology value.
 */
/*@{*/
#define BP_GPU3D_AQIDENT_TECHNOLOGY (8U)   /*!< Bit position for GPU3D_AQIDENT_TECHNOLOGY. */
#define BM_GPU3D_AQIDENT_TECHNOLOGY (0x00000F00U) /*!< Bit mask for GPU3D_AQIDENT_TECHNOLOGY. */
#define BS_GPU3D_AQIDENT_TECHNOLOGY (4U)   /*!< Bit field size in bits for GPU3D_AQIDENT_TECHNOLOGY. */

/*! @brief Read current value of the GPU3D_AQIDENT_TECHNOLOGY field. */
#define BR_GPU3D_AQIDENT_TECHNOLOGY(x) (HW_GPU3D_AQIDENT(x).B.TECHNOLOGY)
/*@}*/

/*!
 * @name Register GPU3D_AQIDENT, field REVISION[15:12] (RO)
 *
 * Revision value.
 */
/*@{*/
#define BP_GPU3D_AQIDENT_REVISION (12U)    /*!< Bit position for GPU3D_AQIDENT_REVISION. */
#define BM_GPU3D_AQIDENT_REVISION (0x0000F000U) /*!< Bit mask for GPU3D_AQIDENT_REVISION. */
#define BS_GPU3D_AQIDENT_REVISION (4U)     /*!< Bit field size in bits for GPU3D_AQIDENT_REVISION. */

/*! @brief Read current value of the GPU3D_AQIDENT_REVISION field. */
#define BR_GPU3D_AQIDENT_REVISION(x) (HW_GPU3D_AQIDENT(x).B.REVISION)
/*@}*/

/*!
 * @name Register GPU3D_AQIDENT, field PRODUCT[23:16] (RO)
 *
 * Product value.
 */
/*@{*/
#define BP_GPU3D_AQIDENT_PRODUCT (16U)     /*!< Bit position for GPU3D_AQIDENT_PRODUCT. */
#define BM_GPU3D_AQIDENT_PRODUCT (0x00FF0000U) /*!< Bit mask for GPU3D_AQIDENT_PRODUCT. */
#define BS_GPU3D_AQIDENT_PRODUCT (8U)      /*!< Bit field size in bits for GPU3D_AQIDENT_PRODUCT. */

/*! @brief Read current value of the GPU3D_AQIDENT_PRODUCT field. */
#define BR_GPU3D_AQIDENT_PRODUCT(x) (HW_GPU3D_AQIDENT(x).B.PRODUCT)
/*@}*/

/*!
 * @name Register GPU3D_AQIDENT, field FAMILY[31:24] (RO)
 *
 * Family value.
 */
/*@{*/
#define BP_GPU3D_AQIDENT_FAMILY (24U)      /*!< Bit position for GPU3D_AQIDENT_FAMILY. */
#define BM_GPU3D_AQIDENT_FAMILY (0xFF000000U) /*!< Bit mask for GPU3D_AQIDENT_FAMILY. */
#define BS_GPU3D_AQIDENT_FAMILY (8U)       /*!< Bit field size in bits for GPU3D_AQIDENT_FAMILY. */

/*! @brief Read current value of the GPU3D_AQIDENT_FAMILY field. */
#define BR_GPU3D_AQIDENT_FAMILY(x) (HW_GPU3D_AQIDENT(x).B.FAMILY)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GC_FEAT - GCFeatures
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GC_FEAT - GCFeatures (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which features are enabled in this chip. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu3d_gc_feat
{
    uint32_t U;
    struct _hw_gpu3d_gc_feat_bitfields
    {
        uint32_t FAST_CLEAR : 1;       /*!< [0]  */
        uint32_t SPECIAL_ANTI_ALIASING : 1; /*!< [1]  */
        uint32_t PIPE_3D : 1;          /*!< [2]  */
        uint32_t DXT_TEXTURE_COMPRESSION : 1; /*!< [3]  */
        uint32_t DEBUG_MODE : 1;       /*!< [4]  */
        uint32_t ZCOMPRESSION : 1;     /*!< [5]  */
        uint32_t YUV420_FILTER : 1;    /*!< [6]  */
        uint32_t MSAA : 1;             /*!< [7]  */
        uint32_t DC : 1;               /*!< [8]  */
        uint32_t PIPE_2D : 1;          /*!< [9]  */
        uint32_t ETC1_TEXTURE_COMPRESSION : 1; /*!< [10]  */
        uint32_t FAST_SCALER : 1;      /*!< [11]  */
        uint32_t HIGH_DYNAMIC_RANGE : 1; /*!< [12]  */
        uint32_t YUV420_TILER : 1;     /*!< [13]  */
        uint32_t MODULE_CG : 1;        /*!< [14]  */
        uint32_t MIN_AREA : 1;         /*!< [15]  */
        uint32_t NO_EZ : 1;            /*!< [16]  */
        uint32_t NO422_TEXTURE : 1;    /*!< [17]  */
        uint32_t BUFFER_INTERLEAVING : 1; /*!< [18]  */
        uint32_t BYTE_WRITE_2D : 1;    /*!< [19]  */
        uint32_t NO_SCALER : 1;        /*!< [20]  */
        uint32_t YUY2_AVERAGING : 1;   /*!< [21]  */
        uint32_t HALF_PE_CACHE : 1;    /*!< [22]  */
        uint32_t HALF_TX_CACHE : 1;    /*!< [23]  */
        uint32_t YUY2_RENDER_TARGET : 1; /*!< [24]  */
        uint32_t MEM32_BIT_SUPPORT : 1; /*!< [25]  */
        uint32_t PIPE_VG : 1;          /*!< [26]  */
        uint32_t VGTS : 1;             /*!< [27]  */
        uint32_t FE20 : 1;             /*!< [28]  */
        uint32_t BYTE_WRITE_3D : 1;    /*!< [29]  */
        uint32_t RS_YUV_TARGET : 1;    /*!< [30]  */
        uint32_t FE20_BIT_INDEX : 1;   /*!< [31]  */
    } B;
} hw_gpu3d_gc_feat_t;

/*!
 * @name Constants and macros for entire GPU3D_GC_FEAT register
 */
/*@{*/
#define HW_GPU3D_GC_FEAT_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_GPU3D_GC_FEAT(x)      (*(__I hw_gpu3d_gc_feat_t *) HW_GPU3D_GC_FEAT_ADDR(x))
#define HW_GPU3D_GC_FEAT_RD(x)   (HW_GPU3D_GC_FEAT(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GC_FEAT bitfields
 */

/*!
 * @name Register GPU3D_GC_FEAT, field FAST_CLEAR[0] (RO)
 *
 * Fast clear.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_FAST_CLEAR (0U)   /*!< Bit position for GPU3D_GC_FEAT_FAST_CLEAR. */
#define BM_GPU3D_GC_FEAT_FAST_CLEAR (0x00000001U) /*!< Bit mask for GPU3D_GC_FEAT_FAST_CLEAR. */
#define BS_GPU3D_GC_FEAT_FAST_CLEAR (1U)   /*!< Bit field size in bits for GPU3D_GC_FEAT_FAST_CLEAR. */

/*! @brief Read current value of the GPU3D_GC_FEAT_FAST_CLEAR field. */
#define BR_GPU3D_GC_FEAT_FAST_CLEAR(x) (HW_GPU3D_GC_FEAT(x).B.FAST_CLEAR)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field SPECIAL_ANTI_ALIASING[1] (RO)
 *
 * Full-screen anti-aliasing.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING (1U) /*!< Bit position for GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING. */
#define BM_GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING (0x00000002U) /*!< Bit mask for GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING. */
#define BS_GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING. */

/*! @brief Read current value of the GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING field. */
#define BR_GPU3D_GC_FEAT_SPECIAL_ANTI_ALIASING(x) (HW_GPU3D_GC_FEAT(x).B.SPECIAL_ANTI_ALIASING)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field PIPE_3D[2] (RO)
 *
 * 3D pipe.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_PIPE_3D (2U)      /*!< Bit position for GPU3D_GC_FEAT_PIPE_3D. */
#define BM_GPU3D_GC_FEAT_PIPE_3D (0x00000004U) /*!< Bit mask for GPU3D_GC_FEAT_PIPE_3D. */
#define BS_GPU3D_GC_FEAT_PIPE_3D (1U)      /*!< Bit field size in bits for GPU3D_GC_FEAT_PIPE_3D. */

/*! @brief Read current value of the GPU3D_GC_FEAT_PIPE_3D field. */
#define BR_GPU3D_GC_FEAT_PIPE_3D(x) (HW_GPU3D_GC_FEAT(x).B.PIPE_3D)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field DXT_TEXTURE_COMPRESSION[3] (RO)
 *
 * DXT texture compression.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION (3U) /*!< Bit position for GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION. */
#define BM_GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION (0x00000008U) /*!< Bit mask for GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION. */
#define BS_GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION. */

/*! @brief Read current value of the GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION field. */
#define BR_GPU3D_GC_FEAT_DXT_TEXTURE_COMPRESSION(x) (HW_GPU3D_GC_FEAT(x).B.DXT_TEXTURE_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field DEBUG_MODE[4] (RO)
 *
 * Debug registers.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_DEBUG_MODE (4U)   /*!< Bit position for GPU3D_GC_FEAT_DEBUG_MODE. */
#define BM_GPU3D_GC_FEAT_DEBUG_MODE (0x00000010U) /*!< Bit mask for GPU3D_GC_FEAT_DEBUG_MODE. */
#define BS_GPU3D_GC_FEAT_DEBUG_MODE (1U)   /*!< Bit field size in bits for GPU3D_GC_FEAT_DEBUG_MODE. */

/*! @brief Read current value of the GPU3D_GC_FEAT_DEBUG_MODE field. */
#define BR_GPU3D_GC_FEAT_DEBUG_MODE(x) (HW_GPU3D_GC_FEAT(x).B.DEBUG_MODE)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field ZCOMPRESSION[5] (RO)
 *
 * Depth and color compression.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_ZCOMPRESSION (5U) /*!< Bit position for GPU3D_GC_FEAT_ZCOMPRESSION. */
#define BM_GPU3D_GC_FEAT_ZCOMPRESSION (0x00000020U) /*!< Bit mask for GPU3D_GC_FEAT_ZCOMPRESSION. */
#define BS_GPU3D_GC_FEAT_ZCOMPRESSION (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_ZCOMPRESSION. */

/*! @brief Read current value of the GPU3D_GC_FEAT_ZCOMPRESSION field. */
#define BR_GPU3D_GC_FEAT_ZCOMPRESSION(x) (HW_GPU3D_GC_FEAT(x).B.ZCOMPRESSION)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field YUV420_FILTER[6] (RO)
 *
 * YUV 4:2:0 support in filter blit.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_YUV420_FILTER (6U) /*!< Bit position for GPU3D_GC_FEAT_YUV420_FILTER. */
#define BM_GPU3D_GC_FEAT_YUV420_FILTER (0x00000040U) /*!< Bit mask for GPU3D_GC_FEAT_YUV420_FILTER. */
#define BS_GPU3D_GC_FEAT_YUV420_FILTER (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_YUV420_FILTER. */

/*! @brief Read current value of the GPU3D_GC_FEAT_YUV420_FILTER field. */
#define BR_GPU3D_GC_FEAT_YUV420_FILTER(x) (HW_GPU3D_GC_FEAT(x).B.YUV420_FILTER)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field MSAA[7] (RO)
 *
 * MSAA support.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_MSAA (7U)         /*!< Bit position for GPU3D_GC_FEAT_MSAA. */
#define BM_GPU3D_GC_FEAT_MSAA (0x00000080U) /*!< Bit mask for GPU3D_GC_FEAT_MSAA. */
#define BS_GPU3D_GC_FEAT_MSAA (1U)         /*!< Bit field size in bits for GPU3D_GC_FEAT_MSAA. */

/*! @brief Read current value of the GPU3D_GC_FEAT_MSAA field. */
#define BR_GPU3D_GC_FEAT_MSAA(x) (HW_GPU3D_GC_FEAT(x).B.MSAA)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field DC[8] (RO)
 *
 * Shows if there is a display controller in the IP.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_DC  (8U)          /*!< Bit position for GPU3D_GC_FEAT_DC. */
#define BM_GPU3D_GC_FEAT_DC  (0x00000100U) /*!< Bit mask for GPU3D_GC_FEAT_DC. */
#define BS_GPU3D_GC_FEAT_DC  (1U)          /*!< Bit field size in bits for GPU3D_GC_FEAT_DC. */

/*! @brief Read current value of the GPU3D_GC_FEAT_DC field. */
#define BR_GPU3D_GC_FEAT_DC(x) (HW_GPU3D_GC_FEAT(x).B.DC)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field PIPE_2D[9] (RO)
 *
 * Shows if there is 2D engine.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_PIPE_2D (9U)      /*!< Bit position for GPU3D_GC_FEAT_PIPE_2D. */
#define BM_GPU3D_GC_FEAT_PIPE_2D (0x00000200U) /*!< Bit mask for GPU3D_GC_FEAT_PIPE_2D. */
#define BS_GPU3D_GC_FEAT_PIPE_2D (1U)      /*!< Bit field size in bits for GPU3D_GC_FEAT_PIPE_2D. */

/*! @brief Read current value of the GPU3D_GC_FEAT_PIPE_2D field. */
#define BR_GPU3D_GC_FEAT_PIPE_2D(x) (HW_GPU3D_GC_FEAT(x).B.PIPE_2D)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field ETC1_TEXTURE_COMPRESSION[10] (RO)
 *
 * ETC1 texture compression.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION (10U) /*!< Bit position for GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION. */
#define BM_GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION (0x00000400U) /*!< Bit mask for GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION. */
#define BS_GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION. */

/*! @brief Read current value of the GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION field. */
#define BR_GPU3D_GC_FEAT_ETC1_TEXTURE_COMPRESSION(x) (HW_GPU3D_GC_FEAT(x).B.ETC1_TEXTURE_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field FAST_SCALER[11] (RO)
 *
 * Shows if the IP has HD scaler.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_FAST_SCALER (11U) /*!< Bit position for GPU3D_GC_FEAT_FAST_SCALER. */
#define BM_GPU3D_GC_FEAT_FAST_SCALER (0x00000800U) /*!< Bit mask for GPU3D_GC_FEAT_FAST_SCALER. */
#define BS_GPU3D_GC_FEAT_FAST_SCALER (1U)  /*!< Bit field size in bits for GPU3D_GC_FEAT_FAST_SCALER. */

/*! @brief Read current value of the GPU3D_GC_FEAT_FAST_SCALER field. */
#define BR_GPU3D_GC_FEAT_FAST_SCALER(x) (HW_GPU3D_GC_FEAT(x).B.FAST_SCALER)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field HIGH_DYNAMIC_RANGE[12] (RO)
 *
 * Shows if the IP has HDR support.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE (12U) /*!< Bit position for GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE. */
#define BM_GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE (0x00001000U) /*!< Bit mask for GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE. */
#define BS_GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE. */

/*! @brief Read current value of the GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE field. */
#define BR_GPU3D_GC_FEAT_HIGH_DYNAMIC_RANGE(x) (HW_GPU3D_GC_FEAT(x).B.HIGH_DYNAMIC_RANGE)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field YUV420_TILER[13] (RO)
 *
 * YUV 4:2:0 tiler is available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_YUV420_TILER (13U) /*!< Bit position for GPU3D_GC_FEAT_YUV420_TILER. */
#define BM_GPU3D_GC_FEAT_YUV420_TILER (0x00002000U) /*!< Bit mask for GPU3D_GC_FEAT_YUV420_TILER. */
#define BS_GPU3D_GC_FEAT_YUV420_TILER (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_YUV420_TILER. */

/*! @brief Read current value of the GPU3D_GC_FEAT_YUV420_TILER field. */
#define BR_GPU3D_GC_FEAT_YUV420_TILER(x) (HW_GPU3D_GC_FEAT(x).B.YUV420_TILER)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field MODULE_CG[14] (RO)
 *
 * Secong level clock gating is available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_MODULE_CG (14U)   /*!< Bit position for GPU3D_GC_FEAT_MODULE_CG. */
#define BM_GPU3D_GC_FEAT_MODULE_CG (0x00004000U) /*!< Bit mask for GPU3D_GC_FEAT_MODULE_CG. */
#define BS_GPU3D_GC_FEAT_MODULE_CG (1U)    /*!< Bit field size in bits for GPU3D_GC_FEAT_MODULE_CG. */

/*! @brief Read current value of the GPU3D_GC_FEAT_MODULE_CG field. */
#define BR_GPU3D_GC_FEAT_MODULE_CG(x) (HW_GPU3D_GC_FEAT(x).B.MODULE_CG)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field MIN_AREA[15] (RO)
 *
 * IP is configured to have minimum area.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_MIN_AREA (15U)    /*!< Bit position for GPU3D_GC_FEAT_MIN_AREA. */
#define BM_GPU3D_GC_FEAT_MIN_AREA (0x00008000U) /*!< Bit mask for GPU3D_GC_FEAT_MIN_AREA. */
#define BS_GPU3D_GC_FEAT_MIN_AREA (1U)     /*!< Bit field size in bits for GPU3D_GC_FEAT_MIN_AREA. */

/*! @brief Read current value of the GPU3D_GC_FEAT_MIN_AREA field. */
#define BR_GPU3D_GC_FEAT_MIN_AREA(x) (HW_GPU3D_GC_FEAT(x).B.MIN_AREA)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field NO_EZ[16] (RO)
 *
 * IP does not have early-Z.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_NO_EZ (16U)       /*!< Bit position for GPU3D_GC_FEAT_NO_EZ. */
#define BM_GPU3D_GC_FEAT_NO_EZ (0x00010000U) /*!< Bit mask for GPU3D_GC_FEAT_NO_EZ. */
#define BS_GPU3D_GC_FEAT_NO_EZ (1U)        /*!< Bit field size in bits for GPU3D_GC_FEAT_NO_EZ. */

/*! @brief Read current value of the GPU3D_GC_FEAT_NO_EZ field. */
#define BR_GPU3D_GC_FEAT_NO_EZ(x) (HW_GPU3D_GC_FEAT(x).B.NO_EZ)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field NO422_TEXTURE[17] (RO)
 *
 * IP does not have 422 texture input format.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_NO422_TEXTURE (17U) /*!< Bit position for GPU3D_GC_FEAT_NO422_TEXTURE. */
#define BM_GPU3D_GC_FEAT_NO422_TEXTURE (0x00020000U) /*!< Bit mask for GPU3D_GC_FEAT_NO422_TEXTURE. */
#define BS_GPU3D_GC_FEAT_NO422_TEXTURE (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_NO422_TEXTURE. */

/*! @brief Read current value of the GPU3D_GC_FEAT_NO422_TEXTURE field. */
#define BR_GPU3D_GC_FEAT_NO422_TEXTURE(x) (HW_GPU3D_GC_FEAT(x).B.NO422_TEXTURE)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field BUFFER_INTERLEAVING[18] (RO)
 *
 * IP supports interleaving depth and color buffers.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_BUFFER_INTERLEAVING (18U) /*!< Bit position for GPU3D_GC_FEAT_BUFFER_INTERLEAVING. */
#define BM_GPU3D_GC_FEAT_BUFFER_INTERLEAVING (0x00040000U) /*!< Bit mask for GPU3D_GC_FEAT_BUFFER_INTERLEAVING. */
#define BS_GPU3D_GC_FEAT_BUFFER_INTERLEAVING (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_BUFFER_INTERLEAVING. */

/*! @brief Read current value of the GPU3D_GC_FEAT_BUFFER_INTERLEAVING field. */
#define BR_GPU3D_GC_FEAT_BUFFER_INTERLEAVING(x) (HW_GPU3D_GC_FEAT(x).B.BUFFER_INTERLEAVING)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field BYTE_WRITE_2D[19] (RO)
 *
 * Supports byte write in 2D.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_BYTE_WRITE_2D (19U) /*!< Bit position for GPU3D_GC_FEAT_BYTE_WRITE_2D. */
#define BM_GPU3D_GC_FEAT_BYTE_WRITE_2D (0x00080000U) /*!< Bit mask for GPU3D_GC_FEAT_BYTE_WRITE_2D. */
#define BS_GPU3D_GC_FEAT_BYTE_WRITE_2D (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_BYTE_WRITE_2D. */

/*! @brief Read current value of the GPU3D_GC_FEAT_BYTE_WRITE_2D field. */
#define BR_GPU3D_GC_FEAT_BYTE_WRITE_2D(x) (HW_GPU3D_GC_FEAT(x).B.BYTE_WRITE_2D)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field NO_SCALER[20] (RO)
 *
 * IP does not have 2D scaler.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_NO_SCALER (20U)   /*!< Bit position for GPU3D_GC_FEAT_NO_SCALER. */
#define BM_GPU3D_GC_FEAT_NO_SCALER (0x00100000U) /*!< Bit mask for GPU3D_GC_FEAT_NO_SCALER. */
#define BS_GPU3D_GC_FEAT_NO_SCALER (1U)    /*!< Bit field size in bits for GPU3D_GC_FEAT_NO_SCALER. */

/*! @brief Read current value of the GPU3D_GC_FEAT_NO_SCALER field. */
#define BR_GPU3D_GC_FEAT_NO_SCALER(x) (HW_GPU3D_GC_FEAT(x).B.NO_SCALER)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field YUY2_AVERAGING[21] (RO)
 *
 * YUY2 averaging support in resolve.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_YUY2_AVERAGING (21U) /*!< Bit position for GPU3D_GC_FEAT_YUY2_AVERAGING. */
#define BM_GPU3D_GC_FEAT_YUY2_AVERAGING (0x00200000U) /*!< Bit mask for GPU3D_GC_FEAT_YUY2_AVERAGING. */
#define BS_GPU3D_GC_FEAT_YUY2_AVERAGING (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_YUY2_AVERAGING. */

/*! @brief Read current value of the GPU3D_GC_FEAT_YUY2_AVERAGING field. */
#define BR_GPU3D_GC_FEAT_YUY2_AVERAGING(x) (HW_GPU3D_GC_FEAT(x).B.YUY2_AVERAGING)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field HALF_PE_CACHE[22] (RO)
 *
 * PE cache is half.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_HALF_PE_CACHE (22U) /*!< Bit position for GPU3D_GC_FEAT_HALF_PE_CACHE. */
#define BM_GPU3D_GC_FEAT_HALF_PE_CACHE (0x00400000U) /*!< Bit mask for GPU3D_GC_FEAT_HALF_PE_CACHE. */
#define BS_GPU3D_GC_FEAT_HALF_PE_CACHE (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_HALF_PE_CACHE. */

/*! @brief Read current value of the GPU3D_GC_FEAT_HALF_PE_CACHE field. */
#define BR_GPU3D_GC_FEAT_HALF_PE_CACHE(x) (HW_GPU3D_GC_FEAT(x).B.HALF_PE_CACHE)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field HALF_TX_CACHE[23] (RO)
 *
 * TX cache is half.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_HALF_TX_CACHE (23U) /*!< Bit position for GPU3D_GC_FEAT_HALF_TX_CACHE. */
#define BM_GPU3D_GC_FEAT_HALF_TX_CACHE (0x00800000U) /*!< Bit mask for GPU3D_GC_FEAT_HALF_TX_CACHE. */
#define BS_GPU3D_GC_FEAT_HALF_TX_CACHE (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_HALF_TX_CACHE. */

/*! @brief Read current value of the GPU3D_GC_FEAT_HALF_TX_CACHE field. */
#define BR_GPU3D_GC_FEAT_HALF_TX_CACHE(x) (HW_GPU3D_GC_FEAT(x).B.HALF_TX_CACHE)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field YUY2_RENDER_TARGET[24] (RO)
 *
 * YUY2 support in PE and YUY2 to RGB conversion in resolve.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_YUY2_RENDER_TARGET (24U) /*!< Bit position for GPU3D_GC_FEAT_YUY2_RENDER_TARGET. */
#define BM_GPU3D_GC_FEAT_YUY2_RENDER_TARGET (0x01000000U) /*!< Bit mask for GPU3D_GC_FEAT_YUY2_RENDER_TARGET. */
#define BS_GPU3D_GC_FEAT_YUY2_RENDER_TARGET (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_YUY2_RENDER_TARGET. */

/*! @brief Read current value of the GPU3D_GC_FEAT_YUY2_RENDER_TARGET field. */
#define BR_GPU3D_GC_FEAT_YUY2_RENDER_TARGET(x) (HW_GPU3D_GC_FEAT(x).B.YUY2_RENDER_TARGET)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field MEM32_BIT_SUPPORT[25] (RO)
 *
 * 32 bit memory address support.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_MEM32_BIT_SUPPORT (25U) /*!< Bit position for GPU3D_GC_FEAT_MEM32_BIT_SUPPORT. */
#define BM_GPU3D_GC_FEAT_MEM32_BIT_SUPPORT (0x02000000U) /*!< Bit mask for GPU3D_GC_FEAT_MEM32_BIT_SUPPORT. */
#define BS_GPU3D_GC_FEAT_MEM32_BIT_SUPPORT (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_MEM32_BIT_SUPPORT. */

/*! @brief Read current value of the GPU3D_GC_FEAT_MEM32_BIT_SUPPORT field. */
#define BR_GPU3D_GC_FEAT_MEM32_BIT_SUPPORT(x) (HW_GPU3D_GC_FEAT(x).B.MEM32_BIT_SUPPORT)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field PIPE_VG[26] (RO)
 *
 * VCG pipe is present.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_PIPE_VG (26U)     /*!< Bit position for GPU3D_GC_FEAT_PIPE_VG. */
#define BM_GPU3D_GC_FEAT_PIPE_VG (0x04000000U) /*!< Bit mask for GPU3D_GC_FEAT_PIPE_VG. */
#define BS_GPU3D_GC_FEAT_PIPE_VG (1U)      /*!< Bit field size in bits for GPU3D_GC_FEAT_PIPE_VG. */

/*! @brief Read current value of the GPU3D_GC_FEAT_PIPE_VG field. */
#define BR_GPU3D_GC_FEAT_PIPE_VG(x) (HW_GPU3D_GC_FEAT(x).B.PIPE_VG)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field VGTS[27] (RO)
 *
 * VG tessellator is present.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_VGTS (27U)        /*!< Bit position for GPU3D_GC_FEAT_VGTS. */
#define BM_GPU3D_GC_FEAT_VGTS (0x08000000U) /*!< Bit mask for GPU3D_GC_FEAT_VGTS. */
#define BS_GPU3D_GC_FEAT_VGTS (1U)         /*!< Bit field size in bits for GPU3D_GC_FEAT_VGTS. */

/*! @brief Read current value of the GPU3D_GC_FEAT_VGTS field. */
#define BR_GPU3D_GC_FEAT_VGTS(x) (HW_GPU3D_GC_FEAT(x).B.VGTS)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field FE20[28] (RO)
 *
 * FE 2.0 is present.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_FE20 (28U)        /*!< Bit position for GPU3D_GC_FEAT_FE20. */
#define BM_GPU3D_GC_FEAT_FE20 (0x10000000U) /*!< Bit mask for GPU3D_GC_FEAT_FE20. */
#define BS_GPU3D_GC_FEAT_FE20 (1U)         /*!< Bit field size in bits for GPU3D_GC_FEAT_FE20. */

/*! @brief Read current value of the GPU3D_GC_FEAT_FE20 field. */
#define BR_GPU3D_GC_FEAT_FE20(x) (HW_GPU3D_GC_FEAT(x).B.FE20)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field BYTE_WRITE_3D[29] (RO)
 *
 * 3D PE has byte write capability.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_BYTE_WRITE_3D (29U) /*!< Bit position for GPU3D_GC_FEAT_BYTE_WRITE_3D. */
#define BM_GPU3D_GC_FEAT_BYTE_WRITE_3D (0x20000000U) /*!< Bit mask for GPU3D_GC_FEAT_BYTE_WRITE_3D. */
#define BS_GPU3D_GC_FEAT_BYTE_WRITE_3D (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_BYTE_WRITE_3D. */

/*! @brief Read current value of the GPU3D_GC_FEAT_BYTE_WRITE_3D field. */
#define BR_GPU3D_GC_FEAT_BYTE_WRITE_3D(x) (HW_GPU3D_GC_FEAT(x).B.BYTE_WRITE_3D)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field RS_YUV_TARGET[30] (RO)
 *
 * Supports resolving into YUV target.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_RS_YUV_TARGET (30U) /*!< Bit position for GPU3D_GC_FEAT_RS_YUV_TARGET. */
#define BM_GPU3D_GC_FEAT_RS_YUV_TARGET (0x40000000U) /*!< Bit mask for GPU3D_GC_FEAT_RS_YUV_TARGET. */
#define BS_GPU3D_GC_FEAT_RS_YUV_TARGET (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_RS_YUV_TARGET. */

/*! @brief Read current value of the GPU3D_GC_FEAT_RS_YUV_TARGET field. */
#define BR_GPU3D_GC_FEAT_RS_YUV_TARGET(x) (HW_GPU3D_GC_FEAT(x).B.RS_YUV_TARGET)
/*@}*/

/*!
 * @name Register GPU3D_GC_FEAT, field FE20_BIT_INDEX[31] (RO)
 *
 * Supports 20 bit index.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GC_FEAT_FE20_BIT_INDEX (31U) /*!< Bit position for GPU3D_GC_FEAT_FE20_BIT_INDEX. */
#define BM_GPU3D_GC_FEAT_FE20_BIT_INDEX (0x80000000U) /*!< Bit mask for GPU3D_GC_FEAT_FE20_BIT_INDEX. */
#define BS_GPU3D_GC_FEAT_FE20_BIT_INDEX (1U) /*!< Bit field size in bits for GPU3D_GC_FEAT_FE20_BIT_INDEX. */

/*! @brief Read current value of the GPU3D_GC_FEAT_FE20_BIT_INDEX field. */
#define BR_GPU3D_GC_FEAT_FE20_BIT_INDEX(x) (HW_GPU3D_GC_FEAT(x).B.FE20_BIT_INDEX)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_ID - GCChipId
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_ID - GCChipId (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the ID for the chip in SBCD. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu3d_gcc_id
{
    uint32_t U;
    struct _hw_gpu3d_gcc_id_bitfields
    {
        uint32_t ID : 32;              /*!< [31:0]  */
    } B;
} hw_gpu3d_gcc_id_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_ID register
 */
/*@{*/
#define HW_GPU3D_GCC_ID_ADDR(x)  ((uintptr_t)(x) + 0x20U)

#define HW_GPU3D_GCC_ID(x)       (*(__I hw_gpu3d_gcc_id_t *) HW_GPU3D_GCC_ID_ADDR(x))
#define HW_GPU3D_GCC_ID_RD(x)    (HW_GPU3D_GCC_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_ID bitfields
 */

/*!
 * @name Register GPU3D_GCC_ID, field ID[31:0] (RO)
 *
 * Id
 */
/*@{*/
#define BP_GPU3D_GCC_ID_ID   (0U)          /*!< Bit position for GPU3D_GCC_ID_ID. */
#define BM_GPU3D_GCC_ID_ID   (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCC_ID_ID. */
#define BS_GPU3D_GCC_ID_ID   (32U)         /*!< Bit field size in bits for GPU3D_GCC_ID_ID. */

/*! @brief Read current value of the GPU3D_GCC_ID_ID field. */
#define BR_GPU3D_GCC_ID_ID(x) (HW_GPU3D_GCC_ID(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_REV - GCChipRev
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_REV - GCChipRev (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the revision for the chip in BCD. This register has no set reset value.
 * It varies with the implementation.
 */
typedef union _hw_gpu3d_gcc_rev
{
    uint32_t U;
    struct _hw_gpu3d_gcc_rev_bitfields
    {
        uint32_t REV : 32;             /*!< [31:0]  */
    } B;
} hw_gpu3d_gcc_rev_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_REV register
 */
/*@{*/
#define HW_GPU3D_GCC_REV_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_GPU3D_GCC_REV(x)      (*(__I hw_gpu3d_gcc_rev_t *) HW_GPU3D_GCC_REV_ADDR(x))
#define HW_GPU3D_GCC_REV_RD(x)   (HW_GPU3D_GCC_REV(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_REV bitfields
 */

/*!
 * @name Register GPU3D_GCC_REV, field REV[31:0] (RO)
 *
 * Revision
 */
/*@{*/
#define BP_GPU3D_GCC_REV_REV (0U)          /*!< Bit position for GPU3D_GCC_REV_REV. */
#define BM_GPU3D_GCC_REV_REV (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCC_REV_REV. */
#define BS_GPU3D_GCC_REV_REV (32U)         /*!< Bit field size in bits for GPU3D_GCC_REV_REV. */

/*! @brief Read current value of the GPU3D_GCC_REV_REV field. */
#define BR_GPU3D_GCC_REV_REV(x) (HW_GPU3D_GCC_REV(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_DATE - GCChipDate
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_DATE - GCChipDate (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the release date for the IP. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu3d_gcc_date
{
    uint32_t U;
    struct _hw_gpu3d_gcc_date_bitfields
    {
        uint32_t DATE : 32;            /*!< [31:0]  */
    } B;
} hw_gpu3d_gcc_date_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_DATE register
 */
/*@{*/
#define HW_GPU3D_GCC_DATE_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_GPU3D_GCC_DATE(x)     (*(__I hw_gpu3d_gcc_date_t *) HW_GPU3D_GCC_DATE_ADDR(x))
#define HW_GPU3D_GCC_DATE_RD(x)  (HW_GPU3D_GCC_DATE(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_DATE bitfields
 */

/*!
 * @name Register GPU3D_GCC_DATE, field DATE[31:0] (RO)
 *
 * Date
 */
/*@{*/
#define BP_GPU3D_GCC_DATE_DATE (0U)        /*!< Bit position for GPU3D_GCC_DATE_DATE. */
#define BM_GPU3D_GCC_DATE_DATE (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCC_DATE_DATE. */
#define BS_GPU3D_GCC_DATE_DATE (32U)       /*!< Bit field size in bits for GPU3D_GCC_DATE_DATE. */

/*! @brief Read current value of the GPU3D_GCC_DATE_DATE field. */
#define BR_GPU3D_GCC_DATE_DATE(x) (HW_GPU3D_GCC_DATE(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_TIME - GCChipTime
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_TIME - GCChipTime (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the release time for the IP. This register has no set reset value. It
 * varies with the implementation.
 */
typedef union _hw_gpu3d_gcc_time
{
    uint32_t U;
    struct _hw_gpu3d_gcc_time_bitfields
    {
        uint32_t TIME : 32;            /*!< [31:0]  */
    } B;
} hw_gpu3d_gcc_time_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_TIME register
 */
/*@{*/
#define HW_GPU3D_GCC_TIME_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_GPU3D_GCC_TIME(x)     (*(__I hw_gpu3d_gcc_time_t *) HW_GPU3D_GCC_TIME_ADDR(x))
#define HW_GPU3D_GCC_TIME_RD(x)  (HW_GPU3D_GCC_TIME(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_TIME bitfields
 */

/*!
 * @name Register GPU3D_GCC_TIME, field TIME[31:0] (RO)
 *
 * Time
 */
/*@{*/
#define BP_GPU3D_GCC_TIME_TIME (0U)        /*!< Bit position for GPU3D_GCC_TIME_TIME. */
#define BM_GPU3D_GCC_TIME_TIME (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCC_TIME_TIME. */
#define BS_GPU3D_GCC_TIME_TIME (32U)       /*!< Bit field size in bits for GPU3D_GCC_TIME_TIME. */

/*! @brief Read current value of the GPU3D_GCC_TIME_TIME field. */
#define BR_GPU3D_GCC_TIME_TIME(x) (HW_GPU3D_GCC_TIME(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_CUST - GCChipCustomer
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_CUST - GCChipCustomer (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows the customer and group for the IP. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu3d_gcc_cust
{
    uint32_t U;
    struct _hw_gpu3d_gcc_cust_bitfields
    {
        uint32_t GROUP : 16;           /*!< [15:0]  */
        uint32_t COMPANY : 16;         /*!< [31:16]  */
    } B;
} hw_gpu3d_gcc_cust_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_CUST register
 */
/*@{*/
#define HW_GPU3D_GCC_CUST_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_GPU3D_GCC_CUST(x)     (*(__I hw_gpu3d_gcc_cust_t *) HW_GPU3D_GCC_CUST_ADDR(x))
#define HW_GPU3D_GCC_CUST_RD(x)  (HW_GPU3D_GCC_CUST(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_CUST bitfields
 */

/*!
 * @name Register GPU3D_GCC_CUST, field GROUP[15:0] (RO)
 *
 * Group
 */
/*@{*/
#define BP_GPU3D_GCC_CUST_GROUP (0U)       /*!< Bit position for GPU3D_GCC_CUST_GROUP. */
#define BM_GPU3D_GCC_CUST_GROUP (0x0000FFFFU) /*!< Bit mask for GPU3D_GCC_CUST_GROUP. */
#define BS_GPU3D_GCC_CUST_GROUP (16U)      /*!< Bit field size in bits for GPU3D_GCC_CUST_GROUP. */

/*! @brief Read current value of the GPU3D_GCC_CUST_GROUP field. */
#define BR_GPU3D_GCC_CUST_GROUP(x) (HW_GPU3D_GCC_CUST(x).B.GROUP)
/*@}*/

/*!
 * @name Register GPU3D_GCC_CUST, field COMPANY[31:16] (RO)
 *
 * Company
 */
/*@{*/
#define BP_GPU3D_GCC_CUST_COMPANY (16U)    /*!< Bit position for GPU3D_GCC_CUST_COMPANY. */
#define BM_GPU3D_GCC_CUST_COMPANY (0xFFFF0000U) /*!< Bit mask for GPU3D_GCC_CUST_COMPANY. */
#define BS_GPU3D_GCC_CUST_COMPANY (16U)    /*!< Bit field size in bits for GPU3D_GCC_CUST_COMPANY. */

/*! @brief Read current value of the GPU3D_GCC_CUST_COMPANY field. */
#define BR_GPU3D_GCC_CUST_COMPANY(x) (HW_GPU3D_GCC_CUST(x).B.COMPANY)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCM_FEAT_0 - GCMinorFeatures0
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCM_FEAT_0 - GCMinorFeatures0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which minor features are enabled in this chip. This register has no set
 * reset value. It varies with the implementation.
 */
typedef union _hw_gpu3d_gcm_feat_0
{
    uint32_t U;
    struct _hw_gpu3d_gcm_feat_0_bitfields
    {
        uint32_t FLIP_Y : 1;           /*!< [0]  */
        uint32_t DUAL_RETURN_BUS : 1;  /*!< [1]  */
        uint32_t ENDIANNESS_CONFIG : 1; /*!< [2]  */
        uint32_t TESTURE8_K : 1;       /*!< [3]  */
        uint32_t CORRECT_TEXTURE_CONVERTER : 1; /*!< [4]  */
        uint32_t SPECIAL_MSAA_LOD : 1; /*!< [5]  */
        uint32_t FAST_CLEAR_FLUSH : 1; /*!< [6]  */
        uint32_t PE202D : 1;           /*!< [7]  */
        uint32_t CORRECT_AUTO_DISABLE : 1; /*!< [8]  */
        uint32_t RENDER_8K : 1;        /*!< [9]  */
        uint32_t TILE_STATUS_2BITS : 1; /*!< [10]  */
        uint32_t SEPARATE_TILE_STATUS_WHEN_INTERLEAVED : 1; /*!< [11]  */
        uint32_t SUPER_TILED_32X32 : 1; /*!< [12]  */
        uint32_t VG_20 : 1;            /*!< [13]  */
        uint32_t TS_EXTENDED_COMMANDS : 1; /*!< [14]  */
        uint32_t COMPRESSION_FIFO_FIXED : 1; /*!< [15]  */
        uint32_t EXTRA_SHADER_INSTRUCTIONS0 : 1; /*!< [16]  */
        uint32_t VG_FILTER : 1;        /*!< [17]  */
        uint32_t VG_21 : 1;            /*!< [18]  */
        uint32_t SHADER_GETS_W : 1;    /*!< [19]  */
        uint32_t EXTRA_SHADER_INSTRUCTIONS1 : 1; /*!< [20]  */
        uint32_t DEFAULT_REG0 : 1;     /*!< [21]  */
        uint32_t MC_20 : 1;            /*!< [22]  */
        uint32_t SHADER_MSAA_SIDEBAND : 1; /*!< [23]  */
        uint32_t BUG_FIXES0 : 1;       /*!< [24]  */
        uint32_t VAA : 1;              /*!< [25]  */
        uint32_t BYPASS_IN_MSAA : 1;   /*!< [26]  */
        uint32_t HIERARCHICAL_Z : 1;   /*!< [27]  */
        uint32_t NEW_TEXTURE : 1;      /*!< [28]  */
        uint32_t A8_TARGET_SUPPORT : 1; /*!< [29]  */
        uint32_t CORRECT_STENCIL : 1;  /*!< [30]  */
        uint32_t ENHANCE_VR : 1;       /*!< [31]  */
    } B;
} hw_gpu3d_gcm_feat_0_t;

/*!
 * @name Constants and macros for entire GPU3D_GCM_FEAT_0 register
 */
/*@{*/
#define HW_GPU3D_GCM_FEAT_0_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_GPU3D_GCM_FEAT_0(x)   (*(__I hw_gpu3d_gcm_feat_0_t *) HW_GPU3D_GCM_FEAT_0_ADDR(x))
#define HW_GPU3D_GCM_FEAT_0_RD(x) (HW_GPU3D_GCM_FEAT_0(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCM_FEAT_0 bitfields
 */

/*!
 * @name Register GPU3D_GCM_FEAT_0, field FLIP_Y[0] (RO)
 *
 * Y flipping capability is added to resolve.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_FLIP_Y (0U)    /*!< Bit position for GPU3D_GCM_FEAT_0_FLIP_Y. */
#define BM_GPU3D_GCM_FEAT_0_FLIP_Y (0x00000001U) /*!< Bit mask for GPU3D_GCM_FEAT_0_FLIP_Y. */
#define BS_GPU3D_GCM_FEAT_0_FLIP_Y (1U)    /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_FLIP_Y. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_FLIP_Y field. */
#define BR_GPU3D_GCM_FEAT_0_FLIP_Y(x) (HW_GPU3D_GCM_FEAT_0(x).B.FLIP_Y)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field DUAL_RETURN_BUS[1] (RO)
 *
 * Dual Return Bus from HI to clients.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS (1U) /*!< Bit position for GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS. */
#define BM_GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS (0x00000002U) /*!< Bit mask for GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS. */
#define BS_GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS field. */
#define BR_GPU3D_GCM_FEAT_0_DUAL_RETURN_BUS(x) (HW_GPU3D_GCM_FEAT_0(x).B.DUAL_RETURN_BUS)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field ENDIANNESS_CONFIG[2] (RO)
 *
 * Configurable endianness support.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG (2U) /*!< Bit position for GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG. */
#define BM_GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG (0x00000004U) /*!< Bit mask for GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG. */
#define BS_GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG field. */
#define BR_GPU3D_GCM_FEAT_0_ENDIANNESS_CONFIG(x) (HW_GPU3D_GCM_FEAT_0(x).B.ENDIANNESS_CONFIG)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field TESTURE8_K[3] (RO)
 *
 * Supports 8Kx8K textures.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_TESTURE8_K (3U) /*!< Bit position for GPU3D_GCM_FEAT_0_TESTURE8_K. */
#define BM_GPU3D_GCM_FEAT_0_TESTURE8_K (0x00000008U) /*!< Bit mask for GPU3D_GCM_FEAT_0_TESTURE8_K. */
#define BS_GPU3D_GCM_FEAT_0_TESTURE8_K (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_TESTURE8_K. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_TESTURE8_K field. */
#define BR_GPU3D_GCM_FEAT_0_TESTURE8_K(x) (HW_GPU3D_GCM_FEAT_0(x).B.TESTURE8_K)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field CORRECT_TEXTURE_CONVERTER[4] (RO)
 *
 * Driver hack is not needed.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER (4U) /*!< Bit position for GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER. */
#define BM_GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER (0x00000010U) /*!< Bit mask for GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER. */
#define BS_GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER field. */
#define BR_GPU3D_GCM_FEAT_0_CORRECT_TEXTURE_CONVERTER(x) (HW_GPU3D_GCM_FEAT_0(x).B.CORRECT_TEXTURE_CONVERTER)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field SPECIAL_MSAA_LOD[5] (RO)
 *
 * Special LOD calculation when MSAA is on.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD (5U) /*!< Bit position for GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD. */
#define BM_GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD (0x00000020U) /*!< Bit mask for GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD. */
#define BS_GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD field. */
#define BR_GPU3D_GCM_FEAT_0_SPECIAL_MSAA_LOD(x) (HW_GPU3D_GCM_FEAT_0(x).B.SPECIAL_MSAA_LOD)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field FAST_CLEAR_FLUSH[6] (RO)
 *
 * Proper flush is done in fast clear cache.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH (6U) /*!< Bit position for GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH. */
#define BM_GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH (0x00000040U) /*!< Bit mask for GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH. */
#define BS_GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH field. */
#define BR_GPU3D_GCM_FEAT_0_FAST_CLEAR_FLUSH(x) (HW_GPU3D_GCM_FEAT_0(x).B.FAST_CLEAR_FLUSH)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field PE202D[7] (RO)
 *
 * 2D PE 2.0 is present.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_PE202D (7U)    /*!< Bit position for GPU3D_GCM_FEAT_0_PE202D. */
#define BM_GPU3D_GCM_FEAT_0_PE202D (0x00000080U) /*!< Bit mask for GPU3D_GCM_FEAT_0_PE202D. */
#define BS_GPU3D_GCM_FEAT_0_PE202D (1U)    /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_PE202D. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_PE202D field. */
#define BR_GPU3D_GCM_FEAT_0_PE202D(x) (HW_GPU3D_GCM_FEAT_0(x).B.PE202D)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field CORRECT_AUTO_DISABLE[8] (RO)
 *
 * Auto disable in FC is correct.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE (8U) /*!< Bit position for GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE. */
#define BM_GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE (0x00000100U) /*!< Bit mask for GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE. */
#define BS_GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE field. */
#define BR_GPU3D_GCM_FEAT_0_CORRECT_AUTO_DISABLE(x) (HW_GPU3D_GCM_FEAT_0(x).B.CORRECT_AUTO_DISABLE)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field RENDER_8K[9] (RO)
 *
 * Supports 8K render target.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_RENDER_8K (9U) /*!< Bit position for GPU3D_GCM_FEAT_0_RENDER_8K. */
#define BM_GPU3D_GCM_FEAT_0_RENDER_8K (0x00000200U) /*!< Bit mask for GPU3D_GCM_FEAT_0_RENDER_8K. */
#define BS_GPU3D_GCM_FEAT_0_RENDER_8K (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_RENDER_8K. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_RENDER_8K field. */
#define BR_GPU3D_GCM_FEAT_0_RENDER_8K(x) (HW_GPU3D_GCM_FEAT_0(x).B.RENDER_8K)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field TILE_STATUS_2BITS[10] (RO)
 *
 * 2 bits are used instead of 4 bits for tile status.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS (10U) /*!< Bit position for GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS. */
#define BM_GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS (0x00000400U) /*!< Bit mask for GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS. */
#define BS_GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS field. */
#define BR_GPU3D_GCM_FEAT_0_TILE_STATUS_2BITS(x) (HW_GPU3D_GCM_FEAT_0(x).B.TILE_STATUS_2BITS)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field SEPARATE_TILE_STATUS_WHEN_INTERLEAVED[11] (RO)
 *
 * Use 2 separate tile status buffers in interleaved mode.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (11U) /*!< Bit position for GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */
#define BM_GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (0x00000800U) /*!< Bit mask for GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */
#define BS_GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED field. */
#define BR_GPU3D_GCM_FEAT_0_SEPARATE_TILE_STATUS_WHEN_INTERLEAVED(x) (HW_GPU3D_GCM_FEAT_0(x).B.SEPARATE_TILE_STATUS_WHEN_INTERLEAVED)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field SUPER_TILED_32X32[12] (RO)
 *
 * 32x32 super tile is available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_SUPER_TILED_32X32 (12U) /*!< Bit position for GPU3D_GCM_FEAT_0_SUPER_TILED_32X32. */
#define BM_GPU3D_GCM_FEAT_0_SUPER_TILED_32X32 (0x00001000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_SUPER_TILED_32X32. */
#define BS_GPU3D_GCM_FEAT_0_SUPER_TILED_32X32 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_SUPER_TILED_32X32. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_SUPER_TILED_32X32 field. */
#define BR_GPU3D_GCM_FEAT_0_SUPER_TILED_32X32(x) (HW_GPU3D_GCM_FEAT_0(x).B.SUPER_TILED_32X32)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field VG_20[13] (RO)
 *
 * Major updates to VG pipe (TS buffer tiling. State masking.).
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_VG_20 (13U)    /*!< Bit position for GPU3D_GCM_FEAT_0_VG_20. */
#define BM_GPU3D_GCM_FEAT_0_VG_20 (0x00002000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_VG_20. */
#define BS_GPU3D_GCM_FEAT_0_VG_20 (1U)     /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_VG_20. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_VG_20 field. */
#define BR_GPU3D_GCM_FEAT_0_VG_20(x) (HW_GPU3D_GCM_FEAT_0(x).B.VG_20)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field TS_EXTENDED_COMMANDS[14] (RO)
 *
 * New commands added to the tessellator.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS (14U) /*!< Bit position for GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS. */
#define BM_GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS (0x00004000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS. */
#define BS_GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS field. */
#define BR_GPU3D_GCM_FEAT_0_TS_EXTENDED_COMMANDS(x) (HW_GPU3D_GCM_FEAT_0(x).B.TS_EXTENDED_COMMANDS)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field COMPRESSION_FIFO_FIXED[15] (RO)
 *
 * If this bit is not set, the FIFO counter should be set to 50. Else, the
 * default should remain.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED (15U) /*!< Bit position for GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED. */
#define BM_GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED (0x00008000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED. */
#define BS_GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED field. */
#define BR_GPU3D_GCM_FEAT_0_COMPRESSION_FIFO_FIXED(x) (HW_GPU3D_GCM_FEAT_0(x).B.COMPRESSION_FIFO_FIXED)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field EXTRA_SHADER_INSTRUCTIONS0[16] (RO)
 *
 * Floor, ceil, and sign instructions are available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0 (16U) /*!< Bit position for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0. */
#define BM_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0 (0x00010000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0. */
#define BS_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0 field. */
#define BR_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS0(x) (HW_GPU3D_GCM_FEAT_0(x).B.EXTRA_SHADER_INSTRUCTIONS0)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field VG_FILTER[17] (RO)
 *
 * VG filter is available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_VG_FILTER (17U) /*!< Bit position for GPU3D_GCM_FEAT_0_VG_FILTER. */
#define BM_GPU3D_GCM_FEAT_0_VG_FILTER (0x00020000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_VG_FILTER. */
#define BS_GPU3D_GCM_FEAT_0_VG_FILTER (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_VG_FILTER. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_VG_FILTER field. */
#define BR_GPU3D_GCM_FEAT_0_VG_FILTER(x) (HW_GPU3D_GCM_FEAT_0(x).B.VG_FILTER)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field VG_21[18] (RO)
 *
 * Minor updates to VG pipe (Event generation from VG, TS, PE). Tiled image
 * support.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_VG_21 (18U)    /*!< Bit position for GPU3D_GCM_FEAT_0_VG_21. */
#define BM_GPU3D_GCM_FEAT_0_VG_21 (0x00040000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_VG_21. */
#define BS_GPU3D_GCM_FEAT_0_VG_21 (1U)     /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_VG_21. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_VG_21 field. */
#define BR_GPU3D_GCM_FEAT_0_VG_21(x) (HW_GPU3D_GCM_FEAT_0(x).B.VG_21)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field SHADER_GETS_W[19] (RO)
 *
 * W is sent to SH from RA.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_SHADER_GETS_W (19U) /*!< Bit position for GPU3D_GCM_FEAT_0_SHADER_GETS_W. */
#define BM_GPU3D_GCM_FEAT_0_SHADER_GETS_W (0x00080000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_SHADER_GETS_W. */
#define BS_GPU3D_GCM_FEAT_0_SHADER_GETS_W (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_SHADER_GETS_W. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_SHADER_GETS_W field. */
#define BR_GPU3D_GCM_FEAT_0_SHADER_GETS_W(x) (HW_GPU3D_GCM_FEAT_0(x).B.SHADER_GETS_W)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field EXTRA_SHADER_INSTRUCTIONS1[20] (RO)
 *
 * Sqrt, sin, cos intructions are available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1 (20U) /*!< Bit position for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1. */
#define BM_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1 (0x00100000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1. */
#define BS_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1 field. */
#define BR_GPU3D_GCM_FEAT_0_EXTRA_SHADER_INSTRUCTIONS1(x) (HW_GPU3D_GCM_FEAT_0(x).B.EXTRA_SHADER_INSTRUCTIONS1)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field DEFAULT_REG0[21] (RO)
 *
 * Unavailable registers will return 0.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_DEFAULT_REG0 (21U) /*!< Bit position for GPU3D_GCM_FEAT_0_DEFAULT_REG0. */
#define BM_GPU3D_GCM_FEAT_0_DEFAULT_REG0 (0x00200000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_DEFAULT_REG0. */
#define BS_GPU3D_GCM_FEAT_0_DEFAULT_REG0 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_DEFAULT_REG0. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_DEFAULT_REG0 field. */
#define BR_GPU3D_GCM_FEAT_0_DEFAULT_REG0(x) (HW_GPU3D_GCM_FEAT_0(x).B.DEFAULT_REG0)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field MC_20[22] (RO)
 *
 * New stlye MC with separate paths for color and depth.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_MC_20 (22U)    /*!< Bit position for GPU3D_GCM_FEAT_0_MC_20. */
#define BM_GPU3D_GCM_FEAT_0_MC_20 (0x00400000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_MC_20. */
#define BS_GPU3D_GCM_FEAT_0_MC_20 (1U)     /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_MC_20. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_MC_20 field. */
#define BR_GPU3D_GCM_FEAT_0_MC_20(x) (HW_GPU3D_GCM_FEAT_0(x).B.MC_20)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field SHADER_MSAA_SIDEBAND[23] (RO)
 *
 * Put the MSAA data into sideband fifo.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND (23U) /*!< Bit position for GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND. */
#define BM_GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND (0x00800000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND. */
#define BS_GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND field. */
#define BR_GPU3D_GCM_FEAT_0_SHADER_MSAA_SIDEBAND(x) (HW_GPU3D_GCM_FEAT_0(x).B.SHADER_MSAA_SIDEBAND)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field BUG_FIXES0[24] (RO)
 *
 * Bug fixes bit 0
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_BUG_FIXES0 (24U) /*!< Bit position for GPU3D_GCM_FEAT_0_BUG_FIXES0. */
#define BM_GPU3D_GCM_FEAT_0_BUG_FIXES0 (0x01000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_BUG_FIXES0. */
#define BS_GPU3D_GCM_FEAT_0_BUG_FIXES0 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_BUG_FIXES0. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_BUG_FIXES0 field. */
#define BR_GPU3D_GCM_FEAT_0_BUG_FIXES0(x) (HW_GPU3D_GCM_FEAT_0(x).B.BUG_FIXES0)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field VAA[25] (RO)
 *
 * VAA is available or not.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_VAA (25U)      /*!< Bit position for GPU3D_GCM_FEAT_0_VAA. */
#define BM_GPU3D_GCM_FEAT_0_VAA (0x02000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_VAA. */
#define BS_GPU3D_GCM_FEAT_0_VAA (1U)       /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_VAA. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_VAA field. */
#define BR_GPU3D_GCM_FEAT_0_VAA(x) (HW_GPU3D_GCM_FEAT_0(x).B.VAA)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field BYPASS_IN_MSAA[26] (RO)
 *
 * Shader supports bypass modew when MSAA is enabled.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA (26U) /*!< Bit position for GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA. */
#define BM_GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA (0x04000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA. */
#define BS_GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA field. */
#define BR_GPU3D_GCM_FEAT_0_BYPASS_IN_MSAA(x) (HW_GPU3D_GCM_FEAT_0(x).B.BYPASS_IN_MSAA)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field HIERARCHICAL_Z[27] (RO)
 *
 * Hierarchical Z is supported.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_HIERARCHICAL_Z (27U) /*!< Bit position for GPU3D_GCM_FEAT_0_HIERARCHICAL_Z. */
#define BM_GPU3D_GCM_FEAT_0_HIERARCHICAL_Z (0x08000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_HIERARCHICAL_Z. */
#define BS_GPU3D_GCM_FEAT_0_HIERARCHICAL_Z (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_HIERARCHICAL_Z. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_HIERARCHICAL_Z field. */
#define BR_GPU3D_GCM_FEAT_0_HIERARCHICAL_Z(x) (HW_GPU3D_GCM_FEAT_0(x).B.HIERARCHICAL_Z)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field NEW_TEXTURE[28] (RO)
 *
 * New texture unit is available.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_NEW_TEXTURE (28U) /*!< Bit position for GPU3D_GCM_FEAT_0_NEW_TEXTURE. */
#define BM_GPU3D_GCM_FEAT_0_NEW_TEXTURE (0x10000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_NEW_TEXTURE. */
#define BS_GPU3D_GCM_FEAT_0_NEW_TEXTURE (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_NEW_TEXTURE. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_NEW_TEXTURE field. */
#define BR_GPU3D_GCM_FEAT_0_NEW_TEXTURE(x) (HW_GPU3D_GCM_FEAT_0(x).B.NEW_TEXTURE)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field A8_TARGET_SUPPORT[29] (RO)
 *
 * 2D engine supports A8 target.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT (29U) /*!< Bit position for GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT. */
#define BM_GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT (0x20000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT. */
#define BS_GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT field. */
#define BR_GPU3D_GCM_FEAT_0_A8_TARGET_SUPPORT(x) (HW_GPU3D_GCM_FEAT_0(x).B.A8_TARGET_SUPPORT)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field CORRECT_STENCIL[30] (RO)
 *
 * Correct stencil behavior in depth only.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_CORRECT_STENCIL (30U) /*!< Bit position for GPU3D_GCM_FEAT_0_CORRECT_STENCIL. */
#define BM_GPU3D_GCM_FEAT_0_CORRECT_STENCIL (0x40000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_CORRECT_STENCIL. */
#define BS_GPU3D_GCM_FEAT_0_CORRECT_STENCIL (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_CORRECT_STENCIL. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_CORRECT_STENCIL field. */
#define BR_GPU3D_GCM_FEAT_0_CORRECT_STENCIL(x) (HW_GPU3D_GCM_FEAT_0(x).B.CORRECT_STENCIL)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_0, field ENHANCE_VR[31] (RO)
 *
 * Enhance VR and add a mode to walk 16 pixels in 16-bit mode in Vertical pass
 * to improve $ hit rate when rotating 90/270.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_0_ENHANCE_VR (31U) /*!< Bit position for GPU3D_GCM_FEAT_0_ENHANCE_VR. */
#define BM_GPU3D_GCM_FEAT_0_ENHANCE_VR (0x80000000U) /*!< Bit mask for GPU3D_GCM_FEAT_0_ENHANCE_VR. */
#define BS_GPU3D_GCM_FEAT_0_ENHANCE_VR (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_0_ENHANCE_VR. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_0_ENHANCE_VR field. */
#define BR_GPU3D_GCM_FEAT_0_ENHANCE_VR(x) (HW_GPU3D_GCM_FEAT_0(x).B.ENHANCE_VR)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_CRTL - GCCacheControl
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_CRTL - GCCacheControl (RW)
 *
 * Reset value: 0x00000000U
 *
 * Not used.
 */
typedef union _hw_gpu3d_gcc_crtl
{
    uint32_t U;
    struct _hw_gpu3d_gcc_crtl_bitfields
    {
        uint32_t NOT_USED : 32;        /*!< [31:0]  */
    } B;
} hw_gpu3d_gcc_crtl_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_CRTL register
 */
/*@{*/
#define HW_GPU3D_GCC_CRTL_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_GPU3D_GCC_CRTL(x)     (*(__IO hw_gpu3d_gcc_crtl_t *) HW_GPU3D_GCC_CRTL_ADDR(x))
#define HW_GPU3D_GCC_CRTL_RD(x)  (HW_GPU3D_GCC_CRTL(x).U)
#define HW_GPU3D_GCC_CRTL_WR(x, v) (HW_GPU3D_GCC_CRTL(x).U = (v))
#define HW_GPU3D_GCC_CRTL_SET(x, v) (HW_GPU3D_GCC_CRTL_WR(x, HW_GPU3D_GCC_CRTL_RD(x) |  (v)))
#define HW_GPU3D_GCC_CRTL_CLR(x, v) (HW_GPU3D_GCC_CRTL_WR(x, HW_GPU3D_GCC_CRTL_RD(x) & ~(v)))
#define HW_GPU3D_GCC_CRTL_TOG(x, v) (HW_GPU3D_GCC_CRTL_WR(x, HW_GPU3D_GCC_CRTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_CRTL bitfields
 */

/*!
 * @name Register GPU3D_GCC_CRTL, field NOT_USED[31:0] (RW)
 *
 * -
 */
/*@{*/
#define BP_GPU3D_GCC_CRTL_NOT_USED (0U)    /*!< Bit position for GPU3D_GCC_CRTL_NOT_USED. */
#define BM_GPU3D_GCC_CRTL_NOT_USED (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCC_CRTL_NOT_USED. */
#define BS_GPU3D_GCC_CRTL_NOT_USED (32U)   /*!< Bit field size in bits for GPU3D_GCC_CRTL_NOT_USED. */

/*! @brief Read current value of the GPU3D_GCC_CRTL_NOT_USED field. */
#define BR_GPU3D_GCC_CRTL_NOT_USED(x) (HW_GPU3D_GCC_CRTL(x).U)

/*! @brief Format value for bitfield GPU3D_GCC_CRTL_NOT_USED. */
#define BF_GPU3D_GCC_CRTL_NOT_USED(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCC_CRTL_NOT_USED) & BM_GPU3D_GCC_CRTL_NOT_USED)

/*! @brief Set the NOT_USED field to a new value. */
#define BW_GPU3D_GCC_CRTL_NOT_USED(x, v) (HW_GPU3D_GCC_CRTL_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCR_MEM_CTRS - GCResetMemCounters
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCR_MEM_CTRS - GCResetMemCounters (RW)
 *
 * Reset value: 0x00000000U
 *
 * Writing 1 will reset the counters and stop counting. Write 0 to start
 * counting again. This register is write only so it has no reset value.
 */
typedef union _hw_gpu3d_gcr_mem_ctrs
{
    uint32_t U;
    struct _hw_gpu3d_gcr_mem_ctrs_bitfields
    {
        uint32_t RESET : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gcr_mem_ctrs_t;

/*!
 * @name Constants and macros for entire GPU3D_GCR_MEM_CTRS register
 */
/*@{*/
#define HW_GPU3D_GCR_MEM_CTRS_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_GPU3D_GCR_MEM_CTRS(x) (*(__IO hw_gpu3d_gcr_mem_ctrs_t *) HW_GPU3D_GCR_MEM_CTRS_ADDR(x))
#define HW_GPU3D_GCR_MEM_CTRS_RD(x) (HW_GPU3D_GCR_MEM_CTRS(x).U)
#define HW_GPU3D_GCR_MEM_CTRS_WR(x, v) (HW_GPU3D_GCR_MEM_CTRS(x).U = (v))
#define HW_GPU3D_GCR_MEM_CTRS_SET(x, v) (HW_GPU3D_GCR_MEM_CTRS_WR(x, HW_GPU3D_GCR_MEM_CTRS_RD(x) |  (v)))
#define HW_GPU3D_GCR_MEM_CTRS_CLR(x, v) (HW_GPU3D_GCR_MEM_CTRS_WR(x, HW_GPU3D_GCR_MEM_CTRS_RD(x) & ~(v)))
#define HW_GPU3D_GCR_MEM_CTRS_TOG(x, v) (HW_GPU3D_GCR_MEM_CTRS_WR(x, HW_GPU3D_GCR_MEM_CTRS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCR_MEM_CTRS bitfields
 */

/*!
 * @name Register GPU3D_GCR_MEM_CTRS, field RESET[31:0] (RW)
 *
 * Reset
 */
/*@{*/
#define BP_GPU3D_GCR_MEM_CTRS_RESET (0U)   /*!< Bit position for GPU3D_GCR_MEM_CTRS_RESET. */
#define BM_GPU3D_GCR_MEM_CTRS_RESET (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCR_MEM_CTRS_RESET. */
#define BS_GPU3D_GCR_MEM_CTRS_RESET (32U)  /*!< Bit field size in bits for GPU3D_GCR_MEM_CTRS_RESET. */

/*! @brief Read current value of the GPU3D_GCR_MEM_CTRS_RESET field. */
#define BR_GPU3D_GCR_MEM_CTRS_RESET(x) (HW_GPU3D_GCR_MEM_CTRS(x).U)

/*! @brief Format value for bitfield GPU3D_GCR_MEM_CTRS_RESET. */
#define BF_GPU3D_GCR_MEM_CTRS_RESET(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCR_MEM_CTRS_RESET) & BM_GPU3D_GCR_MEM_CTRS_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_GPU3D_GCR_MEM_CTRS_RESET(x, v) (HW_GPU3D_GCR_MEM_CTRS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_READS - gcTotalReads
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_READS - gcTotalReads (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total reads in terms of 64 bits.
 */
typedef union _hw_gpu3d_gct_reads
{
    uint32_t U;
    struct _hw_gpu3d_gct_reads_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_reads_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_READS register
 */
/*@{*/
#define HW_GPU3D_GCT_READS_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_GPU3D_GCT_READS(x)    (*(__I hw_gpu3d_gct_reads_t *) HW_GPU3D_GCT_READS_ADDR(x))
#define HW_GPU3D_GCT_READS_RD(x) (HW_GPU3D_GCT_READS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_READS bitfields
 */

/*!
 * @name Register GPU3D_GCT_READS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_READS_COUNT (0U)      /*!< Bit position for GPU3D_GCT_READS_COUNT. */
#define BM_GPU3D_GCT_READS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_READS_COUNT. */
#define BS_GPU3D_GCT_READS_COUNT (32U)     /*!< Bit field size in bits for GPU3D_GCT_READS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_READS_COUNT field. */
#define BR_GPU3D_GCT_READS_COUNT(x) (HW_GPU3D_GCT_READS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_WRITES - gcTotalWrites
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_WRITES - gcTotalWrites (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total writes in terms of 64 bits.
 */
typedef union _hw_gpu3d_gct_writes
{
    uint32_t U;
    struct _hw_gpu3d_gct_writes_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_writes_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_WRITES register
 */
/*@{*/
#define HW_GPU3D_GCT_WRITES_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_GPU3D_GCT_WRITES(x)   (*(__I hw_gpu3d_gct_writes_t *) HW_GPU3D_GCT_WRITES_ADDR(x))
#define HW_GPU3D_GCT_WRITES_RD(x) (HW_GPU3D_GCT_WRITES(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_WRITES bitfields
 */

/*!
 * @name Register GPU3D_GCT_WRITES, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_WRITES_COUNT (0U)     /*!< Bit position for GPU3D_GCT_WRITES_COUNT. */
#define BM_GPU3D_GCT_WRITES_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_WRITES_COUNT. */
#define BS_GPU3D_GCT_WRITES_COUNT (32U)    /*!< Bit field size in bits for GPU3D_GCT_WRITES_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_WRITES_COUNT field. */
#define BR_GPU3D_GCT_WRITES_COUNT(x) (HW_GPU3D_GCT_WRITES(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCC_SPECS - gcChipSpecs
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCC_SPECS - gcChipSpecs (RO)
 *
 * Reset value: 0x00000000U
 *
 * Specs for the chip. This register has no set reset value. It varies with the
 * implementation.
 */
typedef union _hw_gpu3d_gcc_specs
{
    uint32_t U;
    struct _hw_gpu3d_gcc_specs_bitfields
    {
        uint32_t STREAMS : 4;          /*!< [3:0]  */
        uint32_t TEAMP_REGISTERS : 4;  /*!< [7:4]  */
        uint32_t THREAD_COUNT : 4;     /*!< [11:8]  */
        uint32_t VERTEX_CACHE_SIZE : 5; /*!< [16:12]  */
        uint32_t RESERVED0 : 3;        /*!< [19:17]  */
        uint32_t NUM_SHADER_CORES : 5; /*!< [24:20]  */
        uint32_t NUM_PIXEL_PIPES : 3;  /*!< [27:25]  */
        uint32_t VERTEX_OUTPUT_BUFFER_SIZE : 4; /*!< [31:28]  */
    } B;
} hw_gpu3d_gcc_specs_t;

/*!
 * @name Constants and macros for entire GPU3D_GCC_SPECS register
 */
/*@{*/
#define HW_GPU3D_GCC_SPECS_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_GPU3D_GCC_SPECS(x)    (*(__I hw_gpu3d_gcc_specs_t *) HW_GPU3D_GCC_SPECS_ADDR(x))
#define HW_GPU3D_GCC_SPECS_RD(x) (HW_GPU3D_GCC_SPECS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCC_SPECS bitfields
 */

/*!
 * @name Register GPU3D_GCC_SPECS, field STREAMS[3:0] (RO)
 *
 * Number of vertex streams.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_STREAMS (0U)    /*!< Bit position for GPU3D_GCC_SPECS_STREAMS. */
#define BM_GPU3D_GCC_SPECS_STREAMS (0x0000000FU) /*!< Bit mask for GPU3D_GCC_SPECS_STREAMS. */
#define BS_GPU3D_GCC_SPECS_STREAMS (4U)    /*!< Bit field size in bits for GPU3D_GCC_SPECS_STREAMS. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_STREAMS field. */
#define BR_GPU3D_GCC_SPECS_STREAMS(x) (HW_GPU3D_GCC_SPECS(x).B.STREAMS)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field TEAMP_REGISTERS[7:4] (RO)
 *
 * Log2 of temporary registers.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_TEAMP_REGISTERS (4U) /*!< Bit position for GPU3D_GCC_SPECS_TEAMP_REGISTERS. */
#define BM_GPU3D_GCC_SPECS_TEAMP_REGISTERS (0x000000F0U) /*!< Bit mask for GPU3D_GCC_SPECS_TEAMP_REGISTERS. */
#define BS_GPU3D_GCC_SPECS_TEAMP_REGISTERS (4U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_TEAMP_REGISTERS. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_TEAMP_REGISTERS field. */
#define BR_GPU3D_GCC_SPECS_TEAMP_REGISTERS(x) (HW_GPU3D_GCC_SPECS(x).B.TEAMP_REGISTERS)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field THREAD_COUNT[11:8] (RO)
 *
 * Log2 of thread count.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_THREAD_COUNT (8U) /*!< Bit position for GPU3D_GCC_SPECS_THREAD_COUNT. */
#define BM_GPU3D_GCC_SPECS_THREAD_COUNT (0x00000F00U) /*!< Bit mask for GPU3D_GCC_SPECS_THREAD_COUNT. */
#define BS_GPU3D_GCC_SPECS_THREAD_COUNT (4U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_THREAD_COUNT. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_THREAD_COUNT field. */
#define BR_GPU3D_GCC_SPECS_THREAD_COUNT(x) (HW_GPU3D_GCC_SPECS(x).B.THREAD_COUNT)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field VERTEX_CACHE_SIZE[16:12] (RO)
 *
 * Number of entries in the vertex shader cache.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE (12U) /*!< Bit position for GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE. */
#define BM_GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE (0x0001F000U) /*!< Bit mask for GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE. */
#define BS_GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE (5U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE field. */
#define BR_GPU3D_GCC_SPECS_VERTEX_CACHE_SIZE(x) (HW_GPU3D_GCC_SPECS(x).B.VERTEX_CACHE_SIZE)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field NUM_SHADER_CORES[24:20] (RO)
 *
 * Number of shader cores.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_NUM_SHADER_CORES (20U) /*!< Bit position for GPU3D_GCC_SPECS_NUM_SHADER_CORES. */
#define BM_GPU3D_GCC_SPECS_NUM_SHADER_CORES (0x01F00000U) /*!< Bit mask for GPU3D_GCC_SPECS_NUM_SHADER_CORES. */
#define BS_GPU3D_GCC_SPECS_NUM_SHADER_CORES (5U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_NUM_SHADER_CORES. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_NUM_SHADER_CORES field. */
#define BR_GPU3D_GCC_SPECS_NUM_SHADER_CORES(x) (HW_GPU3D_GCC_SPECS(x).B.NUM_SHADER_CORES)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field NUM_PIXEL_PIPES[27:25] (RO)
 *
 * Number of pixel pipes.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_NUM_PIXEL_PIPES (25U) /*!< Bit position for GPU3D_GCC_SPECS_NUM_PIXEL_PIPES. */
#define BM_GPU3D_GCC_SPECS_NUM_PIXEL_PIPES (0x0E000000U) /*!< Bit mask for GPU3D_GCC_SPECS_NUM_PIXEL_PIPES. */
#define BS_GPU3D_GCC_SPECS_NUM_PIXEL_PIPES (3U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_NUM_PIXEL_PIPES. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_NUM_PIXEL_PIPES field. */
#define BR_GPU3D_GCC_SPECS_NUM_PIXEL_PIPES(x) (HW_GPU3D_GCC_SPECS(x).B.NUM_PIXEL_PIPES)
/*@}*/

/*!
 * @name Register GPU3D_GCC_SPECS, field VERTEX_OUTPUT_BUFFER_SIZE[31:28] (RO)
 *
 * Log2 of vertex output buffer size.
 */
/*@{*/
#define BP_GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE (28U) /*!< Bit position for GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE. */
#define BM_GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE (0xF0000000U) /*!< Bit mask for GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE. */
#define BS_GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE (4U) /*!< Bit field size in bits for GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE. */

/*! @brief Read current value of the GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE field. */
#define BR_GPU3D_GCC_SPECS_VERTEX_OUTPUT_BUFFER_SIZE(x) (HW_GPU3D_GCC_SPECS(x).B.VERTEX_OUTPUT_BUFFER_SIZE)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_WRITE_BURSTS - gcTotalWriteBursts
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_WRITE_BURSTS - gcTotalWriteBursts (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total write Data Count in terms of 64 bits. This register has no reset value.
 */
typedef union _hw_gpu3d_gct_write_bursts
{
    uint32_t U;
    struct _hw_gpu3d_gct_write_bursts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_write_bursts_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_WRITE_BURSTS register
 */
/*@{*/
#define HW_GPU3D_GCT_WRITE_BURSTS_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_GPU3D_GCT_WRITE_BURSTS(x) (*(__I hw_gpu3d_gct_write_bursts_t *) HW_GPU3D_GCT_WRITE_BURSTS_ADDR(x))
#define HW_GPU3D_GCT_WRITE_BURSTS_RD(x) (HW_GPU3D_GCT_WRITE_BURSTS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_WRITE_BURSTS bitfields
 */

/*!
 * @name Register GPU3D_GCT_WRITE_BURSTS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_WRITE_BURSTS_COUNT (0U) /*!< Bit position for GPU3D_GCT_WRITE_BURSTS_COUNT. */
#define BM_GPU3D_GCT_WRITE_BURSTS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_WRITE_BURSTS_COUNT. */
#define BS_GPU3D_GCT_WRITE_BURSTS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_WRITE_BURSTS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_WRITE_BURSTS_COUNT field. */
#define BR_GPU3D_GCT_WRITE_BURSTS_COUNT(x) (HW_GPU3D_GCT_WRITE_BURSTS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_WRITE_REQS - gcTotalWriteReqs
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_WRITE_REQS - gcTotalWriteReqs (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total write Request Count. This register has no reset value.
 */
typedef union _hw_gpu3d_gct_write_reqs
{
    uint32_t U;
    struct _hw_gpu3d_gct_write_reqs_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_write_reqs_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_WRITE_REQS register
 */
/*@{*/
#define HW_GPU3D_GCT_WRITE_REQS_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_GPU3D_GCT_WRITE_REQS(x) (*(__I hw_gpu3d_gct_write_reqs_t *) HW_GPU3D_GCT_WRITE_REQS_ADDR(x))
#define HW_GPU3D_GCT_WRITE_REQS_RD(x) (HW_GPU3D_GCT_WRITE_REQS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_WRITE_REQS bitfields
 */

/*!
 * @name Register GPU3D_GCT_WRITE_REQS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_WRITE_REQS_COUNT (0U) /*!< Bit position for GPU3D_GCT_WRITE_REQS_COUNT. */
#define BM_GPU3D_GCT_WRITE_REQS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_WRITE_REQS_COUNT. */
#define BS_GPU3D_GCT_WRITE_REQS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_WRITE_REQS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_WRITE_REQS_COUNT field. */
#define BR_GPU3D_GCT_WRITE_REQS_COUNT(x) (HW_GPU3D_GCT_WRITE_REQS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_WRITE_LASTS - gcTotalWriteLasts
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_WRITE_LASTS - gcTotalWriteLasts (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total WLAST Count. This is used to match with GCTotalWriteReqs. This register
 * has no reset value.
 */
typedef union _hw_gpu3d_gct_write_lasts
{
    uint32_t U;
    struct _hw_gpu3d_gct_write_lasts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_write_lasts_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_WRITE_LASTS register
 */
/*@{*/
#define HW_GPU3D_GCT_WRITE_LASTS_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_GPU3D_GCT_WRITE_LASTS(x) (*(__I hw_gpu3d_gct_write_lasts_t *) HW_GPU3D_GCT_WRITE_LASTS_ADDR(x))
#define HW_GPU3D_GCT_WRITE_LASTS_RD(x) (HW_GPU3D_GCT_WRITE_LASTS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_WRITE_LASTS bitfields
 */

/*!
 * @name Register GPU3D_GCT_WRITE_LASTS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_WRITE_LASTS_COUNT (0U) /*!< Bit position for GPU3D_GCT_WRITE_LASTS_COUNT. */
#define BM_GPU3D_GCT_WRITE_LASTS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_WRITE_LASTS_COUNT. */
#define BS_GPU3D_GCT_WRITE_LASTS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_WRITE_LASTS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_WRITE_LASTS_COUNT field. */
#define BR_GPU3D_GCT_WRITE_LASTS_COUNT(x) (HW_GPU3D_GCT_WRITE_LASTS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_READ_BURSTS - gcTotalReadBursts
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_READ_BURSTS - gcTotalReadBursts (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total Read Data COunt in terms of 64 bits. This register has no reset value.
 */
typedef union _hw_gpu3d_gct_read_bursts
{
    uint32_t U;
    struct _hw_gpu3d_gct_read_bursts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_read_bursts_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_READ_BURSTS register
 */
/*@{*/
#define HW_GPU3D_GCT_READ_BURSTS_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_GPU3D_GCT_READ_BURSTS(x) (*(__I hw_gpu3d_gct_read_bursts_t *) HW_GPU3D_GCT_READ_BURSTS_ADDR(x))
#define HW_GPU3D_GCT_READ_BURSTS_RD(x) (HW_GPU3D_GCT_READ_BURSTS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_READ_BURSTS bitfields
 */

/*!
 * @name Register GPU3D_GCT_READ_BURSTS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_READ_BURSTS_COUNT (0U) /*!< Bit position for GPU3D_GCT_READ_BURSTS_COUNT. */
#define BM_GPU3D_GCT_READ_BURSTS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_READ_BURSTS_COUNT. */
#define BS_GPU3D_GCT_READ_BURSTS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_READ_BURSTS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_READ_BURSTS_COUNT field. */
#define BR_GPU3D_GCT_READ_BURSTS_COUNT(x) (HW_GPU3D_GCT_READ_BURSTS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_READ_REQS - gcTotalReadReqs
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_READ_REQS - gcTotalReadReqs (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total Read Request Count. This register has no reset value. s
 */
typedef union _hw_gpu3d_gct_read_reqs
{
    uint32_t U;
    struct _hw_gpu3d_gct_read_reqs_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_read_reqs_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_READ_REQS register
 */
/*@{*/
#define HW_GPU3D_GCT_READ_REQS_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_GPU3D_GCT_READ_REQS(x) (*(__I hw_gpu3d_gct_read_reqs_t *) HW_GPU3D_GCT_READ_REQS_ADDR(x))
#define HW_GPU3D_GCT_READ_REQS_RD(x) (HW_GPU3D_GCT_READ_REQS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_READ_REQS bitfields
 */

/*!
 * @name Register GPU3D_GCT_READ_REQS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_READ_REQS_COUNT (0U)  /*!< Bit position for GPU3D_GCT_READ_REQS_COUNT. */
#define BM_GPU3D_GCT_READ_REQS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_READ_REQS_COUNT. */
#define BS_GPU3D_GCT_READ_REQS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_READ_REQS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_READ_REQS_COUNT field. */
#define BR_GPU3D_GCT_READ_REQS_COUNT(x) (HW_GPU3D_GCT_READ_REQS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_READ_LASTS - gcTotalReadLasts
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_READ_LASTS - gcTotalReadLasts (RO)
 *
 * Reset value: 0x00000000U
 *
 * Total RLAST Count. This is uset to match with GCTotalReadReqs. This register
 * has no reset value.
 */
typedef union _hw_gpu3d_gct_read_lasts
{
    uint32_t U;
    struct _hw_gpu3d_gct_read_lasts_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_read_lasts_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_READ_LASTS register
 */
/*@{*/
#define HW_GPU3D_GCT_READ_LASTS_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_GPU3D_GCT_READ_LASTS(x) (*(__I hw_gpu3d_gct_read_lasts_t *) HW_GPU3D_GCT_READ_LASTS_ADDR(x))
#define HW_GPU3D_GCT_READ_LASTS_RD(x) (HW_GPU3D_GCT_READ_LASTS(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_READ_LASTS bitfields
 */

/*!
 * @name Register GPU3D_GCT_READ_LASTS, field COUNT[31:0] (RO)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCT_READ_LASTS_COUNT (0U) /*!< Bit position for GPU3D_GCT_READ_LASTS_COUNT. */
#define BM_GPU3D_GCT_READ_LASTS_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_READ_LASTS_COUNT. */
#define BS_GPU3D_GCT_READ_LASTS_COUNT (32U) /*!< Bit field size in bits for GPU3D_GCT_READ_LASTS_COUNT. */

/*! @brief Read current value of the GPU3D_GCT_READ_LASTS_COUNT field. */
#define BR_GPU3D_GCT_READ_LASTS_COUNT(x) (HW_GPU3D_GCT_READ_LASTS(x).U)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCGPO_0 - gcGpOut0
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCGPO_0 - gcGpOut0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register 0. R/W but not connected to anywhere.
 */
typedef union _hw_gpu3d_gcgpo_0
{
    uint32_t U;
    struct _hw_gpu3d_gcgpo_0_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gcgpo_0_t;

/*!
 * @name Constants and macros for entire GPU3D_GCGPO_0 register
 */
/*@{*/
#define HW_GPU3D_GCGPO_0_ADDR(x) ((uintptr_t)(x) + 0x68U)

#define HW_GPU3D_GCGPO_0(x)      (*(__IO hw_gpu3d_gcgpo_0_t *) HW_GPU3D_GCGPO_0_ADDR(x))
#define HW_GPU3D_GCGPO_0_RD(x)   (HW_GPU3D_GCGPO_0(x).U)
#define HW_GPU3D_GCGPO_0_WR(x, v) (HW_GPU3D_GCGPO_0(x).U = (v))
#define HW_GPU3D_GCGPO_0_SET(x, v) (HW_GPU3D_GCGPO_0_WR(x, HW_GPU3D_GCGPO_0_RD(x) |  (v)))
#define HW_GPU3D_GCGPO_0_CLR(x, v) (HW_GPU3D_GCGPO_0_WR(x, HW_GPU3D_GCGPO_0_RD(x) & ~(v)))
#define HW_GPU3D_GCGPO_0_TOG(x, v) (HW_GPU3D_GCGPO_0_WR(x, HW_GPU3D_GCGPO_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCGPO_0 bitfields
 */

/*!
 * @name Register GPU3D_GCGPO_0, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCGPO_0_COUNT (0U)        /*!< Bit position for GPU3D_GCGPO_0_COUNT. */
#define BM_GPU3D_GCGPO_0_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCGPO_0_COUNT. */
#define BS_GPU3D_GCGPO_0_COUNT (32U)       /*!< Bit field size in bits for GPU3D_GCGPO_0_COUNT. */

/*! @brief Read current value of the GPU3D_GCGPO_0_COUNT field. */
#define BR_GPU3D_GCGPO_0_COUNT(x) (HW_GPU3D_GCGPO_0(x).U)

/*! @brief Format value for bitfield GPU3D_GCGPO_0_COUNT. */
#define BF_GPU3D_GCGPO_0_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCGPO_0_COUNT) & BM_GPU3D_GCGPO_0_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU3D_GCGPO_0_COUNT(x, v) (HW_GPU3D_GCGPO_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCGPO_1 - gcGpOut1
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCGPO_1 - gcGpOut1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register 1. R/W but not connected to anywhere.
 */
typedef union _hw_gpu3d_gcgpo_1
{
    uint32_t U;
    struct _hw_gpu3d_gcgpo_1_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gcgpo_1_t;

/*!
 * @name Constants and macros for entire GPU3D_GCGPO_1 register
 */
/*@{*/
#define HW_GPU3D_GCGPO_1_ADDR(x) ((uintptr_t)(x) + 0x6CU)

#define HW_GPU3D_GCGPO_1(x)      (*(__IO hw_gpu3d_gcgpo_1_t *) HW_GPU3D_GCGPO_1_ADDR(x))
#define HW_GPU3D_GCGPO_1_RD(x)   (HW_GPU3D_GCGPO_1(x).U)
#define HW_GPU3D_GCGPO_1_WR(x, v) (HW_GPU3D_GCGPO_1(x).U = (v))
#define HW_GPU3D_GCGPO_1_SET(x, v) (HW_GPU3D_GCGPO_1_WR(x, HW_GPU3D_GCGPO_1_RD(x) |  (v)))
#define HW_GPU3D_GCGPO_1_CLR(x, v) (HW_GPU3D_GCGPO_1_WR(x, HW_GPU3D_GCGPO_1_RD(x) & ~(v)))
#define HW_GPU3D_GCGPO_1_TOG(x, v) (HW_GPU3D_GCGPO_1_WR(x, HW_GPU3D_GCGPO_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCGPO_1 bitfields
 */

/*!
 * @name Register GPU3D_GCGPO_1, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCGPO_1_COUNT (0U)        /*!< Bit position for GPU3D_GCGPO_1_COUNT. */
#define BM_GPU3D_GCGPO_1_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCGPO_1_COUNT. */
#define BS_GPU3D_GCGPO_1_COUNT (32U)       /*!< Bit field size in bits for GPU3D_GCGPO_1_COUNT. */

/*! @brief Read current value of the GPU3D_GCGPO_1_COUNT field. */
#define BR_GPU3D_GCGPO_1_COUNT(x) (HW_GPU3D_GCGPO_1(x).U)

/*! @brief Format value for bitfield GPU3D_GCGPO_1_COUNT. */
#define BF_GPU3D_GCGPO_1_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCGPO_1_COUNT) & BM_GPU3D_GCGPO_1_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU3D_GCGPO_1_COUNT(x, v) (HW_GPU3D_GCGPO_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCGPO_2 - gcGpOut2
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCGPO_2 - gcGpOut2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * General Purpose output register 2. R/W but not connected to anywhere.
 */
typedef union _hw_gpu3d_gcgpo_2
{
    uint32_t U;
    struct _hw_gpu3d_gcgpo_2_bitfields
    {
        uint32_t COUNT : 32;           /*!< [31:0]  */
    } B;
} hw_gpu3d_gcgpo_2_t;

/*!
 * @name Constants and macros for entire GPU3D_GCGPO_2 register
 */
/*@{*/
#define HW_GPU3D_GCGPO_2_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_GPU3D_GCGPO_2(x)      (*(__IO hw_gpu3d_gcgpo_2_t *) HW_GPU3D_GCGPO_2_ADDR(x))
#define HW_GPU3D_GCGPO_2_RD(x)   (HW_GPU3D_GCGPO_2(x).U)
#define HW_GPU3D_GCGPO_2_WR(x, v) (HW_GPU3D_GCGPO_2(x).U = (v))
#define HW_GPU3D_GCGPO_2_SET(x, v) (HW_GPU3D_GCGPO_2_WR(x, HW_GPU3D_GCGPO_2_RD(x) |  (v)))
#define HW_GPU3D_GCGPO_2_CLR(x, v) (HW_GPU3D_GCGPO_2_WR(x, HW_GPU3D_GCGPO_2_RD(x) & ~(v)))
#define HW_GPU3D_GCGPO_2_TOG(x, v) (HW_GPU3D_GCGPO_2_WR(x, HW_GPU3D_GCGPO_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCGPO_2 bitfields
 */

/*!
 * @name Register GPU3D_GCGPO_2, field COUNT[31:0] (RW)
 *
 * Count
 */
/*@{*/
#define BP_GPU3D_GCGPO_2_COUNT (0U)        /*!< Bit position for GPU3D_GCGPO_2_COUNT. */
#define BM_GPU3D_GCGPO_2_COUNT (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCGPO_2_COUNT. */
#define BS_GPU3D_GCGPO_2_COUNT (32U)       /*!< Bit field size in bits for GPU3D_GCGPO_2_COUNT. */

/*! @brief Read current value of the GPU3D_GCGPO_2_COUNT field. */
#define BR_GPU3D_GCGPO_2_COUNT(x) (HW_GPU3D_GCGPO_2(x).U)

/*! @brief Format value for bitfield GPU3D_GCGPO_2_COUNT. */
#define BF_GPU3D_GCGPO_2_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCGPO_2_COUNT) & BM_GPU3D_GCGPO_2_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_GPU3D_GCGPO_2_COUNT(x, v) (HW_GPU3D_GCGPO_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCA_CRTL - gcAxiControl
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCA_CRTL - gcAxiControl (RW)
 *
 * Reset value: 0x00000000U
 *
 * Speacial Handling on AXI Bus.
 */
typedef union _hw_gpu3d_gca_crtl
{
    uint32_t U;
    struct _hw_gpu3d_gca_crtl_bitfields
    {
        uint32_t WR_FULL_BURST_MODE : 1; /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_gpu3d_gca_crtl_t;

/*!
 * @name Constants and macros for entire GPU3D_GCA_CRTL register
 */
/*@{*/
#define HW_GPU3D_GCA_CRTL_ADDR(x) ((uintptr_t)(x) + 0x74U)

#define HW_GPU3D_GCA_CRTL(x)     (*(__IO hw_gpu3d_gca_crtl_t *) HW_GPU3D_GCA_CRTL_ADDR(x))
#define HW_GPU3D_GCA_CRTL_RD(x)  (HW_GPU3D_GCA_CRTL(x).U)
#define HW_GPU3D_GCA_CRTL_WR(x, v) (HW_GPU3D_GCA_CRTL(x).U = (v))
#define HW_GPU3D_GCA_CRTL_SET(x, v) (HW_GPU3D_GCA_CRTL_WR(x, HW_GPU3D_GCA_CRTL_RD(x) |  (v)))
#define HW_GPU3D_GCA_CRTL_CLR(x, v) (HW_GPU3D_GCA_CRTL_WR(x, HW_GPU3D_GCA_CRTL_RD(x) & ~(v)))
#define HW_GPU3D_GCA_CRTL_TOG(x, v) (HW_GPU3D_GCA_CRTL_WR(x, HW_GPU3D_GCA_CRTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCA_CRTL bitfields
 */

/*!
 * @name Register GPU3D_GCA_CRTL, field WR_FULL_BURST_MODE[0] (RW)
 *
 * -
 *
 * Values:
 * - 0 - =>NO_BURST_RESET_VALUE
 * - 1 - =>BURST_RESET_VALUE
 */
/*@{*/
#define BP_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE (0U) /*!< Bit position for GPU3D_GCA_CRTL_WR_FULL_BURST_MODE. */
#define BM_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE (0x00000001U) /*!< Bit mask for GPU3D_GCA_CRTL_WR_FULL_BURST_MODE. */
#define BS_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE (1U) /*!< Bit field size in bits for GPU3D_GCA_CRTL_WR_FULL_BURST_MODE. */

/*! @brief Read current value of the GPU3D_GCA_CRTL_WR_FULL_BURST_MODE field. */
#define BR_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE(x) (HW_GPU3D_GCA_CRTL(x).B.WR_FULL_BURST_MODE)

/*! @brief Format value for bitfield GPU3D_GCA_CRTL_WR_FULL_BURST_MODE. */
#define BF_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE) & BM_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE)

/*! @brief Set the WR_FULL_BURST_MODE field to a new value. */
#define BW_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE(x, v) (HW_GPU3D_GCA_CRTL_WR(x, (HW_GPU3D_GCA_CRTL_RD(x) & ~BM_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE) | BF_GPU3D_GCA_CRTL_WR_FULL_BURST_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCM_FEAT_1 - GCMinorFeatures1
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCM_FEAT_1 - GCMinorFeatures1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Shows which features are enabled in this chip. This register has no set reset
 * value. It varies with the implementation.
 */
typedef union _hw_gpu3d_gcm_feat_1
{
    uint32_t U;
    struct _hw_gpu3d_gcm_feat_1_bitfields
    {
        uint32_t RSUV_SWIZZLE : 1;     /*!< [0]  */
        uint32_t V2_COMPRESSION : 1;   /*!< [1]  */
        uint32_t VG_DOUBLE_BUFFER : 1; /*!< [2]  */
        uint32_t BUG_FIXES1 : 1;       /*!< [3]  */
        uint32_t BUG_FIXES2 : 1;       /*!< [4]  */
        uint32_t TEXTURE_STRIDE : 1;   /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_gpu3d_gcm_feat_1_t;

/*!
 * @name Constants and macros for entire GPU3D_GCM_FEAT_1 register
 */
/*@{*/
#define HW_GPU3D_GCM_FEAT_1_ADDR(x) ((uintptr_t)(x) + 0x78U)

#define HW_GPU3D_GCM_FEAT_1(x)   (*(__I hw_gpu3d_gcm_feat_1_t *) HW_GPU3D_GCM_FEAT_1_ADDR(x))
#define HW_GPU3D_GCM_FEAT_1_RD(x) (HW_GPU3D_GCM_FEAT_1(x).U)
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCM_FEAT_1 bitfields
 */

/*!
 * @name Register GPU3D_GCM_FEAT_1, field RSUV_SWIZZLE[0] (RO)
 *
 * Resolve UV swizzle.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_RSUV_SWIZZLE (0U) /*!< Bit position for GPU3D_GCM_FEAT_1_RSUV_SWIZZLE. */
#define BM_GPU3D_GCM_FEAT_1_RSUV_SWIZZLE (0x00000001U) /*!< Bit mask for GPU3D_GCM_FEAT_1_RSUV_SWIZZLE. */
#define BS_GPU3D_GCM_FEAT_1_RSUV_SWIZZLE (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_RSUV_SWIZZLE. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_RSUV_SWIZZLE field. */
#define BR_GPU3D_GCM_FEAT_1_RSUV_SWIZZLE(x) (HW_GPU3D_GCM_FEAT_1(x).B.RSUV_SWIZZLE)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_1, field V2_COMPRESSION[1] (RO)
 *
 * V2 compression.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_V2_COMPRESSION (1U) /*!< Bit position for GPU3D_GCM_FEAT_1_V2_COMPRESSION. */
#define BM_GPU3D_GCM_FEAT_1_V2_COMPRESSION (0x00000002U) /*!< Bit mask for GPU3D_GCM_FEAT_1_V2_COMPRESSION. */
#define BS_GPU3D_GCM_FEAT_1_V2_COMPRESSION (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_V2_COMPRESSION. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_V2_COMPRESSION field. */
#define BR_GPU3D_GCM_FEAT_1_V2_COMPRESSION(x) (HW_GPU3D_GCM_FEAT_1(x).B.V2_COMPRESSION)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_1, field VG_DOUBLE_BUFFER[2] (RO)
 *
 * Double buffering support for VG (second TS-->VG semaphore is present).
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER (2U) /*!< Bit position for GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER. */
#define BM_GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER (0x00000004U) /*!< Bit mask for GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER. */
#define BS_GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER field. */
#define BR_GPU3D_GCM_FEAT_1_VG_DOUBLE_BUFFER(x) (HW_GPU3D_GCM_FEAT_1(x).B.VG_DOUBLE_BUFFER)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_1, field BUG_FIXES1[3] (RO)
 *
 * Bug fixes bit 1
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_BUG_FIXES1 (3U) /*!< Bit position for GPU3D_GCM_FEAT_1_BUG_FIXES1. */
#define BM_GPU3D_GCM_FEAT_1_BUG_FIXES1 (0x00000008U) /*!< Bit mask for GPU3D_GCM_FEAT_1_BUG_FIXES1. */
#define BS_GPU3D_GCM_FEAT_1_BUG_FIXES1 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_BUG_FIXES1. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_BUG_FIXES1 field. */
#define BR_GPU3D_GCM_FEAT_1_BUG_FIXES1(x) (HW_GPU3D_GCM_FEAT_1(x).B.BUG_FIXES1)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_1, field BUG_FIXES2[4] (RO)
 *
 * Bug fixes bit 2
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_BUG_FIXES2 (4U) /*!< Bit position for GPU3D_GCM_FEAT_1_BUG_FIXES2. */
#define BM_GPU3D_GCM_FEAT_1_BUG_FIXES2 (0x00000010U) /*!< Bit mask for GPU3D_GCM_FEAT_1_BUG_FIXES2. */
#define BS_GPU3D_GCM_FEAT_1_BUG_FIXES2 (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_BUG_FIXES2. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_BUG_FIXES2 field. */
#define BR_GPU3D_GCM_FEAT_1_BUG_FIXES2(x) (HW_GPU3D_GCM_FEAT_1(x).B.BUG_FIXES2)
/*@}*/

/*!
 * @name Register GPU3D_GCM_FEAT_1, field TEXTURE_STRIDE[5] (RO)
 *
 * Texture has stride and memory addressing.
 *
 * Values:
 * - 0 - =>NONE
 * - 1 - =>AVAILABLE
 */
/*@{*/
#define BP_GPU3D_GCM_FEAT_1_TEXTURE_STRIDE (5U) /*!< Bit position for GPU3D_GCM_FEAT_1_TEXTURE_STRIDE. */
#define BM_GPU3D_GCM_FEAT_1_TEXTURE_STRIDE (0x00000020U) /*!< Bit mask for GPU3D_GCM_FEAT_1_TEXTURE_STRIDE. */
#define BS_GPU3D_GCM_FEAT_1_TEXTURE_STRIDE (1U) /*!< Bit field size in bits for GPU3D_GCM_FEAT_1_TEXTURE_STRIDE. */

/*! @brief Read current value of the GPU3D_GCM_FEAT_1_TEXTURE_STRIDE field. */
#define BR_GPU3D_GCM_FEAT_1_TEXTURE_STRIDE(x) (HW_GPU3D_GCM_FEAT_1(x).B.TEXTURE_STRIDE)
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_CYCLES - gcTotalCycles
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_CYCLES - gcTotalCycles (RW)
 *
 * Reset value: 0x00000000U
 *
 * Total cycles. This register is a free-running counter. It can be reset by
 * writing 0 to it.
 */
typedef union _hw_gpu3d_gct_cycles
{
    uint32_t U;
    struct _hw_gpu3d_gct_cycles_bitfields
    {
        uint32_t CYCLES : 32;          /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_cycles_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_CYCLES register
 */
/*@{*/
#define HW_GPU3D_GCT_CYCLES_ADDR(x) ((uintptr_t)(x) + 0x7CU)

#define HW_GPU3D_GCT_CYCLES(x)   (*(__IO hw_gpu3d_gct_cycles_t *) HW_GPU3D_GCT_CYCLES_ADDR(x))
#define HW_GPU3D_GCT_CYCLES_RD(x) (HW_GPU3D_GCT_CYCLES(x).U)
#define HW_GPU3D_GCT_CYCLES_WR(x, v) (HW_GPU3D_GCT_CYCLES(x).U = (v))
#define HW_GPU3D_GCT_CYCLES_SET(x, v) (HW_GPU3D_GCT_CYCLES_WR(x, HW_GPU3D_GCT_CYCLES_RD(x) |  (v)))
#define HW_GPU3D_GCT_CYCLES_CLR(x, v) (HW_GPU3D_GCT_CYCLES_WR(x, HW_GPU3D_GCT_CYCLES_RD(x) & ~(v)))
#define HW_GPU3D_GCT_CYCLES_TOG(x, v) (HW_GPU3D_GCT_CYCLES_WR(x, HW_GPU3D_GCT_CYCLES_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_CYCLES bitfields
 */

/*!
 * @name Register GPU3D_GCT_CYCLES, field CYCLES[31:0] (RW)
 *
 * Cycles
 */
/*@{*/
#define BP_GPU3D_GCT_CYCLES_CYCLES (0U)    /*!< Bit position for GPU3D_GCT_CYCLES_CYCLES. */
#define BM_GPU3D_GCT_CYCLES_CYCLES (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_CYCLES_CYCLES. */
#define BS_GPU3D_GCT_CYCLES_CYCLES (32U)   /*!< Bit field size in bits for GPU3D_GCT_CYCLES_CYCLES. */

/*! @brief Read current value of the GPU3D_GCT_CYCLES_CYCLES field. */
#define BR_GPU3D_GCT_CYCLES_CYCLES(x) (HW_GPU3D_GCT_CYCLES(x).U)

/*! @brief Format value for bitfield GPU3D_GCT_CYCLES_CYCLES. */
#define BF_GPU3D_GCT_CYCLES_CYCLES(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCT_CYCLES_CYCLES) & BM_GPU3D_GCT_CYCLES_CYCLES)

/*! @brief Set the CYCLES field to a new value. */
#define BW_GPU3D_GCT_CYCLES_CYCLES(x, v) (HW_GPU3D_GCT_CYCLES_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_GPU3D_GCT_IDLE_CYCLES - gcTotalIdleCycles
 ******************************************************************************/

/*!
 * @brief HW_GPU3D_GCT_IDLE_CYCLES - gcTotalIdleCycles (RW)
 *
 * Reset value: 0x00000000U
 *
 * Total cycles where the GPU is idle. It is reset when gcTotalCylces register
 * is written to. It looks at all the blocks except FE when determining if the IP
 * is idle.
 */
typedef union _hw_gpu3d_gct_idle_cycles
{
    uint32_t U;
    struct _hw_gpu3d_gct_idle_cycles_bitfields
    {
        uint32_t CYCLES : 32;          /*!< [31:0]  */
    } B;
} hw_gpu3d_gct_idle_cycles_t;

/*!
 * @name Constants and macros for entire GPU3D_GCT_IDLE_CYCLES register
 */
/*@{*/
#define HW_GPU3D_GCT_IDLE_CYCLES_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_GPU3D_GCT_IDLE_CYCLES(x) (*(__IO hw_gpu3d_gct_idle_cycles_t *) HW_GPU3D_GCT_IDLE_CYCLES_ADDR(x))
#define HW_GPU3D_GCT_IDLE_CYCLES_RD(x) (HW_GPU3D_GCT_IDLE_CYCLES(x).U)
#define HW_GPU3D_GCT_IDLE_CYCLES_WR(x, v) (HW_GPU3D_GCT_IDLE_CYCLES(x).U = (v))
#define HW_GPU3D_GCT_IDLE_CYCLES_SET(x, v) (HW_GPU3D_GCT_IDLE_CYCLES_WR(x, HW_GPU3D_GCT_IDLE_CYCLES_RD(x) |  (v)))
#define HW_GPU3D_GCT_IDLE_CYCLES_CLR(x, v) (HW_GPU3D_GCT_IDLE_CYCLES_WR(x, HW_GPU3D_GCT_IDLE_CYCLES_RD(x) & ~(v)))
#define HW_GPU3D_GCT_IDLE_CYCLES_TOG(x, v) (HW_GPU3D_GCT_IDLE_CYCLES_WR(x, HW_GPU3D_GCT_IDLE_CYCLES_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual GPU3D_GCT_IDLE_CYCLES bitfields
 */

/*!
 * @name Register GPU3D_GCT_IDLE_CYCLES, field CYCLES[31:0] (RW)
 *
 * Cycles
 */
/*@{*/
#define BP_GPU3D_GCT_IDLE_CYCLES_CYCLES (0U) /*!< Bit position for GPU3D_GCT_IDLE_CYCLES_CYCLES. */
#define BM_GPU3D_GCT_IDLE_CYCLES_CYCLES (0xFFFFFFFFU) /*!< Bit mask for GPU3D_GCT_IDLE_CYCLES_CYCLES. */
#define BS_GPU3D_GCT_IDLE_CYCLES_CYCLES (32U) /*!< Bit field size in bits for GPU3D_GCT_IDLE_CYCLES_CYCLES. */

/*! @brief Read current value of the GPU3D_GCT_IDLE_CYCLES_CYCLES field. */
#define BR_GPU3D_GCT_IDLE_CYCLES_CYCLES(x) (HW_GPU3D_GCT_IDLE_CYCLES(x).U)

/*! @brief Format value for bitfield GPU3D_GCT_IDLE_CYCLES_CYCLES. */
#define BF_GPU3D_GCT_IDLE_CYCLES_CYCLES(v) ((uint32_t)((uint32_t)(v) << BP_GPU3D_GCT_IDLE_CYCLES_CYCLES) & BM_GPU3D_GCT_IDLE_CYCLES_CYCLES)

/*! @brief Set the CYCLES field to a new value. */
#define BW_GPU3D_GCT_IDLE_CYCLES_CYCLES(x, v) (HW_GPU3D_GCT_IDLE_CYCLES_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_gpu3d_t - module struct
 ******************************************************************************/
/*!
 * @brief All GPU3D module registers.
 */
#pragma pack(1)
typedef struct _hw_gpu3d
{
    __IO hw_gpu3d_aqh_clk_ctrl_t AQH_CLK_CTRL; /*!< [0x0] AQHiClockControl */
    __I hw_gpu3d_aqh_idle_t AQH_IDLE;      /*!< [0x4] AQHIdle */
    __IO hw_gpu3d_aqa_cfg_t AQA_CFG;       /*!< [0x8] AQAxiConfig */
    __I hw_gpu3d_aqa_status_t AQA_STATUS;  /*!< [0xC] AQAxiStatus */
    __I hw_gpu3d_aqi_ack_t AQI_ACK;        /*!< [0x10] AQIntrAcknowledge */
    __IO hw_gpu3d_aqi_enbl_t AQI_ENBL;     /*!< [0x14] AQIntrEnbl */
    __I hw_gpu3d_aqident_t AQIDENT;        /*!< [0x18] AQIdent */
    __I hw_gpu3d_gc_feat_t GC_FEAT;        /*!< [0x1C] GCFeatures */
    __I hw_gpu3d_gcc_id_t GCC_ID;          /*!< [0x20] GCChipId */
    __I hw_gpu3d_gcc_rev_t GCC_REV;        /*!< [0x24] GCChipRev */
    __I hw_gpu3d_gcc_date_t GCC_DATE;      /*!< [0x28] GCChipDate */
    __I hw_gpu3d_gcc_time_t GCC_TIME;      /*!< [0x2C] GCChipTime */
    __I hw_gpu3d_gcc_cust_t GCC_CUST;      /*!< [0x30] GCChipCustomer */
    __I hw_gpu3d_gcm_feat_0_t GCM_FEAT_0;  /*!< [0x34] GCMinorFeatures0 */
    __IO hw_gpu3d_gcc_crtl_t GCC_CRTL;     /*!< [0x38] GCCacheControl */
    __IO hw_gpu3d_gcr_mem_ctrs_t GCR_MEM_CTRS; /*!< [0x3C] GCResetMemCounters */
    __I hw_gpu3d_gct_reads_t GCT_READS;    /*!< [0x40] gcTotalReads */
    __I hw_gpu3d_gct_writes_t GCT_WRITES;  /*!< [0x44] gcTotalWrites */
    __I hw_gpu3d_gcc_specs_t GCC_SPECS;    /*!< [0x48] gcChipSpecs */
    __I hw_gpu3d_gct_write_bursts_t GCT_WRITE_BURSTS; /*!< [0x4C] gcTotalWriteBursts */
    __I hw_gpu3d_gct_write_reqs_t GCT_WRITE_REQS; /*!< [0x50] gcTotalWriteReqs */
    __I hw_gpu3d_gct_write_lasts_t GCT_WRITE_LASTS; /*!< [0x54] gcTotalWriteLasts */
    __I hw_gpu3d_gct_read_bursts_t GCT_READ_BURSTS; /*!< [0x58] gcTotalReadBursts */
    uint8_t _reserved0[4];
    __I hw_gpu3d_gct_read_reqs_t GCT_READ_REQS; /*!< [0x60] gcTotalReadReqs */
    __I hw_gpu3d_gct_read_lasts_t GCT_READ_LASTS; /*!< [0x64] gcTotalReadLasts */
    __IO hw_gpu3d_gcgpo_0_t GCGPO_0;       /*!< [0x68] gcGpOut0 */
    __IO hw_gpu3d_gcgpo_1_t GCGPO_1;       /*!< [0x6C] gcGpOut1 */
    __IO hw_gpu3d_gcgpo_2_t GCGPO_2;       /*!< [0x70] gcGpOut2 */
    __IO hw_gpu3d_gca_crtl_t GCA_CRTL;     /*!< [0x74] gcAxiControl */
    __I hw_gpu3d_gcm_feat_1_t GCM_FEAT_1;  /*!< [0x78] GCMinorFeatures1 */
    __IO hw_gpu3d_gct_cycles_t GCT_CYCLES; /*!< [0x7C] gcTotalCycles */
    __IO hw_gpu3d_gct_idle_cycles_t GCT_IDLE_CYCLES; /*!< [0x80] gcTotalIdleCycles */
} hw_gpu3d_t;
#pragma pack()

/*! @brief Macro to access all GPU3D registers. */
/*! @param x GPU3D module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_GPU3D_REGS(GPU3D_BASE)</code>. */
#define HW_GPU3D_REGS(x) (*(hw_gpu3d_t *)(x))

/*
 * iMX6DP HDMI
 *
 * HDMI
 *
 * Registers defined in this header file:
 * - HW_HDMI_DESIGN_ID - Design Identification Register
 * - HW_HDMI_REVISION_ID - Revision Identification Register
 * - HW_HDMI_PRODUCT_ID0 - Product Identification Register 0
 * - HW_HDMI_PRODUCT_ID1 - Product Identification Register 1
 * - HW_HDMI_CONFIG0_ID - Configuration Identification Register 0
 * - HW_HDMI_CONFIG1_ID - Configuration Identification Register 1
 * - HW_HDMI_CONFIG2_ID - Configuration Identification Register 2
 * - HW_HDMI_CONFIG3_ID - Configuration Identification Register 3
 * - HW_HDMI_IH_FC_STAT0 - Frame Composer Interrupt Status Register 0
 * - HW_HDMI_IH_FC_STAT1 - Frame Composer Interrupt Status Register 1
 * - HW_HDMI_IH_FC_STAT2 - Frame Composer Interrupt Status Register 2
 * - HW_HDMI_IH_AS_STAT0 - Audio Sampler Interrupt Status Register
 * - HW_HDMI_IH_PHY_STAT0 - PHY Interface Interrupt Status Register
 * - HW_HDMI_IH_I2CM_STAT0 - E-DDC I2C Master Interrupt Status Register
 * - HW_HDMI_IH_CEC_STAT0 - CEC Interrupt Status Register
 * - HW_HDMI_IH_VP_STAT0 - Video Packetizer Interrupt Status Register
 * - HW_HDMI_IH_I2CMPHY_STAT0 - PHY GEN2 I2C Master Interrupt Status Register
 * - HW_HDMI_IH_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Status Register
 * - HW_HDMI_IH_MUTE_FC_STAT0 - Frame Composer Interrupt Mute Control Register 0
 * - HW_HDMI_IH_MUTE_FC_STAT1 - Frame Composer Interrupt Mute Control Register 1
 * - HW_HDMI_IH_MUTE_FC_STAT2 - Frame Composer Interrupt Mute Control Register 2
 * - HW_HDMI_IH_MUTE_AS_STAT0 - Audio Sampler Interrupt Mute Control Register 0
 * - HW_HDMI_IH_MUTE_PHY_STAT0 - PHY Interface Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE_I2CM_STAT0 - E-DDC I2C Master Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE_CEC_STAT0 - CEC Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE_VP_STAT0 - Video Packetizer Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE_I2CMPHY_STAT0 - PHY GEN 2 I2C Master Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Mute Control Register
 * - HW_HDMI_IH_MUTE - Global Interrupt Mute Control Register
 * - HW_HDMI_TX_INVID0 - Video Input Mapping and Internal Data Enable Configuration Register
 * - HW_HDMI_TX_INSTUFFING - Video Input Stuffing Enable Register
 * - HW_HDMI_TX_GYDATA0 - Video Input GY Data Channel Stuffing Register 0
 * - HW_HDMI_TX_GYDATA1 - Video Input GY Data Channel Stuffing Register 1
 * - HW_HDMI_TX_RCRDATA0 - Video Input RCR Data Channel Stuffing Register 0
 * - HW_HDMI_TX_RCRDATA1 - Video Input RCR Data Channel Stuffing Register 1
 * - HW_HDMI_TX_BCBDATA0 - Video Input RCB Data Channel Stuffing Register 0
 * - HW_HDMI_TX_BCBDATA1 - Video Input RCB Data Channel Stuffing Register 1
 * - HW_HDMI_VP_STATUS - Video Packetizer Packing Phase Status Register
 * - HW_HDMI_VP_PR_CD - Video Packetizer Pixel Repetition and Color Depth Register
 * - HW_HDMI_VP_STUFF - Video Packetizer Stuffing and Default Packing Phase Register
 * - HW_HDMI_VP_REMAP - Video Packetizer YCC422 Remapping Register
 * - HW_HDMI_VP_CONF - Video Packetizer Output, Bypass, and Enable Configuration Register
 * - HW_HDMI_VP_STAT - VP_STAT
 * - HW_HDMI_VP_INT - VP_INT
 * - HW_HDMI_VP_MASK - Video Packetizer Interrupt Mask Register
 * - HW_HDMI_VP_POL - VP_POL
 * - HW_HDMI_FC_INVIDCONF - Frame Composer Input Video Configuration and HDCP Keepout Register
 * - HW_HDMI_FC_INHACTIV0 - Frame Composer Input Video HActive Pixels Register 0
 * - HW_HDMI_FC_INHACTIV1 - Frame Composer Input Video HActive Pixels Register 1
 * - HW_HDMI_FC_INHBLANK0 - Frame Composer Input Video HBlank Pixels Register 0
 * - HW_HDMI_FC_INHBLANK1 - Frame Composer Input Video HBlank Pixels Register 1
 * - HW_HDMI_FC_INVACTIV0 - Frame Composer Input Video VActive Pixels Register 0
 * - HW_HDMI_FC_INVACTIV1 - Frame Composer Input Video VActive Pixels Register 1
 * - HW_HDMI_FC_INVBLANK - Frame Composer Input Video VBlank Pixels Register
 * - HW_HDMI_FC_HSYNCINDELAY0 - Frame Composer Input Video HSync Front Porch Register 0
 * - HW_HDMI_FC_HSYNCINDELAY1 - Frame Composer Input Video HSync Front Porch Register 1
 * - HW_HDMI_FC_HSYNCINWIDTH0 - Frame Composer Input Video HSync Width Register 0
 * - HW_HDMI_FC_HSYNCINWIDTH1 - Frame Composer Input Video HSync Width Register 1
 * - HW_HDMI_FC_VSYNCINDELAY - Frame Composer Input Video VSync Front Porch Register
 * - HW_HDMI_FC_VSYNCINWIDTH - Frame Composer Input Video VSync Width Register
 * - HW_HDMI_FC_INFREQ0 - Frame Composer Input Video Refresh Rate Register 0
 * - HW_HDMI_FC_INFREQ1 - Frame Composer Input Video Refresh Rate Register 1
 * - HW_HDMI_FC_INFREQ2 - Frame Composer Input Video Refresh Rate Register 2
 * - HW_HDMI_FC_CTRLDUR - Frame Composer Control Period Duration Register
 * - HW_HDMI_FC_EXCTRLDUR - Frame Composer Extended Control Period Duration Register
 * - HW_HDMI_FC_EXCTRLSPAC - Frame Composer Extended Control Period Maximum Spacing Register
 * - HW_HDMI_FC_CH0PREAM - Frame Composer Channel 0 Non-Preamble Data Register
 * - HW_HDMI_FC_CH1PREAM - Frame Composer Channel 1 Non-Preamble Data Register
 * - HW_HDMI_FC_CH2PREAM - Frame Composer Channel 2 Non-Preamble Data Register
 * - HW_HDMI_FC_AVICONF3 - Frame Composer AVI Configuration Register 3
 * - HW_HDMI_FC_GCP - Frame Composer GCP Packet Configuration Register
 * - HW_HDMI_FC_AVICONF0 - Frame Composer AVI Packet Configuration Register 0
 * - HW_HDMI_FC_AVICONF1 - Frame Composer AVI Packet Configuration Register 1
 * - HW_HDMI_FC_AVICONF2 - FC_AVICONFFrame Composer AVI Packet Configuration Register 2
 * - HW_HDMI_FC_AVIVID - Frame Composer AVI Packet VIC Register
 * - HW_HDMI_FC_AVIETB0 - Frame Composer AVI Packet End of Top Bar Register 0
 * - HW_HDMI_FC_AVIETB1 - Frame Composer AVI Packet End of Top Bar Register 1
 * - HW_HDMI_FC_AVISBB0 - Frame Composer AVI Packet Start of Bottom Bar Register 0
 * - HW_HDMI_FC_AVISBB1 - Frame Composer AVI Packet Start of Bottom Bar Register 1
 * - HW_HDMI_FC_AVIELB0 - Frame Composer AVI Packet End of Left Bar Register 0
 * - HW_HDMI_FC_AVIELB1 - Frame Composer AVI Packet End of Left Bar Register 1
 * - HW_HDMI_FC_AVISRB0 - Frame Composer AVI Packet Start of Right Bar Register 0
 * - HW_HDMI_FC_AVISRB1 - Frame Composer AVI Packet Start of Right Bar Register 1
 * - HW_HDMI_FC_AUDICONF0 - Frame Composer AUD Packet Configuration Register 0
 * - HW_HDMI_FC_AUDICONF1 - Frame Composer AUD Packet Configuration Register 1
 * - HW_HDMI_FC_AUDICONF2 - Frame Composer AUD Packet Configuration Register 2
 * - HW_HDMI_FC_AUDICONF3 - Frame Composer AUD Packet Configuration Register 3
 * - HW_HDMI_FC_VSDIEEEID0 - Frame Composer VSI Packet Data IEEE Register 0
 * - HW_HDMI_FC_VSDSIZE - Frame Composer VSI Packet Data Size Register
 * - HW_HDMI_FC_VSDIEEEID1 - Frame Composer VSI Packet Data IEEE Register 1
 * - HW_HDMI_FC_VSDIEEEID2 - Frame Composer VSI Packet Data IEEE Register 2
 * - HW_HDMI_FC_VSDPAYLOAD0 - Frame Composer VSI Packet Data IEEE Register 0
 * - HW_HDMI_FC_VSDPAYLOAD1 - Frame Composer VSI Packet Data IEEE Register 1
 * - HW_HDMI_FC_VSDPAYLOAD2 - Frame Composer VSI Packet Data IEEE Register 2
 * - HW_HDMI_FC_VSDPAYLOAD3 - Frame Composer VSI Packet Data IEEE Register 3
 * - HW_HDMI_FC_VSDPAYLOAD4 - Frame Composer VSI Packet Data IEEE Register 4
 * - HW_HDMI_FC_VSDPAYLOAD5 - Frame Composer VSI Packet Data IEEE Register 5
 * - HW_HDMI_FC_VSDPAYLOAD6 - Frame Composer VSI Packet Data IEEE Register 6
 * - HW_HDMI_FC_VSDPAYLOAD7 - Frame Composer VSI Packet Data IEEE Register 7
 * - HW_HDMI_FC_VSDPAYLOAD8 - Frame Composer VSI Packet Data IEEE Register 8
 * - HW_HDMI_FC_VSDPAYLOAD9 - Frame Composer VSI Packet Data IEEE Register 9
 * - HW_HDMI_FC_VSDPAYLOAD10 - Frame Composer VSI Packet Data IEEE Register 10
 * - HW_HDMI_FC_VSDPAYLOAD11 - Frame Composer VSI Packet Data IEEE Register 11
 * - HW_HDMI_FC_VSDPAYLOAD12 - Frame Composer VSI Packet Data IEEE Register 12
 * - HW_HDMI_FC_VSDPAYLOAD13 - Frame Composer VSI Packet Data IEEE Register 13
 * - HW_HDMI_FC_VSDPAYLOAD14 - Frame Composer VSI Packet Data IEEE Register 14
 * - HW_HDMI_FC_VSDPAYLOAD15 - Frame Composer VSI Packet Data IEEE Register 15
 * - HW_HDMI_FC_VSDPAYLOAD16 - Frame Composer VSI Packet Data IEEE Register 16
 * - HW_HDMI_FC_VSDPAYLOAD17 - Frame Composer VSI Packet Data IEEE Register 17
 * - HW_HDMI_FC_VSDPAYLOAD18 - Frame Composer VSI Packet Data IEEE Register 18
 * - HW_HDMI_FC_VSDPAYLOAD19 - Frame Composer VSI Packet Data IEEE Register 19
 * - HW_HDMI_FC_VSDPAYLOAD20 - Frame Composer VSI Packet Data IEEE Register 20
 * - HW_HDMI_FC_VSDPAYLOAD21 - Frame Composer VSI Packet Data IEEE Register 21
 * - HW_HDMI_FC_VSDPAYLOAD22 - Frame Composer VSI Packet Data IEEE Register 22
 * - HW_HDMI_FC_VSDPAYLOAD23 - Frame Composer VSI Packet Data IEEE Register 23
 * - HW_HDMI_FC_SPDVENDORNAME0 - Frame Composer SPD Packet Data Vendor Name Register 0
 * - HW_HDMI_FC_SPDPRODUCTNAME0 - Frame Composer SPD Packet Data Product Name Register 0
 * - HW_HDMI_FC_SPDDEVICEINF - Frame Composer SPD Packet Data Source Product Descriptor Register
 * - HW_HDMI_FC_AUDSCONF - Frame Composer Audio Sample Flat and Layout Configuration Register
 * - HW_HDMI_FC_AUDSSTAT - Frame Composer Audio Packet Sample Present Status Register
 * - HW_HDMI_FC_CTRLQHIGH - Frame Composer Number of High Priority Packets Attended Configuration Register
 * - HW_HDMI_FC_CTRLQLOW - Frame Composer Number of Low Priority Packets Attended Configuration Register
 * - HW_HDMI_FC_ACP0 - Frame Composer ACP Packet Type Configuration Register 0
 * - HW_HDMI_FC_ACP1 - Frame Composer ACP Packet Type Configuration Register 1
 * - HW_HDMI_FC_ISCR1_0 - FC_ISCR1_Frame Composer Packet Status, Valid, and Continue Configuration Register
 * - HW_HDMI_FC_ISCR1_1 - Frame Composer ISCR1 Packet Body Register 1
 * - HW_HDMI_FC_ISCR2_0 - Frame Composer ISCR2 Packet Body Register 0
 * - HW_HDMI_FC_DATAUTO0 - Frame Composer Data Island Auto Packet Scheduling Register 0
 * - HW_HDMI_FC_DATAUTO1 - Frame Composer Data Island Auto Packet Scheduling Register 1
 * - HW_HDMI_FC_DATAUTO2 - Frame Composer Data Island Auto Packet Scheduling Register 2
 * - HW_HDMI_FC_DATMAN - Frame Composer Data Island Manual Packet Request Register
 * - HW_HDMI_FC_DATAUTO3 - Frame Composer Data Island Auto Packet Scheduling Register 3
 * - HW_HDMI_FC_RDRB0 - Frame Composer Round Robin ACR Packet Insertion Register 0
 * - HW_HDMI_FC_RDRB1 - Frame Composer Round Robin ACR Packet Insertion Register 1
 * - HW_HDMI_FC_RDRB2 - Frame Composer Round Robin ACR Packet Insertion Register 2
 * - HW_HDMI_FC_RDRB3 - Frame Composer Round Robin ACR Packet Insertion Register 3
 * - HW_HDMI_FC_RDRB4 - Frame Composer Round Robin ACR Packet Insertion Register 4
 * - HW_HDMI_FC_RDRB5 - Frame Composer Round Robin ACR Packet Insertion Register 5
 * - HW_HDMI_FC_RDRB6 - Frame Composer Round Robin ACR Packet Insertion Register 6
 * - HW_HDMI_FC_RDRB7 - Frame Composer Round Robin ACR Packet Insertion Register 7
 * - HW_HDMI_FC_STAT0 - FC_STAT0
 * - HW_HDMI_FC_INT0 - FC_INT0
 * - HW_HDMI_FC_MASK0 - Frame Composer Packet Interrupt Mask Register 0
 * - HW_HDMI_FC_POL0 - FC_POL0
 * - HW_HDMI_FC_STAT1 - FC_STAT1
 * - HW_HDMI_FC_INT1 - FC_INT1
 * - HW_HDMI_FC_MASK1 - Frame Composer Packet Interrupt Mask Register 1
 * - HW_HDMI_FC_POL1 - FC_POL1
 * - HW_HDMI_FC_STAT2 - FC_STAT2
 * - HW_HDMI_FC_INT2 - FC_INT2
 * - HW_HDMI_FC_MASK2 - Frame Composer High/Low Priority Overflow Interrupt Mask Register 2
 * - HW_HDMI_FC_POL2 - FC_POL2
 * - HW_HDMI_FC_PRCONF - Frame Composer Pixel Repetition Configuration Register
 * - HW_HDMI_FC_GMD_STAT - Frame Composer GMD Packet Status Register
 * - HW_HDMI_FC_GMD_EN - Frame Composer GMD Packet Enable Register
 * - HW_HDMI_FC_GMD_UP - Frame Composer GMD Packet Update Register
 * - HW_HDMI_FC_GMD_CONF - Frame Composer GMD Packet Schedule Configuration Register
 * - HW_HDMI_FC_GMD_HB - Frame Composer GMD Packet Profile and Gamut Sequence Configuration Register
 * - HW_HDMI_FC_GMD_PB0 - Frame Composer GMD Packet Body Register 0
 * - HW_HDMI_FC_GMD_PB1 - Frame Composer GMD Packet Body Register 1
 * - HW_HDMI_FC_GMD_PB2 - Frame Composer GMD Packet Body Register 2
 * - HW_HDMI_FC_GMD_PB3 - Frame Composer GMD Packet Body Register 3
 * - HW_HDMI_FC_GMD_PB4 - Frame Composer GMD Packet Body Register 4
 * - HW_HDMI_FC_GMD_PB5 - Frame Composer GMD Packet Body Register 5
 * - HW_HDMI_FC_GMD_PB6 - Frame Composer GMD Packet Body Register 6
 * - HW_HDMI_FC_GMD_PB7 - Frame Composer GMD Packet Body Register 7
 * - HW_HDMI_FC_GMD_PB8 - Frame Composer GMD Packet Body Register 8
 * - HW_HDMI_FC_GMD_PB9 - Frame Composer GMD Packet Body Register 9
 * - HW_HDMI_FC_GMD_PB10 - Frame Composer GMD Packet Body Register 10
 * - HW_HDMI_FC_GMD_PB11 - Frame Composer GMD Packet Body Register 11
 * - HW_HDMI_FC_GMD_PB12 - Frame Composer GMD Packet Body Register 12
 * - HW_HDMI_FC_GMD_PB13 - Frame Composer GMD Packet Body Register 13
 * - HW_HDMI_FC_GMD_PB14 - Frame Composer GMD Packet Body Register 14
 * - HW_HDMI_FC_GMD_PB15 - Frame Composer GMD Packet Body Register 15
 * - HW_HDMI_FC_GMD_PB16 - Frame Composer GMD Packet Body Register 16
 * - HW_HDMI_FC_GMD_PB17 - Frame Composer GMD Packet Body Register 17
 * - HW_HDMI_FC_GMD_PB18 - Frame Composer GMD Packet Body Register 18
 * - HW_HDMI_FC_GMD_PB19 - Frame Composer GMD Packet Body Register 19
 * - HW_HDMI_FC_GMD_PB20 - Frame Composer GMD Packet Body Register 20
 * - HW_HDMI_FC_GMD_PB21 - Frame Composer GMD Packet Body Register 21
 * - HW_HDMI_FC_GMD_PB22 - Frame Composer GMD Packet Body Register 22
 * - HW_HDMI_FC_GMD_PB23 - Frame Composer GMD Packet Body Register 23
 * - HW_HDMI_FC_GMD_PB24 - Frame Composer GMD Packet Body Register 24
 * - HW_HDMI_FC_GMD_PB25 - Frame Composer GMD Packet Body Register 25
 * - HW_HDMI_FC_GMD_PB26 - Frame Composer GMD Packet Body Register 26
 * - HW_HDMI_FC_GMD_PB27 - Frame Composer GMD Packet Body Register 27
 * - HW_HDMI_FC_DBGFORCE - Frame Composer Video/Audio Force Enable Register
 * - HW_HDMI_FC_DBGAUD0CH0 - Frame Composer Audio Channel 0 Register 0
 * - HW_HDMI_FC_DBGAUD1CH0 - Frame Composer Audio Channel 0 Register 1
 * - HW_HDMI_FC_DBGAUD2CH0 - Frame Composer Audio Channel 0 Register 2
 * - HW_HDMI_FC_DBGAUD0CH1 - Frame Composer Audio Channel 1 Register 0
 * - HW_HDMI_FC_DBGAUD1CH1 - Frame Composer Audio Channel 1 Register 1
 * - HW_HDMI_FC_DBGAUD2CH1 - Frame Composer Audio Channel 1 Register 2
 * - HW_HDMI_FC_DBGAUD0CH2 - Frame Composer Debug Audio Channel 2 Register 0
 * - HW_HDMI_FC_DBGAUD1CH2 - Frame Composer Debug Audio Channel 2 Register 1
 * - HW_HDMI_FC_DBGAUD2CH2 - Frame Composer Audio Channel 2 Register 2
 * - HW_HDMI_FC_DBGAUD0CH3 - Frame Composer Audio Channel 3 Register 0
 * - HW_HDMI_FC_DBGAUD1CH3 - Frame Composer Audio Channel 3 Register 1
 * - HW_HDMI_FC_DBGAUD2CH3 - Frame Composer Audio Channel 3 Register 2
 * - HW_HDMI_FC_DBGAUD0CH4 - Frame Composer Audio Channel 4 Register 0
 * - HW_HDMI_FC_DBGAUD1CH4 - Frame Composer Audio Channel 4 Register 1
 * - HW_HDMI_FC_DBGAUD2CH4 - Frame Composer Audio Channel 4 Register 2
 * - HW_HDMI_FC_DBGAUD0CH5 - Frame Composer Audio Channel 5 Register 0
 * - HW_HDMI_FC_DBGAUD1CH5 - Frame Composer Audio Channel 5 Register 1
 * - HW_HDMI_FC_DBGAUD2CH5 - Frame Composer Audio Channel 5 Register 2
 * - HW_HDMI_FC_DBGAUD0CH6 - Frame Composer Audio Channel 6 Register 0
 * - HW_HDMI_FC_DBGAUD1CH6 - Frame Composer Audio Channel 6 Register 1
 * - HW_HDMI_FC_DBGAUD2CH6 - Frame Composer Audio Channel 6 Register 2
 * - HW_HDMI_FC_DBGAUD0CH7 - Frame Composer Audio Channel 7 Register 1
 * - HW_HDMI_FC_DBGAUD1CH7 - Frame Composer Audio Channel 7 Register 0
 * - HW_HDMI_FC_DBGAUD2CH7 - Frame Composer Audio Channel 7 Register 2
 * - HW_HDMI_FC_DBGTMDS0 - Frame Composer TMDS Channel 0 Register
 * - HW_HDMI_FC_DBGTMDS1 - Frame Composer TMDS Channel 1 Register
 * - HW_HDMI_FC_DBGTMDS2 - Frame Composer TMDS Channel 2 Register
 * - HW_HDMI_PHY_CONF0 - PHY Configuration Register
 * - HW_HDMI_PHY_TST0 - PHY Test Interface Register 0
 * - HW_HDMI_PHY_TST1 - PHY Test Interface Register 1
 * - HW_HDMI_PHY_TST2 - PHY Test Interface Register 2
 * - HW_HDMI_PHY_STAT0 - PHY RXSENSE, PLL lock, and HPD Status Register
 * - HW_HDMI_PHY_INT0 - PHY RXSENSE, PLL lock, and HPD Interrupt Register
 * - HW_HDMI_PHY_MASK0 - PHY RXSENSE, PLL lock, and HPD Mask Register
 * - HW_HDMI_PHY_POL0 - PHY RXSENSE, PLL lock and HPD Polarity Register
 * - HW_HDMI_PHY_I2CM_SLAVE_ADDR - PHY I2C Slave Address Configuration Register
 * - HW_HDMI_PHY_I2CM_ADDRESS_ADDR - PHY I2C Address Configuration Register
 * - HW_HDMI_PHY_I2CM_DATAO_1_ADDR - PHY I2C Data Write Register 1
 * - HW_HDMI_PHY_I2CM_DATAO_0_ADDR - PHY I2C Data Write Register 0
 * - HW_HDMI_PHY_I2CM_DATAI_1_ADDR - PHY I2C Data Read Register 1
 * - HW_HDMI_PHY_I2CM_DATAI_0_ADDR - PHY I2C Data Read Register 0
 * - HW_HDMI_PHY_I2CM_OPERATION_ADDR - PHY I2C Read/Write Operation
 * - HW_HDMI_PHY_I2CM_INT_ADDR - PHY I2C Done Interrupt Register
 * - HW_HDMI_PHY_I2CM_CTLINT_ADDR - PHY I2C Done Interrupt Register
 * - HW_HDMI_PHY_I2CM_DIV_ADDR - PHY I2C Speed Control Register
 * - HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR - PHY I2C Software Reset Register
 * - HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR - PHY I2C Slow Speed SCL High Level Control Register 1
 * - HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR - PHY I2C Slow Speed SCL High Level Control Register 0
 * - HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 1
 * - HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 0
 * - HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR - PHY I2C Fast Speed SCL High Level Control Register 1
 * - HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR - PHY I2C Fast Speed SCL High Level Control Register 0
 * - HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 1
 * - HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 0
 * - HW_HDMI_AUD_N1 - Audio Clock Regenerator N Value Register 1
 * - HW_HDMI_AUD_N2 - Audio Clock Regenerator N Value Register 2
 * - HW_HDMI_AUD_N3 - Audio Clock Regenerator N Value Register 3
 * - HW_HDMI_AUD_CTS1 - AUD_CTS1
 * - HW_HDMI_AUD_CTS2 - AUD_CTS2
 * - HW_HDMI_AUD_CTS3 - AUD_CTS3
 * - HW_HDMI_AHB_DMA_CONF0 - Audio DMA Start Register
 * - HW_HDMI_AHB_DMA_START - AHB_DMA_START
 * - HW_HDMI_AHB_DMA_STOP - Audio DMA Stop Register
 * - HW_HDMI_AHB_DMA_THRSLD - Audio DMA FIFO Threshold Register
 * - HW_HDMI_AHB_DMA_STRADDR0 - Audio DMA Start Address Register 0
 * - HW_HDMI_AHB_DMA_STRADDR1 - Audio DMA Start Address Register 1
 * - HW_HDMI_AHB_DMA_STRADDR2 - Audio DMA Start Address Register 2
 * - HW_HDMI_AHB_DMA_STRADDR3 - Audio DMA Start Address Register 3
 * - HW_HDMI_AHB_DMA_STPADDR0 - Audio DMA Stop Address Register 0
 * - HW_HDMI_AHB_DMA_STPADDR1 - Audio DMA Stop Address Register 1
 * - HW_HDMI_AHB_DMA_STPADDR2 - Audio DMA Stop Address Register 2
 * - HW_HDMI_AHB_DMA_STPADDR3 - Audio DMA Stop Address Register 3
 * - HW_HDMI_AHB_DMA_BSTADDR0 - Audio DMA Burst Start Address Register 0
 * - HW_HDMI_AHB_DMA_BSTADDR1 - Audio DMA Burst Start Address Register 1
 * - HW_HDMI_AHB_DMA_BSTADDR2 - Audio DMA Burst Start Address Register 2
 * - HW_HDMI_AHB_DMA_BSTADDR3 - Audio DMA Burst Start Address Register 3
 * - HW_HDMI_AHB_DMA_MBLENGTH0 - Audio DMA Burst Length Register 0
 * - HW_HDMI_AHB_DMA_MBLENGTH1 - Audio DMA Burst Length Register 1
 * - HW_HDMI_AHB_DMA_STAT - Audio DMA Interrupt Status Register
 * - HW_HDMI_AHB_DMA_INT - Audio DMA Interrupt Register
 * - HW_HDMI_AHB_DMA_MASK - Audio DMA Mask Interrupt Register
 * - HW_HDMI_AHB_DMA_POL - Audio DMA Polarity Interrupt Register
 * - HW_HDMI_AHB_DMA_CONF1 - Audio DMA Channel Enable Configuration Register 1
 * - HW_HDMI_AHB_DMA_BUFFSTAT - Audio DMA Buffer Interrupt Status Register
 * - HW_HDMI_AHB_DMA_BUFFINT - Audio DMA Buffer Interrupt Register
 * - HW_HDMI_AHB_DMA_BUFFMASK - Audio DMA Buffer Mask Interrupt Register
 * - HW_HDMI_AHB_DMA_BUFFPOL - Audio DMA Buffer Polarity Interrupt Register
 * - HW_HDMI_MC_CLKDIS - Main Controller Synchronous Clock Domain Disable Register
 * - HW_HDMI_MC_SWRSTZREQ - Main Controller Software Reset Register
 * - HW_HDMI_MC_FLOWCTRL - Main Controller Feed Through Control Register
 * - HW_HDMI_MC_PHYRSTZ - Main Controller PHY Reset Register
 * - HW_HDMI_MC_LOCKONCLOCK - Main Controller Clock Present Register
 * - HW_HDMI_MC_HEACPHY_RST - Main Controller HEAC PHY Reset Register
 * - HW_HDMI_CSC_CFG - Color Space Converter Interpolation and Decimation Configuration Register
 * - HW_HDMI_CSC_SCALE - Color Space Converter Scale and Deep Color Configuration Register
 * - HW_HDMI_CSC_COEF_A1_MSB - CSC_COEF_A1_MSB
 * - HW_HDMI_CSC_COEF_A1_LSB - CSC_COEF_A1_LSB
 * - HW_HDMI_CSC_COEF_A2_MSB - CSC_COEF_A2_MSB
 * - HW_HDMI_CSC_COEF_A2_LSB - CSC_COEF_A2_LSB
 * - HW_HDMI_CSC_COEF_A3_MSB - CSC_COEF_A3_MSB
 * - HW_HDMI_CSC_COEF_A3_LSB - CSC_COEF_A3_LSB
 * - HW_HDMI_CSC_COEF_A4_MSB - CSC_COEF_A4_MSB
 * - HW_HDMI_CSC_COEF_A4_LSB - CSC_COEF_A4_LSB
 * - HW_HDMI_CSC_COEF_B1_MSB - CSC_COEF_B1_MSB
 * - HW_HDMI_CSC_COEF_B1_LSB - CSC_COEF_B1_LSB
 * - HW_HDMI_CSC_COEF_B2_MSB - CSC_COEF_B2_MSB
 * - HW_HDMI_CSC_COEF_B2_LSB - CSC_COEF_B2_LSB
 * - HW_HDMI_CSC_COEF_B3_MSB - CSC_COEF_B3_MSB
 * - HW_HDMI_CSC_COEF_B3_LSB - CSC_COEF_B3_LSB
 * - HW_HDMI_CSC_COEF_B4_MSB - CSC_COEF_B4_MSB
 * - HW_HDMI_CSC_COEF_B4_LSB - CSC_COEF_B4_LSB
 * - HW_HDMI_CSC_COEF_C1_MSB - CSC_COEF_C1_MSB
 * - HW_HDMI_CSC_COEF_C1_LSB - CSC_COEF_C1_LSB
 * - HW_HDMI_CSC_COEF_C2_MSB - CSC_COEF_C2_MSB
 * - HW_HDMI_CSC_COEF_C2_LSB - CSC_COEF_C2_LSB
 * - HW_HDMI_CSC_COEF_C3_MSB - CSC_COEF_C3_MSB
 * - HW_HDMI_CSC_COEF_C3_LSB - CSC_COEF_C3_LSB
 * - HW_HDMI_CSC_COEFC4_MSB - CSC_COEFC4_MSB
 * - HW_HDMI_CSC_COEFC4_LSB - CSC_COEFC4_LSB
 * - HW_HDMI_CEC_CTRL - CEC_CTRL
 * - HW_HDMI_CEC_STAT - CEC_STAT
 * - HW_HDMI_CEC_MASK - CEC_MASK
 * - HW_HDMI_CEC_POLARITY - CEC_POLARITY
 * - HW_HDMI_CEC_INT - CEC_INT
 * - HW_HDMI_CEC_ADDR_L - CEC_ADDR_L
 * - HW_HDMI_CEC_ADDR_H - CEC_ADDR_H
 * - HW_HDMI_CEC_TX_CNT - CEC_TX_CNT
 * - HW_HDMI_CEC_RX_CNT - CEC_RX_CNT
 * - HW_HDMI_CEC_TX_DATAn - CEC_TX_DATA
 * - HW_HDMI_CEC_RX_DATAn - CEC_RX_DATA
 * - HW_HDMI_CEC_LOCK - CEC_LOCK
 * - HW_HDMI_CEC_WKUPCTRL - CEC_WKUPCTRL
 * - HW_HDMI_I2CM_SLAVE - I2CM_SLAVE
 * - HW_HDMI_I2CM_ADDRESS - I2CM_ADDRESS
 * - HW_HDMI_I2CM_DATAO - I2CM_DATAO
 * - HW_HDMI_I2CM_DATAI - I2CM_DATAI
 * - HW_HDMI_I2CM_OPERATION - I2CM_OPERATION
 * - HW_HDMI_I2CM_INT - I2CM_INT
 * - HW_HDMI_I2CM_CTLINT - I2CM_CTLINT
 * - HW_HDMI_I2CM_DIV - I2CM_DIV
 * - HW_HDMI_I2CM_SEGADDR - I2CM_SEGADDR
 * - HW_HDMI_I2CM_SOFTRSTZ - I2CM_SOFTRSTZ
 * - HW_HDMI_I2CM_SEGPTR - I2CM_SEGPTR
 * - HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR - I2CM_SS_SCL_HCNT_1_ADDR
 * - HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR - I2CM_SS_SCL_HCNT_0_ADDR
 * - HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR - I2CM_SS_SCL_LCNT_1_ADDR
 * - HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR - I2CM_SS_SCL_LCNT_0_ADDR
 * - HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR - I2CM_FS_SCL_HCNT_1_ADDR
 * - HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR - I2CM_FS_SCL_HCNT_0_ADDR
 * - HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR - I2CM_FS_SCL_LCNT_1_ADDR
 * - HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR - I2CM_FS_SCL_LCNT_0_ADDR
 * - HW_HDMI_BASE_POINTER_ADDR - BASE_POINTER_ADDR
 *
 * - hw_hdmi_t - Struct containing all module registers.
 */

#define HW_HDMI_INSTANCE_COUNT (1U) /*!< Number of instances of the HDMI module. */
#define HW_HDMI (0U) /*!< Instance number for HDMI. */
#define HDMI_BASE             (0x120000U) /*!< Base address for HDMI. */
/*! Array initializer of HDMI base addresses. */
#define HDMI_BASE_ADDRS       { HDMI_BASE }

/*******************************************************************************
 * HW_HDMI_DESIGN_ID - Design Identification Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_DESIGN_ID - Design Identification Register (RO)
 *
 * Reset value: 0x00U
 *
 * The following are the registers used to identify the HDMI TX controller.
 * Name: Design Identification Register Address Offset: 0x0000 Size: 8 bits Value
 * after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_design_id
{
    uint8_t U;
    struct _hw_hdmi_design_id_bitfields
    {
        uint8_t DESIGN_ID : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_design_id_t;

/*!
 * @name Constants and macros for entire HDMI_DESIGN_ID register
 */
/*@{*/
#define HW_HDMI_DESIGN_ID_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_HDMI_DESIGN_ID(x)     (*(__I hw_hdmi_design_id_t *) HW_HDMI_DESIGN_ID_ADDR(x))
#define HW_HDMI_DESIGN_ID_RD(x)  (HW_HDMI_DESIGN_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_DESIGN_ID bitfields
 */

/*!
 * @name Register HDMI_DESIGN_ID, field DESIGN_ID[7:0] (RO)
 *
 * This is a 1 byte design ID code fixed by Freescale that Identifies the main
 * revision of the HDMI TX controller. For example, HDMI TX 1.30a, DESIGN_ID =
 * 11h; REVISION_ID = 0Ah
 */
/*@{*/
#define BP_HDMI_DESIGN_ID_DESIGN_ID (0U)   /*!< Bit position for HDMI_DESIGN_ID_DESIGN_ID. */
#define BM_HDMI_DESIGN_ID_DESIGN_ID (0xFFU) /*!< Bit mask for HDMI_DESIGN_ID_DESIGN_ID. */
#define BS_HDMI_DESIGN_ID_DESIGN_ID (8U)   /*!< Bit field size in bits for HDMI_DESIGN_ID_DESIGN_ID. */

/*! @brief Read current value of the HDMI_DESIGN_ID_DESIGN_ID field. */
#define BR_HDMI_DESIGN_ID_DESIGN_ID(x) (HW_HDMI_DESIGN_ID(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_REVISION_ID - Revision Identification Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_REVISION_ID - Revision Identification Register (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Revision Identification Register Address Offset: 0x0001 Size: 8 bits
 * Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_revision_id
{
    uint8_t U;
    struct _hw_hdmi_revision_id_bitfields
    {
        uint8_t REVISION_ID : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_revision_id_t;

/*!
 * @name Constants and macros for entire HDMI_REVISION_ID register
 */
/*@{*/
#define HW_HDMI_REVISION_ID_ADDR(x) ((uintptr_t)(x) + 0x1U)

#define HW_HDMI_REVISION_ID(x)   (*(__I hw_hdmi_revision_id_t *) HW_HDMI_REVISION_ID_ADDR(x))
#define HW_HDMI_REVISION_ID_RD(x) (HW_HDMI_REVISION_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_REVISION_ID bitfields
 */

/*!
 * @name Register HDMI_REVISION_ID, field REVISION_ID[7:0] (RO)
 *
 * This is a one byte revision ID code fixed by Freescale that Identifies the
 * main revision of the HDMI TX controller. For example, HDMI TX 1.30a, DESIGN_ID =
 * 12h; REVISION_ID = 0Ah
 */
/*@{*/
#define BP_HDMI_REVISION_ID_REVISION_ID (0U) /*!< Bit position for HDMI_REVISION_ID_REVISION_ID. */
#define BM_HDMI_REVISION_ID_REVISION_ID (0xFFU) /*!< Bit mask for HDMI_REVISION_ID_REVISION_ID. */
#define BS_HDMI_REVISION_ID_REVISION_ID (8U) /*!< Bit field size in bits for HDMI_REVISION_ID_REVISION_ID. */

/*! @brief Read current value of the HDMI_REVISION_ID_REVISION_ID field. */
#define BR_HDMI_REVISION_ID_REVISION_ID(x) (HW_HDMI_REVISION_ID(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PRODUCT_ID0 - Product Identification Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PRODUCT_ID0 - Product Identification Register 0 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Product Identification Register 0 Address Offset: 0x0002 Size: 8 bits
 * Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_product_id0
{
    uint8_t U;
    struct _hw_hdmi_product_id0_bitfields
    {
        uint8_t PRODUCT_ID0 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_product_id0_t;

/*!
 * @name Constants and macros for entire HDMI_PRODUCT_ID0 register
 */
/*@{*/
#define HW_HDMI_PRODUCT_ID0_ADDR(x) ((uintptr_t)(x) + 0x2U)

#define HW_HDMI_PRODUCT_ID0(x)   (*(__I hw_hdmi_product_id0_t *) HW_HDMI_PRODUCT_ID0_ADDR(x))
#define HW_HDMI_PRODUCT_ID0_RD(x) (HW_HDMI_PRODUCT_ID0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PRODUCT_ID0 bitfields
 */

/*!
 * @name Register HDMI_PRODUCT_ID0, field PRODUCT_ID0[7:0] (RO)
 *
 * This one byte fixed code Identifies Freescale's product line ("A0h" for HDMI
 * TX products).
 */
/*@{*/
#define BP_HDMI_PRODUCT_ID0_PRODUCT_ID0 (0U) /*!< Bit position for HDMI_PRODUCT_ID0_PRODUCT_ID0. */
#define BM_HDMI_PRODUCT_ID0_PRODUCT_ID0 (0xFFU) /*!< Bit mask for HDMI_PRODUCT_ID0_PRODUCT_ID0. */
#define BS_HDMI_PRODUCT_ID0_PRODUCT_ID0 (8U) /*!< Bit field size in bits for HDMI_PRODUCT_ID0_PRODUCT_ID0. */

/*! @brief Read current value of the HDMI_PRODUCT_ID0_PRODUCT_ID0 field. */
#define BR_HDMI_PRODUCT_ID0_PRODUCT_ID0(x) (HW_HDMI_PRODUCT_ID0(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PRODUCT_ID1 - Product Identification Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PRODUCT_ID1 - Product Identification Register 1 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Product Identification Register 1 Address Offset: 0x0003 Size: 8 bits
 * Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_product_id1
{
    uint8_t U;
    struct _hw_hdmi_product_id1_bitfields
    {
        uint8_t PRODUCT_ID1 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_product_id1_t;

/*!
 * @name Constants and macros for entire HDMI_PRODUCT_ID1 register
 */
/*@{*/
#define HW_HDMI_PRODUCT_ID1_ADDR(x) ((uintptr_t)(x) + 0x3U)

#define HW_HDMI_PRODUCT_ID1(x)   (*(__I hw_hdmi_product_id1_t *) HW_HDMI_PRODUCT_ID1_ADDR(x))
#define HW_HDMI_PRODUCT_ID1_RD(x) (HW_HDMI_PRODUCT_ID1(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PRODUCT_ID1 bitfields
 */

/*!
 * @name Register HDMI_PRODUCT_ID1, field PRODUCT_ID1[7:0] (RO)
 *
 * This one byte fixed code identifies Freescale's product line according to:
 * 01h HDMI TX Controller C1h HDMI TX Controller with HDCP encryption engine
 */
/*@{*/
#define BP_HDMI_PRODUCT_ID1_PRODUCT_ID1 (0U) /*!< Bit position for HDMI_PRODUCT_ID1_PRODUCT_ID1. */
#define BM_HDMI_PRODUCT_ID1_PRODUCT_ID1 (0xFFU) /*!< Bit mask for HDMI_PRODUCT_ID1_PRODUCT_ID1. */
#define BS_HDMI_PRODUCT_ID1_PRODUCT_ID1 (8U) /*!< Bit field size in bits for HDMI_PRODUCT_ID1_PRODUCT_ID1. */

/*! @brief Read current value of the HDMI_PRODUCT_ID1_PRODUCT_ID1 field. */
#define BR_HDMI_PRODUCT_ID1_PRODUCT_ID1(x) (HW_HDMI_PRODUCT_ID1(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CONFIG0_ID - Configuration Identification Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CONFIG0_ID - Configuration Identification Register 0 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Configuration Identification Register 0 Address Offset: 0x0004 Size: 8
 * bits Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_config0_id
{
    uint8_t U;
    struct _hw_hdmi_config0_id_bitfields
    {
        uint8_t hdcp : 1;              /*!< [0]  */
        uint8_t cec : 1;               /*!< [1]  */
        uint8_t csc : 1;               /*!< [2]  */
        uint8_t hdmi14 : 1;            /*!< [3]  */
        uint8_t audi2s : 1;            /*!< [4]  */
        uint8_t audspdif : 1;          /*!< [5]  */
        uint8_t audhbr : 1;            /*!< [6]  */
        uint8_t prepen : 1;            /*!< [7]  */
    } B;
} hw_hdmi_config0_id_t;

/*!
 * @name Constants and macros for entire HDMI_CONFIG0_ID register
 */
/*@{*/
#define HW_HDMI_CONFIG0_ID_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_HDMI_CONFIG0_ID(x)    (*(__I hw_hdmi_config0_id_t *) HW_HDMI_CONFIG0_ID_ADDR(x))
#define HW_HDMI_CONFIG0_ID_RD(x) (HW_HDMI_CONFIG0_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CONFIG0_ID bitfields
 */

/*!
 * @name Register HDMI_CONFIG0_ID, field hdcp[0] (RO)
 *
 * Indicates if HDCP is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_hdcp (0U)       /*!< Bit position for HDMI_CONFIG0_ID_hdcp. */
#define BM_HDMI_CONFIG0_ID_hdcp (0x01U)    /*!< Bit mask for HDMI_CONFIG0_ID_hdcp. */
#define BS_HDMI_CONFIG0_ID_hdcp (1U)       /*!< Bit field size in bits for HDMI_CONFIG0_ID_hdcp. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_hdcp field. */
#define BR_HDMI_CONFIG0_ID_hdcp(x) (HW_HDMI_CONFIG0_ID(x).B.hdcp)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field cec[1] (RO)
 *
 * Indicates if CEC is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_cec (1U)        /*!< Bit position for HDMI_CONFIG0_ID_cec. */
#define BM_HDMI_CONFIG0_ID_cec (0x02U)     /*!< Bit mask for HDMI_CONFIG0_ID_cec. */
#define BS_HDMI_CONFIG0_ID_cec (1U)        /*!< Bit field size in bits for HDMI_CONFIG0_ID_cec. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_cec field. */
#define BR_HDMI_CONFIG0_ID_cec(x) (HW_HDMI_CONFIG0_ID(x).B.cec)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field csc[2] (RO)
 *
 * Indicates if Color Space Conversion block is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_csc (2U)        /*!< Bit position for HDMI_CONFIG0_ID_csc. */
#define BM_HDMI_CONFIG0_ID_csc (0x04U)     /*!< Bit mask for HDMI_CONFIG0_ID_csc. */
#define BS_HDMI_CONFIG0_ID_csc (1U)        /*!< Bit field size in bits for HDMI_CONFIG0_ID_csc. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_csc field. */
#define BR_HDMI_CONFIG0_ID_csc(x) (HW_HDMI_CONFIG0_ID(x).B.csc)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field hdmi14[3] (RO)
 *
 * Indicates if HDMI 1.4 features are present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_hdmi14 (3U)     /*!< Bit position for HDMI_CONFIG0_ID_hdmi14. */
#define BM_HDMI_CONFIG0_ID_hdmi14 (0x08U)  /*!< Bit mask for HDMI_CONFIG0_ID_hdmi14. */
#define BS_HDMI_CONFIG0_ID_hdmi14 (1U)     /*!< Bit field size in bits for HDMI_CONFIG0_ID_hdmi14. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_hdmi14 field. */
#define BR_HDMI_CONFIG0_ID_hdmi14(x) (HW_HDMI_CONFIG0_ID(x).B.hdmi14)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field audi2s[4] (RO)
 *
 * Indicates if I2S interface is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_audi2s (4U)     /*!< Bit position for HDMI_CONFIG0_ID_audi2s. */
#define BM_HDMI_CONFIG0_ID_audi2s (0x10U)  /*!< Bit mask for HDMI_CONFIG0_ID_audi2s. */
#define BS_HDMI_CONFIG0_ID_audi2s (1U)     /*!< Bit field size in bits for HDMI_CONFIG0_ID_audi2s. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_audi2s field. */
#define BR_HDMI_CONFIG0_ID_audi2s(x) (HW_HDMI_CONFIG0_ID(x).B.audi2s)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field audspdif[5] (RO)
 *
 * Indicates if SPDIF interface is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_audspdif (5U)   /*!< Bit position for HDMI_CONFIG0_ID_audspdif. */
#define BM_HDMI_CONFIG0_ID_audspdif (0x20U) /*!< Bit mask for HDMI_CONFIG0_ID_audspdif. */
#define BS_HDMI_CONFIG0_ID_audspdif (1U)   /*!< Bit field size in bits for HDMI_CONFIG0_ID_audspdif. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_audspdif field. */
#define BR_HDMI_CONFIG0_ID_audspdif(x) (HW_HDMI_CONFIG0_ID(x).B.audspdif)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field audhbr[6] (RO)
 *
 * Indicates if HBR interface is present
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_audhbr (6U)     /*!< Bit position for HDMI_CONFIG0_ID_audhbr. */
#define BM_HDMI_CONFIG0_ID_audhbr (0x40U)  /*!< Bit mask for HDMI_CONFIG0_ID_audhbr. */
#define BS_HDMI_CONFIG0_ID_audhbr (1U)     /*!< Bit field size in bits for HDMI_CONFIG0_ID_audhbr. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_audhbr field. */
#define BR_HDMI_CONFIG0_ID_audhbr(x) (HW_HDMI_CONFIG0_ID(x).B.audhbr)
/*@}*/

/*!
 * @name Register HDMI_CONFIG0_ID, field prepen[7] (RO)
 *
 * Indicates if it is possible to use internal pixel repetition
 */
/*@{*/
#define BP_HDMI_CONFIG0_ID_prepen (7U)     /*!< Bit position for HDMI_CONFIG0_ID_prepen. */
#define BM_HDMI_CONFIG0_ID_prepen (0x80U)  /*!< Bit mask for HDMI_CONFIG0_ID_prepen. */
#define BS_HDMI_CONFIG0_ID_prepen (1U)     /*!< Bit field size in bits for HDMI_CONFIG0_ID_prepen. */

/*! @brief Read current value of the HDMI_CONFIG0_ID_prepen field. */
#define BR_HDMI_CONFIG0_ID_prepen(x) (HW_HDMI_CONFIG0_ID(x).B.prepen)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CONFIG1_ID - Configuration Identification Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CONFIG1_ID - Configuration Identification Register 1 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Configuration Identification Register 1 Address Offset: 0x0005 Size: 8
 * bits Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_config1_id
{
    uint8_t U;
    struct _hw_hdmi_config1_id_bitfields
    {
        uint8_t confahb : 1;           /*!< [0]  */
        uint8_t confapb : 1;           /*!< [1]  */
        uint8_t confocp : 1;           /*!< [2]  */
        uint8_t confi2c : 1;           /*!< [3]  */
        uint8_t confsfrdir : 1;        /*!< [4]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_config1_id_t;

/*!
 * @name Constants and macros for entire HDMI_CONFIG1_ID register
 */
/*@{*/
#define HW_HDMI_CONFIG1_ID_ADDR(x) ((uintptr_t)(x) + 0x5U)

#define HW_HDMI_CONFIG1_ID(x)    (*(__I hw_hdmi_config1_id_t *) HW_HDMI_CONFIG1_ID_ADDR(x))
#define HW_HDMI_CONFIG1_ID_RD(x) (HW_HDMI_CONFIG1_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CONFIG1_ID bitfields
 */

/*!
 * @name Register HDMI_CONFIG1_ID, field confahb[0] (RO)
 *
 * Indicates that configuration interface is AHB interface
 */
/*@{*/
#define BP_HDMI_CONFIG1_ID_confahb (0U)    /*!< Bit position for HDMI_CONFIG1_ID_confahb. */
#define BM_HDMI_CONFIG1_ID_confahb (0x01U) /*!< Bit mask for HDMI_CONFIG1_ID_confahb. */
#define BS_HDMI_CONFIG1_ID_confahb (1U)    /*!< Bit field size in bits for HDMI_CONFIG1_ID_confahb. */

/*! @brief Read current value of the HDMI_CONFIG1_ID_confahb field. */
#define BR_HDMI_CONFIG1_ID_confahb(x) (HW_HDMI_CONFIG1_ID(x).B.confahb)
/*@}*/

/*!
 * @name Register HDMI_CONFIG1_ID, field confapb[1] (RO)
 *
 * Indicates that configuration interface is APB interface
 */
/*@{*/
#define BP_HDMI_CONFIG1_ID_confapb (1U)    /*!< Bit position for HDMI_CONFIG1_ID_confapb. */
#define BM_HDMI_CONFIG1_ID_confapb (0x02U) /*!< Bit mask for HDMI_CONFIG1_ID_confapb. */
#define BS_HDMI_CONFIG1_ID_confapb (1U)    /*!< Bit field size in bits for HDMI_CONFIG1_ID_confapb. */

/*! @brief Read current value of the HDMI_CONFIG1_ID_confapb field. */
#define BR_HDMI_CONFIG1_ID_confapb(x) (HW_HDMI_CONFIG1_ID(x).B.confapb)
/*@}*/

/*!
 * @name Register HDMI_CONFIG1_ID, field confocp[2] (RO)
 *
 * Indicates that configuration interface is OCP interface
 */
/*@{*/
#define BP_HDMI_CONFIG1_ID_confocp (2U)    /*!< Bit position for HDMI_CONFIG1_ID_confocp. */
#define BM_HDMI_CONFIG1_ID_confocp (0x04U) /*!< Bit mask for HDMI_CONFIG1_ID_confocp. */
#define BS_HDMI_CONFIG1_ID_confocp (1U)    /*!< Bit field size in bits for HDMI_CONFIG1_ID_confocp. */

/*! @brief Read current value of the HDMI_CONFIG1_ID_confocp field. */
#define BR_HDMI_CONFIG1_ID_confocp(x) (HW_HDMI_CONFIG1_ID(x).B.confocp)
/*@}*/

/*!
 * @name Register HDMI_CONFIG1_ID, field confi2c[3] (RO)
 *
 * Indicates that configuration interface is I2C interface
 */
/*@{*/
#define BP_HDMI_CONFIG1_ID_confi2c (3U)    /*!< Bit position for HDMI_CONFIG1_ID_confi2c. */
#define BM_HDMI_CONFIG1_ID_confi2c (0x08U) /*!< Bit mask for HDMI_CONFIG1_ID_confi2c. */
#define BS_HDMI_CONFIG1_ID_confi2c (1U)    /*!< Bit field size in bits for HDMI_CONFIG1_ID_confi2c. */

/*! @brief Read current value of the HDMI_CONFIG1_ID_confi2c field. */
#define BR_HDMI_CONFIG1_ID_confi2c(x) (HW_HDMI_CONFIG1_ID(x).B.confi2c)
/*@}*/

/*!
 * @name Register HDMI_CONFIG1_ID, field confsfrdir[4] (RO)
 *
 * Indicates that configuration interface is SFR interface
 */
/*@{*/
#define BP_HDMI_CONFIG1_ID_confsfrdir (4U) /*!< Bit position for HDMI_CONFIG1_ID_confsfrdir. */
#define BM_HDMI_CONFIG1_ID_confsfrdir (0x10U) /*!< Bit mask for HDMI_CONFIG1_ID_confsfrdir. */
#define BS_HDMI_CONFIG1_ID_confsfrdir (1U) /*!< Bit field size in bits for HDMI_CONFIG1_ID_confsfrdir. */

/*! @brief Read current value of the HDMI_CONFIG1_ID_confsfrdir field. */
#define BR_HDMI_CONFIG1_ID_confsfrdir(x) (HW_HDMI_CONFIG1_ID(x).B.confsfrdir)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CONFIG2_ID - Configuration Identification Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CONFIG2_ID - Configuration Identification Register 2 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Configuration Identification Register 2 Address Offset: 0x0006 Size: 8
 * bits Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_config2_id
{
    uint8_t U;
    struct _hw_hdmi_config2_id_bitfields
    {
        uint8_t phytype : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_config2_id_t;

/*!
 * @name Constants and macros for entire HDMI_CONFIG2_ID register
 */
/*@{*/
#define HW_HDMI_CONFIG2_ID_ADDR(x) ((uintptr_t)(x) + 0x6U)

#define HW_HDMI_CONFIG2_ID(x)    (*(__I hw_hdmi_config2_id_t *) HW_HDMI_CONFIG2_ID_ADDR(x))
#define HW_HDMI_CONFIG2_ID_RD(x) (HW_HDMI_CONFIG2_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CONFIG2_ID bitfields
 */

/*!
 * @name Register HDMI_CONFIG2_ID, field phytype[7:0] (RO)
 *
 * Indicates the type of PHY interface selected: 00h Legacy PHY (HDMI TX PHY)
 * F2h PHY_Gen2 (HDMI 3D TX PHY) E2h PHY_Gen2 (HDMI 3D TX PHY) + HEAC PHY
 */
/*@{*/
#define BP_HDMI_CONFIG2_ID_phytype (0U)    /*!< Bit position for HDMI_CONFIG2_ID_phytype. */
#define BM_HDMI_CONFIG2_ID_phytype (0xFFU) /*!< Bit mask for HDMI_CONFIG2_ID_phytype. */
#define BS_HDMI_CONFIG2_ID_phytype (8U)    /*!< Bit field size in bits for HDMI_CONFIG2_ID_phytype. */

/*! @brief Read current value of the HDMI_CONFIG2_ID_phytype field. */
#define BR_HDMI_CONFIG2_ID_phytype(x) (HW_HDMI_CONFIG2_ID(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CONFIG3_ID - Configuration Identification Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CONFIG3_ID - Configuration Identification Register 3 (RO)
 *
 * Reset value: 0x00U
 *
 * Name: Configuration Identification Register 3 Address Offset: 0x0007 Size: 8
 * bits Value after Reset: Implementation Dependent Access: Read
 */
typedef union _hw_hdmi_config3_id
{
    uint8_t U;
    struct _hw_hdmi_config3_id_bitfields
    {
        uint8_t confgpaud : 1;         /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_config3_id_t;

/*!
 * @name Constants and macros for entire HDMI_CONFIG3_ID register
 */
/*@{*/
#define HW_HDMI_CONFIG3_ID_ADDR(x) ((uintptr_t)(x) + 0x7U)

#define HW_HDMI_CONFIG3_ID(x)    (*(__I hw_hdmi_config3_id_t *) HW_HDMI_CONFIG3_ID_ADDR(x))
#define HW_HDMI_CONFIG3_ID_RD(x) (HW_HDMI_CONFIG3_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CONFIG3_ID bitfields
 */

/*!
 * @name Register HDMI_CONFIG3_ID, field confgpaud[0] (RO)
 *
 * Indicates that configuration interface is Generic Parallel Audio (GPAUD)
 * interface
 */
/*@{*/
#define BP_HDMI_CONFIG3_ID_confgpaud (0U)  /*!< Bit position for HDMI_CONFIG3_ID_confgpaud. */
#define BM_HDMI_CONFIG3_ID_confgpaud (0x01U) /*!< Bit mask for HDMI_CONFIG3_ID_confgpaud. */
#define BS_HDMI_CONFIG3_ID_confgpaud (1U)  /*!< Bit field size in bits for HDMI_CONFIG3_ID_confgpaud. */

/*! @brief Read current value of the HDMI_CONFIG3_ID_confgpaud field. */
#define BR_HDMI_CONFIG3_ID_confgpaud(x) (HW_HDMI_CONFIG3_ID(x).B.confgpaud)
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_FC_STAT0 - Frame Composer Interrupt Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_FC_STAT0 - Frame Composer Interrupt Status Register 0 (W1C)
 *
 * Reset value: 0x00U
 *
 * This section describes clear on write (1 to corresponding bit) status
 * registers, which contain the following active-high, sticky bit interrupts. HDMI TX
 * introduces a new set of sticky bit mute control registers (IH_MUTE_FC_STAT0 to
 * IH_MUTE_AHBDMAAUD_STAT0) that correspond to the interrupt registers. You can
 * ignore a sticky bit interrupt by setting the corresponding mute control register
 * bit to 1. This puts the global interrupt line on a higher priority than the
 * sticky bit interrupt. Address Offset: 0x0100 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Clear on Write
 */
typedef union _hw_hdmi_ih_fc_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_fc_stat0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t OBA : 1;               /*!< [3]  */
        uint8_t DST : 1;               /*!< [4]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_ih_fc_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_FC_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_FC_STAT0_ADDR(x) ((uintptr_t)(x) + 0x100U)

#define HW_HDMI_IH_FC_STAT0(x)   (*(__IO hw_hdmi_ih_fc_stat0_t *) HW_HDMI_IH_FC_STAT0_ADDR(x))
#define HW_HDMI_IH_FC_STAT0_RD(x) (HW_HDMI_IH_FC_STAT0(x).U)
#define HW_HDMI_IH_FC_STAT0_WR(x, v) (HW_HDMI_IH_FC_STAT0(x).U = (v))
#define HW_HDMI_IH_FC_STAT0_SET(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, HW_HDMI_IH_FC_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_FC_STAT0_CLR(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, HW_HDMI_IH_FC_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_FC_STAT0_TOG(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, HW_HDMI_IH_FC_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_FC_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_FC_STAT0, field NULL_[0] (W1C)
 *
 * Active after successful transmission of an Null packet. Due to high number of
 * audio sample packets transmitted, this interrupt is by default masked at
 * frame composer.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_NULL_ (0U)     /*!< Bit position for HDMI_IH_FC_STAT0_NULL_. */
#define BM_HDMI_IH_FC_STAT0_NULL_ (0x01U)  /*!< Bit mask for HDMI_IH_FC_STAT0_NULL_. */
#define BS_HDMI_IH_FC_STAT0_NULL_ (1U)     /*!< Bit field size in bits for HDMI_IH_FC_STAT0_NULL_. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_NULL_ field. */
#define BR_HDMI_IH_FC_STAT0_NULL_(x) (HW_HDMI_IH_FC_STAT0(x).B.NULL_)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_NULL_. */
#define BF_HDMI_IH_FC_STAT0_NULL_(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_NULL_) & BM_HDMI_IH_FC_STAT0_NULL_)

/*! @brief Set the NULL_ field to a new value. */
#define BW_HDMI_IH_FC_STAT0_NULL_(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_NULL_(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field ACR[1] (W1C)
 *
 * Active after successful transmission of an Audio Clock Regeneration (N/CTS
 * transmission) packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_ACR (1U)       /*!< Bit position for HDMI_IH_FC_STAT0_ACR. */
#define BM_HDMI_IH_FC_STAT0_ACR (0x02U)    /*!< Bit mask for HDMI_IH_FC_STAT0_ACR. */
#define BS_HDMI_IH_FC_STAT0_ACR (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT0_ACR. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_ACR field. */
#define BR_HDMI_IH_FC_STAT0_ACR(x) (HW_HDMI_IH_FC_STAT0(x).B.ACR)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_ACR. */
#define BF_HDMI_IH_FC_STAT0_ACR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_ACR) & BM_HDMI_IH_FC_STAT0_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_HDMI_IH_FC_STAT0_ACR(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_ACR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field AUDS[2] (W1C)
 *
 * Active after successful transmission of an Audio Sample packet. Due to high
 * number of audio sample packets transmitted, this interrupt is by default masked
 * at frame composer.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_AUDS (2U)      /*!< Bit position for HDMI_IH_FC_STAT0_AUDS. */
#define BM_HDMI_IH_FC_STAT0_AUDS (0x04U)   /*!< Bit mask for HDMI_IH_FC_STAT0_AUDS. */
#define BS_HDMI_IH_FC_STAT0_AUDS (1U)      /*!< Bit field size in bits for HDMI_IH_FC_STAT0_AUDS. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_AUDS field. */
#define BR_HDMI_IH_FC_STAT0_AUDS(x) (HW_HDMI_IH_FC_STAT0(x).B.AUDS)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_AUDS. */
#define BF_HDMI_IH_FC_STAT0_AUDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_AUDS) & BM_HDMI_IH_FC_STAT0_AUDS)

/*! @brief Set the AUDS field to a new value. */
#define BW_HDMI_IH_FC_STAT0_AUDS(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_AUDS(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field OBA[3] (W1C)
 *
 * Reserved
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_OBA (3U)       /*!< Bit position for HDMI_IH_FC_STAT0_OBA. */
#define BM_HDMI_IH_FC_STAT0_OBA (0x08U)    /*!< Bit mask for HDMI_IH_FC_STAT0_OBA. */
#define BS_HDMI_IH_FC_STAT0_OBA (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT0_OBA. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_OBA field. */
#define BR_HDMI_IH_FC_STAT0_OBA(x) (HW_HDMI_IH_FC_STAT0(x).B.OBA)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_OBA. */
#define BF_HDMI_IH_FC_STAT0_OBA(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_OBA) & BM_HDMI_IH_FC_STAT0_OBA)

/*! @brief Set the OBA field to a new value. */
#define BW_HDMI_IH_FC_STAT0_OBA(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_OBA(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field DST[4] (W1C)
 *
 * Reserved
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_DST (4U)       /*!< Bit position for HDMI_IH_FC_STAT0_DST. */
#define BM_HDMI_IH_FC_STAT0_DST (0x10U)    /*!< Bit mask for HDMI_IH_FC_STAT0_DST. */
#define BS_HDMI_IH_FC_STAT0_DST (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT0_DST. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_DST field. */
#define BR_HDMI_IH_FC_STAT0_DST(x) (HW_HDMI_IH_FC_STAT0(x).B.DST)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_DST. */
#define BF_HDMI_IH_FC_STAT0_DST(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_DST) & BM_HDMI_IH_FC_STAT0_DST)

/*! @brief Set the DST field to a new value. */
#define BW_HDMI_IH_FC_STAT0_DST(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_DST(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field HBR[5] (W1C)
 *
 * Active after successful transmission of an Audio HBR packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_HBR (5U)       /*!< Bit position for HDMI_IH_FC_STAT0_HBR. */
#define BM_HDMI_IH_FC_STAT0_HBR (0x20U)    /*!< Bit mask for HDMI_IH_FC_STAT0_HBR. */
#define BS_HDMI_IH_FC_STAT0_HBR (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT0_HBR. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_HBR field. */
#define BR_HDMI_IH_FC_STAT0_HBR(x) (HW_HDMI_IH_FC_STAT0(x).B.HBR)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_HBR. */
#define BF_HDMI_IH_FC_STAT0_HBR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_HBR) & BM_HDMI_IH_FC_STAT0_HBR)

/*! @brief Set the HBR field to a new value. */
#define BW_HDMI_IH_FC_STAT0_HBR(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_HBR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field ACP[6] (W1C)
 *
 * Active after successful transmission of an Audio Content Protection packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_ACP (6U)       /*!< Bit position for HDMI_IH_FC_STAT0_ACP. */
#define BM_HDMI_IH_FC_STAT0_ACP (0x40U)    /*!< Bit mask for HDMI_IH_FC_STAT0_ACP. */
#define BS_HDMI_IH_FC_STAT0_ACP (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT0_ACP. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_ACP field. */
#define BR_HDMI_IH_FC_STAT0_ACP(x) (HW_HDMI_IH_FC_STAT0(x).B.ACP)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_ACP. */
#define BF_HDMI_IH_FC_STAT0_ACP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_ACP) & BM_HDMI_IH_FC_STAT0_ACP)

/*! @brief Set the ACP field to a new value. */
#define BW_HDMI_IH_FC_STAT0_ACP(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_ACP | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_AUDI)) | BF_HDMI_IH_FC_STAT0_ACP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT0, field AUDI[7] (W1C)
 *
 * Active after successful transmission of an Audio InfoFrame packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT0_AUDI (7U)      /*!< Bit position for HDMI_IH_FC_STAT0_AUDI. */
#define BM_HDMI_IH_FC_STAT0_AUDI (0x80U)   /*!< Bit mask for HDMI_IH_FC_STAT0_AUDI. */
#define BS_HDMI_IH_FC_STAT0_AUDI (1U)      /*!< Bit field size in bits for HDMI_IH_FC_STAT0_AUDI. */

/*! @brief Read current value of the HDMI_IH_FC_STAT0_AUDI field. */
#define BR_HDMI_IH_FC_STAT0_AUDI(x) (HW_HDMI_IH_FC_STAT0(x).B.AUDI)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT0_AUDI. */
#define BF_HDMI_IH_FC_STAT0_AUDI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT0_AUDI) & BM_HDMI_IH_FC_STAT0_AUDI)

/*! @brief Set the AUDI field to a new value. */
#define BW_HDMI_IH_FC_STAT0_AUDI(x, v) (HW_HDMI_IH_FC_STAT0_WR(x, (HW_HDMI_IH_FC_STAT0_RD(x) & ~(BM_HDMI_IH_FC_STAT0_AUDI | BM_HDMI_IH_FC_STAT0_NULL_ | BM_HDMI_IH_FC_STAT0_ACR | BM_HDMI_IH_FC_STAT0_AUDS | BM_HDMI_IH_FC_STAT0_OBA | BM_HDMI_IH_FC_STAT0_DST | BM_HDMI_IH_FC_STAT0_HBR | BM_HDMI_IH_FC_STAT0_ACP)) | BF_HDMI_IH_FC_STAT0_AUDI(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_FC_STAT1 - Frame Composer Interrupt Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_FC_STAT1 - Frame Composer Interrupt Status Register 1 (W1C)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0101 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_fc_stat1
{
    uint8_t U;
    struct _hw_hdmi_ih_fc_stat1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t MPEG : 1;              /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_ih_fc_stat1_t;

/*!
 * @name Constants and macros for entire HDMI_IH_FC_STAT1 register
 */
/*@{*/
#define HW_HDMI_IH_FC_STAT1_ADDR(x) ((uintptr_t)(x) + 0x101U)

#define HW_HDMI_IH_FC_STAT1(x)   (*(__IO hw_hdmi_ih_fc_stat1_t *) HW_HDMI_IH_FC_STAT1_ADDR(x))
#define HW_HDMI_IH_FC_STAT1_RD(x) (HW_HDMI_IH_FC_STAT1(x).U)
#define HW_HDMI_IH_FC_STAT1_WR(x, v) (HW_HDMI_IH_FC_STAT1(x).U = (v))
#define HW_HDMI_IH_FC_STAT1_SET(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, HW_HDMI_IH_FC_STAT1_RD(x) |  (v)))
#define HW_HDMI_IH_FC_STAT1_CLR(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, HW_HDMI_IH_FC_STAT1_RD(x) & ~(v)))
#define HW_HDMI_IH_FC_STAT1_TOG(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, HW_HDMI_IH_FC_STAT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_FC_STAT1 bitfields
 */

/*!
 * @name Register HDMI_IH_FC_STAT1, field GCP[0] (W1C)
 *
 * Active after successful transmission of an General Control Packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_GCP (0U)       /*!< Bit position for HDMI_IH_FC_STAT1_GCP. */
#define BM_HDMI_IH_FC_STAT1_GCP (0x01U)    /*!< Bit mask for HDMI_IH_FC_STAT1_GCP. */
#define BS_HDMI_IH_FC_STAT1_GCP (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT1_GCP. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_GCP field. */
#define BR_HDMI_IH_FC_STAT1_GCP(x) (HW_HDMI_IH_FC_STAT1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_GCP. */
#define BF_HDMI_IH_FC_STAT1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_GCP) & BM_HDMI_IH_FC_STAT1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_IH_FC_STAT1_GCP(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field AVI[1] (W1C)
 *
 * Active after successful transmission of an AVI infoFrame packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_AVI (1U)       /*!< Bit position for HDMI_IH_FC_STAT1_AVI. */
#define BM_HDMI_IH_FC_STAT1_AVI (0x02U)    /*!< Bit mask for HDMI_IH_FC_STAT1_AVI. */
#define BS_HDMI_IH_FC_STAT1_AVI (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT1_AVI. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_AVI field. */
#define BR_HDMI_IH_FC_STAT1_AVI(x) (HW_HDMI_IH_FC_STAT1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_AVI. */
#define BF_HDMI_IH_FC_STAT1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_AVI) & BM_HDMI_IH_FC_STAT1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_IH_FC_STAT1_AVI(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field MPEG[2] (W1C)
 *
 * Reserved
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_MPEG (2U)      /*!< Bit position for HDMI_IH_FC_STAT1_MPEG. */
#define BM_HDMI_IH_FC_STAT1_MPEG (0x04U)   /*!< Bit mask for HDMI_IH_FC_STAT1_MPEG. */
#define BS_HDMI_IH_FC_STAT1_MPEG (1U)      /*!< Bit field size in bits for HDMI_IH_FC_STAT1_MPEG. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_MPEG field. */
#define BR_HDMI_IH_FC_STAT1_MPEG(x) (HW_HDMI_IH_FC_STAT1(x).B.MPEG)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_MPEG. */
#define BF_HDMI_IH_FC_STAT1_MPEG(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_MPEG) & BM_HDMI_IH_FC_STAT1_MPEG)

/*! @brief Set the MPEG field to a new value. */
#define BW_HDMI_IH_FC_STAT1_MPEG(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_MPEG(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field SPD[3] (W1C)
 *
 * Active after successful transmission of an Source Product Descriptor
 * infoFrame packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_SPD (3U)       /*!< Bit position for HDMI_IH_FC_STAT1_SPD. */
#define BM_HDMI_IH_FC_STAT1_SPD (0x08U)    /*!< Bit mask for HDMI_IH_FC_STAT1_SPD. */
#define BS_HDMI_IH_FC_STAT1_SPD (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT1_SPD. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_SPD field. */
#define BR_HDMI_IH_FC_STAT1_SPD(x) (HW_HDMI_IH_FC_STAT1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_SPD. */
#define BF_HDMI_IH_FC_STAT1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_SPD) & BM_HDMI_IH_FC_STAT1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_IH_FC_STAT1_SPD(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field VSD[4] (W1C)
 *
 * Active after successful transmission of an Vendor Specific Data infoFrame
 * packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_VSD (4U)       /*!< Bit position for HDMI_IH_FC_STAT1_VSD. */
#define BM_HDMI_IH_FC_STAT1_VSD (0x10U)    /*!< Bit mask for HDMI_IH_FC_STAT1_VSD. */
#define BS_HDMI_IH_FC_STAT1_VSD (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT1_VSD. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_VSD field. */
#define BR_HDMI_IH_FC_STAT1_VSD(x) (HW_HDMI_IH_FC_STAT1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_VSD. */
#define BF_HDMI_IH_FC_STAT1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_VSD) & BM_HDMI_IH_FC_STAT1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_IH_FC_STAT1_VSD(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field ISCR2[5] (W1C)
 *
 * Active after successful transmission of an International Standard Recording
 * Code 2 packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_ISCR2 (5U)     /*!< Bit position for HDMI_IH_FC_STAT1_ISCR2. */
#define BM_HDMI_IH_FC_STAT1_ISCR2 (0x20U)  /*!< Bit mask for HDMI_IH_FC_STAT1_ISCR2. */
#define BS_HDMI_IH_FC_STAT1_ISCR2 (1U)     /*!< Bit field size in bits for HDMI_IH_FC_STAT1_ISCR2. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_ISCR2 field. */
#define BR_HDMI_IH_FC_STAT1_ISCR2(x) (HW_HDMI_IH_FC_STAT1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_ISCR2. */
#define BF_HDMI_IH_FC_STAT1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_ISCR2) & BM_HDMI_IH_FC_STAT1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_IH_FC_STAT1_ISCR2(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field ISCR1[6] (W1C)
 *
 * Active after successful transmission of an International Standard Recording
 * Code 1 packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_ISCR1 (6U)     /*!< Bit position for HDMI_IH_FC_STAT1_ISCR1. */
#define BM_HDMI_IH_FC_STAT1_ISCR1 (0x40U)  /*!< Bit mask for HDMI_IH_FC_STAT1_ISCR1. */
#define BS_HDMI_IH_FC_STAT1_ISCR1 (1U)     /*!< Bit field size in bits for HDMI_IH_FC_STAT1_ISCR1. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_ISCR1 field. */
#define BR_HDMI_IH_FC_STAT1_ISCR1(x) (HW_HDMI_IH_FC_STAT1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_ISCR1. */
#define BF_HDMI_IH_FC_STAT1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_ISCR1) & BM_HDMI_IH_FC_STAT1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_IH_FC_STAT1_ISCR1(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_ISCR1 | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_GMD)) | BF_HDMI_IH_FC_STAT1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT1, field GMD[7] (W1C)
 *
 * Active after successful transmission of an Gamut metadata packet.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT1_GMD (7U)       /*!< Bit position for HDMI_IH_FC_STAT1_GMD. */
#define BM_HDMI_IH_FC_STAT1_GMD (0x80U)    /*!< Bit mask for HDMI_IH_FC_STAT1_GMD. */
#define BS_HDMI_IH_FC_STAT1_GMD (1U)       /*!< Bit field size in bits for HDMI_IH_FC_STAT1_GMD. */

/*! @brief Read current value of the HDMI_IH_FC_STAT1_GMD field. */
#define BR_HDMI_IH_FC_STAT1_GMD(x) (HW_HDMI_IH_FC_STAT1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT1_GMD. */
#define BF_HDMI_IH_FC_STAT1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT1_GMD) & BM_HDMI_IH_FC_STAT1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_IH_FC_STAT1_GMD(x, v) (HW_HDMI_IH_FC_STAT1_WR(x, (HW_HDMI_IH_FC_STAT1_RD(x) & ~(BM_HDMI_IH_FC_STAT1_GMD | BM_HDMI_IH_FC_STAT1_GCP | BM_HDMI_IH_FC_STAT1_AVI | BM_HDMI_IH_FC_STAT1_MPEG | BM_HDMI_IH_FC_STAT1_SPD | BM_HDMI_IH_FC_STAT1_VSD | BM_HDMI_IH_FC_STAT1_ISCR2 | BM_HDMI_IH_FC_STAT1_ISCR1)) | BF_HDMI_IH_FC_STAT1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_FC_STAT2 - Frame Composer Interrupt Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_FC_STAT2 - Frame Composer Interrupt Status Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0102 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_fc_stat2
{
    uint8_t U;
    struct _hw_hdmi_ih_fc_stat2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_fc_stat2_t;

/*!
 * @name Constants and macros for entire HDMI_IH_FC_STAT2 register
 */
/*@{*/
#define HW_HDMI_IH_FC_STAT2_ADDR(x) ((uintptr_t)(x) + 0x102U)

#define HW_HDMI_IH_FC_STAT2(x)   (*(__IO hw_hdmi_ih_fc_stat2_t *) HW_HDMI_IH_FC_STAT2_ADDR(x))
#define HW_HDMI_IH_FC_STAT2_RD(x) (HW_HDMI_IH_FC_STAT2(x).U)
#define HW_HDMI_IH_FC_STAT2_WR(x, v) (HW_HDMI_IH_FC_STAT2(x).U = (v))
#define HW_HDMI_IH_FC_STAT2_SET(x, v) (HW_HDMI_IH_FC_STAT2_WR(x, HW_HDMI_IH_FC_STAT2_RD(x) |  (v)))
#define HW_HDMI_IH_FC_STAT2_CLR(x, v) (HW_HDMI_IH_FC_STAT2_WR(x, HW_HDMI_IH_FC_STAT2_RD(x) & ~(v)))
#define HW_HDMI_IH_FC_STAT2_TOG(x, v) (HW_HDMI_IH_FC_STAT2_WR(x, HW_HDMI_IH_FC_STAT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_FC_STAT2 bitfields
 */

/*!
 * @name Register HDMI_IH_FC_STAT2, field HighPriority_overflow[0] (W1C)
 *
 * Frame Composer high priority packet queue descriptor overflow indication.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT2_HighPriority_overflow (0U) /*!< Bit position for HDMI_IH_FC_STAT2_HighPriority_overflow. */
#define BM_HDMI_IH_FC_STAT2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_IH_FC_STAT2_HighPriority_overflow. */
#define BS_HDMI_IH_FC_STAT2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_IH_FC_STAT2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_IH_FC_STAT2_HighPriority_overflow field. */
#define BR_HDMI_IH_FC_STAT2_HighPriority_overflow(x) (HW_HDMI_IH_FC_STAT2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT2_HighPriority_overflow. */
#define BF_HDMI_IH_FC_STAT2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT2_HighPriority_overflow) & BM_HDMI_IH_FC_STAT2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_IH_FC_STAT2_HighPriority_overflow(x, v) (HW_HDMI_IH_FC_STAT2_WR(x, (HW_HDMI_IH_FC_STAT2_RD(x) & ~(BM_HDMI_IH_FC_STAT2_HighPriority_overflow | BM_HDMI_IH_FC_STAT2_LowPriority_overflow)) | BF_HDMI_IH_FC_STAT2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_FC_STAT2, field LowPriority_overflow[1] (W1C)
 *
 * Frame Composer low priority packet queue descriptor overflow indication.
 */
/*@{*/
#define BP_HDMI_IH_FC_STAT2_LowPriority_overflow (1U) /*!< Bit position for HDMI_IH_FC_STAT2_LowPriority_overflow. */
#define BM_HDMI_IH_FC_STAT2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_IH_FC_STAT2_LowPriority_overflow. */
#define BS_HDMI_IH_FC_STAT2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_IH_FC_STAT2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_IH_FC_STAT2_LowPriority_overflow field. */
#define BR_HDMI_IH_FC_STAT2_LowPriority_overflow(x) (HW_HDMI_IH_FC_STAT2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_IH_FC_STAT2_LowPriority_overflow. */
#define BF_HDMI_IH_FC_STAT2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_FC_STAT2_LowPriority_overflow) & BM_HDMI_IH_FC_STAT2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_IH_FC_STAT2_LowPriority_overflow(x, v) (HW_HDMI_IH_FC_STAT2_WR(x, (HW_HDMI_IH_FC_STAT2_RD(x) & ~(BM_HDMI_IH_FC_STAT2_LowPriority_overflow | BM_HDMI_IH_FC_STAT2_HighPriority_overflow)) | BF_HDMI_IH_FC_STAT2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_AS_STAT0 - Audio Sampler Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_AS_STAT0 - Audio Sampler Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0103 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_as_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_as_stat0_bitfields
    {
        uint8_t Aud_fifo_overflow : 1; /*!< [0]  */
        uint8_t Aud_fifo_underflow : 1; /*!< [1]  */
        uint8_t Aud_fifo_underflow_thr : 1; /*!< [2]  */
        uint8_t RESERVED0 : 5;         /*!< [7:3]  */
    } B;
} hw_hdmi_ih_as_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_AS_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_AS_STAT0_ADDR(x) ((uintptr_t)(x) + 0x103U)

#define HW_HDMI_IH_AS_STAT0(x)   (*(__IO hw_hdmi_ih_as_stat0_t *) HW_HDMI_IH_AS_STAT0_ADDR(x))
#define HW_HDMI_IH_AS_STAT0_RD(x) (HW_HDMI_IH_AS_STAT0(x).U)
#define HW_HDMI_IH_AS_STAT0_WR(x, v) (HW_HDMI_IH_AS_STAT0(x).U = (v))
#define HW_HDMI_IH_AS_STAT0_SET(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, HW_HDMI_IH_AS_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_AS_STAT0_CLR(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, HW_HDMI_IH_AS_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_AS_STAT0_TOG(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, HW_HDMI_IH_AS_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_AS_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_AS_STAT0, field Aud_fifo_overflow[0] (W1C)
 *
 * Audio Sampler audio FIFO full indication.
 */
/*@{*/
#define BP_HDMI_IH_AS_STAT0_Aud_fifo_overflow (0U) /*!< Bit position for HDMI_IH_AS_STAT0_Aud_fifo_overflow. */
#define BM_HDMI_IH_AS_STAT0_Aud_fifo_overflow (0x01U) /*!< Bit mask for HDMI_IH_AS_STAT0_Aud_fifo_overflow. */
#define BS_HDMI_IH_AS_STAT0_Aud_fifo_overflow (1U) /*!< Bit field size in bits for HDMI_IH_AS_STAT0_Aud_fifo_overflow. */

/*! @brief Read current value of the HDMI_IH_AS_STAT0_Aud_fifo_overflow field. */
#define BR_HDMI_IH_AS_STAT0_Aud_fifo_overflow(x) (HW_HDMI_IH_AS_STAT0(x).B.Aud_fifo_overflow)

/*! @brief Format value for bitfield HDMI_IH_AS_STAT0_Aud_fifo_overflow. */
#define BF_HDMI_IH_AS_STAT0_Aud_fifo_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AS_STAT0_Aud_fifo_overflow) & BM_HDMI_IH_AS_STAT0_Aud_fifo_overflow)

/*! @brief Set the Aud_fifo_overflow field to a new value. */
#define BW_HDMI_IH_AS_STAT0_Aud_fifo_overflow(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, (HW_HDMI_IH_AS_STAT0_RD(x) & ~(BM_HDMI_IH_AS_STAT0_Aud_fifo_overflow | BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow | BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr)) | BF_HDMI_IH_AS_STAT0_Aud_fifo_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AS_STAT0, field Aud_fifo_underflow[1] (W1C)
 *
 * Audio Sampler audio FIFO empty indication.
 */
/*@{*/
#define BP_HDMI_IH_AS_STAT0_Aud_fifo_underflow (1U) /*!< Bit position for HDMI_IH_AS_STAT0_Aud_fifo_underflow. */
#define BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow (0x02U) /*!< Bit mask for HDMI_IH_AS_STAT0_Aud_fifo_underflow. */
#define BS_HDMI_IH_AS_STAT0_Aud_fifo_underflow (1U) /*!< Bit field size in bits for HDMI_IH_AS_STAT0_Aud_fifo_underflow. */

/*! @brief Read current value of the HDMI_IH_AS_STAT0_Aud_fifo_underflow field. */
#define BR_HDMI_IH_AS_STAT0_Aud_fifo_underflow(x) (HW_HDMI_IH_AS_STAT0(x).B.Aud_fifo_underflow)

/*! @brief Format value for bitfield HDMI_IH_AS_STAT0_Aud_fifo_underflow. */
#define BF_HDMI_IH_AS_STAT0_Aud_fifo_underflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AS_STAT0_Aud_fifo_underflow) & BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow)

/*! @brief Set the Aud_fifo_underflow field to a new value. */
#define BW_HDMI_IH_AS_STAT0_Aud_fifo_underflow(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, (HW_HDMI_IH_AS_STAT0_RD(x) & ~(BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow | BM_HDMI_IH_AS_STAT0_Aud_fifo_overflow | BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr)) | BF_HDMI_IH_AS_STAT0_Aud_fifo_underflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AS_STAT0, field Aud_fifo_underflow_thr[2] (W1C)
 *
 * Audio Sampler audio FIFO empty threshold (four samples) indication. Only
 * valid in HBR audio.
 */
/*@{*/
#define BP_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr (2U) /*!< Bit position for HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr. */
#define BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr (0x04U) /*!< Bit mask for HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr. */
#define BS_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr (1U) /*!< Bit field size in bits for HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr. */

/*! @brief Read current value of the HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr field. */
#define BR_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr(x) (HW_HDMI_IH_AS_STAT0(x).B.Aud_fifo_underflow_thr)

/*! @brief Format value for bitfield HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr. */
#define BF_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr) & BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr)

/*! @brief Set the Aud_fifo_underflow_thr field to a new value. */
#define BW_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr(x, v) (HW_HDMI_IH_AS_STAT0_WR(x, (HW_HDMI_IH_AS_STAT0_RD(x) & ~(BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr | BM_HDMI_IH_AS_STAT0_Aud_fifo_overflow | BM_HDMI_IH_AS_STAT0_Aud_fifo_underflow)) | BF_HDMI_IH_AS_STAT0_Aud_fifo_underflow_thr(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_PHY_STAT0 - PHY Interface Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_PHY_STAT0 - PHY Interface Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0104 Size: 8 bits Value after Reset: 0x00 Access: Clear on
 * Write/Read
 */
typedef union _hw_hdmi_ih_phy_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_phy_stat0_bitfields
    {
        uint8_t HDP : 1;               /*!< [0]  */
        uint8_t TX_PHY_LOCK : 1;       /*!< [1]  */
        uint8_t RX_SENSE0 : 1;         /*!< [2]  */
        uint8_t RX_SENSE1 : 1;         /*!< [3]  */
        uint8_t RX_SENSE2 : 1;         /*!< [4]  */
        uint8_t RX_SENSE3 : 1;         /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_ih_phy_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_PHY_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_PHY_STAT0_ADDR(x) ((uintptr_t)(x) + 0x104U)

#define HW_HDMI_IH_PHY_STAT0(x)  (*(__IO hw_hdmi_ih_phy_stat0_t *) HW_HDMI_IH_PHY_STAT0_ADDR(x))
#define HW_HDMI_IH_PHY_STAT0_RD(x) (HW_HDMI_IH_PHY_STAT0(x).U)
#define HW_HDMI_IH_PHY_STAT0_WR(x, v) (HW_HDMI_IH_PHY_STAT0(x).U = (v))
#define HW_HDMI_IH_PHY_STAT0_SET(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, HW_HDMI_IH_PHY_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_PHY_STAT0_CLR(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, HW_HDMI_IH_PHY_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_PHY_STAT0_TOG(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, HW_HDMI_IH_PHY_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_PHY_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_PHY_STAT0, field HDP[0] (W1C)
 *
 * HDMI Hot Plug Detect indication. You may need to mask or change polarity of
 * this interrupt after it has become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_HDP (0U)      /*!< Bit position for HDMI_IH_PHY_STAT0_HDP. */
#define BM_HDMI_IH_PHY_STAT0_HDP (0x01U)   /*!< Bit mask for HDMI_IH_PHY_STAT0_HDP. */
#define BS_HDMI_IH_PHY_STAT0_HDP (1U)      /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_HDP. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_HDP field. */
#define BR_HDMI_IH_PHY_STAT0_HDP(x) (HW_HDMI_IH_PHY_STAT0(x).B.HDP)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_HDP. */
#define BF_HDMI_IH_PHY_STAT0_HDP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_HDP) & BM_HDMI_IH_PHY_STAT0_HDP)

/*! @brief Set the HDP field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_HDP(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_RX_SENSE2 | BM_HDMI_IH_PHY_STAT0_RX_SENSE3)) | BF_HDMI_IH_PHY_STAT0_HDP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_PHY_STAT0, field TX_PHY_LOCK[1] (W1C)
 *
 * TX PHY PLL lock indication. Please refer to PHY datasheet for more
 * information. You may need to mask or change polarity of this interrupt after it has
 * become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_TX_PHY_LOCK (1U) /*!< Bit position for HDMI_IH_PHY_STAT0_TX_PHY_LOCK. */
#define BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK (0x02U) /*!< Bit mask for HDMI_IH_PHY_STAT0_TX_PHY_LOCK. */
#define BS_HDMI_IH_PHY_STAT0_TX_PHY_LOCK (1U) /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_TX_PHY_LOCK field. */
#define BR_HDMI_IH_PHY_STAT0_TX_PHY_LOCK(x) (HW_HDMI_IH_PHY_STAT0(x).B.TX_PHY_LOCK)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_TX_PHY_LOCK. */
#define BF_HDMI_IH_PHY_STAT0_TX_PHY_LOCK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_TX_PHY_LOCK) & BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK)

/*! @brief Set the TX_PHY_LOCK field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_TX_PHY_LOCK(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_RX_SENSE2 | BM_HDMI_IH_PHY_STAT0_RX_SENSE3)) | BF_HDMI_IH_PHY_STAT0_TX_PHY_LOCK(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_PHY_STAT0, field RX_SENSE0[2] (W1C)
 *
 * TX PHY RX_SENSE indication for driver 0. You may need to mask or change
 * polarity of this interrupt after it has become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_RX_SENSE0 (2U) /*!< Bit position for HDMI_IH_PHY_STAT0_RX_SENSE0. */
#define BM_HDMI_IH_PHY_STAT0_RX_SENSE0 (0x04U) /*!< Bit mask for HDMI_IH_PHY_STAT0_RX_SENSE0. */
#define BS_HDMI_IH_PHY_STAT0_RX_SENSE0 (1U) /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_RX_SENSE0 field. */
#define BR_HDMI_IH_PHY_STAT0_RX_SENSE0(x) (HW_HDMI_IH_PHY_STAT0(x).B.RX_SENSE0)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_RX_SENSE0. */
#define BF_HDMI_IH_PHY_STAT0_RX_SENSE0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_RX_SENSE0) & BM_HDMI_IH_PHY_STAT0_RX_SENSE0)

/*! @brief Set the RX_SENSE0 field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_RX_SENSE0(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_RX_SENSE2 | BM_HDMI_IH_PHY_STAT0_RX_SENSE3)) | BF_HDMI_IH_PHY_STAT0_RX_SENSE0(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_PHY_STAT0, field RX_SENSE1[3] (W1C)
 *
 * TX PHY RX_SENSE indication for driver 1. You may need to mask or change
 * polarity of this interrupt after it has become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_RX_SENSE1 (3U) /*!< Bit position for HDMI_IH_PHY_STAT0_RX_SENSE1. */
#define BM_HDMI_IH_PHY_STAT0_RX_SENSE1 (0x08U) /*!< Bit mask for HDMI_IH_PHY_STAT0_RX_SENSE1. */
#define BS_HDMI_IH_PHY_STAT0_RX_SENSE1 (1U) /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_RX_SENSE1 field. */
#define BR_HDMI_IH_PHY_STAT0_RX_SENSE1(x) (HW_HDMI_IH_PHY_STAT0(x).B.RX_SENSE1)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_RX_SENSE1. */
#define BF_HDMI_IH_PHY_STAT0_RX_SENSE1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_RX_SENSE1) & BM_HDMI_IH_PHY_STAT0_RX_SENSE1)

/*! @brief Set the RX_SENSE1 field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_RX_SENSE1(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_RX_SENSE2 | BM_HDMI_IH_PHY_STAT0_RX_SENSE3)) | BF_HDMI_IH_PHY_STAT0_RX_SENSE1(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_PHY_STAT0, field RX_SENSE2[4] (W1C)
 *
 * TX PHY RX_SENSE indication for driver 2. You may need to mask or change
 * polarity of this interrupt after it has become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_RX_SENSE2 (4U) /*!< Bit position for HDMI_IH_PHY_STAT0_RX_SENSE2. */
#define BM_HDMI_IH_PHY_STAT0_RX_SENSE2 (0x10U) /*!< Bit mask for HDMI_IH_PHY_STAT0_RX_SENSE2. */
#define BS_HDMI_IH_PHY_STAT0_RX_SENSE2 (1U) /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_RX_SENSE2 field. */
#define BR_HDMI_IH_PHY_STAT0_RX_SENSE2(x) (HW_HDMI_IH_PHY_STAT0(x).B.RX_SENSE2)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_RX_SENSE2. */
#define BF_HDMI_IH_PHY_STAT0_RX_SENSE2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_RX_SENSE2) & BM_HDMI_IH_PHY_STAT0_RX_SENSE2)

/*! @brief Set the RX_SENSE2 field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_RX_SENSE2(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_RX_SENSE2 | BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_RX_SENSE3)) | BF_HDMI_IH_PHY_STAT0_RX_SENSE2(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_PHY_STAT0, field RX_SENSE3[5] (W1C)
 *
 * TX PHY RX_SENSE indication for driver 3. You may need to mask or change
 * polarity of this interrupt after it has become active.
 */
/*@{*/
#define BP_HDMI_IH_PHY_STAT0_RX_SENSE3 (5U) /*!< Bit position for HDMI_IH_PHY_STAT0_RX_SENSE3. */
#define BM_HDMI_IH_PHY_STAT0_RX_SENSE3 (0x20U) /*!< Bit mask for HDMI_IH_PHY_STAT0_RX_SENSE3. */
#define BS_HDMI_IH_PHY_STAT0_RX_SENSE3 (1U) /*!< Bit field size in bits for HDMI_IH_PHY_STAT0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_IH_PHY_STAT0_RX_SENSE3 field. */
#define BR_HDMI_IH_PHY_STAT0_RX_SENSE3(x) (HW_HDMI_IH_PHY_STAT0(x).B.RX_SENSE3)

/*! @brief Format value for bitfield HDMI_IH_PHY_STAT0_RX_SENSE3. */
#define BF_HDMI_IH_PHY_STAT0_RX_SENSE3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_PHY_STAT0_RX_SENSE3) & BM_HDMI_IH_PHY_STAT0_RX_SENSE3)

/*! @brief Set the RX_SENSE3 field to a new value. */
#define BW_HDMI_IH_PHY_STAT0_RX_SENSE3(x, v) (HW_HDMI_IH_PHY_STAT0_WR(x, (HW_HDMI_IH_PHY_STAT0_RD(x) & ~(BM_HDMI_IH_PHY_STAT0_RX_SENSE3 | BM_HDMI_IH_PHY_STAT0_HDP | BM_HDMI_IH_PHY_STAT0_TX_PHY_LOCK | BM_HDMI_IH_PHY_STAT0_RX_SENSE0 | BM_HDMI_IH_PHY_STAT0_RX_SENSE1 | BM_HDMI_IH_PHY_STAT0_RX_SENSE2)) | BF_HDMI_IH_PHY_STAT0_RX_SENSE3(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_I2CM_STAT0 - E-DDC I2C Master Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_I2CM_STAT0 - E-DDC I2C Master Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0105 Size: 8 bits Value after Reset: 0x00 Access: Clear on
 * Write/Read
 */
typedef union _hw_hdmi_ih_i2cm_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_i2cm_stat0_bitfields
    {
        uint8_t I2CMASTER_ERROR : 1;   /*!< [0]  */
        uint8_t I2Cmasterdone : 1;     /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_i2cm_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_I2CM_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_I2CM_STAT0_ADDR(x) ((uintptr_t)(x) + 0x105U)

#define HW_HDMI_IH_I2CM_STAT0(x) (*(__IO hw_hdmi_ih_i2cm_stat0_t *) HW_HDMI_IH_I2CM_STAT0_ADDR(x))
#define HW_HDMI_IH_I2CM_STAT0_RD(x) (HW_HDMI_IH_I2CM_STAT0(x).U)
#define HW_HDMI_IH_I2CM_STAT0_WR(x, v) (HW_HDMI_IH_I2CM_STAT0(x).U = (v))
#define HW_HDMI_IH_I2CM_STAT0_SET(x, v) (HW_HDMI_IH_I2CM_STAT0_WR(x, HW_HDMI_IH_I2CM_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_I2CM_STAT0_CLR(x, v) (HW_HDMI_IH_I2CM_STAT0_WR(x, HW_HDMI_IH_I2CM_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_I2CM_STAT0_TOG(x, v) (HW_HDMI_IH_I2CM_STAT0_WR(x, HW_HDMI_IH_I2CM_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_I2CM_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_I2CM_STAT0, field I2CMASTER_ERROR[0] (W1C)
 *
 * I2C Master error indication
 */
/*@{*/
#define BP_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR (0U) /*!< Bit position for HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR. */
#define BM_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR (0x01U) /*!< Bit mask for HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR. */
#define BS_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR (1U) /*!< Bit field size in bits for HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR. */

/*! @brief Read current value of the HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR field. */
#define BR_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR(x) (HW_HDMI_IH_I2CM_STAT0(x).B.I2CMASTER_ERROR)

/*! @brief Format value for bitfield HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR. */
#define BF_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR) & BM_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR)

/*! @brief Set the I2CMASTER_ERROR field to a new value. */
#define BW_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR(x, v) (HW_HDMI_IH_I2CM_STAT0_WR(x, (HW_HDMI_IH_I2CM_STAT0_RD(x) & ~(BM_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR | BM_HDMI_IH_I2CM_STAT0_I2Cmasterdone)) | BF_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_I2CM_STAT0, field I2Cmasterdone[1] (W1C)
 *
 * I2C Master done indication
 */
/*@{*/
#define BP_HDMI_IH_I2CM_STAT0_I2Cmasterdone (1U) /*!< Bit position for HDMI_IH_I2CM_STAT0_I2Cmasterdone. */
#define BM_HDMI_IH_I2CM_STAT0_I2Cmasterdone (0x02U) /*!< Bit mask for HDMI_IH_I2CM_STAT0_I2Cmasterdone. */
#define BS_HDMI_IH_I2CM_STAT0_I2Cmasterdone (1U) /*!< Bit field size in bits for HDMI_IH_I2CM_STAT0_I2Cmasterdone. */

/*! @brief Read current value of the HDMI_IH_I2CM_STAT0_I2Cmasterdone field. */
#define BR_HDMI_IH_I2CM_STAT0_I2Cmasterdone(x) (HW_HDMI_IH_I2CM_STAT0(x).B.I2Cmasterdone)

/*! @brief Format value for bitfield HDMI_IH_I2CM_STAT0_I2Cmasterdone. */
#define BF_HDMI_IH_I2CM_STAT0_I2Cmasterdone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_I2CM_STAT0_I2Cmasterdone) & BM_HDMI_IH_I2CM_STAT0_I2Cmasterdone)

/*! @brief Set the I2Cmasterdone field to a new value. */
#define BW_HDMI_IH_I2CM_STAT0_I2Cmasterdone(x, v) (HW_HDMI_IH_I2CM_STAT0_WR(x, (HW_HDMI_IH_I2CM_STAT0_RD(x) & ~(BM_HDMI_IH_I2CM_STAT0_I2Cmasterdone | BM_HDMI_IH_I2CM_STAT0_I2CMASTER_ERROR)) | BF_HDMI_IH_I2CM_STAT0_I2Cmasterdone(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_CEC_STAT0 - CEC Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_CEC_STAT0 - CEC Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0106 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_cec_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_cec_stat0_bitfields
    {
        uint8_t DONE : 1;              /*!< [0]  */
        uint8_t EOM : 1;               /*!< [1]  */
        uint8_t NACK : 1;              /*!< [2]  */
        uint8_t ARB_LOST : 1;          /*!< [3]  */
        uint8_t ERROR_INITIATOR : 1;   /*!< [4]  */
        uint8_t ERROR_FOLLOW : 1;      /*!< [5]  */
        uint8_t WAKEUP : 1;            /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_ih_cec_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_CEC_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_CEC_STAT0_ADDR(x) ((uintptr_t)(x) + 0x106U)

#define HW_HDMI_IH_CEC_STAT0(x)  (*(__IO hw_hdmi_ih_cec_stat0_t *) HW_HDMI_IH_CEC_STAT0_ADDR(x))
#define HW_HDMI_IH_CEC_STAT0_RD(x) (HW_HDMI_IH_CEC_STAT0(x).U)
#define HW_HDMI_IH_CEC_STAT0_WR(x, v) (HW_HDMI_IH_CEC_STAT0(x).U = (v))
#define HW_HDMI_IH_CEC_STAT0_SET(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, HW_HDMI_IH_CEC_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_CEC_STAT0_CLR(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, HW_HDMI_IH_CEC_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_CEC_STAT0_TOG(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, HW_HDMI_IH_CEC_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_CEC_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_CEC_STAT0, field DONE[0] (W1C)
 *
 * CEC Done Indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_DONE (0U)     /*!< Bit position for HDMI_IH_CEC_STAT0_DONE. */
#define BM_HDMI_IH_CEC_STAT0_DONE (0x01U)  /*!< Bit mask for HDMI_IH_CEC_STAT0_DONE. */
#define BS_HDMI_IH_CEC_STAT0_DONE (1U)     /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_DONE. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_DONE field. */
#define BR_HDMI_IH_CEC_STAT0_DONE(x) (HW_HDMI_IH_CEC_STAT0(x).B.DONE)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_DONE. */
#define BF_HDMI_IH_CEC_STAT0_DONE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_DONE) & BM_HDMI_IH_CEC_STAT0_DONE)

/*! @brief Set the DONE field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_DONE(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_DONE(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field EOM[1] (W1C)
 *
 * CEC End of Message Indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_EOM (1U)      /*!< Bit position for HDMI_IH_CEC_STAT0_EOM. */
#define BM_HDMI_IH_CEC_STAT0_EOM (0x02U)   /*!< Bit mask for HDMI_IH_CEC_STAT0_EOM. */
#define BS_HDMI_IH_CEC_STAT0_EOM (1U)      /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_EOM. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_EOM field. */
#define BR_HDMI_IH_CEC_STAT0_EOM(x) (HW_HDMI_IH_CEC_STAT0(x).B.EOM)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_EOM. */
#define BF_HDMI_IH_CEC_STAT0_EOM(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_EOM) & BM_HDMI_IH_CEC_STAT0_EOM)

/*! @brief Set the EOM field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_EOM(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_EOM(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field NACK[2] (W1C)
 *
 * CEC Nack indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_NACK (2U)     /*!< Bit position for HDMI_IH_CEC_STAT0_NACK. */
#define BM_HDMI_IH_CEC_STAT0_NACK (0x04U)  /*!< Bit mask for HDMI_IH_CEC_STAT0_NACK. */
#define BS_HDMI_IH_CEC_STAT0_NACK (1U)     /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_NACK. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_NACK field. */
#define BR_HDMI_IH_CEC_STAT0_NACK(x) (HW_HDMI_IH_CEC_STAT0(x).B.NACK)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_NACK. */
#define BF_HDMI_IH_CEC_STAT0_NACK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_NACK) & BM_HDMI_IH_CEC_STAT0_NACK)

/*! @brief Set the NACK field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_NACK(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_NACK(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field ARB_LOST[3] (W1C)
 *
 * CEC Arb_Lost indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_ARB_LOST (3U) /*!< Bit position for HDMI_IH_CEC_STAT0_ARB_LOST. */
#define BM_HDMI_IH_CEC_STAT0_ARB_LOST (0x08U) /*!< Bit mask for HDMI_IH_CEC_STAT0_ARB_LOST. */
#define BS_HDMI_IH_CEC_STAT0_ARB_LOST (1U) /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_ARB_LOST. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_ARB_LOST field. */
#define BR_HDMI_IH_CEC_STAT0_ARB_LOST(x) (HW_HDMI_IH_CEC_STAT0(x).B.ARB_LOST)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_ARB_LOST. */
#define BF_HDMI_IH_CEC_STAT0_ARB_LOST(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_ARB_LOST) & BM_HDMI_IH_CEC_STAT0_ARB_LOST)

/*! @brief Set the ARB_LOST field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_ARB_LOST(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_ARB_LOST(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field ERROR_INITIATOR[4] (W1C)
 *
 * CEC Error_follow indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_ERROR_INITIATOR (4U) /*!< Bit position for HDMI_IH_CEC_STAT0_ERROR_INITIATOR. */
#define BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR (0x10U) /*!< Bit mask for HDMI_IH_CEC_STAT0_ERROR_INITIATOR. */
#define BS_HDMI_IH_CEC_STAT0_ERROR_INITIATOR (1U) /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_ERROR_INITIATOR. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_ERROR_INITIATOR field. */
#define BR_HDMI_IH_CEC_STAT0_ERROR_INITIATOR(x) (HW_HDMI_IH_CEC_STAT0(x).B.ERROR_INITIATOR)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_ERROR_INITIATOR. */
#define BF_HDMI_IH_CEC_STAT0_ERROR_INITIATOR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_ERROR_INITIATOR) & BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR)

/*! @brief Set the ERROR_INITIATOR field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_ERROR_INITIATOR(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_ERROR_INITIATOR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field ERROR_FOLLOW[5] (W1C)
 *
 * CEC Error_follow indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_ERROR_FOLLOW (5U) /*!< Bit position for HDMI_IH_CEC_STAT0_ERROR_FOLLOW. */
#define BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW (0x20U) /*!< Bit mask for HDMI_IH_CEC_STAT0_ERROR_FOLLOW. */
#define BS_HDMI_IH_CEC_STAT0_ERROR_FOLLOW (1U) /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_ERROR_FOLLOW. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_ERROR_FOLLOW field. */
#define BR_HDMI_IH_CEC_STAT0_ERROR_FOLLOW(x) (HW_HDMI_IH_CEC_STAT0(x).B.ERROR_FOLLOW)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_ERROR_FOLLOW. */
#define BF_HDMI_IH_CEC_STAT0_ERROR_FOLLOW(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_ERROR_FOLLOW) & BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW)

/*! @brief Set the ERROR_FOLLOW field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_ERROR_FOLLOW(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_WAKEUP)) | BF_HDMI_IH_CEC_STAT0_ERROR_FOLLOW(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_CEC_STAT0, field WAKEUP[6] (W1C)
 *
 * CEC Wake-up indication
 */
/*@{*/
#define BP_HDMI_IH_CEC_STAT0_WAKEUP (6U)   /*!< Bit position for HDMI_IH_CEC_STAT0_WAKEUP. */
#define BM_HDMI_IH_CEC_STAT0_WAKEUP (0x40U) /*!< Bit mask for HDMI_IH_CEC_STAT0_WAKEUP. */
#define BS_HDMI_IH_CEC_STAT0_WAKEUP (1U)   /*!< Bit field size in bits for HDMI_IH_CEC_STAT0_WAKEUP. */

/*! @brief Read current value of the HDMI_IH_CEC_STAT0_WAKEUP field. */
#define BR_HDMI_IH_CEC_STAT0_WAKEUP(x) (HW_HDMI_IH_CEC_STAT0(x).B.WAKEUP)

/*! @brief Format value for bitfield HDMI_IH_CEC_STAT0_WAKEUP. */
#define BF_HDMI_IH_CEC_STAT0_WAKEUP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_CEC_STAT0_WAKEUP) & BM_HDMI_IH_CEC_STAT0_WAKEUP)

/*! @brief Set the WAKEUP field to a new value. */
#define BW_HDMI_IH_CEC_STAT0_WAKEUP(x, v) (HW_HDMI_IH_CEC_STAT0_WR(x, (HW_HDMI_IH_CEC_STAT0_RD(x) & ~(BM_HDMI_IH_CEC_STAT0_WAKEUP | BM_HDMI_IH_CEC_STAT0_DONE | BM_HDMI_IH_CEC_STAT0_EOM | BM_HDMI_IH_CEC_STAT0_NACK | BM_HDMI_IH_CEC_STAT0_ARB_LOST | BM_HDMI_IH_CEC_STAT0_ERROR_INITIATOR | BM_HDMI_IH_CEC_STAT0_ERROR_FOLLOW)) | BF_HDMI_IH_CEC_STAT0_WAKEUP(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_VP_STAT0 - Video Packetizer Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_VP_STAT0 - Video Packetizer Interrupt Status Register (W1C)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0107 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_vp_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_vp_stat0_bitfields
    {
        uint8_t fifoemptybyp : 1;      /*!< [0]  */
        uint8_t fifofullbyp : 1;       /*!< [1]  */
        uint8_t fifoemptyremap : 1;    /*!< [2]  */
        uint8_t fifofullremap : 1;     /*!< [3]  */
        uint8_t fifoemptypp : 1;       /*!< [4]  */
        uint8_t fifofullpp : 1;        /*!< [5]  */
        uint8_t fifoemptyrepet : 1;    /*!< [6]  */
        uint8_t fifofullrepet : 1;     /*!< [7]  */
    } B;
} hw_hdmi_ih_vp_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_VP_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_VP_STAT0_ADDR(x) ((uintptr_t)(x) + 0x107U)

#define HW_HDMI_IH_VP_STAT0(x)   (*(__IO hw_hdmi_ih_vp_stat0_t *) HW_HDMI_IH_VP_STAT0_ADDR(x))
#define HW_HDMI_IH_VP_STAT0_RD(x) (HW_HDMI_IH_VP_STAT0(x).U)
#define HW_HDMI_IH_VP_STAT0_WR(x, v) (HW_HDMI_IH_VP_STAT0(x).U = (v))
#define HW_HDMI_IH_VP_STAT0_SET(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, HW_HDMI_IH_VP_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_VP_STAT0_CLR(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, HW_HDMI_IH_VP_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_VP_STAT0_TOG(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, HW_HDMI_IH_VP_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_VP_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifoemptybyp[0] (W1C)
 *
 * Video packetizer 8-bit bypass fifo empty interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifoemptybyp (0U) /*!< Bit position for HDMI_IH_VP_STAT0_fifoemptybyp. */
#define BM_HDMI_IH_VP_STAT0_fifoemptybyp (0x01U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifoemptybyp. */
#define BS_HDMI_IH_VP_STAT0_fifoemptybyp (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifoemptybyp. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifoemptybyp field. */
#define BR_HDMI_IH_VP_STAT0_fifoemptybyp(x) (HW_HDMI_IH_VP_STAT0(x).B.fifoemptybyp)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifoemptybyp. */
#define BF_HDMI_IH_VP_STAT0_fifoemptybyp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifoemptybyp) & BM_HDMI_IH_VP_STAT0_fifoemptybyp)

/*! @brief Set the fifoemptybyp field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifoemptybyp(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifoemptybyp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifofullbyp[1] (W1C)
 *
 * Video packetizer 8-bit bypass fifo full interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifofullbyp (1U) /*!< Bit position for HDMI_IH_VP_STAT0_fifofullbyp. */
#define BM_HDMI_IH_VP_STAT0_fifofullbyp (0x02U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifofullbyp. */
#define BS_HDMI_IH_VP_STAT0_fifofullbyp (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifofullbyp. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifofullbyp field. */
#define BR_HDMI_IH_VP_STAT0_fifofullbyp(x) (HW_HDMI_IH_VP_STAT0(x).B.fifofullbyp)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifofullbyp. */
#define BF_HDMI_IH_VP_STAT0_fifofullbyp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifofullbyp) & BM_HDMI_IH_VP_STAT0_fifofullbyp)

/*! @brief Set the fifofullbyp field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifofullbyp(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifofullbyp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifoemptyremap[2] (W1C)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO empty interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifoemptyremap (2U) /*!< Bit position for HDMI_IH_VP_STAT0_fifoemptyremap. */
#define BM_HDMI_IH_VP_STAT0_fifoemptyremap (0x04U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifoemptyremap. */
#define BS_HDMI_IH_VP_STAT0_fifoemptyremap (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifoemptyremap. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifoemptyremap field. */
#define BR_HDMI_IH_VP_STAT0_fifoemptyremap(x) (HW_HDMI_IH_VP_STAT0(x).B.fifoemptyremap)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifoemptyremap. */
#define BF_HDMI_IH_VP_STAT0_fifoemptyremap(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifoemptyremap) & BM_HDMI_IH_VP_STAT0_fifoemptyremap)

/*! @brief Set the fifoemptyremap field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifoemptyremap(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifoemptyremap(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifofullremap[3] (W1C)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO full interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifofullremap (3U) /*!< Bit position for HDMI_IH_VP_STAT0_fifofullremap. */
#define BM_HDMI_IH_VP_STAT0_fifofullremap (0x08U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifofullremap. */
#define BS_HDMI_IH_VP_STAT0_fifofullremap (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifofullremap. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifofullremap field. */
#define BR_HDMI_IH_VP_STAT0_fifofullremap(x) (HW_HDMI_IH_VP_STAT0(x).B.fifofullremap)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifofullremap. */
#define BF_HDMI_IH_VP_STAT0_fifofullremap(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifofullremap) & BM_HDMI_IH_VP_STAT0_fifofullremap)

/*! @brief Set the fifofullremap field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifofullremap(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifofullremap(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifoemptypp[4] (W1C)
 *
 * Video packetizer pixel packing FIFO empty interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifoemptypp (4U) /*!< Bit position for HDMI_IH_VP_STAT0_fifoemptypp. */
#define BM_HDMI_IH_VP_STAT0_fifoemptypp (0x10U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifoemptypp. */
#define BS_HDMI_IH_VP_STAT0_fifoemptypp (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifoemptypp. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifoemptypp field. */
#define BR_HDMI_IH_VP_STAT0_fifoemptypp(x) (HW_HDMI_IH_VP_STAT0(x).B.fifoemptypp)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifoemptypp. */
#define BF_HDMI_IH_VP_STAT0_fifoemptypp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifoemptypp) & BM_HDMI_IH_VP_STAT0_fifoemptypp)

/*! @brief Set the fifoemptypp field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifoemptypp(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifoemptypp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifofullpp[5] (W1C)
 *
 * Video packetizer pixel packing FIFO full interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifofullpp (5U) /*!< Bit position for HDMI_IH_VP_STAT0_fifofullpp. */
#define BM_HDMI_IH_VP_STAT0_fifofullpp (0x20U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifofullpp. */
#define BS_HDMI_IH_VP_STAT0_fifofullpp (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifofullpp. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifofullpp field. */
#define BR_HDMI_IH_VP_STAT0_fifofullpp(x) (HW_HDMI_IH_VP_STAT0(x).B.fifofullpp)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifofullpp. */
#define BF_HDMI_IH_VP_STAT0_fifofullpp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifofullpp) & BM_HDMI_IH_VP_STAT0_fifofullpp)

/*! @brief Set the fifofullpp field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifofullpp(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifofullpp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifoemptyrepet[6] (W1C)
 *
 * Video packetizer pixel repeater FIFO empty interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifoemptyrepet (6U) /*!< Bit position for HDMI_IH_VP_STAT0_fifoemptyrepet. */
#define BM_HDMI_IH_VP_STAT0_fifoemptyrepet (0x40U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifoemptyrepet. */
#define BS_HDMI_IH_VP_STAT0_fifoemptyrepet (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifoemptyrepet. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifoemptyrepet field. */
#define BR_HDMI_IH_VP_STAT0_fifoemptyrepet(x) (HW_HDMI_IH_VP_STAT0(x).B.fifoemptyrepet)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifoemptyrepet. */
#define BF_HDMI_IH_VP_STAT0_fifoemptyrepet(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifoemptyrepet) & BM_HDMI_IH_VP_STAT0_fifoemptyrepet)

/*! @brief Set the fifoemptyrepet field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifoemptyrepet(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifoemptyrepet | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifofullrepet)) | BF_HDMI_IH_VP_STAT0_fifoemptyrepet(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_VP_STAT0, field fifofullrepet[7] (W1C)
 *
 * Video packetizer pixel repeater FIFO full interrupt
 */
/*@{*/
#define BP_HDMI_IH_VP_STAT0_fifofullrepet (7U) /*!< Bit position for HDMI_IH_VP_STAT0_fifofullrepet. */
#define BM_HDMI_IH_VP_STAT0_fifofullrepet (0x80U) /*!< Bit mask for HDMI_IH_VP_STAT0_fifofullrepet. */
#define BS_HDMI_IH_VP_STAT0_fifofullrepet (1U) /*!< Bit field size in bits for HDMI_IH_VP_STAT0_fifofullrepet. */

/*! @brief Read current value of the HDMI_IH_VP_STAT0_fifofullrepet field. */
#define BR_HDMI_IH_VP_STAT0_fifofullrepet(x) (HW_HDMI_IH_VP_STAT0(x).B.fifofullrepet)

/*! @brief Format value for bitfield HDMI_IH_VP_STAT0_fifofullrepet. */
#define BF_HDMI_IH_VP_STAT0_fifofullrepet(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_VP_STAT0_fifofullrepet) & BM_HDMI_IH_VP_STAT0_fifofullrepet)

/*! @brief Set the fifofullrepet field to a new value. */
#define BW_HDMI_IH_VP_STAT0_fifofullrepet(x, v) (HW_HDMI_IH_VP_STAT0_WR(x, (HW_HDMI_IH_VP_STAT0_RD(x) & ~(BM_HDMI_IH_VP_STAT0_fifofullrepet | BM_HDMI_IH_VP_STAT0_fifoemptybyp | BM_HDMI_IH_VP_STAT0_fifofullbyp | BM_HDMI_IH_VP_STAT0_fifoemptyremap | BM_HDMI_IH_VP_STAT0_fifofullremap | BM_HDMI_IH_VP_STAT0_fifoemptypp | BM_HDMI_IH_VP_STAT0_fifofullpp | BM_HDMI_IH_VP_STAT0_fifoemptyrepet)) | BF_HDMI_IH_VP_STAT0_fifofullrepet(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_I2CMPHY_STAT0 - PHY GEN2 I2C Master Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_I2CMPHY_STAT0 - PHY GEN2 I2C Master Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * This clear on write (1 to corresponding bit) register contains the following
 * active high sticky bit interrupts. That I2C Master PHY is the I2C Master block
 * used to access the PHY I2C Slave. Address Offset: 0x0108 Size: 8 bits Value
 * after Reset: 0x00 Access: Read/Clear on Write
 */
typedef union _hw_hdmi_ih_i2cmphy_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_i2cmphy_stat0_bitfields
    {
        uint8_t i2cmphyerror : 1;      /*!< [0]  */
        uint8_t i2cmphydone : 1;       /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_i2cmphy_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_I2CMPHY_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_I2CMPHY_STAT0_ADDR(x) ((uintptr_t)(x) + 0x108U)

#define HW_HDMI_IH_I2CMPHY_STAT0(x) (*(__IO hw_hdmi_ih_i2cmphy_stat0_t *) HW_HDMI_IH_I2CMPHY_STAT0_ADDR(x))
#define HW_HDMI_IH_I2CMPHY_STAT0_RD(x) (HW_HDMI_IH_I2CMPHY_STAT0(x).U)
#define HW_HDMI_IH_I2CMPHY_STAT0_WR(x, v) (HW_HDMI_IH_I2CMPHY_STAT0(x).U = (v))
#define HW_HDMI_IH_I2CMPHY_STAT0_SET(x, v) (HW_HDMI_IH_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_I2CMPHY_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_I2CMPHY_STAT0_CLR(x, v) (HW_HDMI_IH_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_I2CMPHY_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_I2CMPHY_STAT0_TOG(x, v) (HW_HDMI_IH_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_I2CMPHY_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_I2CMPHY_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_I2CMPHY_STAT0, field i2cmphyerror[0] (W1C)
 *
 * I2C Master PHY error indication
 */
/*@{*/
#define BP_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror (0U) /*!< Bit position for HDMI_IH_I2CMPHY_STAT0_i2cmphyerror. */
#define BM_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror (0x01U) /*!< Bit mask for HDMI_IH_I2CMPHY_STAT0_i2cmphyerror. */
#define BS_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror (1U) /*!< Bit field size in bits for HDMI_IH_I2CMPHY_STAT0_i2cmphyerror. */

/*! @brief Read current value of the HDMI_IH_I2CMPHY_STAT0_i2cmphyerror field. */
#define BR_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror(x) (HW_HDMI_IH_I2CMPHY_STAT0(x).B.i2cmphyerror)

/*! @brief Format value for bitfield HDMI_IH_I2CMPHY_STAT0_i2cmphyerror. */
#define BF_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror) & BM_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror)

/*! @brief Set the i2cmphyerror field to a new value. */
#define BW_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror(x, v) (HW_HDMI_IH_I2CMPHY_STAT0_WR(x, (HW_HDMI_IH_I2CMPHY_STAT0_RD(x) & ~(BM_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror | BM_HDMI_IH_I2CMPHY_STAT0_i2cmphydone)) | BF_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_I2CMPHY_STAT0, field i2cmphydone[1] (W1C)
 *
 * I2C Master PHY done indication
 */
/*@{*/
#define BP_HDMI_IH_I2CMPHY_STAT0_i2cmphydone (1U) /*!< Bit position for HDMI_IH_I2CMPHY_STAT0_i2cmphydone. */
#define BM_HDMI_IH_I2CMPHY_STAT0_i2cmphydone (0x02U) /*!< Bit mask for HDMI_IH_I2CMPHY_STAT0_i2cmphydone. */
#define BS_HDMI_IH_I2CMPHY_STAT0_i2cmphydone (1U) /*!< Bit field size in bits for HDMI_IH_I2CMPHY_STAT0_i2cmphydone. */

/*! @brief Read current value of the HDMI_IH_I2CMPHY_STAT0_i2cmphydone field. */
#define BR_HDMI_IH_I2CMPHY_STAT0_i2cmphydone(x) (HW_HDMI_IH_I2CMPHY_STAT0(x).B.i2cmphydone)

/*! @brief Format value for bitfield HDMI_IH_I2CMPHY_STAT0_i2cmphydone. */
#define BF_HDMI_IH_I2CMPHY_STAT0_i2cmphydone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_I2CMPHY_STAT0_i2cmphydone) & BM_HDMI_IH_I2CMPHY_STAT0_i2cmphydone)

/*! @brief Set the i2cmphydone field to a new value. */
#define BW_HDMI_IH_I2CMPHY_STAT0_i2cmphydone(x, v) (HW_HDMI_IH_I2CMPHY_STAT0_WR(x, (HW_HDMI_IH_I2CMPHY_STAT0_RD(x) & ~(BM_HDMI_IH_I2CMPHY_STAT0_i2cmphydone | BM_HDMI_IH_I2CMPHY_STAT0_i2cmphyerror)) | BF_HDMI_IH_I2CMPHY_STAT0_i2cmphydone(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Status Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0109 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_ih_ahbdmaaud_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_ahbdmaaud_stat0_bitfields
    {
        uint8_t ahbdmaaud_intbuffempty : 1; /*!< [0]  */
        uint8_t ahbdmaaud_intbufffull : 1; /*!< [1]  */
        uint8_t ahbdmaaud_intdone : 1; /*!< [2]  */
        uint8_t ahbdmaaud_intretrysplit : 1; /*!< [3]  */
        uint8_t ahbdmaaud_intlostownership : 1; /*!< [4]  */
        uint8_t ahbdmaaud_interror : 1; /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_ih_ahbdmaaud_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_AHBDMAAUD_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_AHBDMAAUD_STAT0_ADDR(x) ((uintptr_t)(x) + 0x109U)

#define HW_HDMI_IH_AHBDMAAUD_STAT0(x) (*(__IO hw_hdmi_ih_ahbdmaaud_stat0_t *) HW_HDMI_IH_AHBDMAAUD_STAT0_ADDR(x))
#define HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).U)
#define HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).U = (v))
#define HW_HDMI_IH_AHBDMAAUD_STAT0_SET(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_AHBDMAAUD_STAT0_CLR(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_AHBDMAAUD_STAT0_TOG(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_AHBDMAAUD_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_intbuffempty[0] (W1C)
 *
 * AHB audio DMA Buffer empty interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (0U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (0x01U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intbuffempty)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty)

/*! @brief Set the ahbdmaaud_intbuffempty field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_intbufffull[1] (W1C)
 *
 * AHB audio DMA Buffer full interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (1U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (0x02U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intbufffull)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull)

/*! @brief Set the ahbdmaaud_intbufffull field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_intdone[2] (W1C)
 *
 * AHB audio DMA done interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone (2U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone (0x04U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intdone)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone)

/*! @brief Set the ahbdmaaud_intdone field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_intretrysplit[3] (W1C)
 *
 * AHB audio DMA RETRY/SPLIT interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (3U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (0x08U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intretrysplit)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit)

/*! @brief Set the ahbdmaaud_intretrysplit field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_intlostownership[4] (W1C)
 *
 * AHB audio DMA lost ownership interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (4U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (0x10U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intlostownership)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership)

/*! @brief Set the ahbdmaaud_intlostownership field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_AHBDMAAUD_STAT0, field ahbdmaaud_interror[5] (W1C)
 *
 * AHB audio DMA error interrupt
 */
/*@{*/
#define BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror (5U) /*!< Bit position for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror (0x20U) /*!< Bit mask for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BS_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror (1U) /*!< Bit field size in bits for HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror. */

/*! @brief Read current value of the HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror field. */
#define BR_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror(x) (HW_HDMI_IH_AHBDMAAUD_STAT0(x).B.ahbdmaaud_interror)

/*! @brief Format value for bitfield HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror) & BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror)

/*! @brief Set the ahbdmaaud_interror field to a new value. */
#define BW_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror(x, v) (HW_HDMI_IH_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_AHBDMAAUD_STAT0_RD(x) & ~(BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intdone | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit | BM_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership)) | BF_HDMI_IH_AHBDMAAUD_STAT0_ahbdmaaud_interror(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_FC_STAT0 - Frame Composer Interrupt Mute Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_FC_STAT0 - Frame Composer Interrupt Mute Control Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0180 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_fc_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_fc_stat0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t OBA : 1;               /*!< [3]  */
        uint8_t DST : 1;               /*!< [4]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_ih_mute_fc_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_FC_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_FC_STAT0_ADDR(x) ((uintptr_t)(x) + 0x180U)

#define HW_HDMI_IH_MUTE_FC_STAT0(x) (*(__IO hw_hdmi_ih_mute_fc_stat0_t *) HW_HDMI_IH_MUTE_FC_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_FC_STAT0_RD(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).U)
#define HW_HDMI_IH_MUTE_FC_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_FC_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_FC_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, HW_HDMI_IH_MUTE_FC_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_FC_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_FC_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, HW_HDMI_IH_MUTE_FC_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_FC_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field NULL_[0] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_NULL_ (0U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_NULL_. */
#define BM_HDMI_IH_MUTE_FC_STAT0_NULL_ (0x01U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_NULL_. */
#define BS_HDMI_IH_MUTE_FC_STAT0_NULL_ (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_NULL_. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_NULL_ field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_NULL_(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.NULL_)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_NULL_. */
#define BF_HDMI_IH_MUTE_FC_STAT0_NULL_(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_NULL_) & BM_HDMI_IH_MUTE_FC_STAT0_NULL_)

/*! @brief Set the NULL_ field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_NULL_(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_NULL_) | BF_HDMI_IH_MUTE_FC_STAT0_NULL_(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field ACR[1] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_ACR (1U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_ACR. */
#define BM_HDMI_IH_MUTE_FC_STAT0_ACR (0x02U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_ACR. */
#define BS_HDMI_IH_MUTE_FC_STAT0_ACR (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_ACR. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_ACR field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_ACR(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.ACR)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_ACR. */
#define BF_HDMI_IH_MUTE_FC_STAT0_ACR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_ACR) & BM_HDMI_IH_MUTE_FC_STAT0_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_ACR(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_ACR) | BF_HDMI_IH_MUTE_FC_STAT0_ACR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field AUDS[2] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_AUDS (2U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_AUDS. */
#define BM_HDMI_IH_MUTE_FC_STAT0_AUDS (0x04U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_AUDS. */
#define BS_HDMI_IH_MUTE_FC_STAT0_AUDS (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_AUDS. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_AUDS field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_AUDS(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.AUDS)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_AUDS. */
#define BF_HDMI_IH_MUTE_FC_STAT0_AUDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_AUDS) & BM_HDMI_IH_MUTE_FC_STAT0_AUDS)

/*! @brief Set the AUDS field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_AUDS(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_AUDS) | BF_HDMI_IH_MUTE_FC_STAT0_AUDS(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field OBA[3] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_OBA (3U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_OBA. */
#define BM_HDMI_IH_MUTE_FC_STAT0_OBA (0x08U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_OBA. */
#define BS_HDMI_IH_MUTE_FC_STAT0_OBA (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_OBA. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_OBA field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_OBA(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.OBA)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_OBA. */
#define BF_HDMI_IH_MUTE_FC_STAT0_OBA(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_OBA) & BM_HDMI_IH_MUTE_FC_STAT0_OBA)

/*! @brief Set the OBA field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_OBA(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_OBA) | BF_HDMI_IH_MUTE_FC_STAT0_OBA(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field DST[4] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_DST (4U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_DST. */
#define BM_HDMI_IH_MUTE_FC_STAT0_DST (0x10U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_DST. */
#define BS_HDMI_IH_MUTE_FC_STAT0_DST (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_DST. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_DST field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_DST(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.DST)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_DST. */
#define BF_HDMI_IH_MUTE_FC_STAT0_DST(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_DST) & BM_HDMI_IH_MUTE_FC_STAT0_DST)

/*! @brief Set the DST field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_DST(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_DST) | BF_HDMI_IH_MUTE_FC_STAT0_DST(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field HBR[5] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_HBR (5U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_HBR. */
#define BM_HDMI_IH_MUTE_FC_STAT0_HBR (0x20U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_HBR. */
#define BS_HDMI_IH_MUTE_FC_STAT0_HBR (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_HBR. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_HBR field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_HBR(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.HBR)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_HBR. */
#define BF_HDMI_IH_MUTE_FC_STAT0_HBR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_HBR) & BM_HDMI_IH_MUTE_FC_STAT0_HBR)

/*! @brief Set the HBR field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_HBR(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_HBR) | BF_HDMI_IH_MUTE_FC_STAT0_HBR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field ACP[6] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[6]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_ACP (6U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_ACP. */
#define BM_HDMI_IH_MUTE_FC_STAT0_ACP (0x40U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_ACP. */
#define BS_HDMI_IH_MUTE_FC_STAT0_ACP (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_ACP. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_ACP field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_ACP(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.ACP)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_ACP. */
#define BF_HDMI_IH_MUTE_FC_STAT0_ACP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_ACP) & BM_HDMI_IH_MUTE_FC_STAT0_ACP)

/*! @brief Set the ACP field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_ACP(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_ACP) | BF_HDMI_IH_MUTE_FC_STAT0_ACP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT0, field AUDI[7] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT0[7]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT0_AUDI (7U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT0_AUDI. */
#define BM_HDMI_IH_MUTE_FC_STAT0_AUDI (0x80U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT0_AUDI. */
#define BS_HDMI_IH_MUTE_FC_STAT0_AUDI (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT0_AUDI. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT0_AUDI field. */
#define BR_HDMI_IH_MUTE_FC_STAT0_AUDI(x) (HW_HDMI_IH_MUTE_FC_STAT0(x).B.AUDI)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT0_AUDI. */
#define BF_HDMI_IH_MUTE_FC_STAT0_AUDI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT0_AUDI) & BM_HDMI_IH_MUTE_FC_STAT0_AUDI)

/*! @brief Set the AUDI field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT0_AUDI(x, v) (HW_HDMI_IH_MUTE_FC_STAT0_WR(x, (HW_HDMI_IH_MUTE_FC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT0_AUDI) | BF_HDMI_IH_MUTE_FC_STAT0_AUDI(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_FC_STAT1 - Frame Composer Interrupt Mute Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_FC_STAT1 - Frame Composer Interrupt Mute Control Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0181 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_fc_stat1
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_fc_stat1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t MPEG : 1;              /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_ih_mute_fc_stat1_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_FC_STAT1 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_FC_STAT1_ADDR(x) ((uintptr_t)(x) + 0x181U)

#define HW_HDMI_IH_MUTE_FC_STAT1(x) (*(__IO hw_hdmi_ih_mute_fc_stat1_t *) HW_HDMI_IH_MUTE_FC_STAT1_ADDR(x))
#define HW_HDMI_IH_MUTE_FC_STAT1_RD(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).U)
#define HW_HDMI_IH_MUTE_FC_STAT1_WR(x, v) (HW_HDMI_IH_MUTE_FC_STAT1(x).U = (v))
#define HW_HDMI_IH_MUTE_FC_STAT1_SET(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, HW_HDMI_IH_MUTE_FC_STAT1_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_FC_STAT1_CLR(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_FC_STAT1_TOG(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, HW_HDMI_IH_MUTE_FC_STAT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_FC_STAT1 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field GCP[0] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_GCP (0U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_GCP. */
#define BM_HDMI_IH_MUTE_FC_STAT1_GCP (0x01U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_GCP. */
#define BS_HDMI_IH_MUTE_FC_STAT1_GCP (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_GCP. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_GCP field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_GCP(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_GCP. */
#define BF_HDMI_IH_MUTE_FC_STAT1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_GCP) & BM_HDMI_IH_MUTE_FC_STAT1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_GCP(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_GCP) | BF_HDMI_IH_MUTE_FC_STAT1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field AVI[1] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_AVI (1U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_AVI. */
#define BM_HDMI_IH_MUTE_FC_STAT1_AVI (0x02U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_AVI. */
#define BS_HDMI_IH_MUTE_FC_STAT1_AVI (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_AVI. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_AVI field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_AVI(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_AVI. */
#define BF_HDMI_IH_MUTE_FC_STAT1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_AVI) & BM_HDMI_IH_MUTE_FC_STAT1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_AVI(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_AVI) | BF_HDMI_IH_MUTE_FC_STAT1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field MPEG[2] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_MPEG (2U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_MPEG. */
#define BM_HDMI_IH_MUTE_FC_STAT1_MPEG (0x04U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_MPEG. */
#define BS_HDMI_IH_MUTE_FC_STAT1_MPEG (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_MPEG. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_MPEG field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_MPEG(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.MPEG)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_MPEG. */
#define BF_HDMI_IH_MUTE_FC_STAT1_MPEG(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_MPEG) & BM_HDMI_IH_MUTE_FC_STAT1_MPEG)

/*! @brief Set the MPEG field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_MPEG(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_MPEG) | BF_HDMI_IH_MUTE_FC_STAT1_MPEG(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field SPD[3] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_SPD (3U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_SPD. */
#define BM_HDMI_IH_MUTE_FC_STAT1_SPD (0x08U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_SPD. */
#define BS_HDMI_IH_MUTE_FC_STAT1_SPD (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_SPD. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_SPD field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_SPD(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_SPD. */
#define BF_HDMI_IH_MUTE_FC_STAT1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_SPD) & BM_HDMI_IH_MUTE_FC_STAT1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_SPD(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_SPD) | BF_HDMI_IH_MUTE_FC_STAT1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field VSD[4] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_VSD (4U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_VSD. */
#define BM_HDMI_IH_MUTE_FC_STAT1_VSD (0x10U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_VSD. */
#define BS_HDMI_IH_MUTE_FC_STAT1_VSD (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_VSD. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_VSD field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_VSD(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_VSD. */
#define BF_HDMI_IH_MUTE_FC_STAT1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_VSD) & BM_HDMI_IH_MUTE_FC_STAT1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_VSD(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_VSD) | BF_HDMI_IH_MUTE_FC_STAT1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field ISCR2[5] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_ISCR2 (5U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_ISCR2. */
#define BM_HDMI_IH_MUTE_FC_STAT1_ISCR2 (0x20U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_ISCR2. */
#define BS_HDMI_IH_MUTE_FC_STAT1_ISCR2 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_ISCR2. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_ISCR2 field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_ISCR2(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_ISCR2. */
#define BF_HDMI_IH_MUTE_FC_STAT1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_ISCR2) & BM_HDMI_IH_MUTE_FC_STAT1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_ISCR2(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_ISCR2) | BF_HDMI_IH_MUTE_FC_STAT1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field ISCR1[6] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[6]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_ISCR1 (6U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_ISCR1. */
#define BM_HDMI_IH_MUTE_FC_STAT1_ISCR1 (0x40U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_ISCR1. */
#define BS_HDMI_IH_MUTE_FC_STAT1_ISCR1 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_ISCR1. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_ISCR1 field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_ISCR1(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_ISCR1. */
#define BF_HDMI_IH_MUTE_FC_STAT1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_ISCR1) & BM_HDMI_IH_MUTE_FC_STAT1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_ISCR1(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_ISCR1) | BF_HDMI_IH_MUTE_FC_STAT1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT1, field GMD[7] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT1[7]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT1_GMD (7U)  /*!< Bit position for HDMI_IH_MUTE_FC_STAT1_GMD. */
#define BM_HDMI_IH_MUTE_FC_STAT1_GMD (0x80U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT1_GMD. */
#define BS_HDMI_IH_MUTE_FC_STAT1_GMD (1U)  /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT1_GMD. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT1_GMD field. */
#define BR_HDMI_IH_MUTE_FC_STAT1_GMD(x) (HW_HDMI_IH_MUTE_FC_STAT1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT1_GMD. */
#define BF_HDMI_IH_MUTE_FC_STAT1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT1_GMD) & BM_HDMI_IH_MUTE_FC_STAT1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT1_GMD(x, v) (HW_HDMI_IH_MUTE_FC_STAT1_WR(x, (HW_HDMI_IH_MUTE_FC_STAT1_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT1_GMD) | BF_HDMI_IH_MUTE_FC_STAT1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_FC_STAT2 - Frame Composer Interrupt Mute Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_FC_STAT2 - Frame Composer Interrupt Mute Control Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0182 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_fc_stat2
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_fc_stat2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_mute_fc_stat2_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_FC_STAT2 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_FC_STAT2_ADDR(x) ((uintptr_t)(x) + 0x182U)

#define HW_HDMI_IH_MUTE_FC_STAT2(x) (*(__IO hw_hdmi_ih_mute_fc_stat2_t *) HW_HDMI_IH_MUTE_FC_STAT2_ADDR(x))
#define HW_HDMI_IH_MUTE_FC_STAT2_RD(x) (HW_HDMI_IH_MUTE_FC_STAT2(x).U)
#define HW_HDMI_IH_MUTE_FC_STAT2_WR(x, v) (HW_HDMI_IH_MUTE_FC_STAT2(x).U = (v))
#define HW_HDMI_IH_MUTE_FC_STAT2_SET(x, v) (HW_HDMI_IH_MUTE_FC_STAT2_WR(x, HW_HDMI_IH_MUTE_FC_STAT2_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_FC_STAT2_CLR(x, v) (HW_HDMI_IH_MUTE_FC_STAT2_WR(x, HW_HDMI_IH_MUTE_FC_STAT2_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_FC_STAT2_TOG(x, v) (HW_HDMI_IH_MUTE_FC_STAT2_WR(x, HW_HDMI_IH_MUTE_FC_STAT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_FC_STAT2 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT2, field HighPriority_overflow[0] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT2[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow (0U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow. */
#define BM_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow. */
#define BS_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow field. */
#define BR_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow(x) (HW_HDMI_IH_MUTE_FC_STAT2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow. */
#define BF_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow) & BM_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow(x, v) (HW_HDMI_IH_MUTE_FC_STAT2_WR(x, (HW_HDMI_IH_MUTE_FC_STAT2_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow) | BF_HDMI_IH_MUTE_FC_STAT2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_FC_STAT2, field LowPriority_overflow[1] (RW)
 *
 * When set to 1, mutes IH_ FC_STAT2[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow (1U) /*!< Bit position for HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow. */
#define BM_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow. */
#define BS_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow field. */
#define BR_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow(x) (HW_HDMI_IH_MUTE_FC_STAT2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow. */
#define BF_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow) & BM_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow(x, v) (HW_HDMI_IH_MUTE_FC_STAT2_WR(x, (HW_HDMI_IH_MUTE_FC_STAT2_RD(x) & ~BM_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow) | BF_HDMI_IH_MUTE_FC_STAT2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_AS_STAT0 - Audio Sampler Interrupt Mute Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_AS_STAT0 - Audio Sampler Interrupt Mute Control Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0183 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_as_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_as_stat0_bitfields
    {
        uint8_t Aud_fifo_overflow : 1; /*!< [0]  */
        uint8_t Aud_fifo_underflow : 1; /*!< [1]  */
        uint8_t Aud_fifo_underflow_thr : 1; /*!< [2]  */
        uint8_t RESERVED0 : 5;         /*!< [7:3]  */
    } B;
} hw_hdmi_ih_mute_as_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_AS_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_AS_STAT0_ADDR(x) ((uintptr_t)(x) + 0x183U)

#define HW_HDMI_IH_MUTE_AS_STAT0(x) (*(__IO hw_hdmi_ih_mute_as_stat0_t *) HW_HDMI_IH_MUTE_AS_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_AS_STAT0_RD(x) (HW_HDMI_IH_MUTE_AS_STAT0(x).U)
#define HW_HDMI_IH_MUTE_AS_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_AS_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_AS_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, HW_HDMI_IH_MUTE_AS_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_AS_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, HW_HDMI_IH_MUTE_AS_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_AS_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, HW_HDMI_IH_MUTE_AS_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_AS_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_AS_STAT0, field Aud_fifo_overflow[0] (RW)
 *
 * When set to 1, mutes IH_ AS_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow (0U) /*!< Bit position for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow. */
#define BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow (0x01U) /*!< Bit mask for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow. */
#define BS_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow. */

/*! @brief Read current value of the HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow field. */
#define BR_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow(x) (HW_HDMI_IH_MUTE_AS_STAT0(x).B.Aud_fifo_overflow)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow. */
#define BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow) & BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow)

/*! @brief Set the Aud_fifo_overflow field to a new value. */
#define BW_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, (HW_HDMI_IH_MUTE_AS_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow) | BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AS_STAT0, field Aud_fifo_underflow[1] (RW)
 *
 * When set to 1, mutes IH_ AS_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow (1U) /*!< Bit position for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow. */
#define BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow (0x02U) /*!< Bit mask for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow. */
#define BS_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow. */

/*! @brief Read current value of the HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow field. */
#define BR_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow(x) (HW_HDMI_IH_MUTE_AS_STAT0(x).B.Aud_fifo_underflow)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow. */
#define BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow) & BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow)

/*! @brief Set the Aud_fifo_underflow field to a new value. */
#define BW_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, (HW_HDMI_IH_MUTE_AS_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow) | BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AS_STAT0, field Aud_fifo_underflow_thr[2] (RW)
 *
 * When set to 1, mutes IH_ AS_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr (2U) /*!< Bit position for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr. */
#define BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr (0x04U) /*!< Bit mask for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr. */
#define BS_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr. */

/*! @brief Read current value of the HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr field. */
#define BR_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr(x) (HW_HDMI_IH_MUTE_AS_STAT0(x).B.Aud_fifo_underflow_thr)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr. */
#define BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr) & BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr)

/*! @brief Set the Aud_fifo_underflow_thr field to a new value. */
#define BW_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr(x, v) (HW_HDMI_IH_MUTE_AS_STAT0_WR(x, (HW_HDMI_IH_MUTE_AS_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr) | BF_HDMI_IH_MUTE_AS_STAT0_Aud_fifo_underflow_thr(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_PHY_STAT0 - PHY Interface Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_PHY_STAT0 - PHY Interface Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0184 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_phy_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_phy_stat0_bitfields
    {
        uint8_t HDP : 1;               /*!< [0]  */
        uint8_t TX_PHY_LOCK : 1;       /*!< [1]  */
        uint8_t RX_SENSE0 : 1;         /*!< [2]  */
        uint8_t RX_SENSE1 : 1;         /*!< [3]  */
        uint8_t RX_SENSE2 : 1;         /*!< [4]  */
        uint8_t RX_SENSE3 : 1;         /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_ih_mute_phy_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_PHY_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_PHY_STAT0_ADDR(x) ((uintptr_t)(x) + 0x184U)

#define HW_HDMI_IH_MUTE_PHY_STAT0(x) (*(__IO hw_hdmi_ih_mute_phy_stat0_t *) HW_HDMI_IH_MUTE_PHY_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).U)
#define HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_PHY_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_PHY_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_PHY_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_PHY_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field HDP[0] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_HDP (0U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_HDP. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_HDP (0x01U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_HDP. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_HDP (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_HDP. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_HDP field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_HDP(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.HDP)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_HDP. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_HDP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_HDP) & BM_HDMI_IH_MUTE_PHY_STAT0_HDP)

/*! @brief Set the HDP field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_HDP(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_HDP) | BF_HDMI_IH_MUTE_PHY_STAT0_HDP(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field TX_PHY_LOCK[1] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK (1U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK (0x02U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.TX_PHY_LOCK)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK) & BM_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK)

/*! @brief Set the TX_PHY_LOCK field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK) | BF_HDMI_IH_MUTE_PHY_STAT0_TX_PHY_LOCK(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field RX_SENSE0[2] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0 (2U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0 (0x04U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0 field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.RX_SENSE0)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0) & BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0)

/*! @brief Set the RX_SENSE0 field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0) | BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE0(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field RX_SENSE1[3] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1 (3U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1 (0x08U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1 field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.RX_SENSE1)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1) & BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1)

/*! @brief Set the RX_SENSE1 field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1) | BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE1(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field RX_SENSE2[4] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2 (4U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2 (0x10U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2 field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.RX_SENSE2)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2) & BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2)

/*! @brief Set the RX_SENSE2 field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2) | BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE2(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_PHY_STAT0, field RX_SENSE3[5] (RW)
 *
 * When set to 1, mutes IH_ PHY_STAT0[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3 (5U) /*!< Bit position for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3. */
#define BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3 (0x20U) /*!< Bit mask for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3. */
#define BS_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3 (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3 field. */
#define BR_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3(x) (HW_HDMI_IH_MUTE_PHY_STAT0(x).B.RX_SENSE3)

/*! @brief Format value for bitfield HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3. */
#define BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3) & BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3)

/*! @brief Set the RX_SENSE3 field to a new value. */
#define BW_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3(x, v) (HW_HDMI_IH_MUTE_PHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_PHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3) | BF_HDMI_IH_MUTE_PHY_STAT0_RX_SENSE3(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_I2CM_STAT0 - E-DDC I2C Master Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_I2CM_STAT0 - E-DDC I2C Master Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0185 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_i2cm_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_i2cm_stat0_bitfields
    {
        uint8_t I2CMASTER_ERROR : 1;   /*!< [0]  */
        uint8_t I2Cmasterdone : 1;     /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_mute_i2cm_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_I2CM_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_I2CM_STAT0_ADDR(x) ((uintptr_t)(x) + 0x185U)

#define HW_HDMI_IH_MUTE_I2CM_STAT0(x) (*(__IO hw_hdmi_ih_mute_i2cm_stat0_t *) HW_HDMI_IH_MUTE_I2CM_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) (HW_HDMI_IH_MUTE_I2CM_STAT0(x).U)
#define HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_I2CM_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_I2CM_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_I2CM_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_I2CM_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_I2CM_STAT0, field I2CMASTER_ERROR[0] (RW)
 *
 * When set to 1, mutes IH_ I2CM_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR (0U) /*!< Bit position for HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR. */
#define BM_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR (0x01U) /*!< Bit mask for HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR. */
#define BS_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR. */

/*! @brief Read current value of the HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR field. */
#define BR_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR(x) (HW_HDMI_IH_MUTE_I2CM_STAT0(x).B.I2CMASTER_ERROR)

/*! @brief Format value for bitfield HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR. */
#define BF_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR) & BM_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR)

/*! @brief Set the I2CMASTER_ERROR field to a new value. */
#define BW_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, (HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR) | BF_HDMI_IH_MUTE_I2CM_STAT0_I2CMASTER_ERROR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_I2CM_STAT0, field I2Cmasterdone[1] (RW)
 *
 * When set to 1, mutes IH_ I2CM_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone (1U) /*!< Bit position for HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone. */
#define BM_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone (0x02U) /*!< Bit mask for HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone. */
#define BS_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone. */

/*! @brief Read current value of the HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone field. */
#define BR_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone(x) (HW_HDMI_IH_MUTE_I2CM_STAT0(x).B.I2Cmasterdone)

/*! @brief Format value for bitfield HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone. */
#define BF_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone) & BM_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone)

/*! @brief Set the I2Cmasterdone field to a new value. */
#define BW_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone(x, v) (HW_HDMI_IH_MUTE_I2CM_STAT0_WR(x, (HW_HDMI_IH_MUTE_I2CM_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone) | BF_HDMI_IH_MUTE_I2CM_STAT0_I2Cmasterdone(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_CEC_STAT0 - CEC Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_CEC_STAT0 - CEC Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0186 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_cec_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_cec_stat0_bitfields
    {
        uint8_t DONE : 1;              /*!< [0]  */
        uint8_t EOM : 1;               /*!< [1]  */
        uint8_t NACK : 1;              /*!< [2]  */
        uint8_t ARB_LOST : 1;          /*!< [3]  */
        uint8_t ERROR_INITIATOR : 1;   /*!< [4]  */
        uint8_t ERROR_FOLLOW : 1;      /*!< [5]  */
        uint8_t WAKEUP : 1;            /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_ih_mute_cec_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_CEC_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_CEC_STAT0_ADDR(x) ((uintptr_t)(x) + 0x186U)

#define HW_HDMI_IH_MUTE_CEC_STAT0(x) (*(__IO hw_hdmi_ih_mute_cec_stat0_t *) HW_HDMI_IH_MUTE_CEC_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).U)
#define HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_CEC_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_CEC_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_CEC_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_CEC_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field DONE[0] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_DONE (0U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_DONE. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_DONE (0x01U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_DONE. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_DONE (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_DONE. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_DONE field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_DONE(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.DONE)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_DONE. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_DONE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_DONE) & BM_HDMI_IH_MUTE_CEC_STAT0_DONE)

/*! @brief Set the DONE field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_DONE(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_DONE) | BF_HDMI_IH_MUTE_CEC_STAT0_DONE(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field EOM[1] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_EOM (1U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_EOM. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_EOM (0x02U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_EOM. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_EOM (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_EOM. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_EOM field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_EOM(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.EOM)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_EOM. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_EOM(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_EOM) & BM_HDMI_IH_MUTE_CEC_STAT0_EOM)

/*! @brief Set the EOM field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_EOM(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_EOM) | BF_HDMI_IH_MUTE_CEC_STAT0_EOM(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field NACK[2] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_NACK (2U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_NACK. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_NACK (0x04U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_NACK. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_NACK (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_NACK. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_NACK field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_NACK(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.NACK)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_NACK. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_NACK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_NACK) & BM_HDMI_IH_MUTE_CEC_STAT0_NACK)

/*! @brief Set the NACK field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_NACK(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_NACK) | BF_HDMI_IH_MUTE_CEC_STAT0_NACK(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field ARB_LOST[3] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST (3U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_ARB_LOST. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST (0x08U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_ARB_LOST. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_ARB_LOST. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_ARB_LOST field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.ARB_LOST)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_ARB_LOST. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST) & BM_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST)

/*! @brief Set the ARB_LOST field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST) | BF_HDMI_IH_MUTE_CEC_STAT0_ARB_LOST(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field ERROR_INITIATOR[4] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR (4U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR (0x10U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.ERROR_INITIATOR)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR) & BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR)

/*! @brief Set the ERROR_INITIATOR field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR) | BF_HDMI_IH_MUTE_CEC_STAT0_ERROR_INITIATOR(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field ERROR_FOLLOW[5] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW (5U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW (0x20U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.ERROR_FOLLOW)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW) & BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW)

/*! @brief Set the ERROR_FOLLOW field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW) | BF_HDMI_IH_MUTE_CEC_STAT0_ERROR_FOLLOW(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_CEC_STAT0, field WAKEUP[6] (RW)
 *
 * When set to 1, mutes IH_ CEC_STAT0[6]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_CEC_STAT0_WAKEUP (6U) /*!< Bit position for HDMI_IH_MUTE_CEC_STAT0_WAKEUP. */
#define BM_HDMI_IH_MUTE_CEC_STAT0_WAKEUP (0x40U) /*!< Bit mask for HDMI_IH_MUTE_CEC_STAT0_WAKEUP. */
#define BS_HDMI_IH_MUTE_CEC_STAT0_WAKEUP (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_CEC_STAT0_WAKEUP. */

/*! @brief Read current value of the HDMI_IH_MUTE_CEC_STAT0_WAKEUP field. */
#define BR_HDMI_IH_MUTE_CEC_STAT0_WAKEUP(x) (HW_HDMI_IH_MUTE_CEC_STAT0(x).B.WAKEUP)

/*! @brief Format value for bitfield HDMI_IH_MUTE_CEC_STAT0_WAKEUP. */
#define BF_HDMI_IH_MUTE_CEC_STAT0_WAKEUP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_CEC_STAT0_WAKEUP) & BM_HDMI_IH_MUTE_CEC_STAT0_WAKEUP)

/*! @brief Set the WAKEUP field to a new value. */
#define BW_HDMI_IH_MUTE_CEC_STAT0_WAKEUP(x, v) (HW_HDMI_IH_MUTE_CEC_STAT0_WR(x, (HW_HDMI_IH_MUTE_CEC_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_CEC_STAT0_WAKEUP) | BF_HDMI_IH_MUTE_CEC_STAT0_WAKEUP(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_VP_STAT0 - Video Packetizer Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_VP_STAT0 - Video Packetizer Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0187 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_vp_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_vp_stat0_bitfields
    {
        uint8_t fifoemptybyp : 1;      /*!< [0]  */
        uint8_t fifofullbyp : 1;       /*!< [1]  */
        uint8_t fifoemptyremap : 1;    /*!< [2]  */
        uint8_t fifofullremap : 1;     /*!< [3]  */
        uint8_t fifoemptypp : 1;       /*!< [4]  */
        uint8_t fifofullpp : 1;        /*!< [5]  */
        uint8_t fifoemptyrepet : 1;    /*!< [6]  */
        uint8_t fifofullrepet : 1;     /*!< [7]  */
    } B;
} hw_hdmi_ih_mute_vp_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_VP_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_VP_STAT0_ADDR(x) ((uintptr_t)(x) + 0x187U)

#define HW_HDMI_IH_MUTE_VP_STAT0(x) (*(__IO hw_hdmi_ih_mute_vp_stat0_t *) HW_HDMI_IH_MUTE_VP_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_VP_STAT0_RD(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).U)
#define HW_HDMI_IH_MUTE_VP_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_VP_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_VP_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, HW_HDMI_IH_MUTE_VP_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_VP_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_VP_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, HW_HDMI_IH_MUTE_VP_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_VP_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifoemptybyp[0] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp (0U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifoemptybyp. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp (0x01U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifoemptybyp. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifoemptybyp. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifoemptybyp field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifoemptybyp)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifoemptybyp. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp) & BM_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp)

/*! @brief Set the fifoemptybyp field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp) | BF_HDMI_IH_MUTE_VP_STAT0_fifoemptybyp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifofullbyp[1] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifofullbyp (1U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifofullbyp. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifofullbyp (0x02U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifofullbyp. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifofullbyp (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifofullbyp. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifofullbyp field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifofullbyp(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifofullbyp)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifofullbyp. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifofullbyp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifofullbyp) & BM_HDMI_IH_MUTE_VP_STAT0_fifofullbyp)

/*! @brief Set the fifofullbyp field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifofullbyp(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifofullbyp) | BF_HDMI_IH_MUTE_VP_STAT0_fifofullbyp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifoemptyremap[2] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap (2U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifoemptyremap. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap (0x04U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifoemptyremap. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifoemptyremap. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifoemptyremap field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifoemptyremap)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifoemptyremap. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap) & BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap)

/*! @brief Set the fifoemptyremap field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap) | BF_HDMI_IH_MUTE_VP_STAT0_fifoemptyremap(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifofullremap[3] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifofullremap (3U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifofullremap. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifofullremap (0x08U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifofullremap. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifofullremap (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifofullremap. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifofullremap field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifofullremap(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifofullremap)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifofullremap. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifofullremap(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifofullremap) & BM_HDMI_IH_MUTE_VP_STAT0_fifofullremap)

/*! @brief Set the fifofullremap field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifofullremap(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifofullremap) | BF_HDMI_IH_MUTE_VP_STAT0_fifofullremap(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifoemptypp[4] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifoemptypp (4U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifoemptypp. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifoemptypp (0x10U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifoemptypp. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifoemptypp (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifoemptypp. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifoemptypp field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifoemptypp(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifoemptypp)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifoemptypp. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifoemptypp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifoemptypp) & BM_HDMI_IH_MUTE_VP_STAT0_fifoemptypp)

/*! @brief Set the fifoemptypp field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifoemptypp(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifoemptypp) | BF_HDMI_IH_MUTE_VP_STAT0_fifoemptypp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifofullpp[5] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifofullpp (5U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifofullpp. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifofullpp (0x20U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifofullpp. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifofullpp (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifofullpp. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifofullpp field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifofullpp(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifofullpp)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifofullpp. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifofullpp(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifofullpp) & BM_HDMI_IH_MUTE_VP_STAT0_fifofullpp)

/*! @brief Set the fifofullpp field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifofullpp(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifofullpp) | BF_HDMI_IH_MUTE_VP_STAT0_fifofullpp(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifoemptyrepet[6] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[6]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet (6U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet (0x40U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifoemptyrepet)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet) & BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet)

/*! @brief Set the fifoemptyrepet field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet) | BF_HDMI_IH_MUTE_VP_STAT0_fifoemptyrepet(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_VP_STAT0, field fifofullrepet[7] (RW)
 *
 * When set to 1, mutes IH_ VP_STAT0[7]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_VP_STAT0_fifofullrepet (7U) /*!< Bit position for HDMI_IH_MUTE_VP_STAT0_fifofullrepet. */
#define BM_HDMI_IH_MUTE_VP_STAT0_fifofullrepet (0x80U) /*!< Bit mask for HDMI_IH_MUTE_VP_STAT0_fifofullrepet. */
#define BS_HDMI_IH_MUTE_VP_STAT0_fifofullrepet (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_VP_STAT0_fifofullrepet. */

/*! @brief Read current value of the HDMI_IH_MUTE_VP_STAT0_fifofullrepet field. */
#define BR_HDMI_IH_MUTE_VP_STAT0_fifofullrepet(x) (HW_HDMI_IH_MUTE_VP_STAT0(x).B.fifofullrepet)

/*! @brief Format value for bitfield HDMI_IH_MUTE_VP_STAT0_fifofullrepet. */
#define BF_HDMI_IH_MUTE_VP_STAT0_fifofullrepet(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_VP_STAT0_fifofullrepet) & BM_HDMI_IH_MUTE_VP_STAT0_fifofullrepet)

/*! @brief Set the fifofullrepet field to a new value. */
#define BW_HDMI_IH_MUTE_VP_STAT0_fifofullrepet(x, v) (HW_HDMI_IH_MUTE_VP_STAT0_WR(x, (HW_HDMI_IH_MUTE_VP_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_VP_STAT0_fifofullrepet) | BF_HDMI_IH_MUTE_VP_STAT0_fifofullrepet(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_I2CMPHY_STAT0 - PHY GEN 2 I2C Master Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_I2CMPHY_STAT0 - PHY GEN 2 I2C Master Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0188 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_i2cmphy_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_i2cmphy_stat0_bitfields
    {
        uint8_t i2cmphyerror : 1;      /*!< [0]  */
        uint8_t i2cmphydone : 1;       /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ih_mute_i2cmphy_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_I2CMPHY_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_ADDR(x) ((uintptr_t)(x) + 0x188U)

#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0(x) (*(__IO hw_hdmi_ih_mute_i2cmphy_stat0_t *) HW_HDMI_IH_MUTE_I2CMPHY_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0(x).U)
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_I2CMPHY_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_I2CMPHY_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_I2CMPHY_STAT0, field i2cmphyerror[0] (RW)
 *
 * When set to 1, mutes IH_ I2CMPHY_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror (0U) /*!< Bit position for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror. */
#define BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror (0x01U) /*!< Bit mask for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror. */
#define BS_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror. */

/*! @brief Read current value of the HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror field. */
#define BR_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror(x) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0(x).B.i2cmphyerror)

/*! @brief Format value for bitfield HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror. */
#define BF_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror) & BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror)

/*! @brief Set the i2cmphyerror field to a new value. */
#define BW_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror) | BF_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphyerror(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_I2CMPHY_STAT0, field i2cmphydone[1] (RW)
 *
 * When set to 1, mutes IH_ I2CMPHY_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone (1U) /*!< Bit position for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone. */
#define BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone (0x02U) /*!< Bit mask for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone. */
#define BS_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone. */

/*! @brief Read current value of the HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone field. */
#define BR_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone(x) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0(x).B.i2cmphydone)

/*! @brief Format value for bitfield HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone. */
#define BF_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone) & BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone)

/*! @brief Set the i2cmphydone field to a new value. */
#define BW_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone(x, v) (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_WR(x, (HW_HDMI_IH_MUTE_I2CMPHY_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone) | BF_HDMI_IH_MUTE_I2CMPHY_STAT0_i2cmphydone(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0 - AHB Audio DMA Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0189 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute_ahbdmaaud_stat0
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_ahbdmaaud_stat0_bitfields
    {
        uint8_t ahbdmaaud_intbuffempty : 1; /*!< [0]  */
        uint8_t ahbdmaaud_intbufffull : 1; /*!< [1]  */
        uint8_t ahbdmaaud_intdone : 1; /*!< [2]  */
        uint8_t ahbdmaaud_intretrysplit : 1; /*!< [3]  */
        uint8_t ahbdmaaud_intlostownership : 1; /*!< [4]  */
        uint8_t ahbdmaaud_interror : 1; /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_ih_mute_ahbdmaaud_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE_AHBDMAAUD_STAT0 register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ADDR(x) ((uintptr_t)(x) + 0x189U)

#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x) (*(__IO hw_hdmi_ih_mute_ahbdmaaud_stat0_t *) HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ADDR(x))
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).U)
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).U = (v))
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_SET(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_CLR(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_TOG(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE_AHBDMAAUD_STAT0 bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_intbuffempty[0] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[0]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (0U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (0x01U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intbuffempty)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty)

/*! @brief Set the ahbdmaaud_intbuffempty field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbuffempty(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_intbufffull[1] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[1]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (1U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (0x02U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intbufffull)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull)

/*! @brief Set the ahbdmaaud_intbufffull field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intbufffull(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_intdone[2] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[2]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone (2U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone (0x04U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intdone)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone)

/*! @brief Set the ahbdmaaud_intdone field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intdone(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_intretrysplit[3] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[3]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (3U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (0x08U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intretrysplit)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit)

/*! @brief Set the ahbdmaaud_intretrysplit field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intretrysplit(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_intlostownership[4] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[4]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (4U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (0x10U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_intlostownership)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership)

/*! @brief Set the ahbdmaaud_intlostownership field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_intlostownership(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE_AHBDMAAUD_STAT0, field ahbdmaaud_interror[5] (RW)
 *
 * When set to 1, mutes IH_AHBDMAAUD_STAT0[5]
 */
/*@{*/
#define BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror (5U) /*!< Bit position for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror (0x20U) /*!< Bit mask for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BS_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror. */

/*! @brief Read current value of the HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror field. */
#define BR_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror(x) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0(x).B.ahbdmaaud_interror)

/*! @brief Format value for bitfield HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror. */
#define BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror) & BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror)

/*! @brief Set the ahbdmaaud_interror field to a new value. */
#define BW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror(x, v) (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_WR(x, (HW_HDMI_IH_MUTE_AHBDMAAUD_STAT0_RD(x) & ~BM_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror) | BF_HDMI_IH_MUTE_AHBDMAAUD_STAT0_ahbdmaaud_interror(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_IH_MUTE - Global Interrupt Mute Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_IH_MUTE - Global Interrupt Mute Control Register (RW)
 *
 * Reset value: 0x03U
 *
 * Address Offset: 0x01FF Size: 8 bits Value after Reset: 0x03 Access: Read/Write
 */
typedef union _hw_hdmi_ih_mute
{
    uint8_t U;
    struct _hw_hdmi_ih_mute_bitfields
    {
        uint8_t mute_all_interrupt : 1; /*!< [0]  */
        uint8_t mute_wakeup_interrupt : 1; /*!< [1]  */
        uint8_t rsvd : 6;              /*!< [7:2]  */
    } B;
} hw_hdmi_ih_mute_t;

/*!
 * @name Constants and macros for entire HDMI_IH_MUTE register
 */
/*@{*/
#define HW_HDMI_IH_MUTE_ADDR(x)  ((uintptr_t)(x) + 0x1FFU)

#define HW_HDMI_IH_MUTE(x)       (*(__IO hw_hdmi_ih_mute_t *) HW_HDMI_IH_MUTE_ADDR(x))
#define HW_HDMI_IH_MUTE_RD(x)    (HW_HDMI_IH_MUTE(x).U)
#define HW_HDMI_IH_MUTE_WR(x, v) (HW_HDMI_IH_MUTE(x).U = (v))
#define HW_HDMI_IH_MUTE_SET(x, v) (HW_HDMI_IH_MUTE_WR(x, HW_HDMI_IH_MUTE_RD(x) |  (v)))
#define HW_HDMI_IH_MUTE_CLR(x, v) (HW_HDMI_IH_MUTE_WR(x, HW_HDMI_IH_MUTE_RD(x) & ~(v)))
#define HW_HDMI_IH_MUTE_TOG(x, v) (HW_HDMI_IH_MUTE_WR(x, HW_HDMI_IH_MUTE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_IH_MUTE bitfields
 */

/*!
 * @name Register HDMI_IH_MUTE, field mute_all_interrupt[0] (RW)
 *
 * When set to 1, mutes the main interrupt line (where all interrupts are ORed).
 * The sticky bit interrupts continue with their state; only the main interrupt
 * line will be muted.
 */
/*@{*/
#define BP_HDMI_IH_MUTE_mute_all_interrupt (0U) /*!< Bit position for HDMI_IH_MUTE_mute_all_interrupt. */
#define BM_HDMI_IH_MUTE_mute_all_interrupt (0x01U) /*!< Bit mask for HDMI_IH_MUTE_mute_all_interrupt. */
#define BS_HDMI_IH_MUTE_mute_all_interrupt (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_mute_all_interrupt. */

/*! @brief Read current value of the HDMI_IH_MUTE_mute_all_interrupt field. */
#define BR_HDMI_IH_MUTE_mute_all_interrupt(x) (HW_HDMI_IH_MUTE(x).B.mute_all_interrupt)

/*! @brief Format value for bitfield HDMI_IH_MUTE_mute_all_interrupt. */
#define BF_HDMI_IH_MUTE_mute_all_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_mute_all_interrupt) & BM_HDMI_IH_MUTE_mute_all_interrupt)

/*! @brief Set the mute_all_interrupt field to a new value. */
#define BW_HDMI_IH_MUTE_mute_all_interrupt(x, v) (HW_HDMI_IH_MUTE_WR(x, (HW_HDMI_IH_MUTE_RD(x) & ~BM_HDMI_IH_MUTE_mute_all_interrupt) | BF_HDMI_IH_MUTE_mute_all_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE, field mute_wakeup_interrupt[1] (RW)
 *
 * When set to 1, mutes the wake-up interrupt line. The sticky bit interrupt
 * continues with its state; only the wake up interrupt line is muted.
 */
/*@{*/
#define BP_HDMI_IH_MUTE_mute_wakeup_interrupt (1U) /*!< Bit position for HDMI_IH_MUTE_mute_wakeup_interrupt. */
#define BM_HDMI_IH_MUTE_mute_wakeup_interrupt (0x02U) /*!< Bit mask for HDMI_IH_MUTE_mute_wakeup_interrupt. */
#define BS_HDMI_IH_MUTE_mute_wakeup_interrupt (1U) /*!< Bit field size in bits for HDMI_IH_MUTE_mute_wakeup_interrupt. */

/*! @brief Read current value of the HDMI_IH_MUTE_mute_wakeup_interrupt field. */
#define BR_HDMI_IH_MUTE_mute_wakeup_interrupt(x) (HW_HDMI_IH_MUTE(x).B.mute_wakeup_interrupt)

/*! @brief Format value for bitfield HDMI_IH_MUTE_mute_wakeup_interrupt. */
#define BF_HDMI_IH_MUTE_mute_wakeup_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_IH_MUTE_mute_wakeup_interrupt) & BM_HDMI_IH_MUTE_mute_wakeup_interrupt)

/*! @brief Set the mute_wakeup_interrupt field to a new value. */
#define BW_HDMI_IH_MUTE_mute_wakeup_interrupt(x, v) (HW_HDMI_IH_MUTE_WR(x, (HW_HDMI_IH_MUTE_RD(x) & ~BM_HDMI_IH_MUTE_mute_wakeup_interrupt) | BF_HDMI_IH_MUTE_mute_wakeup_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_IH_MUTE, field rsvd[7:2] (RU)
 */
/*@{*/
#define BP_HDMI_IH_MUTE_rsvd (2U)          /*!< Bit position for HDMI_IH_MUTE_rsvd. */
#define BM_HDMI_IH_MUTE_rsvd (0xFCU)       /*!< Bit mask for HDMI_IH_MUTE_rsvd. */
#define BS_HDMI_IH_MUTE_rsvd (6U)          /*!< Bit field size in bits for HDMI_IH_MUTE_rsvd. */
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_INVID0 - Video Input Mapping and Internal Data Enable Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_INVID0 - Video Input Mapping and Internal Data Enable Configuration Register (RW)
 *
 * Reset value: 0x01U
 *
 * This registers contains the input video mapping code as defined in Table 2-1.
 * Address Offset: 0x0200 Size: 8 bits Value after Reset: 0x01 Access: Read/Write
 */
typedef union _hw_hdmi_tx_invid0
{
    uint8_t U;
    struct _hw_hdmi_tx_invid0_bitfields
    {
        uint8_t video_mapping : 5;     /*!< [4:0]  */
        uint8_t RESERVED0 : 2;         /*!< [6:5]  */
        uint8_t internal_de_generator : 1; /*!< [7]  */
    } B;
} hw_hdmi_tx_invid0_t;

/*!
 * @name Constants and macros for entire HDMI_TX_INVID0 register
 */
/*@{*/
#define HW_HDMI_TX_INVID0_ADDR(x) ((uintptr_t)(x) + 0x200U)

#define HW_HDMI_TX_INVID0(x)     (*(__IO hw_hdmi_tx_invid0_t *) HW_HDMI_TX_INVID0_ADDR(x))
#define HW_HDMI_TX_INVID0_RD(x)  (HW_HDMI_TX_INVID0(x).U)
#define HW_HDMI_TX_INVID0_WR(x, v) (HW_HDMI_TX_INVID0(x).U = (v))
#define HW_HDMI_TX_INVID0_SET(x, v) (HW_HDMI_TX_INVID0_WR(x, HW_HDMI_TX_INVID0_RD(x) |  (v)))
#define HW_HDMI_TX_INVID0_CLR(x, v) (HW_HDMI_TX_INVID0_WR(x, HW_HDMI_TX_INVID0_RD(x) & ~(v)))
#define HW_HDMI_TX_INVID0_TOG(x, v) (HW_HDMI_TX_INVID0_WR(x, HW_HDMI_TX_INVID0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_INVID0 bitfields
 */

/*!
 * @name Register HDMI_TX_INVID0, field video_mapping[4:0] (RW)
 *
 * video_mapping
 */
/*@{*/
#define BP_HDMI_TX_INVID0_video_mapping (0U) /*!< Bit position for HDMI_TX_INVID0_video_mapping. */
#define BM_HDMI_TX_INVID0_video_mapping (0x1FU) /*!< Bit mask for HDMI_TX_INVID0_video_mapping. */
#define BS_HDMI_TX_INVID0_video_mapping (5U) /*!< Bit field size in bits for HDMI_TX_INVID0_video_mapping. */

/*! @brief Read current value of the HDMI_TX_INVID0_video_mapping field. */
#define BR_HDMI_TX_INVID0_video_mapping(x) (HW_HDMI_TX_INVID0(x).B.video_mapping)

/*! @brief Format value for bitfield HDMI_TX_INVID0_video_mapping. */
#define BF_HDMI_TX_INVID0_video_mapping(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_INVID0_video_mapping) & BM_HDMI_TX_INVID0_video_mapping)

/*! @brief Set the video_mapping field to a new value. */
#define BW_HDMI_TX_INVID0_video_mapping(x, v) (HW_HDMI_TX_INVID0_WR(x, (HW_HDMI_TX_INVID0_RD(x) & ~BM_HDMI_TX_INVID0_video_mapping) | BF_HDMI_TX_INVID0_video_mapping(v)))
/*@}*/

/*!
 * @name Register HDMI_TX_INVID0, field internal_de_generator[7] (RW)
 *
 * Internal data enable (DE) generator enable. If data enable is not available
 * for the input video the user may set this bit to one to activate the internal
 * data enable generator. This feature only works for input video modes that have
 * native repetition (such as, all CEA videos). No desired pixel repetition can
 * be used with this feature because these configurations only affect the Frame
 * Composer and not this block.
 */
/*@{*/
#define BP_HDMI_TX_INVID0_internal_de_generator (7U) /*!< Bit position for HDMI_TX_INVID0_internal_de_generator. */
#define BM_HDMI_TX_INVID0_internal_de_generator (0x80U) /*!< Bit mask for HDMI_TX_INVID0_internal_de_generator. */
#define BS_HDMI_TX_INVID0_internal_de_generator (1U) /*!< Bit field size in bits for HDMI_TX_INVID0_internal_de_generator. */

/*! @brief Read current value of the HDMI_TX_INVID0_internal_de_generator field. */
#define BR_HDMI_TX_INVID0_internal_de_generator(x) (HW_HDMI_TX_INVID0(x).B.internal_de_generator)

/*! @brief Format value for bitfield HDMI_TX_INVID0_internal_de_generator. */
#define BF_HDMI_TX_INVID0_internal_de_generator(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_INVID0_internal_de_generator) & BM_HDMI_TX_INVID0_internal_de_generator)

/*! @brief Set the internal_de_generator field to a new value. */
#define BW_HDMI_TX_INVID0_internal_de_generator(x, v) (HW_HDMI_TX_INVID0_WR(x, (HW_HDMI_TX_INVID0_RD(x) & ~BM_HDMI_TX_INVID0_internal_de_generator) | BF_HDMI_TX_INVID0_internal_de_generator(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_INSTUFFING - Video Input Stuffing Enable Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_INSTUFFING - Video Input Stuffing Enable Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register enables the stuffing mechanism of the Video Sampler module in
 * order to correctly perform Color Space Conversion of the ITU.601 standard YCC
 * video. In this case, when "de" is low, the output video components
 * gydata[15:0], rcrdata[15:0], and bcbdata[15:0] can be configured. Address Offset: 0x0201
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_instuffing
{
    uint8_t U;
    struct _hw_hdmi_tx_instuffing_bitfields
    {
        uint8_t GYDATA_STUFFING : 1;   /*!< [0]  */
        uint8_t RCRDATA_STUFFING : 1;  /*!< [1]  */
        uint8_t BCBDATA_STUFFING : 1;  /*!< [2]  */
        uint8_t RESERVED0 : 5;         /*!< [7:3]  */
    } B;
} hw_hdmi_tx_instuffing_t;

/*!
 * @name Constants and macros for entire HDMI_TX_INSTUFFING register
 */
/*@{*/
#define HW_HDMI_TX_INSTUFFING_ADDR(x) ((uintptr_t)(x) + 0x201U)

#define HW_HDMI_TX_INSTUFFING(x) (*(__IO hw_hdmi_tx_instuffing_t *) HW_HDMI_TX_INSTUFFING_ADDR(x))
#define HW_HDMI_TX_INSTUFFING_RD(x) (HW_HDMI_TX_INSTUFFING(x).U)
#define HW_HDMI_TX_INSTUFFING_WR(x, v) (HW_HDMI_TX_INSTUFFING(x).U = (v))
#define HW_HDMI_TX_INSTUFFING_SET(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, HW_HDMI_TX_INSTUFFING_RD(x) |  (v)))
#define HW_HDMI_TX_INSTUFFING_CLR(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, HW_HDMI_TX_INSTUFFING_RD(x) & ~(v)))
#define HW_HDMI_TX_INSTUFFING_TOG(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, HW_HDMI_TX_INSTUFFING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_INSTUFFING bitfields
 */

/*!
 * @name Register HDMI_TX_INSTUFFING, field GYDATA_STUFFING[0] (RW)
 *
 * GYDATA stuffing bit
 *
 * Values:
 * - 0 - when the dataen signal is low, the value in the gydata[15:0] output is
 *     the one sampled from the corresponding input data.
 * - 1 - When the dataen signal is low, the value in the gydata[15:0] output is
 *     given by the values in TX_GYDTA0 and TX_GYDATA1 registers.
 */
/*@{*/
#define BP_HDMI_TX_INSTUFFING_GYDATA_STUFFING (0U) /*!< Bit position for HDMI_TX_INSTUFFING_GYDATA_STUFFING. */
#define BM_HDMI_TX_INSTUFFING_GYDATA_STUFFING (0x01U) /*!< Bit mask for HDMI_TX_INSTUFFING_GYDATA_STUFFING. */
#define BS_HDMI_TX_INSTUFFING_GYDATA_STUFFING (1U) /*!< Bit field size in bits for HDMI_TX_INSTUFFING_GYDATA_STUFFING. */

/*! @brief Read current value of the HDMI_TX_INSTUFFING_GYDATA_STUFFING field. */
#define BR_HDMI_TX_INSTUFFING_GYDATA_STUFFING(x) (HW_HDMI_TX_INSTUFFING(x).B.GYDATA_STUFFING)

/*! @brief Format value for bitfield HDMI_TX_INSTUFFING_GYDATA_STUFFING. */
#define BF_HDMI_TX_INSTUFFING_GYDATA_STUFFING(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_INSTUFFING_GYDATA_STUFFING) & BM_HDMI_TX_INSTUFFING_GYDATA_STUFFING)

/*! @brief Set the GYDATA_STUFFING field to a new value. */
#define BW_HDMI_TX_INSTUFFING_GYDATA_STUFFING(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, (HW_HDMI_TX_INSTUFFING_RD(x) & ~BM_HDMI_TX_INSTUFFING_GYDATA_STUFFING) | BF_HDMI_TX_INSTUFFING_GYDATA_STUFFING(v)))
/*@}*/

/*!
 * @name Register HDMI_TX_INSTUFFING, field RCRDATA_STUFFING[1] (RW)
 *
 * RCRDATA stuffing bit
 *
 * Values:
 * - 0 - When the dataen signal is low, the value in the rcrdata[15:0] output is
 *     the one sampled from the corresponding input data.
 * - 1 - When the dataen signal is low, the value in the rcrdata[15:0] output is
 *     given by the values in TX_RCRDTA0 and TX_RCRDATA1 registers.
 */
/*@{*/
#define BP_HDMI_TX_INSTUFFING_RCRDATA_STUFFING (1U) /*!< Bit position for HDMI_TX_INSTUFFING_RCRDATA_STUFFING. */
#define BM_HDMI_TX_INSTUFFING_RCRDATA_STUFFING (0x02U) /*!< Bit mask for HDMI_TX_INSTUFFING_RCRDATA_STUFFING. */
#define BS_HDMI_TX_INSTUFFING_RCRDATA_STUFFING (1U) /*!< Bit field size in bits for HDMI_TX_INSTUFFING_RCRDATA_STUFFING. */

/*! @brief Read current value of the HDMI_TX_INSTUFFING_RCRDATA_STUFFING field. */
#define BR_HDMI_TX_INSTUFFING_RCRDATA_STUFFING(x) (HW_HDMI_TX_INSTUFFING(x).B.RCRDATA_STUFFING)

/*! @brief Format value for bitfield HDMI_TX_INSTUFFING_RCRDATA_STUFFING. */
#define BF_HDMI_TX_INSTUFFING_RCRDATA_STUFFING(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_INSTUFFING_RCRDATA_STUFFING) & BM_HDMI_TX_INSTUFFING_RCRDATA_STUFFING)

/*! @brief Set the RCRDATA_STUFFING field to a new value. */
#define BW_HDMI_TX_INSTUFFING_RCRDATA_STUFFING(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, (HW_HDMI_TX_INSTUFFING_RD(x) & ~BM_HDMI_TX_INSTUFFING_RCRDATA_STUFFING) | BF_HDMI_TX_INSTUFFING_RCRDATA_STUFFING(v)))
/*@}*/

/*!
 * @name Register HDMI_TX_INSTUFFING, field BCBDATA_STUFFING[2] (RW)
 *
 * BCBDATA stuffing bit
 *
 * Values:
 * - 0 - When the dataen signal is low, the value in the bcbdata[15:0] output is
 *     the one sampled from the corresponding input data.
 * - 1 - When the dataen signal is low, the value in the bcbdata[15:0] output is
 *     given by the values in register TX_BCBDTA0 and TX_BCBDATA1.
 */
/*@{*/
#define BP_HDMI_TX_INSTUFFING_BCBDATA_STUFFING (2U) /*!< Bit position for HDMI_TX_INSTUFFING_BCBDATA_STUFFING. */
#define BM_HDMI_TX_INSTUFFING_BCBDATA_STUFFING (0x04U) /*!< Bit mask for HDMI_TX_INSTUFFING_BCBDATA_STUFFING. */
#define BS_HDMI_TX_INSTUFFING_BCBDATA_STUFFING (1U) /*!< Bit field size in bits for HDMI_TX_INSTUFFING_BCBDATA_STUFFING. */

/*! @brief Read current value of the HDMI_TX_INSTUFFING_BCBDATA_STUFFING field. */
#define BR_HDMI_TX_INSTUFFING_BCBDATA_STUFFING(x) (HW_HDMI_TX_INSTUFFING(x).B.BCBDATA_STUFFING)

/*! @brief Format value for bitfield HDMI_TX_INSTUFFING_BCBDATA_STUFFING. */
#define BF_HDMI_TX_INSTUFFING_BCBDATA_STUFFING(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_INSTUFFING_BCBDATA_STUFFING) & BM_HDMI_TX_INSTUFFING_BCBDATA_STUFFING)

/*! @brief Set the BCBDATA_STUFFING field to a new value. */
#define BW_HDMI_TX_INSTUFFING_BCBDATA_STUFFING(x, v) (HW_HDMI_TX_INSTUFFING_WR(x, (HW_HDMI_TX_INSTUFFING_RD(x) & ~BM_HDMI_TX_INSTUFFING_BCBDATA_STUFFING) | BF_HDMI_TX_INSTUFFING_BCBDATA_STUFFING(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_GYDATA0 - Video Input GY Data Channel Stuffing Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_GYDATA0 - Video Input GY Data Channel Stuffing Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0202 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_gydata0
{
    uint8_t U;
    struct _hw_hdmi_tx_gydata0_bitfields
    {
        uint8_t gydata : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_tx_gydata0_t;

/*!
 * @name Constants and macros for entire HDMI_TX_GYDATA0 register
 */
/*@{*/
#define HW_HDMI_TX_GYDATA0_ADDR(x) ((uintptr_t)(x) + 0x202U)

#define HW_HDMI_TX_GYDATA0(x)    (*(__IO hw_hdmi_tx_gydata0_t *) HW_HDMI_TX_GYDATA0_ADDR(x))
#define HW_HDMI_TX_GYDATA0_RD(x) (HW_HDMI_TX_GYDATA0(x).U)
#define HW_HDMI_TX_GYDATA0_WR(x, v) (HW_HDMI_TX_GYDATA0(x).U = (v))
#define HW_HDMI_TX_GYDATA0_SET(x, v) (HW_HDMI_TX_GYDATA0_WR(x, HW_HDMI_TX_GYDATA0_RD(x) |  (v)))
#define HW_HDMI_TX_GYDATA0_CLR(x, v) (HW_HDMI_TX_GYDATA0_WR(x, HW_HDMI_TX_GYDATA0_RD(x) & ~(v)))
#define HW_HDMI_TX_GYDATA0_TOG(x, v) (HW_HDMI_TX_GYDATA0_WR(x, HW_HDMI_TX_GYDATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_GYDATA0 bitfields
 */

/*!
 * @name Register HDMI_TX_GYDATA0, field gydata[7:0] (RW)
 *
 * gydata[7:0].This register defines the value of gydata[7:0] when
 * TX_INSTUFFING[0] (gydata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_GYDATA0_gydata (0U)     /*!< Bit position for HDMI_TX_GYDATA0_gydata. */
#define BM_HDMI_TX_GYDATA0_gydata (0xFFU)  /*!< Bit mask for HDMI_TX_GYDATA0_gydata. */
#define BS_HDMI_TX_GYDATA0_gydata (8U)     /*!< Bit field size in bits for HDMI_TX_GYDATA0_gydata. */

/*! @brief Read current value of the HDMI_TX_GYDATA0_gydata field. */
#define BR_HDMI_TX_GYDATA0_gydata(x) (HW_HDMI_TX_GYDATA0(x).U)

/*! @brief Format value for bitfield HDMI_TX_GYDATA0_gydata. */
#define BF_HDMI_TX_GYDATA0_gydata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_GYDATA0_gydata) & BM_HDMI_TX_GYDATA0_gydata)

/*! @brief Set the gydata field to a new value. */
#define BW_HDMI_TX_GYDATA0_gydata(x, v) (HW_HDMI_TX_GYDATA0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_GYDATA1 - Video Input GY Data Channel Stuffing Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_GYDATA1 - Video Input GY Data Channel Stuffing Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0203 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_gydata1
{
    uint8_t U;
    struct _hw_hdmi_tx_gydata1_bitfields
    {
        uint8_t gydata : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_tx_gydata1_t;

/*!
 * @name Constants and macros for entire HDMI_TX_GYDATA1 register
 */
/*@{*/
#define HW_HDMI_TX_GYDATA1_ADDR(x) ((uintptr_t)(x) + 0x203U)

#define HW_HDMI_TX_GYDATA1(x)    (*(__IO hw_hdmi_tx_gydata1_t *) HW_HDMI_TX_GYDATA1_ADDR(x))
#define HW_HDMI_TX_GYDATA1_RD(x) (HW_HDMI_TX_GYDATA1(x).U)
#define HW_HDMI_TX_GYDATA1_WR(x, v) (HW_HDMI_TX_GYDATA1(x).U = (v))
#define HW_HDMI_TX_GYDATA1_SET(x, v) (HW_HDMI_TX_GYDATA1_WR(x, HW_HDMI_TX_GYDATA1_RD(x) |  (v)))
#define HW_HDMI_TX_GYDATA1_CLR(x, v) (HW_HDMI_TX_GYDATA1_WR(x, HW_HDMI_TX_GYDATA1_RD(x) & ~(v)))
#define HW_HDMI_TX_GYDATA1_TOG(x, v) (HW_HDMI_TX_GYDATA1_WR(x, HW_HDMI_TX_GYDATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_GYDATA1 bitfields
 */

/*!
 * @name Register HDMI_TX_GYDATA1, field gydata[7:0] (RW)
 *
 * gydata[15:8].This register defines the value of gydata[15:8] when
 * TX_INSTUFFING[0] (gydata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_GYDATA1_gydata (0U)     /*!< Bit position for HDMI_TX_GYDATA1_gydata. */
#define BM_HDMI_TX_GYDATA1_gydata (0xFFU)  /*!< Bit mask for HDMI_TX_GYDATA1_gydata. */
#define BS_HDMI_TX_GYDATA1_gydata (8U)     /*!< Bit field size in bits for HDMI_TX_GYDATA1_gydata. */

/*! @brief Read current value of the HDMI_TX_GYDATA1_gydata field. */
#define BR_HDMI_TX_GYDATA1_gydata(x) (HW_HDMI_TX_GYDATA1(x).U)

/*! @brief Format value for bitfield HDMI_TX_GYDATA1_gydata. */
#define BF_HDMI_TX_GYDATA1_gydata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_GYDATA1_gydata) & BM_HDMI_TX_GYDATA1_gydata)

/*! @brief Set the gydata field to a new value. */
#define BW_HDMI_TX_GYDATA1_gydata(x, v) (HW_HDMI_TX_GYDATA1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_RCRDATA0 - Video Input RCR Data Channel Stuffing Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_RCRDATA0 - Video Input RCR Data Channel Stuffing Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0204 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_rcrdata0
{
    uint8_t U;
    struct _hw_hdmi_tx_rcrdata0_bitfields
    {
        uint8_t rcrdata : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_tx_rcrdata0_t;

/*!
 * @name Constants and macros for entire HDMI_TX_RCRDATA0 register
 */
/*@{*/
#define HW_HDMI_TX_RCRDATA0_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_HDMI_TX_RCRDATA0(x)   (*(__IO hw_hdmi_tx_rcrdata0_t *) HW_HDMI_TX_RCRDATA0_ADDR(x))
#define HW_HDMI_TX_RCRDATA0_RD(x) (HW_HDMI_TX_RCRDATA0(x).U)
#define HW_HDMI_TX_RCRDATA0_WR(x, v) (HW_HDMI_TX_RCRDATA0(x).U = (v))
#define HW_HDMI_TX_RCRDATA0_SET(x, v) (HW_HDMI_TX_RCRDATA0_WR(x, HW_HDMI_TX_RCRDATA0_RD(x) |  (v)))
#define HW_HDMI_TX_RCRDATA0_CLR(x, v) (HW_HDMI_TX_RCRDATA0_WR(x, HW_HDMI_TX_RCRDATA0_RD(x) & ~(v)))
#define HW_HDMI_TX_RCRDATA0_TOG(x, v) (HW_HDMI_TX_RCRDATA0_WR(x, HW_HDMI_TX_RCRDATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_RCRDATA0 bitfields
 */

/*!
 * @name Register HDMI_TX_RCRDATA0, field rcrdata[7:0] (RW)
 *
 * rcrdata[7:0]. This register defines the value of rcrydata[7:0] when
 * TX_INSTUFFING[1] (rcrdata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_RCRDATA0_rcrdata (0U)   /*!< Bit position for HDMI_TX_RCRDATA0_rcrdata. */
#define BM_HDMI_TX_RCRDATA0_rcrdata (0xFFU) /*!< Bit mask for HDMI_TX_RCRDATA0_rcrdata. */
#define BS_HDMI_TX_RCRDATA0_rcrdata (8U)   /*!< Bit field size in bits for HDMI_TX_RCRDATA0_rcrdata. */

/*! @brief Read current value of the HDMI_TX_RCRDATA0_rcrdata field. */
#define BR_HDMI_TX_RCRDATA0_rcrdata(x) (HW_HDMI_TX_RCRDATA0(x).U)

/*! @brief Format value for bitfield HDMI_TX_RCRDATA0_rcrdata. */
#define BF_HDMI_TX_RCRDATA0_rcrdata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_RCRDATA0_rcrdata) & BM_HDMI_TX_RCRDATA0_rcrdata)

/*! @brief Set the rcrdata field to a new value. */
#define BW_HDMI_TX_RCRDATA0_rcrdata(x, v) (HW_HDMI_TX_RCRDATA0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_RCRDATA1 - Video Input RCR Data Channel Stuffing Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_RCRDATA1 - Video Input RCR Data Channel Stuffing Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0205 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_rcrdata1
{
    uint8_t U;
    struct _hw_hdmi_tx_rcrdata1_bitfields
    {
        uint8_t rcrdata : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_tx_rcrdata1_t;

/*!
 * @name Constants and macros for entire HDMI_TX_RCRDATA1 register
 */
/*@{*/
#define HW_HDMI_TX_RCRDATA1_ADDR(x) ((uintptr_t)(x) + 0x205U)

#define HW_HDMI_TX_RCRDATA1(x)   (*(__IO hw_hdmi_tx_rcrdata1_t *) HW_HDMI_TX_RCRDATA1_ADDR(x))
#define HW_HDMI_TX_RCRDATA1_RD(x) (HW_HDMI_TX_RCRDATA1(x).U)
#define HW_HDMI_TX_RCRDATA1_WR(x, v) (HW_HDMI_TX_RCRDATA1(x).U = (v))
#define HW_HDMI_TX_RCRDATA1_SET(x, v) (HW_HDMI_TX_RCRDATA1_WR(x, HW_HDMI_TX_RCRDATA1_RD(x) |  (v)))
#define HW_HDMI_TX_RCRDATA1_CLR(x, v) (HW_HDMI_TX_RCRDATA1_WR(x, HW_HDMI_TX_RCRDATA1_RD(x) & ~(v)))
#define HW_HDMI_TX_RCRDATA1_TOG(x, v) (HW_HDMI_TX_RCRDATA1_WR(x, HW_HDMI_TX_RCRDATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_RCRDATA1 bitfields
 */

/*!
 * @name Register HDMI_TX_RCRDATA1, field rcrdata[7:0] (RW)
 *
 * rcrdata[15:8]. This register defines the value of rcrydata[15:8] when
 * TX_INSTUFFING[1] (rcrdata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_RCRDATA1_rcrdata (0U)   /*!< Bit position for HDMI_TX_RCRDATA1_rcrdata. */
#define BM_HDMI_TX_RCRDATA1_rcrdata (0xFFU) /*!< Bit mask for HDMI_TX_RCRDATA1_rcrdata. */
#define BS_HDMI_TX_RCRDATA1_rcrdata (8U)   /*!< Bit field size in bits for HDMI_TX_RCRDATA1_rcrdata. */

/*! @brief Read current value of the HDMI_TX_RCRDATA1_rcrdata field. */
#define BR_HDMI_TX_RCRDATA1_rcrdata(x) (HW_HDMI_TX_RCRDATA1(x).U)

/*! @brief Format value for bitfield HDMI_TX_RCRDATA1_rcrdata. */
#define BF_HDMI_TX_RCRDATA1_rcrdata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_RCRDATA1_rcrdata) & BM_HDMI_TX_RCRDATA1_rcrdata)

/*! @brief Set the rcrdata field to a new value. */
#define BW_HDMI_TX_RCRDATA1_rcrdata(x, v) (HW_HDMI_TX_RCRDATA1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_BCBDATA0 - Video Input RCB Data Channel Stuffing Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_BCBDATA0 - Video Input RCB Data Channel Stuffing Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0206 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_bcbdata0
{
    uint8_t U;
    struct _hw_hdmi_tx_bcbdata0_bitfields
    {
        uint8_t bcbdata : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_tx_bcbdata0_t;

/*!
 * @name Constants and macros for entire HDMI_TX_BCBDATA0 register
 */
/*@{*/
#define HW_HDMI_TX_BCBDATA0_ADDR(x) ((uintptr_t)(x) + 0x206U)

#define HW_HDMI_TX_BCBDATA0(x)   (*(__IO hw_hdmi_tx_bcbdata0_t *) HW_HDMI_TX_BCBDATA0_ADDR(x))
#define HW_HDMI_TX_BCBDATA0_RD(x) (HW_HDMI_TX_BCBDATA0(x).U)
#define HW_HDMI_TX_BCBDATA0_WR(x, v) (HW_HDMI_TX_BCBDATA0(x).U = (v))
#define HW_HDMI_TX_BCBDATA0_SET(x, v) (HW_HDMI_TX_BCBDATA0_WR(x, HW_HDMI_TX_BCBDATA0_RD(x) |  (v)))
#define HW_HDMI_TX_BCBDATA0_CLR(x, v) (HW_HDMI_TX_BCBDATA0_WR(x, HW_HDMI_TX_BCBDATA0_RD(x) & ~(v)))
#define HW_HDMI_TX_BCBDATA0_TOG(x, v) (HW_HDMI_TX_BCBDATA0_WR(x, HW_HDMI_TX_BCBDATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_BCBDATA0 bitfields
 */

/*!
 * @name Register HDMI_TX_BCBDATA0, field bcbdata[7:0] (RW)
 *
 * bcbdata[7:0]. This register defines the value of bcbdata[7:0] when
 * TX_INSTUFFING[2] (bcbdata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_BCBDATA0_bcbdata (0U)   /*!< Bit position for HDMI_TX_BCBDATA0_bcbdata. */
#define BM_HDMI_TX_BCBDATA0_bcbdata (0xFFU) /*!< Bit mask for HDMI_TX_BCBDATA0_bcbdata. */
#define BS_HDMI_TX_BCBDATA0_bcbdata (8U)   /*!< Bit field size in bits for HDMI_TX_BCBDATA0_bcbdata. */

/*! @brief Read current value of the HDMI_TX_BCBDATA0_bcbdata field. */
#define BR_HDMI_TX_BCBDATA0_bcbdata(x) (HW_HDMI_TX_BCBDATA0(x).U)

/*! @brief Format value for bitfield HDMI_TX_BCBDATA0_bcbdata. */
#define BF_HDMI_TX_BCBDATA0_bcbdata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_BCBDATA0_bcbdata) & BM_HDMI_TX_BCBDATA0_bcbdata)

/*! @brief Set the bcbdata field to a new value. */
#define BW_HDMI_TX_BCBDATA0_bcbdata(x, v) (HW_HDMI_TX_BCBDATA0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_TX_BCBDATA1 - Video Input RCB Data Channel Stuffing Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_TX_BCBDATA1 - Video Input RCB Data Channel Stuffing Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0207 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_tx_bcbdata1
{
    uint8_t U;
    struct _hw_hdmi_tx_bcbdata1_bitfields
    {
        uint8_t bcbdata : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_tx_bcbdata1_t;

/*!
 * @name Constants and macros for entire HDMI_TX_BCBDATA1 register
 */
/*@{*/
#define HW_HDMI_TX_BCBDATA1_ADDR(x) ((uintptr_t)(x) + 0x207U)

#define HW_HDMI_TX_BCBDATA1(x)   (*(__IO hw_hdmi_tx_bcbdata1_t *) HW_HDMI_TX_BCBDATA1_ADDR(x))
#define HW_HDMI_TX_BCBDATA1_RD(x) (HW_HDMI_TX_BCBDATA1(x).U)
#define HW_HDMI_TX_BCBDATA1_WR(x, v) (HW_HDMI_TX_BCBDATA1(x).U = (v))
#define HW_HDMI_TX_BCBDATA1_SET(x, v) (HW_HDMI_TX_BCBDATA1_WR(x, HW_HDMI_TX_BCBDATA1_RD(x) |  (v)))
#define HW_HDMI_TX_BCBDATA1_CLR(x, v) (HW_HDMI_TX_BCBDATA1_WR(x, HW_HDMI_TX_BCBDATA1_RD(x) & ~(v)))
#define HW_HDMI_TX_BCBDATA1_TOG(x, v) (HW_HDMI_TX_BCBDATA1_WR(x, HW_HDMI_TX_BCBDATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_TX_BCBDATA1 bitfields
 */

/*!
 * @name Register HDMI_TX_BCBDATA1, field bcbdata[7:0] (RW)
 *
 * bcbdata[15:8]. This register defines the value of bcbdata[15:8] when
 * TX_INSTUFFING[2] (bcbdata_stuffing) is set to 1b.
 */
/*@{*/
#define BP_HDMI_TX_BCBDATA1_bcbdata (0U)   /*!< Bit position for HDMI_TX_BCBDATA1_bcbdata. */
#define BM_HDMI_TX_BCBDATA1_bcbdata (0xFFU) /*!< Bit mask for HDMI_TX_BCBDATA1_bcbdata. */
#define BS_HDMI_TX_BCBDATA1_bcbdata (8U)   /*!< Bit field size in bits for HDMI_TX_BCBDATA1_bcbdata. */

/*! @brief Read current value of the HDMI_TX_BCBDATA1_bcbdata field. */
#define BR_HDMI_TX_BCBDATA1_bcbdata(x) (HW_HDMI_TX_BCBDATA1(x).U)

/*! @brief Format value for bitfield HDMI_TX_BCBDATA1_bcbdata. */
#define BF_HDMI_TX_BCBDATA1_bcbdata(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_TX_BCBDATA1_bcbdata) & BM_HDMI_TX_BCBDATA1_bcbdata)

/*! @brief Set the bcbdata field to a new value. */
#define BW_HDMI_TX_BCBDATA1_bcbdata(x, v) (HW_HDMI_TX_BCBDATA1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_STATUS - Video Packetizer Packing Phase Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_STATUS - Video Packetizer Packing Phase Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x0800 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_vp_status
{
    uint8_t U;
    struct _hw_hdmi_vp_status_bitfields
    {
        uint8_t packing_phase : 4;     /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_vp_status_t;

/*!
 * @name Constants and macros for entire HDMI_VP_STATUS register
 */
/*@{*/
#define HW_HDMI_VP_STATUS_ADDR(x) ((uintptr_t)(x) + 0x800U)

#define HW_HDMI_VP_STATUS(x)     (*(__I hw_hdmi_vp_status_t *) HW_HDMI_VP_STATUS_ADDR(x))
#define HW_HDMI_VP_STATUS_RD(x)  (HW_HDMI_VP_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_STATUS bitfields
 */

/*!
 * @name Register HDMI_VP_STATUS, field packing_phase[3:0] (RO)
 *
 * Read only register that holds the "packing phase" output by the Video
 * packetizer block. For more information about "packing" video data, refer to the
 * HDMI1.4a specification. The register is updated at tmds clock rate.
 */
/*@{*/
#define BP_HDMI_VP_STATUS_packing_phase (0U) /*!< Bit position for HDMI_VP_STATUS_packing_phase. */
#define BM_HDMI_VP_STATUS_packing_phase (0x0FU) /*!< Bit mask for HDMI_VP_STATUS_packing_phase. */
#define BS_HDMI_VP_STATUS_packing_phase (4U) /*!< Bit field size in bits for HDMI_VP_STATUS_packing_phase. */

/*! @brief Read current value of the HDMI_VP_STATUS_packing_phase field. */
#define BR_HDMI_VP_STATUS_packing_phase(x) (HW_HDMI_VP_STATUS(x).B.packing_phase)
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_PR_CD - Video Packetizer Pixel Repetition and Color Depth Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_PR_CD - Video Packetizer Pixel Repetition and Color Depth Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register configures the Color Depth of the input video and Pixel
 * repetition to apply to video. Address Offset: 0x0801 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_vp_pr_cd
{
    uint8_t U;
    struct _hw_hdmi_vp_pr_cd_bitfields
    {
        uint8_t desired_pr_factor : 4; /*!< [3:0]  */
        uint8_t color_depth : 4;       /*!< [7:4]  */
    } B;
} hw_hdmi_vp_pr_cd_t;

/*!
 * @name Constants and macros for entire HDMI_VP_PR_CD register
 */
/*@{*/
#define HW_HDMI_VP_PR_CD_ADDR(x) ((uintptr_t)(x) + 0x801U)

#define HW_HDMI_VP_PR_CD(x)      (*(__IO hw_hdmi_vp_pr_cd_t *) HW_HDMI_VP_PR_CD_ADDR(x))
#define HW_HDMI_VP_PR_CD_RD(x)   (HW_HDMI_VP_PR_CD(x).U)
#define HW_HDMI_VP_PR_CD_WR(x, v) (HW_HDMI_VP_PR_CD(x).U = (v))
#define HW_HDMI_VP_PR_CD_SET(x, v) (HW_HDMI_VP_PR_CD_WR(x, HW_HDMI_VP_PR_CD_RD(x) |  (v)))
#define HW_HDMI_VP_PR_CD_CLR(x, v) (HW_HDMI_VP_PR_CD_WR(x, HW_HDMI_VP_PR_CD_RD(x) & ~(v)))
#define HW_HDMI_VP_PR_CD_TOG(x, v) (HW_HDMI_VP_PR_CD_WR(x, HW_HDMI_VP_PR_CD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_PR_CD bitfields
 */

/*!
 * @name Register HDMI_VP_PR_CD, field desired_pr_factor[3:0] (RW)
 *
 * Desired pixel repetition factor configuration. The configured value sets H13T
 * PHY PLL to multiply pixel clock by the factor in order to obtain the desired
 * repetition clock. For the CEA modes some are already defined with pixel
 * repetition in the input video. So for CEA modes this shall be always 0. Shall only
 * be used if the user wants to do pixel repetition using H13TCTRL core. other
 * Reserved. Not used.
 *
 * Values:
 * - 0000 - No pixel repetition (pixel sent only once)
 * - 0001 - Pixel sent 2 times (pixel repeated once)
 * - 0010 - Pixel sent 3 times
 * - 0011 - Pixel sent 4 times
 * - 0100 - Pixel sent 5 times
 * - 0101 - Pixel sent 6 times
 * - 0110 - Pixel sent 7 times
 * - 0111 - Pixel sent 8 times
 * - 1000 - Pixel sent 9 times
 * - 1001 - Pixel sent 10 times
 */
/*@{*/
#define BP_HDMI_VP_PR_CD_desired_pr_factor (0U) /*!< Bit position for HDMI_VP_PR_CD_desired_pr_factor. */
#define BM_HDMI_VP_PR_CD_desired_pr_factor (0x0FU) /*!< Bit mask for HDMI_VP_PR_CD_desired_pr_factor. */
#define BS_HDMI_VP_PR_CD_desired_pr_factor (4U) /*!< Bit field size in bits for HDMI_VP_PR_CD_desired_pr_factor. */

/*! @brief Read current value of the HDMI_VP_PR_CD_desired_pr_factor field. */
#define BR_HDMI_VP_PR_CD_desired_pr_factor(x) (HW_HDMI_VP_PR_CD(x).B.desired_pr_factor)

/*! @brief Format value for bitfield HDMI_VP_PR_CD_desired_pr_factor. */
#define BF_HDMI_VP_PR_CD_desired_pr_factor(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_PR_CD_desired_pr_factor) & BM_HDMI_VP_PR_CD_desired_pr_factor)

/*! @brief Set the desired_pr_factor field to a new value. */
#define BW_HDMI_VP_PR_CD_desired_pr_factor(x, v) (HW_HDMI_VP_PR_CD_WR(x, (HW_HDMI_VP_PR_CD_RD(x) & ~BM_HDMI_VP_PR_CD_desired_pr_factor) | BF_HDMI_VP_PR_CD_desired_pr_factor(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_PR_CD, field color_depth[7:4] (RW)
 *
 * Color depth configuration: other Reserved. Not used.
 *
 * Values:
 * - 0000 - 24 bits per pixel video (8 bit per component). 8-bit packing mode.
 * - 0100 - 24 bits per pixel video (8 bit per component). 8-bit packing mode.
 * - 0101 - 30 bits per pixel video (10 bit per component). 10-bit packing mode.
 * - 0110 - 36 bits per pixel video (12 bit per component). 12-bit packing mode.
 * - 0111 - 48 bits per pixel video (16 bit per component). 16-bit packing mode.
 */
/*@{*/
#define BP_HDMI_VP_PR_CD_color_depth (4U)  /*!< Bit position for HDMI_VP_PR_CD_color_depth. */
#define BM_HDMI_VP_PR_CD_color_depth (0xF0U) /*!< Bit mask for HDMI_VP_PR_CD_color_depth. */
#define BS_HDMI_VP_PR_CD_color_depth (4U)  /*!< Bit field size in bits for HDMI_VP_PR_CD_color_depth. */

/*! @brief Read current value of the HDMI_VP_PR_CD_color_depth field. */
#define BR_HDMI_VP_PR_CD_color_depth(x) (HW_HDMI_VP_PR_CD(x).B.color_depth)

/*! @brief Format value for bitfield HDMI_VP_PR_CD_color_depth. */
#define BF_HDMI_VP_PR_CD_color_depth(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_PR_CD_color_depth) & BM_HDMI_VP_PR_CD_color_depth)

/*! @brief Set the color_depth field to a new value. */
#define BW_HDMI_VP_PR_CD_color_depth(x, v) (HW_HDMI_VP_PR_CD_WR(x, (HW_HDMI_VP_PR_CD_RD(x) & ~BM_HDMI_VP_PR_CD_color_depth) | BF_HDMI_VP_PR_CD_color_depth(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_STUFF - Video Packetizer Stuffing and Default Packing Phase Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_STUFF - Video Packetizer Stuffing and Default Packing Phase Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register controls the Pixel repetition, pixel packing and YCC422
 * stuffing. Address Offset: 0x0802 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_vp_stuff
{
    uint8_t U;
    struct _hw_hdmi_vp_stuff_bitfields
    {
        uint8_t pr_stuffing : 1;       /*!< [0]  */
        uint8_t pp_stuffing : 1;       /*!< [1]  */
        uint8_t ycc422_stuffing : 1;   /*!< [2]  */
        uint8_t icx_goto_p0_st : 1;    /*!< [3]  */
        uint8_t ifix_pp_to_last : 1;   /*!< [4]  */
        uint8_t idefault_phase : 1;    /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_vp_stuff_t;

/*!
 * @name Constants and macros for entire HDMI_VP_STUFF register
 */
/*@{*/
#define HW_HDMI_VP_STUFF_ADDR(x) ((uintptr_t)(x) + 0x802U)

#define HW_HDMI_VP_STUFF(x)      (*(__IO hw_hdmi_vp_stuff_t *) HW_HDMI_VP_STUFF_ADDR(x))
#define HW_HDMI_VP_STUFF_RD(x)   (HW_HDMI_VP_STUFF(x).U)
#define HW_HDMI_VP_STUFF_WR(x, v) (HW_HDMI_VP_STUFF(x).U = (v))
#define HW_HDMI_VP_STUFF_SET(x, v) (HW_HDMI_VP_STUFF_WR(x, HW_HDMI_VP_STUFF_RD(x) |  (v)))
#define HW_HDMI_VP_STUFF_CLR(x, v) (HW_HDMI_VP_STUFF_WR(x, HW_HDMI_VP_STUFF_RD(x) & ~(v)))
#define HW_HDMI_VP_STUFF_TOG(x, v) (HW_HDMI_VP_STUFF_WR(x, HW_HDMI_VP_STUFF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_STUFF bitfields
 */

/*!
 * @name Register HDMI_VP_STUFF, field pr_stuffing[0] (RW)
 *
 * Pixel repeater stuffing control
 *
 * Values:
 * - 0 - Pixel repeater block in direct mode (input blanking data goes directly
 *     to output).
 * - 1 - Pixel repeater block in stuffing mode. When "de" goes to low the
 *     outputs are fixed to 0x00.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_pr_stuffing (0U)  /*!< Bit position for HDMI_VP_STUFF_pr_stuffing. */
#define BM_HDMI_VP_STUFF_pr_stuffing (0x01U) /*!< Bit mask for HDMI_VP_STUFF_pr_stuffing. */
#define BS_HDMI_VP_STUFF_pr_stuffing (1U)  /*!< Bit field size in bits for HDMI_VP_STUFF_pr_stuffing. */

/*! @brief Read current value of the HDMI_VP_STUFF_pr_stuffing field. */
#define BR_HDMI_VP_STUFF_pr_stuffing(x) (HW_HDMI_VP_STUFF(x).B.pr_stuffing)

/*! @brief Format value for bitfield HDMI_VP_STUFF_pr_stuffing. */
#define BF_HDMI_VP_STUFF_pr_stuffing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_pr_stuffing) & BM_HDMI_VP_STUFF_pr_stuffing)

/*! @brief Set the pr_stuffing field to a new value. */
#define BW_HDMI_VP_STUFF_pr_stuffing(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_pr_stuffing) | BF_HDMI_VP_STUFF_pr_stuffing(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_STUFF, field pp_stuffing[1] (RW)
 *
 * Pixel packing stuffing control
 *
 * Values:
 * - 0 - Pixel packing block in direct mode (input blanking data goes directly
 *     to output).
 * - 1 - Pixel packing block in stuffing mode. When "de_rep" goes to low the
 *     outputs are fixed to 0x00.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_pp_stuffing (1U)  /*!< Bit position for HDMI_VP_STUFF_pp_stuffing. */
#define BM_HDMI_VP_STUFF_pp_stuffing (0x02U) /*!< Bit mask for HDMI_VP_STUFF_pp_stuffing. */
#define BS_HDMI_VP_STUFF_pp_stuffing (1U)  /*!< Bit field size in bits for HDMI_VP_STUFF_pp_stuffing. */

/*! @brief Read current value of the HDMI_VP_STUFF_pp_stuffing field. */
#define BR_HDMI_VP_STUFF_pp_stuffing(x) (HW_HDMI_VP_STUFF(x).B.pp_stuffing)

/*! @brief Format value for bitfield HDMI_VP_STUFF_pp_stuffing. */
#define BF_HDMI_VP_STUFF_pp_stuffing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_pp_stuffing) & BM_HDMI_VP_STUFF_pp_stuffing)

/*! @brief Set the pp_stuffing field to a new value. */
#define BW_HDMI_VP_STUFF_pp_stuffing(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_pp_stuffing) | BF_HDMI_VP_STUFF_pp_stuffing(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_STUFF, field ycc422_stuffing[2] (RW)
 *
 * YCC 422 remap stuffing control. For horizontal blanking:
 *
 * Values:
 * - 0 - YCC 422 remap block in direct mode (input blanking data goes directly
 *     to output).
 * - 1 - YCC 422 remap block in stuffing mode. When "de" goes to low the outputs
 *     are fixed to 0x00.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_ycc422_stuffing (2U) /*!< Bit position for HDMI_VP_STUFF_ycc422_stuffing. */
#define BM_HDMI_VP_STUFF_ycc422_stuffing (0x04U) /*!< Bit mask for HDMI_VP_STUFF_ycc422_stuffing. */
#define BS_HDMI_VP_STUFF_ycc422_stuffing (1U) /*!< Bit field size in bits for HDMI_VP_STUFF_ycc422_stuffing. */

/*! @brief Read current value of the HDMI_VP_STUFF_ycc422_stuffing field. */
#define BR_HDMI_VP_STUFF_ycc422_stuffing(x) (HW_HDMI_VP_STUFF(x).B.ycc422_stuffing)

/*! @brief Format value for bitfield HDMI_VP_STUFF_ycc422_stuffing. */
#define BF_HDMI_VP_STUFF_ycc422_stuffing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_ycc422_stuffing) & BM_HDMI_VP_STUFF_ycc422_stuffing)

/*! @brief Set the ycc422_stuffing field to a new value. */
#define BW_HDMI_VP_STUFF_ycc422_stuffing(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_ycc422_stuffing) | BF_HDMI_VP_STUFF_ycc422_stuffing(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_STUFF, field icx_goto_p0_st[3] (RW)
 *
 * Reserved. Controls packing machine strategy.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_icx_goto_p0_st (3U) /*!< Bit position for HDMI_VP_STUFF_icx_goto_p0_st. */
#define BM_HDMI_VP_STUFF_icx_goto_p0_st (0x08U) /*!< Bit mask for HDMI_VP_STUFF_icx_goto_p0_st. */
#define BS_HDMI_VP_STUFF_icx_goto_p0_st (1U) /*!< Bit field size in bits for HDMI_VP_STUFF_icx_goto_p0_st. */

/*! @brief Read current value of the HDMI_VP_STUFF_icx_goto_p0_st field. */
#define BR_HDMI_VP_STUFF_icx_goto_p0_st(x) (HW_HDMI_VP_STUFF(x).B.icx_goto_p0_st)

/*! @brief Format value for bitfield HDMI_VP_STUFF_icx_goto_p0_st. */
#define BF_HDMI_VP_STUFF_icx_goto_p0_st(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_icx_goto_p0_st) & BM_HDMI_VP_STUFF_icx_goto_p0_st)

/*! @brief Set the icx_goto_p0_st field to a new value. */
#define BW_HDMI_VP_STUFF_icx_goto_p0_st(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_icx_goto_p0_st) | BF_HDMI_VP_STUFF_icx_goto_p0_st(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_STUFF, field ifix_pp_to_last[4] (RW)
 *
 * Reserved. Controls packing machine strategy.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_ifix_pp_to_last (4U) /*!< Bit position for HDMI_VP_STUFF_ifix_pp_to_last. */
#define BM_HDMI_VP_STUFF_ifix_pp_to_last (0x10U) /*!< Bit mask for HDMI_VP_STUFF_ifix_pp_to_last. */
#define BS_HDMI_VP_STUFF_ifix_pp_to_last (1U) /*!< Bit field size in bits for HDMI_VP_STUFF_ifix_pp_to_last. */

/*! @brief Read current value of the HDMI_VP_STUFF_ifix_pp_to_last field. */
#define BR_HDMI_VP_STUFF_ifix_pp_to_last(x) (HW_HDMI_VP_STUFF(x).B.ifix_pp_to_last)

/*! @brief Format value for bitfield HDMI_VP_STUFF_ifix_pp_to_last. */
#define BF_HDMI_VP_STUFF_ifix_pp_to_last(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_ifix_pp_to_last) & BM_HDMI_VP_STUFF_ifix_pp_to_last)

/*! @brief Set the ifix_pp_to_last field to a new value. */
#define BW_HDMI_VP_STUFF_ifix_pp_to_last(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_ifix_pp_to_last) | BF_HDMI_VP_STUFF_ifix_pp_to_last(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_STUFF, field idefault_phase[5] (RW)
 *
 * Controls the default phase packing machine used according to: "If the
 * transmitted video format has timing such that the phase of the first pixel of every
 * Video Data Period corresponds to pixel packing phase 0 (for example, 10P0,
 * 12P0, 16P0), the Source may set the Default_Phase bit in the GCP. The Sink may use
 * this bit to optimize it's filtering or handling of the PP field." (HDMI
 * specification version 1.4a) This means that for10 bit mode the Htotal must be
 * dividable by 4 and for 12 bit mode the Htotal must be dividable by 2.
 */
/*@{*/
#define BP_HDMI_VP_STUFF_idefault_phase (5U) /*!< Bit position for HDMI_VP_STUFF_idefault_phase. */
#define BM_HDMI_VP_STUFF_idefault_phase (0x20U) /*!< Bit mask for HDMI_VP_STUFF_idefault_phase. */
#define BS_HDMI_VP_STUFF_idefault_phase (1U) /*!< Bit field size in bits for HDMI_VP_STUFF_idefault_phase. */

/*! @brief Read current value of the HDMI_VP_STUFF_idefault_phase field. */
#define BR_HDMI_VP_STUFF_idefault_phase(x) (HW_HDMI_VP_STUFF(x).B.idefault_phase)

/*! @brief Format value for bitfield HDMI_VP_STUFF_idefault_phase. */
#define BF_HDMI_VP_STUFF_idefault_phase(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_STUFF_idefault_phase) & BM_HDMI_VP_STUFF_idefault_phase)

/*! @brief Set the idefault_phase field to a new value. */
#define BW_HDMI_VP_STUFF_idefault_phase(x, v) (HW_HDMI_VP_STUFF_WR(x, (HW_HDMI_VP_STUFF_RD(x) & ~BM_HDMI_VP_STUFF_idefault_phase) | BF_HDMI_VP_STUFF_idefault_phase(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_REMAP - Video Packetizer YCC422 Remapping Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_REMAP - Video Packetizer YCC422 Remapping Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register controls YCC422 remap of the Video Packetizer. For more
 * information about YCC422 remap refer to HDMI 1.4a specification. Address Offset:
 * 0x0803 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_vp_remap
{
    uint8_t U;
    struct _hw_hdmi_vp_remap_bitfields
    {
        uint8_t ycc422_size : 2;       /*!< [1:0]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_vp_remap_t;

/*!
 * @name Constants and macros for entire HDMI_VP_REMAP register
 */
/*@{*/
#define HW_HDMI_VP_REMAP_ADDR(x) ((uintptr_t)(x) + 0x803U)

#define HW_HDMI_VP_REMAP(x)      (*(__IO hw_hdmi_vp_remap_t *) HW_HDMI_VP_REMAP_ADDR(x))
#define HW_HDMI_VP_REMAP_RD(x)   (HW_HDMI_VP_REMAP(x).U)
#define HW_HDMI_VP_REMAP_WR(x, v) (HW_HDMI_VP_REMAP(x).U = (v))
#define HW_HDMI_VP_REMAP_SET(x, v) (HW_HDMI_VP_REMAP_WR(x, HW_HDMI_VP_REMAP_RD(x) |  (v)))
#define HW_HDMI_VP_REMAP_CLR(x, v) (HW_HDMI_VP_REMAP_WR(x, HW_HDMI_VP_REMAP_RD(x) & ~(v)))
#define HW_HDMI_VP_REMAP_TOG(x, v) (HW_HDMI_VP_REMAP_WR(x, HW_HDMI_VP_REMAP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_REMAP bitfields
 */

/*!
 * @name Register HDMI_VP_REMAP, field ycc422_size[1:0] (RW)
 *
 * YCC 422 remap input video size:
 *
 * Values:
 * - 00 - YCC 422 16-bit input video (8 bits per component).
 * - 01 - YCC 422 20-bit input video (10 bits per component).
 * - 10 - YCC 422 24-bit input video (12 bits per component).
 * - 11 - Reserved. Not used.
 */
/*@{*/
#define BP_HDMI_VP_REMAP_ycc422_size (0U)  /*!< Bit position for HDMI_VP_REMAP_ycc422_size. */
#define BM_HDMI_VP_REMAP_ycc422_size (0x03U) /*!< Bit mask for HDMI_VP_REMAP_ycc422_size. */
#define BS_HDMI_VP_REMAP_ycc422_size (2U)  /*!< Bit field size in bits for HDMI_VP_REMAP_ycc422_size. */

/*! @brief Read current value of the HDMI_VP_REMAP_ycc422_size field. */
#define BR_HDMI_VP_REMAP_ycc422_size(x) (HW_HDMI_VP_REMAP(x).B.ycc422_size)

/*! @brief Format value for bitfield HDMI_VP_REMAP_ycc422_size. */
#define BF_HDMI_VP_REMAP_ycc422_size(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_REMAP_ycc422_size) & BM_HDMI_VP_REMAP_ycc422_size)

/*! @brief Set the ycc422_size field to a new value. */
#define BW_HDMI_VP_REMAP_ycc422_size(x, v) (HW_HDMI_VP_REMAP_WR(x, (HW_HDMI_VP_REMAP_RD(x) & ~BM_HDMI_VP_REMAP_ycc422_size) | BF_HDMI_VP_REMAP_ycc422_size(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_CONF - Video Packetizer Output, Bypass, and Enable Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_CONF - Video Packetizer Output, Bypass, and Enable Configuration Register (RW)
 *
 * Reset value: 0x46U
 *
 * This register controls the Video Packetizer output selection, bypass select,
 * YCC422 enable, Pixel repeater, and pixel packing enabling. Address Offset:
 * 0x0804 Size: 8 bits Value after Reset: 0x46 Access: Read/Write
 */
typedef union _hw_hdmi_vp_conf
{
    uint8_t U;
    struct _hw_hdmi_vp_conf_bitfields
    {
        uint8_t output_selector : 2;   /*!< [1:0]  */
        uint8_t BYPASS_SELECT : 1;     /*!< [2]  */
        uint8_t ycc422_en : 1;         /*!< [3]  */
        uint8_t pr_en : 1;             /*!< [4]  */
        uint8_t pp_en : 1;             /*!< [5]  */
        uint8_t bypass_en : 1;         /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_vp_conf_t;

/*!
 * @name Constants and macros for entire HDMI_VP_CONF register
 */
/*@{*/
#define HW_HDMI_VP_CONF_ADDR(x)  ((uintptr_t)(x) + 0x804U)

#define HW_HDMI_VP_CONF(x)       (*(__IO hw_hdmi_vp_conf_t *) HW_HDMI_VP_CONF_ADDR(x))
#define HW_HDMI_VP_CONF_RD(x)    (HW_HDMI_VP_CONF(x).U)
#define HW_HDMI_VP_CONF_WR(x, v) (HW_HDMI_VP_CONF(x).U = (v))
#define HW_HDMI_VP_CONF_SET(x, v) (HW_HDMI_VP_CONF_WR(x, HW_HDMI_VP_CONF_RD(x) |  (v)))
#define HW_HDMI_VP_CONF_CLR(x, v) (HW_HDMI_VP_CONF_WR(x, HW_HDMI_VP_CONF_RD(x) & ~(v)))
#define HW_HDMI_VP_CONF_TOG(x, v) (HW_HDMI_VP_CONF_WR(x, HW_HDMI_VP_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_CONF bitfields
 */

/*!
 * @name Register HDMI_VP_CONF, field output_selector[1:0] (RW)
 *
 * Video packetizer output selection.
 *
 * Values:
 * - 00 - Data from pixel packing block.
 * - 01 - Data from YCC 422 remap block.
 * - 10 - Data from 8-bit bypass block.
 * - 11 - Data from 8-bit bypass block.
 */
/*@{*/
#define BP_HDMI_VP_CONF_output_selector (0U) /*!< Bit position for HDMI_VP_CONF_output_selector. */
#define BM_HDMI_VP_CONF_output_selector (0x03U) /*!< Bit mask for HDMI_VP_CONF_output_selector. */
#define BS_HDMI_VP_CONF_output_selector (2U) /*!< Bit field size in bits for HDMI_VP_CONF_output_selector. */

/*! @brief Read current value of the HDMI_VP_CONF_output_selector field. */
#define BR_HDMI_VP_CONF_output_selector(x) (HW_HDMI_VP_CONF(x).B.output_selector)

/*! @brief Format value for bitfield HDMI_VP_CONF_output_selector. */
#define BF_HDMI_VP_CONF_output_selector(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_output_selector) & BM_HDMI_VP_CONF_output_selector)

/*! @brief Set the output_selector field to a new value. */
#define BW_HDMI_VP_CONF_output_selector(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_output_selector) | BF_HDMI_VP_CONF_output_selector(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_CONF, field BYPASS_SELECT[2] (RW)
 *
 * Bypass select bit
 *
 * Values:
 * - 0 - Data from pixel repeater block.
 * - 1 - Data from input of video packetizer block.
 */
/*@{*/
#define BP_HDMI_VP_CONF_BYPASS_SELECT (2U) /*!< Bit position for HDMI_VP_CONF_BYPASS_SELECT. */
#define BM_HDMI_VP_CONF_BYPASS_SELECT (0x04U) /*!< Bit mask for HDMI_VP_CONF_BYPASS_SELECT. */
#define BS_HDMI_VP_CONF_BYPASS_SELECT (1U) /*!< Bit field size in bits for HDMI_VP_CONF_BYPASS_SELECT. */

/*! @brief Read current value of the HDMI_VP_CONF_BYPASS_SELECT field. */
#define BR_HDMI_VP_CONF_BYPASS_SELECT(x) (HW_HDMI_VP_CONF(x).B.BYPASS_SELECT)

/*! @brief Format value for bitfield HDMI_VP_CONF_BYPASS_SELECT. */
#define BF_HDMI_VP_CONF_BYPASS_SELECT(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_BYPASS_SELECT) & BM_HDMI_VP_CONF_BYPASS_SELECT)

/*! @brief Set the BYPASS_SELECT field to a new value. */
#define BW_HDMI_VP_CONF_BYPASS_SELECT(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_BYPASS_SELECT) | BF_HDMI_VP_CONF_BYPASS_SELECT(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_CONF, field ycc422_en[3] (RW)
 *
 * YCC 422 select enable. Disabling forces bypass module to output always zeros.
 */
/*@{*/
#define BP_HDMI_VP_CONF_ycc422_en (3U)     /*!< Bit position for HDMI_VP_CONF_ycc422_en. */
#define BM_HDMI_VP_CONF_ycc422_en (0x08U)  /*!< Bit mask for HDMI_VP_CONF_ycc422_en. */
#define BS_HDMI_VP_CONF_ycc422_en (1U)     /*!< Bit field size in bits for HDMI_VP_CONF_ycc422_en. */

/*! @brief Read current value of the HDMI_VP_CONF_ycc422_en field. */
#define BR_HDMI_VP_CONF_ycc422_en(x) (HW_HDMI_VP_CONF(x).B.ycc422_en)

/*! @brief Format value for bitfield HDMI_VP_CONF_ycc422_en. */
#define BF_HDMI_VP_CONF_ycc422_en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_ycc422_en) & BM_HDMI_VP_CONF_ycc422_en)

/*! @brief Set the ycc422_en field to a new value. */
#define BW_HDMI_VP_CONF_ycc422_en(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_ycc422_en) | BF_HDMI_VP_CONF_ycc422_en(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_CONF, field pr_en[4] (RW)
 *
 * Pixel repeater enable. Disabling forces bypass module to output always zeros.
 */
/*@{*/
#define BP_HDMI_VP_CONF_pr_en (4U)         /*!< Bit position for HDMI_VP_CONF_pr_en. */
#define BM_HDMI_VP_CONF_pr_en (0x10U)      /*!< Bit mask for HDMI_VP_CONF_pr_en. */
#define BS_HDMI_VP_CONF_pr_en (1U)         /*!< Bit field size in bits for HDMI_VP_CONF_pr_en. */

/*! @brief Read current value of the HDMI_VP_CONF_pr_en field. */
#define BR_HDMI_VP_CONF_pr_en(x) (HW_HDMI_VP_CONF(x).B.pr_en)

/*! @brief Format value for bitfield HDMI_VP_CONF_pr_en. */
#define BF_HDMI_VP_CONF_pr_en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_pr_en) & BM_HDMI_VP_CONF_pr_en)

/*! @brief Set the pr_en field to a new value. */
#define BW_HDMI_VP_CONF_pr_en(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_pr_en) | BF_HDMI_VP_CONF_pr_en(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_CONF, field pp_en[5] (RW)
 *
 * Pixel packing enable. Disabling forces bypass module to output always zeros.
 */
/*@{*/
#define BP_HDMI_VP_CONF_pp_en (5U)         /*!< Bit position for HDMI_VP_CONF_pp_en. */
#define BM_HDMI_VP_CONF_pp_en (0x20U)      /*!< Bit mask for HDMI_VP_CONF_pp_en. */
#define BS_HDMI_VP_CONF_pp_en (1U)         /*!< Bit field size in bits for HDMI_VP_CONF_pp_en. */

/*! @brief Read current value of the HDMI_VP_CONF_pp_en field. */
#define BR_HDMI_VP_CONF_pp_en(x) (HW_HDMI_VP_CONF(x).B.pp_en)

/*! @brief Format value for bitfield HDMI_VP_CONF_pp_en. */
#define BF_HDMI_VP_CONF_pp_en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_pp_en) & BM_HDMI_VP_CONF_pp_en)

/*! @brief Set the pp_en field to a new value. */
#define BW_HDMI_VP_CONF_pp_en(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_pp_en) | BF_HDMI_VP_CONF_pp_en(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_CONF, field bypass_en[6] (RW)
 *
 * Bypass enable. Disabling forces bypass module to output always zeros.
 */
/*@{*/
#define BP_HDMI_VP_CONF_bypass_en (6U)     /*!< Bit position for HDMI_VP_CONF_bypass_en. */
#define BM_HDMI_VP_CONF_bypass_en (0x40U)  /*!< Bit mask for HDMI_VP_CONF_bypass_en. */
#define BS_HDMI_VP_CONF_bypass_en (1U)     /*!< Bit field size in bits for HDMI_VP_CONF_bypass_en. */

/*! @brief Read current value of the HDMI_VP_CONF_bypass_en field. */
#define BR_HDMI_VP_CONF_bypass_en(x) (HW_HDMI_VP_CONF(x).B.bypass_en)

/*! @brief Format value for bitfield HDMI_VP_CONF_bypass_en. */
#define BF_HDMI_VP_CONF_bypass_en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_CONF_bypass_en) & BM_HDMI_VP_CONF_bypass_en)

/*! @brief Set the bypass_en field to a new value. */
#define BW_HDMI_VP_CONF_bypass_en(x, v) (HW_HDMI_VP_CONF_WR(x, (HW_HDMI_VP_CONF_RD(x) & ~BM_HDMI_VP_CONF_bypass_en) | BF_HDMI_VP_CONF_bypass_en(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_STAT - VP_STAT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_STAT - VP_STAT (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the following active high FIFO status indications:
 * Address Offset: 0x0805 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_vp_stat
{
    uint8_t U;
    struct _hw_hdmi_vp_stat_bitfields
    {
        uint8_t ostemptybyp : 1;       /*!< [0]  */
        uint8_t ostfullbyp : 1;        /*!< [1]  */
        uint8_t ostemptyremap : 1;     /*!< [2]  */
        uint8_t ostfullremap : 1;      /*!< [3]  */
        uint8_t ostemptypp : 1;        /*!< [4]  */
        uint8_t ostfullpp : 1;         /*!< [5]  */
        uint8_t ostemptyrepet : 1;     /*!< [6]  */
        uint8_t ostfullrepet : 1;      /*!< [7]  */
    } B;
} hw_hdmi_vp_stat_t;

/*!
 * @name Constants and macros for entire HDMI_VP_STAT register
 */
/*@{*/
#define HW_HDMI_VP_STAT_ADDR(x)  ((uintptr_t)(x) + 0x805U)

#define HW_HDMI_VP_STAT(x)       (*(__I hw_hdmi_vp_stat_t *) HW_HDMI_VP_STAT_ADDR(x))
#define HW_HDMI_VP_STAT_RD(x)    (HW_HDMI_VP_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_STAT bitfields
 */

/*!
 * @name Register HDMI_VP_STAT, field ostemptybyp[0] (RO)
 *
 * Video packetizer 8-bit bypass FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostemptybyp (0U)   /*!< Bit position for HDMI_VP_STAT_ostemptybyp. */
#define BM_HDMI_VP_STAT_ostemptybyp (0x01U) /*!< Bit mask for HDMI_VP_STAT_ostemptybyp. */
#define BS_HDMI_VP_STAT_ostemptybyp (1U)   /*!< Bit field size in bits for HDMI_VP_STAT_ostemptybyp. */

/*! @brief Read current value of the HDMI_VP_STAT_ostemptybyp field. */
#define BR_HDMI_VP_STAT_ostemptybyp(x) (HW_HDMI_VP_STAT(x).B.ostemptybyp)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostfullbyp[1] (RO)
 *
 * Video packetizer 8-bit bypass FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostfullbyp (1U)    /*!< Bit position for HDMI_VP_STAT_ostfullbyp. */
#define BM_HDMI_VP_STAT_ostfullbyp (0x02U) /*!< Bit mask for HDMI_VP_STAT_ostfullbyp. */
#define BS_HDMI_VP_STAT_ostfullbyp (1U)    /*!< Bit field size in bits for HDMI_VP_STAT_ostfullbyp. */

/*! @brief Read current value of the HDMI_VP_STAT_ostfullbyp field. */
#define BR_HDMI_VP_STAT_ostfullbyp(x) (HW_HDMI_VP_STAT(x).B.ostfullbyp)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostemptyremap[2] (RO)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostemptyremap (2U) /*!< Bit position for HDMI_VP_STAT_ostemptyremap. */
#define BM_HDMI_VP_STAT_ostemptyremap (0x04U) /*!< Bit mask for HDMI_VP_STAT_ostemptyremap. */
#define BS_HDMI_VP_STAT_ostemptyremap (1U) /*!< Bit field size in bits for HDMI_VP_STAT_ostemptyremap. */

/*! @brief Read current value of the HDMI_VP_STAT_ostemptyremap field. */
#define BR_HDMI_VP_STAT_ostemptyremap(x) (HW_HDMI_VP_STAT(x).B.ostemptyremap)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostfullremap[3] (RO)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostfullremap (3U)  /*!< Bit position for HDMI_VP_STAT_ostfullremap. */
#define BM_HDMI_VP_STAT_ostfullremap (0x08U) /*!< Bit mask for HDMI_VP_STAT_ostfullremap. */
#define BS_HDMI_VP_STAT_ostfullremap (1U)  /*!< Bit field size in bits for HDMI_VP_STAT_ostfullremap. */

/*! @brief Read current value of the HDMI_VP_STAT_ostfullremap field. */
#define BR_HDMI_VP_STAT_ostfullremap(x) (HW_HDMI_VP_STAT(x).B.ostfullremap)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostemptypp[4] (RO)
 *
 * Video packetizer pixel packing FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostemptypp (4U)    /*!< Bit position for HDMI_VP_STAT_ostemptypp. */
#define BM_HDMI_VP_STAT_ostemptypp (0x10U) /*!< Bit mask for HDMI_VP_STAT_ostemptypp. */
#define BS_HDMI_VP_STAT_ostemptypp (1U)    /*!< Bit field size in bits for HDMI_VP_STAT_ostemptypp. */

/*! @brief Read current value of the HDMI_VP_STAT_ostemptypp field. */
#define BR_HDMI_VP_STAT_ostemptypp(x) (HW_HDMI_VP_STAT(x).B.ostemptypp)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostfullpp[5] (RO)
 *
 * Video packetizer pixel packing FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostfullpp (5U)     /*!< Bit position for HDMI_VP_STAT_ostfullpp. */
#define BM_HDMI_VP_STAT_ostfullpp (0x20U)  /*!< Bit mask for HDMI_VP_STAT_ostfullpp. */
#define BS_HDMI_VP_STAT_ostfullpp (1U)     /*!< Bit field size in bits for HDMI_VP_STAT_ostfullpp. */

/*! @brief Read current value of the HDMI_VP_STAT_ostfullpp field. */
#define BR_HDMI_VP_STAT_ostfullpp(x) (HW_HDMI_VP_STAT(x).B.ostfullpp)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostemptyrepet[6] (RO)
 *
 * Video packetizer pixel repeater FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostemptyrepet (6U) /*!< Bit position for HDMI_VP_STAT_ostemptyrepet. */
#define BM_HDMI_VP_STAT_ostemptyrepet (0x40U) /*!< Bit mask for HDMI_VP_STAT_ostemptyrepet. */
#define BS_HDMI_VP_STAT_ostemptyrepet (1U) /*!< Bit field size in bits for HDMI_VP_STAT_ostemptyrepet. */

/*! @brief Read current value of the HDMI_VP_STAT_ostemptyrepet field. */
#define BR_HDMI_VP_STAT_ostemptyrepet(x) (HW_HDMI_VP_STAT(x).B.ostemptyrepet)
/*@}*/

/*!
 * @name Register HDMI_VP_STAT, field ostfullrepet[7] (RO)
 *
 * Video packetizer pixel repeater FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_STAT_ostfullrepet (7U)  /*!< Bit position for HDMI_VP_STAT_ostfullrepet. */
#define BM_HDMI_VP_STAT_ostfullrepet (0x80U) /*!< Bit mask for HDMI_VP_STAT_ostfullrepet. */
#define BS_HDMI_VP_STAT_ostfullrepet (1U)  /*!< Bit field size in bits for HDMI_VP_STAT_ostfullrepet. */

/*! @brief Read current value of the HDMI_VP_STAT_ostfullrepet field. */
#define BR_HDMI_VP_STAT_ostfullrepet(x) (HW_HDMI_VP_STAT(x).B.ostfullrepet)
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_INT - VP_INT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_INT - VP_INT (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt indication of the VP_STAT status
 * interrupts. Interrupt generation is accomplished in the following way: interrupt =
 * (mask == 1'b0) && (polarity == status); All this interrupts are forwarded to the
 * Interrupt Handler sticky bit registers and after ORed to a single main
 * interrupt line to micro controller. Assertion of this interrupt implies that data
 * related with the corresponding packet has been sent through the HDMI interface.
 * Address Offset: 0x0806 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_vp_int
{
    uint8_t U;
    struct _hw_hdmi_vp_int_bitfields
    {
        uint8_t ointemptybyp : 1;      /*!< [0]  */
        uint8_t ointfullbyp : 1;       /*!< [1]  */
        uint8_t ointemptyremap : 1;    /*!< [2]  */
        uint8_t ointfullremap : 1;     /*!< [3]  */
        uint8_t ointemptypp : 1;       /*!< [4]  */
        uint8_t ointfullpp : 1;        /*!< [5]  */
        uint8_t ointemptyrepet : 1;    /*!< [6]  */
        uint8_t ointfullrepet : 1;     /*!< [7]  */
    } B;
} hw_hdmi_vp_int_t;

/*!
 * @name Constants and macros for entire HDMI_VP_INT register
 */
/*@{*/
#define HW_HDMI_VP_INT_ADDR(x)   ((uintptr_t)(x) + 0x806U)

#define HW_HDMI_VP_INT(x)        (*(__I hw_hdmi_vp_int_t *) HW_HDMI_VP_INT_ADDR(x))
#define HW_HDMI_VP_INT_RD(x)     (HW_HDMI_VP_INT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_INT bitfields
 */

/*!
 * @name Register HDMI_VP_INT, field ointemptybyp[0] (RO)
 *
 * Video packetizer 8-bit bypass FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_INT_ointemptybyp (0U)   /*!< Bit position for HDMI_VP_INT_ointemptybyp. */
#define BM_HDMI_VP_INT_ointemptybyp (0x01U) /*!< Bit mask for HDMI_VP_INT_ointemptybyp. */
#define BS_HDMI_VP_INT_ointemptybyp (1U)   /*!< Bit field size in bits for HDMI_VP_INT_ointemptybyp. */

/*! @brief Read current value of the HDMI_VP_INT_ointemptybyp field. */
#define BR_HDMI_VP_INT_ointemptybyp(x) (HW_HDMI_VP_INT(x).B.ointemptybyp)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointfullbyp[1] (RO)
 *
 * Video packetizer 8-bit bypass FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_INT_ointfullbyp (1U)    /*!< Bit position for HDMI_VP_INT_ointfullbyp. */
#define BM_HDMI_VP_INT_ointfullbyp (0x02U) /*!< Bit mask for HDMI_VP_INT_ointfullbyp. */
#define BS_HDMI_VP_INT_ointfullbyp (1U)    /*!< Bit field size in bits for HDMI_VP_INT_ointfullbyp. */

/*! @brief Read current value of the HDMI_VP_INT_ointfullbyp field. */
#define BR_HDMI_VP_INT_ointfullbyp(x) (HW_HDMI_VP_INT(x).B.ointfullbyp)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointemptyremap[2] (RO)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO empty status.
 */
/*@{*/
#define BP_HDMI_VP_INT_ointemptyremap (2U) /*!< Bit position for HDMI_VP_INT_ointemptyremap. */
#define BM_HDMI_VP_INT_ointemptyremap (0x04U) /*!< Bit mask for HDMI_VP_INT_ointemptyremap. */
#define BS_HDMI_VP_INT_ointemptyremap (1U) /*!< Bit field size in bits for HDMI_VP_INT_ointemptyremap. */

/*! @brief Read current value of the HDMI_VP_INT_ointemptyremap field. */
#define BR_HDMI_VP_INT_ointemptyremap(x) (HW_HDMI_VP_INT(x).B.ointemptyremap)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointfullremap[3] (RO)
 *
 * Video packetizer pixel YCC 422 re-mapper FIFO full status.
 */
/*@{*/
#define BP_HDMI_VP_INT_ointfullremap (3U)  /*!< Bit position for HDMI_VP_INT_ointfullremap. */
#define BM_HDMI_VP_INT_ointfullremap (0x08U) /*!< Bit mask for HDMI_VP_INT_ointfullremap. */
#define BS_HDMI_VP_INT_ointfullremap (1U)  /*!< Bit field size in bits for HDMI_VP_INT_ointfullremap. */

/*! @brief Read current value of the HDMI_VP_INT_ointfullremap field. */
#define BR_HDMI_VP_INT_ointfullremap(x) (HW_HDMI_VP_INT(x).B.ointfullremap)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointemptypp[4] (RO)
 *
 * Video packetizer pixel packing FIFO empty status
 */
/*@{*/
#define BP_HDMI_VP_INT_ointemptypp (4U)    /*!< Bit position for HDMI_VP_INT_ointemptypp. */
#define BM_HDMI_VP_INT_ointemptypp (0x10U) /*!< Bit mask for HDMI_VP_INT_ointemptypp. */
#define BS_HDMI_VP_INT_ointemptypp (1U)    /*!< Bit field size in bits for HDMI_VP_INT_ointemptypp. */

/*! @brief Read current value of the HDMI_VP_INT_ointemptypp field. */
#define BR_HDMI_VP_INT_ointemptypp(x) (HW_HDMI_VP_INT(x).B.ointemptypp)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointfullpp[5] (RO)
 *
 * Video packetizer pixel packing FIFO full status
 */
/*@{*/
#define BP_HDMI_VP_INT_ointfullpp (5U)     /*!< Bit position for HDMI_VP_INT_ointfullpp. */
#define BM_HDMI_VP_INT_ointfullpp (0x20U)  /*!< Bit mask for HDMI_VP_INT_ointfullpp. */
#define BS_HDMI_VP_INT_ointfullpp (1U)     /*!< Bit field size in bits for HDMI_VP_INT_ointfullpp. */

/*! @brief Read current value of the HDMI_VP_INT_ointfullpp field. */
#define BR_HDMI_VP_INT_ointfullpp(x) (HW_HDMI_VP_INT(x).B.ointfullpp)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointemptyrepet[6] (RO)
 *
 * Video packetizer pixel repeater FIFO empty status
 */
/*@{*/
#define BP_HDMI_VP_INT_ointemptyrepet (6U) /*!< Bit position for HDMI_VP_INT_ointemptyrepet. */
#define BM_HDMI_VP_INT_ointemptyrepet (0x40U) /*!< Bit mask for HDMI_VP_INT_ointemptyrepet. */
#define BS_HDMI_VP_INT_ointemptyrepet (1U) /*!< Bit field size in bits for HDMI_VP_INT_ointemptyrepet. */

/*! @brief Read current value of the HDMI_VP_INT_ointemptyrepet field. */
#define BR_HDMI_VP_INT_ointemptyrepet(x) (HW_HDMI_VP_INT(x).B.ointemptyrepet)
/*@}*/

/*!
 * @name Register HDMI_VP_INT, field ointfullrepet[7] (RO)
 *
 * Video packetizer pixel repeater FIFO full status
 */
/*@{*/
#define BP_HDMI_VP_INT_ointfullrepet (7U)  /*!< Bit position for HDMI_VP_INT_ointfullrepet. */
#define BM_HDMI_VP_INT_ointfullrepet (0x80U) /*!< Bit mask for HDMI_VP_INT_ointfullrepet. */
#define BS_HDMI_VP_INT_ointfullrepet (1U)  /*!< Bit field size in bits for HDMI_VP_INT_ointfullrepet. */

/*! @brief Read current value of the HDMI_VP_INT_ointfullrepet field. */
#define BR_HDMI_VP_INT_ointfullrepet(x) (HW_HDMI_VP_INT(x).B.ointfullrepet)
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_MASK - Video Packetizer Interrupt Mask Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_MASK - Video Packetizer Interrupt Mask Register (RW)
 *
 * Reset value: 0x00U
 *
 * Mask register for generation of VP_INT interrupts. Address Offset: 0x0807
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_vp_mask
{
    uint8_t U;
    struct _hw_hdmi_vp_mask_bitfields
    {
        uint8_t VPMASK0 : 1;           /*!< [0]  */
        uint8_t VPMASK1 : 1;           /*!< [1]  */
        uint8_t VPMASK2 : 1;           /*!< [2]  */
        uint8_t VPMASK3 : 1;           /*!< [3]  */
        uint8_t VPMASK4 : 1;           /*!< [4]  */
        uint8_t VPMASK5 : 1;           /*!< [5]  */
        uint8_t VPMASK6 : 1;           /*!< [6]  */
        uint8_t VPMASK7 : 1;           /*!< [7]  */
    } B;
} hw_hdmi_vp_mask_t;

/*!
 * @name Constants and macros for entire HDMI_VP_MASK register
 */
/*@{*/
#define HW_HDMI_VP_MASK_ADDR(x)  ((uintptr_t)(x) + 0x807U)

#define HW_HDMI_VP_MASK(x)       (*(__IO hw_hdmi_vp_mask_t *) HW_HDMI_VP_MASK_ADDR(x))
#define HW_HDMI_VP_MASK_RD(x)    (HW_HDMI_VP_MASK(x).U)
#define HW_HDMI_VP_MASK_WR(x, v) (HW_HDMI_VP_MASK(x).U = (v))
#define HW_HDMI_VP_MASK_SET(x, v) (HW_HDMI_VP_MASK_WR(x, HW_HDMI_VP_MASK_RD(x) |  (v)))
#define HW_HDMI_VP_MASK_CLR(x, v) (HW_HDMI_VP_MASK_WR(x, HW_HDMI_VP_MASK_RD(x) & ~(v)))
#define HW_HDMI_VP_MASK_TOG(x, v) (HW_HDMI_VP_MASK_WR(x, HW_HDMI_VP_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_MASK bitfields
 */

/*!
 * @name Register HDMI_VP_MASK, field VPMASK0[0] (RW)
 *
 * Mask bit for VP_INT[0] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK0 (0U)       /*!< Bit position for HDMI_VP_MASK_VPMASK0. */
#define BM_HDMI_VP_MASK_VPMASK0 (0x01U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK0. */
#define BS_HDMI_VP_MASK_VPMASK0 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK0. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK0 field. */
#define BR_HDMI_VP_MASK_VPMASK0(x) (HW_HDMI_VP_MASK(x).B.VPMASK0)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK0. */
#define BF_HDMI_VP_MASK_VPMASK0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK0) & BM_HDMI_VP_MASK_VPMASK0)

/*! @brief Set the VPMASK0 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK0(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK0) | BF_HDMI_VP_MASK_VPMASK0(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK1[1] (RW)
 *
 * Mask bit for VP_INT[1] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK1 (1U)       /*!< Bit position for HDMI_VP_MASK_VPMASK1. */
#define BM_HDMI_VP_MASK_VPMASK1 (0x02U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK1. */
#define BS_HDMI_VP_MASK_VPMASK1 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK1. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK1 field. */
#define BR_HDMI_VP_MASK_VPMASK1(x) (HW_HDMI_VP_MASK(x).B.VPMASK1)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK1. */
#define BF_HDMI_VP_MASK_VPMASK1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK1) & BM_HDMI_VP_MASK_VPMASK1)

/*! @brief Set the VPMASK1 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK1(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK1) | BF_HDMI_VP_MASK_VPMASK1(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK2[2] (RW)
 *
 * Mask bit for VP_INT[2] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK2 (2U)       /*!< Bit position for HDMI_VP_MASK_VPMASK2. */
#define BM_HDMI_VP_MASK_VPMASK2 (0x04U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK2. */
#define BS_HDMI_VP_MASK_VPMASK2 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK2. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK2 field. */
#define BR_HDMI_VP_MASK_VPMASK2(x) (HW_HDMI_VP_MASK(x).B.VPMASK2)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK2. */
#define BF_HDMI_VP_MASK_VPMASK2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK2) & BM_HDMI_VP_MASK_VPMASK2)

/*! @brief Set the VPMASK2 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK2(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK2) | BF_HDMI_VP_MASK_VPMASK2(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK3[3] (RW)
 *
 * Mask bit for VP_INT[3] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK3 (3U)       /*!< Bit position for HDMI_VP_MASK_VPMASK3. */
#define BM_HDMI_VP_MASK_VPMASK3 (0x08U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK3. */
#define BS_HDMI_VP_MASK_VPMASK3 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK3. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK3 field. */
#define BR_HDMI_VP_MASK_VPMASK3(x) (HW_HDMI_VP_MASK(x).B.VPMASK3)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK3. */
#define BF_HDMI_VP_MASK_VPMASK3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK3) & BM_HDMI_VP_MASK_VPMASK3)

/*! @brief Set the VPMASK3 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK3(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK3) | BF_HDMI_VP_MASK_VPMASK3(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK4[4] (RW)
 *
 * Mask bit for VP_INT[4] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK4 (4U)       /*!< Bit position for HDMI_VP_MASK_VPMASK4. */
#define BM_HDMI_VP_MASK_VPMASK4 (0x10U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK4. */
#define BS_HDMI_VP_MASK_VPMASK4 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK4. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK4 field. */
#define BR_HDMI_VP_MASK_VPMASK4(x) (HW_HDMI_VP_MASK(x).B.VPMASK4)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK4. */
#define BF_HDMI_VP_MASK_VPMASK4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK4) & BM_HDMI_VP_MASK_VPMASK4)

/*! @brief Set the VPMASK4 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK4(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK4) | BF_HDMI_VP_MASK_VPMASK4(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK5[5] (RW)
 *
 * Mask bit for VP_INT[5] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK5 (5U)       /*!< Bit position for HDMI_VP_MASK_VPMASK5. */
#define BM_HDMI_VP_MASK_VPMASK5 (0x20U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK5. */
#define BS_HDMI_VP_MASK_VPMASK5 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK5. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK5 field. */
#define BR_HDMI_VP_MASK_VPMASK5(x) (HW_HDMI_VP_MASK(x).B.VPMASK5)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK5. */
#define BF_HDMI_VP_MASK_VPMASK5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK5) & BM_HDMI_VP_MASK_VPMASK5)

/*! @brief Set the VPMASK5 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK5(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK5) | BF_HDMI_VP_MASK_VPMASK5(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK6[6] (RW)
 *
 * Mask bit for VP_INT[6] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK6 (6U)       /*!< Bit position for HDMI_VP_MASK_VPMASK6. */
#define BM_HDMI_VP_MASK_VPMASK6 (0x40U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK6. */
#define BS_HDMI_VP_MASK_VPMASK6 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK6. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK6 field. */
#define BR_HDMI_VP_MASK_VPMASK6(x) (HW_HDMI_VP_MASK(x).B.VPMASK6)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK6. */
#define BF_HDMI_VP_MASK_VPMASK6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK6) & BM_HDMI_VP_MASK_VPMASK6)

/*! @brief Set the VPMASK6 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK6(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK6) | BF_HDMI_VP_MASK_VPMASK6(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_MASK, field VPMASK7[7] (RW)
 *
 * Mask bit for VP_INT[7] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_MASK_VPMASK7 (7U)       /*!< Bit position for HDMI_VP_MASK_VPMASK7. */
#define BM_HDMI_VP_MASK_VPMASK7 (0x80U)    /*!< Bit mask for HDMI_VP_MASK_VPMASK7. */
#define BS_HDMI_VP_MASK_VPMASK7 (1U)       /*!< Bit field size in bits for HDMI_VP_MASK_VPMASK7. */

/*! @brief Read current value of the HDMI_VP_MASK_VPMASK7 field. */
#define BR_HDMI_VP_MASK_VPMASK7(x) (HW_HDMI_VP_MASK(x).B.VPMASK7)

/*! @brief Format value for bitfield HDMI_VP_MASK_VPMASK7. */
#define BF_HDMI_VP_MASK_VPMASK7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_MASK_VPMASK7) & BM_HDMI_VP_MASK_VPMASK7)

/*! @brief Set the VPMASK7 field to a new value. */
#define BW_HDMI_VP_MASK_VPMASK7(x, v) (HW_HDMI_VP_MASK_WR(x, (HW_HDMI_VP_MASK_RD(x) & ~BM_HDMI_VP_MASK_VPMASK7) | BF_HDMI_VP_MASK_VPMASK7(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_VP_POL - VP_POL
 ******************************************************************************/

/*!
 * @brief HW_HDMI_VP_POL - VP_POL (RW)
 *
 * Reset value: 0xFFU
 *
 * Polarity register for generation of VP_INT interrupts. Address Offset: 0x0808
 * Size: 8 bits Value after Reset: 0xFF Access: Read/Write
 */
typedef union _hw_hdmi_vp_pol
{
    uint8_t U;
    struct _hw_hdmi_vp_pol_bitfields
    {
        uint8_t VPPOL0 : 1;            /*!< [0]  */
        uint8_t VPPOL1 : 1;            /*!< [1]  */
        uint8_t VPPOL2 : 1;            /*!< [2]  */
        uint8_t VPPOL3 : 1;            /*!< [3]  */
        uint8_t VPPOL4 : 1;            /*!< [4]  */
        uint8_t VPPOL5 : 1;            /*!< [5]  */
        uint8_t VPPOL6 : 1;            /*!< [6]  */
        uint8_t VPPOL7 : 1;            /*!< [7]  */
    } B;
} hw_hdmi_vp_pol_t;

/*!
 * @name Constants and macros for entire HDMI_VP_POL register
 */
/*@{*/
#define HW_HDMI_VP_POL_ADDR(x)   ((uintptr_t)(x) + 0x808U)

#define HW_HDMI_VP_POL(x)        (*(__IO hw_hdmi_vp_pol_t *) HW_HDMI_VP_POL_ADDR(x))
#define HW_HDMI_VP_POL_RD(x)     (HW_HDMI_VP_POL(x).U)
#define HW_HDMI_VP_POL_WR(x, v)  (HW_HDMI_VP_POL(x).U = (v))
#define HW_HDMI_VP_POL_SET(x, v) (HW_HDMI_VP_POL_WR(x, HW_HDMI_VP_POL_RD(x) |  (v)))
#define HW_HDMI_VP_POL_CLR(x, v) (HW_HDMI_VP_POL_WR(x, HW_HDMI_VP_POL_RD(x) & ~(v)))
#define HW_HDMI_VP_POL_TOG(x, v) (HW_HDMI_VP_POL_WR(x, HW_HDMI_VP_POL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_VP_POL bitfields
 */

/*!
 * @name Register HDMI_VP_POL, field VPPOL0[0] (RW)
 *
 * Polarity bit for VP_INT[0] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL0 (0U)         /*!< Bit position for HDMI_VP_POL_VPPOL0. */
#define BM_HDMI_VP_POL_VPPOL0 (0x01U)      /*!< Bit mask for HDMI_VP_POL_VPPOL0. */
#define BS_HDMI_VP_POL_VPPOL0 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL0. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL0 field. */
#define BR_HDMI_VP_POL_VPPOL0(x) (HW_HDMI_VP_POL(x).B.VPPOL0)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL0. */
#define BF_HDMI_VP_POL_VPPOL0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL0) & BM_HDMI_VP_POL_VPPOL0)

/*! @brief Set the VPPOL0 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL0(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL0) | BF_HDMI_VP_POL_VPPOL0(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL1[1] (RW)
 *
 * Polarity bit for VP_INT[1] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL1 (1U)         /*!< Bit position for HDMI_VP_POL_VPPOL1. */
#define BM_HDMI_VP_POL_VPPOL1 (0x02U)      /*!< Bit mask for HDMI_VP_POL_VPPOL1. */
#define BS_HDMI_VP_POL_VPPOL1 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL1. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL1 field. */
#define BR_HDMI_VP_POL_VPPOL1(x) (HW_HDMI_VP_POL(x).B.VPPOL1)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL1. */
#define BF_HDMI_VP_POL_VPPOL1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL1) & BM_HDMI_VP_POL_VPPOL1)

/*! @brief Set the VPPOL1 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL1(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL1) | BF_HDMI_VP_POL_VPPOL1(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL2[2] (RW)
 *
 * Polarity bit for VP_INT[2] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL2 (2U)         /*!< Bit position for HDMI_VP_POL_VPPOL2. */
#define BM_HDMI_VP_POL_VPPOL2 (0x04U)      /*!< Bit mask for HDMI_VP_POL_VPPOL2. */
#define BS_HDMI_VP_POL_VPPOL2 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL2. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL2 field. */
#define BR_HDMI_VP_POL_VPPOL2(x) (HW_HDMI_VP_POL(x).B.VPPOL2)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL2. */
#define BF_HDMI_VP_POL_VPPOL2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL2) & BM_HDMI_VP_POL_VPPOL2)

/*! @brief Set the VPPOL2 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL2(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL2) | BF_HDMI_VP_POL_VPPOL2(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL3[3] (RW)
 *
 * Polarity bit for VP_INT[3] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL3 (3U)         /*!< Bit position for HDMI_VP_POL_VPPOL3. */
#define BM_HDMI_VP_POL_VPPOL3 (0x08U)      /*!< Bit mask for HDMI_VP_POL_VPPOL3. */
#define BS_HDMI_VP_POL_VPPOL3 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL3. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL3 field. */
#define BR_HDMI_VP_POL_VPPOL3(x) (HW_HDMI_VP_POL(x).B.VPPOL3)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL3. */
#define BF_HDMI_VP_POL_VPPOL3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL3) & BM_HDMI_VP_POL_VPPOL3)

/*! @brief Set the VPPOL3 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL3(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL3) | BF_HDMI_VP_POL_VPPOL3(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL4[4] (RW)
 *
 * Polarity bit for VP_INT[4] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL4 (4U)         /*!< Bit position for HDMI_VP_POL_VPPOL4. */
#define BM_HDMI_VP_POL_VPPOL4 (0x10U)      /*!< Bit mask for HDMI_VP_POL_VPPOL4. */
#define BS_HDMI_VP_POL_VPPOL4 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL4. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL4 field. */
#define BR_HDMI_VP_POL_VPPOL4(x) (HW_HDMI_VP_POL(x).B.VPPOL4)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL4. */
#define BF_HDMI_VP_POL_VPPOL4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL4) & BM_HDMI_VP_POL_VPPOL4)

/*! @brief Set the VPPOL4 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL4(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL4) | BF_HDMI_VP_POL_VPPOL4(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL5[5] (RW)
 *
 * Polarity bit for VP_INT[5] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL5 (5U)         /*!< Bit position for HDMI_VP_POL_VPPOL5. */
#define BM_HDMI_VP_POL_VPPOL5 (0x20U)      /*!< Bit mask for HDMI_VP_POL_VPPOL5. */
#define BS_HDMI_VP_POL_VPPOL5 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL5. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL5 field. */
#define BR_HDMI_VP_POL_VPPOL5(x) (HW_HDMI_VP_POL(x).B.VPPOL5)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL5. */
#define BF_HDMI_VP_POL_VPPOL5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL5) & BM_HDMI_VP_POL_VPPOL5)

/*! @brief Set the VPPOL5 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL5(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL5) | BF_HDMI_VP_POL_VPPOL5(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL6[6] (RW)
 *
 * Polarity bit for VP_INT[6] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL6 (6U)         /*!< Bit position for HDMI_VP_POL_VPPOL6. */
#define BM_HDMI_VP_POL_VPPOL6 (0x40U)      /*!< Bit mask for HDMI_VP_POL_VPPOL6. */
#define BS_HDMI_VP_POL_VPPOL6 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL6. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL6 field. */
#define BR_HDMI_VP_POL_VPPOL6(x) (HW_HDMI_VP_POL(x).B.VPPOL6)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL6. */
#define BF_HDMI_VP_POL_VPPOL6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL6) & BM_HDMI_VP_POL_VPPOL6)

/*! @brief Set the VPPOL6 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL6(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL6) | BF_HDMI_VP_POL_VPPOL6(v)))
/*@}*/

/*!
 * @name Register HDMI_VP_POL, field VPPOL7[7] (RW)
 *
 * Polarity bit for VP_INT[7] interrupt bit.
 */
/*@{*/
#define BP_HDMI_VP_POL_VPPOL7 (7U)         /*!< Bit position for HDMI_VP_POL_VPPOL7. */
#define BM_HDMI_VP_POL_VPPOL7 (0x80U)      /*!< Bit mask for HDMI_VP_POL_VPPOL7. */
#define BS_HDMI_VP_POL_VPPOL7 (1U)         /*!< Bit field size in bits for HDMI_VP_POL_VPPOL7. */

/*! @brief Read current value of the HDMI_VP_POL_VPPOL7 field. */
#define BR_HDMI_VP_POL_VPPOL7(x) (HW_HDMI_VP_POL(x).B.VPPOL7)

/*! @brief Format value for bitfield HDMI_VP_POL_VPPOL7. */
#define BF_HDMI_VP_POL_VPPOL7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_VP_POL_VPPOL7) & BM_HDMI_VP_POL_VPPOL7)

/*! @brief Set the VPPOL7 field to a new value. */
#define BW_HDMI_VP_POL_VPPOL7(x, v) (HW_HDMI_VP_POL_WR(x, (HW_HDMI_VP_POL_RD(x) & ~BM_HDMI_VP_POL_VPPOL7) | BF_HDMI_VP_POL_VPPOL7(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INVIDCONF - Frame Composer Input Video Configuration and HDCP Keepout Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INVIDCONF - Frame Composer Input Video Configuration and HDCP Keepout Register (RW)
 *
 * Reset value: 0x70U
 *
 * This register configures the Interlaced/progressive, Vblank variation and
 * polarity of all video synchronism of the input video signal. Address Offset:
 * 0x1000 Size: 8 bits Value after Reset: 0x70 Access: Read/Write
 */
typedef union _hw_hdmi_fc_invidconf
{
    uint8_t U;
    struct _hw_hdmi_fc_invidconf_bitfields
    {
        uint8_t in_I_P : 1;            /*!< [0]  */
        uint8_t r_v_blank_in_osc : 1;  /*!< [1]  */
        uint8_t RESERVED0 : 1;         /*!< [2]  */
        uint8_t DVI_mode : 1;          /*!< [3]  */
        uint8_t de_in_polarity : 1;    /*!< [4]  */
        uint8_t hsync_in_polarity : 1; /*!< [5]  */
        uint8_t vsync_in_polarity : 1; /*!< [6]  */
        uint8_t RESERVED1 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_fc_invidconf_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INVIDCONF register
 */
/*@{*/
#define HW_HDMI_FC_INVIDCONF_ADDR(x) ((uintptr_t)(x) + 0x1000U)

#define HW_HDMI_FC_INVIDCONF(x)  (*(__IO hw_hdmi_fc_invidconf_t *) HW_HDMI_FC_INVIDCONF_ADDR(x))
#define HW_HDMI_FC_INVIDCONF_RD(x) (HW_HDMI_FC_INVIDCONF(x).U)
#define HW_HDMI_FC_INVIDCONF_WR(x, v) (HW_HDMI_FC_INVIDCONF(x).U = (v))
#define HW_HDMI_FC_INVIDCONF_SET(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, HW_HDMI_FC_INVIDCONF_RD(x) |  (v)))
#define HW_HDMI_FC_INVIDCONF_CLR(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, HW_HDMI_FC_INVIDCONF_RD(x) & ~(v)))
#define HW_HDMI_FC_INVIDCONF_TOG(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, HW_HDMI_FC_INVIDCONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INVIDCONF bitfields
 */

/*!
 * @name Register HDMI_FC_INVIDCONF, field in_I_P[0] (RW)
 *
 * Input video mode:
 *
 * Values:
 * - 1 - Interlaced
 * - 0 - Progressive
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_in_I_P (0U)   /*!< Bit position for HDMI_FC_INVIDCONF_in_I_P. */
#define BM_HDMI_FC_INVIDCONF_in_I_P (0x01U) /*!< Bit mask for HDMI_FC_INVIDCONF_in_I_P. */
#define BS_HDMI_FC_INVIDCONF_in_I_P (1U)   /*!< Bit field size in bits for HDMI_FC_INVIDCONF_in_I_P. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_in_I_P field. */
#define BR_HDMI_FC_INVIDCONF_in_I_P(x) (HW_HDMI_FC_INVIDCONF(x).B.in_I_P)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_in_I_P. */
#define BF_HDMI_FC_INVIDCONF_in_I_P(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_in_I_P) & BM_HDMI_FC_INVIDCONF_in_I_P)

/*! @brief Set the in_I_P field to a new value. */
#define BW_HDMI_FC_INVIDCONF_in_I_P(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_in_I_P) | BF_HDMI_FC_INVIDCONF_in_I_P(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INVIDCONF, field r_v_blank_in_osc[1] (RW)
 *
 * Used for CEA861-D modes with fractional Vblank (for example, modes 5, 6, 7,
 * 10, 11, 20, 21, and 22. For more modes, refer to CEA861-D specification.
 *
 * Values:
 * - 1 - Active high
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_r_v_blank_in_osc (1U) /*!< Bit position for HDMI_FC_INVIDCONF_r_v_blank_in_osc. */
#define BM_HDMI_FC_INVIDCONF_r_v_blank_in_osc (0x02U) /*!< Bit mask for HDMI_FC_INVIDCONF_r_v_blank_in_osc. */
#define BS_HDMI_FC_INVIDCONF_r_v_blank_in_osc (1U) /*!< Bit field size in bits for HDMI_FC_INVIDCONF_r_v_blank_in_osc. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_r_v_blank_in_osc field. */
#define BR_HDMI_FC_INVIDCONF_r_v_blank_in_osc(x) (HW_HDMI_FC_INVIDCONF(x).B.r_v_blank_in_osc)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_r_v_blank_in_osc. */
#define BF_HDMI_FC_INVIDCONF_r_v_blank_in_osc(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_r_v_blank_in_osc) & BM_HDMI_FC_INVIDCONF_r_v_blank_in_osc)

/*! @brief Set the r_v_blank_in_osc field to a new value. */
#define BW_HDMI_FC_INVIDCONF_r_v_blank_in_osc(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_r_v_blank_in_osc) | BF_HDMI_FC_INVIDCONF_r_v_blank_in_osc(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INVIDCONF, field DVI_mode[3] (RW)
 *
 * Active low
 *
 * Values:
 * - 0 - DVI mode selected
 * - 1 - HDMI mode selected
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_DVI_mode (3U) /*!< Bit position for HDMI_FC_INVIDCONF_DVI_mode. */
#define BM_HDMI_FC_INVIDCONF_DVI_mode (0x08U) /*!< Bit mask for HDMI_FC_INVIDCONF_DVI_mode. */
#define BS_HDMI_FC_INVIDCONF_DVI_mode (1U) /*!< Bit field size in bits for HDMI_FC_INVIDCONF_DVI_mode. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_DVI_mode field. */
#define BR_HDMI_FC_INVIDCONF_DVI_mode(x) (HW_HDMI_FC_INVIDCONF(x).B.DVI_mode)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_DVI_mode. */
#define BF_HDMI_FC_INVIDCONF_DVI_mode(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_DVI_mode) & BM_HDMI_FC_INVIDCONF_DVI_mode)

/*! @brief Set the DVI_mode field to a new value. */
#define BW_HDMI_FC_INVIDCONF_DVI_mode(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_DVI_mode) | BF_HDMI_FC_INVIDCONF_DVI_mode(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INVIDCONF, field de_in_polarity[4] (RW)
 *
 * Data enable input polarity
 *
 * Values:
 * - 1 - Active high
 * - 0 - Active low
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_de_in_polarity (4U) /*!< Bit position for HDMI_FC_INVIDCONF_de_in_polarity. */
#define BM_HDMI_FC_INVIDCONF_de_in_polarity (0x10U) /*!< Bit mask for HDMI_FC_INVIDCONF_de_in_polarity. */
#define BS_HDMI_FC_INVIDCONF_de_in_polarity (1U) /*!< Bit field size in bits for HDMI_FC_INVIDCONF_de_in_polarity. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_de_in_polarity field. */
#define BR_HDMI_FC_INVIDCONF_de_in_polarity(x) (HW_HDMI_FC_INVIDCONF(x).B.de_in_polarity)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_de_in_polarity. */
#define BF_HDMI_FC_INVIDCONF_de_in_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_de_in_polarity) & BM_HDMI_FC_INVIDCONF_de_in_polarity)

/*! @brief Set the de_in_polarity field to a new value. */
#define BW_HDMI_FC_INVIDCONF_de_in_polarity(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_de_in_polarity) | BF_HDMI_FC_INVIDCONF_de_in_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INVIDCONF, field hsync_in_polarity[5] (RW)
 *
 * Hsync input polarity
 *
 * Values:
 * - 1 - Active high
 * - 0 - Active low
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_hsync_in_polarity (5U) /*!< Bit position for HDMI_FC_INVIDCONF_hsync_in_polarity. */
#define BM_HDMI_FC_INVIDCONF_hsync_in_polarity (0x20U) /*!< Bit mask for HDMI_FC_INVIDCONF_hsync_in_polarity. */
#define BS_HDMI_FC_INVIDCONF_hsync_in_polarity (1U) /*!< Bit field size in bits for HDMI_FC_INVIDCONF_hsync_in_polarity. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_hsync_in_polarity field. */
#define BR_HDMI_FC_INVIDCONF_hsync_in_polarity(x) (HW_HDMI_FC_INVIDCONF(x).B.hsync_in_polarity)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_hsync_in_polarity. */
#define BF_HDMI_FC_INVIDCONF_hsync_in_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_hsync_in_polarity) & BM_HDMI_FC_INVIDCONF_hsync_in_polarity)

/*! @brief Set the hsync_in_polarity field to a new value. */
#define BW_HDMI_FC_INVIDCONF_hsync_in_polarity(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_hsync_in_polarity) | BF_HDMI_FC_INVIDCONF_hsync_in_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INVIDCONF, field vsync_in_polarity[6] (RW)
 *
 * Vsync input polarity
 *
 * Values:
 * - 1 - Active high
 * - 0 - Active low
 */
/*@{*/
#define BP_HDMI_FC_INVIDCONF_vsync_in_polarity (6U) /*!< Bit position for HDMI_FC_INVIDCONF_vsync_in_polarity. */
#define BM_HDMI_FC_INVIDCONF_vsync_in_polarity (0x40U) /*!< Bit mask for HDMI_FC_INVIDCONF_vsync_in_polarity. */
#define BS_HDMI_FC_INVIDCONF_vsync_in_polarity (1U) /*!< Bit field size in bits for HDMI_FC_INVIDCONF_vsync_in_polarity. */

/*! @brief Read current value of the HDMI_FC_INVIDCONF_vsync_in_polarity field. */
#define BR_HDMI_FC_INVIDCONF_vsync_in_polarity(x) (HW_HDMI_FC_INVIDCONF(x).B.vsync_in_polarity)

/*! @brief Format value for bitfield HDMI_FC_INVIDCONF_vsync_in_polarity. */
#define BF_HDMI_FC_INVIDCONF_vsync_in_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVIDCONF_vsync_in_polarity) & BM_HDMI_FC_INVIDCONF_vsync_in_polarity)

/*! @brief Set the vsync_in_polarity field to a new value. */
#define BW_HDMI_FC_INVIDCONF_vsync_in_polarity(x, v) (HW_HDMI_FC_INVIDCONF_WR(x, (HW_HDMI_FC_INVIDCONF_RD(x) & ~BM_HDMI_FC_INVIDCONF_vsync_in_polarity) | BF_HDMI_FC_INVIDCONF_vsync_in_polarity(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INHACTIV0 - Frame Composer Input Video HActive Pixels Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INHACTIV0 - Frame Composer Input Video HActive Pixels Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1001 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_inhactiv0
{
    uint8_t U;
    struct _hw_hdmi_fc_inhactiv0_bitfields
    {
        uint8_t H_in_activ : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_inhactiv0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INHACTIV0 register
 */
/*@{*/
#define HW_HDMI_FC_INHACTIV0_ADDR(x) ((uintptr_t)(x) + 0x1001U)

#define HW_HDMI_FC_INHACTIV0(x)  (*(__IO hw_hdmi_fc_inhactiv0_t *) HW_HDMI_FC_INHACTIV0_ADDR(x))
#define HW_HDMI_FC_INHACTIV0_RD(x) (HW_HDMI_FC_INHACTIV0(x).U)
#define HW_HDMI_FC_INHACTIV0_WR(x, v) (HW_HDMI_FC_INHACTIV0(x).U = (v))
#define HW_HDMI_FC_INHACTIV0_SET(x, v) (HW_HDMI_FC_INHACTIV0_WR(x, HW_HDMI_FC_INHACTIV0_RD(x) |  (v)))
#define HW_HDMI_FC_INHACTIV0_CLR(x, v) (HW_HDMI_FC_INHACTIV0_WR(x, HW_HDMI_FC_INHACTIV0_RD(x) & ~(v)))
#define HW_HDMI_FC_INHACTIV0_TOG(x, v) (HW_HDMI_FC_INHACTIV0_WR(x, HW_HDMI_FC_INHACTIV0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INHACTIV0 bitfields
 */

/*!
 * @name Register HDMI_FC_INHACTIV0, field H_in_activ[7:0] (RW)
 *
 * Input video Horizontal active pixel region width. Number of Horizontal active
 * pixels [0...8191].
 */
/*@{*/
#define BP_HDMI_FC_INHACTIV0_H_in_activ (0U) /*!< Bit position for HDMI_FC_INHACTIV0_H_in_activ. */
#define BM_HDMI_FC_INHACTIV0_H_in_activ (0xFFU) /*!< Bit mask for HDMI_FC_INHACTIV0_H_in_activ. */
#define BS_HDMI_FC_INHACTIV0_H_in_activ (8U) /*!< Bit field size in bits for HDMI_FC_INHACTIV0_H_in_activ. */

/*! @brief Read current value of the HDMI_FC_INHACTIV0_H_in_activ field. */
#define BR_HDMI_FC_INHACTIV0_H_in_activ(x) (HW_HDMI_FC_INHACTIV0(x).U)

/*! @brief Format value for bitfield HDMI_FC_INHACTIV0_H_in_activ. */
#define BF_HDMI_FC_INHACTIV0_H_in_activ(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INHACTIV0_H_in_activ) & BM_HDMI_FC_INHACTIV0_H_in_activ)

/*! @brief Set the H_in_activ field to a new value. */
#define BW_HDMI_FC_INHACTIV0_H_in_activ(x, v) (HW_HDMI_FC_INHACTIV0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INHACTIV1 - Frame Composer Input Video HActive Pixels Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INHACTIV1 - Frame Composer Input Video HActive Pixels Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1002 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_inhactiv1
{
    uint8_t U;
    struct _hw_hdmi_fc_inhactiv1_bitfields
    {
        uint8_t H_in_activ : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_inhactiv1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INHACTIV1 register
 */
/*@{*/
#define HW_HDMI_FC_INHACTIV1_ADDR(x) ((uintptr_t)(x) + 0x1002U)

#define HW_HDMI_FC_INHACTIV1(x)  (*(__IO hw_hdmi_fc_inhactiv1_t *) HW_HDMI_FC_INHACTIV1_ADDR(x))
#define HW_HDMI_FC_INHACTIV1_RD(x) (HW_HDMI_FC_INHACTIV1(x).U)
#define HW_HDMI_FC_INHACTIV1_WR(x, v) (HW_HDMI_FC_INHACTIV1(x).U = (v))
#define HW_HDMI_FC_INHACTIV1_SET(x, v) (HW_HDMI_FC_INHACTIV1_WR(x, HW_HDMI_FC_INHACTIV1_RD(x) |  (v)))
#define HW_HDMI_FC_INHACTIV1_CLR(x, v) (HW_HDMI_FC_INHACTIV1_WR(x, HW_HDMI_FC_INHACTIV1_RD(x) & ~(v)))
#define HW_HDMI_FC_INHACTIV1_TOG(x, v) (HW_HDMI_FC_INHACTIV1_WR(x, HW_HDMI_FC_INHACTIV1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INHACTIV1 bitfields
 */

/*!
 * @name Register HDMI_FC_INHACTIV1, field H_in_activ[4:0] (RW)
 *
 * Input video Horizontal active pixel region width. Dependencies: Value after
 * Reset: 0000b the higher bit of Horizontal active pixels; Number of Horizontal
 * active pixels [0...8191].
 */
/*@{*/
#define BP_HDMI_FC_INHACTIV1_H_in_activ (0U) /*!< Bit position for HDMI_FC_INHACTIV1_H_in_activ. */
#define BM_HDMI_FC_INHACTIV1_H_in_activ (0x1FU) /*!< Bit mask for HDMI_FC_INHACTIV1_H_in_activ. */
#define BS_HDMI_FC_INHACTIV1_H_in_activ (5U) /*!< Bit field size in bits for HDMI_FC_INHACTIV1_H_in_activ. */

/*! @brief Read current value of the HDMI_FC_INHACTIV1_H_in_activ field. */
#define BR_HDMI_FC_INHACTIV1_H_in_activ(x) (HW_HDMI_FC_INHACTIV1(x).B.H_in_activ)

/*! @brief Format value for bitfield HDMI_FC_INHACTIV1_H_in_activ. */
#define BF_HDMI_FC_INHACTIV1_H_in_activ(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INHACTIV1_H_in_activ) & BM_HDMI_FC_INHACTIV1_H_in_activ)

/*! @brief Set the H_in_activ field to a new value. */
#define BW_HDMI_FC_INHACTIV1_H_in_activ(x, v) (HW_HDMI_FC_INHACTIV1_WR(x, (HW_HDMI_FC_INHACTIV1_RD(x) & ~BM_HDMI_FC_INHACTIV1_H_in_activ) | BF_HDMI_FC_INHACTIV1_H_in_activ(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INHBLANK0 - Frame Composer Input Video HBlank Pixels Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INHBLANK0 - Frame Composer Input Video HBlank Pixels Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1003 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_inhblank0
{
    uint8_t U;
    struct _hw_hdmi_fc_inhblank0_bitfields
    {
        uint8_t H_in_blank : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_inhblank0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INHBLANK0 register
 */
/*@{*/
#define HW_HDMI_FC_INHBLANK0_ADDR(x) ((uintptr_t)(x) + 0x1003U)

#define HW_HDMI_FC_INHBLANK0(x)  (*(__IO hw_hdmi_fc_inhblank0_t *) HW_HDMI_FC_INHBLANK0_ADDR(x))
#define HW_HDMI_FC_INHBLANK0_RD(x) (HW_HDMI_FC_INHBLANK0(x).U)
#define HW_HDMI_FC_INHBLANK0_WR(x, v) (HW_HDMI_FC_INHBLANK0(x).U = (v))
#define HW_HDMI_FC_INHBLANK0_SET(x, v) (HW_HDMI_FC_INHBLANK0_WR(x, HW_HDMI_FC_INHBLANK0_RD(x) |  (v)))
#define HW_HDMI_FC_INHBLANK0_CLR(x, v) (HW_HDMI_FC_INHBLANK0_WR(x, HW_HDMI_FC_INHBLANK0_RD(x) & ~(v)))
#define HW_HDMI_FC_INHBLANK0_TOG(x, v) (HW_HDMI_FC_INHBLANK0_WR(x, HW_HDMI_FC_INHBLANK0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INHBLANK0 bitfields
 */

/*!
 * @name Register HDMI_FC_INHBLANK0, field H_in_blank[7:0] (RW)
 *
 * Input video Horizontal blanking pixel region width. Number of Horizontal
 * blanking pixels [0...4095].
 */
/*@{*/
#define BP_HDMI_FC_INHBLANK0_H_in_blank (0U) /*!< Bit position for HDMI_FC_INHBLANK0_H_in_blank. */
#define BM_HDMI_FC_INHBLANK0_H_in_blank (0xFFU) /*!< Bit mask for HDMI_FC_INHBLANK0_H_in_blank. */
#define BS_HDMI_FC_INHBLANK0_H_in_blank (8U) /*!< Bit field size in bits for HDMI_FC_INHBLANK0_H_in_blank. */

/*! @brief Read current value of the HDMI_FC_INHBLANK0_H_in_blank field. */
#define BR_HDMI_FC_INHBLANK0_H_in_blank(x) (HW_HDMI_FC_INHBLANK0(x).U)

/*! @brief Format value for bitfield HDMI_FC_INHBLANK0_H_in_blank. */
#define BF_HDMI_FC_INHBLANK0_H_in_blank(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INHBLANK0_H_in_blank) & BM_HDMI_FC_INHBLANK0_H_in_blank)

/*! @brief Set the H_in_blank field to a new value. */
#define BW_HDMI_FC_INHBLANK0_H_in_blank(x, v) (HW_HDMI_FC_INHBLANK0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INHBLANK1 - Frame Composer Input Video HBlank Pixels Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INHBLANK1 - Frame Composer Input Video HBlank Pixels Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1004 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_inhblank1
{
    uint8_t U;
    struct _hw_hdmi_fc_inhblank1_bitfields
    {
        uint8_t H_in_blank : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_inhblank1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INHBLANK1 register
 */
/*@{*/
#define HW_HDMI_FC_INHBLANK1_ADDR(x) ((uintptr_t)(x) + 0x1004U)

#define HW_HDMI_FC_INHBLANK1(x)  (*(__IO hw_hdmi_fc_inhblank1_t *) HW_HDMI_FC_INHBLANK1_ADDR(x))
#define HW_HDMI_FC_INHBLANK1_RD(x) (HW_HDMI_FC_INHBLANK1(x).U)
#define HW_HDMI_FC_INHBLANK1_WR(x, v) (HW_HDMI_FC_INHBLANK1(x).U = (v))
#define HW_HDMI_FC_INHBLANK1_SET(x, v) (HW_HDMI_FC_INHBLANK1_WR(x, HW_HDMI_FC_INHBLANK1_RD(x) |  (v)))
#define HW_HDMI_FC_INHBLANK1_CLR(x, v) (HW_HDMI_FC_INHBLANK1_WR(x, HW_HDMI_FC_INHBLANK1_RD(x) & ~(v)))
#define HW_HDMI_FC_INHBLANK1_TOG(x, v) (HW_HDMI_FC_INHBLANK1_WR(x, HW_HDMI_FC_INHBLANK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INHBLANK1 bitfields
 */

/*!
 * @name Register HDMI_FC_INHBLANK1, field H_in_blank[4:0] (RW)
 *
 * Input video Horizontal blanking pixel region width. Dependencies: Value after
 * Reset: 0000b the higher bits of Horizontal blanking pixels; Number of
 * Horizontal blanking pixels [0...8191].
 */
/*@{*/
#define BP_HDMI_FC_INHBLANK1_H_in_blank (0U) /*!< Bit position for HDMI_FC_INHBLANK1_H_in_blank. */
#define BM_HDMI_FC_INHBLANK1_H_in_blank (0x1FU) /*!< Bit mask for HDMI_FC_INHBLANK1_H_in_blank. */
#define BS_HDMI_FC_INHBLANK1_H_in_blank (5U) /*!< Bit field size in bits for HDMI_FC_INHBLANK1_H_in_blank. */

/*! @brief Read current value of the HDMI_FC_INHBLANK1_H_in_blank field. */
#define BR_HDMI_FC_INHBLANK1_H_in_blank(x) (HW_HDMI_FC_INHBLANK1(x).B.H_in_blank)

/*! @brief Format value for bitfield HDMI_FC_INHBLANK1_H_in_blank. */
#define BF_HDMI_FC_INHBLANK1_H_in_blank(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INHBLANK1_H_in_blank) & BM_HDMI_FC_INHBLANK1_H_in_blank)

/*! @brief Set the H_in_blank field to a new value. */
#define BW_HDMI_FC_INHBLANK1_H_in_blank(x, v) (HW_HDMI_FC_INHBLANK1_WR(x, (HW_HDMI_FC_INHBLANK1_RD(x) & ~BM_HDMI_FC_INHBLANK1_H_in_blank) | BF_HDMI_FC_INHBLANK1_H_in_blank(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INVACTIV0 - Frame Composer Input Video VActive Pixels Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INVACTIV0 - Frame Composer Input Video VActive Pixels Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1005 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_invactiv0
{
    uint8_t U;
    struct _hw_hdmi_fc_invactiv0_bitfields
    {
        uint8_t V_in_activ : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_invactiv0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INVACTIV0 register
 */
/*@{*/
#define HW_HDMI_FC_INVACTIV0_ADDR(x) ((uintptr_t)(x) + 0x1005U)

#define HW_HDMI_FC_INVACTIV0(x)  (*(__IO hw_hdmi_fc_invactiv0_t *) HW_HDMI_FC_INVACTIV0_ADDR(x))
#define HW_HDMI_FC_INVACTIV0_RD(x) (HW_HDMI_FC_INVACTIV0(x).U)
#define HW_HDMI_FC_INVACTIV0_WR(x, v) (HW_HDMI_FC_INVACTIV0(x).U = (v))
#define HW_HDMI_FC_INVACTIV0_SET(x, v) (HW_HDMI_FC_INVACTIV0_WR(x, HW_HDMI_FC_INVACTIV0_RD(x) |  (v)))
#define HW_HDMI_FC_INVACTIV0_CLR(x, v) (HW_HDMI_FC_INVACTIV0_WR(x, HW_HDMI_FC_INVACTIV0_RD(x) & ~(v)))
#define HW_HDMI_FC_INVACTIV0_TOG(x, v) (HW_HDMI_FC_INVACTIV0_WR(x, HW_HDMI_FC_INVACTIV0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INVACTIV0 bitfields
 */

/*!
 * @name Register HDMI_FC_INVACTIV0, field V_in_activ[7:0] (RW)
 *
 * Input video Vertical active pixel region width. Number of Vertical active
 * lines [0...4095].
 */
/*@{*/
#define BP_HDMI_FC_INVACTIV0_V_in_activ (0U) /*!< Bit position for HDMI_FC_INVACTIV0_V_in_activ. */
#define BM_HDMI_FC_INVACTIV0_V_in_activ (0xFFU) /*!< Bit mask for HDMI_FC_INVACTIV0_V_in_activ. */
#define BS_HDMI_FC_INVACTIV0_V_in_activ (8U) /*!< Bit field size in bits for HDMI_FC_INVACTIV0_V_in_activ. */

/*! @brief Read current value of the HDMI_FC_INVACTIV0_V_in_activ field. */
#define BR_HDMI_FC_INVACTIV0_V_in_activ(x) (HW_HDMI_FC_INVACTIV0(x).U)

/*! @brief Format value for bitfield HDMI_FC_INVACTIV0_V_in_activ. */
#define BF_HDMI_FC_INVACTIV0_V_in_activ(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVACTIV0_V_in_activ) & BM_HDMI_FC_INVACTIV0_V_in_activ)

/*! @brief Set the V_in_activ field to a new value. */
#define BW_HDMI_FC_INVACTIV0_V_in_activ(x, v) (HW_HDMI_FC_INVACTIV0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INVACTIV1 - Frame Composer Input Video VActive Pixels Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INVACTIV1 - Frame Composer Input Video VActive Pixels Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1006 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_invactiv1
{
    uint8_t U;
    struct _hw_hdmi_fc_invactiv1_bitfields
    {
        uint8_t V_in_activ : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_invactiv1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INVACTIV1 register
 */
/*@{*/
#define HW_HDMI_FC_INVACTIV1_ADDR(x) ((uintptr_t)(x) + 0x1006U)

#define HW_HDMI_FC_INVACTIV1(x)  (*(__IO hw_hdmi_fc_invactiv1_t *) HW_HDMI_FC_INVACTIV1_ADDR(x))
#define HW_HDMI_FC_INVACTIV1_RD(x) (HW_HDMI_FC_INVACTIV1(x).U)
#define HW_HDMI_FC_INVACTIV1_WR(x, v) (HW_HDMI_FC_INVACTIV1(x).U = (v))
#define HW_HDMI_FC_INVACTIV1_SET(x, v) (HW_HDMI_FC_INVACTIV1_WR(x, HW_HDMI_FC_INVACTIV1_RD(x) |  (v)))
#define HW_HDMI_FC_INVACTIV1_CLR(x, v) (HW_HDMI_FC_INVACTIV1_WR(x, HW_HDMI_FC_INVACTIV1_RD(x) & ~(v)))
#define HW_HDMI_FC_INVACTIV1_TOG(x, v) (HW_HDMI_FC_INVACTIV1_WR(x, HW_HDMI_FC_INVACTIV1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INVACTIV1 bitfields
 */

/*!
 * @name Register HDMI_FC_INVACTIV1, field V_in_activ[4:0] (RW)
 *
 * Input video Vertical active pixel region width. Dependencies: Value after
 * Reset: 0000b the higher 5 bits of Vertical active line; Number of Vertical active
 * lines [0...8191].
 */
/*@{*/
#define BP_HDMI_FC_INVACTIV1_V_in_activ (0U) /*!< Bit position for HDMI_FC_INVACTIV1_V_in_activ. */
#define BM_HDMI_FC_INVACTIV1_V_in_activ (0x1FU) /*!< Bit mask for HDMI_FC_INVACTIV1_V_in_activ. */
#define BS_HDMI_FC_INVACTIV1_V_in_activ (5U) /*!< Bit field size in bits for HDMI_FC_INVACTIV1_V_in_activ. */

/*! @brief Read current value of the HDMI_FC_INVACTIV1_V_in_activ field. */
#define BR_HDMI_FC_INVACTIV1_V_in_activ(x) (HW_HDMI_FC_INVACTIV1(x).B.V_in_activ)

/*! @brief Format value for bitfield HDMI_FC_INVACTIV1_V_in_activ. */
#define BF_HDMI_FC_INVACTIV1_V_in_activ(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVACTIV1_V_in_activ) & BM_HDMI_FC_INVACTIV1_V_in_activ)

/*! @brief Set the V_in_activ field to a new value. */
#define BW_HDMI_FC_INVACTIV1_V_in_activ(x, v) (HW_HDMI_FC_INVACTIV1_WR(x, (HW_HDMI_FC_INVACTIV1_RD(x) & ~BM_HDMI_FC_INVACTIV1_V_in_activ) | BF_HDMI_FC_INVACTIV1_V_in_activ(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INVBLANK - Frame Composer Input Video VBlank Pixels Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INVBLANK - Frame Composer Input Video VBlank Pixels Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1007 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_invblank
{
    uint8_t U;
    struct _hw_hdmi_fc_invblank_bitfields
    {
        uint8_t V_in_blank : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_invblank_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INVBLANK register
 */
/*@{*/
#define HW_HDMI_FC_INVBLANK_ADDR(x) ((uintptr_t)(x) + 0x1007U)

#define HW_HDMI_FC_INVBLANK(x)   (*(__IO hw_hdmi_fc_invblank_t *) HW_HDMI_FC_INVBLANK_ADDR(x))
#define HW_HDMI_FC_INVBLANK_RD(x) (HW_HDMI_FC_INVBLANK(x).U)
#define HW_HDMI_FC_INVBLANK_WR(x, v) (HW_HDMI_FC_INVBLANK(x).U = (v))
#define HW_HDMI_FC_INVBLANK_SET(x, v) (HW_HDMI_FC_INVBLANK_WR(x, HW_HDMI_FC_INVBLANK_RD(x) |  (v)))
#define HW_HDMI_FC_INVBLANK_CLR(x, v) (HW_HDMI_FC_INVBLANK_WR(x, HW_HDMI_FC_INVBLANK_RD(x) & ~(v)))
#define HW_HDMI_FC_INVBLANK_TOG(x, v) (HW_HDMI_FC_INVBLANK_WR(x, HW_HDMI_FC_INVBLANK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INVBLANK bitfields
 */

/*!
 * @name Register HDMI_FC_INVBLANK, field V_in_blank[7:0] (RW)
 *
 * Input video Vertical blanking pixel region width. Number of Vertical blanking
 * lines [0...255]. Value after Reset: 0x00
 */
/*@{*/
#define BP_HDMI_FC_INVBLANK_V_in_blank (0U) /*!< Bit position for HDMI_FC_INVBLANK_V_in_blank. */
#define BM_HDMI_FC_INVBLANK_V_in_blank (0xFFU) /*!< Bit mask for HDMI_FC_INVBLANK_V_in_blank. */
#define BS_HDMI_FC_INVBLANK_V_in_blank (8U) /*!< Bit field size in bits for HDMI_FC_INVBLANK_V_in_blank. */

/*! @brief Read current value of the HDMI_FC_INVBLANK_V_in_blank field. */
#define BR_HDMI_FC_INVBLANK_V_in_blank(x) (HW_HDMI_FC_INVBLANK(x).U)

/*! @brief Format value for bitfield HDMI_FC_INVBLANK_V_in_blank. */
#define BF_HDMI_FC_INVBLANK_V_in_blank(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INVBLANK_V_in_blank) & BM_HDMI_FC_INVBLANK_V_in_blank)

/*! @brief Set the V_in_blank field to a new value. */
#define BW_HDMI_FC_INVBLANK_V_in_blank(x, v) (HW_HDMI_FC_INVBLANK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_HSYNCINDELAY0 - Frame Composer Input Video HSync Front Porch Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_HSYNCINDELAY0 - Frame Composer Input Video HSync Front Porch Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1008 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_hsyncindelay0
{
    uint8_t U;
    struct _hw_hdmi_fc_hsyncindelay0_bitfields
    {
        uint8_t H_in_delay : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_hsyncindelay0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_HSYNCINDELAY0 register
 */
/*@{*/
#define HW_HDMI_FC_HSYNCINDELAY0_ADDR(x) ((uintptr_t)(x) + 0x1008U)

#define HW_HDMI_FC_HSYNCINDELAY0(x) (*(__IO hw_hdmi_fc_hsyncindelay0_t *) HW_HDMI_FC_HSYNCINDELAY0_ADDR(x))
#define HW_HDMI_FC_HSYNCINDELAY0_RD(x) (HW_HDMI_FC_HSYNCINDELAY0(x).U)
#define HW_HDMI_FC_HSYNCINDELAY0_WR(x, v) (HW_HDMI_FC_HSYNCINDELAY0(x).U = (v))
#define HW_HDMI_FC_HSYNCINDELAY0_SET(x, v) (HW_HDMI_FC_HSYNCINDELAY0_WR(x, HW_HDMI_FC_HSYNCINDELAY0_RD(x) |  (v)))
#define HW_HDMI_FC_HSYNCINDELAY0_CLR(x, v) (HW_HDMI_FC_HSYNCINDELAY0_WR(x, HW_HDMI_FC_HSYNCINDELAY0_RD(x) & ~(v)))
#define HW_HDMI_FC_HSYNCINDELAY0_TOG(x, v) (HW_HDMI_FC_HSYNCINDELAY0_WR(x, HW_HDMI_FC_HSYNCINDELAY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_HSYNCINDELAY0 bitfields
 */

/*!
 * @name Register HDMI_FC_HSYNCINDELAY0, field H_in_delay[7:0] (RW)
 *
 * Input video Hsync active edge delay. Integer number of pixel clock cycles
 * from "de" non active edge of the last "de" valid period [0...4095].
 */
/*@{*/
#define BP_HDMI_FC_HSYNCINDELAY0_H_in_delay (0U) /*!< Bit position for HDMI_FC_HSYNCINDELAY0_H_in_delay. */
#define BM_HDMI_FC_HSYNCINDELAY0_H_in_delay (0xFFU) /*!< Bit mask for HDMI_FC_HSYNCINDELAY0_H_in_delay. */
#define BS_HDMI_FC_HSYNCINDELAY0_H_in_delay (8U) /*!< Bit field size in bits for HDMI_FC_HSYNCINDELAY0_H_in_delay. */

/*! @brief Read current value of the HDMI_FC_HSYNCINDELAY0_H_in_delay field. */
#define BR_HDMI_FC_HSYNCINDELAY0_H_in_delay(x) (HW_HDMI_FC_HSYNCINDELAY0(x).U)

/*! @brief Format value for bitfield HDMI_FC_HSYNCINDELAY0_H_in_delay. */
#define BF_HDMI_FC_HSYNCINDELAY0_H_in_delay(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_HSYNCINDELAY0_H_in_delay) & BM_HDMI_FC_HSYNCINDELAY0_H_in_delay)

/*! @brief Set the H_in_delay field to a new value. */
#define BW_HDMI_FC_HSYNCINDELAY0_H_in_delay(x, v) (HW_HDMI_FC_HSYNCINDELAY0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_HSYNCINDELAY1 - Frame Composer Input Video HSync Front Porch Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_HSYNCINDELAY1 - Frame Composer Input Video HSync Front Porch Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1009 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_hsyncindelay1
{
    uint8_t U;
    struct _hw_hdmi_fc_hsyncindelay1_bitfields
    {
        uint8_t H_in_delay : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_hsyncindelay1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_HSYNCINDELAY1 register
 */
/*@{*/
#define HW_HDMI_FC_HSYNCINDELAY1_ADDR(x) ((uintptr_t)(x) + 0x1009U)

#define HW_HDMI_FC_HSYNCINDELAY1(x) (*(__IO hw_hdmi_fc_hsyncindelay1_t *) HW_HDMI_FC_HSYNCINDELAY1_ADDR(x))
#define HW_HDMI_FC_HSYNCINDELAY1_RD(x) (HW_HDMI_FC_HSYNCINDELAY1(x).U)
#define HW_HDMI_FC_HSYNCINDELAY1_WR(x, v) (HW_HDMI_FC_HSYNCINDELAY1(x).U = (v))
#define HW_HDMI_FC_HSYNCINDELAY1_SET(x, v) (HW_HDMI_FC_HSYNCINDELAY1_WR(x, HW_HDMI_FC_HSYNCINDELAY1_RD(x) |  (v)))
#define HW_HDMI_FC_HSYNCINDELAY1_CLR(x, v) (HW_HDMI_FC_HSYNCINDELAY1_WR(x, HW_HDMI_FC_HSYNCINDELAY1_RD(x) & ~(v)))
#define HW_HDMI_FC_HSYNCINDELAY1_TOG(x, v) (HW_HDMI_FC_HSYNCINDELAY1_WR(x, HW_HDMI_FC_HSYNCINDELAY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_HSYNCINDELAY1 bitfields
 */

/*!
 * @name Register HDMI_FC_HSYNCINDELAY1, field H_in_delay[4:0] (RW)
 *
 * Input video Hsync active edge delay. Dependencies: Value after Reset: 0000b
 * the higher 5 bits of delay; Integer number of pixel clock cycles from "de" non
 * active edge of the last "de" valid period [0...8191].
 */
/*@{*/
#define BP_HDMI_FC_HSYNCINDELAY1_H_in_delay (0U) /*!< Bit position for HDMI_FC_HSYNCINDELAY1_H_in_delay. */
#define BM_HDMI_FC_HSYNCINDELAY1_H_in_delay (0x1FU) /*!< Bit mask for HDMI_FC_HSYNCINDELAY1_H_in_delay. */
#define BS_HDMI_FC_HSYNCINDELAY1_H_in_delay (5U) /*!< Bit field size in bits for HDMI_FC_HSYNCINDELAY1_H_in_delay. */

/*! @brief Read current value of the HDMI_FC_HSYNCINDELAY1_H_in_delay field. */
#define BR_HDMI_FC_HSYNCINDELAY1_H_in_delay(x) (HW_HDMI_FC_HSYNCINDELAY1(x).B.H_in_delay)

/*! @brief Format value for bitfield HDMI_FC_HSYNCINDELAY1_H_in_delay. */
#define BF_HDMI_FC_HSYNCINDELAY1_H_in_delay(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_HSYNCINDELAY1_H_in_delay) & BM_HDMI_FC_HSYNCINDELAY1_H_in_delay)

/*! @brief Set the H_in_delay field to a new value. */
#define BW_HDMI_FC_HSYNCINDELAY1_H_in_delay(x, v) (HW_HDMI_FC_HSYNCINDELAY1_WR(x, (HW_HDMI_FC_HSYNCINDELAY1_RD(x) & ~BM_HDMI_FC_HSYNCINDELAY1_H_in_delay) | BF_HDMI_FC_HSYNCINDELAY1_H_in_delay(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_HSYNCINWIDTH0 - Frame Composer Input Video HSync Width Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_HSYNCINWIDTH0 - Frame Composer Input Video HSync Width Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100A Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_hsyncinwidth0
{
    uint8_t U;
    struct _hw_hdmi_fc_hsyncinwidth0_bitfields
    {
        uint8_t H_in_width : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_hsyncinwidth0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_HSYNCINWIDTH0 register
 */
/*@{*/
#define HW_HDMI_FC_HSYNCINWIDTH0_ADDR(x) ((uintptr_t)(x) + 0x100AU)

#define HW_HDMI_FC_HSYNCINWIDTH0(x) (*(__IO hw_hdmi_fc_hsyncinwidth0_t *) HW_HDMI_FC_HSYNCINWIDTH0_ADDR(x))
#define HW_HDMI_FC_HSYNCINWIDTH0_RD(x) (HW_HDMI_FC_HSYNCINWIDTH0(x).U)
#define HW_HDMI_FC_HSYNCINWIDTH0_WR(x, v) (HW_HDMI_FC_HSYNCINWIDTH0(x).U = (v))
#define HW_HDMI_FC_HSYNCINWIDTH0_SET(x, v) (HW_HDMI_FC_HSYNCINWIDTH0_WR(x, HW_HDMI_FC_HSYNCINWIDTH0_RD(x) |  (v)))
#define HW_HDMI_FC_HSYNCINWIDTH0_CLR(x, v) (HW_HDMI_FC_HSYNCINWIDTH0_WR(x, HW_HDMI_FC_HSYNCINWIDTH0_RD(x) & ~(v)))
#define HW_HDMI_FC_HSYNCINWIDTH0_TOG(x, v) (HW_HDMI_FC_HSYNCINWIDTH0_WR(x, HW_HDMI_FC_HSYNCINWIDTH0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_HSYNCINWIDTH0 bitfields
 */

/*!
 * @name Register HDMI_FC_HSYNCINWIDTH0, field H_in_width[7:0] (RW)
 *
 * Input video Hsync active pulse width. Integer number of pixel clock cycles
 * [0...511].
 */
/*@{*/
#define BP_HDMI_FC_HSYNCINWIDTH0_H_in_width (0U) /*!< Bit position for HDMI_FC_HSYNCINWIDTH0_H_in_width. */
#define BM_HDMI_FC_HSYNCINWIDTH0_H_in_width (0xFFU) /*!< Bit mask for HDMI_FC_HSYNCINWIDTH0_H_in_width. */
#define BS_HDMI_FC_HSYNCINWIDTH0_H_in_width (8U) /*!< Bit field size in bits for HDMI_FC_HSYNCINWIDTH0_H_in_width. */

/*! @brief Read current value of the HDMI_FC_HSYNCINWIDTH0_H_in_width field. */
#define BR_HDMI_FC_HSYNCINWIDTH0_H_in_width(x) (HW_HDMI_FC_HSYNCINWIDTH0(x).U)

/*! @brief Format value for bitfield HDMI_FC_HSYNCINWIDTH0_H_in_width. */
#define BF_HDMI_FC_HSYNCINWIDTH0_H_in_width(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_HSYNCINWIDTH0_H_in_width) & BM_HDMI_FC_HSYNCINWIDTH0_H_in_width)

/*! @brief Set the H_in_width field to a new value. */
#define BW_HDMI_FC_HSYNCINWIDTH0_H_in_width(x, v) (HW_HDMI_FC_HSYNCINWIDTH0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_HSYNCINWIDTH1 - Frame Composer Input Video HSync Width Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_HSYNCINWIDTH1 - Frame Composer Input Video HSync Width Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100B Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_hsyncinwidth1
{
    uint8_t U;
    struct _hw_hdmi_fc_hsyncinwidth1_bitfields
    {
        uint8_t H_in_width : 2;        /*!< [1:0]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_fc_hsyncinwidth1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_HSYNCINWIDTH1 register
 */
/*@{*/
#define HW_HDMI_FC_HSYNCINWIDTH1_ADDR(x) ((uintptr_t)(x) + 0x100BU)

#define HW_HDMI_FC_HSYNCINWIDTH1(x) (*(__IO hw_hdmi_fc_hsyncinwidth1_t *) HW_HDMI_FC_HSYNCINWIDTH1_ADDR(x))
#define HW_HDMI_FC_HSYNCINWIDTH1_RD(x) (HW_HDMI_FC_HSYNCINWIDTH1(x).U)
#define HW_HDMI_FC_HSYNCINWIDTH1_WR(x, v) (HW_HDMI_FC_HSYNCINWIDTH1(x).U = (v))
#define HW_HDMI_FC_HSYNCINWIDTH1_SET(x, v) (HW_HDMI_FC_HSYNCINWIDTH1_WR(x, HW_HDMI_FC_HSYNCINWIDTH1_RD(x) |  (v)))
#define HW_HDMI_FC_HSYNCINWIDTH1_CLR(x, v) (HW_HDMI_FC_HSYNCINWIDTH1_WR(x, HW_HDMI_FC_HSYNCINWIDTH1_RD(x) & ~(v)))
#define HW_HDMI_FC_HSYNCINWIDTH1_TOG(x, v) (HW_HDMI_FC_HSYNCINWIDTH1_WR(x, HW_HDMI_FC_HSYNCINWIDTH1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_HSYNCINWIDTH1 bitfields
 */

/*!
 * @name Register HDMI_FC_HSYNCINWIDTH1, field H_in_width[1:0] (RW)
 *
 * Input video Hsync active pulse width. Dependencies: Value after Reset after
 * Reset: 0b Integer number of pixel clock cycles [0...1024].
 */
/*@{*/
#define BP_HDMI_FC_HSYNCINWIDTH1_H_in_width (0U) /*!< Bit position for HDMI_FC_HSYNCINWIDTH1_H_in_width. */
#define BM_HDMI_FC_HSYNCINWIDTH1_H_in_width (0x03U) /*!< Bit mask for HDMI_FC_HSYNCINWIDTH1_H_in_width. */
#define BS_HDMI_FC_HSYNCINWIDTH1_H_in_width (2U) /*!< Bit field size in bits for HDMI_FC_HSYNCINWIDTH1_H_in_width. */

/*! @brief Read current value of the HDMI_FC_HSYNCINWIDTH1_H_in_width field. */
#define BR_HDMI_FC_HSYNCINWIDTH1_H_in_width(x) (HW_HDMI_FC_HSYNCINWIDTH1(x).B.H_in_width)

/*! @brief Format value for bitfield HDMI_FC_HSYNCINWIDTH1_H_in_width. */
#define BF_HDMI_FC_HSYNCINWIDTH1_H_in_width(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_HSYNCINWIDTH1_H_in_width) & BM_HDMI_FC_HSYNCINWIDTH1_H_in_width)

/*! @brief Set the H_in_width field to a new value. */
#define BW_HDMI_FC_HSYNCINWIDTH1_H_in_width(x, v) (HW_HDMI_FC_HSYNCINWIDTH1_WR(x, (HW_HDMI_FC_HSYNCINWIDTH1_RD(x) & ~BM_HDMI_FC_HSYNCINWIDTH1_H_in_width) | BF_HDMI_FC_HSYNCINWIDTH1_H_in_width(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_VSYNCINDELAY - Frame Composer Input Video VSync Front Porch Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSYNCINDELAY - Frame Composer Input Video VSync Front Porch Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100C Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsyncindelay
{
    uint8_t U;
    struct _hw_hdmi_fc_vsyncindelay_bitfields
    {
        uint8_t V_in_delay : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsyncindelay_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSYNCINDELAY register
 */
/*@{*/
#define HW_HDMI_FC_VSYNCINDELAY_ADDR(x) ((uintptr_t)(x) + 0x100CU)

#define HW_HDMI_FC_VSYNCINDELAY(x) (*(__IO hw_hdmi_fc_vsyncindelay_t *) HW_HDMI_FC_VSYNCINDELAY_ADDR(x))
#define HW_HDMI_FC_VSYNCINDELAY_RD(x) (HW_HDMI_FC_VSYNCINDELAY(x).U)
#define HW_HDMI_FC_VSYNCINDELAY_WR(x, v) (HW_HDMI_FC_VSYNCINDELAY(x).U = (v))
#define HW_HDMI_FC_VSYNCINDELAY_SET(x, v) (HW_HDMI_FC_VSYNCINDELAY_WR(x, HW_HDMI_FC_VSYNCINDELAY_RD(x) |  (v)))
#define HW_HDMI_FC_VSYNCINDELAY_CLR(x, v) (HW_HDMI_FC_VSYNCINDELAY_WR(x, HW_HDMI_FC_VSYNCINDELAY_RD(x) & ~(v)))
#define HW_HDMI_FC_VSYNCINDELAY_TOG(x, v) (HW_HDMI_FC_VSYNCINDELAY_WR(x, HW_HDMI_FC_VSYNCINDELAY_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSYNCINDELAY bitfields
 */

/*!
 * @name Register HDMI_FC_VSYNCINDELAY, field V_in_delay[7:0] (RW)
 *
 * Input video Vsync active edge delay. Integer number of Hsync pulses from "de"
 * non active edge of the last "de" valid period. [0...255].
 */
/*@{*/
#define BP_HDMI_FC_VSYNCINDELAY_V_in_delay (0U) /*!< Bit position for HDMI_FC_VSYNCINDELAY_V_in_delay. */
#define BM_HDMI_FC_VSYNCINDELAY_V_in_delay (0xFFU) /*!< Bit mask for HDMI_FC_VSYNCINDELAY_V_in_delay. */
#define BS_HDMI_FC_VSYNCINDELAY_V_in_delay (8U) /*!< Bit field size in bits for HDMI_FC_VSYNCINDELAY_V_in_delay. */

/*! @brief Read current value of the HDMI_FC_VSYNCINDELAY_V_in_delay field. */
#define BR_HDMI_FC_VSYNCINDELAY_V_in_delay(x) (HW_HDMI_FC_VSYNCINDELAY(x).U)

/*! @brief Format value for bitfield HDMI_FC_VSYNCINDELAY_V_in_delay. */
#define BF_HDMI_FC_VSYNCINDELAY_V_in_delay(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_VSYNCINDELAY_V_in_delay) & BM_HDMI_FC_VSYNCINDELAY_V_in_delay)

/*! @brief Set the V_in_delay field to a new value. */
#define BW_HDMI_FC_VSYNCINDELAY_V_in_delay(x, v) (HW_HDMI_FC_VSYNCINDELAY_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_VSYNCINWIDTH - Frame Composer Input Video VSync Width Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSYNCINWIDTH - Frame Composer Input Video VSync Width Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100D Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsyncinwidth
{
    uint8_t U;
    struct _hw_hdmi_fc_vsyncinwidth_bitfields
    {
        uint8_t V_in_width : 6;        /*!< [5:0]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_fc_vsyncinwidth_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSYNCINWIDTH register
 */
/*@{*/
#define HW_HDMI_FC_VSYNCINWIDTH_ADDR(x) ((uintptr_t)(x) + 0x100DU)

#define HW_HDMI_FC_VSYNCINWIDTH(x) (*(__IO hw_hdmi_fc_vsyncinwidth_t *) HW_HDMI_FC_VSYNCINWIDTH_ADDR(x))
#define HW_HDMI_FC_VSYNCINWIDTH_RD(x) (HW_HDMI_FC_VSYNCINWIDTH(x).U)
#define HW_HDMI_FC_VSYNCINWIDTH_WR(x, v) (HW_HDMI_FC_VSYNCINWIDTH(x).U = (v))
#define HW_HDMI_FC_VSYNCINWIDTH_SET(x, v) (HW_HDMI_FC_VSYNCINWIDTH_WR(x, HW_HDMI_FC_VSYNCINWIDTH_RD(x) |  (v)))
#define HW_HDMI_FC_VSYNCINWIDTH_CLR(x, v) (HW_HDMI_FC_VSYNCINWIDTH_WR(x, HW_HDMI_FC_VSYNCINWIDTH_RD(x) & ~(v)))
#define HW_HDMI_FC_VSYNCINWIDTH_TOG(x, v) (HW_HDMI_FC_VSYNCINWIDTH_WR(x, HW_HDMI_FC_VSYNCINWIDTH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSYNCINWIDTH bitfields
 */

/*!
 * @name Register HDMI_FC_VSYNCINWIDTH, field V_in_width[5:0] (RW)
 *
 * Value after Reset: 000000b Input video Vsync active pulse width: Integer
 * number of pixel clock cycles [0...63].
 */
/*@{*/
#define BP_HDMI_FC_VSYNCINWIDTH_V_in_width (0U) /*!< Bit position for HDMI_FC_VSYNCINWIDTH_V_in_width. */
#define BM_HDMI_FC_VSYNCINWIDTH_V_in_width (0x3FU) /*!< Bit mask for HDMI_FC_VSYNCINWIDTH_V_in_width. */
#define BS_HDMI_FC_VSYNCINWIDTH_V_in_width (6U) /*!< Bit field size in bits for HDMI_FC_VSYNCINWIDTH_V_in_width. */

/*! @brief Read current value of the HDMI_FC_VSYNCINWIDTH_V_in_width field. */
#define BR_HDMI_FC_VSYNCINWIDTH_V_in_width(x) (HW_HDMI_FC_VSYNCINWIDTH(x).B.V_in_width)

/*! @brief Format value for bitfield HDMI_FC_VSYNCINWIDTH_V_in_width. */
#define BF_HDMI_FC_VSYNCINWIDTH_V_in_width(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_VSYNCINWIDTH_V_in_width) & BM_HDMI_FC_VSYNCINWIDTH_V_in_width)

/*! @brief Set the V_in_width field to a new value. */
#define BW_HDMI_FC_VSYNCINWIDTH_V_in_width(x, v) (HW_HDMI_FC_VSYNCINWIDTH_WR(x, (HW_HDMI_FC_VSYNCINWIDTH_RD(x) & ~BM_HDMI_FC_VSYNCINWIDTH_V_in_width) | BF_HDMI_FC_VSYNCINWIDTH_V_in_width(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INFREQ0 - Frame Composer Input Video Refresh Rate Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INFREQ0 - Frame Composer Input Video Refresh Rate Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100E Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_infreq0
{
    uint8_t U;
    struct _hw_hdmi_fc_infreq0_bitfields
    {
        uint8_t infreq : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_fc_infreq0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INFREQ0 register
 */
/*@{*/
#define HW_HDMI_FC_INFREQ0_ADDR(x) ((uintptr_t)(x) + 0x100EU)

#define HW_HDMI_FC_INFREQ0(x)    (*(__IO hw_hdmi_fc_infreq0_t *) HW_HDMI_FC_INFREQ0_ADDR(x))
#define HW_HDMI_FC_INFREQ0_RD(x) (HW_HDMI_FC_INFREQ0(x).U)
#define HW_HDMI_FC_INFREQ0_WR(x, v) (HW_HDMI_FC_INFREQ0(x).U = (v))
#define HW_HDMI_FC_INFREQ0_SET(x, v) (HW_HDMI_FC_INFREQ0_WR(x, HW_HDMI_FC_INFREQ0_RD(x) |  (v)))
#define HW_HDMI_FC_INFREQ0_CLR(x, v) (HW_HDMI_FC_INFREQ0_WR(x, HW_HDMI_FC_INFREQ0_RD(x) & ~(v)))
#define HW_HDMI_FC_INFREQ0_TOG(x, v) (HW_HDMI_FC_INFREQ0_WR(x, HW_HDMI_FC_INFREQ0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INFREQ0 bitfields
 */

/*!
 * @name Register HDMI_FC_INFREQ0, field infreq[7:0] (RW)
 *
 * Video refresh rate in Hz*1E3 format. This registers are provided for debug
 * and informative purposes. No data is written to this registers by the H13TCTRL
 * and the data here written by software is not used in any way by the H13TCTRL.
 */
/*@{*/
#define BP_HDMI_FC_INFREQ0_infreq (0U)     /*!< Bit position for HDMI_FC_INFREQ0_infreq. */
#define BM_HDMI_FC_INFREQ0_infreq (0xFFU)  /*!< Bit mask for HDMI_FC_INFREQ0_infreq. */
#define BS_HDMI_FC_INFREQ0_infreq (8U)     /*!< Bit field size in bits for HDMI_FC_INFREQ0_infreq. */

/*! @brief Read current value of the HDMI_FC_INFREQ0_infreq field. */
#define BR_HDMI_FC_INFREQ0_infreq(x) (HW_HDMI_FC_INFREQ0(x).U)

/*! @brief Format value for bitfield HDMI_FC_INFREQ0_infreq. */
#define BF_HDMI_FC_INFREQ0_infreq(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INFREQ0_infreq) & BM_HDMI_FC_INFREQ0_infreq)

/*! @brief Set the infreq field to a new value. */
#define BW_HDMI_FC_INFREQ0_infreq(x, v) (HW_HDMI_FC_INFREQ0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INFREQ1 - Frame Composer Input Video Refresh Rate Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INFREQ1 - Frame Composer Input Video Refresh Rate Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x100F Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_infreq1
{
    uint8_t U;
    struct _hw_hdmi_fc_infreq1_bitfields
    {
        uint8_t infreq : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_fc_infreq1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INFREQ1 register
 */
/*@{*/
#define HW_HDMI_FC_INFREQ1_ADDR(x) ((uintptr_t)(x) + 0x100FU)

#define HW_HDMI_FC_INFREQ1(x)    (*(__IO hw_hdmi_fc_infreq1_t *) HW_HDMI_FC_INFREQ1_ADDR(x))
#define HW_HDMI_FC_INFREQ1_RD(x) (HW_HDMI_FC_INFREQ1(x).U)
#define HW_HDMI_FC_INFREQ1_WR(x, v) (HW_HDMI_FC_INFREQ1(x).U = (v))
#define HW_HDMI_FC_INFREQ1_SET(x, v) (HW_HDMI_FC_INFREQ1_WR(x, HW_HDMI_FC_INFREQ1_RD(x) |  (v)))
#define HW_HDMI_FC_INFREQ1_CLR(x, v) (HW_HDMI_FC_INFREQ1_WR(x, HW_HDMI_FC_INFREQ1_RD(x) & ~(v)))
#define HW_HDMI_FC_INFREQ1_TOG(x, v) (HW_HDMI_FC_INFREQ1_WR(x, HW_HDMI_FC_INFREQ1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INFREQ1 bitfields
 */

/*!
 * @name Register HDMI_FC_INFREQ1, field infreq[7:0] (RW)
 *
 * Video refresh rate in Hz*1E3 format. This registers are provided for debug
 * and informative purposes. No data is written to this registers by the H13TCTRL
 * and the data here written by software is not used in any way by the H13TCTRL.
 */
/*@{*/
#define BP_HDMI_FC_INFREQ1_infreq (0U)     /*!< Bit position for HDMI_FC_INFREQ1_infreq. */
#define BM_HDMI_FC_INFREQ1_infreq (0xFFU)  /*!< Bit mask for HDMI_FC_INFREQ1_infreq. */
#define BS_HDMI_FC_INFREQ1_infreq (8U)     /*!< Bit field size in bits for HDMI_FC_INFREQ1_infreq. */

/*! @brief Read current value of the HDMI_FC_INFREQ1_infreq field. */
#define BR_HDMI_FC_INFREQ1_infreq(x) (HW_HDMI_FC_INFREQ1(x).U)

/*! @brief Format value for bitfield HDMI_FC_INFREQ1_infreq. */
#define BF_HDMI_FC_INFREQ1_infreq(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INFREQ1_infreq) & BM_HDMI_FC_INFREQ1_infreq)

/*! @brief Set the infreq field to a new value. */
#define BW_HDMI_FC_INFREQ1_infreq(x, v) (HW_HDMI_FC_INFREQ1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INFREQ2 - Frame Composer Input Video Refresh Rate Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INFREQ2 - Frame Composer Input Video Refresh Rate Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1010 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_infreq2
{
    uint8_t U;
    struct _hw_hdmi_fc_infreq2_bitfields
    {
        uint8_t infreq : 4;            /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_infreq2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INFREQ2 register
 */
/*@{*/
#define HW_HDMI_FC_INFREQ2_ADDR(x) ((uintptr_t)(x) + 0x1010U)

#define HW_HDMI_FC_INFREQ2(x)    (*(__IO hw_hdmi_fc_infreq2_t *) HW_HDMI_FC_INFREQ2_ADDR(x))
#define HW_HDMI_FC_INFREQ2_RD(x) (HW_HDMI_FC_INFREQ2(x).U)
#define HW_HDMI_FC_INFREQ2_WR(x, v) (HW_HDMI_FC_INFREQ2(x).U = (v))
#define HW_HDMI_FC_INFREQ2_SET(x, v) (HW_HDMI_FC_INFREQ2_WR(x, HW_HDMI_FC_INFREQ2_RD(x) |  (v)))
#define HW_HDMI_FC_INFREQ2_CLR(x, v) (HW_HDMI_FC_INFREQ2_WR(x, HW_HDMI_FC_INFREQ2_RD(x) & ~(v)))
#define HW_HDMI_FC_INFREQ2_TOG(x, v) (HW_HDMI_FC_INFREQ2_WR(x, HW_HDMI_FC_INFREQ2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INFREQ2 bitfields
 */

/*!
 * @name Register HDMI_FC_INFREQ2, field infreq[3:0] (RW)
 *
 * Video refresh rate in Hz*1E3 format. This registers are provided for debug
 * and informative purposes. No data is written to this registers by the H13TCTRL
 * and the data here written by software is not used in any way by the H13TCTRL.
 * Value after Reset: 0000b
 */
/*@{*/
#define BP_HDMI_FC_INFREQ2_infreq (0U)     /*!< Bit position for HDMI_FC_INFREQ2_infreq. */
#define BM_HDMI_FC_INFREQ2_infreq (0x0FU)  /*!< Bit mask for HDMI_FC_INFREQ2_infreq. */
#define BS_HDMI_FC_INFREQ2_infreq (4U)     /*!< Bit field size in bits for HDMI_FC_INFREQ2_infreq. */

/*! @brief Read current value of the HDMI_FC_INFREQ2_infreq field. */
#define BR_HDMI_FC_INFREQ2_infreq(x) (HW_HDMI_FC_INFREQ2(x).B.infreq)

/*! @brief Format value for bitfield HDMI_FC_INFREQ2_infreq. */
#define BF_HDMI_FC_INFREQ2_infreq(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INFREQ2_infreq) & BM_HDMI_FC_INFREQ2_infreq)

/*! @brief Set the infreq field to a new value. */
#define BW_HDMI_FC_INFREQ2_infreq(x, v) (HW_HDMI_FC_INFREQ2_WR(x, (HW_HDMI_FC_INFREQ2_RD(x) & ~BM_HDMI_FC_INFREQ2_infreq) | BF_HDMI_FC_INFREQ2_infreq(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CTRLDUR - Frame Composer Control Period Duration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CTRLDUR - Frame Composer Control Period Duration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1011 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_ctrldur
{
    uint8_t U;
    struct _hw_hdmi_fc_ctrldur_bitfields
    {
        uint8_t ctrlperiodduration : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_ctrldur_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CTRLDUR register
 */
/*@{*/
#define HW_HDMI_FC_CTRLDUR_ADDR(x) ((uintptr_t)(x) + 0x1011U)

#define HW_HDMI_FC_CTRLDUR(x)    (*(__IO hw_hdmi_fc_ctrldur_t *) HW_HDMI_FC_CTRLDUR_ADDR(x))
#define HW_HDMI_FC_CTRLDUR_RD(x) (HW_HDMI_FC_CTRLDUR(x).U)
#define HW_HDMI_FC_CTRLDUR_WR(x, v) (HW_HDMI_FC_CTRLDUR(x).U = (v))
#define HW_HDMI_FC_CTRLDUR_SET(x, v) (HW_HDMI_FC_CTRLDUR_WR(x, HW_HDMI_FC_CTRLDUR_RD(x) |  (v)))
#define HW_HDMI_FC_CTRLDUR_CLR(x, v) (HW_HDMI_FC_CTRLDUR_WR(x, HW_HDMI_FC_CTRLDUR_RD(x) & ~(v)))
#define HW_HDMI_FC_CTRLDUR_TOG(x, v) (HW_HDMI_FC_CTRLDUR_WR(x, HW_HDMI_FC_CTRLDUR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CTRLDUR bitfields
 */

/*!
 * @name Register HDMI_FC_CTRLDUR, field ctrlperiodduration[7:0] (RW)
 *
 * Configuration of the control period minimum duration (min. of 12 pixel clock
 * cycles, refer to HDMI 1.4a specification). Integer number of pixel clocks
 * cycles [0..255].
 */
/*@{*/
#define BP_HDMI_FC_CTRLDUR_ctrlperiodduration (0U) /*!< Bit position for HDMI_FC_CTRLDUR_ctrlperiodduration. */
#define BM_HDMI_FC_CTRLDUR_ctrlperiodduration (0xFFU) /*!< Bit mask for HDMI_FC_CTRLDUR_ctrlperiodduration. */
#define BS_HDMI_FC_CTRLDUR_ctrlperiodduration (8U) /*!< Bit field size in bits for HDMI_FC_CTRLDUR_ctrlperiodduration. */

/*! @brief Read current value of the HDMI_FC_CTRLDUR_ctrlperiodduration field. */
#define BR_HDMI_FC_CTRLDUR_ctrlperiodduration(x) (HW_HDMI_FC_CTRLDUR(x).U)

/*! @brief Format value for bitfield HDMI_FC_CTRLDUR_ctrlperiodduration. */
#define BF_HDMI_FC_CTRLDUR_ctrlperiodduration(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CTRLDUR_ctrlperiodduration) & BM_HDMI_FC_CTRLDUR_ctrlperiodduration)

/*! @brief Set the ctrlperiodduration field to a new value. */
#define BW_HDMI_FC_CTRLDUR_ctrlperiodduration(x, v) (HW_HDMI_FC_CTRLDUR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_EXCTRLDUR - Frame Composer Extended Control Period Duration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_EXCTRLDUR - Frame Composer Extended Control Period Duration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1012 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_exctrldur
{
    uint8_t U;
    struct _hw_hdmi_fc_exctrldur_bitfields
    {
        uint8_t exctrlperiodduration : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_exctrldur_t;

/*!
 * @name Constants and macros for entire HDMI_FC_EXCTRLDUR register
 */
/*@{*/
#define HW_HDMI_FC_EXCTRLDUR_ADDR(x) ((uintptr_t)(x) + 0x1012U)

#define HW_HDMI_FC_EXCTRLDUR(x)  (*(__IO hw_hdmi_fc_exctrldur_t *) HW_HDMI_FC_EXCTRLDUR_ADDR(x))
#define HW_HDMI_FC_EXCTRLDUR_RD(x) (HW_HDMI_FC_EXCTRLDUR(x).U)
#define HW_HDMI_FC_EXCTRLDUR_WR(x, v) (HW_HDMI_FC_EXCTRLDUR(x).U = (v))
#define HW_HDMI_FC_EXCTRLDUR_SET(x, v) (HW_HDMI_FC_EXCTRLDUR_WR(x, HW_HDMI_FC_EXCTRLDUR_RD(x) |  (v)))
#define HW_HDMI_FC_EXCTRLDUR_CLR(x, v) (HW_HDMI_FC_EXCTRLDUR_WR(x, HW_HDMI_FC_EXCTRLDUR_RD(x) & ~(v)))
#define HW_HDMI_FC_EXCTRLDUR_TOG(x, v) (HW_HDMI_FC_EXCTRLDUR_WR(x, HW_HDMI_FC_EXCTRLDUR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_EXCTRLDUR bitfields
 */

/*!
 * @name Register HDMI_FC_EXCTRLDUR, field exctrlperiodduration[7:0] (RW)
 *
 * Configuration of the extended control period minimum duration (min. of 32
 * pixel clock cycles, see HDMI 1.4a specification). Integer number of pixel clocks
 * cycles [0..255].
 */
/*@{*/
#define BP_HDMI_FC_EXCTRLDUR_exctrlperiodduration (0U) /*!< Bit position for HDMI_FC_EXCTRLDUR_exctrlperiodduration. */
#define BM_HDMI_FC_EXCTRLDUR_exctrlperiodduration (0xFFU) /*!< Bit mask for HDMI_FC_EXCTRLDUR_exctrlperiodduration. */
#define BS_HDMI_FC_EXCTRLDUR_exctrlperiodduration (8U) /*!< Bit field size in bits for HDMI_FC_EXCTRLDUR_exctrlperiodduration. */

/*! @brief Read current value of the HDMI_FC_EXCTRLDUR_exctrlperiodduration field. */
#define BR_HDMI_FC_EXCTRLDUR_exctrlperiodduration(x) (HW_HDMI_FC_EXCTRLDUR(x).U)

/*! @brief Format value for bitfield HDMI_FC_EXCTRLDUR_exctrlperiodduration. */
#define BF_HDMI_FC_EXCTRLDUR_exctrlperiodduration(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_EXCTRLDUR_exctrlperiodduration) & BM_HDMI_FC_EXCTRLDUR_exctrlperiodduration)

/*! @brief Set the exctrlperiodduration field to a new value. */
#define BW_HDMI_FC_EXCTRLDUR_exctrlperiodduration(x, v) (HW_HDMI_FC_EXCTRLDUR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_EXCTRLSPAC - Frame Composer Extended Control Period Maximum Spacing Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_EXCTRLSPAC - Frame Composer Extended Control Period Maximum Spacing Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1013 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_exctrlspac
{
    uint8_t U;
    struct _hw_hdmi_fc_exctrlspac_bitfields
    {
        uint8_t exctrlperiodspacing : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_exctrlspac_t;

/*!
 * @name Constants and macros for entire HDMI_FC_EXCTRLSPAC register
 */
/*@{*/
#define HW_HDMI_FC_EXCTRLSPAC_ADDR(x) ((uintptr_t)(x) + 0x1013U)

#define HW_HDMI_FC_EXCTRLSPAC(x) (*(__IO hw_hdmi_fc_exctrlspac_t *) HW_HDMI_FC_EXCTRLSPAC_ADDR(x))
#define HW_HDMI_FC_EXCTRLSPAC_RD(x) (HW_HDMI_FC_EXCTRLSPAC(x).U)
#define HW_HDMI_FC_EXCTRLSPAC_WR(x, v) (HW_HDMI_FC_EXCTRLSPAC(x).U = (v))
#define HW_HDMI_FC_EXCTRLSPAC_SET(x, v) (HW_HDMI_FC_EXCTRLSPAC_WR(x, HW_HDMI_FC_EXCTRLSPAC_RD(x) |  (v)))
#define HW_HDMI_FC_EXCTRLSPAC_CLR(x, v) (HW_HDMI_FC_EXCTRLSPAC_WR(x, HW_HDMI_FC_EXCTRLSPAC_RD(x) & ~(v)))
#define HW_HDMI_FC_EXCTRLSPAC_TOG(x, v) (HW_HDMI_FC_EXCTRLSPAC_WR(x, HW_HDMI_FC_EXCTRLSPAC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_EXCTRLSPAC bitfields
 */

/*!
 * @name Register HDMI_FC_EXCTRLSPAC, field exctrlperiodspacing[7:0] (RW)
 *
 * Configuration of the maximum spacing between consecutive extended control
 * periods (max of 50msec, see HDMI 1.4a specification): generated spacing = (1/freq
 * tmds clock)*256*256*extctrlperiodspacing
 */
/*@{*/
#define BP_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing (0U) /*!< Bit position for HDMI_FC_EXCTRLSPAC_exctrlperiodspacing. */
#define BM_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing (0xFFU) /*!< Bit mask for HDMI_FC_EXCTRLSPAC_exctrlperiodspacing. */
#define BS_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing (8U) /*!< Bit field size in bits for HDMI_FC_EXCTRLSPAC_exctrlperiodspacing. */

/*! @brief Read current value of the HDMI_FC_EXCTRLSPAC_exctrlperiodspacing field. */
#define BR_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing(x) (HW_HDMI_FC_EXCTRLSPAC(x).U)

/*! @brief Format value for bitfield HDMI_FC_EXCTRLSPAC_exctrlperiodspacing. */
#define BF_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing) & BM_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing)

/*! @brief Set the exctrlperiodspacing field to a new value. */
#define BW_HDMI_FC_EXCTRLSPAC_exctrlperiodspacing(x, v) (HW_HDMI_FC_EXCTRLSPAC_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CH0PREAM - Frame Composer Channel 0 Non-Preamble Data Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CH0PREAM - Frame Composer Channel 0 Non-Preamble Data Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1014 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_ch0pream
{
    uint8_t U;
    struct _hw_hdmi_fc_ch0pream_bitfields
    {
        uint8_t ch0_preamble_filter : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_ch0pream_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CH0PREAM register
 */
/*@{*/
#define HW_HDMI_FC_CH0PREAM_ADDR(x) ((uintptr_t)(x) + 0x1014U)

#define HW_HDMI_FC_CH0PREAM(x)   (*(__IO hw_hdmi_fc_ch0pream_t *) HW_HDMI_FC_CH0PREAM_ADDR(x))
#define HW_HDMI_FC_CH0PREAM_RD(x) (HW_HDMI_FC_CH0PREAM(x).U)
#define HW_HDMI_FC_CH0PREAM_WR(x, v) (HW_HDMI_FC_CH0PREAM(x).U = (v))
#define HW_HDMI_FC_CH0PREAM_SET(x, v) (HW_HDMI_FC_CH0PREAM_WR(x, HW_HDMI_FC_CH0PREAM_RD(x) |  (v)))
#define HW_HDMI_FC_CH0PREAM_CLR(x, v) (HW_HDMI_FC_CH0PREAM_WR(x, HW_HDMI_FC_CH0PREAM_RD(x) & ~(v)))
#define HW_HDMI_FC_CH0PREAM_TOG(x, v) (HW_HDMI_FC_CH0PREAM_WR(x, HW_HDMI_FC_CH0PREAM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CH0PREAM bitfields
 */

/*!
 * @name Register HDMI_FC_CH0PREAM, field ch0_preamble_filter[7:0] (RW)
 *
 * When in control mode, configures 8-bits that are going to fill the channel 0
 * data lines not used to transmit the preamble (for more clarifications refer to
 * HDMI 1.4a specification).
 */
/*@{*/
#define BP_HDMI_FC_CH0PREAM_ch0_preamble_filter (0U) /*!< Bit position for HDMI_FC_CH0PREAM_ch0_preamble_filter. */
#define BM_HDMI_FC_CH0PREAM_ch0_preamble_filter (0xFFU) /*!< Bit mask for HDMI_FC_CH0PREAM_ch0_preamble_filter. */
#define BS_HDMI_FC_CH0PREAM_ch0_preamble_filter (8U) /*!< Bit field size in bits for HDMI_FC_CH0PREAM_ch0_preamble_filter. */

/*! @brief Read current value of the HDMI_FC_CH0PREAM_ch0_preamble_filter field. */
#define BR_HDMI_FC_CH0PREAM_ch0_preamble_filter(x) (HW_HDMI_FC_CH0PREAM(x).U)

/*! @brief Format value for bitfield HDMI_FC_CH0PREAM_ch0_preamble_filter. */
#define BF_HDMI_FC_CH0PREAM_ch0_preamble_filter(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CH0PREAM_ch0_preamble_filter) & BM_HDMI_FC_CH0PREAM_ch0_preamble_filter)

/*! @brief Set the ch0_preamble_filter field to a new value. */
#define BW_HDMI_FC_CH0PREAM_ch0_preamble_filter(x, v) (HW_HDMI_FC_CH0PREAM_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CH1PREAM - Frame Composer Channel 1 Non-Preamble Data Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CH1PREAM - Frame Composer Channel 1 Non-Preamble Data Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1015 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_ch1pream
{
    uint8_t U;
    struct _hw_hdmi_fc_ch1pream_bitfields
    {
        uint8_t ch1_preamble_filter : 6; /*!< [5:0]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_fc_ch1pream_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CH1PREAM register
 */
/*@{*/
#define HW_HDMI_FC_CH1PREAM_ADDR(x) ((uintptr_t)(x) + 0x1015U)

#define HW_HDMI_FC_CH1PREAM(x)   (*(__IO hw_hdmi_fc_ch1pream_t *) HW_HDMI_FC_CH1PREAM_ADDR(x))
#define HW_HDMI_FC_CH1PREAM_RD(x) (HW_HDMI_FC_CH1PREAM(x).U)
#define HW_HDMI_FC_CH1PREAM_WR(x, v) (HW_HDMI_FC_CH1PREAM(x).U = (v))
#define HW_HDMI_FC_CH1PREAM_SET(x, v) (HW_HDMI_FC_CH1PREAM_WR(x, HW_HDMI_FC_CH1PREAM_RD(x) |  (v)))
#define HW_HDMI_FC_CH1PREAM_CLR(x, v) (HW_HDMI_FC_CH1PREAM_WR(x, HW_HDMI_FC_CH1PREAM_RD(x) & ~(v)))
#define HW_HDMI_FC_CH1PREAM_TOG(x, v) (HW_HDMI_FC_CH1PREAM_WR(x, HW_HDMI_FC_CH1PREAM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CH1PREAM bitfields
 */

/*!
 * @name Register HDMI_FC_CH1PREAM, field ch1_preamble_filter[5:0] (RW)
 *
 * When in control mode, configures 6-bits that are going to fill the channel 1
 * data lines not used to transmit the preamble (for more clarifications refer to
 * HDMI 1.4a specification).
 */
/*@{*/
#define BP_HDMI_FC_CH1PREAM_ch1_preamble_filter (0U) /*!< Bit position for HDMI_FC_CH1PREAM_ch1_preamble_filter. */
#define BM_HDMI_FC_CH1PREAM_ch1_preamble_filter (0x3FU) /*!< Bit mask for HDMI_FC_CH1PREAM_ch1_preamble_filter. */
#define BS_HDMI_FC_CH1PREAM_ch1_preamble_filter (6U) /*!< Bit field size in bits for HDMI_FC_CH1PREAM_ch1_preamble_filter. */

/*! @brief Read current value of the HDMI_FC_CH1PREAM_ch1_preamble_filter field. */
#define BR_HDMI_FC_CH1PREAM_ch1_preamble_filter(x) (HW_HDMI_FC_CH1PREAM(x).B.ch1_preamble_filter)

/*! @brief Format value for bitfield HDMI_FC_CH1PREAM_ch1_preamble_filter. */
#define BF_HDMI_FC_CH1PREAM_ch1_preamble_filter(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CH1PREAM_ch1_preamble_filter) & BM_HDMI_FC_CH1PREAM_ch1_preamble_filter)

/*! @brief Set the ch1_preamble_filter field to a new value. */
#define BW_HDMI_FC_CH1PREAM_ch1_preamble_filter(x, v) (HW_HDMI_FC_CH1PREAM_WR(x, (HW_HDMI_FC_CH1PREAM_RD(x) & ~BM_HDMI_FC_CH1PREAM_ch1_preamble_filter) | BF_HDMI_FC_CH1PREAM_ch1_preamble_filter(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CH2PREAM - Frame Composer Channel 2 Non-Preamble Data Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CH2PREAM - Frame Composer Channel 2 Non-Preamble Data Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1016 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_ch2pream
{
    uint8_t U;
    struct _hw_hdmi_fc_ch2pream_bitfields
    {
        uint8_t ch2_preamble_filter : 6; /*!< [5:0]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_fc_ch2pream_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CH2PREAM register
 */
/*@{*/
#define HW_HDMI_FC_CH2PREAM_ADDR(x) ((uintptr_t)(x) + 0x1016U)

#define HW_HDMI_FC_CH2PREAM(x)   (*(__IO hw_hdmi_fc_ch2pream_t *) HW_HDMI_FC_CH2PREAM_ADDR(x))
#define HW_HDMI_FC_CH2PREAM_RD(x) (HW_HDMI_FC_CH2PREAM(x).U)
#define HW_HDMI_FC_CH2PREAM_WR(x, v) (HW_HDMI_FC_CH2PREAM(x).U = (v))
#define HW_HDMI_FC_CH2PREAM_SET(x, v) (HW_HDMI_FC_CH2PREAM_WR(x, HW_HDMI_FC_CH2PREAM_RD(x) |  (v)))
#define HW_HDMI_FC_CH2PREAM_CLR(x, v) (HW_HDMI_FC_CH2PREAM_WR(x, HW_HDMI_FC_CH2PREAM_RD(x) & ~(v)))
#define HW_HDMI_FC_CH2PREAM_TOG(x, v) (HW_HDMI_FC_CH2PREAM_WR(x, HW_HDMI_FC_CH2PREAM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CH2PREAM bitfields
 */

/*!
 * @name Register HDMI_FC_CH2PREAM, field ch2_preamble_filter[5:0] (RW)
 *
 * When in control mode, configures 6-bits that are going to fill the channel 2
 * data lines not used to transmit the preamble (for more clarifications, see
 * HDMI 1.4a specification).
 */
/*@{*/
#define BP_HDMI_FC_CH2PREAM_ch2_preamble_filter (0U) /*!< Bit position for HDMI_FC_CH2PREAM_ch2_preamble_filter. */
#define BM_HDMI_FC_CH2PREAM_ch2_preamble_filter (0x3FU) /*!< Bit mask for HDMI_FC_CH2PREAM_ch2_preamble_filter. */
#define BS_HDMI_FC_CH2PREAM_ch2_preamble_filter (6U) /*!< Bit field size in bits for HDMI_FC_CH2PREAM_ch2_preamble_filter. */

/*! @brief Read current value of the HDMI_FC_CH2PREAM_ch2_preamble_filter field. */
#define BR_HDMI_FC_CH2PREAM_ch2_preamble_filter(x) (HW_HDMI_FC_CH2PREAM(x).B.ch2_preamble_filter)

/*! @brief Format value for bitfield HDMI_FC_CH2PREAM_ch2_preamble_filter. */
#define BF_HDMI_FC_CH2PREAM_ch2_preamble_filter(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CH2PREAM_ch2_preamble_filter) & BM_HDMI_FC_CH2PREAM_ch2_preamble_filter)

/*! @brief Set the ch2_preamble_filter field to a new value. */
#define BW_HDMI_FC_CH2PREAM_ch2_preamble_filter(x, v) (HW_HDMI_FC_CH2PREAM_WR(x, (HW_HDMI_FC_CH2PREAM_RD(x) & ~BM_HDMI_FC_CH2PREAM_ch2_preamble_filter) | BF_HDMI_FC_CH2PREAM_ch2_preamble_filter(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVICONF3 - Frame Composer AVI Configuration Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVICONF3 - Frame Composer AVI Configuration Register 3 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1017 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write configuration of Quantization range and IT content type.
 */
typedef union _hw_hdmi_fc_aviconf3
{
    uint8_t U;
    struct _hw_hdmi_fc_aviconf3_bitfields
    {
        uint8_t CN1_CN0 : 2;           /*!< [1:0]  */
        uint8_t YQ1_YQ0_YCC : 2;       /*!< [3:2]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_aviconf3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVICONF3 register
 */
/*@{*/
#define HW_HDMI_FC_AVICONF3_ADDR(x) ((uintptr_t)(x) + 0x1017U)

#define HW_HDMI_FC_AVICONF3(x)   (*(__IO hw_hdmi_fc_aviconf3_t *) HW_HDMI_FC_AVICONF3_ADDR(x))
#define HW_HDMI_FC_AVICONF3_RD(x) (HW_HDMI_FC_AVICONF3(x).U)
#define HW_HDMI_FC_AVICONF3_WR(x, v) (HW_HDMI_FC_AVICONF3(x).U = (v))
#define HW_HDMI_FC_AVICONF3_SET(x, v) (HW_HDMI_FC_AVICONF3_WR(x, HW_HDMI_FC_AVICONF3_RD(x) |  (v)))
#define HW_HDMI_FC_AVICONF3_CLR(x, v) (HW_HDMI_FC_AVICONF3_WR(x, HW_HDMI_FC_AVICONF3_RD(x) & ~(v)))
#define HW_HDMI_FC_AVICONF3_TOG(x, v) (HW_HDMI_FC_AVICONF3_WR(x, HW_HDMI_FC_AVICONF3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVICONF3 bitfields
 */

/*!
 * @name Register HDMI_FC_AVICONF3, field CN1_CN0[1:0] (RW)
 *
 * IT content type according to CEA specification
 */
/*@{*/
#define BP_HDMI_FC_AVICONF3_CN1_CN0 (0U)   /*!< Bit position for HDMI_FC_AVICONF3_CN1_CN0. */
#define BM_HDMI_FC_AVICONF3_CN1_CN0 (0x03U) /*!< Bit mask for HDMI_FC_AVICONF3_CN1_CN0. */
#define BS_HDMI_FC_AVICONF3_CN1_CN0 (2U)   /*!< Bit field size in bits for HDMI_FC_AVICONF3_CN1_CN0. */

/*! @brief Read current value of the HDMI_FC_AVICONF3_CN1_CN0 field. */
#define BR_HDMI_FC_AVICONF3_CN1_CN0(x) (HW_HDMI_FC_AVICONF3(x).B.CN1_CN0)

/*! @brief Format value for bitfield HDMI_FC_AVICONF3_CN1_CN0. */
#define BF_HDMI_FC_AVICONF3_CN1_CN0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF3_CN1_CN0) & BM_HDMI_FC_AVICONF3_CN1_CN0)

/*! @brief Set the CN1_CN0 field to a new value. */
#define BW_HDMI_FC_AVICONF3_CN1_CN0(x, v) (HW_HDMI_FC_AVICONF3_WR(x, (HW_HDMI_FC_AVICONF3_RD(x) & ~BM_HDMI_FC_AVICONF3_CN1_CN0) | BF_HDMI_FC_AVICONF3_CN1_CN0(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF3, field YQ1_YQ0_YCC[3:2] (RW)
 *
 * Quantization range according to CEA specification.
 */
/*@{*/
#define BP_HDMI_FC_AVICONF3_YQ1_YQ0_YCC (2U) /*!< Bit position for HDMI_FC_AVICONF3_YQ1_YQ0_YCC. */
#define BM_HDMI_FC_AVICONF3_YQ1_YQ0_YCC (0x0CU) /*!< Bit mask for HDMI_FC_AVICONF3_YQ1_YQ0_YCC. */
#define BS_HDMI_FC_AVICONF3_YQ1_YQ0_YCC (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF3_YQ1_YQ0_YCC. */

/*! @brief Read current value of the HDMI_FC_AVICONF3_YQ1_YQ0_YCC field. */
#define BR_HDMI_FC_AVICONF3_YQ1_YQ0_YCC(x) (HW_HDMI_FC_AVICONF3(x).B.YQ1_YQ0_YCC)

/*! @brief Format value for bitfield HDMI_FC_AVICONF3_YQ1_YQ0_YCC. */
#define BF_HDMI_FC_AVICONF3_YQ1_YQ0_YCC(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF3_YQ1_YQ0_YCC) & BM_HDMI_FC_AVICONF3_YQ1_YQ0_YCC)

/*! @brief Set the YQ1_YQ0_YCC field to a new value. */
#define BW_HDMI_FC_AVICONF3_YQ1_YQ0_YCC(x, v) (HW_HDMI_FC_AVICONF3_WR(x, (HW_HDMI_FC_AVICONF3_RD(x) & ~BM_HDMI_FC_AVICONF3_YQ1_YQ0_YCC) | BF_HDMI_FC_AVICONF3_YQ1_YQ0_YCC(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GCP - Frame Composer GCP Packet Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GCP - Frame Composer GCP Packet Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the General Control Packet A/V mute indicators and the default
 * phase. Address Offset: 0x1018 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_gcp
{
    uint8_t U;
    struct _hw_hdmi_fc_gcp_bitfields
    {
        uint8_t clear_avmute : 1;      /*!< [0]  */
        uint8_t set_avmute : 1;        /*!< [1]  */
        uint8_t default_phase : 1;     /*!< [2]  */
        uint8_t RESERVED0 : 5;         /*!< [7:3]  */
    } B;
} hw_hdmi_fc_gcp_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GCP register
 */
/*@{*/
#define HW_HDMI_FC_GCP_ADDR(x)   ((uintptr_t)(x) + 0x1018U)

#define HW_HDMI_FC_GCP(x)        (*(__IO hw_hdmi_fc_gcp_t *) HW_HDMI_FC_GCP_ADDR(x))
#define HW_HDMI_FC_GCP_RD(x)     (HW_HDMI_FC_GCP(x).U)
#define HW_HDMI_FC_GCP_WR(x, v)  (HW_HDMI_FC_GCP(x).U = (v))
#define HW_HDMI_FC_GCP_SET(x, v) (HW_HDMI_FC_GCP_WR(x, HW_HDMI_FC_GCP_RD(x) |  (v)))
#define HW_HDMI_FC_GCP_CLR(x, v) (HW_HDMI_FC_GCP_WR(x, HW_HDMI_FC_GCP_RD(x) & ~(v)))
#define HW_HDMI_FC_GCP_TOG(x, v) (HW_HDMI_FC_GCP_WR(x, HW_HDMI_FC_GCP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GCP bitfields
 */

/*!
 * @name Register HDMI_FC_GCP, field clear_avmute[0] (RW)
 *
 * Value of "clear_avmute" in the GCP packet. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_GCP_clear_avmute (0U)   /*!< Bit position for HDMI_FC_GCP_clear_avmute. */
#define BM_HDMI_FC_GCP_clear_avmute (0x01U) /*!< Bit mask for HDMI_FC_GCP_clear_avmute. */
#define BS_HDMI_FC_GCP_clear_avmute (1U)   /*!< Bit field size in bits for HDMI_FC_GCP_clear_avmute. */

/*! @brief Read current value of the HDMI_FC_GCP_clear_avmute field. */
#define BR_HDMI_FC_GCP_clear_avmute(x) (HW_HDMI_FC_GCP(x).B.clear_avmute)

/*! @brief Format value for bitfield HDMI_FC_GCP_clear_avmute. */
#define BF_HDMI_FC_GCP_clear_avmute(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GCP_clear_avmute) & BM_HDMI_FC_GCP_clear_avmute)

/*! @brief Set the clear_avmute field to a new value. */
#define BW_HDMI_FC_GCP_clear_avmute(x, v) (HW_HDMI_FC_GCP_WR(x, (HW_HDMI_FC_GCP_RD(x) & ~BM_HDMI_FC_GCP_clear_avmute) | BF_HDMI_FC_GCP_clear_avmute(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_GCP, field set_avmute[1] (RW)
 *
 * Value of "set_avmute" in the GCP packet. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_GCP_set_avmute (1U)     /*!< Bit position for HDMI_FC_GCP_set_avmute. */
#define BM_HDMI_FC_GCP_set_avmute (0x02U)  /*!< Bit mask for HDMI_FC_GCP_set_avmute. */
#define BS_HDMI_FC_GCP_set_avmute (1U)     /*!< Bit field size in bits for HDMI_FC_GCP_set_avmute. */

/*! @brief Read current value of the HDMI_FC_GCP_set_avmute field. */
#define BR_HDMI_FC_GCP_set_avmute(x) (HW_HDMI_FC_GCP(x).B.set_avmute)

/*! @brief Format value for bitfield HDMI_FC_GCP_set_avmute. */
#define BF_HDMI_FC_GCP_set_avmute(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GCP_set_avmute) & BM_HDMI_FC_GCP_set_avmute)

/*! @brief Set the set_avmute field to a new value. */
#define BW_HDMI_FC_GCP_set_avmute(x, v) (HW_HDMI_FC_GCP_WR(x, (HW_HDMI_FC_GCP_RD(x) & ~BM_HDMI_FC_GCP_set_avmute) | BF_HDMI_FC_GCP_set_avmute(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_GCP, field default_phase[2] (RW)
 *
 * Value of "default_phase" in the GCP packet. This data should be equal to the
 * default phase used at Video packetizer packing machine. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_GCP_default_phase (2U)  /*!< Bit position for HDMI_FC_GCP_default_phase. */
#define BM_HDMI_FC_GCP_default_phase (0x04U) /*!< Bit mask for HDMI_FC_GCP_default_phase. */
#define BS_HDMI_FC_GCP_default_phase (1U)  /*!< Bit field size in bits for HDMI_FC_GCP_default_phase. */

/*! @brief Read current value of the HDMI_FC_GCP_default_phase field. */
#define BR_HDMI_FC_GCP_default_phase(x) (HW_HDMI_FC_GCP(x).B.default_phase)

/*! @brief Format value for bitfield HDMI_FC_GCP_default_phase. */
#define BF_HDMI_FC_GCP_default_phase(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GCP_default_phase) & BM_HDMI_FC_GCP_default_phase)

/*! @brief Set the default_phase field to a new value. */
#define BW_HDMI_FC_GCP_default_phase(x, v) (HW_HDMI_FC_GCP_WR(x, (HW_HDMI_FC_GCP_RD(x) & ~BM_HDMI_FC_GCP_default_phase) | BF_HDMI_FC_GCP_default_phase(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVICONF0 - Frame Composer AVI Packet Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVICONF0 - Frame Composer AVI Packet Configuration Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the AVI infoFrame: RGB/YCC indication
 * Bar information Scan information Active format present Progressive/Interlaced
 * indicator Active aspect ratio Picture aspect ratio Colorimetry IT content
 * Extended colorimetry Quantization range Non-uniform picture scaling For more
 * information, refer to HDMI 1.4a and CEA - 861D specifications. Address Offset: 0x1019
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_aviconf0
{
    uint8_t U;
    struct _hw_hdmi_fc_aviconf0_bitfields
    {
        uint8_t FC_AVICONF0_RGB_YCC : 2; /*!< [1:0]  */
        uint8_t FC_AVICONF0_BAR : 2;   /*!< [3:2]  */
        uint8_t FC_AVICONF0_SCAN : 2;  /*!< [5:4]  */
        uint8_t FC_AVICONF0_ACTIVE_FORMAT : 1; /*!< [6]  */
        uint8_t FC_AVICONF0_MISC : 1;  /*!< [7]  */
    } B;
} hw_hdmi_fc_aviconf0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVICONF0 register
 */
/*@{*/
#define HW_HDMI_FC_AVICONF0_ADDR(x) ((uintptr_t)(x) + 0x1019U)

#define HW_HDMI_FC_AVICONF0(x)   (*(__IO hw_hdmi_fc_aviconf0_t *) HW_HDMI_FC_AVICONF0_ADDR(x))
#define HW_HDMI_FC_AVICONF0_RD(x) (HW_HDMI_FC_AVICONF0(x).U)
#define HW_HDMI_FC_AVICONF0_WR(x, v) (HW_HDMI_FC_AVICONF0(x).U = (v))
#define HW_HDMI_FC_AVICONF0_SET(x, v) (HW_HDMI_FC_AVICONF0_WR(x, HW_HDMI_FC_AVICONF0_RD(x) |  (v)))
#define HW_HDMI_FC_AVICONF0_CLR(x, v) (HW_HDMI_FC_AVICONF0_WR(x, HW_HDMI_FC_AVICONF0_RD(x) & ~(v)))
#define HW_HDMI_FC_AVICONF0_TOG(x, v) (HW_HDMI_FC_AVICONF0_WR(x, HW_HDMI_FC_AVICONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVICONF0 bitfields
 */

/*!
 * @name Register HDMI_FC_AVICONF0, field FC_AVICONF0_RGB_YCC[1:0] (RW)
 *
 * RGB/YCC indication Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC (0U) /*!< Bit position for HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC. */
#define BM_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC (0x03U) /*!< Bit mask for HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC. */
#define BS_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC. */

/*! @brief Read current value of the HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC field. */
#define BR_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC(x) (HW_HDMI_FC_AVICONF0(x).B.FC_AVICONF0_RGB_YCC)

/*! @brief Format value for bitfield HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC. */
#define BF_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC) & BM_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC)

/*! @brief Set the FC_AVICONF0_RGB_YCC field to a new value. */
#define BW_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC(x, v) (HW_HDMI_FC_AVICONF0_WR(x, (HW_HDMI_FC_AVICONF0_RD(x) & ~BM_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC) | BF_HDMI_FC_AVICONF0_FC_AVICONF0_RGB_YCC(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF0, field FC_AVICONF0_BAR[3:2] (RW)
 *
 * Bar information
 */
/*@{*/
#define BP_HDMI_FC_AVICONF0_FC_AVICONF0_BAR (2U) /*!< Bit position for HDMI_FC_AVICONF0_FC_AVICONF0_BAR. */
#define BM_HDMI_FC_AVICONF0_FC_AVICONF0_BAR (0x0CU) /*!< Bit mask for HDMI_FC_AVICONF0_FC_AVICONF0_BAR. */
#define BS_HDMI_FC_AVICONF0_FC_AVICONF0_BAR (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF0_FC_AVICONF0_BAR. */

/*! @brief Read current value of the HDMI_FC_AVICONF0_FC_AVICONF0_BAR field. */
#define BR_HDMI_FC_AVICONF0_FC_AVICONF0_BAR(x) (HW_HDMI_FC_AVICONF0(x).B.FC_AVICONF0_BAR)

/*! @brief Format value for bitfield HDMI_FC_AVICONF0_FC_AVICONF0_BAR. */
#define BF_HDMI_FC_AVICONF0_FC_AVICONF0_BAR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF0_FC_AVICONF0_BAR) & BM_HDMI_FC_AVICONF0_FC_AVICONF0_BAR)

/*! @brief Set the FC_AVICONF0_BAR field to a new value. */
#define BW_HDMI_FC_AVICONF0_FC_AVICONF0_BAR(x, v) (HW_HDMI_FC_AVICONF0_WR(x, (HW_HDMI_FC_AVICONF0_RD(x) & ~BM_HDMI_FC_AVICONF0_FC_AVICONF0_BAR) | BF_HDMI_FC_AVICONF0_FC_AVICONF0_BAR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF0, field FC_AVICONF0_SCAN[5:4] (RW)
 *
 * Scan information
 */
/*@{*/
#define BP_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN (4U) /*!< Bit position for HDMI_FC_AVICONF0_FC_AVICONF0_SCAN. */
#define BM_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN (0x30U) /*!< Bit mask for HDMI_FC_AVICONF0_FC_AVICONF0_SCAN. */
#define BS_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF0_FC_AVICONF0_SCAN. */

/*! @brief Read current value of the HDMI_FC_AVICONF0_FC_AVICONF0_SCAN field. */
#define BR_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN(x) (HW_HDMI_FC_AVICONF0(x).B.FC_AVICONF0_SCAN)

/*! @brief Format value for bitfield HDMI_FC_AVICONF0_FC_AVICONF0_SCAN. */
#define BF_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN) & BM_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN)

/*! @brief Set the FC_AVICONF0_SCAN field to a new value. */
#define BW_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN(x, v) (HW_HDMI_FC_AVICONF0_WR(x, (HW_HDMI_FC_AVICONF0_RD(x) & ~BM_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN) | BF_HDMI_FC_AVICONF0_FC_AVICONF0_SCAN(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF0, field FC_AVICONF0_ACTIVE_FORMAT[6] (RW)
 *
 * Active format present
 */
/*@{*/
#define BP_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT (6U) /*!< Bit position for HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT. */
#define BM_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT (0x40U) /*!< Bit mask for HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT. */
#define BS_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT (1U) /*!< Bit field size in bits for HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT. */

/*! @brief Read current value of the HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT field. */
#define BR_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT(x) (HW_HDMI_FC_AVICONF0(x).B.FC_AVICONF0_ACTIVE_FORMAT)

/*! @brief Format value for bitfield HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT. */
#define BF_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT) & BM_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT)

/*! @brief Set the FC_AVICONF0_ACTIVE_FORMAT field to a new value. */
#define BW_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT(x, v) (HW_HDMI_FC_AVICONF0_WR(x, (HW_HDMI_FC_AVICONF0_RD(x) & ~BM_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT) | BF_HDMI_FC_AVICONF0_FC_AVICONF0_ACTIVE_FORMAT(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF0, field FC_AVICONF0_MISC[7] (RW)
 *
 * Frame composer AVI packet configuration bit
 */
/*@{*/
#define BP_HDMI_FC_AVICONF0_FC_AVICONF0_MISC (7U) /*!< Bit position for HDMI_FC_AVICONF0_FC_AVICONF0_MISC. */
#define BM_HDMI_FC_AVICONF0_FC_AVICONF0_MISC (0x80U) /*!< Bit mask for HDMI_FC_AVICONF0_FC_AVICONF0_MISC. */
#define BS_HDMI_FC_AVICONF0_FC_AVICONF0_MISC (1U) /*!< Bit field size in bits for HDMI_FC_AVICONF0_FC_AVICONF0_MISC. */

/*! @brief Read current value of the HDMI_FC_AVICONF0_FC_AVICONF0_MISC field. */
#define BR_HDMI_FC_AVICONF0_FC_AVICONF0_MISC(x) (HW_HDMI_FC_AVICONF0(x).B.FC_AVICONF0_MISC)

/*! @brief Format value for bitfield HDMI_FC_AVICONF0_FC_AVICONF0_MISC. */
#define BF_HDMI_FC_AVICONF0_FC_AVICONF0_MISC(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF0_FC_AVICONF0_MISC) & BM_HDMI_FC_AVICONF0_FC_AVICONF0_MISC)

/*! @brief Set the FC_AVICONF0_MISC field to a new value. */
#define BW_HDMI_FC_AVICONF0_FC_AVICONF0_MISC(x, v) (HW_HDMI_FC_AVICONF0_WR(x, (HW_HDMI_FC_AVICONF0_RD(x) & ~BM_HDMI_FC_AVICONF0_FC_AVICONF0_MISC) | BF_HDMI_FC_AVICONF0_FC_AVICONF0_MISC(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVICONF1 - Frame Composer AVI Packet Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVICONF1 - Frame Composer AVI Packet Configuration Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x101A Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_aviconf1
{
    uint8_t U;
    struct _hw_hdmi_fc_aviconf1_bitfields
    {
        uint8_t FC_AVICONF1_ACTIVE_AR : 4; /*!< [3:0]  */
        uint8_t FC_AVICONF1_PICTURE_AR : 2; /*!< [5:4]  */
        uint8_t FC_AVICONF0_COLOR : 2; /*!< [7:6]  */
    } B;
} hw_hdmi_fc_aviconf1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVICONF1 register
 */
/*@{*/
#define HW_HDMI_FC_AVICONF1_ADDR(x) ((uintptr_t)(x) + 0x101AU)

#define HW_HDMI_FC_AVICONF1(x)   (*(__IO hw_hdmi_fc_aviconf1_t *) HW_HDMI_FC_AVICONF1_ADDR(x))
#define HW_HDMI_FC_AVICONF1_RD(x) (HW_HDMI_FC_AVICONF1(x).U)
#define HW_HDMI_FC_AVICONF1_WR(x, v) (HW_HDMI_FC_AVICONF1(x).U = (v))
#define HW_HDMI_FC_AVICONF1_SET(x, v) (HW_HDMI_FC_AVICONF1_WR(x, HW_HDMI_FC_AVICONF1_RD(x) |  (v)))
#define HW_HDMI_FC_AVICONF1_CLR(x, v) (HW_HDMI_FC_AVICONF1_WR(x, HW_HDMI_FC_AVICONF1_RD(x) & ~(v)))
#define HW_HDMI_FC_AVICONF1_TOG(x, v) (HW_HDMI_FC_AVICONF1_WR(x, HW_HDMI_FC_AVICONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVICONF1 bitfields
 */

/*!
 * @name Register HDMI_FC_AVICONF1, field FC_AVICONF1_ACTIVE_AR[3:0] (RW)
 *
 * Active aspect ratio Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR (0U) /*!< Bit position for HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR. */
#define BM_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR (0x0FU) /*!< Bit mask for HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR. */
#define BS_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR (4U) /*!< Bit field size in bits for HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR. */

/*! @brief Read current value of the HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR field. */
#define BR_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR(x) (HW_HDMI_FC_AVICONF1(x).B.FC_AVICONF1_ACTIVE_AR)

/*! @brief Format value for bitfield HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR. */
#define BF_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR) & BM_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR)

/*! @brief Set the FC_AVICONF1_ACTIVE_AR field to a new value. */
#define BW_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR(x, v) (HW_HDMI_FC_AVICONF1_WR(x, (HW_HDMI_FC_AVICONF1_RD(x) & ~BM_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR) | BF_HDMI_FC_AVICONF1_FC_AVICONF1_ACTIVE_AR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF1, field FC_AVICONF1_PICTURE_AR[5:4] (RW)
 *
 * Picture aspect ratio
 */
/*@{*/
#define BP_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR (4U) /*!< Bit position for HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR. */
#define BM_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR (0x30U) /*!< Bit mask for HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR. */
#define BS_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR. */

/*! @brief Read current value of the HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR field. */
#define BR_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR(x) (HW_HDMI_FC_AVICONF1(x).B.FC_AVICONF1_PICTURE_AR)

/*! @brief Format value for bitfield HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR. */
#define BF_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR) & BM_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR)

/*! @brief Set the FC_AVICONF1_PICTURE_AR field to a new value. */
#define BW_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR(x, v) (HW_HDMI_FC_AVICONF1_WR(x, (HW_HDMI_FC_AVICONF1_RD(x) & ~BM_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR) | BF_HDMI_FC_AVICONF1_FC_AVICONF1_PICTURE_AR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF1, field FC_AVICONF0_COLOR[7:6] (RW)
 *
 * Colorimetry
 */
/*@{*/
#define BP_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR (6U) /*!< Bit position for HDMI_FC_AVICONF1_FC_AVICONF0_COLOR. */
#define BM_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR (0xC0U) /*!< Bit mask for HDMI_FC_AVICONF1_FC_AVICONF0_COLOR. */
#define BS_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF1_FC_AVICONF0_COLOR. */

/*! @brief Read current value of the HDMI_FC_AVICONF1_FC_AVICONF0_COLOR field. */
#define BR_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR(x) (HW_HDMI_FC_AVICONF1(x).B.FC_AVICONF0_COLOR)

/*! @brief Format value for bitfield HDMI_FC_AVICONF1_FC_AVICONF0_COLOR. */
#define BF_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR) & BM_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR)

/*! @brief Set the FC_AVICONF0_COLOR field to a new value. */
#define BW_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR(x, v) (HW_HDMI_FC_AVICONF1_WR(x, (HW_HDMI_FC_AVICONF1_RD(x) & ~BM_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR) | BF_HDMI_FC_AVICONF1_FC_AVICONF0_COLOR(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVICONF2 - FC_AVICONFFrame Composer AVI Packet Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVICONF2 - FC_AVICONFFrame Composer AVI Packet Configuration Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x101B Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_aviconf2
{
    uint8_t U;
    struct _hw_hdmi_fc_aviconf2_bitfields
    {
        uint8_t FC_AVICONF2_SCALE : 2; /*!< [1:0]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t FC_AVICONF2_EXT_COLOR : 3; /*!< [6:4]  */
        uint8_t FC_AVICONF2_IT : 1;    /*!< [7]  */
    } B;
} hw_hdmi_fc_aviconf2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVICONF2 register
 */
/*@{*/
#define HW_HDMI_FC_AVICONF2_ADDR(x) ((uintptr_t)(x) + 0x101BU)

#define HW_HDMI_FC_AVICONF2(x)   (*(__IO hw_hdmi_fc_aviconf2_t *) HW_HDMI_FC_AVICONF2_ADDR(x))
#define HW_HDMI_FC_AVICONF2_RD(x) (HW_HDMI_FC_AVICONF2(x).U)
#define HW_HDMI_FC_AVICONF2_WR(x, v) (HW_HDMI_FC_AVICONF2(x).U = (v))
#define HW_HDMI_FC_AVICONF2_SET(x, v) (HW_HDMI_FC_AVICONF2_WR(x, HW_HDMI_FC_AVICONF2_RD(x) |  (v)))
#define HW_HDMI_FC_AVICONF2_CLR(x, v) (HW_HDMI_FC_AVICONF2_WR(x, HW_HDMI_FC_AVICONF2_RD(x) & ~(v)))
#define HW_HDMI_FC_AVICONF2_TOG(x, v) (HW_HDMI_FC_AVICONF2_WR(x, HW_HDMI_FC_AVICONF2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVICONF2 bitfields
 */

/*!
 * @name Register HDMI_FC_AVICONF2, field FC_AVICONF2_SCALE[1:0] (RW)
 *
 * Non-uniform picture scaling Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE (0U) /*!< Bit position for HDMI_FC_AVICONF2_FC_AVICONF2_SCALE. */
#define BM_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE (0x03U) /*!< Bit mask for HDMI_FC_AVICONF2_FC_AVICONF2_SCALE. */
#define BS_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE (2U) /*!< Bit field size in bits for HDMI_FC_AVICONF2_FC_AVICONF2_SCALE. */

/*! @brief Read current value of the HDMI_FC_AVICONF2_FC_AVICONF2_SCALE field. */
#define BR_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE(x) (HW_HDMI_FC_AVICONF2(x).B.FC_AVICONF2_SCALE)

/*! @brief Format value for bitfield HDMI_FC_AVICONF2_FC_AVICONF2_SCALE. */
#define BF_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE) & BM_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE)

/*! @brief Set the FC_AVICONF2_SCALE field to a new value. */
#define BW_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE(x, v) (HW_HDMI_FC_AVICONF2_WR(x, (HW_HDMI_FC_AVICONF2_RD(x) & ~BM_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE) | BF_HDMI_FC_AVICONF2_FC_AVICONF2_SCALE(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF2, field FC_AVICONF2_EXT_COLOR[6:4] (RW)
 *
 * Extended colorimetry
 */
/*@{*/
#define BP_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR (4U) /*!< Bit position for HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR. */
#define BM_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR (0x70U) /*!< Bit mask for HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR. */
#define BS_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR (3U) /*!< Bit field size in bits for HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR. */

/*! @brief Read current value of the HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR field. */
#define BR_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR(x) (HW_HDMI_FC_AVICONF2(x).B.FC_AVICONF2_EXT_COLOR)

/*! @brief Format value for bitfield HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR. */
#define BF_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR) & BM_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR)

/*! @brief Set the FC_AVICONF2_EXT_COLOR field to a new value. */
#define BW_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR(x, v) (HW_HDMI_FC_AVICONF2_WR(x, (HW_HDMI_FC_AVICONF2_RD(x) & ~BM_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR) | BF_HDMI_FC_AVICONF2_FC_AVICONF2_EXT_COLOR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AVICONF2, field FC_AVICONF2_IT[7] (RW)
 *
 * IT content
 */
/*@{*/
#define BP_HDMI_FC_AVICONF2_FC_AVICONF2_IT (7U) /*!< Bit position for HDMI_FC_AVICONF2_FC_AVICONF2_IT. */
#define BM_HDMI_FC_AVICONF2_FC_AVICONF2_IT (0x80U) /*!< Bit mask for HDMI_FC_AVICONF2_FC_AVICONF2_IT. */
#define BS_HDMI_FC_AVICONF2_FC_AVICONF2_IT (1U) /*!< Bit field size in bits for HDMI_FC_AVICONF2_FC_AVICONF2_IT. */

/*! @brief Read current value of the HDMI_FC_AVICONF2_FC_AVICONF2_IT field. */
#define BR_HDMI_FC_AVICONF2_FC_AVICONF2_IT(x) (HW_HDMI_FC_AVICONF2(x).B.FC_AVICONF2_IT)

/*! @brief Format value for bitfield HDMI_FC_AVICONF2_FC_AVICONF2_IT. */
#define BF_HDMI_FC_AVICONF2_FC_AVICONF2_IT(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVICONF2_FC_AVICONF2_IT) & BM_HDMI_FC_AVICONF2_FC_AVICONF2_IT)

/*! @brief Set the FC_AVICONF2_IT field to a new value. */
#define BW_HDMI_FC_AVICONF2_FC_AVICONF2_IT(x, v) (HW_HDMI_FC_AVICONF2_WR(x, (HW_HDMI_FC_AVICONF2_RD(x) & ~BM_HDMI_FC_AVICONF2_FC_AVICONF2_IT) | BF_HDMI_FC_AVICONF2_FC_AVICONF2_IT(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVIVID - Frame Composer AVI Packet VIC Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVIVID - Frame Composer AVI Packet VIC Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the AVI infoFrame Video Identification code. For more information,
 * refer to the CEA-861-E specification. Address Offset: 0x101C Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avivid
{
    uint8_t U;
    struct _hw_hdmi_fc_avivid_bitfields
    {
        uint8_t FC_AVIVID : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avivid_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVIVID register
 */
/*@{*/
#define HW_HDMI_FC_AVIVID_ADDR(x) ((uintptr_t)(x) + 0x101CU)

#define HW_HDMI_FC_AVIVID(x)     (*(__IO hw_hdmi_fc_avivid_t *) HW_HDMI_FC_AVIVID_ADDR(x))
#define HW_HDMI_FC_AVIVID_RD(x)  (HW_HDMI_FC_AVIVID(x).U)
#define HW_HDMI_FC_AVIVID_WR(x, v) (HW_HDMI_FC_AVIVID(x).U = (v))
#define HW_HDMI_FC_AVIVID_SET(x, v) (HW_HDMI_FC_AVIVID_WR(x, HW_HDMI_FC_AVIVID_RD(x) |  (v)))
#define HW_HDMI_FC_AVIVID_CLR(x, v) (HW_HDMI_FC_AVIVID_WR(x, HW_HDMI_FC_AVIVID_RD(x) & ~(v)))
#define HW_HDMI_FC_AVIVID_TOG(x, v) (HW_HDMI_FC_AVIVID_WR(x, HW_HDMI_FC_AVIVID_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVIVID bitfields
 */

/*!
 * @name Register HDMI_FC_AVIVID, field FC_AVIVID[7:0] (RW)
 *
 * the AVI infoFrame Video Identification code.
 */
/*@{*/
#define BP_HDMI_FC_AVIVID_FC_AVIVID (0U)   /*!< Bit position for HDMI_FC_AVIVID_FC_AVIVID. */
#define BM_HDMI_FC_AVIVID_FC_AVIVID (0xFFU) /*!< Bit mask for HDMI_FC_AVIVID_FC_AVIVID. */
#define BS_HDMI_FC_AVIVID_FC_AVIVID (8U)   /*!< Bit field size in bits for HDMI_FC_AVIVID_FC_AVIVID. */

/*! @brief Read current value of the HDMI_FC_AVIVID_FC_AVIVID field. */
#define BR_HDMI_FC_AVIVID_FC_AVIVID(x) (HW_HDMI_FC_AVIVID(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVIVID_FC_AVIVID. */
#define BF_HDMI_FC_AVIVID_FC_AVIVID(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVIVID_FC_AVIVID) & BM_HDMI_FC_AVIVID_FC_AVIVID)

/*! @brief Set the FC_AVIVID field to a new value. */
#define BW_HDMI_FC_AVIVID_FC_AVIVID(x, v) (HW_HDMI_FC_AVIVID_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVIETB0 - Frame Composer AVI Packet End of Top Bar Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVIETB0 - Frame Composer AVI Packet End of Top Bar Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers define the AVI infoFrame End of Top Bar value. For more
 * information, refer to CEA-861-E specification. Address Offset: 0x101D Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avietb0
{
    uint8_t U;
    struct _hw_hdmi_fc_avietb0_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avietb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVIETB0 register
 */
/*@{*/
#define HW_HDMI_FC_AVIETB0_ADDR(x) ((uintptr_t)(x) + 0x101DU)

#define HW_HDMI_FC_AVIETB0(x)    (*(__IO hw_hdmi_fc_avietb0_t *) HW_HDMI_FC_AVIETB0_ADDR(x))
#define HW_HDMI_FC_AVIETB0_RD(x) (HW_HDMI_FC_AVIETB0(x).U)
#define HW_HDMI_FC_AVIETB0_WR(x, v) (HW_HDMI_FC_AVIETB0(x).U = (v))
#define HW_HDMI_FC_AVIETB0_SET(x, v) (HW_HDMI_FC_AVIETB0_WR(x, HW_HDMI_FC_AVIETB0_RD(x) |  (v)))
#define HW_HDMI_FC_AVIETB0_CLR(x, v) (HW_HDMI_FC_AVIETB0_WR(x, HW_HDMI_FC_AVIETB0_RD(x) & ~(v)))
#define HW_HDMI_FC_AVIETB0_TOG(x, v) (HW_HDMI_FC_AVIETB0_WR(x, HW_HDMI_FC_AVIETB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVIETB0 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_AVIETB1 - Frame Composer AVI Packet End of Top Bar Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVIETB1 - Frame Composer AVI Packet End of Top Bar Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x101E Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avietb1
{
    uint8_t U;
    struct _hw_hdmi_fc_avietb1_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avietb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVIETB1 register
 */
/*@{*/
#define HW_HDMI_FC_AVIETB1_ADDR(x) ((uintptr_t)(x) + 0x101EU)

#define HW_HDMI_FC_AVIETB1(x)    (*(__IO hw_hdmi_fc_avietb1_t *) HW_HDMI_FC_AVIETB1_ADDR(x))
#define HW_HDMI_FC_AVIETB1_RD(x) (HW_HDMI_FC_AVIETB1(x).U)
#define HW_HDMI_FC_AVIETB1_WR(x, v) (HW_HDMI_FC_AVIETB1(x).U = (v))
#define HW_HDMI_FC_AVIETB1_SET(x, v) (HW_HDMI_FC_AVIETB1_WR(x, HW_HDMI_FC_AVIETB1_RD(x) |  (v)))
#define HW_HDMI_FC_AVIETB1_CLR(x, v) (HW_HDMI_FC_AVIETB1_WR(x, HW_HDMI_FC_AVIETB1_RD(x) & ~(v)))
#define HW_HDMI_FC_AVIETB1_TOG(x, v) (HW_HDMI_FC_AVIETB1_WR(x, HW_HDMI_FC_AVIETB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVIETB1 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_AVISBB0 - Frame Composer AVI Packet Start of Bottom Bar Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVISBB0 - Frame Composer AVI Packet Start of Bottom Bar Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers define the AVI infoFrame Start of Bottom Bar value. For more
 * information, refer to CEA-861D specification. Address Offset: 0x101F Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avisbb0
{
    uint8_t U;
    struct _hw_hdmi_fc_avisbb0_bitfields
    {
        uint8_t FC_AVISBB0 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avisbb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVISBB0 register
 */
/*@{*/
#define HW_HDMI_FC_AVISBB0_ADDR(x) ((uintptr_t)(x) + 0x101FU)

#define HW_HDMI_FC_AVISBB0(x)    (*(__IO hw_hdmi_fc_avisbb0_t *) HW_HDMI_FC_AVISBB0_ADDR(x))
#define HW_HDMI_FC_AVISBB0_RD(x) (HW_HDMI_FC_AVISBB0(x).U)
#define HW_HDMI_FC_AVISBB0_WR(x, v) (HW_HDMI_FC_AVISBB0(x).U = (v))
#define HW_HDMI_FC_AVISBB0_SET(x, v) (HW_HDMI_FC_AVISBB0_WR(x, HW_HDMI_FC_AVISBB0_RD(x) |  (v)))
#define HW_HDMI_FC_AVISBB0_CLR(x, v) (HW_HDMI_FC_AVISBB0_WR(x, HW_HDMI_FC_AVISBB0_RD(x) & ~(v)))
#define HW_HDMI_FC_AVISBB0_TOG(x, v) (HW_HDMI_FC_AVISBB0_WR(x, HW_HDMI_FC_AVISBB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVISBB0 bitfields
 */

/*!
 * @name Register HDMI_FC_AVISBB0, field FC_AVISBB0[7:0] (RW)
 *
 * Line number of Start of Bottom Bar (lower 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVISBB0_FC_AVISBB0 (0U) /*!< Bit position for HDMI_FC_AVISBB0_FC_AVISBB0. */
#define BM_HDMI_FC_AVISBB0_FC_AVISBB0 (0xFFU) /*!< Bit mask for HDMI_FC_AVISBB0_FC_AVISBB0. */
#define BS_HDMI_FC_AVISBB0_FC_AVISBB0 (8U) /*!< Bit field size in bits for HDMI_FC_AVISBB0_FC_AVISBB0. */

/*! @brief Read current value of the HDMI_FC_AVISBB0_FC_AVISBB0 field. */
#define BR_HDMI_FC_AVISBB0_FC_AVISBB0(x) (HW_HDMI_FC_AVISBB0(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVISBB0_FC_AVISBB0. */
#define BF_HDMI_FC_AVISBB0_FC_AVISBB0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVISBB0_FC_AVISBB0) & BM_HDMI_FC_AVISBB0_FC_AVISBB0)

/*! @brief Set the FC_AVISBB0 field to a new value. */
#define BW_HDMI_FC_AVISBB0_FC_AVISBB0(x, v) (HW_HDMI_FC_AVISBB0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVISBB1 - Frame Composer AVI Packet Start of Bottom Bar Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVISBB1 - Frame Composer AVI Packet Start of Bottom Bar Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1020 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avisbb1
{
    uint8_t U;
    struct _hw_hdmi_fc_avisbb1_bitfields
    {
        uint8_t FC_AVISBB1 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avisbb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVISBB1 register
 */
/*@{*/
#define HW_HDMI_FC_AVISBB1_ADDR(x) ((uintptr_t)(x) + 0x1020U)

#define HW_HDMI_FC_AVISBB1(x)    (*(__IO hw_hdmi_fc_avisbb1_t *) HW_HDMI_FC_AVISBB1_ADDR(x))
#define HW_HDMI_FC_AVISBB1_RD(x) (HW_HDMI_FC_AVISBB1(x).U)
#define HW_HDMI_FC_AVISBB1_WR(x, v) (HW_HDMI_FC_AVISBB1(x).U = (v))
#define HW_HDMI_FC_AVISBB1_SET(x, v) (HW_HDMI_FC_AVISBB1_WR(x, HW_HDMI_FC_AVISBB1_RD(x) |  (v)))
#define HW_HDMI_FC_AVISBB1_CLR(x, v) (HW_HDMI_FC_AVISBB1_WR(x, HW_HDMI_FC_AVISBB1_RD(x) & ~(v)))
#define HW_HDMI_FC_AVISBB1_TOG(x, v) (HW_HDMI_FC_AVISBB1_WR(x, HW_HDMI_FC_AVISBB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVISBB1 bitfields
 */

/*!
 * @name Register HDMI_FC_AVISBB1, field FC_AVISBB1[7:0] (RW)
 *
 * Line number of Start of Bottom Bar (upper 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVISBB1_FC_AVISBB1 (0U) /*!< Bit position for HDMI_FC_AVISBB1_FC_AVISBB1. */
#define BM_HDMI_FC_AVISBB1_FC_AVISBB1 (0xFFU) /*!< Bit mask for HDMI_FC_AVISBB1_FC_AVISBB1. */
#define BS_HDMI_FC_AVISBB1_FC_AVISBB1 (8U) /*!< Bit field size in bits for HDMI_FC_AVISBB1_FC_AVISBB1. */

/*! @brief Read current value of the HDMI_FC_AVISBB1_FC_AVISBB1 field. */
#define BR_HDMI_FC_AVISBB1_FC_AVISBB1(x) (HW_HDMI_FC_AVISBB1(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVISBB1_FC_AVISBB1. */
#define BF_HDMI_FC_AVISBB1_FC_AVISBB1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVISBB1_FC_AVISBB1) & BM_HDMI_FC_AVISBB1_FC_AVISBB1)

/*! @brief Set the FC_AVISBB1 field to a new value. */
#define BW_HDMI_FC_AVISBB1_FC_AVISBB1(x, v) (HW_HDMI_FC_AVISBB1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVIELB0 - Frame Composer AVI Packet End of Left Bar Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVIELB0 - Frame Composer AVI Packet End of Left Bar Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers define the AVI infoFrame End of Left Bar value. For more
 * information, refer to CEA-861D specification. Address Offset: 0x1021 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avielb0
{
    uint8_t U;
    struct _hw_hdmi_fc_avielb0_bitfields
    {
        uint8_t FC_AVIELB0 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avielb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVIELB0 register
 */
/*@{*/
#define HW_HDMI_FC_AVIELB0_ADDR(x) ((uintptr_t)(x) + 0x1021U)

#define HW_HDMI_FC_AVIELB0(x)    (*(__IO hw_hdmi_fc_avielb0_t *) HW_HDMI_FC_AVIELB0_ADDR(x))
#define HW_HDMI_FC_AVIELB0_RD(x) (HW_HDMI_FC_AVIELB0(x).U)
#define HW_HDMI_FC_AVIELB0_WR(x, v) (HW_HDMI_FC_AVIELB0(x).U = (v))
#define HW_HDMI_FC_AVIELB0_SET(x, v) (HW_HDMI_FC_AVIELB0_WR(x, HW_HDMI_FC_AVIELB0_RD(x) |  (v)))
#define HW_HDMI_FC_AVIELB0_CLR(x, v) (HW_HDMI_FC_AVIELB0_WR(x, HW_HDMI_FC_AVIELB0_RD(x) & ~(v)))
#define HW_HDMI_FC_AVIELB0_TOG(x, v) (HW_HDMI_FC_AVIELB0_WR(x, HW_HDMI_FC_AVIELB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVIELB0 bitfields
 */

/*!
 * @name Register HDMI_FC_AVIELB0, field FC_AVIELB0[7:0] (RW)
 *
 * Pixel number of end of left Bar (lower 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVIELB0_FC_AVIELB0 (0U) /*!< Bit position for HDMI_FC_AVIELB0_FC_AVIELB0. */
#define BM_HDMI_FC_AVIELB0_FC_AVIELB0 (0xFFU) /*!< Bit mask for HDMI_FC_AVIELB0_FC_AVIELB0. */
#define BS_HDMI_FC_AVIELB0_FC_AVIELB0 (8U) /*!< Bit field size in bits for HDMI_FC_AVIELB0_FC_AVIELB0. */

/*! @brief Read current value of the HDMI_FC_AVIELB0_FC_AVIELB0 field. */
#define BR_HDMI_FC_AVIELB0_FC_AVIELB0(x) (HW_HDMI_FC_AVIELB0(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVIELB0_FC_AVIELB0. */
#define BF_HDMI_FC_AVIELB0_FC_AVIELB0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVIELB0_FC_AVIELB0) & BM_HDMI_FC_AVIELB0_FC_AVIELB0)

/*! @brief Set the FC_AVIELB0 field to a new value. */
#define BW_HDMI_FC_AVIELB0_FC_AVIELB0(x, v) (HW_HDMI_FC_AVIELB0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVIELB1 - Frame Composer AVI Packet End of Left Bar Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVIELB1 - Frame Composer AVI Packet End of Left Bar Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1022 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avielb1
{
    uint8_t U;
    struct _hw_hdmi_fc_avielb1_bitfields
    {
        uint8_t FC_AVIELB1 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avielb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVIELB1 register
 */
/*@{*/
#define HW_HDMI_FC_AVIELB1_ADDR(x) ((uintptr_t)(x) + 0x1022U)

#define HW_HDMI_FC_AVIELB1(x)    (*(__IO hw_hdmi_fc_avielb1_t *) HW_HDMI_FC_AVIELB1_ADDR(x))
#define HW_HDMI_FC_AVIELB1_RD(x) (HW_HDMI_FC_AVIELB1(x).U)
#define HW_HDMI_FC_AVIELB1_WR(x, v) (HW_HDMI_FC_AVIELB1(x).U = (v))
#define HW_HDMI_FC_AVIELB1_SET(x, v) (HW_HDMI_FC_AVIELB1_WR(x, HW_HDMI_FC_AVIELB1_RD(x) |  (v)))
#define HW_HDMI_FC_AVIELB1_CLR(x, v) (HW_HDMI_FC_AVIELB1_WR(x, HW_HDMI_FC_AVIELB1_RD(x) & ~(v)))
#define HW_HDMI_FC_AVIELB1_TOG(x, v) (HW_HDMI_FC_AVIELB1_WR(x, HW_HDMI_FC_AVIELB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVIELB1 bitfields
 */

/*!
 * @name Register HDMI_FC_AVIELB1, field FC_AVIELB1[7:0] (RW)
 *
 * Pixel number of end of left Bar (lower 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVIELB1_FC_AVIELB1 (0U) /*!< Bit position for HDMI_FC_AVIELB1_FC_AVIELB1. */
#define BM_HDMI_FC_AVIELB1_FC_AVIELB1 (0xFFU) /*!< Bit mask for HDMI_FC_AVIELB1_FC_AVIELB1. */
#define BS_HDMI_FC_AVIELB1_FC_AVIELB1 (8U) /*!< Bit field size in bits for HDMI_FC_AVIELB1_FC_AVIELB1. */

/*! @brief Read current value of the HDMI_FC_AVIELB1_FC_AVIELB1 field. */
#define BR_HDMI_FC_AVIELB1_FC_AVIELB1(x) (HW_HDMI_FC_AVIELB1(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVIELB1_FC_AVIELB1. */
#define BF_HDMI_FC_AVIELB1_FC_AVIELB1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVIELB1_FC_AVIELB1) & BM_HDMI_FC_AVIELB1_FC_AVIELB1)

/*! @brief Set the FC_AVIELB1 field to a new value. */
#define BW_HDMI_FC_AVIELB1_FC_AVIELB1(x, v) (HW_HDMI_FC_AVIELB1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVISRB0 - Frame Composer AVI Packet Start of Right Bar Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVISRB0 - Frame Composer AVI Packet Start of Right Bar Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers define the AVI infoFrame Start of Right Bar value. For more
 * information, refer to CEA-861D specification. Address Offset: 0x1023 Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avisrb0
{
    uint8_t U;
    struct _hw_hdmi_fc_avisrb0_bitfields
    {
        uint8_t FC_AVISRB0 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avisrb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVISRB0 register
 */
/*@{*/
#define HW_HDMI_FC_AVISRB0_ADDR(x) ((uintptr_t)(x) + 0x1023U)

#define HW_HDMI_FC_AVISRB0(x)    (*(__IO hw_hdmi_fc_avisrb0_t *) HW_HDMI_FC_AVISRB0_ADDR(x))
#define HW_HDMI_FC_AVISRB0_RD(x) (HW_HDMI_FC_AVISRB0(x).U)
#define HW_HDMI_FC_AVISRB0_WR(x, v) (HW_HDMI_FC_AVISRB0(x).U = (v))
#define HW_HDMI_FC_AVISRB0_SET(x, v) (HW_HDMI_FC_AVISRB0_WR(x, HW_HDMI_FC_AVISRB0_RD(x) |  (v)))
#define HW_HDMI_FC_AVISRB0_CLR(x, v) (HW_HDMI_FC_AVISRB0_WR(x, HW_HDMI_FC_AVISRB0_RD(x) & ~(v)))
#define HW_HDMI_FC_AVISRB0_TOG(x, v) (HW_HDMI_FC_AVISRB0_WR(x, HW_HDMI_FC_AVISRB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVISRB0 bitfields
 */

/*!
 * @name Register HDMI_FC_AVISRB0, field FC_AVISRB0[7:0] (RW)
 *
 * Pixel number of start of right Bar (lower 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVISRB0_FC_AVISRB0 (0U) /*!< Bit position for HDMI_FC_AVISRB0_FC_AVISRB0. */
#define BM_HDMI_FC_AVISRB0_FC_AVISRB0 (0xFFU) /*!< Bit mask for HDMI_FC_AVISRB0_FC_AVISRB0. */
#define BS_HDMI_FC_AVISRB0_FC_AVISRB0 (8U) /*!< Bit field size in bits for HDMI_FC_AVISRB0_FC_AVISRB0. */

/*! @brief Read current value of the HDMI_FC_AVISRB0_FC_AVISRB0 field. */
#define BR_HDMI_FC_AVISRB0_FC_AVISRB0(x) (HW_HDMI_FC_AVISRB0(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVISRB0_FC_AVISRB0. */
#define BF_HDMI_FC_AVISRB0_FC_AVISRB0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVISRB0_FC_AVISRB0) & BM_HDMI_FC_AVISRB0_FC_AVISRB0)

/*! @brief Set the FC_AVISRB0 field to a new value. */
#define BW_HDMI_FC_AVISRB0_FC_AVISRB0(x, v) (HW_HDMI_FC_AVISRB0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AVISRB1 - Frame Composer AVI Packet Start of Right Bar Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AVISRB1 - Frame Composer AVI Packet Start of Right Bar Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1024 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_avisrb1
{
    uint8_t U;
    struct _hw_hdmi_fc_avisrb1_bitfields
    {
        uint8_t FC_AVISRB1 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_avisrb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AVISRB1 register
 */
/*@{*/
#define HW_HDMI_FC_AVISRB1_ADDR(x) ((uintptr_t)(x) + 0x1024U)

#define HW_HDMI_FC_AVISRB1(x)    (*(__IO hw_hdmi_fc_avisrb1_t *) HW_HDMI_FC_AVISRB1_ADDR(x))
#define HW_HDMI_FC_AVISRB1_RD(x) (HW_HDMI_FC_AVISRB1(x).U)
#define HW_HDMI_FC_AVISRB1_WR(x, v) (HW_HDMI_FC_AVISRB1(x).U = (v))
#define HW_HDMI_FC_AVISRB1_SET(x, v) (HW_HDMI_FC_AVISRB1_WR(x, HW_HDMI_FC_AVISRB1_RD(x) |  (v)))
#define HW_HDMI_FC_AVISRB1_CLR(x, v) (HW_HDMI_FC_AVISRB1_WR(x, HW_HDMI_FC_AVISRB1_RD(x) & ~(v)))
#define HW_HDMI_FC_AVISRB1_TOG(x, v) (HW_HDMI_FC_AVISRB1_WR(x, HW_HDMI_FC_AVISRB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AVISRB1 bitfields
 */

/*!
 * @name Register HDMI_FC_AVISRB1, field FC_AVISRB1[7:0] (RW)
 *
 * Pixel number of start of right Bar (upper 8 bits)
 */
/*@{*/
#define BP_HDMI_FC_AVISRB1_FC_AVISRB1 (0U) /*!< Bit position for HDMI_FC_AVISRB1_FC_AVISRB1. */
#define BM_HDMI_FC_AVISRB1_FC_AVISRB1 (0xFFU) /*!< Bit mask for HDMI_FC_AVISRB1_FC_AVISRB1. */
#define BS_HDMI_FC_AVISRB1_FC_AVISRB1 (8U) /*!< Bit field size in bits for HDMI_FC_AVISRB1_FC_AVISRB1. */

/*! @brief Read current value of the HDMI_FC_AVISRB1_FC_AVISRB1 field. */
#define BR_HDMI_FC_AVISRB1_FC_AVISRB1(x) (HW_HDMI_FC_AVISRB1(x).U)

/*! @brief Format value for bitfield HDMI_FC_AVISRB1_FC_AVISRB1. */
#define BF_HDMI_FC_AVISRB1_FC_AVISRB1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AVISRB1_FC_AVISRB1) & BM_HDMI_FC_AVISRB1_FC_AVISRB1)

/*! @brief Set the FC_AVISRB1 field to a new value. */
#define BW_HDMI_FC_AVISRB1_FC_AVISRB1(x, v) (HW_HDMI_FC_AVISRB1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDICONF0 - Frame Composer AUD Packet Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDICONF0 - Frame Composer AUD Packet Configuration Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers configure the following contents of the AUDIO infoFrame:
 * Coding type Channel count Sampling frequency Sampling size Channel allocation
 * Audio level shift value Down mix enable For more information, refer to CEA-861D
 * specification. Address Offset: 0x1025 to 0x1028 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For the FC_AUDICONF0 register, bits [6:5] correspond
 * to LFEPBL1, LFEPBL0 LFE playback level as compared to the other channels (from
 * HDMI 1.4a specification).
 */
typedef union _hw_hdmi_fc_audiconf0
{
    uint8_t U;
    struct _hw_hdmi_fc_audiconf0_bitfields
    {
        uint8_t CT : 4;                /*!< [3:0]  */
        uint8_t CC : 3;                /*!< [6:4]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_fc_audiconf0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDICONF0 register
 */
/*@{*/
#define HW_HDMI_FC_AUDICONF0_ADDR(x) ((uintptr_t)(x) + 0x1025U)

#define HW_HDMI_FC_AUDICONF0(x)  (*(__IO hw_hdmi_fc_audiconf0_t *) HW_HDMI_FC_AUDICONF0_ADDR(x))
#define HW_HDMI_FC_AUDICONF0_RD(x) (HW_HDMI_FC_AUDICONF0(x).U)
#define HW_HDMI_FC_AUDICONF0_WR(x, v) (HW_HDMI_FC_AUDICONF0(x).U = (v))
#define HW_HDMI_FC_AUDICONF0_SET(x, v) (HW_HDMI_FC_AUDICONF0_WR(x, HW_HDMI_FC_AUDICONF0_RD(x) |  (v)))
#define HW_HDMI_FC_AUDICONF0_CLR(x, v) (HW_HDMI_FC_AUDICONF0_WR(x, HW_HDMI_FC_AUDICONF0_RD(x) & ~(v)))
#define HW_HDMI_FC_AUDICONF0_TOG(x, v) (HW_HDMI_FC_AUDICONF0_WR(x, HW_HDMI_FC_AUDICONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDICONF0 bitfields
 */

/*!
 * @name Register HDMI_FC_AUDICONF0, field CT[3:0] (RW)
 *
 * Coding Type
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF0_CT (0U)       /*!< Bit position for HDMI_FC_AUDICONF0_CT. */
#define BM_HDMI_FC_AUDICONF0_CT (0x0FU)    /*!< Bit mask for HDMI_FC_AUDICONF0_CT. */
#define BS_HDMI_FC_AUDICONF0_CT (4U)       /*!< Bit field size in bits for HDMI_FC_AUDICONF0_CT. */

/*! @brief Read current value of the HDMI_FC_AUDICONF0_CT field. */
#define BR_HDMI_FC_AUDICONF0_CT(x) (HW_HDMI_FC_AUDICONF0(x).B.CT)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF0_CT. */
#define BF_HDMI_FC_AUDICONF0_CT(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF0_CT) & BM_HDMI_FC_AUDICONF0_CT)

/*! @brief Set the CT field to a new value. */
#define BW_HDMI_FC_AUDICONF0_CT(x, v) (HW_HDMI_FC_AUDICONF0_WR(x, (HW_HDMI_FC_AUDICONF0_RD(x) & ~BM_HDMI_FC_AUDICONF0_CT) | BF_HDMI_FC_AUDICONF0_CT(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AUDICONF0, field CC[6:4] (RW)
 *
 * Channel count
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF0_CC (4U)       /*!< Bit position for HDMI_FC_AUDICONF0_CC. */
#define BM_HDMI_FC_AUDICONF0_CC (0x70U)    /*!< Bit mask for HDMI_FC_AUDICONF0_CC. */
#define BS_HDMI_FC_AUDICONF0_CC (3U)       /*!< Bit field size in bits for HDMI_FC_AUDICONF0_CC. */

/*! @brief Read current value of the HDMI_FC_AUDICONF0_CC field. */
#define BR_HDMI_FC_AUDICONF0_CC(x) (HW_HDMI_FC_AUDICONF0(x).B.CC)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF0_CC. */
#define BF_HDMI_FC_AUDICONF0_CC(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF0_CC) & BM_HDMI_FC_AUDICONF0_CC)

/*! @brief Set the CC field to a new value. */
#define BW_HDMI_FC_AUDICONF0_CC(x, v) (HW_HDMI_FC_AUDICONF0_WR(x, (HW_HDMI_FC_AUDICONF0_RD(x) & ~BM_HDMI_FC_AUDICONF0_CC) | BF_HDMI_FC_AUDICONF0_CC(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDICONF1 - Frame Composer AUD Packet Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDICONF1 - Frame Composer AUD Packet Configuration Register 1 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_fc_audiconf1
{
    uint8_t U;
    struct _hw_hdmi_fc_audiconf1_bitfields
    {
        uint8_t SF : 3;                /*!< [2:0]  */
        uint8_t RESERVED0 : 1;         /*!< [3]  */
        uint8_t SS : 2;                /*!< [5:4]  */
        uint8_t RESERVED1 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_fc_audiconf1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDICONF1 register
 */
/*@{*/
#define HW_HDMI_FC_AUDICONF1_ADDR(x) ((uintptr_t)(x) + 0x1026U)

#define HW_HDMI_FC_AUDICONF1(x)  (*(__IO hw_hdmi_fc_audiconf1_t *) HW_HDMI_FC_AUDICONF1_ADDR(x))
#define HW_HDMI_FC_AUDICONF1_RD(x) (HW_HDMI_FC_AUDICONF1(x).U)
#define HW_HDMI_FC_AUDICONF1_WR(x, v) (HW_HDMI_FC_AUDICONF1(x).U = (v))
#define HW_HDMI_FC_AUDICONF1_SET(x, v) (HW_HDMI_FC_AUDICONF1_WR(x, HW_HDMI_FC_AUDICONF1_RD(x) |  (v)))
#define HW_HDMI_FC_AUDICONF1_CLR(x, v) (HW_HDMI_FC_AUDICONF1_WR(x, HW_HDMI_FC_AUDICONF1_RD(x) & ~(v)))
#define HW_HDMI_FC_AUDICONF1_TOG(x, v) (HW_HDMI_FC_AUDICONF1_WR(x, HW_HDMI_FC_AUDICONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDICONF1 bitfields
 */

/*!
 * @name Register HDMI_FC_AUDICONF1, field SF[2:0] (RW)
 *
 * Sampling frequency
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF1_SF (0U)       /*!< Bit position for HDMI_FC_AUDICONF1_SF. */
#define BM_HDMI_FC_AUDICONF1_SF (0x07U)    /*!< Bit mask for HDMI_FC_AUDICONF1_SF. */
#define BS_HDMI_FC_AUDICONF1_SF (3U)       /*!< Bit field size in bits for HDMI_FC_AUDICONF1_SF. */

/*! @brief Read current value of the HDMI_FC_AUDICONF1_SF field. */
#define BR_HDMI_FC_AUDICONF1_SF(x) (HW_HDMI_FC_AUDICONF1(x).B.SF)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF1_SF. */
#define BF_HDMI_FC_AUDICONF1_SF(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF1_SF) & BM_HDMI_FC_AUDICONF1_SF)

/*! @brief Set the SF field to a new value. */
#define BW_HDMI_FC_AUDICONF1_SF(x, v) (HW_HDMI_FC_AUDICONF1_WR(x, (HW_HDMI_FC_AUDICONF1_RD(x) & ~BM_HDMI_FC_AUDICONF1_SF) | BF_HDMI_FC_AUDICONF1_SF(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AUDICONF1, field SS[5:4] (RW)
 *
 * Sampling size
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF1_SS (4U)       /*!< Bit position for HDMI_FC_AUDICONF1_SS. */
#define BM_HDMI_FC_AUDICONF1_SS (0x30U)    /*!< Bit mask for HDMI_FC_AUDICONF1_SS. */
#define BS_HDMI_FC_AUDICONF1_SS (2U)       /*!< Bit field size in bits for HDMI_FC_AUDICONF1_SS. */

/*! @brief Read current value of the HDMI_FC_AUDICONF1_SS field. */
#define BR_HDMI_FC_AUDICONF1_SS(x) (HW_HDMI_FC_AUDICONF1(x).B.SS)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF1_SS. */
#define BF_HDMI_FC_AUDICONF1_SS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF1_SS) & BM_HDMI_FC_AUDICONF1_SS)

/*! @brief Set the SS field to a new value. */
#define BW_HDMI_FC_AUDICONF1_SS(x, v) (HW_HDMI_FC_AUDICONF1_WR(x, (HW_HDMI_FC_AUDICONF1_RD(x) & ~BM_HDMI_FC_AUDICONF1_SS) | BF_HDMI_FC_AUDICONF1_SS(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDICONF2 - Frame Composer AUD Packet Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDICONF2 - Frame Composer AUD Packet Configuration Register 2 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_fc_audiconf2
{
    uint8_t U;
    struct _hw_hdmi_fc_audiconf2_bitfields
    {
        uint8_t CA : 8;                /*!< [7:0]  */
    } B;
} hw_hdmi_fc_audiconf2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDICONF2 register
 */
/*@{*/
#define HW_HDMI_FC_AUDICONF2_ADDR(x) ((uintptr_t)(x) + 0x1027U)

#define HW_HDMI_FC_AUDICONF2(x)  (*(__IO hw_hdmi_fc_audiconf2_t *) HW_HDMI_FC_AUDICONF2_ADDR(x))
#define HW_HDMI_FC_AUDICONF2_RD(x) (HW_HDMI_FC_AUDICONF2(x).U)
#define HW_HDMI_FC_AUDICONF2_WR(x, v) (HW_HDMI_FC_AUDICONF2(x).U = (v))
#define HW_HDMI_FC_AUDICONF2_SET(x, v) (HW_HDMI_FC_AUDICONF2_WR(x, HW_HDMI_FC_AUDICONF2_RD(x) |  (v)))
#define HW_HDMI_FC_AUDICONF2_CLR(x, v) (HW_HDMI_FC_AUDICONF2_WR(x, HW_HDMI_FC_AUDICONF2_RD(x) & ~(v)))
#define HW_HDMI_FC_AUDICONF2_TOG(x, v) (HW_HDMI_FC_AUDICONF2_WR(x, HW_HDMI_FC_AUDICONF2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDICONF2 bitfields
 */

/*!
 * @name Register HDMI_FC_AUDICONF2, field CA[7:0] (RW)
 *
 * Channel allocation
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF2_CA (0U)       /*!< Bit position for HDMI_FC_AUDICONF2_CA. */
#define BM_HDMI_FC_AUDICONF2_CA (0xFFU)    /*!< Bit mask for HDMI_FC_AUDICONF2_CA. */
#define BS_HDMI_FC_AUDICONF2_CA (8U)       /*!< Bit field size in bits for HDMI_FC_AUDICONF2_CA. */

/*! @brief Read current value of the HDMI_FC_AUDICONF2_CA field. */
#define BR_HDMI_FC_AUDICONF2_CA(x) (HW_HDMI_FC_AUDICONF2(x).U)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF2_CA. */
#define BF_HDMI_FC_AUDICONF2_CA(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF2_CA) & BM_HDMI_FC_AUDICONF2_CA)

/*! @brief Set the CA field to a new value. */
#define BW_HDMI_FC_AUDICONF2_CA(x, v) (HW_HDMI_FC_AUDICONF2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDICONF3 - Frame Composer AUD Packet Configuration Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDICONF3 - Frame Composer AUD Packet Configuration Register 3 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_fc_audiconf3
{
    uint8_t U;
    struct _hw_hdmi_fc_audiconf3_bitfields
    {
        uint8_t LSV : 4;               /*!< [3:0]  */
        uint8_t DM_INH : 1;            /*!< [4]  */
        uint8_t LFEPBL : 2;            /*!< [6:5]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_fc_audiconf3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDICONF3 register
 */
/*@{*/
#define HW_HDMI_FC_AUDICONF3_ADDR(x) ((uintptr_t)(x) + 0x1028U)

#define HW_HDMI_FC_AUDICONF3(x)  (*(__IO hw_hdmi_fc_audiconf3_t *) HW_HDMI_FC_AUDICONF3_ADDR(x))
#define HW_HDMI_FC_AUDICONF3_RD(x) (HW_HDMI_FC_AUDICONF3(x).U)
#define HW_HDMI_FC_AUDICONF3_WR(x, v) (HW_HDMI_FC_AUDICONF3(x).U = (v))
#define HW_HDMI_FC_AUDICONF3_SET(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, HW_HDMI_FC_AUDICONF3_RD(x) |  (v)))
#define HW_HDMI_FC_AUDICONF3_CLR(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, HW_HDMI_FC_AUDICONF3_RD(x) & ~(v)))
#define HW_HDMI_FC_AUDICONF3_TOG(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, HW_HDMI_FC_AUDICONF3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDICONF3 bitfields
 */

/*!
 * @name Register HDMI_FC_AUDICONF3, field LSV[3:0] (RW)
 *
 * Level shift value (for down mixing)
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF3_LSV (0U)      /*!< Bit position for HDMI_FC_AUDICONF3_LSV. */
#define BM_HDMI_FC_AUDICONF3_LSV (0x0FU)   /*!< Bit mask for HDMI_FC_AUDICONF3_LSV. */
#define BS_HDMI_FC_AUDICONF3_LSV (4U)      /*!< Bit field size in bits for HDMI_FC_AUDICONF3_LSV. */

/*! @brief Read current value of the HDMI_FC_AUDICONF3_LSV field. */
#define BR_HDMI_FC_AUDICONF3_LSV(x) (HW_HDMI_FC_AUDICONF3(x).B.LSV)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF3_LSV. */
#define BF_HDMI_FC_AUDICONF3_LSV(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF3_LSV) & BM_HDMI_FC_AUDICONF3_LSV)

/*! @brief Set the LSV field to a new value. */
#define BW_HDMI_FC_AUDICONF3_LSV(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, (HW_HDMI_FC_AUDICONF3_RD(x) & ~BM_HDMI_FC_AUDICONF3_LSV) | BF_HDMI_FC_AUDICONF3_LSV(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AUDICONF3, field DM_INH[4] (RW)
 *
 * Down mix enable
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF3_DM_INH (4U)   /*!< Bit position for HDMI_FC_AUDICONF3_DM_INH. */
#define BM_HDMI_FC_AUDICONF3_DM_INH (0x10U) /*!< Bit mask for HDMI_FC_AUDICONF3_DM_INH. */
#define BS_HDMI_FC_AUDICONF3_DM_INH (1U)   /*!< Bit field size in bits for HDMI_FC_AUDICONF3_DM_INH. */

/*! @brief Read current value of the HDMI_FC_AUDICONF3_DM_INH field. */
#define BR_HDMI_FC_AUDICONF3_DM_INH(x) (HW_HDMI_FC_AUDICONF3(x).B.DM_INH)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF3_DM_INH. */
#define BF_HDMI_FC_AUDICONF3_DM_INH(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF3_DM_INH) & BM_HDMI_FC_AUDICONF3_DM_INH)

/*! @brief Set the DM_INH field to a new value. */
#define BW_HDMI_FC_AUDICONF3_DM_INH(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, (HW_HDMI_FC_AUDICONF3_RD(x) & ~BM_HDMI_FC_AUDICONF3_DM_INH) | BF_HDMI_FC_AUDICONF3_DM_INH(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AUDICONF3, field LFEPBL[6:5] (RW)
 *
 * LFE playback information
 */
/*@{*/
#define BP_HDMI_FC_AUDICONF3_LFEPBL (5U)   /*!< Bit position for HDMI_FC_AUDICONF3_LFEPBL. */
#define BM_HDMI_FC_AUDICONF3_LFEPBL (0x60U) /*!< Bit mask for HDMI_FC_AUDICONF3_LFEPBL. */
#define BS_HDMI_FC_AUDICONF3_LFEPBL (2U)   /*!< Bit field size in bits for HDMI_FC_AUDICONF3_LFEPBL. */

/*! @brief Read current value of the HDMI_FC_AUDICONF3_LFEPBL field. */
#define BR_HDMI_FC_AUDICONF3_LFEPBL(x) (HW_HDMI_FC_AUDICONF3(x).B.LFEPBL)

/*! @brief Format value for bitfield HDMI_FC_AUDICONF3_LFEPBL. */
#define BF_HDMI_FC_AUDICONF3_LFEPBL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDICONF3_LFEPBL) & BM_HDMI_FC_AUDICONF3_LFEPBL)

/*! @brief Set the LFEPBL field to a new value. */
#define BW_HDMI_FC_AUDICONF3_LFEPBL(x, v) (HW_HDMI_FC_AUDICONF3_WR(x, (HW_HDMI_FC_AUDICONF3_RD(x) & ~BM_HDMI_FC_AUDICONF3_LFEPBL) | BF_HDMI_FC_AUDICONF3_LFEPBL(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_VSDIEEEID0 - Frame Composer VSI Packet Data IEEE Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDIEEEID0 - Frame Composer VSI Packet Data IEEE Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers configure the Vendor Specific infoFrame IEEE registration
 * identifier. For more information, refer to CEA-861D specification. Address
 * Offset: 0x1029 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdieeeid0
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdieeeid0_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdieeeid0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDIEEEID0 register
 */
/*@{*/
#define HW_HDMI_FC_VSDIEEEID0_ADDR(x) ((uintptr_t)(x) + 0x1029U)

#define HW_HDMI_FC_VSDIEEEID0(x) (*(__IO hw_hdmi_fc_vsdieeeid0_t *) HW_HDMI_FC_VSDIEEEID0_ADDR(x))
#define HW_HDMI_FC_VSDIEEEID0_RD(x) (HW_HDMI_FC_VSDIEEEID0(x).U)
#define HW_HDMI_FC_VSDIEEEID0_WR(x, v) (HW_HDMI_FC_VSDIEEEID0(x).U = (v))
#define HW_HDMI_FC_VSDIEEEID0_SET(x, v) (HW_HDMI_FC_VSDIEEEID0_WR(x, HW_HDMI_FC_VSDIEEEID0_RD(x) |  (v)))
#define HW_HDMI_FC_VSDIEEEID0_CLR(x, v) (HW_HDMI_FC_VSDIEEEID0_WR(x, HW_HDMI_FC_VSDIEEEID0_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDIEEEID0_TOG(x, v) (HW_HDMI_FC_VSDIEEEID0_WR(x, HW_HDMI_FC_VSDIEEEID0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDIEEEID0 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDSIZE - Frame Composer VSI Packet Data Size Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDSIZE - Frame Composer VSI Packet Data Size Register (RW)
 *
 * Reset value: 0x1BU
 *
 * Address Offset: 0x102A Size: 8 bits Value after Reset: 0x1B Access:
 * Read/Write configuration of Packet size.
 */
typedef union _hw_hdmi_fc_vsdsize
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdsize_bitfields
    {
        uint8_t VSDSIZE : 5;           /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_vsdsize_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDSIZE register
 */
/*@{*/
#define HW_HDMI_FC_VSDSIZE_ADDR(x) ((uintptr_t)(x) + 0x102AU)

#define HW_HDMI_FC_VSDSIZE(x)    (*(__IO hw_hdmi_fc_vsdsize_t *) HW_HDMI_FC_VSDSIZE_ADDR(x))
#define HW_HDMI_FC_VSDSIZE_RD(x) (HW_HDMI_FC_VSDSIZE(x).U)
#define HW_HDMI_FC_VSDSIZE_WR(x, v) (HW_HDMI_FC_VSDSIZE(x).U = (v))
#define HW_HDMI_FC_VSDSIZE_SET(x, v) (HW_HDMI_FC_VSDSIZE_WR(x, HW_HDMI_FC_VSDSIZE_RD(x) |  (v)))
#define HW_HDMI_FC_VSDSIZE_CLR(x, v) (HW_HDMI_FC_VSDSIZE_WR(x, HW_HDMI_FC_VSDSIZE_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDSIZE_TOG(x, v) (HW_HDMI_FC_VSDSIZE_WR(x, HW_HDMI_FC_VSDSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDSIZE bitfields
 */

/*!
 * @name Register HDMI_FC_VSDSIZE, field VSDSIZE[4:0] (RW)
 *
 * Packet size as described in HDMI Vendor Specific InfoFrame (from HDMI
 * specification).
 */
/*@{*/
#define BP_HDMI_FC_VSDSIZE_VSDSIZE (0U)    /*!< Bit position for HDMI_FC_VSDSIZE_VSDSIZE. */
#define BM_HDMI_FC_VSDSIZE_VSDSIZE (0x1FU) /*!< Bit mask for HDMI_FC_VSDSIZE_VSDSIZE. */
#define BS_HDMI_FC_VSDSIZE_VSDSIZE (5U)    /*!< Bit field size in bits for HDMI_FC_VSDSIZE_VSDSIZE. */

/*! @brief Read current value of the HDMI_FC_VSDSIZE_VSDSIZE field. */
#define BR_HDMI_FC_VSDSIZE_VSDSIZE(x) (HW_HDMI_FC_VSDSIZE(x).B.VSDSIZE)

/*! @brief Format value for bitfield HDMI_FC_VSDSIZE_VSDSIZE. */
#define BF_HDMI_FC_VSDSIZE_VSDSIZE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_VSDSIZE_VSDSIZE) & BM_HDMI_FC_VSDSIZE_VSDSIZE)

/*! @brief Set the VSDSIZE field to a new value. */
#define BW_HDMI_FC_VSDSIZE_VSDSIZE(x, v) (HW_HDMI_FC_VSDSIZE_WR(x, (HW_HDMI_FC_VSDSIZE_RD(x) & ~BM_HDMI_FC_VSDSIZE_VSDSIZE) | BF_HDMI_FC_VSDSIZE_VSDSIZE(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_VSDIEEEID1 - Frame Composer VSI Packet Data IEEE Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDIEEEID1 - Frame Composer VSI Packet Data IEEE Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x102a Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdieeeid1
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdieeeid1_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdieeeid1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDIEEEID1 register
 */
/*@{*/
#define HW_HDMI_FC_VSDIEEEID1_ADDR(x) ((uintptr_t)(x) + 0x1030U)

#define HW_HDMI_FC_VSDIEEEID1(x) (*(__IO hw_hdmi_fc_vsdieeeid1_t *) HW_HDMI_FC_VSDIEEEID1_ADDR(x))
#define HW_HDMI_FC_VSDIEEEID1_RD(x) (HW_HDMI_FC_VSDIEEEID1(x).U)
#define HW_HDMI_FC_VSDIEEEID1_WR(x, v) (HW_HDMI_FC_VSDIEEEID1(x).U = (v))
#define HW_HDMI_FC_VSDIEEEID1_SET(x, v) (HW_HDMI_FC_VSDIEEEID1_WR(x, HW_HDMI_FC_VSDIEEEID1_RD(x) |  (v)))
#define HW_HDMI_FC_VSDIEEEID1_CLR(x, v) (HW_HDMI_FC_VSDIEEEID1_WR(x, HW_HDMI_FC_VSDIEEEID1_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDIEEEID1_TOG(x, v) (HW_HDMI_FC_VSDIEEEID1_WR(x, HW_HDMI_FC_VSDIEEEID1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDIEEEID1 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDIEEEID2 - Frame Composer VSI Packet Data IEEE Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDIEEEID2 - Frame Composer VSI Packet Data IEEE Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x102b Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdieeeid2
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdieeeid2_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdieeeid2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDIEEEID2 register
 */
/*@{*/
#define HW_HDMI_FC_VSDIEEEID2_ADDR(x) ((uintptr_t)(x) + 0x1031U)

#define HW_HDMI_FC_VSDIEEEID2(x) (*(__IO hw_hdmi_fc_vsdieeeid2_t *) HW_HDMI_FC_VSDIEEEID2_ADDR(x))
#define HW_HDMI_FC_VSDIEEEID2_RD(x) (HW_HDMI_FC_VSDIEEEID2(x).U)
#define HW_HDMI_FC_VSDIEEEID2_WR(x, v) (HW_HDMI_FC_VSDIEEEID2(x).U = (v))
#define HW_HDMI_FC_VSDIEEEID2_SET(x, v) (HW_HDMI_FC_VSDIEEEID2_WR(x, HW_HDMI_FC_VSDIEEEID2_RD(x) |  (v)))
#define HW_HDMI_FC_VSDIEEEID2_CLR(x, v) (HW_HDMI_FC_VSDIEEEID2_WR(x, HW_HDMI_FC_VSDIEEEID2_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDIEEEID2_TOG(x, v) (HW_HDMI_FC_VSDIEEEID2_WR(x, HW_HDMI_FC_VSDIEEEID2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDIEEEID2 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD0 - Frame Composer VSI Packet Data IEEE Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD0 - Frame Composer VSI Packet Data IEEE Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers configure the Vendor Specific infoFrame 24 bytes specific
 * payload. For more information, refer to CEA-861D specification. Address Offset:
 * 0x1032 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload0
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload0_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD0 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD0_ADDR(x) ((uintptr_t)(x) + 0x1032U)

#define HW_HDMI_FC_VSDPAYLOAD0(x) (*(__IO hw_hdmi_fc_vsdpayload0_t *) HW_HDMI_FC_VSDPAYLOAD0_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD0_RD(x) (HW_HDMI_FC_VSDPAYLOAD0(x).U)
#define HW_HDMI_FC_VSDPAYLOAD0_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD0(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD0_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD0_WR(x, HW_HDMI_FC_VSDPAYLOAD0_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD0_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD0_WR(x, HW_HDMI_FC_VSDPAYLOAD0_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD0_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD0_WR(x, HW_HDMI_FC_VSDPAYLOAD0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD0 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD1 - Frame Composer VSI Packet Data IEEE Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD1 - Frame Composer VSI Packet Data IEEE Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1033 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload1
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload1_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD1 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD1_ADDR(x) ((uintptr_t)(x) + 0x1033U)

#define HW_HDMI_FC_VSDPAYLOAD1(x) (*(__IO hw_hdmi_fc_vsdpayload1_t *) HW_HDMI_FC_VSDPAYLOAD1_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD1_RD(x) (HW_HDMI_FC_VSDPAYLOAD1(x).U)
#define HW_HDMI_FC_VSDPAYLOAD1_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD1(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD1_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD1_WR(x, HW_HDMI_FC_VSDPAYLOAD1_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD1_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD1_WR(x, HW_HDMI_FC_VSDPAYLOAD1_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD1_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD1_WR(x, HW_HDMI_FC_VSDPAYLOAD1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD1 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD2 - Frame Composer VSI Packet Data IEEE Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD2 - Frame Composer VSI Packet Data IEEE Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1034 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload2
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload2_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD2 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD2_ADDR(x) ((uintptr_t)(x) + 0x1034U)

#define HW_HDMI_FC_VSDPAYLOAD2(x) (*(__IO hw_hdmi_fc_vsdpayload2_t *) HW_HDMI_FC_VSDPAYLOAD2_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD2_RD(x) (HW_HDMI_FC_VSDPAYLOAD2(x).U)
#define HW_HDMI_FC_VSDPAYLOAD2_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD2(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD2_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD2_WR(x, HW_HDMI_FC_VSDPAYLOAD2_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD2_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD2_WR(x, HW_HDMI_FC_VSDPAYLOAD2_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD2_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD2_WR(x, HW_HDMI_FC_VSDPAYLOAD2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD2 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD3 - Frame Composer VSI Packet Data IEEE Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD3 - Frame Composer VSI Packet Data IEEE Register 3 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1035 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload3
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload3_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD3 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD3_ADDR(x) ((uintptr_t)(x) + 0x1035U)

#define HW_HDMI_FC_VSDPAYLOAD3(x) (*(__IO hw_hdmi_fc_vsdpayload3_t *) HW_HDMI_FC_VSDPAYLOAD3_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD3_RD(x) (HW_HDMI_FC_VSDPAYLOAD3(x).U)
#define HW_HDMI_FC_VSDPAYLOAD3_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD3(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD3_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD3_WR(x, HW_HDMI_FC_VSDPAYLOAD3_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD3_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD3_WR(x, HW_HDMI_FC_VSDPAYLOAD3_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD3_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD3_WR(x, HW_HDMI_FC_VSDPAYLOAD3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD3 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD4 - Frame Composer VSI Packet Data IEEE Register 4
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD4 - Frame Composer VSI Packet Data IEEE Register 4 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1036 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload4
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload4_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD4 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD4_ADDR(x) ((uintptr_t)(x) + 0x1036U)

#define HW_HDMI_FC_VSDPAYLOAD4(x) (*(__IO hw_hdmi_fc_vsdpayload4_t *) HW_HDMI_FC_VSDPAYLOAD4_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD4_RD(x) (HW_HDMI_FC_VSDPAYLOAD4(x).U)
#define HW_HDMI_FC_VSDPAYLOAD4_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD4(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD4_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD4_WR(x, HW_HDMI_FC_VSDPAYLOAD4_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD4_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD4_WR(x, HW_HDMI_FC_VSDPAYLOAD4_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD4_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD4_WR(x, HW_HDMI_FC_VSDPAYLOAD4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD4 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD5 - Frame Composer VSI Packet Data IEEE Register 5
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD5 - Frame Composer VSI Packet Data IEEE Register 5 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1037 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload5
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload5_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD5 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD5_ADDR(x) ((uintptr_t)(x) + 0x1037U)

#define HW_HDMI_FC_VSDPAYLOAD5(x) (*(__IO hw_hdmi_fc_vsdpayload5_t *) HW_HDMI_FC_VSDPAYLOAD5_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD5_RD(x) (HW_HDMI_FC_VSDPAYLOAD5(x).U)
#define HW_HDMI_FC_VSDPAYLOAD5_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD5(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD5_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD5_WR(x, HW_HDMI_FC_VSDPAYLOAD5_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD5_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD5_WR(x, HW_HDMI_FC_VSDPAYLOAD5_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD5_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD5_WR(x, HW_HDMI_FC_VSDPAYLOAD5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD5 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD6 - Frame Composer VSI Packet Data IEEE Register 6
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD6 - Frame Composer VSI Packet Data IEEE Register 6 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1038 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload6
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload6_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD6 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD6_ADDR(x) ((uintptr_t)(x) + 0x1038U)

#define HW_HDMI_FC_VSDPAYLOAD6(x) (*(__IO hw_hdmi_fc_vsdpayload6_t *) HW_HDMI_FC_VSDPAYLOAD6_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD6_RD(x) (HW_HDMI_FC_VSDPAYLOAD6(x).U)
#define HW_HDMI_FC_VSDPAYLOAD6_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD6(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD6_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD6_WR(x, HW_HDMI_FC_VSDPAYLOAD6_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD6_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD6_WR(x, HW_HDMI_FC_VSDPAYLOAD6_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD6_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD6_WR(x, HW_HDMI_FC_VSDPAYLOAD6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD6 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD7 - Frame Composer VSI Packet Data IEEE Register 7
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD7 - Frame Composer VSI Packet Data IEEE Register 7 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1039 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload7
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload7_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD7 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD7_ADDR(x) ((uintptr_t)(x) + 0x1039U)

#define HW_HDMI_FC_VSDPAYLOAD7(x) (*(__IO hw_hdmi_fc_vsdpayload7_t *) HW_HDMI_FC_VSDPAYLOAD7_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD7_RD(x) (HW_HDMI_FC_VSDPAYLOAD7(x).U)
#define HW_HDMI_FC_VSDPAYLOAD7_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD7(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD7_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD7_WR(x, HW_HDMI_FC_VSDPAYLOAD7_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD7_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD7_WR(x, HW_HDMI_FC_VSDPAYLOAD7_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD7_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD7_WR(x, HW_HDMI_FC_VSDPAYLOAD7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD7 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD8 - Frame Composer VSI Packet Data IEEE Register 8
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD8 - Frame Composer VSI Packet Data IEEE Register 8 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103a Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload8
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload8_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload8_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD8 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD8_ADDR(x) ((uintptr_t)(x) + 0x103AU)

#define HW_HDMI_FC_VSDPAYLOAD8(x) (*(__IO hw_hdmi_fc_vsdpayload8_t *) HW_HDMI_FC_VSDPAYLOAD8_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD8_RD(x) (HW_HDMI_FC_VSDPAYLOAD8(x).U)
#define HW_HDMI_FC_VSDPAYLOAD8_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD8(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD8_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD8_WR(x, HW_HDMI_FC_VSDPAYLOAD8_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD8_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD8_WR(x, HW_HDMI_FC_VSDPAYLOAD8_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD8_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD8_WR(x, HW_HDMI_FC_VSDPAYLOAD8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD8 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD9 - Frame Composer VSI Packet Data IEEE Register 9
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD9 - Frame Composer VSI Packet Data IEEE Register 9 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103b Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload9
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload9_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload9_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD9 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD9_ADDR(x) ((uintptr_t)(x) + 0x103BU)

#define HW_HDMI_FC_VSDPAYLOAD9(x) (*(__IO hw_hdmi_fc_vsdpayload9_t *) HW_HDMI_FC_VSDPAYLOAD9_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD9_RD(x) (HW_HDMI_FC_VSDPAYLOAD9(x).U)
#define HW_HDMI_FC_VSDPAYLOAD9_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD9(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD9_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD9_WR(x, HW_HDMI_FC_VSDPAYLOAD9_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD9_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD9_WR(x, HW_HDMI_FC_VSDPAYLOAD9_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD9_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD9_WR(x, HW_HDMI_FC_VSDPAYLOAD9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD9 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD10 - Frame Composer VSI Packet Data IEEE Register 10
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD10 - Frame Composer VSI Packet Data IEEE Register 10 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103c Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload10
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload10_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload10_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD10 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD10_ADDR(x) ((uintptr_t)(x) + 0x103CU)

#define HW_HDMI_FC_VSDPAYLOAD10(x) (*(__IO hw_hdmi_fc_vsdpayload10_t *) HW_HDMI_FC_VSDPAYLOAD10_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD10_RD(x) (HW_HDMI_FC_VSDPAYLOAD10(x).U)
#define HW_HDMI_FC_VSDPAYLOAD10_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD10(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD10_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD10_WR(x, HW_HDMI_FC_VSDPAYLOAD10_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD10_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD10_WR(x, HW_HDMI_FC_VSDPAYLOAD10_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD10_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD10_WR(x, HW_HDMI_FC_VSDPAYLOAD10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD10 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD11 - Frame Composer VSI Packet Data IEEE Register 11
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD11 - Frame Composer VSI Packet Data IEEE Register 11 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103d Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload11
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload11_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload11_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD11 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD11_ADDR(x) ((uintptr_t)(x) + 0x103DU)

#define HW_HDMI_FC_VSDPAYLOAD11(x) (*(__IO hw_hdmi_fc_vsdpayload11_t *) HW_HDMI_FC_VSDPAYLOAD11_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD11_RD(x) (HW_HDMI_FC_VSDPAYLOAD11(x).U)
#define HW_HDMI_FC_VSDPAYLOAD11_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD11(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD11_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD11_WR(x, HW_HDMI_FC_VSDPAYLOAD11_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD11_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD11_WR(x, HW_HDMI_FC_VSDPAYLOAD11_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD11_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD11_WR(x, HW_HDMI_FC_VSDPAYLOAD11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD11 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD12 - Frame Composer VSI Packet Data IEEE Register 12
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD12 - Frame Composer VSI Packet Data IEEE Register 12 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103e Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload12
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload12_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload12_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD12 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD12_ADDR(x) ((uintptr_t)(x) + 0x103EU)

#define HW_HDMI_FC_VSDPAYLOAD12(x) (*(__IO hw_hdmi_fc_vsdpayload12_t *) HW_HDMI_FC_VSDPAYLOAD12_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD12_RD(x) (HW_HDMI_FC_VSDPAYLOAD12(x).U)
#define HW_HDMI_FC_VSDPAYLOAD12_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD12(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD12_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD12_WR(x, HW_HDMI_FC_VSDPAYLOAD12_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD12_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD12_WR(x, HW_HDMI_FC_VSDPAYLOAD12_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD12_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD12_WR(x, HW_HDMI_FC_VSDPAYLOAD12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD12 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD13 - Frame Composer VSI Packet Data IEEE Register 13
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD13 - Frame Composer VSI Packet Data IEEE Register 13 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x103f Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload13
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload13_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload13_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD13 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD13_ADDR(x) ((uintptr_t)(x) + 0x103FU)

#define HW_HDMI_FC_VSDPAYLOAD13(x) (*(__IO hw_hdmi_fc_vsdpayload13_t *) HW_HDMI_FC_VSDPAYLOAD13_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD13_RD(x) (HW_HDMI_FC_VSDPAYLOAD13(x).U)
#define HW_HDMI_FC_VSDPAYLOAD13_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD13(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD13_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD13_WR(x, HW_HDMI_FC_VSDPAYLOAD13_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD13_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD13_WR(x, HW_HDMI_FC_VSDPAYLOAD13_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD13_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD13_WR(x, HW_HDMI_FC_VSDPAYLOAD13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD13 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD14 - Frame Composer VSI Packet Data IEEE Register 14
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD14 - Frame Composer VSI Packet Data IEEE Register 14 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1040 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload14
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload14_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload14_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD14 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD14_ADDR(x) ((uintptr_t)(x) + 0x1040U)

#define HW_HDMI_FC_VSDPAYLOAD14(x) (*(__IO hw_hdmi_fc_vsdpayload14_t *) HW_HDMI_FC_VSDPAYLOAD14_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD14_RD(x) (HW_HDMI_FC_VSDPAYLOAD14(x).U)
#define HW_HDMI_FC_VSDPAYLOAD14_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD14(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD14_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD14_WR(x, HW_HDMI_FC_VSDPAYLOAD14_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD14_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD14_WR(x, HW_HDMI_FC_VSDPAYLOAD14_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD14_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD14_WR(x, HW_HDMI_FC_VSDPAYLOAD14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD14 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD15 - Frame Composer VSI Packet Data IEEE Register 15
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD15 - Frame Composer VSI Packet Data IEEE Register 15 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1041 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload15
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload15_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload15_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD15 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD15_ADDR(x) ((uintptr_t)(x) + 0x1041U)

#define HW_HDMI_FC_VSDPAYLOAD15(x) (*(__IO hw_hdmi_fc_vsdpayload15_t *) HW_HDMI_FC_VSDPAYLOAD15_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD15_RD(x) (HW_HDMI_FC_VSDPAYLOAD15(x).U)
#define HW_HDMI_FC_VSDPAYLOAD15_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD15(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD15_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD15_WR(x, HW_HDMI_FC_VSDPAYLOAD15_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD15_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD15_WR(x, HW_HDMI_FC_VSDPAYLOAD15_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD15_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD15_WR(x, HW_HDMI_FC_VSDPAYLOAD15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD15 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD16 - Frame Composer VSI Packet Data IEEE Register 16
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD16 - Frame Composer VSI Packet Data IEEE Register 16 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1042 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload16
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload16_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload16_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD16 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD16_ADDR(x) ((uintptr_t)(x) + 0x1042U)

#define HW_HDMI_FC_VSDPAYLOAD16(x) (*(__IO hw_hdmi_fc_vsdpayload16_t *) HW_HDMI_FC_VSDPAYLOAD16_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD16_RD(x) (HW_HDMI_FC_VSDPAYLOAD16(x).U)
#define HW_HDMI_FC_VSDPAYLOAD16_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD16(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD16_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD16_WR(x, HW_HDMI_FC_VSDPAYLOAD16_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD16_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD16_WR(x, HW_HDMI_FC_VSDPAYLOAD16_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD16_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD16_WR(x, HW_HDMI_FC_VSDPAYLOAD16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD16 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD17 - Frame Composer VSI Packet Data IEEE Register 17
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD17 - Frame Composer VSI Packet Data IEEE Register 17 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1043 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload17
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload17_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload17_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD17 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD17_ADDR(x) ((uintptr_t)(x) + 0x1043U)

#define HW_HDMI_FC_VSDPAYLOAD17(x) (*(__IO hw_hdmi_fc_vsdpayload17_t *) HW_HDMI_FC_VSDPAYLOAD17_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD17_RD(x) (HW_HDMI_FC_VSDPAYLOAD17(x).U)
#define HW_HDMI_FC_VSDPAYLOAD17_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD17(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD17_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD17_WR(x, HW_HDMI_FC_VSDPAYLOAD17_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD17_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD17_WR(x, HW_HDMI_FC_VSDPAYLOAD17_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD17_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD17_WR(x, HW_HDMI_FC_VSDPAYLOAD17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD17 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD18 - Frame Composer VSI Packet Data IEEE Register 18
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD18 - Frame Composer VSI Packet Data IEEE Register 18 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1044 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload18
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload18_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload18_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD18 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD18_ADDR(x) ((uintptr_t)(x) + 0x1044U)

#define HW_HDMI_FC_VSDPAYLOAD18(x) (*(__IO hw_hdmi_fc_vsdpayload18_t *) HW_HDMI_FC_VSDPAYLOAD18_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD18_RD(x) (HW_HDMI_FC_VSDPAYLOAD18(x).U)
#define HW_HDMI_FC_VSDPAYLOAD18_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD18(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD18_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD18_WR(x, HW_HDMI_FC_VSDPAYLOAD18_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD18_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD18_WR(x, HW_HDMI_FC_VSDPAYLOAD18_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD18_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD18_WR(x, HW_HDMI_FC_VSDPAYLOAD18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD18 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD19 - Frame Composer VSI Packet Data IEEE Register 19
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD19 - Frame Composer VSI Packet Data IEEE Register 19 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1045 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload19
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload19_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload19_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD19 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD19_ADDR(x) ((uintptr_t)(x) + 0x1045U)

#define HW_HDMI_FC_VSDPAYLOAD19(x) (*(__IO hw_hdmi_fc_vsdpayload19_t *) HW_HDMI_FC_VSDPAYLOAD19_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD19_RD(x) (HW_HDMI_FC_VSDPAYLOAD19(x).U)
#define HW_HDMI_FC_VSDPAYLOAD19_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD19(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD19_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD19_WR(x, HW_HDMI_FC_VSDPAYLOAD19_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD19_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD19_WR(x, HW_HDMI_FC_VSDPAYLOAD19_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD19_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD19_WR(x, HW_HDMI_FC_VSDPAYLOAD19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD19 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD20 - Frame Composer VSI Packet Data IEEE Register 20
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD20 - Frame Composer VSI Packet Data IEEE Register 20 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1046 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload20
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload20_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload20_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD20 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD20_ADDR(x) ((uintptr_t)(x) + 0x1046U)

#define HW_HDMI_FC_VSDPAYLOAD20(x) (*(__IO hw_hdmi_fc_vsdpayload20_t *) HW_HDMI_FC_VSDPAYLOAD20_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD20_RD(x) (HW_HDMI_FC_VSDPAYLOAD20(x).U)
#define HW_HDMI_FC_VSDPAYLOAD20_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD20(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD20_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD20_WR(x, HW_HDMI_FC_VSDPAYLOAD20_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD20_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD20_WR(x, HW_HDMI_FC_VSDPAYLOAD20_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD20_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD20_WR(x, HW_HDMI_FC_VSDPAYLOAD20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD20 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD21 - Frame Composer VSI Packet Data IEEE Register 21
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD21 - Frame Composer VSI Packet Data IEEE Register 21 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1047 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload21
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload21_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload21_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD21 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD21_ADDR(x) ((uintptr_t)(x) + 0x1047U)

#define HW_HDMI_FC_VSDPAYLOAD21(x) (*(__IO hw_hdmi_fc_vsdpayload21_t *) HW_HDMI_FC_VSDPAYLOAD21_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD21_RD(x) (HW_HDMI_FC_VSDPAYLOAD21(x).U)
#define HW_HDMI_FC_VSDPAYLOAD21_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD21(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD21_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD21_WR(x, HW_HDMI_FC_VSDPAYLOAD21_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD21_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD21_WR(x, HW_HDMI_FC_VSDPAYLOAD21_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD21_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD21_WR(x, HW_HDMI_FC_VSDPAYLOAD21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD21 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD22 - Frame Composer VSI Packet Data IEEE Register 22
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD22 - Frame Composer VSI Packet Data IEEE Register 22 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1048 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload22
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload22_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload22_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD22 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD22_ADDR(x) ((uintptr_t)(x) + 0x1048U)

#define HW_HDMI_FC_VSDPAYLOAD22(x) (*(__IO hw_hdmi_fc_vsdpayload22_t *) HW_HDMI_FC_VSDPAYLOAD22_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD22_RD(x) (HW_HDMI_FC_VSDPAYLOAD22(x).U)
#define HW_HDMI_FC_VSDPAYLOAD22_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD22(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD22_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD22_WR(x, HW_HDMI_FC_VSDPAYLOAD22_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD22_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD22_WR(x, HW_HDMI_FC_VSDPAYLOAD22_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD22_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD22_WR(x, HW_HDMI_FC_VSDPAYLOAD22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD22 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_VSDPAYLOAD23 - Frame Composer VSI Packet Data IEEE Register 23
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_VSDPAYLOAD23 - Frame Composer VSI Packet Data IEEE Register 23 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1049 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_vsdpayload23
{
    uint8_t U;
    struct _hw_hdmi_fc_vsdpayload23_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_fc_vsdpayload23_t;

/*!
 * @name Constants and macros for entire HDMI_FC_VSDPAYLOAD23 register
 */
/*@{*/
#define HW_HDMI_FC_VSDPAYLOAD23_ADDR(x) ((uintptr_t)(x) + 0x1049U)

#define HW_HDMI_FC_VSDPAYLOAD23(x) (*(__IO hw_hdmi_fc_vsdpayload23_t *) HW_HDMI_FC_VSDPAYLOAD23_ADDR(x))
#define HW_HDMI_FC_VSDPAYLOAD23_RD(x) (HW_HDMI_FC_VSDPAYLOAD23(x).U)
#define HW_HDMI_FC_VSDPAYLOAD23_WR(x, v) (HW_HDMI_FC_VSDPAYLOAD23(x).U = (v))
#define HW_HDMI_FC_VSDPAYLOAD23_SET(x, v) (HW_HDMI_FC_VSDPAYLOAD23_WR(x, HW_HDMI_FC_VSDPAYLOAD23_RD(x) |  (v)))
#define HW_HDMI_FC_VSDPAYLOAD23_CLR(x, v) (HW_HDMI_FC_VSDPAYLOAD23_WR(x, HW_HDMI_FC_VSDPAYLOAD23_RD(x) & ~(v)))
#define HW_HDMI_FC_VSDPAYLOAD23_TOG(x, v) (HW_HDMI_FC_VSDPAYLOAD23_WR(x, HW_HDMI_FC_VSDPAYLOAD23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_VSDPAYLOAD23 bitfields
 */

/*******************************************************************************
 * HW_HDMI_FC_SPDVENDORNAME0 - Frame Composer SPD Packet Data Vendor Name Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_SPDVENDORNAME0 - Frame Composer SPD Packet Data Vendor Name Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers configure the Source Product Descriptor infoFrame 8 bytes
 * Vendor name. For more information, refer to CEA-861D specification. Address
 * Offset: 0x104A to 0x1051 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_spdvendorname0
{
    uint8_t U;
    struct _hw_hdmi_fc_spdvendorname0_bitfields
    {
        uint8_t vendor_name : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_spdvendorname0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_SPDVENDORNAME0 register
 */
/*@{*/
#define HW_HDMI_FC_SPDVENDORNAME0_ADDR(x) ((uintptr_t)(x) + 0x104AU)

#define HW_HDMI_FC_SPDVENDORNAME0(x) (*(__IO hw_hdmi_fc_spdvendorname0_t *) HW_HDMI_FC_SPDVENDORNAME0_ADDR(x))
#define HW_HDMI_FC_SPDVENDORNAME0_RD(x) (HW_HDMI_FC_SPDVENDORNAME0(x).U)
#define HW_HDMI_FC_SPDVENDORNAME0_WR(x, v) (HW_HDMI_FC_SPDVENDORNAME0(x).U = (v))
#define HW_HDMI_FC_SPDVENDORNAME0_SET(x, v) (HW_HDMI_FC_SPDVENDORNAME0_WR(x, HW_HDMI_FC_SPDVENDORNAME0_RD(x) |  (v)))
#define HW_HDMI_FC_SPDVENDORNAME0_CLR(x, v) (HW_HDMI_FC_SPDVENDORNAME0_WR(x, HW_HDMI_FC_SPDVENDORNAME0_RD(x) & ~(v)))
#define HW_HDMI_FC_SPDVENDORNAME0_TOG(x, v) (HW_HDMI_FC_SPDVENDORNAME0_WR(x, HW_HDMI_FC_SPDVENDORNAME0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_SPDVENDORNAME0 bitfields
 */

/*!
 * @name Register HDMI_FC_SPDVENDORNAME0, field vendor_name[7:0] (RW)
 *
 * Vendor name
 */
/*@{*/
#define BP_HDMI_FC_SPDVENDORNAME0_vendor_name (0U) /*!< Bit position for HDMI_FC_SPDVENDORNAME0_vendor_name. */
#define BM_HDMI_FC_SPDVENDORNAME0_vendor_name (0xFFU) /*!< Bit mask for HDMI_FC_SPDVENDORNAME0_vendor_name. */
#define BS_HDMI_FC_SPDVENDORNAME0_vendor_name (8U) /*!< Bit field size in bits for HDMI_FC_SPDVENDORNAME0_vendor_name. */

/*! @brief Read current value of the HDMI_FC_SPDVENDORNAME0_vendor_name field. */
#define BR_HDMI_FC_SPDVENDORNAME0_vendor_name(x) (HW_HDMI_FC_SPDVENDORNAME0(x).U)

/*! @brief Format value for bitfield HDMI_FC_SPDVENDORNAME0_vendor_name. */
#define BF_HDMI_FC_SPDVENDORNAME0_vendor_name(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_SPDVENDORNAME0_vendor_name) & BM_HDMI_FC_SPDVENDORNAME0_vendor_name)

/*! @brief Set the vendor_name field to a new value. */
#define BW_HDMI_FC_SPDVENDORNAME0_vendor_name(x, v) (HW_HDMI_FC_SPDVENDORNAME0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_SPDPRODUCTNAME0 - Frame Composer SPD Packet Data Product Name Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_SPDPRODUCTNAME0 - Frame Composer SPD Packet Data Product Name Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers configure the Source Product Descriptor infoFrame 16 bytes
 * Product name. For more information, refer to CEA-861D specification. Address
 * Offset: 0x1052 to 0x1061 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_spdproductname0
{
    uint8_t U;
    struct _hw_hdmi_fc_spdproductname0_bitfields
    {
        uint8_t product_name : 8;      /*!< [7:0]  */
    } B;
} hw_hdmi_fc_spdproductname0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_SPDPRODUCTNAME0 register
 */
/*@{*/
#define HW_HDMI_FC_SPDPRODUCTNAME0_ADDR(x) ((uintptr_t)(x) + 0x1052U)

#define HW_HDMI_FC_SPDPRODUCTNAME0(x) (*(__IO hw_hdmi_fc_spdproductname0_t *) HW_HDMI_FC_SPDPRODUCTNAME0_ADDR(x))
#define HW_HDMI_FC_SPDPRODUCTNAME0_RD(x) (HW_HDMI_FC_SPDPRODUCTNAME0(x).U)
#define HW_HDMI_FC_SPDPRODUCTNAME0_WR(x, v) (HW_HDMI_FC_SPDPRODUCTNAME0(x).U = (v))
#define HW_HDMI_FC_SPDPRODUCTNAME0_SET(x, v) (HW_HDMI_FC_SPDPRODUCTNAME0_WR(x, HW_HDMI_FC_SPDPRODUCTNAME0_RD(x) |  (v)))
#define HW_HDMI_FC_SPDPRODUCTNAME0_CLR(x, v) (HW_HDMI_FC_SPDPRODUCTNAME0_WR(x, HW_HDMI_FC_SPDPRODUCTNAME0_RD(x) & ~(v)))
#define HW_HDMI_FC_SPDPRODUCTNAME0_TOG(x, v) (HW_HDMI_FC_SPDPRODUCTNAME0_WR(x, HW_HDMI_FC_SPDPRODUCTNAME0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_SPDPRODUCTNAME0 bitfields
 */

/*!
 * @name Register HDMI_FC_SPDPRODUCTNAME0, field product_name[7:0] (RW)
 *
 * Product name
 */
/*@{*/
#define BP_HDMI_FC_SPDPRODUCTNAME0_product_name (0U) /*!< Bit position for HDMI_FC_SPDPRODUCTNAME0_product_name. */
#define BM_HDMI_FC_SPDPRODUCTNAME0_product_name (0xFFU) /*!< Bit mask for HDMI_FC_SPDPRODUCTNAME0_product_name. */
#define BS_HDMI_FC_SPDPRODUCTNAME0_product_name (8U) /*!< Bit field size in bits for HDMI_FC_SPDPRODUCTNAME0_product_name. */

/*! @brief Read current value of the HDMI_FC_SPDPRODUCTNAME0_product_name field. */
#define BR_HDMI_FC_SPDPRODUCTNAME0_product_name(x) (HW_HDMI_FC_SPDPRODUCTNAME0(x).U)

/*! @brief Format value for bitfield HDMI_FC_SPDPRODUCTNAME0_product_name. */
#define BF_HDMI_FC_SPDPRODUCTNAME0_product_name(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_SPDPRODUCTNAME0_product_name) & BM_HDMI_FC_SPDPRODUCTNAME0_product_name)

/*! @brief Set the product_name field to a new value. */
#define BW_HDMI_FC_SPDPRODUCTNAME0_product_name(x, v) (HW_HDMI_FC_SPDPRODUCTNAME0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_SPDDEVICEINF - Frame Composer SPD Packet Data Source Product Descriptor Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_SPDDEVICEINF - Frame Composer SPD Packet Data Source Product Descriptor Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register configures Source Product Descriptor infoFrame description
 * device field. For more information, refer to CEA-861D specification. Address
 * Offset: 0x1062 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_spddeviceinf
{
    uint8_t U;
    struct _hw_hdmi_fc_spddeviceinf_bitfields
    {
        uint8_t product_descriptor : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_spddeviceinf_t;

/*!
 * @name Constants and macros for entire HDMI_FC_SPDDEVICEINF register
 */
/*@{*/
#define HW_HDMI_FC_SPDDEVICEINF_ADDR(x) ((uintptr_t)(x) + 0x1062U)

#define HW_HDMI_FC_SPDDEVICEINF(x) (*(__IO hw_hdmi_fc_spddeviceinf_t *) HW_HDMI_FC_SPDDEVICEINF_ADDR(x))
#define HW_HDMI_FC_SPDDEVICEINF_RD(x) (HW_HDMI_FC_SPDDEVICEINF(x).U)
#define HW_HDMI_FC_SPDDEVICEINF_WR(x, v) (HW_HDMI_FC_SPDDEVICEINF(x).U = (v))
#define HW_HDMI_FC_SPDDEVICEINF_SET(x, v) (HW_HDMI_FC_SPDDEVICEINF_WR(x, HW_HDMI_FC_SPDDEVICEINF_RD(x) |  (v)))
#define HW_HDMI_FC_SPDDEVICEINF_CLR(x, v) (HW_HDMI_FC_SPDDEVICEINF_WR(x, HW_HDMI_FC_SPDDEVICEINF_RD(x) & ~(v)))
#define HW_HDMI_FC_SPDDEVICEINF_TOG(x, v) (HW_HDMI_FC_SPDDEVICEINF_WR(x, HW_HDMI_FC_SPDDEVICEINF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_SPDDEVICEINF bitfields
 */

/*!
 * @name Register HDMI_FC_SPDDEVICEINF, field product_descriptor[7:0] (RW)
 *
 * Product descriptor
 */
/*@{*/
#define BP_HDMI_FC_SPDDEVICEINF_product_descriptor (0U) /*!< Bit position for HDMI_FC_SPDDEVICEINF_product_descriptor. */
#define BM_HDMI_FC_SPDDEVICEINF_product_descriptor (0xFFU) /*!< Bit mask for HDMI_FC_SPDDEVICEINF_product_descriptor. */
#define BS_HDMI_FC_SPDDEVICEINF_product_descriptor (8U) /*!< Bit field size in bits for HDMI_FC_SPDDEVICEINF_product_descriptor. */

/*! @brief Read current value of the HDMI_FC_SPDDEVICEINF_product_descriptor field. */
#define BR_HDMI_FC_SPDDEVICEINF_product_descriptor(x) (HW_HDMI_FC_SPDDEVICEINF(x).U)

/*! @brief Format value for bitfield HDMI_FC_SPDDEVICEINF_product_descriptor. */
#define BF_HDMI_FC_SPDDEVICEINF_product_descriptor(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_SPDDEVICEINF_product_descriptor) & BM_HDMI_FC_SPDDEVICEINF_product_descriptor)

/*! @brief Set the product_descriptor field to a new value. */
#define BW_HDMI_FC_SPDDEVICEINF_product_descriptor(x, v) (HW_HDMI_FC_SPDDEVICEINF_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDSCONF - Frame Composer Audio Sample Flat and Layout Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDSCONF - Frame Composer Audio Sample Flat and Layout Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Audio sample packet sample flat and layout configuration. For
 * more information, refer to HDMI 1.4a specification. Address Offset: 0x1063
 * Size: 8 bits Value after Reset: 0x00 AEccess: Read/Write
 */
typedef union _hw_hdmi_fc_audsconf
{
    uint8_t U;
    struct _hw_hdmi_fc_audsconf_bitfields
    {
        uint8_t aud_packet_layout : 1; /*!< [0]  */
        uint8_t RESERVED0 : 3;         /*!< [3:1]  */
        uint8_t aud_packet_sampfit : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_audsconf_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDSCONF register
 */
/*@{*/
#define HW_HDMI_FC_AUDSCONF_ADDR(x) ((uintptr_t)(x) + 0x1063U)

#define HW_HDMI_FC_AUDSCONF(x)   (*(__IO hw_hdmi_fc_audsconf_t *) HW_HDMI_FC_AUDSCONF_ADDR(x))
#define HW_HDMI_FC_AUDSCONF_RD(x) (HW_HDMI_FC_AUDSCONF(x).U)
#define HW_HDMI_FC_AUDSCONF_WR(x, v) (HW_HDMI_FC_AUDSCONF(x).U = (v))
#define HW_HDMI_FC_AUDSCONF_SET(x, v) (HW_HDMI_FC_AUDSCONF_WR(x, HW_HDMI_FC_AUDSCONF_RD(x) |  (v)))
#define HW_HDMI_FC_AUDSCONF_CLR(x, v) (HW_HDMI_FC_AUDSCONF_WR(x, HW_HDMI_FC_AUDSCONF_RD(x) & ~(v)))
#define HW_HDMI_FC_AUDSCONF_TOG(x, v) (HW_HDMI_FC_AUDSCONF_WR(x, HW_HDMI_FC_AUDSCONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDSCONF bitfields
 */

/*!
 * @name Register HDMI_FC_AUDSCONF, field aud_packet_layout[0] (RW)
 *
 * Set the audio packet layout to be sent in the packet:
 *
 * Values:
 * - 1 - layout 1
 * - 0 - layout 0
 */
/*@{*/
#define BP_HDMI_FC_AUDSCONF_aud_packet_layout (0U) /*!< Bit position for HDMI_FC_AUDSCONF_aud_packet_layout. */
#define BM_HDMI_FC_AUDSCONF_aud_packet_layout (0x01U) /*!< Bit mask for HDMI_FC_AUDSCONF_aud_packet_layout. */
#define BS_HDMI_FC_AUDSCONF_aud_packet_layout (1U) /*!< Bit field size in bits for HDMI_FC_AUDSCONF_aud_packet_layout. */

/*! @brief Read current value of the HDMI_FC_AUDSCONF_aud_packet_layout field. */
#define BR_HDMI_FC_AUDSCONF_aud_packet_layout(x) (HW_HDMI_FC_AUDSCONF(x).B.aud_packet_layout)

/*! @brief Format value for bitfield HDMI_FC_AUDSCONF_aud_packet_layout. */
#define BF_HDMI_FC_AUDSCONF_aud_packet_layout(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDSCONF_aud_packet_layout) & BM_HDMI_FC_AUDSCONF_aud_packet_layout)

/*! @brief Set the aud_packet_layout field to a new value. */
#define BW_HDMI_FC_AUDSCONF_aud_packet_layout(x, v) (HW_HDMI_FC_AUDSCONF_WR(x, (HW_HDMI_FC_AUDSCONF_RD(x) & ~BM_HDMI_FC_AUDSCONF_aud_packet_layout) | BF_HDMI_FC_AUDSCONF_aud_packet_layout(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_AUDSCONF, field aud_packet_sampfit[7:4] (RW)
 *
 * Set the audio packet sample flat value to be sent on the packet.
 */
/*@{*/
#define BP_HDMI_FC_AUDSCONF_aud_packet_sampfit (4U) /*!< Bit position for HDMI_FC_AUDSCONF_aud_packet_sampfit. */
#define BM_HDMI_FC_AUDSCONF_aud_packet_sampfit (0xF0U) /*!< Bit mask for HDMI_FC_AUDSCONF_aud_packet_sampfit. */
#define BS_HDMI_FC_AUDSCONF_aud_packet_sampfit (4U) /*!< Bit field size in bits for HDMI_FC_AUDSCONF_aud_packet_sampfit. */

/*! @brief Read current value of the HDMI_FC_AUDSCONF_aud_packet_sampfit field. */
#define BR_HDMI_FC_AUDSCONF_aud_packet_sampfit(x) (HW_HDMI_FC_AUDSCONF(x).B.aud_packet_sampfit)

/*! @brief Format value for bitfield HDMI_FC_AUDSCONF_aud_packet_sampfit. */
#define BF_HDMI_FC_AUDSCONF_aud_packet_sampfit(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_AUDSCONF_aud_packet_sampfit) & BM_HDMI_FC_AUDSCONF_aud_packet_sampfit)

/*! @brief Set the aud_packet_sampfit field to a new value. */
#define BW_HDMI_FC_AUDSCONF_aud_packet_sampfit(x, v) (HW_HDMI_FC_AUDSCONF_WR(x, (HW_HDMI_FC_AUDSCONF_RD(x) & ~BM_HDMI_FC_AUDSCONF_aud_packet_sampfit) | BF_HDMI_FC_AUDSCONF_aud_packet_sampfit(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_AUDSSTAT - Frame Composer Audio Packet Sample Present Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_AUDSSTAT - Frame Composer Audio Packet Sample Present Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * Shows the data sample present indication of the last Audio sample packet sent
 * by the HDMI TX Controller. For more information, refer to HDMI 1.4a
 * specification. Address Offset: 0x1064 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_fc_audsstat
{
    uint8_t U;
    struct _hw_hdmi_fc_audsstat_bitfields
    {
        uint8_t packet_sampprs : 4;    /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_audsstat_t;

/*!
 * @name Constants and macros for entire HDMI_FC_AUDSSTAT register
 */
/*@{*/
#define HW_HDMI_FC_AUDSSTAT_ADDR(x) ((uintptr_t)(x) + 0x1064U)

#define HW_HDMI_FC_AUDSSTAT(x)   (*(__I hw_hdmi_fc_audsstat_t *) HW_HDMI_FC_AUDSSTAT_ADDR(x))
#define HW_HDMI_FC_AUDSSTAT_RD(x) (HW_HDMI_FC_AUDSSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_AUDSSTAT bitfields
 */

/*!
 * @name Register HDMI_FC_AUDSSTAT, field packet_sampprs[3:0] (RO)
 *
 * Shows the data sample present indication of the last Audio sample packet sent
 * by the HDMI TX Controller. This register information is at tmds clock rate.
 */
/*@{*/
#define BP_HDMI_FC_AUDSSTAT_packet_sampprs (0U) /*!< Bit position for HDMI_FC_AUDSSTAT_packet_sampprs. */
#define BM_HDMI_FC_AUDSSTAT_packet_sampprs (0x0FU) /*!< Bit mask for HDMI_FC_AUDSSTAT_packet_sampprs. */
#define BS_HDMI_FC_AUDSSTAT_packet_sampprs (4U) /*!< Bit field size in bits for HDMI_FC_AUDSSTAT_packet_sampprs. */

/*! @brief Read current value of the HDMI_FC_AUDSSTAT_packet_sampprs field. */
#define BR_HDMI_FC_AUDSSTAT_packet_sampprs(x) (HW_HDMI_FC_AUDSSTAT(x).B.packet_sampprs)
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CTRLQHIGH - Frame Composer Number of High Priority Packets Attended Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CTRLQHIGH - Frame Composer Number of High Priority Packets Attended Configuration Register (RW)
 *
 * Reset value: 0x0FU
 *
 * Address Offset: 0x1073 Size: 8 bits Value after Reset: 0x0F Access: Read/Write
 */
typedef union _hw_hdmi_fc_ctrlqhigh
{
    uint8_t U;
    struct _hw_hdmi_fc_ctrlqhigh_bitfields
    {
        uint8_t onhighattended : 5;    /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_ctrlqhigh_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CTRLQHIGH register
 */
/*@{*/
#define HW_HDMI_FC_CTRLQHIGH_ADDR(x) ((uintptr_t)(x) + 0x1073U)

#define HW_HDMI_FC_CTRLQHIGH(x)  (*(__IO hw_hdmi_fc_ctrlqhigh_t *) HW_HDMI_FC_CTRLQHIGH_ADDR(x))
#define HW_HDMI_FC_CTRLQHIGH_RD(x) (HW_HDMI_FC_CTRLQHIGH(x).U)
#define HW_HDMI_FC_CTRLQHIGH_WR(x, v) (HW_HDMI_FC_CTRLQHIGH(x).U = (v))
#define HW_HDMI_FC_CTRLQHIGH_SET(x, v) (HW_HDMI_FC_CTRLQHIGH_WR(x, HW_HDMI_FC_CTRLQHIGH_RD(x) |  (v)))
#define HW_HDMI_FC_CTRLQHIGH_CLR(x, v) (HW_HDMI_FC_CTRLQHIGH_WR(x, HW_HDMI_FC_CTRLQHIGH_RD(x) & ~(v)))
#define HW_HDMI_FC_CTRLQHIGH_TOG(x, v) (HW_HDMI_FC_CTRLQHIGH_WR(x, HW_HDMI_FC_CTRLQHIGH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CTRLQHIGH bitfields
 */

/*!
 * @name Register HDMI_FC_CTRLQHIGH, field onhighattended[4:0] (RW)
 *
 * Configures the number of high priority packets or audio sample packets
 * consecutively attended before checking low priority queue status. Integer number
 * [0..31]
 */
/*@{*/
#define BP_HDMI_FC_CTRLQHIGH_onhighattended (0U) /*!< Bit position for HDMI_FC_CTRLQHIGH_onhighattended. */
#define BM_HDMI_FC_CTRLQHIGH_onhighattended (0x1FU) /*!< Bit mask for HDMI_FC_CTRLQHIGH_onhighattended. */
#define BS_HDMI_FC_CTRLQHIGH_onhighattended (5U) /*!< Bit field size in bits for HDMI_FC_CTRLQHIGH_onhighattended. */

/*! @brief Read current value of the HDMI_FC_CTRLQHIGH_onhighattended field. */
#define BR_HDMI_FC_CTRLQHIGH_onhighattended(x) (HW_HDMI_FC_CTRLQHIGH(x).B.onhighattended)

/*! @brief Format value for bitfield HDMI_FC_CTRLQHIGH_onhighattended. */
#define BF_HDMI_FC_CTRLQHIGH_onhighattended(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CTRLQHIGH_onhighattended) & BM_HDMI_FC_CTRLQHIGH_onhighattended)

/*! @brief Set the onhighattended field to a new value. */
#define BW_HDMI_FC_CTRLQHIGH_onhighattended(x, v) (HW_HDMI_FC_CTRLQHIGH_WR(x, (HW_HDMI_FC_CTRLQHIGH_RD(x) & ~BM_HDMI_FC_CTRLQHIGH_onhighattended) | BF_HDMI_FC_CTRLQHIGH_onhighattended(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_CTRLQLOW - Frame Composer Number of Low Priority Packets Attended Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_CTRLQLOW - Frame Composer Number of Low Priority Packets Attended Configuration Register (RW)
 *
 * Reset value: 0x03U
 *
 * Address Offset: 0x1074 Size: 8 bits Value after Reset: 0x03 Access: Read/Write
 */
typedef union _hw_hdmi_fc_ctrlqlow
{
    uint8_t U;
    struct _hw_hdmi_fc_ctrlqlow_bitfields
    {
        uint8_t onlowattended : 5;     /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_ctrlqlow_t;

/*!
 * @name Constants and macros for entire HDMI_FC_CTRLQLOW register
 */
/*@{*/
#define HW_HDMI_FC_CTRLQLOW_ADDR(x) ((uintptr_t)(x) + 0x1074U)

#define HW_HDMI_FC_CTRLQLOW(x)   (*(__IO hw_hdmi_fc_ctrlqlow_t *) HW_HDMI_FC_CTRLQLOW_ADDR(x))
#define HW_HDMI_FC_CTRLQLOW_RD(x) (HW_HDMI_FC_CTRLQLOW(x).U)
#define HW_HDMI_FC_CTRLQLOW_WR(x, v) (HW_HDMI_FC_CTRLQLOW(x).U = (v))
#define HW_HDMI_FC_CTRLQLOW_SET(x, v) (HW_HDMI_FC_CTRLQLOW_WR(x, HW_HDMI_FC_CTRLQLOW_RD(x) |  (v)))
#define HW_HDMI_FC_CTRLQLOW_CLR(x, v) (HW_HDMI_FC_CTRLQLOW_WR(x, HW_HDMI_FC_CTRLQLOW_RD(x) & ~(v)))
#define HW_HDMI_FC_CTRLQLOW_TOG(x, v) (HW_HDMI_FC_CTRLQLOW_WR(x, HW_HDMI_FC_CTRLQLOW_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_CTRLQLOW bitfields
 */

/*!
 * @name Register HDMI_FC_CTRLQLOW, field onlowattended[4:0] (RW)
 *
 * Configures the number of low priority packets or null packets consecutively
 * attended before checking high priority queue status or audio sample
 * availability. Integer number [0..31]
 */
/*@{*/
#define BP_HDMI_FC_CTRLQLOW_onlowattended (0U) /*!< Bit position for HDMI_FC_CTRLQLOW_onlowattended. */
#define BM_HDMI_FC_CTRLQLOW_onlowattended (0x1FU) /*!< Bit mask for HDMI_FC_CTRLQLOW_onlowattended. */
#define BS_HDMI_FC_CTRLQLOW_onlowattended (5U) /*!< Bit field size in bits for HDMI_FC_CTRLQLOW_onlowattended. */

/*! @brief Read current value of the HDMI_FC_CTRLQLOW_onlowattended field. */
#define BR_HDMI_FC_CTRLQLOW_onlowattended(x) (HW_HDMI_FC_CTRLQLOW(x).B.onlowattended)

/*! @brief Format value for bitfield HDMI_FC_CTRLQLOW_onlowattended. */
#define BF_HDMI_FC_CTRLQLOW_onlowattended(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_CTRLQLOW_onlowattended) & BM_HDMI_FC_CTRLQLOW_onlowattended)

/*! @brief Set the onlowattended field to a new value. */
#define BW_HDMI_FC_CTRLQLOW_onlowattended(x, v) (HW_HDMI_FC_CTRLQLOW_WR(x, (HW_HDMI_FC_CTRLQLOW_RD(x) & ~BM_HDMI_FC_CTRLQLOW_onlowattended) | BF_HDMI_FC_CTRLQLOW_onlowattended(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_ACP0 - Frame Composer ACP Packet Type Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_ACP0 - Frame Composer ACP Packet Type Configuration Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the ACP packet. For more information,
 * refer to the HDMI 1.4 specification. Address Offset: 0x1075 Size: 8 bits Value
 * after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_acp0
{
    uint8_t U;
    struct _hw_hdmi_fc_acp0_bitfields
    {
        uint8_t acptype : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_fc_acp0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_ACP0 register
 */
/*@{*/
#define HW_HDMI_FC_ACP0_ADDR(x)  ((uintptr_t)(x) + 0x1075U)

#define HW_HDMI_FC_ACP0(x)       (*(__IO hw_hdmi_fc_acp0_t *) HW_HDMI_FC_ACP0_ADDR(x))
#define HW_HDMI_FC_ACP0_RD(x)    (HW_HDMI_FC_ACP0(x).U)
#define HW_HDMI_FC_ACP0_WR(x, v) (HW_HDMI_FC_ACP0(x).U = (v))
#define HW_HDMI_FC_ACP0_SET(x, v) (HW_HDMI_FC_ACP0_WR(x, HW_HDMI_FC_ACP0_RD(x) |  (v)))
#define HW_HDMI_FC_ACP0_CLR(x, v) (HW_HDMI_FC_ACP0_WR(x, HW_HDMI_FC_ACP0_RD(x) & ~(v)))
#define HW_HDMI_FC_ACP0_TOG(x, v) (HW_HDMI_FC_ACP0_WR(x, HW_HDMI_FC_ACP0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_ACP0 bitfields
 */

/*!
 * @name Register HDMI_FC_ACP0, field acptype[7:0] (RW)
 *
 * Configures the ACP packet type.
 */
/*@{*/
#define BP_HDMI_FC_ACP0_acptype (0U)       /*!< Bit position for HDMI_FC_ACP0_acptype. */
#define BM_HDMI_FC_ACP0_acptype (0xFFU)    /*!< Bit mask for HDMI_FC_ACP0_acptype. */
#define BS_HDMI_FC_ACP0_acptype (8U)       /*!< Bit field size in bits for HDMI_FC_ACP0_acptype. */

/*! @brief Read current value of the HDMI_FC_ACP0_acptype field. */
#define BR_HDMI_FC_ACP0_acptype(x) (HW_HDMI_FC_ACP0(x).U)

/*! @brief Format value for bitfield HDMI_FC_ACP0_acptype. */
#define BF_HDMI_FC_ACP0_acptype(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ACP0_acptype) & BM_HDMI_FC_ACP0_acptype)

/*! @brief Set the acptype field to a new value. */
#define BW_HDMI_FC_ACP0_acptype(x, v) (HW_HDMI_FC_ACP0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_ACP1 - Frame Composer ACP Packet Type Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_ACP1 - Frame Composer ACP Packet Type Configuration Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the Audio Content Packet (ACP) body:
 * Address Offset: 0x1091 to 0x1082 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_acp1
{
    uint8_t U;
    struct _hw_hdmi_fc_acp1_bitfields
    {
        uint8_t Audio_contentpacket : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_fc_acp1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_ACP1 register
 */
/*@{*/
#define HW_HDMI_FC_ACP1_ADDR(x)  ((uintptr_t)(x) + 0x1091U)

#define HW_HDMI_FC_ACP1(x)       (*(__IO hw_hdmi_fc_acp1_t *) HW_HDMI_FC_ACP1_ADDR(x))
#define HW_HDMI_FC_ACP1_RD(x)    (HW_HDMI_FC_ACP1(x).U)
#define HW_HDMI_FC_ACP1_WR(x, v) (HW_HDMI_FC_ACP1(x).U = (v))
#define HW_HDMI_FC_ACP1_SET(x, v) (HW_HDMI_FC_ACP1_WR(x, HW_HDMI_FC_ACP1_RD(x) |  (v)))
#define HW_HDMI_FC_ACP1_CLR(x, v) (HW_HDMI_FC_ACP1_WR(x, HW_HDMI_FC_ACP1_RD(x) & ~(v)))
#define HW_HDMI_FC_ACP1_TOG(x, v) (HW_HDMI_FC_ACP1_WR(x, HW_HDMI_FC_ACP1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_ACP1 bitfields
 */

/*!
 * @name Register HDMI_FC_ACP1, field Audio_contentpacket[7:0] (RW)
 *
 * Audio content packet
 */
/*@{*/
#define BP_HDMI_FC_ACP1_Audio_contentpacket (0U) /*!< Bit position for HDMI_FC_ACP1_Audio_contentpacket. */
#define BM_HDMI_FC_ACP1_Audio_contentpacket (0xFFU) /*!< Bit mask for HDMI_FC_ACP1_Audio_contentpacket. */
#define BS_HDMI_FC_ACP1_Audio_contentpacket (8U) /*!< Bit field size in bits for HDMI_FC_ACP1_Audio_contentpacket. */

/*! @brief Read current value of the HDMI_FC_ACP1_Audio_contentpacket field. */
#define BR_HDMI_FC_ACP1_Audio_contentpacket(x) (HW_HDMI_FC_ACP1(x).U)

/*! @brief Format value for bitfield HDMI_FC_ACP1_Audio_contentpacket. */
#define BF_HDMI_FC_ACP1_Audio_contentpacket(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ACP1_Audio_contentpacket) & BM_HDMI_FC_ACP1_Audio_contentpacket)

/*! @brief Set the Audio_contentpacket field to a new value. */
#define BW_HDMI_FC_ACP1_Audio_contentpacket(x, v) (HW_HDMI_FC_ACP1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_ISCR1_0 - FC_ISCR1_Frame Composer Packet Status, Valid, and Continue Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_ISCR1_0 - FC_ISCR1_Frame Composer Packet Status, Valid, and Continue Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the ISRC1 packet: Address Offset: 0x1092
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write For more information,
 * see the HDMI 1.4 specification.
 */
typedef union _hw_hdmi_fc_iscr1_0
{
    uint8_t U;
    struct _hw_hdmi_fc_iscr1_0_bitfields
    {
        uint8_t isrc_cont : 1;         /*!< [0]  */
        uint8_t isrc_valid : 1;        /*!< [1]  */
        uint8_t isrc_status : 3;       /*!< [4:2]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_iscr1_0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_ISCR1_0 register
 */
/*@{*/
#define HW_HDMI_FC_ISCR1_0_ADDR(x) ((uintptr_t)(x) + 0x1092U)

#define HW_HDMI_FC_ISCR1_0(x)    (*(__IO hw_hdmi_fc_iscr1_0_t *) HW_HDMI_FC_ISCR1_0_ADDR(x))
#define HW_HDMI_FC_ISCR1_0_RD(x) (HW_HDMI_FC_ISCR1_0(x).U)
#define HW_HDMI_FC_ISCR1_0_WR(x, v) (HW_HDMI_FC_ISCR1_0(x).U = (v))
#define HW_HDMI_FC_ISCR1_0_SET(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, HW_HDMI_FC_ISCR1_0_RD(x) |  (v)))
#define HW_HDMI_FC_ISCR1_0_CLR(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, HW_HDMI_FC_ISCR1_0_RD(x) & ~(v)))
#define HW_HDMI_FC_ISCR1_0_TOG(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, HW_HDMI_FC_ISCR1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_ISCR1_0 bitfields
 */

/*!
 * @name Register HDMI_FC_ISCR1_0, field isrc_cont[0] (RW)
 *
 * Indication of ISRC2.
 */
/*@{*/
#define BP_HDMI_FC_ISCR1_0_isrc_cont (0U)  /*!< Bit position for HDMI_FC_ISCR1_0_isrc_cont. */
#define BM_HDMI_FC_ISCR1_0_isrc_cont (0x01U) /*!< Bit mask for HDMI_FC_ISCR1_0_isrc_cont. */
#define BS_HDMI_FC_ISCR1_0_isrc_cont (1U)  /*!< Bit field size in bits for HDMI_FC_ISCR1_0_isrc_cont. */

/*! @brief Read current value of the HDMI_FC_ISCR1_0_isrc_cont field. */
#define BR_HDMI_FC_ISCR1_0_isrc_cont(x) (HW_HDMI_FC_ISCR1_0(x).B.isrc_cont)

/*! @brief Format value for bitfield HDMI_FC_ISCR1_0_isrc_cont. */
#define BF_HDMI_FC_ISCR1_0_isrc_cont(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ISCR1_0_isrc_cont) & BM_HDMI_FC_ISCR1_0_isrc_cont)

/*! @brief Set the isrc_cont field to a new value. */
#define BW_HDMI_FC_ISCR1_0_isrc_cont(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, (HW_HDMI_FC_ISCR1_0_RD(x) & ~BM_HDMI_FC_ISCR1_0_isrc_cont) | BF_HDMI_FC_ISCR1_0_isrc_cont(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_ISCR1_0, field isrc_valid[1] (RW)
 *
 * Valid of ISRC1.
 */
/*@{*/
#define BP_HDMI_FC_ISCR1_0_isrc_valid (1U) /*!< Bit position for HDMI_FC_ISCR1_0_isrc_valid. */
#define BM_HDMI_FC_ISCR1_0_isrc_valid (0x02U) /*!< Bit mask for HDMI_FC_ISCR1_0_isrc_valid. */
#define BS_HDMI_FC_ISCR1_0_isrc_valid (1U) /*!< Bit field size in bits for HDMI_FC_ISCR1_0_isrc_valid. */

/*! @brief Read current value of the HDMI_FC_ISCR1_0_isrc_valid field. */
#define BR_HDMI_FC_ISCR1_0_isrc_valid(x) (HW_HDMI_FC_ISCR1_0(x).B.isrc_valid)

/*! @brief Format value for bitfield HDMI_FC_ISCR1_0_isrc_valid. */
#define BF_HDMI_FC_ISCR1_0_isrc_valid(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ISCR1_0_isrc_valid) & BM_HDMI_FC_ISCR1_0_isrc_valid)

/*! @brief Set the isrc_valid field to a new value. */
#define BW_HDMI_FC_ISCR1_0_isrc_valid(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, (HW_HDMI_FC_ISCR1_0_RD(x) & ~BM_HDMI_FC_ISCR1_0_isrc_valid) | BF_HDMI_FC_ISCR1_0_isrc_valid(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_ISCR1_0, field isrc_status[4:2] (RW)
 *
 * Status of ISRC1.
 */
/*@{*/
#define BP_HDMI_FC_ISCR1_0_isrc_status (2U) /*!< Bit position for HDMI_FC_ISCR1_0_isrc_status. */
#define BM_HDMI_FC_ISCR1_0_isrc_status (0x1CU) /*!< Bit mask for HDMI_FC_ISCR1_0_isrc_status. */
#define BS_HDMI_FC_ISCR1_0_isrc_status (3U) /*!< Bit field size in bits for HDMI_FC_ISCR1_0_isrc_status. */

/*! @brief Read current value of the HDMI_FC_ISCR1_0_isrc_status field. */
#define BR_HDMI_FC_ISCR1_0_isrc_status(x) (HW_HDMI_FC_ISCR1_0(x).B.isrc_status)

/*! @brief Format value for bitfield HDMI_FC_ISCR1_0_isrc_status. */
#define BF_HDMI_FC_ISCR1_0_isrc_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ISCR1_0_isrc_status) & BM_HDMI_FC_ISCR1_0_isrc_status)

/*! @brief Set the isrc_status field to a new value. */
#define BW_HDMI_FC_ISCR1_0_isrc_status(x, v) (HW_HDMI_FC_ISCR1_0_WR(x, (HW_HDMI_FC_ISCR1_0_RD(x) & ~BM_HDMI_FC_ISCR1_0_isrc_status) | BF_HDMI_FC_ISCR1_0_isrc_status(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_ISCR1_1 - Frame Composer ISCR1 Packet Body Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_ISCR1_1 - Frame Composer ISCR1 Packet Body Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the ISRC1 packet: ISRC1 packet body
 * Address Offset: 0x10A2 to 0x1093 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write For more information, see the HDMI 1.4 specification.
 */
typedef union _hw_hdmi_fc_iscr1_1
{
    uint8_t U;
    struct _hw_hdmi_fc_iscr1_1_bitfields
    {
        uint8_t isrc1 : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_fc_iscr1_1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_ISCR1_1 register
 */
/*@{*/
#define HW_HDMI_FC_ISCR1_1_ADDR(x) ((uintptr_t)(x) + 0x1093U)

#define HW_HDMI_FC_ISCR1_1(x)    (*(__IO hw_hdmi_fc_iscr1_1_t *) HW_HDMI_FC_ISCR1_1_ADDR(x))
#define HW_HDMI_FC_ISCR1_1_RD(x) (HW_HDMI_FC_ISCR1_1(x).U)
#define HW_HDMI_FC_ISCR1_1_WR(x, v) (HW_HDMI_FC_ISCR1_1(x).U = (v))
#define HW_HDMI_FC_ISCR1_1_SET(x, v) (HW_HDMI_FC_ISCR1_1_WR(x, HW_HDMI_FC_ISCR1_1_RD(x) |  (v)))
#define HW_HDMI_FC_ISCR1_1_CLR(x, v) (HW_HDMI_FC_ISCR1_1_WR(x, HW_HDMI_FC_ISCR1_1_RD(x) & ~(v)))
#define HW_HDMI_FC_ISCR1_1_TOG(x, v) (HW_HDMI_FC_ISCR1_1_WR(x, HW_HDMI_FC_ISCR1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_ISCR1_1 bitfields
 */

/*!
 * @name Register HDMI_FC_ISCR1_1, field isrc1[7:0] (RW)
 *
 * Configures the contents of the ISRC1 packet:
 */
/*@{*/
#define BP_HDMI_FC_ISCR1_1_isrc1 (0U)      /*!< Bit position for HDMI_FC_ISCR1_1_isrc1. */
#define BM_HDMI_FC_ISCR1_1_isrc1 (0xFFU)   /*!< Bit mask for HDMI_FC_ISCR1_1_isrc1. */
#define BS_HDMI_FC_ISCR1_1_isrc1 (8U)      /*!< Bit field size in bits for HDMI_FC_ISCR1_1_isrc1. */

/*! @brief Read current value of the HDMI_FC_ISCR1_1_isrc1 field. */
#define BR_HDMI_FC_ISCR1_1_isrc1(x) (HW_HDMI_FC_ISCR1_1(x).U)

/*! @brief Format value for bitfield HDMI_FC_ISCR1_1_isrc1. */
#define BF_HDMI_FC_ISCR1_1_isrc1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ISCR1_1_isrc1) & BM_HDMI_FC_ISCR1_1_isrc1)

/*! @brief Set the isrc1 field to a new value. */
#define BW_HDMI_FC_ISCR1_1_isrc1(x, v) (HW_HDMI_FC_ISCR1_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_ISCR2_0 - Frame Composer ISCR2 Packet Body Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_ISCR2_0 - Frame Composer ISCR2 Packet Body Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the ISRC2 packet: ISRC2 packet body
 * Address Offset: 0x10B2 to 0x10A3 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write For more information, see the HDMI 1.4 specification.
 */
typedef union _hw_hdmi_fc_iscr2_0
{
    uint8_t U;
    struct _hw_hdmi_fc_iscr2_0_bitfields
    {
        uint8_t isrc2 : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_fc_iscr2_0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_ISCR2_0 register
 */
/*@{*/
#define HW_HDMI_FC_ISCR2_0_ADDR(x) ((uintptr_t)(x) + 0x10A3U)

#define HW_HDMI_FC_ISCR2_0(x)    (*(__IO hw_hdmi_fc_iscr2_0_t *) HW_HDMI_FC_ISCR2_0_ADDR(x))
#define HW_HDMI_FC_ISCR2_0_RD(x) (HW_HDMI_FC_ISCR2_0(x).U)
#define HW_HDMI_FC_ISCR2_0_WR(x, v) (HW_HDMI_FC_ISCR2_0(x).U = (v))
#define HW_HDMI_FC_ISCR2_0_SET(x, v) (HW_HDMI_FC_ISCR2_0_WR(x, HW_HDMI_FC_ISCR2_0_RD(x) |  (v)))
#define HW_HDMI_FC_ISCR2_0_CLR(x, v) (HW_HDMI_FC_ISCR2_0_WR(x, HW_HDMI_FC_ISCR2_0_RD(x) & ~(v)))
#define HW_HDMI_FC_ISCR2_0_TOG(x, v) (HW_HDMI_FC_ISCR2_0_WR(x, HW_HDMI_FC_ISCR2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_ISCR2_0 bitfields
 */

/*!
 * @name Register HDMI_FC_ISCR2_0, field isrc2[7:0] (RW)
 *
 * Configures the contents of the ISRC1 packet:
 */
/*@{*/
#define BP_HDMI_FC_ISCR2_0_isrc2 (0U)      /*!< Bit position for HDMI_FC_ISCR2_0_isrc2. */
#define BM_HDMI_FC_ISCR2_0_isrc2 (0xFFU)   /*!< Bit mask for HDMI_FC_ISCR2_0_isrc2. */
#define BS_HDMI_FC_ISCR2_0_isrc2 (8U)      /*!< Bit field size in bits for HDMI_FC_ISCR2_0_isrc2. */

/*! @brief Read current value of the HDMI_FC_ISCR2_0_isrc2 field. */
#define BR_HDMI_FC_ISCR2_0_isrc2(x) (HW_HDMI_FC_ISCR2_0(x).U)

/*! @brief Format value for bitfield HDMI_FC_ISCR2_0_isrc2. */
#define BF_HDMI_FC_ISCR2_0_isrc2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_ISCR2_0_isrc2) & BM_HDMI_FC_ISCR2_0_isrc2)

/*! @brief Set the isrc2 field to a new value. */
#define BW_HDMI_FC_ISCR2_0_isrc2(x, v) (HW_HDMI_FC_ISCR2_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DATAUTO0 - Frame Composer Data Island Auto Packet Scheduling Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DATAUTO0 - Frame Composer Data Island Auto Packet Scheduling Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer RDRB(1)/Manual(0) data island packet insertion
 * for SPD, VSD, ISRC2, ISRC1 and ACP packets. On RDRB mode the described packet
 * scheduling is controlled by registers FC_DATAUTO1 and FC_DATAUTO2, while in
 * Manual mode register FC_DATMAN requests to FC the insertion of the requested
 * packet. Address Offset: 0x10B3 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_datauto0
{
    uint8_t U;
    struct _hw_hdmi_fc_datauto0_bitfields
    {
        uint8_t acp_auto : 1;          /*!< [0]  */
        uint8_t iscr1_auto : 1;        /*!< [1]  */
        uint8_t iscr2_auto : 1;        /*!< [2]  */
        uint8_t vsd_auto : 1;          /*!< [3]  */
        uint8_t spd_auto : 1;          /*!< [4]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_datauto0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DATAUTO0 register
 */
/*@{*/
#define HW_HDMI_FC_DATAUTO0_ADDR(x) ((uintptr_t)(x) + 0x10B3U)

#define HW_HDMI_FC_DATAUTO0(x)   (*(__IO hw_hdmi_fc_datauto0_t *) HW_HDMI_FC_DATAUTO0_ADDR(x))
#define HW_HDMI_FC_DATAUTO0_RD(x) (HW_HDMI_FC_DATAUTO0(x).U)
#define HW_HDMI_FC_DATAUTO0_WR(x, v) (HW_HDMI_FC_DATAUTO0(x).U = (v))
#define HW_HDMI_FC_DATAUTO0_SET(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, HW_HDMI_FC_DATAUTO0_RD(x) |  (v)))
#define HW_HDMI_FC_DATAUTO0_CLR(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, HW_HDMI_FC_DATAUTO0_RD(x) & ~(v)))
#define HW_HDMI_FC_DATAUTO0_TOG(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, HW_HDMI_FC_DATAUTO0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DATAUTO0 bitfields
 */

/*!
 * @name Register HDMI_FC_DATAUTO0, field acp_auto[0] (RW)
 *
 * Enables ACP automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO0_acp_auto (0U)  /*!< Bit position for HDMI_FC_DATAUTO0_acp_auto. */
#define BM_HDMI_FC_DATAUTO0_acp_auto (0x01U) /*!< Bit mask for HDMI_FC_DATAUTO0_acp_auto. */
#define BS_HDMI_FC_DATAUTO0_acp_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO0_acp_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO0_acp_auto field. */
#define BR_HDMI_FC_DATAUTO0_acp_auto(x) (HW_HDMI_FC_DATAUTO0(x).B.acp_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO0_acp_auto. */
#define BF_HDMI_FC_DATAUTO0_acp_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO0_acp_auto) & BM_HDMI_FC_DATAUTO0_acp_auto)

/*! @brief Set the acp_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO0_acp_auto(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, (HW_HDMI_FC_DATAUTO0_RD(x) & ~BM_HDMI_FC_DATAUTO0_acp_auto) | BF_HDMI_FC_DATAUTO0_acp_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO0, field iscr1_auto[1] (RW)
 *
 * Enables ISRC1 automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO0_iscr1_auto (1U) /*!< Bit position for HDMI_FC_DATAUTO0_iscr1_auto. */
#define BM_HDMI_FC_DATAUTO0_iscr1_auto (0x02U) /*!< Bit mask for HDMI_FC_DATAUTO0_iscr1_auto. */
#define BS_HDMI_FC_DATAUTO0_iscr1_auto (1U) /*!< Bit field size in bits for HDMI_FC_DATAUTO0_iscr1_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO0_iscr1_auto field. */
#define BR_HDMI_FC_DATAUTO0_iscr1_auto(x) (HW_HDMI_FC_DATAUTO0(x).B.iscr1_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO0_iscr1_auto. */
#define BF_HDMI_FC_DATAUTO0_iscr1_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO0_iscr1_auto) & BM_HDMI_FC_DATAUTO0_iscr1_auto)

/*! @brief Set the iscr1_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO0_iscr1_auto(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, (HW_HDMI_FC_DATAUTO0_RD(x) & ~BM_HDMI_FC_DATAUTO0_iscr1_auto) | BF_HDMI_FC_DATAUTO0_iscr1_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO0, field iscr2_auto[2] (RW)
 *
 * Enables ISRC2 automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO0_iscr2_auto (2U) /*!< Bit position for HDMI_FC_DATAUTO0_iscr2_auto. */
#define BM_HDMI_FC_DATAUTO0_iscr2_auto (0x04U) /*!< Bit mask for HDMI_FC_DATAUTO0_iscr2_auto. */
#define BS_HDMI_FC_DATAUTO0_iscr2_auto (1U) /*!< Bit field size in bits for HDMI_FC_DATAUTO0_iscr2_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO0_iscr2_auto field. */
#define BR_HDMI_FC_DATAUTO0_iscr2_auto(x) (HW_HDMI_FC_DATAUTO0(x).B.iscr2_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO0_iscr2_auto. */
#define BF_HDMI_FC_DATAUTO0_iscr2_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO0_iscr2_auto) & BM_HDMI_FC_DATAUTO0_iscr2_auto)

/*! @brief Set the iscr2_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO0_iscr2_auto(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, (HW_HDMI_FC_DATAUTO0_RD(x) & ~BM_HDMI_FC_DATAUTO0_iscr2_auto) | BF_HDMI_FC_DATAUTO0_iscr2_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO0, field vsd_auto[3] (RW)
 *
 * Enables VSD automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO0_vsd_auto (3U)  /*!< Bit position for HDMI_FC_DATAUTO0_vsd_auto. */
#define BM_HDMI_FC_DATAUTO0_vsd_auto (0x08U) /*!< Bit mask for HDMI_FC_DATAUTO0_vsd_auto. */
#define BS_HDMI_FC_DATAUTO0_vsd_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO0_vsd_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO0_vsd_auto field. */
#define BR_HDMI_FC_DATAUTO0_vsd_auto(x) (HW_HDMI_FC_DATAUTO0(x).B.vsd_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO0_vsd_auto. */
#define BF_HDMI_FC_DATAUTO0_vsd_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO0_vsd_auto) & BM_HDMI_FC_DATAUTO0_vsd_auto)

/*! @brief Set the vsd_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO0_vsd_auto(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, (HW_HDMI_FC_DATAUTO0_RD(x) & ~BM_HDMI_FC_DATAUTO0_vsd_auto) | BF_HDMI_FC_DATAUTO0_vsd_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO0, field spd_auto[4] (RW)
 *
 * Enables SPD automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO0_spd_auto (4U)  /*!< Bit position for HDMI_FC_DATAUTO0_spd_auto. */
#define BM_HDMI_FC_DATAUTO0_spd_auto (0x10U) /*!< Bit mask for HDMI_FC_DATAUTO0_spd_auto. */
#define BS_HDMI_FC_DATAUTO0_spd_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO0_spd_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO0_spd_auto field. */
#define BR_HDMI_FC_DATAUTO0_spd_auto(x) (HW_HDMI_FC_DATAUTO0(x).B.spd_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO0_spd_auto. */
#define BF_HDMI_FC_DATAUTO0_spd_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO0_spd_auto) & BM_HDMI_FC_DATAUTO0_spd_auto)

/*! @brief Set the spd_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO0_spd_auto(x, v) (HW_HDMI_FC_DATAUTO0_WR(x, (HW_HDMI_FC_DATAUTO0_RD(x) & ~BM_HDMI_FC_DATAUTO0_spd_auto) | BF_HDMI_FC_DATAUTO0_spd_auto(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DATAUTO1 - Frame Composer Data Island Auto Packet Scheduling Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DATAUTO1 - Frame Composer Data Island Auto Packet Scheduling Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB frame interpolation for SPD, VSD,
 * ISRC2, ISRC1 and ACP packet insertion on data island when FC is on RDRB mode for
 * the listed packets. Address Offset: 0x10B4 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_datauto1
{
    uint8_t U;
    struct _hw_hdmi_fc_datauto1_bitfields
    {
        uint8_t AUTO_FRAME_INTERPOLATION : 4; /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_datauto1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DATAUTO1 register
 */
/*@{*/
#define HW_HDMI_FC_DATAUTO1_ADDR(x) ((uintptr_t)(x) + 0x10B4U)

#define HW_HDMI_FC_DATAUTO1(x)   (*(__IO hw_hdmi_fc_datauto1_t *) HW_HDMI_FC_DATAUTO1_ADDR(x))
#define HW_HDMI_FC_DATAUTO1_RD(x) (HW_HDMI_FC_DATAUTO1(x).U)
#define HW_HDMI_FC_DATAUTO1_WR(x, v) (HW_HDMI_FC_DATAUTO1(x).U = (v))
#define HW_HDMI_FC_DATAUTO1_SET(x, v) (HW_HDMI_FC_DATAUTO1_WR(x, HW_HDMI_FC_DATAUTO1_RD(x) |  (v)))
#define HW_HDMI_FC_DATAUTO1_CLR(x, v) (HW_HDMI_FC_DATAUTO1_WR(x, HW_HDMI_FC_DATAUTO1_RD(x) & ~(v)))
#define HW_HDMI_FC_DATAUTO1_TOG(x, v) (HW_HDMI_FC_DATAUTO1_WR(x, HW_HDMI_FC_DATAUTO1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DATAUTO1 bitfields
 */

/*!
 * @name Register HDMI_FC_DATAUTO1, field AUTO_FRAME_INTERPOLATION[3:0] (RW)
 *
 * Packet frame interpolation, for automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION (0U) /*!< Bit position for HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION. */
#define BM_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION (0x0FU) /*!< Bit mask for HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION. */
#define BS_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION (4U) /*!< Bit field size in bits for HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION. */

/*! @brief Read current value of the HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION field. */
#define BR_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION(x) (HW_HDMI_FC_DATAUTO1(x).B.AUTO_FRAME_INTERPOLATION)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION. */
#define BF_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION) & BM_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION)

/*! @brief Set the AUTO_FRAME_INTERPOLATION field to a new value. */
#define BW_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION(x, v) (HW_HDMI_FC_DATAUTO1_WR(x, (HW_HDMI_FC_DATAUTO1_RD(x) & ~BM_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION) | BF_HDMI_FC_DATAUTO1_AUTO_FRAME_INTERPOLATION(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DATAUTO2 - Frame Composer Data Island Auto Packet Scheduling Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DATAUTO2 - Frame Composer Data Island Auto Packet Scheduling Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for SPD, VSD, ISRC2, ISRC1 and ACP packet insertion on data
 * island when FC is on RDRB mode for the listed packets. Address Offset: 0x10B5 Size:
 * 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_datauto2
{
    uint8_t U;
    struct _hw_hdmi_fc_datauto2_bitfields
    {
        uint8_t AUTO_LINE_SPACING : 4; /*!< [3:0]  */
        uint8_t AUTO_FRAME_PACKETS : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_datauto2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DATAUTO2 register
 */
/*@{*/
#define HW_HDMI_FC_DATAUTO2_ADDR(x) ((uintptr_t)(x) + 0x10B5U)

#define HW_HDMI_FC_DATAUTO2(x)   (*(__IO hw_hdmi_fc_datauto2_t *) HW_HDMI_FC_DATAUTO2_ADDR(x))
#define HW_HDMI_FC_DATAUTO2_RD(x) (HW_HDMI_FC_DATAUTO2(x).U)
#define HW_HDMI_FC_DATAUTO2_WR(x, v) (HW_HDMI_FC_DATAUTO2(x).U = (v))
#define HW_HDMI_FC_DATAUTO2_SET(x, v) (HW_HDMI_FC_DATAUTO2_WR(x, HW_HDMI_FC_DATAUTO2_RD(x) |  (v)))
#define HW_HDMI_FC_DATAUTO2_CLR(x, v) (HW_HDMI_FC_DATAUTO2_WR(x, HW_HDMI_FC_DATAUTO2_RD(x) & ~(v)))
#define HW_HDMI_FC_DATAUTO2_TOG(x, v) (HW_HDMI_FC_DATAUTO2_WR(x, HW_HDMI_FC_DATAUTO2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DATAUTO2 bitfields
 */

/*!
 * @name Register HDMI_FC_DATAUTO2, field AUTO_LINE_SPACING[3:0] (RW)
 *
 * Packets line spacing, for automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING (0U) /*!< Bit position for HDMI_FC_DATAUTO2_AUTO_LINE_SPACING. */
#define BM_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING (0x0FU) /*!< Bit mask for HDMI_FC_DATAUTO2_AUTO_LINE_SPACING. */
#define BS_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING (4U) /*!< Bit field size in bits for HDMI_FC_DATAUTO2_AUTO_LINE_SPACING. */

/*! @brief Read current value of the HDMI_FC_DATAUTO2_AUTO_LINE_SPACING field. */
#define BR_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING(x) (HW_HDMI_FC_DATAUTO2(x).B.AUTO_LINE_SPACING)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO2_AUTO_LINE_SPACING. */
#define BF_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING) & BM_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING)

/*! @brief Set the AUTO_LINE_SPACING field to a new value. */
#define BW_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING(x, v) (HW_HDMI_FC_DATAUTO2_WR(x, (HW_HDMI_FC_DATAUTO2_RD(x) & ~BM_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING) | BF_HDMI_FC_DATAUTO2_AUTO_LINE_SPACING(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO2, field AUTO_FRAME_PACKETS[7:4] (RW)
 *
 * Packets per frame, for automatic packet scheduling
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS (4U) /*!< Bit position for HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS. */
#define BM_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS (0xF0U) /*!< Bit mask for HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS. */
#define BS_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS (4U) /*!< Bit field size in bits for HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS. */

/*! @brief Read current value of the HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS field. */
#define BR_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS(x) (HW_HDMI_FC_DATAUTO2(x).B.AUTO_FRAME_PACKETS)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS. */
#define BF_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS) & BM_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS)

/*! @brief Set the AUTO_FRAME_PACKETS field to a new value. */
#define BW_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS(x, v) (HW_HDMI_FC_DATAUTO2_WR(x, (HW_HDMI_FC_DATAUTO2_RD(x) & ~BM_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS) | BF_HDMI_FC_DATAUTO2_AUTO_FRAME_PACKETS(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DATMAN - Frame Composer Data Island Manual Packet Request Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DATMAN - Frame Composer Data Island Manual Packet Request Register (WO)
 *
 * Reset value: 0x00U
 *
 * Requests to the Frame Composer the data island packet insertion for NULL,
 * SPD, VSD, ISRC2, ISRC1 and ACP packets when FC_DATAUTO0 bit is in manual mode for
 * the packet requested. Address Offset: 0x10B6 Size: 8 bits Value after Reset:
 * 0x00 Access: Write
 */
typedef union _hw_hdmi_fc_datman
{
    uint8_t U;
    struct _hw_hdmi_fc_datman_bitfields
    {
        uint8_t acp_tx : 1;            /*!< [0]  */
        uint8_t isr1_tx : 1;           /*!< [1]  */
        uint8_t iscr2_tx : 1;          /*!< [2]  */
        uint8_t vsd_tx : 1;            /*!< [3]  */
        uint8_t spd_tx : 1;            /*!< [4]  */
        uint8_t null_tx : 1;           /*!< [5]  */
        uint8_t RESERVED0 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_fc_datman_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DATMAN register
 */
/*@{*/
#define HW_HDMI_FC_DATMAN_ADDR(x) ((uintptr_t)(x) + 0x10B6U)

#define HW_HDMI_FC_DATMAN(x)     (*(__O hw_hdmi_fc_datman_t *) HW_HDMI_FC_DATMAN_ADDR(x))
#define HW_HDMI_FC_DATMAN_WR(x, v) (HW_HDMI_FC_DATMAN(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DATMAN bitfields
 */

/*!
 * @name Register HDMI_FC_DATMAN, field acp_tx[0] (WO)
 *
 * ACP packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_acp_tx (0U)      /*!< Bit position for HDMI_FC_DATMAN_acp_tx. */
#define BM_HDMI_FC_DATMAN_acp_tx (0x01U)   /*!< Bit mask for HDMI_FC_DATMAN_acp_tx. */
#define BS_HDMI_FC_DATMAN_acp_tx (1U)      /*!< Bit field size in bits for HDMI_FC_DATMAN_acp_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_acp_tx. */
#define BF_HDMI_FC_DATMAN_acp_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_acp_tx) & BM_HDMI_FC_DATMAN_acp_tx)
/*@}*/

/*!
 * @name Register HDMI_FC_DATMAN, field isr1_tx[1] (WO)
 *
 * ISRC1 packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_isr1_tx (1U)     /*!< Bit position for HDMI_FC_DATMAN_isr1_tx. */
#define BM_HDMI_FC_DATMAN_isr1_tx (0x02U)  /*!< Bit mask for HDMI_FC_DATMAN_isr1_tx. */
#define BS_HDMI_FC_DATMAN_isr1_tx (1U)     /*!< Bit field size in bits for HDMI_FC_DATMAN_isr1_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_isr1_tx. */
#define BF_HDMI_FC_DATMAN_isr1_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_isr1_tx) & BM_HDMI_FC_DATMAN_isr1_tx)
/*@}*/

/*!
 * @name Register HDMI_FC_DATMAN, field iscr2_tx[2] (WO)
 *
 * ISRC2 packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_iscr2_tx (2U)    /*!< Bit position for HDMI_FC_DATMAN_iscr2_tx. */
#define BM_HDMI_FC_DATMAN_iscr2_tx (0x04U) /*!< Bit mask for HDMI_FC_DATMAN_iscr2_tx. */
#define BS_HDMI_FC_DATMAN_iscr2_tx (1U)    /*!< Bit field size in bits for HDMI_FC_DATMAN_iscr2_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_iscr2_tx. */
#define BF_HDMI_FC_DATMAN_iscr2_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_iscr2_tx) & BM_HDMI_FC_DATMAN_iscr2_tx)
/*@}*/

/*!
 * @name Register HDMI_FC_DATMAN, field vsd_tx[3] (WO)
 *
 * VSD packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_vsd_tx (3U)      /*!< Bit position for HDMI_FC_DATMAN_vsd_tx. */
#define BM_HDMI_FC_DATMAN_vsd_tx (0x08U)   /*!< Bit mask for HDMI_FC_DATMAN_vsd_tx. */
#define BS_HDMI_FC_DATMAN_vsd_tx (1U)      /*!< Bit field size in bits for HDMI_FC_DATMAN_vsd_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_vsd_tx. */
#define BF_HDMI_FC_DATMAN_vsd_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_vsd_tx) & BM_HDMI_FC_DATMAN_vsd_tx)
/*@}*/

/*!
 * @name Register HDMI_FC_DATMAN, field spd_tx[4] (WO)
 *
 * SPD packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_spd_tx (4U)      /*!< Bit position for HDMI_FC_DATMAN_spd_tx. */
#define BM_HDMI_FC_DATMAN_spd_tx (0x10U)   /*!< Bit mask for HDMI_FC_DATMAN_spd_tx. */
#define BS_HDMI_FC_DATMAN_spd_tx (1U)      /*!< Bit field size in bits for HDMI_FC_DATMAN_spd_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_spd_tx. */
#define BF_HDMI_FC_DATMAN_spd_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_spd_tx) & BM_HDMI_FC_DATMAN_spd_tx)
/*@}*/

/*!
 * @name Register HDMI_FC_DATMAN, field null_tx[5] (WO)
 *
 * Null packet
 */
/*@{*/
#define BP_HDMI_FC_DATMAN_null_tx (5U)     /*!< Bit position for HDMI_FC_DATMAN_null_tx. */
#define BM_HDMI_FC_DATMAN_null_tx (0x20U)  /*!< Bit mask for HDMI_FC_DATMAN_null_tx. */
#define BS_HDMI_FC_DATMAN_null_tx (1U)     /*!< Bit field size in bits for HDMI_FC_DATMAN_null_tx. */

/*! @brief Format value for bitfield HDMI_FC_DATMAN_null_tx. */
#define BF_HDMI_FC_DATMAN_null_tx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATMAN_null_tx) & BM_HDMI_FC_DATMAN_null_tx)
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DATAUTO3 - Frame Composer Data Island Auto Packet Scheduling Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DATAUTO3 - Frame Composer Data Island Auto Packet Scheduling Register 3 (RW)
 *
 * Reset value: 0x0FU
 *
 * Configures the Frame Composer Automatic(1)/RDRB(0) data island packet
 * insertion for AVI, GCP, AUDI and ACR packets. In Automatic mode, the packet will be
 * inserted on Vblanking when first line with active Vsync appears. Address
 * Offset: 0x10B7 Size: 8 bits Value after Reset: 0x0F Access: Read/Write
 */
typedef union _hw_hdmi_fc_datauto3
{
    uint8_t U;
    struct _hw_hdmi_fc_datauto3_bitfields
    {
        uint8_t acr_auto : 1;          /*!< [0]  */
        uint8_t audi_auto : 1;         /*!< [1]  */
        uint8_t gcp_auto : 1;          /*!< [2]  */
        uint8_t avi_auto : 1;          /*!< [3]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_datauto3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DATAUTO3 register
 */
/*@{*/
#define HW_HDMI_FC_DATAUTO3_ADDR(x) ((uintptr_t)(x) + 0x10B7U)

#define HW_HDMI_FC_DATAUTO3(x)   (*(__IO hw_hdmi_fc_datauto3_t *) HW_HDMI_FC_DATAUTO3_ADDR(x))
#define HW_HDMI_FC_DATAUTO3_RD(x) (HW_HDMI_FC_DATAUTO3(x).U)
#define HW_HDMI_FC_DATAUTO3_WR(x, v) (HW_HDMI_FC_DATAUTO3(x).U = (v))
#define HW_HDMI_FC_DATAUTO3_SET(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, HW_HDMI_FC_DATAUTO3_RD(x) |  (v)))
#define HW_HDMI_FC_DATAUTO3_CLR(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, HW_HDMI_FC_DATAUTO3_RD(x) & ~(v)))
#define HW_HDMI_FC_DATAUTO3_TOG(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, HW_HDMI_FC_DATAUTO3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DATAUTO3 bitfields
 */

/*!
 * @name Register HDMI_FC_DATAUTO3, field acr_auto[0] (RW)
 *
 * Enable ACR packet insertion
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO3_acr_auto (0U)  /*!< Bit position for HDMI_FC_DATAUTO3_acr_auto. */
#define BM_HDMI_FC_DATAUTO3_acr_auto (0x01U) /*!< Bit mask for HDMI_FC_DATAUTO3_acr_auto. */
#define BS_HDMI_FC_DATAUTO3_acr_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO3_acr_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO3_acr_auto field. */
#define BR_HDMI_FC_DATAUTO3_acr_auto(x) (HW_HDMI_FC_DATAUTO3(x).B.acr_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO3_acr_auto. */
#define BF_HDMI_FC_DATAUTO3_acr_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO3_acr_auto) & BM_HDMI_FC_DATAUTO3_acr_auto)

/*! @brief Set the acr_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO3_acr_auto(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, (HW_HDMI_FC_DATAUTO3_RD(x) & ~BM_HDMI_FC_DATAUTO3_acr_auto) | BF_HDMI_FC_DATAUTO3_acr_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO3, field audi_auto[1] (RW)
 *
 * Enable AUDI packet insertion
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO3_audi_auto (1U) /*!< Bit position for HDMI_FC_DATAUTO3_audi_auto. */
#define BM_HDMI_FC_DATAUTO3_audi_auto (0x02U) /*!< Bit mask for HDMI_FC_DATAUTO3_audi_auto. */
#define BS_HDMI_FC_DATAUTO3_audi_auto (1U) /*!< Bit field size in bits for HDMI_FC_DATAUTO3_audi_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO3_audi_auto field. */
#define BR_HDMI_FC_DATAUTO3_audi_auto(x) (HW_HDMI_FC_DATAUTO3(x).B.audi_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO3_audi_auto. */
#define BF_HDMI_FC_DATAUTO3_audi_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO3_audi_auto) & BM_HDMI_FC_DATAUTO3_audi_auto)

/*! @brief Set the audi_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO3_audi_auto(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, (HW_HDMI_FC_DATAUTO3_RD(x) & ~BM_HDMI_FC_DATAUTO3_audi_auto) | BF_HDMI_FC_DATAUTO3_audi_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO3, field gcp_auto[2] (RW)
 *
 * Enable GCP packet insertion
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO3_gcp_auto (2U)  /*!< Bit position for HDMI_FC_DATAUTO3_gcp_auto. */
#define BM_HDMI_FC_DATAUTO3_gcp_auto (0x04U) /*!< Bit mask for HDMI_FC_DATAUTO3_gcp_auto. */
#define BS_HDMI_FC_DATAUTO3_gcp_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO3_gcp_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO3_gcp_auto field. */
#define BR_HDMI_FC_DATAUTO3_gcp_auto(x) (HW_HDMI_FC_DATAUTO3(x).B.gcp_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO3_gcp_auto. */
#define BF_HDMI_FC_DATAUTO3_gcp_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO3_gcp_auto) & BM_HDMI_FC_DATAUTO3_gcp_auto)

/*! @brief Set the gcp_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO3_gcp_auto(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, (HW_HDMI_FC_DATAUTO3_RD(x) & ~BM_HDMI_FC_DATAUTO3_gcp_auto) | BF_HDMI_FC_DATAUTO3_gcp_auto(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DATAUTO3, field avi_auto[3] (RW)
 *
 * Enable AVI packet insertion
 */
/*@{*/
#define BP_HDMI_FC_DATAUTO3_avi_auto (3U)  /*!< Bit position for HDMI_FC_DATAUTO3_avi_auto. */
#define BM_HDMI_FC_DATAUTO3_avi_auto (0x08U) /*!< Bit mask for HDMI_FC_DATAUTO3_avi_auto. */
#define BS_HDMI_FC_DATAUTO3_avi_auto (1U)  /*!< Bit field size in bits for HDMI_FC_DATAUTO3_avi_auto. */

/*! @brief Read current value of the HDMI_FC_DATAUTO3_avi_auto field. */
#define BR_HDMI_FC_DATAUTO3_avi_auto(x) (HW_HDMI_FC_DATAUTO3(x).B.avi_auto)

/*! @brief Format value for bitfield HDMI_FC_DATAUTO3_avi_auto. */
#define BF_HDMI_FC_DATAUTO3_avi_auto(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DATAUTO3_avi_auto) & BM_HDMI_FC_DATAUTO3_avi_auto)

/*! @brief Set the avi_auto field to a new value. */
#define BW_HDMI_FC_DATAUTO3_avi_auto(x, v) (HW_HDMI_FC_DATAUTO3_WR(x, (HW_HDMI_FC_DATAUTO3_RD(x) & ~BM_HDMI_FC_DATAUTO3_avi_auto) | BF_HDMI_FC_DATAUTO3_avi_auto(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB0 - Frame Composer Round Robin ACR Packet Insertion Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB0 - Frame Composer Round Robin ACR Packet Insertion Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB frame interpolation for ACR packet
 * insertion on data island when FC is on RDRB mode for this packet. Address
 * Offset: 0x10B8 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb0
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb0_bitfields
    {
        uint8_t ACRframeinterpolation : 4; /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB0 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB0_ADDR(x) ((uintptr_t)(x) + 0x10B8U)

#define HW_HDMI_FC_RDRB0(x)      (*(__IO hw_hdmi_fc_rdrb0_t *) HW_HDMI_FC_RDRB0_ADDR(x))
#define HW_HDMI_FC_RDRB0_RD(x)   (HW_HDMI_FC_RDRB0(x).U)
#define HW_HDMI_FC_RDRB0_WR(x, v) (HW_HDMI_FC_RDRB0(x).U = (v))
#define HW_HDMI_FC_RDRB0_SET(x, v) (HW_HDMI_FC_RDRB0_WR(x, HW_HDMI_FC_RDRB0_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB0_CLR(x, v) (HW_HDMI_FC_RDRB0_WR(x, HW_HDMI_FC_RDRB0_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB0_TOG(x, v) (HW_HDMI_FC_RDRB0_WR(x, HW_HDMI_FC_RDRB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB0 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB0, field ACRframeinterpolation[3:0] (RW)
 *
 * ACR frame interpolation
 */
/*@{*/
#define BP_HDMI_FC_RDRB0_ACRframeinterpolation (0U) /*!< Bit position for HDMI_FC_RDRB0_ACRframeinterpolation. */
#define BM_HDMI_FC_RDRB0_ACRframeinterpolation (0x0FU) /*!< Bit mask for HDMI_FC_RDRB0_ACRframeinterpolation. */
#define BS_HDMI_FC_RDRB0_ACRframeinterpolation (4U) /*!< Bit field size in bits for HDMI_FC_RDRB0_ACRframeinterpolation. */

/*! @brief Read current value of the HDMI_FC_RDRB0_ACRframeinterpolation field. */
#define BR_HDMI_FC_RDRB0_ACRframeinterpolation(x) (HW_HDMI_FC_RDRB0(x).B.ACRframeinterpolation)

/*! @brief Format value for bitfield HDMI_FC_RDRB0_ACRframeinterpolation. */
#define BF_HDMI_FC_RDRB0_ACRframeinterpolation(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB0_ACRframeinterpolation) & BM_HDMI_FC_RDRB0_ACRframeinterpolation)

/*! @brief Set the ACRframeinterpolation field to a new value. */
#define BW_HDMI_FC_RDRB0_ACRframeinterpolation(x, v) (HW_HDMI_FC_RDRB0_WR(x, (HW_HDMI_FC_RDRB0_RD(x) & ~BM_HDMI_FC_RDRB0_ACRframeinterpolation) | BF_HDMI_FC_RDRB0_ACRframeinterpolation(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB1 - Frame Composer Round Robin ACR Packet Insertion Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB1 - Frame Composer Round Robin ACR Packet Insertion Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for the ACR packet insertion on data island when FC is on RDRB
 * mode this packet. Address Offset: 0x10B9 Size: 8 bits Value after Reset: 0x00
 * Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb1
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb1_bitfields
    {
        uint8_t ACRpacketlinespacing : 4; /*!< [3:0]  */
        uint8_t ACRpacketsinframe : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB1 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB1_ADDR(x) ((uintptr_t)(x) + 0x10B9U)

#define HW_HDMI_FC_RDRB1(x)      (*(__IO hw_hdmi_fc_rdrb1_t *) HW_HDMI_FC_RDRB1_ADDR(x))
#define HW_HDMI_FC_RDRB1_RD(x)   (HW_HDMI_FC_RDRB1(x).U)
#define HW_HDMI_FC_RDRB1_WR(x, v) (HW_HDMI_FC_RDRB1(x).U = (v))
#define HW_HDMI_FC_RDRB1_SET(x, v) (HW_HDMI_FC_RDRB1_WR(x, HW_HDMI_FC_RDRB1_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB1_CLR(x, v) (HW_HDMI_FC_RDRB1_WR(x, HW_HDMI_FC_RDRB1_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB1_TOG(x, v) (HW_HDMI_FC_RDRB1_WR(x, HW_HDMI_FC_RDRB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB1 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB1, field ACRpacketlinespacing[3:0] (RW)
 *
 * ACR packet line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB1_ACRpacketlinespacing (0U) /*!< Bit position for HDMI_FC_RDRB1_ACRpacketlinespacing. */
#define BM_HDMI_FC_RDRB1_ACRpacketlinespacing (0x0FU) /*!< Bit mask for HDMI_FC_RDRB1_ACRpacketlinespacing. */
#define BS_HDMI_FC_RDRB1_ACRpacketlinespacing (4U) /*!< Bit field size in bits for HDMI_FC_RDRB1_ACRpacketlinespacing. */

/*! @brief Read current value of the HDMI_FC_RDRB1_ACRpacketlinespacing field. */
#define BR_HDMI_FC_RDRB1_ACRpacketlinespacing(x) (HW_HDMI_FC_RDRB1(x).B.ACRpacketlinespacing)

/*! @brief Format value for bitfield HDMI_FC_RDRB1_ACRpacketlinespacing. */
#define BF_HDMI_FC_RDRB1_ACRpacketlinespacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB1_ACRpacketlinespacing) & BM_HDMI_FC_RDRB1_ACRpacketlinespacing)

/*! @brief Set the ACRpacketlinespacing field to a new value. */
#define BW_HDMI_FC_RDRB1_ACRpacketlinespacing(x, v) (HW_HDMI_FC_RDRB1_WR(x, (HW_HDMI_FC_RDRB1_RD(x) & ~BM_HDMI_FC_RDRB1_ACRpacketlinespacing) | BF_HDMI_FC_RDRB1_ACRpacketlinespacing(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_RDRB1, field ACRpacketsinframe[7:4] (RW)
 *
 * ACR packets in frame
 */
/*@{*/
#define BP_HDMI_FC_RDRB1_ACRpacketsinframe (4U) /*!< Bit position for HDMI_FC_RDRB1_ACRpacketsinframe. */
#define BM_HDMI_FC_RDRB1_ACRpacketsinframe (0xF0U) /*!< Bit mask for HDMI_FC_RDRB1_ACRpacketsinframe. */
#define BS_HDMI_FC_RDRB1_ACRpacketsinframe (4U) /*!< Bit field size in bits for HDMI_FC_RDRB1_ACRpacketsinframe. */

/*! @brief Read current value of the HDMI_FC_RDRB1_ACRpacketsinframe field. */
#define BR_HDMI_FC_RDRB1_ACRpacketsinframe(x) (HW_HDMI_FC_RDRB1(x).B.ACRpacketsinframe)

/*! @brief Format value for bitfield HDMI_FC_RDRB1_ACRpacketsinframe. */
#define BF_HDMI_FC_RDRB1_ACRpacketsinframe(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB1_ACRpacketsinframe) & BM_HDMI_FC_RDRB1_ACRpacketsinframe)

/*! @brief Set the ACRpacketsinframe field to a new value. */
#define BW_HDMI_FC_RDRB1_ACRpacketsinframe(x, v) (HW_HDMI_FC_RDRB1_WR(x, (HW_HDMI_FC_RDRB1_RD(x) & ~BM_HDMI_FC_RDRB1_ACRpacketsinframe) | BF_HDMI_FC_RDRB1_ACRpacketsinframe(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB2 - Frame Composer Round Robin ACR Packet Insertion Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB2 - Frame Composer Round Robin ACR Packet Insertion Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB frame interpolation for AUDI packet
 * insertion on data island when FC is on RDRB mode for this packet. Address
 * Offset: 0x10BA Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb2
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb2_bitfields
    {
        uint8_t AUDIframeinterpolation : 4; /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB2 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB2_ADDR(x) ((uintptr_t)(x) + 0x10BAU)

#define HW_HDMI_FC_RDRB2(x)      (*(__IO hw_hdmi_fc_rdrb2_t *) HW_HDMI_FC_RDRB2_ADDR(x))
#define HW_HDMI_FC_RDRB2_RD(x)   (HW_HDMI_FC_RDRB2(x).U)
#define HW_HDMI_FC_RDRB2_WR(x, v) (HW_HDMI_FC_RDRB2(x).U = (v))
#define HW_HDMI_FC_RDRB2_SET(x, v) (HW_HDMI_FC_RDRB2_WR(x, HW_HDMI_FC_RDRB2_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB2_CLR(x, v) (HW_HDMI_FC_RDRB2_WR(x, HW_HDMI_FC_RDRB2_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB2_TOG(x, v) (HW_HDMI_FC_RDRB2_WR(x, HW_HDMI_FC_RDRB2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB2 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB2, field AUDIframeinterpolation[3:0] (RW)
 *
 * Audio frame interpolation
 */
/*@{*/
#define BP_HDMI_FC_RDRB2_AUDIframeinterpolation (0U) /*!< Bit position for HDMI_FC_RDRB2_AUDIframeinterpolation. */
#define BM_HDMI_FC_RDRB2_AUDIframeinterpolation (0x0FU) /*!< Bit mask for HDMI_FC_RDRB2_AUDIframeinterpolation. */
#define BS_HDMI_FC_RDRB2_AUDIframeinterpolation (4U) /*!< Bit field size in bits for HDMI_FC_RDRB2_AUDIframeinterpolation. */

/*! @brief Read current value of the HDMI_FC_RDRB2_AUDIframeinterpolation field. */
#define BR_HDMI_FC_RDRB2_AUDIframeinterpolation(x) (HW_HDMI_FC_RDRB2(x).B.AUDIframeinterpolation)

/*! @brief Format value for bitfield HDMI_FC_RDRB2_AUDIframeinterpolation. */
#define BF_HDMI_FC_RDRB2_AUDIframeinterpolation(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB2_AUDIframeinterpolation) & BM_HDMI_FC_RDRB2_AUDIframeinterpolation)

/*! @brief Set the AUDIframeinterpolation field to a new value. */
#define BW_HDMI_FC_RDRB2_AUDIframeinterpolation(x, v) (HW_HDMI_FC_RDRB2_WR(x, (HW_HDMI_FC_RDRB2_RD(x) & ~BM_HDMI_FC_RDRB2_AUDIframeinterpolation) | BF_HDMI_FC_RDRB2_AUDIframeinterpolation(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB3 - Frame Composer Round Robin ACR Packet Insertion Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB3 - Frame Composer Round Robin ACR Packet Insertion Register 3 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for the AUDI packet insertion on data island when FC is on RDRB
 * mode this packet. Address Offset: 0x10BB Size: 8 bits Value after Reset: 0x00
 * Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb3
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb3_bitfields
    {
        uint8_t AUDIpacketlinespacing : 4; /*!< [3:0]  */
        uint8_t AUDIpacketsinframe : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB3 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB3_ADDR(x) ((uintptr_t)(x) + 0x10BBU)

#define HW_HDMI_FC_RDRB3(x)      (*(__IO hw_hdmi_fc_rdrb3_t *) HW_HDMI_FC_RDRB3_ADDR(x))
#define HW_HDMI_FC_RDRB3_RD(x)   (HW_HDMI_FC_RDRB3(x).U)
#define HW_HDMI_FC_RDRB3_WR(x, v) (HW_HDMI_FC_RDRB3(x).U = (v))
#define HW_HDMI_FC_RDRB3_SET(x, v) (HW_HDMI_FC_RDRB3_WR(x, HW_HDMI_FC_RDRB3_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB3_CLR(x, v) (HW_HDMI_FC_RDRB3_WR(x, HW_HDMI_FC_RDRB3_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB3_TOG(x, v) (HW_HDMI_FC_RDRB3_WR(x, HW_HDMI_FC_RDRB3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB3 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB3, field AUDIpacketlinespacing[3:0] (RW)
 *
 * Audio packets line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB3_AUDIpacketlinespacing (0U) /*!< Bit position for HDMI_FC_RDRB3_AUDIpacketlinespacing. */
#define BM_HDMI_FC_RDRB3_AUDIpacketlinespacing (0x0FU) /*!< Bit mask for HDMI_FC_RDRB3_AUDIpacketlinespacing. */
#define BS_HDMI_FC_RDRB3_AUDIpacketlinespacing (4U) /*!< Bit field size in bits for HDMI_FC_RDRB3_AUDIpacketlinespacing. */

/*! @brief Read current value of the HDMI_FC_RDRB3_AUDIpacketlinespacing field. */
#define BR_HDMI_FC_RDRB3_AUDIpacketlinespacing(x) (HW_HDMI_FC_RDRB3(x).B.AUDIpacketlinespacing)

/*! @brief Format value for bitfield HDMI_FC_RDRB3_AUDIpacketlinespacing. */
#define BF_HDMI_FC_RDRB3_AUDIpacketlinespacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB3_AUDIpacketlinespacing) & BM_HDMI_FC_RDRB3_AUDIpacketlinespacing)

/*! @brief Set the AUDIpacketlinespacing field to a new value. */
#define BW_HDMI_FC_RDRB3_AUDIpacketlinespacing(x, v) (HW_HDMI_FC_RDRB3_WR(x, (HW_HDMI_FC_RDRB3_RD(x) & ~BM_HDMI_FC_RDRB3_AUDIpacketlinespacing) | BF_HDMI_FC_RDRB3_AUDIpacketlinespacing(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_RDRB3, field AUDIpacketsinframe[7:4] (RW)
 *
 * Audio packets per frame
 */
/*@{*/
#define BP_HDMI_FC_RDRB3_AUDIpacketsinframe (4U) /*!< Bit position for HDMI_FC_RDRB3_AUDIpacketsinframe. */
#define BM_HDMI_FC_RDRB3_AUDIpacketsinframe (0xF0U) /*!< Bit mask for HDMI_FC_RDRB3_AUDIpacketsinframe. */
#define BS_HDMI_FC_RDRB3_AUDIpacketsinframe (4U) /*!< Bit field size in bits for HDMI_FC_RDRB3_AUDIpacketsinframe. */

/*! @brief Read current value of the HDMI_FC_RDRB3_AUDIpacketsinframe field. */
#define BR_HDMI_FC_RDRB3_AUDIpacketsinframe(x) (HW_HDMI_FC_RDRB3(x).B.AUDIpacketsinframe)

/*! @brief Format value for bitfield HDMI_FC_RDRB3_AUDIpacketsinframe. */
#define BF_HDMI_FC_RDRB3_AUDIpacketsinframe(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB3_AUDIpacketsinframe) & BM_HDMI_FC_RDRB3_AUDIpacketsinframe)

/*! @brief Set the AUDIpacketsinframe field to a new value. */
#define BW_HDMI_FC_RDRB3_AUDIpacketsinframe(x, v) (HW_HDMI_FC_RDRB3_WR(x, (HW_HDMI_FC_RDRB3_RD(x) & ~BM_HDMI_FC_RDRB3_AUDIpacketsinframe) | BF_HDMI_FC_RDRB3_AUDIpacketsinframe(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB4 - Frame Composer Round Robin ACR Packet Insertion Register 4
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB4 - Frame Composer Round Robin ACR Packet Insertion Register 4 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB frame interpolation for GCP packet
 * insertion on data island when FC is on RDRB mode for this packet. Address
 * Offset: 0x10BC Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb4
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb4_bitfields
    {
        uint8_t GCPframeinterpolation : 4; /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB4 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB4_ADDR(x) ((uintptr_t)(x) + 0x10BCU)

#define HW_HDMI_FC_RDRB4(x)      (*(__IO hw_hdmi_fc_rdrb4_t *) HW_HDMI_FC_RDRB4_ADDR(x))
#define HW_HDMI_FC_RDRB4_RD(x)   (HW_HDMI_FC_RDRB4(x).U)
#define HW_HDMI_FC_RDRB4_WR(x, v) (HW_HDMI_FC_RDRB4(x).U = (v))
#define HW_HDMI_FC_RDRB4_SET(x, v) (HW_HDMI_FC_RDRB4_WR(x, HW_HDMI_FC_RDRB4_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB4_CLR(x, v) (HW_HDMI_FC_RDRB4_WR(x, HW_HDMI_FC_RDRB4_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB4_TOG(x, v) (HW_HDMI_FC_RDRB4_WR(x, HW_HDMI_FC_RDRB4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB4 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB4, field GCPframeinterpolation[3:0] (RW)
 *
 * GCP packets line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB4_GCPframeinterpolation (0U) /*!< Bit position for HDMI_FC_RDRB4_GCPframeinterpolation. */
#define BM_HDMI_FC_RDRB4_GCPframeinterpolation (0x0FU) /*!< Bit mask for HDMI_FC_RDRB4_GCPframeinterpolation. */
#define BS_HDMI_FC_RDRB4_GCPframeinterpolation (4U) /*!< Bit field size in bits for HDMI_FC_RDRB4_GCPframeinterpolation. */

/*! @brief Read current value of the HDMI_FC_RDRB4_GCPframeinterpolation field. */
#define BR_HDMI_FC_RDRB4_GCPframeinterpolation(x) (HW_HDMI_FC_RDRB4(x).B.GCPframeinterpolation)

/*! @brief Format value for bitfield HDMI_FC_RDRB4_GCPframeinterpolation. */
#define BF_HDMI_FC_RDRB4_GCPframeinterpolation(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB4_GCPframeinterpolation) & BM_HDMI_FC_RDRB4_GCPframeinterpolation)

/*! @brief Set the GCPframeinterpolation field to a new value. */
#define BW_HDMI_FC_RDRB4_GCPframeinterpolation(x, v) (HW_HDMI_FC_RDRB4_WR(x, (HW_HDMI_FC_RDRB4_RD(x) & ~BM_HDMI_FC_RDRB4_GCPframeinterpolation) | BF_HDMI_FC_RDRB4_GCPframeinterpolation(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB5 - Frame Composer Round Robin ACR Packet Insertion Register 5
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB5 - Frame Composer Round Robin ACR Packet Insertion Register 5 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for the GCP packet insertion on data island when FC is on RDRB
 * mode this packet. Address Offset: 0x10BD Size: 8 bits Value after Reset: 0x00
 * Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb5
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb5_bitfields
    {
        uint8_t GCPpacketlinespacing : 4; /*!< [3:0]  */
        uint8_t GCPpacketsinframe : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB5 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB5_ADDR(x) ((uintptr_t)(x) + 0x10BDU)

#define HW_HDMI_FC_RDRB5(x)      (*(__IO hw_hdmi_fc_rdrb5_t *) HW_HDMI_FC_RDRB5_ADDR(x))
#define HW_HDMI_FC_RDRB5_RD(x)   (HW_HDMI_FC_RDRB5(x).U)
#define HW_HDMI_FC_RDRB5_WR(x, v) (HW_HDMI_FC_RDRB5(x).U = (v))
#define HW_HDMI_FC_RDRB5_SET(x, v) (HW_HDMI_FC_RDRB5_WR(x, HW_HDMI_FC_RDRB5_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB5_CLR(x, v) (HW_HDMI_FC_RDRB5_WR(x, HW_HDMI_FC_RDRB5_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB5_TOG(x, v) (HW_HDMI_FC_RDRB5_WR(x, HW_HDMI_FC_RDRB5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB5 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB5, field GCPpacketlinespacing[3:0] (RW)
 *
 * GCP packets line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB5_GCPpacketlinespacing (0U) /*!< Bit position for HDMI_FC_RDRB5_GCPpacketlinespacing. */
#define BM_HDMI_FC_RDRB5_GCPpacketlinespacing (0x0FU) /*!< Bit mask for HDMI_FC_RDRB5_GCPpacketlinespacing. */
#define BS_HDMI_FC_RDRB5_GCPpacketlinespacing (4U) /*!< Bit field size in bits for HDMI_FC_RDRB5_GCPpacketlinespacing. */

/*! @brief Read current value of the HDMI_FC_RDRB5_GCPpacketlinespacing field. */
#define BR_HDMI_FC_RDRB5_GCPpacketlinespacing(x) (HW_HDMI_FC_RDRB5(x).B.GCPpacketlinespacing)

/*! @brief Format value for bitfield HDMI_FC_RDRB5_GCPpacketlinespacing. */
#define BF_HDMI_FC_RDRB5_GCPpacketlinespacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB5_GCPpacketlinespacing) & BM_HDMI_FC_RDRB5_GCPpacketlinespacing)

/*! @brief Set the GCPpacketlinespacing field to a new value. */
#define BW_HDMI_FC_RDRB5_GCPpacketlinespacing(x, v) (HW_HDMI_FC_RDRB5_WR(x, (HW_HDMI_FC_RDRB5_RD(x) & ~BM_HDMI_FC_RDRB5_GCPpacketlinespacing) | BF_HDMI_FC_RDRB5_GCPpacketlinespacing(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_RDRB5, field GCPpacketsinframe[7:4] (RW)
 *
 * GCP packets per frame
 */
/*@{*/
#define BP_HDMI_FC_RDRB5_GCPpacketsinframe (4U) /*!< Bit position for HDMI_FC_RDRB5_GCPpacketsinframe. */
#define BM_HDMI_FC_RDRB5_GCPpacketsinframe (0xF0U) /*!< Bit mask for HDMI_FC_RDRB5_GCPpacketsinframe. */
#define BS_HDMI_FC_RDRB5_GCPpacketsinframe (4U) /*!< Bit field size in bits for HDMI_FC_RDRB5_GCPpacketsinframe. */

/*! @brief Read current value of the HDMI_FC_RDRB5_GCPpacketsinframe field. */
#define BR_HDMI_FC_RDRB5_GCPpacketsinframe(x) (HW_HDMI_FC_RDRB5(x).B.GCPpacketsinframe)

/*! @brief Format value for bitfield HDMI_FC_RDRB5_GCPpacketsinframe. */
#define BF_HDMI_FC_RDRB5_GCPpacketsinframe(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB5_GCPpacketsinframe) & BM_HDMI_FC_RDRB5_GCPpacketsinframe)

/*! @brief Set the GCPpacketsinframe field to a new value. */
#define BW_HDMI_FC_RDRB5_GCPpacketsinframe(x, v) (HW_HDMI_FC_RDRB5_WR(x, (HW_HDMI_FC_RDRB5_RD(x) & ~BM_HDMI_FC_RDRB5_GCPpacketsinframe) | BF_HDMI_FC_RDRB5_GCPpacketsinframe(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB6 - Frame Composer Round Robin ACR Packet Insertion Register 6
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB6 - Frame Composer Round Robin ACR Packet Insertion Register 6 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB frame interpolation for AVI packet
 * insertion on data island when FC is on RDRB mode for this packet. Address
 * Offset: 0x10BE Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb6
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb6_bitfields
    {
        uint8_t AVIframeinterpolation : 4; /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB6 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB6_ADDR(x) ((uintptr_t)(x) + 0x10BEU)

#define HW_HDMI_FC_RDRB6(x)      (*(__IO hw_hdmi_fc_rdrb6_t *) HW_HDMI_FC_RDRB6_ADDR(x))
#define HW_HDMI_FC_RDRB6_RD(x)   (HW_HDMI_FC_RDRB6(x).U)
#define HW_HDMI_FC_RDRB6_WR(x, v) (HW_HDMI_FC_RDRB6(x).U = (v))
#define HW_HDMI_FC_RDRB6_SET(x, v) (HW_HDMI_FC_RDRB6_WR(x, HW_HDMI_FC_RDRB6_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB6_CLR(x, v) (HW_HDMI_FC_RDRB6_WR(x, HW_HDMI_FC_RDRB6_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB6_TOG(x, v) (HW_HDMI_FC_RDRB6_WR(x, HW_HDMI_FC_RDRB6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB6 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB6, field AVIframeinterpolation[3:0] (RW)
 *
 * GCP packets line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB6_AVIframeinterpolation (0U) /*!< Bit position for HDMI_FC_RDRB6_AVIframeinterpolation. */
#define BM_HDMI_FC_RDRB6_AVIframeinterpolation (0x0FU) /*!< Bit mask for HDMI_FC_RDRB6_AVIframeinterpolation. */
#define BS_HDMI_FC_RDRB6_AVIframeinterpolation (4U) /*!< Bit field size in bits for HDMI_FC_RDRB6_AVIframeinterpolation. */

/*! @brief Read current value of the HDMI_FC_RDRB6_AVIframeinterpolation field. */
#define BR_HDMI_FC_RDRB6_AVIframeinterpolation(x) (HW_HDMI_FC_RDRB6(x).B.AVIframeinterpolation)

/*! @brief Format value for bitfield HDMI_FC_RDRB6_AVIframeinterpolation. */
#define BF_HDMI_FC_RDRB6_AVIframeinterpolation(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB6_AVIframeinterpolation) & BM_HDMI_FC_RDRB6_AVIframeinterpolation)

/*! @brief Set the AVIframeinterpolation field to a new value. */
#define BW_HDMI_FC_RDRB6_AVIframeinterpolation(x, v) (HW_HDMI_FC_RDRB6_WR(x, (HW_HDMI_FC_RDRB6_RD(x) & ~BM_HDMI_FC_RDRB6_AVIframeinterpolation) | BF_HDMI_FC_RDRB6_AVIframeinterpolation(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_RDRB7 - Frame Composer Round Robin ACR Packet Insertion Register 7
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_RDRB7 - Frame Composer Round Robin ACR Packet Insertion Register 7 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for the AVI packet insertion on data island when FC is on RDRB
 * mode this packet. Address Offset: 0x10BF Size: 8 bits Value after Reset: 0x00
 * Access: Read/Write
 */
typedef union _hw_hdmi_fc_rdrb7
{
    uint8_t U;
    struct _hw_hdmi_fc_rdrb7_bitfields
    {
        uint8_t AVIpacketlinespacing : 4; /*!< [3:0]  */
        uint8_t AVIpacketsinframe : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_rdrb7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_RDRB7 register
 */
/*@{*/
#define HW_HDMI_FC_RDRB7_ADDR(x) ((uintptr_t)(x) + 0x10BFU)

#define HW_HDMI_FC_RDRB7(x)      (*(__IO hw_hdmi_fc_rdrb7_t *) HW_HDMI_FC_RDRB7_ADDR(x))
#define HW_HDMI_FC_RDRB7_RD(x)   (HW_HDMI_FC_RDRB7(x).U)
#define HW_HDMI_FC_RDRB7_WR(x, v) (HW_HDMI_FC_RDRB7(x).U = (v))
#define HW_HDMI_FC_RDRB7_SET(x, v) (HW_HDMI_FC_RDRB7_WR(x, HW_HDMI_FC_RDRB7_RD(x) |  (v)))
#define HW_HDMI_FC_RDRB7_CLR(x, v) (HW_HDMI_FC_RDRB7_WR(x, HW_HDMI_FC_RDRB7_RD(x) & ~(v)))
#define HW_HDMI_FC_RDRB7_TOG(x, v) (HW_HDMI_FC_RDRB7_WR(x, HW_HDMI_FC_RDRB7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_RDRB7 bitfields
 */

/*!
 * @name Register HDMI_FC_RDRB7, field AVIpacketlinespacing[3:0] (RW)
 *
 * AVI packets line spacing
 */
/*@{*/
#define BP_HDMI_FC_RDRB7_AVIpacketlinespacing (0U) /*!< Bit position for HDMI_FC_RDRB7_AVIpacketlinespacing. */
#define BM_HDMI_FC_RDRB7_AVIpacketlinespacing (0x0FU) /*!< Bit mask for HDMI_FC_RDRB7_AVIpacketlinespacing. */
#define BS_HDMI_FC_RDRB7_AVIpacketlinespacing (4U) /*!< Bit field size in bits for HDMI_FC_RDRB7_AVIpacketlinespacing. */

/*! @brief Read current value of the HDMI_FC_RDRB7_AVIpacketlinespacing field. */
#define BR_HDMI_FC_RDRB7_AVIpacketlinespacing(x) (HW_HDMI_FC_RDRB7(x).B.AVIpacketlinespacing)

/*! @brief Format value for bitfield HDMI_FC_RDRB7_AVIpacketlinespacing. */
#define BF_HDMI_FC_RDRB7_AVIpacketlinespacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB7_AVIpacketlinespacing) & BM_HDMI_FC_RDRB7_AVIpacketlinespacing)

/*! @brief Set the AVIpacketlinespacing field to a new value. */
#define BW_HDMI_FC_RDRB7_AVIpacketlinespacing(x, v) (HW_HDMI_FC_RDRB7_WR(x, (HW_HDMI_FC_RDRB7_RD(x) & ~BM_HDMI_FC_RDRB7_AVIpacketlinespacing) | BF_HDMI_FC_RDRB7_AVIpacketlinespacing(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_RDRB7, field AVIpacketsinframe[7:4] (RW)
 *
 * AVI packets per frame
 */
/*@{*/
#define BP_HDMI_FC_RDRB7_AVIpacketsinframe (4U) /*!< Bit position for HDMI_FC_RDRB7_AVIpacketsinframe. */
#define BM_HDMI_FC_RDRB7_AVIpacketsinframe (0xF0U) /*!< Bit mask for HDMI_FC_RDRB7_AVIpacketsinframe. */
#define BS_HDMI_FC_RDRB7_AVIpacketsinframe (4U) /*!< Bit field size in bits for HDMI_FC_RDRB7_AVIpacketsinframe. */

/*! @brief Read current value of the HDMI_FC_RDRB7_AVIpacketsinframe field. */
#define BR_HDMI_FC_RDRB7_AVIpacketsinframe(x) (HW_HDMI_FC_RDRB7(x).B.AVIpacketsinframe)

/*! @brief Format value for bitfield HDMI_FC_RDRB7_AVIpacketsinframe. */
#define BF_HDMI_FC_RDRB7_AVIpacketsinframe(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_RDRB7_AVIpacketsinframe) & BM_HDMI_FC_RDRB7_AVIpacketsinframe)

/*! @brief Set the AVIpacketsinframe field to a new value. */
#define BW_HDMI_FC_RDRB7_AVIpacketsinframe(x, v) (HW_HDMI_FC_RDRB7_WR(x, (HW_HDMI_FC_RDRB7_RD(x) & ~BM_HDMI_FC_RDRB7_AVIpacketsinframe) | BF_HDMI_FC_RDRB7_AVIpacketsinframe(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_STAT0 - FC_STAT0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_STAT0 - FC_STAT0 (RO)
 *
 * Reset value: 0x00U
 *
 * Configures the Frame Composer (FC) RDRB line interpolation and number of
 * packets in frame for the AVI packet insertion on data island when FC is on RDRB
 * mode this packet. Address Offset: 0x10D0 Size: 8 bits Value after Reset: 0x00
 * Access: Read
 */
typedef union _hw_hdmi_fc_stat0
{
    uint8_t U;
    struct _hw_hdmi_fc_stat0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t RESERVED0 : 2;         /*!< [4:3]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_fc_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_STAT0 register
 */
/*@{*/
#define HW_HDMI_FC_STAT0_ADDR(x) ((uintptr_t)(x) + 0x10D0U)

#define HW_HDMI_FC_STAT0(x)      (*(__I hw_hdmi_fc_stat0_t *) HW_HDMI_FC_STAT0_ADDR(x))
#define HW_HDMI_FC_STAT0_RD(x)   (HW_HDMI_FC_STAT0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_STAT0 bitfields
 */

/*!
 * @name Register HDMI_FC_STAT0, field NULL_[0] (RO)
 *
 * Status bit Active after successful transmission of an Null packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT0_NULL_ (0U)        /*!< Bit position for HDMI_FC_STAT0_NULL_. */
#define BM_HDMI_FC_STAT0_NULL_ (0x01U)     /*!< Bit mask for HDMI_FC_STAT0_NULL_. */
#define BS_HDMI_FC_STAT0_NULL_ (1U)        /*!< Bit field size in bits for HDMI_FC_STAT0_NULL_. */

/*! @brief Read current value of the HDMI_FC_STAT0_NULL_ field. */
#define BR_HDMI_FC_STAT0_NULL_(x) (HW_HDMI_FC_STAT0(x).B.NULL_)
/*@}*/

/*!
 * @name Register HDMI_FC_STAT0, field ACR[1] (RO)
 *
 * Status bit Active after successful transmission of an Audio Clock
 * Regeneration (N/CTS transmission) packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT0_ACR (1U)          /*!< Bit position for HDMI_FC_STAT0_ACR. */
#define BM_HDMI_FC_STAT0_ACR (0x02U)       /*!< Bit mask for HDMI_FC_STAT0_ACR. */
#define BS_HDMI_FC_STAT0_ACR (1U)          /*!< Bit field size in bits for HDMI_FC_STAT0_ACR. */

/*! @brief Read current value of the HDMI_FC_STAT0_ACR field. */
#define BR_HDMI_FC_STAT0_ACR(x) (HW_HDMI_FC_STAT0(x).B.ACR)
/*@}*/

/*!
 * @name Register HDMI_FC_STAT0, field AUDS[2] (RO)
 *
 * Status bit Active after successful transmission of an Audio Sample packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT0_AUDS (2U)         /*!< Bit position for HDMI_FC_STAT0_AUDS. */
#define BM_HDMI_FC_STAT0_AUDS (0x04U)      /*!< Bit mask for HDMI_FC_STAT0_AUDS. */
#define BS_HDMI_FC_STAT0_AUDS (1U)         /*!< Bit field size in bits for HDMI_FC_STAT0_AUDS. */

/*! @brief Read current value of the HDMI_FC_STAT0_AUDS field. */
#define BR_HDMI_FC_STAT0_AUDS(x) (HW_HDMI_FC_STAT0(x).B.AUDS)
/*@}*/

/*!
 * @name Register HDMI_FC_STAT0, field HBR[5] (RO)
 *
 * Status bit. Active after successful transmission of an Audio HBR packet
 */
/*@{*/
#define BP_HDMI_FC_STAT0_HBR (5U)          /*!< Bit position for HDMI_FC_STAT0_HBR. */
#define BM_HDMI_FC_STAT0_HBR (0x20U)       /*!< Bit mask for HDMI_FC_STAT0_HBR. */
#define BS_HDMI_FC_STAT0_HBR (1U)          /*!< Bit field size in bits for HDMI_FC_STAT0_HBR. */

/*! @brief Read current value of the HDMI_FC_STAT0_HBR field. */
#define BR_HDMI_FC_STAT0_HBR(x) (HW_HDMI_FC_STAT0(x).B.HBR)
/*@}*/

/*!
 * @name Register HDMI_FC_STAT0, field ACP[6] (RO)
 *
 * Status bit. Active after successful transmission of an Audio Content
 * Protection Packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT0_ACP (6U)          /*!< Bit position for HDMI_FC_STAT0_ACP. */
#define BM_HDMI_FC_STAT0_ACP (0x40U)       /*!< Bit mask for HDMI_FC_STAT0_ACP. */
#define BS_HDMI_FC_STAT0_ACP (1U)          /*!< Bit field size in bits for HDMI_FC_STAT0_ACP. */

/*! @brief Read current value of the HDMI_FC_STAT0_ACP field. */
#define BR_HDMI_FC_STAT0_ACP(x) (HW_HDMI_FC_STAT0(x).B.ACP)
/*@}*/

/*!
 * @name Register HDMI_FC_STAT0, field AUDI[7] (RO)
 *
 * Status bit Active after successful transmission of an Audio InfoFrame packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT0_AUDI (7U)         /*!< Bit position for HDMI_FC_STAT0_AUDI. */
#define BM_HDMI_FC_STAT0_AUDI (0x80U)      /*!< Bit mask for HDMI_FC_STAT0_AUDI. */
#define BS_HDMI_FC_STAT0_AUDI (1U)         /*!< Bit field size in bits for HDMI_FC_STAT0_AUDI. */

/*! @brief Read current value of the HDMI_FC_STAT0_AUDI field. */
#define BR_HDMI_FC_STAT0_AUDI(x) (HW_HDMI_FC_STAT0(x).B.AUDI)
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INT0 - FC_INT0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INT0 - FC_INT0 (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt indication of the FC_STAT0 status
 * interrupts. Interrupt generation is accomplished in the following way: interrupt =
 * (mask == 1'b0) && (polarity == status); All this interrupts are forwarded to
 * the Interrupt Handler sticky bit registers and after ORed to a single main
 * interrupt line to micro controller. Assertion of this interrupt implies that data
 * related with the corresponding packet has been sent through the HDMI interface.
 * Address Offset: 0x10D1 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_int0
{
    uint8_t U;
    struct _hw_hdmi_fc_int0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t RESERVED0 : 2;         /*!< [4:3]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_fc_int0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INT0 register
 */
/*@{*/
#define HW_HDMI_FC_INT0_ADDR(x)  ((uintptr_t)(x) + 0x10D1U)

#define HW_HDMI_FC_INT0(x)       (*(__IO hw_hdmi_fc_int0_t *) HW_HDMI_FC_INT0_ADDR(x))
#define HW_HDMI_FC_INT0_RD(x)    (HW_HDMI_FC_INT0(x).U)
#define HW_HDMI_FC_INT0_WR(x, v) (HW_HDMI_FC_INT0(x).U = (v))
#define HW_HDMI_FC_INT0_SET(x, v) (HW_HDMI_FC_INT0_WR(x, HW_HDMI_FC_INT0_RD(x) |  (v)))
#define HW_HDMI_FC_INT0_CLR(x, v) (HW_HDMI_FC_INT0_WR(x, HW_HDMI_FC_INT0_RD(x) & ~(v)))
#define HW_HDMI_FC_INT0_TOG(x, v) (HW_HDMI_FC_INT0_WR(x, HW_HDMI_FC_INT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INT0 bitfields
 */

/*!
 * @name Register HDMI_FC_INT0, field NULL_[0] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Null
 * packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_NULL_ (0U)         /*!< Bit position for HDMI_FC_INT0_NULL_. */
#define BM_HDMI_FC_INT0_NULL_ (0x01U)      /*!< Bit mask for HDMI_FC_INT0_NULL_. */
#define BS_HDMI_FC_INT0_NULL_ (1U)         /*!< Bit field size in bits for HDMI_FC_INT0_NULL_. */

/*! @brief Read current value of the HDMI_FC_INT0_NULL_ field. */
#define BR_HDMI_FC_INT0_NULL_(x) (HW_HDMI_FC_INT0(x).B.NULL_)

/*! @brief Format value for bitfield HDMI_FC_INT0_NULL_. */
#define BF_HDMI_FC_INT0_NULL_(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_NULL_) & BM_HDMI_FC_INT0_NULL_)

/*! @brief Set the NULL_ field to a new value. */
#define BW_HDMI_FC_INT0_NULL_(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_NULL_) | BF_HDMI_FC_INT0_NULL_(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT0, field ACR[1] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Audio
 * Clock Regeneration (N/CTS transmission) packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_ACR  (1U)          /*!< Bit position for HDMI_FC_INT0_ACR. */
#define BM_HDMI_FC_INT0_ACR  (0x02U)       /*!< Bit mask for HDMI_FC_INT0_ACR. */
#define BS_HDMI_FC_INT0_ACR  (1U)          /*!< Bit field size in bits for HDMI_FC_INT0_ACR. */

/*! @brief Read current value of the HDMI_FC_INT0_ACR field. */
#define BR_HDMI_FC_INT0_ACR(x) (HW_HDMI_FC_INT0(x).B.ACR)

/*! @brief Format value for bitfield HDMI_FC_INT0_ACR. */
#define BF_HDMI_FC_INT0_ACR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_ACR) & BM_HDMI_FC_INT0_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_HDMI_FC_INT0_ACR(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_ACR) | BF_HDMI_FC_INT0_ACR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT0, field AUDS[2] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Audio
 * Sample packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_AUDS (2U)          /*!< Bit position for HDMI_FC_INT0_AUDS. */
#define BM_HDMI_FC_INT0_AUDS (0x04U)       /*!< Bit mask for HDMI_FC_INT0_AUDS. */
#define BS_HDMI_FC_INT0_AUDS (1U)          /*!< Bit field size in bits for HDMI_FC_INT0_AUDS. */

/*! @brief Read current value of the HDMI_FC_INT0_AUDS field. */
#define BR_HDMI_FC_INT0_AUDS(x) (HW_HDMI_FC_INT0(x).B.AUDS)

/*! @brief Format value for bitfield HDMI_FC_INT0_AUDS. */
#define BF_HDMI_FC_INT0_AUDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_AUDS) & BM_HDMI_FC_INT0_AUDS)

/*! @brief Set the AUDS field to a new value. */
#define BW_HDMI_FC_INT0_AUDS(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_AUDS) | BF_HDMI_FC_INT0_AUDS(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT0, field HBR[5] (RW)
 *
 * Interrupt indication bit Active after successful transmission of a Audio HBR
 * packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_HBR  (5U)          /*!< Bit position for HDMI_FC_INT0_HBR. */
#define BM_HDMI_FC_INT0_HBR  (0x20U)       /*!< Bit mask for HDMI_FC_INT0_HBR. */
#define BS_HDMI_FC_INT0_HBR  (1U)          /*!< Bit field size in bits for HDMI_FC_INT0_HBR. */

/*! @brief Read current value of the HDMI_FC_INT0_HBR field. */
#define BR_HDMI_FC_INT0_HBR(x) (HW_HDMI_FC_INT0(x).B.HBR)

/*! @brief Format value for bitfield HDMI_FC_INT0_HBR. */
#define BF_HDMI_FC_INT0_HBR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_HBR) & BM_HDMI_FC_INT0_HBR)

/*! @brief Set the HBR field to a new value. */
#define BW_HDMI_FC_INT0_HBR(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_HBR) | BF_HDMI_FC_INT0_HBR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT0, field ACP[6] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Audio
 * Content Protection packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_ACP  (6U)          /*!< Bit position for HDMI_FC_INT0_ACP. */
#define BM_HDMI_FC_INT0_ACP  (0x40U)       /*!< Bit mask for HDMI_FC_INT0_ACP. */
#define BS_HDMI_FC_INT0_ACP  (1U)          /*!< Bit field size in bits for HDMI_FC_INT0_ACP. */

/*! @brief Read current value of the HDMI_FC_INT0_ACP field. */
#define BR_HDMI_FC_INT0_ACP(x) (HW_HDMI_FC_INT0(x).B.ACP)

/*! @brief Format value for bitfield HDMI_FC_INT0_ACP. */
#define BF_HDMI_FC_INT0_ACP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_ACP) & BM_HDMI_FC_INT0_ACP)

/*! @brief Set the ACP field to a new value. */
#define BW_HDMI_FC_INT0_ACP(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_ACP) | BF_HDMI_FC_INT0_ACP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT0, field AUDI[7] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Audio
 * InfoFrame packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT0_AUDI (7U)          /*!< Bit position for HDMI_FC_INT0_AUDI. */
#define BM_HDMI_FC_INT0_AUDI (0x80U)       /*!< Bit mask for HDMI_FC_INT0_AUDI. */
#define BS_HDMI_FC_INT0_AUDI (1U)          /*!< Bit field size in bits for HDMI_FC_INT0_AUDI. */

/*! @brief Read current value of the HDMI_FC_INT0_AUDI field. */
#define BR_HDMI_FC_INT0_AUDI(x) (HW_HDMI_FC_INT0(x).B.AUDI)

/*! @brief Format value for bitfield HDMI_FC_INT0_AUDI. */
#define BF_HDMI_FC_INT0_AUDI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT0_AUDI) & BM_HDMI_FC_INT0_AUDI)

/*! @brief Set the AUDI field to a new value. */
#define BW_HDMI_FC_INT0_AUDI(x, v) (HW_HDMI_FC_INT0_WR(x, (HW_HDMI_FC_INT0_RD(x) & ~BM_HDMI_FC_INT0_AUDI) | BF_HDMI_FC_INT0_AUDI(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_MASK0 - Frame Composer Packet Interrupt Mask Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_MASK0 - Frame Composer Packet Interrupt Mask Register 0 (RW)
 *
 * Reset value: 0x25U
 *
 * Mask register for generation of FC_INT0 interrupts. Address Offset: 0x10D2
 * Size: 8 bits Value after Reset: 0x25 Access: Read/Write
 */
typedef union _hw_hdmi_fc_mask0
{
    uint8_t U;
    struct _hw_hdmi_fc_mask0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t RESERVED0 : 2;         /*!< [4:3]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_fc_mask0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_MASK0 register
 */
/*@{*/
#define HW_HDMI_FC_MASK0_ADDR(x) ((uintptr_t)(x) + 0x10D2U)

#define HW_HDMI_FC_MASK0(x)      (*(__IO hw_hdmi_fc_mask0_t *) HW_HDMI_FC_MASK0_ADDR(x))
#define HW_HDMI_FC_MASK0_RD(x)   (HW_HDMI_FC_MASK0(x).U)
#define HW_HDMI_FC_MASK0_WR(x, v) (HW_HDMI_FC_MASK0(x).U = (v))
#define HW_HDMI_FC_MASK0_SET(x, v) (HW_HDMI_FC_MASK0_WR(x, HW_HDMI_FC_MASK0_RD(x) |  (v)))
#define HW_HDMI_FC_MASK0_CLR(x, v) (HW_HDMI_FC_MASK0_WR(x, HW_HDMI_FC_MASK0_RD(x) & ~(v)))
#define HW_HDMI_FC_MASK0_TOG(x, v) (HW_HDMI_FC_MASK0_WR(x, HW_HDMI_FC_MASK0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_MASK0 bitfields
 */

/*!
 * @name Register HDMI_FC_MASK0, field NULL_[0] (RW)
 *
 * Mask bit for FC_INT0.NULL interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_NULL_ (0U)        /*!< Bit position for HDMI_FC_MASK0_NULL_. */
#define BM_HDMI_FC_MASK0_NULL_ (0x01U)     /*!< Bit mask for HDMI_FC_MASK0_NULL_. */
#define BS_HDMI_FC_MASK0_NULL_ (1U)        /*!< Bit field size in bits for HDMI_FC_MASK0_NULL_. */

/*! @brief Read current value of the HDMI_FC_MASK0_NULL_ field. */
#define BR_HDMI_FC_MASK0_NULL_(x) (HW_HDMI_FC_MASK0(x).B.NULL_)

/*! @brief Format value for bitfield HDMI_FC_MASK0_NULL_. */
#define BF_HDMI_FC_MASK0_NULL_(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_NULL_) & BM_HDMI_FC_MASK0_NULL_)

/*! @brief Set the NULL_ field to a new value. */
#define BW_HDMI_FC_MASK0_NULL_(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_NULL_) | BF_HDMI_FC_MASK0_NULL_(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK0, field ACR[1] (RW)
 *
 * Mask bit for FC_INT0.ACR interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_ACR (1U)          /*!< Bit position for HDMI_FC_MASK0_ACR. */
#define BM_HDMI_FC_MASK0_ACR (0x02U)       /*!< Bit mask for HDMI_FC_MASK0_ACR. */
#define BS_HDMI_FC_MASK0_ACR (1U)          /*!< Bit field size in bits for HDMI_FC_MASK0_ACR. */

/*! @brief Read current value of the HDMI_FC_MASK0_ACR field. */
#define BR_HDMI_FC_MASK0_ACR(x) (HW_HDMI_FC_MASK0(x).B.ACR)

/*! @brief Format value for bitfield HDMI_FC_MASK0_ACR. */
#define BF_HDMI_FC_MASK0_ACR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_ACR) & BM_HDMI_FC_MASK0_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_HDMI_FC_MASK0_ACR(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_ACR) | BF_HDMI_FC_MASK0_ACR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK0, field AUDS[2] (RW)
 *
 * Mask bit for FC_INT0.AUDS interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_AUDS (2U)         /*!< Bit position for HDMI_FC_MASK0_AUDS. */
#define BM_HDMI_FC_MASK0_AUDS (0x04U)      /*!< Bit mask for HDMI_FC_MASK0_AUDS. */
#define BS_HDMI_FC_MASK0_AUDS (1U)         /*!< Bit field size in bits for HDMI_FC_MASK0_AUDS. */

/*! @brief Read current value of the HDMI_FC_MASK0_AUDS field. */
#define BR_HDMI_FC_MASK0_AUDS(x) (HW_HDMI_FC_MASK0(x).B.AUDS)

/*! @brief Format value for bitfield HDMI_FC_MASK0_AUDS. */
#define BF_HDMI_FC_MASK0_AUDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_AUDS) & BM_HDMI_FC_MASK0_AUDS)

/*! @brief Set the AUDS field to a new value. */
#define BW_HDMI_FC_MASK0_AUDS(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_AUDS) | BF_HDMI_FC_MASK0_AUDS(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK0, field HBR[5] (RW)
 *
 * Mask bit for FC_INT0.HBR interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_HBR (5U)          /*!< Bit position for HDMI_FC_MASK0_HBR. */
#define BM_HDMI_FC_MASK0_HBR (0x20U)       /*!< Bit mask for HDMI_FC_MASK0_HBR. */
#define BS_HDMI_FC_MASK0_HBR (1U)          /*!< Bit field size in bits for HDMI_FC_MASK0_HBR. */

/*! @brief Read current value of the HDMI_FC_MASK0_HBR field. */
#define BR_HDMI_FC_MASK0_HBR(x) (HW_HDMI_FC_MASK0(x).B.HBR)

/*! @brief Format value for bitfield HDMI_FC_MASK0_HBR. */
#define BF_HDMI_FC_MASK0_HBR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_HBR) & BM_HDMI_FC_MASK0_HBR)

/*! @brief Set the HBR field to a new value. */
#define BW_HDMI_FC_MASK0_HBR(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_HBR) | BF_HDMI_FC_MASK0_HBR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK0, field ACP[6] (RW)
 *
 * Mask bit for FC_INT0.ACP interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_ACP (6U)          /*!< Bit position for HDMI_FC_MASK0_ACP. */
#define BM_HDMI_FC_MASK0_ACP (0x40U)       /*!< Bit mask for HDMI_FC_MASK0_ACP. */
#define BS_HDMI_FC_MASK0_ACP (1U)          /*!< Bit field size in bits for HDMI_FC_MASK0_ACP. */

/*! @brief Read current value of the HDMI_FC_MASK0_ACP field. */
#define BR_HDMI_FC_MASK0_ACP(x) (HW_HDMI_FC_MASK0(x).B.ACP)

/*! @brief Format value for bitfield HDMI_FC_MASK0_ACP. */
#define BF_HDMI_FC_MASK0_ACP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_ACP) & BM_HDMI_FC_MASK0_ACP)

/*! @brief Set the ACP field to a new value. */
#define BW_HDMI_FC_MASK0_ACP(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_ACP) | BF_HDMI_FC_MASK0_ACP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK0, field AUDI[7] (RW)
 *
 * Mask bit for FC_INT0.AUDI interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK0_AUDI (7U)         /*!< Bit position for HDMI_FC_MASK0_AUDI. */
#define BM_HDMI_FC_MASK0_AUDI (0x80U)      /*!< Bit mask for HDMI_FC_MASK0_AUDI. */
#define BS_HDMI_FC_MASK0_AUDI (1U)         /*!< Bit field size in bits for HDMI_FC_MASK0_AUDI. */

/*! @brief Read current value of the HDMI_FC_MASK0_AUDI field. */
#define BR_HDMI_FC_MASK0_AUDI(x) (HW_HDMI_FC_MASK0(x).B.AUDI)

/*! @brief Format value for bitfield HDMI_FC_MASK0_AUDI. */
#define BF_HDMI_FC_MASK0_AUDI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK0_AUDI) & BM_HDMI_FC_MASK0_AUDI)

/*! @brief Set the AUDI field to a new value. */
#define BW_HDMI_FC_MASK0_AUDI(x, v) (HW_HDMI_FC_MASK0_WR(x, (HW_HDMI_FC_MASK0_RD(x) & ~BM_HDMI_FC_MASK0_AUDI) | BF_HDMI_FC_MASK0_AUDI(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_POL0 - FC_POL0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_POL0 - FC_POL0 (RW)
 *
 * Reset value: 0xFFU
 *
 * Polarity register for generation of FC_INT0 interrupts. Address Offset:
 * 0x10D3 Size: 8 bits Value after Reset: 0xFF Access: Read/Write
 */
typedef union _hw_hdmi_fc_pol0
{
    uint8_t U;
    struct _hw_hdmi_fc_pol0_bitfields
    {
        uint8_t NULL_ : 1;             /*!< [0]  */
        uint8_t ACR : 1;               /*!< [1]  */
        uint8_t AUDS : 1;              /*!< [2]  */
        uint8_t RESERVED0 : 2;         /*!< [4:3]  */
        uint8_t HBR : 1;               /*!< [5]  */
        uint8_t ACP : 1;               /*!< [6]  */
        uint8_t AUDI : 1;              /*!< [7]  */
    } B;
} hw_hdmi_fc_pol0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_POL0 register
 */
/*@{*/
#define HW_HDMI_FC_POL0_ADDR(x)  ((uintptr_t)(x) + 0x10D3U)

#define HW_HDMI_FC_POL0(x)       (*(__IO hw_hdmi_fc_pol0_t *) HW_HDMI_FC_POL0_ADDR(x))
#define HW_HDMI_FC_POL0_RD(x)    (HW_HDMI_FC_POL0(x).U)
#define HW_HDMI_FC_POL0_WR(x, v) (HW_HDMI_FC_POL0(x).U = (v))
#define HW_HDMI_FC_POL0_SET(x, v) (HW_HDMI_FC_POL0_WR(x, HW_HDMI_FC_POL0_RD(x) |  (v)))
#define HW_HDMI_FC_POL0_CLR(x, v) (HW_HDMI_FC_POL0_WR(x, HW_HDMI_FC_POL0_RD(x) & ~(v)))
#define HW_HDMI_FC_POL0_TOG(x, v) (HW_HDMI_FC_POL0_WR(x, HW_HDMI_FC_POL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_POL0 bitfields
 */

/*!
 * @name Register HDMI_FC_POL0, field NULL_[0] (RW)
 *
 * Polarity bit for FC_INT0.NULL interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_NULL_ (0U)         /*!< Bit position for HDMI_FC_POL0_NULL_. */
#define BM_HDMI_FC_POL0_NULL_ (0x01U)      /*!< Bit mask for HDMI_FC_POL0_NULL_. */
#define BS_HDMI_FC_POL0_NULL_ (1U)         /*!< Bit field size in bits for HDMI_FC_POL0_NULL_. */

/*! @brief Read current value of the HDMI_FC_POL0_NULL_ field. */
#define BR_HDMI_FC_POL0_NULL_(x) (HW_HDMI_FC_POL0(x).B.NULL_)

/*! @brief Format value for bitfield HDMI_FC_POL0_NULL_. */
#define BF_HDMI_FC_POL0_NULL_(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_NULL_) & BM_HDMI_FC_POL0_NULL_)

/*! @brief Set the NULL_ field to a new value. */
#define BW_HDMI_FC_POL0_NULL_(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_NULL_) | BF_HDMI_FC_POL0_NULL_(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL0, field ACR[1] (RW)
 *
 * Polarity bit for FC_INT0.ACR interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_ACR  (1U)          /*!< Bit position for HDMI_FC_POL0_ACR. */
#define BM_HDMI_FC_POL0_ACR  (0x02U)       /*!< Bit mask for HDMI_FC_POL0_ACR. */
#define BS_HDMI_FC_POL0_ACR  (1U)          /*!< Bit field size in bits for HDMI_FC_POL0_ACR. */

/*! @brief Read current value of the HDMI_FC_POL0_ACR field. */
#define BR_HDMI_FC_POL0_ACR(x) (HW_HDMI_FC_POL0(x).B.ACR)

/*! @brief Format value for bitfield HDMI_FC_POL0_ACR. */
#define BF_HDMI_FC_POL0_ACR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_ACR) & BM_HDMI_FC_POL0_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_HDMI_FC_POL0_ACR(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_ACR) | BF_HDMI_FC_POL0_ACR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL0, field AUDS[2] (RW)
 *
 * Polarity bit for FC_INT0.AUDS interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_AUDS (2U)          /*!< Bit position for HDMI_FC_POL0_AUDS. */
#define BM_HDMI_FC_POL0_AUDS (0x04U)       /*!< Bit mask for HDMI_FC_POL0_AUDS. */
#define BS_HDMI_FC_POL0_AUDS (1U)          /*!< Bit field size in bits for HDMI_FC_POL0_AUDS. */

/*! @brief Read current value of the HDMI_FC_POL0_AUDS field. */
#define BR_HDMI_FC_POL0_AUDS(x) (HW_HDMI_FC_POL0(x).B.AUDS)

/*! @brief Format value for bitfield HDMI_FC_POL0_AUDS. */
#define BF_HDMI_FC_POL0_AUDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_AUDS) & BM_HDMI_FC_POL0_AUDS)

/*! @brief Set the AUDS field to a new value. */
#define BW_HDMI_FC_POL0_AUDS(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_AUDS) | BF_HDMI_FC_POL0_AUDS(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL0, field HBR[5] (RW)
 *
 * Polarity bit for FC_INT0.HBR interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_HBR  (5U)          /*!< Bit position for HDMI_FC_POL0_HBR. */
#define BM_HDMI_FC_POL0_HBR  (0x20U)       /*!< Bit mask for HDMI_FC_POL0_HBR. */
#define BS_HDMI_FC_POL0_HBR  (1U)          /*!< Bit field size in bits for HDMI_FC_POL0_HBR. */

/*! @brief Read current value of the HDMI_FC_POL0_HBR field. */
#define BR_HDMI_FC_POL0_HBR(x) (HW_HDMI_FC_POL0(x).B.HBR)

/*! @brief Format value for bitfield HDMI_FC_POL0_HBR. */
#define BF_HDMI_FC_POL0_HBR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_HBR) & BM_HDMI_FC_POL0_HBR)

/*! @brief Set the HBR field to a new value. */
#define BW_HDMI_FC_POL0_HBR(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_HBR) | BF_HDMI_FC_POL0_HBR(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL0, field ACP[6] (RW)
 *
 * Polarity bit for FC_INT0.ACP interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_ACP  (6U)          /*!< Bit position for HDMI_FC_POL0_ACP. */
#define BM_HDMI_FC_POL0_ACP  (0x40U)       /*!< Bit mask for HDMI_FC_POL0_ACP. */
#define BS_HDMI_FC_POL0_ACP  (1U)          /*!< Bit field size in bits for HDMI_FC_POL0_ACP. */

/*! @brief Read current value of the HDMI_FC_POL0_ACP field. */
#define BR_HDMI_FC_POL0_ACP(x) (HW_HDMI_FC_POL0(x).B.ACP)

/*! @brief Format value for bitfield HDMI_FC_POL0_ACP. */
#define BF_HDMI_FC_POL0_ACP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_ACP) & BM_HDMI_FC_POL0_ACP)

/*! @brief Set the ACP field to a new value. */
#define BW_HDMI_FC_POL0_ACP(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_ACP) | BF_HDMI_FC_POL0_ACP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL0, field AUDI[7] (RW)
 *
 * Polarity bit for FC_INT0.AUDI interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_POL0_AUDI (7U)          /*!< Bit position for HDMI_FC_POL0_AUDI. */
#define BM_HDMI_FC_POL0_AUDI (0x80U)       /*!< Bit mask for HDMI_FC_POL0_AUDI. */
#define BS_HDMI_FC_POL0_AUDI (1U)          /*!< Bit field size in bits for HDMI_FC_POL0_AUDI. */

/*! @brief Read current value of the HDMI_FC_POL0_AUDI field. */
#define BR_HDMI_FC_POL0_AUDI(x) (HW_HDMI_FC_POL0(x).B.AUDI)

/*! @brief Format value for bitfield HDMI_FC_POL0_AUDI. */
#define BF_HDMI_FC_POL0_AUDI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL0_AUDI) & BM_HDMI_FC_POL0_AUDI)

/*! @brief Set the AUDI field to a new value. */
#define BW_HDMI_FC_POL0_AUDI(x, v) (HW_HDMI_FC_POL0_WR(x, (HW_HDMI_FC_POL0_RD(x) & ~BM_HDMI_FC_POL0_AUDI) | BF_HDMI_FC_POL0_AUDI(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_STAT1 - FC_STAT1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_STAT1 - FC_STAT1 (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the following active high packet sent status
 * indications: Address Offset: 0x10D4 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_stat1
{
    uint8_t U;
    struct _hw_hdmi_fc_stat1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 1;         /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_fc_stat1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_STAT1 register
 */
/*@{*/
#define HW_HDMI_FC_STAT1_ADDR(x) ((uintptr_t)(x) + 0x10D4U)

#define HW_HDMI_FC_STAT1(x)      (*(__IO hw_hdmi_fc_stat1_t *) HW_HDMI_FC_STAT1_ADDR(x))
#define HW_HDMI_FC_STAT1_RD(x)   (HW_HDMI_FC_STAT1(x).U)
#define HW_HDMI_FC_STAT1_WR(x, v) (HW_HDMI_FC_STAT1(x).U = (v))
#define HW_HDMI_FC_STAT1_SET(x, v) (HW_HDMI_FC_STAT1_WR(x, HW_HDMI_FC_STAT1_RD(x) |  (v)))
#define HW_HDMI_FC_STAT1_CLR(x, v) (HW_HDMI_FC_STAT1_WR(x, HW_HDMI_FC_STAT1_RD(x) & ~(v)))
#define HW_HDMI_FC_STAT1_TOG(x, v) (HW_HDMI_FC_STAT1_WR(x, HW_HDMI_FC_STAT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_STAT1 bitfields
 */

/*!
 * @name Register HDMI_FC_STAT1, field GCP[0] (RW)
 *
 * Status bit Active after successful transmission of an General Content Packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_GCP (0U)          /*!< Bit position for HDMI_FC_STAT1_GCP. */
#define BM_HDMI_FC_STAT1_GCP (0x01U)       /*!< Bit mask for HDMI_FC_STAT1_GCP. */
#define BS_HDMI_FC_STAT1_GCP (1U)          /*!< Bit field size in bits for HDMI_FC_STAT1_GCP. */

/*! @brief Read current value of the HDMI_FC_STAT1_GCP field. */
#define BR_HDMI_FC_STAT1_GCP(x) (HW_HDMI_FC_STAT1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_FC_STAT1_GCP. */
#define BF_HDMI_FC_STAT1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_GCP) & BM_HDMI_FC_STAT1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_FC_STAT1_GCP(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_GCP) | BF_HDMI_FC_STAT1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field AVI[1] (RW)
 *
 * Status bit Active after successful transmission of an AVI infoFrame packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_AVI (1U)          /*!< Bit position for HDMI_FC_STAT1_AVI. */
#define BM_HDMI_FC_STAT1_AVI (0x02U)       /*!< Bit mask for HDMI_FC_STAT1_AVI. */
#define BS_HDMI_FC_STAT1_AVI (1U)          /*!< Bit field size in bits for HDMI_FC_STAT1_AVI. */

/*! @brief Read current value of the HDMI_FC_STAT1_AVI field. */
#define BR_HDMI_FC_STAT1_AVI(x) (HW_HDMI_FC_STAT1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_FC_STAT1_AVI. */
#define BF_HDMI_FC_STAT1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_AVI) & BM_HDMI_FC_STAT1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_FC_STAT1_AVI(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_AVI) | BF_HDMI_FC_STAT1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field SPD[3] (RW)
 *
 * Active after successful transmission of an Source Product Descriptor
 * infoFrame packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_SPD (3U)          /*!< Bit position for HDMI_FC_STAT1_SPD. */
#define BM_HDMI_FC_STAT1_SPD (0x08U)       /*!< Bit mask for HDMI_FC_STAT1_SPD. */
#define BS_HDMI_FC_STAT1_SPD (1U)          /*!< Bit field size in bits for HDMI_FC_STAT1_SPD. */

/*! @brief Read current value of the HDMI_FC_STAT1_SPD field. */
#define BR_HDMI_FC_STAT1_SPD(x) (HW_HDMI_FC_STAT1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_FC_STAT1_SPD. */
#define BF_HDMI_FC_STAT1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_SPD) & BM_HDMI_FC_STAT1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_FC_STAT1_SPD(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_SPD) | BF_HDMI_FC_STAT1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field VSD[4] (RW)
 *
 * Active after successful transmission of an Vendor Specific Data infoFrame
 * packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_VSD (4U)          /*!< Bit position for HDMI_FC_STAT1_VSD. */
#define BM_HDMI_FC_STAT1_VSD (0x10U)       /*!< Bit mask for HDMI_FC_STAT1_VSD. */
#define BS_HDMI_FC_STAT1_VSD (1U)          /*!< Bit field size in bits for HDMI_FC_STAT1_VSD. */

/*! @brief Read current value of the HDMI_FC_STAT1_VSD field. */
#define BR_HDMI_FC_STAT1_VSD(x) (HW_HDMI_FC_STAT1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_FC_STAT1_VSD. */
#define BF_HDMI_FC_STAT1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_VSD) & BM_HDMI_FC_STAT1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_FC_STAT1_VSD(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_VSD) | BF_HDMI_FC_STAT1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field ISCR2[5] (RW)
 *
 * Active after successful transmission of an International Standard Recording
 * Code 2 packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_ISCR2 (5U)        /*!< Bit position for HDMI_FC_STAT1_ISCR2. */
#define BM_HDMI_FC_STAT1_ISCR2 (0x20U)     /*!< Bit mask for HDMI_FC_STAT1_ISCR2. */
#define BS_HDMI_FC_STAT1_ISCR2 (1U)        /*!< Bit field size in bits for HDMI_FC_STAT1_ISCR2. */

/*! @brief Read current value of the HDMI_FC_STAT1_ISCR2 field. */
#define BR_HDMI_FC_STAT1_ISCR2(x) (HW_HDMI_FC_STAT1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_FC_STAT1_ISCR2. */
#define BF_HDMI_FC_STAT1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_ISCR2) & BM_HDMI_FC_STAT1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_FC_STAT1_ISCR2(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_ISCR2) | BF_HDMI_FC_STAT1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field ISCR1[6] (RW)
 *
 * Status bit Active after successful transmission of an International Standard
 * Recording Code 1 packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_ISCR1 (6U)        /*!< Bit position for HDMI_FC_STAT1_ISCR1. */
#define BM_HDMI_FC_STAT1_ISCR1 (0x40U)     /*!< Bit mask for HDMI_FC_STAT1_ISCR1. */
#define BS_HDMI_FC_STAT1_ISCR1 (1U)        /*!< Bit field size in bits for HDMI_FC_STAT1_ISCR1. */

/*! @brief Read current value of the HDMI_FC_STAT1_ISCR1 field. */
#define BR_HDMI_FC_STAT1_ISCR1(x) (HW_HDMI_FC_STAT1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_FC_STAT1_ISCR1. */
#define BF_HDMI_FC_STAT1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_ISCR1) & BM_HDMI_FC_STAT1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_FC_STAT1_ISCR1(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_ISCR1) | BF_HDMI_FC_STAT1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT1, field GMD[7] (RW)
 *
 * Status bit Active after successful transmission of an Gamut metadata packet.
 */
/*@{*/
#define BP_HDMI_FC_STAT1_GMD (7U)          /*!< Bit position for HDMI_FC_STAT1_GMD. */
#define BM_HDMI_FC_STAT1_GMD (0x80U)       /*!< Bit mask for HDMI_FC_STAT1_GMD. */
#define BS_HDMI_FC_STAT1_GMD (1U)          /*!< Bit field size in bits for HDMI_FC_STAT1_GMD. */

/*! @brief Read current value of the HDMI_FC_STAT1_GMD field. */
#define BR_HDMI_FC_STAT1_GMD(x) (HW_HDMI_FC_STAT1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_FC_STAT1_GMD. */
#define BF_HDMI_FC_STAT1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT1_GMD) & BM_HDMI_FC_STAT1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_FC_STAT1_GMD(x, v) (HW_HDMI_FC_STAT1_WR(x, (HW_HDMI_FC_STAT1_RD(x) & ~BM_HDMI_FC_STAT1_GMD) | BF_HDMI_FC_STAT1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INT1 - FC_INT1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INT1 - FC_INT1 (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt indication of the FC_STAT1 status
 * interrupts. Interrupt generation is accomplished in the following way: interrupt =
 * (mask == 1'b0) && (polarity == status); All this interrupts are forwarded to
 * the Interrupt Handler sticky bit registers and after ORed to a single main
 * interrupt line to micro controller. Assertion of this interrupt implies that data
 * related with the corresponding packet has been sent through the HDMI interface.
 * Address Offset: 0x10D5 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_int1
{
    uint8_t U;
    struct _hw_hdmi_fc_int1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 1;         /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_fc_int1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INT1 register
 */
/*@{*/
#define HW_HDMI_FC_INT1_ADDR(x)  ((uintptr_t)(x) + 0x10D5U)

#define HW_HDMI_FC_INT1(x)       (*(__IO hw_hdmi_fc_int1_t *) HW_HDMI_FC_INT1_ADDR(x))
#define HW_HDMI_FC_INT1_RD(x)    (HW_HDMI_FC_INT1(x).U)
#define HW_HDMI_FC_INT1_WR(x, v) (HW_HDMI_FC_INT1(x).U = (v))
#define HW_HDMI_FC_INT1_SET(x, v) (HW_HDMI_FC_INT1_WR(x, HW_HDMI_FC_INT1_RD(x) |  (v)))
#define HW_HDMI_FC_INT1_CLR(x, v) (HW_HDMI_FC_INT1_WR(x, HW_HDMI_FC_INT1_RD(x) & ~(v)))
#define HW_HDMI_FC_INT1_TOG(x, v) (HW_HDMI_FC_INT1_WR(x, HW_HDMI_FC_INT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INT1 bitfields
 */

/*!
 * @name Register HDMI_FC_INT1, field GCP[0] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an General
 * Content Packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_GCP  (0U)          /*!< Bit position for HDMI_FC_INT1_GCP. */
#define BM_HDMI_FC_INT1_GCP  (0x01U)       /*!< Bit mask for HDMI_FC_INT1_GCP. */
#define BS_HDMI_FC_INT1_GCP  (1U)          /*!< Bit field size in bits for HDMI_FC_INT1_GCP. */

/*! @brief Read current value of the HDMI_FC_INT1_GCP field. */
#define BR_HDMI_FC_INT1_GCP(x) (HW_HDMI_FC_INT1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_FC_INT1_GCP. */
#define BF_HDMI_FC_INT1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_GCP) & BM_HDMI_FC_INT1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_FC_INT1_GCP(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_GCP) | BF_HDMI_FC_INT1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field AVI[1] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an AVI
 * infoFrame packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_AVI  (1U)          /*!< Bit position for HDMI_FC_INT1_AVI. */
#define BM_HDMI_FC_INT1_AVI  (0x02U)       /*!< Bit mask for HDMI_FC_INT1_AVI. */
#define BS_HDMI_FC_INT1_AVI  (1U)          /*!< Bit field size in bits for HDMI_FC_INT1_AVI. */

/*! @brief Read current value of the HDMI_FC_INT1_AVI field. */
#define BR_HDMI_FC_INT1_AVI(x) (HW_HDMI_FC_INT1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_FC_INT1_AVI. */
#define BF_HDMI_FC_INT1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_AVI) & BM_HDMI_FC_INT1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_FC_INT1_AVI(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_AVI) | BF_HDMI_FC_INT1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field SPD[3] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Source
 * Product Descriptor infoFrame packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_SPD  (3U)          /*!< Bit position for HDMI_FC_INT1_SPD. */
#define BM_HDMI_FC_INT1_SPD  (0x08U)       /*!< Bit mask for HDMI_FC_INT1_SPD. */
#define BS_HDMI_FC_INT1_SPD  (1U)          /*!< Bit field size in bits for HDMI_FC_INT1_SPD. */

/*! @brief Read current value of the HDMI_FC_INT1_SPD field. */
#define BR_HDMI_FC_INT1_SPD(x) (HW_HDMI_FC_INT1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_FC_INT1_SPD. */
#define BF_HDMI_FC_INT1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_SPD) & BM_HDMI_FC_INT1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_FC_INT1_SPD(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_SPD) | BF_HDMI_FC_INT1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field VSD[4] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Vendor
 * Specific Data infoFrame packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_VSD  (4U)          /*!< Bit position for HDMI_FC_INT1_VSD. */
#define BM_HDMI_FC_INT1_VSD  (0x10U)       /*!< Bit mask for HDMI_FC_INT1_VSD. */
#define BS_HDMI_FC_INT1_VSD  (1U)          /*!< Bit field size in bits for HDMI_FC_INT1_VSD. */

/*! @brief Read current value of the HDMI_FC_INT1_VSD field. */
#define BR_HDMI_FC_INT1_VSD(x) (HW_HDMI_FC_INT1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_FC_INT1_VSD. */
#define BF_HDMI_FC_INT1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_VSD) & BM_HDMI_FC_INT1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_FC_INT1_VSD(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_VSD) | BF_HDMI_FC_INT1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field ISCR2[5] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an
 * International Standard Recording Code 2 packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_ISCR2 (5U)         /*!< Bit position for HDMI_FC_INT1_ISCR2. */
#define BM_HDMI_FC_INT1_ISCR2 (0x20U)      /*!< Bit mask for HDMI_FC_INT1_ISCR2. */
#define BS_HDMI_FC_INT1_ISCR2 (1U)         /*!< Bit field size in bits for HDMI_FC_INT1_ISCR2. */

/*! @brief Read current value of the HDMI_FC_INT1_ISCR2 field. */
#define BR_HDMI_FC_INT1_ISCR2(x) (HW_HDMI_FC_INT1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_FC_INT1_ISCR2. */
#define BF_HDMI_FC_INT1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_ISCR2) & BM_HDMI_FC_INT1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_FC_INT1_ISCR2(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_ISCR2) | BF_HDMI_FC_INT1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field ISCR1[6] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an
 * International Standard Recording Code 1 packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_ISCR1 (6U)         /*!< Bit position for HDMI_FC_INT1_ISCR1. */
#define BM_HDMI_FC_INT1_ISCR1 (0x40U)      /*!< Bit mask for HDMI_FC_INT1_ISCR1. */
#define BS_HDMI_FC_INT1_ISCR1 (1U)         /*!< Bit field size in bits for HDMI_FC_INT1_ISCR1. */

/*! @brief Read current value of the HDMI_FC_INT1_ISCR1 field. */
#define BR_HDMI_FC_INT1_ISCR1(x) (HW_HDMI_FC_INT1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_FC_INT1_ISCR1. */
#define BF_HDMI_FC_INT1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_ISCR1) & BM_HDMI_FC_INT1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_FC_INT1_ISCR1(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_ISCR1) | BF_HDMI_FC_INT1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT1, field GMD[7] (RW)
 *
 * Interrupt indication bit Active after successful transmission of an Gamut
 * metadata packet interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT1_GMD  (7U)          /*!< Bit position for HDMI_FC_INT1_GMD. */
#define BM_HDMI_FC_INT1_GMD  (0x80U)       /*!< Bit mask for HDMI_FC_INT1_GMD. */
#define BS_HDMI_FC_INT1_GMD  (1U)          /*!< Bit field size in bits for HDMI_FC_INT1_GMD. */

/*! @brief Read current value of the HDMI_FC_INT1_GMD field. */
#define BR_HDMI_FC_INT1_GMD(x) (HW_HDMI_FC_INT1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_FC_INT1_GMD. */
#define BF_HDMI_FC_INT1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT1_GMD) & BM_HDMI_FC_INT1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_FC_INT1_GMD(x, v) (HW_HDMI_FC_INT1_WR(x, (HW_HDMI_FC_INT1_RD(x) & ~BM_HDMI_FC_INT1_GMD) | BF_HDMI_FC_INT1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_MASK1 - Frame Composer Packet Interrupt Mask Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_MASK1 - Frame Composer Packet Interrupt Mask Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Mask register for generation of FC_INT1 interrupts. Address Offset: 0x10D6
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_mask1
{
    uint8_t U;
    struct _hw_hdmi_fc_mask1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 1;         /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_fc_mask1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_MASK1 register
 */
/*@{*/
#define HW_HDMI_FC_MASK1_ADDR(x) ((uintptr_t)(x) + 0x10D6U)

#define HW_HDMI_FC_MASK1(x)      (*(__IO hw_hdmi_fc_mask1_t *) HW_HDMI_FC_MASK1_ADDR(x))
#define HW_HDMI_FC_MASK1_RD(x)   (HW_HDMI_FC_MASK1(x).U)
#define HW_HDMI_FC_MASK1_WR(x, v) (HW_HDMI_FC_MASK1(x).U = (v))
#define HW_HDMI_FC_MASK1_SET(x, v) (HW_HDMI_FC_MASK1_WR(x, HW_HDMI_FC_MASK1_RD(x) |  (v)))
#define HW_HDMI_FC_MASK1_CLR(x, v) (HW_HDMI_FC_MASK1_WR(x, HW_HDMI_FC_MASK1_RD(x) & ~(v)))
#define HW_HDMI_FC_MASK1_TOG(x, v) (HW_HDMI_FC_MASK1_WR(x, HW_HDMI_FC_MASK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_MASK1 bitfields
 */

/*!
 * @name Register HDMI_FC_MASK1, field GCP[0] (RW)
 *
 * Mask bit for FC_INT1.GCP interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_GCP (0U)          /*!< Bit position for HDMI_FC_MASK1_GCP. */
#define BM_HDMI_FC_MASK1_GCP (0x01U)       /*!< Bit mask for HDMI_FC_MASK1_GCP. */
#define BS_HDMI_FC_MASK1_GCP (1U)          /*!< Bit field size in bits for HDMI_FC_MASK1_GCP. */

/*! @brief Read current value of the HDMI_FC_MASK1_GCP field. */
#define BR_HDMI_FC_MASK1_GCP(x) (HW_HDMI_FC_MASK1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_FC_MASK1_GCP. */
#define BF_HDMI_FC_MASK1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_GCP) & BM_HDMI_FC_MASK1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_FC_MASK1_GCP(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_GCP) | BF_HDMI_FC_MASK1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field AVI[1] (RW)
 *
 * Mask bit for FC_INT1.AVI interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_AVI (1U)          /*!< Bit position for HDMI_FC_MASK1_AVI. */
#define BM_HDMI_FC_MASK1_AVI (0x02U)       /*!< Bit mask for HDMI_FC_MASK1_AVI. */
#define BS_HDMI_FC_MASK1_AVI (1U)          /*!< Bit field size in bits for HDMI_FC_MASK1_AVI. */

/*! @brief Read current value of the HDMI_FC_MASK1_AVI field. */
#define BR_HDMI_FC_MASK1_AVI(x) (HW_HDMI_FC_MASK1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_FC_MASK1_AVI. */
#define BF_HDMI_FC_MASK1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_AVI) & BM_HDMI_FC_MASK1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_FC_MASK1_AVI(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_AVI) | BF_HDMI_FC_MASK1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field SPD[3] (RW)
 *
 * Mask bit for FC_INT1.SPD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_SPD (3U)          /*!< Bit position for HDMI_FC_MASK1_SPD. */
#define BM_HDMI_FC_MASK1_SPD (0x08U)       /*!< Bit mask for HDMI_FC_MASK1_SPD. */
#define BS_HDMI_FC_MASK1_SPD (1U)          /*!< Bit field size in bits for HDMI_FC_MASK1_SPD. */

/*! @brief Read current value of the HDMI_FC_MASK1_SPD field. */
#define BR_HDMI_FC_MASK1_SPD(x) (HW_HDMI_FC_MASK1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_FC_MASK1_SPD. */
#define BF_HDMI_FC_MASK1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_SPD) & BM_HDMI_FC_MASK1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_FC_MASK1_SPD(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_SPD) | BF_HDMI_FC_MASK1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field VSD[4] (RW)
 *
 * Mask bit for FC_INT1.VSD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_VSD (4U)          /*!< Bit position for HDMI_FC_MASK1_VSD. */
#define BM_HDMI_FC_MASK1_VSD (0x10U)       /*!< Bit mask for HDMI_FC_MASK1_VSD. */
#define BS_HDMI_FC_MASK1_VSD (1U)          /*!< Bit field size in bits for HDMI_FC_MASK1_VSD. */

/*! @brief Read current value of the HDMI_FC_MASK1_VSD field. */
#define BR_HDMI_FC_MASK1_VSD(x) (HW_HDMI_FC_MASK1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_FC_MASK1_VSD. */
#define BF_HDMI_FC_MASK1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_VSD) & BM_HDMI_FC_MASK1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_FC_MASK1_VSD(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_VSD) | BF_HDMI_FC_MASK1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field ISCR2[5] (RW)
 *
 * Mask bit for FC_INT1.ISRC2 interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_ISCR2 (5U)        /*!< Bit position for HDMI_FC_MASK1_ISCR2. */
#define BM_HDMI_FC_MASK1_ISCR2 (0x20U)     /*!< Bit mask for HDMI_FC_MASK1_ISCR2. */
#define BS_HDMI_FC_MASK1_ISCR2 (1U)        /*!< Bit field size in bits for HDMI_FC_MASK1_ISCR2. */

/*! @brief Read current value of the HDMI_FC_MASK1_ISCR2 field. */
#define BR_HDMI_FC_MASK1_ISCR2(x) (HW_HDMI_FC_MASK1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_FC_MASK1_ISCR2. */
#define BF_HDMI_FC_MASK1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_ISCR2) & BM_HDMI_FC_MASK1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_FC_MASK1_ISCR2(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_ISCR2) | BF_HDMI_FC_MASK1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field ISCR1[6] (RW)
 *
 * Mask bit for FC_INT1.ISRC1 interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_ISCR1 (6U)        /*!< Bit position for HDMI_FC_MASK1_ISCR1. */
#define BM_HDMI_FC_MASK1_ISCR1 (0x40U)     /*!< Bit mask for HDMI_FC_MASK1_ISCR1. */
#define BS_HDMI_FC_MASK1_ISCR1 (1U)        /*!< Bit field size in bits for HDMI_FC_MASK1_ISCR1. */

/*! @brief Read current value of the HDMI_FC_MASK1_ISCR1 field. */
#define BR_HDMI_FC_MASK1_ISCR1(x) (HW_HDMI_FC_MASK1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_FC_MASK1_ISCR1. */
#define BF_HDMI_FC_MASK1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_ISCR1) & BM_HDMI_FC_MASK1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_FC_MASK1_ISCR1(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_ISCR1) | BF_HDMI_FC_MASK1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK1, field GMD[7] (RW)
 *
 * Mask bit for FC_INT1.GMD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_MASK1_GMD (7U)          /*!< Bit position for HDMI_FC_MASK1_GMD. */
#define BM_HDMI_FC_MASK1_GMD (0x80U)       /*!< Bit mask for HDMI_FC_MASK1_GMD. */
#define BS_HDMI_FC_MASK1_GMD (1U)          /*!< Bit field size in bits for HDMI_FC_MASK1_GMD. */

/*! @brief Read current value of the HDMI_FC_MASK1_GMD field. */
#define BR_HDMI_FC_MASK1_GMD(x) (HW_HDMI_FC_MASK1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_FC_MASK1_GMD. */
#define BF_HDMI_FC_MASK1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK1_GMD) & BM_HDMI_FC_MASK1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_FC_MASK1_GMD(x, v) (HW_HDMI_FC_MASK1_WR(x, (HW_HDMI_FC_MASK1_RD(x) & ~BM_HDMI_FC_MASK1_GMD) | BF_HDMI_FC_MASK1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_POL1 - FC_POL1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_POL1 - FC_POL1 (RW)
 *
 * Reset value: 0xFFU
 *
 * Polarity register for generation of FC_INT1 interrupts. Address Offset:
 * 0x10D7 Size: 8 bits Value after Reset: 0xFF Access: Read/Write
 */
typedef union _hw_hdmi_fc_pol1
{
    uint8_t U;
    struct _hw_hdmi_fc_pol1_bitfields
    {
        uint8_t GCP : 1;               /*!< [0]  */
        uint8_t AVI : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 1;         /*!< [2]  */
        uint8_t SPD : 1;               /*!< [3]  */
        uint8_t VSD : 1;               /*!< [4]  */
        uint8_t ISCR2 : 1;             /*!< [5]  */
        uint8_t ISCR1 : 1;             /*!< [6]  */
        uint8_t GMD : 1;               /*!< [7]  */
    } B;
} hw_hdmi_fc_pol1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_POL1 register
 */
/*@{*/
#define HW_HDMI_FC_POL1_ADDR(x)  ((uintptr_t)(x) + 0x10D7U)

#define HW_HDMI_FC_POL1(x)       (*(__IO hw_hdmi_fc_pol1_t *) HW_HDMI_FC_POL1_ADDR(x))
#define HW_HDMI_FC_POL1_RD(x)    (HW_HDMI_FC_POL1(x).U)
#define HW_HDMI_FC_POL1_WR(x, v) (HW_HDMI_FC_POL1(x).U = (v))
#define HW_HDMI_FC_POL1_SET(x, v) (HW_HDMI_FC_POL1_WR(x, HW_HDMI_FC_POL1_RD(x) |  (v)))
#define HW_HDMI_FC_POL1_CLR(x, v) (HW_HDMI_FC_POL1_WR(x, HW_HDMI_FC_POL1_RD(x) & ~(v)))
#define HW_HDMI_FC_POL1_TOG(x, v) (HW_HDMI_FC_POL1_WR(x, HW_HDMI_FC_POL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_POL1 bitfields
 */

/*!
 * @name Register HDMI_FC_POL1, field GCP[0] (RW)
 *
 * Polarity bit for FC_INT1.GCP interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_GCP  (0U)          /*!< Bit position for HDMI_FC_POL1_GCP. */
#define BM_HDMI_FC_POL1_GCP  (0x01U)       /*!< Bit mask for HDMI_FC_POL1_GCP. */
#define BS_HDMI_FC_POL1_GCP  (1U)          /*!< Bit field size in bits for HDMI_FC_POL1_GCP. */

/*! @brief Read current value of the HDMI_FC_POL1_GCP field. */
#define BR_HDMI_FC_POL1_GCP(x) (HW_HDMI_FC_POL1(x).B.GCP)

/*! @brief Format value for bitfield HDMI_FC_POL1_GCP. */
#define BF_HDMI_FC_POL1_GCP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_GCP) & BM_HDMI_FC_POL1_GCP)

/*! @brief Set the GCP field to a new value. */
#define BW_HDMI_FC_POL1_GCP(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_GCP) | BF_HDMI_FC_POL1_GCP(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field AVI[1] (RW)
 *
 * Polarity bit for FC_INT1.AVI interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_AVI  (1U)          /*!< Bit position for HDMI_FC_POL1_AVI. */
#define BM_HDMI_FC_POL1_AVI  (0x02U)       /*!< Bit mask for HDMI_FC_POL1_AVI. */
#define BS_HDMI_FC_POL1_AVI  (1U)          /*!< Bit field size in bits for HDMI_FC_POL1_AVI. */

/*! @brief Read current value of the HDMI_FC_POL1_AVI field. */
#define BR_HDMI_FC_POL1_AVI(x) (HW_HDMI_FC_POL1(x).B.AVI)

/*! @brief Format value for bitfield HDMI_FC_POL1_AVI. */
#define BF_HDMI_FC_POL1_AVI(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_AVI) & BM_HDMI_FC_POL1_AVI)

/*! @brief Set the AVI field to a new value. */
#define BW_HDMI_FC_POL1_AVI(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_AVI) | BF_HDMI_FC_POL1_AVI(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field SPD[3] (RW)
 *
 * Polarity bit for FC_INT1.SPD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_SPD  (3U)          /*!< Bit position for HDMI_FC_POL1_SPD. */
#define BM_HDMI_FC_POL1_SPD  (0x08U)       /*!< Bit mask for HDMI_FC_POL1_SPD. */
#define BS_HDMI_FC_POL1_SPD  (1U)          /*!< Bit field size in bits for HDMI_FC_POL1_SPD. */

/*! @brief Read current value of the HDMI_FC_POL1_SPD field. */
#define BR_HDMI_FC_POL1_SPD(x) (HW_HDMI_FC_POL1(x).B.SPD)

/*! @brief Format value for bitfield HDMI_FC_POL1_SPD. */
#define BF_HDMI_FC_POL1_SPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_SPD) & BM_HDMI_FC_POL1_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_HDMI_FC_POL1_SPD(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_SPD) | BF_HDMI_FC_POL1_SPD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field VSD[4] (RW)
 *
 * Polarity bit for FC_INT1.VSD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_VSD  (4U)          /*!< Bit position for HDMI_FC_POL1_VSD. */
#define BM_HDMI_FC_POL1_VSD  (0x10U)       /*!< Bit mask for HDMI_FC_POL1_VSD. */
#define BS_HDMI_FC_POL1_VSD  (1U)          /*!< Bit field size in bits for HDMI_FC_POL1_VSD. */

/*! @brief Read current value of the HDMI_FC_POL1_VSD field. */
#define BR_HDMI_FC_POL1_VSD(x) (HW_HDMI_FC_POL1(x).B.VSD)

/*! @brief Format value for bitfield HDMI_FC_POL1_VSD. */
#define BF_HDMI_FC_POL1_VSD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_VSD) & BM_HDMI_FC_POL1_VSD)

/*! @brief Set the VSD field to a new value. */
#define BW_HDMI_FC_POL1_VSD(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_VSD) | BF_HDMI_FC_POL1_VSD(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field ISCR2[5] (RW)
 *
 * Polarity bit for FC_INT1.ISRC2 interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_ISCR2 (5U)         /*!< Bit position for HDMI_FC_POL1_ISCR2. */
#define BM_HDMI_FC_POL1_ISCR2 (0x20U)      /*!< Bit mask for HDMI_FC_POL1_ISCR2. */
#define BS_HDMI_FC_POL1_ISCR2 (1U)         /*!< Bit field size in bits for HDMI_FC_POL1_ISCR2. */

/*! @brief Read current value of the HDMI_FC_POL1_ISCR2 field. */
#define BR_HDMI_FC_POL1_ISCR2(x) (HW_HDMI_FC_POL1(x).B.ISCR2)

/*! @brief Format value for bitfield HDMI_FC_POL1_ISCR2. */
#define BF_HDMI_FC_POL1_ISCR2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_ISCR2) & BM_HDMI_FC_POL1_ISCR2)

/*! @brief Set the ISCR2 field to a new value. */
#define BW_HDMI_FC_POL1_ISCR2(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_ISCR2) | BF_HDMI_FC_POL1_ISCR2(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field ISCR1[6] (RW)
 *
 * Polarity bit for FC_INT1.ISRC1 interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_ISCR1 (6U)         /*!< Bit position for HDMI_FC_POL1_ISCR1. */
#define BM_HDMI_FC_POL1_ISCR1 (0x40U)      /*!< Bit mask for HDMI_FC_POL1_ISCR1. */
#define BS_HDMI_FC_POL1_ISCR1 (1U)         /*!< Bit field size in bits for HDMI_FC_POL1_ISCR1. */

/*! @brief Read current value of the HDMI_FC_POL1_ISCR1 field. */
#define BR_HDMI_FC_POL1_ISCR1(x) (HW_HDMI_FC_POL1(x).B.ISCR1)

/*! @brief Format value for bitfield HDMI_FC_POL1_ISCR1. */
#define BF_HDMI_FC_POL1_ISCR1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_ISCR1) & BM_HDMI_FC_POL1_ISCR1)

/*! @brief Set the ISCR1 field to a new value. */
#define BW_HDMI_FC_POL1_ISCR1(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_ISCR1) | BF_HDMI_FC_POL1_ISCR1(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL1, field GMD[7] (RW)
 *
 * Polarity bit for FC_INT1.GMD interrupt bit
 */
/*@{*/
#define BP_HDMI_FC_POL1_GMD  (7U)          /*!< Bit position for HDMI_FC_POL1_GMD. */
#define BM_HDMI_FC_POL1_GMD  (0x80U)       /*!< Bit mask for HDMI_FC_POL1_GMD. */
#define BS_HDMI_FC_POL1_GMD  (1U)          /*!< Bit field size in bits for HDMI_FC_POL1_GMD. */

/*! @brief Read current value of the HDMI_FC_POL1_GMD field. */
#define BR_HDMI_FC_POL1_GMD(x) (HW_HDMI_FC_POL1(x).B.GMD)

/*! @brief Format value for bitfield HDMI_FC_POL1_GMD. */
#define BF_HDMI_FC_POL1_GMD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL1_GMD) & BM_HDMI_FC_POL1_GMD)

/*! @brief Set the GMD field to a new value. */
#define BW_HDMI_FC_POL1_GMD(x, v) (HW_HDMI_FC_POL1_WR(x, (HW_HDMI_FC_POL1_RD(x) & ~BM_HDMI_FC_POL1_GMD) | BF_HDMI_FC_POL1_GMD(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_STAT2 - FC_STAT2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_STAT2 - FC_STAT2 (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the following active high packet sent status
 * indications: Address Offset: 0x10D8 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_stat2
{
    uint8_t U;
    struct _hw_hdmi_fc_stat2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_fc_stat2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_STAT2 register
 */
/*@{*/
#define HW_HDMI_FC_STAT2_ADDR(x) ((uintptr_t)(x) + 0x10D8U)

#define HW_HDMI_FC_STAT2(x)      (*(__IO hw_hdmi_fc_stat2_t *) HW_HDMI_FC_STAT2_ADDR(x))
#define HW_HDMI_FC_STAT2_RD(x)   (HW_HDMI_FC_STAT2(x).U)
#define HW_HDMI_FC_STAT2_WR(x, v) (HW_HDMI_FC_STAT2(x).U = (v))
#define HW_HDMI_FC_STAT2_SET(x, v) (HW_HDMI_FC_STAT2_WR(x, HW_HDMI_FC_STAT2_RD(x) |  (v)))
#define HW_HDMI_FC_STAT2_CLR(x, v) (HW_HDMI_FC_STAT2_WR(x, HW_HDMI_FC_STAT2_RD(x) & ~(v)))
#define HW_HDMI_FC_STAT2_TOG(x, v) (HW_HDMI_FC_STAT2_WR(x, HW_HDMI_FC_STAT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_STAT2 bitfields
 */

/*!
 * @name Register HDMI_FC_STAT2, field HighPriority_overflow[0] (RW)
 *
 * Status bit Frame Composer high priority packet queue descriptor overflow
 * indication.
 */
/*@{*/
#define BP_HDMI_FC_STAT2_HighPriority_overflow (0U) /*!< Bit position for HDMI_FC_STAT2_HighPriority_overflow. */
#define BM_HDMI_FC_STAT2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_FC_STAT2_HighPriority_overflow. */
#define BS_HDMI_FC_STAT2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_STAT2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_STAT2_HighPriority_overflow field. */
#define BR_HDMI_FC_STAT2_HighPriority_overflow(x) (HW_HDMI_FC_STAT2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_STAT2_HighPriority_overflow. */
#define BF_HDMI_FC_STAT2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT2_HighPriority_overflow) & BM_HDMI_FC_STAT2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_FC_STAT2_HighPriority_overflow(x, v) (HW_HDMI_FC_STAT2_WR(x, (HW_HDMI_FC_STAT2_RD(x) & ~BM_HDMI_FC_STAT2_HighPriority_overflow) | BF_HDMI_FC_STAT2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_STAT2, field LowPriority_overflow[1] (RW)
 *
 * Status bit Frame Composer low priority packet queue descriptor overflow
 * indication.
 */
/*@{*/
#define BP_HDMI_FC_STAT2_LowPriority_overflow (1U) /*!< Bit position for HDMI_FC_STAT2_LowPriority_overflow. */
#define BM_HDMI_FC_STAT2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_FC_STAT2_LowPriority_overflow. */
#define BS_HDMI_FC_STAT2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_STAT2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_STAT2_LowPriority_overflow field. */
#define BR_HDMI_FC_STAT2_LowPriority_overflow(x) (HW_HDMI_FC_STAT2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_STAT2_LowPriority_overflow. */
#define BF_HDMI_FC_STAT2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_STAT2_LowPriority_overflow) & BM_HDMI_FC_STAT2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_FC_STAT2_LowPriority_overflow(x, v) (HW_HDMI_FC_STAT2_WR(x, (HW_HDMI_FC_STAT2_RD(x) & ~BM_HDMI_FC_STAT2_LowPriority_overflow) | BF_HDMI_FC_STAT2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_INT2 - FC_INT2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_INT2 - FC_INT2 (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt indication of the FC_STAT2 status
 * interrupts. Interrupt generation is accomplished in the following way: interrupt =
 * (mask == 1'b0) && (polarity == status); All this interrupts are forwarded to
 * the Interrupt Handler sticky bit registers and after ORed to a single main
 * interrupt line to micro controller. Assertion of this interrupt implies that data
 * related with the corresponding packet has been sent through the HDMI interface.
 * Address Offset: 0x10D9 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_int2
{
    uint8_t U;
    struct _hw_hdmi_fc_int2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_fc_int2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_INT2 register
 */
/*@{*/
#define HW_HDMI_FC_INT2_ADDR(x)  ((uintptr_t)(x) + 0x10D9U)

#define HW_HDMI_FC_INT2(x)       (*(__IO hw_hdmi_fc_int2_t *) HW_HDMI_FC_INT2_ADDR(x))
#define HW_HDMI_FC_INT2_RD(x)    (HW_HDMI_FC_INT2(x).U)
#define HW_HDMI_FC_INT2_WR(x, v) (HW_HDMI_FC_INT2(x).U = (v))
#define HW_HDMI_FC_INT2_SET(x, v) (HW_HDMI_FC_INT2_WR(x, HW_HDMI_FC_INT2_RD(x) |  (v)))
#define HW_HDMI_FC_INT2_CLR(x, v) (HW_HDMI_FC_INT2_WR(x, HW_HDMI_FC_INT2_RD(x) & ~(v)))
#define HW_HDMI_FC_INT2_TOG(x, v) (HW_HDMI_FC_INT2_WR(x, HW_HDMI_FC_INT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_INT2 bitfields
 */

/*!
 * @name Register HDMI_FC_INT2, field HighPriority_overflow[0] (RW)
 *
 * Interrupt indication bit Frame Composer high priority packet queue descriptor
 * overflow indication interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT2_HighPriority_overflow (0U) /*!< Bit position for HDMI_FC_INT2_HighPriority_overflow. */
#define BM_HDMI_FC_INT2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_FC_INT2_HighPriority_overflow. */
#define BS_HDMI_FC_INT2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_INT2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_INT2_HighPriority_overflow field. */
#define BR_HDMI_FC_INT2_HighPriority_overflow(x) (HW_HDMI_FC_INT2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_INT2_HighPriority_overflow. */
#define BF_HDMI_FC_INT2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT2_HighPriority_overflow) & BM_HDMI_FC_INT2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_FC_INT2_HighPriority_overflow(x, v) (HW_HDMI_FC_INT2_WR(x, (HW_HDMI_FC_INT2_RD(x) & ~BM_HDMI_FC_INT2_HighPriority_overflow) | BF_HDMI_FC_INT2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_INT2, field LowPriority_overflow[1] (RW)
 *
 * Interrupt indication bit Frame Composer low priority packet queue descriptor
 * overflow indication interrupt.
 */
/*@{*/
#define BP_HDMI_FC_INT2_LowPriority_overflow (1U) /*!< Bit position for HDMI_FC_INT2_LowPriority_overflow. */
#define BM_HDMI_FC_INT2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_FC_INT2_LowPriority_overflow. */
#define BS_HDMI_FC_INT2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_INT2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_INT2_LowPriority_overflow field. */
#define BR_HDMI_FC_INT2_LowPriority_overflow(x) (HW_HDMI_FC_INT2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_INT2_LowPriority_overflow. */
#define BF_HDMI_FC_INT2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_INT2_LowPriority_overflow) & BM_HDMI_FC_INT2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_FC_INT2_LowPriority_overflow(x, v) (HW_HDMI_FC_INT2_WR(x, (HW_HDMI_FC_INT2_RD(x) & ~BM_HDMI_FC_INT2_LowPriority_overflow) | BF_HDMI_FC_INT2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_MASK2 - Frame Composer High/Low Priority Overflow Interrupt Mask Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_MASK2 - Frame Composer High/Low Priority Overflow Interrupt Mask Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Mask register for generation of FC_INT2 interrupts. Address Offset: 0x10DA
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_mask2
{
    uint8_t U;
    struct _hw_hdmi_fc_mask2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_fc_mask2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_MASK2 register
 */
/*@{*/
#define HW_HDMI_FC_MASK2_ADDR(x) ((uintptr_t)(x) + 0x10DAU)

#define HW_HDMI_FC_MASK2(x)      (*(__IO hw_hdmi_fc_mask2_t *) HW_HDMI_FC_MASK2_ADDR(x))
#define HW_HDMI_FC_MASK2_RD(x)   (HW_HDMI_FC_MASK2(x).U)
#define HW_HDMI_FC_MASK2_WR(x, v) (HW_HDMI_FC_MASK2(x).U = (v))
#define HW_HDMI_FC_MASK2_SET(x, v) (HW_HDMI_FC_MASK2_WR(x, HW_HDMI_FC_MASK2_RD(x) |  (v)))
#define HW_HDMI_FC_MASK2_CLR(x, v) (HW_HDMI_FC_MASK2_WR(x, HW_HDMI_FC_MASK2_RD(x) & ~(v)))
#define HW_HDMI_FC_MASK2_TOG(x, v) (HW_HDMI_FC_MASK2_WR(x, HW_HDMI_FC_MASK2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_MASK2 bitfields
 */

/*!
 * @name Register HDMI_FC_MASK2, field HighPriority_overflow[0] (RW)
 *
 * Mask bit for FC_INT1.HighPriority_overflow interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK2_HighPriority_overflow (0U) /*!< Bit position for HDMI_FC_MASK2_HighPriority_overflow. */
#define BM_HDMI_FC_MASK2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_FC_MASK2_HighPriority_overflow. */
#define BS_HDMI_FC_MASK2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_MASK2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_MASK2_HighPriority_overflow field. */
#define BR_HDMI_FC_MASK2_HighPriority_overflow(x) (HW_HDMI_FC_MASK2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_MASK2_HighPriority_overflow. */
#define BF_HDMI_FC_MASK2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK2_HighPriority_overflow) & BM_HDMI_FC_MASK2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_FC_MASK2_HighPriority_overflow(x, v) (HW_HDMI_FC_MASK2_WR(x, (HW_HDMI_FC_MASK2_RD(x) & ~BM_HDMI_FC_MASK2_HighPriority_overflow) | BF_HDMI_FC_MASK2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_MASK2, field LowPriority_overflow[1] (RW)
 *
 * Mask bit for FC_INT1.LowPriority_overflow interrupt bit Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_FC_MASK2_LowPriority_overflow (1U) /*!< Bit position for HDMI_FC_MASK2_LowPriority_overflow. */
#define BM_HDMI_FC_MASK2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_FC_MASK2_LowPriority_overflow. */
#define BS_HDMI_FC_MASK2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_MASK2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_MASK2_LowPriority_overflow field. */
#define BR_HDMI_FC_MASK2_LowPriority_overflow(x) (HW_HDMI_FC_MASK2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_MASK2_LowPriority_overflow. */
#define BF_HDMI_FC_MASK2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_MASK2_LowPriority_overflow) & BM_HDMI_FC_MASK2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_FC_MASK2_LowPriority_overflow(x, v) (HW_HDMI_FC_MASK2_WR(x, (HW_HDMI_FC_MASK2_RD(x) & ~BM_HDMI_FC_MASK2_LowPriority_overflow) | BF_HDMI_FC_MASK2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_POL2 - FC_POL2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_POL2 - FC_POL2 (RW)
 *
 * Reset value: 0x03U
 *
 * Polarity register for generation of FC_INT2 interrupts. Address Offset:
 * 0x10DB Size: 8 bits Value after Reset: 0x03 Access: Read/Write
 */
typedef union _hw_hdmi_fc_pol2
{
    uint8_t U;
    struct _hw_hdmi_fc_pol2_bitfields
    {
        uint8_t HighPriority_overflow : 1; /*!< [0]  */
        uint8_t LowPriority_overflow : 1; /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_fc_pol2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_POL2 register
 */
/*@{*/
#define HW_HDMI_FC_POL2_ADDR(x)  ((uintptr_t)(x) + 0x10DBU)

#define HW_HDMI_FC_POL2(x)       (*(__IO hw_hdmi_fc_pol2_t *) HW_HDMI_FC_POL2_ADDR(x))
#define HW_HDMI_FC_POL2_RD(x)    (HW_HDMI_FC_POL2(x).U)
#define HW_HDMI_FC_POL2_WR(x, v) (HW_HDMI_FC_POL2(x).U = (v))
#define HW_HDMI_FC_POL2_SET(x, v) (HW_HDMI_FC_POL2_WR(x, HW_HDMI_FC_POL2_RD(x) |  (v)))
#define HW_HDMI_FC_POL2_CLR(x, v) (HW_HDMI_FC_POL2_WR(x, HW_HDMI_FC_POL2_RD(x) & ~(v)))
#define HW_HDMI_FC_POL2_TOG(x, v) (HW_HDMI_FC_POL2_WR(x, HW_HDMI_FC_POL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_POL2 bitfields
 */

/*!
 * @name Register HDMI_FC_POL2, field HighPriority_overflow[0] (RW)
 *
 * Polarity bit for FC_INT1.HighPriority_overflow interrupt bit Value after
 * Reset: 1b
 */
/*@{*/
#define BP_HDMI_FC_POL2_HighPriority_overflow (0U) /*!< Bit position for HDMI_FC_POL2_HighPriority_overflow. */
#define BM_HDMI_FC_POL2_HighPriority_overflow (0x01U) /*!< Bit mask for HDMI_FC_POL2_HighPriority_overflow. */
#define BS_HDMI_FC_POL2_HighPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_POL2_HighPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_POL2_HighPriority_overflow field. */
#define BR_HDMI_FC_POL2_HighPriority_overflow(x) (HW_HDMI_FC_POL2(x).B.HighPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_POL2_HighPriority_overflow. */
#define BF_HDMI_FC_POL2_HighPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL2_HighPriority_overflow) & BM_HDMI_FC_POL2_HighPriority_overflow)

/*! @brief Set the HighPriority_overflow field to a new value. */
#define BW_HDMI_FC_POL2_HighPriority_overflow(x, v) (HW_HDMI_FC_POL2_WR(x, (HW_HDMI_FC_POL2_RD(x) & ~BM_HDMI_FC_POL2_HighPriority_overflow) | BF_HDMI_FC_POL2_HighPriority_overflow(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_POL2, field LowPriority_overflow[1] (RW)
 *
 * Polarity bit for FC_INT1.LowPriority_overflow interrupt bit Value after
 * Reset: 1b
 */
/*@{*/
#define BP_HDMI_FC_POL2_LowPriority_overflow (1U) /*!< Bit position for HDMI_FC_POL2_LowPriority_overflow. */
#define BM_HDMI_FC_POL2_LowPriority_overflow (0x02U) /*!< Bit mask for HDMI_FC_POL2_LowPriority_overflow. */
#define BS_HDMI_FC_POL2_LowPriority_overflow (1U) /*!< Bit field size in bits for HDMI_FC_POL2_LowPriority_overflow. */

/*! @brief Read current value of the HDMI_FC_POL2_LowPriority_overflow field. */
#define BR_HDMI_FC_POL2_LowPriority_overflow(x) (HW_HDMI_FC_POL2(x).B.LowPriority_overflow)

/*! @brief Format value for bitfield HDMI_FC_POL2_LowPriority_overflow. */
#define BF_HDMI_FC_POL2_LowPriority_overflow(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_POL2_LowPriority_overflow) & BM_HDMI_FC_POL2_LowPriority_overflow)

/*! @brief Set the LowPriority_overflow field to a new value. */
#define BW_HDMI_FC_POL2_LowPriority_overflow(x, v) (HW_HDMI_FC_POL2_WR(x, (HW_HDMI_FC_POL2_RD(x) & ~BM_HDMI_FC_POL2_LowPriority_overflow) | BF_HDMI_FC_POL2_LowPriority_overflow(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_PRCONF - Frame Composer Pixel Repetition Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_PRCONF - Frame Composer Pixel Repetition Configuration Register (RW)
 *
 * Reset value: 0x10U
 *
 * Defines the Pixel Repetition ratio factor of the input and output video
 * signal. Address Offset: 0x10E0 Size: 8 bits Value after Reset: 0x10 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_prconf
{
    uint8_t U;
    struct _hw_hdmi_fc_prconf_bitfields
    {
        uint8_t output_pr_factor : 4;  /*!< [3:0]  */
        uint8_t incoming_pr_factor : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_prconf_t;

/*!
 * @name Constants and macros for entire HDMI_FC_PRCONF register
 */
/*@{*/
#define HW_HDMI_FC_PRCONF_ADDR(x) ((uintptr_t)(x) + 0x10E0U)

#define HW_HDMI_FC_PRCONF(x)     (*(__IO hw_hdmi_fc_prconf_t *) HW_HDMI_FC_PRCONF_ADDR(x))
#define HW_HDMI_FC_PRCONF_RD(x)  (HW_HDMI_FC_PRCONF(x).U)
#define HW_HDMI_FC_PRCONF_WR(x, v) (HW_HDMI_FC_PRCONF(x).U = (v))
#define HW_HDMI_FC_PRCONF_SET(x, v) (HW_HDMI_FC_PRCONF_WR(x, HW_HDMI_FC_PRCONF_RD(x) |  (v)))
#define HW_HDMI_FC_PRCONF_CLR(x, v) (HW_HDMI_FC_PRCONF_WR(x, HW_HDMI_FC_PRCONF_RD(x) & ~(v)))
#define HW_HDMI_FC_PRCONF_TOG(x, v) (HW_HDMI_FC_PRCONF_WR(x, HW_HDMI_FC_PRCONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_PRCONF bitfields
 */

/*!
 * @name Register HDMI_FC_PRCONF, field output_pr_factor[3:0] (RW)
 *
 * Configures the video pixel repetition ratio to be sent on the AVI infoFrame.
 * This value must be valid according to HDMI spec. The output_pr_factor =
 * incoming_pr_factor(without the + 1 factor) * desired_pr_factor. other: Reserved. Not
 * used.
 *
 * Values:
 * - 0000 - No action. Shall not be used.
 * - 0001 - Pixel sent twice (pixel repeated once).
 * - 0010 - Pixel sent 3 times.
 * - 0011 - Pixel sent 4 times.
 * - 0100 - Pixel sent 5 times.
 * - 0101 - Pixel sent 6 times.
 * - 0110 - Pixel sent 7 times.
 * - 0111 - Pixel sent 8 times.
 * - 1000 - Pixel sent 9 times.
 * - 1001 - Pixel sent 10 times.
 */
/*@{*/
#define BP_HDMI_FC_PRCONF_output_pr_factor (0U) /*!< Bit position for HDMI_FC_PRCONF_output_pr_factor. */
#define BM_HDMI_FC_PRCONF_output_pr_factor (0x0FU) /*!< Bit mask for HDMI_FC_PRCONF_output_pr_factor. */
#define BS_HDMI_FC_PRCONF_output_pr_factor (4U) /*!< Bit field size in bits for HDMI_FC_PRCONF_output_pr_factor. */

/*! @brief Read current value of the HDMI_FC_PRCONF_output_pr_factor field. */
#define BR_HDMI_FC_PRCONF_output_pr_factor(x) (HW_HDMI_FC_PRCONF(x).B.output_pr_factor)

/*! @brief Format value for bitfield HDMI_FC_PRCONF_output_pr_factor. */
#define BF_HDMI_FC_PRCONF_output_pr_factor(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_PRCONF_output_pr_factor) & BM_HDMI_FC_PRCONF_output_pr_factor)

/*! @brief Set the output_pr_factor field to a new value. */
#define BW_HDMI_FC_PRCONF_output_pr_factor(x, v) (HW_HDMI_FC_PRCONF_WR(x, (HW_HDMI_FC_PRCONF_RD(x) & ~BM_HDMI_FC_PRCONF_output_pr_factor) | BF_HDMI_FC_PRCONF_output_pr_factor(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_PRCONF, field incoming_pr_factor[7:4] (RW)
 *
 * Configures the input video pixel repetition. A plus 1 factor should be added
 * in this register configuration. For CEA modes this value should be extracted
 * from the CEA spec for the video mode being inputted. When working in YCC422
 * video the actual repetition of the stream will be Incoming_pr_factor *
 * (desired_pr_factor + 1). This calculation is done internally in the H13TCTRL and no HW
 * overflow protection is available. Care must be taken to avoid this result
 * passes the maximum number of 10 pixels repeated since no HDMI support is available
 * for this in the spec and the H13TPHY does not support this higher repetition
 * values. other: Reserved. Not used.
 *
 * Values:
 * - 0000 - No action. Shall not be used.
 * - 0001 - No pixel repetition (pixel sent only once).
 * - 0010 - Pixel sent twice (pixel repeated once).
 * - 0011 - Pixel sent 3 times.
 * - 0100 - Pixel sent 4 times.
 * - 0101 - Pixel sent 5 times.
 * - 0110 - Pixel sent 6 times.
 * - 0111 - Pixel sent 7 times.
 * - 1000 - Pixel sent 8 times.
 * - 1001 - Pixel sent 9 times.
 * - 1010 - Pixel sent 10 times.
 */
/*@{*/
#define BP_HDMI_FC_PRCONF_incoming_pr_factor (4U) /*!< Bit position for HDMI_FC_PRCONF_incoming_pr_factor. */
#define BM_HDMI_FC_PRCONF_incoming_pr_factor (0xF0U) /*!< Bit mask for HDMI_FC_PRCONF_incoming_pr_factor. */
#define BS_HDMI_FC_PRCONF_incoming_pr_factor (4U) /*!< Bit field size in bits for HDMI_FC_PRCONF_incoming_pr_factor. */

/*! @brief Read current value of the HDMI_FC_PRCONF_incoming_pr_factor field. */
#define BR_HDMI_FC_PRCONF_incoming_pr_factor(x) (HW_HDMI_FC_PRCONF(x).B.incoming_pr_factor)

/*! @brief Format value for bitfield HDMI_FC_PRCONF_incoming_pr_factor. */
#define BF_HDMI_FC_PRCONF_incoming_pr_factor(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_PRCONF_incoming_pr_factor) & BM_HDMI_FC_PRCONF_incoming_pr_factor)

/*! @brief Set the incoming_pr_factor field to a new value. */
#define BW_HDMI_FC_PRCONF_incoming_pr_factor(x, v) (HW_HDMI_FC_PRCONF_WR(x, (HW_HDMI_FC_PRCONF_RD(x) & ~BM_HDMI_FC_PRCONF_incoming_pr_factor) | BF_HDMI_FC_PRCONF_incoming_pr_factor(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_STAT - Frame Composer GMD Packet Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_STAT - Frame Composer GMD Packet Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * Gamut metadata packet status bit information for no_current_gmd,
 * next_gmd_field, gmd_packet_sequence and current_gamut_seq_num. For more information, refer
 * to the HDMI 1.4a specification. Address Offset: 0x1100 Size: 8 bits Value
 * after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_fc_gmd_stat
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_stat_bitfields
    {
        uint8_t igmdcurrent_gamut_seq_num : 4; /*!< [3:0]  */
        uint8_t igmdpacket_seq : 2;    /*!< [5:4]  */
        uint8_t igmddnext_field : 1;   /*!< [6]  */
        uint8_t igmdno_crnt_gbd : 1;   /*!< [7]  */
    } B;
} hw_hdmi_fc_gmd_stat_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_STAT register
 */
/*@{*/
#define HW_HDMI_FC_GMD_STAT_ADDR(x) ((uintptr_t)(x) + 0x1100U)

#define HW_HDMI_FC_GMD_STAT(x)   (*(__I hw_hdmi_fc_gmd_stat_t *) HW_HDMI_FC_GMD_STAT_ADDR(x))
#define HW_HDMI_FC_GMD_STAT_RD(x) (HW_HDMI_FC_GMD_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_STAT bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_STAT, field igmdcurrent_gamut_seq_num[3:0] (RO)
 *
 * Gamut scheduling: Current Gamut packet sequence number
 */
/*@{*/
#define BP_HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num (0U) /*!< Bit position for HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num. */
#define BM_HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num (0x0FU) /*!< Bit mask for HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num. */
#define BS_HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num (4U) /*!< Bit field size in bits for HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num. */

/*! @brief Read current value of the HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num field. */
#define BR_HDMI_FC_GMD_STAT_igmdcurrent_gamut_seq_num(x) (HW_HDMI_FC_GMD_STAT(x).B.igmdcurrent_gamut_seq_num)
/*@}*/

/*!
 * @name Register HDMI_FC_GMD_STAT, field igmdpacket_seq[5:4] (RO)
 *
 * Gamut scheduling: Gamut packet sequence
 */
/*@{*/
#define BP_HDMI_FC_GMD_STAT_igmdpacket_seq (4U) /*!< Bit position for HDMI_FC_GMD_STAT_igmdpacket_seq. */
#define BM_HDMI_FC_GMD_STAT_igmdpacket_seq (0x30U) /*!< Bit mask for HDMI_FC_GMD_STAT_igmdpacket_seq. */
#define BS_HDMI_FC_GMD_STAT_igmdpacket_seq (2U) /*!< Bit field size in bits for HDMI_FC_GMD_STAT_igmdpacket_seq. */

/*! @brief Read current value of the HDMI_FC_GMD_STAT_igmdpacket_seq field. */
#define BR_HDMI_FC_GMD_STAT_igmdpacket_seq(x) (HW_HDMI_FC_GMD_STAT(x).B.igmdpacket_seq)
/*@}*/

/*!
 * @name Register HDMI_FC_GMD_STAT, field igmddnext_field[6] (RO)
 *
 * Gamut scheduling: Gamut Next field
 */
/*@{*/
#define BP_HDMI_FC_GMD_STAT_igmddnext_field (6U) /*!< Bit position for HDMI_FC_GMD_STAT_igmddnext_field. */
#define BM_HDMI_FC_GMD_STAT_igmddnext_field (0x40U) /*!< Bit mask for HDMI_FC_GMD_STAT_igmddnext_field. */
#define BS_HDMI_FC_GMD_STAT_igmddnext_field (1U) /*!< Bit field size in bits for HDMI_FC_GMD_STAT_igmddnext_field. */

/*! @brief Read current value of the HDMI_FC_GMD_STAT_igmddnext_field field. */
#define BR_HDMI_FC_GMD_STAT_igmddnext_field(x) (HW_HDMI_FC_GMD_STAT(x).B.igmddnext_field)
/*@}*/

/*!
 * @name Register HDMI_FC_GMD_STAT, field igmdno_crnt_gbd[7] (RO)
 *
 * Gamut scheduling: No current gamut data
 */
/*@{*/
#define BP_HDMI_FC_GMD_STAT_igmdno_crnt_gbd (7U) /*!< Bit position for HDMI_FC_GMD_STAT_igmdno_crnt_gbd. */
#define BM_HDMI_FC_GMD_STAT_igmdno_crnt_gbd (0x80U) /*!< Bit mask for HDMI_FC_GMD_STAT_igmdno_crnt_gbd. */
#define BS_HDMI_FC_GMD_STAT_igmdno_crnt_gbd (1U) /*!< Bit field size in bits for HDMI_FC_GMD_STAT_igmdno_crnt_gbd. */

/*! @brief Read current value of the HDMI_FC_GMD_STAT_igmdno_crnt_gbd field. */
#define BR_HDMI_FC_GMD_STAT_igmdno_crnt_gbd(x) (HW_HDMI_FC_GMD_STAT(x).B.igmdno_crnt_gbd)
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_EN - Frame Composer GMD Packet Enable Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_EN - Frame Composer GMD Packet Enable Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register enables Gamut metadata (GMD) packet transmission. Packets are
 * inserted in the incoming frame, starting in the line where active Vsync
 * indication starts. After enable of GMD packets the outgoing packet is sent with
 * no_current_gmd active indication until update GMD request is performed in the
 * controller. Address Offset: 0x1101 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_gmd_en
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_en_bitfields
    {
        uint8_t gmdenabletx : 1;       /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_fc_gmd_en_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_EN register
 */
/*@{*/
#define HW_HDMI_FC_GMD_EN_ADDR(x) ((uintptr_t)(x) + 0x1101U)

#define HW_HDMI_FC_GMD_EN(x)     (*(__IO hw_hdmi_fc_gmd_en_t *) HW_HDMI_FC_GMD_EN_ADDR(x))
#define HW_HDMI_FC_GMD_EN_RD(x)  (HW_HDMI_FC_GMD_EN(x).U)
#define HW_HDMI_FC_GMD_EN_WR(x, v) (HW_HDMI_FC_GMD_EN(x).U = (v))
#define HW_HDMI_FC_GMD_EN_SET(x, v) (HW_HDMI_FC_GMD_EN_WR(x, HW_HDMI_FC_GMD_EN_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_EN_CLR(x, v) (HW_HDMI_FC_GMD_EN_WR(x, HW_HDMI_FC_GMD_EN_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_EN_TOG(x, v) (HW_HDMI_FC_GMD_EN_WR(x, HW_HDMI_FC_GMD_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_EN bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_EN, field gmdenabletx[0] (RW)
 *
 * Gamut Metadata packet transmission enable (1b).
 */
/*@{*/
#define BP_HDMI_FC_GMD_EN_gmdenabletx (0U) /*!< Bit position for HDMI_FC_GMD_EN_gmdenabletx. */
#define BM_HDMI_FC_GMD_EN_gmdenabletx (0x01U) /*!< Bit mask for HDMI_FC_GMD_EN_gmdenabletx. */
#define BS_HDMI_FC_GMD_EN_gmdenabletx (1U) /*!< Bit field size in bits for HDMI_FC_GMD_EN_gmdenabletx. */

/*! @brief Read current value of the HDMI_FC_GMD_EN_gmdenabletx field. */
#define BR_HDMI_FC_GMD_EN_gmdenabletx(x) (HW_HDMI_FC_GMD_EN(x).B.gmdenabletx)

/*! @brief Format value for bitfield HDMI_FC_GMD_EN_gmdenabletx. */
#define BF_HDMI_FC_GMD_EN_gmdenabletx(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_EN_gmdenabletx) & BM_HDMI_FC_GMD_EN_gmdenabletx)

/*! @brief Set the gmdenabletx field to a new value. */
#define BW_HDMI_FC_GMD_EN_gmdenabletx(x, v) (HW_HDMI_FC_GMD_EN_WR(x, (HW_HDMI_FC_GMD_EN_RD(x) & ~BM_HDMI_FC_GMD_EN_gmdenabletx) | BF_HDMI_FC_GMD_EN_gmdenabletx(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_UP - Frame Composer GMD Packet Update Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_UP - Frame Composer GMD Packet Update Register (WO)
 *
 * Reset value: 0x00U
 *
 * This register performs an GMD packet content update according to the
 * configured packet body (FC_GMD_PB0 to FC_GMD_PB27) and packet header (FC_GMD_HB). This
 * active high auto clear register reflects the body and header configurations
 * on the GMD packets sent arbitrating the current_gamut_seq_num,
 * gmd_packet_sequence and next_gmd_field bits on packet to correctly indicate to source the
 * Gamut change to be performed. After enable GMD packets the first update request is
 * also responsible for deactivating the no_current_gmd indication bit.
 * Attention packet update request must only be done after correct configuration of GMD
 * packet body and header registers. Correct affected_gamut_seq_num and
 * gmd_profile configuration is user responsibility and must convey with HDMI 1.4a standard
 * gamut rules. Address Offset: 0x1102 Size: 8 bits Value after Reset: 0x00
 * Access: Write
 */
typedef union _hw_hdmi_fc_gmd_up
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_up_bitfields
    {
        uint8_t gmdupdatepacket : 1;   /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_fc_gmd_up_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_UP register
 */
/*@{*/
#define HW_HDMI_FC_GMD_UP_ADDR(x) ((uintptr_t)(x) + 0x1102U)

#define HW_HDMI_FC_GMD_UP(x)     (*(__O hw_hdmi_fc_gmd_up_t *) HW_HDMI_FC_GMD_UP_ADDR(x))
#define HW_HDMI_FC_GMD_UP_WR(x, v) (HW_HDMI_FC_GMD_UP(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_UP bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_UP, field gmdupdatepacket[0] (WO)
 *
 * Gamut Metadata packet update.
 */
/*@{*/
#define BP_HDMI_FC_GMD_UP_gmdupdatepacket (0U) /*!< Bit position for HDMI_FC_GMD_UP_gmdupdatepacket. */
#define BM_HDMI_FC_GMD_UP_gmdupdatepacket (0x01U) /*!< Bit mask for HDMI_FC_GMD_UP_gmdupdatepacket. */
#define BS_HDMI_FC_GMD_UP_gmdupdatepacket (1U) /*!< Bit field size in bits for HDMI_FC_GMD_UP_gmdupdatepacket. */

/*! @brief Format value for bitfield HDMI_FC_GMD_UP_gmdupdatepacket. */
#define BF_HDMI_FC_GMD_UP_gmdupdatepacket(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_UP_gmdupdatepacket) & BM_HDMI_FC_GMD_UP_gmdupdatepacket)
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_CONF - Frame Composer GMD Packet Schedule Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_CONF - Frame Composer GMD Packet Schedule Configuration Register (RW)
 *
 * Reset value: 0x10U
 *
 * This register configures the number of GMD packets to be inserted per frame
 * (starting always in the line where the active Vsync appears) and the line
 * spacing between the transmitted GMD packets. Note that for profile P0 (refer to
 * HDMI 1.4a spec) this register should only indicate one GMD packet to be inserted
 * per video field. Address Offset: 0x1103 Size: 8 bits Value after Reset: 0x10
 * Access: Read/Write
 */
typedef union _hw_hdmi_fc_gmd_conf
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_conf_bitfields
    {
        uint8_t gmdpacketlinespacing : 4; /*!< [3:0]  */
        uint8_t gmdpacketsinframe : 4; /*!< [7:4]  */
    } B;
} hw_hdmi_fc_gmd_conf_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_CONF register
 */
/*@{*/
#define HW_HDMI_FC_GMD_CONF_ADDR(x) ((uintptr_t)(x) + 0x1103U)

#define HW_HDMI_FC_GMD_CONF(x)   (*(__IO hw_hdmi_fc_gmd_conf_t *) HW_HDMI_FC_GMD_CONF_ADDR(x))
#define HW_HDMI_FC_GMD_CONF_RD(x) (HW_HDMI_FC_GMD_CONF(x).U)
#define HW_HDMI_FC_GMD_CONF_WR(x, v) (HW_HDMI_FC_GMD_CONF(x).U = (v))
#define HW_HDMI_FC_GMD_CONF_SET(x, v) (HW_HDMI_FC_GMD_CONF_WR(x, HW_HDMI_FC_GMD_CONF_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_CONF_CLR(x, v) (HW_HDMI_FC_GMD_CONF_WR(x, HW_HDMI_FC_GMD_CONF_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_CONF_TOG(x, v) (HW_HDMI_FC_GMD_CONF_WR(x, HW_HDMI_FC_GMD_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_CONF bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_CONF, field gmdpacketlinespacing[3:0] (RW)
 *
 * Number of line spacing between the transmitted GMD packets
 */
/*@{*/
#define BP_HDMI_FC_GMD_CONF_gmdpacketlinespacing (0U) /*!< Bit position for HDMI_FC_GMD_CONF_gmdpacketlinespacing. */
#define BM_HDMI_FC_GMD_CONF_gmdpacketlinespacing (0x0FU) /*!< Bit mask for HDMI_FC_GMD_CONF_gmdpacketlinespacing. */
#define BS_HDMI_FC_GMD_CONF_gmdpacketlinespacing (4U) /*!< Bit field size in bits for HDMI_FC_GMD_CONF_gmdpacketlinespacing. */

/*! @brief Read current value of the HDMI_FC_GMD_CONF_gmdpacketlinespacing field. */
#define BR_HDMI_FC_GMD_CONF_gmdpacketlinespacing(x) (HW_HDMI_FC_GMD_CONF(x).B.gmdpacketlinespacing)

/*! @brief Format value for bitfield HDMI_FC_GMD_CONF_gmdpacketlinespacing. */
#define BF_HDMI_FC_GMD_CONF_gmdpacketlinespacing(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_CONF_gmdpacketlinespacing) & BM_HDMI_FC_GMD_CONF_gmdpacketlinespacing)

/*! @brief Set the gmdpacketlinespacing field to a new value. */
#define BW_HDMI_FC_GMD_CONF_gmdpacketlinespacing(x, v) (HW_HDMI_FC_GMD_CONF_WR(x, (HW_HDMI_FC_GMD_CONF_RD(x) & ~BM_HDMI_FC_GMD_CONF_gmdpacketlinespacing) | BF_HDMI_FC_GMD_CONF_gmdpacketlinespacing(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_GMD_CONF, field gmdpacketsinframe[7:4] (RW)
 *
 * Number of GMD packets per frame or video field (profile P0)
 */
/*@{*/
#define BP_HDMI_FC_GMD_CONF_gmdpacketsinframe (4U) /*!< Bit position for HDMI_FC_GMD_CONF_gmdpacketsinframe. */
#define BM_HDMI_FC_GMD_CONF_gmdpacketsinframe (0xF0U) /*!< Bit mask for HDMI_FC_GMD_CONF_gmdpacketsinframe. */
#define BS_HDMI_FC_GMD_CONF_gmdpacketsinframe (4U) /*!< Bit field size in bits for HDMI_FC_GMD_CONF_gmdpacketsinframe. */

/*! @brief Read current value of the HDMI_FC_GMD_CONF_gmdpacketsinframe field. */
#define BR_HDMI_FC_GMD_CONF_gmdpacketsinframe(x) (HW_HDMI_FC_GMD_CONF(x).B.gmdpacketsinframe)

/*! @brief Format value for bitfield HDMI_FC_GMD_CONF_gmdpacketsinframe. */
#define BF_HDMI_FC_GMD_CONF_gmdpacketsinframe(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_CONF_gmdpacketsinframe) & BM_HDMI_FC_GMD_CONF_gmdpacketsinframe)

/*! @brief Set the gmdpacketsinframe field to a new value. */
#define BW_HDMI_FC_GMD_CONF_gmdpacketsinframe(x, v) (HW_HDMI_FC_GMD_CONF_WR(x, (HW_HDMI_FC_GMD_CONF_RD(x) & ~BM_HDMI_FC_GMD_CONF_gmdpacketsinframe) | BF_HDMI_FC_GMD_CONF_gmdpacketsinframe(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_HB - Frame Composer GMD Packet Profile and Gamut Sequence Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_HB - Frame Composer GMD Packet Profile and Gamut Sequence Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register configures the GMD packet header affected_gamut_seq_num and
 * gmd_profile bits. For more information, refer to the HDMI 1.4a specification.
 * Address Offset: 0x1104 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_gmd_hb
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_hb_bitfields
    {
        uint8_t gmdaffected_gamut_seq_num : 4; /*!< [3:0]  */
        uint8_t gmdgbd_profile : 3;    /*!< [6:4]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_fc_gmd_hb_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_HB register
 */
/*@{*/
#define HW_HDMI_FC_GMD_HB_ADDR(x) ((uintptr_t)(x) + 0x1104U)

#define HW_HDMI_FC_GMD_HB(x)     (*(__IO hw_hdmi_fc_gmd_hb_t *) HW_HDMI_FC_GMD_HB_ADDR(x))
#define HW_HDMI_FC_GMD_HB_RD(x)  (HW_HDMI_FC_GMD_HB(x).U)
#define HW_HDMI_FC_GMD_HB_WR(x, v) (HW_HDMI_FC_GMD_HB(x).U = (v))
#define HW_HDMI_FC_GMD_HB_SET(x, v) (HW_HDMI_FC_GMD_HB_WR(x, HW_HDMI_FC_GMD_HB_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_HB_CLR(x, v) (HW_HDMI_FC_GMD_HB_WR(x, HW_HDMI_FC_GMD_HB_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_HB_TOG(x, v) (HW_HDMI_FC_GMD_HB_WR(x, HW_HDMI_FC_GMD_HB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_HB bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_HB, field gmdaffected_gamut_seq_num[3:0] (RW)
 *
 * Affected gamut sequence number
 */
/*@{*/
#define BP_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num (0U) /*!< Bit position for HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num. */
#define BM_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num (0x0FU) /*!< Bit mask for HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num. */
#define BS_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num (4U) /*!< Bit field size in bits for HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num. */

/*! @brief Read current value of the HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num field. */
#define BR_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num(x) (HW_HDMI_FC_GMD_HB(x).B.gmdaffected_gamut_seq_num)

/*! @brief Format value for bitfield HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num. */
#define BF_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num) & BM_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num)

/*! @brief Set the gmdaffected_gamut_seq_num field to a new value. */
#define BW_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num(x, v) (HW_HDMI_FC_GMD_HB_WR(x, (HW_HDMI_FC_GMD_HB_RD(x) & ~BM_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num) | BF_HDMI_FC_GMD_HB_gmdaffected_gamut_seq_num(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_GMD_HB, field gmdgbd_profile[6:4] (RW)
 *
 * GMD profile bits
 */
/*@{*/
#define BP_HDMI_FC_GMD_HB_gmdgbd_profile (4U) /*!< Bit position for HDMI_FC_GMD_HB_gmdgbd_profile. */
#define BM_HDMI_FC_GMD_HB_gmdgbd_profile (0x70U) /*!< Bit mask for HDMI_FC_GMD_HB_gmdgbd_profile. */
#define BS_HDMI_FC_GMD_HB_gmdgbd_profile (3U) /*!< Bit field size in bits for HDMI_FC_GMD_HB_gmdgbd_profile. */

/*! @brief Read current value of the HDMI_FC_GMD_HB_gmdgbd_profile field. */
#define BR_HDMI_FC_GMD_HB_gmdgbd_profile(x) (HW_HDMI_FC_GMD_HB(x).B.gmdgbd_profile)

/*! @brief Format value for bitfield HDMI_FC_GMD_HB_gmdgbd_profile. */
#define BF_HDMI_FC_GMD_HB_gmdgbd_profile(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_HB_gmdgbd_profile) & BM_HDMI_FC_GMD_HB_gmdgbd_profile)

/*! @brief Set the gmdgbd_profile field to a new value. */
#define BW_HDMI_FC_GMD_HB_gmdgbd_profile(x, v) (HW_HDMI_FC_GMD_HB_WR(x, (HW_HDMI_FC_GMD_HB_RD(x) & ~BM_HDMI_FC_GMD_HB_gmdgbd_profile) | BF_HDMI_FC_GMD_HB_gmdgbd_profile(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB0 - Frame Composer GMD Packet Body Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB0 - Frame Composer GMD Packet Body Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the following contents of the GMD packet: GMD packet body byte0
 * Address Offset: 0x1105 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 * For more information, refer to the HDMI 1.4a specification.
 */
typedef union _hw_hdmi_fc_gmd_pb0
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb0_bitfields
    {
        uint8_t FC_GMD_PB0 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB0 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB0_ADDR(x) ((uintptr_t)(x) + 0x1105U)

#define HW_HDMI_FC_GMD_PB0(x)    (*(__IO hw_hdmi_fc_gmd_pb0_t *) HW_HDMI_FC_GMD_PB0_ADDR(x))
#define HW_HDMI_FC_GMD_PB0_RD(x) (HW_HDMI_FC_GMD_PB0(x).U)
#define HW_HDMI_FC_GMD_PB0_WR(x, v) (HW_HDMI_FC_GMD_PB0(x).U = (v))
#define HW_HDMI_FC_GMD_PB0_SET(x, v) (HW_HDMI_FC_GMD_PB0_WR(x, HW_HDMI_FC_GMD_PB0_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB0_CLR(x, v) (HW_HDMI_FC_GMD_PB0_WR(x, HW_HDMI_FC_GMD_PB0_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB0_TOG(x, v) (HW_HDMI_FC_GMD_PB0_WR(x, HW_HDMI_FC_GMD_PB0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB0 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB0, field FC_GMD_PB0[7:0] (RW)
 *
 * Gamut Metadata packet byte0
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB0_FC_GMD_PB0 (0U) /*!< Bit position for HDMI_FC_GMD_PB0_FC_GMD_PB0. */
#define BM_HDMI_FC_GMD_PB0_FC_GMD_PB0 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB0_FC_GMD_PB0. */
#define BS_HDMI_FC_GMD_PB0_FC_GMD_PB0 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB0_FC_GMD_PB0. */

/*! @brief Read current value of the HDMI_FC_GMD_PB0_FC_GMD_PB0 field. */
#define BR_HDMI_FC_GMD_PB0_FC_GMD_PB0(x) (HW_HDMI_FC_GMD_PB0(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB0_FC_GMD_PB0. */
#define BF_HDMI_FC_GMD_PB0_FC_GMD_PB0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB0_FC_GMD_PB0) & BM_HDMI_FC_GMD_PB0_FC_GMD_PB0)

/*! @brief Set the FC_GMD_PB0 field to a new value. */
#define BW_HDMI_FC_GMD_PB0_FC_GMD_PB0(x, v) (HW_HDMI_FC_GMD_PB0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB1 - Frame Composer GMD Packet Body Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB1 - Frame Composer GMD Packet Body Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte1 Address Offset: 0x1106 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb1
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb1_bitfields
    {
        uint8_t FC_GMD_PB1 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB1 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB1_ADDR(x) ((uintptr_t)(x) + 0x1106U)

#define HW_HDMI_FC_GMD_PB1(x)    (*(__IO hw_hdmi_fc_gmd_pb1_t *) HW_HDMI_FC_GMD_PB1_ADDR(x))
#define HW_HDMI_FC_GMD_PB1_RD(x) (HW_HDMI_FC_GMD_PB1(x).U)
#define HW_HDMI_FC_GMD_PB1_WR(x, v) (HW_HDMI_FC_GMD_PB1(x).U = (v))
#define HW_HDMI_FC_GMD_PB1_SET(x, v) (HW_HDMI_FC_GMD_PB1_WR(x, HW_HDMI_FC_GMD_PB1_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB1_CLR(x, v) (HW_HDMI_FC_GMD_PB1_WR(x, HW_HDMI_FC_GMD_PB1_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB1_TOG(x, v) (HW_HDMI_FC_GMD_PB1_WR(x, HW_HDMI_FC_GMD_PB1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB1 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB1, field FC_GMD_PB1[7:0] (RW)
 *
 * Gamut Metadata packet byte1
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB1_FC_GMD_PB1 (0U) /*!< Bit position for HDMI_FC_GMD_PB1_FC_GMD_PB1. */
#define BM_HDMI_FC_GMD_PB1_FC_GMD_PB1 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB1_FC_GMD_PB1. */
#define BS_HDMI_FC_GMD_PB1_FC_GMD_PB1 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB1_FC_GMD_PB1. */

/*! @brief Read current value of the HDMI_FC_GMD_PB1_FC_GMD_PB1 field. */
#define BR_HDMI_FC_GMD_PB1_FC_GMD_PB1(x) (HW_HDMI_FC_GMD_PB1(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB1_FC_GMD_PB1. */
#define BF_HDMI_FC_GMD_PB1_FC_GMD_PB1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB1_FC_GMD_PB1) & BM_HDMI_FC_GMD_PB1_FC_GMD_PB1)

/*! @brief Set the FC_GMD_PB1 field to a new value. */
#define BW_HDMI_FC_GMD_PB1_FC_GMD_PB1(x, v) (HW_HDMI_FC_GMD_PB1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB2 - Frame Composer GMD Packet Body Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB2 - Frame Composer GMD Packet Body Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte2 Address Offset: 0x1107 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb2
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb2_bitfields
    {
        uint8_t FC_GMD_PB2 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB2 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB2_ADDR(x) ((uintptr_t)(x) + 0x1107U)

#define HW_HDMI_FC_GMD_PB2(x)    (*(__IO hw_hdmi_fc_gmd_pb2_t *) HW_HDMI_FC_GMD_PB2_ADDR(x))
#define HW_HDMI_FC_GMD_PB2_RD(x) (HW_HDMI_FC_GMD_PB2(x).U)
#define HW_HDMI_FC_GMD_PB2_WR(x, v) (HW_HDMI_FC_GMD_PB2(x).U = (v))
#define HW_HDMI_FC_GMD_PB2_SET(x, v) (HW_HDMI_FC_GMD_PB2_WR(x, HW_HDMI_FC_GMD_PB2_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB2_CLR(x, v) (HW_HDMI_FC_GMD_PB2_WR(x, HW_HDMI_FC_GMD_PB2_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB2_TOG(x, v) (HW_HDMI_FC_GMD_PB2_WR(x, HW_HDMI_FC_GMD_PB2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB2 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB2, field FC_GMD_PB2[7:0] (RW)
 *
 * Gamut Metadata packet byte2
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB2_FC_GMD_PB2 (0U) /*!< Bit position for HDMI_FC_GMD_PB2_FC_GMD_PB2. */
#define BM_HDMI_FC_GMD_PB2_FC_GMD_PB2 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB2_FC_GMD_PB2. */
#define BS_HDMI_FC_GMD_PB2_FC_GMD_PB2 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB2_FC_GMD_PB2. */

/*! @brief Read current value of the HDMI_FC_GMD_PB2_FC_GMD_PB2 field. */
#define BR_HDMI_FC_GMD_PB2_FC_GMD_PB2(x) (HW_HDMI_FC_GMD_PB2(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB2_FC_GMD_PB2. */
#define BF_HDMI_FC_GMD_PB2_FC_GMD_PB2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB2_FC_GMD_PB2) & BM_HDMI_FC_GMD_PB2_FC_GMD_PB2)

/*! @brief Set the FC_GMD_PB2 field to a new value. */
#define BW_HDMI_FC_GMD_PB2_FC_GMD_PB2(x, v) (HW_HDMI_FC_GMD_PB2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB3 - Frame Composer GMD Packet Body Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB3 - Frame Composer GMD Packet Body Register 3 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte3 Address Offset: 0x1108 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb3
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb3_bitfields
    {
        uint8_t FC_GMD_PB3 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB3 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB3_ADDR(x) ((uintptr_t)(x) + 0x1108U)

#define HW_HDMI_FC_GMD_PB3(x)    (*(__IO hw_hdmi_fc_gmd_pb3_t *) HW_HDMI_FC_GMD_PB3_ADDR(x))
#define HW_HDMI_FC_GMD_PB3_RD(x) (HW_HDMI_FC_GMD_PB3(x).U)
#define HW_HDMI_FC_GMD_PB3_WR(x, v) (HW_HDMI_FC_GMD_PB3(x).U = (v))
#define HW_HDMI_FC_GMD_PB3_SET(x, v) (HW_HDMI_FC_GMD_PB3_WR(x, HW_HDMI_FC_GMD_PB3_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB3_CLR(x, v) (HW_HDMI_FC_GMD_PB3_WR(x, HW_HDMI_FC_GMD_PB3_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB3_TOG(x, v) (HW_HDMI_FC_GMD_PB3_WR(x, HW_HDMI_FC_GMD_PB3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB3 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB3, field FC_GMD_PB3[7:0] (RW)
 *
 * Gamut Metadata packet byte3
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB3_FC_GMD_PB3 (0U) /*!< Bit position for HDMI_FC_GMD_PB3_FC_GMD_PB3. */
#define BM_HDMI_FC_GMD_PB3_FC_GMD_PB3 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB3_FC_GMD_PB3. */
#define BS_HDMI_FC_GMD_PB3_FC_GMD_PB3 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB3_FC_GMD_PB3. */

/*! @brief Read current value of the HDMI_FC_GMD_PB3_FC_GMD_PB3 field. */
#define BR_HDMI_FC_GMD_PB3_FC_GMD_PB3(x) (HW_HDMI_FC_GMD_PB3(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB3_FC_GMD_PB3. */
#define BF_HDMI_FC_GMD_PB3_FC_GMD_PB3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB3_FC_GMD_PB3) & BM_HDMI_FC_GMD_PB3_FC_GMD_PB3)

/*! @brief Set the FC_GMD_PB3 field to a new value. */
#define BW_HDMI_FC_GMD_PB3_FC_GMD_PB3(x, v) (HW_HDMI_FC_GMD_PB3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB4 - Frame Composer GMD Packet Body Register 4
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB4 - Frame Composer GMD Packet Body Register 4 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte4 Address Offset: 0x1109 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb4
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb4_bitfields
    {
        uint8_t FC_GMD_PB4 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB4 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB4_ADDR(x) ((uintptr_t)(x) + 0x1109U)

#define HW_HDMI_FC_GMD_PB4(x)    (*(__IO hw_hdmi_fc_gmd_pb4_t *) HW_HDMI_FC_GMD_PB4_ADDR(x))
#define HW_HDMI_FC_GMD_PB4_RD(x) (HW_HDMI_FC_GMD_PB4(x).U)
#define HW_HDMI_FC_GMD_PB4_WR(x, v) (HW_HDMI_FC_GMD_PB4(x).U = (v))
#define HW_HDMI_FC_GMD_PB4_SET(x, v) (HW_HDMI_FC_GMD_PB4_WR(x, HW_HDMI_FC_GMD_PB4_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB4_CLR(x, v) (HW_HDMI_FC_GMD_PB4_WR(x, HW_HDMI_FC_GMD_PB4_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB4_TOG(x, v) (HW_HDMI_FC_GMD_PB4_WR(x, HW_HDMI_FC_GMD_PB4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB4 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB4, field FC_GMD_PB4[7:0] (RW)
 *
 * Gamut Metadata packet byte4
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB4_FC_GMD_PB4 (0U) /*!< Bit position for HDMI_FC_GMD_PB4_FC_GMD_PB4. */
#define BM_HDMI_FC_GMD_PB4_FC_GMD_PB4 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB4_FC_GMD_PB4. */
#define BS_HDMI_FC_GMD_PB4_FC_GMD_PB4 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB4_FC_GMD_PB4. */

/*! @brief Read current value of the HDMI_FC_GMD_PB4_FC_GMD_PB4 field. */
#define BR_HDMI_FC_GMD_PB4_FC_GMD_PB4(x) (HW_HDMI_FC_GMD_PB4(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB4_FC_GMD_PB4. */
#define BF_HDMI_FC_GMD_PB4_FC_GMD_PB4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB4_FC_GMD_PB4) & BM_HDMI_FC_GMD_PB4_FC_GMD_PB4)

/*! @brief Set the FC_GMD_PB4 field to a new value. */
#define BW_HDMI_FC_GMD_PB4_FC_GMD_PB4(x, v) (HW_HDMI_FC_GMD_PB4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB5 - Frame Composer GMD Packet Body Register 5
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB5 - Frame Composer GMD Packet Body Register 5 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte5 Address Offset: 0x110a Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb5
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb5_bitfields
    {
        uint8_t FC_GMD_PB5 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB5 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB5_ADDR(x) ((uintptr_t)(x) + 0x110AU)

#define HW_HDMI_FC_GMD_PB5(x)    (*(__IO hw_hdmi_fc_gmd_pb5_t *) HW_HDMI_FC_GMD_PB5_ADDR(x))
#define HW_HDMI_FC_GMD_PB5_RD(x) (HW_HDMI_FC_GMD_PB5(x).U)
#define HW_HDMI_FC_GMD_PB5_WR(x, v) (HW_HDMI_FC_GMD_PB5(x).U = (v))
#define HW_HDMI_FC_GMD_PB5_SET(x, v) (HW_HDMI_FC_GMD_PB5_WR(x, HW_HDMI_FC_GMD_PB5_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB5_CLR(x, v) (HW_HDMI_FC_GMD_PB5_WR(x, HW_HDMI_FC_GMD_PB5_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB5_TOG(x, v) (HW_HDMI_FC_GMD_PB5_WR(x, HW_HDMI_FC_GMD_PB5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB5 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB5, field FC_GMD_PB5[7:0] (RW)
 *
 * Gamut Metadata packet byte5
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB5_FC_GMD_PB5 (0U) /*!< Bit position for HDMI_FC_GMD_PB5_FC_GMD_PB5. */
#define BM_HDMI_FC_GMD_PB5_FC_GMD_PB5 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB5_FC_GMD_PB5. */
#define BS_HDMI_FC_GMD_PB5_FC_GMD_PB5 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB5_FC_GMD_PB5. */

/*! @brief Read current value of the HDMI_FC_GMD_PB5_FC_GMD_PB5 field. */
#define BR_HDMI_FC_GMD_PB5_FC_GMD_PB5(x) (HW_HDMI_FC_GMD_PB5(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB5_FC_GMD_PB5. */
#define BF_HDMI_FC_GMD_PB5_FC_GMD_PB5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB5_FC_GMD_PB5) & BM_HDMI_FC_GMD_PB5_FC_GMD_PB5)

/*! @brief Set the FC_GMD_PB5 field to a new value. */
#define BW_HDMI_FC_GMD_PB5_FC_GMD_PB5(x, v) (HW_HDMI_FC_GMD_PB5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB6 - Frame Composer GMD Packet Body Register 6
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB6 - Frame Composer GMD Packet Body Register 6 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte6 Address Offset: 0x110b Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb6
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb6_bitfields
    {
        uint8_t FC_GMD_PB6 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB6 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB6_ADDR(x) ((uintptr_t)(x) + 0x110BU)

#define HW_HDMI_FC_GMD_PB6(x)    (*(__IO hw_hdmi_fc_gmd_pb6_t *) HW_HDMI_FC_GMD_PB6_ADDR(x))
#define HW_HDMI_FC_GMD_PB6_RD(x) (HW_HDMI_FC_GMD_PB6(x).U)
#define HW_HDMI_FC_GMD_PB6_WR(x, v) (HW_HDMI_FC_GMD_PB6(x).U = (v))
#define HW_HDMI_FC_GMD_PB6_SET(x, v) (HW_HDMI_FC_GMD_PB6_WR(x, HW_HDMI_FC_GMD_PB6_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB6_CLR(x, v) (HW_HDMI_FC_GMD_PB6_WR(x, HW_HDMI_FC_GMD_PB6_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB6_TOG(x, v) (HW_HDMI_FC_GMD_PB6_WR(x, HW_HDMI_FC_GMD_PB6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB6 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB6, field FC_GMD_PB6[7:0] (RW)
 *
 * Gamut Metadata packet byte6
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB6_FC_GMD_PB6 (0U) /*!< Bit position for HDMI_FC_GMD_PB6_FC_GMD_PB6. */
#define BM_HDMI_FC_GMD_PB6_FC_GMD_PB6 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB6_FC_GMD_PB6. */
#define BS_HDMI_FC_GMD_PB6_FC_GMD_PB6 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB6_FC_GMD_PB6. */

/*! @brief Read current value of the HDMI_FC_GMD_PB6_FC_GMD_PB6 field. */
#define BR_HDMI_FC_GMD_PB6_FC_GMD_PB6(x) (HW_HDMI_FC_GMD_PB6(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB6_FC_GMD_PB6. */
#define BF_HDMI_FC_GMD_PB6_FC_GMD_PB6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB6_FC_GMD_PB6) & BM_HDMI_FC_GMD_PB6_FC_GMD_PB6)

/*! @brief Set the FC_GMD_PB6 field to a new value. */
#define BW_HDMI_FC_GMD_PB6_FC_GMD_PB6(x, v) (HW_HDMI_FC_GMD_PB6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB7 - Frame Composer GMD Packet Body Register 7
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB7 - Frame Composer GMD Packet Body Register 7 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte7 Address Offset: 0x110c Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb7
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb7_bitfields
    {
        uint8_t FC_GMD_PB2 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB7 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB7_ADDR(x) ((uintptr_t)(x) + 0x110CU)

#define HW_HDMI_FC_GMD_PB7(x)    (*(__IO hw_hdmi_fc_gmd_pb7_t *) HW_HDMI_FC_GMD_PB7_ADDR(x))
#define HW_HDMI_FC_GMD_PB7_RD(x) (HW_HDMI_FC_GMD_PB7(x).U)
#define HW_HDMI_FC_GMD_PB7_WR(x, v) (HW_HDMI_FC_GMD_PB7(x).U = (v))
#define HW_HDMI_FC_GMD_PB7_SET(x, v) (HW_HDMI_FC_GMD_PB7_WR(x, HW_HDMI_FC_GMD_PB7_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB7_CLR(x, v) (HW_HDMI_FC_GMD_PB7_WR(x, HW_HDMI_FC_GMD_PB7_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB7_TOG(x, v) (HW_HDMI_FC_GMD_PB7_WR(x, HW_HDMI_FC_GMD_PB7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB7 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB7, field FC_GMD_PB2[7:0] (RW)
 *
 * Gamut Metadata packet byte7
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB7_FC_GMD_PB2 (0U) /*!< Bit position for HDMI_FC_GMD_PB7_FC_GMD_PB2. */
#define BM_HDMI_FC_GMD_PB7_FC_GMD_PB2 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB7_FC_GMD_PB2. */
#define BS_HDMI_FC_GMD_PB7_FC_GMD_PB2 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB7_FC_GMD_PB2. */

/*! @brief Read current value of the HDMI_FC_GMD_PB7_FC_GMD_PB2 field. */
#define BR_HDMI_FC_GMD_PB7_FC_GMD_PB2(x) (HW_HDMI_FC_GMD_PB7(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB7_FC_GMD_PB2. */
#define BF_HDMI_FC_GMD_PB7_FC_GMD_PB2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB7_FC_GMD_PB2) & BM_HDMI_FC_GMD_PB7_FC_GMD_PB2)

/*! @brief Set the FC_GMD_PB2 field to a new value. */
#define BW_HDMI_FC_GMD_PB7_FC_GMD_PB2(x, v) (HW_HDMI_FC_GMD_PB7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB8 - Frame Composer GMD Packet Body Register 8
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB8 - Frame Composer GMD Packet Body Register 8 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte8 Address Offset: 0x110d Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb8
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb8_bitfields
    {
        uint8_t FC_GMD_PB8 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb8_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB8 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB8_ADDR(x) ((uintptr_t)(x) + 0x110DU)

#define HW_HDMI_FC_GMD_PB8(x)    (*(__IO hw_hdmi_fc_gmd_pb8_t *) HW_HDMI_FC_GMD_PB8_ADDR(x))
#define HW_HDMI_FC_GMD_PB8_RD(x) (HW_HDMI_FC_GMD_PB8(x).U)
#define HW_HDMI_FC_GMD_PB8_WR(x, v) (HW_HDMI_FC_GMD_PB8(x).U = (v))
#define HW_HDMI_FC_GMD_PB8_SET(x, v) (HW_HDMI_FC_GMD_PB8_WR(x, HW_HDMI_FC_GMD_PB8_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB8_CLR(x, v) (HW_HDMI_FC_GMD_PB8_WR(x, HW_HDMI_FC_GMD_PB8_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB8_TOG(x, v) (HW_HDMI_FC_GMD_PB8_WR(x, HW_HDMI_FC_GMD_PB8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB8 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB8, field FC_GMD_PB8[7:0] (RW)
 *
 * Gamut Metadata packet byte8
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB8_FC_GMD_PB8 (0U) /*!< Bit position for HDMI_FC_GMD_PB8_FC_GMD_PB8. */
#define BM_HDMI_FC_GMD_PB8_FC_GMD_PB8 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB8_FC_GMD_PB8. */
#define BS_HDMI_FC_GMD_PB8_FC_GMD_PB8 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB8_FC_GMD_PB8. */

/*! @brief Read current value of the HDMI_FC_GMD_PB8_FC_GMD_PB8 field. */
#define BR_HDMI_FC_GMD_PB8_FC_GMD_PB8(x) (HW_HDMI_FC_GMD_PB8(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB8_FC_GMD_PB8. */
#define BF_HDMI_FC_GMD_PB8_FC_GMD_PB8(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB8_FC_GMD_PB8) & BM_HDMI_FC_GMD_PB8_FC_GMD_PB8)

/*! @brief Set the FC_GMD_PB8 field to a new value. */
#define BW_HDMI_FC_GMD_PB8_FC_GMD_PB8(x, v) (HW_HDMI_FC_GMD_PB8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB9 - Frame Composer GMD Packet Body Register 9
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB9 - Frame Composer GMD Packet Body Register 9 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte9 Address Offset: 0x110e Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb9
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb9_bitfields
    {
        uint8_t FC_GMD_PB9 : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb9_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB9 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB9_ADDR(x) ((uintptr_t)(x) + 0x110EU)

#define HW_HDMI_FC_GMD_PB9(x)    (*(__IO hw_hdmi_fc_gmd_pb9_t *) HW_HDMI_FC_GMD_PB9_ADDR(x))
#define HW_HDMI_FC_GMD_PB9_RD(x) (HW_HDMI_FC_GMD_PB9(x).U)
#define HW_HDMI_FC_GMD_PB9_WR(x, v) (HW_HDMI_FC_GMD_PB9(x).U = (v))
#define HW_HDMI_FC_GMD_PB9_SET(x, v) (HW_HDMI_FC_GMD_PB9_WR(x, HW_HDMI_FC_GMD_PB9_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB9_CLR(x, v) (HW_HDMI_FC_GMD_PB9_WR(x, HW_HDMI_FC_GMD_PB9_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB9_TOG(x, v) (HW_HDMI_FC_GMD_PB9_WR(x, HW_HDMI_FC_GMD_PB9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB9 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB9, field FC_GMD_PB9[7:0] (RW)
 *
 * Gamut Metadata packet byte9
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB9_FC_GMD_PB9 (0U) /*!< Bit position for HDMI_FC_GMD_PB9_FC_GMD_PB9. */
#define BM_HDMI_FC_GMD_PB9_FC_GMD_PB9 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB9_FC_GMD_PB9. */
#define BS_HDMI_FC_GMD_PB9_FC_GMD_PB9 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB9_FC_GMD_PB9. */

/*! @brief Read current value of the HDMI_FC_GMD_PB9_FC_GMD_PB9 field. */
#define BR_HDMI_FC_GMD_PB9_FC_GMD_PB9(x) (HW_HDMI_FC_GMD_PB9(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB9_FC_GMD_PB9. */
#define BF_HDMI_FC_GMD_PB9_FC_GMD_PB9(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB9_FC_GMD_PB9) & BM_HDMI_FC_GMD_PB9_FC_GMD_PB9)

/*! @brief Set the FC_GMD_PB9 field to a new value. */
#define BW_HDMI_FC_GMD_PB9_FC_GMD_PB9(x, v) (HW_HDMI_FC_GMD_PB9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB10 - Frame Composer GMD Packet Body Register 10
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB10 - Frame Composer GMD Packet Body Register 10 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte10 Address Offset: 0x110f Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb10
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb10_bitfields
    {
        uint8_t FC_GMD_PB10 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb10_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB10 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB10_ADDR(x) ((uintptr_t)(x) + 0x110FU)

#define HW_HDMI_FC_GMD_PB10(x)   (*(__IO hw_hdmi_fc_gmd_pb10_t *) HW_HDMI_FC_GMD_PB10_ADDR(x))
#define HW_HDMI_FC_GMD_PB10_RD(x) (HW_HDMI_FC_GMD_PB10(x).U)
#define HW_HDMI_FC_GMD_PB10_WR(x, v) (HW_HDMI_FC_GMD_PB10(x).U = (v))
#define HW_HDMI_FC_GMD_PB10_SET(x, v) (HW_HDMI_FC_GMD_PB10_WR(x, HW_HDMI_FC_GMD_PB10_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB10_CLR(x, v) (HW_HDMI_FC_GMD_PB10_WR(x, HW_HDMI_FC_GMD_PB10_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB10_TOG(x, v) (HW_HDMI_FC_GMD_PB10_WR(x, HW_HDMI_FC_GMD_PB10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB10 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB10, field FC_GMD_PB10[7:0] (RW)
 *
 * Gamut Metadata packet byte10
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB10_FC_GMD_PB10 (0U) /*!< Bit position for HDMI_FC_GMD_PB10_FC_GMD_PB10. */
#define BM_HDMI_FC_GMD_PB10_FC_GMD_PB10 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB10_FC_GMD_PB10. */
#define BS_HDMI_FC_GMD_PB10_FC_GMD_PB10 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB10_FC_GMD_PB10. */

/*! @brief Read current value of the HDMI_FC_GMD_PB10_FC_GMD_PB10 field. */
#define BR_HDMI_FC_GMD_PB10_FC_GMD_PB10(x) (HW_HDMI_FC_GMD_PB10(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB10_FC_GMD_PB10. */
#define BF_HDMI_FC_GMD_PB10_FC_GMD_PB10(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB10_FC_GMD_PB10) & BM_HDMI_FC_GMD_PB10_FC_GMD_PB10)

/*! @brief Set the FC_GMD_PB10 field to a new value. */
#define BW_HDMI_FC_GMD_PB10_FC_GMD_PB10(x, v) (HW_HDMI_FC_GMD_PB10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB11 - Frame Composer GMD Packet Body Register 11
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB11 - Frame Composer GMD Packet Body Register 11 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte11 Address Offset: 0x1110 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb11
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb11_bitfields
    {
        uint8_t FC_GMD_PB11 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb11_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB11 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB11_ADDR(x) ((uintptr_t)(x) + 0x1110U)

#define HW_HDMI_FC_GMD_PB11(x)   (*(__IO hw_hdmi_fc_gmd_pb11_t *) HW_HDMI_FC_GMD_PB11_ADDR(x))
#define HW_HDMI_FC_GMD_PB11_RD(x) (HW_HDMI_FC_GMD_PB11(x).U)
#define HW_HDMI_FC_GMD_PB11_WR(x, v) (HW_HDMI_FC_GMD_PB11(x).U = (v))
#define HW_HDMI_FC_GMD_PB11_SET(x, v) (HW_HDMI_FC_GMD_PB11_WR(x, HW_HDMI_FC_GMD_PB11_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB11_CLR(x, v) (HW_HDMI_FC_GMD_PB11_WR(x, HW_HDMI_FC_GMD_PB11_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB11_TOG(x, v) (HW_HDMI_FC_GMD_PB11_WR(x, HW_HDMI_FC_GMD_PB11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB11 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB11, field FC_GMD_PB11[7:0] (RW)
 *
 * Gamut Metadata packet byte11
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB11_FC_GMD_PB11 (0U) /*!< Bit position for HDMI_FC_GMD_PB11_FC_GMD_PB11. */
#define BM_HDMI_FC_GMD_PB11_FC_GMD_PB11 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB11_FC_GMD_PB11. */
#define BS_HDMI_FC_GMD_PB11_FC_GMD_PB11 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB11_FC_GMD_PB11. */

/*! @brief Read current value of the HDMI_FC_GMD_PB11_FC_GMD_PB11 field. */
#define BR_HDMI_FC_GMD_PB11_FC_GMD_PB11(x) (HW_HDMI_FC_GMD_PB11(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB11_FC_GMD_PB11. */
#define BF_HDMI_FC_GMD_PB11_FC_GMD_PB11(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB11_FC_GMD_PB11) & BM_HDMI_FC_GMD_PB11_FC_GMD_PB11)

/*! @brief Set the FC_GMD_PB11 field to a new value. */
#define BW_HDMI_FC_GMD_PB11_FC_GMD_PB11(x, v) (HW_HDMI_FC_GMD_PB11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB12 - Frame Composer GMD Packet Body Register 12
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB12 - Frame Composer GMD Packet Body Register 12 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte12 Address Offset: 0x1111 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb12
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb12_bitfields
    {
        uint8_t FC_GMD_PB12 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb12_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB12 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB12_ADDR(x) ((uintptr_t)(x) + 0x1111U)

#define HW_HDMI_FC_GMD_PB12(x)   (*(__IO hw_hdmi_fc_gmd_pb12_t *) HW_HDMI_FC_GMD_PB12_ADDR(x))
#define HW_HDMI_FC_GMD_PB12_RD(x) (HW_HDMI_FC_GMD_PB12(x).U)
#define HW_HDMI_FC_GMD_PB12_WR(x, v) (HW_HDMI_FC_GMD_PB12(x).U = (v))
#define HW_HDMI_FC_GMD_PB12_SET(x, v) (HW_HDMI_FC_GMD_PB12_WR(x, HW_HDMI_FC_GMD_PB12_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB12_CLR(x, v) (HW_HDMI_FC_GMD_PB12_WR(x, HW_HDMI_FC_GMD_PB12_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB12_TOG(x, v) (HW_HDMI_FC_GMD_PB12_WR(x, HW_HDMI_FC_GMD_PB12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB12 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB12, field FC_GMD_PB12[7:0] (RW)
 *
 * Gamut Metadata packet byte12
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB12_FC_GMD_PB12 (0U) /*!< Bit position for HDMI_FC_GMD_PB12_FC_GMD_PB12. */
#define BM_HDMI_FC_GMD_PB12_FC_GMD_PB12 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB12_FC_GMD_PB12. */
#define BS_HDMI_FC_GMD_PB12_FC_GMD_PB12 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB12_FC_GMD_PB12. */

/*! @brief Read current value of the HDMI_FC_GMD_PB12_FC_GMD_PB12 field. */
#define BR_HDMI_FC_GMD_PB12_FC_GMD_PB12(x) (HW_HDMI_FC_GMD_PB12(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB12_FC_GMD_PB12. */
#define BF_HDMI_FC_GMD_PB12_FC_GMD_PB12(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB12_FC_GMD_PB12) & BM_HDMI_FC_GMD_PB12_FC_GMD_PB12)

/*! @brief Set the FC_GMD_PB12 field to a new value. */
#define BW_HDMI_FC_GMD_PB12_FC_GMD_PB12(x, v) (HW_HDMI_FC_GMD_PB12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB13 - Frame Composer GMD Packet Body Register 13
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB13 - Frame Composer GMD Packet Body Register 13 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte13 Address Offset: 0x1112 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb13
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb13_bitfields
    {
        uint8_t FC_GMD_PB13 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb13_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB13 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB13_ADDR(x) ((uintptr_t)(x) + 0x1112U)

#define HW_HDMI_FC_GMD_PB13(x)   (*(__IO hw_hdmi_fc_gmd_pb13_t *) HW_HDMI_FC_GMD_PB13_ADDR(x))
#define HW_HDMI_FC_GMD_PB13_RD(x) (HW_HDMI_FC_GMD_PB13(x).U)
#define HW_HDMI_FC_GMD_PB13_WR(x, v) (HW_HDMI_FC_GMD_PB13(x).U = (v))
#define HW_HDMI_FC_GMD_PB13_SET(x, v) (HW_HDMI_FC_GMD_PB13_WR(x, HW_HDMI_FC_GMD_PB13_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB13_CLR(x, v) (HW_HDMI_FC_GMD_PB13_WR(x, HW_HDMI_FC_GMD_PB13_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB13_TOG(x, v) (HW_HDMI_FC_GMD_PB13_WR(x, HW_HDMI_FC_GMD_PB13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB13 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB13, field FC_GMD_PB13[7:0] (RW)
 *
 * Gamut Metadata packet byte13
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB13_FC_GMD_PB13 (0U) /*!< Bit position for HDMI_FC_GMD_PB13_FC_GMD_PB13. */
#define BM_HDMI_FC_GMD_PB13_FC_GMD_PB13 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB13_FC_GMD_PB13. */
#define BS_HDMI_FC_GMD_PB13_FC_GMD_PB13 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB13_FC_GMD_PB13. */

/*! @brief Read current value of the HDMI_FC_GMD_PB13_FC_GMD_PB13 field. */
#define BR_HDMI_FC_GMD_PB13_FC_GMD_PB13(x) (HW_HDMI_FC_GMD_PB13(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB13_FC_GMD_PB13. */
#define BF_HDMI_FC_GMD_PB13_FC_GMD_PB13(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB13_FC_GMD_PB13) & BM_HDMI_FC_GMD_PB13_FC_GMD_PB13)

/*! @brief Set the FC_GMD_PB13 field to a new value. */
#define BW_HDMI_FC_GMD_PB13_FC_GMD_PB13(x, v) (HW_HDMI_FC_GMD_PB13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB14 - Frame Composer GMD Packet Body Register 14
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB14 - Frame Composer GMD Packet Body Register 14 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte14 Address Offset: 0x1113 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb14
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb14_bitfields
    {
        uint8_t FC_GMD_PB14 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb14_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB14 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB14_ADDR(x) ((uintptr_t)(x) + 0x1113U)

#define HW_HDMI_FC_GMD_PB14(x)   (*(__IO hw_hdmi_fc_gmd_pb14_t *) HW_HDMI_FC_GMD_PB14_ADDR(x))
#define HW_HDMI_FC_GMD_PB14_RD(x) (HW_HDMI_FC_GMD_PB14(x).U)
#define HW_HDMI_FC_GMD_PB14_WR(x, v) (HW_HDMI_FC_GMD_PB14(x).U = (v))
#define HW_HDMI_FC_GMD_PB14_SET(x, v) (HW_HDMI_FC_GMD_PB14_WR(x, HW_HDMI_FC_GMD_PB14_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB14_CLR(x, v) (HW_HDMI_FC_GMD_PB14_WR(x, HW_HDMI_FC_GMD_PB14_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB14_TOG(x, v) (HW_HDMI_FC_GMD_PB14_WR(x, HW_HDMI_FC_GMD_PB14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB14 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB14, field FC_GMD_PB14[7:0] (RW)
 *
 * Gamut Metadata packet byte14
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB14_FC_GMD_PB14 (0U) /*!< Bit position for HDMI_FC_GMD_PB14_FC_GMD_PB14. */
#define BM_HDMI_FC_GMD_PB14_FC_GMD_PB14 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB14_FC_GMD_PB14. */
#define BS_HDMI_FC_GMD_PB14_FC_GMD_PB14 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB14_FC_GMD_PB14. */

/*! @brief Read current value of the HDMI_FC_GMD_PB14_FC_GMD_PB14 field. */
#define BR_HDMI_FC_GMD_PB14_FC_GMD_PB14(x) (HW_HDMI_FC_GMD_PB14(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB14_FC_GMD_PB14. */
#define BF_HDMI_FC_GMD_PB14_FC_GMD_PB14(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB14_FC_GMD_PB14) & BM_HDMI_FC_GMD_PB14_FC_GMD_PB14)

/*! @brief Set the FC_GMD_PB14 field to a new value. */
#define BW_HDMI_FC_GMD_PB14_FC_GMD_PB14(x, v) (HW_HDMI_FC_GMD_PB14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB15 - Frame Composer GMD Packet Body Register 15
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB15 - Frame Composer GMD Packet Body Register 15 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte15 Address Offset: 0x1114 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb15
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb15_bitfields
    {
        uint8_t FC_GMD_PB15 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb15_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB15 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB15_ADDR(x) ((uintptr_t)(x) + 0x1114U)

#define HW_HDMI_FC_GMD_PB15(x)   (*(__IO hw_hdmi_fc_gmd_pb15_t *) HW_HDMI_FC_GMD_PB15_ADDR(x))
#define HW_HDMI_FC_GMD_PB15_RD(x) (HW_HDMI_FC_GMD_PB15(x).U)
#define HW_HDMI_FC_GMD_PB15_WR(x, v) (HW_HDMI_FC_GMD_PB15(x).U = (v))
#define HW_HDMI_FC_GMD_PB15_SET(x, v) (HW_HDMI_FC_GMD_PB15_WR(x, HW_HDMI_FC_GMD_PB15_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB15_CLR(x, v) (HW_HDMI_FC_GMD_PB15_WR(x, HW_HDMI_FC_GMD_PB15_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB15_TOG(x, v) (HW_HDMI_FC_GMD_PB15_WR(x, HW_HDMI_FC_GMD_PB15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB15 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB15, field FC_GMD_PB15[7:0] (RW)
 *
 * Gamut Metadata packet byte15
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB15_FC_GMD_PB15 (0U) /*!< Bit position for HDMI_FC_GMD_PB15_FC_GMD_PB15. */
#define BM_HDMI_FC_GMD_PB15_FC_GMD_PB15 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB15_FC_GMD_PB15. */
#define BS_HDMI_FC_GMD_PB15_FC_GMD_PB15 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB15_FC_GMD_PB15. */

/*! @brief Read current value of the HDMI_FC_GMD_PB15_FC_GMD_PB15 field. */
#define BR_HDMI_FC_GMD_PB15_FC_GMD_PB15(x) (HW_HDMI_FC_GMD_PB15(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB15_FC_GMD_PB15. */
#define BF_HDMI_FC_GMD_PB15_FC_GMD_PB15(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB15_FC_GMD_PB15) & BM_HDMI_FC_GMD_PB15_FC_GMD_PB15)

/*! @brief Set the FC_GMD_PB15 field to a new value. */
#define BW_HDMI_FC_GMD_PB15_FC_GMD_PB15(x, v) (HW_HDMI_FC_GMD_PB15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB16 - Frame Composer GMD Packet Body Register 16
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB16 - Frame Composer GMD Packet Body Register 16 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte16 Address Offset: 0x1115 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb16
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb16_bitfields
    {
        uint8_t FC_GMD_PB16 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb16_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB16 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB16_ADDR(x) ((uintptr_t)(x) + 0x1115U)

#define HW_HDMI_FC_GMD_PB16(x)   (*(__IO hw_hdmi_fc_gmd_pb16_t *) HW_HDMI_FC_GMD_PB16_ADDR(x))
#define HW_HDMI_FC_GMD_PB16_RD(x) (HW_HDMI_FC_GMD_PB16(x).U)
#define HW_HDMI_FC_GMD_PB16_WR(x, v) (HW_HDMI_FC_GMD_PB16(x).U = (v))
#define HW_HDMI_FC_GMD_PB16_SET(x, v) (HW_HDMI_FC_GMD_PB16_WR(x, HW_HDMI_FC_GMD_PB16_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB16_CLR(x, v) (HW_HDMI_FC_GMD_PB16_WR(x, HW_HDMI_FC_GMD_PB16_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB16_TOG(x, v) (HW_HDMI_FC_GMD_PB16_WR(x, HW_HDMI_FC_GMD_PB16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB16 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB16, field FC_GMD_PB16[7:0] (RW)
 *
 * Gamut Metadata packet byte16
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB16_FC_GMD_PB16 (0U) /*!< Bit position for HDMI_FC_GMD_PB16_FC_GMD_PB16. */
#define BM_HDMI_FC_GMD_PB16_FC_GMD_PB16 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB16_FC_GMD_PB16. */
#define BS_HDMI_FC_GMD_PB16_FC_GMD_PB16 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB16_FC_GMD_PB16. */

/*! @brief Read current value of the HDMI_FC_GMD_PB16_FC_GMD_PB16 field. */
#define BR_HDMI_FC_GMD_PB16_FC_GMD_PB16(x) (HW_HDMI_FC_GMD_PB16(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB16_FC_GMD_PB16. */
#define BF_HDMI_FC_GMD_PB16_FC_GMD_PB16(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB16_FC_GMD_PB16) & BM_HDMI_FC_GMD_PB16_FC_GMD_PB16)

/*! @brief Set the FC_GMD_PB16 field to a new value. */
#define BW_HDMI_FC_GMD_PB16_FC_GMD_PB16(x, v) (HW_HDMI_FC_GMD_PB16_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB17 - Frame Composer GMD Packet Body Register 17
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB17 - Frame Composer GMD Packet Body Register 17 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte17 Address Offset: 0x1116 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb17
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb17_bitfields
    {
        uint8_t FC_GMD_PB17 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb17_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB17 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB17_ADDR(x) ((uintptr_t)(x) + 0x1116U)

#define HW_HDMI_FC_GMD_PB17(x)   (*(__IO hw_hdmi_fc_gmd_pb17_t *) HW_HDMI_FC_GMD_PB17_ADDR(x))
#define HW_HDMI_FC_GMD_PB17_RD(x) (HW_HDMI_FC_GMD_PB17(x).U)
#define HW_HDMI_FC_GMD_PB17_WR(x, v) (HW_HDMI_FC_GMD_PB17(x).U = (v))
#define HW_HDMI_FC_GMD_PB17_SET(x, v) (HW_HDMI_FC_GMD_PB17_WR(x, HW_HDMI_FC_GMD_PB17_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB17_CLR(x, v) (HW_HDMI_FC_GMD_PB17_WR(x, HW_HDMI_FC_GMD_PB17_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB17_TOG(x, v) (HW_HDMI_FC_GMD_PB17_WR(x, HW_HDMI_FC_GMD_PB17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB17 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB17, field FC_GMD_PB17[7:0] (RW)
 *
 * Gamut Metadata packet byte17
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB17_FC_GMD_PB17 (0U) /*!< Bit position for HDMI_FC_GMD_PB17_FC_GMD_PB17. */
#define BM_HDMI_FC_GMD_PB17_FC_GMD_PB17 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB17_FC_GMD_PB17. */
#define BS_HDMI_FC_GMD_PB17_FC_GMD_PB17 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB17_FC_GMD_PB17. */

/*! @brief Read current value of the HDMI_FC_GMD_PB17_FC_GMD_PB17 field. */
#define BR_HDMI_FC_GMD_PB17_FC_GMD_PB17(x) (HW_HDMI_FC_GMD_PB17(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB17_FC_GMD_PB17. */
#define BF_HDMI_FC_GMD_PB17_FC_GMD_PB17(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB17_FC_GMD_PB17) & BM_HDMI_FC_GMD_PB17_FC_GMD_PB17)

/*! @brief Set the FC_GMD_PB17 field to a new value. */
#define BW_HDMI_FC_GMD_PB17_FC_GMD_PB17(x, v) (HW_HDMI_FC_GMD_PB17_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB18 - Frame Composer GMD Packet Body Register 18
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB18 - Frame Composer GMD Packet Body Register 18 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte18 Address Offset: 0x1117 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb18
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb18_bitfields
    {
        uint8_t FC_GMD_PB18 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb18_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB18 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB18_ADDR(x) ((uintptr_t)(x) + 0x1117U)

#define HW_HDMI_FC_GMD_PB18(x)   (*(__IO hw_hdmi_fc_gmd_pb18_t *) HW_HDMI_FC_GMD_PB18_ADDR(x))
#define HW_HDMI_FC_GMD_PB18_RD(x) (HW_HDMI_FC_GMD_PB18(x).U)
#define HW_HDMI_FC_GMD_PB18_WR(x, v) (HW_HDMI_FC_GMD_PB18(x).U = (v))
#define HW_HDMI_FC_GMD_PB18_SET(x, v) (HW_HDMI_FC_GMD_PB18_WR(x, HW_HDMI_FC_GMD_PB18_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB18_CLR(x, v) (HW_HDMI_FC_GMD_PB18_WR(x, HW_HDMI_FC_GMD_PB18_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB18_TOG(x, v) (HW_HDMI_FC_GMD_PB18_WR(x, HW_HDMI_FC_GMD_PB18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB18 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB18, field FC_GMD_PB18[7:0] (RW)
 *
 * Gamut Metadata packet byte18
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB18_FC_GMD_PB18 (0U) /*!< Bit position for HDMI_FC_GMD_PB18_FC_GMD_PB18. */
#define BM_HDMI_FC_GMD_PB18_FC_GMD_PB18 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB18_FC_GMD_PB18. */
#define BS_HDMI_FC_GMD_PB18_FC_GMD_PB18 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB18_FC_GMD_PB18. */

/*! @brief Read current value of the HDMI_FC_GMD_PB18_FC_GMD_PB18 field. */
#define BR_HDMI_FC_GMD_PB18_FC_GMD_PB18(x) (HW_HDMI_FC_GMD_PB18(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB18_FC_GMD_PB18. */
#define BF_HDMI_FC_GMD_PB18_FC_GMD_PB18(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB18_FC_GMD_PB18) & BM_HDMI_FC_GMD_PB18_FC_GMD_PB18)

/*! @brief Set the FC_GMD_PB18 field to a new value. */
#define BW_HDMI_FC_GMD_PB18_FC_GMD_PB18(x, v) (HW_HDMI_FC_GMD_PB18_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB19 - Frame Composer GMD Packet Body Register 19
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB19 - Frame Composer GMD Packet Body Register 19 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte19 Address Offset: 0x1118 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb19
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb19_bitfields
    {
        uint8_t FC_GMD_PB18 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb19_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB19 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB19_ADDR(x) ((uintptr_t)(x) + 0x1118U)

#define HW_HDMI_FC_GMD_PB19(x)   (*(__IO hw_hdmi_fc_gmd_pb19_t *) HW_HDMI_FC_GMD_PB19_ADDR(x))
#define HW_HDMI_FC_GMD_PB19_RD(x) (HW_HDMI_FC_GMD_PB19(x).U)
#define HW_HDMI_FC_GMD_PB19_WR(x, v) (HW_HDMI_FC_GMD_PB19(x).U = (v))
#define HW_HDMI_FC_GMD_PB19_SET(x, v) (HW_HDMI_FC_GMD_PB19_WR(x, HW_HDMI_FC_GMD_PB19_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB19_CLR(x, v) (HW_HDMI_FC_GMD_PB19_WR(x, HW_HDMI_FC_GMD_PB19_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB19_TOG(x, v) (HW_HDMI_FC_GMD_PB19_WR(x, HW_HDMI_FC_GMD_PB19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB19 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB19, field FC_GMD_PB18[7:0] (RW)
 *
 * Gamut Metadata packet byte18
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB19_FC_GMD_PB18 (0U) /*!< Bit position for HDMI_FC_GMD_PB19_FC_GMD_PB18. */
#define BM_HDMI_FC_GMD_PB19_FC_GMD_PB18 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB19_FC_GMD_PB18. */
#define BS_HDMI_FC_GMD_PB19_FC_GMD_PB18 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB19_FC_GMD_PB18. */

/*! @brief Read current value of the HDMI_FC_GMD_PB19_FC_GMD_PB18 field. */
#define BR_HDMI_FC_GMD_PB19_FC_GMD_PB18(x) (HW_HDMI_FC_GMD_PB19(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB19_FC_GMD_PB18. */
#define BF_HDMI_FC_GMD_PB19_FC_GMD_PB18(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB19_FC_GMD_PB18) & BM_HDMI_FC_GMD_PB19_FC_GMD_PB18)

/*! @brief Set the FC_GMD_PB18 field to a new value. */
#define BW_HDMI_FC_GMD_PB19_FC_GMD_PB18(x, v) (HW_HDMI_FC_GMD_PB19_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB20 - Frame Composer GMD Packet Body Register 20
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB20 - Frame Composer GMD Packet Body Register 20 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte20 Address Offset: 0x1119 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb20
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb20_bitfields
    {
        uint8_t FC_GMD_PB20 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb20_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB20 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB20_ADDR(x) ((uintptr_t)(x) + 0x1119U)

#define HW_HDMI_FC_GMD_PB20(x)   (*(__IO hw_hdmi_fc_gmd_pb20_t *) HW_HDMI_FC_GMD_PB20_ADDR(x))
#define HW_HDMI_FC_GMD_PB20_RD(x) (HW_HDMI_FC_GMD_PB20(x).U)
#define HW_HDMI_FC_GMD_PB20_WR(x, v) (HW_HDMI_FC_GMD_PB20(x).U = (v))
#define HW_HDMI_FC_GMD_PB20_SET(x, v) (HW_HDMI_FC_GMD_PB20_WR(x, HW_HDMI_FC_GMD_PB20_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB20_CLR(x, v) (HW_HDMI_FC_GMD_PB20_WR(x, HW_HDMI_FC_GMD_PB20_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB20_TOG(x, v) (HW_HDMI_FC_GMD_PB20_WR(x, HW_HDMI_FC_GMD_PB20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB20 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB20, field FC_GMD_PB20[7:0] (RW)
 *
 * Gamut Metadata packet byte20
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB20_FC_GMD_PB20 (0U) /*!< Bit position for HDMI_FC_GMD_PB20_FC_GMD_PB20. */
#define BM_HDMI_FC_GMD_PB20_FC_GMD_PB20 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB20_FC_GMD_PB20. */
#define BS_HDMI_FC_GMD_PB20_FC_GMD_PB20 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB20_FC_GMD_PB20. */

/*! @brief Read current value of the HDMI_FC_GMD_PB20_FC_GMD_PB20 field. */
#define BR_HDMI_FC_GMD_PB20_FC_GMD_PB20(x) (HW_HDMI_FC_GMD_PB20(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB20_FC_GMD_PB20. */
#define BF_HDMI_FC_GMD_PB20_FC_GMD_PB20(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB20_FC_GMD_PB20) & BM_HDMI_FC_GMD_PB20_FC_GMD_PB20)

/*! @brief Set the FC_GMD_PB20 field to a new value. */
#define BW_HDMI_FC_GMD_PB20_FC_GMD_PB20(x, v) (HW_HDMI_FC_GMD_PB20_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB21 - Frame Composer GMD Packet Body Register 21
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB21 - Frame Composer GMD Packet Body Register 21 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte21 Address Offset: 0x111a Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb21
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb21_bitfields
    {
        uint8_t FC_GMD_PB21 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb21_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB21 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB21_ADDR(x) ((uintptr_t)(x) + 0x111AU)

#define HW_HDMI_FC_GMD_PB21(x)   (*(__IO hw_hdmi_fc_gmd_pb21_t *) HW_HDMI_FC_GMD_PB21_ADDR(x))
#define HW_HDMI_FC_GMD_PB21_RD(x) (HW_HDMI_FC_GMD_PB21(x).U)
#define HW_HDMI_FC_GMD_PB21_WR(x, v) (HW_HDMI_FC_GMD_PB21(x).U = (v))
#define HW_HDMI_FC_GMD_PB21_SET(x, v) (HW_HDMI_FC_GMD_PB21_WR(x, HW_HDMI_FC_GMD_PB21_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB21_CLR(x, v) (HW_HDMI_FC_GMD_PB21_WR(x, HW_HDMI_FC_GMD_PB21_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB21_TOG(x, v) (HW_HDMI_FC_GMD_PB21_WR(x, HW_HDMI_FC_GMD_PB21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB21 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB21, field FC_GMD_PB21[7:0] (RW)
 *
 * Gamut Metadata packet byte21
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB21_FC_GMD_PB21 (0U) /*!< Bit position for HDMI_FC_GMD_PB21_FC_GMD_PB21. */
#define BM_HDMI_FC_GMD_PB21_FC_GMD_PB21 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB21_FC_GMD_PB21. */
#define BS_HDMI_FC_GMD_PB21_FC_GMD_PB21 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB21_FC_GMD_PB21. */

/*! @brief Read current value of the HDMI_FC_GMD_PB21_FC_GMD_PB21 field. */
#define BR_HDMI_FC_GMD_PB21_FC_GMD_PB21(x) (HW_HDMI_FC_GMD_PB21(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB21_FC_GMD_PB21. */
#define BF_HDMI_FC_GMD_PB21_FC_GMD_PB21(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB21_FC_GMD_PB21) & BM_HDMI_FC_GMD_PB21_FC_GMD_PB21)

/*! @brief Set the FC_GMD_PB21 field to a new value. */
#define BW_HDMI_FC_GMD_PB21_FC_GMD_PB21(x, v) (HW_HDMI_FC_GMD_PB21_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB22 - Frame Composer GMD Packet Body Register 22
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB22 - Frame Composer GMD Packet Body Register 22 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte22 Address Offset: 0x111b Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb22
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb22_bitfields
    {
        uint8_t FC_GMD_PB22 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb22_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB22 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB22_ADDR(x) ((uintptr_t)(x) + 0x111BU)

#define HW_HDMI_FC_GMD_PB22(x)   (*(__IO hw_hdmi_fc_gmd_pb22_t *) HW_HDMI_FC_GMD_PB22_ADDR(x))
#define HW_HDMI_FC_GMD_PB22_RD(x) (HW_HDMI_FC_GMD_PB22(x).U)
#define HW_HDMI_FC_GMD_PB22_WR(x, v) (HW_HDMI_FC_GMD_PB22(x).U = (v))
#define HW_HDMI_FC_GMD_PB22_SET(x, v) (HW_HDMI_FC_GMD_PB22_WR(x, HW_HDMI_FC_GMD_PB22_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB22_CLR(x, v) (HW_HDMI_FC_GMD_PB22_WR(x, HW_HDMI_FC_GMD_PB22_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB22_TOG(x, v) (HW_HDMI_FC_GMD_PB22_WR(x, HW_HDMI_FC_GMD_PB22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB22 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB22, field FC_GMD_PB22[7:0] (RW)
 *
 * Gamut Metadata packet byte22
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB22_FC_GMD_PB22 (0U) /*!< Bit position for HDMI_FC_GMD_PB22_FC_GMD_PB22. */
#define BM_HDMI_FC_GMD_PB22_FC_GMD_PB22 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB22_FC_GMD_PB22. */
#define BS_HDMI_FC_GMD_PB22_FC_GMD_PB22 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB22_FC_GMD_PB22. */

/*! @brief Read current value of the HDMI_FC_GMD_PB22_FC_GMD_PB22 field. */
#define BR_HDMI_FC_GMD_PB22_FC_GMD_PB22(x) (HW_HDMI_FC_GMD_PB22(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB22_FC_GMD_PB22. */
#define BF_HDMI_FC_GMD_PB22_FC_GMD_PB22(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB22_FC_GMD_PB22) & BM_HDMI_FC_GMD_PB22_FC_GMD_PB22)

/*! @brief Set the FC_GMD_PB22 field to a new value. */
#define BW_HDMI_FC_GMD_PB22_FC_GMD_PB22(x, v) (HW_HDMI_FC_GMD_PB22_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB23 - Frame Composer GMD Packet Body Register 23
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB23 - Frame Composer GMD Packet Body Register 23 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte23 Address Offset: 0x111c Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb23
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb23_bitfields
    {
        uint8_t FC_GMD_PB23 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb23_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB23 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB23_ADDR(x) ((uintptr_t)(x) + 0x111CU)

#define HW_HDMI_FC_GMD_PB23(x)   (*(__IO hw_hdmi_fc_gmd_pb23_t *) HW_HDMI_FC_GMD_PB23_ADDR(x))
#define HW_HDMI_FC_GMD_PB23_RD(x) (HW_HDMI_FC_GMD_PB23(x).U)
#define HW_HDMI_FC_GMD_PB23_WR(x, v) (HW_HDMI_FC_GMD_PB23(x).U = (v))
#define HW_HDMI_FC_GMD_PB23_SET(x, v) (HW_HDMI_FC_GMD_PB23_WR(x, HW_HDMI_FC_GMD_PB23_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB23_CLR(x, v) (HW_HDMI_FC_GMD_PB23_WR(x, HW_HDMI_FC_GMD_PB23_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB23_TOG(x, v) (HW_HDMI_FC_GMD_PB23_WR(x, HW_HDMI_FC_GMD_PB23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB23 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB23, field FC_GMD_PB23[7:0] (RW)
 *
 * Gamut Metadata packet byte23
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB23_FC_GMD_PB23 (0U) /*!< Bit position for HDMI_FC_GMD_PB23_FC_GMD_PB23. */
#define BM_HDMI_FC_GMD_PB23_FC_GMD_PB23 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB23_FC_GMD_PB23. */
#define BS_HDMI_FC_GMD_PB23_FC_GMD_PB23 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB23_FC_GMD_PB23. */

/*! @brief Read current value of the HDMI_FC_GMD_PB23_FC_GMD_PB23 field. */
#define BR_HDMI_FC_GMD_PB23_FC_GMD_PB23(x) (HW_HDMI_FC_GMD_PB23(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB23_FC_GMD_PB23. */
#define BF_HDMI_FC_GMD_PB23_FC_GMD_PB23(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB23_FC_GMD_PB23) & BM_HDMI_FC_GMD_PB23_FC_GMD_PB23)

/*! @brief Set the FC_GMD_PB23 field to a new value. */
#define BW_HDMI_FC_GMD_PB23_FC_GMD_PB23(x, v) (HW_HDMI_FC_GMD_PB23_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB24 - Frame Composer GMD Packet Body Register 24
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB24 - Frame Composer GMD Packet Body Register 24 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte24 Address Offset: 0x111d Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb24
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb24_bitfields
    {
        uint8_t FC_GMD_PB24 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb24_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB24 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB24_ADDR(x) ((uintptr_t)(x) + 0x111DU)

#define HW_HDMI_FC_GMD_PB24(x)   (*(__IO hw_hdmi_fc_gmd_pb24_t *) HW_HDMI_FC_GMD_PB24_ADDR(x))
#define HW_HDMI_FC_GMD_PB24_RD(x) (HW_HDMI_FC_GMD_PB24(x).U)
#define HW_HDMI_FC_GMD_PB24_WR(x, v) (HW_HDMI_FC_GMD_PB24(x).U = (v))
#define HW_HDMI_FC_GMD_PB24_SET(x, v) (HW_HDMI_FC_GMD_PB24_WR(x, HW_HDMI_FC_GMD_PB24_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB24_CLR(x, v) (HW_HDMI_FC_GMD_PB24_WR(x, HW_HDMI_FC_GMD_PB24_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB24_TOG(x, v) (HW_HDMI_FC_GMD_PB24_WR(x, HW_HDMI_FC_GMD_PB24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB24 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB24, field FC_GMD_PB24[7:0] (RW)
 *
 * Gamut Metadata packet byte24
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB24_FC_GMD_PB24 (0U) /*!< Bit position for HDMI_FC_GMD_PB24_FC_GMD_PB24. */
#define BM_HDMI_FC_GMD_PB24_FC_GMD_PB24 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB24_FC_GMD_PB24. */
#define BS_HDMI_FC_GMD_PB24_FC_GMD_PB24 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB24_FC_GMD_PB24. */

/*! @brief Read current value of the HDMI_FC_GMD_PB24_FC_GMD_PB24 field. */
#define BR_HDMI_FC_GMD_PB24_FC_GMD_PB24(x) (HW_HDMI_FC_GMD_PB24(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB24_FC_GMD_PB24. */
#define BF_HDMI_FC_GMD_PB24_FC_GMD_PB24(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB24_FC_GMD_PB24) & BM_HDMI_FC_GMD_PB24_FC_GMD_PB24)

/*! @brief Set the FC_GMD_PB24 field to a new value. */
#define BW_HDMI_FC_GMD_PB24_FC_GMD_PB24(x, v) (HW_HDMI_FC_GMD_PB24_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB25 - Frame Composer GMD Packet Body Register 25
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB25 - Frame Composer GMD Packet Body Register 25 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte25 Address Offset: 0x111e Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb25
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb25_bitfields
    {
        uint8_t FC_GMD_PB25 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb25_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB25 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB25_ADDR(x) ((uintptr_t)(x) + 0x111EU)

#define HW_HDMI_FC_GMD_PB25(x)   (*(__IO hw_hdmi_fc_gmd_pb25_t *) HW_HDMI_FC_GMD_PB25_ADDR(x))
#define HW_HDMI_FC_GMD_PB25_RD(x) (HW_HDMI_FC_GMD_PB25(x).U)
#define HW_HDMI_FC_GMD_PB25_WR(x, v) (HW_HDMI_FC_GMD_PB25(x).U = (v))
#define HW_HDMI_FC_GMD_PB25_SET(x, v) (HW_HDMI_FC_GMD_PB25_WR(x, HW_HDMI_FC_GMD_PB25_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB25_CLR(x, v) (HW_HDMI_FC_GMD_PB25_WR(x, HW_HDMI_FC_GMD_PB25_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB25_TOG(x, v) (HW_HDMI_FC_GMD_PB25_WR(x, HW_HDMI_FC_GMD_PB25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB25 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB25, field FC_GMD_PB25[7:0] (RW)
 *
 * Gamut Metadata packet byte25
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB25_FC_GMD_PB25 (0U) /*!< Bit position for HDMI_FC_GMD_PB25_FC_GMD_PB25. */
#define BM_HDMI_FC_GMD_PB25_FC_GMD_PB25 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB25_FC_GMD_PB25. */
#define BS_HDMI_FC_GMD_PB25_FC_GMD_PB25 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB25_FC_GMD_PB25. */

/*! @brief Read current value of the HDMI_FC_GMD_PB25_FC_GMD_PB25 field. */
#define BR_HDMI_FC_GMD_PB25_FC_GMD_PB25(x) (HW_HDMI_FC_GMD_PB25(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB25_FC_GMD_PB25. */
#define BF_HDMI_FC_GMD_PB25_FC_GMD_PB25(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB25_FC_GMD_PB25) & BM_HDMI_FC_GMD_PB25_FC_GMD_PB25)

/*! @brief Set the FC_GMD_PB25 field to a new value. */
#define BW_HDMI_FC_GMD_PB25_FC_GMD_PB25(x, v) (HW_HDMI_FC_GMD_PB25_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB26 - Frame Composer GMD Packet Body Register 26
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB26 - Frame Composer GMD Packet Body Register 26 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte26 Address Offset: 0x111f Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb26
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb26_bitfields
    {
        uint8_t FC_GMD_PB26 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb26_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB26 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB26_ADDR(x) ((uintptr_t)(x) + 0x111FU)

#define HW_HDMI_FC_GMD_PB26(x)   (*(__IO hw_hdmi_fc_gmd_pb26_t *) HW_HDMI_FC_GMD_PB26_ADDR(x))
#define HW_HDMI_FC_GMD_PB26_RD(x) (HW_HDMI_FC_GMD_PB26(x).U)
#define HW_HDMI_FC_GMD_PB26_WR(x, v) (HW_HDMI_FC_GMD_PB26(x).U = (v))
#define HW_HDMI_FC_GMD_PB26_SET(x, v) (HW_HDMI_FC_GMD_PB26_WR(x, HW_HDMI_FC_GMD_PB26_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB26_CLR(x, v) (HW_HDMI_FC_GMD_PB26_WR(x, HW_HDMI_FC_GMD_PB26_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB26_TOG(x, v) (HW_HDMI_FC_GMD_PB26_WR(x, HW_HDMI_FC_GMD_PB26_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB26 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB26, field FC_GMD_PB26[7:0] (RW)
 *
 * Gamut Metadata packet byte26
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB26_FC_GMD_PB26 (0U) /*!< Bit position for HDMI_FC_GMD_PB26_FC_GMD_PB26. */
#define BM_HDMI_FC_GMD_PB26_FC_GMD_PB26 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB26_FC_GMD_PB26. */
#define BS_HDMI_FC_GMD_PB26_FC_GMD_PB26 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB26_FC_GMD_PB26. */

/*! @brief Read current value of the HDMI_FC_GMD_PB26_FC_GMD_PB26 field. */
#define BR_HDMI_FC_GMD_PB26_FC_GMD_PB26(x) (HW_HDMI_FC_GMD_PB26(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB26_FC_GMD_PB26. */
#define BF_HDMI_FC_GMD_PB26_FC_GMD_PB26(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB26_FC_GMD_PB26) & BM_HDMI_FC_GMD_PB26_FC_GMD_PB26)

/*! @brief Set the FC_GMD_PB26 field to a new value. */
#define BW_HDMI_FC_GMD_PB26_FC_GMD_PB26(x, v) (HW_HDMI_FC_GMD_PB26_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_GMD_PB27 - Frame Composer GMD Packet Body Register 27
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_GMD_PB27 - Frame Composer GMD Packet Body Register 27 (RW)
 *
 * Reset value: 0x00U
 *
 * GMD packet body byte27 Address Offset: 0x1120 Size: 8 bits Value after Reset:
 * 0x00 Access: Read/Write For more information, refer to the HDMI 1.4a
 * specification.
 */
typedef union _hw_hdmi_fc_gmd_pb27
{
    uint8_t U;
    struct _hw_hdmi_fc_gmd_pb27_bitfields
    {
        uint8_t FC_GMD_PB27 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_gmd_pb27_t;

/*!
 * @name Constants and macros for entire HDMI_FC_GMD_PB27 register
 */
/*@{*/
#define HW_HDMI_FC_GMD_PB27_ADDR(x) ((uintptr_t)(x) + 0x1120U)

#define HW_HDMI_FC_GMD_PB27(x)   (*(__IO hw_hdmi_fc_gmd_pb27_t *) HW_HDMI_FC_GMD_PB27_ADDR(x))
#define HW_HDMI_FC_GMD_PB27_RD(x) (HW_HDMI_FC_GMD_PB27(x).U)
#define HW_HDMI_FC_GMD_PB27_WR(x, v) (HW_HDMI_FC_GMD_PB27(x).U = (v))
#define HW_HDMI_FC_GMD_PB27_SET(x, v) (HW_HDMI_FC_GMD_PB27_WR(x, HW_HDMI_FC_GMD_PB27_RD(x) |  (v)))
#define HW_HDMI_FC_GMD_PB27_CLR(x, v) (HW_HDMI_FC_GMD_PB27_WR(x, HW_HDMI_FC_GMD_PB27_RD(x) & ~(v)))
#define HW_HDMI_FC_GMD_PB27_TOG(x, v) (HW_HDMI_FC_GMD_PB27_WR(x, HW_HDMI_FC_GMD_PB27_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_GMD_PB27 bitfields
 */

/*!
 * @name Register HDMI_FC_GMD_PB27, field FC_GMD_PB27[7:0] (RW)
 *
 * Gamut Metadata packet byte27
 */
/*@{*/
#define BP_HDMI_FC_GMD_PB27_FC_GMD_PB27 (0U) /*!< Bit position for HDMI_FC_GMD_PB27_FC_GMD_PB27. */
#define BM_HDMI_FC_GMD_PB27_FC_GMD_PB27 (0xFFU) /*!< Bit mask for HDMI_FC_GMD_PB27_FC_GMD_PB27. */
#define BS_HDMI_FC_GMD_PB27_FC_GMD_PB27 (8U) /*!< Bit field size in bits for HDMI_FC_GMD_PB27_FC_GMD_PB27. */

/*! @brief Read current value of the HDMI_FC_GMD_PB27_FC_GMD_PB27 field. */
#define BR_HDMI_FC_GMD_PB27_FC_GMD_PB27(x) (HW_HDMI_FC_GMD_PB27(x).U)

/*! @brief Format value for bitfield HDMI_FC_GMD_PB27_FC_GMD_PB27. */
#define BF_HDMI_FC_GMD_PB27_FC_GMD_PB27(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_GMD_PB27_FC_GMD_PB27) & BM_HDMI_FC_GMD_PB27_FC_GMD_PB27)

/*! @brief Set the FC_GMD_PB27 field to a new value. */
#define BW_HDMI_FC_GMD_PB27_FC_GMD_PB27(x, v) (HW_HDMI_FC_GMD_PB27_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGFORCE - Frame Composer Video/Audio Force Enable Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGFORCE - Frame Composer Video/Audio Force Enable Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register allows to force the controller to output audio and video data
 * the values configured in the FC_DBGAUD and FC_DBGTMDS registers. Address
 * Offset: 0x1200 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgforce
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgforce_bitfields
    {
        uint8_t forcevideo : 1;        /*!< [0]  */
        uint8_t RESERVED0 : 3;         /*!< [3:1]  */
        uint8_t forceaudio : 1;        /*!< [4]  */
        uint8_t RESERVED1 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_fc_dbgforce_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGFORCE register
 */
/*@{*/
#define HW_HDMI_FC_DBGFORCE_ADDR(x) ((uintptr_t)(x) + 0x1200U)

#define HW_HDMI_FC_DBGFORCE(x)   (*(__IO hw_hdmi_fc_dbgforce_t *) HW_HDMI_FC_DBGFORCE_ADDR(x))
#define HW_HDMI_FC_DBGFORCE_RD(x) (HW_HDMI_FC_DBGFORCE(x).U)
#define HW_HDMI_FC_DBGFORCE_WR(x, v) (HW_HDMI_FC_DBGFORCE(x).U = (v))
#define HW_HDMI_FC_DBGFORCE_SET(x, v) (HW_HDMI_FC_DBGFORCE_WR(x, HW_HDMI_FC_DBGFORCE_RD(x) |  (v)))
#define HW_HDMI_FC_DBGFORCE_CLR(x, v) (HW_HDMI_FC_DBGFORCE_WR(x, HW_HDMI_FC_DBGFORCE_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGFORCE_TOG(x, v) (HW_HDMI_FC_DBGFORCE_WR(x, HW_HDMI_FC_DBGFORCE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGFORCE bitfields
 */

/*!
 * @name Register HDMI_FC_DBGFORCE, field forcevideo[0] (RW)
 *
 * Force fixed video output with FC_DBGTMDSx registers contain.
 */
/*@{*/
#define BP_HDMI_FC_DBGFORCE_forcevideo (0U) /*!< Bit position for HDMI_FC_DBGFORCE_forcevideo. */
#define BM_HDMI_FC_DBGFORCE_forcevideo (0x01U) /*!< Bit mask for HDMI_FC_DBGFORCE_forcevideo. */
#define BS_HDMI_FC_DBGFORCE_forcevideo (1U) /*!< Bit field size in bits for HDMI_FC_DBGFORCE_forcevideo. */

/*! @brief Read current value of the HDMI_FC_DBGFORCE_forcevideo field. */
#define BR_HDMI_FC_DBGFORCE_forcevideo(x) (HW_HDMI_FC_DBGFORCE(x).B.forcevideo)

/*! @brief Format value for bitfield HDMI_FC_DBGFORCE_forcevideo. */
#define BF_HDMI_FC_DBGFORCE_forcevideo(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGFORCE_forcevideo) & BM_HDMI_FC_DBGFORCE_forcevideo)

/*! @brief Set the forcevideo field to a new value. */
#define BW_HDMI_FC_DBGFORCE_forcevideo(x, v) (HW_HDMI_FC_DBGFORCE_WR(x, (HW_HDMI_FC_DBGFORCE_RD(x) & ~BM_HDMI_FC_DBGFORCE_forcevideo) | BF_HDMI_FC_DBGFORCE_forcevideo(v)))
/*@}*/

/*!
 * @name Register HDMI_FC_DBGFORCE, field forceaudio[4] (RW)
 *
 * Force fixed audio output with FC_DBGAUDxCHx registers contain.
 */
/*@{*/
#define BP_HDMI_FC_DBGFORCE_forceaudio (4U) /*!< Bit position for HDMI_FC_DBGFORCE_forceaudio. */
#define BM_HDMI_FC_DBGFORCE_forceaudio (0x10U) /*!< Bit mask for HDMI_FC_DBGFORCE_forceaudio. */
#define BS_HDMI_FC_DBGFORCE_forceaudio (1U) /*!< Bit field size in bits for HDMI_FC_DBGFORCE_forceaudio. */

/*! @brief Read current value of the HDMI_FC_DBGFORCE_forceaudio field. */
#define BR_HDMI_FC_DBGFORCE_forceaudio(x) (HW_HDMI_FC_DBGFORCE(x).B.forceaudio)

/*! @brief Format value for bitfield HDMI_FC_DBGFORCE_forceaudio. */
#define BF_HDMI_FC_DBGFORCE_forceaudio(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGFORCE_forceaudio) & BM_HDMI_FC_DBGFORCE_forceaudio)

/*! @brief Set the forceaudio field to a new value. */
#define BW_HDMI_FC_DBGFORCE_forceaudio(x, v) (HW_HDMI_FC_DBGFORCE_WR(x, (HW_HDMI_FC_DBGFORCE_RD(x) & ~BM_HDMI_FC_DBGFORCE_forceaudio) | BF_HDMI_FC_DBGFORCE_forceaudio(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH0 - Frame Composer Audio Channel 0 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH0 - Frame Composer Audio Channel 0 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x1201 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch0
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch0_bitfields
    {
        uint8_t FC_DBGAUD0CH0 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH0 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH0_ADDR(x) ((uintptr_t)(x) + 0x1201U)

#define HW_HDMI_FC_DBGAUD0CH0(x) (*(__IO hw_hdmi_fc_dbgaud0ch0_t *) HW_HDMI_FC_DBGAUD0CH0_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH0_RD(x) (HW_HDMI_FC_DBGAUD0CH0(x).U)
#define HW_HDMI_FC_DBGAUD0CH0_WR(x, v) (HW_HDMI_FC_DBGAUD0CH0(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH0_SET(x, v) (HW_HDMI_FC_DBGAUD0CH0_WR(x, HW_HDMI_FC_DBGAUD0CH0_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH0_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH0_WR(x, HW_HDMI_FC_DBGAUD0CH0_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH0_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH0_WR(x, HW_HDMI_FC_DBGAUD0CH0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH0 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH0, field FC_DBGAUD0CH0[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0. */
#define BM_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0. */
#define BS_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0 field. */
#define BR_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0(x) (HW_HDMI_FC_DBGAUD0CH0(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0. */
#define BF_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0) & BM_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0)

/*! @brief Set the FC_DBGAUD0CH0 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH0_FC_DBGAUD0CH0(x, v) (HW_HDMI_FC_DBGAUD0CH0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH0 - Frame Composer Audio Channel 0 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH0 - Frame Composer Audio Channel 0 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1202 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch0
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch0_bitfields
    {
        uint8_t FC_DBGAUD1CH0 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH0 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH0_ADDR(x) ((uintptr_t)(x) + 0x1202U)

#define HW_HDMI_FC_DBGAUD1CH0(x) (*(__IO hw_hdmi_fc_dbgaud1ch0_t *) HW_HDMI_FC_DBGAUD1CH0_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH0_RD(x) (HW_HDMI_FC_DBGAUD1CH0(x).U)
#define HW_HDMI_FC_DBGAUD1CH0_WR(x, v) (HW_HDMI_FC_DBGAUD1CH0(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH0_SET(x, v) (HW_HDMI_FC_DBGAUD1CH0_WR(x, HW_HDMI_FC_DBGAUD1CH0_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH0_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH0_WR(x, HW_HDMI_FC_DBGAUD1CH0_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH0_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH0_WR(x, HW_HDMI_FC_DBGAUD1CH0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH0 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH0, field FC_DBGAUD1CH0[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0. */
#define BM_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0. */
#define BS_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0 field. */
#define BR_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0(x) (HW_HDMI_FC_DBGAUD1CH0(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0. */
#define BF_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0) & BM_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0)

/*! @brief Set the FC_DBGAUD1CH0 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH0_FC_DBGAUD1CH0(x, v) (HW_HDMI_FC_DBGAUD1CH0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH0 - Frame Composer Audio Channel 0 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH0 - Frame Composer Audio Channel 0 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1203 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch0
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch0_bitfields
    {
        uint8_t FC_DBGAUD2CH0 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH0 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH0_ADDR(x) ((uintptr_t)(x) + 0x1203U)

#define HW_HDMI_FC_DBGAUD2CH0(x) (*(__IO hw_hdmi_fc_dbgaud2ch0_t *) HW_HDMI_FC_DBGAUD2CH0_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH0_RD(x) (HW_HDMI_FC_DBGAUD2CH0(x).U)
#define HW_HDMI_FC_DBGAUD2CH0_WR(x, v) (HW_HDMI_FC_DBGAUD2CH0(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH0_SET(x, v) (HW_HDMI_FC_DBGAUD2CH0_WR(x, HW_HDMI_FC_DBGAUD2CH0_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH0_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH0_WR(x, HW_HDMI_FC_DBGAUD2CH0_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH0_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH0_WR(x, HW_HDMI_FC_DBGAUD2CH0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH0 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH0, field FC_DBGAUD2CH0[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0. */
#define BM_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0. */
#define BS_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0 field. */
#define BR_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0(x) (HW_HDMI_FC_DBGAUD2CH0(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0. */
#define BF_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0) & BM_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0)

/*! @brief Set the FC_DBGAUD2CH0 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH0_FC_DBGAUD2CH0(x, v) (HW_HDMI_FC_DBGAUD2CH0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH1 - Frame Composer Audio Channel 1 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH1 - Frame Composer Audio Channel 1 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x1204 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch1
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch1_bitfields
    {
        uint8_t FC_DBGAUD0CH1 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH1 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH1_ADDR(x) ((uintptr_t)(x) + 0x1204U)

#define HW_HDMI_FC_DBGAUD0CH1(x) (*(__IO hw_hdmi_fc_dbgaud0ch1_t *) HW_HDMI_FC_DBGAUD0CH1_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH1_RD(x) (HW_HDMI_FC_DBGAUD0CH1(x).U)
#define HW_HDMI_FC_DBGAUD0CH1_WR(x, v) (HW_HDMI_FC_DBGAUD0CH1(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH1_SET(x, v) (HW_HDMI_FC_DBGAUD0CH1_WR(x, HW_HDMI_FC_DBGAUD0CH1_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH1_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH1_WR(x, HW_HDMI_FC_DBGAUD0CH1_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH1_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH1_WR(x, HW_HDMI_FC_DBGAUD0CH1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH1 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH1, field FC_DBGAUD0CH1[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1. */
#define BM_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1. */
#define BS_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1 field. */
#define BR_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1(x) (HW_HDMI_FC_DBGAUD0CH1(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1. */
#define BF_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1) & BM_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1)

/*! @brief Set the FC_DBGAUD0CH1 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH1_FC_DBGAUD0CH1(x, v) (HW_HDMI_FC_DBGAUD0CH1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH1 - Frame Composer Audio Channel 1 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH1 - Frame Composer Audio Channel 1 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1205 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch1
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch1_bitfields
    {
        uint8_t FC_DBGAUD1CH1 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH1 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH1_ADDR(x) ((uintptr_t)(x) + 0x1205U)

#define HW_HDMI_FC_DBGAUD1CH1(x) (*(__IO hw_hdmi_fc_dbgaud1ch1_t *) HW_HDMI_FC_DBGAUD1CH1_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH1_RD(x) (HW_HDMI_FC_DBGAUD1CH1(x).U)
#define HW_HDMI_FC_DBGAUD1CH1_WR(x, v) (HW_HDMI_FC_DBGAUD1CH1(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH1_SET(x, v) (HW_HDMI_FC_DBGAUD1CH1_WR(x, HW_HDMI_FC_DBGAUD1CH1_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH1_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH1_WR(x, HW_HDMI_FC_DBGAUD1CH1_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH1_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH1_WR(x, HW_HDMI_FC_DBGAUD1CH1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH1 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH1, field FC_DBGAUD1CH1[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 1 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1. */
#define BM_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1. */
#define BS_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1 field. */
#define BR_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1(x) (HW_HDMI_FC_DBGAUD1CH1(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1. */
#define BF_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1) & BM_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1)

/*! @brief Set the FC_DBGAUD1CH1 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH1_FC_DBGAUD1CH1(x, v) (HW_HDMI_FC_DBGAUD1CH1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH1 - Frame Composer Audio Channel 1 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH1 - Frame Composer Audio Channel 1 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1206 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch1
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch1_bitfields
    {
        uint8_t FC_DBGAUD2CH1 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH1 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH1_ADDR(x) ((uintptr_t)(x) + 0x1206U)

#define HW_HDMI_FC_DBGAUD2CH1(x) (*(__IO hw_hdmi_fc_dbgaud2ch1_t *) HW_HDMI_FC_DBGAUD2CH1_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH1_RD(x) (HW_HDMI_FC_DBGAUD2CH1(x).U)
#define HW_HDMI_FC_DBGAUD2CH1_WR(x, v) (HW_HDMI_FC_DBGAUD2CH1(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH1_SET(x, v) (HW_HDMI_FC_DBGAUD2CH1_WR(x, HW_HDMI_FC_DBGAUD2CH1_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH1_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH1_WR(x, HW_HDMI_FC_DBGAUD2CH1_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH1_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH1_WR(x, HW_HDMI_FC_DBGAUD2CH1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH1 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH1, field FC_DBGAUD2CH1[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 1 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1. */
#define BM_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1. */
#define BS_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1 field. */
#define BR_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1(x) (HW_HDMI_FC_DBGAUD2CH1(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1. */
#define BF_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1) & BM_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1)

/*! @brief Set the FC_DBGAUD2CH1 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH1_FC_DBGAUD2CH1(x, v) (HW_HDMI_FC_DBGAUD2CH1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH2 - Frame Composer Debug Audio Channel 2 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH2 - Frame Composer Debug Audio Channel 2 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x1207 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch2
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch2_bitfields
    {
        uint8_t FC_DBGAUD0CH2 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH2 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH2_ADDR(x) ((uintptr_t)(x) + 0x1207U)

#define HW_HDMI_FC_DBGAUD0CH2(x) (*(__IO hw_hdmi_fc_dbgaud0ch2_t *) HW_HDMI_FC_DBGAUD0CH2_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH2_RD(x) (HW_HDMI_FC_DBGAUD0CH2(x).U)
#define HW_HDMI_FC_DBGAUD0CH2_WR(x, v) (HW_HDMI_FC_DBGAUD0CH2(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH2_SET(x, v) (HW_HDMI_FC_DBGAUD0CH2_WR(x, HW_HDMI_FC_DBGAUD0CH2_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH2_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH2_WR(x, HW_HDMI_FC_DBGAUD0CH2_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH2_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH2_WR(x, HW_HDMI_FC_DBGAUD0CH2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH2 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH2, field FC_DBGAUD0CH2[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 2 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2. */
#define BM_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2. */
#define BS_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2 field. */
#define BR_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2(x) (HW_HDMI_FC_DBGAUD0CH2(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2. */
#define BF_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2) & BM_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2)

/*! @brief Set the FC_DBGAUD0CH2 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH2_FC_DBGAUD0CH2(x, v) (HW_HDMI_FC_DBGAUD0CH2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH2 - Frame Composer Debug Audio Channel 2 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH2 - Frame Composer Debug Audio Channel 2 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1208 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch2
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch2_bitfields
    {
        uint8_t FC_DBGAUD1CH2 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH2 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH2_ADDR(x) ((uintptr_t)(x) + 0x1208U)

#define HW_HDMI_FC_DBGAUD1CH2(x) (*(__IO hw_hdmi_fc_dbgaud1ch2_t *) HW_HDMI_FC_DBGAUD1CH2_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH2_RD(x) (HW_HDMI_FC_DBGAUD1CH2(x).U)
#define HW_HDMI_FC_DBGAUD1CH2_WR(x, v) (HW_HDMI_FC_DBGAUD1CH2(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH2_SET(x, v) (HW_HDMI_FC_DBGAUD1CH2_WR(x, HW_HDMI_FC_DBGAUD1CH2_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH2_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH2_WR(x, HW_HDMI_FC_DBGAUD1CH2_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH2_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH2_WR(x, HW_HDMI_FC_DBGAUD1CH2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH2 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH2, field FC_DBGAUD1CH2[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 2 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2. */
#define BM_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2. */
#define BS_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2 field. */
#define BR_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2(x) (HW_HDMI_FC_DBGAUD1CH2(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2. */
#define BF_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2) & BM_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2)

/*! @brief Set the FC_DBGAUD1CH2 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH2_FC_DBGAUD1CH2(x, v) (HW_HDMI_FC_DBGAUD1CH2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH2 - Frame Composer Audio Channel 2 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH2 - Frame Composer Audio Channel 2 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1209 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch2
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch2_bitfields
    {
        uint8_t FC_DBGAUD2CH2 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH2 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH2_ADDR(x) ((uintptr_t)(x) + 0x1209U)

#define HW_HDMI_FC_DBGAUD2CH2(x) (*(__IO hw_hdmi_fc_dbgaud2ch2_t *) HW_HDMI_FC_DBGAUD2CH2_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH2_RD(x) (HW_HDMI_FC_DBGAUD2CH2(x).U)
#define HW_HDMI_FC_DBGAUD2CH2_WR(x, v) (HW_HDMI_FC_DBGAUD2CH2(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH2_SET(x, v) (HW_HDMI_FC_DBGAUD2CH2_WR(x, HW_HDMI_FC_DBGAUD2CH2_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH2_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH2_WR(x, HW_HDMI_FC_DBGAUD2CH2_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH2_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH2_WR(x, HW_HDMI_FC_DBGAUD2CH2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH2 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH2, field FC_DBGAUD2CH2[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 2 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2. */
#define BM_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2. */
#define BS_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2 field. */
#define BR_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2(x) (HW_HDMI_FC_DBGAUD2CH2(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2. */
#define BF_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2) & BM_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2)

/*! @brief Set the FC_DBGAUD2CH2 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH2_FC_DBGAUD2CH2(x, v) (HW_HDMI_FC_DBGAUD2CH2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH3 - Frame Composer Audio Channel 3 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH3 - Frame Composer Audio Channel 3 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x120A Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch3
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch3_bitfields
    {
        uint8_t FC_DBGAUD0CH3 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH3 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH3_ADDR(x) ((uintptr_t)(x) + 0x120AU)

#define HW_HDMI_FC_DBGAUD0CH3(x) (*(__IO hw_hdmi_fc_dbgaud0ch3_t *) HW_HDMI_FC_DBGAUD0CH3_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH3_RD(x) (HW_HDMI_FC_DBGAUD0CH3(x).U)
#define HW_HDMI_FC_DBGAUD0CH3_WR(x, v) (HW_HDMI_FC_DBGAUD0CH3(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH3_SET(x, v) (HW_HDMI_FC_DBGAUD0CH3_WR(x, HW_HDMI_FC_DBGAUD0CH3_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH3_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH3_WR(x, HW_HDMI_FC_DBGAUD0CH3_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH3_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH3_WR(x, HW_HDMI_FC_DBGAUD0CH3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH3 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH3, field FC_DBGAUD0CH3[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 3 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3. */
#define BM_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3. */
#define BS_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3 field. */
#define BR_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3(x) (HW_HDMI_FC_DBGAUD0CH3(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3. */
#define BF_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3) & BM_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3)

/*! @brief Set the FC_DBGAUD0CH3 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH3_FC_DBGAUD0CH3(x, v) (HW_HDMI_FC_DBGAUD0CH3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH3 - Frame Composer Audio Channel 3 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH3 - Frame Composer Audio Channel 3 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x120B Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch3
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch3_bitfields
    {
        uint8_t FC_DBGAUD1CH3 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH3 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH3_ADDR(x) ((uintptr_t)(x) + 0x120BU)

#define HW_HDMI_FC_DBGAUD1CH3(x) (*(__IO hw_hdmi_fc_dbgaud1ch3_t *) HW_HDMI_FC_DBGAUD1CH3_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH3_RD(x) (HW_HDMI_FC_DBGAUD1CH3(x).U)
#define HW_HDMI_FC_DBGAUD1CH3_WR(x, v) (HW_HDMI_FC_DBGAUD1CH3(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH3_SET(x, v) (HW_HDMI_FC_DBGAUD1CH3_WR(x, HW_HDMI_FC_DBGAUD1CH3_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH3_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH3_WR(x, HW_HDMI_FC_DBGAUD1CH3_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH3_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH3_WR(x, HW_HDMI_FC_DBGAUD1CH3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH3 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH3, field FC_DBGAUD1CH3[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 3 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3. */
#define BM_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3. */
#define BS_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3 field. */
#define BR_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3(x) (HW_HDMI_FC_DBGAUD1CH3(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3. */
#define BF_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3) & BM_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3)

/*! @brief Set the FC_DBGAUD1CH3 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH3_FC_DBGAUD1CH3(x, v) (HW_HDMI_FC_DBGAUD1CH3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH3 - Frame Composer Audio Channel 3 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH3 - Frame Composer Audio Channel 3 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x120C Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch3
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch3_bitfields
    {
        uint8_t FC_DBGAUD2CH3 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch3_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH3 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH3_ADDR(x) ((uintptr_t)(x) + 0x120CU)

#define HW_HDMI_FC_DBGAUD2CH3(x) (*(__IO hw_hdmi_fc_dbgaud2ch3_t *) HW_HDMI_FC_DBGAUD2CH3_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH3_RD(x) (HW_HDMI_FC_DBGAUD2CH3(x).U)
#define HW_HDMI_FC_DBGAUD2CH3_WR(x, v) (HW_HDMI_FC_DBGAUD2CH3(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH3_SET(x, v) (HW_HDMI_FC_DBGAUD2CH3_WR(x, HW_HDMI_FC_DBGAUD2CH3_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH3_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH3_WR(x, HW_HDMI_FC_DBGAUD2CH3_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH3_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH3_WR(x, HW_HDMI_FC_DBGAUD2CH3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH3 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH3, field FC_DBGAUD2CH3[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 3 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3. */
#define BM_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3. */
#define BS_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3 field. */
#define BR_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3(x) (HW_HDMI_FC_DBGAUD2CH3(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3. */
#define BF_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3) & BM_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3)

/*! @brief Set the FC_DBGAUD2CH3 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH3_FC_DBGAUD2CH3(x, v) (HW_HDMI_FC_DBGAUD2CH3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH4 - Frame Composer Audio Channel 4 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH4 - Frame Composer Audio Channel 4 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x120D Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch4
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch4_bitfields
    {
        uint8_t FC_DBGAUD0CH4 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH4 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH4_ADDR(x) ((uintptr_t)(x) + 0x120DU)

#define HW_HDMI_FC_DBGAUD0CH4(x) (*(__IO hw_hdmi_fc_dbgaud0ch4_t *) HW_HDMI_FC_DBGAUD0CH4_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH4_RD(x) (HW_HDMI_FC_DBGAUD0CH4(x).U)
#define HW_HDMI_FC_DBGAUD0CH4_WR(x, v) (HW_HDMI_FC_DBGAUD0CH4(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH4_SET(x, v) (HW_HDMI_FC_DBGAUD0CH4_WR(x, HW_HDMI_FC_DBGAUD0CH4_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH4_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH4_WR(x, HW_HDMI_FC_DBGAUD0CH4_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH4_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH4_WR(x, HW_HDMI_FC_DBGAUD0CH4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH4 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH4, field FC_DBGAUD0CH4[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 4 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4. */
#define BM_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4. */
#define BS_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4 field. */
#define BR_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4(x) (HW_HDMI_FC_DBGAUD0CH4(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4. */
#define BF_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4) & BM_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4)

/*! @brief Set the FC_DBGAUD0CH4 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH4_FC_DBGAUD0CH4(x, v) (HW_HDMI_FC_DBGAUD0CH4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH4 - Frame Composer Audio Channel 4 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH4 - Frame Composer Audio Channel 4 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x120E Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch4
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch4_bitfields
    {
        uint8_t FC_DBGAUD1CH4 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH4 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH4_ADDR(x) ((uintptr_t)(x) + 0x120EU)

#define HW_HDMI_FC_DBGAUD1CH4(x) (*(__IO hw_hdmi_fc_dbgaud1ch4_t *) HW_HDMI_FC_DBGAUD1CH4_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH4_RD(x) (HW_HDMI_FC_DBGAUD1CH4(x).U)
#define HW_HDMI_FC_DBGAUD1CH4_WR(x, v) (HW_HDMI_FC_DBGAUD1CH4(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH4_SET(x, v) (HW_HDMI_FC_DBGAUD1CH4_WR(x, HW_HDMI_FC_DBGAUD1CH4_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH4_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH4_WR(x, HW_HDMI_FC_DBGAUD1CH4_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH4_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH4_WR(x, HW_HDMI_FC_DBGAUD1CH4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH4 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH4, field FC_DBGAUD1CH4[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 4 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4. */
#define BM_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4. */
#define BS_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4 field. */
#define BR_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4(x) (HW_HDMI_FC_DBGAUD1CH4(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4. */
#define BF_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4) & BM_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4)

/*! @brief Set the FC_DBGAUD1CH4 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH4_FC_DBGAUD1CH4(x, v) (HW_HDMI_FC_DBGAUD1CH4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH4 - Frame Composer Audio Channel 4 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH4 - Frame Composer Audio Channel 4 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x120F Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch4
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch4_bitfields
    {
        uint8_t FC_DBGAUD2CH4 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch4_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH4 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH4_ADDR(x) ((uintptr_t)(x) + 0x120FU)

#define HW_HDMI_FC_DBGAUD2CH4(x) (*(__IO hw_hdmi_fc_dbgaud2ch4_t *) HW_HDMI_FC_DBGAUD2CH4_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH4_RD(x) (HW_HDMI_FC_DBGAUD2CH4(x).U)
#define HW_HDMI_FC_DBGAUD2CH4_WR(x, v) (HW_HDMI_FC_DBGAUD2CH4(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH4_SET(x, v) (HW_HDMI_FC_DBGAUD2CH4_WR(x, HW_HDMI_FC_DBGAUD2CH4_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH4_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH4_WR(x, HW_HDMI_FC_DBGAUD2CH4_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH4_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH4_WR(x, HW_HDMI_FC_DBGAUD2CH4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH4 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH4, field FC_DBGAUD2CH4[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 4 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4. */
#define BM_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4. */
#define BS_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4 field. */
#define BR_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4(x) (HW_HDMI_FC_DBGAUD2CH4(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4. */
#define BF_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4) & BM_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4)

/*! @brief Set the FC_DBGAUD2CH4 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH4_FC_DBGAUD2CH4(x, v) (HW_HDMI_FC_DBGAUD2CH4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH5 - Frame Composer Audio Channel 5 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH5 - Frame Composer Audio Channel 5 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x1210 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch5
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch5_bitfields
    {
        uint8_t FC_DBGAUD0CH5 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH5 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH5_ADDR(x) ((uintptr_t)(x) + 0x1210U)

#define HW_HDMI_FC_DBGAUD0CH5(x) (*(__IO hw_hdmi_fc_dbgaud0ch5_t *) HW_HDMI_FC_DBGAUD0CH5_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH5_RD(x) (HW_HDMI_FC_DBGAUD0CH5(x).U)
#define HW_HDMI_FC_DBGAUD0CH5_WR(x, v) (HW_HDMI_FC_DBGAUD0CH5(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH5_SET(x, v) (HW_HDMI_FC_DBGAUD0CH5_WR(x, HW_HDMI_FC_DBGAUD0CH5_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH5_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH5_WR(x, HW_HDMI_FC_DBGAUD0CH5_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH5_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH5_WR(x, HW_HDMI_FC_DBGAUD0CH5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH5 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH5, field FC_DBGAUD0CH5[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 5 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5. */
#define BM_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5. */
#define BS_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5 field. */
#define BR_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5(x) (HW_HDMI_FC_DBGAUD0CH5(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5. */
#define BF_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5) & BM_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5)

/*! @brief Set the FC_DBGAUD0CH5 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH5_FC_DBGAUD0CH5(x, v) (HW_HDMI_FC_DBGAUD0CH5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH5 - Frame Composer Audio Channel 5 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH5 - Frame Composer Audio Channel 5 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1211 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch5
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch5_bitfields
    {
        uint8_t FC_DBGAUD1CH5 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH5 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH5_ADDR(x) ((uintptr_t)(x) + 0x1211U)

#define HW_HDMI_FC_DBGAUD1CH5(x) (*(__IO hw_hdmi_fc_dbgaud1ch5_t *) HW_HDMI_FC_DBGAUD1CH5_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH5_RD(x) (HW_HDMI_FC_DBGAUD1CH5(x).U)
#define HW_HDMI_FC_DBGAUD1CH5_WR(x, v) (HW_HDMI_FC_DBGAUD1CH5(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH5_SET(x, v) (HW_HDMI_FC_DBGAUD1CH5_WR(x, HW_HDMI_FC_DBGAUD1CH5_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH5_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH5_WR(x, HW_HDMI_FC_DBGAUD1CH5_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH5_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH5_WR(x, HW_HDMI_FC_DBGAUD1CH5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH5 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH5, field FC_DBGAUD1CH5[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 5 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5. */
#define BM_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5. */
#define BS_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5 field. */
#define BR_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5(x) (HW_HDMI_FC_DBGAUD1CH5(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5. */
#define BF_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5) & BM_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5)

/*! @brief Set the FC_DBGAUD1CH5 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH5_FC_DBGAUD1CH5(x, v) (HW_HDMI_FC_DBGAUD1CH5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH5 - Frame Composer Audio Channel 5 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH5 - Frame Composer Audio Channel 5 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1212 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch5
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch5_bitfields
    {
        uint8_t FC_DBGAUD2CH5 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch5_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH5 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH5_ADDR(x) ((uintptr_t)(x) + 0x1212U)

#define HW_HDMI_FC_DBGAUD2CH5(x) (*(__IO hw_hdmi_fc_dbgaud2ch5_t *) HW_HDMI_FC_DBGAUD2CH5_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH5_RD(x) (HW_HDMI_FC_DBGAUD2CH5(x).U)
#define HW_HDMI_FC_DBGAUD2CH5_WR(x, v) (HW_HDMI_FC_DBGAUD2CH5(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH5_SET(x, v) (HW_HDMI_FC_DBGAUD2CH5_WR(x, HW_HDMI_FC_DBGAUD2CH5_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH5_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH5_WR(x, HW_HDMI_FC_DBGAUD2CH5_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH5_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH5_WR(x, HW_HDMI_FC_DBGAUD2CH5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH5 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH5, field FC_DBGAUD2CH5[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 5 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5. */
#define BM_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5. */
#define BS_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5 field. */
#define BR_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5(x) (HW_HDMI_FC_DBGAUD2CH5(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5. */
#define BF_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5) & BM_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5)

/*! @brief Set the FC_DBGAUD2CH5 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH5_FC_DBGAUD2CH5(x, v) (HW_HDMI_FC_DBGAUD2CH5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH6 - Frame Composer Audio Channel 6 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH6 - Frame Composer Audio Channel 6 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 0 when in fixed audio
 * selection. Address Offset: 0x1213 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch6
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch6_bitfields
    {
        uint8_t FC_DBGAUD0CH6 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH6 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH6_ADDR(x) ((uintptr_t)(x) + 0x1213U)

#define HW_HDMI_FC_DBGAUD0CH6(x) (*(__IO hw_hdmi_fc_dbgaud0ch6_t *) HW_HDMI_FC_DBGAUD0CH6_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH6_RD(x) (HW_HDMI_FC_DBGAUD0CH6(x).U)
#define HW_HDMI_FC_DBGAUD0CH6_WR(x, v) (HW_HDMI_FC_DBGAUD0CH6(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH6_SET(x, v) (HW_HDMI_FC_DBGAUD0CH6_WR(x, HW_HDMI_FC_DBGAUD0CH6_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH6_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH6_WR(x, HW_HDMI_FC_DBGAUD0CH6_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH6_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH6_WR(x, HW_HDMI_FC_DBGAUD0CH6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH6 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH6, field FC_DBGAUD0CH6[7:0] (RW)
 *
 * The audio fixed data byte0 to be used in channel 6 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6. */
#define BM_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6. */
#define BS_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6 field. */
#define BR_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6(x) (HW_HDMI_FC_DBGAUD0CH6(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6. */
#define BF_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6) & BM_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6)

/*! @brief Set the FC_DBGAUD0CH6 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH6_FC_DBGAUD0CH6(x, v) (HW_HDMI_FC_DBGAUD0CH6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH6 - Frame Composer Audio Channel 6 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH6 - Frame Composer Audio Channel 6 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1214 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch6
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch6_bitfields
    {
        uint8_t FC_DBGAUD1CH6 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH6 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH6_ADDR(x) ((uintptr_t)(x) + 0x1214U)

#define HW_HDMI_FC_DBGAUD1CH6(x) (*(__IO hw_hdmi_fc_dbgaud1ch6_t *) HW_HDMI_FC_DBGAUD1CH6_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH6_RD(x) (HW_HDMI_FC_DBGAUD1CH6(x).U)
#define HW_HDMI_FC_DBGAUD1CH6_WR(x, v) (HW_HDMI_FC_DBGAUD1CH6(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH6_SET(x, v) (HW_HDMI_FC_DBGAUD1CH6_WR(x, HW_HDMI_FC_DBGAUD1CH6_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH6_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH6_WR(x, HW_HDMI_FC_DBGAUD1CH6_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH6_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH6_WR(x, HW_HDMI_FC_DBGAUD1CH6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH6 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH6, field FC_DBGAUD1CH6[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 6 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6. */
#define BM_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6. */
#define BS_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6 field. */
#define BR_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6(x) (HW_HDMI_FC_DBGAUD1CH6(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6. */
#define BF_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6) & BM_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6)

/*! @brief Set the FC_DBGAUD1CH6 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH6_FC_DBGAUD1CH6(x, v) (HW_HDMI_FC_DBGAUD1CH6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH6 - Frame Composer Audio Channel 6 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH6 - Frame Composer Audio Channel 6 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1215 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch6
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch6_bitfields
    {
        uint8_t FC_DBGAUD2CH6 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch6_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH6 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH6_ADDR(x) ((uintptr_t)(x) + 0x1215U)

#define HW_HDMI_FC_DBGAUD2CH6(x) (*(__IO hw_hdmi_fc_dbgaud2ch6_t *) HW_HDMI_FC_DBGAUD2CH6_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH6_RD(x) (HW_HDMI_FC_DBGAUD2CH6(x).U)
#define HW_HDMI_FC_DBGAUD2CH6_WR(x, v) (HW_HDMI_FC_DBGAUD2CH6(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH6_SET(x, v) (HW_HDMI_FC_DBGAUD2CH6_WR(x, HW_HDMI_FC_DBGAUD2CH6_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH6_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH6_WR(x, HW_HDMI_FC_DBGAUD2CH6_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH6_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH6_WR(x, HW_HDMI_FC_DBGAUD2CH6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH6 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH6, field FC_DBGAUD2CH6[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 6 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6. */
#define BM_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6. */
#define BS_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6 field. */
#define BR_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6(x) (HW_HDMI_FC_DBGAUD2CH6(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6. */
#define BF_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6) & BM_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6)

/*! @brief Set the FC_DBGAUD2CH6 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH6_FC_DBGAUD2CH6(x, v) (HW_HDMI_FC_DBGAUD2CH6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD0CH7 - Frame Composer Audio Channel 7 Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD0CH7 - Frame Composer Audio Channel 7 Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the audio fixed data to be used in channel 7 when in fixed audio
 * selection. Address Offset: 0x1216 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud0ch7
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud0ch7_bitfields
    {
        uint8_t FC_DBGAUD0CH7 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud0ch7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD0CH7 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD0CH7_ADDR(x) ((uintptr_t)(x) + 0x1216U)

#define HW_HDMI_FC_DBGAUD0CH7(x) (*(__IO hw_hdmi_fc_dbgaud0ch7_t *) HW_HDMI_FC_DBGAUD0CH7_ADDR(x))
#define HW_HDMI_FC_DBGAUD0CH7_RD(x) (HW_HDMI_FC_DBGAUD0CH7(x).U)
#define HW_HDMI_FC_DBGAUD0CH7_WR(x, v) (HW_HDMI_FC_DBGAUD0CH7(x).U = (v))
#define HW_HDMI_FC_DBGAUD0CH7_SET(x, v) (HW_HDMI_FC_DBGAUD0CH7_WR(x, HW_HDMI_FC_DBGAUD0CH7_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD0CH7_CLR(x, v) (HW_HDMI_FC_DBGAUD0CH7_WR(x, HW_HDMI_FC_DBGAUD0CH7_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD0CH7_TOG(x, v) (HW_HDMI_FC_DBGAUD0CH7_WR(x, HW_HDMI_FC_DBGAUD0CH7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD0CH7 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD0CH7, field FC_DBGAUD0CH7[7:0] (RW)
 *
 * the audio fixed data byte0 to be used in channel 7 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7 (0U) /*!< Bit position for HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7. */
#define BM_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7. */
#define BS_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7. */

/*! @brief Read current value of the HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7 field. */
#define BR_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7(x) (HW_HDMI_FC_DBGAUD0CH7(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7. */
#define BF_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7) & BM_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7)

/*! @brief Set the FC_DBGAUD0CH7 field to a new value. */
#define BW_HDMI_FC_DBGAUD0CH7_FC_DBGAUD0CH7(x, v) (HW_HDMI_FC_DBGAUD0CH7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD1CH7 - Frame Composer Audio Channel 7 Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD1CH7 - Frame Composer Audio Channel 7 Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1217 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud1ch7
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud1ch7_bitfields
    {
        uint8_t FC_DBGAUD1CH7 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud1ch7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD1CH7 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD1CH7_ADDR(x) ((uintptr_t)(x) + 0x1217U)

#define HW_HDMI_FC_DBGAUD1CH7(x) (*(__IO hw_hdmi_fc_dbgaud1ch7_t *) HW_HDMI_FC_DBGAUD1CH7_ADDR(x))
#define HW_HDMI_FC_DBGAUD1CH7_RD(x) (HW_HDMI_FC_DBGAUD1CH7(x).U)
#define HW_HDMI_FC_DBGAUD1CH7_WR(x, v) (HW_HDMI_FC_DBGAUD1CH7(x).U = (v))
#define HW_HDMI_FC_DBGAUD1CH7_SET(x, v) (HW_HDMI_FC_DBGAUD1CH7_WR(x, HW_HDMI_FC_DBGAUD1CH7_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD1CH7_CLR(x, v) (HW_HDMI_FC_DBGAUD1CH7_WR(x, HW_HDMI_FC_DBGAUD1CH7_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD1CH7_TOG(x, v) (HW_HDMI_FC_DBGAUD1CH7_WR(x, HW_HDMI_FC_DBGAUD1CH7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD1CH7 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD1CH7, field FC_DBGAUD1CH7[7:0] (RW)
 *
 * the audio fixed data byte1 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7 (0U) /*!< Bit position for HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7. */
#define BM_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7. */
#define BS_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7. */

/*! @brief Read current value of the HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7 field. */
#define BR_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7(x) (HW_HDMI_FC_DBGAUD1CH7(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7. */
#define BF_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7) & BM_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7)

/*! @brief Set the FC_DBGAUD1CH7 field to a new value. */
#define BW_HDMI_FC_DBGAUD1CH7_FC_DBGAUD1CH7(x, v) (HW_HDMI_FC_DBGAUD1CH7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGAUD2CH7 - Frame Composer Audio Channel 7 Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGAUD2CH7 - Frame Composer Audio Channel 7 Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x1218 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgaud2ch7
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgaud2ch7_bitfields
    {
        uint8_t FC_DBGAUD2CH7 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgaud2ch7_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGAUD2CH7 register
 */
/*@{*/
#define HW_HDMI_FC_DBGAUD2CH7_ADDR(x) ((uintptr_t)(x) + 0x1218U)

#define HW_HDMI_FC_DBGAUD2CH7(x) (*(__IO hw_hdmi_fc_dbgaud2ch7_t *) HW_HDMI_FC_DBGAUD2CH7_ADDR(x))
#define HW_HDMI_FC_DBGAUD2CH7_RD(x) (HW_HDMI_FC_DBGAUD2CH7(x).U)
#define HW_HDMI_FC_DBGAUD2CH7_WR(x, v) (HW_HDMI_FC_DBGAUD2CH7(x).U = (v))
#define HW_HDMI_FC_DBGAUD2CH7_SET(x, v) (HW_HDMI_FC_DBGAUD2CH7_WR(x, HW_HDMI_FC_DBGAUD2CH7_RD(x) |  (v)))
#define HW_HDMI_FC_DBGAUD2CH7_CLR(x, v) (HW_HDMI_FC_DBGAUD2CH7_WR(x, HW_HDMI_FC_DBGAUD2CH7_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGAUD2CH7_TOG(x, v) (HW_HDMI_FC_DBGAUD2CH7_WR(x, HW_HDMI_FC_DBGAUD2CH7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGAUD2CH7 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGAUD2CH7, field FC_DBGAUD2CH7[7:0] (RW)
 *
 * the audio fixed data byte2 to be used in channel 0 when in fixed audio
 * selection
 */
/*@{*/
#define BP_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7 (0U) /*!< Bit position for HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7. */
#define BM_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7 (0xFFU) /*!< Bit mask for HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7. */
#define BS_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7 (8U) /*!< Bit field size in bits for HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7. */

/*! @brief Read current value of the HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7 field. */
#define BR_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7(x) (HW_HDMI_FC_DBGAUD2CH7(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7. */
#define BF_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7) & BM_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7)

/*! @brief Set the FC_DBGAUD2CH7 field to a new value. */
#define BW_HDMI_FC_DBGAUD2CH7_FC_DBGAUD2CH7(x, v) (HW_HDMI_FC_DBGAUD2CH7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGTMDS0 - Frame Composer TMDS Channel 0 Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGTMDS0 - Frame Composer TMDS Channel 0 Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the video fixed data to be used in tmds channel 0 when in fixed
 * video selection. This equals to set B pixel component value in RGB video or Cb
 * pixel component value in YCbCr. Address Offset: 0x1219 Size: 8 bits Value after
 * Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgtmds0
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgtmds0_bitfields
    {
        uint8_t FC_DBGTMDS0 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgtmds0_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGTMDS0 register
 */
/*@{*/
#define HW_HDMI_FC_DBGTMDS0_ADDR(x) ((uintptr_t)(x) + 0x1219U)

#define HW_HDMI_FC_DBGTMDS0(x)   (*(__IO hw_hdmi_fc_dbgtmds0_t *) HW_HDMI_FC_DBGTMDS0_ADDR(x))
#define HW_HDMI_FC_DBGTMDS0_RD(x) (HW_HDMI_FC_DBGTMDS0(x).U)
#define HW_HDMI_FC_DBGTMDS0_WR(x, v) (HW_HDMI_FC_DBGTMDS0(x).U = (v))
#define HW_HDMI_FC_DBGTMDS0_SET(x, v) (HW_HDMI_FC_DBGTMDS0_WR(x, HW_HDMI_FC_DBGTMDS0_RD(x) |  (v)))
#define HW_HDMI_FC_DBGTMDS0_CLR(x, v) (HW_HDMI_FC_DBGTMDS0_WR(x, HW_HDMI_FC_DBGTMDS0_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGTMDS0_TOG(x, v) (HW_HDMI_FC_DBGTMDS0_WR(x, HW_HDMI_FC_DBGTMDS0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGTMDS0 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGTMDS0, field FC_DBGTMDS0[7:0] (RW)
 *
 * set B pixel component value in RGB video or Cb pixel component value in YCbCr
 */
/*@{*/
#define BP_HDMI_FC_DBGTMDS0_FC_DBGTMDS0 (0U) /*!< Bit position for HDMI_FC_DBGTMDS0_FC_DBGTMDS0. */
#define BM_HDMI_FC_DBGTMDS0_FC_DBGTMDS0 (0xFFU) /*!< Bit mask for HDMI_FC_DBGTMDS0_FC_DBGTMDS0. */
#define BS_HDMI_FC_DBGTMDS0_FC_DBGTMDS0 (8U) /*!< Bit field size in bits for HDMI_FC_DBGTMDS0_FC_DBGTMDS0. */

/*! @brief Read current value of the HDMI_FC_DBGTMDS0_FC_DBGTMDS0 field. */
#define BR_HDMI_FC_DBGTMDS0_FC_DBGTMDS0(x) (HW_HDMI_FC_DBGTMDS0(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGTMDS0_FC_DBGTMDS0. */
#define BF_HDMI_FC_DBGTMDS0_FC_DBGTMDS0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGTMDS0_FC_DBGTMDS0) & BM_HDMI_FC_DBGTMDS0_FC_DBGTMDS0)

/*! @brief Set the FC_DBGTMDS0 field to a new value. */
#define BW_HDMI_FC_DBGTMDS0_FC_DBGTMDS0(x, v) (HW_HDMI_FC_DBGTMDS0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGTMDS1 - Frame Composer TMDS Channel 1 Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGTMDS1 - Frame Composer TMDS Channel 1 Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the video fixed data to be used in tmds channel 1 when in fixed
 * video selection. This equals to set G pixel component value in RGB video or Y
 * pixel component value in YCbCr. Address Offset: 0x121A Size: 8 bits Value after
 * Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgtmds1
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgtmds1_bitfields
    {
        uint8_t FC_DBGTMDS1 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgtmds1_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGTMDS1 register
 */
/*@{*/
#define HW_HDMI_FC_DBGTMDS1_ADDR(x) ((uintptr_t)(x) + 0x121AU)

#define HW_HDMI_FC_DBGTMDS1(x)   (*(__IO hw_hdmi_fc_dbgtmds1_t *) HW_HDMI_FC_DBGTMDS1_ADDR(x))
#define HW_HDMI_FC_DBGTMDS1_RD(x) (HW_HDMI_FC_DBGTMDS1(x).U)
#define HW_HDMI_FC_DBGTMDS1_WR(x, v) (HW_HDMI_FC_DBGTMDS1(x).U = (v))
#define HW_HDMI_FC_DBGTMDS1_SET(x, v) (HW_HDMI_FC_DBGTMDS1_WR(x, HW_HDMI_FC_DBGTMDS1_RD(x) |  (v)))
#define HW_HDMI_FC_DBGTMDS1_CLR(x, v) (HW_HDMI_FC_DBGTMDS1_WR(x, HW_HDMI_FC_DBGTMDS1_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGTMDS1_TOG(x, v) (HW_HDMI_FC_DBGTMDS1_WR(x, HW_HDMI_FC_DBGTMDS1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGTMDS1 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGTMDS1, field FC_DBGTMDS1[7:0] (RW)
 *
 * set G pixel component value in RGB video or Y pixel component value in YCbCr
 */
/*@{*/
#define BP_HDMI_FC_DBGTMDS1_FC_DBGTMDS1 (0U) /*!< Bit position for HDMI_FC_DBGTMDS1_FC_DBGTMDS1. */
#define BM_HDMI_FC_DBGTMDS1_FC_DBGTMDS1 (0xFFU) /*!< Bit mask for HDMI_FC_DBGTMDS1_FC_DBGTMDS1. */
#define BS_HDMI_FC_DBGTMDS1_FC_DBGTMDS1 (8U) /*!< Bit field size in bits for HDMI_FC_DBGTMDS1_FC_DBGTMDS1. */

/*! @brief Read current value of the HDMI_FC_DBGTMDS1_FC_DBGTMDS1 field. */
#define BR_HDMI_FC_DBGTMDS1_FC_DBGTMDS1(x) (HW_HDMI_FC_DBGTMDS1(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGTMDS1_FC_DBGTMDS1. */
#define BF_HDMI_FC_DBGTMDS1_FC_DBGTMDS1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGTMDS1_FC_DBGTMDS1) & BM_HDMI_FC_DBGTMDS1_FC_DBGTMDS1)

/*! @brief Set the FC_DBGTMDS1 field to a new value. */
#define BW_HDMI_FC_DBGTMDS1_FC_DBGTMDS1(x, v) (HW_HDMI_FC_DBGTMDS1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_FC_DBGTMDS2 - Frame Composer TMDS Channel 2 Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_FC_DBGTMDS2 - Frame Composer TMDS Channel 2 Register (RW)
 *
 * Reset value: 0x00U
 *
 * Configures the video fixed data to be used in tmds channel 2 when in fixed
 * video selection. This equals to set R pixel component value in RGB video or Cr
 * pixel component value in YCbCr. Address Offset: 0x121B Size: 8 bits Value after
 * Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_fc_dbgtmds2
{
    uint8_t U;
    struct _hw_hdmi_fc_dbgtmds2_bitfields
    {
        uint8_t FC_DBGTMDS2 : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_fc_dbgtmds2_t;

/*!
 * @name Constants and macros for entire HDMI_FC_DBGTMDS2 register
 */
/*@{*/
#define HW_HDMI_FC_DBGTMDS2_ADDR(x) ((uintptr_t)(x) + 0x121BU)

#define HW_HDMI_FC_DBGTMDS2(x)   (*(__IO hw_hdmi_fc_dbgtmds2_t *) HW_HDMI_FC_DBGTMDS2_ADDR(x))
#define HW_HDMI_FC_DBGTMDS2_RD(x) (HW_HDMI_FC_DBGTMDS2(x).U)
#define HW_HDMI_FC_DBGTMDS2_WR(x, v) (HW_HDMI_FC_DBGTMDS2(x).U = (v))
#define HW_HDMI_FC_DBGTMDS2_SET(x, v) (HW_HDMI_FC_DBGTMDS2_WR(x, HW_HDMI_FC_DBGTMDS2_RD(x) |  (v)))
#define HW_HDMI_FC_DBGTMDS2_CLR(x, v) (HW_HDMI_FC_DBGTMDS2_WR(x, HW_HDMI_FC_DBGTMDS2_RD(x) & ~(v)))
#define HW_HDMI_FC_DBGTMDS2_TOG(x, v) (HW_HDMI_FC_DBGTMDS2_WR(x, HW_HDMI_FC_DBGTMDS2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_FC_DBGTMDS2 bitfields
 */

/*!
 * @name Register HDMI_FC_DBGTMDS2, field FC_DBGTMDS2[7:0] (RW)
 *
 * set R pixel component value in RGB video or Cr pixel component value in YCbCr
 */
/*@{*/
#define BP_HDMI_FC_DBGTMDS2_FC_DBGTMDS2 (0U) /*!< Bit position for HDMI_FC_DBGTMDS2_FC_DBGTMDS2. */
#define BM_HDMI_FC_DBGTMDS2_FC_DBGTMDS2 (0xFFU) /*!< Bit mask for HDMI_FC_DBGTMDS2_FC_DBGTMDS2. */
#define BS_HDMI_FC_DBGTMDS2_FC_DBGTMDS2 (8U) /*!< Bit field size in bits for HDMI_FC_DBGTMDS2_FC_DBGTMDS2. */

/*! @brief Read current value of the HDMI_FC_DBGTMDS2_FC_DBGTMDS2 field. */
#define BR_HDMI_FC_DBGTMDS2_FC_DBGTMDS2(x) (HW_HDMI_FC_DBGTMDS2(x).U)

/*! @brief Format value for bitfield HDMI_FC_DBGTMDS2_FC_DBGTMDS2. */
#define BF_HDMI_FC_DBGTMDS2_FC_DBGTMDS2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_FC_DBGTMDS2_FC_DBGTMDS2) & BM_HDMI_FC_DBGTMDS2_FC_DBGTMDS2)

/*! @brief Set the FC_DBGTMDS2 field to a new value. */
#define BW_HDMI_FC_DBGTMDS2_FC_DBGTMDS2(x, v) (HW_HDMI_FC_DBGTMDS2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_CONF0 - PHY Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_CONF0 - PHY Configuration Register (RW)
 *
 * Reset value: 0x06U
 *
 * This register holds the power down, data enable polarity and interface
 * control of the HDMI Source PHY control. For more information, refer to the
 * DesignWare Cores HDMI TX PHY Databook. Address Offset: 0x3000 Size: 8 bits Value after
 * Reset: 0x06 Access: Read/Write
 */
typedef union _hw_hdmi_phy_conf0
{
    uint8_t U;
    struct _hw_hdmi_phy_conf0_bitfields
    {
        uint8_t seldipif : 1;          /*!< [0]  */
        uint8_t seldataenpol : 1;      /*!< [1]  */
        uint8_t gen2_enhpdrxsense : 1; /*!< [2]  */
        uint8_t gen2_txpwron : 1;      /*!< [3]  */
        uint8_t gen2_pddq : 1;         /*!< [4]  */
        uint8_t sparectrl : 1;         /*!< [5]  */
        uint8_t ENTMDS : 1;            /*!< [6]  */
        uint8_t PDZ : 1;               /*!< [7]  */
    } B;
} hw_hdmi_phy_conf0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_CONF0 register
 */
/*@{*/
#define HW_HDMI_PHY_CONF0_ADDR(x) ((uintptr_t)(x) + 0x3000U)

#define HW_HDMI_PHY_CONF0(x)     (*(__IO hw_hdmi_phy_conf0_t *) HW_HDMI_PHY_CONF0_ADDR(x))
#define HW_HDMI_PHY_CONF0_RD(x)  (HW_HDMI_PHY_CONF0(x).U)
#define HW_HDMI_PHY_CONF0_WR(x, v) (HW_HDMI_PHY_CONF0(x).U = (v))
#define HW_HDMI_PHY_CONF0_SET(x, v) (HW_HDMI_PHY_CONF0_WR(x, HW_HDMI_PHY_CONF0_RD(x) |  (v)))
#define HW_HDMI_PHY_CONF0_CLR(x, v) (HW_HDMI_PHY_CONF0_WR(x, HW_HDMI_PHY_CONF0_RD(x) & ~(v)))
#define HW_HDMI_PHY_CONF0_TOG(x, v) (HW_HDMI_PHY_CONF0_WR(x, HW_HDMI_PHY_CONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_CONF0 bitfields
 */

/*!
 * @name Register HDMI_PHY_CONF0, field seldipif[0] (RW)
 *
 * Select interface control. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_seldipif (0U)    /*!< Bit position for HDMI_PHY_CONF0_seldipif. */
#define BM_HDMI_PHY_CONF0_seldipif (0x01U) /*!< Bit mask for HDMI_PHY_CONF0_seldipif. */
#define BS_HDMI_PHY_CONF0_seldipif (1U)    /*!< Bit field size in bits for HDMI_PHY_CONF0_seldipif. */

/*! @brief Read current value of the HDMI_PHY_CONF0_seldipif field. */
#define BR_HDMI_PHY_CONF0_seldipif(x) (HW_HDMI_PHY_CONF0(x).B.seldipif)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_seldipif. */
#define BF_HDMI_PHY_CONF0_seldipif(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_seldipif) & BM_HDMI_PHY_CONF0_seldipif)

/*! @brief Set the seldipif field to a new value. */
#define BW_HDMI_PHY_CONF0_seldipif(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_seldipif) | BF_HDMI_PHY_CONF0_seldipif(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field seldataenpol[1] (RW)
 *
 * Select data enable polarity. Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_seldataenpol (1U) /*!< Bit position for HDMI_PHY_CONF0_seldataenpol. */
#define BM_HDMI_PHY_CONF0_seldataenpol (0x02U) /*!< Bit mask for HDMI_PHY_CONF0_seldataenpol. */
#define BS_HDMI_PHY_CONF0_seldataenpol (1U) /*!< Bit field size in bits for HDMI_PHY_CONF0_seldataenpol. */

/*! @brief Read current value of the HDMI_PHY_CONF0_seldataenpol field. */
#define BR_HDMI_PHY_CONF0_seldataenpol(x) (HW_HDMI_PHY_CONF0(x).B.seldataenpol)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_seldataenpol. */
#define BF_HDMI_PHY_CONF0_seldataenpol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_seldataenpol) & BM_HDMI_PHY_CONF0_seldataenpol)

/*! @brief Set the seldataenpol field to a new value. */
#define BW_HDMI_PHY_CONF0_seldataenpol(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_seldataenpol) | BF_HDMI_PHY_CONF0_seldataenpol(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field gen2_enhpdrxsense[2] (RW)
 *
 * PHY_Gen2 ENHPDRXSENSE signal Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_gen2_enhpdrxsense (2U) /*!< Bit position for HDMI_PHY_CONF0_gen2_enhpdrxsense. */
#define BM_HDMI_PHY_CONF0_gen2_enhpdrxsense (0x04U) /*!< Bit mask for HDMI_PHY_CONF0_gen2_enhpdrxsense. */
#define BS_HDMI_PHY_CONF0_gen2_enhpdrxsense (1U) /*!< Bit field size in bits for HDMI_PHY_CONF0_gen2_enhpdrxsense. */

/*! @brief Read current value of the HDMI_PHY_CONF0_gen2_enhpdrxsense field. */
#define BR_HDMI_PHY_CONF0_gen2_enhpdrxsense(x) (HW_HDMI_PHY_CONF0(x).B.gen2_enhpdrxsense)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_gen2_enhpdrxsense. */
#define BF_HDMI_PHY_CONF0_gen2_enhpdrxsense(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_gen2_enhpdrxsense) & BM_HDMI_PHY_CONF0_gen2_enhpdrxsense)

/*! @brief Set the gen2_enhpdrxsense field to a new value. */
#define BW_HDMI_PHY_CONF0_gen2_enhpdrxsense(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_gen2_enhpdrxsense) | BF_HDMI_PHY_CONF0_gen2_enhpdrxsense(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field gen2_txpwron[3] (RW)
 *
 * PHY_Gen2 TXPWRON signal Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_gen2_txpwron (3U) /*!< Bit position for HDMI_PHY_CONF0_gen2_txpwron. */
#define BM_HDMI_PHY_CONF0_gen2_txpwron (0x08U) /*!< Bit mask for HDMI_PHY_CONF0_gen2_txpwron. */
#define BS_HDMI_PHY_CONF0_gen2_txpwron (1U) /*!< Bit field size in bits for HDMI_PHY_CONF0_gen2_txpwron. */

/*! @brief Read current value of the HDMI_PHY_CONF0_gen2_txpwron field. */
#define BR_HDMI_PHY_CONF0_gen2_txpwron(x) (HW_HDMI_PHY_CONF0(x).B.gen2_txpwron)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_gen2_txpwron. */
#define BF_HDMI_PHY_CONF0_gen2_txpwron(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_gen2_txpwron) & BM_HDMI_PHY_CONF0_gen2_txpwron)

/*! @brief Set the gen2_txpwron field to a new value. */
#define BW_HDMI_PHY_CONF0_gen2_txpwron(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_gen2_txpwron) | BF_HDMI_PHY_CONF0_gen2_txpwron(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field gen2_pddq[4] (RW)
 *
 * PHY_Gen2 PDDQ signal Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_gen2_pddq (4U)   /*!< Bit position for HDMI_PHY_CONF0_gen2_pddq. */
#define BM_HDMI_PHY_CONF0_gen2_pddq (0x10U) /*!< Bit mask for HDMI_PHY_CONF0_gen2_pddq. */
#define BS_HDMI_PHY_CONF0_gen2_pddq (1U)   /*!< Bit field size in bits for HDMI_PHY_CONF0_gen2_pddq. */

/*! @brief Read current value of the HDMI_PHY_CONF0_gen2_pddq field. */
#define BR_HDMI_PHY_CONF0_gen2_pddq(x) (HW_HDMI_PHY_CONF0(x).B.gen2_pddq)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_gen2_pddq. */
#define BF_HDMI_PHY_CONF0_gen2_pddq(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_gen2_pddq) & BM_HDMI_PHY_CONF0_gen2_pddq)

/*! @brief Set the gen2_pddq field to a new value. */
#define BW_HDMI_PHY_CONF0_gen2_pddq(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_gen2_pddq) | BF_HDMI_PHY_CONF0_gen2_pddq(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field sparectrl[5] (RW)
 *
 * Reserved. Spare pin control. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_sparectrl (5U)   /*!< Bit position for HDMI_PHY_CONF0_sparectrl. */
#define BM_HDMI_PHY_CONF0_sparectrl (0x20U) /*!< Bit mask for HDMI_PHY_CONF0_sparectrl. */
#define BS_HDMI_PHY_CONF0_sparectrl (1U)   /*!< Bit field size in bits for HDMI_PHY_CONF0_sparectrl. */

/*! @brief Read current value of the HDMI_PHY_CONF0_sparectrl field. */
#define BR_HDMI_PHY_CONF0_sparectrl(x) (HW_HDMI_PHY_CONF0(x).B.sparectrl)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_sparectrl. */
#define BF_HDMI_PHY_CONF0_sparectrl(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_sparectrl) & BM_HDMI_PHY_CONF0_sparectrl)

/*! @brief Set the sparectrl field to a new value. */
#define BW_HDMI_PHY_CONF0_sparectrl(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_sparectrl) | BF_HDMI_PHY_CONF0_sparectrl(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field ENTMDS[6] (RW)
 *
 * Enable TMDS drivers, bias, and TMDS digital logic. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_ENTMDS (6U)      /*!< Bit position for HDMI_PHY_CONF0_ENTMDS. */
#define BM_HDMI_PHY_CONF0_ENTMDS (0x40U)   /*!< Bit mask for HDMI_PHY_CONF0_ENTMDS. */
#define BS_HDMI_PHY_CONF0_ENTMDS (1U)      /*!< Bit field size in bits for HDMI_PHY_CONF0_ENTMDS. */

/*! @brief Read current value of the HDMI_PHY_CONF0_ENTMDS field. */
#define BR_HDMI_PHY_CONF0_ENTMDS(x) (HW_HDMI_PHY_CONF0(x).B.ENTMDS)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_ENTMDS. */
#define BF_HDMI_PHY_CONF0_ENTMDS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_ENTMDS) & BM_HDMI_PHY_CONF0_ENTMDS)

/*! @brief Set the ENTMDS field to a new value. */
#define BW_HDMI_PHY_CONF0_ENTMDS(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_ENTMDS) | BF_HDMI_PHY_CONF0_ENTMDS(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_CONF0, field PDZ[7] (RW)
 *
 * Power-down enable (active low 0b). Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_CONF0_PDZ (7U)         /*!< Bit position for HDMI_PHY_CONF0_PDZ. */
#define BM_HDMI_PHY_CONF0_PDZ (0x80U)      /*!< Bit mask for HDMI_PHY_CONF0_PDZ. */
#define BS_HDMI_PHY_CONF0_PDZ (1U)         /*!< Bit field size in bits for HDMI_PHY_CONF0_PDZ. */

/*! @brief Read current value of the HDMI_PHY_CONF0_PDZ field. */
#define BR_HDMI_PHY_CONF0_PDZ(x) (HW_HDMI_PHY_CONF0(x).B.PDZ)

/*! @brief Format value for bitfield HDMI_PHY_CONF0_PDZ. */
#define BF_HDMI_PHY_CONF0_PDZ(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_CONF0_PDZ) & BM_HDMI_PHY_CONF0_PDZ)

/*! @brief Set the PDZ field to a new value. */
#define BW_HDMI_PHY_CONF0_PDZ(x, v) (HW_HDMI_PHY_CONF0_WR(x, (HW_HDMI_PHY_CONF0_RD(x) & ~BM_HDMI_PHY_CONF0_PDZ) | BF_HDMI_PHY_CONF0_PDZ(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_TST0 - PHY Test Interface Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_TST0 - PHY Test Interface Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * PHY TX mapped text interface (control). For more information, refer to the
 * DesignWare Cores HDMI TX PHY Databook. Address Offset: 0x3001 Size: 8 bits Value
 * after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_tst0
{
    uint8_t U;
    struct _hw_hdmi_phy_tst0_bitfields
    {
        uint8_t testclk : 1;           /*!< [0]  */
        uint8_t RESERVED0 : 3;         /*!< [3:1]  */
        uint8_t testen : 1;            /*!< [4]  */
        uint8_t testclr : 1;           /*!< [5]  */
        uint8_t RESERVED1 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_phy_tst0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_TST0 register
 */
/*@{*/
#define HW_HDMI_PHY_TST0_ADDR(x) ((uintptr_t)(x) + 0x3001U)

#define HW_HDMI_PHY_TST0(x)      (*(__IO hw_hdmi_phy_tst0_t *) HW_HDMI_PHY_TST0_ADDR(x))
#define HW_HDMI_PHY_TST0_RD(x)   (HW_HDMI_PHY_TST0(x).U)
#define HW_HDMI_PHY_TST0_WR(x, v) (HW_HDMI_PHY_TST0(x).U = (v))
#define HW_HDMI_PHY_TST0_SET(x, v) (HW_HDMI_PHY_TST0_WR(x, HW_HDMI_PHY_TST0_RD(x) |  (v)))
#define HW_HDMI_PHY_TST0_CLR(x, v) (HW_HDMI_PHY_TST0_WR(x, HW_HDMI_PHY_TST0_RD(x) & ~(v)))
#define HW_HDMI_PHY_TST0_TOG(x, v) (HW_HDMI_PHY_TST0_WR(x, HW_HDMI_PHY_TST0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_TST0 bitfields
 */

/*!
 * @name Register HDMI_PHY_TST0, field testclk[0] (RW)
 *
 * Test clock signal. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_TST0_testclk (0U)      /*!< Bit position for HDMI_PHY_TST0_testclk. */
#define BM_HDMI_PHY_TST0_testclk (0x01U)   /*!< Bit mask for HDMI_PHY_TST0_testclk. */
#define BS_HDMI_PHY_TST0_testclk (1U)      /*!< Bit field size in bits for HDMI_PHY_TST0_testclk. */

/*! @brief Read current value of the HDMI_PHY_TST0_testclk field. */
#define BR_HDMI_PHY_TST0_testclk(x) (HW_HDMI_PHY_TST0(x).B.testclk)

/*! @brief Format value for bitfield HDMI_PHY_TST0_testclk. */
#define BF_HDMI_PHY_TST0_testclk(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_TST0_testclk) & BM_HDMI_PHY_TST0_testclk)

/*! @brief Set the testclk field to a new value. */
#define BW_HDMI_PHY_TST0_testclk(x, v) (HW_HDMI_PHY_TST0_WR(x, (HW_HDMI_PHY_TST0_RD(x) & ~BM_HDMI_PHY_TST0_testclk) | BF_HDMI_PHY_TST0_testclk(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_TST0, field testen[4] (RW)
 *
 * Reserved. Spare control pins. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_TST0_testen (4U)       /*!< Bit position for HDMI_PHY_TST0_testen. */
#define BM_HDMI_PHY_TST0_testen (0x10U)    /*!< Bit mask for HDMI_PHY_TST0_testen. */
#define BS_HDMI_PHY_TST0_testen (1U)       /*!< Bit field size in bits for HDMI_PHY_TST0_testen. */

/*! @brief Read current value of the HDMI_PHY_TST0_testen field. */
#define BR_HDMI_PHY_TST0_testen(x) (HW_HDMI_PHY_TST0(x).B.testen)

/*! @brief Format value for bitfield HDMI_PHY_TST0_testen. */
#define BF_HDMI_PHY_TST0_testen(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_TST0_testen) & BM_HDMI_PHY_TST0_testen)

/*! @brief Set the testen field to a new value. */
#define BW_HDMI_PHY_TST0_testen(x, v) (HW_HDMI_PHY_TST0_WR(x, (HW_HDMI_PHY_TST0_RD(x) & ~BM_HDMI_PHY_TST0_testen) | BF_HDMI_PHY_TST0_testen(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_TST0, field testclr[5] (RW)
 *
 * Enable TMDS drivers, bias and tmds digital logic. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_TST0_testclr (5U)      /*!< Bit position for HDMI_PHY_TST0_testclr. */
#define BM_HDMI_PHY_TST0_testclr (0x20U)   /*!< Bit mask for HDMI_PHY_TST0_testclr. */
#define BS_HDMI_PHY_TST0_testclr (1U)      /*!< Bit field size in bits for HDMI_PHY_TST0_testclr. */

/*! @brief Read current value of the HDMI_PHY_TST0_testclr field. */
#define BR_HDMI_PHY_TST0_testclr(x) (HW_HDMI_PHY_TST0(x).B.testclr)

/*! @brief Format value for bitfield HDMI_PHY_TST0_testclr. */
#define BF_HDMI_PHY_TST0_testclr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_TST0_testclr) & BM_HDMI_PHY_TST0_testclr)

/*! @brief Set the testclr field to a new value. */
#define BW_HDMI_PHY_TST0_testclr(x, v) (HW_HDMI_PHY_TST0_WR(x, (HW_HDMI_PHY_TST0_RD(x) & ~BM_HDMI_PHY_TST0_testclr) | BF_HDMI_PHY_TST0_testclr(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_TST1 - PHY Test Interface Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_TST1 - PHY Test Interface Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * PHY TX mapped text interface (data in). For more information, refer to the
 * DesignWare Cores HDMI TX PHY Databook. Address Offset: 0x3002 Size: 8 bits Value
 * after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_tst1
{
    uint8_t U;
    struct _hw_hdmi_phy_tst1_bitfields
    {
        uint8_t testdin : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_phy_tst1_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_TST1 register
 */
/*@{*/
#define HW_HDMI_PHY_TST1_ADDR(x) ((uintptr_t)(x) + 0x3002U)

#define HW_HDMI_PHY_TST1(x)      (*(__IO hw_hdmi_phy_tst1_t *) HW_HDMI_PHY_TST1_ADDR(x))
#define HW_HDMI_PHY_TST1_RD(x)   (HW_HDMI_PHY_TST1(x).U)
#define HW_HDMI_PHY_TST1_WR(x, v) (HW_HDMI_PHY_TST1(x).U = (v))
#define HW_HDMI_PHY_TST1_SET(x, v) (HW_HDMI_PHY_TST1_WR(x, HW_HDMI_PHY_TST1_RD(x) |  (v)))
#define HW_HDMI_PHY_TST1_CLR(x, v) (HW_HDMI_PHY_TST1_WR(x, HW_HDMI_PHY_TST1_RD(x) & ~(v)))
#define HW_HDMI_PHY_TST1_TOG(x, v) (HW_HDMI_PHY_TST1_WR(x, HW_HDMI_PHY_TST1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_TST1 bitfields
 */

/*!
 * @name Register HDMI_PHY_TST1, field testdin[7:0] (RW)
 *
 * Test data input.
 */
/*@{*/
#define BP_HDMI_PHY_TST1_testdin (0U)      /*!< Bit position for HDMI_PHY_TST1_testdin. */
#define BM_HDMI_PHY_TST1_testdin (0xFFU)   /*!< Bit mask for HDMI_PHY_TST1_testdin. */
#define BS_HDMI_PHY_TST1_testdin (8U)      /*!< Bit field size in bits for HDMI_PHY_TST1_testdin. */

/*! @brief Read current value of the HDMI_PHY_TST1_testdin field. */
#define BR_HDMI_PHY_TST1_testdin(x) (HW_HDMI_PHY_TST1(x).U)

/*! @brief Format value for bitfield HDMI_PHY_TST1_testdin. */
#define BF_HDMI_PHY_TST1_testdin(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_TST1_testdin) & BM_HDMI_PHY_TST1_testdin)

/*! @brief Set the testdin field to a new value. */
#define BW_HDMI_PHY_TST1_testdin(x, v) (HW_HDMI_PHY_TST1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_TST2 - PHY Test Interface Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_TST2 - PHY Test Interface Register 2 (RO)
 *
 * Reset value: 0x00U
 *
 * PHY TX mapped text interface (data out). For more information, refer to the
 * DesignWare Cores HDMI TX PHY Databook. Address Offset: 0x3003 Size: 8 bits
 * Value after Reset: N/A Access: Read
 */
typedef union _hw_hdmi_phy_tst2
{
    uint8_t U;
    struct _hw_hdmi_phy_tst2_bitfields
    {
        uint8_t testdout : 8;          /*!< [7:0]  */
    } B;
} hw_hdmi_phy_tst2_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_TST2 register
 */
/*@{*/
#define HW_HDMI_PHY_TST2_ADDR(x) ((uintptr_t)(x) + 0x3003U)

#define HW_HDMI_PHY_TST2(x)      (*(__I hw_hdmi_phy_tst2_t *) HW_HDMI_PHY_TST2_ADDR(x))
#define HW_HDMI_PHY_TST2_RD(x)   (HW_HDMI_PHY_TST2(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_TST2 bitfields
 */

/*!
 * @name Register HDMI_PHY_TST2, field testdout[7:0] (RO)
 *
 * Test data output.
 */
/*@{*/
#define BP_HDMI_PHY_TST2_testdout (0U)     /*!< Bit position for HDMI_PHY_TST2_testdout. */
#define BM_HDMI_PHY_TST2_testdout (0xFFU)  /*!< Bit mask for HDMI_PHY_TST2_testdout. */
#define BS_HDMI_PHY_TST2_testdout (8U)     /*!< Bit field size in bits for HDMI_PHY_TST2_testdout. */

/*! @brief Read current value of the HDMI_PHY_TST2_testdout field. */
#define BR_HDMI_PHY_TST2_testdout(x) (HW_HDMI_PHY_TST2(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_STAT0 - PHY RXSENSE, PLL lock, and HPD Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_STAT0 - PHY RXSENSE, PLL lock, and HPD Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the following active high packet sent status
 * indications. For more information, see Overview Address Offset: 0x3004 Size: 8 bits
 * Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_phy_stat0
{
    uint8_t U;
    struct _hw_hdmi_phy_stat0_bitfields
    {
        uint8_t TX_PHY_LOCK : 1;       /*!< [0]  */
        uint8_t HPD : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t RX_SENSE0 : 1;         /*!< [4]  */
        uint8_t RX_SENSE1 : 1;         /*!< [5]  */
        uint8_t RX_SENSE2 : 1;         /*!< [6]  */
        uint8_t RX_SENSE3 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_phy_stat0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_STAT0 register
 */
/*@{*/
#define HW_HDMI_PHY_STAT0_ADDR(x) ((uintptr_t)(x) + 0x3004U)

#define HW_HDMI_PHY_STAT0(x)     (*(__I hw_hdmi_phy_stat0_t *) HW_HDMI_PHY_STAT0_ADDR(x))
#define HW_HDMI_PHY_STAT0_RD(x)  (HW_HDMI_PHY_STAT0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_STAT0 bitfields
 */

/*!
 * @name Register HDMI_PHY_STAT0, field TX_PHY_LOCK[0] (RO)
 *
 * Status bit. TX PHY PLL lock indication. Please refer to PHY datasheet for
 * more information. User may need to mask or change polarity of this interrupt
 * after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_TX_PHY_LOCK (0U) /*!< Bit position for HDMI_PHY_STAT0_TX_PHY_LOCK. */
#define BM_HDMI_PHY_STAT0_TX_PHY_LOCK (0x01U) /*!< Bit mask for HDMI_PHY_STAT0_TX_PHY_LOCK. */
#define BS_HDMI_PHY_STAT0_TX_PHY_LOCK (1U) /*!< Bit field size in bits for HDMI_PHY_STAT0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_PHY_STAT0_TX_PHY_LOCK field. */
#define BR_HDMI_PHY_STAT0_TX_PHY_LOCK(x) (HW_HDMI_PHY_STAT0(x).B.TX_PHY_LOCK)
/*@}*/

/*!
 * @name Register HDMI_PHY_STAT0, field HPD[1] (RO)
 *
 * Status bit. HDMI Hot Plug Detect indication. User may need to mask or change
 * polarity of this interrupt after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_HPD (1U)         /*!< Bit position for HDMI_PHY_STAT0_HPD. */
#define BM_HDMI_PHY_STAT0_HPD (0x02U)      /*!< Bit mask for HDMI_PHY_STAT0_HPD. */
#define BS_HDMI_PHY_STAT0_HPD (1U)         /*!< Bit field size in bits for HDMI_PHY_STAT0_HPD. */

/*! @brief Read current value of the HDMI_PHY_STAT0_HPD field. */
#define BR_HDMI_PHY_STAT0_HPD(x) (HW_HDMI_PHY_STAT0(x).B.HPD)
/*@}*/

/*!
 * @name Register HDMI_PHY_STAT0, field RX_SENSE0[4] (RO)
 *
 * Status bit. TX PHY RX_SENSE indication for TMDS channel 0 driver. User may
 * need to mask or change polarity of this interrupt after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_RX_SENSE0 (4U)   /*!< Bit position for HDMI_PHY_STAT0_RX_SENSE0. */
#define BM_HDMI_PHY_STAT0_RX_SENSE0 (0x10U) /*!< Bit mask for HDMI_PHY_STAT0_RX_SENSE0. */
#define BS_HDMI_PHY_STAT0_RX_SENSE0 (1U)   /*!< Bit field size in bits for HDMI_PHY_STAT0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_PHY_STAT0_RX_SENSE0 field. */
#define BR_HDMI_PHY_STAT0_RX_SENSE0(x) (HW_HDMI_PHY_STAT0(x).B.RX_SENSE0)
/*@}*/

/*!
 * @name Register HDMI_PHY_STAT0, field RX_SENSE1[5] (RO)
 *
 * Status bit. TX PHY RX_SENSE indication for TMDS channel 1 driver. User may
 * need to mask or change polarity of this interrupt after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_RX_SENSE1 (5U)   /*!< Bit position for HDMI_PHY_STAT0_RX_SENSE1. */
#define BM_HDMI_PHY_STAT0_RX_SENSE1 (0x20U) /*!< Bit mask for HDMI_PHY_STAT0_RX_SENSE1. */
#define BS_HDMI_PHY_STAT0_RX_SENSE1 (1U)   /*!< Bit field size in bits for HDMI_PHY_STAT0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_PHY_STAT0_RX_SENSE1 field. */
#define BR_HDMI_PHY_STAT0_RX_SENSE1(x) (HW_HDMI_PHY_STAT0(x).B.RX_SENSE1)
/*@}*/

/*!
 * @name Register HDMI_PHY_STAT0, field RX_SENSE2[6] (RO)
 *
 * Status bit. TX PHY RX_SENSE indication for TMDS channel 2 driver. User may
 * need to mask or change polarity of this interrupt after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_RX_SENSE2 (6U)   /*!< Bit position for HDMI_PHY_STAT0_RX_SENSE2. */
#define BM_HDMI_PHY_STAT0_RX_SENSE2 (0x40U) /*!< Bit mask for HDMI_PHY_STAT0_RX_SENSE2. */
#define BS_HDMI_PHY_STAT0_RX_SENSE2 (1U)   /*!< Bit field size in bits for HDMI_PHY_STAT0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_PHY_STAT0_RX_SENSE2 field. */
#define BR_HDMI_PHY_STAT0_RX_SENSE2(x) (HW_HDMI_PHY_STAT0(x).B.RX_SENSE2)
/*@}*/

/*!
 * @name Register HDMI_PHY_STAT0, field RX_SENSE3[7] (RO)
 *
 * Status bit. TX PHY RX_SENSE indication for TMDS CLK driver. User may need to
 * mask or change polarity of this interrupt after it has became active.
 */
/*@{*/
#define BP_HDMI_PHY_STAT0_RX_SENSE3 (7U)   /*!< Bit position for HDMI_PHY_STAT0_RX_SENSE3. */
#define BM_HDMI_PHY_STAT0_RX_SENSE3 (0x80U) /*!< Bit mask for HDMI_PHY_STAT0_RX_SENSE3. */
#define BS_HDMI_PHY_STAT0_RX_SENSE3 (1U)   /*!< Bit field size in bits for HDMI_PHY_STAT0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_PHY_STAT0_RX_SENSE3 field. */
#define BR_HDMI_PHY_STAT0_RX_SENSE3(x) (HW_HDMI_PHY_STAT0(x).B.RX_SENSE3)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_INT0 - PHY RXSENSE, PLL lock, and HPD Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_INT0 - PHY RXSENSE, PLL lock, and HPD Interrupt Register (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt indication of the PHY_STAT0 status
 * interrupts. Interrupt generation is accomplished in the following way: interrupt =
 * (mask == 1'b0) && (polarity == status); All this interrupts are forwarded to
 * the Interrupt Handler sticky bit registers and after ORed to a single main
 * interrupt line to micro controller. Assertion of this interrupt implies that data
 * related with the corresponding packet has been sent through the HDMI
 * interface. Address Offset: 0x3005 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_phy_int0
{
    uint8_t U;
    struct _hw_hdmi_phy_int0_bitfields
    {
        uint8_t TX_PHY_LOCK : 1;       /*!< [0]  */
        uint8_t HPD : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t RX_SENSE0 : 1;         /*!< [4]  */
        uint8_t RX_SENSE1 : 1;         /*!< [5]  */
        uint8_t RX_SENSE2 : 1;         /*!< [6]  */
        uint8_t RX_SENSE3 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_phy_int0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_INT0 register
 */
/*@{*/
#define HW_HDMI_PHY_INT0_ADDR(x) ((uintptr_t)(x) + 0x3005U)

#define HW_HDMI_PHY_INT0(x)      (*(__I hw_hdmi_phy_int0_t *) HW_HDMI_PHY_INT0_ADDR(x))
#define HW_HDMI_PHY_INT0_RD(x)   (HW_HDMI_PHY_INT0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_INT0 bitfields
 */

/*!
 * @name Register HDMI_PHY_INT0, field TX_PHY_LOCK[0] (RO)
 *
 * Interrupt indication bit TX PHY PLL lock indication interrupt.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_TX_PHY_LOCK (0U)  /*!< Bit position for HDMI_PHY_INT0_TX_PHY_LOCK. */
#define BM_HDMI_PHY_INT0_TX_PHY_LOCK (0x01U) /*!< Bit mask for HDMI_PHY_INT0_TX_PHY_LOCK. */
#define BS_HDMI_PHY_INT0_TX_PHY_LOCK (1U)  /*!< Bit field size in bits for HDMI_PHY_INT0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_PHY_INT0_TX_PHY_LOCK field. */
#define BR_HDMI_PHY_INT0_TX_PHY_LOCK(x) (HW_HDMI_PHY_INT0(x).B.TX_PHY_LOCK)
/*@}*/

/*!
 * @name Register HDMI_PHY_INT0, field HPD[1] (RO)
 *
 * Interrupt indication bit HDMI Hot Plug Detect indication interrupt.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_HPD (1U)          /*!< Bit position for HDMI_PHY_INT0_HPD. */
#define BM_HDMI_PHY_INT0_HPD (0x02U)       /*!< Bit mask for HDMI_PHY_INT0_HPD. */
#define BS_HDMI_PHY_INT0_HPD (1U)          /*!< Bit field size in bits for HDMI_PHY_INT0_HPD. */

/*! @brief Read current value of the HDMI_PHY_INT0_HPD field. */
#define BR_HDMI_PHY_INT0_HPD(x) (HW_HDMI_PHY_INT0(x).B.HPD)
/*@}*/

/*!
 * @name Register HDMI_PHY_INT0, field RX_SENSE0[4] (RO)
 *
 * Interrupt indication bit TX PHY RX_SENSE indication interrupt for TMDS
 * channel 0 driver.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_RX_SENSE0 (4U)    /*!< Bit position for HDMI_PHY_INT0_RX_SENSE0. */
#define BM_HDMI_PHY_INT0_RX_SENSE0 (0x10U) /*!< Bit mask for HDMI_PHY_INT0_RX_SENSE0. */
#define BS_HDMI_PHY_INT0_RX_SENSE0 (1U)    /*!< Bit field size in bits for HDMI_PHY_INT0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_PHY_INT0_RX_SENSE0 field. */
#define BR_HDMI_PHY_INT0_RX_SENSE0(x) (HW_HDMI_PHY_INT0(x).B.RX_SENSE0)
/*@}*/

/*!
 * @name Register HDMI_PHY_INT0, field RX_SENSE1[5] (RO)
 *
 * Interrupt indication bit TX PHY RX_SENSE indication interrupt for TMDS
 * channel 1 driver.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_RX_SENSE1 (5U)    /*!< Bit position for HDMI_PHY_INT0_RX_SENSE1. */
#define BM_HDMI_PHY_INT0_RX_SENSE1 (0x20U) /*!< Bit mask for HDMI_PHY_INT0_RX_SENSE1. */
#define BS_HDMI_PHY_INT0_RX_SENSE1 (1U)    /*!< Bit field size in bits for HDMI_PHY_INT0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_PHY_INT0_RX_SENSE1 field. */
#define BR_HDMI_PHY_INT0_RX_SENSE1(x) (HW_HDMI_PHY_INT0(x).B.RX_SENSE1)
/*@}*/

/*!
 * @name Register HDMI_PHY_INT0, field RX_SENSE2[6] (RO)
 *
 * Interrupt indication bit TX PHY RX_SENSE indication interrupt for TMDS
 * channel 2 driver.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_RX_SENSE2 (6U)    /*!< Bit position for HDMI_PHY_INT0_RX_SENSE2. */
#define BM_HDMI_PHY_INT0_RX_SENSE2 (0x40U) /*!< Bit mask for HDMI_PHY_INT0_RX_SENSE2. */
#define BS_HDMI_PHY_INT0_RX_SENSE2 (1U)    /*!< Bit field size in bits for HDMI_PHY_INT0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_PHY_INT0_RX_SENSE2 field. */
#define BR_HDMI_PHY_INT0_RX_SENSE2(x) (HW_HDMI_PHY_INT0(x).B.RX_SENSE2)
/*@}*/

/*!
 * @name Register HDMI_PHY_INT0, field RX_SENSE3[7] (RO)
 *
 * Interrupt indication bit TX PHY RX_SENSE indication interrupt for TMDS CLK
 * driver.
 */
/*@{*/
#define BP_HDMI_PHY_INT0_RX_SENSE3 (7U)    /*!< Bit position for HDMI_PHY_INT0_RX_SENSE3. */
#define BM_HDMI_PHY_INT0_RX_SENSE3 (0x80U) /*!< Bit mask for HDMI_PHY_INT0_RX_SENSE3. */
#define BS_HDMI_PHY_INT0_RX_SENSE3 (1U)    /*!< Bit field size in bits for HDMI_PHY_INT0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_PHY_INT0_RX_SENSE3 field. */
#define BR_HDMI_PHY_INT0_RX_SENSE3(x) (HW_HDMI_PHY_INT0(x).B.RX_SENSE3)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_MASK0 - PHY RXSENSE, PLL lock, and HPD Mask Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_MASK0 - PHY RXSENSE, PLL lock, and HPD Mask Register (RW)
 *
 * Reset value: 0x00U
 *
 * Mask register for generation of PHY_INT0 interrupts. Address Offset: 0x3006
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_mask0
{
    uint8_t U;
    struct _hw_hdmi_phy_mask0_bitfields
    {
        uint8_t TX_PHY_LOCK : 1;       /*!< [0]  */
        uint8_t HPD : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t RX_SENSE0 : 1;         /*!< [4]  */
        uint8_t RX_SENSE1 : 1;         /*!< [5]  */
        uint8_t RX_SENSE2 : 1;         /*!< [6]  */
        uint8_t RX_SENSE3 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_phy_mask0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_MASK0 register
 */
/*@{*/
#define HW_HDMI_PHY_MASK0_ADDR(x) ((uintptr_t)(x) + 0x3006U)

#define HW_HDMI_PHY_MASK0(x)     (*(__IO hw_hdmi_phy_mask0_t *) HW_HDMI_PHY_MASK0_ADDR(x))
#define HW_HDMI_PHY_MASK0_RD(x)  (HW_HDMI_PHY_MASK0(x).U)
#define HW_HDMI_PHY_MASK0_WR(x, v) (HW_HDMI_PHY_MASK0(x).U = (v))
#define HW_HDMI_PHY_MASK0_SET(x, v) (HW_HDMI_PHY_MASK0_WR(x, HW_HDMI_PHY_MASK0_RD(x) |  (v)))
#define HW_HDMI_PHY_MASK0_CLR(x, v) (HW_HDMI_PHY_MASK0_WR(x, HW_HDMI_PHY_MASK0_RD(x) & ~(v)))
#define HW_HDMI_PHY_MASK0_TOG(x, v) (HW_HDMI_PHY_MASK0_WR(x, HW_HDMI_PHY_MASK0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_MASK0 bitfields
 */

/*!
 * @name Register HDMI_PHY_MASK0, field TX_PHY_LOCK[0] (RW)
 *
 * Mask bit for PHY_INT0.TX_PHY_LOCK interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_TX_PHY_LOCK (0U) /*!< Bit position for HDMI_PHY_MASK0_TX_PHY_LOCK. */
#define BM_HDMI_PHY_MASK0_TX_PHY_LOCK (0x01U) /*!< Bit mask for HDMI_PHY_MASK0_TX_PHY_LOCK. */
#define BS_HDMI_PHY_MASK0_TX_PHY_LOCK (1U) /*!< Bit field size in bits for HDMI_PHY_MASK0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_PHY_MASK0_TX_PHY_LOCK field. */
#define BR_HDMI_PHY_MASK0_TX_PHY_LOCK(x) (HW_HDMI_PHY_MASK0(x).B.TX_PHY_LOCK)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_TX_PHY_LOCK. */
#define BF_HDMI_PHY_MASK0_TX_PHY_LOCK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_TX_PHY_LOCK) & BM_HDMI_PHY_MASK0_TX_PHY_LOCK)

/*! @brief Set the TX_PHY_LOCK field to a new value. */
#define BW_HDMI_PHY_MASK0_TX_PHY_LOCK(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_TX_PHY_LOCK) | BF_HDMI_PHY_MASK0_TX_PHY_LOCK(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_MASK0, field HPD[1] (RW)
 *
 * Mask bit for PHY_INT0.HPD interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_HPD (1U)         /*!< Bit position for HDMI_PHY_MASK0_HPD. */
#define BM_HDMI_PHY_MASK0_HPD (0x02U)      /*!< Bit mask for HDMI_PHY_MASK0_HPD. */
#define BS_HDMI_PHY_MASK0_HPD (1U)         /*!< Bit field size in bits for HDMI_PHY_MASK0_HPD. */

/*! @brief Read current value of the HDMI_PHY_MASK0_HPD field. */
#define BR_HDMI_PHY_MASK0_HPD(x) (HW_HDMI_PHY_MASK0(x).B.HPD)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_HPD. */
#define BF_HDMI_PHY_MASK0_HPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_HPD) & BM_HDMI_PHY_MASK0_HPD)

/*! @brief Set the HPD field to a new value. */
#define BW_HDMI_PHY_MASK0_HPD(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_HPD) | BF_HDMI_PHY_MASK0_HPD(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_MASK0, field RX_SENSE0[4] (RW)
 *
 * Mask bit for PHY_INT0.RX_SENSE0 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_RX_SENSE0 (4U)   /*!< Bit position for HDMI_PHY_MASK0_RX_SENSE0. */
#define BM_HDMI_PHY_MASK0_RX_SENSE0 (0x10U) /*!< Bit mask for HDMI_PHY_MASK0_RX_SENSE0. */
#define BS_HDMI_PHY_MASK0_RX_SENSE0 (1U)   /*!< Bit field size in bits for HDMI_PHY_MASK0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_PHY_MASK0_RX_SENSE0 field. */
#define BR_HDMI_PHY_MASK0_RX_SENSE0(x) (HW_HDMI_PHY_MASK0(x).B.RX_SENSE0)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_RX_SENSE0. */
#define BF_HDMI_PHY_MASK0_RX_SENSE0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_RX_SENSE0) & BM_HDMI_PHY_MASK0_RX_SENSE0)

/*! @brief Set the RX_SENSE0 field to a new value. */
#define BW_HDMI_PHY_MASK0_RX_SENSE0(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_RX_SENSE0) | BF_HDMI_PHY_MASK0_RX_SENSE0(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_MASK0, field RX_SENSE1[5] (RW)
 *
 * Mask bit for PHY_INT0.RX_SENSE1 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_RX_SENSE1 (5U)   /*!< Bit position for HDMI_PHY_MASK0_RX_SENSE1. */
#define BM_HDMI_PHY_MASK0_RX_SENSE1 (0x20U) /*!< Bit mask for HDMI_PHY_MASK0_RX_SENSE1. */
#define BS_HDMI_PHY_MASK0_RX_SENSE1 (1U)   /*!< Bit field size in bits for HDMI_PHY_MASK0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_PHY_MASK0_RX_SENSE1 field. */
#define BR_HDMI_PHY_MASK0_RX_SENSE1(x) (HW_HDMI_PHY_MASK0(x).B.RX_SENSE1)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_RX_SENSE1. */
#define BF_HDMI_PHY_MASK0_RX_SENSE1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_RX_SENSE1) & BM_HDMI_PHY_MASK0_RX_SENSE1)

/*! @brief Set the RX_SENSE1 field to a new value. */
#define BW_HDMI_PHY_MASK0_RX_SENSE1(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_RX_SENSE1) | BF_HDMI_PHY_MASK0_RX_SENSE1(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_MASK0, field RX_SENSE2[6] (RW)
 *
 * Mask bit for PHY_INT0.RX_SENSE2 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_RX_SENSE2 (6U)   /*!< Bit position for HDMI_PHY_MASK0_RX_SENSE2. */
#define BM_HDMI_PHY_MASK0_RX_SENSE2 (0x40U) /*!< Bit mask for HDMI_PHY_MASK0_RX_SENSE2. */
#define BS_HDMI_PHY_MASK0_RX_SENSE2 (1U)   /*!< Bit field size in bits for HDMI_PHY_MASK0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_PHY_MASK0_RX_SENSE2 field. */
#define BR_HDMI_PHY_MASK0_RX_SENSE2(x) (HW_HDMI_PHY_MASK0(x).B.RX_SENSE2)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_RX_SENSE2. */
#define BF_HDMI_PHY_MASK0_RX_SENSE2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_RX_SENSE2) & BM_HDMI_PHY_MASK0_RX_SENSE2)

/*! @brief Set the RX_SENSE2 field to a new value. */
#define BW_HDMI_PHY_MASK0_RX_SENSE2(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_RX_SENSE2) | BF_HDMI_PHY_MASK0_RX_SENSE2(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_MASK0, field RX_SENSE3[7] (RW)
 *
 * Mask bit for PHY_INT0.RX_SENSE3 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_MASK0_RX_SENSE3 (7U)   /*!< Bit position for HDMI_PHY_MASK0_RX_SENSE3. */
#define BM_HDMI_PHY_MASK0_RX_SENSE3 (0x80U) /*!< Bit mask for HDMI_PHY_MASK0_RX_SENSE3. */
#define BS_HDMI_PHY_MASK0_RX_SENSE3 (1U)   /*!< Bit field size in bits for HDMI_PHY_MASK0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_PHY_MASK0_RX_SENSE3 field. */
#define BR_HDMI_PHY_MASK0_RX_SENSE3(x) (HW_HDMI_PHY_MASK0(x).B.RX_SENSE3)

/*! @brief Format value for bitfield HDMI_PHY_MASK0_RX_SENSE3. */
#define BF_HDMI_PHY_MASK0_RX_SENSE3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_MASK0_RX_SENSE3) & BM_HDMI_PHY_MASK0_RX_SENSE3)

/*! @brief Set the RX_SENSE3 field to a new value. */
#define BW_HDMI_PHY_MASK0_RX_SENSE3(x, v) (HW_HDMI_PHY_MASK0_WR(x, (HW_HDMI_PHY_MASK0_RD(x) & ~BM_HDMI_PHY_MASK0_RX_SENSE3) | BF_HDMI_PHY_MASK0_RX_SENSE3(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_POL0 - PHY RXSENSE, PLL lock and HPD Polarity Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_POL0 - PHY RXSENSE, PLL lock and HPD Polarity Register (RW)
 *
 * Reset value: 0xF3U
 *
 * Polarity register for generation of PHY_INT0 interrupts. Address Offset:
 * 0x3007 Size: 8 bits Value after Reset: 0xF3 Access: Read/Write
 */
typedef union _hw_hdmi_phy_pol0
{
    uint8_t U;
    struct _hw_hdmi_phy_pol0_bitfields
    {
        uint8_t TX_PHY_LOCK : 1;       /*!< [0]  */
        uint8_t HPD : 1;               /*!< [1]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t RX_SENSE0 : 1;         /*!< [4]  */
        uint8_t RX_SENSE1 : 1;         /*!< [5]  */
        uint8_t RX_SENSE2 : 1;         /*!< [6]  */
        uint8_t RX_SENSE3 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_phy_pol0_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_POL0 register
 */
/*@{*/
#define HW_HDMI_PHY_POL0_ADDR(x) ((uintptr_t)(x) + 0x3007U)

#define HW_HDMI_PHY_POL0(x)      (*(__IO hw_hdmi_phy_pol0_t *) HW_HDMI_PHY_POL0_ADDR(x))
#define HW_HDMI_PHY_POL0_RD(x)   (HW_HDMI_PHY_POL0(x).U)
#define HW_HDMI_PHY_POL0_WR(x, v) (HW_HDMI_PHY_POL0(x).U = (v))
#define HW_HDMI_PHY_POL0_SET(x, v) (HW_HDMI_PHY_POL0_WR(x, HW_HDMI_PHY_POL0_RD(x) |  (v)))
#define HW_HDMI_PHY_POL0_CLR(x, v) (HW_HDMI_PHY_POL0_WR(x, HW_HDMI_PHY_POL0_RD(x) & ~(v)))
#define HW_HDMI_PHY_POL0_TOG(x, v) (HW_HDMI_PHY_POL0_WR(x, HW_HDMI_PHY_POL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_POL0 bitfields
 */

/*!
 * @name Register HDMI_PHY_POL0, field TX_PHY_LOCK[0] (RW)
 *
 * Polarity bit for PHY_INT0.TX_PHY_LOCK interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_TX_PHY_LOCK (0U)  /*!< Bit position for HDMI_PHY_POL0_TX_PHY_LOCK. */
#define BM_HDMI_PHY_POL0_TX_PHY_LOCK (0x01U) /*!< Bit mask for HDMI_PHY_POL0_TX_PHY_LOCK. */
#define BS_HDMI_PHY_POL0_TX_PHY_LOCK (1U)  /*!< Bit field size in bits for HDMI_PHY_POL0_TX_PHY_LOCK. */

/*! @brief Read current value of the HDMI_PHY_POL0_TX_PHY_LOCK field. */
#define BR_HDMI_PHY_POL0_TX_PHY_LOCK(x) (HW_HDMI_PHY_POL0(x).B.TX_PHY_LOCK)

/*! @brief Format value for bitfield HDMI_PHY_POL0_TX_PHY_LOCK. */
#define BF_HDMI_PHY_POL0_TX_PHY_LOCK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_TX_PHY_LOCK) & BM_HDMI_PHY_POL0_TX_PHY_LOCK)

/*! @brief Set the TX_PHY_LOCK field to a new value. */
#define BW_HDMI_PHY_POL0_TX_PHY_LOCK(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_TX_PHY_LOCK) | BF_HDMI_PHY_POL0_TX_PHY_LOCK(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_POL0, field HPD[1] (RW)
 *
 * Polarity bit for PHY_INT0.HPD interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_HPD (1U)          /*!< Bit position for HDMI_PHY_POL0_HPD. */
#define BM_HDMI_PHY_POL0_HPD (0x02U)       /*!< Bit mask for HDMI_PHY_POL0_HPD. */
#define BS_HDMI_PHY_POL0_HPD (1U)          /*!< Bit field size in bits for HDMI_PHY_POL0_HPD. */

/*! @brief Read current value of the HDMI_PHY_POL0_HPD field. */
#define BR_HDMI_PHY_POL0_HPD(x) (HW_HDMI_PHY_POL0(x).B.HPD)

/*! @brief Format value for bitfield HDMI_PHY_POL0_HPD. */
#define BF_HDMI_PHY_POL0_HPD(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_HPD) & BM_HDMI_PHY_POL0_HPD)

/*! @brief Set the HPD field to a new value. */
#define BW_HDMI_PHY_POL0_HPD(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_HPD) | BF_HDMI_PHY_POL0_HPD(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_POL0, field RX_SENSE0[4] (RW)
 *
 * Polarity bit for PHY_INT0.RX_SENSE0 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_RX_SENSE0 (4U)    /*!< Bit position for HDMI_PHY_POL0_RX_SENSE0. */
#define BM_HDMI_PHY_POL0_RX_SENSE0 (0x10U) /*!< Bit mask for HDMI_PHY_POL0_RX_SENSE0. */
#define BS_HDMI_PHY_POL0_RX_SENSE0 (1U)    /*!< Bit field size in bits for HDMI_PHY_POL0_RX_SENSE0. */

/*! @brief Read current value of the HDMI_PHY_POL0_RX_SENSE0 field. */
#define BR_HDMI_PHY_POL0_RX_SENSE0(x) (HW_HDMI_PHY_POL0(x).B.RX_SENSE0)

/*! @brief Format value for bitfield HDMI_PHY_POL0_RX_SENSE0. */
#define BF_HDMI_PHY_POL0_RX_SENSE0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_RX_SENSE0) & BM_HDMI_PHY_POL0_RX_SENSE0)

/*! @brief Set the RX_SENSE0 field to a new value. */
#define BW_HDMI_PHY_POL0_RX_SENSE0(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_RX_SENSE0) | BF_HDMI_PHY_POL0_RX_SENSE0(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_POL0, field RX_SENSE1[5] (RW)
 *
 * Polarity bit for PHY_INT0.RX_SENSE1 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_RX_SENSE1 (5U)    /*!< Bit position for HDMI_PHY_POL0_RX_SENSE1. */
#define BM_HDMI_PHY_POL0_RX_SENSE1 (0x20U) /*!< Bit mask for HDMI_PHY_POL0_RX_SENSE1. */
#define BS_HDMI_PHY_POL0_RX_SENSE1 (1U)    /*!< Bit field size in bits for HDMI_PHY_POL0_RX_SENSE1. */

/*! @brief Read current value of the HDMI_PHY_POL0_RX_SENSE1 field. */
#define BR_HDMI_PHY_POL0_RX_SENSE1(x) (HW_HDMI_PHY_POL0(x).B.RX_SENSE1)

/*! @brief Format value for bitfield HDMI_PHY_POL0_RX_SENSE1. */
#define BF_HDMI_PHY_POL0_RX_SENSE1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_RX_SENSE1) & BM_HDMI_PHY_POL0_RX_SENSE1)

/*! @brief Set the RX_SENSE1 field to a new value. */
#define BW_HDMI_PHY_POL0_RX_SENSE1(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_RX_SENSE1) | BF_HDMI_PHY_POL0_RX_SENSE1(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_POL0, field RX_SENSE2[6] (RW)
 *
 * Polarity bit for PHY_INT0.RX_SENSE2 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_RX_SENSE2 (6U)    /*!< Bit position for HDMI_PHY_POL0_RX_SENSE2. */
#define BM_HDMI_PHY_POL0_RX_SENSE2 (0x40U) /*!< Bit mask for HDMI_PHY_POL0_RX_SENSE2. */
#define BS_HDMI_PHY_POL0_RX_SENSE2 (1U)    /*!< Bit field size in bits for HDMI_PHY_POL0_RX_SENSE2. */

/*! @brief Read current value of the HDMI_PHY_POL0_RX_SENSE2 field. */
#define BR_HDMI_PHY_POL0_RX_SENSE2(x) (HW_HDMI_PHY_POL0(x).B.RX_SENSE2)

/*! @brief Format value for bitfield HDMI_PHY_POL0_RX_SENSE2. */
#define BF_HDMI_PHY_POL0_RX_SENSE2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_RX_SENSE2) & BM_HDMI_PHY_POL0_RX_SENSE2)

/*! @brief Set the RX_SENSE2 field to a new value. */
#define BW_HDMI_PHY_POL0_RX_SENSE2(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_RX_SENSE2) | BF_HDMI_PHY_POL0_RX_SENSE2(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_POL0, field RX_SENSE3[7] (RW)
 *
 * Polarity bit for PHY_INT0.RX_SENSE3 interrupt bit
 */
/*@{*/
#define BP_HDMI_PHY_POL0_RX_SENSE3 (7U)    /*!< Bit position for HDMI_PHY_POL0_RX_SENSE3. */
#define BM_HDMI_PHY_POL0_RX_SENSE3 (0x80U) /*!< Bit mask for HDMI_PHY_POL0_RX_SENSE3. */
#define BS_HDMI_PHY_POL0_RX_SENSE3 (1U)    /*!< Bit field size in bits for HDMI_PHY_POL0_RX_SENSE3. */

/*! @brief Read current value of the HDMI_PHY_POL0_RX_SENSE3 field. */
#define BR_HDMI_PHY_POL0_RX_SENSE3(x) (HW_HDMI_PHY_POL0(x).B.RX_SENSE3)

/*! @brief Format value for bitfield HDMI_PHY_POL0_RX_SENSE3. */
#define BF_HDMI_PHY_POL0_RX_SENSE3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_POL0_RX_SENSE3) & BM_HDMI_PHY_POL0_RX_SENSE3)

/*! @brief Set the RX_SENSE3 field to a new value. */
#define BW_HDMI_PHY_POL0_RX_SENSE3(x, v) (HW_HDMI_PHY_POL0_WR(x, (HW_HDMI_PHY_POL0_RD(x) & ~BM_HDMI_PHY_POL0_RX_SENSE3) | BF_HDMI_PHY_POL0_RX_SENSE3(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SLAVE_ADDR - PHY I2C Slave Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SLAVE_ADDR - PHY I2C Slave Address Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register writes the slave address of the I2C Master PHY. Address Offset:
 * 0x3020 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_slave_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_slave_addr_bitfields
    {
        uint8_t RESERVED0 : 8;         /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_slave_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SLAVE_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3020U)

#define HW_HDMI_PHY_I2CM_SLAVE_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_slave_addr_t *) HW_HDMI_PHY_I2CM_SLAVE_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SLAVE_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SLAVE_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SLAVE_ADDR_WR(x, HW_HDMI_PHY_I2CM_SLAVE_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SLAVE_ADDR_WR(x, HW_HDMI_PHY_I2CM_SLAVE_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SLAVE_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SLAVE_ADDR_WR(x, HW_HDMI_PHY_I2CM_SLAVE_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SLAVE_ADDR bitfields
 */

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_ADDRESS_ADDR - PHY I2C Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_ADDRESS_ADDR - PHY I2C Address Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register writes the address for read and writer operations. Address
 * Offset: 0x3021 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_address_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_address_addr_bitfields
    {
        uint8_t address : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_address_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_ADDRESS_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3021U)

#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_address_addr_t *) HW_HDMI_PHY_I2CM_ADDRESS_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_RD(x) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR_WR(x, HW_HDMI_PHY_I2CM_ADDRESS_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR_WR(x, HW_HDMI_PHY_I2CM_ADDRESS_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_ADDRESS_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR_WR(x, HW_HDMI_PHY_I2CM_ADDRESS_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_ADDRESS_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_ADDRESS_ADDR, field address[7:0] (RW)
 *
 * Register address for read and write operations.
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_ADDRESS_ADDR_address (0U) /*!< Bit position for HDMI_PHY_I2CM_ADDRESS_ADDR_address. */
#define BM_HDMI_PHY_I2CM_ADDRESS_ADDR_address (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_ADDRESS_ADDR_address. */
#define BS_HDMI_PHY_I2CM_ADDRESS_ADDR_address (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_ADDRESS_ADDR_address. */

/*! @brief Read current value of the HDMI_PHY_I2CM_ADDRESS_ADDR_address field. */
#define BR_HDMI_PHY_I2CM_ADDRESS_ADDR_address(x) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_ADDRESS_ADDR_address. */
#define BF_HDMI_PHY_I2CM_ADDRESS_ADDR_address(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_ADDRESS_ADDR_address) & BM_HDMI_PHY_I2CM_ADDRESS_ADDR_address)

/*! @brief Set the address field to a new value. */
#define BW_HDMI_PHY_I2CM_ADDRESS_ADDR_address(x, v) (HW_HDMI_PHY_I2CM_ADDRESS_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_DATAO_1_ADDR - PHY I2C Data Write Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_DATAO_1_ADDR - PHY I2C Data Write Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3022 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_datao_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_datao_1_addr_bitfields
    {
        uint8_t datao : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_datao_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_DATAO_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3022U)

#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_datao_1_addr_t *) HW_HDMI_PHY_I2CM_DATAO_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_DATAO_1_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_DATAO_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_DATAO_1_ADDR, field datao[7:0] (RW)
 *
 * MSB's of data to be written on register pointed by address [7:0].
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_DATAO_1_ADDR_datao (0U) /*!< Bit position for HDMI_PHY_I2CM_DATAO_1_ADDR_datao. */
#define BM_HDMI_PHY_I2CM_DATAO_1_ADDR_datao (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_DATAO_1_ADDR_datao. */
#define BS_HDMI_PHY_I2CM_DATAO_1_ADDR_datao (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_DATAO_1_ADDR_datao. */

/*! @brief Read current value of the HDMI_PHY_I2CM_DATAO_1_ADDR_datao field. */
#define BR_HDMI_PHY_I2CM_DATAO_1_ADDR_datao(x) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_DATAO_1_ADDR_datao. */
#define BF_HDMI_PHY_I2CM_DATAO_1_ADDR_datao(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_DATAO_1_ADDR_datao) & BM_HDMI_PHY_I2CM_DATAO_1_ADDR_datao)

/*! @brief Set the datao field to a new value. */
#define BW_HDMI_PHY_I2CM_DATAO_1_ADDR_datao(x, v) (HW_HDMI_PHY_I2CM_DATAO_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_DATAO_0_ADDR - PHY I2C Data Write Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_DATAO_0_ADDR - PHY I2C Data Write Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3023 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_datao_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_datao_0_addr_bitfields
    {
        uint8_t datao : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_datao_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_DATAO_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3023U)

#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_datao_0_addr_t *) HW_HDMI_PHY_I2CM_DATAO_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_DATAO_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAO_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_DATAO_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_DATAO_0_ADDR, field datao[7:0] (RW)
 *
 * LSB's of data to be written on register pointed by address [7:0].
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_DATAO_0_ADDR_datao (0U) /*!< Bit position for HDMI_PHY_I2CM_DATAO_0_ADDR_datao. */
#define BM_HDMI_PHY_I2CM_DATAO_0_ADDR_datao (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_DATAO_0_ADDR_datao. */
#define BS_HDMI_PHY_I2CM_DATAO_0_ADDR_datao (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_DATAO_0_ADDR_datao. */

/*! @brief Read current value of the HDMI_PHY_I2CM_DATAO_0_ADDR_datao field. */
#define BR_HDMI_PHY_I2CM_DATAO_0_ADDR_datao(x) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_DATAO_0_ADDR_datao. */
#define BF_HDMI_PHY_I2CM_DATAO_0_ADDR_datao(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_DATAO_0_ADDR_datao) & BM_HDMI_PHY_I2CM_DATAO_0_ADDR_datao)

/*! @brief Set the datao field to a new value. */
#define BW_HDMI_PHY_I2CM_DATAO_0_ADDR_datao(x, v) (HW_HDMI_PHY_I2CM_DATAO_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_DATAI_1_ADDR - PHY I2C Data Read Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_DATAI_1_ADDR - PHY I2C Data Read Register 1 (RO)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3024 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_phy_i2cm_datai_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_datai_1_addr_bitfields
    {
        uint8_t datai : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_datai_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_DATAI_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_DATAI_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3024U)

#define HW_HDMI_PHY_I2CM_DATAI_1_ADDR(x) (*(__I hw_hdmi_phy_i2cm_datai_1_addr_t *) HW_HDMI_PHY_I2CM_DATAI_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_DATAI_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_DATAI_1_ADDR(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_DATAI_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_DATAI_1_ADDR, field datai[7:0] (RO)
 *
 * MSB's of data read from the register pointed by address [7:0].
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_DATAI_1_ADDR_datai (0U) /*!< Bit position for HDMI_PHY_I2CM_DATAI_1_ADDR_datai. */
#define BM_HDMI_PHY_I2CM_DATAI_1_ADDR_datai (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_DATAI_1_ADDR_datai. */
#define BS_HDMI_PHY_I2CM_DATAI_1_ADDR_datai (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_DATAI_1_ADDR_datai. */

/*! @brief Read current value of the HDMI_PHY_I2CM_DATAI_1_ADDR_datai field. */
#define BR_HDMI_PHY_I2CM_DATAI_1_ADDR_datai(x) (HW_HDMI_PHY_I2CM_DATAI_1_ADDR(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_DATAI_0_ADDR - PHY I2C Data Read Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_DATAI_0_ADDR - PHY I2C Data Read Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3025 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_phy_i2cm_datai_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_datai_0_addr_bitfields
    {
        uint8_t datai : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_datai_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_DATAI_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3025U)

#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_datai_0_addr_t *) HW_HDMI_PHY_I2CM_DATAI_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAI_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAI_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_DATAI_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_DATAI_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_DATAI_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_DATAI_0_ADDR, field datai[7:0] (RW)
 *
 * LSB's of data read from the register pointed by address [7:0].
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_DATAI_0_ADDR_datai (0U) /*!< Bit position for HDMI_PHY_I2CM_DATAI_0_ADDR_datai. */
#define BM_HDMI_PHY_I2CM_DATAI_0_ADDR_datai (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_DATAI_0_ADDR_datai. */
#define BS_HDMI_PHY_I2CM_DATAI_0_ADDR_datai (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_DATAI_0_ADDR_datai. */

/*! @brief Read current value of the HDMI_PHY_I2CM_DATAI_0_ADDR_datai field. */
#define BR_HDMI_PHY_I2CM_DATAI_0_ADDR_datai(x) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_DATAI_0_ADDR_datai. */
#define BF_HDMI_PHY_I2CM_DATAI_0_ADDR_datai(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_DATAI_0_ADDR_datai) & BM_HDMI_PHY_I2CM_DATAI_0_ADDR_datai)

/*! @brief Set the datai field to a new value. */
#define BW_HDMI_PHY_I2CM_DATAI_0_ADDR_datai(x, v) (HW_HDMI_PHY_I2CM_DATAI_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_OPERATION_ADDR - PHY I2C Read/Write Operation
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_OPERATION_ADDR - PHY I2C Read/Write Operation (WO)
 *
 * Reset value: 0x00U
 *
 * This register requests read and write operations from the I2C Master PHY.
 * This register can only be written; reading this register always results in 00h.
 * Writing 1'b1 simultaneously to read and write requests is considered a read
 * request. Address Offset: 0x3026 Size: 8 bits Value after Reset: 0x00 Access: Write
 */
typedef union _hw_hdmi_phy_i2cm_operation_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_operation_addr_bitfields
    {
        uint8_t read : 1;              /*!< [0]  */
        uint8_t RESERVED0 : 3;         /*!< [3:1]  */
        uint8_t write : 1;             /*!< [4]  */
        uint8_t RESERVED1 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_phy_i2cm_operation_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_OPERATION_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_OPERATION_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3026U)

#define HW_HDMI_PHY_I2CM_OPERATION_ADDR(x) (*(__O hw_hdmi_phy_i2cm_operation_addr_t *) HW_HDMI_PHY_I2CM_OPERATION_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_OPERATION_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_OPERATION_ADDR(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_OPERATION_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_OPERATION_ADDR, field read[0] (WO)
 *
 * Read operation request.
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_OPERATION_ADDR_read (0U) /*!< Bit position for HDMI_PHY_I2CM_OPERATION_ADDR_read. */
#define BM_HDMI_PHY_I2CM_OPERATION_ADDR_read (0x01U) /*!< Bit mask for HDMI_PHY_I2CM_OPERATION_ADDR_read. */
#define BS_HDMI_PHY_I2CM_OPERATION_ADDR_read (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_OPERATION_ADDR_read. */

/*! @brief Format value for bitfield HDMI_PHY_I2CM_OPERATION_ADDR_read. */
#define BF_HDMI_PHY_I2CM_OPERATION_ADDR_read(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_OPERATION_ADDR_read) & BM_HDMI_PHY_I2CM_OPERATION_ADDR_read)
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_OPERATION_ADDR, field write[4] (WO)
 *
 * Write operation request
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_OPERATION_ADDR_write (4U) /*!< Bit position for HDMI_PHY_I2CM_OPERATION_ADDR_write. */
#define BM_HDMI_PHY_I2CM_OPERATION_ADDR_write (0x10U) /*!< Bit mask for HDMI_PHY_I2CM_OPERATION_ADDR_write. */
#define BS_HDMI_PHY_I2CM_OPERATION_ADDR_write (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_OPERATION_ADDR_write. */

/*! @brief Format value for bitfield HDMI_PHY_I2CM_OPERATION_ADDR_write. */
#define BF_HDMI_PHY_I2CM_OPERATION_ADDR_write(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_OPERATION_ADDR_write) & BM_HDMI_PHY_I2CM_OPERATION_ADDR_write)
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_INT_ADDR - PHY I2C Done Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_INT_ADDR - PHY I2C Done Interrupt Register (RW)
 *
 * Reset value: 0x08U
 *
 * This register contains and configures I2C master PHY done interrupt. Address
 * Offset: 0x3027 Size: 8 bits Value after Reset: 0x08 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_int_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_int_addr_bitfields
    {
        uint8_t done_status : 1;       /*!< [0]  */
        uint8_t done_interrupt : 1;    /*!< [1]  */
        uint8_t done_mask : 1;         /*!< [2]  */
        uint8_t done_pol : 1;          /*!< [3]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_phy_i2cm_int_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_INT_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_INT_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3027U)

#define HW_HDMI_PHY_I2CM_INT_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_int_addr_t *) HW_HDMI_PHY_I2CM_INT_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) (HW_HDMI_PHY_I2CM_INT_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_INT_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_INT_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_INT_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_INT_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_INT_ADDR, field done_status[0] (RW)
 *
 * Operation done status bit.Marks the end of a rd or write operation. Value
 * after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_INT_ADDR_done_status (0U) /*!< Bit position for HDMI_PHY_I2CM_INT_ADDR_done_status. */
#define BM_HDMI_PHY_I2CM_INT_ADDR_done_status (0x01U) /*!< Bit mask for HDMI_PHY_I2CM_INT_ADDR_done_status. */
#define BS_HDMI_PHY_I2CM_INT_ADDR_done_status (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_INT_ADDR_done_status. */

/*! @brief Read current value of the HDMI_PHY_I2CM_INT_ADDR_done_status field. */
#define BR_HDMI_PHY_I2CM_INT_ADDR_done_status(x) (HW_HDMI_PHY_I2CM_INT_ADDR(x).B.done_status)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_INT_ADDR_done_status. */
#define BF_HDMI_PHY_I2CM_INT_ADDR_done_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_INT_ADDR_done_status) & BM_HDMI_PHY_I2CM_INT_ADDR_done_status)

/*! @brief Set the done_status field to a new value. */
#define BW_HDMI_PHY_I2CM_INT_ADDR_done_status(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_INT_ADDR_done_status) | BF_HDMI_PHY_I2CM_INT_ADDR_done_status(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_INT_ADDR, field done_interrupt[1] (RW)
 *
 * Operation done interrupt bit.{done_interrupt =(done_mask==0b)&&
 * (done_status==done_pol)}. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_INT_ADDR_done_interrupt (1U) /*!< Bit position for HDMI_PHY_I2CM_INT_ADDR_done_interrupt. */
#define BM_HDMI_PHY_I2CM_INT_ADDR_done_interrupt (0x02U) /*!< Bit mask for HDMI_PHY_I2CM_INT_ADDR_done_interrupt. */
#define BS_HDMI_PHY_I2CM_INT_ADDR_done_interrupt (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_INT_ADDR_done_interrupt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_INT_ADDR_done_interrupt field. */
#define BR_HDMI_PHY_I2CM_INT_ADDR_done_interrupt(x) (HW_HDMI_PHY_I2CM_INT_ADDR(x).B.done_interrupt)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_INT_ADDR_done_interrupt. */
#define BF_HDMI_PHY_I2CM_INT_ADDR_done_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_INT_ADDR_done_interrupt) & BM_HDMI_PHY_I2CM_INT_ADDR_done_interrupt)

/*! @brief Set the done_interrupt field to a new value. */
#define BW_HDMI_PHY_I2CM_INT_ADDR_done_interrupt(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_INT_ADDR_done_interrupt) | BF_HDMI_PHY_I2CM_INT_ADDR_done_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_INT_ADDR, field done_mask[2] (RW)
 *
 * Done interrupt mask signal Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_INT_ADDR_done_mask (2U) /*!< Bit position for HDMI_PHY_I2CM_INT_ADDR_done_mask. */
#define BM_HDMI_PHY_I2CM_INT_ADDR_done_mask (0x04U) /*!< Bit mask for HDMI_PHY_I2CM_INT_ADDR_done_mask. */
#define BS_HDMI_PHY_I2CM_INT_ADDR_done_mask (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_INT_ADDR_done_mask. */

/*! @brief Read current value of the HDMI_PHY_I2CM_INT_ADDR_done_mask field. */
#define BR_HDMI_PHY_I2CM_INT_ADDR_done_mask(x) (HW_HDMI_PHY_I2CM_INT_ADDR(x).B.done_mask)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_INT_ADDR_done_mask. */
#define BF_HDMI_PHY_I2CM_INT_ADDR_done_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_INT_ADDR_done_mask) & BM_HDMI_PHY_I2CM_INT_ADDR_done_mask)

/*! @brief Set the done_mask field to a new value. */
#define BW_HDMI_PHY_I2CM_INT_ADDR_done_mask(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_INT_ADDR_done_mask) | BF_HDMI_PHY_I2CM_INT_ADDR_done_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_INT_ADDR, field done_pol[3] (RW)
 *
 * Done interrupt polarity configuration Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_INT_ADDR_done_pol (3U) /*!< Bit position for HDMI_PHY_I2CM_INT_ADDR_done_pol. */
#define BM_HDMI_PHY_I2CM_INT_ADDR_done_pol (0x08U) /*!< Bit mask for HDMI_PHY_I2CM_INT_ADDR_done_pol. */
#define BS_HDMI_PHY_I2CM_INT_ADDR_done_pol (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_INT_ADDR_done_pol. */

/*! @brief Read current value of the HDMI_PHY_I2CM_INT_ADDR_done_pol field. */
#define BR_HDMI_PHY_I2CM_INT_ADDR_done_pol(x) (HW_HDMI_PHY_I2CM_INT_ADDR(x).B.done_pol)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_INT_ADDR_done_pol. */
#define BF_HDMI_PHY_I2CM_INT_ADDR_done_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_INT_ADDR_done_pol) & BM_HDMI_PHY_I2CM_INT_ADDR_done_pol)

/*! @brief Set the done_pol field to a new value. */
#define BW_HDMI_PHY_I2CM_INT_ADDR_done_pol(x, v) (HW_HDMI_PHY_I2CM_INT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_INT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_INT_ADDR_done_pol) | BF_HDMI_PHY_I2CM_INT_ADDR_done_pol(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_CTLINT_ADDR - PHY I2C Done Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_CTLINT_ADDR - PHY I2C Done Interrupt Register (RW)
 *
 * Reset value: 0x88U
 *
 * This register contains and configures the I2C master PHY error interrupts.
 * Address Offset: 0x3028 Size: 8 bits Value after Reset: 0x88 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_ctlint_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_ctlint_addr_bitfields
    {
        uint8_t arbitration_status : 1; /*!< [0]  */
        uint8_t arbitration_interrupt : 1; /*!< [1]  */
        uint8_t arbitration_mask : 1;  /*!< [2]  */
        uint8_t arbitration_pol : 1;   /*!< [3]  */
        uint8_t nack_status : 1;       /*!< [4]  */
        uint8_t nack_interrupt : 1;    /*!< [5]  */
        uint8_t nack_mask : 1;         /*!< [6]  */
        uint8_t nack_pol : 1;          /*!< [7]  */
    } B;
} hw_hdmi_phy_i2cm_ctlint_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_CTLINT_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3028U)

#define HW_HDMI_PHY_I2CM_CTLINT_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_ctlint_addr_t *) HW_HDMI_PHY_I2CM_CTLINT_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_CTLINT_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_CTLINT_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field arbitration_status[0] (RW)
 *
 * Arbitration error status bit. Error on master I2C protocol arbitration. Value
 * after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status (0U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status (0x01U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.arbitration_status)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status)

/*! @brief Set the arbitration_status field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_status(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field arbitration_interrupt[1] (RW)
 *
 * Arbitration error interrupt bit.{arbitration_interrupt =
 * (arbitration_mask==0b)&& (arbitration_status==arbitration_pol)}. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt (1U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt (0x02U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.arbitration_interrupt)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt)

/*! @brief Set the arbitration_interrupt field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field arbitration_mask[2] (RW)
 *
 * Arbitration error interrupt mask signal. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask (2U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask (0x04U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.arbitration_mask)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask)

/*! @brief Set the arbitration_mask field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field arbitration_pol[3] (RW)
 *
 * Arbitration error interrupt polarity configuration. Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol (3U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol (0x08U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.arbitration_pol)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol)

/*! @brief Set the arbitration_pol field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_arbitration_pol(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field nack_status[4] (RW)
 *
 * Not acknowledge error status bit.Error on I2C not acknowledge. Value after
 * Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status (4U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_nack_status. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status (0x10U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_nack_status. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_nack_status. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_nack_status field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.nack_status)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_nack_status. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status)

/*! @brief Set the nack_status field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_status(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field nack_interrupt[5] (RW)
 *
 * Not acknowledge error interrupt bit.{nack_interrupt = nack_mask==0b) &&
 * (nack_status==nack_pol)}. Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt (5U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt (0x20U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.nack_interrupt)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt)

/*! @brief Set the nack_interrupt field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field nack_mask[6] (RW)
 *
 * Not acknowledge error interrupt mask signal Value after Reset: 0b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask (6U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask (0x40U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.nack_mask)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask)

/*! @brief Set the nack_mask field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_PHY_I2CM_CTLINT_ADDR, field nack_pol[7] (RW)
 *
 * Not acknowledge error interrupt polarity configuration. Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol (7U) /*!< Bit position for HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol. */
#define BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol (0x80U) /*!< Bit mask for HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol. */
#define BS_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol. */

/*! @brief Read current value of the HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol field. */
#define BR_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol(x) (HW_HDMI_PHY_I2CM_CTLINT_ADDR(x).B.nack_pol)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol. */
#define BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol) & BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol)

/*! @brief Set the nack_pol field to a new value. */
#define BW_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol(x, v) (HW_HDMI_PHY_I2CM_CTLINT_ADDR_WR(x, (HW_HDMI_PHY_I2CM_CTLINT_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol) | BF_HDMI_PHY_I2CM_CTLINT_ADDR_nack_pol(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_DIV_ADDR - PHY I2C Speed Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_DIV_ADDR - PHY I2C Speed Control Register (RW)
 *
 * Reset value: 0x0BU
 *
 * This register wets the I2C Master PHY to work in either Fast or Standard
 * mode. Address Offset: 0x3029 Size: 8 bits Value after Reset: 0x0B Access:
 * Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_div_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_div_addr_bitfields
    {
        uint8_t fast_mode : 4;         /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_phy_i2cm_div_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_DIV_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_DIV_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3029U)

#define HW_HDMI_PHY_I2CM_DIV_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_div_addr_t *) HW_HDMI_PHY_I2CM_DIV_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_DIV_ADDR_RD(x) (HW_HDMI_PHY_I2CM_DIV_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_DIV_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_DIV_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_DIV_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_DIV_ADDR_WR(x, HW_HDMI_PHY_I2CM_DIV_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_DIV_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_DIV_ADDR_WR(x, HW_HDMI_PHY_I2CM_DIV_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_DIV_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_DIV_ADDR_WR(x, HW_HDMI_PHY_I2CM_DIV_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_DIV_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_DIV_ADDR, field fast_mode[3:0] (RW)
 *
 * Sets the I2C Master to work in Fast Mode or Standard Mode (x implies that it
 * can take any value) Value after Reset: 1011b 1xxxb Fast Mode 0xxxb Standard
 * Mode
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_DIV_ADDR_fast_mode (0U) /*!< Bit position for HDMI_PHY_I2CM_DIV_ADDR_fast_mode. */
#define BM_HDMI_PHY_I2CM_DIV_ADDR_fast_mode (0x0FU) /*!< Bit mask for HDMI_PHY_I2CM_DIV_ADDR_fast_mode. */
#define BS_HDMI_PHY_I2CM_DIV_ADDR_fast_mode (4U) /*!< Bit field size in bits for HDMI_PHY_I2CM_DIV_ADDR_fast_mode. */

/*! @brief Read current value of the HDMI_PHY_I2CM_DIV_ADDR_fast_mode field. */
#define BR_HDMI_PHY_I2CM_DIV_ADDR_fast_mode(x) (HW_HDMI_PHY_I2CM_DIV_ADDR(x).B.fast_mode)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_DIV_ADDR_fast_mode. */
#define BF_HDMI_PHY_I2CM_DIV_ADDR_fast_mode(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_DIV_ADDR_fast_mode) & BM_HDMI_PHY_I2CM_DIV_ADDR_fast_mode)

/*! @brief Set the fast_mode field to a new value. */
#define BW_HDMI_PHY_I2CM_DIV_ADDR_fast_mode(x, v) (HW_HDMI_PHY_I2CM_DIV_ADDR_WR(x, (HW_HDMI_PHY_I2CM_DIV_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_DIV_ADDR_fast_mode) | BF_HDMI_PHY_I2CM_DIV_ADDR_fast_mode(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR - PHY I2C Software Reset Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR - PHY I2C Software Reset Register (RW)
 *
 * Reset value: 0x01U
 *
 * This register sets the I2C Master PHY software reset. Address Offset: 0x302A
 * Size: 8 bits Value after Reset: 0x01 Access: Read/Write The following *CNT
 * registers must be set before any I2C bus transaction can take place to ensure
 * proper I/O timing. The following are the I2C Master SCL clock settings: SS:
 * Standard Speed FS: Fast Speed HCNT: SCL High Level counter LCNT: SCL Low Level
 * counter
 */
typedef union _hw_hdmi_phy_i2cm_softrstz_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_softrstz_addr_bitfields
    {
        uint8_t i2c_softrst : 1;       /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_phy_i2cm_softrstz_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SOFTRSTZ_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302AU)

#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_softrstz_addr_t *) HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_WR(x, HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_WR(x, HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_WR(x, HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SOFTRSTZ_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_SOFTRSTZ_ADDR, field i2c_softrst[0] (RW)
 *
 * I2C Master PHY Software Reset. Active by writing a zero and auto cleared to
 * one in the following cycle. Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst (0U) /*!< Bit position for HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst. */
#define BM_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst (0x01U) /*!< Bit mask for HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst. */
#define BS_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst (1U) /*!< Bit field size in bits for HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst. */

/*! @brief Read current value of the HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst field. */
#define BR_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst(x) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR(x).B.i2c_softrst)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst. */
#define BF_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst) & BM_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst)

/*! @brief Set the i2c_softrst field to a new value. */
#define BW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst(x, v) (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_WR(x, (HW_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_RD(x) & ~BM_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst) | BF_HDMI_PHY_I2CM_SOFTRSTZ_ADDR_i2c_softrst(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR - PHY I2C Slow Speed SCL High Level Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR - PHY I2C Slow Speed SCL High Level Control Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x302B Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_ss_scl_hcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_ss_scl_hcnt_1_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_ss_scl_hcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302BU)

#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_ss_scl_hcnt_1_addr_t *) HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR, field i2cmp_ss_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BM_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BS_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt field. */
#define BR_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(x) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BF_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt) & BM_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt)

/*! @brief Set the i2cmp_ss_scl_hcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR - PHY I2C Slow Speed SCL High Level Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR - PHY I2C Slow Speed SCL High Level Control Register 0 (RW)
 *
 * Reset value: 0x6CU
 *
 * Address Offset: 0x302C Size: 8 bits Value after Reset: 0x6C Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_ss_scl_hcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_ss_scl_hcnt_0_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_ss_scl_hcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302CU)

#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_ss_scl_hcnt_0_addr_t *) HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR, field i2cmp_ss_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h6C
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BM_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BS_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt field. */
#define BR_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(x) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BF_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt) & BM_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt)

/*! @brief Set the i2cmp_ss_scl_hcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x302D Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_ss_scl_lcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_ss_scl_lcnt_1_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_ss_scl_lcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302DU)

#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_ss_scl_lcnt_1_addr_t *) HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR, field i2cmp_ss_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BM_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BS_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt field. */
#define BR_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(x) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BF_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt) & BM_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt)

/*! @brief Set the i2cmp_ss_scl_lcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR - PHY I2C Slow Speed SCL Low Level Control Register 0 (RW)
 *
 * Reset value: 0x7FU
 *
 * Address Offset: 0x302E Size: 8 bits Value after Reset: 0x7F Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_ss_scl_lcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_ss_scl_lcnt_0_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_ss_scl_lcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302EU)

#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_ss_scl_lcnt_0_addr_t *) HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR, field i2cmp_ss_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h7F
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BM_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BS_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt field. */
#define BR_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(x) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BF_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt) & BM_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt)

/*! @brief Set the i2cmp_ss_scl_lcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(x, v) (HW_HDMI_PHY_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR - PHY I2C Fast Speed SCL High Level Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR - PHY I2C Fast Speed SCL High Level Control Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x302F Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_fs_scl_hcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_fs_scl_hcnt_1_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_fs_scl_hcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x302FU)

#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_fs_scl_hcnt_1_addr_t *) HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR, field i2cmp_fs_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BM_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BS_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt field. */
#define BR_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(x) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BF_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt) & BM_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt)

/*! @brief Set the i2cmp_fs_scl_hcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR - PHY I2C Fast Speed SCL High Level Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR - PHY I2C Fast Speed SCL High Level Control Register 0 (RW)
 *
 * Reset value: 0x11U
 *
 * Address Offset: 0x3030 Size: 8 bits Value after Reset: 0x11 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_fs_scl_hcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_fs_scl_hcnt_0_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_fs_scl_hcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3030U)

#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_fs_scl_hcnt_0_addr_t *) HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR, field i2cmp_fs_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h11
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BM_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BS_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt field. */
#define BR_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(x) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BF_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt) & BM_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt)

/*! @brief Set the i2cmp_fs_scl_hcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3031 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_fs_scl_lcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_fs_scl_lcnt_1_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_fs_scl_lcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3031U)

#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_fs_scl_lcnt_1_addr_t *) HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR, field i2cmp_fs_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BM_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BS_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt field. */
#define BR_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(x) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BF_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt) & BM_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt)

/*! @brief Set the i2cmp_fs_scl_lcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR - PHY I2C Fast Speed SCL Low Level Control Register 0 (RW)
 *
 * Reset value: 0x24U
 *
 * Address Offset: 0x3032 Size: 8 bits Value after Reset: 0x24 Access: Read/Write
 */
typedef union _hw_hdmi_phy_i2cm_fs_scl_lcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_phy_i2cm_fs_scl_lcnt_0_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_phy_i2cm_fs_scl_lcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x3032U)

#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR(x) (*(__IO hw_hdmi_phy_i2cm_fs_scl_lcnt_0_addr_t *) HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_ADDR(x))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR(x).U)
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR(x).U = (v))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_SET(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_CLR(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_TOG(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR, field i2cmp_fs_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h24
 */
/*@{*/
#define BP_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (0U) /*!< Bit position for HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BM_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BS_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */

/*! @brief Read current value of the HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt field. */
#define BR_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(x) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BF_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt) & BM_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt)

/*! @brief Set the i2cmp_fs_scl_lcnt field to a new value. */
#define BW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(x, v) (HW_HDMI_PHY_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_N1 - Audio Clock Regenerator N Value Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_N1 - Audio Clock Regenerator N Value Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * For N expected values, refer to the HDMI 1.4a specification. Address Offset:
 * 0x3200 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_n1
{
    uint8_t U;
    struct _hw_hdmi_aud_n1_bitfields
    {
        uint8_t AudN : 8;              /*!< [7:0]  */
    } B;
} hw_hdmi_aud_n1_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_N1 register
 */
/*@{*/
#define HW_HDMI_AUD_N1_ADDR(x)   ((uintptr_t)(x) + 0x3200U)

#define HW_HDMI_AUD_N1(x)        (*(__IO hw_hdmi_aud_n1_t *) HW_HDMI_AUD_N1_ADDR(x))
#define HW_HDMI_AUD_N1_RD(x)     (HW_HDMI_AUD_N1(x).U)
#define HW_HDMI_AUD_N1_WR(x, v)  (HW_HDMI_AUD_N1(x).U = (v))
#define HW_HDMI_AUD_N1_SET(x, v) (HW_HDMI_AUD_N1_WR(x, HW_HDMI_AUD_N1_RD(x) |  (v)))
#define HW_HDMI_AUD_N1_CLR(x, v) (HW_HDMI_AUD_N1_WR(x, HW_HDMI_AUD_N1_RD(x) & ~(v)))
#define HW_HDMI_AUD_N1_TOG(x, v) (HW_HDMI_AUD_N1_WR(x, HW_HDMI_AUD_N1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_N1 bitfields
 */

/*!
 * @name Register HDMI_AUD_N1, field AudN[7:0] (RW)
 *
 * HDMI Audio Clock Regenerator N value
 */
/*@{*/
#define BP_HDMI_AUD_N1_AudN  (0U)          /*!< Bit position for HDMI_AUD_N1_AudN. */
#define BM_HDMI_AUD_N1_AudN  (0xFFU)       /*!< Bit mask for HDMI_AUD_N1_AudN. */
#define BS_HDMI_AUD_N1_AudN  (8U)          /*!< Bit field size in bits for HDMI_AUD_N1_AudN. */

/*! @brief Read current value of the HDMI_AUD_N1_AudN field. */
#define BR_HDMI_AUD_N1_AudN(x) (HW_HDMI_AUD_N1(x).U)

/*! @brief Format value for bitfield HDMI_AUD_N1_AudN. */
#define BF_HDMI_AUD_N1_AudN(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_N1_AudN) & BM_HDMI_AUD_N1_AudN)

/*! @brief Set the AudN field to a new value. */
#define BW_HDMI_AUD_N1_AudN(x, v) (HW_HDMI_AUD_N1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_N2 - Audio Clock Regenerator N Value Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_N2 - Audio Clock Regenerator N Value Register 2 (RW)
 *
 * Reset value: 0x00U
 *
 * For N expected values, refer to the HDMI 1.4a specification. Address Offset:
 * 0x3201 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_n2
{
    uint8_t U;
    struct _hw_hdmi_aud_n2_bitfields
    {
        uint8_t AudN : 8;              /*!< [7:0]  */
    } B;
} hw_hdmi_aud_n2_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_N2 register
 */
/*@{*/
#define HW_HDMI_AUD_N2_ADDR(x)   ((uintptr_t)(x) + 0x3201U)

#define HW_HDMI_AUD_N2(x)        (*(__IO hw_hdmi_aud_n2_t *) HW_HDMI_AUD_N2_ADDR(x))
#define HW_HDMI_AUD_N2_RD(x)     (HW_HDMI_AUD_N2(x).U)
#define HW_HDMI_AUD_N2_WR(x, v)  (HW_HDMI_AUD_N2(x).U = (v))
#define HW_HDMI_AUD_N2_SET(x, v) (HW_HDMI_AUD_N2_WR(x, HW_HDMI_AUD_N2_RD(x) |  (v)))
#define HW_HDMI_AUD_N2_CLR(x, v) (HW_HDMI_AUD_N2_WR(x, HW_HDMI_AUD_N2_RD(x) & ~(v)))
#define HW_HDMI_AUD_N2_TOG(x, v) (HW_HDMI_AUD_N2_WR(x, HW_HDMI_AUD_N2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_N2 bitfields
 */

/*!
 * @name Register HDMI_AUD_N2, field AudN[7:0] (RW)
 *
 * HDMI Audio Clock Regenerator N value
 */
/*@{*/
#define BP_HDMI_AUD_N2_AudN  (0U)          /*!< Bit position for HDMI_AUD_N2_AudN. */
#define BM_HDMI_AUD_N2_AudN  (0xFFU)       /*!< Bit mask for HDMI_AUD_N2_AudN. */
#define BS_HDMI_AUD_N2_AudN  (8U)          /*!< Bit field size in bits for HDMI_AUD_N2_AudN. */

/*! @brief Read current value of the HDMI_AUD_N2_AudN field. */
#define BR_HDMI_AUD_N2_AudN(x) (HW_HDMI_AUD_N2(x).U)

/*! @brief Format value for bitfield HDMI_AUD_N2_AudN. */
#define BF_HDMI_AUD_N2_AudN(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_N2_AudN) & BM_HDMI_AUD_N2_AudN)

/*! @brief Set the AudN field to a new value. */
#define BW_HDMI_AUD_N2_AudN(x, v) (HW_HDMI_AUD_N2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_N3 - Audio Clock Regenerator N Value Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_N3 - Audio Clock Regenerator N Value Register 3 (RW)
 *
 * Reset value: 0x00U
 *
 * For N expected values, refer to the HDMI 1.4a specification. Address Offset:
 * 0x3202 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_n3
{
    uint8_t U;
    struct _hw_hdmi_aud_n3_bitfields
    {
        uint8_t AudN : 4;              /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_aud_n3_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_N3 register
 */
/*@{*/
#define HW_HDMI_AUD_N3_ADDR(x)   ((uintptr_t)(x) + 0x3202U)

#define HW_HDMI_AUD_N3(x)        (*(__IO hw_hdmi_aud_n3_t *) HW_HDMI_AUD_N3_ADDR(x))
#define HW_HDMI_AUD_N3_RD(x)     (HW_HDMI_AUD_N3(x).U)
#define HW_HDMI_AUD_N3_WR(x, v)  (HW_HDMI_AUD_N3(x).U = (v))
#define HW_HDMI_AUD_N3_SET(x, v) (HW_HDMI_AUD_N3_WR(x, HW_HDMI_AUD_N3_RD(x) |  (v)))
#define HW_HDMI_AUD_N3_CLR(x, v) (HW_HDMI_AUD_N3_WR(x, HW_HDMI_AUD_N3_RD(x) & ~(v)))
#define HW_HDMI_AUD_N3_TOG(x, v) (HW_HDMI_AUD_N3_WR(x, HW_HDMI_AUD_N3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_N3 bitfields
 */

/*!
 * @name Register HDMI_AUD_N3, field AudN[3:0] (RW)
 *
 * HDMI Audio Clock Regenerator N value
 */
/*@{*/
#define BP_HDMI_AUD_N3_AudN  (0U)          /*!< Bit position for HDMI_AUD_N3_AudN. */
#define BM_HDMI_AUD_N3_AudN  (0x0FU)       /*!< Bit mask for HDMI_AUD_N3_AudN. */
#define BS_HDMI_AUD_N3_AudN  (4U)          /*!< Bit field size in bits for HDMI_AUD_N3_AudN. */

/*! @brief Read current value of the HDMI_AUD_N3_AudN field. */
#define BR_HDMI_AUD_N3_AudN(x) (HW_HDMI_AUD_N3(x).B.AudN)

/*! @brief Format value for bitfield HDMI_AUD_N3_AudN. */
#define BF_HDMI_AUD_N3_AudN(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_N3_AudN) & BM_HDMI_AUD_N3_AudN)

/*! @brief Set the AudN field to a new value. */
#define BW_HDMI_AUD_N3_AudN(x, v) (HW_HDMI_AUD_N3_WR(x, (HW_HDMI_AUD_N3_RD(x) & ~BM_HDMI_AUD_N3_AudN) | BF_HDMI_AUD_N3_AudN(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_CTS1 - AUD_CTS1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_CTS1 - AUD_CTS1 (RW)
 *
 * Reset value: 0x00U
 *
 * For CTS expected values, refer to the HDMI 1.4a specification. Address
 * Offset: 0x3203 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_cts1
{
    uint8_t U;
    struct _hw_hdmi_aud_cts1_bitfields
    {
        uint8_t audCTS : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_aud_cts1_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_CTS1 register
 */
/*@{*/
#define HW_HDMI_AUD_CTS1_ADDR(x) ((uintptr_t)(x) + 0x3203U)

#define HW_HDMI_AUD_CTS1(x)      (*(__IO hw_hdmi_aud_cts1_t *) HW_HDMI_AUD_CTS1_ADDR(x))
#define HW_HDMI_AUD_CTS1_RD(x)   (HW_HDMI_AUD_CTS1(x).U)
#define HW_HDMI_AUD_CTS1_WR(x, v) (HW_HDMI_AUD_CTS1(x).U = (v))
#define HW_HDMI_AUD_CTS1_SET(x, v) (HW_HDMI_AUD_CTS1_WR(x, HW_HDMI_AUD_CTS1_RD(x) |  (v)))
#define HW_HDMI_AUD_CTS1_CLR(x, v) (HW_HDMI_AUD_CTS1_WR(x, HW_HDMI_AUD_CTS1_RD(x) & ~(v)))
#define HW_HDMI_AUD_CTS1_TOG(x, v) (HW_HDMI_AUD_CTS1_WR(x, HW_HDMI_AUD_CTS1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_CTS1 bitfields
 */

/*!
 * @name Register HDMI_AUD_CTS1, field audCTS[7:0] (RW)
 *
 * HDMI Audio Clock Regenerator CTS calculated value. This value can be manually
 * set using the CTS_manual (AUD_CTS3) mechanism.
 */
/*@{*/
#define BP_HDMI_AUD_CTS1_audCTS (0U)       /*!< Bit position for HDMI_AUD_CTS1_audCTS. */
#define BM_HDMI_AUD_CTS1_audCTS (0xFFU)    /*!< Bit mask for HDMI_AUD_CTS1_audCTS. */
#define BS_HDMI_AUD_CTS1_audCTS (8U)       /*!< Bit field size in bits for HDMI_AUD_CTS1_audCTS. */

/*! @brief Read current value of the HDMI_AUD_CTS1_audCTS field. */
#define BR_HDMI_AUD_CTS1_audCTS(x) (HW_HDMI_AUD_CTS1(x).U)

/*! @brief Format value for bitfield HDMI_AUD_CTS1_audCTS. */
#define BF_HDMI_AUD_CTS1_audCTS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_CTS1_audCTS) & BM_HDMI_AUD_CTS1_audCTS)

/*! @brief Set the audCTS field to a new value. */
#define BW_HDMI_AUD_CTS1_audCTS(x, v) (HW_HDMI_AUD_CTS1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_CTS2 - AUD_CTS2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_CTS2 - AUD_CTS2 (RW)
 *
 * Reset value: 0x00U
 *
 * For CTS expected values, refer to the HDMI 1.4a specification. Address
 * Offset: 0x3204 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_cts2
{
    uint8_t U;
    struct _hw_hdmi_aud_cts2_bitfields
    {
        uint8_t audCTS : 8;            /*!< [7:0]  */
    } B;
} hw_hdmi_aud_cts2_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_CTS2 register
 */
/*@{*/
#define HW_HDMI_AUD_CTS2_ADDR(x) ((uintptr_t)(x) + 0x3204U)

#define HW_HDMI_AUD_CTS2(x)      (*(__IO hw_hdmi_aud_cts2_t *) HW_HDMI_AUD_CTS2_ADDR(x))
#define HW_HDMI_AUD_CTS2_RD(x)   (HW_HDMI_AUD_CTS2(x).U)
#define HW_HDMI_AUD_CTS2_WR(x, v) (HW_HDMI_AUD_CTS2(x).U = (v))
#define HW_HDMI_AUD_CTS2_SET(x, v) (HW_HDMI_AUD_CTS2_WR(x, HW_HDMI_AUD_CTS2_RD(x) |  (v)))
#define HW_HDMI_AUD_CTS2_CLR(x, v) (HW_HDMI_AUD_CTS2_WR(x, HW_HDMI_AUD_CTS2_RD(x) & ~(v)))
#define HW_HDMI_AUD_CTS2_TOG(x, v) (HW_HDMI_AUD_CTS2_WR(x, HW_HDMI_AUD_CTS2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_CTS2 bitfields
 */

/*!
 * @name Register HDMI_AUD_CTS2, field audCTS[7:0] (RW)
 *
 * HDMI Audio Clock Regenerator CTS calculated value. This value can be manually
 * set using the CTS_manual (AUD_CTS3) mechanism.
 */
/*@{*/
#define BP_HDMI_AUD_CTS2_audCTS (0U)       /*!< Bit position for HDMI_AUD_CTS2_audCTS. */
#define BM_HDMI_AUD_CTS2_audCTS (0xFFU)    /*!< Bit mask for HDMI_AUD_CTS2_audCTS. */
#define BS_HDMI_AUD_CTS2_audCTS (8U)       /*!< Bit field size in bits for HDMI_AUD_CTS2_audCTS. */

/*! @brief Read current value of the HDMI_AUD_CTS2_audCTS field. */
#define BR_HDMI_AUD_CTS2_audCTS(x) (HW_HDMI_AUD_CTS2(x).U)

/*! @brief Format value for bitfield HDMI_AUD_CTS2_audCTS. */
#define BF_HDMI_AUD_CTS2_audCTS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_CTS2_audCTS) & BM_HDMI_AUD_CTS2_audCTS)

/*! @brief Set the audCTS field to a new value. */
#define BW_HDMI_AUD_CTS2_audCTS(x, v) (HW_HDMI_AUD_CTS2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AUD_CTS3 - AUD_CTS3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AUD_CTS3 - AUD_CTS3 (RW)
 *
 * Reset value: 0x00U
 *
 * For CTS expected values, refer to the HDMI 1.4a specification. Address
 * Offset: 0x3205 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_aud_cts3
{
    uint8_t U;
    struct _hw_hdmi_aud_cts3_bitfields
    {
        uint8_t audCTS : 4;            /*!< [3:0]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_aud_cts3_t;

/*!
 * @name Constants and macros for entire HDMI_AUD_CTS3 register
 */
/*@{*/
#define HW_HDMI_AUD_CTS3_ADDR(x) ((uintptr_t)(x) + 0x3205U)

#define HW_HDMI_AUD_CTS3(x)      (*(__IO hw_hdmi_aud_cts3_t *) HW_HDMI_AUD_CTS3_ADDR(x))
#define HW_HDMI_AUD_CTS3_RD(x)   (HW_HDMI_AUD_CTS3(x).U)
#define HW_HDMI_AUD_CTS3_WR(x, v) (HW_HDMI_AUD_CTS3(x).U = (v))
#define HW_HDMI_AUD_CTS3_SET(x, v) (HW_HDMI_AUD_CTS3_WR(x, HW_HDMI_AUD_CTS3_RD(x) |  (v)))
#define HW_HDMI_AUD_CTS3_CLR(x, v) (HW_HDMI_AUD_CTS3_WR(x, HW_HDMI_AUD_CTS3_RD(x) & ~(v)))
#define HW_HDMI_AUD_CTS3_TOG(x, v) (HW_HDMI_AUD_CTS3_WR(x, HW_HDMI_AUD_CTS3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AUD_CTS3 bitfields
 */

/*!
 * @name Register HDMI_AUD_CTS3, field audCTS[3:0] (RW)
 *
 * HDMI Audio Clock Regenerator CTS calculated value. This value can be manually
 * set using the CTS_manual (AUD_CTS3) mechanism.
 */
/*@{*/
#define BP_HDMI_AUD_CTS3_audCTS (0U)       /*!< Bit position for HDMI_AUD_CTS3_audCTS. */
#define BM_HDMI_AUD_CTS3_audCTS (0x0FU)    /*!< Bit mask for HDMI_AUD_CTS3_audCTS. */
#define BS_HDMI_AUD_CTS3_audCTS (4U)       /*!< Bit field size in bits for HDMI_AUD_CTS3_audCTS. */

/*! @brief Read current value of the HDMI_AUD_CTS3_audCTS field. */
#define BR_HDMI_AUD_CTS3_audCTS(x) (HW_HDMI_AUD_CTS3(x).B.audCTS)

/*! @brief Format value for bitfield HDMI_AUD_CTS3_audCTS. */
#define BF_HDMI_AUD_CTS3_audCTS(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AUD_CTS3_audCTS) & BM_HDMI_AUD_CTS3_audCTS)

/*! @brief Set the audCTS field to a new value. */
#define BW_HDMI_AUD_CTS3_audCTS(x, v) (HW_HDMI_AUD_CTS3_WR(x, (HW_HDMI_AUD_CTS3_RD(x) & ~BM_HDMI_AUD_CTS3_audCTS) | BF_HDMI_AUD_CTS3_audCTS(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_CONF0 - Audio DMA Start Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_CONF0 - Audio DMA Start Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register contains the software reset bit for the audio FIFOs. It also
 * configures operating modes of the AHB master. Address Offset: 0x3600 Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_conf0
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_conf0_bitfields
    {
        uint8_t burst_mode : 1;        /*!< [0]  */
        uint8_t incr_type : 2;         /*!< [2:1]  */
        uint8_t enable_hlock : 1;      /*!< [3]  */
        uint8_t hbr : 1;               /*!< [4]  */
        uint8_t RESERVED0 : 2;         /*!< [6:5]  */
        uint8_t sw_fifo_rst : 1;       /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_conf0_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_CONF0 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_CONF0_ADDR(x) ((uintptr_t)(x) + 0x3600U)

#define HW_HDMI_AHB_DMA_CONF0(x) (*(__IO hw_hdmi_ahb_dma_conf0_t *) HW_HDMI_AHB_DMA_CONF0_ADDR(x))
#define HW_HDMI_AHB_DMA_CONF0_RD(x) (HW_HDMI_AHB_DMA_CONF0(x).U)
#define HW_HDMI_AHB_DMA_CONF0_WR(x, v) (HW_HDMI_AHB_DMA_CONF0(x).U = (v))
#define HW_HDMI_AHB_DMA_CONF0_SET(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, HW_HDMI_AHB_DMA_CONF0_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_CONF0_CLR(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, HW_HDMI_AHB_DMA_CONF0_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_CONF0_TOG(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, HW_HDMI_AHB_DMA_CONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_CONF0 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_CONF0, field burst_mode[0] (RW)
 *
 * Burst mode bit
 *
 * Values:
 * - 1 - Forces the burst mode to be fixed beat incremental burst mode
 *     designated by the incr_type[1:0] signal.
 * - 0 - Normal operation is unspecified length incremental burst. It
 *     corresponds to INCR AHB burst mode.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF0_burst_mode (0U) /*!< Bit position for HDMI_AHB_DMA_CONF0_burst_mode. */
#define BM_HDMI_AHB_DMA_CONF0_burst_mode (0x01U) /*!< Bit mask for HDMI_AHB_DMA_CONF0_burst_mode. */
#define BS_HDMI_AHB_DMA_CONF0_burst_mode (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF0_burst_mode. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF0_burst_mode field. */
#define BR_HDMI_AHB_DMA_CONF0_burst_mode(x) (HW_HDMI_AHB_DMA_CONF0(x).B.burst_mode)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF0_burst_mode. */
#define BF_HDMI_AHB_DMA_CONF0_burst_mode(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF0_burst_mode) & BM_HDMI_AHB_DMA_CONF0_burst_mode)

/*! @brief Set the burst_mode field to a new value. */
#define BW_HDMI_AHB_DMA_CONF0_burst_mode(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, (HW_HDMI_AHB_DMA_CONF0_RD(x) & ~BM_HDMI_AHB_DMA_CONF0_burst_mode) | BF_HDMI_AHB_DMA_CONF0_burst_mode(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF0, field incr_type[2:1] (RW)
 *
 * Forced size burst mode.
 *
 * Values:
 * - 00 - Corresponds to INCR4 fixed four beat incremental AHB burst mode. Only
 *     valid when burst_mode is high.
 * - 01 - Corresponds to INCR8 fixed eight beat incremental AHB burst mode. Only
 *     valid when burst_mode is high.
 * - 10 - Corresponds to INCR16 fixed 16 beat incremental AHB burst mode. Only
 *     valid when burst_mode is high.
 * - 11 - Corresponds to INCR16 fixed 16 beat incremental AHB burst mode. Only
 *     valid when burst_mode is high.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF0_incr_type (1U) /*!< Bit position for HDMI_AHB_DMA_CONF0_incr_type. */
#define BM_HDMI_AHB_DMA_CONF0_incr_type (0x06U) /*!< Bit mask for HDMI_AHB_DMA_CONF0_incr_type. */
#define BS_HDMI_AHB_DMA_CONF0_incr_type (2U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF0_incr_type. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF0_incr_type field. */
#define BR_HDMI_AHB_DMA_CONF0_incr_type(x) (HW_HDMI_AHB_DMA_CONF0(x).B.incr_type)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF0_incr_type. */
#define BF_HDMI_AHB_DMA_CONF0_incr_type(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF0_incr_type) & BM_HDMI_AHB_DMA_CONF0_incr_type)

/*! @brief Set the incr_type field to a new value. */
#define BW_HDMI_AHB_DMA_CONF0_incr_type(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, (HW_HDMI_AHB_DMA_CONF0_RD(x) & ~BM_HDMI_AHB_DMA_CONF0_incr_type) | BF_HDMI_AHB_DMA_CONF0_incr_type(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF0, field enable_hlock[3] (RW)
 *
 * Enable request of locked burst AHB mechanism.
 *
 * Values:
 * - 1 - Enables the usage of ohlock for master request to arbiter of a locked
 *     complete burst.\
 * - 0 - Disables request of locked burst AHB mechanism
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF0_enable_hlock (3U) /*!< Bit position for HDMI_AHB_DMA_CONF0_enable_hlock. */
#define BM_HDMI_AHB_DMA_CONF0_enable_hlock (0x08U) /*!< Bit mask for HDMI_AHB_DMA_CONF0_enable_hlock. */
#define BS_HDMI_AHB_DMA_CONF0_enable_hlock (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF0_enable_hlock. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF0_enable_hlock field. */
#define BR_HDMI_AHB_DMA_CONF0_enable_hlock(x) (HW_HDMI_AHB_DMA_CONF0(x).B.enable_hlock)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF0_enable_hlock. */
#define BF_HDMI_AHB_DMA_CONF0_enable_hlock(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF0_enable_hlock) & BM_HDMI_AHB_DMA_CONF0_enable_hlock)

/*! @brief Set the enable_hlock field to a new value. */
#define BW_HDMI_AHB_DMA_CONF0_enable_hlock(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, (HW_HDMI_AHB_DMA_CONF0_RD(x) & ~BM_HDMI_AHB_DMA_CONF0_enable_hlock) | BF_HDMI_AHB_DMA_CONF0_enable_hlock(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF0, field hbr[4] (RW)
 *
 * HBR packets enable. The HDMI TX sends the HBR packets. This bit is enabled
 * when the audio frequency is higher than 192 KHz. If this bit is enabled, the
 * number of channels configured in AHB_DMA_CONF1 is always 8.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF0_hbr (4U)     /*!< Bit position for HDMI_AHB_DMA_CONF0_hbr. */
#define BM_HDMI_AHB_DMA_CONF0_hbr (0x10U)  /*!< Bit mask for HDMI_AHB_DMA_CONF0_hbr. */
#define BS_HDMI_AHB_DMA_CONF0_hbr (1U)     /*!< Bit field size in bits for HDMI_AHB_DMA_CONF0_hbr. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF0_hbr field. */
#define BR_HDMI_AHB_DMA_CONF0_hbr(x) (HW_HDMI_AHB_DMA_CONF0(x).B.hbr)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF0_hbr. */
#define BF_HDMI_AHB_DMA_CONF0_hbr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF0_hbr) & BM_HDMI_AHB_DMA_CONF0_hbr)

/*! @brief Set the hbr field to a new value. */
#define BW_HDMI_AHB_DMA_CONF0_hbr(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, (HW_HDMI_AHB_DMA_CONF0_RD(x) & ~BM_HDMI_AHB_DMA_CONF0_hbr) | BF_HDMI_AHB_DMA_CONF0_hbr(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF0, field sw_fifo_rst[7] (RW)
 *
 * This is the software reset bit for the audio and FIFOs clear. Writing 0'b
 * does not result in any action. Writing 1'b to this register resets all audio
 * FIFOs. Reading from this register always returns 0'b.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF0_sw_fifo_rst (7U) /*!< Bit position for HDMI_AHB_DMA_CONF0_sw_fifo_rst. */
#define BM_HDMI_AHB_DMA_CONF0_sw_fifo_rst (0x80U) /*!< Bit mask for HDMI_AHB_DMA_CONF0_sw_fifo_rst. */
#define BS_HDMI_AHB_DMA_CONF0_sw_fifo_rst (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF0_sw_fifo_rst. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF0_sw_fifo_rst field. */
#define BR_HDMI_AHB_DMA_CONF0_sw_fifo_rst(x) (HW_HDMI_AHB_DMA_CONF0(x).B.sw_fifo_rst)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF0_sw_fifo_rst. */
#define BF_HDMI_AHB_DMA_CONF0_sw_fifo_rst(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF0_sw_fifo_rst) & BM_HDMI_AHB_DMA_CONF0_sw_fifo_rst)

/*! @brief Set the sw_fifo_rst field to a new value. */
#define BW_HDMI_AHB_DMA_CONF0_sw_fifo_rst(x, v) (HW_HDMI_AHB_DMA_CONF0_WR(x, (HW_HDMI_AHB_DMA_CONF0_RD(x) & ~BM_HDMI_AHB_DMA_CONF0_sw_fifo_rst) | BF_HDMI_AHB_DMA_CONF0_sw_fifo_rst(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_START - AHB_DMA_START
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_START - AHB_DMA_START (RW)
 *
 * Reset value: 0x00U
 *
 * The data_ buffer_ready bit field signals the AHB audio DMA to start accessing
 * system memory in order to fetch data samples to store in the FIFO. After the
 * operation starts, a new request for a DMA start is ignored until the DMA is
 * stopped or it reaches the end address. Only in one of these situations will a
 * new start request be acknowledged. The first DMA burst request after
 * data_buffer_ready configuration uses the initial_addr[31:0] as the ohaddr[31:0] and the
 * MBURSTLENGTH[10:0] = AUDIO_FIFO_DEPTH if AUDIO_FIFO_DEPTH < 1024 or
 * MBURSTLENGTH[10:0] = 1024 if AUDIO_FIFO_DEPTH >= 1024. Address Offset: 0x3601 Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_start
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_start_bitfields
    {
        uint8_t data_buffer_ready : 1; /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_ahb_dma_start_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_START register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_START_ADDR(x) ((uintptr_t)(x) + 0x3601U)

#define HW_HDMI_AHB_DMA_START(x) (*(__IO hw_hdmi_ahb_dma_start_t *) HW_HDMI_AHB_DMA_START_ADDR(x))
#define HW_HDMI_AHB_DMA_START_RD(x) (HW_HDMI_AHB_DMA_START(x).U)
#define HW_HDMI_AHB_DMA_START_WR(x, v) (HW_HDMI_AHB_DMA_START(x).U = (v))
#define HW_HDMI_AHB_DMA_START_SET(x, v) (HW_HDMI_AHB_DMA_START_WR(x, HW_HDMI_AHB_DMA_START_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_START_CLR(x, v) (HW_HDMI_AHB_DMA_START_WR(x, HW_HDMI_AHB_DMA_START_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_START_TOG(x, v) (HW_HDMI_AHB_DMA_START_WR(x, HW_HDMI_AHB_DMA_START_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_START bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_START, field data_buffer_ready[0] (RW)
 *
 * Data buffer ready
 */
/*@{*/
#define BP_HDMI_AHB_DMA_START_data_buffer_ready (0U) /*!< Bit position for HDMI_AHB_DMA_START_data_buffer_ready. */
#define BM_HDMI_AHB_DMA_START_data_buffer_ready (0x01U) /*!< Bit mask for HDMI_AHB_DMA_START_data_buffer_ready. */
#define BS_HDMI_AHB_DMA_START_data_buffer_ready (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_START_data_buffer_ready. */

/*! @brief Read current value of the HDMI_AHB_DMA_START_data_buffer_ready field. */
#define BR_HDMI_AHB_DMA_START_data_buffer_ready(x) (HW_HDMI_AHB_DMA_START(x).B.data_buffer_ready)

/*! @brief Format value for bitfield HDMI_AHB_DMA_START_data_buffer_ready. */
#define BF_HDMI_AHB_DMA_START_data_buffer_ready(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_START_data_buffer_ready) & BM_HDMI_AHB_DMA_START_data_buffer_ready)

/*! @brief Set the data_buffer_ready field to a new value. */
#define BW_HDMI_AHB_DMA_START_data_buffer_ready(x, v) (HW_HDMI_AHB_DMA_START_WR(x, (HW_HDMI_AHB_DMA_START_RD(x) & ~BM_HDMI_AHB_DMA_START_data_buffer_ready) | BF_HDMI_AHB_DMA_START_data_buffer_ready(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STOP - Audio DMA Stop Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STOP - Audio DMA Stop Register (RW)
 *
 * Reset value: 0x00U
 *
 * The stop_dma_transaction bit field signals the AHB audio DMA to stop current
 * memory access. After it stops, if a new start DMA operation is requested, the
 * DMA engine restarts the memory access assuming the initial_addr[31:0] is
 * programmed at AHB_DMA_STRADDR0 to AHB_DMA_STRADDR3. Address Offset: 0x3602 Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_stop
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stop_bitfields
    {
        uint8_t stop_dma_transaction : 1; /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_ahb_dma_stop_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STOP register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STOP_ADDR(x) ((uintptr_t)(x) + 0x3602U)

#define HW_HDMI_AHB_DMA_STOP(x)  (*(__IO hw_hdmi_ahb_dma_stop_t *) HW_HDMI_AHB_DMA_STOP_ADDR(x))
#define HW_HDMI_AHB_DMA_STOP_RD(x) (HW_HDMI_AHB_DMA_STOP(x).U)
#define HW_HDMI_AHB_DMA_STOP_WR(x, v) (HW_HDMI_AHB_DMA_STOP(x).U = (v))
#define HW_HDMI_AHB_DMA_STOP_SET(x, v) (HW_HDMI_AHB_DMA_STOP_WR(x, HW_HDMI_AHB_DMA_STOP_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STOP_CLR(x, v) (HW_HDMI_AHB_DMA_STOP_WR(x, HW_HDMI_AHB_DMA_STOP_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STOP_TOG(x, v) (HW_HDMI_AHB_DMA_STOP_WR(x, HW_HDMI_AHB_DMA_STOP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STOP bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STOP, field stop_dma_transaction[0] (RW)
 *
 * Stop DMA transaction
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STOP_stop_dma_transaction (0U) /*!< Bit position for HDMI_AHB_DMA_STOP_stop_dma_transaction. */
#define BM_HDMI_AHB_DMA_STOP_stop_dma_transaction (0x01U) /*!< Bit mask for HDMI_AHB_DMA_STOP_stop_dma_transaction. */
#define BS_HDMI_AHB_DMA_STOP_stop_dma_transaction (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STOP_stop_dma_transaction. */

/*! @brief Read current value of the HDMI_AHB_DMA_STOP_stop_dma_transaction field. */
#define BR_HDMI_AHB_DMA_STOP_stop_dma_transaction(x) (HW_HDMI_AHB_DMA_STOP(x).B.stop_dma_transaction)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STOP_stop_dma_transaction. */
#define BF_HDMI_AHB_DMA_STOP_stop_dma_transaction(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STOP_stop_dma_transaction) & BM_HDMI_AHB_DMA_STOP_stop_dma_transaction)

/*! @brief Set the stop_dma_transaction field to a new value. */
#define BW_HDMI_AHB_DMA_STOP_stop_dma_transaction(x, v) (HW_HDMI_AHB_DMA_STOP_WR(x, (HW_HDMI_AHB_DMA_STOP_RD(x) & ~BM_HDMI_AHB_DMA_STOP_stop_dma_transaction) | BF_HDMI_AHB_DMA_STOP_stop_dma_transaction(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_THRSLD - Audio DMA FIFO Threshold Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_THRSLD - Audio DMA FIFO Threshold Register (RW)
 *
 * Reset value: 0x00U
 *
 * This register defines the FIFO medium threshold occupation value. After the
 * AHB master successfully completes a burst transaction, the FIFO may stay remain
 * full until the data fetch interface requests samples. The sample request from
 * the FIFO using the data fetch mechanism drops the number of samples stored in
 * the audio FIFO. As soon as the number of samples in the FIFO drops lower than
 * the fifo_threshold[7:0], the DMA engine requests a new burst of samples to
 * the AHB master with a size (MBURSTLENGTH[10:0]) equal to AUDIO_FIFO_DEPTH minus
 * fifo_threshold[7:0]. Therefore, the fifo_threshold[7:0] is the medium number
 * of samples that should be available in the audio FIFO across the DMA operation.
 * Address Offset: 0x3603 Size: 8 bits Value after Reset: 0x04 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_thrsld
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_thrsld_bitfields
    {
        uint8_t fifo_threshold : 8;    /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_thrsld_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_THRSLD register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_THRSLD_ADDR(x) ((uintptr_t)(x) + 0x3603U)

#define HW_HDMI_AHB_DMA_THRSLD(x) (*(__IO hw_hdmi_ahb_dma_thrsld_t *) HW_HDMI_AHB_DMA_THRSLD_ADDR(x))
#define HW_HDMI_AHB_DMA_THRSLD_RD(x) (HW_HDMI_AHB_DMA_THRSLD(x).U)
#define HW_HDMI_AHB_DMA_THRSLD_WR(x, v) (HW_HDMI_AHB_DMA_THRSLD(x).U = (v))
#define HW_HDMI_AHB_DMA_THRSLD_SET(x, v) (HW_HDMI_AHB_DMA_THRSLD_WR(x, HW_HDMI_AHB_DMA_THRSLD_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_THRSLD_CLR(x, v) (HW_HDMI_AHB_DMA_THRSLD_WR(x, HW_HDMI_AHB_DMA_THRSLD_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_THRSLD_TOG(x, v) (HW_HDMI_AHB_DMA_THRSLD_WR(x, HW_HDMI_AHB_DMA_THRSLD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_THRSLD bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_THRSLD, field fifo_threshold[7:0] (RW)
 *
 * FIFO medium threshold occupation value
 */
/*@{*/
#define BP_HDMI_AHB_DMA_THRSLD_fifo_threshold (0U) /*!< Bit position for HDMI_AHB_DMA_THRSLD_fifo_threshold. */
#define BM_HDMI_AHB_DMA_THRSLD_fifo_threshold (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_THRSLD_fifo_threshold. */
#define BS_HDMI_AHB_DMA_THRSLD_fifo_threshold (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_THRSLD_fifo_threshold. */

/*! @brief Read current value of the HDMI_AHB_DMA_THRSLD_fifo_threshold field. */
#define BR_HDMI_AHB_DMA_THRSLD_fifo_threshold(x) (HW_HDMI_AHB_DMA_THRSLD(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_THRSLD_fifo_threshold. */
#define BF_HDMI_AHB_DMA_THRSLD_fifo_threshold(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_THRSLD_fifo_threshold) & BM_HDMI_AHB_DMA_THRSLD_fifo_threshold)

/*! @brief Set the fifo_threshold field to a new value. */
#define BW_HDMI_AHB_DMA_THRSLD_fifo_threshold(x, v) (HW_HDMI_AHB_DMA_THRSLD_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STRADDR0 - Audio DMA Start Address Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STRADDR0 - Audio DMA Start Address Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * These registers define the initial_addr[31:0] used to initiate the DMA burst
 * read transactions upon data_buffer_ready configuration. Address Offset: 0x3604
 * to 0x3607 Size: 8 bits per register Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_straddr0
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_straddr0_bitfields
    {
        uint8_t initial_addr : 8;      /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_straddr0_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STRADDR0 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STRADDR0_ADDR(x) ((uintptr_t)(x) + 0x3604U)

#define HW_HDMI_AHB_DMA_STRADDR0(x) (*(__IO hw_hdmi_ahb_dma_straddr0_t *) HW_HDMI_AHB_DMA_STRADDR0_ADDR(x))
#define HW_HDMI_AHB_DMA_STRADDR0_RD(x) (HW_HDMI_AHB_DMA_STRADDR0(x).U)
#define HW_HDMI_AHB_DMA_STRADDR0_WR(x, v) (HW_HDMI_AHB_DMA_STRADDR0(x).U = (v))
#define HW_HDMI_AHB_DMA_STRADDR0_SET(x, v) (HW_HDMI_AHB_DMA_STRADDR0_WR(x, HW_HDMI_AHB_DMA_STRADDR0_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STRADDR0_CLR(x, v) (HW_HDMI_AHB_DMA_STRADDR0_WR(x, HW_HDMI_AHB_DMA_STRADDR0_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STRADDR0_TOG(x, v) (HW_HDMI_AHB_DMA_STRADDR0_WR(x, HW_HDMI_AHB_DMA_STRADDR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STRADDR0 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STRADDR0, field initial_addr[7:0] (RW)
 *
 * Defines init_addr[7:0] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STRADDR0_initial_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STRADDR0_initial_addr. */
#define BM_HDMI_AHB_DMA_STRADDR0_initial_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STRADDR0_initial_addr. */
#define BS_HDMI_AHB_DMA_STRADDR0_initial_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STRADDR0_initial_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STRADDR0_initial_addr field. */
#define BR_HDMI_AHB_DMA_STRADDR0_initial_addr(x) (HW_HDMI_AHB_DMA_STRADDR0(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STRADDR0_initial_addr. */
#define BF_HDMI_AHB_DMA_STRADDR0_initial_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STRADDR0_initial_addr) & BM_HDMI_AHB_DMA_STRADDR0_initial_addr)

/*! @brief Set the initial_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STRADDR0_initial_addr(x, v) (HW_HDMI_AHB_DMA_STRADDR0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STRADDR1 - Audio DMA Start Address Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STRADDR1 - Audio DMA Start Address Register 1 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_straddr1
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_straddr1_bitfields
    {
        uint8_t initial_addr : 8;      /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_straddr1_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STRADDR1 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STRADDR1_ADDR(x) ((uintptr_t)(x) + 0x3605U)

#define HW_HDMI_AHB_DMA_STRADDR1(x) (*(__IO hw_hdmi_ahb_dma_straddr1_t *) HW_HDMI_AHB_DMA_STRADDR1_ADDR(x))
#define HW_HDMI_AHB_DMA_STRADDR1_RD(x) (HW_HDMI_AHB_DMA_STRADDR1(x).U)
#define HW_HDMI_AHB_DMA_STRADDR1_WR(x, v) (HW_HDMI_AHB_DMA_STRADDR1(x).U = (v))
#define HW_HDMI_AHB_DMA_STRADDR1_SET(x, v) (HW_HDMI_AHB_DMA_STRADDR1_WR(x, HW_HDMI_AHB_DMA_STRADDR1_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STRADDR1_CLR(x, v) (HW_HDMI_AHB_DMA_STRADDR1_WR(x, HW_HDMI_AHB_DMA_STRADDR1_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STRADDR1_TOG(x, v) (HW_HDMI_AHB_DMA_STRADDR1_WR(x, HW_HDMI_AHB_DMA_STRADDR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STRADDR1 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STRADDR1, field initial_addr[7:0] (RW)
 *
 * Defines init_addr[15:8] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STRADDR1_initial_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STRADDR1_initial_addr. */
#define BM_HDMI_AHB_DMA_STRADDR1_initial_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STRADDR1_initial_addr. */
#define BS_HDMI_AHB_DMA_STRADDR1_initial_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STRADDR1_initial_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STRADDR1_initial_addr field. */
#define BR_HDMI_AHB_DMA_STRADDR1_initial_addr(x) (HW_HDMI_AHB_DMA_STRADDR1(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STRADDR1_initial_addr. */
#define BF_HDMI_AHB_DMA_STRADDR1_initial_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STRADDR1_initial_addr) & BM_HDMI_AHB_DMA_STRADDR1_initial_addr)

/*! @brief Set the initial_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STRADDR1_initial_addr(x, v) (HW_HDMI_AHB_DMA_STRADDR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STRADDR2 - Audio DMA Start Address Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STRADDR2 - Audio DMA Start Address Register 2 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_straddr2
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_straddr2_bitfields
    {
        uint8_t initial_addr : 8;      /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_straddr2_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STRADDR2 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STRADDR2_ADDR(x) ((uintptr_t)(x) + 0x3606U)

#define HW_HDMI_AHB_DMA_STRADDR2(x) (*(__IO hw_hdmi_ahb_dma_straddr2_t *) HW_HDMI_AHB_DMA_STRADDR2_ADDR(x))
#define HW_HDMI_AHB_DMA_STRADDR2_RD(x) (HW_HDMI_AHB_DMA_STRADDR2(x).U)
#define HW_HDMI_AHB_DMA_STRADDR2_WR(x, v) (HW_HDMI_AHB_DMA_STRADDR2(x).U = (v))
#define HW_HDMI_AHB_DMA_STRADDR2_SET(x, v) (HW_HDMI_AHB_DMA_STRADDR2_WR(x, HW_HDMI_AHB_DMA_STRADDR2_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STRADDR2_CLR(x, v) (HW_HDMI_AHB_DMA_STRADDR2_WR(x, HW_HDMI_AHB_DMA_STRADDR2_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STRADDR2_TOG(x, v) (HW_HDMI_AHB_DMA_STRADDR2_WR(x, HW_HDMI_AHB_DMA_STRADDR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STRADDR2 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STRADDR2, field initial_addr[7:0] (RW)
 *
 * Defines init_addr[23:16] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STRADDR2_initial_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STRADDR2_initial_addr. */
#define BM_HDMI_AHB_DMA_STRADDR2_initial_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STRADDR2_initial_addr. */
#define BS_HDMI_AHB_DMA_STRADDR2_initial_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STRADDR2_initial_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STRADDR2_initial_addr field. */
#define BR_HDMI_AHB_DMA_STRADDR2_initial_addr(x) (HW_HDMI_AHB_DMA_STRADDR2(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STRADDR2_initial_addr. */
#define BF_HDMI_AHB_DMA_STRADDR2_initial_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STRADDR2_initial_addr) & BM_HDMI_AHB_DMA_STRADDR2_initial_addr)

/*! @brief Set the initial_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STRADDR2_initial_addr(x, v) (HW_HDMI_AHB_DMA_STRADDR2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STRADDR3 - Audio DMA Start Address Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STRADDR3 - Audio DMA Start Address Register 3 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_straddr3
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_straddr3_bitfields
    {
        uint8_t initial_addr : 8;      /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_straddr3_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STRADDR3 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STRADDR3_ADDR(x) ((uintptr_t)(x) + 0x3607U)

#define HW_HDMI_AHB_DMA_STRADDR3(x) (*(__IO hw_hdmi_ahb_dma_straddr3_t *) HW_HDMI_AHB_DMA_STRADDR3_ADDR(x))
#define HW_HDMI_AHB_DMA_STRADDR3_RD(x) (HW_HDMI_AHB_DMA_STRADDR3(x).U)
#define HW_HDMI_AHB_DMA_STRADDR3_WR(x, v) (HW_HDMI_AHB_DMA_STRADDR3(x).U = (v))
#define HW_HDMI_AHB_DMA_STRADDR3_SET(x, v) (HW_HDMI_AHB_DMA_STRADDR3_WR(x, HW_HDMI_AHB_DMA_STRADDR3_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STRADDR3_CLR(x, v) (HW_HDMI_AHB_DMA_STRADDR3_WR(x, HW_HDMI_AHB_DMA_STRADDR3_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STRADDR3_TOG(x, v) (HW_HDMI_AHB_DMA_STRADDR3_WR(x, HW_HDMI_AHB_DMA_STRADDR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STRADDR3 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STRADDR3, field initial_addr[7:0] (RW)
 *
 * Defines init_addr[31:24] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STRADDR3_initial_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STRADDR3_initial_addr. */
#define BM_HDMI_AHB_DMA_STRADDR3_initial_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STRADDR3_initial_addr. */
#define BS_HDMI_AHB_DMA_STRADDR3_initial_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STRADDR3_initial_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STRADDR3_initial_addr field. */
#define BR_HDMI_AHB_DMA_STRADDR3_initial_addr(x) (HW_HDMI_AHB_DMA_STRADDR3(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STRADDR3_initial_addr. */
#define BF_HDMI_AHB_DMA_STRADDR3_initial_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STRADDR3_initial_addr) & BM_HDMI_AHB_DMA_STRADDR3_initial_addr)

/*! @brief Set the initial_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STRADDR3_initial_addr(x, v) (HW_HDMI_AHB_DMA_STRADDR3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STPADDR0 - Audio DMA Stop Address Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STPADDR0 - Audio DMA Stop Address Register 0 (RW)
 *
 * Reset value: 0x00U
 *
 * This registers define the final_addr[31:0] used as the final point to the DMA
 * burst read transactions. Upon data_buffer_ready configuration, the DMA engine
 * starts requesting burst reads from the external system memory. Each burst
 * read can have a maximum theoretical length of 1024 words (due to the AMBA AHB
 * specification restriction). As an example, if the first burst transaction of the
 * AHB audio DMA has a length of 16, then the second burst starts at address
 * ohaddr[31:0] = initial_addr[31:0] + 16 and has a length of MBURSTLENGTH[10:0] =
 * AUDIO_FIFO_DEPTH - fifo_threshold[7:0]. The DMA engine is responsible for
 * incrementing the burst starting address and defining its corresponding burst length
 * to reach the final_addr[31:0] address. The last burst request issued by the
 * DMA engine takes into account that it should only request data until the
 * final_addr[31:0] address (included) and for that should calculate the correct burst
 * length. After reaching the final_addr[31:0] address, the done interrupt is
 * active to signal completion of DMA operation. Address Offset: 0x3608 to 0x360B
 * Size: 8 bits per register Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_stpaddr0
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stpaddr0_bitfields
    {
        uint8_t final_addr : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_stpaddr0_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STPADDR0 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STPADDR0_ADDR(x) ((uintptr_t)(x) + 0x3608U)

#define HW_HDMI_AHB_DMA_STPADDR0(x) (*(__IO hw_hdmi_ahb_dma_stpaddr0_t *) HW_HDMI_AHB_DMA_STPADDR0_ADDR(x))
#define HW_HDMI_AHB_DMA_STPADDR0_RD(x) (HW_HDMI_AHB_DMA_STPADDR0(x).U)
#define HW_HDMI_AHB_DMA_STPADDR0_WR(x, v) (HW_HDMI_AHB_DMA_STPADDR0(x).U = (v))
#define HW_HDMI_AHB_DMA_STPADDR0_SET(x, v) (HW_HDMI_AHB_DMA_STPADDR0_WR(x, HW_HDMI_AHB_DMA_STPADDR0_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STPADDR0_CLR(x, v) (HW_HDMI_AHB_DMA_STPADDR0_WR(x, HW_HDMI_AHB_DMA_STPADDR0_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STPADDR0_TOG(x, v) (HW_HDMI_AHB_DMA_STPADDR0_WR(x, HW_HDMI_AHB_DMA_STPADDR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STPADDR0 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STPADDR0, field final_addr[7:0] (RW)
 *
 * Defines final_addr[7:0] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STPADDR0_final_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STPADDR0_final_addr. */
#define BM_HDMI_AHB_DMA_STPADDR0_final_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STPADDR0_final_addr. */
#define BS_HDMI_AHB_DMA_STPADDR0_final_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STPADDR0_final_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STPADDR0_final_addr field. */
#define BR_HDMI_AHB_DMA_STPADDR0_final_addr(x) (HW_HDMI_AHB_DMA_STPADDR0(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STPADDR0_final_addr. */
#define BF_HDMI_AHB_DMA_STPADDR0_final_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STPADDR0_final_addr) & BM_HDMI_AHB_DMA_STPADDR0_final_addr)

/*! @brief Set the final_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STPADDR0_final_addr(x, v) (HW_HDMI_AHB_DMA_STPADDR0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STPADDR1 - Audio DMA Stop Address Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STPADDR1 - Audio DMA Stop Address Register 1 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_stpaddr1
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stpaddr1_bitfields
    {
        uint8_t final_addr : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_stpaddr1_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STPADDR1 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STPADDR1_ADDR(x) ((uintptr_t)(x) + 0x3609U)

#define HW_HDMI_AHB_DMA_STPADDR1(x) (*(__IO hw_hdmi_ahb_dma_stpaddr1_t *) HW_HDMI_AHB_DMA_STPADDR1_ADDR(x))
#define HW_HDMI_AHB_DMA_STPADDR1_RD(x) (HW_HDMI_AHB_DMA_STPADDR1(x).U)
#define HW_HDMI_AHB_DMA_STPADDR1_WR(x, v) (HW_HDMI_AHB_DMA_STPADDR1(x).U = (v))
#define HW_HDMI_AHB_DMA_STPADDR1_SET(x, v) (HW_HDMI_AHB_DMA_STPADDR1_WR(x, HW_HDMI_AHB_DMA_STPADDR1_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STPADDR1_CLR(x, v) (HW_HDMI_AHB_DMA_STPADDR1_WR(x, HW_HDMI_AHB_DMA_STPADDR1_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STPADDR1_TOG(x, v) (HW_HDMI_AHB_DMA_STPADDR1_WR(x, HW_HDMI_AHB_DMA_STPADDR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STPADDR1 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STPADDR1, field final_addr[7:0] (RW)
 *
 * Defines final_addr[15:8] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STPADDR1_final_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STPADDR1_final_addr. */
#define BM_HDMI_AHB_DMA_STPADDR1_final_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STPADDR1_final_addr. */
#define BS_HDMI_AHB_DMA_STPADDR1_final_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STPADDR1_final_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STPADDR1_final_addr field. */
#define BR_HDMI_AHB_DMA_STPADDR1_final_addr(x) (HW_HDMI_AHB_DMA_STPADDR1(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STPADDR1_final_addr. */
#define BF_HDMI_AHB_DMA_STPADDR1_final_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STPADDR1_final_addr) & BM_HDMI_AHB_DMA_STPADDR1_final_addr)

/*! @brief Set the final_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STPADDR1_final_addr(x, v) (HW_HDMI_AHB_DMA_STPADDR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STPADDR2 - Audio DMA Stop Address Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STPADDR2 - Audio DMA Stop Address Register 2 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_stpaddr2
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stpaddr2_bitfields
    {
        uint8_t final_addr : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_stpaddr2_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STPADDR2 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STPADDR2_ADDR(x) ((uintptr_t)(x) + 0x360AU)

#define HW_HDMI_AHB_DMA_STPADDR2(x) (*(__IO hw_hdmi_ahb_dma_stpaddr2_t *) HW_HDMI_AHB_DMA_STPADDR2_ADDR(x))
#define HW_HDMI_AHB_DMA_STPADDR2_RD(x) (HW_HDMI_AHB_DMA_STPADDR2(x).U)
#define HW_HDMI_AHB_DMA_STPADDR2_WR(x, v) (HW_HDMI_AHB_DMA_STPADDR2(x).U = (v))
#define HW_HDMI_AHB_DMA_STPADDR2_SET(x, v) (HW_HDMI_AHB_DMA_STPADDR2_WR(x, HW_HDMI_AHB_DMA_STPADDR2_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STPADDR2_CLR(x, v) (HW_HDMI_AHB_DMA_STPADDR2_WR(x, HW_HDMI_AHB_DMA_STPADDR2_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STPADDR2_TOG(x, v) (HW_HDMI_AHB_DMA_STPADDR2_WR(x, HW_HDMI_AHB_DMA_STPADDR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STPADDR2 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STPADDR2, field final_addr[7:0] (RW)
 *
 * Defines final_addr[23:16] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STPADDR2_final_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STPADDR2_final_addr. */
#define BM_HDMI_AHB_DMA_STPADDR2_final_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STPADDR2_final_addr. */
#define BS_HDMI_AHB_DMA_STPADDR2_final_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STPADDR2_final_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STPADDR2_final_addr field. */
#define BR_HDMI_AHB_DMA_STPADDR2_final_addr(x) (HW_HDMI_AHB_DMA_STPADDR2(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STPADDR2_final_addr. */
#define BF_HDMI_AHB_DMA_STPADDR2_final_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STPADDR2_final_addr) & BM_HDMI_AHB_DMA_STPADDR2_final_addr)

/*! @brief Set the final_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STPADDR2_final_addr(x, v) (HW_HDMI_AHB_DMA_STPADDR2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STPADDR3 - Audio DMA Stop Address Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STPADDR3 - Audio DMA Stop Address Register 3 (RW)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_stpaddr3
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stpaddr3_bitfields
    {
        uint8_t final_addr : 8;        /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_stpaddr3_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STPADDR3 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STPADDR3_ADDR(x) ((uintptr_t)(x) + 0x360BU)

#define HW_HDMI_AHB_DMA_STPADDR3(x) (*(__IO hw_hdmi_ahb_dma_stpaddr3_t *) HW_HDMI_AHB_DMA_STPADDR3_ADDR(x))
#define HW_HDMI_AHB_DMA_STPADDR3_RD(x) (HW_HDMI_AHB_DMA_STPADDR3(x).U)
#define HW_HDMI_AHB_DMA_STPADDR3_WR(x, v) (HW_HDMI_AHB_DMA_STPADDR3(x).U = (v))
#define HW_HDMI_AHB_DMA_STPADDR3_SET(x, v) (HW_HDMI_AHB_DMA_STPADDR3_WR(x, HW_HDMI_AHB_DMA_STPADDR3_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_STPADDR3_CLR(x, v) (HW_HDMI_AHB_DMA_STPADDR3_WR(x, HW_HDMI_AHB_DMA_STPADDR3_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_STPADDR3_TOG(x, v) (HW_HDMI_AHB_DMA_STPADDR3_WR(x, HW_HDMI_AHB_DMA_STPADDR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STPADDR3 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STPADDR3, field final_addr[7:0] (RW)
 *
 * Defines final_addr[31:24] for bits 7-0 to initiate DMA burst transactions
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STPADDR3_final_addr (0U) /*!< Bit position for HDMI_AHB_DMA_STPADDR3_final_addr. */
#define BM_HDMI_AHB_DMA_STPADDR3_final_addr (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_STPADDR3_final_addr. */
#define BS_HDMI_AHB_DMA_STPADDR3_final_addr (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_STPADDR3_final_addr. */

/*! @brief Read current value of the HDMI_AHB_DMA_STPADDR3_final_addr field. */
#define BR_HDMI_AHB_DMA_STPADDR3_final_addr(x) (HW_HDMI_AHB_DMA_STPADDR3(x).U)

/*! @brief Format value for bitfield HDMI_AHB_DMA_STPADDR3_final_addr. */
#define BF_HDMI_AHB_DMA_STPADDR3_final_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_STPADDR3_final_addr) & BM_HDMI_AHB_DMA_STPADDR3_final_addr)

/*! @brief Set the final_addr field to a new value. */
#define BW_HDMI_AHB_DMA_STPADDR3_final_addr(x, v) (HW_HDMI_AHB_DMA_STPADDR3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BSTADDR0 - Audio DMA Burst Start Address Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BSTADDR0 - Audio DMA Burst Start Address Register 0 (RO)
 *
 * Reset value: 0x00U
 *
 * This read-only register composes the start address of the current burst
 * operation. As an example, if the first burst transaction of the AHB audio DMA as a
 * length of 16, then the second burst should start at address ohaddr[31:0] =
 * initial_addr[31:0] + 16. While this burst is being executed,
 * burst_start_addr[31:0] = haddr[31:0] = initial_addr[31:0] + 16. Address Offset: 0x360C to 0x360F
 * Size: 8 bits per register Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_bstaddr0
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_bstaddr0_bitfields
    {
        uint8_t burst_start : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_bstaddr0_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BSTADDR0 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BSTADDR0_ADDR(x) ((uintptr_t)(x) + 0x360CU)

#define HW_HDMI_AHB_DMA_BSTADDR0(x) (*(__I hw_hdmi_ahb_dma_bstaddr0_t *) HW_HDMI_AHB_DMA_BSTADDR0_ADDR(x))
#define HW_HDMI_AHB_DMA_BSTADDR0_RD(x) (HW_HDMI_AHB_DMA_BSTADDR0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BSTADDR0 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BSTADDR0, field burst_start[7:0] (RO)
 *
 * Start address for the current burst operation
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BSTADDR0_burst_start (0U) /*!< Bit position for HDMI_AHB_DMA_BSTADDR0_burst_start. */
#define BM_HDMI_AHB_DMA_BSTADDR0_burst_start (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_BSTADDR0_burst_start. */
#define BS_HDMI_AHB_DMA_BSTADDR0_burst_start (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_BSTADDR0_burst_start. */

/*! @brief Read current value of the HDMI_AHB_DMA_BSTADDR0_burst_start field. */
#define BR_HDMI_AHB_DMA_BSTADDR0_burst_start(x) (HW_HDMI_AHB_DMA_BSTADDR0(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BSTADDR1 - Audio DMA Burst Start Address Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BSTADDR1 - Audio DMA Burst Start Address Register 1 (RO)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_bstaddr1
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_bstaddr1_bitfields
    {
        uint8_t burst_start : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_bstaddr1_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BSTADDR1 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BSTADDR1_ADDR(x) ((uintptr_t)(x) + 0x360DU)

#define HW_HDMI_AHB_DMA_BSTADDR1(x) (*(__I hw_hdmi_ahb_dma_bstaddr1_t *) HW_HDMI_AHB_DMA_BSTADDR1_ADDR(x))
#define HW_HDMI_AHB_DMA_BSTADDR1_RD(x) (HW_HDMI_AHB_DMA_BSTADDR1(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BSTADDR1 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BSTADDR1, field burst_start[7:0] (RO)
 *
 * Start address for the current burst operation
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BSTADDR1_burst_start (0U) /*!< Bit position for HDMI_AHB_DMA_BSTADDR1_burst_start. */
#define BM_HDMI_AHB_DMA_BSTADDR1_burst_start (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_BSTADDR1_burst_start. */
#define BS_HDMI_AHB_DMA_BSTADDR1_burst_start (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_BSTADDR1_burst_start. */

/*! @brief Read current value of the HDMI_AHB_DMA_BSTADDR1_burst_start field. */
#define BR_HDMI_AHB_DMA_BSTADDR1_burst_start(x) (HW_HDMI_AHB_DMA_BSTADDR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BSTADDR2 - Audio DMA Burst Start Address Register 2
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BSTADDR2 - Audio DMA Burst Start Address Register 2 (RO)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_bstaddr2
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_bstaddr2_bitfields
    {
        uint8_t burst_start : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_bstaddr2_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BSTADDR2 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BSTADDR2_ADDR(x) ((uintptr_t)(x) + 0x360EU)

#define HW_HDMI_AHB_DMA_BSTADDR2(x) (*(__I hw_hdmi_ahb_dma_bstaddr2_t *) HW_HDMI_AHB_DMA_BSTADDR2_ADDR(x))
#define HW_HDMI_AHB_DMA_BSTADDR2_RD(x) (HW_HDMI_AHB_DMA_BSTADDR2(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BSTADDR2 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BSTADDR2, field burst_start[7:0] (RO)
 *
 * Start address for the current burst operation
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BSTADDR2_burst_start (0U) /*!< Bit position for HDMI_AHB_DMA_BSTADDR2_burst_start. */
#define BM_HDMI_AHB_DMA_BSTADDR2_burst_start (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_BSTADDR2_burst_start. */
#define BS_HDMI_AHB_DMA_BSTADDR2_burst_start (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_BSTADDR2_burst_start. */

/*! @brief Read current value of the HDMI_AHB_DMA_BSTADDR2_burst_start field. */
#define BR_HDMI_AHB_DMA_BSTADDR2_burst_start(x) (HW_HDMI_AHB_DMA_BSTADDR2(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BSTADDR3 - Audio DMA Burst Start Address Register 3
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BSTADDR3 - Audio DMA Burst Start Address Register 3 (RO)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_bstaddr3
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_bstaddr3_bitfields
    {
        uint8_t burst_start : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_bstaddr3_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BSTADDR3 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BSTADDR3_ADDR(x) ((uintptr_t)(x) + 0x360FU)

#define HW_HDMI_AHB_DMA_BSTADDR3(x) (*(__I hw_hdmi_ahb_dma_bstaddr3_t *) HW_HDMI_AHB_DMA_BSTADDR3_ADDR(x))
#define HW_HDMI_AHB_DMA_BSTADDR3_RD(x) (HW_HDMI_AHB_DMA_BSTADDR3(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BSTADDR3 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BSTADDR3, field burst_start[7:0] (RO)
 *
 * Start address for the current burst operation
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BSTADDR3_burst_start (0U) /*!< Bit position for HDMI_AHB_DMA_BSTADDR3_burst_start. */
#define BM_HDMI_AHB_DMA_BSTADDR3_burst_start (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_BSTADDR3_burst_start. */
#define BS_HDMI_AHB_DMA_BSTADDR3_burst_start (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_BSTADDR3_burst_start. */

/*! @brief Read current value of the HDMI_AHB_DMA_BSTADDR3_burst_start field. */
#define BR_HDMI_AHB_DMA_BSTADDR3_burst_start(x) (HW_HDMI_AHB_DMA_BSTADDR3(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_MBLENGTH0 - Audio DMA Burst Length Register 0
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_MBLENGTH0 - Audio DMA Burst Length Register 0 (RO)
 *
 * Reset value: 0x00U
 *
 * These registers hold the length of the current burst operation. As an
 * example, if the first burst transaction of the AHB audio DMA is a length of 8, then
 * the second burst should start at address ohaddr[31:0] = initial_addr[31:0] + 8.
 * It will also have length MBURSTLENGTH[10:0] = AUDIO_FIFO_DEPTH -
 * fifo_threshold[7:0] while this burst is being executed, MBURSTLENGTH[10:0] =
 * AUDIO_FIFO_DEPTH - fifo_threshold[7:0]. Address Offset: 0x3610 to 0x3611 Size: 8 bits per
 * register Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_mblength0
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_mblength0_bitfields
    {
        uint8_t MBURSTLENGTH7 : 8;     /*!< [7:0]  */
    } B;
} hw_hdmi_ahb_dma_mblength0_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_MBLENGTH0 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_MBLENGTH0_ADDR(x) ((uintptr_t)(x) + 0x3610U)

#define HW_HDMI_AHB_DMA_MBLENGTH0(x) (*(__I hw_hdmi_ahb_dma_mblength0_t *) HW_HDMI_AHB_DMA_MBLENGTH0_ADDR(x))
#define HW_HDMI_AHB_DMA_MBLENGTH0_RD(x) (HW_HDMI_AHB_DMA_MBLENGTH0(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_MBLENGTH0 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_MBLENGTH0, field MBURSTLENGTH7[7:0] (RO)
 *
 * Requested burst length
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7 (0U) /*!< Bit position for HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7. */
#define BM_HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7 (0xFFU) /*!< Bit mask for HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7. */
#define BS_HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7 (8U) /*!< Bit field size in bits for HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7. */

/*! @brief Read current value of the HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7 field. */
#define BR_HDMI_AHB_DMA_MBLENGTH0_MBURSTLENGTH7(x) (HW_HDMI_AHB_DMA_MBLENGTH0(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_MBLENGTH1 - Audio DMA Burst Length Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_MBLENGTH1 - Audio DMA Burst Length Register 1 (RO)
 *
 * Reset value: 0x00U
 */
typedef union _hw_hdmi_ahb_dma_mblength1
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_mblength1_bitfields
    {
        uint8_t MBURSTLENGTH8 : 1;     /*!< [0]  */
        uint8_t MBURSTLENGTH9 : 1;     /*!< [1]  */
        uint8_t MBURSTLENGTH10 : 1;    /*!< [2]  */
        uint8_t RESERVED0 : 5;         /*!< [7:3]  */
    } B;
} hw_hdmi_ahb_dma_mblength1_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_MBLENGTH1 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_MBLENGTH1_ADDR(x) ((uintptr_t)(x) + 0x3611U)

#define HW_HDMI_AHB_DMA_MBLENGTH1(x) (*(__I hw_hdmi_ahb_dma_mblength1_t *) HW_HDMI_AHB_DMA_MBLENGTH1_ADDR(x))
#define HW_HDMI_AHB_DMA_MBLENGTH1_RD(x) (HW_HDMI_AHB_DMA_MBLENGTH1(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_MBLENGTH1 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_MBLENGTH1, field MBURSTLENGTH8[0] (RO)
 *
 * Requested burst length
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8 (0U) /*!< Bit position for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8. */
#define BM_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8 (0x01U) /*!< Bit mask for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8. */
#define BS_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8. */

/*! @brief Read current value of the HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8 field. */
#define BR_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH8(x) (HW_HDMI_AHB_DMA_MBLENGTH1(x).B.MBURSTLENGTH8)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MBLENGTH1, field MBURSTLENGTH9[1] (RO)
 *
 * Requested burst length
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9 (1U) /*!< Bit position for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9. */
#define BM_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9 (0x02U) /*!< Bit mask for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9. */
#define BS_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9. */

/*! @brief Read current value of the HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9 field. */
#define BR_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH9(x) (HW_HDMI_AHB_DMA_MBLENGTH1(x).B.MBURSTLENGTH9)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MBLENGTH1, field MBURSTLENGTH10[2] (RO)
 *
 * Requested burst length
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10 (2U) /*!< Bit position for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10. */
#define BM_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10 (0x04U) /*!< Bit mask for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10. */
#define BS_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10. */

/*! @brief Read current value of the HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10 field. */
#define BR_HDMI_AHB_DMA_MBLENGTH1_MBURSTLENGTH10(x) (HW_HDMI_AHB_DMA_MBLENGTH1(x).B.MBURSTLENGTH10)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_STAT - Audio DMA Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_STAT - Audio DMA Interrupt Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the status bits of the following interrupts: Address
 * Offset: 0x3612 Size: 8 bits per register Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_stat
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_stat_bitfields
    {
        uint8_t statfifoempty : 1;     /*!< [0]  */
        uint8_t statfifofull : 1;      /*!< [1]  */
        uint8_t statthrfifoempty : 1;  /*!< [2]  */
        uint8_t RESERVED0 : 1;         /*!< [3]  */
        uint8_t staterror : 1;         /*!< [4]  */
        uint8_t statlostownership : 1; /*!< [5]  */
        uint8_t statretrysplit : 1;    /*!< [6]  */
        uint8_t statdone : 1;          /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_stat_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_STAT register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_STAT_ADDR(x) ((uintptr_t)(x) + 0x3612U)

#define HW_HDMI_AHB_DMA_STAT(x)  (*(__I hw_hdmi_ahb_dma_stat_t *) HW_HDMI_AHB_DMA_STAT_ADDR(x))
#define HW_HDMI_AHB_DMA_STAT_RD(x) (HW_HDMI_AHB_DMA_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_STAT bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statfifoempty[0] (RO)
 *
 * Status of audio FIFO empty interrupt.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statfifoempty (0U) /*!< Bit position for HDMI_AHB_DMA_STAT_statfifoempty. */
#define BM_HDMI_AHB_DMA_STAT_statfifoempty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statfifoempty. */
#define BS_HDMI_AHB_DMA_STAT_statfifoempty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statfifoempty. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statfifoempty field. */
#define BR_HDMI_AHB_DMA_STAT_statfifoempty(x) (HW_HDMI_AHB_DMA_STAT(x).B.statfifoempty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statfifofull[1] (RO)
 *
 * Status of audio FIFO full interrupt.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statfifofull (1U) /*!< Bit position for HDMI_AHB_DMA_STAT_statfifofull. */
#define BM_HDMI_AHB_DMA_STAT_statfifofull (0x02U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statfifofull. */
#define BS_HDMI_AHB_DMA_STAT_statfifofull (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statfifofull. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statfifofull field. */
#define BR_HDMI_AHB_DMA_STAT_statfifofull(x) (HW_HDMI_AHB_DMA_STAT(x).B.statfifofull)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statthrfifoempty[2] (RO)
 *
 * Status of audio FIFO empty when audio FIFO has less than four samples.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statthrfifoempty (2U) /*!< Bit position for HDMI_AHB_DMA_STAT_statthrfifoempty. */
#define BM_HDMI_AHB_DMA_STAT_statthrfifoempty (0x04U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statthrfifoempty. */
#define BS_HDMI_AHB_DMA_STAT_statthrfifoempty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statthrfifoempty. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statthrfifoempty field. */
#define BR_HDMI_AHB_DMA_STAT_statthrfifoempty(x) (HW_HDMI_AHB_DMA_STAT(x).B.statthrfifoempty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field staterror[4] (RO)
 *
 * Status of error interrupt. Active when slave indicates error through the
 * isresp[1:0].
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_staterror (4U) /*!< Bit position for HDMI_AHB_DMA_STAT_staterror. */
#define BM_HDMI_AHB_DMA_STAT_staterror (0x10U) /*!< Bit mask for HDMI_AHB_DMA_STAT_staterror. */
#define BS_HDMI_AHB_DMA_STAT_staterror (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_staterror. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_staterror field. */
#define BR_HDMI_AHB_DMA_STAT_staterror(x) (HW_HDMI_AHB_DMA_STAT(x).B.staterror)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statlostownership[5] (RO)
 *
 * Status of master lost ownership when in burst transfer. Active when AHB
 * master loses BUS ownership within the course of a burst transfer.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statlostownership (5U) /*!< Bit position for HDMI_AHB_DMA_STAT_statlostownership. */
#define BM_HDMI_AHB_DMA_STAT_statlostownership (0x20U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statlostownership. */
#define BS_HDMI_AHB_DMA_STAT_statlostownership (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statlostownership. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statlostownership field. */
#define BR_HDMI_AHB_DMA_STAT_statlostownership(x) (HW_HDMI_AHB_DMA_STAT(x).B.statlostownership)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statretrysplit[6] (RO)
 *
 * Status of retry/split interrupt. Active when AHB master receives a RETRY or
 * SPLIT response from slave.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statretrysplit (6U) /*!< Bit position for HDMI_AHB_DMA_STAT_statretrysplit. */
#define BM_HDMI_AHB_DMA_STAT_statretrysplit (0x40U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statretrysplit. */
#define BS_HDMI_AHB_DMA_STAT_statretrysplit (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statretrysplit. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statretrysplit field. */
#define BR_HDMI_AHB_DMA_STAT_statretrysplit(x) (HW_HDMI_AHB_DMA_STAT(x).B.statretrysplit)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_STAT, field statdone[7] (RO)
 *
 * Status of DMA end of operation interrupt. Active when DMA engine reaches
 * final_addr[15:0] or when stop DMA operation is activated.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_STAT_statdone (7U) /*!< Bit position for HDMI_AHB_DMA_STAT_statdone. */
#define BM_HDMI_AHB_DMA_STAT_statdone (0x80U) /*!< Bit mask for HDMI_AHB_DMA_STAT_statdone. */
#define BS_HDMI_AHB_DMA_STAT_statdone (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_STAT_statdone. */

/*! @brief Read current value of the HDMI_AHB_DMA_STAT_statdone field. */
#define BR_HDMI_AHB_DMA_STAT_statdone(x) (HW_HDMI_AHB_DMA_STAT(x).B.statdone)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_INT - Audio DMA Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_INT - Audio DMA Interrupt Register (RO)
 *
 * Reset value: 0x00U
 *
 * This register contains the interrupt bits of the following interrupts:
 * Address Offset: 0x3613 Size: 8 bits per register Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_int
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_int_bitfields
    {
        uint8_t intfifoempty : 1;      /*!< [0]  */
        uint8_t intfifofull : 1;       /*!< [1]  */
        uint8_t intthrfifoempty : 1;   /*!< [2]  */
        uint8_t RESERVED0 : 1;         /*!< [3]  */
        uint8_t interror : 1;          /*!< [4]  */
        uint8_t intlostownership : 1;  /*!< [5]  */
        uint8_t intretrysplit : 1;     /*!< [6]  */
        uint8_t intdone : 1;           /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_int_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_INT register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_INT_ADDR(x) ((uintptr_t)(x) + 0x3613U)

#define HW_HDMI_AHB_DMA_INT(x)   (*(__I hw_hdmi_ahb_dma_int_t *) HW_HDMI_AHB_DMA_INT_ADDR(x))
#define HW_HDMI_AHB_DMA_INT_RD(x) (HW_HDMI_AHB_DMA_INT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_INT bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_INT, field intfifoempty[0] (RO)
 *
 * Audio FIFO empty interrupt.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intfifoempty (0U) /*!< Bit position for HDMI_AHB_DMA_INT_intfifoempty. */
#define BM_HDMI_AHB_DMA_INT_intfifoempty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_INT_intfifoempty. */
#define BS_HDMI_AHB_DMA_INT_intfifoempty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intfifoempty. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intfifoempty field. */
#define BR_HDMI_AHB_DMA_INT_intfifoempty(x) (HW_HDMI_AHB_DMA_INT(x).B.intfifoempty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field intfifofull[1] (RO)
 *
 * Audio FIFO full interrupt.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intfifofull (1U) /*!< Bit position for HDMI_AHB_DMA_INT_intfifofull. */
#define BM_HDMI_AHB_DMA_INT_intfifofull (0x02U) /*!< Bit mask for HDMI_AHB_DMA_INT_intfifofull. */
#define BS_HDMI_AHB_DMA_INT_intfifofull (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intfifofull. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intfifofull field. */
#define BR_HDMI_AHB_DMA_INT_intfifofull(x) (HW_HDMI_AHB_DMA_INT(x).B.intfifofull)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field intthrfifoempty[2] (RO)
 *
 * Audio FIFO empty interrupt when audio FIFO has less than four samples.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intthrfifoempty (2U) /*!< Bit position for HDMI_AHB_DMA_INT_intthrfifoempty. */
#define BM_HDMI_AHB_DMA_INT_intthrfifoempty (0x04U) /*!< Bit mask for HDMI_AHB_DMA_INT_intthrfifoempty. */
#define BS_HDMI_AHB_DMA_INT_intthrfifoempty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intthrfifoempty. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intthrfifoempty field. */
#define BR_HDMI_AHB_DMA_INT_intthrfifoempty(x) (HW_HDMI_AHB_DMA_INT(x).B.intthrfifoempty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field interror[4] (RO)
 *
 * Error interrupt. Active when slave indicates error through the isresp[1:0].
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_interror (4U)  /*!< Bit position for HDMI_AHB_DMA_INT_interror. */
#define BM_HDMI_AHB_DMA_INT_interror (0x10U) /*!< Bit mask for HDMI_AHB_DMA_INT_interror. */
#define BS_HDMI_AHB_DMA_INT_interror (1U)  /*!< Bit field size in bits for HDMI_AHB_DMA_INT_interror. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_interror field. */
#define BR_HDMI_AHB_DMA_INT_interror(x) (HW_HDMI_AHB_DMA_INT(x).B.interror)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field intlostownership[5] (RO)
 *
 * Master lost ownership interrupt when in burst transfer. Active when AHB
 * master loses BUS ownership within the course of a burst transfer.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intlostownership (5U) /*!< Bit position for HDMI_AHB_DMA_INT_intlostownership. */
#define BM_HDMI_AHB_DMA_INT_intlostownership (0x20U) /*!< Bit mask for HDMI_AHB_DMA_INT_intlostownership. */
#define BS_HDMI_AHB_DMA_INT_intlostownership (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intlostownership. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intlostownership field. */
#define BR_HDMI_AHB_DMA_INT_intlostownership(x) (HW_HDMI_AHB_DMA_INT(x).B.intlostownership)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field intretrysplit[6] (RO)
 *
 * Retry/split interrupt. Active when AHB master receives a RETRY or SPLIT
 * response from slave.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intretrysplit (6U) /*!< Bit position for HDMI_AHB_DMA_INT_intretrysplit. */
#define BM_HDMI_AHB_DMA_INT_intretrysplit (0x40U) /*!< Bit mask for HDMI_AHB_DMA_INT_intretrysplit. */
#define BS_HDMI_AHB_DMA_INT_intretrysplit (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intretrysplit. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intretrysplit field. */
#define BR_HDMI_AHB_DMA_INT_intretrysplit(x) (HW_HDMI_AHB_DMA_INT(x).B.intretrysplit)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_INT, field intdone[7] (RO)
 *
 * DMA end of operation interrupt. Active when DMA engine reaches
 * final_addr[15:0] or when stop DMA operation is activated.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_INT_intdone (7U)   /*!< Bit position for HDMI_AHB_DMA_INT_intdone. */
#define BM_HDMI_AHB_DMA_INT_intdone (0x80U) /*!< Bit mask for HDMI_AHB_DMA_INT_intdone. */
#define BS_HDMI_AHB_DMA_INT_intdone (1U)   /*!< Bit field size in bits for HDMI_AHB_DMA_INT_intdone. */

/*! @brief Read current value of the HDMI_AHB_DMA_INT_intdone field. */
#define BR_HDMI_AHB_DMA_INT_intdone(x) (HW_HDMI_AHB_DMA_INT(x).B.intdone)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_MASK - Audio DMA Mask Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_MASK - Audio DMA Mask Interrupt Register (RW)
 *
 * Reset value: 0x11U
 *
 * Mask for each of the interrupts present in the AHB audio DMA module. For
 * usage information, see AHB_DMA_INTAudio DMA Interrupt Register ." Address Offset:
 * 0x3614 Size: 8 bits per register Value after Reset: 0xF7 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_mask
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_mask_bitfields
    {
        uint8_t fifo_empty_mask : 1;   /*!< [0]  */
        uint8_t fifo_full_mask : 1;    /*!< [1]  */
        uint8_t fifo_thrempty_mask : 1; /*!< [2]  */
        uint8_t RESERVED0 : 1;         /*!< [3]  */
        uint8_t error_mask : 1;        /*!< [4]  */
        uint8_t lostownership_mask : 1; /*!< [5]  */
        uint8_t retrysplit_mask : 1;   /*!< [6]  */
        uint8_t done_mask : 1;         /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_mask_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_MASK register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_MASK_ADDR(x) ((uintptr_t)(x) + 0x3614U)

#define HW_HDMI_AHB_DMA_MASK(x)  (*(__IO hw_hdmi_ahb_dma_mask_t *) HW_HDMI_AHB_DMA_MASK_ADDR(x))
#define HW_HDMI_AHB_DMA_MASK_RD(x) (HW_HDMI_AHB_DMA_MASK(x).U)
#define HW_HDMI_AHB_DMA_MASK_WR(x, v) (HW_HDMI_AHB_DMA_MASK(x).U = (v))
#define HW_HDMI_AHB_DMA_MASK_SET(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, HW_HDMI_AHB_DMA_MASK_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_MASK_CLR(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, HW_HDMI_AHB_DMA_MASK_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_MASK_TOG(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, HW_HDMI_AHB_DMA_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_MASK bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_MASK, field fifo_empty_mask[0] (RW)
 *
 * Audio FIFO empty interrupt mask.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_fifo_empty_mask (0U) /*!< Bit position for HDMI_AHB_DMA_MASK_fifo_empty_mask. */
#define BM_HDMI_AHB_DMA_MASK_fifo_empty_mask (0x01U) /*!< Bit mask for HDMI_AHB_DMA_MASK_fifo_empty_mask. */
#define BS_HDMI_AHB_DMA_MASK_fifo_empty_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_fifo_empty_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_fifo_empty_mask field. */
#define BR_HDMI_AHB_DMA_MASK_fifo_empty_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.fifo_empty_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_fifo_empty_mask. */
#define BF_HDMI_AHB_DMA_MASK_fifo_empty_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_fifo_empty_mask) & BM_HDMI_AHB_DMA_MASK_fifo_empty_mask)

/*! @brief Set the fifo_empty_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_fifo_empty_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_fifo_empty_mask) | BF_HDMI_AHB_DMA_MASK_fifo_empty_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field fifo_full_mask[1] (RW)
 *
 * Audio FIFO full interrupt mask.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_fifo_full_mask (1U) /*!< Bit position for HDMI_AHB_DMA_MASK_fifo_full_mask. */
#define BM_HDMI_AHB_DMA_MASK_fifo_full_mask (0x02U) /*!< Bit mask for HDMI_AHB_DMA_MASK_fifo_full_mask. */
#define BS_HDMI_AHB_DMA_MASK_fifo_full_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_fifo_full_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_fifo_full_mask field. */
#define BR_HDMI_AHB_DMA_MASK_fifo_full_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.fifo_full_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_fifo_full_mask. */
#define BF_HDMI_AHB_DMA_MASK_fifo_full_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_fifo_full_mask) & BM_HDMI_AHB_DMA_MASK_fifo_full_mask)

/*! @brief Set the fifo_full_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_fifo_full_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_fifo_full_mask) | BF_HDMI_AHB_DMA_MASK_fifo_full_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field fifo_thrempty_mask[2] (RW)
 *
 * Audio FIFO empty interrupt mask when audio FIFO has less than four samples.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_fifo_thrempty_mask (2U) /*!< Bit position for HDMI_AHB_DMA_MASK_fifo_thrempty_mask. */
#define BM_HDMI_AHB_DMA_MASK_fifo_thrempty_mask (0x04U) /*!< Bit mask for HDMI_AHB_DMA_MASK_fifo_thrempty_mask. */
#define BS_HDMI_AHB_DMA_MASK_fifo_thrempty_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_fifo_thrempty_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_fifo_thrempty_mask field. */
#define BR_HDMI_AHB_DMA_MASK_fifo_thrempty_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.fifo_thrempty_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_fifo_thrempty_mask. */
#define BF_HDMI_AHB_DMA_MASK_fifo_thrempty_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_fifo_thrempty_mask) & BM_HDMI_AHB_DMA_MASK_fifo_thrempty_mask)

/*! @brief Set the fifo_thrempty_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_fifo_thrempty_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_fifo_thrempty_mask) | BF_HDMI_AHB_DMA_MASK_fifo_thrempty_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field error_mask[4] (RW)
 *
 * Error interrupt mask. Active when slave indicates error through the
 * isresp[1:0].
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_error_mask (4U) /*!< Bit position for HDMI_AHB_DMA_MASK_error_mask. */
#define BM_HDMI_AHB_DMA_MASK_error_mask (0x10U) /*!< Bit mask for HDMI_AHB_DMA_MASK_error_mask. */
#define BS_HDMI_AHB_DMA_MASK_error_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_error_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_error_mask field. */
#define BR_HDMI_AHB_DMA_MASK_error_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.error_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_error_mask. */
#define BF_HDMI_AHB_DMA_MASK_error_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_error_mask) & BM_HDMI_AHB_DMA_MASK_error_mask)

/*! @brief Set the error_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_error_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_error_mask) | BF_HDMI_AHB_DMA_MASK_error_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field lostownership_mask[5] (RW)
 *
 * Master lost ownership interrupt mask when in burst transfer. Active when AHB
 * master loses BUS ownership within the course of a burst transfer.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_lostownership_mask (5U) /*!< Bit position for HDMI_AHB_DMA_MASK_lostownership_mask. */
#define BM_HDMI_AHB_DMA_MASK_lostownership_mask (0x20U) /*!< Bit mask for HDMI_AHB_DMA_MASK_lostownership_mask. */
#define BS_HDMI_AHB_DMA_MASK_lostownership_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_lostownership_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_lostownership_mask field. */
#define BR_HDMI_AHB_DMA_MASK_lostownership_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.lostownership_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_lostownership_mask. */
#define BF_HDMI_AHB_DMA_MASK_lostownership_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_lostownership_mask) & BM_HDMI_AHB_DMA_MASK_lostownership_mask)

/*! @brief Set the lostownership_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_lostownership_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_lostownership_mask) | BF_HDMI_AHB_DMA_MASK_lostownership_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field retrysplit_mask[6] (RW)
 *
 * Retry/split interrupt mask. Active when AHB master receives a RETRY or SPLIT
 * response from slave.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_retrysplit_mask (6U) /*!< Bit position for HDMI_AHB_DMA_MASK_retrysplit_mask. */
#define BM_HDMI_AHB_DMA_MASK_retrysplit_mask (0x40U) /*!< Bit mask for HDMI_AHB_DMA_MASK_retrysplit_mask. */
#define BS_HDMI_AHB_DMA_MASK_retrysplit_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_retrysplit_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_retrysplit_mask field. */
#define BR_HDMI_AHB_DMA_MASK_retrysplit_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.retrysplit_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_retrysplit_mask. */
#define BF_HDMI_AHB_DMA_MASK_retrysplit_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_retrysplit_mask) & BM_HDMI_AHB_DMA_MASK_retrysplit_mask)

/*! @brief Set the retrysplit_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_retrysplit_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_retrysplit_mask) | BF_HDMI_AHB_DMA_MASK_retrysplit_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_MASK, field done_mask[7] (RW)
 *
 * DMA end of operation interrupt mask. Active when DMA engine reaches
 * final_addr[15:0] or when stop DMA operation is activated.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_MASK_done_mask (7U) /*!< Bit position for HDMI_AHB_DMA_MASK_done_mask. */
#define BM_HDMI_AHB_DMA_MASK_done_mask (0x80U) /*!< Bit mask for HDMI_AHB_DMA_MASK_done_mask. */
#define BS_HDMI_AHB_DMA_MASK_done_mask (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_MASK_done_mask. */

/*! @brief Read current value of the HDMI_AHB_DMA_MASK_done_mask field. */
#define BR_HDMI_AHB_DMA_MASK_done_mask(x) (HW_HDMI_AHB_DMA_MASK(x).B.done_mask)

/*! @brief Format value for bitfield HDMI_AHB_DMA_MASK_done_mask. */
#define BF_HDMI_AHB_DMA_MASK_done_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_MASK_done_mask) & BM_HDMI_AHB_DMA_MASK_done_mask)

/*! @brief Set the done_mask field to a new value. */
#define BW_HDMI_AHB_DMA_MASK_done_mask(x, v) (HW_HDMI_AHB_DMA_MASK_WR(x, (HW_HDMI_AHB_DMA_MASK_RD(x) & ~BM_HDMI_AHB_DMA_MASK_done_mask) | BF_HDMI_AHB_DMA_MASK_done_mask(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_POL - Audio DMA Polarity Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_POL - Audio DMA Polarity Interrupt Register (RW)
 *
 * Reset value: 0x11U
 *
 * Polarity for each of the interrupts present in the AHB audio DMA module. For
 * usage information, see AHB_DMA_INTAudio DMA Interrupt Register ." Address
 * Offset: 0x3615 Size: 8 bits per register Value after Reset: 0xF7 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_pol
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_pol_bitfields
    {
        uint8_t fifo_empty_polarity : 1; /*!< [0]  */
        uint8_t fifo_full_polarity : 1; /*!< [1]  */
        uint8_t fifo_thrfifoempty_polarity : 1; /*!< [2]  */
        uint8_t RESERVED0 : 1;         /*!< [3]  */
        uint8_t error_polarity : 1;    /*!< [4]  */
        uint8_t lostownership_polarity : 1; /*!< [5]  */
        uint8_t retrysplit_polarity : 1; /*!< [6]  */
        uint8_t done_polarity : 1;     /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_pol_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_POL register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_POL_ADDR(x) ((uintptr_t)(x) + 0x3615U)

#define HW_HDMI_AHB_DMA_POL(x)   (*(__IO hw_hdmi_ahb_dma_pol_t *) HW_HDMI_AHB_DMA_POL_ADDR(x))
#define HW_HDMI_AHB_DMA_POL_RD(x) (HW_HDMI_AHB_DMA_POL(x).U)
#define HW_HDMI_AHB_DMA_POL_WR(x, v) (HW_HDMI_AHB_DMA_POL(x).U = (v))
#define HW_HDMI_AHB_DMA_POL_SET(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, HW_HDMI_AHB_DMA_POL_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_POL_CLR(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, HW_HDMI_AHB_DMA_POL_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_POL_TOG(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, HW_HDMI_AHB_DMA_POL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_POL bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_POL, field fifo_empty_polarity[0] (RW)
 *
 * Audio FIFO empty interrupt mask.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_fifo_empty_polarity (0U) /*!< Bit position for HDMI_AHB_DMA_POL_fifo_empty_polarity. */
#define BM_HDMI_AHB_DMA_POL_fifo_empty_polarity (0x01U) /*!< Bit mask for HDMI_AHB_DMA_POL_fifo_empty_polarity. */
#define BS_HDMI_AHB_DMA_POL_fifo_empty_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_fifo_empty_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_fifo_empty_polarity field. */
#define BR_HDMI_AHB_DMA_POL_fifo_empty_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.fifo_empty_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_fifo_empty_polarity. */
#define BF_HDMI_AHB_DMA_POL_fifo_empty_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_fifo_empty_polarity) & BM_HDMI_AHB_DMA_POL_fifo_empty_polarity)

/*! @brief Set the fifo_empty_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_fifo_empty_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_fifo_empty_polarity) | BF_HDMI_AHB_DMA_POL_fifo_empty_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field fifo_full_polarity[1] (RW)
 *
 * Audio FIFO full interrupt mask.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_fifo_full_polarity (1U) /*!< Bit position for HDMI_AHB_DMA_POL_fifo_full_polarity. */
#define BM_HDMI_AHB_DMA_POL_fifo_full_polarity (0x02U) /*!< Bit mask for HDMI_AHB_DMA_POL_fifo_full_polarity. */
#define BS_HDMI_AHB_DMA_POL_fifo_full_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_fifo_full_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_fifo_full_polarity field. */
#define BR_HDMI_AHB_DMA_POL_fifo_full_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.fifo_full_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_fifo_full_polarity. */
#define BF_HDMI_AHB_DMA_POL_fifo_full_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_fifo_full_polarity) & BM_HDMI_AHB_DMA_POL_fifo_full_polarity)

/*! @brief Set the fifo_full_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_fifo_full_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_fifo_full_polarity) | BF_HDMI_AHB_DMA_POL_fifo_full_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field fifo_thrfifoempty_polarity[2] (RW)
 *
 * Audio FIFO empty interrupt mask when audio FIFO has less than four samples.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity (2U) /*!< Bit position for HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity. */
#define BM_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity (0x04U) /*!< Bit mask for HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity. */
#define BS_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity field. */
#define BR_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.fifo_thrfifoempty_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity. */
#define BF_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity) & BM_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity)

/*! @brief Set the fifo_thrfifoempty_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity) | BF_HDMI_AHB_DMA_POL_fifo_thrfifoempty_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field error_polarity[4] (RW)
 *
 * Error interrupt mask. Active when slave indicates error through the
 * isresp[1:0].
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_error_polarity (4U) /*!< Bit position for HDMI_AHB_DMA_POL_error_polarity. */
#define BM_HDMI_AHB_DMA_POL_error_polarity (0x10U) /*!< Bit mask for HDMI_AHB_DMA_POL_error_polarity. */
#define BS_HDMI_AHB_DMA_POL_error_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_error_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_error_polarity field. */
#define BR_HDMI_AHB_DMA_POL_error_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.error_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_error_polarity. */
#define BF_HDMI_AHB_DMA_POL_error_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_error_polarity) & BM_HDMI_AHB_DMA_POL_error_polarity)

/*! @brief Set the error_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_error_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_error_polarity) | BF_HDMI_AHB_DMA_POL_error_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field lostownership_polarity[5] (RW)
 *
 * Master lost ownership interrupt mask when in burst transfer. Active when AHB
 * master loses BUS ownership within the course of a burst transfer.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_lostownership_polarity (5U) /*!< Bit position for HDMI_AHB_DMA_POL_lostownership_polarity. */
#define BM_HDMI_AHB_DMA_POL_lostownership_polarity (0x20U) /*!< Bit mask for HDMI_AHB_DMA_POL_lostownership_polarity. */
#define BS_HDMI_AHB_DMA_POL_lostownership_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_lostownership_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_lostownership_polarity field. */
#define BR_HDMI_AHB_DMA_POL_lostownership_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.lostownership_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_lostownership_polarity. */
#define BF_HDMI_AHB_DMA_POL_lostownership_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_lostownership_polarity) & BM_HDMI_AHB_DMA_POL_lostownership_polarity)

/*! @brief Set the lostownership_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_lostownership_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_lostownership_polarity) | BF_HDMI_AHB_DMA_POL_lostownership_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field retrysplit_polarity[6] (RW)
 *
 * Retry/split interrupt mask. Active when AHB master receives a RETRY or SPLIT
 * response from slave.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_retrysplit_polarity (6U) /*!< Bit position for HDMI_AHB_DMA_POL_retrysplit_polarity. */
#define BM_HDMI_AHB_DMA_POL_retrysplit_polarity (0x40U) /*!< Bit mask for HDMI_AHB_DMA_POL_retrysplit_polarity. */
#define BS_HDMI_AHB_DMA_POL_retrysplit_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_retrysplit_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_retrysplit_polarity field. */
#define BR_HDMI_AHB_DMA_POL_retrysplit_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.retrysplit_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_retrysplit_polarity. */
#define BF_HDMI_AHB_DMA_POL_retrysplit_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_retrysplit_polarity) & BM_HDMI_AHB_DMA_POL_retrysplit_polarity)

/*! @brief Set the retrysplit_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_retrysplit_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_retrysplit_polarity) | BF_HDMI_AHB_DMA_POL_retrysplit_polarity(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_POL, field done_polarity[7] (RW)
 *
 * DMA end of operation interrupt mask. Active when DMA engine reaches
 * final_addr[15:0] or when stop DMA operation is activated.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_POL_done_polarity (7U) /*!< Bit position for HDMI_AHB_DMA_POL_done_polarity. */
#define BM_HDMI_AHB_DMA_POL_done_polarity (0x80U) /*!< Bit mask for HDMI_AHB_DMA_POL_done_polarity. */
#define BS_HDMI_AHB_DMA_POL_done_polarity (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_POL_done_polarity. */

/*! @brief Read current value of the HDMI_AHB_DMA_POL_done_polarity field. */
#define BR_HDMI_AHB_DMA_POL_done_polarity(x) (HW_HDMI_AHB_DMA_POL(x).B.done_polarity)

/*! @brief Format value for bitfield HDMI_AHB_DMA_POL_done_polarity. */
#define BF_HDMI_AHB_DMA_POL_done_polarity(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_POL_done_polarity) & BM_HDMI_AHB_DMA_POL_done_polarity)

/*! @brief Set the done_polarity field to a new value. */
#define BW_HDMI_AHB_DMA_POL_done_polarity(x, v) (HW_HDMI_AHB_DMA_POL_WR(x, (HW_HDMI_AHB_DMA_POL_RD(x) & ~BM_HDMI_AHB_DMA_POL_done_polarity) | BF_HDMI_AHB_DMA_POL_done_polarity(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_CONF1 - Audio DMA Channel Enable Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_CONF1 - Audio DMA Channel Enable Configuration Register 1 (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3616 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_conf1
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_conf1_bitfields
    {
        uint8_t CH_IN_EN0 : 1;         /*!< [0]  */
        uint8_t CH_IN_EN1 : 1;         /*!< [1]  */
        uint8_t CH_IN_EN2 : 1;         /*!< [2]  */
        uint8_t CH_IN_EN3 : 1;         /*!< [3]  */
        uint8_t CH_IN_EN4 : 1;         /*!< [4]  */
        uint8_t CH_IN_EN5 : 1;         /*!< [5]  */
        uint8_t CH_IN_EN6 : 1;         /*!< [6]  */
        uint8_t CH_IN_EN7 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_ahb_dma_conf1_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_CONF1 register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_CONF1_ADDR(x) ((uintptr_t)(x) + 0x3616U)

#define HW_HDMI_AHB_DMA_CONF1(x) (*(__IO hw_hdmi_ahb_dma_conf1_t *) HW_HDMI_AHB_DMA_CONF1_ADDR(x))
#define HW_HDMI_AHB_DMA_CONF1_RD(x) (HW_HDMI_AHB_DMA_CONF1(x).U)
#define HW_HDMI_AHB_DMA_CONF1_WR(x, v) (HW_HDMI_AHB_DMA_CONF1(x).U = (v))
#define HW_HDMI_AHB_DMA_CONF1_SET(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, HW_HDMI_AHB_DMA_CONF1_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_CONF1_CLR(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, HW_HDMI_AHB_DMA_CONF1_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_CONF1_TOG(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, HW_HDMI_AHB_DMA_CONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_CONF1 bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN0[0] (RW)
 *
 * Channel 0 is always enabled.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN0 (0U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN0. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN0 (0x01U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN0. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN0 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN0. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN0 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN0(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN0)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN0. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN0) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN0)

/*! @brief Set the CH_IN_EN0 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN0(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN0) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN0(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN1[1] (RW)
 *
 * Channel 1 is always enabled.
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN1 (1U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN1. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN1 (0x02U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN1. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN1 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN1. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN1 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN1(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN1)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN1. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN1) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN1)

/*! @brief Set the CH_IN_EN1 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN1(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN1) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN1(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN2[2] (RW)
 *
 * Channel 2 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN2 (2U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN2. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN2 (0x04U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN2. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN2 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN2. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN2 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN2(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN2)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN2. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN2) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN2)

/*! @brief Set the CH_IN_EN2 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN2(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN2) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN2(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN3[3] (RW)
 *
 * Channel 3 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN3 (3U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN3. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN3 (0x08U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN3. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN3 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN3. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN3 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN3(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN3)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN3. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN3) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN3)

/*! @brief Set the CH_IN_EN3 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN3(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN3) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN3(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN4[4] (RW)
 *
 * Channel 4 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN4 (4U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN4. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN4 (0x10U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN4. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN4 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN4. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN4 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN4(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN4)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN4. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN4) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN4)

/*! @brief Set the CH_IN_EN4 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN4(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN4) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN4(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN5[5] (RW)
 *
 * Channel 5 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN5 (5U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN5. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN5 (0x20U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN5. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN5 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN5. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN5 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN5(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN5)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN5. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN5) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN5)

/*! @brief Set the CH_IN_EN5 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN5(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN5) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN5(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN6[6] (RW)
 *
 * Channel 6 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN6 (6U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN6. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN6 (0x40U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN6. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN6 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN6. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN6 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN6(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN6)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN6. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN6) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN6)

/*! @brief Set the CH_IN_EN6 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN6(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN6) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN6(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_CONF1, field CH_IN_EN7[7] (RW)
 *
 * Channel 7 enable bit
 *
 * Values:
 * - 1 - Channel enabled
 * - 0 - Channel disabled
 */
/*@{*/
#define BP_HDMI_AHB_DMA_CONF1_CH_IN_EN7 (7U) /*!< Bit position for HDMI_AHB_DMA_CONF1_CH_IN_EN7. */
#define BM_HDMI_AHB_DMA_CONF1_CH_IN_EN7 (0x80U) /*!< Bit mask for HDMI_AHB_DMA_CONF1_CH_IN_EN7. */
#define BS_HDMI_AHB_DMA_CONF1_CH_IN_EN7 (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_CONF1_CH_IN_EN7. */

/*! @brief Read current value of the HDMI_AHB_DMA_CONF1_CH_IN_EN7 field. */
#define BR_HDMI_AHB_DMA_CONF1_CH_IN_EN7(x) (HW_HDMI_AHB_DMA_CONF1(x).B.CH_IN_EN7)

/*! @brief Format value for bitfield HDMI_AHB_DMA_CONF1_CH_IN_EN7. */
#define BF_HDMI_AHB_DMA_CONF1_CH_IN_EN7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_CONF1_CH_IN_EN7) & BM_HDMI_AHB_DMA_CONF1_CH_IN_EN7)

/*! @brief Set the CH_IN_EN7 field to a new value. */
#define BW_HDMI_AHB_DMA_CONF1_CH_IN_EN7(x, v) (HW_HDMI_AHB_DMA_CONF1_WR(x, (HW_HDMI_AHB_DMA_CONF1_RD(x) & ~BM_HDMI_AHB_DMA_CONF1_CH_IN_EN7) | BF_HDMI_AHB_DMA_CONF1_CH_IN_EN7(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BUFFSTAT - Audio DMA Buffer Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BUFFSTAT - Audio DMA Buffer Interrupt Status Register (RO)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3617 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_buffstat
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_buffstat_bitfields
    {
        uint8_t buff_empty : 1;        /*!< [0]  */
        uint8_t buff_full : 1;         /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ahb_dma_buffstat_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BUFFSTAT register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BUFFSTAT_ADDR(x) ((uintptr_t)(x) + 0x3617U)

#define HW_HDMI_AHB_DMA_BUFFSTAT(x) (*(__I hw_hdmi_ahb_dma_buffstat_t *) HW_HDMI_AHB_DMA_BUFFSTAT_ADDR(x))
#define HW_HDMI_AHB_DMA_BUFFSTAT_RD(x) (HW_HDMI_AHB_DMA_BUFFSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BUFFSTAT bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BUFFSTAT, field buff_empty[0] (RO)
 *
 * Buffer empty flag status
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFSTAT_buff_empty (0U) /*!< Bit position for HDMI_AHB_DMA_BUFFSTAT_buff_empty. */
#define BM_HDMI_AHB_DMA_BUFFSTAT_buff_empty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_BUFFSTAT_buff_empty. */
#define BS_HDMI_AHB_DMA_BUFFSTAT_buff_empty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFSTAT_buff_empty. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFSTAT_buff_empty field. */
#define BR_HDMI_AHB_DMA_BUFFSTAT_buff_empty(x) (HW_HDMI_AHB_DMA_BUFFSTAT(x).B.buff_empty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_BUFFSTAT, field buff_full[1] (RO)
 *
 * Buffer full flag status
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFSTAT_buff_full (1U) /*!< Bit position for HDMI_AHB_DMA_BUFFSTAT_buff_full. */
#define BM_HDMI_AHB_DMA_BUFFSTAT_buff_full (0x02U) /*!< Bit mask for HDMI_AHB_DMA_BUFFSTAT_buff_full. */
#define BS_HDMI_AHB_DMA_BUFFSTAT_buff_full (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFSTAT_buff_full. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFSTAT_buff_full field. */
#define BR_HDMI_AHB_DMA_BUFFSTAT_buff_full(x) (HW_HDMI_AHB_DMA_BUFFSTAT(x).B.buff_full)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BUFFINT - Audio DMA Buffer Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BUFFINT - Audio DMA Buffer Interrupt Register (RO)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x3618 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_ahb_dma_buffint
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_buffint_bitfields
    {
        uint8_t int_buff_empty : 1;    /*!< [0]  */
        uint8_t int_buff_full : 1;     /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ahb_dma_buffint_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BUFFINT register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BUFFINT_ADDR(x) ((uintptr_t)(x) + 0x3618U)

#define HW_HDMI_AHB_DMA_BUFFINT(x) (*(__I hw_hdmi_ahb_dma_buffint_t *) HW_HDMI_AHB_DMA_BUFFINT_ADDR(x))
#define HW_HDMI_AHB_DMA_BUFFINT_RD(x) (HW_HDMI_AHB_DMA_BUFFINT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BUFFINT bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BUFFINT, field int_buff_empty[0] (RO)
 *
 * Buffer empty flag interrupt
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFINT_int_buff_empty (0U) /*!< Bit position for HDMI_AHB_DMA_BUFFINT_int_buff_empty. */
#define BM_HDMI_AHB_DMA_BUFFINT_int_buff_empty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_BUFFINT_int_buff_empty. */
#define BS_HDMI_AHB_DMA_BUFFINT_int_buff_empty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFINT_int_buff_empty. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFINT_int_buff_empty field. */
#define BR_HDMI_AHB_DMA_BUFFINT_int_buff_empty(x) (HW_HDMI_AHB_DMA_BUFFINT(x).B.int_buff_empty)
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_BUFFINT, field int_buff_full[1] (RO)
 *
 * Buffer full flag interrupt
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFINT_int_buff_full (1U) /*!< Bit position for HDMI_AHB_DMA_BUFFINT_int_buff_full. */
#define BM_HDMI_AHB_DMA_BUFFINT_int_buff_full (0x02U) /*!< Bit mask for HDMI_AHB_DMA_BUFFINT_int_buff_full. */
#define BS_HDMI_AHB_DMA_BUFFINT_int_buff_full (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFINT_int_buff_full. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFINT_int_buff_full field. */
#define BR_HDMI_AHB_DMA_BUFFINT_int_buff_full(x) (HW_HDMI_AHB_DMA_BUFFINT(x).B.int_buff_full)
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BUFFMASK - Audio DMA Buffer Mask Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BUFFMASK - Audio DMA Buffer Mask Interrupt Register (RW)
 *
 * Reset value: 0x11U
 *
 * Address Offset: 0x3619 Size: 8 bits Value after Reset: 0x03 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_buffmask
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_buffmask_bitfields
    {
        uint8_t int_buff_empty : 1;    /*!< [0]  */
        uint8_t int_buff_full : 1;     /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ahb_dma_buffmask_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BUFFMASK register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BUFFMASK_ADDR(x) ((uintptr_t)(x) + 0x3619U)

#define HW_HDMI_AHB_DMA_BUFFMASK(x) (*(__IO hw_hdmi_ahb_dma_buffmask_t *) HW_HDMI_AHB_DMA_BUFFMASK_ADDR(x))
#define HW_HDMI_AHB_DMA_BUFFMASK_RD(x) (HW_HDMI_AHB_DMA_BUFFMASK(x).U)
#define HW_HDMI_AHB_DMA_BUFFMASK_WR(x, v) (HW_HDMI_AHB_DMA_BUFFMASK(x).U = (v))
#define HW_HDMI_AHB_DMA_BUFFMASK_SET(x, v) (HW_HDMI_AHB_DMA_BUFFMASK_WR(x, HW_HDMI_AHB_DMA_BUFFMASK_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_BUFFMASK_CLR(x, v) (HW_HDMI_AHB_DMA_BUFFMASK_WR(x, HW_HDMI_AHB_DMA_BUFFMASK_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_BUFFMASK_TOG(x, v) (HW_HDMI_AHB_DMA_BUFFMASK_WR(x, HW_HDMI_AHB_DMA_BUFFMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BUFFMASK bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BUFFMASK, field int_buff_empty[0] (RW)
 *
 * Buffer empty flag mask
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFMASK_int_buff_empty (0U) /*!< Bit position for HDMI_AHB_DMA_BUFFMASK_int_buff_empty. */
#define BM_HDMI_AHB_DMA_BUFFMASK_int_buff_empty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_BUFFMASK_int_buff_empty. */
#define BS_HDMI_AHB_DMA_BUFFMASK_int_buff_empty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFMASK_int_buff_empty. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFMASK_int_buff_empty field. */
#define BR_HDMI_AHB_DMA_BUFFMASK_int_buff_empty(x) (HW_HDMI_AHB_DMA_BUFFMASK(x).B.int_buff_empty)

/*! @brief Format value for bitfield HDMI_AHB_DMA_BUFFMASK_int_buff_empty. */
#define BF_HDMI_AHB_DMA_BUFFMASK_int_buff_empty(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_BUFFMASK_int_buff_empty) & BM_HDMI_AHB_DMA_BUFFMASK_int_buff_empty)

/*! @brief Set the int_buff_empty field to a new value. */
#define BW_HDMI_AHB_DMA_BUFFMASK_int_buff_empty(x, v) (HW_HDMI_AHB_DMA_BUFFMASK_WR(x, (HW_HDMI_AHB_DMA_BUFFMASK_RD(x) & ~BM_HDMI_AHB_DMA_BUFFMASK_int_buff_empty) | BF_HDMI_AHB_DMA_BUFFMASK_int_buff_empty(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_BUFFMASK, field int_buff_full[1] (RW)
 *
 * Buffer full flag mask
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFMASK_int_buff_full (1U) /*!< Bit position for HDMI_AHB_DMA_BUFFMASK_int_buff_full. */
#define BM_HDMI_AHB_DMA_BUFFMASK_int_buff_full (0x02U) /*!< Bit mask for HDMI_AHB_DMA_BUFFMASK_int_buff_full. */
#define BS_HDMI_AHB_DMA_BUFFMASK_int_buff_full (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFMASK_int_buff_full. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFMASK_int_buff_full field. */
#define BR_HDMI_AHB_DMA_BUFFMASK_int_buff_full(x) (HW_HDMI_AHB_DMA_BUFFMASK(x).B.int_buff_full)

/*! @brief Format value for bitfield HDMI_AHB_DMA_BUFFMASK_int_buff_full. */
#define BF_HDMI_AHB_DMA_BUFFMASK_int_buff_full(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_BUFFMASK_int_buff_full) & BM_HDMI_AHB_DMA_BUFFMASK_int_buff_full)

/*! @brief Set the int_buff_full field to a new value. */
#define BW_HDMI_AHB_DMA_BUFFMASK_int_buff_full(x, v) (HW_HDMI_AHB_DMA_BUFFMASK_WR(x, (HW_HDMI_AHB_DMA_BUFFMASK_RD(x) & ~BM_HDMI_AHB_DMA_BUFFMASK_int_buff_full) | BF_HDMI_AHB_DMA_BUFFMASK_int_buff_full(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_AHB_DMA_BUFFPOL - Audio DMA Buffer Polarity Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_AHB_DMA_BUFFPOL - Audio DMA Buffer Polarity Interrupt Register (RW)
 *
 * Reset value: 0x11U
 *
 * Address Offset: 0x361A Size: 8 bits Value after Reset: 0x03 Access: Read/Write
 */
typedef union _hw_hdmi_ahb_dma_buffpol
{
    uint8_t U;
    struct _hw_hdmi_ahb_dma_buffpol_bitfields
    {
        uint8_t int_buff_empty : 1;    /*!< [0]  */
        uint8_t int_buff_full : 1;     /*!< [1]  */
        uint8_t RESERVED0 : 6;         /*!< [7:2]  */
    } B;
} hw_hdmi_ahb_dma_buffpol_t;

/*!
 * @name Constants and macros for entire HDMI_AHB_DMA_BUFFPOL register
 */
/*@{*/
#define HW_HDMI_AHB_DMA_BUFFPOL_ADDR(x) ((uintptr_t)(x) + 0x361AU)

#define HW_HDMI_AHB_DMA_BUFFPOL(x) (*(__IO hw_hdmi_ahb_dma_buffpol_t *) HW_HDMI_AHB_DMA_BUFFPOL_ADDR(x))
#define HW_HDMI_AHB_DMA_BUFFPOL_RD(x) (HW_HDMI_AHB_DMA_BUFFPOL(x).U)
#define HW_HDMI_AHB_DMA_BUFFPOL_WR(x, v) (HW_HDMI_AHB_DMA_BUFFPOL(x).U = (v))
#define HW_HDMI_AHB_DMA_BUFFPOL_SET(x, v) (HW_HDMI_AHB_DMA_BUFFPOL_WR(x, HW_HDMI_AHB_DMA_BUFFPOL_RD(x) |  (v)))
#define HW_HDMI_AHB_DMA_BUFFPOL_CLR(x, v) (HW_HDMI_AHB_DMA_BUFFPOL_WR(x, HW_HDMI_AHB_DMA_BUFFPOL_RD(x) & ~(v)))
#define HW_HDMI_AHB_DMA_BUFFPOL_TOG(x, v) (HW_HDMI_AHB_DMA_BUFFPOL_WR(x, HW_HDMI_AHB_DMA_BUFFPOL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_AHB_DMA_BUFFPOL bitfields
 */

/*!
 * @name Register HDMI_AHB_DMA_BUFFPOL, field int_buff_empty[0] (RW)
 *
 * Buffer empty flag polarity
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFPOL_int_buff_empty (0U) /*!< Bit position for HDMI_AHB_DMA_BUFFPOL_int_buff_empty. */
#define BM_HDMI_AHB_DMA_BUFFPOL_int_buff_empty (0x01U) /*!< Bit mask for HDMI_AHB_DMA_BUFFPOL_int_buff_empty. */
#define BS_HDMI_AHB_DMA_BUFFPOL_int_buff_empty (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFPOL_int_buff_empty. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFPOL_int_buff_empty field. */
#define BR_HDMI_AHB_DMA_BUFFPOL_int_buff_empty(x) (HW_HDMI_AHB_DMA_BUFFPOL(x).B.int_buff_empty)

/*! @brief Format value for bitfield HDMI_AHB_DMA_BUFFPOL_int_buff_empty. */
#define BF_HDMI_AHB_DMA_BUFFPOL_int_buff_empty(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_BUFFPOL_int_buff_empty) & BM_HDMI_AHB_DMA_BUFFPOL_int_buff_empty)

/*! @brief Set the int_buff_empty field to a new value. */
#define BW_HDMI_AHB_DMA_BUFFPOL_int_buff_empty(x, v) (HW_HDMI_AHB_DMA_BUFFPOL_WR(x, (HW_HDMI_AHB_DMA_BUFFPOL_RD(x) & ~BM_HDMI_AHB_DMA_BUFFPOL_int_buff_empty) | BF_HDMI_AHB_DMA_BUFFPOL_int_buff_empty(v)))
/*@}*/

/*!
 * @name Register HDMI_AHB_DMA_BUFFPOL, field int_buff_full[1] (RW)
 *
 * Buffer full flag polarity
 */
/*@{*/
#define BP_HDMI_AHB_DMA_BUFFPOL_int_buff_full (1U) /*!< Bit position for HDMI_AHB_DMA_BUFFPOL_int_buff_full. */
#define BM_HDMI_AHB_DMA_BUFFPOL_int_buff_full (0x02U) /*!< Bit mask for HDMI_AHB_DMA_BUFFPOL_int_buff_full. */
#define BS_HDMI_AHB_DMA_BUFFPOL_int_buff_full (1U) /*!< Bit field size in bits for HDMI_AHB_DMA_BUFFPOL_int_buff_full. */

/*! @brief Read current value of the HDMI_AHB_DMA_BUFFPOL_int_buff_full field. */
#define BR_HDMI_AHB_DMA_BUFFPOL_int_buff_full(x) (HW_HDMI_AHB_DMA_BUFFPOL(x).B.int_buff_full)

/*! @brief Format value for bitfield HDMI_AHB_DMA_BUFFPOL_int_buff_full. */
#define BF_HDMI_AHB_DMA_BUFFPOL_int_buff_full(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_AHB_DMA_BUFFPOL_int_buff_full) & BM_HDMI_AHB_DMA_BUFFPOL_int_buff_full)

/*! @brief Set the int_buff_full field to a new value. */
#define BW_HDMI_AHB_DMA_BUFFPOL_int_buff_full(x, v) (HW_HDMI_AHB_DMA_BUFFPOL_WR(x, (HW_HDMI_AHB_DMA_BUFFPOL_RD(x) & ~BM_HDMI_AHB_DMA_BUFFPOL_int_buff_full) | BF_HDMI_AHB_DMA_BUFFPOL_int_buff_full(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_CLKDIS - Main Controller Synchronous Clock Domain Disable Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_CLKDIS - Main Controller Synchronous Clock Domain Disable Register (RW)
 *
 * Reset value: 0x00U
 *
 * Main controller synchronous disable control per clock domain. Upon release of
 * synchronous disable the corresponding sw reset NRZ request signal, to that
 * domain, is toggled asking to the output for a synchronized active low reset to
 * be generated to that domain. Address Offset: 0x4001 Size: 8 bits Value after
 * Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_mc_clkdis
{
    uint8_t U;
    struct _hw_hdmi_mc_clkdis_bitfields
    {
        uint8_t pixelclk_disable : 1;  /*!< [0]  */
        uint8_t tmdsclk_disable : 1;   /*!< [1]  */
        uint8_t prepclk_disable : 1;   /*!< [2]  */
        uint8_t audclk_disable : 1;    /*!< [3]  */
        uint8_t cscclk_disable : 1;    /*!< [4]  */
        uint8_t cecclk_disable : 1;    /*!< [5]  */
        uint8_t hdcpclk_disable : 1;   /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_mc_clkdis_t;

/*!
 * @name Constants and macros for entire HDMI_MC_CLKDIS register
 */
/*@{*/
#define HW_HDMI_MC_CLKDIS_ADDR(x) ((uintptr_t)(x) + 0x4001U)

#define HW_HDMI_MC_CLKDIS(x)     (*(__IO hw_hdmi_mc_clkdis_t *) HW_HDMI_MC_CLKDIS_ADDR(x))
#define HW_HDMI_MC_CLKDIS_RD(x)  (HW_HDMI_MC_CLKDIS(x).U)
#define HW_HDMI_MC_CLKDIS_WR(x, v) (HW_HDMI_MC_CLKDIS(x).U = (v))
#define HW_HDMI_MC_CLKDIS_SET(x, v) (HW_HDMI_MC_CLKDIS_WR(x, HW_HDMI_MC_CLKDIS_RD(x) |  (v)))
#define HW_HDMI_MC_CLKDIS_CLR(x, v) (HW_HDMI_MC_CLKDIS_WR(x, HW_HDMI_MC_CLKDIS_RD(x) & ~(v)))
#define HW_HDMI_MC_CLKDIS_TOG(x, v) (HW_HDMI_MC_CLKDIS_WR(x, HW_HDMI_MC_CLKDIS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_CLKDIS bitfields
 */

/*!
 * @name Register HDMI_MC_CLKDIS, field pixelclk_disable[0] (RW)
 *
 * Pixel clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_pixelclk_disable (0U) /*!< Bit position for HDMI_MC_CLKDIS_pixelclk_disable. */
#define BM_HDMI_MC_CLKDIS_pixelclk_disable (0x01U) /*!< Bit mask for HDMI_MC_CLKDIS_pixelclk_disable. */
#define BS_HDMI_MC_CLKDIS_pixelclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_pixelclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_pixelclk_disable field. */
#define BR_HDMI_MC_CLKDIS_pixelclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.pixelclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_pixelclk_disable. */
#define BF_HDMI_MC_CLKDIS_pixelclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_pixelclk_disable) & BM_HDMI_MC_CLKDIS_pixelclk_disable)

/*! @brief Set the pixelclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_pixelclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_pixelclk_disable) | BF_HDMI_MC_CLKDIS_pixelclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field tmdsclk_disable[1] (RW)
 *
 * TMDS clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_tmdsclk_disable (1U) /*!< Bit position for HDMI_MC_CLKDIS_tmdsclk_disable. */
#define BM_HDMI_MC_CLKDIS_tmdsclk_disable (0x02U) /*!< Bit mask for HDMI_MC_CLKDIS_tmdsclk_disable. */
#define BS_HDMI_MC_CLKDIS_tmdsclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_tmdsclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_tmdsclk_disable field. */
#define BR_HDMI_MC_CLKDIS_tmdsclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.tmdsclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_tmdsclk_disable. */
#define BF_HDMI_MC_CLKDIS_tmdsclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_tmdsclk_disable) & BM_HDMI_MC_CLKDIS_tmdsclk_disable)

/*! @brief Set the tmdsclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_tmdsclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_tmdsclk_disable) | BF_HDMI_MC_CLKDIS_tmdsclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field prepclk_disable[2] (RW)
 *
 * Pixel Repetition clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_prepclk_disable (2U) /*!< Bit position for HDMI_MC_CLKDIS_prepclk_disable. */
#define BM_HDMI_MC_CLKDIS_prepclk_disable (0x04U) /*!< Bit mask for HDMI_MC_CLKDIS_prepclk_disable. */
#define BS_HDMI_MC_CLKDIS_prepclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_prepclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_prepclk_disable field. */
#define BR_HDMI_MC_CLKDIS_prepclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.prepclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_prepclk_disable. */
#define BF_HDMI_MC_CLKDIS_prepclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_prepclk_disable) & BM_HDMI_MC_CLKDIS_prepclk_disable)

/*! @brief Set the prepclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_prepclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_prepclk_disable) | BF_HDMI_MC_CLKDIS_prepclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field audclk_disable[3] (RW)
 *
 * Audio Sampler clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_audclk_disable (3U) /*!< Bit position for HDMI_MC_CLKDIS_audclk_disable. */
#define BM_HDMI_MC_CLKDIS_audclk_disable (0x08U) /*!< Bit mask for HDMI_MC_CLKDIS_audclk_disable. */
#define BS_HDMI_MC_CLKDIS_audclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_audclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_audclk_disable field. */
#define BR_HDMI_MC_CLKDIS_audclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.audclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_audclk_disable. */
#define BF_HDMI_MC_CLKDIS_audclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_audclk_disable) & BM_HDMI_MC_CLKDIS_audclk_disable)

/*! @brief Set the audclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_audclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_audclk_disable) | BF_HDMI_MC_CLKDIS_audclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field cscclk_disable[4] (RW)
 *
 * Color Space Converter clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_cscclk_disable (4U) /*!< Bit position for HDMI_MC_CLKDIS_cscclk_disable. */
#define BM_HDMI_MC_CLKDIS_cscclk_disable (0x10U) /*!< Bit mask for HDMI_MC_CLKDIS_cscclk_disable. */
#define BS_HDMI_MC_CLKDIS_cscclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_cscclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_cscclk_disable field. */
#define BR_HDMI_MC_CLKDIS_cscclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.cscclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_cscclk_disable. */
#define BF_HDMI_MC_CLKDIS_cscclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_cscclk_disable) & BM_HDMI_MC_CLKDIS_cscclk_disable)

/*! @brief Set the cscclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_cscclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_cscclk_disable) | BF_HDMI_MC_CLKDIS_cscclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field cecclk_disable[5] (RW)
 *
 * CEC Engine clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_cecclk_disable (5U) /*!< Bit position for HDMI_MC_CLKDIS_cecclk_disable. */
#define BM_HDMI_MC_CLKDIS_cecclk_disable (0x20U) /*!< Bit mask for HDMI_MC_CLKDIS_cecclk_disable. */
#define BS_HDMI_MC_CLKDIS_cecclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_cecclk_disable. */

/*! @brief Read current value of the HDMI_MC_CLKDIS_cecclk_disable field. */
#define BR_HDMI_MC_CLKDIS_cecclk_disable(x) (HW_HDMI_MC_CLKDIS(x).B.cecclk_disable)

/*! @brief Format value for bitfield HDMI_MC_CLKDIS_cecclk_disable. */
#define BF_HDMI_MC_CLKDIS_cecclk_disable(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_CLKDIS_cecclk_disable) & BM_HDMI_MC_CLKDIS_cecclk_disable)

/*! @brief Set the cecclk_disable field to a new value. */
#define BW_HDMI_MC_CLKDIS_cecclk_disable(x, v) (HW_HDMI_MC_CLKDIS_WR(x, (HW_HDMI_MC_CLKDIS_RD(x) & ~BM_HDMI_MC_CLKDIS_cecclk_disable) | BF_HDMI_MC_CLKDIS_cecclk_disable(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_CLKDIS, field hdcpclk_disable[6] (RU)
 *
 * Reserved
 */
/*@{*/
#define BP_HDMI_MC_CLKDIS_hdcpclk_disable (6U) /*!< Bit position for HDMI_MC_CLKDIS_hdcpclk_disable. */
#define BM_HDMI_MC_CLKDIS_hdcpclk_disable (0x40U) /*!< Bit mask for HDMI_MC_CLKDIS_hdcpclk_disable. */
#define BS_HDMI_MC_CLKDIS_hdcpclk_disable (1U) /*!< Bit field size in bits for HDMI_MC_CLKDIS_hdcpclk_disable. */
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_SWRSTZREQ - Main Controller Software Reset Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_SWRSTZREQ - Main Controller Software Reset Register (RW)
 *
 * Reset value: 0xFFU
 *
 * Main controller software reset request per clock domain. Writing zero to a
 * bit of this register results in an NRZ signal toggle at sfrclk rate to an output
 * signal that indicates a software reset request. This toggle must be used to
 * generate a synchronized reset to de corresponding domain, with at least 1 clock
 * cycle. Register defaults back to 0xFF. Address Offset: 0x4002 Size: 8 bits
 * Value after Reset: 0xFF Access: Read/Write
 */
typedef union _hw_hdmi_mc_swrstzreq
{
    uint8_t U;
    struct _hw_hdmi_mc_swrstzreq_bitfields
    {
        uint8_t pixelswrst_req : 1;    /*!< [0]  */
        uint8_t tmdsswrst_req : 1;     /*!< [1]  */
        uint8_t prepswrst_req : 1;     /*!< [2]  */
        uint8_t RESERVED0 : 3;         /*!< [5:3]  */
        uint8_t cecswrst_req : 1;      /*!< [6]  */
        uint8_t RESERVED1 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_mc_swrstzreq_t;

/*!
 * @name Constants and macros for entire HDMI_MC_SWRSTZREQ register
 */
/*@{*/
#define HW_HDMI_MC_SWRSTZREQ_ADDR(x) ((uintptr_t)(x) + 0x4002U)

#define HW_HDMI_MC_SWRSTZREQ(x)  (*(__IO hw_hdmi_mc_swrstzreq_t *) HW_HDMI_MC_SWRSTZREQ_ADDR(x))
#define HW_HDMI_MC_SWRSTZREQ_RD(x) (HW_HDMI_MC_SWRSTZREQ(x).U)
#define HW_HDMI_MC_SWRSTZREQ_WR(x, v) (HW_HDMI_MC_SWRSTZREQ(x).U = (v))
#define HW_HDMI_MC_SWRSTZREQ_SET(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, HW_HDMI_MC_SWRSTZREQ_RD(x) |  (v)))
#define HW_HDMI_MC_SWRSTZREQ_CLR(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, HW_HDMI_MC_SWRSTZREQ_RD(x) & ~(v)))
#define HW_HDMI_MC_SWRSTZREQ_TOG(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, HW_HDMI_MC_SWRSTZREQ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_SWRSTZREQ bitfields
 */

/*!
 * @name Register HDMI_MC_SWRSTZREQ, field pixelswrst_req[0] (RW)
 *
 * Pixel software reset request. Defaults back to 1b after reset request.
 */
/*@{*/
#define BP_HDMI_MC_SWRSTZREQ_pixelswrst_req (0U) /*!< Bit position for HDMI_MC_SWRSTZREQ_pixelswrst_req. */
#define BM_HDMI_MC_SWRSTZREQ_pixelswrst_req (0x01U) /*!< Bit mask for HDMI_MC_SWRSTZREQ_pixelswrst_req. */
#define BS_HDMI_MC_SWRSTZREQ_pixelswrst_req (1U) /*!< Bit field size in bits for HDMI_MC_SWRSTZREQ_pixelswrst_req. */

/*! @brief Read current value of the HDMI_MC_SWRSTZREQ_pixelswrst_req field. */
#define BR_HDMI_MC_SWRSTZREQ_pixelswrst_req(x) (HW_HDMI_MC_SWRSTZREQ(x).B.pixelswrst_req)

/*! @brief Format value for bitfield HDMI_MC_SWRSTZREQ_pixelswrst_req. */
#define BF_HDMI_MC_SWRSTZREQ_pixelswrst_req(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_SWRSTZREQ_pixelswrst_req) & BM_HDMI_MC_SWRSTZREQ_pixelswrst_req)

/*! @brief Set the pixelswrst_req field to a new value. */
#define BW_HDMI_MC_SWRSTZREQ_pixelswrst_req(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, (HW_HDMI_MC_SWRSTZREQ_RD(x) & ~BM_HDMI_MC_SWRSTZREQ_pixelswrst_req) | BF_HDMI_MC_SWRSTZREQ_pixelswrst_req(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_SWRSTZREQ, field tmdsswrst_req[1] (RW)
 *
 * TMDS software reset request. Defaults back to 1b after reset request.
 */
/*@{*/
#define BP_HDMI_MC_SWRSTZREQ_tmdsswrst_req (1U) /*!< Bit position for HDMI_MC_SWRSTZREQ_tmdsswrst_req. */
#define BM_HDMI_MC_SWRSTZREQ_tmdsswrst_req (0x02U) /*!< Bit mask for HDMI_MC_SWRSTZREQ_tmdsswrst_req. */
#define BS_HDMI_MC_SWRSTZREQ_tmdsswrst_req (1U) /*!< Bit field size in bits for HDMI_MC_SWRSTZREQ_tmdsswrst_req. */

/*! @brief Read current value of the HDMI_MC_SWRSTZREQ_tmdsswrst_req field. */
#define BR_HDMI_MC_SWRSTZREQ_tmdsswrst_req(x) (HW_HDMI_MC_SWRSTZREQ(x).B.tmdsswrst_req)

/*! @brief Format value for bitfield HDMI_MC_SWRSTZREQ_tmdsswrst_req. */
#define BF_HDMI_MC_SWRSTZREQ_tmdsswrst_req(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_SWRSTZREQ_tmdsswrst_req) & BM_HDMI_MC_SWRSTZREQ_tmdsswrst_req)

/*! @brief Set the tmdsswrst_req field to a new value. */
#define BW_HDMI_MC_SWRSTZREQ_tmdsswrst_req(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, (HW_HDMI_MC_SWRSTZREQ_RD(x) & ~BM_HDMI_MC_SWRSTZREQ_tmdsswrst_req) | BF_HDMI_MC_SWRSTZREQ_tmdsswrst_req(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_SWRSTZREQ, field prepswrst_req[2] (RW)
 *
 * Pixel Repetition clock synchronous disable signal.
 */
/*@{*/
#define BP_HDMI_MC_SWRSTZREQ_prepswrst_req (2U) /*!< Bit position for HDMI_MC_SWRSTZREQ_prepswrst_req. */
#define BM_HDMI_MC_SWRSTZREQ_prepswrst_req (0x04U) /*!< Bit mask for HDMI_MC_SWRSTZREQ_prepswrst_req. */
#define BS_HDMI_MC_SWRSTZREQ_prepswrst_req (1U) /*!< Bit field size in bits for HDMI_MC_SWRSTZREQ_prepswrst_req. */

/*! @brief Read current value of the HDMI_MC_SWRSTZREQ_prepswrst_req field. */
#define BR_HDMI_MC_SWRSTZREQ_prepswrst_req(x) (HW_HDMI_MC_SWRSTZREQ(x).B.prepswrst_req)

/*! @brief Format value for bitfield HDMI_MC_SWRSTZREQ_prepswrst_req. */
#define BF_HDMI_MC_SWRSTZREQ_prepswrst_req(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_SWRSTZREQ_prepswrst_req) & BM_HDMI_MC_SWRSTZREQ_prepswrst_req)

/*! @brief Set the prepswrst_req field to a new value. */
#define BW_HDMI_MC_SWRSTZREQ_prepswrst_req(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, (HW_HDMI_MC_SWRSTZREQ_RD(x) & ~BM_HDMI_MC_SWRSTZREQ_prepswrst_req) | BF_HDMI_MC_SWRSTZREQ_prepswrst_req(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_SWRSTZREQ, field cecswrst_req[6] (RW)
 *
 * CEC software reset request. Defaults back to 1b after reset request.
 */
/*@{*/
#define BP_HDMI_MC_SWRSTZREQ_cecswrst_req (6U) /*!< Bit position for HDMI_MC_SWRSTZREQ_cecswrst_req. */
#define BM_HDMI_MC_SWRSTZREQ_cecswrst_req (0x40U) /*!< Bit mask for HDMI_MC_SWRSTZREQ_cecswrst_req. */
#define BS_HDMI_MC_SWRSTZREQ_cecswrst_req (1U) /*!< Bit field size in bits for HDMI_MC_SWRSTZREQ_cecswrst_req. */

/*! @brief Read current value of the HDMI_MC_SWRSTZREQ_cecswrst_req field. */
#define BR_HDMI_MC_SWRSTZREQ_cecswrst_req(x) (HW_HDMI_MC_SWRSTZREQ(x).B.cecswrst_req)

/*! @brief Format value for bitfield HDMI_MC_SWRSTZREQ_cecswrst_req. */
#define BF_HDMI_MC_SWRSTZREQ_cecswrst_req(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_SWRSTZREQ_cecswrst_req) & BM_HDMI_MC_SWRSTZREQ_cecswrst_req)

/*! @brief Set the cecswrst_req field to a new value. */
#define BW_HDMI_MC_SWRSTZREQ_cecswrst_req(x, v) (HW_HDMI_MC_SWRSTZREQ_WR(x, (HW_HDMI_MC_SWRSTZREQ_RD(x) & ~BM_HDMI_MC_SWRSTZREQ_cecswrst_req) | BF_HDMI_MC_SWRSTZREQ_cecswrst_req(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_FLOWCTRL - Main Controller Feed Through Control Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_FLOWCTRL - Main Controller Feed Through Control Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x4004 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_mc_flowctrl
{
    uint8_t U;
    struct _hw_hdmi_mc_flowctrl_bitfields
    {
        uint8_t Feed_through_off : 1;  /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_mc_flowctrl_t;

/*!
 * @name Constants and macros for entire HDMI_MC_FLOWCTRL register
 */
/*@{*/
#define HW_HDMI_MC_FLOWCTRL_ADDR(x) ((uintptr_t)(x) + 0x4004U)

#define HW_HDMI_MC_FLOWCTRL(x)   (*(__IO hw_hdmi_mc_flowctrl_t *) HW_HDMI_MC_FLOWCTRL_ADDR(x))
#define HW_HDMI_MC_FLOWCTRL_RD(x) (HW_HDMI_MC_FLOWCTRL(x).U)
#define HW_HDMI_MC_FLOWCTRL_WR(x, v) (HW_HDMI_MC_FLOWCTRL(x).U = (v))
#define HW_HDMI_MC_FLOWCTRL_SET(x, v) (HW_HDMI_MC_FLOWCTRL_WR(x, HW_HDMI_MC_FLOWCTRL_RD(x) |  (v)))
#define HW_HDMI_MC_FLOWCTRL_CLR(x, v) (HW_HDMI_MC_FLOWCTRL_WR(x, HW_HDMI_MC_FLOWCTRL_RD(x) & ~(v)))
#define HW_HDMI_MC_FLOWCTRL_TOG(x, v) (HW_HDMI_MC_FLOWCTRL_WR(x, HW_HDMI_MC_FLOWCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_FLOWCTRL bitfields
 */

/*!
 * @name Register HDMI_MC_FLOWCTRL, field Feed_through_off[0] (RW)
 *
 * Video path Feed Through enable bit:
 *
 * Values:
 * - 1 - Color Space Converter is in the video data path.
 * - 0 - Color Space Converter is bypassed (not in the video data path).
 */
/*@{*/
#define BP_HDMI_MC_FLOWCTRL_Feed_through_off (0U) /*!< Bit position for HDMI_MC_FLOWCTRL_Feed_through_off. */
#define BM_HDMI_MC_FLOWCTRL_Feed_through_off (0x01U) /*!< Bit mask for HDMI_MC_FLOWCTRL_Feed_through_off. */
#define BS_HDMI_MC_FLOWCTRL_Feed_through_off (1U) /*!< Bit field size in bits for HDMI_MC_FLOWCTRL_Feed_through_off. */

/*! @brief Read current value of the HDMI_MC_FLOWCTRL_Feed_through_off field. */
#define BR_HDMI_MC_FLOWCTRL_Feed_through_off(x) (HW_HDMI_MC_FLOWCTRL(x).B.Feed_through_off)

/*! @brief Format value for bitfield HDMI_MC_FLOWCTRL_Feed_through_off. */
#define BF_HDMI_MC_FLOWCTRL_Feed_through_off(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_FLOWCTRL_Feed_through_off) & BM_HDMI_MC_FLOWCTRL_Feed_through_off)

/*! @brief Set the Feed_through_off field to a new value. */
#define BW_HDMI_MC_FLOWCTRL_Feed_through_off(x, v) (HW_HDMI_MC_FLOWCTRL_WR(x, (HW_HDMI_MC_FLOWCTRL_RD(x) & ~BM_HDMI_MC_FLOWCTRL_Feed_through_off) | BF_HDMI_MC_FLOWCTRL_Feed_through_off(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_PHYRSTZ - Main Controller PHY Reset Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_PHYRSTZ - Main Controller PHY Reset Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x4005 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_mc_phyrstz
{
    uint8_t U;
    struct _hw_hdmi_mc_phyrstz_bitfields
    {
        uint8_t phyrstz : 1;           /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_mc_phyrstz_t;

/*!
 * @name Constants and macros for entire HDMI_MC_PHYRSTZ register
 */
/*@{*/
#define HW_HDMI_MC_PHYRSTZ_ADDR(x) ((uintptr_t)(x) + 0x4005U)

#define HW_HDMI_MC_PHYRSTZ(x)    (*(__IO hw_hdmi_mc_phyrstz_t *) HW_HDMI_MC_PHYRSTZ_ADDR(x))
#define HW_HDMI_MC_PHYRSTZ_RD(x) (HW_HDMI_MC_PHYRSTZ(x).U)
#define HW_HDMI_MC_PHYRSTZ_WR(x, v) (HW_HDMI_MC_PHYRSTZ(x).U = (v))
#define HW_HDMI_MC_PHYRSTZ_SET(x, v) (HW_HDMI_MC_PHYRSTZ_WR(x, HW_HDMI_MC_PHYRSTZ_RD(x) |  (v)))
#define HW_HDMI_MC_PHYRSTZ_CLR(x, v) (HW_HDMI_MC_PHYRSTZ_WR(x, HW_HDMI_MC_PHYRSTZ_RD(x) & ~(v)))
#define HW_HDMI_MC_PHYRSTZ_TOG(x, v) (HW_HDMI_MC_PHYRSTZ_WR(x, HW_HDMI_MC_PHYRSTZ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_PHYRSTZ bitfields
 */

/*!
 * @name Register HDMI_MC_PHYRSTZ, field phyrstz[0] (RW)
 *
 * HDMI Source PHY active low reset control.
 */
/*@{*/
#define BP_HDMI_MC_PHYRSTZ_phyrstz (0U)    /*!< Bit position for HDMI_MC_PHYRSTZ_phyrstz. */
#define BM_HDMI_MC_PHYRSTZ_phyrstz (0x01U) /*!< Bit mask for HDMI_MC_PHYRSTZ_phyrstz. */
#define BS_HDMI_MC_PHYRSTZ_phyrstz (1U)    /*!< Bit field size in bits for HDMI_MC_PHYRSTZ_phyrstz. */

/*! @brief Read current value of the HDMI_MC_PHYRSTZ_phyrstz field. */
#define BR_HDMI_MC_PHYRSTZ_phyrstz(x) (HW_HDMI_MC_PHYRSTZ(x).B.phyrstz)

/*! @brief Format value for bitfield HDMI_MC_PHYRSTZ_phyrstz. */
#define BF_HDMI_MC_PHYRSTZ_phyrstz(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_PHYRSTZ_phyrstz) & BM_HDMI_MC_PHYRSTZ_phyrstz)

/*! @brief Set the phyrstz field to a new value. */
#define BW_HDMI_MC_PHYRSTZ_phyrstz(x, v) (HW_HDMI_MC_PHYRSTZ_WR(x, (HW_HDMI_MC_PHYRSTZ_RD(x) & ~BM_HDMI_MC_PHYRSTZ_phyrstz) | BF_HDMI_MC_PHYRSTZ_phyrstz(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_LOCKONCLOCK - Main Controller Clock Present Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_LOCKONCLOCK - Main Controller Clock Present Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x4006 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Clear on Write
 */
typedef union _hw_hdmi_mc_lockonclock
{
    uint8_t U;
    struct _hw_hdmi_mc_lockonclock_bitfields
    {
        uint8_t cecclk : 1;            /*!< [0]  */
        uint8_t RESERVED0 : 3;         /*!< [3:1]  */
        uint8_t prepclk : 1;           /*!< [4]  */
        uint8_t tclktclk : 1;          /*!< [5]  */
        uint8_t pclk : 1;              /*!< [6]  */
        uint8_t RESERVED1 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_mc_lockonclock_t;

/*!
 * @name Constants and macros for entire HDMI_MC_LOCKONCLOCK register
 */
/*@{*/
#define HW_HDMI_MC_LOCKONCLOCK_ADDR(x) ((uintptr_t)(x) + 0x4006U)

#define HW_HDMI_MC_LOCKONCLOCK(x) (*(__IO hw_hdmi_mc_lockonclock_t *) HW_HDMI_MC_LOCKONCLOCK_ADDR(x))
#define HW_HDMI_MC_LOCKONCLOCK_RD(x) (HW_HDMI_MC_LOCKONCLOCK(x).U)
#define HW_HDMI_MC_LOCKONCLOCK_WR(x, v) (HW_HDMI_MC_LOCKONCLOCK(x).U = (v))
#define HW_HDMI_MC_LOCKONCLOCK_SET(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, HW_HDMI_MC_LOCKONCLOCK_RD(x) |  (v)))
#define HW_HDMI_MC_LOCKONCLOCK_CLR(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, HW_HDMI_MC_LOCKONCLOCK_RD(x) & ~(v)))
#define HW_HDMI_MC_LOCKONCLOCK_TOG(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, HW_HDMI_MC_LOCKONCLOCK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_LOCKONCLOCK bitfields
 */

/*!
 * @name Register HDMI_MC_LOCKONCLOCK, field cecclk[0] (W1C)
 *
 * CEC clock status. Indicates that the clock is present in the system. Cleared
 * by WR 1 to this position.
 */
/*@{*/
#define BP_HDMI_MC_LOCKONCLOCK_cecclk (0U) /*!< Bit position for HDMI_MC_LOCKONCLOCK_cecclk. */
#define BM_HDMI_MC_LOCKONCLOCK_cecclk (0x01U) /*!< Bit mask for HDMI_MC_LOCKONCLOCK_cecclk. */
#define BS_HDMI_MC_LOCKONCLOCK_cecclk (1U) /*!< Bit field size in bits for HDMI_MC_LOCKONCLOCK_cecclk. */

/*! @brief Read current value of the HDMI_MC_LOCKONCLOCK_cecclk field. */
#define BR_HDMI_MC_LOCKONCLOCK_cecclk(x) (HW_HDMI_MC_LOCKONCLOCK(x).B.cecclk)

/*! @brief Format value for bitfield HDMI_MC_LOCKONCLOCK_cecclk. */
#define BF_HDMI_MC_LOCKONCLOCK_cecclk(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_LOCKONCLOCK_cecclk) & BM_HDMI_MC_LOCKONCLOCK_cecclk)

/*! @brief Set the cecclk field to a new value. */
#define BW_HDMI_MC_LOCKONCLOCK_cecclk(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, (HW_HDMI_MC_LOCKONCLOCK_RD(x) & ~(BM_HDMI_MC_LOCKONCLOCK_cecclk | BM_HDMI_MC_LOCKONCLOCK_prepclk | BM_HDMI_MC_LOCKONCLOCK_tclktclk | BM_HDMI_MC_LOCKONCLOCK_pclk)) | BF_HDMI_MC_LOCKONCLOCK_cecclk(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_LOCKONCLOCK, field prepclk[4] (W1C)
 *
 * Pixel repetition clock status. Indicates that the clock is present in the
 * system. Cleared by WR 1 to this position.
 */
/*@{*/
#define BP_HDMI_MC_LOCKONCLOCK_prepclk (4U) /*!< Bit position for HDMI_MC_LOCKONCLOCK_prepclk. */
#define BM_HDMI_MC_LOCKONCLOCK_prepclk (0x10U) /*!< Bit mask for HDMI_MC_LOCKONCLOCK_prepclk. */
#define BS_HDMI_MC_LOCKONCLOCK_prepclk (1U) /*!< Bit field size in bits for HDMI_MC_LOCKONCLOCK_prepclk. */

/*! @brief Read current value of the HDMI_MC_LOCKONCLOCK_prepclk field. */
#define BR_HDMI_MC_LOCKONCLOCK_prepclk(x) (HW_HDMI_MC_LOCKONCLOCK(x).B.prepclk)

/*! @brief Format value for bitfield HDMI_MC_LOCKONCLOCK_prepclk. */
#define BF_HDMI_MC_LOCKONCLOCK_prepclk(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_LOCKONCLOCK_prepclk) & BM_HDMI_MC_LOCKONCLOCK_prepclk)

/*! @brief Set the prepclk field to a new value. */
#define BW_HDMI_MC_LOCKONCLOCK_prepclk(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, (HW_HDMI_MC_LOCKONCLOCK_RD(x) & ~(BM_HDMI_MC_LOCKONCLOCK_prepclk | BM_HDMI_MC_LOCKONCLOCK_cecclk | BM_HDMI_MC_LOCKONCLOCK_tclktclk | BM_HDMI_MC_LOCKONCLOCK_pclk)) | BF_HDMI_MC_LOCKONCLOCK_prepclk(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_LOCKONCLOCK, field tclktclk[5] (W1C)
 *
 * TMDS clock status. Indicates that the clock is present in the system. Cleared
 * by WR 1 to this position
 */
/*@{*/
#define BP_HDMI_MC_LOCKONCLOCK_tclktclk (5U) /*!< Bit position for HDMI_MC_LOCKONCLOCK_tclktclk. */
#define BM_HDMI_MC_LOCKONCLOCK_tclktclk (0x20U) /*!< Bit mask for HDMI_MC_LOCKONCLOCK_tclktclk. */
#define BS_HDMI_MC_LOCKONCLOCK_tclktclk (1U) /*!< Bit field size in bits for HDMI_MC_LOCKONCLOCK_tclktclk. */

/*! @brief Read current value of the HDMI_MC_LOCKONCLOCK_tclktclk field. */
#define BR_HDMI_MC_LOCKONCLOCK_tclktclk(x) (HW_HDMI_MC_LOCKONCLOCK(x).B.tclktclk)

/*! @brief Format value for bitfield HDMI_MC_LOCKONCLOCK_tclktclk. */
#define BF_HDMI_MC_LOCKONCLOCK_tclktclk(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_LOCKONCLOCK_tclktclk) & BM_HDMI_MC_LOCKONCLOCK_tclktclk)

/*! @brief Set the tclktclk field to a new value. */
#define BW_HDMI_MC_LOCKONCLOCK_tclktclk(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, (HW_HDMI_MC_LOCKONCLOCK_RD(x) & ~(BM_HDMI_MC_LOCKONCLOCK_tclktclk | BM_HDMI_MC_LOCKONCLOCK_cecclk | BM_HDMI_MC_LOCKONCLOCK_prepclk | BM_HDMI_MC_LOCKONCLOCK_pclk)) | BF_HDMI_MC_LOCKONCLOCK_tclktclk(v)))
/*@}*/

/*!
 * @name Register HDMI_MC_LOCKONCLOCK, field pclk[6] (W1C)
 *
 * Pixel clock status. Indicates that the clock is present in the system.
 * Cleared by WR 1 to this position.
 */
/*@{*/
#define BP_HDMI_MC_LOCKONCLOCK_pclk (6U)   /*!< Bit position for HDMI_MC_LOCKONCLOCK_pclk. */
#define BM_HDMI_MC_LOCKONCLOCK_pclk (0x40U) /*!< Bit mask for HDMI_MC_LOCKONCLOCK_pclk. */
#define BS_HDMI_MC_LOCKONCLOCK_pclk (1U)   /*!< Bit field size in bits for HDMI_MC_LOCKONCLOCK_pclk. */

/*! @brief Read current value of the HDMI_MC_LOCKONCLOCK_pclk field. */
#define BR_HDMI_MC_LOCKONCLOCK_pclk(x) (HW_HDMI_MC_LOCKONCLOCK(x).B.pclk)

/*! @brief Format value for bitfield HDMI_MC_LOCKONCLOCK_pclk. */
#define BF_HDMI_MC_LOCKONCLOCK_pclk(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_LOCKONCLOCK_pclk) & BM_HDMI_MC_LOCKONCLOCK_pclk)

/*! @brief Set the pclk field to a new value. */
#define BW_HDMI_MC_LOCKONCLOCK_pclk(x, v) (HW_HDMI_MC_LOCKONCLOCK_WR(x, (HW_HDMI_MC_LOCKONCLOCK_RD(x) & ~(BM_HDMI_MC_LOCKONCLOCK_pclk | BM_HDMI_MC_LOCKONCLOCK_cecclk | BM_HDMI_MC_LOCKONCLOCK_prepclk | BM_HDMI_MC_LOCKONCLOCK_tclktclk)) | BF_HDMI_MC_LOCKONCLOCK_pclk(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_MC_HEACPHY_RST - Main Controller HEAC PHY Reset Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_MC_HEACPHY_RST - Main Controller HEAC PHY Reset Register (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x4007 Size: 8 bits Value after Reset: N/A Access: Read/Write
 */
typedef union _hw_hdmi_mc_heacphy_rst
{
    uint8_t U;
    struct _hw_hdmi_mc_heacphy_rst_bitfields
    {
        uint8_t heacphyrst : 1;        /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_mc_heacphy_rst_t;

/*!
 * @name Constants and macros for entire HDMI_MC_HEACPHY_RST register
 */
/*@{*/
#define HW_HDMI_MC_HEACPHY_RST_ADDR(x) ((uintptr_t)(x) + 0x4007U)

#define HW_HDMI_MC_HEACPHY_RST(x) (*(__IO hw_hdmi_mc_heacphy_rst_t *) HW_HDMI_MC_HEACPHY_RST_ADDR(x))
#define HW_HDMI_MC_HEACPHY_RST_RD(x) (HW_HDMI_MC_HEACPHY_RST(x).U)
#define HW_HDMI_MC_HEACPHY_RST_WR(x, v) (HW_HDMI_MC_HEACPHY_RST(x).U = (v))
#define HW_HDMI_MC_HEACPHY_RST_SET(x, v) (HW_HDMI_MC_HEACPHY_RST_WR(x, HW_HDMI_MC_HEACPHY_RST_RD(x) |  (v)))
#define HW_HDMI_MC_HEACPHY_RST_CLR(x, v) (HW_HDMI_MC_HEACPHY_RST_WR(x, HW_HDMI_MC_HEACPHY_RST_RD(x) & ~(v)))
#define HW_HDMI_MC_HEACPHY_RST_TOG(x, v) (HW_HDMI_MC_HEACPHY_RST_WR(x, HW_HDMI_MC_HEACPHY_RST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_MC_HEACPHY_RST bitfields
 */

/*!
 * @name Register HDMI_MC_HEACPHY_RST, field heacphyrst[0] (RW)
 *
 * HEAC PHY reset (active high)
 */
/*@{*/
#define BP_HDMI_MC_HEACPHY_RST_heacphyrst (0U) /*!< Bit position for HDMI_MC_HEACPHY_RST_heacphyrst. */
#define BM_HDMI_MC_HEACPHY_RST_heacphyrst (0x01U) /*!< Bit mask for HDMI_MC_HEACPHY_RST_heacphyrst. */
#define BS_HDMI_MC_HEACPHY_RST_heacphyrst (1U) /*!< Bit field size in bits for HDMI_MC_HEACPHY_RST_heacphyrst. */

/*! @brief Read current value of the HDMI_MC_HEACPHY_RST_heacphyrst field. */
#define BR_HDMI_MC_HEACPHY_RST_heacphyrst(x) (HW_HDMI_MC_HEACPHY_RST(x).B.heacphyrst)

/*! @brief Format value for bitfield HDMI_MC_HEACPHY_RST_heacphyrst. */
#define BF_HDMI_MC_HEACPHY_RST_heacphyrst(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_MC_HEACPHY_RST_heacphyrst) & BM_HDMI_MC_HEACPHY_RST_heacphyrst)

/*! @brief Set the heacphyrst field to a new value. */
#define BW_HDMI_MC_HEACPHY_RST_heacphyrst(x, v) (HW_HDMI_MC_HEACPHY_RST_WR(x, (HW_HDMI_MC_HEACPHY_RST_RD(x) & ~BM_HDMI_MC_HEACPHY_RST_heacphyrst) | BF_HDMI_MC_HEACPHY_RST_heacphyrst(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_CFG - Color Space Converter Interpolation and Decimation Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_CFG - Color Space Converter Interpolation and Decimation Configuration Register (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion configuration register. Configures YCC422 to YCC444
 * interpolation mode and YCC444 to YCC422 decimation mode. Address Offset: 0x4100
 * Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_cfg
{
    uint8_t U;
    struct _hw_hdmi_csc_cfg_bitfields
    {
        uint8_t DECMODE : 2;           /*!< [1:0]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t INTMODE : 2;           /*!< [5:4]  */
        uint8_t RESERVED1 : 2;         /*!< [7:6]  */
    } B;
} hw_hdmi_csc_cfg_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_CFG register
 */
/*@{*/
#define HW_HDMI_CSC_CFG_ADDR(x)  ((uintptr_t)(x) + 0x4100U)

#define HW_HDMI_CSC_CFG(x)       (*(__IO hw_hdmi_csc_cfg_t *) HW_HDMI_CSC_CFG_ADDR(x))
#define HW_HDMI_CSC_CFG_RD(x)    (HW_HDMI_CSC_CFG(x).U)
#define HW_HDMI_CSC_CFG_WR(x, v) (HW_HDMI_CSC_CFG(x).U = (v))
#define HW_HDMI_CSC_CFG_SET(x, v) (HW_HDMI_CSC_CFG_WR(x, HW_HDMI_CSC_CFG_RD(x) |  (v)))
#define HW_HDMI_CSC_CFG_CLR(x, v) (HW_HDMI_CSC_CFG_WR(x, HW_HDMI_CSC_CFG_RD(x) & ~(v)))
#define HW_HDMI_CSC_CFG_TOG(x, v) (HW_HDMI_CSC_CFG_WR(x, HW_HDMI_CSC_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_CFG bitfields
 */

/*!
 * @name Register HDMI_CSC_CFG, field DECMODE[1:0] (RW)
 *
 * Chroma decimation configuration: DECMODE[1:0] Chroma decimation 00 decimation
 * disabled 01 H d? z?=1 10 H d? z?=1/ 4?1/ 2 z?1?1/4 z?2 11 H d? z?Þ211=?5?12
 * z?2?22 z?4?39 z?6?65 z?8?109 z?10?204 z?12?648 z?14?1024 z?15?648 z?16?204
 * z?18?109 z?20?65 z?22?39 z?24?22 z?26?12 z?28?5 z?30 00 decimation disabled 01 H
 * d (z) = 1 10 H d (Z)=1/4 + 1/2z -1 1+1/4z -2 11H d (z)x2 11 =-5+12z -2 +22z -4
 * +39z -8 +109z -10 -204z -12 +648z -14 +1024z -15 +648z -16 -204z -18 +109z
 * -20 -65z -22 +39z -24 -22z -26 +12z -28 -5z -30
 */
/*@{*/
#define BP_HDMI_CSC_CFG_DECMODE (0U)       /*!< Bit position for HDMI_CSC_CFG_DECMODE. */
#define BM_HDMI_CSC_CFG_DECMODE (0x03U)    /*!< Bit mask for HDMI_CSC_CFG_DECMODE. */
#define BS_HDMI_CSC_CFG_DECMODE (2U)       /*!< Bit field size in bits for HDMI_CSC_CFG_DECMODE. */

/*! @brief Read current value of the HDMI_CSC_CFG_DECMODE field. */
#define BR_HDMI_CSC_CFG_DECMODE(x) (HW_HDMI_CSC_CFG(x).B.DECMODE)

/*! @brief Format value for bitfield HDMI_CSC_CFG_DECMODE. */
#define BF_HDMI_CSC_CFG_DECMODE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_CFG_DECMODE) & BM_HDMI_CSC_CFG_DECMODE)

/*! @brief Set the DECMODE field to a new value. */
#define BW_HDMI_CSC_CFG_DECMODE(x, v) (HW_HDMI_CSC_CFG_WR(x, (HW_HDMI_CSC_CFG_RD(x) & ~BM_HDMI_CSC_CFG_DECMODE) | BF_HDMI_CSC_CFG_DECMODE(v)))
/*@}*/

/*!
 * @name Register HDMI_CSC_CFG, field INTMODE[5:4] (RW)
 *
 * Chroma interpolation configuration: 00 interpolation disabled 01 H u (z) = 1
 * + z -1 10 H u (z)=1/2 + Z -1 +1/2 z -2 11 interpolation disabled.
 */
/*@{*/
#define BP_HDMI_CSC_CFG_INTMODE (4U)       /*!< Bit position for HDMI_CSC_CFG_INTMODE. */
#define BM_HDMI_CSC_CFG_INTMODE (0x30U)    /*!< Bit mask for HDMI_CSC_CFG_INTMODE. */
#define BS_HDMI_CSC_CFG_INTMODE (2U)       /*!< Bit field size in bits for HDMI_CSC_CFG_INTMODE. */

/*! @brief Read current value of the HDMI_CSC_CFG_INTMODE field. */
#define BR_HDMI_CSC_CFG_INTMODE(x) (HW_HDMI_CSC_CFG(x).B.INTMODE)

/*! @brief Format value for bitfield HDMI_CSC_CFG_INTMODE. */
#define BF_HDMI_CSC_CFG_INTMODE(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_CFG_INTMODE) & BM_HDMI_CSC_CFG_INTMODE)

/*! @brief Set the INTMODE field to a new value. */
#define BW_HDMI_CSC_CFG_INTMODE(x, v) (HW_HDMI_CSC_CFG_WR(x, (HW_HDMI_CSC_CFG_RD(x) & ~BM_HDMI_CSC_CFG_INTMODE) | BF_HDMI_CSC_CFG_INTMODE(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_SCALE - Color Space Converter Scale and Deep Color Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_SCALE - Color Space Converter Scale and Deep Color Configuration Register (RW)
 *
 * Reset value: 0x01U
 *
 * Address Offset: 0x4101 Size: 8 bits Value after Reset: 0x01 Access:
 * Read/Write CSC Conversion Functions
 */
typedef union _hw_hdmi_csc_scale
{
    uint8_t U;
    struct _hw_hdmi_csc_scale_bitfields
    {
        uint8_t RESERVED0 : 4;         /*!< [3:0]  */
        uint8_t csc_colorde_pth : 4;   /*!< [7:4]  */
    } B;
} hw_hdmi_csc_scale_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_SCALE register
 */
/*@{*/
#define HW_HDMI_CSC_SCALE_ADDR(x) ((uintptr_t)(x) + 0x4101U)

#define HW_HDMI_CSC_SCALE(x)     (*(__IO hw_hdmi_csc_scale_t *) HW_HDMI_CSC_SCALE_ADDR(x))
#define HW_HDMI_CSC_SCALE_RD(x)  (HW_HDMI_CSC_SCALE(x).U)
#define HW_HDMI_CSC_SCALE_WR(x, v) (HW_HDMI_CSC_SCALE(x).U = (v))
#define HW_HDMI_CSC_SCALE_SET(x, v) (HW_HDMI_CSC_SCALE_WR(x, HW_HDMI_CSC_SCALE_RD(x) |  (v)))
#define HW_HDMI_CSC_SCALE_CLR(x, v) (HW_HDMI_CSC_SCALE_WR(x, HW_HDMI_CSC_SCALE_RD(x) & ~(v)))
#define HW_HDMI_CSC_SCALE_TOG(x, v) (HW_HDMI_CSC_SCALE_WR(x, HW_HDMI_CSC_SCALE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_SCALE bitfields
 */

/*!
 * @name Register HDMI_CSC_SCALE, field csc_colorde_pth[7:4] (RW)
 *
 * Color space converter color depth configuration: Other: Reserved.
 *
 * Values:
 * - 0000 - 24 bit per pixel video (8 bit per component).
 * - 0100 - 24 bit per pixel video (8 bit per component).
 * - 0101 - 30 bit per pixel video (10 bit per component).
 * - 0110 - 36 bit per pixel video (12 bit per component).
 * - 0111 - 48 bit per pixel video (16 bit per component).
 */
/*@{*/
#define BP_HDMI_CSC_SCALE_csc_colorde_pth (4U) /*!< Bit position for HDMI_CSC_SCALE_csc_colorde_pth. */
#define BM_HDMI_CSC_SCALE_csc_colorde_pth (0xF0U) /*!< Bit mask for HDMI_CSC_SCALE_csc_colorde_pth. */
#define BS_HDMI_CSC_SCALE_csc_colorde_pth (4U) /*!< Bit field size in bits for HDMI_CSC_SCALE_csc_colorde_pth. */

/*! @brief Read current value of the HDMI_CSC_SCALE_csc_colorde_pth field. */
#define BR_HDMI_CSC_SCALE_csc_colorde_pth(x) (HW_HDMI_CSC_SCALE(x).B.csc_colorde_pth)

/*! @brief Format value for bitfield HDMI_CSC_SCALE_csc_colorde_pth. */
#define BF_HDMI_CSC_SCALE_csc_colorde_pth(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_SCALE_csc_colorde_pth) & BM_HDMI_CSC_SCALE_csc_colorde_pth)

/*! @brief Set the csc_colorde_pth field to a new value. */
#define BW_HDMI_CSC_SCALE_csc_colorde_pth(x, v) (HW_HDMI_CSC_SCALE_WR(x, (HW_HDMI_CSC_SCALE_RD(x) & ~BM_HDMI_CSC_SCALE_csc_colorde_pth) | BF_HDMI_CSC_SCALE_csc_colorde_pth(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A1_MSB - CSC_COEF_A1_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A1_MSB - CSC_COEF_A1_MSB (RW)
 *
 * Reset value: 0x20U
 *
 * Color Space Conversion A1 coefficient. Address Offset: 0x4102 Size: 8 bits
 * Value after Reset: 0x20 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a1_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a1_msb_bitfields
    {
        uint8_t CSC_COEF_A1_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a1_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A1_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A1_MSB_ADDR(x) ((uintptr_t)(x) + 0x4102U)

#define HW_HDMI_CSC_COEF_A1_MSB(x) (*(__IO hw_hdmi_csc_coef_a1_msb_t *) HW_HDMI_CSC_COEF_A1_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A1_MSB_RD(x) (HW_HDMI_CSC_COEF_A1_MSB(x).U)
#define HW_HDMI_CSC_COEF_A1_MSB_WR(x, v) (HW_HDMI_CSC_COEF_A1_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A1_MSB_SET(x, v) (HW_HDMI_CSC_COEF_A1_MSB_WR(x, HW_HDMI_CSC_COEF_A1_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A1_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_A1_MSB_WR(x, HW_HDMI_CSC_COEF_A1_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A1_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_A1_MSB_WR(x, HW_HDMI_CSC_COEF_A1_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A1_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A1_MSB, field CSC_COEF_A1_MSB[7:0] (RW)
 *
 * Color Space Conversion A1 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB. */
#define BM_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB. */
#define BS_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB field. */
#define BR_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB(x) (HW_HDMI_CSC_COEF_A1_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB. */
#define BF_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB) & BM_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB)

/*! @brief Set the CSC_COEF_A1_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_A1_MSB_CSC_COEF_A1_MSB(x, v) (HW_HDMI_CSC_COEF_A1_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A1_LSB - CSC_COEF_A1_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A1_LSB - CSC_COEF_A1_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A1 coefficient. Address Offset: 0x4103 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a1_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a1_lsb_bitfields
    {
        uint8_t CSC_COEF_A1_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a1_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A1_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A1_LSB_ADDR(x) ((uintptr_t)(x) + 0x4103U)

#define HW_HDMI_CSC_COEF_A1_LSB(x) (*(__IO hw_hdmi_csc_coef_a1_lsb_t *) HW_HDMI_CSC_COEF_A1_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A1_LSB_RD(x) (HW_HDMI_CSC_COEF_A1_LSB(x).U)
#define HW_HDMI_CSC_COEF_A1_LSB_WR(x, v) (HW_HDMI_CSC_COEF_A1_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A1_LSB_SET(x, v) (HW_HDMI_CSC_COEF_A1_LSB_WR(x, HW_HDMI_CSC_COEF_A1_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A1_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_A1_LSB_WR(x, HW_HDMI_CSC_COEF_A1_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A1_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_A1_LSB_WR(x, HW_HDMI_CSC_COEF_A1_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A1_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A1_LSB, field CSC_COEF_A1_LSB[7:0] (RW)
 *
 * Color Space Conversion A1 LSB coefficient
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB. */
#define BM_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB. */
#define BS_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB field. */
#define BR_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB(x) (HW_HDMI_CSC_COEF_A1_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB. */
#define BF_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB) & BM_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB)

/*! @brief Set the CSC_COEF_A1_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_A1_LSB_CSC_COEF_A1_LSB(x, v) (HW_HDMI_CSC_COEF_A1_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A2_MSB - CSC_COEF_A2_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A2_MSB - CSC_COEF_A2_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A2 coefficient. Address Offset: 0x4104 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a2_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a2_msb_bitfields
    {
        uint8_t CSC_COEF_A2_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a2_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A2_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A2_MSB_ADDR(x) ((uintptr_t)(x) + 0x4104U)

#define HW_HDMI_CSC_COEF_A2_MSB(x) (*(__IO hw_hdmi_csc_coef_a2_msb_t *) HW_HDMI_CSC_COEF_A2_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A2_MSB_RD(x) (HW_HDMI_CSC_COEF_A2_MSB(x).U)
#define HW_HDMI_CSC_COEF_A2_MSB_WR(x, v) (HW_HDMI_CSC_COEF_A2_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A2_MSB_SET(x, v) (HW_HDMI_CSC_COEF_A2_MSB_WR(x, HW_HDMI_CSC_COEF_A2_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A2_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_A2_MSB_WR(x, HW_HDMI_CSC_COEF_A2_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A2_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_A2_MSB_WR(x, HW_HDMI_CSC_COEF_A2_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A2_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A2_MSB, field CSC_COEF_A2_MSB[7:0] (RW)
 *
 * Color Space Conversion A2 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB. */
#define BM_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB. */
#define BS_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB field. */
#define BR_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB(x) (HW_HDMI_CSC_COEF_A2_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB. */
#define BF_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB) & BM_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB)

/*! @brief Set the CSC_COEF_A2_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_A2_MSB_CSC_COEF_A2_MSB(x, v) (HW_HDMI_CSC_COEF_A2_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A2_LSB - CSC_COEF_A2_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A2_LSB - CSC_COEF_A2_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A2 coefficient. Address Offset: 0x4105 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a2_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a2_lsb_bitfields
    {
        uint8_t CSC_COEF_A2_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a2_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A2_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A2_LSB_ADDR(x) ((uintptr_t)(x) + 0x4105U)

#define HW_HDMI_CSC_COEF_A2_LSB(x) (*(__IO hw_hdmi_csc_coef_a2_lsb_t *) HW_HDMI_CSC_COEF_A2_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A2_LSB_RD(x) (HW_HDMI_CSC_COEF_A2_LSB(x).U)
#define HW_HDMI_CSC_COEF_A2_LSB_WR(x, v) (HW_HDMI_CSC_COEF_A2_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A2_LSB_SET(x, v) (HW_HDMI_CSC_COEF_A2_LSB_WR(x, HW_HDMI_CSC_COEF_A2_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A2_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_A2_LSB_WR(x, HW_HDMI_CSC_COEF_A2_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A2_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_A2_LSB_WR(x, HW_HDMI_CSC_COEF_A2_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A2_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A2_LSB, field CSC_COEF_A2_LSB[7:0] (RW)
 *
 * Color Space Conversion A2 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB. */
#define BM_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB. */
#define BS_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB field. */
#define BR_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB(x) (HW_HDMI_CSC_COEF_A2_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB. */
#define BF_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB) & BM_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB)

/*! @brief Set the CSC_COEF_A2_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_A2_LSB_CSC_COEF_A2_LSB(x, v) (HW_HDMI_CSC_COEF_A2_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A3_MSB - CSC_COEF_A3_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A3_MSB - CSC_COEF_A3_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A3 coefficient. Address Offset: 0x4106 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a3_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a3_msb_bitfields
    {
        uint8_t CSC_COEF_A3_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a3_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A3_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A3_MSB_ADDR(x) ((uintptr_t)(x) + 0x4106U)

#define HW_HDMI_CSC_COEF_A3_MSB(x) (*(__IO hw_hdmi_csc_coef_a3_msb_t *) HW_HDMI_CSC_COEF_A3_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A3_MSB_RD(x) (HW_HDMI_CSC_COEF_A3_MSB(x).U)
#define HW_HDMI_CSC_COEF_A3_MSB_WR(x, v) (HW_HDMI_CSC_COEF_A3_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A3_MSB_SET(x, v) (HW_HDMI_CSC_COEF_A3_MSB_WR(x, HW_HDMI_CSC_COEF_A3_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A3_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_A3_MSB_WR(x, HW_HDMI_CSC_COEF_A3_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A3_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_A3_MSB_WR(x, HW_HDMI_CSC_COEF_A3_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A3_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A3_MSB, field CSC_COEF_A3_MSB[7:0] (RW)
 *
 * Color Space Conversion A3 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB. */
#define BM_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB. */
#define BS_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB field. */
#define BR_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB(x) (HW_HDMI_CSC_COEF_A3_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB. */
#define BF_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB) & BM_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB)

/*! @brief Set the CSC_COEF_A3_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_A3_MSB_CSC_COEF_A3_MSB(x, v) (HW_HDMI_CSC_COEF_A3_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A3_LSB - CSC_COEF_A3_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A3_LSB - CSC_COEF_A3_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A3 coefficient. Address Offset: 0x4107 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a3_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a3_lsb_bitfields
    {
        uint8_t CSC_COEF_A3_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a3_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A3_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A3_LSB_ADDR(x) ((uintptr_t)(x) + 0x4107U)

#define HW_HDMI_CSC_COEF_A3_LSB(x) (*(__IO hw_hdmi_csc_coef_a3_lsb_t *) HW_HDMI_CSC_COEF_A3_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A3_LSB_RD(x) (HW_HDMI_CSC_COEF_A3_LSB(x).U)
#define HW_HDMI_CSC_COEF_A3_LSB_WR(x, v) (HW_HDMI_CSC_COEF_A3_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A3_LSB_SET(x, v) (HW_HDMI_CSC_COEF_A3_LSB_WR(x, HW_HDMI_CSC_COEF_A3_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A3_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_A3_LSB_WR(x, HW_HDMI_CSC_COEF_A3_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A3_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_A3_LSB_WR(x, HW_HDMI_CSC_COEF_A3_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A3_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A3_LSB, field CSC_COEF_A3_LSB[7:0] (RW)
 *
 * Color Space Conversion A3 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB. */
#define BM_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB. */
#define BS_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB field. */
#define BR_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB(x) (HW_HDMI_CSC_COEF_A3_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB. */
#define BF_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB) & BM_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB)

/*! @brief Set the CSC_COEF_A3_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_A3_LSB_CSC_COEF_A3_LSB(x, v) (HW_HDMI_CSC_COEF_A3_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A4_MSB - CSC_COEF_A4_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A4_MSB - CSC_COEF_A4_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A4 coefficient. Address Offset: 0x4108 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a4_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a4_msb_bitfields
    {
        uint8_t CSC_COEF_A4_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a4_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A4_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A4_MSB_ADDR(x) ((uintptr_t)(x) + 0x4108U)

#define HW_HDMI_CSC_COEF_A4_MSB(x) (*(__IO hw_hdmi_csc_coef_a4_msb_t *) HW_HDMI_CSC_COEF_A4_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A4_MSB_RD(x) (HW_HDMI_CSC_COEF_A4_MSB(x).U)
#define HW_HDMI_CSC_COEF_A4_MSB_WR(x, v) (HW_HDMI_CSC_COEF_A4_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A4_MSB_SET(x, v) (HW_HDMI_CSC_COEF_A4_MSB_WR(x, HW_HDMI_CSC_COEF_A4_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A4_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_A4_MSB_WR(x, HW_HDMI_CSC_COEF_A4_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A4_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_A4_MSB_WR(x, HW_HDMI_CSC_COEF_A4_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A4_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A4_MSB, field CSC_COEF_A4_MSB[7:0] (RW)
 *
 * Color Space Conversion A4 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB. */
#define BM_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB. */
#define BS_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB field. */
#define BR_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB(x) (HW_HDMI_CSC_COEF_A4_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB. */
#define BF_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB) & BM_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB)

/*! @brief Set the CSC_COEF_A4_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_A4_MSB_CSC_COEF_A4_MSB(x, v) (HW_HDMI_CSC_COEF_A4_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_A4_LSB - CSC_COEF_A4_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_A4_LSB - CSC_COEF_A4_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion A4 coefficient. Address Offset: 0x4109 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_a4_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_a4_lsb_bitfields
    {
        uint8_t CSC_COEF_A4_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_a4_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_A4_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_A4_LSB_ADDR(x) ((uintptr_t)(x) + 0x4109U)

#define HW_HDMI_CSC_COEF_A4_LSB(x) (*(__IO hw_hdmi_csc_coef_a4_lsb_t *) HW_HDMI_CSC_COEF_A4_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_A4_LSB_RD(x) (HW_HDMI_CSC_COEF_A4_LSB(x).U)
#define HW_HDMI_CSC_COEF_A4_LSB_WR(x, v) (HW_HDMI_CSC_COEF_A4_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_A4_LSB_SET(x, v) (HW_HDMI_CSC_COEF_A4_LSB_WR(x, HW_HDMI_CSC_COEF_A4_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_A4_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_A4_LSB_WR(x, HW_HDMI_CSC_COEF_A4_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_A4_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_A4_LSB_WR(x, HW_HDMI_CSC_COEF_A4_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_A4_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_A4_LSB, field CSC_COEF_A4_LSB[7:0] (RW)
 *
 * Color Space Conversion A4 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB. */
#define BM_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB. */
#define BS_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB field. */
#define BR_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB(x) (HW_HDMI_CSC_COEF_A4_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB. */
#define BF_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB) & BM_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB)

/*! @brief Set the CSC_COEF_A4_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_A4_LSB_CSC_COEF_A4_LSB(x, v) (HW_HDMI_CSC_COEF_A4_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B1_MSB - CSC_COEF_B1_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B1_MSB - CSC_COEF_B1_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B1 coefficient. Address Offset: 0x410A Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b1_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b1_msb_bitfields
    {
        uint8_t CSC_COEF_B1_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b1_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B1_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B1_MSB_ADDR(x) ((uintptr_t)(x) + 0x410AU)

#define HW_HDMI_CSC_COEF_B1_MSB(x) (*(__IO hw_hdmi_csc_coef_b1_msb_t *) HW_HDMI_CSC_COEF_B1_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B1_MSB_RD(x) (HW_HDMI_CSC_COEF_B1_MSB(x).U)
#define HW_HDMI_CSC_COEF_B1_MSB_WR(x, v) (HW_HDMI_CSC_COEF_B1_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B1_MSB_SET(x, v) (HW_HDMI_CSC_COEF_B1_MSB_WR(x, HW_HDMI_CSC_COEF_B1_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B1_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_B1_MSB_WR(x, HW_HDMI_CSC_COEF_B1_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B1_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_B1_MSB_WR(x, HW_HDMI_CSC_COEF_B1_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B1_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B1_MSB, field CSC_COEF_B1_MSB[7:0] (RW)
 *
 * Color Space Conversion B1 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB. */
#define BM_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB. */
#define BS_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB field. */
#define BR_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB(x) (HW_HDMI_CSC_COEF_B1_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB. */
#define BF_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB) & BM_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB)

/*! @brief Set the CSC_COEF_B1_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_B1_MSB_CSC_COEF_B1_MSB(x, v) (HW_HDMI_CSC_COEF_B1_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B1_LSB - CSC_COEF_B1_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B1_LSB - CSC_COEF_B1_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B1 coefficient. Address Offset: 0x410B Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b1_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b1_lsb_bitfields
    {
        uint8_t CSC_COEF_B1_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b1_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B1_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B1_LSB_ADDR(x) ((uintptr_t)(x) + 0x410BU)

#define HW_HDMI_CSC_COEF_B1_LSB(x) (*(__IO hw_hdmi_csc_coef_b1_lsb_t *) HW_HDMI_CSC_COEF_B1_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B1_LSB_RD(x) (HW_HDMI_CSC_COEF_B1_LSB(x).U)
#define HW_HDMI_CSC_COEF_B1_LSB_WR(x, v) (HW_HDMI_CSC_COEF_B1_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B1_LSB_SET(x, v) (HW_HDMI_CSC_COEF_B1_LSB_WR(x, HW_HDMI_CSC_COEF_B1_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B1_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_B1_LSB_WR(x, HW_HDMI_CSC_COEF_B1_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B1_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_B1_LSB_WR(x, HW_HDMI_CSC_COEF_B1_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B1_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B1_LSB, field CSC_COEF_B1_LSB[7:0] (RW)
 *
 * Color Space Conversion B1 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB. */
#define BM_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB. */
#define BS_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB field. */
#define BR_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB(x) (HW_HDMI_CSC_COEF_B1_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB. */
#define BF_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB) & BM_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB)

/*! @brief Set the CSC_COEF_B1_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_B1_LSB_CSC_COEF_B1_LSB(x, v) (HW_HDMI_CSC_COEF_B1_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B2_MSB - CSC_COEF_B2_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B2_MSB - CSC_COEF_B2_MSB (RW)
 *
 * Reset value: 0x20U
 *
 * Color Space Conversion B2 coefficient. Address Offset: 0x410C Size: 8 bits
 * Value after Reset: 0x20 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b2_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b2_msb_bitfields
    {
        uint8_t CSC_COEF_B2_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b2_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B2_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B2_MSB_ADDR(x) ((uintptr_t)(x) + 0x410CU)

#define HW_HDMI_CSC_COEF_B2_MSB(x) (*(__IO hw_hdmi_csc_coef_b2_msb_t *) HW_HDMI_CSC_COEF_B2_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B2_MSB_RD(x) (HW_HDMI_CSC_COEF_B2_MSB(x).U)
#define HW_HDMI_CSC_COEF_B2_MSB_WR(x, v) (HW_HDMI_CSC_COEF_B2_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B2_MSB_SET(x, v) (HW_HDMI_CSC_COEF_B2_MSB_WR(x, HW_HDMI_CSC_COEF_B2_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B2_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_B2_MSB_WR(x, HW_HDMI_CSC_COEF_B2_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B2_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_B2_MSB_WR(x, HW_HDMI_CSC_COEF_B2_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B2_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B2_MSB, field CSC_COEF_B2_MSB[7:0] (RW)
 *
 * Color Space Conversion B2 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB. */
#define BM_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB. */
#define BS_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB field. */
#define BR_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB(x) (HW_HDMI_CSC_COEF_B2_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB. */
#define BF_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB) & BM_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB)

/*! @brief Set the CSC_COEF_B2_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_B2_MSB_CSC_COEF_B2_MSB(x, v) (HW_HDMI_CSC_COEF_B2_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B2_LSB - CSC_COEF_B2_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B2_LSB - CSC_COEF_B2_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B2 coefficient. Address Offset: 0x410D Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b2_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b2_lsb_bitfields
    {
        uint8_t CSC_COEF_B2_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b2_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B2_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B2_LSB_ADDR(x) ((uintptr_t)(x) + 0x410DU)

#define HW_HDMI_CSC_COEF_B2_LSB(x) (*(__IO hw_hdmi_csc_coef_b2_lsb_t *) HW_HDMI_CSC_COEF_B2_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B2_LSB_RD(x) (HW_HDMI_CSC_COEF_B2_LSB(x).U)
#define HW_HDMI_CSC_COEF_B2_LSB_WR(x, v) (HW_HDMI_CSC_COEF_B2_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B2_LSB_SET(x, v) (HW_HDMI_CSC_COEF_B2_LSB_WR(x, HW_HDMI_CSC_COEF_B2_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B2_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_B2_LSB_WR(x, HW_HDMI_CSC_COEF_B2_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B2_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_B2_LSB_WR(x, HW_HDMI_CSC_COEF_B2_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B2_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B2_LSB, field CSC_COEF_B2_LSB[7:0] (RW)
 *
 * Color Space Conversion B2 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB. */
#define BM_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB. */
#define BS_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB field. */
#define BR_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB(x) (HW_HDMI_CSC_COEF_B2_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB. */
#define BF_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB) & BM_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB)

/*! @brief Set the CSC_COEF_B2_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_B2_LSB_CSC_COEF_B2_LSB(x, v) (HW_HDMI_CSC_COEF_B2_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B3_MSB - CSC_COEF_B3_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B3_MSB - CSC_COEF_B3_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B3 coefficient. Address Offset: 0x410E Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b3_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b3_msb_bitfields
    {
        uint8_t CSC_COEF_B3_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b3_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B3_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B3_MSB_ADDR(x) ((uintptr_t)(x) + 0x410EU)

#define HW_HDMI_CSC_COEF_B3_MSB(x) (*(__IO hw_hdmi_csc_coef_b3_msb_t *) HW_HDMI_CSC_COEF_B3_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B3_MSB_RD(x) (HW_HDMI_CSC_COEF_B3_MSB(x).U)
#define HW_HDMI_CSC_COEF_B3_MSB_WR(x, v) (HW_HDMI_CSC_COEF_B3_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B3_MSB_SET(x, v) (HW_HDMI_CSC_COEF_B3_MSB_WR(x, HW_HDMI_CSC_COEF_B3_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B3_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_B3_MSB_WR(x, HW_HDMI_CSC_COEF_B3_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B3_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_B3_MSB_WR(x, HW_HDMI_CSC_COEF_B3_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B3_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B3_MSB, field CSC_COEF_B3_MSB[7:0] (RW)
 *
 * Color Space Conversion B3 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB. */
#define BM_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB. */
#define BS_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB field. */
#define BR_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB(x) (HW_HDMI_CSC_COEF_B3_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB. */
#define BF_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB) & BM_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB)

/*! @brief Set the CSC_COEF_B3_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_B3_MSB_CSC_COEF_B3_MSB(x, v) (HW_HDMI_CSC_COEF_B3_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B3_LSB - CSC_COEF_B3_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B3_LSB - CSC_COEF_B3_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B3 coefficient. Address Offset: 0x410F Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b3_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b3_lsb_bitfields
    {
        uint8_t CSC_COEF_B3_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b3_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B3_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B3_LSB_ADDR(x) ((uintptr_t)(x) + 0x410FU)

#define HW_HDMI_CSC_COEF_B3_LSB(x) (*(__IO hw_hdmi_csc_coef_b3_lsb_t *) HW_HDMI_CSC_COEF_B3_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B3_LSB_RD(x) (HW_HDMI_CSC_COEF_B3_LSB(x).U)
#define HW_HDMI_CSC_COEF_B3_LSB_WR(x, v) (HW_HDMI_CSC_COEF_B3_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B3_LSB_SET(x, v) (HW_HDMI_CSC_COEF_B3_LSB_WR(x, HW_HDMI_CSC_COEF_B3_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B3_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_B3_LSB_WR(x, HW_HDMI_CSC_COEF_B3_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B3_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_B3_LSB_WR(x, HW_HDMI_CSC_COEF_B3_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B3_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B3_LSB, field CSC_COEF_B3_LSB[7:0] (RW)
 *
 * Color Space Conversion B3 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB. */
#define BM_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB. */
#define BS_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB field. */
#define BR_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB(x) (HW_HDMI_CSC_COEF_B3_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB. */
#define BF_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB) & BM_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB)

/*! @brief Set the CSC_COEF_B3_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_B3_LSB_CSC_COEF_B3_LSB(x, v) (HW_HDMI_CSC_COEF_B3_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B4_MSB - CSC_COEF_B4_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B4_MSB - CSC_COEF_B4_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B4 coefficient. Address Offset: 0x4110 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b4_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b4_msb_bitfields
    {
        uint8_t CSC_COEF_B4_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b4_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B4_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B4_MSB_ADDR(x) ((uintptr_t)(x) + 0x4110U)

#define HW_HDMI_CSC_COEF_B4_MSB(x) (*(__IO hw_hdmi_csc_coef_b4_msb_t *) HW_HDMI_CSC_COEF_B4_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B4_MSB_RD(x) (HW_HDMI_CSC_COEF_B4_MSB(x).U)
#define HW_HDMI_CSC_COEF_B4_MSB_WR(x, v) (HW_HDMI_CSC_COEF_B4_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B4_MSB_SET(x, v) (HW_HDMI_CSC_COEF_B4_MSB_WR(x, HW_HDMI_CSC_COEF_B4_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B4_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_B4_MSB_WR(x, HW_HDMI_CSC_COEF_B4_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B4_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_B4_MSB_WR(x, HW_HDMI_CSC_COEF_B4_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B4_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B4_MSB, field CSC_COEF_B4_MSB[7:0] (RW)
 *
 * Color Space Conversion B4 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB. */
#define BM_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB. */
#define BS_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB field. */
#define BR_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB(x) (HW_HDMI_CSC_COEF_B4_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB. */
#define BF_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB) & BM_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB)

/*! @brief Set the CSC_COEF_B4_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_B4_MSB_CSC_COEF_B4_MSB(x, v) (HW_HDMI_CSC_COEF_B4_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_B4_LSB - CSC_COEF_B4_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_B4_LSB - CSC_COEF_B4_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion B4 coefficient. Address Offset: 0x4111 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_b4_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_b4_lsb_bitfields
    {
        uint8_t CSC_COEF_B4_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_b4_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_B4_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_B4_LSB_ADDR(x) ((uintptr_t)(x) + 0x4111U)

#define HW_HDMI_CSC_COEF_B4_LSB(x) (*(__IO hw_hdmi_csc_coef_b4_lsb_t *) HW_HDMI_CSC_COEF_B4_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_B4_LSB_RD(x) (HW_HDMI_CSC_COEF_B4_LSB(x).U)
#define HW_HDMI_CSC_COEF_B4_LSB_WR(x, v) (HW_HDMI_CSC_COEF_B4_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_B4_LSB_SET(x, v) (HW_HDMI_CSC_COEF_B4_LSB_WR(x, HW_HDMI_CSC_COEF_B4_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_B4_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_B4_LSB_WR(x, HW_HDMI_CSC_COEF_B4_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_B4_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_B4_LSB_WR(x, HW_HDMI_CSC_COEF_B4_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_B4_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_B4_LSB, field CSC_COEF_B4_LSB[7:0] (RW)
 *
 * Color Space Conversion B4 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB. */
#define BM_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB. */
#define BS_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB field. */
#define BR_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB(x) (HW_HDMI_CSC_COEF_B4_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB. */
#define BF_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB) & BM_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB)

/*! @brief Set the CSC_COEF_B4_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_B4_LSB_CSC_COEF_B4_LSB(x, v) (HW_HDMI_CSC_COEF_B4_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C1_MSB - CSC_COEF_C1_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C1_MSB - CSC_COEF_C1_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C1 coefficient. Address Offset: 0x4112 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c1_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c1_msb_bitfields
    {
        uint8_t CSC_COEF_C1_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c1_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C1_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C1_MSB_ADDR(x) ((uintptr_t)(x) + 0x4112U)

#define HW_HDMI_CSC_COEF_C1_MSB(x) (*(__IO hw_hdmi_csc_coef_c1_msb_t *) HW_HDMI_CSC_COEF_C1_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C1_MSB_RD(x) (HW_HDMI_CSC_COEF_C1_MSB(x).U)
#define HW_HDMI_CSC_COEF_C1_MSB_WR(x, v) (HW_HDMI_CSC_COEF_C1_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C1_MSB_SET(x, v) (HW_HDMI_CSC_COEF_C1_MSB_WR(x, HW_HDMI_CSC_COEF_C1_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C1_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_C1_MSB_WR(x, HW_HDMI_CSC_COEF_C1_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C1_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_C1_MSB_WR(x, HW_HDMI_CSC_COEF_C1_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C1_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C1_MSB, field CSC_COEF_C1_MSB[7:0] (RW)
 *
 * Color Space Conversion C1 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB. */
#define BM_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB. */
#define BS_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB field. */
#define BR_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB(x) (HW_HDMI_CSC_COEF_C1_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB. */
#define BF_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB) & BM_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB)

/*! @brief Set the CSC_COEF_C1_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_C1_MSB_CSC_COEF_C1_MSB(x, v) (HW_HDMI_CSC_COEF_C1_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C1_LSB - CSC_COEF_C1_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C1_LSB - CSC_COEF_C1_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C1 coefficient. Address Offset: 0x4113 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c1_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c1_lsb_bitfields
    {
        uint8_t CSC_COEF_C1_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c1_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C1_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C1_LSB_ADDR(x) ((uintptr_t)(x) + 0x4113U)

#define HW_HDMI_CSC_COEF_C1_LSB(x) (*(__IO hw_hdmi_csc_coef_c1_lsb_t *) HW_HDMI_CSC_COEF_C1_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C1_LSB_RD(x) (HW_HDMI_CSC_COEF_C1_LSB(x).U)
#define HW_HDMI_CSC_COEF_C1_LSB_WR(x, v) (HW_HDMI_CSC_COEF_C1_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C1_LSB_SET(x, v) (HW_HDMI_CSC_COEF_C1_LSB_WR(x, HW_HDMI_CSC_COEF_C1_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C1_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_C1_LSB_WR(x, HW_HDMI_CSC_COEF_C1_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C1_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_C1_LSB_WR(x, HW_HDMI_CSC_COEF_C1_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C1_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C1_LSB, field CSC_COEF_C1_LSB[7:0] (RW)
 *
 * Color Space Conversion C1 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB. */
#define BM_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB. */
#define BS_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB field. */
#define BR_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB(x) (HW_HDMI_CSC_COEF_C1_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB. */
#define BF_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB) & BM_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB)

/*! @brief Set the CSC_COEF_C1_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_C1_LSB_CSC_COEF_C1_LSB(x, v) (HW_HDMI_CSC_COEF_C1_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C2_MSB - CSC_COEF_C2_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C2_MSB - CSC_COEF_C2_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C2 coefficient. Address Offset: 0x4114 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c2_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c2_msb_bitfields
    {
        uint8_t CSC_COEF_C2_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c2_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C2_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C2_MSB_ADDR(x) ((uintptr_t)(x) + 0x4114U)

#define HW_HDMI_CSC_COEF_C2_MSB(x) (*(__IO hw_hdmi_csc_coef_c2_msb_t *) HW_HDMI_CSC_COEF_C2_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C2_MSB_RD(x) (HW_HDMI_CSC_COEF_C2_MSB(x).U)
#define HW_HDMI_CSC_COEF_C2_MSB_WR(x, v) (HW_HDMI_CSC_COEF_C2_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C2_MSB_SET(x, v) (HW_HDMI_CSC_COEF_C2_MSB_WR(x, HW_HDMI_CSC_COEF_C2_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C2_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_C2_MSB_WR(x, HW_HDMI_CSC_COEF_C2_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C2_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_C2_MSB_WR(x, HW_HDMI_CSC_COEF_C2_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C2_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C2_MSB, field CSC_COEF_C2_MSB[7:0] (RW)
 *
 * Color Space Conversion C2 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB. */
#define BM_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB. */
#define BS_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB field. */
#define BR_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB(x) (HW_HDMI_CSC_COEF_C2_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB. */
#define BF_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB) & BM_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB)

/*! @brief Set the CSC_COEF_C2_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_C2_MSB_CSC_COEF_C2_MSB(x, v) (HW_HDMI_CSC_COEF_C2_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C2_LSB - CSC_COEF_C2_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C2_LSB - CSC_COEF_C2_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C2 coefficient. Address Offset: 0x4115 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c2_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c2_lsb_bitfields
    {
        uint8_t CSC_COEF_C2_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c2_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C2_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C2_LSB_ADDR(x) ((uintptr_t)(x) + 0x4115U)

#define HW_HDMI_CSC_COEF_C2_LSB(x) (*(__IO hw_hdmi_csc_coef_c2_lsb_t *) HW_HDMI_CSC_COEF_C2_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C2_LSB_RD(x) (HW_HDMI_CSC_COEF_C2_LSB(x).U)
#define HW_HDMI_CSC_COEF_C2_LSB_WR(x, v) (HW_HDMI_CSC_COEF_C2_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C2_LSB_SET(x, v) (HW_HDMI_CSC_COEF_C2_LSB_WR(x, HW_HDMI_CSC_COEF_C2_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C2_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_C2_LSB_WR(x, HW_HDMI_CSC_COEF_C2_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C2_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_C2_LSB_WR(x, HW_HDMI_CSC_COEF_C2_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C2_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C2_LSB, field CSC_COEF_C2_LSB[7:0] (RW)
 *
 * Color Space Conversion C2 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB. */
#define BM_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB. */
#define BS_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB field. */
#define BR_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB(x) (HW_HDMI_CSC_COEF_C2_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB. */
#define BF_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB) & BM_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB)

/*! @brief Set the CSC_COEF_C2_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_C2_LSB_CSC_COEF_C2_LSB(x, v) (HW_HDMI_CSC_COEF_C2_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C3_MSB - CSC_COEF_C3_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C3_MSB - CSC_COEF_C3_MSB (RW)
 *
 * Reset value: 0x20U
 *
 * Color Space Conversion C3 coefficient. Address Offset: 0x4116 Size: 8 bits
 * Value after Reset: 0x20 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c3_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c3_msb_bitfields
    {
        uint8_t CSC_COEF_C3_MSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c3_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C3_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C3_MSB_ADDR(x) ((uintptr_t)(x) + 0x4116U)

#define HW_HDMI_CSC_COEF_C3_MSB(x) (*(__IO hw_hdmi_csc_coef_c3_msb_t *) HW_HDMI_CSC_COEF_C3_MSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C3_MSB_RD(x) (HW_HDMI_CSC_COEF_C3_MSB(x).U)
#define HW_HDMI_CSC_COEF_C3_MSB_WR(x, v) (HW_HDMI_CSC_COEF_C3_MSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C3_MSB_SET(x, v) (HW_HDMI_CSC_COEF_C3_MSB_WR(x, HW_HDMI_CSC_COEF_C3_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C3_MSB_CLR(x, v) (HW_HDMI_CSC_COEF_C3_MSB_WR(x, HW_HDMI_CSC_COEF_C3_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C3_MSB_TOG(x, v) (HW_HDMI_CSC_COEF_C3_MSB_WR(x, HW_HDMI_CSC_COEF_C3_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C3_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C3_MSB, field CSC_COEF_C3_MSB[7:0] (RW)
 *
 * Color Space Conversion C3 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB (0U) /*!< Bit position for HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB. */
#define BM_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB. */
#define BS_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB field. */
#define BR_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB(x) (HW_HDMI_CSC_COEF_C3_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB. */
#define BF_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB) & BM_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB)

/*! @brief Set the CSC_COEF_C3_MSB field to a new value. */
#define BW_HDMI_CSC_COEF_C3_MSB_CSC_COEF_C3_MSB(x, v) (HW_HDMI_CSC_COEF_C3_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEF_C3_LSB - CSC_COEF_C3_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEF_C3_LSB - CSC_COEF_C3_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C3 coefficient. Address Offset: 0x4117 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coef_c3_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coef_c3_lsb_bitfields
    {
        uint8_t CSC_COEF_C3_LSB : 8;   /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coef_c3_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEF_C3_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEF_C3_LSB_ADDR(x) ((uintptr_t)(x) + 0x4117U)

#define HW_HDMI_CSC_COEF_C3_LSB(x) (*(__IO hw_hdmi_csc_coef_c3_lsb_t *) HW_HDMI_CSC_COEF_C3_LSB_ADDR(x))
#define HW_HDMI_CSC_COEF_C3_LSB_RD(x) (HW_HDMI_CSC_COEF_C3_LSB(x).U)
#define HW_HDMI_CSC_COEF_C3_LSB_WR(x, v) (HW_HDMI_CSC_COEF_C3_LSB(x).U = (v))
#define HW_HDMI_CSC_COEF_C3_LSB_SET(x, v) (HW_HDMI_CSC_COEF_C3_LSB_WR(x, HW_HDMI_CSC_COEF_C3_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEF_C3_LSB_CLR(x, v) (HW_HDMI_CSC_COEF_C3_LSB_WR(x, HW_HDMI_CSC_COEF_C3_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEF_C3_LSB_TOG(x, v) (HW_HDMI_CSC_COEF_C3_LSB_WR(x, HW_HDMI_CSC_COEF_C3_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEF_C3_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEF_C3_LSB, field CSC_COEF_C3_LSB[7:0] (RW)
 *
 * Color Space Conversion C3 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB (0U) /*!< Bit position for HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB. */
#define BM_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB. */
#define BS_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB field. */
#define BR_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB(x) (HW_HDMI_CSC_COEF_C3_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB. */
#define BF_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB) & BM_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB)

/*! @brief Set the CSC_COEF_C3_LSB field to a new value. */
#define BW_HDMI_CSC_COEF_C3_LSB_CSC_COEF_C3_LSB(x, v) (HW_HDMI_CSC_COEF_C3_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEFC4_MSB - CSC_COEFC4_MSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEFC4_MSB - CSC_COEFC4_MSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C4 coefficient. Address Offset: 0x4118 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coefc4_msb
{
    uint8_t U;
    struct _hw_hdmi_csc_coefc4_msb_bitfields
    {
        uint8_t CSC_COEFC4_MSB : 8;    /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coefc4_msb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEFC4_MSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEFC4_MSB_ADDR(x) ((uintptr_t)(x) + 0x4118U)

#define HW_HDMI_CSC_COEFC4_MSB(x) (*(__IO hw_hdmi_csc_coefc4_msb_t *) HW_HDMI_CSC_COEFC4_MSB_ADDR(x))
#define HW_HDMI_CSC_COEFC4_MSB_RD(x) (HW_HDMI_CSC_COEFC4_MSB(x).U)
#define HW_HDMI_CSC_COEFC4_MSB_WR(x, v) (HW_HDMI_CSC_COEFC4_MSB(x).U = (v))
#define HW_HDMI_CSC_COEFC4_MSB_SET(x, v) (HW_HDMI_CSC_COEFC4_MSB_WR(x, HW_HDMI_CSC_COEFC4_MSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEFC4_MSB_CLR(x, v) (HW_HDMI_CSC_COEFC4_MSB_WR(x, HW_HDMI_CSC_COEFC4_MSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEFC4_MSB_TOG(x, v) (HW_HDMI_CSC_COEFC4_MSB_WR(x, HW_HDMI_CSC_COEFC4_MSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEFC4_MSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEFC4_MSB, field CSC_COEFC4_MSB[7:0] (RW)
 *
 * Color Space Conversion C4 MSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB (0U) /*!< Bit position for HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB. */
#define BM_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB. */
#define BS_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB. */

/*! @brief Read current value of the HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB field. */
#define BR_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB(x) (HW_HDMI_CSC_COEFC4_MSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB. */
#define BF_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB) & BM_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB)

/*! @brief Set the CSC_COEFC4_MSB field to a new value. */
#define BW_HDMI_CSC_COEFC4_MSB_CSC_COEFC4_MSB(x, v) (HW_HDMI_CSC_COEFC4_MSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CSC_COEFC4_LSB - CSC_COEFC4_LSB
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CSC_COEFC4_LSB - CSC_COEFC4_LSB (RW)
 *
 * Reset value: 0x00U
 *
 * Color Space Conversion C4 coefficient. Address Offset: 0x4119 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_csc_coefc4_lsb
{
    uint8_t U;
    struct _hw_hdmi_csc_coefc4_lsb_bitfields
    {
        uint8_t CSC_COEFC4_LSB : 8;    /*!< [7:0]  */
    } B;
} hw_hdmi_csc_coefc4_lsb_t;

/*!
 * @name Constants and macros for entire HDMI_CSC_COEFC4_LSB register
 */
/*@{*/
#define HW_HDMI_CSC_COEFC4_LSB_ADDR(x) ((uintptr_t)(x) + 0x4119U)

#define HW_HDMI_CSC_COEFC4_LSB(x) (*(__IO hw_hdmi_csc_coefc4_lsb_t *) HW_HDMI_CSC_COEFC4_LSB_ADDR(x))
#define HW_HDMI_CSC_COEFC4_LSB_RD(x) (HW_HDMI_CSC_COEFC4_LSB(x).U)
#define HW_HDMI_CSC_COEFC4_LSB_WR(x, v) (HW_HDMI_CSC_COEFC4_LSB(x).U = (v))
#define HW_HDMI_CSC_COEFC4_LSB_SET(x, v) (HW_HDMI_CSC_COEFC4_LSB_WR(x, HW_HDMI_CSC_COEFC4_LSB_RD(x) |  (v)))
#define HW_HDMI_CSC_COEFC4_LSB_CLR(x, v) (HW_HDMI_CSC_COEFC4_LSB_WR(x, HW_HDMI_CSC_COEFC4_LSB_RD(x) & ~(v)))
#define HW_HDMI_CSC_COEFC4_LSB_TOG(x, v) (HW_HDMI_CSC_COEFC4_LSB_WR(x, HW_HDMI_CSC_COEFC4_LSB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CSC_COEFC4_LSB bitfields
 */

/*!
 * @name Register HDMI_CSC_COEFC4_LSB, field CSC_COEFC4_LSB[7:0] (RW)
 *
 * Color Space Conversion C4 LSB coefficient.
 */
/*@{*/
#define BP_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB (0U) /*!< Bit position for HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB. */
#define BM_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB (0xFFU) /*!< Bit mask for HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB. */
#define BS_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB (8U) /*!< Bit field size in bits for HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB. */

/*! @brief Read current value of the HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB field. */
#define BR_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB(x) (HW_HDMI_CSC_COEFC4_LSB(x).U)

/*! @brief Format value for bitfield HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB. */
#define BF_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB) & BM_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB)

/*! @brief Set the CSC_COEFC4_LSB field to a new value. */
#define BW_HDMI_CSC_COEFC4_LSB_CSC_COEFC4_LSB(x, v) (HW_HDMI_CSC_COEFC4_LSB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_CTRL - CEC_CTRL
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_CTRL - CEC_CTRL (RW)
 *
 * Reset value: 0x02U
 *
 * CEC registers control the CEC feature that is implemented in HDMI TX. They
 * perform various functions like controlling, monitoring, and buffering data for
 * the transmitter and the receiver. This register handles the main control of the
 * CEC initiator. Address Offset: 0x7D00 Size: 8 bits Value after Reset: 0x02
 * Access: Read/Write
 */
typedef union _hw_hdmi_cec_ctrl
{
    uint8_t U;
    struct _hw_hdmi_cec_ctrl_bitfields
    {
        uint8_t SEND : 1;              /*!< [0]  */
        uint8_t FRAME_TYP : 2;         /*!< [2:1]  */
        uint8_t BC_NACK : 1;           /*!< [3]  */
        uint8_t STANDBY : 1;           /*!< [4]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_cec_ctrl_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_CTRL register
 */
/*@{*/
#define HW_HDMI_CEC_CTRL_ADDR(x) ((uintptr_t)(x) + 0x7D00U)

#define HW_HDMI_CEC_CTRL(x)      (*(__IO hw_hdmi_cec_ctrl_t *) HW_HDMI_CEC_CTRL_ADDR(x))
#define HW_HDMI_CEC_CTRL_RD(x)   (HW_HDMI_CEC_CTRL(x).U)
#define HW_HDMI_CEC_CTRL_WR(x, v) (HW_HDMI_CEC_CTRL(x).U = (v))
#define HW_HDMI_CEC_CTRL_SET(x, v) (HW_HDMI_CEC_CTRL_WR(x, HW_HDMI_CEC_CTRL_RD(x) |  (v)))
#define HW_HDMI_CEC_CTRL_CLR(x, v) (HW_HDMI_CEC_CTRL_WR(x, HW_HDMI_CEC_CTRL_RD(x) & ~(v)))
#define HW_HDMI_CEC_CTRL_TOG(x, v) (HW_HDMI_CEC_CTRL_WR(x, HW_HDMI_CEC_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_CTRL bitfields
 */

/*!
 * @name Register HDMI_CEC_CTRL, field SEND[0] (RW)
 *
 * Send bit
 *
 * Values:
 * - 0 - Reset to 0 by hardware when the CEC transmission is done (no matter
 *     successful or failed). It can also work as an indicator checked by software
 *     to see whether the transmission is finished.
 * - 1 - Set by software to trigger CEC sending a frame as an initiator. This
 *     bit keeps at 1 while the transmission is going on.
 */
/*@{*/
#define BP_HDMI_CEC_CTRL_SEND (0U)         /*!< Bit position for HDMI_CEC_CTRL_SEND. */
#define BM_HDMI_CEC_CTRL_SEND (0x01U)      /*!< Bit mask for HDMI_CEC_CTRL_SEND. */
#define BS_HDMI_CEC_CTRL_SEND (1U)         /*!< Bit field size in bits for HDMI_CEC_CTRL_SEND. */

/*! @brief Read current value of the HDMI_CEC_CTRL_SEND field. */
#define BR_HDMI_CEC_CTRL_SEND(x) (HW_HDMI_CEC_CTRL(x).B.SEND)

/*! @brief Format value for bitfield HDMI_CEC_CTRL_SEND. */
#define BF_HDMI_CEC_CTRL_SEND(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_CTRL_SEND) & BM_HDMI_CEC_CTRL_SEND)

/*! @brief Set the SEND field to a new value. */
#define BW_HDMI_CEC_CTRL_SEND(x, v) (HW_HDMI_CEC_CTRL_WR(x, (HW_HDMI_CEC_CTRL_RD(x) & ~BM_HDMI_CEC_CTRL_SEND) | BF_HDMI_CEC_CTRL_SEND(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_CTRL, field FRAME_TYP[2:1] (RW)
 *
 * Frame Type bit
 *
 * Values:
 * - 00 - Signal Free Time = 3-bit periods. Previous attempt to send frame is
 *     unsuccessful.
 * - 01 - Signal Free Time = 5-bit periods. New initiator wants to send a frame.
 * - 10 - Signal Free Time = 7-bit periods. Present initiator wants to send
 *     another frame immediately after its previous frame. (spec CEC 9.1)
 * - 11 - Illegal value. If software write this value, hardware will set the
 *     value to the default 2'b01.
 */
/*@{*/
#define BP_HDMI_CEC_CTRL_FRAME_TYP (1U)    /*!< Bit position for HDMI_CEC_CTRL_FRAME_TYP. */
#define BM_HDMI_CEC_CTRL_FRAME_TYP (0x06U) /*!< Bit mask for HDMI_CEC_CTRL_FRAME_TYP. */
#define BS_HDMI_CEC_CTRL_FRAME_TYP (2U)    /*!< Bit field size in bits for HDMI_CEC_CTRL_FRAME_TYP. */

/*! @brief Read current value of the HDMI_CEC_CTRL_FRAME_TYP field. */
#define BR_HDMI_CEC_CTRL_FRAME_TYP(x) (HW_HDMI_CEC_CTRL(x).B.FRAME_TYP)

/*! @brief Format value for bitfield HDMI_CEC_CTRL_FRAME_TYP. */
#define BF_HDMI_CEC_CTRL_FRAME_TYP(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_CTRL_FRAME_TYP) & BM_HDMI_CEC_CTRL_FRAME_TYP)

/*! @brief Set the FRAME_TYP field to a new value. */
#define BW_HDMI_CEC_CTRL_FRAME_TYP(x, v) (HW_HDMI_CEC_CTRL_WR(x, (HW_HDMI_CEC_CTRL_RD(x) & ~BM_HDMI_CEC_CTRL_FRAME_TYP) | BF_HDMI_CEC_CTRL_FRAME_TYP(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_CTRL, field BC_NACK[3] (RW)
 *
 * Broadcast NACK bit
 *
 * Values:
 * - 0 - Reset by software to ACK the received broadcast message.
 * - 1 - Set by software to NACK the received broadcast message. This bit holds
 *     till software resets. The broadcasts will be answered with 1'b0. It means
 *     the follower reject the message.
 */
/*@{*/
#define BP_HDMI_CEC_CTRL_BC_NACK (3U)      /*!< Bit position for HDMI_CEC_CTRL_BC_NACK. */
#define BM_HDMI_CEC_CTRL_BC_NACK (0x08U)   /*!< Bit mask for HDMI_CEC_CTRL_BC_NACK. */
#define BS_HDMI_CEC_CTRL_BC_NACK (1U)      /*!< Bit field size in bits for HDMI_CEC_CTRL_BC_NACK. */

/*! @brief Read current value of the HDMI_CEC_CTRL_BC_NACK field. */
#define BR_HDMI_CEC_CTRL_BC_NACK(x) (HW_HDMI_CEC_CTRL(x).B.BC_NACK)

/*! @brief Format value for bitfield HDMI_CEC_CTRL_BC_NACK. */
#define BF_HDMI_CEC_CTRL_BC_NACK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_CTRL_BC_NACK) & BM_HDMI_CEC_CTRL_BC_NACK)

/*! @brief Set the BC_NACK field to a new value. */
#define BW_HDMI_CEC_CTRL_BC_NACK(x, v) (HW_HDMI_CEC_CTRL_WR(x, (HW_HDMI_CEC_CTRL_RD(x) & ~BM_HDMI_CEC_CTRL_BC_NACK) | BF_HDMI_CEC_CTRL_BC_NACK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_CTRL, field STANDBY[4] (RW)
 *
 * Standby bit
 *
 * Values:
 * - 0 - CEC controller responds the ACK to all messages.
 * - 1 - CEC controller responds with ACK to all ping messages (only when the
 *     EOM is received) and responds with NACK to all other messages, generating
 *     wake-up status for selected opcodes. Attention that the NACK will only be
 *     posted on the last block of a frame.
 */
/*@{*/
#define BP_HDMI_CEC_CTRL_STANDBY (4U)      /*!< Bit position for HDMI_CEC_CTRL_STANDBY. */
#define BM_HDMI_CEC_CTRL_STANDBY (0x10U)   /*!< Bit mask for HDMI_CEC_CTRL_STANDBY. */
#define BS_HDMI_CEC_CTRL_STANDBY (1U)      /*!< Bit field size in bits for HDMI_CEC_CTRL_STANDBY. */

/*! @brief Read current value of the HDMI_CEC_CTRL_STANDBY field. */
#define BR_HDMI_CEC_CTRL_STANDBY(x) (HW_HDMI_CEC_CTRL(x).B.STANDBY)

/*! @brief Format value for bitfield HDMI_CEC_CTRL_STANDBY. */
#define BF_HDMI_CEC_CTRL_STANDBY(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_CTRL_STANDBY) & BM_HDMI_CEC_CTRL_STANDBY)

/*! @brief Set the STANDBY field to a new value. */
#define BW_HDMI_CEC_CTRL_STANDBY(x, v) (HW_HDMI_CEC_CTRL_WR(x, (HW_HDMI_CEC_CTRL_RD(x) & ~BM_HDMI_CEC_CTRL_STANDBY) | BF_HDMI_CEC_CTRL_STANDBY(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_STAT - CEC_STAT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_STAT - CEC_STAT (RO)
 *
 * Reset value: 0x00U
 *
 * This register indicates the status of CEC line. All bits are read only. When
 * an event occurs, the corresponding bit will set to 1 for one SFR clock cycle
 * only. Then, the bit automatically resets to 0. No software reset is required.
 * Software can read the "stable" interrupts on IH_CEC_STAT0 register (this
 * register has the same bit arrangement as CEC_STAT register). Address Offset: 0x7D01
 * Size: 8 bits Value after Reset: N/A Access: Read
 */
typedef union _hw_hdmi_cec_stat
{
    uint8_t U;
    struct _hw_hdmi_cec_stat_bitfields
    {
        uint8_t DONE : 1;              /*!< [0]  */
        uint8_t EOM : 1;               /*!< [1]  */
        uint8_t NACK : 1;              /*!< [2]  */
        uint8_t ARB_LOST : 1;          /*!< [3]  */
        uint8_t ERROR_INIT : 1;        /*!< [4]  */
        uint8_t ERROR_FOLL : 1;        /*!< [5]  */
        uint8_t WAKEUP : 1;            /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_cec_stat_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_STAT register
 */
/*@{*/
#define HW_HDMI_CEC_STAT_ADDR(x) ((uintptr_t)(x) + 0x7D01U)

#define HW_HDMI_CEC_STAT(x)      (*(__I hw_hdmi_cec_stat_t *) HW_HDMI_CEC_STAT_ADDR(x))
#define HW_HDMI_CEC_STAT_RD(x)   (HW_HDMI_CEC_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_STAT bitfields
 */

/*!
 * @name Register HDMI_CEC_STAT, field DONE[0] (RO)
 *
 * The current transmission is successful (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_DONE (0U)         /*!< Bit position for HDMI_CEC_STAT_DONE. */
#define BM_HDMI_CEC_STAT_DONE (0x01U)      /*!< Bit mask for HDMI_CEC_STAT_DONE. */
#define BS_HDMI_CEC_STAT_DONE (1U)         /*!< Bit field size in bits for HDMI_CEC_STAT_DONE. */

/*! @brief Read current value of the HDMI_CEC_STAT_DONE field. */
#define BR_HDMI_CEC_STAT_DONE(x) (HW_HDMI_CEC_STAT(x).B.DONE)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field EOM[1] (RO)
 *
 * EOM is detected so that the received data is ready in the receiver data
 * buffer (for follower only).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_EOM (1U)          /*!< Bit position for HDMI_CEC_STAT_EOM. */
#define BM_HDMI_CEC_STAT_EOM (0x02U)       /*!< Bit mask for HDMI_CEC_STAT_EOM. */
#define BS_HDMI_CEC_STAT_EOM (1U)          /*!< Bit field size in bits for HDMI_CEC_STAT_EOM. */

/*! @brief Read current value of the HDMI_CEC_STAT_EOM field. */
#define BR_HDMI_CEC_STAT_EOM(x) (HW_HDMI_CEC_STAT(x).B.EOM)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field NACK[2] (RO)
 *
 * A frame is not acknowledged in a directly addressed message. Or a frame is
 * negatively acknowledged in a broadcast message (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_NACK (2U)         /*!< Bit position for HDMI_CEC_STAT_NACK. */
#define BM_HDMI_CEC_STAT_NACK (0x04U)      /*!< Bit mask for HDMI_CEC_STAT_NACK. */
#define BS_HDMI_CEC_STAT_NACK (1U)         /*!< Bit field size in bits for HDMI_CEC_STAT_NACK. */

/*! @brief Read current value of the HDMI_CEC_STAT_NACK field. */
#define BR_HDMI_CEC_STAT_NACK(x) (HW_HDMI_CEC_STAT(x).B.NACK)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field ARB_LOST[3] (RO)
 *
 * The initiator losses the CEC line arbitration to a second initiator.
 * (specification CEC 9).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_ARB_LOST (3U)     /*!< Bit position for HDMI_CEC_STAT_ARB_LOST. */
#define BM_HDMI_CEC_STAT_ARB_LOST (0x08U)  /*!< Bit mask for HDMI_CEC_STAT_ARB_LOST. */
#define BS_HDMI_CEC_STAT_ARB_LOST (1U)     /*!< Bit field size in bits for HDMI_CEC_STAT_ARB_LOST. */

/*! @brief Read current value of the HDMI_CEC_STAT_ARB_LOST field. */
#define BR_HDMI_CEC_STAT_ARB_LOST(x) (HW_HDMI_CEC_STAT(x).B.ARB_LOST)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field ERROR_INIT[4] (RO)
 *
 * An error is detected on cec line (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_ERROR_INIT (4U)   /*!< Bit position for HDMI_CEC_STAT_ERROR_INIT. */
#define BM_HDMI_CEC_STAT_ERROR_INIT (0x10U) /*!< Bit mask for HDMI_CEC_STAT_ERROR_INIT. */
#define BS_HDMI_CEC_STAT_ERROR_INIT (1U)   /*!< Bit field size in bits for HDMI_CEC_STAT_ERROR_INIT. */

/*! @brief Read current value of the HDMI_CEC_STAT_ERROR_INIT field. */
#define BR_HDMI_CEC_STAT_ERROR_INIT(x) (HW_HDMI_CEC_STAT(x).B.ERROR_INIT)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field ERROR_FOLL[5] (RO)
 *
 * An error is notified by a follower. Abnormal logic data bit error (for
 * follower).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_ERROR_FOLL (5U)   /*!< Bit position for HDMI_CEC_STAT_ERROR_FOLL. */
#define BM_HDMI_CEC_STAT_ERROR_FOLL (0x20U) /*!< Bit mask for HDMI_CEC_STAT_ERROR_FOLL. */
#define BS_HDMI_CEC_STAT_ERROR_FOLL (1U)   /*!< Bit field size in bits for HDMI_CEC_STAT_ERROR_FOLL. */

/*! @brief Read current value of the HDMI_CEC_STAT_ERROR_FOLL field. */
#define BR_HDMI_CEC_STAT_ERROR_FOLL(x) (HW_HDMI_CEC_STAT(x).B.ERROR_FOLL)
/*@}*/

/*!
 * @name Register HDMI_CEC_STAT, field WAKEUP[6] (RO)
 *
 * Follower received wake-up command (for follower only).
 */
/*@{*/
#define BP_HDMI_CEC_STAT_WAKEUP (6U)       /*!< Bit position for HDMI_CEC_STAT_WAKEUP. */
#define BM_HDMI_CEC_STAT_WAKEUP (0x40U)    /*!< Bit mask for HDMI_CEC_STAT_WAKEUP. */
#define BS_HDMI_CEC_STAT_WAKEUP (1U)       /*!< Bit field size in bits for HDMI_CEC_STAT_WAKEUP. */

/*! @brief Read current value of the HDMI_CEC_STAT_WAKEUP field. */
#define BR_HDMI_CEC_STAT_WAKEUP(x) (HW_HDMI_CEC_STAT(x).B.WAKEUP)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_MASK - CEC_MASK
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_MASK - CEC_MASK (RW)
 *
 * Reset value: 0x00U
 *
 * This read/write register masks/unmasks the interrupt events. When the bit is
 * set to 1 (masked), the corresponding event will not trigger an interrupt
 * signal at the system interface. When the bit is reset to 0, the interrupt event is
 * unmasked. Address Offset: 0x7D02 Size: 8 bits Value after Reset: 0x00 Access:
 * Read/Write
 */
typedef union _hw_hdmi_cec_mask
{
    uint8_t U;
    struct _hw_hdmi_cec_mask_bitfields
    {
        uint8_t DONE_MASK : 1;         /*!< [0]  */
        uint8_t EOM_MASK : 1;          /*!< [1]  */
        uint8_t NACK_MASK : 1;         /*!< [2]  */
        uint8_t ARB_LOST_MASK : 1;     /*!< [3]  */
        uint8_t ERROR_INIT_MASK : 1;   /*!< [4]  */
        uint8_t ERROR_FOLL_MASK : 1;   /*!< [5]  */
        uint8_t WAKEUP_MASK : 1;       /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_cec_mask_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_MASK register
 */
/*@{*/
#define HW_HDMI_CEC_MASK_ADDR(x) ((uintptr_t)(x) + 0x7D02U)

#define HW_HDMI_CEC_MASK(x)      (*(__IO hw_hdmi_cec_mask_t *) HW_HDMI_CEC_MASK_ADDR(x))
#define HW_HDMI_CEC_MASK_RD(x)   (HW_HDMI_CEC_MASK(x).U)
#define HW_HDMI_CEC_MASK_WR(x, v) (HW_HDMI_CEC_MASK(x).U = (v))
#define HW_HDMI_CEC_MASK_SET(x, v) (HW_HDMI_CEC_MASK_WR(x, HW_HDMI_CEC_MASK_RD(x) |  (v)))
#define HW_HDMI_CEC_MASK_CLR(x, v) (HW_HDMI_CEC_MASK_WR(x, HW_HDMI_CEC_MASK_RD(x) & ~(v)))
#define HW_HDMI_CEC_MASK_TOG(x, v) (HW_HDMI_CEC_MASK_WR(x, HW_HDMI_CEC_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_MASK bitfields
 */

/*!
 * @name Register HDMI_CEC_MASK, field DONE_MASK[0] (RW)
 *
 * The current transmission is successful (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_DONE_MASK (0U)    /*!< Bit position for HDMI_CEC_MASK_DONE_MASK. */
#define BM_HDMI_CEC_MASK_DONE_MASK (0x01U) /*!< Bit mask for HDMI_CEC_MASK_DONE_MASK. */
#define BS_HDMI_CEC_MASK_DONE_MASK (1U)    /*!< Bit field size in bits for HDMI_CEC_MASK_DONE_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_DONE_MASK field. */
#define BR_HDMI_CEC_MASK_DONE_MASK(x) (HW_HDMI_CEC_MASK(x).B.DONE_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_DONE_MASK. */
#define BF_HDMI_CEC_MASK_DONE_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_DONE_MASK) & BM_HDMI_CEC_MASK_DONE_MASK)

/*! @brief Set the DONE_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_DONE_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_DONE_MASK) | BF_HDMI_CEC_MASK_DONE_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field EOM_MASK[1] (RW)
 *
 * EOM is detected so that the received data is ready in the receiver data
 * buffer (for follower only).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_EOM_MASK (1U)     /*!< Bit position for HDMI_CEC_MASK_EOM_MASK. */
#define BM_HDMI_CEC_MASK_EOM_MASK (0x02U)  /*!< Bit mask for HDMI_CEC_MASK_EOM_MASK. */
#define BS_HDMI_CEC_MASK_EOM_MASK (1U)     /*!< Bit field size in bits for HDMI_CEC_MASK_EOM_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_EOM_MASK field. */
#define BR_HDMI_CEC_MASK_EOM_MASK(x) (HW_HDMI_CEC_MASK(x).B.EOM_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_EOM_MASK. */
#define BF_HDMI_CEC_MASK_EOM_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_EOM_MASK) & BM_HDMI_CEC_MASK_EOM_MASK)

/*! @brief Set the EOM_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_EOM_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_EOM_MASK) | BF_HDMI_CEC_MASK_EOM_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field NACK_MASK[2] (RW)
 *
 * A frame is not acknowledged in a directly addressed message. Or a frame is
 * negatively acknowledged in a broadcast message (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_NACK_MASK (2U)    /*!< Bit position for HDMI_CEC_MASK_NACK_MASK. */
#define BM_HDMI_CEC_MASK_NACK_MASK (0x04U) /*!< Bit mask for HDMI_CEC_MASK_NACK_MASK. */
#define BS_HDMI_CEC_MASK_NACK_MASK (1U)    /*!< Bit field size in bits for HDMI_CEC_MASK_NACK_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_NACK_MASK field. */
#define BR_HDMI_CEC_MASK_NACK_MASK(x) (HW_HDMI_CEC_MASK(x).B.NACK_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_NACK_MASK. */
#define BF_HDMI_CEC_MASK_NACK_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_NACK_MASK) & BM_HDMI_CEC_MASK_NACK_MASK)

/*! @brief Set the NACK_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_NACK_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_NACK_MASK) | BF_HDMI_CEC_MASK_NACK_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field ARB_LOST_MASK[3] (RW)
 *
 * The initiator losses the CEC line arbitration to a second initiator.
 * (specification CEC 9).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_ARB_LOST_MASK (3U) /*!< Bit position for HDMI_CEC_MASK_ARB_LOST_MASK. */
#define BM_HDMI_CEC_MASK_ARB_LOST_MASK (0x08U) /*!< Bit mask for HDMI_CEC_MASK_ARB_LOST_MASK. */
#define BS_HDMI_CEC_MASK_ARB_LOST_MASK (1U) /*!< Bit field size in bits for HDMI_CEC_MASK_ARB_LOST_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_ARB_LOST_MASK field. */
#define BR_HDMI_CEC_MASK_ARB_LOST_MASK(x) (HW_HDMI_CEC_MASK(x).B.ARB_LOST_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_ARB_LOST_MASK. */
#define BF_HDMI_CEC_MASK_ARB_LOST_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_ARB_LOST_MASK) & BM_HDMI_CEC_MASK_ARB_LOST_MASK)

/*! @brief Set the ARB_LOST_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_ARB_LOST_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_ARB_LOST_MASK) | BF_HDMI_CEC_MASK_ARB_LOST_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field ERROR_INIT_MASK[4] (RW)
 *
 * An error is detected on cec line (for initiator only).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_ERROR_INIT_MASK (4U) /*!< Bit position for HDMI_CEC_MASK_ERROR_INIT_MASK. */
#define BM_HDMI_CEC_MASK_ERROR_INIT_MASK (0x10U) /*!< Bit mask for HDMI_CEC_MASK_ERROR_INIT_MASK. */
#define BS_HDMI_CEC_MASK_ERROR_INIT_MASK (1U) /*!< Bit field size in bits for HDMI_CEC_MASK_ERROR_INIT_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_ERROR_INIT_MASK field. */
#define BR_HDMI_CEC_MASK_ERROR_INIT_MASK(x) (HW_HDMI_CEC_MASK(x).B.ERROR_INIT_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_ERROR_INIT_MASK. */
#define BF_HDMI_CEC_MASK_ERROR_INIT_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_ERROR_INIT_MASK) & BM_HDMI_CEC_MASK_ERROR_INIT_MASK)

/*! @brief Set the ERROR_INIT_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_ERROR_INIT_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_ERROR_INIT_MASK) | BF_HDMI_CEC_MASK_ERROR_INIT_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field ERROR_FOLL_MASK[5] (RW)
 *
 * An error is notified by a follower. Abnormal logic data bit error (for
 * follower).
 */
/*@{*/
#define BP_HDMI_CEC_MASK_ERROR_FOLL_MASK (5U) /*!< Bit position for HDMI_CEC_MASK_ERROR_FOLL_MASK. */
#define BM_HDMI_CEC_MASK_ERROR_FOLL_MASK (0x20U) /*!< Bit mask for HDMI_CEC_MASK_ERROR_FOLL_MASK. */
#define BS_HDMI_CEC_MASK_ERROR_FOLL_MASK (1U) /*!< Bit field size in bits for HDMI_CEC_MASK_ERROR_FOLL_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_ERROR_FOLL_MASK field. */
#define BR_HDMI_CEC_MASK_ERROR_FOLL_MASK(x) (HW_HDMI_CEC_MASK(x).B.ERROR_FOLL_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_ERROR_FOLL_MASK. */
#define BF_HDMI_CEC_MASK_ERROR_FOLL_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_ERROR_FOLL_MASK) & BM_HDMI_CEC_MASK_ERROR_FOLL_MASK)

/*! @brief Set the ERROR_FOLL_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_ERROR_FOLL_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_ERROR_FOLL_MASK) | BF_HDMI_CEC_MASK_ERROR_FOLL_MASK(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_MASK, field WAKEUP_MASK[6] (RW)
 *
 * Follower wake-up signal mask
 */
/*@{*/
#define BP_HDMI_CEC_MASK_WAKEUP_MASK (6U)  /*!< Bit position for HDMI_CEC_MASK_WAKEUP_MASK. */
#define BM_HDMI_CEC_MASK_WAKEUP_MASK (0x40U) /*!< Bit mask for HDMI_CEC_MASK_WAKEUP_MASK. */
#define BS_HDMI_CEC_MASK_WAKEUP_MASK (1U)  /*!< Bit field size in bits for HDMI_CEC_MASK_WAKEUP_MASK. */

/*! @brief Read current value of the HDMI_CEC_MASK_WAKEUP_MASK field. */
#define BR_HDMI_CEC_MASK_WAKEUP_MASK(x) (HW_HDMI_CEC_MASK(x).B.WAKEUP_MASK)

/*! @brief Format value for bitfield HDMI_CEC_MASK_WAKEUP_MASK. */
#define BF_HDMI_CEC_MASK_WAKEUP_MASK(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_MASK_WAKEUP_MASK) & BM_HDMI_CEC_MASK_WAKEUP_MASK)

/*! @brief Set the WAKEUP_MASK field to a new value. */
#define BW_HDMI_CEC_MASK_WAKEUP_MASK(x, v) (HW_HDMI_CEC_MASK_WR(x, (HW_HDMI_CEC_MASK_RD(x) & ~BM_HDMI_CEC_MASK_WAKEUP_MASK) | BF_HDMI_CEC_MASK_WAKEUP_MASK(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_POLARITY - CEC_POLARITY
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_POLARITY - CEC_POLARITY (RW)
 *
 * Reset value: 0x7FU
 *
 * This register is readable and writable, which controls the polarity of the
 * interrupt status register as well as the polarity of the interrupt signals at
 * system interface. Address Offset: 0x7D03 Size: 8 bits Value after Reset: 0x7F
 * Access: Read/Write
 */
typedef union _hw_hdmi_cec_polarity
{
    uint8_t U;
    struct _hw_hdmi_cec_polarity_bitfields
    {
        uint8_t DONE_POL : 1;          /*!< [0]  */
        uint8_t EOM_POL : 1;           /*!< [1]  */
        uint8_t NACK_POL : 1;          /*!< [2]  */
        uint8_t ARB_LOST_POL : 1;      /*!< [3]  */
        uint8_t ERROR_INIT_POL : 1;    /*!< [4]  */
        uint8_t ERROR_FOLL_POL : 1;    /*!< [5]  */
        uint8_t WAKEUP_POL : 1;        /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_cec_polarity_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_POLARITY register
 */
/*@{*/
#define HW_HDMI_CEC_POLARITY_ADDR(x) ((uintptr_t)(x) + 0x7D03U)

#define HW_HDMI_CEC_POLARITY(x)  (*(__IO hw_hdmi_cec_polarity_t *) HW_HDMI_CEC_POLARITY_ADDR(x))
#define HW_HDMI_CEC_POLARITY_RD(x) (HW_HDMI_CEC_POLARITY(x).U)
#define HW_HDMI_CEC_POLARITY_WR(x, v) (HW_HDMI_CEC_POLARITY(x).U = (v))
#define HW_HDMI_CEC_POLARITY_SET(x, v) (HW_HDMI_CEC_POLARITY_WR(x, HW_HDMI_CEC_POLARITY_RD(x) |  (v)))
#define HW_HDMI_CEC_POLARITY_CLR(x, v) (HW_HDMI_CEC_POLARITY_WR(x, HW_HDMI_CEC_POLARITY_RD(x) & ~(v)))
#define HW_HDMI_CEC_POLARITY_TOG(x, v) (HW_HDMI_CEC_POLARITY_WR(x, HW_HDMI_CEC_POLARITY_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_POLARITY bitfields
 */

/*!
 * @name Register HDMI_CEC_POLARITY, field DONE_POL[0] (RW)
 *
 * Current transmission success or not signal polarity
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_DONE_POL (0U) /*!< Bit position for HDMI_CEC_POLARITY_DONE_POL. */
#define BM_HDMI_CEC_POLARITY_DONE_POL (0x01U) /*!< Bit mask for HDMI_CEC_POLARITY_DONE_POL. */
#define BS_HDMI_CEC_POLARITY_DONE_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_DONE_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_DONE_POL field. */
#define BR_HDMI_CEC_POLARITY_DONE_POL(x) (HW_HDMI_CEC_POLARITY(x).B.DONE_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_DONE_POL. */
#define BF_HDMI_CEC_POLARITY_DONE_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_DONE_POL) & BM_HDMI_CEC_POLARITY_DONE_POL)

/*! @brief Set the DONE_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_DONE_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_DONE_POL) | BF_HDMI_CEC_POLARITY_DONE_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field EOM_POL[1] (RW)
 *
 * EOM detect signal polarity (follower only)
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_EOM_POL (1U)  /*!< Bit position for HDMI_CEC_POLARITY_EOM_POL. */
#define BM_HDMI_CEC_POLARITY_EOM_POL (0x02U) /*!< Bit mask for HDMI_CEC_POLARITY_EOM_POL. */
#define BS_HDMI_CEC_POLARITY_EOM_POL (1U)  /*!< Bit field size in bits for HDMI_CEC_POLARITY_EOM_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_EOM_POL field. */
#define BR_HDMI_CEC_POLARITY_EOM_POL(x) (HW_HDMI_CEC_POLARITY(x).B.EOM_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_EOM_POL. */
#define BF_HDMI_CEC_POLARITY_EOM_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_EOM_POL) & BM_HDMI_CEC_POLARITY_EOM_POL)

/*! @brief Set the EOM_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_EOM_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_EOM_POL) | BF_HDMI_CEC_POLARITY_EOM_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field NACK_POL[2] (RW)
 *
 * Frame NACK signal polarity
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_NACK_POL (2U) /*!< Bit position for HDMI_CEC_POLARITY_NACK_POL. */
#define BM_HDMI_CEC_POLARITY_NACK_POL (0x04U) /*!< Bit mask for HDMI_CEC_POLARITY_NACK_POL. */
#define BS_HDMI_CEC_POLARITY_NACK_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_NACK_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_NACK_POL field. */
#define BR_HDMI_CEC_POLARITY_NACK_POL(x) (HW_HDMI_CEC_POLARITY(x).B.NACK_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_NACK_POL. */
#define BF_HDMI_CEC_POLARITY_NACK_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_NACK_POL) & BM_HDMI_CEC_POLARITY_NACK_POL)

/*! @brief Set the NACK_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_NACK_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_NACK_POL) | BF_HDMI_CEC_POLARITY_NACK_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field ARB_LOST_POL[3] (RW)
 *
 * Initiator Arbitration lost signal polarity
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_ARB_LOST_POL (3U) /*!< Bit position for HDMI_CEC_POLARITY_ARB_LOST_POL. */
#define BM_HDMI_CEC_POLARITY_ARB_LOST_POL (0x08U) /*!< Bit mask for HDMI_CEC_POLARITY_ARB_LOST_POL. */
#define BS_HDMI_CEC_POLARITY_ARB_LOST_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_ARB_LOST_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_ARB_LOST_POL field. */
#define BR_HDMI_CEC_POLARITY_ARB_LOST_POL(x) (HW_HDMI_CEC_POLARITY(x).B.ARB_LOST_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_ARB_LOST_POL. */
#define BF_HDMI_CEC_POLARITY_ARB_LOST_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_ARB_LOST_POL) & BM_HDMI_CEC_POLARITY_ARB_LOST_POL)

/*! @brief Set the ARB_LOST_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_ARB_LOST_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_ARB_LOST_POL) | BF_HDMI_CEC_POLARITY_ARB_LOST_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field ERROR_INIT_POL[4] (RW)
 *
 * CEC line error polarity (for initiator only)
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_ERROR_INIT_POL (4U) /*!< Bit position for HDMI_CEC_POLARITY_ERROR_INIT_POL. */
#define BM_HDMI_CEC_POLARITY_ERROR_INIT_POL (0x10U) /*!< Bit mask for HDMI_CEC_POLARITY_ERROR_INIT_POL. */
#define BS_HDMI_CEC_POLARITY_ERROR_INIT_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_ERROR_INIT_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_ERROR_INIT_POL field. */
#define BR_HDMI_CEC_POLARITY_ERROR_INIT_POL(x) (HW_HDMI_CEC_POLARITY(x).B.ERROR_INIT_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_ERROR_INIT_POL. */
#define BF_HDMI_CEC_POLARITY_ERROR_INIT_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_ERROR_INIT_POL) & BM_HDMI_CEC_POLARITY_ERROR_INIT_POL)

/*! @brief Set the ERROR_INIT_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_ERROR_INIT_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_ERROR_INIT_POL) | BF_HDMI_CEC_POLARITY_ERROR_INIT_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field ERROR_FOLL_POL[5] (RW)
 *
 * CEC line error polarity (for follower only)
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_ERROR_FOLL_POL (5U) /*!< Bit position for HDMI_CEC_POLARITY_ERROR_FOLL_POL. */
#define BM_HDMI_CEC_POLARITY_ERROR_FOLL_POL (0x20U) /*!< Bit mask for HDMI_CEC_POLARITY_ERROR_FOLL_POL. */
#define BS_HDMI_CEC_POLARITY_ERROR_FOLL_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_ERROR_FOLL_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_ERROR_FOLL_POL field. */
#define BR_HDMI_CEC_POLARITY_ERROR_FOLL_POL(x) (HW_HDMI_CEC_POLARITY(x).B.ERROR_FOLL_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_ERROR_FOLL_POL. */
#define BF_HDMI_CEC_POLARITY_ERROR_FOLL_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_ERROR_FOLL_POL) & BM_HDMI_CEC_POLARITY_ERROR_FOLL_POL)

/*! @brief Set the ERROR_FOLL_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_ERROR_FOLL_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_ERROR_FOLL_POL) | BF_HDMI_CEC_POLARITY_ERROR_FOLL_POL(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_POLARITY, field WAKEUP_POL[6] (RW)
 *
 * Follower wakeup signal polarity
 */
/*@{*/
#define BP_HDMI_CEC_POLARITY_WAKEUP_POL (6U) /*!< Bit position for HDMI_CEC_POLARITY_WAKEUP_POL. */
#define BM_HDMI_CEC_POLARITY_WAKEUP_POL (0x40U) /*!< Bit mask for HDMI_CEC_POLARITY_WAKEUP_POL. */
#define BS_HDMI_CEC_POLARITY_WAKEUP_POL (1U) /*!< Bit field size in bits for HDMI_CEC_POLARITY_WAKEUP_POL. */

/*! @brief Read current value of the HDMI_CEC_POLARITY_WAKEUP_POL field. */
#define BR_HDMI_CEC_POLARITY_WAKEUP_POL(x) (HW_HDMI_CEC_POLARITY(x).B.WAKEUP_POL)

/*! @brief Format value for bitfield HDMI_CEC_POLARITY_WAKEUP_POL. */
#define BF_HDMI_CEC_POLARITY_WAKEUP_POL(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_POLARITY_WAKEUP_POL) & BM_HDMI_CEC_POLARITY_WAKEUP_POL)

/*! @brief Set the WAKEUP_POL field to a new value. */
#define BW_HDMI_CEC_POLARITY_WAKEUP_POL(x, v) (HW_HDMI_CEC_POLARITY_WR(x, (HW_HDMI_CEC_POLARITY_RD(x) & ~BM_HDMI_CEC_POLARITY_WAKEUP_POL) | BF_HDMI_CEC_POLARITY_WAKEUP_POL(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_INT - CEC_INT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_INT - CEC_INT (RO)
 *
 * Reset value: 0x00U
 *
 * This register is read only. Each bit of the register is output at the system
 * interface. The output signals hold the active interrupt state (high or low)
 * for only one SFR clock cycle. Then the hardware resets the bit to an inactive
 * state. Software can read the "stable" interrupts on the IH_CEC_STAT0 register at
 * address 0x0106 (this register has the same bit arrangement as the CEC_STAT
 * register). The functional formula for the interrupts is: CEC_INT = (CEC_MASK ==
 * 0b) && (CEC_STATUS == CEC_POLARITY) Address Offset: 0x7D04 Size: 8 bits Value
 * after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_cec_int
{
    uint8_t U;
    struct _hw_hdmi_cec_int_bitfields
    {
        uint8_t DONE_INT : 1;          /*!< [0]  */
        uint8_t EOM_INT : 1;           /*!< [1]  */
        uint8_t NACK_INT : 1;          /*!< [2]  */
        uint8_t ARB_LOST_INT : 1;      /*!< [3]  */
        uint8_t ERROR_INIT_INT : 1;    /*!< [4]  */
        uint8_t ERROR_FOLL_INT : 1;    /*!< [5]  */
        uint8_t WAKEUP_INT : 1;        /*!< [6]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_cec_int_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_INT register
 */
/*@{*/
#define HW_HDMI_CEC_INT_ADDR(x)  ((uintptr_t)(x) + 0x7D04U)

#define HW_HDMI_CEC_INT(x)       (*(__I hw_hdmi_cec_int_t *) HW_HDMI_CEC_INT_ADDR(x))
#define HW_HDMI_CEC_INT_RD(x)    (HW_HDMI_CEC_INT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_INT bitfields
 */

/*!
 * @name Register HDMI_CEC_INT, field DONE_INT[0] (RO)
 *
 * EOM detect interrupt (for follower only)
 */
/*@{*/
#define BP_HDMI_CEC_INT_DONE_INT (0U)      /*!< Bit position for HDMI_CEC_INT_DONE_INT. */
#define BM_HDMI_CEC_INT_DONE_INT (0x01U)   /*!< Bit mask for HDMI_CEC_INT_DONE_INT. */
#define BS_HDMI_CEC_INT_DONE_INT (1U)      /*!< Bit field size in bits for HDMI_CEC_INT_DONE_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_DONE_INT field. */
#define BR_HDMI_CEC_INT_DONE_INT(x) (HW_HDMI_CEC_INT(x).B.DONE_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field EOM_INT[1] (RO)
 *
 * Frame NACK interrupt
 */
/*@{*/
#define BP_HDMI_CEC_INT_EOM_INT (1U)       /*!< Bit position for HDMI_CEC_INT_EOM_INT. */
#define BM_HDMI_CEC_INT_EOM_INT (0x02U)    /*!< Bit mask for HDMI_CEC_INT_EOM_INT. */
#define BS_HDMI_CEC_INT_EOM_INT (1U)       /*!< Bit field size in bits for HDMI_CEC_INT_EOM_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_EOM_INT field. */
#define BR_HDMI_CEC_INT_EOM_INT(x) (HW_HDMI_CEC_INT(x).B.EOM_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field NACK_INT[2] (RO)
 *
 * Initiator Arbitration lost interrupt
 */
/*@{*/
#define BP_HDMI_CEC_INT_NACK_INT (2U)      /*!< Bit position for HDMI_CEC_INT_NACK_INT. */
#define BM_HDMI_CEC_INT_NACK_INT (0x04U)   /*!< Bit mask for HDMI_CEC_INT_NACK_INT. */
#define BS_HDMI_CEC_INT_NACK_INT (1U)      /*!< Bit field size in bits for HDMI_CEC_INT_NACK_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_NACK_INT field. */
#define BR_HDMI_CEC_INT_NACK_INT(x) (HW_HDMI_CEC_INT(x).B.NACK_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field ARB_LOST_INT[3] (RO)
 *
 * CEC line error interrupt (for initiator only)
 */
/*@{*/
#define BP_HDMI_CEC_INT_ARB_LOST_INT (3U)  /*!< Bit position for HDMI_CEC_INT_ARB_LOST_INT. */
#define BM_HDMI_CEC_INT_ARB_LOST_INT (0x08U) /*!< Bit mask for HDMI_CEC_INT_ARB_LOST_INT. */
#define BS_HDMI_CEC_INT_ARB_LOST_INT (1U)  /*!< Bit field size in bits for HDMI_CEC_INT_ARB_LOST_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_ARB_LOST_INT field. */
#define BR_HDMI_CEC_INT_ARB_LOST_INT(x) (HW_HDMI_CEC_INT(x).B.ARB_LOST_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field ERROR_INIT_INT[4] (RO)
 *
 * CEC line error interrupt (for follower only)
 */
/*@{*/
#define BP_HDMI_CEC_INT_ERROR_INIT_INT (4U) /*!< Bit position for HDMI_CEC_INT_ERROR_INIT_INT. */
#define BM_HDMI_CEC_INT_ERROR_INIT_INT (0x10U) /*!< Bit mask for HDMI_CEC_INT_ERROR_INIT_INT. */
#define BS_HDMI_CEC_INT_ERROR_INIT_INT (1U) /*!< Bit field size in bits for HDMI_CEC_INT_ERROR_INIT_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_ERROR_INIT_INT field. */
#define BR_HDMI_CEC_INT_ERROR_INIT_INT(x) (HW_HDMI_CEC_INT(x).B.ERROR_INIT_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field ERROR_FOLL_INT[5] (RO)
 *
 * Follower wakeup interrupt
 */
/*@{*/
#define BP_HDMI_CEC_INT_ERROR_FOLL_INT (5U) /*!< Bit position for HDMI_CEC_INT_ERROR_FOLL_INT. */
#define BM_HDMI_CEC_INT_ERROR_FOLL_INT (0x20U) /*!< Bit mask for HDMI_CEC_INT_ERROR_FOLL_INT. */
#define BS_HDMI_CEC_INT_ERROR_FOLL_INT (1U) /*!< Bit field size in bits for HDMI_CEC_INT_ERROR_FOLL_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_ERROR_FOLL_INT field. */
#define BR_HDMI_CEC_INT_ERROR_FOLL_INT(x) (HW_HDMI_CEC_INT(x).B.ERROR_FOLL_INT)
/*@}*/

/*!
 * @name Register HDMI_CEC_INT, field WAKEUP_INT[6] (RO)
 *
 * Follower wakeup signal polarity
 */
/*@{*/
#define BP_HDMI_CEC_INT_WAKEUP_INT (6U)    /*!< Bit position for HDMI_CEC_INT_WAKEUP_INT. */
#define BM_HDMI_CEC_INT_WAKEUP_INT (0x40U) /*!< Bit mask for HDMI_CEC_INT_WAKEUP_INT. */
#define BS_HDMI_CEC_INT_WAKEUP_INT (1U)    /*!< Bit field size in bits for HDMI_CEC_INT_WAKEUP_INT. */

/*! @brief Read current value of the HDMI_CEC_INT_WAKEUP_INT field. */
#define BR_HDMI_CEC_INT_WAKEUP_INT(x) (HW_HDMI_CEC_INT(x).B.WAKEUP_INT)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_ADDR_L - CEC_ADDR_L
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_ADDR_L - CEC_ADDR_L (RW)
 *
 * Reset value: 0x00U
 *
 * CEC_ADDR_L and CEC_ADDR_H registers indicate the logical address(es)
 * allocated to the CEC device. The logical address mappings are shown in
 * CEC_ADDR_LCEC_ADDR_L and CEC_ADDR_HCEC_ADDR_H . This register is written by software when the
 * logical allocation is finished. Bit value 1 means the corresponding logical
 * address is allocated to this device. Bit value 0 means the corresponding
 * logical address is not allocated to this device. Address Offset: 0x7D05 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_cec_addr_l
{
    uint8_t U;
    struct _hw_hdmi_cec_addr_l_bitfields
    {
        uint8_t CEC_ADDR_L0 : 1;       /*!< [0]  */
        uint8_t CEC_ADDR_L1 : 1;       /*!< [1]  */
        uint8_t CEC_ADDR_L2 : 1;       /*!< [2]  */
        uint8_t CEC_ADDR_L3 : 1;       /*!< [3]  */
        uint8_t CEC_ADDR_L4 : 1;       /*!< [4]  */
        uint8_t CEC_ADDR_L5 : 1;       /*!< [5]  */
        uint8_t CEC_ADDR_L6 : 1;       /*!< [6]  */
        uint8_t CEC_ADDR_L7 : 1;       /*!< [7]  */
    } B;
} hw_hdmi_cec_addr_l_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_ADDR_L register
 */
/*@{*/
#define HW_HDMI_CEC_ADDR_L_ADDR(x) ((uintptr_t)(x) + 0x7D05U)

#define HW_HDMI_CEC_ADDR_L(x)    (*(__IO hw_hdmi_cec_addr_l_t *) HW_HDMI_CEC_ADDR_L_ADDR(x))
#define HW_HDMI_CEC_ADDR_L_RD(x) (HW_HDMI_CEC_ADDR_L(x).U)
#define HW_HDMI_CEC_ADDR_L_WR(x, v) (HW_HDMI_CEC_ADDR_L(x).U = (v))
#define HW_HDMI_CEC_ADDR_L_SET(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, HW_HDMI_CEC_ADDR_L_RD(x) |  (v)))
#define HW_HDMI_CEC_ADDR_L_CLR(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, HW_HDMI_CEC_ADDR_L_RD(x) & ~(v)))
#define HW_HDMI_CEC_ADDR_L_TOG(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, HW_HDMI_CEC_ADDR_L_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_ADDR_L bitfields
 */

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L0[0] (RW)
 *
 * Logical address 0 - Device TV
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L0 (0U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L0. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L0 (0x01U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L0. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L0 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L0. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L0 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L0(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L0)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L0. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L0) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L0)

/*! @brief Set the CEC_ADDR_L0 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L0(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L0) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L0(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L1[1] (RW)
 *
 * Logical address 1 - Recording Device 1
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L1 (1U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L1. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L1 (0x02U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L1. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L1 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L1. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L1 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L1(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L1)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L1. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L1) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L1)

/*! @brief Set the CEC_ADDR_L1 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L1(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L1) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L1(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L2[2] (RW)
 *
 * Logical address 2 - Recording Device 2
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L2 (2U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L2. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L2 (0x04U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L2. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L2 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L2. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L2 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L2(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L2)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L2. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L2) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L2)

/*! @brief Set the CEC_ADDR_L2 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L2(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L2) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L2(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L3[3] (RW)
 *
 * Logical address 3 - Tuner 1
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L3 (3U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L3. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L3 (0x08U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L3. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L3 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L3. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L3 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L3(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L3)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L3. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L3) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L3)

/*! @brief Set the CEC_ADDR_L3 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L3(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L3) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L3(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L4[4] (RW)
 *
 * Logical address 4 - Playback Device 1
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L4 (4U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L4. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L4 (0x10U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L4. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L4 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L4. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L4 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L4(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L4)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L4. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L4) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L4)

/*! @brief Set the CEC_ADDR_L4 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L4(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L4) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L4(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L5[5] (RW)
 *
 * Logical address 5 - Audio System
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L5 (5U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L5. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L5 (0x20U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L5. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L5 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L5. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L5 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L5(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L5)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L5. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L5) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L5)

/*! @brief Set the CEC_ADDR_L5 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L5(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L5) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L5(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L6[6] (RW)
 *
 * Logical address 6 - Tuner 2
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L6 (6U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L6. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L6 (0x40U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L6. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L6 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L6. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L6 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L6(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L6)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L6. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L6) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L6)

/*! @brief Set the CEC_ADDR_L6 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L6(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L6) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L6(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_L, field CEC_ADDR_L7[7] (RW)
 *
 * Logical address 7 - Tuner 3
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_L_CEC_ADDR_L7 (7U) /*!< Bit position for HDMI_CEC_ADDR_L_CEC_ADDR_L7. */
#define BM_HDMI_CEC_ADDR_L_CEC_ADDR_L7 (0x80U) /*!< Bit mask for HDMI_CEC_ADDR_L_CEC_ADDR_L7. */
#define BS_HDMI_CEC_ADDR_L_CEC_ADDR_L7 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_L_CEC_ADDR_L7. */

/*! @brief Read current value of the HDMI_CEC_ADDR_L_CEC_ADDR_L7 field. */
#define BR_HDMI_CEC_ADDR_L_CEC_ADDR_L7(x) (HW_HDMI_CEC_ADDR_L(x).B.CEC_ADDR_L7)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_L_CEC_ADDR_L7. */
#define BF_HDMI_CEC_ADDR_L_CEC_ADDR_L7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_L_CEC_ADDR_L7) & BM_HDMI_CEC_ADDR_L_CEC_ADDR_L7)

/*! @brief Set the CEC_ADDR_L7 field to a new value. */
#define BW_HDMI_CEC_ADDR_L_CEC_ADDR_L7(x, v) (HW_HDMI_CEC_ADDR_L_WR(x, (HW_HDMI_CEC_ADDR_L_RD(x) & ~BM_HDMI_CEC_ADDR_L_CEC_ADDR_L7) | BF_HDMI_CEC_ADDR_L_CEC_ADDR_L7(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_ADDR_H - CEC_ADDR_H
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_ADDR_H - CEC_ADDR_H (RW)
 *
 * Reset value: 0x80U
 *
 * CEC_ADDR_L and CEC_ADDR_H registers indicate the logical address(es)
 * allocated to the CEC device. The logical address mappings are shown in
 * CEC_ADDR_LCEC_ADDR_L and CEC_ADDR_HCEC_ADDR_H . This register is written by software when the
 * logical allocation is finished. Bit value 1 means the corresponding logical
 * address is allocated to this device. Bit value 0 means the corresponding
 * logical address is not allocated to this device. Address Offset: 0x7D06 Size: 8 bits
 * Value after Reset: 0x80 Access: Read/Write
 */
typedef union _hw_hdmi_cec_addr_h
{
    uint8_t U;
    struct _hw_hdmi_cec_addr_h_bitfields
    {
        uint8_t CEC_ADDR_H0 : 1;       /*!< [0]  */
        uint8_t CEC_ADDR_H1 : 1;       /*!< [1]  */
        uint8_t CCEC_ADDR_H2 : 1;      /*!< [2]  */
        uint8_t CEC_ADDR_H3 : 1;       /*!< [3]  */
        uint8_t CEC_ADDR_H4 : 1;       /*!< [4]  */
        uint8_t CEC_ADDR_H5 : 1;       /*!< [5]  */
        uint8_t CEC_ADDR_H6 : 1;       /*!< [6]  */
        uint8_t CEC_ADDR_H7 : 1;       /*!< [7]  */
    } B;
} hw_hdmi_cec_addr_h_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_ADDR_H register
 */
/*@{*/
#define HW_HDMI_CEC_ADDR_H_ADDR(x) ((uintptr_t)(x) + 0x7D06U)

#define HW_HDMI_CEC_ADDR_H(x)    (*(__IO hw_hdmi_cec_addr_h_t *) HW_HDMI_CEC_ADDR_H_ADDR(x))
#define HW_HDMI_CEC_ADDR_H_RD(x) (HW_HDMI_CEC_ADDR_H(x).U)
#define HW_HDMI_CEC_ADDR_H_WR(x, v) (HW_HDMI_CEC_ADDR_H(x).U = (v))
#define HW_HDMI_CEC_ADDR_H_SET(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, HW_HDMI_CEC_ADDR_H_RD(x) |  (v)))
#define HW_HDMI_CEC_ADDR_H_CLR(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, HW_HDMI_CEC_ADDR_H_RD(x) & ~(v)))
#define HW_HDMI_CEC_ADDR_H_TOG(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, HW_HDMI_CEC_ADDR_H_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_ADDR_H bitfields
 */

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H0[0] (RW)
 *
 * Logical address 8 - Playback Device 2
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H0 (0U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H0. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H0 (0x01U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H0. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H0 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H0. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H0 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H0(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H0)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H0. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H0(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H0) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H0)

/*! @brief Set the CEC_ADDR_H0 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H0(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H0) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H0(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H1[1] (RW)
 *
 * Logical address 9 - Playback Device 3
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H1 (1U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H1. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H1 (0x02U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H1. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H1 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H1. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H1 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H1(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H1)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H1. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H1(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H1) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H1)

/*! @brief Set the CEC_ADDR_H1 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H1(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H1) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H1(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CCEC_ADDR_H2[2] (RW)
 *
 * Logical address 10 - Tuner 4
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CCEC_ADDR_H2 (2U) /*!< Bit position for HDMI_CEC_ADDR_H_CCEC_ADDR_H2. */
#define BM_HDMI_CEC_ADDR_H_CCEC_ADDR_H2 (0x04U) /*!< Bit mask for HDMI_CEC_ADDR_H_CCEC_ADDR_H2. */
#define BS_HDMI_CEC_ADDR_H_CCEC_ADDR_H2 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CCEC_ADDR_H2. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CCEC_ADDR_H2 field. */
#define BR_HDMI_CEC_ADDR_H_CCEC_ADDR_H2(x) (HW_HDMI_CEC_ADDR_H(x).B.CCEC_ADDR_H2)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CCEC_ADDR_H2. */
#define BF_HDMI_CEC_ADDR_H_CCEC_ADDR_H2(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CCEC_ADDR_H2) & BM_HDMI_CEC_ADDR_H_CCEC_ADDR_H2)

/*! @brief Set the CCEC_ADDR_H2 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CCEC_ADDR_H2(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CCEC_ADDR_H2) | BF_HDMI_CEC_ADDR_H_CCEC_ADDR_H2(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H3[3] (RW)
 *
 * Logical address 11 - Playback Device 3
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H3 (3U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H3. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H3 (0x08U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H3. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H3 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H3. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H3 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H3(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H3)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H3. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H3(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H3) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H3)

/*! @brief Set the CEC_ADDR_H3 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H3(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H3) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H3(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H4[4] (RW)
 *
 * Logical address 12 - Reserved
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H4 (4U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H4. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H4 (0x10U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H4. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H4 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H4. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H4 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H4(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H4)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H4. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H4(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H4) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H4)

/*! @brief Set the CEC_ADDR_H4 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H4(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H4) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H4(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H5[5] (RW)
 *
 * Logical address 13 - Reserved
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H5 (5U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H5. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H5 (0x20U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H5. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H5 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H5. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H5 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H5(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H5)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H5. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H5(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H5) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H5)

/*! @brief Set the CEC_ADDR_H5 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H5(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H5) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H5(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H6[6] (RW)
 *
 * Logical address 14 - Free use
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H6 (6U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H6. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H6 (0x40U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H6. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H6 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H6. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H6 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H6(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H6)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H6. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H6(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H6) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H6)

/*! @brief Set the CEC_ADDR_H6 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H6(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H6) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H6(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_ADDR_H, field CEC_ADDR_H7[7] (RW)
 *
 * Logical address 15 - Unregistered (as initiator address), Broadcast (as
 * destination address)
 */
/*@{*/
#define BP_HDMI_CEC_ADDR_H_CEC_ADDR_H7 (7U) /*!< Bit position for HDMI_CEC_ADDR_H_CEC_ADDR_H7. */
#define BM_HDMI_CEC_ADDR_H_CEC_ADDR_H7 (0x80U) /*!< Bit mask for HDMI_CEC_ADDR_H_CEC_ADDR_H7. */
#define BS_HDMI_CEC_ADDR_H_CEC_ADDR_H7 (1U) /*!< Bit field size in bits for HDMI_CEC_ADDR_H_CEC_ADDR_H7. */

/*! @brief Read current value of the HDMI_CEC_ADDR_H_CEC_ADDR_H7 field. */
#define BR_HDMI_CEC_ADDR_H_CEC_ADDR_H7(x) (HW_HDMI_CEC_ADDR_H(x).B.CEC_ADDR_H7)

/*! @brief Format value for bitfield HDMI_CEC_ADDR_H_CEC_ADDR_H7. */
#define BF_HDMI_CEC_ADDR_H_CEC_ADDR_H7(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_ADDR_H_CEC_ADDR_H7) & BM_HDMI_CEC_ADDR_H_CEC_ADDR_H7)

/*! @brief Set the CEC_ADDR_H7 field to a new value. */
#define BW_HDMI_CEC_ADDR_H_CEC_ADDR_H7(x, v) (HW_HDMI_CEC_ADDR_H_WR(x, (HW_HDMI_CEC_ADDR_H_RD(x) & ~BM_HDMI_CEC_ADDR_H_CEC_ADDR_H7) | BF_HDMI_CEC_ADDR_H_CEC_ADDR_H7(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_TX_CNT - CEC_TX_CNT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_TX_CNT - CEC_TX_CNT (RW)
 *
 * Reset value: 0x00U
 *
 * This register indicates the size of the frame in bytes (including header and
 * data blocks), which are available in the transmitter data buffer. When the
 * value is zero, the CEC controller ignores the send command triggered by software.
 * When the transmission is done (no matter success or not), the current value
 * is held until it is overwritten by software. Address Offset: 0x7D07 Size: 8
 * bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_cec_tx_cnt
{
    uint8_t U;
    struct _hw_hdmi_cec_tx_cnt_bitfields
    {
        uint8_t CEC_TX_CNT : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_cec_tx_cnt_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_TX_CNT register
 */
/*@{*/
#define HW_HDMI_CEC_TX_CNT_ADDR(x) ((uintptr_t)(x) + 0x7D07U)

#define HW_HDMI_CEC_TX_CNT(x)    (*(__IO hw_hdmi_cec_tx_cnt_t *) HW_HDMI_CEC_TX_CNT_ADDR(x))
#define HW_HDMI_CEC_TX_CNT_RD(x) (HW_HDMI_CEC_TX_CNT(x).U)
#define HW_HDMI_CEC_TX_CNT_WR(x, v) (HW_HDMI_CEC_TX_CNT(x).U = (v))
#define HW_HDMI_CEC_TX_CNT_SET(x, v) (HW_HDMI_CEC_TX_CNT_WR(x, HW_HDMI_CEC_TX_CNT_RD(x) |  (v)))
#define HW_HDMI_CEC_TX_CNT_CLR(x, v) (HW_HDMI_CEC_TX_CNT_WR(x, HW_HDMI_CEC_TX_CNT_RD(x) & ~(v)))
#define HW_HDMI_CEC_TX_CNT_TOG(x, v) (HW_HDMI_CEC_TX_CNT_WR(x, HW_HDMI_CEC_TX_CNT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_TX_CNT bitfields
 */

/*!
 * @name Register HDMI_CEC_TX_CNT, field CEC_TX_CNT[4:0] (RW)
 *
 * CEC Transmitter Counter register: Value after Reset: 5'b00000
 *
 * Values:
 * - 0 - No data needs to be transmitted.
 * - 1 - Frame size is 1 byte.
 */
/*@{*/
#define BP_HDMI_CEC_TX_CNT_CEC_TX_CNT (0U) /*!< Bit position for HDMI_CEC_TX_CNT_CEC_TX_CNT. */
#define BM_HDMI_CEC_TX_CNT_CEC_TX_CNT (0x1FU) /*!< Bit mask for HDMI_CEC_TX_CNT_CEC_TX_CNT. */
#define BS_HDMI_CEC_TX_CNT_CEC_TX_CNT (5U) /*!< Bit field size in bits for HDMI_CEC_TX_CNT_CEC_TX_CNT. */

/*! @brief Read current value of the HDMI_CEC_TX_CNT_CEC_TX_CNT field. */
#define BR_HDMI_CEC_TX_CNT_CEC_TX_CNT(x) (HW_HDMI_CEC_TX_CNT(x).B.CEC_TX_CNT)

/*! @brief Format value for bitfield HDMI_CEC_TX_CNT_CEC_TX_CNT. */
#define BF_HDMI_CEC_TX_CNT_CEC_TX_CNT(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_TX_CNT_CEC_TX_CNT) & BM_HDMI_CEC_TX_CNT_CEC_TX_CNT)

/*! @brief Set the CEC_TX_CNT field to a new value. */
#define BW_HDMI_CEC_TX_CNT_CEC_TX_CNT(x, v) (HW_HDMI_CEC_TX_CNT_WR(x, (HW_HDMI_CEC_TX_CNT_RD(x) & ~BM_HDMI_CEC_TX_CNT_CEC_TX_CNT) | BF_HDMI_CEC_TX_CNT_CEC_TX_CNT(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_RX_CNT - CEC_RX_CNT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_RX_CNT - CEC_RX_CNT (RO)
 *
 * Reset value: 0x00U
 *
 * This register indicates the size of the frame in bytes (including header and
 * data blocks), which are available in the receiver data buffer. Only after the
 * whole receiving process is finished successfully, the counter is refreshed to
 * the value which indicates the total number of data bytes in the Receiver Data
 * Register. Address Offset: 0x7d08 Size: 8 bits Value after Reset: 0x00 Access:
 * Read
 */
typedef union _hw_hdmi_cec_rx_cnt
{
    uint8_t U;
    struct _hw_hdmi_cec_rx_cnt_bitfields
    {
        uint8_t CEC_RX_CNT : 5;        /*!< [4:0]  */
        uint8_t RESERVED0 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_cec_rx_cnt_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_RX_CNT register
 */
/*@{*/
#define HW_HDMI_CEC_RX_CNT_ADDR(x) ((uintptr_t)(x) + 0x7D08U)

#define HW_HDMI_CEC_RX_CNT(x)    (*(__I hw_hdmi_cec_rx_cnt_t *) HW_HDMI_CEC_RX_CNT_ADDR(x))
#define HW_HDMI_CEC_RX_CNT_RD(x) (HW_HDMI_CEC_RX_CNT(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_RX_CNT bitfields
 */

/*!
 * @name Register HDMI_CEC_RX_CNT, field CEC_RX_CNT[4:0] (RO)
 *
 * CEC Receiver Counter register. Value after Reset: 5'b00000
 *
 * Values:
 * - 0 - No data received
 * - 1 - 1-byte data is received.
 */
/*@{*/
#define BP_HDMI_CEC_RX_CNT_CEC_RX_CNT (0U) /*!< Bit position for HDMI_CEC_RX_CNT_CEC_RX_CNT. */
#define BM_HDMI_CEC_RX_CNT_CEC_RX_CNT (0x1FU) /*!< Bit mask for HDMI_CEC_RX_CNT_CEC_RX_CNT. */
#define BS_HDMI_CEC_RX_CNT_CEC_RX_CNT (5U) /*!< Bit field size in bits for HDMI_CEC_RX_CNT_CEC_RX_CNT. */

/*! @brief Read current value of the HDMI_CEC_RX_CNT_CEC_RX_CNT field. */
#define BR_HDMI_CEC_RX_CNT_CEC_RX_CNT(x) (HW_HDMI_CEC_RX_CNT(x).B.CEC_RX_CNT)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_TX_DATAn - CEC_TX_DATA
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_TX_DATAn - CEC_TX_DATA (RW)
 *
 * Reset value: 0x00U
 *
 * These registers (8 bit each) are the buffers used for storing the data
 * waiting for transmission(including header and data blocks). Address Offset: 0x7D10
 * .. 0x7D1F Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_cec_tx_datan
{
    uint8_t U;
    struct _hw_hdmi_cec_tx_datan_bitfields
    {
        uint8_t CEC_TX_DATA : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_cec_tx_datan_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_TX_DATAn register
 */
/*@{*/
#define HW_HDMI_CEC_TX_DATAn_COUNT (16U)

#define HW_HDMI_CEC_TX_DATAn_ADDR(x, n) ((uintptr_t)(x) + 0x7D10U + (0x1U * (n)))

#define HW_HDMI_CEC_TX_DATAn(x, n) (*(__IO hw_hdmi_cec_tx_datan_t *) HW_HDMI_CEC_TX_DATAn_ADDR(x, n))
#define HW_HDMI_CEC_TX_DATAn_RD(x, n) (HW_HDMI_CEC_TX_DATAn(x, n).U)
#define HW_HDMI_CEC_TX_DATAn_WR(x, n, v) (HW_HDMI_CEC_TX_DATAn(x, n).U = (v))
#define HW_HDMI_CEC_TX_DATAn_SET(x, n, v) (HW_HDMI_CEC_TX_DATAn_WR(x, n, HW_HDMI_CEC_TX_DATAn_RD(x, n) |  (v)))
#define HW_HDMI_CEC_TX_DATAn_CLR(x, n, v) (HW_HDMI_CEC_TX_DATAn_WR(x, n, HW_HDMI_CEC_TX_DATAn_RD(x, n) & ~(v)))
#define HW_HDMI_CEC_TX_DATAn_TOG(x, n, v) (HW_HDMI_CEC_TX_DATAn_WR(x, n, HW_HDMI_CEC_TX_DATAn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_TX_DATAn bitfields
 */

/*!
 * @name Register HDMI_CEC_TX_DATAn, field CEC_TX_DATA[7:0] (RW)
 *
 * Header block in CEC_TX_DATA0 Data blockn in CEC_TX_DATAn
 */
/*@{*/
#define BP_HDMI_CEC_TX_DATAn_CEC_TX_DATA (0U) /*!< Bit position for HDMI_CEC_TX_DATAn_CEC_TX_DATA. */
#define BM_HDMI_CEC_TX_DATAn_CEC_TX_DATA (0xFFU) /*!< Bit mask for HDMI_CEC_TX_DATAn_CEC_TX_DATA. */
#define BS_HDMI_CEC_TX_DATAn_CEC_TX_DATA (8U) /*!< Bit field size in bits for HDMI_CEC_TX_DATAn_CEC_TX_DATA. */

/*! @brief Read current value of the HDMI_CEC_TX_DATAn_CEC_TX_DATA field. */
#define BR_HDMI_CEC_TX_DATAn_CEC_TX_DATA(x, n) (HW_HDMI_CEC_TX_DATAn(x, n).U)

/*! @brief Format value for bitfield HDMI_CEC_TX_DATAn_CEC_TX_DATA. */
#define BF_HDMI_CEC_TX_DATAn_CEC_TX_DATA(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_TX_DATAn_CEC_TX_DATA) & BM_HDMI_CEC_TX_DATAn_CEC_TX_DATA)

/*! @brief Set the CEC_TX_DATA field to a new value. */
#define BW_HDMI_CEC_TX_DATAn_CEC_TX_DATA(x, n, v) (HW_HDMI_CEC_TX_DATAn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_RX_DATAn - CEC_RX_DATA
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_RX_DATAn - CEC_RX_DATA (RO)
 *
 * Reset value: 0x00U
 *
 * These registers (8 bit each) are the buffers used for storing the received
 * data (including header and data blocks). Address Offset: 0x7D20 .. 0x7D2F Size:
 * 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_cec_rx_datan
{
    uint8_t U;
    struct _hw_hdmi_cec_rx_datan_bitfields
    {
        uint8_t CEC_RX_DATA : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_cec_rx_datan_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_RX_DATAn register
 */
/*@{*/
#define HW_HDMI_CEC_RX_DATAn_COUNT (16U)

#define HW_HDMI_CEC_RX_DATAn_ADDR(x, n) ((uintptr_t)(x) + 0x7D20U + (0x1U * (n)))

#define HW_HDMI_CEC_RX_DATAn(x, n) (*(__I hw_hdmi_cec_rx_datan_t *) HW_HDMI_CEC_RX_DATAn_ADDR(x, n))
#define HW_HDMI_CEC_RX_DATAn_RD(x, n) (HW_HDMI_CEC_RX_DATAn(x, n).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_RX_DATAn bitfields
 */

/*!
 * @name Register HDMI_CEC_RX_DATAn, field CEC_RX_DATA[7:0] (RO)
 *
 * Header block in CEC_RX_DATA0 Data blockn in CEC_RX_DATAn
 */
/*@{*/
#define BP_HDMI_CEC_RX_DATAn_CEC_RX_DATA (0U) /*!< Bit position for HDMI_CEC_RX_DATAn_CEC_RX_DATA. */
#define BM_HDMI_CEC_RX_DATAn_CEC_RX_DATA (0xFFU) /*!< Bit mask for HDMI_CEC_RX_DATAn_CEC_RX_DATA. */
#define BS_HDMI_CEC_RX_DATAn_CEC_RX_DATA (8U) /*!< Bit field size in bits for HDMI_CEC_RX_DATAn_CEC_RX_DATA. */

/*! @brief Read current value of the HDMI_CEC_RX_DATAn_CEC_RX_DATA field. */
#define BR_HDMI_CEC_RX_DATAn_CEC_RX_DATA(x, n) (HW_HDMI_CEC_RX_DATAn(x, n).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_LOCK - CEC_LOCK
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_LOCK - CEC_LOCK (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7D30 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_cec_lock
{
    uint8_t U;
    struct _hw_hdmi_cec_lock_bitfields
    {
        uint8_t LOCKED_BUFFER : 1;     /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_cec_lock_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_LOCK register
 */
/*@{*/
#define HW_HDMI_CEC_LOCK_ADDR(x) ((uintptr_t)(x) + 0x7D30U)

#define HW_HDMI_CEC_LOCK(x)      (*(__IO hw_hdmi_cec_lock_t *) HW_HDMI_CEC_LOCK_ADDR(x))
#define HW_HDMI_CEC_LOCK_RD(x)   (HW_HDMI_CEC_LOCK(x).U)
#define HW_HDMI_CEC_LOCK_WR(x, v) (HW_HDMI_CEC_LOCK(x).U = (v))
#define HW_HDMI_CEC_LOCK_SET(x, v) (HW_HDMI_CEC_LOCK_WR(x, HW_HDMI_CEC_LOCK_RD(x) |  (v)))
#define HW_HDMI_CEC_LOCK_CLR(x, v) (HW_HDMI_CEC_LOCK_WR(x, HW_HDMI_CEC_LOCK_RD(x) & ~(v)))
#define HW_HDMI_CEC_LOCK_TOG(x, v) (HW_HDMI_CEC_LOCK_WR(x, HW_HDMI_CEC_LOCK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_LOCK bitfields
 */

/*!
 * @name Register HDMI_CEC_LOCK, field LOCKED_BUFFER[0] (RW)
 *
 * When a frame is received, this bit would be active. The CEC controller
 * answers to all the messages with NACK until the CPU writes it to '0'.
 */
/*@{*/
#define BP_HDMI_CEC_LOCK_LOCKED_BUFFER (0U) /*!< Bit position for HDMI_CEC_LOCK_LOCKED_BUFFER. */
#define BM_HDMI_CEC_LOCK_LOCKED_BUFFER (0x01U) /*!< Bit mask for HDMI_CEC_LOCK_LOCKED_BUFFER. */
#define BS_HDMI_CEC_LOCK_LOCKED_BUFFER (1U) /*!< Bit field size in bits for HDMI_CEC_LOCK_LOCKED_BUFFER. */

/*! @brief Read current value of the HDMI_CEC_LOCK_LOCKED_BUFFER field. */
#define BR_HDMI_CEC_LOCK_LOCKED_BUFFER(x) (HW_HDMI_CEC_LOCK(x).B.LOCKED_BUFFER)

/*! @brief Format value for bitfield HDMI_CEC_LOCK_LOCKED_BUFFER. */
#define BF_HDMI_CEC_LOCK_LOCKED_BUFFER(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_LOCK_LOCKED_BUFFER) & BM_HDMI_CEC_LOCK_LOCKED_BUFFER)

/*! @brief Set the LOCKED_BUFFER field to a new value. */
#define BW_HDMI_CEC_LOCK_LOCKED_BUFFER(x, v) (HW_HDMI_CEC_LOCK_WR(x, (HW_HDMI_CEC_LOCK_RD(x) & ~BM_HDMI_CEC_LOCK_LOCKED_BUFFER) | BF_HDMI_CEC_LOCK_LOCKED_BUFFER(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_CEC_WKUPCTRL - CEC_WKUPCTRL
 ******************************************************************************/

/*!
 * @brief HW_HDMI_CEC_WKUPCTRL - CEC_WKUPCTRL (RW)
 *
 * Reset value: 0xFFU
 *
 * Address Offset: 0x7D31 Size: 8 bits Value after Reset: 0xFF Access:
 * Read/Write After receiving a message in the CEC_RX_DATA1 (OPCODE) registers, the CEC
 * engine verifies the message opcode[7:0] against one of the previously defined
 * values to generate the wake-up status: Wakeupstatus is 1 when: received opcode
 * is 0x04 and opcode0x04en is 1 or received opcode is 0x0D and opcode0x0Den is 1
 * or received opcode is 0x41 and opcode0x41en is 1 or received opcode is 0x42
 * and opcode0x42en is 1 or received opcode is 0x44 and opcode0x44en is 1 or
 * received opcode is 0x70 and opcode0x70en is 1 or received opcode is 0x82 and
 * opcode0x82en is 1 or received opcode is 0x86 and opcode0x86en is 1 Wakeupstatus is 0
 * when none of the previous conditions are true. This formula means that the
 * wake-up status (on CEC_STAT[6] register) is only '1' if the opcode[7:0] received
 * is equal to one of the defined values and the corresponding enable bit of that
 * defined value is set to '1'.
 */
typedef union _hw_hdmi_cec_wkupctrl
{
    uint8_t U;
    struct _hw_hdmi_cec_wkupctrl_bitfields
    {
        uint8_t OPCODE0x04en : 1;      /*!< [0]  */
        uint8_t OPCODE0x0Den : 1;      /*!< [1]  */
        uint8_t OPCODE0x41en : 1;      /*!< [2]  */
        uint8_t OPCODE0x42en : 1;      /*!< [3]  */
        uint8_t OPCODE0x44en : 1;      /*!< [4]  */
        uint8_t OPCODE0x70en : 1;      /*!< [5]  */
        uint8_t OPCODE0x82en : 1;      /*!< [6]  */
        uint8_t OPCODE0x86en : 1;      /*!< [7]  */
    } B;
} hw_hdmi_cec_wkupctrl_t;

/*!
 * @name Constants and macros for entire HDMI_CEC_WKUPCTRL register
 */
/*@{*/
#define HW_HDMI_CEC_WKUPCTRL_ADDR(x) ((uintptr_t)(x) + 0x7D31U)

#define HW_HDMI_CEC_WKUPCTRL(x)  (*(__IO hw_hdmi_cec_wkupctrl_t *) HW_HDMI_CEC_WKUPCTRL_ADDR(x))
#define HW_HDMI_CEC_WKUPCTRL_RD(x) (HW_HDMI_CEC_WKUPCTRL(x).U)
#define HW_HDMI_CEC_WKUPCTRL_WR(x, v) (HW_HDMI_CEC_WKUPCTRL(x).U = (v))
#define HW_HDMI_CEC_WKUPCTRL_SET(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, HW_HDMI_CEC_WKUPCTRL_RD(x) |  (v)))
#define HW_HDMI_CEC_WKUPCTRL_CLR(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, HW_HDMI_CEC_WKUPCTRL_RD(x) & ~(v)))
#define HW_HDMI_CEC_WKUPCTRL_TOG(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, HW_HDMI_CEC_WKUPCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_CEC_WKUPCTRL bitfields
 */

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x04en[0] (RW)
 *
 * OPCODE 0x04 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x04en (0U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x04en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x04en (0x01U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x04en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x04en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x04en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x04en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x04en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x04en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x04en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x04en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x04en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x04en)

/*! @brief Set the OPCODE0x04en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x04en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x04en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x04en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x0Den[1] (RW)
 *
 * OPCODE 0x0D wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x0Den (1U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x0Den. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x0Den (0x02U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x0Den. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x0Den (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x0Den. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x0Den field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x0Den(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x0Den)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x0Den. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x0Den(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x0Den) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x0Den)

/*! @brief Set the OPCODE0x0Den field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x0Den(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x0Den) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x0Den(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x41en[2] (RW)
 *
 * OPCODE 0x41 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x41en (2U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x41en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x41en (0x04U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x41en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x41en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x41en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x41en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x41en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x41en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x41en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x41en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x41en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x41en)

/*! @brief Set the OPCODE0x41en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x41en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x41en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x41en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x42en[3] (RW)
 *
 * OPCODE 0x42 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x42en (3U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x42en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x42en (0x08U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x42en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x42en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x42en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x42en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x42en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x42en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x42en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x42en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x42en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x42en)

/*! @brief Set the OPCODE0x42en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x42en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x42en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x42en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x44en[4] (RW)
 *
 * OPCODE 0x44 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x44en (4U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x44en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x44en (0x10U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x44en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x44en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x44en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x44en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x44en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x44en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x44en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x44en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x44en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x44en)

/*! @brief Set the OPCODE0x44en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x44en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x44en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x44en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x70en[5] (RW)
 *
 * OPCODE 0x70 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x70en (5U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x70en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x70en (0x20U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x70en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x70en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x70en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x70en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x70en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x70en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x70en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x70en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x70en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x70en)

/*! @brief Set the OPCODE0x70en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x70en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x70en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x70en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x82en[6] (RW)
 *
 * OPCODE 0x82 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x82en (6U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x82en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x82en (0x40U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x82en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x82en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x82en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x82en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x82en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x82en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x82en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x82en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x82en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x82en)

/*! @brief Set the OPCODE0x82en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x82en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x82en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x82en(v)))
/*@}*/

/*!
 * @name Register HDMI_CEC_WKUPCTRL, field OPCODE0x86en[7] (RW)
 *
 * OPCODE 0x86 wake up enable
 */
/*@{*/
#define BP_HDMI_CEC_WKUPCTRL_OPCODE0x86en (7U) /*!< Bit position for HDMI_CEC_WKUPCTRL_OPCODE0x86en. */
#define BM_HDMI_CEC_WKUPCTRL_OPCODE0x86en (0x80U) /*!< Bit mask for HDMI_CEC_WKUPCTRL_OPCODE0x86en. */
#define BS_HDMI_CEC_WKUPCTRL_OPCODE0x86en (1U) /*!< Bit field size in bits for HDMI_CEC_WKUPCTRL_OPCODE0x86en. */

/*! @brief Read current value of the HDMI_CEC_WKUPCTRL_OPCODE0x86en field. */
#define BR_HDMI_CEC_WKUPCTRL_OPCODE0x86en(x) (HW_HDMI_CEC_WKUPCTRL(x).B.OPCODE0x86en)

/*! @brief Format value for bitfield HDMI_CEC_WKUPCTRL_OPCODE0x86en. */
#define BF_HDMI_CEC_WKUPCTRL_OPCODE0x86en(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_CEC_WKUPCTRL_OPCODE0x86en) & BM_HDMI_CEC_WKUPCTRL_OPCODE0x86en)

/*! @brief Set the OPCODE0x86en field to a new value. */
#define BW_HDMI_CEC_WKUPCTRL_OPCODE0x86en(x, v) (HW_HDMI_CEC_WKUPCTRL_WR(x, (HW_HDMI_CEC_WKUPCTRL_RD(x) & ~BM_HDMI_CEC_WKUPCTRL_OPCODE0x86en) | BF_HDMI_CEC_WKUPCTRL_OPCODE0x86en(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SLAVE - I2CM_SLAVE
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SLAVE - I2CM_SLAVE (RW)
 *
 * Reset value: 0x00U
 *
 * I2C Master Registers (E-DDC) registers are responsible for the Master's
 * coordination with the Slave, by coordinating the Slave address, data
 * identification, transaction status, acknowledgement, and reset functions. Address Offset:
 * 0x7E00 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_slave
{
    uint8_t U;
    struct _hw_hdmi_i2cm_slave_bitfields
    {
        uint8_t slaveaddr : 7;         /*!< [6:0]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_i2cm_slave_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SLAVE register
 */
/*@{*/
#define HW_HDMI_I2CM_SLAVE_ADDR(x) ((uintptr_t)(x) + 0x7E00U)

#define HW_HDMI_I2CM_SLAVE(x)    (*(__IO hw_hdmi_i2cm_slave_t *) HW_HDMI_I2CM_SLAVE_ADDR(x))
#define HW_HDMI_I2CM_SLAVE_RD(x) (HW_HDMI_I2CM_SLAVE(x).U)
#define HW_HDMI_I2CM_SLAVE_WR(x, v) (HW_HDMI_I2CM_SLAVE(x).U = (v))
#define HW_HDMI_I2CM_SLAVE_SET(x, v) (HW_HDMI_I2CM_SLAVE_WR(x, HW_HDMI_I2CM_SLAVE_RD(x) |  (v)))
#define HW_HDMI_I2CM_SLAVE_CLR(x, v) (HW_HDMI_I2CM_SLAVE_WR(x, HW_HDMI_I2CM_SLAVE_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SLAVE_TOG(x, v) (HW_HDMI_I2CM_SLAVE_WR(x, HW_HDMI_I2CM_SLAVE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SLAVE bitfields
 */

/*!
 * @name Register HDMI_I2CM_SLAVE, field slaveaddr[6:0] (RW)
 *
 * Slave address to be sent during read and write normal operations.
 */
/*@{*/
#define BP_HDMI_I2CM_SLAVE_slaveaddr (0U)  /*!< Bit position for HDMI_I2CM_SLAVE_slaveaddr. */
#define BM_HDMI_I2CM_SLAVE_slaveaddr (0x7FU) /*!< Bit mask for HDMI_I2CM_SLAVE_slaveaddr. */
#define BS_HDMI_I2CM_SLAVE_slaveaddr (7U)  /*!< Bit field size in bits for HDMI_I2CM_SLAVE_slaveaddr. */

/*! @brief Read current value of the HDMI_I2CM_SLAVE_slaveaddr field. */
#define BR_HDMI_I2CM_SLAVE_slaveaddr(x) (HW_HDMI_I2CM_SLAVE(x).B.slaveaddr)

/*! @brief Format value for bitfield HDMI_I2CM_SLAVE_slaveaddr. */
#define BF_HDMI_I2CM_SLAVE_slaveaddr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SLAVE_slaveaddr) & BM_HDMI_I2CM_SLAVE_slaveaddr)

/*! @brief Set the slaveaddr field to a new value. */
#define BW_HDMI_I2CM_SLAVE_slaveaddr(x, v) (HW_HDMI_I2CM_SLAVE_WR(x, (HW_HDMI_I2CM_SLAVE_RD(x) & ~BM_HDMI_I2CM_SLAVE_slaveaddr) | BF_HDMI_I2CM_SLAVE_slaveaddr(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_ADDRESS - I2CM_ADDRESS
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_ADDRESS - I2CM_ADDRESS (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E01 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_address
{
    uint8_t U;
    struct _hw_hdmi_i2cm_address_bitfields
    {
        uint8_t address : 8;           /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_address_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_ADDRESS register
 */
/*@{*/
#define HW_HDMI_I2CM_ADDRESS_ADDR(x) ((uintptr_t)(x) + 0x7E01U)

#define HW_HDMI_I2CM_ADDRESS(x)  (*(__IO hw_hdmi_i2cm_address_t *) HW_HDMI_I2CM_ADDRESS_ADDR(x))
#define HW_HDMI_I2CM_ADDRESS_RD(x) (HW_HDMI_I2CM_ADDRESS(x).U)
#define HW_HDMI_I2CM_ADDRESS_WR(x, v) (HW_HDMI_I2CM_ADDRESS(x).U = (v))
#define HW_HDMI_I2CM_ADDRESS_SET(x, v) (HW_HDMI_I2CM_ADDRESS_WR(x, HW_HDMI_I2CM_ADDRESS_RD(x) |  (v)))
#define HW_HDMI_I2CM_ADDRESS_CLR(x, v) (HW_HDMI_I2CM_ADDRESS_WR(x, HW_HDMI_I2CM_ADDRESS_RD(x) & ~(v)))
#define HW_HDMI_I2CM_ADDRESS_TOG(x, v) (HW_HDMI_I2CM_ADDRESS_WR(x, HW_HDMI_I2CM_ADDRESS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_ADDRESS bitfields
 */

/*!
 * @name Register HDMI_I2CM_ADDRESS, field address[7:0] (RW)
 *
 * Register address for read and write operations.
 */
/*@{*/
#define BP_HDMI_I2CM_ADDRESS_address (0U)  /*!< Bit position for HDMI_I2CM_ADDRESS_address. */
#define BM_HDMI_I2CM_ADDRESS_address (0xFFU) /*!< Bit mask for HDMI_I2CM_ADDRESS_address. */
#define BS_HDMI_I2CM_ADDRESS_address (8U)  /*!< Bit field size in bits for HDMI_I2CM_ADDRESS_address. */

/*! @brief Read current value of the HDMI_I2CM_ADDRESS_address field. */
#define BR_HDMI_I2CM_ADDRESS_address(x) (HW_HDMI_I2CM_ADDRESS(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_ADDRESS_address. */
#define BF_HDMI_I2CM_ADDRESS_address(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_ADDRESS_address) & BM_HDMI_I2CM_ADDRESS_address)

/*! @brief Set the address field to a new value. */
#define BW_HDMI_I2CM_ADDRESS_address(x, v) (HW_HDMI_I2CM_ADDRESS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_DATAO - I2CM_DATAO
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_DATAO - I2CM_DATAO (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E02 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_datao
{
    uint8_t U;
    struct _hw_hdmi_i2cm_datao_bitfields
    {
        uint8_t datao : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_datao_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_DATAO register
 */
/*@{*/
#define HW_HDMI_I2CM_DATAO_ADDR(x) ((uintptr_t)(x) + 0x7E02U)

#define HW_HDMI_I2CM_DATAO(x)    (*(__IO hw_hdmi_i2cm_datao_t *) HW_HDMI_I2CM_DATAO_ADDR(x))
#define HW_HDMI_I2CM_DATAO_RD(x) (HW_HDMI_I2CM_DATAO(x).U)
#define HW_HDMI_I2CM_DATAO_WR(x, v) (HW_HDMI_I2CM_DATAO(x).U = (v))
#define HW_HDMI_I2CM_DATAO_SET(x, v) (HW_HDMI_I2CM_DATAO_WR(x, HW_HDMI_I2CM_DATAO_RD(x) |  (v)))
#define HW_HDMI_I2CM_DATAO_CLR(x, v) (HW_HDMI_I2CM_DATAO_WR(x, HW_HDMI_I2CM_DATAO_RD(x) & ~(v)))
#define HW_HDMI_I2CM_DATAO_TOG(x, v) (HW_HDMI_I2CM_DATAO_WR(x, HW_HDMI_I2CM_DATAO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_DATAO bitfields
 */

/*!
 * @name Register HDMI_I2CM_DATAO, field datao[7:0] (RW)
 *
 * Data to be written on register pointed by address[7:0].
 */
/*@{*/
#define BP_HDMI_I2CM_DATAO_datao (0U)      /*!< Bit position for HDMI_I2CM_DATAO_datao. */
#define BM_HDMI_I2CM_DATAO_datao (0xFFU)   /*!< Bit mask for HDMI_I2CM_DATAO_datao. */
#define BS_HDMI_I2CM_DATAO_datao (8U)      /*!< Bit field size in bits for HDMI_I2CM_DATAO_datao. */

/*! @brief Read current value of the HDMI_I2CM_DATAO_datao field. */
#define BR_HDMI_I2CM_DATAO_datao(x) (HW_HDMI_I2CM_DATAO(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_DATAO_datao. */
#define BF_HDMI_I2CM_DATAO_datao(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_DATAO_datao) & BM_HDMI_I2CM_DATAO_datao)

/*! @brief Set the datao field to a new value. */
#define BW_HDMI_I2CM_DATAO_datao(x, v) (HW_HDMI_I2CM_DATAO_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_DATAI - I2CM_DATAI
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_DATAI - I2CM_DATAI (RO)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E03 Size: 8 bits Value after Reset: 0x00 Access: Read
 */
typedef union _hw_hdmi_i2cm_datai
{
    uint8_t U;
    struct _hw_hdmi_i2cm_datai_bitfields
    {
        uint8_t datai : 8;             /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_datai_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_DATAI register
 */
/*@{*/
#define HW_HDMI_I2CM_DATAI_ADDR(x) ((uintptr_t)(x) + 0x7E03U)

#define HW_HDMI_I2CM_DATAI(x)    (*(__I hw_hdmi_i2cm_datai_t *) HW_HDMI_I2CM_DATAI_ADDR(x))
#define HW_HDMI_I2CM_DATAI_RD(x) (HW_HDMI_I2CM_DATAI(x).U)
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_DATAI bitfields
 */

/*!
 * @name Register HDMI_I2CM_DATAI, field datai[7:0] (RO)
 *
 * Data read from register pointed by address[7:0].
 */
/*@{*/
#define BP_HDMI_I2CM_DATAI_datai (0U)      /*!< Bit position for HDMI_I2CM_DATAI_datai. */
#define BM_HDMI_I2CM_DATAI_datai (0xFFU)   /*!< Bit mask for HDMI_I2CM_DATAI_datai. */
#define BS_HDMI_I2CM_DATAI_datai (8U)      /*!< Bit field size in bits for HDMI_I2CM_DATAI_datai. */

/*! @brief Read current value of the HDMI_I2CM_DATAI_datai field. */
#define BR_HDMI_I2CM_DATAI_datai(x) (HW_HDMI_I2CM_DATAI(x).U)
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_OPERATION - I2CM_OPERATION
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_OPERATION - I2CM_OPERATION (WO)
 *
 * Reset value: 0x00U
 *
 * Read and write operation request. This register can only be written, reading
 * this register will always result in 00h. Writing 1'b1 simultaneously to rd,
 * rd_ext and wr requests is considered as a read (rd) request. Address Offset:
 * 0x7E04 Size: 8 bits Value after Reset: 0x00 Access: Write
 */
typedef union _hw_hdmi_i2cm_operation
{
    uint8_t U;
    struct _hw_hdmi_i2cm_operation_bitfields
    {
        uint8_t rd : 1;                /*!< [0]  */
        uint8_t rd_ext : 1;            /*!< [1]  */
        uint8_t RESERVED0 : 2;         /*!< [3:2]  */
        uint8_t wr : 1;                /*!< [4]  */
        uint8_t RESERVED1 : 3;         /*!< [7:5]  */
    } B;
} hw_hdmi_i2cm_operation_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_OPERATION register
 */
/*@{*/
#define HW_HDMI_I2CM_OPERATION_ADDR(x) ((uintptr_t)(x) + 0x7E04U)

#define HW_HDMI_I2CM_OPERATION(x) (*(__O hw_hdmi_i2cm_operation_t *) HW_HDMI_I2CM_OPERATION_ADDR(x))
#define HW_HDMI_I2CM_OPERATION_WR(x, v) (HW_HDMI_I2CM_OPERATION(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_OPERATION bitfields
 */

/*!
 * @name Register HDMI_I2CM_OPERATION, field rd[0] (WO)
 *
 * Read operation request.
 */
/*@{*/
#define BP_HDMI_I2CM_OPERATION_rd (0U)     /*!< Bit position for HDMI_I2CM_OPERATION_rd. */
#define BM_HDMI_I2CM_OPERATION_rd (0x01U)  /*!< Bit mask for HDMI_I2CM_OPERATION_rd. */
#define BS_HDMI_I2CM_OPERATION_rd (1U)     /*!< Bit field size in bits for HDMI_I2CM_OPERATION_rd. */

/*! @brief Format value for bitfield HDMI_I2CM_OPERATION_rd. */
#define BF_HDMI_I2CM_OPERATION_rd(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_OPERATION_rd) & BM_HDMI_I2CM_OPERATION_rd)
/*@}*/

/*!
 * @name Register HDMI_I2CM_OPERATION, field rd_ext[1] (WO)
 *
 * After writing 1'b1 to rd_ext bit a extended data read operation is started
 * (E- DDC read operation).
 */
/*@{*/
#define BP_HDMI_I2CM_OPERATION_rd_ext (1U) /*!< Bit position for HDMI_I2CM_OPERATION_rd_ext. */
#define BM_HDMI_I2CM_OPERATION_rd_ext (0x02U) /*!< Bit mask for HDMI_I2CM_OPERATION_rd_ext. */
#define BS_HDMI_I2CM_OPERATION_rd_ext (1U) /*!< Bit field size in bits for HDMI_I2CM_OPERATION_rd_ext. */

/*! @brief Format value for bitfield HDMI_I2CM_OPERATION_rd_ext. */
#define BF_HDMI_I2CM_OPERATION_rd_ext(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_OPERATION_rd_ext) & BM_HDMI_I2CM_OPERATION_rd_ext)
/*@}*/

/*!
 * @name Register HDMI_I2CM_OPERATION, field wr[4] (WO)
 *
 * Write operation request.
 */
/*@{*/
#define BP_HDMI_I2CM_OPERATION_wr (4U)     /*!< Bit position for HDMI_I2CM_OPERATION_wr. */
#define BM_HDMI_I2CM_OPERATION_wr (0x10U)  /*!< Bit mask for HDMI_I2CM_OPERATION_wr. */
#define BS_HDMI_I2CM_OPERATION_wr (1U)     /*!< Bit field size in bits for HDMI_I2CM_OPERATION_wr. */

/*! @brief Format value for bitfield HDMI_I2CM_OPERATION_wr. */
#define BF_HDMI_I2CM_OPERATION_wr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_OPERATION_wr) & BM_HDMI_I2CM_OPERATION_wr)
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_INT - I2CM_INT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_INT - I2CM_INT (RW)
 *
 * Reset value: 0x08U
 *
 * This register contains and configures I2C master done interrupt. Address
 * Offset: 0x7E05 Size: 8 bits Value after Reset: 0x08 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_int
{
    uint8_t U;
    struct _hw_hdmi_i2cm_int_bitfields
    {
        uint8_t done_status : 1;       /*!< [0]  */
        uint8_t done_interrupt : 1;    /*!< [1]  */
        uint8_t done_mask : 1;         /*!< [2]  */
        uint8_t done_pol : 1;          /*!< [3]  */
        uint8_t RESERVED0 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_i2cm_int_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_INT register
 */
/*@{*/
#define HW_HDMI_I2CM_INT_ADDR(x) ((uintptr_t)(x) + 0x7E05U)

#define HW_HDMI_I2CM_INT(x)      (*(__IO hw_hdmi_i2cm_int_t *) HW_HDMI_I2CM_INT_ADDR(x))
#define HW_HDMI_I2CM_INT_RD(x)   (HW_HDMI_I2CM_INT(x).U)
#define HW_HDMI_I2CM_INT_WR(x, v) (HW_HDMI_I2CM_INT(x).U = (v))
#define HW_HDMI_I2CM_INT_SET(x, v) (HW_HDMI_I2CM_INT_WR(x, HW_HDMI_I2CM_INT_RD(x) |  (v)))
#define HW_HDMI_I2CM_INT_CLR(x, v) (HW_HDMI_I2CM_INT_WR(x, HW_HDMI_I2CM_INT_RD(x) & ~(v)))
#define HW_HDMI_I2CM_INT_TOG(x, v) (HW_HDMI_I2CM_INT_WR(x, HW_HDMI_I2CM_INT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_INT bitfields
 */

/*!
 * @name Register HDMI_I2CM_INT, field done_status[0] (RW)
 *
 * Operation done status bit. Marks the end of a rd or write operation.
 */
/*@{*/
#define BP_HDMI_I2CM_INT_done_status (0U)  /*!< Bit position for HDMI_I2CM_INT_done_status. */
#define BM_HDMI_I2CM_INT_done_status (0x01U) /*!< Bit mask for HDMI_I2CM_INT_done_status. */
#define BS_HDMI_I2CM_INT_done_status (1U)  /*!< Bit field size in bits for HDMI_I2CM_INT_done_status. */

/*! @brief Read current value of the HDMI_I2CM_INT_done_status field. */
#define BR_HDMI_I2CM_INT_done_status(x) (HW_HDMI_I2CM_INT(x).B.done_status)

/*! @brief Format value for bitfield HDMI_I2CM_INT_done_status. */
#define BF_HDMI_I2CM_INT_done_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_INT_done_status) & BM_HDMI_I2CM_INT_done_status)

/*! @brief Set the done_status field to a new value. */
#define BW_HDMI_I2CM_INT_done_status(x, v) (HW_HDMI_I2CM_INT_WR(x, (HW_HDMI_I2CM_INT_RD(x) & ~BM_HDMI_I2CM_INT_done_status) | BF_HDMI_I2CM_INT_done_status(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_INT, field done_interrupt[1] (RW)
 *
 * Operation done interrupt bit. Only lasts for 1 SFR clock cycle and is auto
 * cleaned after it. {done_interrupt = (done_mask==0b) && (done_status==done_pol)}.
 */
/*@{*/
#define BP_HDMI_I2CM_INT_done_interrupt (1U) /*!< Bit position for HDMI_I2CM_INT_done_interrupt. */
#define BM_HDMI_I2CM_INT_done_interrupt (0x02U) /*!< Bit mask for HDMI_I2CM_INT_done_interrupt. */
#define BS_HDMI_I2CM_INT_done_interrupt (1U) /*!< Bit field size in bits for HDMI_I2CM_INT_done_interrupt. */

/*! @brief Read current value of the HDMI_I2CM_INT_done_interrupt field. */
#define BR_HDMI_I2CM_INT_done_interrupt(x) (HW_HDMI_I2CM_INT(x).B.done_interrupt)

/*! @brief Format value for bitfield HDMI_I2CM_INT_done_interrupt. */
#define BF_HDMI_I2CM_INT_done_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_INT_done_interrupt) & BM_HDMI_I2CM_INT_done_interrupt)

/*! @brief Set the done_interrupt field to a new value. */
#define BW_HDMI_I2CM_INT_done_interrupt(x, v) (HW_HDMI_I2CM_INT_WR(x, (HW_HDMI_I2CM_INT_RD(x) & ~BM_HDMI_I2CM_INT_done_interrupt) | BF_HDMI_I2CM_INT_done_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_INT, field done_mask[2] (RW)
 *
 * Done interrupt mask signal.
 */
/*@{*/
#define BP_HDMI_I2CM_INT_done_mask (2U)    /*!< Bit position for HDMI_I2CM_INT_done_mask. */
#define BM_HDMI_I2CM_INT_done_mask (0x04U) /*!< Bit mask for HDMI_I2CM_INT_done_mask. */
#define BS_HDMI_I2CM_INT_done_mask (1U)    /*!< Bit field size in bits for HDMI_I2CM_INT_done_mask. */

/*! @brief Read current value of the HDMI_I2CM_INT_done_mask field. */
#define BR_HDMI_I2CM_INT_done_mask(x) (HW_HDMI_I2CM_INT(x).B.done_mask)

/*! @brief Format value for bitfield HDMI_I2CM_INT_done_mask. */
#define BF_HDMI_I2CM_INT_done_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_INT_done_mask) & BM_HDMI_I2CM_INT_done_mask)

/*! @brief Set the done_mask field to a new value. */
#define BW_HDMI_I2CM_INT_done_mask(x, v) (HW_HDMI_I2CM_INT_WR(x, (HW_HDMI_I2CM_INT_RD(x) & ~BM_HDMI_I2CM_INT_done_mask) | BF_HDMI_I2CM_INT_done_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_INT, field done_pol[3] (RW)
 *
 * Done interrupt polarity configuration.
 */
/*@{*/
#define BP_HDMI_I2CM_INT_done_pol (3U)     /*!< Bit position for HDMI_I2CM_INT_done_pol. */
#define BM_HDMI_I2CM_INT_done_pol (0x08U)  /*!< Bit mask for HDMI_I2CM_INT_done_pol. */
#define BS_HDMI_I2CM_INT_done_pol (1U)     /*!< Bit field size in bits for HDMI_I2CM_INT_done_pol. */

/*! @brief Read current value of the HDMI_I2CM_INT_done_pol field. */
#define BR_HDMI_I2CM_INT_done_pol(x) (HW_HDMI_I2CM_INT(x).B.done_pol)

/*! @brief Format value for bitfield HDMI_I2CM_INT_done_pol. */
#define BF_HDMI_I2CM_INT_done_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_INT_done_pol) & BM_HDMI_I2CM_INT_done_pol)

/*! @brief Set the done_pol field to a new value. */
#define BW_HDMI_I2CM_INT_done_pol(x, v) (HW_HDMI_I2CM_INT_WR(x, (HW_HDMI_I2CM_INT_RD(x) & ~BM_HDMI_I2CM_INT_done_pol) | BF_HDMI_I2CM_INT_done_pol(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_CTLINT - I2CM_CTLINT
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_CTLINT - I2CM_CTLINT (RW)
 *
 * Reset value: 0x88U
 *
 * This register contains and configures I2C master arbitration error and not
 * acknowledge error interrupt. Address Offset: 0x7E06 Size: 8 bits Value after
 * Reset: 0x88 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_ctlint
{
    uint8_t U;
    struct _hw_hdmi_i2cm_ctlint_bitfields
    {
        uint8_t arbitration_status : 1; /*!< [0]  */
        uint8_t arbitration_interrupt : 1; /*!< [1]  */
        uint8_t arbitration_mask : 1;  /*!< [2]  */
        uint8_t arbitration_pol : 1;   /*!< [3]  */
        uint8_t nack_status : 1;       /*!< [4]  */
        uint8_t nack_interrupt : 1;    /*!< [5]  */
        uint8_t nack_mask : 1;         /*!< [6]  */
        uint8_t nack_pol : 1;          /*!< [7]  */
    } B;
} hw_hdmi_i2cm_ctlint_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_CTLINT register
 */
/*@{*/
#define HW_HDMI_I2CM_CTLINT_ADDR(x) ((uintptr_t)(x) + 0x7E06U)

#define HW_HDMI_I2CM_CTLINT(x)   (*(__IO hw_hdmi_i2cm_ctlint_t *) HW_HDMI_I2CM_CTLINT_ADDR(x))
#define HW_HDMI_I2CM_CTLINT_RD(x) (HW_HDMI_I2CM_CTLINT(x).U)
#define HW_HDMI_I2CM_CTLINT_WR(x, v) (HW_HDMI_I2CM_CTLINT(x).U = (v))
#define HW_HDMI_I2CM_CTLINT_SET(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, HW_HDMI_I2CM_CTLINT_RD(x) |  (v)))
#define HW_HDMI_I2CM_CTLINT_CLR(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, HW_HDMI_I2CM_CTLINT_RD(x) & ~(v)))
#define HW_HDMI_I2CM_CTLINT_TOG(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, HW_HDMI_I2CM_CTLINT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_CTLINT bitfields
 */

/*!
 * @name Register HDMI_I2CM_CTLINT, field arbitration_status[0] (RW)
 *
 * Arbitration error status bit. Error on master I2C protocol arbitration.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_arbitration_status (0U) /*!< Bit position for HDMI_I2CM_CTLINT_arbitration_status. */
#define BM_HDMI_I2CM_CTLINT_arbitration_status (0x01U) /*!< Bit mask for HDMI_I2CM_CTLINT_arbitration_status. */
#define BS_HDMI_I2CM_CTLINT_arbitration_status (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_arbitration_status. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_arbitration_status field. */
#define BR_HDMI_I2CM_CTLINT_arbitration_status(x) (HW_HDMI_I2CM_CTLINT(x).B.arbitration_status)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_arbitration_status. */
#define BF_HDMI_I2CM_CTLINT_arbitration_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_arbitration_status) & BM_HDMI_I2CM_CTLINT_arbitration_status)

/*! @brief Set the arbitration_status field to a new value. */
#define BW_HDMI_I2CM_CTLINT_arbitration_status(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_arbitration_status) | BF_HDMI_I2CM_CTLINT_arbitration_status(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field arbitration_interrupt[1] (RW)
 *
 * Arbitration error interrupt bit. Only lasts for 1 SFR clock cycle and is auto
 * cleaned after it. {arbitration_interrupt = (arbitration_mask==0b) &&
 * (arbitration_status==arbitration_pol)}.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_arbitration_interrupt (1U) /*!< Bit position for HDMI_I2CM_CTLINT_arbitration_interrupt. */
#define BM_HDMI_I2CM_CTLINT_arbitration_interrupt (0x02U) /*!< Bit mask for HDMI_I2CM_CTLINT_arbitration_interrupt. */
#define BS_HDMI_I2CM_CTLINT_arbitration_interrupt (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_arbitration_interrupt. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_arbitration_interrupt field. */
#define BR_HDMI_I2CM_CTLINT_arbitration_interrupt(x) (HW_HDMI_I2CM_CTLINT(x).B.arbitration_interrupt)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_arbitration_interrupt. */
#define BF_HDMI_I2CM_CTLINT_arbitration_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_arbitration_interrupt) & BM_HDMI_I2CM_CTLINT_arbitration_interrupt)

/*! @brief Set the arbitration_interrupt field to a new value. */
#define BW_HDMI_I2CM_CTLINT_arbitration_interrupt(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_arbitration_interrupt) | BF_HDMI_I2CM_CTLINT_arbitration_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field arbitration_mask[2] (RW)
 *
 * Arbitration error interrupt mask signal.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_arbitration_mask (2U) /*!< Bit position for HDMI_I2CM_CTLINT_arbitration_mask. */
#define BM_HDMI_I2CM_CTLINT_arbitration_mask (0x04U) /*!< Bit mask for HDMI_I2CM_CTLINT_arbitration_mask. */
#define BS_HDMI_I2CM_CTLINT_arbitration_mask (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_arbitration_mask. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_arbitration_mask field. */
#define BR_HDMI_I2CM_CTLINT_arbitration_mask(x) (HW_HDMI_I2CM_CTLINT(x).B.arbitration_mask)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_arbitration_mask. */
#define BF_HDMI_I2CM_CTLINT_arbitration_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_arbitration_mask) & BM_HDMI_I2CM_CTLINT_arbitration_mask)

/*! @brief Set the arbitration_mask field to a new value. */
#define BW_HDMI_I2CM_CTLINT_arbitration_mask(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_arbitration_mask) | BF_HDMI_I2CM_CTLINT_arbitration_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field arbitration_pol[3] (RW)
 *
 * Arbitration error interrupt polarity configuration.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_arbitration_pol (3U) /*!< Bit position for HDMI_I2CM_CTLINT_arbitration_pol. */
#define BM_HDMI_I2CM_CTLINT_arbitration_pol (0x08U) /*!< Bit mask for HDMI_I2CM_CTLINT_arbitration_pol. */
#define BS_HDMI_I2CM_CTLINT_arbitration_pol (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_arbitration_pol. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_arbitration_pol field. */
#define BR_HDMI_I2CM_CTLINT_arbitration_pol(x) (HW_HDMI_I2CM_CTLINT(x).B.arbitration_pol)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_arbitration_pol. */
#define BF_HDMI_I2CM_CTLINT_arbitration_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_arbitration_pol) & BM_HDMI_I2CM_CTLINT_arbitration_pol)

/*! @brief Set the arbitration_pol field to a new value. */
#define BW_HDMI_I2CM_CTLINT_arbitration_pol(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_arbitration_pol) | BF_HDMI_I2CM_CTLINT_arbitration_pol(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field nack_status[4] (RW)
 *
 * Not acknowledge error status bit. Error on I2C not acknowledge.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_nack_status (4U) /*!< Bit position for HDMI_I2CM_CTLINT_nack_status. */
#define BM_HDMI_I2CM_CTLINT_nack_status (0x10U) /*!< Bit mask for HDMI_I2CM_CTLINT_nack_status. */
#define BS_HDMI_I2CM_CTLINT_nack_status (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_nack_status. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_nack_status field. */
#define BR_HDMI_I2CM_CTLINT_nack_status(x) (HW_HDMI_I2CM_CTLINT(x).B.nack_status)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_nack_status. */
#define BF_HDMI_I2CM_CTLINT_nack_status(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_nack_status) & BM_HDMI_I2CM_CTLINT_nack_status)

/*! @brief Set the nack_status field to a new value. */
#define BW_HDMI_I2CM_CTLINT_nack_status(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_nack_status) | BF_HDMI_I2CM_CTLINT_nack_status(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field nack_interrupt[5] (RW)
 *
 * Not acknowledge error interrupt bit. Only lasts for 1 SFR clock cycle and is
 * auto cleaned after it. {nack_interrupt = (nack_mask==0b) &&
 * (nack_status==nack_pol)}.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_nack_interrupt (5U) /*!< Bit position for HDMI_I2CM_CTLINT_nack_interrupt. */
#define BM_HDMI_I2CM_CTLINT_nack_interrupt (0x20U) /*!< Bit mask for HDMI_I2CM_CTLINT_nack_interrupt. */
#define BS_HDMI_I2CM_CTLINT_nack_interrupt (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_nack_interrupt. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_nack_interrupt field. */
#define BR_HDMI_I2CM_CTLINT_nack_interrupt(x) (HW_HDMI_I2CM_CTLINT(x).B.nack_interrupt)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_nack_interrupt. */
#define BF_HDMI_I2CM_CTLINT_nack_interrupt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_nack_interrupt) & BM_HDMI_I2CM_CTLINT_nack_interrupt)

/*! @brief Set the nack_interrupt field to a new value. */
#define BW_HDMI_I2CM_CTLINT_nack_interrupt(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_nack_interrupt) | BF_HDMI_I2CM_CTLINT_nack_interrupt(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field nack_mask[6] (RW)
 *
 * Not acknowledge error interrupt mask signal.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_nack_mask (6U) /*!< Bit position for HDMI_I2CM_CTLINT_nack_mask. */
#define BM_HDMI_I2CM_CTLINT_nack_mask (0x40U) /*!< Bit mask for HDMI_I2CM_CTLINT_nack_mask. */
#define BS_HDMI_I2CM_CTLINT_nack_mask (1U) /*!< Bit field size in bits for HDMI_I2CM_CTLINT_nack_mask. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_nack_mask field. */
#define BR_HDMI_I2CM_CTLINT_nack_mask(x) (HW_HDMI_I2CM_CTLINT(x).B.nack_mask)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_nack_mask. */
#define BF_HDMI_I2CM_CTLINT_nack_mask(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_nack_mask) & BM_HDMI_I2CM_CTLINT_nack_mask)

/*! @brief Set the nack_mask field to a new value. */
#define BW_HDMI_I2CM_CTLINT_nack_mask(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_nack_mask) | BF_HDMI_I2CM_CTLINT_nack_mask(v)))
/*@}*/

/*!
 * @name Register HDMI_I2CM_CTLINT, field nack_pol[7] (RW)
 *
 * Not acknowledge error interrupt polarity configuration.
 */
/*@{*/
#define BP_HDMI_I2CM_CTLINT_nack_pol (7U)  /*!< Bit position for HDMI_I2CM_CTLINT_nack_pol. */
#define BM_HDMI_I2CM_CTLINT_nack_pol (0x80U) /*!< Bit mask for HDMI_I2CM_CTLINT_nack_pol. */
#define BS_HDMI_I2CM_CTLINT_nack_pol (1U)  /*!< Bit field size in bits for HDMI_I2CM_CTLINT_nack_pol. */

/*! @brief Read current value of the HDMI_I2CM_CTLINT_nack_pol field. */
#define BR_HDMI_I2CM_CTLINT_nack_pol(x) (HW_HDMI_I2CM_CTLINT(x).B.nack_pol)

/*! @brief Format value for bitfield HDMI_I2CM_CTLINT_nack_pol. */
#define BF_HDMI_I2CM_CTLINT_nack_pol(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_CTLINT_nack_pol) & BM_HDMI_I2CM_CTLINT_nack_pol)

/*! @brief Set the nack_pol field to a new value. */
#define BW_HDMI_I2CM_CTLINT_nack_pol(x, v) (HW_HDMI_I2CM_CTLINT_WR(x, (HW_HDMI_I2CM_CTLINT_RD(x) & ~BM_HDMI_I2CM_CTLINT_nack_pol) | BF_HDMI_I2CM_CTLINT_nack_pol(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_DIV - I2CM_DIV
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_DIV - I2CM_DIV (RW)
 *
 * Reset value: 0x0BU
 *
 * This register configures the division relation between master and scl clock.
 * Address Offset: 0x7E07 Size: 8 bits Value after Reset: 0x0B Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_div
{
    uint8_t U;
    struct _hw_hdmi_i2cm_div_bitfields
    {
        uint8_t RESERVED0 : 3;         /*!< [2:0]  */
        uint8_t fast_std_mode : 1;     /*!< [3]  */
        uint8_t RESERVED1 : 4;         /*!< [7:4]  */
    } B;
} hw_hdmi_i2cm_div_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_DIV register
 */
/*@{*/
#define HW_HDMI_I2CM_DIV_ADDR(x) ((uintptr_t)(x) + 0x7E07U)

#define HW_HDMI_I2CM_DIV(x)      (*(__IO hw_hdmi_i2cm_div_t *) HW_HDMI_I2CM_DIV_ADDR(x))
#define HW_HDMI_I2CM_DIV_RD(x)   (HW_HDMI_I2CM_DIV(x).U)
#define HW_HDMI_I2CM_DIV_WR(x, v) (HW_HDMI_I2CM_DIV(x).U = (v))
#define HW_HDMI_I2CM_DIV_SET(x, v) (HW_HDMI_I2CM_DIV_WR(x, HW_HDMI_I2CM_DIV_RD(x) |  (v)))
#define HW_HDMI_I2CM_DIV_CLR(x, v) (HW_HDMI_I2CM_DIV_WR(x, HW_HDMI_I2CM_DIV_RD(x) & ~(v)))
#define HW_HDMI_I2CM_DIV_TOG(x, v) (HW_HDMI_I2CM_DIV_WR(x, HW_HDMI_I2CM_DIV_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_DIV bitfields
 */

/*!
 * @name Register HDMI_I2CM_DIV, field fast_std_mode[3] (RW)
 *
 * Sets the I2C Master to work in Fast Mode or Standard Mode:
 *
 * Values:
 * - 1 - Fast Mode
 * - 0 - Standard Mode
 */
/*@{*/
#define BP_HDMI_I2CM_DIV_fast_std_mode (3U) /*!< Bit position for HDMI_I2CM_DIV_fast_std_mode. */
#define BM_HDMI_I2CM_DIV_fast_std_mode (0x08U) /*!< Bit mask for HDMI_I2CM_DIV_fast_std_mode. */
#define BS_HDMI_I2CM_DIV_fast_std_mode (1U) /*!< Bit field size in bits for HDMI_I2CM_DIV_fast_std_mode. */

/*! @brief Read current value of the HDMI_I2CM_DIV_fast_std_mode field. */
#define BR_HDMI_I2CM_DIV_fast_std_mode(x) (HW_HDMI_I2CM_DIV(x).B.fast_std_mode)

/*! @brief Format value for bitfield HDMI_I2CM_DIV_fast_std_mode. */
#define BF_HDMI_I2CM_DIV_fast_std_mode(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_DIV_fast_std_mode) & BM_HDMI_I2CM_DIV_fast_std_mode)

/*! @brief Set the fast_std_mode field to a new value. */
#define BW_HDMI_I2CM_DIV_fast_std_mode(x, v) (HW_HDMI_I2CM_DIV_WR(x, (HW_HDMI_I2CM_DIV_RD(x) & ~BM_HDMI_I2CM_DIV_fast_std_mode) | BF_HDMI_I2CM_DIV_fast_std_mode(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SEGADDR - I2CM_SEGADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SEGADDR - I2CM_SEGADDR (RW)
 *
 * Reset value: 0x00U
 *
 * This register configures the segment address for extended RD/WR destination.
 * Address Offset: 0x7E08 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_segaddr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_segaddr_bitfields
    {
        uint8_t SEGADDR : 7;           /*!< [6:0]  */
        uint8_t RESERVED0 : 1;         /*!< [7]  */
    } B;
} hw_hdmi_i2cm_segaddr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SEGADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_SEGADDR_ADDR(x) ((uintptr_t)(x) + 0x7E08U)

#define HW_HDMI_I2CM_SEGADDR(x)  (*(__IO hw_hdmi_i2cm_segaddr_t *) HW_HDMI_I2CM_SEGADDR_ADDR(x))
#define HW_HDMI_I2CM_SEGADDR_RD(x) (HW_HDMI_I2CM_SEGADDR(x).U)
#define HW_HDMI_I2CM_SEGADDR_WR(x, v) (HW_HDMI_I2CM_SEGADDR(x).U = (v))
#define HW_HDMI_I2CM_SEGADDR_SET(x, v) (HW_HDMI_I2CM_SEGADDR_WR(x, HW_HDMI_I2CM_SEGADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SEGADDR_CLR(x, v) (HW_HDMI_I2CM_SEGADDR_WR(x, HW_HDMI_I2CM_SEGADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SEGADDR_TOG(x, v) (HW_HDMI_I2CM_SEGADDR_WR(x, HW_HDMI_I2CM_SEGADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SEGADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SEGADDR, field SEGADDR[6:0] (RW)
 *
 * E-DDC Extended read segment address
 */
/*@{*/
#define BP_HDMI_I2CM_SEGADDR_SEGADDR (0U)  /*!< Bit position for HDMI_I2CM_SEGADDR_SEGADDR. */
#define BM_HDMI_I2CM_SEGADDR_SEGADDR (0x7FU) /*!< Bit mask for HDMI_I2CM_SEGADDR_SEGADDR. */
#define BS_HDMI_I2CM_SEGADDR_SEGADDR (7U)  /*!< Bit field size in bits for HDMI_I2CM_SEGADDR_SEGADDR. */

/*! @brief Read current value of the HDMI_I2CM_SEGADDR_SEGADDR field. */
#define BR_HDMI_I2CM_SEGADDR_SEGADDR(x) (HW_HDMI_I2CM_SEGADDR(x).B.SEGADDR)

/*! @brief Format value for bitfield HDMI_I2CM_SEGADDR_SEGADDR. */
#define BF_HDMI_I2CM_SEGADDR_SEGADDR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SEGADDR_SEGADDR) & BM_HDMI_I2CM_SEGADDR_SEGADDR)

/*! @brief Set the SEGADDR field to a new value. */
#define BW_HDMI_I2CM_SEGADDR_SEGADDR(x, v) (HW_HDMI_I2CM_SEGADDR_WR(x, (HW_HDMI_I2CM_SEGADDR_RD(x) & ~BM_HDMI_I2CM_SEGADDR_SEGADDR) | BF_HDMI_I2CM_SEGADDR_SEGADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SOFTRSTZ - I2CM_SOFTRSTZ
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SOFTRSTZ - I2CM_SOFTRSTZ (RW)
 *
 * Reset value: 0x01U
 *
 * This register resets the I2C master. Address Offset: 0x7E09 Size: 8 bits
 * Value after Reset: 0x01 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_softrstz
{
    uint8_t U;
    struct _hw_hdmi_i2cm_softrstz_bitfields
    {
        uint8_t i2c_softrst : 1;       /*!< [0]  */
        uint8_t RESERVED0 : 7;         /*!< [7:1]  */
    } B;
} hw_hdmi_i2cm_softrstz_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SOFTRSTZ register
 */
/*@{*/
#define HW_HDMI_I2CM_SOFTRSTZ_ADDR(x) ((uintptr_t)(x) + 0x7E09U)

#define HW_HDMI_I2CM_SOFTRSTZ(x) (*(__IO hw_hdmi_i2cm_softrstz_t *) HW_HDMI_I2CM_SOFTRSTZ_ADDR(x))
#define HW_HDMI_I2CM_SOFTRSTZ_RD(x) (HW_HDMI_I2CM_SOFTRSTZ(x).U)
#define HW_HDMI_I2CM_SOFTRSTZ_WR(x, v) (HW_HDMI_I2CM_SOFTRSTZ(x).U = (v))
#define HW_HDMI_I2CM_SOFTRSTZ_SET(x, v) (HW_HDMI_I2CM_SOFTRSTZ_WR(x, HW_HDMI_I2CM_SOFTRSTZ_RD(x) |  (v)))
#define HW_HDMI_I2CM_SOFTRSTZ_CLR(x, v) (HW_HDMI_I2CM_SOFTRSTZ_WR(x, HW_HDMI_I2CM_SOFTRSTZ_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SOFTRSTZ_TOG(x, v) (HW_HDMI_I2CM_SOFTRSTZ_WR(x, HW_HDMI_I2CM_SOFTRSTZ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SOFTRSTZ bitfields
 */

/*!
 * @name Register HDMI_I2CM_SOFTRSTZ, field i2c_softrst[0] (RW)
 *
 * I2C Master Software Reset. Active by writing a zero and auto cleared to one
 * in the following cycle. Value after Reset: 1b
 */
/*@{*/
#define BP_HDMI_I2CM_SOFTRSTZ_i2c_softrst (0U) /*!< Bit position for HDMI_I2CM_SOFTRSTZ_i2c_softrst. */
#define BM_HDMI_I2CM_SOFTRSTZ_i2c_softrst (0x01U) /*!< Bit mask for HDMI_I2CM_SOFTRSTZ_i2c_softrst. */
#define BS_HDMI_I2CM_SOFTRSTZ_i2c_softrst (1U) /*!< Bit field size in bits for HDMI_I2CM_SOFTRSTZ_i2c_softrst. */

/*! @brief Read current value of the HDMI_I2CM_SOFTRSTZ_i2c_softrst field. */
#define BR_HDMI_I2CM_SOFTRSTZ_i2c_softrst(x) (HW_HDMI_I2CM_SOFTRSTZ(x).B.i2c_softrst)

/*! @brief Format value for bitfield HDMI_I2CM_SOFTRSTZ_i2c_softrst. */
#define BF_HDMI_I2CM_SOFTRSTZ_i2c_softrst(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SOFTRSTZ_i2c_softrst) & BM_HDMI_I2CM_SOFTRSTZ_i2c_softrst)

/*! @brief Set the i2c_softrst field to a new value. */
#define BW_HDMI_I2CM_SOFTRSTZ_i2c_softrst(x, v) (HW_HDMI_I2CM_SOFTRSTZ_WR(x, (HW_HDMI_I2CM_SOFTRSTZ_RD(x) & ~BM_HDMI_I2CM_SOFTRSTZ_i2c_softrst) | BF_HDMI_I2CM_SOFTRSTZ_i2c_softrst(v)))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SEGPTR - I2CM_SEGPTR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SEGPTR - I2CM_SEGPTR (RW)
 *
 * Reset value: 0x00U
 *
 * This register configures the segment pointer for extended RD/WR request.
 * Address Offset: 0x7E0A Size: 8 bits Value after Reset: 0x00 Access: Read/Write The
 * following *CNT registers must be set before any I2C bus transaction can take
 * place to ensure proper I/O timing.
 */
typedef union _hw_hdmi_i2cm_segptr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_segptr_bitfields
    {
        uint8_t I2CM_SEGPTR : 8;       /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_segptr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SEGPTR register
 */
/*@{*/
#define HW_HDMI_I2CM_SEGPTR_ADDR(x) ((uintptr_t)(x) + 0x7E0AU)

#define HW_HDMI_I2CM_SEGPTR(x)   (*(__IO hw_hdmi_i2cm_segptr_t *) HW_HDMI_I2CM_SEGPTR_ADDR(x))
#define HW_HDMI_I2CM_SEGPTR_RD(x) (HW_HDMI_I2CM_SEGPTR(x).U)
#define HW_HDMI_I2CM_SEGPTR_WR(x, v) (HW_HDMI_I2CM_SEGPTR(x).U = (v))
#define HW_HDMI_I2CM_SEGPTR_SET(x, v) (HW_HDMI_I2CM_SEGPTR_WR(x, HW_HDMI_I2CM_SEGPTR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SEGPTR_CLR(x, v) (HW_HDMI_I2CM_SEGPTR_WR(x, HW_HDMI_I2CM_SEGPTR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SEGPTR_TOG(x, v) (HW_HDMI_I2CM_SEGPTR_WR(x, HW_HDMI_I2CM_SEGPTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SEGPTR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SEGPTR, field I2CM_SEGPTR[7:0] (RW)
 *
 * I2CM_SEGPTR is used for EDID reading operations, particularly for the
 * Extended Data Read Operation (See I2C Master Interface Extended Read ModeThis I2C
 * extended read mode operation implements a segment pointer-based read operation
 * using the Special Register configuration. ") which is used for Enhanced DDC.
 * This is all described in the VESA Enhanced Display Data Channel Standard v1.1
 * spec. (addresses A0h/A1h pairs and a segment pointer - 60h).
 */
/*@{*/
#define BP_HDMI_I2CM_SEGPTR_I2CM_SEGPTR (0U) /*!< Bit position for HDMI_I2CM_SEGPTR_I2CM_SEGPTR. */
#define BM_HDMI_I2CM_SEGPTR_I2CM_SEGPTR (0xFFU) /*!< Bit mask for HDMI_I2CM_SEGPTR_I2CM_SEGPTR. */
#define BS_HDMI_I2CM_SEGPTR_I2CM_SEGPTR (8U) /*!< Bit field size in bits for HDMI_I2CM_SEGPTR_I2CM_SEGPTR. */

/*! @brief Read current value of the HDMI_I2CM_SEGPTR_I2CM_SEGPTR field. */
#define BR_HDMI_I2CM_SEGPTR_I2CM_SEGPTR(x) (HW_HDMI_I2CM_SEGPTR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_SEGPTR_I2CM_SEGPTR. */
#define BF_HDMI_I2CM_SEGPTR_I2CM_SEGPTR(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SEGPTR_I2CM_SEGPTR) & BM_HDMI_I2CM_SEGPTR_I2CM_SEGPTR)

/*! @brief Set the I2CM_SEGPTR field to a new value. */
#define BW_HDMI_I2CM_SEGPTR_I2CM_SEGPTR(x, v) (HW_HDMI_I2CM_SEGPTR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR - I2CM_SS_SCL_HCNT_1_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR - I2CM_SS_SCL_HCNT_1_ADDR (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E0B Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_ss_scl_hcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_ss_scl_hcnt_1_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_ss_scl_hcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SS_SCL_HCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E0BU)

#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR(x) (*(__IO hw_hdmi_i2cm_ss_scl_hcnt_1_addr_t *) HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_ADDR(x))
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR(x).U)
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR(x).U = (v))
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_SET(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_CLR(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_TOG(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SS_SCL_HCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SS_SCL_HCNT_1_ADDR, field i2cmp_ss_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (0U) /*!< Bit position for HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BM_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BS_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */

/*! @brief Read current value of the HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt field. */
#define BR_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(x) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt. */
#define BF_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt) & BM_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt)

/*! @brief Set the i2cmp_ss_scl_hcnt field to a new value. */
#define BW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_i2cmp_ss_scl_hcnt(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR - I2CM_SS_SCL_HCNT_0_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR - I2CM_SS_SCL_HCNT_0_ADDR (RW)
 *
 * Reset value: 0x6CU
 *
 * Address Offset: 0x7E0C Size: 8 bits Value after Reset: 0x6C Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_ss_scl_hcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_ss_scl_hcnt_0_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_ss_scl_hcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SS_SCL_HCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E0CU)

#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR(x) (*(__IO hw_hdmi_i2cm_ss_scl_hcnt_0_addr_t *) HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_ADDR(x))
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR(x).U)
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR(x).U = (v))
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_SET(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_CLR(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_TOG(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SS_SCL_HCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SS_SCL_HCNT_0_ADDR, field i2cmp_ss_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h6C
 */
/*@{*/
#define BP_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (0U) /*!< Bit position for HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BM_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BS_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */

/*! @brief Read current value of the HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt field. */
#define BR_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(x) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt. */
#define BF_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt) & BM_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt)

/*! @brief Set the i2cmp_ss_scl_hcnt field to a new value. */
#define BW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_i2cmp_ss_scl_hcnt(x, v) (HW_HDMI_I2CM_SS_SCL_HCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR - I2CM_SS_SCL_LCNT_1_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR - I2CM_SS_SCL_LCNT_1_ADDR (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E0D Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_ss_scl_lcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_ss_scl_lcnt_1_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_ss_scl_lcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SS_SCL_LCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E0DU)

#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR(x) (*(__IO hw_hdmi_i2cm_ss_scl_lcnt_1_addr_t *) HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_ADDR(x))
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR(x).U)
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR(x).U = (v))
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_SET(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_CLR(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_TOG(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SS_SCL_LCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SS_SCL_LCNT_1_ADDR, field i2cmp_ss_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (0U) /*!< Bit position for HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BM_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BS_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */

/*! @brief Read current value of the HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt field. */
#define BR_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(x) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt. */
#define BF_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt) & BM_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt)

/*! @brief Set the i2cmp_ss_scl_lcnt field to a new value. */
#define BW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_i2cmp_ss_scl_lcnt(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR - I2CM_SS_SCL_LCNT_0_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR - I2CM_SS_SCL_LCNT_0_ADDR (RW)
 *
 * Reset value: 0x7FU
 *
 * Address Offset: 0x7E0E Size: 8 bits Value after Reset: 0x7F Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_ss_scl_lcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_ss_scl_lcnt_0_addr_bitfields
    {
        uint8_t i2cmp_ss_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_ss_scl_lcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_SS_SCL_LCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E0EU)

#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR(x) (*(__IO hw_hdmi_i2cm_ss_scl_lcnt_0_addr_t *) HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_ADDR(x))
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR(x).U)
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR(x).U = (v))
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_SET(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_CLR(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_TOG(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_SS_SCL_LCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_SS_SCL_LCNT_0_ADDR, field i2cmp_ss_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h7F
 */
/*@{*/
#define BP_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (0U) /*!< Bit position for HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BM_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BS_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */

/*! @brief Read current value of the HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt field. */
#define BR_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(x) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt. */
#define BF_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt) & BM_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt)

/*! @brief Set the i2cmp_ss_scl_lcnt field to a new value. */
#define BW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_i2cmp_ss_scl_lcnt(x, v) (HW_HDMI_I2CM_SS_SCL_LCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR - I2CM_FS_SCL_HCNT_1_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR - I2CM_FS_SCL_HCNT_1_ADDR (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E0F Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_fs_scl_hcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_fs_scl_hcnt_1_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_fs_scl_hcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_FS_SCL_HCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E0FU)

#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR(x) (*(__IO hw_hdmi_i2cm_fs_scl_hcnt_1_addr_t *) HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_ADDR(x))
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR(x).U)
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR(x).U = (v))
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_SET(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_CLR(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_TOG(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_FS_SCL_HCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_FS_SCL_HCNT_1_ADDR, field i2cmp_fs_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (0U) /*!< Bit position for HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BM_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BS_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */

/*! @brief Read current value of the HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt field. */
#define BR_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(x) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt. */
#define BF_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt) & BM_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt)

/*! @brief Set the i2cmp_fs_scl_hcnt field to a new value. */
#define BW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_i2cmp_fs_scl_hcnt(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR - I2CM_FS_SCL_HCNT_0_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR - I2CM_FS_SCL_HCNT_0_ADDR (RW)
 *
 * Reset value: 0x11U
 *
 * Address Offset: 0x7E10 Size: 8 bits Value after Reset: 0x11 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_fs_scl_hcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_fs_scl_hcnt_0_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_hcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_fs_scl_hcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_FS_SCL_HCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E10U)

#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR(x) (*(__IO hw_hdmi_i2cm_fs_scl_hcnt_0_addr_t *) HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_ADDR(x))
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR(x).U)
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR(x).U = (v))
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_SET(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_CLR(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_TOG(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_FS_SCL_HCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_FS_SCL_HCNT_0_ADDR, field i2cmp_fs_scl_hcnt[7:0] (RW)
 *
 * Value after Reset: 8'h11
 */
/*@{*/
#define BP_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (0U) /*!< Bit position for HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BM_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BS_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */

/*! @brief Read current value of the HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt field. */
#define BR_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(x) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt. */
#define BF_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt) & BM_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt)

/*! @brief Set the i2cmp_fs_scl_hcnt field to a new value. */
#define BW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_i2cmp_fs_scl_hcnt(x, v) (HW_HDMI_I2CM_FS_SCL_HCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR - I2CM_FS_SCL_LCNT_1_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR - I2CM_FS_SCL_LCNT_1_ADDR (RW)
 *
 * Reset value: 0x00U
 *
 * Address Offset: 0x7E11 Size: 8 bits Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_fs_scl_lcnt_1_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_fs_scl_lcnt_1_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_fs_scl_lcnt_1_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_FS_SCL_LCNT_1_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E11U)

#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR(x) (*(__IO hw_hdmi_i2cm_fs_scl_lcnt_1_addr_t *) HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_ADDR(x))
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR(x).U)
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR(x).U = (v))
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_SET(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_CLR(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_TOG(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_FS_SCL_LCNT_1_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_FS_SCL_LCNT_1_ADDR, field i2cmp_fs_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h00
 */
/*@{*/
#define BP_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (0U) /*!< Bit position for HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BM_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BS_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */

/*! @brief Read current value of the HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt field. */
#define BR_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(x) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt. */
#define BF_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt) & BM_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt)

/*! @brief Set the i2cmp_fs_scl_lcnt field to a new value. */
#define BW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_i2cmp_fs_scl_lcnt(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_1_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR - I2CM_FS_SCL_LCNT_0_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR - I2CM_FS_SCL_LCNT_0_ADDR (RW)
 *
 * Reset value: 0x24U
 *
 * Address Offset: 0x7E12 Size: 8 bits Value after Reset: 0x24 Access: Read/Write
 */
typedef union _hw_hdmi_i2cm_fs_scl_lcnt_0_addr
{
    uint8_t U;
    struct _hw_hdmi_i2cm_fs_scl_lcnt_0_addr_bitfields
    {
        uint8_t i2cmp_fs_scl_lcnt : 8; /*!< [7:0]  */
    } B;
} hw_hdmi_i2cm_fs_scl_lcnt_0_addr_t;

/*!
 * @name Constants and macros for entire HDMI_I2CM_FS_SCL_LCNT_0_ADDR register
 */
/*@{*/
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7E12U)

#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR(x) (*(__IO hw_hdmi_i2cm_fs_scl_lcnt_0_addr_t *) HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_ADDR(x))
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR(x).U)
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR(x).U = (v))
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_SET(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) |  (v)))
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_CLR(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) & ~(v)))
#define HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_TOG(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_I2CM_FS_SCL_LCNT_0_ADDR bitfields
 */

/*!
 * @name Register HDMI_I2CM_FS_SCL_LCNT_0_ADDR, field i2cmp_fs_scl_lcnt[7:0] (RW)
 *
 * Value after Reset: 8'h24
 */
/*@{*/
#define BP_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (0U) /*!< Bit position for HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BM_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (0xFFU) /*!< Bit mask for HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BS_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt (8U) /*!< Bit field size in bits for HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */

/*! @brief Read current value of the HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt field. */
#define BR_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(x) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR(x).U)

/*! @brief Format value for bitfield HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt. */
#define BF_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt) & BM_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt)

/*! @brief Set the i2cmp_fs_scl_lcnt field to a new value. */
#define BW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_i2cmp_fs_scl_lcnt(x, v) (HW_HDMI_I2CM_FS_SCL_LCNT_0_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HDMI_BASE_POINTER_ADDR - BASE_POINTER_ADDR
 ******************************************************************************/

/*!
 * @brief HW_HDMI_BASE_POINTER_ADDR - BASE_POINTER_ADDR (RW)
 *
 * Reset value: 0x00U
 *
 * The I2C Slave Registers allow register memory pagination, and function in the
 * incremental burst operation mode that increases the data throughput when
 * consecutive addressed registers need to be read or write. The I2C base pointer
 * operation mode is a aimed to allow register memory pagination. As long as this
 * operational mode is enabled the value written to this register will be used as
 * the seven most significant bits of the internal Special Function Register
 * address interface (sfraddr[14:8]) for all read or write operations. I2C data
 * transfer protocol used shall be the 7-bit addressed as defined in the section 9 of
 * the I2C-bus Specification, version 2.1. Address Offset: 0x7F00 Size: 8 bits
 * Value after Reset: 0x00 Access: Read/Write
 */
typedef union _hw_hdmi_base_pointer_addr
{
    uint8_t U;
    struct _hw_hdmi_base_pointer_addr_bitfields
    {
        uint8_t base_pointer_base_addr : 7; /*!< [6:0]  */
        uint8_t en_base_pointer_addr : 1; /*!< [7]  */
    } B;
} hw_hdmi_base_pointer_addr_t;

/*!
 * @name Constants and macros for entire HDMI_BASE_POINTER_ADDR register
 */
/*@{*/
#define HW_HDMI_BASE_POINTER_ADDR_ADDR(x) ((uintptr_t)(x) + 0x7F00U)

#define HW_HDMI_BASE_POINTER_ADDR(x) (*(__IO hw_hdmi_base_pointer_addr_t *) HW_HDMI_BASE_POINTER_ADDR_ADDR(x))
#define HW_HDMI_BASE_POINTER_ADDR_RD(x) (HW_HDMI_BASE_POINTER_ADDR(x).U)
#define HW_HDMI_BASE_POINTER_ADDR_WR(x, v) (HW_HDMI_BASE_POINTER_ADDR(x).U = (v))
#define HW_HDMI_BASE_POINTER_ADDR_SET(x, v) (HW_HDMI_BASE_POINTER_ADDR_WR(x, HW_HDMI_BASE_POINTER_ADDR_RD(x) |  (v)))
#define HW_HDMI_BASE_POINTER_ADDR_CLR(x, v) (HW_HDMI_BASE_POINTER_ADDR_WR(x, HW_HDMI_BASE_POINTER_ADDR_RD(x) & ~(v)))
#define HW_HDMI_BASE_POINTER_ADDR_TOG(x, v) (HW_HDMI_BASE_POINTER_ADDR_WR(x, HW_HDMI_BASE_POINTER_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HDMI_BASE_POINTER_ADDR bitfields
 */

/*!
 * @name Register HDMI_BASE_POINTER_ADDR, field base_pointer_base_addr[6:0] (RW)
 *
 * Defines the base address for base pointer operation mode. They represent the
 * address bits [14:8]
 */
/*@{*/
#define BP_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr (0U) /*!< Bit position for HDMI_BASE_POINTER_ADDR_base_pointer_base_addr. */
#define BM_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr (0x7FU) /*!< Bit mask for HDMI_BASE_POINTER_ADDR_base_pointer_base_addr. */
#define BS_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr (7U) /*!< Bit field size in bits for HDMI_BASE_POINTER_ADDR_base_pointer_base_addr. */

/*! @brief Read current value of the HDMI_BASE_POINTER_ADDR_base_pointer_base_addr field. */
#define BR_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr(x) (HW_HDMI_BASE_POINTER_ADDR(x).B.base_pointer_base_addr)

/*! @brief Format value for bitfield HDMI_BASE_POINTER_ADDR_base_pointer_base_addr. */
#define BF_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr) & BM_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr)

/*! @brief Set the base_pointer_base_addr field to a new value. */
#define BW_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr(x, v) (HW_HDMI_BASE_POINTER_ADDR_WR(x, (HW_HDMI_BASE_POINTER_ADDR_RD(x) & ~BM_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr) | BF_HDMI_BASE_POINTER_ADDR_base_pointer_base_addr(v)))
/*@}*/

/*!
 * @name Register HDMI_BASE_POINTER_ADDR, field en_base_pointer_addr[7] (RW)
 *
 * Enables the base pointer operation mode.
 */
/*@{*/
#define BP_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr (7U) /*!< Bit position for HDMI_BASE_POINTER_ADDR_en_base_pointer_addr. */
#define BM_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr (0x80U) /*!< Bit mask for HDMI_BASE_POINTER_ADDR_en_base_pointer_addr. */
#define BS_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr (1U) /*!< Bit field size in bits for HDMI_BASE_POINTER_ADDR_en_base_pointer_addr. */

/*! @brief Read current value of the HDMI_BASE_POINTER_ADDR_en_base_pointer_addr field. */
#define BR_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr(x) (HW_HDMI_BASE_POINTER_ADDR(x).B.en_base_pointer_addr)

/*! @brief Format value for bitfield HDMI_BASE_POINTER_ADDR_en_base_pointer_addr. */
#define BF_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr(v) ((uint8_t)((uint8_t)(v) << BP_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr) & BM_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr)

/*! @brief Set the en_base_pointer_addr field to a new value. */
#define BW_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr(x, v) (HW_HDMI_BASE_POINTER_ADDR_WR(x, (HW_HDMI_BASE_POINTER_ADDR_RD(x) & ~BM_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr) | BF_HDMI_BASE_POINTER_ADDR_en_base_pointer_addr(v)))
/*@}*/

/*******************************************************************************
 * hw_hdmi_t - module struct
 ******************************************************************************/
/*!
 * @brief All HDMI module registers.
 */
#pragma pack(1)
typedef struct _hw_hdmi
{
    __I hw_hdmi_design_id_t DESIGN_ID;     /*!< [0x0] Design Identification Register */
    __I hw_hdmi_revision_id_t REVISION_ID; /*!< [0x1] Revision Identification Register */
    __I hw_hdmi_product_id0_t PRODUCT_ID0; /*!< [0x2] Product Identification Register 0 */
    __I hw_hdmi_product_id1_t PRODUCT_ID1; /*!< [0x3] Product Identification Register 1 */
    __I hw_hdmi_config0_id_t CONFIG0_ID;   /*!< [0x4] Configuration Identification Register 0 */
    __I hw_hdmi_config1_id_t CONFIG1_ID;   /*!< [0x5] Configuration Identification Register 1 */
    __I hw_hdmi_config2_id_t CONFIG2_ID;   /*!< [0x6] Configuration Identification Register 2 */
    __I hw_hdmi_config3_id_t CONFIG3_ID;   /*!< [0x7] Configuration Identification Register 3 */
    uint8_t _reserved0[248];
    __IO hw_hdmi_ih_fc_stat0_t IH_FC_STAT0; /*!< [0x100] Frame Composer Interrupt Status Register 0 */
    __IO hw_hdmi_ih_fc_stat1_t IH_FC_STAT1; /*!< [0x101] Frame Composer Interrupt Status Register 1 */
    __IO hw_hdmi_ih_fc_stat2_t IH_FC_STAT2; /*!< [0x102] Frame Composer Interrupt Status Register 2 */
    __IO hw_hdmi_ih_as_stat0_t IH_AS_STAT0; /*!< [0x103] Audio Sampler Interrupt Status Register */
    __IO hw_hdmi_ih_phy_stat0_t IH_PHY_STAT0; /*!< [0x104] PHY Interface Interrupt Status Register */
    __IO hw_hdmi_ih_i2cm_stat0_t IH_I2CM_STAT0; /*!< [0x105] E-DDC I2C Master Interrupt Status Register */
    __IO hw_hdmi_ih_cec_stat0_t IH_CEC_STAT0; /*!< [0x106] CEC Interrupt Status Register */
    __IO hw_hdmi_ih_vp_stat0_t IH_VP_STAT0; /*!< [0x107] Video Packetizer Interrupt Status Register */
    __IO hw_hdmi_ih_i2cmphy_stat0_t IH_I2CMPHY_STAT0; /*!< [0x108] PHY GEN2 I2C Master Interrupt Status Register */
    __IO hw_hdmi_ih_ahbdmaaud_stat0_t IH_AHBDMAAUD_STAT0; /*!< [0x109] AHB Audio DMA Interrupt Status Register */
    uint8_t _reserved1[118];
    __IO hw_hdmi_ih_mute_fc_stat0_t IH_MUTE_FC_STAT0; /*!< [0x180] Frame Composer Interrupt Mute Control Register 0 */
    __IO hw_hdmi_ih_mute_fc_stat1_t IH_MUTE_FC_STAT1; /*!< [0x181] Frame Composer Interrupt Mute Control Register 1 */
    __IO hw_hdmi_ih_mute_fc_stat2_t IH_MUTE_FC_STAT2; /*!< [0x182] Frame Composer Interrupt Mute Control Register 2 */
    __IO hw_hdmi_ih_mute_as_stat0_t IH_MUTE_AS_STAT0; /*!< [0x183] Audio Sampler Interrupt Mute Control Register 0 */
    __IO hw_hdmi_ih_mute_phy_stat0_t IH_MUTE_PHY_STAT0; /*!< [0x184] PHY Interface Interrupt Mute Control Register */
    __IO hw_hdmi_ih_mute_i2cm_stat0_t IH_MUTE_I2CM_STAT0; /*!< [0x185] E-DDC I2C Master Interrupt Mute Control Register */
    __IO hw_hdmi_ih_mute_cec_stat0_t IH_MUTE_CEC_STAT0; /*!< [0x186] CEC Interrupt Mute Control Register */
    __IO hw_hdmi_ih_mute_vp_stat0_t IH_MUTE_VP_STAT0; /*!< [0x187] Video Packetizer Interrupt Mute Control Register */
    __IO hw_hdmi_ih_mute_i2cmphy_stat0_t IH_MUTE_I2CMPHY_STAT0; /*!< [0x188] PHY GEN 2 I2C Master Interrupt Mute Control Register */
    __IO hw_hdmi_ih_mute_ahbdmaaud_stat0_t IH_MUTE_AHBDMAAUD_STAT0; /*!< [0x189] AHB Audio DMA Interrupt Mute Control Register */
    uint8_t _reserved2[117];
    __IO hw_hdmi_ih_mute_t IH_MUTE;        /*!< [0x1FF] Global Interrupt Mute Control Register */
    __IO hw_hdmi_tx_invid0_t TX_INVID0;    /*!< [0x200] Video Input Mapping and Internal Data Enable Configuration Register */
    __IO hw_hdmi_tx_instuffing_t TX_INSTUFFING; /*!< [0x201] Video Input Stuffing Enable Register */
    __IO hw_hdmi_tx_gydata0_t TX_GYDATA0;  /*!< [0x202] Video Input GY Data Channel Stuffing Register 0 */
    __IO hw_hdmi_tx_gydata1_t TX_GYDATA1;  /*!< [0x203] Video Input GY Data Channel Stuffing Register 1 */
    __IO hw_hdmi_tx_rcrdata0_t TX_RCRDATA0; /*!< [0x204] Video Input RCR Data Channel Stuffing Register 0 */
    __IO hw_hdmi_tx_rcrdata1_t TX_RCRDATA1; /*!< [0x205] Video Input RCR Data Channel Stuffing Register 1 */
    __IO hw_hdmi_tx_bcbdata0_t TX_BCBDATA0; /*!< [0x206] Video Input RCB Data Channel Stuffing Register 0 */
    __IO hw_hdmi_tx_bcbdata1_t TX_BCBDATA1; /*!< [0x207] Video Input RCB Data Channel Stuffing Register 1 */
    uint8_t _reserved3[1528];
    __I hw_hdmi_vp_status_t VP_STATUS;     /*!< [0x800] Video Packetizer Packing Phase Status Register */
    __IO hw_hdmi_vp_pr_cd_t VP_PR_CD;      /*!< [0x801] Video Packetizer Pixel Repetition and Color Depth Register */
    __IO hw_hdmi_vp_stuff_t VP_STUFF;      /*!< [0x802] Video Packetizer Stuffing and Default Packing Phase Register */
    __IO hw_hdmi_vp_remap_t VP_REMAP;      /*!< [0x803] Video Packetizer YCC422 Remapping Register */
    __IO hw_hdmi_vp_conf_t VP_CONF;        /*!< [0x804] Video Packetizer Output, Bypass, and Enable Configuration Register */
    __I hw_hdmi_vp_stat_t VP_STAT;         /*!< [0x805] VP_STAT */
    __I hw_hdmi_vp_int_t VP_INT;           /*!< [0x806] VP_INT */
    __IO hw_hdmi_vp_mask_t VP_MASK;        /*!< [0x807] Video Packetizer Interrupt Mask Register */
    __IO hw_hdmi_vp_pol_t VP_POL;          /*!< [0x808] VP_POL */
    uint8_t _reserved4[2039];
    __IO hw_hdmi_fc_invidconf_t FC_INVIDCONF; /*!< [0x1000] Frame Composer Input Video Configuration and HDCP Keepout Register */
    __IO hw_hdmi_fc_inhactiv0_t FC_INHACTIV0; /*!< [0x1001] Frame Composer Input Video HActive Pixels Register 0 */
    __IO hw_hdmi_fc_inhactiv1_t FC_INHACTIV1; /*!< [0x1002] Frame Composer Input Video HActive Pixels Register 1 */
    __IO hw_hdmi_fc_inhblank0_t FC_INHBLANK0; /*!< [0x1003] Frame Composer Input Video HBlank Pixels Register 0 */
    __IO hw_hdmi_fc_inhblank1_t FC_INHBLANK1; /*!< [0x1004] Frame Composer Input Video HBlank Pixels Register 1 */
    __IO hw_hdmi_fc_invactiv0_t FC_INVACTIV0; /*!< [0x1005] Frame Composer Input Video VActive Pixels Register 0 */
    __IO hw_hdmi_fc_invactiv1_t FC_INVACTIV1; /*!< [0x1006] Frame Composer Input Video VActive Pixels Register 1 */
    __IO hw_hdmi_fc_invblank_t FC_INVBLANK; /*!< [0x1007] Frame Composer Input Video VBlank Pixels Register */
    __IO hw_hdmi_fc_hsyncindelay0_t FC_HSYNCINDELAY0; /*!< [0x1008] Frame Composer Input Video HSync Front Porch Register 0 */
    __IO hw_hdmi_fc_hsyncindelay1_t FC_HSYNCINDELAY1; /*!< [0x1009] Frame Composer Input Video HSync Front Porch Register 1 */
    __IO hw_hdmi_fc_hsyncinwidth0_t FC_HSYNCINWIDTH0; /*!< [0x100A] Frame Composer Input Video HSync Width Register 0 */
    __IO hw_hdmi_fc_hsyncinwidth1_t FC_HSYNCINWIDTH1; /*!< [0x100B] Frame Composer Input Video HSync Width Register 1 */
    __IO hw_hdmi_fc_vsyncindelay_t FC_VSYNCINDELAY; /*!< [0x100C] Frame Composer Input Video VSync Front Porch Register */
    __IO hw_hdmi_fc_vsyncinwidth_t FC_VSYNCINWIDTH; /*!< [0x100D] Frame Composer Input Video VSync Width Register */
    __IO hw_hdmi_fc_infreq0_t FC_INFREQ0;  /*!< [0x100E] Frame Composer Input Video Refresh Rate Register 0 */
    __IO hw_hdmi_fc_infreq1_t FC_INFREQ1;  /*!< [0x100F] Frame Composer Input Video Refresh Rate Register 1 */
    __IO hw_hdmi_fc_infreq2_t FC_INFREQ2;  /*!< [0x1010] Frame Composer Input Video Refresh Rate Register 2 */
    __IO hw_hdmi_fc_ctrldur_t FC_CTRLDUR;  /*!< [0x1011] Frame Composer Control Period Duration Register */
    __IO hw_hdmi_fc_exctrldur_t FC_EXCTRLDUR; /*!< [0x1012] Frame Composer Extended Control Period Duration Register */
    __IO hw_hdmi_fc_exctrlspac_t FC_EXCTRLSPAC; /*!< [0x1013] Frame Composer Extended Control Period Maximum Spacing Register */
    __IO hw_hdmi_fc_ch0pream_t FC_CH0PREAM; /*!< [0x1014] Frame Composer Channel 0 Non-Preamble Data Register */
    __IO hw_hdmi_fc_ch1pream_t FC_CH1PREAM; /*!< [0x1015] Frame Composer Channel 1 Non-Preamble Data Register */
    __IO hw_hdmi_fc_ch2pream_t FC_CH2PREAM; /*!< [0x1016] Frame Composer Channel 2 Non-Preamble Data Register */
    __IO hw_hdmi_fc_aviconf3_t FC_AVICONF3; /*!< [0x1017] Frame Composer AVI Configuration Register 3 */
    __IO hw_hdmi_fc_gcp_t FC_GCP;          /*!< [0x1018] Frame Composer GCP Packet Configuration Register */
    __IO hw_hdmi_fc_aviconf0_t FC_AVICONF0; /*!< [0x1019] Frame Composer AVI Packet Configuration Register 0 */
    __IO hw_hdmi_fc_aviconf1_t FC_AVICONF1; /*!< [0x101A] Frame Composer AVI Packet Configuration Register 1 */
    __IO hw_hdmi_fc_aviconf2_t FC_AVICONF2; /*!< [0x101B] FC_AVICONFFrame Composer AVI Packet Configuration Register 2 */
    __IO hw_hdmi_fc_avivid_t FC_AVIVID;    /*!< [0x101C] Frame Composer AVI Packet VIC Register */
    __IO hw_hdmi_fc_avietb0_t FC_AVIETB0;  /*!< [0x101D] Frame Composer AVI Packet End of Top Bar Register 0 */
    __IO hw_hdmi_fc_avietb1_t FC_AVIETB1;  /*!< [0x101E] Frame Composer AVI Packet End of Top Bar Register 1 */
    __IO hw_hdmi_fc_avisbb0_t FC_AVISBB0;  /*!< [0x101F] Frame Composer AVI Packet Start of Bottom Bar Register 0 */
    __IO hw_hdmi_fc_avisbb1_t FC_AVISBB1;  /*!< [0x1020] Frame Composer AVI Packet Start of Bottom Bar Register 1 */
    __IO hw_hdmi_fc_avielb0_t FC_AVIELB0;  /*!< [0x1021] Frame Composer AVI Packet End of Left Bar Register 0 */
    __IO hw_hdmi_fc_avielb1_t FC_AVIELB1;  /*!< [0x1022] Frame Composer AVI Packet End of Left Bar Register 1 */
    __IO hw_hdmi_fc_avisrb0_t FC_AVISRB0;  /*!< [0x1023] Frame Composer AVI Packet Start of Right Bar Register 0 */
    __IO hw_hdmi_fc_avisrb1_t FC_AVISRB1;  /*!< [0x1024] Frame Composer AVI Packet Start of Right Bar Register 1 */
    __IO hw_hdmi_fc_audiconf0_t FC_AUDICONF0; /*!< [0x1025] Frame Composer AUD Packet Configuration Register 0 */
    __IO hw_hdmi_fc_audiconf1_t FC_AUDICONF1; /*!< [0x1026] Frame Composer AUD Packet Configuration Register 1 */
    __IO hw_hdmi_fc_audiconf2_t FC_AUDICONF2; /*!< [0x1027] Frame Composer AUD Packet Configuration Register 2 */
    __IO hw_hdmi_fc_audiconf3_t FC_AUDICONF3; /*!< [0x1028] Frame Composer AUD Packet Configuration Register 3 */
    __IO hw_hdmi_fc_vsdieeeid0_t FC_VSDIEEEID0; /*!< [0x1029] Frame Composer VSI Packet Data IEEE Register 0 */
    __IO hw_hdmi_fc_vsdsize_t FC_VSDSIZE;  /*!< [0x102A] Frame Composer VSI Packet Data Size Register */
    uint8_t _reserved5[5];
    __IO hw_hdmi_fc_vsdieeeid1_t FC_VSDIEEEID1; /*!< [0x1030] Frame Composer VSI Packet Data IEEE Register 1 */
    __IO hw_hdmi_fc_vsdieeeid2_t FC_VSDIEEEID2; /*!< [0x1031] Frame Composer VSI Packet Data IEEE Register 2 */
    __IO hw_hdmi_fc_vsdpayload0_t FC_VSDPAYLOAD0; /*!< [0x1032] Frame Composer VSI Packet Data IEEE Register 0 */
    __IO hw_hdmi_fc_vsdpayload1_t FC_VSDPAYLOAD1; /*!< [0x1033] Frame Composer VSI Packet Data IEEE Register 1 */
    __IO hw_hdmi_fc_vsdpayload2_t FC_VSDPAYLOAD2; /*!< [0x1034] Frame Composer VSI Packet Data IEEE Register 2 */
    __IO hw_hdmi_fc_vsdpayload3_t FC_VSDPAYLOAD3; /*!< [0x1035] Frame Composer VSI Packet Data IEEE Register 3 */
    __IO hw_hdmi_fc_vsdpayload4_t FC_VSDPAYLOAD4; /*!< [0x1036] Frame Composer VSI Packet Data IEEE Register 4 */
    __IO hw_hdmi_fc_vsdpayload5_t FC_VSDPAYLOAD5; /*!< [0x1037] Frame Composer VSI Packet Data IEEE Register 5 */
    __IO hw_hdmi_fc_vsdpayload6_t FC_VSDPAYLOAD6; /*!< [0x1038] Frame Composer VSI Packet Data IEEE Register 6 */
    __IO hw_hdmi_fc_vsdpayload7_t FC_VSDPAYLOAD7; /*!< [0x1039] Frame Composer VSI Packet Data IEEE Register 7 */
    __IO hw_hdmi_fc_vsdpayload8_t FC_VSDPAYLOAD8; /*!< [0x103A] Frame Composer VSI Packet Data IEEE Register 8 */
    __IO hw_hdmi_fc_vsdpayload9_t FC_VSDPAYLOAD9; /*!< [0x103B] Frame Composer VSI Packet Data IEEE Register 9 */
    __IO hw_hdmi_fc_vsdpayload10_t FC_VSDPAYLOAD10; /*!< [0x103C] Frame Composer VSI Packet Data IEEE Register 10 */
    __IO hw_hdmi_fc_vsdpayload11_t FC_VSDPAYLOAD11; /*!< [0x103D] Frame Composer VSI Packet Data IEEE Register 11 */
    __IO hw_hdmi_fc_vsdpayload12_t FC_VSDPAYLOAD12; /*!< [0x103E] Frame Composer VSI Packet Data IEEE Register 12 */
    __IO hw_hdmi_fc_vsdpayload13_t FC_VSDPAYLOAD13; /*!< [0x103F] Frame Composer VSI Packet Data IEEE Register 13 */
    __IO hw_hdmi_fc_vsdpayload14_t FC_VSDPAYLOAD14; /*!< [0x1040] Frame Composer VSI Packet Data IEEE Register 14 */
    __IO hw_hdmi_fc_vsdpayload15_t FC_VSDPAYLOAD15; /*!< [0x1041] Frame Composer VSI Packet Data IEEE Register 15 */
    __IO hw_hdmi_fc_vsdpayload16_t FC_VSDPAYLOAD16; /*!< [0x1042] Frame Composer VSI Packet Data IEEE Register 16 */
    __IO hw_hdmi_fc_vsdpayload17_t FC_VSDPAYLOAD17; /*!< [0x1043] Frame Composer VSI Packet Data IEEE Register 17 */
    __IO hw_hdmi_fc_vsdpayload18_t FC_VSDPAYLOAD18; /*!< [0x1044] Frame Composer VSI Packet Data IEEE Register 18 */
    __IO hw_hdmi_fc_vsdpayload19_t FC_VSDPAYLOAD19; /*!< [0x1045] Frame Composer VSI Packet Data IEEE Register 19 */
    __IO hw_hdmi_fc_vsdpayload20_t FC_VSDPAYLOAD20; /*!< [0x1046] Frame Composer VSI Packet Data IEEE Register 20 */
    __IO hw_hdmi_fc_vsdpayload21_t FC_VSDPAYLOAD21; /*!< [0x1047] Frame Composer VSI Packet Data IEEE Register 21 */
    __IO hw_hdmi_fc_vsdpayload22_t FC_VSDPAYLOAD22; /*!< [0x1048] Frame Composer VSI Packet Data IEEE Register 22 */
    __IO hw_hdmi_fc_vsdpayload23_t FC_VSDPAYLOAD23; /*!< [0x1049] Frame Composer VSI Packet Data IEEE Register 23 */
    __IO hw_hdmi_fc_spdvendorname0_t FC_SPDVENDORNAME0; /*!< [0x104A] Frame Composer SPD Packet Data Vendor Name Register 0 */
    uint8_t _reserved6[7];
    __IO hw_hdmi_fc_spdproductname0_t FC_SPDPRODUCTNAME0; /*!< [0x1052] Frame Composer SPD Packet Data Product Name Register 0 */
    uint8_t _reserved7[15];
    __IO hw_hdmi_fc_spddeviceinf_t FC_SPDDEVICEINF; /*!< [0x1062] Frame Composer SPD Packet Data Source Product Descriptor Register */
    __IO hw_hdmi_fc_audsconf_t FC_AUDSCONF; /*!< [0x1063] Frame Composer Audio Sample Flat and Layout Configuration Register */
    __I hw_hdmi_fc_audsstat_t FC_AUDSSTAT; /*!< [0x1064] Frame Composer Audio Packet Sample Present Status Register */
    uint8_t _reserved8[14];
    __IO hw_hdmi_fc_ctrlqhigh_t FC_CTRLQHIGH; /*!< [0x1073] Frame Composer Number of High Priority Packets Attended Configuration Register */
    __IO hw_hdmi_fc_ctrlqlow_t FC_CTRLQLOW; /*!< [0x1074] Frame Composer Number of Low Priority Packets Attended Configuration Register */
    __IO hw_hdmi_fc_acp0_t FC_ACP0;        /*!< [0x1075] Frame Composer ACP Packet Type Configuration Register 0 */
    uint8_t _reserved9[27];
    __IO hw_hdmi_fc_acp1_t FC_ACP1;        /*!< [0x1091] Frame Composer ACP Packet Type Configuration Register 1 */
    __IO hw_hdmi_fc_iscr1_0_t FC_ISCR1_0;  /*!< [0x1092] FC_ISCR1_Frame Composer Packet Status, Valid, and Continue Configuration Register */
    __IO hw_hdmi_fc_iscr1_1_t FC_ISCR1_1;  /*!< [0x1093] Frame Composer ISCR1 Packet Body Register 1 */
    uint8_t _reserved10[15];
    __IO hw_hdmi_fc_iscr2_0_t FC_ISCR2_0;  /*!< [0x10A3] Frame Composer ISCR2 Packet Body Register 0 */
    uint8_t _reserved11[15];
    __IO hw_hdmi_fc_datauto0_t FC_DATAUTO0; /*!< [0x10B3] Frame Composer Data Island Auto Packet Scheduling Register 0 */
    __IO hw_hdmi_fc_datauto1_t FC_DATAUTO1; /*!< [0x10B4] Frame Composer Data Island Auto Packet Scheduling Register 1 */
    __IO hw_hdmi_fc_datauto2_t FC_DATAUTO2; /*!< [0x10B5] Frame Composer Data Island Auto Packet Scheduling Register 2 */
    __O hw_hdmi_fc_datman_t FC_DATMAN;     /*!< [0x10B6] Frame Composer Data Island Manual Packet Request Register */
    __IO hw_hdmi_fc_datauto3_t FC_DATAUTO3; /*!< [0x10B7] Frame Composer Data Island Auto Packet Scheduling Register 3 */
    __IO hw_hdmi_fc_rdrb0_t FC_RDRB0;      /*!< [0x10B8] Frame Composer Round Robin ACR Packet Insertion Register 0 */
    __IO hw_hdmi_fc_rdrb1_t FC_RDRB1;      /*!< [0x10B9] Frame Composer Round Robin ACR Packet Insertion Register 1 */
    __IO hw_hdmi_fc_rdrb2_t FC_RDRB2;      /*!< [0x10BA] Frame Composer Round Robin ACR Packet Insertion Register 2 */
    __IO hw_hdmi_fc_rdrb3_t FC_RDRB3;      /*!< [0x10BB] Frame Composer Round Robin ACR Packet Insertion Register 3 */
    __IO hw_hdmi_fc_rdrb4_t FC_RDRB4;      /*!< [0x10BC] Frame Composer Round Robin ACR Packet Insertion Register 4 */
    __IO hw_hdmi_fc_rdrb5_t FC_RDRB5;      /*!< [0x10BD] Frame Composer Round Robin ACR Packet Insertion Register 5 */
    __IO hw_hdmi_fc_rdrb6_t FC_RDRB6;      /*!< [0x10BE] Frame Composer Round Robin ACR Packet Insertion Register 6 */
    __IO hw_hdmi_fc_rdrb7_t FC_RDRB7;      /*!< [0x10BF] Frame Composer Round Robin ACR Packet Insertion Register 7 */
    uint8_t _reserved12[16];
    __I hw_hdmi_fc_stat0_t FC_STAT0;       /*!< [0x10D0] FC_STAT0 */
    __IO hw_hdmi_fc_int0_t FC_INT0;        /*!< [0x10D1] FC_INT0 */
    __IO hw_hdmi_fc_mask0_t FC_MASK0;      /*!< [0x10D2] Frame Composer Packet Interrupt Mask Register 0 */
    __IO hw_hdmi_fc_pol0_t FC_POL0;        /*!< [0x10D3] FC_POL0 */
    __IO hw_hdmi_fc_stat1_t FC_STAT1;      /*!< [0x10D4] FC_STAT1 */
    __IO hw_hdmi_fc_int1_t FC_INT1;        /*!< [0x10D5] FC_INT1 */
    __IO hw_hdmi_fc_mask1_t FC_MASK1;      /*!< [0x10D6] Frame Composer Packet Interrupt Mask Register 1 */
    __IO hw_hdmi_fc_pol1_t FC_POL1;        /*!< [0x10D7] FC_POL1 */
    __IO hw_hdmi_fc_stat2_t FC_STAT2;      /*!< [0x10D8] FC_STAT2 */
    __IO hw_hdmi_fc_int2_t FC_INT2;        /*!< [0x10D9] FC_INT2 */
    __IO hw_hdmi_fc_mask2_t FC_MASK2;      /*!< [0x10DA] Frame Composer High/Low Priority Overflow Interrupt Mask Register 2 */
    __IO hw_hdmi_fc_pol2_t FC_POL2;        /*!< [0x10DB] FC_POL2 */
    uint8_t _reserved13[4];
    __IO hw_hdmi_fc_prconf_t FC_PRCONF;    /*!< [0x10E0] Frame Composer Pixel Repetition Configuration Register */
    uint8_t _reserved14[31];
    __I hw_hdmi_fc_gmd_stat_t FC_GMD_STAT; /*!< [0x1100] Frame Composer GMD Packet Status Register */
    __IO hw_hdmi_fc_gmd_en_t FC_GMD_EN;    /*!< [0x1101] Frame Composer GMD Packet Enable Register */
    __O hw_hdmi_fc_gmd_up_t FC_GMD_UP;     /*!< [0x1102] Frame Composer GMD Packet Update Register */
    __IO hw_hdmi_fc_gmd_conf_t FC_GMD_CONF; /*!< [0x1103] Frame Composer GMD Packet Schedule Configuration Register */
    __IO hw_hdmi_fc_gmd_hb_t FC_GMD_HB;    /*!< [0x1104] Frame Composer GMD Packet Profile and Gamut Sequence Configuration Register */
    __IO hw_hdmi_fc_gmd_pb0_t FC_GMD_PB0;  /*!< [0x1105] Frame Composer GMD Packet Body Register 0 */
    __IO hw_hdmi_fc_gmd_pb1_t FC_GMD_PB1;  /*!< [0x1106] Frame Composer GMD Packet Body Register 1 */
    __IO hw_hdmi_fc_gmd_pb2_t FC_GMD_PB2;  /*!< [0x1107] Frame Composer GMD Packet Body Register 2 */
    __IO hw_hdmi_fc_gmd_pb3_t FC_GMD_PB3;  /*!< [0x1108] Frame Composer GMD Packet Body Register 3 */
    __IO hw_hdmi_fc_gmd_pb4_t FC_GMD_PB4;  /*!< [0x1109] Frame Composer GMD Packet Body Register 4 */
    __IO hw_hdmi_fc_gmd_pb5_t FC_GMD_PB5;  /*!< [0x110A] Frame Composer GMD Packet Body Register 5 */
    __IO hw_hdmi_fc_gmd_pb6_t FC_GMD_PB6;  /*!< [0x110B] Frame Composer GMD Packet Body Register 6 */
    __IO hw_hdmi_fc_gmd_pb7_t FC_GMD_PB7;  /*!< [0x110C] Frame Composer GMD Packet Body Register 7 */
    __IO hw_hdmi_fc_gmd_pb8_t FC_GMD_PB8;  /*!< [0x110D] Frame Composer GMD Packet Body Register 8 */
    __IO hw_hdmi_fc_gmd_pb9_t FC_GMD_PB9;  /*!< [0x110E] Frame Composer GMD Packet Body Register 9 */
    __IO hw_hdmi_fc_gmd_pb10_t FC_GMD_PB10; /*!< [0x110F] Frame Composer GMD Packet Body Register 10 */
    __IO hw_hdmi_fc_gmd_pb11_t FC_GMD_PB11; /*!< [0x1110] Frame Composer GMD Packet Body Register 11 */
    __IO hw_hdmi_fc_gmd_pb12_t FC_GMD_PB12; /*!< [0x1111] Frame Composer GMD Packet Body Register 12 */
    __IO hw_hdmi_fc_gmd_pb13_t FC_GMD_PB13; /*!< [0x1112] Frame Composer GMD Packet Body Register 13 */
    __IO hw_hdmi_fc_gmd_pb14_t FC_GMD_PB14; /*!< [0x1113] Frame Composer GMD Packet Body Register 14 */
    __IO hw_hdmi_fc_gmd_pb15_t FC_GMD_PB15; /*!< [0x1114] Frame Composer GMD Packet Body Register 15 */
    __IO hw_hdmi_fc_gmd_pb16_t FC_GMD_PB16; /*!< [0x1115] Frame Composer GMD Packet Body Register 16 */
    __IO hw_hdmi_fc_gmd_pb17_t FC_GMD_PB17; /*!< [0x1116] Frame Composer GMD Packet Body Register 17 */
    __IO hw_hdmi_fc_gmd_pb18_t FC_GMD_PB18; /*!< [0x1117] Frame Composer GMD Packet Body Register 18 */
    __IO hw_hdmi_fc_gmd_pb19_t FC_GMD_PB19; /*!< [0x1118] Frame Composer GMD Packet Body Register 19 */
    __IO hw_hdmi_fc_gmd_pb20_t FC_GMD_PB20; /*!< [0x1119] Frame Composer GMD Packet Body Register 20 */
    __IO hw_hdmi_fc_gmd_pb21_t FC_GMD_PB21; /*!< [0x111A] Frame Composer GMD Packet Body Register 21 */
    __IO hw_hdmi_fc_gmd_pb22_t FC_GMD_PB22; /*!< [0x111B] Frame Composer GMD Packet Body Register 22 */
    __IO hw_hdmi_fc_gmd_pb23_t FC_GMD_PB23; /*!< [0x111C] Frame Composer GMD Packet Body Register 23 */
    __IO hw_hdmi_fc_gmd_pb24_t FC_GMD_PB24; /*!< [0x111D] Frame Composer GMD Packet Body Register 24 */
    __IO hw_hdmi_fc_gmd_pb25_t FC_GMD_PB25; /*!< [0x111E] Frame Composer GMD Packet Body Register 25 */
    __IO hw_hdmi_fc_gmd_pb26_t FC_GMD_PB26; /*!< [0x111F] Frame Composer GMD Packet Body Register 26 */
    __IO hw_hdmi_fc_gmd_pb27_t FC_GMD_PB27; /*!< [0x1120] Frame Composer GMD Packet Body Register 27 */
    uint8_t _reserved15[223];
    __IO hw_hdmi_fc_dbgforce_t FC_DBGFORCE; /*!< [0x1200] Frame Composer Video/Audio Force Enable Register */
    __IO hw_hdmi_fc_dbgaud0ch0_t FC_DBGAUD0CH0; /*!< [0x1201] Frame Composer Audio Channel 0 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch0_t FC_DBGAUD1CH0; /*!< [0x1202] Frame Composer Audio Channel 0 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch0_t FC_DBGAUD2CH0; /*!< [0x1203] Frame Composer Audio Channel 0 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch1_t FC_DBGAUD0CH1; /*!< [0x1204] Frame Composer Audio Channel 1 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch1_t FC_DBGAUD1CH1; /*!< [0x1205] Frame Composer Audio Channel 1 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch1_t FC_DBGAUD2CH1; /*!< [0x1206] Frame Composer Audio Channel 1 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch2_t FC_DBGAUD0CH2; /*!< [0x1207] Frame Composer Debug Audio Channel 2 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch2_t FC_DBGAUD1CH2; /*!< [0x1208] Frame Composer Debug Audio Channel 2 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch2_t FC_DBGAUD2CH2; /*!< [0x1209] Frame Composer Audio Channel 2 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch3_t FC_DBGAUD0CH3; /*!< [0x120A] Frame Composer Audio Channel 3 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch3_t FC_DBGAUD1CH3; /*!< [0x120B] Frame Composer Audio Channel 3 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch3_t FC_DBGAUD2CH3; /*!< [0x120C] Frame Composer Audio Channel 3 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch4_t FC_DBGAUD0CH4; /*!< [0x120D] Frame Composer Audio Channel 4 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch4_t FC_DBGAUD1CH4; /*!< [0x120E] Frame Composer Audio Channel 4 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch4_t FC_DBGAUD2CH4; /*!< [0x120F] Frame Composer Audio Channel 4 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch5_t FC_DBGAUD0CH5; /*!< [0x1210] Frame Composer Audio Channel 5 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch5_t FC_DBGAUD1CH5; /*!< [0x1211] Frame Composer Audio Channel 5 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch5_t FC_DBGAUD2CH5; /*!< [0x1212] Frame Composer Audio Channel 5 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch6_t FC_DBGAUD0CH6; /*!< [0x1213] Frame Composer Audio Channel 6 Register 0 */
    __IO hw_hdmi_fc_dbgaud1ch6_t FC_DBGAUD1CH6; /*!< [0x1214] Frame Composer Audio Channel 6 Register 1 */
    __IO hw_hdmi_fc_dbgaud2ch6_t FC_DBGAUD2CH6; /*!< [0x1215] Frame Composer Audio Channel 6 Register 2 */
    __IO hw_hdmi_fc_dbgaud0ch7_t FC_DBGAUD0CH7; /*!< [0x1216] Frame Composer Audio Channel 7 Register 1 */
    __IO hw_hdmi_fc_dbgaud1ch7_t FC_DBGAUD1CH7; /*!< [0x1217] Frame Composer Audio Channel 7 Register 0 */
    __IO hw_hdmi_fc_dbgaud2ch7_t FC_DBGAUD2CH7; /*!< [0x1218] Frame Composer Audio Channel 7 Register 2 */
    __IO hw_hdmi_fc_dbgtmds0_t FC_DBGTMDS0; /*!< [0x1219] Frame Composer TMDS Channel 0 Register */
    __IO hw_hdmi_fc_dbgtmds1_t FC_DBGTMDS1; /*!< [0x121A] Frame Composer TMDS Channel 1 Register */
    __IO hw_hdmi_fc_dbgtmds2_t FC_DBGTMDS2; /*!< [0x121B] Frame Composer TMDS Channel 2 Register */
    uint8_t _reserved16[7652];
    __IO hw_hdmi_phy_conf0_t PHY_CONF0;    /*!< [0x3000] PHY Configuration Register */
    __IO hw_hdmi_phy_tst0_t PHY_TST0;      /*!< [0x3001] PHY Test Interface Register 0 */
    __IO hw_hdmi_phy_tst1_t PHY_TST1;      /*!< [0x3002] PHY Test Interface Register 1 */
    __I hw_hdmi_phy_tst2_t PHY_TST2;       /*!< [0x3003] PHY Test Interface Register 2 */
    __I hw_hdmi_phy_stat0_t PHY_STAT0;     /*!< [0x3004] PHY RXSENSE, PLL lock, and HPD Status Register */
    __I hw_hdmi_phy_int0_t PHY_INT0;       /*!< [0x3005] PHY RXSENSE, PLL lock, and HPD Interrupt Register */
    __IO hw_hdmi_phy_mask0_t PHY_MASK0;    /*!< [0x3006] PHY RXSENSE, PLL lock, and HPD Mask Register */
    __IO hw_hdmi_phy_pol0_t PHY_POL0;      /*!< [0x3007] PHY RXSENSE, PLL lock and HPD Polarity Register */
    uint8_t _reserved17[24];
    __IO hw_hdmi_phy_i2cm_slave_addr_t PHY_I2CM_SLAVE_ADDR; /*!< [0x3020] PHY I2C Slave Address Configuration Register */
    __IO hw_hdmi_phy_i2cm_address_addr_t PHY_I2CM_ADDRESS_ADDR; /*!< [0x3021] PHY I2C Address Configuration Register */
    __IO hw_hdmi_phy_i2cm_datao_1_addr_t PHY_I2CM_DATAO_1_ADDR; /*!< [0x3022] PHY I2C Data Write Register 1 */
    __IO hw_hdmi_phy_i2cm_datao_0_addr_t PHY_I2CM_DATAO_0_ADDR; /*!< [0x3023] PHY I2C Data Write Register 0 */
    __I hw_hdmi_phy_i2cm_datai_1_addr_t PHY_I2CM_DATAI_1_ADDR; /*!< [0x3024] PHY I2C Data Read Register 1 */
    __IO hw_hdmi_phy_i2cm_datai_0_addr_t PHY_I2CM_DATAI_0_ADDR; /*!< [0x3025] PHY I2C Data Read Register 0 */
    __O hw_hdmi_phy_i2cm_operation_addr_t PHY_I2CM_OPERATION_ADDR; /*!< [0x3026] PHY I2C Read/Write Operation */
    __IO hw_hdmi_phy_i2cm_int_addr_t PHY_I2CM_INT_ADDR; /*!< [0x3027] PHY I2C Done Interrupt Register */
    __IO hw_hdmi_phy_i2cm_ctlint_addr_t PHY_I2CM_CTLINT_ADDR; /*!< [0x3028] PHY I2C Done Interrupt Register */
    __IO hw_hdmi_phy_i2cm_div_addr_t PHY_I2CM_DIV_ADDR; /*!< [0x3029] PHY I2C Speed Control Register */
    __IO hw_hdmi_phy_i2cm_softrstz_addr_t PHY_I2CM_SOFTRSTZ_ADDR; /*!< [0x302A] PHY I2C Software Reset Register */
    __IO hw_hdmi_phy_i2cm_ss_scl_hcnt_1_addr_t PHY_I2CM_SS_SCL_HCNT_1_ADDR; /*!< [0x302B] PHY I2C Slow Speed SCL High Level Control Register 1 */
    __IO hw_hdmi_phy_i2cm_ss_scl_hcnt_0_addr_t PHY_I2CM_SS_SCL_HCNT_0_ADDR; /*!< [0x302C] PHY I2C Slow Speed SCL High Level Control Register 0 */
    __IO hw_hdmi_phy_i2cm_ss_scl_lcnt_1_addr_t PHY_I2CM_SS_SCL_LCNT_1_ADDR; /*!< [0x302D] PHY I2C Slow Speed SCL Low Level Control Register 1 */
    __IO hw_hdmi_phy_i2cm_ss_scl_lcnt_0_addr_t PHY_I2CM_SS_SCL_LCNT_0_ADDR; /*!< [0x302E] PHY I2C Slow Speed SCL Low Level Control Register 0 */
    __IO hw_hdmi_phy_i2cm_fs_scl_hcnt_1_addr_t PHY_I2CM_FS_SCL_HCNT_1_ADDR; /*!< [0x302F] PHY I2C Fast Speed SCL High Level Control Register 1 */
    __IO hw_hdmi_phy_i2cm_fs_scl_hcnt_0_addr_t PHY_I2CM_FS_SCL_HCNT_0_ADDR; /*!< [0x3030] PHY I2C Fast Speed SCL High Level Control Register 0 */
    __IO hw_hdmi_phy_i2cm_fs_scl_lcnt_1_addr_t PHY_I2CM_FS_SCL_LCNT_1_ADDR; /*!< [0x3031] PHY I2C Fast Speed SCL Low Level Control Register 1 */
    __IO hw_hdmi_phy_i2cm_fs_scl_lcnt_0_addr_t PHY_I2CM_FS_SCL_LCNT_0_ADDR; /*!< [0x3032] PHY I2C Fast Speed SCL Low Level Control Register 0 */
    uint8_t _reserved18[461];
    __IO hw_hdmi_aud_n1_t AUD_N1;          /*!< [0x3200] Audio Clock Regenerator N Value Register 1 */
    __IO hw_hdmi_aud_n2_t AUD_N2;          /*!< [0x3201] Audio Clock Regenerator N Value Register 2 */
    __IO hw_hdmi_aud_n3_t AUD_N3;          /*!< [0x3202] Audio Clock Regenerator N Value Register 3 */
    __IO hw_hdmi_aud_cts1_t AUD_CTS1;      /*!< [0x3203] AUD_CTS1 */
    __IO hw_hdmi_aud_cts2_t AUD_CTS2;      /*!< [0x3204] AUD_CTS2 */
    __IO hw_hdmi_aud_cts3_t AUD_CTS3;      /*!< [0x3205] AUD_CTS3 */
    uint8_t _reserved19[1018];
    __IO hw_hdmi_ahb_dma_conf0_t AHB_DMA_CONF0; /*!< [0x3600] Audio DMA Start Register */
    __IO hw_hdmi_ahb_dma_start_t AHB_DMA_START; /*!< [0x3601] AHB_DMA_START */
    __IO hw_hdmi_ahb_dma_stop_t AHB_DMA_STOP; /*!< [0x3602] Audio DMA Stop Register */
    __IO hw_hdmi_ahb_dma_thrsld_t AHB_DMA_THRSLD; /*!< [0x3603] Audio DMA FIFO Threshold Register */
    __IO hw_hdmi_ahb_dma_straddr0_t AHB_DMA_STRADDR0; /*!< [0x3604] Audio DMA Start Address Register 0 */
    __IO hw_hdmi_ahb_dma_straddr1_t AHB_DMA_STRADDR1; /*!< [0x3605] Audio DMA Start Address Register 1 */
    __IO hw_hdmi_ahb_dma_straddr2_t AHB_DMA_STRADDR2; /*!< [0x3606] Audio DMA Start Address Register 2 */
    __IO hw_hdmi_ahb_dma_straddr3_t AHB_DMA_STRADDR3; /*!< [0x3607] Audio DMA Start Address Register 3 */
    __IO hw_hdmi_ahb_dma_stpaddr0_t AHB_DMA_STPADDR0; /*!< [0x3608] Audio DMA Stop Address Register 0 */
    __IO hw_hdmi_ahb_dma_stpaddr1_t AHB_DMA_STPADDR1; /*!< [0x3609] Audio DMA Stop Address Register 1 */
    __IO hw_hdmi_ahb_dma_stpaddr2_t AHB_DMA_STPADDR2; /*!< [0x360A] Audio DMA Stop Address Register 2 */
    __IO hw_hdmi_ahb_dma_stpaddr3_t AHB_DMA_STPADDR3; /*!< [0x360B] Audio DMA Stop Address Register 3 */
    __I hw_hdmi_ahb_dma_bstaddr0_t AHB_DMA_BSTADDR0; /*!< [0x360C] Audio DMA Burst Start Address Register 0 */
    __I hw_hdmi_ahb_dma_bstaddr1_t AHB_DMA_BSTADDR1; /*!< [0x360D] Audio DMA Burst Start Address Register 1 */
    __I hw_hdmi_ahb_dma_bstaddr2_t AHB_DMA_BSTADDR2; /*!< [0x360E] Audio DMA Burst Start Address Register 2 */
    __I hw_hdmi_ahb_dma_bstaddr3_t AHB_DMA_BSTADDR3; /*!< [0x360F] Audio DMA Burst Start Address Register 3 */
    __I hw_hdmi_ahb_dma_mblength0_t AHB_DMA_MBLENGTH0; /*!< [0x3610] Audio DMA Burst Length Register 0 */
    __I hw_hdmi_ahb_dma_mblength1_t AHB_DMA_MBLENGTH1; /*!< [0x3611] Audio DMA Burst Length Register 1 */
    __I hw_hdmi_ahb_dma_stat_t AHB_DMA_STAT; /*!< [0x3612] Audio DMA Interrupt Status Register */
    __I hw_hdmi_ahb_dma_int_t AHB_DMA_INT; /*!< [0x3613] Audio DMA Interrupt Register */
    __IO hw_hdmi_ahb_dma_mask_t AHB_DMA_MASK; /*!< [0x3614] Audio DMA Mask Interrupt Register */
    __IO hw_hdmi_ahb_dma_pol_t AHB_DMA_POL; /*!< [0x3615] Audio DMA Polarity Interrupt Register */
    __IO hw_hdmi_ahb_dma_conf1_t AHB_DMA_CONF1; /*!< [0x3616] Audio DMA Channel Enable Configuration Register 1 */
    __I hw_hdmi_ahb_dma_buffstat_t AHB_DMA_BUFFSTAT; /*!< [0x3617] Audio DMA Buffer Interrupt Status Register */
    __I hw_hdmi_ahb_dma_buffint_t AHB_DMA_BUFFINT; /*!< [0x3618] Audio DMA Buffer Interrupt Register */
    __IO hw_hdmi_ahb_dma_buffmask_t AHB_DMA_BUFFMASK; /*!< [0x3619] Audio DMA Buffer Mask Interrupt Register */
    __IO hw_hdmi_ahb_dma_buffpol_t AHB_DMA_BUFFPOL; /*!< [0x361A] Audio DMA Buffer Polarity Interrupt Register */
    uint8_t _reserved20[2534];
    __IO hw_hdmi_mc_clkdis_t MC_CLKDIS;    /*!< [0x4001] Main Controller Synchronous Clock Domain Disable Register */
    __IO hw_hdmi_mc_swrstzreq_t MC_SWRSTZREQ; /*!< [0x4002] Main Controller Software Reset Register */
    uint8_t _reserved21[1];
    __IO hw_hdmi_mc_flowctrl_t MC_FLOWCTRL; /*!< [0x4004] Main Controller Feed Through Control Register */
    __IO hw_hdmi_mc_phyrstz_t MC_PHYRSTZ;  /*!< [0x4005] Main Controller PHY Reset Register */
    __IO hw_hdmi_mc_lockonclock_t MC_LOCKONCLOCK; /*!< [0x4006] Main Controller Clock Present Register */
    __IO hw_hdmi_mc_heacphy_rst_t MC_HEACPHY_RST; /*!< [0x4007] Main Controller HEAC PHY Reset Register */
    uint8_t _reserved22[248];
    __IO hw_hdmi_csc_cfg_t CSC_CFG;        /*!< [0x4100] Color Space Converter Interpolation and Decimation Configuration Register */
    __IO hw_hdmi_csc_scale_t CSC_SCALE;    /*!< [0x4101] Color Space Converter Scale and Deep Color Configuration Register */
    __IO hw_hdmi_csc_coef_a1_msb_t CSC_COEF_A1_MSB; /*!< [0x4102] CSC_COEF_A1_MSB */
    __IO hw_hdmi_csc_coef_a1_lsb_t CSC_COEF_A1_LSB; /*!< [0x4103] CSC_COEF_A1_LSB */
    __IO hw_hdmi_csc_coef_a2_msb_t CSC_COEF_A2_MSB; /*!< [0x4104] CSC_COEF_A2_MSB */
    __IO hw_hdmi_csc_coef_a2_lsb_t CSC_COEF_A2_LSB; /*!< [0x4105] CSC_COEF_A2_LSB */
    __IO hw_hdmi_csc_coef_a3_msb_t CSC_COEF_A3_MSB; /*!< [0x4106] CSC_COEF_A3_MSB */
    __IO hw_hdmi_csc_coef_a3_lsb_t CSC_COEF_A3_LSB; /*!< [0x4107] CSC_COEF_A3_LSB */
    __IO hw_hdmi_csc_coef_a4_msb_t CSC_COEF_A4_MSB; /*!< [0x4108] CSC_COEF_A4_MSB */
    __IO hw_hdmi_csc_coef_a4_lsb_t CSC_COEF_A4_LSB; /*!< [0x4109] CSC_COEF_A4_LSB */
    __IO hw_hdmi_csc_coef_b1_msb_t CSC_COEF_B1_MSB; /*!< [0x410A] CSC_COEF_B1_MSB */
    __IO hw_hdmi_csc_coef_b1_lsb_t CSC_COEF_B1_LSB; /*!< [0x410B] CSC_COEF_B1_LSB */
    __IO hw_hdmi_csc_coef_b2_msb_t CSC_COEF_B2_MSB; /*!< [0x410C] CSC_COEF_B2_MSB */
    __IO hw_hdmi_csc_coef_b2_lsb_t CSC_COEF_B2_LSB; /*!< [0x410D] CSC_COEF_B2_LSB */
    __IO hw_hdmi_csc_coef_b3_msb_t CSC_COEF_B3_MSB; /*!< [0x410E] CSC_COEF_B3_MSB */
    __IO hw_hdmi_csc_coef_b3_lsb_t CSC_COEF_B3_LSB; /*!< [0x410F] CSC_COEF_B3_LSB */
    __IO hw_hdmi_csc_coef_b4_msb_t CSC_COEF_B4_MSB; /*!< [0x4110] CSC_COEF_B4_MSB */
    __IO hw_hdmi_csc_coef_b4_lsb_t CSC_COEF_B4_LSB; /*!< [0x4111] CSC_COEF_B4_LSB */
    __IO hw_hdmi_csc_coef_c1_msb_t CSC_COEF_C1_MSB; /*!< [0x4112] CSC_COEF_C1_MSB */
    __IO hw_hdmi_csc_coef_c1_lsb_t CSC_COEF_C1_LSB; /*!< [0x4113] CSC_COEF_C1_LSB */
    __IO hw_hdmi_csc_coef_c2_msb_t CSC_COEF_C2_MSB; /*!< [0x4114] CSC_COEF_C2_MSB */
    __IO hw_hdmi_csc_coef_c2_lsb_t CSC_COEF_C2_LSB; /*!< [0x4115] CSC_COEF_C2_LSB */
    __IO hw_hdmi_csc_coef_c3_msb_t CSC_COEF_C3_MSB; /*!< [0x4116] CSC_COEF_C3_MSB */
    __IO hw_hdmi_csc_coef_c3_lsb_t CSC_COEF_C3_LSB; /*!< [0x4117] CSC_COEF_C3_LSB */
    __IO hw_hdmi_csc_coefc4_msb_t CSC_COEFC4_MSB; /*!< [0x4118] CSC_COEFC4_MSB */
    __IO hw_hdmi_csc_coefc4_lsb_t CSC_COEFC4_LSB; /*!< [0x4119] CSC_COEFC4_LSB */
    uint8_t _reserved23[15334];
    __IO hw_hdmi_cec_ctrl_t CEC_CTRL;      /*!< [0x7D00] CEC_CTRL */
    __I hw_hdmi_cec_stat_t CEC_STAT;       /*!< [0x7D01] CEC_STAT */
    __IO hw_hdmi_cec_mask_t CEC_MASK;      /*!< [0x7D02] CEC_MASK */
    __IO hw_hdmi_cec_polarity_t CEC_POLARITY; /*!< [0x7D03] CEC_POLARITY */
    __I hw_hdmi_cec_int_t CEC_INT;         /*!< [0x7D04] CEC_INT */
    __IO hw_hdmi_cec_addr_l_t CEC_ADDR_L;  /*!< [0x7D05] CEC_ADDR_L */
    __IO hw_hdmi_cec_addr_h_t CEC_ADDR_H;  /*!< [0x7D06] CEC_ADDR_H */
    __IO hw_hdmi_cec_tx_cnt_t CEC_TX_CNT;  /*!< [0x7D07] CEC_TX_CNT */
    __I hw_hdmi_cec_rx_cnt_t CEC_RX_CNT;   /*!< [0x7D08] CEC_RX_CNT */
    uint8_t _reserved24[7];
    __IO hw_hdmi_cec_tx_datan_t CEC_TX_DATAn[16]; /*!< [0x7D10] CEC_TX_DATA */
    __I hw_hdmi_cec_rx_datan_t CEC_RX_DATAn[16]; /*!< [0x7D20] CEC_RX_DATA */
    __IO hw_hdmi_cec_lock_t CEC_LOCK;      /*!< [0x7D30] CEC_LOCK */
    __IO hw_hdmi_cec_wkupctrl_t CEC_WKUPCTRL; /*!< [0x7D31] CEC_WKUPCTRL */
    uint8_t _reserved25[206];
    __IO hw_hdmi_i2cm_slave_t I2CM_SLAVE;  /*!< [0x7E00] I2CM_SLAVE */
    __IO hw_hdmi_i2cm_address_t I2CM_ADDRESS; /*!< [0x7E01] I2CM_ADDRESS */
    __IO hw_hdmi_i2cm_datao_t I2CM_DATAO;  /*!< [0x7E02] I2CM_DATAO */
    __I hw_hdmi_i2cm_datai_t I2CM_DATAI;   /*!< [0x7E03] I2CM_DATAI */
    __O hw_hdmi_i2cm_operation_t I2CM_OPERATION; /*!< [0x7E04] I2CM_OPERATION */
    __IO hw_hdmi_i2cm_int_t I2CM_INT;      /*!< [0x7E05] I2CM_INT */
    __IO hw_hdmi_i2cm_ctlint_t I2CM_CTLINT; /*!< [0x7E06] I2CM_CTLINT */
    __IO hw_hdmi_i2cm_div_t I2CM_DIV;      /*!< [0x7E07] I2CM_DIV */
    __IO hw_hdmi_i2cm_segaddr_t I2CM_SEGADDR; /*!< [0x7E08] I2CM_SEGADDR */
    __IO hw_hdmi_i2cm_softrstz_t I2CM_SOFTRSTZ; /*!< [0x7E09] I2CM_SOFTRSTZ */
    __IO hw_hdmi_i2cm_segptr_t I2CM_SEGPTR; /*!< [0x7E0A] I2CM_SEGPTR */
    __IO hw_hdmi_i2cm_ss_scl_hcnt_1_addr_t I2CM_SS_SCL_HCNT_1_ADDR; /*!< [0x7E0B] I2CM_SS_SCL_HCNT_1_ADDR */
    __IO hw_hdmi_i2cm_ss_scl_hcnt_0_addr_t I2CM_SS_SCL_HCNT_0_ADDR; /*!< [0x7E0C] I2CM_SS_SCL_HCNT_0_ADDR */
    __IO hw_hdmi_i2cm_ss_scl_lcnt_1_addr_t I2CM_SS_SCL_LCNT_1_ADDR; /*!< [0x7E0D] I2CM_SS_SCL_LCNT_1_ADDR */
    __IO hw_hdmi_i2cm_ss_scl_lcnt_0_addr_t I2CM_SS_SCL_LCNT_0_ADDR; /*!< [0x7E0E] I2CM_SS_SCL_LCNT_0_ADDR */
    __IO hw_hdmi_i2cm_fs_scl_hcnt_1_addr_t I2CM_FS_SCL_HCNT_1_ADDR; /*!< [0x7E0F] I2CM_FS_SCL_HCNT_1_ADDR */
    __IO hw_hdmi_i2cm_fs_scl_hcnt_0_addr_t I2CM_FS_SCL_HCNT_0_ADDR; /*!< [0x7E10] I2CM_FS_SCL_HCNT_0_ADDR */
    __IO hw_hdmi_i2cm_fs_scl_lcnt_1_addr_t I2CM_FS_SCL_LCNT_1_ADDR; /*!< [0x7E11] I2CM_FS_SCL_LCNT_1_ADDR */
    __IO hw_hdmi_i2cm_fs_scl_lcnt_0_addr_t I2CM_FS_SCL_LCNT_0_ADDR; /*!< [0x7E12] I2CM_FS_SCL_LCNT_0_ADDR */
    uint8_t _reserved26[237];
    __IO hw_hdmi_base_pointer_addr_t BASE_POINTER_ADDR; /*!< [0x7F00] BASE_POINTER_ADDR */
} hw_hdmi_t;
#pragma pack()

/*! @brief Macro to access all HDMI registers. */
/*! @param x HDMI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_HDMI_REGS(HDMI_BASE)</code>. */
#define HW_HDMI_REGS(x) (*(hw_hdmi_t *)(x))

/*
 * iMX6DP HW_PRE
 *
 * HW PRE
 *
 * Registers defined in this header file:
 * - HW_HW_PRE_CTRL - PRE Control Register
 * - HW_HW_PRE_IRQ_MASK - PRE IRQ Mask Register
 * - HW_HW_PRE_IRQ_STAT - PRE Interrupt Status Register
 * - HW_HW_PRE_CUR_BUF - PRE Base Address 0 Register
 * - HW_HW_PRE_NEXT_BUF - PRE Base Address 1 Register
 * - HW_HW_PRE_U_BUF_OFFSET - PRE U Buffer Offset Register
 * - HW_HW_PRE_V_BUF_OFFSET - PRE V Buffer Offset Register
 * - HW_HW_PRE_TPR_CTRL - PRE TPR Control Register
 * - HW_HW_PRE_PREFETCH_ENGINE_CTRL - PRE Prefetch Engine Control Register
 * - HW_HW_PRE_PREFETCH_ENGINE_STATUS - PRE Prefetch Engine Status Register
 * - HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE - PRE Prefetch Engine Input Size Register
 * - HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC - PRE Prefetch Engine Output Size Up-Left Coordinate
 * - HW_HW_PRE_PREFETCH_ENGINE_PITCH - PRE Prefetch Engine Pitch Register
 * - HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET - PRE Prefetch Engine Shift Control Register
 * - HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH - PRE Prefetch Engine Shift Parameter Register
 * - HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET - PRE Prefetch Engine Interlace Offset
 * - HW_HW_PRE_STORE_ENGINE_CTRL - PRE Store Engine Control Register
 * - HW_HW_PRE_STORE_ENGINE_STATUS - PRE Store Engine Status Register
 * - HW_HW_PRE_STORE_ENGINE_SIZE - PRE Store Engine Source Size Register
 * - HW_HW_PRE_STORE_ENGINE_PITCH - PRE Store Engine Pitch Register
 * - HW_HW_PRE_STORE_ENGINE_ADDR - PRE Store Engine Address Register
 * - HW_HW_PRE_DEBUGCTRL - Debug Control Register
 * - HW_HW_PRE_DEBUG - Debug Register
 *
 * - hw_hw_pre_t - Struct containing all module registers.
 */

#define HW_HW_PRE_INSTANCE_COUNT (1U) /*!< Number of instances of the HW_PRE module. */
#define HW_HW_PRE (0U) /*!< Instance number for HW_PRE. */
#define HW_PRE_BASE           (0x0U) /*!< Base address for HW_PRE. */
/*! Array initializer of HW_PRE base addresses. */
#define HW_PRE_BASE_ADDRS     { HW_PRE_BASE }

/*******************************************************************************
 * HW_HW_PRE_CTRL - PRE Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_CTRL - PRE Control Register (RW)
 *
 * Reset value: 0xC0000004U
 *
 * The CTRL register contains controls for the PRE module.Examples:
 * REG_CTRL_SET(BM_PRE_CTRL_SFTRST); REG_CTRL_CLR(BM_PRE_CTRL_SFTRST | BM_PRE_CTRL_CLKGATE);
 */
typedef union _hw_hw_pre_ctrl
{
    uint32_t U;
    struct _hw_hw_pre_ctrl_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t BLOCK_EN : 1;         /*!< [1]  */
        uint32_t BLOCK_16 : 1;         /*!< [2]  */
        uint32_t RSVD0 : 1;            /*!< [3]  */
        uint32_t SDW_UPDATE : 1;       /*!< [4]  */
        uint32_t VFLIP : 1;            /*!< [5]  */
        uint32_t SO : 1;               /*!< [6]  */
        uint32_t INTERLACED_FIELD : 1; /*!< [7]  */
        uint32_t HANDSHAKE_EN : 1;     /*!< [8]  */
        uint32_t HANDSHAKE_LINE_NUM : 2; /*!< [10:9]  */
        uint32_t HANDSHAKE_ABORT_SKIP_EN : 1; /*!< [11]  */
        uint32_t RSVD1 : 4;            /*!< [15:12]  */
        uint32_t RSVD2 : 12;           /*!< [27:16]  */
        uint32_t EN_REPEAT : 1;        /*!< [28]  */
        uint32_t TPR_REST_SEL : 1;     /*!< [29]  */
        uint32_t CLKGATE : 1;          /*!< [30] CLKGATE */
        uint32_t SFTRST : 1;           /*!< [31]  */
    } B;
} hw_hw_pre_ctrl_t;

/*!
 * @name Constants and macros for entire HW_PRE_CTRL register
 */
/*@{*/
#define HW_HW_PRE_CTRL_ADDR(x)   ((uintptr_t)(x) + 0x0U)

#define HW_HW_PRE_CTRL(x)        (*(__IO hw_hw_pre_ctrl_t *) HW_HW_PRE_CTRL_ADDR(x))
#define HW_HW_PRE_CTRL_RD(x)     (HW_HW_PRE_CTRL(x).U)
#define HW_HW_PRE_CTRL_WR(x, v)  (HW_HW_PRE_CTRL(x).U = (v))
#define HW_HW_PRE_CTRL_SET(x, v) (HW_HW_PRE_CTRL_WR(x, HW_HW_PRE_CTRL_RD(x) |  (v)))
#define HW_HW_PRE_CTRL_CLR(x, v) (HW_HW_PRE_CTRL_WR(x, HW_HW_PRE_CTRL_RD(x) & ~(v)))
#define HW_HW_PRE_CTRL_TOG(x, v) (HW_HW_PRE_CTRL_WR(x, HW_HW_PRE_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_CTRL bitfields
 */

/*!
 * @name Register HW_PRE_CTRL, field ENABLE[0] (RW)
 *
 * Enables PRE operation with specified parameters. The ENABLE bit will remain
 * set while the PRE is active and will be cleared once the current operation
 * completes. Software should use the IRQ bit in the HW_PRE_STAT when polling for PRE
 * completion.
 */
/*@{*/
#define BP_HW_PRE_CTRL_ENABLE (0U)         /*!< Bit position for HW_PRE_CTRL_ENABLE. */
#define BM_HW_PRE_CTRL_ENABLE (0x00000001U) /*!< Bit mask for HW_PRE_CTRL_ENABLE. */
#define BS_HW_PRE_CTRL_ENABLE (1U)         /*!< Bit field size in bits for HW_PRE_CTRL_ENABLE. */

/*! @brief Read current value of the HW_PRE_CTRL_ENABLE field. */
#define BR_HW_PRE_CTRL_ENABLE(x) (HW_HW_PRE_CTRL(x).B.ENABLE)

/*! @brief Format value for bitfield HW_PRE_CTRL_ENABLE. */
#define BF_HW_PRE_CTRL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_ENABLE) & BM_HW_PRE_CTRL_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_HW_PRE_CTRL_ENABLE(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_ENABLE) | BF_HW_PRE_CTRL_ENABLE(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field BLOCK_EN[1] (RW)
 *
 * Chooses the prefetch mode
 *
 * Values:
 * - 0 - 0x0 Prefetch / Store in scan mode
 * - 1 - 0x1 Prefetch / Store in block mode
 */
/*@{*/
#define BP_HW_PRE_CTRL_BLOCK_EN (1U)       /*!< Bit position for HW_PRE_CTRL_BLOCK_EN. */
#define BM_HW_PRE_CTRL_BLOCK_EN (0x00000002U) /*!< Bit mask for HW_PRE_CTRL_BLOCK_EN. */
#define BS_HW_PRE_CTRL_BLOCK_EN (1U)       /*!< Bit field size in bits for HW_PRE_CTRL_BLOCK_EN. */

/*! @brief Read current value of the HW_PRE_CTRL_BLOCK_EN field. */
#define BR_HW_PRE_CTRL_BLOCK_EN(x) (HW_HW_PRE_CTRL(x).B.BLOCK_EN)

/*! @brief Format value for bitfield HW_PRE_CTRL_BLOCK_EN. */
#define BF_HW_PRE_CTRL_BLOCK_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_BLOCK_EN) & BM_HW_PRE_CTRL_BLOCK_EN)

/*! @brief Set the BLOCK_EN field to a new value. */
#define BW_HW_PRE_CTRL_BLOCK_EN(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_BLOCK_EN) | BF_HW_PRE_CTRL_BLOCK_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field BLOCK_16[2] (RW)
 *
 * Determines the block size
 */
/*@{*/
#define BP_HW_PRE_CTRL_BLOCK_16 (2U)       /*!< Bit position for HW_PRE_CTRL_BLOCK_16. */
#define BM_HW_PRE_CTRL_BLOCK_16 (0x00000004U) /*!< Bit mask for HW_PRE_CTRL_BLOCK_16. */
#define BS_HW_PRE_CTRL_BLOCK_16 (1U)       /*!< Bit field size in bits for HW_PRE_CTRL_BLOCK_16. */

/*! @brief Read current value of the HW_PRE_CTRL_BLOCK_16 field. */
#define BR_HW_PRE_CTRL_BLOCK_16(x) (HW_HW_PRE_CTRL(x).B.BLOCK_16)

/*! @brief Format value for bitfield HW_PRE_CTRL_BLOCK_16. */
#define BF_HW_PRE_CTRL_BLOCK_16(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_BLOCK_16) & BM_HW_PRE_CTRL_BLOCK_16)

/*! @brief Set the BLOCK_16 field to a new value. */
#define BW_HW_PRE_CTRL_BLOCK_16(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_BLOCK_16) | BF_HW_PRE_CTRL_BLOCK_16(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field RSVD0[3] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_CTRL_RSVD0 (3U)          /*!< Bit position for HW_PRE_CTRL_RSVD0. */
#define BM_HW_PRE_CTRL_RSVD0 (0x00000008U) /*!< Bit mask for HW_PRE_CTRL_RSVD0. */
#define BS_HW_PRE_CTRL_RSVD0 (1U)          /*!< Bit field size in bits for HW_PRE_CTRL_RSVD0. */

/*! @brief Read current value of the HW_PRE_CTRL_RSVD0 field. */
#define BR_HW_PRE_CTRL_RSVD0(x) (HW_HW_PRE_CTRL(x).B.RSVD0)
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field SDW_UPDATE[4] (RW)
 *
 * Indicates that the shadow register should be updated. If have any control
 * register bits are changed, Software have to set this bit, and then all register
 * bits will be updated to shadow register end of current frame in store engine.
 * And then it will be cleared automatically by hardware.
 */
/*@{*/
#define BP_HW_PRE_CTRL_SDW_UPDATE (4U)     /*!< Bit position for HW_PRE_CTRL_SDW_UPDATE. */
#define BM_HW_PRE_CTRL_SDW_UPDATE (0x00000010U) /*!< Bit mask for HW_PRE_CTRL_SDW_UPDATE. */
#define BS_HW_PRE_CTRL_SDW_UPDATE (1U)     /*!< Bit field size in bits for HW_PRE_CTRL_SDW_UPDATE. */

/*! @brief Read current value of the HW_PRE_CTRL_SDW_UPDATE field. */
#define BR_HW_PRE_CTRL_SDW_UPDATE(x) (HW_HW_PRE_CTRL(x).B.SDW_UPDATE)

/*! @brief Format value for bitfield HW_PRE_CTRL_SDW_UPDATE. */
#define BF_HW_PRE_CTRL_SDW_UPDATE(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_SDW_UPDATE) & BM_HW_PRE_CTRL_SDW_UPDATE)

/*! @brief Set the SDW_UPDATE field to a new value. */
#define BW_HW_PRE_CTRL_SDW_UPDATE(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_SDW_UPDATE) | BF_HW_PRE_CTRL_SDW_UPDATE(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field VFLIP[5] (RW)
 *
 * Indicates that the input should be flipped vertically.
 */
/*@{*/
#define BP_HW_PRE_CTRL_VFLIP (5U)          /*!< Bit position for HW_PRE_CTRL_VFLIP. */
#define BM_HW_PRE_CTRL_VFLIP (0x00000020U) /*!< Bit mask for HW_PRE_CTRL_VFLIP. */
#define BS_HW_PRE_CTRL_VFLIP (1U)          /*!< Bit field size in bits for HW_PRE_CTRL_VFLIP. */

/*! @brief Read current value of the HW_PRE_CTRL_VFLIP field. */
#define BR_HW_PRE_CTRL_VFLIP(x) (HW_HW_PRE_CTRL(x).B.VFLIP)

/*! @brief Format value for bitfield HW_PRE_CTRL_VFLIP. */
#define BF_HW_PRE_CTRL_VFLIP(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_VFLIP) & BM_HW_PRE_CTRL_VFLIP)

/*! @brief Set the VFLIP field to a new value. */
#define BW_HW_PRE_CTRL_VFLIP(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_VFLIP) | BF_HW_PRE_CTRL_VFLIP(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field SO[6] (RW)
 *
 * Indicates that the scan order is progressive or interlaced. SO = 0 Scan order
 * is progressive. SO = 1 Scan order is interlaced.
 */
/*@{*/
#define BP_HW_PRE_CTRL_SO    (6U)          /*!< Bit position for HW_PRE_CTRL_SO. */
#define BM_HW_PRE_CTRL_SO    (0x00000040U) /*!< Bit mask for HW_PRE_CTRL_SO. */
#define BS_HW_PRE_CTRL_SO    (1U)          /*!< Bit field size in bits for HW_PRE_CTRL_SO. */

/*! @brief Read current value of the HW_PRE_CTRL_SO field. */
#define BR_HW_PRE_CTRL_SO(x) (HW_HW_PRE_CTRL(x).B.SO)

/*! @brief Format value for bitfield HW_PRE_CTRL_SO. */
#define BF_HW_PRE_CTRL_SO(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_SO) & BM_HW_PRE_CTRL_SO)

/*! @brief Set the SO field to a new value. */
#define BW_HW_PRE_CTRL_SO(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_SO) | BF_HW_PRE_CTRL_SO(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field INTERLACED_FIELD[7] (RW)
 *
 * Indicates that the interlaced field output order. INTERLACED_FIELD = 0
 * ,Top-Bottom. INTERLACED_FIELD = 1, Bottom-Top.
 */
/*@{*/
#define BP_HW_PRE_CTRL_INTERLACED_FIELD (7U) /*!< Bit position for HW_PRE_CTRL_INTERLACED_FIELD. */
#define BM_HW_PRE_CTRL_INTERLACED_FIELD (0x00000080U) /*!< Bit mask for HW_PRE_CTRL_INTERLACED_FIELD. */
#define BS_HW_PRE_CTRL_INTERLACED_FIELD (1U) /*!< Bit field size in bits for HW_PRE_CTRL_INTERLACED_FIELD. */

/*! @brief Read current value of the HW_PRE_CTRL_INTERLACED_FIELD field. */
#define BR_HW_PRE_CTRL_INTERLACED_FIELD(x) (HW_HW_PRE_CTRL(x).B.INTERLACED_FIELD)

/*! @brief Format value for bitfield HW_PRE_CTRL_INTERLACED_FIELD. */
#define BF_HW_PRE_CTRL_INTERLACED_FIELD(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_INTERLACED_FIELD) & BM_HW_PRE_CTRL_INTERLACED_FIELD)

/*! @brief Set the INTERLACED_FIELD field to a new value. */
#define BW_HW_PRE_CTRL_INTERLACED_FIELD(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_INTERLACED_FIELD) | BF_HW_PRE_CTRL_INTERLACED_FIELD(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field HANDSHAKE_EN[8] (RW)
 *
 * Enable bit for handshake with the PRE and PRG
 *
 * Values:
 * - 0 - 0x0 Handshake with the PRE is disabled.
 * - 1 - 0x1 Handshake with the PRE is enabled.
 */
/*@{*/
#define BP_HW_PRE_CTRL_HANDSHAKE_EN (8U)   /*!< Bit position for HW_PRE_CTRL_HANDSHAKE_EN. */
#define BM_HW_PRE_CTRL_HANDSHAKE_EN (0x00000100U) /*!< Bit mask for HW_PRE_CTRL_HANDSHAKE_EN. */
#define BS_HW_PRE_CTRL_HANDSHAKE_EN (1U)   /*!< Bit field size in bits for HW_PRE_CTRL_HANDSHAKE_EN. */

/*! @brief Read current value of the HW_PRE_CTRL_HANDSHAKE_EN field. */
#define BR_HW_PRE_CTRL_HANDSHAKE_EN(x) (HW_HW_PRE_CTRL(x).B.HANDSHAKE_EN)

/*! @brief Format value for bitfield HW_PRE_CTRL_HANDSHAKE_EN. */
#define BF_HW_PRE_CTRL_HANDSHAKE_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_HANDSHAKE_EN) & BM_HW_PRE_CTRL_HANDSHAKE_EN)

/*! @brief Set the HANDSHAKE_EN field to a new value. */
#define BW_HW_PRE_CTRL_HANDSHAKE_EN(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_HANDSHAKE_EN) | BF_HW_PRE_CTRL_HANDSHAKE_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field HANDSHAKE_LINE_NUM[10:9] (RW)
 *
 * Selects Array Size
 *
 * Values:
 * - 0 - 0x0 4 lines handshake
 * - 1 - 0x1 8 lines handshake
 */
/*@{*/
#define BP_HW_PRE_CTRL_HANDSHAKE_LINE_NUM (9U) /*!< Bit position for HW_PRE_CTRL_HANDSHAKE_LINE_NUM. */
#define BM_HW_PRE_CTRL_HANDSHAKE_LINE_NUM (0x00000600U) /*!< Bit mask for HW_PRE_CTRL_HANDSHAKE_LINE_NUM. */
#define BS_HW_PRE_CTRL_HANDSHAKE_LINE_NUM (2U) /*!< Bit field size in bits for HW_PRE_CTRL_HANDSHAKE_LINE_NUM. */

/*! @brief Read current value of the HW_PRE_CTRL_HANDSHAKE_LINE_NUM field. */
#define BR_HW_PRE_CTRL_HANDSHAKE_LINE_NUM(x) (HW_HW_PRE_CTRL(x).B.HANDSHAKE_LINE_NUM)

/*! @brief Format value for bitfield HW_PRE_CTRL_HANDSHAKE_LINE_NUM. */
#define BF_HW_PRE_CTRL_HANDSHAKE_LINE_NUM(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_HANDSHAKE_LINE_NUM) & BM_HW_PRE_CTRL_HANDSHAKE_LINE_NUM)

/*! @brief Set the HANDSHAKE_LINE_NUM field to a new value. */
#define BW_HW_PRE_CTRL_HANDSHAKE_LINE_NUM(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_HANDSHAKE_LINE_NUM) | BF_HW_PRE_CTRL_HANDSHAKE_LINE_NUM(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field HANDSHAKE_ABORT_SKIP_EN[11] (RW)
 *
 * Enable bit for handshake abort feature
 *
 * Values:
 * - 0 - 0x0 Handshake Abort feature is disabled.
 * - 1 - 0x1 Handshake Abort feature is enabled.
 */
/*@{*/
#define BP_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN (11U) /*!< Bit position for HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN. */
#define BM_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN (0x00000800U) /*!< Bit mask for HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN. */
#define BS_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN (1U) /*!< Bit field size in bits for HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN. */

/*! @brief Read current value of the HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN field. */
#define BR_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN(x) (HW_HW_PRE_CTRL(x).B.HANDSHAKE_ABORT_SKIP_EN)

/*! @brief Format value for bitfield HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN. */
#define BF_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN) & BM_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN)

/*! @brief Set the HANDSHAKE_ABORT_SKIP_EN field to a new value. */
#define BW_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN) | BF_HW_PRE_CTRL_HANDSHAKE_ABORT_SKIP_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field RSVD1[15:12] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_CTRL_RSVD1 (12U)         /*!< Bit position for HW_PRE_CTRL_RSVD1. */
#define BM_HW_PRE_CTRL_RSVD1 (0x0000F000U) /*!< Bit mask for HW_PRE_CTRL_RSVD1. */
#define BS_HW_PRE_CTRL_RSVD1 (4U)          /*!< Bit field size in bits for HW_PRE_CTRL_RSVD1. */

/*! @brief Read current value of the HW_PRE_CTRL_RSVD1 field. */
#define BR_HW_PRE_CTRL_RSVD1(x) (HW_HW_PRE_CTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field RSVD2[27:16] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_CTRL_RSVD2 (16U)         /*!< Bit position for HW_PRE_CTRL_RSVD2. */
#define BM_HW_PRE_CTRL_RSVD2 (0x0FFF0000U) /*!< Bit mask for HW_PRE_CTRL_RSVD2. */
#define BS_HW_PRE_CTRL_RSVD2 (12U)         /*!< Bit field size in bits for HW_PRE_CTRL_RSVD2. */

/*! @brief Read current value of the HW_PRE_CTRL_RSVD2 field. */
#define BR_HW_PRE_CTRL_RSVD2(x) (HW_HW_PRE_CTRL(x).B.RSVD2)
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field EN_REPEAT[28] (RW)
 *
 * Enable the PRE to run continuously. When this bit is set, the PRE will repeat
 * based on the current configuration register settings. If this bit is not set,
 * the PRE will complete the process and enter the idle state ready to accept
 * the next frame to be processed. This bit should be set when the store engine
 * handshake mode is enabled so that the next frame is automatically generated for
 * the next screen refresh cycle. If it does not set and the handshake mode is
 * enabled, the CPU will have to initiate the PRE for the next refresh cycle. When
 * the PRE SHADOW UPDATE bit is set, it has priority over the REPEAT mode, in that
 * the new register settings are fetched first, and then the next PRE operation
 * will continue.
 */
/*@{*/
#define BP_HW_PRE_CTRL_EN_REPEAT (28U)     /*!< Bit position for HW_PRE_CTRL_EN_REPEAT. */
#define BM_HW_PRE_CTRL_EN_REPEAT (0x10000000U) /*!< Bit mask for HW_PRE_CTRL_EN_REPEAT. */
#define BS_HW_PRE_CTRL_EN_REPEAT (1U)      /*!< Bit field size in bits for HW_PRE_CTRL_EN_REPEAT. */

/*! @brief Read current value of the HW_PRE_CTRL_EN_REPEAT field. */
#define BR_HW_PRE_CTRL_EN_REPEAT(x) (HW_HW_PRE_CTRL(x).B.EN_REPEAT)

/*! @brief Format value for bitfield HW_PRE_CTRL_EN_REPEAT. */
#define BF_HW_PRE_CTRL_EN_REPEAT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_EN_REPEAT) & BM_HW_PRE_CTRL_EN_REPEAT)

/*! @brief Set the EN_REPEAT field to a new value. */
#define BW_HW_PRE_CTRL_EN_REPEAT(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_EN_REPEAT) | BF_HW_PRE_CTRL_EN_REPEAT(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field TPR_REST_SEL[29] (RW)
 *
 * TPR software reset select signal
 *
 * Values:
 * - 0 - TPR will not be reset before every frame start.
 * - 1 - TPR will be reset before every frame start.
 */
/*@{*/
#define BP_HW_PRE_CTRL_TPR_REST_SEL (29U)  /*!< Bit position for HW_PRE_CTRL_TPR_REST_SEL. */
#define BM_HW_PRE_CTRL_TPR_REST_SEL (0x20000000U) /*!< Bit mask for HW_PRE_CTRL_TPR_REST_SEL. */
#define BS_HW_PRE_CTRL_TPR_REST_SEL (1U)   /*!< Bit field size in bits for HW_PRE_CTRL_TPR_REST_SEL. */

/*! @brief Read current value of the HW_PRE_CTRL_TPR_REST_SEL field. */
#define BR_HW_PRE_CTRL_TPR_REST_SEL(x) (HW_HW_PRE_CTRL(x).B.TPR_REST_SEL)

/*! @brief Format value for bitfield HW_PRE_CTRL_TPR_REST_SEL. */
#define BF_HW_PRE_CTRL_TPR_REST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_TPR_REST_SEL) & BM_HW_PRE_CTRL_TPR_REST_SEL)

/*! @brief Set the TPR_REST_SEL field to a new value. */
#define BW_HW_PRE_CTRL_TPR_REST_SEL(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_TPR_REST_SEL) | BF_HW_PRE_CTRL_TPR_REST_SEL(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field CLKGATE[30] (RW)
 *
 * This bit must be set to zero for normal operation. When set to 1, it gates
 * off the clocks to the block.
 */
/*@{*/
#define BP_HW_PRE_CTRL_CLKGATE (30U)       /*!< Bit position for HW_PRE_CTRL_CLKGATE. */
#define BM_HW_PRE_CTRL_CLKGATE (0x40000000U) /*!< Bit mask for HW_PRE_CTRL_CLKGATE. */
#define BS_HW_PRE_CTRL_CLKGATE (1U)        /*!< Bit field size in bits for HW_PRE_CTRL_CLKGATE. */

/*! @brief Read current value of the HW_PRE_CTRL_CLKGATE field. */
#define BR_HW_PRE_CTRL_CLKGATE(x) (HW_HW_PRE_CTRL(x).B.CLKGATE)

/*! @brief Format value for bitfield HW_PRE_CTRL_CLKGATE. */
#define BF_HW_PRE_CTRL_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_CLKGATE) & BM_HW_PRE_CTRL_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_HW_PRE_CTRL_CLKGATE(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_CLKGATE) | BF_HW_PRE_CTRL_CLKGATE(v)))
/*@}*/

/*!
 * @name Register HW_PRE_CTRL, field SFTRST[31] (RW)
 *
 * Set this bit to zero to enable normal PRE operation. Set this bit to one
 * (default) to disable clocking with the PRE and hold it in its reset (lowest power)
 * state. This bit can be turned on and then off to reset the PRE block to its
 * default state.
 */
/*@{*/
#define BP_HW_PRE_CTRL_SFTRST (31U)        /*!< Bit position for HW_PRE_CTRL_SFTRST. */
#define BM_HW_PRE_CTRL_SFTRST (0x80000000U) /*!< Bit mask for HW_PRE_CTRL_SFTRST. */
#define BS_HW_PRE_CTRL_SFTRST (1U)         /*!< Bit field size in bits for HW_PRE_CTRL_SFTRST. */

/*! @brief Read current value of the HW_PRE_CTRL_SFTRST field. */
#define BR_HW_PRE_CTRL_SFTRST(x) (HW_HW_PRE_CTRL(x).B.SFTRST)

/*! @brief Format value for bitfield HW_PRE_CTRL_SFTRST. */
#define BF_HW_PRE_CTRL_SFTRST(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CTRL_SFTRST) & BM_HW_PRE_CTRL_SFTRST)

/*! @brief Set the SFTRST field to a new value. */
#define BW_HW_PRE_CTRL_SFTRST(x, v) (HW_HW_PRE_CTRL_WR(x, (HW_HW_PRE_CTRL_RD(x) & ~BM_HW_PRE_CTRL_SFTRST) | BF_HW_PRE_CTRL_SFTRST(v)))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_IRQ_MASK - PRE IRQ Mask Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_IRQ_MASK - PRE IRQ Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Controls masking for all PRE interrupts
 */
typedef union _hw_hw_pre_irq_mask
{
    uint32_t U;
    struct _hw_hw_pre_irq_mask_bitfields
    {
        uint32_t PREFETCH_IRQ_EN : 1;  /*!< [0]  */
        uint32_t STORE_IRQ_EN : 1;     /*!< [1]  */
        uint32_t HANDSHAKE_ABORT_IRQ : 1; /*!< [2]  */
        uint32_t TPR_RD_NUM_BYTES_OVFL_IRQ : 1; /*!< [3]  */
        uint32_t HANDSHAKE_ERROR_IRQ_EN : 1; /*!< [4]  */
        uint32_t RSVD1 : 27;           /*!< [31:5]  */
    } B;
} hw_hw_pre_irq_mask_t;

/*!
 * @name Constants and macros for entire HW_PRE_IRQ_MASK register
 */
/*@{*/
#define HW_HW_PRE_IRQ_MASK_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_HW_PRE_IRQ_MASK(x)    (*(__IO hw_hw_pre_irq_mask_t *) HW_HW_PRE_IRQ_MASK_ADDR(x))
#define HW_HW_PRE_IRQ_MASK_RD(x) (HW_HW_PRE_IRQ_MASK(x).U)
#define HW_HW_PRE_IRQ_MASK_WR(x, v) (HW_HW_PRE_IRQ_MASK(x).U = (v))
#define HW_HW_PRE_IRQ_MASK_SET(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, HW_HW_PRE_IRQ_MASK_RD(x) |  (v)))
#define HW_HW_PRE_IRQ_MASK_CLR(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, HW_HW_PRE_IRQ_MASK_RD(x) & ~(v)))
#define HW_HW_PRE_IRQ_MASK_TOG(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, HW_HW_PRE_IRQ_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_IRQ_MASK bitfields
 */

/*!
 * @name Register HW_PRE_IRQ_MASK, field PREFETCH_IRQ_EN[0] (RW)
 *
 * Enable prefetch engine interrupt detection
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN (0U) /*!< Bit position for HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN. */
#define BM_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN (0x00000001U) /*!< Bit mask for HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN. */
#define BS_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN (1U) /*!< Bit field size in bits for HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN field. */
#define BR_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN(x) (HW_HW_PRE_IRQ_MASK(x).B.PREFETCH_IRQ_EN)

/*! @brief Format value for bitfield HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN. */
#define BF_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN) & BM_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN)

/*! @brief Set the PREFETCH_IRQ_EN field to a new value. */
#define BW_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, (HW_HW_PRE_IRQ_MASK_RD(x) & ~BM_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN) | BF_HW_PRE_IRQ_MASK_PREFETCH_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_MASK, field STORE_IRQ_EN[1] (RW)
 *
 * Enable prefetch engine interrupt detection
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_STORE_IRQ_EN (1U) /*!< Bit position for HW_PRE_IRQ_MASK_STORE_IRQ_EN. */
#define BM_HW_PRE_IRQ_MASK_STORE_IRQ_EN (0x00000002U) /*!< Bit mask for HW_PRE_IRQ_MASK_STORE_IRQ_EN. */
#define BS_HW_PRE_IRQ_MASK_STORE_IRQ_EN (1U) /*!< Bit field size in bits for HW_PRE_IRQ_MASK_STORE_IRQ_EN. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_STORE_IRQ_EN field. */
#define BR_HW_PRE_IRQ_MASK_STORE_IRQ_EN(x) (HW_HW_PRE_IRQ_MASK(x).B.STORE_IRQ_EN)

/*! @brief Format value for bitfield HW_PRE_IRQ_MASK_STORE_IRQ_EN. */
#define BF_HW_PRE_IRQ_MASK_STORE_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_MASK_STORE_IRQ_EN) & BM_HW_PRE_IRQ_MASK_STORE_IRQ_EN)

/*! @brief Set the STORE_IRQ_EN field to a new value. */
#define BW_HW_PRE_IRQ_MASK_STORE_IRQ_EN(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, (HW_HW_PRE_IRQ_MASK_RD(x) & ~BM_HW_PRE_IRQ_MASK_STORE_IRQ_EN) | BF_HW_PRE_IRQ_MASK_STORE_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_MASK, field HANDSHAKE_ABORT_IRQ[2] (RW)
 *
 * Indicates the PRE Handshake Abort interrupt. This IRQ is routed through the
 * PRE_IRQ when the HANDSHAKE_ABORT_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ (2U) /*!< Bit position for HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ. */
#define BM_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ (0x00000004U) /*!< Bit mask for HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ. */
#define BS_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ field. */
#define BR_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ(x) (HW_HW_PRE_IRQ_MASK(x).B.HANDSHAKE_ABORT_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ. */
#define BF_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ) & BM_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ)

/*! @brief Set the HANDSHAKE_ABORT_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, (HW_HW_PRE_IRQ_MASK_RD(x) & ~BM_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ) | BF_HW_PRE_IRQ_MASK_HANDSHAKE_ABORT_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_MASK, field TPR_RD_NUM_BYTES_OVFL_IRQ[3] (RW)
 *
 * Indicates an overflow interrupt when the requested data is bigger that the
 * memory buffer. This IRQ is routed through the PRE_IRQ when the
 * TPR_RD_NUM_BYTES_OVFL_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ (3U) /*!< Bit position for HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BM_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ (0x00000008U) /*!< Bit mask for HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BS_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ field. */
#define BR_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ(x) (HW_HW_PRE_IRQ_MASK(x).B.TPR_RD_NUM_BYTES_OVFL_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BF_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ) & BM_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ)

/*! @brief Set the TPR_RD_NUM_BYTES_OVFL_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, (HW_HW_PRE_IRQ_MASK_RD(x) & ~BM_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ) | BF_HW_PRE_IRQ_MASK_TPR_RD_NUM_BYTES_OVFL_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_MASK, field HANDSHAKE_ERROR_IRQ_EN[4] (RW)
 *
 * Enable Handshake error interrupt detection
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN (4U) /*!< Bit position for HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN. */
#define BM_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN (0x00000010U) /*!< Bit mask for HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN. */
#define BS_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN (1U) /*!< Bit field size in bits for HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN field. */
#define BR_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN(x) (HW_HW_PRE_IRQ_MASK(x).B.HANDSHAKE_ERROR_IRQ_EN)

/*! @brief Format value for bitfield HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN. */
#define BF_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN) & BM_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN)

/*! @brief Set the HANDSHAKE_ERROR_IRQ_EN field to a new value. */
#define BW_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN(x, v) (HW_HW_PRE_IRQ_MASK_WR(x, (HW_HW_PRE_IRQ_MASK_RD(x) & ~BM_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN) | BF_HW_PRE_IRQ_MASK_HANDSHAKE_ERROR_IRQ_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_MASK, field RSVD1[31:5] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_IRQ_MASK_RSVD1 (5U)      /*!< Bit position for HW_PRE_IRQ_MASK_RSVD1. */
#define BM_HW_PRE_IRQ_MASK_RSVD1 (0xFFFFFFE0U) /*!< Bit mask for HW_PRE_IRQ_MASK_RSVD1. */
#define BS_HW_PRE_IRQ_MASK_RSVD1 (27U)     /*!< Bit field size in bits for HW_PRE_IRQ_MASK_RSVD1. */

/*! @brief Read current value of the HW_PRE_IRQ_MASK_RSVD1 field. */
#define BR_HW_PRE_IRQ_MASK_RSVD1(x) (HW_HW_PRE_IRQ_MASK(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_IRQ_STAT - PRE Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_IRQ_STAT - PRE Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * PRE IRQs Each interrupt has a corresponding mask register in
 * HW_EPDC_IRQ_MASK. This register houses the interrupt bits for the Prefetch and Store Engines
 */
typedef union _hw_hw_pre_irq_stat
{
    uint32_t U;
    struct _hw_hw_pre_irq_stat_bitfields
    {
        uint32_t PREFETCH_IRQ : 1;     /*!< [0]  */
        uint32_t STORE_IRQ : 1;        /*!< [1]  */
        uint32_t HANDSHAKE_ABORT_IRQ : 1; /*!< [2]  */
        uint32_t TPR_RD_NUM_BYTES_OVFL_IRQ : 1; /*!< [3]  */
        uint32_t HANDSHAKE_ERROR_IRQ : 1; /*!< [4]  */
        uint32_t RSVD0 : 3;            /*!< [7:5]  */
        uint32_t AXI_WRITE_ERROR : 1;  /*!< [8]  */
        uint32_t AXI_READ_ERROR : 1;   /*!< [9]  */
        uint32_t AXI_ERROR_ID : 4;     /*!< [13:10]  */
        uint32_t RSVD1 : 18;           /*!< [31:14]  */
    } B;
} hw_hw_pre_irq_stat_t;

/*!
 * @name Constants and macros for entire HW_PRE_IRQ_STAT register
 */
/*@{*/
#define HW_HW_PRE_IRQ_STAT_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_HW_PRE_IRQ_STAT(x)    (*(__IO hw_hw_pre_irq_stat_t *) HW_HW_PRE_IRQ_STAT_ADDR(x))
#define HW_HW_PRE_IRQ_STAT_RD(x) (HW_HW_PRE_IRQ_STAT(x).U)
#define HW_HW_PRE_IRQ_STAT_WR(x, v) (HW_HW_PRE_IRQ_STAT(x).U = (v))
#define HW_HW_PRE_IRQ_STAT_SET(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, HW_HW_PRE_IRQ_STAT_RD(x) |  (v)))
#define HW_HW_PRE_IRQ_STAT_CLR(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, HW_HW_PRE_IRQ_STAT_RD(x) & ~(v)))
#define HW_HW_PRE_IRQ_STAT_TOG(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, HW_HW_PRE_IRQ_STAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_IRQ_STAT bitfields
 */

/*!
 * @name Register HW_PRE_IRQ_STAT, field PREFETCH_IRQ[0] (RW)
 *
 * Indicates the Prefetch engine one frame done interrupt status. The IRQ is
 * routed through the PRE_IRQ when the PREFETCH_IRQ_EN bit in the HW_PRE_IRQ_MASK is
 * set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_PREFETCH_IRQ (0U) /*!< Bit position for HW_PRE_IRQ_STAT_PREFETCH_IRQ. */
#define BM_HW_PRE_IRQ_STAT_PREFETCH_IRQ (0x00000001U) /*!< Bit mask for HW_PRE_IRQ_STAT_PREFETCH_IRQ. */
#define BS_HW_PRE_IRQ_STAT_PREFETCH_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_PREFETCH_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_PREFETCH_IRQ field. */
#define BR_HW_PRE_IRQ_STAT_PREFETCH_IRQ(x) (HW_HW_PRE_IRQ_STAT(x).B.PREFETCH_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_PREFETCH_IRQ. */
#define BF_HW_PRE_IRQ_STAT_PREFETCH_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_PREFETCH_IRQ) & BM_HW_PRE_IRQ_STAT_PREFETCH_IRQ)

/*! @brief Set the PREFETCH_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_STAT_PREFETCH_IRQ(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_PREFETCH_IRQ) | BF_HW_PRE_IRQ_STAT_PREFETCH_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field STORE_IRQ[1] (RW)
 *
 * Indicates the Store engine one frame done interrupt status. This IRQ is
 * routed through the PRE_IRQ when the STORE_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_STORE_IRQ (1U)  /*!< Bit position for HW_PRE_IRQ_STAT_STORE_IRQ. */
#define BM_HW_PRE_IRQ_STAT_STORE_IRQ (0x00000002U) /*!< Bit mask for HW_PRE_IRQ_STAT_STORE_IRQ. */
#define BS_HW_PRE_IRQ_STAT_STORE_IRQ (1U)  /*!< Bit field size in bits for HW_PRE_IRQ_STAT_STORE_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_STORE_IRQ field. */
#define BR_HW_PRE_IRQ_STAT_STORE_IRQ(x) (HW_HW_PRE_IRQ_STAT(x).B.STORE_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_STORE_IRQ. */
#define BF_HW_PRE_IRQ_STAT_STORE_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_STORE_IRQ) & BM_HW_PRE_IRQ_STAT_STORE_IRQ)

/*! @brief Set the STORE_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_STAT_STORE_IRQ(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_STORE_IRQ) | BF_HW_PRE_IRQ_STAT_STORE_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field HANDSHAKE_ABORT_IRQ[2] (RW)
 *
 * Indicates the PRE Handshake Abort interrupt. this IRQ is routed through the
 * pre_irq when the HANDSHAKE_ABORT_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ (2U) /*!< Bit position for HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ. */
#define BM_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ (0x00000004U) /*!< Bit mask for HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ. */
#define BS_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ field. */
#define BR_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ(x) (HW_HW_PRE_IRQ_STAT(x).B.HANDSHAKE_ABORT_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ. */
#define BF_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ) & BM_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ)

/*! @brief Set the HANDSHAKE_ABORT_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ) | BF_HW_PRE_IRQ_STAT_HANDSHAKE_ABORT_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field TPR_RD_NUM_BYTES_OVFL_IRQ[3] (RW)
 *
 * Indicates an overflow interrupt when the requested data is bigger that the
 * memory buffer. This IRQ is routed through the pre_irq when the
 * TPR_RD_NUM_BYTES_OVFL_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ (3U) /*!< Bit position for HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BM_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ (0x00000008U) /*!< Bit mask for HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BS_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ field. */
#define BR_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ(x) (HW_HW_PRE_IRQ_STAT(x).B.TPR_RD_NUM_BYTES_OVFL_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ. */
#define BF_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ) & BM_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ)

/*! @brief Set the TPR_RD_NUM_BYTES_OVFL_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ) | BF_HW_PRE_IRQ_STAT_TPR_RD_NUM_BYTES_OVFL_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field HANDSHAKE_ERROR_IRQ[4] (RW)
 *
 * Indicates a Handshake ERROR interrupt. this IRQ is routed through the pre_irq
 * when the HANDSHAKE_ERROR_IRQ_EN bit in the HW_PRE_IRQ_MASK is set.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ (4U) /*!< Bit position for HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ. */
#define BM_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ (0x00000010U) /*!< Bit mask for HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ. */
#define BS_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ field. */
#define BR_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ(x) (HW_HW_PRE_IRQ_STAT(x).B.HANDSHAKE_ERROR_IRQ)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ. */
#define BF_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ) & BM_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ)

/*! @brief Set the HANDSHAKE_ERROR_IRQ field to a new value. */
#define BW_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ) | BF_HW_PRE_IRQ_STAT_HANDSHAKE_ERROR_IRQ(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field RSVD0[7:5] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_RSVD0 (5U)      /*!< Bit position for HW_PRE_IRQ_STAT_RSVD0. */
#define BM_HW_PRE_IRQ_STAT_RSVD0 (0x000000E0U) /*!< Bit mask for HW_PRE_IRQ_STAT_RSVD0. */
#define BS_HW_PRE_IRQ_STAT_RSVD0 (3U)      /*!< Bit field size in bits for HW_PRE_IRQ_STAT_RSVD0. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_RSVD0 field. */
#define BR_HW_PRE_IRQ_STAT_RSVD0(x) (HW_HW_PRE_IRQ_STAT(x).B.RSVD0)
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field AXI_WRITE_ERROR[8] (RW)
 *
 * Indicates PRE encountered an AXI write error and processing has been
 * terminated.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR (8U) /*!< Bit position for HW_PRE_IRQ_STAT_AXI_WRITE_ERROR. */
#define BM_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR (0x00000100U) /*!< Bit mask for HW_PRE_IRQ_STAT_AXI_WRITE_ERROR. */
#define BS_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_AXI_WRITE_ERROR. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_AXI_WRITE_ERROR field. */
#define BR_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR(x) (HW_HW_PRE_IRQ_STAT(x).B.AXI_WRITE_ERROR)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_AXI_WRITE_ERROR. */
#define BF_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR) & BM_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR)

/*! @brief Set the AXI_WRITE_ERROR field to a new value. */
#define BW_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR) | BF_HW_PRE_IRQ_STAT_AXI_WRITE_ERROR(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field AXI_READ_ERROR[9] (RW)
 *
 * Indicates PRE encountered an AXI read error and processing has been
 * terminated.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_AXI_READ_ERROR (9U) /*!< Bit position for HW_PRE_IRQ_STAT_AXI_READ_ERROR. */
#define BM_HW_PRE_IRQ_STAT_AXI_READ_ERROR (0x00000200U) /*!< Bit mask for HW_PRE_IRQ_STAT_AXI_READ_ERROR. */
#define BS_HW_PRE_IRQ_STAT_AXI_READ_ERROR (1U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_AXI_READ_ERROR. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_AXI_READ_ERROR field. */
#define BR_HW_PRE_IRQ_STAT_AXI_READ_ERROR(x) (HW_HW_PRE_IRQ_STAT(x).B.AXI_READ_ERROR)

/*! @brief Format value for bitfield HW_PRE_IRQ_STAT_AXI_READ_ERROR. */
#define BF_HW_PRE_IRQ_STAT_AXI_READ_ERROR(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_IRQ_STAT_AXI_READ_ERROR) & BM_HW_PRE_IRQ_STAT_AXI_READ_ERROR)

/*! @brief Set the AXI_READ_ERROR field to a new value. */
#define BW_HW_PRE_IRQ_STAT_AXI_READ_ERROR(x, v) (HW_HW_PRE_IRQ_STAT_WR(x, (HW_HW_PRE_IRQ_STAT_RD(x) & ~BM_HW_PRE_IRQ_STAT_AXI_READ_ERROR) | BF_HW_PRE_IRQ_STAT_AXI_READ_ERROR(v)))
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field AXI_ERROR_ID[13:10] (RO)
 *
 * Indicates the AXI ID of the failing bus operation.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_AXI_ERROR_ID (10U) /*!< Bit position for HW_PRE_IRQ_STAT_AXI_ERROR_ID. */
#define BM_HW_PRE_IRQ_STAT_AXI_ERROR_ID (0x00003C00U) /*!< Bit mask for HW_PRE_IRQ_STAT_AXI_ERROR_ID. */
#define BS_HW_PRE_IRQ_STAT_AXI_ERROR_ID (4U) /*!< Bit field size in bits for HW_PRE_IRQ_STAT_AXI_ERROR_ID. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_AXI_ERROR_ID field. */
#define BR_HW_PRE_IRQ_STAT_AXI_ERROR_ID(x) (HW_HW_PRE_IRQ_STAT(x).B.AXI_ERROR_ID)
/*@}*/

/*!
 * @name Register HW_PRE_IRQ_STAT, field RSVD1[31:14] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_IRQ_STAT_RSVD1 (14U)     /*!< Bit position for HW_PRE_IRQ_STAT_RSVD1. */
#define BM_HW_PRE_IRQ_STAT_RSVD1 (0xFFFFC000U) /*!< Bit mask for HW_PRE_IRQ_STAT_RSVD1. */
#define BS_HW_PRE_IRQ_STAT_RSVD1 (18U)     /*!< Bit field size in bits for HW_PRE_IRQ_STAT_RSVD1. */

/*! @brief Read current value of the HW_PRE_IRQ_STAT_RSVD1 field. */
#define BR_HW_PRE_IRQ_STAT_RSVD1(x) (HW_HW_PRE_IRQ_STAT(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_CUR_BUF - PRE Base Address 0 Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_CUR_BUF - PRE Base Address 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Control register contains the control bits for the pre block.
 */
typedef union _hw_hw_pre_cur_buf
{
    uint32_t U;
    struct _hw_hw_pre_cur_buf_bitfields
    {
        uint32_t ADDR : 32;            /*!< [31:0]  */
    } B;
} hw_hw_pre_cur_buf_t;

/*!
 * @name Constants and macros for entire HW_PRE_CUR_BUF register
 */
/*@{*/
#define HW_HW_PRE_CUR_BUF_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_HW_PRE_CUR_BUF(x)     (*(__IO hw_hw_pre_cur_buf_t *) HW_HW_PRE_CUR_BUF_ADDR(x))
#define HW_HW_PRE_CUR_BUF_RD(x)  (HW_HW_PRE_CUR_BUF(x).U)
#define HW_HW_PRE_CUR_BUF_WR(x, v) (HW_HW_PRE_CUR_BUF(x).U = (v))
#define HW_HW_PRE_CUR_BUF_SET(x, v) (HW_HW_PRE_CUR_BUF_WR(x, HW_HW_PRE_CUR_BUF_RD(x) |  (v)))
#define HW_HW_PRE_CUR_BUF_CLR(x, v) (HW_HW_PRE_CUR_BUF_WR(x, HW_HW_PRE_CUR_BUF_RD(x) & ~(v)))
#define HW_HW_PRE_CUR_BUF_TOG(x, v) (HW_HW_PRE_CUR_BUF_WR(x, HW_HW_PRE_CUR_BUF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_CUR_BUF bitfields
 */

/*!
 * @name Register HW_PRE_CUR_BUF, field ADDR[31:0] (RW)
 *
 * This address points to the address of the current frame of data being sent
 * out via the PRE. When the current frame is done, the PRE block will assert the
 * store engine done interrupt for software to take action. The block will also
 * copy the HW_PRE_NEXT_BUF_ADDR into this bitfield so that the software can
 * program the next frame address into the HW_PRE_NEXT_BUF_ADDR bitfield.
 */
/*@{*/
#define BP_HW_PRE_CUR_BUF_ADDR (0U)        /*!< Bit position for HW_PRE_CUR_BUF_ADDR. */
#define BM_HW_PRE_CUR_BUF_ADDR (0xFFFFFFFFU) /*!< Bit mask for HW_PRE_CUR_BUF_ADDR. */
#define BS_HW_PRE_CUR_BUF_ADDR (32U)       /*!< Bit field size in bits for HW_PRE_CUR_BUF_ADDR. */

/*! @brief Read current value of the HW_PRE_CUR_BUF_ADDR field. */
#define BR_HW_PRE_CUR_BUF_ADDR(x) (HW_HW_PRE_CUR_BUF(x).U)

/*! @brief Format value for bitfield HW_PRE_CUR_BUF_ADDR. */
#define BF_HW_PRE_CUR_BUF_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_CUR_BUF_ADDR) & BM_HW_PRE_CUR_BUF_ADDR)

/*! @brief Set the ADDR field to a new value. */
#define BW_HW_PRE_CUR_BUF_ADDR(x, v) (HW_HW_PRE_CUR_BUF_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_NEXT_BUF - PRE Base Address 1 Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_NEXT_BUF - PRE Base Address 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Control register contains the control bits for the pre block.
 */
typedef union _hw_hw_pre_next_buf
{
    uint32_t U;
    struct _hw_hw_pre_next_buf_bitfields
    {
        uint32_t ADDR : 32;            /*!< [31:0]  */
    } B;
} hw_hw_pre_next_buf_t;

/*!
 * @name Constants and macros for entire HW_PRE_NEXT_BUF register
 */
/*@{*/
#define HW_HW_PRE_NEXT_BUF_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_HW_PRE_NEXT_BUF(x)    (*(__IO hw_hw_pre_next_buf_t *) HW_HW_PRE_NEXT_BUF_ADDR(x))
#define HW_HW_PRE_NEXT_BUF_RD(x) (HW_HW_PRE_NEXT_BUF(x).U)
#define HW_HW_PRE_NEXT_BUF_WR(x, v) (HW_HW_PRE_NEXT_BUF(x).U = (v))
#define HW_HW_PRE_NEXT_BUF_SET(x, v) (HW_HW_PRE_NEXT_BUF_WR(x, HW_HW_PRE_NEXT_BUF_RD(x) |  (v)))
#define HW_HW_PRE_NEXT_BUF_CLR(x, v) (HW_HW_PRE_NEXT_BUF_WR(x, HW_HW_PRE_NEXT_BUF_RD(x) & ~(v)))
#define HW_HW_PRE_NEXT_BUF_TOG(x, v) (HW_HW_PRE_NEXT_BUF_WR(x, HW_HW_PRE_NEXT_BUF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_NEXT_BUF bitfields
 */

/*!
 * @name Register HW_PRE_NEXT_BUF, field ADDR[31:0] (RW)
 *
 * This address points to the address of the next frame of data that will be
 * sent out via the PRE. It is up to the software to make sure that this register is
 * programmed before the end of the current frame, otherwise it might result in
 * old data going out the PRE.
 */
/*@{*/
#define BP_HW_PRE_NEXT_BUF_ADDR (0U)       /*!< Bit position for HW_PRE_NEXT_BUF_ADDR. */
#define BM_HW_PRE_NEXT_BUF_ADDR (0xFFFFFFFFU) /*!< Bit mask for HW_PRE_NEXT_BUF_ADDR. */
#define BS_HW_PRE_NEXT_BUF_ADDR (32U)      /*!< Bit field size in bits for HW_PRE_NEXT_BUF_ADDR. */

/*! @brief Read current value of the HW_PRE_NEXT_BUF_ADDR field. */
#define BR_HW_PRE_NEXT_BUF_ADDR(x) (HW_HW_PRE_NEXT_BUF(x).U)

/*! @brief Format value for bitfield HW_PRE_NEXT_BUF_ADDR. */
#define BF_HW_PRE_NEXT_BUF_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_NEXT_BUF_ADDR) & BM_HW_PRE_NEXT_BUF_ADDR)

/*! @brief Set the ADDR field to a new value. */
#define BW_HW_PRE_NEXT_BUF_ADDR(x, v) (HW_HW_PRE_NEXT_BUF_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_U_BUF_OFFSET - PRE U Buffer Offset Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_U_BUF_OFFSET - PRE U Buffer Offset Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre block.
 */
typedef union _hw_hw_pre_u_buf_offset
{
    uint32_t U;
    struct _hw_hw_pre_u_buf_offset_bitfields
    {
        uint32_t UBO : 25;             /*!< [24:0]  */
        uint32_t RSVD0 : 7;            /*!< [31:25]  */
    } B;
} hw_hw_pre_u_buf_offset_t;

/*!
 * @name Constants and macros for entire HW_PRE_U_BUF_OFFSET register
 */
/*@{*/
#define HW_HW_PRE_U_BUF_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_HW_PRE_U_BUF_OFFSET(x) (*(__IO hw_hw_pre_u_buf_offset_t *) HW_HW_PRE_U_BUF_OFFSET_ADDR(x))
#define HW_HW_PRE_U_BUF_OFFSET_RD(x) (HW_HW_PRE_U_BUF_OFFSET(x).U)
#define HW_HW_PRE_U_BUF_OFFSET_WR(x, v) (HW_HW_PRE_U_BUF_OFFSET(x).U = (v))
#define HW_HW_PRE_U_BUF_OFFSET_SET(x, v) (HW_HW_PRE_U_BUF_OFFSET_WR(x, HW_HW_PRE_U_BUF_OFFSET_RD(x) |  (v)))
#define HW_HW_PRE_U_BUF_OFFSET_CLR(x, v) (HW_HW_PRE_U_BUF_OFFSET_WR(x, HW_HW_PRE_U_BUF_OFFSET_RD(x) & ~(v)))
#define HW_HW_PRE_U_BUF_OFFSET_TOG(x, v) (HW_HW_PRE_U_BUF_OFFSET_WR(x, HW_HW_PRE_U_BUF_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_U_BUF_OFFSET bitfields
 */

/*!
 * @name Register HW_PRE_U_BUF_OFFSET, field UBO[24:0] (RW)
 *
 * Double buffer destination address offset for Y:U:V (U pointer) formats.
 */
/*@{*/
#define BP_HW_PRE_U_BUF_OFFSET_UBO (0U)    /*!< Bit position for HW_PRE_U_BUF_OFFSET_UBO. */
#define BM_HW_PRE_U_BUF_OFFSET_UBO (0x01FFFFFFU) /*!< Bit mask for HW_PRE_U_BUF_OFFSET_UBO. */
#define BS_HW_PRE_U_BUF_OFFSET_UBO (25U)   /*!< Bit field size in bits for HW_PRE_U_BUF_OFFSET_UBO. */

/*! @brief Read current value of the HW_PRE_U_BUF_OFFSET_UBO field. */
#define BR_HW_PRE_U_BUF_OFFSET_UBO(x) (HW_HW_PRE_U_BUF_OFFSET(x).B.UBO)

/*! @brief Format value for bitfield HW_PRE_U_BUF_OFFSET_UBO. */
#define BF_HW_PRE_U_BUF_OFFSET_UBO(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_U_BUF_OFFSET_UBO) & BM_HW_PRE_U_BUF_OFFSET_UBO)

/*! @brief Set the UBO field to a new value. */
#define BW_HW_PRE_U_BUF_OFFSET_UBO(x, v) (HW_HW_PRE_U_BUF_OFFSET_WR(x, (HW_HW_PRE_U_BUF_OFFSET_RD(x) & ~BM_HW_PRE_U_BUF_OFFSET_UBO) | BF_HW_PRE_U_BUF_OFFSET_UBO(v)))
/*@}*/

/*!
 * @name Register HW_PRE_U_BUF_OFFSET, field RSVD0[31:25] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_U_BUF_OFFSET_RSVD0 (25U) /*!< Bit position for HW_PRE_U_BUF_OFFSET_RSVD0. */
#define BM_HW_PRE_U_BUF_OFFSET_RSVD0 (0xFE000000U) /*!< Bit mask for HW_PRE_U_BUF_OFFSET_RSVD0. */
#define BS_HW_PRE_U_BUF_OFFSET_RSVD0 (7U)  /*!< Bit field size in bits for HW_PRE_U_BUF_OFFSET_RSVD0. */

/*! @brief Read current value of the HW_PRE_U_BUF_OFFSET_RSVD0 field. */
#define BR_HW_PRE_U_BUF_OFFSET_RSVD0(x) (HW_HW_PRE_U_BUF_OFFSET(x).B.RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_V_BUF_OFFSET - PRE V Buffer Offset Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_V_BUF_OFFSET - PRE V Buffer Offset Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre block.
 */
typedef union _hw_hw_pre_v_buf_offset
{
    uint32_t U;
    struct _hw_hw_pre_v_buf_offset_bitfields
    {
        uint32_t VBO : 25;             /*!< [24:0]  */
        uint32_t RSVD0 : 7;            /*!< [31:25]  */
    } B;
} hw_hw_pre_v_buf_offset_t;

/*!
 * @name Constants and macros for entire HW_PRE_V_BUF_OFFSET register
 */
/*@{*/
#define HW_HW_PRE_V_BUF_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_HW_PRE_V_BUF_OFFSET(x) (*(__IO hw_hw_pre_v_buf_offset_t *) HW_HW_PRE_V_BUF_OFFSET_ADDR(x))
#define HW_HW_PRE_V_BUF_OFFSET_RD(x) (HW_HW_PRE_V_BUF_OFFSET(x).U)
#define HW_HW_PRE_V_BUF_OFFSET_WR(x, v) (HW_HW_PRE_V_BUF_OFFSET(x).U = (v))
#define HW_HW_PRE_V_BUF_OFFSET_SET(x, v) (HW_HW_PRE_V_BUF_OFFSET_WR(x, HW_HW_PRE_V_BUF_OFFSET_RD(x) |  (v)))
#define HW_HW_PRE_V_BUF_OFFSET_CLR(x, v) (HW_HW_PRE_V_BUF_OFFSET_WR(x, HW_HW_PRE_V_BUF_OFFSET_RD(x) & ~(v)))
#define HW_HW_PRE_V_BUF_OFFSET_TOG(x, v) (HW_HW_PRE_V_BUF_OFFSET_WR(x, HW_HW_PRE_V_BUF_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_V_BUF_OFFSET bitfields
 */

/*!
 * @name Register HW_PRE_V_BUF_OFFSET, field VBO[24:0] (RW)
 *
 * Double buffer destination address offset for Y:U:V (V pointer) formats.
 */
/*@{*/
#define BP_HW_PRE_V_BUF_OFFSET_VBO (0U)    /*!< Bit position for HW_PRE_V_BUF_OFFSET_VBO. */
#define BM_HW_PRE_V_BUF_OFFSET_VBO (0x01FFFFFFU) /*!< Bit mask for HW_PRE_V_BUF_OFFSET_VBO. */
#define BS_HW_PRE_V_BUF_OFFSET_VBO (25U)   /*!< Bit field size in bits for HW_PRE_V_BUF_OFFSET_VBO. */

/*! @brief Read current value of the HW_PRE_V_BUF_OFFSET_VBO field. */
#define BR_HW_PRE_V_BUF_OFFSET_VBO(x) (HW_HW_PRE_V_BUF_OFFSET(x).B.VBO)

/*! @brief Format value for bitfield HW_PRE_V_BUF_OFFSET_VBO. */
#define BF_HW_PRE_V_BUF_OFFSET_VBO(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_V_BUF_OFFSET_VBO) & BM_HW_PRE_V_BUF_OFFSET_VBO)

/*! @brief Set the VBO field to a new value. */
#define BW_HW_PRE_V_BUF_OFFSET_VBO(x, v) (HW_HW_PRE_V_BUF_OFFSET_WR(x, (HW_HW_PRE_V_BUF_OFFSET_RD(x) & ~BM_HW_PRE_V_BUF_OFFSET_VBO) | BF_HW_PRE_V_BUF_OFFSET_VBO(v)))
/*@}*/

/*!
 * @name Register HW_PRE_V_BUF_OFFSET, field RSVD0[31:25] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_V_BUF_OFFSET_RSVD0 (25U) /*!< Bit position for HW_PRE_V_BUF_OFFSET_RSVD0. */
#define BM_HW_PRE_V_BUF_OFFSET_RSVD0 (0xFE000000U) /*!< Bit mask for HW_PRE_V_BUF_OFFSET_RSVD0. */
#define BS_HW_PRE_V_BUF_OFFSET_RSVD0 (7U)  /*!< Bit field size in bits for HW_PRE_V_BUF_OFFSET_RSVD0. */

/*! @brief Read current value of the HW_PRE_V_BUF_OFFSET_RSVD0 field. */
#define BR_HW_PRE_V_BUF_OFFSET_RSVD0(x) (HW_HW_PRE_V_BUF_OFFSET(x).B.RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_TPR_CTRL - PRE TPR Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_TPR_CTRL - PRE TPR Control Register (RW)
 *
 * Reset value: 0x00000400U
 *
 * The TPR_CTRL register contains controls for the TPR mode of operation.
 */
typedef union _hw_hw_pre_tpr_ctrl
{
    uint32_t U;
    struct _hw_hw_pre_tpr_ctrl_bitfields
    {
        uint32_t TILE_FORMAT : 8;      /*!< [7:0]  */
        uint32_t SBC_OT : 4;           /*!< [11:8]  */
        uint32_t RSVD : 20;            /*!< [31:12]  */
    } B;
} hw_hw_pre_tpr_ctrl_t;

/*!
 * @name Constants and macros for entire HW_PRE_TPR_CTRL register
 */
/*@{*/
#define HW_HW_PRE_TPR_CTRL_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_HW_PRE_TPR_CTRL(x)    (*(__IO hw_hw_pre_tpr_ctrl_t *) HW_HW_PRE_TPR_CTRL_ADDR(x))
#define HW_HW_PRE_TPR_CTRL_RD(x) (HW_HW_PRE_TPR_CTRL(x).U)
#define HW_HW_PRE_TPR_CTRL_WR(x, v) (HW_HW_PRE_TPR_CTRL(x).U = (v))
#define HW_HW_PRE_TPR_CTRL_SET(x, v) (HW_HW_PRE_TPR_CTRL_WR(x, HW_HW_PRE_TPR_CTRL_RD(x) |  (v)))
#define HW_HW_PRE_TPR_CTRL_CLR(x, v) (HW_HW_PRE_TPR_CTRL_WR(x, HW_HW_PRE_TPR_CTRL_RD(x) & ~(v)))
#define HW_HW_PRE_TPR_CTRL_TOG(x, v) (HW_HW_PRE_TPR_CTRL_WR(x, HW_HW_PRE_TPR_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_TPR_CTRL bitfields
 */

/*!
 * @name Register HW_PRE_TPR_CTRL, field TILE_FORMAT[7:0] (RW)
 *
 * Select tile format to prefetch and resolve
 */
/*@{*/
#define BP_HW_PRE_TPR_CTRL_TILE_FORMAT (0U) /*!< Bit position for HW_PRE_TPR_CTRL_TILE_FORMAT. */
#define BM_HW_PRE_TPR_CTRL_TILE_FORMAT (0x000000FFU) /*!< Bit mask for HW_PRE_TPR_CTRL_TILE_FORMAT. */
#define BS_HW_PRE_TPR_CTRL_TILE_FORMAT (8U) /*!< Bit field size in bits for HW_PRE_TPR_CTRL_TILE_FORMAT. */

/*! @brief Read current value of the HW_PRE_TPR_CTRL_TILE_FORMAT field. */
#define BR_HW_PRE_TPR_CTRL_TILE_FORMAT(x) (HW_HW_PRE_TPR_CTRL(x).B.TILE_FORMAT)

/*! @brief Format value for bitfield HW_PRE_TPR_CTRL_TILE_FORMAT. */
#define BF_HW_PRE_TPR_CTRL_TILE_FORMAT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_TPR_CTRL_TILE_FORMAT) & BM_HW_PRE_TPR_CTRL_TILE_FORMAT)

/*! @brief Set the TILE_FORMAT field to a new value. */
#define BW_HW_PRE_TPR_CTRL_TILE_FORMAT(x, v) (HW_HW_PRE_TPR_CTRL_WR(x, (HW_HW_PRE_TPR_CTRL_RD(x) & ~BM_HW_PRE_TPR_CTRL_TILE_FORMAT) | BF_HW_PRE_TPR_CTRL_TILE_FORMAT(v)))
/*@}*/

/*!
 * @name Register HW_PRE_TPR_CTRL, field SBC_OT[11:8] (RW)
 *
 * Max SBC_BUSCMD FIFO outstanding transactions.
 */
/*@{*/
#define BP_HW_PRE_TPR_CTRL_SBC_OT (8U)     /*!< Bit position for HW_PRE_TPR_CTRL_SBC_OT. */
#define BM_HW_PRE_TPR_CTRL_SBC_OT (0x00000F00U) /*!< Bit mask for HW_PRE_TPR_CTRL_SBC_OT. */
#define BS_HW_PRE_TPR_CTRL_SBC_OT (4U)     /*!< Bit field size in bits for HW_PRE_TPR_CTRL_SBC_OT. */

/*! @brief Read current value of the HW_PRE_TPR_CTRL_SBC_OT field. */
#define BR_HW_PRE_TPR_CTRL_SBC_OT(x) (HW_HW_PRE_TPR_CTRL(x).B.SBC_OT)

/*! @brief Format value for bitfield HW_PRE_TPR_CTRL_SBC_OT. */
#define BF_HW_PRE_TPR_CTRL_SBC_OT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_TPR_CTRL_SBC_OT) & BM_HW_PRE_TPR_CTRL_SBC_OT)

/*! @brief Set the SBC_OT field to a new value. */
#define BW_HW_PRE_TPR_CTRL_SBC_OT(x, v) (HW_HW_PRE_TPR_CTRL_WR(x, (HW_HW_PRE_TPR_CTRL_RD(x) & ~BM_HW_PRE_TPR_CTRL_SBC_OT) | BF_HW_PRE_TPR_CTRL_SBC_OT(v)))
/*@}*/

/*!
 * @name Register HW_PRE_TPR_CTRL, field RSVD[31:12] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_TPR_CTRL_RSVD (12U)      /*!< Bit position for HW_PRE_TPR_CTRL_RSVD. */
#define BM_HW_PRE_TPR_CTRL_RSVD (0xFFFFF000U) /*!< Bit mask for HW_PRE_TPR_CTRL_RSVD. */
#define BS_HW_PRE_TPR_CTRL_RSVD (20U)      /*!< Bit field size in bits for HW_PRE_TPR_CTRL_RSVD. */

/*! @brief Read current value of the HW_PRE_TPR_CTRL_RSVD field. */
#define BR_HW_PRE_TPR_CTRL_RSVD(x) (HW_HW_PRE_TPR_CTRL(x).B.RSVD)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_CTRL - PRE Prefetch Engine Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_CTRL - PRE Prefetch Engine Control Register (RW)
 *
 * Reset value: 0x00000806U
 *
 * This register defines the control bits for the pre prefetch_engine sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_ctrl
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_ctrl_bitfields
    {
        uint32_t PREFETCH_EN : 1;      /*!< [0] Prefetch Enable */
        uint32_t RD_NUM_BYTES : 3;     /*!< [3:1]  */
        uint32_t INPUT_ACTIVE_BPP : 2; /*!< [5:4]  */
        uint32_t RSVD0 : 2;            /*!< [7:6]  */
        uint32_t INPUT_PIXEL_FORMAT : 3; /*!< [10:8]  */
        uint32_t SHIFT_BYPASS : 1;     /*!< [11]  */
        uint32_t FIELD_INVERSE : 1;    /*!< [12]  */
        uint32_t RSVD1 : 1;            /*!< [13]  */
        uint32_t PARTIAL_UV_SWAP : 1;  /*!< [14]  */
        uint32_t TPR_COOR_OFFSET_EN : 1; /*!< [15]  */
        uint32_t RSVD2 : 16;           /*!< [31:16]  */
    } B;
} hw_hw_pre_prefetch_engine_ctrl_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_CTRL register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_HW_PRE_PREFETCH_ENGINE_CTRL(x) (*(__IO hw_hw_pre_prefetch_engine_ctrl_t *) HW_HW_PRE_PREFETCH_ENGINE_CTRL_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_CTRL_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_CTRL bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field PREFETCH_EN[0] (RW)
 *
 * Values:
 * - 0 - 0x0 Prefetch function is disable.
 * - 1 - 0x1 Prefetch function is enable.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN (0x00000001U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.PREFETCH_EN)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN)

/*! @brief Set the PREFETCH_EN field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_PREFETCH_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field RD_NUM_BYTES[3:1] (RW)
 *
 * Bytes in a read burst, it is only for scan mode.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES (1U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES (0x0000000EU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.RD_NUM_BYTES)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES)

/*! @brief Set the RD_NUM_BYTES field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_RD_NUM_BYTES(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field INPUT_ACTIVE_BPP[5:4] (RW)
 *
 * Input bits per pixel. When set BLOCK_EN, the value can only be 0, 1, or 2.
 *
 * Values:
 * - 0 - 0x0 8 bits
 * - 1 - 0x1 16 bits
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP (4U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP (0x00000030U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP (2U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.INPUT_ACTIVE_BPP)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP)

/*! @brief Set the INPUT_ACTIVE_BPP field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_ACTIVE_BPP(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field RSVD0[7:6] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0 (6U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0 (0x000000C0U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0 (2U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD0(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.RSVD0)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field INPUT_PIXEL_FORMAT[10:8] (RW)
 *
 * Values:
 * - 0 - 0x0 generic data
 * - 1 - 0x1 non-interleaved YUV444
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT (8U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT (0x00000700U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.INPUT_PIXEL_FORMAT)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT)

/*! @brief Set the INPUT_PIXEL_FORMAT field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_INPUT_PIXEL_FORMAT(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field SHIFT_BYPASS[11] (RW)
 *
 * Values:
 * - 0 - 0x0 prefetch engine do shift function
 * - 1 - 0x1 prefetch engine bypass shift function
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS (11U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS (0x00000800U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.SHIFT_BYPASS)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS)

/*! @brief Set the SHIFT_BYPASS field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_SHIFT_BYPASS(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field FIELD_INVERSE[12] (RW)
 *
 * Values:
 * - 0 - 0x0 INTERLACED_FIELD will not be inverted.
 * - 1 - 0x1 INTERLACED_FIELD will be inverted.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE (12U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE (0x00001000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.FIELD_INVERSE)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE)

/*! @brief Set the FIELD_INVERSE field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_FIELD_INVERSE(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field RSVD1[13] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1 (13U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1 (0x00002000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1 (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD1(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field PARTIAL_UV_SWAP[14] (RW)
 *
 * When input format is partial YUV422 or YUV420, this bit indicate the UV bytes
 * should be swapped when fetch the partial uv buffer.
 *
 * Values:
 * - 0 - 0x0 swap disable
 * - 1 - 0x1 swap enable
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP (14U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP (0x00004000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.PARTIAL_UV_SWAP)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP)

/*! @brief Set the PARTIAL_UV_SWAP field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_PARTIAL_UV_SWAP(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field TPR_COOR_OFFSET_EN[15] (RW)
 *
 * This bit indicate the OUPUT_SIZE_ULC_X and the OUPUT_SIZE_ULC_Y will be added
 * to tpr coord, when this bit set to 1.
 *
 * Values:
 * - 0 - 0x0 add disable
 * - 1 - 0x1 add enable
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN (15U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN (0x00008000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.TPR_COOR_OFFSET_EN)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN. */
#define BF_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN) & BM_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN)

/*! @brief Set the TPR_COOR_OFFSET_EN field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN(x, v) (HW_HW_PRE_PREFETCH_ENGINE_CTRL_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN) | BF_HW_PRE_PREFETCH_ENGINE_CTRL_TPR_COOR_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_CTRL, field RSVD2[31:16] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2 (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2. */
#define BM_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2 (0xFFFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2. */
#define BS_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2 (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_CTRL_RSVD2(x) (HW_HW_PRE_PREFETCH_ENGINE_CTRL(x).B.RSVD2)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_STATUS - PRE Prefetch Engine Status Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_STATUS - PRE Prefetch Engine Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the status bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_status
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_status_bitfields
    {
        uint32_t PREFETCH_BLOCK_X : 16; /*!< [15:0]  */
        uint32_t PREFETCH_BLOCK_Y : 14; /*!< [29:16]  */
        uint32_t PREFETCH_MAIN_FIFO_FULL : 1; /*!< [30]  */
        uint32_t PREFETCH_FIELD : 1;   /*!< [31]  */
    } B;
} hw_hw_pre_prefetch_engine_status_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_STATUS register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_STATUS_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_HW_PRE_PREFETCH_ENGINE_STATUS(x) (*(__I hw_hw_pre_prefetch_engine_status_t *) HW_HW_PRE_PREFETCH_ENGINE_STATUS_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_STATUS_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_STATUS bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_STATUS, field PREFETCH_BLOCK_X[15:0] (RO)
 *
 * When in scan mode, this field indicates the current X coordinate of the
 * frame. In block mode, it indicates the X coordinate of the block currently being
 * rendered.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X. */
#define BM_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X (0x0000FFFFU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X. */
#define BS_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X field. */
#define BR_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_X(x) (HW_HW_PRE_PREFETCH_ENGINE_STATUS(x).B.PREFETCH_BLOCK_X)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_STATUS, field PREFETCH_BLOCK_Y[29:16] (RO)
 *
 * When in scan mode, this field indicates the current Y coordinate of the
 * frame. In block mode, it indicates the Y coordinate of the block currently being
 * rendered.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y. */
#define BM_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y (0x3FFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y. */
#define BS_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y (14U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y field. */
#define BR_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_BLOCK_Y(x) (HW_HW_PRE_PREFETCH_ENGINE_STATUS(x).B.PREFETCH_BLOCK_Y)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_STATUS, field PREFETCH_MAIN_FIFO_FULL[30] (RO)
 *
 * Prefetch main FIFO full
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL (30U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL. */
#define BM_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL (0x40000000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL. */
#define BS_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL field. */
#define BR_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_MAIN_FIFO_FULL(x) (HW_HW_PRE_PREFETCH_ENGINE_STATUS(x).B.PREFETCH_MAIN_FIFO_FULL)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_STATUS, field PREFETCH_FIELD[31] (RO)
 *
 * Prefetch current field
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD (31U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD. */
#define BM_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD (0x80000000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD. */
#define BS_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD (1U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD field. */
#define BR_HW_PRE_PREFETCH_ENGINE_STATUS_PREFETCH_FIELD(x) (HW_HW_PRE_PREFETCH_ENGINE_STATUS(x).B.PREFETCH_FIELD)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE - PRE Prefetch Engine Input Size Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE - PRE Prefetch Engine Input Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_input_size
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_input_size_bitfields
    {
        uint32_t INPUT_WIDTH : 16;     /*!< [15:0]  */
        uint32_t INPUT_HEIGHT : 16;    /*!< [31:16]  */
    } B;
} hw_hw_pre_prefetch_engine_input_size_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_INPUT_SIZE register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_ADDR(x) ((uintptr_t)(x) + 0xA0U)

#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE(x) (*(__IO hw_hw_pre_prefetch_engine_input_size_t *) HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_INPUT_SIZE bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_INPUT_SIZE, field INPUT_WIDTH[15:0] (RW)
 *
 * Actual input frame width, it must be even number when INPUT_PIXEL_FORMAT is
 * YUV422 or YUV420.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH. */
#define BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH (0x0000FFFFU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH. */
#define BS_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH field. */
#define BR_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH(x) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE(x).B.INPUT_WIDTH)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH. */
#define BF_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH) & BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH)

/*! @brief Set the INPUT_WIDTH field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH) | BF_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_WIDTH(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_INPUT_SIZE, field INPUT_HEIGHT[31:16] (RW)
 *
 * Actual input frame height
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT. */
#define BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT (0xFFFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT. */
#define BS_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT field. */
#define BR_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT(x) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE(x).B.INPUT_HEIGHT)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT. */
#define BF_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT) & BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT)

/*! @brief Set the INPUT_HEIGHT field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT) | BF_HW_PRE_PREFETCH_ENGINE_INPUT_SIZE_INPUT_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC - PRE Prefetch Engine Output Size Up-Left Coordinate
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC - PRE Prefetch Engine Output Size Up-Left Coordinate (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_output_size_ulc
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_output_size_ulc_bitfields
    {
        uint32_t OUTPUT_SIZE_ULC_X : 16; /*!< [15:0]  */
        uint32_t OUTPUT_SIZE_ULC_Y : 16; /*!< [31:16]  */
    } B;
} hw_hw_pre_prefetch_engine_output_size_ulc_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_ADDR(x) ((uintptr_t)(x) + 0xB0U)

#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC(x) (*(__IO hw_hw_pre_prefetch_engine_output_size_ulc_t *) HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC, field OUTPUT_SIZE_ULC_X[15:0] (RW)
 *
 * This field indicates the upper left X-coordinate(in pixels) of the active
 * surface.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X. */
#define BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X (0x0000FFFFU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X. */
#define BS_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X field. */
#define BR_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X(x) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC(x).B.OUTPUT_SIZE_ULC_X)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X. */
#define BF_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X) & BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X)

/*! @brief Set the OUTPUT_SIZE_ULC_X field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X) | BF_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_X(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC, field OUTPUT_SIZE_ULC_Y[31:16] (RW)
 *
 * This field indicates the upper left Y-coordinate(in pixels) of the active
 * surface.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y. */
#define BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y (0xFFFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y. */
#define BS_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y field. */
#define BR_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y(x) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC(x).B.OUTPUT_SIZE_ULC_Y)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y. */
#define BF_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y) & BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y)

/*! @brief Set the OUTPUT_SIZE_ULC_Y field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y(x, v) (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y) | BF_HW_PRE_PREFETCH_ENGINE_OUTPUT_SIZE_ULC_OUTPUT_SIZE_ULC_Y(v)))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_PITCH - PRE Prefetch Engine Pitch Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_PITCH - PRE Prefetch Engine Pitch Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_pitch
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_pitch_bitfields
    {
        uint32_t INPUT_Y_PITCH : 16;   /*!< [15:0]  */
        uint32_t INPUT_UV_PITCH : 16;  /*!< [31:16]  */
    } B;
} hw_hw_pre_prefetch_engine_pitch_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_PITCH register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_ADDR(x) ((uintptr_t)(x) + 0xD0U)

#define HW_HW_PRE_PREFETCH_ENGINE_PITCH(x) (*(__IO hw_hw_pre_prefetch_engine_pitch_t *) HW_HW_PRE_PREFETCH_ENGINE_PITCH_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_PITCH(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_PITCH_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_PITCH bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_PITCH, field INPUT_Y_PITCH[15:0] (RW)
 *
 * Indicates the number of bytes in memory between two vertically adjacent
 * pixels for generic data or Y component if YUV format.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH. */
#define BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH (0x0000FFFFU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH. */
#define BS_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH field. */
#define BR_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH(x) (HW_HW_PRE_PREFETCH_ENGINE_PITCH(x).B.INPUT_Y_PITCH)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH. */
#define BF_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH) & BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH)

/*! @brief Set the INPUT_Y_PITCH field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH) | BF_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_Y_PITCH(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_PITCH, field INPUT_UV_PITCH[31:16] (RW)
 *
 * Indicates the number of bytes in memory between two vertically adjacent
 * pixels for U/V component if YUV format.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH. */
#define BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH (0xFFFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH. */
#define BS_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH field. */
#define BR_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH(x) (HW_HW_PRE_PREFETCH_ENGINE_PITCH(x).B.INPUT_UV_PITCH)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH. */
#define BF_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH) & BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH)

/*! @brief Set the INPUT_UV_PITCH field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH(x, v) (HW_HW_PRE_PREFETCH_ENGINE_PITCH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_PITCH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH) | BF_HW_PRE_PREFETCH_ENGINE_PITCH_INPUT_UV_PITCH(v)))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET - PRE Prefetch Engine Shift Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET - PRE Prefetch Engine Shift Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_shift_offset
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_shift_offset_bitfields
    {
        uint32_t OFFSET0 : 5;          /*!< [4:0]  */
        uint32_t RSVD3 : 3;            /*!< [7:5]  */
        uint32_t OFFSET1 : 5;          /*!< [12:8]  */
        uint32_t RSVD2 : 3;            /*!< [15:13]  */
        uint32_t OFFSET2 : 5;          /*!< [20:16]  */
        uint32_t RSVD1 : 3;            /*!< [23:21]  */
        uint32_t OFFSET3 : 5;          /*!< [28:24]  */
        uint32_t RSVD0 : 3;            /*!< [31:29]  */
    } B;
} hw_hw_pre_prefetch_engine_shift_offset_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_ADDR(x) ((uintptr_t)(x) + 0xE0U)

#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x) (*(__IO hw_hw_pre_prefetch_engine_shift_offset_t *) HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field OFFSET0[4:0] (RW)
 *
 * Shift Offset for component 0
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0 (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0 (0x0000001FU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0 (5U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.OFFSET0)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0)

/*! @brief Set the OFFSET0 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET0(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field RSVD3[7:5] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3 (5U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3 (0x000000E0U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3 (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD3(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.RSVD3)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field OFFSET1[12:8] (RW)
 *
 * Shift Offset for component 1
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1 (8U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1 (0x00001F00U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1 (5U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.OFFSET1)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1)

/*! @brief Set the OFFSET1 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET1(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field RSVD2[15:13] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2 (13U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2 (0x0000E000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2 (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD2(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.RSVD2)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field OFFSET2[20:16] (RW)
 *
 * Shift Offset for component 2
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2 (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2 (0x001F0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2 (5U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.OFFSET2)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2)

/*! @brief Set the OFFSET2 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET2(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field RSVD1[23:21] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1 (21U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1 (0x00E00000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1 (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD1(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.RSVD1)
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field OFFSET3[28:24] (RW)
 *
 * Shift Offset for component 3
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3 (24U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3 (0x1F000000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3 (5U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET(x).B.OFFSET3)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3)

/*! @brief Set the OFFSET3 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_OFFSET3(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET, field RSVD0[31:29] (WO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0 (29U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0 (0xE0000000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0 (3U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0. */

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_OFFSET_RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH - PRE Prefetch Engine Shift Parameter Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH - PRE Prefetch Engine Shift Parameter Register (RW)
 *
 * Reset value: 0x00008888U
 *
 * This register defines the control bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_shift_width
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_shift_width_bitfields
    {
        uint32_t WIDTH0 : 4;           /*!< [3:0]  */
        uint32_t WIDTH1 : 4;           /*!< [7:4]  */
        uint32_t WIDTH2 : 4;           /*!< [11:8]  */
        uint32_t WIDTH3 : 4;           /*!< [15:12]  */
        uint32_t RSVD0 : 16;           /*!< [31:16]  */
    } B;
} hw_hw_pre_prefetch_engine_shift_width_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_ADDR(x) ((uintptr_t)(x) + 0xF0U)

#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x) (*(__IO hw_hw_pre_prefetch_engine_shift_width_t *) HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH, field WIDTH0[3:0] (RW)
 *
 * Shift Width for component 0.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0 (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0 (0x0000000FU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0 (4U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).B.WIDTH0)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0)

/*! @brief Set the WIDTH0 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH0(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH, field WIDTH1[7:4] (RW)
 *
 * Shift Width for component 1.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1 (4U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1 (0x000000F0U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1 (4U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).B.WIDTH1)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1)

/*! @brief Set the WIDTH1 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH1(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH, field WIDTH2[11:8] (RW)
 *
 * Shift Width for component 2.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2 (8U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2 (0x00000F00U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2 (4U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).B.WIDTH2)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2)

/*! @brief Set the WIDTH2 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH2(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH, field WIDTH3[15:12] (RW)
 *
 * Shift Width for component 3.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3 (12U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3 (0x0000F000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3 (4U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).B.WIDTH3)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3. */
#define BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3) & BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3)

/*! @brief Set the WIDTH3 field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3(x, v) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WR(x, (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RD(x) & ~BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3) | BF_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_WIDTH3(v)))
/*@}*/

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH, field RSVD0[31:16] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0 (16U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0. */
#define BM_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0 (0xFFFF0000U) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0. */
#define BS_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0 (16U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0 field. */
#define BR_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH_RSVD0(x) (HW_HW_PRE_PREFETCH_ENGINE_SHIFT_WIDTH(x).B.RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET - PRE Prefetch Engine Interlace Offset
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET - PRE Prefetch Engine Interlace Offset (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_prefetch_engine_interlace_offset
{
    uint32_t U;
    struct _hw_hw_pre_prefetch_engine_interlace_offset_bitfields
    {
        uint32_t INTERLACE_OFFSET : 32; /*!< [31:0]  */
    } B;
} hw_hw_pre_prefetch_engine_interlace_offset_t;

/*!
 * @name Constants and macros for entire HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET register
 */
/*@{*/
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x100U)

#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET(x) (*(__IO hw_hw_pre_prefetch_engine_interlace_offset_t *) HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_ADDR(x))
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_RD(x) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET(x).U)
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_WR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET(x).U = (v))
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_SET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_RD(x) |  (v)))
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_CLR(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_RD(x) & ~(v)))
#define HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_TOG(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_WR(x, HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET bitfields
 */

/*!
 * @name Register HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET, field INTERLACE_OFFSET[31:0] (RW)
 *
 * In Scan mode and interlace enable, this offset indicate the second field
 * start address relevant to base address. This value is signed.
 */
/*@{*/
#define BP_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET (0U) /*!< Bit position for HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET. */
#define BM_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET (0xFFFFFFFFU) /*!< Bit mask for HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET. */
#define BS_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET (32U) /*!< Bit field size in bits for HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET. */

/*! @brief Read current value of the HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET field. */
#define BR_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET(x) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET(x).U)

/*! @brief Format value for bitfield HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET. */
#define BF_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET) & BM_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET)

/*! @brief Set the INTERLACE_OFFSET field to a new value. */
#define BW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_INTERLACE_OFFSET(x, v) (HW_HW_PRE_PREFETCH_ENGINE_INTERLACE_OFFSET_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_STORE_ENGINE_CTRL - PRE Store Engine Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_STORE_ENGINE_CTRL - PRE Store Engine Control Register (RW)
 *
 * Reset value: 0x00000006U
 *
 * This register defines the control bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_store_engine_ctrl
{
    uint32_t U;
    struct _hw_hw_pre_store_engine_ctrl_bitfields
    {
        uint32_t STORE_EN : 1;         /*!< [0] Store Enable */
        uint32_t WR_NUM_BYTES : 3;     /*!< [3:1]  */
        uint32_t OUTPUT_ACTIVE_BPP : 2; /*!< [5:4]  */
        uint32_t RSVD0 : 26;           /*!< [31:6]  */
    } B;
} hw_hw_pre_store_engine_ctrl_t;

/*!
 * @name Constants and macros for entire HW_PRE_STORE_ENGINE_CTRL register
 */
/*@{*/
#define HW_HW_PRE_STORE_ENGINE_CTRL_ADDR(x) ((uintptr_t)(x) + 0x110U)

#define HW_HW_PRE_STORE_ENGINE_CTRL(x) (*(__IO hw_hw_pre_store_engine_ctrl_t *) HW_HW_PRE_STORE_ENGINE_CTRL_ADDR(x))
#define HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) (HW_HW_PRE_STORE_ENGINE_CTRL(x).U)
#define HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL(x).U = (v))
#define HW_HW_PRE_STORE_ENGINE_CTRL_SET(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) |  (v)))
#define HW_HW_PRE_STORE_ENGINE_CTRL_CLR(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) & ~(v)))
#define HW_HW_PRE_STORE_ENGINE_CTRL_TOG(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_STORE_ENGINE_CTRL bitfields
 */

/*!
 * @name Register HW_PRE_STORE_ENGINE_CTRL, field STORE_EN[0] (RW)
 *
 * Values:
 * - 0 - 0x0 Store function is disable.
 * - 1 - 0x1 Store function is enable.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_CTRL_STORE_EN (0U) /*!< Bit position for HW_PRE_STORE_ENGINE_CTRL_STORE_EN. */
#define BM_HW_PRE_STORE_ENGINE_CTRL_STORE_EN (0x00000001U) /*!< Bit mask for HW_PRE_STORE_ENGINE_CTRL_STORE_EN. */
#define BS_HW_PRE_STORE_ENGINE_CTRL_STORE_EN (1U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_CTRL_STORE_EN. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_CTRL_STORE_EN field. */
#define BR_HW_PRE_STORE_ENGINE_CTRL_STORE_EN(x) (HW_HW_PRE_STORE_ENGINE_CTRL(x).B.STORE_EN)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_CTRL_STORE_EN. */
#define BF_HW_PRE_STORE_ENGINE_CTRL_STORE_EN(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_CTRL_STORE_EN) & BM_HW_PRE_STORE_ENGINE_CTRL_STORE_EN)

/*! @brief Set the STORE_EN field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_CTRL_STORE_EN(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, (HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_STORE_ENGINE_CTRL_STORE_EN) | BF_HW_PRE_STORE_ENGINE_CTRL_STORE_EN(v)))
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_CTRL, field WR_NUM_BYTES[3:1] (RW)
 *
 * Bytes in a write burst, it is only for scan mode.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES (1U) /*!< Bit position for HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES. */
#define BM_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES (0x0000000EU) /*!< Bit mask for HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES. */
#define BS_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES (3U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES field. */
#define BR_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES(x) (HW_HW_PRE_STORE_ENGINE_CTRL(x).B.WR_NUM_BYTES)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES. */
#define BF_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES) & BM_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES)

/*! @brief Set the WR_NUM_BYTES field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, (HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES) | BF_HW_PRE_STORE_ENGINE_CTRL_WR_NUM_BYTES(v)))
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_CTRL, field OUTPUT_ACTIVE_BPP[5:4] (RW)
 *
 * Output active bits per pixel. When setting block_en, the value can only be 0,
 * 1, or 2.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP (4U) /*!< Bit position for HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP. */
#define BM_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP (0x00000030U) /*!< Bit mask for HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP. */
#define BS_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP (2U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP field. */
#define BR_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP(x) (HW_HW_PRE_STORE_ENGINE_CTRL(x).B.OUTPUT_ACTIVE_BPP)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP. */
#define BF_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP) & BM_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP)

/*! @brief Set the OUTPUT_ACTIVE_BPP field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP(x, v) (HW_HW_PRE_STORE_ENGINE_CTRL_WR(x, (HW_HW_PRE_STORE_ENGINE_CTRL_RD(x) & ~BM_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP) | BF_HW_PRE_STORE_ENGINE_CTRL_OUTPUT_ACTIVE_BPP(v)))
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_CTRL, field RSVD0[31:6] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_CTRL_RSVD0 (6U) /*!< Bit position for HW_PRE_STORE_ENGINE_CTRL_RSVD0. */
#define BM_HW_PRE_STORE_ENGINE_CTRL_RSVD0 (0xFFFFFFC0U) /*!< Bit mask for HW_PRE_STORE_ENGINE_CTRL_RSVD0. */
#define BS_HW_PRE_STORE_ENGINE_CTRL_RSVD0 (26U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_CTRL_RSVD0. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_CTRL_RSVD0 field. */
#define BR_HW_PRE_STORE_ENGINE_CTRL_RSVD0(x) (HW_HW_PRE_STORE_ENGINE_CTRL(x).B.RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_STORE_ENGINE_STATUS - PRE Store Engine Status Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_STORE_ENGINE_STATUS - PRE Store Engine Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the status bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_store_engine_status
{
    uint32_t U;
    struct _hw_hw_pre_store_engine_status_bitfields
    {
        uint32_t STORE_BLOCK_X : 16;   /*!< [15:0]  */
        uint32_t STORE_BLOCK_Y : 14;   /*!< [29:16]  */
        uint32_t STORE_FIFO_FULL : 1;  /*!< [30]  */
        uint32_t STORE_FIELD : 1;      /*!< [31]  */
    } B;
} hw_hw_pre_store_engine_status_t;

/*!
 * @name Constants and macros for entire HW_PRE_STORE_ENGINE_STATUS register
 */
/*@{*/
#define HW_HW_PRE_STORE_ENGINE_STATUS_ADDR(x) ((uintptr_t)(x) + 0x120U)

#define HW_HW_PRE_STORE_ENGINE_STATUS(x) (*(__I hw_hw_pre_store_engine_status_t *) HW_HW_PRE_STORE_ENGINE_STATUS_ADDR(x))
#define HW_HW_PRE_STORE_ENGINE_STATUS_RD(x) (HW_HW_PRE_STORE_ENGINE_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual HW_PRE_STORE_ENGINE_STATUS bitfields
 */

/*!
 * @name Register HW_PRE_STORE_ENGINE_STATUS, field STORE_BLOCK_X[15:0] (RO)
 *
 * When in scan mode, this field indicates the current X coordinate of the
 * frame. In block mode, it indicates the X coordinate of the block currently being
 * rendered.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X (0U) /*!< Bit position for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X. */
#define BM_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X (0x0000FFFFU) /*!< Bit mask for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X. */
#define BS_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X (16U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X field. */
#define BR_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_X(x) (HW_HW_PRE_STORE_ENGINE_STATUS(x).B.STORE_BLOCK_X)
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_STATUS, field STORE_BLOCK_Y[29:16] (RO)
 *
 * When in scan mode, this field indicates the current Y coordinate of the
 * frame. In block mode, it indicates the Y coordinate of the block currently being
 * rendered.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y (16U) /*!< Bit position for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y. */
#define BM_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y (0x3FFF0000U) /*!< Bit mask for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y. */
#define BS_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y (14U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y field. */
#define BR_HW_PRE_STORE_ENGINE_STATUS_STORE_BLOCK_Y(x) (HW_HW_PRE_STORE_ENGINE_STATUS(x).B.STORE_BLOCK_Y)
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_STATUS, field STORE_FIFO_FULL[30] (RO)
 *
 * Store FIFO full
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL (30U) /*!< Bit position for HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL. */
#define BM_HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL (0x40000000U) /*!< Bit mask for HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL. */
#define BS_HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL (1U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL field. */
#define BR_HW_PRE_STORE_ENGINE_STATUS_STORE_FIFO_FULL(x) (HW_HW_PRE_STORE_ENGINE_STATUS(x).B.STORE_FIFO_FULL)
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_STATUS, field STORE_FIELD[31] (RO)
 *
 * Store current field
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD (31U) /*!< Bit position for HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD. */
#define BM_HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD (0x80000000U) /*!< Bit mask for HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD. */
#define BS_HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD (1U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD field. */
#define BR_HW_PRE_STORE_ENGINE_STATUS_STORE_FIELD(x) (HW_HW_PRE_STORE_ENGINE_STATUS(x).B.STORE_FIELD)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_STORE_ENGINE_SIZE - PRE Store Engine Source Size Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_STORE_ENGINE_SIZE - PRE Store Engine Source Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre PREFETCH_ENGINE sub-block.
 */
typedef union _hw_hw_pre_store_engine_size
{
    uint32_t U;
    struct _hw_hw_pre_store_engine_size_bitfields
    {
        uint32_t INPUT_TOTAL_WIDTH : 16; /*!< [15:0]  */
        uint32_t INPUT_TOTAL_HEIGHT : 16; /*!< [31:16]  */
    } B;
} hw_hw_pre_store_engine_size_t;

/*!
 * @name Constants and macros for entire HW_PRE_STORE_ENGINE_SIZE register
 */
/*@{*/
#define HW_HW_PRE_STORE_ENGINE_SIZE_ADDR(x) ((uintptr_t)(x) + 0x130U)

#define HW_HW_PRE_STORE_ENGINE_SIZE(x) (*(__IO hw_hw_pre_store_engine_size_t *) HW_HW_PRE_STORE_ENGINE_SIZE_ADDR(x))
#define HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) (HW_HW_PRE_STORE_ENGINE_SIZE(x).U)
#define HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE(x).U = (v))
#define HW_HW_PRE_STORE_ENGINE_SIZE_SET(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) |  (v)))
#define HW_HW_PRE_STORE_ENGINE_SIZE_CLR(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) & ~(v)))
#define HW_HW_PRE_STORE_ENGINE_SIZE_TOG(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_STORE_ENGINE_SIZE bitfields
 */

/*!
 * @name Register HW_PRE_STORE_ENGINE_SIZE, field INPUT_TOTAL_WIDTH[15:0] (RW)
 *
 * Actual total width
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH (0U) /*!< Bit position for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH. */
#define BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH (0x0000FFFFU) /*!< Bit mask for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH. */
#define BS_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH (16U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH field. */
#define BR_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH(x) (HW_HW_PRE_STORE_ENGINE_SIZE(x).B.INPUT_TOTAL_WIDTH)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH. */
#define BF_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH) & BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH)

/*! @brief Set the INPUT_TOTAL_WIDTH field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, (HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) & ~BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH) | BF_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_WIDTH(v)))
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_SIZE, field INPUT_TOTAL_HEIGHT[31:16] (RW)
 *
 * Actual total height
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT (16U) /*!< Bit position for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT. */
#define BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT (0xFFFF0000U) /*!< Bit mask for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT. */
#define BS_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT (16U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT field. */
#define BR_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT(x) (HW_HW_PRE_STORE_ENGINE_SIZE(x).B.INPUT_TOTAL_HEIGHT)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT. */
#define BF_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT) & BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT)

/*! @brief Set the INPUT_TOTAL_HEIGHT field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT(x, v) (HW_HW_PRE_STORE_ENGINE_SIZE_WR(x, (HW_HW_PRE_STORE_ENGINE_SIZE_RD(x) & ~BM_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT) | BF_HW_PRE_STORE_ENGINE_SIZE_INPUT_TOTAL_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_STORE_ENGINE_PITCH - PRE Store Engine Pitch Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_STORE_ENGINE_PITCH - PRE Store Engine Pitch Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_store_engine_pitch
{
    uint32_t U;
    struct _hw_hw_pre_store_engine_pitch_bitfields
    {
        uint32_t OUT_PITCH : 16;       /*!< [15:0]  */
        uint32_t RSVD0 : 16;           /*!< [31:16]  */
    } B;
} hw_hw_pre_store_engine_pitch_t;

/*!
 * @name Constants and macros for entire HW_PRE_STORE_ENGINE_PITCH register
 */
/*@{*/
#define HW_HW_PRE_STORE_ENGINE_PITCH_ADDR(x) ((uintptr_t)(x) + 0x140U)

#define HW_HW_PRE_STORE_ENGINE_PITCH(x) (*(__IO hw_hw_pre_store_engine_pitch_t *) HW_HW_PRE_STORE_ENGINE_PITCH_ADDR(x))
#define HW_HW_PRE_STORE_ENGINE_PITCH_RD(x) (HW_HW_PRE_STORE_ENGINE_PITCH(x).U)
#define HW_HW_PRE_STORE_ENGINE_PITCH_WR(x, v) (HW_HW_PRE_STORE_ENGINE_PITCH(x).U = (v))
#define HW_HW_PRE_STORE_ENGINE_PITCH_SET(x, v) (HW_HW_PRE_STORE_ENGINE_PITCH_WR(x, HW_HW_PRE_STORE_ENGINE_PITCH_RD(x) |  (v)))
#define HW_HW_PRE_STORE_ENGINE_PITCH_CLR(x, v) (HW_HW_PRE_STORE_ENGINE_PITCH_WR(x, HW_HW_PRE_STORE_ENGINE_PITCH_RD(x) & ~(v)))
#define HW_HW_PRE_STORE_ENGINE_PITCH_TOG(x, v) (HW_HW_PRE_STORE_ENGINE_PITCH_WR(x, HW_HW_PRE_STORE_ENGINE_PITCH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_STORE_ENGINE_PITCH bitfields
 */

/*!
 * @name Register HW_PRE_STORE_ENGINE_PITCH, field OUT_PITCH[15:0] (RW)
 *
 * Indicates the number of bytes in memory between two vertically adjacent
 * pixels. In below case, this register should be 8 bytes alignment. 1, in scan mode,
 * that is, BLOCK_EN = 0, when WR_NUM_BYTES = 128 bytes. 2, in block mode, that
 * is, BLOCK_EN = 1, BLOCK_16 = 0, OUTPUT_ACTIVE_BPP = 2.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH (0U) /*!< Bit position for HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH. */
#define BM_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH (0x0000FFFFU) /*!< Bit mask for HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH. */
#define BS_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH (16U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH field. */
#define BR_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH(x) (HW_HW_PRE_STORE_ENGINE_PITCH(x).B.OUT_PITCH)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH. */
#define BF_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH) & BM_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH)

/*! @brief Set the OUT_PITCH field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH(x, v) (HW_HW_PRE_STORE_ENGINE_PITCH_WR(x, (HW_HW_PRE_STORE_ENGINE_PITCH_RD(x) & ~BM_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH) | BF_HW_PRE_STORE_ENGINE_PITCH_OUT_PITCH(v)))
/*@}*/

/*!
 * @name Register HW_PRE_STORE_ENGINE_PITCH, field RSVD0[31:16] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_PITCH_RSVD0 (16U) /*!< Bit position for HW_PRE_STORE_ENGINE_PITCH_RSVD0. */
#define BM_HW_PRE_STORE_ENGINE_PITCH_RSVD0 (0xFFFF0000U) /*!< Bit mask for HW_PRE_STORE_ENGINE_PITCH_RSVD0. */
#define BS_HW_PRE_STORE_ENGINE_PITCH_RSVD0 (16U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_PITCH_RSVD0. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_PITCH_RSVD0 field. */
#define BR_HW_PRE_STORE_ENGINE_PITCH_RSVD0(x) (HW_HW_PRE_STORE_ENGINE_PITCH(x).B.RSVD0)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_STORE_ENGINE_ADDR - PRE Store Engine Address Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_STORE_ENGINE_ADDR - PRE Store Engine Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control bits for the pre STORE_ENGINE sub-block.
 */
typedef union _hw_hw_pre_store_engine_addr
{
    uint32_t U;
    struct _hw_hw_pre_store_engine_addr_bitfields
    {
        uint32_t OUT_BASE_ADDR : 32;   /*!< [31:0] Output Base Address */
    } B;
} hw_hw_pre_store_engine_addr_t;

/*!
 * @name Constants and macros for entire HW_PRE_STORE_ENGINE_ADDR register
 */
/*@{*/
#define HW_HW_PRE_STORE_ENGINE_ADDR_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_HW_PRE_STORE_ENGINE_ADDR(x) (*(__IO hw_hw_pre_store_engine_addr_t *) HW_HW_PRE_STORE_ENGINE_ADDR_ADDR(x))
#define HW_HW_PRE_STORE_ENGINE_ADDR_RD(x) (HW_HW_PRE_STORE_ENGINE_ADDR(x).U)
#define HW_HW_PRE_STORE_ENGINE_ADDR_WR(x, v) (HW_HW_PRE_STORE_ENGINE_ADDR(x).U = (v))
#define HW_HW_PRE_STORE_ENGINE_ADDR_SET(x, v) (HW_HW_PRE_STORE_ENGINE_ADDR_WR(x, HW_HW_PRE_STORE_ENGINE_ADDR_RD(x) |  (v)))
#define HW_HW_PRE_STORE_ENGINE_ADDR_CLR(x, v) (HW_HW_PRE_STORE_ENGINE_ADDR_WR(x, HW_HW_PRE_STORE_ENGINE_ADDR_RD(x) & ~(v)))
#define HW_HW_PRE_STORE_ENGINE_ADDR_TOG(x, v) (HW_HW_PRE_STORE_ENGINE_ADDR_WR(x, HW_HW_PRE_STORE_ENGINE_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_STORE_ENGINE_ADDR bitfields
 */

/*!
 * @name Register HW_PRE_STORE_ENGINE_ADDR, field OUT_BASE_ADDR[31:0] (RW)
 *
 * It should be 8 bytes aligned when below case occurs.
 *
 * Values:
 * - 1 - In scan mode, that is, BLOCK_EN = 0 when WR_NUM_BYTES = 128 bytes.
 */
/*@{*/
#define BP_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR (0U) /*!< Bit position for HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR. */
#define BM_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR (0xFFFFFFFFU) /*!< Bit mask for HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR. */
#define BS_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR (32U) /*!< Bit field size in bits for HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR. */

/*! @brief Read current value of the HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR field. */
#define BR_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR(x) (HW_HW_PRE_STORE_ENGINE_ADDR(x).U)

/*! @brief Format value for bitfield HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR. */
#define BF_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR) & BM_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR)

/*! @brief Set the OUT_BASE_ADDR field to a new value. */
#define BW_HW_PRE_STORE_ENGINE_ADDR_OUT_BASE_ADDR(x, v) (HW_HW_PRE_STORE_ENGINE_ADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_DEBUGCTRL - Debug Control Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_DEBUGCTRL - Debug Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is for diagnostic purposes only. This register controls the
 * debug features of the Pre.
 */
typedef union _hw_hw_pre_debugctrl
{
    uint32_t U;
    struct _hw_hw_pre_debugctrl_bitfields
    {
        uint32_t SELECT : 4;           /*!< [3:0]  */
        uint32_t RSVD : 4;             /*!< [7:4]  */
        uint32_t TPR_DBG_SEL : 6;      /*!< [13:8]  */
        uint32_t RSVD1 : 18;           /*!< [31:14]  */
    } B;
} hw_hw_pre_debugctrl_t;

/*!
 * @name Constants and macros for entire HW_PRE_DEBUGCTRL register
 */
/*@{*/
#define HW_HW_PRE_DEBUGCTRL_ADDR(x) ((uintptr_t)(x) + 0x160U)

#define HW_HW_PRE_DEBUGCTRL(x)   (*(__IO hw_hw_pre_debugctrl_t *) HW_HW_PRE_DEBUGCTRL_ADDR(x))
#define HW_HW_PRE_DEBUGCTRL_RD(x) (HW_HW_PRE_DEBUGCTRL(x).U)
#define HW_HW_PRE_DEBUGCTRL_WR(x, v) (HW_HW_PRE_DEBUGCTRL(x).U = (v))
#define HW_HW_PRE_DEBUGCTRL_SET(x, v) (HW_HW_PRE_DEBUGCTRL_WR(x, HW_HW_PRE_DEBUGCTRL_RD(x) |  (v)))
#define HW_HW_PRE_DEBUGCTRL_CLR(x, v) (HW_HW_PRE_DEBUGCTRL_WR(x, HW_HW_PRE_DEBUGCTRL_RD(x) & ~(v)))
#define HW_HW_PRE_DEBUGCTRL_TOG(x, v) (HW_HW_PRE_DEBUGCTRL_WR(x, HW_HW_PRE_DEBUGCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual HW_PRE_DEBUGCTRL bitfields
 */

/*!
 * @name Register HW_PRE_DEBUGCTRL, field SELECT[3:0] (RW)
 *
 * Index into one of the PRE debug registers. The data for the selected register
 * will be returned.
 */
/*@{*/
#define BP_HW_PRE_DEBUGCTRL_SELECT (0U)    /*!< Bit position for HW_PRE_DEBUGCTRL_SELECT. */
#define BM_HW_PRE_DEBUGCTRL_SELECT (0x0000000FU) /*!< Bit mask for HW_PRE_DEBUGCTRL_SELECT. */
#define BS_HW_PRE_DEBUGCTRL_SELECT (4U)    /*!< Bit field size in bits for HW_PRE_DEBUGCTRL_SELECT. */

/*! @brief Read current value of the HW_PRE_DEBUGCTRL_SELECT field. */
#define BR_HW_PRE_DEBUGCTRL_SELECT(x) (HW_HW_PRE_DEBUGCTRL(x).B.SELECT)

/*! @brief Format value for bitfield HW_PRE_DEBUGCTRL_SELECT. */
#define BF_HW_PRE_DEBUGCTRL_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_DEBUGCTRL_SELECT) & BM_HW_PRE_DEBUGCTRL_SELECT)

/*! @brief Set the SELECT field to a new value. */
#define BW_HW_PRE_DEBUGCTRL_SELECT(x, v) (HW_HW_PRE_DEBUGCTRL_WR(x, (HW_HW_PRE_DEBUGCTRL_RD(x) & ~BM_HW_PRE_DEBUGCTRL_SELECT) | BF_HW_PRE_DEBUGCTRL_SELECT(v)))
/*@}*/

/*!
 * @name Register HW_PRE_DEBUGCTRL, field RSVD[7:4] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_DEBUGCTRL_RSVD (4U)      /*!< Bit position for HW_PRE_DEBUGCTRL_RSVD. */
#define BM_HW_PRE_DEBUGCTRL_RSVD (0x000000F0U) /*!< Bit mask for HW_PRE_DEBUGCTRL_RSVD. */
#define BS_HW_PRE_DEBUGCTRL_RSVD (4U)      /*!< Bit field size in bits for HW_PRE_DEBUGCTRL_RSVD. */

/*! @brief Read current value of the HW_PRE_DEBUGCTRL_RSVD field. */
#define BR_HW_PRE_DEBUGCTRL_RSVD(x) (HW_HW_PRE_DEBUGCTRL(x).B.RSVD)
/*@}*/

/*!
 * @name Register HW_PRE_DEBUGCTRL, field TPR_DBG_SEL[13:8] (RW)
 *
 * Select debug observation signals in TPR sub-module
 */
/*@{*/
#define BP_HW_PRE_DEBUGCTRL_TPR_DBG_SEL (8U) /*!< Bit position for HW_PRE_DEBUGCTRL_TPR_DBG_SEL. */
#define BM_HW_PRE_DEBUGCTRL_TPR_DBG_SEL (0x00003F00U) /*!< Bit mask for HW_PRE_DEBUGCTRL_TPR_DBG_SEL. */
#define BS_HW_PRE_DEBUGCTRL_TPR_DBG_SEL (6U) /*!< Bit field size in bits for HW_PRE_DEBUGCTRL_TPR_DBG_SEL. */

/*! @brief Read current value of the HW_PRE_DEBUGCTRL_TPR_DBG_SEL field. */
#define BR_HW_PRE_DEBUGCTRL_TPR_DBG_SEL(x) (HW_HW_PRE_DEBUGCTRL(x).B.TPR_DBG_SEL)

/*! @brief Format value for bitfield HW_PRE_DEBUGCTRL_TPR_DBG_SEL. */
#define BF_HW_PRE_DEBUGCTRL_TPR_DBG_SEL(v) ((uint32_t)((uint32_t)(v) << BP_HW_PRE_DEBUGCTRL_TPR_DBG_SEL) & BM_HW_PRE_DEBUGCTRL_TPR_DBG_SEL)

/*! @brief Set the TPR_DBG_SEL field to a new value. */
#define BW_HW_PRE_DEBUGCTRL_TPR_DBG_SEL(x, v) (HW_HW_PRE_DEBUGCTRL_WR(x, (HW_HW_PRE_DEBUGCTRL_RD(x) & ~BM_HW_PRE_DEBUGCTRL_TPR_DBG_SEL) | BF_HW_PRE_DEBUGCTRL_TPR_DBG_SEL(v)))
/*@}*/

/*!
 * @name Register HW_PRE_DEBUGCTRL, field RSVD1[31:14] (RO)
 *
 * Reserved, always set to zero.
 */
/*@{*/
#define BP_HW_PRE_DEBUGCTRL_RSVD1 (14U)    /*!< Bit position for HW_PRE_DEBUGCTRL_RSVD1. */
#define BM_HW_PRE_DEBUGCTRL_RSVD1 (0xFFFFC000U) /*!< Bit mask for HW_PRE_DEBUGCTRL_RSVD1. */
#define BS_HW_PRE_DEBUGCTRL_RSVD1 (18U)    /*!< Bit field size in bits for HW_PRE_DEBUGCTRL_RSVD1. */

/*! @brief Read current value of the HW_PRE_DEBUGCTRL_RSVD1 field. */
#define BR_HW_PRE_DEBUGCTRL_RSVD1(x) (HW_HW_PRE_DEBUGCTRL(x).B.RSVD1)
/*@}*/

/*******************************************************************************
 * HW_HW_PRE_DEBUG - Debug Register
 ******************************************************************************/

/*!
 * @brief HW_HW_PRE_DEBUG - Debug Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is for diagnostic purposes only. This register returns selected
 * debug register values.
 */
typedef union _hw_hw_pre_debug
{
    uint32_t U;
    struct _hw_hw_pre_debug_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_hw_pre_debug_t;

/*!
 * @name Constants and macros for entire HW_PRE_DEBUG register
 */
/*@{*/
#define HW_HW_PRE_DEBUG_ADDR(x)  ((uintptr_t)(x) + 0x170U)

#define HW_HW_PRE_DEBUG(x)       (*(__I hw_hw_pre_debug_t *) HW_HW_PRE_DEBUG_ADDR(x))
#define HW_HW_PRE_DEBUG_RD(x)    (HW_HW_PRE_DEBUG(x).U)
/*@}*/

/*
 * Constants & macros for individual HW_PRE_DEBUG bitfields
 */

/*!
 * @name Register HW_PRE_DEBUG, field DATA[31:0] (RO)
 *
 * Debug data
 */
/*@{*/
#define BP_HW_PRE_DEBUG_DATA (0U)          /*!< Bit position for HW_PRE_DEBUG_DATA. */
#define BM_HW_PRE_DEBUG_DATA (0xFFFFFFFFU) /*!< Bit mask for HW_PRE_DEBUG_DATA. */
#define BS_HW_PRE_DEBUG_DATA (32U)         /*!< Bit field size in bits for HW_PRE_DEBUG_DATA. */

/*! @brief Read current value of the HW_PRE_DEBUG_DATA field. */
#define BR_HW_PRE_DEBUG_DATA(x) (HW_HW_PRE_DEBUG(x).U)
/*@}*/

/*******************************************************************************
 * hw_hw_pre_t - module struct
 ******************************************************************************/
/*!
 * @brief All HW_PRE module registers.
 */
#pragma pack(1)
typedef struct _hw_hw_pre
{
    __IO hw_hw_pre_ctrl_t CTRL;            /*!< [0x0] PRE Control Register */
    uint8_t _reserved0[12];
    __IO hw_hw_pre_irq_mask_t IRQ_MASK;    /*!< [0x10] PRE IRQ Mask Register */
    uint8_t _reserved1[12];
    __IO hw_hw_pre_irq_stat_t IRQ_STAT;    /*!< [0x20] PRE Interrupt Status Register */
    uint8_t _reserved2[12];
    __IO hw_hw_pre_cur_buf_t CUR_BUF;      /*!< [0x30] PRE Base Address 0 Register */
    uint8_t _reserved3[12];
    __IO hw_hw_pre_next_buf_t NEXT_BUF;    /*!< [0x40] PRE Base Address 1 Register */
    uint8_t _reserved4[12];
    __IO hw_hw_pre_u_buf_offset_t U_BUF_OFFSET; /*!< [0x50] PRE U Buffer Offset Register */
    uint8_t _reserved5[12];
    __IO hw_hw_pre_v_buf_offset_t V_BUF_OFFSET; /*!< [0x60] PRE V Buffer Offset Register */
    uint8_t _reserved6[12];
    __IO hw_hw_pre_tpr_ctrl_t TPR_CTRL;    /*!< [0x70] PRE TPR Control Register */
    uint8_t _reserved7[12];
    __IO hw_hw_pre_prefetch_engine_ctrl_t PREFETCH_ENGINE_CTRL; /*!< [0x80] PRE Prefetch Engine Control Register */
    uint8_t _reserved8[12];
    __I hw_hw_pre_prefetch_engine_status_t PREFETCH_ENGINE_STATUS; /*!< [0x90] PRE Prefetch Engine Status Register */
    uint8_t _reserved9[12];
    __IO hw_hw_pre_prefetch_engine_input_size_t PREFETCH_ENGINE_INPUT_SIZE; /*!< [0xA0] PRE Prefetch Engine Input Size Register */
    uint8_t _reserved10[12];
    __IO hw_hw_pre_prefetch_engine_output_size_ulc_t PREFETCH_ENGINE_OUTPUT_SIZE_ULC; /*!< [0xB0] PRE Prefetch Engine Output Size Up-Left Coordinate */
    uint8_t _reserved11[28];
    __IO hw_hw_pre_prefetch_engine_pitch_t PREFETCH_ENGINE_PITCH; /*!< [0xD0] PRE Prefetch Engine Pitch Register */
    uint8_t _reserved12[12];
    __IO hw_hw_pre_prefetch_engine_shift_offset_t PREFETCH_ENGINE_SHIFT_OFFSET; /*!< [0xE0] PRE Prefetch Engine Shift Control Register */
    uint8_t _reserved13[12];
    __IO hw_hw_pre_prefetch_engine_shift_width_t PREFETCH_ENGINE_SHIFT_WIDTH; /*!< [0xF0] PRE Prefetch Engine Shift Parameter Register */
    uint8_t _reserved14[12];
    __IO hw_hw_pre_prefetch_engine_interlace_offset_t PREFETCH_ENGINE_INTERLACE_OFFSET; /*!< [0x100] PRE Prefetch Engine Interlace Offset */
    uint8_t _reserved15[12];
    __IO hw_hw_pre_store_engine_ctrl_t STORE_ENGINE_CTRL; /*!< [0x110] PRE Store Engine Control Register */
    uint8_t _reserved16[12];
    __I hw_hw_pre_store_engine_status_t STORE_ENGINE_STATUS; /*!< [0x120] PRE Store Engine Status Register */
    uint8_t _reserved17[12];
    __IO hw_hw_pre_store_engine_size_t STORE_ENGINE_SIZE; /*!< [0x130] PRE Store Engine Source Size Register */
    uint8_t _reserved18[12];
    __IO hw_hw_pre_store_engine_pitch_t STORE_ENGINE_PITCH; /*!< [0x140] PRE Store Engine Pitch Register */
    uint8_t _reserved19[12];
    __IO hw_hw_pre_store_engine_addr_t STORE_ENGINE_ADDR; /*!< [0x150] PRE Store Engine Address Register */
    uint8_t _reserved20[12];
    __IO hw_hw_pre_debugctrl_t DEBUGCTRL;  /*!< [0x160] Debug Control Register */
    uint8_t _reserved21[12];
    __I hw_hw_pre_debug_t DEBUGr;          /*!< [0x170] Debug Register */
} hw_hw_pre_t;
#pragma pack()

/*! @brief Macro to access all HW_PRE registers. */
/*! @param x HW_PRE module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_HW_PRE_REGS(HW_PRE_BASE)</code>. */
#define HW_HW_PRE_REGS(x) (*(hw_hw_pre_t *)(x))

/*
 * iMX6DP I2C
 *
 * I2C
 *
 * Registers defined in this header file:
 * - HW_I2C_IADR - I2C Address Register
 * - HW_I2C_IFDR - I2C Frequency Divider Register
 * - HW_I2C_I2CR - I2C Control Register
 * - HW_I2C_I2SR - I2C Status Register
 * - HW_I2C_I2DR - I2C Data I/O Register
 *
 * - hw_i2c_t - Struct containing all module registers.
 */

#define HW_I2C_INSTANCE_COUNT (3U) /*!< Number of instances of the I2C module. */
#define HW_I2C1 (0U) /*!< Instance number for I2C1. */
#define HW_I2C2 (1U) /*!< Instance number for I2C2. */
#define HW_I2C3 (2U) /*!< Instance number for I2C3. */
#define I2C1_BASE             (0x21A0000U) /*!< Base address for I2C1. */
#define I2C2_BASE             (0x21A4000U) /*!< Base address for I2C2. */
#define I2C3_BASE             (0x21A8000U) /*!< Base address for I2C3. */
/*! Array initializer of I2C base addresses. */
#define I2C_BASE_ADDRS        { I2C1_BASE, I2C2_BASE, I2C3_BASE }

/*******************************************************************************
 * HW_I2C_IADR - I2C Address Register
 ******************************************************************************/

/*!
 * @brief HW_I2C_IADR - I2C Address Register (RW)
 *
 * Reset value: 0x0000U
 */
typedef union _hw_i2c_iadr
{
    uint16_t U;
    struct _hw_i2c_iadr_bitfields
    {
        uint16_t RESERVED0 : 1;        /*!< [0]  */
        uint16_t ADR : 7;              /*!< [7:1]  */
        uint16_t RESERVED1 : 8;        /*!< [15:8]  */
    } B;
} hw_i2c_iadr_t;

/*!
 * @name Constants and macros for entire I2C_IADR register
 */
/*@{*/
#define HW_I2C_IADR_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_I2C_IADR(x)           (*(__IO hw_i2c_iadr_t *) HW_I2C_IADR_ADDR(x))
#define HW_I2C_IADR_RD(x)        (HW_I2C_IADR(x).U)
#define HW_I2C_IADR_WR(x, v)     (HW_I2C_IADR(x).U = (v))
#define HW_I2C_IADR_SET(x, v)    (HW_I2C_IADR_WR(x, HW_I2C_IADR_RD(x) |  (v)))
#define HW_I2C_IADR_CLR(x, v)    (HW_I2C_IADR_WR(x, HW_I2C_IADR_RD(x) & ~(v)))
#define HW_I2C_IADR_TOG(x, v)    (HW_I2C_IADR_WR(x, HW_I2C_IADR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual I2C_IADR bitfields
 */

/*!
 * @name Register I2C_IADR, field ADR[7:1] (RW)
 *
 * Slave address. Contains the specific slave address to be used by the I2C.
 * Slave mode is the default I2C mode for an address match on the bus. The I2C_IADR
 * holds the address to which the I2C responds when addressed as a slave. The
 * slave address is not the address sent on the bus during the address transfer. The
 * register is not reset by a software reset.
 */
/*@{*/
#define BP_I2C_IADR_ADR      (1U)          /*!< Bit position for I2C_IADR_ADR. */
#define BM_I2C_IADR_ADR      (0x00FEU)     /*!< Bit mask for I2C_IADR_ADR. */
#define BS_I2C_IADR_ADR      (7U)          /*!< Bit field size in bits for I2C_IADR_ADR. */

/*! @brief Read current value of the I2C_IADR_ADR field. */
#define BR_I2C_IADR_ADR(x)   (HW_I2C_IADR(x).B.ADR)

/*! @brief Format value for bitfield I2C_IADR_ADR. */
#define BF_I2C_IADR_ADR(v)   ((uint16_t)((uint16_t)(v) << BP_I2C_IADR_ADR) & BM_I2C_IADR_ADR)

/*! @brief Set the ADR field to a new value. */
#define BW_I2C_IADR_ADR(x, v) (HW_I2C_IADR_WR(x, (HW_I2C_IADR_RD(x) & ~BM_I2C_IADR_ADR) | BF_I2C_IADR_ADR(v)))
/*@}*/

/*******************************************************************************
 * HW_I2C_IFDR - I2C Frequency Divider Register
 ******************************************************************************/

/*!
 * @brief HW_I2C_IFDR - I2C Frequency Divider Register (RW)
 *
 * Reset value: 0x0000U
 *
 * The I2C_IFDR provides a programmable prescaler to configure the clock for
 * bit-rate selection. The register does not get reset by a software reset. I2C
 * clock is sourced from PERCLK_ROOT which is routed from IPG_CLK_ROOT. I2C clock
 * frequency can easily obtained by using the following formula: I2C clock Frequency
 * = (PERCLK_ROOT frequency)/(division factor corresponding to IFDR) By default,
 * IPG_CLK_ROOT and PERCLK_ROOT frequencies are set to 49.5MHz, where the root
 * clock is sourced from PLL2's PFD2. Obtaining the frequencies can be
 * accomplished by: PLL2 = 528MHz PLL2_PFD2 = 528MHz * 18 / 24 = 396MHz IPG_CLK_ROOT =
 * (PLL2_PFD2 / ahb_podf )/ ipg_podf = (396MHz/4)/2 = 49.5MHz PER_CLK_ROOT =
 * IPG_CLK_ROOT/perclk_podf = 49.5MHz/1 = 49.5MHz The above calculation assumes that the
 * default CCM register settings, routing, and division factors are used. If
 * different routing, PFD values, and/or division factors are used, the user must
 * adjust the parameters accordingly to calculate the correct clock frequency. The
 * following table describes the divider and register values for the register field
 * "IC." I2C_IFDR Register Field Values IC Divider IC Divider IC Divider IC
 * Divider 0x00 30 0x10 288 0x20 22 0x30 160 0x01 32 0x11 320 0x21 24 0x31 192 0x02
 * 36 0x12 384 0x22 26 0x32 224 0x03 42 0x13 480 0x23 28 0x33 256 0x04 48 0x14 576
 * 0x24 32 0x34 320 0x05 52 0x15 640 0x25 36 0x35 384 0x06 60 0x16 768 0x26 40
 * 0x36 448 0x07 72 0x17 960 0x27 44 0x37 512 0x08 80 0x18 1152 0x28 48 0x38 640
 * 0x09 88 0x19 1280 0x29 56 0x39 768 0x0A 104 0x1A 1536 0x2A 64 0x3A 896 0x0B 128
 * 0x1B 1920 0x2B 72 0x3B 1024 0x0C 144 0x1C 2304 0x2C 80 0x3C 1280 0x0D 160
 * 0x1D 2560 0x2D 96 0x3D 1536 0x0E 192 0x1E 3072 0x2E 112 0x3E 1792 0x0F 240 0x1F
 * 3840 0x2F 128 0x3F 2048
 */
typedef union _hw_i2c_ifdr
{
    uint16_t U;
    struct _hw_i2c_ifdr_bitfields
    {
        uint16_t IC : 6;               /*!< [5:0]  */
        uint16_t RESERVED0 : 10;       /*!< [15:6]  */
    } B;
} hw_i2c_ifdr_t;

/*!
 * @name Constants and macros for entire I2C_IFDR register
 */
/*@{*/
#define HW_I2C_IFDR_ADDR(x)      ((uintptr_t)(x) + 0x4U)

#define HW_I2C_IFDR(x)           (*(__IO hw_i2c_ifdr_t *) HW_I2C_IFDR_ADDR(x))
#define HW_I2C_IFDR_RD(x)        (HW_I2C_IFDR(x).U)
#define HW_I2C_IFDR_WR(x, v)     (HW_I2C_IFDR(x).U = (v))
#define HW_I2C_IFDR_SET(x, v)    (HW_I2C_IFDR_WR(x, HW_I2C_IFDR_RD(x) |  (v)))
#define HW_I2C_IFDR_CLR(x, v)    (HW_I2C_IFDR_WR(x, HW_I2C_IFDR_RD(x) & ~(v)))
#define HW_I2C_IFDR_TOG(x, v)    (HW_I2C_IFDR_WR(x, HW_I2C_IFDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual I2C_IFDR bitfields
 */

/*!
 * @name Register I2C_IFDR, field IC[5:0] (RW)
 *
 * I2C clock rate. Prescales the clock for bit-rate selection. Due to
 * potentially slow I2Cn_SCL and I2Cn_SDA rise and fall times, bus signals are sampled at
 * the prescaler frequency. The serial bit clock frequency may be lower than
 * IPG_CLK_ROOT divided by the divider shown in the I2C Data I/O Register. The IC
 * value should not be changed during the data transfer, however, it can be changed
 * before a Repeat Start or Start programming sequence in I2C. The I2C protocol
 * supports bit rates of up to 400 kbps. The IC bits need to be programmed in
 * accordance with this constraint.
 */
/*@{*/
#define BP_I2C_IFDR_IC       (0U)          /*!< Bit position for I2C_IFDR_IC. */
#define BM_I2C_IFDR_IC       (0x003FU)     /*!< Bit mask for I2C_IFDR_IC. */
#define BS_I2C_IFDR_IC       (6U)          /*!< Bit field size in bits for I2C_IFDR_IC. */

/*! @brief Read current value of the I2C_IFDR_IC field. */
#define BR_I2C_IFDR_IC(x)    (HW_I2C_IFDR(x).B.IC)

/*! @brief Format value for bitfield I2C_IFDR_IC. */
#define BF_I2C_IFDR_IC(v)    ((uint16_t)((uint16_t)(v) << BP_I2C_IFDR_IC) & BM_I2C_IFDR_IC)

/*! @brief Set the IC field to a new value. */
#define BW_I2C_IFDR_IC(x, v) (HW_I2C_IFDR_WR(x, (HW_I2C_IFDR_RD(x) & ~BM_I2C_IFDR_IC) | BF_I2C_IFDR_IC(v)))
/*@}*/

/*******************************************************************************
 * HW_I2C_I2CR - I2C Control Register
 ******************************************************************************/

/*!
 * @brief HW_I2C_I2CR - I2C Control Register (RW)
 *
 * Reset value: 0x0000U
 *
 * The I2C_I2CR is used to enable the I2C and the I2C interrupt. It also
 * contains bits that govern operation as a slave or a master.
 */
typedef union _hw_i2c_i2cr
{
    uint16_t U;
    struct _hw_i2c_i2cr_bitfields
    {
        uint16_t RESERVED0 : 2;        /*!< [1:0]  */
        uint16_t RSTA : 1;             /*!< [2]  */
        uint16_t TXAK : 1;             /*!< [3]  */
        uint16_t MTX : 1;              /*!< [4]  */
        uint16_t MSTA : 1;             /*!< [5]  */
        uint16_t IIEN : 1;             /*!< [6]  */
        uint16_t IEN : 1;              /*!< [7]  */
        uint16_t RESERVED1 : 8;        /*!< [15:8]  */
    } B;
} hw_i2c_i2cr_t;

/*!
 * @name Constants and macros for entire I2C_I2CR register
 */
/*@{*/
#define HW_I2C_I2CR_ADDR(x)      ((uintptr_t)(x) + 0x8U)

#define HW_I2C_I2CR(x)           (*(__IO hw_i2c_i2cr_t *) HW_I2C_I2CR_ADDR(x))
#define HW_I2C_I2CR_RD(x)        (HW_I2C_I2CR(x).U)
#define HW_I2C_I2CR_WR(x, v)     (HW_I2C_I2CR(x).U = (v))
#define HW_I2C_I2CR_SET(x, v)    (HW_I2C_I2CR_WR(x, HW_I2C_I2CR_RD(x) |  (v)))
#define HW_I2C_I2CR_CLR(x, v)    (HW_I2C_I2CR_WR(x, HW_I2C_I2CR_RD(x) & ~(v)))
#define HW_I2C_I2CR_TOG(x, v)    (HW_I2C_I2CR_WR(x, HW_I2C_I2CR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual I2C_I2CR bitfields
 */

/*!
 * @name Register I2C_I2CR, field RSTA[2] (WORZ)
 *
 * Repeat start. Always reads as 0. Attempting a repeat start without bus
 * mastership causes loss of arbitration.
 *
 * Values:
 * - 0 - No repeat start
 * - 1 - Generates a Repeated Start condition
 */
/*@{*/
#define BP_I2C_I2CR_RSTA     (2U)          /*!< Bit position for I2C_I2CR_RSTA. */
#define BM_I2C_I2CR_RSTA     (0x0004U)     /*!< Bit mask for I2C_I2CR_RSTA. */
#define BS_I2C_I2CR_RSTA     (1U)          /*!< Bit field size in bits for I2C_I2CR_RSTA. */

/*! @brief Format value for bitfield I2C_I2CR_RSTA. */
#define BF_I2C_I2CR_RSTA(v)  ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_RSTA) & BM_I2C_I2CR_RSTA)

/*! @brief Set the RSTA field to a new value. */
#define BW_I2C_I2CR_RSTA(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_RSTA) | BF_I2C_I2CR_RSTA(v)))
/*@}*/

/*!
 * @name Register I2C_I2CR, field TXAK[3] (RW)
 *
 * Transmit acknowledge enable. Specifies the value driven onto I2Cn_SDA during
 * acknowledge cycles for both master and slave receivers. Writing TXAK applies
 * only when the I2C bus is a receiver.
 *
 * Values:
 * - 0 - An acknowledge signal is sent to the bus at the ninth clock bit after
 *     receiving one byte of data.
 * - 1 - No acknowledge signal response is sent (that is, the acknowledge bit =
 *     1).
 */
/*@{*/
#define BP_I2C_I2CR_TXAK     (3U)          /*!< Bit position for I2C_I2CR_TXAK. */
#define BM_I2C_I2CR_TXAK     (0x0008U)     /*!< Bit mask for I2C_I2CR_TXAK. */
#define BS_I2C_I2CR_TXAK     (1U)          /*!< Bit field size in bits for I2C_I2CR_TXAK. */

/*! @brief Read current value of the I2C_I2CR_TXAK field. */
#define BR_I2C_I2CR_TXAK(x)  (HW_I2C_I2CR(x).B.TXAK)

/*! @brief Format value for bitfield I2C_I2CR_TXAK. */
#define BF_I2C_I2CR_TXAK(v)  ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_TXAK) & BM_I2C_I2CR_TXAK)

/*! @brief Set the TXAK field to a new value. */
#define BW_I2C_I2CR_TXAK(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_TXAK) | BF_I2C_I2CR_TXAK(v)))
/*@}*/

/*!
 * @name Register I2C_I2CR, field MTX[4] (RW)
 *
 * Transmit/Receive mode select bit. Selects the direction of master and slave
 * transfers.
 *
 * Values:
 * - 0 - Receive.When a slave is addressed, the software should set MTX
 *     according to the slave read/write bit in the I2C status register (I2C_I2SR[SRW]).
 * - 1 - Transmit.In Master mode, MTX should be set according to the type of
 *     transfer required. Therefore, for address cycles, MTX is always 1.
 */
/*@{*/
#define BP_I2C_I2CR_MTX      (4U)          /*!< Bit position for I2C_I2CR_MTX. */
#define BM_I2C_I2CR_MTX      (0x0010U)     /*!< Bit mask for I2C_I2CR_MTX. */
#define BS_I2C_I2CR_MTX      (1U)          /*!< Bit field size in bits for I2C_I2CR_MTX. */

/*! @brief Read current value of the I2C_I2CR_MTX field. */
#define BR_I2C_I2CR_MTX(x)   (HW_I2C_I2CR(x).B.MTX)

/*! @brief Format value for bitfield I2C_I2CR_MTX. */
#define BF_I2C_I2CR_MTX(v)   ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_MTX) & BM_I2C_I2CR_MTX)

/*! @brief Set the MTX field to a new value. */
#define BW_I2C_I2CR_MTX(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_MTX) | BF_I2C_I2CR_MTX(v)))
/*@}*/

/*!
 * @name Register I2C_I2CR, field MSTA[5] (RW)
 *
 * Master/Slave mode select bit. If the master loses arbitration, MSTA is
 * cleared without generating a Stop signal. The module clock should be on for writing
 * to the MSTA bit. The MSTA bit is cleared by software to generate a Stop
 * condition; it can also be cleared by hardware when the I2C loses the bus arbitration.
 *
 * Values:
 * - 0 - Slave mode. Changing MSTA from 1 to 0 generates a Stop and selects
 *     Slave mode.
 * - 1 - Master mode. Changing MSTA from 0 to 1 signals a Start on the bus and
 *     selects Master mode.
 */
/*@{*/
#define BP_I2C_I2CR_MSTA     (5U)          /*!< Bit position for I2C_I2CR_MSTA. */
#define BM_I2C_I2CR_MSTA     (0x0020U)     /*!< Bit mask for I2C_I2CR_MSTA. */
#define BS_I2C_I2CR_MSTA     (1U)          /*!< Bit field size in bits for I2C_I2CR_MSTA. */

/*! @brief Read current value of the I2C_I2CR_MSTA field. */
#define BR_I2C_I2CR_MSTA(x)  (HW_I2C_I2CR(x).B.MSTA)

/*! @brief Format value for bitfield I2C_I2CR_MSTA. */
#define BF_I2C_I2CR_MSTA(v)  ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_MSTA) & BM_I2C_I2CR_MSTA)

/*! @brief Set the MSTA field to a new value. */
#define BW_I2C_I2CR_MSTA(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_MSTA) | BF_I2C_I2CR_MSTA(v)))
/*@}*/

/*!
 * @name Register I2C_I2CR, field IIEN[6] (RW)
 *
 * I2C interrupt enable. If data is written during the Start condition, that is,
 * just after setting the I2C_I2CR[MSTA] and I2C_I2CR[MTX] bits, then the ICF
 * bit is cleared at the falling edge of SCLK after Start. If data is written after
 * the Start condition and falling edge of SCLK, then the ICF bit is cleared as
 * soon as data is written.
 *
 * Values:
 * - 0 - I2C interrupts are disabled, but the status flag I2C_I2SR[IIF]
 *     continues to be set when an Interrupt condition occurs.
 * - 1 - I2C interrupts are enabled. An I2C interrupt occurs if I2C_I2SR[IIF] is
 *     also set.
 */
/*@{*/
#define BP_I2C_I2CR_IIEN     (6U)          /*!< Bit position for I2C_I2CR_IIEN. */
#define BM_I2C_I2CR_IIEN     (0x0040U)     /*!< Bit mask for I2C_I2CR_IIEN. */
#define BS_I2C_I2CR_IIEN     (1U)          /*!< Bit field size in bits for I2C_I2CR_IIEN. */

/*! @brief Read current value of the I2C_I2CR_IIEN field. */
#define BR_I2C_I2CR_IIEN(x)  (HW_I2C_I2CR(x).B.IIEN)

/*! @brief Format value for bitfield I2C_I2CR_IIEN. */
#define BF_I2C_I2CR_IIEN(v)  ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_IIEN) & BM_I2C_I2CR_IIEN)

/*! @brief Set the IIEN field to a new value. */
#define BW_I2C_I2CR_IIEN(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_IIEN) | BF_I2C_I2CR_IIEN(v)))
/*@}*/

/*!
 * @name Register I2C_I2CR, field IEN[7] (RW)
 *
 * I2C enable. Also controls the software reset of the entire I2C. Resetting the
 * bit generates an internal reset to the block. If the block is enabled in the
 * middle of a byte transfer, Slave mode ignores the current bus transfer and
 * starts operating when the next Start condition is detected. Master mode is not
 * aware that the bus is busy, so initiating a start cycle may corrupt the current
 * bus cycle, ultimately causing either the current master or the I2C to lose
 * arbitration. Subsequently, bus operation returns to normal.
 *
 * Values:
 * - 0 - The block is disabled, but registers can still be accessed.
 * - 1 - The I2C is enabled. This bit must be set before any other I2C_I2CR bits
 *     have an effect.
 */
/*@{*/
#define BP_I2C_I2CR_IEN      (7U)          /*!< Bit position for I2C_I2CR_IEN. */
#define BM_I2C_I2CR_IEN      (0x0080U)     /*!< Bit mask for I2C_I2CR_IEN. */
#define BS_I2C_I2CR_IEN      (1U)          /*!< Bit field size in bits for I2C_I2CR_IEN. */

/*! @brief Read current value of the I2C_I2CR_IEN field. */
#define BR_I2C_I2CR_IEN(x)   (HW_I2C_I2CR(x).B.IEN)

/*! @brief Format value for bitfield I2C_I2CR_IEN. */
#define BF_I2C_I2CR_IEN(v)   ((uint16_t)((uint16_t)(v) << BP_I2C_I2CR_IEN) & BM_I2C_I2CR_IEN)

/*! @brief Set the IEN field to a new value. */
#define BW_I2C_I2CR_IEN(x, v) (HW_I2C_I2CR_WR(x, (HW_I2C_I2CR_RD(x) & ~BM_I2C_I2CR_IEN) | BF_I2C_I2CR_IEN(v)))
/*@}*/

/*******************************************************************************
 * HW_I2C_I2SR - I2C Status Register
 ******************************************************************************/

/*!
 * @brief HW_I2C_I2SR - I2C Status Register (RW)
 *
 * Reset value: 0x0081U
 *
 * The I2C_I2SR contains bits that indicate transaction direction and status.
 */
typedef union _hw_i2c_i2sr
{
    uint16_t U;
    struct _hw_i2c_i2sr_bitfields
    {
        uint16_t RXAK : 1;             /*!< [0]  */
        uint16_t IIF : 1;              /*!< [1]  */
        uint16_t SRW : 1;              /*!< [2]  */
        uint16_t RESERVED0 : 1;        /*!< [3]  */
        uint16_t IAL : 1;              /*!< [4]  */
        uint16_t IBB : 1;              /*!< [5]  */
        uint16_t IAAS : 1;             /*!< [6]  */
        uint16_t ICF : 1;              /*!< [7]  */
        uint16_t RESERVED1 : 8;        /*!< [15:8]  */
    } B;
} hw_i2c_i2sr_t;

/*!
 * @name Constants and macros for entire I2C_I2SR register
 */
/*@{*/
#define HW_I2C_I2SR_ADDR(x)      ((uintptr_t)(x) + 0xCU)

#define HW_I2C_I2SR(x)           (*(__IO hw_i2c_i2sr_t *) HW_I2C_I2SR_ADDR(x))
#define HW_I2C_I2SR_RD(x)        (HW_I2C_I2SR(x).U)
#define HW_I2C_I2SR_WR(x, v)     (HW_I2C_I2SR(x).U = (v))
#define HW_I2C_I2SR_SET(x, v)    (HW_I2C_I2SR_WR(x, HW_I2C_I2SR_RD(x) |  (v)))
#define HW_I2C_I2SR_CLR(x, v)    (HW_I2C_I2SR_WR(x, HW_I2C_I2SR_RD(x) & ~(v)))
#define HW_I2C_I2SR_TOG(x, v)    (HW_I2C_I2SR_WR(x, HW_I2C_I2SR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual I2C_I2SR bitfields
 */

/*!
 * @name Register I2C_I2SR, field RXAK[0] (RO)
 *
 * Received acknowledge. This is the value received from the I2Cn_SDA input for
 * the acknowledge bit during a bus cycle.
 *
 * Values:
 * - 0 - An "acknowledge" signal was received after the completion of an 8-bit
 *     data transmission on the bus.
 * - 1 - A "No acknowledge" signal was detected at the ninth clock.
 */
/*@{*/
#define BP_I2C_I2SR_RXAK     (0U)          /*!< Bit position for I2C_I2SR_RXAK. */
#define BM_I2C_I2SR_RXAK     (0x0001U)     /*!< Bit mask for I2C_I2SR_RXAK. */
#define BS_I2C_I2SR_RXAK     (1U)          /*!< Bit field size in bits for I2C_I2SR_RXAK. */

/*! @brief Read current value of the I2C_I2SR_RXAK field. */
#define BR_I2C_I2SR_RXAK(x)  (HW_I2C_I2SR(x).B.RXAK)
/*@}*/

/*!
 * @name Register I2C_I2SR, field IIF[1] (RW)
 *
 * I2C interrupt. Must be cleared by the software by writing a "0" to it in the
 * interrupt routine. The software cannot set the bit.
 *
 * Values:
 * - 0 - No I2C interrupt pending.
 * - 1 - An interrupt is pending.This causes a processor interrupt request (if
 *     the interrupt enable is asserted [IIEN = 1]). The interrupt is set when one
 *     of the following occurs: One byte transfer is completed (the interrupt is
 *     set at the falling edge of the ninth clock). An address is received that
 *     matches its own specific address in Slave Receive mode. Arbitration is
 *     lost.
 */
/*@{*/
#define BP_I2C_I2SR_IIF      (1U)          /*!< Bit position for I2C_I2SR_IIF. */
#define BM_I2C_I2SR_IIF      (0x0002U)     /*!< Bit mask for I2C_I2SR_IIF. */
#define BS_I2C_I2SR_IIF      (1U)          /*!< Bit field size in bits for I2C_I2SR_IIF. */

/*! @brief Read current value of the I2C_I2SR_IIF field. */
#define BR_I2C_I2SR_IIF(x)   (HW_I2C_I2SR(x).B.IIF)

/*! @brief Format value for bitfield I2C_I2SR_IIF. */
#define BF_I2C_I2SR_IIF(v)   ((uint16_t)((uint16_t)(v) << BP_I2C_I2SR_IIF) & BM_I2C_I2SR_IIF)

/*! @brief Set the IIF field to a new value. */
#define BW_I2C_I2SR_IIF(x, v) (HW_I2C_I2SR_WR(x, (HW_I2C_I2SR_RD(x) & ~BM_I2C_I2SR_IIF) | BF_I2C_I2SR_IIF(v)))
/*@}*/

/*!
 * @name Register I2C_I2SR, field SRW[2] (RO)
 *
 * Slave read/write. When the I2C is addressed as a slave, IAAS is set, and the
 * slave read/write bit (SRW) indicates the value of the R/W command bit of the
 * calling address sent from the master. SRW is valid only when a complete
 * transfer has occurred, no other transfers have been initiated, and the I2C is a slave
 * and has an address match.
 *
 * Values:
 * - 0 - Slave receive, master writing to slave
 * - 1 - Slave transmit, master reading from slave
 */
/*@{*/
#define BP_I2C_I2SR_SRW      (2U)          /*!< Bit position for I2C_I2SR_SRW. */
#define BM_I2C_I2SR_SRW      (0x0004U)     /*!< Bit mask for I2C_I2SR_SRW. */
#define BS_I2C_I2SR_SRW      (1U)          /*!< Bit field size in bits for I2C_I2SR_SRW. */

/*! @brief Read current value of the I2C_I2SR_SRW field. */
#define BR_I2C_I2SR_SRW(x)   (HW_I2C_I2SR(x).B.SRW)
/*@}*/

/*!
 * @name Register I2C_I2SR, field IAL[4] (RW)
 *
 * Arbitration lost. Set by hardware in the following circumstances (IAL must be
 * cleared by software by writing a "0" to it at the start of the interrupt
 * service routine): I2Cn_SDA input samples low when the master drives high during an
 * address or data-transmit cycle. I2Cn_SDA input samples low when the master
 * drives high during the acknowledge bit of a data-receive cycle. For the above
 * two cases, the bit is set at the falling edge of the ninth I2Cn_SCL clock during
 * the ACK cycle. A Start cycle is attempted when the bus is busy. A Repeated
 * Start cycle is requested in Slave mode. A Stop condition is detected when the
 * master did not request it. Software cannot set the bit.
 *
 * Values:
 * - 0 - No arbitration lost.
 * - 1 - Arbitration is lost.
 */
/*@{*/
#define BP_I2C_I2SR_IAL      (4U)          /*!< Bit position for I2C_I2SR_IAL. */
#define BM_I2C_I2SR_IAL      (0x0010U)     /*!< Bit mask for I2C_I2SR_IAL. */
#define BS_I2C_I2SR_IAL      (1U)          /*!< Bit field size in bits for I2C_I2SR_IAL. */

/*! @brief Read current value of the I2C_I2SR_IAL field. */
#define BR_I2C_I2SR_IAL(x)   (HW_I2C_I2SR(x).B.IAL)

/*! @brief Format value for bitfield I2C_I2SR_IAL. */
#define BF_I2C_I2SR_IAL(v)   ((uint16_t)((uint16_t)(v) << BP_I2C_I2SR_IAL) & BM_I2C_I2SR_IAL)

/*! @brief Set the IAL field to a new value. */
#define BW_I2C_I2SR_IAL(x, v) (HW_I2C_I2SR_WR(x, (HW_I2C_I2SR_RD(x) & ~BM_I2C_I2SR_IAL) | BF_I2C_I2SR_IAL(v)))
/*@}*/

/*!
 * @name Register I2C_I2SR, field IBB[5] (RO)
 *
 * I2C bus busy bit. Indicates the status of the bus. When I2C is enabled
 * (I2C_I2CR[IEN] = 1), it continuously polls the bus data (SDA) and clock (SCL)
 * signals to determine a Start or Stop condition.
 *
 * Values:
 * - 0 - Bus is idle. If a Stop signal is detected, IBB is cleared.
 * - 1 - Bus is busy. When Start is detected, IBB is set.
 */
/*@{*/
#define BP_I2C_I2SR_IBB      (5U)          /*!< Bit position for I2C_I2SR_IBB. */
#define BM_I2C_I2SR_IBB      (0x0020U)     /*!< Bit mask for I2C_I2SR_IBB. */
#define BS_I2C_I2SR_IBB      (1U)          /*!< Bit field size in bits for I2C_I2SR_IBB. */

/*! @brief Read current value of the I2C_I2SR_IBB field. */
#define BR_I2C_I2SR_IBB(x)   (HW_I2C_I2SR(x).B.IBB)
/*@}*/

/*!
 * @name Register I2C_I2SR, field IAAS[6] (RO)
 *
 * I2C addressed as a slave bit. The ARM platform is interrupted if the
 * interrupt enable (I2C_I2CR[IIEN]) is set. The ARM platform must check the slave
 * read/write bit (SRW) and set its Transfer/Receive mode accordingly. Writing to
 * I2C_I2CR clears this bit.
 *
 * Values:
 * - 0 - Not addressed
 * - 1 - Addressed as a slave. Set when its own address (I2C_IADR) matches the
 *     calling address.
 */
/*@{*/
#define BP_I2C_I2SR_IAAS     (6U)          /*!< Bit position for I2C_I2SR_IAAS. */
#define BM_I2C_I2SR_IAAS     (0x0040U)     /*!< Bit mask for I2C_I2SR_IAAS. */
#define BS_I2C_I2SR_IAAS     (1U)          /*!< Bit field size in bits for I2C_I2SR_IAAS. */

/*! @brief Read current value of the I2C_I2SR_IAAS field. */
#define BR_I2C_I2SR_IAAS(x)  (HW_I2C_I2SR(x).B.IAAS)
/*@}*/

/*!
 * @name Register I2C_I2SR, field ICF[7] (RO)
 *
 * Data transferring bit. While one byte of data is transferred, ICF is cleared.
 *
 * Values:
 * - 0 - Transfer is in progress.
 * - 1 - Transfer is complete. This bit is set by the falling edge of the ninth
 *     clock of the last byte transfer.
 */
/*@{*/
#define BP_I2C_I2SR_ICF      (7U)          /*!< Bit position for I2C_I2SR_ICF. */
#define BM_I2C_I2SR_ICF      (0x0080U)     /*!< Bit mask for I2C_I2SR_ICF. */
#define BS_I2C_I2SR_ICF      (1U)          /*!< Bit field size in bits for I2C_I2SR_ICF. */

/*! @brief Read current value of the I2C_I2SR_ICF field. */
#define BR_I2C_I2SR_ICF(x)   (HW_I2C_I2SR(x).B.ICF)
/*@}*/

/*******************************************************************************
 * HW_I2C_I2DR - I2C Data I/O Register
 ******************************************************************************/

/*!
 * @brief HW_I2C_I2DR - I2C Data I/O Register (RW)
 *
 * Reset value: 0x0000U
 *
 * In Master Receive mode, reading the data register allows a read to occur and
 * initiates the next byte to be received. In Slave mode, the same function is
 * available after it is addressed.
 */
typedef union _hw_i2c_i2dr
{
    uint16_t U;
    struct _hw_i2c_i2dr_bitfields
    {
        uint16_t DATA : 8;             /*!< [7:0]  */
        uint16_t RESERVED0 : 8;        /*!< [15:8]  */
    } B;
} hw_i2c_i2dr_t;

/*!
 * @name Constants and macros for entire I2C_I2DR register
 */
/*@{*/
#define HW_I2C_I2DR_ADDR(x)      ((uintptr_t)(x) + 0x10U)

#define HW_I2C_I2DR(x)           (*(__IO hw_i2c_i2dr_t *) HW_I2C_I2DR_ADDR(x))
#define HW_I2C_I2DR_RD(x)        (HW_I2C_I2DR(x).U)
#define HW_I2C_I2DR_WR(x, v)     (HW_I2C_I2DR(x).U = (v))
#define HW_I2C_I2DR_SET(x, v)    (HW_I2C_I2DR_WR(x, HW_I2C_I2DR_RD(x) |  (v)))
#define HW_I2C_I2DR_CLR(x, v)    (HW_I2C_I2DR_WR(x, HW_I2C_I2DR_RD(x) & ~(v)))
#define HW_I2C_I2DR_TOG(x, v)    (HW_I2C_I2DR_WR(x, HW_I2C_I2DR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual I2C_I2DR bitfields
 */

/*!
 * @name Register I2C_I2DR, field DATA[7:0] (RW)
 *
 * Data Byte. Holds the last data byte received or the next data byte to be
 * transferred. Software writes the next data byte to be transmitted or reads the
 * data byte received. The core-written value in I2C_I2DR cannot be read back by the
 * core. Only data written by the I2C bus side can be read.
 */
/*@{*/
#define BP_I2C_I2DR_DATA     (0U)          /*!< Bit position for I2C_I2DR_DATA. */
#define BM_I2C_I2DR_DATA     (0x00FFU)     /*!< Bit mask for I2C_I2DR_DATA. */
#define BS_I2C_I2DR_DATA     (8U)          /*!< Bit field size in bits for I2C_I2DR_DATA. */

/*! @brief Read current value of the I2C_I2DR_DATA field. */
#define BR_I2C_I2DR_DATA(x)  (HW_I2C_I2DR(x).B.DATA)

/*! @brief Format value for bitfield I2C_I2DR_DATA. */
#define BF_I2C_I2DR_DATA(v)  ((uint16_t)((uint16_t)(v) << BP_I2C_I2DR_DATA) & BM_I2C_I2DR_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_I2C_I2DR_DATA(x, v) (HW_I2C_I2DR_WR(x, (HW_I2C_I2DR_RD(x) & ~BM_I2C_I2DR_DATA) | BF_I2C_I2DR_DATA(v)))
/*@}*/

/*******************************************************************************
 * hw_i2c_t - module struct
 ******************************************************************************/
/*!
 * @brief All I2C module registers.
 */
#pragma pack(1)
typedef struct _hw_i2c
{
    __IO hw_i2c_iadr_t IADR;               /*!< [0x0] I2C Address Register */
    uint8_t _reserved0[2];
    __IO hw_i2c_ifdr_t IFDR;               /*!< [0x4] I2C Frequency Divider Register */
    uint8_t _reserved1[2];
    __IO hw_i2c_i2cr_t I2CR;               /*!< [0x8] I2C Control Register */
    uint8_t _reserved2[2];
    __IO hw_i2c_i2sr_t I2SR;               /*!< [0xC] I2C Status Register */
    uint8_t _reserved3[2];
    __IO hw_i2c_i2dr_t I2DR;               /*!< [0x10] I2C Data I/O Register */
} hw_i2c_t;
#pragma pack()

/*! @brief Macro to access all I2C registers. */
/*! @param x I2C module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_I2C_REGS(I2C1_BASE)</code>. */
#define HW_I2C_REGS(x) (*(hw_i2c_t *)(x))

/*
 * iMX6DP IOMUXC
 *
 * IOMUXC
 *
 * Registers defined in this header file:
 * - HW_IOMUXC_GPR0 - GPR
 * - HW_IOMUXC_GPR1 - GPR
 * - HW_IOMUXC_GPR2 - GPR
 * - HW_IOMUXC_GPR3 - GPR
 * - HW_IOMUXC_GPR4 - GPR
 * - HW_IOMUXC_GPR5 - GPR
 * - HW_IOMUXC_GPR6 - GPR
 * - HW_IOMUXC_GPR7 - GPR
 * - HW_IOMUXC_GPR8 - GPR
 * - HW_IOMUXC_GPR9 - GPR
 * - HW_IOMUXC_GPR10 - GPR
 * - HW_IOMUXC_GPR11 - GPR
 * - HW_IOMUXC_GPR12 - GPR
 * - HW_IOMUXC_GPR13 - GPR
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2 - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD - Pad Mux Register
 * - HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3 - Pad Mux Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3 - Pad Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B7DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7 - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B0DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B1DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B2DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B3DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B4DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B5DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_B6DS - Pad Group Control Register
 * - HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM - Pad Group Control Register
 * - HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_COL5_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_COL6_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_COL7_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_ROW5_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_ROW6_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_KEY_ROW7_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_USB_OTG_OC_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_USB_H1_OC_SELECT_INPUT - Select Input Register
 * - HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT - Select Input Register
 *
 * - hw_iomuxc_t - Struct containing all module registers.
 */

#define HW_IOMUXC_INSTANCE_COUNT (1U) /*!< Number of instances of the IOMUXC module. */
#define HW_IOMUXC (0U) /*!< Instance number for IOMUXC. */
#define IOMUXC_BASE           (0x20E0000U) /*!< Base address for IOMUXC. */
/*! Array initializer of IOMUXC base addresses. */
#define IOMUXC_BASE_ADDRS     { IOMUXC_BASE }

/*******************************************************************************
 * HW_IOMUXC_GPR0 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR0 - GPR (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_gpr0
{
    uint32_t U;
    struct _hw_iomuxc_gpr0_bitfields
    {
        uint32_t DMAREQ_MUX_SEL0 : 1;  /*!< [0]  */
        uint32_t DMAREQ_MUX_SEL1 : 1;  /*!< [1]  */
        uint32_t DMAREQ_MUX_SEL2 : 1;  /*!< [2]  */
        uint32_t DMAREQ_MUX_SEL3 : 1;  /*!< [3]  */
        uint32_t DMAREQ_MUX_SEL4 : 1;  /*!< [4]  */
        uint32_t DMAREQ_MUX_SEL5 : 1;  /*!< [5]  */
        uint32_t DMAREQ_MUX_SEL6 : 1;  /*!< [6]  */
        uint32_t DMAREQ_MUX_SEL7 : 1;  /*!< [7]  */
        uint32_t CLK_STRETCH : 2;      /*!< [9:8]  */
        uint32_t RESERVED0 : 4;        /*!< [13:10]  */
        uint32_t TX_CLK2_MUX_SEL : 2;  /*!< [15:14]  */
        uint32_t CLOCK_1_MUX_SEL : 2;  /*!< [17:16]  */
        uint32_t CLOCK_9_MUX_SEL : 2;  /*!< [19:18]  */
        uint32_t CLOCK_2_MUX_SEL : 2;  /*!< [21:20]  */
        uint32_t CLOCK_A_MUX_SEL : 2;  /*!< [23:22]  */
        uint32_t CLOCK_3_MUX_SEL : 2;  /*!< [25:24]  */
        uint32_t CLOCK_B_MUX_SEL : 2;  /*!< [27:26]  */
        uint32_t CLOCK_0_MUX_SEL : 2;  /*!< [29:28]  */
        uint32_t CLOCK_8_MUX_SEL : 2;  /*!< [31:30]  */
    } B;
} hw_iomuxc_gpr0_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR0 register
 */
/*@{*/
#define HW_IOMUXC_GPR0_ADDR(x)   ((uintptr_t)(x) + 0x0U)

#define HW_IOMUXC_GPR0(x)        (*(__IO hw_iomuxc_gpr0_t *) HW_IOMUXC_GPR0_ADDR(x))
#define HW_IOMUXC_GPR0_RD(x)     (HW_IOMUXC_GPR0(x).U)
#define HW_IOMUXC_GPR0_WR(x, v)  (HW_IOMUXC_GPR0(x).U = (v))
#define HW_IOMUXC_GPR0_SET(x, v) (HW_IOMUXC_GPR0_WR(x, HW_IOMUXC_GPR0_RD(x) |  (v)))
#define HW_IOMUXC_GPR0_CLR(x, v) (HW_IOMUXC_GPR0_WR(x, HW_IOMUXC_GPR0_RD(x) & ~(v)))
#define HW_IOMUXC_GPR0_TOG(x, v) (HW_IOMUXC_GPR0_WR(x, HW_IOMUXC_GPR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR0 bitfields
 */

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL0[0] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[2]:
 *
 * Values:
 * - 0 - ipu1.ipu_sdma_event
 * - 1 - hdmi_tx.hdmi_tx_ophydtb[0]
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL0 (0U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL0. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL0 (0x00000001U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL0. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL0 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL0. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL0 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL0(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL0)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL0. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL0) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL0)

/*! @brief Set the DMAREQ_MUX_SEL0 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL0(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL0) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL1[1] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[3]:
 *
 * Values:
 * - 0 - ecspi1.ipd_req_cspi_rdma_b
 * - 1 - i2c3.ipi_int_b
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL1 (1U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL1. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL1 (0x00000002U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL1. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL1 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL1. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL1 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL1(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL1)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL1. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL1) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL1)

/*! @brief Set the DMAREQ_MUX_SEL1 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL1(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL1) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL2[2] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[4]:
 *
 * Values:
 * - 0 - ecspi1.ipd_req_cspi_tdma_b
 * - 1 - i2c2.ipi_int_b
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL2 (2U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL2. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL2 (0x00000004U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL2. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL2 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL2. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL2 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL2(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL2)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL2. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL2(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL2) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL2)

/*! @brief Set the DMAREQ_MUX_SEL2 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL2(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL2) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL2(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL3[3] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[5]:
 *
 * Values:
 * - 0 - ecspi2.ipd_req_cspi_rdma_b
 * - 1 - i2c1.ipi_int_b
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL3 (3U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL3. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL3 (0x00000008U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL3. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL3 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL3. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL3 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL3(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL3)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL3. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL3(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL3) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL3)

/*! @brief Set the DMAREQ_MUX_SEL3 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL3(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL3) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL3(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL4[4] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[10]:
 *
 * Values:
 * - 0 - ecspi4.ipd_req_cspi_tdma_b
 * - 1 - i2c1.ipi_int_b
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL4 (4U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL4. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL4 (0x00000010U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL4. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL4 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL4. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL4 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL4(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL4)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL4. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL4(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL4) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL4)

/*! @brief Set the DMAREQ_MUX_SEL4 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL4(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL4) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL4(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL5[5] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[9]:
 *
 * Values:
 * - 0 - ecspi4.ipd_req_cspi_rdma_b
 * - 1 - epit2.ipi_int_epit_oc
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL5 (5U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL5. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL5 (0x00000020U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL5. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL5 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL5. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL5 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL5(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL5)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL5. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL5(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL5) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL5)

/*! @brief Set the DMAREQ_MUX_SEL5 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL5(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL5) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL5(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL6[6] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[23]:
 *
 * Values:
 * - 0 - esai.
 * - 1 - i2c3.ipi_int_b
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL6 (6U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL6. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL6 (0x00000040U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL6. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL6 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL6. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL6 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL6(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL6)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL6. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL6(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL6) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL6)

/*! @brief Set the DMAREQ_MUX_SEL6 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL6(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL6) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL6(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field DMAREQ_MUX_SEL7[7] (RW)
 *
 * Selects between two possible sources for SDMA_EVENT[14]:
 *
 * Values:
 * - 0 - spdif.drq0_spdif_b
 * - 1 - iomux.sdma_ext_events[1] - External DMA Request via DISP0_DAT17 or
 *     GPIO_18
 */
/*@{*/
#define BP_IOMUXC_GPR0_DMAREQ_MUX_SEL7 (7U) /*!< Bit position for IOMUXC_GPR0_DMAREQ_MUX_SEL7. */
#define BM_IOMUXC_GPR0_DMAREQ_MUX_SEL7 (0x00000080U) /*!< Bit mask for IOMUXC_GPR0_DMAREQ_MUX_SEL7. */
#define BS_IOMUXC_GPR0_DMAREQ_MUX_SEL7 (1U) /*!< Bit field size in bits for IOMUXC_GPR0_DMAREQ_MUX_SEL7. */

/*! @brief Read current value of the IOMUXC_GPR0_DMAREQ_MUX_SEL7 field. */
#define BR_IOMUXC_GPR0_DMAREQ_MUX_SEL7(x) (HW_IOMUXC_GPR0(x).B.DMAREQ_MUX_SEL7)

/*! @brief Format value for bitfield IOMUXC_GPR0_DMAREQ_MUX_SEL7. */
#define BF_IOMUXC_GPR0_DMAREQ_MUX_SEL7(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_DMAREQ_MUX_SEL7) & BM_IOMUXC_GPR0_DMAREQ_MUX_SEL7)

/*! @brief Set the DMAREQ_MUX_SEL7 field to a new value. */
#define BW_IOMUXC_GPR0_DMAREQ_MUX_SEL7(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_DMAREQ_MUX_SEL7) | BF_IOMUXC_GPR0_DMAREQ_MUX_SEL7(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLK_STRETCH[9:8] (RW)
 *
 * ENET_1588_EVENT0_OUT clock stretch
 *
 * Values:
 * - 00 - 1 clock pulse width
 * - 01 - 2 clock pulse width
 * - 10 - 3 clock pulse width
 * - 11 - 4 clock pulse width
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLK_STRETCH (8U)    /*!< Bit position for IOMUXC_GPR0_CLK_STRETCH. */
#define BM_IOMUXC_GPR0_CLK_STRETCH (0x00000300U) /*!< Bit mask for IOMUXC_GPR0_CLK_STRETCH. */
#define BS_IOMUXC_GPR0_CLK_STRETCH (2U)    /*!< Bit field size in bits for IOMUXC_GPR0_CLK_STRETCH. */

/*! @brief Read current value of the IOMUXC_GPR0_CLK_STRETCH field. */
#define BR_IOMUXC_GPR0_CLK_STRETCH(x) (HW_IOMUXC_GPR0(x).B.CLK_STRETCH)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLK_STRETCH. */
#define BF_IOMUXC_GPR0_CLK_STRETCH(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLK_STRETCH) & BM_IOMUXC_GPR0_CLK_STRETCH)

/*! @brief Set the CLK_STRETCH field to a new value. */
#define BW_IOMUXC_GPR0_CLK_STRETCH(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLK_STRETCH) | BF_IOMUXC_GPR0_CLK_STRETCH(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field TX_CLK2_MUX_SEL[15:14] (RW)
 *
 * Selects the source of tx_clk2 in SPDIF according to ASRC clock muxing scheme:
 *
 * Values:
 * - 00 - same source as for asrc.asrck_clock_1
 * - 01 - same source as for asrc.asrck_clock_2
 * - 10 - same source as for asrc.asrck_clock_3
 * - 11 - Reserved
 */
/*@{*/
#define BP_IOMUXC_GPR0_TX_CLK2_MUX_SEL (14U) /*!< Bit position for IOMUXC_GPR0_TX_CLK2_MUX_SEL. */
#define BM_IOMUXC_GPR0_TX_CLK2_MUX_SEL (0x0000C000U) /*!< Bit mask for IOMUXC_GPR0_TX_CLK2_MUX_SEL. */
#define BS_IOMUXC_GPR0_TX_CLK2_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_TX_CLK2_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_TX_CLK2_MUX_SEL field. */
#define BR_IOMUXC_GPR0_TX_CLK2_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.TX_CLK2_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_TX_CLK2_MUX_SEL. */
#define BF_IOMUXC_GPR0_TX_CLK2_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_TX_CLK2_MUX_SEL) & BM_IOMUXC_GPR0_TX_CLK2_MUX_SEL)

/*! @brief Set the TX_CLK2_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_TX_CLK2_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_TX_CLK2_MUX_SEL) | BF_IOMUXC_GPR0_TX_CLK2_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_1_MUX_SEL[17:16] (RW)
 *
 * Selects the source of asrck_clock_1 in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_rxclk_p1 muxed with ssi1.ssi_srck
 * - 01 - audmux.amx_output_rxclk_p1
 * - 10 - ssi1.ssi_srck
 * - 11 - ssi1.rx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_1_MUX_SEL (16U) /*!< Bit position for IOMUXC_GPR0_CLOCK_1_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_1_MUX_SEL (0x00030000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_1_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_1_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_1_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_1_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_1_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_1_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_1_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_1_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_1_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_1_MUX_SEL)

/*! @brief Set the CLOCK_1_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_1_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_1_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_1_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_9_MUX_SEL[19:18] (RW)
 *
 * Selects the source of asrck_clock_9 in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_txclk_p1 muxed with ssi1.ssi_stck
 * - 01 - audmux.amx_output_txclk_p1
 * - 10 - ssi1.ssi_stck
 * - 11 - ssi1.tx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_9_MUX_SEL (18U) /*!< Bit position for IOMUXC_GPR0_CLOCK_9_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_9_MUX_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_9_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_9_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_9_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_9_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_9_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_9_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_9_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_9_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_9_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_9_MUX_SEL)

/*! @brief Set the CLOCK_9_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_9_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_9_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_9_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_2_MUX_SEL[21:20] (RW)
 *
 * Selects the source of asrck_clock_2 in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_rxclk_p2 muxed with ssi2.ssi_srck
 * - 01 - audmux.amx_output_rxclk_p2
 * - 10 - ssi2.ssi_srck
 * - 11 - ssi2.rx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_2_MUX_SEL (20U) /*!< Bit position for IOMUXC_GPR0_CLOCK_2_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_2_MUX_SEL (0x00300000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_2_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_2_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_2_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_2_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_2_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_2_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_2_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_2_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_2_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_2_MUX_SEL)

/*! @brief Set the CLOCK_2_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_2_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_2_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_2_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_A_MUX_SEL[23:22] (RW)
 *
 * Selects the source of asrck_clock_a in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_txclk_p2 muxed with ssi2.ssi_stck
 * - 01 - audmux.amx_output_txclk_p2
 * - 10 - ssi2.ssi_stck
 * - 11 - ssi2.tx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_A_MUX_SEL (22U) /*!< Bit position for IOMUXC_GPR0_CLOCK_A_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_A_MUX_SEL (0x00C00000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_A_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_A_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_A_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_A_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_A_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_A_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_A_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_A_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_A_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_A_MUX_SEL)

/*! @brief Set the CLOCK_A_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_A_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_A_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_A_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_3_MUX_SEL[25:24] (RW)
 *
 * Selects the source of asrck_clock_3 in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_rxclk_p7 muxed with ssi3.ssi_srck
 * - 01 - audmux.amx_output_rxclk_p7
 * - 10 - ssi3.ssi_srck
 * - 11 - ssi3.rx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_3_MUX_SEL (24U) /*!< Bit position for IOMUXC_GPR0_CLOCK_3_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_3_MUX_SEL (0x03000000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_3_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_3_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_3_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_3_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_3_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_3_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_3_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_3_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_3_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_3_MUX_SEL)

/*! @brief Set the CLOCK_3_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_3_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_3_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_3_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_B_MUX_SEL[27:26] (RW)
 *
 * Selects the source of asrck_clock_b in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - audmux.amx_output_txclk_p7 muxed with ssi3.ssi_stck
 * - 01 - audmux.amx_output_txclk_p7
 * - 10 - ssi3.ssi_stck
 * - 11 - ssi3.tx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_B_MUX_SEL (26U) /*!< Bit position for IOMUXC_GPR0_CLOCK_B_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_B_MUX_SEL (0x0C000000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_B_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_B_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_B_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_B_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_B_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_B_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_B_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_B_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_B_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_B_MUX_SEL)

/*! @brief Set the CLOCK_B_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_B_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_B_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_B_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_0_MUX_SEL[29:28] (RW)
 *
 * Selects the source of asrck_clock_0 in ASRC according to clock muxing scheme:
 *
 * Values:
 * - 00 - esai.ipp_ind_sckr muxed with esai.ipp_do_sckr
 * - 01 - esai.ipp_ind_sckr
 * - 10 - esai.ipp_do_sckr
 * - 11 - Reserved
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_0_MUX_SEL (28U) /*!< Bit position for IOMUXC_GPR0_CLOCK_0_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_0_MUX_SEL (0x30000000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_0_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_0_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_0_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_0_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_0_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_0_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_0_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_0_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_0_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_0_MUX_SEL)

/*! @brief Set the CLOCK_0_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_0_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_0_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_0_MUX_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR0, field CLOCK_8_MUX_SEL[31:30] (RW)
 *
 * Selects the source of asrck_clock_8 in ASRC according to clock muxing scheme
 *
 * Values:
 * - 00 - audmux.amx_output_rxclk_p7 muxed with ssi3.ssi_srck
 * - 01 - audmux.amx_output_rxclk_p7
 * - 10 - ssi3.ssi_srck
 * - 11 - ssi3.rx_bit_clk
 */
/*@{*/
#define BP_IOMUXC_GPR0_CLOCK_8_MUX_SEL (30U) /*!< Bit position for IOMUXC_GPR0_CLOCK_8_MUX_SEL. */
#define BM_IOMUXC_GPR0_CLOCK_8_MUX_SEL (0xC0000000U) /*!< Bit mask for IOMUXC_GPR0_CLOCK_8_MUX_SEL. */
#define BS_IOMUXC_GPR0_CLOCK_8_MUX_SEL (2U) /*!< Bit field size in bits for IOMUXC_GPR0_CLOCK_8_MUX_SEL. */

/*! @brief Read current value of the IOMUXC_GPR0_CLOCK_8_MUX_SEL field. */
#define BR_IOMUXC_GPR0_CLOCK_8_MUX_SEL(x) (HW_IOMUXC_GPR0(x).B.CLOCK_8_MUX_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR0_CLOCK_8_MUX_SEL. */
#define BF_IOMUXC_GPR0_CLOCK_8_MUX_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR0_CLOCK_8_MUX_SEL) & BM_IOMUXC_GPR0_CLOCK_8_MUX_SEL)

/*! @brief Set the CLOCK_8_MUX_SEL field to a new value. */
#define BW_IOMUXC_GPR0_CLOCK_8_MUX_SEL(x, v) (HW_IOMUXC_GPR0_WR(x, (HW_IOMUXC_GPR0_RD(x) & ~BM_IOMUXC_GPR0_CLOCK_8_MUX_SEL) | BF_IOMUXC_GPR0_CLOCK_8_MUX_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR1 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR1 - GPR (RW)
 *
 * Reset value: 0x68400005U
 */
typedef union _hw_iomuxc_gpr1
{
    uint32_t U;
    struct _hw_iomuxc_gpr1_bitfields
    {
        uint32_t ACT_CS0 : 1;          /*!< [0]  */
        uint32_t ADDRS0 : 2;           /*!< [2:1]  */
        uint32_t ACT_CS1 : 1;          /*!< [3]  */
        uint32_t ADDRS1 : 2;           /*!< [5:4]  */
        uint32_t ACT_CS2 : 1;          /*!< [6]  */
        uint32_t ADDRS2 : 2;           /*!< [8:7]  */
        uint32_t ACT_CS3 : 1;          /*!< [9]  */
        uint32_t ADDRS3 : 2;           /*!< [11:10]  */
        uint32_t GINT : 1;             /*!< [12]  */
        uint32_t USB_OTG_ID_SEL : 1;   /*!< [13]  */
        uint32_t SYS_INT : 1;          /*!< [14]  */
        uint32_t USB_EXP_MODE : 1;     /*!< [15]  */
        uint32_t REF_SSP_EN : 1;       /*!< [16]  */
        uint32_t IPU_VPU_MUX : 1;      /*!< [17]  */
        uint32_t TEST_POWERDOWN : 1;   /*!< [18]  */
        uint32_t MIPI_IPU1_MUX : 1;    /*!< [19]  */
        uint32_t MIPI_IPU2_MUX : 1;    /*!< [20]  */
        uint32_t ENET_CLK_SEL : 1;     /*!< [21]  */
        uint32_t EXC_MON : 1;          /*!< [22]  */
        uint32_t PCIE_SW_PERST : 1;    /*!< [23]  */
        uint32_t MIPI_DPI_OFF : 1;     /*!< [24]  */
        uint32_t MIPI_COLOR_SW : 1;    /*!< [25]  */
        uint32_t APP_REQ_ENTR_L1 : 1;  /*!< [26]  */
        uint32_t APP_READY_ENTR_L23 : 1; /*!< [27]  */
        uint32_t APP_REQ_EXIT_L1 : 1;  /*!< [28]  */
        uint32_t PCIE_SW_RST : 1;      /*!< [29]  */
        uint32_t APP_CLK_REQ_N : 1;    /*!< [30]  */
        uint32_t CFG_L1_CLK_REMOVAL_EN : 1; /*!< [31]  */
    } B;
} hw_iomuxc_gpr1_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR1 register
 */
/*@{*/
#define HW_IOMUXC_GPR1_ADDR(x)   ((uintptr_t)(x) + 0x4U)

#define HW_IOMUXC_GPR1(x)        (*(__IO hw_iomuxc_gpr1_t *) HW_IOMUXC_GPR1_ADDR(x))
#define HW_IOMUXC_GPR1_RD(x)     (HW_IOMUXC_GPR1(x).U)
#define HW_IOMUXC_GPR1_WR(x, v)  (HW_IOMUXC_GPR1(x).U = (v))
#define HW_IOMUXC_GPR1_SET(x, v) (HW_IOMUXC_GPR1_WR(x, HW_IOMUXC_GPR1_RD(x) |  (v)))
#define HW_IOMUXC_GPR1_CLR(x, v) (HW_IOMUXC_GPR1_WR(x, HW_IOMUXC_GPR1_RD(x) & ~(v)))
#define HW_IOMUXC_GPR1_TOG(x, v) (HW_IOMUXC_GPR1_WR(x, HW_IOMUXC_GPR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR1 bitfields
 */

/*!
 * @name Register IOMUXC_GPR1, field ACT_CS0[0] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ACT_CS0 (0U)        /*!< Bit position for IOMUXC_GPR1_ACT_CS0. */
#define BM_IOMUXC_GPR1_ACT_CS0 (0x00000001U) /*!< Bit mask for IOMUXC_GPR1_ACT_CS0. */
#define BS_IOMUXC_GPR1_ACT_CS0 (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_ACT_CS0. */

/*! @brief Read current value of the IOMUXC_GPR1_ACT_CS0 field. */
#define BR_IOMUXC_GPR1_ACT_CS0(x) (HW_IOMUXC_GPR1(x).B.ACT_CS0)

/*! @brief Format value for bitfield IOMUXC_GPR1_ACT_CS0. */
#define BF_IOMUXC_GPR1_ACT_CS0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ACT_CS0) & BM_IOMUXC_GPR1_ACT_CS0)

/*! @brief Set the ACT_CS0 field to a new value. */
#define BW_IOMUXC_GPR1_ACT_CS0(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ACT_CS0) | BF_IOMUXC_GPR1_ACT_CS0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ADDRS0[2:1] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ADDRS0 (1U)         /*!< Bit position for IOMUXC_GPR1_ADDRS0. */
#define BM_IOMUXC_GPR1_ADDRS0 (0x00000006U) /*!< Bit mask for IOMUXC_GPR1_ADDRS0. */
#define BS_IOMUXC_GPR1_ADDRS0 (2U)         /*!< Bit field size in bits for IOMUXC_GPR1_ADDRS0. */

/*! @brief Read current value of the IOMUXC_GPR1_ADDRS0 field. */
#define BR_IOMUXC_GPR1_ADDRS0(x) (HW_IOMUXC_GPR1(x).B.ADDRS0)

/*! @brief Format value for bitfield IOMUXC_GPR1_ADDRS0. */
#define BF_IOMUXC_GPR1_ADDRS0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ADDRS0) & BM_IOMUXC_GPR1_ADDRS0)

/*! @brief Set the ADDRS0 field to a new value. */
#define BW_IOMUXC_GPR1_ADDRS0(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ADDRS0) | BF_IOMUXC_GPR1_ADDRS0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ACT_CS1[3] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ACT_CS1 (3U)        /*!< Bit position for IOMUXC_GPR1_ACT_CS1. */
#define BM_IOMUXC_GPR1_ACT_CS1 (0x00000008U) /*!< Bit mask for IOMUXC_GPR1_ACT_CS1. */
#define BS_IOMUXC_GPR1_ACT_CS1 (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_ACT_CS1. */

/*! @brief Read current value of the IOMUXC_GPR1_ACT_CS1 field. */
#define BR_IOMUXC_GPR1_ACT_CS1(x) (HW_IOMUXC_GPR1(x).B.ACT_CS1)

/*! @brief Format value for bitfield IOMUXC_GPR1_ACT_CS1. */
#define BF_IOMUXC_GPR1_ACT_CS1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ACT_CS1) & BM_IOMUXC_GPR1_ACT_CS1)

/*! @brief Set the ACT_CS1 field to a new value. */
#define BW_IOMUXC_GPR1_ACT_CS1(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ACT_CS1) | BF_IOMUXC_GPR1_ACT_CS1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ADDRS1[5:4] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ADDRS1 (4U)         /*!< Bit position for IOMUXC_GPR1_ADDRS1. */
#define BM_IOMUXC_GPR1_ADDRS1 (0x00000030U) /*!< Bit mask for IOMUXC_GPR1_ADDRS1. */
#define BS_IOMUXC_GPR1_ADDRS1 (2U)         /*!< Bit field size in bits for IOMUXC_GPR1_ADDRS1. */

/*! @brief Read current value of the IOMUXC_GPR1_ADDRS1 field. */
#define BR_IOMUXC_GPR1_ADDRS1(x) (HW_IOMUXC_GPR1(x).B.ADDRS1)

/*! @brief Format value for bitfield IOMUXC_GPR1_ADDRS1. */
#define BF_IOMUXC_GPR1_ADDRS1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ADDRS1) & BM_IOMUXC_GPR1_ADDRS1)

/*! @brief Set the ADDRS1 field to a new value. */
#define BW_IOMUXC_GPR1_ADDRS1(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ADDRS1) | BF_IOMUXC_GPR1_ADDRS1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ACT_CS2[6] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ACT_CS2 (6U)        /*!< Bit position for IOMUXC_GPR1_ACT_CS2. */
#define BM_IOMUXC_GPR1_ACT_CS2 (0x00000040U) /*!< Bit mask for IOMUXC_GPR1_ACT_CS2. */
#define BS_IOMUXC_GPR1_ACT_CS2 (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_ACT_CS2. */

/*! @brief Read current value of the IOMUXC_GPR1_ACT_CS2 field. */
#define BR_IOMUXC_GPR1_ACT_CS2(x) (HW_IOMUXC_GPR1(x).B.ACT_CS2)

/*! @brief Format value for bitfield IOMUXC_GPR1_ACT_CS2. */
#define BF_IOMUXC_GPR1_ACT_CS2(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ACT_CS2) & BM_IOMUXC_GPR1_ACT_CS2)

/*! @brief Set the ACT_CS2 field to a new value. */
#define BW_IOMUXC_GPR1_ACT_CS2(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ACT_CS2) | BF_IOMUXC_GPR1_ACT_CS2(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ADDRS2[8:7] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ADDRS2 (7U)         /*!< Bit position for IOMUXC_GPR1_ADDRS2. */
#define BM_IOMUXC_GPR1_ADDRS2 (0x00000180U) /*!< Bit mask for IOMUXC_GPR1_ADDRS2. */
#define BS_IOMUXC_GPR1_ADDRS2 (2U)         /*!< Bit field size in bits for IOMUXC_GPR1_ADDRS2. */

/*! @brief Read current value of the IOMUXC_GPR1_ADDRS2 field. */
#define BR_IOMUXC_GPR1_ADDRS2(x) (HW_IOMUXC_GPR1(x).B.ADDRS2)

/*! @brief Format value for bitfield IOMUXC_GPR1_ADDRS2. */
#define BF_IOMUXC_GPR1_ADDRS2(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ADDRS2) & BM_IOMUXC_GPR1_ADDRS2)

/*! @brief Set the ADDRS2 field to a new value. */
#define BW_IOMUXC_GPR1_ADDRS2(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ADDRS2) | BF_IOMUXC_GPR1_ADDRS2(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ACT_CS3[9] (RW)
 *
 * See description for ADDRS3[10]
 */
/*@{*/
#define BP_IOMUXC_GPR1_ACT_CS3 (9U)        /*!< Bit position for IOMUXC_GPR1_ACT_CS3. */
#define BM_IOMUXC_GPR1_ACT_CS3 (0x00000200U) /*!< Bit mask for IOMUXC_GPR1_ACT_CS3. */
#define BS_IOMUXC_GPR1_ACT_CS3 (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_ACT_CS3. */

/*! @brief Read current value of the IOMUXC_GPR1_ACT_CS3 field. */
#define BR_IOMUXC_GPR1_ACT_CS3(x) (HW_IOMUXC_GPR1(x).B.ACT_CS3)

/*! @brief Format value for bitfield IOMUXC_GPR1_ACT_CS3. */
#define BF_IOMUXC_GPR1_ACT_CS3(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ACT_CS3) & BM_IOMUXC_GPR1_ACT_CS3)

/*! @brief Set the ACT_CS3 field to a new value. */
#define BW_IOMUXC_GPR1_ACT_CS3(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ACT_CS3) | BF_IOMUXC_GPR1_ACT_CS3(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ADDRS3[11:10] (RW)
 *
 * Active Chip Select and Address Space. Each of the ACT_CSx represents one of
 * the four chip selects of the EIM. When ACT_CSx=1'b1, the corresponding chip
 * select is active and has a valid address space according to its address space
 * configuration determined by ADDRSx[10] bits ADDRSx[10] is setting the space for
 * each chip select which is active. The address space of the first active chip
 * select must be the largest one, the following active chip select address spaces
 * may be equal or smaller. Total address space size is 128 MByte. The supported
 * configurations are: CS0(128M), CS1 (0M), CS2 (0M), CS3(0M) [default
 * configuration] CS0(64M), CS1(64M), CS2(0M), CS3(0M) CS0(64M), CS1(32M), CS2(32M),
 * CS3(0M) CS0(32M), CS1(32M), CS2(32M), CS3(32M) Address Space Configuration options
 * (ADDRSx[10]):
 *
 * Values:
 * - 00 - 32 MByte
 * - 01 - 64 MByte
 * - 10 - 128 MByte
 * - 11 - Reserved
 */
/*@{*/
#define BP_IOMUXC_GPR1_ADDRS3 (10U)        /*!< Bit position for IOMUXC_GPR1_ADDRS3. */
#define BM_IOMUXC_GPR1_ADDRS3 (0x00000C00U) /*!< Bit mask for IOMUXC_GPR1_ADDRS3. */
#define BS_IOMUXC_GPR1_ADDRS3 (2U)         /*!< Bit field size in bits for IOMUXC_GPR1_ADDRS3. */

/*! @brief Read current value of the IOMUXC_GPR1_ADDRS3 field. */
#define BR_IOMUXC_GPR1_ADDRS3(x) (HW_IOMUXC_GPR1(x).B.ADDRS3)

/*! @brief Format value for bitfield IOMUXC_GPR1_ADDRS3. */
#define BF_IOMUXC_GPR1_ADDRS3(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ADDRS3) & BM_IOMUXC_GPR1_ADDRS3)

/*! @brief Set the ADDRS3 field to a new value. */
#define BW_IOMUXC_GPR1_ADDRS3(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ADDRS3) | BF_IOMUXC_GPR1_ADDRS3(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field GINT[12] (RW)
 *
 * Global interrupt "0" bit (connected to ARM IRQ#0 and GPC)
 *
 * Values:
 * - 0 - Global interrupt request is not asserted
 * - 1 - Global interrupt request is asserted
 */
/*@{*/
#define BP_IOMUXC_GPR1_GINT  (12U)         /*!< Bit position for IOMUXC_GPR1_GINT. */
#define BM_IOMUXC_GPR1_GINT  (0x00001000U) /*!< Bit mask for IOMUXC_GPR1_GINT. */
#define BS_IOMUXC_GPR1_GINT  (1U)          /*!< Bit field size in bits for IOMUXC_GPR1_GINT. */

/*! @brief Read current value of the IOMUXC_GPR1_GINT field. */
#define BR_IOMUXC_GPR1_GINT(x) (HW_IOMUXC_GPR1(x).B.GINT)

/*! @brief Format value for bitfield IOMUXC_GPR1_GINT. */
#define BF_IOMUXC_GPR1_GINT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_GINT) & BM_IOMUXC_GPR1_GINT)

/*! @brief Set the GINT field to a new value. */
#define BW_IOMUXC_GPR1_GINT(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_GINT) | BF_IOMUXC_GPR1_GINT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field USB_OTG_ID_SEL[13] (RW)
 *
 * ''usb_otg_id' pin iomux select control. (It functions as the 'daisy chain'
 * mux control)
 *
 * Values:
 * - 0 - selects ENET_RX_ER
 * - 1 - selects GPIO_1.
 */
/*@{*/
#define BP_IOMUXC_GPR1_USB_OTG_ID_SEL (13U) /*!< Bit position for IOMUXC_GPR1_USB_OTG_ID_SEL. */
#define BM_IOMUXC_GPR1_USB_OTG_ID_SEL (0x00002000U) /*!< Bit mask for IOMUXC_GPR1_USB_OTG_ID_SEL. */
#define BS_IOMUXC_GPR1_USB_OTG_ID_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR1_USB_OTG_ID_SEL. */

/*! @brief Read current value of the IOMUXC_GPR1_USB_OTG_ID_SEL field. */
#define BR_IOMUXC_GPR1_USB_OTG_ID_SEL(x) (HW_IOMUXC_GPR1(x).B.USB_OTG_ID_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR1_USB_OTG_ID_SEL. */
#define BF_IOMUXC_GPR1_USB_OTG_ID_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_USB_OTG_ID_SEL) & BM_IOMUXC_GPR1_USB_OTG_ID_SEL)

/*! @brief Set the USB_OTG_ID_SEL field to a new value. */
#define BW_IOMUXC_GPR1_USB_OTG_ID_SEL(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_USB_OTG_ID_SEL) | BF_IOMUXC_GPR1_USB_OTG_ID_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field SYS_INT[14] (RW)
 *
 * PCIe_CTL - When SYS_INT goes from low to high, the core generates an
 * Assert_INTx Message. When sys_int goes from high to low, the core generates a
 * Deassert_INTx Message.
 *
 * Values:
 * - 0 - PCIe system interrupt request is not asserted
 * - 1 - PCIe system interrupt request is asserted
 */
/*@{*/
#define BP_IOMUXC_GPR1_SYS_INT (14U)       /*!< Bit position for IOMUXC_GPR1_SYS_INT. */
#define BM_IOMUXC_GPR1_SYS_INT (0x00004000U) /*!< Bit mask for IOMUXC_GPR1_SYS_INT. */
#define BS_IOMUXC_GPR1_SYS_INT (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_SYS_INT. */

/*! @brief Read current value of the IOMUXC_GPR1_SYS_INT field. */
#define BR_IOMUXC_GPR1_SYS_INT(x) (HW_IOMUXC_GPR1(x).B.SYS_INT)

/*! @brief Format value for bitfield IOMUXC_GPR1_SYS_INT. */
#define BF_IOMUXC_GPR1_SYS_INT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_SYS_INT) & BM_IOMUXC_GPR1_SYS_INT)

/*! @brief Set the SYS_INT field to a new value. */
#define BW_IOMUXC_GPR1_SYS_INT(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_SYS_INT) | BF_IOMUXC_GPR1_SYS_INT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field USB_EXP_MODE[15] (RW)
 *
 * USB Exposure mode
 *
 * Values:
 * - 0 - Exposure mode is disabled.
 * - 1 - Exposure mode is enabled.
 */
/*@{*/
#define BP_IOMUXC_GPR1_USB_EXP_MODE (15U)  /*!< Bit position for IOMUXC_GPR1_USB_EXP_MODE. */
#define BM_IOMUXC_GPR1_USB_EXP_MODE (0x00008000U) /*!< Bit mask for IOMUXC_GPR1_USB_EXP_MODE. */
#define BS_IOMUXC_GPR1_USB_EXP_MODE (1U)   /*!< Bit field size in bits for IOMUXC_GPR1_USB_EXP_MODE. */

/*! @brief Read current value of the IOMUXC_GPR1_USB_EXP_MODE field. */
#define BR_IOMUXC_GPR1_USB_EXP_MODE(x) (HW_IOMUXC_GPR1(x).B.USB_EXP_MODE)

/*! @brief Format value for bitfield IOMUXC_GPR1_USB_EXP_MODE. */
#define BF_IOMUXC_GPR1_USB_EXP_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_USB_EXP_MODE) & BM_IOMUXC_GPR1_USB_EXP_MODE)

/*! @brief Set the USB_EXP_MODE field to a new value. */
#define BW_IOMUXC_GPR1_USB_EXP_MODE(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_USB_EXP_MODE) | BF_IOMUXC_GPR1_USB_EXP_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field REF_SSP_EN[16] (RW)
 *
 * PCIe_PHY - Reference Clock Enable for SS function. Function: Enables the
 * reference clock to the prescaler. The phy_ref_ssp_en signal must remain deasserted
 * until the reference clock is running at the appropriate frequency, at which
 * point phy_ref_ssp_en can be asserted. For lower power states, phy_ref_ssp_en
 * can also be deasserted.
 *
 * Values:
 * - 0 - PCIe PHY reference clock is disabled
 * - 1 - PCIe PHY reference clock is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR1_REF_SSP_EN (16U)    /*!< Bit position for IOMUXC_GPR1_REF_SSP_EN. */
#define BM_IOMUXC_GPR1_REF_SSP_EN (0x00010000U) /*!< Bit mask for IOMUXC_GPR1_REF_SSP_EN. */
#define BS_IOMUXC_GPR1_REF_SSP_EN (1U)     /*!< Bit field size in bits for IOMUXC_GPR1_REF_SSP_EN. */

/*! @brief Read current value of the IOMUXC_GPR1_REF_SSP_EN field. */
#define BR_IOMUXC_GPR1_REF_SSP_EN(x) (HW_IOMUXC_GPR1(x).B.REF_SSP_EN)

/*! @brief Format value for bitfield IOMUXC_GPR1_REF_SSP_EN. */
#define BF_IOMUXC_GPR1_REF_SSP_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_REF_SSP_EN) & BM_IOMUXC_GPR1_REF_SSP_EN)

/*! @brief Set the REF_SSP_EN field to a new value. */
#define BW_IOMUXC_GPR1_REF_SSP_EN(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_REF_SSP_EN) | BF_IOMUXC_GPR1_REF_SSP_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field IPU_VPU_MUX[17] (RW)
 *
 * IPU-1/IPU-2 to VPU signals control. This control selects between IPU-1 and
 * IPU-2 outputs that are going to the VPU (current buffer, new frame, end of line)
 *
 * Values:
 * - 0 - IPU-1 is selected
 * - 1 - IPU-2 is selected
 */
/*@{*/
#define BP_IOMUXC_GPR1_IPU_VPU_MUX (17U)   /*!< Bit position for IOMUXC_GPR1_IPU_VPU_MUX. */
#define BM_IOMUXC_GPR1_IPU_VPU_MUX (0x00020000U) /*!< Bit mask for IOMUXC_GPR1_IPU_VPU_MUX. */
#define BS_IOMUXC_GPR1_IPU_VPU_MUX (1U)    /*!< Bit field size in bits for IOMUXC_GPR1_IPU_VPU_MUX. */

/*! @brief Read current value of the IOMUXC_GPR1_IPU_VPU_MUX field. */
#define BR_IOMUXC_GPR1_IPU_VPU_MUX(x) (HW_IOMUXC_GPR1(x).B.IPU_VPU_MUX)

/*! @brief Format value for bitfield IOMUXC_GPR1_IPU_VPU_MUX. */
#define BF_IOMUXC_GPR1_IPU_VPU_MUX(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_IPU_VPU_MUX) & BM_IOMUXC_GPR1_IPU_VPU_MUX)

/*! @brief Set the IPU_VPU_MUX field to a new value. */
#define BW_IOMUXC_GPR1_IPU_VPU_MUX(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_IPU_VPU_MUX) | BF_IOMUXC_GPR1_IPU_VPU_MUX(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field TEST_POWERDOWN[18] (RW)
 *
 * PCIe_PHY - All Circuits Power-Down Control Function: Powers down all
 * circuitry in the PHY for IDDQ testing.
 *
 * Values:
 * - 0 - Power down is not requested
 * - 1 - Power down is requested
 */
/*@{*/
#define BP_IOMUXC_GPR1_TEST_POWERDOWN (18U) /*!< Bit position for IOMUXC_GPR1_TEST_POWERDOWN. */
#define BM_IOMUXC_GPR1_TEST_POWERDOWN (0x00040000U) /*!< Bit mask for IOMUXC_GPR1_TEST_POWERDOWN. */
#define BS_IOMUXC_GPR1_TEST_POWERDOWN (1U) /*!< Bit field size in bits for IOMUXC_GPR1_TEST_POWERDOWN. */

/*! @brief Read current value of the IOMUXC_GPR1_TEST_POWERDOWN field. */
#define BR_IOMUXC_GPR1_TEST_POWERDOWN(x) (HW_IOMUXC_GPR1(x).B.TEST_POWERDOWN)

/*! @brief Format value for bitfield IOMUXC_GPR1_TEST_POWERDOWN. */
#define BF_IOMUXC_GPR1_TEST_POWERDOWN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_TEST_POWERDOWN) & BM_IOMUXC_GPR1_TEST_POWERDOWN)

/*! @brief Set the TEST_POWERDOWN field to a new value. */
#define BW_IOMUXC_GPR1_TEST_POWERDOWN(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_TEST_POWERDOWN) | BF_IOMUXC_GPR1_TEST_POWERDOWN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field MIPI_IPU1_MUX[19] (RW)
 *
 * MIPI sensor to IPU-1 mux control
 *
 * Values:
 * - 0 - Enable mipi to IPU1 CSI0 - virtual channel is fixed to 0.
 * - 1 - Enable parallel interface to IPU1 CSI0.
 */
/*@{*/
#define BP_IOMUXC_GPR1_MIPI_IPU1_MUX (19U) /*!< Bit position for IOMUXC_GPR1_MIPI_IPU1_MUX. */
#define BM_IOMUXC_GPR1_MIPI_IPU1_MUX (0x00080000U) /*!< Bit mask for IOMUXC_GPR1_MIPI_IPU1_MUX. */
#define BS_IOMUXC_GPR1_MIPI_IPU1_MUX (1U)  /*!< Bit field size in bits for IOMUXC_GPR1_MIPI_IPU1_MUX. */

/*! @brief Read current value of the IOMUXC_GPR1_MIPI_IPU1_MUX field. */
#define BR_IOMUXC_GPR1_MIPI_IPU1_MUX(x) (HW_IOMUXC_GPR1(x).B.MIPI_IPU1_MUX)

/*! @brief Format value for bitfield IOMUXC_GPR1_MIPI_IPU1_MUX. */
#define BF_IOMUXC_GPR1_MIPI_IPU1_MUX(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_MIPI_IPU1_MUX) & BM_IOMUXC_GPR1_MIPI_IPU1_MUX)

/*! @brief Set the MIPI_IPU1_MUX field to a new value. */
#define BW_IOMUXC_GPR1_MIPI_IPU1_MUX(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_MIPI_IPU1_MUX) | BF_IOMUXC_GPR1_MIPI_IPU1_MUX(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field MIPI_IPU2_MUX[20] (RW)
 *
 * MIPI sensor to IPU-2 mux control
 *
 * Values:
 * - 0 - Enable mipi to IPU2 CSI1 - virtual channel is fixed to 3.
 * - 1 - Enable parallel interface to IPU2 CSI1.
 */
/*@{*/
#define BP_IOMUXC_GPR1_MIPI_IPU2_MUX (20U) /*!< Bit position for IOMUXC_GPR1_MIPI_IPU2_MUX. */
#define BM_IOMUXC_GPR1_MIPI_IPU2_MUX (0x00100000U) /*!< Bit mask for IOMUXC_GPR1_MIPI_IPU2_MUX. */
#define BS_IOMUXC_GPR1_MIPI_IPU2_MUX (1U)  /*!< Bit field size in bits for IOMUXC_GPR1_MIPI_IPU2_MUX. */

/*! @brief Read current value of the IOMUXC_GPR1_MIPI_IPU2_MUX field. */
#define BR_IOMUXC_GPR1_MIPI_IPU2_MUX(x) (HW_IOMUXC_GPR1(x).B.MIPI_IPU2_MUX)

/*! @brief Format value for bitfield IOMUXC_GPR1_MIPI_IPU2_MUX. */
#define BF_IOMUXC_GPR1_MIPI_IPU2_MUX(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_MIPI_IPU2_MUX) & BM_IOMUXC_GPR1_MIPI_IPU2_MUX)

/*! @brief Set the MIPI_IPU2_MUX field to a new value. */
#define BW_IOMUXC_GPR1_MIPI_IPU2_MUX(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_MIPI_IPU2_MUX) | BF_IOMUXC_GPR1_MIPI_IPU2_MUX(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field ENET_CLK_SEL[21] (RW)
 *
 * ENET TX reference clock
 *
 * Values:
 * - 0 - get enet tx reference clk from pad (external OSC for both external PHY
 *     and Internal Controller)
 * - 1 - get enet tx reference clk from internal clock from anatop (loopback
 *     through pad), this clock also sent out to external PHY
 */
/*@{*/
#define BP_IOMUXC_GPR1_ENET_CLK_SEL (21U)  /*!< Bit position for IOMUXC_GPR1_ENET_CLK_SEL. */
#define BM_IOMUXC_GPR1_ENET_CLK_SEL (0x00200000U) /*!< Bit mask for IOMUXC_GPR1_ENET_CLK_SEL. */
#define BS_IOMUXC_GPR1_ENET_CLK_SEL (1U)   /*!< Bit field size in bits for IOMUXC_GPR1_ENET_CLK_SEL. */

/*! @brief Read current value of the IOMUXC_GPR1_ENET_CLK_SEL field. */
#define BR_IOMUXC_GPR1_ENET_CLK_SEL(x) (HW_IOMUXC_GPR1(x).B.ENET_CLK_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR1_ENET_CLK_SEL. */
#define BF_IOMUXC_GPR1_ENET_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_ENET_CLK_SEL) & BM_IOMUXC_GPR1_ENET_CLK_SEL)

/*! @brief Set the ENET_CLK_SEL field to a new value. */
#define BW_IOMUXC_GPR1_ENET_CLK_SEL(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_ENET_CLK_SEL) | BF_IOMUXC_GPR1_ENET_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field EXC_MON[22] (RW)
 *
 * Exclusive monitor response select of illegal command (of lal gaskets, except
 * MMDC)
 *
 * Values:
 * - 0 - OKEY response
 * - 1 - SLVError (default)
 */
/*@{*/
#define BP_IOMUXC_GPR1_EXC_MON (22U)       /*!< Bit position for IOMUXC_GPR1_EXC_MON. */
#define BM_IOMUXC_GPR1_EXC_MON (0x00400000U) /*!< Bit mask for IOMUXC_GPR1_EXC_MON. */
#define BS_IOMUXC_GPR1_EXC_MON (1U)        /*!< Bit field size in bits for IOMUXC_GPR1_EXC_MON. */

/*! @brief Read current value of the IOMUXC_GPR1_EXC_MON field. */
#define BR_IOMUXC_GPR1_EXC_MON(x) (HW_IOMUXC_GPR1(x).B.EXC_MON)

/*! @brief Format value for bitfield IOMUXC_GPR1_EXC_MON. */
#define BF_IOMUXC_GPR1_EXC_MON(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_EXC_MON) & BM_IOMUXC_GPR1_EXC_MON)

/*! @brief Set the EXC_MON field to a new value. */
#define BW_IOMUXC_GPR1_EXC_MON(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_EXC_MON) | BF_IOMUXC_GPR1_EXC_MON(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field PCIE_SW_PERST[23] (RW)
 *
 * PCIe software PERST reset.
 *
 * Values:
 * - 0 - inactive
 * - 1 - active
 */
/*@{*/
#define BP_IOMUXC_GPR1_PCIE_SW_PERST (23U) /*!< Bit position for IOMUXC_GPR1_PCIE_SW_PERST. */
#define BM_IOMUXC_GPR1_PCIE_SW_PERST (0x00800000U) /*!< Bit mask for IOMUXC_GPR1_PCIE_SW_PERST. */
#define BS_IOMUXC_GPR1_PCIE_SW_PERST (1U)  /*!< Bit field size in bits for IOMUXC_GPR1_PCIE_SW_PERST. */

/*! @brief Read current value of the IOMUXC_GPR1_PCIE_SW_PERST field. */
#define BR_IOMUXC_GPR1_PCIE_SW_PERST(x) (HW_IOMUXC_GPR1(x).B.PCIE_SW_PERST)

/*! @brief Format value for bitfield IOMUXC_GPR1_PCIE_SW_PERST. */
#define BF_IOMUXC_GPR1_PCIE_SW_PERST(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_PCIE_SW_PERST) & BM_IOMUXC_GPR1_PCIE_SW_PERST)

/*! @brief Set the PCIE_SW_PERST field to a new value. */
#define BW_IOMUXC_GPR1_PCIE_SW_PERST(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_PCIE_SW_PERST) | BF_IOMUXC_GPR1_PCIE_SW_PERST(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field MIPI_DPI_OFF[24] (RW)
 *
 * MIPI DPI shutdown request
 *
 * Values:
 * - 0 - MIPI DPI shutdown request is not set
 * - 1 - MIPI DPI shutdown request is set
 */
/*@{*/
#define BP_IOMUXC_GPR1_MIPI_DPI_OFF (24U)  /*!< Bit position for IOMUXC_GPR1_MIPI_DPI_OFF. */
#define BM_IOMUXC_GPR1_MIPI_DPI_OFF (0x01000000U) /*!< Bit mask for IOMUXC_GPR1_MIPI_DPI_OFF. */
#define BS_IOMUXC_GPR1_MIPI_DPI_OFF (1U)   /*!< Bit field size in bits for IOMUXC_GPR1_MIPI_DPI_OFF. */

/*! @brief Read current value of the IOMUXC_GPR1_MIPI_DPI_OFF field. */
#define BR_IOMUXC_GPR1_MIPI_DPI_OFF(x) (HW_IOMUXC_GPR1(x).B.MIPI_DPI_OFF)

/*! @brief Format value for bitfield IOMUXC_GPR1_MIPI_DPI_OFF. */
#define BF_IOMUXC_GPR1_MIPI_DPI_OFF(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_MIPI_DPI_OFF) & BM_IOMUXC_GPR1_MIPI_DPI_OFF)

/*! @brief Set the MIPI_DPI_OFF field to a new value. */
#define BW_IOMUXC_GPR1_MIPI_DPI_OFF(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_MIPI_DPI_OFF) | BF_IOMUXC_GPR1_MIPI_DPI_OFF(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field MIPI_COLOR_SW[25] (RW)
 *
 * MIPI color switch control
 *
 * Values:
 * - 0 - MIPI color switch request is not set
 * - 1 - MIPI color switch request is set
 */
/*@{*/
#define BP_IOMUXC_GPR1_MIPI_COLOR_SW (25U) /*!< Bit position for IOMUXC_GPR1_MIPI_COLOR_SW. */
#define BM_IOMUXC_GPR1_MIPI_COLOR_SW (0x02000000U) /*!< Bit mask for IOMUXC_GPR1_MIPI_COLOR_SW. */
#define BS_IOMUXC_GPR1_MIPI_COLOR_SW (1U)  /*!< Bit field size in bits for IOMUXC_GPR1_MIPI_COLOR_SW. */

/*! @brief Read current value of the IOMUXC_GPR1_MIPI_COLOR_SW field. */
#define BR_IOMUXC_GPR1_MIPI_COLOR_SW(x) (HW_IOMUXC_GPR1(x).B.MIPI_COLOR_SW)

/*! @brief Format value for bitfield IOMUXC_GPR1_MIPI_COLOR_SW. */
#define BF_IOMUXC_GPR1_MIPI_COLOR_SW(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_MIPI_COLOR_SW) & BM_IOMUXC_GPR1_MIPI_COLOR_SW)

/*! @brief Set the MIPI_COLOR_SW field to a new value. */
#define BW_IOMUXC_GPR1_MIPI_COLOR_SW(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_MIPI_COLOR_SW) | BF_IOMUXC_GPR1_MIPI_COLOR_SW(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field APP_REQ_ENTR_L1[26] (RW)
 *
 * PCIe_CTL - Application Request to Enter L1. Request from the application to
 * enter ASPM state L1.
 *
 * Values:
 * - 0 - PCIe application request is not set
 * - 1 - PCIe application request is set
 */
/*@{*/
#define BP_IOMUXC_GPR1_APP_REQ_ENTR_L1 (26U) /*!< Bit position for IOMUXC_GPR1_APP_REQ_ENTR_L1. */
#define BM_IOMUXC_GPR1_APP_REQ_ENTR_L1 (0x04000000U) /*!< Bit mask for IOMUXC_GPR1_APP_REQ_ENTR_L1. */
#define BS_IOMUXC_GPR1_APP_REQ_ENTR_L1 (1U) /*!< Bit field size in bits for IOMUXC_GPR1_APP_REQ_ENTR_L1. */

/*! @brief Read current value of the IOMUXC_GPR1_APP_REQ_ENTR_L1 field. */
#define BR_IOMUXC_GPR1_APP_REQ_ENTR_L1(x) (HW_IOMUXC_GPR1(x).B.APP_REQ_ENTR_L1)

/*! @brief Format value for bitfield IOMUXC_GPR1_APP_REQ_ENTR_L1. */
#define BF_IOMUXC_GPR1_APP_REQ_ENTR_L1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_APP_REQ_ENTR_L1) & BM_IOMUXC_GPR1_APP_REQ_ENTR_L1)

/*! @brief Set the APP_REQ_ENTR_L1 field to a new value. */
#define BW_IOMUXC_GPR1_APP_REQ_ENTR_L1(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_APP_REQ_ENTR_L1) | BF_IOMUXC_GPR1_APP_REQ_ENTR_L1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field APP_READY_ENTR_L23[27] (RW)
 *
 * PCIe_CTL - Application Ready to Enter L23. Indication from the application
 * that it is ready to enter the L23 state.
 *
 * Values:
 * - 0 - PCIe application is not ready to enter L23
 * - 1 - PCIe application is ready to enter L23
 */
/*@{*/
#define BP_IOMUXC_GPR1_APP_READY_ENTR_L23 (27U) /*!< Bit position for IOMUXC_GPR1_APP_READY_ENTR_L23. */
#define BM_IOMUXC_GPR1_APP_READY_ENTR_L23 (0x08000000U) /*!< Bit mask for IOMUXC_GPR1_APP_READY_ENTR_L23. */
#define BS_IOMUXC_GPR1_APP_READY_ENTR_L23 (1U) /*!< Bit field size in bits for IOMUXC_GPR1_APP_READY_ENTR_L23. */

/*! @brief Read current value of the IOMUXC_GPR1_APP_READY_ENTR_L23 field. */
#define BR_IOMUXC_GPR1_APP_READY_ENTR_L23(x) (HW_IOMUXC_GPR1(x).B.APP_READY_ENTR_L23)

/*! @brief Format value for bitfield IOMUXC_GPR1_APP_READY_ENTR_L23. */
#define BF_IOMUXC_GPR1_APP_READY_ENTR_L23(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_APP_READY_ENTR_L23) & BM_IOMUXC_GPR1_APP_READY_ENTR_L23)

/*! @brief Set the APP_READY_ENTR_L23 field to a new value. */
#define BW_IOMUXC_GPR1_APP_READY_ENTR_L23(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_APP_READY_ENTR_L23) | BF_IOMUXC_GPR1_APP_READY_ENTR_L23(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field APP_REQ_EXIT_L1[28] (RW)
 *
 * PCIe_CTL - Application Request to Exit L1. Request from the application to
 * exit ASPM state L1.
 *
 * Values:
 * - 0 - PCIe application request is not set
 * - 1 - PCIe application request is set
 */
/*@{*/
#define BP_IOMUXC_GPR1_APP_REQ_EXIT_L1 (28U) /*!< Bit position for IOMUXC_GPR1_APP_REQ_EXIT_L1. */
#define BM_IOMUXC_GPR1_APP_REQ_EXIT_L1 (0x10000000U) /*!< Bit mask for IOMUXC_GPR1_APP_REQ_EXIT_L1. */
#define BS_IOMUXC_GPR1_APP_REQ_EXIT_L1 (1U) /*!< Bit field size in bits for IOMUXC_GPR1_APP_REQ_EXIT_L1. */

/*! @brief Read current value of the IOMUXC_GPR1_APP_REQ_EXIT_L1 field. */
#define BR_IOMUXC_GPR1_APP_REQ_EXIT_L1(x) (HW_IOMUXC_GPR1(x).B.APP_REQ_EXIT_L1)

/*! @brief Format value for bitfield IOMUXC_GPR1_APP_REQ_EXIT_L1. */
#define BF_IOMUXC_GPR1_APP_REQ_EXIT_L1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_APP_REQ_EXIT_L1) & BM_IOMUXC_GPR1_APP_REQ_EXIT_L1)

/*! @brief Set the APP_REQ_EXIT_L1 field to a new value. */
#define BW_IOMUXC_GPR1_APP_REQ_EXIT_L1(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_APP_REQ_EXIT_L1) | BF_IOMUXC_GPR1_APP_REQ_EXIT_L1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field PCIE_SW_RST[29] (RW)
 *
 * PCIe software reset.
 *
 * Values:
 * - 0 - inactive
 * - 1 - active
 */
/*@{*/
#define BP_IOMUXC_GPR1_PCIE_SW_RST (29U)   /*!< Bit position for IOMUXC_GPR1_PCIE_SW_RST. */
#define BM_IOMUXC_GPR1_PCIE_SW_RST (0x20000000U) /*!< Bit mask for IOMUXC_GPR1_PCIE_SW_RST. */
#define BS_IOMUXC_GPR1_PCIE_SW_RST (1U)    /*!< Bit field size in bits for IOMUXC_GPR1_PCIE_SW_RST. */

/*! @brief Read current value of the IOMUXC_GPR1_PCIE_SW_RST field. */
#define BR_IOMUXC_GPR1_PCIE_SW_RST(x) (HW_IOMUXC_GPR1(x).B.PCIE_SW_RST)

/*! @brief Format value for bitfield IOMUXC_GPR1_PCIE_SW_RST. */
#define BF_IOMUXC_GPR1_PCIE_SW_RST(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_PCIE_SW_RST) & BM_IOMUXC_GPR1_PCIE_SW_RST)

/*! @brief Set the PCIE_SW_RST field to a new value. */
#define BW_IOMUXC_GPR1_PCIE_SW_RST(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_PCIE_SW_RST) | BF_IOMUXC_GPR1_PCIE_SW_RST(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field APP_CLK_REQ_N[30] (RW)
 *
 * PCIe_CTL (CLK LOGIC CONTROLLER GLUE) - Indicates that application logic is
 * ready to have reference clock removed.
 */
/*@{*/
#define BP_IOMUXC_GPR1_APP_CLK_REQ_N (30U) /*!< Bit position for IOMUXC_GPR1_APP_CLK_REQ_N. */
#define BM_IOMUXC_GPR1_APP_CLK_REQ_N (0x40000000U) /*!< Bit mask for IOMUXC_GPR1_APP_CLK_REQ_N. */
#define BS_IOMUXC_GPR1_APP_CLK_REQ_N (1U)  /*!< Bit field size in bits for IOMUXC_GPR1_APP_CLK_REQ_N. */

/*! @brief Read current value of the IOMUXC_GPR1_APP_CLK_REQ_N field. */
#define BR_IOMUXC_GPR1_APP_CLK_REQ_N(x) (HW_IOMUXC_GPR1(x).B.APP_CLK_REQ_N)

/*! @brief Format value for bitfield IOMUXC_GPR1_APP_CLK_REQ_N. */
#define BF_IOMUXC_GPR1_APP_CLK_REQ_N(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_APP_CLK_REQ_N) & BM_IOMUXC_GPR1_APP_CLK_REQ_N)

/*! @brief Set the APP_CLK_REQ_N field to a new value. */
#define BW_IOMUXC_GPR1_APP_CLK_REQ_N(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_APP_CLK_REQ_N) | BF_IOMUXC_GPR1_APP_CLK_REQ_N(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR1, field CFG_L1_CLK_REMOVAL_EN[31] (RW)
 *
 * PCIe_CTL (CLK LOGIC CONTROLLER GLUE) - Enable the reference clock removal in
 * L1 state. This is a bit from application register.
 */
/*@{*/
#define BP_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN (31U) /*!< Bit position for IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN. */
#define BM_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN (0x80000000U) /*!< Bit mask for IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN. */
#define BS_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN. */

/*! @brief Read current value of the IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN field. */
#define BR_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN(x) (HW_IOMUXC_GPR1(x).B.CFG_L1_CLK_REMOVAL_EN)

/*! @brief Format value for bitfield IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN. */
#define BF_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN) & BM_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN)

/*! @brief Set the CFG_L1_CLK_REMOVAL_EN field to a new value. */
#define BW_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN(x, v) (HW_IOMUXC_GPR1_WR(x, (HW_IOMUXC_GPR1_RD(x) & ~BM_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN) | BF_IOMUXC_GPR1_CFG_L1_CLK_REMOVAL_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR2 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR2 - GPR (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_gpr2
{
    uint32_t U;
    struct _hw_iomuxc_gpr2_bitfields
    {
        uint32_t CH0_MODE : 2;         /*!< [1:0]  */
        uint32_t CH1_MODE : 2;         /*!< [3:2]  */
        uint32_t SPLIT_MODE_EN : 1;    /*!< [4]  */
        uint32_t DATA_WIDTH_CH0 : 1;   /*!< [5]  */
        uint32_t BIT_MAPPING_CH0 : 1;  /*!< [6]  */
        uint32_t DATA_WIDTH_CH1 : 1;   /*!< [7]  */
        uint32_t BIT_MAPPING_CH1 : 1;  /*!< [8]  */
        uint32_t DI0_VS_POLARITY : 1;  /*!< [9]  */
        uint32_t DI1_VS_POLARITY : 1;  /*!< [10]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t LVDS_CLK_SHIFT : 3;   /*!< [18:16]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t COUNTER_RESET_VAL : 2; /*!< [21:20]  */
        uint32_t RESERVED2 : 10;       /*!< [31:22]  */
    } B;
} hw_iomuxc_gpr2_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR2 register
 */
/*@{*/
#define HW_IOMUXC_GPR2_ADDR(x)   ((uintptr_t)(x) + 0x8U)

#define HW_IOMUXC_GPR2(x)        (*(__IO hw_iomuxc_gpr2_t *) HW_IOMUXC_GPR2_ADDR(x))
#define HW_IOMUXC_GPR2_RD(x)     (HW_IOMUXC_GPR2(x).U)
#define HW_IOMUXC_GPR2_WR(x, v)  (HW_IOMUXC_GPR2(x).U = (v))
#define HW_IOMUXC_GPR2_SET(x, v) (HW_IOMUXC_GPR2_WR(x, HW_IOMUXC_GPR2_RD(x) |  (v)))
#define HW_IOMUXC_GPR2_CLR(x, v) (HW_IOMUXC_GPR2_WR(x, HW_IOMUXC_GPR2_RD(x) & ~(v)))
#define HW_IOMUXC_GPR2_TOG(x, v) (HW_IOMUXC_GPR2_WR(x, HW_IOMUXC_GPR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR2 bitfields
 */

/*!
 * @name Register IOMUXC_GPR2, field CH0_MODE[1:0] (RW)
 *
 * LVDS channel 0 operation mode
 *
 * Values:
 * - 00 - Channel disabled.
 * - 01 - Channel enabled, routed to DI0
 * - 10 - Channel disabled.
 * - 11 - Channel enabled, routed to DI1.
 */
/*@{*/
#define BP_IOMUXC_GPR2_CH0_MODE (0U)       /*!< Bit position for IOMUXC_GPR2_CH0_MODE. */
#define BM_IOMUXC_GPR2_CH0_MODE (0x00000003U) /*!< Bit mask for IOMUXC_GPR2_CH0_MODE. */
#define BS_IOMUXC_GPR2_CH0_MODE (2U)       /*!< Bit field size in bits for IOMUXC_GPR2_CH0_MODE. */

/*! @brief Read current value of the IOMUXC_GPR2_CH0_MODE field. */
#define BR_IOMUXC_GPR2_CH0_MODE(x) (HW_IOMUXC_GPR2(x).B.CH0_MODE)

/*! @brief Format value for bitfield IOMUXC_GPR2_CH0_MODE. */
#define BF_IOMUXC_GPR2_CH0_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_CH0_MODE) & BM_IOMUXC_GPR2_CH0_MODE)

/*! @brief Set the CH0_MODE field to a new value. */
#define BW_IOMUXC_GPR2_CH0_MODE(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_CH0_MODE) | BF_IOMUXC_GPR2_CH0_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field CH1_MODE[3:2] (RW)
 *
 * LVDS channel 1 operation mode
 *
 * Values:
 * - 00 - Channel disabled.
 * - 01 - Channel enabled, routed to DI0
 * - 10 - Channel disabled.
 * - 11 - Channel enabled, routed to DI1.
 */
/*@{*/
#define BP_IOMUXC_GPR2_CH1_MODE (2U)       /*!< Bit position for IOMUXC_GPR2_CH1_MODE. */
#define BM_IOMUXC_GPR2_CH1_MODE (0x0000000CU) /*!< Bit mask for IOMUXC_GPR2_CH1_MODE. */
#define BS_IOMUXC_GPR2_CH1_MODE (2U)       /*!< Bit field size in bits for IOMUXC_GPR2_CH1_MODE. */

/*! @brief Read current value of the IOMUXC_GPR2_CH1_MODE field. */
#define BR_IOMUXC_GPR2_CH1_MODE(x) (HW_IOMUXC_GPR2(x).B.CH1_MODE)

/*! @brief Format value for bitfield IOMUXC_GPR2_CH1_MODE. */
#define BF_IOMUXC_GPR2_CH1_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_CH1_MODE) & BM_IOMUXC_GPR2_CH1_MODE)

/*! @brief Set the CH1_MODE field to a new value. */
#define BW_IOMUXC_GPR2_CH1_MODE(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_CH1_MODE) | BF_IOMUXC_GPR2_CH1_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field SPLIT_MODE_EN[4] (RW)
 *
 * Enable split mode.
 *
 * Values:
 * - 0 - Split mode is disabled.
 * - 1 - Split mode is enabled. In this mode both channels should be enabled and
 *     working with the same DI (ch0_mode and ch1_mode should both be either
 *     '01' or '11')
 */
/*@{*/
#define BP_IOMUXC_GPR2_SPLIT_MODE_EN (4U)  /*!< Bit position for IOMUXC_GPR2_SPLIT_MODE_EN. */
#define BM_IOMUXC_GPR2_SPLIT_MODE_EN (0x00000010U) /*!< Bit mask for IOMUXC_GPR2_SPLIT_MODE_EN. */
#define BS_IOMUXC_GPR2_SPLIT_MODE_EN (1U)  /*!< Bit field size in bits for IOMUXC_GPR2_SPLIT_MODE_EN. */

/*! @brief Read current value of the IOMUXC_GPR2_SPLIT_MODE_EN field. */
#define BR_IOMUXC_GPR2_SPLIT_MODE_EN(x) (HW_IOMUXC_GPR2(x).B.SPLIT_MODE_EN)

/*! @brief Format value for bitfield IOMUXC_GPR2_SPLIT_MODE_EN. */
#define BF_IOMUXC_GPR2_SPLIT_MODE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_SPLIT_MODE_EN) & BM_IOMUXC_GPR2_SPLIT_MODE_EN)

/*! @brief Set the SPLIT_MODE_EN field to a new value. */
#define BW_IOMUXC_GPR2_SPLIT_MODE_EN(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_SPLIT_MODE_EN) | BF_IOMUXC_GPR2_SPLIT_MODE_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field DATA_WIDTH_CH0[5] (RW)
 *
 * Data width for LVDS channel 0. This bit must be set when using JEIDA standard
 * (bit_mapping_ch0 is set)
 *
 * Values:
 * - 0 - Data width is 18 bits wide (lvds0_tx3 is not used)
 * - 1 - Data width is 24 bits wide.
 */
/*@{*/
#define BP_IOMUXC_GPR2_DATA_WIDTH_CH0 (5U) /*!< Bit position for IOMUXC_GPR2_DATA_WIDTH_CH0. */
#define BM_IOMUXC_GPR2_DATA_WIDTH_CH0 (0x00000020U) /*!< Bit mask for IOMUXC_GPR2_DATA_WIDTH_CH0. */
#define BS_IOMUXC_GPR2_DATA_WIDTH_CH0 (1U) /*!< Bit field size in bits for IOMUXC_GPR2_DATA_WIDTH_CH0. */

/*! @brief Read current value of the IOMUXC_GPR2_DATA_WIDTH_CH0 field. */
#define BR_IOMUXC_GPR2_DATA_WIDTH_CH0(x) (HW_IOMUXC_GPR2(x).B.DATA_WIDTH_CH0)

/*! @brief Format value for bitfield IOMUXC_GPR2_DATA_WIDTH_CH0. */
#define BF_IOMUXC_GPR2_DATA_WIDTH_CH0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_DATA_WIDTH_CH0) & BM_IOMUXC_GPR2_DATA_WIDTH_CH0)

/*! @brief Set the DATA_WIDTH_CH0 field to a new value. */
#define BW_IOMUXC_GPR2_DATA_WIDTH_CH0(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_DATA_WIDTH_CH0) | BF_IOMUXC_GPR2_DATA_WIDTH_CH0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field BIT_MAPPING_CH0[6] (RW)
 *
 * Data mapping for LVDS channel 0.
 *
 * Values:
 * - 0 - Use SPWG standard.
 * - 1 - Use JEIDA standard.
 */
/*@{*/
#define BP_IOMUXC_GPR2_BIT_MAPPING_CH0 (6U) /*!< Bit position for IOMUXC_GPR2_BIT_MAPPING_CH0. */
#define BM_IOMUXC_GPR2_BIT_MAPPING_CH0 (0x00000040U) /*!< Bit mask for IOMUXC_GPR2_BIT_MAPPING_CH0. */
#define BS_IOMUXC_GPR2_BIT_MAPPING_CH0 (1U) /*!< Bit field size in bits for IOMUXC_GPR2_BIT_MAPPING_CH0. */

/*! @brief Read current value of the IOMUXC_GPR2_BIT_MAPPING_CH0 field. */
#define BR_IOMUXC_GPR2_BIT_MAPPING_CH0(x) (HW_IOMUXC_GPR2(x).B.BIT_MAPPING_CH0)

/*! @brief Format value for bitfield IOMUXC_GPR2_BIT_MAPPING_CH0. */
#define BF_IOMUXC_GPR2_BIT_MAPPING_CH0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_BIT_MAPPING_CH0) & BM_IOMUXC_GPR2_BIT_MAPPING_CH0)

/*! @brief Set the BIT_MAPPING_CH0 field to a new value. */
#define BW_IOMUXC_GPR2_BIT_MAPPING_CH0(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_BIT_MAPPING_CH0) | BF_IOMUXC_GPR2_BIT_MAPPING_CH0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field DATA_WIDTH_CH1[7] (RW)
 *
 * Data width for LVDS channel 1. This bit must be set when using JEIDA standard
 * (bit_mapping_ch1 is set)
 *
 * Values:
 * - 0 - Data width is 18 bits wide (lvds1_tx3 is not used)
 * - 1 - Data width is 24 bits wide.
 */
/*@{*/
#define BP_IOMUXC_GPR2_DATA_WIDTH_CH1 (7U) /*!< Bit position for IOMUXC_GPR2_DATA_WIDTH_CH1. */
#define BM_IOMUXC_GPR2_DATA_WIDTH_CH1 (0x00000080U) /*!< Bit mask for IOMUXC_GPR2_DATA_WIDTH_CH1. */
#define BS_IOMUXC_GPR2_DATA_WIDTH_CH1 (1U) /*!< Bit field size in bits for IOMUXC_GPR2_DATA_WIDTH_CH1. */

/*! @brief Read current value of the IOMUXC_GPR2_DATA_WIDTH_CH1 field. */
#define BR_IOMUXC_GPR2_DATA_WIDTH_CH1(x) (HW_IOMUXC_GPR2(x).B.DATA_WIDTH_CH1)

/*! @brief Format value for bitfield IOMUXC_GPR2_DATA_WIDTH_CH1. */
#define BF_IOMUXC_GPR2_DATA_WIDTH_CH1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_DATA_WIDTH_CH1) & BM_IOMUXC_GPR2_DATA_WIDTH_CH1)

/*! @brief Set the DATA_WIDTH_CH1 field to a new value. */
#define BW_IOMUXC_GPR2_DATA_WIDTH_CH1(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_DATA_WIDTH_CH1) | BF_IOMUXC_GPR2_DATA_WIDTH_CH1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field BIT_MAPPING_CH1[8] (RW)
 *
 * Data mapping for LVDS channel 1.
 *
 * Values:
 * - 0 - Use SPWG standard.
 * - 1 - Use JEIDA standard.
 */
/*@{*/
#define BP_IOMUXC_GPR2_BIT_MAPPING_CH1 (8U) /*!< Bit position for IOMUXC_GPR2_BIT_MAPPING_CH1. */
#define BM_IOMUXC_GPR2_BIT_MAPPING_CH1 (0x00000100U) /*!< Bit mask for IOMUXC_GPR2_BIT_MAPPING_CH1. */
#define BS_IOMUXC_GPR2_BIT_MAPPING_CH1 (1U) /*!< Bit field size in bits for IOMUXC_GPR2_BIT_MAPPING_CH1. */

/*! @brief Read current value of the IOMUXC_GPR2_BIT_MAPPING_CH1 field. */
#define BR_IOMUXC_GPR2_BIT_MAPPING_CH1(x) (HW_IOMUXC_GPR2(x).B.BIT_MAPPING_CH1)

/*! @brief Format value for bitfield IOMUXC_GPR2_BIT_MAPPING_CH1. */
#define BF_IOMUXC_GPR2_BIT_MAPPING_CH1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_BIT_MAPPING_CH1) & BM_IOMUXC_GPR2_BIT_MAPPING_CH1)

/*! @brief Set the BIT_MAPPING_CH1 field to a new value. */
#define BW_IOMUXC_GPR2_BIT_MAPPING_CH1(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_BIT_MAPPING_CH1) | BF_IOMUXC_GPR2_BIT_MAPPING_CH1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field DI0_VS_POLARITY[9] (RW)
 *
 * Vsync polarity for IPU's DI0 interface.
 *
 * Values:
 * - 0 - ipu_di0_vsync is active high.
 * - 1 - ipu_di0_vsync is active low.
 */
/*@{*/
#define BP_IOMUXC_GPR2_DI0_VS_POLARITY (9U) /*!< Bit position for IOMUXC_GPR2_DI0_VS_POLARITY. */
#define BM_IOMUXC_GPR2_DI0_VS_POLARITY (0x00000200U) /*!< Bit mask for IOMUXC_GPR2_DI0_VS_POLARITY. */
#define BS_IOMUXC_GPR2_DI0_VS_POLARITY (1U) /*!< Bit field size in bits for IOMUXC_GPR2_DI0_VS_POLARITY. */

/*! @brief Read current value of the IOMUXC_GPR2_DI0_VS_POLARITY field. */
#define BR_IOMUXC_GPR2_DI0_VS_POLARITY(x) (HW_IOMUXC_GPR2(x).B.DI0_VS_POLARITY)

/*! @brief Format value for bitfield IOMUXC_GPR2_DI0_VS_POLARITY. */
#define BF_IOMUXC_GPR2_DI0_VS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_DI0_VS_POLARITY) & BM_IOMUXC_GPR2_DI0_VS_POLARITY)

/*! @brief Set the DI0_VS_POLARITY field to a new value. */
#define BW_IOMUXC_GPR2_DI0_VS_POLARITY(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_DI0_VS_POLARITY) | BF_IOMUXC_GPR2_DI0_VS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field DI1_VS_POLARITY[10] (RW)
 *
 * Vsync polarity for IPU's DI1 interface.
 *
 * Values:
 * - 0 - ipu_di1_vsync is active high.
 * - 1 - ipu_di1_vsync is active low.
 */
/*@{*/
#define BP_IOMUXC_GPR2_DI1_VS_POLARITY (10U) /*!< Bit position for IOMUXC_GPR2_DI1_VS_POLARITY. */
#define BM_IOMUXC_GPR2_DI1_VS_POLARITY (0x00000400U) /*!< Bit mask for IOMUXC_GPR2_DI1_VS_POLARITY. */
#define BS_IOMUXC_GPR2_DI1_VS_POLARITY (1U) /*!< Bit field size in bits for IOMUXC_GPR2_DI1_VS_POLARITY. */

/*! @brief Read current value of the IOMUXC_GPR2_DI1_VS_POLARITY field. */
#define BR_IOMUXC_GPR2_DI1_VS_POLARITY(x) (HW_IOMUXC_GPR2(x).B.DI1_VS_POLARITY)

/*! @brief Format value for bitfield IOMUXC_GPR2_DI1_VS_POLARITY. */
#define BF_IOMUXC_GPR2_DI1_VS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_DI1_VS_POLARITY) & BM_IOMUXC_GPR2_DI1_VS_POLARITY)

/*! @brief Set the DI1_VS_POLARITY field to a new value. */
#define BW_IOMUXC_GPR2_DI1_VS_POLARITY(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_DI1_VS_POLARITY) | BF_IOMUXC_GPR2_DI1_VS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field LVDS_CLK_SHIFT[18:16] (RW)
 *
 * Shifts the LVDS output clock in relation to the data. Used for debug purposes
 * only. In normal functional operation must be '000'
 *
 * Values:
 * - 000 - Output clock is '1100011' (normal operation)
 * - 001 - Output clock is '1110001'
 * - 010 - Output clock is '1111000'
 * - 011 - Output clock is '1000111'
 * - 100 - Output clock is '0001111'
 * - 101 - Output clock is '0011111'
 * - 110 - Output clock is '0111100'
 * - 111 - Output clock is '1100011'
 */
/*@{*/
#define BP_IOMUXC_GPR2_LVDS_CLK_SHIFT (16U) /*!< Bit position for IOMUXC_GPR2_LVDS_CLK_SHIFT. */
#define BM_IOMUXC_GPR2_LVDS_CLK_SHIFT (0x00070000U) /*!< Bit mask for IOMUXC_GPR2_LVDS_CLK_SHIFT. */
#define BS_IOMUXC_GPR2_LVDS_CLK_SHIFT (3U) /*!< Bit field size in bits for IOMUXC_GPR2_LVDS_CLK_SHIFT. */

/*! @brief Read current value of the IOMUXC_GPR2_LVDS_CLK_SHIFT field. */
#define BR_IOMUXC_GPR2_LVDS_CLK_SHIFT(x) (HW_IOMUXC_GPR2(x).B.LVDS_CLK_SHIFT)

/*! @brief Format value for bitfield IOMUXC_GPR2_LVDS_CLK_SHIFT. */
#define BF_IOMUXC_GPR2_LVDS_CLK_SHIFT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_LVDS_CLK_SHIFT) & BM_IOMUXC_GPR2_LVDS_CLK_SHIFT)

/*! @brief Set the LVDS_CLK_SHIFT field to a new value. */
#define BW_IOMUXC_GPR2_LVDS_CLK_SHIFT(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_LVDS_CLK_SHIFT) | BF_IOMUXC_GPR2_LVDS_CLK_SHIFT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR2, field COUNTER_RESET_VAL[21:20] (RW)
 *
 * Reset value for the LDB counter which determines when the shift registers are
 * loaded with data. Used for debug purposes only. In normal functional
 * operation must be '00'
 *
 * Values:
 * - 00 - Reset value is 5
 * - 01 - Reset value is 3
 * - 10 - Reset value is 4
 * - 11 - Reset value is 6
 */
/*@{*/
#define BP_IOMUXC_GPR2_COUNTER_RESET_VAL (20U) /*!< Bit position for IOMUXC_GPR2_COUNTER_RESET_VAL. */
#define BM_IOMUXC_GPR2_COUNTER_RESET_VAL (0x00300000U) /*!< Bit mask for IOMUXC_GPR2_COUNTER_RESET_VAL. */
#define BS_IOMUXC_GPR2_COUNTER_RESET_VAL (2U) /*!< Bit field size in bits for IOMUXC_GPR2_COUNTER_RESET_VAL. */

/*! @brief Read current value of the IOMUXC_GPR2_COUNTER_RESET_VAL field. */
#define BR_IOMUXC_GPR2_COUNTER_RESET_VAL(x) (HW_IOMUXC_GPR2(x).B.COUNTER_RESET_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR2_COUNTER_RESET_VAL. */
#define BF_IOMUXC_GPR2_COUNTER_RESET_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR2_COUNTER_RESET_VAL) & BM_IOMUXC_GPR2_COUNTER_RESET_VAL)

/*! @brief Set the COUNTER_RESET_VAL field to a new value. */
#define BW_IOMUXC_GPR2_COUNTER_RESET_VAL(x, v) (HW_IOMUXC_GPR2_WR(x, (HW_IOMUXC_GPR2_RD(x) & ~BM_IOMUXC_GPR2_COUNTER_RESET_VAL) | BF_IOMUXC_GPR2_COUNTER_RESET_VAL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR3 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR3 - GPR (RW)
 *
 * Reset value: 0x01E00000U
 */
typedef union _hw_iomuxc_gpr3
{
    uint32_t U;
    struct _hw_iomuxc_gpr3_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t HDMI_MUX_CTL : 2;     /*!< [3:2]  */
        uint32_t MIPI_MUX_CTL : 2;     /*!< [5:4]  */
        uint32_t LVDS0_MUX_CTL : 2;    /*!< [7:6]  */
        uint32_t LVDS1_MUX_CTL : 2;    /*!< [9:8]  */
        uint32_t IPU_DIAG : 1;         /*!< [10]  */
        uint32_t TZASC1_BOOT_LOCK : 1; /*!< [11]  */
        uint32_t TZASC2_BOOT_LOCK : 1; /*!< [12]  */
        uint32_t CORE0_DBG_ACK_EN : 1; /*!< [13]  */
        uint32_t CORE1_DBG_ACK_EN : 1; /*!< [14]  */
        uint32_t CORE2_DBG_ACK_EN : 1; /*!< [15]  */
        uint32_t CORE3_DBG_ACK_EN : 1; /*!< [16]  */
        uint32_t OCRAM_STATUS : 4;     /*!< [20:17]  */
        uint32_t OCRAM_CTL : 4;        /*!< [24:21]  */
        uint32_t uSDHCx_RD_CACHE_CTL : 1; /*!< [25]  */
        uint32_t uSDHCx_WR_CACHE_CTL : 1; /*!< [26]  */
        uint32_t BCH_RD_CACHE_CTL : 1; /*!< [27]  */
        uint32_t BCH_WR_CACHE_CTL : 1; /*!< [28]  */
        uint32_t GPU_DBG : 2;          /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_iomuxc_gpr3_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR3 register
 */
/*@{*/
#define HW_IOMUXC_GPR3_ADDR(x)   ((uintptr_t)(x) + 0xCU)

#define HW_IOMUXC_GPR3(x)        (*(__IO hw_iomuxc_gpr3_t *) HW_IOMUXC_GPR3_ADDR(x))
#define HW_IOMUXC_GPR3_RD(x)     (HW_IOMUXC_GPR3(x).U)
#define HW_IOMUXC_GPR3_WR(x, v)  (HW_IOMUXC_GPR3(x).U = (v))
#define HW_IOMUXC_GPR3_SET(x, v) (HW_IOMUXC_GPR3_WR(x, HW_IOMUXC_GPR3_RD(x) |  (v)))
#define HW_IOMUXC_GPR3_CLR(x, v) (HW_IOMUXC_GPR3_WR(x, HW_IOMUXC_GPR3_RD(x) & ~(v)))
#define HW_IOMUXC_GPR3_TOG(x, v) (HW_IOMUXC_GPR3_WR(x, HW_IOMUXC_GPR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR3 bitfields
 */

/*!
 * @name Register IOMUXC_GPR3, field HDMI_MUX_CTL[3:2] (RW)
 *
 * HDMI MUX control
 *
 * Values:
 * - 00 - HDMI source is IPU1 DI0 port
 * - 01 - HDMI source is IPU1 DI1 port
 * - 10 - HDMI source is IPU2 DI0 port
 * - 11 - HDMI source is IPU2 DI1 port
 */
/*@{*/
#define BP_IOMUXC_GPR3_HDMI_MUX_CTL (2U)   /*!< Bit position for IOMUXC_GPR3_HDMI_MUX_CTL. */
#define BM_IOMUXC_GPR3_HDMI_MUX_CTL (0x0000000CU) /*!< Bit mask for IOMUXC_GPR3_HDMI_MUX_CTL. */
#define BS_IOMUXC_GPR3_HDMI_MUX_CTL (2U)   /*!< Bit field size in bits for IOMUXC_GPR3_HDMI_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_HDMI_MUX_CTL field. */
#define BR_IOMUXC_GPR3_HDMI_MUX_CTL(x) (HW_IOMUXC_GPR3(x).B.HDMI_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_HDMI_MUX_CTL. */
#define BF_IOMUXC_GPR3_HDMI_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_HDMI_MUX_CTL) & BM_IOMUXC_GPR3_HDMI_MUX_CTL)

/*! @brief Set the HDMI_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR3_HDMI_MUX_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_HDMI_MUX_CTL) | BF_IOMUXC_GPR3_HDMI_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field MIPI_MUX_CTL[5:4] (RW)
 *
 * MIPI MUX control
 *
 * Values:
 * - 00 - MIPI source is IPU1 DI0 port
 * - 01 - MIPI source is IPU1 DI1 port
 * - 10 - MIPI source is IPU2 DI0 port
 * - 11 - MIPI source is IPU2 DI1 port
 */
/*@{*/
#define BP_IOMUXC_GPR3_MIPI_MUX_CTL (4U)   /*!< Bit position for IOMUXC_GPR3_MIPI_MUX_CTL. */
#define BM_IOMUXC_GPR3_MIPI_MUX_CTL (0x00000030U) /*!< Bit mask for IOMUXC_GPR3_MIPI_MUX_CTL. */
#define BS_IOMUXC_GPR3_MIPI_MUX_CTL (2U)   /*!< Bit field size in bits for IOMUXC_GPR3_MIPI_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_MIPI_MUX_CTL field. */
#define BR_IOMUXC_GPR3_MIPI_MUX_CTL(x) (HW_IOMUXC_GPR3(x).B.MIPI_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_MIPI_MUX_CTL. */
#define BF_IOMUXC_GPR3_MIPI_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_MIPI_MUX_CTL) & BM_IOMUXC_GPR3_MIPI_MUX_CTL)

/*! @brief Set the MIPI_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR3_MIPI_MUX_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_MIPI_MUX_CTL) | BF_IOMUXC_GPR3_MIPI_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field LVDS0_MUX_CTL[7:6] (RW)
 *
 * LVDS0 MUX control
 *
 * Values:
 * - 00 - LVDS0 source is IPU1 DI0 port
 * - 01 - LVDS0 source is IPU1 DI1 port
 * - 10 - LVDS0 source is IPU2 DI0 port
 * - 11 - LVDS0 source is IPU2 DI1 port
 */
/*@{*/
#define BP_IOMUXC_GPR3_LVDS0_MUX_CTL (6U)  /*!< Bit position for IOMUXC_GPR3_LVDS0_MUX_CTL. */
#define BM_IOMUXC_GPR3_LVDS0_MUX_CTL (0x000000C0U) /*!< Bit mask for IOMUXC_GPR3_LVDS0_MUX_CTL. */
#define BS_IOMUXC_GPR3_LVDS0_MUX_CTL (2U)  /*!< Bit field size in bits for IOMUXC_GPR3_LVDS0_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_LVDS0_MUX_CTL field. */
#define BR_IOMUXC_GPR3_LVDS0_MUX_CTL(x) (HW_IOMUXC_GPR3(x).B.LVDS0_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_LVDS0_MUX_CTL. */
#define BF_IOMUXC_GPR3_LVDS0_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_LVDS0_MUX_CTL) & BM_IOMUXC_GPR3_LVDS0_MUX_CTL)

/*! @brief Set the LVDS0_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR3_LVDS0_MUX_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_LVDS0_MUX_CTL) | BF_IOMUXC_GPR3_LVDS0_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field LVDS1_MUX_CTL[9:8] (RW)
 *
 * LVDS1 MUX control
 *
 * Values:
 * - 00 - LVDS1 source is IPU1 DI0 port
 * - 01 - LVDS1 source is IPU1 DI1 port
 * - 10 - LVDS1 source is IPU2 DI0 port
 * - 11 - LVDS1 source is IPU2 DI1 port
 */
/*@{*/
#define BP_IOMUXC_GPR3_LVDS1_MUX_CTL (8U)  /*!< Bit position for IOMUXC_GPR3_LVDS1_MUX_CTL. */
#define BM_IOMUXC_GPR3_LVDS1_MUX_CTL (0x00000300U) /*!< Bit mask for IOMUXC_GPR3_LVDS1_MUX_CTL. */
#define BS_IOMUXC_GPR3_LVDS1_MUX_CTL (2U)  /*!< Bit field size in bits for IOMUXC_GPR3_LVDS1_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_LVDS1_MUX_CTL field. */
#define BR_IOMUXC_GPR3_LVDS1_MUX_CTL(x) (HW_IOMUXC_GPR3(x).B.LVDS1_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_LVDS1_MUX_CTL. */
#define BF_IOMUXC_GPR3_LVDS1_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_LVDS1_MUX_CTL) & BM_IOMUXC_GPR3_LVDS1_MUX_CTL)

/*! @brief Set the LVDS1_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR3_LVDS1_MUX_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_LVDS1_MUX_CTL) | BF_IOMUXC_GPR3_LVDS1_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field IPU_DIAG[10] (RW)
 *
 * IPU diagnostic debug bus mux
 *
 * Values:
 * - 0 - IPU1 diagnostic bus is selected
 * - 1 - IPU2 diagnostic bus is selected
 */
/*@{*/
#define BP_IOMUXC_GPR3_IPU_DIAG (10U)      /*!< Bit position for IOMUXC_GPR3_IPU_DIAG. */
#define BM_IOMUXC_GPR3_IPU_DIAG (0x00000400U) /*!< Bit mask for IOMUXC_GPR3_IPU_DIAG. */
#define BS_IOMUXC_GPR3_IPU_DIAG (1U)       /*!< Bit field size in bits for IOMUXC_GPR3_IPU_DIAG. */

/*! @brief Read current value of the IOMUXC_GPR3_IPU_DIAG field. */
#define BR_IOMUXC_GPR3_IPU_DIAG(x) (HW_IOMUXC_GPR3(x).B.IPU_DIAG)

/*! @brief Format value for bitfield IOMUXC_GPR3_IPU_DIAG. */
#define BF_IOMUXC_GPR3_IPU_DIAG(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_IPU_DIAG) & BM_IOMUXC_GPR3_IPU_DIAG)

/*! @brief Set the IPU_DIAG field to a new value. */
#define BW_IOMUXC_GPR3_IPU_DIAG(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_IPU_DIAG) | BF_IOMUXC_GPR3_IPU_DIAG(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field TZASC1_BOOT_LOCK[11] (RW)
 *
 * TZASC-1 secure boot lock
 *
 * Values:
 * - 0 - secure boot lock is disabled.
 * - 1 - secure boot lock is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR3_TZASC1_BOOT_LOCK (11U) /*!< Bit position for IOMUXC_GPR3_TZASC1_BOOT_LOCK. */
#define BM_IOMUXC_GPR3_TZASC1_BOOT_LOCK (0x00000800U) /*!< Bit mask for IOMUXC_GPR3_TZASC1_BOOT_LOCK. */
#define BS_IOMUXC_GPR3_TZASC1_BOOT_LOCK (1U) /*!< Bit field size in bits for IOMUXC_GPR3_TZASC1_BOOT_LOCK. */

/*! @brief Read current value of the IOMUXC_GPR3_TZASC1_BOOT_LOCK field. */
#define BR_IOMUXC_GPR3_TZASC1_BOOT_LOCK(x) (HW_IOMUXC_GPR3(x).B.TZASC1_BOOT_LOCK)

/*! @brief Format value for bitfield IOMUXC_GPR3_TZASC1_BOOT_LOCK. */
#define BF_IOMUXC_GPR3_TZASC1_BOOT_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_TZASC1_BOOT_LOCK) & BM_IOMUXC_GPR3_TZASC1_BOOT_LOCK)

/*! @brief Set the TZASC1_BOOT_LOCK field to a new value. */
#define BW_IOMUXC_GPR3_TZASC1_BOOT_LOCK(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_TZASC1_BOOT_LOCK) | BF_IOMUXC_GPR3_TZASC1_BOOT_LOCK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field TZASC2_BOOT_LOCK[12] (RW)
 *
 * TZASC-2 secure boot lock
 *
 * Values:
 * - 0 - secure boot lock is disabled.
 * - 1 - secure boot lock is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR3_TZASC2_BOOT_LOCK (12U) /*!< Bit position for IOMUXC_GPR3_TZASC2_BOOT_LOCK. */
#define BM_IOMUXC_GPR3_TZASC2_BOOT_LOCK (0x00001000U) /*!< Bit mask for IOMUXC_GPR3_TZASC2_BOOT_LOCK. */
#define BS_IOMUXC_GPR3_TZASC2_BOOT_LOCK (1U) /*!< Bit field size in bits for IOMUXC_GPR3_TZASC2_BOOT_LOCK. */

/*! @brief Read current value of the IOMUXC_GPR3_TZASC2_BOOT_LOCK field. */
#define BR_IOMUXC_GPR3_TZASC2_BOOT_LOCK(x) (HW_IOMUXC_GPR3(x).B.TZASC2_BOOT_LOCK)

/*! @brief Format value for bitfield IOMUXC_GPR3_TZASC2_BOOT_LOCK. */
#define BF_IOMUXC_GPR3_TZASC2_BOOT_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_TZASC2_BOOT_LOCK) & BM_IOMUXC_GPR3_TZASC2_BOOT_LOCK)

/*! @brief Set the TZASC2_BOOT_LOCK field to a new value. */
#define BW_IOMUXC_GPR3_TZASC2_BOOT_LOCK(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_TZASC2_BOOT_LOCK) | BF_IOMUXC_GPR3_TZASC2_BOOT_LOCK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field CORE0_DBG_ACK_EN[13] (RW)
 *
 * Mask control of Core 1 debug acknowledge to global debug acknowledge
 *
 * Values:
 * - 0 - Core 0 debug acknowledge is part of global acknowledge.
 * - 1 - Core 0 debug acknowledge is masked by this bit, and it is not part of
 *     global acknowledge.
 */
/*@{*/
#define BP_IOMUXC_GPR3_CORE0_DBG_ACK_EN (13U) /*!< Bit position for IOMUXC_GPR3_CORE0_DBG_ACK_EN. */
#define BM_IOMUXC_GPR3_CORE0_DBG_ACK_EN (0x00002000U) /*!< Bit mask for IOMUXC_GPR3_CORE0_DBG_ACK_EN. */
#define BS_IOMUXC_GPR3_CORE0_DBG_ACK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR3_CORE0_DBG_ACK_EN. */

/*! @brief Read current value of the IOMUXC_GPR3_CORE0_DBG_ACK_EN field. */
#define BR_IOMUXC_GPR3_CORE0_DBG_ACK_EN(x) (HW_IOMUXC_GPR3(x).B.CORE0_DBG_ACK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR3_CORE0_DBG_ACK_EN. */
#define BF_IOMUXC_GPR3_CORE0_DBG_ACK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_CORE0_DBG_ACK_EN) & BM_IOMUXC_GPR3_CORE0_DBG_ACK_EN)

/*! @brief Set the CORE0_DBG_ACK_EN field to a new value. */
#define BW_IOMUXC_GPR3_CORE0_DBG_ACK_EN(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_CORE0_DBG_ACK_EN) | BF_IOMUXC_GPR3_CORE0_DBG_ACK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field CORE1_DBG_ACK_EN[14] (RW)
 *
 * Mask control of Core 1 debug acknowledge to global debug acknowledge.
 *
 * Values:
 * - 0 - Core 1 debug acknowledge is part of global acknowledge.
 * - 1 - Core 1 debug acknowledge is masked by this bit, and it is not part of
 *     global acknowledge.
 */
/*@{*/
#define BP_IOMUXC_GPR3_CORE1_DBG_ACK_EN (14U) /*!< Bit position for IOMUXC_GPR3_CORE1_DBG_ACK_EN. */
#define BM_IOMUXC_GPR3_CORE1_DBG_ACK_EN (0x00004000U) /*!< Bit mask for IOMUXC_GPR3_CORE1_DBG_ACK_EN. */
#define BS_IOMUXC_GPR3_CORE1_DBG_ACK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR3_CORE1_DBG_ACK_EN. */

/*! @brief Read current value of the IOMUXC_GPR3_CORE1_DBG_ACK_EN field. */
#define BR_IOMUXC_GPR3_CORE1_DBG_ACK_EN(x) (HW_IOMUXC_GPR3(x).B.CORE1_DBG_ACK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR3_CORE1_DBG_ACK_EN. */
#define BF_IOMUXC_GPR3_CORE1_DBG_ACK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_CORE1_DBG_ACK_EN) & BM_IOMUXC_GPR3_CORE1_DBG_ACK_EN)

/*! @brief Set the CORE1_DBG_ACK_EN field to a new value. */
#define BW_IOMUXC_GPR3_CORE1_DBG_ACK_EN(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_CORE1_DBG_ACK_EN) | BF_IOMUXC_GPR3_CORE1_DBG_ACK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field CORE2_DBG_ACK_EN[15] (RW)
 *
 * Mask control of Core 2 debug acknowledge to global debug acknowledge
 *
 * Values:
 * - 0 - Core 2 debug acknowledge is part of global acknowledge.
 * - 1 - Core 2 debug acknowledge is masked by this bit, and it is not part of
 *     global acknowledge.
 */
/*@{*/
#define BP_IOMUXC_GPR3_CORE2_DBG_ACK_EN (15U) /*!< Bit position for IOMUXC_GPR3_CORE2_DBG_ACK_EN. */
#define BM_IOMUXC_GPR3_CORE2_DBG_ACK_EN (0x00008000U) /*!< Bit mask for IOMUXC_GPR3_CORE2_DBG_ACK_EN. */
#define BS_IOMUXC_GPR3_CORE2_DBG_ACK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR3_CORE2_DBG_ACK_EN. */

/*! @brief Read current value of the IOMUXC_GPR3_CORE2_DBG_ACK_EN field. */
#define BR_IOMUXC_GPR3_CORE2_DBG_ACK_EN(x) (HW_IOMUXC_GPR3(x).B.CORE2_DBG_ACK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR3_CORE2_DBG_ACK_EN. */
#define BF_IOMUXC_GPR3_CORE2_DBG_ACK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_CORE2_DBG_ACK_EN) & BM_IOMUXC_GPR3_CORE2_DBG_ACK_EN)

/*! @brief Set the CORE2_DBG_ACK_EN field to a new value. */
#define BW_IOMUXC_GPR3_CORE2_DBG_ACK_EN(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_CORE2_DBG_ACK_EN) | BF_IOMUXC_GPR3_CORE2_DBG_ACK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field CORE3_DBG_ACK_EN[16] (RW)
 *
 * Mask control of Core 3 debug acknowledge to global debug acknowledge
 *
 * Values:
 * - 0 - Core 3 debug acknowledge is part of global acknowledge.
 * - 1 - Core 3 debug acknowledge is masked by this bit, and it is not part of
 *     global acknowledge.
 */
/*@{*/
#define BP_IOMUXC_GPR3_CORE3_DBG_ACK_EN (16U) /*!< Bit position for IOMUXC_GPR3_CORE3_DBG_ACK_EN. */
#define BM_IOMUXC_GPR3_CORE3_DBG_ACK_EN (0x00010000U) /*!< Bit mask for IOMUXC_GPR3_CORE3_DBG_ACK_EN. */
#define BS_IOMUXC_GPR3_CORE3_DBG_ACK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR3_CORE3_DBG_ACK_EN. */

/*! @brief Read current value of the IOMUXC_GPR3_CORE3_DBG_ACK_EN field. */
#define BR_IOMUXC_GPR3_CORE3_DBG_ACK_EN(x) (HW_IOMUXC_GPR3(x).B.CORE3_DBG_ACK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR3_CORE3_DBG_ACK_EN. */
#define BF_IOMUXC_GPR3_CORE3_DBG_ACK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_CORE3_DBG_ACK_EN) & BM_IOMUXC_GPR3_CORE3_DBG_ACK_EN)

/*! @brief Set the CORE3_DBG_ACK_EN field to a new value. */
#define BW_IOMUXC_GPR3_CORE3_DBG_ACK_EN(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_CORE3_DBG_ACK_EN) | BF_IOMUXC_GPR3_CORE3_DBG_ACK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field OCRAM_STATUS[20:17] (RO)
 *
 * This field shows the OCRAM pipeline settings status, controlled by
 * OCRAM_CTL[24:21] bits respectively. When the control bit is changed, the corresponding
 * status bit goes high and keeps high until this new configuration is applied the
 * internal logic. This provides a way for software to detect that the
 * configuration has become valid. The suggested flow for changing the configuration in
 * software is: set/clear the control bit poll the status bit until it goes to 0
 * OCRAM_STATUS[17] shows the write address pipeline status. This bit value
 * reflects the propagation of the respective control bit to OCRAM memory.
 * OCRAM_STATUS[18] shows the write data pipeline status. This bit value reflects the
 * propagation of the respective control bit to OCRAM memory. OCRAM_STATUS[19] shows the
 * read address pipeline status. This bit value reflects the propagation of the
 * respective control bit to OCRAM memory. OCRAM_STATUS[20] shows the read data
 * pipeline status. This bit value reflects the propagation of the respective
 * control bit to OCRAM memory.
 *
 * Values:
 * - 0 - read data pipeline configuration valid
 * - 1 - read data pipeline control bit changed
 */
/*@{*/
#define BP_IOMUXC_GPR3_OCRAM_STATUS (17U)  /*!< Bit position for IOMUXC_GPR3_OCRAM_STATUS. */
#define BM_IOMUXC_GPR3_OCRAM_STATUS (0x001E0000U) /*!< Bit mask for IOMUXC_GPR3_OCRAM_STATUS. */
#define BS_IOMUXC_GPR3_OCRAM_STATUS (4U)   /*!< Bit field size in bits for IOMUXC_GPR3_OCRAM_STATUS. */

/*! @brief Read current value of the IOMUXC_GPR3_OCRAM_STATUS field. */
#define BR_IOMUXC_GPR3_OCRAM_STATUS(x) (HW_IOMUXC_GPR3(x).B.OCRAM_STATUS)
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field OCRAM_CTL[24:21] (RW)
 *
 * OCRAM_CTL[24] write address pipeline control bit. When this feature is
 * enabled, the write address from the AXI master would be delayed 1 cycle before it
 * can be accepted by the on-chip RAM. This can avoid any setup time issue for the
 * write access on the memory cell at high frequency. Enabling this feature would
 * cost at most 1 more clock cycle for each AXI write transaction, i.e., at most
 * 1 more clock cycle for each write burst with multiple beats of data. When
 * this feature is disabled, the write address from the AXI master can be accepted
 * by the on-chip RAM without delay, and data can be written to memory at this
 * cycle (if no other access and write data is also ready at this cycle). 0 write
 * address pipeline is disabled 1 write address pipeline is enabled OCRAM_CTL[23] -
 * write data pipeline control bit When this feature is enabled, the write data
 * from the AXI master would be delayed 1 cycle before it can be accepted by the
 * on-chip RAM. This can avoid any setup time issue for the write access on the
 * memory cell at high frequency. Enabling this feature would cost at most 1 more
 * clock cycle for each AXI write transaction, i.e., at most 1 more clock cycle
 * for each write burst with multiple beats of data. When this feature is
 * disabled, the write data from the AXI master can be accepted by the on-chip RAM
 * without delay, and data can be written to memory at this cycle (if no other access
 * and write address is also ready at this cycle). 0 write data pipeline is
 * disabled 1 write data pipeline is enabled OCRAM_CTL[22] read address pipeline
 * control bit. When this feature is enabled, the read address from the AXI master
 * would be delayed 1 cycle before it can be accepted by the on-chip RAM. This can
 * avoid any setup time issue for the read access on the memory cell at high
 * frequency. Enabling this feature would cost at most 1 more clock cycle for each AXI
 * read transaction, i.e., at most 1 more clock cycle for each read burst with
 * multiple beats of data. When this feature is disabled, the read address from the
 * AXI master can be accepted by the on-chip RAM without delay, and data can
 * become ready for master at next clock cycle (if no other access and no read data
 * wait). 0 read address pipeline is disabled 1 read address pipeline is enabled
 * OCRAM_CTL[21] - read data wait state control bit When the read data wait state
 * is enabled, it will cost 2 cycles for each read access, (each beat of a read
 * burst). This can avoid the potential timing problem caused by the relatively
 * longer memory access time at higher frequency. When this feature is disabled,
 * it only costs 1 clock cycle to finish a read transaction, i.e., get read data
 * back in the next cycle of read request becomes valid on the bus.
 *
 * Values:
 * - 0 - read data pipeline is disabled
 * - 1 - read data pipeline is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR3_OCRAM_CTL (21U)     /*!< Bit position for IOMUXC_GPR3_OCRAM_CTL. */
#define BM_IOMUXC_GPR3_OCRAM_CTL (0x01E00000U) /*!< Bit mask for IOMUXC_GPR3_OCRAM_CTL. */
#define BS_IOMUXC_GPR3_OCRAM_CTL (4U)      /*!< Bit field size in bits for IOMUXC_GPR3_OCRAM_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_OCRAM_CTL field. */
#define BR_IOMUXC_GPR3_OCRAM_CTL(x) (HW_IOMUXC_GPR3(x).B.OCRAM_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_OCRAM_CTL. */
#define BF_IOMUXC_GPR3_OCRAM_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_OCRAM_CTL) & BM_IOMUXC_GPR3_OCRAM_CTL)

/*! @brief Set the OCRAM_CTL field to a new value. */
#define BW_IOMUXC_GPR3_OCRAM_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_OCRAM_CTL) | BF_IOMUXC_GPR3_OCRAM_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field uSDHCx_RD_CACHE_CTL[25] (RW)
 *
 * Control uSDHCx [1-4] blocks cacheable attribute of AXI read transactions
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL (25U) /*!< Bit position for IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL. */
#define BM_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL (0x02000000U) /*!< Bit mask for IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL. */
#define BS_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL field. */
#define BR_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL(x) (HW_IOMUXC_GPR3(x).B.uSDHCx_RD_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL. */
#define BF_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL) & BM_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL)

/*! @brief Set the uSDHCx_RD_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL) | BF_IOMUXC_GPR3_uSDHCx_RD_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field uSDHCx_WR_CACHE_CTL[26] (RW)
 *
 * Control uSDHCx [1-4] blocks cacheable attribute of AXI write transactions
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL (26U) /*!< Bit position for IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL. */
#define BM_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL (0x04000000U) /*!< Bit mask for IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL. */
#define BS_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL field. */
#define BR_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL(x) (HW_IOMUXC_GPR3(x).B.uSDHCx_WR_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL. */
#define BF_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL) & BM_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL)

/*! @brief Set the uSDHCx_WR_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL) | BF_IOMUXC_GPR3_uSDHCx_WR_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field BCH_RD_CACHE_CTL[27] (RW)
 *
 * Control BCH block cacheable attribute of AXI read transactions Set of the
 * cache bits, enable packet optimization through the bus system to DDR controller.
 * The only side effect is that bus may change the nature of the accesses, which
 * may lead to problems when accessing FIFO type address. In most typical cases,
 * these bits should be set. For the GPU3D, GPU2D and OpenVG, such settings are
 * possible through the IP programming model. For few peripherals, for these bits
 * to take effect, it is required to also select set '1' to 'cache-mux' control
 * bit.
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR3_BCH_RD_CACHE_CTL (27U) /*!< Bit position for IOMUXC_GPR3_BCH_RD_CACHE_CTL. */
#define BM_IOMUXC_GPR3_BCH_RD_CACHE_CTL (0x08000000U) /*!< Bit mask for IOMUXC_GPR3_BCH_RD_CACHE_CTL. */
#define BS_IOMUXC_GPR3_BCH_RD_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR3_BCH_RD_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_BCH_RD_CACHE_CTL field. */
#define BR_IOMUXC_GPR3_BCH_RD_CACHE_CTL(x) (HW_IOMUXC_GPR3(x).B.BCH_RD_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_BCH_RD_CACHE_CTL. */
#define BF_IOMUXC_GPR3_BCH_RD_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_BCH_RD_CACHE_CTL) & BM_IOMUXC_GPR3_BCH_RD_CACHE_CTL)

/*! @brief Set the BCH_RD_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR3_BCH_RD_CACHE_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_BCH_RD_CACHE_CTL) | BF_IOMUXC_GPR3_BCH_RD_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field BCH_WR_CACHE_CTL[28] (RW)
 *
 * Control BCH block cacheable attribute of AXI write transactions
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR3_BCH_WR_CACHE_CTL (28U) /*!< Bit position for IOMUXC_GPR3_BCH_WR_CACHE_CTL. */
#define BM_IOMUXC_GPR3_BCH_WR_CACHE_CTL (0x10000000U) /*!< Bit mask for IOMUXC_GPR3_BCH_WR_CACHE_CTL. */
#define BS_IOMUXC_GPR3_BCH_WR_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR3_BCH_WR_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR3_BCH_WR_CACHE_CTL field. */
#define BR_IOMUXC_GPR3_BCH_WR_CACHE_CTL(x) (HW_IOMUXC_GPR3(x).B.BCH_WR_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR3_BCH_WR_CACHE_CTL. */
#define BF_IOMUXC_GPR3_BCH_WR_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_BCH_WR_CACHE_CTL) & BM_IOMUXC_GPR3_BCH_WR_CACHE_CTL)

/*! @brief Set the BCH_WR_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR3_BCH_WR_CACHE_CTL(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_BCH_WR_CACHE_CTL) | BF_IOMUXC_GPR3_BCH_WR_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR3, field GPU_DBG[30:29] (RW)
 *
 * GPU debug busses to IOMUX
 *
 * Values:
 * - 00 - GPU3D
 * - 01 - GPU2D
 * - 10 - OpenVG
 * - 11 - Reserved
 */
/*@{*/
#define BP_IOMUXC_GPR3_GPU_DBG (29U)       /*!< Bit position for IOMUXC_GPR3_GPU_DBG. */
#define BM_IOMUXC_GPR3_GPU_DBG (0x60000000U) /*!< Bit mask for IOMUXC_GPR3_GPU_DBG. */
#define BS_IOMUXC_GPR3_GPU_DBG (2U)        /*!< Bit field size in bits for IOMUXC_GPR3_GPU_DBG. */

/*! @brief Read current value of the IOMUXC_GPR3_GPU_DBG field. */
#define BR_IOMUXC_GPR3_GPU_DBG(x) (HW_IOMUXC_GPR3(x).B.GPU_DBG)

/*! @brief Format value for bitfield IOMUXC_GPR3_GPU_DBG. */
#define BF_IOMUXC_GPR3_GPU_DBG(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR3_GPU_DBG) & BM_IOMUXC_GPR3_GPU_DBG)

/*! @brief Set the GPU_DBG field to a new value. */
#define BW_IOMUXC_GPR3_GPU_DBG(x, v) (HW_IOMUXC_GPR3_WR(x, (HW_IOMUXC_GPR3_RD(x) & ~BM_IOMUXC_GPR3_GPU_DBG) | BF_IOMUXC_GPR3_GPU_DBG(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR4 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR4 - GPR (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_gpr4
{
    uint32_t U;
    struct _hw_iomuxc_gpr4_bitfields
    {
        uint32_t IPU_RD_CACHE_CTL : 1; /*!< [0]  */
        uint32_t IPU_WR_CACHE_CTL : 1; /*!< [1]  */
        uint32_t VPU_P_RD_CACHE_VAL : 1; /*!< [2]  */
        uint32_t VPU_P_WR_CACHE_VAL : 1; /*!< [3]  */
        uint32_t RESERVED0 : 2;        /*!< [5:4]  */
        uint32_t VPU_RD_CACHE_SEL : 1; /*!< [6]  */
        uint32_t VPU_WR_CACHE_SEL : 1; /*!< [7]  */
        uint32_t SOC_VERSION : 8;      /*!< [15:8]  */
        uint32_t ENET_STOP_ACK : 1;    /*!< [16]  */
        uint32_t CAN1_STOP_ACK : 1;    /*!< [17]  */
        uint32_t CAN2_STOP_ACK : 1;    /*!< [18]  */
        uint32_t SDMA_STOP_ACK : 1;    /*!< [19]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t PCIe_RD_CACHE_VAL : 1; /*!< [24]  */
        uint32_t PCIe_WR_CACHE_VAL : 1; /*!< [25]  */
        uint32_t PCIe_RD_CACHE_SEL : 1; /*!< [26]  */
        uint32_t PCIe_WR_CACHE_SEL : 1; /*!< [27]  */
        uint32_t VDOA_RD_CACHE_VAL : 1; /*!< [28]  */
        uint32_t VDOA_WR_CACHE_VAL : 1; /*!< [29]  */
        uint32_t VDOA_RD_CACHE_SEL : 1; /*!< [30]  */
        uint32_t VDOA_WR_CACHE_SEL : 1; /*!< [31]  */
    } B;
} hw_iomuxc_gpr4_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR4 register
 */
/*@{*/
#define HW_IOMUXC_GPR4_ADDR(x)   ((uintptr_t)(x) + 0x10U)

#define HW_IOMUXC_GPR4(x)        (*(__IO hw_iomuxc_gpr4_t *) HW_IOMUXC_GPR4_ADDR(x))
#define HW_IOMUXC_GPR4_RD(x)     (HW_IOMUXC_GPR4(x).U)
#define HW_IOMUXC_GPR4_WR(x, v)  (HW_IOMUXC_GPR4(x).U = (v))
#define HW_IOMUXC_GPR4_SET(x, v) (HW_IOMUXC_GPR4_WR(x, HW_IOMUXC_GPR4_RD(x) |  (v)))
#define HW_IOMUXC_GPR4_CLR(x, v) (HW_IOMUXC_GPR4_WR(x, HW_IOMUXC_GPR4_RD(x) & ~(v)))
#define HW_IOMUXC_GPR4_TOG(x, v) (HW_IOMUXC_GPR4_WR(x, HW_IOMUXC_GPR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR4 bitfields
 */

/*!
 * @name Register IOMUXC_GPR4, field IPU_RD_CACHE_CTL[0] (RW)
 *
 * Control IPU-1 and IPU-2 block cacheable attribute of AXI read transactions
 * Set of the cache bits, enable packet optimization through the bus system to DDR
 * controller. The only side effect is that bus may change the nature of the
 * accesses, which may lead to problems when accessing FIFO type address. In most
 * typical cases, these bits should be set. For the GPU3D, GPU2D and OpenVG, such
 * settings are possible through the IP programming model. For few peripherals, for
 * these bits to take effect, it is required to also select set '1' to
 * 'cache-mux' control bit.
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_IPU_RD_CACHE_CTL (0U) /*!< Bit position for IOMUXC_GPR4_IPU_RD_CACHE_CTL. */
#define BM_IOMUXC_GPR4_IPU_RD_CACHE_CTL (0x00000001U) /*!< Bit mask for IOMUXC_GPR4_IPU_RD_CACHE_CTL. */
#define BS_IOMUXC_GPR4_IPU_RD_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_IPU_RD_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR4_IPU_RD_CACHE_CTL field. */
#define BR_IOMUXC_GPR4_IPU_RD_CACHE_CTL(x) (HW_IOMUXC_GPR4(x).B.IPU_RD_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR4_IPU_RD_CACHE_CTL. */
#define BF_IOMUXC_GPR4_IPU_RD_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_IPU_RD_CACHE_CTL) & BM_IOMUXC_GPR4_IPU_RD_CACHE_CTL)

/*! @brief Set the IPU_RD_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR4_IPU_RD_CACHE_CTL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_IPU_RD_CACHE_CTL) | BF_IOMUXC_GPR4_IPU_RD_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field IPU_WR_CACHE_CTL[1] (RW)
 *
 * Control IPU-1 and IPU-2 block cacheable attribute of AXI write transactions
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_IPU_WR_CACHE_CTL (1U) /*!< Bit position for IOMUXC_GPR4_IPU_WR_CACHE_CTL. */
#define BM_IOMUXC_GPR4_IPU_WR_CACHE_CTL (0x00000002U) /*!< Bit mask for IOMUXC_GPR4_IPU_WR_CACHE_CTL. */
#define BS_IOMUXC_GPR4_IPU_WR_CACHE_CTL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_IPU_WR_CACHE_CTL. */

/*! @brief Read current value of the IOMUXC_GPR4_IPU_WR_CACHE_CTL field. */
#define BR_IOMUXC_GPR4_IPU_WR_CACHE_CTL(x) (HW_IOMUXC_GPR4(x).B.IPU_WR_CACHE_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR4_IPU_WR_CACHE_CTL. */
#define BF_IOMUXC_GPR4_IPU_WR_CACHE_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_IPU_WR_CACHE_CTL) & BM_IOMUXC_GPR4_IPU_WR_CACHE_CTL)

/*! @brief Set the IPU_WR_CACHE_CTL field to a new value. */
#define BW_IOMUXC_GPR4_IPU_WR_CACHE_CTL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_IPU_WR_CACHE_CTL) | BF_IOMUXC_GPR4_IPU_WR_CACHE_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VPU_P_RD_CACHE_VAL[2] (RW)
 *
 * VPU (primary bus) block cacheable attribute value of AXI read transactions
 * The value of VPU_P_RD_CACHE_VAL is affecting the transactions only if
 * VPU_RD_CACHE_SEL is set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL (2U) /*!< Bit position for IOMUXC_GPR4_VPU_P_RD_CACHE_VAL. */
#define BM_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL (0x00000004U) /*!< Bit mask for IOMUXC_GPR4_VPU_P_RD_CACHE_VAL. */
#define BS_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VPU_P_RD_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_VPU_P_RD_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.VPU_P_RD_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VPU_P_RD_CACHE_VAL. */
#define BF_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL) & BM_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL)

/*! @brief Set the VPU_P_RD_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL) | BF_IOMUXC_GPR4_VPU_P_RD_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VPU_P_WR_CACHE_VAL[3] (RW)
 *
 * VPU (primary bus) block cacheable attribute value of AXI write transactions
 * The value of VPU_P_WR_CACHE_VAL is affecting the transactions only if
 * VPU_WR_CACHE_SEL is set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL (3U) /*!< Bit position for IOMUXC_GPR4_VPU_P_WR_CACHE_VAL. */
#define BM_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL (0x00000008U) /*!< Bit mask for IOMUXC_GPR4_VPU_P_WR_CACHE_VAL. */
#define BS_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VPU_P_WR_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_VPU_P_WR_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.VPU_P_WR_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VPU_P_WR_CACHE_VAL. */
#define BF_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL) & BM_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL)

/*! @brief Set the VPU_P_WR_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL) | BF_IOMUXC_GPR4_VPU_P_WR_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VPU_RD_CACHE_SEL[6] (RW)
 *
 * This bit selects the cacheable attribute of VPU AXI read transcations (both
 * primary and secondary AXI buses)
 *
 * Values:
 * - 0 - The read transaction cacheable attribute is driven by the VPU core
 * - 1 - The read transaction cacheable attribute is driven by
 *     VPU_SEC_RD_CACHE_VAL for secondary bus and VPU_P_RD_CACHE_VAL for primary bus.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VPU_RD_CACHE_SEL (6U) /*!< Bit position for IOMUXC_GPR4_VPU_RD_CACHE_SEL. */
#define BM_IOMUXC_GPR4_VPU_RD_CACHE_SEL (0x00000040U) /*!< Bit mask for IOMUXC_GPR4_VPU_RD_CACHE_SEL. */
#define BS_IOMUXC_GPR4_VPU_RD_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VPU_RD_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_VPU_RD_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_VPU_RD_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.VPU_RD_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VPU_RD_CACHE_SEL. */
#define BF_IOMUXC_GPR4_VPU_RD_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VPU_RD_CACHE_SEL) & BM_IOMUXC_GPR4_VPU_RD_CACHE_SEL)

/*! @brief Set the VPU_RD_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_VPU_RD_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VPU_RD_CACHE_SEL) | BF_IOMUXC_GPR4_VPU_RD_CACHE_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VPU_WR_CACHE_SEL[7] (RW)
 *
 * This bit selects the cacheable attribute of VPU AXI write transcations (both
 * primary and secondary AXI buses)
 *
 * Values:
 * - 0 - The write transactions cacheable attribute is driven by the VPU core
 * - 1 - The write transactions cacheable attribute is driven by
 *     VPU_SEC_WR_CACHE_VAL for secondary bus and VPU_P_WR_CACHE_VAL for primary bus.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VPU_WR_CACHE_SEL (7U) /*!< Bit position for IOMUXC_GPR4_VPU_WR_CACHE_SEL. */
#define BM_IOMUXC_GPR4_VPU_WR_CACHE_SEL (0x00000080U) /*!< Bit mask for IOMUXC_GPR4_VPU_WR_CACHE_SEL. */
#define BS_IOMUXC_GPR4_VPU_WR_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VPU_WR_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_VPU_WR_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_VPU_WR_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.VPU_WR_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VPU_WR_CACHE_SEL. */
#define BF_IOMUXC_GPR4_VPU_WR_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VPU_WR_CACHE_SEL) & BM_IOMUXC_GPR4_VPU_WR_CACHE_SEL)

/*! @brief Set the VPU_WR_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_VPU_WR_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VPU_WR_CACHE_SEL) | BF_IOMUXC_GPR4_VPU_WR_CACHE_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field SOC_VERSION[15:8] (RW)
 *
 * This is status (read only) field.
 */
/*@{*/
#define BP_IOMUXC_GPR4_SOC_VERSION (8U)    /*!< Bit position for IOMUXC_GPR4_SOC_VERSION. */
#define BM_IOMUXC_GPR4_SOC_VERSION (0x0000FF00U) /*!< Bit mask for IOMUXC_GPR4_SOC_VERSION. */
#define BS_IOMUXC_GPR4_SOC_VERSION (8U)    /*!< Bit field size in bits for IOMUXC_GPR4_SOC_VERSION. */

/*! @brief Read current value of the IOMUXC_GPR4_SOC_VERSION field. */
#define BR_IOMUXC_GPR4_SOC_VERSION(x) (HW_IOMUXC_GPR4(x).B.SOC_VERSION)

/*! @brief Format value for bitfield IOMUXC_GPR4_SOC_VERSION. */
#define BF_IOMUXC_GPR4_SOC_VERSION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_SOC_VERSION) & BM_IOMUXC_GPR4_SOC_VERSION)

/*! @brief Set the SOC_VERSION field to a new value. */
#define BW_IOMUXC_GPR4_SOC_VERSION(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_SOC_VERSION) | BF_IOMUXC_GPR4_SOC_VERSION(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field ENET_STOP_ACK[16] (RW)
 *
 * ENET stop acknowledge. This is status (read only) bit.
 *
 * Values:
 * - 0 - ENET stop acknowledge is not asserted.
 * - 1 - ENET stop acknowledge is asserted, ENET is in STOP mode.
 */
/*@{*/
#define BP_IOMUXC_GPR4_ENET_STOP_ACK (16U) /*!< Bit position for IOMUXC_GPR4_ENET_STOP_ACK. */
#define BM_IOMUXC_GPR4_ENET_STOP_ACK (0x00010000U) /*!< Bit mask for IOMUXC_GPR4_ENET_STOP_ACK. */
#define BS_IOMUXC_GPR4_ENET_STOP_ACK (1U)  /*!< Bit field size in bits for IOMUXC_GPR4_ENET_STOP_ACK. */

/*! @brief Read current value of the IOMUXC_GPR4_ENET_STOP_ACK field. */
#define BR_IOMUXC_GPR4_ENET_STOP_ACK(x) (HW_IOMUXC_GPR4(x).B.ENET_STOP_ACK)

/*! @brief Format value for bitfield IOMUXC_GPR4_ENET_STOP_ACK. */
#define BF_IOMUXC_GPR4_ENET_STOP_ACK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_ENET_STOP_ACK) & BM_IOMUXC_GPR4_ENET_STOP_ACK)

/*! @brief Set the ENET_STOP_ACK field to a new value. */
#define BW_IOMUXC_GPR4_ENET_STOP_ACK(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_ENET_STOP_ACK) | BF_IOMUXC_GPR4_ENET_STOP_ACK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field CAN1_STOP_ACK[17] (RW)
 *
 * CAN-1 stop acknowledge. This is status (read only) bit.
 *
 * Values:
 * - 0 - CAN-1 stop acknowledge is not asserted.
 * - 1 - CAN-1 stop acknowledge is asserted, CAN-1 is in STOP mode.
 */
/*@{*/
#define BP_IOMUXC_GPR4_CAN1_STOP_ACK (17U) /*!< Bit position for IOMUXC_GPR4_CAN1_STOP_ACK. */
#define BM_IOMUXC_GPR4_CAN1_STOP_ACK (0x00020000U) /*!< Bit mask for IOMUXC_GPR4_CAN1_STOP_ACK. */
#define BS_IOMUXC_GPR4_CAN1_STOP_ACK (1U)  /*!< Bit field size in bits for IOMUXC_GPR4_CAN1_STOP_ACK. */

/*! @brief Read current value of the IOMUXC_GPR4_CAN1_STOP_ACK field. */
#define BR_IOMUXC_GPR4_CAN1_STOP_ACK(x) (HW_IOMUXC_GPR4(x).B.CAN1_STOP_ACK)

/*! @brief Format value for bitfield IOMUXC_GPR4_CAN1_STOP_ACK. */
#define BF_IOMUXC_GPR4_CAN1_STOP_ACK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_CAN1_STOP_ACK) & BM_IOMUXC_GPR4_CAN1_STOP_ACK)

/*! @brief Set the CAN1_STOP_ACK field to a new value. */
#define BW_IOMUXC_GPR4_CAN1_STOP_ACK(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_CAN1_STOP_ACK) | BF_IOMUXC_GPR4_CAN1_STOP_ACK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field CAN2_STOP_ACK[18] (RW)
 *
 * CAN-2 stop acknowledge. This is status (read only) bit.
 *
 * Values:
 * - 0 - CAN-2 stop acknowledge is not asserted.
 * - 1 - CAN-2 stop acknowledge is asserted, CAN-2 is in STOP mode.
 */
/*@{*/
#define BP_IOMUXC_GPR4_CAN2_STOP_ACK (18U) /*!< Bit position for IOMUXC_GPR4_CAN2_STOP_ACK. */
#define BM_IOMUXC_GPR4_CAN2_STOP_ACK (0x00040000U) /*!< Bit mask for IOMUXC_GPR4_CAN2_STOP_ACK. */
#define BS_IOMUXC_GPR4_CAN2_STOP_ACK (1U)  /*!< Bit field size in bits for IOMUXC_GPR4_CAN2_STOP_ACK. */

/*! @brief Read current value of the IOMUXC_GPR4_CAN2_STOP_ACK field. */
#define BR_IOMUXC_GPR4_CAN2_STOP_ACK(x) (HW_IOMUXC_GPR4(x).B.CAN2_STOP_ACK)

/*! @brief Format value for bitfield IOMUXC_GPR4_CAN2_STOP_ACK. */
#define BF_IOMUXC_GPR4_CAN2_STOP_ACK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_CAN2_STOP_ACK) & BM_IOMUXC_GPR4_CAN2_STOP_ACK)

/*! @brief Set the CAN2_STOP_ACK field to a new value. */
#define BW_IOMUXC_GPR4_CAN2_STOP_ACK(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_CAN2_STOP_ACK) | BF_IOMUXC_GPR4_CAN2_STOP_ACK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field SDMA_STOP_ACK[19] (RW)
 *
 * SDMA stop acknowledge. This is status (read only) bit.
 *
 * Values:
 * - 0 - SDMA stop acknowledge is not asserted.
 * - 1 - SDMA stop acknowledge is asserted, SDMA is in STOP mode.
 */
/*@{*/
#define BP_IOMUXC_GPR4_SDMA_STOP_ACK (19U) /*!< Bit position for IOMUXC_GPR4_SDMA_STOP_ACK. */
#define BM_IOMUXC_GPR4_SDMA_STOP_ACK (0x00080000U) /*!< Bit mask for IOMUXC_GPR4_SDMA_STOP_ACK. */
#define BS_IOMUXC_GPR4_SDMA_STOP_ACK (1U)  /*!< Bit field size in bits for IOMUXC_GPR4_SDMA_STOP_ACK. */

/*! @brief Read current value of the IOMUXC_GPR4_SDMA_STOP_ACK field. */
#define BR_IOMUXC_GPR4_SDMA_STOP_ACK(x) (HW_IOMUXC_GPR4(x).B.SDMA_STOP_ACK)

/*! @brief Format value for bitfield IOMUXC_GPR4_SDMA_STOP_ACK. */
#define BF_IOMUXC_GPR4_SDMA_STOP_ACK(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_SDMA_STOP_ACK) & BM_IOMUXC_GPR4_SDMA_STOP_ACK)

/*! @brief Set the SDMA_STOP_ACK field to a new value. */
#define BW_IOMUXC_GPR4_SDMA_STOP_ACK(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_SDMA_STOP_ACK) | BF_IOMUXC_GPR4_SDMA_STOP_ACK(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field PCIe_RD_CACHE_VAL[24] (RW)
 *
 * PCIe block cacheable attribute value of AXI read transactions The value of
 * PCIe_RD_CACHE_VAL is affecting the transactions only if PCIe_RD_CACHE_SEL is set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_PCIe_RD_CACHE_VAL (24U) /*!< Bit position for IOMUXC_GPR4_PCIe_RD_CACHE_VAL. */
#define BM_IOMUXC_GPR4_PCIe_RD_CACHE_VAL (0x01000000U) /*!< Bit mask for IOMUXC_GPR4_PCIe_RD_CACHE_VAL. */
#define BS_IOMUXC_GPR4_PCIe_RD_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_PCIe_RD_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_PCIe_RD_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_PCIe_RD_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.PCIe_RD_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_PCIe_RD_CACHE_VAL. */
#define BF_IOMUXC_GPR4_PCIe_RD_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_PCIe_RD_CACHE_VAL) & BM_IOMUXC_GPR4_PCIe_RD_CACHE_VAL)

/*! @brief Set the PCIe_RD_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_PCIe_RD_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_PCIe_RD_CACHE_VAL) | BF_IOMUXC_GPR4_PCIe_RD_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field PCIe_WR_CACHE_VAL[25] (RW)
 *
 * PCIe block cacheable attribute value of AXI write transactions The value of
 * PCIe_WR_CACHE_VAL is affecting the transactions only if PCIe_WR_CACHE_SEL is
 * set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_PCIe_WR_CACHE_VAL (25U) /*!< Bit position for IOMUXC_GPR4_PCIe_WR_CACHE_VAL. */
#define BM_IOMUXC_GPR4_PCIe_WR_CACHE_VAL (0x02000000U) /*!< Bit mask for IOMUXC_GPR4_PCIe_WR_CACHE_VAL. */
#define BS_IOMUXC_GPR4_PCIe_WR_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_PCIe_WR_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_PCIe_WR_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_PCIe_WR_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.PCIe_WR_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_PCIe_WR_CACHE_VAL. */
#define BF_IOMUXC_GPR4_PCIe_WR_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_PCIe_WR_CACHE_VAL) & BM_IOMUXC_GPR4_PCIe_WR_CACHE_VAL)

/*! @brief Set the PCIe_WR_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_PCIe_WR_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_PCIe_WR_CACHE_VAL) | BF_IOMUXC_GPR4_PCIe_WR_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field PCIe_RD_CACHE_SEL[26] (RW)
 *
 * This bit selects the cacheable attribute of PCIe AXI read transcations)
 *
 * Values:
 * - 0 - The read transaction cacheable attribute is driven by the PCIe core
 * - 1 - The read transaction cacheable attribute is driven by PCIe_RD_CACHE_VAL.
 */
/*@{*/
#define BP_IOMUXC_GPR4_PCIe_RD_CACHE_SEL (26U) /*!< Bit position for IOMUXC_GPR4_PCIe_RD_CACHE_SEL. */
#define BM_IOMUXC_GPR4_PCIe_RD_CACHE_SEL (0x04000000U) /*!< Bit mask for IOMUXC_GPR4_PCIe_RD_CACHE_SEL. */
#define BS_IOMUXC_GPR4_PCIe_RD_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_PCIe_RD_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_PCIe_RD_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_PCIe_RD_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.PCIe_RD_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_PCIe_RD_CACHE_SEL. */
#define BF_IOMUXC_GPR4_PCIe_RD_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_PCIe_RD_CACHE_SEL) & BM_IOMUXC_GPR4_PCIe_RD_CACHE_SEL)

/*! @brief Set the PCIe_RD_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_PCIe_RD_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_PCIe_RD_CACHE_SEL) | BF_IOMUXC_GPR4_PCIe_RD_CACHE_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field PCIe_WR_CACHE_SEL[27] (RW)
 *
 * This bit selects the cacheable attribute of PCIe AXI write transcations
 *
 * Values:
 * - 0 - The write transactions cacheable attribute is driven by the PCIe core
 * - 1 - The write transactions cacheable attribute is driven by
 *     PCIe_WR_CACHE_VAL.
 */
/*@{*/
#define BP_IOMUXC_GPR4_PCIe_WR_CACHE_SEL (27U) /*!< Bit position for IOMUXC_GPR4_PCIe_WR_CACHE_SEL. */
#define BM_IOMUXC_GPR4_PCIe_WR_CACHE_SEL (0x08000000U) /*!< Bit mask for IOMUXC_GPR4_PCIe_WR_CACHE_SEL. */
#define BS_IOMUXC_GPR4_PCIe_WR_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_PCIe_WR_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_PCIe_WR_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_PCIe_WR_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.PCIe_WR_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_PCIe_WR_CACHE_SEL. */
#define BF_IOMUXC_GPR4_PCIe_WR_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_PCIe_WR_CACHE_SEL) & BM_IOMUXC_GPR4_PCIe_WR_CACHE_SEL)

/*! @brief Set the PCIe_WR_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_PCIe_WR_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_PCIe_WR_CACHE_SEL) | BF_IOMUXC_GPR4_PCIe_WR_CACHE_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VDOA_RD_CACHE_VAL[28] (RW)
 *
 * VDOA block cacheable attribute value of AXI read transactions The value of
 * VDOA_RD_CACHE_VAL is affecting the transactions only if VDOA_RD_CACHE_SEL is set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for read transactions.
 * - 1 - Cacheable attribute is on for read transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VDOA_RD_CACHE_VAL (28U) /*!< Bit position for IOMUXC_GPR4_VDOA_RD_CACHE_VAL. */
#define BM_IOMUXC_GPR4_VDOA_RD_CACHE_VAL (0x10000000U) /*!< Bit mask for IOMUXC_GPR4_VDOA_RD_CACHE_VAL. */
#define BS_IOMUXC_GPR4_VDOA_RD_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VDOA_RD_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_VDOA_RD_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_VDOA_RD_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.VDOA_RD_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VDOA_RD_CACHE_VAL. */
#define BF_IOMUXC_GPR4_VDOA_RD_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VDOA_RD_CACHE_VAL) & BM_IOMUXC_GPR4_VDOA_RD_CACHE_VAL)

/*! @brief Set the VDOA_RD_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_VDOA_RD_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VDOA_RD_CACHE_VAL) | BF_IOMUXC_GPR4_VDOA_RD_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VDOA_WR_CACHE_VAL[29] (RW)
 *
 * VDOA block cacheable attribute value of AXI write transactions The value of
 * VDOA_WR_CACHE_VAL is affecting the transactions only if VDOA_WR_CACHE_SEL is
 * set.
 *
 * Values:
 * - 0 - Cacheable attribute is off for write transactions.
 * - 1 - Cacheable attribute is on for write transactions.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VDOA_WR_CACHE_VAL (29U) /*!< Bit position for IOMUXC_GPR4_VDOA_WR_CACHE_VAL. */
#define BM_IOMUXC_GPR4_VDOA_WR_CACHE_VAL (0x20000000U) /*!< Bit mask for IOMUXC_GPR4_VDOA_WR_CACHE_VAL. */
#define BS_IOMUXC_GPR4_VDOA_WR_CACHE_VAL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VDOA_WR_CACHE_VAL. */

/*! @brief Read current value of the IOMUXC_GPR4_VDOA_WR_CACHE_VAL field. */
#define BR_IOMUXC_GPR4_VDOA_WR_CACHE_VAL(x) (HW_IOMUXC_GPR4(x).B.VDOA_WR_CACHE_VAL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VDOA_WR_CACHE_VAL. */
#define BF_IOMUXC_GPR4_VDOA_WR_CACHE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VDOA_WR_CACHE_VAL) & BM_IOMUXC_GPR4_VDOA_WR_CACHE_VAL)

/*! @brief Set the VDOA_WR_CACHE_VAL field to a new value. */
#define BW_IOMUXC_GPR4_VDOA_WR_CACHE_VAL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VDOA_WR_CACHE_VAL) | BF_IOMUXC_GPR4_VDOA_WR_CACHE_VAL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VDOA_RD_CACHE_SEL[30] (RW)
 *
 * This bit selects the cacheable attribute of VDOA AXI read transcations)
 *
 * Values:
 * - 0 - The read transaction cacheable attribute is driven by the VDOA core
 * - 1 - The read transaction cacheable attribute is driven by VDOA_RD_CACHE_VAL.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VDOA_RD_CACHE_SEL (30U) /*!< Bit position for IOMUXC_GPR4_VDOA_RD_CACHE_SEL. */
#define BM_IOMUXC_GPR4_VDOA_RD_CACHE_SEL (0x40000000U) /*!< Bit mask for IOMUXC_GPR4_VDOA_RD_CACHE_SEL. */
#define BS_IOMUXC_GPR4_VDOA_RD_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VDOA_RD_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_VDOA_RD_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_VDOA_RD_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.VDOA_RD_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VDOA_RD_CACHE_SEL. */
#define BF_IOMUXC_GPR4_VDOA_RD_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VDOA_RD_CACHE_SEL) & BM_IOMUXC_GPR4_VDOA_RD_CACHE_SEL)

/*! @brief Set the VDOA_RD_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_VDOA_RD_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VDOA_RD_CACHE_SEL) | BF_IOMUXC_GPR4_VDOA_RD_CACHE_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR4, field VDOA_WR_CACHE_SEL[31] (RW)
 *
 * This bit selects the cacheable attribute of VDOA AXI write transcations
 *
 * Values:
 * - 0 - The write transactions cacheable attribute is driven by the VDOA core
 * - 1 - The write transactions cacheable attribute is driven by
 *     VDOA_WR_CACHE_VAL.
 */
/*@{*/
#define BP_IOMUXC_GPR4_VDOA_WR_CACHE_SEL (31U) /*!< Bit position for IOMUXC_GPR4_VDOA_WR_CACHE_SEL. */
#define BM_IOMUXC_GPR4_VDOA_WR_CACHE_SEL (0x80000000U) /*!< Bit mask for IOMUXC_GPR4_VDOA_WR_CACHE_SEL. */
#define BS_IOMUXC_GPR4_VDOA_WR_CACHE_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR4_VDOA_WR_CACHE_SEL. */

/*! @brief Read current value of the IOMUXC_GPR4_VDOA_WR_CACHE_SEL field. */
#define BR_IOMUXC_GPR4_VDOA_WR_CACHE_SEL(x) (HW_IOMUXC_GPR4(x).B.VDOA_WR_CACHE_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR4_VDOA_WR_CACHE_SEL. */
#define BF_IOMUXC_GPR4_VDOA_WR_CACHE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR4_VDOA_WR_CACHE_SEL) & BM_IOMUXC_GPR4_VDOA_WR_CACHE_SEL)

/*! @brief Set the VDOA_WR_CACHE_SEL field to a new value. */
#define BW_IOMUXC_GPR4_VDOA_WR_CACHE_SEL(x, v) (HW_IOMUXC_GPR4_WR(x, (HW_IOMUXC_GPR4_RD(x) & ~BM_IOMUXC_GPR4_VDOA_WR_CACHE_SEL) | BF_IOMUXC_GPR4_VDOA_WR_CACHE_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR5 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR5 - GPR (RW)
 *
 * Reset value: 0x00FF4800U
 */
typedef union _hw_iomuxc_gpr5
{
    uint32_t U;
    struct _hw_iomuxc_gpr5_bitfields
    {
        uint32_t ARM_WFI : 4;          /*!< [3:0]  */
        uint32_t ARM_WFE : 4;          /*!< [7:4]  */
        uint32_t L2_CLK_STOP : 1;      /*!< [8]  */
        uint32_t ENET_TXCLK_SEL : 1;   /*!< [9]  */
        uint32_t SATA_SW_PD : 1;       /*!< [10]  */
        uint32_t SATA_SW_RST : 1;      /*!< [11]  */
        uint32_t PRE_PRG_SEL0 : 2;     /*!< [13:12]  */
        uint32_t PRE_PRG_SEL1 : 2;     /*!< [15:14]  */
        uint32_t OCRAM_PR0_CTL : 4;    /*!< [19:16]  */
        uint32_t OCRAM_PR1_CTL : 4;    /*!< [23:20]  */
        uint32_t OCRAM_PR0_STATUS : 4; /*!< [27:24]  */
        uint32_t OCRAM_PR1_STATUS : 4; /*!< [31:28]  */
    } B;
} hw_iomuxc_gpr5_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR5 register
 */
/*@{*/
#define HW_IOMUXC_GPR5_ADDR(x)   ((uintptr_t)(x) + 0x14U)

#define HW_IOMUXC_GPR5(x)        (*(__IO hw_iomuxc_gpr5_t *) HW_IOMUXC_GPR5_ADDR(x))
#define HW_IOMUXC_GPR5_RD(x)     (HW_IOMUXC_GPR5(x).U)
#define HW_IOMUXC_GPR5_WR(x, v)  (HW_IOMUXC_GPR5(x).U = (v))
#define HW_IOMUXC_GPR5_SET(x, v) (HW_IOMUXC_GPR5_WR(x, HW_IOMUXC_GPR5_RD(x) |  (v)))
#define HW_IOMUXC_GPR5_CLR(x, v) (HW_IOMUXC_GPR5_WR(x, HW_IOMUXC_GPR5_RD(x) & ~(v)))
#define HW_IOMUXC_GPR5_TOG(x, v) (HW_IOMUXC_GPR5_WR(x, HW_IOMUXC_GPR5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR5 bitfields
 */

/*!
 * @name Register IOMUXC_GPR5, field ARM_WFI[3:0] (RO)
 *
 * ARM WFI event out indicating on WFI state of the cores (these are status,
 * read only bits)
 *
 * Values:
 * - 0 - ARM Core[GPR5-index] is not in "Wait for Interrupt" mode
 * - 1 - ARM Core[GPR5-index] is in "Wait for Interrupt" mode
 */
/*@{*/
#define BP_IOMUXC_GPR5_ARM_WFI (0U)        /*!< Bit position for IOMUXC_GPR5_ARM_WFI. */
#define BM_IOMUXC_GPR5_ARM_WFI (0x0000000FU) /*!< Bit mask for IOMUXC_GPR5_ARM_WFI. */
#define BS_IOMUXC_GPR5_ARM_WFI (4U)        /*!< Bit field size in bits for IOMUXC_GPR5_ARM_WFI. */

/*! @brief Read current value of the IOMUXC_GPR5_ARM_WFI field. */
#define BR_IOMUXC_GPR5_ARM_WFI(x) (HW_IOMUXC_GPR5(x).B.ARM_WFI)
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field ARM_WFE[7:4] (RO)
 *
 * ARM WFE event out indication on WFE state of the cores (these are status,
 * read only bits)
 *
 * Values:
 * - 0 - ARM Core[GPR5-index - 4] is not in "Wait for Event" mode
 * - 1 - ARM Core[GPR5-index - 4] is in "Wait for Event" mode
 */
/*@{*/
#define BP_IOMUXC_GPR5_ARM_WFE (4U)        /*!< Bit position for IOMUXC_GPR5_ARM_WFE. */
#define BM_IOMUXC_GPR5_ARM_WFE (0x000000F0U) /*!< Bit mask for IOMUXC_GPR5_ARM_WFE. */
#define BS_IOMUXC_GPR5_ARM_WFE (4U)        /*!< Bit field size in bits for IOMUXC_GPR5_ARM_WFE. */

/*! @brief Read current value of the IOMUXC_GPR5_ARM_WFE field. */
#define BR_IOMUXC_GPR5_ARM_WFE(x) (HW_IOMUXC_GPR5(x).B.ARM_WFE)
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field L2_CLK_STOP[8] (RO)
 *
 * L2 cache clock stop indication (this is a status, read only bit)
 *
 * Values:
 * - 0 - L2 cache clock is running
 * - 1 - L2 cache clock stopped
 */
/*@{*/
#define BP_IOMUXC_GPR5_L2_CLK_STOP (8U)    /*!< Bit position for IOMUXC_GPR5_L2_CLK_STOP. */
#define BM_IOMUXC_GPR5_L2_CLK_STOP (0x00000100U) /*!< Bit mask for IOMUXC_GPR5_L2_CLK_STOP. */
#define BS_IOMUXC_GPR5_L2_CLK_STOP (1U)    /*!< Bit field size in bits for IOMUXC_GPR5_L2_CLK_STOP. */

/*! @brief Read current value of the IOMUXC_GPR5_L2_CLK_STOP field. */
#define BR_IOMUXC_GPR5_L2_CLK_STOP(x) (HW_IOMUXC_GPR5(x).B.L2_CLK_STOP)
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field ENET_TXCLK_SEL[9] (RW)
 *
 * Select clock source of ENET MAC0 TX clock
 *
 * Values:
 * - 0 - Clock from pad
 * - 1 - Clock from PLL
 */
/*@{*/
#define BP_IOMUXC_GPR5_ENET_TXCLK_SEL (9U) /*!< Bit position for IOMUXC_GPR5_ENET_TXCLK_SEL. */
#define BM_IOMUXC_GPR5_ENET_TXCLK_SEL (0x00000200U) /*!< Bit mask for IOMUXC_GPR5_ENET_TXCLK_SEL. */
#define BS_IOMUXC_GPR5_ENET_TXCLK_SEL (1U) /*!< Bit field size in bits for IOMUXC_GPR5_ENET_TXCLK_SEL. */

/*! @brief Read current value of the IOMUXC_GPR5_ENET_TXCLK_SEL field. */
#define BR_IOMUXC_GPR5_ENET_TXCLK_SEL(x) (HW_IOMUXC_GPR5(x).B.ENET_TXCLK_SEL)

/*! @brief Format value for bitfield IOMUXC_GPR5_ENET_TXCLK_SEL. */
#define BF_IOMUXC_GPR5_ENET_TXCLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_ENET_TXCLK_SEL) & BM_IOMUXC_GPR5_ENET_TXCLK_SEL)

/*! @brief Set the ENET_TXCLK_SEL field to a new value. */
#define BW_IOMUXC_GPR5_ENET_TXCLK_SEL(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_ENET_TXCLK_SEL) | BF_IOMUXC_GPR5_ENET_TXCLK_SEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field SATA_SW_PD[10] (RW)
 *
 * SATA PHY power down
 *
 * Values:
 * - 0 - inactive
 * - 1 - active
 */
/*@{*/
#define BP_IOMUXC_GPR5_SATA_SW_PD (10U)    /*!< Bit position for IOMUXC_GPR5_SATA_SW_PD. */
#define BM_IOMUXC_GPR5_SATA_SW_PD (0x00000400U) /*!< Bit mask for IOMUXC_GPR5_SATA_SW_PD. */
#define BS_IOMUXC_GPR5_SATA_SW_PD (1U)     /*!< Bit field size in bits for IOMUXC_GPR5_SATA_SW_PD. */

/*! @brief Read current value of the IOMUXC_GPR5_SATA_SW_PD field. */
#define BR_IOMUXC_GPR5_SATA_SW_PD(x) (HW_IOMUXC_GPR5(x).B.SATA_SW_PD)

/*! @brief Format value for bitfield IOMUXC_GPR5_SATA_SW_PD. */
#define BF_IOMUXC_GPR5_SATA_SW_PD(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_SATA_SW_PD) & BM_IOMUXC_GPR5_SATA_SW_PD)

/*! @brief Set the SATA_SW_PD field to a new value. */
#define BW_IOMUXC_GPR5_SATA_SW_PD(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_SATA_SW_PD) | BF_IOMUXC_GPR5_SATA_SW_PD(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field SATA_SW_RST[11] (RW)
 *
 * SATA PHY software reset.
 *
 * Values:
 * - 0 - inactive
 * - 1 - active
 */
/*@{*/
#define BP_IOMUXC_GPR5_SATA_SW_RST (11U)   /*!< Bit position for IOMUXC_GPR5_SATA_SW_RST. */
#define BM_IOMUXC_GPR5_SATA_SW_RST (0x00000800U) /*!< Bit mask for IOMUXC_GPR5_SATA_SW_RST. */
#define BS_IOMUXC_GPR5_SATA_SW_RST (1U)    /*!< Bit field size in bits for IOMUXC_GPR5_SATA_SW_RST. */

/*! @brief Read current value of the IOMUXC_GPR5_SATA_SW_RST field. */
#define BR_IOMUXC_GPR5_SATA_SW_RST(x) (HW_IOMUXC_GPR5(x).B.SATA_SW_RST)

/*! @brief Format value for bitfield IOMUXC_GPR5_SATA_SW_RST. */
#define BF_IOMUXC_GPR5_SATA_SW_RST(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_SATA_SW_RST) & BM_IOMUXC_GPR5_SATA_SW_RST)

/*! @brief Set the SATA_SW_RST field to a new value. */
#define BW_IOMUXC_GPR5_SATA_SW_RST(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_SATA_SW_RST) | BF_IOMUXC_GPR5_SATA_SW_RST(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field PRE_PRG_SEL0[13:12] (RW)
 *
 * Select 1 of 4 PRG channels for PRE1.
 */
/*@{*/
#define BP_IOMUXC_GPR5_PRE_PRG_SEL0 (12U)  /*!< Bit position for IOMUXC_GPR5_PRE_PRG_SEL0. */
#define BM_IOMUXC_GPR5_PRE_PRG_SEL0 (0x00003000U) /*!< Bit mask for IOMUXC_GPR5_PRE_PRG_SEL0. */
#define BS_IOMUXC_GPR5_PRE_PRG_SEL0 (2U)   /*!< Bit field size in bits for IOMUXC_GPR5_PRE_PRG_SEL0. */

/*! @brief Read current value of the IOMUXC_GPR5_PRE_PRG_SEL0 field. */
#define BR_IOMUXC_GPR5_PRE_PRG_SEL0(x) (HW_IOMUXC_GPR5(x).B.PRE_PRG_SEL0)

/*! @brief Format value for bitfield IOMUXC_GPR5_PRE_PRG_SEL0. */
#define BF_IOMUXC_GPR5_PRE_PRG_SEL0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_PRE_PRG_SEL0) & BM_IOMUXC_GPR5_PRE_PRG_SEL0)

/*! @brief Set the PRE_PRG_SEL0 field to a new value. */
#define BW_IOMUXC_GPR5_PRE_PRG_SEL0(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_PRE_PRG_SEL0) | BF_IOMUXC_GPR5_PRE_PRG_SEL0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field PRE_PRG_SEL1[15:14] (RW)
 *
 * Select 1 of 4 PRG channels for PRE2.
 */
/*@{*/
#define BP_IOMUXC_GPR5_PRE_PRG_SEL1 (14U)  /*!< Bit position for IOMUXC_GPR5_PRE_PRG_SEL1. */
#define BM_IOMUXC_GPR5_PRE_PRG_SEL1 (0x0000C000U) /*!< Bit mask for IOMUXC_GPR5_PRE_PRG_SEL1. */
#define BS_IOMUXC_GPR5_PRE_PRG_SEL1 (2U)   /*!< Bit field size in bits for IOMUXC_GPR5_PRE_PRG_SEL1. */

/*! @brief Read current value of the IOMUXC_GPR5_PRE_PRG_SEL1 field. */
#define BR_IOMUXC_GPR5_PRE_PRG_SEL1(x) (HW_IOMUXC_GPR5(x).B.PRE_PRG_SEL1)

/*! @brief Format value for bitfield IOMUXC_GPR5_PRE_PRG_SEL1. */
#define BF_IOMUXC_GPR5_PRE_PRG_SEL1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_PRE_PRG_SEL1) & BM_IOMUXC_GPR5_PRE_PRG_SEL1)

/*! @brief Set the PRE_PRG_SEL1 field to a new value. */
#define BW_IOMUXC_GPR5_PRE_PRG_SEL1(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_PRE_PRG_SEL1) | BF_IOMUXC_GPR5_PRE_PRG_SEL1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field OCRAM_PR0_CTL[19:16] (RW)
 *
 * OCRAM_PRO_CTL[19] write address pipeline control bit. When this feature is
 * enabled, the write address from the AXI master would be delayed 1 cycle before
 * it can be accepted by the on-chip RAM. This can avoid any setup time issue for
 * the write access on the memory cell at high frequency. Enabling this feature
 * would cost at most 1 more clock cycle for each AXI write transaction, i.e., at
 * most 1 more clock cycle for each write burst with multiple beats of data. When
 * this feature is disabled, the write address from the AXI master can be
 * accepted by the on-chip RAM without delay, and data can be written to memory at this
 * cycle (if no other access and write data is also ready at this cycle). 0
 * write address pipeline is disabled 1 write address pipeline is enabled
 * OCRAM_PRO_CTL[18] - write data pipeline control bit When this feature is enabled, the
 * write data from the AXI master would be delayed 1 cycle before it can be accepted
 * by the on-chip RAM. This can avoid any setup time issue for the write access
 * on the memory cell at high frequency. Enabling this feature would cost at most
 * 1 more clock cycle for each AXI write transaction, i.e., at most 1 more clock
 * cycle for each write burst with multiple beats of data. When this feature is
 * disabled, the write data from the AXI master can be accepted by the on-chip
 * RAM without delay, and data can be written to memory at this cycle (if no other
 * access and write address is also ready at this cycle). 0 write data pipeline
 * is disabled 1 write data pipeline is enabled OCRAM_PRO_CTL[17] read address
 * pipeline control bit. When this feature is enabled, the read address from the AXI
 * master would be delayed 1 cycle before it can be accepted by the on-chip RAM.
 * This can avoid any setup time issue for the read access on the memory cell at
 * high frequency. Enabling this feature would cost at most 1 more clock cycle
 * for each AXI read transaction, i.e., at most 1 more clock cycle for each read
 * burst with multiple beats of data. When this feature is disabled, the read
 * address from the AXI master can be accepted by the on-chip RAM without delay, and
 * data can become ready for master at next clock cycle (if no other access and
 * no read data wait). 0 read address pipeline is disabled 1 read address pipeline
 * is enabled OCRAM_PRO_CTL[16] - read data wait state control bit When the read
 * data wait state is enabled, it will cost 2 cycles for each read access, (each
 * beat of a read burst). This can avoid the potential timing problem caused by
 * the relatively longer memory access time at higher frequency. When this
 * feature is disabled, it only costs 1 clock cycle to finish a read transaction, i.e.,
 * get read data back in the next cycle of read request becomes valid on the bus.
 *
 * Values:
 * - 0 - read data pipeline is disabled
 * - 1 - read data pipeline is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR5_OCRAM_PR0_CTL (16U) /*!< Bit position for IOMUXC_GPR5_OCRAM_PR0_CTL. */
#define BM_IOMUXC_GPR5_OCRAM_PR0_CTL (0x000F0000U) /*!< Bit mask for IOMUXC_GPR5_OCRAM_PR0_CTL. */
#define BS_IOMUXC_GPR5_OCRAM_PR0_CTL (4U)  /*!< Bit field size in bits for IOMUXC_GPR5_OCRAM_PR0_CTL. */

/*! @brief Read current value of the IOMUXC_GPR5_OCRAM_PR0_CTL field. */
#define BR_IOMUXC_GPR5_OCRAM_PR0_CTL(x) (HW_IOMUXC_GPR5(x).B.OCRAM_PR0_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR5_OCRAM_PR0_CTL. */
#define BF_IOMUXC_GPR5_OCRAM_PR0_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_OCRAM_PR0_CTL) & BM_IOMUXC_GPR5_OCRAM_PR0_CTL)

/*! @brief Set the OCRAM_PR0_CTL field to a new value. */
#define BW_IOMUXC_GPR5_OCRAM_PR0_CTL(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_OCRAM_PR0_CTL) | BF_IOMUXC_GPR5_OCRAM_PR0_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field OCRAM_PR1_CTL[23:20] (RW)
 *
 * OCRAM_PR1_CTL[23] write address pipeline control bit. When this feature is
 * enabled, the write address from the AXI master would be delayed 1 cycle before
 * it can be accepted by the on-chip RAM. This can avoid any setup time issue for
 * the write access on the memory cell at high frequency. Enabling this feature
 * would cost at most 1 more clock cycle for each AXI write transaction, i.e., at
 * most 1 more clock cycle for each write burst with multiple beats of data. When
 * this feature is disabled, the write address from the AXI master can be
 * accepted by the on-chip RAM without delay, and data can be written to memory at this
 * cycle (if no other access and write data is also ready at this cycle). 0
 * write address pipeline is disabled 1 write address pipeline is enabled
 * OCRAM_PR1_CTL[22] - write data pipeline control bit When this feature is enabled, the
 * write data from the AXI master would be delayed 1 cycle before it can be accepted
 * by the on-chip RAM. This can avoid any setup time issue for the write access
 * on the memory cell at high frequency. Enabling this feature would cost at most
 * 1 more clock cycle for each AXI write transaction, i.e., at most 1 more clock
 * cycle for each write burst with multiple beats of data. When this feature is
 * disabled, the write data from the AXI master can be accepted by the on-chip
 * RAM without delay, and data can be written to memory at this cycle (if no other
 * access and write address is also ready at this cycle). 0 write data pipeline
 * is disabled 1 write data pipeline is enabled OCRAM_PR1_CTL[21] read address
 * pipeline control bit. When this feature is enabled, the read address from the AXI
 * master would be delayed 1 cycle before it can be accepted by the on-chip RAM.
 * This can avoid any setup time issue for the read access on the memory cell at
 * high frequency. Enabling this feature would cost at most 1 more clock cycle
 * for each AXI read transaction, i.e., at most 1 more clock cycle for each read
 * burst with multiple beats of data. When this feature is disabled, the read
 * address from the AXI master can be accepted by the on-chip RAM without delay, and
 * data can become ready for master at next clock cycle (if no other access and
 * no read data wait). 0 read address pipeline is disabled 1 read address pipeline
 * is enabled OCRAM_PR1_CTL[20] - read data wait state control bit When the read
 * data wait state is enabled, it will cost 2 cycles for each read access, (each
 * beat of a read burst). This can avoid the potential timing problem caused by
 * the relatively longer memory access time at higher frequency. When this
 * feature is disabled, it only costs 1 clock cycle to finish a read transaction, i.e.,
 * get read data back in the next cycle of read request becomes valid on the bus.
 *
 * Values:
 * - 0 - read data pipeline is disabled
 * - 1 - read data pipeline is enabled
 */
/*@{*/
#define BP_IOMUXC_GPR5_OCRAM_PR1_CTL (20U) /*!< Bit position for IOMUXC_GPR5_OCRAM_PR1_CTL. */
#define BM_IOMUXC_GPR5_OCRAM_PR1_CTL (0x00F00000U) /*!< Bit mask for IOMUXC_GPR5_OCRAM_PR1_CTL. */
#define BS_IOMUXC_GPR5_OCRAM_PR1_CTL (4U)  /*!< Bit field size in bits for IOMUXC_GPR5_OCRAM_PR1_CTL. */

/*! @brief Read current value of the IOMUXC_GPR5_OCRAM_PR1_CTL field. */
#define BR_IOMUXC_GPR5_OCRAM_PR1_CTL(x) (HW_IOMUXC_GPR5(x).B.OCRAM_PR1_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR5_OCRAM_PR1_CTL. */
#define BF_IOMUXC_GPR5_OCRAM_PR1_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR5_OCRAM_PR1_CTL) & BM_IOMUXC_GPR5_OCRAM_PR1_CTL)

/*! @brief Set the OCRAM_PR1_CTL field to a new value. */
#define BW_IOMUXC_GPR5_OCRAM_PR1_CTL(x, v) (HW_IOMUXC_GPR5_WR(x, (HW_IOMUXC_GPR5_RD(x) & ~BM_IOMUXC_GPR5_OCRAM_PR1_CTL) | BF_IOMUXC_GPR5_OCRAM_PR1_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field OCRAM_PR0_STATUS[27:24] (RO)
 *
 * This field shows the OCRAM pipeline settings status, controlled by
 * OCRAM_PR0_CTL bits respectively. When the control bit is changed, the corresponding
 * status bit goes high and keeps high until this new configuration is applied the
 * internal logic. This provides a way for software to detect that the
 * configuration has become valid. The suggested flow for changing the configuration in
 * software is: set/clear the control bit poll the status bit until it goes to 0
 * OCRAM_PR0_STATUS[27] shows the write address pipeline status. This bit value
 * reflects the propagation of the respective control bit to OCRAM memory.
 * OCRAM_PR0_STATUS[26] shows the write data pipeline status. This bit value reflects the
 * propagation of the respective control bit to OCRAM memory. OCRAM_PR0_STATUS[25]
 * shows the read address pipeline status. This bit value reflects the propagation
 * of the respective control bit to OCRAM memory. OCRAM_PR0_STATUS[24] shows the
 * read data pipeline status. This bit value reflects the propagation of the
 * respective control bit to OCRAM memory.
 *
 * Values:
 * - 0 - read data pipeline configuration valid
 * - 1 - read data pipeline control bit changed
 */
/*@{*/
#define BP_IOMUXC_GPR5_OCRAM_PR0_STATUS (24U) /*!< Bit position for IOMUXC_GPR5_OCRAM_PR0_STATUS. */
#define BM_IOMUXC_GPR5_OCRAM_PR0_STATUS (0x0F000000U) /*!< Bit mask for IOMUXC_GPR5_OCRAM_PR0_STATUS. */
#define BS_IOMUXC_GPR5_OCRAM_PR0_STATUS (4U) /*!< Bit field size in bits for IOMUXC_GPR5_OCRAM_PR0_STATUS. */

/*! @brief Read current value of the IOMUXC_GPR5_OCRAM_PR0_STATUS field. */
#define BR_IOMUXC_GPR5_OCRAM_PR0_STATUS(x) (HW_IOMUXC_GPR5(x).B.OCRAM_PR0_STATUS)
/*@}*/

/*!
 * @name Register IOMUXC_GPR5, field OCRAM_PR1_STATUS[31:28] (RO)
 *
 * This field shows the OCRAM pipeline settings status, controlled by
 * OCRAM_PR1_CTL bits respectively. When the control bit is changed, the corresponding
 * status bit goes high and keeps high until this new configuration is applied the
 * internal logic. This provides a way for software to detect that the
 * configuration has become valid. The suggested flow for changing the configuration in
 * software is: set/clear the control bit poll the status bit until it goes to 0
 * OCRAM_PR1_STATUS[31] shows the write address pipeline status. This bit value
 * reflects the propagation of the respective control bit to OCRAM memory.
 * OCRAM_PR1_STATUS[30] shows the write data pipeline status. This bit value reflects the
 * propagation of the respective control bit to OCRAM memory. OCRAM_PR1_STATUS[29]
 * shows the read address pipeline status. This bit value reflects the propagation
 * of the respective control bit to OCRAM memory. OCRAM_PR1_STATUS[28] shows the
 * read data pipeline status. This bit value reflects the propagation of the
 * respective control bit to OCRAM memory.
 *
 * Values:
 * - 0 - read data pipeline configuration valid
 * - 1 - read data pipeline control bit changed
 */
/*@{*/
#define BP_IOMUXC_GPR5_OCRAM_PR1_STATUS (28U) /*!< Bit position for IOMUXC_GPR5_OCRAM_PR1_STATUS. */
#define BM_IOMUXC_GPR5_OCRAM_PR1_STATUS (0xF0000000U) /*!< Bit mask for IOMUXC_GPR5_OCRAM_PR1_STATUS. */
#define BS_IOMUXC_GPR5_OCRAM_PR1_STATUS (4U) /*!< Bit field size in bits for IOMUXC_GPR5_OCRAM_PR1_STATUS. */

/*! @brief Read current value of the IOMUXC_GPR5_OCRAM_PR1_STATUS field. */
#define BR_IOMUXC_GPR5_OCRAM_PR1_STATUS(x) (HW_IOMUXC_GPR5(x).B.OCRAM_PR1_STATUS)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR6 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR6 - GPR (RW)
 *
 * Reset value: 0x22222222U
 */
typedef union _hw_iomuxc_gpr6
{
    uint32_t U;
    struct _hw_iomuxc_gpr6_bitfields
    {
        uint32_t IPU1_ID00_WR_QoS : 4; /*!< [3:0]  */
        uint32_t IPU1_ID01_WR_QoS : 4; /*!< [7:4]  */
        uint32_t IPU1_ID10_WR_QoS : 4; /*!< [11:8]  */
        uint32_t IPU1_ID11_WR_QoS : 4; /*!< [15:12]  */
        uint32_t IPU1_ID00_RD_QoS : 4; /*!< [19:16]  */
        uint32_t IPU1_ID01_RD_QoS : 4; /*!< [23:20]  */
        uint32_t IPU1_ID10_RD_QoS : 4; /*!< [27:24]  */
        uint32_t IPU1_ID11_RD_QoS : 4; /*!< [31:28]  */
    } B;
} hw_iomuxc_gpr6_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR6 register
 */
/*@{*/
#define HW_IOMUXC_GPR6_ADDR(x)   ((uintptr_t)(x) + 0x18U)

#define HW_IOMUXC_GPR6(x)        (*(__IO hw_iomuxc_gpr6_t *) HW_IOMUXC_GPR6_ADDR(x))
#define HW_IOMUXC_GPR6_RD(x)     (HW_IOMUXC_GPR6(x).U)
#define HW_IOMUXC_GPR6_WR(x, v)  (HW_IOMUXC_GPR6(x).U = (v))
#define HW_IOMUXC_GPR6_SET(x, v) (HW_IOMUXC_GPR6_WR(x, HW_IOMUXC_GPR6_RD(x) |  (v)))
#define HW_IOMUXC_GPR6_CLR(x, v) (HW_IOMUXC_GPR6_WR(x, HW_IOMUXC_GPR6_RD(x) & ~(v)))
#define HW_IOMUXC_GPR6_TOG(x, v) (HW_IOMUXC_GPR6_WR(x, HW_IOMUXC_GPR6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR6 bitfields
 */

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID00_WR_QoS[3:0] (RW)
 *
 * IPU1 Write AXI ID=00 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID00_WR_QoS (0U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID00_WR_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID00_WR_QoS (0x0000000FU) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID00_WR_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID00_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID00_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID00_WR_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID00_WR_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID00_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID00_WR_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID00_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID00_WR_QoS) & BM_IOMUXC_GPR6_IPU1_ID00_WR_QoS)

/*! @brief Set the IPU1_ID00_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID00_WR_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID00_WR_QoS) | BF_IOMUXC_GPR6_IPU1_ID00_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID01_WR_QoS[7:4] (RW)
 *
 * IPU1 Write AXI ID=01 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID01_WR_QoS (4U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID01_WR_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID01_WR_QoS (0x000000F0U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID01_WR_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID01_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID01_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID01_WR_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID01_WR_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID01_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID01_WR_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID01_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID01_WR_QoS) & BM_IOMUXC_GPR6_IPU1_ID01_WR_QoS)

/*! @brief Set the IPU1_ID01_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID01_WR_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID01_WR_QoS) | BF_IOMUXC_GPR6_IPU1_ID01_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID10_WR_QoS[11:8] (RW)
 *
 * IPU1 Write AXI ID=10 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID10_WR_QoS (8U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID10_WR_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID10_WR_QoS (0x00000F00U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID10_WR_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID10_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID10_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID10_WR_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID10_WR_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID10_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID10_WR_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID10_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID10_WR_QoS) & BM_IOMUXC_GPR6_IPU1_ID10_WR_QoS)

/*! @brief Set the IPU1_ID10_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID10_WR_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID10_WR_QoS) | BF_IOMUXC_GPR6_IPU1_ID10_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID11_WR_QoS[15:12] (RW)
 *
 * IPU1 Write AXI ID=11 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID11_WR_QoS (12U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID11_WR_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID11_WR_QoS (0x0000F000U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID11_WR_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID11_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID11_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID11_WR_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID11_WR_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID11_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID11_WR_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID11_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID11_WR_QoS) & BM_IOMUXC_GPR6_IPU1_ID11_WR_QoS)

/*! @brief Set the IPU1_ID11_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID11_WR_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID11_WR_QoS) | BF_IOMUXC_GPR6_IPU1_ID11_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID00_RD_QoS[19:16] (RW)
 *
 * IPU1 Read AXI ID=00 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID00_RD_QoS (16U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID00_RD_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID00_RD_QoS (0x000F0000U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID00_RD_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID00_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID00_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID00_RD_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID00_RD_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID00_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID00_RD_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID00_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID00_RD_QoS) & BM_IOMUXC_GPR6_IPU1_ID00_RD_QoS)

/*! @brief Set the IPU1_ID00_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID00_RD_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID00_RD_QoS) | BF_IOMUXC_GPR6_IPU1_ID00_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID01_RD_QoS[23:20] (RW)
 *
 * IPU1 Read AXI ID=01 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID01_RD_QoS (20U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID01_RD_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID01_RD_QoS (0x00F00000U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID01_RD_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID01_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID01_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID01_RD_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID01_RD_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID01_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID01_RD_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID01_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID01_RD_QoS) & BM_IOMUXC_GPR6_IPU1_ID01_RD_QoS)

/*! @brief Set the IPU1_ID01_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID01_RD_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID01_RD_QoS) | BF_IOMUXC_GPR6_IPU1_ID01_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID10_RD_QoS[27:24] (RW)
 *
 * IPU1 Read AXI ID=10 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID10_RD_QoS (24U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID10_RD_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID10_RD_QoS (0x0F000000U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID10_RD_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID10_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID10_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID10_RD_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID10_RD_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID10_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID10_RD_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID10_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID10_RD_QoS) & BM_IOMUXC_GPR6_IPU1_ID10_RD_QoS)

/*! @brief Set the IPU1_ID10_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID10_RD_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID10_RD_QoS) | BF_IOMUXC_GPR6_IPU1_ID10_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR6, field IPU1_ID11_RD_QoS[31:28] (RW)
 *
 * IPU1 Read AXI ID=11 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR6_IPU1_ID11_RD_QoS (28U) /*!< Bit position for IOMUXC_GPR6_IPU1_ID11_RD_QoS. */
#define BM_IOMUXC_GPR6_IPU1_ID11_RD_QoS (0xF0000000U) /*!< Bit mask for IOMUXC_GPR6_IPU1_ID11_RD_QoS. */
#define BS_IOMUXC_GPR6_IPU1_ID11_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR6_IPU1_ID11_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR6_IPU1_ID11_RD_QoS field. */
#define BR_IOMUXC_GPR6_IPU1_ID11_RD_QoS(x) (HW_IOMUXC_GPR6(x).B.IPU1_ID11_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR6_IPU1_ID11_RD_QoS. */
#define BF_IOMUXC_GPR6_IPU1_ID11_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR6_IPU1_ID11_RD_QoS) & BM_IOMUXC_GPR6_IPU1_ID11_RD_QoS)

/*! @brief Set the IPU1_ID11_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR6_IPU1_ID11_RD_QoS(x, v) (HW_IOMUXC_GPR6_WR(x, (HW_IOMUXC_GPR6_RD(x) & ~BM_IOMUXC_GPR6_IPU1_ID11_RD_QoS) | BF_IOMUXC_GPR6_IPU1_ID11_RD_QoS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR7 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR7 - GPR (RW)
 *
 * Reset value: 0x22222222U
 */
typedef union _hw_iomuxc_gpr7
{
    uint32_t U;
    struct _hw_iomuxc_gpr7_bitfields
    {
        uint32_t IPU2_ID00_WR_QoS : 4; /*!< [3:0]  */
        uint32_t IPU2_ID01_WR_QoS : 4; /*!< [7:4]  */
        uint32_t IPU2_ID10_WR_QoS : 4; /*!< [11:8]  */
        uint32_t IPU2_ID11_WR_QoS : 4; /*!< [15:12]  */
        uint32_t IPU2_ID00_RD_QoS : 4; /*!< [19:16]  */
        uint32_t IPU2_ID01_RD_QoS : 4; /*!< [23:20]  */
        uint32_t IPU2_ID10_RD_QoS : 4; /*!< [27:24]  */
        uint32_t IPU2_ID11_RD_QoS : 4; /*!< [31:28]  */
    } B;
} hw_iomuxc_gpr7_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR7 register
 */
/*@{*/
#define HW_IOMUXC_GPR7_ADDR(x)   ((uintptr_t)(x) + 0x1CU)

#define HW_IOMUXC_GPR7(x)        (*(__IO hw_iomuxc_gpr7_t *) HW_IOMUXC_GPR7_ADDR(x))
#define HW_IOMUXC_GPR7_RD(x)     (HW_IOMUXC_GPR7(x).U)
#define HW_IOMUXC_GPR7_WR(x, v)  (HW_IOMUXC_GPR7(x).U = (v))
#define HW_IOMUXC_GPR7_SET(x, v) (HW_IOMUXC_GPR7_WR(x, HW_IOMUXC_GPR7_RD(x) |  (v)))
#define HW_IOMUXC_GPR7_CLR(x, v) (HW_IOMUXC_GPR7_WR(x, HW_IOMUXC_GPR7_RD(x) & ~(v)))
#define HW_IOMUXC_GPR7_TOG(x, v) (HW_IOMUXC_GPR7_WR(x, HW_IOMUXC_GPR7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR7 bitfields
 */

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID00_WR_QoS[3:0] (RW)
 *
 * IPU2 Write AXI ID=00 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID00_WR_QoS (0U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID00_WR_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID00_WR_QoS (0x0000000FU) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID00_WR_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID00_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID00_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID00_WR_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID00_WR_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID00_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID00_WR_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID00_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID00_WR_QoS) & BM_IOMUXC_GPR7_IPU2_ID00_WR_QoS)

/*! @brief Set the IPU2_ID00_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID00_WR_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID00_WR_QoS) | BF_IOMUXC_GPR7_IPU2_ID00_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID01_WR_QoS[7:4] (RW)
 *
 * IPU2 Write AXI ID=01 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID01_WR_QoS (4U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID01_WR_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID01_WR_QoS (0x000000F0U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID01_WR_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID01_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID01_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID01_WR_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID01_WR_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID01_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID01_WR_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID01_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID01_WR_QoS) & BM_IOMUXC_GPR7_IPU2_ID01_WR_QoS)

/*! @brief Set the IPU2_ID01_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID01_WR_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID01_WR_QoS) | BF_IOMUXC_GPR7_IPU2_ID01_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID10_WR_QoS[11:8] (RW)
 *
 * IPU2 Write AXI ID=10 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID10_WR_QoS (8U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID10_WR_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID10_WR_QoS (0x00000F00U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID10_WR_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID10_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID10_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID10_WR_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID10_WR_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID10_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID10_WR_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID10_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID10_WR_QoS) & BM_IOMUXC_GPR7_IPU2_ID10_WR_QoS)

/*! @brief Set the IPU2_ID10_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID10_WR_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID10_WR_QoS) | BF_IOMUXC_GPR7_IPU2_ID10_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID11_WR_QoS[15:12] (RW)
 *
 * IPU2 Write AXI ID=11 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID11_WR_QoS (12U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID11_WR_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID11_WR_QoS (0x0000F000U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID11_WR_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID11_WR_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID11_WR_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID11_WR_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID11_WR_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID11_WR_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID11_WR_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID11_WR_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID11_WR_QoS) & BM_IOMUXC_GPR7_IPU2_ID11_WR_QoS)

/*! @brief Set the IPU2_ID11_WR_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID11_WR_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID11_WR_QoS) | BF_IOMUXC_GPR7_IPU2_ID11_WR_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID00_RD_QoS[19:16] (RW)
 *
 * IPU2 Read AXI ID=00 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID00_RD_QoS (16U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID00_RD_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID00_RD_QoS (0x000F0000U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID00_RD_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID00_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID00_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID00_RD_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID00_RD_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID00_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID00_RD_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID00_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID00_RD_QoS) & BM_IOMUXC_GPR7_IPU2_ID00_RD_QoS)

/*! @brief Set the IPU2_ID00_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID00_RD_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID00_RD_QoS) | BF_IOMUXC_GPR7_IPU2_ID00_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID01_RD_QoS[23:20] (RW)
 *
 * IPU2 Read AXI ID=01 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID01_RD_QoS (20U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID01_RD_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID01_RD_QoS (0x00F00000U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID01_RD_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID01_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID01_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID01_RD_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID01_RD_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID01_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID01_RD_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID01_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID01_RD_QoS) & BM_IOMUXC_GPR7_IPU2_ID01_RD_QoS)

/*! @brief Set the IPU2_ID01_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID01_RD_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID01_RD_QoS) | BF_IOMUXC_GPR7_IPU2_ID01_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID10_RD_QoS[27:24] (RW)
 *
 * IPU2 Read AXI ID=10 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID10_RD_QoS (24U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID10_RD_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID10_RD_QoS (0x0F000000U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID10_RD_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID10_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID10_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID10_RD_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID10_RD_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID10_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID10_RD_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID10_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID10_RD_QoS) & BM_IOMUXC_GPR7_IPU2_ID10_RD_QoS)

/*! @brief Set the IPU2_ID10_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID10_RD_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID10_RD_QoS) | BF_IOMUXC_GPR7_IPU2_ID10_RD_QoS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR7, field IPU2_ID11_RD_QoS[31:28] (RW)
 *
 * IPU2 Read AXI ID=11 Quality of Service (QoS) priority 0xxx - 3 lsb's will be
 * passed as configured 1xxx - 1111
 */
/*@{*/
#define BP_IOMUXC_GPR7_IPU2_ID11_RD_QoS (28U) /*!< Bit position for IOMUXC_GPR7_IPU2_ID11_RD_QoS. */
#define BM_IOMUXC_GPR7_IPU2_ID11_RD_QoS (0xF0000000U) /*!< Bit mask for IOMUXC_GPR7_IPU2_ID11_RD_QoS. */
#define BS_IOMUXC_GPR7_IPU2_ID11_RD_QoS (4U) /*!< Bit field size in bits for IOMUXC_GPR7_IPU2_ID11_RD_QoS. */

/*! @brief Read current value of the IOMUXC_GPR7_IPU2_ID11_RD_QoS field. */
#define BR_IOMUXC_GPR7_IPU2_ID11_RD_QoS(x) (HW_IOMUXC_GPR7(x).B.IPU2_ID11_RD_QoS)

/*! @brief Format value for bitfield IOMUXC_GPR7_IPU2_ID11_RD_QoS. */
#define BF_IOMUXC_GPR7_IPU2_ID11_RD_QoS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR7_IPU2_ID11_RD_QoS) & BM_IOMUXC_GPR7_IPU2_ID11_RD_QoS)

/*! @brief Set the IPU2_ID11_RD_QoS field to a new value. */
#define BW_IOMUXC_GPR7_IPU2_ID11_RD_QoS(x, v) (HW_IOMUXC_GPR7_WR(x, (HW_IOMUXC_GPR7_RD(x) & ~BM_IOMUXC_GPR7_IPU2_ID11_RD_QoS) | BF_IOMUXC_GPR7_IPU2_ID11_RD_QoS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR8 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR8 - GPR (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_gpr8
{
    uint32_t U;
    struct _hw_iomuxc_gpr8_bitfields
    {
        uint32_t PCS_TX_DEEMPH_GEN1 : 6; /*!< [5:0]  */
        uint32_t PCS_TX_DEEMPH_GEN2_3P5DB : 6; /*!< [11:6]  */
        uint32_t PCS_TX_DEEMPH_GEN2_6DB : 6; /*!< [17:12]  */
        uint32_t PCS_TX_SWING_FULL : 7; /*!< [24:18]  */
        uint32_t PCS_TX_SWING_LOW : 7; /*!< [31:25]  */
    } B;
} hw_iomuxc_gpr8_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR8 register
 */
/*@{*/
#define HW_IOMUXC_GPR8_ADDR(x)   ((uintptr_t)(x) + 0x20U)

#define HW_IOMUXC_GPR8(x)        (*(__IO hw_iomuxc_gpr8_t *) HW_IOMUXC_GPR8_ADDR(x))
#define HW_IOMUXC_GPR8_RD(x)     (HW_IOMUXC_GPR8(x).U)
#define HW_IOMUXC_GPR8_WR(x, v)  (HW_IOMUXC_GPR8(x).U = (v))
#define HW_IOMUXC_GPR8_SET(x, v) (HW_IOMUXC_GPR8_WR(x, HW_IOMUXC_GPR8_RD(x) |  (v)))
#define HW_IOMUXC_GPR8_CLR(x, v) (HW_IOMUXC_GPR8_WR(x, HW_IOMUXC_GPR8_RD(x) & ~(v)))
#define HW_IOMUXC_GPR8_TOG(x, v) (HW_IOMUXC_GPR8_WR(x, HW_IOMUXC_GPR8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR8 bitfields
 */

/*!
 * @name Register IOMUXC_GPR8, field PCS_TX_DEEMPH_GEN1[5:0] (RW)
 *
 * PCIe_PHY - This static value sets the Tx driver de-emphasis value in the case
 * where pipe0_tx_deemph is set to 1'b1 (the default setting) and the PHY is
 * running at the Gen1 rate. 6'hxx - Gen1 De-emphasis value.
 */
/*@{*/
#define BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1 (0U) /*!< Bit position for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1. */
#define BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1 (0x0000003FU) /*!< Bit mask for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1. */
#define BS_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1 (6U) /*!< Bit field size in bits for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1. */

/*! @brief Read current value of the IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1 field. */
#define BR_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1(x) (HW_IOMUXC_GPR8(x).B.PCS_TX_DEEMPH_GEN1)

/*! @brief Format value for bitfield IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1. */
#define BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1) & BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1)

/*! @brief Set the PCS_TX_DEEMPH_GEN1 field to a new value. */
#define BW_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1(x, v) (HW_IOMUXC_GPR8_WR(x, (HW_IOMUXC_GPR8_RD(x) & ~BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1) | BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR8, field PCS_TX_DEEMPH_GEN2_3P5DB[11:6] (RW)
 *
 * PCIe_PHY - This static value sets the Tx driver de-emphasis value in the case
 * where pipe0_tx_deemph is set to 1'b1 (the default setting) and the PHY is
 * running at the Gen2 (3p5db) rate. 6'hxx - Gen2 De-emphasis value.
 */
/*@{*/
#define BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB (6U) /*!< Bit position for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB. */
#define BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB (0x00000FC0U) /*!< Bit mask for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB. */
#define BS_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB (6U) /*!< Bit field size in bits for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB. */

/*! @brief Read current value of the IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB field. */
#define BR_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB(x) (HW_IOMUXC_GPR8(x).B.PCS_TX_DEEMPH_GEN2_3P5DB)

/*! @brief Format value for bitfield IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB. */
#define BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB) & BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB)

/*! @brief Set the PCS_TX_DEEMPH_GEN2_3P5DB field to a new value. */
#define BW_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB(x, v) (HW_IOMUXC_GPR8_WR(x, (HW_IOMUXC_GPR8_RD(x) & ~BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB) | BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_3P5DB(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR8, field PCS_TX_DEEMPH_GEN2_6DB[17:12] (RW)
 *
 * PCIe_PHY - This static value sets the Tx driver de-emphasis value in the case
 * where pipe0_tx_deemph is set to 1'b0 and the PHY is running at the Gen2 (6db)
 * rate. 6'hxx - Gen2 (6db) De-emphasis value.
 */
/*@{*/
#define BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB (12U) /*!< Bit position for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB. */
#define BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB (0x0003F000U) /*!< Bit mask for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB. */
#define BS_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB (6U) /*!< Bit field size in bits for IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB. */

/*! @brief Read current value of the IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB field. */
#define BR_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB(x) (HW_IOMUXC_GPR8(x).B.PCS_TX_DEEMPH_GEN2_6DB)

/*! @brief Format value for bitfield IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB. */
#define BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB) & BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB)

/*! @brief Set the PCS_TX_DEEMPH_GEN2_6DB field to a new value. */
#define BW_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB(x, v) (HW_IOMUXC_GPR8_WR(x, (HW_IOMUXC_GPR8_RD(x) & ~BM_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB) | BF_IOMUXC_GPR8_PCS_TX_DEEMPH_GEN2_6DB(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR8, field PCS_TX_SWING_FULL[24:18] (RW)
 *
 * PCIe_PHY - This static value sets the Tx driver SWING_FULL value. 7'hxx -
 * Gen2 TX SWING FULL value.
 */
/*@{*/
#define BP_IOMUXC_GPR8_PCS_TX_SWING_FULL (18U) /*!< Bit position for IOMUXC_GPR8_PCS_TX_SWING_FULL. */
#define BM_IOMUXC_GPR8_PCS_TX_SWING_FULL (0x01FC0000U) /*!< Bit mask for IOMUXC_GPR8_PCS_TX_SWING_FULL. */
#define BS_IOMUXC_GPR8_PCS_TX_SWING_FULL (7U) /*!< Bit field size in bits for IOMUXC_GPR8_PCS_TX_SWING_FULL. */

/*! @brief Read current value of the IOMUXC_GPR8_PCS_TX_SWING_FULL field. */
#define BR_IOMUXC_GPR8_PCS_TX_SWING_FULL(x) (HW_IOMUXC_GPR8(x).B.PCS_TX_SWING_FULL)

/*! @brief Format value for bitfield IOMUXC_GPR8_PCS_TX_SWING_FULL. */
#define BF_IOMUXC_GPR8_PCS_TX_SWING_FULL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR8_PCS_TX_SWING_FULL) & BM_IOMUXC_GPR8_PCS_TX_SWING_FULL)

/*! @brief Set the PCS_TX_SWING_FULL field to a new value. */
#define BW_IOMUXC_GPR8_PCS_TX_SWING_FULL(x, v) (HW_IOMUXC_GPR8_WR(x, (HW_IOMUXC_GPR8_RD(x) & ~BM_IOMUXC_GPR8_PCS_TX_SWING_FULL) | BF_IOMUXC_GPR8_PCS_TX_SWING_FULL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR8, field PCS_TX_SWING_LOW[31:25] (RW)
 *
 * PCIe_PHY - This static value sets the launch amplitude of the transmitter
 * when pipe0_tx_swing is set to 1'b0 (default state). 7'hxx - TX launch amplitude
 * swing_low value.
 */
/*@{*/
#define BP_IOMUXC_GPR8_PCS_TX_SWING_LOW (25U) /*!< Bit position for IOMUXC_GPR8_PCS_TX_SWING_LOW. */
#define BM_IOMUXC_GPR8_PCS_TX_SWING_LOW (0xFE000000U) /*!< Bit mask for IOMUXC_GPR8_PCS_TX_SWING_LOW. */
#define BS_IOMUXC_GPR8_PCS_TX_SWING_LOW (7U) /*!< Bit field size in bits for IOMUXC_GPR8_PCS_TX_SWING_LOW. */

/*! @brief Read current value of the IOMUXC_GPR8_PCS_TX_SWING_LOW field. */
#define BR_IOMUXC_GPR8_PCS_TX_SWING_LOW(x) (HW_IOMUXC_GPR8(x).B.PCS_TX_SWING_LOW)

/*! @brief Format value for bitfield IOMUXC_GPR8_PCS_TX_SWING_LOW. */
#define BF_IOMUXC_GPR8_PCS_TX_SWING_LOW(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR8_PCS_TX_SWING_LOW) & BM_IOMUXC_GPR8_PCS_TX_SWING_LOW)

/*! @brief Set the PCS_TX_SWING_LOW field to a new value. */
#define BW_IOMUXC_GPR8_PCS_TX_SWING_LOW(x, v) (HW_IOMUXC_GPR8_WR(x, (HW_IOMUXC_GPR8_RD(x) & ~BM_IOMUXC_GPR8_PCS_TX_SWING_LOW) | BF_IOMUXC_GPR8_PCS_TX_SWING_LOW(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR9 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR9 - GPR (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_gpr9
{
    uint32_t U;
    struct _hw_iomuxc_gpr9_bitfields
    {
        uint32_t TZASC1_BYP : 1;       /*!< [0]  */
        uint32_t TZASC2_BYP : 1;       /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_gpr9_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR9 register
 */
/*@{*/
#define HW_IOMUXC_GPR9_ADDR(x)   ((uintptr_t)(x) + 0x24U)

#define HW_IOMUXC_GPR9(x)        (*(__I hw_iomuxc_gpr9_t *) HW_IOMUXC_GPR9_ADDR(x))
#define HW_IOMUXC_GPR9_RD(x)     (HW_IOMUXC_GPR9(x).U)
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR9 bitfields
 */

/*!
 * @name Register IOMUXC_GPR9, field TZASC1_BYP[0] (RO)
 *
 * TZASC-1 BYPASS MUX control
 *
 * Values:
 * - 0 - The TZASC-1 is bypassed and the transactions to DDR are not being
 *     checked.
 * - 1 - The TZASC-1 is not bypassed and the transactions to DDR are being
 *     monitored / checked.
 */
/*@{*/
#define BP_IOMUXC_GPR9_TZASC1_BYP (0U)     /*!< Bit position for IOMUXC_GPR9_TZASC1_BYP. */
#define BM_IOMUXC_GPR9_TZASC1_BYP (0x00000001U) /*!< Bit mask for IOMUXC_GPR9_TZASC1_BYP. */
#define BS_IOMUXC_GPR9_TZASC1_BYP (1U)     /*!< Bit field size in bits for IOMUXC_GPR9_TZASC1_BYP. */

/*! @brief Read current value of the IOMUXC_GPR9_TZASC1_BYP field. */
#define BR_IOMUXC_GPR9_TZASC1_BYP(x) (HW_IOMUXC_GPR9(x).B.TZASC1_BYP)
/*@}*/

/*!
 * @name Register IOMUXC_GPR9, field TZASC2_BYP[1] (RO)
 *
 * TZASC-2 BYPASS MUX control
 *
 * Values:
 * - 0 - The TZASC-2 is bypassed and the transactions to DDR are not being
 *     checked.
 * - 1 - The TZASC-2 is not bypassed and the transactions to DDR are being
 *     monitored / checked.
 */
/*@{*/
#define BP_IOMUXC_GPR9_TZASC2_BYP (1U)     /*!< Bit position for IOMUXC_GPR9_TZASC2_BYP. */
#define BM_IOMUXC_GPR9_TZASC2_BYP (0x00000002U) /*!< Bit mask for IOMUXC_GPR9_TZASC2_BYP. */
#define BS_IOMUXC_GPR9_TZASC2_BYP (1U)     /*!< Bit field size in bits for IOMUXC_GPR9_TZASC2_BYP. */

/*! @brief Read current value of the IOMUXC_GPR9_TZASC2_BYP field. */
#define BR_IOMUXC_GPR9_TZASC2_BYP(x) (HW_IOMUXC_GPR9(x).B.TZASC2_BYP)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR10 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR10 - GPR (RW)
 *
 * Reset value: 0x00003800U
 */
typedef union _hw_iomuxc_gpr10
{
    uint32_t U;
    struct _hw_iomuxc_gpr10_bitfields
    {
        uint32_t DCIC1_MUX_CTL : 2;    /*!< [1:0]  */
        uint32_t DCIC2_MUX_CTL : 2;    /*!< [3:2]  */
        uint32_t OCRAM_TZ_EN : 1;      /*!< [4]  */
        uint32_t OCRAM_TZ_ADDR : 6;    /*!< [10:5]  */
        uint32_t SEC_ERR_RESP : 1;     /*!< [11]  */
        uint32_t DBG_CLK_EN : 1;       /*!< [12]  */
        uint32_t DBG_EN : 1;           /*!< [13]  */
        uint32_t OCRAM_PR0_TZ_EN : 1;  /*!< [14]  */
        uint32_t OCRAM_PR1_TZ_EN : 1;  /*!< [15]  */
        uint32_t LOCK_DCIC1_MUX_CTL : 2; /*!< [17:16]  */
        uint32_t LOCK_DCIC2_MUX_CTL : 2; /*!< [19:18]  */
        uint32_t LOCK_OCRAM_TZ_EN : 1; /*!< [20]  */
        uint32_t LOCK_OCRAM_TZ_ADDR : 6; /*!< [26:21]  */
        uint32_t LOCK_SEC_ERR_RESP : 1; /*!< [27]  */
        uint32_t LOCK_DBG_CLK_EN : 1;  /*!< [28]  */
        uint32_t LOCK_DBG_EN : 1;      /*!< [29]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_iomuxc_gpr10_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR10 register
 */
/*@{*/
#define HW_IOMUXC_GPR10_ADDR(x)  ((uintptr_t)(x) + 0x28U)

#define HW_IOMUXC_GPR10(x)       (*(__IO hw_iomuxc_gpr10_t *) HW_IOMUXC_GPR10_ADDR(x))
#define HW_IOMUXC_GPR10_RD(x)    (HW_IOMUXC_GPR10(x).U)
#define HW_IOMUXC_GPR10_WR(x, v) (HW_IOMUXC_GPR10(x).U = (v))
#define HW_IOMUXC_GPR10_SET(x, v) (HW_IOMUXC_GPR10_WR(x, HW_IOMUXC_GPR10_RD(x) |  (v)))
#define HW_IOMUXC_GPR10_CLR(x, v) (HW_IOMUXC_GPR10_WR(x, HW_IOMUXC_GPR10_RD(x) & ~(v)))
#define HW_IOMUXC_GPR10_TOG(x, v) (HW_IOMUXC_GPR10_WR(x, HW_IOMUXC_GPR10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR10 bitfields
 */

/*!
 * @name Register IOMUXC_GPR10, field DCIC1_MUX_CTL[1:0] (RW)
 *
 * DCIC-1 MUX control
 *
 * Values:
 * - 00 - DCIC-1 source is IPU1 or IPU2 DI0 port
 * - 01 - DCIC-1 source is LVDS0
 * - 10 - DCIC-1 source is LVDS1
 * - 11 - DCIC-1 source is HDMI
 */
/*@{*/
#define BP_IOMUXC_GPR10_DCIC1_MUX_CTL (0U) /*!< Bit position for IOMUXC_GPR10_DCIC1_MUX_CTL. */
#define BM_IOMUXC_GPR10_DCIC1_MUX_CTL (0x00000003U) /*!< Bit mask for IOMUXC_GPR10_DCIC1_MUX_CTL. */
#define BS_IOMUXC_GPR10_DCIC1_MUX_CTL (2U) /*!< Bit field size in bits for IOMUXC_GPR10_DCIC1_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR10_DCIC1_MUX_CTL field. */
#define BR_IOMUXC_GPR10_DCIC1_MUX_CTL(x) (HW_IOMUXC_GPR10(x).B.DCIC1_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR10_DCIC1_MUX_CTL. */
#define BF_IOMUXC_GPR10_DCIC1_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_DCIC1_MUX_CTL) & BM_IOMUXC_GPR10_DCIC1_MUX_CTL)

/*! @brief Set the DCIC1_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR10_DCIC1_MUX_CTL(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_DCIC1_MUX_CTL) | BF_IOMUXC_GPR10_DCIC1_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field DCIC2_MUX_CTL[3:2] (RW)
 *
 * DCIC-2 MUX control
 *
 * Values:
 * - 00 - DCIC-2 source is IPU1 DI1 port
 * - 01 - DCIC-2 source is LVDS0
 * - 10 - DCIC-2 source is LVDS1
 * - 11 - DCIC-2 source is MIPI DPI
 */
/*@{*/
#define BP_IOMUXC_GPR10_DCIC2_MUX_CTL (2U) /*!< Bit position for IOMUXC_GPR10_DCIC2_MUX_CTL. */
#define BM_IOMUXC_GPR10_DCIC2_MUX_CTL (0x0000000CU) /*!< Bit mask for IOMUXC_GPR10_DCIC2_MUX_CTL. */
#define BS_IOMUXC_GPR10_DCIC2_MUX_CTL (2U) /*!< Bit field size in bits for IOMUXC_GPR10_DCIC2_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR10_DCIC2_MUX_CTL field. */
#define BR_IOMUXC_GPR10_DCIC2_MUX_CTL(x) (HW_IOMUXC_GPR10(x).B.DCIC2_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR10_DCIC2_MUX_CTL. */
#define BF_IOMUXC_GPR10_DCIC2_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_DCIC2_MUX_CTL) & BM_IOMUXC_GPR10_DCIC2_MUX_CTL)

/*! @brief Set the DCIC2_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR10_DCIC2_MUX_CTL(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_DCIC2_MUX_CTL) | BF_IOMUXC_GPR10_DCIC2_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field OCRAM_TZ_EN[4] (RW)
 *
 * OCRAM TrustZone (TZ) enable.
 *
 * Values:
 * - 0 - The TrustZone feature is disabled. Entire OCRAM space is available for
 *     all access types (secure/non-secure/user/supervisor).
 * - 1 - The TrustZone feature is enabled. Access to address in the range
 *     specified by [ENDADDR:STARTADDR] follows the execution mode access policy
 *     described in CSU chapter.
 */
/*@{*/
#define BP_IOMUXC_GPR10_OCRAM_TZ_EN (4U)   /*!< Bit position for IOMUXC_GPR10_OCRAM_TZ_EN. */
#define BM_IOMUXC_GPR10_OCRAM_TZ_EN (0x00000010U) /*!< Bit mask for IOMUXC_GPR10_OCRAM_TZ_EN. */
#define BS_IOMUXC_GPR10_OCRAM_TZ_EN (1U)   /*!< Bit field size in bits for IOMUXC_GPR10_OCRAM_TZ_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_OCRAM_TZ_EN field. */
#define BR_IOMUXC_GPR10_OCRAM_TZ_EN(x) (HW_IOMUXC_GPR10(x).B.OCRAM_TZ_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_OCRAM_TZ_EN. */
#define BF_IOMUXC_GPR10_OCRAM_TZ_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_OCRAM_TZ_EN) & BM_IOMUXC_GPR10_OCRAM_TZ_EN)

/*! @brief Set the OCRAM_TZ_EN field to a new value. */
#define BW_IOMUXC_GPR10_OCRAM_TZ_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_OCRAM_TZ_EN) | BF_IOMUXC_GPR10_OCRAM_TZ_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field OCRAM_TZ_ADDR[10:5] (RW)
 *
 * OCRAM TrustZone (TZ) start address. This is the start address of the secure
 * memory region within the OCRAM memory space is 4KB granularity. The start
 * address affects the OCRAM transactions only if OCRAM_TZ_EN bit is set. The OCRAM TZ
 * ENDADDR is not configurable and is set to the end of OCRAM memory space.
 */
/*@{*/
#define BP_IOMUXC_GPR10_OCRAM_TZ_ADDR (5U) /*!< Bit position for IOMUXC_GPR10_OCRAM_TZ_ADDR. */
#define BM_IOMUXC_GPR10_OCRAM_TZ_ADDR (0x000007E0U) /*!< Bit mask for IOMUXC_GPR10_OCRAM_TZ_ADDR. */
#define BS_IOMUXC_GPR10_OCRAM_TZ_ADDR (6U) /*!< Bit field size in bits for IOMUXC_GPR10_OCRAM_TZ_ADDR. */

/*! @brief Read current value of the IOMUXC_GPR10_OCRAM_TZ_ADDR field. */
#define BR_IOMUXC_GPR10_OCRAM_TZ_ADDR(x) (HW_IOMUXC_GPR10(x).B.OCRAM_TZ_ADDR)

/*! @brief Format value for bitfield IOMUXC_GPR10_OCRAM_TZ_ADDR. */
#define BF_IOMUXC_GPR10_OCRAM_TZ_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_OCRAM_TZ_ADDR) & BM_IOMUXC_GPR10_OCRAM_TZ_ADDR)

/*! @brief Set the OCRAM_TZ_ADDR field to a new value. */
#define BW_IOMUXC_GPR10_OCRAM_TZ_ADDR(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_OCRAM_TZ_ADDR) | BF_IOMUXC_GPR10_OCRAM_TZ_ADDR(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field SEC_ERR_RESP[11] (RW)
 *
 * Security error response enable for all security gaskets (on both AHB and AXI
 * busses)
 *
 * Values:
 * - 0 - OKEY response
 * - 1 - SLVError (default)
 */
/*@{*/
#define BP_IOMUXC_GPR10_SEC_ERR_RESP (11U) /*!< Bit position for IOMUXC_GPR10_SEC_ERR_RESP. */
#define BM_IOMUXC_GPR10_SEC_ERR_RESP (0x00000800U) /*!< Bit mask for IOMUXC_GPR10_SEC_ERR_RESP. */
#define BS_IOMUXC_GPR10_SEC_ERR_RESP (1U)  /*!< Bit field size in bits for IOMUXC_GPR10_SEC_ERR_RESP. */

/*! @brief Read current value of the IOMUXC_GPR10_SEC_ERR_RESP field. */
#define BR_IOMUXC_GPR10_SEC_ERR_RESP(x) (HW_IOMUXC_GPR10(x).B.SEC_ERR_RESP)

/*! @brief Format value for bitfield IOMUXC_GPR10_SEC_ERR_RESP. */
#define BF_IOMUXC_GPR10_SEC_ERR_RESP(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_SEC_ERR_RESP) & BM_IOMUXC_GPR10_SEC_ERR_RESP)

/*! @brief Set the SEC_ERR_RESP field to a new value. */
#define BW_IOMUXC_GPR10_SEC_ERR_RESP(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_SEC_ERR_RESP) | BF_IOMUXC_GPR10_SEC_ERR_RESP(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field DBG_CLK_EN[12] (RW)
 *
 * ARM Debug clock enable
 *
 * Values:
 * - 0 - Debug turned off.
 * - 1 - Debug enabled (default).
 */
/*@{*/
#define BP_IOMUXC_GPR10_DBG_CLK_EN (12U)   /*!< Bit position for IOMUXC_GPR10_DBG_CLK_EN. */
#define BM_IOMUXC_GPR10_DBG_CLK_EN (0x00001000U) /*!< Bit mask for IOMUXC_GPR10_DBG_CLK_EN. */
#define BS_IOMUXC_GPR10_DBG_CLK_EN (1U)    /*!< Bit field size in bits for IOMUXC_GPR10_DBG_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_DBG_CLK_EN field. */
#define BR_IOMUXC_GPR10_DBG_CLK_EN(x) (HW_IOMUXC_GPR10(x).B.DBG_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_DBG_CLK_EN. */
#define BF_IOMUXC_GPR10_DBG_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_DBG_CLK_EN) & BM_IOMUXC_GPR10_DBG_CLK_EN)

/*! @brief Set the DBG_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR10_DBG_CLK_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_DBG_CLK_EN) | BF_IOMUXC_GPR10_DBG_CLK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field DBG_EN[13] (RW)
 *
 * ARM non secure (non-invasive) debug enable
 *
 * Values:
 * - 0 - Debug turned off.
 * - 1 - Debug enabled (default).
 */
/*@{*/
#define BP_IOMUXC_GPR10_DBG_EN (13U)       /*!< Bit position for IOMUXC_GPR10_DBG_EN. */
#define BM_IOMUXC_GPR10_DBG_EN (0x00002000U) /*!< Bit mask for IOMUXC_GPR10_DBG_EN. */
#define BS_IOMUXC_GPR10_DBG_EN (1U)        /*!< Bit field size in bits for IOMUXC_GPR10_DBG_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_DBG_EN field. */
#define BR_IOMUXC_GPR10_DBG_EN(x) (HW_IOMUXC_GPR10(x).B.DBG_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_DBG_EN. */
#define BF_IOMUXC_GPR10_DBG_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_DBG_EN) & BM_IOMUXC_GPR10_DBG_EN)

/*! @brief Set the DBG_EN field to a new value. */
#define BW_IOMUXC_GPR10_DBG_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_DBG_EN) | BF_IOMUXC_GPR10_DBG_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field OCRAM_PR0_TZ_EN[14] (RW)
 *
 * OCRAM_PR0 TrustZone (TZ) start address. This is the start address of the
 * secure memory region within the OCRAM_PR0 memory space is 4KB granularity. The
 * start address affects the OCRAM_PR0 transactions only if OCRAM_PR0_TZ_EN bit is
 * set. The OCRAM_PR0 TZ ENDADDR is not configurable and is set to the end of
 * OCRAM_PR0 memory space.
 */
/*@{*/
#define BP_IOMUXC_GPR10_OCRAM_PR0_TZ_EN (14U) /*!< Bit position for IOMUXC_GPR10_OCRAM_PR0_TZ_EN. */
#define BM_IOMUXC_GPR10_OCRAM_PR0_TZ_EN (0x00004000U) /*!< Bit mask for IOMUXC_GPR10_OCRAM_PR0_TZ_EN. */
#define BS_IOMUXC_GPR10_OCRAM_PR0_TZ_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR10_OCRAM_PR0_TZ_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_OCRAM_PR0_TZ_EN field. */
#define BR_IOMUXC_GPR10_OCRAM_PR0_TZ_EN(x) (HW_IOMUXC_GPR10(x).B.OCRAM_PR0_TZ_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_OCRAM_PR0_TZ_EN. */
#define BF_IOMUXC_GPR10_OCRAM_PR0_TZ_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_OCRAM_PR0_TZ_EN) & BM_IOMUXC_GPR10_OCRAM_PR0_TZ_EN)

/*! @brief Set the OCRAM_PR0_TZ_EN field to a new value. */
#define BW_IOMUXC_GPR10_OCRAM_PR0_TZ_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_OCRAM_PR0_TZ_EN) | BF_IOMUXC_GPR10_OCRAM_PR0_TZ_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field OCRAM_PR1_TZ_EN[15] (RW)
 *
 * OCRAM_PR1 TrustZone (TZ) start address. This is the start address of the
 * secure memory region within the OCRAM_PR1 memory space is 4KB granularity. The
 * start address affects the OCRAM_PR1 transactions only if OCRAM_PR1_TZ_EN bit is
 * set. The OCRAM_PR1 TZ ENDADDR is not configurable and is set to the end of
 * OCRAM_PR1 memory space.
 */
/*@{*/
#define BP_IOMUXC_GPR10_OCRAM_PR1_TZ_EN (15U) /*!< Bit position for IOMUXC_GPR10_OCRAM_PR1_TZ_EN. */
#define BM_IOMUXC_GPR10_OCRAM_PR1_TZ_EN (0x00008000U) /*!< Bit mask for IOMUXC_GPR10_OCRAM_PR1_TZ_EN. */
#define BS_IOMUXC_GPR10_OCRAM_PR1_TZ_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR10_OCRAM_PR1_TZ_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_OCRAM_PR1_TZ_EN field. */
#define BR_IOMUXC_GPR10_OCRAM_PR1_TZ_EN(x) (HW_IOMUXC_GPR10(x).B.OCRAM_PR1_TZ_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_OCRAM_PR1_TZ_EN. */
#define BF_IOMUXC_GPR10_OCRAM_PR1_TZ_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_OCRAM_PR1_TZ_EN) & BM_IOMUXC_GPR10_OCRAM_PR1_TZ_EN)

/*! @brief Set the OCRAM_PR1_TZ_EN field to a new value. */
#define BW_IOMUXC_GPR10_OCRAM_PR1_TZ_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_OCRAM_PR1_TZ_EN) | BF_IOMUXC_GPR10_OCRAM_PR1_TZ_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_DCIC1_MUX_CTL[17:16] (RW)
 *
 * Lock DCIC1_MUX_CTL field for changes. This is a sticky field, once set it
 * can't be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL (16U) /*!< Bit position for IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL. */
#define BM_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL (0x00030000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL. */
#define BS_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL (2U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL field. */
#define BR_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL(x) (HW_IOMUXC_GPR10(x).B.LOCK_DCIC1_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL. */
#define BF_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL) & BM_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL)

/*! @brief Set the LOCK_DCIC1_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL) | BF_IOMUXC_GPR10_LOCK_DCIC1_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_DCIC2_MUX_CTL[19:18] (RW)
 *
 * Lock DCIC2_MUX_CTL field for changes. This is a sticky field, once set it
 * can't be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL (18U) /*!< Bit position for IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL. */
#define BM_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL (0x000C0000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL. */
#define BS_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL (2U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL field. */
#define BR_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL(x) (HW_IOMUXC_GPR10(x).B.LOCK_DCIC2_MUX_CTL)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL. */
#define BF_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL) & BM_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL)

/*! @brief Set the LOCK_DCIC2_MUX_CTL field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL) | BF_IOMUXC_GPR10_LOCK_DCIC2_MUX_CTL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_OCRAM_TZ_EN[20] (RW)
 *
 * Lock OCRAM_TZ_EN field for changes. This is a sticky field, once set it can't
 * be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN (20U) /*!< Bit position for IOMUXC_GPR10_LOCK_OCRAM_TZ_EN. */
#define BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN (0x00100000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_OCRAM_TZ_EN. */
#define BS_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_OCRAM_TZ_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_OCRAM_TZ_EN field. */
#define BR_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN(x) (HW_IOMUXC_GPR10(x).B.LOCK_OCRAM_TZ_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_OCRAM_TZ_EN. */
#define BF_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN) & BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN)

/*! @brief Set the LOCK_OCRAM_TZ_EN field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN) | BF_IOMUXC_GPR10_LOCK_OCRAM_TZ_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_OCRAM_TZ_ADDR[26:21] (RW)
 *
 * Lock OCRAM_TZ_ADDR field for changes. This is a sticky field, once set it
 * can't be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR (21U) /*!< Bit position for IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR. */
#define BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR (0x07E00000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR. */
#define BS_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR (6U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR field. */
#define BR_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR(x) (HW_IOMUXC_GPR10(x).B.LOCK_OCRAM_TZ_ADDR)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR. */
#define BF_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR) & BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR)

/*! @brief Set the LOCK_OCRAM_TZ_ADDR field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR) | BF_IOMUXC_GPR10_LOCK_OCRAM_TZ_ADDR(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_SEC_ERR_RESP[27] (RW)
 *
 * Lock SEC_ERR_RESP field for changes. This is a sticky field, once set it
 * can't be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_SEC_ERR_RESP (27U) /*!< Bit position for IOMUXC_GPR10_LOCK_SEC_ERR_RESP. */
#define BM_IOMUXC_GPR10_LOCK_SEC_ERR_RESP (0x08000000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_SEC_ERR_RESP. */
#define BS_IOMUXC_GPR10_LOCK_SEC_ERR_RESP (1U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_SEC_ERR_RESP. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_SEC_ERR_RESP field. */
#define BR_IOMUXC_GPR10_LOCK_SEC_ERR_RESP(x) (HW_IOMUXC_GPR10(x).B.LOCK_SEC_ERR_RESP)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_SEC_ERR_RESP. */
#define BF_IOMUXC_GPR10_LOCK_SEC_ERR_RESP(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_SEC_ERR_RESP) & BM_IOMUXC_GPR10_LOCK_SEC_ERR_RESP)

/*! @brief Set the LOCK_SEC_ERR_RESP field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_SEC_ERR_RESP(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_SEC_ERR_RESP) | BF_IOMUXC_GPR10_LOCK_SEC_ERR_RESP(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_DBG_CLK_EN[28] (RW)
 *
 * Lock DBG_CLK_EN field for changes. This is a sticky field, once set it can't
 * be cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_DBG_CLK_EN (28U) /*!< Bit position for IOMUXC_GPR10_LOCK_DBG_CLK_EN. */
#define BM_IOMUXC_GPR10_LOCK_DBG_CLK_EN (0x10000000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_DBG_CLK_EN. */
#define BS_IOMUXC_GPR10_LOCK_DBG_CLK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_DBG_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_DBG_CLK_EN field. */
#define BR_IOMUXC_GPR10_LOCK_DBG_CLK_EN(x) (HW_IOMUXC_GPR10(x).B.LOCK_DBG_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_DBG_CLK_EN. */
#define BF_IOMUXC_GPR10_LOCK_DBG_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_DBG_CLK_EN) & BM_IOMUXC_GPR10_LOCK_DBG_CLK_EN)

/*! @brief Set the LOCK_DBG_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_DBG_CLK_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_DBG_CLK_EN) | BF_IOMUXC_GPR10_LOCK_DBG_CLK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR10, field LOCK_DBG_EN[29] (RW)
 *
 * Lock DBG_EN field for changes. This is a sticky field, once set it can't be
 * cleared (only by reset).
 *
 * Values:
 * - 0 - Field is not locked
 * - 1 - Field is locked (read access only)
 */
/*@{*/
#define BP_IOMUXC_GPR10_LOCK_DBG_EN (29U)  /*!< Bit position for IOMUXC_GPR10_LOCK_DBG_EN. */
#define BM_IOMUXC_GPR10_LOCK_DBG_EN (0x20000000U) /*!< Bit mask for IOMUXC_GPR10_LOCK_DBG_EN. */
#define BS_IOMUXC_GPR10_LOCK_DBG_EN (1U)   /*!< Bit field size in bits for IOMUXC_GPR10_LOCK_DBG_EN. */

/*! @brief Read current value of the IOMUXC_GPR10_LOCK_DBG_EN field. */
#define BR_IOMUXC_GPR10_LOCK_DBG_EN(x) (HW_IOMUXC_GPR10(x).B.LOCK_DBG_EN)

/*! @brief Format value for bitfield IOMUXC_GPR10_LOCK_DBG_EN. */
#define BF_IOMUXC_GPR10_LOCK_DBG_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR10_LOCK_DBG_EN) & BM_IOMUXC_GPR10_LOCK_DBG_EN)

/*! @brief Set the LOCK_DBG_EN field to a new value. */
#define BW_IOMUXC_GPR10_LOCK_DBG_EN(x, v) (HW_IOMUXC_GPR10_WR(x, (HW_IOMUXC_GPR10_RD(x) & ~BM_IOMUXC_GPR10_LOCK_DBG_EN) | BF_IOMUXC_GPR10_LOCK_DBG_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR11 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR11 - GPR (ROZ)
 *
 * Reset value: 0x00003800U
 */
typedef union _hw_iomuxc_gpr11
{
    uint32_t U;
    struct _hw_iomuxc_gpr11_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_iomuxc_gpr11_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR11 register
 */
/*@{*/
#define HW_IOMUXC_GPR11_ADDR(x)  ((uintptr_t)(x) + 0x2CU)

#define HW_IOMUXC_GPR11(x)       (*(__I hw_iomuxc_gpr11_t *) HW_IOMUXC_GPR11_ADDR(x))
#define HW_IOMUXC_GPR11_RD(x)    (HW_IOMUXC_GPR11(x).U)
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR11 bitfields
 */

/*******************************************************************************
 * HW_IOMUXC_GPR12 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR12 - GPR (RW)
 *
 * Reset value: 0x0F000000U
 */
typedef union _hw_iomuxc_gpr12
{
    uint32_t U;
    struct _hw_iomuxc_gpr12_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t uSDHC_DBG_MUX : 2;    /*!< [3:2]  */
        uint32_t LOS_LEVEL : 5;        /*!< [8:4]  */
        uint32_t APPS_PM_XMT_PME : 1;  /*!< [9]  */
        uint32_t APP_LTSSM_ENABLE : 1; /*!< [10]  */
        uint32_t APP_INIT_RST : 1;     /*!< [11]  */
        uint32_t DEVICE_TYPE : 4;      /*!< [15:12]  */
        uint32_t APPS_PM_XMT_TURNOFF : 1; /*!< [16]  */
        uint32_t DIA_STATUS_BUS_SELECT : 4; /*!< [20:17]  */
        uint32_t PCIe_CTL_7 : 3;       /*!< [23:21]  */
        uint32_t ARMP_APB_CLK_EN : 1;  /*!< [24]  */
        uint32_t ARMP_ATB_CLK_EN : 1;  /*!< [25]  */
        uint32_t ARMP_AHB_CLK_EN : 1;  /*!< [26]  */
        uint32_t ARMP_IPG_CLK_EN : 1;  /*!< [27]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_iomuxc_gpr12_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR12 register
 */
/*@{*/
#define HW_IOMUXC_GPR12_ADDR(x)  ((uintptr_t)(x) + 0x30U)

#define HW_IOMUXC_GPR12(x)       (*(__IO hw_iomuxc_gpr12_t *) HW_IOMUXC_GPR12_ADDR(x))
#define HW_IOMUXC_GPR12_RD(x)    (HW_IOMUXC_GPR12(x).U)
#define HW_IOMUXC_GPR12_WR(x, v) (HW_IOMUXC_GPR12(x).U = (v))
#define HW_IOMUXC_GPR12_SET(x, v) (HW_IOMUXC_GPR12_WR(x, HW_IOMUXC_GPR12_RD(x) |  (v)))
#define HW_IOMUXC_GPR12_CLR(x, v) (HW_IOMUXC_GPR12_WR(x, HW_IOMUXC_GPR12_RD(x) & ~(v)))
#define HW_IOMUXC_GPR12_TOG(x, v) (HW_IOMUXC_GPR12_WR(x, HW_IOMUXC_GPR12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR12 bitfields
 */

/*!
 * @name Register IOMUXC_GPR12, field uSDHC_DBG_MUX[3:2] (RW)
 *
 * uSDHC debug bus IO mux control '00' - uSDHC1 debug '01' - uSDHC2 debug '10' -
 * uSDHC3 debug '11' - uSDHC4 debug
 */
/*@{*/
#define BP_IOMUXC_GPR12_uSDHC_DBG_MUX (2U) /*!< Bit position for IOMUXC_GPR12_uSDHC_DBG_MUX. */
#define BM_IOMUXC_GPR12_uSDHC_DBG_MUX (0x0000000CU) /*!< Bit mask for IOMUXC_GPR12_uSDHC_DBG_MUX. */
#define BS_IOMUXC_GPR12_uSDHC_DBG_MUX (2U) /*!< Bit field size in bits for IOMUXC_GPR12_uSDHC_DBG_MUX. */

/*! @brief Read current value of the IOMUXC_GPR12_uSDHC_DBG_MUX field. */
#define BR_IOMUXC_GPR12_uSDHC_DBG_MUX(x) (HW_IOMUXC_GPR12(x).B.uSDHC_DBG_MUX)

/*! @brief Format value for bitfield IOMUXC_GPR12_uSDHC_DBG_MUX. */
#define BF_IOMUXC_GPR12_uSDHC_DBG_MUX(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_uSDHC_DBG_MUX) & BM_IOMUXC_GPR12_uSDHC_DBG_MUX)

/*! @brief Set the uSDHC_DBG_MUX field to a new value. */
#define BW_IOMUXC_GPR12_uSDHC_DBG_MUX(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_uSDHC_DBG_MUX) | BF_IOMUXC_GPR12_uSDHC_DBG_MUX(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field LOS_LEVEL[8:4] (RW)
 *
 * PCIe_PHY - Loss-of-Signal Detector Sensitivity Level Control Function: Sets
 * the sensitivity level for the Loss-of-Signal detector. This signal must be set
 * to 0x9
 */
/*@{*/
#define BP_IOMUXC_GPR12_LOS_LEVEL (4U)     /*!< Bit position for IOMUXC_GPR12_LOS_LEVEL. */
#define BM_IOMUXC_GPR12_LOS_LEVEL (0x000001F0U) /*!< Bit mask for IOMUXC_GPR12_LOS_LEVEL. */
#define BS_IOMUXC_GPR12_LOS_LEVEL (5U)     /*!< Bit field size in bits for IOMUXC_GPR12_LOS_LEVEL. */

/*! @brief Read current value of the IOMUXC_GPR12_LOS_LEVEL field. */
#define BR_IOMUXC_GPR12_LOS_LEVEL(x) (HW_IOMUXC_GPR12(x).B.LOS_LEVEL)

/*! @brief Format value for bitfield IOMUXC_GPR12_LOS_LEVEL. */
#define BF_IOMUXC_GPR12_LOS_LEVEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_LOS_LEVEL) & BM_IOMUXC_GPR12_LOS_LEVEL)

/*! @brief Set the LOS_LEVEL field to a new value. */
#define BW_IOMUXC_GPR12_LOS_LEVEL(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_LOS_LEVEL) | BF_IOMUXC_GPR12_LOS_LEVEL(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field APPS_PM_XMT_PME[9] (RW)
 *
 * PCIe_CTL - Wake Up. Used by application logic to wake up the PMC state
 * machine from a D1, D2 or D3 power state. Upon wake-up, the core sends a PM_PME
 * Message
 */
/*@{*/
#define BP_IOMUXC_GPR12_APPS_PM_XMT_PME (9U) /*!< Bit position for IOMUXC_GPR12_APPS_PM_XMT_PME. */
#define BM_IOMUXC_GPR12_APPS_PM_XMT_PME (0x00000200U) /*!< Bit mask for IOMUXC_GPR12_APPS_PM_XMT_PME. */
#define BS_IOMUXC_GPR12_APPS_PM_XMT_PME (1U) /*!< Bit field size in bits for IOMUXC_GPR12_APPS_PM_XMT_PME. */

/*! @brief Read current value of the IOMUXC_GPR12_APPS_PM_XMT_PME field. */
#define BR_IOMUXC_GPR12_APPS_PM_XMT_PME(x) (HW_IOMUXC_GPR12(x).B.APPS_PM_XMT_PME)

/*! @brief Format value for bitfield IOMUXC_GPR12_APPS_PM_XMT_PME. */
#define BF_IOMUXC_GPR12_APPS_PM_XMT_PME(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_APPS_PM_XMT_PME) & BM_IOMUXC_GPR12_APPS_PM_XMT_PME)

/*! @brief Set the APPS_PM_XMT_PME field to a new value. */
#define BW_IOMUXC_GPR12_APPS_PM_XMT_PME(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_APPS_PM_XMT_PME) | BF_IOMUXC_GPR12_APPS_PM_XMT_PME(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field APP_LTSSM_ENABLE[10] (RW)
 *
 * PCIe_CTL - Driven low by the application after reset to hold the LTSSM in the
 * Detect state until the application is ready. When the application has
 * finished initializing the core configuration registers, it asserts app_ltssm_enable
 * to allow the LTSSM to continue Link establishment.
 *
 * Values:
 * - 0 - Application is not ready.
 * - 1 - Application is ready.
 */
/*@{*/
#define BP_IOMUXC_GPR12_APP_LTSSM_ENABLE (10U) /*!< Bit position for IOMUXC_GPR12_APP_LTSSM_ENABLE. */
#define BM_IOMUXC_GPR12_APP_LTSSM_ENABLE (0x00000400U) /*!< Bit mask for IOMUXC_GPR12_APP_LTSSM_ENABLE. */
#define BS_IOMUXC_GPR12_APP_LTSSM_ENABLE (1U) /*!< Bit field size in bits for IOMUXC_GPR12_APP_LTSSM_ENABLE. */

/*! @brief Read current value of the IOMUXC_GPR12_APP_LTSSM_ENABLE field. */
#define BR_IOMUXC_GPR12_APP_LTSSM_ENABLE(x) (HW_IOMUXC_GPR12(x).B.APP_LTSSM_ENABLE)

/*! @brief Format value for bitfield IOMUXC_GPR12_APP_LTSSM_ENABLE. */
#define BF_IOMUXC_GPR12_APP_LTSSM_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_APP_LTSSM_ENABLE) & BM_IOMUXC_GPR12_APP_LTSSM_ENABLE)

/*! @brief Set the APP_LTSSM_ENABLE field to a new value. */
#define BW_IOMUXC_GPR12_APP_LTSSM_ENABLE(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_APP_LTSSM_ENABLE) | BF_IOMUXC_GPR12_APP_LTSSM_ENABLE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field APP_INIT_RST[11] (RW)
 *
 * PCIe_CTL - Request from the application to send a Hot Reset to the downstream
 * device.
 */
/*@{*/
#define BP_IOMUXC_GPR12_APP_INIT_RST (11U) /*!< Bit position for IOMUXC_GPR12_APP_INIT_RST. */
#define BM_IOMUXC_GPR12_APP_INIT_RST (0x00000800U) /*!< Bit mask for IOMUXC_GPR12_APP_INIT_RST. */
#define BS_IOMUXC_GPR12_APP_INIT_RST (1U)  /*!< Bit field size in bits for IOMUXC_GPR12_APP_INIT_RST. */

/*! @brief Read current value of the IOMUXC_GPR12_APP_INIT_RST field. */
#define BR_IOMUXC_GPR12_APP_INIT_RST(x) (HW_IOMUXC_GPR12(x).B.APP_INIT_RST)

/*! @brief Format value for bitfield IOMUXC_GPR12_APP_INIT_RST. */
#define BF_IOMUXC_GPR12_APP_INIT_RST(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_APP_INIT_RST) & BM_IOMUXC_GPR12_APP_INIT_RST)

/*! @brief Set the APP_INIT_RST field to a new value. */
#define BW_IOMUXC_GPR12_APP_INIT_RST(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_APP_INIT_RST) | BF_IOMUXC_GPR12_APP_INIT_RST(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field DEVICE_TYPE[15:12] (RW)
 *
 * PCIe_CTL - Device/Port Type. Indicates the specific type of this PCI Express
 * Function (EP or RC) DEVICE_TYPE field values 0011-1111 are reserved.
 *
 * Values:
 * - 0000 - EP Mode
 * - 0010 - RC Mode
 */
/*@{*/
#define BP_IOMUXC_GPR12_DEVICE_TYPE (12U)  /*!< Bit position for IOMUXC_GPR12_DEVICE_TYPE. */
#define BM_IOMUXC_GPR12_DEVICE_TYPE (0x0000F000U) /*!< Bit mask for IOMUXC_GPR12_DEVICE_TYPE. */
#define BS_IOMUXC_GPR12_DEVICE_TYPE (4U)   /*!< Bit field size in bits for IOMUXC_GPR12_DEVICE_TYPE. */

#define BV_IOMUXC_GPR12_DEVICE_TYPE_PCIE_EP (0U)     /*!< Bit field value for IOMUXC_GPR12_DEVICE_TYPE: EP Mode */
#define BV_IOMUXC_GPR12_DEVICE_TYPE_PCIE_RC (0x2U)   /*!< Bit field value for IOMUXC_GPR12_DEVICE_TYPE: RC Mode */

/*! @brief Read current value of the IOMUXC_GPR12_DEVICE_TYPE field. */
#define BR_IOMUXC_GPR12_DEVICE_TYPE(x) (HW_IOMUXC_GPR12(x).B.DEVICE_TYPE)

/*! @brief Format value for bitfield IOMUXC_GPR12_DEVICE_TYPE. */
#define BF_IOMUXC_GPR12_DEVICE_TYPE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_DEVICE_TYPE) & BM_IOMUXC_GPR12_DEVICE_TYPE)

/*! @brief Set the DEVICE_TYPE field to a new value. */
#define BW_IOMUXC_GPR12_DEVICE_TYPE(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_DEVICE_TYPE) | BF_IOMUXC_GPR12_DEVICE_TYPE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field APPS_PM_XMT_TURNOFF[16] (RW)
 *
 * PCIe_CTL - Request from the application to generate a PM_Turn_Off Message.
 */
/*@{*/
#define BP_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF (16U) /*!< Bit position for IOMUXC_GPR12_APPS_PM_XMT_TURNOFF. */
#define BM_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF (0x00010000U) /*!< Bit mask for IOMUXC_GPR12_APPS_PM_XMT_TURNOFF. */
#define BS_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF (1U) /*!< Bit field size in bits for IOMUXC_GPR12_APPS_PM_XMT_TURNOFF. */

/*! @brief Read current value of the IOMUXC_GPR12_APPS_PM_XMT_TURNOFF field. */
#define BR_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF(x) (HW_IOMUXC_GPR12(x).B.APPS_PM_XMT_TURNOFF)

/*! @brief Format value for bitfield IOMUXC_GPR12_APPS_PM_XMT_TURNOFF. */
#define BF_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF) & BM_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF)

/*! @brief Set the APPS_PM_XMT_TURNOFF field to a new value. */
#define BW_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF) | BF_IOMUXC_GPR12_APPS_PM_XMT_TURNOFF(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field DIA_STATUS_BUS_SELECT[20:17] (RW)
 *
 * PCIe_CTL - used for debug to select what part of diag_status_bus will be
 * reflected on the 32 bits of the iomux
 */
/*@{*/
#define BP_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT (17U) /*!< Bit position for IOMUXC_GPR12_DIA_STATUS_BUS_SELECT. */
#define BM_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT (0x001E0000U) /*!< Bit mask for IOMUXC_GPR12_DIA_STATUS_BUS_SELECT. */
#define BS_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT (4U) /*!< Bit field size in bits for IOMUXC_GPR12_DIA_STATUS_BUS_SELECT. */

/*! @brief Read current value of the IOMUXC_GPR12_DIA_STATUS_BUS_SELECT field. */
#define BR_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT(x) (HW_IOMUXC_GPR12(x).B.DIA_STATUS_BUS_SELECT)

/*! @brief Format value for bitfield IOMUXC_GPR12_DIA_STATUS_BUS_SELECT. */
#define BF_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT) & BM_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT)

/*! @brief Set the DIA_STATUS_BUS_SELECT field to a new value. */
#define BW_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT) | BF_IOMUXC_GPR12_DIA_STATUS_BUS_SELECT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field PCIe_CTL_7[23:21] (RW)
 *
 * PCIe control of diagnostic bus select (Drive 'cxpl_diag_ctrl' PCI controller
 * input)
 */
/*@{*/
#define BP_IOMUXC_GPR12_PCIe_CTL_7 (21U)   /*!< Bit position for IOMUXC_GPR12_PCIe_CTL_7. */
#define BM_IOMUXC_GPR12_PCIe_CTL_7 (0x00E00000U) /*!< Bit mask for IOMUXC_GPR12_PCIe_CTL_7. */
#define BS_IOMUXC_GPR12_PCIe_CTL_7 (3U)    /*!< Bit field size in bits for IOMUXC_GPR12_PCIe_CTL_7. */

/*! @brief Read current value of the IOMUXC_GPR12_PCIe_CTL_7 field. */
#define BR_IOMUXC_GPR12_PCIe_CTL_7(x) (HW_IOMUXC_GPR12(x).B.PCIe_CTL_7)

/*! @brief Format value for bitfield IOMUXC_GPR12_PCIe_CTL_7. */
#define BF_IOMUXC_GPR12_PCIe_CTL_7(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_PCIe_CTL_7) & BM_IOMUXC_GPR12_PCIe_CTL_7)

/*! @brief Set the PCIe_CTL_7 field to a new value. */
#define BW_IOMUXC_GPR12_PCIe_CTL_7(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_PCIe_CTL_7) | BF_IOMUXC_GPR12_PCIe_CTL_7(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field ARMP_APB_CLK_EN[24] (RW)
 *
 * ARM platform APB clock enable
 *
 * Values:
 * - 0 - IPG clock is not running (gated).
 * - 1 - IPG clock is running (enabled).
 */
/*@{*/
#define BP_IOMUXC_GPR12_ARMP_APB_CLK_EN (24U) /*!< Bit position for IOMUXC_GPR12_ARMP_APB_CLK_EN. */
#define BM_IOMUXC_GPR12_ARMP_APB_CLK_EN (0x01000000U) /*!< Bit mask for IOMUXC_GPR12_ARMP_APB_CLK_EN. */
#define BS_IOMUXC_GPR12_ARMP_APB_CLK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR12_ARMP_APB_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR12_ARMP_APB_CLK_EN field. */
#define BR_IOMUXC_GPR12_ARMP_APB_CLK_EN(x) (HW_IOMUXC_GPR12(x).B.ARMP_APB_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR12_ARMP_APB_CLK_EN. */
#define BF_IOMUXC_GPR12_ARMP_APB_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_ARMP_APB_CLK_EN) & BM_IOMUXC_GPR12_ARMP_APB_CLK_EN)

/*! @brief Set the ARMP_APB_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR12_ARMP_APB_CLK_EN(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_ARMP_APB_CLK_EN) | BF_IOMUXC_GPR12_ARMP_APB_CLK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field ARMP_ATB_CLK_EN[25] (RW)
 *
 * ARM platform ATB clock enable
 *
 * Values:
 * - 0 - IPG clock is not running (gated).
 * - 1 - IPG clock is running (enabled).
 */
/*@{*/
#define BP_IOMUXC_GPR12_ARMP_ATB_CLK_EN (25U) /*!< Bit position for IOMUXC_GPR12_ARMP_ATB_CLK_EN. */
#define BM_IOMUXC_GPR12_ARMP_ATB_CLK_EN (0x02000000U) /*!< Bit mask for IOMUXC_GPR12_ARMP_ATB_CLK_EN. */
#define BS_IOMUXC_GPR12_ARMP_ATB_CLK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR12_ARMP_ATB_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR12_ARMP_ATB_CLK_EN field. */
#define BR_IOMUXC_GPR12_ARMP_ATB_CLK_EN(x) (HW_IOMUXC_GPR12(x).B.ARMP_ATB_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR12_ARMP_ATB_CLK_EN. */
#define BF_IOMUXC_GPR12_ARMP_ATB_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_ARMP_ATB_CLK_EN) & BM_IOMUXC_GPR12_ARMP_ATB_CLK_EN)

/*! @brief Set the ARMP_ATB_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR12_ARMP_ATB_CLK_EN(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_ARMP_ATB_CLK_EN) | BF_IOMUXC_GPR12_ARMP_ATB_CLK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field ARMP_AHB_CLK_EN[26] (RW)
 *
 * ARM platform AHB clock enable
 *
 * Values:
 * - 0 - IPG clock is not running (gated).
 * - 1 - IPG clock is running (enabled).
 */
/*@{*/
#define BP_IOMUXC_GPR12_ARMP_AHB_CLK_EN (26U) /*!< Bit position for IOMUXC_GPR12_ARMP_AHB_CLK_EN. */
#define BM_IOMUXC_GPR12_ARMP_AHB_CLK_EN (0x04000000U) /*!< Bit mask for IOMUXC_GPR12_ARMP_AHB_CLK_EN. */
#define BS_IOMUXC_GPR12_ARMP_AHB_CLK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR12_ARMP_AHB_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR12_ARMP_AHB_CLK_EN field. */
#define BR_IOMUXC_GPR12_ARMP_AHB_CLK_EN(x) (HW_IOMUXC_GPR12(x).B.ARMP_AHB_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR12_ARMP_AHB_CLK_EN. */
#define BF_IOMUXC_GPR12_ARMP_AHB_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_ARMP_AHB_CLK_EN) & BM_IOMUXC_GPR12_ARMP_AHB_CLK_EN)

/*! @brief Set the ARMP_AHB_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR12_ARMP_AHB_CLK_EN(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_ARMP_AHB_CLK_EN) | BF_IOMUXC_GPR12_ARMP_AHB_CLK_EN(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR12, field ARMP_IPG_CLK_EN[27] (RW)
 *
 * ARM platform IPG clock enable
 *
 * Values:
 * - 0 - IPG clock is not running (gated).
 * - 1 - IPG clock is running (enabled).
 */
/*@{*/
#define BP_IOMUXC_GPR12_ARMP_IPG_CLK_EN (27U) /*!< Bit position for IOMUXC_GPR12_ARMP_IPG_CLK_EN. */
#define BM_IOMUXC_GPR12_ARMP_IPG_CLK_EN (0x08000000U) /*!< Bit mask for IOMUXC_GPR12_ARMP_IPG_CLK_EN. */
#define BS_IOMUXC_GPR12_ARMP_IPG_CLK_EN (1U) /*!< Bit field size in bits for IOMUXC_GPR12_ARMP_IPG_CLK_EN. */

/*! @brief Read current value of the IOMUXC_GPR12_ARMP_IPG_CLK_EN field. */
#define BR_IOMUXC_GPR12_ARMP_IPG_CLK_EN(x) (HW_IOMUXC_GPR12(x).B.ARMP_IPG_CLK_EN)

/*! @brief Format value for bitfield IOMUXC_GPR12_ARMP_IPG_CLK_EN. */
#define BF_IOMUXC_GPR12_ARMP_IPG_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR12_ARMP_IPG_CLK_EN) & BM_IOMUXC_GPR12_ARMP_IPG_CLK_EN)

/*! @brief Set the ARMP_IPG_CLK_EN field to a new value. */
#define BW_IOMUXC_GPR12_ARMP_IPG_CLK_EN(x, v) (HW_IOMUXC_GPR12_WR(x, (HW_IOMUXC_GPR12_RD(x) & ~BM_IOMUXC_GPR12_ARMP_IPG_CLK_EN) | BF_IOMUXC_GPR12_ARMP_IPG_CLK_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_GPR13 - GPR
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_GPR13 - GPR (RW)
 *
 * Reset value: 0x059124C4U
 *
 * SATA_PHY_6 PHUG FRUG fast_startup Frequency Tolerance (ppm) 000 1 1 None 780
 * 001 2 2 None 780 010 1 4 None 6,250 011 2 4 None 6,250 1xx Reserved
 */
typedef union _hw_iomuxc_gpr13
{
    uint32_t U;
    struct _hw_iomuxc_gpr13_bitfields
    {
        uint32_t SATA_PHY_0 : 1;       /*!< [0]  */
        uint32_t SATA_PHY_1 : 1;       /*!< [1]  */
        uint32_t SATA_PHY_2 : 5;       /*!< [6:2]  */
        uint32_t SATA_PHY_3 : 4;       /*!< [10:7]  */
        uint32_t SATA_PHY_4 : 3;       /*!< [13:11]  */
        uint32_t SATA_PHY_5 : 1;       /*!< [14]  */
        uint32_t SATA_SPEED : 1;       /*!< [15]  */
        uint32_t SATA_PHY_6 : 3;       /*!< [18:16]  */
        uint32_t SATA_PHY_7 : 5;       /*!< [23:19]  */
        uint32_t SATA_PHY_8 : 3;       /*!< [26:24]  */
        uint32_t ENET_STOP_REQ : 1;    /*!< [27]  */
        uint32_t CAN1_STOP_REQ : 1;    /*!< [28]  */
        uint32_t CAN2_STOP_REQ : 1;    /*!< [29]  */
        uint32_t SDMA_STOP_REQ : 1;    /*!< [30]  */
        uint32_t RESERVED0 : 1;        /*!< [31]  */
    } B;
} hw_iomuxc_gpr13_t;

/*!
 * @name Constants and macros for entire IOMUXC_GPR13 register
 */
/*@{*/
#define HW_IOMUXC_GPR13_ADDR(x)  ((uintptr_t)(x) + 0x34U)

#define HW_IOMUXC_GPR13(x)       (*(__IO hw_iomuxc_gpr13_t *) HW_IOMUXC_GPR13_ADDR(x))
#define HW_IOMUXC_GPR13_RD(x)    (HW_IOMUXC_GPR13(x).U)
#define HW_IOMUXC_GPR13_WR(x, v) (HW_IOMUXC_GPR13(x).U = (v))
#define HW_IOMUXC_GPR13_SET(x, v) (HW_IOMUXC_GPR13_WR(x, HW_IOMUXC_GPR13_RD(x) |  (v)))
#define HW_IOMUXC_GPR13_CLR(x, v) (HW_IOMUXC_GPR13_WR(x, HW_IOMUXC_GPR13_RD(x) & ~(v)))
#define HW_IOMUXC_GPR13_TOG(x, v) (HW_IOMUXC_GPR13_WR(x, HW_IOMUXC_GPR13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_GPR13 bitfields
 */

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_0[0] (RW)
 *
 * SATA PHY - Tx Edge rate control enables the SATA PHY to meet the edge rate
 * requirements for all SATA variants
 *
 * Values:
 * - 0 - Fast edge rate
 * - 1 - Medium edge rate
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_0 (0U)    /*!< Bit position for IOMUXC_GPR13_SATA_PHY_0. */
#define BM_IOMUXC_GPR13_SATA_PHY_0 (0x00000001U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_0. */
#define BS_IOMUXC_GPR13_SATA_PHY_0 (1U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_0. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_0 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_0(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_0)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_0. */
#define BF_IOMUXC_GPR13_SATA_PHY_0(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_0) & BM_IOMUXC_GPR13_SATA_PHY_0)

/*! @brief Set the SATA_PHY_0 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_0(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_0) | BF_IOMUXC_GPR13_SATA_PHY_0(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_1[1] (RW)
 *
 * SATA PHY internal PLL Reference Clock Enable
 *
 * Values:
 * - 0 - Disable the reference clock to the internal PLL of SATA PHY
 * - 1 - Enable the reference clock to the internal PLL of SATA PHY
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_1 (1U)    /*!< Bit position for IOMUXC_GPR13_SATA_PHY_1. */
#define BM_IOMUXC_GPR13_SATA_PHY_1 (0x00000002U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_1. */
#define BS_IOMUXC_GPR13_SATA_PHY_1 (1U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_1. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_1 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_1(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_1)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_1. */
#define BF_IOMUXC_GPR13_SATA_PHY_1(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_1) & BM_IOMUXC_GPR13_SATA_PHY_1)

/*! @brief Set the SATA_PHY_1 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_1(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_1) | BF_IOMUXC_GPR13_SATA_PHY_1(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_2[6:2] (RW)
 *
 * SATA PHY - Transmit level settings. Fine resolution settings of transmit
 * signal level, common to all lanes connected to one clock module.
 *
 * Values:
 * - 00000 - 0.937 V
 * - 00001 - 0.947 V
 * - 00010 - 0.957 V
 * - 00011 - 0.966 V
 * - 00100 - 0.976 V
 * - 00101 - 0.986 V
 * - 00110 - 0.996 V
 * - 00111 - 1.005 V
 * - 01000 - 1.015 V
 * - 01001 - 1.025 V
 * - 01010 - 1.035 V
 * - 01011 - 1.045 V
 * - 01100 - 1.054 V
 * - 01101 - 1.064 V
 * - 01110 - 1.074 V
 * - 01111 - 1.084 V
 * - 10000 - 1.094 V
 * - 10001 - 1.104 V (default)
 * - 10010 - 1.113 V
 * - 10011 - 1.123 V
 * - 10100 - 1.133 V
 * - 10101 - 1.143 V
 * - 10110 - 1.152 V
 * - 10111 - 1.162 V
 * - 11000 - 1.172 V
 * - 11001 - 1.182 V
 * - 11010 - 1.191 V
 * - 11011 - 1.201 V
 * - 11100 - 1.211 V
 * - 11101 - 1.221 V
 * - 11110 - 1.230 V
 * - 11111 - 1.240 V
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_2 (2U)    /*!< Bit position for IOMUXC_GPR13_SATA_PHY_2. */
#define BM_IOMUXC_GPR13_SATA_PHY_2 (0x0000007CU) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_2. */
#define BS_IOMUXC_GPR13_SATA_PHY_2 (5U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_2. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_2 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_2(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_2)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_2. */
#define BF_IOMUXC_GPR13_SATA_PHY_2(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_2) & BM_IOMUXC_GPR13_SATA_PHY_2)

/*! @brief Set the SATA_PHY_2 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_2(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_2) | BF_IOMUXC_GPR13_SATA_PHY_2(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_3[10:7] (RW)
 *
 * SATA PHY Tx -Transmit Boost Control, ratio of drive level of transmission bit
 * to non transmission bit.
 *
 * Values:
 * - 0000 - 0dB
 * - 0001 - 0.37 dB
 * - 0010 - 0.74 dB
 * - 0011 - 1.11 dB
 * - 0100 - 1.48 dB
 * - 0101 - 1.85 dB
 * - 0110 - 2.22 dB
 * - 0111 - 2.59 dB
 * - 1000 - 2.96 dB
 * - 1001 - 3.33 dB (default)
 * - 1010 - 3.70 dB
 * - 1011 - 4.07 dB
 * - 1100 - 4.44 dB
 * - 1101 - 4.81 dB
 * - 1110 - 5.28 dB
 * - 1111 - 5.75 dB
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_3 (7U)    /*!< Bit position for IOMUXC_GPR13_SATA_PHY_3. */
#define BM_IOMUXC_GPR13_SATA_PHY_3 (0x00000780U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_3. */
#define BS_IOMUXC_GPR13_SATA_PHY_3 (4U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_3. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_3 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_3(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_3)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_3. */
#define BF_IOMUXC_GPR13_SATA_PHY_3(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_3) & BM_IOMUXC_GPR13_SATA_PHY_3)

/*! @brief Set the SATA_PHY_3 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_3(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_3) | BF_IOMUXC_GPR13_SATA_PHY_3(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_4[13:11] (RW)
 *
 * SATA PHY -Transmit Attenuation control, provides discrete driver attenuation
 * factors (from full driver level).
 *
 * Values:
 * - 000 - 16/16
 * - 001 - 14/16
 * - 010 - 12/16
 * - 011 - 10/16
 * - 100 - 9/16 (default)
 * - 101 - 8/16
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_4 (11U)   /*!< Bit position for IOMUXC_GPR13_SATA_PHY_4. */
#define BM_IOMUXC_GPR13_SATA_PHY_4 (0x00003800U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_4. */
#define BS_IOMUXC_GPR13_SATA_PHY_4 (3U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_4. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_4 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_4(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_4)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_4. */
#define BF_IOMUXC_GPR13_SATA_PHY_4(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_4) & BM_IOMUXC_GPR13_SATA_PHY_4)

/*! @brief Set the SATA_PHY_4 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_4(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_4) | BF_IOMUXC_GPR13_SATA_PHY_4(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_5[14] (RW)
 *
 * SATA PHY - Spread Spectrum Enable. Enables spead spectrum clock production.
 * If the applied RefClk is already spread spectrum, this bit must be deasserted.
 *
 * Values:
 * - 0 - Spread Spectrum disabled
 * - 1 - Spread spectrum enabled
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_5 (14U)   /*!< Bit position for IOMUXC_GPR13_SATA_PHY_5. */
#define BM_IOMUXC_GPR13_SATA_PHY_5 (0x00004000U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_5. */
#define BS_IOMUXC_GPR13_SATA_PHY_5 (1U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_5. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_5 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_5(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_5)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_5. */
#define BF_IOMUXC_GPR13_SATA_PHY_5(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_5) & BM_IOMUXC_GPR13_SATA_PHY_5)

/*! @brief Set the SATA_PHY_5 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_5(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_5) | BF_IOMUXC_GPR13_SATA_PHY_5(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_SPEED[15] (RW)
 *
 * Indicates SATA PHY speed mode
 *
 * Values:
 * - 0 - 1.5 GHz
 * - 1 - 3.0 GHz
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_SPEED (15U)   /*!< Bit position for IOMUXC_GPR13_SATA_SPEED. */
#define BM_IOMUXC_GPR13_SATA_SPEED (0x00008000U) /*!< Bit mask for IOMUXC_GPR13_SATA_SPEED. */
#define BS_IOMUXC_GPR13_SATA_SPEED (1U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_SPEED. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_SPEED field. */
#define BR_IOMUXC_GPR13_SATA_SPEED(x) (HW_IOMUXC_GPR13(x).B.SATA_SPEED)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_SPEED. */
#define BF_IOMUXC_GPR13_SATA_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_SPEED) & BM_IOMUXC_GPR13_SATA_SPEED)

/*! @brief Set the SATA_SPEED field to a new value. */
#define BW_IOMUXC_GPR13_SATA_SPEED(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_SPEED) | BF_IOMUXC_GPR13_SATA_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_6[18:16] (RW)
 *
 * SATA PHY Rx - DPLL mode control, sets phase and frequency gain of receiver
 * DPLL For bits encoding see GPR13GPR below.
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_6 (16U)   /*!< Bit position for IOMUXC_GPR13_SATA_PHY_6. */
#define BM_IOMUXC_GPR13_SATA_PHY_6 (0x00070000U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_6. */
#define BS_IOMUXC_GPR13_SATA_PHY_6 (3U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_6. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_6 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_6(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_6)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_6. */
#define BF_IOMUXC_GPR13_SATA_PHY_6(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_6) & BM_IOMUXC_GPR13_SATA_PHY_6)

/*! @brief Set the SATA_PHY_6 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_6(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_6) | BF_IOMUXC_GPR13_SATA_PHY_6(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_7[23:19] (RW)
 *
 * SATA PHY Rx - Loss of signal detector level. Below the recommended value are
 * shown
 *
 * Values:
 * - 10000 - SATA1i
 * - 10000 - SATA1m
 * - 11010 - SATA1x
 * - 10010 - SATA2i
 * - 10010 - (default) SATA2m
 * - 11010 - SATA2x
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_7 (19U)   /*!< Bit position for IOMUXC_GPR13_SATA_PHY_7. */
#define BM_IOMUXC_GPR13_SATA_PHY_7 (0x00F80000U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_7. */
#define BS_IOMUXC_GPR13_SATA_PHY_7 (5U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_7. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_7 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_7(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_7)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_7. */
#define BF_IOMUXC_GPR13_SATA_PHY_7(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_7) & BM_IOMUXC_GPR13_SATA_PHY_7)

/*! @brief Set the SATA_PHY_7 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_7(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_7) | BF_IOMUXC_GPR13_SATA_PHY_7(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SATA_PHY_8[26:24] (RW)
 *
 * SATA _PHY Rx - Receiver Equalization control
 *
 * Values:
 * - 000 - 0.5 dB
 * - 001 - 1.0 dB
 * - 010 - 1.5 dB
 * - 011 - 2.0 dB
 * - 100 - 2.5 dB
 * - 101 - 3.0 dB (default)
 * - 110 - 3.5 dB
 * - 111 - 4.0 dB
 */
/*@{*/
#define BP_IOMUXC_GPR13_SATA_PHY_8 (24U)   /*!< Bit position for IOMUXC_GPR13_SATA_PHY_8. */
#define BM_IOMUXC_GPR13_SATA_PHY_8 (0x07000000U) /*!< Bit mask for IOMUXC_GPR13_SATA_PHY_8. */
#define BS_IOMUXC_GPR13_SATA_PHY_8 (3U)    /*!< Bit field size in bits for IOMUXC_GPR13_SATA_PHY_8. */

/*! @brief Read current value of the IOMUXC_GPR13_SATA_PHY_8 field. */
#define BR_IOMUXC_GPR13_SATA_PHY_8(x) (HW_IOMUXC_GPR13(x).B.SATA_PHY_8)

/*! @brief Format value for bitfield IOMUXC_GPR13_SATA_PHY_8. */
#define BF_IOMUXC_GPR13_SATA_PHY_8(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SATA_PHY_8) & BM_IOMUXC_GPR13_SATA_PHY_8)

/*! @brief Set the SATA_PHY_8 field to a new value. */
#define BW_IOMUXC_GPR13_SATA_PHY_8(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SATA_PHY_8) | BF_IOMUXC_GPR13_SATA_PHY_8(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field ENET_STOP_REQ[27] (RW)
 *
 * ENET stop request
 *
 * Values:
 * - 0 - Do not request the ENET module to enter STOP mode.
 * - 1 - Request the ENET module to enter STOP mode. The ENET will acknowledge
 *     this request in IOMUXC_GPR4[ENET_STOP_ACK].
 */
/*@{*/
#define BP_IOMUXC_GPR13_ENET_STOP_REQ (27U) /*!< Bit position for IOMUXC_GPR13_ENET_STOP_REQ. */
#define BM_IOMUXC_GPR13_ENET_STOP_REQ (0x08000000U) /*!< Bit mask for IOMUXC_GPR13_ENET_STOP_REQ. */
#define BS_IOMUXC_GPR13_ENET_STOP_REQ (1U) /*!< Bit field size in bits for IOMUXC_GPR13_ENET_STOP_REQ. */

/*! @brief Read current value of the IOMUXC_GPR13_ENET_STOP_REQ field. */
#define BR_IOMUXC_GPR13_ENET_STOP_REQ(x) (HW_IOMUXC_GPR13(x).B.ENET_STOP_REQ)

/*! @brief Format value for bitfield IOMUXC_GPR13_ENET_STOP_REQ. */
#define BF_IOMUXC_GPR13_ENET_STOP_REQ(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_ENET_STOP_REQ) & BM_IOMUXC_GPR13_ENET_STOP_REQ)

/*! @brief Set the ENET_STOP_REQ field to a new value. */
#define BW_IOMUXC_GPR13_ENET_STOP_REQ(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_ENET_STOP_REQ) | BF_IOMUXC_GPR13_ENET_STOP_REQ(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field CAN1_STOP_REQ[28] (RW)
 *
 * CAN1 stop request
 *
 * Values:
 * - 0 - Do not request the CAN1 module to enter STOP mode.
 * - 1 - Request the CAN1 module to enter STOP mode. The CAN1 will acknowledge
 *     this request in IOMUXC_GPR4[CAN1_STOP_ACK].
 */
/*@{*/
#define BP_IOMUXC_GPR13_CAN1_STOP_REQ (28U) /*!< Bit position for IOMUXC_GPR13_CAN1_STOP_REQ. */
#define BM_IOMUXC_GPR13_CAN1_STOP_REQ (0x10000000U) /*!< Bit mask for IOMUXC_GPR13_CAN1_STOP_REQ. */
#define BS_IOMUXC_GPR13_CAN1_STOP_REQ (1U) /*!< Bit field size in bits for IOMUXC_GPR13_CAN1_STOP_REQ. */

/*! @brief Read current value of the IOMUXC_GPR13_CAN1_STOP_REQ field. */
#define BR_IOMUXC_GPR13_CAN1_STOP_REQ(x) (HW_IOMUXC_GPR13(x).B.CAN1_STOP_REQ)

/*! @brief Format value for bitfield IOMUXC_GPR13_CAN1_STOP_REQ. */
#define BF_IOMUXC_GPR13_CAN1_STOP_REQ(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_CAN1_STOP_REQ) & BM_IOMUXC_GPR13_CAN1_STOP_REQ)

/*! @brief Set the CAN1_STOP_REQ field to a new value. */
#define BW_IOMUXC_GPR13_CAN1_STOP_REQ(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_CAN1_STOP_REQ) | BF_IOMUXC_GPR13_CAN1_STOP_REQ(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field CAN2_STOP_REQ[29] (RW)
 *
 * CAN2 stop request
 *
 * Values:
 * - 0 - Do not request the CAN2 module to enter STOP mode.
 * - 1 - Request the CAN2 module to enter STOP mode. The CAN2 will acknowledge
 *     this request in IOMUXC_GPR4[CAN2_STOP_ACK].
 */
/*@{*/
#define BP_IOMUXC_GPR13_CAN2_STOP_REQ (29U) /*!< Bit position for IOMUXC_GPR13_CAN2_STOP_REQ. */
#define BM_IOMUXC_GPR13_CAN2_STOP_REQ (0x20000000U) /*!< Bit mask for IOMUXC_GPR13_CAN2_STOP_REQ. */
#define BS_IOMUXC_GPR13_CAN2_STOP_REQ (1U) /*!< Bit field size in bits for IOMUXC_GPR13_CAN2_STOP_REQ. */

/*! @brief Read current value of the IOMUXC_GPR13_CAN2_STOP_REQ field. */
#define BR_IOMUXC_GPR13_CAN2_STOP_REQ(x) (HW_IOMUXC_GPR13(x).B.CAN2_STOP_REQ)

/*! @brief Format value for bitfield IOMUXC_GPR13_CAN2_STOP_REQ. */
#define BF_IOMUXC_GPR13_CAN2_STOP_REQ(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_CAN2_STOP_REQ) & BM_IOMUXC_GPR13_CAN2_STOP_REQ)

/*! @brief Set the CAN2_STOP_REQ field to a new value. */
#define BW_IOMUXC_GPR13_CAN2_STOP_REQ(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_CAN2_STOP_REQ) | BF_IOMUXC_GPR13_CAN2_STOP_REQ(v)))
/*@}*/

/*!
 * @name Register IOMUXC_GPR13, field SDMA_STOP_REQ[30] (RW)
 *
 * SDMA stop request
 *
 * Values:
 * - 0 - Do not request the SDMA module to enter STOP mode.
 * - 1 - Request the SDMA module to enter STOP mode. The SDMA will acknowledge
 *     this request in IOMUXC_GPR4[SDMA_STOP_ACK].
 */
/*@{*/
#define BP_IOMUXC_GPR13_SDMA_STOP_REQ (30U) /*!< Bit position for IOMUXC_GPR13_SDMA_STOP_REQ. */
#define BM_IOMUXC_GPR13_SDMA_STOP_REQ (0x40000000U) /*!< Bit mask for IOMUXC_GPR13_SDMA_STOP_REQ. */
#define BS_IOMUXC_GPR13_SDMA_STOP_REQ (1U) /*!< Bit field size in bits for IOMUXC_GPR13_SDMA_STOP_REQ. */

/*! @brief Read current value of the IOMUXC_GPR13_SDMA_STOP_REQ field. */
#define BR_IOMUXC_GPR13_SDMA_STOP_REQ(x) (HW_IOMUXC_GPR13(x).B.SDMA_STOP_REQ)

/*! @brief Format value for bitfield IOMUXC_GPR13_SDMA_STOP_REQ. */
#define BF_IOMUXC_GPR13_SDMA_STOP_REQ(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_GPR13_SDMA_STOP_REQ) & BM_IOMUXC_GPR13_SDMA_STOP_REQ)

/*! @brief Set the SDMA_STOP_REQ field to a new value. */
#define BW_IOMUXC_GPR13_SDMA_STOP_REQ(x, v) (HW_IOMUXC_GPR13_WR(x, (HW_IOMUXC_GPR13_RD(x) & ~BM_IOMUXC_GPR13_SDMA_STOP_REQ) | BF_IOMUXC_GPR13_SDMA_STOP_REQ(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: SD2_DAT1. NOTE: Pad SD2_DAT1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_DATA1.
 * - 001 - Select signal ECSPI5_SS0.- Configure register
 *     IOMUXC_ECSPI5_SS0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal EIM_CS2_B.
 * - 011 - Select signal AUD4_TXFS.- Configure register
 *     IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal KEY_COL7.- Configure register
 *     IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO1_IO14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal SD2_DATA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal ECSPI5_SS0.- Configure register IOMUXC_ECSPI5_SS0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal EIM_CS2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal AUD4_TXFS.- Configure register IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal KEY_COL7.- Configure register IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE: Select signal GPIO1_IO14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_DAT1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION: Force input path of pad SD2_DAT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_data2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_data2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: SD2_DAT2. NOTE: Pad SD2_DAT2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_DATA2.
 * - 001 - Select signal ECSPI5_SS1.- Configure register
 *     IOMUXC_ECSPI5_SS1_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal EIM_CS3_B.
 * - 011 - Select signal AUD4_TXD.- Configure register
 *     IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal KEY_ROW6.- Configure register
 *     IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO1_IO13.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal SD2_DATA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal ECSPI5_SS1.- Configure register IOMUXC_ECSPI5_SS1_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal EIM_CS3_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal AUD4_TXD.- Configure register IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal KEY_ROW6.- Configure register IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE: Select signal GPIO1_IO13. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_DAT2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION: Force input path of pad SD2_DAT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: SD2_DAT0. NOTE: Pad SD2_DAT0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_DATA0.
 * - 001 - Select signal ECSPI5_MISO.- Configure register
 *     IOMUXC_ECSPI5_MISO_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 011 - Select signal AUD4_RXD.- Configure register
 *     IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal KEY_ROW7.- Configure register
 *     IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO1_IO15.
 * - 110 - Select signal DCIC2_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal SD2_DATA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal ECSPI5_MISO.- Configure register IOMUXC_ECSPI5_MISO_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal AUD4_RXD.- Configure register IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal KEY_ROW7.- Configure register IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal GPIO1_IO15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE: Select signal DCIC2_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_DAT0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION: Force input path of pad SD2_DAT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_txc
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_txc_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_txc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_txc_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: RGMII_TXC. NOTE: Pad RGMII_TXC
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal USB_H2_DATA.
 * - 001 - Select signal RGMII_TXC.
 * - 010 - Select signal SPDIF_EXT_CLK.- Configure register
 *     IOMUXC_SPDIF_TX_CLK2_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO6_IO19.
 * - 111 - Select signal XTALOSC_REF_CLK_24M.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE: Select signal USB_H2_DATA. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE: Select signal RGMII_TXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE: Select signal SPDIF_EXT_CLK.- Configure register IOMUXC_SPDIF_TX_CLK2_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE: Select signal GPIO6_IO19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE: Select signal XTALOSC_REF_CLK_24M. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TXC.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION: Force input path of pad RGMII_TXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TXC_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_td0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_td0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_td0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_ADDR(x) ((uintptr_t)(x) + 0x5CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_TD0.
 *
 * Values:
 * - 000 - Select signal HSI_TX_READY.
 * - 001 - Select signal RGMII_TD0.
 * - 101 - Select signal GPIO6_IO20.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE: Select signal HSI_TX_READY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE: Select signal RGMII_TD0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE: Select signal GPIO6_IO20. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TD0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION: Force input path of pad RGMII_TD0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_td1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_td1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_td1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_TD1.
 *
 * Values:
 * - 000 - Select signal HSI_RX_FLAG.
 * - 001 - Select signal RGMII_TD1.
 * - 101 - Select signal GPIO6_IO21.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE: Select signal HSI_RX_FLAG. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE: Select signal RGMII_TD1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE: Select signal GPIO6_IO21. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TD1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION: Force input path of pad RGMII_TD1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_td2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_td2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_td2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_TD2.
 *
 * Values:
 * - 000 - Select signal HSI_RX_DATA.
 * - 001 - Select signal RGMII_TD2.
 * - 101 - Select signal GPIO6_IO22.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE: Select signal HSI_RX_DATA. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE: Select signal RGMII_TD2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE: Select signal GPIO6_IO22. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TD2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION: Force input path of pad RGMII_TD2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_td3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_td3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_td3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_ADDR(x) ((uintptr_t)(x) + 0x68U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_TD3.
 *
 * Values:
 * - 000 - Select signal HSI_RX_WAKE.
 * - 001 - Select signal RGMII_TD3.
 * - 101 - Select signal GPIO6_IO23.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE: Select signal HSI_RX_WAKE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE: Select signal RGMII_TD3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE: Select signal GPIO6_IO23. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TD3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION: Force input path of pad RGMII_TD3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TD3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rx_ctl
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rx_ctl_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rx_ctl_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_ADDR(x) ((uintptr_t)(x) + 0x6CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rx_ctl_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RX_CTL. NOTE: Pad
 * RGMII_RX_CTL is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal USB_H3_DATA.
 * - 001 - Select signal RGMII_RX_CTL.- Configure register
 *     IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO24.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE: Select signal USB_H3_DATA. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE: Select signal RGMII_RX_CTL.- Configure register IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE: Select signal GPIO6_IO24. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RX_CTL.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION: Force input path of pad RGMII_RX_CTL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RX_CTL_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rd0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RD0. NOTE: Pad RGMII_RD0
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal HSI_RX_READY.
 * - 001 - Select signal RGMII_RD0.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO25.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE: Select signal HSI_RX_READY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE: Select signal RGMII_RD0.- Configure register IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE: Select signal GPIO6_IO25. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RD0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION: Force input path of pad RGMII_RD0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_tx_ctl
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_tx_ctl_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_tx_ctl_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_ADDR(x) ((uintptr_t)(x) + 0x74U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_tx_ctl_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: RGMII_TX_CTL. NOTE: Pad
 * RGMII_TX_CTL is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal USB_H2_STROBE.
 * - 001 - Select signal RGMII_TX_CTL.
 * - 101 - Select signal GPIO6_IO26.
 * - 111 - Select signal ENET_REF_CLK.- Configure register
 *     IOMUXC_ENET_REF_CLK_SELECT_INPUTSelect Input Register for mode ALT7.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE: Select signal USB_H2_STROBE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE: Select signal RGMII_TX_CTL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE: Select signal GPIO6_IO26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE: Select signal ENET_REF_CLK.- Configure register IOMUXC_ENET_REF_CLK_SELECT_INPUTSelect Input Register for mode ALT7. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_TX_CTL.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION: Force input path of pad RGMII_TX_CTL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_TX_CTL_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rd1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_ADDR(x) ((uintptr_t)(x) + 0x78U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RD1. NOTE: Pad RGMII_RD1
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal HSI_TX_FLAG.
 * - 001 - Select signal RGMII_RD1.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO27.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE: Select signal HSI_TX_FLAG. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE: Select signal RGMII_RD1.- Configure register IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE: Select signal GPIO6_IO27. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RD1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION: Force input path of pad RGMII_RD1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rd2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_ADDR(x) ((uintptr_t)(x) + 0x7CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RD2. NOTE: Pad RGMII_RD2
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal HSI_TX_DATA.
 * - 001 - Select signal RGMII_RD2.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO28.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE: Select signal HSI_TX_DATA. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE: Select signal RGMII_RD2.- Configure register IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE: Select signal GPIO6_IO28. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RD2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION: Force input path of pad RGMII_RD2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rd3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rd3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RD3. NOTE: Pad RGMII_RD3
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal HSI_TX_WAKE.
 * - 001 - Select signal RGMII_RD3.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO29.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE: Select signal HSI_TX_WAKE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE: Select signal RGMII_RD3.- Configure register IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE: Select signal GPIO6_IO29. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RD3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION: Force input path of pad RGMII_RD3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RD3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_rgmii_rxc
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_rgmii_rxc_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_rgmii_rxc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_ADDR(x) ((uintptr_t)(x) + 0x84U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rxc_t *) HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: RGMII_RXC. NOTE: Pad RGMII_RXC
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal USB_H3_STROBE.
 * - 001 - Select signal RGMII_RXC.- Configure register
 *     IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO30.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE: Select signal USB_H3_STROBE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE: Select signal RGMII_RXC.- Configure register IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE: Select signal GPIO6_IO30. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad RGMII_RXC.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION: Force input path of pad RGMII_RXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_RGMII_RXC_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr25
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr25_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr25_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_ADDR(x) ((uintptr_t)(x) + 0x88U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr25_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_A25. NOTE: Pad EIM_A25 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR25.
 * - 001 - Select signal ECSPI4_SS1.
 * - 010 - Select signal ECSPI2_RDY.
 * - 011 - Select signal IPU1_DI1_PIN12.
 * - 100 - Select signal IPU1_DI0_D1_CS.
 * - 101 - Select signal GPIO5_IO02.
 * - 110 - Select signal HDMI_TX_CEC_LINE.- Configure register
 *     IOMUXC_HDMI_ICECIN_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal EIM_ADDR25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal ECSPI4_SS1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal ECSPI2_RDY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal IPU1_DI1_PIN12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal IPU1_DI0_D1_CS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal GPIO5_IO02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE: Select signal HDMI_TX_CEC_LINE.- Configure register IOMUXC_HDMI_ICECIN_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A25.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION: Force input path of pad EIM_A25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR25_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_eb2_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_eb2_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_eb2_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_ADDR(x) ((uintptr_t)(x) + 0x8CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_eb2_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_EB2. NOTE: Pad EIM_EB2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_EB2_B.
 * - 001 - Select signal ECSPI1_SS0.- Configure register
 *     IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 011 - Select signal IPU2_CSI1_DATA19.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal HDMI_TX_DDC_SCL.- Configure register
 *     IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO2_IO30.
 * - 110 - Select signal I2C2_SCL.- Configure register
 *     IOMUXC_I2C2_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal SRC_BOOT_CFG30.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal EIM_EB2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal ECSPI1_SS0.- Configure register IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal IPU2_CSI1_DATA19.- Configure register IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal HDMI_TX_DDC_SCL.- Configure register IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal GPIO2_IO30. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal I2C2_SCL.- Configure register IOMUXC_I2C2_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE: Select signal SRC_BOOT_CFG30. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_EB2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION: Force input path of pad EIM_EB2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data16_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data16_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D16. NOTE: Pad EIM_D16 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA16.
 * - 001 - Select signal ECSPI1_SCLK.- Configure register
 *     IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal IPU1_DI0_PIN05.
 * - 011 - Select signal IPU2_CSI1_DATA18.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal HDMI_TX_DDC_SDA.- Configure register
 *     IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO16.
 * - 110 - Select signal I2C2_SDA.- Configure register
 *     IOMUXC_I2C2_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal EIM_DATA16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal ECSPI1_SCLK.- Configure register IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal IPU1_DI0_PIN05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal IPU2_CSI1_DATA18.- Configure register IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal HDMI_TX_DDC_SDA.- Configure register IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal GPIO3_IO16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE: Select signal I2C2_SDA.- Configure register IOMUXC_I2C2_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D16.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION: Force input path of pad EIM_D16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA16_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data17_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_ADDR(x) ((uintptr_t)(x) + 0x94U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data17_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D17. NOTE: Pad EIM_D17 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA17.
 * - 001 - Select signal ECSPI1_MISO.- Configure register
 *     IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal IPU1_DI0_PIN06.
 * - 011 - Select signal IPU2_CSI1_PIXCLK.- Configure register
 *     IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal DCIC1_OUT.
 * - 101 - Select signal GPIO3_IO17.
 * - 110 - Select signal I2C3_SCL.- Configure register
 *     IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal EIM_DATA17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal ECSPI1_MISO.- Configure register IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal IPU1_DI0_PIN06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal IPU2_CSI1_PIXCLK.- Configure register IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal DCIC1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal GPIO3_IO17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE: Select signal I2C3_SCL.- Configure register IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D17.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION: Force input path of pad EIM_D17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA17_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data18_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_ADDR(x) ((uintptr_t)(x) + 0x98U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data18_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D18. NOTE: Pad EIM_D18 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA18.
 * - 001 - Select signal ECSPI1_MOSI.- Configure register
 *     IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal IPU1_DI0_PIN07.
 * - 011 - Select signal IPU2_CSI1_DATA17.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal IPU1_DI1_D0_CS.
 * - 101 - Select signal GPIO3_IO18.
 * - 110 - Select signal I2C3_SDA.- Configure register
 *     IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal EIM_DATA18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal ECSPI1_MOSI.- Configure register IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal IPU1_DI0_PIN07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal IPU2_CSI1_DATA17.- Configure register IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal IPU1_DI1_D0_CS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal GPIO3_IO18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE: Select signal I2C3_SDA.- Configure register IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D18.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION: Force input path of pad EIM_D18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA18_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data19_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_ADDR(x) ((uintptr_t)(x) + 0x9CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data19_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D19. NOTE: Pad EIM_D19 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA19.
 * - 001 - Select signal ECSPI1_SS1.- Configure register
 *     IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal IPU1_DI0_PIN08.
 * - 011 - Select signal IPU2_CSI1_DATA16.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART1_CTS_B.- Configure register
 *     IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO19.
 * - 110 - Select signal EPIT1_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal EIM_DATA19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal ECSPI1_SS1.- Configure register IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal IPU1_DI0_PIN08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal IPU2_CSI1_DATA16.- Configure register IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal UART1_CTS_B.- Configure register IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal GPIO3_IO19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE: Select signal EPIT1_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D19.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION: Force input path of pad EIM_D19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA19_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data20
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data20_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_ADDR(x) ((uintptr_t)(x) + 0xA0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data20_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D20. NOTE: Pad EIM_D20 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA20.
 * - 001 - Select signal ECSPI4_SS0.- Configure register
 *     IOMUXC_ECSPI4_SS0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal IPU1_DI0_PIN16.
 * - 011 - Select signal IPU2_CSI1_DATA15.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART1_RTS_B.- Configure register
 *     IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO20.
 * - 110 - Select signal EPIT2_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal EIM_DATA20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal ECSPI4_SS0.- Configure register IOMUXC_ECSPI4_SS0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal IPU1_DI0_PIN16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal IPU2_CSI1_DATA15.- Configure register IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal UART1_RTS_B.- Configure register IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal GPIO3_IO20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE: Select signal EPIT2_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D20.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION: Force input path of pad EIM_D20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA20_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data21
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data21_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_ADDR(x) ((uintptr_t)(x) + 0xA4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data21_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D21. NOTE: Pad EIM_D21 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA21.
 * - 001 - Select signal ECSPI4_SCLK.
 * - 010 - Select signal IPU1_DI0_PIN17.
 * - 011 - Select signal IPU2_CSI1_DATA11.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal USB_OTG_OC.- Configure register
 *     IOMUXC_USB_OTG_OC_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO21.
 * - 110 - Select signal I2C1_SCL.- Configure register
 *     IOMUXC_I2C1_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal SPDIF_IN.- Configure register
 *     IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT7.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal EIM_DATA21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal ECSPI4_SCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal IPU1_DI0_PIN17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal IPU2_CSI1_DATA11.- Configure register IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal USB_OTG_OC.- Configure register IOMUXC_USB_OTG_OC_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal GPIO3_IO21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal I2C1_SCL.- Configure register IOMUXC_I2C1_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE: Select signal SPDIF_IN.- Configure register IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT7. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D21.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION: Force input path of pad EIM_D21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA21_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data22
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data22_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_ADDR(x) ((uintptr_t)(x) + 0xA8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data22_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D22. NOTE: Pad EIM_D22 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA22.
 * - 001 - Select signal ECSPI4_MISO.
 * - 010 - Select signal IPU1_DI0_PIN01.
 * - 011 - Select signal IPU2_CSI1_DATA10.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal USB_OTG_PWR.
 * - 101 - Select signal GPIO3_IO22.
 * - 110 - Select signal SPDIF_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal EIM_DATA22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal ECSPI4_MISO. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal IPU1_DI0_PIN01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal IPU2_CSI1_DATA10.- Configure register IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal USB_OTG_PWR. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal GPIO3_IO22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE: Select signal SPDIF_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D22.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION: Force input path of pad EIM_D22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA22_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data23
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data23_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_ADDR(x) ((uintptr_t)(x) + 0xACU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data23_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D23. NOTE: Pad EIM_D23 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA23.
 * - 001 - Select signal IPU1_DI0_D0_CS.
 * - 010 - Select signal UART3_CTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal UART1_DCD_B.
 * - 100 - Select signal IPU2_CSI1_DATA_EN.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO23.
 * - 110 - Select signal IPU1_DI1_PIN02.
 * - 111 - Select signal IPU1_DI1_PIN14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal EIM_DATA23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal IPU1_DI0_D0_CS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal UART3_CTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal UART1_DCD_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal IPU2_CSI1_DATA_EN.- Configure register IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal GPIO3_IO23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal IPU1_DI1_PIN02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE: Select signal IPU1_DI1_PIN14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D23.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION: Force input path of pad EIM_D23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA23_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_eb3_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_eb3_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_eb3_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_ADDR(x) ((uintptr_t)(x) + 0xB0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_eb3_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_EB3. NOTE: Pad EIM_EB3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_EB3_B.
 * - 001 - Select signal ECSPI4_RDY.
 * - 010 - Select signal UART3_RTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal UART1_RI_B.
 * - 100 - Select signal IPU2_CSI1_HSYNC.- Configure register
 *     IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO2_IO31.
 * - 110 - Select signal IPU1_DI1_PIN03.
 * - 111 - Select signal SRC_BOOT_CFG31.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal EIM_EB3_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal ECSPI4_RDY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal UART3_RTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal UART1_RI_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal IPU2_CSI1_HSYNC.- Configure register IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal GPIO2_IO31. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal IPU1_DI1_PIN03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE: Select signal SRC_BOOT_CFG31. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_EB3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION: Force input path of pad EIM_EB3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data24
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data24_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data24_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_ADDR(x) ((uintptr_t)(x) + 0xB4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data24_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D24. NOTE: Pad EIM_D24 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA24.
 * - 001 - Select signal ECSPI4_SS2.
 * - 010 - Select signal UART3_TX_DATA.- Configure register
 *     IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal ECSPI1_SS2.- Configure register
 *     IOMUXC_ECSPI1_SS2_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal ECSPI2_SS2.
 * - 101 - Select signal GPIO3_IO24.
 * - 110 - Select signal AUD5_RXFS.- Configure register
 *     IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal UART1_DTR_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal EIM_DATA24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal ECSPI4_SS2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal UART3_TX_DATA.- Configure register IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal ECSPI1_SS2.- Configure register IOMUXC_ECSPI1_SS2_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal ECSPI2_SS2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal GPIO3_IO24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal AUD5_RXFS.- Configure register IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE: Select signal UART1_DTR_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D24.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION: Force input path of pad EIM_D24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA24_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data25
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data25_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data25_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_ADDR(x) ((uintptr_t)(x) + 0xB8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data25_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D25. NOTE: Pad EIM_D25 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA25.
 * - 001 - Select signal ECSPI4_SS3.
 * - 010 - Select signal UART3_RX_DATA.- Configure register
 *     IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal ECSPI1_SS3.- Configure register
 *     IOMUXC_ECSPI1_SS3_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal ECSPI2_SS3.
 * - 101 - Select signal GPIO3_IO25.
 * - 110 - Select signal AUD5_RXC.- Configure register
 *     IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal UART1_DSR_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal EIM_DATA25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal ECSPI4_SS3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal UART3_RX_DATA.- Configure register IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal ECSPI1_SS3.- Configure register IOMUXC_ECSPI1_SS3_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal ECSPI2_SS3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal GPIO3_IO25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal AUD5_RXC.- Configure register IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE: Select signal UART1_DSR_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D25.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION: Force input path of pad EIM_D25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA25_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data26
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data26_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data26_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_ADDR(x) ((uintptr_t)(x) + 0xBCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data26_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D26. NOTE: Pad EIM_D26 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA26.
 * - 001 - Select signal IPU1_DI1_PIN11.
 * - 010 - Select signal IPU1_CSI0_DATA01.
 * - 011 - Select signal IPU2_CSI1_DATA14.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART2_TX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO26.
 * - 110 - Select signal IPU1_SISG2.
 * - 111 - Select signal IPU1_DISP1_DATA22.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal EIM_DATA26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal IPU1_DI1_PIN11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal IPU1_CSI0_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal IPU2_CSI1_DATA14.- Configure register IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal UART2_TX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal GPIO3_IO26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal IPU1_SISG2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE: Select signal IPU1_DISP1_DATA22. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D26.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION: Force input path of pad EIM_D26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data27
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data27_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data27_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_ADDR(x) ((uintptr_t)(x) + 0xC0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data27_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D27. NOTE: Pad EIM_D27 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA27.
 * - 001 - Select signal IPU1_DI1_PIN13.
 * - 010 - Select signal IPU1_CSI0_DATA00.
 * - 011 - Select signal IPU2_CSI1_DATA13.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART2_RX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO27.
 * - 110 - Select signal IPU1_SISG3.
 * - 111 - Select signal IPU1_DISP1_DATA23.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal EIM_DATA27. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal IPU1_DI1_PIN13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal IPU1_CSI0_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal IPU2_CSI1_DATA13.- Configure register IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal UART2_RX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal GPIO3_IO27. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal IPU1_SISG3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE: Select signal IPU1_DISP1_DATA23. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D27.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION: Force input path of pad EIM_D27. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data28
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data28_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data28_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_ADDR(x) ((uintptr_t)(x) + 0xC4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data28_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: EIM_D28. NOTE: Pad EIM_D28 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA28.
 * - 001 - Select signal I2C1_SDA.- Configure register
 *     IOMUXC_I2C1_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal ECSPI4_MOSI.
 * - 011 - Select signal IPU2_CSI1_DATA12.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART2_CTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO28.
 * - 110 - Select signal IPU1_EXT_TRIG.
 * - 111 - Select signal IPU1_DI0_PIN13.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal EIM_DATA28. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal I2C1_SDA.- Configure register IOMUXC_I2C1_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal ECSPI4_MOSI. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal IPU2_CSI1_DATA12.- Configure register IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal UART2_CTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal GPIO3_IO28. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal IPU1_EXT_TRIG. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE: Select signal IPU1_DI0_PIN13. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D28.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION: Force input path of pad EIM_D28. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA28_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data29
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data29_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data29_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_ADDR(x) ((uintptr_t)(x) + 0xC8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data29_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D29. NOTE: Pad EIM_D29 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA29.
 * - 001 - Select signal IPU1_DI1_PIN15.
 * - 010 - Select signal ECSPI4_SS0.- Configure register
 *     IOMUXC_ECSPI4_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal UART2_RTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO29.
 * - 110 - Select signal IPU2_CSI1_VSYNC.- Configure register
 *     IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal IPU1_DI0_PIN14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal EIM_DATA29. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal IPU1_DI1_PIN15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal ECSPI4_SS0.- Configure register IOMUXC_ECSPI4_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal UART2_RTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal GPIO3_IO29. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal IPU2_CSI1_VSYNC.- Configure register IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE: Select signal IPU1_DI0_PIN14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D29.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION: Force input path of pad EIM_D29. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA29_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data30
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data30_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data30_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_ADDR(x) ((uintptr_t)(x) + 0xCCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data30_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D30. NOTE: Pad EIM_D30 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA30.
 * - 001 - Select signal IPU1_DISP1_DATA21.
 * - 010 - Select signal IPU1_DI0_PIN11.
 * - 011 - Select signal IPU1_CSI0_DATA03.
 * - 100 - Select signal UART3_CTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO30.
 * - 110 - Select signal USB_H1_OC.- Configure register
 *     IOMUXC_USB_H1_OC_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal EIM_DATA30. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal IPU1_DISP1_DATA21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal IPU1_DI0_PIN11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal IPU1_CSI0_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal UART3_CTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal GPIO3_IO30. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE: Select signal USB_H1_OC.- Configure register IOMUXC_USB_H1_OC_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D30.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION: Force input path of pad EIM_D30. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA30_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_data31
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_data31_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_data31_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_ADDR(x) ((uintptr_t)(x) + 0xD0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_data31_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_D31. NOTE: Pad EIM_D31 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_DATA31.
 * - 001 - Select signal IPU1_DISP1_DATA20.
 * - 010 - Select signal IPU1_DI0_PIN12.
 * - 011 - Select signal IPU1_CSI0_DATA02.
 * - 100 - Select signal UART3_RTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO3_IO31.
 * - 110 - Select signal USB_H1_PWR.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal EIM_DATA31. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal IPU1_DISP1_DATA20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal IPU1_DI0_PIN12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal IPU1_CSI0_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal UART3_RTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal GPIO3_IO31. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE: Select signal USB_H1_PWR. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_D31.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION: Force input path of pad EIM_D31. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA31_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr24
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr24_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr24_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_ADDR(x) ((uintptr_t)(x) + 0xD4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr24_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_A24. NOTE: Pad EIM_A24 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR24.
 * - 001 - Select signal IPU1_DISP1_DATA19.
 * - 010 - Select signal IPU2_CSI1_DATA19.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal IPU2_SISG2.
 * - 100 - Select signal IPU1_SISG2.
 * - 101 - Select signal GPIO5_IO04.
 * - 111 - Select signal SRC_BOOT_CFG24.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal EIM_ADDR24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal IPU1_DISP1_DATA19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal IPU2_CSI1_DATA19.- Configure register IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal IPU2_SISG2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal IPU1_SISG2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal GPIO5_IO04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE: Select signal SRC_BOOT_CFG24. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A24.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION: Force input path of pad EIM_A24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR24_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr23
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr23_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_ADDR(x) ((uintptr_t)(x) + 0xD8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr23_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: EIM_A23. NOTE: Pad EIM_A23 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR23.
 * - 001 - Select signal IPU1_DISP1_DATA18.
 * - 010 - Select signal IPU2_CSI1_DATA18.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal IPU2_SISG3.
 * - 100 - Select signal IPU1_SISG3.
 * - 101 - Select signal GPIO6_IO06.
 * - 111 - Select signal SRC_BOOT_CFG23.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal EIM_ADDR23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal IPU1_DISP1_DATA18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal IPU2_CSI1_DATA18.- Configure register IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal IPU2_SISG3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal IPU1_SISG3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal GPIO6_IO06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE: Select signal SRC_BOOT_CFG23. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A23.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION: Force input path of pad EIM_A23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR23_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr22
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr22_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_ADDR(x) ((uintptr_t)(x) + 0xDCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr22_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A22. NOTE: Pad EIM_A22 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR22.
 * - 001 - Select signal IPU1_DISP1_DATA17.
 * - 010 - Select signal IPU2_CSI1_DATA17.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO16.
 * - 111 - Select signal SRC_BOOT_CFG22.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE: Select signal EIM_ADDR22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE: Select signal IPU1_DISP1_DATA17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE: Select signal IPU2_CSI1_DATA17.- Configure register IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE: Select signal GPIO2_IO16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE: Select signal SRC_BOOT_CFG22. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A22.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION: Force input path of pad EIM_A22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR22_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr21
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr21_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_ADDR(x) ((uintptr_t)(x) + 0xE0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr21_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A21. NOTE: Pad EIM_A21 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR21.
 * - 001 - Select signal IPU1_DISP1_DATA16.
 * - 010 - Select signal IPU2_CSI1_DATA16.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO17.
 * - 111 - Select signal SRC_BOOT_CFG21.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE: Select signal EIM_ADDR21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE: Select signal IPU1_DISP1_DATA16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE: Select signal IPU2_CSI1_DATA16.- Configure register IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE: Select signal GPIO2_IO17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE: Select signal SRC_BOOT_CFG21. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A21.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION: Force input path of pad EIM_A21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR21_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr20
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr20_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_ADDR(x) ((uintptr_t)(x) + 0xE4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr20_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A20. NOTE: Pad EIM_A20 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR20.
 * - 001 - Select signal IPU1_DISP1_DATA15.
 * - 010 - Select signal IPU2_CSI1_DATA15.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO18.
 * - 111 - Select signal SRC_BOOT_CFG20.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE: Select signal EIM_ADDR20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE: Select signal IPU1_DISP1_DATA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE: Select signal IPU2_CSI1_DATA15.- Configure register IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE: Select signal GPIO2_IO18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE: Select signal SRC_BOOT_CFG20. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A20.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION: Force input path of pad EIM_A20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR20_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr19
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr19_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_ADDR(x) ((uintptr_t)(x) + 0xE8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr19_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A19. NOTE: Pad EIM_A19 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR19.
 * - 001 - Select signal IPU1_DISP1_DATA14.
 * - 010 - Select signal IPU2_CSI1_DATA14.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO19.
 * - 111 - Select signal SRC_BOOT_CFG19.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE: Select signal EIM_ADDR19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE: Select signal IPU1_DISP1_DATA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE: Select signal IPU2_CSI1_DATA14.- Configure register IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE: Select signal GPIO2_IO19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE: Select signal SRC_BOOT_CFG19. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A19.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION: Force input path of pad EIM_A19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR19_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr18
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr18_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_ADDR(x) ((uintptr_t)(x) + 0xECU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr18_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A18. NOTE: Pad EIM_A18 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR18.
 * - 001 - Select signal IPU1_DISP1_DATA13.
 * - 010 - Select signal IPU2_CSI1_DATA13.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO20.
 * - 111 - Select signal SRC_BOOT_CFG18.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE: Select signal EIM_ADDR18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE: Select signal IPU1_DISP1_DATA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE: Select signal IPU2_CSI1_DATA13.- Configure register IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE: Select signal GPIO2_IO20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE: Select signal SRC_BOOT_CFG18. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A18.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION: Force input path of pad EIM_A18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR18_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr17
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr17_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_ADDR(x) ((uintptr_t)(x) + 0xF0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr17_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A17. NOTE: Pad EIM_A17 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR17.
 * - 001 - Select signal IPU1_DISP1_DATA12.
 * - 010 - Select signal IPU2_CSI1_DATA12.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO21.
 * - 111 - Select signal SRC_BOOT_CFG17.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE: Select signal EIM_ADDR17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE: Select signal IPU1_DISP1_DATA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE: Select signal IPU2_CSI1_DATA12.- Configure register IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE: Select signal GPIO2_IO21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE: Select signal SRC_BOOT_CFG17. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A17.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION: Force input path of pad EIM_A17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR17_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_addr16
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_addr16_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_addr16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_ADDR(x) ((uintptr_t)(x) + 0xF4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_addr16_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_A16. NOTE: Pad EIM_A16 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_ADDR16.
 * - 001 - Select signal IPU1_DI1_DISP_CLK.
 * - 010 - Select signal IPU2_CSI1_PIXCLK.- Configure register
 *     IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO22.
 * - 111 - Select signal SRC_BOOT_CFG16.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE: Select signal EIM_ADDR16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE: Select signal IPU1_DI1_DISP_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE: Select signal IPU2_CSI1_PIXCLK.- Configure register IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE: Select signal GPIO2_IO22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE: Select signal SRC_BOOT_CFG16. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_A16.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION: Force input path of pad EIM_A16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_ADDR16_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_cs0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_cs0_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_cs0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_ADDR(x) ((uintptr_t)(x) + 0xF8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_cs0_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_CS0. NOTE: Pad EIM_CS0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_CS0_B.
 * - 001 - Select signal IPU1_DI1_PIN05.
 * - 010 - Select signal ECSPI2_SCLK.- Configure register
 *     IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO23.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE: Select signal EIM_CS0_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE: Select signal IPU1_DI1_PIN05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE: Select signal ECSPI2_SCLK.- Configure register IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE: Select signal GPIO2_IO23. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_CS0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION: Force input path of pad EIM_CS0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_cs1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_cs1_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_cs1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_ADDR(x) ((uintptr_t)(x) + 0xFCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_cs1_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_CS1. NOTE: Pad EIM_CS1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_CS1_B.
 * - 001 - Select signal IPU1_DI1_PIN06.
 * - 010 - Select signal ECSPI2_MOSI.- Configure register
 *     IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO24.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE: Select signal EIM_CS1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE: Select signal IPU1_DI1_PIN06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE: Select signal ECSPI2_MOSI.- Configure register IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE: Select signal GPIO2_IO24. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_CS1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION: Force input path of pad EIM_CS1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_oe_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_oe_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_oe_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_ADDR(x) ((uintptr_t)(x) + 0x100U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_oe_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_OE. NOTE: Pad EIM_OE is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_OE_B.
 * - 001 - Select signal IPU1_DI1_PIN07.
 * - 010 - Select signal ECSPI2_MISO.- Configure register
 *     IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO25.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE: Select signal EIM_OE_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE: Select signal IPU1_DI1_PIN07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE: Select signal ECSPI2_MISO.- Configure register IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE: Select signal GPIO2_IO25. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_OE.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION: Force input path of pad EIM_OE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_rw
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_rw_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_rw_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_RW register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_ADDR(x) ((uintptr_t)(x) + 0x104U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_rw_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_RW bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_RW, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_RW. NOTE: Pad EIM_RW is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_RW.
 * - 001 - Select signal IPU1_DI1_PIN08.
 * - 010 - Select signal ECSPI2_SS0.- Configure register
 *     IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO26.
 * - 111 - Select signal SRC_BOOT_CFG29.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE: Select signal EIM_RW. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE: Select signal IPU1_DI1_PIN08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE: Select signal ECSPI2_SS0.- Configure register IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE: Select signal GPIO2_IO26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE: Select signal SRC_BOOT_CFG29. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_RW, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_RW.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION: Force input path of pad EIM_RW. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_RW_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_lba_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_lba_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_lba_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_ADDR(x) ((uintptr_t)(x) + 0x108U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_lba_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_LBA. NOTE: Pad EIM_LBA is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_LBA_B.
 * - 001 - Select signal IPU1_DI1_PIN17.
 * - 010 - Select signal ECSPI2_SS1.- Configure register
 *     IOMUXC_ECSPI2_SS1_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO27.
 * - 111 - Select signal SRC_BOOT_CFG26.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE: Select signal EIM_LBA_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE: Select signal IPU1_DI1_PIN17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE: Select signal ECSPI2_SS1.- Configure register IOMUXC_ECSPI2_SS1_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE: Select signal GPIO2_IO27. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE: Select signal SRC_BOOT_CFG26. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_LBA.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION: Force input path of pad EIM_LBA. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_eb0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_eb0_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_eb0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_ADDR(x) ((uintptr_t)(x) + 0x10CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_eb0_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: EIM_EB0. NOTE: Pad EIM_EB0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_EB0_B.
 * - 001 - Select signal IPU1_DISP1_DATA11.
 * - 010 - Select signal IPU2_CSI1_DATA11.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal CCM_PMIC_READY.- Configure register
 *     IOMUXC_CCM_PMIC_READY_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO2_IO28.
 * - 111 - Select signal SRC_BOOT_CFG27.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal EIM_EB0_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal IPU1_DISP1_DATA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal IPU2_CSI1_DATA11.- Configure register IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal CCM_PMIC_READY.- Configure register IOMUXC_CCM_PMIC_READY_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal GPIO2_IO28. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE: Select signal SRC_BOOT_CFG27. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_EB0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION: Force input path of pad EIM_EB0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_eb1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_eb1_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_eb1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_ADDR(x) ((uintptr_t)(x) + 0x110U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_eb1_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_EB1. NOTE: Pad EIM_EB1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_EB1_B.
 * - 001 - Select signal IPU1_DISP1_DATA10.
 * - 010 - Select signal IPU2_CSI1_DATA10.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO29.
 * - 111 - Select signal SRC_BOOT_CFG28.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE: Select signal EIM_EB1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE: Select signal IPU1_DISP1_DATA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE: Select signal IPU2_CSI1_DATA10.- Configure register IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE: Select signal GPIO2_IO29. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE: Select signal SRC_BOOT_CFG28. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_EB1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION: Force input path of pad EIM_EB1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad00
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad00_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD00 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_ADDR(x) ((uintptr_t)(x) + 0x114U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad00_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD00, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA0.
 *
 * Values:
 * - 000 - Select signal EIM_AD00.
 * - 001 - Select signal IPU1_DISP1_DATA09.
 * - 010 - Select signal IPU2_CSI1_DATA09.
 * - 101 - Select signal GPIO3_IO00.
 * - 111 - Select signal SRC_BOOT_CFG00.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE: Select signal EIM_AD00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE: Select signal IPU1_DISP1_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE: Select signal IPU2_CSI1_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE: Select signal GPIO3_IO00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE: Select signal SRC_BOOT_CFG00. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD00, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION: Force input path of pad EIM_DA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD00_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad01
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad01_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD01 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_ADDR(x) ((uintptr_t)(x) + 0x118U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad01_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD01, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA1.
 *
 * Values:
 * - 000 - Select signal EIM_AD01.
 * - 001 - Select signal IPU1_DISP1_DATA08.
 * - 010 - Select signal IPU2_CSI1_DATA08.
 * - 101 - Select signal GPIO3_IO01.
 * - 111 - Select signal SRC_BOOT_CFG01.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE: Select signal EIM_AD01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE: Select signal IPU1_DISP1_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE: Select signal IPU2_CSI1_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE: Select signal GPIO3_IO01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE: Select signal SRC_BOOT_CFG01. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD01, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION: Force input path of pad EIM_DA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD01_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad02
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad02_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD02 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_ADDR(x) ((uintptr_t)(x) + 0x11CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad02_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD02, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA2.
 *
 * Values:
 * - 000 - Select signal EIM_AD02.
 * - 001 - Select signal IPU1_DISP1_DATA07.
 * - 010 - Select signal IPU2_CSI1_DATA07.
 * - 101 - Select signal GPIO3_IO02.
 * - 111 - Select signal SRC_BOOT_CFG02.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE: Select signal EIM_AD02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE: Select signal IPU1_DISP1_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE: Select signal IPU2_CSI1_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE: Select signal GPIO3_IO02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE: Select signal SRC_BOOT_CFG02. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD02, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION: Force input path of pad EIM_DA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD02_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad03
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad03_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD03 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_ADDR(x) ((uintptr_t)(x) + 0x120U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad03_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD03, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA3.
 *
 * Values:
 * - 000 - Select signal EIM_AD03.
 * - 001 - Select signal IPU1_DISP1_DATA06.
 * - 010 - Select signal IPU2_CSI1_DATA06.
 * - 101 - Select signal GPIO3_IO03.
 * - 111 - Select signal SRC_BOOT_CFG03.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE: Select signal EIM_AD03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE: Select signal IPU1_DISP1_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE: Select signal IPU2_CSI1_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE: Select signal GPIO3_IO03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE: Select signal SRC_BOOT_CFG03. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD03, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION: Force input path of pad EIM_DA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD03_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_ADDR(x) ((uintptr_t)(x) + 0x124U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA4.
 *
 * Values:
 * - 000 - Select signal EIM_AD04.
 * - 001 - Select signal IPU1_DISP1_DATA05.
 * - 010 - Select signal IPU2_CSI1_DATA05.
 * - 101 - Select signal GPIO3_IO04.
 * - 111 - Select signal SRC_BOOT_CFG04.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE: Select signal EIM_AD04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE: Select signal IPU1_DISP1_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE: Select signal IPU2_CSI1_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE: Select signal GPIO3_IO04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE: Select signal SRC_BOOT_CFG04. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION: Force input path of pad EIM_DA4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad05
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad05_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD05 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_ADDR(x) ((uintptr_t)(x) + 0x128U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad05_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD05, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA5.
 *
 * Values:
 * - 000 - Select signal EIM_AD05.
 * - 001 - Select signal IPU1_DISP1_DATA04.
 * - 010 - Select signal IPU2_CSI1_DATA04.
 * - 101 - Select signal GPIO3_IO05.
 * - 111 - Select signal SRC_BOOT_CFG05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE: Select signal EIM_AD05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE: Select signal IPU1_DISP1_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE: Select signal IPU2_CSI1_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE: Select signal GPIO3_IO05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE: Select signal SRC_BOOT_CFG05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD05, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION: Force input path of pad EIM_DA5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD05_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad06
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad06_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD06 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_ADDR(x) ((uintptr_t)(x) + 0x12CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad06_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD06, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA6.
 *
 * Values:
 * - 000 - Select signal EIM_AD06.
 * - 001 - Select signal IPU1_DISP1_DATA03.
 * - 010 - Select signal IPU2_CSI1_DATA03.
 * - 101 - Select signal GPIO3_IO06.
 * - 111 - Select signal SRC_BOOT_CFG06.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE: Select signal EIM_AD06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE: Select signal IPU1_DISP1_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE: Select signal IPU2_CSI1_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE: Select signal GPIO3_IO06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE: Select signal SRC_BOOT_CFG06. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD06, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION: Force input path of pad EIM_DA6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD06_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad07
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad07_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD07 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_ADDR(x) ((uintptr_t)(x) + 0x130U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad07_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD07, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA7.
 *
 * Values:
 * - 000 - Select signal EIM_AD07.
 * - 001 - Select signal IPU1_DISP1_DATA02.
 * - 010 - Select signal IPU2_CSI1_DATA02.
 * - 101 - Select signal GPIO3_IO07.
 * - 111 - Select signal SRC_BOOT_CFG07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE: Select signal EIM_AD07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE: Select signal IPU1_DISP1_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE: Select signal IPU2_CSI1_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE: Select signal GPIO3_IO07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE: Select signal SRC_BOOT_CFG07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD07, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION: Force input path of pad EIM_DA7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD07_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad08
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad08_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD08 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_ADDR(x) ((uintptr_t)(x) + 0x134U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad08_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD08, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA8.
 *
 * Values:
 * - 000 - Select signal EIM_AD08.
 * - 001 - Select signal IPU1_DISP1_DATA01.
 * - 010 - Select signal IPU2_CSI1_DATA01.
 * - 101 - Select signal GPIO3_IO08.
 * - 111 - Select signal SRC_BOOT_CFG08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE: Select signal EIM_AD08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE: Select signal IPU1_DISP1_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE: Select signal IPU2_CSI1_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE: Select signal GPIO3_IO08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE: Select signal SRC_BOOT_CFG08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD08, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA8.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION: Force input path of pad EIM_DA8. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD08_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad09
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad09_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD09 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_ADDR(x) ((uintptr_t)(x) + 0x138U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad09_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD09, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA9.
 *
 * Values:
 * - 000 - Select signal EIM_AD09.
 * - 001 - Select signal IPU1_DISP1_DATA00.
 * - 010 - Select signal IPU2_CSI1_DATA00.
 * - 101 - Select signal GPIO3_IO09.
 * - 111 - Select signal SRC_BOOT_CFG09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE: Select signal EIM_AD09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE: Select signal IPU1_DISP1_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE: Select signal IPU2_CSI1_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE: Select signal GPIO3_IO09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE: Select signal SRC_BOOT_CFG09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD09, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA9.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION: Force input path of pad EIM_DA9. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD09_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad10
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad10_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD10 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_ADDR(x) ((uintptr_t)(x) + 0x13CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad10_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD10, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA10. NOTE: Pad EIM_DA10 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_AD10.
 * - 001 - Select signal IPU1_DI1_PIN15.
 * - 010 - Select signal IPU2_CSI1_DATA_EN.- Configure register
 *     IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO3_IO10.
 * - 111 - Select signal SRC_BOOT_CFG10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE: Select signal EIM_AD10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE: Select signal IPU1_DI1_PIN15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE: Select signal IPU2_CSI1_DATA_EN.- Configure register IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE: Select signal GPIO3_IO10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE: Select signal SRC_BOOT_CFG10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD10, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA10.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION: Force input path of pad EIM_DA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD10_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad11
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad11_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD11 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_ADDR(x) ((uintptr_t)(x) + 0x140U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad11_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD11, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA11. NOTE: Pad EIM_DA11 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_AD11.
 * - 001 - Select signal IPU1_DI1_PIN02.
 * - 010 - Select signal IPU2_CSI1_HSYNC.- Configure register
 *     IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO3_IO11.
 * - 111 - Select signal SRC_BOOT_CFG11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE: Select signal EIM_AD11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE: Select signal IPU1_DI1_PIN02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE: Select signal IPU2_CSI1_HSYNC.- Configure register IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE: Select signal GPIO3_IO11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE: Select signal SRC_BOOT_CFG11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD11, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA11.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION: Force input path of pad EIM_DA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD11_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad12
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad12_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD12 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_ADDR(x) ((uintptr_t)(x) + 0x144U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad12_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD12, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA12. NOTE: Pad EIM_DA12 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal EIM_AD12.
 * - 001 - Select signal IPU1_DI1_PIN03.
 * - 010 - Select signal IPU2_CSI1_VSYNC.- Configure register
 *     IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO3_IO12.
 * - 111 - Select signal SRC_BOOT_CFG12.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE: Select signal EIM_AD12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE: Select signal IPU1_DI1_PIN03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE: Select signal IPU2_CSI1_VSYNC.- Configure register IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE: Select signal GPIO3_IO12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE: Select signal SRC_BOOT_CFG12. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD12, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA12.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION: Force input path of pad EIM_DA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD12_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad13
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad13_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD13 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_ADDR(x) ((uintptr_t)(x) + 0x148U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad13_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD13, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_DA13.
 *
 * Values:
 * - 000 - Select signal EIM_AD13.
 * - 001 - Select signal IPU1_DI1_D0_CS.
 * - 101 - Select signal GPIO3_IO13.
 * - 111 - Select signal SRC_BOOT_CFG13.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE: Select signal EIM_AD13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE: Select signal IPU1_DI1_D0_CS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE: Select signal GPIO3_IO13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE: Select signal SRC_BOOT_CFG13. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD13, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA13.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION: Force input path of pad EIM_DA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD13_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad14
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad14_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD14 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_ADDR(x) ((uintptr_t)(x) + 0x14CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad14_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD14, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_DA14.
 *
 * Values:
 * - 000 - Select signal EIM_AD14.
 * - 001 - Select signal IPU1_DI1_D1_CS.
 * - 101 - Select signal GPIO3_IO14.
 * - 111 - Select signal SRC_BOOT_CFG14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE: Select signal EIM_AD14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE: Select signal IPU1_DI1_D1_CS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE: Select signal GPIO3_IO14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE: Select signal SRC_BOOT_CFG14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD14, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA14.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION: Force input path of pad EIM_DA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD14_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_ad15
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_ad15_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_ad15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_AD15 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_ad15_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_AD15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD15, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: EIM_DA15.
 *
 * Values:
 * - 000 - Select signal EIM_AD15.
 * - 001 - Select signal IPU1_DI1_PIN01.
 * - 010 - Select signal IPU1_DI1_PIN04.
 * - 101 - Select signal GPIO3_IO15.
 * - 111 - Select signal SRC_BOOT_CFG15.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE: Select signal EIM_AD15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE: Select signal IPU1_DI1_PIN01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE: Select signal IPU1_DI1_PIN04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE: Select signal GPIO3_IO15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE: Select signal SRC_BOOT_CFG15. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_AD15, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_DA15.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION: Force input path of pad EIM_DA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_AD15_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_wait_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_wait_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_wait_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_wait_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: EIM_WAIT.
 *
 * Values:
 * - 000 - Select signal EIM_WAIT_B.
 * - 001 - Select signal EIM_DTACK_B.
 * - 101 - Select signal GPIO5_IO00.
 * - 111 - Select signal SRC_BOOT_CFG25.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE: Select signal EIM_WAIT_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE: Select signal EIM_DTACK_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE: Select signal GPIO5_IO00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE: Select signal SRC_BOOT_CFG25. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_WAIT.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION: Force input path of pad EIM_WAIT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_WAIT_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_eim_bclk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_eim_bclk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_eim_bclk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_ADDR(x) ((uintptr_t)(x) + 0x158U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_eim_bclk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: EIM_BCLK.
 *
 * Values:
 * - 000 - Select signal EIM_BCLK.
 * - 001 - Select signal IPU1_DI1_PIN16.
 * - 101 - Select signal GPIO6_IO31.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE: Select signal EIM_BCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE: Select signal IPU1_DI1_PIN16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE: Select signal GPIO6_IO31. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad EIM_BCLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION: Force input path of pad EIM_BCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_EIM_BCLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_di0_disp_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_di0_disp_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_di0_disp_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_ADDR(x) ((uintptr_t)(x) + 0x15CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_di0_disp_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 000 - Select signal IPU1_DI0_DISP_CLK.
 * - 001 - Select signal IPU2_DI0_DISP_CLK.
 * - 101 - Select signal GPIO4_IO16.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE: Select signal IPU1_DI0_DISP_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE: Select signal IPU2_DI0_DISP_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE: Select signal GPIO4_IO16. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DI0_DISP_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION: Force input path of pad DI0_DISP_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_DISP_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_di0_pin15
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_di0_pin15_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_di0_pin15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_ADDR(x) ((uintptr_t)(x) + 0x160U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_di0_pin15_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DI0_PIN15.
 *
 * Values:
 * - 000 - Select signal IPU1_DI0_PIN15.
 * - 001 - Select signal IPU2_DI0_PIN15.
 * - 010 - Select signal AUD6_TXC.
 * - 101 - Select signal GPIO4_IO17.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE: Select signal IPU1_DI0_PIN15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE: Select signal IPU2_DI0_PIN15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE: Select signal AUD6_TXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE: Select signal GPIO4_IO17. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DI0_PIN15.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION: Force input path of pad DI0_PIN15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN15_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_di0_pin02
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_di0_pin02_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_di0_pin02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_ADDR(x) ((uintptr_t)(x) + 0x164U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_di0_pin02_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DI0_PIN2.
 *
 * Values:
 * - 000 - Select signal IPU1_DI0_PIN02.
 * - 001 - Select signal IPU2_DI0_PIN02.
 * - 010 - Select signal AUD6_TXD.
 * - 101 - Select signal GPIO4_IO18.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE: Select signal IPU1_DI0_PIN02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE: Select signal IPU2_DI0_PIN02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE: Select signal AUD6_TXD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE: Select signal GPIO4_IO18. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DI0_PIN2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION: Force input path of pad DI0_PIN2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN02_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_di0_pin03
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_di0_pin03_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_di0_pin03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_ADDR(x) ((uintptr_t)(x) + 0x168U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_di0_pin03_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DI0_PIN3.
 *
 * Values:
 * - 000 - Select signal IPU1_DI0_PIN03.
 * - 001 - Select signal IPU2_DI0_PIN03.
 * - 010 - Select signal AUD6_TXFS.
 * - 101 - Select signal GPIO4_IO19.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE: Select signal IPU1_DI0_PIN03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE: Select signal IPU2_DI0_PIN03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE: Select signal AUD6_TXFS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE: Select signal GPIO4_IO19. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DI0_PIN3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION: Force input path of pad DI0_PIN3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN03_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_di0_pin04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_di0_pin04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_di0_pin04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_ADDR(x) ((uintptr_t)(x) + 0x16CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_di0_pin04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DI0_PIN4. NOTE: Pad DI0_PIN4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DI0_PIN04.
 * - 001 - Select signal IPU2_DI0_PIN04.
 * - 010 - Select signal AUD6_RXD.
 * - 011 - Select signal SD1_WP.- Configure register
 *     IOMUXC_USDHC1_WP_ON_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO4_IO20.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE: Select signal IPU1_DI0_PIN04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE: Select signal IPU2_DI0_PIN04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE: Select signal AUD6_RXD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE: Select signal SD1_WP.- Configure register IOMUXC_USDHC1_WP_ON_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE: Select signal GPIO4_IO20. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DI0_PIN4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION: Force input path of pad DI0_PIN4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DI0_PIN04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data00
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data00_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_ADDR(x) ((uintptr_t)(x) + 0x170U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data00_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT0.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA00.
 * - 001 - Select signal IPU2_DISP0_DATA00.
 * - 010 - Select signal ECSPI3_SCLK.
 * - 101 - Select signal GPIO4_IO21.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE: Select signal IPU1_DISP0_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE: Select signal IPU2_DISP0_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE: Select signal ECSPI3_SCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE: Select signal GPIO4_IO21. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION: Force input path of pad DISP0_DAT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA00_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data01
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data01_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_ADDR(x) ((uintptr_t)(x) + 0x174U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data01_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT1.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA01.
 * - 001 - Select signal IPU2_DISP0_DATA01.
 * - 010 - Select signal ECSPI3_MOSI.
 * - 101 - Select signal GPIO4_IO22.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE: Select signal IPU1_DISP0_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE: Select signal IPU2_DISP0_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE: Select signal ECSPI3_MOSI. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE: Select signal GPIO4_IO22. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION: Force input path of pad DISP0_DAT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA01_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data02
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data02_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_ADDR(x) ((uintptr_t)(x) + 0x178U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data02_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT2.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA02.
 * - 001 - Select signal IPU2_DISP0_DATA02.
 * - 010 - Select signal ECSPI3_MISO.
 * - 101 - Select signal GPIO4_IO23.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE: Select signal IPU1_DISP0_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE: Select signal IPU2_DISP0_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE: Select signal ECSPI3_MISO. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE: Select signal GPIO4_IO23. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION: Force input path of pad DISP0_DAT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA02_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data03
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data03_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_ADDR(x) ((uintptr_t)(x) + 0x17CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data03_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT3.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA03.
 * - 001 - Select signal IPU2_DISP0_DATA03.
 * - 010 - Select signal ECSPI3_SS0.
 * - 101 - Select signal GPIO4_IO24.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE: Select signal IPU1_DISP0_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE: Select signal IPU2_DISP0_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE: Select signal ECSPI3_SS0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE: Select signal GPIO4_IO24. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION: Force input path of pad DISP0_DAT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA03_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_ADDR(x) ((uintptr_t)(x) + 0x180U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT4.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA04.
 * - 001 - Select signal IPU2_DISP0_DATA04.
 * - 010 - Select signal ECSPI3_SS1.
 * - 101 - Select signal GPIO4_IO25.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE: Select signal IPU1_DISP0_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE: Select signal IPU2_DISP0_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE: Select signal ECSPI3_SS1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE: Select signal GPIO4_IO25. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION: Force input path of pad DISP0_DAT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data05_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_ADDR(x) ((uintptr_t)(x) + 0x184U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data05_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT5.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA05.
 * - 001 - Select signal IPU2_DISP0_DATA05.
 * - 010 - Select signal ECSPI3_SS2.
 * - 011 - Select signal AUD6_RXFS.
 * - 101 - Select signal GPIO4_IO26.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE: Select signal IPU1_DISP0_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE: Select signal IPU2_DISP0_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE: Select signal ECSPI3_SS2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE: Select signal AUD6_RXFS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE: Select signal GPIO4_IO26. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION: Force input path of pad DISP0_DAT5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA05_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data06_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_ADDR(x) ((uintptr_t)(x) + 0x188U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data06_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT6.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA06.
 * - 001 - Select signal IPU2_DISP0_DATA06.
 * - 010 - Select signal ECSPI3_SS3.
 * - 011 - Select signal AUD6_RXC.
 * - 101 - Select signal GPIO4_IO27.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE: Select signal IPU1_DISP0_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE: Select signal IPU2_DISP0_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE: Select signal ECSPI3_SS3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE: Select signal AUD6_RXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE: Select signal GPIO4_IO27. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION: Force input path of pad DISP0_DAT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA06_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data07_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_ADDR(x) ((uintptr_t)(x) + 0x18CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data07_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT7.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA07.
 * - 001 - Select signal IPU2_DISP0_DATA07.
 * - 010 - Select signal ECSPI3_RDY.
 * - 101 - Select signal GPIO4_IO28.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE: Select signal IPU1_DISP0_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE: Select signal IPU2_DISP0_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE: Select signal ECSPI3_RDY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE: Select signal GPIO4_IO28. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION: Force input path of pad DISP0_DAT7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA07_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data08
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data08_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_ADDR(x) ((uintptr_t)(x) + 0x190U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data08_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT8.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA08.
 * - 001 - Select signal IPU2_DISP0_DATA08.
 * - 010 - Select signal PWM1_OUT.
 * - 011 - Select signal WDOG1_B.
 * - 101 - Select signal GPIO4_IO29.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE: Select signal IPU1_DISP0_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE: Select signal IPU2_DISP0_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE: Select signal PWM1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE: Select signal WDOG1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE: Select signal GPIO4_IO29. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT8.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION: Force input path of pad DISP0_DAT8. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA08_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data09
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data09_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_ADDR(x) ((uintptr_t)(x) + 0x194U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data09_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT9.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA09.
 * - 001 - Select signal IPU2_DISP0_DATA09.
 * - 010 - Select signal PWM2_OUT.
 * - 011 - Select signal WDOG2_B.
 * - 101 - Select signal GPIO4_IO30.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE: Select signal IPU1_DISP0_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE: Select signal IPU2_DISP0_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE: Select signal PWM2_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE: Select signal WDOG2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE: Select signal GPIO4_IO30. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT9.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION: Force input path of pad DISP0_DAT9. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA09_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data10
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data10_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_ADDR(x) ((uintptr_t)(x) + 0x198U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data10_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: DISP0_DAT10.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA10.
 * - 001 - Select signal IPU2_DISP0_DATA10.
 * - 101 - Select signal GPIO4_IO31.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE: Select signal IPU1_DISP0_DATA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE: Select signal IPU2_DISP0_DATA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE: Select signal GPIO4_IO31. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT10.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION: Force input path of pad DISP0_DAT10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA10_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data11
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data11_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_ADDR(x) ((uintptr_t)(x) + 0x19CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data11_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: DISP0_DAT11.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA11.
 * - 001 - Select signal IPU2_DISP0_DATA11.
 * - 101 - Select signal GPIO5_IO05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE: Select signal IPU1_DISP0_DATA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE: Select signal IPU2_DISP0_DATA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE: Select signal GPIO5_IO05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT11.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION: Force input path of pad DISP0_DAT11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA11_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data12
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data12_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_ADDR(x) ((uintptr_t)(x) + 0x1A0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data12_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: DISP0_DAT12.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA12.
 * - 001 - Select signal IPU2_DISP0_DATA12.
 * - 101 - Select signal GPIO5_IO06.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE: Select signal IPU1_DISP0_DATA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE: Select signal IPU2_DISP0_DATA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE: Select signal GPIO5_IO06. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT12.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION: Force input path of pad DISP0_DAT12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA12_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data13
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data13_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_ADDR(x) ((uintptr_t)(x) + 0x1A4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data13_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT13. NOTE: Pad
 * DISP0_DAT13 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA13.
 * - 001 - Select signal IPU2_DISP0_DATA13.
 * - 011 - Select signal AUD5_RXFS.- Configure register
 *     IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE: Select signal IPU1_DISP0_DATA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE: Select signal IPU2_DISP0_DATA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE: Select signal AUD5_RXFS.- Configure register IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE: Select signal GPIO5_IO07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT13.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION: Force input path of pad DISP0_DAT13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA13_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data14
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data14_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_ADDR(x) ((uintptr_t)(x) + 0x1A8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data14_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: DISP0_DAT14. NOTE: Pad
 * DISP0_DAT14 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA14.
 * - 001 - Select signal IPU2_DISP0_DATA14.
 * - 011 - Select signal AUD5_RXC.- Configure register
 *     IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE: Select signal IPU1_DISP0_DATA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE: Select signal IPU2_DISP0_DATA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE: Select signal AUD5_RXC.- Configure register IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE: Select signal GPIO5_IO08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT14.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION: Force input path of pad DISP0_DAT14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA14_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data15
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data15_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_ADDR(x) ((uintptr_t)(x) + 0x1ACU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data15_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT15. NOTE: Pad
 * DISP0_DAT15 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA15.
 * - 001 - Select signal IPU2_DISP0_DATA15.
 * - 010 - Select signal ECSPI1_SS1.- Configure register
 *     IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal ECSPI2_SS1.- Configure register
 *     IOMUXC_ECSPI2_SS1_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE: Select signal IPU1_DISP0_DATA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE: Select signal IPU2_DISP0_DATA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE: Select signal ECSPI1_SS1.- Configure register IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE: Select signal ECSPI2_SS1.- Configure register IOMUXC_ECSPI2_SS1_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE: Select signal GPIO5_IO09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT15.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION: Force input path of pad DISP0_DAT15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA15_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data16_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_ADDR(x) ((uintptr_t)(x) + 0x1B0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data16_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: DISP0_DAT16. NOTE: Pad
 * DISP0_DAT16 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA16.
 * - 001 - Select signal IPU2_DISP0_DATA16.
 * - 010 - Select signal ECSPI2_MOSI.- Configure register
 *     IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD5_TXC.- Configure register
 *     IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal SDMA_EXT_EVENT0.- Configure register
 *     IOMUXC_SDMA_EVENTS14_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal IPU1_DISP0_DATA16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal IPU2_DISP0_DATA16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal ECSPI2_MOSI.- Configure register IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal AUD5_TXC.- Configure register IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal SDMA_EXT_EVENT0.- Configure register IOMUXC_SDMA_EVENTS14_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE: Select signal GPIO5_IO10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT16.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION: Force input path of pad DISP0_DAT16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA16_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data17_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_ADDR(x) ((uintptr_t)(x) + 0x1B4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data17_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: DISP0_DAT17. NOTE: Pad
 * DISP0_DAT17 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA17.
 * - 001 - Select signal IPU2_DISP0_DATA17.
 * - 010 - Select signal ECSPI2_MISO.- Configure register
 *     IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD5_TXD.- Configure register
 *     IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal SDMA_EXT_EVENT1.- Configure register
 *     IOMUXC_SDMA_EVENTS47_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal IPU1_DISP0_DATA17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal IPU2_DISP0_DATA17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal ECSPI2_MISO.- Configure register IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal AUD5_TXD.- Configure register IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal SDMA_EXT_EVENT1.- Configure register IOMUXC_SDMA_EVENTS47_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE: Select signal GPIO5_IO11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT17.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION: Force input path of pad DISP0_DAT17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA17_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data18_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_ADDR(x) ((uintptr_t)(x) + 0x1B8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data18_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: DISP0_DAT18. NOTE: Pad
 * DISP0_DAT18 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA18.
 * - 001 - Select signal IPU2_DISP0_DATA18.
 * - 010 - Select signal ECSPI2_SS0.- Configure register
 *     IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD5_TXFS.- Configure register
 *     IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD4_RXFS.- Configure register
 *     IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO12.
 * - 111 - Select signal EIM_CS2_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal IPU1_DISP0_DATA18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal IPU2_DISP0_DATA18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal ECSPI2_SS0.- Configure register IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal AUD5_TXFS.- Configure register IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal AUD4_RXFS.- Configure register IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal GPIO5_IO12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE: Select signal EIM_CS2_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT18.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION: Force input path of pad DISP0_DAT18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA18_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data19_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_ADDR(x) ((uintptr_t)(x) + 0x1BCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data19_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: DISP0_DAT19. NOTE: Pad
 * DISP0_DAT19 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA19.
 * - 001 - Select signal IPU2_DISP0_DATA19.
 * - 010 - Select signal ECSPI2_SCLK.- Configure register
 *     IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD5_RXD.- Configure register
 *     IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD4_RXC.- Configure register
 *     IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO13.
 * - 111 - Select signal EIM_CS3_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal IPU1_DISP0_DATA19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal IPU2_DISP0_DATA19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal ECSPI2_SCLK.- Configure register IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal AUD5_RXD.- Configure register IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal AUD4_RXC.- Configure register IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal GPIO5_IO13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE: Select signal EIM_CS3_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT19.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION: Force input path of pad DISP0_DAT19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA19_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data20
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data20_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_ADDR(x) ((uintptr_t)(x) + 0x1C0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data20_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT20. NOTE: Pad
 * DISP0_DAT20 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA20.
 * - 001 - Select signal IPU2_DISP0_DATA20.
 * - 010 - Select signal ECSPI1_SCLK.- Configure register
 *     IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_TXC.- Configure register
 *     IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE: Select signal IPU1_DISP0_DATA20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE: Select signal IPU2_DISP0_DATA20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE: Select signal ECSPI1_SCLK.- Configure register IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE: Select signal AUD4_TXC.- Configure register IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE: Select signal GPIO5_IO14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT20.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION: Force input path of pad DISP0_DAT20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA20_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data21
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data21_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_ADDR(x) ((uintptr_t)(x) + 0x1C4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data21_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT21. NOTE: Pad
 * DISP0_DAT21 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA21.
 * - 001 - Select signal IPU2_DISP0_DATA21.
 * - 010 - Select signal ECSPI1_MOSI.- Configure register
 *     IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_TXD.- Configure register
 *     IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO15.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE: Select signal IPU1_DISP0_DATA21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE: Select signal IPU2_DISP0_DATA21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE: Select signal ECSPI1_MOSI.- Configure register IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE: Select signal AUD4_TXD.- Configure register IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE: Select signal GPIO5_IO15. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT21.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION: Force input path of pad DISP0_DAT21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA21_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data22
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data22_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_ADDR(x) ((uintptr_t)(x) + 0x1C8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data22_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT22. NOTE: Pad
 * DISP0_DAT22 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA22.
 * - 001 - Select signal IPU2_DISP0_DATA22.
 * - 010 - Select signal ECSPI1_MISO.- Configure register
 *     IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_TXFS.- Configure register
 *     IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO16.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE: Select signal IPU1_DISP0_DATA22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE: Select signal IPU2_DISP0_DATA22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE: Select signal ECSPI1_MISO.- Configure register IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE: Select signal AUD4_TXFS.- Configure register IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE: Select signal GPIO5_IO16. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT22.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION: Force input path of pad DISP0_DAT22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA22_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_disp0_data23
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_disp0_data23_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_disp0_data23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_ADDR(x) ((uintptr_t)(x) + 0x1CCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_disp0_data23_t *) HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: DISP0_DAT23. NOTE: Pad
 * DISP0_DAT23 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_DISP0_DATA23.
 * - 001 - Select signal IPU2_DISP0_DATA23.
 * - 010 - Select signal ECSPI1_SS0.- Configure register
 *     IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_RXD.- Configure register
 *     IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO17.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE: Select signal IPU1_DISP0_DATA23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE: Select signal IPU2_DISP0_DATA23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE: Select signal ECSPI1_SS0.- Configure register IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE: Select signal AUD4_RXD.- Configure register IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE: Select signal GPIO5_IO17. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad DISP0_DAT23.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION: Force input path of pad DISP0_DAT23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_DISP0_DATA23_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_mdio
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_mdio_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_mdio_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_ADDR(x) ((uintptr_t)(x) + 0x1D0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_mdio_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: ENET_MDIO. NOTE: Pad ENET_MDIO
 * is involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal ENET_MDIO.- Configure register
 *     IOMUXC_ENET_MAC0_MDIO_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal ESAI_RX_CLK.- Configure register
 *     IOMUXC_ESAI_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal ENET_1588_EVENT1_OUT.
 * - 101 - Select signal GPIO1_IO22.
 * - 110 - Select signal SPDIF_LOCK.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE: Select signal ENET_MDIO.- Configure register IOMUXC_ENET_MAC0_MDIO_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE: Select signal ESAI_RX_CLK.- Configure register IOMUXC_ESAI_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE: Select signal ENET_1588_EVENT1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE: Select signal GPIO1_IO22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE: Select signal SPDIF_LOCK. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_MDIO.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION: Force input path of pad ENET_MDIO. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDIO_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_ref_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_ref_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_ref_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_ADDR(x) ((uintptr_t)(x) + 0x1D4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_ref_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: ENET_REF_CLK. NOTE: Pad
 * ENET_REF_CLK is involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal ENET_TX_CLK. In MII mode, provides a timing reference
 *     for TX_EN, TX_DATA[3:0] and TX_ER. In RGMII mode, provides 125 MHz
 *     reference clock input.
 * - 010 - Select signal ESAI_RX_FS.- Configure register
 *     IOMUXC_ESAI_RX_FS_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO23.
 * - 110 - Select signal SPDIF_SR_CLK.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE: Select signal ENET_TX_CLK. In MII mode, provides a timing reference for TX_EN, TX_DATA[3:0] and TX_ER. In RGMII mode, provides 125 MHz reference clock input. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE: Select signal ESAI_RX_FS.- Configure register IOMUXC_ESAI_RX_FS_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE: Select signal GPIO1_IO23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE: Select signal SPDIF_SR_CLK. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_REF_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION: Force input path of pad ENET_REF_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_REF_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_rx_er
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_rx_er_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_rx_er_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_ADDR(x) ((uintptr_t)(x) + 0x1D8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_er_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: ENET_RX_ER. NOTE: Pad
 * ENET_RX_ER is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal USB_OTG_ID.
 * - 001 - Select signal ENET_RX_ER.
 * - 010 - Select signal ESAI_RX_HF_CLK.- Configure register
 *     IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal SPDIF_IN.- Configure register
 *     IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal ENET_1588_EVENT2_OUT.
 * - 101 - Select signal GPIO1_IO24.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal USB_OTG_ID. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal ENET_RX_ER. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal ESAI_RX_HF_CLK.- Configure register IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal SPDIF_IN.- Configure register IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal ENET_1588_EVENT2_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE: Select signal GPIO1_IO24. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_RX_ER.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION: Force input path of pad ENET_RX_ER. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_ER_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_crs_dv
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_crs_dv_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_crs_dv_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_ADDR(x) ((uintptr_t)(x) + 0x1DCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_crs_dv_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: ENET_CRS_DV. NOTE: Pad
 * ENET_CRS_DV is involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal ENET_RX_EN.- Configure register
 *     IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal ESAI_TX_CLK.- Configure register
 *     IOMUXC_ESAI_TX_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal SPDIF_EXT_CLK.- Configure register
 *     IOMUXC_SPDIF_TX_CLK2_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO1_IO25.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE: Select signal ENET_RX_EN.- Configure register IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE: Select signal ESAI_TX_CLK.- Configure register IOMUXC_ESAI_TX_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE: Select signal SPDIF_EXT_CLK.- Configure register IOMUXC_SPDIF_TX_CLK2_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE: Select signal GPIO1_IO25. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_CRS_DV.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION: Force input path of pad ENET_CRS_DV. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_CRS_DV_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_rx_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_rx_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_rx_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_ADDR(x) ((uintptr_t)(x) + 0x1E0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: ENET_RXD1. NOTE: Pad ENET_RXD1
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal MLB_SIG.- Configure register
 *     IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_RX_DATA1.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal ESAI_TX_FS.- Configure register
 *     IOMUXC_ESAI_TX_FS_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal ENET_1588_EVENT3_OUT.
 * - 101 - Select signal GPIO1_IO26.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE: Select signal MLB_SIG.- Configure register IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE: Select signal ENET_RX_DATA1.- Configure register IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE: Select signal ESAI_TX_FS.- Configure register IOMUXC_ESAI_TX_FS_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE: Select signal ENET_1588_EVENT3_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE: Select signal GPIO1_IO26. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_RXD1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION: Force input path of pad ENET_RXD1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_rx_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_rx_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_rx_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_ADDR(x) ((uintptr_t)(x) + 0x1E4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: ENET_RXD0. NOTE: Pad ENET_RXD0
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal XTALOSC_OSC32K_32K_OUT.
 * - 001 - Select signal ENET_RX_DATA0.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal ESAI_TX_HF_CLK.- Configure register
 *     IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal SPDIF_OUT.
 * - 101 - Select signal GPIO1_IO27.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE: Select signal XTALOSC_OSC32K_32K_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE: Select signal ENET_RX_DATA0.- Configure register IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE: Select signal ESAI_TX_HF_CLK.- Configure register IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE: Select signal SPDIF_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE: Select signal GPIO1_IO27. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_RXD0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION: Force input path of pad ENET_RXD0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_RX_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_tx_en
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_tx_en_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_tx_en_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_ADDR(x) ((uintptr_t)(x) + 0x1E8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_en_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: ENET_TX_EN. NOTE: Pad
 * ENET_TX_EN is involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal ENET_TX_EN.
 * - 010 - Select signal ESAI_TX3_RX2.- Configure register
 *     IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO28.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE: Select signal ENET_TX_EN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE: Select signal ESAI_TX3_RX2.- Configure register IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE: Select signal GPIO1_IO28. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_TX_EN.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION: Force input path of pad ENET_TX_EN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_EN_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_tx_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_tx_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_tx_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_ADDR(x) ((uintptr_t)(x) + 0x1ECU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: ENET_TXD1. NOTE: Pad ENET_TXD1
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal MLB_CLK.- Configure register
 *     IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_TX_DATA1.
 * - 010 - Select signal ESAI_TX2_RX3.- Configure register
 *     IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal ENET_1588_EVENT0_IN.
 * - 101 - Select signal GPIO1_IO29.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE: Select signal MLB_CLK.- Configure register IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE: Select signal ENET_TX_DATA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE: Select signal ESAI_TX2_RX3.- Configure register IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE: Select signal ENET_1588_EVENT0_IN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE: Select signal GPIO1_IO29. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_TXD1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION: Force input path of pad ENET_TXD1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_tx_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_tx_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_tx_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_ADDR(x) ((uintptr_t)(x) + 0x1F0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: ENET_TXD0. NOTE: Pad ENET_TXD0
 * is involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal ENET_TX_DATA0.
 * - 010 - Select signal ESAI_TX4_RX1.- Configure register
 *     IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO30.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE: Select signal ENET_TX_DATA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE: Select signal ESAI_TX4_RX1.- Configure register IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE: Select signal GPIO1_IO30. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_TXD0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION: Force input path of pad ENET_TXD0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_TX_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_enet_mdc
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_enet_mdc_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_enet_mdc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_ENET_MDC register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_ADDR(x) ((uintptr_t)(x) + 0x1F4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_enet_mdc_t *) HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_ENET_MDC bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_MDC, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: ENET_MDC. NOTE: Pad ENET_MDC is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal MLB_DATA.- Configure register
 *     IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_MDC.
 * - 010 - Select signal ESAI_TX5_RX0.- Configure register
 *     IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 100 - Select signal ENET_1588_EVENT1_IN.
 * - 101 - Select signal GPIO1_IO31.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE: Select signal MLB_DATA.- Configure register IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE: Select signal ENET_MDC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE: Select signal ESAI_TX5_RX0.- Configure register IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE: Select signal ENET_1588_EVENT1_IN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE: Select signal GPIO1_IO31. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_ENET_MDC, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad ENET_MDC.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION: Force input path of pad ENET_MDC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_ENET_MDC_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_col0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_col0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_col0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_COL0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_ADDR(x) ((uintptr_t)(x) + 0x1F8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_col0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_COL0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_COL0. NOTE: Pad KEY_COL0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_SCLK.- Configure register
 *     IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_RX_DATA3.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal AUD5_TXC.- Configure register
 *     IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL0.
 * - 100 - Select signal UART4_TX_DATA.- Configure register
 *     IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO06.
 * - 110 - Select signal DCIC1_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal ECSPI1_SCLK.- Configure register IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal ENET_RX_DATA3.- Configure register IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal AUD5_TXC.- Configure register IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal KEY_COL0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal UART4_TX_DATA.- Configure register IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal GPIO4_IO06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE: Select signal DCIC1_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_COL0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION: Force input path of pad KEY_COL0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_row0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_row0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_row0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_ADDR(x) ((uintptr_t)(x) + 0x1FCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_row0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_ROW0. NOTE: Pad KEY_ROW0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_MOSI.- Configure register
 *     IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_TX_DATA3.
 * - 010 - Select signal AUD5_TXD.- Configure register
 *     IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW0.
 * - 100 - Select signal UART4_RX_DATA.- Configure register
 *     IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO07.
 * - 110 - Select signal DCIC2_OUT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal ECSPI1_MOSI.- Configure register IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal ENET_TX_DATA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal AUD5_TXD.- Configure register IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal KEY_ROW0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal UART4_RX_DATA.- Configure register IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal GPIO4_IO07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE: Select signal DCIC2_OUT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_ROW0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION: Force input path of pad KEY_ROW0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_col1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_col1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_col1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_COL1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_ADDR(x) ((uintptr_t)(x) + 0x200U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_col1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_COL1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_COL1. NOTE: Pad KEY_COL1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_MISO.- Configure register
 *     IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_MDIO.- Configure register
 *     IOMUXC_ENET_MAC0_MDIO_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal AUD5_TXFS.- Configure register
 *     IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL1.
 * - 100 - Select signal UART5_TX_DATA.- Configure register
 *     IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO08.
 * - 110 - Select signal SD1_VSELECT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal ECSPI1_MISO.- Configure register IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal ENET_MDIO.- Configure register IOMUXC_ENET_MAC0_MDIO_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal AUD5_TXFS.- Configure register IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal KEY_COL1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal UART5_TX_DATA.- Configure register IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal GPIO4_IO08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE: Select signal SD1_VSELECT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_COL1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION: Force input path of pad KEY_COL1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_row1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_row1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_row1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_row1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_ROW1. NOTE: Pad KEY_ROW1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_SS0.- Configure register
 *     IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_COL.
 * - 010 - Select signal AUD5_RXD.- Configure register
 *     IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW1.
 * - 100 - Select signal UART5_RX_DATA.- Configure register
 *     IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO09.
 * - 110 - Select signal SD2_VSELECT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal ECSPI1_SS0.- Configure register IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal ENET_COL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal AUD5_RXD.- Configure register IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal KEY_ROW1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal UART5_RX_DATA.- Configure register IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal GPIO4_IO09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE: Select signal SD2_VSELECT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_ROW1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION: Force input path of pad KEY_ROW1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_col2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_col2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_col2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_COL2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_col2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_COL2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_COL2. NOTE: Pad KEY_COL2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_SS1.- Configure register
 *     IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_RX_DATA2.- Configure register
 *     IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal FLEXCAN1_TX.
 * - 011 - Select signal KEY_COL2.
 * - 100 - Select signal ENET_MDC.
 * - 101 - Select signal GPIO4_IO10.
 * - 110 - Select signal USB_H1_PWR_CTL_WAKE.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal ECSPI1_SS1.- Configure register IOMUXC_ECSPI1_SS1_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal ENET_RX_DATA2.- Configure register IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal FLEXCAN1_TX. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal KEY_COL2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal ENET_MDC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal GPIO4_IO10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE: Select signal USB_H1_PWR_CTL_WAKE. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_COL2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION: Force input path of pad KEY_COL2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_row2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_row2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_row2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_ADDR(x) ((uintptr_t)(x) + 0x20CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_row2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_ROW2. NOTE: Pad KEY_ROW2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_SS2.- Configure register
 *     IOMUXC_ECSPI1_SS2_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_TX_DATA2.
 * - 010 - Select signal FLEXCAN1_RX.- Configure register
 *     IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW2.
 * - 100 - Select signal SD2_VSELECT.
 * - 101 - Select signal GPIO4_IO11.
 * - 110 - Select signal HDMI_TX_CEC_LINE.- Configure register
 *     IOMUXC_HDMI_ICECIN_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal ECSPI1_SS2.- Configure register IOMUXC_ECSPI1_SS2_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal ENET_TX_DATA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal FLEXCAN1_RX.- Configure register IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal KEY_ROW2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal SD2_VSELECT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal GPIO4_IO11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE: Select signal HDMI_TX_CEC_LINE.- Configure register IOMUXC_HDMI_ICECIN_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_ROW2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION: Force input path of pad KEY_ROW2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_col3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_col3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_col3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_COL3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_ADDR(x) ((uintptr_t)(x) + 0x210U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_col3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_COL3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_COL3. NOTE: Pad KEY_COL3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ECSPI1_SS3.- Configure register
 *     IOMUXC_ECSPI1_SS3_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_CRS.
 * - 010 - Select signal HDMI_TX_DDC_SCL.- Configure register
 *     IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL3.
 * - 100 - Select signal I2C2_SCL.- Configure register
 *     IOMUXC_I2C2_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO12.
 * - 110 - Select signal SPDIF_IN.- Configure register
 *     IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal ECSPI1_SS3.- Configure register IOMUXC_ECSPI1_SS3_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal ENET_CRS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal HDMI_TX_DDC_SCL.- Configure register IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal KEY_COL3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal I2C2_SCL.- Configure register IOMUXC_I2C2_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal GPIO4_IO12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE: Select signal SPDIF_IN.- Configure register IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_COL3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION: Force input path of pad KEY_COL3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_row3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_row3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_row3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_ADDR(x) ((uintptr_t)(x) + 0x214U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_row3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: KEY_ROW3. NOTE: Pad KEY_ROW3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal XTALOSC_OSC32K_32K_OUT.
 * - 001 - Select signal ASRC_EXT_CLK.- Configure register
 *     IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal HDMI_TX_DDC_SDA.- Configure register
 *     IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW3.
 * - 100 - Select signal I2C2_SDA.- Configure register
 *     IOMUXC_I2C2_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO13.
 * - 110 - Select signal SD1_VSELECT.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal XTALOSC_OSC32K_32K_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal ASRC_EXT_CLK.- Configure register IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal HDMI_TX_DDC_SDA.- Configure register IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal KEY_ROW3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal I2C2_SDA.- Configure register IOMUXC_I2C2_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal GPIO4_IO13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE: Select signal SD1_VSELECT. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_ROW3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION: Force input path of pad KEY_ROW3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_col4
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_col4_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_col4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_COL4 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_ADDR(x) ((uintptr_t)(x) + 0x218U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_col4_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_COL4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL4, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: KEY_COL4. NOTE: Pad KEY_COL4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal FLEXCAN2_TX.
 * - 001 - Select signal IPU1_SISG4.
 * - 010 - Select signal USB_OTG_OC.- Configure register
 *     IOMUXC_USB_OTG_OC_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL4.
 * - 100 - Select signal UART5_RTS_B.- Configure register
 *     IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal FLEXCAN2_TX. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal IPU1_SISG4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal USB_OTG_OC.- Configure register IOMUXC_USB_OTG_OC_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal KEY_COL4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal UART5_RTS_B.- Configure register IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE: Select signal GPIO4_IO14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_COL4, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_COL4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION: Force input path of pad KEY_COL4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_key_row4
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_key_row4_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_key_row4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_ADDR(x) ((uintptr_t)(x) + 0x21CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_key_row4_t *) HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: KEY_ROW4. NOTE: Pad KEY_ROW4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal FLEXCAN2_RX.- Configure register
 *     IOMUXC_FLEXCAN2_RX_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal IPU1_SISG5.
 * - 010 - Select signal USB_OTG_PWR.
 * - 011 - Select signal KEY_ROW4.
 * - 100 - Select signal UART5_CTS_B.- Configure register
 *     IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO4_IO15.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal FLEXCAN2_RX.- Configure register IOMUXC_FLEXCAN2_RX_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal IPU1_SISG5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal USB_OTG_PWR. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal KEY_ROW4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal UART5_CTS_B.- Configure register IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE: Select signal GPIO4_IO15. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad KEY_ROW4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION: Force input path of pad KEY_ROW4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW4_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio00
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio00_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO00 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_ADDR(x) ((uintptr_t)(x) + 0x220U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio00_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO00, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_0. NOTE: Pad GPIO_0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal CCM_CLKO1.
 * - 010 - Select signal KEY_COL5.- Configure register
 *     IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal ASRC_EXT_CLK.- Configure register
 *     IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal EPIT1_OUT.
 * - 101 - Select signal GPIO1_IO00.
 * - 110 - Select signal USB_H1_PWR.
 * - 111 - Select signal SNVS_VIO_5.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal CCM_CLKO1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal KEY_COL5.- Configure register IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal ASRC_EXT_CLK.- Configure register IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal EPIT1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal GPIO1_IO00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal USB_H1_PWR. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE: Select signal SNVS_VIO_5. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO00_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO00, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION: Force input path of pad GPIO_0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO00_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio01
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio01_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO01 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_ADDR(x) ((uintptr_t)(x) + 0x224U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio01_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO01, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_1. NOTE: Pad GPIO_1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_RX_CLK.- Configure register
 *     IOMUXC_ESAI_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal WDOG2_B.
 * - 010 - Select signal KEY_ROW5.- Configure register
 *     IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal USB_OTG_ID.
 * - 100 - Select signal PWM2_OUT.
 * - 101 - Select signal GPIO1_IO01.
 * - 110 - Select signal SD1_CD_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal ESAI_RX_CLK.- Configure register IOMUXC_ESAI_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal WDOG2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal KEY_ROW5.- Configure register IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal USB_OTG_ID. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal PWM2_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal GPIO1_IO01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE: Select signal SD1_CD_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO01_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO01, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION: Force input path of pad GPIO_1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO01_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio09
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio09_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO09 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_ADDR(x) ((uintptr_t)(x) + 0x228U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio09_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO09, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_9. NOTE: Pad GPIO_9 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_RX_FS.- Configure register
 *     IOMUXC_ESAI_RX_FS_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal WDOG1_B.
 * - 010 - Select signal KEY_COL6.- Configure register
 *     IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal CCM_REF_EN_B.
 * - 100 - Select signal PWM1_OUT.
 * - 101 - Select signal GPIO1_IO09.
 * - 110 - Select signal SD1_WP.- Configure register
 *     IOMUXC_USDHC1_WP_ON_SELECT_INPUTSelect Input Register for mode ALT6.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal ESAI_RX_FS.- Configure register IOMUXC_ESAI_RX_FS_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal WDOG1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal KEY_COL6.- Configure register IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal CCM_REF_EN_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal PWM1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal GPIO1_IO09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE: Select signal SD1_WP.- Configure register IOMUXC_USDHC1_WP_ON_SELECT_INPUTSelect Input Register for mode ALT6. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO09_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO09, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_9.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION: Force input path of pad GPIO_9. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO09_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio03
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio03_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO03 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_ADDR(x) ((uintptr_t)(x) + 0x22CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio03_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO03, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_3. NOTE: Pad GPIO_3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_RX_HF_CLK.- Configure register
 *     IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 010 - Select signal I2C3_SCL.- Configure register
 *     IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal XTALOSC_REF_CLK_24M.
 * - 100 - Select signal CCM_CLKO2.
 * - 101 - Select signal GPIO1_IO03.
 * - 110 - Select signal USB_H1_OC.- Configure register
 *     IOMUXC_USB_H1_OC_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal MLB_CLK.- Configure register
 *     IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT7.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal ESAI_RX_HF_CLK.- Configure register IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal I2C3_SCL.- Configure register IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal XTALOSC_REF_CLK_24M. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal CCM_CLKO2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal GPIO1_IO03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal USB_H1_OC.- Configure register IOMUXC_USB_H1_OC_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE: Select signal MLB_CLK.- Configure register IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT7. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO03_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO03, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION: Force input path of pad GPIO_3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO03_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio06
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio06_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO06 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_ADDR(x) ((uintptr_t)(x) + 0x230U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio06_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO06, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: GPIO_6. NOTE: Pad GPIO_6 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX_CLK.- Configure register
 *     IOMUXC_ESAI_TX_CLK_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 010 - Select signal I2C3_SDA.- Configure register
 *     IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO06.
 * - 110 - Select signal SD2_LCTL.
 * - 111 - Select signal MLB_SIG.- Configure register
 *     IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUTSelect Input Register for mode ALT7.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE: Select signal ESAI_TX_CLK.- Configure register IOMUXC_ESAI_TX_CLK_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE: Select signal I2C3_SDA.- Configure register IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE: Select signal GPIO1_IO06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE: Select signal SD2_LCTL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE: Select signal MLB_SIG.- Configure register IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUTSelect Input Register for mode ALT7. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO06_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO06, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION: Force input path of pad GPIO_6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO06_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio02
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio02_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO02 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_ADDR(x) ((uintptr_t)(x) + 0x234U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio02_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO02, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: GPIO_2. NOTE: Pad GPIO_2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX_FS.- Configure register
 *     IOMUXC_ESAI_TX_FS_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 010 - Select signal KEY_ROW6.- Configure register
 *     IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO02.
 * - 110 - Select signal SD2_WP.
 * - 111 - Select signal MLB_DATA.- Configure register
 *     IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUTSelect Input Register for mode ALT7.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE: Select signal ESAI_TX_FS.- Configure register IOMUXC_ESAI_TX_FS_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE: Select signal KEY_ROW6.- Configure register IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE: Select signal GPIO1_IO02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE: Select signal SD2_WP. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE: Select signal MLB_DATA.- Configure register IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUTSelect Input Register for mode ALT7. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO02_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO02, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION: Force input path of pad GPIO_2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO02_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_ADDR(x) ((uintptr_t)(x) + 0x238U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: GPIO_4. NOTE: Pad GPIO_4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX_HF_CLK.- Configure register
 *     IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 010 - Select signal KEY_COL7.- Configure register
 *     IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO1_IO04.
 * - 110 - Select signal SD2_CD_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE: Select signal ESAI_TX_HF_CLK.- Configure register IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE: Select signal KEY_COL7.- Configure register IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE: Select signal GPIO1_IO04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE: Select signal SD2_CD_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION: Force input path of pad GPIO_4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio05
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio05_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO05 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_ADDR(x) ((uintptr_t)(x) + 0x23CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio05_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO05, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: GPIO_5. NOTE: Pad GPIO_5 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX2_RX3.- Configure register
 *     IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 010 - Select signal KEY_ROW7.- Configure register
 *     IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal CCM_CLKO1.
 * - 101 - Select signal GPIO1_IO05.
 * - 110 - Select signal I2C3_SCL.- Configure register
 *     IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal ARM_EVENTI.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal ESAI_TX2_RX3.- Configure register IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal KEY_ROW7.- Configure register IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal CCM_CLKO1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal GPIO1_IO05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal I2C3_SCL.- Configure register IOMUXC_I2C3_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE: Select signal ARM_EVENTI. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO05_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO05, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION: Force input path of pad GPIO_5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO05_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio07
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio07_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO07 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_ADDR(x) ((uintptr_t)(x) + 0x240U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio07_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO07, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: GPIO_7. NOTE: Pad GPIO_7 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX4_RX1.- Configure register
 *     IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ECSPI5_RDY.
 * - 010 - Select signal EPIT1_OUT.
 * - 011 - Select signal FLEXCAN1_TX.
 * - 100 - Select signal UART2_TX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO1_IO07.
 * - 110 - Select signal SPDIF_LOCK.
 * - 111 - Select signal USB_OTG_HOST_MODE.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal ESAI_TX4_RX1.- Configure register IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal ECSPI5_RDY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal EPIT1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal FLEXCAN1_TX. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal UART2_TX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal GPIO1_IO07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal SPDIF_LOCK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE: Select signal USB_OTG_HOST_MODE. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO07_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO07, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION: Force input path of pad GPIO_7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO07_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio08
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio08_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO08 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_ADDR(x) ((uintptr_t)(x) + 0x244U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio08_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO08, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: GPIO_8. NOTE: Pad GPIO_8 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX5_RX0.- Configure register
 *     IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal XTALOSC_REF_CLK_32K.
 * - 010 - Select signal EPIT2_OUT.
 * - 011 - Select signal FLEXCAN1_RX.- Configure register
 *     IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal UART2_RX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO1_IO08.
 * - 110 - Select signal SPDIF_SR_CLK.
 * - 111 - Select signal USB_OTG_PWR_CTL_WAKE.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal ESAI_TX5_RX0.- Configure register IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal XTALOSC_REF_CLK_32K. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal EPIT2_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal FLEXCAN1_RX.- Configure register IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal UART2_RX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal GPIO1_IO08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal SPDIF_SR_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE: Select signal USB_OTG_PWR_CTL_WAKE. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO08_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO08, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_8.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION: Force input path of pad GPIO_8. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO08_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio16
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio16_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO16 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_ADDR(x) ((uintptr_t)(x) + 0x248U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio16_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO16, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 8 iomux modes to be used for pad: GPIO_16. NOTE: Pad GPIO_16 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX3_RX2.- Configure register
 *     IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_1588_EVENT2_IN.
 * - 010 - Select signal ENET_REF_CLK.- Configure register
 *     IOMUXC_ENET_REF_CLK_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal SD1_LCTL.
 * - 100 - Select signal SPDIF_IN.- Configure register
 *     IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO7_IO11.
 * - 110 - Select signal I2C3_SDA.- Configure register
 *     IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6.
 * - 111 - Select signal JTAG_DE_B.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal ESAI_TX3_RX2.- Configure register IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal ENET_1588_EVENT2_IN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal ENET_REF_CLK.- Configure register IOMUXC_ENET_REF_CLK_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal SD1_LCTL. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal SPDIF_IN.- Configure register IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal GPIO7_IO11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal I2C3_SDA.- Configure register IOMUXC_I2C3_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE: Select signal JTAG_DE_B. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO16_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO16, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_16.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION: Force input path of pad GPIO_16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO16_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio17
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio17_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO17 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_ADDR(x) ((uintptr_t)(x) + 0x24CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio17_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO17, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: GPIO_17. NOTE: Pad GPIO_17 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX0.- Configure register
 *     IOMUXC_ESAI_SDO0_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_1588_EVENT3_IN.
 * - 010 - Select signal CCM_PMIC_READY.- Configure register
 *     IOMUXC_CCM_PMIC_READY_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal SDMA_EXT_EVENT0.- Configure register
 *     IOMUXC_SDMA_EVENTS14_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal SPDIF_OUT.
 * - 101 - Select signal GPIO7_IO12.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal ESAI_TX0.- Configure register IOMUXC_ESAI_SDO0_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal ENET_1588_EVENT3_IN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal CCM_PMIC_READY.- Configure register IOMUXC_CCM_PMIC_READY_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal SDMA_EXT_EVENT0.- Configure register IOMUXC_SDMA_EVENTS14_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal SPDIF_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE: Select signal GPIO7_IO12. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO17_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO17, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_17.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION: Force input path of pad GPIO_17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO17_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio18
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio18_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO18 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_ADDR(x) ((uintptr_t)(x) + 0x250U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio18_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO18, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_18. NOTE: Pad GPIO_18 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal ESAI_TX1.- Configure register
 *     IOMUXC_ESAI_SDO1_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_RX_CLK.- Configure register
 *     IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal SD3_VSELECT.
 * - 011 - Select signal SDMA_EXT_EVENT1.- Configure register
 *     IOMUXC_SDMA_EVENTS47_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal ASRC_EXT_CLK.- Configure register
 *     IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO7_IO13.
 * - 110 - Select signal SNVS_VIO_5_CTL.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal ESAI_TX1.- Configure register IOMUXC_ESAI_SDO1_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal ENET_RX_CLK.- Configure register IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal SD3_VSELECT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal SDMA_EXT_EVENT1.- Configure register IOMUXC_SDMA_EVENTS47_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal ASRC_EXT_CLK.- Configure register IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal GPIO7_IO13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE: Select signal SNVS_VIO_5_CTL. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO18_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO18, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_18.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION: Force input path of pad GPIO_18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO18_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_gpio19
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_gpio19_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_gpio19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_GPIO19 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_ADDR(x) ((uintptr_t)(x) + 0x254U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_gpio19_t *) HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_GPIO19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO19, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: GPIO_19. NOTE: Pad GPIO_19 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal KEY_COL5.- Configure register
 *     IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT0.
 * - 001 - Select signal ENET_1588_EVENT0_OUT.
 * - 010 - Select signal SPDIF_OUT.
 * - 011 - Select signal CCM_CLKO1.
 * - 100 - Select signal ECSPI1_RDY.
 * - 101 - Select signal GPIO4_IO05.
 * - 110 - Select signal ENET_TX_ER.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal KEY_COL5.- Configure register IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal ENET_1588_EVENT0_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal SPDIF_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal CCM_CLKO1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal ECSPI1_RDY. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal GPIO4_IO05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE: Select signal ENET_TX_ER. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO19_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_GPIO19, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad GPIO_19.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION: Force input path of pad GPIO_19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_GPIO19_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_pixclk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_pixclk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_pixclk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_ADDR(x) ((uintptr_t)(x) + 0x258U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_pixclk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_PIXCLK.
 * - 101 - Select signal GPIO5_IO18.
 * - 111 - Select signal ARM_EVENTO.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE: Select signal IPU1_CSI0_PIXCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE: Select signal GPIO5_IO18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE: Select signal ARM_EVENTO. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_PIXCLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION: Force input path of pad CSI0_PIXCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_PIXCLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_hsync
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_hsync_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_hsync_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_ADDR(x) ((uintptr_t)(x) + 0x25CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_hsync_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: CSI0_MCLK.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_HSYNC.
 * - 011 - Select signal CCM_CLKO1.
 * - 101 - Select signal GPIO5_IO19.
 * - 111 - Select signal ARM_TRACE_CTL.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE: Select signal IPU1_CSI0_HSYNC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE: Select signal CCM_CLKO1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE: Select signal GPIO5_IO19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE: Select signal ARM_TRACE_CTL. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_MCLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION: Force input path of pad CSI0_MCLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_HSYNC_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data_en
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data_en_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data_en_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_ADDR(x) ((uintptr_t)(x) + 0x260U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data_en_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA_EN.
 * - 001 - Select signal EIM_DATA00.
 * - 101 - Select signal GPIO5_IO20.
 * - 111 - Select signal ARM_TRACE_CLK.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE: Select signal IPU1_CSI0_DATA_EN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE: Select signal EIM_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE: Select signal GPIO5_IO20. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE: Select signal ARM_TRACE_CLK. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DATA_EN.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION: Force input path of pad CSI0_DATA_EN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA_EN_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_vsync
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_vsync_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_vsync_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_ADDR(x) ((uintptr_t)(x) + 0x264U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_vsync_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: CSI0_VSYNC.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_VSYNC.
 * - 001 - Select signal EIM_DATA01.
 * - 101 - Select signal GPIO5_IO21.
 * - 111 - Select signal ARM_TRACE00.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE: Select signal IPU1_CSI0_VSYNC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE: Select signal EIM_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE: Select signal GPIO5_IO21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE: Select signal ARM_TRACE00. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_VSYNC.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION: Force input path of pad CSI0_VSYNC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_VSYNC_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_ADDR(x) ((uintptr_t)(x) + 0x268U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT4. NOTE: Pad CSI0_DAT4
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA04.
 * - 001 - Select signal EIM_DATA02.
 * - 010 - Select signal ECSPI1_SCLK.- Configure register
 *     IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL5.- Configure register
 *     IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD3_TXC.
 * - 101 - Select signal GPIO5_IO22.
 * - 111 - Select signal ARM_TRACE01.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal IPU1_CSI0_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal EIM_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal ECSPI1_SCLK.- Configure register IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal KEY_COL5.- Configure register IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal AUD3_TXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal GPIO5_IO22. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE: Select signal ARM_TRACE01. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION: Force input path of pad CSI0_DAT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data05_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_ADDR(x) ((uintptr_t)(x) + 0x26CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data05_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT5. NOTE: Pad CSI0_DAT5
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA05.
 * - 001 - Select signal EIM_DATA03.
 * - 010 - Select signal ECSPI1_MOSI.- Configure register
 *     IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW5.- Configure register
 *     IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD3_TXD.
 * - 101 - Select signal GPIO5_IO23.
 * - 111 - Select signal ARM_TRACE02.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal IPU1_CSI0_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal EIM_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal ECSPI1_MOSI.- Configure register IOMUXC_ECSPI1_MOSI_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal KEY_ROW5.- Configure register IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal AUD3_TXD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal GPIO5_IO23. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE: Select signal ARM_TRACE02. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION: Force input path of pad CSI0_DAT5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA05_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data06_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_ADDR(x) ((uintptr_t)(x) + 0x270U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data06_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT6. NOTE: Pad CSI0_DAT6
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA06.
 * - 001 - Select signal EIM_DATA04.
 * - 010 - Select signal ECSPI1_MISO.- Configure register
 *     IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL6.- Configure register
 *     IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD3_TXFS.
 * - 101 - Select signal GPIO5_IO24.
 * - 111 - Select signal ARM_TRACE03.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal IPU1_CSI0_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal EIM_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal ECSPI1_MISO.- Configure register IOMUXC_ECSPI1_MISO_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal KEY_COL6.- Configure register IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal AUD3_TXFS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal GPIO5_IO24. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE: Select signal ARM_TRACE03. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION: Force input path of pad CSI0_DAT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA06_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data07_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_ADDR(x) ((uintptr_t)(x) + 0x274U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data07_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT7. NOTE: Pad CSI0_DAT7
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA07.
 * - 001 - Select signal EIM_DATA05.
 * - 010 - Select signal ECSPI1_SS0.- Configure register
 *     IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW6.- Configure register
 *     IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal AUD3_RXD.
 * - 101 - Select signal GPIO5_IO25.
 * - 111 - Select signal ARM_TRACE04.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal IPU1_CSI0_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal EIM_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal ECSPI1_SS0.- Configure register IOMUXC_ECSPI1_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal KEY_ROW6.- Configure register IOMUXC_KEY_ROW6_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal AUD3_RXD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal GPIO5_IO25. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE: Select signal ARM_TRACE04. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION: Force input path of pad CSI0_DAT7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA07_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data08
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data08_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_ADDR(x) ((uintptr_t)(x) + 0x278U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data08_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT8. NOTE: Pad CSI0_DAT8
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA08.
 * - 001 - Select signal EIM_DATA06.
 * - 010 - Select signal ECSPI2_SCLK.- Configure register
 *     IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_COL7.- Configure register
 *     IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal I2C1_SDA.- Configure register
 *     IOMUXC_I2C1_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO26.
 * - 111 - Select signal ARM_TRACE05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal IPU1_CSI0_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal EIM_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal ECSPI2_SCLK.- Configure register IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal KEY_COL7.- Configure register IOMUXC_KEY_COL7_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal I2C1_SDA.- Configure register IOMUXC_I2C1_SDA_IN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal GPIO5_IO26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE: Select signal ARM_TRACE05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT8.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION: Force input path of pad CSI0_DAT8. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA08_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data09
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data09_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_ADDR(x) ((uintptr_t)(x) + 0x27CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data09_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: CSI0_DAT9. NOTE: Pad CSI0_DAT9
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA09.
 * - 001 - Select signal EIM_DATA07.
 * - 010 - Select signal ECSPI2_MOSI.- Configure register
 *     IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal KEY_ROW7.- Configure register
 *     IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 100 - Select signal I2C1_SCL.- Configure register
 *     IOMUXC_I2C1_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT4.
 * - 101 - Select signal GPIO5_IO27.
 * - 111 - Select signal ARM_TRACE06.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal IPU1_CSI0_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal EIM_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal ECSPI2_MOSI.- Configure register IOMUXC_ECSPI2_MOSI_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal KEY_ROW7.- Configure register IOMUXC_KEY_ROW7_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal I2C1_SCL.- Configure register IOMUXC_I2C1_SCL_IN_SELECT_INPUTSelect Input Register for mode ALT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal GPIO5_IO27. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE: Select signal ARM_TRACE06. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT9.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION: Force input path of pad CSI0_DAT9. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA09_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data10
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data10_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_ADDR(x) ((uintptr_t)(x) + 0x280U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data10_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: CSI0_DAT10. NOTE: Pad
 * CSI0_DAT10 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA10.
 * - 001 - Select signal AUD3_RXC.
 * - 010 - Select signal ECSPI2_MISO.- Configure register
 *     IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal UART1_TX_DATA.- Configure register
 *     IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO28.
 * - 111 - Select signal ARM_TRACE07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal IPU1_CSI0_DATA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal AUD3_RXC. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal ECSPI2_MISO.- Configure register IOMUXC_ECSPI2_MISO_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal UART1_TX_DATA.- Configure register IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal GPIO5_IO28. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE: Select signal ARM_TRACE07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT10.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION: Force input path of pad CSI0_DAT10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data11
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data11_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_ADDR(x) ((uintptr_t)(x) + 0x284U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data11_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: CSI0_DAT11. NOTE: Pad
 * CSI0_DAT11 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA11.
 * - 001 - Select signal AUD3_RXFS.
 * - 010 - Select signal ECSPI2_SS0.- Configure register
 *     IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal UART1_RX_DATA.- Configure register
 *     IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO29.
 * - 111 - Select signal ARM_TRACE08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal IPU1_CSI0_DATA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal AUD3_RXFS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal ECSPI2_SS0.- Configure register IOMUXC_ECSPI2_SS0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal UART1_RX_DATA.- Configure register IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal GPIO5_IO29. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE: Select signal ARM_TRACE08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT11.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION: Force input path of pad CSI0_DAT11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data12
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data12_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_ADDR(x) ((uintptr_t)(x) + 0x288U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data12_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT12. NOTE: Pad
 * CSI0_DAT12 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA12.
 * - 001 - Select signal EIM_DATA08.
 * - 011 - Select signal UART4_TX_DATA.- Configure register
 *     IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO30.
 * - 111 - Select signal ARM_TRACE09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE: Select signal IPU1_CSI0_DATA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE: Select signal EIM_DATA08. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE: Select signal UART4_TX_DATA.- Configure register IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE: Select signal GPIO5_IO30. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE: Select signal ARM_TRACE09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT12.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION: Force input path of pad CSI0_DAT12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data13
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data13_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_ADDR(x) ((uintptr_t)(x) + 0x28CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data13_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT13. NOTE: Pad
 * CSI0_DAT13 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA13.
 * - 001 - Select signal EIM_DATA09.
 * - 011 - Select signal UART4_RX_DATA.- Configure register
 *     IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO5_IO31.
 * - 111 - Select signal ARM_TRACE10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE: Select signal IPU1_CSI0_DATA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE: Select signal EIM_DATA09. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE: Select signal UART4_RX_DATA.- Configure register IOMUXC_UART4_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE: Select signal GPIO5_IO31. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE: Select signal ARM_TRACE10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT13.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION: Force input path of pad CSI0_DAT13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data14
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data14_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_ADDR(x) ((uintptr_t)(x) + 0x290U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data14_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT14. NOTE: Pad
 * CSI0_DAT14 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA14.
 * - 001 - Select signal EIM_DATA10.
 * - 011 - Select signal UART5_TX_DATA.- Configure register
 *     IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO00.
 * - 111 - Select signal ARM_TRACE11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE: Select signal IPU1_CSI0_DATA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE: Select signal EIM_DATA10. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE: Select signal UART5_TX_DATA.- Configure register IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE: Select signal GPIO6_IO00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE: Select signal ARM_TRACE11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT14.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION: Force input path of pad CSI0_DAT14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data15
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data15_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_ADDR(x) ((uintptr_t)(x) + 0x294U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data15_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT15. NOTE: Pad
 * CSI0_DAT15 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA15.
 * - 001 - Select signal EIM_DATA11.
 * - 011 - Select signal UART5_RX_DATA.- Configure register
 *     IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO01.
 * - 111 - Select signal ARM_TRACE12.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE: Select signal IPU1_CSI0_DATA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE: Select signal EIM_DATA11. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE: Select signal UART5_RX_DATA.- Configure register IOMUXC_UART5_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE: Select signal GPIO6_IO01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE: Select signal ARM_TRACE12. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT15.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION: Force input path of pad CSI0_DAT15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data16_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_ADDR(x) ((uintptr_t)(x) + 0x298U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data16_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT16. NOTE: Pad
 * CSI0_DAT16 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA16.
 * - 001 - Select signal EIM_DATA12.
 * - 011 - Select signal UART4_RTS_B.- Configure register
 *     IOMUXC_UART4_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO02.
 * - 111 - Select signal ARM_TRACE13.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE: Select signal IPU1_CSI0_DATA16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE: Select signal EIM_DATA12. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE: Select signal UART4_RTS_B.- Configure register IOMUXC_UART4_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE: Select signal GPIO6_IO02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE: Select signal ARM_TRACE13. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT16.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION: Force input path of pad CSI0_DAT16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA16_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data17_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_ADDR(x) ((uintptr_t)(x) + 0x29CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data17_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT17. NOTE: Pad
 * CSI0_DAT17 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA17.
 * - 001 - Select signal EIM_DATA13.
 * - 011 - Select signal UART4_CTS_B.- Configure register
 *     IOMUXC_UART4_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO03.
 * - 111 - Select signal ARM_TRACE14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE: Select signal IPU1_CSI0_DATA17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE: Select signal EIM_DATA13. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE: Select signal UART4_CTS_B.- Configure register IOMUXC_UART4_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE: Select signal GPIO6_IO03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE: Select signal ARM_TRACE14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT17.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION: Force input path of pad CSI0_DAT17. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA17_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data18_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_ADDR(x) ((uintptr_t)(x) + 0x2A0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data18_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: CSI0_DAT18. NOTE: Pad
 * CSI0_DAT18 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA18.
 * - 001 - Select signal EIM_DATA14.
 * - 011 - Select signal UART5_RTS_B.- Configure register
 *     IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO04.
 * - 111 - Select signal ARM_TRACE15.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE: Select signal IPU1_CSI0_DATA18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE: Select signal EIM_DATA14. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE: Select signal UART5_RTS_B.- Configure register IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE: Select signal GPIO6_IO04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE_ALT7 (0x7U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE: Select signal ARM_TRACE15. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT18.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION: Force input path of pad CSI0_DAT18. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA18_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_csi0_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_csi0_data19_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_csi0_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_ADDR(x) ((uintptr_t)(x) + 0x2A4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_csi0_data19_t *) HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: CSI0_DAT19. NOTE: Pad
 * CSI0_DAT19 is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal IPU1_CSI0_DATA19.
 * - 001 - Select signal EIM_DATA15.
 * - 011 - Select signal UART5_CTS_B.- Configure register
 *     IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO6_IO05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE: Select signal IPU1_CSI0_DATA19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE: Select signal EIM_DATA15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE: Select signal UART5_CTS_B.- Configure register IOMUXC_UART5_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE: Select signal GPIO6_IO05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad CSI0_DAT19.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION: Force input path of pad CSI0_DAT19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA19_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data7
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data7_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_ADDR(x) ((uintptr_t)(x) + 0x2A8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data7_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_DAT7. NOTE: Pad SD3_DAT7 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA7.
 * - 001 - Select signal UART1_TX_DATA.- Configure register
 *     IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO17.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE: Select signal SD3_DATA7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE: Select signal UART1_TX_DATA.- Configure register IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE: Select signal GPIO6_IO17. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION: Force input path of pad SD3_DAT7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA7_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data6
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data6_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_ADDR(x) ((uintptr_t)(x) + 0x2ACU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data6_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_DAT6. NOTE: Pad SD3_DAT6 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA6.
 * - 001 - Select signal UART1_RX_DATA.- Configure register
 *     IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO6_IO18.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE: Select signal SD3_DATA6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE: Select signal UART1_RX_DATA.- Configure register IOMUXC_UART1_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE: Select signal GPIO6_IO18. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION: Force input path of pad SD3_DAT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA6_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data5
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data5_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_ADDR(x) ((uintptr_t)(x) + 0x2B0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data5_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_DAT5. NOTE: Pad SD3_DAT5 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA5.
 * - 001 - Select signal UART2_TX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO7_IO00.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE: Select signal SD3_DATA5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE: Select signal UART2_TX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE: Select signal GPIO7_IO00. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION: Force input path of pad SD3_DAT5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA5_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data4
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data4_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_ADDR(x) ((uintptr_t)(x) + 0x2B4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data4_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_DAT4. NOTE: Pad SD3_DAT4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA4.
 * - 001 - Select signal UART2_RX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO7_IO01.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE: Select signal SD3_DATA4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE: Select signal UART2_RX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE: Select signal GPIO7_IO01. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION: Force input path of pad SD3_DAT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA4_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_cmd_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_ADDR(x) ((uintptr_t)(x) + 0x2B8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_cmd_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_CMD, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD3_CMD. NOTE: Pad SD3_CMD is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_CMD.
 * - 001 - Select signal UART2_CTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal FLEXCAN1_TX.
 * - 101 - Select signal GPIO7_IO02.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE: Select signal SD3_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE: Select signal UART2_CTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE: Select signal FLEXCAN1_TX. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE: Select signal GPIO7_IO02. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_CMD, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_CMD.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION: Force input path of pad SD3_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_ADDR(x) ((uintptr_t)(x) + 0x2BCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD3_CLK. NOTE: Pad SD3_CLK is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_CLK.
 * - 001 - Select signal UART2_RTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal FLEXCAN1_RX.- Configure register
 *     IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO7_IO03.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE: Select signal SD3_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE: Select signal UART2_RTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE: Select signal FLEXCAN1_RX.- Configure register IOMUXC_FLEXCAN1_RX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE: Select signal GPIO7_IO03. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION: Force input path of pad SD3_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_ADDR(x) ((uintptr_t)(x) + 0x2C0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD3_DAT0. NOTE: Pad SD3_DAT0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA0.
 * - 001 - Select signal UART1_CTS_B.- Configure register
 *     IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal FLEXCAN2_TX.
 * - 101 - Select signal GPIO7_IO04.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE: Select signal SD3_DATA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE: Select signal UART1_CTS_B.- Configure register IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE: Select signal FLEXCAN2_TX. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE: Select signal GPIO7_IO04. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION: Force input path of pad SD3_DAT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_ADDR(x) ((uintptr_t)(x) + 0x2C4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD3_DAT1. NOTE: Pad SD3_DAT1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA1.
 * - 001 - Select signal UART1_RTS_B.- Configure register
 *     IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal FLEXCAN2_RX.- Configure register
 *     IOMUXC_FLEXCAN2_RX_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO7_IO05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE: Select signal SD3_DATA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE: Select signal UART1_RTS_B.- Configure register IOMUXC_UART1_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE: Select signal FLEXCAN2_RX.- Configure register IOMUXC_FLEXCAN2_RX_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE: Select signal GPIO7_IO05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION: Force input path of pad SD3_DAT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_ADDR(x) ((uintptr_t)(x) + 0x2C8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 2 iomux modes to be used for pad: SD3_DAT2.
 *
 * Values:
 * - 000 - Select signal SD3_DATA2.
 * - 101 - Select signal GPIO7_IO06.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE: Select signal SD3_DATA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE: Select signal GPIO7_IO06. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION: Force input path of pad SD3_DAT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_data3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_ADDR(x) ((uintptr_t)(x) + 0x2CCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_data3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_DAT3. NOTE: Pad SD3_DAT3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_DATA3.
 * - 001 - Select signal UART3_CTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO7_IO07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE: Select signal SD3_DATA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE: Select signal UART3_CTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE: Select signal GPIO7_IO07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_DAT3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION: Force input path of pad SD3_DAT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd3_reset
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd3_reset_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd3_reset_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD3_RESET register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_ADDR(x) ((uintptr_t)(x) + 0x2D0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd3_reset_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD3_RESET bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_RESET, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD3_RST. NOTE: Pad SD3_RST is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD3_RESET.
 * - 001 - Select signal UART3_RTS_B.- Configure register
 *     IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 101 - Select signal GPIO7_IO08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE: Select signal SD3_RESET. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE: Select signal UART3_RTS_B.- Configure register IOMUXC_UART3_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE: Select signal GPIO7_IO08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD3_RESET, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD3_RST.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION: Force input path of pad SD3_RST. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD3_RESET_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_cle
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_cle_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_cle_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_CLE register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_ADDR(x) ((uintptr_t)(x) + 0x2D4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_cle_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_CLE bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CLE, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_CLE.
 *
 * Values:
 * - 000 - Select signal NAND_CLE.
 * - 001 - Select signal IPU2_SISG4.
 * - 101 - Select signal GPIO6_IO07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE: Select signal NAND_CLE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE: Select signal IPU2_SISG4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE: Select signal GPIO6_IO07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CLE, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_CLE.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION: Force input path of pad NANDF_CLE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CLE_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_ale
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_ale_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_ale_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_ALE register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_ADDR(x) ((uintptr_t)(x) + 0x2D8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_ale_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_ALE bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_ALE, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_ALE.
 *
 * Values:
 * - 000 - Select signal NAND_ALE.
 * - 001 - Select signal SD4_RESET.
 * - 101 - Select signal GPIO6_IO08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE: Select signal NAND_ALE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE: Select signal SD4_RESET. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE: Select signal GPIO6_IO08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_ALE, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_ALE.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION: Force input path of pad NANDF_ALE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_wp_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_wp_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_wp_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_ADDR(x) ((uintptr_t)(x) + 0x2DCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_wp_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_WP_B.
 *
 * Values:
 * - 000 - Select signal NAND_WP_B.
 * - 001 - Select signal IPU2_SISG5.
 * - 101 - Select signal GPIO6_IO09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE: Select signal NAND_WP_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE: Select signal IPU2_SISG5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE: Select signal GPIO6_IO09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_WP_B.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION: Force input path of pad NANDF_WP_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_WP_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_ready_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_ready_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_ready_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_ADDR(x) ((uintptr_t)(x) + 0x2E0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_ready_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_RB0.
 *
 * Values:
 * - 000 - Select signal NAND_READY_B.
 * - 001 - Select signal IPU2_DI0_PIN01.
 * - 101 - Select signal GPIO6_IO10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE: Select signal NAND_READY_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE: Select signal IPU2_DI0_PIN01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE: Select signal GPIO6_IO10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_RB0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION: Force input path of pad NANDF_RB0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_READY_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_cs0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_cs0_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_cs0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_ADDR(x) ((uintptr_t)(x) + 0x2E4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_cs0_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 2 iomux modes to be used for pad: NANDF_CS0.
 *
 * Values:
 * - 000 - Select signal NAND_CE0_B.
 * - 101 - Select signal GPIO6_IO11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE: Select signal NAND_CE0_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE: Select signal GPIO6_IO11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_CS0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION: Force input path of pad NANDF_CS0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS0_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_cs1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_cs1_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_cs1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_ADDR(x) ((uintptr_t)(x) + 0x2E8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_cs1_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: NANDF_CS1.
 *
 * Values:
 * - 000 - Select signal NAND_CE1_B.
 * - 001 - Select signal SD4_VSELECT.
 * - 010 - Select signal SD3_VSELECT.
 * - 101 - Select signal GPIO6_IO14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE: Select signal NAND_CE1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE: Select signal SD4_VSELECT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE: Select signal SD3_VSELECT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE: Select signal GPIO6_IO14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_CS1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION: Force input path of pad NANDF_CS1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS1_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_cs2_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_cs2_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_cs2_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_ADDR(x) ((uintptr_t)(x) + 0x2ECU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_cs2_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: NANDF_CS2. NOTE: Pad NANDF_CS2
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal NAND_CE2_B.
 * - 001 - Select signal IPU1_SISG0.
 * - 010 - Select signal ESAI_TX0.- Configure register
 *     IOMUXC_ESAI_SDO0_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal EIM_CRE.
 * - 100 - Select signal CCM_CLKO2.
 * - 101 - Select signal GPIO6_IO15.
 * - 110 - Select signal IPU2_SISG0.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal NAND_CE2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal IPU1_SISG0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal ESAI_TX0.- Configure register IOMUXC_ESAI_SDO0_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal EIM_CRE. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal CCM_CLKO2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal GPIO6_IO15. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE: Select signal IPU2_SISG0. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_CS2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION: Force input path of pad NANDF_CS2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS2_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_cs3_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_cs3_b_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_cs3_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_ADDR(x) ((uintptr_t)(x) + 0x2F0U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_cs3_b_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 6 iomux modes to be used for pad: NANDF_CS3. NOTE: Pad NANDF_CS3
 * is involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal NAND_CE3_B.
 * - 001 - Select signal IPU1_SISG1.
 * - 010 - Select signal ESAI_TX1.- Configure register
 *     IOMUXC_ESAI_SDO1_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal EIM_ADDR26.
 * - 101 - Select signal GPIO6_IO16.
 * - 110 - Select signal IPU2_SISG1.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal NAND_CE3_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal IPU1_SISG1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal ESAI_TX1.- Configure register IOMUXC_ESAI_SDO1_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal EIM_ADDR26. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal GPIO6_IO16. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE: Select signal IPU2_SISG1. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_CS3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION: Force input path of pad NANDF_CS3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_CS3_B_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_cmd_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_ADDR(x) ((uintptr_t)(x) + 0x2F4U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_cmd_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_CMD, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD4_CMD. NOTE: Pad SD4_CMD is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD4_CMD.
 * - 001 - Select signal NAND_RE_B.
 * - 010 - Select signal UART3_TX_DATA.- Configure register
 *     IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO7_IO09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE: Select signal SD4_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE: Select signal NAND_RE_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE: Select signal UART3_TX_DATA.- Configure register IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE: Select signal GPIO7_IO09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_CMD, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_CMD.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION: Force input path of pad SD4_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_ADDR(x) ((uintptr_t)(x) + 0x2F8U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD4_CLK. NOTE: Pad SD4_CLK is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD4_CLK.
 * - 001 - Select signal NAND_WE_B.
 * - 010 - Select signal UART3_RX_DATA.- Configure register
 *     IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO7_IO10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE: Select signal SD4_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE: Select signal NAND_WE_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE: Select signal UART3_RX_DATA.- Configure register IOMUXC_UART3_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE: Select signal GPIO7_IO10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION: Force input path of pad SD4_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data00
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data00_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_ADDR(x) ((uintptr_t)(x) + 0x2FCU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data00_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D0.
 *
 * Values:
 * - 000 - Select signal NAND_DATA00.
 * - 001 - Select signal SD1_DATA4.
 * - 101 - Select signal GPIO2_IO00.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE: Select signal NAND_DATA00. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE: Select signal SD1_DATA4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE: Select signal GPIO2_IO00. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION: Force input path of pad NANDF_D0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA00_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data01
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data01_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_ADDR(x) ((uintptr_t)(x) + 0x300U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data01_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D1.
 *
 * Values:
 * - 000 - Select signal NAND_DATA01.
 * - 001 - Select signal SD1_DATA5.
 * - 101 - Select signal GPIO2_IO01.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE: Select signal NAND_DATA01. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE: Select signal SD1_DATA5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE: Select signal GPIO2_IO01. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION: Force input path of pad NANDF_D1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA01_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data02
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data02_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_ADDR(x) ((uintptr_t)(x) + 0x304U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data02_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D2.
 *
 * Values:
 * - 000 - Select signal NAND_DATA02.
 * - 001 - Select signal SD1_DATA6.
 * - 101 - Select signal GPIO2_IO02.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE: Select signal NAND_DATA02. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE: Select signal SD1_DATA6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE: Select signal GPIO2_IO02. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION: Force input path of pad NANDF_D2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA02_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data03
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data03_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_ADDR(x) ((uintptr_t)(x) + 0x308U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data03_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D3.
 *
 * Values:
 * - 000 - Select signal NAND_DATA03.
 * - 001 - Select signal SD1_DATA7.
 * - 101 - Select signal GPIO2_IO03.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE: Select signal NAND_DATA03. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE: Select signal SD1_DATA7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE: Select signal GPIO2_IO03. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION: Force input path of pad NANDF_D3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA03_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data04_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_ADDR(x) ((uintptr_t)(x) + 0x30CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data04_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D4.
 *
 * Values:
 * - 000 - Select signal NAND_DATA04.
 * - 001 - Select signal SD2_DATA4.
 * - 101 - Select signal GPIO2_IO04.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE: Select signal NAND_DATA04. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE: Select signal SD2_DATA4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE: Select signal GPIO2_IO04. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION: Force input path of pad NANDF_D4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data05_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_ADDR(x) ((uintptr_t)(x) + 0x310U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data05_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D5.
 *
 * Values:
 * - 000 - Select signal NAND_DATA05.
 * - 001 - Select signal SD2_DATA5.
 * - 101 - Select signal GPIO2_IO05.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE: Select signal NAND_DATA05. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE: Select signal SD2_DATA5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE: Select signal GPIO2_IO05. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION: Force input path of pad NANDF_D5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data06_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_ADDR(x) ((uintptr_t)(x) + 0x314U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data06_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D6.
 *
 * Values:
 * - 000 - Select signal NAND_DATA06.
 * - 001 - Select signal SD2_DATA6.
 * - 101 - Select signal GPIO2_IO06.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE: Select signal NAND_DATA06. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE: Select signal SD2_DATA6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE: Select signal GPIO2_IO06. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION: Force input path of pad NANDF_D6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_nand_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_nand_data07_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_nand_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_ADDR(x) ((uintptr_t)(x) + 0x318U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_nand_data07_t *) HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: NANDF_D7.
 *
 * Values:
 * - 000 - Select signal NAND_DATA07.
 * - 001 - Select signal SD2_DATA7.
 * - 101 - Select signal GPIO2_IO07.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE: Select signal NAND_DATA07. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE: Select signal SD2_DATA7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE: Select signal GPIO2_IO07. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad NANDF_D7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION: Force input path of pad NANDF_D7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_ADDR(x) ((uintptr_t)(x) + 0x31CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT0.
 *
 * Values:
 * - 001 - Select signal SD4_DATA0.
 * - 010 - Select signal NAND_DQS.
 * - 101 - Select signal GPIO2_IO08.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE: Select signal SD4_DATA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE: Select signal NAND_DQS. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE: Select signal GPIO2_IO08. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION: Force input path of pad SD4_DAT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_ADDR(x) ((uintptr_t)(x) + 0x320U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT1.
 *
 * Values:
 * - 001 - Select signal SD4_DATA1.
 * - 010 - Select signal PWM3_OUT.
 * - 101 - Select signal GPIO2_IO09.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE: Select signal SD4_DATA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE: Select signal PWM3_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE: Select signal GPIO2_IO09. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION: Force input path of pad SD4_DAT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_ADDR(x) ((uintptr_t)(x) + 0x324U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT2.
 *
 * Values:
 * - 001 - Select signal SD4_DATA2.
 * - 010 - Select signal PWM4_OUT.
 * - 101 - Select signal GPIO2_IO10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE: Select signal SD4_DATA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE: Select signal PWM4_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE: Select signal GPIO2_IO10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION: Force input path of pad SD4_DAT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_ADDR(x) ((uintptr_t)(x) + 0x328U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 2 iomux modes to be used for pad: SD4_DAT3.
 *
 * Values:
 * - 001 - Select signal SD4_DATA3.
 * - 101 - Select signal GPIO2_IO11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE: Select signal SD4_DATA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE: Select signal GPIO2_IO11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION: Force input path of pad SD4_DAT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data4
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data4_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_ADDR(x) ((uintptr_t)(x) + 0x32CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data4_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT4. NOTE: Pad SD4_DAT4 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal SD4_DATA4.
 * - 010 - Select signal UART2_RX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO12.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE: Select signal SD4_DATA4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE: Select signal UART2_RX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE: Select signal GPIO2_IO12. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT4.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION: Force input path of pad SD4_DAT4. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data5
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data5_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_ADDR(x) ((uintptr_t)(x) + 0x330U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data5_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT5. NOTE: Pad SD4_DAT5 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal SD4_DATA5.
 * - 010 - Select signal UART2_RTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO13.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE: Select signal SD4_DATA5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE: Select signal UART2_RTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE: Select signal GPIO2_IO13. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT5.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION: Force input path of pad SD4_DAT5. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data6
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data6_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_ADDR(x) ((uintptr_t)(x) + 0x334U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data6_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT6. NOTE: Pad SD4_DAT6 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal SD4_DATA6.
 * - 010 - Select signal UART2_CTS_B.- Configure register
 *     IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO14.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE: Select signal SD4_DATA6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE: Select signal UART2_CTS_B.- Configure register IOMUXC_UART2_UART_RTS_B_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE: Select signal GPIO2_IO14. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT6.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION: Force input path of pad SD4_DAT6. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd4_data7
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd4_data7_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd4_data7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_ADDR(x) ((uintptr_t)(x) + 0x338U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd4_data7_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 3 iomux modes to be used for pad: SD4_DAT7. NOTE: Pad SD4_DAT7 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 001 - Select signal SD4_DATA7.
 * - 010 - Select signal UART2_TX_DATA.- Configure register
 *     IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 101 - Select signal GPIO2_IO15.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE: Select signal SD4_DATA7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE: Select signal UART2_TX_DATA.- Configure register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE: Select signal GPIO2_IO15. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD4_DAT7.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION: Force input path of pad SD4_DAT7. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_data1_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_ADDR(x) ((uintptr_t)(x) + 0x33CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_data1_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD1_DAT1. NOTE: Pad SD1_DAT1 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD1_DATA1.
 * - 001 - Select signal ECSPI5_SS0.- Configure register
 *     IOMUXC_ECSPI5_SS0_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal PWM3_OUT.
 * - 011 - Select signal GPT_CAPTURE2.
 * - 101 - Select signal GPIO1_IO17.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE: Select signal SD1_DATA1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE: Select signal ECSPI5_SS0.- Configure register IOMUXC_ECSPI5_SS0_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE: Select signal PWM3_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE: Select signal GPT_CAPTURE2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE: Select signal GPIO1_IO17. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_DAT1.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION: Force input path of pad SD1_DAT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_data0_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_ADDR(x) ((uintptr_t)(x) + 0x340U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_data0_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 4 iomux modes to be used for pad: SD1_DAT0. NOTE: Pad SD1_DAT0 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD1_DATA0.
 * - 001 - Select signal ECSPI5_MISO.- Configure register
 *     IOMUXC_ECSPI5_MISO_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 011 - Select signal GPT_CAPTURE1.
 * - 101 - Select signal GPIO1_IO16.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE: Select signal SD1_DATA0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE: Select signal ECSPI5_MISO.- Configure register IOMUXC_ECSPI5_MISO_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE: Select signal GPT_CAPTURE1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE: Select signal GPIO1_IO16. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_DAT0.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION: Force input path of pad SD1_DAT0. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_data3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_ADDR(x) ((uintptr_t)(x) + 0x344U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_data3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: SD1_DAT3.
 *
 * Values:
 * - 000 - Select signal SD1_DATA3.
 * - 001 - Select signal ECSPI5_SS2.
 * - 010 - Select signal GPT_COMPARE3.
 * - 011 - Select signal PWM1_OUT.
 * - 100 - Select signal WDOG2_B.
 * - 101 - Select signal GPIO1_IO21.
 * - 110 - Select signal WDOG2_RESET_B_DEB.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal SD1_DATA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal ECSPI5_SS2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal GPT_COMPARE3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal PWM1_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal WDOG2_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal GPIO1_IO21. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE: Select signal WDOG2_RESET_B_DEB. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_DAT3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION: Force input path of pad SD1_DAT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_cmd_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_ADDR(x) ((uintptr_t)(x) + 0x348U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_cmd_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_CMD, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD1_CMD. NOTE: Pad SD1_CMD is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD1_CMD.
 * - 001 - Select signal ECSPI5_MOSI.- Configure register
 *     IOMUXC_ECSPI5_MOSI_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal PWM4_OUT.
 * - 011 - Select signal GPT_COMPARE1.
 * - 101 - Select signal GPIO1_IO18.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE: Select signal SD1_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE: Select signal ECSPI5_MOSI.- Configure register IOMUXC_ECSPI5_MOSI_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE: Select signal PWM4_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE: Select signal GPT_COMPARE1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE: Select signal GPIO1_IO18. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_CMD, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_CMD.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION: Force input path of pad SD1_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_data2_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_ADDR(x) ((uintptr_t)(x) + 0x34CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_data2_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 7 iomux modes to be used for pad: SD1_DAT2. NOTE: Pad SD1_DAT2 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD1_DATA2.
 * - 001 - Select signal ECSPI5_SS1.- Configure register
 *     IOMUXC_ECSPI5_SS1_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal GPT_COMPARE2.
 * - 011 - Select signal PWM2_OUT.
 * - 100 - Select signal WDOG1_B.
 * - 101 - Select signal GPIO1_IO19.
 * - 110 - Select signal WDOG1_RESET_B_DEB.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal SD1_DATA2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal ECSPI5_SS1.- Configure register IOMUXC_ECSPI5_SS1_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal GPT_COMPARE2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal PWM2_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT4 (0x4U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal WDOG1_B. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal GPIO1_IO19. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE_ALT6 (0x6U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE: Select signal WDOG1_RESET_B_DEB. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_DAT2.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION: Force input path of pad SD1_DAT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd1_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd1_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd1_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD1_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_ADDR(x) ((uintptr_t)(x) + 0x350U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd1_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD1_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD1_CLK. NOTE: Pad SD1_CLK is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD1_CLK.
 * - 001 - Select signal ECSPI5_SCLK.- Configure register
 *     IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal XTALOSC_OSC32K_32K_OUT.
 * - 011 - Select signal GPT_CLKIN.
 * - 101 - Select signal GPIO1_IO20.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE: Select signal SD1_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE: Select signal ECSPI5_SCLK.- Configure register IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE: Select signal XTALOSC_OSC32K_32K_OUT. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE: Select signal GPT_CLKIN. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE: Select signal GPIO1_IO20. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD1_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD1_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION: Force input path of pad SD1_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_clk_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_ADDR(x) ((uintptr_t)(x) + 0x354U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_clk_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_CLK, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD2_CLK. NOTE: Pad SD2_CLK is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_CLK.
 * - 001 - Select signal ECSPI5_SCLK.- Configure register
 *     IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal KEY_COL5.- Configure register
 *     IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_RXFS.- Configure register
 *     IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO1_IO10.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE: Select signal SD2_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE: Select signal ECSPI5_SCLK.- Configure register IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE: Select signal KEY_COL5.- Configure register IOMUXC_KEY_COL5_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE: Select signal AUD4_RXFS.- Configure register IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE: Select signal GPIO1_IO10. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_CLK, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_CLK.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION: Force input path of pad SD2_CLK. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_cmd_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_ADDR(x) ((uintptr_t)(x) + 0x358U)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_cmd_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_CMD, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD2_CMD. NOTE: Pad SD2_CMD is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_CMD.
 * - 001 - Select signal ECSPI5_MOSI.- Configure register
 *     IOMUXC_ECSPI5_MOSI_SELECT_INPUTSelect Input Register for mode ALT1.
 * - 010 - Select signal KEY_ROW5.- Configure register
 *     IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_RXC.- Configure register
 *     IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO1_IO11.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE: Select signal SD2_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE: Select signal ECSPI5_MOSI.- Configure register IOMUXC_ECSPI5_MOSI_SELECT_INPUTSelect Input Register for mode ALT1. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE: Select signal KEY_ROW5.- Configure register IOMUXC_KEY_ROW5_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE: Select signal AUD4_RXC.- Configure register IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE: Select signal GPIO1_IO11. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_CMD, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_CMD.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION: Force input path of pad SD2_CMD. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3 - Pad Mux Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3 - Pad Mux Register (RW)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_iomuxc_sw_mux_ctl_pad_sd2_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_mux_ctl_pad_sd2_data3_bitfields
    {
        uint32_t MUX_MODE : 3;         /*!< [2:0] MUX Mode Select Field. */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t SION : 1;             /*!< [4] Software Input On Field. */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_iomuxc_sw_mux_ctl_pad_sd2_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_ADDR(x) ((uintptr_t)(x) + 0x35CU)

#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3(x) (*(__IO hw_iomuxc_sw_mux_ctl_pad_sd2_data3_t *) HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_ADDR(x))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3(x).U)
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3(x).U = (v))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SET(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_CLR(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_TOG(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3, field MUX_MODE[2:0] (RW)
 *
 * Select 1 of 5 iomux modes to be used for pad: SD2_DAT3. NOTE: Pad SD2_DAT3 is
 * involved in Daisy Chain.
 *
 * Values:
 * - 000 - Select signal SD2_DATA3.
 * - 001 - Select signal ECSPI5_SS3.
 * - 010 - Select signal KEY_COL6.- Configure register
 *     IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT2.
 * - 011 - Select signal AUD4_TXC.- Configure register
 *     IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3.
 * - 101 - Select signal GPIO1_IO12.
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE (0U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE (0x00000007U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE (3U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE_ALT0 (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE: Select signal SD2_DATA3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE_ALT1 (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE: Select signal ECSPI5_SS3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE_ALT2 (0x2U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE: Select signal KEY_COL6.- Configure register IOMUXC_KEY_COL6_SELECT_INPUTSelect Input Register for mode ALT2. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE_ALT3 (0x3U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE: Select signal AUD4_TXC.- Configure register IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUTSelect Input Register for mode ALT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE_ALT5 (0x5U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE: Select signal GPIO1_IO12. */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3(x).B.MUX_MODE)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE)

/*! @brief Set the MUX_MODE field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_MUX_MODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3, field SION[4] (RW)
 *
 * Force the selected mux mode input path no matter of MUX_MODE functionality.
 *
 * Values:
 * - 1 - Force input path of pad SD2_DAT3.
 * - 0 - Input Path is determined by functionality of the selected mux mode
 *     (regular).
 */
/*@{*/
#define BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION (4U) /*!< Bit position for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION. */
#define BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION (0x00000010U) /*!< Bit mask for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION. */
#define BS_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION (1U) /*!< Bit field size in bits for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION. */

#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION: Force input path of pad SD2_DAT3. */
#define BV_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION: Input Path is determined by functionality of the selected mux mode (regular). */

/*! @brief Read current value of the IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION field. */
#define BR_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION(x) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3(x).B.SION)

/*! @brief Format value for bitfield IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION. */
#define BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION) & BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION)

/*! @brief Set the SION field to a new value. */
#define BW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION(x, v) (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION) | BF_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_SION(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ADDR(x) ((uintptr_t)(x) + 0x360U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_DAT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). Please see Operating Frequency for more
 * details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_DAT1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_DAT1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_DAT1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_DAT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_data2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ADDR(x) ((uintptr_t)(x) + 0x364U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_data2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_DAT2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_DAT2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_DAT2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_DAT2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_DAT2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ADDR(x) ((uintptr_t)(x) + 0x368U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_DAT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_DAT0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_DAT0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_DAT0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_DAT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC - Pad Control Register (RW)
 *
 * Reset value: 0x00013030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_txc
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_txc_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_txc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ADDR(x) ((uintptr_t)(x) + 0x36CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_txc_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TXC.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TXC.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TXC.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TXC.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TXC.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TXC(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_td0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_td0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_td0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ADDR(x) ((uintptr_t)(x) + 0x370U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TD0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TD0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TD0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TD0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TD0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_td1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_td1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_td1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ADDR(x) ((uintptr_t)(x) + 0x374U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TD1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TD1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TD1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TD1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TD1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_td2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_td2_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_td2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ADDR(x) ((uintptr_t)(x) + 0x378U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TD2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TD2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TD2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TD2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TD2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD2(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_td3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_td3_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_td3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ADDR(x) ((uintptr_t)(x) + 0x37CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TD3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TD3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TD3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TD3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TD3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TD3(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL - Pad Control Register (RW)
 *
 * Reset value: 0x00013030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rx_ctl
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rx_ctl_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rx_ctl_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ADDR(x) ((uintptr_t)(x) + 0x380U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rx_ctl_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RX_CTL.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RX_CTL.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RX_CTL.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RX_CTL.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RX_CTL.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RX_CTL(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rd0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ADDR(x) ((uintptr_t)(x) + 0x384U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RD0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RD0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RD0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RD0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RD0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL - Pad Control Register (RW)
 *
 * Reset value: 0x00013030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_tx_ctl
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_tx_ctl_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_tx_ctl_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ADDR(x) ((uintptr_t)(x) + 0x388U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_tx_ctl_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_TX_CTL.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field ODT[10:8] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 000 - Disabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT: Disabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_TX_CTL.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_TX_CTL.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_TX_CTL.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_TX_CTL.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_TX_CTL(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rd1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ADDR(x) ((uintptr_t)(x) + 0x38CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RD1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RD1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RD1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RD1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RD1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd2_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rd2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ADDR(x) ((uintptr_t)(x) + 0x390U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RD2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RD2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RD2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RD2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RD2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD2(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rd3_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rd3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ADDR(x) ((uintptr_t)(x) + 0x394U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RD3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RD3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RD3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RD3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RD3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RD3(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC - Pad Control Register (RW)
 *
 * Reset value: 0x00013030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_rgmii_rxc
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_rgmii_rxc_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED4 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_rgmii_rxc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ADDR(x) ((uintptr_t)(x) + 0x398U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rxc_t *) HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: RGMII_RXC.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V
 * - 010 - 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V
 * - 011 - 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V
 * - 100 - 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V
 * - 101 - 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V
 * - 110 - 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V
 * - 111 - 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_287_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 287/174 Ohm @ 2.5V, 247/201 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_121_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 121/85 Ohm @ 2.5V, 113/96 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_76_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 76/56 Ohm @ 2.5V, 73/63 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_57_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 57/43 Ohm @ 2.5V, 55/48 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_45_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 45/34 Ohm @ 2.5V, 43/38 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_37_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 37/28 Ohm @ 2.5V, 36/32 Ohm pd/pu @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE_31_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE: 31/24 Ohm @ 2.5V, 30/27 Ohm pd/pu @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field ODT[10:8] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_RGMII_TERMPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.ODT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field PKE[12] (RW)
 *
 * Select one of next values for pad: RGMII_RXC.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field PUE[13] (RW)
 *
 * Select one of next values for pad: RGMII_RXC.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: RGMII_RXC.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field HYS[16] (RW)
 *
 * Select one of next values for pad: RGMII_RXC.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMIIPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_RGMII_RXC(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr25
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr25_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr25_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ADDR(x) ((uintptr_t)(x) + 0x39CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr25_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A25.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A25.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A25.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A25.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A25.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR25_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_eb2_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_eb2_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_eb2_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ADDR(x) ((uintptr_t)(x) + 0x3A0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_eb2_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_EB2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_EB2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_EB2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_EB2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_EB2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data16_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ADDR(x) ((uintptr_t)(x) + 0x3A4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data16_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D16.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D16.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D16.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D16.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D16.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA16_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data17_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ADDR(x) ((uintptr_t)(x) + 0x3A8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data17_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D17.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D17.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D17.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D17.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D17.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA17_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data18_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ADDR(x) ((uintptr_t)(x) + 0x3ACU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data18_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D18.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D18.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D18.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D18.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D18.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA18_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data19_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ADDR(x) ((uintptr_t)(x) + 0x3B0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data19_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D19.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D19.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D19.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D19.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D19.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA19_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data20
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data20_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ADDR(x) ((uintptr_t)(x) + 0x3B4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data20_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D20.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D20.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D20.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D20.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D20.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA20_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data21
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data21_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ADDR(x) ((uintptr_t)(x) + 0x3B8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data21_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D21.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D21.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D21.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D21.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D21.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA21_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data22
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data22_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ADDR(x) ((uintptr_t)(x) + 0x3BCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data22_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D22.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D22.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D22.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D22.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D22.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA22_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data23
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data23_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ADDR(x) ((uintptr_t)(x) + 0x3C0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data23_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D23.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D23.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D23.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D23.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D23.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA23_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_eb3_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_eb3_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_eb3_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ADDR(x) ((uintptr_t)(x) + 0x3C4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_eb3_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_EB3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_EB3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_EB3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_EB3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_EB3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data24
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data24_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data24_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ADDR(x) ((uintptr_t)(x) + 0x3C8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data24_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D24.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D24.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D24.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D24.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D24.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA24_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data25
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data25_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data25_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ADDR(x) ((uintptr_t)(x) + 0x3CCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data25_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D25.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D25.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D25.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D25.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D25.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA25_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data26
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data26_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data26_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ADDR(x) ((uintptr_t)(x) + 0x3D0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data26_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D26.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D26.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D26.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D26.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D26.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data27
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data27_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data27_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ADDR(x) ((uintptr_t)(x) + 0x3D4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data27_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D27.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D27.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D27.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D27.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D27.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data28
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data28_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data28_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ADDR(x) ((uintptr_t)(x) + 0x3D8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data28_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D28.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D28.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D28.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D28.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D28.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA28_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data29
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data29_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data29_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ADDR(x) ((uintptr_t)(x) + 0x3DCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data29_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D29.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D29.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D29.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D29.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D29.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA29_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data30
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data30_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data30_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ADDR(x) ((uintptr_t)(x) + 0x3E0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data30_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D30.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D30.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D30.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D30.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D30.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA30_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_data31
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_data31_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_data31_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ADDR(x) ((uintptr_t)(x) + 0x3E4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_data31_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_D31.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_D31.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_D31.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_D31.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_D31.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA31_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr24
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr24_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr24_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ADDR(x) ((uintptr_t)(x) + 0x3E8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr24_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A24.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A24.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A24.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A24.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A24.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR24_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr23
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr23_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ADDR(x) ((uintptr_t)(x) + 0x3ECU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr23_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A23.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A23.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A23.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A23.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A23.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR23_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr22
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr22_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ADDR(x) ((uintptr_t)(x) + 0x3F0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr22_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A22.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A22.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A22.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A22.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A22.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR22_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr21
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr21_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ADDR(x) ((uintptr_t)(x) + 0x3F4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr21_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A21.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A21.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A21.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A21.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A21.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR21_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr20
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr20_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ADDR(x) ((uintptr_t)(x) + 0x3F8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr20_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A20.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A20.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A20.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A20.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A20.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR20_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr19
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr19_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ADDR(x) ((uintptr_t)(x) + 0x3FCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr19_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A19.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A19.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A19.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A19.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A19.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR19_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr18
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr18_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ADDR(x) ((uintptr_t)(x) + 0x400U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr18_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A18.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A18.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A18.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A18.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A18.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR18_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr17
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr17_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ADDR(x) ((uintptr_t)(x) + 0x404U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr17_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A17.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A17.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A17.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A17.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A17.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR17_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_addr16
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_addr16_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_addr16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ADDR(x) ((uintptr_t)(x) + 0x408U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_addr16_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_A16.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_A16.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_A16.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_A16.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_A16.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_ADDR16_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_cs0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_cs0_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_cs0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ADDR(x) ((uintptr_t)(x) + 0x40CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_cs0_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_CS0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_CS0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_CS0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_CS0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_CS0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_cs1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_cs1_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_cs1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ADDR(x) ((uintptr_t)(x) + 0x410U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_cs1_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_CS1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_CS1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_CS1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_CS1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_CS1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_oe_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_oe_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_oe_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ADDR(x) ((uintptr_t)(x) + 0x414U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_oe_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_OE.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_OE.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_OE.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_OE.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_OE.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_rw
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_rw_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_rw_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_RW register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ADDR(x) ((uintptr_t)(x) + 0x418U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_rw_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_RW bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_RW.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_RW.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_RW.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_RW.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_RW, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_RW.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_lba_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_lba_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_lba_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ADDR(x) ((uintptr_t)(x) + 0x41CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_lba_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_LBA.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_LBA.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_LBA.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_LBA.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_LBA.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_eb0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_eb0_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_eb0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ADDR(x) ((uintptr_t)(x) + 0x420U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_eb0_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_EB0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_EB0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_EB0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_EB0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_EB0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_eb1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_eb1_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_eb1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ADDR(x) ((uintptr_t)(x) + 0x424U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_eb1_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_EB1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_EB1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_EB1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_EB1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_EB1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad00
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad00_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD00 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ADDR(x) ((uintptr_t)(x) + 0x428U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad00_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD00, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD00_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad01
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad01_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD01 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ADDR(x) ((uintptr_t)(x) + 0x42CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad01_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD01, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD01_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad02_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ADDR(x) ((uintptr_t)(x) + 0x430U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD02, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD02_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad03_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ADDR(x) ((uintptr_t)(x) + 0x434U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD03, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD03_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ADDR(x) ((uintptr_t)(x) + 0x438U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD04, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad05_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ADDR(x) ((uintptr_t)(x) + 0x43CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD05, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD05_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad06_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ADDR(x) ((uintptr_t)(x) + 0x440U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD06, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD06_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad07_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ADDR(x) ((uintptr_t)(x) + 0x444U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD07, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD07_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad08
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad08_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD08 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ADDR(x) ((uintptr_t)(x) + 0x448U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad08_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA8.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA8.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA8.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA8.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD08, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA8.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD08_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad09
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad09_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD09 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ADDR(x) ((uintptr_t)(x) + 0x44CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad09_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA9.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA9.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA9.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA9.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD09, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA9.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD09_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad10
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad10_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD10 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ADDR(x) ((uintptr_t)(x) + 0x450U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad10_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA10.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA10.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA10.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA10.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD10, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA10.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD10_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad11
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad11_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD11 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ADDR(x) ((uintptr_t)(x) + 0x454U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad11_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA11.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA11.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA11.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA11.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD11, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA11.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD11_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad12
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad12_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD12 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ADDR(x) ((uintptr_t)(x) + 0x458U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad12_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA12.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA12.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA12.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA12.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD12, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA12.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD12_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad13
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad13_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD13 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ADDR(x) ((uintptr_t)(x) + 0x45CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad13_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA13.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA13.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA13.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA13.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD13, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA13.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD13_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad14
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad14_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD14 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ADDR(x) ((uintptr_t)(x) + 0x460U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad14_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA14.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA14.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA14.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA14.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD14, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA14.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD14_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_ad15
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_ad15_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_ad15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_AD15 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ADDR(x) ((uintptr_t)(x) + 0x464U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_ad15_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_AD15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_DA15.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_DA15.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_DA15.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_DA15.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_AD15, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_DA15.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_AD15_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B - Pad Control Register (RW)
 *
 * Reset value: 0x0000B060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_wait_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_wait_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_wait_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ADDR(x) ((uintptr_t)(x) + 0x468U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_wait_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_WAIT.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_WAIT.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_WAIT.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_WAIT.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_WAIT.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK - Pad Control Register (RW)
 *
 * Reset value: 0x0000B0B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_eim_bclk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_eim_bclk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_eim_bclk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ADDR(x) ((uintptr_t)(x) + 0x46CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_eim_bclk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: EIM_BCLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: EIM_BCLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: EIM_BCLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: EIM_BCLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: EIM_BCLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_di0_disp_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_di0_disp_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_di0_disp_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ADDR(x) ((uintptr_t)(x) + 0x470U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_di0_disp_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: DI0_DISP_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_DISP_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_di0_pin15
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_di0_pin15_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_di0_pin15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ADDR(x) ((uintptr_t)(x) + 0x474U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_di0_pin15_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DI0_PIN15.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field PKE[12] (RW)
 *
 * Select one of next values for pad: DI0_PIN15.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field PUE[13] (RW)
 *
 * Select one of next values for pad: DI0_PIN15.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DI0_PIN15.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15, field HYS[16] (RW)
 *
 * Select one of next values for pad: DI0_PIN15.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN15_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_di0_pin02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_di0_pin02_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_di0_pin02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ADDR(x) ((uintptr_t)(x) + 0x478U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_di0_pin02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DI0_PIN2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field PKE[12] (RW)
 *
 * Select one of next values for pad: DI0_PIN2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field PUE[13] (RW)
 *
 * Select one of next values for pad: DI0_PIN2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DI0_PIN2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02, field HYS[16] (RW)
 *
 * Select one of next values for pad: DI0_PIN2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN02_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_di0_pin03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_di0_pin03_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_di0_pin03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ADDR(x) ((uintptr_t)(x) + 0x47CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_di0_pin03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DI0_PIN3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field PKE[12] (RW)
 *
 * Select one of next values for pad: DI0_PIN3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field PUE[13] (RW)
 *
 * Select one of next values for pad: DI0_PIN3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DI0_PIN3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03, field HYS[16] (RW)
 *
 * Select one of next values for pad: DI0_PIN3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN03_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_di0_pin04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_di0_pin04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_di0_pin04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ADDR(x) ((uintptr_t)(x) + 0x480U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_di0_pin04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DI0_PIN4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field PKE[12] (RW)
 *
 * Select one of next values for pad: DI0_PIN4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field PUE[13] (RW)
 *
 * Select one of next values for pad: DI0_PIN4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DI0_PIN4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04, field HYS[16] (RW)
 *
 * Select one of next values for pad: DI0_PIN4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DI0_PIN04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data00
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data00_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ADDR(x) ((uintptr_t)(x) + 0x484U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data00_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA00_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data01
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data01_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ADDR(x) ((uintptr_t)(x) + 0x488U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data01_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA01_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data02_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ADDR(x) ((uintptr_t)(x) + 0x48CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA02_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data03_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ADDR(x) ((uintptr_t)(x) + 0x490U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA03_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ADDR(x) ((uintptr_t)(x) + 0x494U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data05_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ADDR(x) ((uintptr_t)(x) + 0x498U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA05_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data06_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ADDR(x) ((uintptr_t)(x) + 0x49CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA06_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data07_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ADDR(x) ((uintptr_t)(x) + 0x4A0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA07_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data08
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data08_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ADDR(x) ((uintptr_t)(x) + 0x4A4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data08_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT8.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT8.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT8.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT8.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT8.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA08_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data09
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data09_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ADDR(x) ((uintptr_t)(x) + 0x4A8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data09_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT9.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT9.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT9.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT9.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT9.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA09_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data10
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data10_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ADDR(x) ((uintptr_t)(x) + 0x4ACU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data10_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT10.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT10.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT10.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT10.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT10.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA10_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data11
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data11_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ADDR(x) ((uintptr_t)(x) + 0x4B0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data11_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT11.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT11.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT11.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT11.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT11.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA11_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data12
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data12_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ADDR(x) ((uintptr_t)(x) + 0x4B4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data12_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT12.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT12.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT12.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT12.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT12.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA12_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data13
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data13_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ADDR(x) ((uintptr_t)(x) + 0x4B8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data13_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT13.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT13.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT13.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT13.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT13.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA13_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data14
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data14_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ADDR(x) ((uintptr_t)(x) + 0x4BCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data14_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT14.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT14.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT14.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT14.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT14.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA14_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data15
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data15_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ADDR(x) ((uintptr_t)(x) + 0x4C0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data15_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT15.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT15.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT15.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT15.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT15.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA15_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data16_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ADDR(x) ((uintptr_t)(x) + 0x4C4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data16_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT16.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT16.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT16.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT16.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT16.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA16_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data17_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ADDR(x) ((uintptr_t)(x) + 0x4C8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data17_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT17.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT17.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT17.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT17.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT17.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA17_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data18_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ADDR(x) ((uintptr_t)(x) + 0x4CCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data18_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT18.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT18.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT18.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT18.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT18.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA18_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data19_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ADDR(x) ((uintptr_t)(x) + 0x4D0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data19_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT19.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT19.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT19.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT19.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT19.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA19_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data20
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data20_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data20_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ADDR(x) ((uintptr_t)(x) + 0x4D4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data20_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT20.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT20.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT20.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT20.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT20.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA20_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data21
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data21_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data21_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ADDR(x) ((uintptr_t)(x) + 0x4D8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data21_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT21.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT21.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT21.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT21.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT21.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA21_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data22
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data22_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data22_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ADDR(x) ((uintptr_t)(x) + 0x4DCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data22_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT22.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT22.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT22.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT22.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT22.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA22_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_disp0_data23
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_disp0_data23_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_disp0_data23_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ADDR(x) ((uintptr_t)(x) + 0x4E0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_disp0_data23_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DISP0_DAT23.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field PKE[12] (RW)
 *
 * Select one of next values for pad: DISP0_DAT23.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field PUE[13] (RW)
 *
 * Select one of next values for pad: DISP0_DAT23.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DISP0_DAT23.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23, field HYS[16] (RW)
 *
 * Select one of next values for pad: DISP0_DAT23.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DISP0_DATA23_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_mdio
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_mdio_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_mdio_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ADDR(x) ((uintptr_t)(x) + 0x4E4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_mdio_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_MDIO.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_MDIO.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_MDIO.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_MDIO.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_MDIO.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDIO_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_ref_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_ref_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_ref_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ADDR(x) ((uintptr_t)(x) + 0x4E8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_ref_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_REF_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_REF_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_REF_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_REF_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_REF_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_REF_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_rx_er
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_rx_er_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_rx_er_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ADDR(x) ((uintptr_t)(x) + 0x4ECU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_er_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_RX_ER.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_RX_ER.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_RX_ER.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_RX_ER.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_RX_ER.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_ER_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_crs_dv
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_crs_dv_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_crs_dv_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ADDR(x) ((uintptr_t)(x) + 0x4F0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_crs_dv_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_CRS_DV.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field SPEED[7:6] (RO)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - Medium frequency (100, 150 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED_MEDIUM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED: Medium frequency (100, 150 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_CRS_DV.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_CRS_DV.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_CRS_DV.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_CRS_DV.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_CRS_DV_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_rx_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_rx_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_rx_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ADDR(x) ((uintptr_t)(x) + 0x4F4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_RXD1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_RXD1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_RXD1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_RXD1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_RXD1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_rx_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_rx_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_rx_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ADDR(x) ((uintptr_t)(x) + 0x4F8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_RXD0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field SPEED[7:6] (RO)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - Medium frequency (100, 150 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED_MEDIUM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED: Medium frequency (100, 150 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_RXD0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_RXD0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_RXD0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_RXD0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_RX_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_tx_en
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_tx_en_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_tx_en_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ADDR(x) ((uintptr_t)(x) + 0x4FCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_en_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_TX_EN.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_TX_EN.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_TX_EN.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_TX_EN.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_TX_EN.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_EN_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_tx_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_tx_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_tx_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ADDR(x) ((uintptr_t)(x) + 0x500U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_TXD1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_TXD1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_TXD1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_TXD1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_TXD1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_tx_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_tx_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_tx_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ADDR(x) ((uintptr_t)(x) + 0x504U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_TXD0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_TXD0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_TXD0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_TXD0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_TXD0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_TX_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_enet_mdc
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_enet_mdc_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_enet_mdc_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_ENET_MDC register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ADDR(x) ((uintptr_t)(x) + 0x508U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_enet_mdc_t *) HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_ENET_MDC bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: ENET_MDC.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field PKE[12] (RW)
 *
 * Select one of next values for pad: ENET_MDC.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field PUE[13] (RW)
 *
 * Select one of next values for pad: ENET_MDC.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: ENET_MDC.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_ENET_MDC, field HYS[16] (RW)
 *
 * Select one of next values for pad: ENET_MDC.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_ENET_MDC_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs5_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs5_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs5_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ADDR(x) ((uintptr_t)(x) + 0x50CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs5_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS5.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS5_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm5
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm5_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ADDR(x) ((uintptr_t)(x) + 0x510U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm5_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM5.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM5.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM5(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm4_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ADDR(x) ((uintptr_t)(x) + 0x514U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm4_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM4.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM4.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM4(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs4_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs4_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs4_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ADDR(x) ((uintptr_t)(x) + 0x518U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs4_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS4.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS4_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs3_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs3_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs3_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ADDR(x) ((uintptr_t)(x) + 0x51CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs3_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS3.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm3_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ADDR(x) ((uintptr_t)(x) + 0x520U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM3.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM3.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs2_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs2_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs2_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ADDR(x) ((uintptr_t)(x) + 0x524U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs2_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS2.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm2_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ADDR(x) ((uintptr_t)(x) + 0x528U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM2.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM2.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr00
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr00_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ADDR(x) ((uintptr_t)(x) + 0x52CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr00_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR00(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr01
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr01_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ADDR(x) ((uintptr_t)(x) + 0x530U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr01_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR01(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr02_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ADDR(x) ((uintptr_t)(x) + 0x534U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A2.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A2.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR02(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr03_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ADDR(x) ((uintptr_t)(x) + 0x538U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A3.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A3.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR03(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr04_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ADDR(x) ((uintptr_t)(x) + 0x53CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A4.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A4.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR04(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr05_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ADDR(x) ((uintptr_t)(x) + 0x540U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A5.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A5.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR05(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr06_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ADDR(x) ((uintptr_t)(x) + 0x544U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A6.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A6.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR06(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr07_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ADDR(x) ((uintptr_t)(x) + 0x548U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A7.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A7.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR07(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr08
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr08_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ADDR(x) ((uintptr_t)(x) + 0x54CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr08_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A8.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A8.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A8.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR08(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr09
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr09_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ADDR(x) ((uintptr_t)(x) + 0x550U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr09_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A9.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A9.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A9.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR09(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr10
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr10_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ADDR(x) ((uintptr_t)(x) + 0x554U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr10_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A10.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A10.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A10.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR10(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr11
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr11_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ADDR(x) ((uintptr_t)(x) + 0x558U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr11_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A11.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A11.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A11.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR11(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr12
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr12_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ADDR(x) ((uintptr_t)(x) + 0x55CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr12_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A12.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A12.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A12.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR12(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr13
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr13_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ADDR(x) ((uintptr_t)(x) + 0x560U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr13_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A13.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A13.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A13.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR13(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr14
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr14_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ADDR(x) ((uintptr_t)(x) + 0x564U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr14_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A14.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A14.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A14.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR14(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_addr15
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_addr15_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_addr15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ADDR(x) ((uintptr_t)(x) + 0x568U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_addr15_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_A15.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_A15.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_A15.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ADDR15(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_cas_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_cas_b_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_cas_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ADDR(x) ((uintptr_t)(x) + 0x56CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_cas_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_CAS.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_CAS.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_CAS.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_CAS.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_B(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_cs0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_cs0_b_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_cs0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ADDR(x) ((uintptr_t)(x) + 0x570U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_cs0_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_CS0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_CS0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_CS0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_B(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_cs1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_cs1_b_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_cs1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ADDR(x) ((uintptr_t)(x) + 0x574U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_cs1_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_CS1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_CS1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_CS1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_B(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_ras_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_ras_b_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_ras_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ADDR(x) ((uintptr_t)(x) + 0x578U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_ras_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_RAS.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_RAS.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_RAS.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_RAS.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_B(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET - Pad Control Register (RW)
 *
 * Reset value: 0x00083030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_reset
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_reset_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_reset_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ADDR(x) ((uintptr_t)(x) + 0x57CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_reset_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_RESET.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_RESET.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_RESET.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_RESET.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET, field DDR_SEL[19:18] (RW)
 *
 * Select one of next values for pad: DRAM_RESET.
 *
 * Values:
 * - 00 - DDR3 and LPDDR2 mode.
 * - 01 - Reserved
 * - 10 - Reserved
 * - 11 - Reserved
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL_DDR3_LPDDR2 (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL: DDR3 and LPDDR2 mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL_RESERVED1 (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL_RESERVED2 (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL_RESERVED3 (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL: Reserved */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET(x).B.DDR_SEL)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL)

/*! @brief Set the DDR_SEL field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_RESET_DDR_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdba0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdba0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdba0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ADDR(x) ((uintptr_t)(x) + 0x580U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1 - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdba1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdba1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdba1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ADDR(x) ((uintptr_t)(x) + 0x584U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_ADDDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdclk0_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdclk0_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdclk0_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ADDR(x) ((uintptr_t)(x) + 0x588U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdclk0_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK0_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2 - Pad Control Register (RW)
 *
 * Reset value: 0x0000B000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdba2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdba2_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdba2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ADDR(x) ((uintptr_t)(x) + 0x58CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA2.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDBA2.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDBA2(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0 - Pad Control Register (RW)
 *
 * Reset value: 0x00003000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdcke0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdcke0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdcke0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ADDR(x) ((uintptr_t)(x) + 0x590U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdcke0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdclk1_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdclk1_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdclk1_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ADDR(x) ((uintptr_t)(x) + 0x594U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdclk1_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDCLK_1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK1_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1 - Pad Control Register (RW)
 *
 * Reset value: 0x00003000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdcke1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdcke1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdcke1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ADDR(x) ((uintptr_t)(x) + 0x598U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdcke1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDCKE1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0 - Pad Control Register (RW)
 *
 * Reset value: 0x00003030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_odt0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_odt0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_odt0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ADDR(x) ((uintptr_t)(x) + 0x59CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_odt0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1 - Pad Control Register (RW)
 *
 * Reset value: 0x00003030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_odt1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_odt1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_odt1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ADDR(x) ((uintptr_t)(x) + 0x5A0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_odt1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDODT1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_ODT1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B - Pad Control Register (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdwe_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdwe_b_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdwe_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ADDR(x) ((uintptr_t)(x) + 0x5A4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdwe_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B, field DSE[5:3] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_CTLDSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDWE.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_SDWE.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_SDWE.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_B(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs0_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs0_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs0_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ADDR(x) ((uintptr_t)(x) + 0x5A8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs0_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm0_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ADDR(x) ((uintptr_t)(x) + 0x5ACU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM0.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM0.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs1_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs1_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs1_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ADDR(x) ((uintptr_t)(x) + 0x5B0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs1_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ADDR(x) ((uintptr_t)(x) + 0x5B4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM1.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM1.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs6_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs6_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs6_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ADDR(x) ((uintptr_t)(x) + 0x5B8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs6_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS6.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS6_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm6
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm6_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ADDR(x) ((uintptr_t)(x) + 0x5BCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm6_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM6.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM6.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM6(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P - Pad Control Register (RW)
 *
 * Reset value: 0x00002030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs7_p
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_sdqs7_p_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_sdqs7_p_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ADDR(x) ((uintptr_t)(x) + 0x5C0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs7_p_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS7.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field PKE[12] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field PUE[13] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: DRAM_SDQS7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field HYS[16] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRHYSPad Group Control Register Note: The value of this field does not
 * reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.HYS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field DDR_INPUT[17] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTLPad Group Control Register Note: The value of this field
 * does not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.DDR_INPUT)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS7_P(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7 - Pad Control Register (RW)
 *
 * Reset value: 0x00008030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_dram_dqm7
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_dram_dqm7_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED2 : 5;        /*!< [15:11]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED3 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_dram_dqm7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ADDR(x) ((uintptr_t)(x) + 0x5C4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm7_t *) HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: DRAM_DQM7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7, field ODT[10:8] (RW)
 *
 * Select one of next values for pad: DRAM_DQM7.
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_ODT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7, field HYS[16] (RW)
 *
 * Select one of next values for pad: DRAM_DQM7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_HYS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for pad: DRAM_DQM7.
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_INPUT(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7, field DDR_SEL[19:18] (RO)
 *
 * This property can be configured using Group Control Register:
 * IOMUXC_SW_PAD_CTL_GRP_DDR_TYPEPad Group Control Register Note: The value of this field does
 * not reflect the value of the Group Control Register.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM7(x).B.DDR_SEL)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_col0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_col0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_col0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_COL0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ADDR(x) ((uintptr_t)(x) + 0x5C8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_col0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_COL0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_COL0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_COL0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_COL0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_COL0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL0, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_COL0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_row0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_row0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_row0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ADDR(x) ((uintptr_t)(x) + 0x5CCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_row0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_ROW0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_ROW0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_ROW0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_ROW0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_ROW0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_col1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_col1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_col1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_COL1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ADDR(x) ((uintptr_t)(x) + 0x5D0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_col1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_COL1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_COL1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_COL1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_COL1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_COL1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL1, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_COL1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_row1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_row1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_row1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ADDR(x) ((uintptr_t)(x) + 0x5D4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_row1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_ROW1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_ROW1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_ROW1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_ROW1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_ROW1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_col2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_col2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_col2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_COL2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ADDR(x) ((uintptr_t)(x) + 0x5D8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_col2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_COL2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_COL2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_COL2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_COL2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_COL2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL2, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_COL2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_row2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_row2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_row2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ADDR(x) ((uintptr_t)(x) + 0x5DCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_row2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_ROW2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_ROW2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_ROW2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_ROW2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_ROW2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_col3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_col3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_col3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_COL3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ADDR(x) ((uintptr_t)(x) + 0x5E0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_col3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_COL3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_COL3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_COL3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_COL3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_COL3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL3, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_COL3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_row3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_row3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_row3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ADDR(x) ((uintptr_t)(x) + 0x5E4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_row3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_ROW3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_ROW3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_ROW3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_ROW3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_ROW3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_col4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_col4_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_col4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_COL4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ADDR(x) ((uintptr_t)(x) + 0x5E8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_col4_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_COL4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_COL4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_COL4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_COL4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_COL4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_COL4, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_COL4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_key_row4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_key_row4_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_key_row4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ADDR(x) ((uintptr_t)(x) + 0x5ECU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_key_row4_t *) HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: KEY_ROW4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field PKE[12] (RW)
 *
 * Select one of next values for pad: KEY_ROW4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field PUE[13] (RW)
 *
 * Select one of next values for pad: KEY_ROW4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: KEY_ROW4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4, field HYS[16] (RW)
 *
 * Select one of next values for pad: KEY_ROW4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW4_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio00
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio00_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO00 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ADDR(x) ((uintptr_t)(x) + 0x5F0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio00_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field SPEED[7:6] (RO)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - Medium frequency (100, 150 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED_MEDIUM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED: Medium frequency (100, 150 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO00, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO00_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio01
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio01_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO01 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ADDR(x) ((uintptr_t)(x) + 0x5F4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio01_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO01, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO01_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio09
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio09_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO09 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ADDR(x) ((uintptr_t)(x) + 0x5F8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio09_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_9.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_9.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_9.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_9.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO09, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_9.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO09_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio03_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ADDR(x) ((uintptr_t)(x) + 0x5FCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO03, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO03_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio06_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ADDR(x) ((uintptr_t)(x) + 0x600U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO06, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO06_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio02_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ADDR(x) ((uintptr_t)(x) + 0x604U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO02, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO02_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ADDR(x) ((uintptr_t)(x) + 0x608U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO04, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio05_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ADDR(x) ((uintptr_t)(x) + 0x60CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO05, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO05_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio07_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ADDR(x) ((uintptr_t)(x) + 0x610U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO07, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO07_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio08
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio08_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO08 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ADDR(x) ((uintptr_t)(x) + 0x614U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio08_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_8.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_8.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_8.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_8.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO08, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_8.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO08_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio16
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio16_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO16 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ADDR(x) ((uintptr_t)(x) + 0x618U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio16_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_16.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_16.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_16.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_16.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO16, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_16.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO16_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio17
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio17_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO17 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ADDR(x) ((uintptr_t)(x) + 0x61CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio17_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_17.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field SPEED[7:6] (RO)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - Medium frequency (100, 150 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED_MEDIUM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED: Medium frequency (100, 150 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_17.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_17.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_17.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO17, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_17.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO17_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio18
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio18_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO18 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ADDR(x) ((uintptr_t)(x) + 0x620U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio18_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_18.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_18.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_18.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_18.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO18, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_18.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO18_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_gpio19
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_gpio19_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_gpio19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_GPIO19 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ADDR(x) ((uintptr_t)(x) + 0x624U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_gpio19_t *) HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_GPIO19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: GPIO_19.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field PKE[12] (RW)
 *
 * Select one of next values for pad: GPIO_19.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field PUE[13] (RW)
 *
 * Select one of next values for pad: GPIO_19.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: GPIO_19.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_GPIO19, field HYS[16] (RW)
 *
 * Select one of next values for pad: GPIO_19.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_GPIO19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_GPIO19_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_pixclk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_pixclk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_pixclk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ADDR(x) ((uintptr_t)(x) + 0x628U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_pixclk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_PIXCLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_PIXCLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_hsync
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_hsync_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_hsync_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ADDR(x) ((uintptr_t)(x) + 0x62CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_hsync_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_MCLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_MCLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_MCLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_MCLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_MCLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_HSYNC_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data_en
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data_en_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data_en_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ADDR(x) ((uintptr_t)(x) + 0x630U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data_en_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DATA_EN.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA_EN_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_vsync
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_vsync_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_vsync_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ADDR(x) ((uintptr_t)(x) + 0x634U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_vsync_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_VSYNC.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_VSYNC.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_VSYNC.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_VSYNC.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_VSYNC.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_VSYNC_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ADDR(x) ((uintptr_t)(x) + 0x638U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data05_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ADDR(x) ((uintptr_t)(x) + 0x63CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA05_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data06_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ADDR(x) ((uintptr_t)(x) + 0x640U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA06_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data07_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ADDR(x) ((uintptr_t)(x) + 0x644U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA07_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data08
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data08_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data08_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ADDR(x) ((uintptr_t)(x) + 0x648U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data08_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT8.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT8.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT8.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT8.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT8.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA08_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data09
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data09_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data09_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ADDR(x) ((uintptr_t)(x) + 0x64CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data09_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT9.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT9.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT9.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT9.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT9.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA09_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data10
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data10_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data10_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ADDR(x) ((uintptr_t)(x) + 0x650U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data10_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT10.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT10.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT10.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT10.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT10.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data11
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data11_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data11_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ADDR(x) ((uintptr_t)(x) + 0x654U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data11_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT11.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT11.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT11.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT11.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT11.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data12
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data12_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data12_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ADDR(x) ((uintptr_t)(x) + 0x658U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data12_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT12.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT12.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT12.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT12.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT12.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data13
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data13_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data13_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ADDR(x) ((uintptr_t)(x) + 0x65CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data13_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT13.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT13.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT13.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT13.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT13.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data14
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data14_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data14_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ADDR(x) ((uintptr_t)(x) + 0x660U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data14_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT14.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT14.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT14.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT14.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT14.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data15
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data15_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data15_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ADDR(x) ((uintptr_t)(x) + 0x664U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data15_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT15.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT15.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT15.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT15.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT15.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data16
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data16_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data16_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ADDR(x) ((uintptr_t)(x) + 0x668U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data16_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT16.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT16.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT16.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT16.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT16.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA16_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data17
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data17_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data17_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ADDR(x) ((uintptr_t)(x) + 0x66CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data17_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT17.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT17.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT17.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT17.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT17.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA17_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data18
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data18_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data18_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ADDR(x) ((uintptr_t)(x) + 0x670U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data18_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT18.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT18.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT18.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT18.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT18.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA18_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_csi0_data19
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_csi0_data19_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_csi0_data19_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ADDR(x) ((uintptr_t)(x) + 0x674U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_csi0_data19_t *) HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: CSI0_DAT19.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field PKE[12] (RW)
 *
 * Select one of next values for pad: CSI0_DAT19.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field PUE[13] (RW)
 *
 * Select one of next values for pad: CSI0_DAT19.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: CSI0_DAT19.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19, field HYS[16] (RW)
 *
 * Select one of next values for pad: CSI0_DAT19.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA19_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS - Pad Control Register (RW)
 *
 * Reset value: 0x00007060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_tms
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_tms_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_tms_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ADDR(x) ((uintptr_t)(x) + 0x678U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_tms_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 0 - Slow Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE: Slow Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 100 - 60 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE: 60 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 01 - Low (50 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED_50MHZ (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED: Low (50 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_TMS.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: JTAG_TMS.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS, field HYS[16] (RW)
 *
 * Select one of next values for pad: JTAG_TMS.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD - Pad Control Register (RW)
 *
 * Reset value: 0x0000B060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_mod
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_mod_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_mod_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ADDR(x) ((uintptr_t)(x) + 0x67CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_mod_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 0 - Slow Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE: Slow Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 100 - 60 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE: 60 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 01 - Low (50 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED_50MHZ (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED: Low (50 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_MOD.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: JTAG_MOD.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD, field HYS[16] (RW)
 *
 * Select one of next values for pad: JTAG_MOD.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB - Pad Control Register (RW)
 *
 * Reset value: 0x00007060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_trstb
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_trstb_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_trstb_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ADDR(x) ((uintptr_t)(x) + 0x680U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_trstb_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 0 - Slow Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE: Slow Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 100 - 60 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE: 60 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 01 - Low (50 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED_50MHZ (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED: Low (50 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_TRSTB.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: JTAG_TRSTB.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB, field HYS[16] (RW)
 *
 * Select one of next values for pad: JTAG_TRSTB.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI - Pad Control Register (RW)
 *
 * Reset value: 0x00007060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_tdi
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_tdi_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_tdi_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ADDR(x) ((uintptr_t)(x) + 0x684U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_tdi_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 0 - Slow Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE: Slow Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 100 - 60 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE: 60 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 01 - Low (50 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED_50MHZ (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED: Low (50 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_TDI.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: JTAG_TDI.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI, field HYS[16] (RW)
 *
 * Select one of next values for pad: JTAG_TDI.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK - Pad Control Register (RW)
 *
 * Reset value: 0x00007060U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_tck
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_tck_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_tck_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ADDR(x) ((uintptr_t)(x) + 0x688U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_tck_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 0 - Slow Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE: Slow Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 100 - 60 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE: 60 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 01 - Low (50 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED_50MHZ (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED: Low (50 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_TCK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: JTAG_TCK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK, field HYS[16] (RW)
 *
 * Select one of next values for pad: JTAG_TCK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO - Pad Control Register (RW)
 *
 * Reset value: 0x000090B1U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_jtag_tdo
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_jtag_tdo_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_jtag_tdo_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ADDR(x) ((uintptr_t)(x) + 0x68CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_jtag_tdo_t *) HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field SRE[0] (RO)
 *
 * Slew rate control. Read Only Field The value of this field is fixed and
 * cannot be changed.
 *
 * Values:
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.SRE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field DSE[5:3] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 110 - 40 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE: 40 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.DSE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field SPEED[7:6] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - Medium (100 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED_100MHZ (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED: Medium (100 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.SPEED)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field ODE[11] (RO)
 *
 * Enables open drain of the pin. Read Only Field The value of this field is
 * fixed and cannot be changed.
 *
 * Values:
 * - 0 - Output is CMOS.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE: Output is CMOS. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.ODE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field PKE[12] (RW)
 *
 * Select one of next values for pad: JTAG_TDO.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field PUE[13] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 0 - Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE: Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.PUE)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field PUS[15:14] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 10 - 100K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS: 100K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.PUS)
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO, field HYS[16] (RO)
 *
 * Read Only Field The value of this field is fixed and cannot be changed.
 *
 * Values:
 * - 0 - CMOS input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS: CMOS input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDO(x).B.HYS)
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data7
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data7_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ADDR(x) ((uintptr_t)(x) + 0x690U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data7_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA7_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data6
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data6_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ADDR(x) ((uintptr_t)(x) + 0x694U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data6_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA6_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data5
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data5_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ADDR(x) ((uintptr_t)(x) + 0x698U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data5_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA5_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data4_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ADDR(x) ((uintptr_t)(x) + 0x69CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data4_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA4_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_cmd_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ADDR(x) ((uintptr_t)(x) + 0x6A0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_cmd_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_CMD.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_CMD.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_CMD.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_CMD.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CMD, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_CMD.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ADDR(x) ((uintptr_t)(x) + 0x6A4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ADDR(x) ((uintptr_t)(x) + 0x6A8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ADDR(x) ((uintptr_t)(x) + 0x6ACU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ADDR(x) ((uintptr_t)(x) + 0x6B0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_data3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ADDR(x) ((uintptr_t)(x) + 0x6B4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_data3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_DAT3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_DAT3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_DAT3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_DAT3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_DAT3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd3_reset
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd3_reset_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd3_reset_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD3_RESET register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ADDR(x) ((uintptr_t)(x) + 0x6B8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd3_reset_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD3_RESET bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD3_RST.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD3_RST.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD3_RST.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD3_RST.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD3_RESET, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD3_RST.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD3_RESET_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_cle
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_cle_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_cle_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_CLE register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ADDR(x) ((uintptr_t)(x) + 0x6BCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_cle_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_CLE bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_CLE.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_CLE.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_CLE.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_CLE.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CLE, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_CLE.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CLE_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_ale
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_ale_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_ale_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_ALE register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ADDR(x) ((uintptr_t)(x) + 0x6C0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_ale_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_ALE bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_ALE.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_ALE.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_ALE.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_ALE.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_ALE, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_ALE.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_wp_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_wp_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_wp_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ADDR(x) ((uintptr_t)(x) + 0x6C4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_wp_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_WP_B.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_WP_B.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_WP_B.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_WP_B.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_WP_B.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_WP_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_ready_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_ready_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_ready_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ADDR(x) ((uintptr_t)(x) + 0x6C8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_ready_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_RB0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_RB0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_RB0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_RB0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_RB0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_READY_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_cs0_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_cs0_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_cs0_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ADDR(x) ((uintptr_t)(x) + 0x6CCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_cs0_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_CS0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_CS0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_CS0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_CS0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_CS0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS0_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_cs1_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_cs1_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_cs1_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ADDR(x) ((uintptr_t)(x) + 0x6D0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_cs1_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_CS1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_CS1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_CS1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_CS1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_CS1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS1_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_cs2_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_cs2_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_cs2_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ADDR(x) ((uintptr_t)(x) + 0x6D4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_cs2_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_CS2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_CS2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_CS2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_CS2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_CS2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS2_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_cs3_b
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_cs3_b_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_cs3_b_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ADDR(x) ((uintptr_t)(x) + 0x6D8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_cs3_b_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_CS3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_CS3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_CS3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_CS3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_CS3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_CS3_B_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_cmd_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ADDR(x) ((uintptr_t)(x) + 0x6DCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_cmd_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_CMD.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_CMD.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_CMD.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_CMD.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CMD, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_CMD.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ADDR(x) ((uintptr_t)(x) + 0x6E0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data00
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data00_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data00_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ADDR(x) ((uintptr_t)(x) + 0x6E4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data00_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA00_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data01
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data01_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data01_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ADDR(x) ((uintptr_t)(x) + 0x6E8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data01_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA01_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data02
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data02_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data02_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ADDR(x) ((uintptr_t)(x) + 0x6ECU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data02_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA02_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data03
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data03_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data03_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ADDR(x) ((uintptr_t)(x) + 0x6F0U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data03_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA03_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data04
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data04_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data04_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ADDR(x) ((uintptr_t)(x) + 0x6F4U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data04_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data05
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data05_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data05_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ADDR(x) ((uintptr_t)(x) + 0x6F8U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data05_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data06
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data06_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data06_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ADDR(x) ((uintptr_t)(x) + 0x6FCU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data06_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_nand_data07
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_nand_data07_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_nand_data07_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ADDR(x) ((uintptr_t)(x) + 0x700U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_nand_data07_t *) HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: NANDF_D7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field PKE[12] (RW)
 *
 * Select one of next values for pad: NANDF_D7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field PUE[13] (RW)
 *
 * Select one of next values for pad: NANDF_D7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: NANDF_D7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07, field HYS[16] (RW)
 *
 * Select one of next values for pad: NANDF_D7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ADDR(x) ((uintptr_t)(x) + 0x704U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ADDR(x) ((uintptr_t)(x) + 0x708U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ADDR(x) ((uintptr_t)(x) + 0x70CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ADDR(x) ((uintptr_t)(x) + 0x710U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data4_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ADDR(x) ((uintptr_t)(x) + 0x714U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data4_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT4.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT4.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT4.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT4.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT4.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data5
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data5_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ADDR(x) ((uintptr_t)(x) + 0x718U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data5_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT5.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT5.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT5.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT5.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT5.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data6
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data6_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ADDR(x) ((uintptr_t)(x) + 0x71CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data6_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT6.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT6.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT6.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT6.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT6.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd4_data7
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd4_data7_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd4_data7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ADDR(x) ((uintptr_t)(x) + 0x720U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd4_data7_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD4_DAT7.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD4_DAT7.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD4_DAT7.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD4_DAT7.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD4_DAT7.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_data1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_data1_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_data1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ADDR(x) ((uintptr_t)(x) + 0x724U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_data1_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_DAT1.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_DAT1.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_DAT1.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_DAT1.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_DAT1.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_data0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_data0_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_data0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ADDR(x) ((uintptr_t)(x) + 0x728U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_data0_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_DAT0.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_DAT0.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_DAT0.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_DAT0.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_DAT0.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_data3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ADDR(x) ((uintptr_t)(x) + 0x72CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_data3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_DAT3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_DAT3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_DAT3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_DAT3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_DAT3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_cmd_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ADDR(x) ((uintptr_t)(x) + 0x730U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_cmd_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_CMD.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_CMD.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_CMD.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_CMD.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CMD, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_CMD.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_data2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_data2_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_data2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ADDR(x) ((uintptr_t)(x) + 0x734U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_data2_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_DAT2.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_DAT2.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_DAT2.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_DAT2.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_DAT2.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd1_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd1_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd1_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD1_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ADDR(x) ((uintptr_t)(x) + 0x738U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd1_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD1_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD1_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD1_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD1_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD1_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD1_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD1_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_clk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_clk_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_clk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_CLK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ADDR(x) ((uintptr_t)(x) + 0x73CU)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_clk_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_CLK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_CLK.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_CLK.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_CLK.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_CLK.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CLK, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_CLK.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_cmd
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_cmd_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_cmd_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_CMD register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ADDR(x) ((uintptr_t)(x) + 0x740U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_cmd_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_CMD bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_CMD.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_CMD.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_CMD.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_CMD.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_CMD, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_CMD.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3 - Pad Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3 - Pad Control Register (RW)
 *
 * Reset value: 0x0001B0B0U
 */
typedef union _hw_iomuxc_sw_pad_ctl_pad_sd2_data3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_pad_sd2_data3_bitfields
    {
        uint32_t SRE : 1;              /*!< [0] Slew Rate Field */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t SPEED : 2;            /*!< [7:6] Speed Field */
        uint32_t RESERVED1 : 3;        /*!< [10:8]  */
        uint32_t ODE : 1;              /*!< [11] Open Drain Enable Field */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t PUS : 2;              /*!< [15:14] Pull Up / Down Config. Field */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_pad_sd2_data3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ADDR(x) ((uintptr_t)(x) + 0x744U)

#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x) (*(__IO hw_iomuxc_sw_pad_ctl_pad_sd2_data3_t *) HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field SRE[0] (RW)
 *
 * Slew rate control. The operational frequency on GPIO pads is dependent on
 * slew rate (SRE), speed (SPEED), and supply voltage (OVDD). See Operating
 * Frequency for more details.
 *
 * Values:
 * - 0 - Slow Slew Rate
 * - 1 - Fast Slew Rate
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE (0U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE (0x00000001U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE_SLOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE: Slow Slew Rate */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE_FAST (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE: Fast Slew Rate */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.SRE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SRE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field DSE[5:3] (RW)
 *
 * Select one of next values for pad: SD2_DAT3.
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 150 Ohm @ 3.3V, 260 Ohm @ 1.8V
 * - 010 - 75 Ohm @ 3.3V, 130 Ohm @ 1.8V
 * - 011 - 50 Ohm @ 3.3V, 90 Ohm @ 1.8V
 * - 100 - 37 Ohm @ 3.3V, 60 Ohm @ 1.8V
 * - 101 - 30 Ohm @ 3.3V, 50 Ohm @ 1.8V
 * - 110 - 25 Ohm @ 3.3V, 40 Ohm @ 1.8V
 * - 111 - 20 Ohm @ 3.3V, 33 Ohm @ 1.8V
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_HIZ (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_260_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 150 Ohm @ 3.3V, 260 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_130_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 75 Ohm @ 3.3V, 130 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_90_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 50 Ohm @ 3.3V, 90 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 37 Ohm @ 3.3V, 60 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_50_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 30 Ohm @ 3.3V, 50 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 25 Ohm @ 3.3V, 40 Ohm @ 1.8V */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE_33_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE: 20 Ohm @ 3.3V, 33 Ohm @ 1.8V */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_DSE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field SPEED[7:6] (RW)
 *
 * The operational frequency on GPIO pads is dependent on slew rate (SRE), speed
 * (SPEED), and supply voltage (OVDD). See Operating Frequency for more details.
 *
 * Values:
 * - 00 - Low frequency (50 MHz)
 * - 01 - Medium frequency (100, 150 MHz)
 * - 10 - Medium frequency (100, 150 MHz)
 * - 11 - Maximum frequency (100, 150, 200 MHz)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED (6U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED (0x000000C0U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED_LOW (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED: Low frequency (50 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED_MEDIUM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED: Medium frequency (100, 150 MHz) */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED_MAXIMUM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED: Maximum frequency (100, 150, 200 MHz) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.SPEED)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED)

/*! @brief Set the SPEED field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_SPEED(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field ODE[11] (RW)
 *
 * Enables open drain of the pin.
 *
 * Values:
 * - 0 - Output is CMOS.
 * - 1 - Output is Open Drain.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE (11U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE (0x00000800U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE: Output is CMOS. */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE: Output is Open Drain. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.ODE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE)

/*! @brief Set the ODE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_ODE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field PKE[12] (RW)
 *
 * Select one of next values for pad: SD2_DAT3.
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PKE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field PUE[13] (RW)
 *
 * Select one of next values for pad: SD2_DAT3.
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUE(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field PUS[15:14] (RW)
 *
 * Select one of next values for pad: SD2_DAT3.
 *
 * Values:
 * - 00 - 100K Ohm Pull Down
 * - 01 - 47K Ohm Pull Up
 * - 10 - 100K Ohm Pull Up
 * - 11 - 22K Ohm Pull Up
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS (14U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS (0x0000C000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS_100K_OHM_PD (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS: 100K Ohm Pull Down */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS_47K_OHM_PU (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS: 47K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS_100K_OHM_PU (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS: 100K Ohm Pull Up */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS_22K_OHM_PU (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS: 22K Ohm Pull Up */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.PUS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS)

/*! @brief Set the PUS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_PUS(v)))
/*@}*/

/*!
 * @name Register IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3, field HYS[16] (RW)
 *
 * Select one of next values for pad: SD2_DAT3.
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS(x) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS) & BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR(x, (HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS) | BF_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B7DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B7DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b7ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b7ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b7ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B7DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_ADDR(x) ((uintptr_t)(x) + 0x748U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b7ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B7DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B7DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA56,
 * DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60, DRAM_DATA61, DRAM_DATA62, DRAM_DATA63
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B7DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B7DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_addds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_addds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_addds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_ADDDS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_ADDR(x) ((uintptr_t)(x) + 0x74CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_addds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_ADDDS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_ADDDS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_ADDR00,
 * DRAM_ADDR01, DRAM_ADDR02, DRAM_ADDR03, DRAM_ADDR04, DRAM_ADDR05, DRAM_ADDR06,
 * DRAM_ADDR07, DRAM_ADDR08, DRAM_ADDR09, DRAM_ADDR10, DRAM_ADDR11, DRAM_ADDR12,
 * DRAM_ADDR13, DRAM_ADDR14, DRAM_ADDR15, DRAM_SDBA0, DRAM_SDBA1
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_HIZ (0U)  /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_ADDDS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_ADDDS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddrmode_ctl
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddrmode_ctl_bitfields
    {
        uint32_t RESERVED0 : 17;       /*!< [16:0]  */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddrmode_ctl_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_ADDR(x) ((uintptr_t)(x) + 0x750U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddrmode_ctl_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_SDQS0_P,
 * DRAM_SDQS1_P, DRAM_SDQS2_P, DRAM_SDQS3_P, DRAM_SDQS4_P, DRAM_SDQS5_P, DRAM_SDQS6_P,
 * DRAM_SDQS7_P
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CTL_DDR_INPUT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl0
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl0_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl0_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ADDR(x) ((uintptr_t)(x) + 0x754U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl0_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06, DRAM_DATA07
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL0_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE - Pad Group Control Register (RW)
 *
 * Reset value: 0x00001000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddrpke
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddrpke_bitfields
    {
        uint32_t RESERVED0 : 12;       /*!< [11:0]  */
        uint32_t PKE : 1;              /*!< [12] Pull / Keep Enable Field */
        uint32_t RESERVED1 : 19;       /*!< [31:13]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddrpke_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDRPKE register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_ADDR(x) ((uintptr_t)(x) + 0x758U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddrpke_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDRPKE bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDRPKE, field PKE[12] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06,
 * DRAM_DATA07, DRAM_DATA08, DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12,
 * DRAM_DATA13, DRAM_DATA14, DRAM_DATA15, DRAM_DATA16, DRAM_DATA17, DRAM_DATA18,
 * DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23, DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30,
 * DRAM_DATA31, DRAM_DATA32, DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36,
 * DRAM_DATA37, DRAM_DATA38, DRAM_DATA39, DRAM_DATA40, DRAM_DATA41, DRAM_DATA42,
 * DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47, DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54,
 * DRAM_DATA55, DRAM_DATA56, DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60,
 * DRAM_DATA61, DRAM_DATA62, DRAM_DATA63
 *
 * Values:
 * - 0 - Pull/Keeper Disabled
 * - 1 - Pull/Keeper Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE (12U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE (0x00001000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE: Pull/Keeper Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE: Pull/Keeper Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE(x).B.PKE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE) & BM_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE)

/*! @brief Set the PKE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE) | BF_IOMUXC_SW_PAD_CTL_GRP_DDRPKE_PKE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl1
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl1_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl1_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ADDR(x) ((uintptr_t)(x) + 0x75CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl1_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA08,
 * DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12, DRAM_DATA13, DRAM_DATA14, DRAM_DATA15
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL1_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl2
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl2_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl2_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ADDR(x) ((uintptr_t)(x) + 0x760U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl2_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA16,
 * DRAM_DATA17, DRAM_DATA18, DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL2_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl3
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl3_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl3_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ADDR(x) ((uintptr_t)(x) + 0x764U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl3_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30, DRAM_DATA31
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL3_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK - Pad Group Control Register (RW)
 *
 * Reset value: 0x00002000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddrpk
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddrpk_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t PUE : 1;              /*!< [13] Pull / Keep Select Field */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddrpk_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDRPK register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_ADDR(x) ((uintptr_t)(x) + 0x768U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddrpk_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDRPK bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDRPK, field PUE[13] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06,
 * DRAM_DATA07, DRAM_DATA08, DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12,
 * DRAM_DATA13, DRAM_DATA14, DRAM_DATA15, DRAM_DATA16, DRAM_DATA17, DRAM_DATA18,
 * DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23, DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30,
 * DRAM_DATA31, DRAM_DATA32, DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36,
 * DRAM_DATA37, DRAM_DATA38, DRAM_DATA39, DRAM_DATA40, DRAM_DATA41, DRAM_DATA42,
 * DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47, DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54,
 * DRAM_DATA55, DRAM_DATA56, DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60,
 * DRAM_DATA61, DRAM_DATA62, DRAM_DATA63
 *
 * Values:
 * - 0 - Keeper Enabled
 * - 1 - Pull Enabled
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE (13U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE (0x00002000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE_KEEP (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE: Keeper Enabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE_PULL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE: Pull Enabled */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK(x).B.PUE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE) & BM_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE)

/*! @brief Set the PUE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDRPK_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE) | BF_IOMUXC_SW_PAD_CTL_GRP_DDRPK_PUE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl4
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl4_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl4_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ADDR(x) ((uintptr_t)(x) + 0x76CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl4_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA32,
 * DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36, DRAM_DATA37, DRAM_DATA38, DRAM_DATA39
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL4_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddrhys
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddrhys_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t HYS : 1;              /*!< [16] Hysteresis Enable Field */
        uint32_t RESERVED1 : 15;       /*!< [31:17]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddrhys_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDRHYS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_ADDR(x) ((uintptr_t)(x) + 0x770U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddrhys_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDRHYS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDRHYS, field HYS[16] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06,
 * DRAM_DATA07, DRAM_DATA08, DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12,
 * DRAM_DATA13, DRAM_DATA14, DRAM_DATA15, DRAM_DATA16, DRAM_DATA17, DRAM_DATA18,
 * DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23, DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30,
 * DRAM_DATA31, DRAM_DATA32, DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36,
 * DRAM_DATA37, DRAM_DATA38, DRAM_DATA39, DRAM_DATA40, DRAM_DATA41, DRAM_DATA42,
 * DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47, DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54,
 * DRAM_DATA55, DRAM_DATA56, DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60,
 * DRAM_DATA61, DRAM_DATA62, DRAM_DATA63, DRAM_SDQS0_P, DRAM_SDQS1_P, DRAM_SDQS2_P,
 * DRAM_SDQS3_P, DRAM_SDQS4_P, DRAM_SDQS5_P, DRAM_SDQS6_P, DRAM_SDQS7_P
 *
 * Values:
 * - 0 - CMOS input
 * - 1 - Schmitt trigger input
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS (16U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS (0x00010000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS: CMOS input */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS_ENABLED (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS: Schmitt trigger input */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS(x).B.HYS)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS) & BM_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS)

/*! @brief Set the HYS field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS) | BF_IOMUXC_SW_PAD_CTL_GRP_DDRHYS_HYS(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddrmode
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddrmode_bitfields
    {
        uint32_t RESERVED0 : 17;       /*!< [16:0]  */
        uint32_t DDR_INPUT : 1;        /*!< [17] DDR / CMOS Input Mode Field */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddrmode_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDRMODE register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_ADDR(x) ((uintptr_t)(x) + 0x774U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddrmode_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDRMODE bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDRMODE, field DDR_INPUT[17] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06,
 * DRAM_DATA07, DRAM_DATA08, DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12,
 * DRAM_DATA13, DRAM_DATA14, DRAM_DATA15, DRAM_DATA16, DRAM_DATA17, DRAM_DATA18,
 * DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23, DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30,
 * DRAM_DATA31, DRAM_DATA32, DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36,
 * DRAM_DATA37, DRAM_DATA38, DRAM_DATA39, DRAM_DATA40, DRAM_DATA41, DRAM_DATA42,
 * DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47, DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54,
 * DRAM_DATA55, DRAM_DATA56, DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60,
 * DRAM_DATA61, DRAM_DATA62, DRAM_DATA63
 *
 * Values:
 * - 0 - CMOS input mode.
 * - 1 - Differential input mode.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT (17U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT (0x00020000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT (1U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT_CMOS (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT: CMOS input mode. */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT_DIFFERENTIAL (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT: Differential input mode. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE(x).B.DDR_INPUT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT) & BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT)

/*! @brief Set the DDR_INPUT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT) | BF_IOMUXC_SW_PAD_CTL_GRP_DDRMODE_DDR_INPUT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl5
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl5_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl5_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ADDR(x) ((uintptr_t)(x) + 0x778U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl5_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA40,
 * DRAM_DATA41, DRAM_DATA42, DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL5_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl6
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl6_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl6_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ADDR(x) ((uintptr_t)(x) + 0x77CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl6_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54, DRAM_DATA55
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL6_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7 - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7 - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_term_ctl7
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_term_ctl7_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_term_ctl7_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7 register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ADDR(x) ((uintptr_t)(x) + 0x780U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_term_ctl7_t *) HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7 bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA56,
 * DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60, DRAM_DATA61, DRAM_DATA62, DRAM_DATA63
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_TERM_CTL7_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B0DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B0DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b0ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b0ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b0ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B0DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_ADDR(x) ((uintptr_t)(x) + 0x784U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b0ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B0DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B0DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06, DRAM_DATA07
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B0DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B0DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B1DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B1DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b1ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b1ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b1ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B1DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_ADDR(x) ((uintptr_t)(x) + 0x788U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b1ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B1DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B1DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA08,
 * DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12, DRAM_DATA13, DRAM_DATA14, DRAM_DATA15
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B1DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B1DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ctlds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ctlds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ctlds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_CTLDS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_ADDR(x) ((uintptr_t)(x) + 0x78CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ctlds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_CTLDS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_CTLDS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_CS0_B, DRAM_CS1_B,
 * DRAM_SDBA2, DRAM_SDCKE0, DRAM_SDCKE1, DRAM_SDWE_B
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_HIZ (0U)  /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_CTLDS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_CTLDS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII - Pad Group Control Register (RW)
 *
 * Reset value: 0x00080000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddr_type_rgmii
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddr_type_rgmii_bitfields
    {
        uint32_t RESERVED0 : 18;       /*!< [17:0]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED1 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddr_type_rgmii_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_ADDR(x) ((uintptr_t)(x) + 0x790U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddr_type_rgmii_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII, field DDR_SEL[19:18] (RW)
 *
 * Select one of next values for group: . Affected pads: RGMII_RD0DDR Select
 * Field , RGMII_RD1DDR Select Field , RGMII_RD2DDR Select Field , RGMII_RD3DDR
 * Select Field , RGMII_RXCDDR Select Field , RGMII_RX_CTLDDR Select Field ,
 * RGMII_TD0DDR Select Field , RGMII_TD1DDR Select Field , RGMII_TD2DDR Select Field ,
 * RGMII_TD3DDR Select Field , RGMII_TXCDDR Select Field , RGMII_TX_CTLDDR Select
 * Field
 *
 * Values:
 * - 00 - Reserved
 * - 01 - Reserved
 * - 10 - 1.2V I/O interfaces including USB HSIC and MIPI_HSI. Provides
 *     calibrated drive strengths for signals ranging from 1.0V up to 1.3V.
 * - 11 - 1.5V I/O interfaces including ENET. Provides calibrated drive
 *     strengths for signals ranging from 1.3V to 2.5V.
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL_RESERVED0 (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL_RESERVED1 (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL_1P2V_IO (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL: 1.2V I/O interfaces including USB HSIC and MIPI_HSI. Provides calibrated drive strengths for signals ranging from 1.0V up to 1.3V. */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL_1P5V_IO (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL: 1.5V I/O interfaces including ENET. Provides calibrated drive strengths for signals ranging from 1.3V to 2.5V. */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII(x).B.DDR_SEL)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL) & BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL)

/*! @brief Set the DDR_SEL field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL) | BF_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RGMII_DDR_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B2DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B2DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b2ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b2ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b2ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B2DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_ADDR(x) ((uintptr_t)(x) + 0x794U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b2ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B2DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B2DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA16,
 * DRAM_DATA17, DRAM_DATA18, DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B2DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B2DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE - Pad Group Control Register (RW)
 *
 * Reset value: 0x00080000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_ddr_type
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_ddr_type_bitfields
    {
        uint32_t RESERVED0 : 18;       /*!< [17:0]  */
        uint32_t DDR_SEL : 2;          /*!< [19:18] DDR Select Field */
        uint32_t RESERVED1 : 12;       /*!< [31:20]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_ddr_type_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_ADDR(x) ((uintptr_t)(x) + 0x798U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_ddr_type_t *) HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE, field DDR_SEL[19:18] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_ADDR00,
 * DRAM_ADDR01, DRAM_ADDR02, DRAM_ADDR03, DRAM_ADDR04, DRAM_ADDR05, DRAM_ADDR06,
 * DRAM_ADDR07, DRAM_ADDR08, DRAM_ADDR09, DRAM_ADDR10, DRAM_ADDR11, DRAM_ADDR12,
 * DRAM_ADDR13, DRAM_ADDR14, DRAM_ADDR15, DRAM_CAS_B, DRAM_CS0_B, DRAM_CS1_B, DRAM_DATA00,
 * DRAM_DATA01, DRAM_DATA02, DRAM_DATA03, DRAM_DATA04, DRAM_DATA05, DRAM_DATA06,
 * DRAM_DATA07, DRAM_DATA08, DRAM_DATA09, DRAM_DATA10, DRAM_DATA11, DRAM_DATA12,
 * DRAM_DATA13, DRAM_DATA14, DRAM_DATA15, DRAM_DATA16, DRAM_DATA17, DRAM_DATA18,
 * DRAM_DATA19, DRAM_DATA20, DRAM_DATA21, DRAM_DATA22, DRAM_DATA23, DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30,
 * DRAM_DATA31, DRAM_DATA32, DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36,
 * DRAM_DATA37, DRAM_DATA38, DRAM_DATA39, DRAM_DATA40, DRAM_DATA41, DRAM_DATA42,
 * DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47, DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54,
 * DRAM_DATA55, DRAM_DATA56, DRAM_DATA57, DRAM_DATA58, DRAM_DATA59, DRAM_DATA60,
 * DRAM_DATA61, DRAM_DATA62, DRAM_DATA63, DRAM_DQM0, DRAM_DQM1, DRAM_DQM2,
 * DRAM_DQM3, DRAM_DQM4, DRAM_DQM5, DRAM_DQM6, DRAM_DQM7, DRAM_ODT0, DRAM_ODT1,
 * DRAM_RAS_B, DRAM_SDBA0, DRAM_SDBA1, DRAM_SDBA2, DRAM_SDCKE0, DRAM_SDCKE1,
 * DRAM_SDCLK0_P, DRAM_SDCLK1_P, DRAM_SDQS0_P, DRAM_SDQS1_P, DRAM_SDQS2_P, DRAM_SDQS3_P,
 * DRAM_SDQS4_P, DRAM_SDQS5_P, DRAM_SDQS6_P, DRAM_SDQS7_P, DRAM_SDWE_B
 *
 * Values:
 * - 00 - Reserved
 * - 01 - Reserved
 * - 10 - LPDDR2 mode (240 Ohm driver unit calibration, 240, 120, 80, 60, 48,
 *     40, 32 Ohm drive strengths at 1.2V)
 * - 11 - DDR3 mode (240 Ohm driver unit calibration, 240, 120, 80, 60, 48, 40,
 *     32 Ohm drive strengths at 1.5V)
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL (18U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL (0x000C0000U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL (2U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL_RESERVED0 (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL_RESERVED1 (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL: Reserved */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL_LPDDR2 (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL: LPDDR2 mode (240 Ohm driver unit calibration, 240, 120, 80, 60, 48, 40, 32 Ohm drive strengths at 1.2V) */
#define BV_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL_DDR3 (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL: DDR3 mode (240 Ohm driver unit calibration, 240, 120, 80, 60, 48, 40, 32 Ohm drive strengths at 1.5V) */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL(x) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE(x).B.DDR_SEL)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL) & BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL)

/*! @brief Set the DDR_SEL field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL) | BF_IOMUXC_SW_PAD_CTL_GRP_DDR_TYPE_DDR_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B3DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B3DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b3ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b3ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b3ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B3DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_ADDR(x) ((uintptr_t)(x) + 0x79CU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b3ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B3DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B3DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA24,
 * DRAM_DATA25, DRAM_DATA26, DRAM_DATA27, DRAM_DATA28, DRAM_DATA29, DRAM_DATA30, DRAM_DATA31
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B3DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B3DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B4DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B4DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b4ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b4ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b4ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B4DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_ADDR(x) ((uintptr_t)(x) + 0x7A0U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b4ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B4DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B4DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA32,
 * DRAM_DATA33, DRAM_DATA34, DRAM_DATA35, DRAM_DATA36, DRAM_DATA37, DRAM_DATA38, DRAM_DATA39
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B4DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B4DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B5DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B5DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b5ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b5ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b5ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B5DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_ADDR(x) ((uintptr_t)(x) + 0x7A4U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b5ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B5DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B5DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA40,
 * DRAM_DATA41, DRAM_DATA42, DRAM_DATA43, DRAM_DATA44, DRAM_DATA45, DRAM_DATA46, DRAM_DATA47
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B5DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B5DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_B6DS - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_B6DS - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000030U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_b6ds
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_b6ds_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t DSE : 3;              /*!< [5:3] Drive Strength Field */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_b6ds_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_B6DS register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_ADDR(x) ((uintptr_t)(x) + 0x7A8U)

#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_b6ds_t *) HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_B6DS bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_B6DS, field DSE[5:3] (RW)
 *
 * Select one of next values for group: . Affected pads: DRAM_DATA48,
 * DRAM_DATA49, DRAM_DATA50, DRAM_DATA51, DRAM_DATA52, DRAM_DATA53, DRAM_DATA54, DRAM_DATA55
 *
 * Values:
 * - 000 - HI-Z
 * - 001 - 240 Ohm
 * - 010 - 120 Ohm
 * - 011 - 80 Ohm
 * - 100 - 60 Ohm
 * - 101 - 48 Ohm
 * - 110 - 40 Ohm
 * - 111 - 34 Ohm
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE (3U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE (0x00000038U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_HIZ (0U)   /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: HI-Z */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_240_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 240 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_120_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 120 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_80_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 80 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_60_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 60 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_48_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 48 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_40_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 40 Ohm */
#define BV_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE_34_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE: 34 Ohm */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE(x) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS(x).B.DSE)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE) & BM_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_B6DS_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE) | BF_IOMUXC_SW_PAD_CTL_GRP_B6DS_DSE(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM - Pad Group Control Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM - Pad Group Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sw_pad_ctl_grp_rgmii_term
{
    uint32_t U;
    struct _hw_iomuxc_sw_pad_ctl_grp_rgmii_term_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t ODT : 3;              /*!< [10:8] On Die Termination Field */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_iomuxc_sw_pad_ctl_grp_rgmii_term_t;

/*!
 * @name Constants and macros for entire IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM register
 */
/*@{*/
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ADDR(x) ((uintptr_t)(x) + 0x7ACU)

#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM(x) (*(__IO hw_iomuxc_sw_pad_ctl_grp_rgmii_term_t *) HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ADDR(x))
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_RD(x) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM(x).U)
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_WR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM(x).U = (v))
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_SET(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_RD(x) |  (v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_CLR(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_RD(x) & ~(v)))
#define HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_TOG(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_WR(x, HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM bitfields
 */

/*!
 * @name Register IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM, field ODT[10:8] (RW)
 *
 * Select one of next values for group: . Affected pads: RGMII_RD0On Die
 * Termination Field , RGMII_RD1On Die Termination Field , RGMII_RD2On Die Termination
 * Field , RGMII_RD3On Die Termination Field , RGMII_RXCOn Die Termination Field ,
 * RGMII_RX_CTLOn Die Termination Field
 *
 * Values:
 * - 000 - Disabled
 * - 001 - 120 Ohm ODT
 * - 010 - 60 Ohm ODT
 * - 011 - 40 Ohm ODT
 * - 100 - 30 Ohm ODT
 * - 101 - 24 Ohm ODT
 * - 110 - 20 Ohm ODT
 * - 111 - 17 Ohm ODT
 */
/*@{*/
#define BP_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT (8U) /*!< Bit position for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT. */
#define BM_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT (0x00000700U) /*!< Bit mask for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT. */
#define BS_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT (3U) /*!< Bit field size in bits for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT. */

#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_DISABLED (0U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: Disabled */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_120_OHM (0x1U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 120 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_60_OHM (0x2U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 60 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_40_OHM (0x3U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 40 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_30_OHM (0x4U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 30 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_24_OHM (0x5U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 24 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_20_OHM (0x6U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 20 Ohm ODT */
#define BV_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT_17_OHM (0x7U) /*!< Bit field value for IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT: 17 Ohm ODT */

/*! @brief Read current value of the IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT field. */
#define BR_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT(x) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM(x).B.ODT)

/*! @brief Format value for bitfield IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT. */
#define BF_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT) & BM_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT)

/*! @brief Set the ODT field to a new value. */
#define BW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT(x, v) (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_WR(x, (HW_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_RD(x) & ~BM_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT) | BF_IOMUXC_SW_PAD_CTL_GRP_RGMII_TERM_ODT(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_asrc_asrck_clock_6_select_input
{
    uint32_t U;
    struct _hw_iomuxc_asrc_asrck_clock_6_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_asrc_asrck_clock_6_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7B0U)

#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT(x) (*(__IO hw_iomuxc_asrc_asrck_clock_6_select_input_t *) HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_RD(x) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT(x).U)
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_WR(x, HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_WR(x, HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_WR(x, HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad KEY_ROW3 for
 *     ASRC_EXT_CLK.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad GPIO_0 for
 *     ASRC_EXT_CLK.
 * - 10 - Selecting ALT4MUX Mode Select Field. mode of pad GPIO_18 for
 *     ASRC_EXT_CLK.
 */
/*@{*/
#define BP_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY_KEY_ROW3_ALT1 (0U) /*!< Bit field value for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad KEY_ROW3 for ASRC_EXT_CLK. */
#define BV_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY_GPIO00_ALT3 (0x1U) /*!< Bit field value for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad GPIO_0 for ASRC_EXT_CLK. */
#define BV_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY_GPIO18_ALT4 (0x2U) /*!< Bit field value for IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad GPIO_18 for ASRC_EXT_CLK. */

/*! @brief Read current value of the IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY) & BM_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_WR(x, (HW_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY) | BF_IOMUXC_ASRC_ASRCK_CLOCK_6_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_da_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_da_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_da_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7B4U)

#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_da_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT0 for AUD4_RXD.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT23 for
 *     AUD4_RXD.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY_SD2_DATA0_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT0 for AUD4_RXD. */
#define BV_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY_DISP0_DATA23_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT23 for AUD4_RXD. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_DA_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_db_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_db_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_db_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7B8U)

#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_db_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT2 for AUD4_TXD.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT21 for
 *     AUD4_TXD.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY_SD2_DATA2_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT2 for AUD4_TXD. */
#define BV_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY_DISP0_DATA21_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT21 for AUD4_TXD. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_DB_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_rxclk_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_rxclk_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_rxclk_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7BCU)

#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_rxclk_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT19 for
 *     AUD4_RXC.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_CMD for AUD4_RXC.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY_DISP0_DATA19_ALT4 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT19 for AUD4_RXC. */
#define BV_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY_SD2_CMD_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_CMD for AUD4_RXC. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_rxfs_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_rxfs_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_rxfs_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7C0U)

#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_rxfs_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT18 for
 *     AUD4_RXFS.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_CLK for AUD4_RXFS.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY_DISP0_DATA18_ALT4 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT18 for AUD4_RXFS. */
#define BV_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY_SD2_CLK_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_CLK for AUD4_RXFS. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_txclk_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_txclk_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_txclk_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7C4U)

#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_txclk_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT20 for
 *     AUD4_TXC.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT3 for AUD4_TXC.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY_DISP0_DATA20_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT20 for AUD4_TXC. */
#define BV_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY_SD2_DATA3_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT3 for AUD4_TXC. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud4_input_txfs_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud4_input_txfs_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud4_input_txfs_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7C8U)

#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud4_input_txfs_amx_select_input_t *) HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT1 for AUD4_TXFS.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT22 for
 *     AUD4_TXFS.
 */
/*@{*/
#define BP_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY_SD2_DATA1_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad SD2_DAT1 for AUD4_TXFS. */
#define BV_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY_DISP0_DATA22_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT22 for AUD4_TXFS. */

/*! @brief Read current value of the IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD4_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_da_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_da_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_da_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7CCU)

#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_da_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT19 for
 *     AUD5_RXD.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW1 for AUD5_RXD.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY_DISP0_DATA19_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT19 for AUD5_RXD. */
#define BV_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY_KEY_ROW1_ALT2 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW1 for AUD5_RXD. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_DA_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_db_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_db_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_db_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7D0U)

#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_db_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT17 for
 *     AUD5_TXD.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW0 for AUD5_TXD.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY_DISP0_DATA17_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT17 for AUD5_TXD. */
#define BV_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY_KEY_ROW0_ALT2 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW0 for AUD5_TXD. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_DB_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_rxclk_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_rxclk_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_rxclk_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7D4U)

#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_rxclk_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D25 for AUD5_RXC.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT14 for
 *     AUD5_RXC.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY_EIM_DATA25_ALT6 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D25 for AUD5_RXC. */
#define BV_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY_DISP0_DATA14_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT14 for AUD5_RXC. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_RXCLK_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_rxfs_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_rxfs_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_rxfs_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7D8U)

#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_rxfs_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D24 for AUD5_RXFS.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT13 for
 *     AUD5_RXFS.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY_EIM_DATA24_ALT6 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D24 for AUD5_RXFS. */
#define BV_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY_DISP0_DATA13_ALT3 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT13 for AUD5_RXFS. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_RXFS_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_txclk_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_txclk_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_txclk_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7DCU)

#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_txclk_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT16 for
 *     AUD5_TXC.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL0 for AUD5_TXC.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY_DISP0_DATA16_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT16 for AUD5_TXC. */
#define BV_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY_KEY_COL0_ALT2 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL0 for AUD5_TXC. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_TXCLK_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_aud5_input_txfs_amx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_aud5_input_txfs_amx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_aud5_input_txfs_amx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7E0U)

#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT(x) (*(__IO hw_iomuxc_aud5_input_txfs_amx_select_input_t *) HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT(x).U)
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT18 for
 *     AUD5_TXFS.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL1 for AUD5_TXFS.
 */
/*@{*/
#define BP_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY_DISP0_DATA18_ALT3 (0U) /*!< Bit field value for IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT18 for AUD5_TXFS. */
#define BV_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY_KEY_COL1_ALT2 (0x1U) /*!< Bit field value for IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL1 for AUD5_TXFS. */

/*! @brief Read current value of the IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY) & BM_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_WR(x, (HW_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY) | BF_IOMUXC_AUD5_INPUT_TXFS_AMX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_flexcan1_rx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_flexcan1_rx_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_flexcan1_rx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_FLEXCAN1_RX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7E4U)

#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT(x) (*(__IO hw_iomuxc_flexcan1_rx_select_input_t *) HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_RD(x) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT(x).U)
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_FLEXCAN1_RX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_FLEXCAN1_RX_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW2 for
 *     FLEXCAN1_RX.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad GPIO_8 for
 *     FLEXCAN1_RX.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad SD3_CLK for
 *     FLEXCAN1_RX.
 */
/*@{*/
#define BP_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY_KEY_ROW2_ALT2 (0U) /*!< Bit field value for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW2 for FLEXCAN1_RX. */
#define BV_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY_GPIO08_ALT3 (0x1U) /*!< Bit field value for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad GPIO_8 for FLEXCAN1_RX. */
#define BV_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY_SD3_CLK_ALT2 (0x2U) /*!< Bit field value for IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD3_CLK for FLEXCAN1_RX. */

/*! @brief Read current value of the IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY) & BM_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_WR(x, (HW_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY) | BF_IOMUXC_FLEXCAN1_RX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_flexcan2_rx_select_input
{
    uint32_t U;
    struct _hw_iomuxc_flexcan2_rx_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_flexcan2_rx_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_FLEXCAN2_RX_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7E8U)

#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT(x) (*(__IO hw_iomuxc_flexcan2_rx_select_input_t *) HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_RD(x) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT(x).U)
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_WR(x, v) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_SET(x, v) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_WR(x, HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_FLEXCAN2_RX_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_FLEXCAN2_RX_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW4 for
 *     FLEXCAN2_RX.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad SD3_DAT1 for
 *     FLEXCAN2_RX.
 */
/*@{*/
#define BP_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY_KEY_ROW4_ALT0 (0U) /*!< Bit field value for IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW4 for FLEXCAN2_RX. */
#define BV_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY_SD3_DATA1_ALT2 (0x1U) /*!< Bit field value for IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD3_DAT1 for FLEXCAN2_RX. */

/*! @brief Read current value of the IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY(x) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY) & BM_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_WR(x, (HW_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_RD(x) & ~BM_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY) | BF_IOMUXC_FLEXCAN2_RX_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ccm_pmic_ready_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ccm_pmic_ready_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ccm_pmic_ready_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_CCM_PMIC_READY_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7F0U)

#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT(x) (*(__IO hw_iomuxc_ccm_pmic_ready_select_input_t *) HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_RD(x) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT(x).U)
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_WR(x, v) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_SET(x, v) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_WR(x, HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_WR(x, HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_WR(x, HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_CCM_PMIC_READY_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_CCM_PMIC_READY_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB0 for
 *     CCM_PMIC_READY.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_17 for
 *     CCM_PMIC_READY.
 */
/*@{*/
#define BP_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY_EIM_EB0_B_ALT4 (0U) /*!< Bit field value for IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB0 for CCM_PMIC_READY. */
#define BV_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY_GPIO17_ALT2 (0x1U) /*!< Bit field value for IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_17 for CCM_PMIC_READY. */

/*! @brief Read current value of the IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY(x) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY) & BM_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_WR(x, (HW_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_RD(x) & ~BM_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY) | BF_IOMUXC_CCM_PMIC_READY_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_cspi_clk_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_cspi_clk_in_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi1_cspi_clk_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7F4U)

#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_cspi_clk_in_select_input_t *) HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D16 for
 *     ECSPI1_SCLK.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT20 for
 *     ECSPI1_SCLK.
 * - 10 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL0 for
 *     ECSPI1_SCLK.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT4 for
 *     ECSPI1_SCLK.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY_EIM_DATA16_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D16 for ECSPI1_SCLK. */
#define BV_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY_DISP0_DATA20_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT20 for ECSPI1_SCLK. */
#define BV_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY_KEY_COL0_ALT0 (0x2U) /*!< Bit field value for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL0 for ECSPI1_SCLK. */
#define BV_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY_CSI0_DATA04_ALT2 (0x3U) /*!< Bit field value for IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT4 for ECSPI1_SCLK. */

/*! @brief Read current value of the IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_CSPI_CLK_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_miso_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_miso_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi1_miso_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_MISO_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7F8U)

#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_miso_select_input_t *) HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_MISO_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_MISO_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D17 for
 *     ECSPI1_MISO.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT22 for
 *     ECSPI1_MISO.
 * - 10 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL1 for
 *     ECSPI1_MISO.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT6 for
 *     ECSPI1_MISO.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY_EIM_DATA17_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D17 for ECSPI1_MISO. */
#define BV_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY_DISP0_DATA22_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT22 for ECSPI1_MISO. */
#define BV_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY_KEY_COL1_ALT0 (0x2U) /*!< Bit field value for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL1 for ECSPI1_MISO. */
#define BV_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY_CSI0_DATA06_ALT2 (0x3U) /*!< Bit field value for IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT6 for ECSPI1_MISO. */

/*! @brief Read current value of the IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_MISO_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_MISO_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_mosi_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_mosi_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi1_mosi_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_MOSI_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x7FCU)

#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_mosi_select_input_t *) HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_MOSI_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_MOSI_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D18 for
 *     ECSPI1_MOSI.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT21 for
 *     ECSPI1_MOSI.
 * - 10 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW0 for
 *     ECSPI1_MOSI.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT5 for
 *     ECSPI1_MOSI.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY_EIM_DATA18_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D18 for ECSPI1_MOSI. */
#define BV_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY_DISP0_DATA21_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT21 for ECSPI1_MOSI. */
#define BV_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY_KEY_ROW0_ALT0 (0x2U) /*!< Bit field value for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW0 for ECSPI1_MOSI. */
#define BV_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY_CSI0_DATA05_ALT2 (0x3U) /*!< Bit field value for IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT5 for ECSPI1_MOSI. */

/*! @brief Read current value of the IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_MOSI_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_ss0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_ss0_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi1_ss0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_SS0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x800U)

#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_ss0_select_input_t *) HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_SS0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_SS0_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_EB2 for
 *     ECSPI1_SS0.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT23 for
 *     ECSPI1_SS0.
 * - 10 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW1 for
 *     ECSPI1_SS0.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT7 for
 *     ECSPI1_SS0.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY_EIM_EB2_B_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_EB2 for ECSPI1_SS0. */
#define BV_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY_DISP0_DATA23_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT23 for ECSPI1_SS0. */
#define BV_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY_KEY_ROW1_ALT0 (0x2U) /*!< Bit field value for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW1 for ECSPI1_SS0. */
#define BV_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY_CSI0_DATA07_ALT2 (0x3U) /*!< Bit field value for IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT7 for ECSPI1_SS0. */

/*! @brief Read current value of the IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_SS0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_SS0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_ss1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_ss1_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi1_ss1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_SS1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x804U)

#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_ss1_select_input_t *) HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_SS1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_SS1_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D19 for
 *     ECSPI1_SS1.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT15 for
 *     ECSPI1_SS1.
 * - 10 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL2 for
 *     ECSPI1_SS1.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY_EIM_DATA19_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D19 for ECSPI1_SS1. */
#define BV_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY_DISP0_DATA15_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT15 for ECSPI1_SS1. */
#define BV_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY_KEY_COL2_ALT0 (0x2U) /*!< Bit field value for IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL2 for ECSPI1_SS1. */

/*! @brief Read current value of the IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_SS1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_SS1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_ss2_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_ss2_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi1_ss2_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_SS2_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x808U)

#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_ss2_select_input_t *) HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_SS2_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_SS2_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D24 for ECSPI1_SS2.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW2 for
 *     ECSPI1_SS2.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY_EIM_DATA24_ALT3 (0U) /*!< Bit field value for IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D24 for ECSPI1_SS2. */
#define BV_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY_KEY_ROW2_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_ROW2 for ECSPI1_SS2. */

/*! @brief Read current value of the IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_SS2_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_SS2_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi1_ss3_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi1_ss3_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi1_ss3_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI1_SS3_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x80CU)

#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi1_ss3_select_input_t *) HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI1_SS3_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI1_SS3_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D25 for ECSPI1_SS3.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL3 for
 *     ECSPI1_SS3.
 */
/*@{*/
#define BP_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY_EIM_DATA25_ALT3 (0U) /*!< Bit field value for IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D25 for ECSPI1_SS3. */
#define BV_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY_KEY_COL3_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad KEY_COL3 for ECSPI1_SS3. */

/*! @brief Read current value of the IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI1_SS3_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI1_SS3_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi2_cspi_clk_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi2_cspi_clk_in_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi2_cspi_clk_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x810U)

#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi2_cspi_clk_in_select_input_t *) HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_CS0 for
 *     ECSPI2_SCLK.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT19 for
 *     ECSPI2_SCLK.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT8 for
 *     ECSPI2_SCLK.
 */
/*@{*/
#define BP_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY_EIM_CS0_B_ALT2 (0U) /*!< Bit field value for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_CS0 for ECSPI2_SCLK. */
#define BV_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY_DISP0_DATA19_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT19 for ECSPI2_SCLK. */
#define BV_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY_CSI0_DATA08_ALT2 (0x2U) /*!< Bit field value for IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT8 for ECSPI2_SCLK. */

/*! @brief Read current value of the IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI2_CSPI_CLK_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi2_miso_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi2_miso_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi2_miso_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI2_MISO_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x814U)

#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi2_miso_select_input_t *) HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI2_MISO_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI2_MISO_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_OE for
 *     ECSPI2_MISO.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT17 for
 *     ECSPI2_MISO.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT10 for
 *     ECSPI2_MISO.
 */
/*@{*/
#define BP_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY_EIM_OE_B_ALT2 (0U) /*!< Bit field value for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_OE for ECSPI2_MISO. */
#define BV_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY_DISP0_DATA17_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT17 for ECSPI2_MISO. */
#define BV_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY_CSI0_DATA10_ALT2 (0x2U) /*!< Bit field value for IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT10 for ECSPI2_MISO. */

/*! @brief Read current value of the IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI2_MISO_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI2_MISO_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi2_mosi_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi2_mosi_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi2_mosi_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI2_MOSI_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x818U)

#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi2_mosi_select_input_t *) HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI2_MOSI_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI2_MOSI_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_CS1 for
 *     ECSPI2_MOSI.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT16 for
 *     ECSPI2_MOSI.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT9 for
 *     ECSPI2_MOSI.
 */
/*@{*/
#define BP_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY_EIM_CS1_B_ALT2 (0U) /*!< Bit field value for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_CS1 for ECSPI2_MOSI. */
#define BV_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY_DISP0_DATA16_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT16 for ECSPI2_MOSI. */
#define BV_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY_CSI0_DATA09_ALT2 (0x2U) /*!< Bit field value for IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT9 for ECSPI2_MOSI. */

/*! @brief Read current value of the IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI2_MOSI_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi2_ss0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi2_ss0_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_ecspi2_ss0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI2_SS0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x81CU)

#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi2_ss0_select_input_t *) HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI2_SS0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI2_SS0_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_RW for ECSPI2_SS0.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT18 for
 *     ECSPI2_SS0.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT11 for
 *     ECSPI2_SS0.
 */
/*@{*/
#define BP_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY_EIM_RW_ALT2 (0U) /*!< Bit field value for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_RW for ECSPI2_SS0. */
#define BV_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY_DISP0_DATA18_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad DISP0_DAT18 for ECSPI2_SS0. */
#define BV_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY_CSI0_DATA11_ALT2 (0x2U) /*!< Bit field value for IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad CSI0_DAT11 for ECSPI2_SS0. */

/*! @brief Read current value of the IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI2_SS0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI2_SS0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi2_ss1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi2_ss1_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi2_ss1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI2_SS1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x820U)

#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi2_ss1_select_input_t *) HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI2_SS1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI2_SS1_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_LBA for ECSPI2_SS1.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT15 for
 *     ECSPI2_SS1.
 */
/*@{*/
#define BP_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY_EIM_LBA_B_ALT2 (0U) /*!< Bit field value for IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_LBA for ECSPI2_SS1. */
#define BV_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY_DISP0_DATA15_ALT3 (0x1U) /*!< Bit field value for IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DISP0_DAT15 for ECSPI2_SS1. */

/*! @brief Read current value of the IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI2_SS1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI2_SS1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi4_ss0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi4_ss0_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi4_ss0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI4_SS0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x824U)

#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi4_ss0_select_input_t *) HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI4_SS0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI4_SS0_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D20 for ECSPI4_SS0.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_D29 for ECSPI4_SS0.
 */
/*@{*/
#define BP_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY_EIM_DATA20_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D20 for ECSPI4_SS0. */
#define BV_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY_EIM_DATA29_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_D29 for ECSPI4_SS0. */

/*! @brief Read current value of the IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI4_SS0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI4_SS0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi5_cspi_clk_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi5_cspi_clk_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi5_cspi_clk_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x828U)

#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi5_cspi_clk_in_select_input_t *) HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad SD1_CLK for
 *     ECSPI5_SCLK.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad SD2_CLK for
 *     ECSPI5_SCLK.
 */
/*@{*/
#define BP_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY_SD1_CLK_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD1_CLK for ECSPI5_SCLK. */
#define BV_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY_SD2_CLK_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD2_CLK for ECSPI5_SCLK. */

/*! @brief Read current value of the IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI5_CSPI_CLK_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi5_miso_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi5_miso_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi5_miso_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI5_MISO_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x82CU)

#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi5_miso_select_input_t *) HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI5_MISO_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI5_MISO_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT0 for
 *     ECSPI5_MISO.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT0 for
 *     ECSPI5_MISO.
 */
/*@{*/
#define BP_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY_SD2_DATA0_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT0 for ECSPI5_MISO. */
#define BV_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY_SD1_DATA0_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT0 for ECSPI5_MISO. */

/*! @brief Read current value of the IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI5_MISO_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI5_MISO_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi5_mosi_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi5_mosi_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi5_mosi_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI5_MOSI_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x830U)

#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi5_mosi_select_input_t *) HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI5_MOSI_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI5_MOSI_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad SD1_CMD for
 *     ECSPI5_MOSI.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad SD2_CMD for
 *     ECSPI5_MOSI.
 */
/*@{*/
#define BP_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY_SD1_CMD_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD1_CMD for ECSPI5_MOSI. */
#define BV_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY_SD2_CMD_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD2_CMD for ECSPI5_MOSI. */

/*! @brief Read current value of the IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI5_MOSI_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi5_ss0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi5_ss0_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi5_ss0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI5_SS0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x834U)

#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi5_ss0_select_input_t *) HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI5_SS0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI5_SS0_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT1 for
 *     ECSPI5_SS0.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT1 for
 *     ECSPI5_SS0.
 */
/*@{*/
#define BP_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY_SD2_DATA1_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT1 for ECSPI5_SS0. */
#define BV_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY_SD1_DATA1_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT1 for ECSPI5_SS0. */

/*! @brief Read current value of the IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI5_SS0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI5_SS0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ecspi5_ss1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ecspi5_ss1_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ecspi5_ss1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ECSPI5_SS1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x838U)

#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT(x) (*(__IO hw_iomuxc_ecspi5_ss1_select_input_t *) HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_RD(x) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_WR(x, HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ECSPI5_SS1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ECSPI5_SS1_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT2 for
 *     ECSPI5_SS1.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT2 for
 *     ECSPI5_SS1.
 */
/*@{*/
#define BP_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY_SD2_DATA2_ALT1 (0U) /*!< Bit field value for IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD2_DAT2 for ECSPI5_SS1. */
#define BV_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY_SD1_DATA2_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD1_DAT2 for ECSPI5_SS1. */

/*! @brief Read current value of the IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY) & BM_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_WR(x, (HW_IOMUXC_ECSPI5_SS1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY) | BF_IOMUXC_ECSPI5_SS1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_ref_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_ref_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_ref_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_REF_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x83CU)

#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_ref_clk_select_input_t *) HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_REF_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_REF_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT7MUX Mode Select Field. mode of pad RGMII_TX_CTL for
 *     ENET_REF_CLK.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_16 for
 *     ENET_REF_CLK.
 */
/*@{*/
#define BP_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY_RGMII_TX_CTL_ALT7 (0U) /*!< Bit field value for IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY: Selecting ALT7MUX Mode Select Field. mode of pad RGMII_TX_CTL for ENET_REF_CLK. */
#define BV_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY_GPIO16_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_16 for ENET_REF_CLK. */

/*! @brief Read current value of the IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_REF_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_REF_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_mdio_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_mdio_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_mdio_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x840U)

#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_mdio_select_input_t *) HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad ENET_MDIO for
 *     ENET_MDIO.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL1 for ENET_MDIO.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY_ENET_MDIO_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad ENET_MDIO for ENET_MDIO. */
#define BV_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY_KEY_COL1_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL1 for ENET_MDIO. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_MDIO_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x844U)

#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_clk_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RXC for
 *     RGMII_RXC.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad GPIO_18 for
 *     ENET_RX_CLK.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY_RGMII_RXC_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RXC for RGMII_RXC. */
#define BV_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY_GPIO18_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad GPIO_18 for ENET_RX_CLK. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_data0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_data0_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_data0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x848U)

#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_data0_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD0 for
 *     RGMII_RD0.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad ENET_RXD0 for
 *     ENET_RX_DATA0.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY_RGMII_RD0_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD0 for RGMII_RD0. */
#define BV_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY_ENET_RX_DATA0_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad ENET_RXD0 for ENET_RX_DATA0. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_DATA0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_data1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_data1_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_data1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x84CU)

#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_data1_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD1 for
 *     RGMII_RD1.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad ENET_RXD1 for
 *     ENET_RX_DATA1.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY_RGMII_RD1_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD1 for RGMII_RD1. */
#define BV_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY_ENET_RX_DATA1_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad ENET_RXD1 for ENET_RX_DATA1. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_DATA1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_data2_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_data2_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_data2_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x850U)

#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_data2_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD2 for
 *     RGMII_RD2.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL2 for
 *     ENET_RX_DATA2.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY_RGMII_RD2_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD2 for RGMII_RD2. */
#define BV_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY_KEY_COL2_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL2 for ENET_RX_DATA2. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_DATA2_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_data3_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_data3_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_data3_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x854U)

#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_data3_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD3 for
 *     RGMII_RD3.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL0 for
 *     ENET_RX_DATA3.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY_RGMII_RD3_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RD3 for RGMII_RD3. */
#define BV_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY_KEY_COL0_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad KEY_COL0 for ENET_RX_DATA3. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_DATA3_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_enet_mac0_rx_en_select_input
{
    uint32_t U;
    struct _hw_iomuxc_enet_mac0_rx_en_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_enet_mac0_rx_en_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x858U)

#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT(x) (*(__IO hw_iomuxc_enet_mac0_rx_en_select_input_t *) HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_RD(x) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT(x).U)
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_WR(x, HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RX_CTL for
 *     RGMII_RX_CTL.
 * - 1 - Selecting ALT1MUX Mode Select Field. mode of pad ENET_CRS_DV for
 *     ENET_RX_EN.
 */
/*@{*/
#define BP_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY_RGMII_RX_CTL_ALT1 (0U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad RGMII_RX_CTL for RGMII_RX_CTL. */
#define BV_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY_ENET_CRS_DV_ALT1 (0x1U) /*!< Bit field value for IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad ENET_CRS_DV for ENET_RX_EN. */

/*! @brief Read current value of the IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY) & BM_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_WR(x, (HW_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY) | BF_IOMUXC_ENET_MAC0_RX_EN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_rx_fs_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_rx_fs_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_rx_fs_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_RX_FS_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x85CU)

#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_rx_fs_select_input_t *) HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_RX_FS_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_RX_FS_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_REF_CLK for
 *     ESAI_RX_FS.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_9 for ESAI_RX_FS.
 */
/*@{*/
#define BP_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY_ENET_REF_CLK_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_REF_CLK for ESAI_RX_FS. */
#define BV_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY_GPIO09_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_9 for ESAI_RX_FS. */

/*! @brief Read current value of the IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_RX_FS_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_RX_FS_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_tx_fs_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_tx_fs_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_tx_fs_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_TX_FS_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x860U)

#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_tx_fs_select_input_t *) HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_TX_FS_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_TX_FS_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_RXD1 for
 *     ESAI_TX_FS.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_2 for ESAI_TX_FS.
 */
/*@{*/
#define BP_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY_ENET_RX_DATA1_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_RXD1 for ESAI_TX_FS. */
#define BV_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY_GPIO02_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_2 for ESAI_TX_FS. */

/*! @brief Read current value of the IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_TX_FS_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_TX_FS_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_rx_hf_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_rx_hf_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_rx_hf_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x864U)

#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_rx_hf_clk_select_input_t *) HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_RX_ER for
 *     ESAI_RX_HF_CLK.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_3 for
 *     ESAI_RX_HF_CLK.
 */
/*@{*/
#define BP_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY_ENET_RX_ER_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_RX_ER for ESAI_RX_HF_CLK. */
#define BV_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY_GPIO03_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_3 for ESAI_RX_HF_CLK. */

/*! @brief Read current value of the IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_RX_HF_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_tx_hf_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_tx_hf_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_tx_hf_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x868U)

#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_tx_hf_clk_select_input_t *) HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_RXD0 for
 *     ESAI_TX_HF_CLK.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_4 for
 *     ESAI_TX_HF_CLK.
 */
/*@{*/
#define BP_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY_ENET_RX_DATA0_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_RXD0 for ESAI_TX_HF_CLK. */
#define BV_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY_GPIO04_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_4 for ESAI_TX_HF_CLK. */

/*! @brief Read current value of the IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_TX_HF_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_rx_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_rx_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_rx_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_RX_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x86CU)

#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_rx_clk_select_input_t *) HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_RX_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_RX_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_MDIO for
 *     ESAI_RX_CLK.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_1 for ESAI_RX_CLK.
 */
/*@{*/
#define BP_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY_ENET_MDIO_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_MDIO for ESAI_RX_CLK. */
#define BV_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY_GPIO01_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_1 for ESAI_RX_CLK. */

/*! @brief Read current value of the IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_RX_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_tx_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_tx_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_tx_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_TX_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x870U)

#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_tx_clk_select_input_t *) HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_TX_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_TX_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_CRS_DV for
 *     ESAI_TX_CLK.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_6 for ESAI_TX_CLK.
 */
/*@{*/
#define BP_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY_ENET_CRS_DV_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_CRS_DV for ESAI_TX_CLK. */
#define BV_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY_GPIO06_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_6 for ESAI_TX_CLK. */

/*! @brief Read current value of the IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_TX_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo0_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x874U)

#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo0_select_input_t *) HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO0_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_17 for ESAI_TX0.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad NANDF_CS2 for ESAI_TX0.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY_GPIO17_ALT0 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_17 for ESAI_TX0. */
#define BV_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY_NAND_CS2_B_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad NANDF_CS2 for ESAI_TX0. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo1_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x878U)

#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo1_select_input_t *) HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO1_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_18 for ESAI_TX1.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad NANDF_CS3 for ESAI_TX1.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY_GPIO18_ALT0 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_18 for ESAI_TX1. */
#define BV_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY_NAND_CS3_B_ALT2 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad NANDF_CS3 for ESAI_TX1. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo2_sdi3_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo2_sdi3_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo2_sdi3_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x87CU)

#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo2_sdi3_select_input_t *) HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_TXD1 for
 *     ESAI_TX2_RX3.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_5 for
 *     ESAI_TX2_RX3.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY_ENET_TX_DATA1_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_TXD1 for ESAI_TX2_RX3. */
#define BV_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY_GPIO05_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_5 for ESAI_TX2_RX3. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO2_SDI3_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo3_sdi2_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo3_sdi2_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo3_sdi2_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x880U)

#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo3_sdi2_select_input_t *) HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_TX_EN for
 *     ESAI_TX3_RX2.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_16 for
 *     ESAI_TX3_RX2.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY_ENET_TX_EN_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_TX_EN for ESAI_TX3_RX2. */
#define BV_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY_GPIO16_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_16 for ESAI_TX3_RX2. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO3_SDI2_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo4_sdi1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo4_sdi1_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo4_sdi1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x884U)

#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo4_sdi1_select_input_t *) HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_TXD0 for
 *     ESAI_TX4_RX1.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_7 for
 *     ESAI_TX4_RX1.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY_ENET_TX_DATA0_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_TXD0 for ESAI_TX4_RX1. */
#define BV_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY_GPIO07_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_7 for ESAI_TX4_RX1. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO4_SDI1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_esai_sdo5_sdi0_select_input
{
    uint32_t U;
    struct _hw_iomuxc_esai_sdo5_sdi0_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_esai_sdo5_sdi0_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x888U)

#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT(x) (*(__IO hw_iomuxc_esai_sdo5_sdi0_select_input_t *) HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_RD(x) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT(x).U)
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_WR(x, v) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_SET(x, v) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_WR(x, HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad ENET_MDC for
 *     ESAI_TX5_RX0.
 * - 1 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_8 for
 *     ESAI_TX5_RX0.
 */
/*@{*/
#define BP_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY_ENET_MDC_ALT2 (0U) /*!< Bit field value for IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad ENET_MDC for ESAI_TX5_RX0. */
#define BV_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY_GPIO08_ALT0 (0x1U) /*!< Bit field value for IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_8 for ESAI_TX5_RX0. */

/*! @brief Read current value of the IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY(x) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY) & BM_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_WR(x, (HW_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_RD(x) & ~BM_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY) | BF_IOMUXC_ESAI_SDO5_SDI0_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_hdmi_icecin_select_input
{
    uint32_t U;
    struct _hw_iomuxc_hdmi_icecin_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_hdmi_icecin_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_HDMI_ICECIN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x88CU)

#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT(x) (*(__IO hw_iomuxc_hdmi_icecin_select_input_t *) HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_RD(x) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT(x).U)
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_HDMI_ICECIN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_HDMI_ICECIN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_A25 for
 *     HDMI_TX_CEC_LINE.
 * - 1 - Selecting ALT6MUX Mode Select Field. mode of pad KEY_ROW2 for
 *     HDMI_TX_CEC_LINE.
 */
/*@{*/
#define BP_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY_EIM_ADDR25_ALT6 (0U) /*!< Bit field value for IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_A25 for HDMI_TX_CEC_LINE. */
#define BV_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY_KEY_ROW2_ALT6 (0x1U) /*!< Bit field value for IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad KEY_ROW2 for HDMI_TX_CEC_LINE. */

/*! @brief Read current value of the IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY) & BM_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_WR(x, (HW_IOMUXC_HDMI_ICECIN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY) | BF_IOMUXC_HDMI_ICECIN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_hdmi_ii2c_clkin_select_input
{
    uint32_t U;
    struct _hw_iomuxc_hdmi_ii2c_clkin_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_hdmi_ii2c_clkin_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x890U)

#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT(x) (*(__IO hw_iomuxc_hdmi_ii2c_clkin_select_input_t *) HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_RD(x) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT(x).U)
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB2 for
 *     HDMI_TX_DDC_SCL.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL3 for
 *     HDMI_TX_DDC_SCL.
 */
/*@{*/
#define BP_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY_EIM_EB2_B_ALT4 (0U) /*!< Bit field value for IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB2 for HDMI_TX_DDC_SCL. */
#define BV_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY_KEY_COL3_ALT2 (0x1U) /*!< Bit field value for IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL3 for HDMI_TX_DDC_SCL. */

/*! @brief Read current value of the IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY) & BM_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_WR(x, (HW_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY) | BF_IOMUXC_HDMI_II2C_CLKIN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_hdmi_ii2c_datain_select_input
{
    uint32_t U;
    struct _hw_iomuxc_hdmi_ii2c_datain_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_hdmi_ii2c_datain_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x894U)

#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT(x) (*(__IO hw_iomuxc_hdmi_ii2c_datain_select_input_t *) HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_RD(x) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT(x).U)
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_WR(x, HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D16 for
 *     HDMI_TX_DDC_SDA.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW3 for
 *     HDMI_TX_DDC_SDA.
 */
/*@{*/
#define BP_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY_EIM_DATA16_ALT4 (0U) /*!< Bit field value for IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D16 for HDMI_TX_DDC_SDA. */
#define BV_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY_KEY_ROW3_ALT2 (0x1U) /*!< Bit field value for IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_ROW3 for HDMI_TX_DDC_SDA. */

/*! @brief Read current value of the IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY) & BM_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_WR(x, (HW_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY) | BF_IOMUXC_HDMI_II2C_DATAIN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c1_scl_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c1_scl_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_i2c1_scl_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C1_SCL_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x898U)

#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c1_scl_in_select_input_t *) HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C1_SCL_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C1_SCL_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D21 for I2C1_SCL.
 * - 1 - Selecting ALT4MUX Mode Select Field. mode of pad CSI0_DAT9 for I2C1_SCL.
 */
/*@{*/
#define BP_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY_EIM_DATA21_ALT6 (0U) /*!< Bit field value for IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D21 for I2C1_SCL. */
#define BV_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY_CSI0_DATA09_ALT4 (0x1U) /*!< Bit field value for IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad CSI0_DAT9 for I2C1_SCL. */

/*! @brief Read current value of the IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C1_SCL_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c1_sda_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c1_sda_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_i2c1_sda_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C1_SDA_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x89CU)

#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c1_sda_in_select_input_t *) HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C1_SDA_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C1_SDA_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT1MUX Mode Select Field. mode of pad EIM_D28 for I2C1_SDA.
 * - 1 - Selecting ALT4MUX Mode Select Field. mode of pad CSI0_DAT8 for I2C1_SDA.
 */
/*@{*/
#define BP_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY_EIM_DATA28_ALT1 (0U) /*!< Bit field value for IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad EIM_D28 for I2C1_SDA. */
#define BV_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY_CSI0_DATA08_ALT4 (0x1U) /*!< Bit field value for IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad CSI0_DAT8 for I2C1_SDA. */

/*! @brief Read current value of the IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C1_SDA_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c2_scl_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c2_scl_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_i2c2_scl_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C2_SCL_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8A0U)

#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c2_scl_in_select_input_t *) HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C2_SCL_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C2_SCL_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_EB2 for I2C2_SCL.
 * - 1 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL3 for I2C2_SCL.
 */
/*@{*/
#define BP_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY_EIM_EB2_B_ALT6 (0U) /*!< Bit field value for IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_EB2 for I2C2_SCL. */
#define BV_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY_KEY_COL3_ALT4 (0x1U) /*!< Bit field value for IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL3 for I2C2_SCL. */

/*! @brief Read current value of the IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C2_SCL_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c2_sda_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c2_sda_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_i2c2_sda_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C2_SDA_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8A4U)

#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c2_sda_in_select_input_t *) HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C2_SDA_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C2_SDA_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D16 for I2C2_SDA.
 * - 1 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW3 for I2C2_SDA.
 */
/*@{*/
#define BP_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY_EIM_DATA16_ALT6 (0U) /*!< Bit field value for IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D16 for I2C2_SDA. */
#define BV_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY_KEY_ROW3_ALT4 (0x1U) /*!< Bit field value for IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW3 for I2C2_SDA. */

/*! @brief Read current value of the IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C2_SDA_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c3_scl_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c3_scl_in_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_i2c3_scl_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C3_SCL_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8A8U)

#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c3_scl_in_select_input_t *) HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C3_SCL_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C3_SCL_IN_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D17 for I2C3_SCL.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_3 for I2C3_SCL.
 * - 10 - Selecting ALT6MUX Mode Select Field. mode of pad GPIO_5 for I2C3_SCL.
 */
/*@{*/
#define BP_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY_EIM_DATA17_ALT6 (0U) /*!< Bit field value for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D17 for I2C3_SCL. */
#define BV_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY_GPIO03_ALT2 (0x1U) /*!< Bit field value for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_3 for I2C3_SCL. */
#define BV_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY_GPIO05_ALT6 (0x2U) /*!< Bit field value for IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad GPIO_5 for I2C3_SCL. */

/*! @brief Read current value of the IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C3_SCL_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_i2c3_sda_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_i2c3_sda_in_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_i2c3_sda_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_I2C3_SDA_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8ACU)

#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_i2c3_sda_in_select_input_t *) HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_I2C3_SDA_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_I2C3_SDA_IN_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D18 for I2C3_SDA.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_6 for I2C3_SDA.
 * - 10 - Selecting ALT6MUX Mode Select Field. mode of pad GPIO_16 for I2C3_SDA.
 */
/*@{*/
#define BP_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY_EIM_DATA18_ALT6 (0U) /*!< Bit field value for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D18 for I2C3_SDA. */
#define BV_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY_GPIO06_ALT2 (0x1U) /*!< Bit field value for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_6 for I2C3_SDA. */
#define BV_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY_GPIO16_ALT6 (0x2U) /*!< Bit field value for IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad GPIO_16 for I2C3_SDA. */

/*! @brief Read current value of the IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_I2C3_SDA_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data10_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data10_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data10_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8B0U)

#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data10_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D22 for
 *     IPU2_CSI1_DATA10.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB1 for
 *     IPU2_CSI1_DATA10.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY_EIM_DATA22_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D22 for IPU2_CSI1_DATA10. */
#define BV_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY_EIM_EB1_B_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB1 for IPU2_CSI1_DATA10. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA10_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data11_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data11_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data11_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8B4U)

#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data11_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D21 for
 *     IPU2_CSI1_DATA11.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB0 for
 *     IPU2_CSI1_DATA11.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY_EIM_DATA21_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D21 for IPU2_CSI1_DATA11. */
#define BV_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY_EIM_EB0_B_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB0 for IPU2_CSI1_DATA11. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA11_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data12_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data12_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data12_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8B8U)

#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data12_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D28 for
 *     IPU2_CSI1_DATA12.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A17 for
 *     IPU2_CSI1_DATA12.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY_EIM_DATA28_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D28 for IPU2_CSI1_DATA12. */
#define BV_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY_EIM_ADDR17_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A17 for IPU2_CSI1_DATA12. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA12_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data13_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data13_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data13_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8BCU)

#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data13_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D27 for
 *     IPU2_CSI1_DATA13.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A18 for
 *     IPU2_CSI1_DATA13.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY_EIM_DATA27_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D27 for IPU2_CSI1_DATA13. */
#define BV_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY_EIM_ADDR18_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A18 for IPU2_CSI1_DATA13. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA13_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data14_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data14_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data14_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8C0U)

#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data14_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D26 for
 *     IPU2_CSI1_DATA14.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A19 for
 *     IPU2_CSI1_DATA14.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY_EIM_DATA26_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D26 for IPU2_CSI1_DATA14. */
#define BV_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY_EIM_ADDR19_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A19 for IPU2_CSI1_DATA14. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA14_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data15_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data15_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data15_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8C4U)

#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data15_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D20 for
 *     IPU2_CSI1_DATA15.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A20 for
 *     IPU2_CSI1_DATA15.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY_EIM_DATA20_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D20 for IPU2_CSI1_DATA15. */
#define BV_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY_EIM_ADDR20_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A20 for IPU2_CSI1_DATA15. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA15_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data16_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data16_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data16_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8C8U)

#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data16_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D19 for
 *     IPU2_CSI1_DATA16.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A21 for
 *     IPU2_CSI1_DATA16.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY_EIM_DATA19_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D19 for IPU2_CSI1_DATA16. */
#define BV_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY_EIM_ADDR21_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A21 for IPU2_CSI1_DATA16. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA16_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data17_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data17_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data17_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8CCU)

#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data17_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D18 for
 *     IPU2_CSI1_DATA17.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A22 for
 *     IPU2_CSI1_DATA17.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY_EIM_DATA18_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D18 for IPU2_CSI1_DATA17. */
#define BV_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY_EIM_ADDR22_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A22 for IPU2_CSI1_DATA17. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA17_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data18_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data18_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data18_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8D0U)

#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data18_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D16 for
 *     IPU2_CSI1_DATA18.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A23 for
 *     IPU2_CSI1_DATA18.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY_EIM_DATA16_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D16 for IPU2_CSI1_DATA18. */
#define BV_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY_EIM_ADDR23_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A23 for IPU2_CSI1_DATA18. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA18_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data19_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data19_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data19_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8D4U)

#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data19_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_EB2 for
 *     IPU2_CSI1_DATA19.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A24 for
 *     IPU2_CSI1_DATA19.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY_EIM_EB2_B_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_EB2 for IPU2_CSI1_DATA19. */
#define BV_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY_EIM_ADDR24_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A24 for IPU2_CSI1_DATA19. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA19_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_data_en_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_data_en_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_data_en_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8D8U)

#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_data_en_select_input_t *) HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D23 for
 *     IPU2_CSI1_DATA_EN.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA10 for
 *     IPU2_CSI1_DATA_EN.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY_EIM_DATA23_ALT4 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D23 for IPU2_CSI1_DATA_EN. */
#define BV_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY_EIM_AD10_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA10 for IPU2_CSI1_DATA_EN. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_DATA_EN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_hsync_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_hsync_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_hsync_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8DCU)

#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_hsync_select_input_t *) HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB3 for
 *     IPU2_CSI1_HSYNC.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA11 for
 *     IPU2_CSI1_HSYNC.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY_EIM_EB3_B_ALT4 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_EB3 for IPU2_CSI1_HSYNC. */
#define BV_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY_EIM_AD11_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA11 for IPU2_CSI1_HSYNC. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_HSYNC_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_pix_clk_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_pix_clk_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_pix_clk_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8E0U)

#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_pix_clk_select_input_t *) HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad EIM_D17 for
 *     IPU2_CSI1_PIXCLK.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_A16 for
 *     IPU2_CSI1_PIXCLK.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY_EIM_DATA17_ALT3 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad EIM_D17 for IPU2_CSI1_PIXCLK. */
#define BV_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY_EIM_ADDR16_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_A16 for IPU2_CSI1_PIXCLK. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_PIX_CLK_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_ipu2_sens1_vsync_select_input
{
    uint32_t U;
    struct _hw_iomuxc_ipu2_sens1_vsync_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_ipu2_sens1_vsync_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8E4U)

#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT(x) (*(__IO hw_iomuxc_ipu2_sens1_vsync_select_input_t *) HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_RD(x) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT(x).U)
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_WR(x, v) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_SET(x, v) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_WR(x, HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D29 for
 *     IPU2_CSI1_VSYNC.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA12 for
 *     IPU2_CSI1_VSYNC.
 */
/*@{*/
#define BP_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY_EIM_DATA29_ALT6 (0U) /*!< Bit field value for IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D29 for IPU2_CSI1_VSYNC. */
#define BV_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY_EIM_AD12_ALT2 (0x1U) /*!< Bit field value for IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_DA12 for IPU2_CSI1_VSYNC. */

/*! @brief Read current value of the IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY(x) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY) & BM_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_WR(x, (HW_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_RD(x) & ~BM_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY) | BF_IOMUXC_IPU2_SENS1_VSYNC_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_COL5_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_COL5_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_col5_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_col5_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_col5_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_COL5_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8E8U)

#define HW_IOMUXC_KEY_COL5_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_col5_select_input_t *) HW_IOMUXC_KEY_COL5_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_COL5_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_COL5_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_COL5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL5_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_COL5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL5_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_COL5_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_COL5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL5_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_COL5_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_COL5_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_0 for KEY_COL5.
 * - 01 - Selecting ALT0MUX Mode Select Field. mode of pad GPIO_19 for KEY_COL5.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT4 for
 *     KEY_COL5.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad SD2_CLK for KEY_COL5.
 */
/*@{*/
#define BP_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY_GPIO00_ALT2 (0U) /*!< Bit field value for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_0 for KEY_COL5. */
#define BV_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY_GPIO19_ALT0 (0x1U) /*!< Bit field value for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad GPIO_19 for KEY_COL5. */
#define BV_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY_CSI0_DATA04_ALT3 (0x2U) /*!< Bit field value for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT4 for KEY_COL5. */
#define BV_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY_SD2_CLK_ALT2 (0x3U) /*!< Bit field value for IOMUXC_KEY_COL5_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD2_CLK for KEY_COL5. */

/*! @brief Read current value of the IOMUXC_KEY_COL5_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_COL5_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_COL5_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_COL5_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_COL5_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_COL5_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_COL6_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_COL6_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_col6_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_col6_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_col6_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_COL6_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8ECU)

#define HW_IOMUXC_KEY_COL6_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_col6_select_input_t *) HW_IOMUXC_KEY_COL6_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_COL6_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_COL6_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_COL6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL6_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_COL6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL6_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_COL6_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_COL6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL6_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_COL6_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_COL6_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_9 for KEY_COL6.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT6 for
 *     KEY_COL6.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad SD2_DAT3 for KEY_COL6.
 */
/*@{*/
#define BP_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY_GPIO09_ALT2 (0U) /*!< Bit field value for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_9 for KEY_COL6. */
#define BV_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY_CSI0_DATA06_ALT3 (0x1U) /*!< Bit field value for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT6 for KEY_COL6. */
#define BV_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY_SD2_DATA3_ALT2 (0x2U) /*!< Bit field value for IOMUXC_KEY_COL6_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD2_DAT3 for KEY_COL6. */

/*! @brief Read current value of the IOMUXC_KEY_COL6_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_COL6_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_COL6_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_COL6_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_COL6_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_COL6_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_COL7_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_COL7_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_col7_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_col7_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_col7_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_COL7_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8F0U)

#define HW_IOMUXC_KEY_COL7_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_col7_select_input_t *) HW_IOMUXC_KEY_COL7_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_COL7_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_COL7_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_COL7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL7_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_COL7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL7_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_COL7_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_COL7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_COL7_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_COL7_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_COL7_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT1 for KEY_COL7.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_4 for KEY_COL7.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT8 for
 *     KEY_COL7.
 */
/*@{*/
#define BP_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY_SD2_DATA1_ALT4 (0U) /*!< Bit field value for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT1 for KEY_COL7. */
#define BV_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY_GPIO04_ALT2 (0x1U) /*!< Bit field value for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_4 for KEY_COL7. */
#define BV_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY_CSI0_DATA08_ALT3 (0x2U) /*!< Bit field value for IOMUXC_KEY_COL7_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT8 for KEY_COL7. */

/*! @brief Read current value of the IOMUXC_KEY_COL7_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_COL7_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_COL7_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_COL7_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_COL7_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_COL7_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_ROW5_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_ROW5_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_row5_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_row5_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_row5_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_ROW5_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8F4U)

#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_row5_select_input_t *) HW_IOMUXC_KEY_ROW5_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW5_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW5_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_ROW5_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW5_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_ROW5_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_ROW5_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_1 for KEY_ROW5.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT5 for
 *     KEY_ROW5.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad SD2_CMD for KEY_ROW5.
 */
/*@{*/
#define BP_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY_GPIO01_ALT2 (0U) /*!< Bit field value for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_1 for KEY_ROW5. */
#define BV_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY_CSI0_DATA05_ALT3 (0x1U) /*!< Bit field value for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT5 for KEY_ROW5. */
#define BV_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY_SD2_CMD_ALT2 (0x2U) /*!< Bit field value for IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD2_CMD for KEY_ROW5. */

/*! @brief Read current value of the IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_ROW5_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_ROW5_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_ROW5_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_ROW6_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_ROW6_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_row6_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_row6_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_row6_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_ROW6_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8F8U)

#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_row6_select_input_t *) HW_IOMUXC_KEY_ROW6_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW6_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW6_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_ROW6_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW6_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_ROW6_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_ROW6_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT2 for KEY_ROW6.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_2 for KEY_ROW6.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT7 for
 *     KEY_ROW6.
 */
/*@{*/
#define BP_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY_SD2_DATA2_ALT4 (0U) /*!< Bit field value for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT2 for KEY_ROW6. */
#define BV_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY_GPIO02_ALT2 (0x1U) /*!< Bit field value for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_2 for KEY_ROW6. */
#define BV_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY_CSI0_DATA07_ALT3 (0x2U) /*!< Bit field value for IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT7 for KEY_ROW6. */

/*! @brief Read current value of the IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_ROW6_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_ROW6_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_ROW6_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_KEY_ROW7_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_KEY_ROW7_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_key_row7_select_input
{
    uint32_t U;
    struct _hw_iomuxc_key_row7_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_key_row7_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_KEY_ROW7_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x8FCU)

#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT(x) (*(__IO hw_iomuxc_key_row7_select_input_t *) HW_IOMUXC_KEY_ROW7_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_RD(x) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT(x).U)
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_WR(x, v) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_SET(x, v) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW7_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW7_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_KEY_ROW7_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT_WR(x, HW_IOMUXC_KEY_ROW7_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_KEY_ROW7_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_KEY_ROW7_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT0 for KEY_ROW7.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad GPIO_5 for KEY_ROW7.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT9 for
 *     KEY_ROW7.
 */
/*@{*/
#define BP_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY_SD2_DATA0_ALT4 (0U) /*!< Bit field value for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad SD2_DAT0 for KEY_ROW7. */
#define BV_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY_GPIO05_ALT2 (0x1U) /*!< Bit field value for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad GPIO_5 for KEY_ROW7. */
#define BV_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY_CSI0_DATA09_ALT3 (0x2U) /*!< Bit field value for IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT9 for KEY_ROW7. */

/*! @brief Read current value of the IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY(x) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY) & BM_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_KEY_ROW7_SELECT_INPUT_WR(x, (HW_IOMUXC_KEY_ROW7_SELECT_INPUT_RD(x) & ~BM_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY) | BF_IOMUXC_KEY_ROW7_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_mlb_mlb_clk_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_mlb_mlb_clk_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_mlb_mlb_clk_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x900U)

#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_mlb_mlb_clk_in_select_input_t *) HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad ENET_TXD1 for MLB_CLK.
 * - 1 - Selecting ALT7MUX Mode Select Field. mode of pad GPIO_3 for MLB_CLK.
 */
/*@{*/
#define BP_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY_ENET_TX_DATA1_ALT0 (0U) /*!< Bit field value for IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad ENET_TXD1 for MLB_CLK. */
#define BV_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY_GPIO03_ALT7 (0x1U) /*!< Bit field value for IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY: Selecting ALT7MUX Mode Select Field. mode of pad GPIO_3 for MLB_CLK. */

/*! @brief Read current value of the IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_MLB_MLB_CLK_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_mlb_mlb_data_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_mlb_mlb_data_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_mlb_mlb_data_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x904U)

#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_mlb_mlb_data_in_select_input_t *) HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad ENET_MDC for MLB_DATA.
 * - 1 - Selecting ALT7MUX Mode Select Field. mode of pad GPIO_2 for MLB_DATA.
 */
/*@{*/
#define BP_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY_ENET_MDC_ALT0 (0U) /*!< Bit field value for IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad ENET_MDC for MLB_DATA. */
#define BV_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY_GPIO02_ALT7 (0x1U) /*!< Bit field value for IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY: Selecting ALT7MUX Mode Select Field. mode of pad GPIO_2 for MLB_DATA. */

/*! @brief Read current value of the IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_MLB_MLB_DATA_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_mlb_mlb_sig_in_select_input
{
    uint32_t U;
    struct _hw_iomuxc_mlb_mlb_sig_in_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_mlb_mlb_sig_in_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x908U)

#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT(x) (*(__IO hw_iomuxc_mlb_mlb_sig_in_select_input_t *) HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_RD(x) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT(x).U)
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_WR(x, v) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_SET(x, v) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_WR(x, HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT0MUX Mode Select Field. mode of pad ENET_RXD1 for MLB_SIG.
 * - 1 - Selecting ALT7MUX Mode Select Field. mode of pad GPIO_6 for MLB_SIG.
 */
/*@{*/
#define BP_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY_ENET_RX_DATA1_ALT0 (0U) /*!< Bit field value for IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY: Selecting ALT0MUX Mode Select Field. mode of pad ENET_RXD1 for MLB_SIG. */
#define BV_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY_GPIO06_ALT7 (0x1U) /*!< Bit field value for IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY: Selecting ALT7MUX Mode Select Field. mode of pad GPIO_6 for MLB_SIG. */

/*! @brief Read current value of the IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY(x) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY) & BM_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_WR(x, (HW_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_RD(x) & ~BM_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY) | BF_IOMUXC_MLB_MLB_SIG_IN_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sdma_events14_select_input
{
    uint32_t U;
    struct _hw_iomuxc_sdma_events14_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_sdma_events14_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_SDMA_EVENTS14_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x90CU)

#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT(x) (*(__IO hw_iomuxc_sdma_events14_select_input_t *) HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_RD(x) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT(x).U)
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_WR(x, v) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_SET(x, v) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SDMA_EVENTS14_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_SDMA_EVENTS14_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT16 for
 *     SDMA_EXT_EVENT0.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad GPIO_17 for
 *     SDMA_EXT_EVENT0.
 */
/*@{*/
#define BP_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY_DISP0_DATA16_ALT4 (0U) /*!< Bit field value for IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT16 for SDMA_EXT_EVENT0. */
#define BV_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY_GPIO17_ALT3 (0x1U) /*!< Bit field value for IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad GPIO_17 for SDMA_EXT_EVENT0. */

/*! @brief Read current value of the IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY(x) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY) & BM_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_WR(x, (HW_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_RD(x) & ~BM_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY) | BF_IOMUXC_SDMA_EVENTS14_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_sdma_events47_select_input
{
    uint32_t U;
    struct _hw_iomuxc_sdma_events47_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_sdma_events47_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_SDMA_EVENTS47_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x910U)

#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT(x) (*(__IO hw_iomuxc_sdma_events47_select_input_t *) HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_RD(x) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT(x).U)
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_WR(x, v) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_SET(x, v) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_WR(x, HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SDMA_EVENTS47_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_SDMA_EVENTS47_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT17 for
 *     SDMA_EXT_EVENT1.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad GPIO_18 for
 *     SDMA_EXT_EVENT1.
 */
/*@{*/
#define BP_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY_DISP0_DATA17_ALT4 (0U) /*!< Bit field value for IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad DISP0_DAT17 for SDMA_EXT_EVENT1. */
#define BV_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY_GPIO18_ALT3 (0x1U) /*!< Bit field value for IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad GPIO_18 for SDMA_EXT_EVENT1. */

/*! @brief Read current value of the IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY(x) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY) & BM_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_WR(x, (HW_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_RD(x) & ~BM_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY) | BF_IOMUXC_SDMA_EVENTS47_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_spdif_spdif_in1_select_input
{
    uint32_t U;
    struct _hw_iomuxc_spdif_spdif_in1_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_spdif_spdif_in1_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x914U)

#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT(x) (*(__IO hw_iomuxc_spdif_spdif_in1_select_input_t *) HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_RD(x) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT(x).U)
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_WR(x, v) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_SET(x, v) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 00 - Selecting ALT7MUX Mode Select Field. mode of pad EIM_D21 for SPDIF_IN.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad ENET_RX_ER for
 *     SPDIF_IN.
 * - 10 - Selecting ALT6MUX Mode Select Field. mode of pad KEY_COL3 for SPDIF_IN.
 * - 11 - Selecting ALT4MUX Mode Select Field. mode of pad GPIO_16 for SPDIF_IN.
 */
/*@{*/
#define BP_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY_EIM_DATA21_ALT7 (0U) /*!< Bit field value for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY: Selecting ALT7MUX Mode Select Field. mode of pad EIM_D21 for SPDIF_IN. */
#define BV_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY_ENET_RX_ER_ALT3 (0x1U) /*!< Bit field value for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad ENET_RX_ER for SPDIF_IN. */
#define BV_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY_KEY_COL3_ALT6 (0x2U) /*!< Bit field value for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad KEY_COL3 for SPDIF_IN. */
#define BV_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY_GPIO16_ALT4 (0x3U) /*!< Bit field value for IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad GPIO_16 for SPDIF_IN. */

/*! @brief Read current value of the IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY(x) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY) & BM_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_WR(x, (HW_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_RD(x) & ~BM_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY) | BF_IOMUXC_SPDIF_SPDIF_IN1_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_spdif_tx_clk2_select_input
{
    uint32_t U;
    struct _hw_iomuxc_spdif_tx_clk2_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_spdif_tx_clk2_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x918U)

#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT(x) (*(__IO hw_iomuxc_spdif_tx_clk2_select_input_t *) HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_RD(x) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT(x).U)
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_WR(x, v) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_SET(x, v) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_WR(x, HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT2MUX Mode Select Field. mode of pad RGMII_TXC for
 *     SPDIF_EXT_CLK.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad ENET_CRS_DV for
 *     SPDIF_EXT_CLK.
 */
/*@{*/
#define BP_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY_RGMII_TXC_ALT2 (0U) /*!< Bit field value for IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad RGMII_TXC for SPDIF_EXT_CLK. */
#define BV_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY_ENET_CRS_DV_ALT3 (0x1U) /*!< Bit field value for IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad ENET_CRS_DV for SPDIF_EXT_CLK. */

/*! @brief Read current value of the IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY(x) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY) & BM_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_WR(x, (HW_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_RD(x) & ~BM_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY) | BF_IOMUXC_SPDIF_TX_CLK2_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart1_uart_rts_b_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart1_uart_rts_b_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart1_uart_rts_b_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART1_UART_RTS_B_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x91CU)

#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart1_uart_rts_b_select_input_t *) HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_RD(x) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART1_UART_RTS_B_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART1_UART_RTS_B_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RTS_B signal to pad when UART
 * is in DCE mode. Route CTS_B signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D19 for
 *     UART1_CTS_B.
 * - 01 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D20 for
 *     UART1_RTS_B.
 * - 10 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT0 for
 *     UART1_CTS_B.
 * - 11 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT1 for
 *     UART1_RTS_B.
 */
/*@{*/
#define BP_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA19_ALT4 (0U) /*!< Bit field value for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D19 for UART1_CTS_B. */
#define BV_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA20_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D20 for UART1_RTS_B. */
#define BV_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY_SD3_DATA0_ALT1 (0x2U) /*!< Bit field value for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT0 for UART1_CTS_B. */
#define BV_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY_SD3_DATA1_ALT1 (0x3U) /*!< Bit field value for IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT1 for UART1_RTS_B. */

/*! @brief Read current value of the IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY) & BM_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_WR(x, (HW_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY) | BF_IOMUXC_UART1_UART_RTS_B_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart1_uart_rx_data_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart1_uart_rx_data_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart1_uart_rx_data_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x920U)

#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart1_uart_rx_data_select_input_t *) HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_RD(x) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RX_DATA signal to pad when UART
 * is in DCE mode. Route TX_DATA signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT10 for
 *     UART1_TX_DATA.
 * - 01 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT11 for
 *     UART1_RX_DATA.
 * - 10 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT7 for
 *     UART1_TX_DATA.
 * - 11 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT6 for
 *     UART1_RX_DATA.
 */
/*@{*/
#define BP_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA10_ALT3 (0U) /*!< Bit field value for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT10 for UART1_TX_DATA. */
#define BV_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA11_ALT3 (0x1U) /*!< Bit field value for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT11 for UART1_RX_DATA. */
#define BV_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY_SD3_DATA7_ALT1 (0x2U) /*!< Bit field value for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT7 for UART1_TX_DATA. */
#define BV_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY_SD3_DATA6_ALT1 (0x3U) /*!< Bit field value for IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT6 for UART1_RX_DATA. */

/*! @brief Read current value of the IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY) & BM_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(x, (HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY) | BF_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart2_uart_rts_b_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart2_uart_rts_b_select_input_bitfields
    {
        uint32_t DAISY : 3;            /*!< [2:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_iomuxc_uart2_uart_rts_b_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART2_UART_RTS_B_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x924U)

#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart2_uart_rts_b_select_input_t *) HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_RD(x) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART2_UART_RTS_B_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART2_UART_RTS_B_SELECT_INPUT, field DAISY[2:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RTS_B signal to pad when UART
 * is in DCE mode. Route CTS_B signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 000 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D28 for
 *     UART2_CTS_B.
 * - 001 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D29 for
 *     UART2_RTS_B.
 * - 010 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_CMD for
 *     UART2_CTS_B.
 * - 011 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_CLK for
 *     UART2_RTS_B.
 * - 100 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT5 for
 *     UART2_RTS_B.
 * - 101 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT6 for
 *     UART2_CTS_B.
 */
/*@{*/
#define BP_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY (0x00000007U) /*!< Bit mask for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY (3U) /*!< Bit field size in bits for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA28_ALT4 (0U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D28 for UART2_CTS_B. */
#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA29_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D29 for UART2_RTS_B. */
#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_SD3_CMD_ALT1 (0x2U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_CMD for UART2_CTS_B. */
#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_SD3_CLK_ALT1 (0x3U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_CLK for UART2_RTS_B. */
#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_SD4_DATA5_ALT2 (0x4U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT5 for UART2_RTS_B. */
#define BV_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY_SD4_DATA6_ALT2 (0x5U) /*!< Bit field value for IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT6 for UART2_CTS_B. */

/*! @brief Read current value of the IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY) & BM_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_WR(x, (HW_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY) | BF_IOMUXC_UART2_UART_RTS_B_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart2_uart_rx_data_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart2_uart_rx_data_select_input_bitfields
    {
        uint32_t DAISY : 3;            /*!< [2:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_iomuxc_uart2_uart_rx_data_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x928U)

#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart2_uart_rx_data_select_input_t *) HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_RD(x) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT, field DAISY[2:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RX_DATA signal to pad when UART
 * is in DCE mode. Route TX_DATA signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 000 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D26 for
 *     UART2_TX_DATA.
 * - 001 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D27 for
 *     UART2_RX_DATA.
 * - 010 - Selecting ALT4MUX Mode Select Field. mode of pad GPIO_7 for
 *     UART2_TX_DATA.
 * - 011 - Selecting ALT4MUX Mode Select Field. mode of pad GPIO_8 for
 *     UART2_RX_DATA.
 * - 100 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT5 for
 *     UART2_TX_DATA.
 * - 101 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT4 for
 *     UART2_RX_DATA.
 * - 110 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT4 for
 *     UART2_RX_DATA.
 * - 111 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT7 for
 *     UART2_TX_DATA.
 */
/*@{*/
#define BP_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY (0x00000007U) /*!< Bit mask for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY (3U) /*!< Bit field size in bits for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_EIM_DATA26_ALT4 (0U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D26 for UART2_TX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_EIM_DATA27_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D27 for UART2_RX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_GPIO07_ALT4 (0x2U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad GPIO_7 for UART2_TX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_GPIO08_ALT4 (0x3U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad GPIO_8 for UART2_RX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_SD3_DATA5_ALT1 (0x4U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT5 for UART2_TX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_SD3_DATA4_ALT1 (0x5U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT4 for UART2_RX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_SD4_DATA4_ALT2 (0x6U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT4 for UART2_RX_DATA. */
#define BV_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_SD4_DATA7_ALT2 (0x7U) /*!< Bit field value for IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_DAT7 for UART2_TX_DATA. */

/*! @brief Read current value of the IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY) & BM_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(x, (HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY) | BF_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart3_uart_rts_b_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart3_uart_rts_b_select_input_bitfields
    {
        uint32_t DAISY : 3;            /*!< [2:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_iomuxc_uart3_uart_rts_b_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART3_UART_RTS_B_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x92CU)

#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart3_uart_rts_b_select_input_t *) HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_RD(x) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART3_UART_RTS_B_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART3_UART_RTS_B_SELECT_INPUT, field DAISY[2:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RTS_B signal to pad when UART
 * is in DCE mode. Route CTS_B signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 000 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_D23 for
 *     UART3_CTS_B.
 * - 001 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB3 for
 *     UART3_RTS_B.
 * - 010 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D30 for
 *     UART3_CTS_B.
 * - 011 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D31 for
 *     UART3_RTS_B.
 * - 100 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT3 for
 *     UART3_CTS_B.
 * - 101 - Selecting ALT1MUX Mode Select Field. mode of pad SD3_RST for
 *     UART3_RTS_B.
 */
/*@{*/
#define BP_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY (0x00000007U) /*!< Bit mask for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY (3U) /*!< Bit field size in bits for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA23_ALT2 (0U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_D23 for UART3_CTS_B. */
#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_EIM_EB3_B_ALT2 (0x1U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_EB3 for UART3_RTS_B. */
#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA30_ALT4 (0x2U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D30 for UART3_CTS_B. */
#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_EIM_DATA31_ALT4 (0x3U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D31 for UART3_RTS_B. */
#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_SD3_DATA3_ALT1 (0x4U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_DAT3 for UART3_CTS_B. */
#define BV_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY_SD3_RESET_ALT1 (0x5U) /*!< Bit field value for IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT1MUX Mode Select Field. mode of pad SD3_RST for UART3_RTS_B. */

/*! @brief Read current value of the IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY) & BM_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_WR(x, (HW_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY) | BF_IOMUXC_UART3_UART_RTS_B_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart3_uart_rx_data_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart3_uart_rx_data_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart3_uart_rx_data_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x930U)

#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart3_uart_rx_data_select_input_t *) HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_RD(x) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RX_DATA signal to pad when UART
 * is in DCE mode. Route TX_DATA signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_D24 for
 *     UART3_TX_DATA.
 * - 01 - Selecting ALT2MUX Mode Select Field. mode of pad EIM_D25 for
 *     UART3_RX_DATA.
 * - 10 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_CMD for
 *     UART3_TX_DATA.
 * - 11 - Selecting ALT2MUX Mode Select Field. mode of pad SD4_CLK for
 *     UART3_RX_DATA.
 */
/*@{*/
#define BP_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY_EIM_DATA24_ALT2 (0U) /*!< Bit field value for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_D24 for UART3_TX_DATA. */
#define BV_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY_EIM_DATA25_ALT2 (0x1U) /*!< Bit field value for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad EIM_D25 for UART3_RX_DATA. */
#define BV_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY_SD4_CMD_ALT2 (0x2U) /*!< Bit field value for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_CMD for UART3_TX_DATA. */
#define BV_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY_SD4_CLK_ALT2 (0x3U) /*!< Bit field value for IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad SD4_CLK for UART3_RX_DATA. */

/*! @brief Read current value of the IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY) & BM_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_WR(x, (HW_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY) | BF_IOMUXC_UART3_UART_RX_DATA_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart4_uart_rts_b_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart4_uart_rts_b_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_uart4_uart_rts_b_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART4_UART_RTS_B_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x934U)

#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart4_uart_rts_b_select_input_t *) HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_RD(x) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART4_UART_RTS_B_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART4_UART_RTS_B_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RTS_B signal to pad when UART
 * is in DCE mode. Route CTS_B signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT16 for
 *     UART4_RTS_B.
 * - 1 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT17 for
 *     UART4_CTS_B.
 */
/*@{*/
#define BP_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY_CSI0_DATA16_ALT3 (0U) /*!< Bit field value for IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT16 for UART4_RTS_B. */
#define BV_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY_CSI0_DATA17_ALT3 (0x1U) /*!< Bit field value for IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT17 for UART4_CTS_B. */

/*! @brief Read current value of the IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY) & BM_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_WR(x, (HW_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY) | BF_IOMUXC_UART4_UART_RTS_B_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart4_uart_rx_data_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart4_uart_rx_data_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart4_uart_rx_data_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x938U)

#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart4_uart_rx_data_select_input_t *) HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_RD(x) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RX_DATA signal to pad when UART
 * is in DCE mode. Route TX_DATA signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL0 for
 *     UART4_TX_DATA.
 * - 01 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW0 for
 *     UART4_RX_DATA.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT12 for
 *     UART4_TX_DATA.
 * - 11 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT13 for
 *     UART4_RX_DATA.
 */
/*@{*/
#define BP_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY_KEY_COL0_ALT4 (0U) /*!< Bit field value for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL0 for UART4_TX_DATA. */
#define BV_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY_KEY_ROW0_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW0 for UART4_RX_DATA. */
#define BV_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA12_ALT3 (0x2U) /*!< Bit field value for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT12 for UART4_TX_DATA. */
#define BV_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA13_ALT3 (0x3U) /*!< Bit field value for IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT13 for UART4_RX_DATA. */

/*! @brief Read current value of the IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY) & BM_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(x, (HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY) | BF_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart5_uart_rts_b_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart5_uart_rts_b_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart5_uart_rts_b_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART5_UART_RTS_B_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x93CU)

#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart5_uart_rts_b_select_input_t *) HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_RD(x) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART5_UART_RTS_B_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART5_UART_RTS_B_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RTS_B signal to pad when UART
 * is in DCE mode. Route CTS_B signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL4 for
 *     UART5_RTS_B.
 * - 01 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW4 for
 *     UART5_CTS_B.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT18 for
 *     UART5_RTS_B.
 * - 11 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT19 for
 *     UART5_CTS_B.
 */
/*@{*/
#define BP_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY_KEY_COL4_ALT4 (0U) /*!< Bit field value for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL4 for UART5_RTS_B. */
#define BV_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY_KEY_ROW4_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW4 for UART5_CTS_B. */
#define BV_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY_CSI0_DATA18_ALT3 (0x2U) /*!< Bit field value for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT18 for UART5_RTS_B. */
#define BV_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY_CSI0_DATA19_ALT3 (0x3U) /*!< Bit field value for IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT19 for UART5_CTS_B. */

/*! @brief Read current value of the IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY) & BM_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_WR(x, (HW_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY) | BF_IOMUXC_UART5_UART_RTS_B_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_uart5_uart_rx_data_select_input
{
    uint32_t U;
    struct _hw_iomuxc_uart5_uart_rx_data_select_input_bitfields
    {
        uint32_t DAISY : 2;            /*!< [1:0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_iomuxc_uart5_uart_rx_data_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x940U)

#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT(x) (*(__IO hw_iomuxc_uart5_uart_rx_data_select_input_t *) HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_RD(x) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT(x).U)
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(x, v) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_SET(x, v) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(x, HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT, field DAISY[1:0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain. Route RX_DATA signal to pad when UART
 * is in DCE mode. Route TX_DATA signal to pad when UART is in DTE mode.
 *
 * Values:
 * - 00 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL1 for
 *     UART5_TX_DATA.
 * - 01 - Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW1 for
 *     UART5_RX_DATA.
 * - 10 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT14 for
 *     UART5_TX_DATA.
 * - 11 - Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT15 for
 *     UART5_RX_DATA.
 */
/*@{*/
#define BP_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY (0x00000003U) /*!< Bit mask for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY (2U) /*!< Bit field size in bits for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY_KEY_COL1_ALT4 (0U) /*!< Bit field value for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_COL1 for UART5_TX_DATA. */
#define BV_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY_KEY_ROW1_ALT4 (0x1U) /*!< Bit field value for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad KEY_ROW1 for UART5_RX_DATA. */
#define BV_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA14_ALT3 (0x2U) /*!< Bit field value for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT14 for UART5_TX_DATA. */
#define BV_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY_CSI0_DATA15_ALT3 (0x3U) /*!< Bit field value for IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad CSI0_DAT15 for UART5_RX_DATA. */

/*! @brief Read current value of the IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY(x) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY) & BM_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(x, (HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_RD(x) & ~BM_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY) | BF_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_USB_OTG_OC_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_USB_OTG_OC_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_usb_otg_oc_select_input
{
    uint32_t U;
    struct _hw_iomuxc_usb_otg_oc_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_usb_otg_oc_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_USB_OTG_OC_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x944U)

#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT(x) (*(__IO hw_iomuxc_usb_otg_oc_select_input_t *) HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_RD(x) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT(x).U)
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_WR(x, v) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_SET(x, v) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_USB_OTG_OC_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_USB_OTG_OC_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT4MUX Mode Select Field. mode of pad EIM_D21 for USB_OTG_OC.
 * - 1 - Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL4 for
 *     USB_OTG_OC.
 */
/*@{*/
#define BP_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY_EIM_DATA21_ALT4 (0U) /*!< Bit field value for IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY: Selecting ALT4MUX Mode Select Field. mode of pad EIM_D21 for USB_OTG_OC. */
#define BV_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY_KEY_COL4_ALT2 (0x1U) /*!< Bit field value for IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY: Selecting ALT2MUX Mode Select Field. mode of pad KEY_COL4 for USB_OTG_OC. */

/*! @brief Read current value of the IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY(x) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY) & BM_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_WR(x, (HW_IOMUXC_USB_OTG_OC_SELECT_INPUT_RD(x) & ~BM_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY) | BF_IOMUXC_USB_OTG_OC_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_USB_H1_OC_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_USB_H1_OC_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_usb_h1_oc_select_input
{
    uint32_t U;
    struct _hw_iomuxc_usb_h1_oc_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_usb_h1_oc_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_USB_H1_OC_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x948U)

#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT(x) (*(__IO hw_iomuxc_usb_h1_oc_select_input_t *) HW_IOMUXC_USB_H1_OC_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_RD(x) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT(x).U)
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_WR(x, v) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_SET(x, v) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_H1_OC_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_H1_OC_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_USB_H1_OC_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT_WR(x, HW_IOMUXC_USB_H1_OC_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_USB_H1_OC_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_USB_H1_OC_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT6MUX Mode Select Field. mode of pad EIM_D30 for USB_H1_OC.
 * - 1 - Selecting ALT6MUX Mode Select Field. mode of pad GPIO_3 for USB_H1_OC.
 */
/*@{*/
#define BP_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY_EIM_DATA30_ALT6 (0U) /*!< Bit field value for IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad EIM_D30 for USB_H1_OC. */
#define BV_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY_GPIO03_ALT6 (0x1U) /*!< Bit field value for IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad GPIO_3 for USB_H1_OC. */

/*! @brief Read current value of the IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY(x) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY) & BM_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_USB_H1_OC_SELECT_INPUT_WR(x, (HW_IOMUXC_USB_H1_OC_SELECT_INPUT_RD(x) & ~BM_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY) | BF_IOMUXC_USB_H1_OC_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT - Select Input Register
 ******************************************************************************/

/*!
 * @brief HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT - Select Input Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_iomuxc_usdhc1_wp_on_select_input
{
    uint32_t U;
    struct _hw_iomuxc_usdhc1_wp_on_select_input_bitfields
    {
        uint32_t DAISY : 1;            /*!< [0] Input Select (DAISY) Field */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_iomuxc_usdhc1_wp_on_select_input_t;

/*!
 * @name Constants and macros for entire IOMUXC_USDHC1_WP_ON_SELECT_INPUT register
 */
/*@{*/
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_ADDR(x) ((uintptr_t)(x) + 0x94CU)

#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT(x) (*(__IO hw_iomuxc_usdhc1_wp_on_select_input_t *) HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_ADDR(x))
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_RD(x) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT(x).U)
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_WR(x, v) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT(x).U = (v))
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_SET(x, v) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_WR(x, HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_RD(x) |  (v)))
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_CLR(x, v) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_WR(x, HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_RD(x) & ~(v)))
#define HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_TOG(x, v) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_WR(x, HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IOMUXC_USDHC1_WP_ON_SELECT_INPUT bitfields
 */

/*!
 * @name Register IOMUXC_USDHC1_WP_ON_SELECT_INPUT, field DAISY[0] (RW)
 *
 * Selecting Pads Involved in Daisy Chain.
 *
 * Values:
 * - 0 - Selecting ALT3MUX Mode Select Field. mode of pad DI0_PIN4 for SD1_WP.
 * - 1 - Selecting ALT6MUX Mode Select Field. mode of pad GPIO_9 for SD1_WP.
 */
/*@{*/
#define BP_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY (0U) /*!< Bit position for IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY. */
#define BM_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY (0x00000001U) /*!< Bit mask for IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY. */
#define BS_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY (1U) /*!< Bit field size in bits for IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY. */

#define BV_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY_DI0_PIN04_ALT3 (0U) /*!< Bit field value for IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY: Selecting ALT3MUX Mode Select Field. mode of pad DI0_PIN4 for SD1_WP. */
#define BV_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY_GPIO09_ALT6 (0x1U) /*!< Bit field value for IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY: Selecting ALT6MUX Mode Select Field. mode of pad GPIO_9 for SD1_WP. */

/*! @brief Read current value of the IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY field. */
#define BR_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY(x) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT(x).B.DAISY)

/*! @brief Format value for bitfield IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY. */
#define BF_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY(v) ((uint32_t)((uint32_t)(v) << BP_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY) & BM_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY)

/*! @brief Set the DAISY field to a new value. */
#define BW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY(x, v) (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_WR(x, (HW_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_RD(x) & ~BM_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY) | BF_IOMUXC_USDHC1_WP_ON_SELECT_INPUT_DAISY(v)))
/*@}*/

/*******************************************************************************
 * hw_iomuxc_t - module struct
 ******************************************************************************/
/*!
 * @brief All IOMUXC module registers.
 */
#pragma pack(1)
typedef struct _hw_iomuxc
{
    __IO hw_iomuxc_gpr0_t GPR0;            /*!< [0x0] GPR */
    __IO hw_iomuxc_gpr1_t GPR1;            /*!< [0x4] GPR */
    __IO hw_iomuxc_gpr2_t GPR2;            /*!< [0x8] GPR */
    __IO hw_iomuxc_gpr3_t GPR3;            /*!< [0xC] GPR */
    __IO hw_iomuxc_gpr4_t GPR4;            /*!< [0x10] GPR */
    __IO hw_iomuxc_gpr5_t GPR5;            /*!< [0x14] GPR */
    __IO hw_iomuxc_gpr6_t GPR6;            /*!< [0x18] GPR */
    __IO hw_iomuxc_gpr7_t GPR7;            /*!< [0x1C] GPR */
    __IO hw_iomuxc_gpr8_t GPR8;            /*!< [0x20] GPR */
    __I hw_iomuxc_gpr9_t GPR9;             /*!< [0x24] GPR */
    __IO hw_iomuxc_gpr10_t GPR10;          /*!< [0x28] GPR */
    __I hw_iomuxc_gpr11_t GPR11;           /*!< [0x2C] GPR */
    __IO hw_iomuxc_gpr12_t GPR12;          /*!< [0x30] GPR */
    __IO hw_iomuxc_gpr13_t GPR13;          /*!< [0x34] GPR */
    uint8_t _reserved0[20];
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_data1_t SW_MUX_CTL_PAD_SD2_DATA1; /*!< [0x4C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_data2_t SW_MUX_CTL_PAD_SD2_DATA2; /*!< [0x50] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_data0_t SW_MUX_CTL_PAD_SD2_DATA0; /*!< [0x54] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_txc_t SW_MUX_CTL_PAD_RGMII_TXC; /*!< [0x58] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td0_t SW_MUX_CTL_PAD_RGMII_TD0; /*!< [0x5C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td1_t SW_MUX_CTL_PAD_RGMII_TD1; /*!< [0x60] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td2_t SW_MUX_CTL_PAD_RGMII_TD2; /*!< [0x64] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_td3_t SW_MUX_CTL_PAD_RGMII_TD3; /*!< [0x68] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rx_ctl_t SW_MUX_CTL_PAD_RGMII_RX_CTL; /*!< [0x6C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd0_t SW_MUX_CTL_PAD_RGMII_RD0; /*!< [0x70] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_tx_ctl_t SW_MUX_CTL_PAD_RGMII_TX_CTL; /*!< [0x74] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd1_t SW_MUX_CTL_PAD_RGMII_RD1; /*!< [0x78] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd2_t SW_MUX_CTL_PAD_RGMII_RD2; /*!< [0x7C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rd3_t SW_MUX_CTL_PAD_RGMII_RD3; /*!< [0x80] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_rgmii_rxc_t SW_MUX_CTL_PAD_RGMII_RXC; /*!< [0x84] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr25_t SW_MUX_CTL_PAD_EIM_ADDR25; /*!< [0x88] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_eb2_b_t SW_MUX_CTL_PAD_EIM_EB2_B; /*!< [0x8C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data16_t SW_MUX_CTL_PAD_EIM_DATA16; /*!< [0x90] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data17_t SW_MUX_CTL_PAD_EIM_DATA17; /*!< [0x94] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data18_t SW_MUX_CTL_PAD_EIM_DATA18; /*!< [0x98] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data19_t SW_MUX_CTL_PAD_EIM_DATA19; /*!< [0x9C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data20_t SW_MUX_CTL_PAD_EIM_DATA20; /*!< [0xA0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data21_t SW_MUX_CTL_PAD_EIM_DATA21; /*!< [0xA4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data22_t SW_MUX_CTL_PAD_EIM_DATA22; /*!< [0xA8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data23_t SW_MUX_CTL_PAD_EIM_DATA23; /*!< [0xAC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_eb3_b_t SW_MUX_CTL_PAD_EIM_EB3_B; /*!< [0xB0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data24_t SW_MUX_CTL_PAD_EIM_DATA24; /*!< [0xB4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data25_t SW_MUX_CTL_PAD_EIM_DATA25; /*!< [0xB8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data26_t SW_MUX_CTL_PAD_EIM_DATA26; /*!< [0xBC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data27_t SW_MUX_CTL_PAD_EIM_DATA27; /*!< [0xC0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data28_t SW_MUX_CTL_PAD_EIM_DATA28; /*!< [0xC4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data29_t SW_MUX_CTL_PAD_EIM_DATA29; /*!< [0xC8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data30_t SW_MUX_CTL_PAD_EIM_DATA30; /*!< [0xCC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_data31_t SW_MUX_CTL_PAD_EIM_DATA31; /*!< [0xD0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr24_t SW_MUX_CTL_PAD_EIM_ADDR24; /*!< [0xD4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr23_t SW_MUX_CTL_PAD_EIM_ADDR23; /*!< [0xD8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr22_t SW_MUX_CTL_PAD_EIM_ADDR22; /*!< [0xDC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr21_t SW_MUX_CTL_PAD_EIM_ADDR21; /*!< [0xE0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr20_t SW_MUX_CTL_PAD_EIM_ADDR20; /*!< [0xE4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr19_t SW_MUX_CTL_PAD_EIM_ADDR19; /*!< [0xE8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr18_t SW_MUX_CTL_PAD_EIM_ADDR18; /*!< [0xEC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr17_t SW_MUX_CTL_PAD_EIM_ADDR17; /*!< [0xF0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_addr16_t SW_MUX_CTL_PAD_EIM_ADDR16; /*!< [0xF4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_cs0_b_t SW_MUX_CTL_PAD_EIM_CS0_B; /*!< [0xF8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_cs1_b_t SW_MUX_CTL_PAD_EIM_CS1_B; /*!< [0xFC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_oe_b_t SW_MUX_CTL_PAD_EIM_OE_B; /*!< [0x100] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_rw_t SW_MUX_CTL_PAD_EIM_RW; /*!< [0x104] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_lba_b_t SW_MUX_CTL_PAD_EIM_LBA_B; /*!< [0x108] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_eb0_b_t SW_MUX_CTL_PAD_EIM_EB0_B; /*!< [0x10C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_eb1_b_t SW_MUX_CTL_PAD_EIM_EB1_B; /*!< [0x110] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad00_t SW_MUX_CTL_PAD_EIM_AD00; /*!< [0x114] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad01_t SW_MUX_CTL_PAD_EIM_AD01; /*!< [0x118] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad02_t SW_MUX_CTL_PAD_EIM_AD02; /*!< [0x11C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad03_t SW_MUX_CTL_PAD_EIM_AD03; /*!< [0x120] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad04_t SW_MUX_CTL_PAD_EIM_AD04; /*!< [0x124] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad05_t SW_MUX_CTL_PAD_EIM_AD05; /*!< [0x128] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad06_t SW_MUX_CTL_PAD_EIM_AD06; /*!< [0x12C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad07_t SW_MUX_CTL_PAD_EIM_AD07; /*!< [0x130] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad08_t SW_MUX_CTL_PAD_EIM_AD08; /*!< [0x134] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad09_t SW_MUX_CTL_PAD_EIM_AD09; /*!< [0x138] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad10_t SW_MUX_CTL_PAD_EIM_AD10; /*!< [0x13C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad11_t SW_MUX_CTL_PAD_EIM_AD11; /*!< [0x140] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad12_t SW_MUX_CTL_PAD_EIM_AD12; /*!< [0x144] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad13_t SW_MUX_CTL_PAD_EIM_AD13; /*!< [0x148] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad14_t SW_MUX_CTL_PAD_EIM_AD14; /*!< [0x14C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_ad15_t SW_MUX_CTL_PAD_EIM_AD15; /*!< [0x150] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_wait_b_t SW_MUX_CTL_PAD_EIM_WAIT_B; /*!< [0x154] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_eim_bclk_t SW_MUX_CTL_PAD_EIM_BCLK; /*!< [0x158] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_di0_disp_clk_t SW_MUX_CTL_PAD_DI0_DISP_CLK; /*!< [0x15C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_di0_pin15_t SW_MUX_CTL_PAD_DI0_PIN15; /*!< [0x160] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_di0_pin02_t SW_MUX_CTL_PAD_DI0_PIN02; /*!< [0x164] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_di0_pin03_t SW_MUX_CTL_PAD_DI0_PIN03; /*!< [0x168] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_di0_pin04_t SW_MUX_CTL_PAD_DI0_PIN04; /*!< [0x16C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data00_t SW_MUX_CTL_PAD_DISP0_DATA00; /*!< [0x170] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data01_t SW_MUX_CTL_PAD_DISP0_DATA01; /*!< [0x174] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data02_t SW_MUX_CTL_PAD_DISP0_DATA02; /*!< [0x178] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data03_t SW_MUX_CTL_PAD_DISP0_DATA03; /*!< [0x17C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data04_t SW_MUX_CTL_PAD_DISP0_DATA04; /*!< [0x180] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data05_t SW_MUX_CTL_PAD_DISP0_DATA05; /*!< [0x184] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data06_t SW_MUX_CTL_PAD_DISP0_DATA06; /*!< [0x188] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data07_t SW_MUX_CTL_PAD_DISP0_DATA07; /*!< [0x18C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data08_t SW_MUX_CTL_PAD_DISP0_DATA08; /*!< [0x190] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data09_t SW_MUX_CTL_PAD_DISP0_DATA09; /*!< [0x194] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data10_t SW_MUX_CTL_PAD_DISP0_DATA10; /*!< [0x198] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data11_t SW_MUX_CTL_PAD_DISP0_DATA11; /*!< [0x19C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data12_t SW_MUX_CTL_PAD_DISP0_DATA12; /*!< [0x1A0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data13_t SW_MUX_CTL_PAD_DISP0_DATA13; /*!< [0x1A4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data14_t SW_MUX_CTL_PAD_DISP0_DATA14; /*!< [0x1A8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data15_t SW_MUX_CTL_PAD_DISP0_DATA15; /*!< [0x1AC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data16_t SW_MUX_CTL_PAD_DISP0_DATA16; /*!< [0x1B0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data17_t SW_MUX_CTL_PAD_DISP0_DATA17; /*!< [0x1B4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data18_t SW_MUX_CTL_PAD_DISP0_DATA18; /*!< [0x1B8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data19_t SW_MUX_CTL_PAD_DISP0_DATA19; /*!< [0x1BC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data20_t SW_MUX_CTL_PAD_DISP0_DATA20; /*!< [0x1C0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data21_t SW_MUX_CTL_PAD_DISP0_DATA21; /*!< [0x1C4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data22_t SW_MUX_CTL_PAD_DISP0_DATA22; /*!< [0x1C8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_disp0_data23_t SW_MUX_CTL_PAD_DISP0_DATA23; /*!< [0x1CC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_mdio_t SW_MUX_CTL_PAD_ENET_MDIO; /*!< [0x1D0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_ref_clk_t SW_MUX_CTL_PAD_ENET_REF_CLK; /*!< [0x1D4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_er_t SW_MUX_CTL_PAD_ENET_RX_ER; /*!< [0x1D8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_crs_dv_t SW_MUX_CTL_PAD_ENET_CRS_DV; /*!< [0x1DC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_data1_t SW_MUX_CTL_PAD_ENET_RX_DATA1; /*!< [0x1E0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_rx_data0_t SW_MUX_CTL_PAD_ENET_RX_DATA0; /*!< [0x1E4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_en_t SW_MUX_CTL_PAD_ENET_TX_EN; /*!< [0x1E8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_data1_t SW_MUX_CTL_PAD_ENET_TX_DATA1; /*!< [0x1EC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_tx_data0_t SW_MUX_CTL_PAD_ENET_TX_DATA0; /*!< [0x1F0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_enet_mdc_t SW_MUX_CTL_PAD_ENET_MDC; /*!< [0x1F4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_col0_t SW_MUX_CTL_PAD_KEY_COL0; /*!< [0x1F8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_row0_t SW_MUX_CTL_PAD_KEY_ROW0; /*!< [0x1FC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_col1_t SW_MUX_CTL_PAD_KEY_COL1; /*!< [0x200] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_row1_t SW_MUX_CTL_PAD_KEY_ROW1; /*!< [0x204] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_col2_t SW_MUX_CTL_PAD_KEY_COL2; /*!< [0x208] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_row2_t SW_MUX_CTL_PAD_KEY_ROW2; /*!< [0x20C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_col3_t SW_MUX_CTL_PAD_KEY_COL3; /*!< [0x210] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_row3_t SW_MUX_CTL_PAD_KEY_ROW3; /*!< [0x214] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_col4_t SW_MUX_CTL_PAD_KEY_COL4; /*!< [0x218] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_key_row4_t SW_MUX_CTL_PAD_KEY_ROW4; /*!< [0x21C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio00_t SW_MUX_CTL_PAD_GPIO00; /*!< [0x220] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio01_t SW_MUX_CTL_PAD_GPIO01; /*!< [0x224] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio09_t SW_MUX_CTL_PAD_GPIO09; /*!< [0x228] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio03_t SW_MUX_CTL_PAD_GPIO03; /*!< [0x22C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio06_t SW_MUX_CTL_PAD_GPIO06; /*!< [0x230] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio02_t SW_MUX_CTL_PAD_GPIO02; /*!< [0x234] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio04_t SW_MUX_CTL_PAD_GPIO04; /*!< [0x238] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio05_t SW_MUX_CTL_PAD_GPIO05; /*!< [0x23C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio07_t SW_MUX_CTL_PAD_GPIO07; /*!< [0x240] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio08_t SW_MUX_CTL_PAD_GPIO08; /*!< [0x244] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio16_t SW_MUX_CTL_PAD_GPIO16; /*!< [0x248] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio17_t SW_MUX_CTL_PAD_GPIO17; /*!< [0x24C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio18_t SW_MUX_CTL_PAD_GPIO18; /*!< [0x250] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_gpio19_t SW_MUX_CTL_PAD_GPIO19; /*!< [0x254] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_pixclk_t SW_MUX_CTL_PAD_CSI0_PIXCLK; /*!< [0x258] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_hsync_t SW_MUX_CTL_PAD_CSI0_HSYNC; /*!< [0x25C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data_en_t SW_MUX_CTL_PAD_CSI0_DATA_EN; /*!< [0x260] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_vsync_t SW_MUX_CTL_PAD_CSI0_VSYNC; /*!< [0x264] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data04_t SW_MUX_CTL_PAD_CSI0_DATA04; /*!< [0x268] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data05_t SW_MUX_CTL_PAD_CSI0_DATA05; /*!< [0x26C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data06_t SW_MUX_CTL_PAD_CSI0_DATA06; /*!< [0x270] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data07_t SW_MUX_CTL_PAD_CSI0_DATA07; /*!< [0x274] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data08_t SW_MUX_CTL_PAD_CSI0_DATA08; /*!< [0x278] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data09_t SW_MUX_CTL_PAD_CSI0_DATA09; /*!< [0x27C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data10_t SW_MUX_CTL_PAD_CSI0_DATA10; /*!< [0x280] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data11_t SW_MUX_CTL_PAD_CSI0_DATA11; /*!< [0x284] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data12_t SW_MUX_CTL_PAD_CSI0_DATA12; /*!< [0x288] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data13_t SW_MUX_CTL_PAD_CSI0_DATA13; /*!< [0x28C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data14_t SW_MUX_CTL_PAD_CSI0_DATA14; /*!< [0x290] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data15_t SW_MUX_CTL_PAD_CSI0_DATA15; /*!< [0x294] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data16_t SW_MUX_CTL_PAD_CSI0_DATA16; /*!< [0x298] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data17_t SW_MUX_CTL_PAD_CSI0_DATA17; /*!< [0x29C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data18_t SW_MUX_CTL_PAD_CSI0_DATA18; /*!< [0x2A0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_csi0_data19_t SW_MUX_CTL_PAD_CSI0_DATA19; /*!< [0x2A4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data7_t SW_MUX_CTL_PAD_SD3_DATA7; /*!< [0x2A8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data6_t SW_MUX_CTL_PAD_SD3_DATA6; /*!< [0x2AC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data5_t SW_MUX_CTL_PAD_SD3_DATA5; /*!< [0x2B0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data4_t SW_MUX_CTL_PAD_SD3_DATA4; /*!< [0x2B4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_cmd_t SW_MUX_CTL_PAD_SD3_CMD; /*!< [0x2B8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_clk_t SW_MUX_CTL_PAD_SD3_CLK; /*!< [0x2BC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data0_t SW_MUX_CTL_PAD_SD3_DATA0; /*!< [0x2C0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data1_t SW_MUX_CTL_PAD_SD3_DATA1; /*!< [0x2C4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data2_t SW_MUX_CTL_PAD_SD3_DATA2; /*!< [0x2C8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_data3_t SW_MUX_CTL_PAD_SD3_DATA3; /*!< [0x2CC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd3_reset_t SW_MUX_CTL_PAD_SD3_RESET; /*!< [0x2D0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_cle_t SW_MUX_CTL_PAD_NAND_CLE; /*!< [0x2D4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_ale_t SW_MUX_CTL_PAD_NAND_ALE; /*!< [0x2D8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_wp_b_t SW_MUX_CTL_PAD_NAND_WP_B; /*!< [0x2DC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_ready_b_t SW_MUX_CTL_PAD_NAND_READY_B; /*!< [0x2E0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_cs0_b_t SW_MUX_CTL_PAD_NAND_CS0_B; /*!< [0x2E4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_cs1_b_t SW_MUX_CTL_PAD_NAND_CS1_B; /*!< [0x2E8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_cs2_b_t SW_MUX_CTL_PAD_NAND_CS2_B; /*!< [0x2EC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_cs3_b_t SW_MUX_CTL_PAD_NAND_CS3_B; /*!< [0x2F0] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_cmd_t SW_MUX_CTL_PAD_SD4_CMD; /*!< [0x2F4] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_clk_t SW_MUX_CTL_PAD_SD4_CLK; /*!< [0x2F8] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data00_t SW_MUX_CTL_PAD_NAND_DATA00; /*!< [0x2FC] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data01_t SW_MUX_CTL_PAD_NAND_DATA01; /*!< [0x300] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data02_t SW_MUX_CTL_PAD_NAND_DATA02; /*!< [0x304] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data03_t SW_MUX_CTL_PAD_NAND_DATA03; /*!< [0x308] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data04_t SW_MUX_CTL_PAD_NAND_DATA04; /*!< [0x30C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data05_t SW_MUX_CTL_PAD_NAND_DATA05; /*!< [0x310] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data06_t SW_MUX_CTL_PAD_NAND_DATA06; /*!< [0x314] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_nand_data07_t SW_MUX_CTL_PAD_NAND_DATA07; /*!< [0x318] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data0_t SW_MUX_CTL_PAD_SD4_DATA0; /*!< [0x31C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data1_t SW_MUX_CTL_PAD_SD4_DATA1; /*!< [0x320] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data2_t SW_MUX_CTL_PAD_SD4_DATA2; /*!< [0x324] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data3_t SW_MUX_CTL_PAD_SD4_DATA3; /*!< [0x328] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data4_t SW_MUX_CTL_PAD_SD4_DATA4; /*!< [0x32C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data5_t SW_MUX_CTL_PAD_SD4_DATA5; /*!< [0x330] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data6_t SW_MUX_CTL_PAD_SD4_DATA6; /*!< [0x334] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd4_data7_t SW_MUX_CTL_PAD_SD4_DATA7; /*!< [0x338] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_data1_t SW_MUX_CTL_PAD_SD1_DATA1; /*!< [0x33C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_data0_t SW_MUX_CTL_PAD_SD1_DATA0; /*!< [0x340] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_data3_t SW_MUX_CTL_PAD_SD1_DATA3; /*!< [0x344] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_cmd_t SW_MUX_CTL_PAD_SD1_CMD; /*!< [0x348] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_data2_t SW_MUX_CTL_PAD_SD1_DATA2; /*!< [0x34C] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd1_clk_t SW_MUX_CTL_PAD_SD1_CLK; /*!< [0x350] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_clk_t SW_MUX_CTL_PAD_SD2_CLK; /*!< [0x354] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_cmd_t SW_MUX_CTL_PAD_SD2_CMD; /*!< [0x358] Pad Mux Register */
    __IO hw_iomuxc_sw_mux_ctl_pad_sd2_data3_t SW_MUX_CTL_PAD_SD2_DATA3; /*!< [0x35C] Pad Mux Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_data1_t SW_PAD_CTL_PAD_SD2_DATA1; /*!< [0x360] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_data2_t SW_PAD_CTL_PAD_SD2_DATA2; /*!< [0x364] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_data0_t SW_PAD_CTL_PAD_SD2_DATA0; /*!< [0x368] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_txc_t SW_PAD_CTL_PAD_RGMII_TXC; /*!< [0x36C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td0_t SW_PAD_CTL_PAD_RGMII_TD0; /*!< [0x370] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td1_t SW_PAD_CTL_PAD_RGMII_TD1; /*!< [0x374] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td2_t SW_PAD_CTL_PAD_RGMII_TD2; /*!< [0x378] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_td3_t SW_PAD_CTL_PAD_RGMII_TD3; /*!< [0x37C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rx_ctl_t SW_PAD_CTL_PAD_RGMII_RX_CTL; /*!< [0x380] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd0_t SW_PAD_CTL_PAD_RGMII_RD0; /*!< [0x384] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_tx_ctl_t SW_PAD_CTL_PAD_RGMII_TX_CTL; /*!< [0x388] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd1_t SW_PAD_CTL_PAD_RGMII_RD1; /*!< [0x38C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd2_t SW_PAD_CTL_PAD_RGMII_RD2; /*!< [0x390] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rd3_t SW_PAD_CTL_PAD_RGMII_RD3; /*!< [0x394] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_rgmii_rxc_t SW_PAD_CTL_PAD_RGMII_RXC; /*!< [0x398] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr25_t SW_PAD_CTL_PAD_EIM_ADDR25; /*!< [0x39C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_eb2_b_t SW_PAD_CTL_PAD_EIM_EB2_B; /*!< [0x3A0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data16_t SW_PAD_CTL_PAD_EIM_DATA16; /*!< [0x3A4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data17_t SW_PAD_CTL_PAD_EIM_DATA17; /*!< [0x3A8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data18_t SW_PAD_CTL_PAD_EIM_DATA18; /*!< [0x3AC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data19_t SW_PAD_CTL_PAD_EIM_DATA19; /*!< [0x3B0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data20_t SW_PAD_CTL_PAD_EIM_DATA20; /*!< [0x3B4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data21_t SW_PAD_CTL_PAD_EIM_DATA21; /*!< [0x3B8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data22_t SW_PAD_CTL_PAD_EIM_DATA22; /*!< [0x3BC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data23_t SW_PAD_CTL_PAD_EIM_DATA23; /*!< [0x3C0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_eb3_b_t SW_PAD_CTL_PAD_EIM_EB3_B; /*!< [0x3C4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data24_t SW_PAD_CTL_PAD_EIM_DATA24; /*!< [0x3C8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data25_t SW_PAD_CTL_PAD_EIM_DATA25; /*!< [0x3CC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data26_t SW_PAD_CTL_PAD_EIM_DATA26; /*!< [0x3D0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data27_t SW_PAD_CTL_PAD_EIM_DATA27; /*!< [0x3D4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data28_t SW_PAD_CTL_PAD_EIM_DATA28; /*!< [0x3D8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data29_t SW_PAD_CTL_PAD_EIM_DATA29; /*!< [0x3DC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data30_t SW_PAD_CTL_PAD_EIM_DATA30; /*!< [0x3E0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_data31_t SW_PAD_CTL_PAD_EIM_DATA31; /*!< [0x3E4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr24_t SW_PAD_CTL_PAD_EIM_ADDR24; /*!< [0x3E8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr23_t SW_PAD_CTL_PAD_EIM_ADDR23; /*!< [0x3EC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr22_t SW_PAD_CTL_PAD_EIM_ADDR22; /*!< [0x3F0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr21_t SW_PAD_CTL_PAD_EIM_ADDR21; /*!< [0x3F4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr20_t SW_PAD_CTL_PAD_EIM_ADDR20; /*!< [0x3F8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr19_t SW_PAD_CTL_PAD_EIM_ADDR19; /*!< [0x3FC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr18_t SW_PAD_CTL_PAD_EIM_ADDR18; /*!< [0x400] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr17_t SW_PAD_CTL_PAD_EIM_ADDR17; /*!< [0x404] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_addr16_t SW_PAD_CTL_PAD_EIM_ADDR16; /*!< [0x408] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_cs0_b_t SW_PAD_CTL_PAD_EIM_CS0_B; /*!< [0x40C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_cs1_b_t SW_PAD_CTL_PAD_EIM_CS1_B; /*!< [0x410] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_oe_b_t SW_PAD_CTL_PAD_EIM_OE_B; /*!< [0x414] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_rw_t SW_PAD_CTL_PAD_EIM_RW; /*!< [0x418] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_lba_b_t SW_PAD_CTL_PAD_EIM_LBA_B; /*!< [0x41C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_eb0_b_t SW_PAD_CTL_PAD_EIM_EB0_B; /*!< [0x420] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_eb1_b_t SW_PAD_CTL_PAD_EIM_EB1_B; /*!< [0x424] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad00_t SW_PAD_CTL_PAD_EIM_AD00; /*!< [0x428] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad01_t SW_PAD_CTL_PAD_EIM_AD01; /*!< [0x42C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad02_t SW_PAD_CTL_PAD_EIM_AD02; /*!< [0x430] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad03_t SW_PAD_CTL_PAD_EIM_AD03; /*!< [0x434] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad04_t SW_PAD_CTL_PAD_EIM_AD04; /*!< [0x438] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad05_t SW_PAD_CTL_PAD_EIM_AD05; /*!< [0x43C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad06_t SW_PAD_CTL_PAD_EIM_AD06; /*!< [0x440] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad07_t SW_PAD_CTL_PAD_EIM_AD07; /*!< [0x444] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad08_t SW_PAD_CTL_PAD_EIM_AD08; /*!< [0x448] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad09_t SW_PAD_CTL_PAD_EIM_AD09; /*!< [0x44C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad10_t SW_PAD_CTL_PAD_EIM_AD10; /*!< [0x450] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad11_t SW_PAD_CTL_PAD_EIM_AD11; /*!< [0x454] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad12_t SW_PAD_CTL_PAD_EIM_AD12; /*!< [0x458] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad13_t SW_PAD_CTL_PAD_EIM_AD13; /*!< [0x45C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad14_t SW_PAD_CTL_PAD_EIM_AD14; /*!< [0x460] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_ad15_t SW_PAD_CTL_PAD_EIM_AD15; /*!< [0x464] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_wait_b_t SW_PAD_CTL_PAD_EIM_WAIT_B; /*!< [0x468] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_eim_bclk_t SW_PAD_CTL_PAD_EIM_BCLK; /*!< [0x46C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_di0_disp_clk_t SW_PAD_CTL_PAD_DI0_DISP_CLK; /*!< [0x470] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_di0_pin15_t SW_PAD_CTL_PAD_DI0_PIN15; /*!< [0x474] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_di0_pin02_t SW_PAD_CTL_PAD_DI0_PIN02; /*!< [0x478] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_di0_pin03_t SW_PAD_CTL_PAD_DI0_PIN03; /*!< [0x47C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_di0_pin04_t SW_PAD_CTL_PAD_DI0_PIN04; /*!< [0x480] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data00_t SW_PAD_CTL_PAD_DISP0_DATA00; /*!< [0x484] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data01_t SW_PAD_CTL_PAD_DISP0_DATA01; /*!< [0x488] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data02_t SW_PAD_CTL_PAD_DISP0_DATA02; /*!< [0x48C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data03_t SW_PAD_CTL_PAD_DISP0_DATA03; /*!< [0x490] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data04_t SW_PAD_CTL_PAD_DISP0_DATA04; /*!< [0x494] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data05_t SW_PAD_CTL_PAD_DISP0_DATA05; /*!< [0x498] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data06_t SW_PAD_CTL_PAD_DISP0_DATA06; /*!< [0x49C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data07_t SW_PAD_CTL_PAD_DISP0_DATA07; /*!< [0x4A0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data08_t SW_PAD_CTL_PAD_DISP0_DATA08; /*!< [0x4A4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data09_t SW_PAD_CTL_PAD_DISP0_DATA09; /*!< [0x4A8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data10_t SW_PAD_CTL_PAD_DISP0_DATA10; /*!< [0x4AC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data11_t SW_PAD_CTL_PAD_DISP0_DATA11; /*!< [0x4B0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data12_t SW_PAD_CTL_PAD_DISP0_DATA12; /*!< [0x4B4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data13_t SW_PAD_CTL_PAD_DISP0_DATA13; /*!< [0x4B8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data14_t SW_PAD_CTL_PAD_DISP0_DATA14; /*!< [0x4BC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data15_t SW_PAD_CTL_PAD_DISP0_DATA15; /*!< [0x4C0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data16_t SW_PAD_CTL_PAD_DISP0_DATA16; /*!< [0x4C4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data17_t SW_PAD_CTL_PAD_DISP0_DATA17; /*!< [0x4C8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data18_t SW_PAD_CTL_PAD_DISP0_DATA18; /*!< [0x4CC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data19_t SW_PAD_CTL_PAD_DISP0_DATA19; /*!< [0x4D0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data20_t SW_PAD_CTL_PAD_DISP0_DATA20; /*!< [0x4D4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data21_t SW_PAD_CTL_PAD_DISP0_DATA21; /*!< [0x4D8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data22_t SW_PAD_CTL_PAD_DISP0_DATA22; /*!< [0x4DC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_disp0_data23_t SW_PAD_CTL_PAD_DISP0_DATA23; /*!< [0x4E0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_mdio_t SW_PAD_CTL_PAD_ENET_MDIO; /*!< [0x4E4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_ref_clk_t SW_PAD_CTL_PAD_ENET_REF_CLK; /*!< [0x4E8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_er_t SW_PAD_CTL_PAD_ENET_RX_ER; /*!< [0x4EC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_crs_dv_t SW_PAD_CTL_PAD_ENET_CRS_DV; /*!< [0x4F0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_data1_t SW_PAD_CTL_PAD_ENET_RX_DATA1; /*!< [0x4F4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_rx_data0_t SW_PAD_CTL_PAD_ENET_RX_DATA0; /*!< [0x4F8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_en_t SW_PAD_CTL_PAD_ENET_TX_EN; /*!< [0x4FC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_data1_t SW_PAD_CTL_PAD_ENET_TX_DATA1; /*!< [0x500] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_tx_data0_t SW_PAD_CTL_PAD_ENET_TX_DATA0; /*!< [0x504] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_enet_mdc_t SW_PAD_CTL_PAD_ENET_MDC; /*!< [0x508] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs5_p_t SW_PAD_CTL_PAD_DRAM_SDQS5_P; /*!< [0x50C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm5_t SW_PAD_CTL_PAD_DRAM_DQM5; /*!< [0x510] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm4_t SW_PAD_CTL_PAD_DRAM_DQM4; /*!< [0x514] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs4_p_t SW_PAD_CTL_PAD_DRAM_SDQS4_P; /*!< [0x518] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs3_p_t SW_PAD_CTL_PAD_DRAM_SDQS3_P; /*!< [0x51C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm3_t SW_PAD_CTL_PAD_DRAM_DQM3; /*!< [0x520] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs2_p_t SW_PAD_CTL_PAD_DRAM_SDQS2_P; /*!< [0x524] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm2_t SW_PAD_CTL_PAD_DRAM_DQM2; /*!< [0x528] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr00_t SW_PAD_CTL_PAD_DRAM_ADDR00; /*!< [0x52C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr01_t SW_PAD_CTL_PAD_DRAM_ADDR01; /*!< [0x530] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr02_t SW_PAD_CTL_PAD_DRAM_ADDR02; /*!< [0x534] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr03_t SW_PAD_CTL_PAD_DRAM_ADDR03; /*!< [0x538] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr04_t SW_PAD_CTL_PAD_DRAM_ADDR04; /*!< [0x53C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr05_t SW_PAD_CTL_PAD_DRAM_ADDR05; /*!< [0x540] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr06_t SW_PAD_CTL_PAD_DRAM_ADDR06; /*!< [0x544] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr07_t SW_PAD_CTL_PAD_DRAM_ADDR07; /*!< [0x548] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr08_t SW_PAD_CTL_PAD_DRAM_ADDR08; /*!< [0x54C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr09_t SW_PAD_CTL_PAD_DRAM_ADDR09; /*!< [0x550] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr10_t SW_PAD_CTL_PAD_DRAM_ADDR10; /*!< [0x554] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr11_t SW_PAD_CTL_PAD_DRAM_ADDR11; /*!< [0x558] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr12_t SW_PAD_CTL_PAD_DRAM_ADDR12; /*!< [0x55C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr13_t SW_PAD_CTL_PAD_DRAM_ADDR13; /*!< [0x560] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr14_t SW_PAD_CTL_PAD_DRAM_ADDR14; /*!< [0x564] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_addr15_t SW_PAD_CTL_PAD_DRAM_ADDR15; /*!< [0x568] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_cas_b_t SW_PAD_CTL_PAD_DRAM_CAS_B; /*!< [0x56C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_cs0_b_t SW_PAD_CTL_PAD_DRAM_CS0_B; /*!< [0x570] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_cs1_b_t SW_PAD_CTL_PAD_DRAM_CS1_B; /*!< [0x574] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_ras_b_t SW_PAD_CTL_PAD_DRAM_RAS_B; /*!< [0x578] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_reset_t SW_PAD_CTL_PAD_DRAM_RESET; /*!< [0x57C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba0_t SW_PAD_CTL_PAD_DRAM_SDBA0; /*!< [0x580] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba1_t SW_PAD_CTL_PAD_DRAM_SDBA1; /*!< [0x584] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdclk0_p_t SW_PAD_CTL_PAD_DRAM_SDCLK0_P; /*!< [0x588] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdba2_t SW_PAD_CTL_PAD_DRAM_SDBA2; /*!< [0x58C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdcke0_t SW_PAD_CTL_PAD_DRAM_SDCKE0; /*!< [0x590] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdclk1_p_t SW_PAD_CTL_PAD_DRAM_SDCLK1_P; /*!< [0x594] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdcke1_t SW_PAD_CTL_PAD_DRAM_SDCKE1; /*!< [0x598] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_odt0_t SW_PAD_CTL_PAD_DRAM_ODT0; /*!< [0x59C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_odt1_t SW_PAD_CTL_PAD_DRAM_ODT1; /*!< [0x5A0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdwe_b_t SW_PAD_CTL_PAD_DRAM_SDWE_B; /*!< [0x5A4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs0_p_t SW_PAD_CTL_PAD_DRAM_SDQS0_P; /*!< [0x5A8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm0_t SW_PAD_CTL_PAD_DRAM_DQM0; /*!< [0x5AC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs1_p_t SW_PAD_CTL_PAD_DRAM_SDQS1_P; /*!< [0x5B0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm1_t SW_PAD_CTL_PAD_DRAM_DQM1; /*!< [0x5B4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs6_p_t SW_PAD_CTL_PAD_DRAM_SDQS6_P; /*!< [0x5B8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm6_t SW_PAD_CTL_PAD_DRAM_DQM6; /*!< [0x5BC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_sdqs7_p_t SW_PAD_CTL_PAD_DRAM_SDQS7_P; /*!< [0x5C0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_dram_dqm7_t SW_PAD_CTL_PAD_DRAM_DQM7; /*!< [0x5C4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_col0_t SW_PAD_CTL_PAD_KEY_COL0; /*!< [0x5C8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_row0_t SW_PAD_CTL_PAD_KEY_ROW0; /*!< [0x5CC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_col1_t SW_PAD_CTL_PAD_KEY_COL1; /*!< [0x5D0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_row1_t SW_PAD_CTL_PAD_KEY_ROW1; /*!< [0x5D4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_col2_t SW_PAD_CTL_PAD_KEY_COL2; /*!< [0x5D8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_row2_t SW_PAD_CTL_PAD_KEY_ROW2; /*!< [0x5DC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_col3_t SW_PAD_CTL_PAD_KEY_COL3; /*!< [0x5E0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_row3_t SW_PAD_CTL_PAD_KEY_ROW3; /*!< [0x5E4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_col4_t SW_PAD_CTL_PAD_KEY_COL4; /*!< [0x5E8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_key_row4_t SW_PAD_CTL_PAD_KEY_ROW4; /*!< [0x5EC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio00_t SW_PAD_CTL_PAD_GPIO00; /*!< [0x5F0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio01_t SW_PAD_CTL_PAD_GPIO01; /*!< [0x5F4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio09_t SW_PAD_CTL_PAD_GPIO09; /*!< [0x5F8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio03_t SW_PAD_CTL_PAD_GPIO03; /*!< [0x5FC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio06_t SW_PAD_CTL_PAD_GPIO06; /*!< [0x600] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio02_t SW_PAD_CTL_PAD_GPIO02; /*!< [0x604] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio04_t SW_PAD_CTL_PAD_GPIO04; /*!< [0x608] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio05_t SW_PAD_CTL_PAD_GPIO05; /*!< [0x60C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio07_t SW_PAD_CTL_PAD_GPIO07; /*!< [0x610] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio08_t SW_PAD_CTL_PAD_GPIO08; /*!< [0x614] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio16_t SW_PAD_CTL_PAD_GPIO16; /*!< [0x618] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio17_t SW_PAD_CTL_PAD_GPIO17; /*!< [0x61C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio18_t SW_PAD_CTL_PAD_GPIO18; /*!< [0x620] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_gpio19_t SW_PAD_CTL_PAD_GPIO19; /*!< [0x624] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_pixclk_t SW_PAD_CTL_PAD_CSI0_PIXCLK; /*!< [0x628] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_hsync_t SW_PAD_CTL_PAD_CSI0_HSYNC; /*!< [0x62C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data_en_t SW_PAD_CTL_PAD_CSI0_DATA_EN; /*!< [0x630] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_vsync_t SW_PAD_CTL_PAD_CSI0_VSYNC; /*!< [0x634] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data04_t SW_PAD_CTL_PAD_CSI0_DATA04; /*!< [0x638] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data05_t SW_PAD_CTL_PAD_CSI0_DATA05; /*!< [0x63C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data06_t SW_PAD_CTL_PAD_CSI0_DATA06; /*!< [0x640] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data07_t SW_PAD_CTL_PAD_CSI0_DATA07; /*!< [0x644] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data08_t SW_PAD_CTL_PAD_CSI0_DATA08; /*!< [0x648] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data09_t SW_PAD_CTL_PAD_CSI0_DATA09; /*!< [0x64C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data10_t SW_PAD_CTL_PAD_CSI0_DATA10; /*!< [0x650] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data11_t SW_PAD_CTL_PAD_CSI0_DATA11; /*!< [0x654] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data12_t SW_PAD_CTL_PAD_CSI0_DATA12; /*!< [0x658] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data13_t SW_PAD_CTL_PAD_CSI0_DATA13; /*!< [0x65C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data14_t SW_PAD_CTL_PAD_CSI0_DATA14; /*!< [0x660] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data15_t SW_PAD_CTL_PAD_CSI0_DATA15; /*!< [0x664] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data16_t SW_PAD_CTL_PAD_CSI0_DATA16; /*!< [0x668] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data17_t SW_PAD_CTL_PAD_CSI0_DATA17; /*!< [0x66C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data18_t SW_PAD_CTL_PAD_CSI0_DATA18; /*!< [0x670] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_csi0_data19_t SW_PAD_CTL_PAD_CSI0_DATA19; /*!< [0x674] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_tms_t SW_PAD_CTL_PAD_JTAG_TMS; /*!< [0x678] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_mod_t SW_PAD_CTL_PAD_JTAG_MOD; /*!< [0x67C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_trstb_t SW_PAD_CTL_PAD_JTAG_TRSTB; /*!< [0x680] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_tdi_t SW_PAD_CTL_PAD_JTAG_TDI; /*!< [0x684] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_tck_t SW_PAD_CTL_PAD_JTAG_TCK; /*!< [0x688] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_jtag_tdo_t SW_PAD_CTL_PAD_JTAG_TDO; /*!< [0x68C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data7_t SW_PAD_CTL_PAD_SD3_DATA7; /*!< [0x690] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data6_t SW_PAD_CTL_PAD_SD3_DATA6; /*!< [0x694] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data5_t SW_PAD_CTL_PAD_SD3_DATA5; /*!< [0x698] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data4_t SW_PAD_CTL_PAD_SD3_DATA4; /*!< [0x69C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_cmd_t SW_PAD_CTL_PAD_SD3_CMD; /*!< [0x6A0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_clk_t SW_PAD_CTL_PAD_SD3_CLK; /*!< [0x6A4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data0_t SW_PAD_CTL_PAD_SD3_DATA0; /*!< [0x6A8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data1_t SW_PAD_CTL_PAD_SD3_DATA1; /*!< [0x6AC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data2_t SW_PAD_CTL_PAD_SD3_DATA2; /*!< [0x6B0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_data3_t SW_PAD_CTL_PAD_SD3_DATA3; /*!< [0x6B4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd3_reset_t SW_PAD_CTL_PAD_SD3_RESET; /*!< [0x6B8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_cle_t SW_PAD_CTL_PAD_NAND_CLE; /*!< [0x6BC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_ale_t SW_PAD_CTL_PAD_NAND_ALE; /*!< [0x6C0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_wp_b_t SW_PAD_CTL_PAD_NAND_WP_B; /*!< [0x6C4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_ready_b_t SW_PAD_CTL_PAD_NAND_READY_B; /*!< [0x6C8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_cs0_b_t SW_PAD_CTL_PAD_NAND_CS0_B; /*!< [0x6CC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_cs1_b_t SW_PAD_CTL_PAD_NAND_CS1_B; /*!< [0x6D0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_cs2_b_t SW_PAD_CTL_PAD_NAND_CS2_B; /*!< [0x6D4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_cs3_b_t SW_PAD_CTL_PAD_NAND_CS3_B; /*!< [0x6D8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_cmd_t SW_PAD_CTL_PAD_SD4_CMD; /*!< [0x6DC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_clk_t SW_PAD_CTL_PAD_SD4_CLK; /*!< [0x6E0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data00_t SW_PAD_CTL_PAD_NAND_DATA00; /*!< [0x6E4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data01_t SW_PAD_CTL_PAD_NAND_DATA01; /*!< [0x6E8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data02_t SW_PAD_CTL_PAD_NAND_DATA02; /*!< [0x6EC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data03_t SW_PAD_CTL_PAD_NAND_DATA03; /*!< [0x6F0] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data04_t SW_PAD_CTL_PAD_NAND_DATA04; /*!< [0x6F4] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data05_t SW_PAD_CTL_PAD_NAND_DATA05; /*!< [0x6F8] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data06_t SW_PAD_CTL_PAD_NAND_DATA06; /*!< [0x6FC] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_nand_data07_t SW_PAD_CTL_PAD_NAND_DATA07; /*!< [0x700] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data0_t SW_PAD_CTL_PAD_SD4_DATA0; /*!< [0x704] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data1_t SW_PAD_CTL_PAD_SD4_DATA1; /*!< [0x708] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data2_t SW_PAD_CTL_PAD_SD4_DATA2; /*!< [0x70C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data3_t SW_PAD_CTL_PAD_SD4_DATA3; /*!< [0x710] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data4_t SW_PAD_CTL_PAD_SD4_DATA4; /*!< [0x714] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data5_t SW_PAD_CTL_PAD_SD4_DATA5; /*!< [0x718] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data6_t SW_PAD_CTL_PAD_SD4_DATA6; /*!< [0x71C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd4_data7_t SW_PAD_CTL_PAD_SD4_DATA7; /*!< [0x720] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_data1_t SW_PAD_CTL_PAD_SD1_DATA1; /*!< [0x724] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_data0_t SW_PAD_CTL_PAD_SD1_DATA0; /*!< [0x728] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_data3_t SW_PAD_CTL_PAD_SD1_DATA3; /*!< [0x72C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_cmd_t SW_PAD_CTL_PAD_SD1_CMD; /*!< [0x730] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_data2_t SW_PAD_CTL_PAD_SD1_DATA2; /*!< [0x734] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd1_clk_t SW_PAD_CTL_PAD_SD1_CLK; /*!< [0x738] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_clk_t SW_PAD_CTL_PAD_SD2_CLK; /*!< [0x73C] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_cmd_t SW_PAD_CTL_PAD_SD2_CMD; /*!< [0x740] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_pad_sd2_data3_t SW_PAD_CTL_PAD_SD2_DATA3; /*!< [0x744] Pad Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b7ds_t SW_PAD_CTL_GRP_B7DS; /*!< [0x748] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_addds_t SW_PAD_CTL_GRP_ADDDS; /*!< [0x74C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddrmode_ctl_t SW_PAD_CTL_GRP_DDRMODE_CTL; /*!< [0x750] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl0_t SW_PAD_CTL_GRP_TERM_CTL0; /*!< [0x754] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddrpke_t SW_PAD_CTL_GRP_DDRPKE; /*!< [0x758] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl1_t SW_PAD_CTL_GRP_TERM_CTL1; /*!< [0x75C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl2_t SW_PAD_CTL_GRP_TERM_CTL2; /*!< [0x760] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl3_t SW_PAD_CTL_GRP_TERM_CTL3; /*!< [0x764] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddrpk_t SW_PAD_CTL_GRP_DDRPK; /*!< [0x768] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl4_t SW_PAD_CTL_GRP_TERM_CTL4; /*!< [0x76C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddrhys_t SW_PAD_CTL_GRP_DDRHYS; /*!< [0x770] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddrmode_t SW_PAD_CTL_GRP_DDRMODE; /*!< [0x774] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl5_t SW_PAD_CTL_GRP_TERM_CTL5; /*!< [0x778] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl6_t SW_PAD_CTL_GRP_TERM_CTL6; /*!< [0x77C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_term_ctl7_t SW_PAD_CTL_GRP_TERM_CTL7; /*!< [0x780] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b0ds_t SW_PAD_CTL_GRP_B0DS; /*!< [0x784] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b1ds_t SW_PAD_CTL_GRP_B1DS; /*!< [0x788] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ctlds_t SW_PAD_CTL_GRP_CTLDS; /*!< [0x78C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddr_type_rgmii_t SW_PAD_CTL_GRP_DDR_TYPE_RGMII; /*!< [0x790] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b2ds_t SW_PAD_CTL_GRP_B2DS; /*!< [0x794] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_ddr_type_t SW_PAD_CTL_GRP_DDR_TYPE; /*!< [0x798] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b3ds_t SW_PAD_CTL_GRP_B3DS; /*!< [0x79C] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b4ds_t SW_PAD_CTL_GRP_B4DS; /*!< [0x7A0] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b5ds_t SW_PAD_CTL_GRP_B5DS; /*!< [0x7A4] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_b6ds_t SW_PAD_CTL_GRP_B6DS; /*!< [0x7A8] Pad Group Control Register */
    __IO hw_iomuxc_sw_pad_ctl_grp_rgmii_term_t SW_PAD_CTL_GRP_RGMII_TERM; /*!< [0x7AC] Pad Group Control Register */
    __IO hw_iomuxc_asrc_asrck_clock_6_select_input_t ASRC_ASRCK_CLOCK_6_SELECT_INPUT; /*!< [0x7B0] Select Input Register */
    __IO hw_iomuxc_aud4_input_da_amx_select_input_t AUD4_INPUT_DA_AMX_SELECT_INPUT; /*!< [0x7B4] Select Input Register */
    __IO hw_iomuxc_aud4_input_db_amx_select_input_t AUD4_INPUT_DB_AMX_SELECT_INPUT; /*!< [0x7B8] Select Input Register */
    __IO hw_iomuxc_aud4_input_rxclk_amx_select_input_t AUD4_INPUT_RXCLK_AMX_SELECT_INPUT; /*!< [0x7BC] Select Input Register */
    __IO hw_iomuxc_aud4_input_rxfs_amx_select_input_t AUD4_INPUT_RXFS_AMX_SELECT_INPUT; /*!< [0x7C0] Select Input Register */
    __IO hw_iomuxc_aud4_input_txclk_amx_select_input_t AUD4_INPUT_TXCLK_AMX_SELECT_INPUT; /*!< [0x7C4] Select Input Register */
    __IO hw_iomuxc_aud4_input_txfs_amx_select_input_t AUD4_INPUT_TXFS_AMX_SELECT_INPUT; /*!< [0x7C8] Select Input Register */
    __IO hw_iomuxc_aud5_input_da_amx_select_input_t AUD5_INPUT_DA_AMX_SELECT_INPUT; /*!< [0x7CC] Select Input Register */
    __IO hw_iomuxc_aud5_input_db_amx_select_input_t AUD5_INPUT_DB_AMX_SELECT_INPUT; /*!< [0x7D0] Select Input Register */
    __IO hw_iomuxc_aud5_input_rxclk_amx_select_input_t AUD5_INPUT_RXCLK_AMX_SELECT_INPUT; /*!< [0x7D4] Select Input Register */
    __IO hw_iomuxc_aud5_input_rxfs_amx_select_input_t AUD5_INPUT_RXFS_AMX_SELECT_INPUT; /*!< [0x7D8] Select Input Register */
    __IO hw_iomuxc_aud5_input_txclk_amx_select_input_t AUD5_INPUT_TXCLK_AMX_SELECT_INPUT; /*!< [0x7DC] Select Input Register */
    __IO hw_iomuxc_aud5_input_txfs_amx_select_input_t AUD5_INPUT_TXFS_AMX_SELECT_INPUT; /*!< [0x7E0] Select Input Register */
    __IO hw_iomuxc_flexcan1_rx_select_input_t FLEXCAN1_RX_SELECT_INPUT; /*!< [0x7E4] Select Input Register */
    __IO hw_iomuxc_flexcan2_rx_select_input_t FLEXCAN2_RX_SELECT_INPUT; /*!< [0x7E8] Select Input Register */
    uint8_t _reserved1[4];
    __IO hw_iomuxc_ccm_pmic_ready_select_input_t CCM_PMIC_READY_SELECT_INPUT; /*!< [0x7F0] Select Input Register */
    __IO hw_iomuxc_ecspi1_cspi_clk_in_select_input_t ECSPI1_CSPI_CLK_IN_SELECT_INPUT; /*!< [0x7F4] Select Input Register */
    __IO hw_iomuxc_ecspi1_miso_select_input_t ECSPI1_MISO_SELECT_INPUT; /*!< [0x7F8] Select Input Register */
    __IO hw_iomuxc_ecspi1_mosi_select_input_t ECSPI1_MOSI_SELECT_INPUT; /*!< [0x7FC] Select Input Register */
    __IO hw_iomuxc_ecspi1_ss0_select_input_t ECSPI1_SS0_SELECT_INPUT; /*!< [0x800] Select Input Register */
    __IO hw_iomuxc_ecspi1_ss1_select_input_t ECSPI1_SS1_SELECT_INPUT; /*!< [0x804] Select Input Register */
    __IO hw_iomuxc_ecspi1_ss2_select_input_t ECSPI1_SS2_SELECT_INPUT; /*!< [0x808] Select Input Register */
    __IO hw_iomuxc_ecspi1_ss3_select_input_t ECSPI1_SS3_SELECT_INPUT; /*!< [0x80C] Select Input Register */
    __IO hw_iomuxc_ecspi2_cspi_clk_in_select_input_t ECSPI2_CSPI_CLK_IN_SELECT_INPUT; /*!< [0x810] Select Input Register */
    __IO hw_iomuxc_ecspi2_miso_select_input_t ECSPI2_MISO_SELECT_INPUT; /*!< [0x814] Select Input Register */
    __IO hw_iomuxc_ecspi2_mosi_select_input_t ECSPI2_MOSI_SELECT_INPUT; /*!< [0x818] Select Input Register */
    __IO hw_iomuxc_ecspi2_ss0_select_input_t ECSPI2_SS0_SELECT_INPUT; /*!< [0x81C] Select Input Register */
    __IO hw_iomuxc_ecspi2_ss1_select_input_t ECSPI2_SS1_SELECT_INPUT; /*!< [0x820] Select Input Register */
    __IO hw_iomuxc_ecspi4_ss0_select_input_t ECSPI4_SS0_SELECT_INPUT; /*!< [0x824] Select Input Register */
    __IO hw_iomuxc_ecspi5_cspi_clk_in_select_input_t ECSPI5_CSPI_CLK_IN_SELECT_INPUT; /*!< [0x828] Select Input Register */
    __IO hw_iomuxc_ecspi5_miso_select_input_t ECSPI5_MISO_SELECT_INPUT; /*!< [0x82C] Select Input Register */
    __IO hw_iomuxc_ecspi5_mosi_select_input_t ECSPI5_MOSI_SELECT_INPUT; /*!< [0x830] Select Input Register */
    __IO hw_iomuxc_ecspi5_ss0_select_input_t ECSPI5_SS0_SELECT_INPUT; /*!< [0x834] Select Input Register */
    __IO hw_iomuxc_ecspi5_ss1_select_input_t ECSPI5_SS1_SELECT_INPUT; /*!< [0x838] Select Input Register */
    __IO hw_iomuxc_enet_ref_clk_select_input_t ENET_REF_CLK_SELECT_INPUT; /*!< [0x83C] Select Input Register */
    __IO hw_iomuxc_enet_mac0_mdio_select_input_t ENET_MAC0_MDIO_SELECT_INPUT; /*!< [0x840] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_clk_select_input_t ENET_MAC0_RX_CLK_SELECT_INPUT; /*!< [0x844] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_data0_select_input_t ENET_MAC0_RX_DATA0_SELECT_INPUT; /*!< [0x848] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_data1_select_input_t ENET_MAC0_RX_DATA1_SELECT_INPUT; /*!< [0x84C] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_data2_select_input_t ENET_MAC0_RX_DATA2_SELECT_INPUT; /*!< [0x850] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_data3_select_input_t ENET_MAC0_RX_DATA3_SELECT_INPUT; /*!< [0x854] Select Input Register */
    __IO hw_iomuxc_enet_mac0_rx_en_select_input_t ENET_MAC0_RX_EN_SELECT_INPUT; /*!< [0x858] Select Input Register */
    __IO hw_iomuxc_esai_rx_fs_select_input_t ESAI_RX_FS_SELECT_INPUT; /*!< [0x85C] Select Input Register */
    __IO hw_iomuxc_esai_tx_fs_select_input_t ESAI_TX_FS_SELECT_INPUT; /*!< [0x860] Select Input Register */
    __IO hw_iomuxc_esai_rx_hf_clk_select_input_t ESAI_RX_HF_CLK_SELECT_INPUT; /*!< [0x864] Select Input Register */
    __IO hw_iomuxc_esai_tx_hf_clk_select_input_t ESAI_TX_HF_CLK_SELECT_INPUT; /*!< [0x868] Select Input Register */
    __IO hw_iomuxc_esai_rx_clk_select_input_t ESAI_RX_CLK_SELECT_INPUT; /*!< [0x86C] Select Input Register */
    __IO hw_iomuxc_esai_tx_clk_select_input_t ESAI_TX_CLK_SELECT_INPUT; /*!< [0x870] Select Input Register */
    __IO hw_iomuxc_esai_sdo0_select_input_t ESAI_SDO0_SELECT_INPUT; /*!< [0x874] Select Input Register */
    __IO hw_iomuxc_esai_sdo1_select_input_t ESAI_SDO1_SELECT_INPUT; /*!< [0x878] Select Input Register */
    __IO hw_iomuxc_esai_sdo2_sdi3_select_input_t ESAI_SDO2_SDI3_SELECT_INPUT; /*!< [0x87C] Select Input Register */
    __IO hw_iomuxc_esai_sdo3_sdi2_select_input_t ESAI_SDO3_SDI2_SELECT_INPUT; /*!< [0x880] Select Input Register */
    __IO hw_iomuxc_esai_sdo4_sdi1_select_input_t ESAI_SDO4_SDI1_SELECT_INPUT; /*!< [0x884] Select Input Register */
    __IO hw_iomuxc_esai_sdo5_sdi0_select_input_t ESAI_SDO5_SDI0_SELECT_INPUT; /*!< [0x888] Select Input Register */
    __IO hw_iomuxc_hdmi_icecin_select_input_t HDMI_ICECIN_SELECT_INPUT; /*!< [0x88C] Select Input Register */
    __IO hw_iomuxc_hdmi_ii2c_clkin_select_input_t HDMI_II2C_CLKIN_SELECT_INPUT; /*!< [0x890] Select Input Register */
    __IO hw_iomuxc_hdmi_ii2c_datain_select_input_t HDMI_II2C_DATAIN_SELECT_INPUT; /*!< [0x894] Select Input Register */
    __IO hw_iomuxc_i2c1_scl_in_select_input_t I2C1_SCL_IN_SELECT_INPUT; /*!< [0x898] Select Input Register */
    __IO hw_iomuxc_i2c1_sda_in_select_input_t I2C1_SDA_IN_SELECT_INPUT; /*!< [0x89C] Select Input Register */
    __IO hw_iomuxc_i2c2_scl_in_select_input_t I2C2_SCL_IN_SELECT_INPUT; /*!< [0x8A0] Select Input Register */
    __IO hw_iomuxc_i2c2_sda_in_select_input_t I2C2_SDA_IN_SELECT_INPUT; /*!< [0x8A4] Select Input Register */
    __IO hw_iomuxc_i2c3_scl_in_select_input_t I2C3_SCL_IN_SELECT_INPUT; /*!< [0x8A8] Select Input Register */
    __IO hw_iomuxc_i2c3_sda_in_select_input_t I2C3_SDA_IN_SELECT_INPUT; /*!< [0x8AC] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data10_select_input_t IPU2_SENS1_DATA10_SELECT_INPUT; /*!< [0x8B0] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data11_select_input_t IPU2_SENS1_DATA11_SELECT_INPUT; /*!< [0x8B4] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data12_select_input_t IPU2_SENS1_DATA12_SELECT_INPUT; /*!< [0x8B8] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data13_select_input_t IPU2_SENS1_DATA13_SELECT_INPUT; /*!< [0x8BC] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data14_select_input_t IPU2_SENS1_DATA14_SELECT_INPUT; /*!< [0x8C0] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data15_select_input_t IPU2_SENS1_DATA15_SELECT_INPUT; /*!< [0x8C4] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data16_select_input_t IPU2_SENS1_DATA16_SELECT_INPUT; /*!< [0x8C8] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data17_select_input_t IPU2_SENS1_DATA17_SELECT_INPUT; /*!< [0x8CC] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data18_select_input_t IPU2_SENS1_DATA18_SELECT_INPUT; /*!< [0x8D0] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data19_select_input_t IPU2_SENS1_DATA19_SELECT_INPUT; /*!< [0x8D4] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_data_en_select_input_t IPU2_SENS1_DATA_EN_SELECT_INPUT; /*!< [0x8D8] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_hsync_select_input_t IPU2_SENS1_HSYNC_SELECT_INPUT; /*!< [0x8DC] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_pix_clk_select_input_t IPU2_SENS1_PIX_CLK_SELECT_INPUT; /*!< [0x8E0] Select Input Register */
    __IO hw_iomuxc_ipu2_sens1_vsync_select_input_t IPU2_SENS1_VSYNC_SELECT_INPUT; /*!< [0x8E4] Select Input Register */
    __IO hw_iomuxc_key_col5_select_input_t KEY_COL5_SELECT_INPUT; /*!< [0x8E8] Select Input Register */
    __IO hw_iomuxc_key_col6_select_input_t KEY_COL6_SELECT_INPUT; /*!< [0x8EC] Select Input Register */
    __IO hw_iomuxc_key_col7_select_input_t KEY_COL7_SELECT_INPUT; /*!< [0x8F0] Select Input Register */
    __IO hw_iomuxc_key_row5_select_input_t KEY_ROW5_SELECT_INPUT; /*!< [0x8F4] Select Input Register */
    __IO hw_iomuxc_key_row6_select_input_t KEY_ROW6_SELECT_INPUT; /*!< [0x8F8] Select Input Register */
    __IO hw_iomuxc_key_row7_select_input_t KEY_ROW7_SELECT_INPUT; /*!< [0x8FC] Select Input Register */
    __IO hw_iomuxc_mlb_mlb_clk_in_select_input_t MLB_MLB_CLK_IN_SELECT_INPUT; /*!< [0x900] Select Input Register */
    __IO hw_iomuxc_mlb_mlb_data_in_select_input_t MLB_MLB_DATA_IN_SELECT_INPUT; /*!< [0x904] Select Input Register */
    __IO hw_iomuxc_mlb_mlb_sig_in_select_input_t MLB_MLB_SIG_IN_SELECT_INPUT; /*!< [0x908] Select Input Register */
    __IO hw_iomuxc_sdma_events14_select_input_t SDMA_EVENTS14_SELECT_INPUT; /*!< [0x90C] Select Input Register */
    __IO hw_iomuxc_sdma_events47_select_input_t SDMA_EVENTS47_SELECT_INPUT; /*!< [0x910] Select Input Register */
    __IO hw_iomuxc_spdif_spdif_in1_select_input_t SPDIF_SPDIF_IN1_SELECT_INPUT; /*!< [0x914] Select Input Register */
    __IO hw_iomuxc_spdif_tx_clk2_select_input_t SPDIF_TX_CLK2_SELECT_INPUT; /*!< [0x918] Select Input Register */
    __IO hw_iomuxc_uart1_uart_rts_b_select_input_t UART1_UART_RTS_B_SELECT_INPUT; /*!< [0x91C] Select Input Register */
    __IO hw_iomuxc_uart1_uart_rx_data_select_input_t UART1_UART_RX_DATA_SELECT_INPUT; /*!< [0x920] Select Input Register */
    __IO hw_iomuxc_uart2_uart_rts_b_select_input_t UART2_UART_RTS_B_SELECT_INPUT; /*!< [0x924] Select Input Register */
    __IO hw_iomuxc_uart2_uart_rx_data_select_input_t UART2_UART_RX_DATA_SELECT_INPUT; /*!< [0x928] Select Input Register */
    __IO hw_iomuxc_uart3_uart_rts_b_select_input_t UART3_UART_RTS_B_SELECT_INPUT; /*!< [0x92C] Select Input Register */
    __IO hw_iomuxc_uart3_uart_rx_data_select_input_t UART3_UART_RX_DATA_SELECT_INPUT; /*!< [0x930] Select Input Register */
    __IO hw_iomuxc_uart4_uart_rts_b_select_input_t UART4_UART_RTS_B_SELECT_INPUT; /*!< [0x934] Select Input Register */
    __IO hw_iomuxc_uart4_uart_rx_data_select_input_t UART4_UART_RX_DATA_SELECT_INPUT; /*!< [0x938] Select Input Register */
    __IO hw_iomuxc_uart5_uart_rts_b_select_input_t UART5_UART_RTS_B_SELECT_INPUT; /*!< [0x93C] Select Input Register */
    __IO hw_iomuxc_uart5_uart_rx_data_select_input_t UART5_UART_RX_DATA_SELECT_INPUT; /*!< [0x940] Select Input Register */
    __IO hw_iomuxc_usb_otg_oc_select_input_t USB_OTG_OC_SELECT_INPUT; /*!< [0x944] Select Input Register */
    __IO hw_iomuxc_usb_h1_oc_select_input_t USB_H1_OC_SELECT_INPUT; /*!< [0x948] Select Input Register */
    __IO hw_iomuxc_usdhc1_wp_on_select_input_t USDHC1_WP_ON_SELECT_INPUT; /*!< [0x94C] Select Input Register */
} hw_iomuxc_t;
#pragma pack()

/*! @brief Macro to access all IOMUXC registers. */
/*! @param x IOMUXC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_IOMUXC_REGS(IOMUXC_BASE)</code>. */
#define HW_IOMUXC_REGS(x) (*(hw_iomuxc_t *)(x))

/*
 * iMX6DP IPU
 *
 * IPU Registers
 *
 * Registers defined in this header file:
 * - HW_IPU_CONF - Configuration Register
 * - HW_IPU_SISG_CTRL0 - SISG Control 0 Register
 * - HW_IPU_SISG_CTRL1 - SISG Control 1 Register
 * - HW_IPU_SISG_SET_i - SISG Set<i> Register
 * - HW_IPU_SISG_CLR_i - SISG Clear <i> Register
 * - HW_IPU_INT_CTRL_1 - Interrupt Control Register 1
 * - HW_IPU_INT_CTRL_2 - Interrupt Control Register 2
 * - HW_IPU_INT_CTRL_3 - Interrupt Control Register 3
 * - HW_IPU_INT_CTRL_4 - Interrupt Control Register 4
 * - HW_IPU_INT_CTRL_5 - Interrupt Control Register 5
 * - HW_IPU_INT_CTRL_6 - Interrupt Control Register 6
 * - HW_IPU_INT_CTRL_7 - Interrupt Control Register 7
 * - HW_IPU_INT_CTRL_8 - Interrupt Control Register 8
 * - HW_IPU_INT_CTRL_9 - Interrupt Control Register 9
 * - HW_IPU_INT_CTRL_10 - Interrupt Control Register 10
 * - HW_IPU_INT_CTRL_11 - Interrupt Control Register 11
 * - HW_IPU_INT_CTRL_12 - Interrupt Control Register 12
 * - HW_IPU_INT_CTRL_13 - Interrupt Control Register 13
 * - HW_IPU_INT_CTRL_14 - Interrupt Control Register 14
 * - HW_IPU_INT_CTRL_15 - Interrupt Control Register15
 * - HW_IPU_SDMA_EVENT_1 - SDMA Event Control Register 1
 * - HW_IPU_SDMA_EVENT_2 - SDMA Event Control Register 2
 * - HW_IPU_SDMA_EVENT_3 - SDMA Event Control Register 3
 * - HW_IPU_SDMA_EVENT_4 - SDMA Event Control Register 4
 * - HW_IPU_SDMA_EVENT_7 - SDMA Event Control Register 7
 * - HW_IPU_SDMA_EVENT_8 - SDMA Event Control Register 8
 * - HW_IPU_SDMA_EVENT_11 - SDMA Event Control Register 11
 * - HW_IPU_SDMA_EVENT_12 - SDMA Event Control Register 12
 * - HW_IPU_SDMA_EVENT_13 - SDMA Event Control Register 13
 * - HW_IPU_SDMA_EVENT_14 - SDMA Event Control Register 14
 * - HW_IPU_SRM_PRI1 - Shadow Registers Memory Priority 1 Register
 * - HW_IPU_SRM_PRI2 - Shadow Registers Memory Priority 2 Register
 * - HW_IPU_FS_PROC_FLOW1 - FSU Processing Flow 1 Register
 * - HW_IPU_FS_PROC_FLOW2 - FSU Processing Flow 2 Register
 * - HW_IPU_FS_PROC_FLOW3 - FSU Processing Flow 3 Register
 * - HW_IPU_FS_DISP_FLOW1 - FSU Displaying Flow 1 Register
 * - HW_IPU_FS_DISP_FLOW2 - FSU Displaying Flow 2 Register
 * - HW_IPU_SKIP - SKIP Register
 * - HW_IPU_DISP_ALT_CONF - Display Alternate Configuration Register
 * - HW_IPU_DISP_GEN - Display General Control Register
 * - HW_IPU_DISP_ALT1 - Display Alternate Flow Control Register 1
 * - HW_IPU_DISP_ALT2 - Display Alternate Flow Control Register 2
 * - HW_IPU_DISP_ALT3 - Display Alternate Flow Control Register 3
 * - HW_IPU_DISP_ALT4 - Display Alternate Flow Control Register 4
 * - HW_IPU_MEM_RST - Memory Reset Control Register
 * - HW_IPU_PM - Power Modes Control Register
 * - HW_IPU_GPR - General Purpose Register
 * - HW_IPU_CH_DB_MODE_SEL0 - Channel Double Buffer Mode Select 0 Register
 * - HW_IPU_CH_DB_MODE_SEL1 - Channel Double Buffer Mode Select 1 Register
 * - HW_IPU_ALT_CH_DB_MODE_SEL0 - Alternate Channel Double Buffer Mode Select 0 Register
 * - HW_IPU_ALT_CH_DB_MODE_SEL1 - Alternate Channel Double Buffer Mode Select1 Register
 * - HW_IPU_ALT_CH_TRB_MODE_SEL0 - Alternate Channel Triple Buffer Mode Select 0 Register
 * - HW_IPU_ALT_CH_TRB_MODE_SEL1 - Alternate Channel Triple Buffer Mode Select 1 Register
 * - HW_IPU_INT_STAT_1 - Interrupt Status Register 1
 * - HW_IPU_INT_STAT_2 - Interrupt Status Register2
 * - HW_IPU_INT_STAT_3 - Interrupt Status Register 3
 * - HW_IPU_INT_STAT_4 - Interrupt Status Register 4
 * - HW_IPU_INT_STAT_5 - Interrupt Status Register 5
 * - HW_IPU_INT_STAT_6 - Interrupt Status Register 6
 * - HW_IPU_INT_STAT_7 - Interrupt Status Register7 1
 * - HW_IPU_INT_STAT_8 - Interrupt Status Register 8
 * - HW_IPU_INT_STAT_9 - Interrupt Status Register 9
 * - HW_IPU_INT_STAT_10 - Interrupt Status Register 10
 * - HW_IPU_INT_STAT_11 - Interrupt Status Register 11
 * - HW_IPU_INT_STAT_12 - Interrupt Status Register 12
 * - HW_IPU_INT_STAT_13 - Interrupt Status Register 13
 * - HW_IPU_INT_STAT_14 - Interrupt Status Register 14
 * - HW_IPU_INT_STAT_15 - Interrupt Status Register 15
 * - HW_IPU_CUR_BUF_0 - Current Buffer Register 0
 * - HW_IPU_CUR_BUF_1 - Current Buffer Register 1
 * - HW_IPU_ALT_CUR_0 - Alternate Current Buffer Register 0
 * - HW_IPU_ALT_CUR_1 - Alternate Current Buffer Register 1
 * - HW_IPU_SRM_STAT - Shadow Registers Memory Status Register
 * - HW_IPU_PROC_TASKS_STAT - Processing Status Tasks Register
 * - HW_IPU_DISP_TASKS_STAT - Display Tasks Status Register
 * - HW_IPU_TRIPLE_CUR_BUF_0 - Triple Current Buffer Register 0
 * - HW_IPU_TRIPLE_CUR_BUF_1 - Triple Current Buffer Register 1
 * - HW_IPU_TRIPLE_CUR_BUF_2 - Triple Current Buffer Register 2
 * - HW_IPU_TRIPLE_CUR_BUF_3 - Triple Current Buffer Register 3
 * - HW_IPU_CH_BUF0_RDY0 - IPU Channels Buffer 0 Ready 0 Register
 * - HW_IPU_CH_BUF0_RDY1 - IPU Channels Buffer 0 Ready 1 Register
 * - HW_IPU_CH_BUF1_RDY0 - IPU Channels Buffer 1 Ready 0 Register
 * - HW_IPU_CH_BUF1_RDY1 - IPU Channels Buffer 1 Ready 1Register
 * - HW_IPU_ALT_CH_BUF0_RDY0 - IPU Alternate Channels Buffer 0 Ready 0 Register
 * - HW_IPU_ALT_CH_BUF0_RDY1 - IPU Alternate Channels Buffer 0 Ready 1 Register
 * - HW_IPU_ALT_CH_BUF1_RDY0 - IPU Alternate Channels Buffer1 Ready 0 Register
 * - HW_IPU_ALT_CH_BUF1_RDY1 - IPU Alternate Channels Buffer 1 Ready 1 Register
 * - HW_IPU_CH_BUF2_RDY0 - IPU Channels Buffer 2 Ready 0 Register
 * - HW_IPU_CH_BUF2_RDY1 - IPU Channels Buffer 2 Ready 1 Register
 * - HW_IPU_IDMAC_CONF - IDMAC Configuration Register
 * - HW_IPU_IDMAC_CH_EN_1 - IDMAC Channel Enable 1 Register
 * - HW_IPU_IDMAC_CH_EN_2 - IDMAC Channel Enable 2 Register
 * - HW_IPU_IDMAC_SEP_ALPHA - IDMAC Separate Alpha Indication Register
 * - HW_IPU_IDMAC_ALT_SEP_ALPHA - IDMAC Alternate Separate Alpha Indication Register
 * - HW_IPU_IDMAC_CH_PRI_1 - IDMAC Channel Priority 1 Register
 * - HW_IPU_IDMAC_CH_PRI_2 - IDMAC Channel Priority 2 Register
 * - HW_IPU_IDMAC_WM_EN_1 - IDMAC Channel Watermark Enable 1 Register
 * - HW_IPU_IDMAC_WM_EN_2 - IDMAC Channel Watermark Enable 2 Register
 * - HW_IPU_IDMAC_LOCK_EN_1 - IDMAC Channel Lock Enable 1Register
 * - HW_IPU_IDMAC_LOCK_EN_2 - IDMAC Channel Lock Enable 2Register
 * - HW_IPU_IDMAC_SUB_ADDR_0 - IDMAC Channel Alternate Address 0 Register
 * - HW_IPU_IDMAC_SUB_ADDR_1 - IDMAC Channel Alternate Address 1 Register
 * - HW_IPU_IDMAC_SUB_ADDR_2 - IDMAC Channel Alternate Address 2 Register
 * - HW_IPU_IDMAC_SUB_ADDR_3 - IDMAC Channel Alternate Address 3 Register
 * - HW_IPU_IDMAC_SUB_ADDR_4 - IDMAC Channel Alternate Address 4 Register
 * - HW_IPU_IDMAC_BNDM_EN_1 - IDMAC Band Mode Enable 1 Register
 * - HW_IPU_IDMAC_BNDM_EN_2 - IDMAC Band Mode Enable 2 Register
 * - HW_IPU_IDMAC_SC_CORD - IDMAC Scroll Coordinations Register
 * - HW_IPU_IDMAC_SC_CORD_1 - IDMAC Scroll Coordinations Register 1
 * - HW_IPU_IDMAC_CH_BUSY_1 - IDMAC Channel Busy 1 Register
 * - HW_IPU_IDMAC_CH_BUSY_2 - IDMAC Channel Busy 2 Register
 * - HW_IPU_DP_COM_CONF_SYNC - DP Common Configuration Sync Flow Register
 * - HW_IPU_DP_Graph_Wind_CTRL_SYNC - DP Graphic Window Control Sync Flow Register
 * - HW_IPU_DP_FG_POS_SYNC - DP Partial Plane Window Position Sync Flow Register
 * - HW_IPU_DP_CUR_POS_SYNC - DP Cursor Position and Size Sync Flow Register
 * - HW_IPU_DP_CUR_MAP_SYNC - DP Color Cursor Mapping Sync Flow Register
 * - HW_IPU_DP_GAMMA_C_SYNC_i - DP Gamma Constants Sync Flow Register i
 * - HW_IPU_DP_GAMMA_S_SYNC_i - DP Gamma Correction Slope Sync Flow Register i
 * - HW_IPU_DP_CSCA_SYNC_i - DP Color Space Conversion Control Sync Flow Registers
 * - HW_IPU_DP_SCS_SYNC_0 - DP Color Conversion Control Sync Flow Register 0
 * - HW_IPU_DP_SCS_SYNC_1 - DP Color Conversion Control Sync Flow Register 1
 * - HW_IPU_DP_CUR_POS_ALT - DP Cursor Position and Size Alternate Register
 * - HW_IPU_DP_COM_CONF_ASYNC0 - DP Common Configuration Async 0 Flow Register
 * - HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0 - DP Graphic Window Control Async 0 Flow Register
 * - HW_IPU_DP_FG_POS_ASYNC0 - DP Partial Plane Window Position Async 0 Flow Register
 * - HW_IPU_DP_CUR_POS_ASYNC0 - DP Cursor Position and Size Async 0 Flow Register
 * - HW_IPU_DP_CUR_MAP_ASYNC0 - DP Color Cursor Mapping Async 0 Flow Register
 * - HW_IPU_DP_GAMMA_C_ASYNC0_i - DP Gamma Constant Async 0 Flow Register i
 * - HW_IPU_DP_GAMMA_S_ASYNC0_i - DP Gamma Correction Slope Async 0 Flow Register i
 * - HW_IPU_DP_CSCA_ASYNC0_i - DP Color Space Conversion Control Async 0 Flow Register i
 * - HW_IPU_DP_CSC_ASYNC0_0 - DP Color Conversion Control Async 0 Flow Register 0
 * - HW_IPU_DP_CSC_ASYNC_1 - DP Color Conversion Control Async 1 Flow Register
 * - HW_IPU_DP_COM_CONF_ASYNC1 - DP Common Configuration Async 1 Flow Register
 * - HW_IPU_DP_DEBUG_CNT - DP Debug Control Register
 * - HW_IPU_DP_DEBUG_STAT - DP Debug Status Register
 * - HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1 - DP Graphic Window Control Async 1 Flow Register
 * - HW_IPU_DP_FG_POS_ASYNC1 - DP Partial Plane Window Position Async 1 Flow Register
 * - HW_IPU_DP_CUR_POS_ASYNC1 - DP Cursor Postion and Size Async 1 Flow Register
 * - HW_IPU_DP_CUR_MAP_ASYNC1 - DP Color Cursor Mapping Async 1 Flow Register
 * - HW_IPU_DP_GAMMA_C_ASYNC1_i - DP Gamma Constants Async 1 Flow Register i
 * - HW_IPU_DP_GAMMA_S_ASYN1_i - DP Gamma Correction Slope Async 1 Flow Register i
 * - HW_IPU_DP_CSCA_ASYNC1_i - DP Color Space Converstion Control Async 1 Flow Register i
 * - HW_IPU_DP_CSC_ASYNC1_0 - DP Color Conversion Control Async 1 Flow Register 0
 * - HW_IPU_DP_CSC_ASYNC1_1 - DP Color Conversion Control Async 1 Flow Register 1
 * - HW_IPU_IC_CONF - IC Configuration Register
 * - HW_IPU_IC_PRP_ENC_RSC - IC Preprocessing Encoder Resizing Coefficients Register
 * - HW_IPU_IC_PRP_VF_RSC - IC Preprocessing View-Finder Resizing Coefficients Register
 * - HW_IPU_IC_PP_RSC - IC Postprocessing Encoder Resizing Coefficients Register
 * - HW_IPU_IC_CMBP_1 - IC Combining Parameters Register 1
 * - HW_IPU_IC_CMBP_2 - IC Combining Parameters Register 2
 * - HW_IPU_IC_IDMAC_1 - IC IDMAC Parameters 1 Register
 * - HW_IPU_IC_IDMAC_2 - IC IDMAC Parameters 2 Register
 * - HW_IPU_IC_IDMAC_3 - IC IDMAC Parameters 3Register
 * - HW_IPU_IC_IDMAC_4 - IC IDMAC Parameters 4 Register
 * - HW_IPU_CSI0_SENS_CONF - CSI0 Sensor Configuration Register
 * - HW_IPU_CSI0_SENS_FRM_SIZE - CSI0 Sense Frame Size Register
 * - HW_IPU_CSI0_ACT_FRM_SIZE - CSI0 Actual Frame Size Register
 * - HW_IPU_CSI0_OUT_FRM_CTRL - CSI0 Output Control Register
 * - HW_IPU_CSI0_TST_CTRL - CSIO Test Control Register
 * - HW_IPU_CSI0_CCIR_CODE_1 - CSIO CCIR Code Register 1
 * - HW_IPU_CSI0_CCIR_CODE_2 - CSIO CCIR Code Register 2
 * - HW_IPU_CSI0_CCIR_CODE_3 - CSIO CCIR Code Register 3
 * - HW_IPU_CSI0_DI - CSI0 Data Identifier Register
 * - HW_IPU_CSI0_SKIP - CSI0 SKIP Register
 * - HW_IPU_CSIO_CPD_CTRL - CSI0 Compander Control Register
 * - HW_IPU_CSIO_CPD_RC_i - CSI0 Red Component Compander Constants Register <i>
 * - HW_IPU_CSIO_CPD_RS_i - CSI0 Red Component Compander SLOPE Register <i>
 * - HW_IPU_CSIO_CPD_GRC_i - CSI0 GR Component Compander Constants Register <i>
 * - HW_IPU_CSIO_CPD_GRS_i - CSI0 GR Component Compander SLOPE Register <i>
 * - HW_IPU_CSIO_CPD_GBC_i - CSI0 GB Component Compander Constants Register <i>
 * - HW_IPU_CSIO_CPD_GBS_i - CSI0 GB Component Compander SLOPE Register <i>
 * - HW_IPU_CSIO_CPD_BC_i - CSI0 Blue Component Compander Constants Register <i>
 * - HW_IPU_CSIO_CPD_BS_i - CSI0 Blue Component Compander SLOPE Register <i>
 * - HW_IPU_CSI0_CPD_OFFSET1 - CSI0 Compander Offset Register 1
 * - HW_IPU_CSI0_CPD_OFFSET2 - CSI0 Compander Offset Register 2
 * - HW_IPU_CSI1_SENS_CONF - CSI1 Sensor Configuration Register
 * - HW_IPU_CSI1_SENS_FRM_SIZE - CSI1 Sense Frame Size Register
 * - HW_IPU_CSI1_ACT_FRM_SIZE - CSI1 Actual Frame Size Register
 * - HW_IPU_CSI1_OUT_FRM_CTRL - CSI1 Output Control Register
 * - HW_IPU_CSI1_TST_CTRL - CSI1 Test Control Register
 * - HW_IPU_CSI1_CCIR_CODE_1 - CSI1 CCIR Code Register 1
 * - HW_IPU_CSI1_CCIR_CODE_2 - CSI1 CCIR Code Register 2
 * - HW_IPU_CSI1_CCIR_CODE_3 - CSI1 CCIR Code Register 3
 * - HW_IPU_CSI1_DI - CSI1 Data Identifier Register
 * - HW_IPU_CSI1_SKIP - CSI1 SKIP Register
 * - HW_IPU_CSI1_CPD_CTRL - CSI1 Compander Control Register
 * - HW_IPU_CSI1_CPD_RC_i - CSI1 Red Component Compander Constants Register <i>
 * - HW_IPU_CSI1_CPD_RS_i - CSI1 Red Component Compander SLOPE Register <i>
 * - HW_IPU_CSI1_CPD_GRC_i - CSI1 GR Component Compander Constants Register <i>
 * - HW_IPU_CSI1_CPD_GRS_i - CSI1 GR Component Compander SLOPE Register <i>
 * - HW_IPU_CSI1_CPD_GBC_i - CSI1 GB Component Compander Constants Register <i>
 * - HW_IPU_CSI1_CPD_GBS_i - CSI1 GB Component Compander SLOPE Register <i>
 * - HW_IPU_CSI1_CPD_BC_i - CSI1 Blue Component Compander Constants Register <i>
 * - HW_IPU_CSI1_CPD_BS_i - CSI1 Blue Component Compander SLOPE Register <i>
 * - HW_IPU_CSI1_CPD_OFFSET1 - CSI1 Compander Offset Register 1
 * - HW_IPU_CSI1_CPD_OFFSET2 - CSI1 Compander Offset Register 2
 * - HW_IPU_DI0_GENERAL - DI0 General Register
 * - HW_IPU_DI0_BS_CLKGEN0 - DI0 Base Sync Clock Gen 0 Register
 * - HW_IPU_DI0_BS_CLKGEN1 - DI0 Base Sync Clock Gen 1 Register
 * - HW_IPU_DI0_SW_GEN0_1 - DI0 Sync Wave Gen 1 Register 0
 * - HW_IPU_DI0_SW_GEN0_2 - DI0 Sync Wave Gen 2 Register 0
 * - HW_IPU_DI0_SW_GEN0_3 - DI0 Sync Wave Gen 3 Register 0
 * - HW_IPU_DI0_SW_GEN0_4 - DI0 Sync Wave Gen 4 Register 0
 * - HW_IPU_DI0_SW_GEN0_5 - DI0 Sync Wave Gen 5 Register 0
 * - HW_IPU_DI0_SW_GEN0_6 - DI0 Sync Wave Gen 6 Register 0
 * - HW_IPU_DI0_SW_GEN0_7 - DI0 Sync Wave Gen 7 Register 0
 * - HW_IPU_DI0_SW_GEN0_8 - DI0 Sync Wave Gen 8 Register 0
 * - HW_IPU_DI0_SW_GEN0_9 - DI0 Sync Wave Gen 9 Register 0
 * - HW_IPU_DI0_SW_GEN1_1 - DI0 Sync Wave Gen 1 Register 1
 * - HW_IPU_DI0_SW_GEN1_2 - DI0 Sync Wave Gen 2 Register 1
 * - HW_IPU_DI0_SW_GEN1_3 - DI0 Sync Wave Gen 3 Register 1
 * - HW_IPU_DI0_SW_GEN1_4 - DI0 Sync Wave Gen 4 Register 1
 * - HW_IPU_DI0_SW_GEN1_5 - DI0 Sync Wave Gen 5 Register 1
 * - HW_IPU_DI0_SW_GEN1_6 - DI0 Sync Wave Gen 6 Register 1
 * - HW_IPU_DI0_SW_GEN1_7 - DI0 Sync Wave Gen 7 Register 1
 * - HW_IPU_DI0_SW_GEN1_8 - DI0 Sync Wave Gen 8 Register 1
 * - HW_IPU_DI0_SW_GEN1_9 - DI0 Sync Wave Gen 9 Register 1
 * - HW_IPU_DI0_SYNC_AS_GEN - DI0 Sync Assistance Gen Register
 * - HW_IPU_DI0_DW_GEN_i - DI0 Data Wave Gen <i> Register
 * - HW_IPU_DI0_DW_SET0_i - DI0 Data Wave Set 0 <i> Register
 * - HW_IPU_DI0_DW_SET1_i - DI0 Data Wave Set 1 <i> Register
 * - HW_IPU_DI0_DW_SET2_i - DI0 Data Wave Set 2 <i> Register
 * - HW_IPU_DI0_DW_SET3_i - DI0 Data Wave Set 3 <i> Register
 * - HW_IPU_DI0_STP_REP_i - DI0 Step Repeat <i> Registers
 * - HW_IPU_DI0_STP_REP_9 - DI0 Step Repeat 9 Registers
 * - HW_IPU_DI0_SER_CONF - DI0 Serial Display Control Register
 * - HW_IPU_DI0_SSC - DI0 Special Signals Control Register
 * - HW_IPU_DI0_POL - DI0 Polarity Register
 * - HW_IPU_DI0_AW0 - DI0 Active Window 0 Register
 * - HW_IPU_DI0_AW1 - DI0 Active Window 1 Register
 * - HW_IPU_DI0_SCR_CONF - DI0 Screen Configuration Register
 * - HW_IPU_DI0_STAT - DI0 Status Register
 * - HW_IPU_DI1_GENERAL - DI1General Register
 * - HW_IPU_DI1_BS_CLKGEN0 - DI1 Base Sync Clock Gen 0 Register
 * - HW_IPU_DI1_BS_CLKGEN1 - DI1 Base Sync Clock Gen 1 Register
 * - HW_IPU_DI1_SW_GEN0_1 - DI1 Sync Wave Gen 1 Register 0
 * - HW_IPU_DI1_SW_GEN0_2 - DI1 Sync Wave Gen 2 Register 0
 * - HW_IPU_DI1_SW_GEN0_3 - DI1 Sync Wave Gen 3 Register 0
 * - HW_IPU_DI1_SW_GEN0_4 - DI1 Sync Wave Gen 4 Register 0
 * - HW_IPU_DI1_SW_GEN0_5 - DI1 Sync Wave Gen 5 Register 0
 * - HW_IPU_DI1_SW_GEN0_6 - DI1 Sync Wave Gen 6 Register 0
 * - HW_IPU_DI1_SW_GEN0_7 - DI1 Sync Wave Gen 7 Register 0
 * - HW_IPU_DI1_SW_GEN0_8 - DI1 Sync Wave Gen 8 Register 0
 * - HW_IPU_DI1_SW_GEN0_9 - DI1Sync Wave Gen 9 Register 0
 * - HW_IPU_DI1_SW_GEN1_1 - DI1 Sync Wave Gen 1 Register 1
 * - HW_IPU_DI1_SW_GEN1_2 - DI1 Sync Wave Gen 2 Register 1
 * - HW_IPU_DI1_SW_GEN1_3 - DI1 Sync Wave Gen 3 Register 1
 * - HW_IPU_DI1_SW_GEN1_4 - DI1 Sync Wave Gen 4 Register 1
 * - HW_IPU_DI1_SW_GEN1_5 - DI1 Sync Wave Gen 5 Register 1
 * - HW_IPU_DI1_SW_GEN1_6 - DI1 Sync Wave Gen 6 Register 1
 * - HW_IPU_DI1_SW_GEN1_7 - DI1Sync Wave Gen 7 Register 1
 * - HW_IPU_DI1_SW_GEN1_8 - DI1 Sync Wave Gen 8 Register 1
 * - HW_IPU_DI1_SW_GEN1_9 - DI1 Sync Wave Gen 9 Register 1
 * - HW_IPU_DI1_SYNC_AS_GEN - DI1 Sync Assistance Gen Register
 * - HW_IPU_DI1_DW_GEN_i - DI1 Data Wave Gen <i> Register
 * - HW_IPU_DI1_DW_SET0_i - DI1 Data Wave Set 0 <i> Register
 * - HW_IPU_DI1_DW_SET1_i - DI1 Data Wave Set 1 <i> Register
 * - HW_IPU_DI1_DW_SET2_i - DI1 Data Wave Set 2 <i> Register
 * - HW_IPU_DI1_DW_SET3_i - DI1 Data Wave Set 3 <i> Register
 * - HW_IPU_D1_STP_REP_i - DI1 Step Repeat <i> Registers
 * - HW_IPU_DI1_STP_REP_9 - DI1Step Repeat 9 Registers
 * - HW_IPU_DI1_SER_CONF - DI1 Serial Display Control Register
 * - HW_IPU_DI1_SSC - DI1 Special Signals Control Register
 * - HW_IPU_DI1_POL - DI1 Polarity Register
 * - HW_IPU_DI1_AW0 - DI1Active Window 0 Register
 * - HW_IPU_DI1_AW1 - DI1 Active Window 1 Register
 * - HW_IPU_DI1_SCR_CONF - DI1 Screen Configuration Register
 * - HW_IPU_DI1_STAT - DI1 Status Register
 * - HW_IPU_SMFC_MAP - SMFC Mapping Register
 * - HW_IPU_SMFC_WMC - SMFC Watermark Control Register
 * - HW_IPU_SMFC_BS - SMFC Burst Size Register
 * - HW_IPU_DC_READ_CH_CONF - DC Read Channel Configuration Register
 * - HW_IPU_DC_READ_SH_ADDR - DC Read Channel Start Address Register
 * - HW_IPU_DC_RL0_CH_0 - DC Routine Link Register 0 Channel 0
 * - HW_IPU_DC_RL1_CH_0 - DC Routine Link Register 1 Channel 0
 * - HW_IPU_DC_RL2_CH_0 - DC Routine Link Register2 Channel 0
 * - HW_IPU_DC_RL3_CH_0 - DC Routine Link Registe3 Channel 0
 * - HW_IPU_DC_RL4_CH_0 - DC Routine Link Register 4 Channel 0
 * - HW_IPU_DC_WR_CH_CONF_1 - DC Write Channel 1 Configuration Register
 * - HW_IPU_DC_WR_CH_ADDR_1 - DC Write Channel 1 Address Configuration Register
 * - HW_IPU_DC_RL0_CH_1 - DC Routine Link Register 0 Channel 1
 * - HW_IPU_DC_RL1_CH_1 - DC Routine Link Register 1 Channel 1
 * - HW_IPU_DC_RL2_CH_1 - DC Routine Link Register 2 Channel 1
 * - HW_IPU_DC_RL3_CH_1 - DC Routine Link Register 3 Channel 1
 * - HW_IPU_DC_RL4_CH_1 - DC Routine Link Register 4 Channel 1
 * - HW_IPU_DC_WR_CH_CONF_2 - DC Write Channel 2 Configuration Register
 * - HW_IPU_DC_WR_CH_ADDR_2 - DC Write Channel 2 Address Configuration Register
 * - HW_IPU_DC_RL0_CH_2 - DC Routine Link Register 0 Channel 2
 * - HW_IPU_DC_RL1_CH_2 - DC Routine Link Register 1 Channel 2
 * - HW_IPU_DC_RL2_CH_2 - DC Routine Link Register 2 Channel 2
 * - HW_IPU_DC_RL3_CH_2 - DC Routine Link Register 3 Channel 2
 * - HW_IPU_DC_RL4_CH_2 - DC Routine Link Register 4 Channel 2
 * - HW_IPU_DC_CMD_CH_CONF_3 - DC Command Channel 3 Configuration Register
 * - HW_IPU_DC_CMD_CH_CONF_4 - DC Command Channel 4 Configuration Register
 * - HW_IPU_DC_WR_CH_CONF_5 - DC Write Channel 5Configuration Register
 * - HW_IPU_DC_WR_CH_ADDR_5 - DC Write Channel 5Address Configuration Register
 * - HW_IPU_DC_RL0_CH_5 - DC Routine Link Register 0 Channel 5
 * - HW_IPU_DC_RL1_CH_5 - DC Routine Link Register 1 Channel 5
 * - HW_IPU_DC_RL2_CH_5 - DC Routine Link Register 2 Channel 5
 * - HW_IPU_DC_RL3_CH_5 - DC Routine Link Register3 Channel 5
 * - HW_IPU_DC_RL4_CH_5 - DC Routine Link Register 4 Channel 5
 * - HW_IPU_DC_WR_CH_CONF_6 - DC Write Channel 6 Configuration Register
 * - HW_IPU_DC_WR_CH_ADDR_6 - DC Write Channel 6 Address Configuration Register
 * - HW_IPU_DC_RL0_CH_6 - DC Routine Link Register 0Channel 6
 * - HW_IPU_DC_RL1_CH_6 - DC Routine Link Register 1 Channel 6
 * - HW_IPU_DC_RL2_CH_6 - DC Routine Link Register 2 Channel 6
 * - HW_IPU_DC_RL3_CH_6 - DC Routine Link Register 3 Channel 6
 * - HW_IPU_DC_RL4_CH_6 - DC Routine Link Register 4 Channel 6
 * - HW_IPU_DC_WR_CH_CONF1_8 - DC Write Channel 8 Configuration 1Register
 * - HW_IPU_DC_WR_CH_CONF2_8 - DC Write Channel 8 Configuration 2 Register
 * - HW_IPU_DC_RL1_CH_8 - DC Routine Link Register 1 Channel 8
 * - HW_IPU_DC_RL2_CH_8 - DC Routine Link Register 2 Channel 8
 * - HW_IPU_DC_RL3_CH_8 - DC Routine Link Register 3 Channel 8
 * - HW_IPU_DC_RL4_CH_8 - DC Routine Link Register 4 Channel 8
 * - HW_IPU_DC_RL5_CH_8 - DC Routine Link Register 5 Channel 8
 * - HW_IPU_DC_RL6_CH_8 - DC Routine Link Register 6 Channel 8
 * - HW_IPU_DC_WR_CH_CONF1_9 - DC Write Channel 9 Configuration 1Register
 * - HW_IPU_DC_WR_CH_CONF2_9 - DC Write Channel 9Configuration 2Register
 * - HW_IPU_DC_RL1_CH_9 - DC Routine Link Register 1 Channel 9
 * - HW_IPU_DC_RL2_CH_9 - DC Routine Link Register 2 Channel 9
 * - HW_IPU_DC_RL3_CH_9 - DC Routine Link Register 3Channel 9
 * - HW_IPU_DC_RL4_CH_9 - DC Routine Link Register 4 Channel 9
 * - HW_IPU_DC_RL5_CH_9 - DC Routine Link Register 5 Channel 9
 * - HW_IPU_DC_RL6_CH_9 - DC Routine Link Register 6 Channel 9
 * - HW_IPU_DC_GEN - DC General Register
 * - HW_IPU_DC_DISP_CONF1_0 - DC Display Configuration 1 Register 0
 * - HW_IPU_DC_DISP_CONF1_1 - DC Display Configuration 1 Register 1
 * - HW_IPU_DC_DISP_CONF1_2 - DC Display Configuration 1 Register 2
 * - HW_IPU_DC_DISP_CONF1_3 - DC Display Configuration 1 Register 3
 * - HW_IPU_DC_DISP_CONF2_0 - DC Display Configuration 2 Register 0
 * - HW_IPU_DC_DISP_CONF2_1 - DC Display Configuration 2 Register 1
 * - HW_IPU_DC_DISP_CONF2_2 - DC Display Configuration 2 Register 2
 * - HW_IPU_DC_DISP_CONF2_3 - DC Display Configuration 2 Register 3
 * - HW_IPU_DC_DI0_CONF_1 - DC DI0Configuration Register 1
 * - HW_IPU_DC_DI0_CONF_2 - DC DI0Configuration Register 2
 * - HW_IPU_DC_DI1_CONF_1 - DC DI1Configuration Register 1
 * - HW_IPU_DC_DI1_CONF_2 - DC DI1Configuration Register 2
 * - HW_IPU_DC_MAP_CONF_0 - DC Mapping Configuration Register 0
 * - HW_IPU_DC_MAP_CONF_1 - DC Mapping Configuration Register 1
 * - HW_IPU_DC_MAP_CONF_2 - DC Mapping Configuration Register 2
 * - HW_IPU_DC_MAP_CONF_3 - DC Mapping Configuration Register 3
 * - HW_IPU_DC_MAP_CONF_4 - DC Mapping Configuration Register 4
 * - HW_IPU_DC_MAP_CONF_5 - DC Mapping Configuration Register 5
 * - HW_IPU_DC_MAP_CONF_6 - DC Mapping Configuration Register 6
 * - HW_IPU_DC_MAP_CONF_7 - DC Mapping Configuration Register 7
 * - HW_IPU_DC_MAP_CONF_8 - DC Mapping Configuration Register 8
 * - HW_IPU_DC_MAP_CONF_9 - DC Mapping Configuration Register 9
 * - HW_IPU_DC_MAP_CONF_10 - DC Mapping Configuration Register 10
 * - HW_IPU_DC_MAP_CONF_11 - DC Mapping Configuration Register 11
 * - HW_IPU_DC_MAP_CONF_12 - DC Mapping Configuration Register 12
 * - HW_IPU_DC_MAP_CONF_13 - DC Mapping Configuration Register 13
 * - HW_IPU_DC_MAP_CONF_14 - DC Mapping Configuration Register 14
 * - HW_IPU_DC_MAP_CONF_15 - DC Mapping Configuration Register 15
 * - HW_IPU_DC_MAP_CONF_16 - DC Mapping Configuration Register 16
 * - HW_IPU_DC_MAP_CONF_17 - DC Mapping Configuration Register 17
 * - HW_IPU_DC_MAP_CONF_18 - DC Mapping Configuration Register 18
 * - HW_IPU_DC_MAP_CONF_19 - DC Mapping Configuration Register 19
 * - HW_IPU_DC_MAP_CONF_20 - DC Mapping Configuration Register 20
 * - HW_IPU_DC_MAP_CONF_21 - DC Mapping Configuration Register 21
 * - HW_IPU_DC_MAP_CONF_22 - DC Mapping Configuration Register 22
 * - HW_IPU_DC_MAP_CONF_23 - DC Mapping Configuration Register 23
 * - HW_IPU_DC_MAP_CONF_24 - DC Mapping Configuration Register 24
 * - HW_IPU_DC_MAP_CONF_25 - DC Mapping Configuration Register 25
 * - HW_IPU_DC_MAP_CONF_26 - DC Mapping Configuration Register 26
 * - HW_IPU_DC_UGDE0_0 - DC User General Data Event 0 Register 0
 * - HW_IPU_DC_UGDE0_1 - DC User General Data Event 0 Register 1
 * - HW_IPU_DC_UGDE0_2 - DC User General Data Event 0 Register2
 * - HW_IPU_DC_UGDE0_3 - DC User General Data Event 0 Register 3
 * - HW_IPU_DC_UGDE1_0 - DC User General Data Event 1Register0
 * - HW_IPU_DC_UGDE1_1 - DC User General Data Event 1 Register 1
 * - HW_IPU_DC_UGDE1_2 - DC User General Data Event 1Register 2
 * - HW_IPU_DC_UGDE1_3 - DC User General Data Event 1Register 3
 * - HW_IPU_DC_UGDE2_0 - DC User General Data Event 2 Register 0
 * - HW_IPU_DC_UGDE2_1 - DC User General Data Event 2 Register 1
 * - HW_IPU_DC_UGDE2_2 - DC User General Data Event 2Register 2
 * - HW_IPU_DC_UGDE2_3 - DC User General Data Event 2Register 3
 * - HW_IPU_DC_UGDE3_0 - DC User General Data Event 3Register 0
 * - HW_IPU_DC_UGDE3_1 - DC User General Data Event 3Register 1
 * - HW_IPU_DC_UGDE3_2 - DC User General Data Event 3Register 2
 * - HW_IPU_DC_UGDE3_3 - DC User General Data Event 3Register 2
 * - HW_IPU_DC_LLA0 - DC Low Level Access Control Register 0
 * - HW_IPU_DC_LLA1 - DC Low Level Access Control Register 1
 * - HW_IPU_DC_R_LLA0 - DC Read Low Level Read Access Control Register 0
 * - HW_IPU_DC_R_LLA1 - DC Read Low Level Read Access Control Register1
 * - HW_IPU_DC_WR_CH_ADDR_5_ALT - DC Write Channel 5 Configuration Register
 * - HW_IPU_DC_STAT - DC Status Register
 * - HW_IPU_DMFC_RD_CHAN - DMFC Read Channel Register
 * - HW_IPU_DMFC_WR_CHAN - DMFC Write Channel Register
 * - HW_IPU_DMFC_WR_CHAN_DEF - DMFC Write Channel Definition Register
 * - HW_IPU_DMFC_DP_CHAN - DMFC Display Processor Channel Register
 * - HW_IPU_DMFC_DP_CHAN_DEF - DMFC Display Processor Channel Definition Register
 * - HW_IPU_DMFC_GENERAL_1 - DMFC General 1 Register
 * - HW_IPU_DMFC_GENERAL_2 - DMFC General 2 Register
 * - HW_IPU_DMFC_IC_CTRL - DMFC IC Interface Control Register
 * - HW_IPU_DMFC_WR_CHAN_ALT - DMFC Write Channel Alternate Register
 * - HW_IPU_DMFC_WR_CHAN_DEF_ALT - DMFC Write Channel Definition Alternate Register
 * - HW_IPU_DMFC_DP_CHAN_ALT - DMFC MFC Display Processor Channel Alternate Register
 * - HW_IPU_DMFC_DP_CHAN_DEF_ALT - DMFC Display Channel Definition Alternate Register
 * - HW_IPU_DMFC_GENERAL1_ALT - DMFC General 1 Alternate Register
 * - HW_IPU_DMFC_STAT - DMFC Status Register
 * - HW_IPU_VDI_FSIZE - VDI Field Size Register
 * - HW_IPU_VDI_C - VDI Control Register
 * - HW_IPU_VDI_C2_ - VDI Control Register 2
 * - HW_IPU_VDI_CMDP_1 - VDI Combining Parameters Register 1
 * - HW_IPU_VDI_CMDP_2 - VDI Combining Parameters Register 2
 * - HW_IPU_VDI_PS_1 - VDI Plane Size Register 1
 * - HW_IPU_VDI_PS_2 - VDI Plane Size Register 2
 * - HW_IPU_VDI_PS_3 - VDI Plane Size Register 3
 * - HW_IPU_VDI_PS_4 - VDI Plane Size Register 4
 *
 * - hw_ipu_t - Struct containing all module registers.
 */

#define HW_IPU_INSTANCE_COUNT (2U) /*!< Number of instances of the IPU module. */
#define HW_IPU1 (0U) /*!< Instance number for IPU1. */
#define HW_IPU2 (1U) /*!< Instance number for IPU2. */
#define IPU1_BASE             (0x2600000U) /*!< Base address for IPU1. */
#define IPU2_BASE             (0x2A00000U) /*!< Base address for IPU2. */
/*! Array initializer of IPU base addresses. */
#define IPU_BASE_ADDRS        { IPU1_BASE, IPU2_BASE }

/*******************************************************************************
 * HW_IPU_CONF - Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CONF - Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_conf
{
    uint32_t U;
    struct _hw_ipu_conf_bitfields
    {
        uint32_t CSI0_EN : 1;          /*!< [0]  */
        uint32_t CSI1_EN : 1;          /*!< [1]  */
        uint32_t IC_EN : 1;            /*!< [2]  */
        uint32_t IRT_EN : 1;           /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DP_EN : 1;            /*!< [5]  */
        uint32_t DI0_EN : 1;           /*!< [6]  */
        uint32_t DI1_EN : 1;           /*!< [7]  */
        uint32_t SMFC_EN : 1;          /*!< [8]  */
        uint32_t DC_EN : 1;            /*!< [9]  */
        uint32_t DMFC_EN : 1;          /*!< [10]  */
        uint32_t SISG_EN : 1;          /*!< [11]  */
        uint32_t VDI_EN : 1;           /*!< [12]  */
        uint32_t RESERVED1 : 9;        /*!< [21:13]  */
        uint32_t IDMAC_DISABLE : 1;    /*!< [22]  */
        uint32_t RESERVED2 : 2;        /*!< [24:23]  */
        uint32_t IC_DMFC_SEL : 1;      /*!< [25]  */
        uint32_t IC_DMFC_SYNC : 1;     /*!< [26]  */
        uint32_t VDI_DMFC_SYNC : 1;    /*!< [27]  */
        uint32_t CSI0_DATA_SOURCE : 1; /*!< [28]  */
        uint32_t CSI1_DATA_SOURCE : 1; /*!< [29]  */
        uint32_t IC_INPUT : 1;         /*!< [30]  */
        uint32_t CSI_SEL : 1;          /*!< [31]  */
    } B;
} hw_ipu_conf_t;

/*!
 * @name Constants and macros for entire IPU_CONF register
 */
/*@{*/
#define HW_IPU_CONF_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_IPU_CONF(x)           (*(__IO hw_ipu_conf_t *) HW_IPU_CONF_ADDR(x))
#define HW_IPU_CONF_RD(x)        (HW_IPU_CONF(x).U)
#define HW_IPU_CONF_WR(x, v)     (HW_IPU_CONF(x).U = (v))
#define HW_IPU_CONF_SET(x, v)    (HW_IPU_CONF_WR(x, HW_IPU_CONF_RD(x) |  (v)))
#define HW_IPU_CONF_CLR(x, v)    (HW_IPU_CONF_WR(x, HW_IPU_CONF_RD(x) & ~(v)))
#define HW_IPU_CONF_TOG(x, v)    (HW_IPU_CONF_WR(x, HW_IPU_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CONF bitfields
 */

/*!
 * @name Register IPU_CONF, field CSI0_EN[0] (RW)
 *
 * Camera Sensor Interface 0 Enable bit
 *
 * Values:
 * - 0 - CSI0 is disabled
 * - 1 - CSI0 is enabled
 */
/*@{*/
#define BP_IPU_CONF_CSI0_EN  (0U)          /*!< Bit position for IPU_CONF_CSI0_EN. */
#define BM_IPU_CONF_CSI0_EN  (0x00000001U) /*!< Bit mask for IPU_CONF_CSI0_EN. */
#define BS_IPU_CONF_CSI0_EN  (1U)          /*!< Bit field size in bits for IPU_CONF_CSI0_EN. */

/*! @brief Read current value of the IPU_CONF_CSI0_EN field. */
#define BR_IPU_CONF_CSI0_EN(x) (HW_IPU_CONF(x).B.CSI0_EN)

/*! @brief Format value for bitfield IPU_CONF_CSI0_EN. */
#define BF_IPU_CONF_CSI0_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_CSI0_EN) & BM_IPU_CONF_CSI0_EN)

/*! @brief Set the CSI0_EN field to a new value. */
#define BW_IPU_CONF_CSI0_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_CSI0_EN) | BF_IPU_CONF_CSI0_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field CSI1_EN[1] (RW)
 *
 * Camera Sensor Interface 1 Enable bit
 *
 * Values:
 * - 0 - CSI1 is disabled
 * - 1 - CSI1 is enabled
 */
/*@{*/
#define BP_IPU_CONF_CSI1_EN  (1U)          /*!< Bit position for IPU_CONF_CSI1_EN. */
#define BM_IPU_CONF_CSI1_EN  (0x00000002U) /*!< Bit mask for IPU_CONF_CSI1_EN. */
#define BS_IPU_CONF_CSI1_EN  (1U)          /*!< Bit field size in bits for IPU_CONF_CSI1_EN. */

/*! @brief Read current value of the IPU_CONF_CSI1_EN field. */
#define BR_IPU_CONF_CSI1_EN(x) (HW_IPU_CONF(x).B.CSI1_EN)

/*! @brief Format value for bitfield IPU_CONF_CSI1_EN. */
#define BF_IPU_CONF_CSI1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_CSI1_EN) & BM_IPU_CONF_CSI1_EN)

/*! @brief Set the CSI1_EN field to a new value. */
#define BW_IPU_CONF_CSI1_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_CSI1_EN) | BF_IPU_CONF_CSI1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IC_EN[2] (RW)
 *
 * Image Conversion Sub-Block Enable bit
 *
 * Values:
 * - 0 - IC is disabled
 * - 1 - IC is enabled
 */
/*@{*/
#define BP_IPU_CONF_IC_EN    (2U)          /*!< Bit position for IPU_CONF_IC_EN. */
#define BM_IPU_CONF_IC_EN    (0x00000004U) /*!< Bit mask for IPU_CONF_IC_EN. */
#define BS_IPU_CONF_IC_EN    (1U)          /*!< Bit field size in bits for IPU_CONF_IC_EN. */

/*! @brief Read current value of the IPU_CONF_IC_EN field. */
#define BR_IPU_CONF_IC_EN(x) (HW_IPU_CONF(x).B.IC_EN)

/*! @brief Format value for bitfield IPU_CONF_IC_EN. */
#define BF_IPU_CONF_IC_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IC_EN) & BM_IPU_CONF_IC_EN)

/*! @brief Set the IC_EN field to a new value. */
#define BW_IPU_CONF_IC_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IC_EN) | BF_IPU_CONF_IC_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IRT_EN[3] (RW)
 *
 * Image Rotation Sub-Block Enable bit
 *
 * Values:
 * - 0 - IRT is disabled
 * - 1 - IRT is enabled
 */
/*@{*/
#define BP_IPU_CONF_IRT_EN   (3U)          /*!< Bit position for IPU_CONF_IRT_EN. */
#define BM_IPU_CONF_IRT_EN   (0x00000008U) /*!< Bit mask for IPU_CONF_IRT_EN. */
#define BS_IPU_CONF_IRT_EN   (1U)          /*!< Bit field size in bits for IPU_CONF_IRT_EN. */

/*! @brief Read current value of the IPU_CONF_IRT_EN field. */
#define BR_IPU_CONF_IRT_EN(x) (HW_IPU_CONF(x).B.IRT_EN)

/*! @brief Format value for bitfield IPU_CONF_IRT_EN. */
#define BF_IPU_CONF_IRT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IRT_EN) & BM_IPU_CONF_IRT_EN)

/*! @brief Set the IRT_EN field to a new value. */
#define BW_IPU_CONF_IRT_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IRT_EN) | BF_IPU_CONF_IRT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field DP_EN[5] (RW)
 *
 * Display processor Sub-block Enable bit
 *
 * Values:
 * - 0 - DP is disabled
 * - 1 - DP is enabled
 */
/*@{*/
#define BP_IPU_CONF_DP_EN    (5U)          /*!< Bit position for IPU_CONF_DP_EN. */
#define BM_IPU_CONF_DP_EN    (0x00000020U) /*!< Bit mask for IPU_CONF_DP_EN. */
#define BS_IPU_CONF_DP_EN    (1U)          /*!< Bit field size in bits for IPU_CONF_DP_EN. */

/*! @brief Read current value of the IPU_CONF_DP_EN field. */
#define BR_IPU_CONF_DP_EN(x) (HW_IPU_CONF(x).B.DP_EN)

/*! @brief Format value for bitfield IPU_CONF_DP_EN. */
#define BF_IPU_CONF_DP_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_DP_EN) & BM_IPU_CONF_DP_EN)

/*! @brief Set the DP_EN field to a new value. */
#define BW_IPU_CONF_DP_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_DP_EN) | BF_IPU_CONF_DP_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field DI0_EN[6] (RW)
 *
 * Display interface Sub-block 0 Enable bit
 *
 * Values:
 * - 0 - DI0 is disabled
 * - 1 - DI0 is enabled
 */
/*@{*/
#define BP_IPU_CONF_DI0_EN   (6U)          /*!< Bit position for IPU_CONF_DI0_EN. */
#define BM_IPU_CONF_DI0_EN   (0x00000040U) /*!< Bit mask for IPU_CONF_DI0_EN. */
#define BS_IPU_CONF_DI0_EN   (1U)          /*!< Bit field size in bits for IPU_CONF_DI0_EN. */

/*! @brief Read current value of the IPU_CONF_DI0_EN field. */
#define BR_IPU_CONF_DI0_EN(x) (HW_IPU_CONF(x).B.DI0_EN)

/*! @brief Format value for bitfield IPU_CONF_DI0_EN. */
#define BF_IPU_CONF_DI0_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_DI0_EN) & BM_IPU_CONF_DI0_EN)

/*! @brief Set the DI0_EN field to a new value. */
#define BW_IPU_CONF_DI0_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_DI0_EN) | BF_IPU_CONF_DI0_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field DI1_EN[7] (RW)
 *
 * Display Interface Sub-block 1 Enable bit
 *
 * Values:
 * - 0 - DI1 is disabled
 * - 1 - DI1 is enabled
 */
/*@{*/
#define BP_IPU_CONF_DI1_EN   (7U)          /*!< Bit position for IPU_CONF_DI1_EN. */
#define BM_IPU_CONF_DI1_EN   (0x00000080U) /*!< Bit mask for IPU_CONF_DI1_EN. */
#define BS_IPU_CONF_DI1_EN   (1U)          /*!< Bit field size in bits for IPU_CONF_DI1_EN. */

/*! @brief Read current value of the IPU_CONF_DI1_EN field. */
#define BR_IPU_CONF_DI1_EN(x) (HW_IPU_CONF(x).B.DI1_EN)

/*! @brief Format value for bitfield IPU_CONF_DI1_EN. */
#define BF_IPU_CONF_DI1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_DI1_EN) & BM_IPU_CONF_DI1_EN)

/*! @brief Set the DI1_EN field to a new value. */
#define BW_IPU_CONF_DI1_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_DI1_EN) | BF_IPU_CONF_DI1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field SMFC_EN[8] (RW)
 *
 * Sensor's Multi FIFO Controller Sub-block (SMFC) Enable bit
 *
 * Values:
 * - 0 - SMFC is disabled
 * - 1 - SMFC is enabled
 */
/*@{*/
#define BP_IPU_CONF_SMFC_EN  (8U)          /*!< Bit position for IPU_CONF_SMFC_EN. */
#define BM_IPU_CONF_SMFC_EN  (0x00000100U) /*!< Bit mask for IPU_CONF_SMFC_EN. */
#define BS_IPU_CONF_SMFC_EN  (1U)          /*!< Bit field size in bits for IPU_CONF_SMFC_EN. */

/*! @brief Read current value of the IPU_CONF_SMFC_EN field. */
#define BR_IPU_CONF_SMFC_EN(x) (HW_IPU_CONF(x).B.SMFC_EN)

/*! @brief Format value for bitfield IPU_CONF_SMFC_EN. */
#define BF_IPU_CONF_SMFC_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_SMFC_EN) & BM_IPU_CONF_SMFC_EN)

/*! @brief Set the SMFC_EN field to a new value. */
#define BW_IPU_CONF_SMFC_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_SMFC_EN) | BF_IPU_CONF_SMFC_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field DC_EN[9] (RW)
 *
 * Display Controller sub-block (DC) Enable bit
 *
 * Values:
 * - 0 - DC is disabled
 * - 1 - DC is enabled
 */
/*@{*/
#define BP_IPU_CONF_DC_EN    (9U)          /*!< Bit position for IPU_CONF_DC_EN. */
#define BM_IPU_CONF_DC_EN    (0x00000200U) /*!< Bit mask for IPU_CONF_DC_EN. */
#define BS_IPU_CONF_DC_EN    (1U)          /*!< Bit field size in bits for IPU_CONF_DC_EN. */

/*! @brief Read current value of the IPU_CONF_DC_EN field. */
#define BR_IPU_CONF_DC_EN(x) (HW_IPU_CONF(x).B.DC_EN)

/*! @brief Format value for bitfield IPU_CONF_DC_EN. */
#define BF_IPU_CONF_DC_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_DC_EN) & BM_IPU_CONF_DC_EN)

/*! @brief Set the DC_EN field to a new value. */
#define BW_IPU_CONF_DC_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_DC_EN) | BF_IPU_CONF_DC_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field DMFC_EN[10] (RW)
 *
 * Display's Multi FIFO Controller sub-block (DMFC) Enable bit
 *
 * Values:
 * - 0 - DMFC is disabled
 * - 1 - DMFC is enabled
 */
/*@{*/
#define BP_IPU_CONF_DMFC_EN  (10U)         /*!< Bit position for IPU_CONF_DMFC_EN. */
#define BM_IPU_CONF_DMFC_EN  (0x00000400U) /*!< Bit mask for IPU_CONF_DMFC_EN. */
#define BS_IPU_CONF_DMFC_EN  (1U)          /*!< Bit field size in bits for IPU_CONF_DMFC_EN. */

/*! @brief Read current value of the IPU_CONF_DMFC_EN field. */
#define BR_IPU_CONF_DMFC_EN(x) (HW_IPU_CONF(x).B.DMFC_EN)

/*! @brief Format value for bitfield IPU_CONF_DMFC_EN. */
#define BF_IPU_CONF_DMFC_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_DMFC_EN) & BM_IPU_CONF_DMFC_EN)

/*! @brief Set the DMFC_EN field to a new value. */
#define BW_IPU_CONF_DMFC_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_DMFC_EN) | BF_IPU_CONF_DMFC_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field SISG_EN[11] (RW)
 *
 * Still Image Synchronization Generator (SISG) Enable bit
 *
 * Values:
 * - 0 - SISG is disabled
 * - 1 - SISG is enabled
 */
/*@{*/
#define BP_IPU_CONF_SISG_EN  (11U)         /*!< Bit position for IPU_CONF_SISG_EN. */
#define BM_IPU_CONF_SISG_EN  (0x00000800U) /*!< Bit mask for IPU_CONF_SISG_EN. */
#define BS_IPU_CONF_SISG_EN  (1U)          /*!< Bit field size in bits for IPU_CONF_SISG_EN. */

/*! @brief Read current value of the IPU_CONF_SISG_EN field. */
#define BR_IPU_CONF_SISG_EN(x) (HW_IPU_CONF(x).B.SISG_EN)

/*! @brief Format value for bitfield IPU_CONF_SISG_EN. */
#define BF_IPU_CONF_SISG_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_SISG_EN) & BM_IPU_CONF_SISG_EN)

/*! @brief Set the SISG_EN field to a new value. */
#define BW_IPU_CONF_SISG_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_SISG_EN) | BF_IPU_CONF_SISG_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field VDI_EN[12] (RW)
 *
 * VDI enable bit. This bit must be cleared if the ISP_EN bit is set.
 *
 * Values:
 * - 0 - VDIC is disabled
 * - 1 - VDIC is enabled
 */
/*@{*/
#define BP_IPU_CONF_VDI_EN   (12U)         /*!< Bit position for IPU_CONF_VDI_EN. */
#define BM_IPU_CONF_VDI_EN   (0x00001000U) /*!< Bit mask for IPU_CONF_VDI_EN. */
#define BS_IPU_CONF_VDI_EN   (1U)          /*!< Bit field size in bits for IPU_CONF_VDI_EN. */

/*! @brief Read current value of the IPU_CONF_VDI_EN field. */
#define BR_IPU_CONF_VDI_EN(x) (HW_IPU_CONF(x).B.VDI_EN)

/*! @brief Format value for bitfield IPU_CONF_VDI_EN. */
#define BF_IPU_CONF_VDI_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_VDI_EN) & BM_IPU_CONF_VDI_EN)

/*! @brief Set the VDI_EN field to a new value. */
#define BW_IPU_CONF_VDI_EN(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_VDI_EN) | BF_IPU_CONF_VDI_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IDMAC_DISABLE[22] (RW)
 *
 * Image DMA controller (IDMAC) disable bit. This bit allows the user to turn
 * off the clock of the IDMAC if the use case permits it. By default the IDMAC is
 * enabled.
 *
 * Values:
 * - 0 - IDMAC is enabled
 * - 1 - IDMAC is disabled
 */
/*@{*/
#define BP_IPU_CONF_IDMAC_DISABLE (22U)    /*!< Bit position for IPU_CONF_IDMAC_DISABLE. */
#define BM_IPU_CONF_IDMAC_DISABLE (0x00400000U) /*!< Bit mask for IPU_CONF_IDMAC_DISABLE. */
#define BS_IPU_CONF_IDMAC_DISABLE (1U)     /*!< Bit field size in bits for IPU_CONF_IDMAC_DISABLE. */

/*! @brief Read current value of the IPU_CONF_IDMAC_DISABLE field. */
#define BR_IPU_CONF_IDMAC_DISABLE(x) (HW_IPU_CONF(x).B.IDMAC_DISABLE)

/*! @brief Format value for bitfield IPU_CONF_IDMAC_DISABLE. */
#define BF_IPU_CONF_IDMAC_DISABLE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IDMAC_DISABLE) & BM_IPU_CONF_IDMAC_DISABLE)

/*! @brief Set the IDMAC_DISABLE field to a new value. */
#define BW_IPU_CONF_IDMAC_DISABLE(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IDMAC_DISABLE) | BF_IPU_CONF_IDMAC_DISABLE(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IC_DMFC_SEL[25] (RW)
 *
 * IC to DMFC select Selects the DMAIC_1 (channel 21) channel's connectivity
 * between the IC and the DMFC
 *
 * Values:
 * - 0 - DMAIC_1 (channel 21) is routed to the IDMAC
 * - 1 - DMAIC_1 (channel 21) is routed to DMFCIn case DMFC was selected the
 *     IDMAC_CH_EN[21] must be clear.
 */
/*@{*/
#define BP_IPU_CONF_IC_DMFC_SEL (25U)      /*!< Bit position for IPU_CONF_IC_DMFC_SEL. */
#define BM_IPU_CONF_IC_DMFC_SEL (0x02000000U) /*!< Bit mask for IPU_CONF_IC_DMFC_SEL. */
#define BS_IPU_CONF_IC_DMFC_SEL (1U)       /*!< Bit field size in bits for IPU_CONF_IC_DMFC_SEL. */

/*! @brief Read current value of the IPU_CONF_IC_DMFC_SEL field. */
#define BR_IPU_CONF_IC_DMFC_SEL(x) (HW_IPU_CONF(x).B.IC_DMFC_SEL)

/*! @brief Format value for bitfield IPU_CONF_IC_DMFC_SEL. */
#define BF_IPU_CONF_IC_DMFC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IC_DMFC_SEL) & BM_IPU_CONF_IC_DMFC_SEL)

/*! @brief Set the IC_DMFC_SEL field to a new value. */
#define BW_IPU_CONF_IC_DMFC_SEL(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IC_DMFC_SEL) | BF_IPU_CONF_IC_DMFC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IC_DMFC_SYNC[26] (RW)
 *
 * IC to DMFC Sync flow This bit defines if the direct flow between IC to DMFC
 * is synchronous or asynchronous
 *
 * Values:
 * - 0 - async flow
 * - 1 - Sync flow
 */
/*@{*/
#define BP_IPU_CONF_IC_DMFC_SYNC (26U)     /*!< Bit position for IPU_CONF_IC_DMFC_SYNC. */
#define BM_IPU_CONF_IC_DMFC_SYNC (0x04000000U) /*!< Bit mask for IPU_CONF_IC_DMFC_SYNC. */
#define BS_IPU_CONF_IC_DMFC_SYNC (1U)      /*!< Bit field size in bits for IPU_CONF_IC_DMFC_SYNC. */

/*! @brief Read current value of the IPU_CONF_IC_DMFC_SYNC field. */
#define BR_IPU_CONF_IC_DMFC_SYNC(x) (HW_IPU_CONF(x).B.IC_DMFC_SYNC)

/*! @brief Format value for bitfield IPU_CONF_IC_DMFC_SYNC. */
#define BF_IPU_CONF_IC_DMFC_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IC_DMFC_SYNC) & BM_IPU_CONF_IC_DMFC_SYNC)

/*! @brief Set the IC_DMFC_SYNC field to a new value. */
#define BW_IPU_CONF_IC_DMFC_SYNC(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IC_DMFC_SYNC) | BF_IPU_CONF_IC_DMFC_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field VDI_DMFC_SYNC[27] (RW)
 *
 * This bit enables the direct path VDIC -> IC_VF -> DMFC for sync flow. If this
 * bit is set IC_DMFC_SEL must be set.
 *
 * Values:
 * - 0 - the flow is disabled
 * - 1 - the flow is enabled
 */
/*@{*/
#define BP_IPU_CONF_VDI_DMFC_SYNC (27U)    /*!< Bit position for IPU_CONF_VDI_DMFC_SYNC. */
#define BM_IPU_CONF_VDI_DMFC_SYNC (0x08000000U) /*!< Bit mask for IPU_CONF_VDI_DMFC_SYNC. */
#define BS_IPU_CONF_VDI_DMFC_SYNC (1U)     /*!< Bit field size in bits for IPU_CONF_VDI_DMFC_SYNC. */

/*! @brief Read current value of the IPU_CONF_VDI_DMFC_SYNC field. */
#define BR_IPU_CONF_VDI_DMFC_SYNC(x) (HW_IPU_CONF(x).B.VDI_DMFC_SYNC)

/*! @brief Format value for bitfield IPU_CONF_VDI_DMFC_SYNC. */
#define BF_IPU_CONF_VDI_DMFC_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_VDI_DMFC_SYNC) & BM_IPU_CONF_VDI_DMFC_SYNC)

/*! @brief Set the VDI_DMFC_SYNC field to a new value. */
#define BW_IPU_CONF_VDI_DMFC_SYNC(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_VDI_DMFC_SYNC) | BF_IPU_CONF_VDI_DMFC_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field CSI0_DATA_SOURCE[28] (RW)
 *
 * CSI0 data Source This bit selects what is the data source for the CSI0. This
 * is a static mux that should not be changed while CSI0 is working. Data is
 * handles differently if the source is MCT (MIPI) or parallel interface.
 *
 * Values:
 * - 0 - Parallel interface is connected to CSI0
 * - 1 - MCT (MIPI) is connected to CSI0
 */
/*@{*/
#define BP_IPU_CONF_CSI0_DATA_SOURCE (28U) /*!< Bit position for IPU_CONF_CSI0_DATA_SOURCE. */
#define BM_IPU_CONF_CSI0_DATA_SOURCE (0x10000000U) /*!< Bit mask for IPU_CONF_CSI0_DATA_SOURCE. */
#define BS_IPU_CONF_CSI0_DATA_SOURCE (1U)  /*!< Bit field size in bits for IPU_CONF_CSI0_DATA_SOURCE. */

/*! @brief Read current value of the IPU_CONF_CSI0_DATA_SOURCE field. */
#define BR_IPU_CONF_CSI0_DATA_SOURCE(x) (HW_IPU_CONF(x).B.CSI0_DATA_SOURCE)

/*! @brief Format value for bitfield IPU_CONF_CSI0_DATA_SOURCE. */
#define BF_IPU_CONF_CSI0_DATA_SOURCE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_CSI0_DATA_SOURCE) & BM_IPU_CONF_CSI0_DATA_SOURCE)

/*! @brief Set the CSI0_DATA_SOURCE field to a new value. */
#define BW_IPU_CONF_CSI0_DATA_SOURCE(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_CSI0_DATA_SOURCE) | BF_IPU_CONF_CSI0_DATA_SOURCE(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field CSI1_DATA_SOURCE[29] (RW)
 *
 * CSI1 data Source This bit selects what is the data source for the CSI1. This
 * is a static mux that should not be changed while CSI1 is working. Data is
 * handles differently if the source is MCT (MIPI) or parallel interface.
 *
 * Values:
 * - 0 - Parallel interface is connected to CSI1
 * - 1 - MCT (MIPI) is connected to CSI1
 */
/*@{*/
#define BP_IPU_CONF_CSI1_DATA_SOURCE (29U) /*!< Bit position for IPU_CONF_CSI1_DATA_SOURCE. */
#define BM_IPU_CONF_CSI1_DATA_SOURCE (0x20000000U) /*!< Bit mask for IPU_CONF_CSI1_DATA_SOURCE. */
#define BS_IPU_CONF_CSI1_DATA_SOURCE (1U)  /*!< Bit field size in bits for IPU_CONF_CSI1_DATA_SOURCE. */

/*! @brief Read current value of the IPU_CONF_CSI1_DATA_SOURCE field. */
#define BR_IPU_CONF_CSI1_DATA_SOURCE(x) (HW_IPU_CONF(x).B.CSI1_DATA_SOURCE)

/*! @brief Format value for bitfield IPU_CONF_CSI1_DATA_SOURCE. */
#define BF_IPU_CONF_CSI1_DATA_SOURCE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_CSI1_DATA_SOURCE) & BM_IPU_CONF_CSI1_DATA_SOURCE)

/*! @brief Set the CSI1_DATA_SOURCE field to a new value. */
#define BW_IPU_CONF_CSI1_DATA_SOURCE(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_CSI1_DATA_SOURCE) | BF_IPU_CONF_CSI1_DATA_SOURCE(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field IC_INPUT[30] (RW)
 *
 * IC Input select bit. This bit selects manually between the 2 inputs to the IC
 *
 * Values:
 * - 0 - CSI0/1 is selected; In order to select between the CSIs use the CSI_SEL
 *     bit.
 * - 1 - VDI
 */
/*@{*/
#define BP_IPU_CONF_IC_INPUT (30U)         /*!< Bit position for IPU_CONF_IC_INPUT. */
#define BM_IPU_CONF_IC_INPUT (0x40000000U) /*!< Bit mask for IPU_CONF_IC_INPUT. */
#define BS_IPU_CONF_IC_INPUT (1U)          /*!< Bit field size in bits for IPU_CONF_IC_INPUT. */

/*! @brief Read current value of the IPU_CONF_IC_INPUT field. */
#define BR_IPU_CONF_IC_INPUT(x) (HW_IPU_CONF(x).B.IC_INPUT)

/*! @brief Format value for bitfield IPU_CONF_IC_INPUT. */
#define BF_IPU_CONF_IC_INPUT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_IC_INPUT) & BM_IPU_CONF_IC_INPUT)

/*! @brief Set the IC_INPUT field to a new value. */
#define BW_IPU_CONF_IC_INPUT(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_IC_INPUT) | BF_IPU_CONF_IC_INPUT(v)))
/*@}*/

/*!
 * @name Register IPU_CONF, field CSI_SEL[31] (RW)
 *
 * CSI select bit; This bit selects manually between the 2 CSI's. This bit
 * defines which CSI is the input to the IC. This bit is effective only if IC_INPUT is
 * bit cleared
 *
 * Values:
 * - 0 - CSI0 is selected
 * - 1 - CSI1 is selected
 */
/*@{*/
#define BP_IPU_CONF_CSI_SEL  (31U)         /*!< Bit position for IPU_CONF_CSI_SEL. */
#define BM_IPU_CONF_CSI_SEL  (0x80000000U) /*!< Bit mask for IPU_CONF_CSI_SEL. */
#define BS_IPU_CONF_CSI_SEL  (1U)          /*!< Bit field size in bits for IPU_CONF_CSI_SEL. */

/*! @brief Read current value of the IPU_CONF_CSI_SEL field. */
#define BR_IPU_CONF_CSI_SEL(x) (HW_IPU_CONF(x).B.CSI_SEL)

/*! @brief Format value for bitfield IPU_CONF_CSI_SEL. */
#define BF_IPU_CONF_CSI_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CONF_CSI_SEL) & BM_IPU_CONF_CSI_SEL)

/*! @brief Set the CSI_SEL field to a new value. */
#define BW_IPU_CONF_CSI_SEL(x, v) (HW_IPU_CONF_WR(x, (HW_IPU_CONF_RD(x) & ~BM_IPU_CONF_CSI_SEL) | BF_IPU_CONF_CSI_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SISG_CTRL0 - SISG Control 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SISG_CTRL0 - SISG Control 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_sisg_ctrl0
{
    uint32_t U;
    struct _hw_ipu_sisg_ctrl0_bitfields
    {
        uint32_t VSYNC_RST_CNT : 1;    /*!< [0]  */
        uint32_t NO_VSYNC_2_STRT_CNT : 3; /*!< [3:1]  */
        uint32_t VAL_STOP_SISG_COUNTER : 25; /*!< [28:4]  */
        uint32_t MCU_ACTV_TRIG : 1;    /*!< [29]  */
        uint32_t EXT_ACTV : 1;         /*!< [30]  */
        uint32_t RESERVED0 : 1;        /*!< [31]  */
    } B;
} hw_ipu_sisg_ctrl0_t;

/*!
 * @name Constants and macros for entire IPU_SISG_CTRL0 register
 */
/*@{*/
#define HW_IPU_SISG_CTRL0_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_IPU_SISG_CTRL0(x)     (*(__IO hw_ipu_sisg_ctrl0_t *) HW_IPU_SISG_CTRL0_ADDR(x))
#define HW_IPU_SISG_CTRL0_RD(x)  (HW_IPU_SISG_CTRL0(x).U)
#define HW_IPU_SISG_CTRL0_WR(x, v) (HW_IPU_SISG_CTRL0(x).U = (v))
#define HW_IPU_SISG_CTRL0_SET(x, v) (HW_IPU_SISG_CTRL0_WR(x, HW_IPU_SISG_CTRL0_RD(x) |  (v)))
#define HW_IPU_SISG_CTRL0_CLR(x, v) (HW_IPU_SISG_CTRL0_WR(x, HW_IPU_SISG_CTRL0_RD(x) & ~(v)))
#define HW_IPU_SISG_CTRL0_TOG(x, v) (HW_IPU_SISG_CTRL0_WR(x, HW_IPU_SISG_CTRL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SISG_CTRL0 bitfields
 */

/*!
 * @name Register IPU_SISG_CTRL0, field VSYNC_RST_CNT[0] (RW)
 *
 * VSYNC Resets counters Defines if the counters are stooped following VSYNC or
 * when the counters reach a pre defined value (VAL_STOP_SISG_COUNTER)
 *
 * Values:
 * - 1 - The counters are stopped at VSYNC
 * - 0 - The counters are stooped when the counters reach the
 *     VAL_STOP_SISG_COUNTER value.
 */
/*@{*/
#define BP_IPU_SISG_CTRL0_VSYNC_RST_CNT (0U) /*!< Bit position for IPU_SISG_CTRL0_VSYNC_RST_CNT. */
#define BM_IPU_SISG_CTRL0_VSYNC_RST_CNT (0x00000001U) /*!< Bit mask for IPU_SISG_CTRL0_VSYNC_RST_CNT. */
#define BS_IPU_SISG_CTRL0_VSYNC_RST_CNT (1U) /*!< Bit field size in bits for IPU_SISG_CTRL0_VSYNC_RST_CNT. */

/*! @brief Read current value of the IPU_SISG_CTRL0_VSYNC_RST_CNT field. */
#define BR_IPU_SISG_CTRL0_VSYNC_RST_CNT(x) (HW_IPU_SISG_CTRL0(x).B.VSYNC_RST_CNT)

/*! @brief Format value for bitfield IPU_SISG_CTRL0_VSYNC_RST_CNT. */
#define BF_IPU_SISG_CTRL0_VSYNC_RST_CNT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL0_VSYNC_RST_CNT) & BM_IPU_SISG_CTRL0_VSYNC_RST_CNT)

/*! @brief Set the VSYNC_RST_CNT field to a new value. */
#define BW_IPU_SISG_CTRL0_VSYNC_RST_CNT(x, v) (HW_IPU_SISG_CTRL0_WR(x, (HW_IPU_SISG_CTRL0_RD(x) & ~BM_IPU_SISG_CTRL0_VSYNC_RST_CNT) | BF_IPU_SISG_CTRL0_VSYNC_RST_CNT(v)))
/*@}*/

/*!
 * @name Register IPU_SISG_CTRL0, field NO_VSYNC_2_STRT_CNT[3:1] (RW)
 *
 * VSYCs to Start Counter This bits define how many VSYNCs signals will be
 * counter before activating the SISG counters. If set to 0 starts immediately. If set
 * to N (1..7) starts after N VSYNCs.
 */
/*@{*/
#define BP_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT (1U) /*!< Bit position for IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT. */
#define BM_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT (0x0000000EU) /*!< Bit mask for IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT. */
#define BS_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT (3U) /*!< Bit field size in bits for IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT. */

/*! @brief Read current value of the IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT field. */
#define BR_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT(x) (HW_IPU_SISG_CTRL0(x).B.NO_VSYNC_2_STRT_CNT)

/*! @brief Format value for bitfield IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT. */
#define BF_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT) & BM_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT)

/*! @brief Set the NO_VSYNC_2_STRT_CNT field to a new value. */
#define BW_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT(x, v) (HW_IPU_SISG_CTRL0_WR(x, (HW_IPU_SISG_CTRL0_RD(x) & ~BM_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT) | BF_IPU_SISG_CTRL0_NO_VSYNC_2_STRT_CNT(v)))
/*@}*/

/*!
 * @name Register IPU_SISG_CTRL0, field VAL_STOP_SISG_COUNTER[28:4] (RW)
 *
 * SISG Stop Counters value. This is a predefined value that stops the SISG
 * counters. The user should write to this field the N-1 value of the desired value.
 */
/*@{*/
#define BP_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER (4U) /*!< Bit position for IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER. */
#define BM_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER (0x1FFFFFF0U) /*!< Bit mask for IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER. */
#define BS_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER (25U) /*!< Bit field size in bits for IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER. */

/*! @brief Read current value of the IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER field. */
#define BR_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER(x) (HW_IPU_SISG_CTRL0(x).B.VAL_STOP_SISG_COUNTER)

/*! @brief Format value for bitfield IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER. */
#define BF_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER) & BM_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER)

/*! @brief Set the VAL_STOP_SISG_COUNTER field to a new value. */
#define BW_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER(x, v) (HW_IPU_SISG_CTRL0_WR(x, (HW_IPU_SISG_CTRL0_RD(x) & ~BM_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER) | BF_IPU_SISG_CTRL0_VAL_STOP_SISG_COUNTER(v)))
/*@}*/

/*!
 * @name Register IPU_SISG_CTRL0, field MCU_ACTV_TRIG[29] (RW)
 *
 * Reserved, should be cleared.
 */
/*@{*/
#define BP_IPU_SISG_CTRL0_MCU_ACTV_TRIG (29U) /*!< Bit position for IPU_SISG_CTRL0_MCU_ACTV_TRIG. */
#define BM_IPU_SISG_CTRL0_MCU_ACTV_TRIG (0x20000000U) /*!< Bit mask for IPU_SISG_CTRL0_MCU_ACTV_TRIG. */
#define BS_IPU_SISG_CTRL0_MCU_ACTV_TRIG (1U) /*!< Bit field size in bits for IPU_SISG_CTRL0_MCU_ACTV_TRIG. */

/*! @brief Read current value of the IPU_SISG_CTRL0_MCU_ACTV_TRIG field. */
#define BR_IPU_SISG_CTRL0_MCU_ACTV_TRIG(x) (HW_IPU_SISG_CTRL0(x).B.MCU_ACTV_TRIG)

/*! @brief Format value for bitfield IPU_SISG_CTRL0_MCU_ACTV_TRIG. */
#define BF_IPU_SISG_CTRL0_MCU_ACTV_TRIG(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL0_MCU_ACTV_TRIG) & BM_IPU_SISG_CTRL0_MCU_ACTV_TRIG)

/*! @brief Set the MCU_ACTV_TRIG field to a new value. */
#define BW_IPU_SISG_CTRL0_MCU_ACTV_TRIG(x, v) (HW_IPU_SISG_CTRL0_WR(x, (HW_IPU_SISG_CTRL0_RD(x) & ~BM_IPU_SISG_CTRL0_MCU_ACTV_TRIG) | BF_IPU_SISG_CTRL0_MCU_ACTV_TRIG(v)))
/*@}*/

/*!
 * @name Register IPU_SISG_CTRL0, field EXT_ACTV[30] (RW)
 *
 * External Active Define if an external active trigger will start the counters.
 * The external active trigger is an input signal to the IPU called ext_actv_trig
 */
/*@{*/
#define BP_IPU_SISG_CTRL0_EXT_ACTV (30U)   /*!< Bit position for IPU_SISG_CTRL0_EXT_ACTV. */
#define BM_IPU_SISG_CTRL0_EXT_ACTV (0x40000000U) /*!< Bit mask for IPU_SISG_CTRL0_EXT_ACTV. */
#define BS_IPU_SISG_CTRL0_EXT_ACTV (1U)    /*!< Bit field size in bits for IPU_SISG_CTRL0_EXT_ACTV. */

/*! @brief Read current value of the IPU_SISG_CTRL0_EXT_ACTV field. */
#define BR_IPU_SISG_CTRL0_EXT_ACTV(x) (HW_IPU_SISG_CTRL0(x).B.EXT_ACTV)

/*! @brief Format value for bitfield IPU_SISG_CTRL0_EXT_ACTV. */
#define BF_IPU_SISG_CTRL0_EXT_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL0_EXT_ACTV) & BM_IPU_SISG_CTRL0_EXT_ACTV)

/*! @brief Set the EXT_ACTV field to a new value. */
#define BW_IPU_SISG_CTRL0_EXT_ACTV(x, v) (HW_IPU_SISG_CTRL0_WR(x, (HW_IPU_SISG_CTRL0_RD(x) & ~BM_IPU_SISG_CTRL0_EXT_ACTV) | BF_IPU_SISG_CTRL0_EXT_ACTV(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SISG_CTRL1 - SISG Control 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SISG_CTRL1 - SISG Control 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_sisg_ctrl1
{
    uint32_t U;
    struct _hw_ipu_sisg_ctrl1_bitfields
    {
        uint32_t SISG_STROBE_CNT : 5;  /*!< [4:0]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t SISG_OUT_POL : 6;     /*!< [13:8]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_sisg_ctrl1_t;

/*!
 * @name Constants and macros for entire IPU_SISG_CTRL1 register
 */
/*@{*/
#define HW_IPU_SISG_CTRL1_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_IPU_SISG_CTRL1(x)     (*(__IO hw_ipu_sisg_ctrl1_t *) HW_IPU_SISG_CTRL1_ADDR(x))
#define HW_IPU_SISG_CTRL1_RD(x)  (HW_IPU_SISG_CTRL1(x).U)
#define HW_IPU_SISG_CTRL1_WR(x, v) (HW_IPU_SISG_CTRL1(x).U = (v))
#define HW_IPU_SISG_CTRL1_SET(x, v) (HW_IPU_SISG_CTRL1_WR(x, HW_IPU_SISG_CTRL1_RD(x) |  (v)))
#define HW_IPU_SISG_CTRL1_CLR(x, v) (HW_IPU_SISG_CTRL1_WR(x, HW_IPU_SISG_CTRL1_RD(x) & ~(v)))
#define HW_IPU_SISG_CTRL1_TOG(x, v) (HW_IPU_SISG_CTRL1_WR(x, HW_IPU_SISG_CTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SISG_CTRL1 bitfields
 */

/*!
 * @name Register IPU_SISG_CTRL1, field SISG_STROBE_CNT[4:0] (RW)
 *
 * SISG Strobe Count The SISG can repeat the sequence for up to 32 cycles; this
 * is used for generating a train of pulses.
 */
/*@{*/
#define BP_IPU_SISG_CTRL1_SISG_STROBE_CNT (0U) /*!< Bit position for IPU_SISG_CTRL1_SISG_STROBE_CNT. */
#define BM_IPU_SISG_CTRL1_SISG_STROBE_CNT (0x0000001FU) /*!< Bit mask for IPU_SISG_CTRL1_SISG_STROBE_CNT. */
#define BS_IPU_SISG_CTRL1_SISG_STROBE_CNT (5U) /*!< Bit field size in bits for IPU_SISG_CTRL1_SISG_STROBE_CNT. */

/*! @brief Read current value of the IPU_SISG_CTRL1_SISG_STROBE_CNT field. */
#define BR_IPU_SISG_CTRL1_SISG_STROBE_CNT(x) (HW_IPU_SISG_CTRL1(x).B.SISG_STROBE_CNT)

/*! @brief Format value for bitfield IPU_SISG_CTRL1_SISG_STROBE_CNT. */
#define BF_IPU_SISG_CTRL1_SISG_STROBE_CNT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL1_SISG_STROBE_CNT) & BM_IPU_SISG_CTRL1_SISG_STROBE_CNT)

/*! @brief Set the SISG_STROBE_CNT field to a new value. */
#define BW_IPU_SISG_CTRL1_SISG_STROBE_CNT(x, v) (HW_IPU_SISG_CTRL1_WR(x, (HW_IPU_SISG_CTRL1_RD(x) & ~BM_IPU_SISG_CTRL1_SISG_STROBE_CNT) | BF_IPU_SISG_CTRL1_SISG_STROBE_CNT(v)))
/*@}*/

/*!
 * @name Register IPU_SISG_CTRL1, field SISG_OUT_POL[13:8] (RW)
 *
 * SISG_OUT_POL This bits defines the polarity of the SISG output signals
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_SISG_CTRL1_SISG_OUT_POL (8U) /*!< Bit position for IPU_SISG_CTRL1_SISG_OUT_POL. */
#define BM_IPU_SISG_CTRL1_SISG_OUT_POL (0x00003F00U) /*!< Bit mask for IPU_SISG_CTRL1_SISG_OUT_POL. */
#define BS_IPU_SISG_CTRL1_SISG_OUT_POL (6U) /*!< Bit field size in bits for IPU_SISG_CTRL1_SISG_OUT_POL. */

/*! @brief Read current value of the IPU_SISG_CTRL1_SISG_OUT_POL field. */
#define BR_IPU_SISG_CTRL1_SISG_OUT_POL(x) (HW_IPU_SISG_CTRL1(x).B.SISG_OUT_POL)

/*! @brief Format value for bitfield IPU_SISG_CTRL1_SISG_OUT_POL. */
#define BF_IPU_SISG_CTRL1_SISG_OUT_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CTRL1_SISG_OUT_POL) & BM_IPU_SISG_CTRL1_SISG_OUT_POL)

/*! @brief Set the SISG_OUT_POL field to a new value. */
#define BW_IPU_SISG_CTRL1_SISG_OUT_POL(x, v) (HW_IPU_SISG_CTRL1_WR(x, (HW_IPU_SISG_CTRL1_RD(x) & ~BM_IPU_SISG_CTRL1_SISG_OUT_POL) | BF_IPU_SISG_CTRL1_SISG_OUT_POL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SISG_SET_i - SISG Set<i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SISG_SET_i - SISG Set<i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_sisg_set_i
{
    uint32_t U;
    struct _hw_ipu_sisg_set_i_bitfields
    {
        uint32_t SISG_SET_i : 25;      /*!< [24:0]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_sisg_set_i_t;

/*!
 * @name Constants and macros for entire IPU_SISG_SET_i register
 */
/*@{*/
#define HW_IPU_SISG_SET_i_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_IPU_SISG_SET_i(x)     (*(__IO hw_ipu_sisg_set_i_t *) HW_IPU_SISG_SET_i_ADDR(x))
#define HW_IPU_SISG_SET_i_RD(x)  (HW_IPU_SISG_SET_i(x).U)
#define HW_IPU_SISG_SET_i_WR(x, v) (HW_IPU_SISG_SET_i(x).U = (v))
#define HW_IPU_SISG_SET_i_SET(x, v) (HW_IPU_SISG_SET_i_WR(x, HW_IPU_SISG_SET_i_RD(x) |  (v)))
#define HW_IPU_SISG_SET_i_CLR(x, v) (HW_IPU_SISG_SET_i_WR(x, HW_IPU_SISG_SET_i_RD(x) & ~(v)))
#define HW_IPU_SISG_SET_i_TOG(x, v) (HW_IPU_SISG_SET_i_WR(x, HW_IPU_SISG_SET_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SISG_SET_i bitfields
 */

/*!
 * @name Register IPU_SISG_SET_i, field SISG_SET_i[24:0] (RW)
 *
 * SISG SET <i> value These bits define the set value of the SISG counter #<i>
 */
/*@{*/
#define BP_IPU_SISG_SET_i_SISG_SET_i (0U)  /*!< Bit position for IPU_SISG_SET_i_SISG_SET_i. */
#define BM_IPU_SISG_SET_i_SISG_SET_i (0x01FFFFFFU) /*!< Bit mask for IPU_SISG_SET_i_SISG_SET_i. */
#define BS_IPU_SISG_SET_i_SISG_SET_i (25U) /*!< Bit field size in bits for IPU_SISG_SET_i_SISG_SET_i. */

/*! @brief Read current value of the IPU_SISG_SET_i_SISG_SET_i field. */
#define BR_IPU_SISG_SET_i_SISG_SET_i(x) (HW_IPU_SISG_SET_i(x).B.SISG_SET_i)

/*! @brief Format value for bitfield IPU_SISG_SET_i_SISG_SET_i. */
#define BF_IPU_SISG_SET_i_SISG_SET_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_SET_i_SISG_SET_i) & BM_IPU_SISG_SET_i_SISG_SET_i)

/*! @brief Set the SISG_SET_i field to a new value. */
#define BW_IPU_SISG_SET_i_SISG_SET_i(x, v) (HW_IPU_SISG_SET_i_WR(x, (HW_IPU_SISG_SET_i_RD(x) & ~BM_IPU_SISG_SET_i_SISG_SET_i) | BF_IPU_SISG_SET_i_SISG_SET_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SISG_CLR_i - SISG Clear <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SISG_CLR_i - SISG Clear <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_sisg_clr_i
{
    uint32_t U;
    struct _hw_ipu_sisg_clr_i_bitfields
    {
        uint32_t SISG_CLEAR_i : 25;    /*!< [24:0]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_sisg_clr_i_t;

/*!
 * @name Constants and macros for entire IPU_SISG_CLR_i register
 */
/*@{*/
#define HW_IPU_SISG_CLR_i_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_IPU_SISG_CLR_i(x)     (*(__IO hw_ipu_sisg_clr_i_t *) HW_IPU_SISG_CLR_i_ADDR(x))
#define HW_IPU_SISG_CLR_i_RD(x)  (HW_IPU_SISG_CLR_i(x).U)
#define HW_IPU_SISG_CLR_i_WR(x, v) (HW_IPU_SISG_CLR_i(x).U = (v))
#define HW_IPU_SISG_CLR_i_SET(x, v) (HW_IPU_SISG_CLR_i_WR(x, HW_IPU_SISG_CLR_i_RD(x) |  (v)))
#define HW_IPU_SISG_CLR_i_CLR(x, v) (HW_IPU_SISG_CLR_i_WR(x, HW_IPU_SISG_CLR_i_RD(x) & ~(v)))
#define HW_IPU_SISG_CLR_i_TOG(x, v) (HW_IPU_SISG_CLR_i_WR(x, HW_IPU_SISG_CLR_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SISG_CLR_i bitfields
 */

/*!
 * @name Register IPU_SISG_CLR_i, field SISG_CLEAR_i[24:0] (RW)
 *
 * SISG CLR <i> value These bits define the clear value of the SISG counter #<i>
 */
/*@{*/
#define BP_IPU_SISG_CLR_i_SISG_CLEAR_i (0U) /*!< Bit position for IPU_SISG_CLR_i_SISG_CLEAR_i. */
#define BM_IPU_SISG_CLR_i_SISG_CLEAR_i (0x01FFFFFFU) /*!< Bit mask for IPU_SISG_CLR_i_SISG_CLEAR_i. */
#define BS_IPU_SISG_CLR_i_SISG_CLEAR_i (25U) /*!< Bit field size in bits for IPU_SISG_CLR_i_SISG_CLEAR_i. */

/*! @brief Read current value of the IPU_SISG_CLR_i_SISG_CLEAR_i field. */
#define BR_IPU_SISG_CLR_i_SISG_CLEAR_i(x) (HW_IPU_SISG_CLR_i(x).B.SISG_CLEAR_i)

/*! @brief Format value for bitfield IPU_SISG_CLR_i_SISG_CLEAR_i. */
#define BF_IPU_SISG_CLR_i_SISG_CLEAR_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SISG_CLR_i_SISG_CLEAR_i) & BM_IPU_SISG_CLR_i_SISG_CLEAR_i)

/*! @brief Set the SISG_CLEAR_i field to a new value. */
#define BW_IPU_SISG_CLR_i_SISG_CLEAR_i(x, v) (HW_IPU_SISG_CLR_i_WR(x, (HW_IPU_SISG_CLR_i_RD(x) & ~BM_IPU_SISG_CLR_i_SISG_CLEAR_i) | BF_IPU_SISG_CLR_i_SISG_CLEAR_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_1 - Interrupt Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_1 - Interrupt Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of EOF
 * (end of frame) of DMA Channels interrupts [31:0] can be found in this register.
 */
typedef union _hw_ipu_int_ctrl_1
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_1_bitfields
    {
        uint32_t IDMAC_EOF_EN_0 : 1;   /*!< [0]  */
        uint32_t IDMAC_EOF_EN_1 : 1;   /*!< [1]  */
        uint32_t IDMAC_EOF_EN_2 : 1;   /*!< [2]  */
        uint32_t IDMAC_EOF_EN_3 : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOF_EN_5 : 1;   /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_EOF_EN_8 : 1;   /*!< [8]  */
        uint32_t IDMAC_EOF_EN_9 : 1;   /*!< [9]  */
        uint32_t IDMAC_EOF_EN_10 : 1;  /*!< [10]  */
        uint32_t IDMAC_EOF_EN_11 : 1;  /*!< [11]  */
        uint32_t IDMAC_EOF_EN_12 : 1;  /*!< [12]  */
        uint32_t IDMAC_EOF_EN_13 : 1;  /*!< [13]  */
        uint32_t IDMAC_EOF_EN_14 : 1;  /*!< [14]  */
        uint32_t IDMAC_EOF_EN_15 : 1;  /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_EOF_EN_17 : 1;  /*!< [17]  */
        uint32_t IDMAC_EOF_EN_18 : 1;  /*!< [18]  */
        uint32_t IDMAC_EOF_EN_19 : 1;  /*!< [19]  */
        uint32_t IDMAC_EOF_EN_20 : 1;  /*!< [20]  */
        uint32_t IDMAC_EOF_EN_21 : 1;  /*!< [21]  */
        uint32_t IDMAC_EOF_EN_22 : 1;  /*!< [22]  */
        uint32_t IDMAC_EOF_EN_23 : 1;  /*!< [23]  */
        uint32_t IDMAC_EOF_EN_24 : 1;  /*!< [24]  */
        uint32_t IDMAC_EOF_EN_25 : 1;  /*!< [25]  */
        uint32_t IDMAC_EOF_EN_26 : 1;  /*!< [26]  */
        uint32_t IDMAC_EOF_EN_27 : 1;  /*!< [27]  */
        uint32_t IDMAC_EOF_EN_28 : 1;  /*!< [28]  */
        uint32_t IDMAC_EOF_EN_29 : 1;  /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOF_EN_31 : 1;  /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_1_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_1 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_1_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_IPU_INT_CTRL_1(x)     (*(__IO hw_ipu_int_ctrl_1_t *) HW_IPU_INT_CTRL_1_ADDR(x))
#define HW_IPU_INT_CTRL_1_RD(x)  (HW_IPU_INT_CTRL_1(x).U)
#define HW_IPU_INT_CTRL_1_WR(x, v) (HW_IPU_INT_CTRL_1(x).U = (v))
#define HW_IPU_INT_CTRL_1_SET(x, v) (HW_IPU_INT_CTRL_1_WR(x, HW_IPU_INT_CTRL_1_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_1_CLR(x, v) (HW_IPU_INT_CTRL_1_WR(x, HW_IPU_INT_CTRL_1_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_1_TOG(x, v) (HW_IPU_INT_CTRL_1_WR(x, HW_IPU_INT_CTRL_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_1 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_0[0] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_0 (0U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_0. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_0. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_0. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_0 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_0(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_0)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_0. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_0) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_0)

/*! @brief Set the IDMAC_EOF_EN_0 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_0(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_0) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_1[1] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_1 (1U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_1. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_1. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_1. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_1 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_1(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_1)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_1. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_1) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_1)

/*! @brief Set the IDMAC_EOF_EN_1 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_1(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_1) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_2[2] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_2 (2U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_2. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_2. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_2. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_2 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_2(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_2)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_2. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_2) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_2)

/*! @brief Set the IDMAC_EOF_EN_2 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_2(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_2) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_3[3] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_3 (3U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_3. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_3. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_3. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_3 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_3(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_3)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_3. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_3) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_3)

/*! @brief Set the IDMAC_EOF_EN_3 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_3(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_3) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_5[5] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_5 (5U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_5. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_5. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_5. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_5 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_5(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_5)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_5. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_5) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_5)

/*! @brief Set the IDMAC_EOF_EN_5 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_5(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_5) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_8[8] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_8 (8U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_8. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_8 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_8. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_8 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_8. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_8 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_8(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_8)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_8. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_8) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_8)

/*! @brief Set the IDMAC_EOF_EN_8 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_8(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_8) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_9[9] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_9 (9U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_9. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_9 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_9. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_9 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_9. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_9 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_9(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_9)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_9. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_9) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_9)

/*! @brief Set the IDMAC_EOF_EN_9 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_9(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_9) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_10[10] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_10 (10U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_10. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_10 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_10. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_10 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_10. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_10 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_10(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_10)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_10. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_10) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_10)

/*! @brief Set the IDMAC_EOF_EN_10 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_10(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_10) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_11[11] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_11 (11U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_11. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_11. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_11. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_11 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_11(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_11)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_11. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_11) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_11)

/*! @brief Set the IDMAC_EOF_EN_11 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_11(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_11) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_12[12] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_12 (12U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_12. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_12. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_12. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_12 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_12(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_12)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_12. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_12) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_12)

/*! @brief Set the IDMAC_EOF_EN_12 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_12(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_12) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_13[13] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_13 (13U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_13. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_13 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_13. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_13 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_13. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_13 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_13(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_13)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_13. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_13) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_13)

/*! @brief Set the IDMAC_EOF_EN_13 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_13(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_13) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_14[14] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_14 (14U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_14. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_14 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_14. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_14 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_14. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_14 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_14(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_14)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_14. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_14) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_14)

/*! @brief Set the IDMAC_EOF_EN_14 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_14(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_14) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_15[15] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_15 (15U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_15. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_15 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_15. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_15 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_15. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_15 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_15(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_15)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_15. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_15) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_15)

/*! @brief Set the IDMAC_EOF_EN_15 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_15(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_15) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_17[17] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_17 (17U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_17. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_17 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_17. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_17 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_17. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_17 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_17(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_17)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_17. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_17) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_17)

/*! @brief Set the IDMAC_EOF_EN_17 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_17(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_17) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_18[18] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_18 (18U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_18. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_18 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_18. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_18 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_18. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_18 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_18(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_18)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_18. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_18) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_18)

/*! @brief Set the IDMAC_EOF_EN_18 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_18(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_18) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_19[19] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_19 (19U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_19. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_19. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_19. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_19 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_19(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_19)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_19. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_19) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_19)

/*! @brief Set the IDMAC_EOF_EN_19 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_19(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_19) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_20[20] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_20 (20U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_20. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_20. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_20. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_20 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_20(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_20)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_20. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_20) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_20)

/*! @brief Set the IDMAC_EOF_EN_20 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_20(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_20) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_21[21] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_21 (21U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_21. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_21. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_21. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_21 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_21(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_21)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_21. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_21) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_21)

/*! @brief Set the IDMAC_EOF_EN_21 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_21(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_21) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_22[22] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_22 (22U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_22. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_22. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_22. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_22 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_22(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_22)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_22. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_22) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_22)

/*! @brief Set the IDMAC_EOF_EN_22 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_22(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_22) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_23[23] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_23 (23U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_23. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_23. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_23. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_23 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_23(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_23)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_23. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_23) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_23)

/*! @brief Set the IDMAC_EOF_EN_23 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_23(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_23) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_24[24] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_24 (24U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_24. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_24. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_24. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_24 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_24(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_24)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_24. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_24) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_24)

/*! @brief Set the IDMAC_EOF_EN_24 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_24(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_24) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_25[25] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_25. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_25. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_25 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_25(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_25. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_25) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_25)

/*! @brief Set the IDMAC_EOF_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_25(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_25) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_26[26] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_26. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_26. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_26 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_26(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_26. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_26) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_26)

/*! @brief Set the IDMAC_EOF_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_26(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_26) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_27[27] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_27 (27U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_27. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_27. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_27. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_27 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_27(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_27)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_27. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_27) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_27)

/*! @brief Set the IDMAC_EOF_EN_27 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_27(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_27) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_28[28] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_28 (28U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_28. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_28. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_28. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_28 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_28(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_28)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_28. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_28) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_28)

/*! @brief Set the IDMAC_EOF_EN_28 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_28(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_28) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_29[29] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_29 (29U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_29. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_29. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_29. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_29 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_29(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_29)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_29. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_29) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_29)

/*! @brief Set the IDMAC_EOF_EN_29 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_29(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_29) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_1, field IDMAC_EOF_EN_31[31] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_31 (31U) /*!< Bit position for IPU_INT_CTRL_1_IDMAC_EOF_EN_31. */
#define BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_1_IDMAC_EOF_EN_31. */
#define BS_IPU_INT_CTRL_1_IDMAC_EOF_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_1_IDMAC_EOF_EN_31. */

/*! @brief Read current value of the IPU_INT_CTRL_1_IDMAC_EOF_EN_31 field. */
#define BR_IPU_INT_CTRL_1_IDMAC_EOF_EN_31(x) (HW_IPU_INT_CTRL_1(x).B.IDMAC_EOF_EN_31)

/*! @brief Format value for bitfield IPU_INT_CTRL_1_IDMAC_EOF_EN_31. */
#define BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_1_IDMAC_EOF_EN_31) & BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_31)

/*! @brief Set the IDMAC_EOF_EN_31 field to a new value. */
#define BW_IPU_INT_CTRL_1_IDMAC_EOF_EN_31(x, v) (HW_IPU_INT_CTRL_1_WR(x, (HW_IPU_INT_CTRL_1_RD(x) & ~BM_IPU_INT_CTRL_1_IDMAC_EOF_EN_31) | BF_IPU_INT_CTRL_1_IDMAC_EOF_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_2 - Interrupt Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_2 - Interrupt Control Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of EOF
 * (end of frame) of DMA Channels interrupts [63:32] can be found in this register.
 */
typedef union _hw_ipu_int_ctrl_2
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOF_EN_33 : 1;  /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_EOF_EN_40 : 1;  /*!< [8]  */
        uint32_t IDMAC_EOF_EN_41 : 1;  /*!< [9]  */
        uint32_t IDMAC_EOF_EN_42 : 1;  /*!< [10]  */
        uint32_t IDMAC_EOF_EN_43 : 1;  /*!< [11]  */
        uint32_t IDMAC_EOF_EN_44 : 1;  /*!< [12]  */
        uint32_t IDMAC_EOF_EN_45 : 1;  /*!< [13]  */
        uint32_t IDMAC_EOF_EN_46 : 1;  /*!< [14]  */
        uint32_t IDMAC_EOF_EN_47 : 1;  /*!< [15]  */
        uint32_t IDMAC_EOF_EN_48 : 1;  /*!< [16]  */
        uint32_t IDMAC_EOF_EN_49 : 1;  /*!< [17]  */
        uint32_t IDMAC_EOF_EN_50 : 1;  /*!< [18]  */
        uint32_t IDMAC_EOF_EN_51 : 1;  /*!< [19]  */
        uint32_t IDMAC_EOF_EN_52 : 1;  /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_ctrl_2_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_2 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_2_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_IPU_INT_CTRL_2(x)     (*(__IO hw_ipu_int_ctrl_2_t *) HW_IPU_INT_CTRL_2_ADDR(x))
#define HW_IPU_INT_CTRL_2_RD(x)  (HW_IPU_INT_CTRL_2(x).U)
#define HW_IPU_INT_CTRL_2_WR(x, v) (HW_IPU_INT_CTRL_2(x).U = (v))
#define HW_IPU_INT_CTRL_2_SET(x, v) (HW_IPU_INT_CTRL_2_WR(x, HW_IPU_INT_CTRL_2_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_2_CLR(x, v) (HW_IPU_INT_CTRL_2_WR(x, HW_IPU_INT_CTRL_2_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_2_TOG(x, v) (HW_IPU_INT_CTRL_2_WR(x, HW_IPU_INT_CTRL_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_2 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_33[1] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_33 (1U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_33. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_33. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_33. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_33 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_33(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_33)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_33. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_33) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_33)

/*! @brief Set the IDMAC_EOF_EN_33 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_33(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_33) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_40[8] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_40 (8U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_40. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_40 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_40. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_40 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_40. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_40 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_40(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_40)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_40. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_40) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_40)

/*! @brief Set the IDMAC_EOF_EN_40 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_40(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_40) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_41[9] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_41 (9U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_41. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_41. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_41. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_41 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_41(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_41)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_41. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_41) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_41)

/*! @brief Set the IDMAC_EOF_EN_41 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_41(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_41) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_42[10] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_42 (10U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_42. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_42. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_42. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_42 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_42(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_42)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_42. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_42) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_42)

/*! @brief Set the IDMAC_EOF_EN_42 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_42(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_42) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_43[11] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_43 (11U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_43. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_43. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_43. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_43 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_43(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_43)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_43. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_43) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_43)

/*! @brief Set the IDMAC_EOF_EN_43 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_43(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_43) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_44[12] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_44 (12U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_44. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_44. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_44. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_44 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_44(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_44)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_44. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_44) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_44)

/*! @brief Set the IDMAC_EOF_EN_44 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_44(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_44) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_45[13] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_45 (13U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_45. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_45. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_45. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_45 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_45(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_45)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_45. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_45) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_45)

/*! @brief Set the IDMAC_EOF_EN_45 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_45(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_45) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_46[14] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_46 (14U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_46. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_46. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_46. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_46 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_46(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_46)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_46. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_46) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_46)

/*! @brief Set the IDMAC_EOF_EN_46 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_46(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_46) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_47[15] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_47 (15U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_47. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_47. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_47. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_47 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_47(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_47)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_47. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_47) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_47)

/*! @brief Set the IDMAC_EOF_EN_47 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_47(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_47) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_48[16] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_48 (16U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_48. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_48. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_48. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_48 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_48(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_48)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_48. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_48) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_48)

/*! @brief Set the IDMAC_EOF_EN_48 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_48(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_48) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_49[17] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_49 (17U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_49. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_49. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_49. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_49 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_49(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_49)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_49. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_49) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_49)

/*! @brief Set the IDMAC_EOF_EN_49 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_49(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_49) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_50[18] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_50 (18U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_50. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_50. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_50. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_50 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_50(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_50)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_50. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_50) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_50)

/*! @brief Set the IDMAC_EOF_EN_50 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_50(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_50) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_51[19] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_51 (19U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_51. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_51. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_51. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_51 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_51(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_51)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_51. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_51) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_51)

/*! @brief Set the IDMAC_EOF_EN_51 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_51(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_51) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_2, field IDMAC_EOF_EN_52[20] (RW)
 *
 * Enable End of Frame of Channel interrupt. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_52 (20U) /*!< Bit position for IPU_INT_CTRL_2_IDMAC_EOF_EN_52. */
#define BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_2_IDMAC_EOF_EN_52. */
#define BS_IPU_INT_CTRL_2_IDMAC_EOF_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_2_IDMAC_EOF_EN_52. */

/*! @brief Read current value of the IPU_INT_CTRL_2_IDMAC_EOF_EN_52 field. */
#define BR_IPU_INT_CTRL_2_IDMAC_EOF_EN_52(x) (HW_IPU_INT_CTRL_2(x).B.IDMAC_EOF_EN_52)

/*! @brief Format value for bitfield IPU_INT_CTRL_2_IDMAC_EOF_EN_52. */
#define BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_2_IDMAC_EOF_EN_52) & BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_52)

/*! @brief Set the IDMAC_EOF_EN_52 field to a new value. */
#define BW_IPU_INT_CTRL_2_IDMAC_EOF_EN_52(x, v) (HW_IPU_INT_CTRL_2_WR(x, (HW_IPU_INT_CTRL_2_RD(x) & ~BM_IPU_INT_CTRL_2_IDMAC_EOF_EN_52) | BF_IPU_INT_CTRL_2_IDMAC_EOF_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_3 - Interrupt Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_3 - Interrupt Control Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of NFACK
 * (New Frame Ack) of DMA Channels interrupts [31:0] can be found in this
 * register.
 */
typedef union _hw_ipu_int_ctrl_3
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_3_bitfields
    {
        uint32_t IDMAC_NFACK_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_NFACK_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_NFACK_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_NFACK_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_NFACK_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_NFACK_EN_8 : 1; /*!< [8]  */
        uint32_t IDMAC_NFACK_EN_9 : 1; /*!< [9]  */
        uint32_t IDMAC_NFACK_EN_10 : 1; /*!< [10]  */
        uint32_t IDMAC_NFACK_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_NFACK_EN_12 : 1; /*!< [12]  */
        uint32_t IDMAC_NFACK_EN_13 : 1; /*!< [13]  */
        uint32_t IDMAC_NFACK_EN_14 : 1; /*!< [14]  */
        uint32_t IDMAC_NFACK_EN_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_NFACK_EN_17 : 1; /*!< [17]  */
        uint32_t IDMAC_NFACK_EN_18 : 1; /*!< [18]  */
        uint32_t IDMAC_NFACK_EN_19 : 1; /*!< [19]  */
        uint32_t IDMAC_NFACK_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_NFACK_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_NFACK_EN_22 : 1; /*!< [22]  */
        uint32_t IDMAC_NFACK_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_NFACK_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_NFACK_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_NFACK_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_NFACK_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_NFACK_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_NFACK_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_NFACK_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_3_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_3 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_3_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_IPU_INT_CTRL_3(x)     (*(__IO hw_ipu_int_ctrl_3_t *) HW_IPU_INT_CTRL_3_ADDR(x))
#define HW_IPU_INT_CTRL_3_RD(x)  (HW_IPU_INT_CTRL_3(x).U)
#define HW_IPU_INT_CTRL_3_WR(x, v) (HW_IPU_INT_CTRL_3(x).U = (v))
#define HW_IPU_INT_CTRL_3_SET(x, v) (HW_IPU_INT_CTRL_3_WR(x, HW_IPU_INT_CTRL_3_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_3_CLR(x, v) (HW_IPU_INT_CTRL_3_WR(x, HW_IPU_INT_CTRL_3_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_3_TOG(x, v) (HW_IPU_INT_CTRL_3_WR(x, HW_IPU_INT_CTRL_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_3 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_0[0] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0 (0U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_0. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_0. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_0. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_0 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_0)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_0. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0)

/*! @brief Set the IDMAC_NFACK_EN_0 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_1[1] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1 (1U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_1. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_1. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_1. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_1 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_1)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_1. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1)

/*! @brief Set the IDMAC_NFACK_EN_1 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_2[2] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2 (2U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_2. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_2. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_2. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_2 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_2)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_2. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2)

/*! @brief Set the IDMAC_NFACK_EN_2 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_3[3] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3 (3U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_3. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_3. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_3. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_3 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_3)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_3. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3)

/*! @brief Set the IDMAC_NFACK_EN_3 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_5[5] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5 (5U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_5. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_5. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_5. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_5 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_5)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_5. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5)

/*! @brief Set the IDMAC_NFACK_EN_5 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_8[8] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8 (8U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_8. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_8. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_8. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_8 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_8)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_8. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8)

/*! @brief Set the IDMAC_NFACK_EN_8 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_9[9] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9 (9U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_9. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_9. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_9. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_9 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_9)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_9. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9)

/*! @brief Set the IDMAC_NFACK_EN_9 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_10[10] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10 (10U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_10. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_10. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_10. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_10 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_10)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_10. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10)

/*! @brief Set the IDMAC_NFACK_EN_10 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_11[11] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11 (11U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_11. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_11. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_11. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_11 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_11)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_11. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11)

/*! @brief Set the IDMAC_NFACK_EN_11 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_12[12] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12 (12U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_12. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_12. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_12. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_12 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_12)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_12. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12)

/*! @brief Set the IDMAC_NFACK_EN_12 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_13[13] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13 (13U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_13. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_13. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_13. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_13 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_13)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_13. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13)

/*! @brief Set the IDMAC_NFACK_EN_13 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_14[14] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14 (14U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_14. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_14. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_14. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_14 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_14)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_14. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14)

/*! @brief Set the IDMAC_NFACK_EN_14 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_15[15] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15 (15U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_15. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_15. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_15. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_15 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_15)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_15. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15)

/*! @brief Set the IDMAC_NFACK_EN_15 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_17[17] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17 (17U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_17. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_17. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_17. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_17 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_17)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_17. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17)

/*! @brief Set the IDMAC_NFACK_EN_17 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_18[18] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18 (18U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_18. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_18. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_18. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_18 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_18)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_18. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18)

/*! @brief Set the IDMAC_NFACK_EN_18 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_19[19] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19 (19U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_19. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_19. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_19. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_19 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_19)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_19. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19)

/*! @brief Set the IDMAC_NFACK_EN_19 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_20[20] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20 (20U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_20. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_20. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_20. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_20 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_20)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_20. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20)

/*! @brief Set the IDMAC_NFACK_EN_20 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_21[21] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21 (21U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_21. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_21. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_21. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_21 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_21)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_21. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21)

/*! @brief Set the IDMAC_NFACK_EN_21 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_22[22] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22 (22U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_22. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_22. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_22. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_22 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_22)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_22. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22)

/*! @brief Set the IDMAC_NFACK_EN_22 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_23[23] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23 (23U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_23. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_23. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_23. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_23 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_23)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_23. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23)

/*! @brief Set the IDMAC_NFACK_EN_23 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_24[24] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24 (24U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_24. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_24. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_24. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_24 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_24)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_24. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24)

/*! @brief Set the IDMAC_NFACK_EN_24 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_25[25] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_25. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_25. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_25 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_25. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25)

/*! @brief Set the IDMAC_NFACK_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_26[26] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_26. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_26. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_26 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_26. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26)

/*! @brief Set the IDMAC_NFACK_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_27[27] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27 (27U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_27. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_27. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_27. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_27 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_27)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_27. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27)

/*! @brief Set the IDMAC_NFACK_EN_27 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_28[28] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28 (28U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_28. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_28. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_28. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_28 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_28)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_28. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28)

/*! @brief Set the IDMAC_NFACK_EN_28 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_29[29] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29 (29U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_29. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_29. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_29. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_29 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_29)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_29. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29)

/*! @brief Set the IDMAC_NFACK_EN_29 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_3, field IDMAC_NFACK_EN_31[31] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31 (31U) /*!< Bit position for IPU_INT_CTRL_3_IDMAC_NFACK_EN_31. */
#define BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_3_IDMAC_NFACK_EN_31. */
#define BS_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_3_IDMAC_NFACK_EN_31. */

/*! @brief Read current value of the IPU_INT_CTRL_3_IDMAC_NFACK_EN_31 field. */
#define BR_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31(x) (HW_IPU_INT_CTRL_3(x).B.IDMAC_NFACK_EN_31)

/*! @brief Format value for bitfield IPU_INT_CTRL_3_IDMAC_NFACK_EN_31. */
#define BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31) & BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31)

/*! @brief Set the IDMAC_NFACK_EN_31 field to a new value. */
#define BW_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31(x, v) (HW_IPU_INT_CTRL_3_WR(x, (HW_IPU_INT_CTRL_3_RD(x) & ~BM_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31) | BF_IPU_INT_CTRL_3_IDMAC_NFACK_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_4 - Interrupt Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_4 - Interrupt Control Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of NFACK
 * (New Frame Ack) of DMA Channels interrupts [63:32] can be found in this
 * register.
 */
typedef union _hw_ipu_int_ctrl_4
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_4_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_NFACK_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_NFACK_EN_40 : 1; /*!< [8]  */
        uint32_t IDMAC_NFACK_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_NFACK_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_NFACK_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_NFACK_EN_44 : 1; /*!< [12]  */
        uint32_t IDMAC_NFACK_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_NFACK_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_NFACK_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_NFACK_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_NFACK_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_NFACK_EN_50 : 1; /*!< [18]  */
        uint32_t IDMAC_NFACK_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_NFACK_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_ctrl_4_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_4 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_4_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_IPU_INT_CTRL_4(x)     (*(__IO hw_ipu_int_ctrl_4_t *) HW_IPU_INT_CTRL_4_ADDR(x))
#define HW_IPU_INT_CTRL_4_RD(x)  (HW_IPU_INT_CTRL_4(x).U)
#define HW_IPU_INT_CTRL_4_WR(x, v) (HW_IPU_INT_CTRL_4(x).U = (v))
#define HW_IPU_INT_CTRL_4_SET(x, v) (HW_IPU_INT_CTRL_4_WR(x, HW_IPU_INT_CTRL_4_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_4_CLR(x, v) (HW_IPU_INT_CTRL_4_WR(x, HW_IPU_INT_CTRL_4_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_4_TOG(x, v) (HW_IPU_INT_CTRL_4_WR(x, HW_IPU_INT_CTRL_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_4 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_33[1] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33 (1U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_33. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_33. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_33. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_33 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_33)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_33. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33)

/*! @brief Set the IDMAC_NFACK_EN_33 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_40[8] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40 (8U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_40. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_40. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_40. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_40 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_40)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_40. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40)

/*! @brief Set the IDMAC_NFACK_EN_40 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_41[9] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41 (9U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_41. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_41. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_41. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_41 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_41)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_41. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41)

/*! @brief Set the IDMAC_NFACK_EN_41 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_42[10] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42 (10U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_42. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_42. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_42. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_42 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_42)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_42. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42)

/*! @brief Set the IDMAC_NFACK_EN_42 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_43[11] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43 (11U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_43. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_43. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_43. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_43 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_43)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_43. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43)

/*! @brief Set the IDMAC_NFACK_EN_43 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_44[12] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44 (12U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_44. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_44. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_44. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_44 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_44)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_44. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44)

/*! @brief Set the IDMAC_NFACK_EN_44 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_45[13] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45 (13U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_45. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_45. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_45. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_45 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_45)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_45. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45)

/*! @brief Set the IDMAC_NFACK_EN_45 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_46[14] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46 (14U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_46. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_46. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_46. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_46 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_46)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_46. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46)

/*! @brief Set the IDMAC_NFACK_EN_46 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_47[15] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47 (15U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_47. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_47. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_47. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_47 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_47)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_47. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47)

/*! @brief Set the IDMAC_NFACK_EN_47 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_48[16] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48 (16U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_48. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_48. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_48. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_48 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_48)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_48. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48)

/*! @brief Set the IDMAC_NFACK_EN_48 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_49[17] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49 (17U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_49. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_49. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_49. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_49 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_49)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_49. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49)

/*! @brief Set the IDMAC_NFACK_EN_49 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_50[18] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50 (18U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_50. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_50. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_50. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_50 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_50)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_50. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50)

/*! @brief Set the IDMAC_NFACK_EN_50 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_51[19] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51 (19U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_51. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_51. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_51. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_51 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_51)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_51. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51)

/*! @brief Set the IDMAC_NFACK_EN_51 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_4, field IDMAC_NFACK_EN_52[20] (RW)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the control of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52 (20U) /*!< Bit position for IPU_INT_CTRL_4_IDMAC_NFACK_EN_52. */
#define BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_4_IDMAC_NFACK_EN_52. */
#define BS_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_4_IDMAC_NFACK_EN_52. */

/*! @brief Read current value of the IPU_INT_CTRL_4_IDMAC_NFACK_EN_52 field. */
#define BR_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52(x) (HW_IPU_INT_CTRL_4(x).B.IDMAC_NFACK_EN_52)

/*! @brief Format value for bitfield IPU_INT_CTRL_4_IDMAC_NFACK_EN_52. */
#define BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52) & BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52)

/*! @brief Set the IDMAC_NFACK_EN_52 field to a new value. */
#define BW_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52(x, v) (HW_IPU_INT_CTRL_4_WR(x, (HW_IPU_INT_CTRL_4_RD(x) & ~BM_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52) | BF_IPU_INT_CTRL_4_IDMAC_NFACK_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_5 - Interrupt Control Register 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_5 - Interrupt Control Register 5 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * New-frame before end-of-frame indication (NFB4EOF) of DMA Channels interrupts
 * [31:0] can be found in this register.
 */
typedef union _hw_ipu_int_ctrl_5
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_5_bitfields
    {
        uint32_t IDMAC_NFB4EOF_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_NFB4EOF_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_NFB4EOF_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_NFB4EOF_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_NFB4EOF_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_NFB4EOF_EN_8 : 1; /*!< [8]  */
        uint32_t IDMAC_NFB4EOF_EN_9 : 1; /*!< [9]  */
        uint32_t IDMAC_NFB4EOF_EN_10 : 1; /*!< [10]  */
        uint32_t IDMAC_NFB4EOF_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_NFB4EOF_EN_12 : 1; /*!< [12]  */
        uint32_t IDMAC_NFB4EOF_EN_13 : 1; /*!< [13]  */
        uint32_t IDMAC_NFB4EOF_EN_14 : 1; /*!< [14]  */
        uint32_t IDMAC_NFB4EOF_EN_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_NFB4EOF_EN_17 : 1; /*!< [17]  */
        uint32_t IDMAC_NFB4EOF_EN_18 : 1; /*!< [18]  */
        uint32_t IDMAC_NFB4EOF_EN_19 : 1; /*!< [19]  */
        uint32_t IDMAC_NFB4EOF_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_NFB4EOF_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_NFB4EOF_EN_22 : 1; /*!< [22]  */
        uint32_t IDMAC_NFB4EOF_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_NFB4EOF_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_NFB4EOF_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_NFB4EOF_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_NFB4EOF_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_NFB4EOF_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_NFB4EOF_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_NFB4EOF_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_5_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_5 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_5_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_IPU_INT_CTRL_5(x)     (*(__IO hw_ipu_int_ctrl_5_t *) HW_IPU_INT_CTRL_5_ADDR(x))
#define HW_IPU_INT_CTRL_5_RD(x)  (HW_IPU_INT_CTRL_5(x).U)
#define HW_IPU_INT_CTRL_5_WR(x, v) (HW_IPU_INT_CTRL_5(x).U = (v))
#define HW_IPU_INT_CTRL_5_SET(x, v) (HW_IPU_INT_CTRL_5_WR(x, HW_IPU_INT_CTRL_5_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_5_CLR(x, v) (HW_IPU_INT_CTRL_5_WR(x, HW_IPU_INT_CTRL_5_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_5_TOG(x, v) (HW_IPU_INT_CTRL_5_WR(x, HW_IPU_INT_CTRL_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_5 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_0[0] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0 (0U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_0)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0)

/*! @brief Set the IDMAC_NFB4EOF_EN_0 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_1[1] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1 (1U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_1)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1)

/*! @brief Set the IDMAC_NFB4EOF_EN_1 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_2[2] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2 (2U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_2)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2)

/*! @brief Set the IDMAC_NFB4EOF_EN_2 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_3[3] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3 (3U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_3)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3)

/*! @brief Set the IDMAC_NFB4EOF_EN_3 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_5[5] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5 (5U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_5)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5)

/*! @brief Set the IDMAC_NFB4EOF_EN_5 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_8[8] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8 (8U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_8)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8)

/*! @brief Set the IDMAC_NFB4EOF_EN_8 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_9[9] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9 (9U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_9)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9)

/*! @brief Set the IDMAC_NFB4EOF_EN_9 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_10[10] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10 (10U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_10)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10)

/*! @brief Set the IDMAC_NFB4EOF_EN_10 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_11[11] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11 (11U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_11)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11)

/*! @brief Set the IDMAC_NFB4EOF_EN_11 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_12[12] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12 (12U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_12)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12)

/*! @brief Set the IDMAC_NFB4EOF_EN_12 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_13[13] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13 (13U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_13)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13)

/*! @brief Set the IDMAC_NFB4EOF_EN_13 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_14[14] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14 (14U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_14)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14)

/*! @brief Set the IDMAC_NFB4EOF_EN_14 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_15[15] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15 (15U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_15)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15)

/*! @brief Set the IDMAC_NFB4EOF_EN_15 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_17[17] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17 (17U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_17)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17)

/*! @brief Set the IDMAC_NFB4EOF_EN_17 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_18[18] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18 (18U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_18)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18)

/*! @brief Set the IDMAC_NFB4EOF_EN_18 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_19[19] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19 (19U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_19)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19)

/*! @brief Set the IDMAC_NFB4EOF_EN_19 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_20[20] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20 (20U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_20)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20)

/*! @brief Set the IDMAC_NFB4EOF_EN_20 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_21[21] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21 (21U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_21)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21)

/*! @brief Set the IDMAC_NFB4EOF_EN_21 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_22[22] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22 (22U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_22)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22)

/*! @brief Set the IDMAC_NFB4EOF_EN_22 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_23[23] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23 (23U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_23)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23)

/*! @brief Set the IDMAC_NFB4EOF_EN_23 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_24[24] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24 (24U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_24)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24)

/*! @brief Set the IDMAC_NFB4EOF_EN_24 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_25[25] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25)

/*! @brief Set the IDMAC_NFB4EOF_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_26[26] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26)

/*! @brief Set the IDMAC_NFB4EOF_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_27[27] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27 (27U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_27)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27)

/*! @brief Set the IDMAC_NFB4EOF_EN_27 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_28[28] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28 (28U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_28)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28)

/*! @brief Set the IDMAC_NFB4EOF_EN_28 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_29[29] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29 (29U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_29)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29)

/*! @brief Set the IDMAC_NFB4EOF_EN_29 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_5, field IDMAC_NFB4EOF_EN_31[31] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31 (31U) /*!< Bit position for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31. */
#define BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31. */
#define BS_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31. */

/*! @brief Read current value of the IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31 field. */
#define BR_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31(x) (HW_IPU_INT_CTRL_5(x).B.IDMAC_NFB4EOF_EN_31)

/*! @brief Format value for bitfield IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31. */
#define BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31) & BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31)

/*! @brief Set the IDMAC_NFB4EOF_EN_31 field to a new value. */
#define BW_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31(x, v) (HW_IPU_INT_CTRL_5_WR(x, (HW_IPU_INT_CTRL_5_RD(x) & ~BM_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31) | BF_IPU_INT_CTRL_5_IDMAC_NFB4EOF_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_6 - Interrupt Control Register 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_6 - Interrupt Control Register 6 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * New-frame before end-of-frame indication (NFB4EOF_ERR) of DMA Channels
 * interrupts [63:32] can be found in this register.
 */
typedef union _hw_ipu_int_ctrl_6
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_6_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_NFB4EOF_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_NFB4EOF_EN_40 : 1; /*!< [8]  */
        uint32_t IDMAC_NFB4EOF_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_NFB4EOF_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_NFB4EOF_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_NFB4EOF_EN_44 : 1; /*!< [12]  */
        uint32_t IDMAC_NFB4EOF_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_NFB4EOF_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_NFB4EOF_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_NFB4EOF_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_NFB4EOF_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_NFB4EOF_EN_50 : 1; /*!< [18]  */
        uint32_t IDMAC_NFB4EOF_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_NFB4EOF_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_ctrl_6_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_6 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_6_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_IPU_INT_CTRL_6(x)     (*(__IO hw_ipu_int_ctrl_6_t *) HW_IPU_INT_CTRL_6_ADDR(x))
#define HW_IPU_INT_CTRL_6_RD(x)  (HW_IPU_INT_CTRL_6(x).U)
#define HW_IPU_INT_CTRL_6_WR(x, v) (HW_IPU_INT_CTRL_6(x).U = (v))
#define HW_IPU_INT_CTRL_6_SET(x, v) (HW_IPU_INT_CTRL_6_WR(x, HW_IPU_INT_CTRL_6_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_6_CLR(x, v) (HW_IPU_INT_CTRL_6_WR(x, HW_IPU_INT_CTRL_6_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_6_TOG(x, v) (HW_IPU_INT_CTRL_6_WR(x, HW_IPU_INT_CTRL_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_6 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_33[1] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33 (1U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_33)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33)

/*! @brief Set the IDMAC_NFB4EOF_EN_33 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_40[8] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40 (8U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_40)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40)

/*! @brief Set the IDMAC_NFB4EOF_EN_40 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_41[9] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41 (9U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_41)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41)

/*! @brief Set the IDMAC_NFB4EOF_EN_41 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_42[10] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42 (10U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_42)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42)

/*! @brief Set the IDMAC_NFB4EOF_EN_42 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_43[11] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43 (11U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_43)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43)

/*! @brief Set the IDMAC_NFB4EOF_EN_43 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_44[12] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44 (12U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_44)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44)

/*! @brief Set the IDMAC_NFB4EOF_EN_44 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_45[13] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45 (13U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_45)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45)

/*! @brief Set the IDMAC_NFB4EOF_EN_45 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_46[14] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46 (14U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_46)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46)

/*! @brief Set the IDMAC_NFB4EOF_EN_46 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_47[15] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47 (15U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_47)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47)

/*! @brief Set the IDMAC_NFB4EOF_EN_47 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_48[16] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48 (16U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_48)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48)

/*! @brief Set the IDMAC_NFB4EOF_EN_48 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_49[17] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49 (17U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_49)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49)

/*! @brief Set the IDMAC_NFB4EOF_EN_49 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_50[18] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50 (18U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_50)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50)

/*! @brief Set the IDMAC_NFB4EOF_EN_50 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_51[19] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51 (19U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_51)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51)

/*! @brief Set the IDMAC_NFB4EOF_EN_51 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_6, field IDMAC_NFB4EOF_EN_52[20] (RW)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the control of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52 (20U) /*!< Bit position for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52. */
#define BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52. */
#define BS_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52. */

/*! @brief Read current value of the IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52 field. */
#define BR_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52(x) (HW_IPU_INT_CTRL_6(x).B.IDMAC_NFB4EOF_EN_52)

/*! @brief Format value for bitfield IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52. */
#define BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52) & BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52)

/*! @brief Set the IDMAC_NFB4EOF_EN_52 field to a new value. */
#define BW_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52(x, v) (HW_IPU_INT_CTRL_6_WR(x, (HW_IPU_INT_CTRL_6_RD(x) & ~BM_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52) | BF_IPU_INT_CTRL_6_IDMAC_NFB4EOF_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_7 - Interrupt Control Register 7
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_7 - Interrupt Control Register 7 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPUIPU interrupts controls. The controls of
 * the End-of-Scroll indication (EOS) of DMA Channels interrupts [31:0] can be
 * found in this register.
 */
typedef union _hw_ipu_int_ctrl_7
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_7_bitfields
    {
        uint32_t RESERVED0 : 19;       /*!< [18:0]  */
        uint32_t IDMAC_EOS_EN_19 : 1;  /*!< [19]  */
        uint32_t RESERVED1 : 3;        /*!< [22:20]  */
        uint32_t IDMAC_EOS_EN_23 : 1;  /*!< [23]  */
        uint32_t IDMAC_EOS_EN_24 : 1;  /*!< [24]  */
        uint32_t IDMAC_EOS_EN_25 : 1;  /*!< [25]  */
        uint32_t IDMAC_EOS_EN_26 : 1;  /*!< [26]  */
        uint32_t IDMAC_EOS_EN_27 : 1;  /*!< [27]  */
        uint32_t IDMAC_EOS_EN_28 : 1;  /*!< [28]  */
        uint32_t IDMAC_EOS_EN_29 : 1;  /*!< [29]  */
        uint32_t RESERVED2 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOS_EN_31 : 1;  /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_7_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_7 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_7_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_IPU_INT_CTRL_7(x)     (*(__IO hw_ipu_int_ctrl_7_t *) HW_IPU_INT_CTRL_7_ADDR(x))
#define HW_IPU_INT_CTRL_7_RD(x)  (HW_IPU_INT_CTRL_7(x).U)
#define HW_IPU_INT_CTRL_7_WR(x, v) (HW_IPU_INT_CTRL_7(x).U = (v))
#define HW_IPU_INT_CTRL_7_SET(x, v) (HW_IPU_INT_CTRL_7_WR(x, HW_IPU_INT_CTRL_7_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_7_CLR(x, v) (HW_IPU_INT_CTRL_7_WR(x, HW_IPU_INT_CTRL_7_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_7_TOG(x, v) (HW_IPU_INT_CTRL_7_WR(x, HW_IPU_INT_CTRL_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_7 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_19[19] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_19 (19U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_19. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_19. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_19. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_19 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_19(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_19)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_19. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_19) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_19)

/*! @brief Set the IDMAC_EOS_EN_19 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_19(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_19) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_23[23] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_23 (23U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_23. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_23. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_23. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_23 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_23(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_23)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_23. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_23) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_23)

/*! @brief Set the IDMAC_EOS_EN_23 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_23(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_23) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_24[24] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_24 (24U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_24. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_24. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_24. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_24 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_24(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_24)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_24. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_24) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_24)

/*! @brief Set the IDMAC_EOS_EN_24 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_24(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_24) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_25[25] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_25. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_25. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_25 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_25(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_25. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_25) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_25)

/*! @brief Set the IDMAC_EOS_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_25(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_25) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_26[26] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_26. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_26. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_26 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_26(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_26. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_26) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_26)

/*! @brief Set the IDMAC_EOS_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_26(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_26) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_27[27] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_27 (27U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_27. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_27. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_27. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_27 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_27(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_27)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_27. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_27) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_27)

/*! @brief Set the IDMAC_EOS_EN_27 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_27(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_27) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_28[28] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_28 (28U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_28. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_28. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_28. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_28 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_28(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_28)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_28. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_28) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_28)

/*! @brief Set the IDMAC_EOS_EN_28 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_28(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_28) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_29[29] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_29 (29U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_29. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_29. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_29. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_29 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_29(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_29)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_29. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_29) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_29)

/*! @brief Set the IDMAC_EOS_EN_29 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_29(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_29) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_7, field IDMAC_EOS_EN_31[31] (RW)
 *
 * End of Scroll indication of Channel interrupt. This bit is the control of End
 * of Scroll interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_31 (31U) /*!< Bit position for IPU_INT_CTRL_7_IDMAC_EOS_EN_31. */
#define BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_7_IDMAC_EOS_EN_31. */
#define BS_IPU_INT_CTRL_7_IDMAC_EOS_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_7_IDMAC_EOS_EN_31. */

/*! @brief Read current value of the IPU_INT_CTRL_7_IDMAC_EOS_EN_31 field. */
#define BR_IPU_INT_CTRL_7_IDMAC_EOS_EN_31(x) (HW_IPU_INT_CTRL_7(x).B.IDMAC_EOS_EN_31)

/*! @brief Format value for bitfield IPU_INT_CTRL_7_IDMAC_EOS_EN_31. */
#define BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_7_IDMAC_EOS_EN_31) & BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_31)

/*! @brief Set the IDMAC_EOS_EN_31 field to a new value. */
#define BW_IPU_INT_CTRL_7_IDMAC_EOS_EN_31(x, v) (HW_IPU_INT_CTRL_7_WR(x, (HW_IPU_INT_CTRL_7_RD(x) & ~BM_IPU_INT_CTRL_7_IDMAC_EOS_EN_31) | BF_IPU_INT_CTRL_7_IDMAC_EOS_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_8 - Interrupt Control Register 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_8 - Interrupt Control Register 8 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * End of Scroll indication (EOS) of DMA Channels interrupts [63:32] can be found
 * in this register.
 */
typedef union _hw_ipu_int_ctrl_8
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_8_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOS_EN_33 : 1;  /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t IDMAC_EOS_EN_41 : 1;  /*!< [9]  */
        uint32_t IDMAC_EOS_EN_42 : 1;  /*!< [10]  */
        uint32_t IDMAC_EOS_EN_43 : 1;  /*!< [11]  */
        uint32_t IDMAC_EOS_EN_44 : 1;  /*!< [12]  */
        uint32_t RESERVED2 : 6;        /*!< [18:13]  */
        uint32_t IDMAC_EOS_EN_51 : 1;  /*!< [19]  */
        uint32_t IDMAC_EOS_EN_52 : 1;  /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_ctrl_8_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_8 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_8_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_IPU_INT_CTRL_8(x)     (*(__IO hw_ipu_int_ctrl_8_t *) HW_IPU_INT_CTRL_8_ADDR(x))
#define HW_IPU_INT_CTRL_8_RD(x)  (HW_IPU_INT_CTRL_8(x).U)
#define HW_IPU_INT_CTRL_8_WR(x, v) (HW_IPU_INT_CTRL_8(x).U = (v))
#define HW_IPU_INT_CTRL_8_SET(x, v) (HW_IPU_INT_CTRL_8_WR(x, HW_IPU_INT_CTRL_8_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_8_CLR(x, v) (HW_IPU_INT_CTRL_8_WR(x, HW_IPU_INT_CTRL_8_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_8_TOG(x, v) (HW_IPU_INT_CTRL_8_WR(x, HW_IPU_INT_CTRL_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_8 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_33[1] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_33 (1U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_33. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_33. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_33. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_33 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_33(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_33)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_33. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_33) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_33)

/*! @brief Set the IDMAC_EOS_EN_33 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_33(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_33) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_41[9] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_41 (9U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_41. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_41. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_41. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_41 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_41(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_41)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_41. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_41) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_41)

/*! @brief Set the IDMAC_EOS_EN_41 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_41(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_41) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_42[10] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_42 (10U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_42. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_42. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_42. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_42 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_42(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_42)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_42. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_42) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_42)

/*! @brief Set the IDMAC_EOS_EN_42 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_42(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_42) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_43[11] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_43 (11U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_43. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_43. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_43. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_43 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_43(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_43)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_43. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_43) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_43)

/*! @brief Set the IDMAC_EOS_EN_43 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_43(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_43) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_44[12] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_44 (12U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_44. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_44. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_44. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_44 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_44(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_44)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_44. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_44) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_44)

/*! @brief Set the IDMAC_EOS_EN_44 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_44(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_44) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_51[19] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_51 (19U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_51. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_51. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_51. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_51 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_51(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_51)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_51. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_51) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_51)

/*! @brief Set the IDMAC_EOS_EN_51 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_51(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_51) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_8, field IDMAC_EOS_EN_52[20] (RW)
 *
 * End of Scroll of Channel interrupt. This bit is the control of End Of Scroll
 * interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_52 (20U) /*!< Bit position for IPU_INT_CTRL_8_IDMAC_EOS_EN_52. */
#define BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_8_IDMAC_EOS_EN_52. */
#define BS_IPU_INT_CTRL_8_IDMAC_EOS_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_8_IDMAC_EOS_EN_52. */

/*! @brief Read current value of the IPU_INT_CTRL_8_IDMAC_EOS_EN_52 field. */
#define BR_IPU_INT_CTRL_8_IDMAC_EOS_EN_52(x) (HW_IPU_INT_CTRL_8(x).B.IDMAC_EOS_EN_52)

/*! @brief Format value for bitfield IPU_INT_CTRL_8_IDMAC_EOS_EN_52. */
#define BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_8_IDMAC_EOS_EN_52) & BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_52)

/*! @brief Set the IDMAC_EOS_EN_52 field to a new value. */
#define BW_IPU_INT_CTRL_8_IDMAC_EOS_EN_52(x, v) (HW_IPU_INT_CTRL_8_WR(x, (HW_IPU_INT_CTRL_8_RD(x) & ~BM_IPU_INT_CTRL_8_IDMAC_EOS_EN_52) | BF_IPU_INT_CTRL_8_IDMAC_EOS_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_9 - Interrupt Control Register 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_9 - Interrupt Control Register 9 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. This register
 * controls error interrupt signals coming from different sub-blocks within
 */
typedef union _hw_ipu_int_ctrl_9
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_9_bitfields
    {
        uint32_t VDI_FIFO1_OVF_EN : 1; /*!< [0]  */
        uint32_t RESERVED0 : 25;       /*!< [25:1]  */
        uint32_t IC_BAYER_BUF_OVF_EN : 1; /*!< [26]  */
        uint32_t IC_ENC_BUF_OVF_EN : 1; /*!< [27]  */
        uint32_t IC_VF_BUF_OVF_EN : 1; /*!< [28]  */
        uint32_t RESERVED1 : 1;        /*!< [29]  */
        uint32_t CSI0_PUPE_EN : 1;     /*!< [30]  */
        uint32_t CSI1_PUPE_EN : 1;     /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_9_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_9 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_9_ADDR(x) ((uintptr_t)(x) + 0x5CU)

#define HW_IPU_INT_CTRL_9(x)     (*(__IO hw_ipu_int_ctrl_9_t *) HW_IPU_INT_CTRL_9_ADDR(x))
#define HW_IPU_INT_CTRL_9_RD(x)  (HW_IPU_INT_CTRL_9(x).U)
#define HW_IPU_INT_CTRL_9_WR(x, v) (HW_IPU_INT_CTRL_9(x).U = (v))
#define HW_IPU_INT_CTRL_9_SET(x, v) (HW_IPU_INT_CTRL_9_WR(x, HW_IPU_INT_CTRL_9_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_9_CLR(x, v) (HW_IPU_INT_CTRL_9_WR(x, HW_IPU_INT_CTRL_9_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_9_TOG(x, v) (HW_IPU_INT_CTRL_9_WR(x, HW_IPU_INT_CTRL_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_9 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_9, field VDI_FIFO1_OVF_EN[0] (RW)
 *
 * FIFO1 overflow Interrupt1 Enable The VDIC generates FIFO1 overflow interrupt1
 * when the write pointer of FIFO1 overruns read pointer.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN (0U) /*!< Bit position for IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN. */
#define BM_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN. */
#define BS_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN field. */
#define BR_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN(x) (HW_IPU_INT_CTRL_9(x).B.VDI_FIFO1_OVF_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN. */
#define BF_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN) & BM_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN)

/*! @brief Set the VDI_FIFO1_OVF_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN) | BF_IPU_INT_CTRL_9_VDI_FIFO1_OVF_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_9, field IC_BAYER_BUF_OVF_EN[26] (RW)
 *
 * This bit enables an interrupt that is a result of the IC Buffer overflow for
 * bayer coming from the IC. The user needs to write 1 to this bit in order to
 * clear it.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN (26U) /*!< Bit position for IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN. */
#define BM_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN. */
#define BS_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN field. */
#define BR_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN(x) (HW_IPU_INT_CTRL_9(x).B.IC_BAYER_BUF_OVF_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN. */
#define BF_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN) & BM_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN)

/*! @brief Set the IC_BAYER_BUF_OVF_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN) | BF_IPU_INT_CTRL_9_IC_BAYER_BUF_OVF_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_9, field IC_ENC_BUF_OVF_EN[27] (RW)
 *
 * This bit enables an interrupt that is a result of the IC Buffer overflow for
 * encoding coming from the IC. The user needs to write 1 to this bit in order to
 * clear it.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN (27U) /*!< Bit position for IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN. */
#define BM_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN. */
#define BS_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN field. */
#define BR_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN(x) (HW_IPU_INT_CTRL_9(x).B.IC_ENC_BUF_OVF_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN. */
#define BF_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN) & BM_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN)

/*! @brief Set the IC_ENC_BUF_OVF_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN) | BF_IPU_INT_CTRL_9_IC_ENC_BUF_OVF_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_9, field IC_VF_BUF_OVF_EN[28] (RW)
 *
 * This bit enables an interrupt that is a result of the IC Buffer overflow for
 * view finder coming from the IC. The user needs to write 1 to this bit in order
 * to clear it.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN (28U) /*!< Bit position for IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN. */
#define BM_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN. */
#define BS_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN field. */
#define BR_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN(x) (HW_IPU_INT_CTRL_9(x).B.IC_VF_BUF_OVF_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN. */
#define BF_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN) & BM_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN)

/*! @brief Set the IC_VF_BUF_OVF_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN) | BF_IPU_INT_CTRL_9_IC_VF_BUF_OVF_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_9, field CSI0_PUPE_EN[30] (RW)
 *
 * CSI0_PUPE_EN - CSI0 parameters update error interrupt enable. This bit
 * enables an interrupt that is a result of an error generated by the CSI0. The error
 * is generated in case where new frame arrived from the CSI0 before the
 * completion of the CSI0's parameters update by the SRM
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_CSI0_PUPE_EN (30U) /*!< Bit position for IPU_INT_CTRL_9_CSI0_PUPE_EN. */
#define BM_IPU_INT_CTRL_9_CSI0_PUPE_EN (0x40000000U) /*!< Bit mask for IPU_INT_CTRL_9_CSI0_PUPE_EN. */
#define BS_IPU_INT_CTRL_9_CSI0_PUPE_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_CSI0_PUPE_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_CSI0_PUPE_EN field. */
#define BR_IPU_INT_CTRL_9_CSI0_PUPE_EN(x) (HW_IPU_INT_CTRL_9(x).B.CSI0_PUPE_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_CSI0_PUPE_EN. */
#define BF_IPU_INT_CTRL_9_CSI0_PUPE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_CSI0_PUPE_EN) & BM_IPU_INT_CTRL_9_CSI0_PUPE_EN)

/*! @brief Set the CSI0_PUPE_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_CSI0_PUPE_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_CSI0_PUPE_EN) | BF_IPU_INT_CTRL_9_CSI0_PUPE_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_9, field CSI1_PUPE_EN[31] (RW)
 *
 * CSI1_PUPE_EN - CSI1 parameters update error interrupt enable. This bit
 * enables an interrupt that is a result of an error generated by the CSI1. The error
 * is generated in case where new frame arrived from the CSI1 before the
 * completion of the CSI1's parameters update by the SRM
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_9_CSI1_PUPE_EN (31U) /*!< Bit position for IPU_INT_CTRL_9_CSI1_PUPE_EN. */
#define BM_IPU_INT_CTRL_9_CSI1_PUPE_EN (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_9_CSI1_PUPE_EN. */
#define BS_IPU_INT_CTRL_9_CSI1_PUPE_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_9_CSI1_PUPE_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_9_CSI1_PUPE_EN field. */
#define BR_IPU_INT_CTRL_9_CSI1_PUPE_EN(x) (HW_IPU_INT_CTRL_9(x).B.CSI1_PUPE_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_9_CSI1_PUPE_EN. */
#define BF_IPU_INT_CTRL_9_CSI1_PUPE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_9_CSI1_PUPE_EN) & BM_IPU_INT_CTRL_9_CSI1_PUPE_EN)

/*! @brief Set the CSI1_PUPE_EN field to a new value. */
#define BW_IPU_INT_CTRL_9_CSI1_PUPE_EN(x, v) (HW_IPU_INT_CTRL_9_WR(x, (HW_IPU_INT_CTRL_9_RD(x) & ~BM_IPU_INT_CTRL_9_CSI1_PUPE_EN) | BF_IPU_INT_CTRL_9_CSI1_PUPE_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_10 - Interrupt Control Register 10
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_10 - Interrupt Control Register 10 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. This register
 * controls error interrupt signals coming from different modules within
 */
typedef union _hw_ipu_int_ctrl_10
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_10_bitfields
    {
        uint32_t SMFC0_FRM_LOST_EN : 1; /*!< [0]  */
        uint32_t SMFC1_FRM_LOST_EN : 1; /*!< [1]  */
        uint32_t SMFC2_FRM_LOST_EN : 1; /*!< [2]  */
        uint32_t SMFC3_FRM_LOST_EN : 1; /*!< [3]  */
        uint32_t RESERVED0 : 12;       /*!< [15:4]  */
        uint32_t DC_TEARING_ERR_1_EN : 1; /*!< [16]  */
        uint32_t DC_TEARING_ERR_2_EN : 1; /*!< [17]  */
        uint32_t DC_TEARING_ERR_6_EN : 1; /*!< [18]  */
        uint32_t DI0_SYNC_DISP_ERR_EN : 1; /*!< [19]  */
        uint32_t DI1_SYNC_DISP_ERR_EN : 1; /*!< [20]  */
        uint32_t DI0_TIME_OUT_ERR_EN : 1; /*!< [21]  */
        uint32_t DI1_TIME_OUT_ERR_EN : 1; /*!< [22]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t IC_VF_FRM_LOST_ERR_EN : 1; /*!< [24]  */
        uint32_t IC_ENC_FRM_LOST_ERR_EN : 1; /*!< [25]  */
        uint32_t IC_BAYER_FRM_LOST_ERR_EN : 1; /*!< [26]  */
        uint32_t RESERVED2 : 1;        /*!< [27]  */
        uint32_t NON_PRIVILEGED_ACC_ERR_EN : 1; /*!< [28]  */
        uint32_t AXIW_ERR_EN : 1;      /*!< [29]  */
        uint32_t AXIR_ERR_EN : 1;      /*!< [30]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_10_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_10 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_10_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_IPU_INT_CTRL_10(x)    (*(__IO hw_ipu_int_ctrl_10_t *) HW_IPU_INT_CTRL_10_ADDR(x))
#define HW_IPU_INT_CTRL_10_RD(x) (HW_IPU_INT_CTRL_10(x).U)
#define HW_IPU_INT_CTRL_10_WR(x, v) (HW_IPU_INT_CTRL_10(x).U = (v))
#define HW_IPU_INT_CTRL_10_SET(x, v) (HW_IPU_INT_CTRL_10_WR(x, HW_IPU_INT_CTRL_10_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_10_CLR(x, v) (HW_IPU_INT_CTRL_10_WR(x, HW_IPU_INT_CTRL_10_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_10_TOG(x, v) (HW_IPU_INT_CTRL_10_WR(x, HW_IPU_INT_CTRL_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_10 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_10, field SMFC0_FRM_LOST_EN[0] (RW)
 *
 * Frame Lost of SMFC channel 0 interrupt enable bit This bit enables an
 * interrupt that is a result of a Frame Lost of SMFC channel 0.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN (0U) /*!< Bit position for IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN. */
#define BM_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN. */
#define BS_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN field. */
#define BR_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN(x) (HW_IPU_INT_CTRL_10(x).B.SMFC0_FRM_LOST_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN. */
#define BF_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN) & BM_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN)

/*! @brief Set the SMFC0_FRM_LOST_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN) | BF_IPU_INT_CTRL_10_SMFC0_FRM_LOST_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field SMFC1_FRM_LOST_EN[1] (RW)
 *
 * Frame Lost of SMFC channel 1 interrupt enable bit This bit enables an
 * interrupt that is a result of a Frame Lost of SMFC channel 1.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN (1U) /*!< Bit position for IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN. */
#define BM_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN. */
#define BS_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN field. */
#define BR_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN(x) (HW_IPU_INT_CTRL_10(x).B.SMFC1_FRM_LOST_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN. */
#define BF_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN) & BM_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN)

/*! @brief Set the SMFC1_FRM_LOST_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN) | BF_IPU_INT_CTRL_10_SMFC1_FRM_LOST_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field SMFC2_FRM_LOST_EN[2] (RW)
 *
 * Frame Lost of SMFC channel 2 interrupt enable bit This bit enables an
 * interrupt that is a result of a Frame Lost of SMFC channel 2.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN (2U) /*!< Bit position for IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN. */
#define BM_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN. */
#define BS_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN field. */
#define BR_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN(x) (HW_IPU_INT_CTRL_10(x).B.SMFC2_FRM_LOST_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN. */
#define BF_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN) & BM_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN)

/*! @brief Set the SMFC2_FRM_LOST_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN) | BF_IPU_INT_CTRL_10_SMFC2_FRM_LOST_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field SMFC3_FRM_LOST_EN[3] (RW)
 *
 * Frame Lost of SMFC channel 3 interrupt enable bit This bit enables an
 * interrupt that is a result of a Frame Lost of SMFC channel 3.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN (3U) /*!< Bit position for IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN. */
#define BM_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN. */
#define BS_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN field. */
#define BR_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN(x) (HW_IPU_INT_CTRL_10(x).B.SMFC3_FRM_LOST_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN. */
#define BF_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN) & BM_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN)

/*! @brief Set the SMFC3_FRM_LOST_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN) | BF_IPU_INT_CTRL_10_SMFC3_FRM_LOST_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DC_TEARING_ERR_1_EN[16] (RW)
 *
 * Tearing Error #1 enable This bit enables the interrupt that is a result of
 * tearing error while the anti tearing mechanism is activated for DC channel 1
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN (16U) /*!< Bit position for IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN. */
#define BM_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN. */
#define BS_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN field. */
#define BR_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN(x) (HW_IPU_INT_CTRL_10(x).B.DC_TEARING_ERR_1_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN. */
#define BF_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN) & BM_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN)

/*! @brief Set the DC_TEARING_ERR_1_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN) | BF_IPU_INT_CTRL_10_DC_TEARING_ERR_1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DC_TEARING_ERR_2_EN[17] (RW)
 *
 * Tearing Error #2 enable This bit enables the interrupt that is a result of
 * tearing error while the anti tearing mechanism is activated for DC channel 2
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN (17U) /*!< Bit position for IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN. */
#define BM_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN. */
#define BS_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN field. */
#define BR_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN(x) (HW_IPU_INT_CTRL_10(x).B.DC_TEARING_ERR_2_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN. */
#define BF_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN) & BM_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN)

/*! @brief Set the DC_TEARING_ERR_2_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN) | BF_IPU_INT_CTRL_10_DC_TEARING_ERR_2_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DC_TEARING_ERR_6_EN[18] (RW)
 *
 * Tearing Error #6 enable This bit enables the interrupt that is a result of
 * tearing error while the anti tearing mechanism is activated for DC channel 6
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN (18U) /*!< Bit position for IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN. */
#define BM_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN. */
#define BS_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN field. */
#define BR_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN(x) (HW_IPU_INT_CTRL_10(x).B.DC_TEARING_ERR_6_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN. */
#define BF_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN) & BM_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN)

/*! @brief Set the DC_TEARING_ERR_6_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN) | BF_IPU_INT_CTRL_10_DC_TEARING_ERR_6_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DI0_SYNC_DISP_ERR_EN[19] (RW)
 *
 * DI0 Synchronous display error enable This bit enables the interrupt that is a
 * result of an error during access to a synchronous display via DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN (19U) /*!< Bit position for IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN. */
#define BM_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN. */
#define BS_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.DI0_SYNC_DISP_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN. */
#define BF_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN) & BM_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN)

/*! @brief Set the DI0_SYNC_DISP_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN) | BF_IPU_INT_CTRL_10_DI0_SYNC_DISP_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DI1_SYNC_DISP_ERR_EN[20] (RW)
 *
 * DI1 Synchronous display error enable This bit enables the interrupt that is a
 * result of an error during access to a synchronous display via DI1
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN (20U) /*!< Bit position for IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN. */
#define BM_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN. */
#define BS_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.DI1_SYNC_DISP_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN. */
#define BF_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN) & BM_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN)

/*! @brief Set the DI1_SYNC_DISP_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN) | BF_IPU_INT_CTRL_10_DI1_SYNC_DISP_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DI0_TIME_OUT_ERR_EN[21] (RW)
 *
 * DI0 time outwore interrupt enable This bit enables the interrupt that is a
 * result of a time out error during a read access via DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN (21U) /*!< Bit position for IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN. */
#define BM_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN. */
#define BS_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.DI0_TIME_OUT_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN. */
#define BF_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN) & BM_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN)

/*! @brief Set the DI0_TIME_OUT_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN) | BF_IPU_INT_CTRL_10_DI0_TIME_OUT_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field DI1_TIME_OUT_ERR_EN[22] (RW)
 *
 * DI1 time out error interrupt enable This bit enables the interrupt that is a
 * result of a time out error during a read access via DI1
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN (22U) /*!< Bit position for IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN. */
#define BM_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN. */
#define BS_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.DI1_TIME_OUT_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN. */
#define BF_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN) & BM_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN)

/*! @brief Set the DI1_TIME_OUT_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN) | BF_IPU_INT_CTRL_10_DI1_TIME_OUT_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field IC_VF_FRM_LOST_ERR_EN[24] (RW)
 *
 * This bit enables an interrupt that is a result of IC's view finder frame lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN (24U) /*!< Bit position for IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN. */
#define BM_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN. */
#define BS_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.IC_VF_FRM_LOST_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN. */
#define BF_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN) & BM_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN)

/*! @brief Set the IC_VF_FRM_LOST_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN) | BF_IPU_INT_CTRL_10_IC_VF_FRM_LOST_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field IC_ENC_FRM_LOST_ERR_EN[25] (RW)
 *
 * This bit enables an interrupt that is a result of IC's encoding frame lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN (25U) /*!< Bit position for IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN. */
#define BM_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN. */
#define BS_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.IC_ENC_FRM_LOST_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN. */
#define BF_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN) & BM_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN)

/*! @brief Set the IC_ENC_FRM_LOST_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN) | BF_IPU_INT_CTRL_10_IC_ENC_FRM_LOST_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field IC_BAYER_FRM_LOST_ERR_EN[26] (RW)
 *
 * This bit enables an interrupt that is a result of IC's Bayer frame lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN (26U) /*!< Bit position for IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN. */
#define BM_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN. */
#define BS_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.IC_BAYER_FRM_LOST_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN. */
#define BF_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN) & BM_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN)

/*! @brief Set the IC_BAYER_FRM_LOST_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN) | BF_IPU_INT_CTRL_10_IC_BAYER_FRM_LOST_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field NON_PRIVILEGED_ACC_ERR_EN[28] (RW)
 *
 * Non Privileged Access Error interrupt enable. The CPMEM and the DP can be
 * accessed by the ARM platform in privileged mode only HPROT[1] =1. An attempt to
 * access these regions in user mode will issue an interrupt. This bit enables the
 * interrupt.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN (28U) /*!< Bit position for IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN. */
#define BM_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN. */
#define BS_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.NON_PRIVILEGED_ACC_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN. */
#define BF_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN) & BM_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN)

/*! @brief Set the NON_PRIVILEGED_ACC_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN) | BF_IPU_INT_CTRL_10_NON_PRIVILEGED_ACC_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field AXIW_ERR_EN[29] (RW)
 *
 * This bit enables an interrupt that is a result of AXI write access resulted
 * with error response.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_AXIW_ERR_EN (29U) /*!< Bit position for IPU_INT_CTRL_10_AXIW_ERR_EN. */
#define BM_IPU_INT_CTRL_10_AXIW_ERR_EN (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_10_AXIW_ERR_EN. */
#define BS_IPU_INT_CTRL_10_AXIW_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_AXIW_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_AXIW_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_AXIW_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.AXIW_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_AXIW_ERR_EN. */
#define BF_IPU_INT_CTRL_10_AXIW_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_AXIW_ERR_EN) & BM_IPU_INT_CTRL_10_AXIW_ERR_EN)

/*! @brief Set the AXIW_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_AXIW_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_AXIW_ERR_EN) | BF_IPU_INT_CTRL_10_AXIW_ERR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_10, field AXIR_ERR_EN[30] (RW)
 *
 * This bit enables an interrupt that is a result of AXI read access resulted
 * with error response.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_10_AXIR_ERR_EN (30U) /*!< Bit position for IPU_INT_CTRL_10_AXIR_ERR_EN. */
#define BM_IPU_INT_CTRL_10_AXIR_ERR_EN (0x40000000U) /*!< Bit mask for IPU_INT_CTRL_10_AXIR_ERR_EN. */
#define BS_IPU_INT_CTRL_10_AXIR_ERR_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_10_AXIR_ERR_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_10_AXIR_ERR_EN field. */
#define BR_IPU_INT_CTRL_10_AXIR_ERR_EN(x) (HW_IPU_INT_CTRL_10(x).B.AXIR_ERR_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_10_AXIR_ERR_EN. */
#define BF_IPU_INT_CTRL_10_AXIR_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_10_AXIR_ERR_EN) & BM_IPU_INT_CTRL_10_AXIR_ERR_EN)

/*! @brief Set the AXIR_ERR_EN field to a new value. */
#define BW_IPU_INT_CTRL_10_AXIR_ERR_EN(x, v) (HW_IPU_INT_CTRL_10_WR(x, (HW_IPU_INT_CTRL_10_RD(x) & ~BM_IPU_INT_CTRL_10_AXIR_ERR_EN) | BF_IPU_INT_CTRL_10_AXIR_ERR_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_11 - Interrupt Control Register 11
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_11 - Interrupt Control Register 11 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * end-of-band indication (EOBND) of DMA Channels interrupts [31:0] can be found
 * in this register. Hide VDOA_SYNC for all versions Show VDOA_SYNC for IPUv3H
 * version. The table below tagged with other settings (like IPU3M_only) should be
 * hidden in IPUv3H version.
 */
typedef union _hw_ipu_int_ctrl_11
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_11_bitfields
    {
        uint32_t IDMAC_EOBND_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_EOBND_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_EOBND_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_EOBND_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOBND_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 5;        /*!< [10:6]  */
        uint32_t IDMAC_EOBND_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_EOBND_EN_12 : 1; /*!< [12]  */
        uint32_t RESERVED2 : 7;        /*!< [19:13]  */
        uint32_t IDMAC_EOBND_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_EOBND_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_EOBND_EN_22 : 1; /*!< [22]  */
        uint32_t RESERVED3 : 2;        /*!< [24:23]  */
        uint32_t IDMAC_EOBND_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_EOBND_EN_26 : 1; /*!< [26]  */
        uint32_t RESERVED4 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_int_ctrl_11_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_11 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_11_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_IPU_INT_CTRL_11(x)    (*(__IO hw_ipu_int_ctrl_11_t *) HW_IPU_INT_CTRL_11_ADDR(x))
#define HW_IPU_INT_CTRL_11_RD(x) (HW_IPU_INT_CTRL_11(x).U)
#define HW_IPU_INT_CTRL_11_WR(x, v) (HW_IPU_INT_CTRL_11(x).U = (v))
#define HW_IPU_INT_CTRL_11_SET(x, v) (HW_IPU_INT_CTRL_11_WR(x, HW_IPU_INT_CTRL_11_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_11_CLR(x, v) (HW_IPU_INT_CTRL_11_WR(x, HW_IPU_INT_CTRL_11_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_11_TOG(x, v) (HW_IPU_INT_CTRL_11_WR(x, HW_IPU_INT_CTRL_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_11 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_0[0] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0 (0U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_0. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_0. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_0. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_0 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_0)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_0. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0)

/*! @brief Set the IDMAC_EOBND_EN_0 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_1[1] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1 (1U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_1. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_1. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_1. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_1 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_1)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_1. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1)

/*! @brief Set the IDMAC_EOBND_EN_1 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_2[2] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2 (2U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_2. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_2. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_2. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_2 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_2)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_2. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2)

/*! @brief Set the IDMAC_EOBND_EN_2 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_3[3] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3 (3U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_3. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_3. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_3. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_3 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_3)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_3. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3)

/*! @brief Set the IDMAC_EOBND_EN_3 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_5[5] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5 (5U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_5. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_5. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_5. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_5 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_5)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_5. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5)

/*! @brief Set the IDMAC_EOBND_EN_5 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_11[11] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11 (11U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_11. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_11. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_11. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_11 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_11)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_11. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11)

/*! @brief Set the IDMAC_EOBND_EN_11 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_12[12] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12 (12U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_12. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_12. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_12. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_12 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_12)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_12. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12)

/*! @brief Set the IDMAC_EOBND_EN_12 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_20[20] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20 (20U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_20. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_20. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_20. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_20 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_20)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_20. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20)

/*! @brief Set the IDMAC_EOBND_EN_20 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_21[21] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21 (21U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_21. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_21. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_21. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_21 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_21)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_21. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21)

/*! @brief Set the IDMAC_EOBND_EN_21 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_22[22] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22 (22U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_22. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_22. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_22. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_22 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_22)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_22. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22)

/*! @brief Set the IDMAC_EOBND_EN_22 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_25[25] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_25. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_25. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_25 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_25. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25)

/*! @brief Set the IDMAC_EOBND_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_11, field IDMAC_EOBND_EN_26[26] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_11_IDMAC_EOBND_EN_26. */
#define BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_11_IDMAC_EOBND_EN_26. */
#define BS_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_11_IDMAC_EOBND_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_11_IDMAC_EOBND_EN_26 field. */
#define BR_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26(x) (HW_IPU_INT_CTRL_11(x).B.IDMAC_EOBND_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_11_IDMAC_EOBND_EN_26. */
#define BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26) & BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26)

/*! @brief Set the IDMAC_EOBND_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26(x, v) (HW_IPU_INT_CTRL_11_WR(x, (HW_IPU_INT_CTRL_11_RD(x) & ~BM_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26) | BF_IPU_INT_CTRL_11_IDMAC_EOBND_EN_26(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_12 - Interrupt Control Register 12
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_12 - Interrupt Control Register 12 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * end-of-band indication (EOBND) of DMA Channels interrupts [63:32] can be found
 * in this register.
 */
typedef union _hw_ipu_int_ctrl_12
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_12_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t IDMAC_EOBND_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_EOBND_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_EOBND_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_EOBND_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_EOBND_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_EOBND_EN_50 : 1; /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_int_ctrl_12_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_12 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_12_ADDR(x) ((uintptr_t)(x) + 0x68U)

#define HW_IPU_INT_CTRL_12(x)    (*(__IO hw_ipu_int_ctrl_12_t *) HW_IPU_INT_CTRL_12_ADDR(x))
#define HW_IPU_INT_CTRL_12_RD(x) (HW_IPU_INT_CTRL_12(x).U)
#define HW_IPU_INT_CTRL_12_WR(x, v) (HW_IPU_INT_CTRL_12(x).U = (v))
#define HW_IPU_INT_CTRL_12_SET(x, v) (HW_IPU_INT_CTRL_12_WR(x, HW_IPU_INT_CTRL_12_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_12_CLR(x, v) (HW_IPU_INT_CTRL_12_WR(x, HW_IPU_INT_CTRL_12_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_12_TOG(x, v) (HW_IPU_INT_CTRL_12_WR(x, HW_IPU_INT_CTRL_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_12 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_45[13] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45 (13U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_45. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_45. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_45. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_45 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_45)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_45. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45)

/*! @brief Set the IDMAC_EOBND_EN_45 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_46[14] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46 (14U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_46. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_46. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_46. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_46 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_46)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_46. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46)

/*! @brief Set the IDMAC_EOBND_EN_46 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_47[15] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47 (15U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_47. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_47. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_47. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_47 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_47)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_47. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47)

/*! @brief Set the IDMAC_EOBND_EN_47 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_48[16] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48 (16U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_48. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_48. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_48. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_48 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_48)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_48. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48)

/*! @brief Set the IDMAC_EOBND_EN_48 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_49[17] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49 (17U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_49. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_49. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_49. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_49 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_49)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_49. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49)

/*! @brief Set the IDMAC_EOBND_EN_49 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_12, field IDMAC_EOBND_EN_50[18] (RW)
 *
 * end-of-band indication of Channel interrupt. This bit is the control
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50 (18U) /*!< Bit position for IPU_INT_CTRL_12_IDMAC_EOBND_EN_50. */
#define BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_12_IDMAC_EOBND_EN_50. */
#define BS_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_12_IDMAC_EOBND_EN_50. */

/*! @brief Read current value of the IPU_INT_CTRL_12_IDMAC_EOBND_EN_50 field. */
#define BR_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50(x) (HW_IPU_INT_CTRL_12(x).B.IDMAC_EOBND_EN_50)

/*! @brief Format value for bitfield IPU_INT_CTRL_12_IDMAC_EOBND_EN_50. */
#define BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50) & BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50)

/*! @brief Set the IDMAC_EOBND_EN_50 field to a new value. */
#define BW_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50(x, v) (HW_IPU_INT_CTRL_12_WR(x, (HW_IPU_INT_CTRL_12_RD(x) & ~BM_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50) | BF_IPU_INT_CTRL_12_IDMAC_EOBND_EN_50(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_13 - Interrupt Control Register 13
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_13 - Interrupt Control Register 13 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * threshold crossing indication (TH) of DMA Channels interrupts [31:0] can be
 * found in this register.
 */
typedef union _hw_ipu_int_ctrl_13
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_13_bitfields
    {
        uint32_t IDMAC_TH_EN_0 : 1;    /*!< [0]  */
        uint32_t IDMAC_TH_EN_1 : 1;    /*!< [1]  */
        uint32_t IDMAC_TH_EN_2 : 1;    /*!< [2]  */
        uint32_t IDMAC_TH_EN_3 : 1;    /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_TH_EN_5 : 1;    /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_TH_EN_8 : 1;    /*!< [8]  */
        uint32_t IDMAC_TH_EN_9 : 1;    /*!< [9]  */
        uint32_t IDMAC_TH_EN_10 : 1;   /*!< [10]  */
        uint32_t IDMAC_TH_EN_11 : 1;   /*!< [11]  */
        uint32_t IDMAC_TH_EN_12 : 1;   /*!< [12]  */
        uint32_t IDMAC_TH_EN_13 : 1;   /*!< [13]  */
        uint32_t IDMAC_TH_EN_14 : 1;   /*!< [14]  */
        uint32_t IDMAC_TH_EN_15 : 1;   /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_TH_EN_17 : 1;   /*!< [17]  */
        uint32_t IDMAC_TH_EN_18 : 1;   /*!< [18]  */
        uint32_t IDMAC_TH_EN_19 : 1;   /*!< [19]  */
        uint32_t IDMAC_TH_EN_20 : 1;   /*!< [20]  */
        uint32_t IDMAC_TH_EN_21 : 1;   /*!< [21]  */
        uint32_t IDMAC_TH_EN_22 : 1;   /*!< [22]  */
        uint32_t IDMAC_TH_EN_23 : 1;   /*!< [23]  */
        uint32_t IDMAC_TH_EN_24 : 1;   /*!< [24]  */
        uint32_t IDMAC_TH_EN_25 : 1;   /*!< [25]  */
        uint32_t IDMAC_TH_EN_26 : 1;   /*!< [26]  */
        uint32_t IDMAC_TH_EN_27 : 1;   /*!< [27]  */
        uint32_t IDMAC_TH_EN_28 : 1;   /*!< [28]  */
        uint32_t IDMAC_TH_EN_29 : 1;   /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_TH_EN_31 : 1;   /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_13_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_13 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_13_ADDR(x) ((uintptr_t)(x) + 0x6CU)

#define HW_IPU_INT_CTRL_13(x)    (*(__IO hw_ipu_int_ctrl_13_t *) HW_IPU_INT_CTRL_13_ADDR(x))
#define HW_IPU_INT_CTRL_13_RD(x) (HW_IPU_INT_CTRL_13(x).U)
#define HW_IPU_INT_CTRL_13_WR(x, v) (HW_IPU_INT_CTRL_13(x).U = (v))
#define HW_IPU_INT_CTRL_13_SET(x, v) (HW_IPU_INT_CTRL_13_WR(x, HW_IPU_INT_CTRL_13_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_13_CLR(x, v) (HW_IPU_INT_CTRL_13_WR(x, HW_IPU_INT_CTRL_13_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_13_TOG(x, v) (HW_IPU_INT_CTRL_13_WR(x, HW_IPU_INT_CTRL_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_13 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_0[0] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_0 (0U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_0. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_0. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_0. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_0 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_0(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_0)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_0. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_0) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_0)

/*! @brief Set the IDMAC_TH_EN_0 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_0(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_0) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_1[1] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_1 (1U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_1. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_1. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_1. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_1 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_1(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_1)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_1. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_1) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_1)

/*! @brief Set the IDMAC_TH_EN_1 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_1(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_1) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_2[2] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_2 (2U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_2. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_2. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_2. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_2 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_2(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_2)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_2. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_2) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_2)

/*! @brief Set the IDMAC_TH_EN_2 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_2(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_2) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_3[3] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_3 (3U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_3. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_3. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_3. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_3 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_3(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_3)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_3. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_3) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_3)

/*! @brief Set the IDMAC_TH_EN_3 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_3(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_3) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_5[5] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_5 (5U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_5. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_5. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_5. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_5 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_5(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_5)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_5. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_5) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_5)

/*! @brief Set the IDMAC_TH_EN_5 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_5(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_5) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_8[8] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_8 (8U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_8. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_8 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_8. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_8 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_8. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_8 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_8(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_8)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_8. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_8) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_8)

/*! @brief Set the IDMAC_TH_EN_8 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_8(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_8) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_9[9] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_9 (9U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_9. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_9 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_9. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_9 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_9. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_9 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_9(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_9)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_9. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_9) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_9)

/*! @brief Set the IDMAC_TH_EN_9 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_9(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_9) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_10[10] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_10 (10U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_10. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_10 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_10. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_10 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_10. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_10 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_10(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_10)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_10. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_10) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_10)

/*! @brief Set the IDMAC_TH_EN_10 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_10(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_10) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_11[11] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_11 (11U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_11. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_11. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_11. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_11 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_11(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_11)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_11. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_11) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_11)

/*! @brief Set the IDMAC_TH_EN_11 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_11(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_11) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_12[12] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_12 (12U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_12. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_12. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_12. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_12 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_12(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_12)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_12. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_12) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_12)

/*! @brief Set the IDMAC_TH_EN_12 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_12(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_12) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_13[13] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_13 (13U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_13. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_13 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_13. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_13 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_13. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_13 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_13(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_13)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_13. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_13) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_13)

/*! @brief Set the IDMAC_TH_EN_13 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_13(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_13) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_14[14] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_14 (14U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_14. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_14 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_14. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_14 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_14. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_14 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_14(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_14)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_14. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_14) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_14)

/*! @brief Set the IDMAC_TH_EN_14 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_14(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_14) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_15[15] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_15 (15U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_15. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_15 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_15. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_15 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_15. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_15 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_15(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_15)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_15. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_15) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_15)

/*! @brief Set the IDMAC_TH_EN_15 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_15(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_15) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_17[17] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_17 (17U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_17. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_17 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_17. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_17 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_17. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_17 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_17(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_17)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_17. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_17) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_17)

/*! @brief Set the IDMAC_TH_EN_17 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_17(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_17) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_18[18] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_18 (18U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_18. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_18 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_18. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_18 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_18. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_18 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_18(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_18)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_18. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_18) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_18)

/*! @brief Set the IDMAC_TH_EN_18 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_18(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_18) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_19[19] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_19 (19U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_19. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_19. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_19. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_19 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_19(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_19)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_19. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_19) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_19)

/*! @brief Set the IDMAC_TH_EN_19 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_19(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_19) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_20[20] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_20 (20U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_20. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_20. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_20. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_20 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_20(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_20)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_20. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_20) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_20)

/*! @brief Set the IDMAC_TH_EN_20 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_20(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_20) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_21[21] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_21 (21U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_21. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_21. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_21. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_21 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_21(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_21)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_21. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_21) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_21)

/*! @brief Set the IDMAC_TH_EN_21 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_21(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_21) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_22[22] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_22 (22U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_22. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_22. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_22. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_22 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_22(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_22)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_22. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_22) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_22)

/*! @brief Set the IDMAC_TH_EN_22 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_22(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_22) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_23[23] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_23 (23U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_23. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_23. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_23. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_23 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_23(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_23)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_23. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_23) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_23)

/*! @brief Set the IDMAC_TH_EN_23 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_23(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_23) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_24[24] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_24 (24U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_24. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_24. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_24. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_24 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_24(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_24)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_24. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_24) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_24)

/*! @brief Set the IDMAC_TH_EN_24 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_24(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_24) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_25[25] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_25 (25U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_25. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_25. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_25. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_25 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_25(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_25)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_25. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_25) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_25)

/*! @brief Set the IDMAC_TH_EN_25 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_25(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_25) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_26[26] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_26 (26U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_26. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_26. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_26. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_26 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_26(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_26)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_26. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_26) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_26)

/*! @brief Set the IDMAC_TH_EN_26 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_26(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_26) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_27[27] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_27 (27U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_27. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_27. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_27. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_27 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_27(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_27)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_27. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_27) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_27)

/*! @brief Set the IDMAC_TH_EN_27 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_27(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_27) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_28[28] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_28 (28U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_28. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_28. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_28. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_28 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_28(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_28)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_28. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_28) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_28)

/*! @brief Set the IDMAC_TH_EN_28 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_28(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_28) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_29[29] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_29 (29U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_29. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_29. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_29. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_29 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_29(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_29)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_29. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_29) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_29)

/*! @brief Set the IDMAC_TH_EN_29 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_29(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_29) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_13, field IDMAC_TH_EN_31[31] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_13_IDMAC_TH_EN_31 (31U) /*!< Bit position for IPU_INT_CTRL_13_IDMAC_TH_EN_31. */
#define BM_IPU_INT_CTRL_13_IDMAC_TH_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_13_IDMAC_TH_EN_31. */
#define BS_IPU_INT_CTRL_13_IDMAC_TH_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_13_IDMAC_TH_EN_31. */

/*! @brief Read current value of the IPU_INT_CTRL_13_IDMAC_TH_EN_31 field. */
#define BR_IPU_INT_CTRL_13_IDMAC_TH_EN_31(x) (HW_IPU_INT_CTRL_13(x).B.IDMAC_TH_EN_31)

/*! @brief Format value for bitfield IPU_INT_CTRL_13_IDMAC_TH_EN_31. */
#define BF_IPU_INT_CTRL_13_IDMAC_TH_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_13_IDMAC_TH_EN_31) & BM_IPU_INT_CTRL_13_IDMAC_TH_EN_31)

/*! @brief Set the IDMAC_TH_EN_31 field to a new value. */
#define BW_IPU_INT_CTRL_13_IDMAC_TH_EN_31(x, v) (HW_IPU_INT_CTRL_13_WR(x, (HW_IPU_INT_CTRL_13_RD(x) & ~BM_IPU_INT_CTRL_13_IDMAC_TH_EN_31) | BF_IPU_INT_CTRL_13_IDMAC_TH_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_14 - Interrupt Control Register 14
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_14 - Interrupt Control Register 14 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of the
 * Threshold crossing indication (TH) of DMA Channels interrupts [63:32] can be
 * found in this register.
 */
typedef union _hw_ipu_int_ctrl_14
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_14_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_TH_EN_33 : 1;   /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_TH_EN_40 : 1;   /*!< [8]  */
        uint32_t IDMAC_TH_EN_41 : 1;   /*!< [9]  */
        uint32_t IDMAC_TH_EN_42 : 1;   /*!< [10]  */
        uint32_t IDMAC_TH_EN_43 : 1;   /*!< [11]  */
        uint32_t IDMAC_TH_EN_44 : 1;   /*!< [12]  */
        uint32_t IDMAC_TH_EN_45 : 1;   /*!< [13]  */
        uint32_t IDMAC_TH_EN_46 : 1;   /*!< [14]  */
        uint32_t IDMAC_TH_EN_47 : 1;   /*!< [15]  */
        uint32_t IDMAC_TH_EN_48 : 1;   /*!< [16]  */
        uint32_t IDMAC_TH_EN_49 : 1;   /*!< [17]  */
        uint32_t IDMAC_TH_EN_50 : 1;   /*!< [18]  */
        uint32_t IDMAC_TH_EN_51 : 1;   /*!< [19]  */
        uint32_t IDMAC_TH_EN_52 : 1;   /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_ctrl_14_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_14 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_14_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_IPU_INT_CTRL_14(x)    (*(__IO hw_ipu_int_ctrl_14_t *) HW_IPU_INT_CTRL_14_ADDR(x))
#define HW_IPU_INT_CTRL_14_RD(x) (HW_IPU_INT_CTRL_14(x).U)
#define HW_IPU_INT_CTRL_14_WR(x, v) (HW_IPU_INT_CTRL_14(x).U = (v))
#define HW_IPU_INT_CTRL_14_SET(x, v) (HW_IPU_INT_CTRL_14_WR(x, HW_IPU_INT_CTRL_14_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_14_CLR(x, v) (HW_IPU_INT_CTRL_14_WR(x, HW_IPU_INT_CTRL_14_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_14_TOG(x, v) (HW_IPU_INT_CTRL_14_WR(x, HW_IPU_INT_CTRL_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_14 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_33[1] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_33 (1U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_33. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_33. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_33. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_33 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_33(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_33)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_33. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_33) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_33)

/*! @brief Set the IDMAC_TH_EN_33 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_33(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_33) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_40[8] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_40 (8U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_40. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_40 (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_40. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_40 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_40. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_40 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_40(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_40)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_40. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_40) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_40)

/*! @brief Set the IDMAC_TH_EN_40 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_40(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_40) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_41[9] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_41 (9U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_41. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_41. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_41. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_41 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_41(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_41)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_41. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_41) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_41)

/*! @brief Set the IDMAC_TH_EN_41 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_41(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_41) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_42[10] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_42 (10U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_42. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_42. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_42. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_42 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_42(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_42)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_42. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_42) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_42)

/*! @brief Set the IDMAC_TH_EN_42 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_42(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_42) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_43[11] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_43 (11U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_43. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_43. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_43. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_43 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_43(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_43)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_43. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_43) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_43)

/*! @brief Set the IDMAC_TH_EN_43 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_43(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_43) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_44[12] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_44 (12U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_44. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_44. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_44. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_44 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_44(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_44)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_44. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_44) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_44)

/*! @brief Set the IDMAC_TH_EN_44 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_44(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_44) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_45[13] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_45 (13U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_45. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_45. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_45. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_45 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_45(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_45)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_45. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_45) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_45)

/*! @brief Set the IDMAC_TH_EN_45 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_45(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_45) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_46[14] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_46 (14U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_46. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_46. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_46. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_46 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_46(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_46)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_46. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_46) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_46)

/*! @brief Set the IDMAC_TH_EN_46 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_46(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_46) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_47[15] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_47 (15U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_47. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_47. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_47. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_47 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_47(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_47)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_47. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_47) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_47)

/*! @brief Set the IDMAC_TH_EN_47 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_47(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_47) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_48[16] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_48 (16U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_48. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_48. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_48. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_48 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_48(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_48)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_48. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_48) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_48)

/*! @brief Set the IDMAC_TH_EN_48 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_48(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_48) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_49[17] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_49 (17U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_49. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_49. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_49. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_49 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_49(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_49)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_49. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_49) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_49)

/*! @brief Set the IDMAC_TH_EN_49 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_49(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_49) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_50[18] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_50 (18U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_50. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_50. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_50. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_50 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_50(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_50)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_50. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_50) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_50)

/*! @brief Set the IDMAC_TH_EN_50 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_50(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_50) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_51[19] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_51 (19U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_51. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_51. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_51. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_51 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_51(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_51)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_51. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_51) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_51)

/*! @brief Set the IDMAC_TH_EN_51 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_51(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_51) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_14, field IDMAC_TH_EN_52[20] (RW)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the control
 * Threshold crossing interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_14_IDMAC_TH_EN_52 (20U) /*!< Bit position for IPU_INT_CTRL_14_IDMAC_TH_EN_52. */
#define BM_IPU_INT_CTRL_14_IDMAC_TH_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_14_IDMAC_TH_EN_52. */
#define BS_IPU_INT_CTRL_14_IDMAC_TH_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_CTRL_14_IDMAC_TH_EN_52. */

/*! @brief Read current value of the IPU_INT_CTRL_14_IDMAC_TH_EN_52 field. */
#define BR_IPU_INT_CTRL_14_IDMAC_TH_EN_52(x) (HW_IPU_INT_CTRL_14(x).B.IDMAC_TH_EN_52)

/*! @brief Format value for bitfield IPU_INT_CTRL_14_IDMAC_TH_EN_52. */
#define BF_IPU_INT_CTRL_14_IDMAC_TH_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_14_IDMAC_TH_EN_52) & BM_IPU_INT_CTRL_14_IDMAC_TH_EN_52)

/*! @brief Set the IDMAC_TH_EN_52 field to a new value. */
#define BW_IPU_INT_CTRL_14_IDMAC_TH_EN_52(x, v) (HW_IPU_INT_CTRL_14_WR(x, (HW_IPU_INT_CTRL_14_RD(x) & ~BM_IPU_INT_CTRL_14_IDMAC_TH_EN_52) | BF_IPU_INT_CTRL_14_IDMAC_TH_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_CTRL_15 - Interrupt Control Register15
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_CTRL_15 - Interrupt Control Register15 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU interrupts controls. The controls of
 * general purpose interrupts can be found in this register.
 */
typedef union _hw_ipu_int_ctrl_15
{
    uint32_t U;
    struct _hw_ipu_int_ctrl_15_bitfields
    {
        uint32_t SNOOPING1_INT_EN : 1; /*!< [0]  */
        uint32_t SNOOPING2_INT_EN : 1; /*!< [1]  */
        uint32_t DP_SF_START_EN : 1;   /*!< [2]  */
        uint32_t DP_SF_END_EN : 1;     /*!< [3]  */
        uint32_t DP_ASF_START_EN : 1;  /*!< [4]  */
        uint32_t DP_ASF_END_EN : 1;    /*!< [5]  */
        uint32_t DP_SF_BRAKE_EN : 1;   /*!< [6]  */
        uint32_t DP_ASF_BRAKE_EN : 1;  /*!< [7]  */
        uint32_t DC_FC_0_EN : 1;       /*!< [8]  */
        uint32_t DC_FC_1_EN : 1;       /*!< [9]  */
        uint32_t DC_FC_2_EN : 1;       /*!< [10]  */
        uint32_t DC_FC_3_EN : 1;       /*!< [11]  */
        uint32_t DC_FC_4_EN : 1;       /*!< [12]  */
        uint32_t DC_FC_6_EN : 1;       /*!< [13]  */
        uint32_t DI_VSYNC_PRE_0_EN : 1; /*!< [14]  */
        uint32_t DI_VSYNC_PRE_1_EN : 1; /*!< [15]  */
        uint32_t DC_DP_START_EN : 1;   /*!< [16]  */
        uint32_t DC_ASYNC_STOP_EN : 1; /*!< [17]  */
        uint32_t DI0_CNT_EN_PRE_0_EN : 1; /*!< [18]  */
        uint32_t DI0_CNT_EN_PRE_1_EN : 1; /*!< [19]  */
        uint32_t DI0_CNT_EN_PRE_2_EN : 1; /*!< [20]  */
        uint32_t DI0_CNT_EN_PRE_3_EN : 1; /*!< [21]  */
        uint32_t DI0_CNT_EN_PRE_4_EN : 1; /*!< [22]  */
        uint32_t DI0_CNT_EN_PRE_5_EN : 1; /*!< [23]  */
        uint32_t DI0_CNT_EN_PRE_6_EN : 1; /*!< [24]  */
        uint32_t DI0_CNT_EN_PRE_7_EN : 1; /*!< [25]  */
        uint32_t DI0_CNT_EN_PRE_8_EN : 1; /*!< [26]  */
        uint32_t DI0_CNT_EN_PRE_9_EN : 1; /*!< [27]  */
        uint32_t DI0_CNT_EN_PRE_10_EN : 1; /*!< [28]  */
        uint32_t DI1_DISP_CLK_EN_PRE_EN : 1; /*!< [29]  */
        uint32_t DI1_CNT_EN_PRE_3_EN : 1; /*!< [30]  */
        uint32_t DI1_CNT_EN_PRE_8_EN : 1; /*!< [31]  */
    } B;
} hw_ipu_int_ctrl_15_t;

/*!
 * @name Constants and macros for entire IPU_INT_CTRL_15 register
 */
/*@{*/
#define HW_IPU_INT_CTRL_15_ADDR(x) ((uintptr_t)(x) + 0x74U)

#define HW_IPU_INT_CTRL_15(x)    (*(__IO hw_ipu_int_ctrl_15_t *) HW_IPU_INT_CTRL_15_ADDR(x))
#define HW_IPU_INT_CTRL_15_RD(x) (HW_IPU_INT_CTRL_15(x).U)
#define HW_IPU_INT_CTRL_15_WR(x, v) (HW_IPU_INT_CTRL_15(x).U = (v))
#define HW_IPU_INT_CTRL_15_SET(x, v) (HW_IPU_INT_CTRL_15_WR(x, HW_IPU_INT_CTRL_15_RD(x) |  (v)))
#define HW_IPU_INT_CTRL_15_CLR(x, v) (HW_IPU_INT_CTRL_15_WR(x, HW_IPU_INT_CTRL_15_RD(x) & ~(v)))
#define HW_IPU_INT_CTRL_15_TOG(x, v) (HW_IPU_INT_CTRL_15_WR(x, HW_IPU_INT_CTRL_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_CTRL_15 bitfields
 */

/*!
 * @name Register IPU_INT_CTRL_15, field SNOOPING1_INT_EN[0] (RW)
 *
 * IPU snooping 1 interrupt enable bit. This bit enables the interrupt that is a
 * result of the detection of a snooping 1 signal assertion coming to the IPU
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_SNOOPING1_INT_EN (0U) /*!< Bit position for IPU_INT_CTRL_15_SNOOPING1_INT_EN. */
#define BM_IPU_INT_CTRL_15_SNOOPING1_INT_EN (0x00000001U) /*!< Bit mask for IPU_INT_CTRL_15_SNOOPING1_INT_EN. */
#define BS_IPU_INT_CTRL_15_SNOOPING1_INT_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_SNOOPING1_INT_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_SNOOPING1_INT_EN field. */
#define BR_IPU_INT_CTRL_15_SNOOPING1_INT_EN(x) (HW_IPU_INT_CTRL_15(x).B.SNOOPING1_INT_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_SNOOPING1_INT_EN. */
#define BF_IPU_INT_CTRL_15_SNOOPING1_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_SNOOPING1_INT_EN) & BM_IPU_INT_CTRL_15_SNOOPING1_INT_EN)

/*! @brief Set the SNOOPING1_INT_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_SNOOPING1_INT_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_SNOOPING1_INT_EN) | BF_IPU_INT_CTRL_15_SNOOPING1_INT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field SNOOPING2_INT_EN[1] (RW)
 *
 * IPU snooping 2 interrupt enable bit. This bit enables the interrupt that is a
 * result of the detection of a snooping 2 signal assertion coming to the IPU
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_SNOOPING2_INT_EN (1U) /*!< Bit position for IPU_INT_CTRL_15_SNOOPING2_INT_EN. */
#define BM_IPU_INT_CTRL_15_SNOOPING2_INT_EN (0x00000002U) /*!< Bit mask for IPU_INT_CTRL_15_SNOOPING2_INT_EN. */
#define BS_IPU_INT_CTRL_15_SNOOPING2_INT_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_SNOOPING2_INT_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_SNOOPING2_INT_EN field. */
#define BR_IPU_INT_CTRL_15_SNOOPING2_INT_EN(x) (HW_IPU_INT_CTRL_15(x).B.SNOOPING2_INT_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_SNOOPING2_INT_EN. */
#define BF_IPU_INT_CTRL_15_SNOOPING2_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_SNOOPING2_INT_EN) & BM_IPU_INT_CTRL_15_SNOOPING2_INT_EN)

/*! @brief Set the SNOOPING2_INT_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_SNOOPING2_INT_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_SNOOPING2_INT_EN) | BF_IPU_INT_CTRL_15_SNOOPING2_INT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_SF_START_EN[2] (RW)
 *
 * DP Sync Flow Start enable bit. This bit enables the interrupt that is a
 * result of the Sync flow start at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_SF_START_EN (2U) /*!< Bit position for IPU_INT_CTRL_15_DP_SF_START_EN. */
#define BM_IPU_INT_CTRL_15_DP_SF_START_EN (0x00000004U) /*!< Bit mask for IPU_INT_CTRL_15_DP_SF_START_EN. */
#define BS_IPU_INT_CTRL_15_DP_SF_START_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_SF_START_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_SF_START_EN field. */
#define BR_IPU_INT_CTRL_15_DP_SF_START_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_SF_START_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_SF_START_EN. */
#define BF_IPU_INT_CTRL_15_DP_SF_START_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_SF_START_EN) & BM_IPU_INT_CTRL_15_DP_SF_START_EN)

/*! @brief Set the DP_SF_START_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_SF_START_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_SF_START_EN) | BF_IPU_INT_CTRL_15_DP_SF_START_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_SF_END_EN[3] (RW)
 *
 * DP Sync Flow End enable bit. This bit enables the interrupt that is a result
 * of the Sync flow end at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_SF_END_EN (3U) /*!< Bit position for IPU_INT_CTRL_15_DP_SF_END_EN. */
#define BM_IPU_INT_CTRL_15_DP_SF_END_EN (0x00000008U) /*!< Bit mask for IPU_INT_CTRL_15_DP_SF_END_EN. */
#define BS_IPU_INT_CTRL_15_DP_SF_END_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_SF_END_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_SF_END_EN field. */
#define BR_IPU_INT_CTRL_15_DP_SF_END_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_SF_END_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_SF_END_EN. */
#define BF_IPU_INT_CTRL_15_DP_SF_END_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_SF_END_EN) & BM_IPU_INT_CTRL_15_DP_SF_END_EN)

/*! @brief Set the DP_SF_END_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_SF_END_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_SF_END_EN) | BF_IPU_INT_CTRL_15_DP_SF_END_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_ASF_START_EN[4] (RW)
 *
 * DP Async Flow Start enable bit. This bit enables the interrupt that is a
 * result of the Async flow start at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_ASF_START_EN (4U) /*!< Bit position for IPU_INT_CTRL_15_DP_ASF_START_EN. */
#define BM_IPU_INT_CTRL_15_DP_ASF_START_EN (0x00000010U) /*!< Bit mask for IPU_INT_CTRL_15_DP_ASF_START_EN. */
#define BS_IPU_INT_CTRL_15_DP_ASF_START_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_ASF_START_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_ASF_START_EN field. */
#define BR_IPU_INT_CTRL_15_DP_ASF_START_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_ASF_START_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_ASF_START_EN. */
#define BF_IPU_INT_CTRL_15_DP_ASF_START_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_ASF_START_EN) & BM_IPU_INT_CTRL_15_DP_ASF_START_EN)

/*! @brief Set the DP_ASF_START_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_ASF_START_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_ASF_START_EN) | BF_IPU_INT_CTRL_15_DP_ASF_START_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_ASF_END_EN[5] (RW)
 *
 * DP Async Flow End enable bit. This bit enables the interrupt that is a result
 * of the Async flow end at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_ASF_END_EN (5U) /*!< Bit position for IPU_INT_CTRL_15_DP_ASF_END_EN. */
#define BM_IPU_INT_CTRL_15_DP_ASF_END_EN (0x00000020U) /*!< Bit mask for IPU_INT_CTRL_15_DP_ASF_END_EN. */
#define BS_IPU_INT_CTRL_15_DP_ASF_END_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_ASF_END_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_ASF_END_EN field. */
#define BR_IPU_INT_CTRL_15_DP_ASF_END_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_ASF_END_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_ASF_END_EN. */
#define BF_IPU_INT_CTRL_15_DP_ASF_END_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_ASF_END_EN) & BM_IPU_INT_CTRL_15_DP_ASF_END_EN)

/*! @brief Set the DP_ASF_END_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_ASF_END_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_ASF_END_EN) | BF_IPU_INT_CTRL_15_DP_ASF_END_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_SF_BRAKE_EN[6] (RW)
 *
 * DP Sync Flow Brake enable bit. This bit enables the interrupt that is a
 * result of the Sync flow brake at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_SF_BRAKE_EN (6U) /*!< Bit position for IPU_INT_CTRL_15_DP_SF_BRAKE_EN. */
#define BM_IPU_INT_CTRL_15_DP_SF_BRAKE_EN (0x00000040U) /*!< Bit mask for IPU_INT_CTRL_15_DP_SF_BRAKE_EN. */
#define BS_IPU_INT_CTRL_15_DP_SF_BRAKE_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_SF_BRAKE_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_SF_BRAKE_EN field. */
#define BR_IPU_INT_CTRL_15_DP_SF_BRAKE_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_SF_BRAKE_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_SF_BRAKE_EN. */
#define BF_IPU_INT_CTRL_15_DP_SF_BRAKE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_SF_BRAKE_EN) & BM_IPU_INT_CTRL_15_DP_SF_BRAKE_EN)

/*! @brief Set the DP_SF_BRAKE_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_SF_BRAKE_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_SF_BRAKE_EN) | BF_IPU_INT_CTRL_15_DP_SF_BRAKE_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DP_ASF_BRAKE_EN[7] (RW)
 *
 * DP Async Flow Brake enable bit. This bit enables the interrupt that is a
 * result of the async flow brake at the DP
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN (7U) /*!< Bit position for IPU_INT_CTRL_15_DP_ASF_BRAKE_EN. */
#define BM_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN (0x00000080U) /*!< Bit mask for IPU_INT_CTRL_15_DP_ASF_BRAKE_EN. */
#define BS_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DP_ASF_BRAKE_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DP_ASF_BRAKE_EN field. */
#define BR_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN(x) (HW_IPU_INT_CTRL_15(x).B.DP_ASF_BRAKE_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DP_ASF_BRAKE_EN. */
#define BF_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN) & BM_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN)

/*! @brief Set the DP_ASF_BRAKE_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN) | BF_IPU_INT_CTRL_15_DP_ASF_BRAKE_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_0_EN[8] (RW)
 *
 * This bit enables they'd Frame Complete on channel #0 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_0_EN (8U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_0_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_0_EN (0x00000100U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_0_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_0_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_0_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_0_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_0_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_0_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_0_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_0_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_0_EN) & BM_IPU_INT_CTRL_15_DC_FC_0_EN)

/*! @brief Set the DC_FC_0_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_0_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_0_EN) | BF_IPU_INT_CTRL_15_DC_FC_0_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_1_EN[9] (RW)
 *
 * This bit enables they'd Frame Complete on channel #1 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_1_EN (9U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_1_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_1_EN (0x00000200U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_1_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_1_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_1_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_1_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_1_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_1_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_1_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_1_EN) & BM_IPU_INT_CTRL_15_DC_FC_1_EN)

/*! @brief Set the DC_FC_1_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_1_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_1_EN) | BF_IPU_INT_CTRL_15_DC_FC_1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_2_EN[10] (RW)
 *
 * This bit enables the DC Frame Complete on channel #2 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_2_EN (10U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_2_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_2_EN (0x00000400U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_2_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_2_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_2_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_2_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_2_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_2_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_2_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_2_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_2_EN) & BM_IPU_INT_CTRL_15_DC_FC_2_EN)

/*! @brief Set the DC_FC_2_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_2_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_2_EN) | BF_IPU_INT_CTRL_15_DC_FC_2_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_3_EN[11] (RW)
 *
 * This bit enables the DC Frame Complete on channel #3 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_3_EN (11U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_3_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_3_EN (0x00000800U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_3_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_3_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_3_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_3_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_3_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_3_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_3_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_3_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_3_EN) & BM_IPU_INT_CTRL_15_DC_FC_3_EN)

/*! @brief Set the DC_FC_3_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_3_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_3_EN) | BF_IPU_INT_CTRL_15_DC_FC_3_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_4_EN[12] (RW)
 *
 * This bit enables the DC Frame Complete on channel #4 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_4_EN (12U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_4_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_4_EN (0x00001000U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_4_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_4_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_4_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_4_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_4_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_4_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_4_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_4_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_4_EN) & BM_IPU_INT_CTRL_15_DC_FC_4_EN)

/*! @brief Set the DC_FC_4_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_4_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_4_EN) | BF_IPU_INT_CTRL_15_DC_FC_4_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_FC_6_EN[13] (RW)
 *
 * This bit enables the DC Frame Complete on channel #6 interrupt
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_FC_6_EN (13U) /*!< Bit position for IPU_INT_CTRL_15_DC_FC_6_EN. */
#define BM_IPU_INT_CTRL_15_DC_FC_6_EN (0x00002000U) /*!< Bit mask for IPU_INT_CTRL_15_DC_FC_6_EN. */
#define BS_IPU_INT_CTRL_15_DC_FC_6_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_FC_6_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_FC_6_EN field. */
#define BR_IPU_INT_CTRL_15_DC_FC_6_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_FC_6_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_FC_6_EN. */
#define BF_IPU_INT_CTRL_15_DC_FC_6_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_FC_6_EN) & BM_IPU_INT_CTRL_15_DC_FC_6_EN)

/*! @brief Set the DC_FC_6_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_FC_6_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_FC_6_EN) | BF_IPU_INT_CTRL_15_DC_FC_6_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI_VSYNC_PRE_0_EN[14] (RW)
 *
 * This bit enables the DI0 interrupt indicating of a VSYNC signal asserted 2
 * rows before the VSYNC sent to the display
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN (14U) /*!< Bit position for IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN. */
#define BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN (0x00004000U) /*!< Bit mask for IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN. */
#define BS_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN field. */
#define BR_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI_VSYNC_PRE_0_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN. */
#define BF_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN) & BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN)

/*! @brief Set the DI_VSYNC_PRE_0_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN) | BF_IPU_INT_CTRL_15_DI_VSYNC_PRE_0_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI_VSYNC_PRE_1_EN[15] (RW)
 *
 * This bit enables the DI1 interrupt indicating of a VSYNC signal asserted 2
 * rows before the VSYNC sent to the display
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN (15U) /*!< Bit position for IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN. */
#define BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN (0x00008000U) /*!< Bit mask for IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN. */
#define BS_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN field. */
#define BR_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI_VSYNC_PRE_1_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN. */
#define BF_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN) & BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN)

/*! @brief Set the DI_VSYNC_PRE_1_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN) | BF_IPU_INT_CTRL_15_DI_VSYNC_PRE_1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_DP_START_EN[16] (RW)
 *
 * This bit enables the interrupt asserted anytime the DP start a new sync or
 * async flow or when an async flow is interrupted by a sync flow
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_DP_START_EN (16U) /*!< Bit position for IPU_INT_CTRL_15_DC_DP_START_EN. */
#define BM_IPU_INT_CTRL_15_DC_DP_START_EN (0x00010000U) /*!< Bit mask for IPU_INT_CTRL_15_DC_DP_START_EN. */
#define BS_IPU_INT_CTRL_15_DC_DP_START_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_DP_START_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_DP_START_EN field. */
#define BR_IPU_INT_CTRL_15_DC_DP_START_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_DP_START_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_DP_START_EN. */
#define BF_IPU_INT_CTRL_15_DC_DP_START_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_DP_START_EN) & BM_IPU_INT_CTRL_15_DC_DP_START_EN)

/*! @brief Set the DC_DP_START_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_DP_START_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_DP_START_EN) | BF_IPU_INT_CTRL_15_DC_DP_START_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DC_ASYNC_STOP_EN[17] (RW)
 *
 * This bit enables the interrupt asserted anytime the DP stops an async flow
 * and moves to a sync flow
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN (17U) /*!< Bit position for IPU_INT_CTRL_15_DC_ASYNC_STOP_EN. */
#define BM_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN (0x00020000U) /*!< Bit mask for IPU_INT_CTRL_15_DC_ASYNC_STOP_EN. */
#define BS_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DC_ASYNC_STOP_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DC_ASYNC_STOP_EN field. */
#define BR_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN(x) (HW_IPU_INT_CTRL_15(x).B.DC_ASYNC_STOP_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DC_ASYNC_STOP_EN. */
#define BF_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN) & BM_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN)

/*! @brief Set the DC_ASYNC_STOP_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN) | BF_IPU_INT_CTRL_15_DC_ASYNC_STOP_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_0_EN[18] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #0 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN (18U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN (0x00040000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_0_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN)

/*! @brief Set the DI0_CNT_EN_PRE_0_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_0_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_1_EN[19] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #1 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN (19U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN (0x00080000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_1_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN)

/*! @brief Set the DI0_CNT_EN_PRE_1_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_1_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_2_EN[20] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #2 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN (20U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN (0x00100000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_2_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN)

/*! @brief Set the DI0_CNT_EN_PRE_2_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_2_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_3_EN[21] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #3 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN (21U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN (0x00200000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_3_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN)

/*! @brief Set the DI0_CNT_EN_PRE_3_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_3_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_4_EN[22] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #4 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN (22U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN (0x00400000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_4_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN)

/*! @brief Set the DI0_CNT_EN_PRE_4_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_4_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_5_EN[23] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #5 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN (23U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN (0x00800000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_5_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN)

/*! @brief Set the DI0_CNT_EN_PRE_5_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_5_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_6_EN[24] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #6 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN (24U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN (0x01000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_6_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN)

/*! @brief Set the DI0_CNT_EN_PRE_6_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_6_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_7_EN[25] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #7 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN (25U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN (0x02000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_7_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN)

/*! @brief Set the DI0_CNT_EN_PRE_7_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_7_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_8_EN[26] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #8 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN (26U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN (0x04000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_8_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN)

/*! @brief Set the DI0_CNT_EN_PRE_8_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_8_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_9_EN[27] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #9 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN (27U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN (0x08000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_9_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN)

/*! @brief Set the DI0_CNT_EN_PRE_9_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_9_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI0_CNT_EN_PRE_10_EN[28] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #10 of DI0
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN (28U) /*!< Bit position for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN. */
#define BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN (0x10000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN. */
#define BS_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN field. */
#define BR_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI0_CNT_EN_PRE_10_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN. */
#define BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN) & BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN)

/*! @brief Set the DI0_CNT_EN_PRE_10_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN) | BF_IPU_INT_CTRL_15_DI0_CNT_EN_PRE_10_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI1_DISP_CLK_EN_PRE_EN[29] (RW)
 *
 * DI1_DISP_CLK_EN_PRE_EN
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN (29U) /*!< Bit position for IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN. */
#define BM_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN (0x20000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN. */
#define BS_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN field. */
#define BR_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI1_DISP_CLK_EN_PRE_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN. */
#define BF_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN) & BM_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN)

/*! @brief Set the DI1_DISP_CLK_EN_PRE_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN) | BF_IPU_INT_CTRL_15_DI1_DISP_CLK_EN_PRE_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI1_CNT_EN_PRE_3_EN[30] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #3 of DI1
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN (30U) /*!< Bit position for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN. */
#define BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN (0x40000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN. */
#define BS_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN field. */
#define BR_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI1_CNT_EN_PRE_3_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN. */
#define BF_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN) & BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN)

/*! @brief Set the DI1_CNT_EN_PRE_3_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN) | BF_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_3_EN(v)))
/*@}*/

/*!
 * @name Register IPU_INT_CTRL_15, field DI1_CNT_EN_PRE_8_EN[31] (RW)
 *
 * This bit enables the interrupt that is a result of a trigger generated by
 * counter #8 of DI1
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN (31U) /*!< Bit position for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN. */
#define BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN (0x80000000U) /*!< Bit mask for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN. */
#define BS_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN (1U) /*!< Bit field size in bits for IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN. */

/*! @brief Read current value of the IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN field. */
#define BR_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN(x) (HW_IPU_INT_CTRL_15(x).B.DI1_CNT_EN_PRE_8_EN)

/*! @brief Format value for bitfield IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN. */
#define BF_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN) & BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN)

/*! @brief Set the DI1_CNT_EN_PRE_8_EN field to a new value. */
#define BW_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN(x, v) (HW_IPU_INT_CTRL_15_WR(x, (HW_IPU_INT_CTRL_15_RD(x) & ~BM_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN) | BF_IPU_INT_CTRL_15_DI1_CNT_EN_PRE_8_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_1 - SDMA Event Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_1 - SDMA Event Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of EOF
 * (end of frame) of DMA Channels SDMA events [31:0] can be found in this
 * register.
 */
typedef union _hw_ipu_sdma_event_1
{
    uint32_t U;
    struct _hw_ipu_sdma_event_1_bitfields
    {
        uint32_t IDMAC_EOF_SDMA_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_EOF_SDMA_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_EOF_SDMA_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_EOF_SDMA_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOF_SDMA_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_EOF_SDMA_EN_8 : 1; /*!< [8]  */
        uint32_t IDMAC_EOF_SDMA_EN_9 : 1; /*!< [9]  */
        uint32_t IDMAC_EOF_SDMA_EN_10 : 1; /*!< [10]  */
        uint32_t IDMAC_EOF_SDMA_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_EOF_SDMA_EN_12 : 1; /*!< [12]  */
        uint32_t IDMAC_EOF_SDMA_EN_13 : 1; /*!< [13]  */
        uint32_t IDMAC_EOF_SDMA_EN_14 : 1; /*!< [14]  */
        uint32_t IDMAC_EOF_SDMA_EN_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_EOF_SDMA_EN_17 : 1; /*!< [17]  */
        uint32_t IDMAC_EOF_SDMA_EN_18 : 1; /*!< [18]  */
        uint32_t IDMAC_EOF_SDMA_EN_19 : 1; /*!< [19]  */
        uint32_t IDMAC_EOF_SDMA_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_EOF_SDMA_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_EOF_SDMA_EN_22 : 1; /*!< [22]  */
        uint32_t IDMAC_EOF_SDMA_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_EOF_SDMA_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_EOF_SDMA_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_EOF_SDMA_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_EOF_SDMA_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_EOF_SDMA_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_EOF_SDMA_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOF_SDMA_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_sdma_event_1_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_1 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_1_ADDR(x) ((uintptr_t)(x) + 0x78U)

#define HW_IPU_SDMA_EVENT_1(x)   (*(__IO hw_ipu_sdma_event_1_t *) HW_IPU_SDMA_EVENT_1_ADDR(x))
#define HW_IPU_SDMA_EVENT_1_RD(x) (HW_IPU_SDMA_EVENT_1(x).U)
#define HW_IPU_SDMA_EVENT_1_WR(x, v) (HW_IPU_SDMA_EVENT_1(x).U = (v))
#define HW_IPU_SDMA_EVENT_1_SET(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, HW_IPU_SDMA_EVENT_1_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_1_CLR(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, HW_IPU_SDMA_EVENT_1_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_1_TOG(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, HW_IPU_SDMA_EVENT_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_1 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_0[0] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0 (0U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0 (0x00000001U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_0)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0)

/*! @brief Set the IDMAC_EOF_SDMA_EN_0 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_1[1] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1 (1U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_1)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1)

/*! @brief Set the IDMAC_EOF_SDMA_EN_1 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_2[2] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2 (2U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2 (0x00000004U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_2)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2)

/*! @brief Set the IDMAC_EOF_SDMA_EN_2 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_3[3] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3 (3U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3 (0x00000008U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_3)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3)

/*! @brief Set the IDMAC_EOF_SDMA_EN_3 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_5[5] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5 (5U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5 (0x00000020U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_5)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5)

/*! @brief Set the IDMAC_EOF_SDMA_EN_5 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_8[8] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8 (8U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_8)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8)

/*! @brief Set the IDMAC_EOF_SDMA_EN_8 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_9[9] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9 (9U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_9)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9)

/*! @brief Set the IDMAC_EOF_SDMA_EN_9 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_10[10] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10 (10U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_10)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10)

/*! @brief Set the IDMAC_EOF_SDMA_EN_10 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_11[11] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11 (11U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_11)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11)

/*! @brief Set the IDMAC_EOF_SDMA_EN_11 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_12[12] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12 (12U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_12)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12)

/*! @brief Set the IDMAC_EOF_SDMA_EN_12 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_13[13] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13 (13U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_13)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13)

/*! @brief Set the IDMAC_EOF_SDMA_EN_13 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_14[14] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14 (14U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_14)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14)

/*! @brief Set the IDMAC_EOF_SDMA_EN_14 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_15[15] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15 (15U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_15)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15)

/*! @brief Set the IDMAC_EOF_SDMA_EN_15 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_17[17] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17 (17U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_17)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17)

/*! @brief Set the IDMAC_EOF_SDMA_EN_17 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_18[18] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18 (18U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_18)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18)

/*! @brief Set the IDMAC_EOF_SDMA_EN_18 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_19[19] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19 (19U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_19)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19)

/*! @brief Set the IDMAC_EOF_SDMA_EN_19 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_20[20] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20 (20U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_20)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20)

/*! @brief Set the IDMAC_EOF_SDMA_EN_20 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_21[21] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21 (21U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21 (0x00200000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_21)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21)

/*! @brief Set the IDMAC_EOF_SDMA_EN_21 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_22[22] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22 (22U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22 (0x00400000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_22)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22)

/*! @brief Set the IDMAC_EOF_SDMA_EN_22 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_23[23] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23 (23U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23 (0x00800000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_23)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23)

/*! @brief Set the IDMAC_EOF_SDMA_EN_23 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_24[24] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24 (24U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24 (0x01000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_24)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24)

/*! @brief Set the IDMAC_EOF_SDMA_EN_24 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_25[25] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25 (25U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25 (0x02000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_25)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25)

/*! @brief Set the IDMAC_EOF_SDMA_EN_25 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_26[26] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26 (26U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26 (0x04000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_26)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26)

/*! @brief Set the IDMAC_EOF_SDMA_EN_26 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_27[27] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27 (27U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27 (0x08000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_27)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27)

/*! @brief Set the IDMAC_EOF_SDMA_EN_27 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_28[28] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28 (28U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28 (0x10000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_28)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28)

/*! @brief Set the IDMAC_EOF_SDMA_EN_28 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_29[29] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29 (29U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29 (0x20000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_29)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29)

/*! @brief Set the IDMAC_EOF_SDMA_EN_29 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_1, field IDMAC_EOF_SDMA_EN_31[31] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31 (31U) /*!< Bit position for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31. */
#define BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31 (0x80000000U) /*!< Bit mask for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31. */
#define BS_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31. */

/*! @brief Read current value of the IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31 field. */
#define BR_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31(x) (HW_IPU_SDMA_EVENT_1(x).B.IDMAC_EOF_SDMA_EN_31)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31. */
#define BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31) & BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31)

/*! @brief Set the IDMAC_EOF_SDMA_EN_31 field to a new value. */
#define BW_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31(x, v) (HW_IPU_SDMA_EVENT_1_WR(x, (HW_IPU_SDMA_EVENT_1_RD(x) & ~BM_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31) | BF_IPU_SDMA_EVENT_1_IDMAC_EOF_SDMA_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_2 - SDMA Event Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_2 - SDMA Event Control Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of EOF
 * (end of frame) of DMA Channels SDMA events [63:32] can be found in this
 * register.
 */
typedef union _hw_ipu_sdma_event_2
{
    uint32_t U;
    struct _hw_ipu_sdma_event_2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOF_SDMA_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_EOF_SDMA_EN_40 : 1; /*!< [8]  */
        uint32_t IDMAC_EOF_SDMA_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_EOF_SDMA_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_EOF_SDMA_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_EOF_SDMA_EN_44 : 1; /*!< [12]  */
        uint32_t IDMAC_EOF_SDMA_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_EOF_SDMA_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_EOF_SDMA_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_EOF_SDMA_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_EOF_SDMA_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_EOF_SDMA_EN_50 : 1; /*!< [18]  */
        uint32_t IDMAC_EOF_SDMA_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_EOF_SDMA_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_sdma_event_2_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_2 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_2_ADDR(x) ((uintptr_t)(x) + 0x7CU)

#define HW_IPU_SDMA_EVENT_2(x)   (*(__IO hw_ipu_sdma_event_2_t *) HW_IPU_SDMA_EVENT_2_ADDR(x))
#define HW_IPU_SDMA_EVENT_2_RD(x) (HW_IPU_SDMA_EVENT_2(x).U)
#define HW_IPU_SDMA_EVENT_2_WR(x, v) (HW_IPU_SDMA_EVENT_2(x).U = (v))
#define HW_IPU_SDMA_EVENT_2_SET(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, HW_IPU_SDMA_EVENT_2_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_2_CLR(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, HW_IPU_SDMA_EVENT_2_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_2_TOG(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, HW_IPU_SDMA_EVENT_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_2 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_33[1] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33 (1U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_33)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33)

/*! @brief Set the IDMAC_EOF_SDMA_EN_33 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_40[8] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40 (8U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_40)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40)

/*! @brief Set the IDMAC_EOF_SDMA_EN_40 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_41[9] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41 (9U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_41)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41)

/*! @brief Set the IDMAC_EOF_SDMA_EN_41 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_42[10] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42 (10U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_42)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42)

/*! @brief Set the IDMAC_EOF_SDMA_EN_42 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_43[11] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43 (11U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_43)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43)

/*! @brief Set the IDMAC_EOF_SDMA_EN_43 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_44[12] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44 (12U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_44)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44)

/*! @brief Set the IDMAC_EOF_SDMA_EN_44 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_45[13] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45 (13U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_45)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45)

/*! @brief Set the IDMAC_EOF_SDMA_EN_45 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_46[14] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46 (14U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_46)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46)

/*! @brief Set the IDMAC_EOF_SDMA_EN_46 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_47[15] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47 (15U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_47)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47)

/*! @brief Set the IDMAC_EOF_SDMA_EN_47 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_48[16] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48 (16U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48 (0x00010000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_48)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48)

/*! @brief Set the IDMAC_EOF_SDMA_EN_48 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_49[17] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49 (17U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_49)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49)

/*! @brief Set the IDMAC_EOF_SDMA_EN_49 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_50[18] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50 (18U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_50)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50)

/*! @brief Set the IDMAC_EOF_SDMA_EN_50 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_51[19] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51 (19U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_51)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51)

/*! @brief Set the IDMAC_EOF_SDMA_EN_51 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_2, field IDMAC_EOF_SDMA_EN_52[20] (RW)
 *
 * Enable End of Frame of Channel SDMA event. This bit is the control of End Of
 * Frame of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52 (20U) /*!< Bit position for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52. */
#define BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52. */
#define BS_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52. */

/*! @brief Read current value of the IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52 field. */
#define BR_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52(x) (HW_IPU_SDMA_EVENT_2(x).B.IDMAC_EOF_SDMA_EN_52)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52. */
#define BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52) & BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52)

/*! @brief Set the IDMAC_EOF_SDMA_EN_52 field to a new value. */
#define BW_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52(x, v) (HW_IPU_SDMA_EVENT_2_WR(x, (HW_IPU_SDMA_EVENT_2_RD(x) & ~BM_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52) | BF_IPU_SDMA_EVENT_2_IDMAC_EOF_SDMA_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_3 - SDMA Event Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_3 - SDMA Event Control Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of
 * NFACK (New Frame Acknowledge) of DMA Channels SDMA events [31:0] can be found in
 * this register.
 */
typedef union _hw_ipu_sdma_event_3
{
    uint32_t U;
    struct _hw_ipu_sdma_event_3_bitfields
    {
        uint32_t IDMAC_NFACK_SDMA_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_NFACK_SDMA_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_NFACK_SDMA_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_NFACK_SDMA_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_NFACK_SDMA_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_NFACK_SDMA_EN_8 : 1; /*!< [8]  */
        uint32_t IDMAC_NFACK_SDMA_EN_9 : 1; /*!< [9]  */
        uint32_t IDMAC_NFACK_SDMA_EN_10 : 1; /*!< [10]  */
        uint32_t IDMAC_NFACK_SDMA_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_NFACK_SDMA_EN_12 : 1; /*!< [12]  */
        uint32_t IDMAC_NFACK_SDMA_EN_13 : 1; /*!< [13]  */
        uint32_t IDMAC_NFACK_SDMA_EN_14 : 1; /*!< [14]  */
        uint32_t IDMAC_NFACK_SDMA_EN_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_NFACK_SDMA_EN_17 : 1; /*!< [17]  */
        uint32_t IDMAC_NFACK_SDMA_EN_18 : 1; /*!< [18]  */
        uint32_t IDMAC_NFACK_SDMA_EN_19 : 1; /*!< [19]  */
        uint32_t IDMAC_NFACK_SDMA_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_NFACK_SDMA_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_NFACK_SDMA_EN_22 : 1; /*!< [22]  */
        uint32_t IDMAC_NFACK_SDMA_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_NFACK_SDMA_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_NFACK_SDMA_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_NFACK_SDMA_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_NFACK_SDMA_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_NFACK_SDMA_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_NFACK_SDMA_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_NFACK_SDMA_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_sdma_event_3_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_3 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_3_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_IPU_SDMA_EVENT_3(x)   (*(__IO hw_ipu_sdma_event_3_t *) HW_IPU_SDMA_EVENT_3_ADDR(x))
#define HW_IPU_SDMA_EVENT_3_RD(x) (HW_IPU_SDMA_EVENT_3(x).U)
#define HW_IPU_SDMA_EVENT_3_WR(x, v) (HW_IPU_SDMA_EVENT_3(x).U = (v))
#define HW_IPU_SDMA_EVENT_3_SET(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, HW_IPU_SDMA_EVENT_3_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_3_CLR(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, HW_IPU_SDMA_EVENT_3_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_3_TOG(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, HW_IPU_SDMA_EVENT_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_3 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_0[0] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0 (0U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0 (0x00000001U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_0)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_0 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_1[1] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1 (1U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_1)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_1 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_2[2] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2 (2U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2 (0x00000004U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_2)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_2 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_3[3] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3 (3U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3 (0x00000008U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_3)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_3 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_5[5] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5 (5U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5 (0x00000020U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_5)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_5 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_8[8] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8 (8U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_8)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_8 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_9[9] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9 (9U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_9)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_9 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_10[10] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10 (10U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_10)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_10 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_11[11] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11 (11U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_11)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_11 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_12[12] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12 (12U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_12)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_12 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_13[13] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13 (13U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_13)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_13 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_14[14] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14 (14U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_14)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_14 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_15[15] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15 (15U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_15)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_15 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_17[17] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17 (17U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_17)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_17 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_18[18] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18 (18U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_18)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_18 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_19[19] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19 (19U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_19)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_19 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_20[20] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20 (20U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_20)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_20 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_21[21] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21 (21U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21 (0x00200000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_21)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_21 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_22[22] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22 (22U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22 (0x00400000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_22)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_22 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_23[23] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23 (23U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23 (0x00800000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_23)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_23 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_24[24] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24 (24U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24 (0x01000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_24)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_24 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_25[25] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25 (25U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25 (0x02000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_25)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_25 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_26[26] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26 (26U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26 (0x04000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_26)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_26 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_27[27] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27 (27U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27 (0x08000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_27)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_27 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_28[28] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28 (28U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28 (0x10000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_28)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_28 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_29[29] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29 (29U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29 (0x20000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_29)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_29 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_3, field IDMAC_NFACK_SDMA_EN_31[31] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31 (31U) /*!< Bit position for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31. */
#define BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31 (0x80000000U) /*!< Bit mask for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31. */
#define BS_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31. */

/*! @brief Read current value of the IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31 field. */
#define BR_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31(x) (HW_IPU_SDMA_EVENT_3(x).B.IDMAC_NFACK_SDMA_EN_31)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31. */
#define BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31) & BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_31 field to a new value. */
#define BW_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31(x, v) (HW_IPU_SDMA_EVENT_3_WR(x, (HW_IPU_SDMA_EVENT_3_RD(x) & ~BM_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31) | BF_IPU_SDMA_EVENT_3_IDMAC_NFACK_SDMA_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_4 - SDMA Event Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_4 - SDMA Event Control Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of
 * NFACK (New Frame Acknowledge) of DMA Channels SDMA events [63:32] can be found in
 * this register.
 */
typedef union _hw_ipu_sdma_event_4
{
    uint32_t U;
    struct _hw_ipu_sdma_event_4_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_NFACK_SDMA_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_NFACK_SDMA_EN_40 : 1; /*!< [8]  */
        uint32_t IDMAC_NFACK_SDMA_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_NFACK_SDMA_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_NFACK_SDMA_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_NFACK_SDMA_EN_44 : 1; /*!< [12]  */
        uint32_t IDMAC_NFACK_SDMA_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_NFACK_SDMA_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_NFACK_SDMA_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_NFACK_SDMA_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_NFACK_SDMA_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_NFACK_SDMA_EN_50 : 1; /*!< [18]  */
        uint32_t IDMAC_NFACK_SDMA_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_NFACK_SDMA_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_sdma_event_4_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_4 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_4_ADDR(x) ((uintptr_t)(x) + 0x84U)

#define HW_IPU_SDMA_EVENT_4(x)   (*(__IO hw_ipu_sdma_event_4_t *) HW_IPU_SDMA_EVENT_4_ADDR(x))
#define HW_IPU_SDMA_EVENT_4_RD(x) (HW_IPU_SDMA_EVENT_4(x).U)
#define HW_IPU_SDMA_EVENT_4_WR(x, v) (HW_IPU_SDMA_EVENT_4(x).U = (v))
#define HW_IPU_SDMA_EVENT_4_SET(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, HW_IPU_SDMA_EVENT_4_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_4_CLR(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, HW_IPU_SDMA_EVENT_4_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_4_TOG(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, HW_IPU_SDMA_EVENT_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_4 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_33[1] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33 (1U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_33)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_33 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_40[8] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40 (8U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_40)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_40 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_41[9] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41 (9U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_41)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_41 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_42[10] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42 (10U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_42)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_42 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_43[11] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43 (11U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_43)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_43 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_44[12] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44 (12U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_44)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_44 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_45[13] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45 (13U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_45)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_45 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_46[14] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46 (14U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_46)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_46 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_47[15] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47 (15U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_47)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_47 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_48[16] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48 (16U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48 (0x00010000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_48)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_48 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_49[17] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49 (17U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_49)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_49 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_50[18] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50 (18U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_50)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_50 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_51[19] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51 (19U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_51)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_51 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_4, field IDMAC_NFACK_SDMA_EN_52[20] (RW)
 *
 * Enable New Frame Acknowledge of Channel SDMA event. This bit is the control
 * of New Frame Acknowledge of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52 (20U) /*!< Bit position for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52. */
#define BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52. */
#define BS_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52. */

/*! @brief Read current value of the IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52 field. */
#define BR_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52(x) (HW_IPU_SDMA_EVENT_4(x).B.IDMAC_NFACK_SDMA_EN_52)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52. */
#define BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52) & BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52)

/*! @brief Set the IDMAC_NFACK_SDMA_EN_52 field to a new value. */
#define BW_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52(x, v) (HW_IPU_SDMA_EVENT_4_WR(x, (HW_IPU_SDMA_EVENT_4_RD(x) & ~BM_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52) | BF_IPU_SDMA_EVENT_4_IDMAC_NFACK_SDMA_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_7 - SDMA Event Control Register 7
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_7 - SDMA Event Control Register 7 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of EOS
 * (End of Scroll) of DMA Channels SDMA events [31:0] can be found in this
 * register.
 */
typedef union _hw_ipu_sdma_event_7
{
    uint32_t U;
    struct _hw_ipu_sdma_event_7_bitfields
    {
        uint32_t RESERVED0 : 19;       /*!< [18:0]  */
        uint32_t IDMAC_EOS_SDMA_EN_19 : 1; /*!< [19]  */
        uint32_t RESERVED1 : 3;        /*!< [22:20]  */
        uint32_t IDMAC_EOS_SDMA_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_EOS_SDMA_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_EOS_SDMA_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_EOS_SDMA_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_EOS_SDMA_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_EOS_SDMA_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_EOS_SDMA_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED2 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOS_SDMA_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_sdma_event_7_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_7 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_7_ADDR(x) ((uintptr_t)(x) + 0x88U)

#define HW_IPU_SDMA_EVENT_7(x)   (*(__IO hw_ipu_sdma_event_7_t *) HW_IPU_SDMA_EVENT_7_ADDR(x))
#define HW_IPU_SDMA_EVENT_7_RD(x) (HW_IPU_SDMA_EVENT_7(x).U)
#define HW_IPU_SDMA_EVENT_7_WR(x, v) (HW_IPU_SDMA_EVENT_7(x).U = (v))
#define HW_IPU_SDMA_EVENT_7_SET(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, HW_IPU_SDMA_EVENT_7_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_7_CLR(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, HW_IPU_SDMA_EVENT_7_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_7_TOG(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, HW_IPU_SDMA_EVENT_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_7 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_19[19] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19 (19U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_19)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19)

/*! @brief Set the IDMAC_EOS_SDMA_EN_19 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_23[23] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23 (23U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23 (0x00800000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_23)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23)

/*! @brief Set the IDMAC_EOS_SDMA_EN_23 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_24[24] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24 (24U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24 (0x01000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_24)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24)

/*! @brief Set the IDMAC_EOS_SDMA_EN_24 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_25[25] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25 (25U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25 (0x02000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_25)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25)

/*! @brief Set the IDMAC_EOS_SDMA_EN_25 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_26[26] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26 (26U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26 (0x04000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_26)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26)

/*! @brief Set the IDMAC_EOS_SDMA_EN_26 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_27[27] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27 (27U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27 (0x08000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_27)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27)

/*! @brief Set the IDMAC_EOS_SDMA_EN_27 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_28[28] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28 (28U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28 (0x10000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_28)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28)

/*! @brief Set the IDMAC_EOS_SDMA_EN_28 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_29[29] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29 (29U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29 (0x20000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_29)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29)

/*! @brief Set the IDMAC_EOS_SDMA_EN_29 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_7, field IDMAC_EOS_SDMA_EN_31[31] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31 (31U) /*!< Bit position for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31. */
#define BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31 (0x80000000U) /*!< Bit mask for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31. */
#define BS_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31. */

/*! @brief Read current value of the IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31 field. */
#define BR_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31(x) (HW_IPU_SDMA_EVENT_7(x).B.IDMAC_EOS_SDMA_EN_31)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31. */
#define BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31) & BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31)

/*! @brief Set the IDMAC_EOS_SDMA_EN_31 field to a new value. */
#define BW_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31(x, v) (HW_IPU_SDMA_EVENT_7_WR(x, (HW_IPU_SDMA_EVENT_7_RD(x) & ~BM_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31) | BF_IPU_SDMA_EVENT_7_IDMAC_EOS_SDMA_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_8 - SDMA Event Control Register 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_8 - SDMA Event Control Register 8 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of EOS
 * (End of Scroll) of DMA Channels SDMA events [63:32] can be found in this
 * register.
 */
typedef union _hw_ipu_sdma_event_8
{
    uint32_t U;
    struct _hw_ipu_sdma_event_8_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOS_SDMA_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t IDMAC_EOS_SDMA_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_EOS_SDMA_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_EOS_SDMA_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_EOS_SDMA_EN_44 : 1; /*!< [12]  */
        uint32_t RESERVED2 : 6;        /*!< [18:13]  */
        uint32_t IDMAC_EOS_SDMA_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_EOS_SDMA_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_sdma_event_8_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_8 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_8_ADDR(x) ((uintptr_t)(x) + 0x8CU)

#define HW_IPU_SDMA_EVENT_8(x)   (*(__IO hw_ipu_sdma_event_8_t *) HW_IPU_SDMA_EVENT_8_ADDR(x))
#define HW_IPU_SDMA_EVENT_8_RD(x) (HW_IPU_SDMA_EVENT_8(x).U)
#define HW_IPU_SDMA_EVENT_8_WR(x, v) (HW_IPU_SDMA_EVENT_8(x).U = (v))
#define HW_IPU_SDMA_EVENT_8_SET(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, HW_IPU_SDMA_EVENT_8_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_8_CLR(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, HW_IPU_SDMA_EVENT_8_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_8_TOG(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, HW_IPU_SDMA_EVENT_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_8 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_33[1] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33 (1U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_33)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33)

/*! @brief Set the IDMAC_EOS_SDMA_EN_33 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_41[9] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41 (9U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_41)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41)

/*! @brief Set the IDMAC_EOS_SDMA_EN_41 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_42[10] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42 (10U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_42)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42)

/*! @brief Set the IDMAC_EOS_SDMA_EN_42 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_43[11] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43 (11U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_43)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43)

/*! @brief Set the IDMAC_EOS_SDMA_EN_43 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_44[12] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44 (12U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_44)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44)

/*! @brief Set the IDMAC_EOS_SDMA_EN_44 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_51[19] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51 (19U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_51)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51)

/*! @brief Set the IDMAC_EOS_SDMA_EN_51 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_8, field IDMAC_EOS_SDMA_EN_52[20] (RW)
 *
 * Enable End of Scroll of Channel SDMA event. This bit is the control of End Of
 * Scroll of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52 (20U) /*!< Bit position for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52. */
#define BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52. */
#define BS_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52. */

/*! @brief Read current value of the IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52 field. */
#define BR_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52(x) (HW_IPU_SDMA_EVENT_8(x).B.IDMAC_EOS_SDMA_EN_52)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52. */
#define BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52) & BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52)

/*! @brief Set the IDMAC_EOS_SDMA_EN_52 field to a new value. */
#define BW_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52(x, v) (HW_IPU_SDMA_EVENT_8_WR(x, (HW_IPU_SDMA_EVENT_8_RD(x) & ~BM_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52) | BF_IPU_SDMA_EVENT_8_IDMAC_EOS_SDMA_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_11 - SDMA Event Control Register 11
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_11 - SDMA Event Control Register 11 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of
 * EOBND (End of Band) of DMA Channels SDMA events [31:0] can be found in this
 * register. Hide VDOA_SYNC for all versions Show VDOA_SYNC for IPUv3H version. The
 * table below tagged with other settings (like IPU3M_only) should be hidden in
 * IPUv3H version.
 */
typedef union _hw_ipu_sdma_event_11
{
    uint32_t U;
    struct _hw_ipu_sdma_event_11_bitfields
    {
        uint32_t IDMAC_EOBND_SDMA_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_EOBND_SDMA_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_EOBND_SDMA_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_EOBND_SDMA_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOBND_SDMA_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 5;        /*!< [10:6]  */
        uint32_t IDMAC_EOBND_SDMA_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_EOBND_SDMA_EN_12 : 1; /*!< [12]  */
        uint32_t RESERVED2 : 7;        /*!< [19:13]  */
        uint32_t IDMAC_EOBND_SDMA_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_EOBND_SDMA_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_EOBND_SDMA_EN_22 : 1; /*!< [22]  */
        uint32_t RESERVED3 : 2;        /*!< [24:23]  */
        uint32_t IDMAC_EOBND_SDMA_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_EOBND_SDMA_EN_26 : 1; /*!< [26]  */
        uint32_t RESERVED4 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_sdma_event_11_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_11 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_11_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_IPU_SDMA_EVENT_11(x)  (*(__IO hw_ipu_sdma_event_11_t *) HW_IPU_SDMA_EVENT_11_ADDR(x))
#define HW_IPU_SDMA_EVENT_11_RD(x) (HW_IPU_SDMA_EVENT_11(x).U)
#define HW_IPU_SDMA_EVENT_11_WR(x, v) (HW_IPU_SDMA_EVENT_11(x).U = (v))
#define HW_IPU_SDMA_EVENT_11_SET(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, HW_IPU_SDMA_EVENT_11_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_11_CLR(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, HW_IPU_SDMA_EVENT_11_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_11_TOG(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, HW_IPU_SDMA_EVENT_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_11 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_0[0] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0 (0U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0 (0x00000001U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_0)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_0 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_1[1] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1 (1U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_1)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_1 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_2[2] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2 (2U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2 (0x00000004U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_2)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_2 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_3[3] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3 (3U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3 (0x00000008U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_3)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_3 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_5[5] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5 (5U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5 (0x00000020U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_5)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_5 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_11[11] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11 (11U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_11)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_11 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_12[12] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12 (12U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_12)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_12 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_20[20] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20 (20U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_20)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_20 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_21[21] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21 (21U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21 (0x00200000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_21)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_21 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_22[22] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22 (22U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22 (0x00400000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_22)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_22 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_25[25] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25 (25U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25 (0x02000000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_25)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_25 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_11, field IDMAC_EOBND_SDMA_EN_26[26] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26 (26U) /*!< Bit position for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26. */
#define BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26 (0x04000000U) /*!< Bit mask for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26. */
#define BS_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26. */

/*! @brief Read current value of the IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26 field. */
#define BR_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26(x) (HW_IPU_SDMA_EVENT_11(x).B.IDMAC_EOBND_SDMA_EN_26)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26. */
#define BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26) & BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_26 field to a new value. */
#define BW_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26(x, v) (HW_IPU_SDMA_EVENT_11_WR(x, (HW_IPU_SDMA_EVENT_11_RD(x) & ~BM_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26) | BF_IPU_SDMA_EVENT_11_IDMAC_EOBND_SDMA_EN_26(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_12 - SDMA Event Control Register 12
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_12 - SDMA Event Control Register 12 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of
 * EOBND (End of Band) of DMA Channels SDMA events [63:32] can be found in this
 * register.
 */
typedef union _hw_ipu_sdma_event_12
{
    uint32_t U;
    struct _hw_ipu_sdma_event_12_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t IDMAC_EOBND_SDMA_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_EOBND_SDMA_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_EOBND_SDMA_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_EOBND_SDMA_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_EOBND_SDMA_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_EOBND_SDMA_EN_50 : 1; /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_sdma_event_12_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_12 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_12_ADDR(x) ((uintptr_t)(x) + 0x94U)

#define HW_IPU_SDMA_EVENT_12(x)  (*(__IO hw_ipu_sdma_event_12_t *) HW_IPU_SDMA_EVENT_12_ADDR(x))
#define HW_IPU_SDMA_EVENT_12_RD(x) (HW_IPU_SDMA_EVENT_12(x).U)
#define HW_IPU_SDMA_EVENT_12_WR(x, v) (HW_IPU_SDMA_EVENT_12(x).U = (v))
#define HW_IPU_SDMA_EVENT_12_SET(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, HW_IPU_SDMA_EVENT_12_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_12_CLR(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, HW_IPU_SDMA_EVENT_12_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_12_TOG(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, HW_IPU_SDMA_EVENT_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_12 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_45[13] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45 (13U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_45)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_45 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_46[14] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46 (14U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_46)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_46 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_47[15] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47 (15U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_47)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_47 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_48[16] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48 (16U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48 (0x00010000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_48)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_48 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_49[17] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49 (17U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_49)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_49 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_12, field IDMAC_EOBND_SDMA_EN_50[18] (RW)
 *
 * Enable End of Band of Channel SDMA event. This bit is the control of End Of
 * Band of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50 (18U) /*!< Bit position for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50. */
#define BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50. */
#define BS_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50. */

/*! @brief Read current value of the IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50 field. */
#define BR_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50(x) (HW_IPU_SDMA_EVENT_12(x).B.IDMAC_EOBND_SDMA_EN_50)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50. */
#define BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50) & BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50)

/*! @brief Set the IDMAC_EOBND_SDMA_EN_50 field to a new value. */
#define BW_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50(x, v) (HW_IPU_SDMA_EVENT_12_WR(x, (HW_IPU_SDMA_EVENT_12_RD(x) & ~BM_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50) | BF_IPU_SDMA_EVENT_12_IDMAC_EOBND_SDMA_EN_50(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_13 - SDMA Event Control Register 13
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_13 - SDMA Event Control Register 13 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of TH
 * (Threshold) of DMA Channels SDMA events [31:0] can be found in this register.
 */
typedef union _hw_ipu_sdma_event_13
{
    uint32_t U;
    struct _hw_ipu_sdma_event_13_bitfields
    {
        uint32_t IDMAC_TH_SDMA_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_TH_SDMA_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_TH_SDMA_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_TH_SDMA_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_TH_SDMA_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_TH_SDMA_EN_8 : 1; /*!< [8]  */
        uint32_t IDMAC_TH_SDMA_EN_9 : 1; /*!< [9]  */
        uint32_t IDMAC_TH_SDMA_EN_10 : 1; /*!< [10]  */
        uint32_t IDMAC_TH_SDMA_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_TH_SDMA_EN_12 : 1; /*!< [12]  */
        uint32_t IDMAC_TH_SDMA_EN_13 : 1; /*!< [13]  */
        uint32_t IDMAC_TH_SDMA_EN_14 : 1; /*!< [14]  */
        uint32_t IDMAC_TH_SDMA_EN_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_TH_SDMA_EN_17 : 1; /*!< [17]  */
        uint32_t IDMAC_TH_SDMA_EN_18 : 1; /*!< [18]  */
        uint32_t IDMAC_TH_SDMA_EN_19 : 1; /*!< [19]  */
        uint32_t IDMAC_TH_SDMA_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_TH_SDMA_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_TH_SDMA_EN_22 : 1; /*!< [22]  */
        uint32_t IDMAC_TH_SDMA_EN_23 : 1; /*!< [23]  */
        uint32_t IDMAC_TH_SDMA_EN_24 : 1; /*!< [24]  */
        uint32_t IDMAC_TH_SDMA_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_TH_SDMA_EN_26 : 1; /*!< [26]  */
        uint32_t IDMAC_TH_SDMA_EN_27 : 1; /*!< [27]  */
        uint32_t IDMAC_TH_SDMA_EN_28 : 1; /*!< [28]  */
        uint32_t IDMAC_TH_SDMA_EN_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_TH_SDMA_EN_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_sdma_event_13_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_13 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_13_ADDR(x) ((uintptr_t)(x) + 0x98U)

#define HW_IPU_SDMA_EVENT_13(x)  (*(__IO hw_ipu_sdma_event_13_t *) HW_IPU_SDMA_EVENT_13_ADDR(x))
#define HW_IPU_SDMA_EVENT_13_RD(x) (HW_IPU_SDMA_EVENT_13(x).U)
#define HW_IPU_SDMA_EVENT_13_WR(x, v) (HW_IPU_SDMA_EVENT_13(x).U = (v))
#define HW_IPU_SDMA_EVENT_13_SET(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, HW_IPU_SDMA_EVENT_13_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_13_CLR(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, HW_IPU_SDMA_EVENT_13_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_13_TOG(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, HW_IPU_SDMA_EVENT_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_13 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_0[0] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0 (0U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0 (0x00000001U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_0)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0)

/*! @brief Set the IDMAC_TH_SDMA_EN_0 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_1[1] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1 (1U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_1)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1)

/*! @brief Set the IDMAC_TH_SDMA_EN_1 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_2[2] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2 (2U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2 (0x00000004U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_2)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2)

/*! @brief Set the IDMAC_TH_SDMA_EN_2 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_3[3] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3 (3U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3 (0x00000008U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_3)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3)

/*! @brief Set the IDMAC_TH_SDMA_EN_3 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_5[5] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5 (5U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5 (0x00000020U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_5)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5)

/*! @brief Set the IDMAC_TH_SDMA_EN_5 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_8[8] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8 (8U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_8)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8)

/*! @brief Set the IDMAC_TH_SDMA_EN_8 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_9[9] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9 (9U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_9)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9)

/*! @brief Set the IDMAC_TH_SDMA_EN_9 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_10[10] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10 (10U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_10)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10)

/*! @brief Set the IDMAC_TH_SDMA_EN_10 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_11[11] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11 (11U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_11)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11)

/*! @brief Set the IDMAC_TH_SDMA_EN_11 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_12[12] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12 (12U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_12)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12)

/*! @brief Set the IDMAC_TH_SDMA_EN_12 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_13[13] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13 (13U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_13)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13)

/*! @brief Set the IDMAC_TH_SDMA_EN_13 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_14[14] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14 (14U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_14)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14)

/*! @brief Set the IDMAC_TH_SDMA_EN_14 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_15[15] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15 (15U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_15)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15)

/*! @brief Set the IDMAC_TH_SDMA_EN_15 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_17[17] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17 (17U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_17)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17)

/*! @brief Set the IDMAC_TH_SDMA_EN_17 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_18[18] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18 (18U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_18)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18)

/*! @brief Set the IDMAC_TH_SDMA_EN_18 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_19[19] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19 (19U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_19)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19)

/*! @brief Set the IDMAC_TH_SDMA_EN_19 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_20[20] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20 (20U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_20)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20)

/*! @brief Set the IDMAC_TH_SDMA_EN_20 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_21[21] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21 (21U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21 (0x00200000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_21)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21)

/*! @brief Set the IDMAC_TH_SDMA_EN_21 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_22[22] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22 (22U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22 (0x00400000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_22)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22)

/*! @brief Set the IDMAC_TH_SDMA_EN_22 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_23[23] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23 (23U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23 (0x00800000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_23)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23)

/*! @brief Set the IDMAC_TH_SDMA_EN_23 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_24[24] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24 (24U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24 (0x01000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_24)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24)

/*! @brief Set the IDMAC_TH_SDMA_EN_24 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_25[25] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25 (25U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25 (0x02000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_25)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25)

/*! @brief Set the IDMAC_TH_SDMA_EN_25 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_26[26] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26 (26U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26 (0x04000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_26)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26)

/*! @brief Set the IDMAC_TH_SDMA_EN_26 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_27[27] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27 (27U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27 (0x08000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_27)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27)

/*! @brief Set the IDMAC_TH_SDMA_EN_27 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_28[28] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28 (28U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28 (0x10000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_28)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28)

/*! @brief Set the IDMAC_TH_SDMA_EN_28 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_29[29] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29 (29U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29 (0x20000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_29)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29)

/*! @brief Set the IDMAC_TH_SDMA_EN_29 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_13, field IDMAC_TH_SDMA_EN_31[31] (RW)
 *
 * Enable Threshold of Channel SDMA event. This bit is the control of Threshold
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31 (31U) /*!< Bit position for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31. */
#define BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31 (0x80000000U) /*!< Bit mask for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31. */
#define BS_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31. */

/*! @brief Read current value of the IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31 field. */
#define BR_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31(x) (HW_IPU_SDMA_EVENT_13(x).B.IDMAC_TH_SDMA_EN_31)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31. */
#define BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31) & BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31)

/*! @brief Set the IDMAC_TH_SDMA_EN_31 field to a new value. */
#define BW_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31(x, v) (HW_IPU_SDMA_EVENT_13_WR(x, (HW_IPU_SDMA_EVENT_13_RD(x) & ~BM_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31) | BF_IPU_SDMA_EVENT_13_IDMAC_TH_SDMA_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SDMA_EVENT_14 - SDMA Event Control Register 14
 ******************************************************************************/

/*!
 * @brief HW_IPU_SDMA_EVENT_14 - SDMA Event Control Register 14 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains part of IPU SDMA events controls. The controls of TH
 * (Threshold) of DMA Channels SDMA events [63:32] can be found in this register.
 */
typedef union _hw_ipu_sdma_event_14
{
    uint32_t U;
    struct _hw_ipu_sdma_event_14_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_TH_SDMA_EN_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_TH_SDMA_EN_40 : 1; /*!< [8]  */
        uint32_t IDMAC_TH_SDMA_EN_41 : 1; /*!< [9]  */
        uint32_t IDMAC_TH_SDMA_EN_42 : 1; /*!< [10]  */
        uint32_t IDMAC_TH_SDMA_EN_43 : 1; /*!< [11]  */
        uint32_t IDMAC_TH_SDMA_EN_44 : 1; /*!< [12]  */
        uint32_t IDMAC_TH_SDMA_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_TH_SDMA_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_TH_SDMA_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_TH_SDMA_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_TH_SDMA_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_TH_SDMA_EN_50 : 1; /*!< [18]  */
        uint32_t IDMAC_TH_SDMA_EN_51 : 1; /*!< [19]  */
        uint32_t IDMAC_TH_SDMA_EN_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_sdma_event_14_t;

/*!
 * @name Constants and macros for entire IPU_SDMA_EVENT_14 register
 */
/*@{*/
#define HW_IPU_SDMA_EVENT_14_ADDR(x) ((uintptr_t)(x) + 0x9CU)

#define HW_IPU_SDMA_EVENT_14(x)  (*(__IO hw_ipu_sdma_event_14_t *) HW_IPU_SDMA_EVENT_14_ADDR(x))
#define HW_IPU_SDMA_EVENT_14_RD(x) (HW_IPU_SDMA_EVENT_14(x).U)
#define HW_IPU_SDMA_EVENT_14_WR(x, v) (HW_IPU_SDMA_EVENT_14(x).U = (v))
#define HW_IPU_SDMA_EVENT_14_SET(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, HW_IPU_SDMA_EVENT_14_RD(x) |  (v)))
#define HW_IPU_SDMA_EVENT_14_CLR(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, HW_IPU_SDMA_EVENT_14_RD(x) & ~(v)))
#define HW_IPU_SDMA_EVENT_14_TOG(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, HW_IPU_SDMA_EVENT_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SDMA_EVENT_14 bitfields
 */

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_33[1] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33 (1U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33 (0x00000002U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_33)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33)

/*! @brief Set the IDMAC_TH_SDMA_EN_33 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_40[8] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40 (8U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40 (0x00000100U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_40)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40)

/*! @brief Set the IDMAC_TH_SDMA_EN_40 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_41[9] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41 (9U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41 (0x00000200U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_41)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41)

/*! @brief Set the IDMAC_TH_SDMA_EN_41 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_42[10] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42 (10U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42 (0x00000400U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_42)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42)

/*! @brief Set the IDMAC_TH_SDMA_EN_42 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_43[11] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43 (11U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43 (0x00000800U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_43)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43)

/*! @brief Set the IDMAC_TH_SDMA_EN_43 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_44[12] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44 (12U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44 (0x00001000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_44)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44)

/*! @brief Set the IDMAC_TH_SDMA_EN_44 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_45[13] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45 (13U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45 (0x00002000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_45)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45)

/*! @brief Set the IDMAC_TH_SDMA_EN_45 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_46[14] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46 (14U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46 (0x00004000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_46)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46)

/*! @brief Set the IDMAC_TH_SDMA_EN_46 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_47[15] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47 (15U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47 (0x00008000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_47)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47)

/*! @brief Set the IDMAC_TH_SDMA_EN_47 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_48[16] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48 (16U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48 (0x00010000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_48)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48)

/*! @brief Set the IDMAC_TH_SDMA_EN_48 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_49[17] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49 (17U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49 (0x00020000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_49)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49)

/*! @brief Set the IDMAC_TH_SDMA_EN_49 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_50[18] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50 (18U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50 (0x00040000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_50)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50)

/*! @brief Set the IDMAC_TH_SDMA_EN_50 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_51[19] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51 (19U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51 (0x00080000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_51)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51)

/*! @brief Set the IDMAC_TH_SDMA_EN_51 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_SDMA_EVENT_14, field IDMAC_TH_SDMA_EN_52[20] (RW)
 *
 * Threshold of Channel SDMA event. This bit is the control of Threshold of
 * Channel #n. n Indicates the corresponding DMA channel number. n Indicates the
 * corresponding DMA channel number.
 *
 * Values:
 * - 0 - SDMA event is disabled.
 * - 1 - SDMA event is enabled.
 */
/*@{*/
#define BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52 (20U) /*!< Bit position for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52. */
#define BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52 (0x00100000U) /*!< Bit mask for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52. */
#define BS_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52 (1U) /*!< Bit field size in bits for IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52. */

/*! @brief Read current value of the IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52 field. */
#define BR_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52(x) (HW_IPU_SDMA_EVENT_14(x).B.IDMAC_TH_SDMA_EN_52)

/*! @brief Format value for bitfield IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52. */
#define BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52) & BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52)

/*! @brief Set the IDMAC_TH_SDMA_EN_52 field to a new value. */
#define BW_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52(x, v) (HW_IPU_SDMA_EVENT_14_WR(x, (HW_IPU_SDMA_EVENT_14_RD(x) & ~BM_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52) | BF_IPU_SDMA_EVENT_14_IDMAC_TH_SDMA_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SRM_PRI1 - Shadow Registers Memory Priority 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SRM_PRI1 - Shadow Registers Memory Priority 1 Register (RW)
 *
 * Reset value: 0x00000100U
 *
 * The register controls the priority of SRM updates. The priority level for
 * each block that has a shadow of its registers in the SRM should be unique. The
 * priority level defines the order of SRM updates. A block with priority set to
 * 010 will be updated before a block with priority set to 001.
 */
typedef union _hw_ipu_srm_pri1
{
    uint32_t U;
    struct _hw_ipu_srm_pri1_bitfields
    {
        uint32_t CSI1_SRM_PRI : 3;     /*!< [2:0]  */
        uint32_t CSI1_SRM_MODE : 2;    /*!< [4:3]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t CSI0_SRM_PRI : 3;     /*!< [10:8]  */
        uint32_t CSI0_SRM_MODE : 2;    /*!< [12:11]  */
        uint32_t RESERVED1 : 19;       /*!< [31:13]  */
    } B;
} hw_ipu_srm_pri1_t;

/*!
 * @name Constants and macros for entire IPU_SRM_PRI1 register
 */
/*@{*/
#define HW_IPU_SRM_PRI1_ADDR(x)  ((uintptr_t)(x) + 0xA0U)

#define HW_IPU_SRM_PRI1(x)       (*(__IO hw_ipu_srm_pri1_t *) HW_IPU_SRM_PRI1_ADDR(x))
#define HW_IPU_SRM_PRI1_RD(x)    (HW_IPU_SRM_PRI1(x).U)
#define HW_IPU_SRM_PRI1_WR(x, v) (HW_IPU_SRM_PRI1(x).U = (v))
#define HW_IPU_SRM_PRI1_SET(x, v) (HW_IPU_SRM_PRI1_WR(x, HW_IPU_SRM_PRI1_RD(x) |  (v)))
#define HW_IPU_SRM_PRI1_CLR(x, v) (HW_IPU_SRM_PRI1_WR(x, HW_IPU_SRM_PRI1_RD(x) & ~(v)))
#define HW_IPU_SRM_PRI1_TOG(x, v) (HW_IPU_SRM_PRI1_WR(x, HW_IPU_SRM_PRI1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SRM_PRI1 bitfields
 */

/*!
 * @name Register IPU_SRM_PRI1, field CSI1_SRM_PRI[2:0] (RW)
 *
 * CSI1 SRM priority This bits define the priority of the CSI0 module
 */
/*@{*/
#define BP_IPU_SRM_PRI1_CSI1_SRM_PRI (0U)  /*!< Bit position for IPU_SRM_PRI1_CSI1_SRM_PRI. */
#define BM_IPU_SRM_PRI1_CSI1_SRM_PRI (0x00000007U) /*!< Bit mask for IPU_SRM_PRI1_CSI1_SRM_PRI. */
#define BS_IPU_SRM_PRI1_CSI1_SRM_PRI (3U)  /*!< Bit field size in bits for IPU_SRM_PRI1_CSI1_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI1_CSI1_SRM_PRI field. */
#define BR_IPU_SRM_PRI1_CSI1_SRM_PRI(x) (HW_IPU_SRM_PRI1(x).B.CSI1_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI1_CSI1_SRM_PRI. */
#define BF_IPU_SRM_PRI1_CSI1_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI1_CSI1_SRM_PRI) & BM_IPU_SRM_PRI1_CSI1_SRM_PRI)

/*! @brief Set the CSI1_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI1_CSI1_SRM_PRI(x, v) (HW_IPU_SRM_PRI1_WR(x, (HW_IPU_SRM_PRI1_RD(x) & ~BM_IPU_SRM_PRI1_CSI1_SRM_PRI) | BF_IPU_SRM_PRI1_CSI1_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI1, field CSI1_SRM_MODE[4:3] (RW)
 *
 * CSI1 SRM Mode This field controls the SRM logic that handles the CSI1
 * registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     CSI0's region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI1_CSI1_SRM_MODE (3U) /*!< Bit position for IPU_SRM_PRI1_CSI1_SRM_MODE. */
#define BM_IPU_SRM_PRI1_CSI1_SRM_MODE (0x00000018U) /*!< Bit mask for IPU_SRM_PRI1_CSI1_SRM_MODE. */
#define BS_IPU_SRM_PRI1_CSI1_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI1_CSI1_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI1_CSI1_SRM_MODE field. */
#define BR_IPU_SRM_PRI1_CSI1_SRM_MODE(x) (HW_IPU_SRM_PRI1(x).B.CSI1_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI1_CSI1_SRM_MODE. */
#define BF_IPU_SRM_PRI1_CSI1_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI1_CSI1_SRM_MODE) & BM_IPU_SRM_PRI1_CSI1_SRM_MODE)

/*! @brief Set the CSI1_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI1_CSI1_SRM_MODE(x, v) (HW_IPU_SRM_PRI1_WR(x, (HW_IPU_SRM_PRI1_RD(x) & ~BM_IPU_SRM_PRI1_CSI1_SRM_MODE) | BF_IPU_SRM_PRI1_CSI1_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI1, field CSI0_SRM_PRI[10:8] (RW)
 *
 * CSI0 SRM priority This bits define the priority of the CSI1 block
 */
/*@{*/
#define BP_IPU_SRM_PRI1_CSI0_SRM_PRI (8U)  /*!< Bit position for IPU_SRM_PRI1_CSI0_SRM_PRI. */
#define BM_IPU_SRM_PRI1_CSI0_SRM_PRI (0x00000700U) /*!< Bit mask for IPU_SRM_PRI1_CSI0_SRM_PRI. */
#define BS_IPU_SRM_PRI1_CSI0_SRM_PRI (3U)  /*!< Bit field size in bits for IPU_SRM_PRI1_CSI0_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI1_CSI0_SRM_PRI field. */
#define BR_IPU_SRM_PRI1_CSI0_SRM_PRI(x) (HW_IPU_SRM_PRI1(x).B.CSI0_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI1_CSI0_SRM_PRI. */
#define BF_IPU_SRM_PRI1_CSI0_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI1_CSI0_SRM_PRI) & BM_IPU_SRM_PRI1_CSI0_SRM_PRI)

/*! @brief Set the CSI0_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI1_CSI0_SRM_PRI(x, v) (HW_IPU_SRM_PRI1_WR(x, (HW_IPU_SRM_PRI1_RD(x) & ~BM_IPU_SRM_PRI1_CSI0_SRM_PRI) | BF_IPU_SRM_PRI1_CSI0_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI1, field CSI0_SRM_MODE[12:11] (RW)
 *
 * CSI0 SRM Mode This field controls the SRM logic that handles the CSI0
 * registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     CSI1's region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM Platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI1_CSI0_SRM_MODE (11U) /*!< Bit position for IPU_SRM_PRI1_CSI0_SRM_MODE. */
#define BM_IPU_SRM_PRI1_CSI0_SRM_MODE (0x00001800U) /*!< Bit mask for IPU_SRM_PRI1_CSI0_SRM_MODE. */
#define BS_IPU_SRM_PRI1_CSI0_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI1_CSI0_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI1_CSI0_SRM_MODE field. */
#define BR_IPU_SRM_PRI1_CSI0_SRM_MODE(x) (HW_IPU_SRM_PRI1(x).B.CSI0_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI1_CSI0_SRM_MODE. */
#define BF_IPU_SRM_PRI1_CSI0_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI1_CSI0_SRM_MODE) & BM_IPU_SRM_PRI1_CSI0_SRM_MODE)

/*! @brief Set the CSI0_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI1_CSI0_SRM_MODE(x, v) (HW_IPU_SRM_PRI1_WR(x, (HW_IPU_SRM_PRI1_RD(x) & ~BM_IPU_SRM_PRI1_CSI0_SRM_MODE) | BF_IPU_SRM_PRI1_CSI0_SRM_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SRM_PRI2 - Shadow Registers Memory Priority 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SRM_PRI2 - Shadow Registers Memory Priority 2 Register (RW)
 *
 * Reset value: 0x06050803U
 *
 * The register controls the priority of SRM updates. The priority level for
 * each block that has a shadow of its registers in the SRM should be unique. The
 * priority level defines the order of SRM updates. a block with priority set to
 * 010 will be updated before a block with priority set to 001.
 */
typedef union _hw_ipu_srm_pri2
{
    uint32_t U;
    struct _hw_ipu_srm_pri2_bitfields
    {
        uint32_t DP_SRM_PRI : 3;       /*!< [2:0]  */
        uint32_t DP_S_SRM_MODE : 2;    /*!< [4:3]  */
        uint32_t DP_A0_SRM_MODE : 2;   /*!< [6:5]  */
        uint32_t DP_A1_SRM_MODE : 2;   /*!< [8:7]  */
        uint32_t DC_SRM_PRI : 3;       /*!< [11:9]  */
        uint32_t DC_2_SRM_MODE : 2;    /*!< [13:12]  */
        uint32_t DC_6_SRM_MODE : 2;    /*!< [15:14]  */
        uint32_t DI0_SRM_PRI : 3;      /*!< [18:16]  */
        uint32_t DI0_SRM_MCU_USE : 2;  /*!< [20:19]  */
        uint32_t RESERVED0 : 3;        /*!< [23:21]  */
        uint32_t DI1_SRM_PRI : 3;      /*!< [26:24]  */
        uint32_t DI1_SRM_MODE : 2;     /*!< [28:27]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_srm_pri2_t;

/*!
 * @name Constants and macros for entire IPU_SRM_PRI2 register
 */
/*@{*/
#define HW_IPU_SRM_PRI2_ADDR(x)  ((uintptr_t)(x) + 0xA4U)

#define HW_IPU_SRM_PRI2(x)       (*(__IO hw_ipu_srm_pri2_t *) HW_IPU_SRM_PRI2_ADDR(x))
#define HW_IPU_SRM_PRI2_RD(x)    (HW_IPU_SRM_PRI2(x).U)
#define HW_IPU_SRM_PRI2_WR(x, v) (HW_IPU_SRM_PRI2(x).U = (v))
#define HW_IPU_SRM_PRI2_SET(x, v) (HW_IPU_SRM_PRI2_WR(x, HW_IPU_SRM_PRI2_RD(x) |  (v)))
#define HW_IPU_SRM_PRI2_CLR(x, v) (HW_IPU_SRM_PRI2_WR(x, HW_IPU_SRM_PRI2_RD(x) & ~(v)))
#define HW_IPU_SRM_PRI2_TOG(x, v) (HW_IPU_SRM_PRI2_WR(x, HW_IPU_SRM_PRI2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SRM_PRI2 bitfields
 */

/*!
 * @name Register IPU_SRM_PRI2, field DP_SRM_PRI[2:0] (RW)
 *
 * DP SRM priority This bits define the priority of the DP module
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DP_SRM_PRI (0U)    /*!< Bit position for IPU_SRM_PRI2_DP_SRM_PRI. */
#define BM_IPU_SRM_PRI2_DP_SRM_PRI (0x00000007U) /*!< Bit mask for IPU_SRM_PRI2_DP_SRM_PRI. */
#define BS_IPU_SRM_PRI2_DP_SRM_PRI (3U)    /*!< Bit field size in bits for IPU_SRM_PRI2_DP_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI2_DP_SRM_PRI field. */
#define BR_IPU_SRM_PRI2_DP_SRM_PRI(x) (HW_IPU_SRM_PRI2(x).B.DP_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DP_SRM_PRI. */
#define BF_IPU_SRM_PRI2_DP_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DP_SRM_PRI) & BM_IPU_SRM_PRI2_DP_SRM_PRI)

/*! @brief Set the DP_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI2_DP_SRM_PRI(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DP_SRM_PRI) | BF_IPU_SRM_PRI2_DP_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DP_S_SRM_MODE[4:3] (RW)
 *
 * DP sync flow SRM Mode This field controls the SRM logic that handles the DP
 * sync flow registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DP sync flow region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done on the
 *     next frame.
 * - 10 - Reserved
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DP_S_SRM_MODE (3U) /*!< Bit position for IPU_SRM_PRI2_DP_S_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DP_S_SRM_MODE (0x00000018U) /*!< Bit mask for IPU_SRM_PRI2_DP_S_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DP_S_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DP_S_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DP_S_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DP_S_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DP_S_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DP_S_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DP_S_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DP_S_SRM_MODE) & BM_IPU_SRM_PRI2_DP_S_SRM_MODE)

/*! @brief Set the DP_S_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DP_S_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DP_S_SRM_MODE) | BF_IPU_SRM_PRI2_DP_S_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DP_A0_SRM_MODE[6:5] (RW)
 *
 * DP Async flow #0 SRM Mode This field controls the SRM logic that handles the
 * DP Async flow #0 registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DP Async flow #0 region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DP_A0_SRM_MODE (5U) /*!< Bit position for IPU_SRM_PRI2_DP_A0_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DP_A0_SRM_MODE (0x00000060U) /*!< Bit mask for IPU_SRM_PRI2_DP_A0_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DP_A0_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DP_A0_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DP_A0_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DP_A0_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DP_A0_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DP_A0_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DP_A0_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DP_A0_SRM_MODE) & BM_IPU_SRM_PRI2_DP_A0_SRM_MODE)

/*! @brief Set the DP_A0_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DP_A0_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DP_A0_SRM_MODE) | BF_IPU_SRM_PRI2_DP_A0_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DP_A1_SRM_MODE[8:7] (RW)
 *
 * DP Async flow #1 SRM Mode This field controls the SRM logic that handles the
 * DP Async flow #1 registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DP Async flow #1 region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DP_A1_SRM_MODE (7U) /*!< Bit position for IPU_SRM_PRI2_DP_A1_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DP_A1_SRM_MODE (0x00000180U) /*!< Bit mask for IPU_SRM_PRI2_DP_A1_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DP_A1_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DP_A1_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DP_A1_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DP_A1_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DP_A1_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DP_A1_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DP_A1_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DP_A1_SRM_MODE) & BM_IPU_SRM_PRI2_DP_A1_SRM_MODE)

/*! @brief Set the DP_A1_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DP_A1_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DP_A1_SRM_MODE) | BF_IPU_SRM_PRI2_DP_A1_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DC_SRM_PRI[11:9] (RW)
 *
 * DC SRM priority This bits define the priority of the DC module
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DC_SRM_PRI (9U)    /*!< Bit position for IPU_SRM_PRI2_DC_SRM_PRI. */
#define BM_IPU_SRM_PRI2_DC_SRM_PRI (0x00000E00U) /*!< Bit mask for IPU_SRM_PRI2_DC_SRM_PRI. */
#define BS_IPU_SRM_PRI2_DC_SRM_PRI (3U)    /*!< Bit field size in bits for IPU_SRM_PRI2_DC_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI2_DC_SRM_PRI field. */
#define BR_IPU_SRM_PRI2_DC_SRM_PRI(x) (HW_IPU_SRM_PRI2(x).B.DC_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DC_SRM_PRI. */
#define BF_IPU_SRM_PRI2_DC_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DC_SRM_PRI) & BM_IPU_SRM_PRI2_DC_SRM_PRI)

/*! @brief Set the DC_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI2_DC_SRM_PRI(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DC_SRM_PRI) | BF_IPU_SRM_PRI2_DC_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DC_2_SRM_MODE[13:12] (RW)
 *
 * DC Group #2 SRM Mode This field controls the SRM logic that handles the DC
 * Group #2 registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DC Group #2's region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DC_2_SRM_MODE (12U) /*!< Bit position for IPU_SRM_PRI2_DC_2_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DC_2_SRM_MODE (0x00003000U) /*!< Bit mask for IPU_SRM_PRI2_DC_2_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DC_2_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DC_2_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DC_2_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DC_2_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DC_2_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DC_2_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DC_2_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DC_2_SRM_MODE) & BM_IPU_SRM_PRI2_DC_2_SRM_MODE)

/*! @brief Set the DC_2_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DC_2_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DC_2_SRM_MODE) | BF_IPU_SRM_PRI2_DC_2_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DC_6_SRM_MODE[15:14] (RW)
 *
 * DC Group #6 SRM Mode This field controls the SRM logic that handles the DC
 * Group #6 registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DC Group #6's region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DC_6_SRM_MODE (14U) /*!< Bit position for IPU_SRM_PRI2_DC_6_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DC_6_SRM_MODE (0x0000C000U) /*!< Bit mask for IPU_SRM_PRI2_DC_6_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DC_6_SRM_MODE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DC_6_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DC_6_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DC_6_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DC_6_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DC_6_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DC_6_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DC_6_SRM_MODE) & BM_IPU_SRM_PRI2_DC_6_SRM_MODE)

/*! @brief Set the DC_6_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DC_6_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DC_6_SRM_MODE) | BF_IPU_SRM_PRI2_DC_6_SRM_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DI0_SRM_PRI[18:16] (RW)
 *
 * DI0 SRM priority This bits define the priority of the DI0 module
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DI0_SRM_PRI (16U)  /*!< Bit position for IPU_SRM_PRI2_DI0_SRM_PRI. */
#define BM_IPU_SRM_PRI2_DI0_SRM_PRI (0x00070000U) /*!< Bit mask for IPU_SRM_PRI2_DI0_SRM_PRI. */
#define BS_IPU_SRM_PRI2_DI0_SRM_PRI (3U)   /*!< Bit field size in bits for IPU_SRM_PRI2_DI0_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI2_DI0_SRM_PRI field. */
#define BR_IPU_SRM_PRI2_DI0_SRM_PRI(x) (HW_IPU_SRM_PRI2(x).B.DI0_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DI0_SRM_PRI. */
#define BF_IPU_SRM_PRI2_DI0_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DI0_SRM_PRI) & BM_IPU_SRM_PRI2_DI0_SRM_PRI)

/*! @brief Set the DI0_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI2_DI0_SRM_PRI(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DI0_SRM_PRI) | BF_IPU_SRM_PRI2_DI0_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DI0_SRM_MCU_USE[20:19] (RW)
 *
 * DI0 SRM is used by ARM platform This bit indicates that the registers of the
 * DI0 are currently being updated by the ARM platform. The ARM platform should
 * set this bit before accessing the SRM part that is relevant to the DI0. The ARM
 * platform should clear this bit when the update procedure is finished. When
 * this bit is set the SRM mechanism will not update the DI0's registers to avoid
 * data coherency problems.
 *
 * Values:
 * - 1 - DI0 SRM is currently updated by the ARM platform
 * - 0 - DI0 SRM s currently not updated by the ARM platform
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DI0_SRM_MCU_USE (19U) /*!< Bit position for IPU_SRM_PRI2_DI0_SRM_MCU_USE. */
#define BM_IPU_SRM_PRI2_DI0_SRM_MCU_USE (0x00180000U) /*!< Bit mask for IPU_SRM_PRI2_DI0_SRM_MCU_USE. */
#define BS_IPU_SRM_PRI2_DI0_SRM_MCU_USE (2U) /*!< Bit field size in bits for IPU_SRM_PRI2_DI0_SRM_MCU_USE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DI0_SRM_MCU_USE field. */
#define BR_IPU_SRM_PRI2_DI0_SRM_MCU_USE(x) (HW_IPU_SRM_PRI2(x).B.DI0_SRM_MCU_USE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DI0_SRM_MCU_USE. */
#define BF_IPU_SRM_PRI2_DI0_SRM_MCU_USE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DI0_SRM_MCU_USE) & BM_IPU_SRM_PRI2_DI0_SRM_MCU_USE)

/*! @brief Set the DI0_SRM_MCU_USE field to a new value. */
#define BW_IPU_SRM_PRI2_DI0_SRM_MCU_USE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DI0_SRM_MCU_USE) | BF_IPU_SRM_PRI2_DI0_SRM_MCU_USE(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DI1_SRM_PRI[26:24] (RW)
 *
 * DI1 SRM priority This bits define the priority of the DI1 module
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DI1_SRM_PRI (24U)  /*!< Bit position for IPU_SRM_PRI2_DI1_SRM_PRI. */
#define BM_IPU_SRM_PRI2_DI1_SRM_PRI (0x07000000U) /*!< Bit mask for IPU_SRM_PRI2_DI1_SRM_PRI. */
#define BS_IPU_SRM_PRI2_DI1_SRM_PRI (3U)   /*!< Bit field size in bits for IPU_SRM_PRI2_DI1_SRM_PRI. */

/*! @brief Read current value of the IPU_SRM_PRI2_DI1_SRM_PRI field. */
#define BR_IPU_SRM_PRI2_DI1_SRM_PRI(x) (HW_IPU_SRM_PRI2(x).B.DI1_SRM_PRI)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DI1_SRM_PRI. */
#define BF_IPU_SRM_PRI2_DI1_SRM_PRI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DI1_SRM_PRI) & BM_IPU_SRM_PRI2_DI1_SRM_PRI)

/*! @brief Set the DI1_SRM_PRI field to a new value. */
#define BW_IPU_SRM_PRI2_DI1_SRM_PRI(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DI1_SRM_PRI) | BF_IPU_SRM_PRI2_DI1_SRM_PRI(v)))
/*@}*/

/*!
 * @name Register IPU_SRM_PRI2, field DI1_SRM_MODE[28:27] (RW)
 *
 * DCI1 SRM Mode This field controls the SRM logic that handles the DI1 registers
 *
 * Values:
 * - 00 - Automatic swapping is disabled; ARM platform is allowed to access the
 *     DI1 region in the RAM
 * - 01 - The SRM logic is controlled by the FSU. The update will be done of the
 *     next frame.
 * - 10 - The SRM logic is controlled by the FSU. Registers are swapped
 *     continuously frame by frame
 * - 11 - Update now. The SRM is controlled by the ARM platform. The Register
 *     will be update now
 */
/*@{*/
#define BP_IPU_SRM_PRI2_DI1_SRM_MODE (27U) /*!< Bit position for IPU_SRM_PRI2_DI1_SRM_MODE. */
#define BM_IPU_SRM_PRI2_DI1_SRM_MODE (0x18000000U) /*!< Bit mask for IPU_SRM_PRI2_DI1_SRM_MODE. */
#define BS_IPU_SRM_PRI2_DI1_SRM_MODE (2U)  /*!< Bit field size in bits for IPU_SRM_PRI2_DI1_SRM_MODE. */

/*! @brief Read current value of the IPU_SRM_PRI2_DI1_SRM_MODE field. */
#define BR_IPU_SRM_PRI2_DI1_SRM_MODE(x) (HW_IPU_SRM_PRI2(x).B.DI1_SRM_MODE)

/*! @brief Format value for bitfield IPU_SRM_PRI2_DI1_SRM_MODE. */
#define BF_IPU_SRM_PRI2_DI1_SRM_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SRM_PRI2_DI1_SRM_MODE) & BM_IPU_SRM_PRI2_DI1_SRM_MODE)

/*! @brief Set the DI1_SRM_MODE field to a new value. */
#define BW_IPU_SRM_PRI2_DI1_SRM_MODE(x, v) (HW_IPU_SRM_PRI2_WR(x, (HW_IPU_SRM_PRI2_RD(x) & ~BM_IPU_SRM_PRI2_DI1_SRM_MODE) | BF_IPU_SRM_PRI2_DI1_SRM_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_FS_PROC_FLOW1 - FSU Processing Flow 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_FS_PROC_FLOW1 - FSU Processing Flow 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contain controls for IPU's tasks.
 */
typedef union _hw_ipu_fs_proc_flow1
{
    uint32_t U;
    struct _hw_ipu_fs_proc_flow1_bitfields
    {
        uint32_t PRPENC_ROT_SRC_SEL : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t PRPVF_ROT_SRC_SEL : 4; /*!< [11:8]  */
        uint32_t PP_SRC_SEL : 4;       /*!< [15:12]  */
        uint32_t PP_ROT_SRC_SEL : 4;   /*!< [19:16]  */
        uint32_t VDI1_SRC_SEL : 2;     /*!< [21:20]  */
        uint32_t VDI3_SRC_SEL : 2;     /*!< [23:22]  */
        uint32_t PRP_SRC_SEL : 4;      /*!< [27:24]  */
        uint32_t VDI_SRC_SEL : 2;      /*!< [29:28]  */
        uint32_t ENC_IN_VALID : 1;     /*!< [30]  */
        uint32_t VF_IN_VALID : 1;      /*!< [31]  */
    } B;
} hw_ipu_fs_proc_flow1_t;

/*!
 * @name Constants and macros for entire IPU_FS_PROC_FLOW1 register
 */
/*@{*/
#define HW_IPU_FS_PROC_FLOW1_ADDR(x) ((uintptr_t)(x) + 0xA8U)

#define HW_IPU_FS_PROC_FLOW1(x)  (*(__IO hw_ipu_fs_proc_flow1_t *) HW_IPU_FS_PROC_FLOW1_ADDR(x))
#define HW_IPU_FS_PROC_FLOW1_RD(x) (HW_IPU_FS_PROC_FLOW1(x).U)
#define HW_IPU_FS_PROC_FLOW1_WR(x, v) (HW_IPU_FS_PROC_FLOW1(x).U = (v))
#define HW_IPU_FS_PROC_FLOW1_SET(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, HW_IPU_FS_PROC_FLOW1_RD(x) |  (v)))
#define HW_IPU_FS_PROC_FLOW1_CLR(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, HW_IPU_FS_PROC_FLOW1_RD(x) & ~(v)))
#define HW_IPU_FS_PROC_FLOW1_TOG(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, HW_IPU_FS_PROC_FLOW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_FS_PROC_FLOW1 bitfields
 */

/*!
 * @name Register IPU_FS_PROC_FLOW1, field PRPENC_ROT_SRC_SEL[3:0] (RW)
 *
 * Source select for the encoding task of the IRT
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture1 (smfc1)
 * - 0011 - capture2 (smfc2)
 * - 0100 - capture3 (smfc3)
 * - 0101 - IC direct (cb7)
 * - 0110 - Reserved
 * - 0111 - encoding
 * - 1000 - Reserved
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL (0U) /*!< Bit position for IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL (0x0000000FU) /*!< Bit mask for IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.PRPENC_ROT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL)

/*! @brief Set the PRPENC_ROT_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_PRPENC_ROT_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field PRPVF_ROT_SRC_SEL[11:8] (RW)
 *
 * Source select for the view finder task of the IRT 0000 ARM platform
 *
 * Values:
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture1 (smfc1)
 * - 0011 - capture2 (smfc2)
 * - 0100 - capture3 (smfc3)
 * - 0101 - IC direct (cb7)
 * - 0110 - Reserved
 * - 0111 - Reserved
 * - 1000 - View-finder
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL (8U) /*!< Bit position for IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL (0x00000F00U) /*!< Bit mask for IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.PRPVF_ROT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL)

/*! @brief Set the PRPVF_ROT_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_PRPVF_ROT_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field PP_SRC_SEL[15:12] (RW)
 *
 * Source select for the pre processing task of the IC
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - Reserved
 * - 0011 - capture2 (smfc2)
 * - 0100 - Reserved
 * - 0101 - Reserved
 * - 0110 - Rotation for post-processing
 * - 0111 - Reserved
 * - 1000 - Reserved
 * - 1000 - VDOA
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_PP_SRC_SEL (12U) /*!< Bit position for IPU_FS_PROC_FLOW1_PP_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_PP_SRC_SEL (0x0000F000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_PP_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_PP_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_PP_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_PP_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_PP_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.PP_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_PP_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_PP_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_PP_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_PP_SRC_SEL)

/*! @brief Set the PP_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_PP_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_PP_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_PP_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field PP_ROT_SRC_SEL[19:16] (RW)
 *
 * Source select for the pre processing task of the IRT (CH 50)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - Reserved
 * - 0011 - capture2 (smfc2)
 * - 0100 - Reserved
 * - 0101 - Post-processing
 * - 0110 - Reserved
 * - 0111 - Reserved
 * - 1000 - Reserved
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL (16U) /*!< Bit position for IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL (0x000F0000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.PP_ROT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL)

/*! @brief Set the PP_ROT_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_PP_ROT_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field VDI1_SRC_SEL[21:20] (RW)
 *
 * Source select for the VDIC plane #1 (IDMAC's CH26) This field is relevant
 * only if the VDIC works in combining mode (VDI_CMB_EN bit is set)
 *
 * Values:
 * - 00 - ARM platform
 * - 01 - IRT viewfinder
 * - 10 - IRT playback
 * - 11 - post-processing
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL (20U) /*!< Bit position for IPU_FS_PROC_FLOW1_VDI1_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL (0x00300000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_VDI1_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_VDI1_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_VDI1_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.VDI1_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_VDI1_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL)

/*! @brief Set the VDI1_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_VDI1_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field VDI3_SRC_SEL[23:22] (RW)
 *
 * Source select for the VDIC plane #3 (IDMAC's CH 25)
 *
 * Values:
 * - 00 - ARM platformThis field is relevant only if the VDIC works in combining
 *     mode (VDI_CMB_EN bit is set)
 * - 01 - IRT viewfinder (ch 49)
 * - 10 - IRT playback (ch 50)
 * - 11 - post-processing (ch 22)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL (22U) /*!< Bit position for IPU_FS_PROC_FLOW1_VDI3_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL (0x00C00000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_VDI3_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_VDI3_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_VDI3_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.VDI3_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_VDI3_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL)

/*! @brief Set the VDI3_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_VDI3_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field PRP_SRC_SEL[27:24] (RW)
 *
 * Source select for the Pre Processing Task 0000 ARM platform
 *
 * Values:
 * - 0001 - capture0 (smfc0)
 * - 0011 - capture2 (smfc2)
 * - 0101 - IC direct (cb7)
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - Reserved
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_PRP_SRC_SEL (24U) /*!< Bit position for IPU_FS_PROC_FLOW1_PRP_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_PRP_SRC_SEL (0x0F000000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_PRP_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_PRP_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_PRP_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_PRP_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_PRP_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.PRP_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_PRP_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_PRP_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_PRP_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_PRP_SRC_SEL)

/*! @brief Set the PRP_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_PRP_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_PRP_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_PRP_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field VDI_SRC_SEL[29:28] (RW)
 *
 * Source select for the VDIC This field is relevant if the VDIC works in
 * de-interlacing mode (when VDI_CMB_EN bit is clear)
 *
 * Values:
 * - 00 - ARM platform
 * - 01 - CSI direct (cb7)
 * - 10 - Reserved
 * - 10 - VDOA
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_VDI_SRC_SEL (28U) /*!< Bit position for IPU_FS_PROC_FLOW1_VDI_SRC_SEL. */
#define BM_IPU_FS_PROC_FLOW1_VDI_SRC_SEL (0x30000000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_VDI_SRC_SEL. */
#define BS_IPU_FS_PROC_FLOW1_VDI_SRC_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_VDI_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_VDI_SRC_SEL field. */
#define BR_IPU_FS_PROC_FLOW1_VDI_SRC_SEL(x) (HW_IPU_FS_PROC_FLOW1(x).B.VDI_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_VDI_SRC_SEL. */
#define BF_IPU_FS_PROC_FLOW1_VDI_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_VDI_SRC_SEL) & BM_IPU_FS_PROC_FLOW1_VDI_SRC_SEL)

/*! @brief Set the VDI_SRC_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_VDI_SRC_SEL(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_VDI_SRC_SEL) | BF_IPU_FS_PROC_FLOW1_VDI_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field ENC_IN_VALID[30] (RW)
 *
 * Encoding Input valid. Setting this bit indicates that the buffer in memory
 * for encoding is validated by the ARM platform (valid only when RWS_EN is '1').
 *
 * Values:
 * - 0 - Encoding should skip buffer in memory.
 * - 1 - Encoding should use buffer in memory.
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_ENC_IN_VALID (30U) /*!< Bit position for IPU_FS_PROC_FLOW1_ENC_IN_VALID. */
#define BM_IPU_FS_PROC_FLOW1_ENC_IN_VALID (0x40000000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_ENC_IN_VALID. */
#define BS_IPU_FS_PROC_FLOW1_ENC_IN_VALID (1U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_ENC_IN_VALID. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_ENC_IN_VALID field. */
#define BR_IPU_FS_PROC_FLOW1_ENC_IN_VALID(x) (HW_IPU_FS_PROC_FLOW1(x).B.ENC_IN_VALID)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_ENC_IN_VALID. */
#define BF_IPU_FS_PROC_FLOW1_ENC_IN_VALID(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_ENC_IN_VALID) & BM_IPU_FS_PROC_FLOW1_ENC_IN_VALID)

/*! @brief Set the ENC_IN_VALID field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_ENC_IN_VALID(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_ENC_IN_VALID) | BF_IPU_FS_PROC_FLOW1_ENC_IN_VALID(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW1, field VF_IN_VALID[31] (RW)
 *
 * View-finder Input valid. Setting this bit indicates that the buffer in memory
 * for viewfinder is validated by the ARM platform (valid only when RWS_EN is
 * '1').
 *
 * Values:
 * - 0 - View-finder should skip buffer in memory.
 * - 1 - View-finder should use buffer in memory.
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW1_VF_IN_VALID (31U) /*!< Bit position for IPU_FS_PROC_FLOW1_VF_IN_VALID. */
#define BM_IPU_FS_PROC_FLOW1_VF_IN_VALID (0x80000000U) /*!< Bit mask for IPU_FS_PROC_FLOW1_VF_IN_VALID. */
#define BS_IPU_FS_PROC_FLOW1_VF_IN_VALID (1U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW1_VF_IN_VALID. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW1_VF_IN_VALID field. */
#define BR_IPU_FS_PROC_FLOW1_VF_IN_VALID(x) (HW_IPU_FS_PROC_FLOW1(x).B.VF_IN_VALID)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW1_VF_IN_VALID. */
#define BF_IPU_FS_PROC_FLOW1_VF_IN_VALID(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW1_VF_IN_VALID) & BM_IPU_FS_PROC_FLOW1_VF_IN_VALID)

/*! @brief Set the VF_IN_VALID field to a new value. */
#define BW_IPU_FS_PROC_FLOW1_VF_IN_VALID(x, v) (HW_IPU_FS_PROC_FLOW1_WR(x, (HW_IPU_FS_PROC_FLOW1_RD(x) & ~BM_IPU_FS_PROC_FLOW1_VF_IN_VALID) | BF_IPU_FS_PROC_FLOW1_VF_IN_VALID(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_FS_PROC_FLOW2 - FSU Processing Flow 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_FS_PROC_FLOW2 - FSU Processing Flow 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains controls for IPU's tasks.
 */
typedef union _hw_ipu_fs_proc_flow2
{
    uint32_t U;
    struct _hw_ipu_fs_proc_flow2_bitfields
    {
        uint32_t PRP_ENC_DEST_SEL : 4; /*!< [3:0]  */
        uint32_t PRPVF_DEST_SEL : 4;   /*!< [7:4]  */
        uint32_t PRPVF_ROT_DEST_SEL : 4; /*!< [11:8]  */
        uint32_t PP_DEST_SEL : 4;      /*!< [15:12]  */
        uint32_t PP_ROT_DEST_SEL : 4;  /*!< [19:16]  */
        uint32_t PRPENC_ROT_DEST_SEL : 4; /*!< [23:20]  */
        uint32_t PRP_DEST_SEL : 4;     /*!< [27:24]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_fs_proc_flow2_t;

/*!
 * @name Constants and macros for entire IPU_FS_PROC_FLOW2 register
 */
/*@{*/
#define HW_IPU_FS_PROC_FLOW2_ADDR(x) ((uintptr_t)(x) + 0xACU)

#define HW_IPU_FS_PROC_FLOW2(x)  (*(__IO hw_ipu_fs_proc_flow2_t *) HW_IPU_FS_PROC_FLOW2_ADDR(x))
#define HW_IPU_FS_PROC_FLOW2_RD(x) (HW_IPU_FS_PROC_FLOW2(x).U)
#define HW_IPU_FS_PROC_FLOW2_WR(x, v) (HW_IPU_FS_PROC_FLOW2(x).U = (v))
#define HW_IPU_FS_PROC_FLOW2_SET(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, HW_IPU_FS_PROC_FLOW2_RD(x) |  (v)))
#define HW_IPU_FS_PROC_FLOW2_CLR(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, HW_IPU_FS_PROC_FLOW2_RD(x) & ~(v)))
#define HW_IPU_FS_PROC_FLOW2_TOG(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, HW_IPU_FS_PROC_FLOW2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_FS_PROC_FLOW2 bitfields
 */

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PRP_ENC_DEST_SEL[3:0] (RW)
 *
 * Destination select for Encoding task
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - IRT Encoding
 * - 0010 - Reserved
 * - 0011 - Reserved
 * - 0100 - Reserved
 * - 0101 - Reserved
 * - 0110 - Reserved
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL (0U) /*!< Bit position for IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL (0x0000000FU) /*!< Bit mask for IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PRP_ENC_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL)

/*! @brief Set the PRP_ENC_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PRP_ENC_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PRPVF_DEST_SEL[7:4] (RW)
 *
 * Destination select for View finder task
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - IRT viewfinder
 * - 0010 - Reserved
 * - 0011 - Reserved
 * - 0100 - Reserved
 * - 0101 - Reserved
 * - 0110 - Reserved
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL (4U) /*!< Bit position for IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL (0x000000F0U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PRPVF_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL)

/*! @brief Set the PRPVF_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PRPVF_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PRPVF_ROT_DEST_SEL[11:8] (RW)
 *
 * Destination select for Rotation task coming from the View finder input
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - Reserved
 * - 0010 - Reserved
 * - 0011 - VDI_PLANE3 (Ch 25)
 * - 0100 - VDI_PLANE1 (Ch 26)
 * - 0101 - IC Pre Processing
 * - 0110 - Reserved
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL (8U) /*!< Bit position for IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL (0x00000F00U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PRPVF_ROT_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL)

/*! @brief Set the PRPVF_ROT_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PRPVF_ROT_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PP_DEST_SEL[15:12] (RW)
 *
 * Destination select for post processing task
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - Reserved
 * - 0010 - Reserved
 * - 0011 - IRT playback
 * - 0100 - VDI_PLANE3 (Ch 25)
 * - 0101 - VDI_PLANE1 (Ch 26)
 * - 0110 - Reserved
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PP_DEST_SEL (12U) /*!< Bit position for IPU_FS_PROC_FLOW2_PP_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PP_DEST_SEL (0x0000F000U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PP_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PP_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PP_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PP_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PP_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PP_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PP_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PP_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PP_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PP_DEST_SEL)

/*! @brief Set the PP_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PP_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PP_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PP_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PP_ROT_DEST_SEL[19:16] (RW)
 *
 * Destination select for Rotation task coming from the Post Processing input
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - Reserved
 * - 0010 - Reserved
 * - 0011 - Reserved
 * - 0100 - IC Playback (Post Processing)
 * - 0101 - VDI_PLANE3 (Ch 25)
 * - 0110 - VDI_PLANE1 (Ch 26)
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL (16U) /*!< Bit position for IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL (0x000F0000U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PP_ROT_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL)

/*! @brief Set the PP_ROT_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PP_ROT_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PRPENC_ROT_DEST_SEL[23:20] (RW)
 *
 * Destination select for Rotation task coming from the Encoding input
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - Reserved
 * - 0010 - Reserved
 * - 0011 - Reserved
 * - 0100 - Reserved
 * - 0101 - IC Pre Processing
 * - 0110 - Reserved
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL (20U) /*!< Bit position for IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL (0x00F00000U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PRPENC_ROT_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL)

/*! @brief Set the PRPENC_ROT_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PRPENC_ROT_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW2, field PRP_DEST_SEL[27:24] (RW)
 *
 * Pre processing destination select (for channel DMAIC_7)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - IC input buffer (ch12)
 * - 0010 - PP (ch11)
 * - 0011 - PP_ROT (ch47)
 * - 0100 - DC1 (ch28)
 * - 0101 - DC2 (ch41)
 * - 0110 - DP_ASYNC1 (ch24)
 * - 0111 - DP_ASYNC0 (ch29)
 * - 1000 - DP_SYNC1 (ch27)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - Alt DC2 (ch41)
 * - 1011 - Alt DP_ASYNC1 (ch24)
 * - 1100 - Alt DP_ASYNC0 (ch29)
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW2_PRP_DEST_SEL (24U) /*!< Bit position for IPU_FS_PROC_FLOW2_PRP_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW2_PRP_DEST_SEL (0x0F000000U) /*!< Bit mask for IPU_FS_PROC_FLOW2_PRP_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW2_PRP_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW2_PRP_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW2_PRP_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW2_PRP_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW2(x).B.PRP_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW2_PRP_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW2_PRP_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW2_PRP_DEST_SEL) & BM_IPU_FS_PROC_FLOW2_PRP_DEST_SEL)

/*! @brief Set the PRP_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW2_PRP_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW2_WR(x, (HW_IPU_FS_PROC_FLOW2_RD(x) & ~BM_IPU_FS_PROC_FLOW2_PRP_DEST_SEL) | BF_IPU_FS_PROC_FLOW2_PRP_DEST_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_FS_PROC_FLOW3 - FSU Processing Flow 3 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_FS_PROC_FLOW3 - FSU Processing Flow 3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains controls for IPU's tasks. Hide VPU_SUB_FRAME_SYNC for
 * all versions Show VPU_SUB_FRAME_SYNC for IPUv3H version. The table below
 * tagged with other settings (like IPU3M_only) should be hidden in IPUv3H version.
 * This requires some sophisticated conditional tag settings
 */
typedef union _hw_ipu_fs_proc_flow3
{
    uint32_t U;
    struct _hw_ipu_fs_proc_flow3_bitfields
    {
        uint32_t SMFC0_DEST_SEL : 4;   /*!< [3:0]  */
        uint32_t SMFC1_DEST_SEL : 3;   /*!< [6:4]  */
        uint32_t SMFC2_DEST_SEL : 4;   /*!< [10:7]  */
        uint32_t SMFC3_DEST_SEL : 3;   /*!< [13:11]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VDOA_DEST_SEL : 2;    /*!< [17:16]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t EXT_SRC1_DEST_SEL : 2; /*!< [21:20]  */
        uint32_t EXT_SRC2_DEST_SEL : 2; /*!< [23:22]  */
        uint32_t VPU_DEST_SEL : 2;     /*!< [25:24]  */
        uint32_t RESERVED2 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_fs_proc_flow3_t;

/*!
 * @name Constants and macros for entire IPU_FS_PROC_FLOW3 register
 */
/*@{*/
#define HW_IPU_FS_PROC_FLOW3_ADDR(x) ((uintptr_t)(x) + 0xB0U)

#define HW_IPU_FS_PROC_FLOW3(x)  (*(__IO hw_ipu_fs_proc_flow3_t *) HW_IPU_FS_PROC_FLOW3_ADDR(x))
#define HW_IPU_FS_PROC_FLOW3_RD(x) (HW_IPU_FS_PROC_FLOW3(x).U)
#define HW_IPU_FS_PROC_FLOW3_WR(x, v) (HW_IPU_FS_PROC_FLOW3(x).U = (v))
#define HW_IPU_FS_PROC_FLOW3_SET(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, HW_IPU_FS_PROC_FLOW3_RD(x) |  (v)))
#define HW_IPU_FS_PROC_FLOW3_CLR(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, HW_IPU_FS_PROC_FLOW3_RD(x) & ~(v)))
#define HW_IPU_FS_PROC_FLOW3_TOG(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, HW_IPU_FS_PROC_FLOW3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_FS_PROC_FLOW3 bitfields
 */

/*!
 * @name Register IPU_FS_PROC_FLOW3, field SMFC0_DEST_SEL[3:0] (RW)
 *
 * Destination select for SMFC0
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - IRT Encoding
 * - 0010 - IRT viewfinder
 * - 0011 - IRT playback
 * - 0100 - IC Playback (Post Processing)
 * - 0101 - IC Pre Processing
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL (0U) /*!< Bit position for IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL (0x0000000FU) /*!< Bit mask for IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.SMFC0_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL)

/*! @brief Set the SMFC0_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_SMFC0_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field SMFC1_DEST_SEL[6:4] (RW)
 *
 * Destination select for SMFC1
 *
 * Values:
 * - 000 - ARM platform
 * - 001 - IRT Encoding
 * - 010 - IRT viewfinder
 * - 011 - IRT playback
 * - 100 - IC Playback (Post Processing)
 * - 101 - IC Pre Processing
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL (4U) /*!< Bit position for IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL (0x00000070U) /*!< Bit mask for IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL (3U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.SMFC1_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL)

/*! @brief Set the SMFC1_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_SMFC1_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field SMFC2_DEST_SEL[10:7] (RW)
 *
 * Destination select for SMFC2
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - IRT Encoding
 * - 0010 - IRT viewfinder
 * - 0011 - IRT playback
 * - 0100 - IC Playback (Post Processing)
 * - 0101 - IC Pre Processing
 * - 0111 - DC1 (ch28)
 * - 1000 - DC2 (ch41)
 * - 1001 - DP_SYNC0 (ch23)
 * - 1010 - DP_SYNC1 (ch27)
 * - 1011 - DP_ASYNC1 (ch24)
 * - 1100 - DP_ASYNC0 (ch29)
 * - 1101 - Alt DC2 (ch41)
 * - 1110 - Alt DP_ASYNC1 (ch24)
 * - 1111 - Alt DP_ASYNC0 (ch29)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL (7U) /*!< Bit position for IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL (0x00000780U) /*!< Bit mask for IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL (4U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.SMFC2_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL)

/*! @brief Set the SMFC2_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_SMFC2_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field SMFC3_DEST_SEL[13:11] (RW)
 *
 * Destination select for SMFC3
 *
 * Values:
 * - 000 - ARM platform
 * - 001 - IRT Encoding
 * - 010 - IRT viewfinder
 * - 011 - IRT playback
 * - 100 - IC Playback (Post Processing)
 * - 101 - IC Pre Processing
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL (11U) /*!< Bit position for IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL (0x00003800U) /*!< Bit mask for IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL (3U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.SMFC3_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL)

/*! @brief Set the SMFC3_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_SMFC3_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field VDOA_DEST_SEL[17:16] (RW)
 *
 * Destination select for VDOA
 *
 * Values:
 * - 00 - disabled
 * - 01 - IC Playback (Post Processing)
 * - 10 - VDI (ch8,ch9 & ch10 or ch9 according to VDI_MOT_SEL settings)
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL (16U) /*!< Bit position for IPU_FS_PROC_FLOW3_VDOA_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL (0x00030000U) /*!< Bit mask for IPU_FS_PROC_FLOW3_VDOA_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_VDOA_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_VDOA_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.VDOA_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_VDOA_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL)

/*! @brief Set the VDOA_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_VDOA_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field EXT_SRC1_DEST_SEL[21:20] (RW)
 *
 * Destination select for External Source 1
 *
 * Values:
 * - 00 - disabled
 * - 01 - DP_SYNC0 (ch23)
 * - 10 - DP_SYNC1 (ch27)
 * - 11 - DC1 (ch28)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL (20U) /*!< Bit position for IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL (0x00300000U) /*!< Bit mask for IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.EXT_SRC1_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL)

/*! @brief Set the EXT_SRC1_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_EXT_SRC1_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field EXT_SRC2_DEST_SEL[23:22] (RW)
 *
 * Destination select for External Source 2
 *
 * Values:
 * - 00 - disabled
 * - 01 - DP_SYNC0 (ch23)
 * - 10 - DP_SYNC1 (ch27)
 * - 11 - DC1 (ch28)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL (22U) /*!< Bit position for IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL (0x00C00000U) /*!< Bit mask for IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.EXT_SRC2_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL)

/*! @brief Set the EXT_SRC2_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_EXT_SRC2_DEST_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_PROC_FLOW3, field VPU_DEST_SEL[25:24] (RW)
 *
 * This bits selects the corresponding IDMAC channel's EOL indication to be used
 * for sub frame synchronization with the VPU. The corresponding IDMAC channel's
 * EOLI bit at the CPMEM has to be set as well.
 *
 * Values:
 * - 00 - disabled
 * - 01 - capture0 (smfc0) (ch0)
 * - 10 - capture2 (smfc2) (ch2)
 * - 11 - IC viewfinder (ch21)
 */
/*@{*/
#define BP_IPU_FS_PROC_FLOW3_VPU_DEST_SEL (24U) /*!< Bit position for IPU_FS_PROC_FLOW3_VPU_DEST_SEL. */
#define BM_IPU_FS_PROC_FLOW3_VPU_DEST_SEL (0x03000000U) /*!< Bit mask for IPU_FS_PROC_FLOW3_VPU_DEST_SEL. */
#define BS_IPU_FS_PROC_FLOW3_VPU_DEST_SEL (2U) /*!< Bit field size in bits for IPU_FS_PROC_FLOW3_VPU_DEST_SEL. */

/*! @brief Read current value of the IPU_FS_PROC_FLOW3_VPU_DEST_SEL field. */
#define BR_IPU_FS_PROC_FLOW3_VPU_DEST_SEL(x) (HW_IPU_FS_PROC_FLOW3(x).B.VPU_DEST_SEL)

/*! @brief Format value for bitfield IPU_FS_PROC_FLOW3_VPU_DEST_SEL. */
#define BF_IPU_FS_PROC_FLOW3_VPU_DEST_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_PROC_FLOW3_VPU_DEST_SEL) & BM_IPU_FS_PROC_FLOW3_VPU_DEST_SEL)

/*! @brief Set the VPU_DEST_SEL field to a new value. */
#define BW_IPU_FS_PROC_FLOW3_VPU_DEST_SEL(x, v) (HW_IPU_FS_PROC_FLOW3_WR(x, (HW_IPU_FS_PROC_FLOW3_RD(x) & ~BM_IPU_FS_PROC_FLOW3_VPU_DEST_SEL) | BF_IPU_FS_PROC_FLOW3_VPU_DEST_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_FS_DISP_FLOW1 - FSU Displaying Flow 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_FS_DISP_FLOW1 - FSU Displaying Flow 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains controls for IPU's tasks.
 */
typedef union _hw_ipu_fs_disp_flow1
{
    uint32_t U;
    struct _hw_ipu_fs_disp_flow1_bitfields
    {
        uint32_t DP_SYNC0_SRC_SEL : 4; /*!< [3:0]  */
        uint32_t DP_SYNC1_SRC_SEL : 4; /*!< [7:4]  */
        uint32_t DP_ASYNC0_SRC_SEL : 4; /*!< [11:8]  */
        uint32_t DP_ASYNC1_SRC_SEL : 4; /*!< [15:12]  */
        uint32_t DC2_SRC_SEL : 4;      /*!< [19:16]  */
        uint32_t DC1_SRC_SEL : 4;      /*!< [23:20]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_fs_disp_flow1_t;

/*!
 * @name Constants and macros for entire IPU_FS_DISP_FLOW1 register
 */
/*@{*/
#define HW_IPU_FS_DISP_FLOW1_ADDR(x) ((uintptr_t)(x) + 0xB4U)

#define HW_IPU_FS_DISP_FLOW1(x)  (*(__IO hw_ipu_fs_disp_flow1_t *) HW_IPU_FS_DISP_FLOW1_ADDR(x))
#define HW_IPU_FS_DISP_FLOW1_RD(x) (HW_IPU_FS_DISP_FLOW1(x).U)
#define HW_IPU_FS_DISP_FLOW1_WR(x, v) (HW_IPU_FS_DISP_FLOW1(x).U = (v))
#define HW_IPU_FS_DISP_FLOW1_SET(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, HW_IPU_FS_DISP_FLOW1_RD(x) |  (v)))
#define HW_IPU_FS_DISP_FLOW1_CLR(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, HW_IPU_FS_DISP_FLOW1_RD(x) & ~(v)))
#define HW_IPU_FS_DISP_FLOW1_TOG(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, HW_IPU_FS_DISP_FLOW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_FS_DISP_FLOW1 bitfields
 */

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DP_SYNC0_SRC_SEL[3:0] (RW)
 *
 * Source select for DS2 - MG (graphics) plane (ch23)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL (0U) /*!< Bit position for IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL (0x0000000FU) /*!< Bit mask for IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DP_SYNC0_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL)

/*! @brief Set the DP_SYNC0_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DP_SYNC0_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DP_SYNC1_SRC_SEL[7:4] (RW)
 *
 * Source select for DS1/DS2 - Vx (video) plane (ch27)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL (4U) /*!< Bit position for IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL (0x000000F0U) /*!< Bit mask for IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DP_SYNC1_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL)

/*! @brief Set the DP_SYNC1_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DP_SYNC1_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DP_ASYNC0_SRC_SEL[11:8] (RW)
 *
 * Source select for DS2 - MG (graphics) plane (ch29)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL (8U) /*!< Bit position for IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL (0x00000F00U) /*!< Bit mask for IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DP_ASYNC0_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL)

/*! @brief Set the DP_ASYNC0_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DP_ASYNC0_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DP_ASYNC1_SRC_SEL[15:12] (RW)
 *
 * Source select for DS1/DS2 - Vx (video) plane (ch24)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL (12U) /*!< Bit position for IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL (0x0000F000U) /*!< Bit mask for IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DP_ASYNC1_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL)

/*! @brief Set the DP_ASYNC1_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DP_ASYNC1_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DC2_SRC_SEL[19:16] (RW)
 *
 * Source select for DS3 (ch41)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DC2_SRC_SEL (16U) /*!< Bit position for IPU_FS_DISP_FLOW1_DC2_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DC2_SRC_SEL (0x000F0000U) /*!< Bit mask for IPU_FS_DISP_FLOW1_DC2_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DC2_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DC2_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DC2_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DC2_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DC2_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DC2_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DC2_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DC2_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DC2_SRC_SEL)

/*! @brief Set the DC2_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DC2_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DC2_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DC2_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW1, field DC1_SRC_SEL[23:20] (RW)
 *
 * Source select for DS1/DS2 - MG (graphics) plane (ch28)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - External source #1 (e.g. an external block like GPU)
 * - 1110 - snoop1
 * - 1111 - External source #2 (e.g. an external block like GPU)
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW1_DC1_SRC_SEL (20U) /*!< Bit position for IPU_FS_DISP_FLOW1_DC1_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW1_DC1_SRC_SEL (0x00F00000U) /*!< Bit mask for IPU_FS_DISP_FLOW1_DC1_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW1_DC1_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW1_DC1_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW1_DC1_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW1_DC1_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW1(x).B.DC1_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW1_DC1_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW1_DC1_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW1_DC1_SRC_SEL) & BM_IPU_FS_DISP_FLOW1_DC1_SRC_SEL)

/*! @brief Set the DC1_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW1_DC1_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW1_WR(x, (HW_IPU_FS_DISP_FLOW1_RD(x) & ~BM_IPU_FS_DISP_FLOW1_DC1_SRC_SEL) | BF_IPU_FS_DISP_FLOW1_DC1_SRC_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_FS_DISP_FLOW2 - FSU Displaying Flow 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_FS_DISP_FLOW2 - FSU Displaying Flow 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains controls for IPU's tasks.
 */
typedef union _hw_ipu_fs_disp_flow2
{
    uint32_t U;
    struct _hw_ipu_fs_disp_flow2_bitfields
    {
        uint32_t DP_ASYNC0_ALT_SRC_SEL : 4; /*!< [3:0]  */
        uint32_t DP_ASYNC1_ALT_SRC_SEL : 4; /*!< [7:4]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t DC2_ALT_SRC_SEL : 4;  /*!< [19:16]  */
        uint32_t RESERVED1 : 12;       /*!< [31:20]  */
    } B;
} hw_ipu_fs_disp_flow2_t;

/*!
 * @name Constants and macros for entire IPU_FS_DISP_FLOW2 register
 */
/*@{*/
#define HW_IPU_FS_DISP_FLOW2_ADDR(x) ((uintptr_t)(x) + 0xB8U)

#define HW_IPU_FS_DISP_FLOW2(x)  (*(__IO hw_ipu_fs_disp_flow2_t *) HW_IPU_FS_DISP_FLOW2_ADDR(x))
#define HW_IPU_FS_DISP_FLOW2_RD(x) (HW_IPU_FS_DISP_FLOW2(x).U)
#define HW_IPU_FS_DISP_FLOW2_WR(x, v) (HW_IPU_FS_DISP_FLOW2(x).U = (v))
#define HW_IPU_FS_DISP_FLOW2_SET(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, HW_IPU_FS_DISP_FLOW2_RD(x) |  (v)))
#define HW_IPU_FS_DISP_FLOW2_CLR(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, HW_IPU_FS_DISP_FLOW2_RD(x) & ~(v)))
#define HW_IPU_FS_DISP_FLOW2_TOG(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, HW_IPU_FS_DISP_FLOW2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_FS_DISP_FLOW2 bitfields
 */

/*!
 * @name Register IPU_FS_DISP_FLOW2, field DP_ASYNC0_ALT_SRC_SEL[3:0] (RW)
 *
 * Source select for alternate DS2 - MG (graphics) plane (ch29)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL (0U) /*!< Bit position for IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL (0x0000000FU) /*!< Bit mask for IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW2(x).B.DP_ASYNC0_ALT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL) & BM_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL)

/*! @brief Set the DP_ASYNC0_ALT_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, (HW_IPU_FS_DISP_FLOW2_RD(x) & ~BM_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL) | BF_IPU_FS_DISP_FLOW2_DP_ASYNC0_ALT_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW2, field DP_ASYNC1_ALT_SRC_SEL[7:4] (RW)
 *
 * Source select for alternate DS1/DS2 - Vx (video) plane (ch24)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL (4U) /*!< Bit position for IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL (0x000000F0U) /*!< Bit mask for IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW2(x).B.DP_ASYNC1_ALT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL) & BM_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL)

/*! @brief Set the DP_ASYNC1_ALT_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, (HW_IPU_FS_DISP_FLOW2_RD(x) & ~BM_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL) | BF_IPU_FS_DISP_FLOW2_DP_ASYNC1_ALT_SRC_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_FS_DISP_FLOW2, field DC2_ALT_SRC_SEL[19:16] (RW)
 *
 * Source select for Alternate DS3 (ch41)
 *
 * Values:
 * - 0000 - ARM platform
 * - 0001 - capture0 (smfc0)
 * - 0010 - capture2 (smfc2)
 * - 0011 - IC encoding
 * - 0100 - IC viewfinder
 * - 0101 - IC playback
 * - 0110 - IRT Encoding
 * - 0111 - IRT viewfinder
 * - 1000 - IRT playback
 * - 1001 - Reserved
 * - 1010 - Reserved
 * - 1011 - autoref
 * - 1100 - autoref+snoop1
 * - 1101 - autoref+snoop2
 * - 1110 - snoop1
 * - 1111 - snoop2
 */
/*@{*/
#define BP_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL (16U) /*!< Bit position for IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL. */
#define BM_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL (0x000F0000U) /*!< Bit mask for IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL. */
#define BS_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL (4U) /*!< Bit field size in bits for IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL. */

/*! @brief Read current value of the IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL field. */
#define BR_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL(x) (HW_IPU_FS_DISP_FLOW2(x).B.DC2_ALT_SRC_SEL)

/*! @brief Format value for bitfield IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL. */
#define BF_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL) & BM_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL)

/*! @brief Set the DC2_ALT_SRC_SEL field to a new value. */
#define BW_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL(x, v) (HW_IPU_FS_DISP_FLOW2_WR(x, (HW_IPU_FS_DISP_FLOW2_RD(x) & ~BM_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL) | BF_IPU_FS_DISP_FLOW2_DC2_ALT_SRC_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SKIP - SKIP Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SKIP - SKIP Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls the different frame skipping supported by the IPU.
 */
typedef union _hw_ipu_skip
{
    uint32_t U;
    struct _hw_ipu_skip_bitfields
    {
        uint32_t CSI_MAX_RATIO_SKIP_IC_ENC : 3; /*!< [2:0]  */
        uint32_t CSI_SKIP_IC_ENC : 5;  /*!< [7:3]  */
        uint32_t CSI_MAX_RATIO_SKIP_IC_VF : 3; /*!< [10:8]  */
        uint32_t CSI_SKIP_IC_VF : 5;   /*!< [15:11]  */
        uint32_t VDI_MAX_RATIO_SKIP : 4; /*!< [19:16]  */
        uint32_t VDI_SKIP : 12;        /*!< [31:20]  */
    } B;
} hw_ipu_skip_t;

/*!
 * @name Constants and macros for entire IPU_SKIP register
 */
/*@{*/
#define HW_IPU_SKIP_ADDR(x)      ((uintptr_t)(x) + 0xBCU)

#define HW_IPU_SKIP(x)           (*(__IO hw_ipu_skip_t *) HW_IPU_SKIP_ADDR(x))
#define HW_IPU_SKIP_RD(x)        (HW_IPU_SKIP(x).U)
#define HW_IPU_SKIP_WR(x, v)     (HW_IPU_SKIP(x).U = (v))
#define HW_IPU_SKIP_SET(x, v)    (HW_IPU_SKIP_WR(x, HW_IPU_SKIP_RD(x) |  (v)))
#define HW_IPU_SKIP_CLR(x, v)    (HW_IPU_SKIP_WR(x, HW_IPU_SKIP_RD(x) & ~(v)))
#define HW_IPU_SKIP_TOG(x, v)    (HW_IPU_SKIP_WR(x, HW_IPU_SKIP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SKIP bitfields
 */

/*!
 * @name Register IPU_SKIP, field CSI_MAX_RATIO_SKIP_IC_ENC[2:0] (RW)
 *
 * CSI Maximum Ratio Skip for IC (encoding task) These bits define the number of
 * frames in a skipping set. The maximum value of this bits is 4. When set to 0
 * the skipping is disabled.
 */
/*@{*/
#define BP_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC (0U) /*!< Bit position for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC. */
#define BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC (0x00000007U) /*!< Bit mask for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC. */
#define BS_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC (3U) /*!< Bit field size in bits for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC. */

/*! @brief Read current value of the IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC field. */
#define BR_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC(x) (HW_IPU_SKIP(x).B.CSI_MAX_RATIO_SKIP_IC_ENC)

/*! @brief Format value for bitfield IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC. */
#define BF_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC) & BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC)

/*! @brief Set the CSI_MAX_RATIO_SKIP_IC_ENC field to a new value. */
#define BW_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC) | BF_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_ENC(v)))
/*@}*/

/*!
 * @name Register IPU_SKIP, field CSI_SKIP_IC_ENC[7:3] (RW)
 *
 * CSI SKIP IC_ENC These 5 bits define the skipping pattern of the frames send
 * to the IC for encoding task from one of the CSIs as defined on the CSI_SEL and
 * IC_INPUT bits Skipping is done for a set of frames. The number of frames in a
 * set is defined at CSI_MAX_RATIO_SKIP_IC_ENC. when CSI_MAX_RATIO_SKIP_IC_ENC =
 * 1 => CSI_SKIP_IC_ENC[1:0] are used; other bits are ignored when
 * CSI_MAX_RATIO_SKIP_IC_ENC = 2 => CSI_SKIP_IC_ENC[2:0] are used; other bits are ignored when
 * CSI_MAX_RATIO_SKIP_IC_ENC = 3 => CSI_SKIP_IC_ENC[3:0] are used; other bits are
 * ignored when CSI_MAX_RATIO_SKIP_IC_ENC = 4 => CSI_SKIP_IC_ENC[4:0] are used;
 * Setting bit #n of CSI_SKIP_IC_ENC means that the #n frame in the set is
 * skipped. For example: if CSI_MAX_RATIO_SKIP_IC_ENC = 4 and CSI_SKIP_IC_ENC = 11010
 * Frames #0 & Frame #2 will not be skipped as bit0 and bit2 are cleared Frames #1
 * & Frame #3 will be skipped as bit1 and bit3 are set bit #4 is ignored as
 * CSI_MAX_RATIO_SKIP_IC_ENC is set to 4
 */
/*@{*/
#define BP_IPU_SKIP_CSI_SKIP_IC_ENC (3U)   /*!< Bit position for IPU_SKIP_CSI_SKIP_IC_ENC. */
#define BM_IPU_SKIP_CSI_SKIP_IC_ENC (0x000000F8U) /*!< Bit mask for IPU_SKIP_CSI_SKIP_IC_ENC. */
#define BS_IPU_SKIP_CSI_SKIP_IC_ENC (5U)   /*!< Bit field size in bits for IPU_SKIP_CSI_SKIP_IC_ENC. */

/*! @brief Read current value of the IPU_SKIP_CSI_SKIP_IC_ENC field. */
#define BR_IPU_SKIP_CSI_SKIP_IC_ENC(x) (HW_IPU_SKIP(x).B.CSI_SKIP_IC_ENC)

/*! @brief Format value for bitfield IPU_SKIP_CSI_SKIP_IC_ENC. */
#define BF_IPU_SKIP_CSI_SKIP_IC_ENC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_CSI_SKIP_IC_ENC) & BM_IPU_SKIP_CSI_SKIP_IC_ENC)

/*! @brief Set the CSI_SKIP_IC_ENC field to a new value. */
#define BW_IPU_SKIP_CSI_SKIP_IC_ENC(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_CSI_SKIP_IC_ENC) | BF_IPU_SKIP_CSI_SKIP_IC_ENC(v)))
/*@}*/

/*!
 * @name Register IPU_SKIP, field CSI_MAX_RATIO_SKIP_IC_VF[10:8] (RW)
 *
 * CSI Maximum Ratio Skip for IC (view finder task) These bits define the number
 * of frames in a skipping set. The maximum value of this bits is 4. When set to
 * 0 the skipping is disabled.
 */
/*@{*/
#define BP_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF (8U) /*!< Bit position for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF. */
#define BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF (0x00000700U) /*!< Bit mask for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF. */
#define BS_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF (3U) /*!< Bit field size in bits for IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF. */

/*! @brief Read current value of the IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF field. */
#define BR_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF(x) (HW_IPU_SKIP(x).B.CSI_MAX_RATIO_SKIP_IC_VF)

/*! @brief Format value for bitfield IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF. */
#define BF_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF) & BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF)

/*! @brief Set the CSI_MAX_RATIO_SKIP_IC_VF field to a new value. */
#define BW_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF) | BF_IPU_SKIP_CSI_MAX_RATIO_SKIP_IC_VF(v)))
/*@}*/

/*!
 * @name Register IPU_SKIP, field CSI_SKIP_IC_VF[15:11] (RW)
 *
 * CSI SKIP IC_VF These 5 bits define the skipping pattern of the frames send to
 * the IC for view finder task from one of the CSIs as defined on the CSI_SEL
 * and IC_INPUT bits Skipping is done for a set of frames. The number of frames in
 * a set is defined at CSI_MAX_RATIO_SKIP_IC_VF. when CSI_MAX_RATIO_SKIP_IC_VF =
 * 1 => CSI_SKIP_IC_VF[1:0] are used; other bits are ignored when
 * CSI_MAX_RATIO_SKIP_IC_VF = 2 => CSI_SKIP_IC_VF[2:0] are used; other bits are ignored when
 * CSI_MAX_RATIO_SKIP_IC_VF =3 => CSI_SKIP_IC_VF[3:0] are used; other bits are
 * ignored when CSI_MAX_RATIO_SKIP_IC_VF = 4 => CSI_SKIP_IC_VF[4:0] are used; Setting
 * bit #n of CSI_SKIP_IC_VF means that the #n frame in the set is skipped. For
 * example: if CSI_MAX_RATIO_SKIP_IC_VF = 4 and CSI_SKIP_IC_VF = 11010 Frames #0 &
 * Frame #2 will not be skipped as bit0 and bit2 are cleared Frames #1 & Frame #3
 * will be skipped as bit1 and bit3 are set bit #4 is ignored as
 * CSI_MAX_RATIO_SKIP_IC_VF is set to 4
 */
/*@{*/
#define BP_IPU_SKIP_CSI_SKIP_IC_VF (11U)   /*!< Bit position for IPU_SKIP_CSI_SKIP_IC_VF. */
#define BM_IPU_SKIP_CSI_SKIP_IC_VF (0x0000F800U) /*!< Bit mask for IPU_SKIP_CSI_SKIP_IC_VF. */
#define BS_IPU_SKIP_CSI_SKIP_IC_VF (5U)    /*!< Bit field size in bits for IPU_SKIP_CSI_SKIP_IC_VF. */

/*! @brief Read current value of the IPU_SKIP_CSI_SKIP_IC_VF field. */
#define BR_IPU_SKIP_CSI_SKIP_IC_VF(x) (HW_IPU_SKIP(x).B.CSI_SKIP_IC_VF)

/*! @brief Format value for bitfield IPU_SKIP_CSI_SKIP_IC_VF. */
#define BF_IPU_SKIP_CSI_SKIP_IC_VF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_CSI_SKIP_IC_VF) & BM_IPU_SKIP_CSI_SKIP_IC_VF)

/*! @brief Set the CSI_SKIP_IC_VF field to a new value. */
#define BW_IPU_SKIP_CSI_SKIP_IC_VF(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_CSI_SKIP_IC_VF) | BF_IPU_SKIP_CSI_SKIP_IC_VF(v)))
/*@}*/

/*!
 * @name Register IPU_SKIP, field VDI_MAX_RATIO_SKIP[19:16] (RW)
 *
 * Maximum Ratio Skip for VDIC These bits define the number of frames in a
 * skipping set. The maximum value of this bits is 11. When set to 0 the skipping is
 * disabled.
 */
/*@{*/
#define BP_IPU_SKIP_VDI_MAX_RATIO_SKIP (16U) /*!< Bit position for IPU_SKIP_VDI_MAX_RATIO_SKIP. */
#define BM_IPU_SKIP_VDI_MAX_RATIO_SKIP (0x000F0000U) /*!< Bit mask for IPU_SKIP_VDI_MAX_RATIO_SKIP. */
#define BS_IPU_SKIP_VDI_MAX_RATIO_SKIP (4U) /*!< Bit field size in bits for IPU_SKIP_VDI_MAX_RATIO_SKIP. */

/*! @brief Read current value of the IPU_SKIP_VDI_MAX_RATIO_SKIP field. */
#define BR_IPU_SKIP_VDI_MAX_RATIO_SKIP(x) (HW_IPU_SKIP(x).B.VDI_MAX_RATIO_SKIP)

/*! @brief Format value for bitfield IPU_SKIP_VDI_MAX_RATIO_SKIP. */
#define BF_IPU_SKIP_VDI_MAX_RATIO_SKIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_VDI_MAX_RATIO_SKIP) & BM_IPU_SKIP_VDI_MAX_RATIO_SKIP)

/*! @brief Set the VDI_MAX_RATIO_SKIP field to a new value. */
#define BW_IPU_SKIP_VDI_MAX_RATIO_SKIP(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_VDI_MAX_RATIO_SKIP) | BF_IPU_SKIP_VDI_MAX_RATIO_SKIP(v)))
/*@}*/

/*!
 * @name Register IPU_SKIP, field VDI_SKIP[31:20] (RW)
 *
 * VDI_SKIP These 12 bits define the skipping pattern of the frames send from
 * the VDIC. The VDIC avoids reading fields from the memory if the output frame is
 * skipped. Skipping is relevant only if the source to the VDIC is coming from
 * the CSI. Skipping is done for a set of frames. The number of frames in a set is
 * defined at VDI_MAX_RATIO_SKIP. when VDI_MAX_RATIO_SKIP = 1 => VDI_SKIP[1:0] is
 * used; other bits are ignored when VDI_MAX_RATIO_SKIP = 2 => VDI_SKIP[2:0] are
 * used; other bits are ignored .. .. when VDI_MAX_RATIO_SKIP = 11 =>
 * VDI_SKIP[11:0] are used;
 */
/*@{*/
#define BP_IPU_SKIP_VDI_SKIP (20U)         /*!< Bit position for IPU_SKIP_VDI_SKIP. */
#define BM_IPU_SKIP_VDI_SKIP (0xFFF00000U) /*!< Bit mask for IPU_SKIP_VDI_SKIP. */
#define BS_IPU_SKIP_VDI_SKIP (12U)         /*!< Bit field size in bits for IPU_SKIP_VDI_SKIP. */

/*! @brief Read current value of the IPU_SKIP_VDI_SKIP field. */
#define BR_IPU_SKIP_VDI_SKIP(x) (HW_IPU_SKIP(x).B.VDI_SKIP)

/*! @brief Format value for bitfield IPU_SKIP_VDI_SKIP. */
#define BF_IPU_SKIP_VDI_SKIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SKIP_VDI_SKIP) & BM_IPU_SKIP_VDI_SKIP)

/*! @brief Set the VDI_SKIP field to a new value. */
#define BW_IPU_SKIP_VDI_SKIP(x, v) (HW_IPU_SKIP_WR(x, (HW_IPU_SKIP_RD(x) & ~BM_IPU_SKIP_VDI_SKIP) | BF_IPU_SKIP_VDI_SKIP(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_ALT_CONF - Display Alternate Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_ALT_CONF - Display Alternate Configuration Register (ROZ)
 *
 * Reset value: 0x00000000U
 *
 * This register controls various parameters that are used for alternate flows
 * related to the display modules.
 */
typedef union _hw_ipu_disp_alt_conf
{
    uint32_t U;
    struct _hw_ipu_disp_alt_conf_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_ipu_disp_alt_conf_t;

/*!
 * @name Constants and macros for entire IPU_DISP_ALT_CONF register
 */
/*@{*/
#define HW_IPU_DISP_ALT_CONF_ADDR(x) ((uintptr_t)(x) + 0xC0U)

#define HW_IPU_DISP_ALT_CONF(x)  (*(__I hw_ipu_disp_alt_conf_t *) HW_IPU_DISP_ALT_CONF_ADDR(x))
#define HW_IPU_DISP_ALT_CONF_RD(x) (HW_IPU_DISP_ALT_CONF(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_ALT_CONF bitfields
 */

/*******************************************************************************
 * HW_IPU_DISP_GEN - Display General Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_GEN - Display General Control Register (RW)
 *
 * Reset value: 0x00400000U
 *
 * This register controls various aspects of the display port.
 */
typedef union _hw_ipu_disp_gen
{
    uint32_t U;
    struct _hw_ipu_disp_gen_bitfields
    {
        uint32_t DI0_DUAL_MODE : 1;    /*!< [0]  */
        uint32_t DI1_DUAL_MODE : 1;    /*!< [1]  */
        uint32_t DC2_DOUBLE_FLOW : 1;  /*!< [2]  */
        uint32_t DP_ASYNC_DOUBLE_FLOW : 1; /*!< [3]  */
        uint32_t DP_FG_EN_ASYNC0 : 1;  /*!< [4]  */
        uint32_t DP_FG_EN_ASYNC1 : 1;  /*!< [5]  */
        uint32_t DP_PIPE_CLR : 1;      /*!< [6]  */
        uint32_t RESERVED0 : 9;        /*!< [15:7]  */
        uint32_t MCU_DI_ID_8 : 1;      /*!< [16]  */
        uint32_t MCU_DI_ID_9 : 1;      /*!< [17]  */
        uint32_t MCU_T : 4;            /*!< [21:18]  */
        uint32_t MCU_MAX_BURST_STOP : 1; /*!< [22]  */
        uint32_t CSI_VSYNC_DEST : 1;   /*!< [23]  */
        uint32_t DI0_COUNTER_RELEASE : 1; /*!< [24]  */
        uint32_t DI1_COUNTER_RELEASE : 1; /*!< [25]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_disp_gen_t;

/*!
 * @name Constants and macros for entire IPU_DISP_GEN register
 */
/*@{*/
#define HW_IPU_DISP_GEN_ADDR(x)  ((uintptr_t)(x) + 0xC4U)

#define HW_IPU_DISP_GEN(x)       (*(__IO hw_ipu_disp_gen_t *) HW_IPU_DISP_GEN_ADDR(x))
#define HW_IPU_DISP_GEN_RD(x)    (HW_IPU_DISP_GEN(x).U)
#define HW_IPU_DISP_GEN_WR(x, v) (HW_IPU_DISP_GEN(x).U = (v))
#define HW_IPU_DISP_GEN_SET(x, v) (HW_IPU_DISP_GEN_WR(x, HW_IPU_DISP_GEN_RD(x) |  (v)))
#define HW_IPU_DISP_GEN_CLR(x, v) (HW_IPU_DISP_GEN_WR(x, HW_IPU_DISP_GEN_RD(x) & ~(v)))
#define HW_IPU_DISP_GEN_TOG(x, v) (HW_IPU_DISP_GEN_WR(x, HW_IPU_DISP_GEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_GEN bitfields
 */

/*!
 * @name Register IPU_DISP_GEN, field DI0_DUAL_MODE[0] (RW)
 *
 * DI0 dual mode control
 *
 * Values:
 * - 1 - DI0 operates in dual mode
 * - 0 - DI0 is not in dual mode
 */
/*@{*/
#define BP_IPU_DISP_GEN_DI0_DUAL_MODE (0U) /*!< Bit position for IPU_DISP_GEN_DI0_DUAL_MODE. */
#define BM_IPU_DISP_GEN_DI0_DUAL_MODE (0x00000001U) /*!< Bit mask for IPU_DISP_GEN_DI0_DUAL_MODE. */
#define BS_IPU_DISP_GEN_DI0_DUAL_MODE (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DI0_DUAL_MODE. */

/*! @brief Read current value of the IPU_DISP_GEN_DI0_DUAL_MODE field. */
#define BR_IPU_DISP_GEN_DI0_DUAL_MODE(x) (HW_IPU_DISP_GEN(x).B.DI0_DUAL_MODE)

/*! @brief Format value for bitfield IPU_DISP_GEN_DI0_DUAL_MODE. */
#define BF_IPU_DISP_GEN_DI0_DUAL_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DI0_DUAL_MODE) & BM_IPU_DISP_GEN_DI0_DUAL_MODE)

/*! @brief Set the DI0_DUAL_MODE field to a new value. */
#define BW_IPU_DISP_GEN_DI0_DUAL_MODE(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DI0_DUAL_MODE) | BF_IPU_DISP_GEN_DI0_DUAL_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DI1_DUAL_MODE[1] (RW)
 *
 * DI1 dual mode control
 *
 * Values:
 * - 1 - DI1 operates in dual mode
 * - 0 - DI1 is not in dual mode
 */
/*@{*/
#define BP_IPU_DISP_GEN_DI1_DUAL_MODE (1U) /*!< Bit position for IPU_DISP_GEN_DI1_DUAL_MODE. */
#define BM_IPU_DISP_GEN_DI1_DUAL_MODE (0x00000002U) /*!< Bit mask for IPU_DISP_GEN_DI1_DUAL_MODE. */
#define BS_IPU_DISP_GEN_DI1_DUAL_MODE (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DI1_DUAL_MODE. */

/*! @brief Read current value of the IPU_DISP_GEN_DI1_DUAL_MODE field. */
#define BR_IPU_DISP_GEN_DI1_DUAL_MODE(x) (HW_IPU_DISP_GEN(x).B.DI1_DUAL_MODE)

/*! @brief Format value for bitfield IPU_DISP_GEN_DI1_DUAL_MODE. */
#define BF_IPU_DISP_GEN_DI1_DUAL_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DI1_DUAL_MODE) & BM_IPU_DISP_GEN_DI1_DUAL_MODE)

/*! @brief Set the DI1_DUAL_MODE field to a new value. */
#define BW_IPU_DISP_GEN_DI1_DUAL_MODE(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DI1_DUAL_MODE) | BF_IPU_DISP_GEN_DI1_DUAL_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DC2_DOUBLE_FLOW[2] (RW)
 *
 * DC2 Double Flow. This bit define how many flows are currently handles via DC2
 * channel (ch41)
 *
 * Values:
 * - 1 - 2 flows are handled via DC2
 * - 0 - single flow is handled via DC2
 */
/*@{*/
#define BP_IPU_DISP_GEN_DC2_DOUBLE_FLOW (2U) /*!< Bit position for IPU_DISP_GEN_DC2_DOUBLE_FLOW. */
#define BM_IPU_DISP_GEN_DC2_DOUBLE_FLOW (0x00000004U) /*!< Bit mask for IPU_DISP_GEN_DC2_DOUBLE_FLOW. */
#define BS_IPU_DISP_GEN_DC2_DOUBLE_FLOW (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DC2_DOUBLE_FLOW. */

/*! @brief Read current value of the IPU_DISP_GEN_DC2_DOUBLE_FLOW field. */
#define BR_IPU_DISP_GEN_DC2_DOUBLE_FLOW(x) (HW_IPU_DISP_GEN(x).B.DC2_DOUBLE_FLOW)

/*! @brief Format value for bitfield IPU_DISP_GEN_DC2_DOUBLE_FLOW. */
#define BF_IPU_DISP_GEN_DC2_DOUBLE_FLOW(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DC2_DOUBLE_FLOW) & BM_IPU_DISP_GEN_DC2_DOUBLE_FLOW)

/*! @brief Set the DC2_DOUBLE_FLOW field to a new value. */
#define BW_IPU_DISP_GEN_DC2_DOUBLE_FLOW(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DC2_DOUBLE_FLOW) | BF_IPU_DISP_GEN_DC2_DOUBLE_FLOW(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DP_ASYNC_DOUBLE_FLOW[3] (RW)
 *
 * DP Async Double Flow. This bit define how many async flows are currently
 * handles via DP channel (ch24+29)
 *
 * Values:
 * - 1 - 2 flows are handled via DP
 * - 0 - single flow is handled via DP
 */
/*@{*/
#define BP_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW (3U) /*!< Bit position for IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW. */
#define BM_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW (0x00000008U) /*!< Bit mask for IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW. */
#define BS_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW. */

/*! @brief Read current value of the IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW field. */
#define BR_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW(x) (HW_IPU_DISP_GEN(x).B.DP_ASYNC_DOUBLE_FLOW)

/*! @brief Format value for bitfield IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW. */
#define BF_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW) & BM_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW)

/*! @brief Set the DP_ASYNC_DOUBLE_FLOW field to a new value. */
#define BW_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW) | BF_IPU_DISP_GEN_DP_ASYNC_DOUBLE_FLOW(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DP_FG_EN_ASYNC0[4] (RW)
 *
 * FG_EN - partial plane Enable for async flow 0. This bit enables the partial
 * plane channel.
 *
 * Values:
 * - 1 - partial plane channel is enabled.
 * - 0 - partial plane channel is disabled.
 */
/*@{*/
#define BP_IPU_DISP_GEN_DP_FG_EN_ASYNC0 (4U) /*!< Bit position for IPU_DISP_GEN_DP_FG_EN_ASYNC0. */
#define BM_IPU_DISP_GEN_DP_FG_EN_ASYNC0 (0x00000010U) /*!< Bit mask for IPU_DISP_GEN_DP_FG_EN_ASYNC0. */
#define BS_IPU_DISP_GEN_DP_FG_EN_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DP_FG_EN_ASYNC0. */

/*! @brief Read current value of the IPU_DISP_GEN_DP_FG_EN_ASYNC0 field. */
#define BR_IPU_DISP_GEN_DP_FG_EN_ASYNC0(x) (HW_IPU_DISP_GEN(x).B.DP_FG_EN_ASYNC0)

/*! @brief Format value for bitfield IPU_DISP_GEN_DP_FG_EN_ASYNC0. */
#define BF_IPU_DISP_GEN_DP_FG_EN_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DP_FG_EN_ASYNC0) & BM_IPU_DISP_GEN_DP_FG_EN_ASYNC0)

/*! @brief Set the DP_FG_EN_ASYNC0 field to a new value. */
#define BW_IPU_DISP_GEN_DP_FG_EN_ASYNC0(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DP_FG_EN_ASYNC0) | BF_IPU_DISP_GEN_DP_FG_EN_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DP_FG_EN_ASYNC1[5] (RW)
 *
 * FG_EN - partial plane Enable for async flow 1. This bit enables the partial
 * plane channel.
 *
 * Values:
 * - 1 - partial plane channel is enabled.
 * - 0 - partial plane channel is disabled.
 */
/*@{*/
#define BP_IPU_DISP_GEN_DP_FG_EN_ASYNC1 (5U) /*!< Bit position for IPU_DISP_GEN_DP_FG_EN_ASYNC1. */
#define BM_IPU_DISP_GEN_DP_FG_EN_ASYNC1 (0x00000020U) /*!< Bit mask for IPU_DISP_GEN_DP_FG_EN_ASYNC1. */
#define BS_IPU_DISP_GEN_DP_FG_EN_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DP_FG_EN_ASYNC1. */

/*! @brief Read current value of the IPU_DISP_GEN_DP_FG_EN_ASYNC1 field. */
#define BR_IPU_DISP_GEN_DP_FG_EN_ASYNC1(x) (HW_IPU_DISP_GEN(x).B.DP_FG_EN_ASYNC1)

/*! @brief Format value for bitfield IPU_DISP_GEN_DP_FG_EN_ASYNC1. */
#define BF_IPU_DISP_GEN_DP_FG_EN_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DP_FG_EN_ASYNC1) & BM_IPU_DISP_GEN_DP_FG_EN_ASYNC1)

/*! @brief Set the DP_FG_EN_ASYNC1 field to a new value. */
#define BW_IPU_DISP_GEN_DP_FG_EN_ASYNC1(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DP_FG_EN_ASYNC1) | BF_IPU_DISP_GEN_DP_FG_EN_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DP_PIPE_CLR[6] (WORZ)
 *
 * DP Pipe Clear This bit clears the internal pipe of the DP. The user may use
 * this bit in case of an error condition This is a self clear bit
 *
 * Values:
 * - 1 - Clear the internal pipe of the DP
 * - 0 - Idle - does nothing
 */
/*@{*/
#define BP_IPU_DISP_GEN_DP_PIPE_CLR (6U)   /*!< Bit position for IPU_DISP_GEN_DP_PIPE_CLR. */
#define BM_IPU_DISP_GEN_DP_PIPE_CLR (0x00000040U) /*!< Bit mask for IPU_DISP_GEN_DP_PIPE_CLR. */
#define BS_IPU_DISP_GEN_DP_PIPE_CLR (1U)   /*!< Bit field size in bits for IPU_DISP_GEN_DP_PIPE_CLR. */

/*! @brief Format value for bitfield IPU_DISP_GEN_DP_PIPE_CLR. */
#define BF_IPU_DISP_GEN_DP_PIPE_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DP_PIPE_CLR) & BM_IPU_DISP_GEN_DP_PIPE_CLR)

/*! @brief Set the DP_PIPE_CLR field to a new value. */
#define BW_IPU_DISP_GEN_DP_PIPE_CLR(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DP_PIPE_CLR) | BF_IPU_DISP_GEN_DP_PIPE_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field MCU_DI_ID_8[16] (RW)
 *
 * MCU_DI_ID_8 - DI ID via DC channel 8. This bit defines the DI that the ARM
 * platform DC's access via channel #8
 *
 * Values:
 * - 1 - ARM platform accesses DC's channel #8 via DI1.
 * - 0 - ARM platform accesses DC's channel #8 via DI0.
 */
/*@{*/
#define BP_IPU_DISP_GEN_MCU_DI_ID_8 (16U)  /*!< Bit position for IPU_DISP_GEN_MCU_DI_ID_8. */
#define BM_IPU_DISP_GEN_MCU_DI_ID_8 (0x00010000U) /*!< Bit mask for IPU_DISP_GEN_MCU_DI_ID_8. */
#define BS_IPU_DISP_GEN_MCU_DI_ID_8 (1U)   /*!< Bit field size in bits for IPU_DISP_GEN_MCU_DI_ID_8. */

/*! @brief Read current value of the IPU_DISP_GEN_MCU_DI_ID_8 field. */
#define BR_IPU_DISP_GEN_MCU_DI_ID_8(x) (HW_IPU_DISP_GEN(x).B.MCU_DI_ID_8)

/*! @brief Format value for bitfield IPU_DISP_GEN_MCU_DI_ID_8. */
#define BF_IPU_DISP_GEN_MCU_DI_ID_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_MCU_DI_ID_8) & BM_IPU_DISP_GEN_MCU_DI_ID_8)

/*! @brief Set the MCU_DI_ID_8 field to a new value. */
#define BW_IPU_DISP_GEN_MCU_DI_ID_8(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_MCU_DI_ID_8) | BF_IPU_DISP_GEN_MCU_DI_ID_8(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field MCU_DI_ID_9[17] (RW)
 *
 * MCU_DI_ID_9 - DI ID via DC channel 9. This bit defines the DI that the ARM
 * platform DC's access via channel #9
 *
 * Values:
 * - 1 - ARM platform accesses DC's channel #9 via DI1.
 * - 0 - ARM platform accesses DC's channel #9 via DI0.
 */
/*@{*/
#define BP_IPU_DISP_GEN_MCU_DI_ID_9 (17U)  /*!< Bit position for IPU_DISP_GEN_MCU_DI_ID_9. */
#define BM_IPU_DISP_GEN_MCU_DI_ID_9 (0x00020000U) /*!< Bit mask for IPU_DISP_GEN_MCU_DI_ID_9. */
#define BS_IPU_DISP_GEN_MCU_DI_ID_9 (1U)   /*!< Bit field size in bits for IPU_DISP_GEN_MCU_DI_ID_9. */

/*! @brief Read current value of the IPU_DISP_GEN_MCU_DI_ID_9 field. */
#define BR_IPU_DISP_GEN_MCU_DI_ID_9(x) (HW_IPU_DISP_GEN(x).B.MCU_DI_ID_9)

/*! @brief Format value for bitfield IPU_DISP_GEN_MCU_DI_ID_9. */
#define BF_IPU_DISP_GEN_MCU_DI_ID_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_MCU_DI_ID_9) & BM_IPU_DISP_GEN_MCU_DI_ID_9)

/*! @brief Set the MCU_DI_ID_9 field to a new value. */
#define BW_IPU_DISP_GEN_MCU_DI_ID_9(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_MCU_DI_ID_9) | BF_IPU_DISP_GEN_MCU_DI_ID_9(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field MCU_T[21:18] (RW)
 *
 * The address space for accesses through the AHB-lite slave port is MB and it
 * is split internally (with 32MB resolution) according to bits [28:25] of the
 * address. Using the following notation: Address = (ID[31:29], MSB[28:25],
 * LSB[24:0]) The address is used as follows ("T" is a configurable integer between 0 and
 * 13): MSB<T: access to an external device, with address = (MSB, LSB)
 * T<=MSB<14: access to an external device, with address (MSB-T, LSB)
 */
/*@{*/
#define BP_IPU_DISP_GEN_MCU_T (18U)        /*!< Bit position for IPU_DISP_GEN_MCU_T. */
#define BM_IPU_DISP_GEN_MCU_T (0x003C0000U) /*!< Bit mask for IPU_DISP_GEN_MCU_T. */
#define BS_IPU_DISP_GEN_MCU_T (4U)         /*!< Bit field size in bits for IPU_DISP_GEN_MCU_T. */

/*! @brief Read current value of the IPU_DISP_GEN_MCU_T field. */
#define BR_IPU_DISP_GEN_MCU_T(x) (HW_IPU_DISP_GEN(x).B.MCU_T)

/*! @brief Format value for bitfield IPU_DISP_GEN_MCU_T. */
#define BF_IPU_DISP_GEN_MCU_T(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_MCU_T) & BM_IPU_DISP_GEN_MCU_T)

/*! @brief Set the MCU_T field to a new value. */
#define BW_IPU_DISP_GEN_MCU_T(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_MCU_T) | BF_IPU_DISP_GEN_MCU_T(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field MCU_MAX_BURST_STOP[22] (RW)
 *
 * ARM platform Maximal burst This bit limit the maximal unspecified length
 * burst.
 *
 * Values:
 * - 1 - The maximum unspecified burst length is 8-beat
 * - 0 - The unspecified burst length is unlimited
 */
/*@{*/
#define BP_IPU_DISP_GEN_MCU_MAX_BURST_STOP (22U) /*!< Bit position for IPU_DISP_GEN_MCU_MAX_BURST_STOP. */
#define BM_IPU_DISP_GEN_MCU_MAX_BURST_STOP (0x00400000U) /*!< Bit mask for IPU_DISP_GEN_MCU_MAX_BURST_STOP. */
#define BS_IPU_DISP_GEN_MCU_MAX_BURST_STOP (1U) /*!< Bit field size in bits for IPU_DISP_GEN_MCU_MAX_BURST_STOP. */

/*! @brief Read current value of the IPU_DISP_GEN_MCU_MAX_BURST_STOP field. */
#define BR_IPU_DISP_GEN_MCU_MAX_BURST_STOP(x) (HW_IPU_DISP_GEN(x).B.MCU_MAX_BURST_STOP)

/*! @brief Format value for bitfield IPU_DISP_GEN_MCU_MAX_BURST_STOP. */
#define BF_IPU_DISP_GEN_MCU_MAX_BURST_STOP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_MCU_MAX_BURST_STOP) & BM_IPU_DISP_GEN_MCU_MAX_BURST_STOP)

/*! @brief Set the MCU_MAX_BURST_STOP field to a new value. */
#define BW_IPU_DISP_GEN_MCU_MAX_BURST_STOP(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_MCU_MAX_BURST_STOP) | BF_IPU_DISP_GEN_MCU_MAX_BURST_STOP(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field CSI_VSYNC_DEST[23] (RW)
 *
 * CSI_VSYNC destination This bit defines the destination of the VSYNC coming
 * from the CSI's
 *
 * Values:
 * - 1 - csi1_vsync is connected to DI0; csi0_vsync is connected to DI1
 * - 0 - csi0_vsync is connected to DI0; csi1_vsync is connected to DI1
 */
/*@{*/
#define BP_IPU_DISP_GEN_CSI_VSYNC_DEST (23U) /*!< Bit position for IPU_DISP_GEN_CSI_VSYNC_DEST. */
#define BM_IPU_DISP_GEN_CSI_VSYNC_DEST (0x00800000U) /*!< Bit mask for IPU_DISP_GEN_CSI_VSYNC_DEST. */
#define BS_IPU_DISP_GEN_CSI_VSYNC_DEST (1U) /*!< Bit field size in bits for IPU_DISP_GEN_CSI_VSYNC_DEST. */

/*! @brief Read current value of the IPU_DISP_GEN_CSI_VSYNC_DEST field. */
#define BR_IPU_DISP_GEN_CSI_VSYNC_DEST(x) (HW_IPU_DISP_GEN(x).B.CSI_VSYNC_DEST)

/*! @brief Format value for bitfield IPU_DISP_GEN_CSI_VSYNC_DEST. */
#define BF_IPU_DISP_GEN_CSI_VSYNC_DEST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_CSI_VSYNC_DEST) & BM_IPU_DISP_GEN_CSI_VSYNC_DEST)

/*! @brief Set the CSI_VSYNC_DEST field to a new value. */
#define BW_IPU_DISP_GEN_CSI_VSYNC_DEST(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_CSI_VSYNC_DEST) | BF_IPU_DISP_GEN_CSI_VSYNC_DEST(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DI0_COUNTER_RELEASE[24] (RW)
 *
 * DI1 Counter release By default the DI0 counters responsible for waveform
 * generation for sync flow are frozen. For the first attempt to use the DI in sync
 * flow the user should set this bit
 *
 * Values:
 * - 1 - counter is released and running
 * - 0 - counter is cleared and stopped
 */
/*@{*/
#define BP_IPU_DISP_GEN_DI0_COUNTER_RELEASE (24U) /*!< Bit position for IPU_DISP_GEN_DI0_COUNTER_RELEASE. */
#define BM_IPU_DISP_GEN_DI0_COUNTER_RELEASE (0x01000000U) /*!< Bit mask for IPU_DISP_GEN_DI0_COUNTER_RELEASE. */
#define BS_IPU_DISP_GEN_DI0_COUNTER_RELEASE (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DI0_COUNTER_RELEASE. */

/*! @brief Read current value of the IPU_DISP_GEN_DI0_COUNTER_RELEASE field. */
#define BR_IPU_DISP_GEN_DI0_COUNTER_RELEASE(x) (HW_IPU_DISP_GEN(x).B.DI0_COUNTER_RELEASE)

/*! @brief Format value for bitfield IPU_DISP_GEN_DI0_COUNTER_RELEASE. */
#define BF_IPU_DISP_GEN_DI0_COUNTER_RELEASE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DI0_COUNTER_RELEASE) & BM_IPU_DISP_GEN_DI0_COUNTER_RELEASE)

/*! @brief Set the DI0_COUNTER_RELEASE field to a new value. */
#define BW_IPU_DISP_GEN_DI0_COUNTER_RELEASE(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DI0_COUNTER_RELEASE) | BF_IPU_DISP_GEN_DI0_COUNTER_RELEASE(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_GEN, field DI1_COUNTER_RELEASE[25] (RW)
 *
 * DI1 Counter release By default the DI0 counters responsible for waveform
 * generation for sync flow are frozen. For the first attempt to use the DI in sync
 * flow the user should set this bit
 *
 * Values:
 * - 1 - counter is released and running
 * - 0 - counter is cleared and stopped
 */
/*@{*/
#define BP_IPU_DISP_GEN_DI1_COUNTER_RELEASE (25U) /*!< Bit position for IPU_DISP_GEN_DI1_COUNTER_RELEASE. */
#define BM_IPU_DISP_GEN_DI1_COUNTER_RELEASE (0x02000000U) /*!< Bit mask for IPU_DISP_GEN_DI1_COUNTER_RELEASE. */
#define BS_IPU_DISP_GEN_DI1_COUNTER_RELEASE (1U) /*!< Bit field size in bits for IPU_DISP_GEN_DI1_COUNTER_RELEASE. */

/*! @brief Read current value of the IPU_DISP_GEN_DI1_COUNTER_RELEASE field. */
#define BR_IPU_DISP_GEN_DI1_COUNTER_RELEASE(x) (HW_IPU_DISP_GEN(x).B.DI1_COUNTER_RELEASE)

/*! @brief Format value for bitfield IPU_DISP_GEN_DI1_COUNTER_RELEASE. */
#define BF_IPU_DISP_GEN_DI1_COUNTER_RELEASE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_GEN_DI1_COUNTER_RELEASE) & BM_IPU_DISP_GEN_DI1_COUNTER_RELEASE)

/*! @brief Set the DI1_COUNTER_RELEASE field to a new value. */
#define BW_IPU_DISP_GEN_DI1_COUNTER_RELEASE(x, v) (HW_IPU_DISP_GEN_WR(x, (HW_IPU_DISP_GEN_RD(x) & ~BM_IPU_DISP_GEN_DI1_COUNTER_RELEASE) | BF_IPU_DISP_GEN_DI1_COUNTER_RELEASE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_ALT1 - Display Alternate Flow Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_ALT1 - Display Alternate Flow Control Register 1 (RW)
 *
 * Reset value: 0x00400000U
 *
 * This register controls various aspects of the display port.
 */
typedef union _hw_ipu_disp_alt1
{
    uint32_t U;
    struct _hw_ipu_disp_alt1_bitfields
    {
        uint32_t run_value_m1_alt_0 : 12; /*!< [11:0]  */
        uint32_t cnt_clr_sel_alt_0 : 3; /*!< [14:12]  */
        uint32_t cnt_auto_reload_alt_0 : 1; /*!< [15]  */
        uint32_t step_repeat_alt_0 : 12; /*!< [27:16]  */
        uint32_t sel_alt_0 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_disp_alt1_t;

/*!
 * @name Constants and macros for entire IPU_DISP_ALT1 register
 */
/*@{*/
#define HW_IPU_DISP_ALT1_ADDR(x) ((uintptr_t)(x) + 0xC8U)

#define HW_IPU_DISP_ALT1(x)      (*(__IO hw_ipu_disp_alt1_t *) HW_IPU_DISP_ALT1_ADDR(x))
#define HW_IPU_DISP_ALT1_RD(x)   (HW_IPU_DISP_ALT1(x).U)
#define HW_IPU_DISP_ALT1_WR(x, v) (HW_IPU_DISP_ALT1(x).U = (v))
#define HW_IPU_DISP_ALT1_SET(x, v) (HW_IPU_DISP_ALT1_WR(x, HW_IPU_DISP_ALT1_RD(x) |  (v)))
#define HW_IPU_DISP_ALT1_CLR(x, v) (HW_IPU_DISP_ALT1_WR(x, HW_IPU_DISP_ALT1_RD(x) & ~(v)))
#define HW_IPU_DISP_ALT1_TOG(x, v) (HW_IPU_DISP_ALT1_WR(x, HW_IPU_DISP_ALT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_ALT1 bitfields
 */

/*!
 * @name Register IPU_DISP_ALT1, field run_value_m1_alt_0[11:0] (RW)
 *
 * Counter pre defined value This fields defines the counter pre defines value.
 * real value- 1
 */
/*@{*/
#define BP_IPU_DISP_ALT1_run_value_m1_alt_0 (0U) /*!< Bit position for IPU_DISP_ALT1_run_value_m1_alt_0. */
#define BM_IPU_DISP_ALT1_run_value_m1_alt_0 (0x00000FFFU) /*!< Bit mask for IPU_DISP_ALT1_run_value_m1_alt_0. */
#define BS_IPU_DISP_ALT1_run_value_m1_alt_0 (12U) /*!< Bit field size in bits for IPU_DISP_ALT1_run_value_m1_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT1_run_value_m1_alt_0 field. */
#define BR_IPU_DISP_ALT1_run_value_m1_alt_0(x) (HW_IPU_DISP_ALT1(x).B.run_value_m1_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT1_run_value_m1_alt_0. */
#define BF_IPU_DISP_ALT1_run_value_m1_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT1_run_value_m1_alt_0) & BM_IPU_DISP_ALT1_run_value_m1_alt_0)

/*! @brief Set the run_value_m1_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT1_run_value_m1_alt_0(x, v) (HW_IPU_DISP_ALT1_WR(x, (HW_IPU_DISP_ALT1_RD(x) & ~BM_IPU_DISP_ALT1_run_value_m1_alt_0) | BF_IPU_DISP_ALT1_run_value_m1_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT1, field cnt_clr_sel_alt_0[14:12] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DISP_ALT1_cnt_clr_sel_alt_0 (12U) /*!< Bit position for IPU_DISP_ALT1_cnt_clr_sel_alt_0. */
#define BM_IPU_DISP_ALT1_cnt_clr_sel_alt_0 (0x00007000U) /*!< Bit mask for IPU_DISP_ALT1_cnt_clr_sel_alt_0. */
#define BS_IPU_DISP_ALT1_cnt_clr_sel_alt_0 (3U) /*!< Bit field size in bits for IPU_DISP_ALT1_cnt_clr_sel_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT1_cnt_clr_sel_alt_0 field. */
#define BR_IPU_DISP_ALT1_cnt_clr_sel_alt_0(x) (HW_IPU_DISP_ALT1(x).B.cnt_clr_sel_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT1_cnt_clr_sel_alt_0. */
#define BF_IPU_DISP_ALT1_cnt_clr_sel_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT1_cnt_clr_sel_alt_0) & BM_IPU_DISP_ALT1_cnt_clr_sel_alt_0)

/*! @brief Set the cnt_clr_sel_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT1_cnt_clr_sel_alt_0(x, v) (HW_IPU_DISP_ALT1_WR(x, (HW_IPU_DISP_ALT1_RD(x) & ~BM_IPU_DISP_ALT1_cnt_clr_sel_alt_0) | BF_IPU_DISP_ALT1_cnt_clr_sel_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT1, field cnt_auto_reload_alt_0[15] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the step_repeat_alt_0 field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the step_repeat_alt_0 field
 */
/*@{*/
#define BP_IPU_DISP_ALT1_cnt_auto_reload_alt_0 (15U) /*!< Bit position for IPU_DISP_ALT1_cnt_auto_reload_alt_0. */
#define BM_IPU_DISP_ALT1_cnt_auto_reload_alt_0 (0x00008000U) /*!< Bit mask for IPU_DISP_ALT1_cnt_auto_reload_alt_0. */
#define BS_IPU_DISP_ALT1_cnt_auto_reload_alt_0 (1U) /*!< Bit field size in bits for IPU_DISP_ALT1_cnt_auto_reload_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT1_cnt_auto_reload_alt_0 field. */
#define BR_IPU_DISP_ALT1_cnt_auto_reload_alt_0(x) (HW_IPU_DISP_ALT1(x).B.cnt_auto_reload_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT1_cnt_auto_reload_alt_0. */
#define BF_IPU_DISP_ALT1_cnt_auto_reload_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT1_cnt_auto_reload_alt_0) & BM_IPU_DISP_ALT1_cnt_auto_reload_alt_0)

/*! @brief Set the cnt_auto_reload_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT1_cnt_auto_reload_alt_0(x, v) (HW_IPU_DISP_ALT1_WR(x, (HW_IPU_DISP_ALT1_RD(x) & ~BM_IPU_DISP_ALT1_cnt_auto_reload_alt_0) | BF_IPU_DISP_ALT1_cnt_auto_reload_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT1, field step_repeat_alt_0[27:16] (RW)
 *
 * This fields defines the amount of repetitions that will be performed by the
 * counter
 */
/*@{*/
#define BP_IPU_DISP_ALT1_step_repeat_alt_0 (16U) /*!< Bit position for IPU_DISP_ALT1_step_repeat_alt_0. */
#define BM_IPU_DISP_ALT1_step_repeat_alt_0 (0x0FFF0000U) /*!< Bit mask for IPU_DISP_ALT1_step_repeat_alt_0. */
#define BS_IPU_DISP_ALT1_step_repeat_alt_0 (12U) /*!< Bit field size in bits for IPU_DISP_ALT1_step_repeat_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT1_step_repeat_alt_0 field. */
#define BR_IPU_DISP_ALT1_step_repeat_alt_0(x) (HW_IPU_DISP_ALT1(x).B.step_repeat_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT1_step_repeat_alt_0. */
#define BF_IPU_DISP_ALT1_step_repeat_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT1_step_repeat_alt_0) & BM_IPU_DISP_ALT1_step_repeat_alt_0)

/*! @brief Set the step_repeat_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT1_step_repeat_alt_0(x, v) (HW_IPU_DISP_ALT1_WR(x, (HW_IPU_DISP_ALT1_RD(x) & ~BM_IPU_DISP_ALT1_step_repeat_alt_0) | BF_IPU_DISP_ALT1_step_repeat_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT1, field sel_alt_0[31:28] (RW)
 *
 * Select alternative parameters instead of DI Sync Wave Gen counter#. The DI is
 * selected according to DP's synchronous channel destination 0000-disable
 *
 * Values:
 * - 0001 - instead of counter 1
 * - 0010 - instead of counter 2
 * - 1000 - instead of counter 8
 */
/*@{*/
#define BP_IPU_DISP_ALT1_sel_alt_0 (28U)   /*!< Bit position for IPU_DISP_ALT1_sel_alt_0. */
#define BM_IPU_DISP_ALT1_sel_alt_0 (0xF0000000U) /*!< Bit mask for IPU_DISP_ALT1_sel_alt_0. */
#define BS_IPU_DISP_ALT1_sel_alt_0 (4U)    /*!< Bit field size in bits for IPU_DISP_ALT1_sel_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT1_sel_alt_0 field. */
#define BR_IPU_DISP_ALT1_sel_alt_0(x) (HW_IPU_DISP_ALT1(x).B.sel_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT1_sel_alt_0. */
#define BF_IPU_DISP_ALT1_sel_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT1_sel_alt_0) & BM_IPU_DISP_ALT1_sel_alt_0)

/*! @brief Set the sel_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT1_sel_alt_0(x, v) (HW_IPU_DISP_ALT1_WR(x, (HW_IPU_DISP_ALT1_RD(x) & ~BM_IPU_DISP_ALT1_sel_alt_0) | BF_IPU_DISP_ALT1_sel_alt_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_ALT2 - Display Alternate Flow Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_ALT2 - Display Alternate Flow Control Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls various aspects of the display port.
 */
typedef union _hw_ipu_disp_alt2
{
    uint32_t U;
    struct _hw_ipu_disp_alt2_bitfields
    {
        uint32_t offset_value_alt_0 : 12; /*!< [11:0]  */
        uint32_t offset_resolution_alt_0 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t run_resolution_alt_0 : 3; /*!< [18:16]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_disp_alt2_t;

/*!
 * @name Constants and macros for entire IPU_DISP_ALT2 register
 */
/*@{*/
#define HW_IPU_DISP_ALT2_ADDR(x) ((uintptr_t)(x) + 0xCCU)

#define HW_IPU_DISP_ALT2(x)      (*(__IO hw_ipu_disp_alt2_t *) HW_IPU_DISP_ALT2_ADDR(x))
#define HW_IPU_DISP_ALT2_RD(x)   (HW_IPU_DISP_ALT2(x).U)
#define HW_IPU_DISP_ALT2_WR(x, v) (HW_IPU_DISP_ALT2(x).U = (v))
#define HW_IPU_DISP_ALT2_SET(x, v) (HW_IPU_DISP_ALT2_WR(x, HW_IPU_DISP_ALT2_RD(x) |  (v)))
#define HW_IPU_DISP_ALT2_CLR(x, v) (HW_IPU_DISP_ALT2_WR(x, HW_IPU_DISP_ALT2_RD(x) & ~(v)))
#define HW_IPU_DISP_ALT2_TOG(x, v) (HW_IPU_DISP_ALT2_WR(x, HW_IPU_DISP_ALT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_ALT2 bitfields
 */

/*!
 * @name Register IPU_DISP_ALT2, field offset_value_alt_0[11:0] (RW)
 *
 * Counter offset value The counter can start counting after a pre defined delay
 * This field defines the amount of cycles that the counter will be delayed by
 */
/*@{*/
#define BP_IPU_DISP_ALT2_offset_value_alt_0 (0U) /*!< Bit position for IPU_DISP_ALT2_offset_value_alt_0. */
#define BM_IPU_DISP_ALT2_offset_value_alt_0 (0x00000FFFU) /*!< Bit mask for IPU_DISP_ALT2_offset_value_alt_0. */
#define BS_IPU_DISP_ALT2_offset_value_alt_0 (12U) /*!< Bit field size in bits for IPU_DISP_ALT2_offset_value_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT2_offset_value_alt_0 field. */
#define BR_IPU_DISP_ALT2_offset_value_alt_0(x) (HW_IPU_DISP_ALT2(x).B.offset_value_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT2_offset_value_alt_0. */
#define BF_IPU_DISP_ALT2_offset_value_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT2_offset_value_alt_0) & BM_IPU_DISP_ALT2_offset_value_alt_0)

/*! @brief Set the offset_value_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT2_offset_value_alt_0(x, v) (HW_IPU_DISP_ALT2_WR(x, (HW_IPU_DISP_ALT2_RD(x) & ~BM_IPU_DISP_ALT2_offset_value_alt_0) | BF_IPU_DISP_ALT2_offset_value_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT2, field offset_resolution_alt_0[14:12] (RW)
 *
 * Counter offset Resolution This field defines the trigger causing the offset
 * counter to increment The counter offset resolution should be defined in the
 * same way as in original DI's counter#
 */
/*@{*/
#define BP_IPU_DISP_ALT2_offset_resolution_alt_0 (12U) /*!< Bit position for IPU_DISP_ALT2_offset_resolution_alt_0. */
#define BM_IPU_DISP_ALT2_offset_resolution_alt_0 (0x00007000U) /*!< Bit mask for IPU_DISP_ALT2_offset_resolution_alt_0. */
#define BS_IPU_DISP_ALT2_offset_resolution_alt_0 (3U) /*!< Bit field size in bits for IPU_DISP_ALT2_offset_resolution_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT2_offset_resolution_alt_0 field. */
#define BR_IPU_DISP_ALT2_offset_resolution_alt_0(x) (HW_IPU_DISP_ALT2(x).B.offset_resolution_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT2_offset_resolution_alt_0. */
#define BF_IPU_DISP_ALT2_offset_resolution_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT2_offset_resolution_alt_0) & BM_IPU_DISP_ALT2_offset_resolution_alt_0)

/*! @brief Set the offset_resolution_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT2_offset_resolution_alt_0(x, v) (HW_IPU_DISP_ALT2_WR(x, (HW_IPU_DISP_ALT2_RD(x) & ~BM_IPU_DISP_ALT2_offset_resolution_alt_0) | BF_IPU_DISP_ALT2_offset_resolution_alt_0(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT2, field run_resolution_alt_0[18:16] (RW)
 *
 * Counter Run Resolution This field defines the trigger causing the counter to
 * increment. The counter run resolution should be defined in the same way as in
 * original DI's counter#
 */
/*@{*/
#define BP_IPU_DISP_ALT2_run_resolution_alt_0 (16U) /*!< Bit position for IPU_DISP_ALT2_run_resolution_alt_0. */
#define BM_IPU_DISP_ALT2_run_resolution_alt_0 (0x00070000U) /*!< Bit mask for IPU_DISP_ALT2_run_resolution_alt_0. */
#define BS_IPU_DISP_ALT2_run_resolution_alt_0 (3U) /*!< Bit field size in bits for IPU_DISP_ALT2_run_resolution_alt_0. */

/*! @brief Read current value of the IPU_DISP_ALT2_run_resolution_alt_0 field. */
#define BR_IPU_DISP_ALT2_run_resolution_alt_0(x) (HW_IPU_DISP_ALT2(x).B.run_resolution_alt_0)

/*! @brief Format value for bitfield IPU_DISP_ALT2_run_resolution_alt_0. */
#define BF_IPU_DISP_ALT2_run_resolution_alt_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT2_run_resolution_alt_0) & BM_IPU_DISP_ALT2_run_resolution_alt_0)

/*! @brief Set the run_resolution_alt_0 field to a new value. */
#define BW_IPU_DISP_ALT2_run_resolution_alt_0(x, v) (HW_IPU_DISP_ALT2_WR(x, (HW_IPU_DISP_ALT2_RD(x) & ~BM_IPU_DISP_ALT2_run_resolution_alt_0) | BF_IPU_DISP_ALT2_run_resolution_alt_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_ALT3 - Display Alternate Flow Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_ALT3 - Display Alternate Flow Control Register 3 (RW)
 *
 * Reset value: 0x00400000U
 *
 * This register controls various aspects of the display port.
 */
typedef union _hw_ipu_disp_alt3
{
    uint32_t U;
    struct _hw_ipu_disp_alt3_bitfields
    {
        uint32_t run_value_m1_alt_1 : 12; /*!< [11:0]  */
        uint32_t cnt_clr_sel_alt_1 : 3; /*!< [14:12]  */
        uint32_t cnt_auto_reload_alt_1 : 1; /*!< [15]  */
        uint32_t step_repeat_alt_1 : 12; /*!< [27:16]  */
        uint32_t sel_alt_1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_disp_alt3_t;

/*!
 * @name Constants and macros for entire IPU_DISP_ALT3 register
 */
/*@{*/
#define HW_IPU_DISP_ALT3_ADDR(x) ((uintptr_t)(x) + 0xD0U)

#define HW_IPU_DISP_ALT3(x)      (*(__IO hw_ipu_disp_alt3_t *) HW_IPU_DISP_ALT3_ADDR(x))
#define HW_IPU_DISP_ALT3_RD(x)   (HW_IPU_DISP_ALT3(x).U)
#define HW_IPU_DISP_ALT3_WR(x, v) (HW_IPU_DISP_ALT3(x).U = (v))
#define HW_IPU_DISP_ALT3_SET(x, v) (HW_IPU_DISP_ALT3_WR(x, HW_IPU_DISP_ALT3_RD(x) |  (v)))
#define HW_IPU_DISP_ALT3_CLR(x, v) (HW_IPU_DISP_ALT3_WR(x, HW_IPU_DISP_ALT3_RD(x) & ~(v)))
#define HW_IPU_DISP_ALT3_TOG(x, v) (HW_IPU_DISP_ALT3_WR(x, HW_IPU_DISP_ALT3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_ALT3 bitfields
 */

/*!
 * @name Register IPU_DISP_ALT3, field run_value_m1_alt_1[11:0] (RW)
 *
 * Counter pre defined value This fields defines the counter pre defines value.
 * real value- 1
 */
/*@{*/
#define BP_IPU_DISP_ALT3_run_value_m1_alt_1 (0U) /*!< Bit position for IPU_DISP_ALT3_run_value_m1_alt_1. */
#define BM_IPU_DISP_ALT3_run_value_m1_alt_1 (0x00000FFFU) /*!< Bit mask for IPU_DISP_ALT3_run_value_m1_alt_1. */
#define BS_IPU_DISP_ALT3_run_value_m1_alt_1 (12U) /*!< Bit field size in bits for IPU_DISP_ALT3_run_value_m1_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT3_run_value_m1_alt_1 field. */
#define BR_IPU_DISP_ALT3_run_value_m1_alt_1(x) (HW_IPU_DISP_ALT3(x).B.run_value_m1_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT3_run_value_m1_alt_1. */
#define BF_IPU_DISP_ALT3_run_value_m1_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT3_run_value_m1_alt_1) & BM_IPU_DISP_ALT3_run_value_m1_alt_1)

/*! @brief Set the run_value_m1_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT3_run_value_m1_alt_1(x, v) (HW_IPU_DISP_ALT3_WR(x, (HW_IPU_DISP_ALT3_RD(x) & ~BM_IPU_DISP_ALT3_run_value_m1_alt_1) | BF_IPU_DISP_ALT3_run_value_m1_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT3, field cnt_clr_sel_alt_1[14:12] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DISP_ALT3_cnt_clr_sel_alt_1 (12U) /*!< Bit position for IPU_DISP_ALT3_cnt_clr_sel_alt_1. */
#define BM_IPU_DISP_ALT3_cnt_clr_sel_alt_1 (0x00007000U) /*!< Bit mask for IPU_DISP_ALT3_cnt_clr_sel_alt_1. */
#define BS_IPU_DISP_ALT3_cnt_clr_sel_alt_1 (3U) /*!< Bit field size in bits for IPU_DISP_ALT3_cnt_clr_sel_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT3_cnt_clr_sel_alt_1 field. */
#define BR_IPU_DISP_ALT3_cnt_clr_sel_alt_1(x) (HW_IPU_DISP_ALT3(x).B.cnt_clr_sel_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT3_cnt_clr_sel_alt_1. */
#define BF_IPU_DISP_ALT3_cnt_clr_sel_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT3_cnt_clr_sel_alt_1) & BM_IPU_DISP_ALT3_cnt_clr_sel_alt_1)

/*! @brief Set the cnt_clr_sel_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT3_cnt_clr_sel_alt_1(x, v) (HW_IPU_DISP_ALT3_WR(x, (HW_IPU_DISP_ALT3_RD(x) & ~BM_IPU_DISP_ALT3_cnt_clr_sel_alt_1) | BF_IPU_DISP_ALT3_cnt_clr_sel_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT3, field cnt_auto_reload_alt_1[15] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the step_repeat_alt_0 field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the step_repeat_alt_0 field
 */
/*@{*/
#define BP_IPU_DISP_ALT3_cnt_auto_reload_alt_1 (15U) /*!< Bit position for IPU_DISP_ALT3_cnt_auto_reload_alt_1. */
#define BM_IPU_DISP_ALT3_cnt_auto_reload_alt_1 (0x00008000U) /*!< Bit mask for IPU_DISP_ALT3_cnt_auto_reload_alt_1. */
#define BS_IPU_DISP_ALT3_cnt_auto_reload_alt_1 (1U) /*!< Bit field size in bits for IPU_DISP_ALT3_cnt_auto_reload_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT3_cnt_auto_reload_alt_1 field. */
#define BR_IPU_DISP_ALT3_cnt_auto_reload_alt_1(x) (HW_IPU_DISP_ALT3(x).B.cnt_auto_reload_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT3_cnt_auto_reload_alt_1. */
#define BF_IPU_DISP_ALT3_cnt_auto_reload_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT3_cnt_auto_reload_alt_1) & BM_IPU_DISP_ALT3_cnt_auto_reload_alt_1)

/*! @brief Set the cnt_auto_reload_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT3_cnt_auto_reload_alt_1(x, v) (HW_IPU_DISP_ALT3_WR(x, (HW_IPU_DISP_ALT3_RD(x) & ~BM_IPU_DISP_ALT3_cnt_auto_reload_alt_1) | BF_IPU_DISP_ALT3_cnt_auto_reload_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT3, field step_repeat_alt_1[27:16] (RW)
 *
 * This fields defines the amount of repetitions that will be performed by the
 * counter
 */
/*@{*/
#define BP_IPU_DISP_ALT3_step_repeat_alt_1 (16U) /*!< Bit position for IPU_DISP_ALT3_step_repeat_alt_1. */
#define BM_IPU_DISP_ALT3_step_repeat_alt_1 (0x0FFF0000U) /*!< Bit mask for IPU_DISP_ALT3_step_repeat_alt_1. */
#define BS_IPU_DISP_ALT3_step_repeat_alt_1 (12U) /*!< Bit field size in bits for IPU_DISP_ALT3_step_repeat_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT3_step_repeat_alt_1 field. */
#define BR_IPU_DISP_ALT3_step_repeat_alt_1(x) (HW_IPU_DISP_ALT3(x).B.step_repeat_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT3_step_repeat_alt_1. */
#define BF_IPU_DISP_ALT3_step_repeat_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT3_step_repeat_alt_1) & BM_IPU_DISP_ALT3_step_repeat_alt_1)

/*! @brief Set the step_repeat_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT3_step_repeat_alt_1(x, v) (HW_IPU_DISP_ALT3_WR(x, (HW_IPU_DISP_ALT3_RD(x) & ~BM_IPU_DISP_ALT3_step_repeat_alt_1) | BF_IPU_DISP_ALT3_step_repeat_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT3, field sel_alt_1[31:28] (RW)
 *
 * Select alternative parameters instead of DI Sync Wave Gen counter#. The DI is
 * selected according to DP's synchronous channel destination
 *
 * Values:
 * - 0000 - disable
 * - 0001 - instead of counter 1
 * - 0010 - instead of counter 2
 * - 1000 - instead of counter 8
 */
/*@{*/
#define BP_IPU_DISP_ALT3_sel_alt_1 (28U)   /*!< Bit position for IPU_DISP_ALT3_sel_alt_1. */
#define BM_IPU_DISP_ALT3_sel_alt_1 (0xF0000000U) /*!< Bit mask for IPU_DISP_ALT3_sel_alt_1. */
#define BS_IPU_DISP_ALT3_sel_alt_1 (4U)    /*!< Bit field size in bits for IPU_DISP_ALT3_sel_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT3_sel_alt_1 field. */
#define BR_IPU_DISP_ALT3_sel_alt_1(x) (HW_IPU_DISP_ALT3(x).B.sel_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT3_sel_alt_1. */
#define BF_IPU_DISP_ALT3_sel_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT3_sel_alt_1) & BM_IPU_DISP_ALT3_sel_alt_1)

/*! @brief Set the sel_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT3_sel_alt_1(x, v) (HW_IPU_DISP_ALT3_WR(x, (HW_IPU_DISP_ALT3_RD(x) & ~BM_IPU_DISP_ALT3_sel_alt_1) | BF_IPU_DISP_ALT3_sel_alt_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_ALT4 - Display Alternate Flow Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_ALT4 - Display Alternate Flow Control Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls various aspects of the display port.
 */
typedef union _hw_ipu_disp_alt4
{
    uint32_t U;
    struct _hw_ipu_disp_alt4_bitfields
    {
        uint32_t offset_value_alt_1 : 12; /*!< [11:0]  */
        uint32_t offset_resolution_alt_1 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t run_resolution_alt_1 : 3; /*!< [18:16]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_disp_alt4_t;

/*!
 * @name Constants and macros for entire IPU_DISP_ALT4 register
 */
/*@{*/
#define HW_IPU_DISP_ALT4_ADDR(x) ((uintptr_t)(x) + 0xD4U)

#define HW_IPU_DISP_ALT4(x)      (*(__IO hw_ipu_disp_alt4_t *) HW_IPU_DISP_ALT4_ADDR(x))
#define HW_IPU_DISP_ALT4_RD(x)   (HW_IPU_DISP_ALT4(x).U)
#define HW_IPU_DISP_ALT4_WR(x, v) (HW_IPU_DISP_ALT4(x).U = (v))
#define HW_IPU_DISP_ALT4_SET(x, v) (HW_IPU_DISP_ALT4_WR(x, HW_IPU_DISP_ALT4_RD(x) |  (v)))
#define HW_IPU_DISP_ALT4_CLR(x, v) (HW_IPU_DISP_ALT4_WR(x, HW_IPU_DISP_ALT4_RD(x) & ~(v)))
#define HW_IPU_DISP_ALT4_TOG(x, v) (HW_IPU_DISP_ALT4_WR(x, HW_IPU_DISP_ALT4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_ALT4 bitfields
 */

/*!
 * @name Register IPU_DISP_ALT4, field offset_value_alt_1[11:0] (RW)
 *
 * Counter offset value The counter can start counting after a pre defined delay
 * This field defines the amount of cycles that the counter will be delayed by
 */
/*@{*/
#define BP_IPU_DISP_ALT4_offset_value_alt_1 (0U) /*!< Bit position for IPU_DISP_ALT4_offset_value_alt_1. */
#define BM_IPU_DISP_ALT4_offset_value_alt_1 (0x00000FFFU) /*!< Bit mask for IPU_DISP_ALT4_offset_value_alt_1. */
#define BS_IPU_DISP_ALT4_offset_value_alt_1 (12U) /*!< Bit field size in bits for IPU_DISP_ALT4_offset_value_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT4_offset_value_alt_1 field. */
#define BR_IPU_DISP_ALT4_offset_value_alt_1(x) (HW_IPU_DISP_ALT4(x).B.offset_value_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT4_offset_value_alt_1. */
#define BF_IPU_DISP_ALT4_offset_value_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT4_offset_value_alt_1) & BM_IPU_DISP_ALT4_offset_value_alt_1)

/*! @brief Set the offset_value_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT4_offset_value_alt_1(x, v) (HW_IPU_DISP_ALT4_WR(x, (HW_IPU_DISP_ALT4_RD(x) & ~BM_IPU_DISP_ALT4_offset_value_alt_1) | BF_IPU_DISP_ALT4_offset_value_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT4, field offset_resolution_alt_1[14:12] (RW)
 *
 * Counter offset Resolution This field defines the trigger causing the offset
 * counter to increment The counter offset resolution should be defined in the
 * same way as in original DI's counter#
 */
/*@{*/
#define BP_IPU_DISP_ALT4_offset_resolution_alt_1 (12U) /*!< Bit position for IPU_DISP_ALT4_offset_resolution_alt_1. */
#define BM_IPU_DISP_ALT4_offset_resolution_alt_1 (0x00007000U) /*!< Bit mask for IPU_DISP_ALT4_offset_resolution_alt_1. */
#define BS_IPU_DISP_ALT4_offset_resolution_alt_1 (3U) /*!< Bit field size in bits for IPU_DISP_ALT4_offset_resolution_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT4_offset_resolution_alt_1 field. */
#define BR_IPU_DISP_ALT4_offset_resolution_alt_1(x) (HW_IPU_DISP_ALT4(x).B.offset_resolution_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT4_offset_resolution_alt_1. */
#define BF_IPU_DISP_ALT4_offset_resolution_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT4_offset_resolution_alt_1) & BM_IPU_DISP_ALT4_offset_resolution_alt_1)

/*! @brief Set the offset_resolution_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT4_offset_resolution_alt_1(x, v) (HW_IPU_DISP_ALT4_WR(x, (HW_IPU_DISP_ALT4_RD(x) & ~BM_IPU_DISP_ALT4_offset_resolution_alt_1) | BF_IPU_DISP_ALT4_offset_resolution_alt_1(v)))
/*@}*/

/*!
 * @name Register IPU_DISP_ALT4, field run_resolution_alt_1[18:16] (RW)
 *
 * Counter Run Resolution This field defines the trigger causing the counter to
 * increment. The counter run resolution should be defined in the same way as in
 * original DI's counter#
 */
/*@{*/
#define BP_IPU_DISP_ALT4_run_resolution_alt_1 (16U) /*!< Bit position for IPU_DISP_ALT4_run_resolution_alt_1. */
#define BM_IPU_DISP_ALT4_run_resolution_alt_1 (0x00070000U) /*!< Bit mask for IPU_DISP_ALT4_run_resolution_alt_1. */
#define BS_IPU_DISP_ALT4_run_resolution_alt_1 (3U) /*!< Bit field size in bits for IPU_DISP_ALT4_run_resolution_alt_1. */

/*! @brief Read current value of the IPU_DISP_ALT4_run_resolution_alt_1 field. */
#define BR_IPU_DISP_ALT4_run_resolution_alt_1(x) (HW_IPU_DISP_ALT4(x).B.run_resolution_alt_1)

/*! @brief Format value for bitfield IPU_DISP_ALT4_run_resolution_alt_1. */
#define BF_IPU_DISP_ALT4_run_resolution_alt_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DISP_ALT4_run_resolution_alt_1) & BM_IPU_DISP_ALT4_run_resolution_alt_1)

/*! @brief Set the run_resolution_alt_1 field to a new value. */
#define BW_IPU_DISP_ALT4_run_resolution_alt_1(x, v) (HW_IPU_DISP_ALT4_WR(x, (HW_IPU_DISP_ALT4_RD(x) & ~BM_IPU_DISP_ALT4_run_resolution_alt_1) | BF_IPU_DISP_ALT4_run_resolution_alt_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_MEM_RST - Memory Reset Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_MEM_RST - Memory Reset Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls the memory reset mechanism. IPU has a hardware
 * mechanism for clearing the content of the internal memories. This allows the user to
 * clear the content of or more of the internal memories without the need to
 * perform write accesses to the memories.
 */
typedef union _hw_ipu_mem_rst
{
    uint32_t U;
    struct _hw_ipu_mem_rst_bitfields
    {
        uint32_t RST_MEM_EN : 23;      /*!< [22:0]  */
        uint32_t RESERVED0 : 8;        /*!< [30:23]  */
        uint32_t RST_MEM_START : 1;    /*!< [31]  */
    } B;
} hw_ipu_mem_rst_t;

/*!
 * @name Constants and macros for entire IPU_MEM_RST register
 */
/*@{*/
#define HW_IPU_MEM_RST_ADDR(x)   ((uintptr_t)(x) + 0xDCU)

#define HW_IPU_MEM_RST(x)        (*(__IO hw_ipu_mem_rst_t *) HW_IPU_MEM_RST_ADDR(x))
#define HW_IPU_MEM_RST_RD(x)     (HW_IPU_MEM_RST(x).U)
#define HW_IPU_MEM_RST_WR(x, v)  (HW_IPU_MEM_RST(x).U = (v))
#define HW_IPU_MEM_RST_SET(x, v) (HW_IPU_MEM_RST_WR(x, HW_IPU_MEM_RST_RD(x) |  (v)))
#define HW_IPU_MEM_RST_CLR(x, v) (HW_IPU_MEM_RST_WR(x, HW_IPU_MEM_RST_RD(x) & ~(v)))
#define HW_IPU_MEM_RST_TOG(x, v) (HW_IPU_MEM_RST_WR(x, HW_IPU_MEM_RST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_MEM_RST bitfields
 */

/*!
 * @name Register IPU_MEM_RST, field RST_MEM_EN[22:0] (RW)
 *
 * Reset Memory Enable Each bit on this field enables the memory reset mechanism
 * for a specific memory. The user should set the relevant bits for the memories
 * that need to be cleared. Below is the list of memories and their
 * corresponding bit. srm = rst_mem_en[0] alpha = rst_mem_en[1] cpmem = rst_mem_en[2] tpm =
 * rst_mem_en[3] mpm = rst_mem_en[4] bm = rst_mem_en[5] rm = rst_mem_en[6] dstm =
 * rst_mem_en[7] dsom = rst_mem_en[8] lut0 = rst_mem_en[9] lut1 = rst_mem_en[10]
 * ram_smfc = rst_mem_en[11] vdi_fifo2 = rst_mem_en[12] vdi_fifo3 =
 * rst_mem_en[13] icb = rst_mem_en[14] vdi_fifo1 = rst_mem_en[15] dc_template = rst_mem_en[20]
 * dmfc_rd = rst_mem_en[21] dmfc_wr = rst_mem_en[22]
 */
/*@{*/
#define BP_IPU_MEM_RST_RST_MEM_EN (0U)     /*!< Bit position for IPU_MEM_RST_RST_MEM_EN. */
#define BM_IPU_MEM_RST_RST_MEM_EN (0x007FFFFFU) /*!< Bit mask for IPU_MEM_RST_RST_MEM_EN. */
#define BS_IPU_MEM_RST_RST_MEM_EN (23U)    /*!< Bit field size in bits for IPU_MEM_RST_RST_MEM_EN. */

/*! @brief Read current value of the IPU_MEM_RST_RST_MEM_EN field. */
#define BR_IPU_MEM_RST_RST_MEM_EN(x) (HW_IPU_MEM_RST(x).B.RST_MEM_EN)

/*! @brief Format value for bitfield IPU_MEM_RST_RST_MEM_EN. */
#define BF_IPU_MEM_RST_RST_MEM_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_MEM_RST_RST_MEM_EN) & BM_IPU_MEM_RST_RST_MEM_EN)

/*! @brief Set the RST_MEM_EN field to a new value. */
#define BW_IPU_MEM_RST_RST_MEM_EN(x, v) (HW_IPU_MEM_RST_WR(x, (HW_IPU_MEM_RST_RD(x) & ~BM_IPU_MEM_RST_RST_MEM_EN) | BF_IPU_MEM_RST_RST_MEM_EN(v)))
/*@}*/

/*!
 * @name Register IPU_MEM_RST, field RST_MEM_START[31] (RW)
 *
 * Memory Reset Start Writing one to this bit activate the memory reset
 * mechanism. The memories that their corresponding RST_MEM_EN bit is set will be
 * cleared. When the memory reset mechanism completes the memory clearing procedure this
 * bit will be automatically cleared.
 *
 * Values:
 * - 1 - The memory reset mechanism is activated and busy
 * - 0 - Idle, the memory reset mechanism is not working.
 */
/*@{*/
#define BP_IPU_MEM_RST_RST_MEM_START (31U) /*!< Bit position for IPU_MEM_RST_RST_MEM_START. */
#define BM_IPU_MEM_RST_RST_MEM_START (0x80000000U) /*!< Bit mask for IPU_MEM_RST_RST_MEM_START. */
#define BS_IPU_MEM_RST_RST_MEM_START (1U)  /*!< Bit field size in bits for IPU_MEM_RST_RST_MEM_START. */

/*! @brief Read current value of the IPU_MEM_RST_RST_MEM_START field. */
#define BR_IPU_MEM_RST_RST_MEM_START(x) (HW_IPU_MEM_RST(x).B.RST_MEM_START)

/*! @brief Format value for bitfield IPU_MEM_RST_RST_MEM_START. */
#define BF_IPU_MEM_RST_RST_MEM_START(v) ((uint32_t)((uint32_t)(v) << BP_IPU_MEM_RST_RST_MEM_START) & BM_IPU_MEM_RST_RST_MEM_START)

/*! @brief Set the RST_MEM_START field to a new value. */
#define BW_IPU_MEM_RST_RST_MEM_START(x, v) (HW_IPU_MEM_RST_WR(x, (HW_IPU_MEM_RST_RD(x) & ~BM_IPU_MEM_RST_RST_MEM_START) | BF_IPU_MEM_RST_RST_MEM_START(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PM - Power Modes Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PM - Power Modes Control Register (RW)
 *
 * Reset value: 0x08100810U
 *
 * This register controls the automatic transitions of the IPU between different
 * power modes of the SoC and handles the clock change modes.
 */
typedef union _hw_ipu_pm
{
    uint32_t U;
    struct _hw_ipu_pm_bitfields
    {
        uint32_t DI0_CLK_PERIOD_0 : 7; /*!< [6:0]  */
        uint32_t DI0_CLK_PERIOD_1 : 7; /*!< [13:7]  */
        uint32_t DI0_SRM_CLOCK_CHANGE_MODE : 1; /*!< [14]  */
        uint32_t CLCOK_MODE_STAT : 1;  /*!< [15]  */
        uint32_t DI1_CLK_PERIOD_0 : 7; /*!< [22:16]  */
        uint32_t DI1_CLK_PERIOD_1 : 7; /*!< [29:23]  */
        uint32_t DI1_SRM_CLOCK_CHANGE_MODE : 1; /*!< [30]  */
        uint32_t LPSR_MODE : 1;        /*!< [31]  */
    } B;
} hw_ipu_pm_t;

/*!
 * @name Constants and macros for entire IPU_PM register
 */
/*@{*/
#define HW_IPU_PM_ADDR(x)        ((uintptr_t)(x) + 0xE0U)

#define HW_IPU_PM(x)             (*(__IO hw_ipu_pm_t *) HW_IPU_PM_ADDR(x))
#define HW_IPU_PM_RD(x)          (HW_IPU_PM(x).U)
#define HW_IPU_PM_WR(x, v)       (HW_IPU_PM(x).U = (v))
#define HW_IPU_PM_SET(x, v)      (HW_IPU_PM_WR(x, HW_IPU_PM_RD(x) |  (v)))
#define HW_IPU_PM_CLR(x, v)      (HW_IPU_PM_WR(x, HW_IPU_PM_RD(x) & ~(v)))
#define HW_IPU_PM_TOG(x, v)      (HW_IPU_PM_WR(x, HW_IPU_PM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PM bitfields
 */

/*!
 * @name Register IPU_PM, field DI0_CLK_PERIOD_0[6:0] (RW)
 *
 * DI0_CLK period option 0. This parameter defines the period of the clock that
 * the DI0 works with. This parameter contains integer part (bits [6:4]) and
 * fractional part (bits [3:0]). Setting this value to 1.0 (default) means that the
 * DI0 works on the fastest possible clock. Setting a value smaller than 1.0 is
 * not allowed. The value to be programmed to the DI0_CLK_PERIOD_1 field is equal
 * to: Fast_freq/Target_freq Where: Target_freq = The frequency that the DI clock
 * works with Fast_freq = fastest possible clock that the DI can work with
 */
/*@{*/
#define BP_IPU_PM_DI0_CLK_PERIOD_0 (0U)    /*!< Bit position for IPU_PM_DI0_CLK_PERIOD_0. */
#define BM_IPU_PM_DI0_CLK_PERIOD_0 (0x0000007FU) /*!< Bit mask for IPU_PM_DI0_CLK_PERIOD_0. */
#define BS_IPU_PM_DI0_CLK_PERIOD_0 (7U)    /*!< Bit field size in bits for IPU_PM_DI0_CLK_PERIOD_0. */

/*! @brief Read current value of the IPU_PM_DI0_CLK_PERIOD_0 field. */
#define BR_IPU_PM_DI0_CLK_PERIOD_0(x) (HW_IPU_PM(x).B.DI0_CLK_PERIOD_0)

/*! @brief Format value for bitfield IPU_PM_DI0_CLK_PERIOD_0. */
#define BF_IPU_PM_DI0_CLK_PERIOD_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI0_CLK_PERIOD_0) & BM_IPU_PM_DI0_CLK_PERIOD_0)

/*! @brief Set the DI0_CLK_PERIOD_0 field to a new value. */
#define BW_IPU_PM_DI0_CLK_PERIOD_0(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI0_CLK_PERIOD_0) | BF_IPU_PM_DI0_CLK_PERIOD_0(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field DI0_CLK_PERIOD_1[13:7] (RW)
 *
 * DI0_CLK period option 1. This parameter defines the period of the clock that
 * the DI0 works with. This parameter contains integer part (bits [6:4]) and
 * fractional part (bits [3:0]). Setting this value to 1.0 (default) means that the
 * DI0 works on the fastest possible clock. Setting a value smaller than 1.0 is
 * not allowed. The value to be programmed to the DI0_CLK_PERIOD_1 field is equal
 * to: Fast_freq/Target_freq Where: Target_freq = The frequency that the DI clock
 * works with Fast_freq = fastest possible clock that the DI can work with
 */
/*@{*/
#define BP_IPU_PM_DI0_CLK_PERIOD_1 (7U)    /*!< Bit position for IPU_PM_DI0_CLK_PERIOD_1. */
#define BM_IPU_PM_DI0_CLK_PERIOD_1 (0x00003F80U) /*!< Bit mask for IPU_PM_DI0_CLK_PERIOD_1. */
#define BS_IPU_PM_DI0_CLK_PERIOD_1 (7U)    /*!< Bit field size in bits for IPU_PM_DI0_CLK_PERIOD_1. */

/*! @brief Read current value of the IPU_PM_DI0_CLK_PERIOD_1 field. */
#define BR_IPU_PM_DI0_CLK_PERIOD_1(x) (HW_IPU_PM(x).B.DI0_CLK_PERIOD_1)

/*! @brief Format value for bitfield IPU_PM_DI0_CLK_PERIOD_1. */
#define BF_IPU_PM_DI0_CLK_PERIOD_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI0_CLK_PERIOD_1) & BM_IPU_PM_DI0_CLK_PERIOD_1)

/*! @brief Set the DI0_CLK_PERIOD_1 field to a new value. */
#define BW_IPU_PM_DI0_CLK_PERIOD_1(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI0_CLK_PERIOD_1) | BF_IPU_PM_DI0_CLK_PERIOD_1(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field DI0_SRM_CLOCK_CHANGE_MODE[14] (RW)
 *
 * SRM clock change mode When the clock is going to be changed to any new ratio
 * other then 1:1, 1:2. 1:4. The user needs to prepare an alternate set of DI
 * setting in the SRM. This bit enable this mode. This bit is self cleared.
 *
 * Values:
 * - 1 - SRM clock change mode is enabled; the next clock change will be done by
 *     updating the DI settings from the SRM
 * - 0 - SRM clock change mode is disabled.
 */
/*@{*/
#define BP_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE (14U) /*!< Bit position for IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE. */
#define BM_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE (0x00004000U) /*!< Bit mask for IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE. */
#define BS_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE (1U) /*!< Bit field size in bits for IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE. */

/*! @brief Read current value of the IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE field. */
#define BR_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE(x) (HW_IPU_PM(x).B.DI0_SRM_CLOCK_CHANGE_MODE)

/*! @brief Format value for bitfield IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE. */
#define BF_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE) & BM_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE)

/*! @brief Set the DI0_SRM_CLOCK_CHANGE_MODE field to a new value. */
#define BW_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE) | BF_IPU_PM_DI0_SRM_CLOCK_CHANGE_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field CLCOK_MODE_STAT[15] (RO)
 *
 * Clock mode status This is a read only bit indicating what is the current
 * clock mode
 *
 * Values:
 * - 1 - current clock mode is 1
 * - 0 - current clock mode is 0
 */
/*@{*/
#define BP_IPU_PM_CLCOK_MODE_STAT (15U)    /*!< Bit position for IPU_PM_CLCOK_MODE_STAT. */
#define BM_IPU_PM_CLCOK_MODE_STAT (0x00008000U) /*!< Bit mask for IPU_PM_CLCOK_MODE_STAT. */
#define BS_IPU_PM_CLCOK_MODE_STAT (1U)     /*!< Bit field size in bits for IPU_PM_CLCOK_MODE_STAT. */

/*! @brief Read current value of the IPU_PM_CLCOK_MODE_STAT field. */
#define BR_IPU_PM_CLCOK_MODE_STAT(x) (HW_IPU_PM(x).B.CLCOK_MODE_STAT)
/*@}*/

/*!
 * @name Register IPU_PM, field DI1_CLK_PERIOD_0[22:16] (RW)
 *
 * DI1_CLK period option 0. This parameter defines the period of the clock that
 * the DI1 works with. This parameter contains integer part (bits [6:4]) and
 * fractional part (bits [3:0]). Setting this value to 1.0 (default) means that the
 * DI1 works on the fastest possible clock. Setting a value smaller than 1.0 is
 * not allowed. The value to be programmed to the DI1_CLK_PERIOD_1 field is equal
 * to: Fast_freq/Target_freq Where: Target_freq = The frequency that the DI clock
 * works with Fast_freq = fastest possible clock that the DI can work with
 */
/*@{*/
#define BP_IPU_PM_DI1_CLK_PERIOD_0 (16U)   /*!< Bit position for IPU_PM_DI1_CLK_PERIOD_0. */
#define BM_IPU_PM_DI1_CLK_PERIOD_0 (0x007F0000U) /*!< Bit mask for IPU_PM_DI1_CLK_PERIOD_0. */
#define BS_IPU_PM_DI1_CLK_PERIOD_0 (7U)    /*!< Bit field size in bits for IPU_PM_DI1_CLK_PERIOD_0. */

/*! @brief Read current value of the IPU_PM_DI1_CLK_PERIOD_0 field. */
#define BR_IPU_PM_DI1_CLK_PERIOD_0(x) (HW_IPU_PM(x).B.DI1_CLK_PERIOD_0)

/*! @brief Format value for bitfield IPU_PM_DI1_CLK_PERIOD_0. */
#define BF_IPU_PM_DI1_CLK_PERIOD_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI1_CLK_PERIOD_0) & BM_IPU_PM_DI1_CLK_PERIOD_0)

/*! @brief Set the DI1_CLK_PERIOD_0 field to a new value. */
#define BW_IPU_PM_DI1_CLK_PERIOD_0(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI1_CLK_PERIOD_0) | BF_IPU_PM_DI1_CLK_PERIOD_0(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field DI1_CLK_PERIOD_1[29:23] (RW)
 *
 * DI1_CLK period option 1. This parameter defines the period of the clock that
 * the DI1 works with. This parameter contains integer part (bits [6:4]) and
 * fractional part (bits [3:0]). Setting this value to 1.0 (default) means that the
 * DI1 works on the fastest possible clock. Setting a value smaller than 1.0 is
 * not allowed. The value to be programmed to the DI1_CLK_PERIOD_1 field is equal
 * to: Fast_freq/Target_freq Where: Target_freq = The frequency that the DI clock
 * works with Fast_freq = fastest possible clock that the DI can work with
 */
/*@{*/
#define BP_IPU_PM_DI1_CLK_PERIOD_1 (23U)   /*!< Bit position for IPU_PM_DI1_CLK_PERIOD_1. */
#define BM_IPU_PM_DI1_CLK_PERIOD_1 (0x3F800000U) /*!< Bit mask for IPU_PM_DI1_CLK_PERIOD_1. */
#define BS_IPU_PM_DI1_CLK_PERIOD_1 (7U)    /*!< Bit field size in bits for IPU_PM_DI1_CLK_PERIOD_1. */

/*! @brief Read current value of the IPU_PM_DI1_CLK_PERIOD_1 field. */
#define BR_IPU_PM_DI1_CLK_PERIOD_1(x) (HW_IPU_PM(x).B.DI1_CLK_PERIOD_1)

/*! @brief Format value for bitfield IPU_PM_DI1_CLK_PERIOD_1. */
#define BF_IPU_PM_DI1_CLK_PERIOD_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI1_CLK_PERIOD_1) & BM_IPU_PM_DI1_CLK_PERIOD_1)

/*! @brief Set the DI1_CLK_PERIOD_1 field to a new value. */
#define BW_IPU_PM_DI1_CLK_PERIOD_1(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI1_CLK_PERIOD_1) | BF_IPU_PM_DI1_CLK_PERIOD_1(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field DI1_SRM_CLOCK_CHANGE_MODE[30] (RW)
 *
 * SRM clock change mode When the clock is going to be changed to any new ratio
 * other then 1:1, 1:2. 1:4. The user needs to prepare an alternate set of DI
 * setting in the SRM. This bit enable this mode. This bit is self cleared.
 *
 * Values:
 * - 1 - SRM clock change mode is enabled; the next clock change will be done by
 *     updating the DI settings from the SRM
 * - 0 - SRM clock change mode is disabled.
 */
/*@{*/
#define BP_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE (30U) /*!< Bit position for IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE. */
#define BM_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE (0x40000000U) /*!< Bit mask for IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE. */
#define BS_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE (1U) /*!< Bit field size in bits for IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE. */

/*! @brief Read current value of the IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE field. */
#define BR_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE(x) (HW_IPU_PM(x).B.DI1_SRM_CLOCK_CHANGE_MODE)

/*! @brief Format value for bitfield IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE. */
#define BF_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE) & BM_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE)

/*! @brief Set the DI1_SRM_CLOCK_CHANGE_MODE field to a new value. */
#define BW_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE) | BF_IPU_PM_DI1_SRM_CLOCK_CHANGE_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_PM, field LPSR_MODE[31] (RW)
 *
 * LPSR Mode This bit indicates that the next attempt for entering low power
 * mode is an attempt to move to LPST mode. Setting this bit by the user is
 * essential in order to assure proper response of the IPU to the assertion of the stop
 * request from the CCM.
 *
 * Values:
 * - 1 - Next low power mode will be LPSR
 * - 0 - Next low power mode is not LPSR
 */
/*@{*/
#define BP_IPU_PM_LPSR_MODE  (31U)         /*!< Bit position for IPU_PM_LPSR_MODE. */
#define BM_IPU_PM_LPSR_MODE  (0x80000000U) /*!< Bit mask for IPU_PM_LPSR_MODE. */
#define BS_IPU_PM_LPSR_MODE  (1U)          /*!< Bit field size in bits for IPU_PM_LPSR_MODE. */

/*! @brief Read current value of the IPU_PM_LPSR_MODE field. */
#define BR_IPU_PM_LPSR_MODE(x) (HW_IPU_PM(x).B.LPSR_MODE)

/*! @brief Format value for bitfield IPU_PM_LPSR_MODE. */
#define BF_IPU_PM_LPSR_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PM_LPSR_MODE) & BM_IPU_PM_LPSR_MODE)

/*! @brief Set the LPSR_MODE field to a new value. */
#define BW_IPU_PM_LPSR_MODE(x, v) (HW_IPU_PM_WR(x, (HW_IPU_PM_RD(x) & ~BM_IPU_PM_LPSR_MODE) | BF_IPU_PM_LPSR_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_GPR - General Purpose Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_GPR - General Purpose Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains general purpose bits.
 */
typedef union _hw_ipu_gpr
{
    uint32_t U;
    struct _hw_ipu_gpr_bitfields
    {
        uint32_t IPU_GPn : 20;         /*!< [19:0]  */
        uint32_t IPU_CH_BUF2_RDY0_CLR : 1; /*!< [20]  */
        uint32_t IPU_CH_BUF2_RDY1_CLR : 1; /*!< [21]  */
        uint32_t IPU_DI0_CLK_CHANGE_ACK_DIS : 1; /*!< [22]  */
        uint32_t IPU_DI1_CLK_CHANGE_ACK_DIS : 1; /*!< [23]  */
        uint32_t IPU_ALT_CH_BUF0_RDY0_CLR : 1; /*!< [24]  */
        uint32_t IPU_ALT_CH_BUF0_RDY1_CLR : 1; /*!< [25]  */
        uint32_t IPU_ALT_CH_BUF1_RDY0_CLR : 1; /*!< [26]  */
        uint32_t IPU_ALT_CH_BUF1_RDY1_CLR : 1; /*!< [27]  */
        uint32_t IPU_CH_BUF0_RDY0_CLR : 1; /*!< [28]  */
        uint32_t IPU_CH_BUF0_RDY1_CLR : 1; /*!< [29]  */
        uint32_t IPU_CH_BUF1_RDY0_CLR : 1; /*!< [30]  */
        uint32_t IPU_CH_BUF1_RDY1_CLR : 1; /*!< [31]  */
    } B;
} hw_ipu_gpr_t;

/*!
 * @name Constants and macros for entire IPU_GPR register
 */
/*@{*/
#define HW_IPU_GPR_ADDR(x)       ((uintptr_t)(x) + 0xE4U)

#define HW_IPU_GPR(x)            (*(__IO hw_ipu_gpr_t *) HW_IPU_GPR_ADDR(x))
#define HW_IPU_GPR_RD(x)         (HW_IPU_GPR(x).U)
#define HW_IPU_GPR_WR(x, v)      (HW_IPU_GPR(x).U = (v))
#define HW_IPU_GPR_SET(x, v)     (HW_IPU_GPR_WR(x, HW_IPU_GPR_RD(x) |  (v)))
#define HW_IPU_GPR_CLR(x, v)     (HW_IPU_GPR_WR(x, HW_IPU_GPR_RD(x) & ~(v)))
#define HW_IPU_GPR_TOG(x, v)     (HW_IPU_GPR_WR(x, HW_IPU_GPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_GPR bitfields
 */

/*!
 * @name Register IPU_GPR, field IPU_GPn[19:0] (RW)
 *
 * IPU General Purpose bit. n Indicates the corresponding DMA channel number.
 * This bits are general Read/Write bits, reserved for future use
 */
/*@{*/
#define BP_IPU_GPR_IPU_GPn   (0U)          /*!< Bit position for IPU_GPR_IPU_GPn. */
#define BM_IPU_GPR_IPU_GPn   (0x000FFFFFU) /*!< Bit mask for IPU_GPR_IPU_GPn. */
#define BS_IPU_GPR_IPU_GPn   (20U)         /*!< Bit field size in bits for IPU_GPR_IPU_GPn. */

/*! @brief Read current value of the IPU_GPR_IPU_GPn field. */
#define BR_IPU_GPR_IPU_GPn(x) (HW_IPU_GPR(x).B.IPU_GPn)

/*! @brief Format value for bitfield IPU_GPR_IPU_GPn. */
#define BF_IPU_GPR_IPU_GPn(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_GPn) & BM_IPU_GPR_IPU_GPn)

/*! @brief Set the IPU_GPn field to a new value. */
#define BW_IPU_GPR_IPU_GPn(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_GPn) | BF_IPU_GPR_IPU_GPn(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF2_RDY0_CLR[20] (RW)
 *
 * This bit defines the IPU_CH_BUF2_RDY0 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF2_RDY0
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF2_RDY0 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF2_RDY0_CLR (20U) /*!< Bit position for IPU_GPR_IPU_CH_BUF2_RDY0_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF2_RDY0_CLR (0x00100000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF2_RDY0_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF2_RDY0_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF2_RDY0_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF2_RDY0_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF2_RDY0_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF2_RDY0_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF2_RDY0_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF2_RDY0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF2_RDY0_CLR) & BM_IPU_GPR_IPU_CH_BUF2_RDY0_CLR)

/*! @brief Set the IPU_CH_BUF2_RDY0_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF2_RDY0_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF2_RDY0_CLR) | BF_IPU_GPR_IPU_CH_BUF2_RDY0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF2_RDY1_CLR[21] (RW)
 *
 * This bit defines the IPU_CH_BUF2_RDY1 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF2_RDY1
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF2_RDY1 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF2_RDY1_CLR (21U) /*!< Bit position for IPU_GPR_IPU_CH_BUF2_RDY1_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF2_RDY1_CLR (0x00200000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF2_RDY1_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF2_RDY1_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF2_RDY1_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF2_RDY1_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF2_RDY1_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF2_RDY1_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF2_RDY1_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF2_RDY1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF2_RDY1_CLR) & BM_IPU_GPR_IPU_CH_BUF2_RDY1_CLR)

/*! @brief Set the IPU_CH_BUF2_RDY1_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF2_RDY1_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF2_RDY1_CLR) | BF_IPU_GPR_IPU_CH_BUF2_RDY1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_DI0_CLK_CHANGE_ACK_DIS[22] (RW)
 *
 * Disable DI0's clock change mechanism.
 *
 * Values:
 * - 1 - clock change mechanism is disabled. DI automatically acknowledges a
 *     clock change request
 * - 0 - clock change mechanism is disabled. DI performs the clock change
 *     procedure
 */
/*@{*/
#define BP_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS (22U) /*!< Bit position for IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS. */
#define BM_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS (0x00400000U) /*!< Bit mask for IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS. */
#define BS_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS (1U) /*!< Bit field size in bits for IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS. */

/*! @brief Read current value of the IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS field. */
#define BR_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS(x) (HW_IPU_GPR(x).B.IPU_DI0_CLK_CHANGE_ACK_DIS)

/*! @brief Format value for bitfield IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS. */
#define BF_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS) & BM_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS)

/*! @brief Set the IPU_DI0_CLK_CHANGE_ACK_DIS field to a new value. */
#define BW_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS) | BF_IPU_GPR_IPU_DI0_CLK_CHANGE_ACK_DIS(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_DI1_CLK_CHANGE_ACK_DIS[23] (RW)
 *
 * Disable DI1's clock change mechanism.
 *
 * Values:
 * - 1 - clock change mechanism is disabled. DI automatically acknowledges a
 *     clock change request
 * - 0 - clock change mechanism is disabled. DI performs the clock change
 *     procedure
 */
/*@{*/
#define BP_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS (23U) /*!< Bit position for IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS. */
#define BM_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS (0x00800000U) /*!< Bit mask for IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS. */
#define BS_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS (1U) /*!< Bit field size in bits for IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS. */

/*! @brief Read current value of the IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS field. */
#define BR_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS(x) (HW_IPU_GPR(x).B.IPU_DI1_CLK_CHANGE_ACK_DIS)

/*! @brief Format value for bitfield IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS. */
#define BF_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS) & BM_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS)

/*! @brief Set the IPU_DI1_CLK_CHANGE_ACK_DIS field to a new value. */
#define BW_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS) | BF_IPU_GPR_IPU_DI1_CLK_CHANGE_ACK_DIS(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_ALT_CH_BUF0_RDY0_CLR[24] (RW)
 *
 * This bit defines the IPU_ALT_CH_BUF0_RDY0 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit;
 *     IPU_ALT_CH_BUF0_RDY0 is w1c register
 * - 0 - writing one to a bit of this register sets this bit
 *     IPU_ALT_CH_BUF0_RDY0 is w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR (24U) /*!< Bit position for IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR. */
#define BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR (0x01000000U) /*!< Bit mask for IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR. */
#define BS_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR field. */
#define BR_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR(x) (HW_IPU_GPR(x).B.IPU_ALT_CH_BUF0_RDY0_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR. */
#define BF_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR) & BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR)

/*! @brief Set the IPU_ALT_CH_BUF0_RDY0_CLR field to a new value. */
#define BW_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR) | BF_IPU_GPR_IPU_ALT_CH_BUF0_RDY0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_ALT_CH_BUF0_RDY1_CLR[25] (RW)
 *
 * This bit defines the IPU_ALT_CH_BUF0_RDY1 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit;
 *     IPU_ALT_CH_BUF0_RDY1 is w1c register
 * - 0 - writing one to a bit of this register sets this bit
 *     IPU_ALT_CH_BUF0_RDY1 is w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR (25U) /*!< Bit position for IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR. */
#define BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR (0x02000000U) /*!< Bit mask for IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR. */
#define BS_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR field. */
#define BR_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR(x) (HW_IPU_GPR(x).B.IPU_ALT_CH_BUF0_RDY1_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR. */
#define BF_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR) & BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR)

/*! @brief Set the IPU_ALT_CH_BUF0_RDY1_CLR field to a new value. */
#define BW_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR) | BF_IPU_GPR_IPU_ALT_CH_BUF0_RDY1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_ALT_CH_BUF1_RDY0_CLR[26] (RW)
 *
 * This bit defines the IPU_ALT_CH_BUF1_RDY0 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit;
 *     IPU_ALT_CH_BUF1_RDY0 is w1c register
 * - 0 - writing one to a bit of this register sets this bit
 *     IPU_ALT_CH_BUF1_RDY0 is w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR (26U) /*!< Bit position for IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR. */
#define BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR (0x04000000U) /*!< Bit mask for IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR. */
#define BS_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR field. */
#define BR_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR(x) (HW_IPU_GPR(x).B.IPU_ALT_CH_BUF1_RDY0_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR. */
#define BF_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR) & BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR)

/*! @brief Set the IPU_ALT_CH_BUF1_RDY0_CLR field to a new value. */
#define BW_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR) | BF_IPU_GPR_IPU_ALT_CH_BUF1_RDY0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_ALT_CH_BUF1_RDY1_CLR[27] (RW)
 *
 * This bit defines the IPU_ALT_CH_BUF1_RDY1 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit;
 *     IPU_ALT_CH_BUF1_RDY1 is w1c register
 * - 0 - writing one to a bit of this register sets this bit
 *     IPU_ALT_CH_BUF1_RDY1 is w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR (27U) /*!< Bit position for IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR. */
#define BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR (0x08000000U) /*!< Bit mask for IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR. */
#define BS_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR field. */
#define BR_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR(x) (HW_IPU_GPR(x).B.IPU_ALT_CH_BUF1_RDY1_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR. */
#define BF_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR) & BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR)

/*! @brief Set the IPU_ALT_CH_BUF1_RDY1_CLR field to a new value. */
#define BW_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR) | BF_IPU_GPR_IPU_ALT_CH_BUF1_RDY1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF0_RDY0_CLR[28] (RW)
 *
 * This bit defines the IPU_CH_BUF0_RDY0 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF0_RDY0
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF0_RDY0 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF0_RDY0_CLR (28U) /*!< Bit position for IPU_GPR_IPU_CH_BUF0_RDY0_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF0_RDY0_CLR (0x10000000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF0_RDY0_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF0_RDY0_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF0_RDY0_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF0_RDY0_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF0_RDY0_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF0_RDY0_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF0_RDY0_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF0_RDY0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF0_RDY0_CLR) & BM_IPU_GPR_IPU_CH_BUF0_RDY0_CLR)

/*! @brief Set the IPU_CH_BUF0_RDY0_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF0_RDY0_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF0_RDY0_CLR) | BF_IPU_GPR_IPU_CH_BUF0_RDY0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF0_RDY1_CLR[29] (RW)
 *
 * This bit defines the IPU_CH_BUF0_RDY1 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF0_RDY1
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF0_RDY1 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF0_RDY1_CLR (29U) /*!< Bit position for IPU_GPR_IPU_CH_BUF0_RDY1_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF0_RDY1_CLR (0x20000000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF0_RDY1_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF0_RDY1_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF0_RDY1_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF0_RDY1_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF0_RDY1_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF0_RDY1_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF0_RDY1_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF0_RDY1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF0_RDY1_CLR) & BM_IPU_GPR_IPU_CH_BUF0_RDY1_CLR)

/*! @brief Set the IPU_CH_BUF0_RDY1_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF0_RDY1_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF0_RDY1_CLR) | BF_IPU_GPR_IPU_CH_BUF0_RDY1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF1_RDY0_CLR[30] (RW)
 *
 * This bit defines the IPU_CH_BUF1_RDY0 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF1_RDY0
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF1_RDY0 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF1_RDY0_CLR (30U) /*!< Bit position for IPU_GPR_IPU_CH_BUF1_RDY0_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF1_RDY0_CLR (0x40000000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF1_RDY0_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF1_RDY0_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF1_RDY0_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF1_RDY0_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF1_RDY0_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF1_RDY0_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF1_RDY0_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF1_RDY0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF1_RDY0_CLR) & BM_IPU_GPR_IPU_CH_BUF1_RDY0_CLR)

/*! @brief Set the IPU_CH_BUF1_RDY0_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF1_RDY0_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF1_RDY0_CLR) | BF_IPU_GPR_IPU_CH_BUF1_RDY0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_GPR, field IPU_CH_BUF1_RDY1_CLR[31] (RW)
 *
 * This bit defines the IPU_CH_BUF1_RDY1 properties. This register can be a
 * write one to clear OR write one to set.
 *
 * Values:
 * - 1 - writing one to a bit of this register clears this bit; IPU_CH_BUF1_RDY1
 *     is w1c register
 * - 0 - writing one to a bit of this register sets this bit IPU_CH_BUF1_RDY1 is
 *     w1s register
 */
/*@{*/
#define BP_IPU_GPR_IPU_CH_BUF1_RDY1_CLR (31U) /*!< Bit position for IPU_GPR_IPU_CH_BUF1_RDY1_CLR. */
#define BM_IPU_GPR_IPU_CH_BUF1_RDY1_CLR (0x80000000U) /*!< Bit mask for IPU_GPR_IPU_CH_BUF1_RDY1_CLR. */
#define BS_IPU_GPR_IPU_CH_BUF1_RDY1_CLR (1U) /*!< Bit field size in bits for IPU_GPR_IPU_CH_BUF1_RDY1_CLR. */

/*! @brief Read current value of the IPU_GPR_IPU_CH_BUF1_RDY1_CLR field. */
#define BR_IPU_GPR_IPU_CH_BUF1_RDY1_CLR(x) (HW_IPU_GPR(x).B.IPU_CH_BUF1_RDY1_CLR)

/*! @brief Format value for bitfield IPU_GPR_IPU_CH_BUF1_RDY1_CLR. */
#define BF_IPU_GPR_IPU_CH_BUF1_RDY1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_GPR_IPU_CH_BUF1_RDY1_CLR) & BM_IPU_GPR_IPU_CH_BUF1_RDY1_CLR)

/*! @brief Set the IPU_CH_BUF1_RDY1_CLR field to a new value. */
#define BW_IPU_GPR_IPU_CH_BUF1_RDY1_CLR(x, v) (HW_IPU_GPR_WR(x, (HW_IPU_GPR_RD(x) & ~BM_IPU_GPR_IPU_CH_BUF1_RDY1_CLR) | BF_IPU_GPR_IPU_CH_BUF1_RDY1_CLR(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_DB_MODE_SEL0 - Channel Double Buffer Mode Select 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_DB_MODE_SEL0 - Channel Double Buffer Mode Select 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains double buffer mode select control information for 32
 * IPU's DMA channels.
 */
typedef union _hw_ipu_ch_db_mode_sel0
{
    uint32_t U;
    struct _hw_ipu_ch_db_mode_sel0_bitfields
    {
        uint32_t DMA_CH_DB_MODE_SEL_0 : 1; /*!< [0]  */
        uint32_t DMA_CH_DB_MODE_SEL_1 : 1; /*!< [1]  */
        uint32_t DMA_CH_DB_MODE_SEL_2 : 1; /*!< [2]  */
        uint32_t DMA_CH_DB_MODE_SEL_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DMA_CH_DB_MODE_SEL_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t DMA_CH_DB_MODE_SEL_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_DB_MODE_SEL_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_DB_MODE_SEL_10 : 1; /*!< [10]  */
        uint32_t DMA_CH_DB_MODE_SEL_11 : 1; /*!< [11]  */
        uint32_t DMA_CH_DB_MODE_SEL_12 : 1; /*!< [12]  */
        uint32_t DMA_CH_DB_MODE_SEL_13 : 1; /*!< [13]  */
        uint32_t DMA_CH_DB_MODE_SEL_14 : 1; /*!< [14]  */
        uint32_t DMA_CH_DB_MODE_SEL_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t DMA_CH_DB_MODE_SEL_17 : 1; /*!< [17]  */
        uint32_t DMA_CH_DB_MODE_SEL_18 : 1; /*!< [18]  */
        uint32_t DMA_CH_DB_MODE_SEL_19 : 1; /*!< [19]  */
        uint32_t DMA_CH_DB_MODE_SEL_20 : 1; /*!< [20]  */
        uint32_t DMA_CH_DB_MODE_SEL_21 : 1; /*!< [21]  */
        uint32_t DMA_CH_DB_MODE_SEL_22 : 1; /*!< [22]  */
        uint32_t DMA_CH_DB_MODE_SEL_23 : 1; /*!< [23]  */
        uint32_t DMA_CH_DB_MODE_SEL_24 : 1; /*!< [24]  */
        uint32_t DMA_CH_DB_MODE_SEL_25 : 1; /*!< [25]  */
        uint32_t DMA_CH_DB_MODE_SEL_26 : 1; /*!< [26]  */
        uint32_t DMA_CH_DB_MODE_SEL_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_DB_MODE_SEL_28 : 1; /*!< [28]  */
        uint32_t DMA_CH_DB_MODE_SEL_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t DMA_CH_DB_MODE_SEL_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_ch_db_mode_sel0_t;

/*!
 * @name Constants and macros for entire IPU_CH_DB_MODE_SEL0 register
 */
/*@{*/
#define HW_IPU_CH_DB_MODE_SEL0_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_IPU_CH_DB_MODE_SEL0(x) (*(__IO hw_ipu_ch_db_mode_sel0_t *) HW_IPU_CH_DB_MODE_SEL0_ADDR(x))
#define HW_IPU_CH_DB_MODE_SEL0_RD(x) (HW_IPU_CH_DB_MODE_SEL0(x).U)
#define HW_IPU_CH_DB_MODE_SEL0_WR(x, v) (HW_IPU_CH_DB_MODE_SEL0(x).U = (v))
#define HW_IPU_CH_DB_MODE_SEL0_SET(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, HW_IPU_CH_DB_MODE_SEL0_RD(x) |  (v)))
#define HW_IPU_CH_DB_MODE_SEL0_CLR(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~(v)))
#define HW_IPU_CH_DB_MODE_SEL0_TOG(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, HW_IPU_CH_DB_MODE_SEL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_DB_MODE_SEL0 bitfields
 */

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_0[0] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0 (0U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0 (0x00000001U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_0)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0)

/*! @brief Set the DMA_CH_DB_MODE_SEL_0 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_0(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_1[1] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1 (1U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1 (0x00000002U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_1)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1)

/*! @brief Set the DMA_CH_DB_MODE_SEL_1 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_1(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_2[2] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2 (2U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2 (0x00000004U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_2)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2)

/*! @brief Set the DMA_CH_DB_MODE_SEL_2 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_2(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_3[3] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3 (3U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3 (0x00000008U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_3)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3)

/*! @brief Set the DMA_CH_DB_MODE_SEL_3 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_3(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_5[5] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5 (5U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5 (0x00000020U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_5)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5)

/*! @brief Set the DMA_CH_DB_MODE_SEL_5 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_5(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_8[8] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8 (8U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8 (0x00000100U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_8)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8)

/*! @brief Set the DMA_CH_DB_MODE_SEL_8 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_8(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_9[9] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9 (9U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9 (0x00000200U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_9)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9)

/*! @brief Set the DMA_CH_DB_MODE_SEL_9 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_9(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_10[10] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10 (10U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10 (0x00000400U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_10)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10)

/*! @brief Set the DMA_CH_DB_MODE_SEL_10 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_10(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_11[11] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11 (11U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11 (0x00000800U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_11)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11)

/*! @brief Set the DMA_CH_DB_MODE_SEL_11 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_11(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_12[12] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12 (12U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12 (0x00001000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_12)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12)

/*! @brief Set the DMA_CH_DB_MODE_SEL_12 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_12(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_13[13] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13 (13U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13 (0x00002000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_13)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13)

/*! @brief Set the DMA_CH_DB_MODE_SEL_13 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_13(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_14[14] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14 (14U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14 (0x00004000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_14)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14)

/*! @brief Set the DMA_CH_DB_MODE_SEL_14 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_14(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_15[15] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15 (15U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15 (0x00008000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_15)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15)

/*! @brief Set the DMA_CH_DB_MODE_SEL_15 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_15(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_17[17] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17 (17U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17 (0x00020000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_17)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17)

/*! @brief Set the DMA_CH_DB_MODE_SEL_17 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_17(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_18[18] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18 (18U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18 (0x00040000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_18)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18)

/*! @brief Set the DMA_CH_DB_MODE_SEL_18 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_18(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_19[19] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19 (19U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19 (0x00080000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_19)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19)

/*! @brief Set the DMA_CH_DB_MODE_SEL_19 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_19(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_20[20] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20 (20U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20 (0x00100000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_20)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20)

/*! @brief Set the DMA_CH_DB_MODE_SEL_20 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_20(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_21[21] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21 (21U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21 (0x00200000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_21)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21)

/*! @brief Set the DMA_CH_DB_MODE_SEL_21 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_21(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_22[22] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22 (22U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22 (0x00400000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_22)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22)

/*! @brief Set the DMA_CH_DB_MODE_SEL_22 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_22(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_23[23] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23 (23U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23 (0x00800000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_23)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23)

/*! @brief Set the DMA_CH_DB_MODE_SEL_23 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_23(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_24[24] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24 (24U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24 (0x01000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_24)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24)

/*! @brief Set the DMA_CH_DB_MODE_SEL_24 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_24(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_25[25] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25 (25U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25 (0x02000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_25)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25)

/*! @brief Set the DMA_CH_DB_MODE_SEL_25 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_25(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_26[26] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26 (26U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26 (0x04000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_26)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26)

/*! @brief Set the DMA_CH_DB_MODE_SEL_26 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_26(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_27[27] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27 (27U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27 (0x08000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_27)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27)

/*! @brief Set the DMA_CH_DB_MODE_SEL_27 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_27(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_28[28] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28 (28U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28 (0x10000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_28)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28)

/*! @brief Set the DMA_CH_DB_MODE_SEL_28 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_28(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_29[29] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29 (29U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29 (0x20000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_29)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29)

/*! @brief Set the DMA_CH_DB_MODE_SEL_29 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_29(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL0, field DMA_CH_DB_MODE_SEL_31[31] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31 (31U) /*!< Bit position for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31. */
#define BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31 (0x80000000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31. */
#define BS_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31 field. */
#define BR_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31(x) (HW_IPU_CH_DB_MODE_SEL0(x).B.DMA_CH_DB_MODE_SEL_31)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31. */
#define BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31) & BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31)

/*! @brief Set the DMA_CH_DB_MODE_SEL_31 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31(x, v) (HW_IPU_CH_DB_MODE_SEL0_WR(x, (HW_IPU_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31) | BF_IPU_CH_DB_MODE_SEL0_DMA_CH_DB_MODE_SEL_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_DB_MODE_SEL1 - Channel Double Buffer Mode Select 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_DB_MODE_SEL1 - Channel Double Buffer Mode Select 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains double buffer mode select control information for 32
 * IPU's DMA channels.
 */
typedef union _hw_ipu_ch_db_mode_sel1
{
    uint32_t U;
    struct _hw_ipu_ch_db_mode_sel1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_DB_MODE_SEL_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t DMA_CH_DB_MODE_SEL_40 : 1; /*!< [8]  */
        uint32_t DMA_CH_DB_MODE_SEL_41 : 1; /*!< [9]  */
        uint32_t DMA_CH_DB_MODE_SEL_42 : 1; /*!< [10]  */
        uint32_t DMA_CH_DB_MODE_SEL_43 : 1; /*!< [11]  */
        uint32_t DMA_CH_DB_MODE_SEL_44 : 1; /*!< [12]  */
        uint32_t DMA_CH_DB_MODE_SEL_45 : 1; /*!< [13]  */
        uint32_t DMA_CH_DB_MODE_SEL_46 : 1; /*!< [14]  */
        uint32_t DMA_CH_DB_MODE_SEL_47 : 1; /*!< [15]  */
        uint32_t DMA_CH_DB_MODE_SEL_48 : 1; /*!< [16]  */
        uint32_t DMA_CH_DB_MODE_SEL_49 : 1; /*!< [17]  */
        uint32_t DMA_CH_DB_MODE_SEL_50 : 1; /*!< [18]  */
        uint32_t DMA_CH_DB_MODE_SEL_51 : 1; /*!< [19]  */
        uint32_t DMA_CH_DB_MODE_SEL_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_ch_db_mode_sel1_t;

/*!
 * @name Constants and macros for entire IPU_CH_DB_MODE_SEL1 register
 */
/*@{*/
#define HW_IPU_CH_DB_MODE_SEL1_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_IPU_CH_DB_MODE_SEL1(x) (*(__IO hw_ipu_ch_db_mode_sel1_t *) HW_IPU_CH_DB_MODE_SEL1_ADDR(x))
#define HW_IPU_CH_DB_MODE_SEL1_RD(x) (HW_IPU_CH_DB_MODE_SEL1(x).U)
#define HW_IPU_CH_DB_MODE_SEL1_WR(x, v) (HW_IPU_CH_DB_MODE_SEL1(x).U = (v))
#define HW_IPU_CH_DB_MODE_SEL1_SET(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, HW_IPU_CH_DB_MODE_SEL1_RD(x) |  (v)))
#define HW_IPU_CH_DB_MODE_SEL1_CLR(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~(v)))
#define HW_IPU_CH_DB_MODE_SEL1_TOG(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, HW_IPU_CH_DB_MODE_SEL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_DB_MODE_SEL1 bitfields
 */

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_33[1] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33 (1U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33 (0x00000002U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_33)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33)

/*! @brief Set the DMA_CH_DB_MODE_SEL_33 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_33(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_40[8] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40 (8U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40 (0x00000100U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_40)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40)

/*! @brief Set the DMA_CH_DB_MODE_SEL_40 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_40(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_41[9] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41 (9U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41 (0x00000200U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_41)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41)

/*! @brief Set the DMA_CH_DB_MODE_SEL_41 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_41(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_42[10] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42 (10U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42 (0x00000400U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_42)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42)

/*! @brief Set the DMA_CH_DB_MODE_SEL_42 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_42(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_43[11] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43 (11U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43 (0x00000800U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_43)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43)

/*! @brief Set the DMA_CH_DB_MODE_SEL_43 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_43(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_44[12] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44 (12U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44 (0x00001000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_44)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44)

/*! @brief Set the DMA_CH_DB_MODE_SEL_44 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_44(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_45[13] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45 (13U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45 (0x00002000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_45)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45)

/*! @brief Set the DMA_CH_DB_MODE_SEL_45 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_45(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_46[14] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46 (14U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46 (0x00004000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_46)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46)

/*! @brief Set the DMA_CH_DB_MODE_SEL_46 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_46(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_47[15] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47 (15U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47 (0x00008000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_47)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47)

/*! @brief Set the DMA_CH_DB_MODE_SEL_47 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_47(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_48[16] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48 (16U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48 (0x00010000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_48)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48)

/*! @brief Set the DMA_CH_DB_MODE_SEL_48 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_48(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_49[17] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49 (17U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49 (0x00020000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_49)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49)

/*! @brief Set the DMA_CH_DB_MODE_SEL_49 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_49(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_50[18] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50 (18U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50 (0x00040000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_50)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50)

/*! @brief Set the DMA_CH_DB_MODE_SEL_50 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_50(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_51[19] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51 (19U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51 (0x00080000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_51)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51)

/*! @brief Set the DMA_CH_DB_MODE_SEL_51 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_51(v)))
/*@}*/

/*!
 * @name Register IPU_CH_DB_MODE_SEL1, field DMA_CH_DB_MODE_SEL_52[20] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52 (20U) /*!< Bit position for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52. */
#define BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52 (0x00100000U) /*!< Bit mask for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52. */
#define BS_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52 (1U) /*!< Bit field size in bits for IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52. */

/*! @brief Read current value of the IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52 field. */
#define BR_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52(x) (HW_IPU_CH_DB_MODE_SEL1(x).B.DMA_CH_DB_MODE_SEL_52)

/*! @brief Format value for bitfield IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52. */
#define BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52) & BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52)

/*! @brief Set the DMA_CH_DB_MODE_SEL_52 field to a new value. */
#define BW_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52(x, v) (HW_IPU_CH_DB_MODE_SEL1_WR(x, (HW_IPU_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52) | BF_IPU_CH_DB_MODE_SEL1_DMA_CH_DB_MODE_SEL_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_DB_MODE_SEL0 - Alternate Channel Double Buffer Mode Select 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_DB_MODE_SEL0 - Alternate Channel Double Buffer Mode Select 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains double buffer mode select control information for 32
 * IPU's DMA channels.
 */
typedef union _hw_ipu_alt_ch_db_mode_sel0
{
    uint32_t U;
    struct _hw_ipu_alt_ch_db_mode_sel0_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_4 : 1; /*!< [4]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_5 : 1; /*!< [5]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_6 : 1; /*!< [6]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_7 : 1; /*!< [7]  */
        uint32_t RESERVED1 : 16;       /*!< [23:8]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_24 : 1; /*!< [24]  */
        uint32_t RESERVED2 : 4;        /*!< [28:25]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_alt_ch_db_mode_sel0_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_DB_MODE_SEL0 register
 */
/*@{*/
#define HW_IPU_ALT_CH_DB_MODE_SEL0_ADDR(x) ((uintptr_t)(x) + 0x168U)

#define HW_IPU_ALT_CH_DB_MODE_SEL0(x) (*(__IO hw_ipu_alt_ch_db_mode_sel0_t *) HW_IPU_ALT_CH_DB_MODE_SEL0_ADDR(x))
#define HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).U)
#define HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).U = (v))
#define HW_IPU_ALT_CH_DB_MODE_SEL0_SET(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) |  (v)))
#define HW_IPU_ALT_CH_DB_MODE_SEL0_CLR(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_DB_MODE_SEL0_TOG(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_DB_MODE_SEL0 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_4[4] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4 (4U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4 (0x00000010U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_4)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_4 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_4(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_5[5] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5 (5U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5 (0x00000020U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_5)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_5 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_5(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_6[6] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6 (6U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6 (0x00000040U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_6)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_6 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_6(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_7[7] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7 (7U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7 (0x00000080U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_7)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_7 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_7(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_24[24] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24 (24U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24 (0x01000000U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_24)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_24 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_24(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL0, field DMA_CH_ALT_DB_MODE_SEL_29[29] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29 (29U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29. */
#define BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29 (0x20000000U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29. */
#define BS_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29(x) (HW_IPU_ALT_CH_DB_MODE_SEL0(x).B.DMA_CH_ALT_DB_MODE_SEL_29)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29. */
#define BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29) & BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_29 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29) | BF_IPU_ALT_CH_DB_MODE_SEL0_DMA_CH_ALT_DB_MODE_SEL_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_DB_MODE_SEL1 - Alternate Channel Double Buffer Mode Select1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_DB_MODE_SEL1 - Alternate Channel Double Buffer Mode Select1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains double buffer mode select control information for 32
 * IPU's DMA channels.
 */
typedef union _hw_ipu_alt_ch_db_mode_sel1
{
    uint32_t U;
    struct _hw_ipu_alt_ch_db_mode_sel1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_41 : 1; /*!< [9]  */
        uint32_t RESERVED2 : 10;       /*!< [19:10]  */
        uint32_t DMA_CH_ALT_DB_MODE_SEL_52 : 1; /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_alt_ch_db_mode_sel1_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_DB_MODE_SEL1 register
 */
/*@{*/
#define HW_IPU_ALT_CH_DB_MODE_SEL1_ADDR(x) ((uintptr_t)(x) + 0x16CU)

#define HW_IPU_ALT_CH_DB_MODE_SEL1(x) (*(__IO hw_ipu_alt_ch_db_mode_sel1_t *) HW_IPU_ALT_CH_DB_MODE_SEL1_ADDR(x))
#define HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) (HW_IPU_ALT_CH_DB_MODE_SEL1(x).U)
#define HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1(x).U = (v))
#define HW_IPU_ALT_CH_DB_MODE_SEL1_SET(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) |  (v)))
#define HW_IPU_ALT_CH_DB_MODE_SEL1_CLR(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_DB_MODE_SEL1_TOG(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_DB_MODE_SEL1 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL1, field DMA_CH_ALT_DB_MODE_SEL_33[1] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33 (1U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33. */
#define BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33 (0x00000002U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33. */
#define BS_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33(x) (HW_IPU_ALT_CH_DB_MODE_SEL1(x).B.DMA_CH_ALT_DB_MODE_SEL_33)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33. */
#define BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33) & BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_33 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33) | BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_33(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL1, field DMA_CH_ALT_DB_MODE_SEL_41[9] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41 (9U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41. */
#define BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41 (0x00000200U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41. */
#define BS_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41(x) (HW_IPU_ALT_CH_DB_MODE_SEL1(x).B.DMA_CH_ALT_DB_MODE_SEL_41)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41. */
#define BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41) & BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_41 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41) | BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_41(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_DB_MODE_SEL1, field DMA_CH_ALT_DB_MODE_SEL_52[20] (RW)
 *
 * Double Buffer Mode Select. This bit indicates if a double buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Double buffer is not used for this channel.
 * - 1 - Double buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52 (20U) /*!< Bit position for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52. */
#define BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52 (0x00100000U) /*!< Bit mask for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52. */
#define BS_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52 (1U) /*!< Bit field size in bits for IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52. */

/*! @brief Read current value of the IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52 field. */
#define BR_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52(x) (HW_IPU_ALT_CH_DB_MODE_SEL1(x).B.DMA_CH_ALT_DB_MODE_SEL_52)

/*! @brief Format value for bitfield IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52. */
#define BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52) & BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52)

/*! @brief Set the DMA_CH_ALT_DB_MODE_SEL_52 field to a new value. */
#define BW_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52(x, v) (HW_IPU_ALT_CH_DB_MODE_SEL1_WR(x, (HW_IPU_ALT_CH_DB_MODE_SEL1_RD(x) & ~BM_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52) | BF_IPU_ALT_CH_DB_MODE_SEL1_DMA_CH_ALT_DB_MODE_SEL_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_TRB_MODE_SEL0 - Alternate Channel Triple Buffer Mode Select 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_TRB_MODE_SEL0 - Alternate Channel Triple Buffer Mode Select 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains triple buffer mode select control information for 32
 * IPU's DMA channels. When the channel is configured for triple buffer mode. The
 * double buffer mode settings configured on the corresponding DB_MODE_SEL bit are
 * overridden. Hide VPU_SUB_FRAME_SYNC for all versions Show VPU_SUB_FRAME_SYNC
 * for IPUv3H version. The table below tagged with other settings (like
 * IPU3M_only) should be hidden in IPUv3H version. This requires some sophisticated
 * conditional tag settings
 */
typedef union _hw_ipu_alt_ch_trb_mode_sel0
{
    uint32_t U;
    struct _hw_ipu_alt_ch_trb_mode_sel0_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t DMA_CH_TRB_MODE_SEL_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_TRB_MODE_SEL_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_TRB_MODE_SEL_10 : 1; /*!< [10]  */
        uint32_t RESERVED1 : 2;        /*!< [12:11]  */
        uint32_t DMA_CH_TRB_MODE_SEL_13 : 1; /*!< [13]  */
        uint32_t RESERVED2 : 7;        /*!< [20:14]  */
        uint32_t DMA_CH_TRB_MODE_SEL_21 : 1; /*!< [21]  */
        uint32_t RESERVED3 : 1;        /*!< [22]  */
        uint32_t DMA_CH_TRB_MODE_SEL_23 : 1; /*!< [23]  */
        uint32_t RESERVED4 : 3;        /*!< [26:24]  */
        uint32_t DMA_CH_TRB_MODE_SEL_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_TRB_MODE_SEL_28 : 1; /*!< [28]  */
        uint32_t RESERVED5 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_alt_ch_trb_mode_sel0_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_TRB_MODE_SEL0 register
 */
/*@{*/
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_ADDR(x) ((uintptr_t)(x) + 0x178U)

#define HW_IPU_ALT_CH_TRB_MODE_SEL0(x) (*(__IO hw_ipu_alt_ch_trb_mode_sel0_t *) HW_IPU_ALT_CH_TRB_MODE_SEL0_ADDR(x))
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).U)
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).U = (v))
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_SET(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) |  (v)))
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_CLR(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_TRB_MODE_SEL0_TOG(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_TRB_MODE_SEL0 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_8[8] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8 (8U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8 (0x00000100U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_8)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_8 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_8(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_9[9] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9 (9U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9 (0x00000200U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_9)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_9 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_9(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_10[10] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10 (10U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10 (0x00000400U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_10)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_10 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_10(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_13[13] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13 (13U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13 (0x00002000U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_13)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_13 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_13(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_21[21] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21 (21U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21 (0x00200000U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_21)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_21 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_21(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_23[23] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23 (23U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23 (0x00800000U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_23)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_23 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_23(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_27[27] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27 (27U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27 (0x08000000U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_27)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_27 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_27(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL0, field DMA_CH_TRB_MODE_SEL_28[28] (RW)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28 (28U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28 (0x10000000U) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28 (1U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28 field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28(x) (HW_IPU_ALT_CH_TRB_MODE_SEL0(x).B.DMA_CH_TRB_MODE_SEL_28)

/*! @brief Format value for bitfield IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28. */
#define BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28) & BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28)

/*! @brief Set the DMA_CH_TRB_MODE_SEL_28 field to a new value. */
#define BW_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28(x, v) (HW_IPU_ALT_CH_TRB_MODE_SEL0_WR(x, (HW_IPU_ALT_CH_TRB_MODE_SEL0_RD(x) & ~BM_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28) | BF_IPU_ALT_CH_TRB_MODE_SEL0_DMA_CH_TRB_MODE_SEL_28(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_TRB_MODE_SEL1 - Alternate Channel Triple Buffer Mode Select 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_TRB_MODE_SEL1 - Alternate Channel Triple Buffer Mode Select 1 Register (ROZ)
 *
 * Reset value: 0x00000000U
 *
 * The register contains triple buffer mode select control information for 32
 * IPU's DMA channels. When the channel is configured for triple buffer mode. The
 * double buffer mode settings configured on the corresponding DB_MODE_SEL bit are
 * overridden.
 */
typedef union _hw_ipu_alt_ch_trb_mode_sel1
{
    uint32_t U;
    struct _hw_ipu_alt_ch_trb_mode_sel1_bitfields
    {
        uint32_t DMA_CH_TRB_MODE_SEL_n : 32; /*!< [31:0]  */
    } B;
} hw_ipu_alt_ch_trb_mode_sel1_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_TRB_MODE_SEL1 register
 */
/*@{*/
#define HW_IPU_ALT_CH_TRB_MODE_SEL1_ADDR(x) ((uintptr_t)(x) + 0x17CU)

#define HW_IPU_ALT_CH_TRB_MODE_SEL1(x) (*(__I hw_ipu_alt_ch_trb_mode_sel1_t *) HW_IPU_ALT_CH_TRB_MODE_SEL1_ADDR(x))
#define HW_IPU_ALT_CH_TRB_MODE_SEL1_RD(x) (HW_IPU_ALT_CH_TRB_MODE_SEL1(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_TRB_MODE_SEL1 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_TRB_MODE_SEL1, field DMA_CH_TRB_MODE_SEL_n[31:0] (ROZ)
 *
 * Triple Buffer Mode Select. This bit indicates if a triple buffer is used for
 * this channel. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Triple buffer is not used for this channel.
 * - 1 - Triple buffer is used for this channel.
 */
/*@{*/
#define BP_IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n (0U) /*!< Bit position for IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n. */
#define BM_IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n (0xFFFFFFFFU) /*!< Bit mask for IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n. */
#define BS_IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n (32U) /*!< Bit field size in bits for IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n. */

/*! @brief Read current value of the IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n field. */
#define BR_IPU_ALT_CH_TRB_MODE_SEL1_DMA_CH_TRB_MODE_SEL_n(x) (HW_IPU_ALT_CH_TRB_MODE_SEL1(x).U)
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_1 - Interrupt Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_1 - Interrupt Status Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of EOF
 * (end of frame) of DMA Channels interrupts [31:0] can be found in this register.
 */
typedef union _hw_ipu_int_stat_1
{
    uint32_t U;
    struct _hw_ipu_int_stat_1_bitfields
    {
        uint32_t IDMAC_EOF_0 : 1;      /*!< [0]  */
        uint32_t IDMAC_EOF_1 : 1;      /*!< [1]  */
        uint32_t IDMAC_EOF_2 : 1;      /*!< [2]  */
        uint32_t IDMAC_EOF_3 : 1;      /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOF_5 : 1;      /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_EOF_8 : 1;      /*!< [8]  */
        uint32_t IDMAC_EOF_9 : 1;      /*!< [9]  */
        uint32_t IDMAC_EOF_10 : 1;     /*!< [10]  */
        uint32_t IDMAC_EOF_11 : 1;     /*!< [11]  */
        uint32_t IDMAC_EOF_12 : 1;     /*!< [12]  */
        uint32_t IDMAC_EOF_13 : 1;     /*!< [13]  */
        uint32_t IDMAC_EOF_14 : 1;     /*!< [14]  */
        uint32_t IDMAC_EOF_15 : 1;     /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_EOF_17 : 1;     /*!< [17]  */
        uint32_t IDMAC_EOF_18 : 1;     /*!< [18]  */
        uint32_t IDMAC_EOF_19 : 1;     /*!< [19]  */
        uint32_t IDMAC_EOF_20 : 1;     /*!< [20]  */
        uint32_t IDMAC_EOF_21 : 1;     /*!< [21]  */
        uint32_t IDMAC_EOF_22 : 1;     /*!< [22]  */
        uint32_t IDMAC_EOF_23 : 1;     /*!< [23]  */
        uint32_t IDMAC_EOF_24 : 1;     /*!< [24]  */
        uint32_t IDMAC_EOF_25 : 1;     /*!< [25]  */
        uint32_t IDMAC_EOF_26 : 1;     /*!< [26]  */
        uint32_t IDMAC_EOF_27 : 1;     /*!< [27]  */
        uint32_t IDMAC_EOF_28 : 1;     /*!< [28]  */
        uint32_t IDMAC_EOF_29 : 1;     /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOF_31 : 1;     /*!< [31]  */
    } B;
} hw_ipu_int_stat_1_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_1 register
 */
/*@{*/
#define HW_IPU_INT_STAT_1_ADDR(x) ((uintptr_t)(x) + 0x200U)

#define HW_IPU_INT_STAT_1(x)     (*(__IO hw_ipu_int_stat_1_t *) HW_IPU_INT_STAT_1_ADDR(x))
#define HW_IPU_INT_STAT_1_RD(x)  (HW_IPU_INT_STAT_1(x).U)
#define HW_IPU_INT_STAT_1_WR(x, v) (HW_IPU_INT_STAT_1(x).U = (v))
#define HW_IPU_INT_STAT_1_SET(x, v) (HW_IPU_INT_STAT_1_WR(x, HW_IPU_INT_STAT_1_RD(x) |  (v)))
#define HW_IPU_INT_STAT_1_CLR(x, v) (HW_IPU_INT_STAT_1_WR(x, HW_IPU_INT_STAT_1_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_1_TOG(x, v) (HW_IPU_INT_STAT_1_WR(x, HW_IPU_INT_STAT_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_1 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_0[0] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_0 (0U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_0. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_0 (0x00000001U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_0. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_0. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_0 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_0(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_0)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_0. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_0) & BM_IPU_INT_STAT_1_IDMAC_EOF_0)

/*! @brief Set the IDMAC_EOF_0 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_0(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_1[1] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_1 (1U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_1. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_1 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_1. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_1. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_1 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_1(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_1)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_1. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_1) & BM_IPU_INT_STAT_1_IDMAC_EOF_1)

/*! @brief Set the IDMAC_EOF_1 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_1(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_2[2] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_2 (2U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_2. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_2 (0x00000004U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_2. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_2. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_2 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_2(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_2)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_2. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_2) & BM_IPU_INT_STAT_1_IDMAC_EOF_2)

/*! @brief Set the IDMAC_EOF_2 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_2(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_3[3] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_3 (3U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_3. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_3 (0x00000008U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_3. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_3. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_3 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_3(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_3)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_3. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_3) & BM_IPU_INT_STAT_1_IDMAC_EOF_3)

/*! @brief Set the IDMAC_EOF_3 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_3(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_5[5] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_5 (5U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_5. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_5 (0x00000020U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_5. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_5. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_5 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_5(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_5)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_5. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_5) & BM_IPU_INT_STAT_1_IDMAC_EOF_5)

/*! @brief Set the IDMAC_EOF_5 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_5(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_8[8] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_8 (8U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_8. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_8 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_8. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_8. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_8 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_8(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_8)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_8. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_8) & BM_IPU_INT_STAT_1_IDMAC_EOF_8)

/*! @brief Set the IDMAC_EOF_8 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_8(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_9[9] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_9 (9U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_9. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_9 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_9. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_9 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_9. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_9 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_9(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_9)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_9. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_9) & BM_IPU_INT_STAT_1_IDMAC_EOF_9)

/*! @brief Set the IDMAC_EOF_9 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_9(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_10[10] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_10 (10U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_10. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_10 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_10. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_10 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_10. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_10 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_10(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_10)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_10. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_10) & BM_IPU_INT_STAT_1_IDMAC_EOF_10)

/*! @brief Set the IDMAC_EOF_10 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_10(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_11[11] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_11 (11U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_11. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_11 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_11. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_11 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_11. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_11 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_11(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_11)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_11. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_11) & BM_IPU_INT_STAT_1_IDMAC_EOF_11)

/*! @brief Set the IDMAC_EOF_11 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_11(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_12[12] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_12 (12U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_12. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_12 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_12. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_12 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_12. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_12 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_12(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_12)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_12. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_12) & BM_IPU_INT_STAT_1_IDMAC_EOF_12)

/*! @brief Set the IDMAC_EOF_12 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_12(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_13[13] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_13 (13U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_13. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_13 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_13. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_13 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_13. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_13 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_13(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_13)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_13. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_13) & BM_IPU_INT_STAT_1_IDMAC_EOF_13)

/*! @brief Set the IDMAC_EOF_13 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_13(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_14[14] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_14 (14U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_14. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_14 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_14. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_14 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_14. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_14 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_14(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_14)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_14. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_14) & BM_IPU_INT_STAT_1_IDMAC_EOF_14)

/*! @brief Set the IDMAC_EOF_14 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_14(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_15[15] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_15 (15U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_15. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_15 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_15. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_15 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_15. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_15 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_15(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_15)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_15. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_15) & BM_IPU_INT_STAT_1_IDMAC_EOF_15)

/*! @brief Set the IDMAC_EOF_15 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_15(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_17[17] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_17 (17U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_17. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_17 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_17. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_17 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_17. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_17 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_17(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_17)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_17. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_17) & BM_IPU_INT_STAT_1_IDMAC_EOF_17)

/*! @brief Set the IDMAC_EOF_17 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_17(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_18[18] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_18 (18U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_18. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_18 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_18. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_18 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_18. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_18 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_18(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_18)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_18. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_18) & BM_IPU_INT_STAT_1_IDMAC_EOF_18)

/*! @brief Set the IDMAC_EOF_18 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_18(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_19[19] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_19 (19U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_19. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_19 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_19. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_19 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_19. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_19 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_19(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_19)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_19. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_19) & BM_IPU_INT_STAT_1_IDMAC_EOF_19)

/*! @brief Set the IDMAC_EOF_19 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_19(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_20[20] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_20 (20U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_20. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_20 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_20. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_20 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_20. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_20 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_20(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_20)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_20. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_20) & BM_IPU_INT_STAT_1_IDMAC_EOF_20)

/*! @brief Set the IDMAC_EOF_20 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_20(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_21[21] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_21 (21U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_21. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_21 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_21. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_21 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_21. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_21 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_21(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_21)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_21. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_21) & BM_IPU_INT_STAT_1_IDMAC_EOF_21)

/*! @brief Set the IDMAC_EOF_21 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_21(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_22[22] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_22 (22U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_22. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_22 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_22. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_22 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_22. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_22 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_22(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_22)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_22. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_22) & BM_IPU_INT_STAT_1_IDMAC_EOF_22)

/*! @brief Set the IDMAC_EOF_22 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_22(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_23[23] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_23 (23U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_23. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_23 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_23. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_23 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_23. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_23 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_23(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_23)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_23. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_23) & BM_IPU_INT_STAT_1_IDMAC_EOF_23)

/*! @brief Set the IDMAC_EOF_23 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_23(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_24[24] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_24 (24U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_24. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_24 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_24. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_24 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_24. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_24 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_24(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_24)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_24. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_24) & BM_IPU_INT_STAT_1_IDMAC_EOF_24)

/*! @brief Set the IDMAC_EOF_24 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_24(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_25[25] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_25 (25U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_25. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_25. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_25. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_25 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_25(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_25)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_25. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_25) & BM_IPU_INT_STAT_1_IDMAC_EOF_25)

/*! @brief Set the IDMAC_EOF_25 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_25(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_26[26] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_26 (26U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_26. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_26. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_26. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_26 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_26(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_26)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_26. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_26) & BM_IPU_INT_STAT_1_IDMAC_EOF_26)

/*! @brief Set the IDMAC_EOF_26 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_26(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_27[27] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_27 (27U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_27. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_27 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_27. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_27 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_27. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_27 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_27(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_27)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_27. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_27) & BM_IPU_INT_STAT_1_IDMAC_EOF_27)

/*! @brief Set the IDMAC_EOF_27 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_27(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_28[28] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_28 (28U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_28. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_28 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_28. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_28 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_28. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_28 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_28(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_28)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_28. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_28) & BM_IPU_INT_STAT_1_IDMAC_EOF_28)

/*! @brief Set the IDMAC_EOF_28 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_28(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_29[29] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_29 (29U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_29. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_29 (0x20000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_29. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_29 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_29. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_29 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_29(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_29)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_29. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_29) & BM_IPU_INT_STAT_1_IDMAC_EOF_29)

/*! @brief Set the IDMAC_EOF_29 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_29(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_29 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_31)) | BF_IPU_INT_STAT_1_IDMAC_EOF_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_1, field IDMAC_EOF_31[31] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_1_IDMAC_EOF_31 (31U) /*!< Bit position for IPU_INT_STAT_1_IDMAC_EOF_31. */
#define BM_IPU_INT_STAT_1_IDMAC_EOF_31 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_1_IDMAC_EOF_31. */
#define BS_IPU_INT_STAT_1_IDMAC_EOF_31 (1U) /*!< Bit field size in bits for IPU_INT_STAT_1_IDMAC_EOF_31. */

/*! @brief Read current value of the IPU_INT_STAT_1_IDMAC_EOF_31 field. */
#define BR_IPU_INT_STAT_1_IDMAC_EOF_31(x) (HW_IPU_INT_STAT_1(x).B.IDMAC_EOF_31)

/*! @brief Format value for bitfield IPU_INT_STAT_1_IDMAC_EOF_31. */
#define BF_IPU_INT_STAT_1_IDMAC_EOF_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_1_IDMAC_EOF_31) & BM_IPU_INT_STAT_1_IDMAC_EOF_31)

/*! @brief Set the IDMAC_EOF_31 field to a new value. */
#define BW_IPU_INT_STAT_1_IDMAC_EOF_31(x, v) (HW_IPU_INT_STAT_1_WR(x, (HW_IPU_INT_STAT_1_RD(x) & ~(BM_IPU_INT_STAT_1_IDMAC_EOF_31 | BM_IPU_INT_STAT_1_IDMAC_EOF_0 | BM_IPU_INT_STAT_1_IDMAC_EOF_1 | BM_IPU_INT_STAT_1_IDMAC_EOF_2 | BM_IPU_INT_STAT_1_IDMAC_EOF_3 | BM_IPU_INT_STAT_1_IDMAC_EOF_5 | BM_IPU_INT_STAT_1_IDMAC_EOF_8 | BM_IPU_INT_STAT_1_IDMAC_EOF_9 | BM_IPU_INT_STAT_1_IDMAC_EOF_10 | BM_IPU_INT_STAT_1_IDMAC_EOF_11 | BM_IPU_INT_STAT_1_IDMAC_EOF_12 | BM_IPU_INT_STAT_1_IDMAC_EOF_13 | BM_IPU_INT_STAT_1_IDMAC_EOF_14 | BM_IPU_INT_STAT_1_IDMAC_EOF_15 | BM_IPU_INT_STAT_1_IDMAC_EOF_17 | BM_IPU_INT_STAT_1_IDMAC_EOF_18 | BM_IPU_INT_STAT_1_IDMAC_EOF_19 | BM_IPU_INT_STAT_1_IDMAC_EOF_20 | BM_IPU_INT_STAT_1_IDMAC_EOF_21 | BM_IPU_INT_STAT_1_IDMAC_EOF_22 | BM_IPU_INT_STAT_1_IDMAC_EOF_23 | BM_IPU_INT_STAT_1_IDMAC_EOF_24 | BM_IPU_INT_STAT_1_IDMAC_EOF_25 | BM_IPU_INT_STAT_1_IDMAC_EOF_26 | BM_IPU_INT_STAT_1_IDMAC_EOF_27 | BM_IPU_INT_STAT_1_IDMAC_EOF_28 | BM_IPU_INT_STAT_1_IDMAC_EOF_29)) | BF_IPU_INT_STAT_1_IDMAC_EOF_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_2 - Interrupt Status Register2
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_2 - Interrupt Status Register2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of EOF
 * (end of frame) of DMA Channels interrupts [63:32] can be found in this register.
 */
typedef union _hw_ipu_int_stat_2
{
    uint32_t U;
    struct _hw_ipu_int_stat_2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOF_33 : 1;     /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_EOF_40 : 1;     /*!< [8]  */
        uint32_t IDMAC_EOF_41 : 1;     /*!< [9]  */
        uint32_t IDMAC_EOF_42 : 1;     /*!< [10]  */
        uint32_t IDMAC_EOF_43 : 1;     /*!< [11]  */
        uint32_t IDMAC_EOF_44 : 1;     /*!< [12]  */
        uint32_t IDMAC_EOF_45 : 1;     /*!< [13]  */
        uint32_t IDMAC_EOF_46 : 1;     /*!< [14]  */
        uint32_t IDMAC_EOF_47 : 1;     /*!< [15]  */
        uint32_t IDMAC_EOF_48 : 1;     /*!< [16]  */
        uint32_t IDMAC_EOF_49 : 1;     /*!< [17]  */
        uint32_t IDMAC_EOF_50 : 1;     /*!< [18]  */
        uint32_t IDMAC_EOF_51 : 1;     /*!< [19]  */
        uint32_t IDMAC_EOF_52 : 1;     /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_stat_2_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_2 register
 */
/*@{*/
#define HW_IPU_INT_STAT_2_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_IPU_INT_STAT_2(x)     (*(__IO hw_ipu_int_stat_2_t *) HW_IPU_INT_STAT_2_ADDR(x))
#define HW_IPU_INT_STAT_2_RD(x)  (HW_IPU_INT_STAT_2(x).U)
#define HW_IPU_INT_STAT_2_WR(x, v) (HW_IPU_INT_STAT_2(x).U = (v))
#define HW_IPU_INT_STAT_2_SET(x, v) (HW_IPU_INT_STAT_2_WR(x, HW_IPU_INT_STAT_2_RD(x) |  (v)))
#define HW_IPU_INT_STAT_2_CLR(x, v) (HW_IPU_INT_STAT_2_WR(x, HW_IPU_INT_STAT_2_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_2_TOG(x, v) (HW_IPU_INT_STAT_2_WR(x, HW_IPU_INT_STAT_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_2 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_33[1] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_33 (1U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_33. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_33 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_33. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_33 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_33. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_33 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_33(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_33)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_33. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_33) & BM_IPU_INT_STAT_2_IDMAC_EOF_33)

/*! @brief Set the IDMAC_EOF_33 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_33(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_40[8] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_40 (8U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_40. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_40 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_40. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_40 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_40. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_40 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_40(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_40)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_40. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_40) & BM_IPU_INT_STAT_2_IDMAC_EOF_40)

/*! @brief Set the IDMAC_EOF_40 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_40(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_41[9] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_41 (9U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_41. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_41 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_41. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_41 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_41. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_41 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_41(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_41)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_41. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_41) & BM_IPU_INT_STAT_2_IDMAC_EOF_41)

/*! @brief Set the IDMAC_EOF_41 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_41(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_42[10] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_42 (10U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_42. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_42 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_42. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_42 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_42. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_42 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_42(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_42)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_42. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_42) & BM_IPU_INT_STAT_2_IDMAC_EOF_42)

/*! @brief Set the IDMAC_EOF_42 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_42(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_43[11] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_43 (11U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_43. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_43 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_43. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_43 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_43. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_43 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_43(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_43)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_43. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_43) & BM_IPU_INT_STAT_2_IDMAC_EOF_43)

/*! @brief Set the IDMAC_EOF_43 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_43(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_44[12] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_44 (12U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_44. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_44 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_44. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_44 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_44. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_44 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_44(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_44)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_44. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_44) & BM_IPU_INT_STAT_2_IDMAC_EOF_44)

/*! @brief Set the IDMAC_EOF_44 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_44(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_45[13] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_45 (13U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_45. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_45 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_45. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_45 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_45. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_45 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_45(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_45)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_45. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_45) & BM_IPU_INT_STAT_2_IDMAC_EOF_45)

/*! @brief Set the IDMAC_EOF_45 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_45(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_46[14] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_46 (14U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_46. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_46 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_46. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_46 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_46. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_46 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_46(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_46)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_46. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_46) & BM_IPU_INT_STAT_2_IDMAC_EOF_46)

/*! @brief Set the IDMAC_EOF_46 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_46(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_47[15] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_47 (15U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_47. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_47 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_47. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_47 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_47. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_47 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_47(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_47)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_47. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_47) & BM_IPU_INT_STAT_2_IDMAC_EOF_47)

/*! @brief Set the IDMAC_EOF_47 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_47(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_48[16] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_48 (16U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_48. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_48 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_48. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_48 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_48. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_48 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_48(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_48)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_48. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_48) & BM_IPU_INT_STAT_2_IDMAC_EOF_48)

/*! @brief Set the IDMAC_EOF_48 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_48(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_49[17] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_49 (17U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_49. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_49 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_49. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_49 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_49. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_49 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_49(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_49)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_49. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_49) & BM_IPU_INT_STAT_2_IDMAC_EOF_49)

/*! @brief Set the IDMAC_EOF_49 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_49(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_50[18] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_50 (18U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_50. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_50 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_50. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_50 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_50. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_50 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_50(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_50)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_50. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_50) & BM_IPU_INT_STAT_2_IDMAC_EOF_50)

/*! @brief Set the IDMAC_EOF_50 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_50(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_51[19] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_51 (19U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_51. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_51 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_51. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_51 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_51. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_51 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_51(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_51)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_51. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_51) & BM_IPU_INT_STAT_2_IDMAC_EOF_51)

/*! @brief Set the IDMAC_EOF_51 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_51(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_51 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_52)) | BF_IPU_INT_STAT_2_IDMAC_EOF_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_2, field IDMAC_EOF_52[20] (W1C)
 *
 * End of Frame of Channel interrupt. This bit is the status bit of End Of Frame
 * of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_2_IDMAC_EOF_52 (20U) /*!< Bit position for IPU_INT_STAT_2_IDMAC_EOF_52. */
#define BM_IPU_INT_STAT_2_IDMAC_EOF_52 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_2_IDMAC_EOF_52. */
#define BS_IPU_INT_STAT_2_IDMAC_EOF_52 (1U) /*!< Bit field size in bits for IPU_INT_STAT_2_IDMAC_EOF_52. */

/*! @brief Read current value of the IPU_INT_STAT_2_IDMAC_EOF_52 field. */
#define BR_IPU_INT_STAT_2_IDMAC_EOF_52(x) (HW_IPU_INT_STAT_2(x).B.IDMAC_EOF_52)

/*! @brief Format value for bitfield IPU_INT_STAT_2_IDMAC_EOF_52. */
#define BF_IPU_INT_STAT_2_IDMAC_EOF_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_2_IDMAC_EOF_52) & BM_IPU_INT_STAT_2_IDMAC_EOF_52)

/*! @brief Set the IDMAC_EOF_52 field to a new value. */
#define BW_IPU_INT_STAT_2_IDMAC_EOF_52(x, v) (HW_IPU_INT_STAT_2_WR(x, (HW_IPU_INT_STAT_2_RD(x) & ~(BM_IPU_INT_STAT_2_IDMAC_EOF_52 | BM_IPU_INT_STAT_2_IDMAC_EOF_33 | BM_IPU_INT_STAT_2_IDMAC_EOF_40 | BM_IPU_INT_STAT_2_IDMAC_EOF_41 | BM_IPU_INT_STAT_2_IDMAC_EOF_42 | BM_IPU_INT_STAT_2_IDMAC_EOF_43 | BM_IPU_INT_STAT_2_IDMAC_EOF_44 | BM_IPU_INT_STAT_2_IDMAC_EOF_45 | BM_IPU_INT_STAT_2_IDMAC_EOF_46 | BM_IPU_INT_STAT_2_IDMAC_EOF_47 | BM_IPU_INT_STAT_2_IDMAC_EOF_48 | BM_IPU_INT_STAT_2_IDMAC_EOF_49 | BM_IPU_INT_STAT_2_IDMAC_EOF_50 | BM_IPU_INT_STAT_2_IDMAC_EOF_51)) | BF_IPU_INT_STAT_2_IDMAC_EOF_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_3 - Interrupt Status Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_3 - Interrupt Status Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of NFACK
 * (New Frame Ack) of DMA Channels interrupts [31:0] can be found in this
 * register.
 */
typedef union _hw_ipu_int_stat_3
{
    uint32_t U;
    struct _hw_ipu_int_stat_3_bitfields
    {
        uint32_t IDMAC_NFACK_0 : 1;    /*!< [0]  */
        uint32_t IDMAC_NFACK_1 : 1;    /*!< [1]  */
        uint32_t IDMAC_NFACK_2 : 1;    /*!< [2]  */
        uint32_t IDMAC_NFACK_3 : 1;    /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_NFACK_5 : 1;    /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_NFACK_8 : 1;    /*!< [8]  */
        uint32_t IDMAC_NFACK_9 : 1;    /*!< [9]  */
        uint32_t IDMAC_NFACK_10 : 1;   /*!< [10]  */
        uint32_t IDMAC_NFACK_11 : 1;   /*!< [11]  */
        uint32_t IDMAC_NFACK_12 : 1;   /*!< [12]  */
        uint32_t IDMAC_NFACK_13 : 1;   /*!< [13]  */
        uint32_t IDMAC_NFACK_14 : 1;   /*!< [14]  */
        uint32_t IDMAC_NFACK_15 : 1;   /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_NFACK_17 : 1;   /*!< [17]  */
        uint32_t IDMAC_NFACK_18 : 1;   /*!< [18]  */
        uint32_t IDMAC_NFACK_19 : 1;   /*!< [19]  */
        uint32_t IDMAC_NFACK_20 : 1;   /*!< [20]  */
        uint32_t IDMAC_NFACK_21 : 1;   /*!< [21]  */
        uint32_t IDMAC_NFACK_22 : 1;   /*!< [22]  */
        uint32_t IDMAC_NFACK_23 : 1;   /*!< [23]  */
        uint32_t IDMAC_NFACK_24 : 1;   /*!< [24]  */
        uint32_t IDMAC_NFACK_25 : 1;   /*!< [25]  */
        uint32_t IDMAC_NFACK_26 : 1;   /*!< [26]  */
        uint32_t IDMAC_NFACK_27 : 1;   /*!< [27]  */
        uint32_t IDMAC_NFACK_28 : 1;   /*!< [28]  */
        uint32_t IDMAC_NFACK_29 : 1;   /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_NFACK_31 : 1;   /*!< [31]  */
    } B;
} hw_ipu_int_stat_3_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_3 register
 */
/*@{*/
#define HW_IPU_INT_STAT_3_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_IPU_INT_STAT_3(x)     (*(__IO hw_ipu_int_stat_3_t *) HW_IPU_INT_STAT_3_ADDR(x))
#define HW_IPU_INT_STAT_3_RD(x)  (HW_IPU_INT_STAT_3(x).U)
#define HW_IPU_INT_STAT_3_WR(x, v) (HW_IPU_INT_STAT_3(x).U = (v))
#define HW_IPU_INT_STAT_3_SET(x, v) (HW_IPU_INT_STAT_3_WR(x, HW_IPU_INT_STAT_3_RD(x) |  (v)))
#define HW_IPU_INT_STAT_3_CLR(x, v) (HW_IPU_INT_STAT_3_WR(x, HW_IPU_INT_STAT_3_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_3_TOG(x, v) (HW_IPU_INT_STAT_3_WR(x, HW_IPU_INT_STAT_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_3 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_0[0] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_0 (0U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_0. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_0 (0x00000001U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_0. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_0. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_0 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_0(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_0)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_0. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_0) & BM_IPU_INT_STAT_3_IDMAC_NFACK_0)

/*! @brief Set the IDMAC_NFACK_0 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_0(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_1[1] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_1 (1U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_1. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_1 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_1. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_1. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_1 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_1(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_1)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_1. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_1) & BM_IPU_INT_STAT_3_IDMAC_NFACK_1)

/*! @brief Set the IDMAC_NFACK_1 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_1(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_2[2] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_2 (2U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_2. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_2 (0x00000004U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_2. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_2. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_2 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_2(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_2)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_2. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_2) & BM_IPU_INT_STAT_3_IDMAC_NFACK_2)

/*! @brief Set the IDMAC_NFACK_2 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_2(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_3[3] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_3 (3U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_3. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_3 (0x00000008U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_3. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_3. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_3 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_3(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_3)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_3. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_3) & BM_IPU_INT_STAT_3_IDMAC_NFACK_3)

/*! @brief Set the IDMAC_NFACK_3 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_3(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_5[5] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_5 (5U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_5. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_5 (0x00000020U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_5. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_5. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_5 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_5(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_5)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_5. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_5) & BM_IPU_INT_STAT_3_IDMAC_NFACK_5)

/*! @brief Set the IDMAC_NFACK_5 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_5(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_8[8] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_8 (8U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_8. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_8 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_8. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_8. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_8 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_8(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_8)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_8. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_8) & BM_IPU_INT_STAT_3_IDMAC_NFACK_8)

/*! @brief Set the IDMAC_NFACK_8 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_8(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_9[9] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_9 (9U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_9. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_9 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_9. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_9 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_9. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_9 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_9(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_9)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_9. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_9) & BM_IPU_INT_STAT_3_IDMAC_NFACK_9)

/*! @brief Set the IDMAC_NFACK_9 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_9(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_10[10] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_10 (10U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_10. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_10 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_10. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_10 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_10. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_10 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_10(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_10)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_10. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_10) & BM_IPU_INT_STAT_3_IDMAC_NFACK_10)

/*! @brief Set the IDMAC_NFACK_10 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_10(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_11[11] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_11 (11U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_11. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_11 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_11. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_11 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_11. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_11 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_11(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_11)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_11. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_11) & BM_IPU_INT_STAT_3_IDMAC_NFACK_11)

/*! @brief Set the IDMAC_NFACK_11 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_11(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_12[12] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_12 (12U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_12. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_12 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_12. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_12 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_12. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_12 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_12(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_12)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_12. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_12) & BM_IPU_INT_STAT_3_IDMAC_NFACK_12)

/*! @brief Set the IDMAC_NFACK_12 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_12(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_13[13] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_13 (13U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_13. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_13 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_13. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_13 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_13. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_13 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_13(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_13)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_13. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_13) & BM_IPU_INT_STAT_3_IDMAC_NFACK_13)

/*! @brief Set the IDMAC_NFACK_13 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_13(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_14[14] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_14 (14U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_14. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_14 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_14. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_14 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_14. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_14 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_14(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_14)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_14. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_14) & BM_IPU_INT_STAT_3_IDMAC_NFACK_14)

/*! @brief Set the IDMAC_NFACK_14 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_14(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_15[15] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_15 (15U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_15. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_15 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_15. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_15 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_15. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_15 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_15(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_15)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_15. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_15) & BM_IPU_INT_STAT_3_IDMAC_NFACK_15)

/*! @brief Set the IDMAC_NFACK_15 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_15(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_17[17] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_17 (17U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_17. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_17 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_17. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_17 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_17. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_17 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_17(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_17)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_17. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_17) & BM_IPU_INT_STAT_3_IDMAC_NFACK_17)

/*! @brief Set the IDMAC_NFACK_17 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_17(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_18[18] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_18 (18U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_18. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_18 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_18. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_18 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_18. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_18 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_18(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_18)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_18. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_18) & BM_IPU_INT_STAT_3_IDMAC_NFACK_18)

/*! @brief Set the IDMAC_NFACK_18 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_18(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_19[19] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_19 (19U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_19. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_19 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_19. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_19 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_19. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_19 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_19(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_19)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_19. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_19) & BM_IPU_INT_STAT_3_IDMAC_NFACK_19)

/*! @brief Set the IDMAC_NFACK_19 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_19(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_20[20] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_20 (20U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_20. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_20 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_20. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_20 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_20. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_20 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_20(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_20)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_20. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_20) & BM_IPU_INT_STAT_3_IDMAC_NFACK_20)

/*! @brief Set the IDMAC_NFACK_20 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_20(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_21[21] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_21 (21U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_21. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_21 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_21. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_21 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_21. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_21 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_21(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_21)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_21. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_21) & BM_IPU_INT_STAT_3_IDMAC_NFACK_21)

/*! @brief Set the IDMAC_NFACK_21 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_21(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_22[22] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_22 (22U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_22. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_22 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_22. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_22 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_22. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_22 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_22(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_22)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_22. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_22) & BM_IPU_INT_STAT_3_IDMAC_NFACK_22)

/*! @brief Set the IDMAC_NFACK_22 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_22(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_23[23] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_23 (23U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_23. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_23 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_23. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_23 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_23. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_23 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_23(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_23)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_23. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_23) & BM_IPU_INT_STAT_3_IDMAC_NFACK_23)

/*! @brief Set the IDMAC_NFACK_23 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_23(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_24[24] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_24 (24U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_24. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_24 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_24. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_24 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_24. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_24 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_24(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_24)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_24. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_24) & BM_IPU_INT_STAT_3_IDMAC_NFACK_24)

/*! @brief Set the IDMAC_NFACK_24 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_24(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_25[25] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_25 (25U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_25. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_25. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_25. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_25 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_25(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_25)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_25. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_25) & BM_IPU_INT_STAT_3_IDMAC_NFACK_25)

/*! @brief Set the IDMAC_NFACK_25 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_25(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_26[26] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_26 (26U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_26. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_26. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_26. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_26 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_26(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_26)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_26. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_26) & BM_IPU_INT_STAT_3_IDMAC_NFACK_26)

/*! @brief Set the IDMAC_NFACK_26 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_26(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_27[27] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_27 (27U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_27. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_27 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_27. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_27 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_27. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_27 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_27(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_27)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_27. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_27) & BM_IPU_INT_STAT_3_IDMAC_NFACK_27)

/*! @brief Set the IDMAC_NFACK_27 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_27(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_28[28] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_28 (28U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_28. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_28 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_28. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_28 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_28. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_28 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_28(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_28)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_28. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_28) & BM_IPU_INT_STAT_3_IDMAC_NFACK_28)

/*! @brief Set the IDMAC_NFACK_28 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_28(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_29[29] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_29 (29U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_29. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_29 (0x20000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_29. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_29 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_29. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_29 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_29(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_29)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_29. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_29) & BM_IPU_INT_STAT_3_IDMAC_NFACK_29)

/*! @brief Set the IDMAC_NFACK_29 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_29(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_29 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_31)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_3, field IDMAC_NFACK_31[31] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_3_IDMAC_NFACK_31 (31U) /*!< Bit position for IPU_INT_STAT_3_IDMAC_NFACK_31. */
#define BM_IPU_INT_STAT_3_IDMAC_NFACK_31 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_3_IDMAC_NFACK_31. */
#define BS_IPU_INT_STAT_3_IDMAC_NFACK_31 (1U) /*!< Bit field size in bits for IPU_INT_STAT_3_IDMAC_NFACK_31. */

/*! @brief Read current value of the IPU_INT_STAT_3_IDMAC_NFACK_31 field. */
#define BR_IPU_INT_STAT_3_IDMAC_NFACK_31(x) (HW_IPU_INT_STAT_3(x).B.IDMAC_NFACK_31)

/*! @brief Format value for bitfield IPU_INT_STAT_3_IDMAC_NFACK_31. */
#define BF_IPU_INT_STAT_3_IDMAC_NFACK_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_3_IDMAC_NFACK_31) & BM_IPU_INT_STAT_3_IDMAC_NFACK_31)

/*! @brief Set the IDMAC_NFACK_31 field to a new value. */
#define BW_IPU_INT_STAT_3_IDMAC_NFACK_31(x, v) (HW_IPU_INT_STAT_3_WR(x, (HW_IPU_INT_STAT_3_RD(x) & ~(BM_IPU_INT_STAT_3_IDMAC_NFACK_31 | BM_IPU_INT_STAT_3_IDMAC_NFACK_0 | BM_IPU_INT_STAT_3_IDMAC_NFACK_1 | BM_IPU_INT_STAT_3_IDMAC_NFACK_2 | BM_IPU_INT_STAT_3_IDMAC_NFACK_3 | BM_IPU_INT_STAT_3_IDMAC_NFACK_5 | BM_IPU_INT_STAT_3_IDMAC_NFACK_8 | BM_IPU_INT_STAT_3_IDMAC_NFACK_9 | BM_IPU_INT_STAT_3_IDMAC_NFACK_10 | BM_IPU_INT_STAT_3_IDMAC_NFACK_11 | BM_IPU_INT_STAT_3_IDMAC_NFACK_12 | BM_IPU_INT_STAT_3_IDMAC_NFACK_13 | BM_IPU_INT_STAT_3_IDMAC_NFACK_14 | BM_IPU_INT_STAT_3_IDMAC_NFACK_15 | BM_IPU_INT_STAT_3_IDMAC_NFACK_17 | BM_IPU_INT_STAT_3_IDMAC_NFACK_18 | BM_IPU_INT_STAT_3_IDMAC_NFACK_19 | BM_IPU_INT_STAT_3_IDMAC_NFACK_20 | BM_IPU_INT_STAT_3_IDMAC_NFACK_21 | BM_IPU_INT_STAT_3_IDMAC_NFACK_22 | BM_IPU_INT_STAT_3_IDMAC_NFACK_23 | BM_IPU_INT_STAT_3_IDMAC_NFACK_24 | BM_IPU_INT_STAT_3_IDMAC_NFACK_25 | BM_IPU_INT_STAT_3_IDMAC_NFACK_26 | BM_IPU_INT_STAT_3_IDMAC_NFACK_27 | BM_IPU_INT_STAT_3_IDMAC_NFACK_28 | BM_IPU_INT_STAT_3_IDMAC_NFACK_29)) | BF_IPU_INT_STAT_3_IDMAC_NFACK_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_4 - Interrupt Status Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_4 - Interrupt Status Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of NFACK
 * (New Frame Ack) of DMA Channels interrupts [63:32] can be found in this
 * register.
 */
typedef union _hw_ipu_int_stat_4
{
    uint32_t U;
    struct _hw_ipu_int_stat_4_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_NFACK_33 : 1;   /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_NFACK_40 : 1;   /*!< [8]  */
        uint32_t IDMAC_NFACK_41 : 1;   /*!< [9]  */
        uint32_t IDMAC_NFACK_42 : 1;   /*!< [10]  */
        uint32_t IDMAC_NFACK_43 : 1;   /*!< [11]  */
        uint32_t IDMAC_NFACK_44 : 1;   /*!< [12]  */
        uint32_t IDMAC_NFACK_45 : 1;   /*!< [13]  */
        uint32_t IDMAC_NFACK_46 : 1;   /*!< [14]  */
        uint32_t IDMAC_NFACK_47 : 1;   /*!< [15]  */
        uint32_t IDMAC_NFACK_48 : 1;   /*!< [16]  */
        uint32_t IDMAC_NFACK_49 : 1;   /*!< [17]  */
        uint32_t IDMAC_NFACK_50 : 1;   /*!< [18]  */
        uint32_t IDMAC_NFACK_51 : 1;   /*!< [19]  */
        uint32_t IDMAC_NFACK_52 : 1;   /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_stat_4_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_4 register
 */
/*@{*/
#define HW_IPU_INT_STAT_4_ADDR(x) ((uintptr_t)(x) + 0x20CU)

#define HW_IPU_INT_STAT_4(x)     (*(__IO hw_ipu_int_stat_4_t *) HW_IPU_INT_STAT_4_ADDR(x))
#define HW_IPU_INT_STAT_4_RD(x)  (HW_IPU_INT_STAT_4(x).U)
#define HW_IPU_INT_STAT_4_WR(x, v) (HW_IPU_INT_STAT_4(x).U = (v))
#define HW_IPU_INT_STAT_4_SET(x, v) (HW_IPU_INT_STAT_4_WR(x, HW_IPU_INT_STAT_4_RD(x) |  (v)))
#define HW_IPU_INT_STAT_4_CLR(x, v) (HW_IPU_INT_STAT_4_WR(x, HW_IPU_INT_STAT_4_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_4_TOG(x, v) (HW_IPU_INT_STAT_4_WR(x, HW_IPU_INT_STAT_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_4 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_33[1] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_33 (1U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_33. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_33 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_33. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_33 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_33. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_33 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_33(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_33)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_33. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_33) & BM_IPU_INT_STAT_4_IDMAC_NFACK_33)

/*! @brief Set the IDMAC_NFACK_33 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_33(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_40[8] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_40 (8U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_40. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_40 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_40. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_40 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_40. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_40 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_40(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_40)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_40. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_40) & BM_IPU_INT_STAT_4_IDMAC_NFACK_40)

/*! @brief Set the IDMAC_NFACK_40 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_40(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_41[9] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_41 (9U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_41. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_41 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_41. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_41 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_41. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_41 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_41(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_41)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_41. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_41) & BM_IPU_INT_STAT_4_IDMAC_NFACK_41)

/*! @brief Set the IDMAC_NFACK_41 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_41(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_42[10] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_42 (10U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_42. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_42 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_42. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_42 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_42. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_42 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_42(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_42)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_42. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_42) & BM_IPU_INT_STAT_4_IDMAC_NFACK_42)

/*! @brief Set the IDMAC_NFACK_42 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_42(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_43[11] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_43 (11U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_43. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_43 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_43. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_43 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_43. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_43 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_43(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_43)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_43. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_43) & BM_IPU_INT_STAT_4_IDMAC_NFACK_43)

/*! @brief Set the IDMAC_NFACK_43 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_43(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_44[12] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_44 (12U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_44. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_44 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_44. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_44 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_44. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_44 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_44(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_44)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_44. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_44) & BM_IPU_INT_STAT_4_IDMAC_NFACK_44)

/*! @brief Set the IDMAC_NFACK_44 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_44(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_45[13] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_45 (13U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_45. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_45 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_45. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_45 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_45. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_45 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_45(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_45)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_45. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_45) & BM_IPU_INT_STAT_4_IDMAC_NFACK_45)

/*! @brief Set the IDMAC_NFACK_45 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_45(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_46[14] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_46 (14U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_46. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_46 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_46. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_46 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_46. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_46 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_46(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_46)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_46. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_46) & BM_IPU_INT_STAT_4_IDMAC_NFACK_46)

/*! @brief Set the IDMAC_NFACK_46 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_46(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_47[15] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_47 (15U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_47. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_47 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_47. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_47 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_47. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_47 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_47(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_47)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_47. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_47) & BM_IPU_INT_STAT_4_IDMAC_NFACK_47)

/*! @brief Set the IDMAC_NFACK_47 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_47(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_48[16] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_48 (16U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_48. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_48 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_48. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_48 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_48. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_48 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_48(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_48)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_48. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_48) & BM_IPU_INT_STAT_4_IDMAC_NFACK_48)

/*! @brief Set the IDMAC_NFACK_48 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_48(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_49[17] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_49 (17U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_49. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_49 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_49. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_49 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_49. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_49 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_49(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_49)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_49. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_49) & BM_IPU_INT_STAT_4_IDMAC_NFACK_49)

/*! @brief Set the IDMAC_NFACK_49 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_49(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_50[18] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_50 (18U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_50. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_50 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_50. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_50 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_50. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_50 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_50(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_50)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_50. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_50) & BM_IPU_INT_STAT_4_IDMAC_NFACK_50)

/*! @brief Set the IDMAC_NFACK_50 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_50(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_51[19] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_51 (19U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_51. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_51 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_51. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_51 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_51. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_51 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_51(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_51)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_51. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_51) & BM_IPU_INT_STAT_4_IDMAC_NFACK_51)

/*! @brief Set the IDMAC_NFACK_51 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_51(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_51 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_52)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_4, field IDMAC_NFACK_52[20] (W1C)
 *
 * Enable New Frame Ack of Channel interrupt. This bit is the status bits of New
 * Frame Ack of Channel #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_4_IDMAC_NFACK_52 (20U) /*!< Bit position for IPU_INT_STAT_4_IDMAC_NFACK_52. */
#define BM_IPU_INT_STAT_4_IDMAC_NFACK_52 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_4_IDMAC_NFACK_52. */
#define BS_IPU_INT_STAT_4_IDMAC_NFACK_52 (1U) /*!< Bit field size in bits for IPU_INT_STAT_4_IDMAC_NFACK_52. */

/*! @brief Read current value of the IPU_INT_STAT_4_IDMAC_NFACK_52 field. */
#define BR_IPU_INT_STAT_4_IDMAC_NFACK_52(x) (HW_IPU_INT_STAT_4(x).B.IDMAC_NFACK_52)

/*! @brief Format value for bitfield IPU_INT_STAT_4_IDMAC_NFACK_52. */
#define BF_IPU_INT_STAT_4_IDMAC_NFACK_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_4_IDMAC_NFACK_52) & BM_IPU_INT_STAT_4_IDMAC_NFACK_52)

/*! @brief Set the IDMAC_NFACK_52 field to a new value. */
#define BW_IPU_INT_STAT_4_IDMAC_NFACK_52(x, v) (HW_IPU_INT_STAT_4_WR(x, (HW_IPU_INT_STAT_4_RD(x) & ~(BM_IPU_INT_STAT_4_IDMAC_NFACK_52 | BM_IPU_INT_STAT_4_IDMAC_NFACK_33 | BM_IPU_INT_STAT_4_IDMAC_NFACK_40 | BM_IPU_INT_STAT_4_IDMAC_NFACK_41 | BM_IPU_INT_STAT_4_IDMAC_NFACK_42 | BM_IPU_INT_STAT_4_IDMAC_NFACK_43 | BM_IPU_INT_STAT_4_IDMAC_NFACK_44 | BM_IPU_INT_STAT_4_IDMAC_NFACK_45 | BM_IPU_INT_STAT_4_IDMAC_NFACK_46 | BM_IPU_INT_STAT_4_IDMAC_NFACK_47 | BM_IPU_INT_STAT_4_IDMAC_NFACK_48 | BM_IPU_INT_STAT_4_IDMAC_NFACK_49 | BM_IPU_INT_STAT_4_IDMAC_NFACK_50 | BM_IPU_INT_STAT_4_IDMAC_NFACK_51)) | BF_IPU_INT_STAT_4_IDMAC_NFACK_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_5 - Interrupt Status Register 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_5 - Interrupt Status Register 5 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * New-frame before end-of-frame indication (NFB4EOF_ERR) of DMA Channels
 * interrupts [31:0] can be found in this register.
 */
typedef union _hw_ipu_int_stat_5
{
    uint32_t U;
    struct _hw_ipu_int_stat_5_bitfields
    {
        uint32_t IDMAC_NFB4EOF_ERR_0 : 1; /*!< [0]  */
        uint32_t IDMAC_NFB4EOF_ERR_1 : 1; /*!< [1]  */
        uint32_t IDMAC_NFB4EOF_ERR_2 : 1; /*!< [2]  */
        uint32_t IDMAC_NFB4EOF_ERR_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_NFB4EOF_ERR_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_NFB4EOF_ERR_8 : 1; /*!< [8]  */
        uint32_t IDMAC_NFB4EOF_ERR_9 : 1; /*!< [9]  */
        uint32_t IDMAC_NFB4EOF_ERR_10 : 1; /*!< [10]  */
        uint32_t IDMAC_NFB4EOF_ERR_11 : 1; /*!< [11]  */
        uint32_t IDMAC_NFB4EOF_ERR_12 : 1; /*!< [12]  */
        uint32_t IDMAC_NFB4EOF_ERR_13 : 1; /*!< [13]  */
        uint32_t IDMAC_NFB4EOF_ERR_14 : 1; /*!< [14]  */
        uint32_t IDMAC_NFB4EOF_ERR_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_NFB4EOF_ERR_17 : 1; /*!< [17]  */
        uint32_t IDMAC_NFB4EOF_ERR_18 : 1; /*!< [18]  */
        uint32_t IDMAC_NFB4EOF_ERR_19 : 1; /*!< [19]  */
        uint32_t IDMAC_NFB4EOF_ERR_20 : 1; /*!< [20]  */
        uint32_t IDMAC_NFB4EOF_ERR_21 : 1; /*!< [21]  */
        uint32_t IDMAC_NFB4EOF_ERR_22 : 1; /*!< [22]  */
        uint32_t IDMAC_NFB4EOF_ERR_23 : 1; /*!< [23]  */
        uint32_t IDMAC_NFB4EOF_ERR_24 : 1; /*!< [24]  */
        uint32_t IDMAC_NFB4EOF_ERR_25 : 1; /*!< [25]  */
        uint32_t IDMAC_NFB4EOF_ERR_26 : 1; /*!< [26]  */
        uint32_t IDMAC_NFB4EOF_ERR_27 : 1; /*!< [27]  */
        uint32_t IDMAC_NFB4EOF_ERR_28 : 1; /*!< [28]  */
        uint32_t IDMAC_NFB4EOF_ERR_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_NFB4EOF_ERR_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_int_stat_5_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_5 register
 */
/*@{*/
#define HW_IPU_INT_STAT_5_ADDR(x) ((uintptr_t)(x) + 0x210U)

#define HW_IPU_INT_STAT_5(x)     (*(__IO hw_ipu_int_stat_5_t *) HW_IPU_INT_STAT_5_ADDR(x))
#define HW_IPU_INT_STAT_5_RD(x)  (HW_IPU_INT_STAT_5(x).U)
#define HW_IPU_INT_STAT_5_WR(x, v) (HW_IPU_INT_STAT_5(x).U = (v))
#define HW_IPU_INT_STAT_5_SET(x, v) (HW_IPU_INT_STAT_5_WR(x, HW_IPU_INT_STAT_5_RD(x) |  (v)))
#define HW_IPU_INT_STAT_5_CLR(x, v) (HW_IPU_INT_STAT_5_WR(x, HW_IPU_INT_STAT_5_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_5_TOG(x, v) (HW_IPU_INT_STAT_5_WR(x, HW_IPU_INT_STAT_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_5 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_0[0] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 (0U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 (0x00000001U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_0)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0)

/*! @brief Set the IDMAC_NFB4EOF_ERR_0 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_1[1] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 (1U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_1)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1)

/*! @brief Set the IDMAC_NFB4EOF_ERR_1 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_2[2] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 (2U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 (0x00000004U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_2)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2)

/*! @brief Set the IDMAC_NFB4EOF_ERR_2 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_3[3] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 (3U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 (0x00000008U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_3)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3)

/*! @brief Set the IDMAC_NFB4EOF_ERR_3 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_5[5] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 (5U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 (0x00000020U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_5)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5)

/*! @brief Set the IDMAC_NFB4EOF_ERR_5 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_8[8] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 (8U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_8)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8)

/*! @brief Set the IDMAC_NFB4EOF_ERR_8 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_9[9] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 (9U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_9)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9)

/*! @brief Set the IDMAC_NFB4EOF_ERR_9 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_10[10] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 (10U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_10)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10)

/*! @brief Set the IDMAC_NFB4EOF_ERR_10 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_11[11] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 (11U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_11)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11)

/*! @brief Set the IDMAC_NFB4EOF_ERR_11 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_12[12] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 (12U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_12)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12)

/*! @brief Set the IDMAC_NFB4EOF_ERR_12 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_13[13] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 (13U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_13)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13)

/*! @brief Set the IDMAC_NFB4EOF_ERR_13 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_14[14] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 (14U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_14)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14)

/*! @brief Set the IDMAC_NFB4EOF_ERR_14 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_15[15] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 (15U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_15)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15)

/*! @brief Set the IDMAC_NFB4EOF_ERR_15 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_17[17] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 (17U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_17)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17)

/*! @brief Set the IDMAC_NFB4EOF_ERR_17 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_18[18] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 (18U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_18)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18)

/*! @brief Set the IDMAC_NFB4EOF_ERR_18 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_19[19] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 (19U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_19)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19)

/*! @brief Set the IDMAC_NFB4EOF_ERR_19 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_20[20] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 (20U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_20)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20)

/*! @brief Set the IDMAC_NFB4EOF_ERR_20 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_21[21] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 (21U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_21)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21)

/*! @brief Set the IDMAC_NFB4EOF_ERR_21 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_22[22] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 (22U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_22)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22)

/*! @brief Set the IDMAC_NFB4EOF_ERR_22 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_23[23] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 (23U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_23)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23)

/*! @brief Set the IDMAC_NFB4EOF_ERR_23 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_24[24] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 (24U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_24)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24)

/*! @brief Set the IDMAC_NFB4EOF_ERR_24 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_25[25] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 (25U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_25)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25)

/*! @brief Set the IDMAC_NFB4EOF_ERR_25 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_26[26] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 (26U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_26)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26)

/*! @brief Set the IDMAC_NFB4EOF_ERR_26 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_27[27] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 (27U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_27)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27)

/*! @brief Set the IDMAC_NFB4EOF_ERR_27 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_28[28] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 (28U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_28)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28)

/*! @brief Set the IDMAC_NFB4EOF_ERR_28 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_29[29] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 (29U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 (0x20000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_29)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29)

/*! @brief Set the IDMAC_NFB4EOF_ERR_29 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_5, field IDMAC_NFB4EOF_ERR_31[31] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31 (31U) /*!< Bit position for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31. */
#define BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31. */
#define BS_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31 (1U) /*!< Bit field size in bits for IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31. */

/*! @brief Read current value of the IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31 field. */
#define BR_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31(x) (HW_IPU_INT_STAT_5(x).B.IDMAC_NFB4EOF_ERR_31)

/*! @brief Format value for bitfield IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31. */
#define BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31) & BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31)

/*! @brief Set the IDMAC_NFB4EOF_ERR_31 field to a new value. */
#define BW_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31(x, v) (HW_IPU_INT_STAT_5_WR(x, (HW_IPU_INT_STAT_5_RD(x) & ~(BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_0 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_1 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_2 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_3 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_5 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_8 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_9 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_10 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_11 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_12 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_13 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_14 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_15 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_17 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_18 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_19 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_20 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_21 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_22 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_23 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_24 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_25 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_26 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_27 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_28 | BM_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_29)) | BF_IPU_INT_STAT_5_IDMAC_NFB4EOF_ERR_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_6 - Interrupt Status Register 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_6 - Interrupt Status Register 6 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * New-frame before end-of-frame indication (NFB4EOF_ERR) of DMA Channels
 * interrupts [63:32] can be found in this register.
 */
typedef union _hw_ipu_int_stat_6
{
    uint32_t U;
    struct _hw_ipu_int_stat_6_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_NFB4EOF_ERR_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_NFB4EOF_ERR_40 : 1; /*!< [8]  */
        uint32_t IDMAC_NFB4EOF_ERR_41 : 1; /*!< [9]  */
        uint32_t IDMAC_NFB4EOF_ERR_42 : 1; /*!< [10]  */
        uint32_t IDMAC_NFB4EOF_ERR_43 : 1; /*!< [11]  */
        uint32_t IDMAC_NFB4EOF_ERR_44 : 1; /*!< [12]  */
        uint32_t IDMAC_NFB4EOF_ERR_45 : 1; /*!< [13]  */
        uint32_t IDMAC_NFB4EOF_ERR_46 : 1; /*!< [14]  */
        uint32_t IDMAC_NFB4EOF_ERR_47 : 1; /*!< [15]  */
        uint32_t IDMAC_NFB4EOF_ERR_48 : 1; /*!< [16]  */
        uint32_t IDMAC_NFB4EOF_ERR_49 : 1; /*!< [17]  */
        uint32_t IDMAC_NFB4EOF_ERR_50 : 1; /*!< [18]  */
        uint32_t IDMAC_NFB4EOF_ERR_51 : 1; /*!< [19]  */
        uint32_t IDMAC_NFB4EOF_ERR_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_stat_6_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_6 register
 */
/*@{*/
#define HW_IPU_INT_STAT_6_ADDR(x) ((uintptr_t)(x) + 0x214U)

#define HW_IPU_INT_STAT_6(x)     (*(__IO hw_ipu_int_stat_6_t *) HW_IPU_INT_STAT_6_ADDR(x))
#define HW_IPU_INT_STAT_6_RD(x)  (HW_IPU_INT_STAT_6(x).U)
#define HW_IPU_INT_STAT_6_WR(x, v) (HW_IPU_INT_STAT_6(x).U = (v))
#define HW_IPU_INT_STAT_6_SET(x, v) (HW_IPU_INT_STAT_6_WR(x, HW_IPU_INT_STAT_6_RD(x) |  (v)))
#define HW_IPU_INT_STAT_6_CLR(x, v) (HW_IPU_INT_STAT_6_WR(x, HW_IPU_INT_STAT_6_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_6_TOG(x, v) (HW_IPU_INT_STAT_6_WR(x, HW_IPU_INT_STAT_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_6 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_33[1] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 (1U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_33)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33)

/*! @brief Set the IDMAC_NFB4EOF_ERR_33 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_40[8] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 (8U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_40)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40)

/*! @brief Set the IDMAC_NFB4EOF_ERR_40 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_41[9] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 (9U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_41)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41)

/*! @brief Set the IDMAC_NFB4EOF_ERR_41 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_42[10] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 (10U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_42)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42)

/*! @brief Set the IDMAC_NFB4EOF_ERR_42 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_43[11] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 (11U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_43)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43)

/*! @brief Set the IDMAC_NFB4EOF_ERR_43 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_44[12] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 (12U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_44)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44)

/*! @brief Set the IDMAC_NFB4EOF_ERR_44 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_45[13] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 (13U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_45)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45)

/*! @brief Set the IDMAC_NFB4EOF_ERR_45 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_46[14] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 (14U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_46)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46)

/*! @brief Set the IDMAC_NFB4EOF_ERR_46 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_47[15] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 (15U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_47)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47)

/*! @brief Set the IDMAC_NFB4EOF_ERR_47 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_48[16] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 (16U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_48)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48)

/*! @brief Set the IDMAC_NFB4EOF_ERR_48 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_49[17] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 (17U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_49)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49)

/*! @brief Set the IDMAC_NFB4EOF_ERR_49 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_50[18] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 (18U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_50)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50)

/*! @brief Set the IDMAC_NFB4EOF_ERR_50 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_51[19] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 (19U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_51)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51)

/*! @brief Set the IDMAC_NFB4EOF_ERR_51 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_6, field IDMAC_NFB4EOF_ERR_52[20] (W1C)
 *
 * New Frame before end-of-frame error indication of Channel interrupt. This bit
 * is the status bit of New Frame before end-of-frame error interrupt of Channel
 * #n. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52 (20U) /*!< Bit position for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52. */
#define BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52. */
#define BS_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52 (1U) /*!< Bit field size in bits for IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52. */

/*! @brief Read current value of the IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52 field. */
#define BR_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52(x) (HW_IPU_INT_STAT_6(x).B.IDMAC_NFB4EOF_ERR_52)

/*! @brief Format value for bitfield IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52. */
#define BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52) & BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52)

/*! @brief Set the IDMAC_NFB4EOF_ERR_52 field to a new value. */
#define BW_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52(x, v) (HW_IPU_INT_STAT_6_WR(x, (HW_IPU_INT_STAT_6_RD(x) & ~(BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_33 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_40 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_41 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_42 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_43 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_44 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_45 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_46 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_47 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_48 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_49 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_50 | BM_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_51)) | BF_IPU_INT_STAT_6_IDMAC_NFB4EOF_ERR_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_7 - Interrupt Status Register7 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_7 - Interrupt Status Register7 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * End-of-Scroll indication (EOS) of DMA Channels interrupts [31:0] can be found
 * in this register.
 */
typedef union _hw_ipu_int_stat_7
{
    uint32_t U;
    struct _hw_ipu_int_stat_7_bitfields
    {
        uint32_t RESERVED0 : 19;       /*!< [18:0]  */
        uint32_t IDMAC_EOS_EN_19 : 1;  /*!< [19]  */
        uint32_t RESERVED1 : 3;        /*!< [22:20]  */
        uint32_t IDMAC_EOS_EN_23 : 1;  /*!< [23]  */
        uint32_t IDMAC_EOS_EN_24 : 1;  /*!< [24]  */
        uint32_t IDMAC_EOS_EN_25 : 1;  /*!< [25]  */
        uint32_t IDMAC_EOS_EN_26 : 1;  /*!< [26]  */
        uint32_t IDMAC_EOS_EN_27 : 1;  /*!< [27]  */
        uint32_t IDMAC_EOS_EN_28 : 1;  /*!< [28]  */
        uint32_t IDMAC_EOS_EN_29 : 1;  /*!< [29]  */
        uint32_t RESERVED2 : 1;        /*!< [30]  */
        uint32_t IDMAC_EOS_EN_31 : 1;  /*!< [31]  */
    } B;
} hw_ipu_int_stat_7_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_7 register
 */
/*@{*/
#define HW_IPU_INT_STAT_7_ADDR(x) ((uintptr_t)(x) + 0x218U)

#define HW_IPU_INT_STAT_7(x)     (*(__IO hw_ipu_int_stat_7_t *) HW_IPU_INT_STAT_7_ADDR(x))
#define HW_IPU_INT_STAT_7_RD(x)  (HW_IPU_INT_STAT_7(x).U)
#define HW_IPU_INT_STAT_7_WR(x, v) (HW_IPU_INT_STAT_7(x).U = (v))
#define HW_IPU_INT_STAT_7_SET(x, v) (HW_IPU_INT_STAT_7_WR(x, HW_IPU_INT_STAT_7_RD(x) |  (v)))
#define HW_IPU_INT_STAT_7_CLR(x, v) (HW_IPU_INT_STAT_7_WR(x, HW_IPU_INT_STAT_7_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_7_TOG(x, v) (HW_IPU_INT_STAT_7_WR(x, HW_IPU_INT_STAT_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_7 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_19[19] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_19 (19U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_19. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_19. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_19 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_19. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_19 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_19(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_19)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_19. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_19) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19)

/*! @brief Set the IDMAC_EOS_EN_19 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_19(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_23[23] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_23 (23U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_23. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_23. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_23 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_23. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_23 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_23(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_23)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_23. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_23) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23)

/*! @brief Set the IDMAC_EOS_EN_23 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_23(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_24[24] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_24 (24U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_24. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_24. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_24 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_24. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_24 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_24(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_24)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_24. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_24) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24)

/*! @brief Set the IDMAC_EOS_EN_24 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_24(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_25[25] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_25 (25U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_25. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_25. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_25. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_25 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_25(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_25)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_25. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_25) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25)

/*! @brief Set the IDMAC_EOS_EN_25 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_25(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_26[26] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_26 (26U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_26. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_26. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_26. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_26 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_26(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_26)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_26. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_26) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26)

/*! @brief Set the IDMAC_EOS_EN_26 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_26(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_27[27] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_27 (27U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_27. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_27. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_27 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_27. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_27 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_27(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_27)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_27. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_27) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27)

/*! @brief Set the IDMAC_EOS_EN_27 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_27(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_28[28] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_28 (28U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_28. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_28. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_28 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_28. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_28 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_28(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_28)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_28. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_28) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28)

/*! @brief Set the IDMAC_EOS_EN_28 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_28(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_29[29] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_29 (29U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_29. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 (0x20000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_29. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_29 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_29. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_29 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_29(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_29)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_29. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_29) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29)

/*! @brief Set the IDMAC_EOS_EN_29 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_29(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_7, field IDMAC_EOS_EN_31[31] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_7_IDMAC_EOS_EN_31 (31U) /*!< Bit position for IPU_INT_STAT_7_IDMAC_EOS_EN_31. */
#define BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_7_IDMAC_EOS_EN_31. */
#define BS_IPU_INT_STAT_7_IDMAC_EOS_EN_31 (1U) /*!< Bit field size in bits for IPU_INT_STAT_7_IDMAC_EOS_EN_31. */

/*! @brief Read current value of the IPU_INT_STAT_7_IDMAC_EOS_EN_31 field. */
#define BR_IPU_INT_STAT_7_IDMAC_EOS_EN_31(x) (HW_IPU_INT_STAT_7(x).B.IDMAC_EOS_EN_31)

/*! @brief Format value for bitfield IPU_INT_STAT_7_IDMAC_EOS_EN_31. */
#define BF_IPU_INT_STAT_7_IDMAC_EOS_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_7_IDMAC_EOS_EN_31) & BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31)

/*! @brief Set the IDMAC_EOS_EN_31 field to a new value. */
#define BW_IPU_INT_STAT_7_IDMAC_EOS_EN_31(x, v) (HW_IPU_INT_STAT_7_WR(x, (HW_IPU_INT_STAT_7_RD(x) & ~(BM_IPU_INT_STAT_7_IDMAC_EOS_EN_31 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_19 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_23 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_24 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_25 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_26 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_27 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_28 | BM_IPU_INT_STAT_7_IDMAC_EOS_EN_29)) | BF_IPU_INT_STAT_7_IDMAC_EOS_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_8 - Interrupt Status Register 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_8 - Interrupt Status Register 8 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. All the status bits of
 * the End of Scroll indication (EOS) of DMA Channels interrupts [63:32] can be
 * found in this register.
 */
typedef union _hw_ipu_int_stat_8
{
    uint32_t U;
    struct _hw_ipu_int_stat_8_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_EOS_EN_33 : 1;  /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t IDMAC_EOS_EN_41 : 1;  /*!< [9]  */
        uint32_t IDMAC_EOS_EN_42 : 1;  /*!< [10]  */
        uint32_t IDMAC_EOS_EN_43 : 1;  /*!< [11]  */
        uint32_t IDMAC_EOS_EN_44 : 1;  /*!< [12]  */
        uint32_t RESERVED2 : 6;        /*!< [18:13]  */
        uint32_t IDMAC_EOS_EN_51 : 1;  /*!< [19]  */
        uint32_t IDMAC_EOS_EN_52 : 1;  /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_stat_8_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_8 register
 */
/*@{*/
#define HW_IPU_INT_STAT_8_ADDR(x) ((uintptr_t)(x) + 0x21CU)

#define HW_IPU_INT_STAT_8(x)     (*(__IO hw_ipu_int_stat_8_t *) HW_IPU_INT_STAT_8_ADDR(x))
#define HW_IPU_INT_STAT_8_RD(x)  (HW_IPU_INT_STAT_8(x).U)
#define HW_IPU_INT_STAT_8_WR(x, v) (HW_IPU_INT_STAT_8(x).U = (v))
#define HW_IPU_INT_STAT_8_SET(x, v) (HW_IPU_INT_STAT_8_WR(x, HW_IPU_INT_STAT_8_RD(x) |  (v)))
#define HW_IPU_INT_STAT_8_CLR(x, v) (HW_IPU_INT_STAT_8_WR(x, HW_IPU_INT_STAT_8_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_8_TOG(x, v) (HW_IPU_INT_STAT_8_WR(x, HW_IPU_INT_STAT_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_8 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_33[1] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_33 (1U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_33. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_33. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_33 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_33. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_33 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_33(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_33)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_33. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_33) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33)

/*! @brief Set the IDMAC_EOS_EN_33 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_33(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_41[9] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_41 (9U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_41. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_41. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_41 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_41. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_41 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_41(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_41)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_41. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_41) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41)

/*! @brief Set the IDMAC_EOS_EN_41 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_41(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_42[10] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_42 (10U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_42. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_42. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_42 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_42. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_42 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_42(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_42)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_42. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_42) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42)

/*! @brief Set the IDMAC_EOS_EN_42 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_42(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_43[11] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_43 (11U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_43. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_43. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_43 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_43. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_43 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_43(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_43)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_43. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_43) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43)

/*! @brief Set the IDMAC_EOS_EN_43 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_43(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_44[12] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_44 (12U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_44. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_44. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_44 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_44. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_44 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_44(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_44)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_44. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_44) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44)

/*! @brief Set the IDMAC_EOS_EN_44 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_44(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_51[19] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_51 (19U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_51. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_51. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_51 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_51. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_51 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_51(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_51)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_51. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_51) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51)

/*! @brief Set the IDMAC_EOS_EN_51 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_51(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_8, field IDMAC_EOS_EN_52[20] (W1C)
 *
 * End of Scroll indication of Channel interrupt. This bit is the status bit of
 * End of Scroll interrupt of Channel #n. n Indicates the corresponding DMA
 * channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_8_IDMAC_EOS_EN_52 (20U) /*!< Bit position for IPU_INT_STAT_8_IDMAC_EOS_EN_52. */
#define BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_8_IDMAC_EOS_EN_52. */
#define BS_IPU_INT_STAT_8_IDMAC_EOS_EN_52 (1U) /*!< Bit field size in bits for IPU_INT_STAT_8_IDMAC_EOS_EN_52. */

/*! @brief Read current value of the IPU_INT_STAT_8_IDMAC_EOS_EN_52 field. */
#define BR_IPU_INT_STAT_8_IDMAC_EOS_EN_52(x) (HW_IPU_INT_STAT_8(x).B.IDMAC_EOS_EN_52)

/*! @brief Format value for bitfield IPU_INT_STAT_8_IDMAC_EOS_EN_52. */
#define BF_IPU_INT_STAT_8_IDMAC_EOS_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_8_IDMAC_EOS_EN_52) & BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52)

/*! @brief Set the IDMAC_EOS_EN_52 field to a new value. */
#define BW_IPU_INT_STAT_8_IDMAC_EOS_EN_52(x, v) (HW_IPU_INT_STAT_8_WR(x, (HW_IPU_INT_STAT_8_RD(x) & ~(BM_IPU_INT_STAT_8_IDMAC_EOS_EN_52 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_33 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_41 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_42 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_43 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_44 | BM_IPU_INT_STAT_8_IDMAC_EOS_EN_51)) | BF_IPU_INT_STAT_8_IDMAC_EOS_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_9 - Interrupt Status Register 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_9 - Interrupt Status Register 9 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. This register holds the
 * error interrupt indications coming from different modules within All the bits
 * in this register are write one to clear.
 */
typedef union _hw_ipu_int_stat_9
{
    uint32_t U;
    struct _hw_ipu_int_stat_9_bitfields
    {
        uint32_t VDI_FIFO1_OVF : 1;    /*!< [0]  */
        uint32_t RESERVED0 : 25;       /*!< [25:1]  */
        uint32_t IC_BAYER_BUF_OVF : 1; /*!< [26]  */
        uint32_t IC_ENC_BUF_OVF : 1;   /*!< [27]  */
        uint32_t IC_VF_BUF_OVF : 1;    /*!< [28]  */
        uint32_t RESERVED1 : 1;        /*!< [29]  */
        uint32_t CSI0_PUPE : 1;        /*!< [30]  */
        uint32_t CSI1_PUPE : 1;        /*!< [31]  */
    } B;
} hw_ipu_int_stat_9_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_9 register
 */
/*@{*/
#define HW_IPU_INT_STAT_9_ADDR(x) ((uintptr_t)(x) + 0x220U)

#define HW_IPU_INT_STAT_9(x)     (*(__IO hw_ipu_int_stat_9_t *) HW_IPU_INT_STAT_9_ADDR(x))
#define HW_IPU_INT_STAT_9_RD(x)  (HW_IPU_INT_STAT_9(x).U)
#define HW_IPU_INT_STAT_9_WR(x, v) (HW_IPU_INT_STAT_9(x).U = (v))
#define HW_IPU_INT_STAT_9_SET(x, v) (HW_IPU_INT_STAT_9_WR(x, HW_IPU_INT_STAT_9_RD(x) |  (v)))
#define HW_IPU_INT_STAT_9_CLR(x, v) (HW_IPU_INT_STAT_9_WR(x, HW_IPU_INT_STAT_9_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_9_TOG(x, v) (HW_IPU_INT_STAT_9_WR(x, HW_IPU_INT_STAT_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_9 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_9, field VDI_FIFO1_OVF[0] (W1C)
 *
 * FIFO1 overflow Interrupt1 The VDIC generate FIFO1 overflow interrupt1 when
 * write pointer of FIFO1 overrun read pointer.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_VDI_FIFO1_OVF (0U) /*!< Bit position for IPU_INT_STAT_9_VDI_FIFO1_OVF. */
#define BM_IPU_INT_STAT_9_VDI_FIFO1_OVF (0x00000001U) /*!< Bit mask for IPU_INT_STAT_9_VDI_FIFO1_OVF. */
#define BS_IPU_INT_STAT_9_VDI_FIFO1_OVF (1U) /*!< Bit field size in bits for IPU_INT_STAT_9_VDI_FIFO1_OVF. */

/*! @brief Read current value of the IPU_INT_STAT_9_VDI_FIFO1_OVF field. */
#define BR_IPU_INT_STAT_9_VDI_FIFO1_OVF(x) (HW_IPU_INT_STAT_9(x).B.VDI_FIFO1_OVF)

/*! @brief Format value for bitfield IPU_INT_STAT_9_VDI_FIFO1_OVF. */
#define BF_IPU_INT_STAT_9_VDI_FIFO1_OVF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_VDI_FIFO1_OVF) & BM_IPU_INT_STAT_9_VDI_FIFO1_OVF)

/*! @brief Set the VDI_FIFO1_OVF field to a new value. */
#define BW_IPU_INT_STAT_9_VDI_FIFO1_OVF(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_CSI0_PUPE | BM_IPU_INT_STAT_9_CSI1_PUPE)) | BF_IPU_INT_STAT_9_VDI_FIFO1_OVF(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_9, field IC_BAYER_BUF_OVF[26] (W1C)
 *
 * This bit indicates on an interrupt that is a result of the IC Buffer overflow
 * for Bayer coming from the IC. The user needs to write 1 to this bit in order
 * to clear it.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_IC_BAYER_BUF_OVF (26U) /*!< Bit position for IPU_INT_STAT_9_IC_BAYER_BUF_OVF. */
#define BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF (0x04000000U) /*!< Bit mask for IPU_INT_STAT_9_IC_BAYER_BUF_OVF. */
#define BS_IPU_INT_STAT_9_IC_BAYER_BUF_OVF (1U) /*!< Bit field size in bits for IPU_INT_STAT_9_IC_BAYER_BUF_OVF. */

/*! @brief Read current value of the IPU_INT_STAT_9_IC_BAYER_BUF_OVF field. */
#define BR_IPU_INT_STAT_9_IC_BAYER_BUF_OVF(x) (HW_IPU_INT_STAT_9(x).B.IC_BAYER_BUF_OVF)

/*! @brief Format value for bitfield IPU_INT_STAT_9_IC_BAYER_BUF_OVF. */
#define BF_IPU_INT_STAT_9_IC_BAYER_BUF_OVF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_IC_BAYER_BUF_OVF) & BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF)

/*! @brief Set the IC_BAYER_BUF_OVF field to a new value. */
#define BW_IPU_INT_STAT_9_IC_BAYER_BUF_OVF(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_CSI0_PUPE | BM_IPU_INT_STAT_9_CSI1_PUPE)) | BF_IPU_INT_STAT_9_IC_BAYER_BUF_OVF(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_9, field IC_ENC_BUF_OVF[27] (W1C)
 *
 * This bit indicates on an interrupt that is a result of the IC Buffer overflow
 * for encoding coming from the IC. The user needs to write 1 to this bit in
 * order to clear it.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_IC_ENC_BUF_OVF (27U) /*!< Bit position for IPU_INT_STAT_9_IC_ENC_BUF_OVF. */
#define BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF (0x08000000U) /*!< Bit mask for IPU_INT_STAT_9_IC_ENC_BUF_OVF. */
#define BS_IPU_INT_STAT_9_IC_ENC_BUF_OVF (1U) /*!< Bit field size in bits for IPU_INT_STAT_9_IC_ENC_BUF_OVF. */

/*! @brief Read current value of the IPU_INT_STAT_9_IC_ENC_BUF_OVF field. */
#define BR_IPU_INT_STAT_9_IC_ENC_BUF_OVF(x) (HW_IPU_INT_STAT_9(x).B.IC_ENC_BUF_OVF)

/*! @brief Format value for bitfield IPU_INT_STAT_9_IC_ENC_BUF_OVF. */
#define BF_IPU_INT_STAT_9_IC_ENC_BUF_OVF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_IC_ENC_BUF_OVF) & BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF)

/*! @brief Set the IC_ENC_BUF_OVF field to a new value. */
#define BW_IPU_INT_STAT_9_IC_ENC_BUF_OVF(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_CSI0_PUPE | BM_IPU_INT_STAT_9_CSI1_PUPE)) | BF_IPU_INT_STAT_9_IC_ENC_BUF_OVF(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_9, field IC_VF_BUF_OVF[28] (W1C)
 *
 * This bit indicates on an interrupt that is a result of the IC Buffer overflow
 * for view finder coming from the IC. The user needs to write 1 to this bit in
 * order to clear it.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_IC_VF_BUF_OVF (28U) /*!< Bit position for IPU_INT_STAT_9_IC_VF_BUF_OVF. */
#define BM_IPU_INT_STAT_9_IC_VF_BUF_OVF (0x10000000U) /*!< Bit mask for IPU_INT_STAT_9_IC_VF_BUF_OVF. */
#define BS_IPU_INT_STAT_9_IC_VF_BUF_OVF (1U) /*!< Bit field size in bits for IPU_INT_STAT_9_IC_VF_BUF_OVF. */

/*! @brief Read current value of the IPU_INT_STAT_9_IC_VF_BUF_OVF field. */
#define BR_IPU_INT_STAT_9_IC_VF_BUF_OVF(x) (HW_IPU_INT_STAT_9(x).B.IC_VF_BUF_OVF)

/*! @brief Format value for bitfield IPU_INT_STAT_9_IC_VF_BUF_OVF. */
#define BF_IPU_INT_STAT_9_IC_VF_BUF_OVF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_IC_VF_BUF_OVF) & BM_IPU_INT_STAT_9_IC_VF_BUF_OVF)

/*! @brief Set the IC_VF_BUF_OVF field to a new value. */
#define BW_IPU_INT_STAT_9_IC_VF_BUF_OVF(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_CSI0_PUPE | BM_IPU_INT_STAT_9_CSI1_PUPE)) | BF_IPU_INT_STAT_9_IC_VF_BUF_OVF(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_9, field CSI0_PUPE[30] (W1C)
 *
 * CSI0_PUPE - CSI0 parameters update error interrupt. This bit indicates on an
 * interrupt that is a result of an error generated by the CSI0. The error is
 * generated in case where new frame arrived from the CSI0 before the completion of
 * the CSI0's parameters update by the SRM
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_CSI0_PUPE (30U)  /*!< Bit position for IPU_INT_STAT_9_CSI0_PUPE. */
#define BM_IPU_INT_STAT_9_CSI0_PUPE (0x40000000U) /*!< Bit mask for IPU_INT_STAT_9_CSI0_PUPE. */
#define BS_IPU_INT_STAT_9_CSI0_PUPE (1U)   /*!< Bit field size in bits for IPU_INT_STAT_9_CSI0_PUPE. */

/*! @brief Read current value of the IPU_INT_STAT_9_CSI0_PUPE field. */
#define BR_IPU_INT_STAT_9_CSI0_PUPE(x) (HW_IPU_INT_STAT_9(x).B.CSI0_PUPE)

/*! @brief Format value for bitfield IPU_INT_STAT_9_CSI0_PUPE. */
#define BF_IPU_INT_STAT_9_CSI0_PUPE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_CSI0_PUPE) & BM_IPU_INT_STAT_9_CSI0_PUPE)

/*! @brief Set the CSI0_PUPE field to a new value. */
#define BW_IPU_INT_STAT_9_CSI0_PUPE(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_CSI0_PUPE | BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_CSI1_PUPE)) | BF_IPU_INT_STAT_9_CSI0_PUPE(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_9, field CSI1_PUPE[31] (W1C)
 *
 * CSI1_PUPE - CSI1 parameters update error interrupt. This bit indicates on an
 * interrupt that is a result of an error generated by the CSI1. The error is
 * generated in case where new frame arrived from the CSI1 before the completion of
 * the CSI1's parameters update by the SRM
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_9_CSI1_PUPE (31U)  /*!< Bit position for IPU_INT_STAT_9_CSI1_PUPE. */
#define BM_IPU_INT_STAT_9_CSI1_PUPE (0x80000000U) /*!< Bit mask for IPU_INT_STAT_9_CSI1_PUPE. */
#define BS_IPU_INT_STAT_9_CSI1_PUPE (1U)   /*!< Bit field size in bits for IPU_INT_STAT_9_CSI1_PUPE. */

/*! @brief Read current value of the IPU_INT_STAT_9_CSI1_PUPE field. */
#define BR_IPU_INT_STAT_9_CSI1_PUPE(x) (HW_IPU_INT_STAT_9(x).B.CSI1_PUPE)

/*! @brief Format value for bitfield IPU_INT_STAT_9_CSI1_PUPE. */
#define BF_IPU_INT_STAT_9_CSI1_PUPE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_9_CSI1_PUPE) & BM_IPU_INT_STAT_9_CSI1_PUPE)

/*! @brief Set the CSI1_PUPE field to a new value. */
#define BW_IPU_INT_STAT_9_CSI1_PUPE(x, v) (HW_IPU_INT_STAT_9_WR(x, (HW_IPU_INT_STAT_9_RD(x) & ~(BM_IPU_INT_STAT_9_CSI1_PUPE | BM_IPU_INT_STAT_9_VDI_FIFO1_OVF | BM_IPU_INT_STAT_9_IC_BAYER_BUF_OVF | BM_IPU_INT_STAT_9_IC_ENC_BUF_OVF | BM_IPU_INT_STAT_9_IC_VF_BUF_OVF | BM_IPU_INT_STAT_9_CSI0_PUPE)) | BF_IPU_INT_STAT_9_CSI1_PUPE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_10 - Interrupt Status Register 10
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_10 - Interrupt Status Register 10 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. This register holds
 * error interrupt indications coming from different modules within All the bits in
 * this register are write one to clear.
 */
typedef union _hw_ipu_int_stat_10
{
    uint32_t U;
    struct _hw_ipu_int_stat_10_bitfields
    {
        uint32_t SMFC0_FRM_LOST : 1;   /*!< [0]  */
        uint32_t SMFC1_FRM_LOST : 1;   /*!< [1]  */
        uint32_t SMFC2_FRM_LOST : 1;   /*!< [2]  */
        uint32_t SMFC3_FRM_LOST : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 12;       /*!< [15:4]  */
        uint32_t DC_TEARING_ERR_1 : 1; /*!< [16]  */
        uint32_t DC_TEARING_ERR_2 : 1; /*!< [17]  */
        uint32_t DC_TEARING_ERR_6 : 1; /*!< [18]  */
        uint32_t DI0_SYNC_DISP_ERR : 1; /*!< [19]  */
        uint32_t DI1_SYNC_DISP_ERR : 1; /*!< [20]  */
        uint32_t DI0_TIME_OUT_ERR : 1; /*!< [21]  */
        uint32_t DI1_TIME_OUT_ERR : 1; /*!< [22]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t IC_VF_FRM_LOST_ERR : 1; /*!< [24]  */
        uint32_t IC_ENC_FRM_LOST_ERR : 1; /*!< [25]  */
        uint32_t IC_BAYER_FRM_LOST_ERR : 1; /*!< [26]  */
        uint32_t RESERVED2 : 1;        /*!< [27]  */
        uint32_t NON_PRIVILEGED_ACC_ERR : 1; /*!< [28]  */
        uint32_t AXIW_ERR : 1;         /*!< [29]  */
        uint32_t AXIR_ERR : 1;         /*!< [30]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_ipu_int_stat_10_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_10 register
 */
/*@{*/
#define HW_IPU_INT_STAT_10_ADDR(x) ((uintptr_t)(x) + 0x224U)

#define HW_IPU_INT_STAT_10(x)    (*(__IO hw_ipu_int_stat_10_t *) HW_IPU_INT_STAT_10_ADDR(x))
#define HW_IPU_INT_STAT_10_RD(x) (HW_IPU_INT_STAT_10(x).U)
#define HW_IPU_INT_STAT_10_WR(x, v) (HW_IPU_INT_STAT_10(x).U = (v))
#define HW_IPU_INT_STAT_10_SET(x, v) (HW_IPU_INT_STAT_10_WR(x, HW_IPU_INT_STAT_10_RD(x) |  (v)))
#define HW_IPU_INT_STAT_10_CLR(x, v) (HW_IPU_INT_STAT_10_WR(x, HW_IPU_INT_STAT_10_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_10_TOG(x, v) (HW_IPU_INT_STAT_10_WR(x, HW_IPU_INT_STAT_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_10 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_10, field SMFC0_FRM_LOST[0] (W1C)
 *
 * Frame Lost of SMFC channel 0 interrupt. This bit indicates on an interrupt
 * that is a result of a result of a Frame Lost of SMFC channel 0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_SMFC0_FRM_LOST (0U) /*!< Bit position for IPU_INT_STAT_10_SMFC0_FRM_LOST. */
#define BM_IPU_INT_STAT_10_SMFC0_FRM_LOST (0x00000001U) /*!< Bit mask for IPU_INT_STAT_10_SMFC0_FRM_LOST. */
#define BS_IPU_INT_STAT_10_SMFC0_FRM_LOST (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_SMFC0_FRM_LOST. */

/*! @brief Read current value of the IPU_INT_STAT_10_SMFC0_FRM_LOST field. */
#define BR_IPU_INT_STAT_10_SMFC0_FRM_LOST(x) (HW_IPU_INT_STAT_10(x).B.SMFC0_FRM_LOST)

/*! @brief Format value for bitfield IPU_INT_STAT_10_SMFC0_FRM_LOST. */
#define BF_IPU_INT_STAT_10_SMFC0_FRM_LOST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_SMFC0_FRM_LOST) & BM_IPU_INT_STAT_10_SMFC0_FRM_LOST)

/*! @brief Set the SMFC0_FRM_LOST field to a new value. */
#define BW_IPU_INT_STAT_10_SMFC0_FRM_LOST(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_SMFC0_FRM_LOST(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field SMFC1_FRM_LOST[1] (W1C)
 *
 * Frame Lost of SMFC channel 1 interrupt. This bit indicates on an interrupt
 * that is a result of a result of a Frame Lost of SMFC channel 1
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_SMFC1_FRM_LOST (1U) /*!< Bit position for IPU_INT_STAT_10_SMFC1_FRM_LOST. */
#define BM_IPU_INT_STAT_10_SMFC1_FRM_LOST (0x00000002U) /*!< Bit mask for IPU_INT_STAT_10_SMFC1_FRM_LOST. */
#define BS_IPU_INT_STAT_10_SMFC1_FRM_LOST (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_SMFC1_FRM_LOST. */

/*! @brief Read current value of the IPU_INT_STAT_10_SMFC1_FRM_LOST field. */
#define BR_IPU_INT_STAT_10_SMFC1_FRM_LOST(x) (HW_IPU_INT_STAT_10(x).B.SMFC1_FRM_LOST)

/*! @brief Format value for bitfield IPU_INT_STAT_10_SMFC1_FRM_LOST. */
#define BF_IPU_INT_STAT_10_SMFC1_FRM_LOST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_SMFC1_FRM_LOST) & BM_IPU_INT_STAT_10_SMFC1_FRM_LOST)

/*! @brief Set the SMFC1_FRM_LOST field to a new value. */
#define BW_IPU_INT_STAT_10_SMFC1_FRM_LOST(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_SMFC1_FRM_LOST(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field SMFC2_FRM_LOST[2] (W1C)
 *
 * Frame Lost of SMFC channel 2 interrupt. This bit indicates on an interrupt
 * that is a result of a result of a Frame Lost of SMFC channel 2
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_SMFC2_FRM_LOST (2U) /*!< Bit position for IPU_INT_STAT_10_SMFC2_FRM_LOST. */
#define BM_IPU_INT_STAT_10_SMFC2_FRM_LOST (0x00000004U) /*!< Bit mask for IPU_INT_STAT_10_SMFC2_FRM_LOST. */
#define BS_IPU_INT_STAT_10_SMFC2_FRM_LOST (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_SMFC2_FRM_LOST. */

/*! @brief Read current value of the IPU_INT_STAT_10_SMFC2_FRM_LOST field. */
#define BR_IPU_INT_STAT_10_SMFC2_FRM_LOST(x) (HW_IPU_INT_STAT_10(x).B.SMFC2_FRM_LOST)

/*! @brief Format value for bitfield IPU_INT_STAT_10_SMFC2_FRM_LOST. */
#define BF_IPU_INT_STAT_10_SMFC2_FRM_LOST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_SMFC2_FRM_LOST) & BM_IPU_INT_STAT_10_SMFC2_FRM_LOST)

/*! @brief Set the SMFC2_FRM_LOST field to a new value. */
#define BW_IPU_INT_STAT_10_SMFC2_FRM_LOST(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_SMFC2_FRM_LOST(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field SMFC3_FRM_LOST[3] (W1C)
 *
 * Frame Lost of SMFC channel 3 interrupt. This bit indicates on an interrupt
 * that is a result of a result of a Frame Lost of SMFC channel 3
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_SMFC3_FRM_LOST (3U) /*!< Bit position for IPU_INT_STAT_10_SMFC3_FRM_LOST. */
#define BM_IPU_INT_STAT_10_SMFC3_FRM_LOST (0x00000008U) /*!< Bit mask for IPU_INT_STAT_10_SMFC3_FRM_LOST. */
#define BS_IPU_INT_STAT_10_SMFC3_FRM_LOST (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_SMFC3_FRM_LOST. */

/*! @brief Read current value of the IPU_INT_STAT_10_SMFC3_FRM_LOST field. */
#define BR_IPU_INT_STAT_10_SMFC3_FRM_LOST(x) (HW_IPU_INT_STAT_10(x).B.SMFC3_FRM_LOST)

/*! @brief Format value for bitfield IPU_INT_STAT_10_SMFC3_FRM_LOST. */
#define BF_IPU_INT_STAT_10_SMFC3_FRM_LOST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_SMFC3_FRM_LOST) & BM_IPU_INT_STAT_10_SMFC3_FRM_LOST)

/*! @brief Set the SMFC3_FRM_LOST field to a new value. */
#define BW_IPU_INT_STAT_10_SMFC3_FRM_LOST(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_SMFC3_FRM_LOST(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DC_TEARING_ERR_1[16] (W1C)
 *
 * Tearing Error #1 interrupt This bit indicates on the interrupt that is a
 * result of tearing error while the anti tearing mechanism is activated for DC
 * channel 1
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DC_TEARING_ERR_1 (16U) /*!< Bit position for IPU_INT_STAT_10_DC_TEARING_ERR_1. */
#define BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_10_DC_TEARING_ERR_1. */
#define BS_IPU_INT_STAT_10_DC_TEARING_ERR_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DC_TEARING_ERR_1. */

/*! @brief Read current value of the IPU_INT_STAT_10_DC_TEARING_ERR_1 field. */
#define BR_IPU_INT_STAT_10_DC_TEARING_ERR_1(x) (HW_IPU_INT_STAT_10(x).B.DC_TEARING_ERR_1)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DC_TEARING_ERR_1. */
#define BF_IPU_INT_STAT_10_DC_TEARING_ERR_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DC_TEARING_ERR_1) & BM_IPU_INT_STAT_10_DC_TEARING_ERR_1)

/*! @brief Set the DC_TEARING_ERR_1 field to a new value. */
#define BW_IPU_INT_STAT_10_DC_TEARING_ERR_1(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DC_TEARING_ERR_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DC_TEARING_ERR_2[17] (W1C)
 *
 * Tearing Error #2 interrupt This bit indicates on the interrupt that is a
 * result of tearing error while the anti tearing mechanism is activated for DC
 * channel 2
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DC_TEARING_ERR_2 (17U) /*!< Bit position for IPU_INT_STAT_10_DC_TEARING_ERR_2. */
#define BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_10_DC_TEARING_ERR_2. */
#define BS_IPU_INT_STAT_10_DC_TEARING_ERR_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DC_TEARING_ERR_2. */

/*! @brief Read current value of the IPU_INT_STAT_10_DC_TEARING_ERR_2 field. */
#define BR_IPU_INT_STAT_10_DC_TEARING_ERR_2(x) (HW_IPU_INT_STAT_10(x).B.DC_TEARING_ERR_2)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DC_TEARING_ERR_2. */
#define BF_IPU_INT_STAT_10_DC_TEARING_ERR_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DC_TEARING_ERR_2) & BM_IPU_INT_STAT_10_DC_TEARING_ERR_2)

/*! @brief Set the DC_TEARING_ERR_2 field to a new value. */
#define BW_IPU_INT_STAT_10_DC_TEARING_ERR_2(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DC_TEARING_ERR_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DC_TEARING_ERR_6[18] (W1C)
 *
 * Tearing Error #6 interrupt This bit indicates on the interrupt that is a
 * result of tearing error while the anti tearing mechanism is activated for DC
 * channel 6
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DC_TEARING_ERR_6 (18U) /*!< Bit position for IPU_INT_STAT_10_DC_TEARING_ERR_6. */
#define BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_10_DC_TEARING_ERR_6. */
#define BS_IPU_INT_STAT_10_DC_TEARING_ERR_6 (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DC_TEARING_ERR_6. */

/*! @brief Read current value of the IPU_INT_STAT_10_DC_TEARING_ERR_6 field. */
#define BR_IPU_INT_STAT_10_DC_TEARING_ERR_6(x) (HW_IPU_INT_STAT_10(x).B.DC_TEARING_ERR_6)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DC_TEARING_ERR_6. */
#define BF_IPU_INT_STAT_10_DC_TEARING_ERR_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DC_TEARING_ERR_6) & BM_IPU_INT_STAT_10_DC_TEARING_ERR_6)

/*! @brief Set the DC_TEARING_ERR_6 field to a new value. */
#define BW_IPU_INT_STAT_10_DC_TEARING_ERR_6(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DC_TEARING_ERR_6(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DI0_SYNC_DISP_ERR[19] (W1C)
 *
 * DI0 Synchronous display error interrupt This bit indicates on the interrupt
 * that is a result of an error during access to a synchronous display via DI0
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR (19U) /*!< Bit position for IPU_INT_STAT_10_DI0_SYNC_DISP_ERR. */
#define BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR (0x00080000U) /*!< Bit mask for IPU_INT_STAT_10_DI0_SYNC_DISP_ERR. */
#define BS_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DI0_SYNC_DISP_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_DI0_SYNC_DISP_ERR field. */
#define BR_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR(x) (HW_IPU_INT_STAT_10(x).B.DI0_SYNC_DISP_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DI0_SYNC_DISP_ERR. */
#define BF_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR) & BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR)

/*! @brief Set the DI0_SYNC_DISP_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DI1_SYNC_DISP_ERR[20] (W1C)
 *
 * DI1 Synchronous display error interrupt This bit indicates on the interrupt
 * that is a result of an error during access to a synchronous display via DI1
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR (20U) /*!< Bit position for IPU_INT_STAT_10_DI1_SYNC_DISP_ERR. */
#define BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR (0x00100000U) /*!< Bit mask for IPU_INT_STAT_10_DI1_SYNC_DISP_ERR. */
#define BS_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DI1_SYNC_DISP_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_DI1_SYNC_DISP_ERR field. */
#define BR_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR(x) (HW_IPU_INT_STAT_10(x).B.DI1_SYNC_DISP_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DI1_SYNC_DISP_ERR. */
#define BF_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR) & BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR)

/*! @brief Set the DI1_SYNC_DISP_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DI0_TIME_OUT_ERR[21] (W1C)
 *
 * DI0 time out error interrupt This bit indicates on the interrupt that is a
 * result of a time out error during a read access via DI0
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DI0_TIME_OUT_ERR (21U) /*!< Bit position for IPU_INT_STAT_10_DI0_TIME_OUT_ERR. */
#define BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR (0x00200000U) /*!< Bit mask for IPU_INT_STAT_10_DI0_TIME_OUT_ERR. */
#define BS_IPU_INT_STAT_10_DI0_TIME_OUT_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DI0_TIME_OUT_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_DI0_TIME_OUT_ERR field. */
#define BR_IPU_INT_STAT_10_DI0_TIME_OUT_ERR(x) (HW_IPU_INT_STAT_10(x).B.DI0_TIME_OUT_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DI0_TIME_OUT_ERR. */
#define BF_IPU_INT_STAT_10_DI0_TIME_OUT_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DI0_TIME_OUT_ERR) & BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR)

/*! @brief Set the DI0_TIME_OUT_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_DI0_TIME_OUT_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DI0_TIME_OUT_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field DI1_TIME_OUT_ERR[22] (W1C)
 *
 * DI1 time out error interrupt This bit indicates on the interrupt that is a
 * result of a time out error during a read access via DI1
 */
/*@{*/
#define BP_IPU_INT_STAT_10_DI1_TIME_OUT_ERR (22U) /*!< Bit position for IPU_INT_STAT_10_DI1_TIME_OUT_ERR. */
#define BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR (0x00400000U) /*!< Bit mask for IPU_INT_STAT_10_DI1_TIME_OUT_ERR. */
#define BS_IPU_INT_STAT_10_DI1_TIME_OUT_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_DI1_TIME_OUT_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_DI1_TIME_OUT_ERR field. */
#define BR_IPU_INT_STAT_10_DI1_TIME_OUT_ERR(x) (HW_IPU_INT_STAT_10(x).B.DI1_TIME_OUT_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_DI1_TIME_OUT_ERR. */
#define BF_IPU_INT_STAT_10_DI1_TIME_OUT_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_DI1_TIME_OUT_ERR) & BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR)

/*! @brief Set the DI1_TIME_OUT_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_DI1_TIME_OUT_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_DI1_TIME_OUT_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field IC_VF_FRM_LOST_ERR[24] (W1C)
 *
 * This bit indicates on an interrupt that is a result of IC's view finder frame
 * lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR (24U) /*!< Bit position for IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR. */
#define BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR (0x01000000U) /*!< Bit mask for IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR. */
#define BS_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR field. */
#define BR_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR(x) (HW_IPU_INT_STAT_10(x).B.IC_VF_FRM_LOST_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR. */
#define BF_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR) & BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR)

/*! @brief Set the IC_VF_FRM_LOST_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field IC_ENC_FRM_LOST_ERR[25] (W1C)
 *
 * This bit indicates on an interrupt that is a result of IC's encoding frame
 * lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR (25U) /*!< Bit position for IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR. */
#define BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR (0x02000000U) /*!< Bit mask for IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR. */
#define BS_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR field. */
#define BR_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR(x) (HW_IPU_INT_STAT_10(x).B.IC_ENC_FRM_LOST_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR. */
#define BF_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR) & BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR)

/*! @brief Set the IC_ENC_FRM_LOST_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field IC_BAYER_FRM_LOST_ERR[26] (W1C)
 *
 * This bit indicates on an interrupt that is a result of IC's Bayer frame lost.
 *
 * Values:
 * - 0 - Interrupt is disabled.
 * - 1 - Interrupt is enabled.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR (26U) /*!< Bit position for IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR. */
#define BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR (0x04000000U) /*!< Bit mask for IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR. */
#define BS_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR field. */
#define BR_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR(x) (HW_IPU_INT_STAT_10(x).B.IC_BAYER_FRM_LOST_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR. */
#define BF_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR) & BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR)

/*! @brief Set the IC_BAYER_FRM_LOST_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field NON_PRIVILEGED_ACC_ERR[28] (W1C)
 *
 * Non Privileged Access Error interrupt. This bit indicates on an interrupt
 * that is a result of access the CPMEM or the DP memory in user mode
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR (28U) /*!< Bit position for IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR. */
#define BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR (0x10000000U) /*!< Bit mask for IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR. */
#define BS_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR (1U) /*!< Bit field size in bits for IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR field. */
#define BR_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR(x) (HW_IPU_INT_STAT_10(x).B.NON_PRIVILEGED_ACC_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR. */
#define BF_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR) & BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR)

/*! @brief Set the NON_PRIVILEGED_ACC_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field AXIW_ERR[29] (W1C)
 *
 * This bit indicates on an interrupt that is a result of AXI write access
 * resulted with error response. The user needs to write 1 to this bit in order to
 * clear it.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_AXIW_ERR (29U)  /*!< Bit position for IPU_INT_STAT_10_AXIW_ERR. */
#define BM_IPU_INT_STAT_10_AXIW_ERR (0x20000000U) /*!< Bit mask for IPU_INT_STAT_10_AXIW_ERR. */
#define BS_IPU_INT_STAT_10_AXIW_ERR (1U)   /*!< Bit field size in bits for IPU_INT_STAT_10_AXIW_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_AXIW_ERR field. */
#define BR_IPU_INT_STAT_10_AXIW_ERR(x) (HW_IPU_INT_STAT_10(x).B.AXIW_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_AXIW_ERR. */
#define BF_IPU_INT_STAT_10_AXIW_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_AXIW_ERR) & BM_IPU_INT_STAT_10_AXIW_ERR)

/*! @brief Set the AXIW_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_AXIW_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_AXIW_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIR_ERR)) | BF_IPU_INT_STAT_10_AXIW_ERR(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_10, field AXIR_ERR[30] (W1C)
 *
 * This bit indicates on an interrupt that is a result of AXI read access
 * resulted with error response. The user needs to write 1 to this bit in order to
 * clear it.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_10_AXIR_ERR (30U)  /*!< Bit position for IPU_INT_STAT_10_AXIR_ERR. */
#define BM_IPU_INT_STAT_10_AXIR_ERR (0x40000000U) /*!< Bit mask for IPU_INT_STAT_10_AXIR_ERR. */
#define BS_IPU_INT_STAT_10_AXIR_ERR (1U)   /*!< Bit field size in bits for IPU_INT_STAT_10_AXIR_ERR. */

/*! @brief Read current value of the IPU_INT_STAT_10_AXIR_ERR field. */
#define BR_IPU_INT_STAT_10_AXIR_ERR(x) (HW_IPU_INT_STAT_10(x).B.AXIR_ERR)

/*! @brief Format value for bitfield IPU_INT_STAT_10_AXIR_ERR. */
#define BF_IPU_INT_STAT_10_AXIR_ERR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_10_AXIR_ERR) & BM_IPU_INT_STAT_10_AXIR_ERR)

/*! @brief Set the AXIR_ERR field to a new value. */
#define BW_IPU_INT_STAT_10_AXIR_ERR(x, v) (HW_IPU_INT_STAT_10_WR(x, (HW_IPU_INT_STAT_10_RD(x) & ~(BM_IPU_INT_STAT_10_AXIR_ERR | BM_IPU_INT_STAT_10_SMFC0_FRM_LOST | BM_IPU_INT_STAT_10_SMFC1_FRM_LOST | BM_IPU_INT_STAT_10_SMFC2_FRM_LOST | BM_IPU_INT_STAT_10_SMFC3_FRM_LOST | BM_IPU_INT_STAT_10_DC_TEARING_ERR_1 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_2 | BM_IPU_INT_STAT_10_DC_TEARING_ERR_6 | BM_IPU_INT_STAT_10_DI0_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI1_SYNC_DISP_ERR | BM_IPU_INT_STAT_10_DI0_TIME_OUT_ERR | BM_IPU_INT_STAT_10_DI1_TIME_OUT_ERR | BM_IPU_INT_STAT_10_IC_VF_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_ENC_FRM_LOST_ERR | BM_IPU_INT_STAT_10_IC_BAYER_FRM_LOST_ERR | BM_IPU_INT_STAT_10_NON_PRIVILEGED_ACC_ERR | BM_IPU_INT_STAT_10_AXIW_ERR)) | BF_IPU_INT_STAT_10_AXIR_ERR(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_11 - Interrupt Status Register 11
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_11 - Interrupt Status Register 11 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * end-of-band indication (EOBND) of DMA Channels interrupts [31:0] can be found
 * in this register. Hide VDOA_SYNC for all versions Show VDOA_SYNC for IPUv3H
 * version. The table below tagged with other settings (like IPU3M_only) should be
 * hidden in IPUv3H version.
 */
typedef union _hw_ipu_int_stat_11
{
    uint32_t U;
    struct _hw_ipu_int_stat_11_bitfields
    {
        uint32_t IDMAC_EOBND_EN_0 : 1; /*!< [0]  */
        uint32_t IDMAC_EOBND_EN_1 : 1; /*!< [1]  */
        uint32_t IDMAC_EOBND_EN_2 : 1; /*!< [2]  */
        uint32_t IDMAC_EOBND_EN_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_EOBND_EN_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 5;        /*!< [10:6]  */
        uint32_t IDMAC_EOBND_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_EOBND_EN_12 : 1; /*!< [12]  */
        uint32_t RESERVED2 : 7;        /*!< [19:13]  */
        uint32_t IDMAC_EOBND_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_EOBND_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_EOBND_EN_22 : 1; /*!< [22]  */
        uint32_t RESERVED3 : 2;        /*!< [24:23]  */
        uint32_t IDMAC_EOBND_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_EOBND_EN_26 : 1; /*!< [26]  */
        uint32_t RESERVED4 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_int_stat_11_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_11 register
 */
/*@{*/
#define HW_IPU_INT_STAT_11_ADDR(x) ((uintptr_t)(x) + 0x228U)

#define HW_IPU_INT_STAT_11(x)    (*(__IO hw_ipu_int_stat_11_t *) HW_IPU_INT_STAT_11_ADDR(x))
#define HW_IPU_INT_STAT_11_RD(x) (HW_IPU_INT_STAT_11(x).U)
#define HW_IPU_INT_STAT_11_WR(x, v) (HW_IPU_INT_STAT_11(x).U = (v))
#define HW_IPU_INT_STAT_11_SET(x, v) (HW_IPU_INT_STAT_11_WR(x, HW_IPU_INT_STAT_11_RD(x) |  (v)))
#define HW_IPU_INT_STAT_11_CLR(x, v) (HW_IPU_INT_STAT_11_WR(x, HW_IPU_INT_STAT_11_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_11_TOG(x, v) (HW_IPU_INT_STAT_11_WR(x, HW_IPU_INT_STAT_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_11 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_0[0] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 (0U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_0. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 (0x00000001U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_0. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_0. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_0 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_0(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_0)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_0. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_0) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0)

/*! @brief Set the IDMAC_EOBND_EN_0 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_0(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_1[1] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 (1U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_1. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_1. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_1. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_1 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_1(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_1)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_1. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_1) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1)

/*! @brief Set the IDMAC_EOBND_EN_1 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_1(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_2[2] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 (2U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_2. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 (0x00000004U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_2. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_2. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_2 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_2(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_2)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_2. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_2) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2)

/*! @brief Set the IDMAC_EOBND_EN_2 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_2(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_3[3] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 (3U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_3. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 (0x00000008U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_3. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_3. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_3 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_3(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_3)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_3. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_3) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3)

/*! @brief Set the IDMAC_EOBND_EN_3 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_3(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_5[5] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 (5U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_5. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 (0x00000020U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_5. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_5. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_5 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_5(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_5)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_5. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_5) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5)

/*! @brief Set the IDMAC_EOBND_EN_5 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_5(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_11[11] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 (11U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_11. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_11. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_11. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_11 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_11(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_11)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_11. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_11) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11)

/*! @brief Set the IDMAC_EOBND_EN_11 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_11(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_12[12] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 (12U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_12. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_12. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_12. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_12 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_12(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_12)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_12. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_12) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12)

/*! @brief Set the IDMAC_EOBND_EN_12 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_12(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_20[20] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 (20U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_20. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_20. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_20. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_20 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_20(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_20)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_20. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_20) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20)

/*! @brief Set the IDMAC_EOBND_EN_20 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_20(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_21[21] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 (21U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_21. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_21. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_21. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_21 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_21(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_21)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_21. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_21) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21)

/*! @brief Set the IDMAC_EOBND_EN_21 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_21(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_22[22] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 (22U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_22. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_22. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_22. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_22 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_22(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_22)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_22. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_22) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22)

/*! @brief Set the IDMAC_EOBND_EN_22 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_22(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_25[25] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 (25U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_25. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_25. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_25. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_25 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_25(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_25)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_25. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_25) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25)

/*! @brief Set the IDMAC_EOBND_EN_25 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_25(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_11, field IDMAC_EOBND_EN_26[26] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_26 (26U) /*!< Bit position for IPU_INT_STAT_11_IDMAC_EOBND_EN_26. */
#define BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_11_IDMAC_EOBND_EN_26. */
#define BS_IPU_INT_STAT_11_IDMAC_EOBND_EN_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_11_IDMAC_EOBND_EN_26. */

/*! @brief Read current value of the IPU_INT_STAT_11_IDMAC_EOBND_EN_26 field. */
#define BR_IPU_INT_STAT_11_IDMAC_EOBND_EN_26(x) (HW_IPU_INT_STAT_11(x).B.IDMAC_EOBND_EN_26)

/*! @brief Format value for bitfield IPU_INT_STAT_11_IDMAC_EOBND_EN_26. */
#define BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_11_IDMAC_EOBND_EN_26) & BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26)

/*! @brief Set the IDMAC_EOBND_EN_26 field to a new value. */
#define BW_IPU_INT_STAT_11_IDMAC_EOBND_EN_26(x, v) (HW_IPU_INT_STAT_11_WR(x, (HW_IPU_INT_STAT_11_RD(x) & ~(BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_26 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_0 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_1 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_2 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_3 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_5 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_11 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_12 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_20 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_21 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_22 | BM_IPU_INT_STAT_11_IDMAC_EOBND_EN_25)) | BF_IPU_INT_STAT_11_IDMAC_EOBND_EN_26(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_12 - Interrupt Status Register 12
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_12 - Interrupt Status Register 12 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * end-of-band indication (EOBND) of DMA Channels interrupts [63:32] can be found
 * in this register.
 */
typedef union _hw_ipu_int_stat_12
{
    uint32_t U;
    struct _hw_ipu_int_stat_12_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t IDMAC_EOBND_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_EOBND_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_EOBND_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_EOBND_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_EOBND_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_EOBND_EN_50 : 1; /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_int_stat_12_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_12 register
 */
/*@{*/
#define HW_IPU_INT_STAT_12_ADDR(x) ((uintptr_t)(x) + 0x22CU)

#define HW_IPU_INT_STAT_12(x)    (*(__IO hw_ipu_int_stat_12_t *) HW_IPU_INT_STAT_12_ADDR(x))
#define HW_IPU_INT_STAT_12_RD(x) (HW_IPU_INT_STAT_12(x).U)
#define HW_IPU_INT_STAT_12_WR(x, v) (HW_IPU_INT_STAT_12(x).U = (v))
#define HW_IPU_INT_STAT_12_SET(x, v) (HW_IPU_INT_STAT_12_WR(x, HW_IPU_INT_STAT_12_RD(x) |  (v)))
#define HW_IPU_INT_STAT_12_CLR(x, v) (HW_IPU_INT_STAT_12_WR(x, HW_IPU_INT_STAT_12_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_12_TOG(x, v) (HW_IPU_INT_STAT_12_WR(x, HW_IPU_INT_STAT_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_12 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_45[13] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 (13U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_45. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_45. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_45. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_45 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_45(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_45)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_45. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_45) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45)

/*! @brief Set the IDMAC_EOBND_EN_45 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_45(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_46[14] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 (14U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_46. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_46. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_46. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_46 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_46(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_46)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_46. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_46) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46)

/*! @brief Set the IDMAC_EOBND_EN_46 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_46(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_47[15] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 (15U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_47. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_47. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_47. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_47 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_47(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_47)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_47. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_47) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47)

/*! @brief Set the IDMAC_EOBND_EN_47 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_47(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_48[16] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 (16U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_48. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_48. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_48. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_48 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_48(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_48)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_48. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_48) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48)

/*! @brief Set the IDMAC_EOBND_EN_48 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_48(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_49[17] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 (17U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_49. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_49. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_49. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_49 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_49(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_49)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_49. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_49) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49)

/*! @brief Set the IDMAC_EOBND_EN_49 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_49(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_12, field IDMAC_EOBND_EN_50[18] (W1C)
 *
 * end-of-band indication of Channel interrupt. This bit is the status bit of
 * end-of-band interrupt of Channel #n. n Indicates the corresponding DMA channel
 * number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_50 (18U) /*!< Bit position for IPU_INT_STAT_12_IDMAC_EOBND_EN_50. */
#define BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_12_IDMAC_EOBND_EN_50. */
#define BS_IPU_INT_STAT_12_IDMAC_EOBND_EN_50 (1U) /*!< Bit field size in bits for IPU_INT_STAT_12_IDMAC_EOBND_EN_50. */

/*! @brief Read current value of the IPU_INT_STAT_12_IDMAC_EOBND_EN_50 field. */
#define BR_IPU_INT_STAT_12_IDMAC_EOBND_EN_50(x) (HW_IPU_INT_STAT_12(x).B.IDMAC_EOBND_EN_50)

/*! @brief Format value for bitfield IPU_INT_STAT_12_IDMAC_EOBND_EN_50. */
#define BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_12_IDMAC_EOBND_EN_50) & BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50)

/*! @brief Set the IDMAC_EOBND_EN_50 field to a new value. */
#define BW_IPU_INT_STAT_12_IDMAC_EOBND_EN_50(x, v) (HW_IPU_INT_STAT_12_WR(x, (HW_IPU_INT_STAT_12_RD(x) & ~(BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_50 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_45 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_46 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_47 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_48 | BM_IPU_INT_STAT_12_IDMAC_EOBND_EN_49)) | BF_IPU_INT_STAT_12_IDMAC_EOBND_EN_50(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_13 - Interrupt Status Register 13
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_13 - Interrupt Status Register 13 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * Threshold crossing indication (TH) of DMA Channels interrupts [31:0] can be
 * found in this register.
 */
typedef union _hw_ipu_int_stat_13
{
    uint32_t U;
    struct _hw_ipu_int_stat_13_bitfields
    {
        uint32_t IDMAC_TH_0 : 1;       /*!< [0]  */
        uint32_t IDMAC_TH_1 : 1;       /*!< [1]  */
        uint32_t IDMAC_TH_2 : 1;       /*!< [2]  */
        uint32_t IDMAC_TH_3 : 1;       /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_TH_5 : 1;       /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_TH_8 : 1;       /*!< [8]  */
        uint32_t IDMAC_TH_9 : 1;       /*!< [9]  */
        uint32_t IDMAC_TH_10 : 1;      /*!< [10]  */
        uint32_t IDMAC_TH_11 : 1;      /*!< [11]  */
        uint32_t IDMAC_TH_12 : 1;      /*!< [12]  */
        uint32_t IDMAC_TH_13 : 1;      /*!< [13]  */
        uint32_t IDMAC_TH_14 : 1;      /*!< [14]  */
        uint32_t IDMAC_TH_15 : 1;      /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_TH_17 : 1;      /*!< [17]  */
        uint32_t IDMAC_TH_18 : 1;      /*!< [18]  */
        uint32_t IDMAC_TH_19 : 1;      /*!< [19]  */
        uint32_t IDMAC_TH_20 : 1;      /*!< [20]  */
        uint32_t IDMAC_TH_21 : 1;      /*!< [21]  */
        uint32_t IDMAC_TH_22 : 1;      /*!< [22]  */
        uint32_t IDMAC_TH_23 : 1;      /*!< [23]  */
        uint32_t IDMAC_TH_24 : 1;      /*!< [24]  */
        uint32_t IDMAC_TH_25 : 1;      /*!< [25]  */
        uint32_t IDMAC_TH_26 : 1;      /*!< [26]  */
        uint32_t IDMAC_TH_27 : 1;      /*!< [27]  */
        uint32_t IDMAC_TH_28 : 1;      /*!< [28]  */
        uint32_t IDMAC_TH_29 : 1;      /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_TH_31 : 1;      /*!< [31]  */
    } B;
} hw_ipu_int_stat_13_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_13 register
 */
/*@{*/
#define HW_IPU_INT_STAT_13_ADDR(x) ((uintptr_t)(x) + 0x230U)

#define HW_IPU_INT_STAT_13(x)    (*(__IO hw_ipu_int_stat_13_t *) HW_IPU_INT_STAT_13_ADDR(x))
#define HW_IPU_INT_STAT_13_RD(x) (HW_IPU_INT_STAT_13(x).U)
#define HW_IPU_INT_STAT_13_WR(x, v) (HW_IPU_INT_STAT_13(x).U = (v))
#define HW_IPU_INT_STAT_13_SET(x, v) (HW_IPU_INT_STAT_13_WR(x, HW_IPU_INT_STAT_13_RD(x) |  (v)))
#define HW_IPU_INT_STAT_13_CLR(x, v) (HW_IPU_INT_STAT_13_WR(x, HW_IPU_INT_STAT_13_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_13_TOG(x, v) (HW_IPU_INT_STAT_13_WR(x, HW_IPU_INT_STAT_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_13 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_0[0] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_0 (0U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_0. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_0 (0x00000001U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_0. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_0. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_0 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_0(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_0)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_0. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_0) & BM_IPU_INT_STAT_13_IDMAC_TH_0)

/*! @brief Set the IDMAC_TH_0 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_0(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_1[1] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_1 (1U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_1. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_1 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_1. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_1. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_1 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_1(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_1)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_1. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_1) & BM_IPU_INT_STAT_13_IDMAC_TH_1)

/*! @brief Set the IDMAC_TH_1 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_1(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_2[2] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_2 (2U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_2. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_2 (0x00000004U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_2. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_2. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_2 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_2(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_2)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_2. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_2) & BM_IPU_INT_STAT_13_IDMAC_TH_2)

/*! @brief Set the IDMAC_TH_2 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_2(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_3[3] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_3 (3U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_3. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_3 (0x00000008U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_3. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_3. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_3 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_3(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_3)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_3. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_3) & BM_IPU_INT_STAT_13_IDMAC_TH_3)

/*! @brief Set the IDMAC_TH_3 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_3(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_5[5] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_5 (5U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_5. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_5 (0x00000020U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_5. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_5. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_5 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_5(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_5)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_5. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_5) & BM_IPU_INT_STAT_13_IDMAC_TH_5)

/*! @brief Set the IDMAC_TH_5 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_5(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_8[8] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_8 (8U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_8. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_8 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_8. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_8. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_8 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_8(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_8)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_8. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_8) & BM_IPU_INT_STAT_13_IDMAC_TH_8)

/*! @brief Set the IDMAC_TH_8 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_8(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_9[9] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_9 (9U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_9. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_9 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_9. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_9 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_9. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_9 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_9(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_9)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_9. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_9) & BM_IPU_INT_STAT_13_IDMAC_TH_9)

/*! @brief Set the IDMAC_TH_9 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_9(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_10[10] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_10 (10U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_10. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_10 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_10. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_10 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_10. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_10 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_10(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_10)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_10. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_10) & BM_IPU_INT_STAT_13_IDMAC_TH_10)

/*! @brief Set the IDMAC_TH_10 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_10(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_11[11] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_11 (11U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_11. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_11 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_11. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_11 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_11. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_11 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_11(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_11)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_11. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_11) & BM_IPU_INT_STAT_13_IDMAC_TH_11)

/*! @brief Set the IDMAC_TH_11 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_11(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_11(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_12[12] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_12 (12U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_12. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_12 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_12. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_12 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_12. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_12 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_12(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_12)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_12. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_12) & BM_IPU_INT_STAT_13_IDMAC_TH_12)

/*! @brief Set the IDMAC_TH_12 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_12(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_12(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_13[13] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_13 (13U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_13. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_13 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_13. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_13 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_13. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_13 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_13(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_13)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_13. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_13) & BM_IPU_INT_STAT_13_IDMAC_TH_13)

/*! @brief Set the IDMAC_TH_13 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_13(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_13(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_14[14] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_14 (14U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_14. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_14 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_14. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_14 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_14. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_14 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_14(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_14)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_14. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_14) & BM_IPU_INT_STAT_13_IDMAC_TH_14)

/*! @brief Set the IDMAC_TH_14 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_14(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_14(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_15[15] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_15 (15U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_15. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_15 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_15. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_15 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_15. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_15 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_15(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_15)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_15. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_15) & BM_IPU_INT_STAT_13_IDMAC_TH_15)

/*! @brief Set the IDMAC_TH_15 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_15(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_15(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_17[17] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_17 (17U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_17. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_17 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_17. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_17 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_17. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_17 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_17(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_17)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_17. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_17) & BM_IPU_INT_STAT_13_IDMAC_TH_17)

/*! @brief Set the IDMAC_TH_17 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_17(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_17(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_18[18] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_18 (18U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_18. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_18 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_18. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_18 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_18. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_18 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_18(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_18)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_18. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_18) & BM_IPU_INT_STAT_13_IDMAC_TH_18)

/*! @brief Set the IDMAC_TH_18 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_18(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_18(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_19[19] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_19 (19U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_19. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_19 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_19. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_19 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_19. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_19 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_19(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_19)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_19. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_19) & BM_IPU_INT_STAT_13_IDMAC_TH_19)

/*! @brief Set the IDMAC_TH_19 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_19(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_19(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_20[20] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_20 (20U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_20. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_20 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_20. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_20 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_20. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_20 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_20(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_20)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_20. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_20) & BM_IPU_INT_STAT_13_IDMAC_TH_20)

/*! @brief Set the IDMAC_TH_20 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_20(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_20(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_21[21] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_21 (21U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_21. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_21 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_21. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_21 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_21. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_21 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_21(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_21)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_21. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_21) & BM_IPU_INT_STAT_13_IDMAC_TH_21)

/*! @brief Set the IDMAC_TH_21 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_21(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_21(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_22[22] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_22 (22U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_22. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_22 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_22. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_22 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_22. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_22 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_22(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_22)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_22. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_22) & BM_IPU_INT_STAT_13_IDMAC_TH_22)

/*! @brief Set the IDMAC_TH_22 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_22(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_22(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_23[23] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_23 (23U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_23. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_23 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_23. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_23 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_23. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_23 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_23(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_23)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_23. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_23) & BM_IPU_INT_STAT_13_IDMAC_TH_23)

/*! @brief Set the IDMAC_TH_23 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_23(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_23(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_24[24] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_24 (24U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_24. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_24 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_24. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_24 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_24. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_24 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_24(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_24)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_24. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_24) & BM_IPU_INT_STAT_13_IDMAC_TH_24)

/*! @brief Set the IDMAC_TH_24 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_24(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_24(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_25[25] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_25 (25U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_25. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_25 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_25. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_25 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_25. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_25 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_25(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_25)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_25. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_25) & BM_IPU_INT_STAT_13_IDMAC_TH_25)

/*! @brief Set the IDMAC_TH_25 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_25(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_25(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_26[26] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_26 (26U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_26. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_26 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_26. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_26 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_26. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_26 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_26(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_26)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_26. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_26) & BM_IPU_INT_STAT_13_IDMAC_TH_26)

/*! @brief Set the IDMAC_TH_26 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_26(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_26(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_27[27] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_27 (27U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_27. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_27 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_27. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_27 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_27. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_27 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_27(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_27)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_27. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_27) & BM_IPU_INT_STAT_13_IDMAC_TH_27)

/*! @brief Set the IDMAC_TH_27 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_27(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_27(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_28[28] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_28 (28U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_28. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_28 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_28. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_28 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_28. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_28 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_28(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_28)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_28. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_28) & BM_IPU_INT_STAT_13_IDMAC_TH_28)

/*! @brief Set the IDMAC_TH_28 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_28(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_28(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_29[29] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_29 (29U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_29. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_29 (0x20000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_29. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_29 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_29. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_29 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_29(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_29)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_29. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_29) & BM_IPU_INT_STAT_13_IDMAC_TH_29)

/*! @brief Set the IDMAC_TH_29 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_29(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_29 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_31)) | BF_IPU_INT_STAT_13_IDMAC_TH_29(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_13, field IDMAC_TH_31[31] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_13_IDMAC_TH_31 (31U) /*!< Bit position for IPU_INT_STAT_13_IDMAC_TH_31. */
#define BM_IPU_INT_STAT_13_IDMAC_TH_31 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_13_IDMAC_TH_31. */
#define BS_IPU_INT_STAT_13_IDMAC_TH_31 (1U) /*!< Bit field size in bits for IPU_INT_STAT_13_IDMAC_TH_31. */

/*! @brief Read current value of the IPU_INT_STAT_13_IDMAC_TH_31 field. */
#define BR_IPU_INT_STAT_13_IDMAC_TH_31(x) (HW_IPU_INT_STAT_13(x).B.IDMAC_TH_31)

/*! @brief Format value for bitfield IPU_INT_STAT_13_IDMAC_TH_31. */
#define BF_IPU_INT_STAT_13_IDMAC_TH_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_13_IDMAC_TH_31) & BM_IPU_INT_STAT_13_IDMAC_TH_31)

/*! @brief Set the IDMAC_TH_31 field to a new value. */
#define BW_IPU_INT_STAT_13_IDMAC_TH_31(x, v) (HW_IPU_INT_STAT_13_WR(x, (HW_IPU_INT_STAT_13_RD(x) & ~(BM_IPU_INT_STAT_13_IDMAC_TH_31 | BM_IPU_INT_STAT_13_IDMAC_TH_0 | BM_IPU_INT_STAT_13_IDMAC_TH_1 | BM_IPU_INT_STAT_13_IDMAC_TH_2 | BM_IPU_INT_STAT_13_IDMAC_TH_3 | BM_IPU_INT_STAT_13_IDMAC_TH_5 | BM_IPU_INT_STAT_13_IDMAC_TH_8 | BM_IPU_INT_STAT_13_IDMAC_TH_9 | BM_IPU_INT_STAT_13_IDMAC_TH_10 | BM_IPU_INT_STAT_13_IDMAC_TH_11 | BM_IPU_INT_STAT_13_IDMAC_TH_12 | BM_IPU_INT_STAT_13_IDMAC_TH_13 | BM_IPU_INT_STAT_13_IDMAC_TH_14 | BM_IPU_INT_STAT_13_IDMAC_TH_15 | BM_IPU_INT_STAT_13_IDMAC_TH_17 | BM_IPU_INT_STAT_13_IDMAC_TH_18 | BM_IPU_INT_STAT_13_IDMAC_TH_19 | BM_IPU_INT_STAT_13_IDMAC_TH_20 | BM_IPU_INT_STAT_13_IDMAC_TH_21 | BM_IPU_INT_STAT_13_IDMAC_TH_22 | BM_IPU_INT_STAT_13_IDMAC_TH_23 | BM_IPU_INT_STAT_13_IDMAC_TH_24 | BM_IPU_INT_STAT_13_IDMAC_TH_25 | BM_IPU_INT_STAT_13_IDMAC_TH_26 | BM_IPU_INT_STAT_13_IDMAC_TH_27 | BM_IPU_INT_STAT_13_IDMAC_TH_28 | BM_IPU_INT_STAT_13_IDMAC_TH_29)) | BF_IPU_INT_STAT_13_IDMAC_TH_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_14 - Interrupt Status Register 14
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_14 - Interrupt Status Register 14 (RW)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of the
 * Threshold crossing indication (TH) of DMA Channels interrupts [63:32] can be
 * found in this register.
 */
typedef union _hw_ipu_int_stat_14
{
    uint32_t U;
    struct _hw_ipu_int_stat_14_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_TH_33 : 1;      /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_TH_40 : 1;      /*!< [8]  */
        uint32_t IDMAC_TH_41 : 1;      /*!< [9]  */
        uint32_t IDMAC_TH_42 : 1;      /*!< [10]  */
        uint32_t IDMAC_TH_43 : 1;      /*!< [11]  */
        uint32_t IDMAC_TH_44 : 1;      /*!< [12]  */
        uint32_t IDMAC_TH_45 : 1;      /*!< [13]  */
        uint32_t IDMAC_TH_46 : 1;      /*!< [14]  */
        uint32_t IDMAC_TH_47 : 1;      /*!< [15]  */
        uint32_t IDMAC_TH_48 : 1;      /*!< [16]  */
        uint32_t IDMAC_TH_49 : 1;      /*!< [17]  */
        uint32_t IDMAC_TH_50 : 1;      /*!< [18]  */
        uint32_t IDMAC_TH_51 : 1;      /*!< [19]  */
        uint32_t IDMAC_TH_52 : 1;      /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_int_stat_14_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_14 register
 */
/*@{*/
#define HW_IPU_INT_STAT_14_ADDR(x) ((uintptr_t)(x) + 0x234U)

#define HW_IPU_INT_STAT_14(x)    (*(__IO hw_ipu_int_stat_14_t *) HW_IPU_INT_STAT_14_ADDR(x))
#define HW_IPU_INT_STAT_14_RD(x) (HW_IPU_INT_STAT_14(x).U)
#define HW_IPU_INT_STAT_14_WR(x, v) (HW_IPU_INT_STAT_14(x).U = (v))
#define HW_IPU_INT_STAT_14_SET(x, v) (HW_IPU_INT_STAT_14_WR(x, HW_IPU_INT_STAT_14_RD(x) |  (v)))
#define HW_IPU_INT_STAT_14_CLR(x, v) (HW_IPU_INT_STAT_14_WR(x, HW_IPU_INT_STAT_14_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_14_TOG(x, v) (HW_IPU_INT_STAT_14_WR(x, HW_IPU_INT_STAT_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_14 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_33[1] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_33 (1U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_33. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_33 (0x00000002U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_33. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_33 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_33. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_33 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_33(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_33)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_33. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_33) & BM_IPU_INT_STAT_14_IDMAC_TH_33)

/*! @brief Set the IDMAC_TH_33 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_33(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_33(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_40[8] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_40 (8U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_40. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_40 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_40. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_40 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_40. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_40 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_40(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_40)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_40. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_40) & BM_IPU_INT_STAT_14_IDMAC_TH_40)

/*! @brief Set the IDMAC_TH_40 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_40(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_40(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_41[9] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_41 (9U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_41. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_41 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_41. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_41 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_41. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_41 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_41(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_41)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_41. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_41) & BM_IPU_INT_STAT_14_IDMAC_TH_41)

/*! @brief Set the IDMAC_TH_41 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_41(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_41(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_42[10] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_42 (10U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_42. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_42 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_42. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_42 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_42. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_42 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_42(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_42)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_42. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_42) & BM_IPU_INT_STAT_14_IDMAC_TH_42)

/*! @brief Set the IDMAC_TH_42 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_42(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_42(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_43[11] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_43 (11U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_43. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_43 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_43. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_43 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_43. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_43 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_43(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_43)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_43. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_43) & BM_IPU_INT_STAT_14_IDMAC_TH_43)

/*! @brief Set the IDMAC_TH_43 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_43(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_43(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_44[12] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_44 (12U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_44. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_44 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_44. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_44 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_44. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_44 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_44(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_44)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_44. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_44) & BM_IPU_INT_STAT_14_IDMAC_TH_44)

/*! @brief Set the IDMAC_TH_44 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_44(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_44(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_45[13] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_45 (13U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_45. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_45 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_45. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_45 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_45. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_45 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_45(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_45)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_45. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_45) & BM_IPU_INT_STAT_14_IDMAC_TH_45)

/*! @brief Set the IDMAC_TH_45 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_45(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_45(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_46[14] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_46 (14U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_46. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_46 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_46. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_46 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_46. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_46 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_46(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_46)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_46. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_46) & BM_IPU_INT_STAT_14_IDMAC_TH_46)

/*! @brief Set the IDMAC_TH_46 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_46(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_46(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_47[15] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_47 (15U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_47. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_47 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_47. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_47 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_47. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_47 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_47(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_47)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_47. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_47) & BM_IPU_INT_STAT_14_IDMAC_TH_47)

/*! @brief Set the IDMAC_TH_47 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_47(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_47(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_48[16] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_48 (16U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_48. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_48 (0x00010000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_48. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_48 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_48. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_48 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_48(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_48)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_48. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_48) & BM_IPU_INT_STAT_14_IDMAC_TH_48)

/*! @brief Set the IDMAC_TH_48 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_48(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_48(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_49[17] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_49 (17U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_49. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_49 (0x00020000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_49. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_49 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_49. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_49 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_49(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_49)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_49. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_49) & BM_IPU_INT_STAT_14_IDMAC_TH_49)

/*! @brief Set the IDMAC_TH_49 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_49(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_49(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_50[18] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_50 (18U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_50. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_50 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_50. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_50 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_50. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_50 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_50(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_50)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_50. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_50) & BM_IPU_INT_STAT_14_IDMAC_TH_50)

/*! @brief Set the IDMAC_TH_50 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_50(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_50(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_51[19] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_51 (19U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_51. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_51 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_51. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_51 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_51. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_51 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_51(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_51)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_51. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_51) & BM_IPU_INT_STAT_14_IDMAC_TH_51)

/*! @brief Set the IDMAC_TH_51 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_51(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_51 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_52)) | BF_IPU_INT_STAT_14_IDMAC_TH_51(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_14, field IDMAC_TH_52[20] (W1C)
 *
 * Threshold crossing indication of Channel interrupt. This bit is the status
 * bit of Threshold crossing interrupt of Channel #n. n Indicates the corresponding
 * DMA channel number.
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_14_IDMAC_TH_52 (20U) /*!< Bit position for IPU_INT_STAT_14_IDMAC_TH_52. */
#define BM_IPU_INT_STAT_14_IDMAC_TH_52 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_14_IDMAC_TH_52. */
#define BS_IPU_INT_STAT_14_IDMAC_TH_52 (1U) /*!< Bit field size in bits for IPU_INT_STAT_14_IDMAC_TH_52. */

/*! @brief Read current value of the IPU_INT_STAT_14_IDMAC_TH_52 field. */
#define BR_IPU_INT_STAT_14_IDMAC_TH_52(x) (HW_IPU_INT_STAT_14(x).B.IDMAC_TH_52)

/*! @brief Format value for bitfield IPU_INT_STAT_14_IDMAC_TH_52. */
#define BF_IPU_INT_STAT_14_IDMAC_TH_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_14_IDMAC_TH_52) & BM_IPU_INT_STAT_14_IDMAC_TH_52)

/*! @brief Set the IDMAC_TH_52 field to a new value. */
#define BW_IPU_INT_STAT_14_IDMAC_TH_52(x, v) (HW_IPU_INT_STAT_14_WR(x, (HW_IPU_INT_STAT_14_RD(x) & ~(BM_IPU_INT_STAT_14_IDMAC_TH_52 | BM_IPU_INT_STAT_14_IDMAC_TH_33 | BM_IPU_INT_STAT_14_IDMAC_TH_40 | BM_IPU_INT_STAT_14_IDMAC_TH_41 | BM_IPU_INT_STAT_14_IDMAC_TH_42 | BM_IPU_INT_STAT_14_IDMAC_TH_43 | BM_IPU_INT_STAT_14_IDMAC_TH_44 | BM_IPU_INT_STAT_14_IDMAC_TH_45 | BM_IPU_INT_STAT_14_IDMAC_TH_46 | BM_IPU_INT_STAT_14_IDMAC_TH_47 | BM_IPU_INT_STAT_14_IDMAC_TH_48 | BM_IPU_INT_STAT_14_IDMAC_TH_49 | BM_IPU_INT_STAT_14_IDMAC_TH_50 | BM_IPU_INT_STAT_14_IDMAC_TH_51)) | BF_IPU_INT_STAT_14_IDMAC_TH_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_INT_STAT_15 - Interrupt Status Register 15
 ******************************************************************************/

/*!
 * @brief HW_IPU_INT_STAT_15 - Interrupt Status Register 15 (W1C)
 *
 * Reset value: 0x00000000U
 *
 * IPU status registers are not stored in the SRM during power gating mode.IPU
 * status registers are not stored in the SRM during power gating mode.This
 * register contains part of IPU interrupts status bits. The status bits of general
 * purpose interrupts can be found in this register.
 */
typedef union _hw_ipu_int_stat_15
{
    uint32_t U;
    struct _hw_ipu_int_stat_15_bitfields
    {
        uint32_t SNOOPING1_INT : 1;    /*!< [0]  */
        uint32_t SNOOPING2_INT : 1;    /*!< [1]  */
        uint32_t DP_SF_START : 1;      /*!< [2]  */
        uint32_t DP_SF_END : 1;        /*!< [3]  */
        uint32_t DP_ASF_START : 1;     /*!< [4]  */
        uint32_t DP_ASF_END : 1;       /*!< [5]  */
        uint32_t DP_SF_BRAKE : 1;      /*!< [6]  */
        uint32_t DP_ASF_BRAKE : 1;     /*!< [7]  */
        uint32_t DC_FC_0 : 1;          /*!< [8]  */
        uint32_t DC_FC_1 : 1;          /*!< [9]  */
        uint32_t DC_FC_2 : 1;          /*!< [10]  */
        uint32_t DC_FC_3 : 1;          /*!< [11]  */
        uint32_t DC_FC_4 : 1;          /*!< [12]  */
        uint32_t DC_FC_6 : 1;          /*!< [13]  */
        uint32_t DI_VSYNC_PRE_0 : 1;   /*!< [14]  */
        uint32_t DI_VSYNC_PRE_1 : 1;   /*!< [15]  */
        uint32_t DC_DP_START : 1;      /*!< [16]  */
        uint32_t DC_ASYNC_STOP : 1;    /*!< [17]  */
        uint32_t DI0_CNT_EN_PRE_0 : 1; /*!< [18]  */
        uint32_t DI0_CNT_EN_PRE_1 : 1; /*!< [19]  */
        uint32_t DI0_CNT_EN_PRE_2 : 1; /*!< [20]  */
        uint32_t DI0_CNT_EN_PRE_3 : 1; /*!< [21]  */
        uint32_t DI0_CNT_EN_PRE_4 : 1; /*!< [22]  */
        uint32_t DI0_CNT_EN_PRE_5 : 1; /*!< [23]  */
        uint32_t DI0_CNT_EN_PRE_6 : 1; /*!< [24]  */
        uint32_t DI0_CNT_EN_PRE_7 : 1; /*!< [25]  */
        uint32_t DI0_CNT_EN_PRE_8 : 1; /*!< [26]  */
        uint32_t DI0_CNT_EN_PRE_9 : 1; /*!< [27]  */
        uint32_t DI0_CNT_EN_PRE_10 : 1; /*!< [28]  */
        uint32_t DI1_DISP_CLK_EN_PRE : 1; /*!< [29]  */
        uint32_t DI1_CNT_EN_PRE_3 : 1; /*!< [30]  */
        uint32_t DI1_CNT_EN_PRE_8 : 1; /*!< [31]  */
    } B;
} hw_ipu_int_stat_15_t;

/*!
 * @name Constants and macros for entire IPU_INT_STAT_15 register
 */
/*@{*/
#define HW_IPU_INT_STAT_15_ADDR(x) ((uintptr_t)(x) + 0x238U)

#define HW_IPU_INT_STAT_15(x)    (*(__IO hw_ipu_int_stat_15_t *) HW_IPU_INT_STAT_15_ADDR(x))
#define HW_IPU_INT_STAT_15_RD(x) (HW_IPU_INT_STAT_15(x).U)
#define HW_IPU_INT_STAT_15_WR(x, v) (HW_IPU_INT_STAT_15(x).U = (v))
#define HW_IPU_INT_STAT_15_SET(x, v) (HW_IPU_INT_STAT_15_WR(x, HW_IPU_INT_STAT_15_RD(x) |  (v)))
#define HW_IPU_INT_STAT_15_CLR(x, v) (HW_IPU_INT_STAT_15_WR(x, HW_IPU_INT_STAT_15_RD(x) & ~(v)))
#define HW_IPU_INT_STAT_15_TOG(x, v) (HW_IPU_INT_STAT_15_WR(x, HW_IPU_INT_STAT_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_INT_STAT_15 bitfields
 */

/*!
 * @name Register IPU_INT_STAT_15, field SNOOPING1_INT[0] (W1C)
 *
 * IPU snooping 1 event indication interrupt. This bit indicates on the
 * interrupt that is a result of the detection of a snooping 1 signal assertion coming to
 * the
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_SNOOPING1_INT (0U) /*!< Bit position for IPU_INT_STAT_15_SNOOPING1_INT. */
#define BM_IPU_INT_STAT_15_SNOOPING1_INT (0x00000001U) /*!< Bit mask for IPU_INT_STAT_15_SNOOPING1_INT. */
#define BS_IPU_INT_STAT_15_SNOOPING1_INT (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_SNOOPING1_INT. */

/*! @brief Read current value of the IPU_INT_STAT_15_SNOOPING1_INT field. */
#define BR_IPU_INT_STAT_15_SNOOPING1_INT(x) (HW_IPU_INT_STAT_15(x).B.SNOOPING1_INT)

/*! @brief Format value for bitfield IPU_INT_STAT_15_SNOOPING1_INT. */
#define BF_IPU_INT_STAT_15_SNOOPING1_INT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_SNOOPING1_INT) & BM_IPU_INT_STAT_15_SNOOPING1_INT)

/*! @brief Set the SNOOPING1_INT field to a new value. */
#define BW_IPU_INT_STAT_15_SNOOPING1_INT(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_SNOOPING1_INT(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field SNOOPING2_INT[1] (W1C)
 *
 * IPU snooping 2 event indication interrupt. This bit indicates on the
 * interrupt that is a result of the detection of a snooping 2 signal assertion coming to
 * the IPU
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_SNOOPING2_INT (1U) /*!< Bit position for IPU_INT_STAT_15_SNOOPING2_INT. */
#define BM_IPU_INT_STAT_15_SNOOPING2_INT (0x00000002U) /*!< Bit mask for IPU_INT_STAT_15_SNOOPING2_INT. */
#define BS_IPU_INT_STAT_15_SNOOPING2_INT (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_SNOOPING2_INT. */

/*! @brief Read current value of the IPU_INT_STAT_15_SNOOPING2_INT field. */
#define BR_IPU_INT_STAT_15_SNOOPING2_INT(x) (HW_IPU_INT_STAT_15(x).B.SNOOPING2_INT)

/*! @brief Format value for bitfield IPU_INT_STAT_15_SNOOPING2_INT. */
#define BF_IPU_INT_STAT_15_SNOOPING2_INT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_SNOOPING2_INT) & BM_IPU_INT_STAT_15_SNOOPING2_INT)

/*! @brief Set the SNOOPING2_INT field to a new value. */
#define BW_IPU_INT_STAT_15_SNOOPING2_INT(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_SNOOPING2_INT(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_SF_START[2] (W1C)
 *
 * DP Sync Flow Start indication interrupt. This bit indicates on the interrupt
 * that is a result of the Sync flow start at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_SF_START (2U) /*!< Bit position for IPU_INT_STAT_15_DP_SF_START. */
#define BM_IPU_INT_STAT_15_DP_SF_START (0x00000004U) /*!< Bit mask for IPU_INT_STAT_15_DP_SF_START. */
#define BS_IPU_INT_STAT_15_DP_SF_START (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DP_SF_START. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_SF_START field. */
#define BR_IPU_INT_STAT_15_DP_SF_START(x) (HW_IPU_INT_STAT_15(x).B.DP_SF_START)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_SF_START. */
#define BF_IPU_INT_STAT_15_DP_SF_START(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_SF_START) & BM_IPU_INT_STAT_15_DP_SF_START)

/*! @brief Set the DP_SF_START field to a new value. */
#define BW_IPU_INT_STAT_15_DP_SF_START(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_SF_START(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_SF_END[3] (W1C)
 *
 * DP Sync Flow End indication interrupt. This bit indicates on the interrupt
 * that is a result of the Sync flow end at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_SF_END (3U)  /*!< Bit position for IPU_INT_STAT_15_DP_SF_END. */
#define BM_IPU_INT_STAT_15_DP_SF_END (0x00000008U) /*!< Bit mask for IPU_INT_STAT_15_DP_SF_END. */
#define BS_IPU_INT_STAT_15_DP_SF_END (1U)  /*!< Bit field size in bits for IPU_INT_STAT_15_DP_SF_END. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_SF_END field. */
#define BR_IPU_INT_STAT_15_DP_SF_END(x) (HW_IPU_INT_STAT_15(x).B.DP_SF_END)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_SF_END. */
#define BF_IPU_INT_STAT_15_DP_SF_END(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_SF_END) & BM_IPU_INT_STAT_15_DP_SF_END)

/*! @brief Set the DP_SF_END field to a new value. */
#define BW_IPU_INT_STAT_15_DP_SF_END(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_SF_END(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_ASF_START[4] (W1C)
 *
 * DP Async Flow Start indication interrupt. This bit indicates on the interrupt
 * that is a result of the Async flow start at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_ASF_START (4U) /*!< Bit position for IPU_INT_STAT_15_DP_ASF_START. */
#define BM_IPU_INT_STAT_15_DP_ASF_START (0x00000010U) /*!< Bit mask for IPU_INT_STAT_15_DP_ASF_START. */
#define BS_IPU_INT_STAT_15_DP_ASF_START (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DP_ASF_START. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_ASF_START field. */
#define BR_IPU_INT_STAT_15_DP_ASF_START(x) (HW_IPU_INT_STAT_15(x).B.DP_ASF_START)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_ASF_START. */
#define BF_IPU_INT_STAT_15_DP_ASF_START(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_ASF_START) & BM_IPU_INT_STAT_15_DP_ASF_START)

/*! @brief Set the DP_ASF_START field to a new value. */
#define BW_IPU_INT_STAT_15_DP_ASF_START(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_ASF_START(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_ASF_END[5] (W1C)
 *
 * DP Async Flow End indication interrupt. This bit indicates on the interrupt
 * that is a result of the Async flow end at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_ASF_END (5U) /*!< Bit position for IPU_INT_STAT_15_DP_ASF_END. */
#define BM_IPU_INT_STAT_15_DP_ASF_END (0x00000020U) /*!< Bit mask for IPU_INT_STAT_15_DP_ASF_END. */
#define BS_IPU_INT_STAT_15_DP_ASF_END (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DP_ASF_END. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_ASF_END field. */
#define BR_IPU_INT_STAT_15_DP_ASF_END(x) (HW_IPU_INT_STAT_15(x).B.DP_ASF_END)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_ASF_END. */
#define BF_IPU_INT_STAT_15_DP_ASF_END(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_ASF_END) & BM_IPU_INT_STAT_15_DP_ASF_END)

/*! @brief Set the DP_ASF_END field to a new value. */
#define BW_IPU_INT_STAT_15_DP_ASF_END(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_ASF_END(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_SF_BRAKE[6] (W1C)
 *
 * DP Sync Flow Brake indication interrupt. This bit indicates on the interrupt
 * that is a result of the Sync flow brake at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_SF_BRAKE (6U) /*!< Bit position for IPU_INT_STAT_15_DP_SF_BRAKE. */
#define BM_IPU_INT_STAT_15_DP_SF_BRAKE (0x00000040U) /*!< Bit mask for IPU_INT_STAT_15_DP_SF_BRAKE. */
#define BS_IPU_INT_STAT_15_DP_SF_BRAKE (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DP_SF_BRAKE. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_SF_BRAKE field. */
#define BR_IPU_INT_STAT_15_DP_SF_BRAKE(x) (HW_IPU_INT_STAT_15(x).B.DP_SF_BRAKE)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_SF_BRAKE. */
#define BF_IPU_INT_STAT_15_DP_SF_BRAKE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_SF_BRAKE) & BM_IPU_INT_STAT_15_DP_SF_BRAKE)

/*! @brief Set the DP_SF_BRAKE field to a new value. */
#define BW_IPU_INT_STAT_15_DP_SF_BRAKE(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_SF_BRAKE(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DP_ASF_BRAKE[7] (W1C)
 *
 * DP Async Flow Brake indication interrupt. This bit indicates on the interrupt
 * that is a result of the async flow brake at the DP
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DP_ASF_BRAKE (7U) /*!< Bit position for IPU_INT_STAT_15_DP_ASF_BRAKE. */
#define BM_IPU_INT_STAT_15_DP_ASF_BRAKE (0x00000080U) /*!< Bit mask for IPU_INT_STAT_15_DP_ASF_BRAKE. */
#define BS_IPU_INT_STAT_15_DP_ASF_BRAKE (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DP_ASF_BRAKE. */

/*! @brief Read current value of the IPU_INT_STAT_15_DP_ASF_BRAKE field. */
#define BR_IPU_INT_STAT_15_DP_ASF_BRAKE(x) (HW_IPU_INT_STAT_15(x).B.DP_ASF_BRAKE)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DP_ASF_BRAKE. */
#define BF_IPU_INT_STAT_15_DP_ASF_BRAKE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DP_ASF_BRAKE) & BM_IPU_INT_STAT_15_DP_ASF_BRAKE)

/*! @brief Set the DP_ASF_BRAKE field to a new value. */
#define BW_IPU_INT_STAT_15_DP_ASF_BRAKE(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DP_ASF_BRAKE(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_0[8] (W1C)
 *
 * DC Frame Complete on channel #0 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_0 (8U)    /*!< Bit position for IPU_INT_STAT_15_DC_FC_0. */
#define BM_IPU_INT_STAT_15_DC_FC_0 (0x00000100U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_0. */
#define BS_IPU_INT_STAT_15_DC_FC_0 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_0. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_0 field. */
#define BR_IPU_INT_STAT_15_DC_FC_0(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_0)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_0. */
#define BF_IPU_INT_STAT_15_DC_FC_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_0) & BM_IPU_INT_STAT_15_DC_FC_0)

/*! @brief Set the DC_FC_0 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_0(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_1[9] (W1C)
 *
 * DC Frame Complete on channel #1 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_1 (9U)    /*!< Bit position for IPU_INT_STAT_15_DC_FC_1. */
#define BM_IPU_INT_STAT_15_DC_FC_1 (0x00000200U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_1. */
#define BS_IPU_INT_STAT_15_DC_FC_1 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_1. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_1 field. */
#define BR_IPU_INT_STAT_15_DC_FC_1(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_1)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_1. */
#define BF_IPU_INT_STAT_15_DC_FC_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_1) & BM_IPU_INT_STAT_15_DC_FC_1)

/*! @brief Set the DC_FC_1 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_1(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_2[10] (W1C)
 *
 * DC Frame Complete on channel #2 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_2 (10U)   /*!< Bit position for IPU_INT_STAT_15_DC_FC_2. */
#define BM_IPU_INT_STAT_15_DC_FC_2 (0x00000400U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_2. */
#define BS_IPU_INT_STAT_15_DC_FC_2 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_2. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_2 field. */
#define BR_IPU_INT_STAT_15_DC_FC_2(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_2)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_2. */
#define BF_IPU_INT_STAT_15_DC_FC_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_2) & BM_IPU_INT_STAT_15_DC_FC_2)

/*! @brief Set the DC_FC_2 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_2(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_3[11] (W1C)
 *
 * DC Frame Complete on channel #3 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_3 (11U)   /*!< Bit position for IPU_INT_STAT_15_DC_FC_3. */
#define BM_IPU_INT_STAT_15_DC_FC_3 (0x00000800U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_3. */
#define BS_IPU_INT_STAT_15_DC_FC_3 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_3. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_3 field. */
#define BR_IPU_INT_STAT_15_DC_FC_3(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_3)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_3. */
#define BF_IPU_INT_STAT_15_DC_FC_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_3) & BM_IPU_INT_STAT_15_DC_FC_3)

/*! @brief Set the DC_FC_3 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_3(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_4[12] (W1C)
 *
 * DC Frame Complete on channel #4 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_4 (12U)   /*!< Bit position for IPU_INT_STAT_15_DC_FC_4. */
#define BM_IPU_INT_STAT_15_DC_FC_4 (0x00001000U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_4. */
#define BS_IPU_INT_STAT_15_DC_FC_4 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_4. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_4 field. */
#define BR_IPU_INT_STAT_15_DC_FC_4(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_4)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_4. */
#define BF_IPU_INT_STAT_15_DC_FC_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_4) & BM_IPU_INT_STAT_15_DC_FC_4)

/*! @brief Set the DC_FC_4 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_4(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_4(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_FC_6[13] (W1C)
 *
 * DC Frame Complete on channel #6 interrupt indication
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_FC_6 (13U)   /*!< Bit position for IPU_INT_STAT_15_DC_FC_6. */
#define BM_IPU_INT_STAT_15_DC_FC_6 (0x00002000U) /*!< Bit mask for IPU_INT_STAT_15_DC_FC_6. */
#define BS_IPU_INT_STAT_15_DC_FC_6 (1U)    /*!< Bit field size in bits for IPU_INT_STAT_15_DC_FC_6. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_FC_6 field. */
#define BR_IPU_INT_STAT_15_DC_FC_6(x) (HW_IPU_INT_STAT_15(x).B.DC_FC_6)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_FC_6. */
#define BF_IPU_INT_STAT_15_DC_FC_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_FC_6) & BM_IPU_INT_STAT_15_DC_FC_6)

/*! @brief Set the DC_FC_6 field to a new value. */
#define BW_IPU_INT_STAT_15_DC_FC_6(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_FC_6(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI_VSYNC_PRE_0[14] (W1C)
 *
 * DI0 interrupt indicating of a VSYNC signal asserted 2 rows before the VSYNC
 * sent to the display
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI_VSYNC_PRE_0 (14U) /*!< Bit position for IPU_INT_STAT_15_DI_VSYNC_PRE_0. */
#define BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 (0x00004000U) /*!< Bit mask for IPU_INT_STAT_15_DI_VSYNC_PRE_0. */
#define BS_IPU_INT_STAT_15_DI_VSYNC_PRE_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI_VSYNC_PRE_0. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI_VSYNC_PRE_0 field. */
#define BR_IPU_INT_STAT_15_DI_VSYNC_PRE_0(x) (HW_IPU_INT_STAT_15(x).B.DI_VSYNC_PRE_0)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI_VSYNC_PRE_0. */
#define BF_IPU_INT_STAT_15_DI_VSYNC_PRE_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI_VSYNC_PRE_0) & BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0)

/*! @brief Set the DI_VSYNC_PRE_0 field to a new value. */
#define BW_IPU_INT_STAT_15_DI_VSYNC_PRE_0(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI_VSYNC_PRE_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI_VSYNC_PRE_1[15] (W1C)
 *
 * DI1 interrupt indicating of a VSYNC signal asserted 2 rows before the VSYNC
 * sent to the display
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI_VSYNC_PRE_1 (15U) /*!< Bit position for IPU_INT_STAT_15_DI_VSYNC_PRE_1. */
#define BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 (0x00008000U) /*!< Bit mask for IPU_INT_STAT_15_DI_VSYNC_PRE_1. */
#define BS_IPU_INT_STAT_15_DI_VSYNC_PRE_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI_VSYNC_PRE_1. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI_VSYNC_PRE_1 field. */
#define BR_IPU_INT_STAT_15_DI_VSYNC_PRE_1(x) (HW_IPU_INT_STAT_15(x).B.DI_VSYNC_PRE_1)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI_VSYNC_PRE_1. */
#define BF_IPU_INT_STAT_15_DI_VSYNC_PRE_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI_VSYNC_PRE_1) & BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1)

/*! @brief Set the DI_VSYNC_PRE_1 field to a new value. */
#define BW_IPU_INT_STAT_15_DI_VSYNC_PRE_1(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI_VSYNC_PRE_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_DP_START[16] (W1C)
 *
 * This bit indicates on an interrupt asserted anytime the DP start a new sync
 * or async flow or when an async flow is interrupted by a sync flow
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_DP_START (16U) /*!< Bit position for IPU_INT_STAT_15_DC_DP_START. */
#define BM_IPU_INT_STAT_15_DC_DP_START (0x00010000U) /*!< Bit mask for IPU_INT_STAT_15_DC_DP_START. */
#define BS_IPU_INT_STAT_15_DC_DP_START (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DC_DP_START. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_DP_START field. */
#define BR_IPU_INT_STAT_15_DC_DP_START(x) (HW_IPU_INT_STAT_15(x).B.DC_DP_START)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_DP_START. */
#define BF_IPU_INT_STAT_15_DC_DP_START(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_DP_START) & BM_IPU_INT_STAT_15_DC_DP_START)

/*! @brief Set the DC_DP_START field to a new value. */
#define BW_IPU_INT_STAT_15_DC_DP_START(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_DP_START(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DC_ASYNC_STOP[17] (W1C)
 *
 * This bit indicates on an interrupt asserted anytime the DP stops an async
 * flow and moves to a sync flow
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DC_ASYNC_STOP (17U) /*!< Bit position for IPU_INT_STAT_15_DC_ASYNC_STOP. */
#define BM_IPU_INT_STAT_15_DC_ASYNC_STOP (0x00020000U) /*!< Bit mask for IPU_INT_STAT_15_DC_ASYNC_STOP. */
#define BS_IPU_INT_STAT_15_DC_ASYNC_STOP (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DC_ASYNC_STOP. */

/*! @brief Read current value of the IPU_INT_STAT_15_DC_ASYNC_STOP field. */
#define BR_IPU_INT_STAT_15_DC_ASYNC_STOP(x) (HW_IPU_INT_STAT_15(x).B.DC_ASYNC_STOP)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DC_ASYNC_STOP. */
#define BF_IPU_INT_STAT_15_DC_ASYNC_STOP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DC_ASYNC_STOP) & BM_IPU_INT_STAT_15_DC_ASYNC_STOP)

/*! @brief Set the DC_ASYNC_STOP field to a new value. */
#define BW_IPU_INT_STAT_15_DC_ASYNC_STOP(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DC_ASYNC_STOP(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_0[18] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #0 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 (18U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_0. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 (0x00040000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_0. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_0. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_0)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_0. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0)

/*! @brief Set the DI0_CNT_EN_PRE_0 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_1[19] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #1 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 (19U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_1. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 (0x00080000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_1. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_1. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_1)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_1. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1)

/*! @brief Set the DI0_CNT_EN_PRE_1 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_2[20] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #2 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 (20U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_2. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 (0x00100000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_2. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_2. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_2)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_2. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2)

/*! @brief Set the DI0_CNT_EN_PRE_2 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_3[21] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #3 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 (21U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_3. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 (0x00200000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_3. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_3. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_3)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_3. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3)

/*! @brief Set the DI0_CNT_EN_PRE_3 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_4[22] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #4 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 (22U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_4. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 (0x00400000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_4. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_4. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_4)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_4. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4)

/*! @brief Set the DI0_CNT_EN_PRE_4 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_5[23] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #5 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 (23U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_5. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 (0x00800000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_5. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_5. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_5)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_5. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5)

/*! @brief Set the DI0_CNT_EN_PRE_5 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_6[24] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #6 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 (24U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_6. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 (0x01000000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_6. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_6. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_6)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_6. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6)

/*! @brief Set the DI0_CNT_EN_PRE_6 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_7[25] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #7 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 (25U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_7. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 (0x02000000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_7. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_7. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_7)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_7. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7)

/*! @brief Set the DI0_CNT_EN_PRE_7 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_8[26] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #8 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 (26U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_8. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 (0x04000000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_8. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_8. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_8)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_8. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8)

/*! @brief Set the DI0_CNT_EN_PRE_8 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_9[27] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #9 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 (27U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_9. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 (0x08000000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_9. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_9. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_9)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_9. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9)

/*! @brief Set the DI0_CNT_EN_PRE_9 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI0_CNT_EN_PRE_10[28] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #10 of DI0
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 (28U) /*!< Bit position for IPU_INT_STAT_15_DI0_CNT_EN_PRE_10. */
#define BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 (0x10000000U) /*!< Bit mask for IPU_INT_STAT_15_DI0_CNT_EN_PRE_10. */
#define BS_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI0_CNT_EN_PRE_10. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 field. */
#define BR_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10(x) (HW_IPU_INT_STAT_15(x).B.DI0_CNT_EN_PRE_10)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI0_CNT_EN_PRE_10. */
#define BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10) & BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10)

/*! @brief Set the DI0_CNT_EN_PRE_10 field to a new value. */
#define BW_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI1_DISP_CLK_EN_PRE[29] (W1C)
 *
 * DI1_DISP_CLK_EN_PRE
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE (29U) /*!< Bit position for IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE. */
#define BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE (0x20000000U) /*!< Bit mask for IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE. */
#define BS_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE field. */
#define BR_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE(x) (HW_IPU_INT_STAT_15(x).B.DI1_DISP_CLK_EN_PRE)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE. */
#define BF_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE) & BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE)

/*! @brief Set the DI1_DISP_CLK_EN_PRE field to a new value. */
#define BW_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI1_CNT_EN_PRE_3[30] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #3 of DI1
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 (30U) /*!< Bit position for IPU_INT_STAT_15_DI1_CNT_EN_PRE_3. */
#define BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 (0x40000000U) /*!< Bit mask for IPU_INT_STAT_15_DI1_CNT_EN_PRE_3. */
#define BS_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI1_CNT_EN_PRE_3. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 field. */
#define BR_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3(x) (HW_IPU_INT_STAT_15(x).B.DI1_CNT_EN_PRE_3)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI1_CNT_EN_PRE_3. */
#define BF_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3) & BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3)

/*! @brief Set the DI1_CNT_EN_PRE_3 field to a new value. */
#define BW_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)) | BF_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3(v)))
/*@}*/

/*!
 * @name Register IPU_INT_STAT_15, field DI1_CNT_EN_PRE_8[31] (W1C)
 *
 * This bit indicates on the interrupt that is a result of a trigger generated
 * by counter #8 of DI1
 *
 * Values:
 * - 0 - Interrupt is cleared.
 * - 1 - Interrupt is requested.
 */
/*@{*/
#define BP_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8 (31U) /*!< Bit position for IPU_INT_STAT_15_DI1_CNT_EN_PRE_8. */
#define BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8 (0x80000000U) /*!< Bit mask for IPU_INT_STAT_15_DI1_CNT_EN_PRE_8. */
#define BS_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8 (1U) /*!< Bit field size in bits for IPU_INT_STAT_15_DI1_CNT_EN_PRE_8. */

/*! @brief Read current value of the IPU_INT_STAT_15_DI1_CNT_EN_PRE_8 field. */
#define BR_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8(x) (HW_IPU_INT_STAT_15(x).B.DI1_CNT_EN_PRE_8)

/*! @brief Format value for bitfield IPU_INT_STAT_15_DI1_CNT_EN_PRE_8. */
#define BF_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8) & BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8)

/*! @brief Set the DI1_CNT_EN_PRE_8 field to a new value. */
#define BW_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8(x, v) (HW_IPU_INT_STAT_15_WR(x, (HW_IPU_INT_STAT_15_RD(x) & ~(BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_SNOOPING1_INT | BM_IPU_INT_STAT_15_SNOOPING2_INT | BM_IPU_INT_STAT_15_DP_SF_START | BM_IPU_INT_STAT_15_DP_SF_END | BM_IPU_INT_STAT_15_DP_ASF_START | BM_IPU_INT_STAT_15_DP_ASF_END | BM_IPU_INT_STAT_15_DP_SF_BRAKE | BM_IPU_INT_STAT_15_DP_ASF_BRAKE | BM_IPU_INT_STAT_15_DC_FC_0 | BM_IPU_INT_STAT_15_DC_FC_1 | BM_IPU_INT_STAT_15_DC_FC_2 | BM_IPU_INT_STAT_15_DC_FC_3 | BM_IPU_INT_STAT_15_DC_FC_4 | BM_IPU_INT_STAT_15_DC_FC_6 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_0 | BM_IPU_INT_STAT_15_DI_VSYNC_PRE_1 | BM_IPU_INT_STAT_15_DC_DP_START | BM_IPU_INT_STAT_15_DC_ASYNC_STOP | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_0 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_1 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_2 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_3 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_4 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_5 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_6 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_7 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_8 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_9 | BM_IPU_INT_STAT_15_DI0_CNT_EN_PRE_10 | BM_IPU_INT_STAT_15_DI1_DISP_CLK_EN_PRE | BM_IPU_INT_STAT_15_DI1_CNT_EN_PRE_3)) | BF_IPU_INT_STAT_15_DI1_CNT_EN_PRE_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CUR_BUF_0 - Current Buffer Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_CUR_BUF_0 - Current Buffer Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information bit for each DMA
 * channel.
 */
typedef union _hw_ipu_cur_buf_0
{
    uint32_t U;
    struct _hw_ipu_cur_buf_0_bitfields
    {
        uint32_t DMA_CH_CUR_BUF_0 : 1; /*!< [0]  */
        uint32_t DMA_CH_CUR_BUF_1 : 1; /*!< [1]  */
        uint32_t DMA_CH_CUR_BUF_2 : 1; /*!< [2]  */
        uint32_t DMA_CH_CUR_BUF_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DMA_CH_CUR_BUF_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t DMA_CH_CUR_BUF_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_CUR_BUF_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_CUR_BUF_10 : 1; /*!< [10]  */
        uint32_t DMA_CH_CUR_BUF_11 : 1; /*!< [11]  */
        uint32_t DMA_CH_CUR_BUF_12 : 1; /*!< [12]  */
        uint32_t DMA_CH_CUR_BUF_13 : 1; /*!< [13]  */
        uint32_t DMA_CH_CUR_BUF_14 : 1; /*!< [14]  */
        uint32_t DMA_CH_CUR_BUF_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t DMA_CH_CUR_BUF_17 : 1; /*!< [17]  */
        uint32_t DMA_CH_CUR_BUF_18 : 1; /*!< [18]  */
        uint32_t DMA_CH_CUR_BUF_19 : 1; /*!< [19]  */
        uint32_t DMA_CH_CUR_BUF_20 : 1; /*!< [20]  */
        uint32_t DMA_CH_CUR_BUF_21 : 1; /*!< [21]  */
        uint32_t DMA_CH_CUR_BUF_22 : 1; /*!< [22]  */
        uint32_t DMA_CH_CUR_BUF_23 : 1; /*!< [23]  */
        uint32_t DMA_CH_CUR_BUF_24 : 1; /*!< [24]  */
        uint32_t DMA_CH_CUR_BUF_25 : 1; /*!< [25]  */
        uint32_t DMA_CH_CUR_BUF_26 : 1; /*!< [26]  */
        uint32_t DMA_CH_CUR_BUF_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_CUR_BUF_28 : 1; /*!< [28]  */
        uint32_t DMA_CH_CUR_BUF_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t DMA_CH_CUR_BUF_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_cur_buf_0_t;

/*!
 * @name Constants and macros for entire IPU_CUR_BUF_0 register
 */
/*@{*/
#define HW_IPU_CUR_BUF_0_ADDR(x) ((uintptr_t)(x) + 0x23CU)

#define HW_IPU_CUR_BUF_0(x)      (*(__I hw_ipu_cur_buf_0_t *) HW_IPU_CUR_BUF_0_ADDR(x))
#define HW_IPU_CUR_BUF_0_RD(x)   (HW_IPU_CUR_BUF_0(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_CUR_BUF_0 bitfields
 */

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_0[0] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0 (0U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0 (0x00000001U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_0(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_0)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_1[1] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1 (1U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1 (0x00000002U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_1(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_1)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_2[2] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2 (2U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2 (0x00000004U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_2(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_2)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_3[3] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3 (3U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3 (0x00000008U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_3(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_3)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_5[5] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5 (5U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5 (0x00000020U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_5(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_5)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_8[8] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8 (8U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8 (0x00000100U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_8(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_8)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_9[9] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9 (9U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9 (0x00000200U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_9(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_9)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_10[10] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10 (10U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10 (0x00000400U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_10(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_10)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_11[11] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11 (11U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11 (0x00000800U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_11(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_11)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_12[12] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12 (12U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12 (0x00001000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_12(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_12)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_13[13] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13 (13U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13 (0x00002000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_13(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_13)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_14[14] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14 (14U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14 (0x00004000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_14(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_14)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_15[15] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15 (15U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15 (0x00008000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_15(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_15)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_17[17] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17 (17U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17 (0x00020000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_17(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_17)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_18[18] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18 (18U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18 (0x00040000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_18(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_18)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_19[19] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19 (19U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19 (0x00080000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_19(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_19)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_20[20] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20 (20U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20 (0x00100000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_20(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_20)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_21[21] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21 (21U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21 (0x00200000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_21(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_21)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_22[22] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22 (22U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22 (0x00400000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_22(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_22)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_23[23] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23 (23U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23 (0x00800000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_23(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_23)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_24[24] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24 (24U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24 (0x01000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_24(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_24)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_25[25] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25 (25U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25 (0x02000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_25(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_25)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_26[26] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26 (26U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26 (0x04000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_26(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_26)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_27[27] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27 (27U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27 (0x08000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_27(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_27)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_28[28] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28 (28U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28 (0x10000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_28(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_28)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_29[29] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29 (29U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29 (0x20000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_29(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_29)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_0, field DMA_CH_CUR_BUF_31[31] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31 (31U) /*!< Bit position for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31. */
#define BM_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31 (0x80000000U) /*!< Bit mask for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31. */
#define BS_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31. */

/*! @brief Read current value of the IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31 field. */
#define BR_IPU_CUR_BUF_0_DMA_CH_CUR_BUF_31(x) (HW_IPU_CUR_BUF_0(x).B.DMA_CH_CUR_BUF_31)
/*@}*/

/*******************************************************************************
 * HW_IPU_CUR_BUF_1 - Current Buffer Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_CUR_BUF_1 - Current Buffer Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information bit for each DMA
 * channel.
 */
typedef union _hw_ipu_cur_buf_1
{
    uint32_t U;
    struct _hw_ipu_cur_buf_1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_CUR_BUF_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t DMA_CH_CUR_BUF_40 : 1; /*!< [8]  */
        uint32_t DMA_CH_CUR_BUF_41 : 1; /*!< [9]  */
        uint32_t DMA_CH_CUR_BUF_42 : 1; /*!< [10]  */
        uint32_t DMA_CH_CUR_BUF_43 : 1; /*!< [11]  */
        uint32_t DMA_CH_CUR_BUF_44 : 1; /*!< [12]  */
        uint32_t DMA_CH_CUR_BUF_45 : 1; /*!< [13]  */
        uint32_t DMA_CH_CUR_BUF_46 : 1; /*!< [14]  */
        uint32_t DMA_CH_CUR_BUF_47 : 1; /*!< [15]  */
        uint32_t DMA_CH_CUR_BUF_48 : 1; /*!< [16]  */
        uint32_t DMA_CH_CUR_BUF_49 : 1; /*!< [17]  */
        uint32_t DMA_CH_CUR_BUF_50 : 1; /*!< [18]  */
        uint32_t DMA_CH_CUR_BUF_51 : 1; /*!< [19]  */
        uint32_t DMA_CH_CUR_BUF_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_cur_buf_1_t;

/*!
 * @name Constants and macros for entire IPU_CUR_BUF_1 register
 */
/*@{*/
#define HW_IPU_CUR_BUF_1_ADDR(x) ((uintptr_t)(x) + 0x240U)

#define HW_IPU_CUR_BUF_1(x)      (*(__I hw_ipu_cur_buf_1_t *) HW_IPU_CUR_BUF_1_ADDR(x))
#define HW_IPU_CUR_BUF_1_RD(x)   (HW_IPU_CUR_BUF_1(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_CUR_BUF_1 bitfields
 */

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_33[1] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33 (1U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33 (0x00000002U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_33(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_33)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_40[8] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40 (8U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40 (0x00000100U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_40(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_40)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_41[9] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41 (9U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41 (0x00000200U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_41(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_41)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_42[10] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42 (10U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42 (0x00000400U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_42(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_42)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_43[11] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43 (11U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43 (0x00000800U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_43(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_43)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_44[12] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44 (12U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44 (0x00001000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_44(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_44)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_45[13] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45 (13U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45 (0x00002000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_45(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_45)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_46[14] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46 (14U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46 (0x00004000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_46(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_46)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_47[15] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47 (15U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47 (0x00008000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_47(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_47)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_48[16] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48 (16U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48 (0x00010000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_48(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_48)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_49[17] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49 (17U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49 (0x00020000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_49(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_49)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_50[18] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50 (18U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50 (0x00040000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_50(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_50)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_51[19] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51 (19U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51 (0x00080000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_51(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_51)
/*@}*/

/*!
 * @name Register IPU_CUR_BUF_1, field DMA_CH_CUR_BUF_52[20] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52 (20U) /*!< Bit position for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52. */
#define BM_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52 (0x00100000U) /*!< Bit mask for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52. */
#define BS_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52 (1U) /*!< Bit field size in bits for IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52. */

/*! @brief Read current value of the IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52 field. */
#define BR_IPU_CUR_BUF_1_DMA_CH_CUR_BUF_52(x) (HW_IPU_CUR_BUF_1(x).B.DMA_CH_CUR_BUF_52)
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CUR_0 - Alternate Current Buffer Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CUR_0 - Alternate Current Buffer Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information bit for each DMA
 * channel.
 */
typedef union _hw_ipu_alt_cur_0
{
    uint32_t U;
    struct _hw_ipu_alt_cur_0_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t DMA_CH_ALT_CUR_BUF_24 : 1; /*!< [24]  */
        uint32_t RESERVED1 : 4;        /*!< [28:25]  */
        uint32_t DMA_CH_ALT_CUR_BUF_29 : 1; /*!< [29]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_alt_cur_0_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CUR_0 register
 */
/*@{*/
#define HW_IPU_ALT_CUR_0_ADDR(x) ((uintptr_t)(x) + 0x244U)

#define HW_IPU_ALT_CUR_0(x)      (*(__I hw_ipu_alt_cur_0_t *) HW_IPU_ALT_CUR_0_ADDR(x))
#define HW_IPU_ALT_CUR_0_RD(x)   (HW_IPU_ALT_CUR_0(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CUR_0 bitfields
 */

/*!
 * @name Register IPU_ALT_CUR_0, field DMA_CH_ALT_CUR_BUF_24[24] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24 (24U) /*!< Bit position for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24. */
#define BM_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24 (0x01000000U) /*!< Bit mask for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24. */
#define BS_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24 (1U) /*!< Bit field size in bits for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24. */

/*! @brief Read current value of the IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24 field. */
#define BR_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_24(x) (HW_IPU_ALT_CUR_0(x).B.DMA_CH_ALT_CUR_BUF_24)
/*@}*/

/*!
 * @name Register IPU_ALT_CUR_0, field DMA_CH_ALT_CUR_BUF_29[29] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29 (29U) /*!< Bit position for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29. */
#define BM_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29 (0x20000000U) /*!< Bit mask for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29. */
#define BS_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29 (1U) /*!< Bit field size in bits for IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29. */

/*! @brief Read current value of the IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29 field. */
#define BR_IPU_ALT_CUR_0_DMA_CH_ALT_CUR_BUF_29(x) (HW_IPU_ALT_CUR_0(x).B.DMA_CH_ALT_CUR_BUF_29)
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CUR_1 - Alternate Current Buffer Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CUR_1 - Alternate Current Buffer Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information bit for each DMA
 * channel. The register is shown in VDI Plane Size Register 4 Alternate Current
 * Buffer Register 1 , and the register fields are described in VDI Plane Size
 * Register 4 Alternate Current Buffer Register 1 .
 */
typedef union _hw_ipu_alt_cur_1
{
    uint32_t U;
    struct _hw_ipu_alt_cur_1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_ALT_CUR_BUF0_n : 1; /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t DMA_CH_ALT_CUR_BUF1_n : 1; /*!< [9]  */
        uint32_t RESERVED2 : 10;       /*!< [19:10]  */
        uint32_t DMA_CH_ALT_CUR_BUF_52 : 1; /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_alt_cur_1_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CUR_1 register
 */
/*@{*/
#define HW_IPU_ALT_CUR_1_ADDR(x) ((uintptr_t)(x) + 0x248U)

#define HW_IPU_ALT_CUR_1(x)      (*(__I hw_ipu_alt_cur_1_t *) HW_IPU_ALT_CUR_1_ADDR(x))
#define HW_IPU_ALT_CUR_1_RD(x)   (HW_IPU_ALT_CUR_1(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CUR_1 bitfields
 */

/*!
 * @name Register IPU_ALT_CUR_1, field DMA_CH_ALT_CUR_BUF0_n[1] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n (1U) /*!< Bit position for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n. */
#define BM_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n (0x00000002U) /*!< Bit mask for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n. */
#define BS_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n (1U) /*!< Bit field size in bits for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n. */

/*! @brief Read current value of the IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n field. */
#define BR_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF0_n(x) (HW_IPU_ALT_CUR_1(x).B.DMA_CH_ALT_CUR_BUF0_n)
/*@}*/

/*!
 * @name Register IPU_ALT_CUR_1, field DMA_CH_ALT_CUR_BUF1_n[9] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n (9U) /*!< Bit position for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n. */
#define BM_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n (0x00000200U) /*!< Bit mask for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n. */
#define BS_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n (1U) /*!< Bit field size in bits for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n. */

/*! @brief Read current value of the IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n field. */
#define BR_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF1_n(x) (HW_IPU_ALT_CUR_1(x).B.DMA_CH_ALT_CUR_BUF1_n)
/*@}*/

/*!
 * @name Register IPU_ALT_CUR_1, field DMA_CH_ALT_CUR_BUF_52[20] (RO)
 *
 * Current Buffer. This bit indicates which buffer is in use by DMA when double
 * buffer mode is selected. n Indicates the corresponding DMA channel number.
 *
 * Values:
 * - 0 - Current buffer used by DMA is buffer 0.
 * - 1 - Current buffer used by DMA is buffer 1.
 */
/*@{*/
#define BP_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52 (20U) /*!< Bit position for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52. */
#define BM_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52 (0x00100000U) /*!< Bit mask for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52. */
#define BS_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52 (1U) /*!< Bit field size in bits for IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52. */

/*! @brief Read current value of the IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52 field. */
#define BR_IPU_ALT_CUR_1_DMA_CH_ALT_CUR_BUF_52(x) (HW_IPU_ALT_CUR_1(x).B.DMA_CH_ALT_CUR_BUF_52)
/*@}*/

/*******************************************************************************
 * HW_IPU_SRM_STAT - Shadow Registers Memory Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SRM_STAT - Shadow Registers Memory Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The register contains status bits of SRM updates. There is a bit for each
 * block. The bit is set when the SRM is currently updating the module's registers.
 * When the SRM completes updating the registers of the block the bit is cleared.
 * SW should not update the block's registers while it is being updated by the
 * SRM.
 */
typedef union _hw_ipu_srm_stat
{
    uint32_t U;
    struct _hw_ipu_srm_stat_bitfields
    {
        uint32_t DP_S_SRM_STAT : 1;    /*!< [0]  */
        uint32_t DP_A0_SRM_STAT : 1;   /*!< [1]  */
        uint32_t DP_A1_SRM_STAT : 1;   /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t DC_2_SRM_STAT : 1;    /*!< [4]  */
        uint32_t DC_6_SRM_STAT : 1;    /*!< [5]  */
        uint32_t CSI0_SRM_STAT : 1;    /*!< [6]  */
        uint32_t CSI1_SRM_STAT : 1;    /*!< [7]  */
        uint32_t DI0_SRM_STAT : 1;     /*!< [8]  */
        uint32_t DI1_SRM_STAT : 1;     /*!< [9]  */
        uint32_t RESERVED1 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_srm_stat_t;

/*!
 * @name Constants and macros for entire IPU_SRM_STAT register
 */
/*@{*/
#define HW_IPU_SRM_STAT_ADDR(x)  ((uintptr_t)(x) + 0x24CU)

#define HW_IPU_SRM_STAT(x)       (*(__I hw_ipu_srm_stat_t *) HW_IPU_SRM_STAT_ADDR(x))
#define HW_IPU_SRM_STAT_RD(x)    (HW_IPU_SRM_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_SRM_STAT bitfields
 */

/*!
 * @name Register IPU_SRM_STAT, field DP_S_SRM_STAT[0] (RO)
 *
 * DP SYNC FLOW SRM STAT This bit indicates that the SRM is currently updating
 * the DP sync flow registers
 *
 * Values:
 * - 1 - SRM is busy updating the DP sync flow registers
 * - 0 - SRM is not updating the DP sync flow registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DP_S_SRM_STAT (0U) /*!< Bit position for IPU_SRM_STAT_DP_S_SRM_STAT. */
#define BM_IPU_SRM_STAT_DP_S_SRM_STAT (0x00000001U) /*!< Bit mask for IPU_SRM_STAT_DP_S_SRM_STAT. */
#define BS_IPU_SRM_STAT_DP_S_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_DP_S_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DP_S_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DP_S_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DP_S_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DP_A0_SRM_STAT[1] (RO)
 *
 * DP ASYNC0 FLOW SRM STAT This bit indicates that the SRM is currently updating
 * the DP async flow 0 registers
 *
 * Values:
 * - 1 - SRM is busy updating the DP async flow 0 registers
 * - 0 - SRM is not updating the DP async flow 0 registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DP_A0_SRM_STAT (1U) /*!< Bit position for IPU_SRM_STAT_DP_A0_SRM_STAT. */
#define BM_IPU_SRM_STAT_DP_A0_SRM_STAT (0x00000002U) /*!< Bit mask for IPU_SRM_STAT_DP_A0_SRM_STAT. */
#define BS_IPU_SRM_STAT_DP_A0_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_DP_A0_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DP_A0_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DP_A0_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DP_A0_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DP_A1_SRM_STAT[2] (RO)
 *
 * DP ASYNC1 FLOW SRM STAT This bit indicates that the SRM is currently updating
 * the DP async flow 1 registers
 *
 * Values:
 * - 1 - SRM is busy updating the DP sync flow registers
 * - 0 - SRM is not updating the DP sync flow registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DP_A1_SRM_STAT (2U) /*!< Bit position for IPU_SRM_STAT_DP_A1_SRM_STAT. */
#define BM_IPU_SRM_STAT_DP_A1_SRM_STAT (0x00000004U) /*!< Bit mask for IPU_SRM_STAT_DP_A1_SRM_STAT. */
#define BS_IPU_SRM_STAT_DP_A1_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_DP_A1_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DP_A1_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DP_A1_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DP_A1_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DC_2_SRM_STAT[4] (RO)
 *
 * DC group #2 SRM STAT This bit indicates that the SRM is currently updating
 * the DC group #2 registers
 *
 * Values:
 * - 1 - SRM is busy updating the DC group #6 registers
 * - 0 - SRM is not updating the DC group #2 registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DC_2_SRM_STAT (4U) /*!< Bit position for IPU_SRM_STAT_DC_2_SRM_STAT. */
#define BM_IPU_SRM_STAT_DC_2_SRM_STAT (0x00000010U) /*!< Bit mask for IPU_SRM_STAT_DC_2_SRM_STAT. */
#define BS_IPU_SRM_STAT_DC_2_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_DC_2_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DC_2_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DC_2_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DC_2_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DC_6_SRM_STAT[5] (RO)
 *
 * DC group #6 SRM STAT This bit indicates that the SRM is currently updating
 * the DC group #6 registers
 *
 * Values:
 * - 1 - SRM is busy updating the DC registers
 * - 0 - SRM is not updating the DC registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DC_6_SRM_STAT (5U) /*!< Bit position for IPU_SRM_STAT_DC_6_SRM_STAT. */
#define BM_IPU_SRM_STAT_DC_6_SRM_STAT (0x00000020U) /*!< Bit mask for IPU_SRM_STAT_DC_6_SRM_STAT. */
#define BS_IPU_SRM_STAT_DC_6_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_DC_6_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DC_6_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DC_6_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DC_6_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field CSI0_SRM_STAT[6] (RO)
 *
 * CSI1_SRM_STAT
 */
/*@{*/
#define BP_IPU_SRM_STAT_CSI0_SRM_STAT (6U) /*!< Bit position for IPU_SRM_STAT_CSI0_SRM_STAT. */
#define BM_IPU_SRM_STAT_CSI0_SRM_STAT (0x00000040U) /*!< Bit mask for IPU_SRM_STAT_CSI0_SRM_STAT. */
#define BS_IPU_SRM_STAT_CSI0_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_CSI0_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_CSI0_SRM_STAT field. */
#define BR_IPU_SRM_STAT_CSI0_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.CSI0_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field CSI1_SRM_STAT[7] (RO)
 *
 * CSI1_SRM_STAT
 */
/*@{*/
#define BP_IPU_SRM_STAT_CSI1_SRM_STAT (7U) /*!< Bit position for IPU_SRM_STAT_CSI1_SRM_STAT. */
#define BM_IPU_SRM_STAT_CSI1_SRM_STAT (0x00000080U) /*!< Bit mask for IPU_SRM_STAT_CSI1_SRM_STAT. */
#define BS_IPU_SRM_STAT_CSI1_SRM_STAT (1U) /*!< Bit field size in bits for IPU_SRM_STAT_CSI1_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_CSI1_SRM_STAT field. */
#define BR_IPU_SRM_STAT_CSI1_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.CSI1_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DI0_SRM_STAT[8] (RO)
 *
 * DI0 SRM STAT This bit indicates that the SRM is currently updating the DI0
 * registers
 *
 * Values:
 * - 1 - SRM is busy updating the DI0 registers
 * - 0 - SRM is not updating the DI0 registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DI0_SRM_STAT (8U)  /*!< Bit position for IPU_SRM_STAT_DI0_SRM_STAT. */
#define BM_IPU_SRM_STAT_DI0_SRM_STAT (0x00000100U) /*!< Bit mask for IPU_SRM_STAT_DI0_SRM_STAT. */
#define BS_IPU_SRM_STAT_DI0_SRM_STAT (1U)  /*!< Bit field size in bits for IPU_SRM_STAT_DI0_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DI0_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DI0_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DI0_SRM_STAT)
/*@}*/

/*!
 * @name Register IPU_SRM_STAT, field DI1_SRM_STAT[9] (RO)
 *
 * DI1 SRM STAT This bit indicates that the SRM is currently updating the DI1
 * registers
 *
 * Values:
 * - 1 - SRM is busy updating the DI1 registers
 * - 0 - SRM is not updating the DI1 registers
 */
/*@{*/
#define BP_IPU_SRM_STAT_DI1_SRM_STAT (9U)  /*!< Bit position for IPU_SRM_STAT_DI1_SRM_STAT. */
#define BM_IPU_SRM_STAT_DI1_SRM_STAT (0x00000200U) /*!< Bit mask for IPU_SRM_STAT_DI1_SRM_STAT. */
#define BS_IPU_SRM_STAT_DI1_SRM_STAT (1U)  /*!< Bit field size in bits for IPU_SRM_STAT_DI1_SRM_STAT. */

/*! @brief Read current value of the IPU_SRM_STAT_DI1_SRM_STAT field. */
#define BR_IPU_SRM_STAT_DI1_SRM_STAT(x) (HW_IPU_SRM_STAT(x).B.DI1_SRM_STAT)
/*@}*/

/*******************************************************************************
 * HW_IPU_PROC_TASKS_STAT - Processing Status Tasks Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PROC_TASKS_STAT - Processing Status Tasks Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains status bits for IPU's tasks.
 */
typedef union _hw_ipu_proc_tasks_stat
{
    uint32_t U;
    struct _hw_ipu_proc_tasks_stat_bitfields
    {
        uint32_t ENC_TSTAT : 2;        /*!< [1:0]  */
        uint32_t VF_TSTAT : 2;         /*!< [3:2]  */
        uint32_t PP_TSTAT : 2;         /*!< [5:4]  */
        uint32_t ENC_ROT_TSTAT : 2;    /*!< [7:6]  */
        uint32_t VF_ROT_TSTAT : 2;     /*!< [9:8]  */
        uint32_t PP_ROT_TSTAT : 2;     /*!< [11:10]  */
        uint32_t MEM2PRP_TSTAT : 3;    /*!< [14:12]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_ipu_proc_tasks_stat_t;

/*!
 * @name Constants and macros for entire IPU_PROC_TASKS_STAT register
 */
/*@{*/
#define HW_IPU_PROC_TASKS_STAT_ADDR(x) ((uintptr_t)(x) + 0x250U)

#define HW_IPU_PROC_TASKS_STAT(x) (*(__I hw_ipu_proc_tasks_stat_t *) HW_IPU_PROC_TASKS_STAT_ADDR(x))
#define HW_IPU_PROC_TASKS_STAT_RD(x) (HW_IPU_PROC_TASKS_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_PROC_TASKS_STAT bitfields
 */

/*!
 * @name Register IPU_PROC_TASKS_STAT, field ENC_TSTAT[1:0] (RO)
 *
 * Status of the encoding task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_ENC_TSTAT (0U) /*!< Bit position for IPU_PROC_TASKS_STAT_ENC_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_ENC_TSTAT (0x00000003U) /*!< Bit mask for IPU_PROC_TASKS_STAT_ENC_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_ENC_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_ENC_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_ENC_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_ENC_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.ENC_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field VF_TSTAT[3:2] (RO)
 *
 * Status of the viewfinder task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_VF_TSTAT (2U) /*!< Bit position for IPU_PROC_TASKS_STAT_VF_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_VF_TSTAT (0x0000000CU) /*!< Bit mask for IPU_PROC_TASKS_STAT_VF_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_VF_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_VF_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_VF_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_VF_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.VF_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field PP_TSTAT[5:4] (RO)
 *
 * Status of the post processing task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_PP_TSTAT (4U) /*!< Bit position for IPU_PROC_TASKS_STAT_PP_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_PP_TSTAT (0x00000030U) /*!< Bit mask for IPU_PROC_TASKS_STAT_PP_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_PP_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_PP_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_PP_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_PP_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.PP_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field ENC_ROT_TSTAT[7:6] (RO)
 *
 * Status of the rotation for encoding task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT (6U) /*!< Bit position for IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT (0x000000C0U) /*!< Bit mask for IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_ENC_ROT_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.ENC_ROT_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field VF_ROT_TSTAT[9:8] (RO)
 *
 * Status of the rotation for viewfinder task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_VF_ROT_TSTAT (8U) /*!< Bit position for IPU_PROC_TASKS_STAT_VF_ROT_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_VF_ROT_TSTAT (0x00000300U) /*!< Bit mask for IPU_PROC_TASKS_STAT_VF_ROT_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_VF_ROT_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_VF_ROT_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_VF_ROT_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_VF_ROT_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.VF_ROT_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field PP_ROT_TSTAT[11:10] (RO)
 *
 * Status of the rotation for post processing task
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - The primary flow of this task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_PP_ROT_TSTAT (10U) /*!< Bit position for IPU_PROC_TASKS_STAT_PP_ROT_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_PP_ROT_TSTAT (0x00000C00U) /*!< Bit mask for IPU_PROC_TASKS_STAT_PP_ROT_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_PP_ROT_TSTAT (2U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_PP_ROT_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_PP_ROT_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_PP_ROT_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.PP_ROT_TSTAT)
/*@}*/

/*!
 * @name Register IPU_PROC_TASKS_STAT, field MEM2PRP_TSTAT[14:12] (RO)
 *
 * Status of the pre processing tasks (viewfinder and encoding) when the source
 * is coming from the memory.
 *
 * Values:
 * - 000 - IDLE - Both pre processing tasks are idle
 * - 001 - BOTH_ACTIVE - Both pre processing tasks are idle
 * - 010 - ENC_ACTIVE - Encoding task is active
 * - 011 - VF_ACTIVE - View finder task is active
 * - 100 - BOTH_PAUSE - both tasks are paused
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserve
 */
/*@{*/
#define BP_IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT (12U) /*!< Bit position for IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT. */
#define BM_IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT (0x00007000U) /*!< Bit mask for IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT. */
#define BS_IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT (3U) /*!< Bit field size in bits for IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT. */

/*! @brief Read current value of the IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT field. */
#define BR_IPU_PROC_TASKS_STAT_MEM2PRP_TSTAT(x) (HW_IPU_PROC_TASKS_STAT(x).B.MEM2PRP_TSTAT)
/*@}*/

/*******************************************************************************
 * HW_IPU_DISP_TASKS_STAT - Display Tasks Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DISP_TASKS_STAT - Display Tasks Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains status bits for IPU's tasks.
 */
typedef union _hw_ipu_disp_tasks_stat
{
    uint32_t U;
    struct _hw_ipu_disp_tasks_stat_bitfields
    {
        uint32_t DP_ASYNC_STAT : 3;    /*!< [2:0]  */
        uint32_t DP_ASYNC_CUR_FLOW : 1; /*!< [3]  */
        uint32_t DC_ASYNC1_STAT : 2;   /*!< [5:4]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t DC_ASYNCH2_STAT : 3;  /*!< [10:8]  */
        uint32_t DC_ASYNC2_CUR_FLOW : 1; /*!< [11]  */
        uint32_t RESERVED1 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_disp_tasks_stat_t;

/*!
 * @name Constants and macros for entire IPU_DISP_TASKS_STAT register
 */
/*@{*/
#define HW_IPU_DISP_TASKS_STAT_ADDR(x) ((uintptr_t)(x) + 0x254U)

#define HW_IPU_DISP_TASKS_STAT(x) (*(__I hw_ipu_disp_tasks_stat_t *) HW_IPU_DISP_TASKS_STAT_ADDR(x))
#define HW_IPU_DISP_TASKS_STAT_RD(x) (HW_IPU_DISP_TASKS_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DISP_TASKS_STAT bitfields
 */

/*!
 * @name Register IPU_DISP_TASKS_STAT, field DP_ASYNC_STAT[2:0] (RO)
 *
 * Status of the Asynchronous flow through the DP
 *
 * Values:
 * - 000 - IDLE - the task is idle
 * - 001 - PRIM_ACTIVE - The primary flow of this task is currently active
 * - 010 - ALT_ACTIVE - The alternate flow of this task is currently active
 * - 011 - UPDATE_PARAM - The FSU is busy updating parameters from the SRM
 * - 100 - PAUSE - The task is paused
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DISP_TASKS_STAT_DP_ASYNC_STAT (0U) /*!< Bit position for IPU_DISP_TASKS_STAT_DP_ASYNC_STAT. */
#define BM_IPU_DISP_TASKS_STAT_DP_ASYNC_STAT (0x00000007U) /*!< Bit mask for IPU_DISP_TASKS_STAT_DP_ASYNC_STAT. */
#define BS_IPU_DISP_TASKS_STAT_DP_ASYNC_STAT (3U) /*!< Bit field size in bits for IPU_DISP_TASKS_STAT_DP_ASYNC_STAT. */

/*! @brief Read current value of the IPU_DISP_TASKS_STAT_DP_ASYNC_STAT field. */
#define BR_IPU_DISP_TASKS_STAT_DP_ASYNC_STAT(x) (HW_IPU_DISP_TASKS_STAT(x).B.DP_ASYNC_STAT)
/*@}*/

/*!
 * @name Register IPU_DISP_TASKS_STAT, field DP_ASYNC_CUR_FLOW[3] (RO)
 *
 * Current asynchronous flow via the DP
 *
 * Values:
 * - 1 - alternate flow
 * - 0 - main flow
 */
/*@{*/
#define BP_IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW (3U) /*!< Bit position for IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW. */
#define BM_IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW (0x00000008U) /*!< Bit mask for IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW. */
#define BS_IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW (1U) /*!< Bit field size in bits for IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW. */

/*! @brief Read current value of the IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW field. */
#define BR_IPU_DISP_TASKS_STAT_DP_ASYNC_CUR_FLOW(x) (HW_IPU_DISP_TASKS_STAT(x).B.DP_ASYNC_CUR_FLOW)
/*@}*/

/*!
 * @name Register IPU_DISP_TASKS_STAT, field DC_ASYNC1_STAT[5:4] (RO)
 *
 * Status of the Asynchronous flow #1 through the DC (ch 28)
 *
 * Values:
 * - 00 - IDLE - The task is idle
 * - 01 - ACTIVE - This task is currently active
 * - 10 - WAIT_FOR_ READY - The task is waiting for a buffer to be ready
 */
/*@{*/
#define BP_IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT (4U) /*!< Bit position for IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT. */
#define BM_IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT (0x00000030U) /*!< Bit mask for IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT. */
#define BS_IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT (2U) /*!< Bit field size in bits for IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT. */

/*! @brief Read current value of the IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT field. */
#define BR_IPU_DISP_TASKS_STAT_DC_ASYNC1_STAT(x) (HW_IPU_DISP_TASKS_STAT(x).B.DC_ASYNC1_STAT)
/*@}*/

/*!
 * @name Register IPU_DISP_TASKS_STAT, field DC_ASYNCH2_STAT[10:8] (RO)
 *
 * Status of the Asynchronous flow #2 through the DC
 *
 * Values:
 * - 000 - IDLE - the task is idle
 * - 001 - PRIM_ACTIVE - The primary flow of this task is currently active
 * - 010 - ALT_ACTIVE - The alternate flow of this task is currently active
 * - 011 - UPDATE_PARAM - The FSU is busy updating parameters from the SRM
 * - 100 - PAUSE - The task is paused
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT (8U) /*!< Bit position for IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT. */
#define BM_IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT (0x00000700U) /*!< Bit mask for IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT. */
#define BS_IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT (3U) /*!< Bit field size in bits for IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT. */

/*! @brief Read current value of the IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT field. */
#define BR_IPU_DISP_TASKS_STAT_DC_ASYNCH2_STAT(x) (HW_IPU_DISP_TASKS_STAT(x).B.DC_ASYNCH2_STAT)
/*@}*/

/*!
 * @name Register IPU_DISP_TASKS_STAT, field DC_ASYNC2_CUR_FLOW[11] (RO)
 *
 * Current asynchronous #2 flow via the DC
 *
 * Values:
 * - 1 - alternate flow
 * - 0 - main flow
 */
/*@{*/
#define BP_IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW (11U) /*!< Bit position for IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW. */
#define BM_IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW (0x00000800U) /*!< Bit mask for IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW. */
#define BS_IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW (1U) /*!< Bit field size in bits for IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW. */

/*! @brief Read current value of the IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW field. */
#define BR_IPU_DISP_TASKS_STAT_DC_ASYNC2_CUR_FLOW(x) (HW_IPU_DISP_TASKS_STAT(x).B.DC_ASYNC2_CUR_FLOW)
/*@}*/

/*******************************************************************************
 * HW_IPU_TRIPLE_CUR_BUF_0 - Triple Current Buffer Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_TRIPLE_CUR_BUF_0 - Triple Current Buffer Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information for triple
 * buffer mode for each DMA channel. Hide VPU_SUB_FRAME_SYNC for all versions Show
 * VPU_SUB_FRAME_SYNC for IPUv3H version. The table below tagged with other settings
 * (like IPU3M_only) should be hidden in IPUv3H version. This requires some
 * sophisticated conditional tag settings
 */
typedef union _hw_ipu_triple_cur_buf_0
{
    uint32_t U;
    struct _hw_ipu_triple_cur_buf_0_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_8 : 2; /*!< [17:16]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_9 : 2; /*!< [19:18]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_10 : 2; /*!< [21:20]  */
        uint32_t RESERVED1 : 4;        /*!< [25:22]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_13 : 2; /*!< [27:26]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_triple_cur_buf_0_t;

/*!
 * @name Constants and macros for entire IPU_TRIPLE_CUR_BUF_0 register
 */
/*@{*/
#define HW_IPU_TRIPLE_CUR_BUF_0_ADDR(x) ((uintptr_t)(x) + 0x258U)

#define HW_IPU_TRIPLE_CUR_BUF_0(x) (*(__I hw_ipu_triple_cur_buf_0_t *) HW_IPU_TRIPLE_CUR_BUF_0_ADDR(x))
#define HW_IPU_TRIPLE_CUR_BUF_0_RD(x) (HW_IPU_TRIPLE_CUR_BUF_0(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_TRIPLE_CUR_BUF_0 bitfields
 */

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_0, field DMA_CH_TRIPLE_CUR_BUF_8[17:16] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8 (16U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8. */
#define BM_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8 (0x00030000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8. */
#define BS_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8 field. */
#define BR_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_8(x) (HW_IPU_TRIPLE_CUR_BUF_0(x).B.DMA_CH_TRIPLE_CUR_BUF_8)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_0, field DMA_CH_TRIPLE_CUR_BUF_9[19:18] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9 (18U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9. */
#define BM_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9 (0x000C0000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9. */
#define BS_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9 field. */
#define BR_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_9(x) (HW_IPU_TRIPLE_CUR_BUF_0(x).B.DMA_CH_TRIPLE_CUR_BUF_9)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_0, field DMA_CH_TRIPLE_CUR_BUF_10[21:20] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10 (20U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10. */
#define BM_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10 (0x00300000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10. */
#define BS_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10 field. */
#define BR_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_10(x) (HW_IPU_TRIPLE_CUR_BUF_0(x).B.DMA_CH_TRIPLE_CUR_BUF_10)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_0, field DMA_CH_TRIPLE_CUR_BUF_13[27:26] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13 (26U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13. */
#define BM_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13 (0x0C000000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13. */
#define BS_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13 field. */
#define BR_IPU_TRIPLE_CUR_BUF_0_DMA_CH_TRIPLE_CUR_BUF_13(x) (HW_IPU_TRIPLE_CUR_BUF_0(x).B.DMA_CH_TRIPLE_CUR_BUF_13)
/*@}*/

/*******************************************************************************
 * HW_IPU_TRIPLE_CUR_BUF_1 - Triple Current Buffer Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_TRIPLE_CUR_BUF_1 - Triple Current Buffer Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information for triple
 * buffer mode for each DMA channel.
 */
typedef union _hw_ipu_triple_cur_buf_1
{
    uint32_t U;
    struct _hw_ipu_triple_cur_buf_1_bitfields
    {
        uint32_t RESERVED0 : 10;       /*!< [9:0]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_21 : 2; /*!< [11:10]  */
        uint32_t RESERVED1 : 2;        /*!< [13:12]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_23 : 2; /*!< [15:14]  */
        uint32_t RESERVED2 : 6;        /*!< [21:16]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_27 : 2; /*!< [23:22]  */
        uint32_t DMA_CH_TRIPLE_CUR_BUF_28 : 2; /*!< [25:24]  */
        uint32_t RESERVED3 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_triple_cur_buf_1_t;

/*!
 * @name Constants and macros for entire IPU_TRIPLE_CUR_BUF_1 register
 */
/*@{*/
#define HW_IPU_TRIPLE_CUR_BUF_1_ADDR(x) ((uintptr_t)(x) + 0x25CU)

#define HW_IPU_TRIPLE_CUR_BUF_1(x) (*(__I hw_ipu_triple_cur_buf_1_t *) HW_IPU_TRIPLE_CUR_BUF_1_ADDR(x))
#define HW_IPU_TRIPLE_CUR_BUF_1_RD(x) (HW_IPU_TRIPLE_CUR_BUF_1(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_TRIPLE_CUR_BUF_1 bitfields
 */

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_1, field DMA_CH_TRIPLE_CUR_BUF_21[11:10] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21 (10U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21. */
#define BM_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21 (0x00000C00U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21. */
#define BS_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21 field. */
#define BR_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_21(x) (HW_IPU_TRIPLE_CUR_BUF_1(x).B.DMA_CH_TRIPLE_CUR_BUF_21)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_1, field DMA_CH_TRIPLE_CUR_BUF_23[15:14] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23 (14U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23. */
#define BM_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23 (0x0000C000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23. */
#define BS_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23 field. */
#define BR_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_23(x) (HW_IPU_TRIPLE_CUR_BUF_1(x).B.DMA_CH_TRIPLE_CUR_BUF_23)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_1, field DMA_CH_TRIPLE_CUR_BUF_27[23:22] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27 (22U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27. */
#define BM_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27 (0x00C00000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27. */
#define BS_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27 field. */
#define BR_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_27(x) (HW_IPU_TRIPLE_CUR_BUF_1(x).B.DMA_CH_TRIPLE_CUR_BUF_27)
/*@}*/

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_1, field DMA_CH_TRIPLE_CUR_BUF_28[25:24] (RO)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by the DMA when triple buffer mode is selected. Each pair of bits indicate
 * the corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 11 - NA
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28 (24U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28. */
#define BM_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28 (0x03000000U) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28. */
#define BS_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28 (2U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28 field. */
#define BR_IPU_TRIPLE_CUR_BUF_1_DMA_CH_TRIPLE_CUR_BUF_28(x) (HW_IPU_TRIPLE_CUR_BUF_1(x).B.DMA_CH_TRIPLE_CUR_BUF_28)
/*@}*/

/*******************************************************************************
 * HW_IPU_TRIPLE_CUR_BUF_2 - Triple Current Buffer Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_TRIPLE_CUR_BUF_2 - Triple Current Buffer Register 2 (ROZ)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information for triple
 * buffer mode for each DMA channel.
 */
typedef union _hw_ipu_triple_cur_buf_2
{
    uint32_t U;
    struct _hw_ipu_triple_cur_buf_2_bitfields
    {
        uint32_t DMA_CH_TRIPLE_CUR_BUF_n : 32; /*!< [31:0]  */
    } B;
} hw_ipu_triple_cur_buf_2_t;

/*!
 * @name Constants and macros for entire IPU_TRIPLE_CUR_BUF_2 register
 */
/*@{*/
#define HW_IPU_TRIPLE_CUR_BUF_2_ADDR(x) ((uintptr_t)(x) + 0x260U)

#define HW_IPU_TRIPLE_CUR_BUF_2(x) (*(__I hw_ipu_triple_cur_buf_2_t *) HW_IPU_TRIPLE_CUR_BUF_2_ADDR(x))
#define HW_IPU_TRIPLE_CUR_BUF_2_RD(x) (HW_IPU_TRIPLE_CUR_BUF_2(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_TRIPLE_CUR_BUF_2 bitfields
 */

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_2, field DMA_CH_TRIPLE_CUR_BUF_n[31:0] (ROZ)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by DMA when triple buffer mode is selected. Each pair of bits indicate the
 * corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n (0U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n. */
#define BM_IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n (0xFFFFFFFFU) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n. */
#define BS_IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n (32U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n field. */
#define BR_IPU_TRIPLE_CUR_BUF_2_DMA_CH_TRIPLE_CUR_BUF_n(x) (HW_IPU_TRIPLE_CUR_BUF_2(x).U)
/*@}*/

/*******************************************************************************
 * HW_IPU_TRIPLE_CUR_BUF_3 - Triple Current Buffer Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_TRIPLE_CUR_BUF_3 - Triple Current Buffer Register 3 (ROZ)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the current buffer status information for triple
 * buffer mode for each DMA channel.
 */
typedef union _hw_ipu_triple_cur_buf_3
{
    uint32_t U;
    struct _hw_ipu_triple_cur_buf_3_bitfields
    {
        uint32_t DMA_CH_TRIPLE_CUR_BUF_n : 32; /*!< [31:0]  */
    } B;
} hw_ipu_triple_cur_buf_3_t;

/*!
 * @name Constants and macros for entire IPU_TRIPLE_CUR_BUF_3 register
 */
/*@{*/
#define HW_IPU_TRIPLE_CUR_BUF_3_ADDR(x) ((uintptr_t)(x) + 0x264U)

#define HW_IPU_TRIPLE_CUR_BUF_3(x) (*(__I hw_ipu_triple_cur_buf_3_t *) HW_IPU_TRIPLE_CUR_BUF_3_ADDR(x))
#define HW_IPU_TRIPLE_CUR_BUF_3_RD(x) (HW_IPU_TRIPLE_CUR_BUF_3(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_TRIPLE_CUR_BUF_3 bitfields
 */

/*!
 * @name Register IPU_TRIPLE_CUR_BUF_3, field DMA_CH_TRIPLE_CUR_BUF_n[31:0] (ROZ)
 *
 * Current Buffer for triple buffer mode. This bits indicate which buffer is in
 * use by DMA when triple buffer mode is selected. Each pair of bits indicate the
 * corresponding DMA channel (bits [1:0] correspond to ch #0; (bits [3:2]
 * correspond to ch #1, etc.)
 *
 * Values:
 * - 00 - Current buffer used by DMA is buffer 0.
 * - 01 - Current buffer used by DMA is buffer 1.
 * - 10 - Current buffer used by DMA is buffer 2.
 */
/*@{*/
#define BP_IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n (0U) /*!< Bit position for IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n. */
#define BM_IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n (0xFFFFFFFFU) /*!< Bit mask for IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n. */
#define BS_IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n (32U) /*!< Bit field size in bits for IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n. */

/*! @brief Read current value of the IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n field. */
#define BR_IPU_TRIPLE_CUR_BUF_3_DMA_CH_TRIPLE_CUR_BUF_n(x) (HW_IPU_TRIPLE_CUR_BUF_3(x).U)
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF0_RDY0 - IPU Channels Buffer 0 Ready 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF0_RDY0 - IPU Channels Buffer 0 Ready 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (31-0). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF0_RDY0_CLR bit. The register is shown in
 * CH_BUF0_RDY0IPU Channels Buffer 0 Ready 0 Register , and the register fields are
 * described in CH_BUF0_RDY0IPU Channels Buffer 0 Ready 0 Register .
 */
typedef union _hw_ipu_ch_buf0_rdy0
{
    uint32_t U;
    struct _hw_ipu_ch_buf0_rdy0_bitfields
    {
        uint32_t DMA_CH_BUF0_RDY_0 : 1; /*!< [0]  */
        uint32_t DMA_CH_BUF0_RDY_1 : 1; /*!< [1]  */
        uint32_t DMA_CH_BUF0_RDY_2 : 1; /*!< [2]  */
        uint32_t DMA_CH_BUF0_RDY_3 : 1; /*!< [3]  */
        uint32_t DMA_CH_BUF0_RDY_4 : 1; /*!< [4]  */
        uint32_t DMA_CH_BUF0_RDY_5 : 1; /*!< [5]  */
        uint32_t DMA_CH_BUF0_RDY_6 : 1; /*!< [6]  */
        uint32_t DMA_CH_BUF0_RDY_7 : 1; /*!< [7]  */
        uint32_t DMA_CH_BUF0_RDY_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_BUF0_RDY_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_BUF0_RDY_10 : 1; /*!< [10]  */
        uint32_t DMA_CH_BUF0_RDY_11 : 1; /*!< [11]  */
        uint32_t DMA_CH_BUF0_RDY_12 : 1; /*!< [12]  */
        uint32_t DMA_CH_BUF0_RDY_13 : 1; /*!< [13]  */
        uint32_t DMA_CH_BUF0_RDY_14 : 1; /*!< [14]  */
        uint32_t DMA_CH_BUF0_RDY_15 : 1; /*!< [15]  */
        uint32_t RESERVED0 : 1;        /*!< [16]  */
        uint32_t DMA_CH_BUF0_RDY_17 : 1; /*!< [17]  */
        uint32_t DMA_CH_BUF0_RDY_18 : 1; /*!< [18]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t DMA_CH_BUF0_RDY_20 : 1; /*!< [20]  */
        uint32_t DMA_CH_BUF0_RDY_21 : 1; /*!< [21]  */
        uint32_t DMA_CH_BUF0_RDY_22 : 1; /*!< [22]  */
        uint32_t DMA_CH_BUF0_RDY_23 : 1; /*!< [23]  */
        uint32_t DMA_CH_BUF0_RDY_24 : 1; /*!< [24]  */
        uint32_t RESERVED2 : 2;        /*!< [26:25]  */
        uint32_t DMA_CH_BUF0_RDY_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_BUF0_RDY_28 : 1; /*!< [28]  */
        uint32_t DMA_CH_BUF0_RDY_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t DMA_CH_BUF0_RDY_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_ch_buf0_rdy0_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF0_RDY0 register
 */
/*@{*/
#define HW_IPU_CH_BUF0_RDY0_ADDR(x) ((uintptr_t)(x) + 0x268U)

#define HW_IPU_CH_BUF0_RDY0(x)   (*(__IO hw_ipu_ch_buf0_rdy0_t *) HW_IPU_CH_BUF0_RDY0_ADDR(x))
#define HW_IPU_CH_BUF0_RDY0_RD(x) (HW_IPU_CH_BUF0_RDY0(x).U)
#define HW_IPU_CH_BUF0_RDY0_WR(x, v) (HW_IPU_CH_BUF0_RDY0(x).U = (v))
#define HW_IPU_CH_BUF0_RDY0_SET(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, HW_IPU_CH_BUF0_RDY0_RD(x) |  (v)))
#define HW_IPU_CH_BUF0_RDY0_CLR(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, HW_IPU_CH_BUF0_RDY0_RD(x) & ~(v)))
#define HW_IPU_CH_BUF0_RDY0_TOG(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, HW_IPU_CH_BUF0_RDY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF0_RDY0 bitfields
 */

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_0[0] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0 (0U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0 (0x00000001U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_0)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0)

/*! @brief Set the DMA_CH_BUF0_RDY_0 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_0(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_1[1] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1 (1U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1 (0x00000002U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_1)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1)

/*! @brief Set the DMA_CH_BUF0_RDY_1 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_1(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_2[2] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2 (2U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2 (0x00000004U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_2)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2)

/*! @brief Set the DMA_CH_BUF0_RDY_2 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_2(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_3[3] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3 (3U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3 (0x00000008U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_3)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3)

/*! @brief Set the DMA_CH_BUF0_RDY_3 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_3(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_4[4] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4 (4U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4 (0x00000010U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_4)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4)

/*! @brief Set the DMA_CH_BUF0_RDY_4 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_4(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_5[5] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5 (5U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5 (0x00000020U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_5)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5)

/*! @brief Set the DMA_CH_BUF0_RDY_5 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_5(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_6[6] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6 (6U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6 (0x00000040U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_6)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6)

/*! @brief Set the DMA_CH_BUF0_RDY_6 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_6(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_7[7] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7 (7U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7 (0x00000080U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_7)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7)

/*! @brief Set the DMA_CH_BUF0_RDY_7 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_7(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_8[8] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8 (8U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8 (0x00000100U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_8)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8)

/*! @brief Set the DMA_CH_BUF0_RDY_8 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_8(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_9[9] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9 (9U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9 (0x00000200U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_9)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9)

/*! @brief Set the DMA_CH_BUF0_RDY_9 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_9(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_10[10] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10 (10U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10 (0x00000400U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_10)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10)

/*! @brief Set the DMA_CH_BUF0_RDY_10 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_10(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_11[11] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11 (11U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11 (0x00000800U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_11)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11)

/*! @brief Set the DMA_CH_BUF0_RDY_11 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_11(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_12[12] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12 (12U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12 (0x00001000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_12)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12)

/*! @brief Set the DMA_CH_BUF0_RDY_12 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_12(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_13[13] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13 (13U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13 (0x00002000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_13)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13)

/*! @brief Set the DMA_CH_BUF0_RDY_13 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_13(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_14[14] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14 (14U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14 (0x00004000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_14)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14)

/*! @brief Set the DMA_CH_BUF0_RDY_14 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_14(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_15[15] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15 (15U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15 (0x00008000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_15)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15)

/*! @brief Set the DMA_CH_BUF0_RDY_15 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_15(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_17[17] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17 (17U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17 (0x00020000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_17)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17)

/*! @brief Set the DMA_CH_BUF0_RDY_17 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_17(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_18[18] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18 (18U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18 (0x00040000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_18)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18)

/*! @brief Set the DMA_CH_BUF0_RDY_18 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_18(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_20[20] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20 (20U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20 (0x00100000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_20)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20)

/*! @brief Set the DMA_CH_BUF0_RDY_20 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_20(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_21[21] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21 (21U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21 (0x00200000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_21)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21)

/*! @brief Set the DMA_CH_BUF0_RDY_21 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_21(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_22[22] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22 (22U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22 (0x00400000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_22)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22)

/*! @brief Set the DMA_CH_BUF0_RDY_22 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_22(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_23[23] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23 (23U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23 (0x00800000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_23)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23)

/*! @brief Set the DMA_CH_BUF0_RDY_23 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_23(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_24[24] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24 (24U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24 (0x01000000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_24)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24)

/*! @brief Set the DMA_CH_BUF0_RDY_24 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_24(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_27[27] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27 (27U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27 (0x08000000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_27)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27)

/*! @brief Set the DMA_CH_BUF0_RDY_27 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_27(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_28[28] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28 (28U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28 (0x10000000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_28)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28)

/*! @brief Set the DMA_CH_BUF0_RDY_28 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_28(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_29[29] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29 (29U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29 (0x20000000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_29)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29)

/*! @brief Set the DMA_CH_BUF0_RDY_29 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_29(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY0, field DMA_CH_BUF0_RDY_31[31] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31 (31U) /*!< Bit position for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31. */
#define BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31 (0x80000000U) /*!< Bit mask for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31. */
#define BS_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31 field. */
#define BR_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31(x) (HW_IPU_CH_BUF0_RDY0(x).B.DMA_CH_BUF0_RDY_31)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31. */
#define BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31) & BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31)

/*! @brief Set the DMA_CH_BUF0_RDY_31 field to a new value. */
#define BW_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31(x, v) (HW_IPU_CH_BUF0_RDY0_WR(x, (HW_IPU_CH_BUF0_RDY0_RD(x) & ~BM_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31) | BF_IPU_CH_BUF0_RDY0_DMA_CH_BUF0_RDY_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF0_RDY1 - IPU Channels Buffer 0 Ready 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF0_RDY1 - IPU Channels Buffer 0 Ready 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (63-32). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF0_RDY1_CLR bit.
 */
typedef union _hw_ipu_ch_buf0_rdy1
{
    uint32_t U;
    struct _hw_ipu_ch_buf0_rdy1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_BUF0_RDY_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t DMA_CH_BUF0_RDY_40 : 1; /*!< [8]  */
        uint32_t DMA_CH_BUF0_RDY_41 : 1; /*!< [9]  */
        uint32_t DMA_CH_BUF0_RDY_42 : 1; /*!< [10]  */
        uint32_t DMA_CH_BUF0_RDY_43 : 1; /*!< [11]  */
        uint32_t DMA_CH_BUF0_RDY_44 : 1; /*!< [12]  */
        uint32_t DMA_CH_BUF0_RDY_45 : 1; /*!< [13]  */
        uint32_t DMA_CH_BUF0_RDY_46 : 1; /*!< [14]  */
        uint32_t DMA_CH_BUF0_RDY_47 : 1; /*!< [15]  */
        uint32_t DMA_CH_BUF0_RDY_48 : 1; /*!< [16]  */
        uint32_t DMA_CH_BUF0_RDY_49 : 1; /*!< [17]  */
        uint32_t DMA_CH_BUF0_RDY_50 : 1; /*!< [18]  */
        uint32_t DMA_CH_BUF0_RDY_51 : 1; /*!< [19]  */
        uint32_t DMA_CH_BUF0_RDY_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_ch_buf0_rdy1_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF0_RDY1 register
 */
/*@{*/
#define HW_IPU_CH_BUF0_RDY1_ADDR(x) ((uintptr_t)(x) + 0x26CU)

#define HW_IPU_CH_BUF0_RDY1(x)   (*(__IO hw_ipu_ch_buf0_rdy1_t *) HW_IPU_CH_BUF0_RDY1_ADDR(x))
#define HW_IPU_CH_BUF0_RDY1_RD(x) (HW_IPU_CH_BUF0_RDY1(x).U)
#define HW_IPU_CH_BUF0_RDY1_WR(x, v) (HW_IPU_CH_BUF0_RDY1(x).U = (v))
#define HW_IPU_CH_BUF0_RDY1_SET(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, HW_IPU_CH_BUF0_RDY1_RD(x) |  (v)))
#define HW_IPU_CH_BUF0_RDY1_CLR(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, HW_IPU_CH_BUF0_RDY1_RD(x) & ~(v)))
#define HW_IPU_CH_BUF0_RDY1_TOG(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, HW_IPU_CH_BUF0_RDY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF0_RDY1 bitfields
 */

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_33[1] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33 (1U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33 (0x00000002U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_33)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33)

/*! @brief Set the DMA_CH_BUF0_RDY_33 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_33(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_40[8] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40 (8U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40 (0x00000100U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_40)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40)

/*! @brief Set the DMA_CH_BUF0_RDY_40 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_40(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_41[9] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41 (9U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41 (0x00000200U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_41)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41)

/*! @brief Set the DMA_CH_BUF0_RDY_41 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_41(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_42[10] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42 (10U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42 (0x00000400U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_42)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42)

/*! @brief Set the DMA_CH_BUF0_RDY_42 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_42(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_43[11] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43 (11U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43 (0x00000800U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_43)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43)

/*! @brief Set the DMA_CH_BUF0_RDY_43 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_43(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_44[12] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44 (12U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44 (0x00001000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_44)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44)

/*! @brief Set the DMA_CH_BUF0_RDY_44 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_44(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_45[13] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45 (13U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45 (0x00002000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_45)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45)

/*! @brief Set the DMA_CH_BUF0_RDY_45 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_45(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_46[14] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46 (14U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46 (0x00004000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_46)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46)

/*! @brief Set the DMA_CH_BUF0_RDY_46 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_46(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_47[15] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47 (15U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47 (0x00008000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_47)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47)

/*! @brief Set the DMA_CH_BUF0_RDY_47 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_47(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_48[16] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48 (16U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48 (0x00010000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_48)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48)

/*! @brief Set the DMA_CH_BUF0_RDY_48 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_48(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_49[17] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49 (17U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49 (0x00020000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_49)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49)

/*! @brief Set the DMA_CH_BUF0_RDY_49 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_49(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_50[18] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50 (18U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50 (0x00040000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_50)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50)

/*! @brief Set the DMA_CH_BUF0_RDY_50 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_50(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_51[19] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51 (19U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51 (0x00080000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_51)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51)

/*! @brief Set the DMA_CH_BUF0_RDY_51 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_51(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF0_RDY1, field DMA_CH_BUF0_RDY_52[20] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52 (20U) /*!< Bit position for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52. */
#define BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52 (0x00100000U) /*!< Bit mask for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52. */
#define BS_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52 (1U) /*!< Bit field size in bits for IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52. */

/*! @brief Read current value of the IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52 field. */
#define BR_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52(x) (HW_IPU_CH_BUF0_RDY1(x).B.DMA_CH_BUF0_RDY_52)

/*! @brief Format value for bitfield IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52. */
#define BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52) & BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52)

/*! @brief Set the DMA_CH_BUF0_RDY_52 field to a new value. */
#define BW_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52(x, v) (HW_IPU_CH_BUF0_RDY1_WR(x, (HW_IPU_CH_BUF0_RDY1_RD(x) & ~BM_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52) | BF_IPU_CH_BUF0_RDY1_DMA_CH_BUF0_RDY_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF1_RDY0 - IPU Channels Buffer 1 Ready 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF1_RDY0 - IPU Channels Buffer 1 Ready 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 1 ready control information for 32 IPU's DMA
 * channels (31-0). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF1_RDY0_CLR bit.
 */
typedef union _hw_ipu_ch_buf1_rdy0
{
    uint32_t U;
    struct _hw_ipu_ch_buf1_rdy0_bitfields
    {
        uint32_t DMA_CH_BUF1_RDY_0 : 1; /*!< [0]  */
        uint32_t DMA_CH_BUF1_RDY_1 : 1; /*!< [1]  */
        uint32_t DMA_CH_BUF1_RDY_2 : 1; /*!< [2]  */
        uint32_t DMA_CH_BUF1_RDY_3 : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DMA_CH_BUF1_RDY_5 : 1; /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t DMA_CH_BUF1_RDY_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_BUF1_RDY_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_BUF1_RDY_10 : 1; /*!< [10]  */
        uint32_t DMA_CH_BUF1_RDY_ : 1; /*!< [11]  */
        uint32_t DMA_CH_BUF1_RDY_12 : 1; /*!< [12]  */
        uint32_t DMA_CH_BUF1_RDY_13 : 1; /*!< [13]  */
        uint32_t DMA_CH_BUF1_RDY_14 : 1; /*!< [14]  */
        uint32_t DMA_CH_BUF1_RDY_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t DMA_CH_BUF1_RDY_17 : 1; /*!< [17]  */
        uint32_t DMA_CH_BUF1_RDY_18 : 1; /*!< [18]  */
        uint32_t DMA_CH_BUF1_RDY_19 : 1; /*!< [19]  */
        uint32_t DMA_CH_BUF1_RDY_20 : 1; /*!< [20]  */
        uint32_t DMA_CH_BUF1_RDY_21 : 1; /*!< [21]  */
        uint32_t DMA_CH_BUF1_RDY_22 : 1; /*!< [22]  */
        uint32_t DMA_CH_BUF1_RDY_23 : 1; /*!< [23]  */
        uint32_t DMA_CH_BUF1_RDY_24 : 1; /*!< [24]  */
        uint32_t DMA_CH_BUF1_RDY_25 : 1; /*!< [25]  */
        uint32_t DMA_CH_BUF1_RDY_26 : 1; /*!< [26]  */
        uint32_t DMA_CH_BUF1_RDY_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_BUF1_RDY_28 : 1; /*!< [28]  */
        uint32_t DMA_CH_BUF1_RDY_29 : 1; /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t DMA_CH_BUF1_RDY_31 : 1; /*!< [31]  */
    } B;
} hw_ipu_ch_buf1_rdy0_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF1_RDY0 register
 */
/*@{*/
#define HW_IPU_CH_BUF1_RDY0_ADDR(x) ((uintptr_t)(x) + 0x270U)

#define HW_IPU_CH_BUF1_RDY0(x)   (*(__IO hw_ipu_ch_buf1_rdy0_t *) HW_IPU_CH_BUF1_RDY0_ADDR(x))
#define HW_IPU_CH_BUF1_RDY0_RD(x) (HW_IPU_CH_BUF1_RDY0(x).U)
#define HW_IPU_CH_BUF1_RDY0_WR(x, v) (HW_IPU_CH_BUF1_RDY0(x).U = (v))
#define HW_IPU_CH_BUF1_RDY0_SET(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, HW_IPU_CH_BUF1_RDY0_RD(x) |  (v)))
#define HW_IPU_CH_BUF1_RDY0_CLR(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, HW_IPU_CH_BUF1_RDY0_RD(x) & ~(v)))
#define HW_IPU_CH_BUF1_RDY0_TOG(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, HW_IPU_CH_BUF1_RDY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF1_RDY0 bitfields
 */

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_0[0] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0 (0U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0 (0x00000001U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_0)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0)

/*! @brief Set the DMA_CH_BUF1_RDY_0 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_0(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_1[1] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1 (1U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1 (0x00000002U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_1)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1)

/*! @brief Set the DMA_CH_BUF1_RDY_1 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_1(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_2[2] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2 (2U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2 (0x00000004U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_2)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2)

/*! @brief Set the DMA_CH_BUF1_RDY_2 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_2(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_3[3] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3 (3U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3 (0x00000008U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_3)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3)

/*! @brief Set the DMA_CH_BUF1_RDY_3 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_3(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_5[5] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5 (5U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5 (0x00000020U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_5)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5)

/*! @brief Set the DMA_CH_BUF1_RDY_5 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_5(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_8[8] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8 (8U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8 (0x00000100U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_8)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8)

/*! @brief Set the DMA_CH_BUF1_RDY_8 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_8(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_9[9] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9 (9U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9 (0x00000200U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_9)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9)

/*! @brief Set the DMA_CH_BUF1_RDY_9 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_9(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_10[10] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10 (10U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10 (0x00000400U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_10)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10)

/*! @brief Set the DMA_CH_BUF1_RDY_10 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_10(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_[11] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_ (11U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_ (0x00000800U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_ (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_ field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_)

/*! @brief Set the DMA_CH_BUF1_RDY_ field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_12[12] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12 (12U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12 (0x00001000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_12)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12)

/*! @brief Set the DMA_CH_BUF1_RDY_12 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_12(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_13[13] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13 (13U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13 (0x00002000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_13)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13)

/*! @brief Set the DMA_CH_BUF1_RDY_13 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_13(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_14[14] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14 (14U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14 (0x00004000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_14)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14)

/*! @brief Set the DMA_CH_BUF1_RDY_14 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_14(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_15[15] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15 (15U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15 (0x00008000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_15)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15)

/*! @brief Set the DMA_CH_BUF1_RDY_15 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_15(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_17[17] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17 (17U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17 (0x00020000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_17)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17)

/*! @brief Set the DMA_CH_BUF1_RDY_17 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_17(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_18[18] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18 (18U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18 (0x00040000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_18)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18)

/*! @brief Set the DMA_CH_BUF1_RDY_18 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_18(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_19[19] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19 (19U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19 (0x00080000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_19)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19)

/*! @brief Set the DMA_CH_BUF1_RDY_19 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_19(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_20[20] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20 (20U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20 (0x00100000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_20)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20)

/*! @brief Set the DMA_CH_BUF1_RDY_20 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_20(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_21[21] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21 (21U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21 (0x00200000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_21)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21)

/*! @brief Set the DMA_CH_BUF1_RDY_21 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_21(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_22[22] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22 (22U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22 (0x00400000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_22)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22)

/*! @brief Set the DMA_CH_BUF1_RDY_22 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_22(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_23[23] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23 (23U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23 (0x00800000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_23)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23)

/*! @brief Set the DMA_CH_BUF1_RDY_23 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_23(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_24[24] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24 (24U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24 (0x01000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_24)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24)

/*! @brief Set the DMA_CH_BUF1_RDY_24 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_24(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_25[25] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25 (25U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25 (0x02000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_25)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25)

/*! @brief Set the DMA_CH_BUF1_RDY_25 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_25(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_26[26] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26 (26U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26 (0x04000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_26)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26)

/*! @brief Set the DMA_CH_BUF1_RDY_26 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_26(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_27[27] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27 (27U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27 (0x08000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_27)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27)

/*! @brief Set the DMA_CH_BUF1_RDY_27 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_27(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_28[28] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28 (28U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28 (0x10000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_28)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28)

/*! @brief Set the DMA_CH_BUF1_RDY_28 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_28(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_29[29] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29 (29U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29 (0x20000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_29)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29)

/*! @brief Set the DMA_CH_BUF1_RDY_29 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_29(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY0, field DMA_CH_BUF1_RDY_31[31] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31 (31U) /*!< Bit position for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31. */
#define BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31 (0x80000000U) /*!< Bit mask for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31. */
#define BS_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31 field. */
#define BR_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31(x) (HW_IPU_CH_BUF1_RDY0(x).B.DMA_CH_BUF1_RDY_31)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31. */
#define BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31) & BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31)

/*! @brief Set the DMA_CH_BUF1_RDY_31 field to a new value. */
#define BW_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31(x, v) (HW_IPU_CH_BUF1_RDY0_WR(x, (HW_IPU_CH_BUF1_RDY0_RD(x) & ~BM_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31) | BF_IPU_CH_BUF1_RDY0_DMA_CH_BUF1_RDY_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF1_RDY1 - IPU Channels Buffer 1 Ready 1Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF1_RDY1 - IPU Channels Buffer 1 Ready 1Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (63-32). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF1_RDY1_CLR bit. The register is shown in
 * CH_BUF1_RDY1IPU Channels Buffer 1 Ready 1Register , and the register fields are
 * described in CH_BUF1_RDY1IPU Channels Buffer 1 Ready 1Register .
 */
typedef union _hw_ipu_ch_buf1_rdy1
{
    uint32_t U;
    struct _hw_ipu_ch_buf1_rdy1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_BUF0_RDY_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t DMA_CH_BUF0_RDY_40 : 1; /*!< [8]  */
        uint32_t DMA_CH_BUF0_RDY_41 : 1; /*!< [9]  */
        uint32_t DMA_CH_BUF0_RDY_42 : 1; /*!< [10]  */
        uint32_t DMA_CH_BUF0_RDY_43 : 1; /*!< [11]  */
        uint32_t DMA_CH_BUF0_RDY_44 : 1; /*!< [12]  */
        uint32_t DMA_CH_BUF0_RDY_45 : 1; /*!< [13]  */
        uint32_t DMA_CH_BUF0_RDY_46 : 1; /*!< [14]  */
        uint32_t DMA_CH_BUF0_RDY_47 : 1; /*!< [15]  */
        uint32_t DMA_CH_BUF0_RDY_48 : 1; /*!< [16]  */
        uint32_t DMA_CH_BUF0_RDY_49 : 1; /*!< [17]  */
        uint32_t DMA_CH_BUF0_RDY_50 : 1; /*!< [18]  */
        uint32_t DMA_CH_BUF0_RDY_51 : 1; /*!< [19]  */
        uint32_t DMA_CH_BUF0_RDY_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_ch_buf1_rdy1_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF1_RDY1 register
 */
/*@{*/
#define HW_IPU_CH_BUF1_RDY1_ADDR(x) ((uintptr_t)(x) + 0x274U)

#define HW_IPU_CH_BUF1_RDY1(x)   (*(__IO hw_ipu_ch_buf1_rdy1_t *) HW_IPU_CH_BUF1_RDY1_ADDR(x))
#define HW_IPU_CH_BUF1_RDY1_RD(x) (HW_IPU_CH_BUF1_RDY1(x).U)
#define HW_IPU_CH_BUF1_RDY1_WR(x, v) (HW_IPU_CH_BUF1_RDY1(x).U = (v))
#define HW_IPU_CH_BUF1_RDY1_SET(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, HW_IPU_CH_BUF1_RDY1_RD(x) |  (v)))
#define HW_IPU_CH_BUF1_RDY1_CLR(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, HW_IPU_CH_BUF1_RDY1_RD(x) & ~(v)))
#define HW_IPU_CH_BUF1_RDY1_TOG(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, HW_IPU_CH_BUF1_RDY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF1_RDY1 bitfields
 */

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_33[1] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33 (1U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33 (0x00000002U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_33)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33)

/*! @brief Set the DMA_CH_BUF0_RDY_33 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_33(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_40[8] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40 (8U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40 (0x00000100U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_40)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40)

/*! @brief Set the DMA_CH_BUF0_RDY_40 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_40(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_41[9] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41 (9U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41 (0x00000200U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_41)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41)

/*! @brief Set the DMA_CH_BUF0_RDY_41 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_41(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_42[10] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42 (10U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42 (0x00000400U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_42)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42)

/*! @brief Set the DMA_CH_BUF0_RDY_42 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_42(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_43[11] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43 (11U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43 (0x00000800U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_43)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43)

/*! @brief Set the DMA_CH_BUF0_RDY_43 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_43(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_44[12] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44 (12U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44 (0x00001000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_44)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44)

/*! @brief Set the DMA_CH_BUF0_RDY_44 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_44(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_45[13] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45 (13U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45 (0x00002000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_45)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45)

/*! @brief Set the DMA_CH_BUF0_RDY_45 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_45(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_46[14] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46 (14U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46 (0x00004000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_46)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46)

/*! @brief Set the DMA_CH_BUF0_RDY_46 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_46(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_47[15] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47 (15U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47 (0x00008000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_47)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47)

/*! @brief Set the DMA_CH_BUF0_RDY_47 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_47(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_48[16] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48 (16U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48 (0x00010000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_48)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48)

/*! @brief Set the DMA_CH_BUF0_RDY_48 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_48(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_49[17] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49 (17U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49 (0x00020000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_49)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49)

/*! @brief Set the DMA_CH_BUF0_RDY_49 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_49(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_50[18] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50 (18U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50 (0x00040000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_50)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50)

/*! @brief Set the DMA_CH_BUF0_RDY_50 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_50(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_51[19] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51 (19U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51 (0x00080000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_51)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51)

/*! @brief Set the DMA_CH_BUF0_RDY_51 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_51(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF1_RDY1, field DMA_CH_BUF0_RDY_52[20] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - Buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52 (20U) /*!< Bit position for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52. */
#define BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52 (0x00100000U) /*!< Bit mask for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52. */
#define BS_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52 (1U) /*!< Bit field size in bits for IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52. */

/*! @brief Read current value of the IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52 field. */
#define BR_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52(x) (HW_IPU_CH_BUF1_RDY1(x).B.DMA_CH_BUF0_RDY_52)

/*! @brief Format value for bitfield IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52. */
#define BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52) & BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52)

/*! @brief Set the DMA_CH_BUF0_RDY_52 field to a new value. */
#define BW_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52(x, v) (HW_IPU_CH_BUF1_RDY1_WR(x, (HW_IPU_CH_BUF1_RDY1_RD(x) & ~BM_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52) | BF_IPU_CH_BUF1_RDY1_DMA_CH_BUF0_RDY_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_BUF0_RDY0 - IPU Alternate Channels Buffer 0 Ready 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_BUF0_RDY0 - IPU Alternate Channels Buffer 0 Ready 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (31-0). Writing "1" to each field will set each bit. Writing "0" to each
 * field simultaneously will clear all the bits.
 */
typedef union _hw_ipu_alt_ch_buf0_rdy0
{
    uint32_t U;
    struct _hw_ipu_alt_ch_buf0_rdy0_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t DMA_CH_ALT_BUF0_RDY_24 : 1; /*!< [24]  */
        uint32_t RESERVED1 : 4;        /*!< [28:25]  */
        uint32_t DMA_CH_ALT_BUF0_RDY_29 : 1; /*!< [29]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_alt_ch_buf0_rdy0_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_BUF0_RDY0 register
 */
/*@{*/
#define HW_IPU_ALT_CH_BUF0_RDY0_ADDR(x) ((uintptr_t)(x) + 0x278U)

#define HW_IPU_ALT_CH_BUF0_RDY0(x) (*(__IO hw_ipu_alt_ch_buf0_rdy0_t *) HW_IPU_ALT_CH_BUF0_RDY0_ADDR(x))
#define HW_IPU_ALT_CH_BUF0_RDY0_RD(x) (HW_IPU_ALT_CH_BUF0_RDY0(x).U)
#define HW_IPU_ALT_CH_BUF0_RDY0_WR(x, v) (HW_IPU_ALT_CH_BUF0_RDY0(x).U = (v))
#define HW_IPU_ALT_CH_BUF0_RDY0_SET(x, v) (HW_IPU_ALT_CH_BUF0_RDY0_WR(x, HW_IPU_ALT_CH_BUF0_RDY0_RD(x) |  (v)))
#define HW_IPU_ALT_CH_BUF0_RDY0_CLR(x, v) (HW_IPU_ALT_CH_BUF0_RDY0_WR(x, HW_IPU_ALT_CH_BUF0_RDY0_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_BUF0_RDY0_TOG(x, v) (HW_IPU_ALT_CH_BUF0_RDY0_WR(x, HW_IPU_ALT_CH_BUF0_RDY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_BUF0_RDY0 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_BUF0_RDY0, field DMA_CH_ALT_BUF0_RDY_24[24] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24 (24U) /*!< Bit position for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24. */
#define BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24 (0x01000000U) /*!< Bit mask for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24. */
#define BS_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24. */

/*! @brief Read current value of the IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24 field. */
#define BR_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24(x) (HW_IPU_ALT_CH_BUF0_RDY0(x).B.DMA_CH_ALT_BUF0_RDY_24)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24. */
#define BF_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24) & BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24)

/*! @brief Set the DMA_CH_ALT_BUF0_RDY_24 field to a new value. */
#define BW_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24(x, v) (HW_IPU_ALT_CH_BUF0_RDY0_WR(x, (HW_IPU_ALT_CH_BUF0_RDY0_RD(x) & ~BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24) | BF_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_24(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF0_RDY0, field DMA_CH_ALT_BUF0_RDY_29[29] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29 (29U) /*!< Bit position for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29. */
#define BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29 (0x20000000U) /*!< Bit mask for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29. */
#define BS_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29. */

/*! @brief Read current value of the IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29 field. */
#define BR_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29(x) (HW_IPU_ALT_CH_BUF0_RDY0(x).B.DMA_CH_ALT_BUF0_RDY_29)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29. */
#define BF_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29) & BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29)

/*! @brief Set the DMA_CH_ALT_BUF0_RDY_29 field to a new value. */
#define BW_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29(x, v) (HW_IPU_ALT_CH_BUF0_RDY0_WR(x, (HW_IPU_ALT_CH_BUF0_RDY0_RD(x) & ~BM_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29) | BF_IPU_ALT_CH_BUF0_RDY0_DMA_CH_ALT_BUF0_RDY_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_BUF0_RDY1 - IPU Alternate Channels Buffer 0 Ready 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_BUF0_RDY1 - IPU Alternate Channels Buffer 0 Ready 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (63-32). Writing "1" to each field will set each bit. Writing "0" to
 * each field simultaneously will clear all the bits.
 */
typedef union _hw_ipu_alt_ch_buf0_rdy1
{
    uint32_t U;
    struct _hw_ipu_alt_ch_buf0_rdy1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_ALT_BUF0_RDY_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t DMA_CH_ALT_BUF0_RDY_41 : 1; /*!< [9]  */
        uint32_t RESERVED2 : 10;       /*!< [19:10]  */
        uint32_t DMA_CH_ALT_BUF0_RDY_52 : 1; /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_alt_ch_buf0_rdy1_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_BUF0_RDY1 register
 */
/*@{*/
#define HW_IPU_ALT_CH_BUF0_RDY1_ADDR(x) ((uintptr_t)(x) + 0x27CU)

#define HW_IPU_ALT_CH_BUF0_RDY1(x) (*(__IO hw_ipu_alt_ch_buf0_rdy1_t *) HW_IPU_ALT_CH_BUF0_RDY1_ADDR(x))
#define HW_IPU_ALT_CH_BUF0_RDY1_RD(x) (HW_IPU_ALT_CH_BUF0_RDY1(x).U)
#define HW_IPU_ALT_CH_BUF0_RDY1_WR(x, v) (HW_IPU_ALT_CH_BUF0_RDY1(x).U = (v))
#define HW_IPU_ALT_CH_BUF0_RDY1_SET(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, HW_IPU_ALT_CH_BUF0_RDY1_RD(x) |  (v)))
#define HW_IPU_ALT_CH_BUF0_RDY1_CLR(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, HW_IPU_ALT_CH_BUF0_RDY1_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_BUF0_RDY1_TOG(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, HW_IPU_ALT_CH_BUF0_RDY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_BUF0_RDY1 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_BUF0_RDY1, field DMA_CH_ALT_BUF0_RDY_33[1] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33 (1U) /*!< Bit position for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33. */
#define BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33 (0x00000002U) /*!< Bit mask for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33. */
#define BS_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33. */

/*! @brief Read current value of the IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33 field. */
#define BR_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33(x) (HW_IPU_ALT_CH_BUF0_RDY1(x).B.DMA_CH_ALT_BUF0_RDY_33)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33. */
#define BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33) & BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33)

/*! @brief Set the DMA_CH_ALT_BUF0_RDY_33 field to a new value. */
#define BW_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, (HW_IPU_ALT_CH_BUF0_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33) | BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_33(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF0_RDY1, field DMA_CH_ALT_BUF0_RDY_41[9] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41 (9U) /*!< Bit position for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41. */
#define BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41 (0x00000200U) /*!< Bit mask for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41. */
#define BS_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41. */

/*! @brief Read current value of the IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41 field. */
#define BR_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41(x) (HW_IPU_ALT_CH_BUF0_RDY1(x).B.DMA_CH_ALT_BUF0_RDY_41)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41. */
#define BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41) & BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41)

/*! @brief Set the DMA_CH_ALT_BUF0_RDY_41 field to a new value. */
#define BW_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, (HW_IPU_ALT_CH_BUF0_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41) | BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_41(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF0_RDY1, field DMA_CH_ALT_BUF0_RDY_52[20] (RW)
 *
 * Buffer 0 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 0 in memory.
 *
 * Values:
 * - 0 - Buffer 0 is not ready.
 * - 1 - Buffer 0 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52 (20U) /*!< Bit position for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52. */
#define BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52 (0x00100000U) /*!< Bit mask for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52. */
#define BS_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52. */

/*! @brief Read current value of the IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52 field. */
#define BR_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52(x) (HW_IPU_ALT_CH_BUF0_RDY1(x).B.DMA_CH_ALT_BUF0_RDY_52)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52. */
#define BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52) & BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52)

/*! @brief Set the DMA_CH_ALT_BUF0_RDY_52 field to a new value. */
#define BW_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52(x, v) (HW_IPU_ALT_CH_BUF0_RDY1_WR(x, (HW_IPU_ALT_CH_BUF0_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52) | BF_IPU_ALT_CH_BUF0_RDY1_DMA_CH_ALT_BUF0_RDY_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_BUF1_RDY0 - IPU Alternate Channels Buffer1 Ready 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_BUF1_RDY0 - IPU Alternate Channels Buffer1 Ready 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 1 ready control information for 32 IPU's DMA
 * channels (31-0). Writing "1" to each field will set each bit. Writing "0" to each
 * field simultaneously will clear all the bits. The register is shown in
 * ALT_CH_BUF1_RDY0IPU Alternate Channels Buffer1 Ready 0 Register , and the register
 * fields are described in ALT_CH_BUF1_RDY0IPU Alternate Channels Buffer1 Ready 0
 * Register .
 */
typedef union _hw_ipu_alt_ch_buf1_rdy0
{
    uint32_t U;
    struct _hw_ipu_alt_ch_buf1_rdy0_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_24 : 1; /*!< [24]  */
        uint32_t RESERVED1 : 4;        /*!< [28:25]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_29 : 1; /*!< [29]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_alt_ch_buf1_rdy0_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_BUF1_RDY0 register
 */
/*@{*/
#define HW_IPU_ALT_CH_BUF1_RDY0_ADDR(x) ((uintptr_t)(x) + 0x280U)

#define HW_IPU_ALT_CH_BUF1_RDY0(x) (*(__IO hw_ipu_alt_ch_buf1_rdy0_t *) HW_IPU_ALT_CH_BUF1_RDY0_ADDR(x))
#define HW_IPU_ALT_CH_BUF1_RDY0_RD(x) (HW_IPU_ALT_CH_BUF1_RDY0(x).U)
#define HW_IPU_ALT_CH_BUF1_RDY0_WR(x, v) (HW_IPU_ALT_CH_BUF1_RDY0(x).U = (v))
#define HW_IPU_ALT_CH_BUF1_RDY0_SET(x, v) (HW_IPU_ALT_CH_BUF1_RDY0_WR(x, HW_IPU_ALT_CH_BUF1_RDY0_RD(x) |  (v)))
#define HW_IPU_ALT_CH_BUF1_RDY0_CLR(x, v) (HW_IPU_ALT_CH_BUF1_RDY0_WR(x, HW_IPU_ALT_CH_BUF1_RDY0_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_BUF1_RDY0_TOG(x, v) (HW_IPU_ALT_CH_BUF1_RDY0_WR(x, HW_IPU_ALT_CH_BUF1_RDY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_BUF1_RDY0 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_BUF1_RDY0, field DMA_CH_ALT_BUF1_RDY_24[24] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24 (24U) /*!< Bit position for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24. */
#define BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24 (0x01000000U) /*!< Bit mask for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24. */
#define BS_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24. */

/*! @brief Read current value of the IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24 field. */
#define BR_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24(x) (HW_IPU_ALT_CH_BUF1_RDY0(x).B.DMA_CH_ALT_BUF1_RDY_24)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24. */
#define BF_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24) & BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_24 field to a new value. */
#define BW_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24(x, v) (HW_IPU_ALT_CH_BUF1_RDY0_WR(x, (HW_IPU_ALT_CH_BUF1_RDY0_RD(x) & ~BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24) | BF_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_24(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF1_RDY0, field DMA_CH_ALT_BUF1_RDY_29[29] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29 (29U) /*!< Bit position for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29. */
#define BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29 (0x20000000U) /*!< Bit mask for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29. */
#define BS_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29. */

/*! @brief Read current value of the IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29 field. */
#define BR_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29(x) (HW_IPU_ALT_CH_BUF1_RDY0(x).B.DMA_CH_ALT_BUF1_RDY_29)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29. */
#define BF_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29) & BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_29 field to a new value. */
#define BW_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29(x, v) (HW_IPU_ALT_CH_BUF1_RDY0_WR(x, (HW_IPU_ALT_CH_BUF1_RDY0_RD(x) & ~BM_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29) | BF_IPU_ALT_CH_BUF1_RDY0_DMA_CH_ALT_BUF1_RDY_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_ALT_CH_BUF1_RDY1 - IPU Alternate Channels Buffer 1 Ready 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_ALT_CH_BUF1_RDY1 - IPU Alternate Channels Buffer 1 Ready 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 0 ready control information for 32 IPU's DMA
 * channels (63-32). Writing "1" to each field will set each bit. Writing "0" to
 * each field simultaneously will clear all the bits. The register is shown in
 * ALT_CH_BUF1_RDY1IPU Alternate Channels Buffer 1 Ready 1 Register , and the register
 * fields are described in ALT_CH_BUF1_RDY1IPU Alternate Channels Buffer 1 Ready
 * 1 Register .
 */
typedef union _hw_ipu_alt_ch_buf1_rdy1
{
    uint32_t U;
    struct _hw_ipu_alt_ch_buf1_rdy1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 7;        /*!< [8:2]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_41 : 1; /*!< [9]  */
        uint32_t RESERVED2 : 10;       /*!< [19:10]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_52 : 1; /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_alt_ch_buf1_rdy1_t;

/*!
 * @name Constants and macros for entire IPU_ALT_CH_BUF1_RDY1 register
 */
/*@{*/
#define HW_IPU_ALT_CH_BUF1_RDY1_ADDR(x) ((uintptr_t)(x) + 0x284U)

#define HW_IPU_ALT_CH_BUF1_RDY1(x) (*(__IO hw_ipu_alt_ch_buf1_rdy1_t *) HW_IPU_ALT_CH_BUF1_RDY1_ADDR(x))
#define HW_IPU_ALT_CH_BUF1_RDY1_RD(x) (HW_IPU_ALT_CH_BUF1_RDY1(x).U)
#define HW_IPU_ALT_CH_BUF1_RDY1_WR(x, v) (HW_IPU_ALT_CH_BUF1_RDY1(x).U = (v))
#define HW_IPU_ALT_CH_BUF1_RDY1_SET(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, HW_IPU_ALT_CH_BUF1_RDY1_RD(x) |  (v)))
#define HW_IPU_ALT_CH_BUF1_RDY1_CLR(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, HW_IPU_ALT_CH_BUF1_RDY1_RD(x) & ~(v)))
#define HW_IPU_ALT_CH_BUF1_RDY1_TOG(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, HW_IPU_ALT_CH_BUF1_RDY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_ALT_CH_BUF1_RDY1 bitfields
 */

/*!
 * @name Register IPU_ALT_CH_BUF1_RDY1, field DMA_CH_ALT_BUF1_RDY_33[1] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33 (1U) /*!< Bit position for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33. */
#define BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33 (0x00000002U) /*!< Bit mask for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33. */
#define BS_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33. */

/*! @brief Read current value of the IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33 field. */
#define BR_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33(x) (HW_IPU_ALT_CH_BUF1_RDY1(x).B.DMA_CH_ALT_BUF1_RDY_33)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33. */
#define BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33) & BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_33 field to a new value. */
#define BW_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, (HW_IPU_ALT_CH_BUF1_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33) | BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_33(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF1_RDY1, field DMA_CH_ALT_BUF1_RDY_41[9] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41 (9U) /*!< Bit position for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41. */
#define BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41 (0x00000200U) /*!< Bit mask for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41. */
#define BS_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41. */

/*! @brief Read current value of the IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41 field. */
#define BR_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41(x) (HW_IPU_ALT_CH_BUF1_RDY1(x).B.DMA_CH_ALT_BUF1_RDY_41)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41. */
#define BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41) & BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_41 field to a new value. */
#define BW_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, (HW_IPU_ALT_CH_BUF1_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41) | BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_41(v)))
/*@}*/

/*!
 * @name Register IPU_ALT_CH_BUF1_RDY1, field DMA_CH_ALT_BUF1_RDY_52[20] (RW)
 *
 * Buffer 1 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 1 in memory.
 *
 * Values:
 * - 0 - buffer 1 is not ready.
 * - 1 - buffer 1 is ready.
 */
/*@{*/
#define BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52 (20U) /*!< Bit position for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52. */
#define BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52 (0x00100000U) /*!< Bit mask for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52. */
#define BS_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52 (1U) /*!< Bit field size in bits for IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52. */

/*! @brief Read current value of the IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52 field. */
#define BR_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52(x) (HW_IPU_ALT_CH_BUF1_RDY1(x).B.DMA_CH_ALT_BUF1_RDY_52)

/*! @brief Format value for bitfield IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52. */
#define BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52) & BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_52 field to a new value. */
#define BW_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52(x, v) (HW_IPU_ALT_CH_BUF1_RDY1_WR(x, (HW_IPU_ALT_CH_BUF1_RDY1_RD(x) & ~BM_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52) | BF_IPU_ALT_CH_BUF1_RDY1_DMA_CH_ALT_BUF1_RDY_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF2_RDY0 - IPU Channels Buffer 2 Ready 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF2_RDY0 - IPU Channels Buffer 2 Ready 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 2 ready control information for 32 IPU's DMA
 * channels (31-0). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF2_RDY0_CLR bit. The register is shown in
 * CH_BUF2_RDY0IPU Channels Buffer 2 Ready 0 Register , and the register fields are
 * described in CH_BUF2_RDY0IPU Channels Buffer 2 Ready 0 Register .
 */
typedef union _hw_ipu_ch_buf2_rdy0
{
    uint32_t U;
    struct _hw_ipu_ch_buf2_rdy0_bitfields
    {
        uint32_t DMA_CH_BUF2_RDY_0 : 1; /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t DMA_CH_BUF2_RDY_2 : 1; /*!< [2]  */
        uint32_t RESERVED1 : 5;        /*!< [7:3]  */
        uint32_t DMA_CH_BUF2_RDY_8 : 1; /*!< [8]  */
        uint32_t DMA_CH_BUF2_RDY_9 : 1; /*!< [9]  */
        uint32_t DMA_CH_BUF2_RDY_10 : 1; /*!< [10]  */
        uint32_t RESERVED2 : 2;        /*!< [12:11]  */
        uint32_t DMA_CH_BUF2_RDY_13 : 1; /*!< [13]  */
        uint32_t RESERVED3 : 7;        /*!< [20:14]  */
        uint32_t DMA_CH_BUF2_RDY_21 : 1; /*!< [21]  */
        uint32_t RESERVED4 : 1;        /*!< [22]  */
        uint32_t DMA_CH_BUF2_RDY_23 : 1; /*!< [23]  */
        uint32_t RESERVED5 : 3;        /*!< [26:24]  */
        uint32_t DMA_CH_ALT_BUF1_RDY_27 : 1; /*!< [27]  */
        uint32_t DMA_CH_BUF2_RDY_28 : 1; /*!< [28]  */
        uint32_t RESERVED6 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_ch_buf2_rdy0_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF2_RDY0 register
 */
/*@{*/
#define HW_IPU_CH_BUF2_RDY0_ADDR(x) ((uintptr_t)(x) + 0x288U)

#define HW_IPU_CH_BUF2_RDY0(x)   (*(__IO hw_ipu_ch_buf2_rdy0_t *) HW_IPU_CH_BUF2_RDY0_ADDR(x))
#define HW_IPU_CH_BUF2_RDY0_RD(x) (HW_IPU_CH_BUF2_RDY0(x).U)
#define HW_IPU_CH_BUF2_RDY0_WR(x, v) (HW_IPU_CH_BUF2_RDY0(x).U = (v))
#define HW_IPU_CH_BUF2_RDY0_SET(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, HW_IPU_CH_BUF2_RDY0_RD(x) |  (v)))
#define HW_IPU_CH_BUF2_RDY0_CLR(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, HW_IPU_CH_BUF2_RDY0_RD(x) & ~(v)))
#define HW_IPU_CH_BUF2_RDY0_TOG(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, HW_IPU_CH_BUF2_RDY0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF2_RDY0 bitfields
 */

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_0[0] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0 (0U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0 (0x00000001U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_0)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0)

/*! @brief Set the DMA_CH_BUF2_RDY_0 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_0(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_2[2] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2 (2U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2 (0x00000004U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_2)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2)

/*! @brief Set the DMA_CH_BUF2_RDY_2 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_2(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_8[8] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8 (8U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8 (0x00000100U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_8)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8)

/*! @brief Set the DMA_CH_BUF2_RDY_8 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_8(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_9[9] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9 (9U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9 (0x00000200U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_9)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9)

/*! @brief Set the DMA_CH_BUF2_RDY_9 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_9(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_10[10] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10 (10U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10 (0x00000400U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_10)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10)

/*! @brief Set the DMA_CH_BUF2_RDY_10 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_10(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_13[13] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13 (13U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13 (0x00002000U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_13)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13)

/*! @brief Set the DMA_CH_BUF2_RDY_13 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_13(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_21[21] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21 (21U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21 (0x00200000U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_21)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21)

/*! @brief Set the DMA_CH_BUF2_RDY_21 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_21(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_23[23] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23 (23U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23 (0x00800000U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_23)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23)

/*! @brief Set the DMA_CH_BUF2_RDY_23 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_23(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_ALT_BUF1_RDY_27[27] (RW)
 *
 * buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - buffer 2 is not ready.
 * - 1 - buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27 (27U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27 (0x08000000U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_ALT_BUF1_RDY_27)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27) & BM_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27)

/*! @brief Set the DMA_CH_ALT_BUF1_RDY_27 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27) | BF_IPU_CH_BUF2_RDY0_DMA_CH_ALT_BUF1_RDY_27(v)))
/*@}*/

/*!
 * @name Register IPU_CH_BUF2_RDY0, field DMA_CH_BUF2_RDY_28[28] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28 (28U) /*!< Bit position for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28. */
#define BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28 (0x10000000U) /*!< Bit mask for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28. */
#define BS_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28 (1U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28 field. */
#define BR_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28(x) (HW_IPU_CH_BUF2_RDY0(x).B.DMA_CH_BUF2_RDY_28)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28. */
#define BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28) & BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28)

/*! @brief Set the DMA_CH_BUF2_RDY_28 field to a new value. */
#define BW_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28(x, v) (HW_IPU_CH_BUF2_RDY0_WR(x, (HW_IPU_CH_BUF2_RDY0_RD(x) & ~BM_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28) | BF_IPU_CH_BUF2_RDY0_DMA_CH_BUF2_RDY_28(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CH_BUF2_RDY1 - IPU Channels Buffer 2 Ready 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CH_BUF2_RDY1 - IPU Channels Buffer 2 Ready 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register contains buffer 2 ready control information for 32 IPU's DMA
 * channels (63-32). This register can be a write one to set or a write one to clear
 * according to the IPU_CH_BUF2_RDY1_CLR bit. The register is shown in
 * CH_BUF2_RDY1IPU Channels Buffer 2 Ready 1 Register , and the register fields are
 * described in CH_BUF2_RDY1IPU Channels Buffer 2 Ready 1 Register .
 */
typedef union _hw_ipu_ch_buf2_rdy1
{
    uint32_t U;
    struct _hw_ipu_ch_buf2_rdy1_bitfields
    {
        uint32_t DMA_CH_BUF2_RDY_x : 32; /*!< [31:0]  */
    } B;
} hw_ipu_ch_buf2_rdy1_t;

/*!
 * @name Constants and macros for entire IPU_CH_BUF2_RDY1 register
 */
/*@{*/
#define HW_IPU_CH_BUF2_RDY1_ADDR(x) ((uintptr_t)(x) + 0x28CU)

#define HW_IPU_CH_BUF2_RDY1(x)   (*(__IO hw_ipu_ch_buf2_rdy1_t *) HW_IPU_CH_BUF2_RDY1_ADDR(x))
#define HW_IPU_CH_BUF2_RDY1_RD(x) (HW_IPU_CH_BUF2_RDY1(x).U)
#define HW_IPU_CH_BUF2_RDY1_WR(x, v) (HW_IPU_CH_BUF2_RDY1(x).U = (v))
#define HW_IPU_CH_BUF2_RDY1_SET(x, v) (HW_IPU_CH_BUF2_RDY1_WR(x, HW_IPU_CH_BUF2_RDY1_RD(x) |  (v)))
#define HW_IPU_CH_BUF2_RDY1_CLR(x, v) (HW_IPU_CH_BUF2_RDY1_WR(x, HW_IPU_CH_BUF2_RDY1_RD(x) & ~(v)))
#define HW_IPU_CH_BUF2_RDY1_TOG(x, v) (HW_IPU_CH_BUF2_RDY1_WR(x, HW_IPU_CH_BUF2_RDY1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CH_BUF2_RDY1 bitfields
 */

/*!
 * @name Register IPU_CH_BUF2_RDY1, field DMA_CH_BUF2_RDY_x[31:0] (RW)
 *
 * Buffer 2 is ready. This bit indicates that ARM platform finished/writing
 * reading buffer 2 in memory.
 *
 * Values:
 * - 0 - Buffer 2 is not ready.
 * - 1 - Buffer 2 is ready.
 */
/*@{*/
#define BP_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x (0U) /*!< Bit position for IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x. */
#define BM_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x (0xFFFFFFFFU) /*!< Bit mask for IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x. */
#define BS_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x (32U) /*!< Bit field size in bits for IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x. */

/*! @brief Read current value of the IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x field. */
#define BR_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x(x) (HW_IPU_CH_BUF2_RDY1(x).U)

/*! @brief Format value for bitfield IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x. */
#define BF_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x) & BM_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x)

/*! @brief Set the DMA_CH_BUF2_RDY_x field to a new value. */
#define BW_IPU_CH_BUF2_RDY1_DMA_CH_BUF2_RDY_x(x, v) (HW_IPU_CH_BUF2_RDY1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CONF - IDMAC Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CONF - IDMAC Configuration Register (RW)
 *
 * Reset value: 0x0000002FU
 */
typedef union _hw_ipu_idmac_conf
{
    uint32_t U;
    struct _hw_ipu_idmac_conf_bitfields
    {
        uint32_t MAX_REQ_READ : 3;     /*!< [2:0]  */
        uint32_t WIDPT : 2;            /*!< [4:3]  */
        uint32_t RDI : 1;              /*!< [5]  */
        uint32_t RESERVED0 : 10;       /*!< [15:6]  */
        uint32_t P_ENDIAN : 1;         /*!< [16]  */
        uint32_t USED_BUFS_MAX_W : 3;  /*!< [19:17]  */
        uint32_t USED_BUFS_EN_W : 1;   /*!< [20]  */
        uint32_t USED_BUFS_MAX_R : 4;  /*!< [24:21]  */
        uint32_t USED_BUFS_EN_R : 1;   /*!< [25]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_idmac_conf_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CONF register
 */
/*@{*/
#define HW_IPU_IDMAC_CONF_ADDR(x) ((uintptr_t)(x) + 0x8000U)

#define HW_IPU_IDMAC_CONF(x)     (*(__IO hw_ipu_idmac_conf_t *) HW_IPU_IDMAC_CONF_ADDR(x))
#define HW_IPU_IDMAC_CONF_RD(x)  (HW_IPU_IDMAC_CONF(x).U)
#define HW_IPU_IDMAC_CONF_WR(x, v) (HW_IPU_IDMAC_CONF(x).U = (v))
#define HW_IPU_IDMAC_CONF_SET(x, v) (HW_IPU_IDMAC_CONF_WR(x, HW_IPU_IDMAC_CONF_RD(x) |  (v)))
#define HW_IPU_IDMAC_CONF_CLR(x, v) (HW_IPU_IDMAC_CONF_WR(x, HW_IPU_IDMAC_CONF_RD(x) & ~(v)))
#define HW_IPU_IDMAC_CONF_TOG(x, v) (HW_IPU_IDMAC_CONF_WR(x, HW_IPU_IDMAC_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CONF bitfields
 */

/*!
 * @name Register IPU_IDMAC_CONF, field MAX_REQ_READ[2:0] (RW)
 *
 * Maximum Read Requests. This fields sets the maximum pending requests allowed
 * in the AXI Read requests queue.
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_MAX_REQ_READ (0U) /*!< Bit position for IPU_IDMAC_CONF_MAX_REQ_READ. */
#define BM_IPU_IDMAC_CONF_MAX_REQ_READ (0x00000007U) /*!< Bit mask for IPU_IDMAC_CONF_MAX_REQ_READ. */
#define BS_IPU_IDMAC_CONF_MAX_REQ_READ (3U) /*!< Bit field size in bits for IPU_IDMAC_CONF_MAX_REQ_READ. */

/*! @brief Read current value of the IPU_IDMAC_CONF_MAX_REQ_READ field. */
#define BR_IPU_IDMAC_CONF_MAX_REQ_READ(x) (HW_IPU_IDMAC_CONF(x).B.MAX_REQ_READ)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_MAX_REQ_READ. */
#define BF_IPU_IDMAC_CONF_MAX_REQ_READ(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_MAX_REQ_READ) & BM_IPU_IDMAC_CONF_MAX_REQ_READ)

/*! @brief Set the MAX_REQ_READ field to a new value. */
#define BW_IPU_IDMAC_CONF_MAX_REQ_READ(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_MAX_REQ_READ) | BF_IPU_IDMAC_CONF_MAX_REQ_READ(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field WIDPT[4:3] (RW)
 *
 * Write Interleaving Depth These 2 bits define the Write Interleaving Depth of
 * the AXI port. This bits should be configured by the user according to the AXI
 * slave's Write Interleaving Depth. WIDPT defines the maximal number of active
 * bursts (yet to be responded) with different IDs. IDMAC will block data phase if
 * the next data's ID is new (no such ID active) and the number of active IDs is
 * equal to WIDPT. 00 Write Interleaving Depth of 1 01 Write Interleaving Depth
 * of 2 10 Write Interleaving Depth of 3 11 Write Interleaving Depth of 4
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_WIDPT (3U)       /*!< Bit position for IPU_IDMAC_CONF_WIDPT. */
#define BM_IPU_IDMAC_CONF_WIDPT (0x00000018U) /*!< Bit mask for IPU_IDMAC_CONF_WIDPT. */
#define BS_IPU_IDMAC_CONF_WIDPT (2U)       /*!< Bit field size in bits for IPU_IDMAC_CONF_WIDPT. */

/*! @brief Read current value of the IPU_IDMAC_CONF_WIDPT field. */
#define BR_IPU_IDMAC_CONF_WIDPT(x) (HW_IPU_IDMAC_CONF(x).B.WIDPT)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_WIDPT. */
#define BF_IPU_IDMAC_CONF_WIDPT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_WIDPT) & BM_IPU_IDMAC_CONF_WIDPT)

/*! @brief Set the WIDPT field to a new value. */
#define BW_IPU_IDMAC_CONF_WIDPT(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_WIDPT) | BF_IPU_IDMAC_CONF_WIDPT(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field RDI[5] (RW)
 *
 * Read Data Interleaving. This bit must match the slave read data interleaving
 * support. If the AXI slave connected to the IPU supports read data interleaving
 * then this bit must be set. If the AXI slave does not support read data
 * interleaving then the IDMAC can utilize this and issue more address phases on read.
 * In that case it is recommended to have this bit cleared. 0 The AXI slave does
 * not support read data interleaving 1 The AXI slave supports read data
 * interleaving
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_RDI (5U)         /*!< Bit position for IPU_IDMAC_CONF_RDI. */
#define BM_IPU_IDMAC_CONF_RDI (0x00000020U) /*!< Bit mask for IPU_IDMAC_CONF_RDI. */
#define BS_IPU_IDMAC_CONF_RDI (1U)         /*!< Bit field size in bits for IPU_IDMAC_CONF_RDI. */

/*! @brief Read current value of the IPU_IDMAC_CONF_RDI field. */
#define BR_IPU_IDMAC_CONF_RDI(x) (HW_IPU_IDMAC_CONF(x).B.RDI)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_RDI. */
#define BF_IPU_IDMAC_CONF_RDI(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_RDI) & BM_IPU_IDMAC_CONF_RDI)

/*! @brief Set the RDI field to a new value. */
#define BW_IPU_IDMAC_CONF_RDI(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_RDI) | BF_IPU_IDMAC_CONF_RDI(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field P_ENDIAN[16] (RW)
 *
 * Pixel Endianness. The pixel Endianness must not be changed while any of the
 * IDMAC channels is enabled. 0 little endian 1 Big endian
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_P_ENDIAN (16U)   /*!< Bit position for IPU_IDMAC_CONF_P_ENDIAN. */
#define BM_IPU_IDMAC_CONF_P_ENDIAN (0x00010000U) /*!< Bit mask for IPU_IDMAC_CONF_P_ENDIAN. */
#define BS_IPU_IDMAC_CONF_P_ENDIAN (1U)    /*!< Bit field size in bits for IPU_IDMAC_CONF_P_ENDIAN. */

/*! @brief Read current value of the IPU_IDMAC_CONF_P_ENDIAN field. */
#define BR_IPU_IDMAC_CONF_P_ENDIAN(x) (HW_IPU_IDMAC_CONF(x).B.P_ENDIAN)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_P_ENDIAN. */
#define BF_IPU_IDMAC_CONF_P_ENDIAN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_P_ENDIAN) & BM_IPU_IDMAC_CONF_P_ENDIAN)

/*! @brief Set the P_ENDIAN field to a new value. */
#define BW_IPU_IDMAC_CONF_P_ENDIAN(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_P_ENDIAN) | BF_IPU_IDMAC_CONF_P_ENDIAN(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field USED_BUFS_MAX_W[19:17] (RW)
 *
 * Limit the number of pending non real time write requests. The value can be
 * between 0 to 6. This field has no affect if USED_BUFS_EN_W is cleared
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_USED_BUFS_MAX_W (17U) /*!< Bit position for IPU_IDMAC_CONF_USED_BUFS_MAX_W. */
#define BM_IPU_IDMAC_CONF_USED_BUFS_MAX_W (0x000E0000U) /*!< Bit mask for IPU_IDMAC_CONF_USED_BUFS_MAX_W. */
#define BS_IPU_IDMAC_CONF_USED_BUFS_MAX_W (3U) /*!< Bit field size in bits for IPU_IDMAC_CONF_USED_BUFS_MAX_W. */

/*! @brief Read current value of the IPU_IDMAC_CONF_USED_BUFS_MAX_W field. */
#define BR_IPU_IDMAC_CONF_USED_BUFS_MAX_W(x) (HW_IPU_IDMAC_CONF(x).B.USED_BUFS_MAX_W)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_USED_BUFS_MAX_W. */
#define BF_IPU_IDMAC_CONF_USED_BUFS_MAX_W(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_USED_BUFS_MAX_W) & BM_IPU_IDMAC_CONF_USED_BUFS_MAX_W)

/*! @brief Set the USED_BUFS_MAX_W field to a new value. */
#define BW_IPU_IDMAC_CONF_USED_BUFS_MAX_W(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_USED_BUFS_MAX_W) | BF_IPU_IDMAC_CONF_USED_BUFS_MAX_W(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field USED_BUFS_EN_W[20] (RW)
 *
 * Enables the limit on the number of pending non real time write requests.
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_USED_BUFS_EN_W (20U) /*!< Bit position for IPU_IDMAC_CONF_USED_BUFS_EN_W. */
#define BM_IPU_IDMAC_CONF_USED_BUFS_EN_W (0x00100000U) /*!< Bit mask for IPU_IDMAC_CONF_USED_BUFS_EN_W. */
#define BS_IPU_IDMAC_CONF_USED_BUFS_EN_W (1U) /*!< Bit field size in bits for IPU_IDMAC_CONF_USED_BUFS_EN_W. */

/*! @brief Read current value of the IPU_IDMAC_CONF_USED_BUFS_EN_W field. */
#define BR_IPU_IDMAC_CONF_USED_BUFS_EN_W(x) (HW_IPU_IDMAC_CONF(x).B.USED_BUFS_EN_W)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_USED_BUFS_EN_W. */
#define BF_IPU_IDMAC_CONF_USED_BUFS_EN_W(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_USED_BUFS_EN_W) & BM_IPU_IDMAC_CONF_USED_BUFS_EN_W)

/*! @brief Set the USED_BUFS_EN_W field to a new value. */
#define BW_IPU_IDMAC_CONF_USED_BUFS_EN_W(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_USED_BUFS_EN_W) | BF_IPU_IDMAC_CONF_USED_BUFS_EN_W(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field USED_BUFS_MAX_R[24:21] (RW)
 *
 * Limit the number of pending non real time read requests. The value can be
 * between 0 to 8. This field has no affect if USED_BUFS_EN_R is cleared
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_USED_BUFS_MAX_R (21U) /*!< Bit position for IPU_IDMAC_CONF_USED_BUFS_MAX_R. */
#define BM_IPU_IDMAC_CONF_USED_BUFS_MAX_R (0x01E00000U) /*!< Bit mask for IPU_IDMAC_CONF_USED_BUFS_MAX_R. */
#define BS_IPU_IDMAC_CONF_USED_BUFS_MAX_R (4U) /*!< Bit field size in bits for IPU_IDMAC_CONF_USED_BUFS_MAX_R. */

/*! @brief Read current value of the IPU_IDMAC_CONF_USED_BUFS_MAX_R field. */
#define BR_IPU_IDMAC_CONF_USED_BUFS_MAX_R(x) (HW_IPU_IDMAC_CONF(x).B.USED_BUFS_MAX_R)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_USED_BUFS_MAX_R. */
#define BF_IPU_IDMAC_CONF_USED_BUFS_MAX_R(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_USED_BUFS_MAX_R) & BM_IPU_IDMAC_CONF_USED_BUFS_MAX_R)

/*! @brief Set the USED_BUFS_MAX_R field to a new value. */
#define BW_IPU_IDMAC_CONF_USED_BUFS_MAX_R(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_USED_BUFS_MAX_R) | BF_IPU_IDMAC_CONF_USED_BUFS_MAX_R(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CONF, field USED_BUFS_EN_R[25] (RW)
 *
 * Enables the limit on the number of pending non real time read requests.
 */
/*@{*/
#define BP_IPU_IDMAC_CONF_USED_BUFS_EN_R (25U) /*!< Bit position for IPU_IDMAC_CONF_USED_BUFS_EN_R. */
#define BM_IPU_IDMAC_CONF_USED_BUFS_EN_R (0x02000000U) /*!< Bit mask for IPU_IDMAC_CONF_USED_BUFS_EN_R. */
#define BS_IPU_IDMAC_CONF_USED_BUFS_EN_R (1U) /*!< Bit field size in bits for IPU_IDMAC_CONF_USED_BUFS_EN_R. */

/*! @brief Read current value of the IPU_IDMAC_CONF_USED_BUFS_EN_R field. */
#define BR_IPU_IDMAC_CONF_USED_BUFS_EN_R(x) (HW_IPU_IDMAC_CONF(x).B.USED_BUFS_EN_R)

/*! @brief Format value for bitfield IPU_IDMAC_CONF_USED_BUFS_EN_R. */
#define BF_IPU_IDMAC_CONF_USED_BUFS_EN_R(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CONF_USED_BUFS_EN_R) & BM_IPU_IDMAC_CONF_USED_BUFS_EN_R)

/*! @brief Set the USED_BUFS_EN_R field to a new value. */
#define BW_IPU_IDMAC_CONF_USED_BUFS_EN_R(x, v) (HW_IPU_IDMAC_CONF_WR(x, (HW_IPU_IDMAC_CONF_RD(x) & ~BM_IPU_IDMAC_CONF_USED_BUFS_EN_R) | BF_IPU_IDMAC_CONF_USED_BUFS_EN_R(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_EN_1 - IDMAC Channel Enable 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_EN_1 - IDMAC Channel Enable 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_en_1
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_en_1_bitfields
    {
        uint32_t IDMAC_CH_EN_0 : 1;    /*!< [0]  */
        uint32_t IDMAC_CH_EN_1 : 1;    /*!< [1]  */
        uint32_t IDMAC_CH_EN_2 : 1;    /*!< [2]  */
        uint32_t IDMAC_CH_EN_3 : 1;    /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_CH_EN_5 : 1;    /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_CH_EN_8 : 1;    /*!< [8]  */
        uint32_t IDMAC_CH_EN_9 : 1;    /*!< [9]  */
        uint32_t IDMAC_CH_EN_10 : 1;   /*!< [10]  */
        uint32_t IDMAC_CH_EN_11 : 1;   /*!< [11]  */
        uint32_t IDMAC_CH_EN_12 : 1;   /*!< [12]  */
        uint32_t IDMAC_CH_EN_13 : 1;   /*!< [13]  */
        uint32_t IDMAC_CH_EN_14 : 1;   /*!< [14]  */
        uint32_t IDMAC_CH_EN_15 : 1;   /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_CH_EN_17 : 1;   /*!< [17]  */
        uint32_t IDMAC_CH_EN_18 : 1;   /*!< [18]  */
        uint32_t IDMAC_CH_EN_19 : 1;   /*!< [19]  */
        uint32_t IDMAC_CH_EN_20 : 1;   /*!< [20]  */
        uint32_t IDMAC_CH_EN_21 : 1;   /*!< [21]  */
        uint32_t IDMAC_CH_EN_22 : 1;   /*!< [22]  */
        uint32_t IDMAC_CH_EN_23 : 1;   /*!< [23]  */
        uint32_t IDMAC_CH_EN_24 : 1;   /*!< [24]  */
        uint32_t IDMAC_CH_EN_25 : 1;   /*!< [25]  */
        uint32_t IDMAC_CH_EN_26 : 1;   /*!< [26]  */
        uint32_t IDMAC_CH_EN_27 : 1;   /*!< [27]  */
        uint32_t IDMAC_CH_EN_28 : 1;   /*!< [28]  */
        uint32_t IDMAC_CH_EN_29 : 1;   /*!< [29]  */
        uint32_t RESERVED3 : 1;        /*!< [30]  */
        uint32_t IDMAC_CH_EN_31 : 1;   /*!< [31]  */
    } B;
} hw_ipu_idmac_ch_en_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_EN_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_EN_1_ADDR(x) ((uintptr_t)(x) + 0x8004U)

#define HW_IPU_IDMAC_CH_EN_1(x)  (*(__IO hw_ipu_idmac_ch_en_1_t *) HW_IPU_IDMAC_CH_EN_1_ADDR(x))
#define HW_IPU_IDMAC_CH_EN_1_RD(x) (HW_IPU_IDMAC_CH_EN_1(x).U)
#define HW_IPU_IDMAC_CH_EN_1_WR(x, v) (HW_IPU_IDMAC_CH_EN_1(x).U = (v))
#define HW_IPU_IDMAC_CH_EN_1_SET(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, HW_IPU_IDMAC_CH_EN_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_CH_EN_1_CLR(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, HW_IPU_IDMAC_CH_EN_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_CH_EN_1_TOG(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, HW_IPU_IDMAC_CH_EN_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_EN_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_0[0] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0 (0U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0 (0x00000001U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_0)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0)

/*! @brief Set the IDMAC_CH_EN_0 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_1[1] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1 (1U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1 (0x00000002U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_1)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1)

/*! @brief Set the IDMAC_CH_EN_1 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_2[2] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2 (2U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2 (0x00000004U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_2)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2)

/*! @brief Set the IDMAC_CH_EN_2 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_3[3] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3 (3U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3 (0x00000008U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_3)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3)

/*! @brief Set the IDMAC_CH_EN_3 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_5[5] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5 (5U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5 (0x00000020U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_5)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5)

/*! @brief Set the IDMAC_CH_EN_5 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_8[8] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8 (8U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_8)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8)

/*! @brief Set the IDMAC_CH_EN_8 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_9[9] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9 (9U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_9)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9)

/*! @brief Set the IDMAC_CH_EN_9 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_9(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_10[10] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10 (10U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_10)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10)

/*! @brief Set the IDMAC_CH_EN_10 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_11[11] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11 (11U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_11)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11)

/*! @brief Set the IDMAC_CH_EN_11 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_12[12] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12 (12U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_12)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12)

/*! @brief Set the IDMAC_CH_EN_12 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_13[13] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13 (13U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_13)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13)

/*! @brief Set the IDMAC_CH_EN_13 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_14[14] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14 (14U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_14)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14)

/*! @brief Set the IDMAC_CH_EN_14 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_15[15] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15 (15U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_15)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15)

/*! @brief Set the IDMAC_CH_EN_15 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_17[17] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17 (17U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17 (0x00020000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_17)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17)

/*! @brief Set the IDMAC_CH_EN_17 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_17(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_18[18] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18 (18U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18 (0x00040000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_18)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18)

/*! @brief Set the IDMAC_CH_EN_18 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_18(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_19[19] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19 (19U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19 (0x00080000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_19)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19)

/*! @brief Set the IDMAC_CH_EN_19 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_19(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_20[20] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20 (20U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20 (0x00100000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_20)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20)

/*! @brief Set the IDMAC_CH_EN_20 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_21[21] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21 (21U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21 (0x00200000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_21)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21)

/*! @brief Set the IDMAC_CH_EN_21 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_22[22] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22 (22U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22 (0x00400000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_22)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22)

/*! @brief Set the IDMAC_CH_EN_22 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_23[23] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23 (23U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_23)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23)

/*! @brief Set the IDMAC_CH_EN_23 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_24[24] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24 (24U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_24)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24)

/*! @brief Set the IDMAC_CH_EN_24 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_25[25] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25 (25U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_25)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25)

/*! @brief Set the IDMAC_CH_EN_25 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_26[26] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26 (26U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26 (0x04000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_26)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26)

/*! @brief Set the IDMAC_CH_EN_26 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_27[27] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27 (27U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27 (0x08000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_27)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27)

/*! @brief Set the IDMAC_CH_EN_27 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_28[28] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28 (28U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28 (0x10000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_28)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28)

/*! @brief Set the IDMAC_CH_EN_28 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_29[29] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29 (29U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_29)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29)

/*! @brief Set the IDMAC_CH_EN_29 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_29(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_1, field IDMAC_CH_EN_31[31] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31 (31U) /*!< Bit position for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31. */
#define BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31 (0x80000000U) /*!< Bit mask for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31. */
#define BS_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31 field. */
#define BR_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31(x) (HW_IPU_IDMAC_CH_EN_1(x).B.IDMAC_CH_EN_31)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31. */
#define BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31) & BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31)

/*! @brief Set the IDMAC_CH_EN_31 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31(x, v) (HW_IPU_IDMAC_CH_EN_1_WR(x, (HW_IPU_IDMAC_CH_EN_1_RD(x) & ~BM_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31) | BF_IPU_IDMAC_CH_EN_1_IDMAC_CH_EN_31(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_EN_2 - IDMAC Channel Enable 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_EN_2 - IDMAC Channel Enable 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_en_2
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_en_2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_CH_EN_33 : 1;   /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_CH_EN_40 : 1;   /*!< [8]  */
        uint32_t IDMAC_CH_EN_41 : 1;   /*!< [9]  */
        uint32_t IDMAC_CH_EN_42 : 1;   /*!< [10]  */
        uint32_t IDMAC_CH_EN_43 : 1;   /*!< [11]  */
        uint32_t IDMAC_CH_EN_44 : 1;   /*!< [12]  */
        uint32_t IDMAC_CH_EN_45 : 1;   /*!< [13]  */
        uint32_t IDMAC_CH_EN_46 : 1;   /*!< [14]  */
        uint32_t IDMAC_CH_EN_47 : 1;   /*!< [15]  */
        uint32_t IDMAC_CH_EN_48 : 1;   /*!< [16]  */
        uint32_t IDMAC_CH_EN_49 : 1;   /*!< [17]  */
        uint32_t IDMAC_CH_EN_50 : 1;   /*!< [18]  */
        uint32_t IDMAC_CH_EN_51 : 1;   /*!< [19]  */
        uint32_t IDMAC_CH_EN_52 : 1;   /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_idmac_ch_en_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_EN_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_EN_2_ADDR(x) ((uintptr_t)(x) + 0x8008U)

#define HW_IPU_IDMAC_CH_EN_2(x)  (*(__IO hw_ipu_idmac_ch_en_2_t *) HW_IPU_IDMAC_CH_EN_2_ADDR(x))
#define HW_IPU_IDMAC_CH_EN_2_RD(x) (HW_IPU_IDMAC_CH_EN_2(x).U)
#define HW_IPU_IDMAC_CH_EN_2_WR(x, v) (HW_IPU_IDMAC_CH_EN_2(x).U = (v))
#define HW_IPU_IDMAC_CH_EN_2_SET(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, HW_IPU_IDMAC_CH_EN_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_CH_EN_2_CLR(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, HW_IPU_IDMAC_CH_EN_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_CH_EN_2_TOG(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, HW_IPU_IDMAC_CH_EN_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_EN_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_33[1] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33 (1U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33 (0x00000002U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_33)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33)

/*! @brief Set the IDMAC_CH_EN_33 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_33(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_40[8] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40 (8U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_40)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40)

/*! @brief Set the IDMAC_CH_EN_40 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_41[9] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41 (9U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_41)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41)

/*! @brief Set the IDMAC_CH_EN_41 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_42[10] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42 (10U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_42)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42)

/*! @brief Set the IDMAC_CH_EN_42 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_43[11] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43 (11U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_43)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43)

/*! @brief Set the IDMAC_CH_EN_43 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_44[12] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44 (12U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_44)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44)

/*! @brief Set the IDMAC_CH_EN_44 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_44(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_45[13] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45 (13U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_45)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45)

/*! @brief Set the IDMAC_CH_EN_45 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_46[14] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46 (14U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_46)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46)

/*! @brief Set the IDMAC_CH_EN_46 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_47[15] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47 (15U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_47)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47)

/*! @brief Set the IDMAC_CH_EN_47 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_48[16] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48 (16U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48 (0x00010000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_48)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48)

/*! @brief Set the IDMAC_CH_EN_48 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_49[17] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49 (17U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49 (0x00020000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_49)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49)

/*! @brief Set the IDMAC_CH_EN_49 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_50[18] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50 (18U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50 (0x00040000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_50)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50)

/*! @brief Set the IDMAC_CH_EN_50 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_50(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_51[19] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51 (19U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51 (0x00080000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_51)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51)

/*! @brief Set the IDMAC_CH_EN_51 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_51(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_EN_2, field IDMAC_CH_EN_52[20] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel is disabled
 * - 1 - IDMAC channel is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52 (20U) /*!< Bit position for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52. */
#define BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52 (0x00100000U) /*!< Bit mask for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52. */
#define BS_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52. */

/*! @brief Read current value of the IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52 field. */
#define BR_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52(x) (HW_IPU_IDMAC_CH_EN_2(x).B.IDMAC_CH_EN_52)

/*! @brief Format value for bitfield IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52. */
#define BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52) & BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52)

/*! @brief Set the IDMAC_CH_EN_52 field to a new value. */
#define BW_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52(x, v) (HW_IPU_IDMAC_CH_EN_2_WR(x, (HW_IPU_IDMAC_CH_EN_2_RD(x) & ~BM_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52) | BF_IPU_IDMAC_CH_EN_2_IDMAC_CH_EN_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SEP_ALPHA - IDMAC Separate Alpha Indication Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SEP_ALPHA - IDMAC Separate Alpha Indication Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sep_alpha
{
    uint32_t U;
    struct _hw_ipu_idmac_sep_alpha_bitfields
    {
        uint32_t RESERVED0 : 14;       /*!< [13:0]  */
        uint32_t IDMAC_SEP_AL_14 : 1;  /*!< [14]  */
        uint32_t IDMAC_SEP_AL_15 : 1;  /*!< [15]  */
        uint32_t RESERVED1 : 7;        /*!< [22:16]  */
        uint32_t IDMAC_SEP_AL_23 : 1;  /*!< [23]  */
        uint32_t IDMAC_SEP_AL_24 : 1;  /*!< [24]  */
        uint32_t IDMAC_SEP_AL_25 : 1;  /*!< [25]  */
        uint32_t RESERVED2 : 1;        /*!< [26]  */
        uint32_t IDMAC_SEP_AL_27 : 1;  /*!< [27]  */
        uint32_t RESERVED3 : 1;        /*!< [28]  */
        uint32_t IDMAC_SEP_AL_29 : 1;  /*!< [29]  */
        uint32_t RESERVED4 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_idmac_sep_alpha_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SEP_ALPHA register
 */
/*@{*/
#define HW_IPU_IDMAC_SEP_ALPHA_ADDR(x) ((uintptr_t)(x) + 0x800CU)

#define HW_IPU_IDMAC_SEP_ALPHA(x) (*(__IO hw_ipu_idmac_sep_alpha_t *) HW_IPU_IDMAC_SEP_ALPHA_ADDR(x))
#define HW_IPU_IDMAC_SEP_ALPHA_RD(x) (HW_IPU_IDMAC_SEP_ALPHA(x).U)
#define HW_IPU_IDMAC_SEP_ALPHA_WR(x, v) (HW_IPU_IDMAC_SEP_ALPHA(x).U = (v))
#define HW_IPU_IDMAC_SEP_ALPHA_SET(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, HW_IPU_IDMAC_SEP_ALPHA_RD(x) |  (v)))
#define HW_IPU_IDMAC_SEP_ALPHA_CLR(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SEP_ALPHA_TOG(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, HW_IPU_IDMAC_SEP_ALPHA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SEP_ALPHA bitfields
 */

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_14[14] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14 (14U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_14)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14)

/*! @brief Set the IDMAC_SEP_AL_14 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_15[15] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15 (15U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15 (0x00008000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_15)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15)

/*! @brief Set the IDMAC_SEP_AL_15 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_15(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_23[23] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23 (23U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_23)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23)

/*! @brief Set the IDMAC_SEP_AL_23 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_24[24] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24 (24U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_24)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24)

/*! @brief Set the IDMAC_SEP_AL_24 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_25[25] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25 (25U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_25)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25)

/*! @brief Set the IDMAC_SEP_AL_25 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_25(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_27[27] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27 (27U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27 (0x08000000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_27)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27)

/*! @brief Set the IDMAC_SEP_AL_27 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_27(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SEP_ALPHA, field IDMAC_SEP_AL_29[29] (RW)
 *
 * IDMAC Separate alpha indication bit [i] A sub block may need to read data
 * from the system's memory where the pixel data and the alpha transparency data are
 * located in separate buffers. In that case the Alpha transparency data is read
 * by the special Alpha channel. In a case where the alpha should be read from a
 * separate buffer, the user should set the channels corresponding.
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29 (29U) /*!< Bit position for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29. */
#define BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29. */
#define BS_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29. */

/*! @brief Read current value of the IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29 field. */
#define BR_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29(x) (HW_IPU_IDMAC_SEP_ALPHA(x).B.IDMAC_SEP_AL_29)

/*! @brief Format value for bitfield IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29. */
#define BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29) & BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29)

/*! @brief Set the IDMAC_SEP_AL_29 field to a new value. */
#define BW_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29(x, v) (HW_IPU_IDMAC_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29) | BF_IPU_IDMAC_SEP_ALPHA_IDMAC_SEP_AL_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_ALT_SEP_ALPHA - IDMAC Alternate Separate Alpha Indication Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_ALT_SEP_ALPHA - IDMAC Alternate Separate Alpha Indication Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_alt_sep_alpha
{
    uint32_t U;
    struct _hw_ipu_idmac_alt_sep_alpha_bitfields
    {
        uint32_t RESERVED0 : 23;       /*!< [22:0]  */
        uint32_t IDMAC_ALT_SEP_AL_23 : 1; /*!< [23]  */
        uint32_t IDMAC_ALT_SEP_AL_24 : 1; /*!< [24]  */
        uint32_t RESERVED1 : 4;        /*!< [28:25]  */
        uint32_t IDMAC_ALT_SEP_AL_29 : 1; /*!< [29]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_idmac_alt_sep_alpha_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_ALT_SEP_ALPHA register
 */
/*@{*/
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_ADDR(x) ((uintptr_t)(x) + 0x8010U)

#define HW_IPU_IDMAC_ALT_SEP_ALPHA(x) (*(__IO hw_ipu_idmac_alt_sep_alpha_t *) HW_IPU_IDMAC_ALT_SEP_ALPHA_ADDR(x))
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) (HW_IPU_IDMAC_ALT_SEP_ALPHA(x).U)
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA(x).U = (v))
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_SET(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) |  (v)))
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_CLR(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) & ~(v)))
#define HW_IPU_IDMAC_ALT_SEP_ALPHA_TOG(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_ALT_SEP_ALPHA bitfields
 */

/*!
 * @name Register IPU_IDMAC_ALT_SEP_ALPHA, field IDMAC_ALT_SEP_AL_23[23] (RW)
 *
 * IDMAC Alternate Separate alpha indication bit [i] A sub block may need to
 * read data from the system's memory where the pixel data and the alpha
 * transparency data are located in separate buffers. In that case the Alpha transparency
 * data is read by the special Alpha channel. In a case where the alpha should be
 * read from a separate buffer, the user should set the channels corresponding.
 * For channels that may have alternate flow and may use separate alpha. This bit
 * indicates the mode of the alpha for the alternate flow
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23 (23U) /*!< Bit position for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23. */
#define BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23. */
#define BS_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23. */

/*! @brief Read current value of the IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23 field. */
#define BR_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23(x) (HW_IPU_IDMAC_ALT_SEP_ALPHA(x).B.IDMAC_ALT_SEP_AL_23)

/*! @brief Format value for bitfield IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23. */
#define BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23) & BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23)

/*! @brief Set the IDMAC_ALT_SEP_AL_23 field to a new value. */
#define BW_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23) | BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_ALT_SEP_ALPHA, field IDMAC_ALT_SEP_AL_24[24] (RW)
 *
 * IDMAC Alternate Separate alpha indication bit [i] A sub block may need to
 * read data from the system's memory where the pixel data and the alpha
 * transparency data are located in separate buffers. In that case the Alpha transparency
 * data is read by the special Alpha channel. In a case where the alpha should be
 * read from a separate buffer, the user should set the channels corresponding.
 * For channels that may have alternate flow and may use separate alpha. This bit
 * indicates the mode of the alpha for the alternate flow
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24 (24U) /*!< Bit position for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24. */
#define BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24. */
#define BS_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24. */

/*! @brief Read current value of the IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24 field. */
#define BR_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24(x) (HW_IPU_IDMAC_ALT_SEP_ALPHA(x).B.IDMAC_ALT_SEP_AL_24)

/*! @brief Format value for bitfield IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24. */
#define BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24) & BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24)

/*! @brief Set the IDMAC_ALT_SEP_AL_24 field to a new value. */
#define BW_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24) | BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_ALT_SEP_ALPHA, field IDMAC_ALT_SEP_AL_29[29] (RW)
 *
 * IDMAC Alternate Separate alpha indication bit [i] A sub block may need to
 * read data from the system's memory where the pixel data and the alpha
 * transparency data are located in separate buffers. In that case the Alpha transparency
 * data is read by the special Alpha channel. In a case where the alpha should be
 * read from a separate buffer, the user should set the channels corresponding.
 * For channels that may have alternate flow and may use separate alpha. This bit
 * indicates the mode of the alpha for the alternate flow
 *
 * Values:
 * - 0 - Channel [i] does not read Alpha transparency data from a separate
 *     buffer.
 * - 1 - Channel [i] reads Alpha transparency data from a separate buffer.
 */
/*@{*/
#define BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29 (29U) /*!< Bit position for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29. */
#define BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29. */
#define BS_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29. */

/*! @brief Read current value of the IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29 field. */
#define BR_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29(x) (HW_IPU_IDMAC_ALT_SEP_ALPHA(x).B.IDMAC_ALT_SEP_AL_29)

/*! @brief Format value for bitfield IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29. */
#define BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29) & BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29)

/*! @brief Set the IDMAC_ALT_SEP_AL_29 field to a new value. */
#define BW_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29(x, v) (HW_IPU_IDMAC_ALT_SEP_ALPHA_WR(x, (HW_IPU_IDMAC_ALT_SEP_ALPHA_RD(x) & ~BM_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29) | BF_IPU_IDMAC_ALT_SEP_ALPHA_IDMAC_ALT_SEP_AL_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_PRI_1 - IDMAC Channel Priority 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_PRI_1 - IDMAC Channel Priority 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_pri_1
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_pri_1_bitfields
    {
        uint32_t IDMAC_CH_PRI_0 : 1;   /*!< [0]  */
        uint32_t IDMAC_CH_PRI_1 : 1;   /*!< [1]  */
        uint32_t IDMAC_CH_PRI_2 : 1;   /*!< [2]  */
        uint32_t IDMAC_CH_PRI_3 : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_CH_PRI_5 : 1;   /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_CH_PRI_8 : 1;   /*!< [8]  */
        uint32_t IDMAC_CH_PRI_9 : 1;   /*!< [9]  */
        uint32_t IDMAC_CH_PRI_10 : 1;  /*!< [10]  */
        uint32_t IDMAC_CH_PRI_11 : 1;  /*!< [11]  */
        uint32_t IDMAC_CH_PRI_12 : 1;  /*!< [12]  */
        uint32_t IDMAC_CH_PRI_13 : 1;  /*!< [13]  */
        uint32_t IDMAC_CH_PRI_14 : 1;  /*!< [14]  */
        uint32_t IDMAC_CH_PRI_15 : 1;  /*!< [15]  */
        uint32_t RESERVED2 : 4;        /*!< [19:16]  */
        uint32_t IDMAC_CH_PRI_20 : 1;  /*!< [20]  */
        uint32_t IDMAC_CH_PRI_21 : 1;  /*!< [21]  */
        uint32_t IDMAC_CH_PRI_22 : 1;  /*!< [22]  */
        uint32_t IDMAC_CH_PRI_23 : 1;  /*!< [23]  */
        uint32_t IDMAC_CH_PRI_24 : 1;  /*!< [24]  */
        uint32_t IDMAC_CH_PRI_25 : 1;  /*!< [25]  */
        uint32_t IDMAC_CH_PRI_26 : 1;  /*!< [26]  */
        uint32_t IDMAC_CH_PRI_27 : 1;  /*!< [27]  */
        uint32_t IDMAC_CH_PRI_28 : 1;  /*!< [28]  */
        uint32_t IDMAC_CH_PRI_29 : 1;  /*!< [29]  */
        uint32_t RESERVED3 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_idmac_ch_pri_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_PRI_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_PRI_1_ADDR(x) ((uintptr_t)(x) + 0x8014U)

#define HW_IPU_IDMAC_CH_PRI_1(x) (*(__IO hw_ipu_idmac_ch_pri_1_t *) HW_IPU_IDMAC_CH_PRI_1_ADDR(x))
#define HW_IPU_IDMAC_CH_PRI_1_RD(x) (HW_IPU_IDMAC_CH_PRI_1(x).U)
#define HW_IPU_IDMAC_CH_PRI_1_WR(x, v) (HW_IPU_IDMAC_CH_PRI_1(x).U = (v))
#define HW_IPU_IDMAC_CH_PRI_1_SET(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, HW_IPU_IDMAC_CH_PRI_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_CH_PRI_1_CLR(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_CH_PRI_1_TOG(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, HW_IPU_IDMAC_CH_PRI_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_PRI_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_0[0] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0 (0U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0 (0x00000001U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_0)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0)

/*! @brief Set the IDMAC_CH_PRI_0 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_0(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_1[1] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1 (1U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1 (0x00000002U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_1)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1)

/*! @brief Set the IDMAC_CH_PRI_1 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_1(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_2[2] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2 (2U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2 (0x00000004U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_2)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2)

/*! @brief Set the IDMAC_CH_PRI_2 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_2(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_3[3] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3 (3U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3 (0x00000008U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_3)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3)

/*! @brief Set the IDMAC_CH_PRI_3 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_3(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_5[5] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5 (5U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5 (0x00000020U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_5)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5)

/*! @brief Set the IDMAC_CH_PRI_5 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_5(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_8[8] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8 (8U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_8)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8)

/*! @brief Set the IDMAC_CH_PRI_8 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_8(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_9[9] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9 (9U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_9)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9)

/*! @brief Set the IDMAC_CH_PRI_9 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_9(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_10[10] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10 (10U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_10)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10)

/*! @brief Set the IDMAC_CH_PRI_10 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_10(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_11[11] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11 (11U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_11)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11)

/*! @brief Set the IDMAC_CH_PRI_11 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_11(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_12[12] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12 (12U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_12)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12)

/*! @brief Set the IDMAC_CH_PRI_12 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_13[13] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13 (13U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_13)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13)

/*! @brief Set the IDMAC_CH_PRI_13 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_13(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_14[14] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14 (14U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_14)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14)

/*! @brief Set the IDMAC_CH_PRI_14 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_15[15] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15 (15U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_15)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15)

/*! @brief Set the IDMAC_CH_PRI_15 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_15(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_20[20] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20 (20U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20 (0x00100000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_20)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20)

/*! @brief Set the IDMAC_CH_PRI_20 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_20(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_21[21] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21 (21U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21 (0x00200000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_21)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21)

/*! @brief Set the IDMAC_CH_PRI_21 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_21(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_22[22] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22 (22U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22 (0x00400000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_22)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22)

/*! @brief Set the IDMAC_CH_PRI_22 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_22(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_23[23] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23 (23U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_23)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23)

/*! @brief Set the IDMAC_CH_PRI_23 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_24[24] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24 (24U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_24)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24)

/*! @brief Set the IDMAC_CH_PRI_24 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_25[25] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25 (25U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_25)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25)

/*! @brief Set the IDMAC_CH_PRI_25 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_25(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_26[26] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26 (26U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26 (0x04000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_26)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26)

/*! @brief Set the IDMAC_CH_PRI_26 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_26(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_27[27] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27 (27U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27 (0x08000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_27)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27)

/*! @brief Set the IDMAC_CH_PRI_27 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_27(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_28[28] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28 (28U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28 (0x10000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_28)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28)

/*! @brief Set the IDMAC_CH_PRI_28 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_28(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_1, field IDMAC_CH_PRI_29[29] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29 (29U) /*!< Bit position for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29. */
#define BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29. */
#define BS_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29 field. */
#define BR_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29(x) (HW_IPU_IDMAC_CH_PRI_1(x).B.IDMAC_CH_PRI_29)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29. */
#define BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29) & BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29)

/*! @brief Set the IDMAC_CH_PRI_29 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29(x, v) (HW_IPU_IDMAC_CH_PRI_1_WR(x, (HW_IPU_IDMAC_CH_PRI_1_RD(x) & ~BM_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29) | BF_IPU_IDMAC_CH_PRI_1_IDMAC_CH_PRI_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_PRI_2 - IDMAC Channel Priority 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_PRI_2 - IDMAC Channel Priority 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_pri_2
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_pri_2_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t IDMAC_CH_PRI_8 : 1;   /*!< [8]  */
        uint32_t IDMAC_CH_PRI_9 : 1;   /*!< [9]  */
        uint32_t IDMAC_CH_PRI_10 : 1;  /*!< [10]  */
        uint32_t IDMAC_CH_PRI_11 : 1;  /*!< [11]  */
        uint32_t IDMAC_CH_PRI_12 : 1;  /*!< [12]  */
        uint32_t IDMAC_CH_PRI_13 : 1;  /*!< [13]  */
        uint32_t IDMAC_CH_PRI_14 : 1;  /*!< [14]  */
        uint32_t IDMAC_CH_PRI_15 : 1;  /*!< [15]  */
        uint32_t IDMAC_CH_PRI_16 : 1;  /*!< [16]  */
        uint32_t IDMAC_CH_PRI_17 : 1;  /*!< [17]  */
        uint32_t IDMAC_CH_PRI_18 : 1;  /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_idmac_ch_pri_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_PRI_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_PRI_2_ADDR(x) ((uintptr_t)(x) + 0x8018U)

#define HW_IPU_IDMAC_CH_PRI_2(x) (*(__IO hw_ipu_idmac_ch_pri_2_t *) HW_IPU_IDMAC_CH_PRI_2_ADDR(x))
#define HW_IPU_IDMAC_CH_PRI_2_RD(x) (HW_IPU_IDMAC_CH_PRI_2(x).U)
#define HW_IPU_IDMAC_CH_PRI_2_WR(x, v) (HW_IPU_IDMAC_CH_PRI_2(x).U = (v))
#define HW_IPU_IDMAC_CH_PRI_2_SET(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, HW_IPU_IDMAC_CH_PRI_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_CH_PRI_2_CLR(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_CH_PRI_2_TOG(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, HW_IPU_IDMAC_CH_PRI_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_PRI_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_8[8] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8 (8U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_8)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8)

/*! @brief Set the IDMAC_CH_PRI_8 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_8(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_9[9] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9 (9U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_9)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9)

/*! @brief Set the IDMAC_CH_PRI_9 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_9(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_10[10] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10 (10U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_10)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10)

/*! @brief Set the IDMAC_CH_PRI_10 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_10(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_11[11] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11 (11U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_11)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11)

/*! @brief Set the IDMAC_CH_PRI_11 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_11(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_12[12] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12 (12U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_12)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12)

/*! @brief Set the IDMAC_CH_PRI_12 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_13[13] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13 (13U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_13)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13)

/*! @brief Set the IDMAC_CH_PRI_13 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_13(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_14[14] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14 (14U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_14)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14)

/*! @brief Set the IDMAC_CH_PRI_14 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_15[15] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15 (15U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_15)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15)

/*! @brief Set the IDMAC_CH_PRI_15 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_15(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_16[16] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16 (16U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16 (0x00010000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_16)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16)

/*! @brief Set the IDMAC_CH_PRI_16 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_16(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_17[17] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17 (17U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17 (0x00020000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_17)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17)

/*! @brief Set the IDMAC_CH_PRI_17 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_17(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_PRI_2, field IDMAC_CH_PRI_18[18] (RW)
 *
 * IDMAC Channel enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] is in low priority
 * - 1 - IDMAC channel [i] is in high priority
 */
/*@{*/
#define BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18 (18U) /*!< Bit position for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18. */
#define BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18 (0x00040000U) /*!< Bit mask for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18. */
#define BS_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18. */

/*! @brief Read current value of the IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18 field. */
#define BR_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18(x) (HW_IPU_IDMAC_CH_PRI_2(x).B.IDMAC_CH_PRI_18)

/*! @brief Format value for bitfield IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18. */
#define BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18) & BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18)

/*! @brief Set the IDMAC_CH_PRI_18 field to a new value. */
#define BW_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18(x, v) (HW_IPU_IDMAC_CH_PRI_2_WR(x, (HW_IPU_IDMAC_CH_PRI_2_RD(x) & ~BM_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18) | BF_IPU_IDMAC_CH_PRI_2_IDMAC_CH_PRI_18(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_WM_EN_1 - IDMAC Channel Watermark Enable 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_WM_EN_1 - IDMAC Channel Watermark Enable 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_wm_en_1
{
    uint32_t U;
    struct _hw_ipu_idmac_wm_en_1_bitfields
    {
        uint32_t IDMAC_WM_EN_0 : 1;    /*!< [0]  */
        uint32_t IDMAC_WM_EN_1 : 1;    /*!< [1]  */
        uint32_t IDMAC_WM_EN_2 : 1;    /*!< [2]  */
        uint32_t IDMAC_WM_EN_3 : 1;    /*!< [3]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t IDMAC_WM_EN_8 : 1;    /*!< [8]  */
        uint32_t RESERVED1 : 1;        /*!< [9]  */
        uint32_t IDMAC_WM_EN_10 : 1;   /*!< [10]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t IDMAC_WM_EN_12 : 1;   /*!< [12]  */
        uint32_t IDMAC_WM_EN_13 : 1;   /*!< [13]  */
        uint32_t IDMAC_WM_EN_14 : 1;   /*!< [14]  */
        uint32_t RESERVED3 : 8;        /*!< [22:15]  */
        uint32_t IDMAC_WM_EN_23 : 1;   /*!< [23]  */
        uint32_t IDMAC_WM_EN_24 : 1;   /*!< [24]  */
        uint32_t IDMAC_WM_EN_25 : 1;   /*!< [25]  */
        uint32_t IDMAC_WM_EN_26 : 1;   /*!< [26]  */
        uint32_t IDMAC_WM_EN_27 : 1;   /*!< [27]  */
        uint32_t IDMAC_WM_EN_28 : 1;   /*!< [28]  */
        uint32_t IDMAC_WM_EN_29 : 1;   /*!< [29]  */
        uint32_t RESERVED4 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_idmac_wm_en_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_WM_EN_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_WM_EN_1_ADDR(x) ((uintptr_t)(x) + 0x801CU)

#define HW_IPU_IDMAC_WM_EN_1(x)  (*(__IO hw_ipu_idmac_wm_en_1_t *) HW_IPU_IDMAC_WM_EN_1_ADDR(x))
#define HW_IPU_IDMAC_WM_EN_1_RD(x) (HW_IPU_IDMAC_WM_EN_1(x).U)
#define HW_IPU_IDMAC_WM_EN_1_WR(x, v) (HW_IPU_IDMAC_WM_EN_1(x).U = (v))
#define HW_IPU_IDMAC_WM_EN_1_SET(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, HW_IPU_IDMAC_WM_EN_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_WM_EN_1_CLR(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, HW_IPU_IDMAC_WM_EN_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_WM_EN_1_TOG(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, HW_IPU_IDMAC_WM_EN_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_WM_EN_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_0[0] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0 (0U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0 (0x00000001U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_0)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0)

/*! @brief Set the IDMAC_WM_EN_0 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_1[1] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1 (1U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1 (0x00000002U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_1)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1)

/*! @brief Set the IDMAC_WM_EN_1 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_2[2] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2 (2U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2 (0x00000004U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_2)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2)

/*! @brief Set the IDMAC_WM_EN_2 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_3[3] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3 (3U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3 (0x00000008U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_3)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3)

/*! @brief Set the IDMAC_WM_EN_3 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_8[8] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8 (8U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8 (0x00000100U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_8)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8)

/*! @brief Set the IDMAC_WM_EN_8 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_8(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_10[10] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10 (10U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10 (0x00000400U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_10)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10)

/*! @brief Set the IDMAC_WM_EN_10 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_10(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_12[12] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12 (12U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_12)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12)

/*! @brief Set the IDMAC_WM_EN_12 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_13[13] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13 (13U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13 (0x00002000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_13)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13)

/*! @brief Set the IDMAC_WM_EN_13 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_13(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_14[14] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14 (14U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_14)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14)

/*! @brief Set the IDMAC_WM_EN_14 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_23[23] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23 (23U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_23)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23)

/*! @brief Set the IDMAC_WM_EN_23 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_24[24] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24 (24U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_24)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24)

/*! @brief Set the IDMAC_WM_EN_24 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_25[25] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25 (25U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_25)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25)

/*! @brief Set the IDMAC_WM_EN_25 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_26[26] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26 (26U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26 (0x04000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_26)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26)

/*! @brief Set the IDMAC_WM_EN_26 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_26(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_27[27] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27 (27U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27 (0x08000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_27)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27)

/*! @brief Set the IDMAC_WM_EN_27 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_28[28] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28 (28U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28 (0x10000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_28)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28)

/*! @brief Set the IDMAC_WM_EN_28 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_28(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_1, field IDMAC_WM_EN_29[29] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29 (29U) /*!< Bit position for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29. */
#define BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29. */
#define BS_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29 field. */
#define BR_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29(x) (HW_IPU_IDMAC_WM_EN_1(x).B.IDMAC_WM_EN_29)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29. */
#define BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29) & BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29)

/*! @brief Set the IDMAC_WM_EN_29 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29(x, v) (HW_IPU_IDMAC_WM_EN_1_WR(x, (HW_IPU_IDMAC_WM_EN_1_RD(x) & ~BM_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29) | BF_IPU_IDMAC_WM_EN_1_IDMAC_WM_EN_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_WM_EN_2 - IDMAC Channel Watermark Enable 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_WM_EN_2 - IDMAC Channel Watermark Enable 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_wm_en_2
{
    uint32_t U;
    struct _hw_ipu_idmac_wm_en_2_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t IDMAC_WM_EN_40 : 1;   /*!< [8]  */
        uint32_t IDMAC_WM_EN_41 : 1;   /*!< [9]  */
        uint32_t IDMAC_WM_EN_42 : 1;   /*!< [10]  */
        uint32_t IDMAC_WM_EN_43 : 1;   /*!< [11]  */
        uint32_t IDMAC_WM_EN_44 : 1;   /*!< [12]  */
        uint32_t RESERVED1 : 19;       /*!< [31:13]  */
    } B;
} hw_ipu_idmac_wm_en_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_WM_EN_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_WM_EN_2_ADDR(x) ((uintptr_t)(x) + 0x8020U)

#define HW_IPU_IDMAC_WM_EN_2(x)  (*(__IO hw_ipu_idmac_wm_en_2_t *) HW_IPU_IDMAC_WM_EN_2_ADDR(x))
#define HW_IPU_IDMAC_WM_EN_2_RD(x) (HW_IPU_IDMAC_WM_EN_2(x).U)
#define HW_IPU_IDMAC_WM_EN_2_WR(x, v) (HW_IPU_IDMAC_WM_EN_2(x).U = (v))
#define HW_IPU_IDMAC_WM_EN_2_SET(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, HW_IPU_IDMAC_WM_EN_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_WM_EN_2_CLR(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, HW_IPU_IDMAC_WM_EN_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_WM_EN_2_TOG(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, HW_IPU_IDMAC_WM_EN_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_WM_EN_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_WM_EN_2, field IDMAC_WM_EN_40[8] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40 (8U) /*!< Bit position for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40. */
#define BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40 (0x00000100U) /*!< Bit mask for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40. */
#define BS_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40 field. */
#define BR_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40(x) (HW_IPU_IDMAC_WM_EN_2(x).B.IDMAC_WM_EN_40)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40. */
#define BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40) & BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40)

/*! @brief Set the IDMAC_WM_EN_40 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, (HW_IPU_IDMAC_WM_EN_2_RD(x) & ~BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40) | BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_40(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_2, field IDMAC_WM_EN_41[9] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41 (9U) /*!< Bit position for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41. */
#define BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41 (0x00000200U) /*!< Bit mask for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41. */
#define BS_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41 field. */
#define BR_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41(x) (HW_IPU_IDMAC_WM_EN_2(x).B.IDMAC_WM_EN_41)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41. */
#define BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41) & BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41)

/*! @brief Set the IDMAC_WM_EN_41 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, (HW_IPU_IDMAC_WM_EN_2_RD(x) & ~BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41) | BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_41(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_2, field IDMAC_WM_EN_42[10] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42 (10U) /*!< Bit position for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42. */
#define BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42 (0x00000400U) /*!< Bit mask for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42. */
#define BS_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42 field. */
#define BR_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42(x) (HW_IPU_IDMAC_WM_EN_2(x).B.IDMAC_WM_EN_42)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42. */
#define BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42) & BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42)

/*! @brief Set the IDMAC_WM_EN_42 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, (HW_IPU_IDMAC_WM_EN_2_RD(x) & ~BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42) | BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_42(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_2, field IDMAC_WM_EN_43[11] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43 (11U) /*!< Bit position for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43. */
#define BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43 (0x00000800U) /*!< Bit mask for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43. */
#define BS_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43 field. */
#define BR_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43(x) (HW_IPU_IDMAC_WM_EN_2(x).B.IDMAC_WM_EN_43)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43. */
#define BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43) & BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43)

/*! @brief Set the IDMAC_WM_EN_43 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, (HW_IPU_IDMAC_WM_EN_2_RD(x) & ~BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43) | BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_43(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_WM_EN_2, field IDMAC_WM_EN_44[12] (RW)
 *
 * IDMAC Watermark enable bit [i]
 *
 * Values:
 * - 0 - IDMAC channel [i] watermark feature is disabled
 * - 1 - IDMAC channel [i] watermark feature is enabled
 */
/*@{*/
#define BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44 (12U) /*!< Bit position for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44. */
#define BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44 (0x00001000U) /*!< Bit mask for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44. */
#define BS_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44 (1U) /*!< Bit field size in bits for IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44. */

/*! @brief Read current value of the IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44 field. */
#define BR_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44(x) (HW_IPU_IDMAC_WM_EN_2(x).B.IDMAC_WM_EN_44)

/*! @brief Format value for bitfield IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44. */
#define BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44) & BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44)

/*! @brief Set the IDMAC_WM_EN_44 field to a new value. */
#define BW_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44(x, v) (HW_IPU_IDMAC_WM_EN_2_WR(x, (HW_IPU_IDMAC_WM_EN_2_RD(x) & ~BM_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44) | BF_IPU_IDMAC_WM_EN_2_IDMAC_WM_EN_44(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_LOCK_EN_1 - IDMAC Channel Lock Enable 1Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_LOCK_EN_1 - IDMAC Channel Lock Enable 1Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_lock_en_1
{
    uint32_t U;
    struct _hw_ipu_idmac_lock_en_1_bitfields
    {
        uint32_t IDMAC_LOCK_EN_5 : 2;  /*!< [1:0]  */
        uint32_t IDMAC_LOCK_EN_11 : 2; /*!< [3:2]  */
        uint32_t IDMAC_LOCK_EN_12 : 2; /*!< [5:4]  */
        uint32_t IDMAC_LOCK_EN_14 : 2; /*!< [7:6]  */
        uint32_t IDMAC_LOCK_EN_15 : 2; /*!< [9:8]  */
        uint32_t IDMAC_LOCK_EN_20 : 2; /*!< [11:10]  */
        uint32_t IDMAC_LOCK_EN_21 : 2; /*!< [13:12]  */
        uint32_t IDMAC_LOCK_EN_22 : 2; /*!< [15:14]  */
        uint32_t IDMAC_LOCK_EN_23 : 2; /*!< [17:16]  */
        uint32_t IDMAC_LOCK_EN_27 : 2; /*!< [19:18]  */
        uint32_t IDMAC_LOCK_EN_28 : 2; /*!< [21:20]  */
        uint32_t RESERVED0 : 10;       /*!< [31:22]  */
    } B;
} hw_ipu_idmac_lock_en_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_LOCK_EN_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_LOCK_EN_1_ADDR(x) ((uintptr_t)(x) + 0x8024U)

#define HW_IPU_IDMAC_LOCK_EN_1(x) (*(__IO hw_ipu_idmac_lock_en_1_t *) HW_IPU_IDMAC_LOCK_EN_1_ADDR(x))
#define HW_IPU_IDMAC_LOCK_EN_1_RD(x) (HW_IPU_IDMAC_LOCK_EN_1(x).U)
#define HW_IPU_IDMAC_LOCK_EN_1_WR(x, v) (HW_IPU_IDMAC_LOCK_EN_1(x).U = (v))
#define HW_IPU_IDMAC_LOCK_EN_1_SET(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, HW_IPU_IDMAC_LOCK_EN_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_LOCK_EN_1_CLR(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_LOCK_EN_1_TOG(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, HW_IPU_IDMAC_LOCK_EN_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_LOCK_EN_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_5[1:0] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5 (0U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5 (0x00000003U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_5)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5)

/*! @brief Set the IDMAC_LOCK_EN_5 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_11[3:2] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11 (2U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11 (0x0000000CU) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_11)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11)

/*! @brief Set the IDMAC_LOCK_EN_11 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_12[5:4] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12 (4U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12 (0x00000030U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_12)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12)

/*! @brief Set the IDMAC_LOCK_EN_12 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_14[7:6] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14 (6U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14 (0x000000C0U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_14)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14)

/*! @brief Set the IDMAC_LOCK_EN_14 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_14(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_15[9:8] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15 (8U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15 (0x00000300U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_15)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15)

/*! @brief Set the IDMAC_LOCK_EN_15 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_15(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_20[11:10] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20 (10U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20 (0x00000C00U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_20)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20)

/*! @brief Set the IDMAC_LOCK_EN_20 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_21[13:12] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21 (12U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21 (0x00003000U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_21)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21)

/*! @brief Set the IDMAC_LOCK_EN_21 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_22[15:14] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22 (14U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22 (0x0000C000U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_22)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22)

/*! @brief Set the IDMAC_LOCK_EN_22 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_23[17:16] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23 (16U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23 (0x00030000U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_23)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23)

/*! @brief Set the IDMAC_LOCK_EN_23 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_27[19:18] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27 (18U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27 (0x000C0000U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_27)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27)

/*! @brief Set the IDMAC_LOCK_EN_27 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_27(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_1, field IDMAC_LOCK_EN_28[21:20] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28 (20U) /*!< Bit position for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28. */
#define BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28 (0x00300000U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28. */
#define BS_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28 field. */
#define BR_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28(x) (HW_IPU_IDMAC_LOCK_EN_1(x).B.IDMAC_LOCK_EN_28)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28. */
#define BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28) & BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28)

/*! @brief Set the IDMAC_LOCK_EN_28 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28(x, v) (HW_IPU_IDMAC_LOCK_EN_1_WR(x, (HW_IPU_IDMAC_LOCK_EN_1_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28) | BF_IPU_IDMAC_LOCK_EN_1_IDMAC_LOCK_EN_28(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_LOCK_EN_2 - IDMAC Channel Lock Enable 2Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_LOCK_EN_2 - IDMAC Channel Lock Enable 2Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_lock_en_2
{
    uint32_t U;
    struct _hw_ipu_idmac_lock_en_2_bitfields
    {
        uint32_t IDMAC_LOCK_45 : 2;    /*!< [1:0]  */
        uint32_t IDMAC_LOCK_46 : 2;    /*!< [3:2]  */
        uint32_t IDMAC_LOCK_47 : 2;    /*!< [5:4]  */
        uint32_t IDMAC_LOCK_48 : 2;    /*!< [7:6]  */
        uint32_t IDMAC_LOCK_49 : 2;    /*!< [9:8]  */
        uint32_t IDMAC_LOCK_50 : 2;    /*!< [11:10]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_idmac_lock_en_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_LOCK_EN_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_LOCK_EN_2_ADDR(x) ((uintptr_t)(x) + 0x8028U)

#define HW_IPU_IDMAC_LOCK_EN_2(x) (*(__IO hw_ipu_idmac_lock_en_2_t *) HW_IPU_IDMAC_LOCK_EN_2_ADDR(x))
#define HW_IPU_IDMAC_LOCK_EN_2_RD(x) (HW_IPU_IDMAC_LOCK_EN_2(x).U)
#define HW_IPU_IDMAC_LOCK_EN_2_WR(x, v) (HW_IPU_IDMAC_LOCK_EN_2(x).U = (v))
#define HW_IPU_IDMAC_LOCK_EN_2_SET(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, HW_IPU_IDMAC_LOCK_EN_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_LOCK_EN_2_CLR(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_LOCK_EN_2_TOG(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, HW_IPU_IDMAC_LOCK_EN_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_LOCK_EN_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_45[1:0] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45 (0U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45 (0x00000003U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_45)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45)

/*! @brief Set the IDMAC_LOCK_45 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_45(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_46[3:2] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46 (2U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46 (0x0000000CU) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_46)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46)

/*! @brief Set the IDMAC_LOCK_46 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_46(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_47[5:4] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47 (4U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47 (0x00000030U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_47)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47)

/*! @brief Set the IDMAC_LOCK_47 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_47(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_48[7:6] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48 (6U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48 (0x000000C0U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_48)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48)

/*! @brief Set the IDMAC_LOCK_48 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_48(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_49[9:8] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49 (8U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49 (0x00000300U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_49)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49)

/*! @brief Set the IDMAC_LOCK_49 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_49(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_LOCK_EN_2, field IDMAC_LOCK_50[11:10] (RW)
 *
 * IDMAC lock bits for channel [i]
 *
 * Values:
 * - 00 - The lock feature is disabled. The IDMAC will generate one AXI burst
 *     upon the assertion of the DMA request.
 * - 01 - The IDMAC will generate two AXI bursts upon the assertion of the DMA
 *     request.
 * - 10 - The IDMAC will generate four AXI bursts upon the assertion of the DMA
 *     request.
 * - 11 - The IDMAC will generate eight AXI bursts upon the assertion of the DMA
 *     request.
 */
/*@{*/
#define BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50 (10U) /*!< Bit position for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50. */
#define BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50 (0x00000C00U) /*!< Bit mask for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50. */
#define BS_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50 (2U) /*!< Bit field size in bits for IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50. */

/*! @brief Read current value of the IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50 field. */
#define BR_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50(x) (HW_IPU_IDMAC_LOCK_EN_2(x).B.IDMAC_LOCK_50)

/*! @brief Format value for bitfield IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50. */
#define BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50) & BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50)

/*! @brief Set the IDMAC_LOCK_50 field to a new value. */
#define BW_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50(x, v) (HW_IPU_IDMAC_LOCK_EN_2_WR(x, (HW_IPU_IDMAC_LOCK_EN_2_RD(x) & ~BM_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50) | BF_IPU_IDMAC_LOCK_EN_2_IDMAC_LOCK_50(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SUB_ADDR_0 - IDMAC Channel Alternate Address 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SUB_ADDR_0 - IDMAC Channel Alternate Address 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sub_addr_0
{
    uint32_t U;
    struct _hw_ipu_idmac_sub_addr_0_bitfields
    {
        uint32_t IDMAC_SUB_ADDR_i : 32; /*!< [31:0]  */
    } B;
} hw_ipu_idmac_sub_addr_0_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SUB_ADDR_0 register
 */
/*@{*/
#define HW_IPU_IDMAC_SUB_ADDR_0_ADDR(x) ((uintptr_t)(x) + 0x802CU)

#define HW_IPU_IDMAC_SUB_ADDR_0(x) (*(__IO hw_ipu_idmac_sub_addr_0_t *) HW_IPU_IDMAC_SUB_ADDR_0_ADDR(x))
#define HW_IPU_IDMAC_SUB_ADDR_0_RD(x) (HW_IPU_IDMAC_SUB_ADDR_0(x).U)
#define HW_IPU_IDMAC_SUB_ADDR_0_WR(x, v) (HW_IPU_IDMAC_SUB_ADDR_0(x).U = (v))
#define HW_IPU_IDMAC_SUB_ADDR_0_SET(x, v) (HW_IPU_IDMAC_SUB_ADDR_0_WR(x, HW_IPU_IDMAC_SUB_ADDR_0_RD(x) |  (v)))
#define HW_IPU_IDMAC_SUB_ADDR_0_CLR(x, v) (HW_IPU_IDMAC_SUB_ADDR_0_WR(x, HW_IPU_IDMAC_SUB_ADDR_0_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SUB_ADDR_0_TOG(x, v) (HW_IPU_IDMAC_SUB_ADDR_0_WR(x, HW_IPU_IDMAC_SUB_ADDR_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SUB_ADDR_0 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_0, field IDMAC_SUB_ADDR_i[31:0] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i (0U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i. */
#define BM_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i (0xFFFFFFFFU) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i. */
#define BS_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i (32U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i field. */
#define BR_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i(x) (HW_IPU_IDMAC_SUB_ADDR_0(x).U)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i. */
#define BF_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i) & BM_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i)

/*! @brief Set the IDMAC_SUB_ADDR_i field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_0_IDMAC_SUB_ADDR_i(x, v) (HW_IPU_IDMAC_SUB_ADDR_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SUB_ADDR_1 - IDMAC Channel Alternate Address 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SUB_ADDR_1 - IDMAC Channel Alternate Address 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sub_addr_1
{
    uint32_t U;
    struct _hw_ipu_idmac_sub_addr_1_bitfields
    {
        uint32_t IDMAC_SUB_ADDR_23 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t IDMAC_SUB_ADDR_24 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t IDMAC_SUB_ADDR_29 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t IDMAC_SUB_ADDR_33 : 7; /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_ipu_idmac_sub_addr_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SUB_ADDR_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_SUB_ADDR_1_ADDR(x) ((uintptr_t)(x) + 0x8030U)

#define HW_IPU_IDMAC_SUB_ADDR_1(x) (*(__IO hw_ipu_idmac_sub_addr_1_t *) HW_IPU_IDMAC_SUB_ADDR_1_ADDR(x))
#define HW_IPU_IDMAC_SUB_ADDR_1_RD(x) (HW_IPU_IDMAC_SUB_ADDR_1(x).U)
#define HW_IPU_IDMAC_SUB_ADDR_1_WR(x, v) (HW_IPU_IDMAC_SUB_ADDR_1(x).U = (v))
#define HW_IPU_IDMAC_SUB_ADDR_1_SET(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, HW_IPU_IDMAC_SUB_ADDR_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_SUB_ADDR_1_CLR(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, HW_IPU_IDMAC_SUB_ADDR_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SUB_ADDR_1_TOG(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, HW_IPU_IDMAC_SUB_ADDR_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SUB_ADDR_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_1, field IDMAC_SUB_ADDR_23[6:0] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23 (0U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23. */
#define BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23 (0x0000007FU) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23. */
#define BS_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23 field. */
#define BR_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23(x) (HW_IPU_IDMAC_SUB_ADDR_1(x).B.IDMAC_SUB_ADDR_23)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23. */
#define BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23) & BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23)

/*! @brief Set the IDMAC_SUB_ADDR_23 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, (HW_IPU_IDMAC_SUB_ADDR_1_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23) | BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_23(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_1, field IDMAC_SUB_ADDR_24[14:8] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24 (8U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24. */
#define BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24 (0x00007F00U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24. */
#define BS_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24 field. */
#define BR_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24(x) (HW_IPU_IDMAC_SUB_ADDR_1(x).B.IDMAC_SUB_ADDR_24)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24. */
#define BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24) & BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24)

/*! @brief Set the IDMAC_SUB_ADDR_24 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, (HW_IPU_IDMAC_SUB_ADDR_1_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24) | BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_24(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_1, field IDMAC_SUB_ADDR_29[22:16] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29 (16U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29. */
#define BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29 (0x007F0000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29. */
#define BS_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29 field. */
#define BR_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29(x) (HW_IPU_IDMAC_SUB_ADDR_1(x).B.IDMAC_SUB_ADDR_29)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29. */
#define BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29) & BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29)

/*! @brief Set the IDMAC_SUB_ADDR_29 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, (HW_IPU_IDMAC_SUB_ADDR_1_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29) | BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_29(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_1, field IDMAC_SUB_ADDR_33[30:24] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33 (24U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33. */
#define BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33 (0x7F000000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33. */
#define BS_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33 field. */
#define BR_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33(x) (HW_IPU_IDMAC_SUB_ADDR_1(x).B.IDMAC_SUB_ADDR_33)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33. */
#define BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33) & BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33)

/*! @brief Set the IDMAC_SUB_ADDR_33 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33(x, v) (HW_IPU_IDMAC_SUB_ADDR_1_WR(x, (HW_IPU_IDMAC_SUB_ADDR_1_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33) | BF_IPU_IDMAC_SUB_ADDR_1_IDMAC_SUB_ADDR_33(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SUB_ADDR_2 - IDMAC Channel Alternate Address 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SUB_ADDR_2 - IDMAC Channel Alternate Address 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sub_addr_2
{
    uint32_t U;
    struct _hw_ipu_idmac_sub_addr_2_bitfields
    {
        uint32_t IDMAC_SUB_ADDR_41 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t IDMAC_SUB_ADDR_51 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t IDMAC_SUB_ADDR_52 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 9;        /*!< [31:23]  */
    } B;
} hw_ipu_idmac_sub_addr_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SUB_ADDR_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_SUB_ADDR_2_ADDR(x) ((uintptr_t)(x) + 0x8034U)

#define HW_IPU_IDMAC_SUB_ADDR_2(x) (*(__IO hw_ipu_idmac_sub_addr_2_t *) HW_IPU_IDMAC_SUB_ADDR_2_ADDR(x))
#define HW_IPU_IDMAC_SUB_ADDR_2_RD(x) (HW_IPU_IDMAC_SUB_ADDR_2(x).U)
#define HW_IPU_IDMAC_SUB_ADDR_2_WR(x, v) (HW_IPU_IDMAC_SUB_ADDR_2(x).U = (v))
#define HW_IPU_IDMAC_SUB_ADDR_2_SET(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, HW_IPU_IDMAC_SUB_ADDR_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_SUB_ADDR_2_CLR(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, HW_IPU_IDMAC_SUB_ADDR_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SUB_ADDR_2_TOG(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, HW_IPU_IDMAC_SUB_ADDR_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SUB_ADDR_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_2, field IDMAC_SUB_ADDR_41[6:0] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41 (0U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41. */
#define BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41 (0x0000007FU) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41. */
#define BS_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41 field. */
#define BR_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41(x) (HW_IPU_IDMAC_SUB_ADDR_2(x).B.IDMAC_SUB_ADDR_41)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41. */
#define BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41) & BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41)

/*! @brief Set the IDMAC_SUB_ADDR_41 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, (HW_IPU_IDMAC_SUB_ADDR_2_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41) | BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_41(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_2, field IDMAC_SUB_ADDR_51[14:8] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51 (8U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51. */
#define BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51 (0x00007F00U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51. */
#define BS_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51 field. */
#define BR_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51(x) (HW_IPU_IDMAC_SUB_ADDR_2(x).B.IDMAC_SUB_ADDR_51)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51. */
#define BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51) & BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51)

/*! @brief Set the IDMAC_SUB_ADDR_51 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, (HW_IPU_IDMAC_SUB_ADDR_2_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51) | BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_51(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_2, field IDMAC_SUB_ADDR_52[22:16] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52 (16U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52. */
#define BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52 (0x007F0000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52. */
#define BS_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52 field. */
#define BR_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52(x) (HW_IPU_IDMAC_SUB_ADDR_2(x).B.IDMAC_SUB_ADDR_52)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52. */
#define BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52) & BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52)

/*! @brief Set the IDMAC_SUB_ADDR_52 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52(x, v) (HW_IPU_IDMAC_SUB_ADDR_2_WR(x, (HW_IPU_IDMAC_SUB_ADDR_2_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52) | BF_IPU_IDMAC_SUB_ADDR_2_IDMAC_SUB_ADDR_52(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SUB_ADDR_3 - IDMAC Channel Alternate Address 3 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SUB_ADDR_3 - IDMAC Channel Alternate Address 3 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sub_addr_3
{
    uint32_t U;
    struct _hw_ipu_idmac_sub_addr_3_bitfields
    {
        uint32_t IDMAC_SUB_ADDR_9 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t IDMAC_SUB_ADDR_10 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t IDMAC_SUB_ADDR_13 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t IDMAC_SUB_ADDR_27 : 7; /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_ipu_idmac_sub_addr_3_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SUB_ADDR_3 register
 */
/*@{*/
#define HW_IPU_IDMAC_SUB_ADDR_3_ADDR(x) ((uintptr_t)(x) + 0x8038U)

#define HW_IPU_IDMAC_SUB_ADDR_3(x) (*(__IO hw_ipu_idmac_sub_addr_3_t *) HW_IPU_IDMAC_SUB_ADDR_3_ADDR(x))
#define HW_IPU_IDMAC_SUB_ADDR_3_RD(x) (HW_IPU_IDMAC_SUB_ADDR_3(x).U)
#define HW_IPU_IDMAC_SUB_ADDR_3_WR(x, v) (HW_IPU_IDMAC_SUB_ADDR_3(x).U = (v))
#define HW_IPU_IDMAC_SUB_ADDR_3_SET(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, HW_IPU_IDMAC_SUB_ADDR_3_RD(x) |  (v)))
#define HW_IPU_IDMAC_SUB_ADDR_3_CLR(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, HW_IPU_IDMAC_SUB_ADDR_3_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SUB_ADDR_3_TOG(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, HW_IPU_IDMAC_SUB_ADDR_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SUB_ADDR_3 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_3, field IDMAC_SUB_ADDR_9[6:0] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9 (0U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9. */
#define BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9 (0x0000007FU) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9. */
#define BS_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9 field. */
#define BR_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9(x) (HW_IPU_IDMAC_SUB_ADDR_3(x).B.IDMAC_SUB_ADDR_9)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9. */
#define BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9) & BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9)

/*! @brief Set the IDMAC_SUB_ADDR_9 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, (HW_IPU_IDMAC_SUB_ADDR_3_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9) | BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_9(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_3, field IDMAC_SUB_ADDR_10[14:8] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10 (8U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10. */
#define BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10 (0x00007F00U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10. */
#define BS_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10 field. */
#define BR_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10(x) (HW_IPU_IDMAC_SUB_ADDR_3(x).B.IDMAC_SUB_ADDR_10)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10. */
#define BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10) & BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10)

/*! @brief Set the IDMAC_SUB_ADDR_10 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, (HW_IPU_IDMAC_SUB_ADDR_3_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10) | BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_10(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_3, field IDMAC_SUB_ADDR_13[22:16] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13 (16U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13. */
#define BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13 (0x007F0000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13. */
#define BS_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13 field. */
#define BR_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13(x) (HW_IPU_IDMAC_SUB_ADDR_3(x).B.IDMAC_SUB_ADDR_13)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13. */
#define BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13) & BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13)

/*! @brief Set the IDMAC_SUB_ADDR_13 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, (HW_IPU_IDMAC_SUB_ADDR_3_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13) | BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_13(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_3, field IDMAC_SUB_ADDR_27[30:24] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27 (24U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27. */
#define BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27 (0x7F000000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27. */
#define BS_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27 field. */
#define BR_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27(x) (HW_IPU_IDMAC_SUB_ADDR_3(x).B.IDMAC_SUB_ADDR_27)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27. */
#define BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27) & BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27)

/*! @brief Set the IDMAC_SUB_ADDR_27 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27(x, v) (HW_IPU_IDMAC_SUB_ADDR_3_WR(x, (HW_IPU_IDMAC_SUB_ADDR_3_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27) | BF_IPU_IDMAC_SUB_ADDR_3_IDMAC_SUB_ADDR_27(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SUB_ADDR_4 - IDMAC Channel Alternate Address 4 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SUB_ADDR_4 - IDMAC Channel Alternate Address 4 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sub_addr_4
{
    uint32_t U;
    struct _hw_ipu_idmac_sub_addr_4_bitfields
    {
        uint32_t IDMAC_SUB_ADDR_28 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t IDMAC_SUB_ADDR_8 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t IDMAC_SUB_ADDR_21 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 9;        /*!< [31:23]  */
    } B;
} hw_ipu_idmac_sub_addr_4_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SUB_ADDR_4 register
 */
/*@{*/
#define HW_IPU_IDMAC_SUB_ADDR_4_ADDR(x) ((uintptr_t)(x) + 0x803CU)

#define HW_IPU_IDMAC_SUB_ADDR_4(x) (*(__IO hw_ipu_idmac_sub_addr_4_t *) HW_IPU_IDMAC_SUB_ADDR_4_ADDR(x))
#define HW_IPU_IDMAC_SUB_ADDR_4_RD(x) (HW_IPU_IDMAC_SUB_ADDR_4(x).U)
#define HW_IPU_IDMAC_SUB_ADDR_4_WR(x, v) (HW_IPU_IDMAC_SUB_ADDR_4(x).U = (v))
#define HW_IPU_IDMAC_SUB_ADDR_4_SET(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, HW_IPU_IDMAC_SUB_ADDR_4_RD(x) |  (v)))
#define HW_IPU_IDMAC_SUB_ADDR_4_CLR(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, HW_IPU_IDMAC_SUB_ADDR_4_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SUB_ADDR_4_TOG(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, HW_IPU_IDMAC_SUB_ADDR_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SUB_ADDR_4 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_4, field IDMAC_SUB_ADDR_28[6:0] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28 (0U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28. */
#define BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28 (0x0000007FU) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28. */
#define BS_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28 field. */
#define BR_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28(x) (HW_IPU_IDMAC_SUB_ADDR_4(x).B.IDMAC_SUB_ADDR_28)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28. */
#define BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28) & BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28)

/*! @brief Set the IDMAC_SUB_ADDR_28 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, (HW_IPU_IDMAC_SUB_ADDR_4_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28) | BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_28(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_4, field IDMAC_SUB_ADDR_8[14:8] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8 (8U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8. */
#define BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8 (0x00007F00U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8. */
#define BS_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8 field. */
#define BR_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8(x) (HW_IPU_IDMAC_SUB_ADDR_4(x).B.IDMAC_SUB_ADDR_8)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8. */
#define BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8) & BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8)

/*! @brief Set the IDMAC_SUB_ADDR_8 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, (HW_IPU_IDMAC_SUB_ADDR_4_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8) | BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_8(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SUB_ADDR_4, field IDMAC_SUB_ADDR_21[22:16] (RW)
 *
 * The CPMEM alternative entry [i] holds the parameters of the channel that is
 * number appears in IDMAC_SUB_ADDR_i. The user must set each IDMAC_SUB_ADDR_i
 * field to a unique channel. Alternative CPMEM entry is relevant only for channels
 * supporting alternate flows.
 */
/*@{*/
#define BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21 (16U) /*!< Bit position for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21. */
#define BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21 (0x007F0000U) /*!< Bit mask for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21. */
#define BS_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21 (7U) /*!< Bit field size in bits for IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21. */

/*! @brief Read current value of the IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21 field. */
#define BR_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21(x) (HW_IPU_IDMAC_SUB_ADDR_4(x).B.IDMAC_SUB_ADDR_21)

/*! @brief Format value for bitfield IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21. */
#define BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21) & BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21)

/*! @brief Set the IDMAC_SUB_ADDR_21 field to a new value. */
#define BW_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21(x, v) (HW_IPU_IDMAC_SUB_ADDR_4_WR(x, (HW_IPU_IDMAC_SUB_ADDR_4_RD(x) & ~BM_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21) | BF_IPU_IDMAC_SUB_ADDR_4_IDMAC_SUB_ADDR_21(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_BNDM_EN_1 - IDMAC Band Mode Enable 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_BNDM_EN_1 - IDMAC Band Mode Enable 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_bndm_en_1
{
    uint32_t U;
    struct _hw_ipu_idmac_bndm_en_1_bitfields
    {
        uint32_t IDMAC_BNDM_EN_0 : 1;  /*!< [0]  */
        uint32_t IDMAC_BNDM_EN_1 : 1;  /*!< [1]  */
        uint32_t IDMAC_BNDM_EN_2 : 1;  /*!< [2]  */
        uint32_t IDMAC_BNDM_EN_3 : 1;  /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_BNDM_EN_5 : 1;  /*!< [5]  */
        uint32_t RESERVED1 : 5;        /*!< [10:6]  */
        uint32_t IDMAC_BNDM_EN_11 : 1; /*!< [11]  */
        uint32_t IDMAC_BNDM_EN_12 : 1; /*!< [12]  */
        uint32_t RESERVED2 : 7;        /*!< [19:13]  */
        uint32_t IDMAC_BNDM_EN_20 : 1; /*!< [20]  */
        uint32_t IDMAC_BNDM_EN_21 : 1; /*!< [21]  */
        uint32_t IDMAC_BNDM_EN_22 : 1; /*!< [22]  */
        uint32_t RESERVED3 : 2;        /*!< [24:23]  */
        uint32_t IDMAC_BNDM_EN_25 : 1; /*!< [25]  */
        uint32_t IDMAC_BNDM_EN_26 : 1; /*!< [26]  */
        uint32_t RESERVED4 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_idmac_bndm_en_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_BNDM_EN_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_BNDM_EN_1_ADDR(x) ((uintptr_t)(x) + 0x8040U)

#define HW_IPU_IDMAC_BNDM_EN_1(x) (*(__IO hw_ipu_idmac_bndm_en_1_t *) HW_IPU_IDMAC_BNDM_EN_1_ADDR(x))
#define HW_IPU_IDMAC_BNDM_EN_1_RD(x) (HW_IPU_IDMAC_BNDM_EN_1(x).U)
#define HW_IPU_IDMAC_BNDM_EN_1_WR(x, v) (HW_IPU_IDMAC_BNDM_EN_1(x).U = (v))
#define HW_IPU_IDMAC_BNDM_EN_1_SET(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, HW_IPU_IDMAC_BNDM_EN_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_BNDM_EN_1_CLR(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_BNDM_EN_1_TOG(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, HW_IPU_IDMAC_BNDM_EN_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_BNDM_EN_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_0[0] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0 (0U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0 (0x00000001U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_0)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0)

/*! @brief Set the IDMAC_BNDM_EN_0 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_1[1] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1 (1U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1 (0x00000002U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_1)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1)

/*! @brief Set the IDMAC_BNDM_EN_1 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_2[2] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2 (2U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2 (0x00000004U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_2)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2)

/*! @brief Set the IDMAC_BNDM_EN_2 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_3[3] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3 (3U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3 (0x00000008U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_3)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3)

/*! @brief Set the IDMAC_BNDM_EN_3 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_5[5] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5 (5U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5 (0x00000020U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_5)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5)

/*! @brief Set the IDMAC_BNDM_EN_5 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_5(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_11[11] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11 (11U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11 (0x00000800U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_11)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11)

/*! @brief Set the IDMAC_BNDM_EN_11 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_11(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_12[12] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12 (12U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_12)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12)

/*! @brief Set the IDMAC_BNDM_EN_12 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_12(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_20[20] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20 (20U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20 (0x00100000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_20)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20)

/*! @brief Set the IDMAC_BNDM_EN_20 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_20(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_21[21] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21 (21U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21 (0x00200000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_21)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21)

/*! @brief Set the IDMAC_BNDM_EN_21 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_21(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_22[22] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22 (22U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22 (0x00400000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_22)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22)

/*! @brief Set the IDMAC_BNDM_EN_22 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_22(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_25[25] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25 (25U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_25)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25)

/*! @brief Set the IDMAC_BNDM_EN_25 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_25(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_1, field IDMAC_BNDM_EN_26[26] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26 (26U) /*!< Bit position for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26. */
#define BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26 (0x04000000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26. */
#define BS_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26 field. */
#define BR_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26(x) (HW_IPU_IDMAC_BNDM_EN_1(x).B.IDMAC_BNDM_EN_26)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26. */
#define BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26) & BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26)

/*! @brief Set the IDMAC_BNDM_EN_26 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26(x, v) (HW_IPU_IDMAC_BNDM_EN_1_WR(x, (HW_IPU_IDMAC_BNDM_EN_1_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26) | BF_IPU_IDMAC_BNDM_EN_1_IDMAC_BNDM_EN_26(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_BNDM_EN_2 - IDMAC Band Mode Enable 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_BNDM_EN_2 - IDMAC Band Mode Enable 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_bndm_en_2
{
    uint32_t U;
    struct _hw_ipu_idmac_bndm_en_2_bitfields
    {
        uint32_t RESERVED0 : 13;       /*!< [12:0]  */
        uint32_t IDMAC_BNDM_EN_45 : 1; /*!< [13]  */
        uint32_t IDMAC_BNDM_EN_46 : 1; /*!< [14]  */
        uint32_t IDMAC_BNDM_EN_47 : 1; /*!< [15]  */
        uint32_t IDMAC_BNDM_EN_48 : 1; /*!< [16]  */
        uint32_t IDMAC_BNDM_EN_49 : 1; /*!< [17]  */
        uint32_t IDMAC_BNDM_EN_50 : 1; /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_ipu_idmac_bndm_en_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_BNDM_EN_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_BNDM_EN_2_ADDR(x) ((uintptr_t)(x) + 0x8044U)

#define HW_IPU_IDMAC_BNDM_EN_2(x) (*(__IO hw_ipu_idmac_bndm_en_2_t *) HW_IPU_IDMAC_BNDM_EN_2_ADDR(x))
#define HW_IPU_IDMAC_BNDM_EN_2_RD(x) (HW_IPU_IDMAC_BNDM_EN_2(x).U)
#define HW_IPU_IDMAC_BNDM_EN_2_WR(x, v) (HW_IPU_IDMAC_BNDM_EN_2(x).U = (v))
#define HW_IPU_IDMAC_BNDM_EN_2_SET(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, HW_IPU_IDMAC_BNDM_EN_2_RD(x) |  (v)))
#define HW_IPU_IDMAC_BNDM_EN_2_CLR(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~(v)))
#define HW_IPU_IDMAC_BNDM_EN_2_TOG(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, HW_IPU_IDMAC_BNDM_EN_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_BNDM_EN_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_45[13] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45 (13U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45 (0x00002000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_45)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45)

/*! @brief Set the IDMAC_BNDM_EN_45 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_45(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_46[14] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46 (14U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46 (0x00004000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_46)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46)

/*! @brief Set the IDMAC_BNDM_EN_46 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_46(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_47[15] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47 (15U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47 (0x00008000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_47)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47)

/*! @brief Set the IDMAC_BNDM_EN_47 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_47(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_48[16] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48 (16U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48 (0x00010000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_48)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48)

/*! @brief Set the IDMAC_BNDM_EN_48 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_48(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_49[17] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49 (17U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49 (0x00020000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_49)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49)

/*! @brief Set the IDMAC_BNDM_EN_49 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_49(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_BNDM_EN_2, field IDMAC_BNDM_EN_50[18] (RW)
 *
 * IDMAC Band Mode Enable bit [i] This bit controls if the channel currently
 * works in band mode. When alternate flow is running via this channel, both the
 * main flow and the alternate flow should have the same band mode configuration.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not in band mode
 * - 1 - IDMAC channel [i] is in band mode
 */
/*@{*/
#define BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50 (18U) /*!< Bit position for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50. */
#define BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50 (0x00040000U) /*!< Bit mask for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50. */
#define BS_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50 (1U) /*!< Bit field size in bits for IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50. */

/*! @brief Read current value of the IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50 field. */
#define BR_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50(x) (HW_IPU_IDMAC_BNDM_EN_2(x).B.IDMAC_BNDM_EN_50)

/*! @brief Format value for bitfield IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50. */
#define BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50) & BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50)

/*! @brief Set the IDMAC_BNDM_EN_50 field to a new value. */
#define BW_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50(x, v) (HW_IPU_IDMAC_BNDM_EN_2_WR(x, (HW_IPU_IDMAC_BNDM_EN_2_RD(x) & ~BM_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50) | BF_IPU_IDMAC_BNDM_EN_2_IDMAC_BNDM_EN_50(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SC_CORD - IDMAC Scroll Coordinations Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SC_CORD - IDMAC Scroll Coordinations Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sc_cord
{
    uint32_t U;
    struct _hw_ipu_idmac_sc_cord_bitfields
    {
        uint32_t SY0 : 11;             /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t SX0 : 12;             /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_idmac_sc_cord_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SC_CORD register
 */
/*@{*/
#define HW_IPU_IDMAC_SC_CORD_ADDR(x) ((uintptr_t)(x) + 0x8048U)

#define HW_IPU_IDMAC_SC_CORD(x)  (*(__IO hw_ipu_idmac_sc_cord_t *) HW_IPU_IDMAC_SC_CORD_ADDR(x))
#define HW_IPU_IDMAC_SC_CORD_RD(x) (HW_IPU_IDMAC_SC_CORD(x).U)
#define HW_IPU_IDMAC_SC_CORD_WR(x, v) (HW_IPU_IDMAC_SC_CORD(x).U = (v))
#define HW_IPU_IDMAC_SC_CORD_SET(x, v) (HW_IPU_IDMAC_SC_CORD_WR(x, HW_IPU_IDMAC_SC_CORD_RD(x) |  (v)))
#define HW_IPU_IDMAC_SC_CORD_CLR(x, v) (HW_IPU_IDMAC_SC_CORD_WR(x, HW_IPU_IDMAC_SC_CORD_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SC_CORD_TOG(x, v) (HW_IPU_IDMAC_SC_CORD_WR(x, HW_IPU_IDMAC_SC_CORD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SC_CORD bitfields
 */

/*!
 * @name Register IPU_IDMAC_SC_CORD, field SY0[10:0] (RW)
 *
 * Scroll Y coordination This field indicates the Y coordinate of the scroll.
 * This parameter has an affect on continuos scroll mode only. Units are pixels.
 * When the alpha buffer resides in a separate buffer and the alpha is different
 * than 8 BPP this field should be 0.
 */
/*@{*/
#define BP_IPU_IDMAC_SC_CORD_SY0 (0U)      /*!< Bit position for IPU_IDMAC_SC_CORD_SY0. */
#define BM_IPU_IDMAC_SC_CORD_SY0 (0x000007FFU) /*!< Bit mask for IPU_IDMAC_SC_CORD_SY0. */
#define BS_IPU_IDMAC_SC_CORD_SY0 (11U)     /*!< Bit field size in bits for IPU_IDMAC_SC_CORD_SY0. */

/*! @brief Read current value of the IPU_IDMAC_SC_CORD_SY0 field. */
#define BR_IPU_IDMAC_SC_CORD_SY0(x) (HW_IPU_IDMAC_SC_CORD(x).B.SY0)

/*! @brief Format value for bitfield IPU_IDMAC_SC_CORD_SY0. */
#define BF_IPU_IDMAC_SC_CORD_SY0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SC_CORD_SY0) & BM_IPU_IDMAC_SC_CORD_SY0)

/*! @brief Set the SY0 field to a new value. */
#define BW_IPU_IDMAC_SC_CORD_SY0(x, v) (HW_IPU_IDMAC_SC_CORD_WR(x, (HW_IPU_IDMAC_SC_CORD_RD(x) & ~BM_IPU_IDMAC_SC_CORD_SY0) | BF_IPU_IDMAC_SC_CORD_SY0(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SC_CORD, field SX0[27:16] (RW)
 *
 * Scroll X coordination This field indicates the X coordinate of the scroll.
 * This parameter has an affect on continuos scroll mode only. Units are pixels.
 * When the alpha buffer resides in a separate buffer and the alpha is different
 * than 8 BPP this field should be 0.
 */
/*@{*/
#define BP_IPU_IDMAC_SC_CORD_SX0 (16U)     /*!< Bit position for IPU_IDMAC_SC_CORD_SX0. */
#define BM_IPU_IDMAC_SC_CORD_SX0 (0x0FFF0000U) /*!< Bit mask for IPU_IDMAC_SC_CORD_SX0. */
#define BS_IPU_IDMAC_SC_CORD_SX0 (12U)     /*!< Bit field size in bits for IPU_IDMAC_SC_CORD_SX0. */

/*! @brief Read current value of the IPU_IDMAC_SC_CORD_SX0 field. */
#define BR_IPU_IDMAC_SC_CORD_SX0(x) (HW_IPU_IDMAC_SC_CORD(x).B.SX0)

/*! @brief Format value for bitfield IPU_IDMAC_SC_CORD_SX0. */
#define BF_IPU_IDMAC_SC_CORD_SX0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SC_CORD_SX0) & BM_IPU_IDMAC_SC_CORD_SX0)

/*! @brief Set the SX0 field to a new value. */
#define BW_IPU_IDMAC_SC_CORD_SX0(x, v) (HW_IPU_IDMAC_SC_CORD_WR(x, (HW_IPU_IDMAC_SC_CORD_RD(x) & ~BM_IPU_IDMAC_SC_CORD_SX0) | BF_IPU_IDMAC_SC_CORD_SX0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_SC_CORD_1 - IDMAC Scroll Coordinations Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_SC_CORD_1 - IDMAC Scroll Coordinations Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_sc_cord_1
{
    uint32_t U;
    struct _hw_ipu_idmac_sc_cord_1_bitfields
    {
        uint32_t SY1 : 11;             /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t SX1 : 12;             /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_idmac_sc_cord_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_SC_CORD_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_SC_CORD_1_ADDR(x) ((uintptr_t)(x) + 0x804CU)

#define HW_IPU_IDMAC_SC_CORD_1(x) (*(__IO hw_ipu_idmac_sc_cord_1_t *) HW_IPU_IDMAC_SC_CORD_1_ADDR(x))
#define HW_IPU_IDMAC_SC_CORD_1_RD(x) (HW_IPU_IDMAC_SC_CORD_1(x).U)
#define HW_IPU_IDMAC_SC_CORD_1_WR(x, v) (HW_IPU_IDMAC_SC_CORD_1(x).U = (v))
#define HW_IPU_IDMAC_SC_CORD_1_SET(x, v) (HW_IPU_IDMAC_SC_CORD_1_WR(x, HW_IPU_IDMAC_SC_CORD_1_RD(x) |  (v)))
#define HW_IPU_IDMAC_SC_CORD_1_CLR(x, v) (HW_IPU_IDMAC_SC_CORD_1_WR(x, HW_IPU_IDMAC_SC_CORD_1_RD(x) & ~(v)))
#define HW_IPU_IDMAC_SC_CORD_1_TOG(x, v) (HW_IPU_IDMAC_SC_CORD_1_WR(x, HW_IPU_IDMAC_SC_CORD_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_SC_CORD_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_SC_CORD_1, field SY1[10:0] (RW)
 *
 * Scroll Y coordination (2nd set) This field indicates the Y coordinate of the
 * scroll. This parameter has an affect on continuos scroll mode only. Units are
 * pixels. When the alpha buffer resides in a separate buffer and the alpha is
 * different than 8 BPP this field should be 0.
 */
/*@{*/
#define BP_IPU_IDMAC_SC_CORD_1_SY1 (0U)    /*!< Bit position for IPU_IDMAC_SC_CORD_1_SY1. */
#define BM_IPU_IDMAC_SC_CORD_1_SY1 (0x000007FFU) /*!< Bit mask for IPU_IDMAC_SC_CORD_1_SY1. */
#define BS_IPU_IDMAC_SC_CORD_1_SY1 (11U)   /*!< Bit field size in bits for IPU_IDMAC_SC_CORD_1_SY1. */

/*! @brief Read current value of the IPU_IDMAC_SC_CORD_1_SY1 field. */
#define BR_IPU_IDMAC_SC_CORD_1_SY1(x) (HW_IPU_IDMAC_SC_CORD_1(x).B.SY1)

/*! @brief Format value for bitfield IPU_IDMAC_SC_CORD_1_SY1. */
#define BF_IPU_IDMAC_SC_CORD_1_SY1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SC_CORD_1_SY1) & BM_IPU_IDMAC_SC_CORD_1_SY1)

/*! @brief Set the SY1 field to a new value. */
#define BW_IPU_IDMAC_SC_CORD_1_SY1(x, v) (HW_IPU_IDMAC_SC_CORD_1_WR(x, (HW_IPU_IDMAC_SC_CORD_1_RD(x) & ~BM_IPU_IDMAC_SC_CORD_1_SY1) | BF_IPU_IDMAC_SC_CORD_1_SY1(v)))
/*@}*/

/*!
 * @name Register IPU_IDMAC_SC_CORD_1, field SX1[27:16] (RW)
 *
 * Scroll X coordination (2nd set) This field indicates the X coordinate of the
 * scroll. This parameter has an affect on continuos scroll mode only. Units are
 * pixels. When the alpha buffer resides in a separate buffer and the alpha is
 * different than 8 BPP this field should be 0.
 */
/*@{*/
#define BP_IPU_IDMAC_SC_CORD_1_SX1 (16U)   /*!< Bit position for IPU_IDMAC_SC_CORD_1_SX1. */
#define BM_IPU_IDMAC_SC_CORD_1_SX1 (0x0FFF0000U) /*!< Bit mask for IPU_IDMAC_SC_CORD_1_SX1. */
#define BS_IPU_IDMAC_SC_CORD_1_SX1 (12U)   /*!< Bit field size in bits for IPU_IDMAC_SC_CORD_1_SX1. */

/*! @brief Read current value of the IPU_IDMAC_SC_CORD_1_SX1 field. */
#define BR_IPU_IDMAC_SC_CORD_1_SX1(x) (HW_IPU_IDMAC_SC_CORD_1(x).B.SX1)

/*! @brief Format value for bitfield IPU_IDMAC_SC_CORD_1_SX1. */
#define BF_IPU_IDMAC_SC_CORD_1_SX1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IDMAC_SC_CORD_1_SX1) & BM_IPU_IDMAC_SC_CORD_1_SX1)

/*! @brief Set the SX1 field to a new value. */
#define BW_IPU_IDMAC_SC_CORD_1_SX1(x, v) (HW_IPU_IDMAC_SC_CORD_1_WR(x, (HW_IPU_IDMAC_SC_CORD_1_RD(x) & ~BM_IPU_IDMAC_SC_CORD_1_SX1) | BF_IPU_IDMAC_SC_CORD_1_SX1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_BUSY_1 - IDMAC Channel Busy 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_BUSY_1 - IDMAC Channel Busy 1 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_busy_1
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_busy_1_bitfields
    {
        uint32_t IDMAC_CH_BUSY_0 : 1;  /*!< [0]  */
        uint32_t IDMAC_CH_BUSY_1 : 1;  /*!< [1]  */
        uint32_t IDMAC_CH_BUSY_2 : 1;  /*!< [2]  */
        uint32_t IDMAC_CH_BUSY_3 : 1;  /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t IDMAC_CH_BUSY_5 : 1;  /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t IDMAC_CH_BUSY_8 : 1;  /*!< [8]  */
        uint32_t IDMAC_CH_BUSY_9 : 1;  /*!< [9]  */
        uint32_t IDMAC_CH_BUSY_10 : 1; /*!< [10]  */
        uint32_t IDMAC_CH_BUSY_11 : 1; /*!< [11]  */
        uint32_t IDMAC_CH_BUSY_12 : 1; /*!< [12]  */
        uint32_t IDMAC_CH_BUSY_13 : 1; /*!< [13]  */
        uint32_t IDMAC_CH_BUSY_14 : 1; /*!< [14]  */
        uint32_t IDMAC_CH_BUSY_15 : 1; /*!< [15]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t IDMAC_CH_BUSY_17 : 1; /*!< [17]  */
        uint32_t IDMAC_CH_BUSY_18 : 1; /*!< [18]  */
        uint32_t RESERVED3 : 1;        /*!< [19]  */
        uint32_t IDMAC_CH_BUSY_20 : 1; /*!< [20]  */
        uint32_t IDMAC_CH_BUSY_21 : 1; /*!< [21]  */
        uint32_t IDMAC_CH_BUSY_22 : 1; /*!< [22]  */
        uint32_t IDMAC_CH_BUSY_23 : 1; /*!< [23]  */
        uint32_t IDMAC_CH_BUSY_24 : 1; /*!< [24]  */
        uint32_t IDMAC_CH_BUSY_25 : 1; /*!< [25]  */
        uint32_t IDMAC_CH_BUSY_26 : 1; /*!< [26]  */
        uint32_t IDMAC_CH_BUSY_27 : 1; /*!< [27]  */
        uint32_t IDMAC_CH_BUSY_28 : 1; /*!< [28]  */
        uint32_t IDMAC_CH_BUSY_29 : 1; /*!< [29]  */
        uint32_t RESERVED4 : 1;        /*!< [30]  */
        uint32_t IDMAC_CH_BUSY_ : 1;   /*!< [31]  */
    } B;
} hw_ipu_idmac_ch_busy_1_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_BUSY_1 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_BUSY_1_ADDR(x) ((uintptr_t)(x) + 0x8100U)

#define HW_IPU_IDMAC_CH_BUSY_1(x) (*(__I hw_ipu_idmac_ch_busy_1_t *) HW_IPU_IDMAC_CH_BUSY_1_ADDR(x))
#define HW_IPU_IDMAC_CH_BUSY_1_RD(x) (HW_IPU_IDMAC_CH_BUSY_1(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_BUSY_1 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_0[0] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0 (0U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0 (0x00000001U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_0(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_0)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_1[1] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1 (1U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1 (0x00000002U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_1(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_1)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_2[2] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2 (2U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2 (0x00000004U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_2(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_2)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_3[3] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3 (3U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3 (0x00000008U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_3(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_3)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_5[5] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5 (5U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5 (0x00000020U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_5(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_5)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_8[8] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8 (8U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_8(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_8)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_9[9] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9 (9U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_9(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_9)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_10[10] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10 (10U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_10(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_10)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_11[11] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11 (11U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_11(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_11)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_12[12] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12 (12U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_12(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_12)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_13[13] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13 (13U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_13(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_13)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_14[14] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14 (14U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_14(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_14)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_15[15] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15 (15U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_15(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_15)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_17[17] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17 (17U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17 (0x00020000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_17(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_17)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_18[18] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18 (18U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18 (0x00040000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_18(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_18)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_20[20] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20 (20U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20 (0x00100000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_20(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_20)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_21[21] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21 (21U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21 (0x00200000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_21(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_21)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_22[22] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22 (22U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22 (0x00400000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_22(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_22)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_23[23] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23 (23U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23 (0x00800000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_23(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_23)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_24[24] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24 (24U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24 (0x01000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_24(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_24)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_25[25] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25 (25U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25 (0x02000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_25(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_25)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_26[26] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26 (26U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26 (0x04000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_26(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_26)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_27[27] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27 (27U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27 (0x08000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_27(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_27)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_28[28] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28 (28U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28 (0x10000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_28(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_28)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_29[29] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29 (29U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29 (0x20000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29 field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_29(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_29)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_1, field IDMAC_CH_BUSY_[31] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_ (31U) /*!< Bit position for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_. */
#define BM_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_ (0x80000000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_. */
#define BS_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_ (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_ field. */
#define BR_IPU_IDMAC_CH_BUSY_1_IDMAC_CH_BUSY_(x) (HW_IPU_IDMAC_CH_BUSY_1(x).B.IDMAC_CH_BUSY_)
/*@}*/

/*******************************************************************************
 * HW_IPU_IDMAC_CH_BUSY_2 - IDMAC Channel Busy 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IDMAC_CH_BUSY_2 - IDMAC Channel Busy 2 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_idmac_ch_busy_2
{
    uint32_t U;
    struct _hw_ipu_idmac_ch_busy_2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t IDMAC_CH_BUSY_33 : 1; /*!< [1]  */
        uint32_t RESERVED1 : 6;        /*!< [7:2]  */
        uint32_t IDMAC_CH_BUSY_40 : 1; /*!< [8]  */
        uint32_t IDMAC_CH_BUSY_41 : 1; /*!< [9]  */
        uint32_t IDMAC_CH_BUSY_42 : 1; /*!< [10]  */
        uint32_t IDMAC_CH_BUSY_43 : 1; /*!< [11]  */
        uint32_t IDMAC_CH_BUSY_44 : 1; /*!< [12]  */
        uint32_t IDMAC_CH_BUSY_45 : 1; /*!< [13]  */
        uint32_t IDMAC_CH_BUSY_46 : 1; /*!< [14]  */
        uint32_t IDMAC_CH_BUSY_47 : 1; /*!< [15]  */
        uint32_t IDMAC_CH_BUSY_48 : 1; /*!< [16]  */
        uint32_t IDMAC_CH_BUSY_49 : 1; /*!< [17]  */
        uint32_t IDMAC_CH_BUSY_50 : 1; /*!< [18]  */
        uint32_t IDMAC_CH_BUSY_51 : 1; /*!< [19]  */
        uint32_t IDMAC_CH_BUSY_52 : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_ipu_idmac_ch_busy_2_t;

/*!
 * @name Constants and macros for entire IPU_IDMAC_CH_BUSY_2 register
 */
/*@{*/
#define HW_IPU_IDMAC_CH_BUSY_2_ADDR(x) ((uintptr_t)(x) + 0x8104U)

#define HW_IPU_IDMAC_CH_BUSY_2(x) (*(__I hw_ipu_idmac_ch_busy_2_t *) HW_IPU_IDMAC_CH_BUSY_2_ADDR(x))
#define HW_IPU_IDMAC_CH_BUSY_2_RD(x) (HW_IPU_IDMAC_CH_BUSY_2(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_IDMAC_CH_BUSY_2 bitfields
 */

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_33[1] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33 (1U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33 (0x00000002U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_33(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_33)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_40[8] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40 (8U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40 (0x00000100U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_40(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_40)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_41[9] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41 (9U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41 (0x00000200U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_41(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_41)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_42[10] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42 (10U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42 (0x00000400U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_42(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_42)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_43[11] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43 (11U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43 (0x00000800U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_43(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_43)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_44[12] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44 (12U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44 (0x00001000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_44(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_44)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_45[13] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45 (13U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45 (0x00002000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_45(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_45)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_46[14] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46 (14U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46 (0x00004000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_46(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_46)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_47[15] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47 (15U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47 (0x00008000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_47(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_47)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_48[16] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48 (16U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48 (0x00010000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_48(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_48)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_49[17] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49 (17U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49 (0x00020000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_49(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_49)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_50[18] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50 (18U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50 (0x00040000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_50(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_50)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_51[19] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51 (19U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51 (0x00080000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_51(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_51)
/*@}*/

/*!
 * @name Register IPU_IDMAC_CH_BUSY_2, field IDMAC_CH_BUSY_52[20] (RO)
 *
 * IDMAC Channel busy bit [i] This bit indicates if the channel is currently
 * served by the IDMAC. This bit is self cleared by the IDMAC.
 *
 * Values:
 * - 0 - IDMAC channel [i] is not busy
 * - 1 - IDMAC channel [i] is busy
 */
/*@{*/
#define BP_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52 (20U) /*!< Bit position for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52. */
#define BM_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52 (0x00100000U) /*!< Bit mask for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52. */
#define BS_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52 (1U) /*!< Bit field size in bits for IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52. */

/*! @brief Read current value of the IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52 field. */
#define BR_IPU_IDMAC_CH_BUSY_2_IDMAC_CH_BUSY_52(x) (HW_IPU_IDMAC_CH_BUSY_2(x).B.IDMAC_CH_BUSY_52)
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_COM_CONF_SYNC - DP Common Configuration Sync Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_COM_CONF_SYNC - DP Common Configuration Sync Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_com_conf_sync
{
    uint32_t U;
    struct _hw_ipu_dp_com_conf_sync_bitfields
    {
        uint32_t DP_FG_EN_SYNC : 1;    /*!< [0]  */
        uint32_t DP_GWSEL_SYNC : 1;    /*!< [1]  */
        uint32_t DP_GWAM_SYNC : 1;     /*!< [2]  */
        uint32_t DP_GWCKE_SYNC : 1;    /*!< [3]  */
        uint32_t DP_COC_SYNC : 3;      /*!< [6:4]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t DP_CSC_DEF_SYNC : 2;  /*!< [9:8]  */
        uint32_t DP_CSC_GAMUT_SAT_EN_SYNC : 1; /*!< [10]  */
        uint32_t DP_CSC_YUV_SAT_MODE_SYNC : 1; /*!< [11]  */
        uint32_t DP_GAMMA_EN_SYNC : 1; /*!< [12]  */
        uint32_t DP_GAMMA_YUV_EN_SYNC : 1; /*!< [13]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_dp_com_conf_sync_t;

/*!
 * @name Constants and macros for entire IPU_DP_COM_CONF_SYNC register
 */
/*@{*/
#define HW_IPU_DP_COM_CONF_SYNC_ADDR(x) ((uintptr_t)(x) + 0x18000U)

#define HW_IPU_DP_COM_CONF_SYNC(x) (*(__IO hw_ipu_dp_com_conf_sync_t *) HW_IPU_DP_COM_CONF_SYNC_ADDR(x))
#define HW_IPU_DP_COM_CONF_SYNC_RD(x) (HW_IPU_DP_COM_CONF_SYNC(x).U)
#define HW_IPU_DP_COM_CONF_SYNC_WR(x, v) (HW_IPU_DP_COM_CONF_SYNC(x).U = (v))
#define HW_IPU_DP_COM_CONF_SYNC_SET(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, HW_IPU_DP_COM_CONF_SYNC_RD(x) |  (v)))
#define HW_IPU_DP_COM_CONF_SYNC_CLR(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~(v)))
#define HW_IPU_DP_COM_CONF_SYNC_TOG(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, HW_IPU_DP_COM_CONF_SYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_COM_CONF_SYNC bitfields
 */

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_FG_EN_SYNC[0] (RW)
 *
 * FG_EN - partial plane Enable. This bit enables the partial plane channel.
 *
 * Values:
 * - 1 - partial plane channel is enabled.
 * - 0 - partial plane channel is disabled.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC (0U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC (0x00000001U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_FG_EN_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC)

/*! @brief Set the DP_FG_EN_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_FG_EN_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_GWSEL_SYNC[1] (RW)
 *
 * GWSEL - Graphic Window Select Select graphic window to be on partial plane or
 * full plane.
 *
 * Values:
 * - 1 - Graphic window is partial plane.
 * - 0 - Graphic window is full plane.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC (1U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC (0x00000002U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_GWSEL_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC)

/*! @brief Set the DP_GWSEL_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_GWSEL_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_GWAM_SYNC[2] (RW)
 *
 * GWAM - Graphic Window Alpha Mode Select the use of Alpha to be global or
 * local.
 *
 * Values:
 * - 1 - Global Alpha.
 * - 0 - Local Alpha.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC (2U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC (0x00000004U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_GWAM_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC)

/*! @brief Set the DP_GWAM_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_GWAM_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_GWCKE_SYNC[3] (RW)
 *
 * GWCKE - Graphic Window Color Keying Enable Enable or disable graphic window
 * color keying.
 *
 * Values:
 * - 1 - Enable color keying of graphic window
 * - 0 - Disable color keying of graphic window
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC (3U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC (0x00000008U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_GWCKE_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC)

/*! @brief Set the DP_GWCKE_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_GWCKE_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_COC_SYNC[6:4] (RW)
 *
 * COC - Cursor Operation Control Controls the format of the cursor and the type
 * of arithmetic operations
 *
 * Values:
 * - 000 - Transparent, cursor is disabled.
 * - 001 - Full cursor.
 * - 010 - Reversed cursor.
 * - 011 - AND between full plane and cursor.
 * - 100 - Reserved
 * - 101 - OR between full plane and cursor.
 * - 110 - XOR between full plane and cursor.
 * - 111 - Reserved.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC (4U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_COC_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC (0x00000070U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_COC_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC (3U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_COC_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_COC_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_COC_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_COC_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC)

/*! @brief Set the DP_COC_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_COC_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_CSC_DEF_SYNC[9:8] (RW)
 *
 * CSC_DEF Enable or disable Color Space Conversion.
 *
 * Values:
 * - 00 - CSC disable
 * - 01 - CSC enable after combining
 * - 10 - CSC enable before combining on BG channel
 * - 11 - CSC enable before combining on FG channel
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC (8U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC (0x00000300U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC (2U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_CSC_DEF_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC)

/*! @brief Set the DP_CSC_DEF_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_CSC_DEF_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_CSC_GAMUT_SAT_EN_SYNC[10] (RW)
 *
 * CSC_GAMUT_SAT_EN Indicate if GAMUT saturation is enabled
 *
 * Values:
 * - 0 - disable GAMUT mapping
 * - 1 - enable GAMUT mapping
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC (10U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC (0x00000400U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_CSC_GAMUT_SAT_EN_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC)

/*! @brief Set the DP_CSC_GAMUT_SAT_EN_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_CSC_GAMUT_SAT_EN_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_CSC_YUV_SAT_MODE_SYNC[11] (RW)
 *
 * CSC_YUV_SAT_MODE YUV saturation mode for color space conversion
 *
 * Values:
 * - 0 - Y/U/V range 0 -255
 * - 1 - Y range 16-235, U/V range 16-240
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC (11U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC (0x00000800U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_CSC_YUV_SAT_MODE_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC)

/*! @brief Set the DP_CSC_YUV_SAT_MODE_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_CSC_YUV_SAT_MODE_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_GAMMA_EN_SYNC[12] (RW)
 *
 * GAMMA_EN - Gamma correction block enable bit
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC (12U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC (0x00001000U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_GAMMA_EN_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC)

/*! @brief Set the DP_GAMMA_EN_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_GAMMA_EN_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_SYNC, field DP_GAMMA_YUV_EN_SYNC[13] (RW)
 *
 * GAMMA's YUV mode enable for sync flow
 *
 * Values:
 * - 0 - YUV mode is OFF.
 * - 1 - YUV mode is ON.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC (13U) /*!< Bit position for IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC. */
#define BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC (0x00002000U) /*!< Bit mask for IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC. */
#define BS_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC. */

/*! @brief Read current value of the IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC field. */
#define BR_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC(x) (HW_IPU_DP_COM_CONF_SYNC(x).B.DP_GAMMA_YUV_EN_SYNC)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC. */
#define BF_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC) & BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC)

/*! @brief Set the DP_GAMMA_YUV_EN_SYNC field to a new value. */
#define BW_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC(x, v) (HW_IPU_DP_COM_CONF_SYNC_WR(x, (HW_IPU_DP_COM_CONF_SYNC_RD(x) & ~BM_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC) | BF_IPU_DP_COM_CONF_SYNC_DP_GAMMA_YUV_EN_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_Graph_Wind_CTRL_SYNC - DP Graphic Window Control Sync Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_Graph_Wind_CTRL_SYNC - DP Graphic Window Control Sync Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_graph_wind_ctrl_sync
{
    uint32_t U;
    struct _hw_ipu_dp_graph_wind_ctrl_sync_bitfields
    {
        uint32_t DP_GWCKB_SYNC : 8;    /*!< [7:0]  */
        uint32_t DP_GWCKG_SYNC : 8;    /*!< [15:8]  */
        uint32_t DP_GWCKR_SYNC : 8;    /*!< [23:16]  */
        uint32_t DP_GWAV_SYNC : 8;     /*!< [31:24]  */
    } B;
} hw_ipu_dp_graph_wind_ctrl_sync_t;

/*!
 * @name Constants and macros for entire IPU_DP_Graph_Wind_CTRL_SYNC register
 */
/*@{*/
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_ADDR(x) ((uintptr_t)(x) + 0x18004U)

#define HW_IPU_DP_Graph_Wind_CTRL_SYNC(x) (*(__IO hw_ipu_dp_graph_wind_ctrl_sync_t *) HW_IPU_DP_Graph_Wind_CTRL_SYNC_ADDR(x))
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).U)
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).U = (v))
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_SET(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) |  (v)))
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_CLR(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) & ~(v)))
#define HW_IPU_DP_Graph_Wind_CTRL_SYNC_TOG(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_Graph_Wind_CTRL_SYNC bitfields
 */

/*!
 * @name Register IPU_DP_Graph_Wind_CTRL_SYNC, field DP_GWCKB_SYNC[7:0] (RW)
 *
 * GWCKB - Graphic Window Color Keying Blue Component Defines the blue component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No blue
 * - 11111111 - Full blue
 */
/*@{*/
#define BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC (0U) /*!< Bit position for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC. */
#define BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC (0x000000FFU) /*!< Bit mask for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC. */
#define BS_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC (8U) /*!< Bit field size in bits for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC. */

/*! @brief Read current value of the IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC field. */
#define BR_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC(x) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).B.DP_GWCKB_SYNC)

/*! @brief Format value for bitfield IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC. */
#define BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC) & BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC)

/*! @brief Set the DP_GWCKB_SYNC field to a new value. */
#define BW_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, (HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) & ~BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC) | BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKB_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_Graph_Wind_CTRL_SYNC, field DP_GWCKG_SYNC[15:8] (RW)
 *
 * GWCKG - Graphic Window Color Keying Green Component Defines the green
 * component of graphic window color keying.
 *
 * Values:
 * - 00000000 - No Green
 * - 11111111 - Full Green
 */
/*@{*/
#define BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC (8U) /*!< Bit position for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC. */
#define BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC (0x0000FF00U) /*!< Bit mask for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC. */
#define BS_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC (8U) /*!< Bit field size in bits for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC. */

/*! @brief Read current value of the IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC field. */
#define BR_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC(x) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).B.DP_GWCKG_SYNC)

/*! @brief Format value for bitfield IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC. */
#define BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC) & BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC)

/*! @brief Set the DP_GWCKG_SYNC field to a new value. */
#define BW_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, (HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) & ~BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC) | BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKG_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_Graph_Wind_CTRL_SYNC, field DP_GWCKR_SYNC[23:16] (RW)
 *
 * GWCKR - Graphic Window Color Keying Red Component Defines the red component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No red
 * - 11111111 - Full red
 */
/*@{*/
#define BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC (16U) /*!< Bit position for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC. */
#define BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC (0x00FF0000U) /*!< Bit mask for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC. */
#define BS_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC (8U) /*!< Bit field size in bits for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC. */

/*! @brief Read current value of the IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC field. */
#define BR_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC(x) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).B.DP_GWCKR_SYNC)

/*! @brief Format value for bitfield IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC. */
#define BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC) & BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC)

/*! @brief Set the DP_GWCKR_SYNC field to a new value. */
#define BW_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, (HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) & ~BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC) | BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWCKR_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_Graph_Wind_CTRL_SYNC, field DP_GWAV_SYNC[31:24] (RW)
 *
 * GWAV - Graphic Window Alpha Value Defines the alpha value of graphic window
 * used for alpha blending between graphic window and full plane. The Value the
 * number that writing to GWAV register. The Actual Value the number, that insert
 * to calculation in Combining Module. If Value = < 0.5- 1/256 (01111111) then
 * Actual Value = Value. If Value >= 0.5 (10000000), then Actual Value = Value +
 * 1/256.
 *
 * Values:
 * - 00000000 - Actual value is 00000000; Graphic window totally opaque i.e.
 *     overlay on LCD screen
 * - 01111111 - Actual value is 01111111;
 * - 10000000 - Actual value is 10000001
 * - 10000001 - Actual value is 10000010
 * - 11111110 - Actual value is 11111111
 * - 11111111 - Actual value is 100000000;Graphic window totally transparent
 *     i.e. not displayed on LCD screen
 */
/*@{*/
#define BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC (24U) /*!< Bit position for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC. */
#define BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC (0xFF000000U) /*!< Bit mask for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC. */
#define BS_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC (8U) /*!< Bit field size in bits for IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC. */

/*! @brief Read current value of the IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC field. */
#define BR_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC(x) (HW_IPU_DP_Graph_Wind_CTRL_SYNC(x).B.DP_GWAV_SYNC)

/*! @brief Format value for bitfield IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC. */
#define BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC) & BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC)

/*! @brief Set the DP_GWAV_SYNC field to a new value. */
#define BW_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC(x, v) (HW_IPU_DP_Graph_Wind_CTRL_SYNC_WR(x, (HW_IPU_DP_Graph_Wind_CTRL_SYNC_RD(x) & ~BM_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC) | BF_IPU_DP_Graph_Wind_CTRL_SYNC_DP_GWAV_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_FG_POS_SYNC - DP Partial Plane Window Position Sync Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_FG_POS_SYNC - DP Partial Plane Window Position Sync Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The DP partial plane Window Position Register is used to determine the
 * starting position of the partial plane window relative to BG window position. This
 * Register is used for the synchronous flow only.
 */
typedef union _hw_ipu_dp_fg_pos_sync
{
    uint32_t U;
    struct _hw_ipu_dp_fg_pos_sync_bitfields
    {
        uint32_t DP_FGYP_SYNC : 11;    /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t DP_FGXP_SYNC : 11;    /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dp_fg_pos_sync_t;

/*!
 * @name Constants and macros for entire IPU_DP_FG_POS_SYNC register
 */
/*@{*/
#define HW_IPU_DP_FG_POS_SYNC_ADDR(x) ((uintptr_t)(x) + 0x18008U)

#define HW_IPU_DP_FG_POS_SYNC(x) (*(__IO hw_ipu_dp_fg_pos_sync_t *) HW_IPU_DP_FG_POS_SYNC_ADDR(x))
#define HW_IPU_DP_FG_POS_SYNC_RD(x) (HW_IPU_DP_FG_POS_SYNC(x).U)
#define HW_IPU_DP_FG_POS_SYNC_WR(x, v) (HW_IPU_DP_FG_POS_SYNC(x).U = (v))
#define HW_IPU_DP_FG_POS_SYNC_SET(x, v) (HW_IPU_DP_FG_POS_SYNC_WR(x, HW_IPU_DP_FG_POS_SYNC_RD(x) |  (v)))
#define HW_IPU_DP_FG_POS_SYNC_CLR(x, v) (HW_IPU_DP_FG_POS_SYNC_WR(x, HW_IPU_DP_FG_POS_SYNC_RD(x) & ~(v)))
#define HW_IPU_DP_FG_POS_SYNC_TOG(x, v) (HW_IPU_DP_FG_POS_SYNC_WR(x, HW_IPU_DP_FG_POS_SYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_FG_POS_SYNC bitfields
 */

/*!
 * @name Register IPU_DP_FG_POS_SYNC, field DP_FGYP_SYNC[10:0] (RW)
 *
 * FGYP partial plane window Y position partial plane Window Y Position -
 * Specifies the number of lines between the start of full plane windows Y position and
 * the beginning of the first data.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC (0U) /*!< Bit position for IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC. */
#define BM_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC (0x000007FFU) /*!< Bit mask for IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC. */
#define BS_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC. */

/*! @brief Read current value of the IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC field. */
#define BR_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC(x) (HW_IPU_DP_FG_POS_SYNC(x).B.DP_FGYP_SYNC)

/*! @brief Format value for bitfield IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC. */
#define BF_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC) & BM_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC)

/*! @brief Set the DP_FGYP_SYNC field to a new value. */
#define BW_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC(x, v) (HW_IPU_DP_FG_POS_SYNC_WR(x, (HW_IPU_DP_FG_POS_SYNC_RD(x) & ~BM_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC) | BF_IPU_DP_FG_POS_SYNC_DP_FGYP_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_FG_POS_SYNC, field DP_FGXP_SYNC[26:16] (RW)
 *
 * FGXP partial plane Window X Position. partial plane Window X Position -
 * Specifies the number of pixels between the start of full plane window X position
 * and the beginning of the first data of new line.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC (16U) /*!< Bit position for IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC. */
#define BM_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC (0x07FF0000U) /*!< Bit mask for IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC. */
#define BS_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC. */

/*! @brief Read current value of the IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC field. */
#define BR_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC(x) (HW_IPU_DP_FG_POS_SYNC(x).B.DP_FGXP_SYNC)

/*! @brief Format value for bitfield IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC. */
#define BF_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC) & BM_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC)

/*! @brief Set the DP_FGXP_SYNC field to a new value. */
#define BW_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC(x, v) (HW_IPU_DP_FG_POS_SYNC_WR(x, (HW_IPU_DP_FG_POS_SYNC_RD(x) & ~BM_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC) | BF_IPU_DP_FG_POS_SYNC_DP_FGXP_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_POS_SYNC - DP Cursor Position and Size Sync Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_POS_SYNC - DP Cursor Position and Size Sync Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Cursor Position Register is used to determine the starting position
 * of the cursor relative to BG windows position.
 */
typedef union _hw_ipu_dp_cur_pos_sync
{
    uint32_t U;
    struct _hw_ipu_dp_cur_pos_sync_bitfields
    {
        uint32_t DP_CXW_SYNC : 11;     /*!< [10:0]  */
        uint32_t DP_CXP_SYNC : 5;      /*!< [15:11]  */
        uint32_t DP_CYH_SYNC : 11;     /*!< [26:16]  */
        uint32_t DP_CYP_SYNC : 5;      /*!< [31:27]  */
    } B;
} hw_ipu_dp_cur_pos_sync_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_POS_SYNC register
 */
/*@{*/
#define HW_IPU_DP_CUR_POS_SYNC_ADDR(x) ((uintptr_t)(x) + 0x1800CU)

#define HW_IPU_DP_CUR_POS_SYNC(x) (*(__IO hw_ipu_dp_cur_pos_sync_t *) HW_IPU_DP_CUR_POS_SYNC_ADDR(x))
#define HW_IPU_DP_CUR_POS_SYNC_RD(x) (HW_IPU_DP_CUR_POS_SYNC(x).U)
#define HW_IPU_DP_CUR_POS_SYNC_WR(x, v) (HW_IPU_DP_CUR_POS_SYNC(x).U = (v))
#define HW_IPU_DP_CUR_POS_SYNC_SET(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, HW_IPU_DP_CUR_POS_SYNC_RD(x) |  (v)))
#define HW_IPU_DP_CUR_POS_SYNC_CLR(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, HW_IPU_DP_CUR_POS_SYNC_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_POS_SYNC_TOG(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, HW_IPU_DP_CUR_POS_SYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_POS_SYNC bitfields
 */

/*!
 * @name Register IPU_DP_CUR_POS_SYNC, field DP_CXW_SYNC[10:0] (RW)
 *
 * CXW - Cursor Width. Specifies the width of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC (0U) /*!< Bit position for IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC. */
#define BM_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC (0x000007FFU) /*!< Bit mask for IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC. */
#define BS_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC field. */
#define BR_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC(x) (HW_IPU_DP_CUR_POS_SYNC(x).B.DP_CXW_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC. */
#define BF_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC) & BM_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC)

/*! @brief Set the DP_CXW_SYNC field to a new value. */
#define BW_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, (HW_IPU_DP_CUR_POS_SYNC_RD(x) & ~BM_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC) | BF_IPU_DP_CUR_POS_SYNC_DP_CXW_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_SYNC, field DP_CXP_SYNC[15:11] (RW)
 *
 * CXP - Cursor X Position Represents the cursors horizontal starting position X
 * in pixel count (from 0 to CXW).
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC (11U) /*!< Bit position for IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC. */
#define BM_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC (0x0000F800U) /*!< Bit mask for IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC. */
#define BS_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC field. */
#define BR_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC(x) (HW_IPU_DP_CUR_POS_SYNC(x).B.DP_CXP_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC. */
#define BF_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC) & BM_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC)

/*! @brief Set the DP_CXP_SYNC field to a new value. */
#define BW_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, (HW_IPU_DP_CUR_POS_SYNC_RD(x) & ~BM_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC) | BF_IPU_DP_CUR_POS_SYNC_DP_CXP_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_SYNC, field DP_CYH_SYNC[26:16] (RW)
 *
 * CYH - Cursor Height Specifies the height of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC (16U) /*!< Bit position for IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC. */
#define BM_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC (0x07FF0000U) /*!< Bit mask for IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC. */
#define BS_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC field. */
#define BR_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC(x) (HW_IPU_DP_CUR_POS_SYNC(x).B.DP_CYH_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC. */
#define BF_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC) & BM_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC)

/*! @brief Set the DP_CYH_SYNC field to a new value. */
#define BW_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, (HW_IPU_DP_CUR_POS_SYNC_RD(x) & ~BM_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC) | BF_IPU_DP_CUR_POS_SYNC_DP_CYH_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_SYNC, field DP_CYP_SYNC[31:27] (RW)
 *
 * CYP - Cursor Y Position Represents the cursors vertical starting position Y
 * in pixel count (from 0 to CYH).Live View Resolution Mode.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC (27U) /*!< Bit position for IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC. */
#define BM_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC (0xF8000000U) /*!< Bit mask for IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC. */
#define BS_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC field. */
#define BR_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC(x) (HW_IPU_DP_CUR_POS_SYNC(x).B.DP_CYP_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC. */
#define BF_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC) & BM_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC)

/*! @brief Set the DP_CYP_SYNC field to a new value. */
#define BW_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC(x, v) (HW_IPU_DP_CUR_POS_SYNC_WR(x, (HW_IPU_DP_CUR_POS_SYNC_RD(x) & ~BM_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC) | BF_IPU_DP_CUR_POS_SYNC_DP_CYP_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_MAP_SYNC - DP Color Cursor Mapping Sync Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_MAP_SYNC - DP Color Cursor Mapping Sync Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Color Cursor Mapping Register defines the color of the cursor in
 * passive or TFT color modes.
 */
typedef union _hw_ipu_dp_cur_map_sync
{
    uint32_t U;
    struct _hw_ipu_dp_cur_map_sync_bitfields
    {
        uint32_t DP_CUR_COL_R_SYNC : 8; /*!< [7:0]  */
        uint32_t DP_CUR_COL_G_SYNC : 8; /*!< [15:8]  */
        uint32_t DP_CUR_COL_B_SYNC : 8; /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_dp_cur_map_sync_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_MAP_SYNC register
 */
/*@{*/
#define HW_IPU_DP_CUR_MAP_SYNC_ADDR(x) ((uintptr_t)(x) + 0x18010U)

#define HW_IPU_DP_CUR_MAP_SYNC(x) (*(__IO hw_ipu_dp_cur_map_sync_t *) HW_IPU_DP_CUR_MAP_SYNC_ADDR(x))
#define HW_IPU_DP_CUR_MAP_SYNC_RD(x) (HW_IPU_DP_CUR_MAP_SYNC(x).U)
#define HW_IPU_DP_CUR_MAP_SYNC_WR(x, v) (HW_IPU_DP_CUR_MAP_SYNC(x).U = (v))
#define HW_IPU_DP_CUR_MAP_SYNC_SET(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, HW_IPU_DP_CUR_MAP_SYNC_RD(x) |  (v)))
#define HW_IPU_DP_CUR_MAP_SYNC_CLR(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, HW_IPU_DP_CUR_MAP_SYNC_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_MAP_SYNC_TOG(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, HW_IPU_DP_CUR_MAP_SYNC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_MAP_SYNC bitfields
 */

/*!
 * @name Register IPU_DP_CUR_MAP_SYNC, field DP_CUR_COL_R_SYNC[7:0] (RW)
 *
 * CUR_COL_B - Cursor Red Field Defines the Red component of the cursor color in
 * color mode
 *
 * Values:
 * - 00000000 - No Red.
 * - 11111111 - Full Red.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC (0U) /*!< Bit position for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC. */
#define BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC (0x000000FFU) /*!< Bit mask for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC. */
#define BS_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC field. */
#define BR_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC(x) (HW_IPU_DP_CUR_MAP_SYNC(x).B.DP_CUR_COL_R_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC. */
#define BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC) & BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC)

/*! @brief Set the DP_CUR_COL_R_SYNC field to a new value. */
#define BW_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, (HW_IPU_DP_CUR_MAP_SYNC_RD(x) & ~BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC) | BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_R_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_SYNC, field DP_CUR_COL_G_SYNC[15:8] (RW)
 *
 * CUR_COL_G - Cursor Green Field Defines the Green component of the cursor
 * color in color mode
 *
 * Values:
 * - 00000000 - No Green.
 * - 11111111 - Full Green.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC (8U) /*!< Bit position for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC. */
#define BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC (0x0000FF00U) /*!< Bit mask for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC. */
#define BS_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC field. */
#define BR_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC(x) (HW_IPU_DP_CUR_MAP_SYNC(x).B.DP_CUR_COL_G_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC. */
#define BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC) & BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC)

/*! @brief Set the DP_CUR_COL_G_SYNC field to a new value. */
#define BW_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, (HW_IPU_DP_CUR_MAP_SYNC_RD(x) & ~BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC) | BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_G_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_SYNC, field DP_CUR_COL_B_SYNC[23:16] (RW)
 *
 * CUR_COL_B - Cursor Blue Field Defines the Blue component of the cursor color
 * in color mode
 *
 * Values:
 * - 00000000 - No Blue.
 * - 11111111 - Full Blue.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC (16U) /*!< Bit position for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC. */
#define BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC (0x00FF0000U) /*!< Bit mask for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC. */
#define BS_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC field. */
#define BR_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC(x) (HW_IPU_DP_CUR_MAP_SYNC(x).B.DP_CUR_COL_B_SYNC)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC. */
#define BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC) & BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC)

/*! @brief Set the DP_CUR_COL_B_SYNC field to a new value. */
#define BW_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC(x, v) (HW_IPU_DP_CUR_MAP_SYNC_WR(x, (HW_IPU_DP_CUR_MAP_SYNC_RD(x) & ~BM_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC) | BF_IPU_DP_CUR_MAP_SYNC_DP_CUR_COL_B_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_C_SYNC_i - DP Gamma Constants Sync Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_C_SYNC_i - DP Gamma Constants Sync Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains CONSTANTi parameters used for gamma correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_c_sync_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_c_sync_i_bitfields
    {
        uint32_t DP_GAMMA_C_SYNC_2i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t DP_GAMMA_C_SYNC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_dp_gamma_c_sync_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_C_SYNC_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_C_SYNC_i_ADDR(x) ((uintptr_t)(x) + 0x18014U)

#define HW_IPU_DP_GAMMA_C_SYNC_i(x) (*(__IO hw_ipu_dp_gamma_c_sync_i_t *) HW_IPU_DP_GAMMA_C_SYNC_i_ADDR(x))
#define HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) (HW_IPU_DP_GAMMA_C_SYNC_i(x).U)
#define HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i(x).U = (v))
#define HW_IPU_DP_GAMMA_C_SYNC_i_SET(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_C_SYNC_i_CLR(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_C_SYNC_i_TOG(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_C_SYNC_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_C_SYNC_i, field DP_GAMMA_C_SYNC_2i[8:0] (RW)
 *
 * CONSTANTi parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i (0U) /*!< Bit position for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i. */
#define BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i (0x000001FFU) /*!< Bit mask for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i. */
#define BS_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i (9U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i field. */
#define BR_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i(x) (HW_IPU_DP_GAMMA_C_SYNC_i(x).B.DP_GAMMA_C_SYNC_2i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i. */
#define BF_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i) & BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i)

/*! @brief Set the DP_GAMMA_C_SYNC_2i field to a new value. */
#define BW_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i) | BF_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_C_SYNC_i, field DP_GAMMA_C_SYNC_2i_1[24:16] (RW)
 *
 * CONSTANTi+1 parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1 (16U) /*!< Bit position for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1. */
#define BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1. */
#define BS_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1 (9U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1 field. */
#define BR_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1(x) (HW_IPU_DP_GAMMA_C_SYNC_i(x).B.DP_GAMMA_C_SYNC_2i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1. */
#define BF_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1) & BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1)

/*! @brief Set the DP_GAMMA_C_SYNC_2i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1(x, v) (HW_IPU_DP_GAMMA_C_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_C_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1) | BF_IPU_DP_GAMMA_C_SYNC_i_DP_GAMMA_C_SYNC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_S_SYNC_i - DP Gamma Correction Slope Sync Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_S_SYNC_i - DP Gamma Correction Slope Sync Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains SLOPEi parameters used for Gamma Correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_s_sync_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_s_sync_i_bitfields
    {
        uint32_t DP_GAMMA_S_SYNC_4i : 8; /*!< [7:0]  */
        uint32_t DP_GAMMA_S_SYNC_4i_1 : 8; /*!< [15:8]  */
        uint32_t DP_GAMMA_S_SYNC_4i_2 : 8; /*!< [23:16]  */
        uint32_t DP_GAMMA_S_SYNC_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dp_gamma_s_sync_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_S_SYNC_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_S_SYNC_i_ADDR(x) ((uintptr_t)(x) + 0x18034U)

#define HW_IPU_DP_GAMMA_S_SYNC_i(x) (*(__IO hw_ipu_dp_gamma_s_sync_i_t *) HW_IPU_DP_GAMMA_S_SYNC_i_ADDR(x))
#define HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) (HW_IPU_DP_GAMMA_S_SYNC_i(x).U)
#define HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i(x).U = (v))
#define HW_IPU_DP_GAMMA_S_SYNC_i_SET(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_S_SYNC_i_CLR(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_S_SYNC_i_TOG(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_S_SYNC_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_S_SYNC_i, field DP_GAMMA_S_SYNC_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i (0U) /*!< Bit position for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i. */
#define BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i (0x000000FFU) /*!< Bit mask for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i. */
#define BS_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i field. */
#define BR_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i(x) (HW_IPU_DP_GAMMA_S_SYNC_i(x).B.DP_GAMMA_S_SYNC_4i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i. */
#define BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i) & BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i)

/*! @brief Set the DP_GAMMA_S_SYNC_4i field to a new value. */
#define BW_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i) | BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_SYNC_i, field DP_GAMMA_S_SYNC_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1 (8U) /*!< Bit position for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1. */
#define BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1. */
#define BS_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1 field. */
#define BR_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1(x) (HW_IPU_DP_GAMMA_S_SYNC_i(x).B.DP_GAMMA_S_SYNC_4i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1. */
#define BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1) & BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1)

/*! @brief Set the DP_GAMMA_S_SYNC_4i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1) | BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_SYNC_i, field DP_GAMMA_S_SYNC_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2 (16U) /*!< Bit position for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2. */
#define BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2. */
#define BS_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2 field. */
#define BR_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2(x) (HW_IPU_DP_GAMMA_S_SYNC_i(x).B.DP_GAMMA_S_SYNC_4i_2)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2. */
#define BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2) & BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2)

/*! @brief Set the DP_GAMMA_S_SYNC_4i_2 field to a new value. */
#define BW_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2) | BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_SYNC_i, field DP_GAMMA_S_SYNC_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3 (24U) /*!< Bit position for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3. */
#define BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3 (0xFF000000U) /*!< Bit mask for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3. */
#define BS_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3 field. */
#define BR_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3(x) (HW_IPU_DP_GAMMA_S_SYNC_i(x).B.DP_GAMMA_S_SYNC_4i_3)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3. */
#define BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3) & BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3)

/*! @brief Set the DP_GAMMA_S_SYNC_4i_3 field to a new value. */
#define BW_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3(x, v) (HW_IPU_DP_GAMMA_S_SYNC_i_WR(x, (HW_IPU_DP_GAMMA_S_SYNC_i_RD(x) & ~BM_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3) | BF_IPU_DP_GAMMA_S_SYNC_i_DP_GAMMA_S_SYNC_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSCA_SYNC_i - DP Color Space Conversion Control Sync Flow Registers
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSCA_SYNC_i - DP Color Space Conversion Control Sync Flow Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csca_sync_i
{
    uint32_t U;
    struct _hw_ipu_dp_csca_sync_i_bitfields
    {
        uint32_t DP_CSC_A_SYNC_2i : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_A_SYNC_2i_1 : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_dp_csca_sync_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSCA_SYNC_i register
 */
/*@{*/
#define HW_IPU_DP_CSCA_SYNC_i_ADDR(x) ((uintptr_t)(x) + 0x18044U)

#define HW_IPU_DP_CSCA_SYNC_i(x) (*(__IO hw_ipu_dp_csca_sync_i_t *) HW_IPU_DP_CSCA_SYNC_i_ADDR(x))
#define HW_IPU_DP_CSCA_SYNC_i_RD(x) (HW_IPU_DP_CSCA_SYNC_i(x).U)
#define HW_IPU_DP_CSCA_SYNC_i_WR(x, v) (HW_IPU_DP_CSCA_SYNC_i(x).U = (v))
#define HW_IPU_DP_CSCA_SYNC_i_SET(x, v) (HW_IPU_DP_CSCA_SYNC_i_WR(x, HW_IPU_DP_CSCA_SYNC_i_RD(x) |  (v)))
#define HW_IPU_DP_CSCA_SYNC_i_CLR(x, v) (HW_IPU_DP_CSCA_SYNC_i_WR(x, HW_IPU_DP_CSCA_SYNC_i_RD(x) & ~(v)))
#define HW_IPU_DP_CSCA_SYNC_i_TOG(x, v) (HW_IPU_DP_CSCA_SYNC_i_WR(x, HW_IPU_DP_CSCA_SYNC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSCA_SYNC_i bitfields
 */

/*!
 * @name Register IPU_DP_CSCA_SYNC_i, field DP_CSC_A_SYNC_2i[9:0] (RW)
 *
 * A<2*i> parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i (0U) /*!< Bit position for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i. */
#define BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i (0x000003FFU) /*!< Bit mask for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i. */
#define BS_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i (10U) /*!< Bit field size in bits for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i. */

/*! @brief Read current value of the IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i field. */
#define BR_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i(x) (HW_IPU_DP_CSCA_SYNC_i(x).B.DP_CSC_A_SYNC_2i)

/*! @brief Format value for bitfield IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i. */
#define BF_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i) & BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i)

/*! @brief Set the DP_CSC_A_SYNC_2i field to a new value. */
#define BW_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i(x, v) (HW_IPU_DP_CSCA_SYNC_i_WR(x, (HW_IPU_DP_CSCA_SYNC_i_RD(x) & ~BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i) | BF_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSCA_SYNC_i, field DP_CSC_A_SYNC_2i_1[25:16] (RW)
 *
 * A<2*i+1> parameter of color conversion
 */
/*@{*/
#define BP_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1 (16U) /*!< Bit position for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1. */
#define BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1 (0x03FF0000U) /*!< Bit mask for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1. */
#define BS_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1 (10U) /*!< Bit field size in bits for IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1. */

/*! @brief Read current value of the IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1 field. */
#define BR_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1(x) (HW_IPU_DP_CSCA_SYNC_i(x).B.DP_CSC_A_SYNC_2i_1)

/*! @brief Format value for bitfield IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1. */
#define BF_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1) & BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1)

/*! @brief Set the DP_CSC_A_SYNC_2i_1 field to a new value. */
#define BW_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1(x, v) (HW_IPU_DP_CSCA_SYNC_i_WR(x, (HW_IPU_DP_CSCA_SYNC_i_RD(x) & ~BM_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1) | BF_IPU_DP_CSCA_SYNC_i_DP_CSC_A_SYNC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_SCS_SYNC_0 - DP Color Conversion Control Sync Flow Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_SCS_SYNC_0 - DP Color Conversion Control Sync Flow Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_scs_sync_0
{
    uint32_t U;
    struct _hw_ipu_dp_scs_sync_0_bitfields
    {
        uint32_t DP_CSC_A8_SYNC : 10;  /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_B0_SYNC : 14;  /*!< [29:16]  */
        uint32_t DP_CSC_S0_SYNC : 2;   /*!< [31:30]  */
    } B;
} hw_ipu_dp_scs_sync_0_t;

/*!
 * @name Constants and macros for entire IPU_DP_SCS_SYNC_0 register
 */
/*@{*/
#define HW_IPU_DP_SCS_SYNC_0_ADDR(x) ((uintptr_t)(x) + 0x18054U)

#define HW_IPU_DP_SCS_SYNC_0(x)  (*(__IO hw_ipu_dp_scs_sync_0_t *) HW_IPU_DP_SCS_SYNC_0_ADDR(x))
#define HW_IPU_DP_SCS_SYNC_0_RD(x) (HW_IPU_DP_SCS_SYNC_0(x).U)
#define HW_IPU_DP_SCS_SYNC_0_WR(x, v) (HW_IPU_DP_SCS_SYNC_0(x).U = (v))
#define HW_IPU_DP_SCS_SYNC_0_SET(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, HW_IPU_DP_SCS_SYNC_0_RD(x) |  (v)))
#define HW_IPU_DP_SCS_SYNC_0_CLR(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, HW_IPU_DP_SCS_SYNC_0_RD(x) & ~(v)))
#define HW_IPU_DP_SCS_SYNC_0_TOG(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, HW_IPU_DP_SCS_SYNC_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_SCS_SYNC_0 bitfields
 */

/*!
 * @name Register IPU_DP_SCS_SYNC_0, field DP_CSC_A8_SYNC[9:0] (RW)
 *
 * A9 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC (0U) /*!< Bit position for IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC. */
#define BM_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC (0x000003FFU) /*!< Bit mask for IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC. */
#define BS_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC (10U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC(x) (HW_IPU_DP_SCS_SYNC_0(x).B.DP_CSC_A8_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC. */
#define BF_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC) & BM_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC)

/*! @brief Set the DP_CSC_A8_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, (HW_IPU_DP_SCS_SYNC_0_RD(x) & ~BM_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC) | BF_IPU_DP_SCS_SYNC_0_DP_CSC_A8_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_SCS_SYNC_0, field DP_CSC_B0_SYNC[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC (16U) /*!< Bit position for IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC. */
#define BM_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC (0x3FFF0000U) /*!< Bit mask for IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC. */
#define BS_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC (14U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC(x) (HW_IPU_DP_SCS_SYNC_0(x).B.DP_CSC_B0_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC. */
#define BF_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC) & BM_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC)

/*! @brief Set the DP_CSC_B0_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, (HW_IPU_DP_SCS_SYNC_0_RD(x) & ~BM_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC) | BF_IPU_DP_SCS_SYNC_0_DP_CSC_B0_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_SCS_SYNC_0, field DP_CSC_S0_SYNC[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 0
 * - 11 - scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC (30U) /*!< Bit position for IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC. */
#define BM_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC (0xC0000000U) /*!< Bit mask for IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC. */
#define BS_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC (2U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC(x) (HW_IPU_DP_SCS_SYNC_0(x).B.DP_CSC_S0_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC. */
#define BF_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC) & BM_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC)

/*! @brief Set the DP_CSC_S0_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_0_WR(x, (HW_IPU_DP_SCS_SYNC_0_RD(x) & ~BM_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC) | BF_IPU_DP_SCS_SYNC_0_DP_CSC_S0_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_SCS_SYNC_1 - DP Color Conversion Control Sync Flow Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_SCS_SYNC_1 - DP Color Conversion Control Sync Flow Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_scs_sync_1
{
    uint32_t U;
    struct _hw_ipu_dp_scs_sync_1_bitfields
    {
        uint32_t DP_CSC_B1_SYNC : 14;  /*!< [13:0]  */
        uint32_t DP_CSC_S1_SYNC : 2;   /*!< [15:14]  */
        uint32_t DP_CSC_B2_SYNC : 14;  /*!< [29:16]  */
        uint32_t DP_CSC_S2_SYNC : 2;   /*!< [31:30]  */
    } B;
} hw_ipu_dp_scs_sync_1_t;

/*!
 * @name Constants and macros for entire IPU_DP_SCS_SYNC_1 register
 */
/*@{*/
#define HW_IPU_DP_SCS_SYNC_1_ADDR(x) ((uintptr_t)(x) + 0x18058U)

#define HW_IPU_DP_SCS_SYNC_1(x)  (*(__IO hw_ipu_dp_scs_sync_1_t *) HW_IPU_DP_SCS_SYNC_1_ADDR(x))
#define HW_IPU_DP_SCS_SYNC_1_RD(x) (HW_IPU_DP_SCS_SYNC_1(x).U)
#define HW_IPU_DP_SCS_SYNC_1_WR(x, v) (HW_IPU_DP_SCS_SYNC_1(x).U = (v))
#define HW_IPU_DP_SCS_SYNC_1_SET(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, HW_IPU_DP_SCS_SYNC_1_RD(x) |  (v)))
#define HW_IPU_DP_SCS_SYNC_1_CLR(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, HW_IPU_DP_SCS_SYNC_1_RD(x) & ~(v)))
#define HW_IPU_DP_SCS_SYNC_1_TOG(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, HW_IPU_DP_SCS_SYNC_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_SCS_SYNC_1 bitfields
 */

/*!
 * @name Register IPU_DP_SCS_SYNC_1, field DP_CSC_B1_SYNC[13:0] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC (0U) /*!< Bit position for IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC. */
#define BM_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC (0x00003FFFU) /*!< Bit mask for IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC. */
#define BS_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC (14U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC(x) (HW_IPU_DP_SCS_SYNC_1(x).B.DP_CSC_B1_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC. */
#define BF_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC) & BM_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC)

/*! @brief Set the DP_CSC_B1_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, (HW_IPU_DP_SCS_SYNC_1_RD(x) & ~BM_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC) | BF_IPU_DP_SCS_SYNC_1_DP_CSC_B1_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_SCS_SYNC_1, field DP_CSC_S1_SYNC[15:14] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC (14U) /*!< Bit position for IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC. */
#define BM_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC (0x0000C000U) /*!< Bit mask for IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC. */
#define BS_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC (2U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC(x) (HW_IPU_DP_SCS_SYNC_1(x).B.DP_CSC_S1_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC. */
#define BF_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC) & BM_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC)

/*! @brief Set the DP_CSC_S1_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, (HW_IPU_DP_SCS_SYNC_1_RD(x) & ~BM_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC) | BF_IPU_DP_SCS_SYNC_1_DP_CSC_S1_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_SCS_SYNC_1, field DP_CSC_B2_SYNC[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC (16U) /*!< Bit position for IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC. */
#define BM_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC (0x3FFF0000U) /*!< Bit mask for IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC. */
#define BS_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC (14U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC(x) (HW_IPU_DP_SCS_SYNC_1(x).B.DP_CSC_B2_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC. */
#define BF_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC) & BM_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC)

/*! @brief Set the DP_CSC_B2_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, (HW_IPU_DP_SCS_SYNC_1_RD(x) & ~BM_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC) | BF_IPU_DP_SCS_SYNC_1_DP_CSC_B2_SYNC(v)))
/*@}*/

/*!
 * @name Register IPU_DP_SCS_SYNC_1, field DP_CSC_S2_SYNC[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC (30U) /*!< Bit position for IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC. */
#define BM_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC (0xC0000000U) /*!< Bit mask for IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC. */
#define BS_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC (2U) /*!< Bit field size in bits for IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC. */

/*! @brief Read current value of the IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC field. */
#define BR_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC(x) (HW_IPU_DP_SCS_SYNC_1(x).B.DP_CSC_S2_SYNC)

/*! @brief Format value for bitfield IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC. */
#define BF_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC) & BM_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC)

/*! @brief Set the DP_CSC_S2_SYNC field to a new value. */
#define BW_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC(x, v) (HW_IPU_DP_SCS_SYNC_1_WR(x, (HW_IPU_DP_SCS_SYNC_1_RD(x) & ~BM_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC) | BF_IPU_DP_SCS_SYNC_1_DP_CSC_S2_SYNC(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_POS_ALT - DP Cursor Position and Size Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_POS_ALT - DP Cursor Position and Size Alternate Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Cursor Position Register is used to determine the starting position
 * of the cursor relative to BG windows position for the alternative flow.
 */
typedef union _hw_ipu_dp_cur_pos_alt
{
    uint32_t U;
    struct _hw_ipu_dp_cur_pos_alt_bitfields
    {
        uint32_t DP_CXW_SYNC_ALT : 11; /*!< [10:0]  */
        uint32_t DP_CXP_SYNC_ALT : 5;  /*!< [15:11]  */
        uint32_t DP_CYH_SYNC_ALT : 11; /*!< [26:16]  */
        uint32_t DP_CYP_SYNC_ALT : 5;  /*!< [31:27]  */
    } B;
} hw_ipu_dp_cur_pos_alt_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_POS_ALT register
 */
/*@{*/
#define HW_IPU_DP_CUR_POS_ALT_ADDR(x) ((uintptr_t)(x) + 0x1805CU)

#define HW_IPU_DP_CUR_POS_ALT(x) (*(__IO hw_ipu_dp_cur_pos_alt_t *) HW_IPU_DP_CUR_POS_ALT_ADDR(x))
#define HW_IPU_DP_CUR_POS_ALT_RD(x) (HW_IPU_DP_CUR_POS_ALT(x).U)
#define HW_IPU_DP_CUR_POS_ALT_WR(x, v) (HW_IPU_DP_CUR_POS_ALT(x).U = (v))
#define HW_IPU_DP_CUR_POS_ALT_SET(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, HW_IPU_DP_CUR_POS_ALT_RD(x) |  (v)))
#define HW_IPU_DP_CUR_POS_ALT_CLR(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, HW_IPU_DP_CUR_POS_ALT_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_POS_ALT_TOG(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, HW_IPU_DP_CUR_POS_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_POS_ALT bitfields
 */

/*!
 * @name Register IPU_DP_CUR_POS_ALT, field DP_CXW_SYNC_ALT[10:0] (RW)
 *
 * CXW_ALT - Cursor Width. Specifies the width of the hardware cursor in pixels
 * for the alternative flow.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT (0U) /*!< Bit position for IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT. */
#define BM_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT (0x000007FFU) /*!< Bit mask for IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT. */
#define BS_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT field. */
#define BR_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT(x) (HW_IPU_DP_CUR_POS_ALT(x).B.DP_CXW_SYNC_ALT)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT. */
#define BF_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT) & BM_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT)

/*! @brief Set the DP_CXW_SYNC_ALT field to a new value. */
#define BW_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, (HW_IPU_DP_CUR_POS_ALT_RD(x) & ~BM_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT) | BF_IPU_DP_CUR_POS_ALT_DP_CXW_SYNC_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ALT, field DP_CXP_SYNC_ALT[15:11] (RW)
 *
 * CXP_ALT - Cursor X Position Represents the cursors horizontal starting
 * position X in pixel count (from 0 to CXW) for the alternative flow.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT (11U) /*!< Bit position for IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT. */
#define BM_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT (0x0000F800U) /*!< Bit mask for IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT. */
#define BS_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT field. */
#define BR_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT(x) (HW_IPU_DP_CUR_POS_ALT(x).B.DP_CXP_SYNC_ALT)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT. */
#define BF_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT) & BM_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT)

/*! @brief Set the DP_CXP_SYNC_ALT field to a new value. */
#define BW_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, (HW_IPU_DP_CUR_POS_ALT_RD(x) & ~BM_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT) | BF_IPU_DP_CUR_POS_ALT_DP_CXP_SYNC_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ALT, field DP_CYH_SYNC_ALT[26:16] (RW)
 *
 * CYH_ALT - Cursor Height Specifies the height of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT (16U) /*!< Bit position for IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT. */
#define BM_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT (0x07FF0000U) /*!< Bit mask for IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT. */
#define BS_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT field. */
#define BR_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT(x) (HW_IPU_DP_CUR_POS_ALT(x).B.DP_CYH_SYNC_ALT)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT. */
#define BF_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT) & BM_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT)

/*! @brief Set the DP_CYH_SYNC_ALT field to a new value. */
#define BW_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, (HW_IPU_DP_CUR_POS_ALT_RD(x) & ~BM_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT) | BF_IPU_DP_CUR_POS_ALT_DP_CYH_SYNC_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ALT, field DP_CYP_SYNC_ALT[31:27] (RW)
 *
 * CYP_ALT - Cursor Y Position Represents the cursors vertical starting position
 * Y in pixel count (from 0 to CYH).Live View Resolution Mode for the
 * alternative flow.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT (27U) /*!< Bit position for IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT. */
#define BM_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT (0xF8000000U) /*!< Bit mask for IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT. */
#define BS_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT field. */
#define BR_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT(x) (HW_IPU_DP_CUR_POS_ALT(x).B.DP_CYP_SYNC_ALT)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT. */
#define BF_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT) & BM_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT)

/*! @brief Set the DP_CYP_SYNC_ALT field to a new value. */
#define BW_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT(x, v) (HW_IPU_DP_CUR_POS_ALT_WR(x, (HW_IPU_DP_CUR_POS_ALT_RD(x) & ~BM_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT) | BF_IPU_DP_CUR_POS_ALT_DP_CYP_SYNC_ALT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_COM_CONF_ASYNC0 - DP Common Configuration Async 0 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_COM_CONF_ASYNC0 - DP Common Configuration Async 0 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_com_conf_async0
{
    uint32_t U;
    struct _hw_ipu_dp_com_conf_async0_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DP_GWSEL_ASYNC0 : 1;  /*!< [1]  */
        uint32_t DP_GWAM_ASYNC0 : 1;   /*!< [2]  */
        uint32_t DP_GWCKE_ASYNC0 : 1;  /*!< [3]  */
        uint32_t DP_COC_ASYNC0 : 3;    /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t DP_CSC_DEF_ASYNC0 : 2; /*!< [9:8]  */
        uint32_t DP_CSC_GAMUT_SAT_EN_ASYNC0 : 1; /*!< [10]  */
        uint32_t DP_CSC_YUV_SAT_MODE_ASYNC0 : 1; /*!< [11]  */
        uint32_t DP_GAMMA_EN_ASYNC0 : 1; /*!< [12]  */
        uint32_t DP_GAMMA_YUV_EN_ASYNC0 : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_dp_com_conf_async0_t;

/*!
 * @name Constants and macros for entire IPU_DP_COM_CONF_ASYNC0 register
 */
/*@{*/
#define HW_IPU_DP_COM_CONF_ASYNC0_ADDR(x) ((uintptr_t)(x) + 0x18060U)

#define HW_IPU_DP_COM_CONF_ASYNC0(x) (*(__IO hw_ipu_dp_com_conf_async0_t *) HW_IPU_DP_COM_CONF_ASYNC0_ADDR(x))
#define HW_IPU_DP_COM_CONF_ASYNC0_RD(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).U)
#define HW_IPU_DP_COM_CONF_ASYNC0_WR(x, v) (HW_IPU_DP_COM_CONF_ASYNC0(x).U = (v))
#define HW_IPU_DP_COM_CONF_ASYNC0_SET(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, HW_IPU_DP_COM_CONF_ASYNC0_RD(x) |  (v)))
#define HW_IPU_DP_COM_CONF_ASYNC0_CLR(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~(v)))
#define HW_IPU_DP_COM_CONF_ASYNC0_TOG(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, HW_IPU_DP_COM_CONF_ASYNC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_COM_CONF_ASYNC0 bitfields
 */

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_GWSEL_ASYNC0[1] (RW)
 *
 * GWSEL - Graphic Window Select Select graphic window to be on partial plane or
 * full plane.
 *
 * Values:
 * - 1 - Graphic window is partial plane.
 * - 0 - Graphic window is full plane.5
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0 (1U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0 (0x00000002U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_GWSEL_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0)

/*! @brief Set the DP_GWSEL_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_GWSEL_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_GWAM_ASYNC0[2] (RW)
 *
 * GWAM - Graphic Window Alpha Mode Select the use of Alpha to be global or
 * local.
 *
 * Values:
 * - 1 - Global Alpha.
 * - 0 - Local Alpha.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0 (2U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0 (0x00000004U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_GWAM_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0)

/*! @brief Set the DP_GWAM_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_GWAM_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_GWCKE_ASYNC0[3] (RW)
 *
 * GWCKE - Graphic Window Color Keying Enable Enable or disable graphic window
 * color keying.
 *
 * Values:
 * - 1 - Enable color keying of graphic window
 * - 0 - Disable color keying of graphic window
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0 (3U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0 (0x00000008U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_GWCKE_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0)

/*! @brief Set the DP_GWCKE_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_GWCKE_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_COC_ASYNC0[6:4] (RW)
 *
 * COC - Cursor Operation Control Controls the format of the cursor and the type
 * of arithmetic operations
 *
 * Values:
 * - 000 - Transparent, cursor is disabled.
 * - 001 - Full cursor.
 * - 010 - Reversed cursor.
 * - 011 - AND between full plane and cursor.
 * - 100 - Reserved
 * - 101 - OR between full plane and cursor.
 * - 110 - XOR between full plane and cursor.
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0 (4U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0 (0x00000070U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0 (3U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_COC_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0)

/*! @brief Set the DP_COC_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_COC_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_CSC_DEF_ASYNC0[9:8] (RW)
 *
 * CSC_DEF Enable or disable Color Space Conversion.
 *
 * Values:
 * - 00 - CSC disable
 * - 01 - CSC enable after combining
 * - 10 - CSC enable before combining on BG channel
 * - 11 - CSC enable before combining on FG channel
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0 (8U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0 (0x00000300U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0 (2U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_CSC_DEF_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0)

/*! @brief Set the DP_CSC_DEF_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_DEF_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_CSC_GAMUT_SAT_EN_ASYNC0[10] (RW)
 *
 * CSC_GAMUT_SAT_EN Indicate if GAMUT saturation is enabled
 *
 * Values:
 * - 0 - disable GAMUT mapping
 * - 1 - enable GAMUT mapping
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0 (10U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0 (0x00000400U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_CSC_GAMUT_SAT_EN_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0)

/*! @brief Set the DP_CSC_GAMUT_SAT_EN_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_GAMUT_SAT_EN_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_CSC_YUV_SAT_MODE_ASYNC0[11] (RW)
 *
 * CSC_YUV_SAT_MODE YUV saturation mode for color space conversion
 *
 * Values:
 * - 0 - Y/U/V range 0 -255
 * - 1 - Y range 16-235, U/V range 16-240
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0 (11U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0 (0x00000800U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_CSC_YUV_SAT_MODE_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0)

/*! @brief Set the DP_CSC_YUV_SAT_MODE_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_CSC_YUV_SAT_MODE_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_GAMMA_EN_ASYNC0[12] (RW)
 *
 * GAMMA_EN - Gamma correction block enable bit
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0 (12U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0 (0x00001000U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_GAMMA_EN_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0)

/*! @brief Set the DP_GAMMA_EN_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_EN_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC0, field DP_GAMMA_YUV_EN_ASYNC0[13] (RW)
 *
 * GAMMA's YUV mode enable for async flow 0
 *
 * Values:
 * - 0 - YUV mode is OFF.
 * - 1 - YUV mode is ON.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0 (13U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0. */
#define BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0 (0x00002000U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0. */
#define BS_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0 field. */
#define BR_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0(x) (HW_IPU_DP_COM_CONF_ASYNC0(x).B.DP_GAMMA_YUV_EN_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0. */
#define BF_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0) & BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0)

/*! @brief Set the DP_GAMMA_YUV_EN_ASYNC0 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0(x, v) (HW_IPU_DP_COM_CONF_ASYNC0_WR(x, (HW_IPU_DP_COM_CONF_ASYNC0_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0) | BF_IPU_DP_COM_CONF_ASYNC0_DP_GAMMA_YUV_EN_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0 - DP Graphic Window Control Async 0 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0 - DP Graphic Window Control Async 0 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_graph_wind_ctrl_async0
{
    uint32_t U;
    struct _hw_ipu_dp_graph_wind_ctrl_async0_bitfields
    {
        uint32_t DP_GWCKB_ASYNC0 : 8;  /*!< [7:0]  */
        uint32_t DP_GWCKG_ASYNC0 : 8;  /*!< [15:8]  */
        uint32_t DP_GWCKR_ASYNC0 : 8;  /*!< [23:16]  */
        uint32_t DP_GWAV_ASYNC0 : 8;   /*!< [31:24]  */
    } B;
} hw_ipu_dp_graph_wind_ctrl_async0_t;

/*!
 * @name Constants and macros for entire IPU_DP_GRAPH_WIND_CTRL_ASYNC0 register
 */
/*@{*/
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_ADDR(x) ((uintptr_t)(x) + 0x18064U)

#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x) (*(__IO hw_ipu_dp_graph_wind_ctrl_async0_t *) HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_ADDR(x))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).U)
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).U = (v))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_SET(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) |  (v)))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_CLR(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) & ~(v)))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_TOG(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GRAPH_WIND_CTRL_ASYNC0 bitfields
 */

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC0, field DP_GWCKB_ASYNC0[7:0] (RW)
 *
 * GWCKB - Graphic Window Color Keying Blue Component Defines the blue component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No blue
 * - 11111111 - Full blue
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0 (0U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0 (0x000000FFU) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).B.DP_GWCKB_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0)

/*! @brief Set the DP_GWCKB_ASYNC0 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKB_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC0, field DP_GWCKG_ASYNC0[15:8] (RW)
 *
 * GWCKG - Graphic Window Color Keying Green Component Defines the green
 * component of graphic window color keying.
 *
 * Values:
 * - 00000000 - No Green
 * - 11111111 - Full Green
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0 (8U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0 (0x0000FF00U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).B.DP_GWCKG_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0)

/*! @brief Set the DP_GWCKG_ASYNC0 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKG_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC0, field DP_GWCKR_ASYNC0[23:16] (RW)
 *
 * GWCKR - Graphic Window Color Keying Red Component Defines the red component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No red
 * - 11111111 - Full red
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0 (16U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0 (0x00FF0000U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).B.DP_GWCKR_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0)

/*! @brief Set the DP_GWCKR_ASYNC0 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWCKR_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC0, field DP_GWAV_ASYNC0[31:24] (RW)
 *
 * GWAV - Graphic Window Alpha Value Defines the alpha value of graphic window
 * used for alpha blending between graphic window and full plane. The Value the
 * number that writing to GWAV register. The Actual Value the number, that insert
 * to calculation in Combining Module. If Value = < 0.5- 1/256 (01111111) then
 * Actual Value = Value. If Value >= 0.5 (10000000), then Actual Value = Value +
 * 1/256.
 *
 * Values:
 * - 00000000 - Actual value is 00000000; Graphic window totally opaque i.e.
 *     overlay on LCD screen
 * - 01111111 - Actual value is 01111111;
 * - 10000000 - Actual value is 10000001
 * - 10000001 - Actual value is 10000010
 * - 11111110 - Actual value is 11111111
 * - 11111111 - Actual value is 100000000;Graphic window totally transparent
 *     i.e. not displayed on LCD screen
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0 (24U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0 (0xFF000000U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0(x).B.DP_GWAV_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0)

/*! @brief Set the DP_GWAV_ASYNC0 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC0_DP_GWAV_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_FG_POS_ASYNC0 - DP Partial Plane Window Position Async 0 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_FG_POS_ASYNC0 - DP Partial Plane Window Position Async 0 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The DP partial plane Window Position Register is used to determine the
 * starting position of the partial plane window relative to BG window position. This
 * Register is used for the synchronous flow only.
 */
typedef union _hw_ipu_dp_fg_pos_async0
{
    uint32_t U;
    struct _hw_ipu_dp_fg_pos_async0_bitfields
    {
        uint32_t DP_FGYP_ASYNC0 : 11;  /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t DP_FGXP_ASYNC0 : 11;  /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dp_fg_pos_async0_t;

/*!
 * @name Constants and macros for entire IPU_DP_FG_POS_ASYNC0 register
 */
/*@{*/
#define HW_IPU_DP_FG_POS_ASYNC0_ADDR(x) ((uintptr_t)(x) + 0x18068U)

#define HW_IPU_DP_FG_POS_ASYNC0(x) (*(__IO hw_ipu_dp_fg_pos_async0_t *) HW_IPU_DP_FG_POS_ASYNC0_ADDR(x))
#define HW_IPU_DP_FG_POS_ASYNC0_RD(x) (HW_IPU_DP_FG_POS_ASYNC0(x).U)
#define HW_IPU_DP_FG_POS_ASYNC0_WR(x, v) (HW_IPU_DP_FG_POS_ASYNC0(x).U = (v))
#define HW_IPU_DP_FG_POS_ASYNC0_SET(x, v) (HW_IPU_DP_FG_POS_ASYNC0_WR(x, HW_IPU_DP_FG_POS_ASYNC0_RD(x) |  (v)))
#define HW_IPU_DP_FG_POS_ASYNC0_CLR(x, v) (HW_IPU_DP_FG_POS_ASYNC0_WR(x, HW_IPU_DP_FG_POS_ASYNC0_RD(x) & ~(v)))
#define HW_IPU_DP_FG_POS_ASYNC0_TOG(x, v) (HW_IPU_DP_FG_POS_ASYNC0_WR(x, HW_IPU_DP_FG_POS_ASYNC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_FG_POS_ASYNC0 bitfields
 */

/*!
 * @name Register IPU_DP_FG_POS_ASYNC0, field DP_FGYP_ASYNC0[10:0] (RW)
 *
 * FGYP partial plane window Y position partial plane Window Y Position -
 * Specifies the number of lines between the start of full plane windows Y position and
 * the beginning of the first data.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0 (0U) /*!< Bit position for IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0. */
#define BM_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0 (0x000007FFU) /*!< Bit mask for IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0. */
#define BS_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0 (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0. */

/*! @brief Read current value of the IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0 field. */
#define BR_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0(x) (HW_IPU_DP_FG_POS_ASYNC0(x).B.DP_FGYP_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0. */
#define BF_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0) & BM_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0)

/*! @brief Set the DP_FGYP_ASYNC0 field to a new value. */
#define BW_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0(x, v) (HW_IPU_DP_FG_POS_ASYNC0_WR(x, (HW_IPU_DP_FG_POS_ASYNC0_RD(x) & ~BM_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0) | BF_IPU_DP_FG_POS_ASYNC0_DP_FGYP_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_FG_POS_ASYNC0, field DP_FGXP_ASYNC0[26:16] (RW)
 *
 * FGXP partial plane Window X Position. partial plane Window X Position -
 * Specifies the number of pixels between the start of full plane window X position
 * and the beginning of the first data of new line.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0 (16U) /*!< Bit position for IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0. */
#define BM_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0 (0x07FF0000U) /*!< Bit mask for IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0. */
#define BS_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0 (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0. */

/*! @brief Read current value of the IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0 field. */
#define BR_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0(x) (HW_IPU_DP_FG_POS_ASYNC0(x).B.DP_FGXP_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0. */
#define BF_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0) & BM_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0)

/*! @brief Set the DP_FGXP_ASYNC0 field to a new value. */
#define BW_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0(x, v) (HW_IPU_DP_FG_POS_ASYNC0_WR(x, (HW_IPU_DP_FG_POS_ASYNC0_RD(x) & ~BM_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0) | BF_IPU_DP_FG_POS_ASYNC0_DP_FGXP_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_POS_ASYNC0 - DP Cursor Position and Size Async 0 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_POS_ASYNC0 - DP Cursor Position and Size Async 0 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Cursor Position Register is used to determine the starting position
 * of the cursor relative to BG windows position.
 */
typedef union _hw_ipu_dp_cur_pos_async0
{
    uint32_t U;
    struct _hw_ipu_dp_cur_pos_async0_bitfields
    {
        uint32_t DP_CXW_ASYNC0 : 11;   /*!< [10:0]  */
        uint32_t DP_CXP_ASYNC0 : 5;    /*!< [15:11]  */
        uint32_t DP_CYH_ASYNC0 : 11;   /*!< [26:16]  */
        uint32_t DP_CYP_ASYNC0 : 5;    /*!< [31:27]  */
    } B;
} hw_ipu_dp_cur_pos_async0_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_POS_ASYNC0 register
 */
/*@{*/
#define HW_IPU_DP_CUR_POS_ASYNC0_ADDR(x) ((uintptr_t)(x) + 0x1806CU)

#define HW_IPU_DP_CUR_POS_ASYNC0(x) (*(__IO hw_ipu_dp_cur_pos_async0_t *) HW_IPU_DP_CUR_POS_ASYNC0_ADDR(x))
#define HW_IPU_DP_CUR_POS_ASYNC0_RD(x) (HW_IPU_DP_CUR_POS_ASYNC0(x).U)
#define HW_IPU_DP_CUR_POS_ASYNC0_WR(x, v) (HW_IPU_DP_CUR_POS_ASYNC0(x).U = (v))
#define HW_IPU_DP_CUR_POS_ASYNC0_SET(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, HW_IPU_DP_CUR_POS_ASYNC0_RD(x) |  (v)))
#define HW_IPU_DP_CUR_POS_ASYNC0_CLR(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, HW_IPU_DP_CUR_POS_ASYNC0_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_POS_ASYNC0_TOG(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, HW_IPU_DP_CUR_POS_ASYNC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_POS_ASYNC0 bitfields
 */

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC0, field DP_CXW_ASYNC0[10:0] (RW)
 *
 * CXW - Cursor Width. Specifies the width of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0 (0U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0. */
#define BM_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0 (0x000007FFU) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0. */
#define BS_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0 (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0 field. */
#define BR_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0(x) (HW_IPU_DP_CUR_POS_ASYNC0(x).B.DP_CXW_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0. */
#define BF_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0) & BM_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0)

/*! @brief Set the DP_CXW_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, (HW_IPU_DP_CUR_POS_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0) | BF_IPU_DP_CUR_POS_ASYNC0_DP_CXW_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC0, field DP_CXP_ASYNC0[15:11] (RW)
 *
 * CXP - Cursor X Position Represents the cursors horizontal starting position X
 * in pixel count (from 0 to CXW).
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0 (11U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0. */
#define BM_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0 (0x0000F800U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0. */
#define BS_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0 (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0 field. */
#define BR_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0(x) (HW_IPU_DP_CUR_POS_ASYNC0(x).B.DP_CXP_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0. */
#define BF_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0) & BM_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0)

/*! @brief Set the DP_CXP_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, (HW_IPU_DP_CUR_POS_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0) | BF_IPU_DP_CUR_POS_ASYNC0_DP_CXP_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC0, field DP_CYH_ASYNC0[26:16] (RW)
 *
 * CYH - Cursor Height Specifies the height of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0 (16U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0. */
#define BM_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0 (0x07FF0000U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0. */
#define BS_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0 (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0 field. */
#define BR_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0(x) (HW_IPU_DP_CUR_POS_ASYNC0(x).B.DP_CYH_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0. */
#define BF_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0) & BM_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0)

/*! @brief Set the DP_CYH_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, (HW_IPU_DP_CUR_POS_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0) | BF_IPU_DP_CUR_POS_ASYNC0_DP_CYH_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC0, field DP_CYP_ASYNC0[31:27] (RW)
 *
 * CYP - Cursor Y Position Represents the cursors vertical starting position Y
 * in pixel count (from 0 to CYH).Live View Resolution Mode.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0 (27U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0. */
#define BM_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0 (0xF8000000U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0. */
#define BS_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0 (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0 field. */
#define BR_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0(x) (HW_IPU_DP_CUR_POS_ASYNC0(x).B.DP_CYP_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0. */
#define BF_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0) & BM_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0)

/*! @brief Set the DP_CYP_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0(x, v) (HW_IPU_DP_CUR_POS_ASYNC0_WR(x, (HW_IPU_DP_CUR_POS_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0) | BF_IPU_DP_CUR_POS_ASYNC0_DP_CYP_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_MAP_ASYNC0 - DP Color Cursor Mapping Async 0 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_MAP_ASYNC0 - DP Color Cursor Mapping Async 0 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Color Cursor Mapping Register defines the color of the cursor in
 * passive or TFT color modes.
 */
typedef union _hw_ipu_dp_cur_map_async0
{
    uint32_t U;
    struct _hw_ipu_dp_cur_map_async0_bitfields
    {
        uint32_t DP_CUR_COL_R_ASYNC0 : 8; /*!< [7:0]  */
        uint32_t DP_CUR_COL_G_ASYNC0 : 8; /*!< [15:8]  */
        uint32_t DP_CUR_COL_B_ASYNC0 : 8; /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_dp_cur_map_async0_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_MAP_ASYNC0 register
 */
/*@{*/
#define HW_IPU_DP_CUR_MAP_ASYNC0_ADDR(x) ((uintptr_t)(x) + 0x18070U)

#define HW_IPU_DP_CUR_MAP_ASYNC0(x) (*(__IO hw_ipu_dp_cur_map_async0_t *) HW_IPU_DP_CUR_MAP_ASYNC0_ADDR(x))
#define HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) (HW_IPU_DP_CUR_MAP_ASYNC0(x).U)
#define HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0(x).U = (v))
#define HW_IPU_DP_CUR_MAP_ASYNC0_SET(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) |  (v)))
#define HW_IPU_DP_CUR_MAP_ASYNC0_CLR(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_MAP_ASYNC0_TOG(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_MAP_ASYNC0 bitfields
 */

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC0, field DP_CUR_COL_R_ASYNC0[7:0] (RW)
 *
 * CUR_COL_R - Cursor Red Field Defines the Red component of the cursor color in
 * color mode
 *
 * Values:
 * - 00000000 - No Red.
 * - 11111111 - Full Red.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0 (0U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0. */
#define BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0 (0x000000FFU) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0. */
#define BS_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0(x) (HW_IPU_DP_CUR_MAP_ASYNC0(x).B.DP_CUR_COL_R_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0. */
#define BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0) & BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0)

/*! @brief Set the DP_CUR_COL_R_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0) | BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_R_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC0, field DP_CUR_COL_G_ASYNC0[15:8] (RW)
 *
 * CUR_COL_G - Cursor Green Field Defines the Green component of the cursor
 * color in color mode
 *
 * Values:
 * - 00000000 - No Green.
 * - 11111111 - Full Green.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0 (8U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0. */
#define BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0 (0x0000FF00U) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0. */
#define BS_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0(x) (HW_IPU_DP_CUR_MAP_ASYNC0(x).B.DP_CUR_COL_G_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0. */
#define BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0) & BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0)

/*! @brief Set the DP_CUR_COL_G_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0) | BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_G_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC0, field DP_CUR_COL_B_ASYNC0[23:16] (RW)
 *
 * CUR_COL_B - Cursor Blue Field Defines the Blue component of the cursor color
 * in color mode
 *
 * Values:
 * - 00000000 - No Blue.
 * - 11111111 - Full Blue.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0 (16U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0. */
#define BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0 (0x00FF0000U) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0. */
#define BS_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0(x) (HW_IPU_DP_CUR_MAP_ASYNC0(x).B.DP_CUR_COL_B_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0. */
#define BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0) & BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0)

/*! @brief Set the DP_CUR_COL_B_ASYNC0 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0(x, v) (HW_IPU_DP_CUR_MAP_ASYNC0_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC0_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0) | BF_IPU_DP_CUR_MAP_ASYNC0_DP_CUR_COL_B_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_C_ASYNC0_i - DP Gamma Constant Async 0 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_C_ASYNC0_i - DP Gamma Constant Async 0 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains CONSTANTi parameters used for gamma correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_c_async0_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_c_async0_i_bitfields
    {
        uint32_t DP_GAMMA_C_ASYNC0_2i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t DP_GAMMA_C_ASYNC0_2i_1 : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_dp_gamma_c_async0_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_C_ASYNC0_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_ADDR(x) ((uintptr_t)(x) + 0x18074U)

#define HW_IPU_DP_GAMMA_C_ASYNC0_i(x) (*(__IO hw_ipu_dp_gamma_c_async0_i_t *) HW_IPU_DP_GAMMA_C_ASYNC0_i_ADDR(x))
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) (HW_IPU_DP_GAMMA_C_ASYNC0_i(x).U)
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i(x).U = (v))
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_SET(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_CLR(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_C_ASYNC0_i_TOG(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_C_ASYNC0_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_C_ASYNC0_i, field DP_GAMMA_C_ASYNC0_2i[8:0] (RW)
 *
 * CONSTANTi parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i (0U) /*!< Bit position for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i. */
#define BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i (0x000001FFU) /*!< Bit mask for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i. */
#define BS_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i (9U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i field. */
#define BR_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i(x) (HW_IPU_DP_GAMMA_C_ASYNC0_i(x).B.DP_GAMMA_C_ASYNC0_2i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i. */
#define BF_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i) & BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i)

/*! @brief Set the DP_GAMMA_C_ASYNC0_2i field to a new value. */
#define BW_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i) | BF_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_C_ASYNC0_i, field DP_GAMMA_C_ASYNC0_2i_1[27:16] (RW)
 *
 * CONSTANTi+1 parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1 (16U) /*!< Bit position for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1. */
#define BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1 (0x0FFF0000U) /*!< Bit mask for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1. */
#define BS_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1 (12U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1 field. */
#define BR_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1(x) (HW_IPU_DP_GAMMA_C_ASYNC0_i(x).B.DP_GAMMA_C_ASYNC0_2i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1. */
#define BF_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1) & BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1)

/*! @brief Set the DP_GAMMA_C_ASYNC0_2i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1(x, v) (HW_IPU_DP_GAMMA_C_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_C_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1) | BF_IPU_DP_GAMMA_C_ASYNC0_i_DP_GAMMA_C_ASYNC0_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_S_ASYNC0_i - DP Gamma Correction Slope Async 0 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_S_ASYNC0_i - DP Gamma Correction Slope Async 0 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains SLOPEi parameters used for Gamma Correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_s_async0_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_s_async0_i_bitfields
    {
        uint32_t DP_GAMMA_S_ASYNC0_4i : 8; /*!< [7:0]  */
        uint32_t DP_GAMMA_S_ASYNC0_4i_1 : 8; /*!< [15:8]  */
        uint32_t DP_GAMMA_S_ASYNC0_4i_2 : 8; /*!< [23:16]  */
        uint32_t DP_GAMMA_S_ASYNC0_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dp_gamma_s_async0_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_S_ASYNC0_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_ADDR(x) ((uintptr_t)(x) + 0x18094U)

#define HW_IPU_DP_GAMMA_S_ASYNC0_i(x) (*(__IO hw_ipu_dp_gamma_s_async0_i_t *) HW_IPU_DP_GAMMA_S_ASYNC0_i_ADDR(x))
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).U)
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).U = (v))
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_SET(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_CLR(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_S_ASYNC0_i_TOG(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_S_ASYNC0_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_S_ASYNC0_i, field DP_GAMMA_S_ASYNC0_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i (0U) /*!< Bit position for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i. */
#define BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i (0x000000FFU) /*!< Bit mask for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i. */
#define BS_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i field. */
#define BR_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i(x) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).B.DP_GAMMA_S_ASYNC0_4i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i. */
#define BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i) & BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i)

/*! @brief Set the DP_GAMMA_S_ASYNC0_4i field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i) | BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYNC0_i, field DP_GAMMA_S_ASYNC0_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1 (8U) /*!< Bit position for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1. */
#define BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1. */
#define BS_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1 field. */
#define BR_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1(x) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).B.DP_GAMMA_S_ASYNC0_4i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1. */
#define BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1) & BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1)

/*! @brief Set the DP_GAMMA_S_ASYNC0_4i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1) | BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYNC0_i, field DP_GAMMA_S_ASYNC0_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2 (16U) /*!< Bit position for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2. */
#define BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2. */
#define BS_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2 field. */
#define BR_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2(x) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).B.DP_GAMMA_S_ASYNC0_4i_2)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2. */
#define BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2) & BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2)

/*! @brief Set the DP_GAMMA_S_ASYNC0_4i_2 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2) | BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYNC0_i, field DP_GAMMA_S_ASYNC0_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3 (24U) /*!< Bit position for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3. */
#define BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3 (0xFF000000U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3. */
#define BS_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3 field. */
#define BR_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3(x) (HW_IPU_DP_GAMMA_S_ASYNC0_i(x).B.DP_GAMMA_S_ASYNC0_4i_3)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3. */
#define BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3) & BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3)

/*! @brief Set the DP_GAMMA_S_ASYNC0_4i_3 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3(x, v) (HW_IPU_DP_GAMMA_S_ASYNC0_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYNC0_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3) | BF_IPU_DP_GAMMA_S_ASYNC0_i_DP_GAMMA_S_ASYNC0_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSCA_ASYNC0_i - DP Color Space Conversion Control Async 0 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSCA_ASYNC0_i - DP Color Space Conversion Control Async 0 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csca_async0_i
{
    uint32_t U;
    struct _hw_ipu_dp_csca_async0_i_bitfields
    {
        uint32_t DP_CSC_A_ASYNC0_2i : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_A_ASYNC0_2i_1 : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_dp_csca_async0_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSCA_ASYNC0_i register
 */
/*@{*/
#define HW_IPU_DP_CSCA_ASYNC0_i_ADDR(x) ((uintptr_t)(x) + 0x180A4U)

#define HW_IPU_DP_CSCA_ASYNC0_i(x) (*(__IO hw_ipu_dp_csca_async0_i_t *) HW_IPU_DP_CSCA_ASYNC0_i_ADDR(x))
#define HW_IPU_DP_CSCA_ASYNC0_i_RD(x) (HW_IPU_DP_CSCA_ASYNC0_i(x).U)
#define HW_IPU_DP_CSCA_ASYNC0_i_WR(x, v) (HW_IPU_DP_CSCA_ASYNC0_i(x).U = (v))
#define HW_IPU_DP_CSCA_ASYNC0_i_SET(x, v) (HW_IPU_DP_CSCA_ASYNC0_i_WR(x, HW_IPU_DP_CSCA_ASYNC0_i_RD(x) |  (v)))
#define HW_IPU_DP_CSCA_ASYNC0_i_CLR(x, v) (HW_IPU_DP_CSCA_ASYNC0_i_WR(x, HW_IPU_DP_CSCA_ASYNC0_i_RD(x) & ~(v)))
#define HW_IPU_DP_CSCA_ASYNC0_i_TOG(x, v) (HW_IPU_DP_CSCA_ASYNC0_i_WR(x, HW_IPU_DP_CSCA_ASYNC0_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSCA_ASYNC0_i bitfields
 */

/*!
 * @name Register IPU_DP_CSCA_ASYNC0_i, field DP_CSC_A_ASYNC0_2i[9:0] (RW)
 *
 * A<2*i> parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i (0U) /*!< Bit position for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i. */
#define BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i (0x000003FFU) /*!< Bit mask for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i. */
#define BS_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i (10U) /*!< Bit field size in bits for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i. */

/*! @brief Read current value of the IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i field. */
#define BR_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i(x) (HW_IPU_DP_CSCA_ASYNC0_i(x).B.DP_CSC_A_ASYNC0_2i)

/*! @brief Format value for bitfield IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i. */
#define BF_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i) & BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i)

/*! @brief Set the DP_CSC_A_ASYNC0_2i field to a new value. */
#define BW_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i(x, v) (HW_IPU_DP_CSCA_ASYNC0_i_WR(x, (HW_IPU_DP_CSCA_ASYNC0_i_RD(x) & ~BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i) | BF_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSCA_ASYNC0_i, field DP_CSC_A_ASYNC0_2i_1[25:16] (RW)
 *
 * A<2*i+1> parameter of color conversion
 */
/*@{*/
#define BP_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1 (16U) /*!< Bit position for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1. */
#define BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1 (0x03FF0000U) /*!< Bit mask for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1. */
#define BS_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1 (10U) /*!< Bit field size in bits for IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1. */

/*! @brief Read current value of the IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1 field. */
#define BR_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1(x) (HW_IPU_DP_CSCA_ASYNC0_i(x).B.DP_CSC_A_ASYNC0_2i_1)

/*! @brief Format value for bitfield IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1. */
#define BF_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1) & BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1)

/*! @brief Set the DP_CSC_A_ASYNC0_2i_1 field to a new value. */
#define BW_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1(x, v) (HW_IPU_DP_CSCA_ASYNC0_i_WR(x, (HW_IPU_DP_CSCA_ASYNC0_i_RD(x) & ~BM_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1) | BF_IPU_DP_CSCA_ASYNC0_i_DP_CSC_A_ASYNC0_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSC_ASYNC0_0 - DP Color Conversion Control Async 0 Flow Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSC_ASYNC0_0 - DP Color Conversion Control Async 0 Flow Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csc_async0_0
{
    uint32_t U;
    struct _hw_ipu_dp_csc_async0_0_bitfields
    {
        uint32_t DP_CSC_A8_ASYNC0 : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_B0_ASYNC0 : 14; /*!< [29:16]  */
        uint32_t DP_CSC_S0_ASYNC0 : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dp_csc_async0_0_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSC_ASYNC0_0 register
 */
/*@{*/
#define HW_IPU_DP_CSC_ASYNC0_0_ADDR(x) ((uintptr_t)(x) + 0x180B4U)

#define HW_IPU_DP_CSC_ASYNC0_0(x) (*(__IO hw_ipu_dp_csc_async0_0_t *) HW_IPU_DP_CSC_ASYNC0_0_ADDR(x))
#define HW_IPU_DP_CSC_ASYNC0_0_RD(x) (HW_IPU_DP_CSC_ASYNC0_0(x).U)
#define HW_IPU_DP_CSC_ASYNC0_0_WR(x, v) (HW_IPU_DP_CSC_ASYNC0_0(x).U = (v))
#define HW_IPU_DP_CSC_ASYNC0_0_SET(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, HW_IPU_DP_CSC_ASYNC0_0_RD(x) |  (v)))
#define HW_IPU_DP_CSC_ASYNC0_0_CLR(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, HW_IPU_DP_CSC_ASYNC0_0_RD(x) & ~(v)))
#define HW_IPU_DP_CSC_ASYNC0_0_TOG(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, HW_IPU_DP_CSC_ASYNC0_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSC_ASYNC0_0 bitfields
 */

/*!
 * @name Register IPU_DP_CSC_ASYNC0_0, field DP_CSC_A8_ASYNC0[9:0] (RW)
 *
 * A9 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0 (0U) /*!< Bit position for IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0 (0x000003FFU) /*!< Bit mask for IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0 (10U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC0_0(x).B.DP_CSC_A8_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0) & BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0)

/*! @brief Set the DP_CSC_A8_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, (HW_IPU_DP_CSC_ASYNC0_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0) | BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_A8_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC0_0, field DP_CSC_B0_ASYNC0[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0 (16U) /*!< Bit position for IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0 (0x3FFF0000U) /*!< Bit mask for IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC0_0(x).B.DP_CSC_B0_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0) & BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0)

/*! @brief Set the DP_CSC_B0_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, (HW_IPU_DP_CSC_ASYNC0_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0) | BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_B0_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC0_0, field DP_CSC_S0_ASYNC0[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 0
 * - 11 - scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0 (30U) /*!< Bit position for IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0 (0xC0000000U) /*!< Bit mask for IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC0_0(x).B.DP_CSC_S0_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0) & BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0)

/*! @brief Set the DP_CSC_S0_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC0_0_WR(x, (HW_IPU_DP_CSC_ASYNC0_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0) | BF_IPU_DP_CSC_ASYNC0_0_DP_CSC_S0_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSC_ASYNC_1 - DP Color Conversion Control Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSC_ASYNC_1 - DP Color Conversion Control Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csc_async_1
{
    uint32_t U;
    struct _hw_ipu_dp_csc_async_1_bitfields
    {
        uint32_t DP_CSC_B1_ASYNC0 : 14; /*!< [13:0]  */
        uint32_t DP_CSC_S1_ASYNC0 : 2; /*!< [15:14]  */
        uint32_t DP_CSC_B2_ASYNC0 : 14; /*!< [29:16]  */
        uint32_t DP_CSC_S2_ASYNC0 : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dp_csc_async_1_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSC_ASYNC_1 register
 */
/*@{*/
#define HW_IPU_DP_CSC_ASYNC_1_ADDR(x) ((uintptr_t)(x) + 0x180B8U)

#define HW_IPU_DP_CSC_ASYNC_1(x) (*(__IO hw_ipu_dp_csc_async_1_t *) HW_IPU_DP_CSC_ASYNC_1_ADDR(x))
#define HW_IPU_DP_CSC_ASYNC_1_RD(x) (HW_IPU_DP_CSC_ASYNC_1(x).U)
#define HW_IPU_DP_CSC_ASYNC_1_WR(x, v) (HW_IPU_DP_CSC_ASYNC_1(x).U = (v))
#define HW_IPU_DP_CSC_ASYNC_1_SET(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, HW_IPU_DP_CSC_ASYNC_1_RD(x) |  (v)))
#define HW_IPU_DP_CSC_ASYNC_1_CLR(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, HW_IPU_DP_CSC_ASYNC_1_RD(x) & ~(v)))
#define HW_IPU_DP_CSC_ASYNC_1_TOG(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, HW_IPU_DP_CSC_ASYNC_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSC_ASYNC_1 bitfields
 */

/*!
 * @name Register IPU_DP_CSC_ASYNC_1, field DP_CSC_B1_ASYNC0[13:0] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0 (0U) /*!< Bit position for IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0 (0x00003FFFU) /*!< Bit mask for IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC_1(x).B.DP_CSC_B1_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0) & BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0)

/*! @brief Set the DP_CSC_B1_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, (HW_IPU_DP_CSC_ASYNC_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0) | BF_IPU_DP_CSC_ASYNC_1_DP_CSC_B1_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC_1, field DP_CSC_S1_ASYNC0[15:14] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0 (14U) /*!< Bit position for IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0 (0x0000C000U) /*!< Bit mask for IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC_1(x).B.DP_CSC_S1_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0) & BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0)

/*! @brief Set the DP_CSC_S1_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, (HW_IPU_DP_CSC_ASYNC_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0) | BF_IPU_DP_CSC_ASYNC_1_DP_CSC_S1_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC_1, field DP_CSC_B2_ASYNC0[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0 (16U) /*!< Bit position for IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0 (0x3FFF0000U) /*!< Bit mask for IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC_1(x).B.DP_CSC_B2_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0) & BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0)

/*! @brief Set the DP_CSC_B2_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, (HW_IPU_DP_CSC_ASYNC_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0) | BF_IPU_DP_CSC_ASYNC_1_DP_CSC_B2_ASYNC0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC_1, field DP_CSC_S2_ASYNC0[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0 (30U) /*!< Bit position for IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0. */
#define BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0 (0xC0000000U) /*!< Bit mask for IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0. */
#define BS_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0 field. */
#define BR_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0(x) (HW_IPU_DP_CSC_ASYNC_1(x).B.DP_CSC_S2_ASYNC0)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0. */
#define BF_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0) & BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0)

/*! @brief Set the DP_CSC_S2_ASYNC0 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0(x, v) (HW_IPU_DP_CSC_ASYNC_1_WR(x, (HW_IPU_DP_CSC_ASYNC_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0) | BF_IPU_DP_CSC_ASYNC_1_DP_CSC_S2_ASYNC0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_COM_CONF_ASYNC1 - DP Common Configuration Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_COM_CONF_ASYNC1 - DP Common Configuration Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_com_conf_async1
{
    uint32_t U;
    struct _hw_ipu_dp_com_conf_async1_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t DP_GWSEL_ASYNC1 : 1;  /*!< [1]  */
        uint32_t DP_GWAM_ASYNC1 : 1;   /*!< [2]  */
        uint32_t DP_GWCKE_ASYNC1 : 1;  /*!< [3]  */
        uint32_t DP_COC_ASYNC1 : 3;    /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t DP_CSC_DEF_ASYNC1 : 2; /*!< [9:8]  */
        uint32_t DP_CSC_GAMUT_SAT_EN_ASYNC1 : 1; /*!< [10]  */
        uint32_t DP_CSC_YUV_SAT_MODE_ASYNC1 : 1; /*!< [11]  */
        uint32_t DP_GAMMA_EN_ASYNC1 : 1; /*!< [12]  */
        uint32_t DP_GAMMA_YUV_EN_ASYNC1 : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_dp_com_conf_async1_t;

/*!
 * @name Constants and macros for entire IPU_DP_COM_CONF_ASYNC1 register
 */
/*@{*/
#define HW_IPU_DP_COM_CONF_ASYNC1_ADDR(x) ((uintptr_t)(x) + 0x180BCU)

#define HW_IPU_DP_COM_CONF_ASYNC1(x) (*(__IO hw_ipu_dp_com_conf_async1_t *) HW_IPU_DP_COM_CONF_ASYNC1_ADDR(x))
#define HW_IPU_DP_COM_CONF_ASYNC1_RD(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).U)
#define HW_IPU_DP_COM_CONF_ASYNC1_WR(x, v) (HW_IPU_DP_COM_CONF_ASYNC1(x).U = (v))
#define HW_IPU_DP_COM_CONF_ASYNC1_SET(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, HW_IPU_DP_COM_CONF_ASYNC1_RD(x) |  (v)))
#define HW_IPU_DP_COM_CONF_ASYNC1_CLR(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~(v)))
#define HW_IPU_DP_COM_CONF_ASYNC1_TOG(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, HW_IPU_DP_COM_CONF_ASYNC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_COM_CONF_ASYNC1 bitfields
 */

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_GWSEL_ASYNC1[1] (RW)
 *
 * GWSEL - Graphic Window Select Select graphic window to be on partial plane or
 * full plane.
 *
 * Values:
 * - 1 - Graphic window is partial plane.
 * - 0 - Graphic window is full plane.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1 (1U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1 (0x00000002U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_GWSEL_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1)

/*! @brief Set the DP_GWSEL_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_GWSEL_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_GWAM_ASYNC1[2] (RW)
 *
 * GWAM - Graphic Window Alpha Mode Select the use of Alpha to be global or
 * local.
 *
 * Values:
 * - 1 - Global Alpha.
 * - 0 - Local Alpha.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1 (2U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1 (0x00000004U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_GWAM_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1)

/*! @brief Set the DP_GWAM_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_GWAM_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_GWCKE_ASYNC1[3] (RW)
 *
 * GWCKE - Graphic Window Color Keying Enable Enable or disable graphic window
 * color keying.
 *
 * Values:
 * - 1 - Enable color keying of graphic window
 * - 0 - Disable color keying of graphic window
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1 (3U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1 (0x00000008U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_GWCKE_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1)

/*! @brief Set the DP_GWCKE_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_GWCKE_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_COC_ASYNC1[6:4] (RW)
 *
 * COC - Cursor Operation Control Controls the format of the cursor and the type
 * of arithmetic operations
 *
 * Values:
 * - 000 - Transparent, cursor is disabled.
 * - 001 - Full cursor.
 * - 010 - Reversed cursor.
 * - 011 - AND between full plane and cursor.
 * - 100 - Reserved
 * - 101 - OR between full plane and cursor.
 * - 110 - XOR between full plane and cursor.
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1 (4U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1 (0x00000070U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1 (3U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_COC_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1)

/*! @brief Set the DP_COC_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_COC_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_CSC_DEF_ASYNC1[9:8] (RW)
 *
 * CSC_DEF Enable or disable Color Space Conversion.
 *
 * Values:
 * - 00 - CSC disable
 * - 01 - CSC enable after combining
 * - 10 - CSC enable before combining on BG channel
 * - 11 - CSC enable before combining on FG channel
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1 (8U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1 (0x00000300U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1 (2U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_CSC_DEF_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1)

/*! @brief Set the DP_CSC_DEF_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_DEF_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_CSC_GAMUT_SAT_EN_ASYNC1[10] (RW)
 *
 * CSC_GAMUT_SAT_EN Indicate if GAMUT saturation is enabled
 *
 * Values:
 * - 0 - disable GAMUT mapping
 * - 1 - enable GAMUT mapping
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1 (10U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1 (0x00000400U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_CSC_GAMUT_SAT_EN_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1)

/*! @brief Set the DP_CSC_GAMUT_SAT_EN_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_GAMUT_SAT_EN_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_CSC_YUV_SAT_MODE_ASYNC1[11] (RW)
 *
 * CSC_YUV_SAT_MODE YUV saturation mode for color space conversion
 *
 * Values:
 * - 0 - Y/U/V range 0 -255
 * - 1 - Y range 16-235, U/V range 16-240
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1 (11U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1 (0x00000800U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_CSC_YUV_SAT_MODE_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1)

/*! @brief Set the DP_CSC_YUV_SAT_MODE_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_CSC_YUV_SAT_MODE_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_GAMMA_EN_ASYNC1[12] (RW)
 *
 * GAMMA_EN - Gamma correction block enable bit
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1 (12U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1 (0x00001000U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_GAMMA_EN_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1)

/*! @brief Set the DP_GAMMA_EN_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_EN_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_COM_CONF_ASYNC1, field DP_GAMMA_YUV_EN_ASYNC1[13] (RW)
 *
 * GAMMA's YUV mode enable for async flow 1
 *
 * Values:
 * - 0 - YUV mode is OFF.
 * - 1 - YUV mode is ON.
 */
/*@{*/
#define BP_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1 (13U) /*!< Bit position for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1. */
#define BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1 (0x00002000U) /*!< Bit mask for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1. */
#define BS_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1 (1U) /*!< Bit field size in bits for IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1. */

/*! @brief Read current value of the IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1 field. */
#define BR_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1(x) (HW_IPU_DP_COM_CONF_ASYNC1(x).B.DP_GAMMA_YUV_EN_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1. */
#define BF_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1) & BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1)

/*! @brief Set the DP_GAMMA_YUV_EN_ASYNC1 field to a new value. */
#define BW_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1(x, v) (HW_IPU_DP_COM_CONF_ASYNC1_WR(x, (HW_IPU_DP_COM_CONF_ASYNC1_RD(x) & ~BM_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1) | BF_IPU_DP_COM_CONF_ASYNC1_DP_GAMMA_YUV_EN_ASYNC1(v)))
/*@}*/
/*******************************************************************************
 * HW_IPU_DP_DEBUG_CNT - DP Debug Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_DEBUG_CNT - DP Debug Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is the debug unit control register. This register is not stored in the
 * SRM.
 */
typedef union _hw_ipu_dp_debug_cnt
{
    uint32_t U;
    struct _hw_ipu_dp_debug_cnt_bitfields
    {
        uint32_t BRAKE_STATUS_EN_0 : 1; /*!< [0]  */
        uint32_t BRAKE_CNT_0 : 3;      /*!< [3:1]  */
        uint32_t BRAKE_STATUS_EN_1 : 1; /*!< [4]  */
        uint32_t BRAKE_CNT_1 : 3;      /*!< [7:5]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dp_debug_cnt_t;

/*!
 * @name Constants and macros for entire IPU_DP_DEBUG_CNT register
 */
/*@{*/
#define HW_IPU_DP_DEBUG_CNT_ADDR(x) ((uintptr_t)(x) + 0x180BCU)

#define HW_IPU_DP_DEBUG_CNT(x)   (*(__IO hw_ipu_dp_debug_cnt_t *) HW_IPU_DP_DEBUG_CNT_ADDR(x))
#define HW_IPU_DP_DEBUG_CNT_RD(x) (HW_IPU_DP_DEBUG_CNT(x).U)
#define HW_IPU_DP_DEBUG_CNT_WR(x, v) (HW_IPU_DP_DEBUG_CNT(x).U = (v))
#define HW_IPU_DP_DEBUG_CNT_SET(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, HW_IPU_DP_DEBUG_CNT_RD(x) |  (v)))
#define HW_IPU_DP_DEBUG_CNT_CLR(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, HW_IPU_DP_DEBUG_CNT_RD(x) & ~(v)))
#define HW_IPU_DP_DEBUG_CNT_TOG(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, HW_IPU_DP_DEBUG_CNT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_DEBUG_CNT bitfields
 */

/*!
 * @name Register IPU_DP_DEBUG_CNT, field BRAKE_STATUS_EN_0[0] (RW)
 *
 * This bit enables the break/status unit #0
 */
/*@{*/
#define BP_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0 (0U) /*!< Bit position for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0. */
#define BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0 (0x00000001U) /*!< Bit mask for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0. */
#define BS_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0 field. */
#define BR_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0(x) (HW_IPU_DP_DEBUG_CNT(x).B.BRAKE_STATUS_EN_0)

/*! @brief Format value for bitfield IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0. */
#define BF_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0) & BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0)

/*! @brief Set the BRAKE_STATUS_EN_0 field to a new value. */
#define BW_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, (HW_IPU_DP_DEBUG_CNT_RD(x) & ~BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0) | BF_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_CNT, field BRAKE_CNT_0[3:1] (RW)
 *
 * The async flow can be broken multiple times. It possible to control which
 * breaking event will cause the interrupt. This field counts the breaking events
 * for unit #0
 */
/*@{*/
#define BP_IPU_DP_DEBUG_CNT_BRAKE_CNT_0 (1U) /*!< Bit position for IPU_DP_DEBUG_CNT_BRAKE_CNT_0. */
#define BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_0 (0x0000000EU) /*!< Bit mask for IPU_DP_DEBUG_CNT_BRAKE_CNT_0. */
#define BS_IPU_DP_DEBUG_CNT_BRAKE_CNT_0 (3U) /*!< Bit field size in bits for IPU_DP_DEBUG_CNT_BRAKE_CNT_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_CNT_BRAKE_CNT_0 field. */
#define BR_IPU_DP_DEBUG_CNT_BRAKE_CNT_0(x) (HW_IPU_DP_DEBUG_CNT(x).B.BRAKE_CNT_0)

/*! @brief Format value for bitfield IPU_DP_DEBUG_CNT_BRAKE_CNT_0. */
#define BF_IPU_DP_DEBUG_CNT_BRAKE_CNT_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_DEBUG_CNT_BRAKE_CNT_0) & BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_0)

/*! @brief Set the BRAKE_CNT_0 field to a new value. */
#define BW_IPU_DP_DEBUG_CNT_BRAKE_CNT_0(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, (HW_IPU_DP_DEBUG_CNT_RD(x) & ~BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_0) | BF_IPU_DP_DEBUG_CNT_BRAKE_CNT_0(v)))
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_CNT, field BRAKE_STATUS_EN_1[4] (RW)
 *
 * This bit enables the break/status unit #1
 */
/*@{*/
#define BP_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1 (4U) /*!< Bit position for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1. */
#define BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1 (0x00000010U) /*!< Bit mask for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1. */
#define BS_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1 field. */
#define BR_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1(x) (HW_IPU_DP_DEBUG_CNT(x).B.BRAKE_STATUS_EN_1)

/*! @brief Format value for bitfield IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1. */
#define BF_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1) & BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1)

/*! @brief Set the BRAKE_STATUS_EN_1 field to a new value. */
#define BW_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, (HW_IPU_DP_DEBUG_CNT_RD(x) & ~BM_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1) | BF_IPU_DP_DEBUG_CNT_BRAKE_STATUS_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_CNT, field BRAKE_CNT_1[7:5] (RW)
 *
 * The async flow can be broken multiple times. It possible to control which
 * breaking event will cause the interrupt. This field counts the breaking events
 * for unit #1
 */
/*@{*/
#define BP_IPU_DP_DEBUG_CNT_BRAKE_CNT_1 (5U) /*!< Bit position for IPU_DP_DEBUG_CNT_BRAKE_CNT_1. */
#define BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_1 (0x000000E0U) /*!< Bit mask for IPU_DP_DEBUG_CNT_BRAKE_CNT_1. */
#define BS_IPU_DP_DEBUG_CNT_BRAKE_CNT_1 (3U) /*!< Bit field size in bits for IPU_DP_DEBUG_CNT_BRAKE_CNT_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_CNT_BRAKE_CNT_1 field. */
#define BR_IPU_DP_DEBUG_CNT_BRAKE_CNT_1(x) (HW_IPU_DP_DEBUG_CNT(x).B.BRAKE_CNT_1)

/*! @brief Format value for bitfield IPU_DP_DEBUG_CNT_BRAKE_CNT_1. */
#define BF_IPU_DP_DEBUG_CNT_BRAKE_CNT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_DEBUG_CNT_BRAKE_CNT_1) & BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_1)

/*! @brief Set the BRAKE_CNT_1 field to a new value. */
#define BW_IPU_DP_DEBUG_CNT_BRAKE_CNT_1(x, v) (HW_IPU_DP_DEBUG_CNT_WR(x, (HW_IPU_DP_DEBUG_CNT_RD(x) & ~BM_IPU_DP_DEBUG_CNT_BRAKE_CNT_1) | BF_IPU_DP_DEBUG_CNT_BRAKE_CNT_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_DEBUG_STAT - DP Debug Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_DEBUG_STAT - DP Debug Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_debug_stat
{
    uint32_t U;
    struct _hw_ipu_dp_debug_stat_bitfields
    {
        uint32_t V_CNT_OLD_0 : 11;     /*!< [10:0]  */
        uint32_t FG_ACTIVE_0 : 1;      /*!< [11]  */
        uint32_t COMBYP_EN_OLD_0 : 1;  /*!< [12]  */
        uint32_t CYP_EN_OLD_0 : 1;     /*!< [13]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t V_CNT_OLD_1 : 11;     /*!< [26:16]  */
        uint32_t FG_ACTIVE_1 : 1;      /*!< [27]  */
        uint32_t COMBYP_EN_OLD_1 : 1;  /*!< [28]  */
        uint32_t CYP_EN_OLD_1 : 1;     /*!< [29]  */
        uint32_t RESERVED1 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_dp_debug_stat_t;

/*!
 * @name Constants and macros for entire IPU_DP_DEBUG_STAT register
 */
/*@{*/
#define HW_IPU_DP_DEBUG_STAT_ADDR(x) ((uintptr_t)(x) + 0x180C0U)

#define HW_IPU_DP_DEBUG_STAT(x)  (*(__I hw_ipu_dp_debug_stat_t *) HW_IPU_DP_DEBUG_STAT_ADDR(x))
#define HW_IPU_DP_DEBUG_STAT_RD(x) (HW_IPU_DP_DEBUG_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DP_DEBUG_STAT bitfields
 */

/*!
 * @name Register IPU_DP_DEBUG_STAT, field V_CNT_OLD_0[10:0] (RO)
 *
 * The exact row where the async flow has been broken (This filed is relevant
 * for debug unit #0)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_V_CNT_OLD_0 (0U) /*!< Bit position for IPU_DP_DEBUG_STAT_V_CNT_OLD_0. */
#define BM_IPU_DP_DEBUG_STAT_V_CNT_OLD_0 (0x000007FFU) /*!< Bit mask for IPU_DP_DEBUG_STAT_V_CNT_OLD_0. */
#define BS_IPU_DP_DEBUG_STAT_V_CNT_OLD_0 (11U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_V_CNT_OLD_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_V_CNT_OLD_0 field. */
#define BR_IPU_DP_DEBUG_STAT_V_CNT_OLD_0(x) (HW_IPU_DP_DEBUG_STAT(x).B.V_CNT_OLD_0)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field FG_ACTIVE_0[11] (RO)
 *
 * Displaying the partial frame has been started for async flow (This filed is
 * relevant for debug unit #0)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_FG_ACTIVE_0 (11U) /*!< Bit position for IPU_DP_DEBUG_STAT_FG_ACTIVE_0. */
#define BM_IPU_DP_DEBUG_STAT_FG_ACTIVE_0 (0x00000800U) /*!< Bit mask for IPU_DP_DEBUG_STAT_FG_ACTIVE_0. */
#define BS_IPU_DP_DEBUG_STAT_FG_ACTIVE_0 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_FG_ACTIVE_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_FG_ACTIVE_0 field. */
#define BR_IPU_DP_DEBUG_STAT_FG_ACTIVE_0(x) (HW_IPU_DP_DEBUG_STAT(x).B.FG_ACTIVE_0)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field COMBYP_EN_OLD_0[12] (RO)
 *
 * the async flow has been broken in the middle of combining (This filed is
 * relevant for debug unit #0)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0 (12U) /*!< Bit position for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0. */
#define BM_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0 (0x00001000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0. */
#define BS_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0 field. */
#define BR_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_0(x) (HW_IPU_DP_DEBUG_STAT(x).B.COMBYP_EN_OLD_0)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field CYP_EN_OLD_0[13] (RO)
 *
 * The async flow has been broken in the middle of a cursor (This filed is
 * relevant for debug unit #0)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_CYP_EN_OLD_0 (13U) /*!< Bit position for IPU_DP_DEBUG_STAT_CYP_EN_OLD_0. */
#define BM_IPU_DP_DEBUG_STAT_CYP_EN_OLD_0 (0x00002000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_CYP_EN_OLD_0. */
#define BS_IPU_DP_DEBUG_STAT_CYP_EN_OLD_0 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_CYP_EN_OLD_0. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_CYP_EN_OLD_0 field. */
#define BR_IPU_DP_DEBUG_STAT_CYP_EN_OLD_0(x) (HW_IPU_DP_DEBUG_STAT(x).B.CYP_EN_OLD_0)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field V_CNT_OLD_1[26:16] (RO)
 *
 * The exact row where the async flow has been broken (This filed is relevant
 * for debug unit #0)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_V_CNT_OLD_1 (16U) /*!< Bit position for IPU_DP_DEBUG_STAT_V_CNT_OLD_1. */
#define BM_IPU_DP_DEBUG_STAT_V_CNT_OLD_1 (0x07FF0000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_V_CNT_OLD_1. */
#define BS_IPU_DP_DEBUG_STAT_V_CNT_OLD_1 (11U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_V_CNT_OLD_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_V_CNT_OLD_1 field. */
#define BR_IPU_DP_DEBUG_STAT_V_CNT_OLD_1(x) (HW_IPU_DP_DEBUG_STAT(x).B.V_CNT_OLD_1)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field FG_ACTIVE_1[27] (RO)
 *
 * Displaying the partial frame has been started (This filed is relevant for
 * debug unit #1)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_FG_ACTIVE_1 (27U) /*!< Bit position for IPU_DP_DEBUG_STAT_FG_ACTIVE_1. */
#define BM_IPU_DP_DEBUG_STAT_FG_ACTIVE_1 (0x08000000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_FG_ACTIVE_1. */
#define BS_IPU_DP_DEBUG_STAT_FG_ACTIVE_1 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_FG_ACTIVE_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_FG_ACTIVE_1 field. */
#define BR_IPU_DP_DEBUG_STAT_FG_ACTIVE_1(x) (HW_IPU_DP_DEBUG_STAT(x).B.FG_ACTIVE_1)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field COMBYP_EN_OLD_1[28] (RO)
 *
 * the async1 flow has been broken in the middle of combining (This filed is
 * relevant for debug unit #1)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1 (28U) /*!< Bit position for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1. */
#define BM_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1 (0x10000000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1. */
#define BS_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1 field. */
#define BR_IPU_DP_DEBUG_STAT_COMBYP_EN_OLD_1(x) (HW_IPU_DP_DEBUG_STAT(x).B.COMBYP_EN_OLD_1)
/*@}*/

/*!
 * @name Register IPU_DP_DEBUG_STAT, field CYP_EN_OLD_1[29] (RO)
 *
 * The async flow has been broken in the middle of a cursor (This filed is
 * relevant for debug unit #1)
 */
/*@{*/
#define BP_IPU_DP_DEBUG_STAT_CYP_EN_OLD_1 (29U) /*!< Bit position for IPU_DP_DEBUG_STAT_CYP_EN_OLD_1. */
#define BM_IPU_DP_DEBUG_STAT_CYP_EN_OLD_1 (0x20000000U) /*!< Bit mask for IPU_DP_DEBUG_STAT_CYP_EN_OLD_1. */
#define BS_IPU_DP_DEBUG_STAT_CYP_EN_OLD_1 (1U) /*!< Bit field size in bits for IPU_DP_DEBUG_STAT_CYP_EN_OLD_1. */

/*! @brief Read current value of the IPU_DP_DEBUG_STAT_CYP_EN_OLD_1 field. */
#define BR_IPU_DP_DEBUG_STAT_CYP_EN_OLD_1(x) (HW_IPU_DP_DEBUG_STAT(x).B.CYP_EN_OLD_1)
/*@}*/
/*******************************************************************************
 * HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1 - DP Graphic Window Control Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1 - DP Graphic Window Control Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains common configuration parameters for the DP.
 */
typedef union _hw_ipu_dp_graph_wind_ctrl_async1
{
    uint32_t U;
    struct _hw_ipu_dp_graph_wind_ctrl_async1_bitfields
    {
        uint32_t DP_GWCKB_ASYNC1 : 8;  /*!< [7:0]  */
        uint32_t DP_GWCKG_ASYNC1 : 8;  /*!< [15:8]  */
        uint32_t DP_GWCKR_ASYNC1 : 8;  /*!< [23:16]  */
        uint32_t DP_GWAV_ASYNC1 : 8;   /*!< [31:24]  */
    } B;
} hw_ipu_dp_graph_wind_ctrl_async1_t;

/*!
 * @name Constants and macros for entire IPU_DP_GRAPH_WIND_CTRL_ASYNC1 register
 */
/*@{*/
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_ADDR(x) ((uintptr_t)(x) + 0x180C0U)

#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x) (*(__IO hw_ipu_dp_graph_wind_ctrl_async1_t *) HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_ADDR(x))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).U)
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).U = (v))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_SET(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) |  (v)))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_CLR(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) & ~(v)))
#define HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_TOG(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GRAPH_WIND_CTRL_ASYNC1 bitfields
 */

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC1, field DP_GWCKB_ASYNC1[7:0] (RW)
 *
 * GWCKB - Graphic Window Color Keying Blue Component Defines the blue component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No blue
 * - 11111111 - Full blue
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1 (0U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1 (0x000000FFU) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).B.DP_GWCKB_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1)

/*! @brief Set the DP_GWCKB_ASYNC1 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKB_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC1, field DP_GWCKG_ASYNC1[15:8] (RW)
 *
 * GWCKG - Graphic Window Color Keying Green Component Defines the green
 * component of graphic window color keying.
 *
 * Values:
 * - 00000000 - No Green
 * - 11111111 - Full Green
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1 (8U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1 (0x0000FF00U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).B.DP_GWCKG_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1)

/*! @brief Set the DP_GWCKG_ASYNC1 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKG_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC1, field DP_GWCKR_ASYNC1[23:16] (RW)
 *
 * GWCKR - Graphic Window Color Keying Red Component Defines the red component
 * of graphic window color keying.
 *
 * Values:
 * - 00000000 - No red
 * - 11111111 - Full red
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1 (16U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1 (0x00FF0000U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).B.DP_GWCKR_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1)

/*! @brief Set the DP_GWCKR_ASYNC1 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWCKR_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GRAPH_WIND_CTRL_ASYNC1, field DP_GWAV_ASYNC1[31:24] (RW)
 *
 * GWAV - Graphic Window Alpha Value Defines the alpha value of graphic window
 * used for alpha blending between graphic window and full plane. The Value the
 * number that writing to GWAV register. The Actual Value the number, that insert
 * to calculation in Combining Module. If Value = < 0.5- 1/256 (01111111) then
 * Actual Value = Value. If Value >= 0.5 (10000000), then Actual Value = Value +
 * 1/256.
 *
 * Values:
 * - 00000000 - Actual value is 00000000; Graphic window totally opaque i.e.
 *     overlay on LCD screen
 * - 01111111 - Actual value is 01111111;
 * - 10000000 - Actual value is 10000001
 * - 10000001 - Actual value is 10000010
 * - 11111110 - Actual value is 11111111
 * - 11111111 - Actual value is 100000000;Graphic window totally transparent
 *     i.e. not displayed on LCD screen
 */
/*@{*/
#define BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1 (24U) /*!< Bit position for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1. */
#define BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1 (0xFF000000U) /*!< Bit mask for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1. */
#define BS_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1. */

/*! @brief Read current value of the IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1 field. */
#define BR_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1(x) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1(x).B.DP_GWAV_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1. */
#define BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1) & BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1)

/*! @brief Set the DP_GWAV_ASYNC1 field to a new value. */
#define BW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1(x, v) (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_WR(x, (HW_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_RD(x) & ~BM_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1) | BF_IPU_DP_GRAPH_WIND_CTRL_ASYNC1_DP_GWAV_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_FG_POS_ASYNC1 - DP Partial Plane Window Position Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_FG_POS_ASYNC1 - DP Partial Plane Window Position Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The DP partial plane Window Position Register is used to determine the
 * starting position of the partial plane window relative to BG window position. This
 * Register is used for the synchronous flow only.
 */
typedef union _hw_ipu_dp_fg_pos_async1
{
    uint32_t U;
    struct _hw_ipu_dp_fg_pos_async1_bitfields
    {
        uint32_t DP_FGYP_ASYNC1 : 11;  /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t DP_FGXP_ASYNC1 : 11;  /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dp_fg_pos_async1_t;

/*!
 * @name Constants and macros for entire IPU_DP_FG_POS_ASYNC1 register
 */
/*@{*/
#define HW_IPU_DP_FG_POS_ASYNC1_ADDR(x) ((uintptr_t)(x) + 0x180C4U)

#define HW_IPU_DP_FG_POS_ASYNC1(x) (*(__IO hw_ipu_dp_fg_pos_async1_t *) HW_IPU_DP_FG_POS_ASYNC1_ADDR(x))
#define HW_IPU_DP_FG_POS_ASYNC1_RD(x) (HW_IPU_DP_FG_POS_ASYNC1(x).U)
#define HW_IPU_DP_FG_POS_ASYNC1_WR(x, v) (HW_IPU_DP_FG_POS_ASYNC1(x).U = (v))
#define HW_IPU_DP_FG_POS_ASYNC1_SET(x, v) (HW_IPU_DP_FG_POS_ASYNC1_WR(x, HW_IPU_DP_FG_POS_ASYNC1_RD(x) |  (v)))
#define HW_IPU_DP_FG_POS_ASYNC1_CLR(x, v) (HW_IPU_DP_FG_POS_ASYNC1_WR(x, HW_IPU_DP_FG_POS_ASYNC1_RD(x) & ~(v)))
#define HW_IPU_DP_FG_POS_ASYNC1_TOG(x, v) (HW_IPU_DP_FG_POS_ASYNC1_WR(x, HW_IPU_DP_FG_POS_ASYNC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_FG_POS_ASYNC1 bitfields
 */

/*!
 * @name Register IPU_DP_FG_POS_ASYNC1, field DP_FGYP_ASYNC1[10:0] (RW)
 *
 * FGYP partial plane window Y position partial plane Window Y Position -
 * Specifies the number of lines between the start of full plane windows Y position and
 * the beginning of the first data.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1 (0U) /*!< Bit position for IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1. */
#define BM_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1 (0x000007FFU) /*!< Bit mask for IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1. */
#define BS_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1 (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1. */

/*! @brief Read current value of the IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1 field. */
#define BR_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1(x) (HW_IPU_DP_FG_POS_ASYNC1(x).B.DP_FGYP_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1. */
#define BF_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1) & BM_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1)

/*! @brief Set the DP_FGYP_ASYNC1 field to a new value. */
#define BW_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1(x, v) (HW_IPU_DP_FG_POS_ASYNC1_WR(x, (HW_IPU_DP_FG_POS_ASYNC1_RD(x) & ~BM_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1) | BF_IPU_DP_FG_POS_ASYNC1_DP_FGYP_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_FG_POS_ASYNC1, field DP_FGXP_ASYNC1[26:16] (RW)
 *
 * FGXP partial plane Window X Position. partial plane Window X Position -
 * Specifies the number of pixels between the start of full plane window X position
 * and the beginning of the first data of new line.
 */
/*@{*/
#define BP_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1 (16U) /*!< Bit position for IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1. */
#define BM_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1 (0x07FF0000U) /*!< Bit mask for IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1. */
#define BS_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1 (11U) /*!< Bit field size in bits for IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1. */

/*! @brief Read current value of the IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1 field. */
#define BR_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1(x) (HW_IPU_DP_FG_POS_ASYNC1(x).B.DP_FGXP_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1. */
#define BF_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1) & BM_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1)

/*! @brief Set the DP_FGXP_ASYNC1 field to a new value. */
#define BW_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1(x, v) (HW_IPU_DP_FG_POS_ASYNC1_WR(x, (HW_IPU_DP_FG_POS_ASYNC1_RD(x) & ~BM_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1) | BF_IPU_DP_FG_POS_ASYNC1_DP_FGXP_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_POS_ASYNC1 - DP Cursor Postion and Size Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_POS_ASYNC1 - DP Cursor Postion and Size Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Cursor Position Register is used to determine the starting position
 * of the cursor relative to BG windows position.
 */
typedef union _hw_ipu_dp_cur_pos_async1
{
    uint32_t U;
    struct _hw_ipu_dp_cur_pos_async1_bitfields
    {
        uint32_t DP_CXW_ASYNC1 : 11;   /*!< [10:0]  */
        uint32_t DP_CXP_ASYNC1 : 5;    /*!< [15:11]  */
        uint32_t DP_CYH_ASYNC1 : 11;   /*!< [26:16]  */
        uint32_t DP_CYP_ASYNC1 : 5;    /*!< [31:27]  */
    } B;
} hw_ipu_dp_cur_pos_async1_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_POS_ASYNC1 register
 */
/*@{*/
#define HW_IPU_DP_CUR_POS_ASYNC1_ADDR(x) ((uintptr_t)(x) + 0x180C8U)

#define HW_IPU_DP_CUR_POS_ASYNC1(x) (*(__IO hw_ipu_dp_cur_pos_async1_t *) HW_IPU_DP_CUR_POS_ASYNC1_ADDR(x))
#define HW_IPU_DP_CUR_POS_ASYNC1_RD(x) (HW_IPU_DP_CUR_POS_ASYNC1(x).U)
#define HW_IPU_DP_CUR_POS_ASYNC1_WR(x, v) (HW_IPU_DP_CUR_POS_ASYNC1(x).U = (v))
#define HW_IPU_DP_CUR_POS_ASYNC1_SET(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, HW_IPU_DP_CUR_POS_ASYNC1_RD(x) |  (v)))
#define HW_IPU_DP_CUR_POS_ASYNC1_CLR(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, HW_IPU_DP_CUR_POS_ASYNC1_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_POS_ASYNC1_TOG(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, HW_IPU_DP_CUR_POS_ASYNC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_POS_ASYNC1 bitfields
 */

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC1, field DP_CXW_ASYNC1[10:0] (RW)
 *
 * CXW - Cursor Width. Specifies the width of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1 (0U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1. */
#define BM_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1 (0x000007FFU) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1. */
#define BS_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1 (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1 field. */
#define BR_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1(x) (HW_IPU_DP_CUR_POS_ASYNC1(x).B.DP_CXW_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1. */
#define BF_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1) & BM_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1)

/*! @brief Set the DP_CXW_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, (HW_IPU_DP_CUR_POS_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1) | BF_IPU_DP_CUR_POS_ASYNC1_DP_CXW_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC1, field DP_CXP_ASYNC1[15:11] (RW)
 *
 * CXP - Cursor X Position Represents the cursors horizontal starting position X
 * in pixel count (from 0 to CXW).
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1 (11U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1. */
#define BM_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1 (0x0000F800U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1. */
#define BS_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1 (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1 field. */
#define BR_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1(x) (HW_IPU_DP_CUR_POS_ASYNC1(x).B.DP_CXP_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1. */
#define BF_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1) & BM_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1)

/*! @brief Set the DP_CXP_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, (HW_IPU_DP_CUR_POS_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1) | BF_IPU_DP_CUR_POS_ASYNC1_DP_CXP_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC1, field DP_CYH_ASYNC1[26:16] (RW)
 *
 * CYH - Cursor Height Specifies the height of the hardware cursor in pixels.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1 (16U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1. */
#define BM_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1 (0x07FF0000U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1. */
#define BS_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1 (11U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1 field. */
#define BR_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1(x) (HW_IPU_DP_CUR_POS_ASYNC1(x).B.DP_CYH_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1. */
#define BF_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1) & BM_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1)

/*! @brief Set the DP_CYH_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, (HW_IPU_DP_CUR_POS_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1) | BF_IPU_DP_CUR_POS_ASYNC1_DP_CYH_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_POS_ASYNC1, field DP_CYP_ASYNC1[31:27] (RW)
 *
 * CYP - Cursor Y Position Represents the cursors vertical starting position Y
 * in pixel count (from 0 to CYH).Live View Resolution Mode.
 */
/*@{*/
#define BP_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1 (27U) /*!< Bit position for IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1. */
#define BM_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1 (0xF8000000U) /*!< Bit mask for IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1. */
#define BS_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1 (5U) /*!< Bit field size in bits for IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1 field. */
#define BR_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1(x) (HW_IPU_DP_CUR_POS_ASYNC1(x).B.DP_CYP_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1. */
#define BF_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1) & BM_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1)

/*! @brief Set the DP_CYP_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1(x, v) (HW_IPU_DP_CUR_POS_ASYNC1_WR(x, (HW_IPU_DP_CUR_POS_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1) | BF_IPU_DP_CUR_POS_ASYNC1_DP_CYP_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CUR_MAP_ASYNC1 - DP Color Cursor Mapping Async 1 Flow Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CUR_MAP_ASYNC1 - DP Color Cursor Mapping Async 1 Flow Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LCD Color Cursor Mapping Register defines the color of the cursor in
 * passive or TFT color modes.
 */
typedef union _hw_ipu_dp_cur_map_async1
{
    uint32_t U;
    struct _hw_ipu_dp_cur_map_async1_bitfields
    {
        uint32_t DP_CUR_COL_R_ASYNC1 : 8; /*!< [7:0]  */
        uint32_t DP_CUR_COL_G_ASYNC1 : 8; /*!< [15:8]  */
        uint32_t DP_CUR_COL_B_ASYNC1 : 8; /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_dp_cur_map_async1_t;

/*!
 * @name Constants and macros for entire IPU_DP_CUR_MAP_ASYNC1 register
 */
/*@{*/
#define HW_IPU_DP_CUR_MAP_ASYNC1_ADDR(x) ((uintptr_t)(x) + 0x180CCU)

#define HW_IPU_DP_CUR_MAP_ASYNC1(x) (*(__IO hw_ipu_dp_cur_map_async1_t *) HW_IPU_DP_CUR_MAP_ASYNC1_ADDR(x))
#define HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) (HW_IPU_DP_CUR_MAP_ASYNC1(x).U)
#define HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1(x).U = (v))
#define HW_IPU_DP_CUR_MAP_ASYNC1_SET(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) |  (v)))
#define HW_IPU_DP_CUR_MAP_ASYNC1_CLR(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) & ~(v)))
#define HW_IPU_DP_CUR_MAP_ASYNC1_TOG(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CUR_MAP_ASYNC1 bitfields
 */

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC1, field DP_CUR_COL_R_ASYNC1[7:0] (RW)
 *
 * CUR_COL_R - Cursor Red Field Defines the Red component of the cursor color in
 * color mode
 *
 * Values:
 * - 00000000 - No Red.
 * - 11111111 - Full Red.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1 (0U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1. */
#define BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1 (0x000000FFU) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1. */
#define BS_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1(x) (HW_IPU_DP_CUR_MAP_ASYNC1(x).B.DP_CUR_COL_R_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1. */
#define BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1) & BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1)

/*! @brief Set the DP_CUR_COL_R_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1) | BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_R_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC1, field DP_CUR_COL_G_ASYNC1[15:8] (RW)
 *
 * CUR_COL_G - Cursor Green Field Defines the Green component of the cursor
 * color in color mode
 *
 * Values:
 * - 00000000 - No Green.
 * - 11111111 - Full Green.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1 (8U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1. */
#define BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1 (0x0000FF00U) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1. */
#define BS_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1(x) (HW_IPU_DP_CUR_MAP_ASYNC1(x).B.DP_CUR_COL_G_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1. */
#define BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1) & BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1)

/*! @brief Set the DP_CUR_COL_G_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1) | BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_G_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CUR_MAP_ASYNC1, field DP_CUR_COL_B_ASYNC1[23:16] (RW)
 *
 * CUR_COL_B - Cursor Blue Field Defines the Blue component of the cursor color
 * in color mode
 *
 * Values:
 * - 00000000 - No Blue.
 * - 11111111 - Full Blue.
 */
/*@{*/
#define BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1 (16U) /*!< Bit position for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1. */
#define BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1 (0x00FF0000U) /*!< Bit mask for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1. */
#define BS_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1 (8U) /*!< Bit field size in bits for IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1 field. */
#define BR_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1(x) (HW_IPU_DP_CUR_MAP_ASYNC1(x).B.DP_CUR_COL_B_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1. */
#define BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1) & BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1)

/*! @brief Set the DP_CUR_COL_B_ASYNC1 field to a new value. */
#define BW_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1(x, v) (HW_IPU_DP_CUR_MAP_ASYNC1_WR(x, (HW_IPU_DP_CUR_MAP_ASYNC1_RD(x) & ~BM_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1) | BF_IPU_DP_CUR_MAP_ASYNC1_DP_CUR_COL_B_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_C_ASYNC1_i - DP Gamma Constants Async 1 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_C_ASYNC1_i - DP Gamma Constants Async 1 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains CONSTANTi parameters used for gamma correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_c_async1_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_c_async1_i_bitfields
    {
        uint32_t DP_GAMMA_C_ASYNC1_2i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t DP_GAMMA_C_ASYNC1_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_dp_gamma_c_async1_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_C_ASYNC1_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_ADDR(x) ((uintptr_t)(x) + 0x180D0U)

#define HW_IPU_DP_GAMMA_C_ASYNC1_i(x) (*(__IO hw_ipu_dp_gamma_c_async1_i_t *) HW_IPU_DP_GAMMA_C_ASYNC1_i_ADDR(x))
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) (HW_IPU_DP_GAMMA_C_ASYNC1_i(x).U)
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i(x).U = (v))
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_SET(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_CLR(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_C_ASYNC1_i_TOG(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_C_ASYNC1_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_C_ASYNC1_i, field DP_GAMMA_C_ASYNC1_2i[8:0] (RW)
 *
 * CONSTANTi parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i (0U) /*!< Bit position for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i. */
#define BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i (0x000001FFU) /*!< Bit mask for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i. */
#define BS_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i (9U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i field. */
#define BR_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i(x) (HW_IPU_DP_GAMMA_C_ASYNC1_i(x).B.DP_GAMMA_C_ASYNC1_2i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i. */
#define BF_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i) & BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i)

/*! @brief Set the DP_GAMMA_C_ASYNC1_2i field to a new value. */
#define BW_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, (HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) & ~BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i) | BF_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_C_ASYNC1_i, field DP_GAMMA_C_ASYNC1_2i_1[24:16] (RW)
 *
 * CONSTANTi+1 parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1 (16U) /*!< Bit position for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1. */
#define BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1. */
#define BS_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1 (9U) /*!< Bit field size in bits for IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1 field. */
#define BR_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1(x) (HW_IPU_DP_GAMMA_C_ASYNC1_i(x).B.DP_GAMMA_C_ASYNC1_2i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1. */
#define BF_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1) & BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1)

/*! @brief Set the DP_GAMMA_C_ASYNC1_2i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1(x, v) (HW_IPU_DP_GAMMA_C_ASYNC1_i_WR(x, (HW_IPU_DP_GAMMA_C_ASYNC1_i_RD(x) & ~BM_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1) | BF_IPU_DP_GAMMA_C_ASYNC1_i_DP_GAMMA_C_ASYNC1_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_GAMMA_S_ASYN1_i - DP Gamma Correction Slope Async 1 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_GAMMA_S_ASYN1_i - DP Gamma Correction Slope Async 1 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contains SLOPEi parameters used for Gamma Correction inside
 * the display processor (DP).
 */
typedef union _hw_ipu_dp_gamma_s_asyn1_i
{
    uint32_t U;
    struct _hw_ipu_dp_gamma_s_asyn1_i_bitfields
    {
        uint32_t DP_GAMMA_S_ASYNC1_4i : 8; /*!< [7:0]  */
        uint32_t DP_GAMMA_S_ASYNC1_4i_1 : 8; /*!< [15:8]  */
        uint32_t DP_GAMMA_S_ASYNC1_4i_2 : 8; /*!< [23:16]  */
        uint32_t DP_GAMMA_S_ASYNC1_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dp_gamma_s_asyn1_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_GAMMA_S_ASYN1_i register
 */
/*@{*/
#define HW_IPU_DP_GAMMA_S_ASYN1_i_ADDR(x) ((uintptr_t)(x) + 0x180F0U)

#define HW_IPU_DP_GAMMA_S_ASYN1_i(x) (*(__IO hw_ipu_dp_gamma_s_asyn1_i_t *) HW_IPU_DP_GAMMA_S_ASYN1_i_ADDR(x))
#define HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).U)
#define HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).U = (v))
#define HW_IPU_DP_GAMMA_S_ASYN1_i_SET(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) |  (v)))
#define HW_IPU_DP_GAMMA_S_ASYN1_i_CLR(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) & ~(v)))
#define HW_IPU_DP_GAMMA_S_ASYN1_i_TOG(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_GAMMA_S_ASYN1_i bitfields
 */

/*!
 * @name Register IPU_DP_GAMMA_S_ASYN1_i, field DP_GAMMA_S_ASYNC1_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i (0U) /*!< Bit position for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i. */
#define BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i (0x000000FFU) /*!< Bit mask for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i. */
#define BS_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i field. */
#define BR_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i(x) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).B.DP_GAMMA_S_ASYNC1_4i)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i. */
#define BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i) & BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i)

/*! @brief Set the DP_GAMMA_S_ASYNC1_4i field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i) | BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYN1_i, field DP_GAMMA_S_ASYNC1_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1 (8U) /*!< Bit position for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1. */
#define BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1. */
#define BS_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1 field. */
#define BR_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1(x) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).B.DP_GAMMA_S_ASYNC1_4i_1)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1. */
#define BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1) & BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1)

/*! @brief Set the DP_GAMMA_S_ASYNC1_4i_1 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1) | BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYN1_i, field DP_GAMMA_S_ASYNC1_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2 (16U) /*!< Bit position for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2. */
#define BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2. */
#define BS_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2 field. */
#define BR_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2(x) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).B.DP_GAMMA_S_ASYNC1_4i_2)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2. */
#define BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2) & BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2)

/*! @brief Set the DP_GAMMA_S_ASYNC1_4i_2 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2) | BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_DP_GAMMA_S_ASYN1_i, field DP_GAMMA_S_ASYNC1_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Gamma Correction.
 */
/*@{*/
#define BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3 (24U) /*!< Bit position for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3. */
#define BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3 (0xFF000000U) /*!< Bit mask for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3. */
#define BS_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3 (8U) /*!< Bit field size in bits for IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3. */

/*! @brief Read current value of the IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3 field. */
#define BR_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3(x) (HW_IPU_DP_GAMMA_S_ASYN1_i(x).B.DP_GAMMA_S_ASYNC1_4i_3)

/*! @brief Format value for bitfield IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3. */
#define BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3) & BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3)

/*! @brief Set the DP_GAMMA_S_ASYNC1_4i_3 field to a new value. */
#define BW_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3(x, v) (HW_IPU_DP_GAMMA_S_ASYN1_i_WR(x, (HW_IPU_DP_GAMMA_S_ASYN1_i_RD(x) & ~BM_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3) | BF_IPU_DP_GAMMA_S_ASYN1_i_DP_GAMMA_S_ASYNC1_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSCA_ASYNC1_i - DP Color Space Converstion Control Async 1 Flow Register i
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSCA_ASYNC1_i - DP Color Space Converstion Control Async 1 Flow Register i (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csca_async1_i
{
    uint32_t U;
    struct _hw_ipu_dp_csca_async1_i_bitfields
    {
        uint32_t DP_CSC_A_ASYNC1_2i : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_A_ASYNC1_2i_1 : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_dp_csca_async1_i_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSCA_ASYNC1_i register
 */
/*@{*/
#define HW_IPU_DP_CSCA_ASYNC1_i_ADDR(x) ((uintptr_t)(x) + 0x18100U)

#define HW_IPU_DP_CSCA_ASYNC1_i(x) (*(__IO hw_ipu_dp_csca_async1_i_t *) HW_IPU_DP_CSCA_ASYNC1_i_ADDR(x))
#define HW_IPU_DP_CSCA_ASYNC1_i_RD(x) (HW_IPU_DP_CSCA_ASYNC1_i(x).U)
#define HW_IPU_DP_CSCA_ASYNC1_i_WR(x, v) (HW_IPU_DP_CSCA_ASYNC1_i(x).U = (v))
#define HW_IPU_DP_CSCA_ASYNC1_i_SET(x, v) (HW_IPU_DP_CSCA_ASYNC1_i_WR(x, HW_IPU_DP_CSCA_ASYNC1_i_RD(x) |  (v)))
#define HW_IPU_DP_CSCA_ASYNC1_i_CLR(x, v) (HW_IPU_DP_CSCA_ASYNC1_i_WR(x, HW_IPU_DP_CSCA_ASYNC1_i_RD(x) & ~(v)))
#define HW_IPU_DP_CSCA_ASYNC1_i_TOG(x, v) (HW_IPU_DP_CSCA_ASYNC1_i_WR(x, HW_IPU_DP_CSCA_ASYNC1_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSCA_ASYNC1_i bitfields
 */

/*!
 * @name Register IPU_DP_CSCA_ASYNC1_i, field DP_CSC_A_ASYNC1_2i[9:0] (RW)
 *
 * A<2*i> parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i (0U) /*!< Bit position for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i. */
#define BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i (0x000003FFU) /*!< Bit mask for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i. */
#define BS_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i (10U) /*!< Bit field size in bits for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i. */

/*! @brief Read current value of the IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i field. */
#define BR_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i(x) (HW_IPU_DP_CSCA_ASYNC1_i(x).B.DP_CSC_A_ASYNC1_2i)

/*! @brief Format value for bitfield IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i. */
#define BF_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i) & BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i)

/*! @brief Set the DP_CSC_A_ASYNC1_2i field to a new value. */
#define BW_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i(x, v) (HW_IPU_DP_CSCA_ASYNC1_i_WR(x, (HW_IPU_DP_CSCA_ASYNC1_i_RD(x) & ~BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i) | BF_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSCA_ASYNC1_i, field DP_CSC_A_ASYNC1_2i_1[25:16] (RW)
 *
 * A<2*i+1> parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1 (16U) /*!< Bit position for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1. */
#define BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1 (0x03FF0000U) /*!< Bit mask for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1. */
#define BS_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1 (10U) /*!< Bit field size in bits for IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1. */

/*! @brief Read current value of the IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1 field. */
#define BR_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1(x) (HW_IPU_DP_CSCA_ASYNC1_i(x).B.DP_CSC_A_ASYNC1_2i_1)

/*! @brief Format value for bitfield IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1. */
#define BF_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1) & BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1)

/*! @brief Set the DP_CSC_A_ASYNC1_2i_1 field to a new value. */
#define BW_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1(x, v) (HW_IPU_DP_CSCA_ASYNC1_i_WR(x, (HW_IPU_DP_CSCA_ASYNC1_i_RD(x) & ~BM_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1) | BF_IPU_DP_CSCA_ASYNC1_i_DP_CSC_A_ASYNC1_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSC_ASYNC1_0 - DP Color Conversion Control Async 1 Flow Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSC_ASYNC1_0 - DP Color Conversion Control Async 1 Flow Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csc_async1_0
{
    uint32_t U;
    struct _hw_ipu_dp_csc_async1_0_bitfields
    {
        uint32_t DP_CSC_A8_ASYNC1 : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t DP_CSC_B0_ASYNC1 : 14; /*!< [29:16]  */
        uint32_t DP_CSC_S0_ASYNC1 : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dp_csc_async1_0_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSC_ASYNC1_0 register
 */
/*@{*/
#define HW_IPU_DP_CSC_ASYNC1_0_ADDR(x) ((uintptr_t)(x) + 0x18110U)

#define HW_IPU_DP_CSC_ASYNC1_0(x) (*(__IO hw_ipu_dp_csc_async1_0_t *) HW_IPU_DP_CSC_ASYNC1_0_ADDR(x))
#define HW_IPU_DP_CSC_ASYNC1_0_RD(x) (HW_IPU_DP_CSC_ASYNC1_0(x).U)
#define HW_IPU_DP_CSC_ASYNC1_0_WR(x, v) (HW_IPU_DP_CSC_ASYNC1_0(x).U = (v))
#define HW_IPU_DP_CSC_ASYNC1_0_SET(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, HW_IPU_DP_CSC_ASYNC1_0_RD(x) |  (v)))
#define HW_IPU_DP_CSC_ASYNC1_0_CLR(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, HW_IPU_DP_CSC_ASYNC1_0_RD(x) & ~(v)))
#define HW_IPU_DP_CSC_ASYNC1_0_TOG(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, HW_IPU_DP_CSC_ASYNC1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSC_ASYNC1_0 bitfields
 */

/*!
 * @name Register IPU_DP_CSC_ASYNC1_0, field DP_CSC_A8_ASYNC1[9:0] (RW)
 *
 * A9 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1 (0U) /*!< Bit position for IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1 (0x000003FFU) /*!< Bit mask for IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1 (10U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_0(x).B.DP_CSC_A8_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1)

/*! @brief Set the DP_CSC_A8_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, (HW_IPU_DP_CSC_ASYNC1_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_A8_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC1_0, field DP_CSC_B0_ASYNC1[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1 (16U) /*!< Bit position for IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1 (0x3FFF0000U) /*!< Bit mask for IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_0(x).B.DP_CSC_B0_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1)

/*! @brief Set the DP_CSC_B0_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, (HW_IPU_DP_CSC_ASYNC1_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_B0_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC1_0, field DP_CSC_S0_ASYNC1[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 0
 * - 11 - scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1 (30U) /*!< Bit position for IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1 (0xC0000000U) /*!< Bit mask for IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_0(x).B.DP_CSC_S0_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1)

/*! @brief Set the DP_CSC_S0_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_0_WR(x, (HW_IPU_DP_CSC_ASYNC1_0_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_0_DP_CSC_S0_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DP_CSC_ASYNC1_1 - DP Color Conversion Control Async 1 Flow Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DP_CSC_ASYNC1_1 - DP Color Conversion Control Async 1 Flow Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dp_csc_async1_1
{
    uint32_t U;
    struct _hw_ipu_dp_csc_async1_1_bitfields
    {
        uint32_t DP_CSC_B1_ASYNC1 : 14; /*!< [13:0]  */
        uint32_t DP_CSC_S1_ASYNC1 : 2; /*!< [15:14]  */
        uint32_t DP_CSC_B2_ASYNC1 : 14; /*!< [29:16]  */
        uint32_t DP_CSC_S2_ASYNC1 : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dp_csc_async1_1_t;

/*!
 * @name Constants and macros for entire IPU_DP_CSC_ASYNC1_1 register
 */
/*@{*/
#define HW_IPU_DP_CSC_ASYNC1_1_ADDR(x) ((uintptr_t)(x) + 0x18114U)

#define HW_IPU_DP_CSC_ASYNC1_1(x) (*(__IO hw_ipu_dp_csc_async1_1_t *) HW_IPU_DP_CSC_ASYNC1_1_ADDR(x))
#define HW_IPU_DP_CSC_ASYNC1_1_RD(x) (HW_IPU_DP_CSC_ASYNC1_1(x).U)
#define HW_IPU_DP_CSC_ASYNC1_1_WR(x, v) (HW_IPU_DP_CSC_ASYNC1_1(x).U = (v))
#define HW_IPU_DP_CSC_ASYNC1_1_SET(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, HW_IPU_DP_CSC_ASYNC1_1_RD(x) |  (v)))
#define HW_IPU_DP_CSC_ASYNC1_1_CLR(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, HW_IPU_DP_CSC_ASYNC1_1_RD(x) & ~(v)))
#define HW_IPU_DP_CSC_ASYNC1_1_TOG(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, HW_IPU_DP_CSC_ASYNC1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DP_CSC_ASYNC1_1 bitfields
 */

/*!
 * @name Register IPU_DP_CSC_ASYNC1_1, field DP_CSC_B1_ASYNC1[13:0] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1 (0U) /*!< Bit position for IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1 (0x00003FFFU) /*!< Bit mask for IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_1(x).B.DP_CSC_B1_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1)

/*! @brief Set the DP_CSC_B1_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, (HW_IPU_DP_CSC_ASYNC1_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_B1_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC1_1, field DP_CSC_S1_ASYNC1[15:14] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1 (14U) /*!< Bit position for IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1 (0x0000C000U) /*!< Bit mask for IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_1(x).B.DP_CSC_S1_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1)

/*! @brief Set the DP_CSC_S1_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, (HW_IPU_DP_CSC_ASYNC1_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_S1_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC1_1, field DP_CSC_B2_ASYNC1[29:16] (RW)
 *
 * B0 parameter of color conversion.
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1 (16U) /*!< Bit position for IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1 (0x3FFF0000U) /*!< Bit mask for IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1 (14U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_1(x).B.DP_CSC_B2_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1)

/*! @brief Set the DP_CSC_B2_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, (HW_IPU_DP_CSC_ASYNC1_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_B2_ASYNC1(v)))
/*@}*/

/*!
 * @name Register IPU_DP_CSC_ASYNC1_1, field DP_CSC_S2_ASYNC1[31:30] (RW)
 *
 * S0 parameter of color conversion.
 *
 * Values:
 * - 00 - scale factor of 2
 * - 01 - scale factor of 1
 * - 10 - scale factor of 011 scale factor of -1
 */
/*@{*/
#define BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1 (30U) /*!< Bit position for IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1. */
#define BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1 (0xC0000000U) /*!< Bit mask for IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1. */
#define BS_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1 (2U) /*!< Bit field size in bits for IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1. */

/*! @brief Read current value of the IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1 field. */
#define BR_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1(x) (HW_IPU_DP_CSC_ASYNC1_1(x).B.DP_CSC_S2_ASYNC1)

/*! @brief Format value for bitfield IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1. */
#define BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1) & BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1)

/*! @brief Set the DP_CSC_S2_ASYNC1 field to a new value. */
#define BW_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1(x, v) (HW_IPU_DP_CSC_ASYNC1_1_WR(x, (HW_IPU_DP_CSC_ASYNC1_1_RD(x) & ~BM_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1) | BF_IPU_DP_CSC_ASYNC1_1_DP_CSC_S2_ASYNC1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_CONF - IC Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_CONF - IC Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains control parameter for IC 3 tasks (pre-processing for
 * encoding, pre-processing for view-finder and post processing).
 */
typedef union _hw_ipu_ic_conf
{
    uint32_t U;
    struct _hw_ipu_ic_conf_bitfields
    {
        uint32_t PRPENC_EN : 1;        /*!< [0]  */
        uint32_t PRPENC_CSC1 : 1;      /*!< [1]  */
        uint32_t PRPENC_ROT_EN : 1;    /*!< [2]  */
        uint32_t RESERVED0 : 5;        /*!< [7:3]  */
        uint32_t PRPVF_EN : 1;         /*!< [8]  */
        uint32_t PRPVF_CSC1 : 1;       /*!< [9]  */
        uint32_t PRPVF_CSC2 : 1;       /*!< [10]  */
        uint32_t PRPVF_CMB : 1;        /*!< [11]  */
        uint32_t PRPVF_ROT_EN : 1;     /*!< [12]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t PP_EN : 1;            /*!< [16]  */
        uint32_t PP_CSC1 : 1;          /*!< [17]  */
        uint32_t PP_CSC2 : 1;          /*!< [18]  */
        uint32_t PP_CMB : 1;           /*!< [19]  */
        uint32_t PP_ROT_EN : 1;        /*!< [20]  */
        uint32_t RESERVED2 : 7;        /*!< [27:21]  */
        uint32_t IC_GLB_LOC_A : 1;     /*!< [28]  */
        uint32_t IC_KEY_COLOR_EN : 1;  /*!< [29]  */
        uint32_t RWS_EN : 1;           /*!< [30]  */
        uint32_t CSI_MEM_WR_EN : 1;    /*!< [31]  */
    } B;
} hw_ipu_ic_conf_t;

/*!
 * @name Constants and macros for entire IPU_IC_CONF register
 */
/*@{*/
#define HW_IPU_IC_CONF_ADDR(x)   ((uintptr_t)(x) + 0x20000U)

#define HW_IPU_IC_CONF(x)        (*(__IO hw_ipu_ic_conf_t *) HW_IPU_IC_CONF_ADDR(x))
#define HW_IPU_IC_CONF_RD(x)     (HW_IPU_IC_CONF(x).U)
#define HW_IPU_IC_CONF_WR(x, v)  (HW_IPU_IC_CONF(x).U = (v))
#define HW_IPU_IC_CONF_SET(x, v) (HW_IPU_IC_CONF_WR(x, HW_IPU_IC_CONF_RD(x) |  (v)))
#define HW_IPU_IC_CONF_CLR(x, v) (HW_IPU_IC_CONF_WR(x, HW_IPU_IC_CONF_RD(x) & ~(v)))
#define HW_IPU_IC_CONF_TOG(x, v) (HW_IPU_IC_CONF_WR(x, HW_IPU_IC_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_CONF bitfields
 */

/*!
 * @name Register IPU_IC_CONF, field PRPENC_EN[0] (RW)
 *
 * Preprocessing Task for encoding enable. This bit enables the encoding task.
 *
 * Values:
 * - 0 - Task is disabled.
 * - 1 - Task is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPENC_EN (0U)      /*!< Bit position for IPU_IC_CONF_PRPENC_EN. */
#define BM_IPU_IC_CONF_PRPENC_EN (0x00000001U) /*!< Bit mask for IPU_IC_CONF_PRPENC_EN. */
#define BS_IPU_IC_CONF_PRPENC_EN (1U)      /*!< Bit field size in bits for IPU_IC_CONF_PRPENC_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PRPENC_EN field. */
#define BR_IPU_IC_CONF_PRPENC_EN(x) (HW_IPU_IC_CONF(x).B.PRPENC_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPENC_EN. */
#define BF_IPU_IC_CONF_PRPENC_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPENC_EN) & BM_IPU_IC_CONF_PRPENC_EN)

/*! @brief Set the PRPENC_EN field to a new value. */
#define BW_IPU_IC_CONF_PRPENC_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPENC_EN) | BF_IPU_IC_CONF_PRPENC_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPENC_CSC1[1] (RW)
 *
 * Preprocessing Task for encoding color conversion enable. This bit enables
 * color conversion.
 *
 * Values:
 * - 0 - Color conversion is disabled.
 * - 1 - Color conversion is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPENC_CSC1 (1U)    /*!< Bit position for IPU_IC_CONF_PRPENC_CSC1. */
#define BM_IPU_IC_CONF_PRPENC_CSC1 (0x00000002U) /*!< Bit mask for IPU_IC_CONF_PRPENC_CSC1. */
#define BS_IPU_IC_CONF_PRPENC_CSC1 (1U)    /*!< Bit field size in bits for IPU_IC_CONF_PRPENC_CSC1. */

/*! @brief Read current value of the IPU_IC_CONF_PRPENC_CSC1 field. */
#define BR_IPU_IC_CONF_PRPENC_CSC1(x) (HW_IPU_IC_CONF(x).B.PRPENC_CSC1)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPENC_CSC1. */
#define BF_IPU_IC_CONF_PRPENC_CSC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPENC_CSC1) & BM_IPU_IC_CONF_PRPENC_CSC1)

/*! @brief Set the PRPENC_CSC1 field to a new value. */
#define BW_IPU_IC_CONF_PRPENC_CSC1(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPENC_CSC1) | BF_IPU_IC_CONF_PRPENC_CSC1(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPENC_ROT_EN[2] (RW)
 *
 * Preprocessing Rotation Task for encoding enable. This bit enable
 * Preprocessing Rotation Task for encoding.
 *
 * Values:
 * - 0 - Rotation is disabled.
 * - 1 - Rotation is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPENC_ROT_EN (2U)  /*!< Bit position for IPU_IC_CONF_PRPENC_ROT_EN. */
#define BM_IPU_IC_CONF_PRPENC_ROT_EN (0x00000004U) /*!< Bit mask for IPU_IC_CONF_PRPENC_ROT_EN. */
#define BS_IPU_IC_CONF_PRPENC_ROT_EN (1U)  /*!< Bit field size in bits for IPU_IC_CONF_PRPENC_ROT_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PRPENC_ROT_EN field. */
#define BR_IPU_IC_CONF_PRPENC_ROT_EN(x) (HW_IPU_IC_CONF(x).B.PRPENC_ROT_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPENC_ROT_EN. */
#define BF_IPU_IC_CONF_PRPENC_ROT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPENC_ROT_EN) & BM_IPU_IC_CONF_PRPENC_ROT_EN)

/*! @brief Set the PRPENC_ROT_EN field to a new value. */
#define BW_IPU_IC_CONF_PRPENC_ROT_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPENC_ROT_EN) | BF_IPU_IC_CONF_PRPENC_ROT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPVF_EN[8] (RW)
 *
 * Preprocessing Task for View-Finder enable. This bit enables the View-Finder
 * task.
 *
 * Values:
 * - 0 - Task is disabled.
 * - 1 - Task is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPVF_EN (8U)       /*!< Bit position for IPU_IC_CONF_PRPVF_EN. */
#define BM_IPU_IC_CONF_PRPVF_EN (0x00000100U) /*!< Bit mask for IPU_IC_CONF_PRPVF_EN. */
#define BS_IPU_IC_CONF_PRPVF_EN (1U)       /*!< Bit field size in bits for IPU_IC_CONF_PRPVF_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PRPVF_EN field. */
#define BR_IPU_IC_CONF_PRPVF_EN(x) (HW_IPU_IC_CONF(x).B.PRPVF_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPVF_EN. */
#define BF_IPU_IC_CONF_PRPVF_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPVF_EN) & BM_IPU_IC_CONF_PRPVF_EN)

/*! @brief Set the PRPVF_EN field to a new value. */
#define BW_IPU_IC_CONF_PRPVF_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPVF_EN) | BF_IPU_IC_CONF_PRPVF_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPVF_CSC1[9] (RW)
 *
 * Pre-processing task for view-finder first color conversion enable. This bit
 * enables first color conversion.
 *
 * Values:
 * - 0 - First color conversion is disabled.
 * - 1 - First color conversion is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPVF_CSC1 (9U)     /*!< Bit position for IPU_IC_CONF_PRPVF_CSC1. */
#define BM_IPU_IC_CONF_PRPVF_CSC1 (0x00000200U) /*!< Bit mask for IPU_IC_CONF_PRPVF_CSC1. */
#define BS_IPU_IC_CONF_PRPVF_CSC1 (1U)     /*!< Bit field size in bits for IPU_IC_CONF_PRPVF_CSC1. */

/*! @brief Read current value of the IPU_IC_CONF_PRPVF_CSC1 field. */
#define BR_IPU_IC_CONF_PRPVF_CSC1(x) (HW_IPU_IC_CONF(x).B.PRPVF_CSC1)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPVF_CSC1. */
#define BF_IPU_IC_CONF_PRPVF_CSC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPVF_CSC1) & BM_IPU_IC_CONF_PRPVF_CSC1)

/*! @brief Set the PRPVF_CSC1 field to a new value. */
#define BW_IPU_IC_CONF_PRPVF_CSC1(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPVF_CSC1) | BF_IPU_IC_CONF_PRPVF_CSC1(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPVF_CSC2[10] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPVF_CSC2 (10U)    /*!< Bit position for IPU_IC_CONF_PRPVF_CSC2. */
#define BM_IPU_IC_CONF_PRPVF_CSC2 (0x00000400U) /*!< Bit mask for IPU_IC_CONF_PRPVF_CSC2. */
#define BS_IPU_IC_CONF_PRPVF_CSC2 (1U)     /*!< Bit field size in bits for IPU_IC_CONF_PRPVF_CSC2. */

/*! @brief Read current value of the IPU_IC_CONF_PRPVF_CSC2 field. */
#define BR_IPU_IC_CONF_PRPVF_CSC2(x) (HW_IPU_IC_CONF(x).B.PRPVF_CSC2)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPVF_CSC2. */
#define BF_IPU_IC_CONF_PRPVF_CSC2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPVF_CSC2) & BM_IPU_IC_CONF_PRPVF_CSC2)

/*! @brief Set the PRPVF_CSC2 field to a new value. */
#define BW_IPU_IC_CONF_PRPVF_CSC2(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPVF_CSC2) | BF_IPU_IC_CONF_PRPVF_CSC2(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPVF_CMB[11] (RW)
 *
 * Preprocessing Task for View-Finder combining enable. This bit enables
 * combining.
 *
 * Values:
 * - 0 - Combining is disabled.
 * - 1 - Combining is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPVF_CMB (11U)     /*!< Bit position for IPU_IC_CONF_PRPVF_CMB. */
#define BM_IPU_IC_CONF_PRPVF_CMB (0x00000800U) /*!< Bit mask for IPU_IC_CONF_PRPVF_CMB. */
#define BS_IPU_IC_CONF_PRPVF_CMB (1U)      /*!< Bit field size in bits for IPU_IC_CONF_PRPVF_CMB. */

/*! @brief Read current value of the IPU_IC_CONF_PRPVF_CMB field. */
#define BR_IPU_IC_CONF_PRPVF_CMB(x) (HW_IPU_IC_CONF(x).B.PRPVF_CMB)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPVF_CMB. */
#define BF_IPU_IC_CONF_PRPVF_CMB(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPVF_CMB) & BM_IPU_IC_CONF_PRPVF_CMB)

/*! @brief Set the PRPVF_CMB field to a new value. */
#define BW_IPU_IC_CONF_PRPVF_CMB(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPVF_CMB) | BF_IPU_IC_CONF_PRPVF_CMB(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PRPVF_ROT_EN[12] (RW)
 *
 * Preprocessing Rotation Task for viewfinder enable. This bit enable
 * Preprocessing Rotation Task for viewfinder.
 *
 * Values:
 * - 0 - Rotation is disabled.
 * - 1 - Rotation is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PRPVF_ROT_EN (12U)  /*!< Bit position for IPU_IC_CONF_PRPVF_ROT_EN. */
#define BM_IPU_IC_CONF_PRPVF_ROT_EN (0x00001000U) /*!< Bit mask for IPU_IC_CONF_PRPVF_ROT_EN. */
#define BS_IPU_IC_CONF_PRPVF_ROT_EN (1U)   /*!< Bit field size in bits for IPU_IC_CONF_PRPVF_ROT_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PRPVF_ROT_EN field. */
#define BR_IPU_IC_CONF_PRPVF_ROT_EN(x) (HW_IPU_IC_CONF(x).B.PRPVF_ROT_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PRPVF_ROT_EN. */
#define BF_IPU_IC_CONF_PRPVF_ROT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PRPVF_ROT_EN) & BM_IPU_IC_CONF_PRPVF_ROT_EN)

/*! @brief Set the PRPVF_ROT_EN field to a new value. */
#define BW_IPU_IC_CONF_PRPVF_ROT_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PRPVF_ROT_EN) | BF_IPU_IC_CONF_PRPVF_ROT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PP_EN[16] (RW)
 *
 * Post-Processing Task enable. This bit enables the Post-Processing task.
 *
 * Values:
 * - 0 - Task is disabled.
 * - 1 - Task is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PP_EN (16U)         /*!< Bit position for IPU_IC_CONF_PP_EN. */
#define BM_IPU_IC_CONF_PP_EN (0x00010000U) /*!< Bit mask for IPU_IC_CONF_PP_EN. */
#define BS_IPU_IC_CONF_PP_EN (1U)          /*!< Bit field size in bits for IPU_IC_CONF_PP_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PP_EN field. */
#define BR_IPU_IC_CONF_PP_EN(x) (HW_IPU_IC_CONF(x).B.PP_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PP_EN. */
#define BF_IPU_IC_CONF_PP_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PP_EN) & BM_IPU_IC_CONF_PP_EN)

/*! @brief Set the PP_EN field to a new value. */
#define BW_IPU_IC_CONF_PP_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PP_EN) | BF_IPU_IC_CONF_PP_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PP_CSC1[17] (RW)
 *
 * Post-Processing Task color conversion YUV-->RGB enable. This bit enables
 * YUV-->RGB.
 *
 * Values:
 * - 0 - YUV-->RGB is disabled.
 * - 1 - YUV-->RGB is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PP_CSC1 (17U)       /*!< Bit position for IPU_IC_CONF_PP_CSC1. */
#define BM_IPU_IC_CONF_PP_CSC1 (0x00020000U) /*!< Bit mask for IPU_IC_CONF_PP_CSC1. */
#define BS_IPU_IC_CONF_PP_CSC1 (1U)        /*!< Bit field size in bits for IPU_IC_CONF_PP_CSC1. */

/*! @brief Read current value of the IPU_IC_CONF_PP_CSC1 field. */
#define BR_IPU_IC_CONF_PP_CSC1(x) (HW_IPU_IC_CONF(x).B.PP_CSC1)

/*! @brief Format value for bitfield IPU_IC_CONF_PP_CSC1. */
#define BF_IPU_IC_CONF_PP_CSC1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PP_CSC1) & BM_IPU_IC_CONF_PP_CSC1)

/*! @brief Set the PP_CSC1 field to a new value. */
#define BW_IPU_IC_CONF_PP_CSC1(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PP_CSC1) | BF_IPU_IC_CONF_PP_CSC1(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PP_CSC2[18] (RW)
 *
 * Post-Processing Task color conversion RGB-->YUV enable. This bit enables
 * YUV-->RGB. Reserved
 *
 * Values:
 * - 0 - RGB-->YUV is disabled.
 * - 1 - RGB-->YUV is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PP_CSC2 (18U)       /*!< Bit position for IPU_IC_CONF_PP_CSC2. */
#define BM_IPU_IC_CONF_PP_CSC2 (0x00040000U) /*!< Bit mask for IPU_IC_CONF_PP_CSC2. */
#define BS_IPU_IC_CONF_PP_CSC2 (1U)        /*!< Bit field size in bits for IPU_IC_CONF_PP_CSC2. */

/*! @brief Read current value of the IPU_IC_CONF_PP_CSC2 field. */
#define BR_IPU_IC_CONF_PP_CSC2(x) (HW_IPU_IC_CONF(x).B.PP_CSC2)

/*! @brief Format value for bitfield IPU_IC_CONF_PP_CSC2. */
#define BF_IPU_IC_CONF_PP_CSC2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PP_CSC2) & BM_IPU_IC_CONF_PP_CSC2)

/*! @brief Set the PP_CSC2 field to a new value. */
#define BW_IPU_IC_CONF_PP_CSC2(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PP_CSC2) | BF_IPU_IC_CONF_PP_CSC2(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PP_CMB[19] (RW)
 *
 * Post-Processing Task combining enable. This bit enables combining.
 *
 * Values:
 * - 0 - Combining is disabled.
 * - 1 - Combining is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PP_CMB (19U)        /*!< Bit position for IPU_IC_CONF_PP_CMB. */
#define BM_IPU_IC_CONF_PP_CMB (0x00080000U) /*!< Bit mask for IPU_IC_CONF_PP_CMB. */
#define BS_IPU_IC_CONF_PP_CMB (1U)         /*!< Bit field size in bits for IPU_IC_CONF_PP_CMB. */

/*! @brief Read current value of the IPU_IC_CONF_PP_CMB field. */
#define BR_IPU_IC_CONF_PP_CMB(x) (HW_IPU_IC_CONF(x).B.PP_CMB)

/*! @brief Format value for bitfield IPU_IC_CONF_PP_CMB. */
#define BF_IPU_IC_CONF_PP_CMB(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PP_CMB) & BM_IPU_IC_CONF_PP_CMB)

/*! @brief Set the PP_CMB field to a new value. */
#define BW_IPU_IC_CONF_PP_CMB(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PP_CMB) | BF_IPU_IC_CONF_PP_CMB(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field PP_ROT_EN[20] (RW)
 *
 * Post-Processing Rotation Task enable. This bit enable Post-Processing
 * Rotation Task.
 *
 * Values:
 * - 0 - Rotation is disabled.
 * - 1 - Rotation is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_PP_ROT_EN (20U)     /*!< Bit position for IPU_IC_CONF_PP_ROT_EN. */
#define BM_IPU_IC_CONF_PP_ROT_EN (0x00100000U) /*!< Bit mask for IPU_IC_CONF_PP_ROT_EN. */
#define BS_IPU_IC_CONF_PP_ROT_EN (1U)      /*!< Bit field size in bits for IPU_IC_CONF_PP_ROT_EN. */

/*! @brief Read current value of the IPU_IC_CONF_PP_ROT_EN field. */
#define BR_IPU_IC_CONF_PP_ROT_EN(x) (HW_IPU_IC_CONF(x).B.PP_ROT_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_PP_ROT_EN. */
#define BF_IPU_IC_CONF_PP_ROT_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_PP_ROT_EN) & BM_IPU_IC_CONF_PP_ROT_EN)

/*! @brief Set the PP_ROT_EN field to a new value. */
#define BW_IPU_IC_CONF_PP_ROT_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_PP_ROT_EN) | BF_IPU_IC_CONF_PP_ROT_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field IC_GLB_LOC_A[28] (RW)
 *
 * Global Alpha. This bit select the source of Alpha parameter.
 *
 * Values:
 * - 0 - Alpha parameter is local.
 * - 1 - Alpha parameter is global.
 */
/*@{*/
#define BP_IPU_IC_CONF_IC_GLB_LOC_A (28U)  /*!< Bit position for IPU_IC_CONF_IC_GLB_LOC_A. */
#define BM_IPU_IC_CONF_IC_GLB_LOC_A (0x10000000U) /*!< Bit mask for IPU_IC_CONF_IC_GLB_LOC_A. */
#define BS_IPU_IC_CONF_IC_GLB_LOC_A (1U)   /*!< Bit field size in bits for IPU_IC_CONF_IC_GLB_LOC_A. */

/*! @brief Read current value of the IPU_IC_CONF_IC_GLB_LOC_A field. */
#define BR_IPU_IC_CONF_IC_GLB_LOC_A(x) (HW_IPU_IC_CONF(x).B.IC_GLB_LOC_A)

/*! @brief Format value for bitfield IPU_IC_CONF_IC_GLB_LOC_A. */
#define BF_IPU_IC_CONF_IC_GLB_LOC_A(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_IC_GLB_LOC_A) & BM_IPU_IC_CONF_IC_GLB_LOC_A)

/*! @brief Set the IC_GLB_LOC_A field to a new value. */
#define BW_IPU_IC_CONF_IC_GLB_LOC_A(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_IC_GLB_LOC_A) | BF_IPU_IC_CONF_IC_GLB_LOC_A(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field IC_KEY_COLOR_EN[29] (RW)
 *
 * Key Color enable. This bit enables the key color feature.
 *
 * Values:
 * - 0 - Key color is disabled.
 * - 1 - Key color is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_IC_KEY_COLOR_EN (29U) /*!< Bit position for IPU_IC_CONF_IC_KEY_COLOR_EN. */
#define BM_IPU_IC_CONF_IC_KEY_COLOR_EN (0x20000000U) /*!< Bit mask for IPU_IC_CONF_IC_KEY_COLOR_EN. */
#define BS_IPU_IC_CONF_IC_KEY_COLOR_EN (1U) /*!< Bit field size in bits for IPU_IC_CONF_IC_KEY_COLOR_EN. */

/*! @brief Read current value of the IPU_IC_CONF_IC_KEY_COLOR_EN field. */
#define BR_IPU_IC_CONF_IC_KEY_COLOR_EN(x) (HW_IPU_IC_CONF(x).B.IC_KEY_COLOR_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_IC_KEY_COLOR_EN. */
#define BF_IPU_IC_CONF_IC_KEY_COLOR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_IC_KEY_COLOR_EN) & BM_IPU_IC_CONF_IC_KEY_COLOR_EN)

/*! @brief Set the IC_KEY_COLOR_EN field to a new value. */
#define BW_IPU_IC_CONF_IC_KEY_COLOR_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_IC_KEY_COLOR_EN) | BF_IPU_IC_CONF_IC_KEY_COLOR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field RWS_EN[30] (RW)
 *
 * Raw sensor enable. This bit indicate if a Raw sensor is attached (Bayer
 * format). This bit is used together with the CSI_MEM_WR_EN bit as follows:
 * CSI_MEM_WR_EN=0, RWS_EN=0 - data is fed from the CSI to the IC for processing;
 * CSI_MEM_WR_EN=1, RWS_EN=0 - data is fed from the CSI to the IC for processing and also
 * for writing to the system memory; CSI_MEM_WR_EN=0, RWS_EN=1 - data is fed
 * from the CSI to the system memory (via the IC) and from the system memory to the
 * IC for processing; CSI_MEM_WR_EN=1, RWS_EN=1 - non-valid configuration.
 *
 * Values:
 * - 0 - Raw sensor is not attached.
 * - 1 - Raw sensor is attached.
 */
/*@{*/
#define BP_IPU_IC_CONF_RWS_EN (30U)        /*!< Bit position for IPU_IC_CONF_RWS_EN. */
#define BM_IPU_IC_CONF_RWS_EN (0x40000000U) /*!< Bit mask for IPU_IC_CONF_RWS_EN. */
#define BS_IPU_IC_CONF_RWS_EN (1U)         /*!< Bit field size in bits for IPU_IC_CONF_RWS_EN. */

/*! @brief Read current value of the IPU_IC_CONF_RWS_EN field. */
#define BR_IPU_IC_CONF_RWS_EN(x) (HW_IPU_IC_CONF(x).B.RWS_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_RWS_EN. */
#define BF_IPU_IC_CONF_RWS_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_RWS_EN) & BM_IPU_IC_CONF_RWS_EN)

/*! @brief Set the RWS_EN field to a new value. */
#define BW_IPU_IC_CONF_RWS_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_RWS_EN) | BF_IPU_IC_CONF_RWS_EN(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CONF, field CSI_MEM_WR_EN[31] (RW)
 *
 * CSI direct memory write enable. This bit enables writing data from sensor
 * directly to memory even when a raw sensor is not attached.
 *
 * Values:
 * - 0 - CSI direct writing to memory is disabled.
 * - 1 - CSI direct writing to memory is enabled.
 */
/*@{*/
#define BP_IPU_IC_CONF_CSI_MEM_WR_EN (31U) /*!< Bit position for IPU_IC_CONF_CSI_MEM_WR_EN. */
#define BM_IPU_IC_CONF_CSI_MEM_WR_EN (0x80000000U) /*!< Bit mask for IPU_IC_CONF_CSI_MEM_WR_EN. */
#define BS_IPU_IC_CONF_CSI_MEM_WR_EN (1U)  /*!< Bit field size in bits for IPU_IC_CONF_CSI_MEM_WR_EN. */

/*! @brief Read current value of the IPU_IC_CONF_CSI_MEM_WR_EN field. */
#define BR_IPU_IC_CONF_CSI_MEM_WR_EN(x) (HW_IPU_IC_CONF(x).B.CSI_MEM_WR_EN)

/*! @brief Format value for bitfield IPU_IC_CONF_CSI_MEM_WR_EN. */
#define BF_IPU_IC_CONF_CSI_MEM_WR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CONF_CSI_MEM_WR_EN) & BM_IPU_IC_CONF_CSI_MEM_WR_EN)

/*! @brief Set the CSI_MEM_WR_EN field to a new value. */
#define BW_IPU_IC_CONF_CSI_MEM_WR_EN(x, v) (HW_IPU_IC_CONF_WR(x, (HW_IPU_IC_CONF_RD(x) & ~BM_IPU_IC_CONF_CSI_MEM_WR_EN) | BF_IPU_IC_CONF_CSI_MEM_WR_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_PRP_ENC_RSC - IC Preprocessing Encoder Resizing Coefficients Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_PRP_ENC_RSC - IC Preprocessing Encoder Resizing Coefficients Register (RW)
 *
 * Reset value: 0x20002000U
 *
 * This register contains the resizing and downsizing parameters for
 * Preprocessing task for encoding.
 */
typedef union _hw_ipu_ic_prp_enc_rsc
{
    uint32_t U;
    struct _hw_ipu_ic_prp_enc_rsc_bitfields
    {
        uint32_t PRPENC_RS_R_H : 14;   /*!< [13:0]  */
        uint32_t PRPENC_DS_R_H : 2;    /*!< [15:14]  */
        uint32_t PRPENC_RS_R_V : 14;   /*!< [29:16]  */
        uint32_t PRPENC_DS_R_V : 2;    /*!< [31:30]  */
    } B;
} hw_ipu_ic_prp_enc_rsc_t;

/*!
 * @name Constants and macros for entire IPU_IC_PRP_ENC_RSC register
 */
/*@{*/
#define HW_IPU_IC_PRP_ENC_RSC_ADDR(x) ((uintptr_t)(x) + 0x20004U)

#define HW_IPU_IC_PRP_ENC_RSC(x) (*(__IO hw_ipu_ic_prp_enc_rsc_t *) HW_IPU_IC_PRP_ENC_RSC_ADDR(x))
#define HW_IPU_IC_PRP_ENC_RSC_RD(x) (HW_IPU_IC_PRP_ENC_RSC(x).U)
#define HW_IPU_IC_PRP_ENC_RSC_WR(x, v) (HW_IPU_IC_PRP_ENC_RSC(x).U = (v))
#define HW_IPU_IC_PRP_ENC_RSC_SET(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, HW_IPU_IC_PRP_ENC_RSC_RD(x) |  (v)))
#define HW_IPU_IC_PRP_ENC_RSC_CLR(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, HW_IPU_IC_PRP_ENC_RSC_RD(x) & ~(v)))
#define HW_IPU_IC_PRP_ENC_RSC_TOG(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, HW_IPU_IC_PRP_ENC_RSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_PRP_ENC_RSC bitfields
 */

/*!
 * @name Register IPU_IC_PRP_ENC_RSC, field PRPENC_RS_R_H[13:0] (RW)
 *
 * Preprocessing task for encoding Resizing horizontal Ratio. This field
 * contains the resizing horizontal coefficient of Preprocessing for Encoding. Resizing
 * Ratio is equal to PRPENC_RS_R_H: M Where M = 2^13; SI - input size; SO -
 * output size PRPENC_RS_R_H = floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H (0U) /*!< Bit position for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H. */
#define BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H (0x00003FFFU) /*!< Bit mask for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H. */
#define BS_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H (14U) /*!< Bit field size in bits for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H. */

/*! @brief Read current value of the IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H field. */
#define BR_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H(x) (HW_IPU_IC_PRP_ENC_RSC(x).B.PRPENC_RS_R_H)

/*! @brief Format value for bitfield IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H. */
#define BF_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H) & BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H)

/*! @brief Set the PRPENC_RS_R_H field to a new value. */
#define BW_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, (HW_IPU_IC_PRP_ENC_RSC_RD(x) & ~BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H) | BF_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_ENC_RSC, field PRPENC_DS_R_H[15:14] (RW)
 *
 * Preprocessing task for encoding Downsizing horizontal Ratio. This field
 * contains the downsizing horizontal coefficient of Preprocessing for Encoding.
 * Values:
 *
 * Values:
 * - 00 - 1
 * - 01 - 2
 * - 10 - 4
 * - 11 - RSV
 */
/*@{*/
#define BP_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H (14U) /*!< Bit position for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H. */
#define BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H (0x0000C000U) /*!< Bit mask for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H. */
#define BS_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H (2U) /*!< Bit field size in bits for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H. */

/*! @brief Read current value of the IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H field. */
#define BR_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H(x) (HW_IPU_IC_PRP_ENC_RSC(x).B.PRPENC_DS_R_H)

/*! @brief Format value for bitfield IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H. */
#define BF_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H) & BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H)

/*! @brief Set the PRPENC_DS_R_H field to a new value. */
#define BW_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, (HW_IPU_IC_PRP_ENC_RSC_RD(x) & ~BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H) | BF_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_ENC_RSC, field PRPENC_RS_R_V[29:16] (RW)
 *
 * Preprocessing task for encoding Resizing vertical Ratio. This field contains
 * the resizing vertical coefficient of Preprocessing for Encoding. Resizing
 * Ratio is equal to PRPENC_RS_R_V: M Where M = 2^13; SI - input size; SO - output
 * size PRPENC_RS_R_V = floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V (16U) /*!< Bit position for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V. */
#define BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V (0x3FFF0000U) /*!< Bit mask for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V. */
#define BS_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V (14U) /*!< Bit field size in bits for IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V. */

/*! @brief Read current value of the IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V field. */
#define BR_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V(x) (HW_IPU_IC_PRP_ENC_RSC(x).B.PRPENC_RS_R_V)

/*! @brief Format value for bitfield IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V. */
#define BF_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V) & BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V)

/*! @brief Set the PRPENC_RS_R_V field to a new value. */
#define BW_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, (HW_IPU_IC_PRP_ENC_RSC_RD(x) & ~BM_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V) | BF_IPU_IC_PRP_ENC_RSC_PRPENC_RS_R_V(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_ENC_RSC, field PRPENC_DS_R_V[31:30] (RW)
 *
 * Preprocessing task for encoding Downsizing vertical Ratio. This field
 * contains the downsizing vertical coefficient of Preprocessing for Encoding.
 */
/*@{*/
#define BP_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V (30U) /*!< Bit position for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V. */
#define BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V (0xC0000000U) /*!< Bit mask for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V. */
#define BS_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V (2U) /*!< Bit field size in bits for IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V. */

/*! @brief Read current value of the IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V field. */
#define BR_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V(x) (HW_IPU_IC_PRP_ENC_RSC(x).B.PRPENC_DS_R_V)

/*! @brief Format value for bitfield IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V. */
#define BF_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V) & BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V)

/*! @brief Set the PRPENC_DS_R_V field to a new value. */
#define BW_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V(x, v) (HW_IPU_IC_PRP_ENC_RSC_WR(x, (HW_IPU_IC_PRP_ENC_RSC_RD(x) & ~BM_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V) | BF_IPU_IC_PRP_ENC_RSC_PRPENC_DS_R_V(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_PRP_VF_RSC - IC Preprocessing View-Finder Resizing Coefficients Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_PRP_VF_RSC - IC Preprocessing View-Finder Resizing Coefficients Register (RW)
 *
 * Reset value: 0x20002000U
 *
 * This register contains the resizing and downsizing parameters for
 * preprocessing task for display.
 */
typedef union _hw_ipu_ic_prp_vf_rsc
{
    uint32_t U;
    struct _hw_ipu_ic_prp_vf_rsc_bitfields
    {
        uint32_t PRPVF_RS_R_H : 14;    /*!< [13:0]  */
        uint32_t PRPVF_DS_R_H : 2;     /*!< [15:14]  */
        uint32_t PRPVF_RS_R_V : 14;    /*!< [29:16]  */
        uint32_t PRPVF_DS_R_V : 2;     /*!< [31:30]  */
    } B;
} hw_ipu_ic_prp_vf_rsc_t;

/*!
 * @name Constants and macros for entire IPU_IC_PRP_VF_RSC register
 */
/*@{*/
#define HW_IPU_IC_PRP_VF_RSC_ADDR(x) ((uintptr_t)(x) + 0x20008U)

#define HW_IPU_IC_PRP_VF_RSC(x)  (*(__IO hw_ipu_ic_prp_vf_rsc_t *) HW_IPU_IC_PRP_VF_RSC_ADDR(x))
#define HW_IPU_IC_PRP_VF_RSC_RD(x) (HW_IPU_IC_PRP_VF_RSC(x).U)
#define HW_IPU_IC_PRP_VF_RSC_WR(x, v) (HW_IPU_IC_PRP_VF_RSC(x).U = (v))
#define HW_IPU_IC_PRP_VF_RSC_SET(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, HW_IPU_IC_PRP_VF_RSC_RD(x) |  (v)))
#define HW_IPU_IC_PRP_VF_RSC_CLR(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, HW_IPU_IC_PRP_VF_RSC_RD(x) & ~(v)))
#define HW_IPU_IC_PRP_VF_RSC_TOG(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, HW_IPU_IC_PRP_VF_RSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_PRP_VF_RSC bitfields
 */

/*!
 * @name Register IPU_IC_PRP_VF_RSC, field PRPVF_RS_R_H[13:0] (RW)
 *
 * Preprocessing task for view-finding resizing horizontal ratio. This field
 * contains the resizing horizontal coefficient of preprocessing Task For
 * View-finder. Resizing Ratio is equal to PRPVF_RS_R_H: M Where M = 2^13; SI - input size;
 * SO - output size PRPVF_RS_R_H = floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H (0U) /*!< Bit position for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H. */
#define BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H (0x00003FFFU) /*!< Bit mask for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H. */
#define BS_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H (14U) /*!< Bit field size in bits for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H. */

/*! @brief Read current value of the IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H field. */
#define BR_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H(x) (HW_IPU_IC_PRP_VF_RSC(x).B.PRPVF_RS_R_H)

/*! @brief Format value for bitfield IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H. */
#define BF_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H) & BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H)

/*! @brief Set the PRPVF_RS_R_H field to a new value. */
#define BW_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, (HW_IPU_IC_PRP_VF_RSC_RD(x) & ~BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H) | BF_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_VF_RSC, field PRPVF_DS_R_H[15:14] (RW)
 *
 * Preprocessing task for encoding Downsizing horizontal Ratio. This field
 * contains the downsizing horizontal coefficient of Preprocessing for View-Finder.
 * Values:
 *
 * Values:
 * - 00 - 1
 * - 01 - 2
 * - 10 - 4
 * - 11 - RSV
 */
/*@{*/
#define BP_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H (14U) /*!< Bit position for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H. */
#define BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H (0x0000C000U) /*!< Bit mask for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H. */
#define BS_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H (2U) /*!< Bit field size in bits for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H. */

/*! @brief Read current value of the IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H field. */
#define BR_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H(x) (HW_IPU_IC_PRP_VF_RSC(x).B.PRPVF_DS_R_H)

/*! @brief Format value for bitfield IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H. */
#define BF_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H) & BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H)

/*! @brief Set the PRPVF_DS_R_H field to a new value. */
#define BW_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, (HW_IPU_IC_PRP_VF_RSC_RD(x) & ~BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H) | BF_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_VF_RSC, field PRPVF_RS_R_V[29:16] (RW)
 *
 * Preprocessing task for encoding Resizing vertical Ratio. This field contains
 * the resizing vertical coefficient of Preprocessing for View-Finder. Resizing
 * Ratio is equal to PRPVF_RS_R_V: M Where M = 2^13; SI - input size; SO - output
 * size PRPVF_RS_R_V = floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V (16U) /*!< Bit position for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V. */
#define BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V (0x3FFF0000U) /*!< Bit mask for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V. */
#define BS_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V (14U) /*!< Bit field size in bits for IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V. */

/*! @brief Read current value of the IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V field. */
#define BR_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V(x) (HW_IPU_IC_PRP_VF_RSC(x).B.PRPVF_RS_R_V)

/*! @brief Format value for bitfield IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V. */
#define BF_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V) & BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V)

/*! @brief Set the PRPVF_RS_R_V field to a new value. */
#define BW_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, (HW_IPU_IC_PRP_VF_RSC_RD(x) & ~BM_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V) | BF_IPU_IC_PRP_VF_RSC_PRPVF_RS_R_V(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PRP_VF_RSC, field PRPVF_DS_R_V[31:30] (RW)
 *
 * Preprocessing task for encoding Downsizing vertical Ratio. This field
 * contains the downsizing vertical coefficient of Preprocessing for View-Finder.
 */
/*@{*/
#define BP_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V (30U) /*!< Bit position for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V. */
#define BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V (0xC0000000U) /*!< Bit mask for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V. */
#define BS_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V (2U) /*!< Bit field size in bits for IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V. */

/*! @brief Read current value of the IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V field. */
#define BR_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V(x) (HW_IPU_IC_PRP_VF_RSC(x).B.PRPVF_DS_R_V)

/*! @brief Format value for bitfield IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V. */
#define BF_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V) & BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V)

/*! @brief Set the PRPVF_DS_R_V field to a new value. */
#define BW_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V(x, v) (HW_IPU_IC_PRP_VF_RSC_WR(x, (HW_IPU_IC_PRP_VF_RSC_RD(x) & ~BM_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V) | BF_IPU_IC_PRP_VF_RSC_PRPVF_DS_R_V(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_PP_RSC - IC Postprocessing Encoder Resizing Coefficients Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_PP_RSC - IC Postprocessing Encoder Resizing Coefficients Register (RW)
 *
 * Reset value: 0x20002000U
 *
 * This register contains the resizing and downsizing parameters for
 * Post-Processing task for display.
 */
typedef union _hw_ipu_ic_pp_rsc
{
    uint32_t U;
    struct _hw_ipu_ic_pp_rsc_bitfields
    {
        uint32_t PP_RS_R_H : 14;       /*!< [13:0]  */
        uint32_t PP_DS_R_H : 2;        /*!< [15:14]  */
        uint32_t PP_RS_R_V : 14;       /*!< [29:16]  */
        uint32_t PP_DS_R_V : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_ic_pp_rsc_t;

/*!
 * @name Constants and macros for entire IPU_IC_PP_RSC register
 */
/*@{*/
#define HW_IPU_IC_PP_RSC_ADDR(x) ((uintptr_t)(x) + 0x2000CU)

#define HW_IPU_IC_PP_RSC(x)      (*(__IO hw_ipu_ic_pp_rsc_t *) HW_IPU_IC_PP_RSC_ADDR(x))
#define HW_IPU_IC_PP_RSC_RD(x)   (HW_IPU_IC_PP_RSC(x).U)
#define HW_IPU_IC_PP_RSC_WR(x, v) (HW_IPU_IC_PP_RSC(x).U = (v))
#define HW_IPU_IC_PP_RSC_SET(x, v) (HW_IPU_IC_PP_RSC_WR(x, HW_IPU_IC_PP_RSC_RD(x) |  (v)))
#define HW_IPU_IC_PP_RSC_CLR(x, v) (HW_IPU_IC_PP_RSC_WR(x, HW_IPU_IC_PP_RSC_RD(x) & ~(v)))
#define HW_IPU_IC_PP_RSC_TOG(x, v) (HW_IPU_IC_PP_RSC_WR(x, HW_IPU_IC_PP_RSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_PP_RSC bitfields
 */

/*!
 * @name Register IPU_IC_PP_RSC, field PP_RS_R_H[13:0] (RW)
 *
 * Post-Processing task Resizing horizontal Ratio. This field contains the
 * resizing horizontal coefficient of Post-Processing. Resizing Ratio is equal to
 * PP_RS_R_H: M Where M = 2^13; SI - input size; SO - output size PP_RS_R_H =
 * floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PP_RSC_PP_RS_R_H (0U)    /*!< Bit position for IPU_IC_PP_RSC_PP_RS_R_H. */
#define BM_IPU_IC_PP_RSC_PP_RS_R_H (0x00003FFFU) /*!< Bit mask for IPU_IC_PP_RSC_PP_RS_R_H. */
#define BS_IPU_IC_PP_RSC_PP_RS_R_H (14U)   /*!< Bit field size in bits for IPU_IC_PP_RSC_PP_RS_R_H. */

/*! @brief Read current value of the IPU_IC_PP_RSC_PP_RS_R_H field. */
#define BR_IPU_IC_PP_RSC_PP_RS_R_H(x) (HW_IPU_IC_PP_RSC(x).B.PP_RS_R_H)

/*! @brief Format value for bitfield IPU_IC_PP_RSC_PP_RS_R_H. */
#define BF_IPU_IC_PP_RSC_PP_RS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PP_RSC_PP_RS_R_H) & BM_IPU_IC_PP_RSC_PP_RS_R_H)

/*! @brief Set the PP_RS_R_H field to a new value. */
#define BW_IPU_IC_PP_RSC_PP_RS_R_H(x, v) (HW_IPU_IC_PP_RSC_WR(x, (HW_IPU_IC_PP_RSC_RD(x) & ~BM_IPU_IC_PP_RSC_PP_RS_R_H) | BF_IPU_IC_PP_RSC_PP_RS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PP_RSC, field PP_DS_R_H[15:14] (RW)
 *
 * Post-Processing task Downsizing horizontal Ratio. This field contains the
 * downsizing horizontal coefficient of Post-Processing.
 *
 * Values:
 * - 00 - 1
 * - 01 - 2
 * - 10 - 4
 * - 11 - RSV
 */
/*@{*/
#define BP_IPU_IC_PP_RSC_PP_DS_R_H (14U)   /*!< Bit position for IPU_IC_PP_RSC_PP_DS_R_H. */
#define BM_IPU_IC_PP_RSC_PP_DS_R_H (0x0000C000U) /*!< Bit mask for IPU_IC_PP_RSC_PP_DS_R_H. */
#define BS_IPU_IC_PP_RSC_PP_DS_R_H (2U)    /*!< Bit field size in bits for IPU_IC_PP_RSC_PP_DS_R_H. */

/*! @brief Read current value of the IPU_IC_PP_RSC_PP_DS_R_H field. */
#define BR_IPU_IC_PP_RSC_PP_DS_R_H(x) (HW_IPU_IC_PP_RSC(x).B.PP_DS_R_H)

/*! @brief Format value for bitfield IPU_IC_PP_RSC_PP_DS_R_H. */
#define BF_IPU_IC_PP_RSC_PP_DS_R_H(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PP_RSC_PP_DS_R_H) & BM_IPU_IC_PP_RSC_PP_DS_R_H)

/*! @brief Set the PP_DS_R_H field to a new value. */
#define BW_IPU_IC_PP_RSC_PP_DS_R_H(x, v) (HW_IPU_IC_PP_RSC_WR(x, (HW_IPU_IC_PP_RSC_RD(x) & ~BM_IPU_IC_PP_RSC_PP_DS_R_H) | BF_IPU_IC_PP_RSC_PP_DS_R_H(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PP_RSC, field PP_RS_R_V[29:16] (RW)
 *
 * Post-Processing task Resizing vertical Ratio. This field contains the
 * resizing vertical coefficient of Post-Processing. Resizing Ratio is equal to
 * PP_RS_R_V: M Where M = 2^13; SI - input size; SO - output size PP_RS_R_V =
 * floor(M*(SI-1)/(SO-1));
 */
/*@{*/
#define BP_IPU_IC_PP_RSC_PP_RS_R_V (16U)   /*!< Bit position for IPU_IC_PP_RSC_PP_RS_R_V. */
#define BM_IPU_IC_PP_RSC_PP_RS_R_V (0x3FFF0000U) /*!< Bit mask for IPU_IC_PP_RSC_PP_RS_R_V. */
#define BS_IPU_IC_PP_RSC_PP_RS_R_V (14U)   /*!< Bit field size in bits for IPU_IC_PP_RSC_PP_RS_R_V. */

/*! @brief Read current value of the IPU_IC_PP_RSC_PP_RS_R_V field. */
#define BR_IPU_IC_PP_RSC_PP_RS_R_V(x) (HW_IPU_IC_PP_RSC(x).B.PP_RS_R_V)

/*! @brief Format value for bitfield IPU_IC_PP_RSC_PP_RS_R_V. */
#define BF_IPU_IC_PP_RSC_PP_RS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PP_RSC_PP_RS_R_V) & BM_IPU_IC_PP_RSC_PP_RS_R_V)

/*! @brief Set the PP_RS_R_V field to a new value. */
#define BW_IPU_IC_PP_RSC_PP_RS_R_V(x, v) (HW_IPU_IC_PP_RSC_WR(x, (HW_IPU_IC_PP_RSC_RD(x) & ~BM_IPU_IC_PP_RSC_PP_RS_R_V) | BF_IPU_IC_PP_RSC_PP_RS_R_V(v)))
/*@}*/

/*!
 * @name Register IPU_IC_PP_RSC, field PP_DS_R_V[31:30] (RW)
 *
 * Post-Processing task Downsizing vertical Ratio. This field contains the
 * downsizing vertical coefficient of Post-Processing.
 */
/*@{*/
#define BP_IPU_IC_PP_RSC_PP_DS_R_V (30U)   /*!< Bit position for IPU_IC_PP_RSC_PP_DS_R_V. */
#define BM_IPU_IC_PP_RSC_PP_DS_R_V (0xC0000000U) /*!< Bit mask for IPU_IC_PP_RSC_PP_DS_R_V. */
#define BS_IPU_IC_PP_RSC_PP_DS_R_V (2U)    /*!< Bit field size in bits for IPU_IC_PP_RSC_PP_DS_R_V. */

/*! @brief Read current value of the IPU_IC_PP_RSC_PP_DS_R_V field. */
#define BR_IPU_IC_PP_RSC_PP_DS_R_V(x) (HW_IPU_IC_PP_RSC(x).B.PP_DS_R_V)

/*! @brief Format value for bitfield IPU_IC_PP_RSC_PP_DS_R_V. */
#define BF_IPU_IC_PP_RSC_PP_DS_R_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_PP_RSC_PP_DS_R_V) & BM_IPU_IC_PP_RSC_PP_DS_R_V)

/*! @brief Set the PP_DS_R_V field to a new value. */
#define BW_IPU_IC_PP_RSC_PP_DS_R_V(x, v) (HW_IPU_IC_PP_RSC_WR(x, (HW_IPU_IC_PP_RSC_RD(x) & ~BM_IPU_IC_PP_RSC_PP_DS_R_V) | BF_IPU_IC_PP_RSC_PP_DS_R_V(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_CMBP_1 - IC Combining Parameters Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_CMBP_1 - IC Combining Parameters Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_cmbp_1
{
    uint32_t U;
    struct _hw_ipu_ic_cmbp_1_bitfields
    {
        uint32_t IC_PRPVF_ALPHA_V : 8; /*!< [7:0]  */
        uint32_t IC_PP_ALPHA_V : 8;    /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_ic_cmbp_1_t;

/*!
 * @name Constants and macros for entire IPU_IC_CMBP_1 register
 */
/*@{*/
#define HW_IPU_IC_CMBP_1_ADDR(x) ((uintptr_t)(x) + 0x20010U)

#define HW_IPU_IC_CMBP_1(x)      (*(__IO hw_ipu_ic_cmbp_1_t *) HW_IPU_IC_CMBP_1_ADDR(x))
#define HW_IPU_IC_CMBP_1_RD(x)   (HW_IPU_IC_CMBP_1(x).U)
#define HW_IPU_IC_CMBP_1_WR(x, v) (HW_IPU_IC_CMBP_1(x).U = (v))
#define HW_IPU_IC_CMBP_1_SET(x, v) (HW_IPU_IC_CMBP_1_WR(x, HW_IPU_IC_CMBP_1_RD(x) |  (v)))
#define HW_IPU_IC_CMBP_1_CLR(x, v) (HW_IPU_IC_CMBP_1_WR(x, HW_IPU_IC_CMBP_1_RD(x) & ~(v)))
#define HW_IPU_IC_CMBP_1_TOG(x, v) (HW_IPU_IC_CMBP_1_WR(x, HW_IPU_IC_CMBP_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_CMBP_1 bitfields
 */

/*!
 * @name Register IPU_IC_CMBP_1, field IC_PRPVF_ALPHA_V[7:0] (RW)
 *
 * Preprocessing task for viewfinder Global Alpha. This field contains the
 * Global Alpha value of Preprocessing for viewfinder.
 */
/*@{*/
#define BP_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V (0U) /*!< Bit position for IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V. */
#define BM_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V (0x000000FFU) /*!< Bit mask for IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V. */
#define BS_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V (8U) /*!< Bit field size in bits for IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V. */

/*! @brief Read current value of the IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V field. */
#define BR_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V(x) (HW_IPU_IC_CMBP_1(x).B.IC_PRPVF_ALPHA_V)

/*! @brief Format value for bitfield IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V. */
#define BF_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V) & BM_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V)

/*! @brief Set the IC_PRPVF_ALPHA_V field to a new value. */
#define BW_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V(x, v) (HW_IPU_IC_CMBP_1_WR(x, (HW_IPU_IC_CMBP_1_RD(x) & ~BM_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V) | BF_IPU_IC_CMBP_1_IC_PRPVF_ALPHA_V(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CMBP_1, field IC_PP_ALPHA_V[15:8] (RW)
 *
 * Post-Processing task Global Alpha. This field contains the Global Alpha value
 * of Post-Processing.
 */
/*@{*/
#define BP_IPU_IC_CMBP_1_IC_PP_ALPHA_V (8U) /*!< Bit position for IPU_IC_CMBP_1_IC_PP_ALPHA_V. */
#define BM_IPU_IC_CMBP_1_IC_PP_ALPHA_V (0x0000FF00U) /*!< Bit mask for IPU_IC_CMBP_1_IC_PP_ALPHA_V. */
#define BS_IPU_IC_CMBP_1_IC_PP_ALPHA_V (8U) /*!< Bit field size in bits for IPU_IC_CMBP_1_IC_PP_ALPHA_V. */

/*! @brief Read current value of the IPU_IC_CMBP_1_IC_PP_ALPHA_V field. */
#define BR_IPU_IC_CMBP_1_IC_PP_ALPHA_V(x) (HW_IPU_IC_CMBP_1(x).B.IC_PP_ALPHA_V)

/*! @brief Format value for bitfield IPU_IC_CMBP_1_IC_PP_ALPHA_V. */
#define BF_IPU_IC_CMBP_1_IC_PP_ALPHA_V(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CMBP_1_IC_PP_ALPHA_V) & BM_IPU_IC_CMBP_1_IC_PP_ALPHA_V)

/*! @brief Set the IC_PP_ALPHA_V field to a new value. */
#define BW_IPU_IC_CMBP_1_IC_PP_ALPHA_V(x, v) (HW_IPU_IC_CMBP_1_WR(x, (HW_IPU_IC_CMBP_1_RD(x) & ~BM_IPU_IC_CMBP_1_IC_PP_ALPHA_V) | BF_IPU_IC_CMBP_1_IC_PP_ALPHA_V(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_CMBP_2 - IC Combining Parameters Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_CMBP_2 - IC Combining Parameters Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_cmbp_2
{
    uint32_t U;
    struct _hw_ipu_ic_cmbp_2_bitfields
    {
        uint32_t IC_KEY_COLOR_B : 8;   /*!< [7:0]  */
        uint32_t IC_KEY_COLOR_G : 8;   /*!< [15:8]  */
        uint32_t IC_KEY_COLOR_R : 8;   /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_ic_cmbp_2_t;

/*!
 * @name Constants and macros for entire IPU_IC_CMBP_2 register
 */
/*@{*/
#define HW_IPU_IC_CMBP_2_ADDR(x) ((uintptr_t)(x) + 0x20014U)

#define HW_IPU_IC_CMBP_2(x)      (*(__IO hw_ipu_ic_cmbp_2_t *) HW_IPU_IC_CMBP_2_ADDR(x))
#define HW_IPU_IC_CMBP_2_RD(x)   (HW_IPU_IC_CMBP_2(x).U)
#define HW_IPU_IC_CMBP_2_WR(x, v) (HW_IPU_IC_CMBP_2(x).U = (v))
#define HW_IPU_IC_CMBP_2_SET(x, v) (HW_IPU_IC_CMBP_2_WR(x, HW_IPU_IC_CMBP_2_RD(x) |  (v)))
#define HW_IPU_IC_CMBP_2_CLR(x, v) (HW_IPU_IC_CMBP_2_WR(x, HW_IPU_IC_CMBP_2_RD(x) & ~(v)))
#define HW_IPU_IC_CMBP_2_TOG(x, v) (HW_IPU_IC_CMBP_2_WR(x, HW_IPU_IC_CMBP_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_CMBP_2 bitfields
 */

/*!
 * @name Register IPU_IC_CMBP_2, field IC_KEY_COLOR_B[7:0] (RW)
 *
 * Key Color Blue.
 */
/*@{*/
#define BP_IPU_IC_CMBP_2_IC_KEY_COLOR_B (0U) /*!< Bit position for IPU_IC_CMBP_2_IC_KEY_COLOR_B. */
#define BM_IPU_IC_CMBP_2_IC_KEY_COLOR_B (0x000000FFU) /*!< Bit mask for IPU_IC_CMBP_2_IC_KEY_COLOR_B. */
#define BS_IPU_IC_CMBP_2_IC_KEY_COLOR_B (8U) /*!< Bit field size in bits for IPU_IC_CMBP_2_IC_KEY_COLOR_B. */

/*! @brief Read current value of the IPU_IC_CMBP_2_IC_KEY_COLOR_B field. */
#define BR_IPU_IC_CMBP_2_IC_KEY_COLOR_B(x) (HW_IPU_IC_CMBP_2(x).B.IC_KEY_COLOR_B)

/*! @brief Format value for bitfield IPU_IC_CMBP_2_IC_KEY_COLOR_B. */
#define BF_IPU_IC_CMBP_2_IC_KEY_COLOR_B(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CMBP_2_IC_KEY_COLOR_B) & BM_IPU_IC_CMBP_2_IC_KEY_COLOR_B)

/*! @brief Set the IC_KEY_COLOR_B field to a new value. */
#define BW_IPU_IC_CMBP_2_IC_KEY_COLOR_B(x, v) (HW_IPU_IC_CMBP_2_WR(x, (HW_IPU_IC_CMBP_2_RD(x) & ~BM_IPU_IC_CMBP_2_IC_KEY_COLOR_B) | BF_IPU_IC_CMBP_2_IC_KEY_COLOR_B(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CMBP_2, field IC_KEY_COLOR_G[15:8] (RW)
 *
 * Key Color Green.
 */
/*@{*/
#define BP_IPU_IC_CMBP_2_IC_KEY_COLOR_G (8U) /*!< Bit position for IPU_IC_CMBP_2_IC_KEY_COLOR_G. */
#define BM_IPU_IC_CMBP_2_IC_KEY_COLOR_G (0x0000FF00U) /*!< Bit mask for IPU_IC_CMBP_2_IC_KEY_COLOR_G. */
#define BS_IPU_IC_CMBP_2_IC_KEY_COLOR_G (8U) /*!< Bit field size in bits for IPU_IC_CMBP_2_IC_KEY_COLOR_G. */

/*! @brief Read current value of the IPU_IC_CMBP_2_IC_KEY_COLOR_G field. */
#define BR_IPU_IC_CMBP_2_IC_KEY_COLOR_G(x) (HW_IPU_IC_CMBP_2(x).B.IC_KEY_COLOR_G)

/*! @brief Format value for bitfield IPU_IC_CMBP_2_IC_KEY_COLOR_G. */
#define BF_IPU_IC_CMBP_2_IC_KEY_COLOR_G(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CMBP_2_IC_KEY_COLOR_G) & BM_IPU_IC_CMBP_2_IC_KEY_COLOR_G)

/*! @brief Set the IC_KEY_COLOR_G field to a new value. */
#define BW_IPU_IC_CMBP_2_IC_KEY_COLOR_G(x, v) (HW_IPU_IC_CMBP_2_WR(x, (HW_IPU_IC_CMBP_2_RD(x) & ~BM_IPU_IC_CMBP_2_IC_KEY_COLOR_G) | BF_IPU_IC_CMBP_2_IC_KEY_COLOR_G(v)))
/*@}*/

/*!
 * @name Register IPU_IC_CMBP_2, field IC_KEY_COLOR_R[23:16] (RW)
 *
 * Key Color Red.
 */
/*@{*/
#define BP_IPU_IC_CMBP_2_IC_KEY_COLOR_R (16U) /*!< Bit position for IPU_IC_CMBP_2_IC_KEY_COLOR_R. */
#define BM_IPU_IC_CMBP_2_IC_KEY_COLOR_R (0x00FF0000U) /*!< Bit mask for IPU_IC_CMBP_2_IC_KEY_COLOR_R. */
#define BS_IPU_IC_CMBP_2_IC_KEY_COLOR_R (8U) /*!< Bit field size in bits for IPU_IC_CMBP_2_IC_KEY_COLOR_R. */

/*! @brief Read current value of the IPU_IC_CMBP_2_IC_KEY_COLOR_R field. */
#define BR_IPU_IC_CMBP_2_IC_KEY_COLOR_R(x) (HW_IPU_IC_CMBP_2(x).B.IC_KEY_COLOR_R)

/*! @brief Format value for bitfield IPU_IC_CMBP_2_IC_KEY_COLOR_R. */
#define BF_IPU_IC_CMBP_2_IC_KEY_COLOR_R(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_CMBP_2_IC_KEY_COLOR_R) & BM_IPU_IC_CMBP_2_IC_KEY_COLOR_R)

/*! @brief Set the IC_KEY_COLOR_R field to a new value. */
#define BW_IPU_IC_CMBP_2_IC_KEY_COLOR_R(x, v) (HW_IPU_IC_CMBP_2_WR(x, (HW_IPU_IC_CMBP_2_RD(x) & ~BM_IPU_IC_CMBP_2_IC_KEY_COLOR_R) | BF_IPU_IC_CMBP_2_IC_KEY_COLOR_R(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_IDMAC_1 - IC IDMAC Parameters 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_IDMAC_1 - IC IDMAC Parameters 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_idmac_1
{
    uint32_t U;
    struct _hw_ipu_ic_idmac_1_bitfields
    {
        uint32_t CB0_BURST_16 : 1;     /*!< [0]  */
        uint32_t CB1_BURST_16 : 1;     /*!< [1]  */
        uint32_t CB2_BURST_16 : 1;     /*!< [2]  */
        uint32_t CB3_BURST_16 : 1;     /*!< [3]  */
        uint32_t CB4_BURST_16 : 1;     /*!< [4]  */
        uint32_t CB5_BURST_16 : 1;     /*!< [5]  */
        uint32_t CB6_BURST_16 : 1;     /*!< [6]  */
        uint32_t CB7_BURST_16 : 1;     /*!< [7]  */
        uint32_t RESERVED0 : 3;        /*!< [10:8]  */
        uint32_t T1_ROT : 1;           /*!< [11]  */
        uint32_t T1_FLIP_LR : 1;       /*!< [12]  */
        uint32_t T1_FLIP_UD : 1;       /*!< [13]  */
        uint32_t T2_ROT : 1;           /*!< [14]  */
        uint32_t T2_FLIP_LR : 1;       /*!< [15]  */
        uint32_t T2_FLIP_UD : 1;       /*!< [16]  */
        uint32_t T3_ROT : 1;           /*!< [17]  */
        uint32_t T3_FLIP_LR : 1;       /*!< [18]  */
        uint32_t T3_FLIP_UD : 1;       /*!< [19]  */
        uint32_t T1_FLIP_RS : 1;       /*!< [20]  */
        uint32_t T2_FLIP_RS : 1;       /*!< [21]  */
        uint32_t T3_FLIP_RS : 1;       /*!< [22]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t ALT_CB6_BURST_16 : 1; /*!< [24]  */
        uint32_t ALT_CB7_BURST_16 : 1; /*!< [25]  */
        uint32_t RESERVED2 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_ic_idmac_1_t;

/*!
 * @name Constants and macros for entire IPU_IC_IDMAC_1 register
 */
/*@{*/
#define HW_IPU_IC_IDMAC_1_ADDR(x) ((uintptr_t)(x) + 0x20018U)

#define HW_IPU_IC_IDMAC_1(x)     (*(__IO hw_ipu_ic_idmac_1_t *) HW_IPU_IC_IDMAC_1_ADDR(x))
#define HW_IPU_IC_IDMAC_1_RD(x)  (HW_IPU_IC_IDMAC_1(x).U)
#define HW_IPU_IC_IDMAC_1_WR(x, v) (HW_IPU_IC_IDMAC_1(x).U = (v))
#define HW_IPU_IC_IDMAC_1_SET(x, v) (HW_IPU_IC_IDMAC_1_WR(x, HW_IPU_IC_IDMAC_1_RD(x) |  (v)))
#define HW_IPU_IC_IDMAC_1_CLR(x, v) (HW_IPU_IC_IDMAC_1_WR(x, HW_IPU_IC_IDMAC_1_RD(x) & ~(v)))
#define HW_IPU_IC_IDMAC_1_TOG(x, v) (HW_IPU_IC_IDMAC_1_WR(x, HW_IPU_IC_IDMAC_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_IDMAC_1 bitfields
 */

/*!
 * @name Register IPU_IC_IDMAC_1, field CB0_BURST_16[0] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB0 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB0_BURST_16 (0U) /*!< Bit position for IPU_IC_IDMAC_1_CB0_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB0_BURST_16 (0x00000001U) /*!< Bit mask for IPU_IC_IDMAC_1_CB0_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB0_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB0_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB0_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB0_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB0_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB0_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB0_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB0_BURST_16) & BM_IPU_IC_IDMAC_1_CB0_BURST_16)

/*! @brief Set the CB0_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB0_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB0_BURST_16) | BF_IPU_IC_IDMAC_1_CB0_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB1_BURST_16[1] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB1 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB1_BURST_16 (1U) /*!< Bit position for IPU_IC_IDMAC_1_CB1_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB1_BURST_16 (0x00000002U) /*!< Bit mask for IPU_IC_IDMAC_1_CB1_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB1_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB1_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB1_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB1_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB1_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB1_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB1_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB1_BURST_16) & BM_IPU_IC_IDMAC_1_CB1_BURST_16)

/*! @brief Set the CB1_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB1_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB1_BURST_16) | BF_IPU_IC_IDMAC_1_CB1_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB2_BURST_16[2] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB2 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB2_BURST_16 (2U) /*!< Bit position for IPU_IC_IDMAC_1_CB2_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB2_BURST_16 (0x00000004U) /*!< Bit mask for IPU_IC_IDMAC_1_CB2_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB2_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB2_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB2_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB2_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB2_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB2_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB2_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB2_BURST_16) & BM_IPU_IC_IDMAC_1_CB2_BURST_16)

/*! @brief Set the CB2_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB2_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB2_BURST_16) | BF_IPU_IC_IDMAC_1_CB2_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB3_BURST_16[3] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB3 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB3_BURST_16 (3U) /*!< Bit position for IPU_IC_IDMAC_1_CB3_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB3_BURST_16 (0x00000008U) /*!< Bit mask for IPU_IC_IDMAC_1_CB3_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB3_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB3_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB3_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB3_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB3_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB3_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB3_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB3_BURST_16) & BM_IPU_IC_IDMAC_1_CB3_BURST_16)

/*! @brief Set the CB3_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB3_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB3_BURST_16) | BF_IPU_IC_IDMAC_1_CB3_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB4_BURST_16[4] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB4 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB4_BURST_16 (4U) /*!< Bit position for IPU_IC_IDMAC_1_CB4_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB4_BURST_16 (0x00000010U) /*!< Bit mask for IPU_IC_IDMAC_1_CB4_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB4_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB4_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB4_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB4_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB4_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB4_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB4_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB4_BURST_16) & BM_IPU_IC_IDMAC_1_CB4_BURST_16)

/*! @brief Set the CB4_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB4_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB4_BURST_16) | BF_IPU_IC_IDMAC_1_CB4_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB5_BURST_16[5] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB5 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB5_BURST_16 (5U) /*!< Bit position for IPU_IC_IDMAC_1_CB5_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB5_BURST_16 (0x00000020U) /*!< Bit mask for IPU_IC_IDMAC_1_CB5_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB5_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB5_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB5_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB5_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB5_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB5_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB5_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB5_BURST_16) & BM_IPU_IC_IDMAC_1_CB5_BURST_16)

/*! @brief Set the CB5_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB5_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB5_BURST_16) | BF_IPU_IC_IDMAC_1_CB5_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB6_BURST_16[6] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB6 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB6_BURST_16 (6U) /*!< Bit position for IPU_IC_IDMAC_1_CB6_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB6_BURST_16 (0x00000040U) /*!< Bit mask for IPU_IC_IDMAC_1_CB6_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB6_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB6_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB6_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB6_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB6_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB6_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB6_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB6_BURST_16) & BM_IPU_IC_IDMAC_1_CB6_BURST_16)

/*! @brief Set the CB6_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB6_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB6_BURST_16) | BF_IPU_IC_IDMAC_1_CB6_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field CB7_BURST_16[7] (RW)
 *
 * This bit defines the number of active cycles within a burst (burst size)
 * coming from the IDMAC for IC's CB7 For pixel data the number of pixels should
 * match the NPB[6:2] value on the IDMAC's CPMEM
 *
 * Values:
 * - 0 - Burst size is 8 pixels; The Matching NPB[6:2] should be 00111
 * - 1 - Burst size is 16 pixels; The Matching NPB[6:2] should be 01111
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_CB7_BURST_16 (7U) /*!< Bit position for IPU_IC_IDMAC_1_CB7_BURST_16. */
#define BM_IPU_IC_IDMAC_1_CB7_BURST_16 (0x00000080U) /*!< Bit mask for IPU_IC_IDMAC_1_CB7_BURST_16. */
#define BS_IPU_IC_IDMAC_1_CB7_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_CB7_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_CB7_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_CB7_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.CB7_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_CB7_BURST_16. */
#define BF_IPU_IC_IDMAC_1_CB7_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_CB7_BURST_16) & BM_IPU_IC_IDMAC_1_CB7_BURST_16)

/*! @brief Set the CB7_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_CB7_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_CB7_BURST_16) | BF_IPU_IC_IDMAC_1_CB7_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T1_ROT[11] (RW)
 *
 * Rotation for Encoding (ENC) task The value of this field must be identical to
 * the corresponding channel's ROT parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - 90 degree rotation clockwise
 * - 0 - no rotation
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T1_ROT (11U)     /*!< Bit position for IPU_IC_IDMAC_1_T1_ROT. */
#define BM_IPU_IC_IDMAC_1_T1_ROT (0x00000800U) /*!< Bit mask for IPU_IC_IDMAC_1_T1_ROT. */
#define BS_IPU_IC_IDMAC_1_T1_ROT (1U)      /*!< Bit field size in bits for IPU_IC_IDMAC_1_T1_ROT. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T1_ROT field. */
#define BR_IPU_IC_IDMAC_1_T1_ROT(x) (HW_IPU_IC_IDMAC_1(x).B.T1_ROT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T1_ROT. */
#define BF_IPU_IC_IDMAC_1_T1_ROT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T1_ROT) & BM_IPU_IC_IDMAC_1_T1_ROT)

/*! @brief Set the T1_ROT field to a new value. */
#define BW_IPU_IC_IDMAC_1_T1_ROT(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T1_ROT) | BF_IPU_IC_IDMAC_1_T1_ROT(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T1_FLIP_LR[12] (RW)
 *
 * LEFT/RIGHT flip for Encoding (ENC) task; this bit affect the flipping done on
 * the rotation unit The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T1_FLIP_LR (12U) /*!< Bit position for IPU_IC_IDMAC_1_T1_FLIP_LR. */
#define BM_IPU_IC_IDMAC_1_T1_FLIP_LR (0x00001000U) /*!< Bit mask for IPU_IC_IDMAC_1_T1_FLIP_LR. */
#define BS_IPU_IC_IDMAC_1_T1_FLIP_LR (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T1_FLIP_LR. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T1_FLIP_LR field. */
#define BR_IPU_IC_IDMAC_1_T1_FLIP_LR(x) (HW_IPU_IC_IDMAC_1(x).B.T1_FLIP_LR)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T1_FLIP_LR. */
#define BF_IPU_IC_IDMAC_1_T1_FLIP_LR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T1_FLIP_LR) & BM_IPU_IC_IDMAC_1_T1_FLIP_LR)

/*! @brief Set the T1_FLIP_LR field to a new value. */
#define BW_IPU_IC_IDMAC_1_T1_FLIP_LR(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T1_FLIP_LR) | BF_IPU_IC_IDMAC_1_T1_FLIP_LR(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T1_FLIP_UD[13] (RW)
 *
 * UP/DOWN flip for Encoding (ENC) task The value of this field must be
 * identical to the corresponding channel's VF parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - Vertical flip enable
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T1_FLIP_UD (13U) /*!< Bit position for IPU_IC_IDMAC_1_T1_FLIP_UD. */
#define BM_IPU_IC_IDMAC_1_T1_FLIP_UD (0x00002000U) /*!< Bit mask for IPU_IC_IDMAC_1_T1_FLIP_UD. */
#define BS_IPU_IC_IDMAC_1_T1_FLIP_UD (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T1_FLIP_UD. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T1_FLIP_UD field. */
#define BR_IPU_IC_IDMAC_1_T1_FLIP_UD(x) (HW_IPU_IC_IDMAC_1(x).B.T1_FLIP_UD)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T1_FLIP_UD. */
#define BF_IPU_IC_IDMAC_1_T1_FLIP_UD(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T1_FLIP_UD) & BM_IPU_IC_IDMAC_1_T1_FLIP_UD)

/*! @brief Set the T1_FLIP_UD field to a new value. */
#define BW_IPU_IC_IDMAC_1_T1_FLIP_UD(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T1_FLIP_UD) | BF_IPU_IC_IDMAC_1_T1_FLIP_UD(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T2_ROT[14] (RW)
 *
 * Rotation for View Finder (VF) task The value of this field must be identical
 * to the corresponding channel's ROT parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - 90 degree rotation clockwise
 * - 0 - no rotation
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T2_ROT (14U)     /*!< Bit position for IPU_IC_IDMAC_1_T2_ROT. */
#define BM_IPU_IC_IDMAC_1_T2_ROT (0x00004000U) /*!< Bit mask for IPU_IC_IDMAC_1_T2_ROT. */
#define BS_IPU_IC_IDMAC_1_T2_ROT (1U)      /*!< Bit field size in bits for IPU_IC_IDMAC_1_T2_ROT. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T2_ROT field. */
#define BR_IPU_IC_IDMAC_1_T2_ROT(x) (HW_IPU_IC_IDMAC_1(x).B.T2_ROT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T2_ROT. */
#define BF_IPU_IC_IDMAC_1_T2_ROT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T2_ROT) & BM_IPU_IC_IDMAC_1_T2_ROT)

/*! @brief Set the T2_ROT field to a new value. */
#define BW_IPU_IC_IDMAC_1_T2_ROT(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T2_ROT) | BF_IPU_IC_IDMAC_1_T2_ROT(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T2_FLIP_LR[15] (RW)
 *
 * LEFT/RIGHT flip for View Finder (VF) task; this bit affect the flipping done
 * on the rotation unit The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T2_FLIP_LR (15U) /*!< Bit position for IPU_IC_IDMAC_1_T2_FLIP_LR. */
#define BM_IPU_IC_IDMAC_1_T2_FLIP_LR (0x00008000U) /*!< Bit mask for IPU_IC_IDMAC_1_T2_FLIP_LR. */
#define BS_IPU_IC_IDMAC_1_T2_FLIP_LR (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T2_FLIP_LR. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T2_FLIP_LR field. */
#define BR_IPU_IC_IDMAC_1_T2_FLIP_LR(x) (HW_IPU_IC_IDMAC_1(x).B.T2_FLIP_LR)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T2_FLIP_LR. */
#define BF_IPU_IC_IDMAC_1_T2_FLIP_LR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T2_FLIP_LR) & BM_IPU_IC_IDMAC_1_T2_FLIP_LR)

/*! @brief Set the T2_FLIP_LR field to a new value. */
#define BW_IPU_IC_IDMAC_1_T2_FLIP_LR(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T2_FLIP_LR) | BF_IPU_IC_IDMAC_1_T2_FLIP_LR(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T2_FLIP_UD[16] (RW)
 *
 * UP/DOWN flip for View Finder (VF) task The value of this field must be
 * identical to the corresponding channel's VF parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - Vertical flip enable
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T2_FLIP_UD (16U) /*!< Bit position for IPU_IC_IDMAC_1_T2_FLIP_UD. */
#define BM_IPU_IC_IDMAC_1_T2_FLIP_UD (0x00010000U) /*!< Bit mask for IPU_IC_IDMAC_1_T2_FLIP_UD. */
#define BS_IPU_IC_IDMAC_1_T2_FLIP_UD (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T2_FLIP_UD. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T2_FLIP_UD field. */
#define BR_IPU_IC_IDMAC_1_T2_FLIP_UD(x) (HW_IPU_IC_IDMAC_1(x).B.T2_FLIP_UD)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T2_FLIP_UD. */
#define BF_IPU_IC_IDMAC_1_T2_FLIP_UD(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T2_FLIP_UD) & BM_IPU_IC_IDMAC_1_T2_FLIP_UD)

/*! @brief Set the T2_FLIP_UD field to a new value. */
#define BW_IPU_IC_IDMAC_1_T2_FLIP_UD(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T2_FLIP_UD) | BF_IPU_IC_IDMAC_1_T2_FLIP_UD(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T3_ROT[17] (RW)
 *
 * Rotation for Post Processing (PP) task The value of this field must be
 * identical to the corresponding channel's ROT parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - 90 degree rotation clockwise
 * - 0 - no rotation
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T3_ROT (17U)     /*!< Bit position for IPU_IC_IDMAC_1_T3_ROT. */
#define BM_IPU_IC_IDMAC_1_T3_ROT (0x00020000U) /*!< Bit mask for IPU_IC_IDMAC_1_T3_ROT. */
#define BS_IPU_IC_IDMAC_1_T3_ROT (1U)      /*!< Bit field size in bits for IPU_IC_IDMAC_1_T3_ROT. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T3_ROT field. */
#define BR_IPU_IC_IDMAC_1_T3_ROT(x) (HW_IPU_IC_IDMAC_1(x).B.T3_ROT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T3_ROT. */
#define BF_IPU_IC_IDMAC_1_T3_ROT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T3_ROT) & BM_IPU_IC_IDMAC_1_T3_ROT)

/*! @brief Set the T3_ROT field to a new value. */
#define BW_IPU_IC_IDMAC_1_T3_ROT(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T3_ROT) | BF_IPU_IC_IDMAC_1_T3_ROT(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T3_FLIP_LR[18] (RW)
 *
 * LEFT/RIGHT flip for Post Processing (PP) task; this bit affect the flipping
 * done on the rotation unit The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T3_FLIP_LR (18U) /*!< Bit position for IPU_IC_IDMAC_1_T3_FLIP_LR. */
#define BM_IPU_IC_IDMAC_1_T3_FLIP_LR (0x00040000U) /*!< Bit mask for IPU_IC_IDMAC_1_T3_FLIP_LR. */
#define BS_IPU_IC_IDMAC_1_T3_FLIP_LR (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T3_FLIP_LR. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T3_FLIP_LR field. */
#define BR_IPU_IC_IDMAC_1_T3_FLIP_LR(x) (HW_IPU_IC_IDMAC_1(x).B.T3_FLIP_LR)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T3_FLIP_LR. */
#define BF_IPU_IC_IDMAC_1_T3_FLIP_LR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T3_FLIP_LR) & BM_IPU_IC_IDMAC_1_T3_FLIP_LR)

/*! @brief Set the T3_FLIP_LR field to a new value. */
#define BW_IPU_IC_IDMAC_1_T3_FLIP_LR(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T3_FLIP_LR) | BF_IPU_IC_IDMAC_1_T3_FLIP_LR(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T3_FLIP_UD[19] (RW)
 *
 * UP/DOWN flip for Post Processing (PP) task The value of this field must be
 * identical to the corresponding channel's VF parameters in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - Vertical flip enable
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T3_FLIP_UD (19U) /*!< Bit position for IPU_IC_IDMAC_1_T3_FLIP_UD. */
#define BM_IPU_IC_IDMAC_1_T3_FLIP_UD (0x00080000U) /*!< Bit mask for IPU_IC_IDMAC_1_T3_FLIP_UD. */
#define BS_IPU_IC_IDMAC_1_T3_FLIP_UD (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T3_FLIP_UD. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T3_FLIP_UD field. */
#define BR_IPU_IC_IDMAC_1_T3_FLIP_UD(x) (HW_IPU_IC_IDMAC_1(x).B.T3_FLIP_UD)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T3_FLIP_UD. */
#define BF_IPU_IC_IDMAC_1_T3_FLIP_UD(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T3_FLIP_UD) & BM_IPU_IC_IDMAC_1_T3_FLIP_UD)

/*! @brief Set the T3_FLIP_UD field to a new value. */
#define BW_IPU_IC_IDMAC_1_T3_FLIP_UD(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T3_FLIP_UD) | BF_IPU_IC_IDMAC_1_T3_FLIP_UD(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T1_FLIP_RS[20] (RW)
 *
 * LEFT/RIGHT flip for Encoding (ENC) task; this bit affect the flipping done on
 * the resizing unit. The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T1_FLIP_RS (20U) /*!< Bit position for IPU_IC_IDMAC_1_T1_FLIP_RS. */
#define BM_IPU_IC_IDMAC_1_T1_FLIP_RS (0x00100000U) /*!< Bit mask for IPU_IC_IDMAC_1_T1_FLIP_RS. */
#define BS_IPU_IC_IDMAC_1_T1_FLIP_RS (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T1_FLIP_RS. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T1_FLIP_RS field. */
#define BR_IPU_IC_IDMAC_1_T1_FLIP_RS(x) (HW_IPU_IC_IDMAC_1(x).B.T1_FLIP_RS)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T1_FLIP_RS. */
#define BF_IPU_IC_IDMAC_1_T1_FLIP_RS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T1_FLIP_RS) & BM_IPU_IC_IDMAC_1_T1_FLIP_RS)

/*! @brief Set the T1_FLIP_RS field to a new value. */
#define BW_IPU_IC_IDMAC_1_T1_FLIP_RS(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T1_FLIP_RS) | BF_IPU_IC_IDMAC_1_T1_FLIP_RS(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T2_FLIP_RS[21] (RW)
 *
 * LEFT/RIGHT flip for View Finder (VF) task; this bit affect the flipping done
 * on the resizing unit. The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T2_FLIP_RS (21U) /*!< Bit position for IPU_IC_IDMAC_1_T2_FLIP_RS. */
#define BM_IPU_IC_IDMAC_1_T2_FLIP_RS (0x00200000U) /*!< Bit mask for IPU_IC_IDMAC_1_T2_FLIP_RS. */
#define BS_IPU_IC_IDMAC_1_T2_FLIP_RS (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T2_FLIP_RS. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T2_FLIP_RS field. */
#define BR_IPU_IC_IDMAC_1_T2_FLIP_RS(x) (HW_IPU_IC_IDMAC_1(x).B.T2_FLIP_RS)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T2_FLIP_RS. */
#define BF_IPU_IC_IDMAC_1_T2_FLIP_RS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T2_FLIP_RS) & BM_IPU_IC_IDMAC_1_T2_FLIP_RS)

/*! @brief Set the T2_FLIP_RS field to a new value. */
#define BW_IPU_IC_IDMAC_1_T2_FLIP_RS(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T2_FLIP_RS) | BF_IPU_IC_IDMAC_1_T2_FLIP_RS(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field T3_FLIP_RS[22] (RW)
 *
 * LEFT/RIGHT flip for Post Processing (PP) task; his bit affect the flipping
 * done on the resizing unit. The value of this field must be identical to the
 * corresponding channel's HF parameter in the IDMAC's CPMEM
 *
 * Values:
 * - 1 - horizontal flip enabled
 * - 0 - no flip
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_T3_FLIP_RS (22U) /*!< Bit position for IPU_IC_IDMAC_1_T3_FLIP_RS. */
#define BM_IPU_IC_IDMAC_1_T3_FLIP_RS (0x00400000U) /*!< Bit mask for IPU_IC_IDMAC_1_T3_FLIP_RS. */
#define BS_IPU_IC_IDMAC_1_T3_FLIP_RS (1U)  /*!< Bit field size in bits for IPU_IC_IDMAC_1_T3_FLIP_RS. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_T3_FLIP_RS field. */
#define BR_IPU_IC_IDMAC_1_T3_FLIP_RS(x) (HW_IPU_IC_IDMAC_1(x).B.T3_FLIP_RS)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_T3_FLIP_RS. */
#define BF_IPU_IC_IDMAC_1_T3_FLIP_RS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_T3_FLIP_RS) & BM_IPU_IC_IDMAC_1_T3_FLIP_RS)

/*! @brief Set the T3_FLIP_RS field to a new value. */
#define BW_IPU_IC_IDMAC_1_T3_FLIP_RS(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_T3_FLIP_RS) | BF_IPU_IC_IDMAC_1_T3_FLIP_RS(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field ALT_CB6_BURST_16[24] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_ALT_CB6_BURST_16 (24U) /*!< Bit position for IPU_IC_IDMAC_1_ALT_CB6_BURST_16. */
#define BM_IPU_IC_IDMAC_1_ALT_CB6_BURST_16 (0x01000000U) /*!< Bit mask for IPU_IC_IDMAC_1_ALT_CB6_BURST_16. */
#define BS_IPU_IC_IDMAC_1_ALT_CB6_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_ALT_CB6_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_ALT_CB6_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_ALT_CB6_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.ALT_CB6_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_ALT_CB6_BURST_16. */
#define BF_IPU_IC_IDMAC_1_ALT_CB6_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_ALT_CB6_BURST_16) & BM_IPU_IC_IDMAC_1_ALT_CB6_BURST_16)

/*! @brief Set the ALT_CB6_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_ALT_CB6_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_ALT_CB6_BURST_16) | BF_IPU_IC_IDMAC_1_ALT_CB6_BURST_16(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_1, field ALT_CB7_BURST_16[25] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_IC_IDMAC_1_ALT_CB7_BURST_16 (25U) /*!< Bit position for IPU_IC_IDMAC_1_ALT_CB7_BURST_16. */
#define BM_IPU_IC_IDMAC_1_ALT_CB7_BURST_16 (0x02000000U) /*!< Bit mask for IPU_IC_IDMAC_1_ALT_CB7_BURST_16. */
#define BS_IPU_IC_IDMAC_1_ALT_CB7_BURST_16 (1U) /*!< Bit field size in bits for IPU_IC_IDMAC_1_ALT_CB7_BURST_16. */

/*! @brief Read current value of the IPU_IC_IDMAC_1_ALT_CB7_BURST_16 field. */
#define BR_IPU_IC_IDMAC_1_ALT_CB7_BURST_16(x) (HW_IPU_IC_IDMAC_1(x).B.ALT_CB7_BURST_16)

/*! @brief Format value for bitfield IPU_IC_IDMAC_1_ALT_CB7_BURST_16. */
#define BF_IPU_IC_IDMAC_1_ALT_CB7_BURST_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_1_ALT_CB7_BURST_16) & BM_IPU_IC_IDMAC_1_ALT_CB7_BURST_16)

/*! @brief Set the ALT_CB7_BURST_16 field to a new value. */
#define BW_IPU_IC_IDMAC_1_ALT_CB7_BURST_16(x, v) (HW_IPU_IC_IDMAC_1_WR(x, (HW_IPU_IC_IDMAC_1_RD(x) & ~BM_IPU_IC_IDMAC_1_ALT_CB7_BURST_16) | BF_IPU_IC_IDMAC_1_ALT_CB7_BURST_16(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_IDMAC_2 - IC IDMAC Parameters 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_IDMAC_2 - IC IDMAC Parameters 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_idmac_2
{
    uint32_t U;
    struct _hw_ipu_ic_idmac_2_bitfields
    {
        uint32_t T1_FR_HEIGHT : 10;    /*!< [9:0]  */
        uint32_t T2_FR_HEIGHT : 10;    /*!< [19:10]  */
        uint32_t T3_FR_HEIGHT : 10;    /*!< [29:20]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_ic_idmac_2_t;

/*!
 * @name Constants and macros for entire IPU_IC_IDMAC_2 register
 */
/*@{*/
#define HW_IPU_IC_IDMAC_2_ADDR(x) ((uintptr_t)(x) + 0x2001CU)

#define HW_IPU_IC_IDMAC_2(x)     (*(__IO hw_ipu_ic_idmac_2_t *) HW_IPU_IC_IDMAC_2_ADDR(x))
#define HW_IPU_IC_IDMAC_2_RD(x)  (HW_IPU_IC_IDMAC_2(x).U)
#define HW_IPU_IC_IDMAC_2_WR(x, v) (HW_IPU_IC_IDMAC_2(x).U = (v))
#define HW_IPU_IC_IDMAC_2_SET(x, v) (HW_IPU_IC_IDMAC_2_WR(x, HW_IPU_IC_IDMAC_2_RD(x) |  (v)))
#define HW_IPU_IC_IDMAC_2_CLR(x, v) (HW_IPU_IC_IDMAC_2_WR(x, HW_IPU_IC_IDMAC_2_RD(x) & ~(v)))
#define HW_IPU_IC_IDMAC_2_TOG(x, v) (HW_IPU_IC_IDMAC_2_WR(x, HW_IPU_IC_IDMAC_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_IDMAC_2 bitfields
 */

/*!
 * @name Register IPU_IC_IDMAC_2, field T1_FR_HEIGHT[9:0] (RW)
 *
 * Frame Height for Encoding (ENC) task The value of this field must be
 * identical to corresponding FH channel's parameters in the IDMAC's CPMEM. This
 * parameter refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_2_T1_FR_HEIGHT (0U) /*!< Bit position for IPU_IC_IDMAC_2_T1_FR_HEIGHT. */
#define BM_IPU_IC_IDMAC_2_T1_FR_HEIGHT (0x000003FFU) /*!< Bit mask for IPU_IC_IDMAC_2_T1_FR_HEIGHT. */
#define BS_IPU_IC_IDMAC_2_T1_FR_HEIGHT (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_2_T1_FR_HEIGHT. */

/*! @brief Read current value of the IPU_IC_IDMAC_2_T1_FR_HEIGHT field. */
#define BR_IPU_IC_IDMAC_2_T1_FR_HEIGHT(x) (HW_IPU_IC_IDMAC_2(x).B.T1_FR_HEIGHT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_2_T1_FR_HEIGHT. */
#define BF_IPU_IC_IDMAC_2_T1_FR_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_2_T1_FR_HEIGHT) & BM_IPU_IC_IDMAC_2_T1_FR_HEIGHT)

/*! @brief Set the T1_FR_HEIGHT field to a new value. */
#define BW_IPU_IC_IDMAC_2_T1_FR_HEIGHT(x, v) (HW_IPU_IC_IDMAC_2_WR(x, (HW_IPU_IC_IDMAC_2_RD(x) & ~BM_IPU_IC_IDMAC_2_T1_FR_HEIGHT) | BF_IPU_IC_IDMAC_2_T1_FR_HEIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_2, field T2_FR_HEIGHT[19:10] (RW)
 *
 * Frame Height for View Finder (VF) task The value of this field must be
 * identical to the corresponding FH channel's parameters in the IDMAC's CPMEM. This
 * parameter refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_2_T2_FR_HEIGHT (10U) /*!< Bit position for IPU_IC_IDMAC_2_T2_FR_HEIGHT. */
#define BM_IPU_IC_IDMAC_2_T2_FR_HEIGHT (0x000FFC00U) /*!< Bit mask for IPU_IC_IDMAC_2_T2_FR_HEIGHT. */
#define BS_IPU_IC_IDMAC_2_T2_FR_HEIGHT (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_2_T2_FR_HEIGHT. */

/*! @brief Read current value of the IPU_IC_IDMAC_2_T2_FR_HEIGHT field. */
#define BR_IPU_IC_IDMAC_2_T2_FR_HEIGHT(x) (HW_IPU_IC_IDMAC_2(x).B.T2_FR_HEIGHT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_2_T2_FR_HEIGHT. */
#define BF_IPU_IC_IDMAC_2_T2_FR_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_2_T2_FR_HEIGHT) & BM_IPU_IC_IDMAC_2_T2_FR_HEIGHT)

/*! @brief Set the T2_FR_HEIGHT field to a new value. */
#define BW_IPU_IC_IDMAC_2_T2_FR_HEIGHT(x, v) (HW_IPU_IC_IDMAC_2_WR(x, (HW_IPU_IC_IDMAC_2_RD(x) & ~BM_IPU_IC_IDMAC_2_T2_FR_HEIGHT) | BF_IPU_IC_IDMAC_2_T2_FR_HEIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_2, field T3_FR_HEIGHT[29:20] (RW)
 *
 * Frame Height for Post Processing (PP) task The value of this field must be
 * identical to the corresponding FH channel's parameters in the IDMAC's CPMEM.
 * This parameter refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_2_T3_FR_HEIGHT (20U) /*!< Bit position for IPU_IC_IDMAC_2_T3_FR_HEIGHT. */
#define BM_IPU_IC_IDMAC_2_T3_FR_HEIGHT (0x3FF00000U) /*!< Bit mask for IPU_IC_IDMAC_2_T3_FR_HEIGHT. */
#define BS_IPU_IC_IDMAC_2_T3_FR_HEIGHT (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_2_T3_FR_HEIGHT. */

/*! @brief Read current value of the IPU_IC_IDMAC_2_T3_FR_HEIGHT field. */
#define BR_IPU_IC_IDMAC_2_T3_FR_HEIGHT(x) (HW_IPU_IC_IDMAC_2(x).B.T3_FR_HEIGHT)

/*! @brief Format value for bitfield IPU_IC_IDMAC_2_T3_FR_HEIGHT. */
#define BF_IPU_IC_IDMAC_2_T3_FR_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_2_T3_FR_HEIGHT) & BM_IPU_IC_IDMAC_2_T3_FR_HEIGHT)

/*! @brief Set the T3_FR_HEIGHT field to a new value. */
#define BW_IPU_IC_IDMAC_2_T3_FR_HEIGHT(x, v) (HW_IPU_IC_IDMAC_2_WR(x, (HW_IPU_IC_IDMAC_2_RD(x) & ~BM_IPU_IC_IDMAC_2_T3_FR_HEIGHT) | BF_IPU_IC_IDMAC_2_T3_FR_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_IDMAC_3 - IC IDMAC Parameters 3Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_IDMAC_3 - IC IDMAC Parameters 3Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_idmac_3
{
    uint32_t U;
    struct _hw_ipu_ic_idmac_3_bitfields
    {
        uint32_t T1_FR_WIDTH : 10;     /*!< [9:0]  */
        uint32_t T2_FR_WIDTH : 10;     /*!< [19:10]  */
        uint32_t T3_FR_WIDTH : 10;     /*!< [29:20]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_ic_idmac_3_t;

/*!
 * @name Constants and macros for entire IPU_IC_IDMAC_3 register
 */
/*@{*/
#define HW_IPU_IC_IDMAC_3_ADDR(x) ((uintptr_t)(x) + 0x20020U)

#define HW_IPU_IC_IDMAC_3(x)     (*(__IO hw_ipu_ic_idmac_3_t *) HW_IPU_IC_IDMAC_3_ADDR(x))
#define HW_IPU_IC_IDMAC_3_RD(x)  (HW_IPU_IC_IDMAC_3(x).U)
#define HW_IPU_IC_IDMAC_3_WR(x, v) (HW_IPU_IC_IDMAC_3(x).U = (v))
#define HW_IPU_IC_IDMAC_3_SET(x, v) (HW_IPU_IC_IDMAC_3_WR(x, HW_IPU_IC_IDMAC_3_RD(x) |  (v)))
#define HW_IPU_IC_IDMAC_3_CLR(x, v) (HW_IPU_IC_IDMAC_3_WR(x, HW_IPU_IC_IDMAC_3_RD(x) & ~(v)))
#define HW_IPU_IC_IDMAC_3_TOG(x, v) (HW_IPU_IC_IDMAC_3_WR(x, HW_IPU_IC_IDMAC_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_IDMAC_3 bitfields
 */

/*!
 * @name Register IPU_IC_IDMAC_3, field T1_FR_WIDTH[9:0] (RW)
 *
 * Frame Width for Encoding (ENC) task The value of this field must be identical
 * to corresponding FW channel's parameters in the IDMAC's CPMEM. This parameter
 * refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_3_T1_FR_WIDTH (0U) /*!< Bit position for IPU_IC_IDMAC_3_T1_FR_WIDTH. */
#define BM_IPU_IC_IDMAC_3_T1_FR_WIDTH (0x000003FFU) /*!< Bit mask for IPU_IC_IDMAC_3_T1_FR_WIDTH. */
#define BS_IPU_IC_IDMAC_3_T1_FR_WIDTH (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_3_T1_FR_WIDTH. */

/*! @brief Read current value of the IPU_IC_IDMAC_3_T1_FR_WIDTH field. */
#define BR_IPU_IC_IDMAC_3_T1_FR_WIDTH(x) (HW_IPU_IC_IDMAC_3(x).B.T1_FR_WIDTH)

/*! @brief Format value for bitfield IPU_IC_IDMAC_3_T1_FR_WIDTH. */
#define BF_IPU_IC_IDMAC_3_T1_FR_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_3_T1_FR_WIDTH) & BM_IPU_IC_IDMAC_3_T1_FR_WIDTH)

/*! @brief Set the T1_FR_WIDTH field to a new value. */
#define BW_IPU_IC_IDMAC_3_T1_FR_WIDTH(x, v) (HW_IPU_IC_IDMAC_3_WR(x, (HW_IPU_IC_IDMAC_3_RD(x) & ~BM_IPU_IC_IDMAC_3_T1_FR_WIDTH) | BF_IPU_IC_IDMAC_3_T1_FR_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_3, field T2_FR_WIDTH[19:10] (RW)
 *
 * Frame Width for View Finder (VF) task The value of this field must be
 * identical to the corresponding FW channel's parameters in the IDMAC's CPMEM. This
 * parameter refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_3_T2_FR_WIDTH (10U) /*!< Bit position for IPU_IC_IDMAC_3_T2_FR_WIDTH. */
#define BM_IPU_IC_IDMAC_3_T2_FR_WIDTH (0x000FFC00U) /*!< Bit mask for IPU_IC_IDMAC_3_T2_FR_WIDTH. */
#define BS_IPU_IC_IDMAC_3_T2_FR_WIDTH (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_3_T2_FR_WIDTH. */

/*! @brief Read current value of the IPU_IC_IDMAC_3_T2_FR_WIDTH field. */
#define BR_IPU_IC_IDMAC_3_T2_FR_WIDTH(x) (HW_IPU_IC_IDMAC_3(x).B.T2_FR_WIDTH)

/*! @brief Format value for bitfield IPU_IC_IDMAC_3_T2_FR_WIDTH. */
#define BF_IPU_IC_IDMAC_3_T2_FR_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_3_T2_FR_WIDTH) & BM_IPU_IC_IDMAC_3_T2_FR_WIDTH)

/*! @brief Set the T2_FR_WIDTH field to a new value. */
#define BW_IPU_IC_IDMAC_3_T2_FR_WIDTH(x, v) (HW_IPU_IC_IDMAC_3_WR(x, (HW_IPU_IC_IDMAC_3_RD(x) & ~BM_IPU_IC_IDMAC_3_T2_FR_WIDTH) | BF_IPU_IC_IDMAC_3_T2_FR_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_3, field T3_FR_WIDTH[29:20] (RW)
 *
 * Frame Width for Post Processing (PP) task The value of this field must be
 * identical to the corresponding FW channel's parameters in the IDMAC's CPMEM. This
 * parameter refers to the output's size -1
 */
/*@{*/
#define BP_IPU_IC_IDMAC_3_T3_FR_WIDTH (20U) /*!< Bit position for IPU_IC_IDMAC_3_T3_FR_WIDTH. */
#define BM_IPU_IC_IDMAC_3_T3_FR_WIDTH (0x3FF00000U) /*!< Bit mask for IPU_IC_IDMAC_3_T3_FR_WIDTH. */
#define BS_IPU_IC_IDMAC_3_T3_FR_WIDTH (10U) /*!< Bit field size in bits for IPU_IC_IDMAC_3_T3_FR_WIDTH. */

/*! @brief Read current value of the IPU_IC_IDMAC_3_T3_FR_WIDTH field. */
#define BR_IPU_IC_IDMAC_3_T3_FR_WIDTH(x) (HW_IPU_IC_IDMAC_3(x).B.T3_FR_WIDTH)

/*! @brief Format value for bitfield IPU_IC_IDMAC_3_T3_FR_WIDTH. */
#define BF_IPU_IC_IDMAC_3_T3_FR_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_3_T3_FR_WIDTH) & BM_IPU_IC_IDMAC_3_T3_FR_WIDTH)

/*! @brief Set the T3_FR_WIDTH field to a new value. */
#define BW_IPU_IC_IDMAC_3_T3_FR_WIDTH(x, v) (HW_IPU_IC_IDMAC_3_WR(x, (HW_IPU_IC_IDMAC_3_RD(x) & ~BM_IPU_IC_IDMAC_3_T3_FR_WIDTH) | BF_IPU_IC_IDMAC_3_T3_FR_WIDTH(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_IC_IDMAC_4 - IC IDMAC Parameters 4 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_IC_IDMAC_4 - IC IDMAC Parameters 4 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_ic_idmac_4
{
    uint32_t U;
    struct _hw_ipu_ic_idmac_4_bitfields
    {
        uint32_t mpm_rw_brdg_max_rq : 4; /*!< [3:0]  */
        uint32_t mpm_dmfc_brdg_max_rq : 4; /*!< [7:4]  */
        uint32_t ibm_brdg_max_rq : 4;  /*!< [11:8]  */
        uint32_t rm_brdg_max_rq : 4;   /*!< [15:12]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_ic_idmac_4_t;

/*!
 * @name Constants and macros for entire IPU_IC_IDMAC_4 register
 */
/*@{*/
#define HW_IPU_IC_IDMAC_4_ADDR(x) ((uintptr_t)(x) + 0x20024U)

#define HW_IPU_IC_IDMAC_4(x)     (*(__IO hw_ipu_ic_idmac_4_t *) HW_IPU_IC_IDMAC_4_ADDR(x))
#define HW_IPU_IC_IDMAC_4_RD(x)  (HW_IPU_IC_IDMAC_4(x).U)
#define HW_IPU_IC_IDMAC_4_WR(x, v) (HW_IPU_IC_IDMAC_4(x).U = (v))
#define HW_IPU_IC_IDMAC_4_SET(x, v) (HW_IPU_IC_IDMAC_4_WR(x, HW_IPU_IC_IDMAC_4_RD(x) |  (v)))
#define HW_IPU_IC_IDMAC_4_CLR(x, v) (HW_IPU_IC_IDMAC_4_WR(x, HW_IPU_IC_IDMAC_4_RD(x) & ~(v)))
#define HW_IPU_IC_IDMAC_4_TOG(x, v) (HW_IPU_IC_IDMAC_4_WR(x, HW_IPU_IC_IDMAC_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_IC_IDMAC_4 bitfields
 */

/*!
 * @name Register IPU_IC_IDMAC_4, field mpm_rw_brdg_max_rq[3:0] (RW)
 *
 * MPM memory Bridge Max Requests between MPM's read and writes
 *
 * Values:
 * - 0000 - Feature is disabled
 * - 0001 - Max request is 1
 * - 1111 - Max request are15
 */
/*@{*/
#define BP_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq (0U) /*!< Bit position for IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq. */
#define BM_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq (0x0000000FU) /*!< Bit mask for IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq. */
#define BS_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq (4U) /*!< Bit field size in bits for IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq. */

/*! @brief Read current value of the IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq field. */
#define BR_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq(x) (HW_IPU_IC_IDMAC_4(x).B.mpm_rw_brdg_max_rq)

/*! @brief Format value for bitfield IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq. */
#define BF_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq) & BM_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq)

/*! @brief Set the mpm_rw_brdg_max_rq field to a new value. */
#define BW_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq(x, v) (HW_IPU_IC_IDMAC_4_WR(x, (HW_IPU_IC_IDMAC_4_RD(x) & ~BM_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq) | BF_IPU_IC_IDMAC_4_mpm_rw_brdg_max_rq(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_4, field mpm_dmfc_brdg_max_rq[7:4] (RW)
 *
 * MPM memory Bridge Max Requests for the IC DMFC interface
 *
 * Values:
 * - 0000 - Feature is disabled
 * - 0001 - Max request is 1
 * - 1111 - Max request are15
 */
/*@{*/
#define BP_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq (4U) /*!< Bit position for IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq. */
#define BM_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq (0x000000F0U) /*!< Bit mask for IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq. */
#define BS_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq (4U) /*!< Bit field size in bits for IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq. */

/*! @brief Read current value of the IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq field. */
#define BR_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq(x) (HW_IPU_IC_IDMAC_4(x).B.mpm_dmfc_brdg_max_rq)

/*! @brief Format value for bitfield IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq. */
#define BF_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq) & BM_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq)

/*! @brief Set the mpm_dmfc_brdg_max_rq field to a new value. */
#define BW_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq(x, v) (HW_IPU_IC_IDMAC_4_WR(x, (HW_IPU_IC_IDMAC_4_RD(x) & ~BM_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq) | BF_IPU_IC_IDMAC_4_mpm_dmfc_brdg_max_rq(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_4, field ibm_brdg_max_rq[11:8] (RW)
 *
 * IBM memory Bridge Max Requests
 *
 * Values:
 * - 0000 - Feature is disabled
 * - 0001 - Max request is 1
 * - 1111 - Max request are15
 */
/*@{*/
#define BP_IPU_IC_IDMAC_4_ibm_brdg_max_rq (8U) /*!< Bit position for IPU_IC_IDMAC_4_ibm_brdg_max_rq. */
#define BM_IPU_IC_IDMAC_4_ibm_brdg_max_rq (0x00000F00U) /*!< Bit mask for IPU_IC_IDMAC_4_ibm_brdg_max_rq. */
#define BS_IPU_IC_IDMAC_4_ibm_brdg_max_rq (4U) /*!< Bit field size in bits for IPU_IC_IDMAC_4_ibm_brdg_max_rq. */

/*! @brief Read current value of the IPU_IC_IDMAC_4_ibm_brdg_max_rq field. */
#define BR_IPU_IC_IDMAC_4_ibm_brdg_max_rq(x) (HW_IPU_IC_IDMAC_4(x).B.ibm_brdg_max_rq)

/*! @brief Format value for bitfield IPU_IC_IDMAC_4_ibm_brdg_max_rq. */
#define BF_IPU_IC_IDMAC_4_ibm_brdg_max_rq(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_4_ibm_brdg_max_rq) & BM_IPU_IC_IDMAC_4_ibm_brdg_max_rq)

/*! @brief Set the ibm_brdg_max_rq field to a new value. */
#define BW_IPU_IC_IDMAC_4_ibm_brdg_max_rq(x, v) (HW_IPU_IC_IDMAC_4_WR(x, (HW_IPU_IC_IDMAC_4_RD(x) & ~BM_IPU_IC_IDMAC_4_ibm_brdg_max_rq) | BF_IPU_IC_IDMAC_4_ibm_brdg_max_rq(v)))
/*@}*/

/*!
 * @name Register IPU_IC_IDMAC_4, field rm_brdg_max_rq[15:12] (RW)
 *
 * RM memory Bridge Max Requests
 *
 * Values:
 * - 0000 - Feature is disabled
 * - 0001 - Max request is 1
 * - 1111 - Max request are15
 */
/*@{*/
#define BP_IPU_IC_IDMAC_4_rm_brdg_max_rq (12U) /*!< Bit position for IPU_IC_IDMAC_4_rm_brdg_max_rq. */
#define BM_IPU_IC_IDMAC_4_rm_brdg_max_rq (0x0000F000U) /*!< Bit mask for IPU_IC_IDMAC_4_rm_brdg_max_rq. */
#define BS_IPU_IC_IDMAC_4_rm_brdg_max_rq (4U) /*!< Bit field size in bits for IPU_IC_IDMAC_4_rm_brdg_max_rq. */

/*! @brief Read current value of the IPU_IC_IDMAC_4_rm_brdg_max_rq field. */
#define BR_IPU_IC_IDMAC_4_rm_brdg_max_rq(x) (HW_IPU_IC_IDMAC_4(x).B.rm_brdg_max_rq)

/*! @brief Format value for bitfield IPU_IC_IDMAC_4_rm_brdg_max_rq. */
#define BF_IPU_IC_IDMAC_4_rm_brdg_max_rq(v) ((uint32_t)((uint32_t)(v) << BP_IPU_IC_IDMAC_4_rm_brdg_max_rq) & BM_IPU_IC_IDMAC_4_rm_brdg_max_rq)

/*! @brief Set the rm_brdg_max_rq field to a new value. */
#define BW_IPU_IC_IDMAC_4_rm_brdg_max_rq(x, v) (HW_IPU_IC_IDMAC_4_WR(x, (HW_IPU_IC_IDMAC_4_RD(x) & ~BM_IPU_IC_IDMAC_4_rm_brdg_max_rq) | BF_IPU_IC_IDMAC_4_rm_brdg_max_rq(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_SENS_CONF - CSI0 Sensor Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_SENS_CONF - CSI0 Sensor Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_sens_conf
{
    uint32_t U;
    struct _hw_ipu_csi0_sens_conf_bitfields
    {
        uint32_t CSI0_VSYNC_POL : 1;   /*!< [0]  */
        uint32_t CSI0_HSYNC_POL : 1;   /*!< [1]  */
        uint32_t CSI0_DATA_POL : 1;    /*!< [2]  */
        uint32_t CSI0_SENS_PIX_CLK_POL : 1; /*!< [3]  */
        uint32_t CSI0_SENS_PRTCL : 3;  /*!< [6:4]  */
        uint32_t CSI0_PACK_TIGHT : 1;  /*!< [7]  */
        uint32_t CSI0_SENS_DATA_FORMAT : 3; /*!< [10:8]  */
        uint32_t CSI0_DATA_WIDTH : 4;  /*!< [14:11]  */
        uint32_t CSI0_EXT_VSYNC : 1;   /*!< [15]  */
        uint32_t CSI0_DIV_RATIO : 8;   /*!< [23:16]  */
        uint32_t CSI0_DATA_DEST : 3;   /*!< [26:24]  */
        uint32_t CSI0_JPEG8_EN : 1;    /*!< [27]  */
        uint32_t CSI0_JPEG_MODE : 1;   /*!< [28]  */
        uint32_t CSI0_FORCE_EOF : 1;   /*!< [29]  */
        uint32_t RESERVED0 : 1;        /*!< [30]  */
        uint32_t CSI0_DATA_EN_POL : 1; /*!< [31]  */
    } B;
} hw_ipu_csi0_sens_conf_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_SENS_CONF register
 */
/*@{*/
#define HW_IPU_CSI0_SENS_CONF_ADDR(x) ((uintptr_t)(x) + 0x30000U)

#define HW_IPU_CSI0_SENS_CONF(x) (*(__IO hw_ipu_csi0_sens_conf_t *) HW_IPU_CSI0_SENS_CONF_ADDR(x))
#define HW_IPU_CSI0_SENS_CONF_RD(x) (HW_IPU_CSI0_SENS_CONF(x).U)
#define HW_IPU_CSI0_SENS_CONF_WR(x, v) (HW_IPU_CSI0_SENS_CONF(x).U = (v))
#define HW_IPU_CSI0_SENS_CONF_SET(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, HW_IPU_CSI0_SENS_CONF_RD(x) |  (v)))
#define HW_IPU_CSI0_SENS_CONF_CLR(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, HW_IPU_CSI0_SENS_CONF_RD(x) & ~(v)))
#define HW_IPU_CSI0_SENS_CONF_TOG(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, HW_IPU_CSI0_SENS_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_SENS_CONF bitfields
 */

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_VSYNC_POL[0] (RW)
 *
 * Invert IPP_IND_SENSB_VSYNC input. This bit selects the polarity of
 * IPP_IND_SENSB_VSYNC signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_VSYNC is not inverted before applied to internal
 *     circuitry.
 * - 1 - IPP_IND_SENSB_VSYNC is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL (0U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL (0x00000001U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_VSYNC_POL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL) & BM_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL)

/*! @brief Set the CSI0_VSYNC_POL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL) | BF_IPU_CSI0_SENS_CONF_CSI0_VSYNC_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_HSYNC_POL[1] (RW)
 *
 * Invert IPP_IND_SENSB_HSYNC input. This bit selects the polarity of
 * IPP_IND_SENSB_HSYNC signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_HSYNC is directly applied to internal circuitry.
 * - 1 - IPP_IND_SENSB_HSYNC is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL (1U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL (0x00000002U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_HSYNC_POL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL) & BM_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL)

/*! @brief Set the CSI0_HSYNC_POL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL) | BF_IPU_CSI0_SENS_CONF_CSI0_HSYNC_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_DATA_POL[2] (RW)
 *
 * Invert data input. This bit selects the polarity of data input.
 *
 * Values:
 * - 0 - data lines are directly applied to internal circuitry.
 * - 1 - data lines are inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_DATA_POL (2U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_DATA_POL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_DATA_POL (0x00000004U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_DATA_POL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_DATA_POL (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_DATA_POL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_DATA_POL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_DATA_POL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_DATA_POL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_DATA_POL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_DATA_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_DATA_POL) & BM_IPU_CSI0_SENS_CONF_CSI0_DATA_POL)

/*! @brief Set the CSI0_DATA_POL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_DATA_POL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_DATA_POL) | BF_IPU_CSI0_SENS_CONF_CSI0_DATA_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_SENS_PIX_CLK_POL[3] (RW)
 *
 * Invert Pixel clock input. This bit selects the polarity of pixel clock.
 *
 * Values:
 * - 0 - pixel clock is directly applied to internal circuitry.
 * - 1 - pixel clock is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL (3U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL (0x00000008U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_SENS_PIX_CLK_POL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL) & BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL)

/*! @brief Set the CSI0_SENS_PIX_CLK_POL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL) | BF_IPU_CSI0_SENS_CONF_CSI0_SENS_PIX_CLK_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_SENS_PRTCL[6:4] (RW)
 *
 * Sensor Protocol. This bit defines the Sensor timing/data mode protocol.
 * Values:
 *
 * Values:
 * - 000 - Gated clock mode
 * - 001 - Non-gated clock mode
 * - 010 - CCIR progressive mode (BT.656)
 * - 011 - CCIR interlaced mode (BT.656)
 * - 100 - CCIR progressive (BT.1120 DDR mode: data arrives on every edge of the
 *     clock)
 * - 101 - CCIR progressive (BT.1120 SDR mode: data arrives only on the positive
 *     edge of the clock)
 * - 110 - CCIR interlaced mode (BT.1120 DDR mode: data arrives on every edge of
 *     the clock)
 * - 111 - CCIR interlaced mode (BT.1120 SDR mode: data arrives only on the
 *     positive edge of the clock)
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL (4U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL (0x00000070U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL (3U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_SENS_PRTCL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL) & BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL)

/*! @brief Set the CSI0_SENS_PRTCL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL) | BF_IPU_CSI0_SENS_CONF_CSI0_SENS_PRTCL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_PACK_TIGHT[7] (RW)
 *
 * CSI0 Pack Tight When the data format is YUV or RGB and the component's width
 * is 9-16 bits, it can be sent to the memory in 2 different ways.
 *
 * Values:
 * - 1 - Three 10 bits components are packed into a 32 bit word. Color
 *     extension/reduction is performed
 * - 0 - Each component is written as a 16 bit word where the MSB is written to
 *     bit #15, color extension is done for the remaining least significant bits.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT (7U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT (0x00000080U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_PACK_TIGHT)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT) & BM_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT)

/*! @brief Set the CSI0_PACK_TIGHT field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT) | BF_IPU_CSI0_SENS_CONF_CSI0_PACK_TIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_SENS_DATA_FORMAT[10:8] (RW)
 *
 * Data format from the sensor. This field defines the data format for the input
 * of the CSI sensor. Values:
 *
 * Values:
 * - 000 - full RGB or YUV444
 * - 001 - YUV422 (YUYV...)
 * - 010 - YUV422 (UYVY...)
 * - 011 - Bayer or Generic data
 * - 100 - RGB565
 * - 101 - RGB555
 * - 110 - RGB444
 * - 111 - JPEG
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT (8U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT (0x00000700U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT (3U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_SENS_DATA_FORMAT)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT) & BM_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT)

/*! @brief Set the CSI0_SENS_DATA_FORMAT field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT) | BF_IPU_CSI0_SENS_CONF_CSI0_SENS_DATA_FORMAT(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_DATA_WIDTH[14:11] (RW)
 *
 * Data width. This field defines the number of bits per color. Values:
 *
 * Values:
 * - 0000 - 4 bits per color
 * - 0001 - 8 bits per color
 * - 0010 - 9 bits per color
 * - 0011 - 10 bits per color
 * - 0100 - 11 bits per color
 * - 0101 - 12 bits per color
 * - 0110 - 13 bits per color
 * - 0111 - 14 bits per color
 * - 1000 - 15 bits per color
 * - 1001 - 16 bits per color
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH (11U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH (0x00007800U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH (4U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_DATA_WIDTH)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH) & BM_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH)

/*! @brief Set the CSI0_DATA_WIDTH field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH) | BF_IPU_CSI0_SENS_CONF_CSI0_DATA_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_EXT_VSYNC[15] (RW)
 *
 * External VSYNC enable. This bits select between external and internal VSYNC.
 *
 * Values:
 * - 0 - Internal VSYNC mode.
 * - 1 - External VSYNC mode.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC (15U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC (0x00008000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_EXT_VSYNC)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC) & BM_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC)

/*! @brief Set the CSI0_EXT_VSYNC field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC) | BF_IPU_CSI0_SENS_CONF_CSI0_EXT_VSYNC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_DIV_RATIO[23:16] (RW)
 *
 * DIV Ratio Clock division ratio minus 1. This field defines the division ratio
 * of HSP_CLK into SENSB_MCLK: SENSB_MCLK rate = HSP_CLK rate /(DIV_RATIO+1)
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO (16U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO (0x00FF0000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO (8U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_DIV_RATIO)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO) & BM_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO)

/*! @brief Set the CSI0_DIV_RATIO field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO) | BF_IPU_CSI0_SENS_CONF_CSI0_DIV_RATIO(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_DATA_DEST[26:24] (RW)
 *
 * These bits enable the destination of the data coming from the CSI.
 * CSI0_DATA_DEST[0] - Reserved CSI0_DATA_DEST[1] - destination is IC CSI0_DATA_DEST[2] -
 * destination is IDMAC via SMFC
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST (24U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_DATA_DEST. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST (0x07000000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_DATA_DEST. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST (3U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_DATA_DEST. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_DATA_DEST field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_DATA_DEST)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_DATA_DEST. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST) & BM_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST)

/*! @brief Set the CSI0_DATA_DEST field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST) | BF_IPU_CSI0_SENS_CONF_CSI0_DATA_DEST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_JPEG8_EN[27] (RW)
 *
 * JPEG8 enable bit
 *
 * Values:
 * - 1 - JPEG8 detection is enabled
 * - 0 - JPEG8 is disabled
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN (27U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN (0x08000000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_JPEG8_EN)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN) & BM_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN)

/*! @brief Set the CSI0_JPEG8_EN field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN) | BF_IPU_CSI0_SENS_CONF_CSI0_JPEG8_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_JPEG_MODE[28] (RW)
 *
 * JPEG Mode - this bit defines the mode of the control signals when working in
 * JPEG mode
 *
 * Values:
 * - 1 - The data is valid as long as HSYNC and VSYNC signals are active; HSYNC
 *     is valid for single frame
 * - 0 - The frame starts withe the assertion of VSYNC. The frame ends on the
 *     next VSYNC or by setting the CSI0_FORCE_EOF bit.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE (28U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE (0x10000000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_JPEG_MODE)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE) & BM_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE)

/*! @brief Set the CSI0_JPEG_MODE field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE) | BF_IPU_CSI0_SENS_CONF_CSI0_JPEG_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_FORCE_EOF[29] (RW)
 *
 * Force End of frame This is a self clear bit allowing the user to force an
 * End-of-frame event; This bit can be used in cases where the frame sent by the
 * sensor was not completed.
 *
 * Values:
 * - 1 - force end of frame
 * - 0 - no action
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF (29U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF (0x20000000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_FORCE_EOF)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF) & BM_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF)

/*! @brief Set the CSI0_FORCE_EOF field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF) | BF_IPU_CSI0_SENS_CONF_CSI0_FORCE_EOF(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_CONF, field CSI0_DATA_EN_POL[31] (RW)
 *
 * Invert IPP_IND_SENSB_DATA_EN input. This bit selects the polarity of
 * IPP_IND_SENSB_DATA_EN signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_DATA_EN is directly applied to internal circuitry.
 * - 1 - IPP_IND_SENSB_DATA_EN is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL (31U) /*!< Bit position for IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL. */
#define BM_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL (0x80000000U) /*!< Bit mask for IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL. */
#define BS_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL (1U) /*!< Bit field size in bits for IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL. */

/*! @brief Read current value of the IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL field. */
#define BR_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL(x) (HW_IPU_CSI0_SENS_CONF(x).B.CSI0_DATA_EN_POL)

/*! @brief Format value for bitfield IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL. */
#define BF_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL) & BM_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL)

/*! @brief Set the CSI0_DATA_EN_POL field to a new value. */
#define BW_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL(x, v) (HW_IPU_CSI0_SENS_CONF_WR(x, (HW_IPU_CSI0_SENS_CONF_RD(x) & ~BM_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL) | BF_IPU_CSI0_SENS_CONF_CSI0_DATA_EN_POL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_SENS_FRM_SIZE - CSI0 Sense Frame Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_SENS_FRM_SIZE - CSI0 Sense Frame Size Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_sens_frm_size
{
    uint32_t U;
    struct _hw_ipu_csi0_sens_frm_size_bitfields
    {
        uint32_t CSI0_SENS_FRM_WIDTH : 13; /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t CSI0_SENS_FRM_HEIGHT : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_csi0_sens_frm_size_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_SENS_FRM_SIZE register
 */
/*@{*/
#define HW_IPU_CSI0_SENS_FRM_SIZE_ADDR(x) ((uintptr_t)(x) + 0x30004U)

#define HW_IPU_CSI0_SENS_FRM_SIZE(x) (*(__IO hw_ipu_csi0_sens_frm_size_t *) HW_IPU_CSI0_SENS_FRM_SIZE_ADDR(x))
#define HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) (HW_IPU_CSI0_SENS_FRM_SIZE(x).U)
#define HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE(x).U = (v))
#define HW_IPU_CSI0_SENS_FRM_SIZE_SET(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) |  (v)))
#define HW_IPU_CSI0_SENS_FRM_SIZE_CLR(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) & ~(v)))
#define HW_IPU_CSI0_SENS_FRM_SIZE_TOG(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_SENS_FRM_SIZE bitfields
 */

/*!
 * @name Register IPU_CSI0_SENS_FRM_SIZE, field CSI0_SENS_FRM_WIDTH[12:0] (RW)
 *
 * Sensor frame width minus 1. This field defines the sensor frame column number
 * minus 1.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH (0U) /*!< Bit position for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH. */
#define BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH (0x00001FFFU) /*!< Bit mask for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH. */
#define BS_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH (13U) /*!< Bit field size in bits for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH. */

/*! @brief Read current value of the IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH field. */
#define BR_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH(x) (HW_IPU_CSI0_SENS_FRM_SIZE(x).B.CSI0_SENS_FRM_WIDTH)

/*! @brief Format value for bitfield IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH. */
#define BF_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH) & BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH)

/*! @brief Set the CSI0_SENS_FRM_WIDTH field to a new value. */
#define BW_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, (HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) & ~BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH) | BF_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SENS_FRM_SIZE, field CSI0_SENS_FRM_HEIGHT[27:16] (RW)
 *
 * Sensor frame height minus 1. This field defines the sensor frame rows number
 * minus 1.
 */
/*@{*/
#define BP_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT (16U) /*!< Bit position for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT. */
#define BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT. */
#define BS_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT (12U) /*!< Bit field size in bits for IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT. */

/*! @brief Read current value of the IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT field. */
#define BR_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT(x) (HW_IPU_CSI0_SENS_FRM_SIZE(x).B.CSI0_SENS_FRM_HEIGHT)

/*! @brief Format value for bitfield IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT. */
#define BF_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT) & BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT)

/*! @brief Set the CSI0_SENS_FRM_HEIGHT field to a new value. */
#define BW_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT(x, v) (HW_IPU_CSI0_SENS_FRM_SIZE_WR(x, (HW_IPU_CSI0_SENS_FRM_SIZE_RD(x) & ~BM_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT) | BF_IPU_CSI0_SENS_FRM_SIZE_CSI0_SENS_FRM_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_ACT_FRM_SIZE - CSI0 Actual Frame Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_ACT_FRM_SIZE - CSI0 Actual Frame Size Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_act_frm_size
{
    uint32_t U;
    struct _hw_ipu_csi0_act_frm_size_bitfields
    {
        uint32_t CSI0_ACT_FRM_WIDTH : 13; /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t CSI0_ACT_FRM_HEIGHT : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_csi0_act_frm_size_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_ACT_FRM_SIZE register
 */
/*@{*/
#define HW_IPU_CSI0_ACT_FRM_SIZE_ADDR(x) ((uintptr_t)(x) + 0x30008U)

#define HW_IPU_CSI0_ACT_FRM_SIZE(x) (*(__IO hw_ipu_csi0_act_frm_size_t *) HW_IPU_CSI0_ACT_FRM_SIZE_ADDR(x))
#define HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) (HW_IPU_CSI0_ACT_FRM_SIZE(x).U)
#define HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE(x).U = (v))
#define HW_IPU_CSI0_ACT_FRM_SIZE_SET(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) |  (v)))
#define HW_IPU_CSI0_ACT_FRM_SIZE_CLR(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) & ~(v)))
#define HW_IPU_CSI0_ACT_FRM_SIZE_TOG(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_ACT_FRM_SIZE bitfields
 */

/*!
 * @name Register IPU_CSI0_ACT_FRM_SIZE, field CSI0_ACT_FRM_WIDTH[12:0] (RW)
 *
 * Actual frame width minus 1. This field defines the CSI output frame columns
 * number minus 1.
 */
/*@{*/
#define BP_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH (0U) /*!< Bit position for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH. */
#define BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH (0x00001FFFU) /*!< Bit mask for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH. */
#define BS_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH (13U) /*!< Bit field size in bits for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH. */

/*! @brief Read current value of the IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH field. */
#define BR_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH(x) (HW_IPU_CSI0_ACT_FRM_SIZE(x).B.CSI0_ACT_FRM_WIDTH)

/*! @brief Format value for bitfield IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH. */
#define BF_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH) & BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH)

/*! @brief Set the CSI0_ACT_FRM_WIDTH field to a new value. */
#define BW_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, (HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) & ~BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH) | BF_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_ACT_FRM_SIZE, field CSI0_ACT_FRM_HEIGHT[27:16] (RW)
 *
 * Actual frame height minus 1. This field defines the CSI output frame rows
 * number minus 1.
 */
/*@{*/
#define BP_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT (16U) /*!< Bit position for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT. */
#define BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT. */
#define BS_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT (12U) /*!< Bit field size in bits for IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT. */

/*! @brief Read current value of the IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT field. */
#define BR_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT(x) (HW_IPU_CSI0_ACT_FRM_SIZE(x).B.CSI0_ACT_FRM_HEIGHT)

/*! @brief Format value for bitfield IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT. */
#define BF_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT) & BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT)

/*! @brief Set the CSI0_ACT_FRM_HEIGHT field to a new value. */
#define BW_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT(x, v) (HW_IPU_CSI0_ACT_FRM_SIZE_WR(x, (HW_IPU_CSI0_ACT_FRM_SIZE_RD(x) & ~BM_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT) | BF_IPU_CSI0_ACT_FRM_SIZE_CSI0_ACT_FRM_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_OUT_FRM_CTRL - CSI0 Output Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_OUT_FRM_CTRL - CSI0 Output Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_out_frm_ctrl
{
    uint32_t U;
    struct _hw_ipu_csi0_out_frm_ctrl_bitfields
    {
        uint32_t CSI0_VSC : 12;        /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI0_HSC : 13;        /*!< [28:16]  */
        uint32_t RESERVED1 : 1;        /*!< [29]  */
        uint32_t CSI0_VERT_DWNS : 1;   /*!< [30]  */
        uint32_t CSI0_HORZ_DWNS : 1;   /*!< [31]  */
    } B;
} hw_ipu_csi0_out_frm_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_OUT_FRM_CTRL register
 */
/*@{*/
#define HW_IPU_CSI0_OUT_FRM_CTRL_ADDR(x) ((uintptr_t)(x) + 0x3000CU)

#define HW_IPU_CSI0_OUT_FRM_CTRL(x) (*(__IO hw_ipu_csi0_out_frm_ctrl_t *) HW_IPU_CSI0_OUT_FRM_CTRL_ADDR(x))
#define HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) (HW_IPU_CSI0_OUT_FRM_CTRL(x).U)
#define HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL(x).U = (v))
#define HW_IPU_CSI0_OUT_FRM_CTRL_SET(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) |  (v)))
#define HW_IPU_CSI0_OUT_FRM_CTRL_CLR(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) & ~(v)))
#define HW_IPU_CSI0_OUT_FRM_CTRL_TOG(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_OUT_FRM_CTRL bitfields
 */

/*!
 * @name Register IPU_CSI0_OUT_FRM_CTRL, field CSI0_VSC[11:0] (RW)
 *
 * Vertical skip. This field defines the number of rows to skip.
 */
/*@{*/
#define BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC (0U) /*!< Bit position for IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC. */
#define BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC (0x00000FFFU) /*!< Bit mask for IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC. */
#define BS_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC (12U) /*!< Bit field size in bits for IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC. */

/*! @brief Read current value of the IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC field. */
#define BR_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC(x) (HW_IPU_CSI0_OUT_FRM_CTRL(x).B.CSI0_VSC)

/*! @brief Format value for bitfield IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC. */
#define BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC) & BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC)

/*! @brief Set the CSI0_VSC field to a new value. */
#define BW_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC) | BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_VSC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_OUT_FRM_CTRL, field CSI0_HSC[28:16] (RW)
 *
 * Horizontal skip. This field defines the number of columns to skip. In
 * Interlaced mode this number refers to the number of lines per field.
 */
/*@{*/
#define BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC (16U) /*!< Bit position for IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC. */
#define BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC (0x1FFF0000U) /*!< Bit mask for IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC. */
#define BS_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC (13U) /*!< Bit field size in bits for IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC. */

/*! @brief Read current value of the IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC field. */
#define BR_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC(x) (HW_IPU_CSI0_OUT_FRM_CTRL(x).B.CSI0_HSC)

/*! @brief Format value for bitfield IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC. */
#define BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC) & BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC)

/*! @brief Set the CSI0_HSC field to a new value. */
#define BW_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC) | BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_HSC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_OUT_FRM_CTRL, field CSI0_VERT_DWNS[30] (RW)
 *
 * Enable vertical downsizing (decimation) by 2.
 *
 * Values:
 * - 0 - Downsizing disabled
 * - 1 - Downsizing enabled
 */
/*@{*/
#define BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS (30U) /*!< Bit position for IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS. */
#define BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS (0x40000000U) /*!< Bit mask for IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS. */
#define BS_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS (1U) /*!< Bit field size in bits for IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS. */

/*! @brief Read current value of the IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS field. */
#define BR_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS(x) (HW_IPU_CSI0_OUT_FRM_CTRL(x).B.CSI0_VERT_DWNS)

/*! @brief Format value for bitfield IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS. */
#define BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS) & BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS)

/*! @brief Set the CSI0_VERT_DWNS field to a new value. */
#define BW_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS) | BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_VERT_DWNS(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_OUT_FRM_CTRL, field CSI0_HORZ_DWNS[31] (RW)
 *
 * Enable horizontal downsizing (decimation) by 2.
 *
 * Values:
 * - 0 - Downsizing disabled1 Downsizing enabled
 */
/*@{*/
#define BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS (31U) /*!< Bit position for IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS. */
#define BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS (0x80000000U) /*!< Bit mask for IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS. */
#define BS_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS (1U) /*!< Bit field size in bits for IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS. */

/*! @brief Read current value of the IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS field. */
#define BR_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS(x) (HW_IPU_CSI0_OUT_FRM_CTRL(x).B.CSI0_HORZ_DWNS)

/*! @brief Format value for bitfield IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS. */
#define BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS) & BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS)

/*! @brief Set the CSI0_HORZ_DWNS field to a new value. */
#define BW_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS(x, v) (HW_IPU_CSI0_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI0_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS) | BF_IPU_CSI0_OUT_FRM_CTRL_CSI0_HORZ_DWNS(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_TST_CTRL - CSIO Test Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_TST_CTRL - CSIO Test Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_tst_ctrl
{
    uint32_t U;
    struct _hw_ipu_csi0_tst_ctrl_bitfields
    {
        uint32_t PG_R_VALUE : 8;       /*!< [7:0]  */
        uint32_t PG_G_VALUE : 8;       /*!< [15:8]  */
        uint32_t PG_B_VALUE : 8;       /*!< [23:16]  */
        uint32_t TEST_GEN_MODE : 1;    /*!< [24]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi0_tst_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_TST_CTRL register
 */
/*@{*/
#define HW_IPU_CSI0_TST_CTRL_ADDR(x) ((uintptr_t)(x) + 0x30010U)

#define HW_IPU_CSI0_TST_CTRL(x)  (*(__IO hw_ipu_csi0_tst_ctrl_t *) HW_IPU_CSI0_TST_CTRL_ADDR(x))
#define HW_IPU_CSI0_TST_CTRL_RD(x) (HW_IPU_CSI0_TST_CTRL(x).U)
#define HW_IPU_CSI0_TST_CTRL_WR(x, v) (HW_IPU_CSI0_TST_CTRL(x).U = (v))
#define HW_IPU_CSI0_TST_CTRL_SET(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, HW_IPU_CSI0_TST_CTRL_RD(x) |  (v)))
#define HW_IPU_CSI0_TST_CTRL_CLR(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, HW_IPU_CSI0_TST_CTRL_RD(x) & ~(v)))
#define HW_IPU_CSI0_TST_CTRL_TOG(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, HW_IPU_CSI0_TST_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_TST_CTRL bitfields
 */

/*!
 * @name Register IPU_CSI0_TST_CTRL, field PG_R_VALUE[7:0] (RW)
 *
 * Pattern generator R value. This field selects the R value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI0_TST_CTRL_PG_R_VALUE (0U) /*!< Bit position for IPU_CSI0_TST_CTRL_PG_R_VALUE. */
#define BM_IPU_CSI0_TST_CTRL_PG_R_VALUE (0x000000FFU) /*!< Bit mask for IPU_CSI0_TST_CTRL_PG_R_VALUE. */
#define BS_IPU_CSI0_TST_CTRL_PG_R_VALUE (8U) /*!< Bit field size in bits for IPU_CSI0_TST_CTRL_PG_R_VALUE. */

/*! @brief Read current value of the IPU_CSI0_TST_CTRL_PG_R_VALUE field. */
#define BR_IPU_CSI0_TST_CTRL_PG_R_VALUE(x) (HW_IPU_CSI0_TST_CTRL(x).B.PG_R_VALUE)

/*! @brief Format value for bitfield IPU_CSI0_TST_CTRL_PG_R_VALUE. */
#define BF_IPU_CSI0_TST_CTRL_PG_R_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_TST_CTRL_PG_R_VALUE) & BM_IPU_CSI0_TST_CTRL_PG_R_VALUE)

/*! @brief Set the PG_R_VALUE field to a new value. */
#define BW_IPU_CSI0_TST_CTRL_PG_R_VALUE(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, (HW_IPU_CSI0_TST_CTRL_RD(x) & ~BM_IPU_CSI0_TST_CTRL_PG_R_VALUE) | BF_IPU_CSI0_TST_CTRL_PG_R_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_TST_CTRL, field PG_G_VALUE[15:8] (RW)
 *
 * Pattern generator G value. This field selects the G value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI0_TST_CTRL_PG_G_VALUE (8U) /*!< Bit position for IPU_CSI0_TST_CTRL_PG_G_VALUE. */
#define BM_IPU_CSI0_TST_CTRL_PG_G_VALUE (0x0000FF00U) /*!< Bit mask for IPU_CSI0_TST_CTRL_PG_G_VALUE. */
#define BS_IPU_CSI0_TST_CTRL_PG_G_VALUE (8U) /*!< Bit field size in bits for IPU_CSI0_TST_CTRL_PG_G_VALUE. */

/*! @brief Read current value of the IPU_CSI0_TST_CTRL_PG_G_VALUE field. */
#define BR_IPU_CSI0_TST_CTRL_PG_G_VALUE(x) (HW_IPU_CSI0_TST_CTRL(x).B.PG_G_VALUE)

/*! @brief Format value for bitfield IPU_CSI0_TST_CTRL_PG_G_VALUE. */
#define BF_IPU_CSI0_TST_CTRL_PG_G_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_TST_CTRL_PG_G_VALUE) & BM_IPU_CSI0_TST_CTRL_PG_G_VALUE)

/*! @brief Set the PG_G_VALUE field to a new value. */
#define BW_IPU_CSI0_TST_CTRL_PG_G_VALUE(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, (HW_IPU_CSI0_TST_CTRL_RD(x) & ~BM_IPU_CSI0_TST_CTRL_PG_G_VALUE) | BF_IPU_CSI0_TST_CTRL_PG_G_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_TST_CTRL, field PG_B_VALUE[23:16] (RW)
 *
 * Pattern generator B value. This field selects the B value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI0_TST_CTRL_PG_B_VALUE (16U) /*!< Bit position for IPU_CSI0_TST_CTRL_PG_B_VALUE. */
#define BM_IPU_CSI0_TST_CTRL_PG_B_VALUE (0x00FF0000U) /*!< Bit mask for IPU_CSI0_TST_CTRL_PG_B_VALUE. */
#define BS_IPU_CSI0_TST_CTRL_PG_B_VALUE (8U) /*!< Bit field size in bits for IPU_CSI0_TST_CTRL_PG_B_VALUE. */

/*! @brief Read current value of the IPU_CSI0_TST_CTRL_PG_B_VALUE field. */
#define BR_IPU_CSI0_TST_CTRL_PG_B_VALUE(x) (HW_IPU_CSI0_TST_CTRL(x).B.PG_B_VALUE)

/*! @brief Format value for bitfield IPU_CSI0_TST_CTRL_PG_B_VALUE. */
#define BF_IPU_CSI0_TST_CTRL_PG_B_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_TST_CTRL_PG_B_VALUE) & BM_IPU_CSI0_TST_CTRL_PG_B_VALUE)

/*! @brief Set the PG_B_VALUE field to a new value. */
#define BW_IPU_CSI0_TST_CTRL_PG_B_VALUE(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, (HW_IPU_CSI0_TST_CTRL_RD(x) & ~BM_IPU_CSI0_TST_CTRL_PG_B_VALUE) | BF_IPU_CSI0_TST_CTRL_PG_B_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_TST_CTRL, field TEST_GEN_MODE[24] (RW)
 *
 * Test generator mode. This bit activates the signal generation.
 *
 * Values:
 * - 0 - Test signal generator is inactive.
 * - 1 - Test signal generator is active.
 */
/*@{*/
#define BP_IPU_CSI0_TST_CTRL_TEST_GEN_MODE (24U) /*!< Bit position for IPU_CSI0_TST_CTRL_TEST_GEN_MODE. */
#define BM_IPU_CSI0_TST_CTRL_TEST_GEN_MODE (0x01000000U) /*!< Bit mask for IPU_CSI0_TST_CTRL_TEST_GEN_MODE. */
#define BS_IPU_CSI0_TST_CTRL_TEST_GEN_MODE (1U) /*!< Bit field size in bits for IPU_CSI0_TST_CTRL_TEST_GEN_MODE. */

/*! @brief Read current value of the IPU_CSI0_TST_CTRL_TEST_GEN_MODE field. */
#define BR_IPU_CSI0_TST_CTRL_TEST_GEN_MODE(x) (HW_IPU_CSI0_TST_CTRL(x).B.TEST_GEN_MODE)

/*! @brief Format value for bitfield IPU_CSI0_TST_CTRL_TEST_GEN_MODE. */
#define BF_IPU_CSI0_TST_CTRL_TEST_GEN_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_TST_CTRL_TEST_GEN_MODE) & BM_IPU_CSI0_TST_CTRL_TEST_GEN_MODE)

/*! @brief Set the TEST_GEN_MODE field to a new value. */
#define BW_IPU_CSI0_TST_CTRL_TEST_GEN_MODE(x, v) (HW_IPU_CSI0_TST_CTRL_WR(x, (HW_IPU_CSI0_TST_CTRL_RD(x) & ~BM_IPU_CSI0_TST_CTRL_TEST_GEN_MODE) | BF_IPU_CSI0_TST_CTRL_TEST_GEN_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_CCIR_CODE_1 - CSIO CCIR Code Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_CCIR_CODE_1 - CSIO CCIR Code Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_ccir_code_1
{
    uint32_t U;
    struct _hw_ipu_csi0_ccir_code_1_bitfields
    {
        uint32_t CSI0_END_FLD0_BLNK_1ST : 3; /*!< [2:0]  */
        uint32_t CSI0_STRT_FLD0_BLNK_1ST : 3; /*!< [5:3]  */
        uint32_t CSI0_END_FLD0_BLNK_2ND : 3; /*!< [8:6]  */
        uint32_t CSI0_STRT_FLD0_BLNK_2ND : 3; /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI0_END_FLD0_ACTV : 3; /*!< [18:16]  */
        uint32_t CSI0_STRT_FLD0_ACTV : 3; /*!< [21:19]  */
        uint32_t RESERVED1 : 2;        /*!< [23:22]  */
        uint32_t CSI0_CCIR_ERR_DET_EN : 1; /*!< [24]  */
        uint32_t RESERVED2 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi0_ccir_code_1_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_CCIR_CODE_1 register
 */
/*@{*/
#define HW_IPU_CSI0_CCIR_CODE_1_ADDR(x) ((uintptr_t)(x) + 0x30014U)

#define HW_IPU_CSI0_CCIR_CODE_1(x) (*(__IO hw_ipu_csi0_ccir_code_1_t *) HW_IPU_CSI0_CCIR_CODE_1_ADDR(x))
#define HW_IPU_CSI0_CCIR_CODE_1_RD(x) (HW_IPU_CSI0_CCIR_CODE_1(x).U)
#define HW_IPU_CSI0_CCIR_CODE_1_WR(x, v) (HW_IPU_CSI0_CCIR_CODE_1(x).U = (v))
#define HW_IPU_CSI0_CCIR_CODE_1_SET(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, HW_IPU_CSI0_CCIR_CODE_1_RD(x) |  (v)))
#define HW_IPU_CSI0_CCIR_CODE_1_CLR(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~(v)))
#define HW_IPU_CSI0_CCIR_CODE_1_TOG(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, HW_IPU_CSI0_CCIR_CODE_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_CCIR_CODE_1 bitfields
 */

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_END_FLD0_BLNK_1ST[2:0] (RW)
 *
 * End of field 0 first blanking line command (interlaces mode). (In progressive
 * mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST (0U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST (0x00000007U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_END_FLD0_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST)

/*! @brief Set the CSI0_END_FLD0_BLNK_1ST field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_STRT_FLD0_BLNK_1ST[5:3] (RW)
 *
 * Start of field 0 first blanking line command (interlaces mode). (In
 * progressive mode this field indicates start of blanking line command).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST (3U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST (0x00000038U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_STRT_FLD0_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST)

/*! @brief Set the CSI0_STRT_FLD0_BLNK_1ST field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_END_FLD0_BLNK_2ND[8:6] (RW)
 *
 * End of field 0 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND (6U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND (0x000001C0U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_END_FLD0_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND)

/*! @brief Set the CSI0_END_FLD0_BLNK_2ND field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_STRT_FLD0_BLNK_2ND[11:9] (RW)
 *
 * Start of field 0 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND (9U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND (0x00000E00U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_STRT_FLD0_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND)

/*! @brief Set the CSI0_STRT_FLD0_BLNK_2ND field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_END_FLD0_ACTV[18:16] (RW)
 *
 * End of field 0 active line command (interlaces mode). (In progressive mode,
 * end of active line command mode).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV (16U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV (0x00070000U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_END_FLD0_ACTV)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV)

/*! @brief Set the CSI0_END_FLD0_ACTV field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_END_FLD0_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_STRT_FLD0_ACTV[21:19] (RW)
 *
 * Start of field 0 active line command (interlaces mode). (In progressive mode,
 * start of active line command mode).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV (19U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV (0x00380000U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_STRT_FLD0_ACTV)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV)

/*! @brief Set the CSI0_STRT_FLD0_ACTV field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_STRT_FLD0_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_1, field CSI0_CCIR_ERR_DET_EN[24] (RW)
 *
 * Enable error detection and correction for CCIR interlaced mode with
 * protection bit.
 *
 * Values:
 * - 0 - Error detection and correction is disabled.
 * - 1 - Error detection and correction is enabled.
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN (24U) /*!< Bit position for IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN. */
#define BM_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN (0x01000000U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN. */
#define BS_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN (1U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN field. */
#define BR_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN(x) (HW_IPU_CSI0_CCIR_CODE_1(x).B.CSI0_CCIR_ERR_DET_EN)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN. */
#define BF_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN) & BM_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN)

/*! @brief Set the CSI0_CCIR_ERR_DET_EN field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN(x, v) (HW_IPU_CSI0_CCIR_CODE_1_WR(x, (HW_IPU_CSI0_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN) | BF_IPU_CSI0_CCIR_CODE_1_CSI0_CCIR_ERR_DET_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_CCIR_CODE_2 - CSIO CCIR Code Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_CCIR_CODE_2 - CSIO CCIR Code Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_ccir_code_2
{
    uint32_t U;
    struct _hw_ipu_csi0_ccir_code_2_bitfields
    {
        uint32_t CSI0_END_FLD1_BLNK_1ST : 3; /*!< [2:0]  */
        uint32_t CSI0_STRT_FLD1_BLNK_1ST : 3; /*!< [5:3]  */
        uint32_t CSI0_END_FLD1_BLNK_2ND : 3; /*!< [8:6]  */
        uint32_t CSI0_STRT_FLD1_BLNK_2ND : 3; /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI0_END_FLD1_ACTV : 3; /*!< [18:16]  */
        uint32_t CSI0_STRT_FLD1_ACTV : 3; /*!< [21:19]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_ipu_csi0_ccir_code_2_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_CCIR_CODE_2 register
 */
/*@{*/
#define HW_IPU_CSI0_CCIR_CODE_2_ADDR(x) ((uintptr_t)(x) + 0x30018U)

#define HW_IPU_CSI0_CCIR_CODE_2(x) (*(__IO hw_ipu_csi0_ccir_code_2_t *) HW_IPU_CSI0_CCIR_CODE_2_ADDR(x))
#define HW_IPU_CSI0_CCIR_CODE_2_RD(x) (HW_IPU_CSI0_CCIR_CODE_2(x).U)
#define HW_IPU_CSI0_CCIR_CODE_2_WR(x, v) (HW_IPU_CSI0_CCIR_CODE_2(x).U = (v))
#define HW_IPU_CSI0_CCIR_CODE_2_SET(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, HW_IPU_CSI0_CCIR_CODE_2_RD(x) |  (v)))
#define HW_IPU_CSI0_CCIR_CODE_2_CLR(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~(v)))
#define HW_IPU_CSI0_CCIR_CODE_2_TOG(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, HW_IPU_CSI0_CCIR_CODE_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_CCIR_CODE_2 bitfields
 */

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_END_FLD1_BLNK_1ST[2:0] (RW)
 *
 * End of field 1 first blanking line command (interlaces mode). (In progressive
 * mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST (0U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST (0x00000007U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_END_FLD1_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST)

/*! @brief Set the CSI0_END_FLD1_BLNK_1ST field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_STRT_FLD1_BLNK_1ST[5:3] (RW)
 *
 * Start of field 1 first blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST (3U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST (0x00000038U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_STRT_FLD1_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST)

/*! @brief Set the CSI0_STRT_FLD1_BLNK_1ST field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_END_FLD1_BLNK_2ND[8:6] (RW)
 *
 * End of field 1 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND (6U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND (0x000001C0U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_END_FLD1_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND)

/*! @brief Set the CSI0_END_FLD1_BLNK_2ND field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_STRT_FLD1_BLNK_2ND[11:9] (RW)
 *
 * Start of field 1 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND (9U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND (0x00000E00U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_STRT_FLD1_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND)

/*! @brief Set the CSI0_STRT_FLD1_BLNK_2ND field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_END_FLD1_ACTV[18:16] (RW)
 *
 * End of field 1 active line command (interlaces mode). (In progressive mode
 * this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV (16U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV (0x00070000U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_END_FLD1_ACTV)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV)

/*! @brief Set the CSI0_END_FLD1_ACTV field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_END_FLD1_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CCIR_CODE_2, field CSI0_STRT_FLD1_ACTV[21:19] (RW)
 *
 * Start of field 1 active line command (interlaces mode). (In progressive mode
 * this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV (19U) /*!< Bit position for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV. */
#define BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV (0x00380000U) /*!< Bit mask for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV. */
#define BS_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV (3U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV field. */
#define BR_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV(x) (HW_IPU_CSI0_CCIR_CODE_2(x).B.CSI0_STRT_FLD1_ACTV)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV. */
#define BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV) & BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV)

/*! @brief Set the CSI0_STRT_FLD1_ACTV field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV(x, v) (HW_IPU_CSI0_CCIR_CODE_2_WR(x, (HW_IPU_CSI0_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV) | BF_IPU_CSI0_CCIR_CODE_2_CSI0_STRT_FLD1_ACTV(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_CCIR_CODE_3 - CSIO CCIR Code Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_CCIR_CODE_3 - CSIO CCIR Code Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi0_ccir_code_3
{
    uint32_t U;
    struct _hw_ipu_csi0_ccir_code_3_bitfields
    {
        uint32_t CSI0_CCIR_PRECOM : 30; /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_csi0_ccir_code_3_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_CCIR_CODE_3 register
 */
/*@{*/
#define HW_IPU_CSI0_CCIR_CODE_3_ADDR(x) ((uintptr_t)(x) + 0x3001CU)

#define HW_IPU_CSI0_CCIR_CODE_3(x) (*(__IO hw_ipu_csi0_ccir_code_3_t *) HW_IPU_CSI0_CCIR_CODE_3_ADDR(x))
#define HW_IPU_CSI0_CCIR_CODE_3_RD(x) (HW_IPU_CSI0_CCIR_CODE_3(x).U)
#define HW_IPU_CSI0_CCIR_CODE_3_WR(x, v) (HW_IPU_CSI0_CCIR_CODE_3(x).U = (v))
#define HW_IPU_CSI0_CCIR_CODE_3_SET(x, v) (HW_IPU_CSI0_CCIR_CODE_3_WR(x, HW_IPU_CSI0_CCIR_CODE_3_RD(x) |  (v)))
#define HW_IPU_CSI0_CCIR_CODE_3_CLR(x, v) (HW_IPU_CSI0_CCIR_CODE_3_WR(x, HW_IPU_CSI0_CCIR_CODE_3_RD(x) & ~(v)))
#define HW_IPU_CSI0_CCIR_CODE_3_TOG(x, v) (HW_IPU_CSI0_CCIR_CODE_3_WR(x, HW_IPU_CSI0_CCIR_CODE_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_CCIR_CODE_3 bitfields
 */

/*!
 * @name Register IPU_CSI0_CCIR_CODE_3, field CSI0_CCIR_PRECOM[29:0] (RW)
 *
 * CCIR pre command. This field defines the sequence which comes before the CCIR
 * command. For BT.656 the code should be written to bits [23:0] while bits
 * [29:24] are ignored (3X8bit) For BT.1120 the code should be written to bits [29:0]
 * (3X10bit)
 */
/*@{*/
#define BP_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM (0U) /*!< Bit position for IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM. */
#define BM_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM (0x3FFFFFFFU) /*!< Bit mask for IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM. */
#define BS_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM (30U) /*!< Bit field size in bits for IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM. */

/*! @brief Read current value of the IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM field. */
#define BR_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM(x) (HW_IPU_CSI0_CCIR_CODE_3(x).B.CSI0_CCIR_PRECOM)

/*! @brief Format value for bitfield IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM. */
#define BF_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM) & BM_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM)

/*! @brief Set the CSI0_CCIR_PRECOM field to a new value. */
#define BW_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM(x, v) (HW_IPU_CSI0_CCIR_CODE_3_WR(x, (HW_IPU_CSI0_CCIR_CODE_3_RD(x) & ~BM_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM) | BF_IPU_CSI0_CCIR_CODE_3_CSI0_CCIR_PRECOM(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_DI - CSI0 Data Identifier Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_DI - CSI0 Data Identifier Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 */
typedef union _hw_ipu_csi0_di
{
    uint32_t U;
    struct _hw_ipu_csi0_di_bitfields
    {
        uint32_t CSI0_MIPI_DI0 : 8;    /*!< [7:0]  */
        uint32_t CSI0_MIPI_DI1 : 8;    /*!< [15:8]  */
        uint32_t CSI0_MIPI_DI2 : 8;    /*!< [23:16]  */
        uint32_t CSI0_MIPI_DI3 : 8;    /*!< [31:24]  */
    } B;
} hw_ipu_csi0_di_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_DI register
 */
/*@{*/
#define HW_IPU_CSI0_DI_ADDR(x)   ((uintptr_t)(x) + 0x30020U)

#define HW_IPU_CSI0_DI(x)        (*(__IO hw_ipu_csi0_di_t *) HW_IPU_CSI0_DI_ADDR(x))
#define HW_IPU_CSI0_DI_RD(x)     (HW_IPU_CSI0_DI(x).U)
#define HW_IPU_CSI0_DI_WR(x, v)  (HW_IPU_CSI0_DI(x).U = (v))
#define HW_IPU_CSI0_DI_SET(x, v) (HW_IPU_CSI0_DI_WR(x, HW_IPU_CSI0_DI_RD(x) |  (v)))
#define HW_IPU_CSI0_DI_CLR(x, v) (HW_IPU_CSI0_DI_WR(x, HW_IPU_CSI0_DI_RD(x) & ~(v)))
#define HW_IPU_CSI0_DI_TOG(x, v) (HW_IPU_CSI0_DI_WR(x, HW_IPU_CSI0_DI_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_DI bitfields
 */

/*!
 * @name Register IPU_CSI0_DI, field CSI0_MIPI_DI0[7:0] (RW)
 *
 * CSI0_MIPI_DI0 This field holds the Data Identifier #0 handled by the CSI;
 * This is the main stream.
 */
/*@{*/
#define BP_IPU_CSI0_DI_CSI0_MIPI_DI0 (0U)  /*!< Bit position for IPU_CSI0_DI_CSI0_MIPI_DI0. */
#define BM_IPU_CSI0_DI_CSI0_MIPI_DI0 (0x000000FFU) /*!< Bit mask for IPU_CSI0_DI_CSI0_MIPI_DI0. */
#define BS_IPU_CSI0_DI_CSI0_MIPI_DI0 (8U)  /*!< Bit field size in bits for IPU_CSI0_DI_CSI0_MIPI_DI0. */

/*! @brief Read current value of the IPU_CSI0_DI_CSI0_MIPI_DI0 field. */
#define BR_IPU_CSI0_DI_CSI0_MIPI_DI0(x) (HW_IPU_CSI0_DI(x).B.CSI0_MIPI_DI0)

/*! @brief Format value for bitfield IPU_CSI0_DI_CSI0_MIPI_DI0. */
#define BF_IPU_CSI0_DI_CSI0_MIPI_DI0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_DI_CSI0_MIPI_DI0) & BM_IPU_CSI0_DI_CSI0_MIPI_DI0)

/*! @brief Set the CSI0_MIPI_DI0 field to a new value. */
#define BW_IPU_CSI0_DI_CSI0_MIPI_DI0(x, v) (HW_IPU_CSI0_DI_WR(x, (HW_IPU_CSI0_DI_RD(x) & ~BM_IPU_CSI0_DI_CSI0_MIPI_DI0) | BF_IPU_CSI0_DI_CSI0_MIPI_DI0(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_DI, field CSI0_MIPI_DI1[15:8] (RW)
 *
 * CSI0_MIPI_DI1 This field holds the Data Identifier #1 handled by the CSI
 */
/*@{*/
#define BP_IPU_CSI0_DI_CSI0_MIPI_DI1 (8U)  /*!< Bit position for IPU_CSI0_DI_CSI0_MIPI_DI1. */
#define BM_IPU_CSI0_DI_CSI0_MIPI_DI1 (0x0000FF00U) /*!< Bit mask for IPU_CSI0_DI_CSI0_MIPI_DI1. */
#define BS_IPU_CSI0_DI_CSI0_MIPI_DI1 (8U)  /*!< Bit field size in bits for IPU_CSI0_DI_CSI0_MIPI_DI1. */

/*! @brief Read current value of the IPU_CSI0_DI_CSI0_MIPI_DI1 field. */
#define BR_IPU_CSI0_DI_CSI0_MIPI_DI1(x) (HW_IPU_CSI0_DI(x).B.CSI0_MIPI_DI1)

/*! @brief Format value for bitfield IPU_CSI0_DI_CSI0_MIPI_DI1. */
#define BF_IPU_CSI0_DI_CSI0_MIPI_DI1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_DI_CSI0_MIPI_DI1) & BM_IPU_CSI0_DI_CSI0_MIPI_DI1)

/*! @brief Set the CSI0_MIPI_DI1 field to a new value. */
#define BW_IPU_CSI0_DI_CSI0_MIPI_DI1(x, v) (HW_IPU_CSI0_DI_WR(x, (HW_IPU_CSI0_DI_RD(x) & ~BM_IPU_CSI0_DI_CSI0_MIPI_DI1) | BF_IPU_CSI0_DI_CSI0_MIPI_DI1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_DI, field CSI0_MIPI_DI2[23:16] (RW)
 *
 * CSI0_MIPI_DI2 This field holds the Data Identifier #2 handled by the CSI.
 */
/*@{*/
#define BP_IPU_CSI0_DI_CSI0_MIPI_DI2 (16U) /*!< Bit position for IPU_CSI0_DI_CSI0_MIPI_DI2. */
#define BM_IPU_CSI0_DI_CSI0_MIPI_DI2 (0x00FF0000U) /*!< Bit mask for IPU_CSI0_DI_CSI0_MIPI_DI2. */
#define BS_IPU_CSI0_DI_CSI0_MIPI_DI2 (8U)  /*!< Bit field size in bits for IPU_CSI0_DI_CSI0_MIPI_DI2. */

/*! @brief Read current value of the IPU_CSI0_DI_CSI0_MIPI_DI2 field. */
#define BR_IPU_CSI0_DI_CSI0_MIPI_DI2(x) (HW_IPU_CSI0_DI(x).B.CSI0_MIPI_DI2)

/*! @brief Format value for bitfield IPU_CSI0_DI_CSI0_MIPI_DI2. */
#define BF_IPU_CSI0_DI_CSI0_MIPI_DI2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_DI_CSI0_MIPI_DI2) & BM_IPU_CSI0_DI_CSI0_MIPI_DI2)

/*! @brief Set the CSI0_MIPI_DI2 field to a new value. */
#define BW_IPU_CSI0_DI_CSI0_MIPI_DI2(x, v) (HW_IPU_CSI0_DI_WR(x, (HW_IPU_CSI0_DI_RD(x) & ~BM_IPU_CSI0_DI_CSI0_MIPI_DI2) | BF_IPU_CSI0_DI_CSI0_MIPI_DI2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_DI, field CSI0_MIPI_DI3[31:24] (RW)
 *
 * CSI0_MIPI_DI3 This field holds the Data Identifier #3 handled by the CSI.
 */
/*@{*/
#define BP_IPU_CSI0_DI_CSI0_MIPI_DI3 (24U) /*!< Bit position for IPU_CSI0_DI_CSI0_MIPI_DI3. */
#define BM_IPU_CSI0_DI_CSI0_MIPI_DI3 (0xFF000000U) /*!< Bit mask for IPU_CSI0_DI_CSI0_MIPI_DI3. */
#define BS_IPU_CSI0_DI_CSI0_MIPI_DI3 (8U)  /*!< Bit field size in bits for IPU_CSI0_DI_CSI0_MIPI_DI3. */

/*! @brief Read current value of the IPU_CSI0_DI_CSI0_MIPI_DI3 field. */
#define BR_IPU_CSI0_DI_CSI0_MIPI_DI3(x) (HW_IPU_CSI0_DI(x).B.CSI0_MIPI_DI3)

/*! @brief Format value for bitfield IPU_CSI0_DI_CSI0_MIPI_DI3. */
#define BF_IPU_CSI0_DI_CSI0_MIPI_DI3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_DI_CSI0_MIPI_DI3) & BM_IPU_CSI0_DI_CSI0_MIPI_DI3)

/*! @brief Set the CSI0_MIPI_DI3 field to a new value. */
#define BW_IPU_CSI0_DI_CSI0_MIPI_DI3(x, v) (HW_IPU_CSI0_DI_WR(x, (HW_IPU_CSI0_DI_RD(x) & ~BM_IPU_CSI0_DI_CSI0_MIPI_DI3) | BF_IPU_CSI0_DI_CSI0_MIPI_DI3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_SKIP - CSI0 SKIP Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_SKIP - CSI0 SKIP Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls the frame skipping supported between CSI0 and the SMFC.
 */
typedef union _hw_ipu_csi0_skip
{
    uint32_t U;
    struct _hw_ipu_csi0_skip_bitfields
    {
        uint32_t CSI0_MAX_RATIO_SKIP_SMFC : 3; /*!< [2:0]  */
        uint32_t CSI0_SKIP_SMFC : 5;   /*!< [7:3]  */
        uint32_t CSI0_ID_2_SKIP : 2;   /*!< [9:8]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_csi0_skip_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_SKIP register
 */
/*@{*/
#define HW_IPU_CSI0_SKIP_ADDR(x) ((uintptr_t)(x) + 0x30024U)

#define HW_IPU_CSI0_SKIP(x)      (*(__IO hw_ipu_csi0_skip_t *) HW_IPU_CSI0_SKIP_ADDR(x))
#define HW_IPU_CSI0_SKIP_RD(x)   (HW_IPU_CSI0_SKIP(x).U)
#define HW_IPU_CSI0_SKIP_WR(x, v) (HW_IPU_CSI0_SKIP(x).U = (v))
#define HW_IPU_CSI0_SKIP_SET(x, v) (HW_IPU_CSI0_SKIP_WR(x, HW_IPU_CSI0_SKIP_RD(x) |  (v)))
#define HW_IPU_CSI0_SKIP_CLR(x, v) (HW_IPU_CSI0_SKIP_WR(x, HW_IPU_CSI0_SKIP_RD(x) & ~(v)))
#define HW_IPU_CSI0_SKIP_TOG(x, v) (HW_IPU_CSI0_SKIP_WR(x, HW_IPU_CSI0_SKIP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_SKIP bitfields
 */

/*!
 * @name Register IPU_CSI0_SKIP, field CSI0_MAX_RATIO_SKIP_SMFC[2:0] (RW)
 *
 * CSI0 Maximum Ratio Skip for SMFC These bits define the number of frames in a
 * skipping set. The skipping number is equal to CSI0_MAX_RATIO_SKIP_SMFC+1; The
 * maximum value of this bits is 5. When set to 0 the skipping is disabled.
 */
/*@{*/
#define BP_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC (0U) /*!< Bit position for IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC. */
#define BM_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC (0x00000007U) /*!< Bit mask for IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC. */
#define BS_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC (3U) /*!< Bit field size in bits for IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC. */

/*! @brief Read current value of the IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC field. */
#define BR_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC(x) (HW_IPU_CSI0_SKIP(x).B.CSI0_MAX_RATIO_SKIP_SMFC)

/*! @brief Format value for bitfield IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC. */
#define BF_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC) & BM_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC)

/*! @brief Set the CSI0_MAX_RATIO_SKIP_SMFC field to a new value. */
#define BW_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC(x, v) (HW_IPU_CSI0_SKIP_WR(x, (HW_IPU_CSI0_SKIP_RD(x) & ~BM_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC) | BF_IPU_CSI0_SKIP_CSI0_MAX_RATIO_SKIP_SMFC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SKIP, field CSI0_SKIP_SMFC[7:3] (RW)
 *
 * CSI0 SKIP SMFC These 5 bits define the skipping pattern of the frames send to
 * the SMFC. Skipping is done for a set of frames. The number of frames in a set
 * is defined at CSI0_MAX_RATIO_SKIP_SMFC. when CSI0_MAX_RATIO_SKIP_SMFC = 1 =>
 * CSI0_SKIP_SMFC[0] is used; other bits are ignored when
 * CSI0_MAX_RATIO_SKIP_SMFC = 2 => CSI0_SKIP_SMFC[1:0] are used; other bits are ignored when
 * CSI0_MAX_RATIO_SKIP_SMFC = 3 => CSI0_SKIP_SMFC[2:0] are used; other bits are ignored when
 * CSI0_MAX_RATIO_SKIP_SMFC = 4 => CSI0_SKIP_SMFC[3:0] are used; other bits are
 * ignored when CSI0_MAX_RATIO_SKIP_SMFC = 5 => CSI0_SKIP_SMFC[4:0] are used;
 * Setting bit #n of CSI0_SKIP_SMFC means that the #n frame in the set is skipped.
 * For example: if CSI0_MAX_RATIO_SKIP_SMFC = 4 and CSI0_SKIP_SMFC = 11010 Frames
 * #0 & Frame #2 will not be skipped as bit0 and bit2 are cleared Frames #1 &
 * Frame #3 will be skipped as bit1 and bit3 are set bit #4 is ignored as
 * CSI0_MAX_RATIO_SKIP_SMFC is set to 4
 */
/*@{*/
#define BP_IPU_CSI0_SKIP_CSI0_SKIP_SMFC (3U) /*!< Bit position for IPU_CSI0_SKIP_CSI0_SKIP_SMFC. */
#define BM_IPU_CSI0_SKIP_CSI0_SKIP_SMFC (0x000000F8U) /*!< Bit mask for IPU_CSI0_SKIP_CSI0_SKIP_SMFC. */
#define BS_IPU_CSI0_SKIP_CSI0_SKIP_SMFC (5U) /*!< Bit field size in bits for IPU_CSI0_SKIP_CSI0_SKIP_SMFC. */

/*! @brief Read current value of the IPU_CSI0_SKIP_CSI0_SKIP_SMFC field. */
#define BR_IPU_CSI0_SKIP_CSI0_SKIP_SMFC(x) (HW_IPU_CSI0_SKIP(x).B.CSI0_SKIP_SMFC)

/*! @brief Format value for bitfield IPU_CSI0_SKIP_CSI0_SKIP_SMFC. */
#define BF_IPU_CSI0_SKIP_CSI0_SKIP_SMFC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SKIP_CSI0_SKIP_SMFC) & BM_IPU_CSI0_SKIP_CSI0_SKIP_SMFC)

/*! @brief Set the CSI0_SKIP_SMFC field to a new value. */
#define BW_IPU_CSI0_SKIP_CSI0_SKIP_SMFC(x, v) (HW_IPU_CSI0_SKIP_WR(x, (HW_IPU_CSI0_SKIP_RD(x) & ~BM_IPU_CSI0_SKIP_CSI0_SKIP_SMFC) | BF_IPU_CSI0_SKIP_CSI0_SKIP_SMFC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_SKIP, field CSI0_ID_2_SKIP[9:8] (RW)
 *
 * CSI0 to SMFC Skipping ID. Data from the CSI0 to the SMFC has an ID associated
 * with it. The ID is received from the MIPI interface. The skipping mechanism
 * between the CSI0 and the SMFC can be used for only one ID. There is no skipping
 * for data coming with ID different from the ID programed in this bits
 *
 * Values:
 * - 00 - - Skipping mechanism is activated on frames with ID equal to 00
 * - 01 - - Skipping mechanism is activated on frames with ID equal to 01
 * - 10 - - Skipping mechanism is activated on frames with ID equal to 10
 * - 11 - - Skipping mechanism is activated on frames with ID equal to 11
 */
/*@{*/
#define BP_IPU_CSI0_SKIP_CSI0_ID_2_SKIP (8U) /*!< Bit position for IPU_CSI0_SKIP_CSI0_ID_2_SKIP. */
#define BM_IPU_CSI0_SKIP_CSI0_ID_2_SKIP (0x00000300U) /*!< Bit mask for IPU_CSI0_SKIP_CSI0_ID_2_SKIP. */
#define BS_IPU_CSI0_SKIP_CSI0_ID_2_SKIP (2U) /*!< Bit field size in bits for IPU_CSI0_SKIP_CSI0_ID_2_SKIP. */

/*! @brief Read current value of the IPU_CSI0_SKIP_CSI0_ID_2_SKIP field. */
#define BR_IPU_CSI0_SKIP_CSI0_ID_2_SKIP(x) (HW_IPU_CSI0_SKIP(x).B.CSI0_ID_2_SKIP)

/*! @brief Format value for bitfield IPU_CSI0_SKIP_CSI0_ID_2_SKIP. */
#define BF_IPU_CSI0_SKIP_CSI0_ID_2_SKIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_SKIP_CSI0_ID_2_SKIP) & BM_IPU_CSI0_SKIP_CSI0_ID_2_SKIP)

/*! @brief Set the CSI0_ID_2_SKIP field to a new value. */
#define BW_IPU_CSI0_SKIP_CSI0_ID_2_SKIP(x, v) (HW_IPU_CSI0_SKIP_WR(x, (HW_IPU_CSI0_SKIP_RD(x) & ~BM_IPU_CSI0_SKIP_CSI0_ID_2_SKIP) | BF_IPU_CSI0_SKIP_CSI0_ID_2_SKIP(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_CTRL - CSI0 Compander Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_CTRL - CSI0 Compander Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csio_cpd_ctrl
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_ctrl_bitfields
    {
        uint32_t CSI0_GREEN_P_BEGIN : 1; /*!< [0]  */
        uint32_t CSI0_RED_ROW_BEGIN : 1; /*!< [1]  */
        uint32_t CSI0_CPD : 3;         /*!< [4:2]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_ipu_csio_cpd_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_CTRL register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_CTRL_ADDR(x) ((uintptr_t)(x) + 0x30028U)

#define HW_IPU_CSIO_CPD_CTRL(x)  (*(__IO hw_ipu_csio_cpd_ctrl_t *) HW_IPU_CSIO_CPD_CTRL_ADDR(x))
#define HW_IPU_CSIO_CPD_CTRL_RD(x) (HW_IPU_CSIO_CPD_CTRL(x).U)
#define HW_IPU_CSIO_CPD_CTRL_WR(x, v) (HW_IPU_CSIO_CPD_CTRL(x).U = (v))
#define HW_IPU_CSIO_CPD_CTRL_SET(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, HW_IPU_CSIO_CPD_CTRL_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_CTRL_CLR(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, HW_IPU_CSIO_CPD_CTRL_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_CTRL_TOG(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, HW_IPU_CSIO_CPD_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_CTRL bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_CTRL, field CSI0_GREEN_P_BEGIN[0] (RW)
 *
 * Color of first component in the frame. Reserved
 *
 * Values:
 * - 0 - First component in the frame is blue or red, depending from RED_ROW bit.
 * - 1 - First component in the frame is green
 */
/*@{*/
#define BP_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN (0U) /*!< Bit position for IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN. */
#define BM_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN (0x00000001U) /*!< Bit mask for IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN. */
#define BS_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN (1U) /*!< Bit field size in bits for IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN. */

/*! @brief Read current value of the IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN field. */
#define BR_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN(x) (HW_IPU_CSIO_CPD_CTRL(x).B.CSI0_GREEN_P_BEGIN)

/*! @brief Format value for bitfield IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN. */
#define BF_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN) & BM_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN)

/*! @brief Set the CSI0_GREEN_P_BEGIN field to a new value. */
#define BW_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, (HW_IPU_CSIO_CPD_CTRL_RD(x) & ~BM_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN) | BF_IPU_CSIO_CPD_CTRL_CSI0_GREEN_P_BEGIN(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_CTRL, field CSI0_RED_ROW_BEGIN[1] (RW)
 *
 * Color of first row in the frame. Reserved
 *
 * Values:
 * - 0 - First row in the frame is GBGB.
 * - 1 - First row in the frame is GRGR.
 */
/*@{*/
#define BP_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN (1U) /*!< Bit position for IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN. */
#define BM_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN (0x00000002U) /*!< Bit mask for IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN. */
#define BS_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN (1U) /*!< Bit field size in bits for IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN. */

/*! @brief Read current value of the IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN field. */
#define BR_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN(x) (HW_IPU_CSIO_CPD_CTRL(x).B.CSI0_RED_ROW_BEGIN)

/*! @brief Format value for bitfield IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN. */
#define BF_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN) & BM_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN)

/*! @brief Set the CSI0_RED_ROW_BEGIN field to a new value. */
#define BW_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, (HW_IPU_CSIO_CPD_CTRL_RD(x) & ~BM_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN) | BF_IPU_CSIO_CPD_CTRL_CSI0_RED_ROW_BEGIN(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_CTRL, field CSI0_CPD[4:2] (RW)
 *
 * CSI0_CPD These bits enable the compander in the path to different
 * destination. CSI0_CPD[0] - CSI0_CPD[1] - Enable for the compander for data sent to the IC
 * CSI0_CPD[2] - Enable for the compander for data sent to the IDMAC via SMFC If
 * all the 3 bits are zero the compander is disabled Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_CTRL_CSI0_CPD (2U) /*!< Bit position for IPU_CSIO_CPD_CTRL_CSI0_CPD. */
#define BM_IPU_CSIO_CPD_CTRL_CSI0_CPD (0x0000001CU) /*!< Bit mask for IPU_CSIO_CPD_CTRL_CSI0_CPD. */
#define BS_IPU_CSIO_CPD_CTRL_CSI0_CPD (3U) /*!< Bit field size in bits for IPU_CSIO_CPD_CTRL_CSI0_CPD. */

/*! @brief Read current value of the IPU_CSIO_CPD_CTRL_CSI0_CPD field. */
#define BR_IPU_CSIO_CPD_CTRL_CSI0_CPD(x) (HW_IPU_CSIO_CPD_CTRL(x).B.CSI0_CPD)

/*! @brief Format value for bitfield IPU_CSIO_CPD_CTRL_CSI0_CPD. */
#define BF_IPU_CSIO_CPD_CTRL_CSI0_CPD(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_CTRL_CSI0_CPD) & BM_IPU_CSIO_CPD_CTRL_CSI0_CPD)

/*! @brief Set the CSI0_CPD field to a new value. */
#define BW_IPU_CSIO_CPD_CTRL_CSI0_CPD(x, v) (HW_IPU_CSIO_CPD_CTRL_WR(x, (HW_IPU_CSIO_CPD_CTRL_RD(x) & ~BM_IPU_CSIO_CPD_CTRL_CSI0_CPD) | BF_IPU_CSIO_CPD_CTRL_CSI0_CPD(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_RC_i - CSI0 Red Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_RC_i - CSI0 Red Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANT <i> parameters used for companding of red
 * component.
 */
typedef union _hw_ipu_csio_cpd_rc_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_rc_i_bitfields
    {
        uint32_t CSI0_CPD_RC_2i : 9;   /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI0_CPD_RC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csio_cpd_rc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_RC_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_RC_i_ADDR(x) ((uintptr_t)(x) + 0x3002CU)

#define HW_IPU_CSIO_CPD_RC_i(x)  (*(__IO hw_ipu_csio_cpd_rc_i_t *) HW_IPU_CSIO_CPD_RC_i_ADDR(x))
#define HW_IPU_CSIO_CPD_RC_i_RD(x) (HW_IPU_CSIO_CPD_RC_i(x).U)
#define HW_IPU_CSIO_CPD_RC_i_WR(x, v) (HW_IPU_CSIO_CPD_RC_i(x).U = (v))
#define HW_IPU_CSIO_CPD_RC_i_SET(x, v) (HW_IPU_CSIO_CPD_RC_i_WR(x, HW_IPU_CSIO_CPD_RC_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_RC_i_CLR(x, v) (HW_IPU_CSIO_CPD_RC_i_WR(x, HW_IPU_CSIO_CPD_RC_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_RC_i_TOG(x, v) (HW_IPU_CSIO_CPD_RC_i_WR(x, HW_IPU_CSIO_CPD_RC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_RC_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_RC_i, field CSI0_CPD_RC_2i[8:0] (RW)
 *
 * CONSTANT <2*i> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i (0U) /*!< Bit position for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i. */
#define BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i (0x000001FFU) /*!< Bit mask for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i. */
#define BS_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i. */

/*! @brief Read current value of the IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i field. */
#define BR_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i(x) (HW_IPU_CSIO_CPD_RC_i(x).B.CSI0_CPD_RC_2i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i. */
#define BF_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i) & BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i)

/*! @brief Set the CSI0_CPD_RC_2i field to a new value. */
#define BW_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i(x, v) (HW_IPU_CSIO_CPD_RC_i_WR(x, (HW_IPU_CSIO_CPD_RC_i_RD(x) & ~BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i) | BF_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_RC_i, field CSI0_CPD_RC_2i_1[24:16] (RW)
 *
 * CONSTANT <2*i+1> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1 (16U) /*!< Bit position for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1. */
#define BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1. */
#define BS_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1 field. */
#define BR_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1(x) (HW_IPU_CSIO_CPD_RC_i(x).B.CSI0_CPD_RC_2i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1. */
#define BF_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1) & BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1)

/*! @brief Set the CSI0_CPD_RC_2i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1(x, v) (HW_IPU_CSIO_CPD_RC_i_WR(x, (HW_IPU_CSIO_CPD_RC_i_RD(x) & ~BM_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1) | BF_IPU_CSIO_CPD_RC_i_CSI0_CPD_RC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_RS_i - CSI0 Red Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_RS_i - CSI0 Red Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPE <i> parameters used for companding of red
 * component.
 */
typedef union _hw_ipu_csio_cpd_rs_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_rs_i_bitfields
    {
        uint32_t CSI0_CPD_RS_4i : 8;   /*!< [7:0]  */
        uint32_t CSI0_CPD_RS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI0_CPD_RS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI0_CPD_RS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csio_cpd_rs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_RS_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_RS_i_ADDR(x) ((uintptr_t)(x) + 0x3004CU)

#define HW_IPU_CSIO_CPD_RS_i(x)  (*(__IO hw_ipu_csio_cpd_rs_i_t *) HW_IPU_CSIO_CPD_RS_i_ADDR(x))
#define HW_IPU_CSIO_CPD_RS_i_RD(x) (HW_IPU_CSIO_CPD_RS_i(x).U)
#define HW_IPU_CSIO_CPD_RS_i_WR(x, v) (HW_IPU_CSIO_CPD_RS_i(x).U = (v))
#define HW_IPU_CSIO_CPD_RS_i_SET(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, HW_IPU_CSIO_CPD_RS_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_RS_i_CLR(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, HW_IPU_CSIO_CPD_RS_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_RS_i_TOG(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, HW_IPU_CSIO_CPD_RS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_RS_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_RS_i, field CSI0_CPD_RS_4i[7:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i (0U) /*!< Bit position for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i. */
#define BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i (0x000000FFU) /*!< Bit mask for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i. */
#define BS_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i. */

/*! @brief Read current value of the IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i field. */
#define BR_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i(x) (HW_IPU_CSIO_CPD_RS_i(x).B.CSI0_CPD_RS_4i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i. */
#define BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i) & BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i)

/*! @brief Set the CSI0_CPD_RS_4i field to a new value. */
#define BW_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, (HW_IPU_CSIO_CPD_RS_i_RD(x) & ~BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i) | BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_RS_i, field CSI0_CPD_RS_4i_1[15:8] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1 (8U) /*!< Bit position for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1. */
#define BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1. */
#define BS_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1 field. */
#define BR_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1(x) (HW_IPU_CSIO_CPD_RS_i(x).B.CSI0_CPD_RS_4i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1. */
#define BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1) & BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1)

/*! @brief Set the CSI0_CPD_RS_4i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, (HW_IPU_CSIO_CPD_RS_i_RD(x) & ~BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1) | BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_RS_i, field CSI0_CPD_RS_4i_2[23:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2 (16U) /*!< Bit position for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2. */
#define BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2. */
#define BS_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2. */

/*! @brief Read current value of the IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2 field. */
#define BR_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2(x) (HW_IPU_CSIO_CPD_RS_i(x).B.CSI0_CPD_RS_4i_2)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2. */
#define BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2) & BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2)

/*! @brief Set the CSI0_CPD_RS_4i_2 field to a new value. */
#define BW_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, (HW_IPU_CSIO_CPD_RS_i_RD(x) & ~BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2) | BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_RS_i, field CSI0_CPD_RS_4i_3[31:24] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3 (24U) /*!< Bit position for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3. */
#define BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3. */
#define BS_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3. */

/*! @brief Read current value of the IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3 field. */
#define BR_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3(x) (HW_IPU_CSIO_CPD_RS_i(x).B.CSI0_CPD_RS_4i_3)

/*! @brief Format value for bitfield IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3. */
#define BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3) & BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3)

/*! @brief Set the CSI0_CPD_RS_4i_3 field to a new value. */
#define BW_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3(x, v) (HW_IPU_CSIO_CPD_RS_i_WR(x, (HW_IPU_CSIO_CPD_RS_i_RD(x) & ~BM_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3) | BF_IPU_CSIO_CPD_RS_i_CSI0_CPD_RS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_GRC_i - CSI0 GR Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_GRC_i - CSI0 GR Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANTi parameters used for companding of green
 * components in GRGR rows.
 */
typedef union _hw_ipu_csio_cpd_grc_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_grc_i_bitfields
    {
        uint32_t CSI0_CPD_GRC_2i : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI0_CPD_GRC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csio_cpd_grc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_GRC_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_GRC_i_ADDR(x) ((uintptr_t)(x) + 0x3005CU)

#define HW_IPU_CSIO_CPD_GRC_i(x) (*(__IO hw_ipu_csio_cpd_grc_i_t *) HW_IPU_CSIO_CPD_GRC_i_ADDR(x))
#define HW_IPU_CSIO_CPD_GRC_i_RD(x) (HW_IPU_CSIO_CPD_GRC_i(x).U)
#define HW_IPU_CSIO_CPD_GRC_i_WR(x, v) (HW_IPU_CSIO_CPD_GRC_i(x).U = (v))
#define HW_IPU_CSIO_CPD_GRC_i_SET(x, v) (HW_IPU_CSIO_CPD_GRC_i_WR(x, HW_IPU_CSIO_CPD_GRC_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_GRC_i_CLR(x, v) (HW_IPU_CSIO_CPD_GRC_i_WR(x, HW_IPU_CSIO_CPD_GRC_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_GRC_i_TOG(x, v) (HW_IPU_CSIO_CPD_GRC_i_WR(x, HW_IPU_CSIO_CPD_GRC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_GRC_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_GRC_i, field CSI0_CPD_GRC_2i[8:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i (0U) /*!< Bit position for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i. */
#define BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i (0x000001FFU) /*!< Bit mask for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i. */
#define BS_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i field. */
#define BR_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i(x) (HW_IPU_CSIO_CPD_GRC_i(x).B.CSI0_CPD_GRC_2i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i. */
#define BF_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i) & BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i)

/*! @brief Set the CSI0_CPD_GRC_2i field to a new value. */
#define BW_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i(x, v) (HW_IPU_CSIO_CPD_GRC_i_WR(x, (HW_IPU_CSIO_CPD_GRC_i_RD(x) & ~BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i) | BF_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GRC_i, field CSI0_CPD_GRC_2i_1[24:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1 (16U) /*!< Bit position for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1. */
#define BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1. */
#define BS_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1 field. */
#define BR_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1(x) (HW_IPU_CSIO_CPD_GRC_i(x).B.CSI0_CPD_GRC_2i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1. */
#define BF_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1) & BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1)

/*! @brief Set the CSI0_CPD_GRC_2i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1(x, v) (HW_IPU_CSIO_CPD_GRC_i_WR(x, (HW_IPU_CSIO_CPD_GRC_i_RD(x) & ~BM_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1) | BF_IPU_CSIO_CPD_GRC_i_CSI0_CPD_GRC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_GRS_i - CSI0 GR Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_GRS_i - CSI0 GR Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPEi parameters used for companding of green
 * components in GRGR rows.
 */
typedef union _hw_ipu_csio_cpd_grs_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_grs_i_bitfields
    {
        uint32_t CSI0_CPD_GRS_4i : 8;  /*!< [7:0]  */
        uint32_t CSI0_CPD_GRS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI0_CPD_GRS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI0_CPD_GRS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csio_cpd_grs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_GRS_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_GRS_i_ADDR(x) ((uintptr_t)(x) + 0x3007CU)

#define HW_IPU_CSIO_CPD_GRS_i(x) (*(__IO hw_ipu_csio_cpd_grs_i_t *) HW_IPU_CSIO_CPD_GRS_i_ADDR(x))
#define HW_IPU_CSIO_CPD_GRS_i_RD(x) (HW_IPU_CSIO_CPD_GRS_i(x).U)
#define HW_IPU_CSIO_CPD_GRS_i_WR(x, v) (HW_IPU_CSIO_CPD_GRS_i(x).U = (v))
#define HW_IPU_CSIO_CPD_GRS_i_SET(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, HW_IPU_CSIO_CPD_GRS_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_GRS_i_CLR(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, HW_IPU_CSIO_CPD_GRS_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_GRS_i_TOG(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, HW_IPU_CSIO_CPD_GRS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_GRS_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_GRS_i, field CSI0_CPD_GRS_4i[7:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i (0U) /*!< Bit position for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i. */
#define BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i (0x000000FFU) /*!< Bit mask for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i. */
#define BS_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i field. */
#define BR_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i(x) (HW_IPU_CSIO_CPD_GRS_i(x).B.CSI0_CPD_GRS_4i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i. */
#define BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i) & BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i)

/*! @brief Set the CSI0_CPD_GRS_4i field to a new value. */
#define BW_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, (HW_IPU_CSIO_CPD_GRS_i_RD(x) & ~BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i) | BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GRS_i, field CSI0_CPD_GRS_4i_1[15:8] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1 (8U) /*!< Bit position for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1. */
#define BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1. */
#define BS_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1 field. */
#define BR_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1(x) (HW_IPU_CSIO_CPD_GRS_i(x).B.CSI0_CPD_GRS_4i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1. */
#define BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1) & BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1)

/*! @brief Set the CSI0_CPD_GRS_4i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, (HW_IPU_CSIO_CPD_GRS_i_RD(x) & ~BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1) | BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GRS_i, field CSI0_CPD_GRS_4i_2[23:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2 (16U) /*!< Bit position for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2. */
#define BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2. */
#define BS_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2 field. */
#define BR_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2(x) (HW_IPU_CSIO_CPD_GRS_i(x).B.CSI0_CPD_GRS_4i_2)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2. */
#define BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2) & BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2)

/*! @brief Set the CSI0_CPD_GRS_4i_2 field to a new value. */
#define BW_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, (HW_IPU_CSIO_CPD_GRS_i_RD(x) & ~BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2) | BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GRS_i, field CSI0_CPD_GRS_4i_3[31:24] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3 (24U) /*!< Bit position for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3. */
#define BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3. */
#define BS_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3. */

/*! @brief Read current value of the IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3 field. */
#define BR_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3(x) (HW_IPU_CSIO_CPD_GRS_i(x).B.CSI0_CPD_GRS_4i_3)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3. */
#define BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3) & BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3)

/*! @brief Set the CSI0_CPD_GRS_4i_3 field to a new value. */
#define BW_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3(x, v) (HW_IPU_CSIO_CPD_GRS_i_WR(x, (HW_IPU_CSIO_CPD_GRS_i_RD(x) & ~BM_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3) | BF_IPU_CSIO_CPD_GRS_i_CSI0_CPD_GRS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_GBC_i - CSI0 GB Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_GBC_i - CSI0 GB Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANTi parameters used for companding of green
 * components in GBGB rows.
 */
typedef union _hw_ipu_csio_cpd_gbc_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_gbc_i_bitfields
    {
        uint32_t CSI0_CPD_GBC_2i : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI0_CPD_GBC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csio_cpd_gbc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_GBC_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_GBC_i_ADDR(x) ((uintptr_t)(x) + 0x3008CU)

#define HW_IPU_CSIO_CPD_GBC_i(x) (*(__IO hw_ipu_csio_cpd_gbc_i_t *) HW_IPU_CSIO_CPD_GBC_i_ADDR(x))
#define HW_IPU_CSIO_CPD_GBC_i_RD(x) (HW_IPU_CSIO_CPD_GBC_i(x).U)
#define HW_IPU_CSIO_CPD_GBC_i_WR(x, v) (HW_IPU_CSIO_CPD_GBC_i(x).U = (v))
#define HW_IPU_CSIO_CPD_GBC_i_SET(x, v) (HW_IPU_CSIO_CPD_GBC_i_WR(x, HW_IPU_CSIO_CPD_GBC_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_GBC_i_CLR(x, v) (HW_IPU_CSIO_CPD_GBC_i_WR(x, HW_IPU_CSIO_CPD_GBC_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_GBC_i_TOG(x, v) (HW_IPU_CSIO_CPD_GBC_i_WR(x, HW_IPU_CSIO_CPD_GBC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_GBC_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_GBC_i, field CSI0_CPD_GBC_2i[8:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i (0U) /*!< Bit position for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i. */
#define BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i (0x000001FFU) /*!< Bit mask for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i. */
#define BS_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i field. */
#define BR_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i(x) (HW_IPU_CSIO_CPD_GBC_i(x).B.CSI0_CPD_GBC_2i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i. */
#define BF_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i) & BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i)

/*! @brief Set the CSI0_CPD_GBC_2i field to a new value. */
#define BW_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i(x, v) (HW_IPU_CSIO_CPD_GBC_i_WR(x, (HW_IPU_CSIO_CPD_GBC_i_RD(x) & ~BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i) | BF_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GBC_i, field CSI0_CPD_GBC_2i_1[24:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1 (16U) /*!< Bit position for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1. */
#define BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1. */
#define BS_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1 field. */
#define BR_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1(x) (HW_IPU_CSIO_CPD_GBC_i(x).B.CSI0_CPD_GBC_2i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1. */
#define BF_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1) & BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1)

/*! @brief Set the CSI0_CPD_GBC_2i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1(x, v) (HW_IPU_CSIO_CPD_GBC_i_WR(x, (HW_IPU_CSIO_CPD_GBC_i_RD(x) & ~BM_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1) | BF_IPU_CSIO_CPD_GBC_i_CSI0_CPD_GBC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_GBS_i - CSI0 GB Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_GBS_i - CSI0 GB Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPEi parameters used for companding of green
 * components in GBGB rows.
 */
typedef union _hw_ipu_csio_cpd_gbs_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_gbs_i_bitfields
    {
        uint32_t CSI0_CPD_GBS_4i : 8;  /*!< [7:0]  */
        uint32_t CSI0_CPD_GBS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI0_CPD_GBS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI0_CPD_GBS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csio_cpd_gbs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_GBS_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_GBS_i_ADDR(x) ((uintptr_t)(x) + 0x300ACU)

#define HW_IPU_CSIO_CPD_GBS_i(x) (*(__IO hw_ipu_csio_cpd_gbs_i_t *) HW_IPU_CSIO_CPD_GBS_i_ADDR(x))
#define HW_IPU_CSIO_CPD_GBS_i_RD(x) (HW_IPU_CSIO_CPD_GBS_i(x).U)
#define HW_IPU_CSIO_CPD_GBS_i_WR(x, v) (HW_IPU_CSIO_CPD_GBS_i(x).U = (v))
#define HW_IPU_CSIO_CPD_GBS_i_SET(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, HW_IPU_CSIO_CPD_GBS_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_GBS_i_CLR(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, HW_IPU_CSIO_CPD_GBS_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_GBS_i_TOG(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, HW_IPU_CSIO_CPD_GBS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_GBS_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_GBS_i, field CSI0_CPD_GBS_4i[7:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i (0U) /*!< Bit position for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i. */
#define BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i (0x000000FFU) /*!< Bit mask for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i. */
#define BS_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i field. */
#define BR_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i(x) (HW_IPU_CSIO_CPD_GBS_i(x).B.CSI0_CPD_GBS_4i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i. */
#define BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i) & BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i)

/*! @brief Set the CSI0_CPD_GBS_4i field to a new value. */
#define BW_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, (HW_IPU_CSIO_CPD_GBS_i_RD(x) & ~BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i) | BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GBS_i, field CSI0_CPD_GBS_4i_1[15:8] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1 (8U) /*!< Bit position for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1. */
#define BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1. */
#define BS_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1 field. */
#define BR_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1(x) (HW_IPU_CSIO_CPD_GBS_i(x).B.CSI0_CPD_GBS_4i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1. */
#define BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1) & BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1)

/*! @brief Set the CSI0_CPD_GBS_4i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, (HW_IPU_CSIO_CPD_GBS_i_RD(x) & ~BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1) | BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GBS_i, field CSI0_CPD_GBS_4i_2[23:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2 (16U) /*!< Bit position for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2. */
#define BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2. */
#define BS_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2 field. */
#define BR_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2(x) (HW_IPU_CSIO_CPD_GBS_i(x).B.CSI0_CPD_GBS_4i_2)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2. */
#define BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2) & BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2)

/*! @brief Set the CSI0_CPD_GBS_4i_2 field to a new value. */
#define BW_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, (HW_IPU_CSIO_CPD_GBS_i_RD(x) & ~BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2) | BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_GBS_i, field CSI0_CPD_GBS_4i_3[31:24] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3 (24U) /*!< Bit position for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3. */
#define BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3. */
#define BS_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3. */

/*! @brief Read current value of the IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3 field. */
#define BR_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3(x) (HW_IPU_CSIO_CPD_GBS_i(x).B.CSI0_CPD_GBS_4i_3)

/*! @brief Format value for bitfield IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3. */
#define BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3) & BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3)

/*! @brief Set the CSI0_CPD_GBS_4i_3 field to a new value. */
#define BW_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3(x, v) (HW_IPU_CSIO_CPD_GBS_i_WR(x, (HW_IPU_CSIO_CPD_GBS_i_RD(x) & ~BM_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3) | BF_IPU_CSIO_CPD_GBS_i_CSI0_CPD_GBS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_BC_i - CSI0 Blue Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_BC_i - CSI0 Blue Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANTi parameters used for companding of blue
 * component.
 */
typedef union _hw_ipu_csio_cpd_bc_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_bc_i_bitfields
    {
        uint32_t CSI0_CPD_BC_2i : 9;   /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI0_CPD_BC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csio_cpd_bc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_BC_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_BC_i_ADDR(x) ((uintptr_t)(x) + 0x300BCU)

#define HW_IPU_CSIO_CPD_BC_i(x)  (*(__IO hw_ipu_csio_cpd_bc_i_t *) HW_IPU_CSIO_CPD_BC_i_ADDR(x))
#define HW_IPU_CSIO_CPD_BC_i_RD(x) (HW_IPU_CSIO_CPD_BC_i(x).U)
#define HW_IPU_CSIO_CPD_BC_i_WR(x, v) (HW_IPU_CSIO_CPD_BC_i(x).U = (v))
#define HW_IPU_CSIO_CPD_BC_i_SET(x, v) (HW_IPU_CSIO_CPD_BC_i_WR(x, HW_IPU_CSIO_CPD_BC_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_BC_i_CLR(x, v) (HW_IPU_CSIO_CPD_BC_i_WR(x, HW_IPU_CSIO_CPD_BC_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_BC_i_TOG(x, v) (HW_IPU_CSIO_CPD_BC_i_WR(x, HW_IPU_CSIO_CPD_BC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_BC_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_BC_i, field CSI0_CPD_BC_2i[8:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i (0U) /*!< Bit position for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i. */
#define BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i (0x000001FFU) /*!< Bit mask for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i. */
#define BS_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i. */

/*! @brief Read current value of the IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i field. */
#define BR_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i(x) (HW_IPU_CSIO_CPD_BC_i(x).B.CSI0_CPD_BC_2i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i. */
#define BF_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i) & BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i)

/*! @brief Set the CSI0_CPD_BC_2i field to a new value. */
#define BW_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i(x, v) (HW_IPU_CSIO_CPD_BC_i_WR(x, (HW_IPU_CSIO_CPD_BC_i_RD(x) & ~BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i) | BF_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_BC_i, field CSI0_CPD_BC_2i_1[24:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1 (16U) /*!< Bit position for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1. */
#define BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1. */
#define BS_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1 field. */
#define BR_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1(x) (HW_IPU_CSIO_CPD_BC_i(x).B.CSI0_CPD_BC_2i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1. */
#define BF_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1) & BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1)

/*! @brief Set the CSI0_CPD_BC_2i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1(x, v) (HW_IPU_CSIO_CPD_BC_i_WR(x, (HW_IPU_CSIO_CPD_BC_i_RD(x) & ~BM_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1) | BF_IPU_CSIO_CPD_BC_i_CSI0_CPD_BC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSIO_CPD_BS_i - CSI0 Blue Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSIO_CPD_BS_i - CSI0 Blue Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPEi parameters used for companding of red
 * component.
 */
typedef union _hw_ipu_csio_cpd_bs_i
{
    uint32_t U;
    struct _hw_ipu_csio_cpd_bs_i_bitfields
    {
        uint32_t CSI0_CPD_BS_4i : 8;   /*!< [7:0]  */
        uint32_t CSI0_CPD_BS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI0_CPD_BS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI0_CPD_BS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csio_cpd_bs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSIO_CPD_BS_i register
 */
/*@{*/
#define HW_IPU_CSIO_CPD_BS_i_ADDR(x) ((uintptr_t)(x) + 0x300DCU)

#define HW_IPU_CSIO_CPD_BS_i(x)  (*(__IO hw_ipu_csio_cpd_bs_i_t *) HW_IPU_CSIO_CPD_BS_i_ADDR(x))
#define HW_IPU_CSIO_CPD_BS_i_RD(x) (HW_IPU_CSIO_CPD_BS_i(x).U)
#define HW_IPU_CSIO_CPD_BS_i_WR(x, v) (HW_IPU_CSIO_CPD_BS_i(x).U = (v))
#define HW_IPU_CSIO_CPD_BS_i_SET(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, HW_IPU_CSIO_CPD_BS_i_RD(x) |  (v)))
#define HW_IPU_CSIO_CPD_BS_i_CLR(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, HW_IPU_CSIO_CPD_BS_i_RD(x) & ~(v)))
#define HW_IPU_CSIO_CPD_BS_i_TOG(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, HW_IPU_CSIO_CPD_BS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSIO_CPD_BS_i bitfields
 */

/*!
 * @name Register IPU_CSIO_CPD_BS_i, field CSI0_CPD_BS_4i[7:0] (RW)
 *
 * Reserved l
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i (0U) /*!< Bit position for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i. */
#define BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i (0x000000FFU) /*!< Bit mask for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i. */
#define BS_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i. */

/*! @brief Read current value of the IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i field. */
#define BR_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i(x) (HW_IPU_CSIO_CPD_BS_i(x).B.CSI0_CPD_BS_4i)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i. */
#define BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i) & BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i)

/*! @brief Set the CSI0_CPD_BS_4i field to a new value. */
#define BW_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, (HW_IPU_CSIO_CPD_BS_i_RD(x) & ~BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i) | BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_BS_i, field CSI0_CPD_BS_4i_1[15:8] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1 (8U) /*!< Bit position for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1. */
#define BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1. */
#define BS_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1. */

/*! @brief Read current value of the IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1 field. */
#define BR_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1(x) (HW_IPU_CSIO_CPD_BS_i(x).B.CSI0_CPD_BS_4i_1)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1. */
#define BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1) & BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1)

/*! @brief Set the CSI0_CPD_BS_4i_1 field to a new value. */
#define BW_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, (HW_IPU_CSIO_CPD_BS_i_RD(x) & ~BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1) | BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_BS_i, field CSI0_CPD_BS_4i_2[23:16] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2 (16U) /*!< Bit position for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2. */
#define BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2. */
#define BS_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2. */

/*! @brief Read current value of the IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2 field. */
#define BR_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2(x) (HW_IPU_CSIO_CPD_BS_i(x).B.CSI0_CPD_BS_4i_2)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2. */
#define BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2) & BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2)

/*! @brief Set the CSI0_CPD_BS_4i_2 field to a new value. */
#define BW_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, (HW_IPU_CSIO_CPD_BS_i_RD(x) & ~BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2) | BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSIO_CPD_BS_i, field CSI0_CPD_BS_4i_3[31:24] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3 (24U) /*!< Bit position for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3. */
#define BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3. */
#define BS_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3. */

/*! @brief Read current value of the IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3 field. */
#define BR_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3(x) (HW_IPU_CSIO_CPD_BS_i(x).B.CSI0_CPD_BS_4i_3)

/*! @brief Format value for bitfield IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3. */
#define BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3) & BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3)

/*! @brief Set the CSI0_CPD_BS_4i_3 field to a new value. */
#define BW_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3(x, v) (HW_IPU_CSIO_CPD_BS_i_WR(x, (HW_IPU_CSIO_CPD_BS_i_RD(x) & ~BM_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3) | BF_IPU_CSIO_CPD_BS_i_CSI0_CPD_BS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_CPD_OFFSET1 - CSI0 Compander Offset Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_CPD_OFFSET1 - CSI0 Compander Offset Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain Offset parameters used for companding.
 */
typedef union _hw_ipu_csi0_cpd_offset1
{
    uint32_t U;
    struct _hw_ipu_csi0_cpd_offset1_bitfields
    {
        uint32_t CSI0_GR_OFFSET : 10;  /*!< [9:0]  */
        uint32_t CSI0_GB_OFFSET : 10;  /*!< [19:10]  */
        uint32_t CSI0_CPD_B_OFFSET : 10; /*!< [29:20]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_csi0_cpd_offset1_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_CPD_OFFSET1 register
 */
/*@{*/
#define HW_IPU_CSI0_CPD_OFFSET1_ADDR(x) ((uintptr_t)(x) + 0x300ECU)

#define HW_IPU_CSI0_CPD_OFFSET1(x) (*(__IO hw_ipu_csi0_cpd_offset1_t *) HW_IPU_CSI0_CPD_OFFSET1_ADDR(x))
#define HW_IPU_CSI0_CPD_OFFSET1_RD(x) (HW_IPU_CSI0_CPD_OFFSET1(x).U)
#define HW_IPU_CSI0_CPD_OFFSET1_WR(x, v) (HW_IPU_CSI0_CPD_OFFSET1(x).U = (v))
#define HW_IPU_CSI0_CPD_OFFSET1_SET(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, HW_IPU_CSI0_CPD_OFFSET1_RD(x) |  (v)))
#define HW_IPU_CSI0_CPD_OFFSET1_CLR(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, HW_IPU_CSI0_CPD_OFFSET1_RD(x) & ~(v)))
#define HW_IPU_CSI0_CPD_OFFSET1_TOG(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, HW_IPU_CSI0_CPD_OFFSET1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_CPD_OFFSET1 bitfields
 */

/*!
 * @name Register IPU_CSI0_CPD_OFFSET1, field CSI0_GR_OFFSET[9:0] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET (0U) /*!< Bit position for IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET. */
#define BM_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET (0x000003FFU) /*!< Bit mask for IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET. */
#define BS_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET. */

/*! @brief Read current value of the IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET field. */
#define BR_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET(x) (HW_IPU_CSI0_CPD_OFFSET1(x).B.CSI0_GR_OFFSET)

/*! @brief Format value for bitfield IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET. */
#define BF_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET) & BM_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET)

/*! @brief Set the CSI0_GR_OFFSET field to a new value. */
#define BW_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, (HW_IPU_CSI0_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET) | BF_IPU_CSI0_CPD_OFFSET1_CSI0_GR_OFFSET(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CPD_OFFSET1, field CSI0_GB_OFFSET[19:10] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET (10U) /*!< Bit position for IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET. */
#define BM_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET (0x000FFC00U) /*!< Bit mask for IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET. */
#define BS_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET. */

/*! @brief Read current value of the IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET field. */
#define BR_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET(x) (HW_IPU_CSI0_CPD_OFFSET1(x).B.CSI0_GB_OFFSET)

/*! @brief Format value for bitfield IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET. */
#define BF_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET) & BM_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET)

/*! @brief Set the CSI0_GB_OFFSET field to a new value. */
#define BW_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, (HW_IPU_CSI0_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET) | BF_IPU_CSI0_CPD_OFFSET1_CSI0_GB_OFFSET(v)))
/*@}*/

/*!
 * @name Register IPU_CSI0_CPD_OFFSET1, field CSI0_CPD_B_OFFSET[29:20] (RW)
 *
 * Reserved
 */
/*@{*/
#define BP_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET (20U) /*!< Bit position for IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET. */
#define BM_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET (0x3FF00000U) /*!< Bit mask for IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET. */
#define BS_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET. */

/*! @brief Read current value of the IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET field. */
#define BR_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET(x) (HW_IPU_CSI0_CPD_OFFSET1(x).B.CSI0_CPD_B_OFFSET)

/*! @brief Format value for bitfield IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET. */
#define BF_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET) & BM_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET)

/*! @brief Set the CSI0_CPD_B_OFFSET field to a new value. */
#define BW_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET(x, v) (HW_IPU_CSI0_CPD_OFFSET1_WR(x, (HW_IPU_CSI0_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET) | BF_IPU_CSI0_CPD_OFFSET1_CSI0_CPD_B_OFFSET(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI0_CPD_OFFSET2 - CSI0 Compander Offset Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI0_CPD_OFFSET2 - CSI0 Compander Offset Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contain Offset parameters used for companding.
 */
typedef union _hw_ipu_csi0_cpd_offset2
{
    uint32_t U;
    struct _hw_ipu_csi0_cpd_offset2_bitfields
    {
        uint32_t CSI0_CPD_R_OFFSET : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_csi0_cpd_offset2_t;

/*!
 * @name Constants and macros for entire IPU_CSI0_CPD_OFFSET2 register
 */
/*@{*/
#define HW_IPU_CSI0_CPD_OFFSET2_ADDR(x) ((uintptr_t)(x) + 0x300F0U)

#define HW_IPU_CSI0_CPD_OFFSET2(x) (*(__IO hw_ipu_csi0_cpd_offset2_t *) HW_IPU_CSI0_CPD_OFFSET2_ADDR(x))
#define HW_IPU_CSI0_CPD_OFFSET2_RD(x) (HW_IPU_CSI0_CPD_OFFSET2(x).U)
#define HW_IPU_CSI0_CPD_OFFSET2_WR(x, v) (HW_IPU_CSI0_CPD_OFFSET2(x).U = (v))
#define HW_IPU_CSI0_CPD_OFFSET2_SET(x, v) (HW_IPU_CSI0_CPD_OFFSET2_WR(x, HW_IPU_CSI0_CPD_OFFSET2_RD(x) |  (v)))
#define HW_IPU_CSI0_CPD_OFFSET2_CLR(x, v) (HW_IPU_CSI0_CPD_OFFSET2_WR(x, HW_IPU_CSI0_CPD_OFFSET2_RD(x) & ~(v)))
#define HW_IPU_CSI0_CPD_OFFSET2_TOG(x, v) (HW_IPU_CSI0_CPD_OFFSET2_WR(x, HW_IPU_CSI0_CPD_OFFSET2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI0_CPD_OFFSET2 bitfields
 */

/*!
 * @name Register IPU_CSI0_CPD_OFFSET2, field CSI0_CPD_R_OFFSET[9:0] (RW)
 *
 * CSI0 Red component offset The value is between -512 to 511. The value is
 * added to the red component before companding. Clipping: If the result of the red
 * components value + the offset is smaller than 0, the result is zero If the
 * result of the red components value + the offset is greater than 1023, the result
 * is 1023 Reserved
 */
/*@{*/
#define BP_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET (0U) /*!< Bit position for IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET. */
#define BM_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET (0x000003FFU) /*!< Bit mask for IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET. */
#define BS_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET. */

/*! @brief Read current value of the IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET field. */
#define BR_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET(x) (HW_IPU_CSI0_CPD_OFFSET2(x).B.CSI0_CPD_R_OFFSET)

/*! @brief Format value for bitfield IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET. */
#define BF_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET) & BM_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET)

/*! @brief Set the CSI0_CPD_R_OFFSET field to a new value. */
#define BW_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET(x, v) (HW_IPU_CSI0_CPD_OFFSET2_WR(x, (HW_IPU_CSI0_CPD_OFFSET2_RD(x) & ~BM_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET) | BF_IPU_CSI0_CPD_OFFSET2_CSI0_CPD_R_OFFSET(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_SENS_CONF - CSI1 Sensor Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_SENS_CONF - CSI1 Sensor Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_sens_conf
{
    uint32_t U;
    struct _hw_ipu_csi1_sens_conf_bitfields
    {
        uint32_t CSI1_VSYNC_POL : 1;   /*!< [0]  */
        uint32_t CSI1_HSYNC_POL : 1;   /*!< [1]  */
        uint32_t CSI1_DATA_POL : 1;    /*!< [2]  */
        uint32_t CSI1_SENS_PIX_CLK_POL : 1; /*!< [3]  */
        uint32_t CSI1_SENS_PRTCL : 3;  /*!< [6:4]  */
        uint32_t CSI1_PACK_TIGHT : 1;  /*!< [7]  */
        uint32_t CSI1_SENS_DATA_FORMAT : 3; /*!< [10:8]  */
        uint32_t CSI1_DATA_WIDTH : 4;  /*!< [14:11]  */
        uint32_t CSI1_EXT_VSYNC : 1;   /*!< [15]  */
        uint32_t CSI1_DIV_RATIO : 8;   /*!< [23:16]  */
        uint32_t CSI1_DATA_DEST : 3;   /*!< [26:24]  */
        uint32_t CSI1_JPEG8_EN : 1;    /*!< [27]  */
        uint32_t CSI1_JPEG_MODE : 1;   /*!< [28]  */
        uint32_t CSI1_FORCE_EOF : 1;   /*!< [29]  */
        uint32_t RESERVED0 : 1;        /*!< [30]  */
        uint32_t CSI0_DATA_EN_POL : 1; /*!< [31]  */
    } B;
} hw_ipu_csi1_sens_conf_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_SENS_CONF register
 */
/*@{*/
#define HW_IPU_CSI1_SENS_CONF_ADDR(x) ((uintptr_t)(x) + 0x38000U)

#define HW_IPU_CSI1_SENS_CONF(x) (*(__IO hw_ipu_csi1_sens_conf_t *) HW_IPU_CSI1_SENS_CONF_ADDR(x))
#define HW_IPU_CSI1_SENS_CONF_RD(x) (HW_IPU_CSI1_SENS_CONF(x).U)
#define HW_IPU_CSI1_SENS_CONF_WR(x, v) (HW_IPU_CSI1_SENS_CONF(x).U = (v))
#define HW_IPU_CSI1_SENS_CONF_SET(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, HW_IPU_CSI1_SENS_CONF_RD(x) |  (v)))
#define HW_IPU_CSI1_SENS_CONF_CLR(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, HW_IPU_CSI1_SENS_CONF_RD(x) & ~(v)))
#define HW_IPU_CSI1_SENS_CONF_TOG(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, HW_IPU_CSI1_SENS_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_SENS_CONF bitfields
 */

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_VSYNC_POL[0] (RW)
 *
 * Invert IPP_IND_SENSB_VSYNC input. This bit selects the polarity of
 * IPP_IND_SENSB_VSYNC signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_VSYNC is not inverted before applied to internal
 *     circuitry.
 * - 1 - IPP_IND_SENSB_VSYNC is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL (0U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL (0x00000001U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_VSYNC_POL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL) & BM_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL)

/*! @brief Set the CSI1_VSYNC_POL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL) | BF_IPU_CSI1_SENS_CONF_CSI1_VSYNC_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_HSYNC_POL[1] (RW)
 *
 * Invert IPP_IND_SENSB_HSYNC input. This bit selects the polarity of
 * IPP_IND_SENSB_HSYNC signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_HSYNC is directly applied to internal circuitry.
 * - 1 - IPP_IND_SENSB_HSYNC is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL (1U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL (0x00000002U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_HSYNC_POL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL) & BM_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL)

/*! @brief Set the CSI1_HSYNC_POL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL) | BF_IPU_CSI1_SENS_CONF_CSI1_HSYNC_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_DATA_POL[2] (RW)
 *
 * Invert data input. This bit selects the polarity of data input.
 *
 * Values:
 * - 0 - data lines are directly applied to internal circuitry.
 * - 1 - data lines are inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_DATA_POL (2U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_DATA_POL. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_DATA_POL (0x00000004U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_DATA_POL. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_DATA_POL (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_DATA_POL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_DATA_POL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_DATA_POL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_DATA_POL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_DATA_POL. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_DATA_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_DATA_POL) & BM_IPU_CSI1_SENS_CONF_CSI1_DATA_POL)

/*! @brief Set the CSI1_DATA_POL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_DATA_POL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_DATA_POL) | BF_IPU_CSI1_SENS_CONF_CSI1_DATA_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_SENS_PIX_CLK_POL[3] (RW)
 *
 * Invert Pixel clock input. This bit selects the polarity of pixel clock.
 *
 * Values:
 * - 0 - pixel clock is directly applied to internal circuitry.
 * - 1 - pixel clock is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL (3U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL (0x00000008U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_SENS_PIX_CLK_POL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL) & BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL)

/*! @brief Set the CSI1_SENS_PIX_CLK_POL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL) | BF_IPU_CSI1_SENS_CONF_CSI1_SENS_PIX_CLK_POL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_SENS_PRTCL[6:4] (RW)
 *
 * Sensor Protocol. This bit defines the Sensor timing/data mode protocol.
 * Values:
 *
 * Values:
 * - 000 - Gated clock mode
 * - 001 - Non-gated clock mode
 * - 010 - CCIR progressive mode (BT.656)
 * - 011 - CCIR interlaced mode (BT.656)
 * - 100 - CCIR progressive (BT.1120 DDR mode: data arrives on every edge of the
 *     clock)
 * - 101 - CCIR progressive (BT.1120 SDR mode: data arrives only on the positive
 *     edge of the clock)
 * - 110 - CCIR interlaced mode (BT.1120 DDR mode: data arrives on every edge of
 *     the clock)
 * - 111 - CCIR interlaced mode (BT.1120 SDR mode: data arrives only on the
 *     positive edge of the clock)
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL (4U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL (0x00000070U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL (3U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_SENS_PRTCL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL) & BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL)

/*! @brief Set the CSI1_SENS_PRTCL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL) | BF_IPU_CSI1_SENS_CONF_CSI1_SENS_PRTCL(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_PACK_TIGHT[7] (RW)
 *
 * CSI1 Pack Tight When the data format is YUV or RGB and the component's width
 * is 9-16 bits, it can be sent to the memory in 2 different ways
 *
 * Values:
 * - 1 - Three 10 bits components are packed into a 32 bit word. Color
 *     extension/reduction is performed
 * - 0 - Each component is written as a 16 bit word where the MSB is written to
 *     bit #15, color extension is done for the remaining least significant bits.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT (7U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT (0x00000080U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_PACK_TIGHT)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT) & BM_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT)

/*! @brief Set the CSI1_PACK_TIGHT field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT) | BF_IPU_CSI1_SENS_CONF_CSI1_PACK_TIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_SENS_DATA_FORMAT[10:8] (RW)
 *
 * Data format from the sensor. This field defines the data format for the input
 * of the CSI sensor. Values:
 *
 * Values:
 * - 000 - full RGB or YUV444
 * - 001 - YUV422 (YUYV...)
 * - 010 - YUV422 (UYVY...)
 * - 011 - Bayer or Generic data
 * - 100 - RGB565
 * - 101 - RGB555
 * - 110 - RGB444
 * - 111 - JPEG
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT (8U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT (0x00000700U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT (3U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_SENS_DATA_FORMAT)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT) & BM_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT)

/*! @brief Set the CSI1_SENS_DATA_FORMAT field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT) | BF_IPU_CSI1_SENS_CONF_CSI1_SENS_DATA_FORMAT(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_DATA_WIDTH[14:11] (RW)
 *
 * Data width. This fields defines the number of bits per color. Values:
 *
 * Values:
 * - 0000 - 4 bits per color
 * - 0000 - Reserved
 * - 0001 - 8 bits per color
 * - 0010 - 9 bits per color
 * - 0010 - Reserved
 * - 0011 - 10 bits per color
 * - 0100 - 11 bits per color
 * - 0100 - Reserved
 * - 0101 - 12 bits per color
 * - 0101 - Reserved
 * - 0110 - 13 bits per color
 * - 0110 - Reserved
 * - 0111 - 14 bits per color
 * - 0111 - Reserved
 * - 1000 - 15 bits per color
 * - 1000 - Reserved
 * - 1001 - 16 bits per color
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH (11U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH (0x00007800U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH (4U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_DATA_WIDTH)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH) & BM_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH)

/*! @brief Set the CSI1_DATA_WIDTH field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH) | BF_IPU_CSI1_SENS_CONF_CSI1_DATA_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_EXT_VSYNC[15] (RW)
 *
 * External VSYNC enable. This bits select between external and internal VSYNC.
 *
 * Values:
 * - 0 - Internal VSYNC mode.
 * - 1 - External VSYNC mode.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC (15U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC (0x00008000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_EXT_VSYNC)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC) & BM_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC)

/*! @brief Set the CSI1_EXT_VSYNC field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC) | BF_IPU_CSI1_SENS_CONF_CSI1_EXT_VSYNC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_DIV_RATIO[23:16] (RW)
 *
 * DIV Ratio Clock division ratio minus 1. This field defines the division ratio
 * of HSP_CLK into SENSB_MCLK: SENSB_MCLK rate = HSP_CLK rate /(DIV_RATIO+1)
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO (16U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO (0x00FF0000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO (8U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_DIV_RATIO)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO) & BM_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO)

/*! @brief Set the CSI1_DIV_RATIO field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO) | BF_IPU_CSI1_SENS_CONF_CSI1_DIV_RATIO(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_DATA_DEST[26:24] (RW)
 *
 * These bits enable the destination of the data coming from the CSI.
 * CSI1_DATA_DEST[0] - Reserved CSI1_DATA_DEST[1] - destination is IC CSI1_DATA_DEST[2] -
 * destination is IDMAC via SMFC
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST (24U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_DATA_DEST. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST (0x07000000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_DATA_DEST. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST (3U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_DATA_DEST. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_DATA_DEST field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_DATA_DEST)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_DATA_DEST. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST) & BM_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST)

/*! @brief Set the CSI1_DATA_DEST field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST) | BF_IPU_CSI1_SENS_CONF_CSI1_DATA_DEST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_JPEG8_EN[27] (RW)
 *
 * JPEG8 enable bit
 *
 * Values:
 * - 1 - JPEG8 detection is enabled
 * - 0 - JPEG8 is disabled
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN (27U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN (0x08000000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_JPEG8_EN)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN) & BM_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN)

/*! @brief Set the CSI1_JPEG8_EN field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN) | BF_IPU_CSI1_SENS_CONF_CSI1_JPEG8_EN(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_JPEG_MODE[28] (RW)
 *
 * JPEG Mode - this bit defines the mode of the control signals when working in
 * JPEG mode
 *
 * Values:
 * - 1 - The data is valid as long as HSYNC and VSYNC signals are active; HSYNC
 *     is valid for single frame
 * - 0 - The frame starts withe the assertion of VSYNC. The frame ends on the
 *     next VSYNC or by setting the CSI0_FORCE_EOF bit
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE (28U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE (0x10000000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_JPEG_MODE)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE) & BM_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE)

/*! @brief Set the CSI1_JPEG_MODE field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE) | BF_IPU_CSI1_SENS_CONF_CSI1_JPEG_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI1_FORCE_EOF[29] (RW)
 *
 * Force End of frame This is a self clear bit allowing the user to force an
 * End-of-frame event; This bit can be used in cases where the frame sent by the
 * sensor was not completed.
 *
 * Values:
 * - 1 - force end of frame
 * - 0 - no action
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF (29U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF. */
#define BM_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF (0x20000000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF. */
#define BS_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF field. */
#define BR_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI1_FORCE_EOF)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF. */
#define BF_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF) & BM_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF)

/*! @brief Set the CSI1_FORCE_EOF field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF) | BF_IPU_CSI1_SENS_CONF_CSI1_FORCE_EOF(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_CONF, field CSI0_DATA_EN_POL[31] (RW)
 *
 * Invert IPP_IND_SENSB_DATA_EN input. This bit selects the polarity of
 * IPP_IND_SENSB_DATA_EN signal.
 *
 * Values:
 * - 0 - IPP_IND_SENSB_DATA_EN is directly applied to internal circuitry.
 * - 1 - IPP_IND_SENSB_DATA_EN is inverted before applied to internal circuitry.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL (31U) /*!< Bit position for IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL. */
#define BM_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL (0x80000000U) /*!< Bit mask for IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL. */
#define BS_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL (1U) /*!< Bit field size in bits for IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL. */

/*! @brief Read current value of the IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL field. */
#define BR_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL(x) (HW_IPU_CSI1_SENS_CONF(x).B.CSI0_DATA_EN_POL)

/*! @brief Format value for bitfield IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL. */
#define BF_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL) & BM_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL)

/*! @brief Set the CSI0_DATA_EN_POL field to a new value. */
#define BW_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL(x, v) (HW_IPU_CSI1_SENS_CONF_WR(x, (HW_IPU_CSI1_SENS_CONF_RD(x) & ~BM_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL) | BF_IPU_CSI1_SENS_CONF_CSI0_DATA_EN_POL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_SENS_FRM_SIZE - CSI1 Sense Frame Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_SENS_FRM_SIZE - CSI1 Sense Frame Size Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_sens_frm_size
{
    uint32_t U;
    struct _hw_ipu_csi1_sens_frm_size_bitfields
    {
        uint32_t CSI1_SENS_FRM_WIDTH : 13; /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t CSI1_SENS_FRM_HEIGHT : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_csi1_sens_frm_size_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_SENS_FRM_SIZE register
 */
/*@{*/
#define HW_IPU_CSI1_SENS_FRM_SIZE_ADDR(x) ((uintptr_t)(x) + 0x38004U)

#define HW_IPU_CSI1_SENS_FRM_SIZE(x) (*(__IO hw_ipu_csi1_sens_frm_size_t *) HW_IPU_CSI1_SENS_FRM_SIZE_ADDR(x))
#define HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) (HW_IPU_CSI1_SENS_FRM_SIZE(x).U)
#define HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE(x).U = (v))
#define HW_IPU_CSI1_SENS_FRM_SIZE_SET(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) |  (v)))
#define HW_IPU_CSI1_SENS_FRM_SIZE_CLR(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) & ~(v)))
#define HW_IPU_CSI1_SENS_FRM_SIZE_TOG(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_SENS_FRM_SIZE bitfields
 */

/*!
 * @name Register IPU_CSI1_SENS_FRM_SIZE, field CSI1_SENS_FRM_WIDTH[12:0] (RW)
 *
 * Sensor frame width minus 1. This field defines the sensor frame column number
 * minus 1.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH (0U) /*!< Bit position for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH. */
#define BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH (0x00001FFFU) /*!< Bit mask for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH. */
#define BS_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH (13U) /*!< Bit field size in bits for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH. */

/*! @brief Read current value of the IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH field. */
#define BR_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH(x) (HW_IPU_CSI1_SENS_FRM_SIZE(x).B.CSI1_SENS_FRM_WIDTH)

/*! @brief Format value for bitfield IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH. */
#define BF_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH) & BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH)

/*! @brief Set the CSI1_SENS_FRM_WIDTH field to a new value. */
#define BW_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, (HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) & ~BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH) | BF_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SENS_FRM_SIZE, field CSI1_SENS_FRM_HEIGHT[27:16] (RW)
 *
 * Sensor frame height minus 1. This field defines the sensor frame rows number
 * minus 1.
 */
/*@{*/
#define BP_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT (16U) /*!< Bit position for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT. */
#define BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT. */
#define BS_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT (12U) /*!< Bit field size in bits for IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT. */

/*! @brief Read current value of the IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT field. */
#define BR_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT(x) (HW_IPU_CSI1_SENS_FRM_SIZE(x).B.CSI1_SENS_FRM_HEIGHT)

/*! @brief Format value for bitfield IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT. */
#define BF_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT) & BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT)

/*! @brief Set the CSI1_SENS_FRM_HEIGHT field to a new value. */
#define BW_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT(x, v) (HW_IPU_CSI1_SENS_FRM_SIZE_WR(x, (HW_IPU_CSI1_SENS_FRM_SIZE_RD(x) & ~BM_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT) | BF_IPU_CSI1_SENS_FRM_SIZE_CSI1_SENS_FRM_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_ACT_FRM_SIZE - CSI1 Actual Frame Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_ACT_FRM_SIZE - CSI1 Actual Frame Size Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_act_frm_size
{
    uint32_t U;
    struct _hw_ipu_csi1_act_frm_size_bitfields
    {
        uint32_t CSI1_ACT_FRM_WIDTH : 13; /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t CSI1_ACT_FRM_HEIGHT : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_csi1_act_frm_size_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_ACT_FRM_SIZE register
 */
/*@{*/
#define HW_IPU_CSI1_ACT_FRM_SIZE_ADDR(x) ((uintptr_t)(x) + 0x38008U)

#define HW_IPU_CSI1_ACT_FRM_SIZE(x) (*(__IO hw_ipu_csi1_act_frm_size_t *) HW_IPU_CSI1_ACT_FRM_SIZE_ADDR(x))
#define HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) (HW_IPU_CSI1_ACT_FRM_SIZE(x).U)
#define HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE(x).U = (v))
#define HW_IPU_CSI1_ACT_FRM_SIZE_SET(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) |  (v)))
#define HW_IPU_CSI1_ACT_FRM_SIZE_CLR(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) & ~(v)))
#define HW_IPU_CSI1_ACT_FRM_SIZE_TOG(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_ACT_FRM_SIZE bitfields
 */

/*!
 * @name Register IPU_CSI1_ACT_FRM_SIZE, field CSI1_ACT_FRM_WIDTH[12:0] (RW)
 *
 * Actual frame width minus 1. This field defines the CSI output frame columns
 * number minus 1.
 */
/*@{*/
#define BP_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH (0U) /*!< Bit position for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH. */
#define BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH (0x00001FFFU) /*!< Bit mask for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH. */
#define BS_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH (13U) /*!< Bit field size in bits for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH. */

/*! @brief Read current value of the IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH field. */
#define BR_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH(x) (HW_IPU_CSI1_ACT_FRM_SIZE(x).B.CSI1_ACT_FRM_WIDTH)

/*! @brief Format value for bitfield IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH. */
#define BF_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH) & BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH)

/*! @brief Set the CSI1_ACT_FRM_WIDTH field to a new value. */
#define BW_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, (HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) & ~BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH) | BF_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_WIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_ACT_FRM_SIZE, field CSI1_ACT_FRM_HEIGHT[27:16] (RW)
 *
 * Actual frame height minus 1. This field defines the CSI output frame rows
 * number minus 1.
 */
/*@{*/
#define BP_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT (16U) /*!< Bit position for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT. */
#define BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT. */
#define BS_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT (12U) /*!< Bit field size in bits for IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT. */

/*! @brief Read current value of the IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT field. */
#define BR_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT(x) (HW_IPU_CSI1_ACT_FRM_SIZE(x).B.CSI1_ACT_FRM_HEIGHT)

/*! @brief Format value for bitfield IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT. */
#define BF_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT) & BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT)

/*! @brief Set the CSI1_ACT_FRM_HEIGHT field to a new value. */
#define BW_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT(x, v) (HW_IPU_CSI1_ACT_FRM_SIZE_WR(x, (HW_IPU_CSI1_ACT_FRM_SIZE_RD(x) & ~BM_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT) | BF_IPU_CSI1_ACT_FRM_SIZE_CSI1_ACT_FRM_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_OUT_FRM_CTRL - CSI1 Output Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_OUT_FRM_CTRL - CSI1 Output Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_out_frm_ctrl
{
    uint32_t U;
    struct _hw_ipu_csi1_out_frm_ctrl_bitfields
    {
        uint32_t CSI1_VSC : 12;        /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI1_HSC : 13;        /*!< [28:16]  */
        uint32_t RESERVED1 : 1;        /*!< [29]  */
        uint32_t CSI1_VERT_DWNS : 1;   /*!< [30]  */
        uint32_t CSI1_HORZ_DWNS : 1;   /*!< [31]  */
    } B;
} hw_ipu_csi1_out_frm_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_OUT_FRM_CTRL register
 */
/*@{*/
#define HW_IPU_CSI1_OUT_FRM_CTRL_ADDR(x) ((uintptr_t)(x) + 0x3800CU)

#define HW_IPU_CSI1_OUT_FRM_CTRL(x) (*(__IO hw_ipu_csi1_out_frm_ctrl_t *) HW_IPU_CSI1_OUT_FRM_CTRL_ADDR(x))
#define HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) (HW_IPU_CSI1_OUT_FRM_CTRL(x).U)
#define HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL(x).U = (v))
#define HW_IPU_CSI1_OUT_FRM_CTRL_SET(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) |  (v)))
#define HW_IPU_CSI1_OUT_FRM_CTRL_CLR(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) & ~(v)))
#define HW_IPU_CSI1_OUT_FRM_CTRL_TOG(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_OUT_FRM_CTRL bitfields
 */

/*!
 * @name Register IPU_CSI1_OUT_FRM_CTRL, field CSI1_VSC[11:0] (RW)
 *
 * Vertical skip. This field defines the number of rows to skip.
 */
/*@{*/
#define BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC (0U) /*!< Bit position for IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC. */
#define BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC (0x00000FFFU) /*!< Bit mask for IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC. */
#define BS_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC (12U) /*!< Bit field size in bits for IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC. */

/*! @brief Read current value of the IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC field. */
#define BR_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC(x) (HW_IPU_CSI1_OUT_FRM_CTRL(x).B.CSI1_VSC)

/*! @brief Format value for bitfield IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC. */
#define BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC) & BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC)

/*! @brief Set the CSI1_VSC field to a new value. */
#define BW_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC) | BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_VSC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_OUT_FRM_CTRL, field CSI1_HSC[28:16] (RW)
 *
 * Horizontal skip. This field defines the number of columns to skip. In
 * Interlaced mode this number refers to the number of lines per field
 */
/*@{*/
#define BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC (16U) /*!< Bit position for IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC. */
#define BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC (0x1FFF0000U) /*!< Bit mask for IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC. */
#define BS_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC (13U) /*!< Bit field size in bits for IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC. */

/*! @brief Read current value of the IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC field. */
#define BR_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC(x) (HW_IPU_CSI1_OUT_FRM_CTRL(x).B.CSI1_HSC)

/*! @brief Format value for bitfield IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC. */
#define BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC) & BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC)

/*! @brief Set the CSI1_HSC field to a new value. */
#define BW_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC) | BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_HSC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_OUT_FRM_CTRL, field CSI1_VERT_DWNS[30] (RW)
 *
 * Enable vertical downsizing (decimation) by 2.
 *
 * Values:
 * - 0 - Downsizing disabled
 * - 1 - Downsizing enabled
 */
/*@{*/
#define BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS (30U) /*!< Bit position for IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS. */
#define BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS (0x40000000U) /*!< Bit mask for IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS. */
#define BS_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS (1U) /*!< Bit field size in bits for IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS. */

/*! @brief Read current value of the IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS field. */
#define BR_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS(x) (HW_IPU_CSI1_OUT_FRM_CTRL(x).B.CSI1_VERT_DWNS)

/*! @brief Format value for bitfield IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS. */
#define BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS) & BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS)

/*! @brief Set the CSI1_VERT_DWNS field to a new value. */
#define BW_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS) | BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_VERT_DWNS(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_OUT_FRM_CTRL, field CSI1_HORZ_DWNS[31] (RW)
 *
 * Enable horizontal downsizing (decimation) by 2.
 *
 * Values:
 * - 0 - Downsizing disabled1 Downsizing enabled
 */
/*@{*/
#define BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS (31U) /*!< Bit position for IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS. */
#define BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS (0x80000000U) /*!< Bit mask for IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS. */
#define BS_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS (1U) /*!< Bit field size in bits for IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS. */

/*! @brief Read current value of the IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS field. */
#define BR_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS(x) (HW_IPU_CSI1_OUT_FRM_CTRL(x).B.CSI1_HORZ_DWNS)

/*! @brief Format value for bitfield IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS. */
#define BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS) & BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS)

/*! @brief Set the CSI1_HORZ_DWNS field to a new value. */
#define BW_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS(x, v) (HW_IPU_CSI1_OUT_FRM_CTRL_WR(x, (HW_IPU_CSI1_OUT_FRM_CTRL_RD(x) & ~BM_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS) | BF_IPU_CSI1_OUT_FRM_CTRL_CSI1_HORZ_DWNS(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_TST_CTRL - CSI1 Test Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_TST_CTRL - CSI1 Test Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_tst_ctrl
{
    uint32_t U;
    struct _hw_ipu_csi1_tst_ctrl_bitfields
    {
        uint32_t PG_R_VALUE : 8;       /*!< [7:0]  */
        uint32_t PG_G_VALUE : 8;       /*!< [15:8]  */
        uint32_t PG_B_VALUE : 8;       /*!< [23:16]  */
        uint32_t TEST_GEN_MODE : 1;    /*!< [24]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_tst_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_TST_CTRL register
 */
/*@{*/
#define HW_IPU_CSI1_TST_CTRL_ADDR(x) ((uintptr_t)(x) + 0x38010U)

#define HW_IPU_CSI1_TST_CTRL(x)  (*(__IO hw_ipu_csi1_tst_ctrl_t *) HW_IPU_CSI1_TST_CTRL_ADDR(x))
#define HW_IPU_CSI1_TST_CTRL_RD(x) (HW_IPU_CSI1_TST_CTRL(x).U)
#define HW_IPU_CSI1_TST_CTRL_WR(x, v) (HW_IPU_CSI1_TST_CTRL(x).U = (v))
#define HW_IPU_CSI1_TST_CTRL_SET(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, HW_IPU_CSI1_TST_CTRL_RD(x) |  (v)))
#define HW_IPU_CSI1_TST_CTRL_CLR(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, HW_IPU_CSI1_TST_CTRL_RD(x) & ~(v)))
#define HW_IPU_CSI1_TST_CTRL_TOG(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, HW_IPU_CSI1_TST_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_TST_CTRL bitfields
 */

/*!
 * @name Register IPU_CSI1_TST_CTRL, field PG_R_VALUE[7:0] (RW)
 *
 * Pattern generator R value. This field selects the R value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI1_TST_CTRL_PG_R_VALUE (0U) /*!< Bit position for IPU_CSI1_TST_CTRL_PG_R_VALUE. */
#define BM_IPU_CSI1_TST_CTRL_PG_R_VALUE (0x000000FFU) /*!< Bit mask for IPU_CSI1_TST_CTRL_PG_R_VALUE. */
#define BS_IPU_CSI1_TST_CTRL_PG_R_VALUE (8U) /*!< Bit field size in bits for IPU_CSI1_TST_CTRL_PG_R_VALUE. */

/*! @brief Read current value of the IPU_CSI1_TST_CTRL_PG_R_VALUE field. */
#define BR_IPU_CSI1_TST_CTRL_PG_R_VALUE(x) (HW_IPU_CSI1_TST_CTRL(x).B.PG_R_VALUE)

/*! @brief Format value for bitfield IPU_CSI1_TST_CTRL_PG_R_VALUE. */
#define BF_IPU_CSI1_TST_CTRL_PG_R_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_TST_CTRL_PG_R_VALUE) & BM_IPU_CSI1_TST_CTRL_PG_R_VALUE)

/*! @brief Set the PG_R_VALUE field to a new value. */
#define BW_IPU_CSI1_TST_CTRL_PG_R_VALUE(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, (HW_IPU_CSI1_TST_CTRL_RD(x) & ~BM_IPU_CSI1_TST_CTRL_PG_R_VALUE) | BF_IPU_CSI1_TST_CTRL_PG_R_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_TST_CTRL, field PG_G_VALUE[15:8] (RW)
 *
 * Pattern generator G value. This field selects the G value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI1_TST_CTRL_PG_G_VALUE (8U) /*!< Bit position for IPU_CSI1_TST_CTRL_PG_G_VALUE. */
#define BM_IPU_CSI1_TST_CTRL_PG_G_VALUE (0x0000FF00U) /*!< Bit mask for IPU_CSI1_TST_CTRL_PG_G_VALUE. */
#define BS_IPU_CSI1_TST_CTRL_PG_G_VALUE (8U) /*!< Bit field size in bits for IPU_CSI1_TST_CTRL_PG_G_VALUE. */

/*! @brief Read current value of the IPU_CSI1_TST_CTRL_PG_G_VALUE field. */
#define BR_IPU_CSI1_TST_CTRL_PG_G_VALUE(x) (HW_IPU_CSI1_TST_CTRL(x).B.PG_G_VALUE)

/*! @brief Format value for bitfield IPU_CSI1_TST_CTRL_PG_G_VALUE. */
#define BF_IPU_CSI1_TST_CTRL_PG_G_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_TST_CTRL_PG_G_VALUE) & BM_IPU_CSI1_TST_CTRL_PG_G_VALUE)

/*! @brief Set the PG_G_VALUE field to a new value. */
#define BW_IPU_CSI1_TST_CTRL_PG_G_VALUE(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, (HW_IPU_CSI1_TST_CTRL_RD(x) & ~BM_IPU_CSI1_TST_CTRL_PG_G_VALUE) | BF_IPU_CSI1_TST_CTRL_PG_G_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_TST_CTRL, field PG_B_VALUE[23:16] (RW)
 *
 * Pattern generator B value. This field selects the B value for the generated
 * pattern of even pixel.
 */
/*@{*/
#define BP_IPU_CSI1_TST_CTRL_PG_B_VALUE (16U) /*!< Bit position for IPU_CSI1_TST_CTRL_PG_B_VALUE. */
#define BM_IPU_CSI1_TST_CTRL_PG_B_VALUE (0x00FF0000U) /*!< Bit mask for IPU_CSI1_TST_CTRL_PG_B_VALUE. */
#define BS_IPU_CSI1_TST_CTRL_PG_B_VALUE (8U) /*!< Bit field size in bits for IPU_CSI1_TST_CTRL_PG_B_VALUE. */

/*! @brief Read current value of the IPU_CSI1_TST_CTRL_PG_B_VALUE field. */
#define BR_IPU_CSI1_TST_CTRL_PG_B_VALUE(x) (HW_IPU_CSI1_TST_CTRL(x).B.PG_B_VALUE)

/*! @brief Format value for bitfield IPU_CSI1_TST_CTRL_PG_B_VALUE. */
#define BF_IPU_CSI1_TST_CTRL_PG_B_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_TST_CTRL_PG_B_VALUE) & BM_IPU_CSI1_TST_CTRL_PG_B_VALUE)

/*! @brief Set the PG_B_VALUE field to a new value. */
#define BW_IPU_CSI1_TST_CTRL_PG_B_VALUE(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, (HW_IPU_CSI1_TST_CTRL_RD(x) & ~BM_IPU_CSI1_TST_CTRL_PG_B_VALUE) | BF_IPU_CSI1_TST_CTRL_PG_B_VALUE(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_TST_CTRL, field TEST_GEN_MODE[24] (RW)
 *
 * Test generator mode. This bit activates the signal generation.
 *
 * Values:
 * - 0 - Test signal generator is inactive.
 * - 1 - Test signal generator is active.
 */
/*@{*/
#define BP_IPU_CSI1_TST_CTRL_TEST_GEN_MODE (24U) /*!< Bit position for IPU_CSI1_TST_CTRL_TEST_GEN_MODE. */
#define BM_IPU_CSI1_TST_CTRL_TEST_GEN_MODE (0x01000000U) /*!< Bit mask for IPU_CSI1_TST_CTRL_TEST_GEN_MODE. */
#define BS_IPU_CSI1_TST_CTRL_TEST_GEN_MODE (1U) /*!< Bit field size in bits for IPU_CSI1_TST_CTRL_TEST_GEN_MODE. */

/*! @brief Read current value of the IPU_CSI1_TST_CTRL_TEST_GEN_MODE field. */
#define BR_IPU_CSI1_TST_CTRL_TEST_GEN_MODE(x) (HW_IPU_CSI1_TST_CTRL(x).B.TEST_GEN_MODE)

/*! @brief Format value for bitfield IPU_CSI1_TST_CTRL_TEST_GEN_MODE. */
#define BF_IPU_CSI1_TST_CTRL_TEST_GEN_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_TST_CTRL_TEST_GEN_MODE) & BM_IPU_CSI1_TST_CTRL_TEST_GEN_MODE)

/*! @brief Set the TEST_GEN_MODE field to a new value. */
#define BW_IPU_CSI1_TST_CTRL_TEST_GEN_MODE(x, v) (HW_IPU_CSI1_TST_CTRL_WR(x, (HW_IPU_CSI1_TST_CTRL_RD(x) & ~BM_IPU_CSI1_TST_CTRL_TEST_GEN_MODE) | BF_IPU_CSI1_TST_CTRL_TEST_GEN_MODE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CCIR_CODE_1 - CSI1 CCIR Code Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CCIR_CODE_1 - CSI1 CCIR Code Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_ccir_code_1
{
    uint32_t U;
    struct _hw_ipu_csi1_ccir_code_1_bitfields
    {
        uint32_t CSI1_END_FLD0_BLNK_1ST : 3; /*!< [2:0]  */
        uint32_t CSI1_STRT_FLD0_BLNK_1ST : 3; /*!< [5:3]  */
        uint32_t CSI1_END_FLD0_BLNK_2ND : 3; /*!< [8:6]  */
        uint32_t CSI1_STRT_FLD0_BLNK_2ND : 3; /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI1_END_FLD0_ACTV : 3; /*!< [18:16]  */
        uint32_t CSI1_STRT_FLD0_ACTV : 3; /*!< [21:19]  */
        uint32_t RESERVED1 : 2;        /*!< [23:22]  */
        uint32_t CSI1_CCIR_ERR_DET_EN : 1; /*!< [24]  */
        uint32_t RESERVED2 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_ccir_code_1_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CCIR_CODE_1 register
 */
/*@{*/
#define HW_IPU_CSI1_CCIR_CODE_1_ADDR(x) ((uintptr_t)(x) + 0x38014U)

#define HW_IPU_CSI1_CCIR_CODE_1(x) (*(__IO hw_ipu_csi1_ccir_code_1_t *) HW_IPU_CSI1_CCIR_CODE_1_ADDR(x))
#define HW_IPU_CSI1_CCIR_CODE_1_RD(x) (HW_IPU_CSI1_CCIR_CODE_1(x).U)
#define HW_IPU_CSI1_CCIR_CODE_1_WR(x, v) (HW_IPU_CSI1_CCIR_CODE_1(x).U = (v))
#define HW_IPU_CSI1_CCIR_CODE_1_SET(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, HW_IPU_CSI1_CCIR_CODE_1_RD(x) |  (v)))
#define HW_IPU_CSI1_CCIR_CODE_1_CLR(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~(v)))
#define HW_IPU_CSI1_CCIR_CODE_1_TOG(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, HW_IPU_CSI1_CCIR_CODE_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CCIR_CODE_1 bitfields
 */

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_END_FLD0_BLNK_1ST[2:0] (RW)
 *
 * End of field 0 first blanking line command (interlaces mode). (In progressive
 * mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST (0U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST (0x00000007U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_END_FLD0_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST)

/*! @brief Set the CSI1_END_FLD0_BLNK_1ST field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_STRT_FLD0_BLNK_1ST[5:3] (RW)
 *
 * Start of field 0 first blanking line command (interlaces mode). (In
 * progressive mode this field indicates start of blanking line command).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST (3U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST (0x00000038U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_STRT_FLD0_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST)

/*! @brief Set the CSI1_STRT_FLD0_BLNK_1ST field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_END_FLD0_BLNK_2ND[8:6] (RW)
 *
 * End of field 0 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND (6U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND (0x000001C0U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_END_FLD0_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND)

/*! @brief Set the CSI1_END_FLD0_BLNK_2ND field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_STRT_FLD0_BLNK_2ND[11:9] (RW)
 *
 * Start of field 0 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND (9U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND (0x00000E00U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_STRT_FLD0_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND)

/*! @brief Set the CSI1_STRT_FLD0_BLNK_2ND field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_END_FLD0_ACTV[18:16] (RW)
 *
 * End of field 0 active line command (interlaces mode). (In progressive mode,
 * end of active line command mode).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV (16U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV (0x00070000U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_END_FLD0_ACTV)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV)

/*! @brief Set the CSI1_END_FLD0_ACTV field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_END_FLD0_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_STRT_FLD0_ACTV[21:19] (RW)
 *
 * Start of field 0 active line command (interlaces mode). (In progressive mode,
 * start of active line command mode).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV (19U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV (0x00380000U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_STRT_FLD0_ACTV)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV)

/*! @brief Set the CSI1_STRT_FLD0_ACTV field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_STRT_FLD0_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_1, field CSI1_CCIR_ERR_DET_EN[24] (RW)
 *
 * Enable error detection and correction for CCIR interlaced mode with
 * protection bit.
 *
 * Values:
 * - 0 - Error detection and correction is disabled.
 * - 1 - Error detection and correction is enabled.
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN (24U) /*!< Bit position for IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN. */
#define BM_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN (0x01000000U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN. */
#define BS_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN (1U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN field. */
#define BR_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN(x) (HW_IPU_CSI1_CCIR_CODE_1(x).B.CSI1_CCIR_ERR_DET_EN)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN. */
#define BF_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN) & BM_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN)

/*! @brief Set the CSI1_CCIR_ERR_DET_EN field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN(x, v) (HW_IPU_CSI1_CCIR_CODE_1_WR(x, (HW_IPU_CSI1_CCIR_CODE_1_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN) | BF_IPU_CSI1_CCIR_CODE_1_CSI1_CCIR_ERR_DET_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CCIR_CODE_2 - CSI1 CCIR Code Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CCIR_CODE_2 - CSI1 CCIR Code Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_ccir_code_2
{
    uint32_t U;
    struct _hw_ipu_csi1_ccir_code_2_bitfields
    {
        uint32_t CSI1_END_FLD1_BLNK_1ST : 3; /*!< [2:0]  */
        uint32_t CSI1_STRT_FLD1_BLNK_1ST : 3; /*!< [5:3]  */
        uint32_t CSI1_END_FLD1_BLNK_2ND : 3; /*!< [8:6]  */
        uint32_t CSI1_STRT_FLD1_BLNK_2ND : 3; /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CSI1_END_FLD1_ACTV : 3; /*!< [18:16]  */
        uint32_t CSI1_STRT_FLD1_ACTV : 3; /*!< [21:19]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_ipu_csi1_ccir_code_2_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CCIR_CODE_2 register
 */
/*@{*/
#define HW_IPU_CSI1_CCIR_CODE_2_ADDR(x) ((uintptr_t)(x) + 0x38018U)

#define HW_IPU_CSI1_CCIR_CODE_2(x) (*(__IO hw_ipu_csi1_ccir_code_2_t *) HW_IPU_CSI1_CCIR_CODE_2_ADDR(x))
#define HW_IPU_CSI1_CCIR_CODE_2_RD(x) (HW_IPU_CSI1_CCIR_CODE_2(x).U)
#define HW_IPU_CSI1_CCIR_CODE_2_WR(x, v) (HW_IPU_CSI1_CCIR_CODE_2(x).U = (v))
#define HW_IPU_CSI1_CCIR_CODE_2_SET(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, HW_IPU_CSI1_CCIR_CODE_2_RD(x) |  (v)))
#define HW_IPU_CSI1_CCIR_CODE_2_CLR(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~(v)))
#define HW_IPU_CSI1_CCIR_CODE_2_TOG(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, HW_IPU_CSI1_CCIR_CODE_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CCIR_CODE_2 bitfields
 */

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_END_FLD1_BLNK_1ST[2:0] (RW)
 *
 * End of field 1 first blanking line command (interlaces mode). (In progressive
 * mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST (0U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST (0x00000007U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_END_FLD1_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST)

/*! @brief Set the CSI1_END_FLD1_BLNK_1ST field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_STRT_FLD1_BLNK_1ST[5:3] (RW)
 *
 * Start of field 1 first blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST (3U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST (0x00000038U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_STRT_FLD1_BLNK_1ST)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST)

/*! @brief Set the CSI1_STRT_FLD1_BLNK_1ST field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_1ST(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_END_FLD1_BLNK_2ND[8:6] (RW)
 *
 * End of field 1 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND (6U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND (0x000001C0U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_END_FLD1_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND)

/*! @brief Set the CSI1_END_FLD1_BLNK_2ND field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_STRT_FLD1_BLNK_2ND[11:9] (RW)
 *
 * Start of field 1 second blanking line command (interlaces mode). (In
 * progressive mode this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND (9U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND (0x00000E00U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_STRT_FLD1_BLNK_2ND)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND)

/*! @brief Set the CSI1_STRT_FLD1_BLNK_2ND field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_BLNK_2ND(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_END_FLD1_ACTV[18:16] (RW)
 *
 * End of field 1 active line command (interlaces mode). (In progressive mode
 * this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV (16U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV (0x00070000U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_END_FLD1_ACTV)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV)

/*! @brief Set the CSI1_END_FLD1_ACTV field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_END_FLD1_ACTV(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CCIR_CODE_2, field CSI1_STRT_FLD1_ACTV[21:19] (RW)
 *
 * Start of field 1 active line command (interlaces mode). (In progressive mode
 * this field is ignored).
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV (19U) /*!< Bit position for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV. */
#define BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV (0x00380000U) /*!< Bit mask for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV. */
#define BS_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV (3U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV field. */
#define BR_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV(x) (HW_IPU_CSI1_CCIR_CODE_2(x).B.CSI1_STRT_FLD1_ACTV)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV. */
#define BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV) & BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV)

/*! @brief Set the CSI1_STRT_FLD1_ACTV field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV(x, v) (HW_IPU_CSI1_CCIR_CODE_2_WR(x, (HW_IPU_CSI1_CCIR_CODE_2_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV) | BF_IPU_CSI1_CCIR_CODE_2_CSI1_STRT_FLD1_ACTV(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CCIR_CODE_3 - CSI1 CCIR Code Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CCIR_CODE_3 - CSI1 CCIR Code Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_ccir_code_3
{
    uint32_t U;
    struct _hw_ipu_csi1_ccir_code_3_bitfields
    {
        uint32_t CSI1_CCIR_PRECOM : 30; /*!< [29:0]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_csi1_ccir_code_3_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CCIR_CODE_3 register
 */
/*@{*/
#define HW_IPU_CSI1_CCIR_CODE_3_ADDR(x) ((uintptr_t)(x) + 0x3801CU)

#define HW_IPU_CSI1_CCIR_CODE_3(x) (*(__IO hw_ipu_csi1_ccir_code_3_t *) HW_IPU_CSI1_CCIR_CODE_3_ADDR(x))
#define HW_IPU_CSI1_CCIR_CODE_3_RD(x) (HW_IPU_CSI1_CCIR_CODE_3(x).U)
#define HW_IPU_CSI1_CCIR_CODE_3_WR(x, v) (HW_IPU_CSI1_CCIR_CODE_3(x).U = (v))
#define HW_IPU_CSI1_CCIR_CODE_3_SET(x, v) (HW_IPU_CSI1_CCIR_CODE_3_WR(x, HW_IPU_CSI1_CCIR_CODE_3_RD(x) |  (v)))
#define HW_IPU_CSI1_CCIR_CODE_3_CLR(x, v) (HW_IPU_CSI1_CCIR_CODE_3_WR(x, HW_IPU_CSI1_CCIR_CODE_3_RD(x) & ~(v)))
#define HW_IPU_CSI1_CCIR_CODE_3_TOG(x, v) (HW_IPU_CSI1_CCIR_CODE_3_WR(x, HW_IPU_CSI1_CCIR_CODE_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CCIR_CODE_3 bitfields
 */

/*!
 * @name Register IPU_CSI1_CCIR_CODE_3, field CSI1_CCIR_PRECOM[29:0] (RW)
 *
 * CCIR pre command. This field defines the sequence which comes before the CCIR
 * command. For BT.656 the code should be written to bits [23:0] while bits
 * [29:24] are ignored (3X8bit) For BT.1120 the code should be written to bits [29:0]
 * (3X10bit)
 */
/*@{*/
#define BP_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM (0U) /*!< Bit position for IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM. */
#define BM_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM (0x3FFFFFFFU) /*!< Bit mask for IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM. */
#define BS_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM (30U) /*!< Bit field size in bits for IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM. */

/*! @brief Read current value of the IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM field. */
#define BR_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM(x) (HW_IPU_CSI1_CCIR_CODE_3(x).B.CSI1_CCIR_PRECOM)

/*! @brief Format value for bitfield IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM. */
#define BF_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM) & BM_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM)

/*! @brief Set the CSI1_CCIR_PRECOM field to a new value. */
#define BW_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM(x, v) (HW_IPU_CSI1_CCIR_CODE_3_WR(x, (HW_IPU_CSI1_CCIR_CODE_3_RD(x) & ~BM_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM) | BF_IPU_CSI1_CCIR_CODE_3_CSI1_CCIR_PRECOM(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_DI - CSI1 Data Identifier Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_DI - CSI1 Data Identifier Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 */
typedef union _hw_ipu_csi1_di
{
    uint32_t U;
    struct _hw_ipu_csi1_di_bitfields
    {
        uint32_t CSI1_MIPI_DI0 : 8;    /*!< [7:0]  */
        uint32_t CSI0_MIPI_DI1 : 8;    /*!< [15:8]  */
        uint32_t CSI1_MIPI_DI2 : 8;    /*!< [23:16]  */
        uint32_t CSI1_MIPI_DI3 : 8;    /*!< [31:24]  */
    } B;
} hw_ipu_csi1_di_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_DI register
 */
/*@{*/
#define HW_IPU_CSI1_DI_ADDR(x)   ((uintptr_t)(x) + 0x38020U)

#define HW_IPU_CSI1_DI(x)        (*(__IO hw_ipu_csi1_di_t *) HW_IPU_CSI1_DI_ADDR(x))
#define HW_IPU_CSI1_DI_RD(x)     (HW_IPU_CSI1_DI(x).U)
#define HW_IPU_CSI1_DI_WR(x, v)  (HW_IPU_CSI1_DI(x).U = (v))
#define HW_IPU_CSI1_DI_SET(x, v) (HW_IPU_CSI1_DI_WR(x, HW_IPU_CSI1_DI_RD(x) |  (v)))
#define HW_IPU_CSI1_DI_CLR(x, v) (HW_IPU_CSI1_DI_WR(x, HW_IPU_CSI1_DI_RD(x) & ~(v)))
#define HW_IPU_CSI1_DI_TOG(x, v) (HW_IPU_CSI1_DI_WR(x, HW_IPU_CSI1_DI_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_DI bitfields
 */

/*!
 * @name Register IPU_CSI1_DI, field CSI1_MIPI_DI0[7:0] (RW)
 *
 * CSI1_MIPI_DI0 This field holds the Data Identifier #0 handled by the CSI;
 * This is the main stream.
 */
/*@{*/
#define BP_IPU_CSI1_DI_CSI1_MIPI_DI0 (0U)  /*!< Bit position for IPU_CSI1_DI_CSI1_MIPI_DI0. */
#define BM_IPU_CSI1_DI_CSI1_MIPI_DI0 (0x000000FFU) /*!< Bit mask for IPU_CSI1_DI_CSI1_MIPI_DI0. */
#define BS_IPU_CSI1_DI_CSI1_MIPI_DI0 (8U)  /*!< Bit field size in bits for IPU_CSI1_DI_CSI1_MIPI_DI0. */

/*! @brief Read current value of the IPU_CSI1_DI_CSI1_MIPI_DI0 field. */
#define BR_IPU_CSI1_DI_CSI1_MIPI_DI0(x) (HW_IPU_CSI1_DI(x).B.CSI1_MIPI_DI0)

/*! @brief Format value for bitfield IPU_CSI1_DI_CSI1_MIPI_DI0. */
#define BF_IPU_CSI1_DI_CSI1_MIPI_DI0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_DI_CSI1_MIPI_DI0) & BM_IPU_CSI1_DI_CSI1_MIPI_DI0)

/*! @brief Set the CSI1_MIPI_DI0 field to a new value. */
#define BW_IPU_CSI1_DI_CSI1_MIPI_DI0(x, v) (HW_IPU_CSI1_DI_WR(x, (HW_IPU_CSI1_DI_RD(x) & ~BM_IPU_CSI1_DI_CSI1_MIPI_DI0) | BF_IPU_CSI1_DI_CSI1_MIPI_DI0(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_DI, field CSI0_MIPI_DI1[15:8] (RW)
 *
 * CSI1_MIPI_DI1 This field holds the Data Identifier #1 handled by the CSI
 */
/*@{*/
#define BP_IPU_CSI1_DI_CSI0_MIPI_DI1 (8U)  /*!< Bit position for IPU_CSI1_DI_CSI0_MIPI_DI1. */
#define BM_IPU_CSI1_DI_CSI0_MIPI_DI1 (0x0000FF00U) /*!< Bit mask for IPU_CSI1_DI_CSI0_MIPI_DI1. */
#define BS_IPU_CSI1_DI_CSI0_MIPI_DI1 (8U)  /*!< Bit field size in bits for IPU_CSI1_DI_CSI0_MIPI_DI1. */

/*! @brief Read current value of the IPU_CSI1_DI_CSI0_MIPI_DI1 field. */
#define BR_IPU_CSI1_DI_CSI0_MIPI_DI1(x) (HW_IPU_CSI1_DI(x).B.CSI0_MIPI_DI1)

/*! @brief Format value for bitfield IPU_CSI1_DI_CSI0_MIPI_DI1. */
#define BF_IPU_CSI1_DI_CSI0_MIPI_DI1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_DI_CSI0_MIPI_DI1) & BM_IPU_CSI1_DI_CSI0_MIPI_DI1)

/*! @brief Set the CSI0_MIPI_DI1 field to a new value. */
#define BW_IPU_CSI1_DI_CSI0_MIPI_DI1(x, v) (HW_IPU_CSI1_DI_WR(x, (HW_IPU_CSI1_DI_RD(x) & ~BM_IPU_CSI1_DI_CSI0_MIPI_DI1) | BF_IPU_CSI1_DI_CSI0_MIPI_DI1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_DI, field CSI1_MIPI_DI2[23:16] (RW)
 *
 * CSI1_MIPI_DI2 This field holds the Data Identifier #2 handled by the CSI.
 */
/*@{*/
#define BP_IPU_CSI1_DI_CSI1_MIPI_DI2 (16U) /*!< Bit position for IPU_CSI1_DI_CSI1_MIPI_DI2. */
#define BM_IPU_CSI1_DI_CSI1_MIPI_DI2 (0x00FF0000U) /*!< Bit mask for IPU_CSI1_DI_CSI1_MIPI_DI2. */
#define BS_IPU_CSI1_DI_CSI1_MIPI_DI2 (8U)  /*!< Bit field size in bits for IPU_CSI1_DI_CSI1_MIPI_DI2. */

/*! @brief Read current value of the IPU_CSI1_DI_CSI1_MIPI_DI2 field. */
#define BR_IPU_CSI1_DI_CSI1_MIPI_DI2(x) (HW_IPU_CSI1_DI(x).B.CSI1_MIPI_DI2)

/*! @brief Format value for bitfield IPU_CSI1_DI_CSI1_MIPI_DI2. */
#define BF_IPU_CSI1_DI_CSI1_MIPI_DI2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_DI_CSI1_MIPI_DI2) & BM_IPU_CSI1_DI_CSI1_MIPI_DI2)

/*! @brief Set the CSI1_MIPI_DI2 field to a new value. */
#define BW_IPU_CSI1_DI_CSI1_MIPI_DI2(x, v) (HW_IPU_CSI1_DI_WR(x, (HW_IPU_CSI1_DI_RD(x) & ~BM_IPU_CSI1_DI_CSI1_MIPI_DI2) | BF_IPU_CSI1_DI_CSI1_MIPI_DI2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_DI, field CSI1_MIPI_DI3[31:24] (RW)
 *
 * CSI1_MIPI_DI3 This field holds the Data Identifier #3 handled by the CSI.
 */
/*@{*/
#define BP_IPU_CSI1_DI_CSI1_MIPI_DI3 (24U) /*!< Bit position for IPU_CSI1_DI_CSI1_MIPI_DI3. */
#define BM_IPU_CSI1_DI_CSI1_MIPI_DI3 (0xFF000000U) /*!< Bit mask for IPU_CSI1_DI_CSI1_MIPI_DI3. */
#define BS_IPU_CSI1_DI_CSI1_MIPI_DI3 (8U)  /*!< Bit field size in bits for IPU_CSI1_DI_CSI1_MIPI_DI3. */

/*! @brief Read current value of the IPU_CSI1_DI_CSI1_MIPI_DI3 field. */
#define BR_IPU_CSI1_DI_CSI1_MIPI_DI3(x) (HW_IPU_CSI1_DI(x).B.CSI1_MIPI_DI3)

/*! @brief Format value for bitfield IPU_CSI1_DI_CSI1_MIPI_DI3. */
#define BF_IPU_CSI1_DI_CSI1_MIPI_DI3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_DI_CSI1_MIPI_DI3) & BM_IPU_CSI1_DI_CSI1_MIPI_DI3)

/*! @brief Set the CSI1_MIPI_DI3 field to a new value. */
#define BW_IPU_CSI1_DI_CSI1_MIPI_DI3(x, v) (HW_IPU_CSI1_DI_WR(x, (HW_IPU_CSI1_DI_RD(x) & ~BM_IPU_CSI1_DI_CSI1_MIPI_DI3) | BF_IPU_CSI1_DI_CSI1_MIPI_DI3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_SKIP - CSI1 SKIP Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_SKIP - CSI1 SKIP Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register control the frame skipping supported between CSI1 and the SMFC.
 */
typedef union _hw_ipu_csi1_skip
{
    uint32_t U;
    struct _hw_ipu_csi1_skip_bitfields
    {
        uint32_t CSI1_MAX_RATIO_SKIP_SMFC : 3; /*!< [2:0]  */
        uint32_t CSI1_SKIP_SMFC : 5;   /*!< [7:3]  */
        uint32_t CSI1_ID_2_SKIP : 2;   /*!< [9:8]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_csi1_skip_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_SKIP register
 */
/*@{*/
#define HW_IPU_CSI1_SKIP_ADDR(x) ((uintptr_t)(x) + 0x38024U)

#define HW_IPU_CSI1_SKIP(x)      (*(__IO hw_ipu_csi1_skip_t *) HW_IPU_CSI1_SKIP_ADDR(x))
#define HW_IPU_CSI1_SKIP_RD(x)   (HW_IPU_CSI1_SKIP(x).U)
#define HW_IPU_CSI1_SKIP_WR(x, v) (HW_IPU_CSI1_SKIP(x).U = (v))
#define HW_IPU_CSI1_SKIP_SET(x, v) (HW_IPU_CSI1_SKIP_WR(x, HW_IPU_CSI1_SKIP_RD(x) |  (v)))
#define HW_IPU_CSI1_SKIP_CLR(x, v) (HW_IPU_CSI1_SKIP_WR(x, HW_IPU_CSI1_SKIP_RD(x) & ~(v)))
#define HW_IPU_CSI1_SKIP_TOG(x, v) (HW_IPU_CSI1_SKIP_WR(x, HW_IPU_CSI1_SKIP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_SKIP bitfields
 */

/*!
 * @name Register IPU_CSI1_SKIP, field CSI1_MAX_RATIO_SKIP_SMFC[2:0] (RW)
 *
 * CSI1 Maximum Ratio Skip for SMFC These bits define the number of frames in a
 * skipping set. These bits define the number of frames in a skipping set. The
 * skipping number is equal to CSI1_MAX_RATIO_SKIP_SMFC+1; The maximum value of
 * this bits is 5. When set to 0 the skipping is disabled.
 */
/*@{*/
#define BP_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC (0U) /*!< Bit position for IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC. */
#define BM_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC (0x00000007U) /*!< Bit mask for IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC. */
#define BS_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC (3U) /*!< Bit field size in bits for IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC. */

/*! @brief Read current value of the IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC field. */
#define BR_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC(x) (HW_IPU_CSI1_SKIP(x).B.CSI1_MAX_RATIO_SKIP_SMFC)

/*! @brief Format value for bitfield IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC. */
#define BF_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC) & BM_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC)

/*! @brief Set the CSI1_MAX_RATIO_SKIP_SMFC field to a new value. */
#define BW_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC(x, v) (HW_IPU_CSI1_SKIP_WR(x, (HW_IPU_CSI1_SKIP_RD(x) & ~BM_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC) | BF_IPU_CSI1_SKIP_CSI1_MAX_RATIO_SKIP_SMFC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SKIP, field CSI1_SKIP_SMFC[7:3] (RW)
 *
 * CSI1 SKIP SMFC These 5 bits define the skipping pattern of the frames send to
 * the SMFC. Skipping is done for a set of frames. The number of frames in a set
 * is defined at CSI1_MAX_RATIO_SKIP_SMFC. when CSI1_MAX_RATIO_SKIP_SMFC = 1 =>
 * CSI1_SKIP_SMFC[0] is used; other bits are ignored when
 * CSI1_MAX_RATIO_SKIP_SMFC = 2 => CSI1_SKIP_SMFC[1:0] are used; other bits are ignored when
 * CSI1_MAX_RATIO_SKIP_SMFC = 3 => CSI1_SKIP_SMFC[2:0] are used; other bits are ignored when
 * CSI1_MAX_RATIO_SKIP_SMFC = 4 => CSI1_SKIP_SMFC[3:0] are used; other bits are
 * ignored when CSI1_MAX_RATIO_SKIP_SMFC = 5 => CSI1_SKIP_SMFC[4:0] are used;
 * Setting bit #n of CSI1_SKIP_SMFC means that the #n frame in the set is skipped.
 * For example: if CSI1_MAX_RATIO_SKIP_SMFC = 4 and CSI1_SKIP_SMFC = 11010 Frames
 * #0 & Frame #2 will not be skipped as bit0 and bit2 are cleared Frames #1 &
 * Frame #3 will be skipped as bit1 and bit3 are set bit #4 is ignored as
 * CSI1_MAX_RATIO_SKIP_SMFC is set to 4
 */
/*@{*/
#define BP_IPU_CSI1_SKIP_CSI1_SKIP_SMFC (3U) /*!< Bit position for IPU_CSI1_SKIP_CSI1_SKIP_SMFC. */
#define BM_IPU_CSI1_SKIP_CSI1_SKIP_SMFC (0x000000F8U) /*!< Bit mask for IPU_CSI1_SKIP_CSI1_SKIP_SMFC. */
#define BS_IPU_CSI1_SKIP_CSI1_SKIP_SMFC (5U) /*!< Bit field size in bits for IPU_CSI1_SKIP_CSI1_SKIP_SMFC. */

/*! @brief Read current value of the IPU_CSI1_SKIP_CSI1_SKIP_SMFC field. */
#define BR_IPU_CSI1_SKIP_CSI1_SKIP_SMFC(x) (HW_IPU_CSI1_SKIP(x).B.CSI1_SKIP_SMFC)

/*! @brief Format value for bitfield IPU_CSI1_SKIP_CSI1_SKIP_SMFC. */
#define BF_IPU_CSI1_SKIP_CSI1_SKIP_SMFC(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SKIP_CSI1_SKIP_SMFC) & BM_IPU_CSI1_SKIP_CSI1_SKIP_SMFC)

/*! @brief Set the CSI1_SKIP_SMFC field to a new value. */
#define BW_IPU_CSI1_SKIP_CSI1_SKIP_SMFC(x, v) (HW_IPU_CSI1_SKIP_WR(x, (HW_IPU_CSI1_SKIP_RD(x) & ~BM_IPU_CSI1_SKIP_CSI1_SKIP_SMFC) | BF_IPU_CSI1_SKIP_CSI1_SKIP_SMFC(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_SKIP, field CSI1_ID_2_SKIP[9:8] (RW)
 *
 * CSI1 to SMFC Skipping ID. Data from the CSI1 to the SMFC has an ID associated
 * with it. The ID is received from the MIPI interface. The skipping mechanism
 * between the CSI1 and the SMFC can be used for only one ID. There is no skipping
 * for data coming with ID different from the ID programed in this bits
 *
 * Values:
 * - 00 - - Skipping mechanism is activated on frames with ID equal to 00
 * - 01 - - Skipping mechanism is activated on frames with ID equal to 01
 * - 10 - - Skipping mechanism is activated on frames with ID equal to 10
 * - 11 - - Skipping mechanism is activated on frames with ID equal to 11
 */
/*@{*/
#define BP_IPU_CSI1_SKIP_CSI1_ID_2_SKIP (8U) /*!< Bit position for IPU_CSI1_SKIP_CSI1_ID_2_SKIP. */
#define BM_IPU_CSI1_SKIP_CSI1_ID_2_SKIP (0x00000300U) /*!< Bit mask for IPU_CSI1_SKIP_CSI1_ID_2_SKIP. */
#define BS_IPU_CSI1_SKIP_CSI1_ID_2_SKIP (2U) /*!< Bit field size in bits for IPU_CSI1_SKIP_CSI1_ID_2_SKIP. */

/*! @brief Read current value of the IPU_CSI1_SKIP_CSI1_ID_2_SKIP field. */
#define BR_IPU_CSI1_SKIP_CSI1_ID_2_SKIP(x) (HW_IPU_CSI1_SKIP(x).B.CSI1_ID_2_SKIP)

/*! @brief Format value for bitfield IPU_CSI1_SKIP_CSI1_ID_2_SKIP. */
#define BF_IPU_CSI1_SKIP_CSI1_ID_2_SKIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_SKIP_CSI1_ID_2_SKIP) & BM_IPU_CSI1_SKIP_CSI1_ID_2_SKIP)

/*! @brief Set the CSI1_ID_2_SKIP field to a new value. */
#define BW_IPU_CSI1_SKIP_CSI1_ID_2_SKIP(x, v) (HW_IPU_CSI1_SKIP_WR(x, (HW_IPU_CSI1_SKIP_RD(x) & ~BM_IPU_CSI1_SKIP_CSI1_ID_2_SKIP) | BF_IPU_CSI1_SKIP_CSI1_ID_2_SKIP(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_CTRL - CSI1 Compander Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_CTRL - CSI1 Compander Control Register (ROZ)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_csi1_cpd_ctrl
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_ctrl_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_ipu_csi1_cpd_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_CTRL register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_CTRL_ADDR(x) ((uintptr_t)(x) + 0x38028U)

#define HW_IPU_CSI1_CPD_CTRL(x)  (*(__I hw_ipu_csi1_cpd_ctrl_t *) HW_IPU_CSI1_CPD_CTRL_ADDR(x))
#define HW_IPU_CSI1_CPD_CTRL_RD(x) (HW_IPU_CSI1_CPD_CTRL(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_CTRL bitfields
 */

/*******************************************************************************
 * HW_IPU_CSI1_CPD_RC_i - CSI1 Red Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_RC_i - CSI1 Red Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANT <i> parameters used for companding of red
 * component.
 */
typedef union _hw_ipu_csi1_cpd_rc_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_rc_i_bitfields
    {
        uint32_t CSI1_CPD_RC_2i : 9;   /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI1_CPD_RC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_cpd_rc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_RC_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_RC_i_ADDR(x) ((uintptr_t)(x) + 0x3802CU)

#define HW_IPU_CSI1_CPD_RC_i(x)  (*(__IO hw_ipu_csi1_cpd_rc_i_t *) HW_IPU_CSI1_CPD_RC_i_ADDR(x))
#define HW_IPU_CSI1_CPD_RC_i_RD(x) (HW_IPU_CSI1_CPD_RC_i(x).U)
#define HW_IPU_CSI1_CPD_RC_i_WR(x, v) (HW_IPU_CSI1_CPD_RC_i(x).U = (v))
#define HW_IPU_CSI1_CPD_RC_i_SET(x, v) (HW_IPU_CSI1_CPD_RC_i_WR(x, HW_IPU_CSI1_CPD_RC_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_RC_i_CLR(x, v) (HW_IPU_CSI1_CPD_RC_i_WR(x, HW_IPU_CSI1_CPD_RC_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_RC_i_TOG(x, v) (HW_IPU_CSI1_CPD_RC_i_WR(x, HW_IPU_CSI1_CPD_RC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_RC_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_RC_i, field CSI1_CPD_RC_2i[8:0] (RW)
 *
 * CONSTANT <2*i> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i (0U) /*!< Bit position for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i. */
#define BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i (0x000001FFU) /*!< Bit mask for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i. */
#define BS_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i. */

/*! @brief Read current value of the IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i field. */
#define BR_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i(x) (HW_IPU_CSI1_CPD_RC_i(x).B.CSI1_CPD_RC_2i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i. */
#define BF_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i) & BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i)

/*! @brief Set the CSI1_CPD_RC_2i field to a new value. */
#define BW_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i(x, v) (HW_IPU_CSI1_CPD_RC_i_WR(x, (HW_IPU_CSI1_CPD_RC_i_RD(x) & ~BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i) | BF_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_RC_i, field CSI1_CPD_RC_2i_1[24:16] (RW)
 *
 * CONSTANT <2*i+1> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1 (16U) /*!< Bit position for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1. */
#define BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1. */
#define BS_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1 field. */
#define BR_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1(x) (HW_IPU_CSI1_CPD_RC_i(x).B.CSI1_CPD_RC_2i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1. */
#define BF_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1) & BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1)

/*! @brief Set the CSI1_CPD_RC_2i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1(x, v) (HW_IPU_CSI1_CPD_RC_i_WR(x, (HW_IPU_CSI1_CPD_RC_i_RD(x) & ~BM_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1) | BF_IPU_CSI1_CPD_RC_i_CSI1_CPD_RC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_RS_i - CSI1 Red Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_RS_i - CSI1 Red Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPE <i> parameters used for companding of red
 * component.
 */
typedef union _hw_ipu_csi1_cpd_rs_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_rs_i_bitfields
    {
        uint32_t CSI1_CPD_RS_4i : 8;   /*!< [7:0]  */
        uint32_t CSI1_CPD_RS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI1_CPD_RS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI1_CPD_RS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csi1_cpd_rs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_RS_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_RS_i_ADDR(x) ((uintptr_t)(x) + 0x3804CU)

#define HW_IPU_CSI1_CPD_RS_i(x)  (*(__IO hw_ipu_csi1_cpd_rs_i_t *) HW_IPU_CSI1_CPD_RS_i_ADDR(x))
#define HW_IPU_CSI1_CPD_RS_i_RD(x) (HW_IPU_CSI1_CPD_RS_i(x).U)
#define HW_IPU_CSI1_CPD_RS_i_WR(x, v) (HW_IPU_CSI1_CPD_RS_i(x).U = (v))
#define HW_IPU_CSI1_CPD_RS_i_SET(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, HW_IPU_CSI1_CPD_RS_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_RS_i_CLR(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, HW_IPU_CSI1_CPD_RS_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_RS_i_TOG(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, HW_IPU_CSI1_CPD_RS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_RS_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_RS_i, field CSI1_CPD_RS_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i (0U) /*!< Bit position for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i. */
#define BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i (0x000000FFU) /*!< Bit mask for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i. */
#define BS_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i. */

/*! @brief Read current value of the IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i field. */
#define BR_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i(x) (HW_IPU_CSI1_CPD_RS_i(x).B.CSI1_CPD_RS_4i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i. */
#define BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i) & BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i)

/*! @brief Set the CSI1_CPD_RS_4i field to a new value. */
#define BW_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, (HW_IPU_CSI1_CPD_RS_i_RD(x) & ~BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i) | BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_RS_i, field CSI1_CPD_RS_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1 (8U) /*!< Bit position for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1. */
#define BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1. */
#define BS_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1 field. */
#define BR_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1(x) (HW_IPU_CSI1_CPD_RS_i(x).B.CSI1_CPD_RS_4i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1. */
#define BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1) & BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1)

/*! @brief Set the CSI1_CPD_RS_4i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, (HW_IPU_CSI1_CPD_RS_i_RD(x) & ~BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1) | BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_RS_i, field CSI1_CPD_RS_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2 (16U) /*!< Bit position for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2. */
#define BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2. */
#define BS_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2. */

/*! @brief Read current value of the IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2 field. */
#define BR_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2(x) (HW_IPU_CSI1_CPD_RS_i(x).B.CSI1_CPD_RS_4i_2)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2. */
#define BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2) & BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2)

/*! @brief Set the CSI1_CPD_RS_4i_2 field to a new value. */
#define BW_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, (HW_IPU_CSI1_CPD_RS_i_RD(x) & ~BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2) | BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_RS_i, field CSI1_CPD_RS_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Compander, Red component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3 (24U) /*!< Bit position for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3. */
#define BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3. */
#define BS_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3. */

/*! @brief Read current value of the IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3 field. */
#define BR_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3(x) (HW_IPU_CSI1_CPD_RS_i(x).B.CSI1_CPD_RS_4i_3)

/*! @brief Format value for bitfield IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3. */
#define BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3) & BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3)

/*! @brief Set the CSI1_CPD_RS_4i_3 field to a new value. */
#define BW_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3(x, v) (HW_IPU_CSI1_CPD_RS_i_WR(x, (HW_IPU_CSI1_CPD_RS_i_RD(x) & ~BM_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3) | BF_IPU_CSI1_CPD_RS_i_CSI1_CPD_RS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_GRC_i - CSI1 GR Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_GRC_i - CSI1 GR Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANTi parameters used for companding of green
 * components in GRGR rows.
 */
typedef union _hw_ipu_csi1_cpd_grc_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_grc_i_bitfields
    {
        uint32_t CSI1_CPD_GRC_2i : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI1_CPD_GRC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_cpd_grc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_GRC_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_GRC_i_ADDR(x) ((uintptr_t)(x) + 0x3805CU)

#define HW_IPU_CSI1_CPD_GRC_i(x) (*(__IO hw_ipu_csi1_cpd_grc_i_t *) HW_IPU_CSI1_CPD_GRC_i_ADDR(x))
#define HW_IPU_CSI1_CPD_GRC_i_RD(x) (HW_IPU_CSI1_CPD_GRC_i(x).U)
#define HW_IPU_CSI1_CPD_GRC_i_WR(x, v) (HW_IPU_CSI1_CPD_GRC_i(x).U = (v))
#define HW_IPU_CSI1_CPD_GRC_i_SET(x, v) (HW_IPU_CSI1_CPD_GRC_i_WR(x, HW_IPU_CSI1_CPD_GRC_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_GRC_i_CLR(x, v) (HW_IPU_CSI1_CPD_GRC_i_WR(x, HW_IPU_CSI1_CPD_GRC_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_GRC_i_TOG(x, v) (HW_IPU_CSI1_CPD_GRC_i_WR(x, HW_IPU_CSI1_CPD_GRC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_GRC_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_GRC_i, field CSI1_CPD_GRC_2i[8:0] (RW)
 *
 * CONSTANT<2*i> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRC should be equal to CSI1_CPD_GBC Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i (0U) /*!< Bit position for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i. */
#define BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i (0x000001FFU) /*!< Bit mask for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i. */
#define BS_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i field. */
#define BR_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i(x) (HW_IPU_CSI1_CPD_GRC_i(x).B.CSI1_CPD_GRC_2i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i. */
#define BF_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i) & BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i)

/*! @brief Set the CSI1_CPD_GRC_2i field to a new value. */
#define BW_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i(x, v) (HW_IPU_CSI1_CPD_GRC_i_WR(x, (HW_IPU_CSI1_CPD_GRC_i_RD(x) & ~BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i) | BF_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GRC_i, field CSI1_CPD_GRC_2i_1[24:16] (RW)
 *
 * CONST<2*i+1> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRC should be equal to CSI1_CPD_GBC Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1 (16U) /*!< Bit position for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1. */
#define BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1. */
#define BS_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1 field. */
#define BR_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1(x) (HW_IPU_CSI1_CPD_GRC_i(x).B.CSI1_CPD_GRC_2i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1. */
#define BF_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1) & BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1)

/*! @brief Set the CSI1_CPD_GRC_2i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1(x, v) (HW_IPU_CSI1_CPD_GRC_i_WR(x, (HW_IPU_CSI1_CPD_GRC_i_RD(x) & ~BM_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1) | BF_IPU_CSI1_CPD_GRC_i_CSI1_CPD_GRC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_GRS_i - CSI1 GR Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_GRS_i - CSI1 GR Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPEi parameters used for companding of green
 * components in GRGR rows.
 */
typedef union _hw_ipu_csi1_cpd_grs_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_grs_i_bitfields
    {
        uint32_t CSI1_CPD_GRS_4i : 8;  /*!< [7:0]  */
        uint32_t CSI1_CPD_GRS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI1_CPD_GRS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI1_CPD_GRS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csi1_cpd_grs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_GRS_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_GRS_i_ADDR(x) ((uintptr_t)(x) + 0x3807CU)

#define HW_IPU_CSI1_CPD_GRS_i(x) (*(__IO hw_ipu_csi1_cpd_grs_i_t *) HW_IPU_CSI1_CPD_GRS_i_ADDR(x))
#define HW_IPU_CSI1_CPD_GRS_i_RD(x) (HW_IPU_CSI1_CPD_GRS_i(x).U)
#define HW_IPU_CSI1_CPD_GRS_i_WR(x, v) (HW_IPU_CSI1_CPD_GRS_i(x).U = (v))
#define HW_IPU_CSI1_CPD_GRS_i_SET(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, HW_IPU_CSI1_CPD_GRS_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_GRS_i_CLR(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, HW_IPU_CSI1_CPD_GRS_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_GRS_i_TOG(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, HW_IPU_CSI1_CPD_GRS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_GRS_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_GRS_i, field CSI1_CPD_GRS_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRS should be equal to CSI1_CPD_GBS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i (0U) /*!< Bit position for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i. */
#define BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i (0x000000FFU) /*!< Bit mask for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i. */
#define BS_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i field. */
#define BR_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i(x) (HW_IPU_CSI1_CPD_GRS_i(x).B.CSI1_CPD_GRS_4i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i. */
#define BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i) & BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i)

/*! @brief Set the CSI1_CPD_GRS_4i field to a new value. */
#define BW_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, (HW_IPU_CSI1_CPD_GRS_i_RD(x) & ~BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i) | BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GRS_i, field CSI1_CPD_GRS_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRS should be equal to CSI1_CPD_GBS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1 (8U) /*!< Bit position for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1. */
#define BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1. */
#define BS_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1 field. */
#define BR_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1(x) (HW_IPU_CSI1_CPD_GRS_i(x).B.CSI1_CPD_GRS_4i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1. */
#define BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1) & BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1)

/*! @brief Set the CSI1_CPD_GRS_4i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, (HW_IPU_CSI1_CPD_GRS_i_RD(x) & ~BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1) | BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GRS_i, field CSI1_CPD_GRS_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRS should be equal to CSI1_CPD_GBS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2 (16U) /*!< Bit position for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2. */
#define BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2. */
#define BS_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2 field. */
#define BR_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2(x) (HW_IPU_CSI1_CPD_GRS_i(x).B.CSI1_CPD_GRS_4i_2)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2. */
#define BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2) & BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2)

/*! @brief Set the CSI1_CPD_GRS_4i_2 field to a new value. */
#define BW_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, (HW_IPU_CSI1_CPD_GRS_i_RD(x) & ~BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2) | BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GRS_i, field CSI1_CPD_GRS_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Compander, GR component. If the input format is
 * RGB/YUV then CSI1_CPD_GRS should be equal to CSI1_CPD_GBS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3 (24U) /*!< Bit position for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3. */
#define BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3. */
#define BS_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3. */

/*! @brief Read current value of the IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3 field. */
#define BR_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3(x) (HW_IPU_CSI1_CPD_GRS_i(x).B.CSI1_CPD_GRS_4i_3)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3. */
#define BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3) & BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3)

/*! @brief Set the CSI1_CPD_GRS_4i_3 field to a new value. */
#define BW_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3(x, v) (HW_IPU_CSI1_CPD_GRS_i_WR(x, (HW_IPU_CSI1_CPD_GRS_i_RD(x) & ~BM_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3) | BF_IPU_CSI1_CPD_GRS_i_CSI1_CPD_GRS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_GBC_i - CSI1 GB Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_GBC_i - CSI1 GB Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain CONSTANTi parameters used for companding of green
 * components in GBGB rows.
 */
typedef union _hw_ipu_csi1_cpd_gbc_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_gbc_i_bitfields
    {
        uint32_t CSI1_CPD_GBC_2i : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI1_CPD_GBC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_cpd_gbc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_GBC_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_GBC_i_ADDR(x) ((uintptr_t)(x) + 0x3808CU)

#define HW_IPU_CSI1_CPD_GBC_i(x) (*(__IO hw_ipu_csi1_cpd_gbc_i_t *) HW_IPU_CSI1_CPD_GBC_i_ADDR(x))
#define HW_IPU_CSI1_CPD_GBC_i_RD(x) (HW_IPU_CSI1_CPD_GBC_i(x).U)
#define HW_IPU_CSI1_CPD_GBC_i_WR(x, v) (HW_IPU_CSI1_CPD_GBC_i(x).U = (v))
#define HW_IPU_CSI1_CPD_GBC_i_SET(x, v) (HW_IPU_CSI1_CPD_GBC_i_WR(x, HW_IPU_CSI1_CPD_GBC_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_GBC_i_CLR(x, v) (HW_IPU_CSI1_CPD_GBC_i_WR(x, HW_IPU_CSI1_CPD_GBC_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_GBC_i_TOG(x, v) (HW_IPU_CSI1_CPD_GBC_i_WR(x, HW_IPU_CSI1_CPD_GBC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_GBC_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_GBC_i, field CSI1_CPD_GBC_2i[8:0] (RW)
 *
 * CONSTANTi parameter of Compander, GB component. If the input format is
 * RGB/YUV then CSI1_CPD_GBC should be equal to CSI1_CPD_GRC Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i (0U) /*!< Bit position for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i. */
#define BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i (0x000001FFU) /*!< Bit mask for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i. */
#define BS_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i field. */
#define BR_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i(x) (HW_IPU_CSI1_CPD_GBC_i(x).B.CSI1_CPD_GBC_2i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i. */
#define BF_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i) & BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i)

/*! @brief Set the CSI1_CPD_GBC_2i field to a new value. */
#define BW_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i(x, v) (HW_IPU_CSI1_CPD_GBC_i_WR(x, (HW_IPU_CSI1_CPD_GBC_i_RD(x) & ~BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i) | BF_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GBC_i, field CSI1_CPD_GBC_2i_1[24:16] (RW)
 *
 * CONSTi+1 parameter of Compander, GB component. If the input format is RGB/YUV
 * then CSI1_CPD_GBC should be equal to CSI1_CPD_GRC Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1 (16U) /*!< Bit position for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1. */
#define BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1. */
#define BS_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1 field. */
#define BR_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1(x) (HW_IPU_CSI1_CPD_GBC_i(x).B.CSI1_CPD_GBC_2i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1. */
#define BF_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1) & BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1)

/*! @brief Set the CSI1_CPD_GBC_2i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1(x, v) (HW_IPU_CSI1_CPD_GBC_i_WR(x, (HW_IPU_CSI1_CPD_GBC_i_RD(x) & ~BM_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1) | BF_IPU_CSI1_CPD_GBC_i_CSI1_CPD_GBC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_GBS_i - CSI1 GB Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_GBS_i - CSI1 GB Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain SLOPEi parameters used for companding of green
 * components in GBGB rows.
 */
typedef union _hw_ipu_csi1_cpd_gbs_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_gbs_i_bitfields
    {
        uint32_t CSI1_CPD_GBS_4i : 8;  /*!< [7:0]  */
        uint32_t CSI1_CPD_GBS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI1_CPD_GBS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI1_CPD_GBS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csi1_cpd_gbs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_GBS_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_GBS_i_ADDR(x) ((uintptr_t)(x) + 0x380ACU)

#define HW_IPU_CSI1_CPD_GBS_i(x) (*(__IO hw_ipu_csi1_cpd_gbs_i_t *) HW_IPU_CSI1_CPD_GBS_i_ADDR(x))
#define HW_IPU_CSI1_CPD_GBS_i_RD(x) (HW_IPU_CSI1_CPD_GBS_i(x).U)
#define HW_IPU_CSI1_CPD_GBS_i_WR(x, v) (HW_IPU_CSI1_CPD_GBS_i(x).U = (v))
#define HW_IPU_CSI1_CPD_GBS_i_SET(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, HW_IPU_CSI1_CPD_GBS_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_GBS_i_CLR(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, HW_IPU_CSI1_CPD_GBS_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_GBS_i_TOG(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, HW_IPU_CSI1_CPD_GBS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_GBS_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_GBS_i, field CSI1_CPD_GBS_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Compander, GB component. If the input format is
 * RGB/YUV then CSI1_CPD_GBS should be equal to CSI1_CPD_GRS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i (0U) /*!< Bit position for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i. */
#define BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i (0x000000FFU) /*!< Bit mask for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i. */
#define BS_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i field. */
#define BR_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i(x) (HW_IPU_CSI1_CPD_GBS_i(x).B.CSI1_CPD_GBS_4i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i. */
#define BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i) & BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i)

/*! @brief Set the CSI1_CPD_GBS_4i field to a new value. */
#define BW_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, (HW_IPU_CSI1_CPD_GBS_i_RD(x) & ~BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i) | BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GBS_i, field CSI1_CPD_GBS_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Compander, GB component. If the input format is
 * RGB/YUV then CSI1_CPD_GBS should be equal to CSI1_CPD_GRS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1 (8U) /*!< Bit position for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1. */
#define BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1. */
#define BS_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1 field. */
#define BR_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1(x) (HW_IPU_CSI1_CPD_GBS_i(x).B.CSI1_CPD_GBS_4i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1. */
#define BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1) & BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1)

/*! @brief Set the CSI1_CPD_GBS_4i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, (HW_IPU_CSI1_CPD_GBS_i_RD(x) & ~BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1) | BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GBS_i, field CSI1_CPD_GBS_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Compander, GB component. If the input format is
 * RGB/YUV then CSI1_CPD_GBS should be equal to CSI1_CPD_GRS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2 (16U) /*!< Bit position for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2. */
#define BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2. */
#define BS_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2 field. */
#define BR_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2(x) (HW_IPU_CSI1_CPD_GBS_i(x).B.CSI1_CPD_GBS_4i_2)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2. */
#define BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2) & BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2)

/*! @brief Set the CSI1_CPD_GBS_4i_2 field to a new value. */
#define BW_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, (HW_IPU_CSI1_CPD_GBS_i_RD(x) & ~BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2) | BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_GBS_i, field CSI1_CPD_GBS_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Compander, GB component. If the input format is
 * RGB/YUV then CSI1_CPD_GBS should be equal to CSI1_CPD_GRS Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3 (24U) /*!< Bit position for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3. */
#define BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3. */
#define BS_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3. */

/*! @brief Read current value of the IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3 field. */
#define BR_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3(x) (HW_IPU_CSI1_CPD_GBS_i(x).B.CSI1_CPD_GBS_4i_3)

/*! @brief Format value for bitfield IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3. */
#define BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3) & BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3)

/*! @brief Set the CSI1_CPD_GBS_4i_3 field to a new value. */
#define BW_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3(x, v) (HW_IPU_CSI1_CPD_GBS_i_WR(x, (HW_IPU_CSI1_CPD_GBS_i_RD(x) & ~BM_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3) | BF_IPU_CSI1_CPD_GBS_i_CSI1_CPD_GBS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_BC_i - CSI1 Blue Component Compander Constants Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_BC_i - CSI1 Blue Component Compander Constants Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contend CONSTANTi parameters used for companding of blue
 * component.
 */
typedef union _hw_ipu_csi1_cpd_bc_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_bc_i_bitfields
    {
        uint32_t CSI1_CPD_BC_2i : 9;   /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t CSI1_CPD_BC_2i_1 : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_csi1_cpd_bc_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_BC_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_BC_i_ADDR(x) ((uintptr_t)(x) + 0x380BCU)

#define HW_IPU_CSI1_CPD_BC_i(x)  (*(__IO hw_ipu_csi1_cpd_bc_i_t *) HW_IPU_CSI1_CPD_BC_i_ADDR(x))
#define HW_IPU_CSI1_CPD_BC_i_RD(x) (HW_IPU_CSI1_CPD_BC_i(x).U)
#define HW_IPU_CSI1_CPD_BC_i_WR(x, v) (HW_IPU_CSI1_CPD_BC_i(x).U = (v))
#define HW_IPU_CSI1_CPD_BC_i_SET(x, v) (HW_IPU_CSI1_CPD_BC_i_WR(x, HW_IPU_CSI1_CPD_BC_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_BC_i_CLR(x, v) (HW_IPU_CSI1_CPD_BC_i_WR(x, HW_IPU_CSI1_CPD_BC_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_BC_i_TOG(x, v) (HW_IPU_CSI1_CPD_BC_i_WR(x, HW_IPU_CSI1_CPD_BC_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_BC_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_BC_i, field CSI1_CPD_BC_2i[8:0] (RW)
 *
 * CONSTANT<2*i> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i (0U) /*!< Bit position for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i. */
#define BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i (0x000001FFU) /*!< Bit mask for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i. */
#define BS_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i. */

/*! @brief Read current value of the IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i field. */
#define BR_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i(x) (HW_IPU_CSI1_CPD_BC_i(x).B.CSI1_CPD_BC_2i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i. */
#define BF_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i) & BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i)

/*! @brief Set the CSI1_CPD_BC_2i field to a new value. */
#define BW_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i(x, v) (HW_IPU_CSI1_CPD_BC_i_WR(x, (HW_IPU_CSI1_CPD_BC_i_RD(x) & ~BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i) | BF_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_BC_i, field CSI1_CPD_BC_2i_1[24:16] (RW)
 *
 * CONSTANT<2*i+1> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1 (16U) /*!< Bit position for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1. */
#define BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1 (0x01FF0000U) /*!< Bit mask for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1. */
#define BS_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1 (9U) /*!< Bit field size in bits for IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1 field. */
#define BR_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1(x) (HW_IPU_CSI1_CPD_BC_i(x).B.CSI1_CPD_BC_2i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1. */
#define BF_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1) & BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1)

/*! @brief Set the CSI1_CPD_BC_2i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1(x, v) (HW_IPU_CSI1_CPD_BC_i_WR(x, (HW_IPU_CSI1_CPD_BC_i_RD(x) & ~BM_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1) | BF_IPU_CSI1_CPD_BC_i_CSI1_CPD_BC_2i_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_BS_i - CSI1 Blue Component Compander SLOPE Register <i>
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_BS_i - CSI1 Blue Component Compander SLOPE Register <i> (RW)
 *
 * Reset value: 0x00000000U
 *
 * This registers contain SLOPEi parameters used for companding of red component.
 */
typedef union _hw_ipu_csi1_cpd_bs_i
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_bs_i_bitfields
    {
        uint32_t CSI1_CPD_BS_4i : 8;   /*!< [7:0]  */
        uint32_t CSI1_CPD_BS_4i_1 : 8; /*!< [15:8]  */
        uint32_t CSI1_CPD_BS_4i_2 : 8; /*!< [23:16]  */
        uint32_t CSI1_CPD_BS_4i_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_csi1_cpd_bs_i_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_BS_i register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_BS_i_ADDR(x) ((uintptr_t)(x) + 0x380DCU)

#define HW_IPU_CSI1_CPD_BS_i(x)  (*(__IO hw_ipu_csi1_cpd_bs_i_t *) HW_IPU_CSI1_CPD_BS_i_ADDR(x))
#define HW_IPU_CSI1_CPD_BS_i_RD(x) (HW_IPU_CSI1_CPD_BS_i(x).U)
#define HW_IPU_CSI1_CPD_BS_i_WR(x, v) (HW_IPU_CSI1_CPD_BS_i(x).U = (v))
#define HW_IPU_CSI1_CPD_BS_i_SET(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, HW_IPU_CSI1_CPD_BS_i_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_BS_i_CLR(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, HW_IPU_CSI1_CPD_BS_i_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_BS_i_TOG(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, HW_IPU_CSI1_CPD_BS_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_BS_i bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_BS_i, field CSI1_CPD_BS_4i[7:0] (RW)
 *
 * SLOPE<4*i> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i (0U) /*!< Bit position for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i. */
#define BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i (0x000000FFU) /*!< Bit mask for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i. */
#define BS_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i. */

/*! @brief Read current value of the IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i field. */
#define BR_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i(x) (HW_IPU_CSI1_CPD_BS_i(x).B.CSI1_CPD_BS_4i)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i. */
#define BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i) & BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i)

/*! @brief Set the CSI1_CPD_BS_4i field to a new value. */
#define BW_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, (HW_IPU_CSI1_CPD_BS_i_RD(x) & ~BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i) | BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_BS_i, field CSI1_CPD_BS_4i_1[15:8] (RW)
 *
 * SLOPE<4*i+1> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1 (8U) /*!< Bit position for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1. */
#define BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1 (0x0000FF00U) /*!< Bit mask for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1. */
#define BS_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1. */

/*! @brief Read current value of the IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1 field. */
#define BR_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1(x) (HW_IPU_CSI1_CPD_BS_i(x).B.CSI1_CPD_BS_4i_1)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1. */
#define BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1) & BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1)

/*! @brief Set the CSI1_CPD_BS_4i_1 field to a new value. */
#define BW_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, (HW_IPU_CSI1_CPD_BS_i_RD(x) & ~BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1) | BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_1(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_BS_i, field CSI1_CPD_BS_4i_2[23:16] (RW)
 *
 * SLOPE<4*i+2> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2 (16U) /*!< Bit position for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2. */
#define BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2 (0x00FF0000U) /*!< Bit mask for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2. */
#define BS_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2. */

/*! @brief Read current value of the IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2 field. */
#define BR_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2(x) (HW_IPU_CSI1_CPD_BS_i(x).B.CSI1_CPD_BS_4i_2)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2. */
#define BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2) & BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2)

/*! @brief Set the CSI1_CPD_BS_4i_2 field to a new value. */
#define BW_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, (HW_IPU_CSI1_CPD_BS_i_RD(x) & ~BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2) | BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_2(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_BS_i, field CSI1_CPD_BS_4i_3[31:24] (RW)
 *
 * SLOPE<4*i+3> parameter of Compander, Blue component. Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3 (24U) /*!< Bit position for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3. */
#define BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3 (0xFF000000U) /*!< Bit mask for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3. */
#define BS_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3 (8U) /*!< Bit field size in bits for IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3. */

/*! @brief Read current value of the IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3 field. */
#define BR_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3(x) (HW_IPU_CSI1_CPD_BS_i(x).B.CSI1_CPD_BS_4i_3)

/*! @brief Format value for bitfield IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3. */
#define BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3) & BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3)

/*! @brief Set the CSI1_CPD_BS_4i_3 field to a new value. */
#define BW_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3(x, v) (HW_IPU_CSI1_CPD_BS_i_WR(x, (HW_IPU_CSI1_CPD_BS_i_RD(x) & ~BM_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3) | BF_IPU_CSI1_CPD_BS_i_CSI1_CPD_BS_4i_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_OFFSET1 - CSI1 Compander Offset Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_OFFSET1 - CSI1 Compander Offset Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain Offset parameters used for companding.
 */
typedef union _hw_ipu_csi1_cpd_offset1
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_offset1_bitfields
    {
        uint32_t CSI1_CPD_GR_OFFSET : 10; /*!< [9:0]  */
        uint32_t CSI1_CPD_GB_OFFSET : 10; /*!< [19:10]  */
        uint32_t CSI1_CPD_B_OFFSET : 10; /*!< [29:20]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_ipu_csi1_cpd_offset1_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_OFFSET1 register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_OFFSET1_ADDR(x) ((uintptr_t)(x) + 0x380ECU)

#define HW_IPU_CSI1_CPD_OFFSET1(x) (*(__IO hw_ipu_csi1_cpd_offset1_t *) HW_IPU_CSI1_CPD_OFFSET1_ADDR(x))
#define HW_IPU_CSI1_CPD_OFFSET1_RD(x) (HW_IPU_CSI1_CPD_OFFSET1(x).U)
#define HW_IPU_CSI1_CPD_OFFSET1_WR(x, v) (HW_IPU_CSI1_CPD_OFFSET1(x).U = (v))
#define HW_IPU_CSI1_CPD_OFFSET1_SET(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, HW_IPU_CSI1_CPD_OFFSET1_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_OFFSET1_CLR(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, HW_IPU_CSI1_CPD_OFFSET1_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_OFFSET1_TOG(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, HW_IPU_CSI1_CPD_OFFSET1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_OFFSET1 bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_OFFSET1, field CSI1_CPD_GR_OFFSET[9:0] (RW)
 *
 * CSI1 Green Red component offset The value is between -512 to 511. The value
 * is added to the green-red component before companding. Clipping: If the result
 * of the green-red components value + the offset is smaller than 0, the result
 * is zero If the result of the green-red components value + the offset is greater
 * than 1023, the result is 1023 Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET (0U) /*!< Bit position for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET. */
#define BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET (0x000003FFU) /*!< Bit mask for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET. */
#define BS_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET. */

/*! @brief Read current value of the IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET field. */
#define BR_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET(x) (HW_IPU_CSI1_CPD_OFFSET1(x).B.CSI1_CPD_GR_OFFSET)

/*! @brief Format value for bitfield IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET. */
#define BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET) & BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET)

/*! @brief Set the CSI1_CPD_GR_OFFSET field to a new value. */
#define BW_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, (HW_IPU_CSI1_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET) | BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GR_OFFSET(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_OFFSET1, field CSI1_CPD_GB_OFFSET[19:10] (RW)
 *
 * CSI1 Green Blue component offset The value is between -512 to 511. The value
 * is added to the blue component before companding. Clipping: If the result of
 * the green-blue components value + the offset is smaller than 0, the result is
 * zero If the result of the green-blue components value + the offset is greater
 * than 1023, the result is 1023 If the input format is RGB/YUV then
 * CSI1_GB_OFFSET must be equal to CSI1_GR_OFFSET Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET (10U) /*!< Bit position for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET. */
#define BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET (0x000FFC00U) /*!< Bit mask for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET. */
#define BS_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET. */

/*! @brief Read current value of the IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET field. */
#define BR_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET(x) (HW_IPU_CSI1_CPD_OFFSET1(x).B.CSI1_CPD_GB_OFFSET)

/*! @brief Format value for bitfield IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET. */
#define BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET) & BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET)

/*! @brief Set the CSI1_CPD_GB_OFFSET field to a new value. */
#define BW_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, (HW_IPU_CSI1_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET) | BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_GB_OFFSET(v)))
/*@}*/

/*!
 * @name Register IPU_CSI1_CPD_OFFSET1, field CSI1_CPD_B_OFFSET[29:20] (RW)
 *
 * CSI1 Blue component offset The value is between -512 to 511. The value is
 * added to the blue component before companding. Clipping: If the result of the
 * blue components value + the offset is smaller than 0, the result is zero If the
 * result of the blue components value + the offset is greater than 1023, the
 * result is 1023 Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET (20U) /*!< Bit position for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET. */
#define BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET (0x3FF00000U) /*!< Bit mask for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET. */
#define BS_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET. */

/*! @brief Read current value of the IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET field. */
#define BR_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET(x) (HW_IPU_CSI1_CPD_OFFSET1(x).B.CSI1_CPD_B_OFFSET)

/*! @brief Format value for bitfield IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET. */
#define BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET) & BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET)

/*! @brief Set the CSI1_CPD_B_OFFSET field to a new value. */
#define BW_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET(x, v) (HW_IPU_CSI1_CPD_OFFSET1_WR(x, (HW_IPU_CSI1_CPD_OFFSET1_RD(x) & ~BM_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET) | BF_IPU_CSI1_CPD_OFFSET1_CSI1_CPD_B_OFFSET(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_CSI1_CPD_OFFSET2 - CSI1 Compander Offset Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_CSI1_CPD_OFFSET2 - CSI1 Compander Offset Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * These registers contain Offset parameters used for companding.
 */
typedef union _hw_ipu_csi1_cpd_offset2
{
    uint32_t U;
    struct _hw_ipu_csi1_cpd_offset2_bitfields
    {
        uint32_t CSI1_CPD_R_OFFSET : 10; /*!< [9:0]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_csi1_cpd_offset2_t;

/*!
 * @name Constants and macros for entire IPU_CSI1_CPD_OFFSET2 register
 */
/*@{*/
#define HW_IPU_CSI1_CPD_OFFSET2_ADDR(x) ((uintptr_t)(x) + 0x380F0U)

#define HW_IPU_CSI1_CPD_OFFSET2(x) (*(__IO hw_ipu_csi1_cpd_offset2_t *) HW_IPU_CSI1_CPD_OFFSET2_ADDR(x))
#define HW_IPU_CSI1_CPD_OFFSET2_RD(x) (HW_IPU_CSI1_CPD_OFFSET2(x).U)
#define HW_IPU_CSI1_CPD_OFFSET2_WR(x, v) (HW_IPU_CSI1_CPD_OFFSET2(x).U = (v))
#define HW_IPU_CSI1_CPD_OFFSET2_SET(x, v) (HW_IPU_CSI1_CPD_OFFSET2_WR(x, HW_IPU_CSI1_CPD_OFFSET2_RD(x) |  (v)))
#define HW_IPU_CSI1_CPD_OFFSET2_CLR(x, v) (HW_IPU_CSI1_CPD_OFFSET2_WR(x, HW_IPU_CSI1_CPD_OFFSET2_RD(x) & ~(v)))
#define HW_IPU_CSI1_CPD_OFFSET2_TOG(x, v) (HW_IPU_CSI1_CPD_OFFSET2_WR(x, HW_IPU_CSI1_CPD_OFFSET2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_CSI1_CPD_OFFSET2 bitfields
 */

/*!
 * @name Register IPU_CSI1_CPD_OFFSET2, field CSI1_CPD_R_OFFSET[9:0] (RW)
 *
 * CSI1 Red component offset The value is between -512 to 511. The value is
 * added to the red component before companding. Clipping: If the result of the red
 * components value + the offset is smaller than 0, the result is zero If the
 * result of the red components value + the offset is greater than 1023, the result
 * is 1023 Reserved
 */
/*@{*/
#define BP_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET (0U) /*!< Bit position for IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET. */
#define BM_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET (0x000003FFU) /*!< Bit mask for IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET. */
#define BS_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET (10U) /*!< Bit field size in bits for IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET. */

/*! @brief Read current value of the IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET field. */
#define BR_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET(x) (HW_IPU_CSI1_CPD_OFFSET2(x).B.CSI1_CPD_R_OFFSET)

/*! @brief Format value for bitfield IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET. */
#define BF_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET) & BM_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET)

/*! @brief Set the CSI1_CPD_R_OFFSET field to a new value. */
#define BW_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET(x, v) (HW_IPU_CSI1_CPD_OFFSET2_WR(x, (HW_IPU_CSI1_CPD_OFFSET2_RD(x) & ~BM_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET) | BF_IPU_CSI1_CPD_OFFSET2_CSI1_CPD_R_OFFSET(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_GENERAL - DI0 General Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_GENERAL - DI0 General Register (RW)
 *
 * Reset value: 0x00200000U
 */
typedef union _hw_ipu_di0_general
{
    uint32_t U;
    struct _hw_ipu_di0_general_bitfields
    {
        uint32_t di0_polarity_i_1 : 8; /*!< [7:0]  */
        uint32_t di0_polarity_cs0 : 1; /*!< [8]  */
        uint32_t di0_polarity_cs1 : 1; /*!< [9]  */
        uint32_t di0_erm_vsync_sel : 1; /*!< [10]  */
        uint32_t di0_err_treatment : 1; /*!< [11]  */
        uint32_t di0_sync_count_sel : 4; /*!< [15:12]  */
        uint32_t RESERVED0 : 1;        /*!< [16]  */
        uint32_t di0_polarity_disp_clk : 1; /*!< [17]  */
        uint32_t DI0_WATCHDOG_MODE : 2; /*!< [19:18]  */
        uint32_t di0_clk_ext : 1;      /*!< [20]  */
        uint32_t di0_vsync_ext : 1;    /*!< [21]  */
        uint32_t di0_mask_sel : 1;     /*!< [22]  */
        uint32_t DI0_DISP_CLOCK_INIT : 1; /*!< [23]  */
        uint32_t DI0_CLOCK_STOP_MODE : 4; /*!< [27:24]  */
        uint32_t di0_disp_y_sel : 3;   /*!< [30:28]  */
        uint32_t di0_pin8_pin15_sel : 1; /*!< [31]  */
    } B;
} hw_ipu_di0_general_t;

/*!
 * @name Constants and macros for entire IPU_DI0_GENERAL register
 */
/*@{*/
#define HW_IPU_DI0_GENERAL_ADDR(x) ((uintptr_t)(x) + 0x40000U)

#define HW_IPU_DI0_GENERAL(x)    (*(__IO hw_ipu_di0_general_t *) HW_IPU_DI0_GENERAL_ADDR(x))
#define HW_IPU_DI0_GENERAL_RD(x) (HW_IPU_DI0_GENERAL(x).U)
#define HW_IPU_DI0_GENERAL_WR(x, v) (HW_IPU_DI0_GENERAL(x).U = (v))
#define HW_IPU_DI0_GENERAL_SET(x, v) (HW_IPU_DI0_GENERAL_WR(x, HW_IPU_DI0_GENERAL_RD(x) |  (v)))
#define HW_IPU_DI0_GENERAL_CLR(x, v) (HW_IPU_DI0_GENERAL_WR(x, HW_IPU_DI0_GENERAL_RD(x) & ~(v)))
#define HW_IPU_DI0_GENERAL_TOG(x, v) (HW_IPU_DI0_GENERAL_WR(x, HW_IPU_DI0_GENERAL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_GENERAL bitfields
 */

/*!
 * @name Register IPU_DI0_GENERAL, field di0_polarity_i_1[7:0] (RW)
 *
 * DI0 output pin's polarity This bits define the polarity of each of the DI's
 * outputs.
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_polarity_i_1 (0U) /*!< Bit position for IPU_DI0_GENERAL_di0_polarity_i_1. */
#define BM_IPU_DI0_GENERAL_di0_polarity_i_1 (0x000000FFU) /*!< Bit mask for IPU_DI0_GENERAL_di0_polarity_i_1. */
#define BS_IPU_DI0_GENERAL_di0_polarity_i_1 (8U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_polarity_i_1. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_polarity_i_1 field. */
#define BR_IPU_DI0_GENERAL_di0_polarity_i_1(x) (HW_IPU_DI0_GENERAL(x).B.di0_polarity_i_1)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_polarity_i_1. */
#define BF_IPU_DI0_GENERAL_di0_polarity_i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_polarity_i_1) & BM_IPU_DI0_GENERAL_di0_polarity_i_1)

/*! @brief Set the di0_polarity_i_1 field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_polarity_i_1(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_polarity_i_1) | BF_IPU_DI0_GENERAL_di0_polarity_i_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_polarity_cs0[8] (RW)
 *
 * DI0 Chip Select's 0 polarity This bits define the polarity of the DI's CS0.
 *
 * Values:
 * - 1 - The CS0 is active high
 * - 0 - The CS0 is active low
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_polarity_cs0 (8U) /*!< Bit position for IPU_DI0_GENERAL_di0_polarity_cs0. */
#define BM_IPU_DI0_GENERAL_di0_polarity_cs0 (0x00000100U) /*!< Bit mask for IPU_DI0_GENERAL_di0_polarity_cs0. */
#define BS_IPU_DI0_GENERAL_di0_polarity_cs0 (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_polarity_cs0. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_polarity_cs0 field. */
#define BR_IPU_DI0_GENERAL_di0_polarity_cs0(x) (HW_IPU_DI0_GENERAL(x).B.di0_polarity_cs0)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_polarity_cs0. */
#define BF_IPU_DI0_GENERAL_di0_polarity_cs0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_polarity_cs0) & BM_IPU_DI0_GENERAL_di0_polarity_cs0)

/*! @brief Set the di0_polarity_cs0 field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_polarity_cs0(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_polarity_cs0) | BF_IPU_DI0_GENERAL_di0_polarity_cs0(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_polarity_cs1[9] (RW)
 *
 * DI0 Chip Select's 1 polarity This bits define the polarity of the DI's CS1.
 *
 * Values:
 * - 1 - The CS1 is active high
 * - 0 - The CS1 is active low
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_polarity_cs1 (9U) /*!< Bit position for IPU_DI0_GENERAL_di0_polarity_cs1. */
#define BM_IPU_DI0_GENERAL_di0_polarity_cs1 (0x00000200U) /*!< Bit mask for IPU_DI0_GENERAL_di0_polarity_cs1. */
#define BS_IPU_DI0_GENERAL_di0_polarity_cs1 (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_polarity_cs1. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_polarity_cs1 field. */
#define BR_IPU_DI0_GENERAL_di0_polarity_cs1(x) (HW_IPU_DI0_GENERAL(x).B.di0_polarity_cs1)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_polarity_cs1. */
#define BF_IPU_DI0_GENERAL_di0_polarity_cs1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_polarity_cs1) & BM_IPU_DI0_GENERAL_di0_polarity_cs1)

/*! @brief Set the di0_polarity_cs1 field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_polarity_cs1(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_polarity_cs1) | BF_IPU_DI0_GENERAL_di0_polarity_cs1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_erm_vsync_sel[10] (RW)
 *
 * DI0 error recovery block's VSYNC source select The error recovery block
 * detect a case where the DI's VSYNC is asserted before the EOF. This bit selects the
 * source of the VSYNC signal monitored by this mechanism.
 *
 * Values:
 * - 1 - vsync_post - an internal VSYNC signal asserted 2 lines after the DI's
 *     VSYNC
 * - 0 - vsync_pre - an internal VSYNC signal asserted 2 lines before the DI's
 *     VSYNC
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_erm_vsync_sel (10U) /*!< Bit position for IPU_DI0_GENERAL_di0_erm_vsync_sel. */
#define BM_IPU_DI0_GENERAL_di0_erm_vsync_sel (0x00000400U) /*!< Bit mask for IPU_DI0_GENERAL_di0_erm_vsync_sel. */
#define BS_IPU_DI0_GENERAL_di0_erm_vsync_sel (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_erm_vsync_sel. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_erm_vsync_sel field. */
#define BR_IPU_DI0_GENERAL_di0_erm_vsync_sel(x) (HW_IPU_DI0_GENERAL(x).B.di0_erm_vsync_sel)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_erm_vsync_sel. */
#define BF_IPU_DI0_GENERAL_di0_erm_vsync_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_erm_vsync_sel) & BM_IPU_DI0_GENERAL_di0_erm_vsync_sel)

/*! @brief Set the di0_erm_vsync_sel field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_erm_vsync_sel(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_erm_vsync_sel) | BF_IPU_DI0_GENERAL_di0_erm_vsync_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_err_treatment[11] (RW)
 *
 * In case of synchronous flow error there are 2 ways to handle the display
 *
 * Values:
 * - 1 - to wait (stop clock)
 * - 0 - Drive the last component
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_err_treatment (11U) /*!< Bit position for IPU_DI0_GENERAL_di0_err_treatment. */
#define BM_IPU_DI0_GENERAL_di0_err_treatment (0x00000800U) /*!< Bit mask for IPU_DI0_GENERAL_di0_err_treatment. */
#define BS_IPU_DI0_GENERAL_di0_err_treatment (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_err_treatment. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_err_treatment field. */
#define BR_IPU_DI0_GENERAL_di0_err_treatment(x) (HW_IPU_DI0_GENERAL(x).B.di0_err_treatment)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_err_treatment. */
#define BF_IPU_DI0_GENERAL_di0_err_treatment(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_err_treatment) & BM_IPU_DI0_GENERAL_di0_err_treatment)

/*! @brief Set the di0_err_treatment field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_err_treatment(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_err_treatment) | BF_IPU_DI0_GENERAL_di0_err_treatment(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_sync_count_sel[15:12] (RW)
 *
 * For synchronous flow error: selects synchronous flow synchronization counter
 * in DI:
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_sync_count_sel (12U) /*!< Bit position for IPU_DI0_GENERAL_di0_sync_count_sel. */
#define BM_IPU_DI0_GENERAL_di0_sync_count_sel (0x0000F000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_sync_count_sel. */
#define BS_IPU_DI0_GENERAL_di0_sync_count_sel (4U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_sync_count_sel. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_sync_count_sel field. */
#define BR_IPU_DI0_GENERAL_di0_sync_count_sel(x) (HW_IPU_DI0_GENERAL(x).B.di0_sync_count_sel)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_sync_count_sel. */
#define BF_IPU_DI0_GENERAL_di0_sync_count_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_sync_count_sel) & BM_IPU_DI0_GENERAL_di0_sync_count_sel)

/*! @brief Set the di0_sync_count_sel field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_sync_count_sel(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_sync_count_sel) | BF_IPU_DI0_GENERAL_di0_sync_count_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_polarity_disp_clk[17] (RW)
 *
 * DI0 Output Clock's polarity This bits define the polarity of the DI0's clock.
 *
 * Values:
 * - 1 - The output clock is active high
 * - 0 - The output clock is active low
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_polarity_disp_clk (17U) /*!< Bit position for IPU_DI0_GENERAL_di0_polarity_disp_clk. */
#define BM_IPU_DI0_GENERAL_di0_polarity_disp_clk (0x00020000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_polarity_disp_clk. */
#define BS_IPU_DI0_GENERAL_di0_polarity_disp_clk (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_polarity_disp_clk. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_polarity_disp_clk field. */
#define BR_IPU_DI0_GENERAL_di0_polarity_disp_clk(x) (HW_IPU_DI0_GENERAL(x).B.di0_polarity_disp_clk)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_polarity_disp_clk. */
#define BF_IPU_DI0_GENERAL_di0_polarity_disp_clk(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_polarity_disp_clk) & BM_IPU_DI0_GENERAL_di0_polarity_disp_clk)

/*! @brief Set the di0_polarity_disp_clk field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_polarity_disp_clk(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_polarity_disp_clk) | BF_IPU_DI0_GENERAL_di0_polarity_disp_clk(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field DI0_WATCHDOG_MODE[19:18] (RW)
 *
 * DI0 watchdog mode In case of a display error where the DI clock is stopped
 * (defined at di0_err_treatment). An internal watchdog counts DI clocks. If this
 * timer reached its pre defined value the DI will skip the current frame and
 * restart on the frame. This 2 bits define the number of DI clock cycles that the
 * timer counts.
 *
 * Values:
 * - 00 - The timer counts 4 DI cycles
 * - 01 - The timer counts 16 DI cycles
 * - 10 - The timer counts 64 DI cycles
 * - 11 - The timer counts 128 DI cycles
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE (18U) /*!< Bit position for IPU_DI0_GENERAL_DI0_WATCHDOG_MODE. */
#define BM_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE (0x000C0000U) /*!< Bit mask for IPU_DI0_GENERAL_DI0_WATCHDOG_MODE. */
#define BS_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE (2U) /*!< Bit field size in bits for IPU_DI0_GENERAL_DI0_WATCHDOG_MODE. */

/*! @brief Read current value of the IPU_DI0_GENERAL_DI0_WATCHDOG_MODE field. */
#define BR_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE(x) (HW_IPU_DI0_GENERAL(x).B.DI0_WATCHDOG_MODE)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_DI0_WATCHDOG_MODE. */
#define BF_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE) & BM_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE)

/*! @brief Set the DI0_WATCHDOG_MODE field to a new value. */
#define BW_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE) | BF_IPU_DI0_GENERAL_DI0_WATCHDOG_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_clk_ext[20] (RW)
 *
 * DI0 External Clock. This bit selects the source of the DI0's clock
 *
 * Values:
 * - 1 - The source of the clock is external to the IPU
 * - 0 - The clock is internally generated by the IPU
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_clk_ext (20U) /*!< Bit position for IPU_DI0_GENERAL_di0_clk_ext. */
#define BM_IPU_DI0_GENERAL_di0_clk_ext (0x00100000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_clk_ext. */
#define BS_IPU_DI0_GENERAL_di0_clk_ext (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_clk_ext. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_clk_ext field. */
#define BR_IPU_DI0_GENERAL_di0_clk_ext(x) (HW_IPU_DI0_GENERAL(x).B.di0_clk_ext)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_clk_ext. */
#define BF_IPU_DI0_GENERAL_di0_clk_ext(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_clk_ext) & BM_IPU_DI0_GENERAL_di0_clk_ext)

/*! @brief Set the di0_clk_ext field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_clk_ext(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_clk_ext) | BF_IPU_DI0_GENERAL_di0_clk_ext(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_vsync_ext[21] (RW)
 *
 * DI0 External VSYNC. This bit selects the source of the VSYNC signal
 *
 * Values:
 * - 1 - External to the IPU
 * - 0 - Internally generated by the IPU
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_vsync_ext (21U) /*!< Bit position for IPU_DI0_GENERAL_di0_vsync_ext. */
#define BM_IPU_DI0_GENERAL_di0_vsync_ext (0x00200000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_vsync_ext. */
#define BS_IPU_DI0_GENERAL_di0_vsync_ext (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_vsync_ext. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_vsync_ext field. */
#define BR_IPU_DI0_GENERAL_di0_vsync_ext(x) (HW_IPU_DI0_GENERAL(x).B.di0_vsync_ext)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_vsync_ext. */
#define BF_IPU_DI0_GENERAL_di0_vsync_ext(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_vsync_ext) & BM_IPU_DI0_GENERAL_di0_vsync_ext)

/*! @brief Set the di0_vsync_ext field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_vsync_ext(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_vsync_ext) | BF_IPU_DI0_GENERAL_di0_vsync_ext(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_mask_sel[22] (RW)
 *
 * DI0 Mask select. IPP_PIN_2 output of the DI that functions as MASK signal can
 * come from 2 sources: counter #2 or extracted from the MASK data coming from
 * the memory.
 *
 * Values:
 * - 1 - IPP_PIN_2 is coming from extracted MASK data coming from the memory
 * - 0 - IPP_PIN_2 is coming from counter #2
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_mask_sel (22U) /*!< Bit position for IPU_DI0_GENERAL_di0_mask_sel. */
#define BM_IPU_DI0_GENERAL_di0_mask_sel (0x00400000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_mask_sel. */
#define BS_IPU_DI0_GENERAL_di0_mask_sel (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_mask_sel. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_mask_sel field. */
#define BR_IPU_DI0_GENERAL_di0_mask_sel(x) (HW_IPU_DI0_GENERAL(x).B.di0_mask_sel)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_mask_sel. */
#define BF_IPU_DI0_GENERAL_di0_mask_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_mask_sel) & BM_IPU_DI0_GENERAL_di0_mask_sel)

/*! @brief Set the di0_mask_sel field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_mask_sel(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_mask_sel) | BF_IPU_DI0_GENERAL_di0_mask_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field DI0_DISP_CLOCK_INIT[23] (RW)
 *
 * Display clock's initial mode For synchronization error conditions the display
 * clock can be stopped on the next VSYNC
 *
 * Values:
 * - 1 - The display's clock is running after the next VSYNC (indicating new
 *     frame)
 * - 0 - The display's clock is stopped after the next VSYNC (indicating new
 *     frame)
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT (23U) /*!< Bit position for IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT. */
#define BM_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT (0x00800000U) /*!< Bit mask for IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT. */
#define BS_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT. */

/*! @brief Read current value of the IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT field. */
#define BR_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT(x) (HW_IPU_DI0_GENERAL(x).B.DI0_DISP_CLOCK_INIT)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT. */
#define BF_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT) & BM_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT)

/*! @brief Set the DI0_DISP_CLOCK_INIT field to a new value. */
#define BW_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT) | BF_IPU_DI0_GENERAL_DI0_DISP_CLOCK_INIT(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field DI0_CLOCK_STOP_MODE[27:24] (RW)
 *
 * DI clock stop mode When performing a clock change. The DI stops the clock to
 * the display. These field defines when the clock will be stopped. Stopping at
 * EOL/EOF is supported for the case where the data is coming from the IDMAC (DMA
 * access). In case that only direct accesses is performed, the user should set
 * this field to 0000 0001-1001 stop at the next event of one of the counters
 * (counter #1 to counter #9)
 *
 * Values:
 * - 0000 - stop at the next edge of the display clock
 * - 1100 - stop at EOL (end of a line), but if stop request is during blanking
 *     interval, stop now
 * - 1101 - stop at EOF (end of a frame), but if stop request is during blanking
 *     interval, stop now
 * - 1110 - stop at EOL (end of a line), but if stop request is during blanking
 *     interval, stop at the end of the next line
 * - 1111 - stop at EOF (end of a frame), but if stop request is during blanking
 *     interval, stop at the end of the next frame
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE (24U) /*!< Bit position for IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE. */
#define BM_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE (0x0F000000U) /*!< Bit mask for IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE. */
#define BS_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE (4U) /*!< Bit field size in bits for IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE. */

/*! @brief Read current value of the IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE field. */
#define BR_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE(x) (HW_IPU_DI0_GENERAL(x).B.DI0_CLOCK_STOP_MODE)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE. */
#define BF_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE) & BM_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE)

/*! @brief Set the DI0_CLOCK_STOP_MODE field to a new value. */
#define BW_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE) | BF_IPU_DI0_GENERAL_DI0_CLOCK_STOP_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_disp_y_sel[30:28] (RW)
 *
 * DI0 Display Vertical coordinate (Y) select. This field defines which one of
 * the 8 counters will be used as a display's line counter.
 *
 * Values:
 * - 000 - counter #1 is selected
 * - 111 - counter #8 is selected
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_disp_y_sel (28U) /*!< Bit position for IPU_DI0_GENERAL_di0_disp_y_sel. */
#define BM_IPU_DI0_GENERAL_di0_disp_y_sel (0x70000000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_disp_y_sel. */
#define BS_IPU_DI0_GENERAL_di0_disp_y_sel (3U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_disp_y_sel. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_disp_y_sel field. */
#define BR_IPU_DI0_GENERAL_di0_disp_y_sel(x) (HW_IPU_DI0_GENERAL(x).B.di0_disp_y_sel)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_disp_y_sel. */
#define BF_IPU_DI0_GENERAL_di0_disp_y_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_disp_y_sel) & BM_IPU_DI0_GENERAL_di0_disp_y_sel)

/*! @brief Set the di0_disp_y_sel field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_disp_y_sel(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_disp_y_sel) | BF_IPU_DI0_GENERAL_di0_disp_y_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_GENERAL, field di0_pin8_pin15_sel[31] (RW)
 *
 * This bit routes PIN8 over PIN15
 *
 * Values:
 * - 1 - PIN8 is routed to PIN15, PIN8 is also routed to PIN8
 * - 0 - PIN15 is routed to PIN15, PIN8 is routed to PIN8
 */
/*@{*/
#define BP_IPU_DI0_GENERAL_di0_pin8_pin15_sel (31U) /*!< Bit position for IPU_DI0_GENERAL_di0_pin8_pin15_sel. */
#define BM_IPU_DI0_GENERAL_di0_pin8_pin15_sel (0x80000000U) /*!< Bit mask for IPU_DI0_GENERAL_di0_pin8_pin15_sel. */
#define BS_IPU_DI0_GENERAL_di0_pin8_pin15_sel (1U) /*!< Bit field size in bits for IPU_DI0_GENERAL_di0_pin8_pin15_sel. */

/*! @brief Read current value of the IPU_DI0_GENERAL_di0_pin8_pin15_sel field. */
#define BR_IPU_DI0_GENERAL_di0_pin8_pin15_sel(x) (HW_IPU_DI0_GENERAL(x).B.di0_pin8_pin15_sel)

/*! @brief Format value for bitfield IPU_DI0_GENERAL_di0_pin8_pin15_sel. */
#define BF_IPU_DI0_GENERAL_di0_pin8_pin15_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_GENERAL_di0_pin8_pin15_sel) & BM_IPU_DI0_GENERAL_di0_pin8_pin15_sel)

/*! @brief Set the di0_pin8_pin15_sel field to a new value. */
#define BW_IPU_DI0_GENERAL_di0_pin8_pin15_sel(x, v) (HW_IPU_DI0_GENERAL_WR(x, (HW_IPU_DI0_GENERAL_RD(x) & ~BM_IPU_DI0_GENERAL_di0_pin8_pin15_sel) | BF_IPU_DI0_GENERAL_di0_pin8_pin15_sel(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_BS_CLKGEN0 - DI0 Base Sync Clock Gen 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_BS_CLKGEN0 - DI0 Base Sync Clock Gen 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_bs_clkgen0
{
    uint32_t U;
    struct _hw_ipu_di0_bs_clkgen0_bitfields
    {
        uint32_t di0_disp_clk_period : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t di0_disp_clk_offset : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_bs_clkgen0_t;

/*!
 * @name Constants and macros for entire IPU_DI0_BS_CLKGEN0 register
 */
/*@{*/
#define HW_IPU_DI0_BS_CLKGEN0_ADDR(x) ((uintptr_t)(x) + 0x40004U)

#define HW_IPU_DI0_BS_CLKGEN0(x) (*(__IO hw_ipu_di0_bs_clkgen0_t *) HW_IPU_DI0_BS_CLKGEN0_ADDR(x))
#define HW_IPU_DI0_BS_CLKGEN0_RD(x) (HW_IPU_DI0_BS_CLKGEN0(x).U)
#define HW_IPU_DI0_BS_CLKGEN0_WR(x, v) (HW_IPU_DI0_BS_CLKGEN0(x).U = (v))
#define HW_IPU_DI0_BS_CLKGEN0_SET(x, v) (HW_IPU_DI0_BS_CLKGEN0_WR(x, HW_IPU_DI0_BS_CLKGEN0_RD(x) |  (v)))
#define HW_IPU_DI0_BS_CLKGEN0_CLR(x, v) (HW_IPU_DI0_BS_CLKGEN0_WR(x, HW_IPU_DI0_BS_CLKGEN0_RD(x) & ~(v)))
#define HW_IPU_DI0_BS_CLKGEN0_TOG(x, v) (HW_IPU_DI0_BS_CLKGEN0_WR(x, HW_IPU_DI0_BS_CLKGEN0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_BS_CLKGEN0 bitfields
 */

/*!
 * @name Register IPU_DI0_BS_CLKGEN0, field di0_disp_clk_period[11:0] (RW)
 *
 * DI0 Display Clock Period This field defines the Display interface clock
 * period for display write access. This parameter contains an integer part (bits
 * 11:4) and a fractional part (bits 3:0). It defines a fractional division ratio of
 * the HSP_CLK clock for generation of the display's interface clock.
 */
/*@{*/
#define BP_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period (0U) /*!< Bit position for IPU_DI0_BS_CLKGEN0_di0_disp_clk_period. */
#define BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period (0x00000FFFU) /*!< Bit mask for IPU_DI0_BS_CLKGEN0_di0_disp_clk_period. */
#define BS_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period (12U) /*!< Bit field size in bits for IPU_DI0_BS_CLKGEN0_di0_disp_clk_period. */

/*! @brief Read current value of the IPU_DI0_BS_CLKGEN0_di0_disp_clk_period field. */
#define BR_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period(x) (HW_IPU_DI0_BS_CLKGEN0(x).B.di0_disp_clk_period)

/*! @brief Format value for bitfield IPU_DI0_BS_CLKGEN0_di0_disp_clk_period. */
#define BF_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period) & BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period)

/*! @brief Set the di0_disp_clk_period field to a new value. */
#define BW_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period(x, v) (HW_IPU_DI0_BS_CLKGEN0_WR(x, (HW_IPU_DI0_BS_CLKGEN0_RD(x) & ~BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period) | BF_IPU_DI0_BS_CLKGEN0_di0_disp_clk_period(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_BS_CLKGEN0, field di0_disp_clk_offset[24:16] (RW)
 *
 * DI0 Display Clock Offset The DI has the ability to delay the display's clock
 * This field defines the amount of IPU's clock cycles added as delay on this
 * clock.
 */
/*@{*/
#define BP_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset (16U) /*!< Bit position for IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset. */
#define BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset (0x01FF0000U) /*!< Bit mask for IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset. */
#define BS_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset (9U) /*!< Bit field size in bits for IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset. */

/*! @brief Read current value of the IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset field. */
#define BR_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset(x) (HW_IPU_DI0_BS_CLKGEN0(x).B.di0_disp_clk_offset)

/*! @brief Format value for bitfield IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset. */
#define BF_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset) & BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset)

/*! @brief Set the di0_disp_clk_offset field to a new value. */
#define BW_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset(x, v) (HW_IPU_DI0_BS_CLKGEN0_WR(x, (HW_IPU_DI0_BS_CLKGEN0_RD(x) & ~BM_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset) | BF_IPU_DI0_BS_CLKGEN0_di0_disp_clk_offset(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_BS_CLKGEN1 - DI0 Base Sync Clock Gen 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_BS_CLKGEN1 - DI0 Base Sync Clock Gen 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_bs_clkgen1
{
    uint32_t U;
    struct _hw_ipu_di0_bs_clkgen1_bitfields
    {
        uint32_t di0_disp_clk_up : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di0_disp_clk_down : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_bs_clkgen1_t;

/*!
 * @name Constants and macros for entire IPU_DI0_BS_CLKGEN1 register
 */
/*@{*/
#define HW_IPU_DI0_BS_CLKGEN1_ADDR(x) ((uintptr_t)(x) + 0x40008U)

#define HW_IPU_DI0_BS_CLKGEN1(x) (*(__IO hw_ipu_di0_bs_clkgen1_t *) HW_IPU_DI0_BS_CLKGEN1_ADDR(x))
#define HW_IPU_DI0_BS_CLKGEN1_RD(x) (HW_IPU_DI0_BS_CLKGEN1(x).U)
#define HW_IPU_DI0_BS_CLKGEN1_WR(x, v) (HW_IPU_DI0_BS_CLKGEN1(x).U = (v))
#define HW_IPU_DI0_BS_CLKGEN1_SET(x, v) (HW_IPU_DI0_BS_CLKGEN1_WR(x, HW_IPU_DI0_BS_CLKGEN1_RD(x) |  (v)))
#define HW_IPU_DI0_BS_CLKGEN1_CLR(x, v) (HW_IPU_DI0_BS_CLKGEN1_WR(x, HW_IPU_DI0_BS_CLKGEN1_RD(x) & ~(v)))
#define HW_IPU_DI0_BS_CLKGEN1_TOG(x, v) (HW_IPU_DI0_BS_CLKGEN1_WR(x, HW_IPU_DI0_BS_CLKGEN1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_BS_CLKGEN1 bitfields
 */

/*!
 * @name Register IPU_DI0_BS_CLKGEN1, field di0_disp_clk_up[8:0] (RW)
 *
 * DI0 display clock rising edge position This parameter contains an integer
 * part (bits 8:1) and a fractional part (bit 0). The position value is a time
 * interval between display's access start point and display's interface clock rising
 * edge.
 */
/*@{*/
#define BP_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up (0U) /*!< Bit position for IPU_DI0_BS_CLKGEN1_di0_disp_clk_up. */
#define BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up (0x000001FFU) /*!< Bit mask for IPU_DI0_BS_CLKGEN1_di0_disp_clk_up. */
#define BS_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up (9U) /*!< Bit field size in bits for IPU_DI0_BS_CLKGEN1_di0_disp_clk_up. */

/*! @brief Read current value of the IPU_DI0_BS_CLKGEN1_di0_disp_clk_up field. */
#define BR_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up(x) (HW_IPU_DI0_BS_CLKGEN1(x).B.di0_disp_clk_up)

/*! @brief Format value for bitfield IPU_DI0_BS_CLKGEN1_di0_disp_clk_up. */
#define BF_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up) & BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up)

/*! @brief Set the di0_disp_clk_up field to a new value. */
#define BW_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up(x, v) (HW_IPU_DI0_BS_CLKGEN1_WR(x, (HW_IPU_DI0_BS_CLKGEN1_RD(x) & ~BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up) | BF_IPU_DI0_BS_CLKGEN1_di0_disp_clk_up(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_BS_CLKGEN1, field di0_disp_clk_down[24:16] (RW)
 *
 * DI0 display clock falling edge position This parameter contains an integer
 * part (bits 24:17) and a fractional part (bit 16). The position value is a time
 * interval between display's access start point and display's interface clock
 * falling edge.
 */
/*@{*/
#define BP_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down (16U) /*!< Bit position for IPU_DI0_BS_CLKGEN1_di0_disp_clk_down. */
#define BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down (0x01FF0000U) /*!< Bit mask for IPU_DI0_BS_CLKGEN1_di0_disp_clk_down. */
#define BS_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down (9U) /*!< Bit field size in bits for IPU_DI0_BS_CLKGEN1_di0_disp_clk_down. */

/*! @brief Read current value of the IPU_DI0_BS_CLKGEN1_di0_disp_clk_down field. */
#define BR_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down(x) (HW_IPU_DI0_BS_CLKGEN1(x).B.di0_disp_clk_down)

/*! @brief Format value for bitfield IPU_DI0_BS_CLKGEN1_di0_disp_clk_down. */
#define BF_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down) & BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down)

/*! @brief Set the di0_disp_clk_down field to a new value. */
#define BW_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down(x, v) (HW_IPU_DI0_BS_CLKGEN1_WR(x, (HW_IPU_DI0_BS_CLKGEN1_RD(x) & ~BM_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down) | BF_IPU_DI0_BS_CLKGEN1_di0_disp_clk_down(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_1 - DI0 Sync Wave Gen 1 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_1 - DI0 Sync Wave Gen 1 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_1
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_1_bitfields
    {
        uint32_t di0_offset_resolution_1 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_1 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_1 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_1 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_1_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_1 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_1_ADDR(x) ((uintptr_t)(x) + 0x4000CU)

#define HW_IPU_DI0_SW_GEN0_1(x)  (*(__IO hw_ipu_di0_sw_gen0_1_t *) HW_IPU_DI0_SW_GEN0_1_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_1_RD(x) (HW_IPU_DI0_SW_GEN0_1(x).U)
#define HW_IPU_DI0_SW_GEN0_1_WR(x, v) (HW_IPU_DI0_SW_GEN0_1(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_1_SET(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, HW_IPU_DI0_SW_GEN0_1_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_1_CLR(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, HW_IPU_DI0_SW_GEN0_1_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_1_TOG(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, HW_IPU_DI0_SW_GEN0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_1 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_1, field di0_offset_resolution_1[2:0] (RW)
 *
 * DI0 counter #1 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock
 * - 010 - NA
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSIs
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_1_di0_offset_resolution_1. */
#define BM_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_1_di0_offset_resolution_1. */
#define BS_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_1_di0_offset_resolution_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_1_di0_offset_resolution_1 field. */
#define BR_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1(x) (HW_IPU_DI0_SW_GEN0_1(x).B.di0_offset_resolution_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_1_di0_offset_resolution_1. */
#define BF_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1) & BM_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1)

/*! @brief Set the di0_offset_resolution_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, (HW_IPU_DI0_SW_GEN0_1_RD(x) & ~BM_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1) | BF_IPU_DI0_SW_GEN0_1_di0_offset_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_1, field di0_offset_value_1[14:3] (RW)
 *
 * DI0 counter #1 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_1_di0_offset_value_1 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_1_di0_offset_value_1. */
#define BM_IPU_DI0_SW_GEN0_1_di0_offset_value_1 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_1_di0_offset_value_1. */
#define BS_IPU_DI0_SW_GEN0_1_di0_offset_value_1 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_1_di0_offset_value_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_1_di0_offset_value_1 field. */
#define BR_IPU_DI0_SW_GEN0_1_di0_offset_value_1(x) (HW_IPU_DI0_SW_GEN0_1(x).B.di0_offset_value_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_1_di0_offset_value_1. */
#define BF_IPU_DI0_SW_GEN0_1_di0_offset_value_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_1_di0_offset_value_1) & BM_IPU_DI0_SW_GEN0_1_di0_offset_value_1)

/*! @brief Set the di0_offset_value_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_1_di0_offset_value_1(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, (HW_IPU_DI0_SW_GEN0_1_RD(x) & ~BM_IPU_DI0_SW_GEN0_1_di0_offset_value_1) | BF_IPU_DI0_SW_GEN0_1_di0_offset_value_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_1, field di0_run_resolution_1[18:16] (RW)
 *
 * DI0 counter #1 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - NA
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSIs
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_1_di0_run_resolution_1 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_1_di0_run_resolution_1. */
#define BM_IPU_DI0_SW_GEN0_1_di0_run_resolution_1 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_1_di0_run_resolution_1. */
#define BS_IPU_DI0_SW_GEN0_1_di0_run_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_1_di0_run_resolution_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_1_di0_run_resolution_1 field. */
#define BR_IPU_DI0_SW_GEN0_1_di0_run_resolution_1(x) (HW_IPU_DI0_SW_GEN0_1(x).B.di0_run_resolution_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_1_di0_run_resolution_1. */
#define BF_IPU_DI0_SW_GEN0_1_di0_run_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_1_di0_run_resolution_1) & BM_IPU_DI0_SW_GEN0_1_di0_run_resolution_1)

/*! @brief Set the di0_run_resolution_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_1_di0_run_resolution_1(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, (HW_IPU_DI0_SW_GEN0_1_RD(x) & ~BM_IPU_DI0_SW_GEN0_1_di0_run_resolution_1) | BF_IPU_DI0_SW_GEN0_1_di0_run_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_1, field di0_run_value_m1_1[30:19] (RW)
 *
 * DI0 counter #1 pre defined value This fields defines the counter #1 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_1 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_1_di0_run_value_m1_1. */
#define BM_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_1_di0_run_value_m1_1. */
#define BS_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_1_di0_run_value_m1_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_1_di0_run_value_m1_1 field. */
#define BR_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1(x) (HW_IPU_DI0_SW_GEN0_1(x).B.di0_run_value_m1_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_1_di0_run_value_m1_1. */
#define BF_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1) & BM_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1)

/*! @brief Set the di0_run_value_m1_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1(x, v) (HW_IPU_DI0_SW_GEN0_1_WR(x, (HW_IPU_DI0_SW_GEN0_1_RD(x) & ~BM_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1) | BF_IPU_DI0_SW_GEN0_1_di0_run_value_m1_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_2 - DI0 Sync Wave Gen 2 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_2 - DI0 Sync Wave Gen 2 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_2
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_2_bitfields
    {
        uint32_t di0_offset_resolution_2 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_2 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_2 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_2 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_2_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_2 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_2_ADDR(x) ((uintptr_t)(x) + 0x40010U)

#define HW_IPU_DI0_SW_GEN0_2(x)  (*(__IO hw_ipu_di0_sw_gen0_2_t *) HW_IPU_DI0_SW_GEN0_2_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_2_RD(x) (HW_IPU_DI0_SW_GEN0_2(x).U)
#define HW_IPU_DI0_SW_GEN0_2_WR(x, v) (HW_IPU_DI0_SW_GEN0_2(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_2_SET(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, HW_IPU_DI0_SW_GEN0_2_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_2_CLR(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, HW_IPU_DI0_SW_GEN0_2_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_2_TOG(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, HW_IPU_DI0_SW_GEN0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_2 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_2, field di0_offset_resolution_2[2:0] (RW)
 *
 * DI0 counter #2 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSIs
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_2_di0_offset_resolution_2. */
#define BM_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_2_di0_offset_resolution_2. */
#define BS_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_2_di0_offset_resolution_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_2_di0_offset_resolution_2 field. */
#define BR_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2(x) (HW_IPU_DI0_SW_GEN0_2(x).B.di0_offset_resolution_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_2_di0_offset_resolution_2. */
#define BF_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2) & BM_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2)

/*! @brief Set the di0_offset_resolution_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, (HW_IPU_DI0_SW_GEN0_2_RD(x) & ~BM_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2) | BF_IPU_DI0_SW_GEN0_2_di0_offset_resolution_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_2, field di0_offset_value_2[14:3] (RW)
 *
 * DI0 counter #2 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_2_di0_offset_value_2 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_2_di0_offset_value_2. */
#define BM_IPU_DI0_SW_GEN0_2_di0_offset_value_2 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_2_di0_offset_value_2. */
#define BS_IPU_DI0_SW_GEN0_2_di0_offset_value_2 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_2_di0_offset_value_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_2_di0_offset_value_2 field. */
#define BR_IPU_DI0_SW_GEN0_2_di0_offset_value_2(x) (HW_IPU_DI0_SW_GEN0_2(x).B.di0_offset_value_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_2_di0_offset_value_2. */
#define BF_IPU_DI0_SW_GEN0_2_di0_offset_value_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_2_di0_offset_value_2) & BM_IPU_DI0_SW_GEN0_2_di0_offset_value_2)

/*! @brief Set the di0_offset_value_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_2_di0_offset_value_2(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, (HW_IPU_DI0_SW_GEN0_2_RD(x) & ~BM_IPU_DI0_SW_GEN0_2_di0_offset_value_2) | BF_IPU_DI0_SW_GEN0_2_di0_offset_value_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_2, field di0_run_resolution_2[18:16] (RW)
 *
 * DI0 counter #2 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock
 * - 010 - The Counter is triggered by counter #1
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_2_di0_run_resolution_2 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_2_di0_run_resolution_2. */
#define BM_IPU_DI0_SW_GEN0_2_di0_run_resolution_2 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_2_di0_run_resolution_2. */
#define BS_IPU_DI0_SW_GEN0_2_di0_run_resolution_2 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_2_di0_run_resolution_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_2_di0_run_resolution_2 field. */
#define BR_IPU_DI0_SW_GEN0_2_di0_run_resolution_2(x) (HW_IPU_DI0_SW_GEN0_2(x).B.di0_run_resolution_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_2_di0_run_resolution_2. */
#define BF_IPU_DI0_SW_GEN0_2_di0_run_resolution_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_2_di0_run_resolution_2) & BM_IPU_DI0_SW_GEN0_2_di0_run_resolution_2)

/*! @brief Set the di0_run_resolution_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_2_di0_run_resolution_2(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, (HW_IPU_DI0_SW_GEN0_2_RD(x) & ~BM_IPU_DI0_SW_GEN0_2_di0_run_resolution_2) | BF_IPU_DI0_SW_GEN0_2_di0_run_resolution_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_2, field di0_run_value_m1_2[30:19] (RW)
 *
 * DI0 counter #2 pre defined value This fields defines the counter #2 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_2 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_2_di0_run_value_m1_2. */
#define BM_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_2_di0_run_value_m1_2. */
#define BS_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_2_di0_run_value_m1_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_2_di0_run_value_m1_2 field. */
#define BR_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2(x) (HW_IPU_DI0_SW_GEN0_2(x).B.di0_run_value_m1_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_2_di0_run_value_m1_2. */
#define BF_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2) & BM_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2)

/*! @brief Set the di0_run_value_m1_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2(x, v) (HW_IPU_DI0_SW_GEN0_2_WR(x, (HW_IPU_DI0_SW_GEN0_2_RD(x) & ~BM_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2) | BF_IPU_DI0_SW_GEN0_2_di0_run_value_m1_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_3 - DI0 Sync Wave Gen 3 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_3 - DI0 Sync Wave Gen 3 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_3
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_3_bitfields
    {
        uint32_t di0_offset_resolution_3 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_3 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_3 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_3 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_3_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_3 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_3_ADDR(x) ((uintptr_t)(x) + 0x40014U)

#define HW_IPU_DI0_SW_GEN0_3(x)  (*(__IO hw_ipu_di0_sw_gen0_3_t *) HW_IPU_DI0_SW_GEN0_3_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_3_RD(x) (HW_IPU_DI0_SW_GEN0_3(x).U)
#define HW_IPU_DI0_SW_GEN0_3_WR(x, v) (HW_IPU_DI0_SW_GEN0_3(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_3_SET(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, HW_IPU_DI0_SW_GEN0_3_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_3_CLR(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, HW_IPU_DI0_SW_GEN0_3_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_3_TOG(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, HW_IPU_DI0_SW_GEN0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_3 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_3, field di0_offset_resolution_3[2:0] (RW)
 *
 * DI0 counter #3 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_3_di0_offset_resolution_3. */
#define BM_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_3_di0_offset_resolution_3. */
#define BS_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_3_di0_offset_resolution_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_3_di0_offset_resolution_3 field. */
#define BR_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3(x) (HW_IPU_DI0_SW_GEN0_3(x).B.di0_offset_resolution_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_3_di0_offset_resolution_3. */
#define BF_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3) & BM_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3)

/*! @brief Set the di0_offset_resolution_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, (HW_IPU_DI0_SW_GEN0_3_RD(x) & ~BM_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3) | BF_IPU_DI0_SW_GEN0_3_di0_offset_resolution_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_3, field di0_offset_value_3[14:3] (RW)
 *
 * DI0 counter #3 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_3_di0_offset_value_3 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_3_di0_offset_value_3. */
#define BM_IPU_DI0_SW_GEN0_3_di0_offset_value_3 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_3_di0_offset_value_3. */
#define BS_IPU_DI0_SW_GEN0_3_di0_offset_value_3 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_3_di0_offset_value_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_3_di0_offset_value_3 field. */
#define BR_IPU_DI0_SW_GEN0_3_di0_offset_value_3(x) (HW_IPU_DI0_SW_GEN0_3(x).B.di0_offset_value_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_3_di0_offset_value_3. */
#define BF_IPU_DI0_SW_GEN0_3_di0_offset_value_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_3_di0_offset_value_3) & BM_IPU_DI0_SW_GEN0_3_di0_offset_value_3)

/*! @brief Set the di0_offset_value_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_3_di0_offset_value_3(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, (HW_IPU_DI0_SW_GEN0_3_RD(x) & ~BM_IPU_DI0_SW_GEN0_3_di0_offset_value_3) | BF_IPU_DI0_SW_GEN0_3_di0_offset_value_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_3, field di0_run_resolution_3[18:16] (RW)
 *
 * DI0 counter #3 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_3_di0_run_resolution_3 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_3_di0_run_resolution_3. */
#define BM_IPU_DI0_SW_GEN0_3_di0_run_resolution_3 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_3_di0_run_resolution_3. */
#define BS_IPU_DI0_SW_GEN0_3_di0_run_resolution_3 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_3_di0_run_resolution_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_3_di0_run_resolution_3 field. */
#define BR_IPU_DI0_SW_GEN0_3_di0_run_resolution_3(x) (HW_IPU_DI0_SW_GEN0_3(x).B.di0_run_resolution_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_3_di0_run_resolution_3. */
#define BF_IPU_DI0_SW_GEN0_3_di0_run_resolution_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_3_di0_run_resolution_3) & BM_IPU_DI0_SW_GEN0_3_di0_run_resolution_3)

/*! @brief Set the di0_run_resolution_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_3_di0_run_resolution_3(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, (HW_IPU_DI0_SW_GEN0_3_RD(x) & ~BM_IPU_DI0_SW_GEN0_3_di0_run_resolution_3) | BF_IPU_DI0_SW_GEN0_3_di0_run_resolution_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_3, field di0_run_value_m1_3[30:19] (RW)
 *
 * DI0 counter #3 pre defined value This fields defines the counter #3 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_3 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_3_di0_run_value_m1_3. */
#define BM_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_3_di0_run_value_m1_3. */
#define BS_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_3_di0_run_value_m1_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_3_di0_run_value_m1_3 field. */
#define BR_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3(x) (HW_IPU_DI0_SW_GEN0_3(x).B.di0_run_value_m1_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_3_di0_run_value_m1_3. */
#define BF_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3) & BM_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3)

/*! @brief Set the di0_run_value_m1_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3(x, v) (HW_IPU_DI0_SW_GEN0_3_WR(x, (HW_IPU_DI0_SW_GEN0_3_RD(x) & ~BM_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3) | BF_IPU_DI0_SW_GEN0_3_di0_run_value_m1_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_4 - DI0 Sync Wave Gen 4 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_4 - DI0 Sync Wave Gen 4 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_4
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_4_bitfields
    {
        uint32_t di0_offset_resolution_4 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_4 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_4 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_4 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_4_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_4 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_4_ADDR(x) ((uintptr_t)(x) + 0x40018U)

#define HW_IPU_DI0_SW_GEN0_4(x)  (*(__IO hw_ipu_di0_sw_gen0_4_t *) HW_IPU_DI0_SW_GEN0_4_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_4_RD(x) (HW_IPU_DI0_SW_GEN0_4(x).U)
#define HW_IPU_DI0_SW_GEN0_4_WR(x, v) (HW_IPU_DI0_SW_GEN0_4(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_4_SET(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, HW_IPU_DI0_SW_GEN0_4_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_4_CLR(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, HW_IPU_DI0_SW_GEN0_4_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_4_TOG(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, HW_IPU_DI0_SW_GEN0_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_4 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_4, field di0_offset_resolution_4[2:0] (RW)
 *
 * DI0 counter #4 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_4_di0_offset_resolution_4. */
#define BM_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_4_di0_offset_resolution_4. */
#define BS_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_4_di0_offset_resolution_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_4_di0_offset_resolution_4 field. */
#define BR_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4(x) (HW_IPU_DI0_SW_GEN0_4(x).B.di0_offset_resolution_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_4_di0_offset_resolution_4. */
#define BF_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4) & BM_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4)

/*! @brief Set the di0_offset_resolution_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, (HW_IPU_DI0_SW_GEN0_4_RD(x) & ~BM_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4) | BF_IPU_DI0_SW_GEN0_4_di0_offset_resolution_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_4, field di0_offset_value_4[14:3] (RW)
 *
 * DI0 counter #4 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_4_di0_offset_value_4 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_4_di0_offset_value_4. */
#define BM_IPU_DI0_SW_GEN0_4_di0_offset_value_4 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_4_di0_offset_value_4. */
#define BS_IPU_DI0_SW_GEN0_4_di0_offset_value_4 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_4_di0_offset_value_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_4_di0_offset_value_4 field. */
#define BR_IPU_DI0_SW_GEN0_4_di0_offset_value_4(x) (HW_IPU_DI0_SW_GEN0_4(x).B.di0_offset_value_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_4_di0_offset_value_4. */
#define BF_IPU_DI0_SW_GEN0_4_di0_offset_value_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_4_di0_offset_value_4) & BM_IPU_DI0_SW_GEN0_4_di0_offset_value_4)

/*! @brief Set the di0_offset_value_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_4_di0_offset_value_4(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, (HW_IPU_DI0_SW_GEN0_4_RD(x) & ~BM_IPU_DI0_SW_GEN0_4_di0_offset_value_4) | BF_IPU_DI0_SW_GEN0_4_di0_offset_value_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_4, field di0_run_resolution_4[18:16] (RW)
 *
 * DI0 counter #4 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_4_di0_run_resolution_4 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_4_di0_run_resolution_4. */
#define BM_IPU_DI0_SW_GEN0_4_di0_run_resolution_4 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_4_di0_run_resolution_4. */
#define BS_IPU_DI0_SW_GEN0_4_di0_run_resolution_4 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_4_di0_run_resolution_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_4_di0_run_resolution_4 field. */
#define BR_IPU_DI0_SW_GEN0_4_di0_run_resolution_4(x) (HW_IPU_DI0_SW_GEN0_4(x).B.di0_run_resolution_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_4_di0_run_resolution_4. */
#define BF_IPU_DI0_SW_GEN0_4_di0_run_resolution_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_4_di0_run_resolution_4) & BM_IPU_DI0_SW_GEN0_4_di0_run_resolution_4)

/*! @brief Set the di0_run_resolution_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_4_di0_run_resolution_4(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, (HW_IPU_DI0_SW_GEN0_4_RD(x) & ~BM_IPU_DI0_SW_GEN0_4_di0_run_resolution_4) | BF_IPU_DI0_SW_GEN0_4_di0_run_resolution_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_4, field di0_run_value_m1_4[30:19] (RW)
 *
 * DI0 counter #4 pre defined value This fields defines the counter #4 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_4 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_4_di0_run_value_m1_4. */
#define BM_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_4_di0_run_value_m1_4. */
#define BS_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_4_di0_run_value_m1_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_4_di0_run_value_m1_4 field. */
#define BR_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4(x) (HW_IPU_DI0_SW_GEN0_4(x).B.di0_run_value_m1_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_4_di0_run_value_m1_4. */
#define BF_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4) & BM_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4)

/*! @brief Set the di0_run_value_m1_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4(x, v) (HW_IPU_DI0_SW_GEN0_4_WR(x, (HW_IPU_DI0_SW_GEN0_4_RD(x) & ~BM_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4) | BF_IPU_DI0_SW_GEN0_4_di0_run_value_m1_4(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_5 - DI0 Sync Wave Gen 5 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_5 - DI0 Sync Wave Gen 5 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_5
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_5_bitfields
    {
        uint32_t di0_offset_resolution_5 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_5 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_5 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_5 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_5_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_5 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_5_ADDR(x) ((uintptr_t)(x) + 0x4001CU)

#define HW_IPU_DI0_SW_GEN0_5(x)  (*(__IO hw_ipu_di0_sw_gen0_5_t *) HW_IPU_DI0_SW_GEN0_5_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_5_RD(x) (HW_IPU_DI0_SW_GEN0_5(x).U)
#define HW_IPU_DI0_SW_GEN0_5_WR(x, v) (HW_IPU_DI0_SW_GEN0_5(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_5_SET(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, HW_IPU_DI0_SW_GEN0_5_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_5_CLR(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, HW_IPU_DI0_SW_GEN0_5_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_5_TOG(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, HW_IPU_DI0_SW_GEN0_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_5 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_5, field di0_offset_resolution_5[2:0] (RW)
 *
 * DI0 counter #5 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - -The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_5_di0_offset_resolution_5. */
#define BM_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_5_di0_offset_resolution_5. */
#define BS_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_5_di0_offset_resolution_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_5_di0_offset_resolution_5 field. */
#define BR_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5(x) (HW_IPU_DI0_SW_GEN0_5(x).B.di0_offset_resolution_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_5_di0_offset_resolution_5. */
#define BF_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5) & BM_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5)

/*! @brief Set the di0_offset_resolution_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, (HW_IPU_DI0_SW_GEN0_5_RD(x) & ~BM_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5) | BF_IPU_DI0_SW_GEN0_5_di0_offset_resolution_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_5, field di0_offset_value_5[14:3] (RW)
 *
 * DI0 counter #5 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_5_di0_offset_value_5 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_5_di0_offset_value_5. */
#define BM_IPU_DI0_SW_GEN0_5_di0_offset_value_5 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_5_di0_offset_value_5. */
#define BS_IPU_DI0_SW_GEN0_5_di0_offset_value_5 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_5_di0_offset_value_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_5_di0_offset_value_5 field. */
#define BR_IPU_DI0_SW_GEN0_5_di0_offset_value_5(x) (HW_IPU_DI0_SW_GEN0_5(x).B.di0_offset_value_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_5_di0_offset_value_5. */
#define BF_IPU_DI0_SW_GEN0_5_di0_offset_value_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_5_di0_offset_value_5) & BM_IPU_DI0_SW_GEN0_5_di0_offset_value_5)

/*! @brief Set the di0_offset_value_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_5_di0_offset_value_5(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, (HW_IPU_DI0_SW_GEN0_5_RD(x) & ~BM_IPU_DI0_SW_GEN0_5_di0_offset_value_5) | BF_IPU_DI0_SW_GEN0_5_di0_offset_value_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_5, field di0_run_resolution_5[18:16] (RW)
 *
 * DI0 counter #5 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_5_di0_run_resolution_5 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_5_di0_run_resolution_5. */
#define BM_IPU_DI0_SW_GEN0_5_di0_run_resolution_5 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_5_di0_run_resolution_5. */
#define BS_IPU_DI0_SW_GEN0_5_di0_run_resolution_5 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_5_di0_run_resolution_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_5_di0_run_resolution_5 field. */
#define BR_IPU_DI0_SW_GEN0_5_di0_run_resolution_5(x) (HW_IPU_DI0_SW_GEN0_5(x).B.di0_run_resolution_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_5_di0_run_resolution_5. */
#define BF_IPU_DI0_SW_GEN0_5_di0_run_resolution_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_5_di0_run_resolution_5) & BM_IPU_DI0_SW_GEN0_5_di0_run_resolution_5)

/*! @brief Set the di0_run_resolution_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_5_di0_run_resolution_5(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, (HW_IPU_DI0_SW_GEN0_5_RD(x) & ~BM_IPU_DI0_SW_GEN0_5_di0_run_resolution_5) | BF_IPU_DI0_SW_GEN0_5_di0_run_resolution_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_5, field di0_run_value_m1_5[30:19] (RW)
 *
 * DI0 counter #5 pre defined value This fields defines the counter #5 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_5 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_5_di0_run_value_m1_5. */
#define BM_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_5_di0_run_value_m1_5. */
#define BS_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_5_di0_run_value_m1_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_5_di0_run_value_m1_5 field. */
#define BR_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5(x) (HW_IPU_DI0_SW_GEN0_5(x).B.di0_run_value_m1_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_5_di0_run_value_m1_5. */
#define BF_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5) & BM_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5)

/*! @brief Set the di0_run_value_m1_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5(x, v) (HW_IPU_DI0_SW_GEN0_5_WR(x, (HW_IPU_DI0_SW_GEN0_5_RD(x) & ~BM_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5) | BF_IPU_DI0_SW_GEN0_5_di0_run_value_m1_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_6 - DI0 Sync Wave Gen 6 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_6 - DI0 Sync Wave Gen 6 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_6
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_6_bitfields
    {
        uint32_t di0_offset_resolution_6 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_6 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_6 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_6 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_6_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_6 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_6_ADDR(x) ((uintptr_t)(x) + 0x40020U)

#define HW_IPU_DI0_SW_GEN0_6(x)  (*(__IO hw_ipu_di0_sw_gen0_6_t *) HW_IPU_DI0_SW_GEN0_6_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_6_RD(x) (HW_IPU_DI0_SW_GEN0_6(x).U)
#define HW_IPU_DI0_SW_GEN0_6_WR(x, v) (HW_IPU_DI0_SW_GEN0_6(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_6_SET(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, HW_IPU_DI0_SW_GEN0_6_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_6_CLR(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, HW_IPU_DI0_SW_GEN0_6_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_6_TOG(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, HW_IPU_DI0_SW_GEN0_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_6 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_6, field di0_offset_resolution_6[2:0] (RW)
 *
 * DI0 counter #6 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_6_di0_offset_resolution_6. */
#define BM_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_6_di0_offset_resolution_6. */
#define BS_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_6_di0_offset_resolution_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_6_di0_offset_resolution_6 field. */
#define BR_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6(x) (HW_IPU_DI0_SW_GEN0_6(x).B.di0_offset_resolution_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_6_di0_offset_resolution_6. */
#define BF_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6) & BM_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6)

/*! @brief Set the di0_offset_resolution_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, (HW_IPU_DI0_SW_GEN0_6_RD(x) & ~BM_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6) | BF_IPU_DI0_SW_GEN0_6_di0_offset_resolution_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_6, field di0_offset_value_6[14:3] (RW)
 *
 * DI0 counter #6 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_6_di0_offset_value_6 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_6_di0_offset_value_6. */
#define BM_IPU_DI0_SW_GEN0_6_di0_offset_value_6 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_6_di0_offset_value_6. */
#define BS_IPU_DI0_SW_GEN0_6_di0_offset_value_6 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_6_di0_offset_value_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_6_di0_offset_value_6 field. */
#define BR_IPU_DI0_SW_GEN0_6_di0_offset_value_6(x) (HW_IPU_DI0_SW_GEN0_6(x).B.di0_offset_value_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_6_di0_offset_value_6. */
#define BF_IPU_DI0_SW_GEN0_6_di0_offset_value_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_6_di0_offset_value_6) & BM_IPU_DI0_SW_GEN0_6_di0_offset_value_6)

/*! @brief Set the di0_offset_value_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_6_di0_offset_value_6(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, (HW_IPU_DI0_SW_GEN0_6_RD(x) & ~BM_IPU_DI0_SW_GEN0_6_di0_offset_value_6) | BF_IPU_DI0_SW_GEN0_6_di0_offset_value_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_6, field di0_run_resolution_6[18:16] (RW)
 *
 * DI0 counter #6 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_6_di0_run_resolution_6 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_6_di0_run_resolution_6. */
#define BM_IPU_DI0_SW_GEN0_6_di0_run_resolution_6 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_6_di0_run_resolution_6. */
#define BS_IPU_DI0_SW_GEN0_6_di0_run_resolution_6 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_6_di0_run_resolution_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_6_di0_run_resolution_6 field. */
#define BR_IPU_DI0_SW_GEN0_6_di0_run_resolution_6(x) (HW_IPU_DI0_SW_GEN0_6(x).B.di0_run_resolution_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_6_di0_run_resolution_6. */
#define BF_IPU_DI0_SW_GEN0_6_di0_run_resolution_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_6_di0_run_resolution_6) & BM_IPU_DI0_SW_GEN0_6_di0_run_resolution_6)

/*! @brief Set the di0_run_resolution_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_6_di0_run_resolution_6(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, (HW_IPU_DI0_SW_GEN0_6_RD(x) & ~BM_IPU_DI0_SW_GEN0_6_di0_run_resolution_6) | BF_IPU_DI0_SW_GEN0_6_di0_run_resolution_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_6, field di0_run_value_m1_6[30:19] (RW)
 *
 * DI0 counter #6 pre defined value This fields defines the counter #6 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_6 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_6_di0_run_value_m1_6. */
#define BM_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_6_di0_run_value_m1_6. */
#define BS_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_6_di0_run_value_m1_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_6_di0_run_value_m1_6 field. */
#define BR_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6(x) (HW_IPU_DI0_SW_GEN0_6(x).B.di0_run_value_m1_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_6_di0_run_value_m1_6. */
#define BF_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6) & BM_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6)

/*! @brief Set the di0_run_value_m1_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6(x, v) (HW_IPU_DI0_SW_GEN0_6_WR(x, (HW_IPU_DI0_SW_GEN0_6_RD(x) & ~BM_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6) | BF_IPU_DI0_SW_GEN0_6_di0_run_value_m1_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_7 - DI0 Sync Wave Gen 7 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_7 - DI0 Sync Wave Gen 7 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_7
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_7_bitfields
    {
        uint32_t di0_offset_resolution_1 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_7 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_7 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_7 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_7_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_7 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_7_ADDR(x) ((uintptr_t)(x) + 0x40024U)

#define HW_IPU_DI0_SW_GEN0_7(x)  (*(__IO hw_ipu_di0_sw_gen0_7_t *) HW_IPU_DI0_SW_GEN0_7_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_7_RD(x) (HW_IPU_DI0_SW_GEN0_7(x).U)
#define HW_IPU_DI0_SW_GEN0_7_WR(x, v) (HW_IPU_DI0_SW_GEN0_7(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_7_SET(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, HW_IPU_DI0_SW_GEN0_7_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_7_CLR(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, HW_IPU_DI0_SW_GEN0_7_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_7_TOG(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, HW_IPU_DI0_SW_GEN0_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_7 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_7, field di0_offset_resolution_1[2:0] (RW)
 *
 * DI0 counter #7 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_7_di0_offset_resolution_1. */
#define BM_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_7_di0_offset_resolution_1. */
#define BS_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_7_di0_offset_resolution_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_7_di0_offset_resolution_1 field. */
#define BR_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1(x) (HW_IPU_DI0_SW_GEN0_7(x).B.di0_offset_resolution_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_7_di0_offset_resolution_1. */
#define BF_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1) & BM_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1)

/*! @brief Set the di0_offset_resolution_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, (HW_IPU_DI0_SW_GEN0_7_RD(x) & ~BM_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1) | BF_IPU_DI0_SW_GEN0_7_di0_offset_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_7, field di0_offset_value_7[14:3] (RW)
 *
 * DI0 counter #7 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_7_di0_offset_value_7 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_7_di0_offset_value_7. */
#define BM_IPU_DI0_SW_GEN0_7_di0_offset_value_7 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_7_di0_offset_value_7. */
#define BS_IPU_DI0_SW_GEN0_7_di0_offset_value_7 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_7_di0_offset_value_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_7_di0_offset_value_7 field. */
#define BR_IPU_DI0_SW_GEN0_7_di0_offset_value_7(x) (HW_IPU_DI0_SW_GEN0_7(x).B.di0_offset_value_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_7_di0_offset_value_7. */
#define BF_IPU_DI0_SW_GEN0_7_di0_offset_value_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_7_di0_offset_value_7) & BM_IPU_DI0_SW_GEN0_7_di0_offset_value_7)

/*! @brief Set the di0_offset_value_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_7_di0_offset_value_7(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, (HW_IPU_DI0_SW_GEN0_7_RD(x) & ~BM_IPU_DI0_SW_GEN0_7_di0_offset_value_7) | BF_IPU_DI0_SW_GEN0_7_di0_offset_value_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_7, field di0_run_resolution_7[18:16] (RW)
 *
 * DI0 counter #1 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_7_di0_run_resolution_7 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_7_di0_run_resolution_7. */
#define BM_IPU_DI0_SW_GEN0_7_di0_run_resolution_7 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_7_di0_run_resolution_7. */
#define BS_IPU_DI0_SW_GEN0_7_di0_run_resolution_7 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_7_di0_run_resolution_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_7_di0_run_resolution_7 field. */
#define BR_IPU_DI0_SW_GEN0_7_di0_run_resolution_7(x) (HW_IPU_DI0_SW_GEN0_7(x).B.di0_run_resolution_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_7_di0_run_resolution_7. */
#define BF_IPU_DI0_SW_GEN0_7_di0_run_resolution_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_7_di0_run_resolution_7) & BM_IPU_DI0_SW_GEN0_7_di0_run_resolution_7)

/*! @brief Set the di0_run_resolution_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_7_di0_run_resolution_7(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, (HW_IPU_DI0_SW_GEN0_7_RD(x) & ~BM_IPU_DI0_SW_GEN0_7_di0_run_resolution_7) | BF_IPU_DI0_SW_GEN0_7_di0_run_resolution_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_7, field di0_run_value_m1_7[30:19] (RW)
 *
 * DI0 counter #7 pre defined value This fields defines the counter #7 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_7 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_7_di0_run_value_m1_7. */
#define BM_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_7_di0_run_value_m1_7. */
#define BS_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_7_di0_run_value_m1_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_7_di0_run_value_m1_7 field. */
#define BR_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7(x) (HW_IPU_DI0_SW_GEN0_7(x).B.di0_run_value_m1_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_7_di0_run_value_m1_7. */
#define BF_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7) & BM_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7)

/*! @brief Set the di0_run_value_m1_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7(x, v) (HW_IPU_DI0_SW_GEN0_7_WR(x, (HW_IPU_DI0_SW_GEN0_7_RD(x) & ~BM_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7) | BF_IPU_DI0_SW_GEN0_7_di0_run_value_m1_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_8 - DI0 Sync Wave Gen 8 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_8 - DI0 Sync Wave Gen 8 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_8
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_8_bitfields
    {
        uint32_t di0_offset_resolution_8 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_8 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_8 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_8 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_8_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_8 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_8_ADDR(x) ((uintptr_t)(x) + 0x40028U)

#define HW_IPU_DI0_SW_GEN0_8(x)  (*(__IO hw_ipu_di0_sw_gen0_8_t *) HW_IPU_DI0_SW_GEN0_8_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_8_RD(x) (HW_IPU_DI0_SW_GEN0_8(x).U)
#define HW_IPU_DI0_SW_GEN0_8_WR(x, v) (HW_IPU_DI0_SW_GEN0_8(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_8_SET(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, HW_IPU_DI0_SW_GEN0_8_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_8_CLR(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, HW_IPU_DI0_SW_GEN0_8_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_8_TOG(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, HW_IPU_DI0_SW_GEN0_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_8 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_8, field di0_offset_resolution_8[2:0] (RW)
 *
 * DI0 counter #8 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_8_di0_offset_resolution_8. */
#define BM_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_8_di0_offset_resolution_8. */
#define BS_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_8_di0_offset_resolution_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_8_di0_offset_resolution_8 field. */
#define BR_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8(x) (HW_IPU_DI0_SW_GEN0_8(x).B.di0_offset_resolution_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_8_di0_offset_resolution_8. */
#define BF_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8) & BM_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8)

/*! @brief Set the di0_offset_resolution_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, (HW_IPU_DI0_SW_GEN0_8_RD(x) & ~BM_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8) | BF_IPU_DI0_SW_GEN0_8_di0_offset_resolution_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_8, field di0_offset_value_8[14:3] (RW)
 *
 * DI0 counter #8 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_8_di0_offset_value_8 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_8_di0_offset_value_8. */
#define BM_IPU_DI0_SW_GEN0_8_di0_offset_value_8 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_8_di0_offset_value_8. */
#define BS_IPU_DI0_SW_GEN0_8_di0_offset_value_8 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_8_di0_offset_value_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_8_di0_offset_value_8 field. */
#define BR_IPU_DI0_SW_GEN0_8_di0_offset_value_8(x) (HW_IPU_DI0_SW_GEN0_8(x).B.di0_offset_value_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_8_di0_offset_value_8. */
#define BF_IPU_DI0_SW_GEN0_8_di0_offset_value_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_8_di0_offset_value_8) & BM_IPU_DI0_SW_GEN0_8_di0_offset_value_8)

/*! @brief Set the di0_offset_value_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_8_di0_offset_value_8(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, (HW_IPU_DI0_SW_GEN0_8_RD(x) & ~BM_IPU_DI0_SW_GEN0_8_di0_offset_value_8) | BF_IPU_DI0_SW_GEN0_8_di0_offset_value_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_8, field di0_run_resolution_8[18:16] (RW)
 *
 * DI0 counter #8 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_8_di0_run_resolution_8 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_8_di0_run_resolution_8. */
#define BM_IPU_DI0_SW_GEN0_8_di0_run_resolution_8 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_8_di0_run_resolution_8. */
#define BS_IPU_DI0_SW_GEN0_8_di0_run_resolution_8 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_8_di0_run_resolution_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_8_di0_run_resolution_8 field. */
#define BR_IPU_DI0_SW_GEN0_8_di0_run_resolution_8(x) (HW_IPU_DI0_SW_GEN0_8(x).B.di0_run_resolution_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_8_di0_run_resolution_8. */
#define BF_IPU_DI0_SW_GEN0_8_di0_run_resolution_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_8_di0_run_resolution_8) & BM_IPU_DI0_SW_GEN0_8_di0_run_resolution_8)

/*! @brief Set the di0_run_resolution_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_8_di0_run_resolution_8(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, (HW_IPU_DI0_SW_GEN0_8_RD(x) & ~BM_IPU_DI0_SW_GEN0_8_di0_run_resolution_8) | BF_IPU_DI0_SW_GEN0_8_di0_run_resolution_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_8, field di0_run_value_m1_8[30:19] (RW)
 *
 * DI0 counter #8 pre defined value This fields defines the counter #8 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_8 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_8_di0_run_value_m1_8. */
#define BM_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_8_di0_run_value_m1_8. */
#define BS_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_8_di0_run_value_m1_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_8_di0_run_value_m1_8 field. */
#define BR_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8(x) (HW_IPU_DI0_SW_GEN0_8(x).B.di0_run_value_m1_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_8_di0_run_value_m1_8. */
#define BF_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8) & BM_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8)

/*! @brief Set the di0_run_value_m1_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8(x, v) (HW_IPU_DI0_SW_GEN0_8_WR(x, (HW_IPU_DI0_SW_GEN0_8_RD(x) & ~BM_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8) | BF_IPU_DI0_SW_GEN0_8_di0_run_value_m1_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN0_9 - DI0 Sync Wave Gen 9 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN0_9 - DI0 Sync Wave Gen 9 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen0_9
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen0_9_bitfields
    {
        uint32_t di0_offset_resolution_9 : 3; /*!< [2:0]  */
        uint32_t di0_offset_value_9 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_run_resolution_9 : 3; /*!< [18:16]  */
        uint32_t di0_run_value_m1_9 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen0_9_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN0_9 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN0_9_ADDR(x) ((uintptr_t)(x) + 0x4002CU)

#define HW_IPU_DI0_SW_GEN0_9(x)  (*(__IO hw_ipu_di0_sw_gen0_9_t *) HW_IPU_DI0_SW_GEN0_9_ADDR(x))
#define HW_IPU_DI0_SW_GEN0_9_RD(x) (HW_IPU_DI0_SW_GEN0_9(x).U)
#define HW_IPU_DI0_SW_GEN0_9_WR(x, v) (HW_IPU_DI0_SW_GEN0_9(x).U = (v))
#define HW_IPU_DI0_SW_GEN0_9_SET(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, HW_IPU_DI0_SW_GEN0_9_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN0_9_CLR(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, HW_IPU_DI0_SW_GEN0_9_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN0_9_TOG(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, HW_IPU_DI0_SW_GEN0_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN0_9 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN0_9, field di0_offset_resolution_9[2:0] (RW)
 *
 * DI0 counter #9 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9 (0U) /*!< Bit position for IPU_DI0_SW_GEN0_9_di0_offset_resolution_9. */
#define BM_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9 (0x00000007U) /*!< Bit mask for IPU_DI0_SW_GEN0_9_di0_offset_resolution_9. */
#define BS_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_9_di0_offset_resolution_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_9_di0_offset_resolution_9 field. */
#define BR_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9(x) (HW_IPU_DI0_SW_GEN0_9(x).B.di0_offset_resolution_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_9_di0_offset_resolution_9. */
#define BF_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9) & BM_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9)

/*! @brief Set the di0_offset_resolution_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, (HW_IPU_DI0_SW_GEN0_9_RD(x) & ~BM_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9) | BF_IPU_DI0_SW_GEN0_9_di0_offset_resolution_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_9, field di0_offset_value_9[14:3] (RW)
 *
 * DI0 counter #9 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_9_di0_offset_value_9 (3U) /*!< Bit position for IPU_DI0_SW_GEN0_9_di0_offset_value_9. */
#define BM_IPU_DI0_SW_GEN0_9_di0_offset_value_9 (0x00007FF8U) /*!< Bit mask for IPU_DI0_SW_GEN0_9_di0_offset_value_9. */
#define BS_IPU_DI0_SW_GEN0_9_di0_offset_value_9 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_9_di0_offset_value_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_9_di0_offset_value_9 field. */
#define BR_IPU_DI0_SW_GEN0_9_di0_offset_value_9(x) (HW_IPU_DI0_SW_GEN0_9(x).B.di0_offset_value_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_9_di0_offset_value_9. */
#define BF_IPU_DI0_SW_GEN0_9_di0_offset_value_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_9_di0_offset_value_9) & BM_IPU_DI0_SW_GEN0_9_di0_offset_value_9)

/*! @brief Set the di0_offset_value_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_9_di0_offset_value_9(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, (HW_IPU_DI0_SW_GEN0_9_RD(x) & ~BM_IPU_DI0_SW_GEN0_9_di0_offset_value_9) | BF_IPU_DI0_SW_GEN0_9_di0_offset_value_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_9, field di0_run_resolution_9[18:16] (RW)
 *
 * DI0 counter #9 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_9_di0_run_resolution_9 (16U) /*!< Bit position for IPU_DI0_SW_GEN0_9_di0_run_resolution_9. */
#define BM_IPU_DI0_SW_GEN0_9_di0_run_resolution_9 (0x00070000U) /*!< Bit mask for IPU_DI0_SW_GEN0_9_di0_run_resolution_9. */
#define BS_IPU_DI0_SW_GEN0_9_di0_run_resolution_9 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_9_di0_run_resolution_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_9_di0_run_resolution_9 field. */
#define BR_IPU_DI0_SW_GEN0_9_di0_run_resolution_9(x) (HW_IPU_DI0_SW_GEN0_9(x).B.di0_run_resolution_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_9_di0_run_resolution_9. */
#define BF_IPU_DI0_SW_GEN0_9_di0_run_resolution_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_9_di0_run_resolution_9) & BM_IPU_DI0_SW_GEN0_9_di0_run_resolution_9)

/*! @brief Set the di0_run_resolution_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_9_di0_run_resolution_9(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, (HW_IPU_DI0_SW_GEN0_9_RD(x) & ~BM_IPU_DI0_SW_GEN0_9_di0_run_resolution_9) | BF_IPU_DI0_SW_GEN0_9_di0_run_resolution_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN0_9, field di0_run_value_m1_9[30:19] (RW)
 *
 * DI0 counter #9 pre defined value This fields defines the counter #9 pre
 * defines value. When the counter is auto reload mode (di0_cnt_auto_reload_9 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di0_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9 (19U) /*!< Bit position for IPU_DI0_SW_GEN0_9_di0_run_value_m1_9. */
#define BM_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9 (0x7FF80000U) /*!< Bit mask for IPU_DI0_SW_GEN0_9_di0_run_value_m1_9. */
#define BS_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9 (12U) /*!< Bit field size in bits for IPU_DI0_SW_GEN0_9_di0_run_value_m1_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN0_9_di0_run_value_m1_9 field. */
#define BR_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9(x) (HW_IPU_DI0_SW_GEN0_9(x).B.di0_run_value_m1_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN0_9_di0_run_value_m1_9. */
#define BF_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9) & BM_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9)

/*! @brief Set the di0_run_value_m1_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9(x, v) (HW_IPU_DI0_SW_GEN0_9_WR(x, (HW_IPU_DI0_SW_GEN0_9_RD(x) & ~BM_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9) | BF_IPU_DI0_SW_GEN0_9_di0_run_value_m1_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_1 - DI0 Sync Wave Gen 1 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_1 - DI0 Sync Wave Gen 1 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_1
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_1_bitfields
    {
        uint32_t di0_cnt_up_1 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_1 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_1 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_1 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_1 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_1 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_1 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_1_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_1 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_1_ADDR(x) ((uintptr_t)(x) + 0x40030U)

#define HW_IPU_DI0_SW_GEN1_1(x)  (*(__IO hw_ipu_di0_sw_gen1_1_t *) HW_IPU_DI0_SW_GEN1_1_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_1_RD(x) (HW_IPU_DI0_SW_GEN1_1(x).U)
#define HW_IPU_DI0_SW_GEN1_1_WR(x, v) (HW_IPU_DI0_SW_GEN1_1(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_1_SET(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, HW_IPU_DI0_SW_GEN1_1_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_1_CLR(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, HW_IPU_DI0_SW_GEN1_1_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_1_TOG(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, HW_IPU_DI0_SW_GEN1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_1 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_up_1[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_up_1 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_up_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_up_1 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_up_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_up_1 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_up_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_up_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_up_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_up_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_up_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_up_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_up_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_up_1)

/*! @brief Set the di0_cnt_up_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_up_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_up_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_up_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_polarity_clr_sel_1[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_polarity_clr_sel_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1)

/*! @brief Set the di0_cnt_polarity_clr_sel_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_clr_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_polarity_trigger_sel_1[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_polarity_trigger_sel_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1)

/*! @brief Set the di0_cnt_polarity_trigger_sel_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_trigger_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_down_1[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_down_1 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_down_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_down_1 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_down_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_down_1 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_down_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_down_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_down_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_down_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_down_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_down_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_down_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_down_1)

/*! @brief Set the di0_cnt_down_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_down_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_down_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_down_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_clr_sel_1[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_clr_sel_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1)

/*! @brief Set the di0_cnt_clr_sel_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_clr_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_auto_reload_1[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_1 field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_auto_reload_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1)

/*! @brief Set the di0_cnt_auto_reload_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_auto_reload_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_1, field di0_cnt_polarity_gen_en_1[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1. */
#define BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1. */
#define BS_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1 field. */
#define BR_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1(x) (HW_IPU_DI0_SW_GEN1_1(x).B.di0_cnt_polarity_gen_en_1)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1. */
#define BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1) & BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1)

/*! @brief Set the di0_cnt_polarity_gen_en_1 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1(x, v) (HW_IPU_DI0_SW_GEN1_1_WR(x, (HW_IPU_DI0_SW_GEN1_1_RD(x) & ~BM_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1) | BF_IPU_DI0_SW_GEN1_1_di0_cnt_polarity_gen_en_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_2 - DI0 Sync Wave Gen 2 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_2 - DI0 Sync Wave Gen 2 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_2
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_2_bitfields
    {
        uint32_t di0_cnt_up_2 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_2 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_2 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_2 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_2 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_2 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_2 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_2_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_2 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_2_ADDR(x) ((uintptr_t)(x) + 0x40034U)

#define HW_IPU_DI0_SW_GEN1_2(x)  (*(__IO hw_ipu_di0_sw_gen1_2_t *) HW_IPU_DI0_SW_GEN1_2_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_2_RD(x) (HW_IPU_DI0_SW_GEN1_2(x).U)
#define HW_IPU_DI0_SW_GEN1_2_WR(x, v) (HW_IPU_DI0_SW_GEN1_2(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_2_SET(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, HW_IPU_DI0_SW_GEN1_2_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_2_CLR(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, HW_IPU_DI0_SW_GEN1_2_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_2_TOG(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, HW_IPU_DI0_SW_GEN1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_2 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_up_2[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_up_2 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_up_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_up_2 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_up_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_up_2 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_up_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_up_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_up_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_up_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_up_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_up_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_up_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_up_2)

/*! @brief Set the di0_cnt_up_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_up_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_up_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_up_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_polarity_clr_sel_2[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_polarity_clr_sel_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2)

/*! @brief Set the di0_cnt_polarity_clr_sel_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_clr_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_polarity_trigger_sel_2[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_polarity_trigger_sel_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2)

/*! @brief Set the di0_cnt_polarity_trigger_sel_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_trigger_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_down_2[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_down_2 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_down_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_down_2 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_down_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_down_2 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_down_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_down_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_down_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_down_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_down_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_down_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_down_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_down_2)

/*! @brief Set the di0_cnt_down_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_down_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_down_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_down_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_clr_sel_2[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_clr_sel_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2)

/*! @brief Set the di0_cnt_clr_sel_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_clr_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_auto_reload_2[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_auto_reload_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2)

/*! @brief Set the di0_cnt_auto_reload_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_auto_reload_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_2, field di0_cnt_polarity_gen_en_2[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2. */
#define BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2. */
#define BS_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2 field. */
#define BR_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2(x) (HW_IPU_DI0_SW_GEN1_2(x).B.di0_cnt_polarity_gen_en_2)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2. */
#define BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2) & BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2)

/*! @brief Set the di0_cnt_polarity_gen_en_2 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2(x, v) (HW_IPU_DI0_SW_GEN1_2_WR(x, (HW_IPU_DI0_SW_GEN1_2_RD(x) & ~BM_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2) | BF_IPU_DI0_SW_GEN1_2_di0_cnt_polarity_gen_en_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_3 - DI0 Sync Wave Gen 3 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_3 - DI0 Sync Wave Gen 3 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_3
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_3_bitfields
    {
        uint32_t di0_cnt_up_3 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_3 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_3 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_3 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_3 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_3 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_3 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_3_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_3 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_3_ADDR(x) ((uintptr_t)(x) + 0x40038U)

#define HW_IPU_DI0_SW_GEN1_3(x)  (*(__IO hw_ipu_di0_sw_gen1_3_t *) HW_IPU_DI0_SW_GEN1_3_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_3_RD(x) (HW_IPU_DI0_SW_GEN1_3(x).U)
#define HW_IPU_DI0_SW_GEN1_3_WR(x, v) (HW_IPU_DI0_SW_GEN1_3(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_3_SET(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, HW_IPU_DI0_SW_GEN1_3_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_3_CLR(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, HW_IPU_DI0_SW_GEN1_3_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_3_TOG(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, HW_IPU_DI0_SW_GEN1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_3 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_up_3[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_up_3 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_up_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_up_3 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_up_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_up_3 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_up_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_up_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_up_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_up_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_up_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_up_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_up_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_up_3)

/*! @brief Set the di0_cnt_up_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_up_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_up_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_up_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_polarity_clr_sel_3[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_polarity_clr_sel_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3)

/*! @brief Set the di0_cnt_polarity_clr_sel_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_clr_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_polarity_trigger_sel_3[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_polarity_trigger_sel_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3)

/*! @brief Set the di0_cnt_polarity_trigger_sel_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_trigger_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_down_3[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_down_3 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_down_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_down_3 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_down_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_down_3 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_down_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_down_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_down_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_down_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_down_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_down_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_down_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_down_3)

/*! @brief Set the di0_cnt_down_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_down_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_down_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_down_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_clr_sel_3[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_clr_sel_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3)

/*! @brief Set the di0_cnt_clr_sel_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_clr_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_auto_reload_3[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_auto_reload_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3)

/*! @brief Set the di0_cnt_auto_reload_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_auto_reload_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_3, field di0_cnt_polarity_gen_en_3[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3. */
#define BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3. */
#define BS_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3 field. */
#define BR_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3(x) (HW_IPU_DI0_SW_GEN1_3(x).B.di0_cnt_polarity_gen_en_3)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3. */
#define BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3) & BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3)

/*! @brief Set the di0_cnt_polarity_gen_en_3 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3(x, v) (HW_IPU_DI0_SW_GEN1_3_WR(x, (HW_IPU_DI0_SW_GEN1_3_RD(x) & ~BM_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3) | BF_IPU_DI0_SW_GEN1_3_di0_cnt_polarity_gen_en_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_4 - DI0 Sync Wave Gen 4 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_4 - DI0 Sync Wave Gen 4 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_4
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_4_bitfields
    {
        uint32_t di0_cnt_up_4 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_4 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_4 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_4 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_4 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_4 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_4 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_4_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_4 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_4_ADDR(x) ((uintptr_t)(x) + 0x4003CU)

#define HW_IPU_DI0_SW_GEN1_4(x)  (*(__IO hw_ipu_di0_sw_gen1_4_t *) HW_IPU_DI0_SW_GEN1_4_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_4_RD(x) (HW_IPU_DI0_SW_GEN1_4(x).U)
#define HW_IPU_DI0_SW_GEN1_4_WR(x, v) (HW_IPU_DI0_SW_GEN1_4(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_4_SET(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, HW_IPU_DI0_SW_GEN1_4_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_4_CLR(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, HW_IPU_DI0_SW_GEN1_4_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_4_TOG(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, HW_IPU_DI0_SW_GEN1_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_4 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_up_4[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_up_4 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_up_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_up_4 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_up_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_up_4 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_up_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_up_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_up_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_up_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_up_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_up_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_up_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_up_4)

/*! @brief Set the di0_cnt_up_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_up_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_up_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_up_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_polarity_clr_sel_4[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_polarity_clr_sel_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4)

/*! @brief Set the di0_cnt_polarity_clr_sel_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_clr_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_polarity_trigger_sel_4[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_polarity_trigger_sel_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4)

/*! @brief Set the di0_cnt_polarity_trigger_sel_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_trigger_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_down_4[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_down_4 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_down_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_down_4 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_down_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_down_4 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_down_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_down_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_down_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_down_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_down_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_down_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_down_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_down_4)

/*! @brief Set the di0_cnt_down_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_down_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_down_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_down_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_clr_sel_4[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_clr_sel_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4)

/*! @brief Set the di0_cnt_clr_sel_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_clr_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_auto_reload_4[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_auto_reload_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4)

/*! @brief Set the di0_cnt_auto_reload_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_auto_reload_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_4, field di0_cnt_polarity_gen_en_4[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4. */
#define BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4. */
#define BS_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4 field. */
#define BR_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4(x) (HW_IPU_DI0_SW_GEN1_4(x).B.di0_cnt_polarity_gen_en_4)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4. */
#define BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4) & BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4)

/*! @brief Set the di0_cnt_polarity_gen_en_4 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4(x, v) (HW_IPU_DI0_SW_GEN1_4_WR(x, (HW_IPU_DI0_SW_GEN1_4_RD(x) & ~BM_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4) | BF_IPU_DI0_SW_GEN1_4_di0_cnt_polarity_gen_en_4(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_5 - DI0 Sync Wave Gen 5 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_5 - DI0 Sync Wave Gen 5 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_5
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_5_bitfields
    {
        uint32_t di0_cnt_up_5 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_5 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_5 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_5 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_5 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_5 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_5 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_5_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_5 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_5_ADDR(x) ((uintptr_t)(x) + 0x40040U)

#define HW_IPU_DI0_SW_GEN1_5(x)  (*(__IO hw_ipu_di0_sw_gen1_5_t *) HW_IPU_DI0_SW_GEN1_5_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_5_RD(x) (HW_IPU_DI0_SW_GEN1_5(x).U)
#define HW_IPU_DI0_SW_GEN1_5_WR(x, v) (HW_IPU_DI0_SW_GEN1_5(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_5_SET(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, HW_IPU_DI0_SW_GEN1_5_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_5_CLR(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, HW_IPU_DI0_SW_GEN1_5_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_5_TOG(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, HW_IPU_DI0_SW_GEN1_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_5 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_up_5[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_up_5 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_up_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_up_5 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_up_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_up_5 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_up_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_up_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_up_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_up_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_up_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_up_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_up_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_up_5)

/*! @brief Set the di0_cnt_up_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_up_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_up_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_up_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_polarity_clr_sel_5[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_polarity_clr_sel_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5)

/*! @brief Set the di0_cnt_polarity_clr_sel_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_clr_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_polarity_trigger_sel_5[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_polarity_trigger_sel_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5)

/*! @brief Set the di0_cnt_polarity_trigger_sel_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_trigger_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_down_5[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_down_5 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_down_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_down_5 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_down_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_down_5 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_down_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_down_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_down_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_down_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_down_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_down_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_down_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_down_5)

/*! @brief Set the di0_cnt_down_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_down_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_down_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_down_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_clr_sel_5[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_clr_sel_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5)

/*! @brief Set the di0_cnt_clr_sel_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_clr_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_auto_reload_5[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_auto_reload_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5)

/*! @brief Set the di0_cnt_auto_reload_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_auto_reload_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_5, field di0_cnt_polarity_gen_en_5[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5. */
#define BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5. */
#define BS_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5 field. */
#define BR_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5(x) (HW_IPU_DI0_SW_GEN1_5(x).B.di0_cnt_polarity_gen_en_5)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5. */
#define BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5) & BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5)

/*! @brief Set the di0_cnt_polarity_gen_en_5 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5(x, v) (HW_IPU_DI0_SW_GEN1_5_WR(x, (HW_IPU_DI0_SW_GEN1_5_RD(x) & ~BM_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5) | BF_IPU_DI0_SW_GEN1_5_di0_cnt_polarity_gen_en_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_6 - DI0 Sync Wave Gen 6 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_6 - DI0 Sync Wave Gen 6 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_6
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_6_bitfields
    {
        uint32_t di0_cnt_up_6 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_6 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_6 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_6 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_6 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_6 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_6 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_6_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_6 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_6_ADDR(x) ((uintptr_t)(x) + 0x40044U)

#define HW_IPU_DI0_SW_GEN1_6(x)  (*(__IO hw_ipu_di0_sw_gen1_6_t *) HW_IPU_DI0_SW_GEN1_6_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_6_RD(x) (HW_IPU_DI0_SW_GEN1_6(x).U)
#define HW_IPU_DI0_SW_GEN1_6_WR(x, v) (HW_IPU_DI0_SW_GEN1_6(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_6_SET(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, HW_IPU_DI0_SW_GEN1_6_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_6_CLR(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, HW_IPU_DI0_SW_GEN1_6_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_6_TOG(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, HW_IPU_DI0_SW_GEN1_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_6 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_up_6[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_up_6 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_up_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_up_6 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_up_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_up_6 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_up_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_up_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_up_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_up_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_up_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_up_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_up_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_up_6)

/*! @brief Set the di0_cnt_up_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_up_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_up_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_up_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_polarity_clr_sel_6[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_polarity_clr_sel_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6)

/*! @brief Set the di0_cnt_polarity_clr_sel_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_clr_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_polarity_trigger_sel_6[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_polarity_trigger_sel_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6)

/*! @brief Set the di0_cnt_polarity_trigger_sel_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_trigger_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_down_6[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_down_6 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_down_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_down_6 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_down_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_down_6 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_down_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_down_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_down_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_down_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_down_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_down_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_down_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_down_6)

/*! @brief Set the di0_cnt_down_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_down_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_down_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_down_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_clr_sel_6[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_clr_sel_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6)

/*! @brief Set the di0_cnt_clr_sel_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_clr_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_auto_reload_6[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_auto_reload_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6)

/*! @brief Set the di0_cnt_auto_reload_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_auto_reload_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_6, field di0_cnt_polarity_gen_en_6[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6. */
#define BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6. */
#define BS_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6 field. */
#define BR_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6(x) (HW_IPU_DI0_SW_GEN1_6(x).B.di0_cnt_polarity_gen_en_6)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6. */
#define BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6) & BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6)

/*! @brief Set the di0_cnt_polarity_gen_en_6 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6(x, v) (HW_IPU_DI0_SW_GEN1_6_WR(x, (HW_IPU_DI0_SW_GEN1_6_RD(x) & ~BM_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6) | BF_IPU_DI0_SW_GEN1_6_di0_cnt_polarity_gen_en_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_7 - DI0 Sync Wave Gen 7 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_7 - DI0 Sync Wave Gen 7 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_7
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_7_bitfields
    {
        uint32_t di0_cnt_up_7 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_7 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_7 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_7 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_7 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_7 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_7 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_7_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_7 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_7_ADDR(x) ((uintptr_t)(x) + 0x40048U)

#define HW_IPU_DI0_SW_GEN1_7(x)  (*(__IO hw_ipu_di0_sw_gen1_7_t *) HW_IPU_DI0_SW_GEN1_7_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_7_RD(x) (HW_IPU_DI0_SW_GEN1_7(x).U)
#define HW_IPU_DI0_SW_GEN1_7_WR(x, v) (HW_IPU_DI0_SW_GEN1_7(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_7_SET(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, HW_IPU_DI0_SW_GEN1_7_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_7_CLR(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, HW_IPU_DI0_SW_GEN1_7_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_7_TOG(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, HW_IPU_DI0_SW_GEN1_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_7 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_up_7[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_up_7 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_up_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_up_7 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_up_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_up_7 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_up_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_up_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_up_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_up_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_up_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_up_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_up_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_up_7)

/*! @brief Set the di0_cnt_up_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_up_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_up_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_up_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_polarity_clr_sel_7[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Output is inverted if the output of counter #6 is set
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_polarity_clr_sel_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7)

/*! @brief Set the di0_cnt_polarity_clr_sel_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_clr_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_polarity_trigger_sel_7[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_polarity_trigger_sel_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7)

/*! @brief Set the di0_cnt_polarity_trigger_sel_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_trigger_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_down_7[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_down_7 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_down_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_down_7 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_down_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_down_7 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_down_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_down_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_down_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_down_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_down_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_down_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_down_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_down_7)

/*! @brief Set the di0_cnt_down_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_down_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_down_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_down_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_clr_sel_7[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_clr_sel_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7)

/*! @brief Set the di0_cnt_clr_sel_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_clr_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_auto_reload_7[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_auto_reload_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7)

/*! @brief Set the di0_cnt_auto_reload_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_auto_reload_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_7, field di0_cnt_polarity_gen_en_7[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7. */
#define BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7. */
#define BS_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7 field. */
#define BR_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7(x) (HW_IPU_DI0_SW_GEN1_7(x).B.di0_cnt_polarity_gen_en_7)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7. */
#define BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7) & BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7)

/*! @brief Set the di0_cnt_polarity_gen_en_7 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7(x, v) (HW_IPU_DI0_SW_GEN1_7_WR(x, (HW_IPU_DI0_SW_GEN1_7_RD(x) & ~BM_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7) | BF_IPU_DI0_SW_GEN1_7_di0_cnt_polarity_gen_en_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_8 - DI0 Sync Wave Gen 8 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_8 - DI0 Sync Wave Gen 8 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_8
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_8_bitfields
    {
        uint32_t di0_cnt_up_8 : 9;     /*!< [8:0]  */
        uint32_t di0_cnt_polarity_clr_sel_8 : 3; /*!< [11:9]  */
        uint32_t di0_cnt_polarity_trigger_sel_8 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di0_cnt_down_8 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_8 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_8 : 1; /*!< [28]  */
        uint32_t di0_cnt_polarity_gen_en_8 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di0_sw_gen1_8_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_8 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_8_ADDR(x) ((uintptr_t)(x) + 0x4004CU)

#define HW_IPU_DI0_SW_GEN1_8(x)  (*(__IO hw_ipu_di0_sw_gen1_8_t *) HW_IPU_DI0_SW_GEN1_8_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_8_RD(x) (HW_IPU_DI0_SW_GEN1_8(x).U)
#define HW_IPU_DI0_SW_GEN1_8_WR(x, v) (HW_IPU_DI0_SW_GEN1_8(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_8_SET(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, HW_IPU_DI0_SW_GEN1_8_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_8_CLR(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, HW_IPU_DI0_SW_GEN1_8_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_8_TOG(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, HW_IPU_DI0_SW_GEN1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_8 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_up_8[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_up_8 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_up_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_up_8 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_up_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_up_8 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_up_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_up_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_up_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_up_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_up_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_up_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_up_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_up_8)

/*! @brief Set the di0_cnt_up_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_up_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_up_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_up_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_polarity_clr_sel_8[11:9] (RW)
 *
 * DI0 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Output is inverted if the output of counter #6 is set
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8 (9U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8 (0x00000E00U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_polarity_clr_sel_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8)

/*! @brief Set the di0_cnt_polarity_clr_sel_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_clr_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_polarity_trigger_sel_8[14:12] (RW)
 *
 * DI0 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8 (12U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8 (0x00007000U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_polarity_trigger_sel_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8)

/*! @brief Set the di0_cnt_polarity_trigger_sel_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_trigger_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_down_8[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_down_8 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_down_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_down_8 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_down_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_down_8 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_down_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_down_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_down_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_down_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_down_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_down_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_down_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_down_8)

/*! @brief Set the di0_cnt_down_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_down_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_down_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_down_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_clr_sel_8[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_clr_sel_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8)

/*! @brief Set the di0_cnt_clr_sel_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_clr_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_auto_reload_8[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_auto_reload_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8)

/*! @brief Set the di0_cnt_auto_reload_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_auto_reload_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_8, field di0_cnt_polarity_gen_en_8[30:29] (RW)
 *
 * DI0 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8. */
#define BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8 (0x60000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8. */
#define BS_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8 (2U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8 field. */
#define BR_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8(x) (HW_IPU_DI0_SW_GEN1_8(x).B.di0_cnt_polarity_gen_en_8)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8. */
#define BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8) & BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8)

/*! @brief Set the di0_cnt_polarity_gen_en_8 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8(x, v) (HW_IPU_DI0_SW_GEN1_8_WR(x, (HW_IPU_DI0_SW_GEN1_8_RD(x) & ~BM_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8) | BF_IPU_DI0_SW_GEN1_8_di0_cnt_polarity_gen_en_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SW_GEN1_9 - DI0 Sync Wave Gen 9 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SW_GEN1_9 - DI0 Sync Wave Gen 9 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sw_gen1_9
{
    uint32_t U;
    struct _hw_ipu_di0_sw_gen1_9_bitfields
    {
        uint32_t di0_cnt_up_9 : 9;     /*!< [8:0]  */
        uint32_t RESERVED0 : 6;        /*!< [14:9]  */
        uint32_t di0_tag_sel_9 : 1;    /*!< [15]  */
        uint32_t di0_cnt_down_9 : 9;   /*!< [24:16]  */
        uint32_t di0_cnt_clr_sel_9 : 3; /*!< [27:25]  */
        uint32_t di0_cnt_auto_reload_9 : 1; /*!< [28]  */
        uint32_t di0_gentime_sel_9 : 3; /*!< [31:29]  */
    } B;
} hw_ipu_di0_sw_gen1_9_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SW_GEN1_9 register
 */
/*@{*/
#define HW_IPU_DI0_SW_GEN1_9_ADDR(x) ((uintptr_t)(x) + 0x40050U)

#define HW_IPU_DI0_SW_GEN1_9(x)  (*(__IO hw_ipu_di0_sw_gen1_9_t *) HW_IPU_DI0_SW_GEN1_9_ADDR(x))
#define HW_IPU_DI0_SW_GEN1_9_RD(x) (HW_IPU_DI0_SW_GEN1_9(x).U)
#define HW_IPU_DI0_SW_GEN1_9_WR(x, v) (HW_IPU_DI0_SW_GEN1_9(x).U = (v))
#define HW_IPU_DI0_SW_GEN1_9_SET(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, HW_IPU_DI0_SW_GEN1_9_RD(x) |  (v)))
#define HW_IPU_DI0_SW_GEN1_9_CLR(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, HW_IPU_DI0_SW_GEN1_9_RD(x) & ~(v)))
#define HW_IPU_DI0_SW_GEN1_9_TOG(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, HW_IPU_DI0_SW_GEN1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SW_GEN1_9 bitfields
 */

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_cnt_up_9[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_cnt_up_9 (0U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_cnt_up_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_cnt_up_9 (0x000001FFU) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_cnt_up_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_cnt_up_9 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_cnt_up_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_cnt_up_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_cnt_up_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_cnt_up_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_cnt_up_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_cnt_up_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_cnt_up_9) & BM_IPU_DI0_SW_GEN1_9_di0_cnt_up_9)

/*! @brief Set the di0_cnt_up_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_cnt_up_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_cnt_up_9) | BF_IPU_DI0_SW_GEN1_9_di0_cnt_up_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_tag_sel_9[15] (RW)
 *
 * Counter #9 can send a synchronous tag when counter #9 reach its predefined
 * value or when it's triggering counter reaches its pre defined value.
 *
 * Values:
 * - 1 - tag source is counter #9
 * - 0 - Tag's source is the triggering counter.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_tag_sel_9 (15U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_tag_sel_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_tag_sel_9 (0x00008000U) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_tag_sel_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_tag_sel_9 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_tag_sel_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_tag_sel_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_tag_sel_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_tag_sel_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_tag_sel_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_tag_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_tag_sel_9) & BM_IPU_DI0_SW_GEN1_9_di0_tag_sel_9)

/*! @brief Set the di0_tag_sel_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_tag_sel_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_tag_sel_9) | BF_IPU_DI0_SW_GEN1_9_di0_tag_sel_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_cnt_down_9[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_cnt_down_9 (16U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_cnt_down_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_cnt_down_9 (0x01FF0000U) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_cnt_down_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_cnt_down_9 (9U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_cnt_down_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_cnt_down_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_cnt_down_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_cnt_down_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_cnt_down_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_cnt_down_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_cnt_down_9) & BM_IPU_DI0_SW_GEN1_9_di0_cnt_down_9)

/*! @brief Set the di0_cnt_down_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_cnt_down_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_cnt_down_9) | BF_IPU_DI0_SW_GEN1_9_di0_cnt_down_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_cnt_clr_sel_9[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9 (25U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9 (0x0E000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_cnt_clr_sel_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9) & BM_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9)

/*! @brief Set the di0_cnt_clr_sel_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9) | BF_IPU_DI0_SW_GEN1_9_di0_cnt_clr_sel_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_cnt_auto_reload_9[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di0_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di0_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9 (28U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9 (0x10000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9 (1U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_cnt_auto_reload_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9) & BM_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9)

/*! @brief Set the di0_cnt_auto_reload_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9) | BF_IPU_DI0_SW_GEN1_9_di0_cnt_auto_reload_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SW_GEN1_9, field di0_gentime_sel_9[31:29] (RW)
 *
 * Counter #9 main waveform select This field defines the counter that counter
 * #9's auxiliary waveform will be attached too.
 *
 * Values:
 * - 000 - Counter #9's waveform is attached to counter #1's waveform
 * - 001 - Counter #9's waveform is attached to counter #2's waveform
 * - 010 - Counter #9's waveform is attached to counter #3's waveform
 * - 011 - Counter #9's waveform is attached to counter #4's waveform
 * - 100 - Counter #9's waveform is attached to counter #5's waveform
 * - 101 - Counter #9's waveform is attached to counter #6's waveform
 * - 110 - Counter #9's waveform is attached to counter #7's waveform
 * - 111 - Counter #9's waveform is attached to counter #8's waveform
 */
/*@{*/
#define BP_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9 (29U) /*!< Bit position for IPU_DI0_SW_GEN1_9_di0_gentime_sel_9. */
#define BM_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9 (0xE0000000U) /*!< Bit mask for IPU_DI0_SW_GEN1_9_di0_gentime_sel_9. */
#define BS_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9 (3U) /*!< Bit field size in bits for IPU_DI0_SW_GEN1_9_di0_gentime_sel_9. */

/*! @brief Read current value of the IPU_DI0_SW_GEN1_9_di0_gentime_sel_9 field. */
#define BR_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9(x) (HW_IPU_DI0_SW_GEN1_9(x).B.di0_gentime_sel_9)

/*! @brief Format value for bitfield IPU_DI0_SW_GEN1_9_di0_gentime_sel_9. */
#define BF_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9) & BM_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9)

/*! @brief Set the di0_gentime_sel_9 field to a new value. */
#define BW_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9(x, v) (HW_IPU_DI0_SW_GEN1_9_WR(x, (HW_IPU_DI0_SW_GEN1_9_RD(x) & ~BM_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9) | BF_IPU_DI0_SW_GEN1_9_di0_gentime_sel_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SYNC_AS_GEN - DI0 Sync Assistance Gen Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SYNC_AS_GEN - DI0 Sync Assistance Gen Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_sync_as_gen
{
    uint32_t U;
    struct _hw_ipu_di0_sync_as_gen_bitfields
    {
        uint32_t di0_sync_start : 12;  /*!< [11:0]  */
        uint32_t RESERVED0 : 1;        /*!< [12]  */
        uint32_t di0_vsync_sel : 3;    /*!< [15:13]  */
        uint32_t RESERVED1 : 12;       /*!< [27:16]  */
        uint32_t di0_sync_start_en : 1; /*!< [28]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_di0_sync_as_gen_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SYNC_AS_GEN register
 */
/*@{*/
#define HW_IPU_DI0_SYNC_AS_GEN_ADDR(x) ((uintptr_t)(x) + 0x40054U)

#define HW_IPU_DI0_SYNC_AS_GEN(x) (*(__IO hw_ipu_di0_sync_as_gen_t *) HW_IPU_DI0_SYNC_AS_GEN_ADDR(x))
#define HW_IPU_DI0_SYNC_AS_GEN_RD(x) (HW_IPU_DI0_SYNC_AS_GEN(x).U)
#define HW_IPU_DI0_SYNC_AS_GEN_WR(x, v) (HW_IPU_DI0_SYNC_AS_GEN(x).U = (v))
#define HW_IPU_DI0_SYNC_AS_GEN_SET(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, HW_IPU_DI0_SYNC_AS_GEN_RD(x) |  (v)))
#define HW_IPU_DI0_SYNC_AS_GEN_CLR(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, HW_IPU_DI0_SYNC_AS_GEN_RD(x) & ~(v)))
#define HW_IPU_DI0_SYNC_AS_GEN_TOG(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, HW_IPU_DI0_SYNC_AS_GEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SYNC_AS_GEN bitfields
 */

/*!
 * @name Register IPU_DI0_SYNC_AS_GEN, field di0_sync_start[11:0] (RW)
 *
 * DI0 Sync start This field defines the number of low (including blanking rows)
 * on the which the DI0 starts preparing the data for the next frame.
 */
/*@{*/
#define BP_IPU_DI0_SYNC_AS_GEN_di0_sync_start (0U) /*!< Bit position for IPU_DI0_SYNC_AS_GEN_di0_sync_start. */
#define BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start (0x00000FFFU) /*!< Bit mask for IPU_DI0_SYNC_AS_GEN_di0_sync_start. */
#define BS_IPU_DI0_SYNC_AS_GEN_di0_sync_start (12U) /*!< Bit field size in bits for IPU_DI0_SYNC_AS_GEN_di0_sync_start. */

/*! @brief Read current value of the IPU_DI0_SYNC_AS_GEN_di0_sync_start field. */
#define BR_IPU_DI0_SYNC_AS_GEN_di0_sync_start(x) (HW_IPU_DI0_SYNC_AS_GEN(x).B.di0_sync_start)

/*! @brief Format value for bitfield IPU_DI0_SYNC_AS_GEN_di0_sync_start. */
#define BF_IPU_DI0_SYNC_AS_GEN_di0_sync_start(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SYNC_AS_GEN_di0_sync_start) & BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start)

/*! @brief Set the di0_sync_start field to a new value. */
#define BW_IPU_DI0_SYNC_AS_GEN_di0_sync_start(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, (HW_IPU_DI0_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start) | BF_IPU_DI0_SYNC_AS_GEN_di0_sync_start(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SYNC_AS_GEN, field di0_vsync_sel[15:13] (RW)
 *
 * VSYNC select This field defines which of the counters functions as VSYNC
 * signal
 *
 * Values:
 * - 000 - VSYNC is coming from counter #1
 * - 001 - VSYNC is coming from counter #2
 * - 111 - VSYNC is coming from counter #8
 */
/*@{*/
#define BP_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel (13U) /*!< Bit position for IPU_DI0_SYNC_AS_GEN_di0_vsync_sel. */
#define BM_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel (0x0000E000U) /*!< Bit mask for IPU_DI0_SYNC_AS_GEN_di0_vsync_sel. */
#define BS_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel (3U) /*!< Bit field size in bits for IPU_DI0_SYNC_AS_GEN_di0_vsync_sel. */

/*! @brief Read current value of the IPU_DI0_SYNC_AS_GEN_di0_vsync_sel field. */
#define BR_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel(x) (HW_IPU_DI0_SYNC_AS_GEN(x).B.di0_vsync_sel)

/*! @brief Format value for bitfield IPU_DI0_SYNC_AS_GEN_di0_vsync_sel. */
#define BF_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel) & BM_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel)

/*! @brief Set the di0_vsync_sel field to a new value. */
#define BW_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, (HW_IPU_DI0_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel) | BF_IPU_DI0_SYNC_AS_GEN_di0_vsync_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SYNC_AS_GEN, field di0_sync_start_en[28] (RW)
 *
 * di0_sync_start_en
 */
/*@{*/
#define BP_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en (28U) /*!< Bit position for IPU_DI0_SYNC_AS_GEN_di0_sync_start_en. */
#define BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en (0x10000000U) /*!< Bit mask for IPU_DI0_SYNC_AS_GEN_di0_sync_start_en. */
#define BS_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en (1U) /*!< Bit field size in bits for IPU_DI0_SYNC_AS_GEN_di0_sync_start_en. */

/*! @brief Read current value of the IPU_DI0_SYNC_AS_GEN_di0_sync_start_en field. */
#define BR_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en(x) (HW_IPU_DI0_SYNC_AS_GEN(x).B.di0_sync_start_en)

/*! @brief Format value for bitfield IPU_DI0_SYNC_AS_GEN_di0_sync_start_en. */
#define BF_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en) & BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en)

/*! @brief Set the di0_sync_start_en field to a new value. */
#define BW_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en(x, v) (HW_IPU_DI0_SYNC_AS_GEN_WR(x, (HW_IPU_DI0_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en) | BF_IPU_DI0_SYNC_AS_GEN_di0_sync_start_en(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_DW_GEN_i - DI0 Data Wave Gen <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_DW_GEN_i - DI0 Data Wave Gen <i> Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The DI0_DW_GEN_<i> register holds pointers for the waveform generators. These
 * registers have different bit arrangements for parallel and serial display.
 * When using a parallel display VDI Plane Size Register 4 DI0 Data Wave Gen <i>
 * Register is applicable. When using a serial interface VDI Plane Size Register 4
 * DI0 Data Wave Gen <i> Register is applicable. Register Field Descriptions for
 * Serial Display Field Description 31-24 di0_serial_period_<i> DI0 Serial Period
 * <i> This field defines the period of the time base serial display clock. The
 * units are the internal DI clock 23-16 di0_start_period_<i> DI0 start period
 * This field defines the amount of cycles between the point where the access is
 * ready to be launched to the actual point where the time base serial display
 * clock restarts. The units are the internal DI clock 15-14 di0_cst_<i> DI0 Chip
 * Select pointer for waveform <i> This field points to a register that defines the
 * waveform of the CS pin. For serial displays the down value as defined on
 * DI0_DW_SET*_<i> is measured from the assertion of the last serial display time base
 * clock. 00 The waveform is defined according to the settings on
 * DI0_DW_SET0_<i> 01 The waveform is defined according to the settings on DI0_DW_SET1_<i> 10
 * The waveform is defined according to the settings on DI0_DW_SET2_<i> 11 The
 * waveform is defined according to the settings on DI0_DW_SET3_<i> 13-9 Reserved
 * 8-4 di0_serial_valid_bits<i> DI0 Serial valid bits. This field defines the
 * amount of valid bits to be transmitted within the 32 bits internal word aligned to
 * bit[0]. The actual amount of valid bits is di0_serial_valid_bits_<i> + 1 3-2
 * di0_serial_rs_<i> DI0 Serial RS This field points to a register that defines
 * the waveform of the RS pin. For serial displays the down value as defined on
 * DI0_DW_SET*_<i> is measured from the assertion of the last serial display time
 * base clock. 00 The waveform is defined according to the settings on
 * DI0_DW_SET0_<i> 01 The waveform is defined according to the settings on DI0_DW_SET1_<i> 10
 * The waveform is defined according to the settings on DI0_DW_SET2_<i> 11 The
 * waveform is defined according to the settings on DI0_DW_SET3_<i> 1-0
 * di0_serial_clk_<i> DI0 serial clock<i> This field points to a register that defines the
 * waveform of the Serial clock pin. 00 The waveform is defined according to the
 * settings on DI0_DW_SET0_<i> 01 The waveform is defined according to the
 * settings on DI0_DW_SET1_<i> 10 The waveform is defined according to the settings on
 * DI0_DW_SET2_<i> 11 The waveform is defined according to the settings on
 * DI0_DW_SET3_<i>
 */
typedef union _hw_ipu_di0_dw_gen_i
{
    uint32_t U;
    struct _hw_ipu_di0_dw_gen_i_bitfields
    {
        uint32_t di0_pt_0_i : 2;       /*!< [1:0]  */
        uint32_t di0_pt_1_i : 2;       /*!< [3:2]  */
        uint32_t di0_pt_2_i : 2;       /*!< [5:4]  */
        uint32_t di0_pt_3_i : 2;       /*!< [7:6]  */
        uint32_t di0_pt_4_i : 2;       /*!< [9:8]  */
        uint32_t di0_pt_5_i : 2;       /*!< [11:10]  */
        uint32_t di0_pt_6_i : 2;       /*!< [13:12]  */
        uint32_t di0_cst_i : 2;        /*!< [15:14]  */
        uint32_t di0_componnent_size_i : 8; /*!< [23:16]  */
        uint32_t di0_access_size_i : 8; /*!< [31:24]  */
    } B;
} hw_ipu_di0_dw_gen_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_DW_GEN_i register
 */
/*@{*/
#define HW_IPU_DI0_DW_GEN_i_ADDR(x) ((uintptr_t)(x) + 0x40058U)

#define HW_IPU_DI0_DW_GEN_i(x)   (*(__IO hw_ipu_di0_dw_gen_i_t *) HW_IPU_DI0_DW_GEN_i_ADDR(x))
#define HW_IPU_DI0_DW_GEN_i_RD(x) (HW_IPU_DI0_DW_GEN_i(x).U)
#define HW_IPU_DI0_DW_GEN_i_WR(x, v) (HW_IPU_DI0_DW_GEN_i(x).U = (v))
#define HW_IPU_DI0_DW_GEN_i_SET(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, HW_IPU_DI0_DW_GEN_i_RD(x) |  (v)))
#define HW_IPU_DI0_DW_GEN_i_CLR(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, HW_IPU_DI0_DW_GEN_i_RD(x) & ~(v)))
#define HW_IPU_DI0_DW_GEN_i_TOG(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, HW_IPU_DI0_DW_GEN_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_DW_GEN_i bitfields
 */

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_0_i[1:0] (RW)
 *
 * DI0 PIN_11 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_11 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_0_i (0U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_0_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_0_i (0x00000003U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_0_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_0_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_0_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_0_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_0_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_0_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_0_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_0_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_0_i)

/*! @brief Set the di0_pt_0_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_0_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_0_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_0_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_1_i[3:2] (RW)
 *
 * DI0 PIN_12 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_12 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_1_i (2U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_1_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_1_i (0x0000000CU) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_1_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_1_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_1_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_1_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_1_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_1_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_1_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_1_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_1_i)

/*! @brief Set the di0_pt_1_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_1_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_1_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_1_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_2_i[5:4] (RW)
 *
 * DI0 PIN_13 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_13 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_2_i (4U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_2_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_2_i (0x00000030U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_2_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_2_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_2_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_2_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_2_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_2_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_2_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_2_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_2_i)

/*! @brief Set the di0_pt_2_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_2_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_2_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_2_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_3_i[7:6] (RW)
 *
 * DI0 PIN_14 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_14 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_3_i (6U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_3_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_3_i (0x000000C0U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_3_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_3_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_3_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_3_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_3_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_3_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_3_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_3_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_3_i)

/*! @brief Set the di0_pt_3_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_3_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_3_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_3_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_4_i[9:8] (RW)
 *
 * DI0 PIN_15 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_15 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_4_i (8U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_4_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_4_i (0x00000300U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_4_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_4_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_4_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_4_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_4_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_4_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_4_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_4_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_4_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_4_i)

/*! @brief Set the di0_pt_4_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_4_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_4_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_4_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_5_i[11:10] (RW)
 *
 * DI0 PIN_16 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_16 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_5_i (10U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_5_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_5_i (0x00000C00U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_5_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_5_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_5_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_5_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_5_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_5_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_5_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_5_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_5_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_5_i)

/*! @brief Set the di0_pt_5_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_5_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_5_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_5_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_pt_6_i[13:12] (RW)
 *
 * DI0 PIN_17 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_17 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_pt_6_i (12U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_pt_6_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_pt_6_i (0x00003000U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_pt_6_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_pt_6_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_pt_6_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_pt_6_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_pt_6_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_pt_6_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_pt_6_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_pt_6_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_pt_6_i) & BM_IPU_DI0_DW_GEN_i_di0_pt_6_i)

/*! @brief Set the di0_pt_6_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_pt_6_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_pt_6_i) | BF_IPU_DI0_DW_GEN_i_di0_pt_6_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_cst_i[15:14] (RW)
 *
 * DI0 Chip Select pointer for waveform <i> This field points to a register that
 * defines the waveform of the CS pin. The CS is automatically mapped to a
 * specific display
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI0_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI0_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI0_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI0_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_cst_i (14U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_cst_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_cst_i (0x0000C000U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_cst_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_cst_i (2U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_cst_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_cst_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_cst_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_cst_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_cst_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_cst_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_cst_i) & BM_IPU_DI0_DW_GEN_i_di0_cst_i)

/*! @brief Set the di0_cst_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_cst_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_cst_i) | BF_IPU_DI0_DW_GEN_i_di0_cst_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_componnent_size_i[23:16] (RW)
 *
 * DI0 component Size This field defines the amount of IPU cycles between any 2
 * components
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_componnent_size_i (16U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_componnent_size_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_componnent_size_i (0x00FF0000U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_componnent_size_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_componnent_size_i (8U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_componnent_size_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_componnent_size_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_componnent_size_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_componnent_size_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_componnent_size_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_componnent_size_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_componnent_size_i) & BM_IPU_DI0_DW_GEN_i_di0_componnent_size_i)

/*! @brief Set the di0_componnent_size_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_componnent_size_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_componnent_size_i) | BF_IPU_DI0_DW_GEN_i_di0_componnent_size_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_GEN_i, field di0_access_size_i[31:24] (RW)
 *
 * DI0 Access Size <i> This field defines the amount of IPU cycles between any 2
 * accesses (an access may be a pixel or generic data that may have more one
 * component)
 */
/*@{*/
#define BP_IPU_DI0_DW_GEN_i_di0_access_size_i (24U) /*!< Bit position for IPU_DI0_DW_GEN_i_di0_access_size_i. */
#define BM_IPU_DI0_DW_GEN_i_di0_access_size_i (0xFF000000U) /*!< Bit mask for IPU_DI0_DW_GEN_i_di0_access_size_i. */
#define BS_IPU_DI0_DW_GEN_i_di0_access_size_i (8U) /*!< Bit field size in bits for IPU_DI0_DW_GEN_i_di0_access_size_i. */

/*! @brief Read current value of the IPU_DI0_DW_GEN_i_di0_access_size_i field. */
#define BR_IPU_DI0_DW_GEN_i_di0_access_size_i(x) (HW_IPU_DI0_DW_GEN_i(x).B.di0_access_size_i)

/*! @brief Format value for bitfield IPU_DI0_DW_GEN_i_di0_access_size_i. */
#define BF_IPU_DI0_DW_GEN_i_di0_access_size_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_GEN_i_di0_access_size_i) & BM_IPU_DI0_DW_GEN_i_di0_access_size_i)

/*! @brief Set the di0_access_size_i field to a new value. */
#define BW_IPU_DI0_DW_GEN_i_di0_access_size_i(x, v) (HW_IPU_DI0_DW_GEN_i_WR(x, (HW_IPU_DI0_DW_GEN_i_RD(x) & ~BM_IPU_DI0_DW_GEN_i_di0_access_size_i) | BF_IPU_DI0_DW_GEN_i_di0_access_size_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_DW_SET0_i - DI0 Data Wave Set 0 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_DW_SET0_i - DI0 Data Wave Set 0 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_dw_set0_i
{
    uint32_t U;
    struct _hw_ipu_di0_dw_set0_i_bitfields
    {
        uint32_t di0_data_cnt_up0_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di0_data_cnt_down0_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_dw_set0_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_DW_SET0_i register
 */
/*@{*/
#define HW_IPU_DI0_DW_SET0_i_ADDR(x) ((uintptr_t)(x) + 0x40088U)

#define HW_IPU_DI0_DW_SET0_i(x)  (*(__IO hw_ipu_di0_dw_set0_i_t *) HW_IPU_DI0_DW_SET0_i_ADDR(x))
#define HW_IPU_DI0_DW_SET0_i_RD(x) (HW_IPU_DI0_DW_SET0_i(x).U)
#define HW_IPU_DI0_DW_SET0_i_WR(x, v) (HW_IPU_DI0_DW_SET0_i(x).U = (v))
#define HW_IPU_DI0_DW_SET0_i_SET(x, v) (HW_IPU_DI0_DW_SET0_i_WR(x, HW_IPU_DI0_DW_SET0_i_RD(x) |  (v)))
#define HW_IPU_DI0_DW_SET0_i_CLR(x, v) (HW_IPU_DI0_DW_SET0_i_WR(x, HW_IPU_DI0_DW_SET0_i_RD(x) & ~(v)))
#define HW_IPU_DI0_DW_SET0_i_TOG(x, v) (HW_IPU_DI0_DW_SET0_i_WR(x, HW_IPU_DI0_DW_SET0_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_DW_SET0_i bitfields
 */

/*!
 * @name Register IPU_DI0_DW_SET0_i, field di0_data_cnt_up0_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a point according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i (0U) /*!< Bit position for IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i. */
#define BM_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i (0x000001FFU) /*!< Bit mask for IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i. */
#define BS_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i field. */
#define BR_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i(x) (HW_IPU_DI0_DW_SET0_i(x).B.di0_data_cnt_up0_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i. */
#define BF_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i) & BM_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i)

/*! @brief Set the di0_data_cnt_up0_i field to a new value. */
#define BW_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i(x, v) (HW_IPU_DI0_DW_SET0_i_WR(x, (HW_IPU_DI0_DW_SET0_i_RD(x) & ~BM_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i) | BF_IPU_DI0_DW_SET0_i_di0_data_cnt_up0_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_SET0_i, field di0_data_cnt_down0_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a point according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i (16U) /*!< Bit position for IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i. */
#define BM_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i (0x01FF0000U) /*!< Bit mask for IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i. */
#define BS_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i field. */
#define BR_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i(x) (HW_IPU_DI0_DW_SET0_i(x).B.di0_data_cnt_down0_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i. */
#define BF_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i) & BM_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i)

/*! @brief Set the di0_data_cnt_down0_i field to a new value. */
#define BW_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i(x, v) (HW_IPU_DI0_DW_SET0_i_WR(x, (HW_IPU_DI0_DW_SET0_i_RD(x) & ~BM_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i) | BF_IPU_DI0_DW_SET0_i_di0_data_cnt_down0_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_DW_SET1_i - DI0 Data Wave Set 1 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_DW_SET1_i - DI0 Data Wave Set 1 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_dw_set1_i
{
    uint32_t U;
    struct _hw_ipu_di0_dw_set1_i_bitfields
    {
        uint32_t di0_data_cnt_up1_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di0_data_cnt_down1_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_dw_set1_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_DW_SET1_i register
 */
/*@{*/
#define HW_IPU_DI0_DW_SET1_i_ADDR(x) ((uintptr_t)(x) + 0x400B8U)

#define HW_IPU_DI0_DW_SET1_i(x)  (*(__IO hw_ipu_di0_dw_set1_i_t *) HW_IPU_DI0_DW_SET1_i_ADDR(x))
#define HW_IPU_DI0_DW_SET1_i_RD(x) (HW_IPU_DI0_DW_SET1_i(x).U)
#define HW_IPU_DI0_DW_SET1_i_WR(x, v) (HW_IPU_DI0_DW_SET1_i(x).U = (v))
#define HW_IPU_DI0_DW_SET1_i_SET(x, v) (HW_IPU_DI0_DW_SET1_i_WR(x, HW_IPU_DI0_DW_SET1_i_RD(x) |  (v)))
#define HW_IPU_DI0_DW_SET1_i_CLR(x, v) (HW_IPU_DI0_DW_SET1_i_WR(x, HW_IPU_DI0_DW_SET1_i_RD(x) & ~(v)))
#define HW_IPU_DI0_DW_SET1_i_TOG(x, v) (HW_IPU_DI0_DW_SET1_i_WR(x, HW_IPU_DI0_DW_SET1_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_DW_SET1_i bitfields
 */

/*!
 * @name Register IPU_DI0_DW_SET1_i, field di0_data_cnt_up1_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i (0U) /*!< Bit position for IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i. */
#define BM_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i (0x000001FFU) /*!< Bit mask for IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i. */
#define BS_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i field. */
#define BR_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i(x) (HW_IPU_DI0_DW_SET1_i(x).B.di0_data_cnt_up1_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i. */
#define BF_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i) & BM_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i)

/*! @brief Set the di0_data_cnt_up1_i field to a new value. */
#define BW_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i(x, v) (HW_IPU_DI0_DW_SET1_i_WR(x, (HW_IPU_DI0_DW_SET1_i_RD(x) & ~BM_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i) | BF_IPU_DI0_DW_SET1_i_di0_data_cnt_up1_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_SET1_i, field di0_data_cnt_down1_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i (16U) /*!< Bit position for IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i. */
#define BM_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i (0x01FF0000U) /*!< Bit mask for IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i. */
#define BS_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i field. */
#define BR_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i(x) (HW_IPU_DI0_DW_SET1_i(x).B.di0_data_cnt_down1_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i. */
#define BF_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i) & BM_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i)

/*! @brief Set the di0_data_cnt_down1_i field to a new value. */
#define BW_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i(x, v) (HW_IPU_DI0_DW_SET1_i_WR(x, (HW_IPU_DI0_DW_SET1_i_RD(x) & ~BM_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i) | BF_IPU_DI0_DW_SET1_i_di0_data_cnt_down1_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_DW_SET2_i - DI0 Data Wave Set 2 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_DW_SET2_i - DI0 Data Wave Set 2 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_dw_set2_i
{
    uint32_t U;
    struct _hw_ipu_di0_dw_set2_i_bitfields
    {
        uint32_t di0_data_cnt_up2_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di0_data_cnt_down2_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_dw_set2_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_DW_SET2_i register
 */
/*@{*/
#define HW_IPU_DI0_DW_SET2_i_ADDR(x) ((uintptr_t)(x) + 0x400E8U)

#define HW_IPU_DI0_DW_SET2_i(x)  (*(__IO hw_ipu_di0_dw_set2_i_t *) HW_IPU_DI0_DW_SET2_i_ADDR(x))
#define HW_IPU_DI0_DW_SET2_i_RD(x) (HW_IPU_DI0_DW_SET2_i(x).U)
#define HW_IPU_DI0_DW_SET2_i_WR(x, v) (HW_IPU_DI0_DW_SET2_i(x).U = (v))
#define HW_IPU_DI0_DW_SET2_i_SET(x, v) (HW_IPU_DI0_DW_SET2_i_WR(x, HW_IPU_DI0_DW_SET2_i_RD(x) |  (v)))
#define HW_IPU_DI0_DW_SET2_i_CLR(x, v) (HW_IPU_DI0_DW_SET2_i_WR(x, HW_IPU_DI0_DW_SET2_i_RD(x) & ~(v)))
#define HW_IPU_DI0_DW_SET2_i_TOG(x, v) (HW_IPU_DI0_DW_SET2_i_WR(x, HW_IPU_DI0_DW_SET2_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_DW_SET2_i bitfields
 */

/*!
 * @name Register IPU_DI0_DW_SET2_i, field di0_data_cnt_up2_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i (0U) /*!< Bit position for IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i. */
#define BM_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i (0x000001FFU) /*!< Bit mask for IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i. */
#define BS_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i field. */
#define BR_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i(x) (HW_IPU_DI0_DW_SET2_i(x).B.di0_data_cnt_up2_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i. */
#define BF_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i) & BM_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i)

/*! @brief Set the di0_data_cnt_up2_i field to a new value. */
#define BW_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i(x, v) (HW_IPU_DI0_DW_SET2_i_WR(x, (HW_IPU_DI0_DW_SET2_i_RD(x) & ~BM_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i) | BF_IPU_DI0_DW_SET2_i_di0_data_cnt_up2_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_SET2_i, field di0_data_cnt_down2_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i (16U) /*!< Bit position for IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i. */
#define BM_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i (0x01FF0000U) /*!< Bit mask for IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i. */
#define BS_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i field. */
#define BR_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i(x) (HW_IPU_DI0_DW_SET2_i(x).B.di0_data_cnt_down2_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i. */
#define BF_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i) & BM_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i)

/*! @brief Set the di0_data_cnt_down2_i field to a new value. */
#define BW_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i(x, v) (HW_IPU_DI0_DW_SET2_i_WR(x, (HW_IPU_DI0_DW_SET2_i_RD(x) & ~BM_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i) | BF_IPU_DI0_DW_SET2_i_di0_data_cnt_down2_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_DW_SET3_i - DI0 Data Wave Set 3 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_DW_SET3_i - DI0 Data Wave Set 3 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_dw_set3_i
{
    uint32_t U;
    struct _hw_ipu_di0_dw_set3_i_bitfields
    {
        uint32_t di0_data_cnt_up3_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di0_data_cnt_down3_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di0_dw_set3_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_DW_SET3_i register
 */
/*@{*/
#define HW_IPU_DI0_DW_SET3_i_ADDR(x) ((uintptr_t)(x) + 0x40118U)

#define HW_IPU_DI0_DW_SET3_i(x)  (*(__IO hw_ipu_di0_dw_set3_i_t *) HW_IPU_DI0_DW_SET3_i_ADDR(x))
#define HW_IPU_DI0_DW_SET3_i_RD(x) (HW_IPU_DI0_DW_SET3_i(x).U)
#define HW_IPU_DI0_DW_SET3_i_WR(x, v) (HW_IPU_DI0_DW_SET3_i(x).U = (v))
#define HW_IPU_DI0_DW_SET3_i_SET(x, v) (HW_IPU_DI0_DW_SET3_i_WR(x, HW_IPU_DI0_DW_SET3_i_RD(x) |  (v)))
#define HW_IPU_DI0_DW_SET3_i_CLR(x, v) (HW_IPU_DI0_DW_SET3_i_WR(x, HW_IPU_DI0_DW_SET3_i_RD(x) & ~(v)))
#define HW_IPU_DI0_DW_SET3_i_TOG(x, v) (HW_IPU_DI0_DW_SET3_i_WR(x, HW_IPU_DI0_DW_SET3_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_DW_SET3_i bitfields
 */

/*!
 * @name Register IPU_DI0_DW_SET3_i, field di0_data_cnt_up3_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i (0U) /*!< Bit position for IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i. */
#define BM_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i (0x000001FFU) /*!< Bit mask for IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i. */
#define BS_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i field. */
#define BR_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i(x) (HW_IPU_DI0_DW_SET3_i(x).B.di0_data_cnt_up3_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i. */
#define BF_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i) & BM_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i)

/*! @brief Set the di0_data_cnt_up3_i field to a new value. */
#define BW_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i(x, v) (HW_IPU_DI0_DW_SET3_i_WR(x, (HW_IPU_DI0_DW_SET3_i_RD(x) & ~BM_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i) | BF_IPU_DI0_DW_SET3_i_di0_data_cnt_up3_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_DW_SET3_i, field di0_data_cnt_down3_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di0_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i (16U) /*!< Bit position for IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i. */
#define BM_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i (0x01FF0000U) /*!< Bit mask for IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i. */
#define BS_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i (9U) /*!< Bit field size in bits for IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i. */

/*! @brief Read current value of the IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i field. */
#define BR_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i(x) (HW_IPU_DI0_DW_SET3_i(x).B.di0_data_cnt_down3_i)

/*! @brief Format value for bitfield IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i. */
#define BF_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i) & BM_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i)

/*! @brief Set the di0_data_cnt_down3_i field to a new value. */
#define BW_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i(x, v) (HW_IPU_DI0_DW_SET3_i_WR(x, (HW_IPU_DI0_DW_SET3_i_RD(x) & ~BM_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i) | BF_IPU_DI0_DW_SET3_i_di0_data_cnt_down3_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_STP_REP_i - DI0 Step Repeat <i> Registers
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_STP_REP_i - DI0 Step Repeat <i> Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_stp_rep_i
{
    uint32_t U;
    struct _hw_ipu_di0_stp_rep_i_bitfields
    {
        uint32_t di0_step_repeat_2i_minus_1 : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t di0_step_repeat_2i : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_di0_stp_rep_i_t;

/*!
 * @name Constants and macros for entire IPU_DI0_STP_REP_i register
 */
/*@{*/
#define HW_IPU_DI0_STP_REP_i_ADDR(x) ((uintptr_t)(x) + 0x40148U)

#define HW_IPU_DI0_STP_REP_i(x)  (*(__IO hw_ipu_di0_stp_rep_i_t *) HW_IPU_DI0_STP_REP_i_ADDR(x))
#define HW_IPU_DI0_STP_REP_i_RD(x) (HW_IPU_DI0_STP_REP_i(x).U)
#define HW_IPU_DI0_STP_REP_i_WR(x, v) (HW_IPU_DI0_STP_REP_i(x).U = (v))
#define HW_IPU_DI0_STP_REP_i_SET(x, v) (HW_IPU_DI0_STP_REP_i_WR(x, HW_IPU_DI0_STP_REP_i_RD(x) |  (v)))
#define HW_IPU_DI0_STP_REP_i_CLR(x, v) (HW_IPU_DI0_STP_REP_i_WR(x, HW_IPU_DI0_STP_REP_i_RD(x) & ~(v)))
#define HW_IPU_DI0_STP_REP_i_TOG(x, v) (HW_IPU_DI0_STP_REP_i_WR(x, HW_IPU_DI0_STP_REP_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_STP_REP_i bitfields
 */

/*!
 * @name Register IPU_DI0_STP_REP_i, field di0_step_repeat_2i_minus_1[11:0] (RW)
 *
 * Step Repeat <i> This fields defines the amount of repetitions that will be
 * performed by the counter <i>
 */
/*@{*/
#define BP_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1 (0U) /*!< Bit position for IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1. */
#define BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1 (0x00000FFFU) /*!< Bit mask for IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1. */
#define BS_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1 (12U) /*!< Bit field size in bits for IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1. */

/*! @brief Read current value of the IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1 field. */
#define BR_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1(x) (HW_IPU_DI0_STP_REP_i(x).B.di0_step_repeat_2i_minus_1)

/*! @brief Format value for bitfield IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1. */
#define BF_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1) & BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1)

/*! @brief Set the di0_step_repeat_2i_minus_1 field to a new value. */
#define BW_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1(x, v) (HW_IPU_DI0_STP_REP_i_WR(x, (HW_IPU_DI0_STP_REP_i_RD(x) & ~BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1) | BF_IPU_DI0_STP_REP_i_di0_step_repeat_2i_minus_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_STP_REP_i, field di0_step_repeat_2i[27:16] (RW)
 *
 * Step Repeat <i> This fields defines the amount of repetitions that will be
 * performed by the counter <i>
 */
/*@{*/
#define BP_IPU_DI0_STP_REP_i_di0_step_repeat_2i (16U) /*!< Bit position for IPU_DI0_STP_REP_i_di0_step_repeat_2i. */
#define BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i (0x0FFF0000U) /*!< Bit mask for IPU_DI0_STP_REP_i_di0_step_repeat_2i. */
#define BS_IPU_DI0_STP_REP_i_di0_step_repeat_2i (12U) /*!< Bit field size in bits for IPU_DI0_STP_REP_i_di0_step_repeat_2i. */

/*! @brief Read current value of the IPU_DI0_STP_REP_i_di0_step_repeat_2i field. */
#define BR_IPU_DI0_STP_REP_i_di0_step_repeat_2i(x) (HW_IPU_DI0_STP_REP_i(x).B.di0_step_repeat_2i)

/*! @brief Format value for bitfield IPU_DI0_STP_REP_i_di0_step_repeat_2i. */
#define BF_IPU_DI0_STP_REP_i_di0_step_repeat_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_STP_REP_i_di0_step_repeat_2i) & BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i)

/*! @brief Set the di0_step_repeat_2i field to a new value. */
#define BW_IPU_DI0_STP_REP_i_di0_step_repeat_2i(x, v) (HW_IPU_DI0_STP_REP_i_WR(x, (HW_IPU_DI0_STP_REP_i_RD(x) & ~BM_IPU_DI0_STP_REP_i_di0_step_repeat_2i) | BF_IPU_DI0_STP_REP_i_di0_step_repeat_2i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_STP_REP_9 - DI0 Step Repeat 9 Registers
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_STP_REP_9 - DI0 Step Repeat 9 Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_stp_rep_9
{
    uint32_t U;
    struct _hw_ipu_di0_stp_rep_9_bitfields
    {
        uint32_t di0_step_repeat_9 : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_di0_stp_rep_9_t;

/*!
 * @name Constants and macros for entire IPU_DI0_STP_REP_9 register
 */
/*@{*/
#define HW_IPU_DI0_STP_REP_9_ADDR(x) ((uintptr_t)(x) + 0x40158U)

#define HW_IPU_DI0_STP_REP_9(x)  (*(__IO hw_ipu_di0_stp_rep_9_t *) HW_IPU_DI0_STP_REP_9_ADDR(x))
#define HW_IPU_DI0_STP_REP_9_RD(x) (HW_IPU_DI0_STP_REP_9(x).U)
#define HW_IPU_DI0_STP_REP_9_WR(x, v) (HW_IPU_DI0_STP_REP_9(x).U = (v))
#define HW_IPU_DI0_STP_REP_9_SET(x, v) (HW_IPU_DI0_STP_REP_9_WR(x, HW_IPU_DI0_STP_REP_9_RD(x) |  (v)))
#define HW_IPU_DI0_STP_REP_9_CLR(x, v) (HW_IPU_DI0_STP_REP_9_WR(x, HW_IPU_DI0_STP_REP_9_RD(x) & ~(v)))
#define HW_IPU_DI0_STP_REP_9_TOG(x, v) (HW_IPU_DI0_STP_REP_9_WR(x, HW_IPU_DI0_STP_REP_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_STP_REP_9 bitfields
 */

/*!
 * @name Register IPU_DI0_STP_REP_9, field di0_step_repeat_9[11:0] (RW)
 *
 * Step Repeat 9 This fields defines the amount of repetitions that will be
 * performed by the counter 9
 */
/*@{*/
#define BP_IPU_DI0_STP_REP_9_di0_step_repeat_9 (0U) /*!< Bit position for IPU_DI0_STP_REP_9_di0_step_repeat_9. */
#define BM_IPU_DI0_STP_REP_9_di0_step_repeat_9 (0x00000FFFU) /*!< Bit mask for IPU_DI0_STP_REP_9_di0_step_repeat_9. */
#define BS_IPU_DI0_STP_REP_9_di0_step_repeat_9 (12U) /*!< Bit field size in bits for IPU_DI0_STP_REP_9_di0_step_repeat_9. */

/*! @brief Read current value of the IPU_DI0_STP_REP_9_di0_step_repeat_9 field. */
#define BR_IPU_DI0_STP_REP_9_di0_step_repeat_9(x) (HW_IPU_DI0_STP_REP_9(x).B.di0_step_repeat_9)

/*! @brief Format value for bitfield IPU_DI0_STP_REP_9_di0_step_repeat_9. */
#define BF_IPU_DI0_STP_REP_9_di0_step_repeat_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_STP_REP_9_di0_step_repeat_9) & BM_IPU_DI0_STP_REP_9_di0_step_repeat_9)

/*! @brief Set the di0_step_repeat_9 field to a new value. */
#define BW_IPU_DI0_STP_REP_9_di0_step_repeat_9(x, v) (HW_IPU_DI0_STP_REP_9_WR(x, (HW_IPU_DI0_STP_REP_9_RD(x) & ~BM_IPU_DI0_STP_REP_9_di0_step_repeat_9) | BF_IPU_DI0_STP_REP_9_di0_step_repeat_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SER_CONF - DI0 Serial Display Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SER_CONF - DI0 Serial Display Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_ser_conf
{
    uint32_t U;
    struct _hw_ipu_di0_ser_conf_bitfields
    {
        uint32_t DI0_WAIT4SERIAL : 1;  /*!< [0]  */
        uint32_t DI0_SERIAL_CS_POLARITY : 1; /*!< [1]  */
        uint32_t DI0_SERIAL_RS_POLARITY : 1; /*!< [2]  */
        uint32_t DI0_SERIAL_DATA_POLARITY : 1; /*!< [3]  */
        uint32_t DI0_SER_CLK_POLARITY : 1; /*!< [4]  */
        uint32_t DI0_LLA_SER_ACCESS : 1; /*!< [5]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t DI0_SERIAL_LATCH : 8; /*!< [15:8]  */
        uint32_t DI0_SERIAL_LLA_PNTR_RS_W_0 : 4; /*!< [19:16]  */
        uint32_t DI0_SERIAL_LLA_PNTR_RS_W_1 : 4; /*!< [23:20]  */
        uint32_t DI0_SERIAL_LLA_PNTR_RS_R_0 : 4; /*!< [27:24]  */
        uint32_t DI0_SERIAL_LLA_PNTR_RS_R_1 : 4; /*!< [31:28]  */
    } B;
} hw_ipu_di0_ser_conf_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SER_CONF register
 */
/*@{*/
#define HW_IPU_DI0_SER_CONF_ADDR(x) ((uintptr_t)(x) + 0x4015CU)

#define HW_IPU_DI0_SER_CONF(x)   (*(__IO hw_ipu_di0_ser_conf_t *) HW_IPU_DI0_SER_CONF_ADDR(x))
#define HW_IPU_DI0_SER_CONF_RD(x) (HW_IPU_DI0_SER_CONF(x).U)
#define HW_IPU_DI0_SER_CONF_WR(x, v) (HW_IPU_DI0_SER_CONF(x).U = (v))
#define HW_IPU_DI0_SER_CONF_SET(x, v) (HW_IPU_DI0_SER_CONF_WR(x, HW_IPU_DI0_SER_CONF_RD(x) |  (v)))
#define HW_IPU_DI0_SER_CONF_CLR(x, v) (HW_IPU_DI0_SER_CONF_WR(x, HW_IPU_DI0_SER_CONF_RD(x) & ~(v)))
#define HW_IPU_DI0_SER_CONF_TOG(x, v) (HW_IPU_DI0_SER_CONF_WR(x, HW_IPU_DI0_SER_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SER_CONF bitfields
 */

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_WAIT4SERIAL[0] (RW)
 *
 * Wait for Serial When the parallel display share pins with the serial port.
 * Accessing the parallel port is not allowed till the serial port completes its
 * access.
 *
 * Values:
 * - 1 - The parallel port should wait to the serial port as the pins are shared
 * - 0 - The parallel port should not wait to the serial port as the pins are
 *     not shared
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL (0U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_WAIT4SERIAL. */
#define BM_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL (0x00000001U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_WAIT4SERIAL. */
#define BS_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_WAIT4SERIAL. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_WAIT4SERIAL field. */
#define BR_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_WAIT4SERIAL)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_WAIT4SERIAL. */
#define BF_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL) & BM_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL)

/*! @brief Set the DI0_WAIT4SERIAL field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL) | BF_IPU_DI0_SER_CONF_DI0_WAIT4SERIAL(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_CS_POLARITY[1] (RW)
 *
 * Serial Chip Select Polarity The output polarity of the SER_CS pin
 *
 * Values:
 * - 1 - The CS is inverted
 * - 0 - The CS is not inverted
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY (1U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY (0x00000002U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_CS_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY)

/*! @brief Set the DI0_SERIAL_CS_POLARITY field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_CS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_RS_POLARITY[2] (RW)
 *
 * Serial RS Polarity The output polarity of the SER_RS pin
 *
 * Values:
 * - 1 - The RS is inverted
 * - 0 - The RS is not inverted
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY (2U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY (0x00000004U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_RS_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY)

/*! @brief Set the DI0_SERIAL_RS_POLARITY field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_RS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_DATA_POLARITY[3] (RW)
 *
 * Serial Data Polarity The output polarity of the SER_DATA pin
 *
 * Values:
 * - 1 - The data is inverted
 * - 0 - The data is not inverted
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY (3U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY (0x00000008U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY)

/*! @brief Set the DI0_SERIAL_DATA_POLARITY field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SER_CLK_POLARITY[4] (RW)
 *
 * Serial Clock Polarity The output polarity of the SER_CLK pin
 *
 * Values:
 * - 1 - The clock is inverted
 * - 0 - The clock is not inverted
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY (4U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY. */
#define BM_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY (0x00000010U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY. */
#define BS_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY field. */
#define BR_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SER_CLK_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY. */
#define BF_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY) & BM_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY)

/*! @brief Set the DI0_SER_CLK_POLARITY field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY) | BF_IPU_DI0_SER_CONF_DI0_SER_CLK_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_LLA_SER_ACCESS[5] (RW)
 *
 * Direct Low Level Access to Serial display
 *
 * Values:
 * - 1 - ARM platform access is performed via a direct path to the serial
 *     display in LLA mode, in this mode only the ARM platform in LLA mode can access
 *     the serial port
 * - 0 - ARM platform access to the serial display port is not done directly,
 *     hence other source are allowed to access the serial port. The arbitration is
 *     done automatically
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS (5U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS. */
#define BM_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS (0x00000020U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS. */
#define BS_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS (1U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS field. */
#define BR_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_LLA_SER_ACCESS)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS. */
#define BF_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS) & BM_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS)

/*! @brief Set the DI0_LLA_SER_ACCESS field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS) | BF_IPU_DI0_SER_CONF_DI0_LLA_SER_ACCESS(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_LATCH[15:8] (RW)
 *
 * DI0 Serial Latch This field defines how many cycles to insert between serial
 * read accesses start to data sampling in the
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH (8U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_LATCH. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH (0x0000FF00U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_LATCH. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH (8U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_LATCH. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_LATCH field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_LATCH)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_LATCH. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH)

/*! @brief Set the DI0_SERIAL_LATCH field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_LATCH(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_LLA_PNTR_RS_W_0[19:16] (RW)
 *
 * RS 0 waveform pointer for write low level access This pointer defines which
 * waveform set will be chosen when the low level write access is targeted to RS
 * group 0.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0 (16U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0 (0x000F0000U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0 (4U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0 field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_LLA_PNTR_RS_W_0)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0)

/*! @brief Set the DI0_SERIAL_LLA_PNTR_RS_W_0 field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_0(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_LLA_PNTR_RS_W_1[23:20] (RW)
 *
 * RS 1 waveform pointer for write low level access This pointer defines which
 * waveform set will be chosen when the low level write access is targeted to RS
 * group 1.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1 (20U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1 (0x00F00000U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1 (4U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1 field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_LLA_PNTR_RS_W_1)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1)

/*! @brief Set the DI0_SERIAL_LLA_PNTR_RS_W_1 field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_W_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_LLA_PNTR_RS_R_0[27:24] (RW)
 *
 * RS 2 waveform pointer for read low level access This pointer defines which
 * waveform set will be chosen when the read low level access is targeted to RS
 * group 0.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0 (24U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0 (0x0F000000U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0 (4U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0 field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_LLA_PNTR_RS_R_0)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0)

/*! @brief Set the DI0_SERIAL_LLA_PNTR_RS_R_0 field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_0(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SER_CONF, field DI0_SERIAL_LLA_PNTR_RS_R_1[31:28] (RW)
 *
 * RS 3 waveform pointer for read low level access This pointer defines which
 * waveform set will be chosen when the read low level access is targeted to RS
 * group 1.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1 (28U) /*!< Bit position for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1. */
#define BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1 (0xF0000000U) /*!< Bit mask for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1. */
#define BS_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1 (4U) /*!< Bit field size in bits for IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1. */

/*! @brief Read current value of the IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1 field. */
#define BR_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1(x) (HW_IPU_DI0_SER_CONF(x).B.DI0_SERIAL_LLA_PNTR_RS_R_1)

/*! @brief Format value for bitfield IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1. */
#define BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1) & BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1)

/*! @brief Set the DI0_SERIAL_LLA_PNTR_RS_R_1 field to a new value. */
#define BW_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1(x, v) (HW_IPU_DI0_SER_CONF_WR(x, (HW_IPU_DI0_SER_CONF_RD(x) & ~BM_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1) | BF_IPU_DI0_SER_CONF_DI0_SERIAL_LLA_PNTR_RS_R_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SSC - DI0 Special Signals Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SSC - DI0 Special Signals Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_ssc
{
    uint32_t U;
    struct _hw_ipu_di0_ssc_bitfields
    {
        uint32_t DI0_BYTE_EN_PNTR : 3; /*!< [2:0]  */
        uint32_t DI0_BYTE_EN_RD_IN : 1; /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DI0_WAIT_ON : 1;      /*!< [5]  */
        uint32_t RESERVED1 : 10;       /*!< [15:6]  */
        uint32_t DI0_CS_ERM : 1;       /*!< [16]  */
        uint32_t DI0_PIN11_ERM : 1;    /*!< [17]  */
        uint32_t DI0_PIN12_ERM : 1;    /*!< [18]  */
        uint32_t DI0_PIN13_ERM : 1;    /*!< [19]  */
        uint32_t DI0_PIN14_ERM : 1;    /*!< [20]  */
        uint32_t DI0_PIN15_ERM : 1;    /*!< [21]  */
        uint32_t DI0_PIN16_ERM : 1;    /*!< [22]  */
        uint32_t DI0_PIN17_ERM : 1;    /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_di0_ssc_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SSC register
 */
/*@{*/
#define HW_IPU_DI0_SSC_ADDR(x)   ((uintptr_t)(x) + 0x40160U)

#define HW_IPU_DI0_SSC(x)        (*(__IO hw_ipu_di0_ssc_t *) HW_IPU_DI0_SSC_ADDR(x))
#define HW_IPU_DI0_SSC_RD(x)     (HW_IPU_DI0_SSC(x).U)
#define HW_IPU_DI0_SSC_WR(x, v)  (HW_IPU_DI0_SSC(x).U = (v))
#define HW_IPU_DI0_SSC_SET(x, v) (HW_IPU_DI0_SSC_WR(x, HW_IPU_DI0_SSC_RD(x) |  (v)))
#define HW_IPU_DI0_SSC_CLR(x, v) (HW_IPU_DI0_SSC_WR(x, HW_IPU_DI0_SSC_RD(x) & ~(v)))
#define HW_IPU_DI0_SSC_TOG(x, v) (HW_IPU_DI0_SSC_WR(x, HW_IPU_DI0_SSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SSC bitfields
 */

/*!
 * @name Register IPU_DI0_SSC, field DI0_BYTE_EN_PNTR[2:0] (RW)
 *
 * Byte Enable Pointer This pointer selects the pin asserted along with the byte
 * enables signals
 *
 * Values:
 * - 000 - wave form of byte enable as pin_11
 * - 001 - wave form of byte enable as pin_12
 * - 111 - wave form of byte enable as suitable CS pin
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_BYTE_EN_PNTR (0U) /*!< Bit position for IPU_DI0_SSC_DI0_BYTE_EN_PNTR. */
#define BM_IPU_DI0_SSC_DI0_BYTE_EN_PNTR (0x00000007U) /*!< Bit mask for IPU_DI0_SSC_DI0_BYTE_EN_PNTR. */
#define BS_IPU_DI0_SSC_DI0_BYTE_EN_PNTR (3U) /*!< Bit field size in bits for IPU_DI0_SSC_DI0_BYTE_EN_PNTR. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_BYTE_EN_PNTR field. */
#define BR_IPU_DI0_SSC_DI0_BYTE_EN_PNTR(x) (HW_IPU_DI0_SSC(x).B.DI0_BYTE_EN_PNTR)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_BYTE_EN_PNTR. */
#define BF_IPU_DI0_SSC_DI0_BYTE_EN_PNTR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_BYTE_EN_PNTR) & BM_IPU_DI0_SSC_DI0_BYTE_EN_PNTR)

/*! @brief Set the DI0_BYTE_EN_PNTR field to a new value. */
#define BW_IPU_DI0_SSC_DI0_BYTE_EN_PNTR(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_BYTE_EN_PNTR) | BF_IPU_DI0_SSC_DI0_BYTE_EN_PNTR(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_BYTE_EN_RD_IN[3] (RW)
 *
 * Byte Enable Read In This bit selects the source of the byte enable pins
 *
 * Values:
 * - 1 - The write byte enable signals are routed via bits [17:16] of the
 *     display's data, The read byte enable signals are routed via bits [19:18 of the
 *     display's data
 * - 0 - The byte enable signals are routed via bits [17:16] of the display's
 *     data for both read and write
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN (3U) /*!< Bit position for IPU_DI0_SSC_DI0_BYTE_EN_RD_IN. */
#define BM_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN (0x00000008U) /*!< Bit mask for IPU_DI0_SSC_DI0_BYTE_EN_RD_IN. */
#define BS_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN (1U) /*!< Bit field size in bits for IPU_DI0_SSC_DI0_BYTE_EN_RD_IN. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_BYTE_EN_RD_IN field. */
#define BR_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN(x) (HW_IPU_DI0_SSC(x).B.DI0_BYTE_EN_RD_IN)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_BYTE_EN_RD_IN. */
#define BF_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN) & BM_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN)

/*! @brief Set the DI0_BYTE_EN_RD_IN field to a new value. */
#define BW_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN) | BF_IPU_DI0_SSC_DI0_BYTE_EN_RD_IN(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_WAIT_ON[5] (RW)
 *
 * Wait On This field defines the DC's response to WAIT signal
 *
 * Values:
 * - 1 - The DC holds the flow as long as WAIT is asserted
 * - 0 - The DC continues the flow regardless the WAIT signal
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_WAIT_ON (5U)    /*!< Bit position for IPU_DI0_SSC_DI0_WAIT_ON. */
#define BM_IPU_DI0_SSC_DI0_WAIT_ON (0x00000020U) /*!< Bit mask for IPU_DI0_SSC_DI0_WAIT_ON. */
#define BS_IPU_DI0_SSC_DI0_WAIT_ON (1U)    /*!< Bit field size in bits for IPU_DI0_SSC_DI0_WAIT_ON. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_WAIT_ON field. */
#define BR_IPU_DI0_SSC_DI0_WAIT_ON(x) (HW_IPU_DI0_SSC(x).B.DI0_WAIT_ON)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_WAIT_ON. */
#define BF_IPU_DI0_SSC_DI0_WAIT_ON(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_WAIT_ON) & BM_IPU_DI0_SSC_DI0_WAIT_ON)

/*! @brief Set the DI0_WAIT_ON field to a new value. */
#define BW_IPU_DI0_SSC_DI0_WAIT_ON(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_WAIT_ON) | BF_IPU_DI0_SSC_DI0_WAIT_ON(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_CS_ERM[16] (RW)
 *
 * DI0 GLUELOGIC error recovery mode. This bit defines the error recovery mode
 * of the GLUELOGIC.
 *
 * Values:
 * - 1 - The GLUELOGIC is release in case of a synchronous display error. The
 *     release will be done on the next VSYNC
 * - 0 - Nothing is done to the GLUELOGIC following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_CS_ERM (16U)    /*!< Bit position for IPU_DI0_SSC_DI0_CS_ERM. */
#define BM_IPU_DI0_SSC_DI0_CS_ERM (0x00010000U) /*!< Bit mask for IPU_DI0_SSC_DI0_CS_ERM. */
#define BS_IPU_DI0_SSC_DI0_CS_ERM (1U)     /*!< Bit field size in bits for IPU_DI0_SSC_DI0_CS_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_CS_ERM field. */
#define BR_IPU_DI0_SSC_DI0_CS_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_CS_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_CS_ERM. */
#define BF_IPU_DI0_SSC_DI0_CS_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_CS_ERM) & BM_IPU_DI0_SSC_DI0_CS_ERM)

/*! @brief Set the DI0_CS_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_CS_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_CS_ERM) | BF_IPU_DI0_SSC_DI0_CS_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN11_ERM[17] (RW)
 *
 * DI0 PIN11 error recovery mode. This bit defines the error recovery mode of
 * the PIN11 pin.
 *
 * Values:
 * - 1 - The PIN11 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN11 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN11_ERM (17U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN11_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN11_ERM (0x00020000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN11_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN11_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN11_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN11_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN11_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN11_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN11_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN11_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN11_ERM) & BM_IPU_DI0_SSC_DI0_PIN11_ERM)

/*! @brief Set the DI0_PIN11_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN11_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN11_ERM) | BF_IPU_DI0_SSC_DI0_PIN11_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN12_ERM[18] (RW)
 *
 * DI0 PIN12 error recovery mode. This bit defines the error recovery mode of
 * the PIN12 pin.
 *
 * Values:
 * - 1 - The PIN12 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN12 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN12_ERM (18U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN12_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN12_ERM (0x00040000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN12_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN12_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN12_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN12_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN12_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN12_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN12_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN12_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN12_ERM) & BM_IPU_DI0_SSC_DI0_PIN12_ERM)

/*! @brief Set the DI0_PIN12_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN12_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN12_ERM) | BF_IPU_DI0_SSC_DI0_PIN12_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN13_ERM[19] (RW)
 *
 * DI0 PIN13 error recovery mode. This bit defines the error recovery mode of
 * the PIN13 pin.
 *
 * Values:
 * - 1 - The PIN13 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN13 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN13_ERM (19U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN13_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN13_ERM (0x00080000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN13_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN13_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN13_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN13_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN13_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN13_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN13_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN13_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN13_ERM) & BM_IPU_DI0_SSC_DI0_PIN13_ERM)

/*! @brief Set the DI0_PIN13_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN13_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN13_ERM) | BF_IPU_DI0_SSC_DI0_PIN13_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN14_ERM[20] (RW)
 *
 * DI0 PIN14 error recovery mode. This bit defines the error recovery mode of
 * the PIN14 pin.
 *
 * Values:
 * - 1 - The PIN14 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN14 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN14_ERM (20U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN14_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN14_ERM (0x00100000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN14_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN14_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN14_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN14_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN14_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN14_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN14_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN14_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN14_ERM) & BM_IPU_DI0_SSC_DI0_PIN14_ERM)

/*! @brief Set the DI0_PIN14_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN14_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN14_ERM) | BF_IPU_DI0_SSC_DI0_PIN14_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN15_ERM[21] (RW)
 *
 * DI0 PIN15 error recovery mode. This bit defines the error recovery mode of
 * the PIN15 pin.
 *
 * Values:
 * - 1 - The PIN15 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN15 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN15_ERM (21U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN15_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN15_ERM (0x00200000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN15_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN15_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN15_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN15_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN15_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN15_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN15_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN15_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN15_ERM) & BM_IPU_DI0_SSC_DI0_PIN15_ERM)

/*! @brief Set the DI0_PIN15_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN15_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN15_ERM) | BF_IPU_DI0_SSC_DI0_PIN15_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN16_ERM[22] (RW)
 *
 * DI0 PIN16 error recovery mode. This bit defines the error recovery mode of
 * the PIN16 pin.
 *
 * Values:
 * - 1 - The PIN16 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN16 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN16_ERM (22U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN16_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN16_ERM (0x00400000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN16_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN16_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN16_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN16_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN16_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN16_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN16_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN16_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN16_ERM) & BM_IPU_DI0_SSC_DI0_PIN16_ERM)

/*! @brief Set the DI0_PIN16_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN16_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN16_ERM) | BF_IPU_DI0_SSC_DI0_PIN16_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_SSC, field DI0_PIN17_ERM[23] (RW)
 *
 * DI0 PIN17 error recovery mode. This bit defines the error recovery mode of
 * the PIN17 pin.
 *
 * Values:
 * - 1 - The PIN17 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC
 * - 0 - Nothing is done to the PIN17 pin following a display error detection
 */
/*@{*/
#define BP_IPU_DI0_SSC_DI0_PIN17_ERM (23U) /*!< Bit position for IPU_DI0_SSC_DI0_PIN17_ERM. */
#define BM_IPU_DI0_SSC_DI0_PIN17_ERM (0x00800000U) /*!< Bit mask for IPU_DI0_SSC_DI0_PIN17_ERM. */
#define BS_IPU_DI0_SSC_DI0_PIN17_ERM (1U)  /*!< Bit field size in bits for IPU_DI0_SSC_DI0_PIN17_ERM. */

/*! @brief Read current value of the IPU_DI0_SSC_DI0_PIN17_ERM field. */
#define BR_IPU_DI0_SSC_DI0_PIN17_ERM(x) (HW_IPU_DI0_SSC(x).B.DI0_PIN17_ERM)

/*! @brief Format value for bitfield IPU_DI0_SSC_DI0_PIN17_ERM. */
#define BF_IPU_DI0_SSC_DI0_PIN17_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SSC_DI0_PIN17_ERM) & BM_IPU_DI0_SSC_DI0_PIN17_ERM)

/*! @brief Set the DI0_PIN17_ERM field to a new value. */
#define BW_IPU_DI0_SSC_DI0_PIN17_ERM(x, v) (HW_IPU_DI0_SSC_WR(x, (HW_IPU_DI0_SSC_RD(x) & ~BM_IPU_DI0_SSC_DI0_PIN17_ERM) | BF_IPU_DI0_SSC_DI0_PIN17_ERM(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_POL - DI0 Polarity Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_POL - DI0 Polarity Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_pol
{
    uint32_t U;
    struct _hw_ipu_di0_pol_bitfields
    {
        uint32_t di0_drdy_polarity : 7; /*!< [6:0]  */
        uint32_t DI0_DRDY_DATA_POLARITY : 1; /*!< [7]  */
        uint32_t di0_cs0_polarity : 7; /*!< [14:8]  */
        uint32_t DI0_CS0_DATA_POLARITY : 1; /*!< [15]  */
        uint32_t di0_cs1_polarity : 7; /*!< [22:16]  */
        uint32_t DI0_CS1_DATA_POLARITY : 1; /*!< [23]  */
        uint32_t DI0_CS0_BYTE_EN_POLARITY : 1; /*!< [24]  */
        uint32_t DI0_CS1_BYTE_EN_POLARITY : 1; /*!< [25]  */
        uint32_t DI0_WAIT_POLARITY : 1; /*!< [26]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_di0_pol_t;

/*!
 * @name Constants and macros for entire IPU_DI0_POL register
 */
/*@{*/
#define HW_IPU_DI0_POL_ADDR(x)   ((uintptr_t)(x) + 0x40164U)

#define HW_IPU_DI0_POL(x)        (*(__IO hw_ipu_di0_pol_t *) HW_IPU_DI0_POL_ADDR(x))
#define HW_IPU_DI0_POL_RD(x)     (HW_IPU_DI0_POL(x).U)
#define HW_IPU_DI0_POL_WR(x, v)  (HW_IPU_DI0_POL(x).U = (v))
#define HW_IPU_DI0_POL_SET(x, v) (HW_IPU_DI0_POL_WR(x, HW_IPU_DI0_POL_RD(x) |  (v)))
#define HW_IPU_DI0_POL_CLR(x, v) (HW_IPU_DI0_POL_WR(x, HW_IPU_DI0_POL_RD(x) & ~(v)))
#define HW_IPU_DI0_POL_TOG(x, v) (HW_IPU_DI0_POL_WR(x, HW_IPU_DI0_POL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_POL bitfields
 */

/*!
 * @name Register IPU_DI0_POL, field di0_drdy_polarity[6:0] (RW)
 *
 * DI0 output dynamic pin's polarity for synchronous access This bits define the
 * polarity of each of the DI's outputs when synchronous display access is
 * asserted The pins' default polarity is the same as defined in the di0_drdy_polarity
 * bits
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI0_POL_di0_drdy_polarity (0U) /*!< Bit position for IPU_DI0_POL_di0_drdy_polarity. */
#define BM_IPU_DI0_POL_di0_drdy_polarity (0x0000007FU) /*!< Bit mask for IPU_DI0_POL_di0_drdy_polarity. */
#define BS_IPU_DI0_POL_di0_drdy_polarity (7U) /*!< Bit field size in bits for IPU_DI0_POL_di0_drdy_polarity. */

/*! @brief Read current value of the IPU_DI0_POL_di0_drdy_polarity field. */
#define BR_IPU_DI0_POL_di0_drdy_polarity(x) (HW_IPU_DI0_POL(x).B.di0_drdy_polarity)

/*! @brief Format value for bitfield IPU_DI0_POL_di0_drdy_polarity. */
#define BF_IPU_DI0_POL_di0_drdy_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_di0_drdy_polarity) & BM_IPU_DI0_POL_di0_drdy_polarity)

/*! @brief Set the di0_drdy_polarity field to a new value. */
#define BW_IPU_DI0_POL_di0_drdy_polarity(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_di0_drdy_polarity) | BF_IPU_DI0_POL_di0_drdy_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_DRDY_DATA_POLARITY[7] (RW)
 *
 * Data Polarity associated with DRDY
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY (7U) /*!< Bit position for IPU_DI0_POL_DI0_DRDY_DATA_POLARITY. */
#define BM_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY (0x00000080U) /*!< Bit mask for IPU_DI0_POL_DI0_DRDY_DATA_POLARITY. */
#define BS_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_DRDY_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_DRDY_DATA_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_DRDY_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_DRDY_DATA_POLARITY. */
#define BF_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY) & BM_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY)

/*! @brief Set the DI0_DRDY_DATA_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY) | BF_IPU_DI0_POL_DI0_DRDY_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field di0_cs0_polarity[14:8] (RW)
 *
 * DI0 output pin's polarity for CS1 This bits define the polarity of each of
 * the DI's outputs when CS1 is asserted
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI0_POL_di0_cs0_polarity (8U) /*!< Bit position for IPU_DI0_POL_di0_cs0_polarity. */
#define BM_IPU_DI0_POL_di0_cs0_polarity (0x00007F00U) /*!< Bit mask for IPU_DI0_POL_di0_cs0_polarity. */
#define BS_IPU_DI0_POL_di0_cs0_polarity (7U) /*!< Bit field size in bits for IPU_DI0_POL_di0_cs0_polarity. */

/*! @brief Read current value of the IPU_DI0_POL_di0_cs0_polarity field. */
#define BR_IPU_DI0_POL_di0_cs0_polarity(x) (HW_IPU_DI0_POL(x).B.di0_cs0_polarity)

/*! @brief Format value for bitfield IPU_DI0_POL_di0_cs0_polarity. */
#define BF_IPU_DI0_POL_di0_cs0_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_di0_cs0_polarity) & BM_IPU_DI0_POL_di0_cs0_polarity)

/*! @brief Set the di0_cs0_polarity field to a new value. */
#define BW_IPU_DI0_POL_di0_cs0_polarity(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_di0_cs0_polarity) | BF_IPU_DI0_POL_di0_cs0_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_CS0_DATA_POLARITY[15] (RW)
 *
 * Data Polarity associated with CS0
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_CS0_DATA_POLARITY (15U) /*!< Bit position for IPU_DI0_POL_DI0_CS0_DATA_POLARITY. */
#define BM_IPU_DI0_POL_DI0_CS0_DATA_POLARITY (0x00008000U) /*!< Bit mask for IPU_DI0_POL_DI0_CS0_DATA_POLARITY. */
#define BS_IPU_DI0_POL_DI0_CS0_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_CS0_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_CS0_DATA_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_CS0_DATA_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_CS0_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_CS0_DATA_POLARITY. */
#define BF_IPU_DI0_POL_DI0_CS0_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_CS0_DATA_POLARITY) & BM_IPU_DI0_POL_DI0_CS0_DATA_POLARITY)

/*! @brief Set the DI0_CS0_DATA_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_CS0_DATA_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_CS0_DATA_POLARITY) | BF_IPU_DI0_POL_DI0_CS0_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field di0_cs1_polarity[22:16] (RW)
 *
 * DI0 output pin's polarity for CS1 This bits define the polarity of each of
 * the DI's outputs when CS1 is asserted
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI0_POL_di0_cs1_polarity (16U) /*!< Bit position for IPU_DI0_POL_di0_cs1_polarity. */
#define BM_IPU_DI0_POL_di0_cs1_polarity (0x007F0000U) /*!< Bit mask for IPU_DI0_POL_di0_cs1_polarity. */
#define BS_IPU_DI0_POL_di0_cs1_polarity (7U) /*!< Bit field size in bits for IPU_DI0_POL_di0_cs1_polarity. */

/*! @brief Read current value of the IPU_DI0_POL_di0_cs1_polarity field. */
#define BR_IPU_DI0_POL_di0_cs1_polarity(x) (HW_IPU_DI0_POL(x).B.di0_cs1_polarity)

/*! @brief Format value for bitfield IPU_DI0_POL_di0_cs1_polarity. */
#define BF_IPU_DI0_POL_di0_cs1_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_di0_cs1_polarity) & BM_IPU_DI0_POL_di0_cs1_polarity)

/*! @brief Set the di0_cs1_polarity field to a new value. */
#define BW_IPU_DI0_POL_di0_cs1_polarity(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_di0_cs1_polarity) | BF_IPU_DI0_POL_di0_cs1_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_CS1_DATA_POLARITY[23] (RW)
 *
 * Data Polarity associated with CS1
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_CS1_DATA_POLARITY (23U) /*!< Bit position for IPU_DI0_POL_DI0_CS1_DATA_POLARITY. */
#define BM_IPU_DI0_POL_DI0_CS1_DATA_POLARITY (0x00800000U) /*!< Bit mask for IPU_DI0_POL_DI0_CS1_DATA_POLARITY. */
#define BS_IPU_DI0_POL_DI0_CS1_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_CS1_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_CS1_DATA_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_CS1_DATA_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_CS1_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_CS1_DATA_POLARITY. */
#define BF_IPU_DI0_POL_DI0_CS1_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_CS1_DATA_POLARITY) & BM_IPU_DI0_POL_DI0_CS1_DATA_POLARITY)

/*! @brief Set the DI0_CS1_DATA_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_CS1_DATA_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_CS1_DATA_POLARITY) | BF_IPU_DI0_POL_DI0_CS1_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_CS0_BYTE_EN_POLARITY[24] (RW)
 *
 * Byte Enable associated with CS0 polarity This bit defines the polarity of the
 * byte enable signals to the display
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY (24U) /*!< Bit position for IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY. */
#define BM_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY (0x01000000U) /*!< Bit mask for IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY. */
#define BS_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_CS0_BYTE_EN_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY. */
#define BF_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY) & BM_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY)

/*! @brief Set the DI0_CS0_BYTE_EN_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY) | BF_IPU_DI0_POL_DI0_CS0_BYTE_EN_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_CS1_BYTE_EN_POLARITY[25] (RW)
 *
 * Byte Enable associated with CS1 polarity This bit defines the polarity of the
 * byte enable signals to the display
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY (25U) /*!< Bit position for IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY. */
#define BM_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY (0x02000000U) /*!< Bit mask for IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY. */
#define BS_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_CS1_BYTE_EN_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY. */
#define BF_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY) & BM_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY)

/*! @brief Set the DI0_CS1_BYTE_EN_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY) | BF_IPU_DI0_POL_DI0_CS1_BYTE_EN_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_POL, field DI0_WAIT_POLARITY[26] (RW)
 *
 * WAIT polarity This bit defines the polarity of the wait signal input coming
 * from the displa1
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI0_POL_DI0_WAIT_POLARITY (26U) /*!< Bit position for IPU_DI0_POL_DI0_WAIT_POLARITY. */
#define BM_IPU_DI0_POL_DI0_WAIT_POLARITY (0x04000000U) /*!< Bit mask for IPU_DI0_POL_DI0_WAIT_POLARITY. */
#define BS_IPU_DI0_POL_DI0_WAIT_POLARITY (1U) /*!< Bit field size in bits for IPU_DI0_POL_DI0_WAIT_POLARITY. */

/*! @brief Read current value of the IPU_DI0_POL_DI0_WAIT_POLARITY field. */
#define BR_IPU_DI0_POL_DI0_WAIT_POLARITY(x) (HW_IPU_DI0_POL(x).B.DI0_WAIT_POLARITY)

/*! @brief Format value for bitfield IPU_DI0_POL_DI0_WAIT_POLARITY. */
#define BF_IPU_DI0_POL_DI0_WAIT_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_POL_DI0_WAIT_POLARITY) & BM_IPU_DI0_POL_DI0_WAIT_POLARITY)

/*! @brief Set the DI0_WAIT_POLARITY field to a new value. */
#define BW_IPU_DI0_POL_DI0_WAIT_POLARITY(x, v) (HW_IPU_DI0_POL_WR(x, (HW_IPU_DI0_POL_RD(x) & ~BM_IPU_DI0_POL_DI0_WAIT_POLARITY) | BF_IPU_DI0_POL_DI0_WAIT_POLARITY(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_AW0 - DI0 Active Window 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_AW0 - DI0 Active Window 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_aw0
{
    uint32_t U;
    struct _hw_ipu_di0_aw0_bitfields
    {
        uint32_t DI0_AW_HSTART : 12;   /*!< [11:0]  */
        uint32_t DI0_AW_HCOUNT_SEL : 4; /*!< [15:12]  */
        uint32_t DI0_AW_HEND : 12;     /*!< [27:16]  */
        uint32_t DI0_AW_TRIG_SEL : 4;  /*!< [31:28]  */
    } B;
} hw_ipu_di0_aw0_t;

/*!
 * @name Constants and macros for entire IPU_DI0_AW0 register
 */
/*@{*/
#define HW_IPU_DI0_AW0_ADDR(x)   ((uintptr_t)(x) + 0x40168U)

#define HW_IPU_DI0_AW0(x)        (*(__IO hw_ipu_di0_aw0_t *) HW_IPU_DI0_AW0_ADDR(x))
#define HW_IPU_DI0_AW0_RD(x)     (HW_IPU_DI0_AW0(x).U)
#define HW_IPU_DI0_AW0_WR(x, v)  (HW_IPU_DI0_AW0(x).U = (v))
#define HW_IPU_DI0_AW0_SET(x, v) (HW_IPU_DI0_AW0_WR(x, HW_IPU_DI0_AW0_RD(x) |  (v)))
#define HW_IPU_DI0_AW0_CLR(x, v) (HW_IPU_DI0_AW0_WR(x, HW_IPU_DI0_AW0_RD(x) & ~(v)))
#define HW_IPU_DI0_AW0_TOG(x, v) (HW_IPU_DI0_AW0_WR(x, HW_IPU_DI0_AW0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_AW0 bitfields
 */

/*!
 * @name Register IPU_DI0_AW0, field DI0_AW_HSTART[11:0] (RW)
 *
 * This field defines the horizontal start of the active window DI0_AW_HSTART <
 * DI0_AW_HEND
 */
/*@{*/
#define BP_IPU_DI0_AW0_DI0_AW_HSTART (0U)  /*!< Bit position for IPU_DI0_AW0_DI0_AW_HSTART. */
#define BM_IPU_DI0_AW0_DI0_AW_HSTART (0x00000FFFU) /*!< Bit mask for IPU_DI0_AW0_DI0_AW_HSTART. */
#define BS_IPU_DI0_AW0_DI0_AW_HSTART (12U) /*!< Bit field size in bits for IPU_DI0_AW0_DI0_AW_HSTART. */

/*! @brief Read current value of the IPU_DI0_AW0_DI0_AW_HSTART field. */
#define BR_IPU_DI0_AW0_DI0_AW_HSTART(x) (HW_IPU_DI0_AW0(x).B.DI0_AW_HSTART)

/*! @brief Format value for bitfield IPU_DI0_AW0_DI0_AW_HSTART. */
#define BF_IPU_DI0_AW0_DI0_AW_HSTART(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW0_DI0_AW_HSTART) & BM_IPU_DI0_AW0_DI0_AW_HSTART)

/*! @brief Set the DI0_AW_HSTART field to a new value. */
#define BW_IPU_DI0_AW0_DI0_AW_HSTART(x, v) (HW_IPU_DI0_AW0_WR(x, (HW_IPU_DI0_AW0_RD(x) & ~BM_IPU_DI0_AW0_DI0_AW_HSTART) | BF_IPU_DI0_AW0_DI0_AW_HSTART(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_AW0, field DI0_AW_HCOUNT_SEL[15:12] (RW)
 *
 * GM: This field selects the counter that counts the horizontal position of the
 * display's active window
 *
 * Values:
 * - 0000 - disabled
 * - 0001 - reserved
 * - 0010 - The counter is counter #1
 * - 0011 - The counter is counter #2
 * - 0100 - The counter is counter #3
 * - 0101 - The counter is counter #4
 * - 0110 - The counter is counter #5
 * - 1001 - The counter is counter #8
 */
/*@{*/
#define BP_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL (12U) /*!< Bit position for IPU_DI0_AW0_DI0_AW_HCOUNT_SEL. */
#define BM_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL (0x0000F000U) /*!< Bit mask for IPU_DI0_AW0_DI0_AW_HCOUNT_SEL. */
#define BS_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL (4U) /*!< Bit field size in bits for IPU_DI0_AW0_DI0_AW_HCOUNT_SEL. */

/*! @brief Read current value of the IPU_DI0_AW0_DI0_AW_HCOUNT_SEL field. */
#define BR_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL(x) (HW_IPU_DI0_AW0(x).B.DI0_AW_HCOUNT_SEL)

/*! @brief Format value for bitfield IPU_DI0_AW0_DI0_AW_HCOUNT_SEL. */
#define BF_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL) & BM_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL)

/*! @brief Set the DI0_AW_HCOUNT_SEL field to a new value. */
#define BW_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL(x, v) (HW_IPU_DI0_AW0_WR(x, (HW_IPU_DI0_AW0_RD(x) & ~BM_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL) | BF_IPU_DI0_AW0_DI0_AW_HCOUNT_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_AW0, field DI0_AW_HEND[27:16] (RW)
 *
 * This field defines the horizontal end of the active window
 */
/*@{*/
#define BP_IPU_DI0_AW0_DI0_AW_HEND (16U)   /*!< Bit position for IPU_DI0_AW0_DI0_AW_HEND. */
#define BM_IPU_DI0_AW0_DI0_AW_HEND (0x0FFF0000U) /*!< Bit mask for IPU_DI0_AW0_DI0_AW_HEND. */
#define BS_IPU_DI0_AW0_DI0_AW_HEND (12U)   /*!< Bit field size in bits for IPU_DI0_AW0_DI0_AW_HEND. */

/*! @brief Read current value of the IPU_DI0_AW0_DI0_AW_HEND field. */
#define BR_IPU_DI0_AW0_DI0_AW_HEND(x) (HW_IPU_DI0_AW0(x).B.DI0_AW_HEND)

/*! @brief Format value for bitfield IPU_DI0_AW0_DI0_AW_HEND. */
#define BF_IPU_DI0_AW0_DI0_AW_HEND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW0_DI0_AW_HEND) & BM_IPU_DI0_AW0_DI0_AW_HEND)

/*! @brief Set the DI0_AW_HEND field to a new value. */
#define BW_IPU_DI0_AW0_DI0_AW_HEND(x, v) (HW_IPU_DI0_AW0_WR(x, (HW_IPU_DI0_AW0_RD(x) & ~BM_IPU_DI0_AW0_DI0_AW_HEND) | BF_IPU_DI0_AW0_DI0_AW_HEND(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_AW0, field DI0_AW_TRIG_SEL[31:28] (RW)
 *
 * This field selects the trigger for sending data during the display's active
 * window
 *
 * Values:
 * - 000 - disabled
 * - 001 - The trigger is the same trigger that triggers the displays clock.
 * - 010 - The trigger is counter #1
 * - 011 - The trigger is counter #2
 * - 100 - The trigger is counter #3
 * - 101 - The trigger is counter #4
 * - 110 - The trigger is counter #5
 * - 111 - The trigger is always on.
 */
/*@{*/
#define BP_IPU_DI0_AW0_DI0_AW_TRIG_SEL (28U) /*!< Bit position for IPU_DI0_AW0_DI0_AW_TRIG_SEL. */
#define BM_IPU_DI0_AW0_DI0_AW_TRIG_SEL (0xF0000000U) /*!< Bit mask for IPU_DI0_AW0_DI0_AW_TRIG_SEL. */
#define BS_IPU_DI0_AW0_DI0_AW_TRIG_SEL (4U) /*!< Bit field size in bits for IPU_DI0_AW0_DI0_AW_TRIG_SEL. */

/*! @brief Read current value of the IPU_DI0_AW0_DI0_AW_TRIG_SEL field. */
#define BR_IPU_DI0_AW0_DI0_AW_TRIG_SEL(x) (HW_IPU_DI0_AW0(x).B.DI0_AW_TRIG_SEL)

/*! @brief Format value for bitfield IPU_DI0_AW0_DI0_AW_TRIG_SEL. */
#define BF_IPU_DI0_AW0_DI0_AW_TRIG_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW0_DI0_AW_TRIG_SEL) & BM_IPU_DI0_AW0_DI0_AW_TRIG_SEL)

/*! @brief Set the DI0_AW_TRIG_SEL field to a new value. */
#define BW_IPU_DI0_AW0_DI0_AW_TRIG_SEL(x, v) (HW_IPU_DI0_AW0_WR(x, (HW_IPU_DI0_AW0_RD(x) & ~BM_IPU_DI0_AW0_DI0_AW_TRIG_SEL) | BF_IPU_DI0_AW0_DI0_AW_TRIG_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_AW1 - DI0 Active Window 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_AW1 - DI0 Active Window 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_aw1
{
    uint32_t U;
    struct _hw_ipu_di0_aw1_bitfields
    {
        uint32_t DI0_AW_VSTART : 12;   /*!< [11:0]  */
        uint32_t DI0_AW_VCOUNT_SEL : 4; /*!< [15:12]  */
        uint32_t DI0_AW_VEND : 12;     /*!< [27:16]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_di0_aw1_t;

/*!
 * @name Constants and macros for entire IPU_DI0_AW1 register
 */
/*@{*/
#define HW_IPU_DI0_AW1_ADDR(x)   ((uintptr_t)(x) + 0x4016CU)

#define HW_IPU_DI0_AW1(x)        (*(__IO hw_ipu_di0_aw1_t *) HW_IPU_DI0_AW1_ADDR(x))
#define HW_IPU_DI0_AW1_RD(x)     (HW_IPU_DI0_AW1(x).U)
#define HW_IPU_DI0_AW1_WR(x, v)  (HW_IPU_DI0_AW1(x).U = (v))
#define HW_IPU_DI0_AW1_SET(x, v) (HW_IPU_DI0_AW1_WR(x, HW_IPU_DI0_AW1_RD(x) |  (v)))
#define HW_IPU_DI0_AW1_CLR(x, v) (HW_IPU_DI0_AW1_WR(x, HW_IPU_DI0_AW1_RD(x) & ~(v)))
#define HW_IPU_DI0_AW1_TOG(x, v) (HW_IPU_DI0_AW1_WR(x, HW_IPU_DI0_AW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_AW1 bitfields
 */

/*!
 * @name Register IPU_DI0_AW1, field DI0_AW_VSTART[11:0] (RW)
 *
 * This field defines the vertical start of the active window DI0_AW_VSTART <
 * DI0_AW_VEND
 */
/*@{*/
#define BP_IPU_DI0_AW1_DI0_AW_VSTART (0U)  /*!< Bit position for IPU_DI0_AW1_DI0_AW_VSTART. */
#define BM_IPU_DI0_AW1_DI0_AW_VSTART (0x00000FFFU) /*!< Bit mask for IPU_DI0_AW1_DI0_AW_VSTART. */
#define BS_IPU_DI0_AW1_DI0_AW_VSTART (12U) /*!< Bit field size in bits for IPU_DI0_AW1_DI0_AW_VSTART. */

/*! @brief Read current value of the IPU_DI0_AW1_DI0_AW_VSTART field. */
#define BR_IPU_DI0_AW1_DI0_AW_VSTART(x) (HW_IPU_DI0_AW1(x).B.DI0_AW_VSTART)

/*! @brief Format value for bitfield IPU_DI0_AW1_DI0_AW_VSTART. */
#define BF_IPU_DI0_AW1_DI0_AW_VSTART(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW1_DI0_AW_VSTART) & BM_IPU_DI0_AW1_DI0_AW_VSTART)

/*! @brief Set the DI0_AW_VSTART field to a new value. */
#define BW_IPU_DI0_AW1_DI0_AW_VSTART(x, v) (HW_IPU_DI0_AW1_WR(x, (HW_IPU_DI0_AW1_RD(x) & ~BM_IPU_DI0_AW1_DI0_AW_VSTART) | BF_IPU_DI0_AW1_DI0_AW_VSTART(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_AW1, field DI0_AW_VCOUNT_SEL[15:12] (RW)
 *
 * This field selects the counter that counts the vertical position of the
 * display's active window
 *
 * Values:
 * - 0000 - disabled
 * - 0001 - reserved
 * - 0010 - The counter is counter #1
 * - 0011 - The counter is counter #2
 * - 0100 - The counter is counter #3
 * - 0101 - The counter is counter #4
 * - 0110 - The counter is counter #5
 * - 1001 - The counter is counter #8
 */
/*@{*/
#define BP_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL (12U) /*!< Bit position for IPU_DI0_AW1_DI0_AW_VCOUNT_SEL. */
#define BM_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL (0x0000F000U) /*!< Bit mask for IPU_DI0_AW1_DI0_AW_VCOUNT_SEL. */
#define BS_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL (4U) /*!< Bit field size in bits for IPU_DI0_AW1_DI0_AW_VCOUNT_SEL. */

/*! @brief Read current value of the IPU_DI0_AW1_DI0_AW_VCOUNT_SEL field. */
#define BR_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL(x) (HW_IPU_DI0_AW1(x).B.DI0_AW_VCOUNT_SEL)

/*! @brief Format value for bitfield IPU_DI0_AW1_DI0_AW_VCOUNT_SEL. */
#define BF_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL) & BM_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL)

/*! @brief Set the DI0_AW_VCOUNT_SEL field to a new value. */
#define BW_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL(x, v) (HW_IPU_DI0_AW1_WR(x, (HW_IPU_DI0_AW1_RD(x) & ~BM_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL) | BF_IPU_DI0_AW1_DI0_AW_VCOUNT_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_DI0_AW1, field DI0_AW_VEND[27:16] (RW)
 *
 * This field defines the vertical end of the active window
 */
/*@{*/
#define BP_IPU_DI0_AW1_DI0_AW_VEND (16U)   /*!< Bit position for IPU_DI0_AW1_DI0_AW_VEND. */
#define BM_IPU_DI0_AW1_DI0_AW_VEND (0x0FFF0000U) /*!< Bit mask for IPU_DI0_AW1_DI0_AW_VEND. */
#define BS_IPU_DI0_AW1_DI0_AW_VEND (12U)   /*!< Bit field size in bits for IPU_DI0_AW1_DI0_AW_VEND. */

/*! @brief Read current value of the IPU_DI0_AW1_DI0_AW_VEND field. */
#define BR_IPU_DI0_AW1_DI0_AW_VEND(x) (HW_IPU_DI0_AW1(x).B.DI0_AW_VEND)

/*! @brief Format value for bitfield IPU_DI0_AW1_DI0_AW_VEND. */
#define BF_IPU_DI0_AW1_DI0_AW_VEND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_AW1_DI0_AW_VEND) & BM_IPU_DI0_AW1_DI0_AW_VEND)

/*! @brief Set the DI0_AW_VEND field to a new value. */
#define BW_IPU_DI0_AW1_DI0_AW_VEND(x, v) (HW_IPU_DI0_AW1_WR(x, (HW_IPU_DI0_AW1_RD(x) & ~BM_IPU_DI0_AW1_DI0_AW_VEND) | BF_IPU_DI0_AW1_DI0_AW_VEND(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_SCR_CONF - DI0 Screen Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_SCR_CONF - DI0 Screen Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di0_scr_conf
{
    uint32_t U;
    struct _hw_ipu_di0_scr_conf_bitfields
    {
        uint32_t DI0_SCREEN_HEIGHT : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_di0_scr_conf_t;

/*!
 * @name Constants and macros for entire IPU_DI0_SCR_CONF register
 */
/*@{*/
#define HW_IPU_DI0_SCR_CONF_ADDR(x) ((uintptr_t)(x) + 0x40170U)

#define HW_IPU_DI0_SCR_CONF(x)   (*(__IO hw_ipu_di0_scr_conf_t *) HW_IPU_DI0_SCR_CONF_ADDR(x))
#define HW_IPU_DI0_SCR_CONF_RD(x) (HW_IPU_DI0_SCR_CONF(x).U)
#define HW_IPU_DI0_SCR_CONF_WR(x, v) (HW_IPU_DI0_SCR_CONF(x).U = (v))
#define HW_IPU_DI0_SCR_CONF_SET(x, v) (HW_IPU_DI0_SCR_CONF_WR(x, HW_IPU_DI0_SCR_CONF_RD(x) |  (v)))
#define HW_IPU_DI0_SCR_CONF_CLR(x, v) (HW_IPU_DI0_SCR_CONF_WR(x, HW_IPU_DI0_SCR_CONF_RD(x) & ~(v)))
#define HW_IPU_DI0_SCR_CONF_TOG(x, v) (HW_IPU_DI0_SCR_CONF_WR(x, HW_IPU_DI0_SCR_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_SCR_CONF bitfields
 */

/*!
 * @name Register IPU_DI0_SCR_CONF, field DI0_SCREEN_HEIGHT[11:0] (RW)
 *
 * This field defines the number of display rows (Number_of_ROWS =
 * DI0_SCREEN_HEIGHT+1) This field is used for VSYNC calculation and for anti-tearing
 */
/*@{*/
#define BP_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT (0U) /*!< Bit position for IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT. */
#define BM_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT (0x00000FFFU) /*!< Bit mask for IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT. */
#define BS_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT (12U) /*!< Bit field size in bits for IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT. */

/*! @brief Read current value of the IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT field. */
#define BR_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT(x) (HW_IPU_DI0_SCR_CONF(x).B.DI0_SCREEN_HEIGHT)

/*! @brief Format value for bitfield IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT. */
#define BF_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT) & BM_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT)

/*! @brief Set the DI0_SCREEN_HEIGHT field to a new value. */
#define BW_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT(x, v) (HW_IPU_DI0_SCR_CONF_WR(x, (HW_IPU_DI0_SCR_CONF_RD(x) & ~BM_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT) | BF_IPU_DI0_SCR_CONF_DI0_SCREEN_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI0_STAT - DI0 Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI0_STAT - DI0 Status Register (RO)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_ipu_di0_stat
{
    uint32_t U;
    struct _hw_ipu_di0_stat_bitfields
    {
        uint32_t DI0_READ_FIFO_EMPTY : 1; /*!< [0]  */
        uint32_t DI0_READ_FIFO_FULL : 1; /*!< [1]  */
        uint32_t DI0_READ_CNTR_EMPTY : 1; /*!< [2]  */
        uint32_t DI0_CNTR_FIFO_FULL : 1; /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_ipu_di0_stat_t;

/*!
 * @name Constants and macros for entire IPU_DI0_STAT register
 */
/*@{*/
#define HW_IPU_DI0_STAT_ADDR(x)  ((uintptr_t)(x) + 0x40174U)

#define HW_IPU_DI0_STAT(x)       (*(__I hw_ipu_di0_stat_t *) HW_IPU_DI0_STAT_ADDR(x))
#define HW_IPU_DI0_STAT_RD(x)    (HW_IPU_DI0_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DI0_STAT bitfields
 */

/*!
 * @name Register IPU_DI0_STAT, field DI0_READ_FIFO_EMPTY[0] (RO)
 *
 * This bit indicates an empty state of the DI0 FIFO when performing a read.
 * This FIFO is part of the DI0 synchronizer.
 */
/*@{*/
#define BP_IPU_DI0_STAT_DI0_READ_FIFO_EMPTY (0U) /*!< Bit position for IPU_DI0_STAT_DI0_READ_FIFO_EMPTY. */
#define BM_IPU_DI0_STAT_DI0_READ_FIFO_EMPTY (0x00000001U) /*!< Bit mask for IPU_DI0_STAT_DI0_READ_FIFO_EMPTY. */
#define BS_IPU_DI0_STAT_DI0_READ_FIFO_EMPTY (1U) /*!< Bit field size in bits for IPU_DI0_STAT_DI0_READ_FIFO_EMPTY. */

/*! @brief Read current value of the IPU_DI0_STAT_DI0_READ_FIFO_EMPTY field. */
#define BR_IPU_DI0_STAT_DI0_READ_FIFO_EMPTY(x) (HW_IPU_DI0_STAT(x).B.DI0_READ_FIFO_EMPTY)
/*@}*/

/*!
 * @name Register IPU_DI0_STAT, field DI0_READ_FIFO_FULL[1] (RO)
 *
 * This bit indicates a full state of the DI0 FIFO when performing a read. This
 * FIFO is part of the DI0 synchronizer.
 */
/*@{*/
#define BP_IPU_DI0_STAT_DI0_READ_FIFO_FULL (1U) /*!< Bit position for IPU_DI0_STAT_DI0_READ_FIFO_FULL. */
#define BM_IPU_DI0_STAT_DI0_READ_FIFO_FULL (0x00000002U) /*!< Bit mask for IPU_DI0_STAT_DI0_READ_FIFO_FULL. */
#define BS_IPU_DI0_STAT_DI0_READ_FIFO_FULL (1U) /*!< Bit field size in bits for IPU_DI0_STAT_DI0_READ_FIFO_FULL. */

/*! @brief Read current value of the IPU_DI0_STAT_DI0_READ_FIFO_FULL field. */
#define BR_IPU_DI0_STAT_DI0_READ_FIFO_FULL(x) (HW_IPU_DI0_STAT(x).B.DI0_READ_FIFO_FULL)
/*@}*/

/*!
 * @name Register IPU_DI0_STAT, field DI0_READ_CNTR_EMPTY[2] (RO)
 *
 * This bit indicates an empty state of the DI0 FIFO. This FIFO is part of the
 * DI0 synchronizer.
 */
/*@{*/
#define BP_IPU_DI0_STAT_DI0_READ_CNTR_EMPTY (2U) /*!< Bit position for IPU_DI0_STAT_DI0_READ_CNTR_EMPTY. */
#define BM_IPU_DI0_STAT_DI0_READ_CNTR_EMPTY (0x00000004U) /*!< Bit mask for IPU_DI0_STAT_DI0_READ_CNTR_EMPTY. */
#define BS_IPU_DI0_STAT_DI0_READ_CNTR_EMPTY (1U) /*!< Bit field size in bits for IPU_DI0_STAT_DI0_READ_CNTR_EMPTY. */

/*! @brief Read current value of the IPU_DI0_STAT_DI0_READ_CNTR_EMPTY field. */
#define BR_IPU_DI0_STAT_DI0_READ_CNTR_EMPTY(x) (HW_IPU_DI0_STAT(x).B.DI0_READ_CNTR_EMPTY)
/*@}*/

/*!
 * @name Register IPU_DI0_STAT, field DI0_CNTR_FIFO_FULL[3] (RO)
 *
 * This bit indicates a full state of the DI0 FIFO. This FIFO is part of the DI0
 * synchronizer.
 */
/*@{*/
#define BP_IPU_DI0_STAT_DI0_CNTR_FIFO_FULL (3U) /*!< Bit position for IPU_DI0_STAT_DI0_CNTR_FIFO_FULL. */
#define BM_IPU_DI0_STAT_DI0_CNTR_FIFO_FULL (0x00000008U) /*!< Bit mask for IPU_DI0_STAT_DI0_CNTR_FIFO_FULL. */
#define BS_IPU_DI0_STAT_DI0_CNTR_FIFO_FULL (1U) /*!< Bit field size in bits for IPU_DI0_STAT_DI0_CNTR_FIFO_FULL. */

/*! @brief Read current value of the IPU_DI0_STAT_DI0_CNTR_FIFO_FULL field. */
#define BR_IPU_DI0_STAT_DI0_CNTR_FIFO_FULL(x) (HW_IPU_DI0_STAT(x).B.DI0_CNTR_FIFO_FULL)
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_GENERAL - DI1General Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_GENERAL - DI1General Register (RW)
 *
 * Reset value: 0x00200000U
 */
typedef union _hw_ipu_di1_general
{
    uint32_t U;
    struct _hw_ipu_di1_general_bitfields
    {
        uint32_t di1_polarity_i_1 : 8; /*!< [7:0]  */
        uint32_t di1_polarity_cs0 : 1; /*!< [8]  */
        uint32_t di1_polarity_cs1 : 1; /*!< [9]  */
        uint32_t di1_erm_vsync_sel : 1; /*!< [10]  */
        uint32_t di1_err_treatment : 1; /*!< [11]  */
        uint32_t di1_sync_count_sel : 4; /*!< [15:12]  */
        uint32_t RESERVED0 : 1;        /*!< [16]  */
        uint32_t di1_polarity_disp_clk : 1; /*!< [17]  */
        uint32_t DI1_WATCHDOG_MODE : 2; /*!< [19:18]  */
        uint32_t di1_clk_ext : 1;      /*!< [20]  */
        uint32_t di1_vsync_ext : 1;    /*!< [21]  */
        uint32_t di1_mask_sel : 1;     /*!< [22]  */
        uint32_t DI1_DISP_CLOCK_INIT : 1; /*!< [23]  */
        uint32_t DI1_CLOCK_STOP_MODE : 4; /*!< [27:24]  */
        uint32_t di1_disp_y_sel : 3;   /*!< [30:28]  */
        uint32_t di1_pin8_pin15_sel : 1; /*!< [31]  */
    } B;
} hw_ipu_di1_general_t;

/*!
 * @name Constants and macros for entire IPU_DI1_GENERAL register
 */
/*@{*/
#define HW_IPU_DI1_GENERAL_ADDR(x) ((uintptr_t)(x) + 0x48000U)

#define HW_IPU_DI1_GENERAL(x)    (*(__IO hw_ipu_di1_general_t *) HW_IPU_DI1_GENERAL_ADDR(x))
#define HW_IPU_DI1_GENERAL_RD(x) (HW_IPU_DI1_GENERAL(x).U)
#define HW_IPU_DI1_GENERAL_WR(x, v) (HW_IPU_DI1_GENERAL(x).U = (v))
#define HW_IPU_DI1_GENERAL_SET(x, v) (HW_IPU_DI1_GENERAL_WR(x, HW_IPU_DI1_GENERAL_RD(x) |  (v)))
#define HW_IPU_DI1_GENERAL_CLR(x, v) (HW_IPU_DI1_GENERAL_WR(x, HW_IPU_DI1_GENERAL_RD(x) & ~(v)))
#define HW_IPU_DI1_GENERAL_TOG(x, v) (HW_IPU_DI1_GENERAL_WR(x, HW_IPU_DI1_GENERAL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_GENERAL bitfields
 */

/*!
 * @name Register IPU_DI1_GENERAL, field di1_polarity_i_1[7:0] (RW)
 *
 * DI1 output pin's polarity This bits define the polarity of each of the DI's
 * outputs.
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_polarity_i_1 (0U) /*!< Bit position for IPU_DI1_GENERAL_di1_polarity_i_1. */
#define BM_IPU_DI1_GENERAL_di1_polarity_i_1 (0x000000FFU) /*!< Bit mask for IPU_DI1_GENERAL_di1_polarity_i_1. */
#define BS_IPU_DI1_GENERAL_di1_polarity_i_1 (8U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_polarity_i_1. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_polarity_i_1 field. */
#define BR_IPU_DI1_GENERAL_di1_polarity_i_1(x) (HW_IPU_DI1_GENERAL(x).B.di1_polarity_i_1)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_polarity_i_1. */
#define BF_IPU_DI1_GENERAL_di1_polarity_i_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_polarity_i_1) & BM_IPU_DI1_GENERAL_di1_polarity_i_1)

/*! @brief Set the di1_polarity_i_1 field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_polarity_i_1(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_polarity_i_1) | BF_IPU_DI1_GENERAL_di1_polarity_i_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_polarity_cs0[8] (RW)
 *
 * DI1 Chip Select's 0 polarity This bits define the polarity of the DI's CS0.
 *
 * Values:
 * - 1 - The CS0 is active high
 * - 0 - The CS0 is active low
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_polarity_cs0 (8U) /*!< Bit position for IPU_DI1_GENERAL_di1_polarity_cs0. */
#define BM_IPU_DI1_GENERAL_di1_polarity_cs0 (0x00000100U) /*!< Bit mask for IPU_DI1_GENERAL_di1_polarity_cs0. */
#define BS_IPU_DI1_GENERAL_di1_polarity_cs0 (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_polarity_cs0. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_polarity_cs0 field. */
#define BR_IPU_DI1_GENERAL_di1_polarity_cs0(x) (HW_IPU_DI1_GENERAL(x).B.di1_polarity_cs0)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_polarity_cs0. */
#define BF_IPU_DI1_GENERAL_di1_polarity_cs0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_polarity_cs0) & BM_IPU_DI1_GENERAL_di1_polarity_cs0)

/*! @brief Set the di1_polarity_cs0 field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_polarity_cs0(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_polarity_cs0) | BF_IPU_DI1_GENERAL_di1_polarity_cs0(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_polarity_cs1[9] (RW)
 *
 * DI1 Chip Select's 1 polarity This bits define the polarity of the DI's CS1.
 *
 * Values:
 * - 1 - The CS1 is active high
 * - 0 - The CS1 is active low
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_polarity_cs1 (9U) /*!< Bit position for IPU_DI1_GENERAL_di1_polarity_cs1. */
#define BM_IPU_DI1_GENERAL_di1_polarity_cs1 (0x00000200U) /*!< Bit mask for IPU_DI1_GENERAL_di1_polarity_cs1. */
#define BS_IPU_DI1_GENERAL_di1_polarity_cs1 (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_polarity_cs1. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_polarity_cs1 field. */
#define BR_IPU_DI1_GENERAL_di1_polarity_cs1(x) (HW_IPU_DI1_GENERAL(x).B.di1_polarity_cs1)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_polarity_cs1. */
#define BF_IPU_DI1_GENERAL_di1_polarity_cs1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_polarity_cs1) & BM_IPU_DI1_GENERAL_di1_polarity_cs1)

/*! @brief Set the di1_polarity_cs1 field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_polarity_cs1(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_polarity_cs1) | BF_IPU_DI1_GENERAL_di1_polarity_cs1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_erm_vsync_sel[10] (RW)
 *
 * DI1 error recovery module's VSYNC source select The error recovery block
 * detect a case where the DI's VSYNC is asserted before the EOF. This bit selects
 * the source of the VSYNC signal monitored by this mechanism.
 *
 * Values:
 * - 1 - vsync_post - an internal VSYNC signal asserted 2 lines after the DI's
 *     VSYNC
 * - 0 - vsync_pre - an internal VSYNC signal asserted 2 lines before the DI's
 *     VSYNC
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_erm_vsync_sel (10U) /*!< Bit position for IPU_DI1_GENERAL_di1_erm_vsync_sel. */
#define BM_IPU_DI1_GENERAL_di1_erm_vsync_sel (0x00000400U) /*!< Bit mask for IPU_DI1_GENERAL_di1_erm_vsync_sel. */
#define BS_IPU_DI1_GENERAL_di1_erm_vsync_sel (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_erm_vsync_sel. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_erm_vsync_sel field. */
#define BR_IPU_DI1_GENERAL_di1_erm_vsync_sel(x) (HW_IPU_DI1_GENERAL(x).B.di1_erm_vsync_sel)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_erm_vsync_sel. */
#define BF_IPU_DI1_GENERAL_di1_erm_vsync_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_erm_vsync_sel) & BM_IPU_DI1_GENERAL_di1_erm_vsync_sel)

/*! @brief Set the di1_erm_vsync_sel field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_erm_vsync_sel(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_erm_vsync_sel) | BF_IPU_DI1_GENERAL_di1_erm_vsync_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_err_treatment[11] (RW)
 *
 * In case of synchronous flow error there are 2 ways to handle the display
 *
 * Values:
 * - 1 - to wait (i.e. stop clock)
 * - 0 - Drive the last component
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_err_treatment (11U) /*!< Bit position for IPU_DI1_GENERAL_di1_err_treatment. */
#define BM_IPU_DI1_GENERAL_di1_err_treatment (0x00000800U) /*!< Bit mask for IPU_DI1_GENERAL_di1_err_treatment. */
#define BS_IPU_DI1_GENERAL_di1_err_treatment (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_err_treatment. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_err_treatment field. */
#define BR_IPU_DI1_GENERAL_di1_err_treatment(x) (HW_IPU_DI1_GENERAL(x).B.di1_err_treatment)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_err_treatment. */
#define BF_IPU_DI1_GENERAL_di1_err_treatment(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_err_treatment) & BM_IPU_DI1_GENERAL_di1_err_treatment)

/*! @brief Set the di1_err_treatment field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_err_treatment(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_err_treatment) | BF_IPU_DI1_GENERAL_di1_err_treatment(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_sync_count_sel[15:12] (RW)
 *
 * For synchronous flow error: selects synchronous flow synchronization counter
 * in DI:
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_sync_count_sel (12U) /*!< Bit position for IPU_DI1_GENERAL_di1_sync_count_sel. */
#define BM_IPU_DI1_GENERAL_di1_sync_count_sel (0x0000F000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_sync_count_sel. */
#define BS_IPU_DI1_GENERAL_di1_sync_count_sel (4U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_sync_count_sel. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_sync_count_sel field. */
#define BR_IPU_DI1_GENERAL_di1_sync_count_sel(x) (HW_IPU_DI1_GENERAL(x).B.di1_sync_count_sel)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_sync_count_sel. */
#define BF_IPU_DI1_GENERAL_di1_sync_count_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_sync_count_sel) & BM_IPU_DI1_GENERAL_di1_sync_count_sel)

/*! @brief Set the di1_sync_count_sel field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_sync_count_sel(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_sync_count_sel) | BF_IPU_DI1_GENERAL_di1_sync_count_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_polarity_disp_clk[17] (RW)
 *
 * DI1 Output Clock's polarity This bits define the polarity of the DI's clock.
 *
 * Values:
 * - 1 - The output clock is active high
 * - 0 - The output clock is active low
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_polarity_disp_clk (17U) /*!< Bit position for IPU_DI1_GENERAL_di1_polarity_disp_clk. */
#define BM_IPU_DI1_GENERAL_di1_polarity_disp_clk (0x00020000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_polarity_disp_clk. */
#define BS_IPU_DI1_GENERAL_di1_polarity_disp_clk (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_polarity_disp_clk. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_polarity_disp_clk field. */
#define BR_IPU_DI1_GENERAL_di1_polarity_disp_clk(x) (HW_IPU_DI1_GENERAL(x).B.di1_polarity_disp_clk)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_polarity_disp_clk. */
#define BF_IPU_DI1_GENERAL_di1_polarity_disp_clk(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_polarity_disp_clk) & BM_IPU_DI1_GENERAL_di1_polarity_disp_clk)

/*! @brief Set the di1_polarity_disp_clk field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_polarity_disp_clk(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_polarity_disp_clk) | BF_IPU_DI1_GENERAL_di1_polarity_disp_clk(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field DI1_WATCHDOG_MODE[19:18] (RW)
 *
 * DI1 watchdog mode In case of a display error where the DI clock is stopped
 * (defined at di0_err_treatment). An internal watchdog counts DI clocks. If this
 * timer reached its pre defined value the DI will skip the current frame and
 * restart on the frame. This 2 bits define the number of DI clock cycles that the
 * timer counts.
 *
 * Values:
 * - 00 - The timer counts 4 DI cycles
 * - 01 - The timer counts 16 DI cycles
 * - 10 - The timer counts 64 DI cycles
 * - 11 - The timer counts 128 DI cycles
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE (18U) /*!< Bit position for IPU_DI1_GENERAL_DI1_WATCHDOG_MODE. */
#define BM_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE (0x000C0000U) /*!< Bit mask for IPU_DI1_GENERAL_DI1_WATCHDOG_MODE. */
#define BS_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE (2U) /*!< Bit field size in bits for IPU_DI1_GENERAL_DI1_WATCHDOG_MODE. */

/*! @brief Read current value of the IPU_DI1_GENERAL_DI1_WATCHDOG_MODE field. */
#define BR_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE(x) (HW_IPU_DI1_GENERAL(x).B.DI1_WATCHDOG_MODE)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_DI1_WATCHDOG_MODE. */
#define BF_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE) & BM_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE)

/*! @brief Set the DI1_WATCHDOG_MODE field to a new value. */
#define BW_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE) | BF_IPU_DI1_GENERAL_DI1_WATCHDOG_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_clk_ext[20] (RW)
 *
 * DI1 External Clock. This bit selects the source of the DI's clock
 *
 * Values:
 * - 1 - The source of the clock is external to the IPU
 * - 0 - The clock is internally generated by the IPU
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_clk_ext (20U) /*!< Bit position for IPU_DI1_GENERAL_di1_clk_ext. */
#define BM_IPU_DI1_GENERAL_di1_clk_ext (0x00100000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_clk_ext. */
#define BS_IPU_DI1_GENERAL_di1_clk_ext (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_clk_ext. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_clk_ext field. */
#define BR_IPU_DI1_GENERAL_di1_clk_ext(x) (HW_IPU_DI1_GENERAL(x).B.di1_clk_ext)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_clk_ext. */
#define BF_IPU_DI1_GENERAL_di1_clk_ext(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_clk_ext) & BM_IPU_DI1_GENERAL_di1_clk_ext)

/*! @brief Set the di1_clk_ext field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_clk_ext(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_clk_ext) | BF_IPU_DI1_GENERAL_di1_clk_ext(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_vsync_ext[21] (RW)
 *
 * DI1 External VSYNC. This bit selects the source of the VSYNC signal
 *
 * Values:
 * - 1 - External to the IPU
 * - 0 - Internally generated by the IPU
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_vsync_ext (21U) /*!< Bit position for IPU_DI1_GENERAL_di1_vsync_ext. */
#define BM_IPU_DI1_GENERAL_di1_vsync_ext (0x00200000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_vsync_ext. */
#define BS_IPU_DI1_GENERAL_di1_vsync_ext (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_vsync_ext. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_vsync_ext field. */
#define BR_IPU_DI1_GENERAL_di1_vsync_ext(x) (HW_IPU_DI1_GENERAL(x).B.di1_vsync_ext)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_vsync_ext. */
#define BF_IPU_DI1_GENERAL_di1_vsync_ext(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_vsync_ext) & BM_IPU_DI1_GENERAL_di1_vsync_ext)

/*! @brief Set the di1_vsync_ext field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_vsync_ext(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_vsync_ext) | BF_IPU_DI1_GENERAL_di1_vsync_ext(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_mask_sel[22] (RW)
 *
 * DI1 Mask select. IPP_PIN_2 output of the DI that functions as MASK signal can
 * come from 2 sources: counter #2 or extracted from the MASK data coming from
 * the memory.
 *
 * Values:
 * - 1 - IPP_PIN_2 is coming from extracted MASK data coming from the memory
 * - 0 - IPP_PIN_2 is coming from counter #2
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_mask_sel (22U) /*!< Bit position for IPU_DI1_GENERAL_di1_mask_sel. */
#define BM_IPU_DI1_GENERAL_di1_mask_sel (0x00400000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_mask_sel. */
#define BS_IPU_DI1_GENERAL_di1_mask_sel (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_mask_sel. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_mask_sel field. */
#define BR_IPU_DI1_GENERAL_di1_mask_sel(x) (HW_IPU_DI1_GENERAL(x).B.di1_mask_sel)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_mask_sel. */
#define BF_IPU_DI1_GENERAL_di1_mask_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_mask_sel) & BM_IPU_DI1_GENERAL_di1_mask_sel)

/*! @brief Set the di1_mask_sel field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_mask_sel(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_mask_sel) | BF_IPU_DI1_GENERAL_di1_mask_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field DI1_DISP_CLOCK_INIT[23] (RW)
 *
 * Display clock's initial mode For synchronization error conditions the display
 * clock can be stopped on the next VSYNC
 *
 * Values:
 * - 1 - The display's clock is running after the next VSYNC (indicating new
 *     frame)
 * - 0 - The display's clock is stopped after the next VSYNC (indicating new
 *     frame)
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT (23U) /*!< Bit position for IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT. */
#define BM_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT (0x00800000U) /*!< Bit mask for IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT. */
#define BS_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT. */

/*! @brief Read current value of the IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT field. */
#define BR_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT(x) (HW_IPU_DI1_GENERAL(x).B.DI1_DISP_CLOCK_INIT)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT. */
#define BF_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT) & BM_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT)

/*! @brief Set the DI1_DISP_CLOCK_INIT field to a new value. */
#define BW_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT) | BF_IPU_DI1_GENERAL_DI1_DISP_CLOCK_INIT(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field DI1_CLOCK_STOP_MODE[27:24] (RW)
 *
 * DI clock stop mode When performing a clock change. The DI stops the clock to
 * the display. These field defines when the clock will be stopped Stopping at
 * EOL/EOF is supported for the case where the data is coming from the IDMAC (DMA
 * access). In case that only direct accesses is performed, the user should set
 * this field to 0000 0001-1001 stop at the next event of one of the counters
 * (counter #1 to counter #9)
 *
 * Values:
 * - 0000 - stop at the next edge of the display clock
 * - 1100 - stop at EOL (end of a line), but if stop request is during blanking
 *     interval, stop now
 * - 1101 - stop at EOF (end of a frame), but if stop request is during blanking
 *     interval, stop now
 * - 1110 - stop at EOL (end of a line), but if stop request is during blanking
 *     interval, stop at the end of the next line
 * - 1111 - stop at EOF (end of a frame), but if stop request is during blanking
 *     interval, stop at the end of the next frame
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE (24U) /*!< Bit position for IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE. */
#define BM_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE (0x0F000000U) /*!< Bit mask for IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE. */
#define BS_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE (4U) /*!< Bit field size in bits for IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE. */

/*! @brief Read current value of the IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE field. */
#define BR_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE(x) (HW_IPU_DI1_GENERAL(x).B.DI1_CLOCK_STOP_MODE)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE. */
#define BF_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE) & BM_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE)

/*! @brief Set the DI1_CLOCK_STOP_MODE field to a new value. */
#define BW_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE) | BF_IPU_DI1_GENERAL_DI1_CLOCK_STOP_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_disp_y_sel[30:28] (RW)
 *
 * DI1 Display Vertical coordinate (Y) select. This field defines which one of
 * the 8 counters will be used as a display's line counter.
 *
 * Values:
 * - 000 - counter #1 is selected
 * - 111 - counter #8 is selected
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_disp_y_sel (28U) /*!< Bit position for IPU_DI1_GENERAL_di1_disp_y_sel. */
#define BM_IPU_DI1_GENERAL_di1_disp_y_sel (0x70000000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_disp_y_sel. */
#define BS_IPU_DI1_GENERAL_di1_disp_y_sel (3U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_disp_y_sel. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_disp_y_sel field. */
#define BR_IPU_DI1_GENERAL_di1_disp_y_sel(x) (HW_IPU_DI1_GENERAL(x).B.di1_disp_y_sel)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_disp_y_sel. */
#define BF_IPU_DI1_GENERAL_di1_disp_y_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_disp_y_sel) & BM_IPU_DI1_GENERAL_di1_disp_y_sel)

/*! @brief Set the di1_disp_y_sel field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_disp_y_sel(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_disp_y_sel) | BF_IPU_DI1_GENERAL_di1_disp_y_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_GENERAL, field di1_pin8_pin15_sel[31] (RW)
 *
 * This bit routes PIN8 over PIN15
 *
 * Values:
 * - 1 - PIN8 is routed to PIN15, PIN8 is also routed to PIN8
 * - 0 - PIN15 is routed to PIN15, PIN8 is routed to PIN8
 */
/*@{*/
#define BP_IPU_DI1_GENERAL_di1_pin8_pin15_sel (31U) /*!< Bit position for IPU_DI1_GENERAL_di1_pin8_pin15_sel. */
#define BM_IPU_DI1_GENERAL_di1_pin8_pin15_sel (0x80000000U) /*!< Bit mask for IPU_DI1_GENERAL_di1_pin8_pin15_sel. */
#define BS_IPU_DI1_GENERAL_di1_pin8_pin15_sel (1U) /*!< Bit field size in bits for IPU_DI1_GENERAL_di1_pin8_pin15_sel. */

/*! @brief Read current value of the IPU_DI1_GENERAL_di1_pin8_pin15_sel field. */
#define BR_IPU_DI1_GENERAL_di1_pin8_pin15_sel(x) (HW_IPU_DI1_GENERAL(x).B.di1_pin8_pin15_sel)

/*! @brief Format value for bitfield IPU_DI1_GENERAL_di1_pin8_pin15_sel. */
#define BF_IPU_DI1_GENERAL_di1_pin8_pin15_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_GENERAL_di1_pin8_pin15_sel) & BM_IPU_DI1_GENERAL_di1_pin8_pin15_sel)

/*! @brief Set the di1_pin8_pin15_sel field to a new value. */
#define BW_IPU_DI1_GENERAL_di1_pin8_pin15_sel(x, v) (HW_IPU_DI1_GENERAL_WR(x, (HW_IPU_DI1_GENERAL_RD(x) & ~BM_IPU_DI1_GENERAL_di1_pin8_pin15_sel) | BF_IPU_DI1_GENERAL_di1_pin8_pin15_sel(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_BS_CLKGEN0 - DI1 Base Sync Clock Gen 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_BS_CLKGEN0 - DI1 Base Sync Clock Gen 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_bs_clkgen0
{
    uint32_t U;
    struct _hw_ipu_di1_bs_clkgen0_bitfields
    {
        uint32_t di1_disp_clk_period : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t di1_disp_clk_offset : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_bs_clkgen0_t;

/*!
 * @name Constants and macros for entire IPU_DI1_BS_CLKGEN0 register
 */
/*@{*/
#define HW_IPU_DI1_BS_CLKGEN0_ADDR(x) ((uintptr_t)(x) + 0x48004U)

#define HW_IPU_DI1_BS_CLKGEN0(x) (*(__IO hw_ipu_di1_bs_clkgen0_t *) HW_IPU_DI1_BS_CLKGEN0_ADDR(x))
#define HW_IPU_DI1_BS_CLKGEN0_RD(x) (HW_IPU_DI1_BS_CLKGEN0(x).U)
#define HW_IPU_DI1_BS_CLKGEN0_WR(x, v) (HW_IPU_DI1_BS_CLKGEN0(x).U = (v))
#define HW_IPU_DI1_BS_CLKGEN0_SET(x, v) (HW_IPU_DI1_BS_CLKGEN0_WR(x, HW_IPU_DI1_BS_CLKGEN0_RD(x) |  (v)))
#define HW_IPU_DI1_BS_CLKGEN0_CLR(x, v) (HW_IPU_DI1_BS_CLKGEN0_WR(x, HW_IPU_DI1_BS_CLKGEN0_RD(x) & ~(v)))
#define HW_IPU_DI1_BS_CLKGEN0_TOG(x, v) (HW_IPU_DI1_BS_CLKGEN0_WR(x, HW_IPU_DI1_BS_CLKGEN0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_BS_CLKGEN0 bitfields
 */

/*!
 * @name Register IPU_DI1_BS_CLKGEN0, field di1_disp_clk_period[11:0] (RW)
 *
 * DI1 Display Clock Period This field defines the Display interface clock
 * period for display write access. This parameter contains an integer part (bits
 * 11:4) and a fractional part (bits 3:0). It defines a fractional division ratio of
 * the HSP_CLK clock for generation of the display's interface clock.
 */
/*@{*/
#define BP_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period (0U) /*!< Bit position for IPU_DI1_BS_CLKGEN0_di1_disp_clk_period. */
#define BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period (0x00000FFFU) /*!< Bit mask for IPU_DI1_BS_CLKGEN0_di1_disp_clk_period. */
#define BS_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period (12U) /*!< Bit field size in bits for IPU_DI1_BS_CLKGEN0_di1_disp_clk_period. */

/*! @brief Read current value of the IPU_DI1_BS_CLKGEN0_di1_disp_clk_period field. */
#define BR_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period(x) (HW_IPU_DI1_BS_CLKGEN0(x).B.di1_disp_clk_period)

/*! @brief Format value for bitfield IPU_DI1_BS_CLKGEN0_di1_disp_clk_period. */
#define BF_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period) & BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period)

/*! @brief Set the di1_disp_clk_period field to a new value. */
#define BW_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period(x, v) (HW_IPU_DI1_BS_CLKGEN0_WR(x, (HW_IPU_DI1_BS_CLKGEN0_RD(x) & ~BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period) | BF_IPU_DI1_BS_CLKGEN0_di1_disp_clk_period(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_BS_CLKGEN0, field di1_disp_clk_offset[24:16] (RW)
 *
 * DI1 Display Clock Offset The DI has the ability to delay the display's clock
 * This field defines the amount of IPU's clock cycles added as delay on this
 * clock.
 */
/*@{*/
#define BP_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset (16U) /*!< Bit position for IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset. */
#define BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset (0x01FF0000U) /*!< Bit mask for IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset. */
#define BS_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset (9U) /*!< Bit field size in bits for IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset. */

/*! @brief Read current value of the IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset field. */
#define BR_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset(x) (HW_IPU_DI1_BS_CLKGEN0(x).B.di1_disp_clk_offset)

/*! @brief Format value for bitfield IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset. */
#define BF_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset) & BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset)

/*! @brief Set the di1_disp_clk_offset field to a new value. */
#define BW_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset(x, v) (HW_IPU_DI1_BS_CLKGEN0_WR(x, (HW_IPU_DI1_BS_CLKGEN0_RD(x) & ~BM_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset) | BF_IPU_DI1_BS_CLKGEN0_di1_disp_clk_offset(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_BS_CLKGEN1 - DI1 Base Sync Clock Gen 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_BS_CLKGEN1 - DI1 Base Sync Clock Gen 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_bs_clkgen1
{
    uint32_t U;
    struct _hw_ipu_di1_bs_clkgen1_bitfields
    {
        uint32_t di1_disp_clk_up : 9;  /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di1_disp_clk_down : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_bs_clkgen1_t;

/*!
 * @name Constants and macros for entire IPU_DI1_BS_CLKGEN1 register
 */
/*@{*/
#define HW_IPU_DI1_BS_CLKGEN1_ADDR(x) ((uintptr_t)(x) + 0x48008U)

#define HW_IPU_DI1_BS_CLKGEN1(x) (*(__IO hw_ipu_di1_bs_clkgen1_t *) HW_IPU_DI1_BS_CLKGEN1_ADDR(x))
#define HW_IPU_DI1_BS_CLKGEN1_RD(x) (HW_IPU_DI1_BS_CLKGEN1(x).U)
#define HW_IPU_DI1_BS_CLKGEN1_WR(x, v) (HW_IPU_DI1_BS_CLKGEN1(x).U = (v))
#define HW_IPU_DI1_BS_CLKGEN1_SET(x, v) (HW_IPU_DI1_BS_CLKGEN1_WR(x, HW_IPU_DI1_BS_CLKGEN1_RD(x) |  (v)))
#define HW_IPU_DI1_BS_CLKGEN1_CLR(x, v) (HW_IPU_DI1_BS_CLKGEN1_WR(x, HW_IPU_DI1_BS_CLKGEN1_RD(x) & ~(v)))
#define HW_IPU_DI1_BS_CLKGEN1_TOG(x, v) (HW_IPU_DI1_BS_CLKGEN1_WR(x, HW_IPU_DI1_BS_CLKGEN1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_BS_CLKGEN1 bitfields
 */

/*!
 * @name Register IPU_DI1_BS_CLKGEN1, field di1_disp_clk_up[8:0] (RW)
 *
 * DI1 display clock rising edge position This parameter contains an integer
 * part (bits 8:1) and a fractional part (bit 0). The position value is a time
 * interval between display's access start point and display 's interface clock rising
 * edge.
 */
/*@{*/
#define BP_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up (0U) /*!< Bit position for IPU_DI1_BS_CLKGEN1_di1_disp_clk_up. */
#define BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up (0x000001FFU) /*!< Bit mask for IPU_DI1_BS_CLKGEN1_di1_disp_clk_up. */
#define BS_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up (9U) /*!< Bit field size in bits for IPU_DI1_BS_CLKGEN1_di1_disp_clk_up. */

/*! @brief Read current value of the IPU_DI1_BS_CLKGEN1_di1_disp_clk_up field. */
#define BR_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up(x) (HW_IPU_DI1_BS_CLKGEN1(x).B.di1_disp_clk_up)

/*! @brief Format value for bitfield IPU_DI1_BS_CLKGEN1_di1_disp_clk_up. */
#define BF_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up) & BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up)

/*! @brief Set the di1_disp_clk_up field to a new value. */
#define BW_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up(x, v) (HW_IPU_DI1_BS_CLKGEN1_WR(x, (HW_IPU_DI1_BS_CLKGEN1_RD(x) & ~BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up) | BF_IPU_DI1_BS_CLKGEN1_di1_disp_clk_up(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_BS_CLKGEN1, field di1_disp_clk_down[24:16] (RW)
 *
 * DI1 display clock falling edge position This parameter contains an integer
 * part (bits 24:17) and a fractional part (bit 16). The position value is a time
 * interval between display's access start point and display 's interface clock
 * falling edge.
 */
/*@{*/
#define BP_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down (16U) /*!< Bit position for IPU_DI1_BS_CLKGEN1_di1_disp_clk_down. */
#define BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down (0x01FF0000U) /*!< Bit mask for IPU_DI1_BS_CLKGEN1_di1_disp_clk_down. */
#define BS_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down (9U) /*!< Bit field size in bits for IPU_DI1_BS_CLKGEN1_di1_disp_clk_down. */

/*! @brief Read current value of the IPU_DI1_BS_CLKGEN1_di1_disp_clk_down field. */
#define BR_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down(x) (HW_IPU_DI1_BS_CLKGEN1(x).B.di1_disp_clk_down)

/*! @brief Format value for bitfield IPU_DI1_BS_CLKGEN1_di1_disp_clk_down. */
#define BF_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down) & BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down)

/*! @brief Set the di1_disp_clk_down field to a new value. */
#define BW_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down(x, v) (HW_IPU_DI1_BS_CLKGEN1_WR(x, (HW_IPU_DI1_BS_CLKGEN1_RD(x) & ~BM_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down) | BF_IPU_DI1_BS_CLKGEN1_di1_disp_clk_down(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_1 - DI1 Sync Wave Gen 1 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_1 - DI1 Sync Wave Gen 1 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_1
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_1_bitfields
    {
        uint32_t di1_offset_resolution_1 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_1 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_1 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_1 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_1_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_1 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_1_ADDR(x) ((uintptr_t)(x) + 0x4800CU)

#define HW_IPU_DI1_SW_GEN0_1(x)  (*(__IO hw_ipu_di1_sw_gen0_1_t *) HW_IPU_DI1_SW_GEN0_1_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_1_RD(x) (HW_IPU_DI1_SW_GEN0_1(x).U)
#define HW_IPU_DI1_SW_GEN0_1_WR(x, v) (HW_IPU_DI1_SW_GEN0_1(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_1_SET(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, HW_IPU_DI1_SW_GEN0_1_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_1_CLR(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, HW_IPU_DI1_SW_GEN0_1_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_1_TOG(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, HW_IPU_DI1_SW_GEN0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_1 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_1, field di1_offset_resolution_1[2:0] (RW)
 *
 * DI1 counter #1 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - NA
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_1_di1_offset_resolution_1. */
#define BM_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_1_di1_offset_resolution_1. */
#define BS_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_1_di1_offset_resolution_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_1_di1_offset_resolution_1 field. */
#define BR_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1(x) (HW_IPU_DI1_SW_GEN0_1(x).B.di1_offset_resolution_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_1_di1_offset_resolution_1. */
#define BF_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1) & BM_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1)

/*! @brief Set the di1_offset_resolution_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, (HW_IPU_DI1_SW_GEN0_1_RD(x) & ~BM_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1) | BF_IPU_DI1_SW_GEN0_1_di1_offset_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_1, field di1_offset_value_1[14:3] (RW)
 *
 * DI1 counter #1 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_1_di1_offset_value_1 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_1_di1_offset_value_1. */
#define BM_IPU_DI1_SW_GEN0_1_di1_offset_value_1 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_1_di1_offset_value_1. */
#define BS_IPU_DI1_SW_GEN0_1_di1_offset_value_1 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_1_di1_offset_value_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_1_di1_offset_value_1 field. */
#define BR_IPU_DI1_SW_GEN0_1_di1_offset_value_1(x) (HW_IPU_DI1_SW_GEN0_1(x).B.di1_offset_value_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_1_di1_offset_value_1. */
#define BF_IPU_DI1_SW_GEN0_1_di1_offset_value_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_1_di1_offset_value_1) & BM_IPU_DI1_SW_GEN0_1_di1_offset_value_1)

/*! @brief Set the di1_offset_value_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_1_di1_offset_value_1(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, (HW_IPU_DI1_SW_GEN0_1_RD(x) & ~BM_IPU_DI1_SW_GEN0_1_di1_offset_value_1) | BF_IPU_DI1_SW_GEN0_1_di1_offset_value_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_1, field di1_run_resolution_1[18:16] (RW)
 *
 * DI1 counter #1 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - NA
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_1_di1_run_resolution_1 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_1_di1_run_resolution_1. */
#define BM_IPU_DI1_SW_GEN0_1_di1_run_resolution_1 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_1_di1_run_resolution_1. */
#define BS_IPU_DI1_SW_GEN0_1_di1_run_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_1_di1_run_resolution_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_1_di1_run_resolution_1 field. */
#define BR_IPU_DI1_SW_GEN0_1_di1_run_resolution_1(x) (HW_IPU_DI1_SW_GEN0_1(x).B.di1_run_resolution_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_1_di1_run_resolution_1. */
#define BF_IPU_DI1_SW_GEN0_1_di1_run_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_1_di1_run_resolution_1) & BM_IPU_DI1_SW_GEN0_1_di1_run_resolution_1)

/*! @brief Set the di1_run_resolution_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_1_di1_run_resolution_1(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, (HW_IPU_DI1_SW_GEN0_1_RD(x) & ~BM_IPU_DI1_SW_GEN0_1_di1_run_resolution_1) | BF_IPU_DI1_SW_GEN0_1_di1_run_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_1, field di1_run_value_m1_1[30:19] (RW)
 *
 * DI1 counter #1 pre defined value This fields defines the counter #1 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_1 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_1_di1_run_value_m1_1. */
#define BM_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_1_di1_run_value_m1_1. */
#define BS_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_1_di1_run_value_m1_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_1_di1_run_value_m1_1 field. */
#define BR_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1(x) (HW_IPU_DI1_SW_GEN0_1(x).B.di1_run_value_m1_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_1_di1_run_value_m1_1. */
#define BF_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1) & BM_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1)

/*! @brief Set the di1_run_value_m1_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1(x, v) (HW_IPU_DI1_SW_GEN0_1_WR(x, (HW_IPU_DI1_SW_GEN0_1_RD(x) & ~BM_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1) | BF_IPU_DI1_SW_GEN0_1_di1_run_value_m1_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_2 - DI1 Sync Wave Gen 2 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_2 - DI1 Sync Wave Gen 2 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_2
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_2_bitfields
    {
        uint32_t di1_offset_resolution_2 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_2 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_2 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_2 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_2_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_2 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_2_ADDR(x) ((uintptr_t)(x) + 0x48010U)

#define HW_IPU_DI1_SW_GEN0_2(x)  (*(__IO hw_ipu_di1_sw_gen0_2_t *) HW_IPU_DI1_SW_GEN0_2_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_2_RD(x) (HW_IPU_DI1_SW_GEN0_2(x).U)
#define HW_IPU_DI1_SW_GEN0_2_WR(x, v) (HW_IPU_DI1_SW_GEN0_2(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_2_SET(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, HW_IPU_DI1_SW_GEN0_2_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_2_CLR(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, HW_IPU_DI1_SW_GEN0_2_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_2_TOG(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, HW_IPU_DI1_SW_GEN0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_2 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_2, field di1_offset_resolution_2[2:0] (RW)
 *
 * DI1 counter #2 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_2_di1_offset_resolution_2. */
#define BM_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_2_di1_offset_resolution_2. */
#define BS_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_2_di1_offset_resolution_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_2_di1_offset_resolution_2 field. */
#define BR_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2(x) (HW_IPU_DI1_SW_GEN0_2(x).B.di1_offset_resolution_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_2_di1_offset_resolution_2. */
#define BF_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2) & BM_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2)

/*! @brief Set the di1_offset_resolution_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, (HW_IPU_DI1_SW_GEN0_2_RD(x) & ~BM_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2) | BF_IPU_DI1_SW_GEN0_2_di1_offset_resolution_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_2, field di1_offset_value_2[14:3] (RW)
 *
 * DI1 counter #2 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_2_di1_offset_value_2 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_2_di1_offset_value_2. */
#define BM_IPU_DI1_SW_GEN0_2_di1_offset_value_2 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_2_di1_offset_value_2. */
#define BS_IPU_DI1_SW_GEN0_2_di1_offset_value_2 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_2_di1_offset_value_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_2_di1_offset_value_2 field. */
#define BR_IPU_DI1_SW_GEN0_2_di1_offset_value_2(x) (HW_IPU_DI1_SW_GEN0_2(x).B.di1_offset_value_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_2_di1_offset_value_2. */
#define BF_IPU_DI1_SW_GEN0_2_di1_offset_value_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_2_di1_offset_value_2) & BM_IPU_DI1_SW_GEN0_2_di1_offset_value_2)

/*! @brief Set the di1_offset_value_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_2_di1_offset_value_2(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, (HW_IPU_DI1_SW_GEN0_2_RD(x) & ~BM_IPU_DI1_SW_GEN0_2_di1_offset_value_2) | BF_IPU_DI1_SW_GEN0_2_di1_offset_value_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_2, field di1_run_resolution_2[18:16] (RW)
 *
 * DI1 counter #2 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - NA
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_2_di1_run_resolution_2 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_2_di1_run_resolution_2. */
#define BM_IPU_DI1_SW_GEN0_2_di1_run_resolution_2 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_2_di1_run_resolution_2. */
#define BS_IPU_DI1_SW_GEN0_2_di1_run_resolution_2 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_2_di1_run_resolution_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_2_di1_run_resolution_2 field. */
#define BR_IPU_DI1_SW_GEN0_2_di1_run_resolution_2(x) (HW_IPU_DI1_SW_GEN0_2(x).B.di1_run_resolution_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_2_di1_run_resolution_2. */
#define BF_IPU_DI1_SW_GEN0_2_di1_run_resolution_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_2_di1_run_resolution_2) & BM_IPU_DI1_SW_GEN0_2_di1_run_resolution_2)

/*! @brief Set the di1_run_resolution_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_2_di1_run_resolution_2(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, (HW_IPU_DI1_SW_GEN0_2_RD(x) & ~BM_IPU_DI1_SW_GEN0_2_di1_run_resolution_2) | BF_IPU_DI1_SW_GEN0_2_di1_run_resolution_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_2, field di1_run_value_m1_2[30:19] (RW)
 *
 * DI1 counter #2 pre defined value This fields defines the counter #2 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_2 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_2_di1_run_value_m1_2. */
#define BM_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_2_di1_run_value_m1_2. */
#define BS_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_2_di1_run_value_m1_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_2_di1_run_value_m1_2 field. */
#define BR_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2(x) (HW_IPU_DI1_SW_GEN0_2(x).B.di1_run_value_m1_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_2_di1_run_value_m1_2. */
#define BF_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2) & BM_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2)

/*! @brief Set the di1_run_value_m1_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2(x, v) (HW_IPU_DI1_SW_GEN0_2_WR(x, (HW_IPU_DI1_SW_GEN0_2_RD(x) & ~BM_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2) | BF_IPU_DI1_SW_GEN0_2_di1_run_value_m1_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_3 - DI1 Sync Wave Gen 3 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_3 - DI1 Sync Wave Gen 3 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_3
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_3_bitfields
    {
        uint32_t di1_offset_resolution_3 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_3 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_3 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_3 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_3_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_3 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_3_ADDR(x) ((uintptr_t)(x) + 0x48014U)

#define HW_IPU_DI1_SW_GEN0_3(x)  (*(__IO hw_ipu_di1_sw_gen0_3_t *) HW_IPU_DI1_SW_GEN0_3_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_3_RD(x) (HW_IPU_DI1_SW_GEN0_3(x).U)
#define HW_IPU_DI1_SW_GEN0_3_WR(x, v) (HW_IPU_DI1_SW_GEN0_3(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_3_SET(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, HW_IPU_DI1_SW_GEN0_3_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_3_CLR(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, HW_IPU_DI1_SW_GEN0_3_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_3_TOG(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, HW_IPU_DI1_SW_GEN0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_3 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_3, field di1_offset_resolution_3[2:0] (RW)
 *
 * DI1 counter #3 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_3_di1_offset_resolution_3. */
#define BM_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_3_di1_offset_resolution_3. */
#define BS_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_3_di1_offset_resolution_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_3_di1_offset_resolution_3 field. */
#define BR_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3(x) (HW_IPU_DI1_SW_GEN0_3(x).B.di1_offset_resolution_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_3_di1_offset_resolution_3. */
#define BF_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3) & BM_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3)

/*! @brief Set the di1_offset_resolution_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, (HW_IPU_DI1_SW_GEN0_3_RD(x) & ~BM_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3) | BF_IPU_DI1_SW_GEN0_3_di1_offset_resolution_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_3, field di1_offset_value_3[14:3] (RW)
 *
 * DI1 counter #3 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_3_di1_offset_value_3 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_3_di1_offset_value_3. */
#define BM_IPU_DI1_SW_GEN0_3_di1_offset_value_3 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_3_di1_offset_value_3. */
#define BS_IPU_DI1_SW_GEN0_3_di1_offset_value_3 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_3_di1_offset_value_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_3_di1_offset_value_3 field. */
#define BR_IPU_DI1_SW_GEN0_3_di1_offset_value_3(x) (HW_IPU_DI1_SW_GEN0_3(x).B.di1_offset_value_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_3_di1_offset_value_3. */
#define BF_IPU_DI1_SW_GEN0_3_di1_offset_value_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_3_di1_offset_value_3) & BM_IPU_DI1_SW_GEN0_3_di1_offset_value_3)

/*! @brief Set the di1_offset_value_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_3_di1_offset_value_3(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, (HW_IPU_DI1_SW_GEN0_3_RD(x) & ~BM_IPU_DI1_SW_GEN0_3_di1_offset_value_3) | BF_IPU_DI1_SW_GEN0_3_di1_offset_value_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_3, field di1_run_resolution_3[18:16] (RW)
 *
 * DI1 counter #3 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - NA
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_3_di1_run_resolution_3 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_3_di1_run_resolution_3. */
#define BM_IPU_DI1_SW_GEN0_3_di1_run_resolution_3 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_3_di1_run_resolution_3. */
#define BS_IPU_DI1_SW_GEN0_3_di1_run_resolution_3 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_3_di1_run_resolution_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_3_di1_run_resolution_3 field. */
#define BR_IPU_DI1_SW_GEN0_3_di1_run_resolution_3(x) (HW_IPU_DI1_SW_GEN0_3(x).B.di1_run_resolution_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_3_di1_run_resolution_3. */
#define BF_IPU_DI1_SW_GEN0_3_di1_run_resolution_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_3_di1_run_resolution_3) & BM_IPU_DI1_SW_GEN0_3_di1_run_resolution_3)

/*! @brief Set the di1_run_resolution_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_3_di1_run_resolution_3(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, (HW_IPU_DI1_SW_GEN0_3_RD(x) & ~BM_IPU_DI1_SW_GEN0_3_di1_run_resolution_3) | BF_IPU_DI1_SW_GEN0_3_di1_run_resolution_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_3, field di1_run_value_m1_3[30:19] (RW)
 *
 * DI1 counter #3 pre defined value This fields defines the counter #3 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_3 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_3_di1_run_value_m1_3. */
#define BM_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_3_di1_run_value_m1_3. */
#define BS_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_3_di1_run_value_m1_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_3_di1_run_value_m1_3 field. */
#define BR_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3(x) (HW_IPU_DI1_SW_GEN0_3(x).B.di1_run_value_m1_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_3_di1_run_value_m1_3. */
#define BF_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3) & BM_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3)

/*! @brief Set the di1_run_value_m1_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3(x, v) (HW_IPU_DI1_SW_GEN0_3_WR(x, (HW_IPU_DI1_SW_GEN0_3_RD(x) & ~BM_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3) | BF_IPU_DI1_SW_GEN0_3_di1_run_value_m1_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_4 - DI1 Sync Wave Gen 4 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_4 - DI1 Sync Wave Gen 4 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_4
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_4_bitfields
    {
        uint32_t di1_offset_resolution_4 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_4 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_4 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_4 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_4_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_4 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_4_ADDR(x) ((uintptr_t)(x) + 0x48018U)

#define HW_IPU_DI1_SW_GEN0_4(x)  (*(__IO hw_ipu_di1_sw_gen0_4_t *) HW_IPU_DI1_SW_GEN0_4_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_4_RD(x) (HW_IPU_DI1_SW_GEN0_4(x).U)
#define HW_IPU_DI1_SW_GEN0_4_WR(x, v) (HW_IPU_DI1_SW_GEN0_4(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_4_SET(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, HW_IPU_DI1_SW_GEN0_4_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_4_CLR(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, HW_IPU_DI1_SW_GEN0_4_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_4_TOG(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, HW_IPU_DI1_SW_GEN0_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_4 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_4, field di1_offset_resolution_4[2:0] (RW)
 *
 * DI1 counter #4 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_4_di1_offset_resolution_4. */
#define BM_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_4_di1_offset_resolution_4. */
#define BS_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_4_di1_offset_resolution_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_4_di1_offset_resolution_4 field. */
#define BR_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4(x) (HW_IPU_DI1_SW_GEN0_4(x).B.di1_offset_resolution_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_4_di1_offset_resolution_4. */
#define BF_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4) & BM_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4)

/*! @brief Set the di1_offset_resolution_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, (HW_IPU_DI1_SW_GEN0_4_RD(x) & ~BM_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4) | BF_IPU_DI1_SW_GEN0_4_di1_offset_resolution_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_4, field di1_offset_value_4[14:3] (RW)
 *
 * DI1 counter #4 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_4_di1_offset_value_4 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_4_di1_offset_value_4. */
#define BM_IPU_DI1_SW_GEN0_4_di1_offset_value_4 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_4_di1_offset_value_4. */
#define BS_IPU_DI1_SW_GEN0_4_di1_offset_value_4 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_4_di1_offset_value_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_4_di1_offset_value_4 field. */
#define BR_IPU_DI1_SW_GEN0_4_di1_offset_value_4(x) (HW_IPU_DI1_SW_GEN0_4(x).B.di1_offset_value_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_4_di1_offset_value_4. */
#define BF_IPU_DI1_SW_GEN0_4_di1_offset_value_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_4_di1_offset_value_4) & BM_IPU_DI1_SW_GEN0_4_di1_offset_value_4)

/*! @brief Set the di1_offset_value_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_4_di1_offset_value_4(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, (HW_IPU_DI1_SW_GEN0_4_RD(x) & ~BM_IPU_DI1_SW_GEN0_4_di1_offset_value_4) | BF_IPU_DI1_SW_GEN0_4_di1_offset_value_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_4, field di1_run_resolution_4[18:16] (RW)
 *
 * DI1 counter #4 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_4_di1_run_resolution_4 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_4_di1_run_resolution_4. */
#define BM_IPU_DI1_SW_GEN0_4_di1_run_resolution_4 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_4_di1_run_resolution_4. */
#define BS_IPU_DI1_SW_GEN0_4_di1_run_resolution_4 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_4_di1_run_resolution_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_4_di1_run_resolution_4 field. */
#define BR_IPU_DI1_SW_GEN0_4_di1_run_resolution_4(x) (HW_IPU_DI1_SW_GEN0_4(x).B.di1_run_resolution_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_4_di1_run_resolution_4. */
#define BF_IPU_DI1_SW_GEN0_4_di1_run_resolution_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_4_di1_run_resolution_4) & BM_IPU_DI1_SW_GEN0_4_di1_run_resolution_4)

/*! @brief Set the di1_run_resolution_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_4_di1_run_resolution_4(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, (HW_IPU_DI1_SW_GEN0_4_RD(x) & ~BM_IPU_DI1_SW_GEN0_4_di1_run_resolution_4) | BF_IPU_DI1_SW_GEN0_4_di1_run_resolution_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_4, field di1_run_value_m1_4[30:19] (RW)
 *
 * DI1 counter #4 pre defined value This fields defines the counter #4 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_4 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_4_di1_run_value_m1_4. */
#define BM_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_4_di1_run_value_m1_4. */
#define BS_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_4_di1_run_value_m1_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_4_di1_run_value_m1_4 field. */
#define BR_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4(x) (HW_IPU_DI1_SW_GEN0_4(x).B.di1_run_value_m1_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_4_di1_run_value_m1_4. */
#define BF_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4) & BM_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4)

/*! @brief Set the di1_run_value_m1_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4(x, v) (HW_IPU_DI1_SW_GEN0_4_WR(x, (HW_IPU_DI1_SW_GEN0_4_RD(x) & ~BM_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4) | BF_IPU_DI1_SW_GEN0_4_di1_run_value_m1_4(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_5 - DI1 Sync Wave Gen 5 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_5 - DI1 Sync Wave Gen 5 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_5
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_5_bitfields
    {
        uint32_t di1_offset_resolution_5 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_5 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_5 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_5 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_5_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_5 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_5_ADDR(x) ((uintptr_t)(x) + 0x4801CU)

#define HW_IPU_DI1_SW_GEN0_5(x)  (*(__IO hw_ipu_di1_sw_gen0_5_t *) HW_IPU_DI1_SW_GEN0_5_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_5_RD(x) (HW_IPU_DI1_SW_GEN0_5(x).U)
#define HW_IPU_DI1_SW_GEN0_5_WR(x, v) (HW_IPU_DI1_SW_GEN0_5(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_5_SET(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, HW_IPU_DI1_SW_GEN0_5_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_5_CLR(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, HW_IPU_DI1_SW_GEN0_5_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_5_TOG(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, HW_IPU_DI1_SW_GEN0_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_5 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_5, field di1_offset_resolution_5[2:0] (RW)
 *
 * DI1 counter #5 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - -The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_5_di1_offset_resolution_5. */
#define BM_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_5_di1_offset_resolution_5. */
#define BS_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_5_di1_offset_resolution_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_5_di1_offset_resolution_5 field. */
#define BR_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5(x) (HW_IPU_DI1_SW_GEN0_5(x).B.di1_offset_resolution_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_5_di1_offset_resolution_5. */
#define BF_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5) & BM_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5)

/*! @brief Set the di1_offset_resolution_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, (HW_IPU_DI1_SW_GEN0_5_RD(x) & ~BM_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5) | BF_IPU_DI1_SW_GEN0_5_di1_offset_resolution_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_5, field di1_offset_value_5[14:3] (RW)
 *
 * DI1 counter #5 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_5_di1_offset_value_5 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_5_di1_offset_value_5. */
#define BM_IPU_DI1_SW_GEN0_5_di1_offset_value_5 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_5_di1_offset_value_5. */
#define BS_IPU_DI1_SW_GEN0_5_di1_offset_value_5 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_5_di1_offset_value_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_5_di1_offset_value_5 field. */
#define BR_IPU_DI1_SW_GEN0_5_di1_offset_value_5(x) (HW_IPU_DI1_SW_GEN0_5(x).B.di1_offset_value_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_5_di1_offset_value_5. */
#define BF_IPU_DI1_SW_GEN0_5_di1_offset_value_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_5_di1_offset_value_5) & BM_IPU_DI1_SW_GEN0_5_di1_offset_value_5)

/*! @brief Set the di1_offset_value_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_5_di1_offset_value_5(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, (HW_IPU_DI1_SW_GEN0_5_RD(x) & ~BM_IPU_DI1_SW_GEN0_5_di1_offset_value_5) | BF_IPU_DI1_SW_GEN0_5_di1_offset_value_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_5, field di1_run_resolution_5[18:16] (RW)
 *
 * DI1 counter #5 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_5_di1_run_resolution_5 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_5_di1_run_resolution_5. */
#define BM_IPU_DI1_SW_GEN0_5_di1_run_resolution_5 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_5_di1_run_resolution_5. */
#define BS_IPU_DI1_SW_GEN0_5_di1_run_resolution_5 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_5_di1_run_resolution_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_5_di1_run_resolution_5 field. */
#define BR_IPU_DI1_SW_GEN0_5_di1_run_resolution_5(x) (HW_IPU_DI1_SW_GEN0_5(x).B.di1_run_resolution_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_5_di1_run_resolution_5. */
#define BF_IPU_DI1_SW_GEN0_5_di1_run_resolution_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_5_di1_run_resolution_5) & BM_IPU_DI1_SW_GEN0_5_di1_run_resolution_5)

/*! @brief Set the di1_run_resolution_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_5_di1_run_resolution_5(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, (HW_IPU_DI1_SW_GEN0_5_RD(x) & ~BM_IPU_DI1_SW_GEN0_5_di1_run_resolution_5) | BF_IPU_DI1_SW_GEN0_5_di1_run_resolution_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_5, field di1_run_value_m1_5[30:19] (RW)
 *
 * DI1 counter #5 pre defined value This fields defines the counter #5 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_5 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_5_di1_run_value_m1_5. */
#define BM_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_5_di1_run_value_m1_5. */
#define BS_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_5_di1_run_value_m1_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_5_di1_run_value_m1_5 field. */
#define BR_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5(x) (HW_IPU_DI1_SW_GEN0_5(x).B.di1_run_value_m1_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_5_di1_run_value_m1_5. */
#define BF_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5) & BM_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5)

/*! @brief Set the di1_run_value_m1_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5(x, v) (HW_IPU_DI1_SW_GEN0_5_WR(x, (HW_IPU_DI1_SW_GEN0_5_RD(x) & ~BM_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5) | BF_IPU_DI1_SW_GEN0_5_di1_run_value_m1_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_6 - DI1 Sync Wave Gen 6 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_6 - DI1 Sync Wave Gen 6 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_6
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_6_bitfields
    {
        uint32_t di1_offset_resolution_6 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_6 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_6 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_6 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_6_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_6 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_6_ADDR(x) ((uintptr_t)(x) + 0x48020U)

#define HW_IPU_DI1_SW_GEN0_6(x)  (*(__IO hw_ipu_di1_sw_gen0_6_t *) HW_IPU_DI1_SW_GEN0_6_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_6_RD(x) (HW_IPU_DI1_SW_GEN0_6(x).U)
#define HW_IPU_DI1_SW_GEN0_6_WR(x, v) (HW_IPU_DI1_SW_GEN0_6(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_6_SET(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, HW_IPU_DI1_SW_GEN0_6_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_6_CLR(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, HW_IPU_DI1_SW_GEN0_6_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_6_TOG(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, HW_IPU_DI1_SW_GEN0_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_6 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_6, field di1_offset_resolution_6[2:0] (RW)
 *
 * DI1 counter #6 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_6_di1_offset_resolution_6. */
#define BM_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_6_di1_offset_resolution_6. */
#define BS_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_6_di1_offset_resolution_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_6_di1_offset_resolution_6 field. */
#define BR_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6(x) (HW_IPU_DI1_SW_GEN0_6(x).B.di1_offset_resolution_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_6_di1_offset_resolution_6. */
#define BF_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6) & BM_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6)

/*! @brief Set the di1_offset_resolution_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, (HW_IPU_DI1_SW_GEN0_6_RD(x) & ~BM_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6) | BF_IPU_DI1_SW_GEN0_6_di1_offset_resolution_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_6, field di1_offset_value_6[14:3] (RW)
 *
 * DI1 counter #6 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_6_di1_offset_value_6 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_6_di1_offset_value_6. */
#define BM_IPU_DI1_SW_GEN0_6_di1_offset_value_6 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_6_di1_offset_value_6. */
#define BS_IPU_DI1_SW_GEN0_6_di1_offset_value_6 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_6_di1_offset_value_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_6_di1_offset_value_6 field. */
#define BR_IPU_DI1_SW_GEN0_6_di1_offset_value_6(x) (HW_IPU_DI1_SW_GEN0_6(x).B.di1_offset_value_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_6_di1_offset_value_6. */
#define BF_IPU_DI1_SW_GEN0_6_di1_offset_value_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_6_di1_offset_value_6) & BM_IPU_DI1_SW_GEN0_6_di1_offset_value_6)

/*! @brief Set the di1_offset_value_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_6_di1_offset_value_6(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, (HW_IPU_DI1_SW_GEN0_6_RD(x) & ~BM_IPU_DI1_SW_GEN0_6_di1_offset_value_6) | BF_IPU_DI1_SW_GEN0_6_di1_offset_value_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_6, field di1_run_resolution_6[18:16] (RW)
 *
 * DI1 counter #6 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_6_di1_run_resolution_6 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_6_di1_run_resolution_6. */
#define BM_IPU_DI1_SW_GEN0_6_di1_run_resolution_6 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_6_di1_run_resolution_6. */
#define BS_IPU_DI1_SW_GEN0_6_di1_run_resolution_6 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_6_di1_run_resolution_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_6_di1_run_resolution_6 field. */
#define BR_IPU_DI1_SW_GEN0_6_di1_run_resolution_6(x) (HW_IPU_DI1_SW_GEN0_6(x).B.di1_run_resolution_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_6_di1_run_resolution_6. */
#define BF_IPU_DI1_SW_GEN0_6_di1_run_resolution_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_6_di1_run_resolution_6) & BM_IPU_DI1_SW_GEN0_6_di1_run_resolution_6)

/*! @brief Set the di1_run_resolution_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_6_di1_run_resolution_6(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, (HW_IPU_DI1_SW_GEN0_6_RD(x) & ~BM_IPU_DI1_SW_GEN0_6_di1_run_resolution_6) | BF_IPU_DI1_SW_GEN0_6_di1_run_resolution_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_6, field di1_run_value_m1_6[30:19] (RW)
 *
 * DI1 counter #6 pre defined value This fields defines the counter #6 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_6 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_6_di1_run_value_m1_6. */
#define BM_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_6_di1_run_value_m1_6. */
#define BS_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_6_di1_run_value_m1_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_6_di1_run_value_m1_6 field. */
#define BR_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6(x) (HW_IPU_DI1_SW_GEN0_6(x).B.di1_run_value_m1_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_6_di1_run_value_m1_6. */
#define BF_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6) & BM_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6)

/*! @brief Set the di1_run_value_m1_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6(x, v) (HW_IPU_DI1_SW_GEN0_6_WR(x, (HW_IPU_DI1_SW_GEN0_6_RD(x) & ~BM_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6) | BF_IPU_DI1_SW_GEN0_6_di1_run_value_m1_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_7 - DI1 Sync Wave Gen 7 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_7 - DI1 Sync Wave Gen 7 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_7
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_7_bitfields
    {
        uint32_t di1_offset_resolution_1 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_7 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_7 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_7 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_7_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_7 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_7_ADDR(x) ((uintptr_t)(x) + 0x48024U)

#define HW_IPU_DI1_SW_GEN0_7(x)  (*(__IO hw_ipu_di1_sw_gen0_7_t *) HW_IPU_DI1_SW_GEN0_7_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_7_RD(x) (HW_IPU_DI1_SW_GEN0_7(x).U)
#define HW_IPU_DI1_SW_GEN0_7_WR(x, v) (HW_IPU_DI1_SW_GEN0_7(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_7_SET(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, HW_IPU_DI1_SW_GEN0_7_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_7_CLR(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, HW_IPU_DI1_SW_GEN0_7_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_7_TOG(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, HW_IPU_DI1_SW_GEN0_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_7 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_7, field di1_offset_resolution_1[2:0] (RW)
 *
 * DI1 counter #7 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_7_di1_offset_resolution_1. */
#define BM_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_7_di1_offset_resolution_1. */
#define BS_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_7_di1_offset_resolution_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_7_di1_offset_resolution_1 field. */
#define BR_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1(x) (HW_IPU_DI1_SW_GEN0_7(x).B.di1_offset_resolution_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_7_di1_offset_resolution_1. */
#define BF_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1) & BM_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1)

/*! @brief Set the di1_offset_resolution_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, (HW_IPU_DI1_SW_GEN0_7_RD(x) & ~BM_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1) | BF_IPU_DI1_SW_GEN0_7_di1_offset_resolution_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_7, field di1_offset_value_7[14:3] (RW)
 *
 * DI1 counter #7 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_7_di1_offset_value_7 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_7_di1_offset_value_7. */
#define BM_IPU_DI1_SW_GEN0_7_di1_offset_value_7 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_7_di1_offset_value_7. */
#define BS_IPU_DI1_SW_GEN0_7_di1_offset_value_7 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_7_di1_offset_value_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_7_di1_offset_value_7 field. */
#define BR_IPU_DI1_SW_GEN0_7_di1_offset_value_7(x) (HW_IPU_DI1_SW_GEN0_7(x).B.di1_offset_value_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_7_di1_offset_value_7. */
#define BF_IPU_DI1_SW_GEN0_7_di1_offset_value_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_7_di1_offset_value_7) & BM_IPU_DI1_SW_GEN0_7_di1_offset_value_7)

/*! @brief Set the di1_offset_value_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_7_di1_offset_value_7(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, (HW_IPU_DI1_SW_GEN0_7_RD(x) & ~BM_IPU_DI1_SW_GEN0_7_di1_offset_value_7) | BF_IPU_DI1_SW_GEN0_7_di1_offset_value_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_7, field di1_run_resolution_7[18:16] (RW)
 *
 * DI1 counter #1 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_7_di1_run_resolution_7 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_7_di1_run_resolution_7. */
#define BM_IPU_DI1_SW_GEN0_7_di1_run_resolution_7 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_7_di1_run_resolution_7. */
#define BS_IPU_DI1_SW_GEN0_7_di1_run_resolution_7 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_7_di1_run_resolution_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_7_di1_run_resolution_7 field. */
#define BR_IPU_DI1_SW_GEN0_7_di1_run_resolution_7(x) (HW_IPU_DI1_SW_GEN0_7(x).B.di1_run_resolution_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_7_di1_run_resolution_7. */
#define BF_IPU_DI1_SW_GEN0_7_di1_run_resolution_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_7_di1_run_resolution_7) & BM_IPU_DI1_SW_GEN0_7_di1_run_resolution_7)

/*! @brief Set the di1_run_resolution_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_7_di1_run_resolution_7(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, (HW_IPU_DI1_SW_GEN0_7_RD(x) & ~BM_IPU_DI1_SW_GEN0_7_di1_run_resolution_7) | BF_IPU_DI1_SW_GEN0_7_di1_run_resolution_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_7, field di1_run_value_m1_7[30:19] (RW)
 *
 * DI1 counter #7 pre defined value This fields defines the counter #7 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_7 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_7_di1_run_value_m1_7. */
#define BM_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_7_di1_run_value_m1_7. */
#define BS_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_7_di1_run_value_m1_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_7_di1_run_value_m1_7 field. */
#define BR_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7(x) (HW_IPU_DI1_SW_GEN0_7(x).B.di1_run_value_m1_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_7_di1_run_value_m1_7. */
#define BF_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7) & BM_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7)

/*! @brief Set the di1_run_value_m1_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7(x, v) (HW_IPU_DI1_SW_GEN0_7_WR(x, (HW_IPU_DI1_SW_GEN0_7_RD(x) & ~BM_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7) | BF_IPU_DI1_SW_GEN0_7_di1_run_value_m1_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_8 - DI1 Sync Wave Gen 8 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_8 - DI1 Sync Wave Gen 8 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_8
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_8_bitfields
    {
        uint32_t di1_offset_resolution_8 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_8 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_8 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_8 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_8_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_8 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_8_ADDR(x) ((uintptr_t)(x) + 0x48028U)

#define HW_IPU_DI1_SW_GEN0_8(x)  (*(__IO hw_ipu_di1_sw_gen0_8_t *) HW_IPU_DI1_SW_GEN0_8_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_8_RD(x) (HW_IPU_DI1_SW_GEN0_8(x).U)
#define HW_IPU_DI1_SW_GEN0_8_WR(x, v) (HW_IPU_DI1_SW_GEN0_8(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_8_SET(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, HW_IPU_DI1_SW_GEN0_8_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_8_CLR(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, HW_IPU_DI1_SW_GEN0_8_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_8_TOG(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, HW_IPU_DI1_SW_GEN0_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_8 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_8, field di1_offset_resolution_8[2:0] (RW)
 *
 * DI1 counter #8 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_8_di1_offset_resolution_8. */
#define BM_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_8_di1_offset_resolution_8. */
#define BS_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_8_di1_offset_resolution_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_8_di1_offset_resolution_8 field. */
#define BR_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8(x) (HW_IPU_DI1_SW_GEN0_8(x).B.di1_offset_resolution_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_8_di1_offset_resolution_8. */
#define BF_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8) & BM_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8)

/*! @brief Set the di1_offset_resolution_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, (HW_IPU_DI1_SW_GEN0_8_RD(x) & ~BM_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8) | BF_IPU_DI1_SW_GEN0_8_di1_offset_resolution_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_8, field di1_offset_value_8[14:3] (RW)
 *
 * DI1 counter #8 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_8_di1_offset_value_8 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_8_di1_offset_value_8. */
#define BM_IPU_DI1_SW_GEN0_8_di1_offset_value_8 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_8_di1_offset_value_8. */
#define BS_IPU_DI1_SW_GEN0_8_di1_offset_value_8 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_8_di1_offset_value_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_8_di1_offset_value_8 field. */
#define BR_IPU_DI1_SW_GEN0_8_di1_offset_value_8(x) (HW_IPU_DI1_SW_GEN0_8(x).B.di1_offset_value_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_8_di1_offset_value_8. */
#define BF_IPU_DI1_SW_GEN0_8_di1_offset_value_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_8_di1_offset_value_8) & BM_IPU_DI1_SW_GEN0_8_di1_offset_value_8)

/*! @brief Set the di1_offset_value_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_8_di1_offset_value_8(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, (HW_IPU_DI1_SW_GEN0_8_RD(x) & ~BM_IPU_DI1_SW_GEN0_8_di1_offset_value_8) | BF_IPU_DI1_SW_GEN0_8_di1_offset_value_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_8, field di1_run_resolution_8[18:16] (RW)
 *
 * DI1 counter #8 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_8_di1_run_resolution_8 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_8_di1_run_resolution_8. */
#define BM_IPU_DI1_SW_GEN0_8_di1_run_resolution_8 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_8_di1_run_resolution_8. */
#define BS_IPU_DI1_SW_GEN0_8_di1_run_resolution_8 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_8_di1_run_resolution_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_8_di1_run_resolution_8 field. */
#define BR_IPU_DI1_SW_GEN0_8_di1_run_resolution_8(x) (HW_IPU_DI1_SW_GEN0_8(x).B.di1_run_resolution_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_8_di1_run_resolution_8. */
#define BF_IPU_DI1_SW_GEN0_8_di1_run_resolution_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_8_di1_run_resolution_8) & BM_IPU_DI1_SW_GEN0_8_di1_run_resolution_8)

/*! @brief Set the di1_run_resolution_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_8_di1_run_resolution_8(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, (HW_IPU_DI1_SW_GEN0_8_RD(x) & ~BM_IPU_DI1_SW_GEN0_8_di1_run_resolution_8) | BF_IPU_DI1_SW_GEN0_8_di1_run_resolution_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_8, field di1_run_value_m1_8[30:19] (RW)
 *
 * DI1 counter #8 pre defined value This fields defines the counter #8 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_8 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_8_di1_run_value_m1_8. */
#define BM_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_8_di1_run_value_m1_8. */
#define BS_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_8_di1_run_value_m1_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_8_di1_run_value_m1_8 field. */
#define BR_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8(x) (HW_IPU_DI1_SW_GEN0_8(x).B.di1_run_value_m1_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_8_di1_run_value_m1_8. */
#define BF_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8) & BM_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8)

/*! @brief Set the di1_run_value_m1_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8(x, v) (HW_IPU_DI1_SW_GEN0_8_WR(x, (HW_IPU_DI1_SW_GEN0_8_RD(x) & ~BM_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8) | BF_IPU_DI1_SW_GEN0_8_di1_run_value_m1_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN0_9 - DI1Sync Wave Gen 9 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN0_9 - DI1Sync Wave Gen 9 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen0_9
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen0_9_bitfields
    {
        uint32_t di1_offset_resolution_9 : 3; /*!< [2:0]  */
        uint32_t di1_offset_value_9 : 12; /*!< [14:3]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_run_resolution_9 : 3; /*!< [18:16]  */
        uint32_t di1_run_value_m1_9 : 12; /*!< [30:19]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen0_9_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN0_9 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN0_9_ADDR(x) ((uintptr_t)(x) + 0x4802CU)

#define HW_IPU_DI1_SW_GEN0_9(x)  (*(__IO hw_ipu_di1_sw_gen0_9_t *) HW_IPU_DI1_SW_GEN0_9_ADDR(x))
#define HW_IPU_DI1_SW_GEN0_9_RD(x) (HW_IPU_DI1_SW_GEN0_9(x).U)
#define HW_IPU_DI1_SW_GEN0_9_WR(x, v) (HW_IPU_DI1_SW_GEN0_9(x).U = (v))
#define HW_IPU_DI1_SW_GEN0_9_SET(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, HW_IPU_DI1_SW_GEN0_9_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN0_9_CLR(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, HW_IPU_DI1_SW_GEN0_9_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN0_9_TOG(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, HW_IPU_DI1_SW_GEN0_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN0_9 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN0_9, field di1_offset_resolution_9[2:0] (RW)
 *
 * DI1 counter #9 offset Resolution This field defines the trigger causing the
 * offset counter to increment
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9 (0U) /*!< Bit position for IPU_DI1_SW_GEN0_9_di1_offset_resolution_9. */
#define BM_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9 (0x00000007U) /*!< Bit mask for IPU_DI1_SW_GEN0_9_di1_offset_resolution_9. */
#define BS_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_9_di1_offset_resolution_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_9_di1_offset_resolution_9 field. */
#define BR_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9(x) (HW_IPU_DI1_SW_GEN0_9(x).B.di1_offset_resolution_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_9_di1_offset_resolution_9. */
#define BF_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9) & BM_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9)

/*! @brief Set the di1_offset_resolution_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, (HW_IPU_DI1_SW_GEN0_9_RD(x) & ~BM_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9) | BF_IPU_DI1_SW_GEN0_9_di1_offset_resolution_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_9, field di1_offset_value_9[14:3] (RW)
 *
 * DI1 counter #9 offset value The counter can start counting after a pre
 * defined delay This field defines the amount of cycles that the counter will be
 * delayed by
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_9_di1_offset_value_9 (3U) /*!< Bit position for IPU_DI1_SW_GEN0_9_di1_offset_value_9. */
#define BM_IPU_DI1_SW_GEN0_9_di1_offset_value_9 (0x00007FF8U) /*!< Bit mask for IPU_DI1_SW_GEN0_9_di1_offset_value_9. */
#define BS_IPU_DI1_SW_GEN0_9_di1_offset_value_9 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_9_di1_offset_value_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_9_di1_offset_value_9 field. */
#define BR_IPU_DI1_SW_GEN0_9_di1_offset_value_9(x) (HW_IPU_DI1_SW_GEN0_9(x).B.di1_offset_value_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_9_di1_offset_value_9. */
#define BF_IPU_DI1_SW_GEN0_9_di1_offset_value_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_9_di1_offset_value_9) & BM_IPU_DI1_SW_GEN0_9_di1_offset_value_9)

/*! @brief Set the di1_offset_value_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_9_di1_offset_value_9(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, (HW_IPU_DI1_SW_GEN0_9_RD(x) & ~BM_IPU_DI1_SW_GEN0_9_di1_offset_value_9) | BF_IPU_DI1_SW_GEN0_9_di1_offset_value_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_9, field di1_run_resolution_9[18:16] (RW)
 *
 * DI1 counter #9 Run Resolution This field defines the trigger causing the
 * counter to increment.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_9_di1_run_resolution_9 (16U) /*!< Bit position for IPU_DI1_SW_GEN0_9_di1_run_resolution_9. */
#define BM_IPU_DI1_SW_GEN0_9_di1_run_resolution_9 (0x00070000U) /*!< Bit mask for IPU_DI1_SW_GEN0_9_di1_run_resolution_9. */
#define BS_IPU_DI1_SW_GEN0_9_di1_run_resolution_9 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_9_di1_run_resolution_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_9_di1_run_resolution_9 field. */
#define BR_IPU_DI1_SW_GEN0_9_di1_run_resolution_9(x) (HW_IPU_DI1_SW_GEN0_9(x).B.di1_run_resolution_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_9_di1_run_resolution_9. */
#define BF_IPU_DI1_SW_GEN0_9_di1_run_resolution_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_9_di1_run_resolution_9) & BM_IPU_DI1_SW_GEN0_9_di1_run_resolution_9)

/*! @brief Set the di1_run_resolution_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_9_di1_run_resolution_9(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, (HW_IPU_DI1_SW_GEN0_9_RD(x) & ~BM_IPU_DI1_SW_GEN0_9_di1_run_resolution_9) | BF_IPU_DI1_SW_GEN0_9_di1_run_resolution_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN0_9, field di1_run_value_m1_9[30:19] (RW)
 *
 * DI1 counter #9 pre defined value This fields defines the counter #9 pre
 * defines value. When the counter is auto reload mode (di1_cnt_auto_reload_9 bit is
 * set), the counter automatically restarts. otherwise the counter restarts for
 * the amount of time defined on the corresponding di1_step_repeat field.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9 (19U) /*!< Bit position for IPU_DI1_SW_GEN0_9_di1_run_value_m1_9. */
#define BM_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9 (0x7FF80000U) /*!< Bit mask for IPU_DI1_SW_GEN0_9_di1_run_value_m1_9. */
#define BS_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9 (12U) /*!< Bit field size in bits for IPU_DI1_SW_GEN0_9_di1_run_value_m1_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN0_9_di1_run_value_m1_9 field. */
#define BR_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9(x) (HW_IPU_DI1_SW_GEN0_9(x).B.di1_run_value_m1_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN0_9_di1_run_value_m1_9. */
#define BF_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9) & BM_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9)

/*! @brief Set the di1_run_value_m1_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9(x, v) (HW_IPU_DI1_SW_GEN0_9_WR(x, (HW_IPU_DI1_SW_GEN0_9_RD(x) & ~BM_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9) | BF_IPU_DI1_SW_GEN0_9_di1_run_value_m1_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_1 - DI1 Sync Wave Gen 1 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_1 - DI1 Sync Wave Gen 1 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_1
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_1_bitfields
    {
        uint32_t di1_cnt_up_1 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_1 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_1 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_1 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_1 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_1 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_1 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_1_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_1 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_1_ADDR(x) ((uintptr_t)(x) + 0x48030U)

#define HW_IPU_DI1_SW_GEN1_1(x)  (*(__IO hw_ipu_di1_sw_gen1_1_t *) HW_IPU_DI1_SW_GEN1_1_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_1_RD(x) (HW_IPU_DI1_SW_GEN1_1(x).U)
#define HW_IPU_DI1_SW_GEN1_1_WR(x, v) (HW_IPU_DI1_SW_GEN1_1(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_1_SET(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, HW_IPU_DI1_SW_GEN1_1_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_1_CLR(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, HW_IPU_DI1_SW_GEN1_1_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_1_TOG(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, HW_IPU_DI1_SW_GEN1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_1 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_up_1[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_up_1 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_up_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_up_1 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_up_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_up_1 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_up_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_up_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_up_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_up_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_up_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_up_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_up_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_up_1)

/*! @brief Set the di1_cnt_up_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_up_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_up_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_up_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_polarity_clr_sel_1[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_polarity_clr_sel_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1)

/*! @brief Set the di1_cnt_polarity_clr_sel_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_clr_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_polarity_trigger_sel_1[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_polarity_trigger_sel_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1)

/*! @brief Set the di1_cnt_polarity_trigger_sel_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_trigger_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_down_1[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_down_1 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_down_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_down_1 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_down_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_down_1 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_down_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_down_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_down_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_down_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_down_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_down_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_down_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_down_1)

/*! @brief Set the di1_cnt_down_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_down_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_down_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_down_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_clr_sel_1[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_clr_sel_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1)

/*! @brief Set the di1_cnt_clr_sel_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_clr_sel_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_auto_reload_1[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_1 field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_auto_reload_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1)

/*! @brief Set the di1_cnt_auto_reload_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_auto_reload_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_1, field di1_cnt_polarity_gen_en_1[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1. */
#define BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1. */
#define BS_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1 field. */
#define BR_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1(x) (HW_IPU_DI1_SW_GEN1_1(x).B.di1_cnt_polarity_gen_en_1)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1. */
#define BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1) & BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1)

/*! @brief Set the di1_cnt_polarity_gen_en_1 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1(x, v) (HW_IPU_DI1_SW_GEN1_1_WR(x, (HW_IPU_DI1_SW_GEN1_1_RD(x) & ~BM_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1) | BF_IPU_DI1_SW_GEN1_1_di1_cnt_polarity_gen_en_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_2 - DI1 Sync Wave Gen 2 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_2 - DI1 Sync Wave Gen 2 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_2
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_2_bitfields
    {
        uint32_t di1_cnt_up_2 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_2 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_2 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_2 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_2 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_2 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_2 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_2_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_2 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_2_ADDR(x) ((uintptr_t)(x) + 0x48034U)

#define HW_IPU_DI1_SW_GEN1_2(x)  (*(__IO hw_ipu_di1_sw_gen1_2_t *) HW_IPU_DI1_SW_GEN1_2_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_2_RD(x) (HW_IPU_DI1_SW_GEN1_2(x).U)
#define HW_IPU_DI1_SW_GEN1_2_WR(x, v) (HW_IPU_DI1_SW_GEN1_2(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_2_SET(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, HW_IPU_DI1_SW_GEN1_2_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_2_CLR(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, HW_IPU_DI1_SW_GEN1_2_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_2_TOG(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, HW_IPU_DI1_SW_GEN1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_2 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_up_2[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_up_2 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_up_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_up_2 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_up_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_up_2 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_up_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_up_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_up_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_up_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_up_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_up_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_up_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_up_2)

/*! @brief Set the di1_cnt_up_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_up_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_up_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_up_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_polarity_clr_sel_2[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Reserved
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_polarity_clr_sel_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2)

/*! @brief Set the di1_cnt_polarity_clr_sel_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_clr_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_polarity_trigger_sel_2[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_polarity_trigger_sel_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2)

/*! @brief Set the di1_cnt_polarity_trigger_sel_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_trigger_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_down_2[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_down_2 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_down_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_down_2 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_down_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_down_2 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_down_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_down_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_down_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_down_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_down_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_down_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_down_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_down_2)

/*! @brief Set the di1_cnt_down_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_down_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_down_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_down_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_clr_sel_2[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - Reserved
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_clr_sel_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2)

/*! @brief Set the di1_cnt_clr_sel_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_clr_sel_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_auto_reload_2[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_auto_reload_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2)

/*! @brief Set the di1_cnt_auto_reload_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_auto_reload_2(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_2, field di1_cnt_polarity_gen_en_2[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2. */
#define BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2. */
#define BS_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2 field. */
#define BR_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2(x) (HW_IPU_DI1_SW_GEN1_2(x).B.di1_cnt_polarity_gen_en_2)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2. */
#define BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2) & BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2)

/*! @brief Set the di1_cnt_polarity_gen_en_2 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2(x, v) (HW_IPU_DI1_SW_GEN1_2_WR(x, (HW_IPU_DI1_SW_GEN1_2_RD(x) & ~BM_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2) | BF_IPU_DI1_SW_GEN1_2_di1_cnt_polarity_gen_en_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_3 - DI1 Sync Wave Gen 3 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_3 - DI1 Sync Wave Gen 3 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_3
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_3_bitfields
    {
        uint32_t di1_cnt_up_3 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_3 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_3 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_3 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_3 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_3 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_3 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_3_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_3 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_3_ADDR(x) ((uintptr_t)(x) + 0x48038U)

#define HW_IPU_DI1_SW_GEN1_3(x)  (*(__IO hw_ipu_di1_sw_gen1_3_t *) HW_IPU_DI1_SW_GEN1_3_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_3_RD(x) (HW_IPU_DI1_SW_GEN1_3(x).U)
#define HW_IPU_DI1_SW_GEN1_3_WR(x, v) (HW_IPU_DI1_SW_GEN1_3(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_3_SET(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, HW_IPU_DI1_SW_GEN1_3_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_3_CLR(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, HW_IPU_DI1_SW_GEN1_3_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_3_TOG(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, HW_IPU_DI1_SW_GEN1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_3 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_up_3[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_up_3 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_up_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_up_3 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_up_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_up_3 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_up_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_up_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_up_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_up_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_up_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_up_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_up_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_up_3)

/*! @brief Set the di1_cnt_up_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_up_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_up_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_up_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_polarity_clr_sel_3[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Reserved
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_polarity_clr_sel_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3)

/*! @brief Set the di1_cnt_polarity_clr_sel_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_clr_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_polarity_trigger_sel_3[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_polarity_trigger_sel_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3)

/*! @brief Set the di1_cnt_polarity_trigger_sel_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_trigger_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_down_3[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_down_3 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_down_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_down_3 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_down_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_down_3 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_down_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_down_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_down_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_down_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_down_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_down_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_down_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_down_3)

/*! @brief Set the di1_cnt_down_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_down_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_down_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_down_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_clr_sel_3[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - Reserved
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_clr_sel_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3)

/*! @brief Set the di1_cnt_clr_sel_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_clr_sel_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_auto_reload_3[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_auto_reload_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3)

/*! @brief Set the di1_cnt_auto_reload_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_auto_reload_3(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_3, field di1_cnt_polarity_gen_en_3[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3. */
#define BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3. */
#define BS_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3 field. */
#define BR_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3(x) (HW_IPU_DI1_SW_GEN1_3(x).B.di1_cnt_polarity_gen_en_3)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3. */
#define BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3) & BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3)

/*! @brief Set the di1_cnt_polarity_gen_en_3 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3(x, v) (HW_IPU_DI1_SW_GEN1_3_WR(x, (HW_IPU_DI1_SW_GEN1_3_RD(x) & ~BM_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3) | BF_IPU_DI1_SW_GEN1_3_di1_cnt_polarity_gen_en_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_4 - DI1 Sync Wave Gen 4 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_4 - DI1 Sync Wave Gen 4 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_4
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_4_bitfields
    {
        uint32_t di1_cnt_up_4 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_4 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_4 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_4 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_4 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_4 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_4 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_4_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_4 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_4_ADDR(x) ((uintptr_t)(x) + 0x4803CU)

#define HW_IPU_DI1_SW_GEN1_4(x)  (*(__IO hw_ipu_di1_sw_gen1_4_t *) HW_IPU_DI1_SW_GEN1_4_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_4_RD(x) (HW_IPU_DI1_SW_GEN1_4(x).U)
#define HW_IPU_DI1_SW_GEN1_4_WR(x, v) (HW_IPU_DI1_SW_GEN1_4(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_4_SET(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, HW_IPU_DI1_SW_GEN1_4_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_4_CLR(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, HW_IPU_DI1_SW_GEN1_4_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_4_TOG(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, HW_IPU_DI1_SW_GEN1_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_4 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_up_4[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_up_4 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_up_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_up_4 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_up_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_up_4 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_up_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_up_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_up_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_up_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_up_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_up_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_up_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_up_4)

/*! @brief Set the di1_cnt_up_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_up_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_up_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_up_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_polarity_clr_sel_4[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_polarity_clr_sel_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4)

/*! @brief Set the di1_cnt_polarity_clr_sel_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_clr_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_polarity_trigger_sel_4[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - - Counter is disabled
 * - 001 - - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - - The Counter is triggered by counter #1
 * - 011 - - The Counter is triggered by counter #2
 * - 100 - - The Counter is triggered by counter #3
 * - 101 - - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_polarity_trigger_sel_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4)

/*! @brief Set the di1_cnt_polarity_trigger_sel_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_trigger_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_down_4[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_down_4 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_down_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_down_4 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_down_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_down_4 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_down_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_down_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_down_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_down_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_down_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_down_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_down_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_down_4)

/*! @brief Set the di1_cnt_down_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_down_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_down_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_down_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_clr_sel_4[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - CSI VSYNC. The VSYNC is a trigger coming from one of the CSI's
 *     according to the CSI_VSYNC_DEST bit.
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_clr_sel_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4)

/*! @brief Set the di1_cnt_clr_sel_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_clr_sel_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_auto_reload_4[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_auto_reload_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4)

/*! @brief Set the di1_cnt_auto_reload_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_auto_reload_4(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_4, field di1_cnt_polarity_gen_en_4[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4. */
#define BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4. */
#define BS_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4 field. */
#define BR_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4(x) (HW_IPU_DI1_SW_GEN1_4(x).B.di1_cnt_polarity_gen_en_4)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4. */
#define BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4) & BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4)

/*! @brief Set the di1_cnt_polarity_gen_en_4 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4(x, v) (HW_IPU_DI1_SW_GEN1_4_WR(x, (HW_IPU_DI1_SW_GEN1_4_RD(x) & ~BM_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4) | BF_IPU_DI1_SW_GEN1_4_di1_cnt_polarity_gen_en_4(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_5 - DI1 Sync Wave Gen 5 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_5 - DI1 Sync Wave Gen 5 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_5
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_5_bitfields
    {
        uint32_t di1_cnt_up_5 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_5 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_5 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_5 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_5 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_5 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_5 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_5_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_5 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_5_ADDR(x) ((uintptr_t)(x) + 0x48040U)

#define HW_IPU_DI1_SW_GEN1_5(x)  (*(__IO hw_ipu_di1_sw_gen1_5_t *) HW_IPU_DI1_SW_GEN1_5_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_5_RD(x) (HW_IPU_DI1_SW_GEN1_5(x).U)
#define HW_IPU_DI1_SW_GEN1_5_WR(x, v) (HW_IPU_DI1_SW_GEN1_5(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_5_SET(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, HW_IPU_DI1_SW_GEN1_5_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_5_CLR(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, HW_IPU_DI1_SW_GEN1_5_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_5_TOG(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, HW_IPU_DI1_SW_GEN1_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_5 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_up_5[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_up_5 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_up_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_up_5 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_up_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_up_5 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_up_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_up_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_up_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_up_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_up_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_up_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_up_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_up_5)

/*! @brief Set the di1_cnt_up_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_up_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_up_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_up_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_polarity_clr_sel_5[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_polarity_clr_sel_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5)

/*! @brief Set the di1_cnt_polarity_clr_sel_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_clr_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_polarity_trigger_sel_5[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_polarity_trigger_sel_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5)

/*! @brief Set the di1_cnt_polarity_trigger_sel_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_trigger_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_down_5[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_down_5 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_down_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_down_5 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_down_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_down_5 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_down_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_down_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_down_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_down_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_down_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_down_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_down_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_down_5)

/*! @brief Set the di1_cnt_down_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_down_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_down_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_down_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_clr_sel_5[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - External VSYNC
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_clr_sel_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5)

/*! @brief Set the di1_cnt_clr_sel_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_clr_sel_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_auto_reload_5[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_auto_reload_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5)

/*! @brief Set the di1_cnt_auto_reload_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_auto_reload_5(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_5, field di1_cnt_polarity_gen_en_5[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5. */
#define BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5. */
#define BS_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5 field. */
#define BR_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5(x) (HW_IPU_DI1_SW_GEN1_5(x).B.di1_cnt_polarity_gen_en_5)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5. */
#define BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5) & BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5)

/*! @brief Set the di1_cnt_polarity_gen_en_5 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5(x, v) (HW_IPU_DI1_SW_GEN1_5_WR(x, (HW_IPU_DI1_SW_GEN1_5_RD(x) & ~BM_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5) | BF_IPU_DI1_SW_GEN1_5_di1_cnt_polarity_gen_en_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_6 - DI1 Sync Wave Gen 6 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_6 - DI1 Sync Wave Gen 6 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_6
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_6_bitfields
    {
        uint32_t di1_cnt_up_6 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_6 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_6 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_6 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_6 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_6 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_6 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_6_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_6 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_6_ADDR(x) ((uintptr_t)(x) + 0x48044U)

#define HW_IPU_DI1_SW_GEN1_6(x)  (*(__IO hw_ipu_di1_sw_gen1_6_t *) HW_IPU_DI1_SW_GEN1_6_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_6_RD(x) (HW_IPU_DI1_SW_GEN1_6(x).U)
#define HW_IPU_DI1_SW_GEN1_6_WR(x, v) (HW_IPU_DI1_SW_GEN1_6(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_6_SET(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, HW_IPU_DI1_SW_GEN1_6_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_6_CLR(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, HW_IPU_DI1_SW_GEN1_6_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_6_TOG(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, HW_IPU_DI1_SW_GEN1_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_6 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_up_6[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_up_6 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_up_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_up_6 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_up_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_up_6 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_up_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_up_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_up_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_up_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_up_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_up_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_up_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_up_6)

/*! @brief Set the di1_cnt_up_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_up_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_up_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_up_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_polarity_clr_sel_6[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_polarity_clr_sel_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6)

/*! @brief Set the di1_cnt_polarity_clr_sel_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_clr_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_polarity_trigger_sel_6[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_polarity_trigger_sel_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6)

/*! @brief Set the di1_cnt_polarity_trigger_sel_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_trigger_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_down_6[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_down_6 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_down_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_down_6 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_down_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_down_6 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_down_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_down_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_down_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_down_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_down_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_down_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_down_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_down_6)

/*! @brief Set the di1_cnt_down_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_down_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_down_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_down_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_clr_sel_6[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_clr_sel_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6)

/*! @brief Set the di1_cnt_clr_sel_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_clr_sel_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_auto_reload_6[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_auto_reload_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6)

/*! @brief Set the di1_cnt_auto_reload_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_auto_reload_6(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_6, field di1_cnt_polarity_gen_en_6[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6. */
#define BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6. */
#define BS_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6 field. */
#define BR_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6(x) (HW_IPU_DI1_SW_GEN1_6(x).B.di1_cnt_polarity_gen_en_6)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6. */
#define BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6) & BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6)

/*! @brief Set the di1_cnt_polarity_gen_en_6 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6(x, v) (HW_IPU_DI1_SW_GEN1_6_WR(x, (HW_IPU_DI1_SW_GEN1_6_RD(x) & ~BM_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6) | BF_IPU_DI1_SW_GEN1_6_di1_cnt_polarity_gen_en_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_7 - DI1Sync Wave Gen 7 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_7 - DI1Sync Wave Gen 7 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_7
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_7_bitfields
    {
        uint32_t di1_cnt_up_7 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_7 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_7 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_7 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_7 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_7 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_7 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_7_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_7 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_7_ADDR(x) ((uintptr_t)(x) + 0x48048U)

#define HW_IPU_DI1_SW_GEN1_7(x)  (*(__IO hw_ipu_di1_sw_gen1_7_t *) HW_IPU_DI1_SW_GEN1_7_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_7_RD(x) (HW_IPU_DI1_SW_GEN1_7(x).U)
#define HW_IPU_DI1_SW_GEN1_7_WR(x, v) (HW_IPU_DI1_SW_GEN1_7(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_7_SET(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, HW_IPU_DI1_SW_GEN1_7_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_7_CLR(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, HW_IPU_DI1_SW_GEN1_7_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_7_TOG(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, HW_IPU_DI1_SW_GEN1_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_7 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_up_7[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_up_7 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_up_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_up_7 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_up_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_up_7 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_up_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_up_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_up_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_up_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_up_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_up_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_up_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_up_7)

/*! @brief Set the di1_cnt_up_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_up_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_up_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_up_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_polarity_clr_sel_7[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Output is inverted if the output of counter #6 is set
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_polarity_clr_sel_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7)

/*! @brief Set the di1_cnt_polarity_clr_sel_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_clr_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_polarity_trigger_sel_7[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_polarity_trigger_sel_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7)

/*! @brief Set the di1_cnt_polarity_trigger_sel_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_trigger_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_down_7[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_down_7 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_down_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_down_7 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_down_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_down_7 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_down_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_down_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_down_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_down_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_down_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_down_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_down_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_down_7)

/*! @brief Set the di1_cnt_down_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_down_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_down_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_down_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_clr_sel_7[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_clr_sel_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7)

/*! @brief Set the di1_cnt_clr_sel_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_clr_sel_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_auto_reload_7[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_auto_reload_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7)

/*! @brief Set the di1_cnt_auto_reload_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_auto_reload_7(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_7, field di1_cnt_polarity_gen_en_7[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7. */
#define BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7. */
#define BS_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7 field. */
#define BR_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7(x) (HW_IPU_DI1_SW_GEN1_7(x).B.di1_cnt_polarity_gen_en_7)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7. */
#define BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7) & BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7)

/*! @brief Set the di1_cnt_polarity_gen_en_7 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7(x, v) (HW_IPU_DI1_SW_GEN1_7_WR(x, (HW_IPU_DI1_SW_GEN1_7_RD(x) & ~BM_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7) | BF_IPU_DI1_SW_GEN1_7_di1_cnt_polarity_gen_en_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_8 - DI1 Sync Wave Gen 8 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_8 - DI1 Sync Wave Gen 8 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_8
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_8_bitfields
    {
        uint32_t di1_cnt_up_8 : 9;     /*!< [8:0]  */
        uint32_t di1_cnt_polarity_clr_sel_8 : 3; /*!< [11:9]  */
        uint32_t di1_cnt_polarity_trigger_sel_8 : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t di1_cnt_down_8 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_8 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_8 : 1; /*!< [28]  */
        uint32_t di1_cnt_polarity_gen_en_8 : 2; /*!< [30:29]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_di1_sw_gen1_8_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_8 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_8_ADDR(x) ((uintptr_t)(x) + 0x4804CU)

#define HW_IPU_DI1_SW_GEN1_8(x)  (*(__IO hw_ipu_di1_sw_gen1_8_t *) HW_IPU_DI1_SW_GEN1_8_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_8_RD(x) (HW_IPU_DI1_SW_GEN1_8(x).U)
#define HW_IPU_DI1_SW_GEN1_8_WR(x, v) (HW_IPU_DI1_SW_GEN1_8(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_8_SET(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, HW_IPU_DI1_SW_GEN1_8_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_8_CLR(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, HW_IPU_DI1_SW_GEN1_8_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_8_TOG(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, HW_IPU_DI1_SW_GEN1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_8 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_up_8[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_up_8 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_up_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_up_8 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_up_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_up_8 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_up_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_up_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_up_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_up_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_up_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_up_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_up_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_up_8)

/*! @brief Set the di1_cnt_up_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_up_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_up_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_up_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_polarity_clr_sel_8[11:9] (RW)
 *
 * DI1 counter's polarity Clear select This field selects the input to the
 * counter telling the counter wether to invert the output
 *
 * Values:
 * - 000 - Output is always inverted
 * - 001 - Output is kept the same (no inversion)
 * - 010 - Output is inverted if the output of counter #1 is set
 * - 011 - Output is inverted if the output of counter #2 is set
 * - 100 - Output is inverted if the output of counter #3 is set
 * - 101 - Output is inverted if the output of counter #4 is set
 * - 110 - Output is inverted if the output of counter #5 is set
 * - 111 - Output is inverted if the output of counter #6 is set
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8 (9U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8 (0x00000E00U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_polarity_clr_sel_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8)

/*! @brief Set the di1_cnt_polarity_clr_sel_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_clr_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_polarity_trigger_sel_8[14:12] (RW)
 *
 * DI1 Counter's toggling trigger select This field selects the counter's
 * trigger causing the output to toggle
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8 (12U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8 (0x00007000U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_polarity_trigger_sel_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8)

/*! @brief Set the di1_cnt_polarity_trigger_sel_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_trigger_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_down_8[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_down_8 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_down_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_down_8 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_down_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_down_8 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_down_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_down_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_down_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_down_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_down_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_down_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_down_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_down_8)

/*! @brief Set the di1_cnt_down_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_down_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_down_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_down_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_clr_sel_8[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_clr_sel_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8)

/*! @brief Set the di1_cnt_clr_sel_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_clr_sel_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_auto_reload_8[28] (RW)
 *
 * Counter auto reload mode 1 The counter will automatically be reloaded
 * forever, ignoring the value of the di1_step_repeat_<i> field 0 The counter will not
 * be automatically reloaded, It will be reloaded for the amount of repeat times
 * defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_auto_reload_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8)

/*! @brief Set the di1_cnt_auto_reload_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_auto_reload_8(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_8, field di1_cnt_polarity_gen_en_8[30:29] (RW)
 *
 * DI1 Counter polarity generator enable The counter's output polarity can be
 * changed on the fly.
 *
 * Values:
 * - 00 - Dynamic polarity change is disabled
 * - 01 - The counters UP and DOWN value are calculated according to the trigger
 *     selected by cnt_polarity_trigger_sel field. When selecting this mode the
 *     UP and DOWN values has to be a multiple of 2.
 * - 10 - Dynamic polarity change is enabled
 * - 11 - Outputs polarity is dynamically changed every time the counter reaches
 *     its pre defined value
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8. */
#define BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8 (0x60000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8. */
#define BS_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8 (2U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8 field. */
#define BR_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8(x) (HW_IPU_DI1_SW_GEN1_8(x).B.di1_cnt_polarity_gen_en_8)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8. */
#define BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8) & BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8)

/*! @brief Set the di1_cnt_polarity_gen_en_8 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8(x, v) (HW_IPU_DI1_SW_GEN1_8_WR(x, (HW_IPU_DI1_SW_GEN1_8_RD(x) & ~BM_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8) | BF_IPU_DI1_SW_GEN1_8_di1_cnt_polarity_gen_en_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SW_GEN1_9 - DI1 Sync Wave Gen 9 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SW_GEN1_9 - DI1 Sync Wave Gen 9 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sw_gen1_9
{
    uint32_t U;
    struct _hw_ipu_di1_sw_gen1_9_bitfields
    {
        uint32_t di1_cnt_up_9 : 9;     /*!< [8:0]  */
        uint32_t RESERVED0 : 6;        /*!< [14:9]  */
        uint32_t di1_tag_sel_9 : 1;    /*!< [15]  */
        uint32_t di1_cnt_down_9 : 9;   /*!< [24:16]  */
        uint32_t di1_cnt_clr_sel_9 : 3; /*!< [27:25]  */
        uint32_t di1_cnt_auto_reload_9 : 1; /*!< [28]  */
        uint32_t di1_gentime_sel_9 : 3; /*!< [31:29]  */
    } B;
} hw_ipu_di1_sw_gen1_9_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SW_GEN1_9 register
 */
/*@{*/
#define HW_IPU_DI1_SW_GEN1_9_ADDR(x) ((uintptr_t)(x) + 0x48050U)

#define HW_IPU_DI1_SW_GEN1_9(x)  (*(__IO hw_ipu_di1_sw_gen1_9_t *) HW_IPU_DI1_SW_GEN1_9_ADDR(x))
#define HW_IPU_DI1_SW_GEN1_9_RD(x) (HW_IPU_DI1_SW_GEN1_9(x).U)
#define HW_IPU_DI1_SW_GEN1_9_WR(x, v) (HW_IPU_DI1_SW_GEN1_9(x).U = (v))
#define HW_IPU_DI1_SW_GEN1_9_SET(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, HW_IPU_DI1_SW_GEN1_9_RD(x) |  (v)))
#define HW_IPU_DI1_SW_GEN1_9_CLR(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, HW_IPU_DI1_SW_GEN1_9_RD(x) & ~(v)))
#define HW_IPU_DI1_SW_GEN1_9_TOG(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, HW_IPU_DI1_SW_GEN1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SW_GEN1_9 bitfields
 */

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_cnt_up_9[8:0] (RW)
 *
 * Counter rising edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's rising edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_cnt_up_9 (0U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_cnt_up_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_cnt_up_9 (0x000001FFU) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_cnt_up_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_cnt_up_9 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_cnt_up_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_cnt_up_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_cnt_up_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_cnt_up_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_cnt_up_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_cnt_up_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_cnt_up_9) & BM_IPU_DI1_SW_GEN1_9_di1_cnt_up_9)

/*! @brief Set the di1_cnt_up_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_cnt_up_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_cnt_up_9) | BF_IPU_DI1_SW_GEN1_9_di1_cnt_up_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_tag_sel_9[15] (RW)
 *
 * Counter #9 can send a synchronous tag when counter #9 reach its predefined
 * value or when it's triggering counter reaches its pre defined value.
 *
 * Values:
 * - 1 - tag source is counter #9
 * - 0 - Tag's source is the triggering counter.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_tag_sel_9 (15U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_tag_sel_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_tag_sel_9 (0x00008000U) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_tag_sel_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_tag_sel_9 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_tag_sel_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_tag_sel_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_tag_sel_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_tag_sel_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_tag_sel_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_tag_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_tag_sel_9) & BM_IPU_DI1_SW_GEN1_9_di1_tag_sel_9)

/*! @brief Set the di1_tag_sel_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_tag_sel_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_tag_sel_9) | BF_IPU_DI1_SW_GEN1_9_di1_tag_sel_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_cnt_down_9[24:16] (RW)
 *
 * Counter falling edge position This parameter contains an integer part (bits
 * 24:17) and a fractional part (bit 16). The position value is the amount of
 * cycles between the trigger's start point and the waveform's falling edge.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_cnt_down_9 (16U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_cnt_down_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_cnt_down_9 (0x01FF0000U) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_cnt_down_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_cnt_down_9 (9U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_cnt_down_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_cnt_down_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_cnt_down_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_cnt_down_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_cnt_down_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_cnt_down_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_cnt_down_9) & BM_IPU_DI1_SW_GEN1_9_di1_cnt_down_9)

/*! @brief Set the di1_cnt_down_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_cnt_down_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_cnt_down_9) | BF_IPU_DI1_SW_GEN1_9_di1_cnt_down_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_cnt_clr_sel_9[27:25] (RW)
 *
 * Counter Clear select This field defines the source of the signals that clears
 * the counter.
 *
 * Values:
 * - 000 - Counter is disabled
 * - 001 - The counter is triggered by the same trigger that triggers the
 *     displays clock.
 * - 010 - The Counter is triggered by counter #1
 * - 011 - The Counter is triggered by counter #2
 * - 100 - The Counter is triggered by counter #3
 * - 101 - The Counter is triggered by counter #4
 * - 110 - The Counter is triggered by counter #5
 * - 111 - Counter is always on.
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9 (25U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9 (0x0E000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_cnt_clr_sel_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9) & BM_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9)

/*! @brief Set the di1_cnt_clr_sel_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9) | BF_IPU_DI1_SW_GEN1_9_di1_cnt_clr_sel_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_cnt_auto_reload_9[28] (RW)
 *
 * Counter auto reload mode
 *
 * Values:
 * - 1 - The counter will automatically be reloaded forever, ignoring the value
 *     of the di1_step_repeat_<i> field
 * - 0 - The counter will not be automatically reloaded, It will be reloaded for
 *     the amount of repeat times defined on the di1_step_repeat_<i> field
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9 (28U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9 (0x10000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9 (1U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_cnt_auto_reload_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9) & BM_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9)

/*! @brief Set the di1_cnt_auto_reload_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9) | BF_IPU_DI1_SW_GEN1_9_di1_cnt_auto_reload_9(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SW_GEN1_9, field di1_gentime_sel_9[31:29] (RW)
 *
 * Counter #9 main waveform select This field defines the counter that counter
 * #9's auxiliary waveform will be attached too.
 *
 * Values:
 * - 000 - Counter #9's waveform is attached to counter #1's waveform
 * - 001 - Counter #9's waveform is attached to counter #2's waveform
 * - 010 - Counter #9's waveform is attached to counter #3's waveform
 * - 011 - Counter #9's waveform is attached to counter #4's waveform
 * - 100 - Counter #9's waveform is attached to counter #5's waveform
 * - 101 - Counter #9's waveform is attached to counter #6's waveform
 * - 110 - Counter #9's waveform is attached to counter #7's waveform
 * - 111 - Counter #9's waveform is attached to counter #8's waveform
 */
/*@{*/
#define BP_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9 (29U) /*!< Bit position for IPU_DI1_SW_GEN1_9_di1_gentime_sel_9. */
#define BM_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9 (0xE0000000U) /*!< Bit mask for IPU_DI1_SW_GEN1_9_di1_gentime_sel_9. */
#define BS_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9 (3U) /*!< Bit field size in bits for IPU_DI1_SW_GEN1_9_di1_gentime_sel_9. */

/*! @brief Read current value of the IPU_DI1_SW_GEN1_9_di1_gentime_sel_9 field. */
#define BR_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9(x) (HW_IPU_DI1_SW_GEN1_9(x).B.di1_gentime_sel_9)

/*! @brief Format value for bitfield IPU_DI1_SW_GEN1_9_di1_gentime_sel_9. */
#define BF_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9) & BM_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9)

/*! @brief Set the di1_gentime_sel_9 field to a new value. */
#define BW_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9(x, v) (HW_IPU_DI1_SW_GEN1_9_WR(x, (HW_IPU_DI1_SW_GEN1_9_RD(x) & ~BM_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9) | BF_IPU_DI1_SW_GEN1_9_di1_gentime_sel_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SYNC_AS_GEN - DI1 Sync Assistance Gen Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SYNC_AS_GEN - DI1 Sync Assistance Gen Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_sync_as_gen
{
    uint32_t U;
    struct _hw_ipu_di1_sync_as_gen_bitfields
    {
        uint32_t di1_sync_start : 12;  /*!< [11:0]  */
        uint32_t RESERVED0 : 1;        /*!< [12]  */
        uint32_t di1_vsync_sel : 3;    /*!< [15:13]  */
        uint32_t RESERVED1 : 12;       /*!< [27:16]  */
        uint32_t di1_sync_start_en : 1; /*!< [28]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_di1_sync_as_gen_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SYNC_AS_GEN register
 */
/*@{*/
#define HW_IPU_DI1_SYNC_AS_GEN_ADDR(x) ((uintptr_t)(x) + 0x48054U)

#define HW_IPU_DI1_SYNC_AS_GEN(x) (*(__IO hw_ipu_di1_sync_as_gen_t *) HW_IPU_DI1_SYNC_AS_GEN_ADDR(x))
#define HW_IPU_DI1_SYNC_AS_GEN_RD(x) (HW_IPU_DI1_SYNC_AS_GEN(x).U)
#define HW_IPU_DI1_SYNC_AS_GEN_WR(x, v) (HW_IPU_DI1_SYNC_AS_GEN(x).U = (v))
#define HW_IPU_DI1_SYNC_AS_GEN_SET(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, HW_IPU_DI1_SYNC_AS_GEN_RD(x) |  (v)))
#define HW_IPU_DI1_SYNC_AS_GEN_CLR(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, HW_IPU_DI1_SYNC_AS_GEN_RD(x) & ~(v)))
#define HW_IPU_DI1_SYNC_AS_GEN_TOG(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, HW_IPU_DI1_SYNC_AS_GEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SYNC_AS_GEN bitfields
 */

/*!
 * @name Register IPU_DI1_SYNC_AS_GEN, field di1_sync_start[11:0] (RW)
 *
 * DI1 Sync start This field defines the number of low (including blanking rows)
 * on the which the DI1 starts preparing the data for the next frame.
 */
/*@{*/
#define BP_IPU_DI1_SYNC_AS_GEN_di1_sync_start (0U) /*!< Bit position for IPU_DI1_SYNC_AS_GEN_di1_sync_start. */
#define BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start (0x00000FFFU) /*!< Bit mask for IPU_DI1_SYNC_AS_GEN_di1_sync_start. */
#define BS_IPU_DI1_SYNC_AS_GEN_di1_sync_start (12U) /*!< Bit field size in bits for IPU_DI1_SYNC_AS_GEN_di1_sync_start. */

/*! @brief Read current value of the IPU_DI1_SYNC_AS_GEN_di1_sync_start field. */
#define BR_IPU_DI1_SYNC_AS_GEN_di1_sync_start(x) (HW_IPU_DI1_SYNC_AS_GEN(x).B.di1_sync_start)

/*! @brief Format value for bitfield IPU_DI1_SYNC_AS_GEN_di1_sync_start. */
#define BF_IPU_DI1_SYNC_AS_GEN_di1_sync_start(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SYNC_AS_GEN_di1_sync_start) & BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start)

/*! @brief Set the di1_sync_start field to a new value. */
#define BW_IPU_DI1_SYNC_AS_GEN_di1_sync_start(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, (HW_IPU_DI1_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start) | BF_IPU_DI1_SYNC_AS_GEN_di1_sync_start(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SYNC_AS_GEN, field di1_vsync_sel[15:13] (RW)
 *
 * VSYNC select This field defines which of the counters functions as VSYNC
 * signal
 *
 * Values:
 * - 000 - VSYNC is coming from counter #1
 * - 001 - VSYNC is coming from counter #2
 * - 111 - VSYNC is coming from counter #8
 */
/*@{*/
#define BP_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel (13U) /*!< Bit position for IPU_DI1_SYNC_AS_GEN_di1_vsync_sel. */
#define BM_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel (0x0000E000U) /*!< Bit mask for IPU_DI1_SYNC_AS_GEN_di1_vsync_sel. */
#define BS_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel (3U) /*!< Bit field size in bits for IPU_DI1_SYNC_AS_GEN_di1_vsync_sel. */

/*! @brief Read current value of the IPU_DI1_SYNC_AS_GEN_di1_vsync_sel field. */
#define BR_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel(x) (HW_IPU_DI1_SYNC_AS_GEN(x).B.di1_vsync_sel)

/*! @brief Format value for bitfield IPU_DI1_SYNC_AS_GEN_di1_vsync_sel. */
#define BF_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel) & BM_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel)

/*! @brief Set the di1_vsync_sel field to a new value. */
#define BW_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, (HW_IPU_DI1_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel) | BF_IPU_DI1_SYNC_AS_GEN_di1_vsync_sel(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SYNC_AS_GEN, field di1_sync_start_en[28] (RW)
 *
 * di1_sync_start_en
 */
/*@{*/
#define BP_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en (28U) /*!< Bit position for IPU_DI1_SYNC_AS_GEN_di1_sync_start_en. */
#define BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en (0x10000000U) /*!< Bit mask for IPU_DI1_SYNC_AS_GEN_di1_sync_start_en. */
#define BS_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en (1U) /*!< Bit field size in bits for IPU_DI1_SYNC_AS_GEN_di1_sync_start_en. */

/*! @brief Read current value of the IPU_DI1_SYNC_AS_GEN_di1_sync_start_en field. */
#define BR_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en(x) (HW_IPU_DI1_SYNC_AS_GEN(x).B.di1_sync_start_en)

/*! @brief Format value for bitfield IPU_DI1_SYNC_AS_GEN_di1_sync_start_en. */
#define BF_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en) & BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en)

/*! @brief Set the di1_sync_start_en field to a new value. */
#define BW_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en(x, v) (HW_IPU_DI1_SYNC_AS_GEN_WR(x, (HW_IPU_DI1_SYNC_AS_GEN_RD(x) & ~BM_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en) | BF_IPU_DI1_SYNC_AS_GEN_di1_sync_start_en(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_DW_GEN_i - DI1 Data Wave Gen <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_DW_GEN_i - DI1 Data Wave Gen <i> Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The DI1_DW_GEN_<i> register holds pointers for the waveform generators. These
 * registers have different bit arrangements for parallel and serial display.
 * When using a parallel display VDI Plane Size Register 4 DI1 Data Wave Gen <i>
 * Register is applicable. When using a serial interface VDI Plane Size Register 4
 * DI1 Data Wave Gen <i> Register is applicable. Register Field Descriptions for
 * Serial display Field Description 31-24 di1_serial_period_<i> DI1 Serial Period
 * <i> This field defines the period of the time base serial display clock. The
 * units are the internal DI clock 23-16 di1_start_period_<i> DI1 start period
 * This field defines the amount of cycles between the point where the access is
 * ready to be launched to the actual point where the time base serial display
 * clock restarts. The units are the internal DI clock. 15-14 di1_cst_<i> DI1 Chip
 * Select pointer for waveform <i> This field points to a register that defines the
 * waveform of the CS pin. For serial displays the down value as defined on
 * DI1_DW_SET*_<i> is measured from the assertion of the last serial display time
 * base clock. 00 The waveform is defined according to the settings on
 * DI1_DW_SET0_<i> 01 The waveform is defined according to the settings on DI1_DW_SET1_<i> 10
 * The waveform is defined according to the settings on DI1_DW_SET2_<i> 11 The
 * waveform is defined according to the settings on DI1_DW_SET3_<i> 13-9 Reserved
 * 8-4 di1_serial_valid_bits_<i> DI1 Serial valid bits. This field defines the
 * amount of valid bits to be transmitted within the 32 bits internal word aligned
 * to bit[0]. The actual amount of valid bits is di1_serial_valid_bits_<i> + 1 3-2
 * di1_serial_rs_<i> DI1 Serial RS This field points to a register that defines
 * the waveform of the RS pin. For serial displays the down value as defined on
 * DI1_DW_SET*_<i> is measured from the assertion of the last serial display time
 * base clock. 00 The waveform is defined according to the settings on
 * DI1_DW_SET0_<i> 01 The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * 10 The waveform is defined according to the settings on DI1_DW_SET2_<i> 11 The
 * waveform is defined according to the settings on DI1_DW_SET3_<i> 1-0
 * di1_serial_clk_<i> DI1 serial clock<i> This field points to a register that defines
 * the waveform of the Serial clock pin. 00 The waveform is defined according to
 * the settings on DI1_DW_SET0_<i> 01 The waveform is defined according to the
 * settings on DI1_DW_SET1_<i> 10 The waveform is defined according to the settings
 * on DI1_DW_SET2_<i> 11 The waveform is defined according to the settings on
 * DI1_DW_SET3_<i>
 */
typedef union _hw_ipu_di1_dw_gen_i
{
    uint32_t U;
    struct _hw_ipu_di1_dw_gen_i_bitfields
    {
        uint32_t di1_pt_0_i : 2;       /*!< [1:0]  */
        uint32_t di1_pt_1_i : 2;       /*!< [3:2]  */
        uint32_t di1_pt_2_i : 2;       /*!< [5:4]  */
        uint32_t di1_pt_3_i : 2;       /*!< [7:6]  */
        uint32_t di1_pt_4_i : 2;       /*!< [9:8]  */
        uint32_t di1_pt_5_i : 2;       /*!< [11:10]  */
        uint32_t di1_pt_6_i : 2;       /*!< [13:12]  */
        uint32_t di1_cst_i : 2;        /*!< [15:14]  */
        uint32_t di1_componnent_size_i : 8; /*!< [23:16]  */
        uint32_t di1_access_size_i : 8; /*!< [31:24]  */
    } B;
} hw_ipu_di1_dw_gen_i_t;

/*!
 * @name Constants and macros for entire IPU_DI1_DW_GEN_i register
 */
/*@{*/
#define HW_IPU_DI1_DW_GEN_i_ADDR(x) ((uintptr_t)(x) + 0x48058U)

#define HW_IPU_DI1_DW_GEN_i(x)   (*(__IO hw_ipu_di1_dw_gen_i_t *) HW_IPU_DI1_DW_GEN_i_ADDR(x))
#define HW_IPU_DI1_DW_GEN_i_RD(x) (HW_IPU_DI1_DW_GEN_i(x).U)
#define HW_IPU_DI1_DW_GEN_i_WR(x, v) (HW_IPU_DI1_DW_GEN_i(x).U = (v))
#define HW_IPU_DI1_DW_GEN_i_SET(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, HW_IPU_DI1_DW_GEN_i_RD(x) |  (v)))
#define HW_IPU_DI1_DW_GEN_i_CLR(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, HW_IPU_DI1_DW_GEN_i_RD(x) & ~(v)))
#define HW_IPU_DI1_DW_GEN_i_TOG(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, HW_IPU_DI1_DW_GEN_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_DW_GEN_i bitfields
 */

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_0_i[1:0] (RW)
 *
 * DI1 PIN_11 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_11 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_0_i (0U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_0_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_0_i (0x00000003U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_0_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_0_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_0_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_0_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_0_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_0_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_0_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_0_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_0_i)

/*! @brief Set the di1_pt_0_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_0_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_0_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_0_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_1_i[3:2] (RW)
 *
 * DI1 PIN_12 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_12 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_1_i (2U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_1_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_1_i (0x0000000CU) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_1_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_1_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_1_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_1_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_1_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_1_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_1_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_1_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_1_i)

/*! @brief Set the di1_pt_1_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_1_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_1_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_1_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_2_i[5:4] (RW)
 *
 * DI1 PIN_13 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_13 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_2_i (4U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_2_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_2_i (0x00000030U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_2_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_2_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_2_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_2_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_2_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_2_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_2_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_2_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_2_i)

/*! @brief Set the di1_pt_2_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_2_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_2_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_2_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_3_i[7:6] (RW)
 *
 * DI1 PIN_14 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_14 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_3_i (6U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_3_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_3_i (0x000000C0U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_3_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_3_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_3_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_3_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_3_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_3_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_3_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_3_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_3_i)

/*! @brief Set the di1_pt_3_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_3_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_3_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_3_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_4_i[9:8] (RW)
 *
 * DI1 PIN_15 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_15 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_4_i (8U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_4_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_4_i (0x00000300U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_4_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_4_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_4_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_4_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_4_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_4_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_4_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_4_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_4_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_4_i)

/*! @brief Set the di1_pt_4_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_4_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_4_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_4_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_5_i[11:10] (RW)
 *
 * DI1 PIN_16 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_16 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_5_i (10U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_5_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_5_i (0x00000C00U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_5_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_5_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_5_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_5_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_5_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_5_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_5_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_5_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_5_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_5_i)

/*! @brief Set the di1_pt_5_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_5_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_5_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_5_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_pt_6_i[13:12] (RW)
 *
 * DI1 PIN_17 pointer for waveform <i> This field points to a register that
 * defines the waveform of the PIN_17 pin.
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_pt_6_i (12U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_pt_6_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_pt_6_i (0x00003000U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_pt_6_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_pt_6_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_pt_6_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_pt_6_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_pt_6_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_pt_6_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_pt_6_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_pt_6_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_pt_6_i) & BM_IPU_DI1_DW_GEN_i_di1_pt_6_i)

/*! @brief Set the di1_pt_6_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_pt_6_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_pt_6_i) | BF_IPU_DI1_DW_GEN_i_di1_pt_6_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_cst_i[15:14] (RW)
 *
 * DI1 Chip Select pointer for waveform <i> This field points to a register that
 * defines the waveform of the CS pin. The CS is automatically mapped to a
 * specific display
 *
 * Values:
 * - 00 - The waveform is defined according to the settings on DI1_DW_SET0_<i>
 * - 01 - The waveform is defined according to the settings on DI1_DW_SET1_<i>
 * - 10 - The waveform is defined according to the settings on DI1_DW_SET2_<i>
 * - 11 - The waveform is defined according to the settings on DI1_DW_SET3_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_cst_i (14U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_cst_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_cst_i (0x0000C000U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_cst_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_cst_i (2U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_cst_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_cst_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_cst_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_cst_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_cst_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_cst_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_cst_i) & BM_IPU_DI1_DW_GEN_i_di1_cst_i)

/*! @brief Set the di1_cst_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_cst_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_cst_i) | BF_IPU_DI1_DW_GEN_i_di1_cst_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_componnent_size_i[23:16] (RW)
 *
 * DI1 component Size This field defines the amount of IPU cycles between any 2
 * components
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_componnent_size_i (16U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_componnent_size_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_componnent_size_i (0x00FF0000U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_componnent_size_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_componnent_size_i (8U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_componnent_size_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_componnent_size_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_componnent_size_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_componnent_size_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_componnent_size_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_componnent_size_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_componnent_size_i) & BM_IPU_DI1_DW_GEN_i_di1_componnent_size_i)

/*! @brief Set the di1_componnent_size_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_componnent_size_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_componnent_size_i) | BF_IPU_DI1_DW_GEN_i_di1_componnent_size_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_GEN_i, field di1_access_size_i[31:24] (RW)
 *
 * DI1 Access Size <i> This field defines the amount of IPU cycles between any 2
 * accesses (an access may be a pixel or generic data that may have more one
 * component)
 */
/*@{*/
#define BP_IPU_DI1_DW_GEN_i_di1_access_size_i (24U) /*!< Bit position for IPU_DI1_DW_GEN_i_di1_access_size_i. */
#define BM_IPU_DI1_DW_GEN_i_di1_access_size_i (0xFF000000U) /*!< Bit mask for IPU_DI1_DW_GEN_i_di1_access_size_i. */
#define BS_IPU_DI1_DW_GEN_i_di1_access_size_i (8U) /*!< Bit field size in bits for IPU_DI1_DW_GEN_i_di1_access_size_i. */

/*! @brief Read current value of the IPU_DI1_DW_GEN_i_di1_access_size_i field. */
#define BR_IPU_DI1_DW_GEN_i_di1_access_size_i(x) (HW_IPU_DI1_DW_GEN_i(x).B.di1_access_size_i)

/*! @brief Format value for bitfield IPU_DI1_DW_GEN_i_di1_access_size_i. */
#define BF_IPU_DI1_DW_GEN_i_di1_access_size_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_GEN_i_di1_access_size_i) & BM_IPU_DI1_DW_GEN_i_di1_access_size_i)

/*! @brief Set the di1_access_size_i field to a new value. */
#define BW_IPU_DI1_DW_GEN_i_di1_access_size_i(x, v) (HW_IPU_DI1_DW_GEN_i_WR(x, (HW_IPU_DI1_DW_GEN_i_RD(x) & ~BM_IPU_DI1_DW_GEN_i_di1_access_size_i) | BF_IPU_DI1_DW_GEN_i_di1_access_size_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_DW_SET0_i - DI1 Data Wave Set 0 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_DW_SET0_i - DI1 Data Wave Set 0 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_dw_set0_i
{
    uint32_t U;
    struct _hw_ipu_di1_dw_set0_i_bitfields
    {
        uint32_t di1_data_cnt_up0_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di1_data_cnt_down0_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_dw_set0_i_t;

/*!
 * @name Constants and macros for entire IPU_DI1_DW_SET0_i register
 */
/*@{*/
#define HW_IPU_DI1_DW_SET0_i_ADDR(x) ((uintptr_t)(x) + 0x48088U)

#define HW_IPU_DI1_DW_SET0_i(x)  (*(__IO hw_ipu_di1_dw_set0_i_t *) HW_IPU_DI1_DW_SET0_i_ADDR(x))
#define HW_IPU_DI1_DW_SET0_i_RD(x) (HW_IPU_DI1_DW_SET0_i(x).U)
#define HW_IPU_DI1_DW_SET0_i_WR(x, v) (HW_IPU_DI1_DW_SET0_i(x).U = (v))
#define HW_IPU_DI1_DW_SET0_i_SET(x, v) (HW_IPU_DI1_DW_SET0_i_WR(x, HW_IPU_DI1_DW_SET0_i_RD(x) |  (v)))
#define HW_IPU_DI1_DW_SET0_i_CLR(x, v) (HW_IPU_DI1_DW_SET0_i_WR(x, HW_IPU_DI1_DW_SET0_i_RD(x) & ~(v)))
#define HW_IPU_DI1_DW_SET0_i_TOG(x, v) (HW_IPU_DI1_DW_SET0_i_WR(x, HW_IPU_DI1_DW_SET0_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_DW_SET0_i bitfields
 */

/*!
 * @name Register IPU_DI1_DW_SET0_i, field di1_data_cnt_up0_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i (0U) /*!< Bit position for IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i. */
#define BM_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i (0x000001FFU) /*!< Bit mask for IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i. */
#define BS_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i field. */
#define BR_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i(x) (HW_IPU_DI1_DW_SET0_i(x).B.di1_data_cnt_up0_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i. */
#define BF_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i) & BM_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i)

/*! @brief Set the di1_data_cnt_up0_i field to a new value. */
#define BW_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i(x, v) (HW_IPU_DI1_DW_SET0_i_WR(x, (HW_IPU_DI1_DW_SET0_i_RD(x) & ~BM_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i) | BF_IPU_DI1_DW_SET0_i_di1_data_cnt_up0_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_SET0_i, field di1_data_cnt_down0_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i (16U) /*!< Bit position for IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i. */
#define BM_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i (0x01FF0000U) /*!< Bit mask for IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i. */
#define BS_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i field. */
#define BR_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i(x) (HW_IPU_DI1_DW_SET0_i(x).B.di1_data_cnt_down0_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i. */
#define BF_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i) & BM_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i)

/*! @brief Set the di1_data_cnt_down0_i field to a new value. */
#define BW_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i(x, v) (HW_IPU_DI1_DW_SET0_i_WR(x, (HW_IPU_DI1_DW_SET0_i_RD(x) & ~BM_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i) | BF_IPU_DI1_DW_SET0_i_di1_data_cnt_down0_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_DW_SET1_i - DI1 Data Wave Set 1 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_DW_SET1_i - DI1 Data Wave Set 1 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_dw_set1_i
{
    uint32_t U;
    struct _hw_ipu_di1_dw_set1_i_bitfields
    {
        uint32_t di1_data_cnt_up1_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di1_data_cnt_down1_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_dw_set1_i_t;

/*!
 * @name Constants and macros for entire IPU_DI1_DW_SET1_i register
 */
/*@{*/
#define HW_IPU_DI1_DW_SET1_i_ADDR(x) ((uintptr_t)(x) + 0x480B8U)

#define HW_IPU_DI1_DW_SET1_i(x)  (*(__IO hw_ipu_di1_dw_set1_i_t *) HW_IPU_DI1_DW_SET1_i_ADDR(x))
#define HW_IPU_DI1_DW_SET1_i_RD(x) (HW_IPU_DI1_DW_SET1_i(x).U)
#define HW_IPU_DI1_DW_SET1_i_WR(x, v) (HW_IPU_DI1_DW_SET1_i(x).U = (v))
#define HW_IPU_DI1_DW_SET1_i_SET(x, v) (HW_IPU_DI1_DW_SET1_i_WR(x, HW_IPU_DI1_DW_SET1_i_RD(x) |  (v)))
#define HW_IPU_DI1_DW_SET1_i_CLR(x, v) (HW_IPU_DI1_DW_SET1_i_WR(x, HW_IPU_DI1_DW_SET1_i_RD(x) & ~(v)))
#define HW_IPU_DI1_DW_SET1_i_TOG(x, v) (HW_IPU_DI1_DW_SET1_i_WR(x, HW_IPU_DI1_DW_SET1_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_DW_SET1_i bitfields
 */

/*!
 * @name Register IPU_DI1_DW_SET1_i, field di1_data_cnt_up1_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i (0U) /*!< Bit position for IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i. */
#define BM_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i (0x000001FFU) /*!< Bit mask for IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i. */
#define BS_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i field. */
#define BR_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i(x) (HW_IPU_DI1_DW_SET1_i(x).B.di1_data_cnt_up1_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i. */
#define BF_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i) & BM_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i)

/*! @brief Set the di1_data_cnt_up1_i field to a new value. */
#define BW_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i(x, v) (HW_IPU_DI1_DW_SET1_i_WR(x, (HW_IPU_DI1_DW_SET1_i_RD(x) & ~BM_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i) | BF_IPU_DI1_DW_SET1_i_di1_data_cnt_up1_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_SET1_i, field di1_data_cnt_down1_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i (16U) /*!< Bit position for IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i. */
#define BM_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i (0x01FF0000U) /*!< Bit mask for IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i. */
#define BS_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i field. */
#define BR_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i(x) (HW_IPU_DI1_DW_SET1_i(x).B.di1_data_cnt_down1_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i. */
#define BF_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i) & BM_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i)

/*! @brief Set the di1_data_cnt_down1_i field to a new value. */
#define BW_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i(x, v) (HW_IPU_DI1_DW_SET1_i_WR(x, (HW_IPU_DI1_DW_SET1_i_RD(x) & ~BM_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i) | BF_IPU_DI1_DW_SET1_i_di1_data_cnt_down1_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_DW_SET2_i - DI1 Data Wave Set 2 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_DW_SET2_i - DI1 Data Wave Set 2 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_dw_set2_i
{
    uint32_t U;
    struct _hw_ipu_di1_dw_set2_i_bitfields
    {
        uint32_t di1_data_cnt_up2_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di1_data_cnt_down2_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_dw_set2_i_t;

/*!
 * @name Constants and macros for entire IPU_DI1_DW_SET2_i register
 */
/*@{*/
#define HW_IPU_DI1_DW_SET2_i_ADDR(x) ((uintptr_t)(x) + 0x480E8U)

#define HW_IPU_DI1_DW_SET2_i(x)  (*(__IO hw_ipu_di1_dw_set2_i_t *) HW_IPU_DI1_DW_SET2_i_ADDR(x))
#define HW_IPU_DI1_DW_SET2_i_RD(x) (HW_IPU_DI1_DW_SET2_i(x).U)
#define HW_IPU_DI1_DW_SET2_i_WR(x, v) (HW_IPU_DI1_DW_SET2_i(x).U = (v))
#define HW_IPU_DI1_DW_SET2_i_SET(x, v) (HW_IPU_DI1_DW_SET2_i_WR(x, HW_IPU_DI1_DW_SET2_i_RD(x) |  (v)))
#define HW_IPU_DI1_DW_SET2_i_CLR(x, v) (HW_IPU_DI1_DW_SET2_i_WR(x, HW_IPU_DI1_DW_SET2_i_RD(x) & ~(v)))
#define HW_IPU_DI1_DW_SET2_i_TOG(x, v) (HW_IPU_DI1_DW_SET2_i_WR(x, HW_IPU_DI1_DW_SET2_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_DW_SET2_i bitfields
 */

/*!
 * @name Register IPU_DI1_DW_SET2_i, field di1_data_cnt_up2_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i (0U) /*!< Bit position for IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i. */
#define BM_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i (0x000001FFU) /*!< Bit mask for IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i. */
#define BS_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i field. */
#define BR_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i(x) (HW_IPU_DI1_DW_SET2_i(x).B.di1_data_cnt_up2_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i. */
#define BF_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i) & BM_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i)

/*! @brief Set the di1_data_cnt_up2_i field to a new value. */
#define BW_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i(x, v) (HW_IPU_DI1_DW_SET2_i_WR(x, (HW_IPU_DI1_DW_SET2_i_RD(x) & ~BM_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i) | BF_IPU_DI1_DW_SET2_i_di1_data_cnt_up2_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_SET2_i, field di1_data_cnt_down2_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i (16U) /*!< Bit position for IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i. */
#define BM_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i (0x01FF0000U) /*!< Bit mask for IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i. */
#define BS_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i field. */
#define BR_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i(x) (HW_IPU_DI1_DW_SET2_i(x).B.di1_data_cnt_down2_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i. */
#define BF_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i) & BM_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i)

/*! @brief Set the di1_data_cnt_down2_i field to a new value. */
#define BW_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i(x, v) (HW_IPU_DI1_DW_SET2_i_WR(x, (HW_IPU_DI1_DW_SET2_i_RD(x) & ~BM_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i) | BF_IPU_DI1_DW_SET2_i_di1_data_cnt_down2_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_DW_SET3_i - DI1 Data Wave Set 3 <i> Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_DW_SET3_i - DI1 Data Wave Set 3 <i> Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_dw_set3_i
{
    uint32_t U;
    struct _hw_ipu_di1_dw_set3_i_bitfields
    {
        uint32_t di1_data_cnt_up3_i : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t di1_data_cnt_down3_i : 9; /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_di1_dw_set3_i_t;

/*!
 * @name Constants and macros for entire IPU_DI1_DW_SET3_i register
 */
/*@{*/
#define HW_IPU_DI1_DW_SET3_i_ADDR(x) ((uintptr_t)(x) + 0x48118U)

#define HW_IPU_DI1_DW_SET3_i(x)  (*(__IO hw_ipu_di1_dw_set3_i_t *) HW_IPU_DI1_DW_SET3_i_ADDR(x))
#define HW_IPU_DI1_DW_SET3_i_RD(x) (HW_IPU_DI1_DW_SET3_i(x).U)
#define HW_IPU_DI1_DW_SET3_i_WR(x, v) (HW_IPU_DI1_DW_SET3_i(x).U = (v))
#define HW_IPU_DI1_DW_SET3_i_SET(x, v) (HW_IPU_DI1_DW_SET3_i_WR(x, HW_IPU_DI1_DW_SET3_i_RD(x) |  (v)))
#define HW_IPU_DI1_DW_SET3_i_CLR(x, v) (HW_IPU_DI1_DW_SET3_i_WR(x, HW_IPU_DI1_DW_SET3_i_RD(x) & ~(v)))
#define HW_IPU_DI1_DW_SET3_i_TOG(x, v) (HW_IPU_DI1_DW_SET3_i_WR(x, HW_IPU_DI1_DW_SET3_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_DW_SET3_i bitfields
 */

/*!
 * @name Register IPU_DI1_DW_SET3_i, field di1_data_cnt_up3_i[8:0] (RW)
 *
 * Waveform's rising edge position. This field defines the Waveform's rising
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i (0U) /*!< Bit position for IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i. */
#define BM_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i (0x000001FFU) /*!< Bit mask for IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i. */
#define BS_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i field. */
#define BR_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i(x) (HW_IPU_DI1_DW_SET3_i(x).B.di1_data_cnt_up3_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i. */
#define BF_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i) & BM_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i)

/*! @brief Set the di1_data_cnt_up3_i field to a new value. */
#define BW_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i(x, v) (HW_IPU_DI1_DW_SET3_i_WR(x, (HW_IPU_DI1_DW_SET3_i_RD(x) & ~BM_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i) | BF_IPU_DI1_DW_SET3_i_di1_data_cnt_up3_i(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_DW_SET3_i, field di1_data_cnt_down3_i[24:16] (RW)
 *
 * Waveform's falling edge position. This field defines the Waveform's falling
 * edge position. The Waveform is mapped to a pint according to the corresponding
 * di1_pt_*_<i>
 */
/*@{*/
#define BP_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i (16U) /*!< Bit position for IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i. */
#define BM_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i (0x01FF0000U) /*!< Bit mask for IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i. */
#define BS_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i (9U) /*!< Bit field size in bits for IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i. */

/*! @brief Read current value of the IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i field. */
#define BR_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i(x) (HW_IPU_DI1_DW_SET3_i(x).B.di1_data_cnt_down3_i)

/*! @brief Format value for bitfield IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i. */
#define BF_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i) & BM_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i)

/*! @brief Set the di1_data_cnt_down3_i field to a new value. */
#define BW_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i(x, v) (HW_IPU_DI1_DW_SET3_i_WR(x, (HW_IPU_DI1_DW_SET3_i_RD(x) & ~BM_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i) | BF_IPU_DI1_DW_SET3_i_di1_data_cnt_down3_i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_D1_STP_REP_i - DI1 Step Repeat <i> Registers
 ******************************************************************************/

/*!
 * @brief HW_IPU_D1_STP_REP_i - DI1 Step Repeat <i> Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_d1_stp_rep_i
{
    uint32_t U;
    struct _hw_ipu_d1_stp_rep_i_bitfields
    {
        uint32_t di1_step_repeat_2i_minus_1 : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t di1_step_repeat_2i : 12; /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_d1_stp_rep_i_t;

/*!
 * @name Constants and macros for entire IPU_D1_STP_REP_i register
 */
/*@{*/
#define HW_IPU_D1_STP_REP_i_ADDR(x) ((uintptr_t)(x) + 0x48148U)

#define HW_IPU_D1_STP_REP_i(x)   (*(__IO hw_ipu_d1_stp_rep_i_t *) HW_IPU_D1_STP_REP_i_ADDR(x))
#define HW_IPU_D1_STP_REP_i_RD(x) (HW_IPU_D1_STP_REP_i(x).U)
#define HW_IPU_D1_STP_REP_i_WR(x, v) (HW_IPU_D1_STP_REP_i(x).U = (v))
#define HW_IPU_D1_STP_REP_i_SET(x, v) (HW_IPU_D1_STP_REP_i_WR(x, HW_IPU_D1_STP_REP_i_RD(x) |  (v)))
#define HW_IPU_D1_STP_REP_i_CLR(x, v) (HW_IPU_D1_STP_REP_i_WR(x, HW_IPU_D1_STP_REP_i_RD(x) & ~(v)))
#define HW_IPU_D1_STP_REP_i_TOG(x, v) (HW_IPU_D1_STP_REP_i_WR(x, HW_IPU_D1_STP_REP_i_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_D1_STP_REP_i bitfields
 */

/*!
 * @name Register IPU_D1_STP_REP_i, field di1_step_repeat_2i_minus_1[11:0] (RW)
 *
 * Step Repeat <i> This fields defines the amount of repetitions that will be
 * performed by the counter <i>
 */
/*@{*/
#define BP_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1 (0U) /*!< Bit position for IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1. */
#define BM_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1 (0x00000FFFU) /*!< Bit mask for IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1. */
#define BS_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1 (12U) /*!< Bit field size in bits for IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1. */

/*! @brief Read current value of the IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1 field. */
#define BR_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1(x) (HW_IPU_D1_STP_REP_i(x).B.di1_step_repeat_2i_minus_1)

/*! @brief Format value for bitfield IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1. */
#define BF_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1) & BM_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1)

/*! @brief Set the di1_step_repeat_2i_minus_1 field to a new value. */
#define BW_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1(x, v) (HW_IPU_D1_STP_REP_i_WR(x, (HW_IPU_D1_STP_REP_i_RD(x) & ~BM_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1) | BF_IPU_D1_STP_REP_i_di1_step_repeat_2i_minus_1(v)))
/*@}*/

/*!
 * @name Register IPU_D1_STP_REP_i, field di1_step_repeat_2i[27:16] (RW)
 *
 * Step Repeat <i> This fields defines the amount of repetitions that will be
 * performed by the counter <i>
 */
/*@{*/
#define BP_IPU_D1_STP_REP_i_di1_step_repeat_2i (16U) /*!< Bit position for IPU_D1_STP_REP_i_di1_step_repeat_2i. */
#define BM_IPU_D1_STP_REP_i_di1_step_repeat_2i (0x0FFF0000U) /*!< Bit mask for IPU_D1_STP_REP_i_di1_step_repeat_2i. */
#define BS_IPU_D1_STP_REP_i_di1_step_repeat_2i (12U) /*!< Bit field size in bits for IPU_D1_STP_REP_i_di1_step_repeat_2i. */

/*! @brief Read current value of the IPU_D1_STP_REP_i_di1_step_repeat_2i field. */
#define BR_IPU_D1_STP_REP_i_di1_step_repeat_2i(x) (HW_IPU_D1_STP_REP_i(x).B.di1_step_repeat_2i)

/*! @brief Format value for bitfield IPU_D1_STP_REP_i_di1_step_repeat_2i. */
#define BF_IPU_D1_STP_REP_i_di1_step_repeat_2i(v) ((uint32_t)((uint32_t)(v) << BP_IPU_D1_STP_REP_i_di1_step_repeat_2i) & BM_IPU_D1_STP_REP_i_di1_step_repeat_2i)

/*! @brief Set the di1_step_repeat_2i field to a new value. */
#define BW_IPU_D1_STP_REP_i_di1_step_repeat_2i(x, v) (HW_IPU_D1_STP_REP_i_WR(x, (HW_IPU_D1_STP_REP_i_RD(x) & ~BM_IPU_D1_STP_REP_i_di1_step_repeat_2i) | BF_IPU_D1_STP_REP_i_di1_step_repeat_2i(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_STP_REP_9 - DI1Step Repeat 9 Registers
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_STP_REP_9 - DI1Step Repeat 9 Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_stp_rep_9
{
    uint32_t U;
    struct _hw_ipu_di1_stp_rep_9_bitfields
    {
        uint32_t di1_step_repeat_9 : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_di1_stp_rep_9_t;

/*!
 * @name Constants and macros for entire IPU_DI1_STP_REP_9 register
 */
/*@{*/
#define HW_IPU_DI1_STP_REP_9_ADDR(x) ((uintptr_t)(x) + 0x48158U)

#define HW_IPU_DI1_STP_REP_9(x)  (*(__IO hw_ipu_di1_stp_rep_9_t *) HW_IPU_DI1_STP_REP_9_ADDR(x))
#define HW_IPU_DI1_STP_REP_9_RD(x) (HW_IPU_DI1_STP_REP_9(x).U)
#define HW_IPU_DI1_STP_REP_9_WR(x, v) (HW_IPU_DI1_STP_REP_9(x).U = (v))
#define HW_IPU_DI1_STP_REP_9_SET(x, v) (HW_IPU_DI1_STP_REP_9_WR(x, HW_IPU_DI1_STP_REP_9_RD(x) |  (v)))
#define HW_IPU_DI1_STP_REP_9_CLR(x, v) (HW_IPU_DI1_STP_REP_9_WR(x, HW_IPU_DI1_STP_REP_9_RD(x) & ~(v)))
#define HW_IPU_DI1_STP_REP_9_TOG(x, v) (HW_IPU_DI1_STP_REP_9_WR(x, HW_IPU_DI1_STP_REP_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_STP_REP_9 bitfields
 */

/*!
 * @name Register IPU_DI1_STP_REP_9, field di1_step_repeat_9[11:0] (RW)
 *
 * Step Repeat 9 This fields defines the amount of repetitions that will be
 * performed by the counter 9.
 */
/*@{*/
#define BP_IPU_DI1_STP_REP_9_di1_step_repeat_9 (0U) /*!< Bit position for IPU_DI1_STP_REP_9_di1_step_repeat_9. */
#define BM_IPU_DI1_STP_REP_9_di1_step_repeat_9 (0x00000FFFU) /*!< Bit mask for IPU_DI1_STP_REP_9_di1_step_repeat_9. */
#define BS_IPU_DI1_STP_REP_9_di1_step_repeat_9 (12U) /*!< Bit field size in bits for IPU_DI1_STP_REP_9_di1_step_repeat_9. */

/*! @brief Read current value of the IPU_DI1_STP_REP_9_di1_step_repeat_9 field. */
#define BR_IPU_DI1_STP_REP_9_di1_step_repeat_9(x) (HW_IPU_DI1_STP_REP_9(x).B.di1_step_repeat_9)

/*! @brief Format value for bitfield IPU_DI1_STP_REP_9_di1_step_repeat_9. */
#define BF_IPU_DI1_STP_REP_9_di1_step_repeat_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_STP_REP_9_di1_step_repeat_9) & BM_IPU_DI1_STP_REP_9_di1_step_repeat_9)

/*! @brief Set the di1_step_repeat_9 field to a new value. */
#define BW_IPU_DI1_STP_REP_9_di1_step_repeat_9(x, v) (HW_IPU_DI1_STP_REP_9_WR(x, (HW_IPU_DI1_STP_REP_9_RD(x) & ~BM_IPU_DI1_STP_REP_9_di1_step_repeat_9) | BF_IPU_DI1_STP_REP_9_di1_step_repeat_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SER_CONF - DI1 Serial Display Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SER_CONF - DI1 Serial Display Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_ser_conf
{
    uint32_t U;
    struct _hw_ipu_di1_ser_conf_bitfields
    {
        uint32_t DI1_WAIT4SERIAL : 1;  /*!< [0]  */
        uint32_t DI1_SERIAL_CS_POLARITY : 1; /*!< [1]  */
        uint32_t DI1_SERIAL_RS_POLARITY : 1; /*!< [2]  */
        uint32_t DI1_SERIAL_DATA_POLARITY : 1; /*!< [3]  */
        uint32_t DI1_SER_CLK_POLARITY : 1; /*!< [4]  */
        uint32_t DI1_LLA_SER_ACCESS : 1; /*!< [5]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t DI1_SERIAL_LATCH : 8; /*!< [15:8]  */
        uint32_t DI1_SERIAL_LLA_PNTR_RS_W_0 : 4; /*!< [19:16]  */
        uint32_t DI1_SERIAL_LLA_PNTR_RS_W_1 : 4; /*!< [23:20]  */
        uint32_t DI1_SERIAL_LLA_PNTR_RS_R_0 : 4; /*!< [27:24]  */
        uint32_t DI1_SERIAL_LLA_PNTR_RS_R_1 : 4; /*!< [31:28]  */
    } B;
} hw_ipu_di1_ser_conf_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SER_CONF register
 */
/*@{*/
#define HW_IPU_DI1_SER_CONF_ADDR(x) ((uintptr_t)(x) + 0x4815CU)

#define HW_IPU_DI1_SER_CONF(x)   (*(__IO hw_ipu_di1_ser_conf_t *) HW_IPU_DI1_SER_CONF_ADDR(x))
#define HW_IPU_DI1_SER_CONF_RD(x) (HW_IPU_DI1_SER_CONF(x).U)
#define HW_IPU_DI1_SER_CONF_WR(x, v) (HW_IPU_DI1_SER_CONF(x).U = (v))
#define HW_IPU_DI1_SER_CONF_SET(x, v) (HW_IPU_DI1_SER_CONF_WR(x, HW_IPU_DI1_SER_CONF_RD(x) |  (v)))
#define HW_IPU_DI1_SER_CONF_CLR(x, v) (HW_IPU_DI1_SER_CONF_WR(x, HW_IPU_DI1_SER_CONF_RD(x) & ~(v)))
#define HW_IPU_DI1_SER_CONF_TOG(x, v) (HW_IPU_DI1_SER_CONF_WR(x, HW_IPU_DI1_SER_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SER_CONF bitfields
 */

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_WAIT4SERIAL[0] (RW)
 *
 * Wait for Serial When the parallel display share pins with the serial port.
 * Accessing the parallel port is not allowed till the serial port completes its
 * access.
 *
 * Values:
 * - 1 - The parallel port should wait to the serial port as the pins are shared
 * - 0 - The parallel port should not wait to the serial port as the pins are
 *     not shared
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL (0U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_WAIT4SERIAL. */
#define BM_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL (0x00000001U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_WAIT4SERIAL. */
#define BS_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_WAIT4SERIAL. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_WAIT4SERIAL field. */
#define BR_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_WAIT4SERIAL)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_WAIT4SERIAL. */
#define BF_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL) & BM_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL)

/*! @brief Set the DI1_WAIT4SERIAL field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL) | BF_IPU_DI1_SER_CONF_DI1_WAIT4SERIAL(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_CS_POLARITY[1] (RW)
 *
 * Serial Chip Select Polarity The output polarity of the SER_CS pin
 *
 * Values:
 * - 1 - The CS is inverted
 * - 0 - The CS is not inverted
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY (1U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY (0x00000002U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_CS_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY)

/*! @brief Set the DI1_SERIAL_CS_POLARITY field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_CS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_RS_POLARITY[2] (RW)
 *
 * Serial RS Polarity The output polarity of the SER_RS pin
 *
 * Values:
 * - 1 - The RS is inverted
 * - 0 - The RS is not inverted
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY (2U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY (0x00000004U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_RS_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY)

/*! @brief Set the DI1_SERIAL_RS_POLARITY field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_RS_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_DATA_POLARITY[3] (RW)
 *
 * Serial Data Polarity The output polarity of the SER_DATA pin
 *
 * Values:
 * - 1 - The data is inverted
 * - 0 - The data is not inverted
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY (3U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY (0x00000008U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY)

/*! @brief Set the DI1_SERIAL_DATA_POLARITY field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SER_CLK_POLARITY[4] (RW)
 *
 * Serial Clock Polarity The output polarity of the SER_CLK pin
 *
 * Values:
 * - 1 - The clock is inverted
 * - 0 - The clock is not inverted
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY (4U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY. */
#define BM_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY (0x00000010U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY. */
#define BS_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY field. */
#define BR_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SER_CLK_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY. */
#define BF_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY) & BM_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY)

/*! @brief Set the DI1_SER_CLK_POLARITY field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY) | BF_IPU_DI1_SER_CONF_DI1_SER_CLK_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_LLA_SER_ACCESS[5] (RW)
 *
 * Direct Low Level Access to Serial display
 *
 * Values:
 * - 1 - ARM platform access is performed via a direct path to the serial
 *     display in LLA mode, in this mode only the ARM platform in LLA mode can access
 *     the serial port
 * - 0 - ARM platform access to the serial display port is not done directly,
 *     hence other source are allowed to access the serial port. The arbitration is
 *     done automatically
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS (5U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS. */
#define BM_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS (0x00000020U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS. */
#define BS_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS (1U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS field. */
#define BR_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_LLA_SER_ACCESS)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS. */
#define BF_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS) & BM_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS)

/*! @brief Set the DI1_LLA_SER_ACCESS field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS) | BF_IPU_DI1_SER_CONF_DI1_LLA_SER_ACCESS(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_LATCH[15:8] (RW)
 *
 * DI1 Serial Latch This field defines how many cycles to insert between serial
 * read accesses start to data sampling in the
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH (8U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_LATCH. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH (0x0000FF00U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_LATCH. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH (8U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_LATCH. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_LATCH field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_LATCH)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_LATCH. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH)

/*! @brief Set the DI1_SERIAL_LATCH field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_LATCH(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_LLA_PNTR_RS_W_0[19:16] (RW)
 *
 * RS 0 waveform pointer for write low level access This pointer defines which
 * waveform set will be chosen when the write low level access is targeted to RS
 * group 0.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0 (16U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0 (0x000F0000U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0 (4U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0 field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_LLA_PNTR_RS_W_0)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0)

/*! @brief Set the DI1_SERIAL_LLA_PNTR_RS_W_0 field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_0(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_LLA_PNTR_RS_W_1[23:20] (RW)
 *
 * RS 1 waveform pointer for write low level access This pointer defines which
 * waveform set will be chosen when the write low level access is targeted to RS
 * group 1.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1 (20U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1 (0x00F00000U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1 (4U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1 field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_LLA_PNTR_RS_W_1)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1)

/*! @brief Set the DI1_SERIAL_LLA_PNTR_RS_W_1 field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_W_1(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_LLA_PNTR_RS_R_0[27:24] (RW)
 *
 * RS 2 waveform pointer for low level access This pointer defines which
 * waveform set will be chosen when the read low level access is targeted to RS group 0.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0 (24U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0 (0x0F000000U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0 (4U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0 field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_LLA_PNTR_RS_R_0)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0)

/*! @brief Set the DI1_SERIAL_LLA_PNTR_RS_R_0 field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_0(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SER_CONF, field DI1_SERIAL_LLA_PNTR_RS_R_1[31:28] (RW)
 *
 * RS 3 waveform pointer for read low level access This pointer defines which
 * waveform set will be chosen when the read low level access is targeted to RS
 * group 1.
 *
 * Values:
 * - 0000 - Waveform set #1
 * - 0001 - Waveform set #2
 * - 1011 - Waveform set #12
 * - 1100 - Reserved
 * - 1101 - Reserved
 * - 1100 - Reserved
 */
/*@{*/
#define BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1 (28U) /*!< Bit position for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1. */
#define BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1 (0xF0000000U) /*!< Bit mask for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1. */
#define BS_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1 (4U) /*!< Bit field size in bits for IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1. */

/*! @brief Read current value of the IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1 field. */
#define BR_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1(x) (HW_IPU_DI1_SER_CONF(x).B.DI1_SERIAL_LLA_PNTR_RS_R_1)

/*! @brief Format value for bitfield IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1. */
#define BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1) & BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1)

/*! @brief Set the DI1_SERIAL_LLA_PNTR_RS_R_1 field to a new value. */
#define BW_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1(x, v) (HW_IPU_DI1_SER_CONF_WR(x, (HW_IPU_DI1_SER_CONF_RD(x) & ~BM_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1) | BF_IPU_DI1_SER_CONF_DI1_SERIAL_LLA_PNTR_RS_R_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SSC - DI1 Special Signals Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SSC - DI1 Special Signals Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_ssc
{
    uint32_t U;
    struct _hw_ipu_di1_ssc_bitfields
    {
        uint32_t DI1_BYTE_EN_PNTR : 3; /*!< [2:0]  */
        uint32_t DI1_BYTE_EN_RD_IN : 1; /*!< [3]  */
        uint32_t DI1_BYTE_EN_POLARITY : 1; /*!< [4]  */
        uint32_t DI1_WAIT_ON : 1;      /*!< [5]  */
        uint32_t RESERVED0 : 10;       /*!< [15:6]  */
        uint32_t DI1_CS_ERM : 1;       /*!< [16]  */
        uint32_t DI1_PIN11_ERM : 1;    /*!< [17]  */
        uint32_t DI1_PIN12_ERM : 1;    /*!< [18]  */
        uint32_t DI1_PIN13_ERM : 1;    /*!< [19]  */
        uint32_t DI1_PIN14_ERM : 1;    /*!< [20]  */
        uint32_t DI1_PIN15_ERM : 1;    /*!< [21]  */
        uint32_t DI1_PIN16_ERM : 1;    /*!< [22]  */
        uint32_t DI1_PIN17_ERM : 1;    /*!< [23]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_di1_ssc_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SSC register
 */
/*@{*/
#define HW_IPU_DI1_SSC_ADDR(x)   ((uintptr_t)(x) + 0x48160U)

#define HW_IPU_DI1_SSC(x)        (*(__IO hw_ipu_di1_ssc_t *) HW_IPU_DI1_SSC_ADDR(x))
#define HW_IPU_DI1_SSC_RD(x)     (HW_IPU_DI1_SSC(x).U)
#define HW_IPU_DI1_SSC_WR(x, v)  (HW_IPU_DI1_SSC(x).U = (v))
#define HW_IPU_DI1_SSC_SET(x, v) (HW_IPU_DI1_SSC_WR(x, HW_IPU_DI1_SSC_RD(x) |  (v)))
#define HW_IPU_DI1_SSC_CLR(x, v) (HW_IPU_DI1_SSC_WR(x, HW_IPU_DI1_SSC_RD(x) & ~(v)))
#define HW_IPU_DI1_SSC_TOG(x, v) (HW_IPU_DI1_SSC_WR(x, HW_IPU_DI1_SSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SSC bitfields
 */

/*!
 * @name Register IPU_DI1_SSC, field DI1_BYTE_EN_PNTR[2:0] (RW)
 *
 * Byte Enable Pointer This pointer selects the pin asserted along with the byte
 * enables signals
 *
 * Values:
 * - 000 - wave form of byte enable as pin_11
 * - 001 - wave form of byte enable as pin_12
 * - 111 - wave form of byte enable as suitable CS pin
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_BYTE_EN_PNTR (0U) /*!< Bit position for IPU_DI1_SSC_DI1_BYTE_EN_PNTR. */
#define BM_IPU_DI1_SSC_DI1_BYTE_EN_PNTR (0x00000007U) /*!< Bit mask for IPU_DI1_SSC_DI1_BYTE_EN_PNTR. */
#define BS_IPU_DI1_SSC_DI1_BYTE_EN_PNTR (3U) /*!< Bit field size in bits for IPU_DI1_SSC_DI1_BYTE_EN_PNTR. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_BYTE_EN_PNTR field. */
#define BR_IPU_DI1_SSC_DI1_BYTE_EN_PNTR(x) (HW_IPU_DI1_SSC(x).B.DI1_BYTE_EN_PNTR)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_BYTE_EN_PNTR. */
#define BF_IPU_DI1_SSC_DI1_BYTE_EN_PNTR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_BYTE_EN_PNTR) & BM_IPU_DI1_SSC_DI1_BYTE_EN_PNTR)

/*! @brief Set the DI1_BYTE_EN_PNTR field to a new value. */
#define BW_IPU_DI1_SSC_DI1_BYTE_EN_PNTR(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_BYTE_EN_PNTR) | BF_IPU_DI1_SSC_DI1_BYTE_EN_PNTR(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_BYTE_EN_RD_IN[3] (RW)
 *
 * Byte Enable Read In This bit selects the source of the byte enable pins
 *
 * Values:
 * - 1 - The write byte enable signals are routed via bits [17:16] of the
 *     display's data, The read byte enable signals are routed via bits [19:18 of the
 *     display's data
 * - 0 - The byte enable signals are routed via bits [17:16] of the display's
 *     data for both read and write
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN (3U) /*!< Bit position for IPU_DI1_SSC_DI1_BYTE_EN_RD_IN. */
#define BM_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN (0x00000008U) /*!< Bit mask for IPU_DI1_SSC_DI1_BYTE_EN_RD_IN. */
#define BS_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN (1U) /*!< Bit field size in bits for IPU_DI1_SSC_DI1_BYTE_EN_RD_IN. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_BYTE_EN_RD_IN field. */
#define BR_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN(x) (HW_IPU_DI1_SSC(x).B.DI1_BYTE_EN_RD_IN)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_BYTE_EN_RD_IN. */
#define BF_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN) & BM_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN)

/*! @brief Set the DI1_BYTE_EN_RD_IN field to a new value. */
#define BW_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN) | BF_IPU_DI1_SSC_DI1_BYTE_EN_RD_IN(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_BYTE_EN_POLARITY[4] (RW)
 *
 * Byte Enable polarity This bit defines the polarity of the byte enable signals
 * to the display.
 *
 * Values:
 * - 1 - active high.
 * - 0 - active low.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY (4U) /*!< Bit position for IPU_DI1_SSC_DI1_BYTE_EN_POLARITY. */
#define BM_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY (0x00000010U) /*!< Bit mask for IPU_DI1_SSC_DI1_BYTE_EN_POLARITY. */
#define BS_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_SSC_DI1_BYTE_EN_POLARITY. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_BYTE_EN_POLARITY field. */
#define BR_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY(x) (HW_IPU_DI1_SSC(x).B.DI1_BYTE_EN_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_BYTE_EN_POLARITY. */
#define BF_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY) & BM_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY)

/*! @brief Set the DI1_BYTE_EN_POLARITY field to a new value. */
#define BW_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY) | BF_IPU_DI1_SSC_DI1_BYTE_EN_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_WAIT_ON[5] (RW)
 *
 * Wait On This field defines the DC's response to WAIT signal
 *
 * Values:
 * - 1 - The DC holds the flow as long as WAIT is asserted.
 * - 0 - The DC continues the flow regardless the WAIT signal.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_WAIT_ON (5U)    /*!< Bit position for IPU_DI1_SSC_DI1_WAIT_ON. */
#define BM_IPU_DI1_SSC_DI1_WAIT_ON (0x00000020U) /*!< Bit mask for IPU_DI1_SSC_DI1_WAIT_ON. */
#define BS_IPU_DI1_SSC_DI1_WAIT_ON (1U)    /*!< Bit field size in bits for IPU_DI1_SSC_DI1_WAIT_ON. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_WAIT_ON field. */
#define BR_IPU_DI1_SSC_DI1_WAIT_ON(x) (HW_IPU_DI1_SSC(x).B.DI1_WAIT_ON)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_WAIT_ON. */
#define BF_IPU_DI1_SSC_DI1_WAIT_ON(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_WAIT_ON) & BM_IPU_DI1_SSC_DI1_WAIT_ON)

/*! @brief Set the DI1_WAIT_ON field to a new value. */
#define BW_IPU_DI1_SSC_DI1_WAIT_ON(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_WAIT_ON) | BF_IPU_DI1_SSC_DI1_WAIT_ON(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_CS_ERM[16] (RW)
 *
 * DI1 GLUELOGIC error recovery mode. This bit defines the error recovery mode
 * of the GLUELOGIC.
 *
 * Values:
 * - 1 - The GLUELOGIC is release in case of a synchronous display error. The
 *     release will be done on the next VSYNC.
 * - 0 - Nothing is done to the GLUELOGIC following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_CS_ERM (16U)    /*!< Bit position for IPU_DI1_SSC_DI1_CS_ERM. */
#define BM_IPU_DI1_SSC_DI1_CS_ERM (0x00010000U) /*!< Bit mask for IPU_DI1_SSC_DI1_CS_ERM. */
#define BS_IPU_DI1_SSC_DI1_CS_ERM (1U)     /*!< Bit field size in bits for IPU_DI1_SSC_DI1_CS_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_CS_ERM field. */
#define BR_IPU_DI1_SSC_DI1_CS_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_CS_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_CS_ERM. */
#define BF_IPU_DI1_SSC_DI1_CS_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_CS_ERM) & BM_IPU_DI1_SSC_DI1_CS_ERM)

/*! @brief Set the DI1_CS_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_CS_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_CS_ERM) | BF_IPU_DI1_SSC_DI1_CS_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN11_ERM[17] (RW)
 *
 * DI1 PIN11 error recovery mode. This bit defines the error recovery mode of
 * the PIN11 pin.
 *
 * Values:
 * - 1 - The PIN11 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN11 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN11_ERM (17U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN11_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN11_ERM (0x00020000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN11_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN11_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN11_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN11_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN11_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN11_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN11_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN11_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN11_ERM) & BM_IPU_DI1_SSC_DI1_PIN11_ERM)

/*! @brief Set the DI1_PIN11_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN11_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN11_ERM) | BF_IPU_DI1_SSC_DI1_PIN11_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN12_ERM[18] (RW)
 *
 * DI1 PIN12 error recovery mode. This bit defines the error recovery mode of
 * the PIN12 pin.
 *
 * Values:
 * - 1 - The PIN12 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN12 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN12_ERM (18U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN12_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN12_ERM (0x00040000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN12_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN12_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN12_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN12_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN12_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN12_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN12_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN12_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN12_ERM) & BM_IPU_DI1_SSC_DI1_PIN12_ERM)

/*! @brief Set the DI1_PIN12_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN12_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN12_ERM) | BF_IPU_DI1_SSC_DI1_PIN12_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN13_ERM[19] (RW)
 *
 * DI1 PIN13 error recovery mode. This bit defines the error recovery mode of
 * the PIN13 pin.
 *
 * Values:
 * - 1 - The PIN13 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN13 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN13_ERM (19U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN13_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN13_ERM (0x00080000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN13_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN13_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN13_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN13_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN13_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN13_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN13_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN13_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN13_ERM) & BM_IPU_DI1_SSC_DI1_PIN13_ERM)

/*! @brief Set the DI1_PIN13_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN13_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN13_ERM) | BF_IPU_DI1_SSC_DI1_PIN13_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN14_ERM[20] (RW)
 *
 * DI1 PIN14 error recovery mode. This bit defines the error recovery mode of
 * the PIN14 pin.
 *
 * Values:
 * - 1 - The PIN14 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN14 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN14_ERM (20U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN14_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN14_ERM (0x00100000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN14_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN14_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN14_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN14_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN14_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN14_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN14_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN14_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN14_ERM) & BM_IPU_DI1_SSC_DI1_PIN14_ERM)

/*! @brief Set the DI1_PIN14_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN14_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN14_ERM) | BF_IPU_DI1_SSC_DI1_PIN14_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN15_ERM[21] (RW)
 *
 * DI1 PIN15 error recovery mode. This bit defines the error recovery mode of
 * the PIN15 pin.
 *
 * Values:
 * - 1 - The PIN15 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN15 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN15_ERM (21U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN15_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN15_ERM (0x00200000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN15_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN15_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN15_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN15_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN15_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN15_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN15_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN15_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN15_ERM) & BM_IPU_DI1_SSC_DI1_PIN15_ERM)

/*! @brief Set the DI1_PIN15_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN15_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN15_ERM) | BF_IPU_DI1_SSC_DI1_PIN15_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN16_ERM[22] (RW)
 *
 * DI1 PIN16 error recovery mode. This bit defines the error recovery mode of
 * the PIN16 pin.
 *
 * Values:
 * - 1 - The PIN16 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN16 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN16_ERM (22U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN16_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN16_ERM (0x00400000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN16_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN16_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN16_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN16_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN16_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN16_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN16_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN16_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN16_ERM) & BM_IPU_DI1_SSC_DI1_PIN16_ERM)

/*! @brief Set the DI1_PIN16_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN16_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN16_ERM) | BF_IPU_DI1_SSC_DI1_PIN16_ERM(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_SSC, field DI1_PIN17_ERM[23] (RW)
 *
 * DI1 PIN17 error recovery mode. This bit defines the error recovery mode of
 * the PIN17 pin.
 *
 * Values:
 * - 1 - The PIN17 pin is cleared in case of a synchronous display error. The
 *     clear will be done on the next VSYNC.
 * - 0 - Nothing is done to the PIN17 pin following a display error detection.
 */
/*@{*/
#define BP_IPU_DI1_SSC_DI1_PIN17_ERM (23U) /*!< Bit position for IPU_DI1_SSC_DI1_PIN17_ERM. */
#define BM_IPU_DI1_SSC_DI1_PIN17_ERM (0x00800000U) /*!< Bit mask for IPU_DI1_SSC_DI1_PIN17_ERM. */
#define BS_IPU_DI1_SSC_DI1_PIN17_ERM (1U)  /*!< Bit field size in bits for IPU_DI1_SSC_DI1_PIN17_ERM. */

/*! @brief Read current value of the IPU_DI1_SSC_DI1_PIN17_ERM field. */
#define BR_IPU_DI1_SSC_DI1_PIN17_ERM(x) (HW_IPU_DI1_SSC(x).B.DI1_PIN17_ERM)

/*! @brief Format value for bitfield IPU_DI1_SSC_DI1_PIN17_ERM. */
#define BF_IPU_DI1_SSC_DI1_PIN17_ERM(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SSC_DI1_PIN17_ERM) & BM_IPU_DI1_SSC_DI1_PIN17_ERM)

/*! @brief Set the DI1_PIN17_ERM field to a new value. */
#define BW_IPU_DI1_SSC_DI1_PIN17_ERM(x, v) (HW_IPU_DI1_SSC_WR(x, (HW_IPU_DI1_SSC_RD(x) & ~BM_IPU_DI1_SSC_DI1_PIN17_ERM) | BF_IPU_DI1_SSC_DI1_PIN17_ERM(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_POL - DI1 Polarity Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_POL - DI1 Polarity Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_pol
{
    uint32_t U;
    struct _hw_ipu_di1_pol_bitfields
    {
        uint32_t di1_drdy_polarity : 7; /*!< [6:0]  */
        uint32_t DI1_DRDY_DATA_POLARITY : 1; /*!< [7]  */
        uint32_t di1_cs0_polarity : 7; /*!< [14:8]  */
        uint32_t DI1_CS0_DATA_POLARITY : 1; /*!< [15]  */
        uint32_t di1_cs1_polarity : 7; /*!< [22:16]  */
        uint32_t DI1_CS1_DATA_POLARITY : 1; /*!< [23]  */
        uint32_t DI1_CS0_BYTE_EN_POLARITY : 1; /*!< [24]  */
        uint32_t DI1_CS1_BYTE_EN_POLARITY : 1; /*!< [25]  */
        uint32_t DI1_WAIT_POLARITY : 1; /*!< [26]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_di1_pol_t;

/*!
 * @name Constants and macros for entire IPU_DI1_POL register
 */
/*@{*/
#define HW_IPU_DI1_POL_ADDR(x)   ((uintptr_t)(x) + 0x48164U)

#define HW_IPU_DI1_POL(x)        (*(__IO hw_ipu_di1_pol_t *) HW_IPU_DI1_POL_ADDR(x))
#define HW_IPU_DI1_POL_RD(x)     (HW_IPU_DI1_POL(x).U)
#define HW_IPU_DI1_POL_WR(x, v)  (HW_IPU_DI1_POL(x).U = (v))
#define HW_IPU_DI1_POL_SET(x, v) (HW_IPU_DI1_POL_WR(x, HW_IPU_DI1_POL_RD(x) |  (v)))
#define HW_IPU_DI1_POL_CLR(x, v) (HW_IPU_DI1_POL_WR(x, HW_IPU_DI1_POL_RD(x) & ~(v)))
#define HW_IPU_DI1_POL_TOG(x, v) (HW_IPU_DI1_POL_WR(x, HW_IPU_DI1_POL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_POL bitfields
 */

/*!
 * @name Register IPU_DI1_POL, field di1_drdy_polarity[6:0] (RW)
 *
 * DI1 output dynamic pin's polarity for synchronous access This bits define the
 * polarity of each of the DI's outputs when synchronous display access is
 * asserted The pins' default polarity is the same as defined in the di0_drdy_polarity
 * bits
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI1_POL_di1_drdy_polarity (0U) /*!< Bit position for IPU_DI1_POL_di1_drdy_polarity. */
#define BM_IPU_DI1_POL_di1_drdy_polarity (0x0000007FU) /*!< Bit mask for IPU_DI1_POL_di1_drdy_polarity. */
#define BS_IPU_DI1_POL_di1_drdy_polarity (7U) /*!< Bit field size in bits for IPU_DI1_POL_di1_drdy_polarity. */

/*! @brief Read current value of the IPU_DI1_POL_di1_drdy_polarity field. */
#define BR_IPU_DI1_POL_di1_drdy_polarity(x) (HW_IPU_DI1_POL(x).B.di1_drdy_polarity)

/*! @brief Format value for bitfield IPU_DI1_POL_di1_drdy_polarity. */
#define BF_IPU_DI1_POL_di1_drdy_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_di1_drdy_polarity) & BM_IPU_DI1_POL_di1_drdy_polarity)

/*! @brief Set the di1_drdy_polarity field to a new value. */
#define BW_IPU_DI1_POL_di1_drdy_polarity(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_di1_drdy_polarity) | BF_IPU_DI1_POL_di1_drdy_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_DRDY_DATA_POLARITY[7] (RW)
 *
 * Data Polarity associated with DRDY
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY (7U) /*!< Bit position for IPU_DI1_POL_DI1_DRDY_DATA_POLARITY. */
#define BM_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY (0x00000080U) /*!< Bit mask for IPU_DI1_POL_DI1_DRDY_DATA_POLARITY. */
#define BS_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_DRDY_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_DRDY_DATA_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_DRDY_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_DRDY_DATA_POLARITY. */
#define BF_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY) & BM_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY)

/*! @brief Set the DI1_DRDY_DATA_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY) | BF_IPU_DI1_POL_DI1_DRDY_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field di1_cs0_polarity[14:8] (RW)
 *
 * DI1 output pin's polarity for CS1 This bits define the polarity of each of
 * the DI's outputs when CS1 is asserted
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI1_POL_di1_cs0_polarity (8U) /*!< Bit position for IPU_DI1_POL_di1_cs0_polarity. */
#define BM_IPU_DI1_POL_di1_cs0_polarity (0x00007F00U) /*!< Bit mask for IPU_DI1_POL_di1_cs0_polarity. */
#define BS_IPU_DI1_POL_di1_cs0_polarity (7U) /*!< Bit field size in bits for IPU_DI1_POL_di1_cs0_polarity. */

/*! @brief Read current value of the IPU_DI1_POL_di1_cs0_polarity field. */
#define BR_IPU_DI1_POL_di1_cs0_polarity(x) (HW_IPU_DI1_POL(x).B.di1_cs0_polarity)

/*! @brief Format value for bitfield IPU_DI1_POL_di1_cs0_polarity. */
#define BF_IPU_DI1_POL_di1_cs0_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_di1_cs0_polarity) & BM_IPU_DI1_POL_di1_cs0_polarity)

/*! @brief Set the di1_cs0_polarity field to a new value. */
#define BW_IPU_DI1_POL_di1_cs0_polarity(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_di1_cs0_polarity) | BF_IPU_DI1_POL_di1_cs0_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_CS0_DATA_POLARITY[15] (RW)
 *
 * Data Polarity associated with CS0
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_CS0_DATA_POLARITY (15U) /*!< Bit position for IPU_DI1_POL_DI1_CS0_DATA_POLARITY. */
#define BM_IPU_DI1_POL_DI1_CS0_DATA_POLARITY (0x00008000U) /*!< Bit mask for IPU_DI1_POL_DI1_CS0_DATA_POLARITY. */
#define BS_IPU_DI1_POL_DI1_CS0_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_CS0_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_CS0_DATA_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_CS0_DATA_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_CS0_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_CS0_DATA_POLARITY. */
#define BF_IPU_DI1_POL_DI1_CS0_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_CS0_DATA_POLARITY) & BM_IPU_DI1_POL_DI1_CS0_DATA_POLARITY)

/*! @brief Set the DI1_CS0_DATA_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_CS0_DATA_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_CS0_DATA_POLARITY) | BF_IPU_DI1_POL_DI1_CS0_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field di1_cs1_polarity[22:16] (RW)
 *
 * DI1 output pin's polarity for CS1 This bits define the polarity of each of
 * the DI's outputs when CS1 is asserted
 *
 * Values:
 * - 1 - The output pin is active high
 * - 0 - The output pin is active low
 */
/*@{*/
#define BP_IPU_DI1_POL_di1_cs1_polarity (16U) /*!< Bit position for IPU_DI1_POL_di1_cs1_polarity. */
#define BM_IPU_DI1_POL_di1_cs1_polarity (0x007F0000U) /*!< Bit mask for IPU_DI1_POL_di1_cs1_polarity. */
#define BS_IPU_DI1_POL_di1_cs1_polarity (7U) /*!< Bit field size in bits for IPU_DI1_POL_di1_cs1_polarity. */

/*! @brief Read current value of the IPU_DI1_POL_di1_cs1_polarity field. */
#define BR_IPU_DI1_POL_di1_cs1_polarity(x) (HW_IPU_DI1_POL(x).B.di1_cs1_polarity)

/*! @brief Format value for bitfield IPU_DI1_POL_di1_cs1_polarity. */
#define BF_IPU_DI1_POL_di1_cs1_polarity(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_di1_cs1_polarity) & BM_IPU_DI1_POL_di1_cs1_polarity)

/*! @brief Set the di1_cs1_polarity field to a new value. */
#define BW_IPU_DI1_POL_di1_cs1_polarity(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_di1_cs1_polarity) | BF_IPU_DI1_POL_di1_cs1_polarity(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_CS1_DATA_POLARITY[23] (RW)
 *
 * Data Polarity associated with CS1
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_CS1_DATA_POLARITY (23U) /*!< Bit position for IPU_DI1_POL_DI1_CS1_DATA_POLARITY. */
#define BM_IPU_DI1_POL_DI1_CS1_DATA_POLARITY (0x00800000U) /*!< Bit mask for IPU_DI1_POL_DI1_CS1_DATA_POLARITY. */
#define BS_IPU_DI1_POL_DI1_CS1_DATA_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_CS1_DATA_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_CS1_DATA_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_CS1_DATA_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_CS1_DATA_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_CS1_DATA_POLARITY. */
#define BF_IPU_DI1_POL_DI1_CS1_DATA_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_CS1_DATA_POLARITY) & BM_IPU_DI1_POL_DI1_CS1_DATA_POLARITY)

/*! @brief Set the DI1_CS1_DATA_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_CS1_DATA_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_CS1_DATA_POLARITY) | BF_IPU_DI1_POL_DI1_CS1_DATA_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_CS0_BYTE_EN_POLARITY[24] (RW)
 *
 * Byte Enable associated with CS0 polarity This bit defines the polarity of the
 * byte enable signals to the display
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY (24U) /*!< Bit position for IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY. */
#define BM_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY (0x01000000U) /*!< Bit mask for IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY. */
#define BS_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_CS0_BYTE_EN_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY. */
#define BF_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY) & BM_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY)

/*! @brief Set the DI1_CS0_BYTE_EN_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY) | BF_IPU_DI1_POL_DI1_CS0_BYTE_EN_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_CS1_BYTE_EN_POLARITY[25] (RW)
 *
 * Byte Enable associated with CS1 polarity This bit defines the polarity of the
 * byte enable signals to the display
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY (25U) /*!< Bit position for IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY. */
#define BM_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY (0x02000000U) /*!< Bit mask for IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY. */
#define BS_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_CS1_BYTE_EN_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY. */
#define BF_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY) & BM_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY)

/*! @brief Set the DI1_CS1_BYTE_EN_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY) | BF_IPU_DI1_POL_DI1_CS1_BYTE_EN_POLARITY(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_POL, field DI1_WAIT_POLARITY[26] (RW)
 *
 * WAIT polarity This bit defines the polarity of the wait signal input coming
 * from the displa1
 *
 * Values:
 * - 1 - active high
 * - 0 - active low
 */
/*@{*/
#define BP_IPU_DI1_POL_DI1_WAIT_POLARITY (26U) /*!< Bit position for IPU_DI1_POL_DI1_WAIT_POLARITY. */
#define BM_IPU_DI1_POL_DI1_WAIT_POLARITY (0x04000000U) /*!< Bit mask for IPU_DI1_POL_DI1_WAIT_POLARITY. */
#define BS_IPU_DI1_POL_DI1_WAIT_POLARITY (1U) /*!< Bit field size in bits for IPU_DI1_POL_DI1_WAIT_POLARITY. */

/*! @brief Read current value of the IPU_DI1_POL_DI1_WAIT_POLARITY field. */
#define BR_IPU_DI1_POL_DI1_WAIT_POLARITY(x) (HW_IPU_DI1_POL(x).B.DI1_WAIT_POLARITY)

/*! @brief Format value for bitfield IPU_DI1_POL_DI1_WAIT_POLARITY. */
#define BF_IPU_DI1_POL_DI1_WAIT_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_POL_DI1_WAIT_POLARITY) & BM_IPU_DI1_POL_DI1_WAIT_POLARITY)

/*! @brief Set the DI1_WAIT_POLARITY field to a new value. */
#define BW_IPU_DI1_POL_DI1_WAIT_POLARITY(x, v) (HW_IPU_DI1_POL_WR(x, (HW_IPU_DI1_POL_RD(x) & ~BM_IPU_DI1_POL_DI1_WAIT_POLARITY) | BF_IPU_DI1_POL_DI1_WAIT_POLARITY(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_AW0 - DI1Active Window 0 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_AW0 - DI1Active Window 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_aw0
{
    uint32_t U;
    struct _hw_ipu_di1_aw0_bitfields
    {
        uint32_t DI1_AW_HSTART : 12;   /*!< [11:0]  */
        uint32_t DI1_AW_HCOUNT_SEL : 4; /*!< [15:12]  */
        uint32_t DI1_AW_HEND : 12;     /*!< [27:16]  */
        uint32_t DI1_AW_TRIG_SEL : 4;  /*!< [31:28]  */
    } B;
} hw_ipu_di1_aw0_t;

/*!
 * @name Constants and macros for entire IPU_DI1_AW0 register
 */
/*@{*/
#define HW_IPU_DI1_AW0_ADDR(x)   ((uintptr_t)(x) + 0x48168U)

#define HW_IPU_DI1_AW0(x)        (*(__IO hw_ipu_di1_aw0_t *) HW_IPU_DI1_AW0_ADDR(x))
#define HW_IPU_DI1_AW0_RD(x)     (HW_IPU_DI1_AW0(x).U)
#define HW_IPU_DI1_AW0_WR(x, v)  (HW_IPU_DI1_AW0(x).U = (v))
#define HW_IPU_DI1_AW0_SET(x, v) (HW_IPU_DI1_AW0_WR(x, HW_IPU_DI1_AW0_RD(x) |  (v)))
#define HW_IPU_DI1_AW0_CLR(x, v) (HW_IPU_DI1_AW0_WR(x, HW_IPU_DI1_AW0_RD(x) & ~(v)))
#define HW_IPU_DI1_AW0_TOG(x, v) (HW_IPU_DI1_AW0_WR(x, HW_IPU_DI1_AW0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_AW0 bitfields
 */

/*!
 * @name Register IPU_DI1_AW0, field DI1_AW_HSTART[11:0] (RW)
 *
 * This field defines the horizontal start of the active window DI1_AW_HSTART <
 * DI1_AW_HEND
 */
/*@{*/
#define BP_IPU_DI1_AW0_DI1_AW_HSTART (0U)  /*!< Bit position for IPU_DI1_AW0_DI1_AW_HSTART. */
#define BM_IPU_DI1_AW0_DI1_AW_HSTART (0x00000FFFU) /*!< Bit mask for IPU_DI1_AW0_DI1_AW_HSTART. */
#define BS_IPU_DI1_AW0_DI1_AW_HSTART (12U) /*!< Bit field size in bits for IPU_DI1_AW0_DI1_AW_HSTART. */

/*! @brief Read current value of the IPU_DI1_AW0_DI1_AW_HSTART field. */
#define BR_IPU_DI1_AW0_DI1_AW_HSTART(x) (HW_IPU_DI1_AW0(x).B.DI1_AW_HSTART)

/*! @brief Format value for bitfield IPU_DI1_AW0_DI1_AW_HSTART. */
#define BF_IPU_DI1_AW0_DI1_AW_HSTART(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW0_DI1_AW_HSTART) & BM_IPU_DI1_AW0_DI1_AW_HSTART)

/*! @brief Set the DI1_AW_HSTART field to a new value. */
#define BW_IPU_DI1_AW0_DI1_AW_HSTART(x, v) (HW_IPU_DI1_AW0_WR(x, (HW_IPU_DI1_AW0_RD(x) & ~BM_IPU_DI1_AW0_DI1_AW_HSTART) | BF_IPU_DI1_AW0_DI1_AW_HSTART(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_AW0, field DI1_AW_HCOUNT_SEL[15:12] (RW)
 *
 * This field selects the counter that counts the horizontal position of the
 * display's active window
 *
 * Values:
 * - 0000 - disabled
 * - 0001 - reserved
 * - 0010 - The counter is counter #1
 * - 0011 - The counter is counter #2
 * - 0100 - The counter is counter #3
 * - 0101 - The counter is counter #4
 * - 0110 - The counter is counter #5
 * - 1001 - The counter is counter #8
 */
/*@{*/
#define BP_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL (12U) /*!< Bit position for IPU_DI1_AW0_DI1_AW_HCOUNT_SEL. */
#define BM_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL (0x0000F000U) /*!< Bit mask for IPU_DI1_AW0_DI1_AW_HCOUNT_SEL. */
#define BS_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL (4U) /*!< Bit field size in bits for IPU_DI1_AW0_DI1_AW_HCOUNT_SEL. */

/*! @brief Read current value of the IPU_DI1_AW0_DI1_AW_HCOUNT_SEL field. */
#define BR_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL(x) (HW_IPU_DI1_AW0(x).B.DI1_AW_HCOUNT_SEL)

/*! @brief Format value for bitfield IPU_DI1_AW0_DI1_AW_HCOUNT_SEL. */
#define BF_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL) & BM_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL)

/*! @brief Set the DI1_AW_HCOUNT_SEL field to a new value. */
#define BW_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL(x, v) (HW_IPU_DI1_AW0_WR(x, (HW_IPU_DI1_AW0_RD(x) & ~BM_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL) | BF_IPU_DI1_AW0_DI1_AW_HCOUNT_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_AW0, field DI1_AW_HEND[27:16] (RW)
 *
 * This field defines the horizontal end of the active window
 */
/*@{*/
#define BP_IPU_DI1_AW0_DI1_AW_HEND (16U)   /*!< Bit position for IPU_DI1_AW0_DI1_AW_HEND. */
#define BM_IPU_DI1_AW0_DI1_AW_HEND (0x0FFF0000U) /*!< Bit mask for IPU_DI1_AW0_DI1_AW_HEND. */
#define BS_IPU_DI1_AW0_DI1_AW_HEND (12U)   /*!< Bit field size in bits for IPU_DI1_AW0_DI1_AW_HEND. */

/*! @brief Read current value of the IPU_DI1_AW0_DI1_AW_HEND field. */
#define BR_IPU_DI1_AW0_DI1_AW_HEND(x) (HW_IPU_DI1_AW0(x).B.DI1_AW_HEND)

/*! @brief Format value for bitfield IPU_DI1_AW0_DI1_AW_HEND. */
#define BF_IPU_DI1_AW0_DI1_AW_HEND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW0_DI1_AW_HEND) & BM_IPU_DI1_AW0_DI1_AW_HEND)

/*! @brief Set the DI1_AW_HEND field to a new value. */
#define BW_IPU_DI1_AW0_DI1_AW_HEND(x, v) (HW_IPU_DI1_AW0_WR(x, (HW_IPU_DI1_AW0_RD(x) & ~BM_IPU_DI1_AW0_DI1_AW_HEND) | BF_IPU_DI1_AW0_DI1_AW_HEND(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_AW0, field DI1_AW_TRIG_SEL[31:28] (RW)
 *
 * This field selects the trigger for sending data during the display's active
 * window
 *
 * Values:
 * - 000 - disabled
 * - 001 - The trigger is the same trigger that triggers the displays clock.
 * - 010 - The trigger is counter #1
 * - 011 - The trigger is counter #2
 * - 100 - The trigger is counter #3
 * - 101 - The trigger is counter #4
 * - 110 - The trigger is counter #5
 * - 111 - The trigger is always on.
 */
/*@{*/
#define BP_IPU_DI1_AW0_DI1_AW_TRIG_SEL (28U) /*!< Bit position for IPU_DI1_AW0_DI1_AW_TRIG_SEL. */
#define BM_IPU_DI1_AW0_DI1_AW_TRIG_SEL (0xF0000000U) /*!< Bit mask for IPU_DI1_AW0_DI1_AW_TRIG_SEL. */
#define BS_IPU_DI1_AW0_DI1_AW_TRIG_SEL (4U) /*!< Bit field size in bits for IPU_DI1_AW0_DI1_AW_TRIG_SEL. */

/*! @brief Read current value of the IPU_DI1_AW0_DI1_AW_TRIG_SEL field. */
#define BR_IPU_DI1_AW0_DI1_AW_TRIG_SEL(x) (HW_IPU_DI1_AW0(x).B.DI1_AW_TRIG_SEL)

/*! @brief Format value for bitfield IPU_DI1_AW0_DI1_AW_TRIG_SEL. */
#define BF_IPU_DI1_AW0_DI1_AW_TRIG_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW0_DI1_AW_TRIG_SEL) & BM_IPU_DI1_AW0_DI1_AW_TRIG_SEL)

/*! @brief Set the DI1_AW_TRIG_SEL field to a new value. */
#define BW_IPU_DI1_AW0_DI1_AW_TRIG_SEL(x, v) (HW_IPU_DI1_AW0_WR(x, (HW_IPU_DI1_AW0_RD(x) & ~BM_IPU_DI1_AW0_DI1_AW_TRIG_SEL) | BF_IPU_DI1_AW0_DI1_AW_TRIG_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_AW1 - DI1 Active Window 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_AW1 - DI1 Active Window 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_aw1
{
    uint32_t U;
    struct _hw_ipu_di1_aw1_bitfields
    {
        uint32_t DI1_AW_VSTART : 12;   /*!< [11:0]  */
        uint32_t DI1_AW_VCOUNT_SEL : 4; /*!< [15:12]  */
        uint32_t DI1_AW_VEND : 12;     /*!< [27:16]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_di1_aw1_t;

/*!
 * @name Constants and macros for entire IPU_DI1_AW1 register
 */
/*@{*/
#define HW_IPU_DI1_AW1_ADDR(x)   ((uintptr_t)(x) + 0x4816CU)

#define HW_IPU_DI1_AW1(x)        (*(__IO hw_ipu_di1_aw1_t *) HW_IPU_DI1_AW1_ADDR(x))
#define HW_IPU_DI1_AW1_RD(x)     (HW_IPU_DI1_AW1(x).U)
#define HW_IPU_DI1_AW1_WR(x, v)  (HW_IPU_DI1_AW1(x).U = (v))
#define HW_IPU_DI1_AW1_SET(x, v) (HW_IPU_DI1_AW1_WR(x, HW_IPU_DI1_AW1_RD(x) |  (v)))
#define HW_IPU_DI1_AW1_CLR(x, v) (HW_IPU_DI1_AW1_WR(x, HW_IPU_DI1_AW1_RD(x) & ~(v)))
#define HW_IPU_DI1_AW1_TOG(x, v) (HW_IPU_DI1_AW1_WR(x, HW_IPU_DI1_AW1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_AW1 bitfields
 */

/*!
 * @name Register IPU_DI1_AW1, field DI1_AW_VSTART[11:0] (RW)
 *
 * This field defines the vertical start of the active window DI1_AW_VSTART <
 * DI1_AW_VEND
 */
/*@{*/
#define BP_IPU_DI1_AW1_DI1_AW_VSTART (0U)  /*!< Bit position for IPU_DI1_AW1_DI1_AW_VSTART. */
#define BM_IPU_DI1_AW1_DI1_AW_VSTART (0x00000FFFU) /*!< Bit mask for IPU_DI1_AW1_DI1_AW_VSTART. */
#define BS_IPU_DI1_AW1_DI1_AW_VSTART (12U) /*!< Bit field size in bits for IPU_DI1_AW1_DI1_AW_VSTART. */

/*! @brief Read current value of the IPU_DI1_AW1_DI1_AW_VSTART field. */
#define BR_IPU_DI1_AW1_DI1_AW_VSTART(x) (HW_IPU_DI1_AW1(x).B.DI1_AW_VSTART)

/*! @brief Format value for bitfield IPU_DI1_AW1_DI1_AW_VSTART. */
#define BF_IPU_DI1_AW1_DI1_AW_VSTART(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW1_DI1_AW_VSTART) & BM_IPU_DI1_AW1_DI1_AW_VSTART)

/*! @brief Set the DI1_AW_VSTART field to a new value. */
#define BW_IPU_DI1_AW1_DI1_AW_VSTART(x, v) (HW_IPU_DI1_AW1_WR(x, (HW_IPU_DI1_AW1_RD(x) & ~BM_IPU_DI1_AW1_DI1_AW_VSTART) | BF_IPU_DI1_AW1_DI1_AW_VSTART(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_AW1, field DI1_AW_VCOUNT_SEL[15:12] (RW)
 *
 * This field selects the counter that counts the vertical position of the
 * display's active window
 *
 * Values:
 * - 0000 - disabled
 * - 0001 - reserved
 * - 0010 - The counter is counter #1
 * - 0011 - The counter is counter #2
 * - 0100 - The counter is counter #3
 * - 0101 - The counter is counter #4
 * - 0110 - The counter is counter #5
 * - 1001 - The counter is counter #8
 */
/*@{*/
#define BP_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL (12U) /*!< Bit position for IPU_DI1_AW1_DI1_AW_VCOUNT_SEL. */
#define BM_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL (0x0000F000U) /*!< Bit mask for IPU_DI1_AW1_DI1_AW_VCOUNT_SEL. */
#define BS_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL (4U) /*!< Bit field size in bits for IPU_DI1_AW1_DI1_AW_VCOUNT_SEL. */

/*! @brief Read current value of the IPU_DI1_AW1_DI1_AW_VCOUNT_SEL field. */
#define BR_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL(x) (HW_IPU_DI1_AW1(x).B.DI1_AW_VCOUNT_SEL)

/*! @brief Format value for bitfield IPU_DI1_AW1_DI1_AW_VCOUNT_SEL. */
#define BF_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL) & BM_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL)

/*! @brief Set the DI1_AW_VCOUNT_SEL field to a new value. */
#define BW_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL(x, v) (HW_IPU_DI1_AW1_WR(x, (HW_IPU_DI1_AW1_RD(x) & ~BM_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL) | BF_IPU_DI1_AW1_DI1_AW_VCOUNT_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_DI1_AW1, field DI1_AW_VEND[27:16] (RW)
 *
 * This field defines the vertical end of the active window
 */
/*@{*/
#define BP_IPU_DI1_AW1_DI1_AW_VEND (16U)   /*!< Bit position for IPU_DI1_AW1_DI1_AW_VEND. */
#define BM_IPU_DI1_AW1_DI1_AW_VEND (0x0FFF0000U) /*!< Bit mask for IPU_DI1_AW1_DI1_AW_VEND. */
#define BS_IPU_DI1_AW1_DI1_AW_VEND (12U)   /*!< Bit field size in bits for IPU_DI1_AW1_DI1_AW_VEND. */

/*! @brief Read current value of the IPU_DI1_AW1_DI1_AW_VEND field. */
#define BR_IPU_DI1_AW1_DI1_AW_VEND(x) (HW_IPU_DI1_AW1(x).B.DI1_AW_VEND)

/*! @brief Format value for bitfield IPU_DI1_AW1_DI1_AW_VEND. */
#define BF_IPU_DI1_AW1_DI1_AW_VEND(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_AW1_DI1_AW_VEND) & BM_IPU_DI1_AW1_DI1_AW_VEND)

/*! @brief Set the DI1_AW_VEND field to a new value. */
#define BW_IPU_DI1_AW1_DI1_AW_VEND(x, v) (HW_IPU_DI1_AW1_WR(x, (HW_IPU_DI1_AW1_RD(x) & ~BM_IPU_DI1_AW1_DI1_AW_VEND) | BF_IPU_DI1_AW1_DI1_AW_VEND(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_SCR_CONF - DI1 Screen Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_SCR_CONF - DI1 Screen Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_di1_scr_conf
{
    uint32_t U;
    struct _hw_ipu_di1_scr_conf_bitfields
    {
        uint32_t DI1_SCREEN_HEIGHT : 12; /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_di1_scr_conf_t;

/*!
 * @name Constants and macros for entire IPU_DI1_SCR_CONF register
 */
/*@{*/
#define HW_IPU_DI1_SCR_CONF_ADDR(x) ((uintptr_t)(x) + 0x48170U)

#define HW_IPU_DI1_SCR_CONF(x)   (*(__IO hw_ipu_di1_scr_conf_t *) HW_IPU_DI1_SCR_CONF_ADDR(x))
#define HW_IPU_DI1_SCR_CONF_RD(x) (HW_IPU_DI1_SCR_CONF(x).U)
#define HW_IPU_DI1_SCR_CONF_WR(x, v) (HW_IPU_DI1_SCR_CONF(x).U = (v))
#define HW_IPU_DI1_SCR_CONF_SET(x, v) (HW_IPU_DI1_SCR_CONF_WR(x, HW_IPU_DI1_SCR_CONF_RD(x) |  (v)))
#define HW_IPU_DI1_SCR_CONF_CLR(x, v) (HW_IPU_DI1_SCR_CONF_WR(x, HW_IPU_DI1_SCR_CONF_RD(x) & ~(v)))
#define HW_IPU_DI1_SCR_CONF_TOG(x, v) (HW_IPU_DI1_SCR_CONF_WR(x, HW_IPU_DI1_SCR_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_SCR_CONF bitfields
 */

/*!
 * @name Register IPU_DI1_SCR_CONF, field DI1_SCREEN_HEIGHT[11:0] (RW)
 *
 * This field defines the number of display rows (Number_of_ROWS =
 * DI1_SCREEN_HEIGHT+1) This field is used for VSYNC calculation and for anti-tearing
 */
/*@{*/
#define BP_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT (0U) /*!< Bit position for IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT. */
#define BM_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT (0x00000FFFU) /*!< Bit mask for IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT. */
#define BS_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT (12U) /*!< Bit field size in bits for IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT. */

/*! @brief Read current value of the IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT field. */
#define BR_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT(x) (HW_IPU_DI1_SCR_CONF(x).B.DI1_SCREEN_HEIGHT)

/*! @brief Format value for bitfield IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT. */
#define BF_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT) & BM_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT)

/*! @brief Set the DI1_SCREEN_HEIGHT field to a new value. */
#define BW_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT(x, v) (HW_IPU_DI1_SCR_CONF_WR(x, (HW_IPU_DI1_SCR_CONF_RD(x) & ~BM_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT) | BF_IPU_DI1_SCR_CONF_DI1_SCREEN_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DI1_STAT - DI1 Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DI1_STAT - DI1 Status Register (RO)
 *
 * Reset value: 0x00000005U
 */
typedef union _hw_ipu_di1_stat
{
    uint32_t U;
    struct _hw_ipu_di1_stat_bitfields
    {
        uint32_t DI1_READ_FIFO_EMPTY : 1; /*!< [0]  */
        uint32_t DI1_READ_FIFO_FULL : 1; /*!< [1]  */
        uint32_t DI1_CNTR_FIFO_EMPTY : 1; /*!< [2]  */
        uint32_t DI1_CNTR_FIFO_FULL : 1; /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_ipu_di1_stat_t;

/*!
 * @name Constants and macros for entire IPU_DI1_STAT register
 */
/*@{*/
#define HW_IPU_DI1_STAT_ADDR(x)  ((uintptr_t)(x) + 0x48174U)

#define HW_IPU_DI1_STAT(x)       (*(__I hw_ipu_di1_stat_t *) HW_IPU_DI1_STAT_ADDR(x))
#define HW_IPU_DI1_STAT_RD(x)    (HW_IPU_DI1_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DI1_STAT bitfields
 */

/*!
 * @name Register IPU_DI1_STAT, field DI1_READ_FIFO_EMPTY[0] (RO)
 *
 * This bit indicates an empty state of the DI1 FIFO when performing a read.
 * This FIFO is part of the DI1 synchronizer.
 */
/*@{*/
#define BP_IPU_DI1_STAT_DI1_READ_FIFO_EMPTY (0U) /*!< Bit position for IPU_DI1_STAT_DI1_READ_FIFO_EMPTY. */
#define BM_IPU_DI1_STAT_DI1_READ_FIFO_EMPTY (0x00000001U) /*!< Bit mask for IPU_DI1_STAT_DI1_READ_FIFO_EMPTY. */
#define BS_IPU_DI1_STAT_DI1_READ_FIFO_EMPTY (1U) /*!< Bit field size in bits for IPU_DI1_STAT_DI1_READ_FIFO_EMPTY. */

/*! @brief Read current value of the IPU_DI1_STAT_DI1_READ_FIFO_EMPTY field. */
#define BR_IPU_DI1_STAT_DI1_READ_FIFO_EMPTY(x) (HW_IPU_DI1_STAT(x).B.DI1_READ_FIFO_EMPTY)
/*@}*/

/*!
 * @name Register IPU_DI1_STAT, field DI1_READ_FIFO_FULL[1] (RO)
 *
 * This bit indicates a full state of the DI1 FIFO when performing a read. This
 * FIFO is part of the DI1 synchronizer.
 */
/*@{*/
#define BP_IPU_DI1_STAT_DI1_READ_FIFO_FULL (1U) /*!< Bit position for IPU_DI1_STAT_DI1_READ_FIFO_FULL. */
#define BM_IPU_DI1_STAT_DI1_READ_FIFO_FULL (0x00000002U) /*!< Bit mask for IPU_DI1_STAT_DI1_READ_FIFO_FULL. */
#define BS_IPU_DI1_STAT_DI1_READ_FIFO_FULL (1U) /*!< Bit field size in bits for IPU_DI1_STAT_DI1_READ_FIFO_FULL. */

/*! @brief Read current value of the IPU_DI1_STAT_DI1_READ_FIFO_FULL field. */
#define BR_IPU_DI1_STAT_DI1_READ_FIFO_FULL(x) (HW_IPU_DI1_STAT(x).B.DI1_READ_FIFO_FULL)
/*@}*/

/*!
 * @name Register IPU_DI1_STAT, field DI1_CNTR_FIFO_EMPTY[2] (RO)
 *
 * This bit indicates an empty state of the DI1 FIFO. This FIFO is part of the
 * DI1 synchronizer.
 */
/*@{*/
#define BP_IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY (2U) /*!< Bit position for IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY. */
#define BM_IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY (0x00000004U) /*!< Bit mask for IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY. */
#define BS_IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY (1U) /*!< Bit field size in bits for IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY. */

/*! @brief Read current value of the IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY field. */
#define BR_IPU_DI1_STAT_DI1_CNTR_FIFO_EMPTY(x) (HW_IPU_DI1_STAT(x).B.DI1_CNTR_FIFO_EMPTY)
/*@}*/

/*!
 * @name Register IPU_DI1_STAT, field DI1_CNTR_FIFO_FULL[3] (RO)
 *
 * This bit indicates a full state of the DI1 FIFO. This FIFO is part of the DI1
 * synchronizer.
 */
/*@{*/
#define BP_IPU_DI1_STAT_DI1_CNTR_FIFO_FULL (3U) /*!< Bit position for IPU_DI1_STAT_DI1_CNTR_FIFO_FULL. */
#define BM_IPU_DI1_STAT_DI1_CNTR_FIFO_FULL (0x00000008U) /*!< Bit mask for IPU_DI1_STAT_DI1_CNTR_FIFO_FULL. */
#define BS_IPU_DI1_STAT_DI1_CNTR_FIFO_FULL (1U) /*!< Bit field size in bits for IPU_DI1_STAT_DI1_CNTR_FIFO_FULL. */

/*! @brief Read current value of the IPU_DI1_STAT_DI1_CNTR_FIFO_FULL field. */
#define BR_IPU_DI1_STAT_DI1_CNTR_FIFO_FULL(x) (HW_IPU_DI1_STAT(x).B.DI1_CNTR_FIFO_FULL)
/*@}*/

/*******************************************************************************
 * HW_IPU_SMFC_MAP - SMFC Mapping Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SMFC_MAP - SMFC Mapping Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The purpose of this register is to map CSI frames to IDMAC channels.
 */
typedef union _hw_ipu_smfc_map
{
    uint32_t U;
    struct _hw_ipu_smfc_map_bitfields
    {
        uint32_t MAP_CH0 : 3;          /*!< [2:0]  */
        uint32_t MAP_CH1 : 3;          /*!< [5:3]  */
        uint32_t MAP_CH2 : 3;          /*!< [8:6]  */
        uint32_t MAP_CH3 : 3;          /*!< [11:9]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_ipu_smfc_map_t;

/*!
 * @name Constants and macros for entire IPU_SMFC_MAP register
 */
/*@{*/
#define HW_IPU_SMFC_MAP_ADDR(x)  ((uintptr_t)(x) + 0x50000U)

#define HW_IPU_SMFC_MAP(x)       (*(__IO hw_ipu_smfc_map_t *) HW_IPU_SMFC_MAP_ADDR(x))
#define HW_IPU_SMFC_MAP_RD(x)    (HW_IPU_SMFC_MAP(x).U)
#define HW_IPU_SMFC_MAP_WR(x, v) (HW_IPU_SMFC_MAP(x).U = (v))
#define HW_IPU_SMFC_MAP_SET(x, v) (HW_IPU_SMFC_MAP_WR(x, HW_IPU_SMFC_MAP_RD(x) |  (v)))
#define HW_IPU_SMFC_MAP_CLR(x, v) (HW_IPU_SMFC_MAP_WR(x, HW_IPU_SMFC_MAP_RD(x) & ~(v)))
#define HW_IPU_SMFC_MAP_TOG(x, v) (HW_IPU_SMFC_MAP_WR(x, HW_IPU_SMFC_MAP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SMFC_MAP bitfields
 */

/*!
 * @name Register IPU_SMFC_MAP, field MAP_CH0[2:0] (RW)
 *
 * DMASMFC channel 0 mapping bits.
 *
 * Values:
 * - 000 - CSI0, ID=0 mapped to DMASMFC channel 0.
 * - 001 - CSI0, ID=1 mapped to DMASMFC channel 0.
 * - 010 - CSI0, ID=2 mapped to DMASMFC channel 0.
 * - 011 - CSI0, ID=3 mapped to DMASMFC channel 0.
 * - 100 - CSI1, ID=0 mapped to DMASMFC channel 0.
 * - 101 - CSI1, ID=1 mapped to DMASMFC channel 0.
 * - 110 - CSI1, ID=2 mapped to DMASMFC channel 0.
 * - 111 - CSI1, ID=3 mapped to DMASMFC channel 0.
 */
/*@{*/
#define BP_IPU_SMFC_MAP_MAP_CH0 (0U)       /*!< Bit position for IPU_SMFC_MAP_MAP_CH0. */
#define BM_IPU_SMFC_MAP_MAP_CH0 (0x00000007U) /*!< Bit mask for IPU_SMFC_MAP_MAP_CH0. */
#define BS_IPU_SMFC_MAP_MAP_CH0 (3U)       /*!< Bit field size in bits for IPU_SMFC_MAP_MAP_CH0. */

/*! @brief Read current value of the IPU_SMFC_MAP_MAP_CH0 field. */
#define BR_IPU_SMFC_MAP_MAP_CH0(x) (HW_IPU_SMFC_MAP(x).B.MAP_CH0)

/*! @brief Format value for bitfield IPU_SMFC_MAP_MAP_CH0. */
#define BF_IPU_SMFC_MAP_MAP_CH0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_MAP_MAP_CH0) & BM_IPU_SMFC_MAP_MAP_CH0)

/*! @brief Set the MAP_CH0 field to a new value. */
#define BW_IPU_SMFC_MAP_MAP_CH0(x, v) (HW_IPU_SMFC_MAP_WR(x, (HW_IPU_SMFC_MAP_RD(x) & ~BM_IPU_SMFC_MAP_MAP_CH0) | BF_IPU_SMFC_MAP_MAP_CH0(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_MAP, field MAP_CH1[5:3] (RW)
 *
 * DMASMFC channel 1 mapping bits.
 *
 * Values:
 * - 000 - CSI0, ID=0 mapped to DMASMFC channel 1.
 * - 001 - CSI0, ID=1 mapped to DMASMFC channel 1.
 * - 010 - CSI0, ID=2 mapped to DMASMFC channel 1.
 * - 011 - CSI0, ID=3 mapped to DMASMFC channel 1.
 * - 100 - CSI1, ID=0 mapped to DMASMFC channel 1.
 * - 101 - CSI1, ID=1 mapped to DMASMFC channel 1.
 * - 110 - CSI1, ID=2 mapped to DMASMFC channel 1.
 * - 111 - CSI1, ID=3 mapped to DMASMFC channel 1.
 */
/*@{*/
#define BP_IPU_SMFC_MAP_MAP_CH1 (3U)       /*!< Bit position for IPU_SMFC_MAP_MAP_CH1. */
#define BM_IPU_SMFC_MAP_MAP_CH1 (0x00000038U) /*!< Bit mask for IPU_SMFC_MAP_MAP_CH1. */
#define BS_IPU_SMFC_MAP_MAP_CH1 (3U)       /*!< Bit field size in bits for IPU_SMFC_MAP_MAP_CH1. */

/*! @brief Read current value of the IPU_SMFC_MAP_MAP_CH1 field. */
#define BR_IPU_SMFC_MAP_MAP_CH1(x) (HW_IPU_SMFC_MAP(x).B.MAP_CH1)

/*! @brief Format value for bitfield IPU_SMFC_MAP_MAP_CH1. */
#define BF_IPU_SMFC_MAP_MAP_CH1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_MAP_MAP_CH1) & BM_IPU_SMFC_MAP_MAP_CH1)

/*! @brief Set the MAP_CH1 field to a new value. */
#define BW_IPU_SMFC_MAP_MAP_CH1(x, v) (HW_IPU_SMFC_MAP_WR(x, (HW_IPU_SMFC_MAP_RD(x) & ~BM_IPU_SMFC_MAP_MAP_CH1) | BF_IPU_SMFC_MAP_MAP_CH1(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_MAP, field MAP_CH2[8:6] (RW)
 *
 * DMASMFC channel 2 mapping bits.
 *
 * Values:
 * - 000 - CSI0, ID=0 mapped to DMASMFC channel 2.
 * - 001 - CSI0, ID=1 mapped to DMASMFC channel 2.
 * - 010 - CSI0, ID=2 mapped to DMASMFC channel 2.
 * - 011 - CSI0, ID=3 mapped to DMASMFC channel 2.
 * - 100 - CSI1, ID=0 mapped to DMASMFC channel 2.
 * - 101 - CSI1, ID=1 mapped to DMASMFC channel 2.
 * - 110 - CSI1, ID=2 mapped to DMASMFC channel 2.
 * - 111 - CSI1, ID=3 mapped to DMASMFC channel 2.
 */
/*@{*/
#define BP_IPU_SMFC_MAP_MAP_CH2 (6U)       /*!< Bit position for IPU_SMFC_MAP_MAP_CH2. */
#define BM_IPU_SMFC_MAP_MAP_CH2 (0x000001C0U) /*!< Bit mask for IPU_SMFC_MAP_MAP_CH2. */
#define BS_IPU_SMFC_MAP_MAP_CH2 (3U)       /*!< Bit field size in bits for IPU_SMFC_MAP_MAP_CH2. */

/*! @brief Read current value of the IPU_SMFC_MAP_MAP_CH2 field. */
#define BR_IPU_SMFC_MAP_MAP_CH2(x) (HW_IPU_SMFC_MAP(x).B.MAP_CH2)

/*! @brief Format value for bitfield IPU_SMFC_MAP_MAP_CH2. */
#define BF_IPU_SMFC_MAP_MAP_CH2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_MAP_MAP_CH2) & BM_IPU_SMFC_MAP_MAP_CH2)

/*! @brief Set the MAP_CH2 field to a new value. */
#define BW_IPU_SMFC_MAP_MAP_CH2(x, v) (HW_IPU_SMFC_MAP_WR(x, (HW_IPU_SMFC_MAP_RD(x) & ~BM_IPU_SMFC_MAP_MAP_CH2) | BF_IPU_SMFC_MAP_MAP_CH2(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_MAP, field MAP_CH3[11:9] (RW)
 *
 * DMASMFC channel 3mapping bits.
 *
 * Values:
 * - 000 - CSI0, ID=0 mapped to DMASMFC channel 3.
 * - 001 - CSI0, ID=1 mapped to DMASMFC channel 3.
 * - 010 - CSI0, ID=2 mapped to DMASMFC channel 3.
 * - 011 - CSI0, ID=3 mapped to DMASMFC channel 3.
 * - 100 - CSI1, ID=0 mapped to DMASMFC channel 3.
 * - 101 - CSI1, ID=1 mapped to DMASMFC channel 3.
 * - 110 - CSI1, ID=2 mapped to DMASMFC channel 3.
 * - 111 - CSI1, ID=3 mapped to DMASMFC channel 3.
 */
/*@{*/
#define BP_IPU_SMFC_MAP_MAP_CH3 (9U)       /*!< Bit position for IPU_SMFC_MAP_MAP_CH3. */
#define BM_IPU_SMFC_MAP_MAP_CH3 (0x00000E00U) /*!< Bit mask for IPU_SMFC_MAP_MAP_CH3. */
#define BS_IPU_SMFC_MAP_MAP_CH3 (3U)       /*!< Bit field size in bits for IPU_SMFC_MAP_MAP_CH3. */

/*! @brief Read current value of the IPU_SMFC_MAP_MAP_CH3 field. */
#define BR_IPU_SMFC_MAP_MAP_CH3(x) (HW_IPU_SMFC_MAP(x).B.MAP_CH3)

/*! @brief Format value for bitfield IPU_SMFC_MAP_MAP_CH3. */
#define BF_IPU_SMFC_MAP_MAP_CH3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_MAP_MAP_CH3) & BM_IPU_SMFC_MAP_MAP_CH3)

/*! @brief Set the MAP_CH3 field to a new value. */
#define BW_IPU_SMFC_MAP_MAP_CH3(x, v) (HW_IPU_SMFC_MAP_WR(x, (HW_IPU_SMFC_MAP_RD(x) & ~BM_IPU_SMFC_MAP_MAP_CH3) | BF_IPU_SMFC_MAP_MAP_CH3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SMFC_WMC - SMFC Watermark Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SMFC_WMC - SMFC Watermark Control Register (RW)
 *
 * Reset value: 0x000009A6U
 *
 * The purpose of this register is to control watermarks levels of DMA channels.
 * The bit setting given relative to FIFO size and not in number of words since
 * FIFO size depend from number of enabled DMA channels.
 */
typedef union _hw_ipu_smfc_wmc
{
    uint32_t U;
    struct _hw_ipu_smfc_wmc_bitfields
    {
        uint32_t WM0_SET : 3;          /*!< [2:0]  */
        uint32_t WM0_CLR : 3;          /*!< [5:3]  */
        uint32_t WM1_SET : 3;          /*!< [8:6]  */
        uint32_t WM1_CLR : 3;          /*!< [11:9]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t WM2_SET : 3;          /*!< [18:16]  */
        uint32_t WM2_CLR : 3;          /*!< [21:19]  */
        uint32_t WM3_SET : 3;          /*!< [24:22]  */
        uint32_t WM3_CLR : 3;          /*!< [27:25]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_smfc_wmc_t;

/*!
 * @name Constants and macros for entire IPU_SMFC_WMC register
 */
/*@{*/
#define HW_IPU_SMFC_WMC_ADDR(x)  ((uintptr_t)(x) + 0x50004U)

#define HW_IPU_SMFC_WMC(x)       (*(__IO hw_ipu_smfc_wmc_t *) HW_IPU_SMFC_WMC_ADDR(x))
#define HW_IPU_SMFC_WMC_RD(x)    (HW_IPU_SMFC_WMC(x).U)
#define HW_IPU_SMFC_WMC_WR(x, v) (HW_IPU_SMFC_WMC(x).U = (v))
#define HW_IPU_SMFC_WMC_SET(x, v) (HW_IPU_SMFC_WMC_WR(x, HW_IPU_SMFC_WMC_RD(x) |  (v)))
#define HW_IPU_SMFC_WMC_CLR(x, v) (HW_IPU_SMFC_WMC_WR(x, HW_IPU_SMFC_WMC_RD(x) & ~(v)))
#define HW_IPU_SMFC_WMC_TOG(x, v) (HW_IPU_SMFC_WMC_WR(x, HW_IPU_SMFC_WMC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SMFC_WMC bitfields
 */

/*!
 * @name Register IPU_SMFC_WMC, field WM0_SET[2:0] (RW)
 *
 * Watermark "set" level of DMASMFC channel 0.
 *
 * Values:
 * - 000 - set watermark level when FIFO is full on 1/8 of their size.
 * - 001 - set watermark level when FIFO is full on 2/8 of their size.
 * - 110 - set watermark level when FIFO is full on 7/8 of their size.
 * - 111 - set watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM0_SET (0U)       /*!< Bit position for IPU_SMFC_WMC_WM0_SET. */
#define BM_IPU_SMFC_WMC_WM0_SET (0x00000007U) /*!< Bit mask for IPU_SMFC_WMC_WM0_SET. */
#define BS_IPU_SMFC_WMC_WM0_SET (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM0_SET. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM0_SET field. */
#define BR_IPU_SMFC_WMC_WM0_SET(x) (HW_IPU_SMFC_WMC(x).B.WM0_SET)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM0_SET. */
#define BF_IPU_SMFC_WMC_WM0_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM0_SET) & BM_IPU_SMFC_WMC_WM0_SET)

/*! @brief Set the WM0_SET field to a new value. */
#define BW_IPU_SMFC_WMC_WM0_SET(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM0_SET) | BF_IPU_SMFC_WMC_WM0_SET(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM0_CLR[5:3] (RW)
 *
 * Watermark "clear" level of DMASMFC channel 0.
 *
 * Values:
 * - 000 - clear watermark level when FIFO is full on 1/8 of their size.
 * - 001 - clear watermark level when FIFO is full on 2/8 of their size.
 * - 110 - clear watermark level when FIFO is full on 7/8 of their size.
 * - 111 - clear watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM0_CLR (3U)       /*!< Bit position for IPU_SMFC_WMC_WM0_CLR. */
#define BM_IPU_SMFC_WMC_WM0_CLR (0x00000038U) /*!< Bit mask for IPU_SMFC_WMC_WM0_CLR. */
#define BS_IPU_SMFC_WMC_WM0_CLR (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM0_CLR. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM0_CLR field. */
#define BR_IPU_SMFC_WMC_WM0_CLR(x) (HW_IPU_SMFC_WMC(x).B.WM0_CLR)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM0_CLR. */
#define BF_IPU_SMFC_WMC_WM0_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM0_CLR) & BM_IPU_SMFC_WMC_WM0_CLR)

/*! @brief Set the WM0_CLR field to a new value. */
#define BW_IPU_SMFC_WMC_WM0_CLR(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM0_CLR) | BF_IPU_SMFC_WMC_WM0_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM1_SET[8:6] (RW)
 *
 * Watermark "set" level of DMASMFC channel 1.
 *
 * Values:
 * - 000 - set watermark level when FIFO is full on 1/8 of their size.
 * - 001 - set watermark level when FIFO is full on 2/8 of their size.
 * - 110 - set watermark level when FIFO is full on 7/8 of their size.
 * - 111 - set watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM1_SET (6U)       /*!< Bit position for IPU_SMFC_WMC_WM1_SET. */
#define BM_IPU_SMFC_WMC_WM1_SET (0x000001C0U) /*!< Bit mask for IPU_SMFC_WMC_WM1_SET. */
#define BS_IPU_SMFC_WMC_WM1_SET (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM1_SET. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM1_SET field. */
#define BR_IPU_SMFC_WMC_WM1_SET(x) (HW_IPU_SMFC_WMC(x).B.WM1_SET)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM1_SET. */
#define BF_IPU_SMFC_WMC_WM1_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM1_SET) & BM_IPU_SMFC_WMC_WM1_SET)

/*! @brief Set the WM1_SET field to a new value. */
#define BW_IPU_SMFC_WMC_WM1_SET(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM1_SET) | BF_IPU_SMFC_WMC_WM1_SET(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM1_CLR[11:9] (RW)
 *
 * Watermark "clear" level of DMASMFC channel 1.
 *
 * Values:
 * - 000 - clear watermark level when FIFO is full on 1/8 of their size.
 * - 001 - clear watermark level when FIFO is full on 2/8 of their size.
 * - 110 - clear watermark level when FIFO is full on 7/8 of their size.
 * - 111 - clear watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM1_CLR (9U)       /*!< Bit position for IPU_SMFC_WMC_WM1_CLR. */
#define BM_IPU_SMFC_WMC_WM1_CLR (0x00000E00U) /*!< Bit mask for IPU_SMFC_WMC_WM1_CLR. */
#define BS_IPU_SMFC_WMC_WM1_CLR (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM1_CLR. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM1_CLR field. */
#define BR_IPU_SMFC_WMC_WM1_CLR(x) (HW_IPU_SMFC_WMC(x).B.WM1_CLR)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM1_CLR. */
#define BF_IPU_SMFC_WMC_WM1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM1_CLR) & BM_IPU_SMFC_WMC_WM1_CLR)

/*! @brief Set the WM1_CLR field to a new value. */
#define BW_IPU_SMFC_WMC_WM1_CLR(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM1_CLR) | BF_IPU_SMFC_WMC_WM1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM2_SET[18:16] (RW)
 *
 * Watermark "set" level of DMASMFC channel 2.
 *
 * Values:
 * - 000 - set watermark level when FIFO is full on 1/8 of their size.
 * - 001 - set watermark level when FIFO is full on 2/8 of their size.
 * - 110 - set watermark level when FIFO is full on 7/8 of their size.
 * - 111 - set watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM2_SET (16U)      /*!< Bit position for IPU_SMFC_WMC_WM2_SET. */
#define BM_IPU_SMFC_WMC_WM2_SET (0x00070000U) /*!< Bit mask for IPU_SMFC_WMC_WM2_SET. */
#define BS_IPU_SMFC_WMC_WM2_SET (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM2_SET. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM2_SET field. */
#define BR_IPU_SMFC_WMC_WM2_SET(x) (HW_IPU_SMFC_WMC(x).B.WM2_SET)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM2_SET. */
#define BF_IPU_SMFC_WMC_WM2_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM2_SET) & BM_IPU_SMFC_WMC_WM2_SET)

/*! @brief Set the WM2_SET field to a new value. */
#define BW_IPU_SMFC_WMC_WM2_SET(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM2_SET) | BF_IPU_SMFC_WMC_WM2_SET(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM2_CLR[21:19] (RW)
 *
 * Watermark "clear" level of DMASMFC channel 2.
 *
 * Values:
 * - 000 - clear watermark level when FIFO is full on 1/8 of their size.
 * - 001 - clear watermark level when FIFO is full on 2/8 of their size.
 * - 110 - clear watermark level when FIFO is full on 7/8 of their size.
 * - 111 - clear watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM2_CLR (19U)      /*!< Bit position for IPU_SMFC_WMC_WM2_CLR. */
#define BM_IPU_SMFC_WMC_WM2_CLR (0x00380000U) /*!< Bit mask for IPU_SMFC_WMC_WM2_CLR. */
#define BS_IPU_SMFC_WMC_WM2_CLR (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM2_CLR. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM2_CLR field. */
#define BR_IPU_SMFC_WMC_WM2_CLR(x) (HW_IPU_SMFC_WMC(x).B.WM2_CLR)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM2_CLR. */
#define BF_IPU_SMFC_WMC_WM2_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM2_CLR) & BM_IPU_SMFC_WMC_WM2_CLR)

/*! @brief Set the WM2_CLR field to a new value. */
#define BW_IPU_SMFC_WMC_WM2_CLR(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM2_CLR) | BF_IPU_SMFC_WMC_WM2_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM3_SET[24:22] (RW)
 *
 * Watermark "set" level of DMASMFC channel 3
 *
 * Values:
 * - 000 - set watermark level when FIFO is full on 1/8 of their size.
 * - 001 - set watermark level when FIFO is full on 2/8 of their size.
 * - 110 - set watermark level when FIFO is full on 7/8 of their size.
 * - 111 - set watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM3_SET (22U)      /*!< Bit position for IPU_SMFC_WMC_WM3_SET. */
#define BM_IPU_SMFC_WMC_WM3_SET (0x01C00000U) /*!< Bit mask for IPU_SMFC_WMC_WM3_SET. */
#define BS_IPU_SMFC_WMC_WM3_SET (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM3_SET. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM3_SET field. */
#define BR_IPU_SMFC_WMC_WM3_SET(x) (HW_IPU_SMFC_WMC(x).B.WM3_SET)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM3_SET. */
#define BF_IPU_SMFC_WMC_WM3_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM3_SET) & BM_IPU_SMFC_WMC_WM3_SET)

/*! @brief Set the WM3_SET field to a new value. */
#define BW_IPU_SMFC_WMC_WM3_SET(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM3_SET) | BF_IPU_SMFC_WMC_WM3_SET(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_WMC, field WM3_CLR[27:25] (RW)
 *
 * Watermark "clear" level of DMASMFC channel 3.
 *
 * Values:
 * - 000 - clear watermark level when FIFO is full on 1/8 of their size.
 * - 001 - clear watermark level when FIFO is full on 2/8 of their size.
 * - 110 - clear watermark level when FIFO is full on 7/8 of their size.
 * - 111 - clear watermark level when FIFO is full.
 */
/*@{*/
#define BP_IPU_SMFC_WMC_WM3_CLR (25U)      /*!< Bit position for IPU_SMFC_WMC_WM3_CLR. */
#define BM_IPU_SMFC_WMC_WM3_CLR (0x0E000000U) /*!< Bit mask for IPU_SMFC_WMC_WM3_CLR. */
#define BS_IPU_SMFC_WMC_WM3_CLR (3U)       /*!< Bit field size in bits for IPU_SMFC_WMC_WM3_CLR. */

/*! @brief Read current value of the IPU_SMFC_WMC_WM3_CLR field. */
#define BR_IPU_SMFC_WMC_WM3_CLR(x) (HW_IPU_SMFC_WMC(x).B.WM3_CLR)

/*! @brief Format value for bitfield IPU_SMFC_WMC_WM3_CLR. */
#define BF_IPU_SMFC_WMC_WM3_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_WMC_WM3_CLR) & BM_IPU_SMFC_WMC_WM3_CLR)

/*! @brief Set the WM3_CLR field to a new value. */
#define BW_IPU_SMFC_WMC_WM3_CLR(x, v) (HW_IPU_SMFC_WMC_WR(x, (HW_IPU_SMFC_WMC_RD(x) & ~BM_IPU_SMFC_WMC_WM3_CLR) | BF_IPU_SMFC_WMC_WM3_CLR(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_SMFC_BS - SMFC Burst Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_SMFC_BS - SMFC Burst Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the burst size value for each DMASMFC channel. The burst
 * size is the number of IDMAC's active accesses that will done for each IDMAC's
 * burst. This number is a function of PFS, BPP & NPB parameters in the IDMAC's
 * CPMEM. These are the parameters corresponding to the IDMAC's channel used. The
 * table below describes what should be the burst size according to PFS, BPP &
 * NPB settings SMFC Burst Size BPP PFS BURST_SIZE 8 6 NPB[6:4] 16 6 NPB[6:3] All
 * other All other NPB[6:2]
 */
typedef union _hw_ipu_smfc_bs
{
    uint32_t U;
    struct _hw_ipu_smfc_bs_bitfields
    {
        uint32_t BURST0_SIZE : 4;      /*!< [3:0]  */
        uint32_t BURST1_SIZE : 4;      /*!< [7:4]  */
        uint32_t BURST2_SIZE : 4;      /*!< [11:8]  */
        uint32_t BURST3_SIZE : 4;      /*!< [15:12]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_smfc_bs_t;

/*!
 * @name Constants and macros for entire IPU_SMFC_BS register
 */
/*@{*/
#define HW_IPU_SMFC_BS_ADDR(x)   ((uintptr_t)(x) + 0x50008U)

#define HW_IPU_SMFC_BS(x)        (*(__IO hw_ipu_smfc_bs_t *) HW_IPU_SMFC_BS_ADDR(x))
#define HW_IPU_SMFC_BS_RD(x)     (HW_IPU_SMFC_BS(x).U)
#define HW_IPU_SMFC_BS_WR(x, v)  (HW_IPU_SMFC_BS(x).U = (v))
#define HW_IPU_SMFC_BS_SET(x, v) (HW_IPU_SMFC_BS_WR(x, HW_IPU_SMFC_BS_RD(x) |  (v)))
#define HW_IPU_SMFC_BS_CLR(x, v) (HW_IPU_SMFC_BS_WR(x, HW_IPU_SMFC_BS_RD(x) & ~(v)))
#define HW_IPU_SMFC_BS_TOG(x, v) (HW_IPU_SMFC_BS_WR(x, HW_IPU_SMFC_BS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_SMFC_BS bitfields
 */

/*!
 * @name Register IPU_SMFC_BS, field BURST0_SIZE[3:0] (RW)
 *
 * Burst Size of SMFCDMA channel 0. The value programed here should be
 * BURST_SIZE-1 (for example: for a burst size of 1, write 0 to these bits)
 */
/*@{*/
#define BP_IPU_SMFC_BS_BURST0_SIZE (0U)    /*!< Bit position for IPU_SMFC_BS_BURST0_SIZE. */
#define BM_IPU_SMFC_BS_BURST0_SIZE (0x0000000FU) /*!< Bit mask for IPU_SMFC_BS_BURST0_SIZE. */
#define BS_IPU_SMFC_BS_BURST0_SIZE (4U)    /*!< Bit field size in bits for IPU_SMFC_BS_BURST0_SIZE. */

/*! @brief Read current value of the IPU_SMFC_BS_BURST0_SIZE field. */
#define BR_IPU_SMFC_BS_BURST0_SIZE(x) (HW_IPU_SMFC_BS(x).B.BURST0_SIZE)

/*! @brief Format value for bitfield IPU_SMFC_BS_BURST0_SIZE. */
#define BF_IPU_SMFC_BS_BURST0_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_BS_BURST0_SIZE) & BM_IPU_SMFC_BS_BURST0_SIZE)

/*! @brief Set the BURST0_SIZE field to a new value. */
#define BW_IPU_SMFC_BS_BURST0_SIZE(x, v) (HW_IPU_SMFC_BS_WR(x, (HW_IPU_SMFC_BS_RD(x) & ~BM_IPU_SMFC_BS_BURST0_SIZE) | BF_IPU_SMFC_BS_BURST0_SIZE(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_BS, field BURST1_SIZE[7:4] (RW)
 *
 * Burst Size of SMFCDMA channel 1. The value programed here should be
 * BURST_SIZE-1 (for example: for a burst size of 1, write 0 to these bits)
 */
/*@{*/
#define BP_IPU_SMFC_BS_BURST1_SIZE (4U)    /*!< Bit position for IPU_SMFC_BS_BURST1_SIZE. */
#define BM_IPU_SMFC_BS_BURST1_SIZE (0x000000F0U) /*!< Bit mask for IPU_SMFC_BS_BURST1_SIZE. */
#define BS_IPU_SMFC_BS_BURST1_SIZE (4U)    /*!< Bit field size in bits for IPU_SMFC_BS_BURST1_SIZE. */

/*! @brief Read current value of the IPU_SMFC_BS_BURST1_SIZE field. */
#define BR_IPU_SMFC_BS_BURST1_SIZE(x) (HW_IPU_SMFC_BS(x).B.BURST1_SIZE)

/*! @brief Format value for bitfield IPU_SMFC_BS_BURST1_SIZE. */
#define BF_IPU_SMFC_BS_BURST1_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_BS_BURST1_SIZE) & BM_IPU_SMFC_BS_BURST1_SIZE)

/*! @brief Set the BURST1_SIZE field to a new value. */
#define BW_IPU_SMFC_BS_BURST1_SIZE(x, v) (HW_IPU_SMFC_BS_WR(x, (HW_IPU_SMFC_BS_RD(x) & ~BM_IPU_SMFC_BS_BURST1_SIZE) | BF_IPU_SMFC_BS_BURST1_SIZE(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_BS, field BURST2_SIZE[11:8] (RW)
 *
 * Burst Size of SMFCDMA channel 2. The value programed here should be
 * BURST_SIZE-1 (for example: for a burst size of 1, write 0 to these bits)
 */
/*@{*/
#define BP_IPU_SMFC_BS_BURST2_SIZE (8U)    /*!< Bit position for IPU_SMFC_BS_BURST2_SIZE. */
#define BM_IPU_SMFC_BS_BURST2_SIZE (0x00000F00U) /*!< Bit mask for IPU_SMFC_BS_BURST2_SIZE. */
#define BS_IPU_SMFC_BS_BURST2_SIZE (4U)    /*!< Bit field size in bits for IPU_SMFC_BS_BURST2_SIZE. */

/*! @brief Read current value of the IPU_SMFC_BS_BURST2_SIZE field. */
#define BR_IPU_SMFC_BS_BURST2_SIZE(x) (HW_IPU_SMFC_BS(x).B.BURST2_SIZE)

/*! @brief Format value for bitfield IPU_SMFC_BS_BURST2_SIZE. */
#define BF_IPU_SMFC_BS_BURST2_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_BS_BURST2_SIZE) & BM_IPU_SMFC_BS_BURST2_SIZE)

/*! @brief Set the BURST2_SIZE field to a new value. */
#define BW_IPU_SMFC_BS_BURST2_SIZE(x, v) (HW_IPU_SMFC_BS_WR(x, (HW_IPU_SMFC_BS_RD(x) & ~BM_IPU_SMFC_BS_BURST2_SIZE) | BF_IPU_SMFC_BS_BURST2_SIZE(v)))
/*@}*/

/*!
 * @name Register IPU_SMFC_BS, field BURST3_SIZE[15:12] (RW)
 *
 * Burst Size of SMFCDMA channel 3. The value programed here should be
 * BURST_SIZE-1 (for example: for a burst size of 1, write 0 to these bits)
 */
/*@{*/
#define BP_IPU_SMFC_BS_BURST3_SIZE (12U)   /*!< Bit position for IPU_SMFC_BS_BURST3_SIZE. */
#define BM_IPU_SMFC_BS_BURST3_SIZE (0x0000F000U) /*!< Bit mask for IPU_SMFC_BS_BURST3_SIZE. */
#define BS_IPU_SMFC_BS_BURST3_SIZE (4U)    /*!< Bit field size in bits for IPU_SMFC_BS_BURST3_SIZE. */

/*! @brief Read current value of the IPU_SMFC_BS_BURST3_SIZE field. */
#define BR_IPU_SMFC_BS_BURST3_SIZE(x) (HW_IPU_SMFC_BS(x).B.BURST3_SIZE)

/*! @brief Format value for bitfield IPU_SMFC_BS_BURST3_SIZE. */
#define BF_IPU_SMFC_BS_BURST3_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_SMFC_BS_BURST3_SIZE) & BM_IPU_SMFC_BS_BURST3_SIZE)

/*! @brief Set the BURST3_SIZE field to a new value. */
#define BW_IPU_SMFC_BS_BURST3_SIZE(x, v) (HW_IPU_SMFC_BS_WR(x, (HW_IPU_SMFC_BS_RD(x) & ~BM_IPU_SMFC_BS_BURST3_SIZE) | BF_IPU_SMFC_BS_BURST3_SIZE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_READ_CH_CONF - DC Read Channel Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_READ_CH_CONF - DC Read Channel Configuration Register (RW)
 *
 * Reset value: 0xFFFF0000U
 */
typedef union _hw_ipu_dc_read_ch_conf
{
    uint32_t U;
    struct _hw_ipu_dc_read_ch_conf_bitfields
    {
        uint32_t RD_CHANNEL_EN : 1;    /*!< [0]  */
        uint32_t PROG_DI_ID_0 : 1;     /*!< [1]  */
        uint32_t PROG_DISP_ID_0 : 2;   /*!< [3:2]  */
        uint32_t W_SIZE_0 : 2;         /*!< [5:4]  */
        uint32_t CHAN_MASK_DEFAULT_0 : 1; /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t CS_ID_0 : 1;          /*!< [8]  */
        uint32_t CS_ID_1 : 1;          /*!< [9]  */
        uint32_t CS_ID_2 : 1;          /*!< [10]  */
        uint32_t CS_ID_3 : 1;          /*!< [11]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t TIME_OUT_VALUE : 16;  /*!< [31:16]  */
    } B;
} hw_ipu_dc_read_ch_conf_t;

/*!
 * @name Constants and macros for entire IPU_DC_READ_CH_CONF register
 */
/*@{*/
#define HW_IPU_DC_READ_CH_CONF_ADDR(x) ((uintptr_t)(x) + 0x58000U)

#define HW_IPU_DC_READ_CH_CONF(x) (*(__IO hw_ipu_dc_read_ch_conf_t *) HW_IPU_DC_READ_CH_CONF_ADDR(x))
#define HW_IPU_DC_READ_CH_CONF_RD(x) (HW_IPU_DC_READ_CH_CONF(x).U)
#define HW_IPU_DC_READ_CH_CONF_WR(x, v) (HW_IPU_DC_READ_CH_CONF(x).U = (v))
#define HW_IPU_DC_READ_CH_CONF_SET(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, HW_IPU_DC_READ_CH_CONF_RD(x) |  (v)))
#define HW_IPU_DC_READ_CH_CONF_CLR(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, HW_IPU_DC_READ_CH_CONF_RD(x) & ~(v)))
#define HW_IPU_DC_READ_CH_CONF_TOG(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, HW_IPU_DC_READ_CH_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_READ_CH_CONF bitfields
 */

/*!
 * @name Register IPU_DC_READ_CH_CONF, field RD_CHANNEL_EN[0] (RW)
 *
 * This bit enables the read channel.
 *
 * Values:
 * - 1 - The Read channel is enabled
 * - 0 - The Read channel is disabled
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN (0U) /*!< Bit position for IPU_DC_READ_CH_CONF_RD_CHANNEL_EN. */
#define BM_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN (0x00000001U) /*!< Bit mask for IPU_DC_READ_CH_CONF_RD_CHANNEL_EN. */
#define BS_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_RD_CHANNEL_EN. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_RD_CHANNEL_EN field. */
#define BR_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN(x) (HW_IPU_DC_READ_CH_CONF(x).B.RD_CHANNEL_EN)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_RD_CHANNEL_EN. */
#define BF_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN) & BM_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN)

/*! @brief Set the RD_CHANNEL_EN field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN) | BF_IPU_DC_READ_CH_CONF_RD_CHANNEL_EN(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field PROG_DI_ID_0[1] (RW)
 *
 * This bit select the DI which a read transaction can be performed through
 *
 * Values:
 * - 1 - DI #1
 * - 0 - DI #0
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_PROG_DI_ID_0 (1U) /*!< Bit position for IPU_DC_READ_CH_CONF_PROG_DI_ID_0. */
#define BM_IPU_DC_READ_CH_CONF_PROG_DI_ID_0 (0x00000002U) /*!< Bit mask for IPU_DC_READ_CH_CONF_PROG_DI_ID_0. */
#define BS_IPU_DC_READ_CH_CONF_PROG_DI_ID_0 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_PROG_DI_ID_0. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_PROG_DI_ID_0 field. */
#define BR_IPU_DC_READ_CH_CONF_PROG_DI_ID_0(x) (HW_IPU_DC_READ_CH_CONF(x).B.PROG_DI_ID_0)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_PROG_DI_ID_0. */
#define BF_IPU_DC_READ_CH_CONF_PROG_DI_ID_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_PROG_DI_ID_0) & BM_IPU_DC_READ_CH_CONF_PROG_DI_ID_0)

/*! @brief Set the PROG_DI_ID_0 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_PROG_DI_ID_0(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_PROG_DI_ID_0) | BF_IPU_DC_READ_CH_CONF_PROG_DI_ID_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field PROG_DISP_ID_0[3:2] (RW)
 *
 * The field defines which one of the 4 displays can be read.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0 (2U) /*!< Bit position for IPU_DC_READ_CH_CONF_PROG_DISP_ID_0. */
#define BM_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0 (0x0000000CU) /*!< Bit mask for IPU_DC_READ_CH_CONF_PROG_DISP_ID_0. */
#define BS_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0 (2U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_PROG_DISP_ID_0. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_PROG_DISP_ID_0 field. */
#define BR_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0(x) (HW_IPU_DC_READ_CH_CONF(x).B.PROG_DISP_ID_0)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_PROG_DISP_ID_0. */
#define BF_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0) & BM_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0)

/*! @brief Set the PROG_DISP_ID_0 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0) | BF_IPU_DC_READ_CH_CONF_PROG_DISP_ID_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field W_SIZE_0[5:4] (RW)
 *
 * Word Size The data coming from the IDMAC is 32bit wide. This field defines
 * the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_W_SIZE_0 (4U) /*!< Bit position for IPU_DC_READ_CH_CONF_W_SIZE_0. */
#define BM_IPU_DC_READ_CH_CONF_W_SIZE_0 (0x00000030U) /*!< Bit mask for IPU_DC_READ_CH_CONF_W_SIZE_0. */
#define BS_IPU_DC_READ_CH_CONF_W_SIZE_0 (2U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_W_SIZE_0. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_W_SIZE_0 field. */
#define BR_IPU_DC_READ_CH_CONF_W_SIZE_0(x) (HW_IPU_DC_READ_CH_CONF(x).B.W_SIZE_0)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_W_SIZE_0. */
#define BF_IPU_DC_READ_CH_CONF_W_SIZE_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_W_SIZE_0) & BM_IPU_DC_READ_CH_CONF_W_SIZE_0)

/*! @brief Set the W_SIZE_0 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_W_SIZE_0(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_W_SIZE_0) | BF_IPU_DC_READ_CH_CONF_W_SIZE_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field CHAN_MASK_DEFAULT_0[6] (RW)
 *
 * Event mask bit for the read channel When more then one event is used during a
 * flow (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event
 * that is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0 (6U) /*!< Bit position for IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0. */
#define BM_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0 (0x00000040U) /*!< Bit mask for IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0. */
#define BS_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0 field. */
#define BR_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0(x) (HW_IPU_DC_READ_CH_CONF(x).B.CHAN_MASK_DEFAULT_0)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0. */
#define BF_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0) & BM_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0)

/*! @brief Set the CHAN_MASK_DEFAULT_0 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0) | BF_IPU_DC_READ_CH_CONF_CHAN_MASK_DEFAULT_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field CS_ID_0[8] (RW)
 *
 * This bit maps an asynchronous display to a chip select
 *
 * Values:
 * - 1 - display #0 is connected to CS1
 * - 0 - display #0 is connected to CS0
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_CS_ID_0 (8U) /*!< Bit position for IPU_DC_READ_CH_CONF_CS_ID_0. */
#define BM_IPU_DC_READ_CH_CONF_CS_ID_0 (0x00000100U) /*!< Bit mask for IPU_DC_READ_CH_CONF_CS_ID_0. */
#define BS_IPU_DC_READ_CH_CONF_CS_ID_0 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_CS_ID_0. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_CS_ID_0 field. */
#define BR_IPU_DC_READ_CH_CONF_CS_ID_0(x) (HW_IPU_DC_READ_CH_CONF(x).B.CS_ID_0)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_CS_ID_0. */
#define BF_IPU_DC_READ_CH_CONF_CS_ID_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_CS_ID_0) & BM_IPU_DC_READ_CH_CONF_CS_ID_0)

/*! @brief Set the CS_ID_0 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_CS_ID_0(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_CS_ID_0) | BF_IPU_DC_READ_CH_CONF_CS_ID_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field CS_ID_1[9] (RW)
 *
 * This bit maps an asynchronous display to a chip select
 *
 * Values:
 * - 1 - display #1 is connected to CS1
 * - 0 - display #1 is connected to CS0
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_CS_ID_1 (9U) /*!< Bit position for IPU_DC_READ_CH_CONF_CS_ID_1. */
#define BM_IPU_DC_READ_CH_CONF_CS_ID_1 (0x00000200U) /*!< Bit mask for IPU_DC_READ_CH_CONF_CS_ID_1. */
#define BS_IPU_DC_READ_CH_CONF_CS_ID_1 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_CS_ID_1. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_CS_ID_1 field. */
#define BR_IPU_DC_READ_CH_CONF_CS_ID_1(x) (HW_IPU_DC_READ_CH_CONF(x).B.CS_ID_1)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_CS_ID_1. */
#define BF_IPU_DC_READ_CH_CONF_CS_ID_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_CS_ID_1) & BM_IPU_DC_READ_CH_CONF_CS_ID_1)

/*! @brief Set the CS_ID_1 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_CS_ID_1(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_CS_ID_1) | BF_IPU_DC_READ_CH_CONF_CS_ID_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field CS_ID_2[10] (RW)
 *
 * This bit maps an asynchronous display to a chip select
 *
 * Values:
 * - 1 - display #2 is connected to CS1
 * - 0 - display #2 is connected to CS0
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_CS_ID_2 (10U) /*!< Bit position for IPU_DC_READ_CH_CONF_CS_ID_2. */
#define BM_IPU_DC_READ_CH_CONF_CS_ID_2 (0x00000400U) /*!< Bit mask for IPU_DC_READ_CH_CONF_CS_ID_2. */
#define BS_IPU_DC_READ_CH_CONF_CS_ID_2 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_CS_ID_2. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_CS_ID_2 field. */
#define BR_IPU_DC_READ_CH_CONF_CS_ID_2(x) (HW_IPU_DC_READ_CH_CONF(x).B.CS_ID_2)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_CS_ID_2. */
#define BF_IPU_DC_READ_CH_CONF_CS_ID_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_CS_ID_2) & BM_IPU_DC_READ_CH_CONF_CS_ID_2)

/*! @brief Set the CS_ID_2 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_CS_ID_2(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_CS_ID_2) | BF_IPU_DC_READ_CH_CONF_CS_ID_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field CS_ID_3[11] (RW)
 *
 * This bit maps an asynchronous display to a chip select
 *
 * Values:
 * - 1 - display #3 is connected to CS1
 * - 0 - display #3 is connected to CS0
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_CS_ID_3 (11U) /*!< Bit position for IPU_DC_READ_CH_CONF_CS_ID_3. */
#define BM_IPU_DC_READ_CH_CONF_CS_ID_3 (0x00000800U) /*!< Bit mask for IPU_DC_READ_CH_CONF_CS_ID_3. */
#define BS_IPU_DC_READ_CH_CONF_CS_ID_3 (1U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_CS_ID_3. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_CS_ID_3 field. */
#define BR_IPU_DC_READ_CH_CONF_CS_ID_3(x) (HW_IPU_DC_READ_CH_CONF(x).B.CS_ID_3)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_CS_ID_3. */
#define BF_IPU_DC_READ_CH_CONF_CS_ID_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_CS_ID_3) & BM_IPU_DC_READ_CH_CONF_CS_ID_3)

/*! @brief Set the CS_ID_3 field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_CS_ID_3(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_CS_ID_3) | BF_IPU_DC_READ_CH_CONF_CS_ID_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_READ_CH_CONF, field TIME_OUT_VALUE[31:16] (RW)
 *
 * Time out value. In case of a error during read accesses to the display, where
 * no response from the display was received. A time-out counter will terminate
 * the current access and perform the next commend defined in the microcode. This
 * field defines the amount of the hsp_clk cycles counted before the time-out
 * event is issued. This event is tied to the interrupt controller and can generate
 * an error interrupt.
 */
/*@{*/
#define BP_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE (16U) /*!< Bit position for IPU_DC_READ_CH_CONF_TIME_OUT_VALUE. */
#define BM_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE (0xFFFF0000U) /*!< Bit mask for IPU_DC_READ_CH_CONF_TIME_OUT_VALUE. */
#define BS_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE (16U) /*!< Bit field size in bits for IPU_DC_READ_CH_CONF_TIME_OUT_VALUE. */

/*! @brief Read current value of the IPU_DC_READ_CH_CONF_TIME_OUT_VALUE field. */
#define BR_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE(x) (HW_IPU_DC_READ_CH_CONF(x).B.TIME_OUT_VALUE)

/*! @brief Format value for bitfield IPU_DC_READ_CH_CONF_TIME_OUT_VALUE. */
#define BF_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE) & BM_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE)

/*! @brief Set the TIME_OUT_VALUE field to a new value. */
#define BW_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE(x, v) (HW_IPU_DC_READ_CH_CONF_WR(x, (HW_IPU_DC_READ_CH_CONF_RD(x) & ~BM_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE) | BF_IPU_DC_READ_CH_CONF_TIME_OUT_VALUE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_READ_SH_ADDR - DC Read Channel Start Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_READ_SH_ADDR - DC Read Channel Start Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_read_sh_addr
{
    uint32_t U;
    struct _hw_ipu_dc_read_sh_addr_bitfields
    {
        uint32_t ST_ADDR_0 : 29;       /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_read_sh_addr_t;

/*!
 * @name Constants and macros for entire IPU_DC_READ_SH_ADDR register
 */
/*@{*/
#define HW_IPU_DC_READ_SH_ADDR_ADDR(x) ((uintptr_t)(x) + 0x58004U)

#define HW_IPU_DC_READ_SH_ADDR(x) (*(__IO hw_ipu_dc_read_sh_addr_t *) HW_IPU_DC_READ_SH_ADDR_ADDR(x))
#define HW_IPU_DC_READ_SH_ADDR_RD(x) (HW_IPU_DC_READ_SH_ADDR(x).U)
#define HW_IPU_DC_READ_SH_ADDR_WR(x, v) (HW_IPU_DC_READ_SH_ADDR(x).U = (v))
#define HW_IPU_DC_READ_SH_ADDR_SET(x, v) (HW_IPU_DC_READ_SH_ADDR_WR(x, HW_IPU_DC_READ_SH_ADDR_RD(x) |  (v)))
#define HW_IPU_DC_READ_SH_ADDR_CLR(x, v) (HW_IPU_DC_READ_SH_ADDR_WR(x, HW_IPU_DC_READ_SH_ADDR_RD(x) & ~(v)))
#define HW_IPU_DC_READ_SH_ADDR_TOG(x, v) (HW_IPU_DC_READ_SH_ADDR_WR(x, HW_IPU_DC_READ_SH_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_READ_SH_ADDR bitfields
 */

/*!
 * @name Register IPU_DC_READ_SH_ADDR, field ST_ADDR_0[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the read transactions will be done from.
 */
/*@{*/
#define BP_IPU_DC_READ_SH_ADDR_ST_ADDR_0 (0U) /*!< Bit position for IPU_DC_READ_SH_ADDR_ST_ADDR_0. */
#define BM_IPU_DC_READ_SH_ADDR_ST_ADDR_0 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_READ_SH_ADDR_ST_ADDR_0. */
#define BS_IPU_DC_READ_SH_ADDR_ST_ADDR_0 (29U) /*!< Bit field size in bits for IPU_DC_READ_SH_ADDR_ST_ADDR_0. */

/*! @brief Read current value of the IPU_DC_READ_SH_ADDR_ST_ADDR_0 field. */
#define BR_IPU_DC_READ_SH_ADDR_ST_ADDR_0(x) (HW_IPU_DC_READ_SH_ADDR(x).B.ST_ADDR_0)

/*! @brief Format value for bitfield IPU_DC_READ_SH_ADDR_ST_ADDR_0. */
#define BF_IPU_DC_READ_SH_ADDR_ST_ADDR_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_READ_SH_ADDR_ST_ADDR_0) & BM_IPU_DC_READ_SH_ADDR_ST_ADDR_0)

/*! @brief Set the ST_ADDR_0 field to a new value. */
#define BW_IPU_DC_READ_SH_ADDR_ST_ADDR_0(x, v) (HW_IPU_DC_READ_SH_ADDR_WR(x, (HW_IPU_DC_READ_SH_ADDR_RD(x) & ~BM_IPU_DC_READ_SH_ADDR_ST_ADDR_0) | BF_IPU_DC_READ_SH_ADDR_ST_ADDR_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL0_CH_0 - DC Routine Link Register 0 Channel 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL0_CH_0 - DC Routine Link Register 0 Channel 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl0_ch_0
{
    uint32_t U;
    struct _hw_ipu_dc_rl0_ch_0_bitfields
    {
        uint32_t COD_NF_PRIORITY_CHAN_0 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NF_START_CHAN_0 : 8; /*!< [15:8]  */
        uint32_t COD_NL_PRIORITY_CHAN_0 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NL_START_CHAN_0 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl0_ch_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL0_CH_0 register
 */
/*@{*/
#define HW_IPU_DC_RL0_CH_0_ADDR(x) ((uintptr_t)(x) + 0x58008U)

#define HW_IPU_DC_RL0_CH_0(x)    (*(__IO hw_ipu_dc_rl0_ch_0_t *) HW_IPU_DC_RL0_CH_0_ADDR(x))
#define HW_IPU_DC_RL0_CH_0_RD(x) (HW_IPU_DC_RL0_CH_0(x).U)
#define HW_IPU_DC_RL0_CH_0_WR(x, v) (HW_IPU_DC_RL0_CH_0(x).U = (v))
#define HW_IPU_DC_RL0_CH_0_SET(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, HW_IPU_DC_RL0_CH_0_RD(x) |  (v)))
#define HW_IPU_DC_RL0_CH_0_CLR(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, HW_IPU_DC_RL0_CH_0_RD(x) & ~(v)))
#define HW_IPU_DC_RL0_CH_0_TOG(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, HW_IPU_DC_RL0_CH_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL0_CH_0 bitfields
 */

/*!
 * @name Register IPU_DC_RL0_CH_0, field COD_NF_PRIORITY_CHAN_0[3:0] (RW)
 *
 * This field defines the priority of the new frame (NF) event The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0 (0U) /*!< Bit position for IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0 (0x0000000FU) /*!< Bit mask for IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL0_CH_0(x).B.COD_NF_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0) & BM_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0)

/*! @brief Set the COD_NF_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, (HW_IPU_DC_RL0_CH_0_RD(x) & ~BM_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0) | BF_IPU_DC_RL0_CH_0_COD_NF_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_0, field COD_NF_START_CHAN_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new Frame event (NF) resides
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0 (8U) /*!< Bit position for IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0. */
#define BM_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0. */
#define BS_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0 field. */
#define BR_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0(x) (HW_IPU_DC_RL0_CH_0(x).B.COD_NF_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0. */
#define BF_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0) & BM_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0)

/*! @brief Set the COD_NF_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, (HW_IPU_DC_RL0_CH_0_RD(x) & ~BM_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0) | BF_IPU_DC_RL0_CH_0_COD_NF_START_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_0, field COD_NL_PRIORITY_CHAN_0[19:16] (RW)
 *
 * This field defines the priority of the new line (NL) event The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0 (16U) /*!< Bit position for IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0 (0x000F0000U) /*!< Bit mask for IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL0_CH_0(x).B.COD_NL_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0) & BM_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0)

/*! @brief Set the COD_NL_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, (HW_IPU_DC_RL0_CH_0_RD(x) & ~BM_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0) | BF_IPU_DC_RL0_CH_0_COD_NL_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_0, field COD_NL_START_CHAN_0[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new line event (NL) resides
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0 (24U) /*!< Bit position for IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0. */
#define BM_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0 (0xFF000000U) /*!< Bit mask for IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0. */
#define BS_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0 field. */
#define BR_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0(x) (HW_IPU_DC_RL0_CH_0(x).B.COD_NL_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0. */
#define BF_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0) & BM_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0)

/*! @brief Set the COD_NL_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0(x, v) (HW_IPU_DC_RL0_CH_0_WR(x, (HW_IPU_DC_RL0_CH_0_RD(x) & ~BM_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0) | BF_IPU_DC_RL0_CH_0_COD_NL_START_CHAN_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_0 - DC Routine Link Register 1 Channel 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_0 - DC Routine Link Register 1 Channel 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_0
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_0_bitfields
    {
        uint32_t COD_EOF_PRIORITY_CHAN_0 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOF_START_CHAN_0 : 8; /*!< [15:8]  */
        uint32_t COD_NFIELD_PRIORITY_CHAN_0 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NFIELD_START_CHAN_0 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_0 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_0_ADDR(x) ((uintptr_t)(x) + 0x5800CU)

#define HW_IPU_DC_RL1_CH_0(x)    (*(__IO hw_ipu_dc_rl1_ch_0_t *) HW_IPU_DC_RL1_CH_0_ADDR(x))
#define HW_IPU_DC_RL1_CH_0_RD(x) (HW_IPU_DC_RL1_CH_0(x).U)
#define HW_IPU_DC_RL1_CH_0_WR(x, v) (HW_IPU_DC_RL1_CH_0(x).U = (v))
#define HW_IPU_DC_RL1_CH_0_SET(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, HW_IPU_DC_RL1_CH_0_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_0_CLR(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, HW_IPU_DC_RL1_CH_0_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_0_TOG(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, HW_IPU_DC_RL1_CH_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_0 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_0, field COD_EOF_PRIORITY_CHAN_0[3:0] (RW)
 *
 * This field defines the priority of the end-of-frame event (EOF) event The
 * priority between the events should be set to a unique value. i.e. two events must
 * not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0 (0U) /*!< Bit position for IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL1_CH_0(x).B.COD_EOF_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0) & BM_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0)

/*! @brief Set the COD_EOF_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, (HW_IPU_DC_RL1_CH_0_RD(x) & ~BM_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0) | BF_IPU_DC_RL1_CH_0_COD_EOF_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_0, field COD_EOF_START_CHAN_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end-of-frame event (EOF) resides
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0 (8U) /*!< Bit position for IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0. */
#define BM_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0. */
#define BS_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0 field. */
#define BR_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0(x) (HW_IPU_DC_RL1_CH_0(x).B.COD_EOF_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0. */
#define BF_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0) & BM_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0)

/*! @brief Set the COD_EOF_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, (HW_IPU_DC_RL1_CH_0_RD(x) & ~BM_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0) | BF_IPU_DC_RL1_CH_0_COD_EOF_START_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_0, field COD_NFIELD_PRIORITY_CHAN_0[19:16] (RW)
 *
 * This field defines the priority of the new field event The priority between
 * the events should be set to a unique value. i.e. two events must not have the
 * same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0 (16U) /*!< Bit position for IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0 (0x000F0000U) /*!< Bit mask for IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL1_CH_0(x).B.COD_NFIELD_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0) & BM_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0)

/*! @brief Set the COD_NFIELD_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, (HW_IPU_DC_RL1_CH_0_RD(x) & ~BM_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0) | BF_IPU_DC_RL1_CH_0_COD_NFIELD_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_0, field COD_NFIELD_START_CHAN_0[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new field event resides
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0 (24U) /*!< Bit position for IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0. */
#define BM_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0. */
#define BS_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0 field. */
#define BR_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0(x) (HW_IPU_DC_RL1_CH_0(x).B.COD_NFIELD_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0. */
#define BF_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0) & BM_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0)

/*! @brief Set the COD_NFIELD_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0(x, v) (HW_IPU_DC_RL1_CH_0_WR(x, (HW_IPU_DC_RL1_CH_0_RD(x) & ~BM_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0) | BF_IPU_DC_RL1_CH_0_COD_NFIELD_START_CHAN_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_0 - DC Routine Link Register2 Channel 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_0 - DC Routine Link Register2 Channel 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_0
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_0_bitfields
    {
        uint32_t COD_EOL_PRIORITY_CHAN_0 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOL_START_CHAN_0 : 8; /*!< [15:8]  */
        uint32_t COD_EOFIELD_PRIORITY_CHAN_0 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_EOFIELD_START_CHAN_0 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_0 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_0_ADDR(x) ((uintptr_t)(x) + 0x58010U)

#define HW_IPU_DC_RL2_CH_0(x)    (*(__IO hw_ipu_dc_rl2_ch_0_t *) HW_IPU_DC_RL2_CH_0_ADDR(x))
#define HW_IPU_DC_RL2_CH_0_RD(x) (HW_IPU_DC_RL2_CH_0(x).U)
#define HW_IPU_DC_RL2_CH_0_WR(x, v) (HW_IPU_DC_RL2_CH_0(x).U = (v))
#define HW_IPU_DC_RL2_CH_0_SET(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, HW_IPU_DC_RL2_CH_0_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_0_CLR(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, HW_IPU_DC_RL2_CH_0_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_0_TOG(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, HW_IPU_DC_RL2_CH_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_0 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_0, field COD_EOL_PRIORITY_CHAN_0[3:0] (RW)
 *
 * This field defines the priority of the end-of-line event (EOL) event The
 * priority between the events should be set to a unique value. i.e. two events must
 * not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0 (0U) /*!< Bit position for IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL2_CH_0(x).B.COD_EOL_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0) & BM_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0)

/*! @brief Set the COD_EOL_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, (HW_IPU_DC_RL2_CH_0_RD(x) & ~BM_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0) | BF_IPU_DC_RL2_CH_0_COD_EOL_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_0, field COD_EOL_START_CHAN_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end-of-line event (EOL) resides
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0 (8U) /*!< Bit position for IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0. */
#define BM_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0. */
#define BS_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0 field. */
#define BR_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0(x) (HW_IPU_DC_RL2_CH_0(x).B.COD_EOL_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0. */
#define BF_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0) & BM_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0)

/*! @brief Set the COD_EOL_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, (HW_IPU_DC_RL2_CH_0_RD(x) & ~BM_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0) | BF_IPU_DC_RL2_CH_0_COD_EOL_START_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_0, field COD_EOFIELD_PRIORITY_CHAN_0[19:16] (RW)
 *
 * This field defines the priority of the end-of-field event The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0 (16U) /*!< Bit position for IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0 (0x000F0000U) /*!< Bit mask for IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL2_CH_0(x).B.COD_EOFIELD_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0) & BM_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0)

/*! @brief Set the COD_EOFIELD_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, (HW_IPU_DC_RL2_CH_0_RD(x) & ~BM_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0) | BF_IPU_DC_RL2_CH_0_COD_EOFIELD_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_0, field COD_EOFIELD_START_CHAN_0[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end-of-field event resides
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0 (24U) /*!< Bit position for IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0. */
#define BM_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0. */
#define BS_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0 field. */
#define BR_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0(x) (HW_IPU_DC_RL2_CH_0(x).B.COD_EOFIELD_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0. */
#define BF_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0) & BM_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0)

/*! @brief Set the COD_EOFIELD_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0(x, v) (HW_IPU_DC_RL2_CH_0_WR(x, (HW_IPU_DC_RL2_CH_0_RD(x) & ~BM_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0) | BF_IPU_DC_RL2_CH_0_COD_EOFIELD_START_CHAN_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_0 - DC Routine Link Registe3 Channel 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_0 - DC Routine Link Registe3 Channel 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_0
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_0_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_0 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_0 : 8; /*!< [15:8]  */
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_0 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NEW_CHAN_START_CHAN_0 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_0 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_0_ADDR(x) ((uintptr_t)(x) + 0x58014U)

#define HW_IPU_DC_RL3_CH_0(x)    (*(__IO hw_ipu_dc_rl3_ch_0_t *) HW_IPU_DC_RL3_CH_0_ADDR(x))
#define HW_IPU_DC_RL3_CH_0_RD(x) (HW_IPU_DC_RL3_CH_0(x).U)
#define HW_IPU_DC_RL3_CH_0_WR(x, v) (HW_IPU_DC_RL3_CH_0(x).U = (v))
#define HW_IPU_DC_RL3_CH_0_SET(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, HW_IPU_DC_RL3_CH_0_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_0_CLR(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, HW_IPU_DC_RL3_CH_0_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_0_TOG(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, HW_IPU_DC_RL3_CH_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_0 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_0, field COD_NEW_ADDR_PRIORITY_CHAN_0[3:0] (RW)
 *
 * This field defines the priority of the new address event The priority between
 * the events should be set to a unique value. i.e. two events must not have the
 * same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0 (0U) /*!< Bit position for IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL3_CH_0(x).B.COD_NEW_ADDR_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0) & BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, (HW_IPU_DC_RL3_CH_0_RD(x) & ~BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0) | BF_IPU_DC_RL3_CH_0_COD_NEW_ADDR_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_0, field COD_NEW_ADDR_START_CHAN_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0 (8U) /*!< Bit position for IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0. */
#define BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0. */
#define BS_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0 field. */
#define BR_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0(x) (HW_IPU_DC_RL3_CH_0(x).B.COD_NEW_ADDR_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0. */
#define BF_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0) & BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, (HW_IPU_DC_RL3_CH_0_RD(x) & ~BM_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0) | BF_IPU_DC_RL3_CH_0_COD_NEW_ADDR_START_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_0, field COD_NEW_CHAN_PRIORITY_CHAN_0[19:16] (RW)
 *
 * This field defines the priority of the new channel event The priority between
 * the events should be set to a unique value. i.e. two events must not have the
 * same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0 (16U) /*!< Bit position for IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0 (0x000F0000U) /*!< Bit mask for IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL3_CH_0(x).B.COD_NEW_CHAN_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0) & BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, (HW_IPU_DC_RL3_CH_0_RD(x) & ~BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0) | BF_IPU_DC_RL3_CH_0_COD_NEW_CHAN_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_0, field COD_NEW_CHAN_START_CHAN_0[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0 (24U) /*!< Bit position for IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0. */
#define BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0. */
#define BS_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0 field. */
#define BR_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0(x) (HW_IPU_DC_RL3_CH_0(x).B.COD_NEW_CHAN_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0. */
#define BF_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0) & BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0(x, v) (HW_IPU_DC_RL3_CH_0_WR(x, (HW_IPU_DC_RL3_CH_0_RD(x) & ~BM_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0) | BF_IPU_DC_RL3_CH_0_COD_NEW_CHAN_START_CHAN_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_0 - DC Routine Link Register 4 Channel 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_0 - DC Routine Link Register 4 Channel 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_0
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_0_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_0 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dc_rl4_ch_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_0 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_0_ADDR(x) ((uintptr_t)(x) + 0x58018U)

#define HW_IPU_DC_RL4_CH_0(x)    (*(__IO hw_ipu_dc_rl4_ch_0_t *) HW_IPU_DC_RL4_CH_0_ADDR(x))
#define HW_IPU_DC_RL4_CH_0_RD(x) (HW_IPU_DC_RL4_CH_0(x).U)
#define HW_IPU_DC_RL4_CH_0_WR(x, v) (HW_IPU_DC_RL4_CH_0(x).U = (v))
#define HW_IPU_DC_RL4_CH_0_SET(x, v) (HW_IPU_DC_RL4_CH_0_WR(x, HW_IPU_DC_RL4_CH_0_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_0_CLR(x, v) (HW_IPU_DC_RL4_CH_0_WR(x, HW_IPU_DC_RL4_CH_0_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_0_TOG(x, v) (HW_IPU_DC_RL4_CH_0_WR(x, HW_IPU_DC_RL4_CH_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_0 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_0, field COD_NEW_DATA_PRIORITY_CHAN_0[3:0] (RW)
 *
 * This field defines the priority of the new data event The priority between
 * the events should be set to a unique value. i.e. two events must not have the
 * same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0 (0U) /*!< Bit position for IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0. */
#define BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0 (0x0000000FU) /*!< Bit mask for IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0. */
#define BS_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0 (4U) /*!< Bit field size in bits for IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0 field. */
#define BR_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0(x) (HW_IPU_DC_RL4_CH_0(x).B.COD_NEW_DATA_PRIORITY_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0. */
#define BF_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0) & BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0(x, v) (HW_IPU_DC_RL4_CH_0_WR(x, (HW_IPU_DC_RL4_CH_0_RD(x) & ~BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0) | BF_IPU_DC_RL4_CH_0_COD_NEW_DATA_PRIORITY_CHAN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_0, field COD_NEW_DATA_START_CHAN_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0 (8U) /*!< Bit position for IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0. */
#define BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0. */
#define BS_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0. */

/*! @brief Read current value of the IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0 field. */
#define BR_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0(x) (HW_IPU_DC_RL4_CH_0(x).B.COD_NEW_DATA_START_CHAN_0)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0. */
#define BF_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0) & BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0)

/*! @brief Set the COD_NEW_DATA_START_CHAN_0 field to a new value. */
#define BW_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0(x, v) (HW_IPU_DC_RL4_CH_0_WR(x, (HW_IPU_DC_RL4_CH_0_RD(x) & ~BM_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0) | BF_IPU_DC_RL4_CH_0_COD_NEW_DATA_START_CHAN_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF_1 - DC Write Channel 1 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF_1 - DC Write Channel 1 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf_1
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf_1_bitfields
    {
        uint32_t W_SIZE_1 : 2;         /*!< [1:0]  */
        uint32_t PROG_DI_ID_1 : 1;     /*!< [2]  */
        uint32_t PROG_DISP_ID_1 : 2;   /*!< [4:3]  */
        uint32_t PROG_CHAN_TYP_1 : 3;  /*!< [7:5]  */
        uint32_t CHAN_MASK_DEFAULT_1 : 1; /*!< [8]  */
        uint32_t FIELD_MODE_1 : 1;     /*!< [9]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t PROG_START_TIME_1 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dc_wr_ch_conf_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF_1 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF_1_ADDR(x) ((uintptr_t)(x) + 0x5801CU)

#define HW_IPU_DC_WR_CH_CONF_1(x) (*(__IO hw_ipu_dc_wr_ch_conf_1_t *) HW_IPU_DC_WR_CH_CONF_1_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF_1_RD(x) (HW_IPU_DC_WR_CH_CONF_1(x).U)
#define HW_IPU_DC_WR_CH_CONF_1_WR(x, v) (HW_IPU_DC_WR_CH_CONF_1(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF_1_SET(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, HW_IPU_DC_WR_CH_CONF_1_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF_1_CLR(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF_1_TOG(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, HW_IPU_DC_WR_CH_CONF_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF_1 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field W_SIZE_1[1:0] (RW)
 *
 * Word Size associated with channel #1 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_W_SIZE_1 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_W_SIZE_1. */
#define BM_IPU_DC_WR_CH_CONF_1_W_SIZE_1 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_W_SIZE_1. */
#define BS_IPU_DC_WR_CH_CONF_1_W_SIZE_1 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_W_SIZE_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_W_SIZE_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_W_SIZE_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.W_SIZE_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_W_SIZE_1. */
#define BF_IPU_DC_WR_CH_CONF_1_W_SIZE_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_W_SIZE_1) & BM_IPU_DC_WR_CH_CONF_1_W_SIZE_1)

/*! @brief Set the W_SIZE_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_W_SIZE_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_W_SIZE_1) | BF_IPU_DC_WR_CH_CONF_1_W_SIZE_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field PROG_DI_ID_1[2] (RW)
 *
 * This bit select the DI which a transaction associated with channel #1 can be
 * performed to
 *
 * Values:
 * - 1 - DI #1
 * - 0 - DI #0
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1. */
#define BM_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1. */
#define BS_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.PROG_DI_ID_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1. */
#define BF_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1) & BM_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1)

/*! @brief Set the PROG_DI_ID_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1) | BF_IPU_DC_WR_CH_CONF_1_PROG_DI_ID_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field PROG_DISP_ID_1[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #1.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1. */
#define BM_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1. */
#define BS_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.PROG_DISP_ID_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1. */
#define BF_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1) & BM_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1)

/*! @brief Set the PROG_DISP_ID_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1) | BF_IPU_DC_WR_CH_CONF_1_PROG_DISP_ID_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field PROG_CHAN_TYP_1[7:5] (RW)
 *
 * This field define the mode of operation of channel #1
 *
 * Values:
 * - 000 - Disable
 * - 001 - Reserved
 * - 010 - Reserved
 * - 100 - Normal mode without anti-tearing. For sync display this is the only
 *     mode allowed
 * - 101 - Normal mode with anti-tearing
 * - 110 - Reserved
 * - 111 - Additional command channel is added to the flow handled by DC channel
 *     #1
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1 (5U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1. */
#define BM_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1 (0x000000E0U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1. */
#define BS_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1 (3U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.PROG_CHAN_TYP_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1. */
#define BF_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1) & BM_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1)

/*! @brief Set the PROG_CHAN_TYP_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1) | BF_IPU_DC_WR_CH_CONF_1_PROG_CHAN_TYP_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field CHAN_MASK_DEFAULT_1[8] (RW)
 *
 * Event mask bit for channel #1 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1 (8U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1. */
#define BM_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1 (0x00000100U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1. */
#define BS_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.CHAN_MASK_DEFAULT_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1. */
#define BF_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1) & BM_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1)

/*! @brief Set the CHAN_MASK_DEFAULT_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1) | BF_IPU_DC_WR_CH_CONF_1_CHAN_MASK_DEFAULT_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field FIELD_MODE_1[9] (RW)
 *
 * Field mode bit for channel #1 This bit defines if the channel works in field
 * mode or frame mode; This bit is relevant if the flow is sync flow
 *
 * Values:
 * - 1 - Field mode
 * - 0 - Frame mode
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1 (9U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_FIELD_MODE_1. */
#define BM_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1 (0x00000200U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_FIELD_MODE_1. */
#define BS_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_FIELD_MODE_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_FIELD_MODE_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.FIELD_MODE_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_FIELD_MODE_1. */
#define BF_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1) & BM_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1)

/*! @brief Set the FIELD_MODE_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1) | BF_IPU_DC_WR_CH_CONF_1_FIELD_MODE_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_1, field PROG_START_TIME_1[26:16] (RW)
 *
 * This field defines the delay between display 's vertical synchronization
 * pulse and the start time point of DC's channel 1 window. The delay is defined in
 * pairs of rows. It is used for tearing elimination
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1 (16U) /*!< Bit position for IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1. */
#define BM_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1 (0x07FF0000U) /*!< Bit mask for IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1. */
#define BS_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1 (11U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1 field. */
#define BR_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1(x) (HW_IPU_DC_WR_CH_CONF_1(x).B.PROG_START_TIME_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1. */
#define BF_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1) & BM_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1)

/*! @brief Set the PROG_START_TIME_1 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1(x, v) (HW_IPU_DC_WR_CH_CONF_1_WR(x, (HW_IPU_DC_WR_CH_CONF_1_RD(x) & ~BM_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1) | BF_IPU_DC_WR_CH_CONF_1_PROG_START_TIME_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_ADDR_1 - DC Write Channel 1 Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_ADDR_1 - DC Write Channel 1 Address Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_addr_1
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_addr_1_bitfields
    {
        uint32_t ST_ADDR_1 : 29;       /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_addr_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_ADDR_1 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_ADDR_1_ADDR(x) ((uintptr_t)(x) + 0x58020U)

#define HW_IPU_DC_WR_CH_ADDR_1(x) (*(__IO hw_ipu_dc_wr_ch_addr_1_t *) HW_IPU_DC_WR_CH_ADDR_1_ADDR(x))
#define HW_IPU_DC_WR_CH_ADDR_1_RD(x) (HW_IPU_DC_WR_CH_ADDR_1(x).U)
#define HW_IPU_DC_WR_CH_ADDR_1_WR(x, v) (HW_IPU_DC_WR_CH_ADDR_1(x).U = (v))
#define HW_IPU_DC_WR_CH_ADDR_1_SET(x, v) (HW_IPU_DC_WR_CH_ADDR_1_WR(x, HW_IPU_DC_WR_CH_ADDR_1_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_ADDR_1_CLR(x, v) (HW_IPU_DC_WR_CH_ADDR_1_WR(x, HW_IPU_DC_WR_CH_ADDR_1_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_ADDR_1_TOG(x, v) (HW_IPU_DC_WR_CH_ADDR_1_WR(x, HW_IPU_DC_WR_CH_ADDR_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_ADDR_1 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_ADDR_1, field ST_ADDR_1[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the write transactions will be done to for channel #1.
 */
/*@{*/
#define BP_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1 (0U) /*!< Bit position for IPU_DC_WR_CH_ADDR_1_ST_ADDR_1. */
#define BM_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_ADDR_1_ST_ADDR_1. */
#define BS_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_ADDR_1_ST_ADDR_1. */

/*! @brief Read current value of the IPU_DC_WR_CH_ADDR_1_ST_ADDR_1 field. */
#define BR_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1(x) (HW_IPU_DC_WR_CH_ADDR_1(x).B.ST_ADDR_1)

/*! @brief Format value for bitfield IPU_DC_WR_CH_ADDR_1_ST_ADDR_1. */
#define BF_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1) & BM_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1)

/*! @brief Set the ST_ADDR_1 field to a new value. */
#define BW_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1(x, v) (HW_IPU_DC_WR_CH_ADDR_1_WR(x, (HW_IPU_DC_WR_CH_ADDR_1_RD(x) & ~BM_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1) | BF_IPU_DC_WR_CH_ADDR_1_ST_ADDR_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL0_CH_1 - DC Routine Link Register 0 Channel 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL0_CH_1 - DC Routine Link Register 0 Channel 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl0_ch_1
{
    uint32_t U;
    struct _hw_ipu_dc_rl0_ch_1_bitfields
    {
        uint32_t COD_NF_PRIORITY_CHAN_1 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NF_START_CHAN_1 : 8; /*!< [15:8]  */
        uint32_t COD_NL_PRIORITY_CHAN_1 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NL_START_CHAN_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl0_ch_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL0_CH_1 register
 */
/*@{*/
#define HW_IPU_DC_RL0_CH_1_ADDR(x) ((uintptr_t)(x) + 0x58024U)

#define HW_IPU_DC_RL0_CH_1(x)    (*(__IO hw_ipu_dc_rl0_ch_1_t *) HW_IPU_DC_RL0_CH_1_ADDR(x))
#define HW_IPU_DC_RL0_CH_1_RD(x) (HW_IPU_DC_RL0_CH_1(x).U)
#define HW_IPU_DC_RL0_CH_1_WR(x, v) (HW_IPU_DC_RL0_CH_1(x).U = (v))
#define HW_IPU_DC_RL0_CH_1_SET(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, HW_IPU_DC_RL0_CH_1_RD(x) |  (v)))
#define HW_IPU_DC_RL0_CH_1_CLR(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, HW_IPU_DC_RL0_CH_1_RD(x) & ~(v)))
#define HW_IPU_DC_RL0_CH_1_TOG(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, HW_IPU_DC_RL0_CH_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL0_CH_1 bitfields
 */

/*!
 * @name Register IPU_DC_RL0_CH_1, field COD_NF_PRIORITY_CHAN_1[3:0] (RW)
 *
 * This field defines the priority of the new frame event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1 (0U) /*!< Bit position for IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1 (0x0000000FU) /*!< Bit mask for IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL0_CH_1(x).B.COD_NF_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1) & BM_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1)

/*! @brief Set the COD_NF_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, (HW_IPU_DC_RL0_CH_1_RD(x) & ~BM_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1) | BF_IPU_DC_RL0_CH_1_COD_NF_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_1, field COD_NF_START_CHAN_1[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new frame event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1 (8U) /*!< Bit position for IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1. */
#define BM_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1. */
#define BS_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1 field. */
#define BR_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1(x) (HW_IPU_DC_RL0_CH_1(x).B.COD_NF_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1. */
#define BF_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1) & BM_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1)

/*! @brief Set the COD_NF_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, (HW_IPU_DC_RL0_CH_1_RD(x) & ~BM_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1) | BF_IPU_DC_RL0_CH_1_COD_NF_START_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_1, field COD_NL_PRIORITY_CHAN_1[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1 (16U) /*!< Bit position for IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1 (0x000F0000U) /*!< Bit mask for IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL0_CH_1(x).B.COD_NL_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1) & BM_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1)

/*! @brief Set the COD_NL_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, (HW_IPU_DC_RL0_CH_1_RD(x) & ~BM_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1) | BF_IPU_DC_RL0_CH_1_COD_NL_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_1, field COD_NL_START_CHAN_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new line event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1 (24U) /*!< Bit position for IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1. */
#define BM_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1. */
#define BS_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1 field. */
#define BR_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1(x) (HW_IPU_DC_RL0_CH_1(x).B.COD_NL_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1. */
#define BF_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1) & BM_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1)

/*! @brief Set the COD_NL_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1(x, v) (HW_IPU_DC_RL0_CH_1_WR(x, (HW_IPU_DC_RL0_CH_1_RD(x) & ~BM_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1) | BF_IPU_DC_RL0_CH_1_COD_NL_START_CHAN_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_1 - DC Routine Link Register 1 Channel 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_1 - DC Routine Link Register 1 Channel 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_1
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_1_bitfields
    {
        uint32_t COD_EOF_PRIORITY_CHAN_1 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOF_START_CHAN_1 : 8; /*!< [15:8]  */
        uint32_t COD_NFIELD_PRIORITY_CHAN_1 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NFIELD_START_CHAN_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_1 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_1_ADDR(x) ((uintptr_t)(x) + 0x58028U)

#define HW_IPU_DC_RL1_CH_1(x)    (*(__IO hw_ipu_dc_rl1_ch_1_t *) HW_IPU_DC_RL1_CH_1_ADDR(x))
#define HW_IPU_DC_RL1_CH_1_RD(x) (HW_IPU_DC_RL1_CH_1(x).U)
#define HW_IPU_DC_RL1_CH_1_WR(x, v) (HW_IPU_DC_RL1_CH_1(x).U = (v))
#define HW_IPU_DC_RL1_CH_1_SET(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, HW_IPU_DC_RL1_CH_1_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_1_CLR(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, HW_IPU_DC_RL1_CH_1_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_1_TOG(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, HW_IPU_DC_RL1_CH_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_1 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_1, field COD_EOF_PRIORITY_CHAN_1[3:0] (RW)
 *
 * This field defines the priority of the end of frame event (associated with
 * channel #1) The priority between the events should be set to a unique value.
 * i.e. two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1 (0U) /*!< Bit position for IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL1_CH_1(x).B.COD_EOF_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1) & BM_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1)

/*! @brief Set the COD_EOF_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, (HW_IPU_DC_RL1_CH_1_RD(x) & ~BM_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1) | BF_IPU_DC_RL1_CH_1_COD_EOF_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_1, field COD_EOF_START_CHAN_1[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of frame event resides (associated with channel
 * #1)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1 (8U) /*!< Bit position for IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1. */
#define BM_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1. */
#define BS_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1 field. */
#define BR_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1(x) (HW_IPU_DC_RL1_CH_1(x).B.COD_EOF_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1. */
#define BF_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1) & BM_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1)

/*! @brief Set the COD_EOF_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, (HW_IPU_DC_RL1_CH_1_RD(x) & ~BM_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1) | BF_IPU_DC_RL1_CH_1_COD_EOF_START_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_1, field COD_NFIELD_PRIORITY_CHAN_1[19:16] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1 (16U) /*!< Bit position for IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1 (0x000F0000U) /*!< Bit mask for IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL1_CH_1(x).B.COD_NFIELD_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1) & BM_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1)

/*! @brief Set the COD_NFIELD_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, (HW_IPU_DC_RL1_CH_1_RD(x) & ~BM_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1) | BF_IPU_DC_RL1_CH_1_COD_NFIELD_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_1, field COD_NFIELD_START_CHAN_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new field event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1 (24U) /*!< Bit position for IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1. */
#define BM_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1. */
#define BS_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1 field. */
#define BR_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1(x) (HW_IPU_DC_RL1_CH_1(x).B.COD_NFIELD_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1. */
#define BF_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1) & BM_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1)

/*! @brief Set the COD_NFIELD_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1(x, v) (HW_IPU_DC_RL1_CH_1_WR(x, (HW_IPU_DC_RL1_CH_1_RD(x) & ~BM_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1) | BF_IPU_DC_RL1_CH_1_COD_NFIELD_START_CHAN_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_1 - DC Routine Link Register 2 Channel 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_1 - DC Routine Link Register 2 Channel 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_1
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_1_bitfields
    {
        uint32_t COD_EOL_PRIORITY_CHAN_1 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOL_START_CHAN_1 : 8; /*!< [15:8]  */
        uint32_t COD_EOFIELD_PRIORITY_CHAN_1 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_EOFIELD_START_CHAN_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_1 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_1_ADDR(x) ((uintptr_t)(x) + 0x5802CU)

#define HW_IPU_DC_RL2_CH_1(x)    (*(__IO hw_ipu_dc_rl2_ch_1_t *) HW_IPU_DC_RL2_CH_1_ADDR(x))
#define HW_IPU_DC_RL2_CH_1_RD(x) (HW_IPU_DC_RL2_CH_1(x).U)
#define HW_IPU_DC_RL2_CH_1_WR(x, v) (HW_IPU_DC_RL2_CH_1(x).U = (v))
#define HW_IPU_DC_RL2_CH_1_SET(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, HW_IPU_DC_RL2_CH_1_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_1_CLR(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, HW_IPU_DC_RL2_CH_1_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_1_TOG(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, HW_IPU_DC_RL2_CH_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_1 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_1, field COD_EOL_PRIORITY_CHAN_1[3:0] (RW)
 *
 * This field defines the priority of the end of line event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1 (0U) /*!< Bit position for IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL2_CH_1(x).B.COD_EOL_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1) & BM_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1)

/*! @brief Set the COD_EOL_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, (HW_IPU_DC_RL2_CH_1_RD(x) & ~BM_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1) | BF_IPU_DC_RL2_CH_1_COD_EOL_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_1, field COD_EOL_START_CHAN_1[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of line event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1 (8U) /*!< Bit position for IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1. */
#define BM_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1. */
#define BS_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1 field. */
#define BR_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1(x) (HW_IPU_DC_RL2_CH_1(x).B.COD_EOL_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1. */
#define BF_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1) & BM_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1)

/*! @brief Set the COD_EOL_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, (HW_IPU_DC_RL2_CH_1_RD(x) & ~BM_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1) | BF_IPU_DC_RL2_CH_1_COD_EOL_START_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_1, field COD_EOFIELD_PRIORITY_CHAN_1[19:16] (RW)
 *
 * This field defines the priority of the end of field event (associated with
 * channel #1) The priority between the events should be set to a unique value.
 * i.e. two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1 (16U) /*!< Bit position for IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1 (0x000F0000U) /*!< Bit mask for IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL2_CH_1(x).B.COD_EOFIELD_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1) & BM_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1)

/*! @brief Set the COD_EOFIELD_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, (HW_IPU_DC_RL2_CH_1_RD(x) & ~BM_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1) | BF_IPU_DC_RL2_CH_1_COD_EOFIELD_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_1, field COD_EOFIELD_START_CHAN_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of field event resides (associated with channel
 * #1)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1 (24U) /*!< Bit position for IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1. */
#define BM_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1. */
#define BS_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1 field. */
#define BR_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1(x) (HW_IPU_DC_RL2_CH_1(x).B.COD_EOFIELD_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1. */
#define BF_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1) & BM_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1)

/*! @brief Set the COD_EOFIELD_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1(x, v) (HW_IPU_DC_RL2_CH_1_WR(x, (HW_IPU_DC_RL2_CH_1_RD(x) & ~BM_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1) | BF_IPU_DC_RL2_CH_1_COD_EOFIELD_START_CHAN_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_1 - DC Routine Link Register 3 Channel 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_1 - DC Routine Link Register 3 Channel 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_1
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_1_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_1 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_1 : 8; /*!< [15:8]  */
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_1 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NEW_CHAN_START_CHAN_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_1 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_1_ADDR(x) ((uintptr_t)(x) + 0x58030U)

#define HW_IPU_DC_RL3_CH_1(x)    (*(__IO hw_ipu_dc_rl3_ch_1_t *) HW_IPU_DC_RL3_CH_1_ADDR(x))
#define HW_IPU_DC_RL3_CH_1_RD(x) (HW_IPU_DC_RL3_CH_1(x).U)
#define HW_IPU_DC_RL3_CH_1_WR(x, v) (HW_IPU_DC_RL3_CH_1(x).U = (v))
#define HW_IPU_DC_RL3_CH_1_SET(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, HW_IPU_DC_RL3_CH_1_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_1_CLR(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, HW_IPU_DC_RL3_CH_1_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_1_TOG(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, HW_IPU_DC_RL3_CH_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_1 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_1, field COD_NEW_ADDR_PRIORITY_CHAN_1[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1 (0U) /*!< Bit position for IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL3_CH_1(x).B.COD_NEW_ADDR_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1) & BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, (HW_IPU_DC_RL3_CH_1_RD(x) & ~BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1) | BF_IPU_DC_RL3_CH_1_COD_NEW_ADDR_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_1, field COD_NEW_ADDR_START_CHAN_1[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1 (8U) /*!< Bit position for IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1. */
#define BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1. */
#define BS_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1 field. */
#define BR_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1(x) (HW_IPU_DC_RL3_CH_1(x).B.COD_NEW_ADDR_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1. */
#define BF_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1) & BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, (HW_IPU_DC_RL3_CH_1_RD(x) & ~BM_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1) | BF_IPU_DC_RL3_CH_1_COD_NEW_ADDR_START_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_1, field COD_NEW_CHAN_PRIORITY_CHAN_1[19:16] (RW)
 *
 * This field defines the priority of the new channel event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1 (16U) /*!< Bit position for IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1 (0x000F0000U) /*!< Bit mask for IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL3_CH_1(x).B.COD_NEW_CHAN_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1) & BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, (HW_IPU_DC_RL3_CH_1_RD(x) & ~BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1) | BF_IPU_DC_RL3_CH_1_COD_NEW_CHAN_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_1, field COD_NEW_CHAN_START_CHAN_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1 (24U) /*!< Bit position for IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1. */
#define BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1. */
#define BS_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1 field. */
#define BR_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1(x) (HW_IPU_DC_RL3_CH_1(x).B.COD_NEW_CHAN_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1. */
#define BF_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1) & BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1(x, v) (HW_IPU_DC_RL3_CH_1_WR(x, (HW_IPU_DC_RL3_CH_1_RD(x) & ~BM_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1) | BF_IPU_DC_RL3_CH_1_COD_NEW_CHAN_START_CHAN_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_1 - DC Routine Link Register 4 Channel 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_1 - DC Routine Link Register 4 Channel 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_1
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_1_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_1 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_1 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dc_rl4_ch_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_1 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_1_ADDR(x) ((uintptr_t)(x) + 0x58034U)

#define HW_IPU_DC_RL4_CH_1(x)    (*(__IO hw_ipu_dc_rl4_ch_1_t *) HW_IPU_DC_RL4_CH_1_ADDR(x))
#define HW_IPU_DC_RL4_CH_1_RD(x) (HW_IPU_DC_RL4_CH_1(x).U)
#define HW_IPU_DC_RL4_CH_1_WR(x, v) (HW_IPU_DC_RL4_CH_1(x).U = (v))
#define HW_IPU_DC_RL4_CH_1_SET(x, v) (HW_IPU_DC_RL4_CH_1_WR(x, HW_IPU_DC_RL4_CH_1_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_1_CLR(x, v) (HW_IPU_DC_RL4_CH_1_WR(x, HW_IPU_DC_RL4_CH_1_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_1_TOG(x, v) (HW_IPU_DC_RL4_CH_1_WR(x, HW_IPU_DC_RL4_CH_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_1 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_1, field COD_NEW_DATA_PRIORITY_CHAN_1[3:0] (RW)
 *
 * This field defines the priority of the new data event (associated with
 * channel #1) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1 (0U) /*!< Bit position for IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1. */
#define BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1 (0x0000000FU) /*!< Bit mask for IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1. */
#define BS_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1 (4U) /*!< Bit field size in bits for IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1 field. */
#define BR_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1(x) (HW_IPU_DC_RL4_CH_1(x).B.COD_NEW_DATA_PRIORITY_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1. */
#define BF_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1) & BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1(x, v) (HW_IPU_DC_RL4_CH_1_WR(x, (HW_IPU_DC_RL4_CH_1_RD(x) & ~BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1) | BF_IPU_DC_RL4_CH_1_COD_NEW_DATA_PRIORITY_CHAN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_1, field COD_NEW_DATA_START_CHAN_1[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #1)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1 (8U) /*!< Bit position for IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1. */
#define BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1. */
#define BS_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1. */

/*! @brief Read current value of the IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1 field. */
#define BR_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1(x) (HW_IPU_DC_RL4_CH_1(x).B.COD_NEW_DATA_START_CHAN_1)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1. */
#define BF_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1) & BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1)

/*! @brief Set the COD_NEW_DATA_START_CHAN_1 field to a new value. */
#define BW_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1(x, v) (HW_IPU_DC_RL4_CH_1_WR(x, (HW_IPU_DC_RL4_CH_1_RD(x) & ~BM_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1) | BF_IPU_DC_RL4_CH_1_COD_NEW_DATA_START_CHAN_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF_2 - DC Write Channel 2 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF_2 - DC Write Channel 2 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf_2
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf_2_bitfields
    {
        uint32_t W_SIZE_2 : 2;         /*!< [1:0]  */
        uint32_t PROG_DI_ID_2 : 1;     /*!< [2]  */
        uint32_t PROG_DISP_ID_2 : 2;   /*!< [4:3]  */
        uint32_t PROG_CHAN_TYP_2 : 3;  /*!< [7:5]  */
        uint32_t CHAN_MASK_DEFAULT_2 : 1; /*!< [8]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t PROG_START_TIME_2 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dc_wr_ch_conf_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF_2 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF_2_ADDR(x) ((uintptr_t)(x) + 0x58038U)

#define HW_IPU_DC_WR_CH_CONF_2(x) (*(__IO hw_ipu_dc_wr_ch_conf_2_t *) HW_IPU_DC_WR_CH_CONF_2_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF_2_RD(x) (HW_IPU_DC_WR_CH_CONF_2(x).U)
#define HW_IPU_DC_WR_CH_CONF_2_WR(x, v) (HW_IPU_DC_WR_CH_CONF_2(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF_2_SET(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, HW_IPU_DC_WR_CH_CONF_2_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF_2_CLR(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF_2_TOG(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, HW_IPU_DC_WR_CH_CONF_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF_2 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field W_SIZE_2[1:0] (RW)
 *
 * Word Size The data coming from the IDMAC is 32bit wide. This field defines
 * the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_W_SIZE_2 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_W_SIZE_2. */
#define BM_IPU_DC_WR_CH_CONF_2_W_SIZE_2 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_W_SIZE_2. */
#define BS_IPU_DC_WR_CH_CONF_2_W_SIZE_2 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_W_SIZE_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_W_SIZE_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_W_SIZE_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.W_SIZE_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_W_SIZE_2. */
#define BF_IPU_DC_WR_CH_CONF_2_W_SIZE_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_W_SIZE_2) & BM_IPU_DC_WR_CH_CONF_2_W_SIZE_2)

/*! @brief Set the W_SIZE_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_W_SIZE_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_W_SIZE_2) | BF_IPU_DC_WR_CH_CONF_2_W_SIZE_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field PROG_DI_ID_2[2] (RW)
 *
 * This bit select the DI which a transaction associated with channel #2 can be
 * performed to
 *
 * Values:
 * - 1 - DI #1
 * - 0 - DI #0
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2. */
#define BM_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2. */
#define BS_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.PROG_DI_ID_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2. */
#define BF_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2) & BM_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2)

/*! @brief Set the PROG_DI_ID_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2) | BF_IPU_DC_WR_CH_CONF_2_PROG_DI_ID_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field PROG_DISP_ID_2[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #2.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2. */
#define BM_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2. */
#define BS_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.PROG_DISP_ID_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2. */
#define BF_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2) & BM_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2)

/*! @brief Set the PROG_DISP_ID_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2) | BF_IPU_DC_WR_CH_CONF_2_PROG_DISP_ID_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field PROG_CHAN_TYP_2[7:5] (RW)
 *
 * This field define the mode of operation of channel #2
 *
 * Values:
 * - 000 - Disable
 * - 001 - Reserved
 * - 010 - Reserved
 * - 100 - Normal mode without anti-tearing. For sync display this is the only
 *     mode allowed
 * - 101 - Normal mode with anti-tearing
 * - 110 - Reserved
 * - 111 - Additional command channel is added to the flow handled by DC channel
 *     #2
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2 (5U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2. */
#define BM_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2 (0x000000E0U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2. */
#define BS_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2 (3U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.PROG_CHAN_TYP_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2. */
#define BF_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2) & BM_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2)

/*! @brief Set the PROG_CHAN_TYP_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2) | BF_IPU_DC_WR_CH_CONF_2_PROG_CHAN_TYP_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field CHAN_MASK_DEFAULT_2[8] (RW)
 *
 * Event mask bit for channel #2 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2 (8U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2. */
#define BM_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2 (0x00000100U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2. */
#define BS_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.CHAN_MASK_DEFAULT_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2. */
#define BF_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2) & BM_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2)

/*! @brief Set the CHAN_MASK_DEFAULT_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2) | BF_IPU_DC_WR_CH_CONF_2_CHAN_MASK_DEFAULT_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_2, field PROG_START_TIME_2[26:16] (RW)
 *
 * This field defines the delay between display 's vertical synchronization
 * pulse and the start time point of DC's channel 2 window. The delay is defined in
 * pairs of rows. It is used for tearing elimination
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2 (16U) /*!< Bit position for IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2. */
#define BM_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2 (0x07FF0000U) /*!< Bit mask for IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2. */
#define BS_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2 (11U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2 field. */
#define BR_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2(x) (HW_IPU_DC_WR_CH_CONF_2(x).B.PROG_START_TIME_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2. */
#define BF_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2) & BM_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2)

/*! @brief Set the PROG_START_TIME_2 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2(x, v) (HW_IPU_DC_WR_CH_CONF_2_WR(x, (HW_IPU_DC_WR_CH_CONF_2_RD(x) & ~BM_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2) | BF_IPU_DC_WR_CH_CONF_2_PROG_START_TIME_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_ADDR_2 - DC Write Channel 2 Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_ADDR_2 - DC Write Channel 2 Address Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_addr_2
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_addr_2_bitfields
    {
        uint32_t ST_ADDR_2 : 29;       /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_addr_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_ADDR_2 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_ADDR_2_ADDR(x) ((uintptr_t)(x) + 0x5803CU)

#define HW_IPU_DC_WR_CH_ADDR_2(x) (*(__IO hw_ipu_dc_wr_ch_addr_2_t *) HW_IPU_DC_WR_CH_ADDR_2_ADDR(x))
#define HW_IPU_DC_WR_CH_ADDR_2_RD(x) (HW_IPU_DC_WR_CH_ADDR_2(x).U)
#define HW_IPU_DC_WR_CH_ADDR_2_WR(x, v) (HW_IPU_DC_WR_CH_ADDR_2(x).U = (v))
#define HW_IPU_DC_WR_CH_ADDR_2_SET(x, v) (HW_IPU_DC_WR_CH_ADDR_2_WR(x, HW_IPU_DC_WR_CH_ADDR_2_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_ADDR_2_CLR(x, v) (HW_IPU_DC_WR_CH_ADDR_2_WR(x, HW_IPU_DC_WR_CH_ADDR_2_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_ADDR_2_TOG(x, v) (HW_IPU_DC_WR_CH_ADDR_2_WR(x, HW_IPU_DC_WR_CH_ADDR_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_ADDR_2 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_ADDR_2, field ST_ADDR_2[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the write transactions will be done to for channel #2.
 */
/*@{*/
#define BP_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2 (0U) /*!< Bit position for IPU_DC_WR_CH_ADDR_2_ST_ADDR_2. */
#define BM_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_ADDR_2_ST_ADDR_2. */
#define BS_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_ADDR_2_ST_ADDR_2. */

/*! @brief Read current value of the IPU_DC_WR_CH_ADDR_2_ST_ADDR_2 field. */
#define BR_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2(x) (HW_IPU_DC_WR_CH_ADDR_2(x).B.ST_ADDR_2)

/*! @brief Format value for bitfield IPU_DC_WR_CH_ADDR_2_ST_ADDR_2. */
#define BF_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2) & BM_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2)

/*! @brief Set the ST_ADDR_2 field to a new value. */
#define BW_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2(x, v) (HW_IPU_DC_WR_CH_ADDR_2_WR(x, (HW_IPU_DC_WR_CH_ADDR_2_RD(x) & ~BM_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2) | BF_IPU_DC_WR_CH_ADDR_2_ST_ADDR_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL0_CH_2 - DC Routine Link Register 0 Channel 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL0_CH_2 - DC Routine Link Register 0 Channel 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl0_ch_2
{
    uint32_t U;
    struct _hw_ipu_dc_rl0_ch_2_bitfields
    {
        uint32_t COD_NF_PRIORITY_CHAN_2 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NF_START_CHAN_2 : 8; /*!< [15:8]  */
        uint32_t COD_NL_PRIORITY_CHAN_2 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NL_START_CHAN_2 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl0_ch_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL0_CH_2 register
 */
/*@{*/
#define HW_IPU_DC_RL0_CH_2_ADDR(x) ((uintptr_t)(x) + 0x58040U)

#define HW_IPU_DC_RL0_CH_2(x)    (*(__IO hw_ipu_dc_rl0_ch_2_t *) HW_IPU_DC_RL0_CH_2_ADDR(x))
#define HW_IPU_DC_RL0_CH_2_RD(x) (HW_IPU_DC_RL0_CH_2(x).U)
#define HW_IPU_DC_RL0_CH_2_WR(x, v) (HW_IPU_DC_RL0_CH_2(x).U = (v))
#define HW_IPU_DC_RL0_CH_2_SET(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, HW_IPU_DC_RL0_CH_2_RD(x) |  (v)))
#define HW_IPU_DC_RL0_CH_2_CLR(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, HW_IPU_DC_RL0_CH_2_RD(x) & ~(v)))
#define HW_IPU_DC_RL0_CH_2_TOG(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, HW_IPU_DC_RL0_CH_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL0_CH_2 bitfields
 */

/*!
 * @name Register IPU_DC_RL0_CH_2, field COD_NF_PRIORITY_CHAN_2[3:0] (RW)
 *
 * This field defines the priority of the new frame event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2 (0U) /*!< Bit position for IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2 (0x0000000FU) /*!< Bit mask for IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL0_CH_2(x).B.COD_NF_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2) & BM_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2)

/*! @brief Set the COD_NF_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, (HW_IPU_DC_RL0_CH_2_RD(x) & ~BM_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2) | BF_IPU_DC_RL0_CH_2_COD_NF_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_2, field COD_NF_START_CHAN_2[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new frame event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2 (8U) /*!< Bit position for IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2. */
#define BM_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2. */
#define BS_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2 field. */
#define BR_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2(x) (HW_IPU_DC_RL0_CH_2(x).B.COD_NF_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2. */
#define BF_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2) & BM_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2)

/*! @brief Set the COD_NF_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, (HW_IPU_DC_RL0_CH_2_RD(x) & ~BM_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2) | BF_IPU_DC_RL0_CH_2_COD_NF_START_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_2, field COD_NL_PRIORITY_CHAN_2[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2 (16U) /*!< Bit position for IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2 (0x000F0000U) /*!< Bit mask for IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL0_CH_2(x).B.COD_NL_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2) & BM_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2)

/*! @brief Set the COD_NL_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, (HW_IPU_DC_RL0_CH_2_RD(x) & ~BM_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2) | BF_IPU_DC_RL0_CH_2_COD_NL_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_2, field COD_NL_START_CHAN_2[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new line event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2 (24U) /*!< Bit position for IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2. */
#define BM_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2 (0xFF000000U) /*!< Bit mask for IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2. */
#define BS_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2 field. */
#define BR_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2(x) (HW_IPU_DC_RL0_CH_2(x).B.COD_NL_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2. */
#define BF_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2) & BM_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2)

/*! @brief Set the COD_NL_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2(x, v) (HW_IPU_DC_RL0_CH_2_WR(x, (HW_IPU_DC_RL0_CH_2_RD(x) & ~BM_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2) | BF_IPU_DC_RL0_CH_2_COD_NL_START_CHAN_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_2 - DC Routine Link Register 1 Channel 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_2 - DC Routine Link Register 1 Channel 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_2
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_2_bitfields
    {
        uint32_t COD_EOF_PRIORITY_CHAN_2 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOF_START_CHAN_2 : 8; /*!< [15:8]  */
        uint32_t COD_NFIELD_PRIORITY_CHAN_2 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NFIELD_START_CHAN_2 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_2 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_2_ADDR(x) ((uintptr_t)(x) + 0x58044U)

#define HW_IPU_DC_RL1_CH_2(x)    (*(__IO hw_ipu_dc_rl1_ch_2_t *) HW_IPU_DC_RL1_CH_2_ADDR(x))
#define HW_IPU_DC_RL1_CH_2_RD(x) (HW_IPU_DC_RL1_CH_2(x).U)
#define HW_IPU_DC_RL1_CH_2_WR(x, v) (HW_IPU_DC_RL1_CH_2(x).U = (v))
#define HW_IPU_DC_RL1_CH_2_SET(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, HW_IPU_DC_RL1_CH_2_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_2_CLR(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, HW_IPU_DC_RL1_CH_2_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_2_TOG(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, HW_IPU_DC_RL1_CH_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_2 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_2, field COD_EOF_PRIORITY_CHAN_2[3:0] (RW)
 *
 * This field defines the priority of the end of frame event (associated with
 * channel #2) The priority between the events should be set to a unique value.
 * i.e. two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2 (0U) /*!< Bit position for IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL1_CH_2(x).B.COD_EOF_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2) & BM_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2)

/*! @brief Set the COD_EOF_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, (HW_IPU_DC_RL1_CH_2_RD(x) & ~BM_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2) | BF_IPU_DC_RL1_CH_2_COD_EOF_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_2, field COD_EOF_START_CHAN_2[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of frame event resides (associated with channel
 * #2)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2 (8U) /*!< Bit position for IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2. */
#define BM_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2. */
#define BS_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2 field. */
#define BR_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2(x) (HW_IPU_DC_RL1_CH_2(x).B.COD_EOF_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2. */
#define BF_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2) & BM_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2)

/*! @brief Set the COD_EOF_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, (HW_IPU_DC_RL1_CH_2_RD(x) & ~BM_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2) | BF_IPU_DC_RL1_CH_2_COD_EOF_START_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_2, field COD_NFIELD_PRIORITY_CHAN_2[19:16] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2 (16U) /*!< Bit position for IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2 (0x000F0000U) /*!< Bit mask for IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL1_CH_2(x).B.COD_NFIELD_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2) & BM_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2)

/*! @brief Set the COD_NFIELD_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, (HW_IPU_DC_RL1_CH_2_RD(x) & ~BM_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2) | BF_IPU_DC_RL1_CH_2_COD_NFIELD_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_2, field COD_NFIELD_START_CHAN_2[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new field event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2 (24U) /*!< Bit position for IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2. */
#define BM_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2. */
#define BS_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2 field. */
#define BR_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2(x) (HW_IPU_DC_RL1_CH_2(x).B.COD_NFIELD_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2. */
#define BF_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2) & BM_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2)

/*! @brief Set the COD_NFIELD_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2(x, v) (HW_IPU_DC_RL1_CH_2_WR(x, (HW_IPU_DC_RL1_CH_2_RD(x) & ~BM_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2) | BF_IPU_DC_RL1_CH_2_COD_NFIELD_START_CHAN_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_2 - DC Routine Link Register 2 Channel 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_2 - DC Routine Link Register 2 Channel 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_2
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_2_bitfields
    {
        uint32_t COD_EOL_PRIORITY_CHAN_2 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOL_START_CHAN_2 : 8; /*!< [15:8]  */
        uint32_t COD_EOFIELD_PRIORITY_CHAN_2 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_EOFIELD_START_CHAN_2 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_2 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_2_ADDR(x) ((uintptr_t)(x) + 0x58048U)

#define HW_IPU_DC_RL2_CH_2(x)    (*(__IO hw_ipu_dc_rl2_ch_2_t *) HW_IPU_DC_RL2_CH_2_ADDR(x))
#define HW_IPU_DC_RL2_CH_2_RD(x) (HW_IPU_DC_RL2_CH_2(x).U)
#define HW_IPU_DC_RL2_CH_2_WR(x, v) (HW_IPU_DC_RL2_CH_2(x).U = (v))
#define HW_IPU_DC_RL2_CH_2_SET(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, HW_IPU_DC_RL2_CH_2_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_2_CLR(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, HW_IPU_DC_RL2_CH_2_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_2_TOG(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, HW_IPU_DC_RL2_CH_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_2 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_2, field COD_EOL_PRIORITY_CHAN_2[3:0] (RW)
 *
 * This field defines the priority of the end of line event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2 (0U) /*!< Bit position for IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL2_CH_2(x).B.COD_EOL_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2) & BM_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2)

/*! @brief Set the COD_EOL_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, (HW_IPU_DC_RL2_CH_2_RD(x) & ~BM_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2) | BF_IPU_DC_RL2_CH_2_COD_EOL_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_2, field COD_EOL_START_CHAN_2[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of line event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2 (8U) /*!< Bit position for IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2. */
#define BM_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2. */
#define BS_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2 field. */
#define BR_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2(x) (HW_IPU_DC_RL2_CH_2(x).B.COD_EOL_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2. */
#define BF_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2) & BM_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2)

/*! @brief Set the COD_EOL_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, (HW_IPU_DC_RL2_CH_2_RD(x) & ~BM_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2) | BF_IPU_DC_RL2_CH_2_COD_EOL_START_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_2, field COD_EOFIELD_PRIORITY_CHAN_2[19:16] (RW)
 *
 * This field defines the priority of the end of field event (associated with
 * channel #2) The priority between the events should be set to a unique value.
 * i.e. two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2 (16U) /*!< Bit position for IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2 (0x000F0000U) /*!< Bit mask for IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL2_CH_2(x).B.COD_EOFIELD_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2) & BM_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2)

/*! @brief Set the COD_EOFIELD_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, (HW_IPU_DC_RL2_CH_2_RD(x) & ~BM_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2) | BF_IPU_DC_RL2_CH_2_COD_EOFIELD_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_2, field COD_EOFIELD_START_CHAN_2[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of field event resides (associated with channel
 * #2)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2 (24U) /*!< Bit position for IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2. */
#define BM_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2. */
#define BS_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2 field. */
#define BR_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2(x) (HW_IPU_DC_RL2_CH_2(x).B.COD_EOFIELD_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2. */
#define BF_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2) & BM_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2)

/*! @brief Set the COD_EOFIELD_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2(x, v) (HW_IPU_DC_RL2_CH_2_WR(x, (HW_IPU_DC_RL2_CH_2_RD(x) & ~BM_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2) | BF_IPU_DC_RL2_CH_2_COD_EOFIELD_START_CHAN_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_2 - DC Routine Link Register 3 Channel 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_2 - DC Routine Link Register 3 Channel 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_2
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_2_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_2 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_2 : 8; /*!< [15:8]  */
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_2 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NEW_CHAN_START_CHAN_2 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_2 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_2_ADDR(x) ((uintptr_t)(x) + 0x5804CU)

#define HW_IPU_DC_RL3_CH_2(x)    (*(__IO hw_ipu_dc_rl3_ch_2_t *) HW_IPU_DC_RL3_CH_2_ADDR(x))
#define HW_IPU_DC_RL3_CH_2_RD(x) (HW_IPU_DC_RL3_CH_2(x).U)
#define HW_IPU_DC_RL3_CH_2_WR(x, v) (HW_IPU_DC_RL3_CH_2(x).U = (v))
#define HW_IPU_DC_RL3_CH_2_SET(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, HW_IPU_DC_RL3_CH_2_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_2_CLR(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, HW_IPU_DC_RL3_CH_2_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_2_TOG(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, HW_IPU_DC_RL3_CH_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_2 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_2, field COD_NEW_ADDR_PRIORITY_CHAN_2[3:0] (RW)
 *
 * This field defines the priority of the end of line event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2 (0U) /*!< Bit position for IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL3_CH_2(x).B.COD_NEW_ADDR_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2) & BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, (HW_IPU_DC_RL3_CH_2_RD(x) & ~BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2) | BF_IPU_DC_RL3_CH_2_COD_NEW_ADDR_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_2, field COD_NEW_ADDR_START_CHAN_2[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2 (8U) /*!< Bit position for IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2. */
#define BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2. */
#define BS_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2 field. */
#define BR_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2(x) (HW_IPU_DC_RL3_CH_2(x).B.COD_NEW_ADDR_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2. */
#define BF_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2) & BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, (HW_IPU_DC_RL3_CH_2_RD(x) & ~BM_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2) | BF_IPU_DC_RL3_CH_2_COD_NEW_ADDR_START_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_2, field COD_NEW_CHAN_PRIORITY_CHAN_2[19:16] (RW)
 *
 * This field defines the priority of the end of line event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2 (16U) /*!< Bit position for IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2 (0x000F0000U) /*!< Bit mask for IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL3_CH_2(x).B.COD_NEW_CHAN_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2) & BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, (HW_IPU_DC_RL3_CH_2_RD(x) & ~BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2) | BF_IPU_DC_RL3_CH_2_COD_NEW_CHAN_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_2, field COD_NEW_CHAN_START_CHAN_2[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2 (24U) /*!< Bit position for IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2. */
#define BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2. */
#define BS_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2 field. */
#define BR_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2(x) (HW_IPU_DC_RL3_CH_2(x).B.COD_NEW_CHAN_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2. */
#define BF_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2) & BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2(x, v) (HW_IPU_DC_RL3_CH_2_WR(x, (HW_IPU_DC_RL3_CH_2_RD(x) & ~BM_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2) | BF_IPU_DC_RL3_CH_2_COD_NEW_CHAN_START_CHAN_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_2 - DC Routine Link Register 4 Channel 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_2 - DC Routine Link Register 4 Channel 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_2
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_2_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_2 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_2 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dc_rl4_ch_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_2 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_2_ADDR(x) ((uintptr_t)(x) + 0x58050U)

#define HW_IPU_DC_RL4_CH_2(x)    (*(__IO hw_ipu_dc_rl4_ch_2_t *) HW_IPU_DC_RL4_CH_2_ADDR(x))
#define HW_IPU_DC_RL4_CH_2_RD(x) (HW_IPU_DC_RL4_CH_2(x).U)
#define HW_IPU_DC_RL4_CH_2_WR(x, v) (HW_IPU_DC_RL4_CH_2(x).U = (v))
#define HW_IPU_DC_RL4_CH_2_SET(x, v) (HW_IPU_DC_RL4_CH_2_WR(x, HW_IPU_DC_RL4_CH_2_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_2_CLR(x, v) (HW_IPU_DC_RL4_CH_2_WR(x, HW_IPU_DC_RL4_CH_2_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_2_TOG(x, v) (HW_IPU_DC_RL4_CH_2_WR(x, HW_IPU_DC_RL4_CH_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_2 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_2, field COD_NEW_DATA_PRIORITY_CHAN_2[3:0] (RW)
 *
 * This field defines the priority of the end of line event (associated with
 * channel #2) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2 (0U) /*!< Bit position for IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2. */
#define BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2 (0x0000000FU) /*!< Bit mask for IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2. */
#define BS_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2 (4U) /*!< Bit field size in bits for IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2 field. */
#define BR_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2(x) (HW_IPU_DC_RL4_CH_2(x).B.COD_NEW_DATA_PRIORITY_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2. */
#define BF_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2) & BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2(x, v) (HW_IPU_DC_RL4_CH_2_WR(x, (HW_IPU_DC_RL4_CH_2_RD(x) & ~BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2) | BF_IPU_DC_RL4_CH_2_COD_NEW_DATA_PRIORITY_CHAN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_2, field COD_NEW_DATA_START_CHAN_2[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #2)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2 (8U) /*!< Bit position for IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2. */
#define BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2. */
#define BS_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2. */

/*! @brief Read current value of the IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2 field. */
#define BR_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2(x) (HW_IPU_DC_RL4_CH_2(x).B.COD_NEW_DATA_START_CHAN_2)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2. */
#define BF_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2) & BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2)

/*! @brief Set the COD_NEW_DATA_START_CHAN_2 field to a new value. */
#define BW_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2(x, v) (HW_IPU_DC_RL4_CH_2_WR(x, (HW_IPU_DC_RL4_CH_2_RD(x) & ~BM_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2) | BF_IPU_DC_RL4_CH_2_COD_NEW_DATA_START_CHAN_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_CMD_CH_CONF_3 - DC Command Channel 3 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_CMD_CH_CONF_3 - DC Command Channel 3 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_cmd_ch_conf_3
{
    uint32_t U;
    struct _hw_ipu_dc_cmd_ch_conf_3_bitfields
    {
        uint32_t W_SIZE_3 : 2;         /*!< [1:0]  */
        uint32_t RESERVED0 : 6;        /*!< [7:2]  */
        uint32_t COD_CMND_START_CHAN_RS0_3 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_CMND_START_CHAN_RS1_3 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_cmd_ch_conf_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_CMD_CH_CONF_3 register
 */
/*@{*/
#define HW_IPU_DC_CMD_CH_CONF_3_ADDR(x) ((uintptr_t)(x) + 0x58054U)

#define HW_IPU_DC_CMD_CH_CONF_3(x) (*(__IO hw_ipu_dc_cmd_ch_conf_3_t *) HW_IPU_DC_CMD_CH_CONF_3_ADDR(x))
#define HW_IPU_DC_CMD_CH_CONF_3_RD(x) (HW_IPU_DC_CMD_CH_CONF_3(x).U)
#define HW_IPU_DC_CMD_CH_CONF_3_WR(x, v) (HW_IPU_DC_CMD_CH_CONF_3(x).U = (v))
#define HW_IPU_DC_CMD_CH_CONF_3_SET(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, HW_IPU_DC_CMD_CH_CONF_3_RD(x) |  (v)))
#define HW_IPU_DC_CMD_CH_CONF_3_CLR(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, HW_IPU_DC_CMD_CH_CONF_3_RD(x) & ~(v)))
#define HW_IPU_DC_CMD_CH_CONF_3_TOG(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, HW_IPU_DC_CMD_CH_CONF_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_CMD_CH_CONF_3 bitfields
 */

/*!
 * @name Register IPU_DC_CMD_CH_CONF_3, field W_SIZE_3[1:0] (RW)
 *
 * Word Size associated with channel #3 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_3_W_SIZE_3 (0U) /*!< Bit position for IPU_DC_CMD_CH_CONF_3_W_SIZE_3. */
#define BM_IPU_DC_CMD_CH_CONF_3_W_SIZE_3 (0x00000003U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_3_W_SIZE_3. */
#define BS_IPU_DC_CMD_CH_CONF_3_W_SIZE_3 (2U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_3_W_SIZE_3. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_3_W_SIZE_3 field. */
#define BR_IPU_DC_CMD_CH_CONF_3_W_SIZE_3(x) (HW_IPU_DC_CMD_CH_CONF_3(x).B.W_SIZE_3)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_3_W_SIZE_3. */
#define BF_IPU_DC_CMD_CH_CONF_3_W_SIZE_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_3_W_SIZE_3) & BM_IPU_DC_CMD_CH_CONF_3_W_SIZE_3)

/*! @brief Set the W_SIZE_3 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_3_W_SIZE_3(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, (HW_IPU_DC_CMD_CH_CONF_3_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_3_W_SIZE_3) | BF_IPU_DC_CMD_CH_CONF_3_W_SIZE_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_CMD_CH_CONF_3, field COD_CMND_START_CHAN_RS0_3[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the command start event resides (associated with channel
 * #3); This field is relevant when RS is equal to 0
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3 (8U) /*!< Bit position for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3. */
#define BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3 (0x0000FF00U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3. */
#define BS_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3 (8U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3 field. */
#define BR_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3(x) (HW_IPU_DC_CMD_CH_CONF_3(x).B.COD_CMND_START_CHAN_RS0_3)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3. */
#define BF_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3) & BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3)

/*! @brief Set the COD_CMND_START_CHAN_RS0_3 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, (HW_IPU_DC_CMD_CH_CONF_3_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3) | BF_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS0_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_CMD_CH_CONF_3, field COD_CMND_START_CHAN_RS1_3[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the command start event resides (associated with channel
 * #3); This field is relevant when RS is equal to 1
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3 (24U) /*!< Bit position for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3. */
#define BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3 (0xFF000000U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3. */
#define BS_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3 (8U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3 field. */
#define BR_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3(x) (HW_IPU_DC_CMD_CH_CONF_3(x).B.COD_CMND_START_CHAN_RS1_3)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3. */
#define BF_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3) & BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3)

/*! @brief Set the COD_CMND_START_CHAN_RS1_3 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3(x, v) (HW_IPU_DC_CMD_CH_CONF_3_WR(x, (HW_IPU_DC_CMD_CH_CONF_3_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3) | BF_IPU_DC_CMD_CH_CONF_3_COD_CMND_START_CHAN_RS1_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_CMD_CH_CONF_4 - DC Command Channel 4 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_CMD_CH_CONF_4 - DC Command Channel 4 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_cmd_ch_conf_4
{
    uint32_t U;
    struct _hw_ipu_dc_cmd_ch_conf_4_bitfields
    {
        uint32_t W_SIZE_4 : 2;         /*!< [1:0]  */
        uint32_t RESERVED0 : 6;        /*!< [7:2]  */
        uint32_t COD_CMND_START_CHAN_RS0_4 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_CMND_START_CHAN_RS1_4 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_cmd_ch_conf_4_t;

/*!
 * @name Constants and macros for entire IPU_DC_CMD_CH_CONF_4 register
 */
/*@{*/
#define HW_IPU_DC_CMD_CH_CONF_4_ADDR(x) ((uintptr_t)(x) + 0x58058U)

#define HW_IPU_DC_CMD_CH_CONF_4(x) (*(__IO hw_ipu_dc_cmd_ch_conf_4_t *) HW_IPU_DC_CMD_CH_CONF_4_ADDR(x))
#define HW_IPU_DC_CMD_CH_CONF_4_RD(x) (HW_IPU_DC_CMD_CH_CONF_4(x).U)
#define HW_IPU_DC_CMD_CH_CONF_4_WR(x, v) (HW_IPU_DC_CMD_CH_CONF_4(x).U = (v))
#define HW_IPU_DC_CMD_CH_CONF_4_SET(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, HW_IPU_DC_CMD_CH_CONF_4_RD(x) |  (v)))
#define HW_IPU_DC_CMD_CH_CONF_4_CLR(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, HW_IPU_DC_CMD_CH_CONF_4_RD(x) & ~(v)))
#define HW_IPU_DC_CMD_CH_CONF_4_TOG(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, HW_IPU_DC_CMD_CH_CONF_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_CMD_CH_CONF_4 bitfields
 */

/*!
 * @name Register IPU_DC_CMD_CH_CONF_4, field W_SIZE_4[1:0] (RW)
 *
 * Word Size associated with channel #4 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_4_W_SIZE_4 (0U) /*!< Bit position for IPU_DC_CMD_CH_CONF_4_W_SIZE_4. */
#define BM_IPU_DC_CMD_CH_CONF_4_W_SIZE_4 (0x00000003U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_4_W_SIZE_4. */
#define BS_IPU_DC_CMD_CH_CONF_4_W_SIZE_4 (2U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_4_W_SIZE_4. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_4_W_SIZE_4 field. */
#define BR_IPU_DC_CMD_CH_CONF_4_W_SIZE_4(x) (HW_IPU_DC_CMD_CH_CONF_4(x).B.W_SIZE_4)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_4_W_SIZE_4. */
#define BF_IPU_DC_CMD_CH_CONF_4_W_SIZE_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_4_W_SIZE_4) & BM_IPU_DC_CMD_CH_CONF_4_W_SIZE_4)

/*! @brief Set the W_SIZE_4 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_4_W_SIZE_4(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, (HW_IPU_DC_CMD_CH_CONF_4_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_4_W_SIZE_4) | BF_IPU_DC_CMD_CH_CONF_4_W_SIZE_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_CMD_CH_CONF_4, field COD_CMND_START_CHAN_RS0_4[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the command start event resides (associated with channel
 * #4); This field is relevant when RS is equal to 0
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4 (8U) /*!< Bit position for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4. */
#define BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4 (0x0000FF00U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4. */
#define BS_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4 (8U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4 field. */
#define BR_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4(x) (HW_IPU_DC_CMD_CH_CONF_4(x).B.COD_CMND_START_CHAN_RS0_4)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4. */
#define BF_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4) & BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4)

/*! @brief Set the COD_CMND_START_CHAN_RS0_4 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, (HW_IPU_DC_CMD_CH_CONF_4_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4) | BF_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS0_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_CMD_CH_CONF_4, field COD_CMND_START_CHAN_RS1_4[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the command start event resides (associated with channel
 * #4); This field is relevant when RS is equal to 1
 */
/*@{*/
#define BP_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4 (24U) /*!< Bit position for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4. */
#define BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4 (0xFF000000U) /*!< Bit mask for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4. */
#define BS_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4 (8U) /*!< Bit field size in bits for IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4. */

/*! @brief Read current value of the IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4 field. */
#define BR_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4(x) (HW_IPU_DC_CMD_CH_CONF_4(x).B.COD_CMND_START_CHAN_RS1_4)

/*! @brief Format value for bitfield IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4. */
#define BF_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4) & BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4)

/*! @brief Set the COD_CMND_START_CHAN_RS1_4 field to a new value. */
#define BW_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4(x, v) (HW_IPU_DC_CMD_CH_CONF_4_WR(x, (HW_IPU_DC_CMD_CH_CONF_4_RD(x) & ~BM_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4) | BF_IPU_DC_CMD_CH_CONF_4_COD_CMND_START_CHAN_RS1_4(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF_5 - DC Write Channel 5Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF_5 - DC Write Channel 5Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf_5
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf_5_bitfields
    {
        uint32_t W_SIZE_5 : 2;         /*!< [1:0]  */
        uint32_t PROG_DI_ID_5 : 1;     /*!< [2]  */
        uint32_t PROG_DISP_ID_5 : 2;   /*!< [4:3]  */
        uint32_t PROG_CHAN_TYP_5 : 3;  /*!< [7:5]  */
        uint32_t CHAN_MASK_DEFAULT_5 : 1; /*!< [8]  */
        uint32_t FIELD_MODE_5 : 1;     /*!< [9]  */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t PROG_START_TIME_5 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dc_wr_ch_conf_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF_5 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF_5_ADDR(x) ((uintptr_t)(x) + 0x5805CU)

#define HW_IPU_DC_WR_CH_CONF_5(x) (*(__IO hw_ipu_dc_wr_ch_conf_5_t *) HW_IPU_DC_WR_CH_CONF_5_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF_5_RD(x) (HW_IPU_DC_WR_CH_CONF_5(x).U)
#define HW_IPU_DC_WR_CH_CONF_5_WR(x, v) (HW_IPU_DC_WR_CH_CONF_5(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF_5_SET(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, HW_IPU_DC_WR_CH_CONF_5_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF_5_CLR(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF_5_TOG(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, HW_IPU_DC_WR_CH_CONF_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF_5 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field W_SIZE_5[1:0] (RW)
 *
 * Word Size associated with channel #5 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_W_SIZE_5 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_W_SIZE_5. */
#define BM_IPU_DC_WR_CH_CONF_5_W_SIZE_5 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_W_SIZE_5. */
#define BS_IPU_DC_WR_CH_CONF_5_W_SIZE_5 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_W_SIZE_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_W_SIZE_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_W_SIZE_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.W_SIZE_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_W_SIZE_5. */
#define BF_IPU_DC_WR_CH_CONF_5_W_SIZE_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_W_SIZE_5) & BM_IPU_DC_WR_CH_CONF_5_W_SIZE_5)

/*! @brief Set the W_SIZE_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_W_SIZE_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_W_SIZE_5) | BF_IPU_DC_WR_CH_CONF_5_W_SIZE_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field PROG_DI_ID_5[2] (RW)
 *
 * This bit select the DI which a transaction associated with channel #5 can be
 * performed to. When channel 28 is connected to DI0, channel 23 must be
 * connected to DI1 even if ch23 is not used. This is done by writing 1 to this bit.
 *
 * Values:
 * - 1 - DI #1
 * - 0 - DI #0
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5. */
#define BM_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5. */
#define BS_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.PROG_DI_ID_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5. */
#define BF_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5) & BM_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5)

/*! @brief Set the PROG_DI_ID_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5) | BF_IPU_DC_WR_CH_CONF_5_PROG_DI_ID_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field PROG_DISP_ID_5[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #5.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5. */
#define BM_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5. */
#define BS_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.PROG_DISP_ID_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5. */
#define BF_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5) & BM_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5)

/*! @brief Set the PROG_DISP_ID_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5) | BF_IPU_DC_WR_CH_CONF_5_PROG_DISP_ID_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field PROG_CHAN_TYP_5[7:5] (RW)
 *
 * This field define the mode of operation of channel #5
 *
 * Values:
 * - 000 - Disable
 * - 001 - Reserved
 * - 010 - Reserved
 * - 100 - Normal mode without anti-tearing. For sync display this is the only
 *     mode allowed
 * - 101 - Normal mode with anti-tearing
 * - 110 - Reserved
 * - 111 - Additional command channel is added to the flow handled by DC channel
 *     #5
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5 (5U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5. */
#define BM_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5 (0x000000E0U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5. */
#define BS_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5 (3U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.PROG_CHAN_TYP_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5. */
#define BF_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5) & BM_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5)

/*! @brief Set the PROG_CHAN_TYP_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5) | BF_IPU_DC_WR_CH_CONF_5_PROG_CHAN_TYP_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field CHAN_MASK_DEFAULT_5[8] (RW)
 *
 * Event mask bit for channel #5 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5 (8U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5. */
#define BM_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5 (0x00000100U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5. */
#define BS_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.CHAN_MASK_DEFAULT_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5. */
#define BF_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5) & BM_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5)

/*! @brief Set the CHAN_MASK_DEFAULT_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5) | BF_IPU_DC_WR_CH_CONF_5_CHAN_MASK_DEFAULT_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field FIELD_MODE_5[9] (RW)
 *
 * Field mode bit for channel #5 This bit defines if the channel works in field
 * mode or frame mode; This bit is relevant if the flow is sync flow
 *
 * Values:
 * - 1 - Field mode
 * - 0 - Frame mode
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5 (9U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_FIELD_MODE_5. */
#define BM_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5 (0x00000200U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_FIELD_MODE_5. */
#define BS_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_FIELD_MODE_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_FIELD_MODE_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.FIELD_MODE_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_FIELD_MODE_5. */
#define BF_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5) & BM_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5)

/*! @brief Set the FIELD_MODE_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5) | BF_IPU_DC_WR_CH_CONF_5_FIELD_MODE_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_5, field PROG_START_TIME_5[26:16] (RW)
 *
 * This field defines the delay between display 's vertical synchronization
 * pulse and the start time point of DC's channel 5 window. The delay is defined in
 * pairs of rows. It is used for tearing elimination
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5 (16U) /*!< Bit position for IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5. */
#define BM_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5 (0x07FF0000U) /*!< Bit mask for IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5. */
#define BS_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5 (11U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5 field. */
#define BR_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5(x) (HW_IPU_DC_WR_CH_CONF_5(x).B.PROG_START_TIME_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5. */
#define BF_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5) & BM_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5)

/*! @brief Set the PROG_START_TIME_5 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5(x, v) (HW_IPU_DC_WR_CH_CONF_5_WR(x, (HW_IPU_DC_WR_CH_CONF_5_RD(x) & ~BM_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5) | BF_IPU_DC_WR_CH_CONF_5_PROG_START_TIME_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_ADDR_5 - DC Write Channel 5Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_ADDR_5 - DC Write Channel 5Address Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_addr_5
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_addr_5_bitfields
    {
        uint32_t ST_ADDR_5 : 29;       /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_addr_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_ADDR_5 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_ADDR_5_ADDR(x) ((uintptr_t)(x) + 0x58060U)

#define HW_IPU_DC_WR_CH_ADDR_5(x) (*(__IO hw_ipu_dc_wr_ch_addr_5_t *) HW_IPU_DC_WR_CH_ADDR_5_ADDR(x))
#define HW_IPU_DC_WR_CH_ADDR_5_RD(x) (HW_IPU_DC_WR_CH_ADDR_5(x).U)
#define HW_IPU_DC_WR_CH_ADDR_5_WR(x, v) (HW_IPU_DC_WR_CH_ADDR_5(x).U = (v))
#define HW_IPU_DC_WR_CH_ADDR_5_SET(x, v) (HW_IPU_DC_WR_CH_ADDR_5_WR(x, HW_IPU_DC_WR_CH_ADDR_5_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_ADDR_5_CLR(x, v) (HW_IPU_DC_WR_CH_ADDR_5_WR(x, HW_IPU_DC_WR_CH_ADDR_5_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_ADDR_5_TOG(x, v) (HW_IPU_DC_WR_CH_ADDR_5_WR(x, HW_IPU_DC_WR_CH_ADDR_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_ADDR_5 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_ADDR_5, field ST_ADDR_5[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the write transactions will be done to for channel #5.
 */
/*@{*/
#define BP_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5 (0U) /*!< Bit position for IPU_DC_WR_CH_ADDR_5_ST_ADDR_5. */
#define BM_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_ADDR_5_ST_ADDR_5. */
#define BS_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_ADDR_5_ST_ADDR_5. */

/*! @brief Read current value of the IPU_DC_WR_CH_ADDR_5_ST_ADDR_5 field. */
#define BR_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5(x) (HW_IPU_DC_WR_CH_ADDR_5(x).B.ST_ADDR_5)

/*! @brief Format value for bitfield IPU_DC_WR_CH_ADDR_5_ST_ADDR_5. */
#define BF_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5) & BM_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5)

/*! @brief Set the ST_ADDR_5 field to a new value. */
#define BW_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5(x, v) (HW_IPU_DC_WR_CH_ADDR_5_WR(x, (HW_IPU_DC_WR_CH_ADDR_5_RD(x) & ~BM_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5) | BF_IPU_DC_WR_CH_ADDR_5_ST_ADDR_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL0_CH_5 - DC Routine Link Register 0 Channel 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL0_CH_5 - DC Routine Link Register 0 Channel 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl0_ch_5
{
    uint32_t U;
    struct _hw_ipu_dc_rl0_ch_5_bitfields
    {
        uint32_t COD_NF_PRIORITY_CHAN_5 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NF_START_CHAN_5 : 8; /*!< [15:8]  */
        uint32_t COD_NL_PRIORITY_CHAN_5 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NL_START_CHAN_5 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl0_ch_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL0_CH_5 register
 */
/*@{*/
#define HW_IPU_DC_RL0_CH_5_ADDR(x) ((uintptr_t)(x) + 0x58064U)

#define HW_IPU_DC_RL0_CH_5(x)    (*(__IO hw_ipu_dc_rl0_ch_5_t *) HW_IPU_DC_RL0_CH_5_ADDR(x))
#define HW_IPU_DC_RL0_CH_5_RD(x) (HW_IPU_DC_RL0_CH_5(x).U)
#define HW_IPU_DC_RL0_CH_5_WR(x, v) (HW_IPU_DC_RL0_CH_5(x).U = (v))
#define HW_IPU_DC_RL0_CH_5_SET(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, HW_IPU_DC_RL0_CH_5_RD(x) |  (v)))
#define HW_IPU_DC_RL0_CH_5_CLR(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, HW_IPU_DC_RL0_CH_5_RD(x) & ~(v)))
#define HW_IPU_DC_RL0_CH_5_TOG(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, HW_IPU_DC_RL0_CH_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL0_CH_5 bitfields
 */

/*!
 * @name Register IPU_DC_RL0_CH_5, field COD_NF_PRIORITY_CHAN_5[3:0] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5 (0U) /*!< Bit position for IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5 (0x0000000FU) /*!< Bit mask for IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL0_CH_5(x).B.COD_NF_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5) & BM_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5)

/*! @brief Set the COD_NF_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, (HW_IPU_DC_RL0_CH_5_RD(x) & ~BM_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5) | BF_IPU_DC_RL0_CH_5_COD_NF_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_5, field COD_NF_START_CHAN_5[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new frame event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5 (8U) /*!< Bit position for IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5. */
#define BM_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5. */
#define BS_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5 field. */
#define BR_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5(x) (HW_IPU_DC_RL0_CH_5(x).B.COD_NF_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5. */
#define BF_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5) & BM_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5)

/*! @brief Set the COD_NF_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, (HW_IPU_DC_RL0_CH_5_RD(x) & ~BM_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5) | BF_IPU_DC_RL0_CH_5_COD_NF_START_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_5, field COD_NL_PRIORITY_CHAN_5[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5 (16U) /*!< Bit position for IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5 (0x000F0000U) /*!< Bit mask for IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL0_CH_5(x).B.COD_NL_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5) & BM_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5)

/*! @brief Set the COD_NL_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, (HW_IPU_DC_RL0_CH_5_RD(x) & ~BM_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5) | BF_IPU_DC_RL0_CH_5_COD_NL_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_5, field COD_NL_START_CHAN_5[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new line event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5 (24U) /*!< Bit position for IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5. */
#define BM_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5 (0xFF000000U) /*!< Bit mask for IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5. */
#define BS_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5 field. */
#define BR_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5(x) (HW_IPU_DC_RL0_CH_5(x).B.COD_NL_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5. */
#define BF_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5) & BM_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5)

/*! @brief Set the COD_NL_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5(x, v) (HW_IPU_DC_RL0_CH_5_WR(x, (HW_IPU_DC_RL0_CH_5_RD(x) & ~BM_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5) | BF_IPU_DC_RL0_CH_5_COD_NL_START_CHAN_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_5 - DC Routine Link Register 1 Channel 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_5 - DC Routine Link Register 1 Channel 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_5
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_5_bitfields
    {
        uint32_t COD_EOF_PRIORITY_CHAN_5 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOF_START_CHAN_5 : 8; /*!< [15:8]  */
        uint32_t COD_NFIELD_PRIORITY_CHAN_5 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NFIELD_START_CHAN_5 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_5 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_5_ADDR(x) ((uintptr_t)(x) + 0x58068U)

#define HW_IPU_DC_RL1_CH_5(x)    (*(__IO hw_ipu_dc_rl1_ch_5_t *) HW_IPU_DC_RL1_CH_5_ADDR(x))
#define HW_IPU_DC_RL1_CH_5_RD(x) (HW_IPU_DC_RL1_CH_5(x).U)
#define HW_IPU_DC_RL1_CH_5_WR(x, v) (HW_IPU_DC_RL1_CH_5(x).U = (v))
#define HW_IPU_DC_RL1_CH_5_SET(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, HW_IPU_DC_RL1_CH_5_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_5_CLR(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, HW_IPU_DC_RL1_CH_5_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_5_TOG(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, HW_IPU_DC_RL1_CH_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_5 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_5, field COD_EOF_PRIORITY_CHAN_5[3:0] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5 (0U) /*!< Bit position for IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL1_CH_5(x).B.COD_EOF_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5) & BM_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5)

/*! @brief Set the COD_EOF_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, (HW_IPU_DC_RL1_CH_5_RD(x) & ~BM_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5) | BF_IPU_DC_RL1_CH_5_COD_EOF_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_5, field COD_EOF_START_CHAN_5[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of frame event resides (associated with channel
 * #5)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5 (8U) /*!< Bit position for IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5. */
#define BM_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5. */
#define BS_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5 field. */
#define BR_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5(x) (HW_IPU_DC_RL1_CH_5(x).B.COD_EOF_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5. */
#define BF_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5) & BM_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5)

/*! @brief Set the COD_EOF_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, (HW_IPU_DC_RL1_CH_5_RD(x) & ~BM_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5) | BF_IPU_DC_RL1_CH_5_COD_EOF_START_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_5, field COD_NFIELD_PRIORITY_CHAN_5[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5 (16U) /*!< Bit position for IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5 (0x000F0000U) /*!< Bit mask for IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL1_CH_5(x).B.COD_NFIELD_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5) & BM_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5)

/*! @brief Set the COD_NFIELD_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, (HW_IPU_DC_RL1_CH_5_RD(x) & ~BM_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5) | BF_IPU_DC_RL1_CH_5_COD_NFIELD_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_5, field COD_NFIELD_START_CHAN_5[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new field event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5 (24U) /*!< Bit position for IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5. */
#define BM_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5. */
#define BS_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5 field. */
#define BR_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5(x) (HW_IPU_DC_RL1_CH_5(x).B.COD_NFIELD_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5. */
#define BF_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5) & BM_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5)

/*! @brief Set the COD_NFIELD_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5(x, v) (HW_IPU_DC_RL1_CH_5_WR(x, (HW_IPU_DC_RL1_CH_5_RD(x) & ~BM_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5) | BF_IPU_DC_RL1_CH_5_COD_NFIELD_START_CHAN_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_5 - DC Routine Link Register 2 Channel 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_5 - DC Routine Link Register 2 Channel 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_5
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_5_bitfields
    {
        uint32_t COD_EOL_PRIORITY_CHAN_5 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOL_START_CHAN_5 : 8; /*!< [15:8]  */
        uint32_t COD_EOFIELD_PRIORITY_CHAN_5 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_EOFIELD_START_CHAN_5 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_5 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_5_ADDR(x) ((uintptr_t)(x) + 0x5806CU)

#define HW_IPU_DC_RL2_CH_5(x)    (*(__IO hw_ipu_dc_rl2_ch_5_t *) HW_IPU_DC_RL2_CH_5_ADDR(x))
#define HW_IPU_DC_RL2_CH_5_RD(x) (HW_IPU_DC_RL2_CH_5(x).U)
#define HW_IPU_DC_RL2_CH_5_WR(x, v) (HW_IPU_DC_RL2_CH_5(x).U = (v))
#define HW_IPU_DC_RL2_CH_5_SET(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, HW_IPU_DC_RL2_CH_5_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_5_CLR(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, HW_IPU_DC_RL2_CH_5_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_5_TOG(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, HW_IPU_DC_RL2_CH_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_5 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_5, field COD_EOL_PRIORITY_CHAN_5[3:0] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5 (0U) /*!< Bit position for IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL2_CH_5(x).B.COD_EOL_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5) & BM_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5)

/*! @brief Set the COD_EOL_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, (HW_IPU_DC_RL2_CH_5_RD(x) & ~BM_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5) | BF_IPU_DC_RL2_CH_5_COD_EOL_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_5, field COD_EOL_START_CHAN_5[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of line event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5 (8U) /*!< Bit position for IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5. */
#define BM_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5. */
#define BS_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5 field. */
#define BR_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5(x) (HW_IPU_DC_RL2_CH_5(x).B.COD_EOL_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5. */
#define BF_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5) & BM_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5)

/*! @brief Set the COD_EOL_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, (HW_IPU_DC_RL2_CH_5_RD(x) & ~BM_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5) | BF_IPU_DC_RL2_CH_5_COD_EOL_START_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_5, field COD_EOFIELD_PRIORITY_CHAN_5[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5 (16U) /*!< Bit position for IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5 (0x000F0000U) /*!< Bit mask for IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL2_CH_5(x).B.COD_EOFIELD_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5) & BM_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5)

/*! @brief Set the COD_EOFIELD_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, (HW_IPU_DC_RL2_CH_5_RD(x) & ~BM_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5) | BF_IPU_DC_RL2_CH_5_COD_EOFIELD_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_5, field COD_EOFIELD_START_CHAN_5[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of field event resides (associated with channel
 * #5)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5 (24U) /*!< Bit position for IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5. */
#define BM_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5. */
#define BS_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5 field. */
#define BR_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5(x) (HW_IPU_DC_RL2_CH_5(x).B.COD_EOFIELD_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5. */
#define BF_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5) & BM_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5)

/*! @brief Set the COD_EOFIELD_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5(x, v) (HW_IPU_DC_RL2_CH_5_WR(x, (HW_IPU_DC_RL2_CH_5_RD(x) & ~BM_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5) | BF_IPU_DC_RL2_CH_5_COD_EOFIELD_START_CHAN_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_5 - DC Routine Link Register3 Channel 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_5 - DC Routine Link Register3 Channel 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_5
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_5_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_5 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_5 : 8; /*!< [15:8]  */
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_5 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NEW_CHAN_START_CHAN_5 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_5 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_5_ADDR(x) ((uintptr_t)(x) + 0x58070U)

#define HW_IPU_DC_RL3_CH_5(x)    (*(__IO hw_ipu_dc_rl3_ch_5_t *) HW_IPU_DC_RL3_CH_5_ADDR(x))
#define HW_IPU_DC_RL3_CH_5_RD(x) (HW_IPU_DC_RL3_CH_5(x).U)
#define HW_IPU_DC_RL3_CH_5_WR(x, v) (HW_IPU_DC_RL3_CH_5(x).U = (v))
#define HW_IPU_DC_RL3_CH_5_SET(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, HW_IPU_DC_RL3_CH_5_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_5_CLR(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, HW_IPU_DC_RL3_CH_5_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_5_TOG(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, HW_IPU_DC_RL3_CH_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_5 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_5, field COD_NEW_ADDR_PRIORITY_CHAN_5[3:0] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5 (0U) /*!< Bit position for IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL3_CH_5(x).B.COD_NEW_ADDR_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5) & BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, (HW_IPU_DC_RL3_CH_5_RD(x) & ~BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5) | BF_IPU_DC_RL3_CH_5_COD_NEW_ADDR_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_5, field COD_NEW_ADDR_START_CHAN_5[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5 (8U) /*!< Bit position for IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5. */
#define BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5. */
#define BS_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5 field. */
#define BR_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5(x) (HW_IPU_DC_RL3_CH_5(x).B.COD_NEW_ADDR_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5. */
#define BF_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5) & BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, (HW_IPU_DC_RL3_CH_5_RD(x) & ~BM_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5) | BF_IPU_DC_RL3_CH_5_COD_NEW_ADDR_START_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_5, field COD_NEW_CHAN_PRIORITY_CHAN_5[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5 (16U) /*!< Bit position for IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5 (0x000F0000U) /*!< Bit mask for IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL3_CH_5(x).B.COD_NEW_CHAN_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5) & BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, (HW_IPU_DC_RL3_CH_5_RD(x) & ~BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5) | BF_IPU_DC_RL3_CH_5_COD_NEW_CHAN_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_5, field COD_NEW_CHAN_START_CHAN_5[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5 (24U) /*!< Bit position for IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5. */
#define BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5. */
#define BS_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5 field. */
#define BR_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5(x) (HW_IPU_DC_RL3_CH_5(x).B.COD_NEW_CHAN_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5. */
#define BF_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5) & BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5(x, v) (HW_IPU_DC_RL3_CH_5_WR(x, (HW_IPU_DC_RL3_CH_5_RD(x) & ~BM_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5) | BF_IPU_DC_RL3_CH_5_COD_NEW_CHAN_START_CHAN_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_5 - DC Routine Link Register 4 Channel 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_5 - DC Routine Link Register 4 Channel 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_5
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_5_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_5 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_5 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dc_rl4_ch_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_5 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_5_ADDR(x) ((uintptr_t)(x) + 0x58074U)

#define HW_IPU_DC_RL4_CH_5(x)    (*(__IO hw_ipu_dc_rl4_ch_5_t *) HW_IPU_DC_RL4_CH_5_ADDR(x))
#define HW_IPU_DC_RL4_CH_5_RD(x) (HW_IPU_DC_RL4_CH_5(x).U)
#define HW_IPU_DC_RL4_CH_5_WR(x, v) (HW_IPU_DC_RL4_CH_5(x).U = (v))
#define HW_IPU_DC_RL4_CH_5_SET(x, v) (HW_IPU_DC_RL4_CH_5_WR(x, HW_IPU_DC_RL4_CH_5_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_5_CLR(x, v) (HW_IPU_DC_RL4_CH_5_WR(x, HW_IPU_DC_RL4_CH_5_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_5_TOG(x, v) (HW_IPU_DC_RL4_CH_5_WR(x, HW_IPU_DC_RL4_CH_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_5 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_5, field COD_NEW_DATA_PRIORITY_CHAN_5[3:0] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #5) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5 (0U) /*!< Bit position for IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5. */
#define BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5 (0x0000000FU) /*!< Bit mask for IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5. */
#define BS_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5 (4U) /*!< Bit field size in bits for IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5 field. */
#define BR_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5(x) (HW_IPU_DC_RL4_CH_5(x).B.COD_NEW_DATA_PRIORITY_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5. */
#define BF_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5) & BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5(x, v) (HW_IPU_DC_RL4_CH_5_WR(x, (HW_IPU_DC_RL4_CH_5_RD(x) & ~BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5) | BF_IPU_DC_RL4_CH_5_COD_NEW_DATA_PRIORITY_CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_5, field COD_NEW_DATA_START_CHAN_5[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #5)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5 (8U) /*!< Bit position for IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5. */
#define BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5. */
#define BS_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5. */

/*! @brief Read current value of the IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5 field. */
#define BR_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5(x) (HW_IPU_DC_RL4_CH_5(x).B.COD_NEW_DATA_START_CHAN_5)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5. */
#define BF_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5) & BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5)

/*! @brief Set the COD_NEW_DATA_START_CHAN_5 field to a new value. */
#define BW_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5(x, v) (HW_IPU_DC_RL4_CH_5_WR(x, (HW_IPU_DC_RL4_CH_5_RD(x) & ~BM_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5) | BF_IPU_DC_RL4_CH_5_COD_NEW_DATA_START_CHAN_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF_6 - DC Write Channel 6 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF_6 - DC Write Channel 6 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf_6
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf_6_bitfields
    {
        uint32_t W_SIZE_6 : 2;         /*!< [1:0]  */
        uint32_t PROG_DI_ID_6 : 1;     /*!< [2]  */
        uint32_t PROG_DISP_ID_6 : 2;   /*!< [4:3]  */
        uint32_t PROG_CHAN_TYP_6 : 3;  /*!< [7:5]  */
        uint32_t CHAN_MASK_DEFAULT_6 : 1; /*!< [8]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t PROG_START_TIME_6 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_dc_wr_ch_conf_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF_6 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF_6_ADDR(x) ((uintptr_t)(x) + 0x58078U)

#define HW_IPU_DC_WR_CH_CONF_6(x) (*(__IO hw_ipu_dc_wr_ch_conf_6_t *) HW_IPU_DC_WR_CH_CONF_6_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF_6_RD(x) (HW_IPU_DC_WR_CH_CONF_6(x).U)
#define HW_IPU_DC_WR_CH_CONF_6_WR(x, v) (HW_IPU_DC_WR_CH_CONF_6(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF_6_SET(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, HW_IPU_DC_WR_CH_CONF_6_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF_6_CLR(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF_6_TOG(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, HW_IPU_DC_WR_CH_CONF_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF_6 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field W_SIZE_6[1:0] (RW)
 *
 * Word Size associated with channel #6 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_W_SIZE_6 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_W_SIZE_6. */
#define BM_IPU_DC_WR_CH_CONF_6_W_SIZE_6 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_W_SIZE_6. */
#define BS_IPU_DC_WR_CH_CONF_6_W_SIZE_6 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_W_SIZE_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_W_SIZE_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_W_SIZE_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.W_SIZE_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_W_SIZE_6. */
#define BF_IPU_DC_WR_CH_CONF_6_W_SIZE_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_W_SIZE_6) & BM_IPU_DC_WR_CH_CONF_6_W_SIZE_6)

/*! @brief Set the W_SIZE_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_W_SIZE_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_W_SIZE_6) | BF_IPU_DC_WR_CH_CONF_6_W_SIZE_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field PROG_DI_ID_6[2] (RW)
 *
 * This bit select the DI which a transaction associated with channel #6 can be
 * performed to
 *
 * Values:
 * - 1 - DI #1
 * - 0 - DI #0
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6. */
#define BM_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6. */
#define BS_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.PROG_DI_ID_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6. */
#define BF_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6) & BM_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6)

/*! @brief Set the PROG_DI_ID_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6) | BF_IPU_DC_WR_CH_CONF_6_PROG_DI_ID_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field PROG_DISP_ID_6[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #6.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6. */
#define BM_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6. */
#define BS_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.PROG_DISP_ID_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6. */
#define BF_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6) & BM_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6)

/*! @brief Set the PROG_DISP_ID_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6) | BF_IPU_DC_WR_CH_CONF_6_PROG_DISP_ID_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field PROG_CHAN_TYP_6[7:5] (RW)
 *
 * This field define the mode of operation of channel #6
 *
 * Values:
 * - 000 - Disable
 * - 001 - Reserved
 * - 010 - Reserved
 * - 100 - Normal mode without anti-tearing. For sync display this is the only
 *     mode allowed
 * - 101 - Normal mode with anti-tearing
 * - 110 - Reserved
 * - 111 - Additional command channel is added to the flow handled by DC channel
 *     #6
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6 (5U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6. */
#define BM_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6 (0x000000E0U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6. */
#define BS_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6 (3U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.PROG_CHAN_TYP_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6. */
#define BF_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6) & BM_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6)

/*! @brief Set the PROG_CHAN_TYP_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6) | BF_IPU_DC_WR_CH_CONF_6_PROG_CHAN_TYP_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field CHAN_MASK_DEFAULT_6[8] (RW)
 *
 * Event mask bit for channel #6 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6 (8U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6. */
#define BM_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6 (0x00000100U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6. */
#define BS_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.CHAN_MASK_DEFAULT_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6. */
#define BF_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6) & BM_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6)

/*! @brief Set the CHAN_MASK_DEFAULT_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6) | BF_IPU_DC_WR_CH_CONF_6_CHAN_MASK_DEFAULT_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF_6, field PROG_START_TIME_6[26:16] (RW)
 *
 * This field defines the delay between display 's vertical synchronization
 * pulse and the start time point of DC's channel 6 window. The delay is defined in
 * pairs of rows. It is used for tearing elimination
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6 (16U) /*!< Bit position for IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6. */
#define BM_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6 (0x07FF0000U) /*!< Bit mask for IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6. */
#define BS_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6 (11U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6 field. */
#define BR_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6(x) (HW_IPU_DC_WR_CH_CONF_6(x).B.PROG_START_TIME_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6. */
#define BF_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6) & BM_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6)

/*! @brief Set the PROG_START_TIME_6 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6(x, v) (HW_IPU_DC_WR_CH_CONF_6_WR(x, (HW_IPU_DC_WR_CH_CONF_6_RD(x) & ~BM_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6) | BF_IPU_DC_WR_CH_CONF_6_PROG_START_TIME_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_ADDR_6 - DC Write Channel 6 Address Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_ADDR_6 - DC Write Channel 6 Address Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_addr_6
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_addr_6_bitfields
    {
        uint32_t ST_ADDR_6 : 29;       /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_addr_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_ADDR_6 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_ADDR_6_ADDR(x) ((uintptr_t)(x) + 0x5807CU)

#define HW_IPU_DC_WR_CH_ADDR_6(x) (*(__IO hw_ipu_dc_wr_ch_addr_6_t *) HW_IPU_DC_WR_CH_ADDR_6_ADDR(x))
#define HW_IPU_DC_WR_CH_ADDR_6_RD(x) (HW_IPU_DC_WR_CH_ADDR_6(x).U)
#define HW_IPU_DC_WR_CH_ADDR_6_WR(x, v) (HW_IPU_DC_WR_CH_ADDR_6(x).U = (v))
#define HW_IPU_DC_WR_CH_ADDR_6_SET(x, v) (HW_IPU_DC_WR_CH_ADDR_6_WR(x, HW_IPU_DC_WR_CH_ADDR_6_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_ADDR_6_CLR(x, v) (HW_IPU_DC_WR_CH_ADDR_6_WR(x, HW_IPU_DC_WR_CH_ADDR_6_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_ADDR_6_TOG(x, v) (HW_IPU_DC_WR_CH_ADDR_6_WR(x, HW_IPU_DC_WR_CH_ADDR_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_ADDR_6 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_ADDR_6, field ST_ADDR_6[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the write transactions will be done to for channel #6.
 */
/*@{*/
#define BP_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6 (0U) /*!< Bit position for IPU_DC_WR_CH_ADDR_6_ST_ADDR_6. */
#define BM_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_ADDR_6_ST_ADDR_6. */
#define BS_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_ADDR_6_ST_ADDR_6. */

/*! @brief Read current value of the IPU_DC_WR_CH_ADDR_6_ST_ADDR_6 field. */
#define BR_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6(x) (HW_IPU_DC_WR_CH_ADDR_6(x).B.ST_ADDR_6)

/*! @brief Format value for bitfield IPU_DC_WR_CH_ADDR_6_ST_ADDR_6. */
#define BF_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6) & BM_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6)

/*! @brief Set the ST_ADDR_6 field to a new value. */
#define BW_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6(x, v) (HW_IPU_DC_WR_CH_ADDR_6_WR(x, (HW_IPU_DC_WR_CH_ADDR_6_RD(x) & ~BM_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6) | BF_IPU_DC_WR_CH_ADDR_6_ST_ADDR_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL0_CH_6 - DC Routine Link Register 0Channel 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL0_CH_6 - DC Routine Link Register 0Channel 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl0_ch_6
{
    uint32_t U;
    struct _hw_ipu_dc_rl0_ch_6_bitfields
    {
        uint32_t COD_NF_PRIORITY_CHAN_6 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NF_START_CHAN_6 : 8; /*!< [15:8]  */
        uint32_t COD_NL_PRIORITY_CHAN_6 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NL_START_CHAN_6 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl0_ch_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL0_CH_6 register
 */
/*@{*/
#define HW_IPU_DC_RL0_CH_6_ADDR(x) ((uintptr_t)(x) + 0x58080U)

#define HW_IPU_DC_RL0_CH_6(x)    (*(__IO hw_ipu_dc_rl0_ch_6_t *) HW_IPU_DC_RL0_CH_6_ADDR(x))
#define HW_IPU_DC_RL0_CH_6_RD(x) (HW_IPU_DC_RL0_CH_6(x).U)
#define HW_IPU_DC_RL0_CH_6_WR(x, v) (HW_IPU_DC_RL0_CH_6(x).U = (v))
#define HW_IPU_DC_RL0_CH_6_SET(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, HW_IPU_DC_RL0_CH_6_RD(x) |  (v)))
#define HW_IPU_DC_RL0_CH_6_CLR(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, HW_IPU_DC_RL0_CH_6_RD(x) & ~(v)))
#define HW_IPU_DC_RL0_CH_6_TOG(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, HW_IPU_DC_RL0_CH_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL0_CH_6 bitfields
 */

/*!
 * @name Register IPU_DC_RL0_CH_6, field COD_NF_PRIORITY_CHAN_6[3:0] (RW)
 *
 * This field defines the priority of the new frame event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6 (0U) /*!< Bit position for IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6 (0x0000000FU) /*!< Bit mask for IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL0_CH_6(x).B.COD_NF_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6) & BM_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6)

/*! @brief Set the COD_NF_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, (HW_IPU_DC_RL0_CH_6_RD(x) & ~BM_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6) | BF_IPU_DC_RL0_CH_6_COD_NF_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_6, field COD_NF_START_CHAN_6[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new frame event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6 (8U) /*!< Bit position for IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6. */
#define BM_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6. */
#define BS_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6 field. */
#define BR_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6(x) (HW_IPU_DC_RL0_CH_6(x).B.COD_NF_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6. */
#define BF_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6) & BM_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6)

/*! @brief Set the COD_NF_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, (HW_IPU_DC_RL0_CH_6_RD(x) & ~BM_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6) | BF_IPU_DC_RL0_CH_6_COD_NF_START_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_6, field COD_NL_PRIORITY_CHAN_6[19:16] (RW)
 *
 * This field defines the priority of the new line event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6 (16U) /*!< Bit position for IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6 (0x000F0000U) /*!< Bit mask for IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL0_CH_6(x).B.COD_NL_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6) & BM_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6)

/*! @brief Set the COD_NL_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, (HW_IPU_DC_RL0_CH_6_RD(x) & ~BM_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6) | BF_IPU_DC_RL0_CH_6_COD_NL_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL0_CH_6, field COD_NL_START_CHAN_6[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new line event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6 (24U) /*!< Bit position for IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6. */
#define BM_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6 (0xFF000000U) /*!< Bit mask for IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6. */
#define BS_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6 field. */
#define BR_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6(x) (HW_IPU_DC_RL0_CH_6(x).B.COD_NL_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6. */
#define BF_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6) & BM_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6)

/*! @brief Set the COD_NL_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6(x, v) (HW_IPU_DC_RL0_CH_6_WR(x, (HW_IPU_DC_RL0_CH_6_RD(x) & ~BM_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6) | BF_IPU_DC_RL0_CH_6_COD_NL_START_CHAN_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_6 - DC Routine Link Register 1 Channel 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_6 - DC Routine Link Register 1 Channel 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_6
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_6_bitfields
    {
        uint32_t COD_EOF_PRIORITY_CHAN_6 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOF_START_CHAN_6 : 8; /*!< [15:8]  */
        uint32_t COD_NFIELD_PRIORITY_CHAN_6 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NFIELD_START_CHAN_6 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_6 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_6_ADDR(x) ((uintptr_t)(x) + 0x58084U)

#define HW_IPU_DC_RL1_CH_6(x)    (*(__IO hw_ipu_dc_rl1_ch_6_t *) HW_IPU_DC_RL1_CH_6_ADDR(x))
#define HW_IPU_DC_RL1_CH_6_RD(x) (HW_IPU_DC_RL1_CH_6(x).U)
#define HW_IPU_DC_RL1_CH_6_WR(x, v) (HW_IPU_DC_RL1_CH_6(x).U = (v))
#define HW_IPU_DC_RL1_CH_6_SET(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, HW_IPU_DC_RL1_CH_6_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_6_CLR(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, HW_IPU_DC_RL1_CH_6_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_6_TOG(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, HW_IPU_DC_RL1_CH_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_6 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_6, field COD_EOF_PRIORITY_CHAN_6[3:0] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6 (0U) /*!< Bit position for IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL1_CH_6(x).B.COD_EOF_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6) & BM_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6)

/*! @brief Set the COD_EOF_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, (HW_IPU_DC_RL1_CH_6_RD(x) & ~BM_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6) | BF_IPU_DC_RL1_CH_6_COD_EOF_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_6, field COD_EOF_START_CHAN_6[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of frame event resides (associated with channel
 * #6)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6 (8U) /*!< Bit position for IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6. */
#define BM_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6. */
#define BS_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6 field. */
#define BR_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6(x) (HW_IPU_DC_RL1_CH_6(x).B.COD_EOF_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6. */
#define BF_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6) & BM_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6)

/*! @brief Set the COD_EOF_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, (HW_IPU_DC_RL1_CH_6_RD(x) & ~BM_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6) | BF_IPU_DC_RL1_CH_6_COD_EOF_START_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_6, field COD_NFIELD_PRIORITY_CHAN_6[19:16] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6 (16U) /*!< Bit position for IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6 (0x000F0000U) /*!< Bit mask for IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL1_CH_6(x).B.COD_NFIELD_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6) & BM_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6)

/*! @brief Set the COD_NFIELD_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, (HW_IPU_DC_RL1_CH_6_RD(x) & ~BM_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6) | BF_IPU_DC_RL1_CH_6_COD_NFIELD_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_6, field COD_NFIELD_START_CHAN_6[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new field event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6 (24U) /*!< Bit position for IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6. */
#define BM_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6. */
#define BS_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6 field. */
#define BR_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6(x) (HW_IPU_DC_RL1_CH_6(x).B.COD_NFIELD_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6. */
#define BF_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6) & BM_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6)

/*! @brief Set the COD_NFIELD_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6(x, v) (HW_IPU_DC_RL1_CH_6_WR(x, (HW_IPU_DC_RL1_CH_6_RD(x) & ~BM_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6) | BF_IPU_DC_RL1_CH_6_COD_NFIELD_START_CHAN_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_6 - DC Routine Link Register 2 Channel 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_6 - DC Routine Link Register 2 Channel 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_6
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_6_bitfields
    {
        uint32_t COD_EOL_PRIORITY_CHAN_6 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_EOL_START_CHAN_6 : 8; /*!< [15:8]  */
        uint32_t COD_EOFIELD_PRIORITY_CHAN_6 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_EOFIELD_START_CHAN_6 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_6 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_6_ADDR(x) ((uintptr_t)(x) + 0x58088U)

#define HW_IPU_DC_RL2_CH_6(x)    (*(__IO hw_ipu_dc_rl2_ch_6_t *) HW_IPU_DC_RL2_CH_6_ADDR(x))
#define HW_IPU_DC_RL2_CH_6_RD(x) (HW_IPU_DC_RL2_CH_6(x).U)
#define HW_IPU_DC_RL2_CH_6_WR(x, v) (HW_IPU_DC_RL2_CH_6(x).U = (v))
#define HW_IPU_DC_RL2_CH_6_SET(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, HW_IPU_DC_RL2_CH_6_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_6_CLR(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, HW_IPU_DC_RL2_CH_6_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_6_TOG(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, HW_IPU_DC_RL2_CH_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_6 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_6, field COD_EOL_PRIORITY_CHAN_6[3:0] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6 (0U) /*!< Bit position for IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL2_CH_6(x).B.COD_EOL_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6) & BM_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6)

/*! @brief Set the COD_EOL_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, (HW_IPU_DC_RL2_CH_6_RD(x) & ~BM_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6) | BF_IPU_DC_RL2_CH_6_COD_EOL_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_6, field COD_EOL_START_CHAN_6[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of line event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6 (8U) /*!< Bit position for IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6. */
#define BM_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6. */
#define BS_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6 field. */
#define BR_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6(x) (HW_IPU_DC_RL2_CH_6(x).B.COD_EOL_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6. */
#define BF_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6) & BM_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6)

/*! @brief Set the COD_EOL_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, (HW_IPU_DC_RL2_CH_6_RD(x) & ~BM_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6) | BF_IPU_DC_RL2_CH_6_COD_EOL_START_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_6, field COD_EOFIELD_PRIORITY_CHAN_6[19:16] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6 (16U) /*!< Bit position for IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6 (0x000F0000U) /*!< Bit mask for IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL2_CH_6(x).B.COD_EOFIELD_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6) & BM_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6)

/*! @brief Set the COD_EOFIELD_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, (HW_IPU_DC_RL2_CH_6_RD(x) & ~BM_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6) | BF_IPU_DC_RL2_CH_6_COD_EOFIELD_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_6, field COD_EOFIELD_START_CHAN_6[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the end of field event resides (associated with channel
 * #6)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6 (24U) /*!< Bit position for IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6. */
#define BM_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6. */
#define BS_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6 field. */
#define BR_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6(x) (HW_IPU_DC_RL2_CH_6(x).B.COD_EOFIELD_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6. */
#define BF_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6) & BM_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6)

/*! @brief Set the COD_EOFIELD_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6(x, v) (HW_IPU_DC_RL2_CH_6_WR(x, (HW_IPU_DC_RL2_CH_6_RD(x) & ~BM_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6) | BF_IPU_DC_RL2_CH_6_COD_EOFIELD_START_CHAN_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_6 - DC Routine Link Register 3 Channel 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_6 - DC Routine Link Register 3 Channel 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_6
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_6_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_6 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_6 : 8; /*!< [15:8]  */
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_6 : 4; /*!< [19:16]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t COD_NEW_CHAN_START_CHAN_6 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_6 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_6_ADDR(x) ((uintptr_t)(x) + 0x5808CU)

#define HW_IPU_DC_RL3_CH_6(x)    (*(__IO hw_ipu_dc_rl3_ch_6_t *) HW_IPU_DC_RL3_CH_6_ADDR(x))
#define HW_IPU_DC_RL3_CH_6_RD(x) (HW_IPU_DC_RL3_CH_6(x).U)
#define HW_IPU_DC_RL3_CH_6_WR(x, v) (HW_IPU_DC_RL3_CH_6(x).U = (v))
#define HW_IPU_DC_RL3_CH_6_SET(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, HW_IPU_DC_RL3_CH_6_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_6_CLR(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, HW_IPU_DC_RL3_CH_6_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_6_TOG(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, HW_IPU_DC_RL3_CH_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_6 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_6, field COD_NEW_ADDR_PRIORITY_CHAN_6[3:0] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6 (0U) /*!< Bit position for IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL3_CH_6(x).B.COD_NEW_ADDR_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6) & BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, (HW_IPU_DC_RL3_CH_6_RD(x) & ~BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6) | BF_IPU_DC_RL3_CH_6_COD_NEW_ADDR_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_6, field COD_NEW_ADDR_START_CHAN_6[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6 (8U) /*!< Bit position for IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6. */
#define BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6. */
#define BS_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6 field. */
#define BR_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6(x) (HW_IPU_DC_RL3_CH_6(x).B.COD_NEW_ADDR_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6. */
#define BF_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6) & BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, (HW_IPU_DC_RL3_CH_6_RD(x) & ~BM_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6) | BF_IPU_DC_RL3_CH_6_COD_NEW_ADDR_START_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_6, field COD_NEW_CHAN_PRIORITY_CHAN_6[19:16] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6 (16U) /*!< Bit position for IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6 (0x000F0000U) /*!< Bit mask for IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL3_CH_6(x).B.COD_NEW_CHAN_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6) & BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, (HW_IPU_DC_RL3_CH_6_RD(x) & ~BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6) | BF_IPU_DC_RL3_CH_6_COD_NEW_CHAN_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_6, field COD_NEW_CHAN_START_CHAN_6[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6 (24U) /*!< Bit position for IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6. */
#define BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6. */
#define BS_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6 field. */
#define BR_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6(x) (HW_IPU_DC_RL3_CH_6(x).B.COD_NEW_CHAN_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6. */
#define BF_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6) & BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6(x, v) (HW_IPU_DC_RL3_CH_6_WR(x, (HW_IPU_DC_RL3_CH_6_RD(x) & ~BM_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6) | BF_IPU_DC_RL3_CH_6_COD_NEW_CHAN_START_CHAN_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_6 - DC Routine Link Register 4 Channel 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_6 - DC Routine Link Register 4 Channel 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_6
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_6_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_6 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_6 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dc_rl4_ch_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_6 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_6_ADDR(x) ((uintptr_t)(x) + 0x58090U)

#define HW_IPU_DC_RL4_CH_6(x)    (*(__IO hw_ipu_dc_rl4_ch_6_t *) HW_IPU_DC_RL4_CH_6_ADDR(x))
#define HW_IPU_DC_RL4_CH_6_RD(x) (HW_IPU_DC_RL4_CH_6(x).U)
#define HW_IPU_DC_RL4_CH_6_WR(x, v) (HW_IPU_DC_RL4_CH_6(x).U = (v))
#define HW_IPU_DC_RL4_CH_6_SET(x, v) (HW_IPU_DC_RL4_CH_6_WR(x, HW_IPU_DC_RL4_CH_6_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_6_CLR(x, v) (HW_IPU_DC_RL4_CH_6_WR(x, HW_IPU_DC_RL4_CH_6_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_6_TOG(x, v) (HW_IPU_DC_RL4_CH_6_WR(x, HW_IPU_DC_RL4_CH_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_6 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_6, field COD_NEW_DATA_PRIORITY_CHAN_6[3:0] (RW)
 *
 * This field defines the priority of the new field event (associated with
 * channel #6) The priority between the events should be set to a unique value. i.e.
 * two events must not have the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6 (0U) /*!< Bit position for IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6. */
#define BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6 (0x0000000FU) /*!< Bit mask for IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6. */
#define BS_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6 (4U) /*!< Bit field size in bits for IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6 field. */
#define BR_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6(x) (HW_IPU_DC_RL4_CH_6(x).B.COD_NEW_DATA_PRIORITY_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6. */
#define BF_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6) & BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6(x, v) (HW_IPU_DC_RL4_CH_6_WR(x, (HW_IPU_DC_RL4_CH_6_RD(x) & ~BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6) | BF_IPU_DC_RL4_CH_6_COD_NEW_DATA_PRIORITY_CHAN_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_6, field COD_NEW_DATA_START_CHAN_6[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #6)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6 (8U) /*!< Bit position for IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6. */
#define BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6. */
#define BS_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6. */

/*! @brief Read current value of the IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6 field. */
#define BR_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6(x) (HW_IPU_DC_RL4_CH_6(x).B.COD_NEW_DATA_START_CHAN_6)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6. */
#define BF_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6) & BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6)

/*! @brief Set the COD_NEW_DATA_START_CHAN_6 field to a new value. */
#define BW_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6(x, v) (HW_IPU_DC_RL4_CH_6_WR(x, (HW_IPU_DC_RL4_CH_6_RD(x) & ~BM_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6) | BF_IPU_DC_RL4_CH_6_COD_NEW_DATA_START_CHAN_6(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF1_8 - DC Write Channel 8 Configuration 1Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF1_8 - DC Write Channel 8 Configuration 1Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf1_8
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf1_8_bitfields
    {
        uint32_t W_SIZE_8 : 2;         /*!< [1:0]  */
        uint32_t CHAN_MASK_DEFAULT_8 : 1; /*!< [2]  */
        uint32_t MCU_DISP_ID_8 : 2;    /*!< [4:3]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_ipu_dc_wr_ch_conf1_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF1_8 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF1_8_ADDR(x) ((uintptr_t)(x) + 0x58094U)

#define HW_IPU_DC_WR_CH_CONF1_8(x) (*(__IO hw_ipu_dc_wr_ch_conf1_8_t *) HW_IPU_DC_WR_CH_CONF1_8_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF1_8_RD(x) (HW_IPU_DC_WR_CH_CONF1_8(x).U)
#define HW_IPU_DC_WR_CH_CONF1_8_WR(x, v) (HW_IPU_DC_WR_CH_CONF1_8(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF1_8_SET(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, HW_IPU_DC_WR_CH_CONF1_8_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF1_8_CLR(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, HW_IPU_DC_WR_CH_CONF1_8_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF1_8_TOG(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, HW_IPU_DC_WR_CH_CONF1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF1_8 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF1_8, field W_SIZE_8[1:0] (RW)
 *
 * Word Size associated with channel #8 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_8_W_SIZE_8 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF1_8_W_SIZE_8. */
#define BM_IPU_DC_WR_CH_CONF1_8_W_SIZE_8 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_8_W_SIZE_8. */
#define BS_IPU_DC_WR_CH_CONF1_8_W_SIZE_8 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_8_W_SIZE_8. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_8_W_SIZE_8 field. */
#define BR_IPU_DC_WR_CH_CONF1_8_W_SIZE_8(x) (HW_IPU_DC_WR_CH_CONF1_8(x).B.W_SIZE_8)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_8_W_SIZE_8. */
#define BF_IPU_DC_WR_CH_CONF1_8_W_SIZE_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_8_W_SIZE_8) & BM_IPU_DC_WR_CH_CONF1_8_W_SIZE_8)

/*! @brief Set the W_SIZE_8 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_8_W_SIZE_8(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, (HW_IPU_DC_WR_CH_CONF1_8_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_8_W_SIZE_8) | BF_IPU_DC_WR_CH_CONF1_8_W_SIZE_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF1_8, field CHAN_MASK_DEFAULT_8[2] (RW)
 *
 * Event mask bit for channel #8 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8. */
#define BM_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8. */
#define BS_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8 field. */
#define BR_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8(x) (HW_IPU_DC_WR_CH_CONF1_8(x).B.CHAN_MASK_DEFAULT_8)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8. */
#define BF_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8) & BM_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8)

/*! @brief Set the CHAN_MASK_DEFAULT_8 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, (HW_IPU_DC_WR_CH_CONF1_8_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8) | BF_IPU_DC_WR_CH_CONF1_8_CHAN_MASK_DEFAULT_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF1_8, field MCU_DISP_ID_8[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #8.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8. */
#define BM_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8. */
#define BS_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8 field. */
#define BR_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8(x) (HW_IPU_DC_WR_CH_CONF1_8(x).B.MCU_DISP_ID_8)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8. */
#define BF_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8) & BM_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8)

/*! @brief Set the MCU_DISP_ID_8 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8(x, v) (HW_IPU_DC_WR_CH_CONF1_8_WR(x, (HW_IPU_DC_WR_CH_CONF1_8_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8) | BF_IPU_DC_WR_CH_CONF1_8_MCU_DISP_ID_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF2_8 - DC Write Channel 8 Configuration 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF2_8 - DC Write Channel 8 Configuration 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf2_8
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf2_8_bitfields
    {
        uint32_t NEW_ADDR_SPACE_SA_8 : 29; /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_conf2_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF2_8 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF2_8_ADDR(x) ((uintptr_t)(x) + 0x58098U)

#define HW_IPU_DC_WR_CH_CONF2_8(x) (*(__IO hw_ipu_dc_wr_ch_conf2_8_t *) HW_IPU_DC_WR_CH_CONF2_8_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF2_8_RD(x) (HW_IPU_DC_WR_CH_CONF2_8(x).U)
#define HW_IPU_DC_WR_CH_CONF2_8_WR(x, v) (HW_IPU_DC_WR_CH_CONF2_8(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF2_8_SET(x, v) (HW_IPU_DC_WR_CH_CONF2_8_WR(x, HW_IPU_DC_WR_CH_CONF2_8_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF2_8_CLR(x, v) (HW_IPU_DC_WR_CH_CONF2_8_WR(x, HW_IPU_DC_WR_CH_CONF2_8_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF2_8_TOG(x, v) (HW_IPU_DC_WR_CH_CONF2_8_WR(x, HW_IPU_DC_WR_CH_CONF2_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF2_8 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF2_8, field NEW_ADDR_SPACE_SA_8[28:0] (RW)
 *
 * Channel #8 is used for ARM platform direct access to the display. This field
 * defines the base address of the second region accessible on the display
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8. */
#define BM_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8. */
#define BS_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8 field. */
#define BR_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8(x) (HW_IPU_DC_WR_CH_CONF2_8(x).B.NEW_ADDR_SPACE_SA_8)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8. */
#define BF_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8) & BM_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8)

/*! @brief Set the NEW_ADDR_SPACE_SA_8 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8(x, v) (HW_IPU_DC_WR_CH_CONF2_8_WR(x, (HW_IPU_DC_WR_CH_CONF2_8_RD(x) & ~BM_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8) | BF_IPU_DC_WR_CH_CONF2_8_NEW_ADDR_SPACE_SA_8(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_8 - DC Routine Link Register 1 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_8 - DC Routine Link Register 1 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_8_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_8 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_W_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_ADDR_START_CHAN_W_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_8_ADDR(x) ((uintptr_t)(x) + 0x5809CU)

#define HW_IPU_DC_RL1_CH_8(x)    (*(__IO hw_ipu_dc_rl1_ch_8_t *) HW_IPU_DC_RL1_CH_8_ADDR(x))
#define HW_IPU_DC_RL1_CH_8_RD(x) (HW_IPU_DC_RL1_CH_8(x).U)
#define HW_IPU_DC_RL1_CH_8_WR(x, v) (HW_IPU_DC_RL1_CH_8(x).U = (v))
#define HW_IPU_DC_RL1_CH_8_SET(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, HW_IPU_DC_RL1_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_8_CLR(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, HW_IPU_DC_RL1_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_8_TOG(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, HW_IPU_DC_RL1_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_8, field COD_NEW_ADDR_PRIORITY_CHAN_8[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #8, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8 (0U) /*!< Bit position for IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8. */
#define BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8. */
#define BS_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8. */

/*! @brief Read current value of the IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8 field. */
#define BR_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8(x) (HW_IPU_DC_RL1_CH_8(x).B.COD_NEW_ADDR_PRIORITY_CHAN_8)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8. */
#define BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8) & BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_8 field to a new value. */
#define BW_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, (HW_IPU_DC_RL1_CH_8_RD(x) & ~BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8) | BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_PRIORITY_CHAN_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_8, field COD_NEW_ADDR_START_CHAN_W_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #8, first region)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0 (8U) /*!< Bit position for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0. */
#define BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0. */
#define BS_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0 field. */
#define BR_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0(x) (HW_IPU_DC_RL1_CH_8(x).B.COD_NEW_ADDR_START_CHAN_W_8_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0. */
#define BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0) & BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_W_8_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, (HW_IPU_DC_RL1_CH_8_RD(x) & ~BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0) | BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_8, field COD_NEW_ADDR_START_CHAN_W_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #8, second region)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1 (24U) /*!< Bit position for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1. */
#define BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1. */
#define BS_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1 field. */
#define BR_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1(x) (HW_IPU_DC_RL1_CH_8(x).B.COD_NEW_ADDR_START_CHAN_W_8_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1. */
#define BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1) & BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_W_8_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1(x, v) (HW_IPU_DC_RL1_CH_8_WR(x, (HW_IPU_DC_RL1_CH_8_RD(x) & ~BM_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1) | BF_IPU_DC_RL1_CH_8_COD_NEW_ADDR_START_CHAN_W_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_8 - DC Routine Link Register 2 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_8 - DC Routine Link Register 2 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_8_bitfields
    {
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_8 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_CHAN_START_CHAN_W_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_CHAN_START_CHAN_W_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_8_ADDR(x) ((uintptr_t)(x) + 0x580A0U)

#define HW_IPU_DC_RL2_CH_8(x)    (*(__IO hw_ipu_dc_rl2_ch_8_t *) HW_IPU_DC_RL2_CH_8_ADDR(x))
#define HW_IPU_DC_RL2_CH_8_RD(x) (HW_IPU_DC_RL2_CH_8(x).U)
#define HW_IPU_DC_RL2_CH_8_WR(x, v) (HW_IPU_DC_RL2_CH_8(x).U = (v))
#define HW_IPU_DC_RL2_CH_8_SET(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, HW_IPU_DC_RL2_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_8_CLR(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, HW_IPU_DC_RL2_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_8_TOG(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, HW_IPU_DC_RL2_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_8, field COD_NEW_CHAN_PRIORITY_CHAN_8[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #8, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8 (0U) /*!< Bit position for IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8. */
#define BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8. */
#define BS_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8. */

/*! @brief Read current value of the IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8 field. */
#define BR_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8(x) (HW_IPU_DC_RL2_CH_8(x).B.COD_NEW_CHAN_PRIORITY_CHAN_8)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8. */
#define BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8) & BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_8 field to a new value. */
#define BW_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, (HW_IPU_DC_RL2_CH_8_RD(x) & ~BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8) | BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_PRIORITY_CHAN_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_8, field COD_NEW_CHAN_START_CHAN_W_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #8, first region)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0 (8U) /*!< Bit position for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0. */
#define BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0. */
#define BS_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0 field. */
#define BR_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0(x) (HW_IPU_DC_RL2_CH_8(x).B.COD_NEW_CHAN_START_CHAN_W_8_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0. */
#define BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0) & BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_W_8_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, (HW_IPU_DC_RL2_CH_8_RD(x) & ~BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0) | BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_8, field COD_NEW_CHAN_START_CHAN_W_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #8, second region)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1 (24U) /*!< Bit position for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1. */
#define BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1. */
#define BS_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1 field. */
#define BR_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1(x) (HW_IPU_DC_RL2_CH_8(x).B.COD_NEW_CHAN_START_CHAN_W_8_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1. */
#define BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1) & BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_W_8_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1(x, v) (HW_IPU_DC_RL2_CH_8_WR(x, (HW_IPU_DC_RL2_CH_8_RD(x) & ~BM_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1) | BF_IPU_DC_RL2_CH_8_COD_NEW_CHAN_START_CHAN_W_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_8 - DC Routine Link Register 3 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_8 - DC Routine Link Register 3 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_8_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_8 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_W_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_DATA_START_CHAN_W_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_8_ADDR(x) ((uintptr_t)(x) + 0x580A4U)

#define HW_IPU_DC_RL3_CH_8(x)    (*(__IO hw_ipu_dc_rl3_ch_8_t *) HW_IPU_DC_RL3_CH_8_ADDR(x))
#define HW_IPU_DC_RL3_CH_8_RD(x) (HW_IPU_DC_RL3_CH_8(x).U)
#define HW_IPU_DC_RL3_CH_8_WR(x, v) (HW_IPU_DC_RL3_CH_8(x).U = (v))
#define HW_IPU_DC_RL3_CH_8_SET(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, HW_IPU_DC_RL3_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_8_CLR(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, HW_IPU_DC_RL3_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_8_TOG(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, HW_IPU_DC_RL3_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_8, field COD_NEW_DATA_PRIORITY_CHAN_8[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #8, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8 (0U) /*!< Bit position for IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8. */
#define BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8. */
#define BS_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8. */

/*! @brief Read current value of the IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8 field. */
#define BR_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8(x) (HW_IPU_DC_RL3_CH_8(x).B.COD_NEW_DATA_PRIORITY_CHAN_8)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8. */
#define BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8) & BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_8 field to a new value. */
#define BW_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, (HW_IPU_DC_RL3_CH_8_RD(x) & ~BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8) | BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_PRIORITY_CHAN_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_8, field COD_NEW_DATA_START_CHAN_W_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #8,
 * first region)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0 (8U) /*!< Bit position for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0. */
#define BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0. */
#define BS_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0 field. */
#define BR_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0(x) (HW_IPU_DC_RL3_CH_8(x).B.COD_NEW_DATA_START_CHAN_W_8_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0. */
#define BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0) & BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0)

/*! @brief Set the COD_NEW_DATA_START_CHAN_W_8_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, (HW_IPU_DC_RL3_CH_8_RD(x) & ~BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0) | BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_8, field COD_NEW_DATA_START_CHAN_W_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel
 * #8,second region)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1 (24U) /*!< Bit position for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1. */
#define BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1. */
#define BS_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1 field. */
#define BR_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1(x) (HW_IPU_DC_RL3_CH_8(x).B.COD_NEW_DATA_START_CHAN_W_8_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1. */
#define BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1) & BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1)

/*! @brief Set the COD_NEW_DATA_START_CHAN_W_8_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1(x, v) (HW_IPU_DC_RL3_CH_8_WR(x, (HW_IPU_DC_RL3_CH_8_RD(x) & ~BM_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1) | BF_IPU_DC_RL3_CH_8_COD_NEW_DATA_START_CHAN_W_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_8 - DC Routine Link Register 4 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_8 - DC Routine Link Register 4 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_8_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_ADDR_START_CHAN_R_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_ADDR_START_CHAN_R_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl4_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_8_ADDR(x) ((uintptr_t)(x) + 0x580A8U)

#define HW_IPU_DC_RL4_CH_8(x)    (*(__IO hw_ipu_dc_rl4_ch_8_t *) HW_IPU_DC_RL4_CH_8_ADDR(x))
#define HW_IPU_DC_RL4_CH_8_RD(x) (HW_IPU_DC_RL4_CH_8(x).U)
#define HW_IPU_DC_RL4_CH_8_WR(x, v) (HW_IPU_DC_RL4_CH_8(x).U = (v))
#define HW_IPU_DC_RL4_CH_8_SET(x, v) (HW_IPU_DC_RL4_CH_8_WR(x, HW_IPU_DC_RL4_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_8_CLR(x, v) (HW_IPU_DC_RL4_CH_8_WR(x, HW_IPU_DC_RL4_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_8_TOG(x, v) (HW_IPU_DC_RL4_CH_8_WR(x, HW_IPU_DC_RL4_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_8, field COD_NEW_ADDR_START_CHAN_R_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #8, first region)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0 (8U) /*!< Bit position for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0. */
#define BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0. */
#define BS_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0. */

/*! @brief Read current value of the IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0 field. */
#define BR_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0(x) (HW_IPU_DC_RL4_CH_8(x).B.COD_NEW_ADDR_START_CHAN_R_8_0)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0. */
#define BF_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0) & BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_R_8_0 field to a new value. */
#define BW_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0(x, v) (HW_IPU_DC_RL4_CH_8_WR(x, (HW_IPU_DC_RL4_CH_8_RD(x) & ~BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0) | BF_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_8, field COD_NEW_ADDR_START_CHAN_R_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #8, second region)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1 (24U) /*!< Bit position for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1. */
#define BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1. */
#define BS_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1. */

/*! @brief Read current value of the IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1 field. */
#define BR_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1(x) (HW_IPU_DC_RL4_CH_8(x).B.COD_NEW_ADDR_START_CHAN_R_8_1)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1. */
#define BF_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1) & BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_R_8_1 field to a new value. */
#define BW_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1(x, v) (HW_IPU_DC_RL4_CH_8_WR(x, (HW_IPU_DC_RL4_CH_8_RD(x) & ~BM_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1) | BF_IPU_DC_RL4_CH_8_COD_NEW_ADDR_START_CHAN_R_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL5_CH_8 - DC Routine Link Register 5 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL5_CH_8 - DC Routine Link Register 5 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl5_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl5_ch_8_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_CHAN_START_CHAN_R_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_CHAN_START_CHAN_R_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl5_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL5_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL5_CH_8_ADDR(x) ((uintptr_t)(x) + 0x580ACU)

#define HW_IPU_DC_RL5_CH_8(x)    (*(__IO hw_ipu_dc_rl5_ch_8_t *) HW_IPU_DC_RL5_CH_8_ADDR(x))
#define HW_IPU_DC_RL5_CH_8_RD(x) (HW_IPU_DC_RL5_CH_8(x).U)
#define HW_IPU_DC_RL5_CH_8_WR(x, v) (HW_IPU_DC_RL5_CH_8(x).U = (v))
#define HW_IPU_DC_RL5_CH_8_SET(x, v) (HW_IPU_DC_RL5_CH_8_WR(x, HW_IPU_DC_RL5_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL5_CH_8_CLR(x, v) (HW_IPU_DC_RL5_CH_8_WR(x, HW_IPU_DC_RL5_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL5_CH_8_TOG(x, v) (HW_IPU_DC_RL5_CH_8_WR(x, HW_IPU_DC_RL5_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL5_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL5_CH_8, field COD_NEW_CHAN_START_CHAN_R_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #8, first region)
 */
/*@{*/
#define BP_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0 (8U) /*!< Bit position for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0. */
#define BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0. */
#define BS_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0. */

/*! @brief Read current value of the IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0 field. */
#define BR_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0(x) (HW_IPU_DC_RL5_CH_8(x).B.COD_NEW_CHAN_START_CHAN_R_8_0)

/*! @brief Format value for bitfield IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0. */
#define BF_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0) & BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_R_8_0 field to a new value. */
#define BW_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0(x, v) (HW_IPU_DC_RL5_CH_8_WR(x, (HW_IPU_DC_RL5_CH_8_RD(x) & ~BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0) | BF_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL5_CH_8, field COD_NEW_CHAN_START_CHAN_R_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #8, second region)
 */
/*@{*/
#define BP_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1 (24U) /*!< Bit position for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1. */
#define BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1. */
#define BS_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1. */

/*! @brief Read current value of the IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1 field. */
#define BR_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1(x) (HW_IPU_DC_RL5_CH_8(x).B.COD_NEW_CHAN_START_CHAN_R_8_1)

/*! @brief Format value for bitfield IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1. */
#define BF_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1) & BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_R_8_1 field to a new value. */
#define BW_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1(x, v) (HW_IPU_DC_RL5_CH_8_WR(x, (HW_IPU_DC_RL5_CH_8_RD(x) & ~BM_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1) | BF_IPU_DC_RL5_CH_8_COD_NEW_CHAN_START_CHAN_R_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL6_CH_8 - DC Routine Link Register 6 Channel 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL6_CH_8 - DC Routine Link Register 6 Channel 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl6_ch_8
{
    uint32_t U;
    struct _hw_ipu_dc_rl6_ch_8_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_DATA_START_CHAN_R_8_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_DATA_START_CHAN_R_8_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl6_ch_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL6_CH_8 register
 */
/*@{*/
#define HW_IPU_DC_RL6_CH_8_ADDR(x) ((uintptr_t)(x) + 0x580B0U)

#define HW_IPU_DC_RL6_CH_8(x)    (*(__IO hw_ipu_dc_rl6_ch_8_t *) HW_IPU_DC_RL6_CH_8_ADDR(x))
#define HW_IPU_DC_RL6_CH_8_RD(x) (HW_IPU_DC_RL6_CH_8(x).U)
#define HW_IPU_DC_RL6_CH_8_WR(x, v) (HW_IPU_DC_RL6_CH_8(x).U = (v))
#define HW_IPU_DC_RL6_CH_8_SET(x, v) (HW_IPU_DC_RL6_CH_8_WR(x, HW_IPU_DC_RL6_CH_8_RD(x) |  (v)))
#define HW_IPU_DC_RL6_CH_8_CLR(x, v) (HW_IPU_DC_RL6_CH_8_WR(x, HW_IPU_DC_RL6_CH_8_RD(x) & ~(v)))
#define HW_IPU_DC_RL6_CH_8_TOG(x, v) (HW_IPU_DC_RL6_CH_8_WR(x, HW_IPU_DC_RL6_CH_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL6_CH_8 bitfields
 */

/*!
 * @name Register IPU_DC_RL6_CH_8, field COD_NEW_DATA_START_CHAN_R_8_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #8,
 * first region)
 */
/*@{*/
#define BP_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0 (8U) /*!< Bit position for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0. */
#define BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0. */
#define BS_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0 (8U) /*!< Bit field size in bits for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0. */

/*! @brief Read current value of the IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0 field. */
#define BR_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0(x) (HW_IPU_DC_RL6_CH_8(x).B.COD_NEW_DATA_START_CHAN_R_8_0)

/*! @brief Format value for bitfield IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0. */
#define BF_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0) & BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0)

/*! @brief Set the COD_NEW_DATA_START_CHAN_R_8_0 field to a new value. */
#define BW_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0(x, v) (HW_IPU_DC_RL6_CH_8_WR(x, (HW_IPU_DC_RL6_CH_8_RD(x) & ~BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0) | BF_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL6_CH_8, field COD_NEW_DATA_START_CHAN_R_8_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #8,
 * second region)
 */
/*@{*/
#define BP_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1 (24U) /*!< Bit position for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1. */
#define BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1. */
#define BS_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1 (8U) /*!< Bit field size in bits for IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1. */

/*! @brief Read current value of the IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1 field. */
#define BR_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1(x) (HW_IPU_DC_RL6_CH_8(x).B.COD_NEW_DATA_START_CHAN_R_8_1)

/*! @brief Format value for bitfield IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1. */
#define BF_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1) & BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1)

/*! @brief Set the COD_NEW_DATA_START_CHAN_R_8_1 field to a new value. */
#define BW_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1(x, v) (HW_IPU_DC_RL6_CH_8_WR(x, (HW_IPU_DC_RL6_CH_8_RD(x) & ~BM_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1) | BF_IPU_DC_RL6_CH_8_COD_NEW_DATA_START_CHAN_R_8_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF1_9 - DC Write Channel 9 Configuration 1Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF1_9 - DC Write Channel 9 Configuration 1Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf1_9
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf1_9_bitfields
    {
        uint32_t W_SIZE_9 : 2;         /*!< [1:0]  */
        uint32_t CHAN_MASK_DEFAULT_9 : 1; /*!< [2]  */
        uint32_t MCU_DISP_ID_9 : 2;    /*!< [4:3]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_ipu_dc_wr_ch_conf1_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF1_9 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF1_9_ADDR(x) ((uintptr_t)(x) + 0x580B4U)

#define HW_IPU_DC_WR_CH_CONF1_9(x) (*(__IO hw_ipu_dc_wr_ch_conf1_9_t *) HW_IPU_DC_WR_CH_CONF1_9_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF1_9_RD(x) (HW_IPU_DC_WR_CH_CONF1_9(x).U)
#define HW_IPU_DC_WR_CH_CONF1_9_WR(x, v) (HW_IPU_DC_WR_CH_CONF1_9(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF1_9_SET(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, HW_IPU_DC_WR_CH_CONF1_9_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF1_9_CLR(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, HW_IPU_DC_WR_CH_CONF1_9_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF1_9_TOG(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, HW_IPU_DC_WR_CH_CONF1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF1_9 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF1_9, field W_SIZE_9[1:0] (RW)
 *
 * Word Size associated with channel #9 The data coming from the IDMAC is 32bit
 * wide. This field defines the size of the word used by the DC
 *
 * Values:
 * - 00 - 8 bits are used - a 32 bit words includes 4X8bit valid words.
 * - 01 - 16 LSB bits - a 32 bit words includes 2 X16bit valid words.
 * - 10 - 24 MSB bits are used (RGB) - 8 LSB bits are ignored by the DC
 * - 11 - 32 bits are used
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_9_W_SIZE_9 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF1_9_W_SIZE_9. */
#define BM_IPU_DC_WR_CH_CONF1_9_W_SIZE_9 (0x00000003U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_9_W_SIZE_9. */
#define BS_IPU_DC_WR_CH_CONF1_9_W_SIZE_9 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_9_W_SIZE_9. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_9_W_SIZE_9 field. */
#define BR_IPU_DC_WR_CH_CONF1_9_W_SIZE_9(x) (HW_IPU_DC_WR_CH_CONF1_9(x).B.W_SIZE_9)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_9_W_SIZE_9. */
#define BF_IPU_DC_WR_CH_CONF1_9_W_SIZE_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_9_W_SIZE_9) & BM_IPU_DC_WR_CH_CONF1_9_W_SIZE_9)

/*! @brief Set the W_SIZE_9 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_9_W_SIZE_9(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, (HW_IPU_DC_WR_CH_CONF1_9_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_9_W_SIZE_9) | BF_IPU_DC_WR_CH_CONF1_9_W_SIZE_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF1_9, field CHAN_MASK_DEFAULT_9[2] (RW)
 *
 * Event mask bit for channel #9 When more then one event is used during a flow
 * (EOF, EOL, NL, NF, EOFIELD, etc.) masks all the event besides the event that
 * is defined as the highest priority event
 *
 * Values:
 * - 1 - All the events are used - no mask
 * - 0 - Only the highest priority event is used, the rest are masked
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9 (2U) /*!< Bit position for IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9. */
#define BM_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9 (0x00000004U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9. */
#define BS_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9 (1U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9 field. */
#define BR_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9(x) (HW_IPU_DC_WR_CH_CONF1_9(x).B.CHAN_MASK_DEFAULT_9)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9. */
#define BF_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9) & BM_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9)

/*! @brief Set the CHAN_MASK_DEFAULT_9 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, (HW_IPU_DC_WR_CH_CONF1_9_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9) | BF_IPU_DC_WR_CH_CONF1_9_CHAN_MASK_DEFAULT_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_WR_CH_CONF1_9, field MCU_DISP_ID_9[4:3] (RW)
 *
 * The field defines which one of the 4 displays is associated with channel #9.
 *
 * Values:
 * - 00 - display #0
 * - 01 - display #1
 * - 10 - display #2
 * - 11 - display #3
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9 (3U) /*!< Bit position for IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9. */
#define BM_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9 (0x00000018U) /*!< Bit mask for IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9. */
#define BS_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9 (2U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9 field. */
#define BR_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9(x) (HW_IPU_DC_WR_CH_CONF1_9(x).B.MCU_DISP_ID_9)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9. */
#define BF_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9) & BM_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9)

/*! @brief Set the MCU_DISP_ID_9 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9(x, v) (HW_IPU_DC_WR_CH_CONF1_9_WR(x, (HW_IPU_DC_WR_CH_CONF1_9_RD(x) & ~BM_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9) | BF_IPU_DC_WR_CH_CONF1_9_MCU_DISP_ID_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_CONF2_9 - DC Write Channel 9Configuration 2Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_CONF2_9 - DC Write Channel 9Configuration 2Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_conf2_9
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_conf2_9_bitfields
    {
        uint32_t NEW_ADDR_SPACE_SA_9 : 29; /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_conf2_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_CONF2_9 register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_CONF2_9_ADDR(x) ((uintptr_t)(x) + 0x580B8U)

#define HW_IPU_DC_WR_CH_CONF2_9(x) (*(__IO hw_ipu_dc_wr_ch_conf2_9_t *) HW_IPU_DC_WR_CH_CONF2_9_ADDR(x))
#define HW_IPU_DC_WR_CH_CONF2_9_RD(x) (HW_IPU_DC_WR_CH_CONF2_9(x).U)
#define HW_IPU_DC_WR_CH_CONF2_9_WR(x, v) (HW_IPU_DC_WR_CH_CONF2_9(x).U = (v))
#define HW_IPU_DC_WR_CH_CONF2_9_SET(x, v) (HW_IPU_DC_WR_CH_CONF2_9_WR(x, HW_IPU_DC_WR_CH_CONF2_9_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_CONF2_9_CLR(x, v) (HW_IPU_DC_WR_CH_CONF2_9_WR(x, HW_IPU_DC_WR_CH_CONF2_9_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_CONF2_9_TOG(x, v) (HW_IPU_DC_WR_CH_CONF2_9_WR(x, HW_IPU_DC_WR_CH_CONF2_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_CONF2_9 bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_CONF2_9, field NEW_ADDR_SPACE_SA_9[28:0] (RW)
 *
 * Channel #8 is used for ARM platform direct access to the display. This field
 * defines the base address of the second region accessible on the display
 */
/*@{*/
#define BP_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9 (0U) /*!< Bit position for IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9. */
#define BM_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9. */
#define BS_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9 (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9. */

/*! @brief Read current value of the IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9 field. */
#define BR_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9(x) (HW_IPU_DC_WR_CH_CONF2_9(x).B.NEW_ADDR_SPACE_SA_9)

/*! @brief Format value for bitfield IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9. */
#define BF_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9) & BM_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9)

/*! @brief Set the NEW_ADDR_SPACE_SA_9 field to a new value. */
#define BW_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9(x, v) (HW_IPU_DC_WR_CH_CONF2_9_WR(x, (HW_IPU_DC_WR_CH_CONF2_9_RD(x) & ~BM_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9) | BF_IPU_DC_WR_CH_CONF2_9_NEW_ADDR_SPACE_SA_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL1_CH_9 - DC Routine Link Register 1 Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL1_CH_9 - DC Routine Link Register 1 Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl1_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl1_ch_9_bitfields
    {
        uint32_t COD_NEW_ADDR_PRIORITY_CHAN_9 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_ADDR_START_CHAN_W_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_ADDR_START_CHAN_W_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl1_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL1_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL1_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580BCU)

#define HW_IPU_DC_RL1_CH_9(x)    (*(__IO hw_ipu_dc_rl1_ch_9_t *) HW_IPU_DC_RL1_CH_9_ADDR(x))
#define HW_IPU_DC_RL1_CH_9_RD(x) (HW_IPU_DC_RL1_CH_9(x).U)
#define HW_IPU_DC_RL1_CH_9_WR(x, v) (HW_IPU_DC_RL1_CH_9(x).U = (v))
#define HW_IPU_DC_RL1_CH_9_SET(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, HW_IPU_DC_RL1_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL1_CH_9_CLR(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, HW_IPU_DC_RL1_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL1_CH_9_TOG(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, HW_IPU_DC_RL1_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL1_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL1_CH_9, field COD_NEW_ADDR_PRIORITY_CHAN_9[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #9, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9 (0U) /*!< Bit position for IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9. */
#define BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9 (0x0000000FU) /*!< Bit mask for IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9. */
#define BS_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9 (4U) /*!< Bit field size in bits for IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9. */

/*! @brief Read current value of the IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9 field. */
#define BR_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9(x) (HW_IPU_DC_RL1_CH_9(x).B.COD_NEW_ADDR_PRIORITY_CHAN_9)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9. */
#define BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9) & BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9)

/*! @brief Set the COD_NEW_ADDR_PRIORITY_CHAN_9 field to a new value. */
#define BW_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, (HW_IPU_DC_RL1_CH_9_RD(x) & ~BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9) | BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_PRIORITY_CHAN_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_9, field COD_NEW_ADDR_START_CHAN_W_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #9, first region)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0 (8U) /*!< Bit position for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0. */
#define BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0. */
#define BS_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0. */

/*! @brief Read current value of the IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0 field. */
#define BR_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0(x) (HW_IPU_DC_RL1_CH_9(x).B.COD_NEW_ADDR_START_CHAN_W_9_0)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0. */
#define BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0) & BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_W_9_0 field to a new value. */
#define BW_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, (HW_IPU_DC_RL1_CH_9_RD(x) & ~BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0) | BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL1_CH_9, field COD_NEW_ADDR_START_CHAN_W_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #9, second region)
 */
/*@{*/
#define BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1 (24U) /*!< Bit position for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1. */
#define BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1. */
#define BS_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1. */

/*! @brief Read current value of the IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1 field. */
#define BR_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1(x) (HW_IPU_DC_RL1_CH_9(x).B.COD_NEW_ADDR_START_CHAN_W_9_1)

/*! @brief Format value for bitfield IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1. */
#define BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1) & BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_W_9_1 field to a new value. */
#define BW_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1(x, v) (HW_IPU_DC_RL1_CH_9_WR(x, (HW_IPU_DC_RL1_CH_9_RD(x) & ~BM_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1) | BF_IPU_DC_RL1_CH_9_COD_NEW_ADDR_START_CHAN_W_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL2_CH_9 - DC Routine Link Register 2 Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL2_CH_9 - DC Routine Link Register 2 Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl2_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl2_ch_9_bitfields
    {
        uint32_t COD_NEW_CHAN_PRIORITY_CHAN_9 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_CHAN_START_CHAN_W_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_CHAN_START_CHAN_W_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl2_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL2_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL2_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580C0U)

#define HW_IPU_DC_RL2_CH_9(x)    (*(__IO hw_ipu_dc_rl2_ch_9_t *) HW_IPU_DC_RL2_CH_9_ADDR(x))
#define HW_IPU_DC_RL2_CH_9_RD(x) (HW_IPU_DC_RL2_CH_9(x).U)
#define HW_IPU_DC_RL2_CH_9_WR(x, v) (HW_IPU_DC_RL2_CH_9(x).U = (v))
#define HW_IPU_DC_RL2_CH_9_SET(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, HW_IPU_DC_RL2_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL2_CH_9_CLR(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, HW_IPU_DC_RL2_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL2_CH_9_TOG(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, HW_IPU_DC_RL2_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL2_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL2_CH_9, field COD_NEW_CHAN_PRIORITY_CHAN_9[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #9, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9 (0U) /*!< Bit position for IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9. */
#define BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9 (0x0000000FU) /*!< Bit mask for IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9. */
#define BS_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9 (4U) /*!< Bit field size in bits for IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9. */

/*! @brief Read current value of the IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9 field. */
#define BR_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9(x) (HW_IPU_DC_RL2_CH_9(x).B.COD_NEW_CHAN_PRIORITY_CHAN_9)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9. */
#define BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9) & BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9)

/*! @brief Set the COD_NEW_CHAN_PRIORITY_CHAN_9 field to a new value. */
#define BW_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, (HW_IPU_DC_RL2_CH_9_RD(x) & ~BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9) | BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_PRIORITY_CHAN_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_9, field COD_NEW_CHAN_START_CHAN_W_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #9, first region)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0 (8U) /*!< Bit position for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0. */
#define BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0. */
#define BS_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0. */

/*! @brief Read current value of the IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0 field. */
#define BR_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0(x) (HW_IPU_DC_RL2_CH_9(x).B.COD_NEW_CHAN_START_CHAN_W_9_0)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0. */
#define BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0) & BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_W_9_0 field to a new value. */
#define BW_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, (HW_IPU_DC_RL2_CH_9_RD(x) & ~BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0) | BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL2_CH_9, field COD_NEW_CHAN_START_CHAN_W_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #9, second region)
 */
/*@{*/
#define BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1 (24U) /*!< Bit position for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1. */
#define BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1. */
#define BS_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1. */

/*! @brief Read current value of the IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1 field. */
#define BR_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1(x) (HW_IPU_DC_RL2_CH_9(x).B.COD_NEW_CHAN_START_CHAN_W_9_1)

/*! @brief Format value for bitfield IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1. */
#define BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1) & BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_W_9_1 field to a new value. */
#define BW_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1(x, v) (HW_IPU_DC_RL2_CH_9_WR(x, (HW_IPU_DC_RL2_CH_9_RD(x) & ~BM_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1) | BF_IPU_DC_RL2_CH_9_COD_NEW_CHAN_START_CHAN_W_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL3_CH_9 - DC Routine Link Register 3Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL3_CH_9 - DC Routine Link Register 3Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl3_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl3_ch_9_bitfields
    {
        uint32_t COD_NEW_DATA_PRIORITY_CHAN_9 : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t COD_NEW_DATA_START_CHAN_W_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_DATA_START_CHAN_W_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl3_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL3_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL3_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580C4U)

#define HW_IPU_DC_RL3_CH_9(x)    (*(__IO hw_ipu_dc_rl3_ch_9_t *) HW_IPU_DC_RL3_CH_9_ADDR(x))
#define HW_IPU_DC_RL3_CH_9_RD(x) (HW_IPU_DC_RL3_CH_9(x).U)
#define HW_IPU_DC_RL3_CH_9_WR(x, v) (HW_IPU_DC_RL3_CH_9(x).U = (v))
#define HW_IPU_DC_RL3_CH_9_SET(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, HW_IPU_DC_RL3_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL3_CH_9_CLR(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, HW_IPU_DC_RL3_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL3_CH_9_TOG(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, HW_IPU_DC_RL3_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL3_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL3_CH_9, field COD_NEW_DATA_PRIORITY_CHAN_9[3:0] (RW)
 *
 * This field defines the priority of the new address event (associated with
 * channel #9, both regions) The priority between the events should be set to a
 * unique value. i.e. two events must not have the same priority (except 0000 -
 * disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9 (0U) /*!< Bit position for IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9. */
#define BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9 (0x0000000FU) /*!< Bit mask for IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9. */
#define BS_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9 (4U) /*!< Bit field size in bits for IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9. */

/*! @brief Read current value of the IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9 field. */
#define BR_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9(x) (HW_IPU_DC_RL3_CH_9(x).B.COD_NEW_DATA_PRIORITY_CHAN_9)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9. */
#define BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9) & BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9)

/*! @brief Set the COD_NEW_DATA_PRIORITY_CHAN_9 field to a new value. */
#define BW_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, (HW_IPU_DC_RL3_CH_9_RD(x) & ~BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9) | BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_PRIORITY_CHAN_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_9, field COD_NEW_DATA_START_CHAN_W_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #9,
 * first region)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0 (8U) /*!< Bit position for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0. */
#define BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0. */
#define BS_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0. */

/*! @brief Read current value of the IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0 field. */
#define BR_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0(x) (HW_IPU_DC_RL3_CH_9(x).B.COD_NEW_DATA_START_CHAN_W_9_0)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0. */
#define BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0) & BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0)

/*! @brief Set the COD_NEW_DATA_START_CHAN_W_9_0 field to a new value. */
#define BW_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, (HW_IPU_DC_RL3_CH_9_RD(x) & ~BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0) | BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL3_CH_9, field COD_NEW_DATA_START_CHAN_W_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #9,
 * second region)
 */
/*@{*/
#define BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1 (24U) /*!< Bit position for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1. */
#define BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1. */
#define BS_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1. */

/*! @brief Read current value of the IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1 field. */
#define BR_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1(x) (HW_IPU_DC_RL3_CH_9(x).B.COD_NEW_DATA_START_CHAN_W_9_1)

/*! @brief Format value for bitfield IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1. */
#define BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1) & BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1)

/*! @brief Set the COD_NEW_DATA_START_CHAN_W_9_1 field to a new value. */
#define BW_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1(x, v) (HW_IPU_DC_RL3_CH_9_WR(x, (HW_IPU_DC_RL3_CH_9_RD(x) & ~BM_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1) | BF_IPU_DC_RL3_CH_9_COD_NEW_DATA_START_CHAN_W_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL4_CH_9 - DC Routine Link Register 4 Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL4_CH_9 - DC Routine Link Register 4 Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl4_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl4_ch_9_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_ADDR_START_CHAN_R_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_ADDR_START_CHAN_R_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl4_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL4_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL4_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580C8U)

#define HW_IPU_DC_RL4_CH_9(x)    (*(__IO hw_ipu_dc_rl4_ch_9_t *) HW_IPU_DC_RL4_CH_9_ADDR(x))
#define HW_IPU_DC_RL4_CH_9_RD(x) (HW_IPU_DC_RL4_CH_9(x).U)
#define HW_IPU_DC_RL4_CH_9_WR(x, v) (HW_IPU_DC_RL4_CH_9(x).U = (v))
#define HW_IPU_DC_RL4_CH_9_SET(x, v) (HW_IPU_DC_RL4_CH_9_WR(x, HW_IPU_DC_RL4_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL4_CH_9_CLR(x, v) (HW_IPU_DC_RL4_CH_9_WR(x, HW_IPU_DC_RL4_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL4_CH_9_TOG(x, v) (HW_IPU_DC_RL4_CH_9_WR(x, HW_IPU_DC_RL4_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL4_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL4_CH_9, field COD_NEW_ADDR_START_CHAN_R_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #9, first region)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0 (8U) /*!< Bit position for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0. */
#define BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0. */
#define BS_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0. */

/*! @brief Read current value of the IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0 field. */
#define BR_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0(x) (HW_IPU_DC_RL4_CH_9(x).B.COD_NEW_ADDR_START_CHAN_R_9_0)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0. */
#define BF_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0) & BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_R_9_0 field to a new value. */
#define BW_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0(x, v) (HW_IPU_DC_RL4_CH_9_WR(x, (HW_IPU_DC_RL4_CH_9_RD(x) & ~BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0) | BF_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL4_CH_9, field COD_NEW_ADDR_START_CHAN_R_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new address event resides (associated with channel
 * #9, second region)
 */
/*@{*/
#define BP_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1 (24U) /*!< Bit position for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1. */
#define BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1. */
#define BS_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1. */

/*! @brief Read current value of the IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1 field. */
#define BR_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1(x) (HW_IPU_DC_RL4_CH_9(x).B.COD_NEW_ADDR_START_CHAN_R_9_1)

/*! @brief Format value for bitfield IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1. */
#define BF_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1) & BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1)

/*! @brief Set the COD_NEW_ADDR_START_CHAN_R_9_1 field to a new value. */
#define BW_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1(x, v) (HW_IPU_DC_RL4_CH_9_WR(x, (HW_IPU_DC_RL4_CH_9_RD(x) & ~BM_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1) | BF_IPU_DC_RL4_CH_9_COD_NEW_ADDR_START_CHAN_R_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL5_CH_9 - DC Routine Link Register 5 Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL5_CH_9 - DC Routine Link Register 5 Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl5_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl5_ch_9_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_CHAN_START_CHAN_R_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_CHAN_START_CHAN_R_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl5_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL5_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL5_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580CCU)

#define HW_IPU_DC_RL5_CH_9(x)    (*(__IO hw_ipu_dc_rl5_ch_9_t *) HW_IPU_DC_RL5_CH_9_ADDR(x))
#define HW_IPU_DC_RL5_CH_9_RD(x) (HW_IPU_DC_RL5_CH_9(x).U)
#define HW_IPU_DC_RL5_CH_9_WR(x, v) (HW_IPU_DC_RL5_CH_9(x).U = (v))
#define HW_IPU_DC_RL5_CH_9_SET(x, v) (HW_IPU_DC_RL5_CH_9_WR(x, HW_IPU_DC_RL5_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL5_CH_9_CLR(x, v) (HW_IPU_DC_RL5_CH_9_WR(x, HW_IPU_DC_RL5_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL5_CH_9_TOG(x, v) (HW_IPU_DC_RL5_CH_9_WR(x, HW_IPU_DC_RL5_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL5_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL5_CH_9, field COD_NEW_CHAN_START_CHAN_R_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #9, first region)
 */
/*@{*/
#define BP_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0 (8U) /*!< Bit position for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0. */
#define BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0. */
#define BS_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0. */

/*! @brief Read current value of the IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0 field. */
#define BR_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0(x) (HW_IPU_DC_RL5_CH_9(x).B.COD_NEW_CHAN_START_CHAN_R_9_0)

/*! @brief Format value for bitfield IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0. */
#define BF_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0) & BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_R_9_0 field to a new value. */
#define BW_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0(x, v) (HW_IPU_DC_RL5_CH_9_WR(x, (HW_IPU_DC_RL5_CH_9_RD(x) & ~BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0) | BF_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL5_CH_9, field COD_NEW_CHAN_START_CHAN_R_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new channel event resides (associated with channel
 * #9, second region)
 */
/*@{*/
#define BP_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1 (24U) /*!< Bit position for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1. */
#define BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1. */
#define BS_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1. */

/*! @brief Read current value of the IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1 field. */
#define BR_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1(x) (HW_IPU_DC_RL5_CH_9(x).B.COD_NEW_CHAN_START_CHAN_R_9_1)

/*! @brief Format value for bitfield IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1. */
#define BF_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1) & BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1)

/*! @brief Set the COD_NEW_CHAN_START_CHAN_R_9_1 field to a new value. */
#define BW_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1(x, v) (HW_IPU_DC_RL5_CH_9_WR(x, (HW_IPU_DC_RL5_CH_9_RD(x) & ~BM_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1) | BF_IPU_DC_RL5_CH_9_COD_NEW_CHAN_START_CHAN_R_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_RL6_CH_9 - DC Routine Link Register 6 Channel 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_RL6_CH_9 - DC Routine Link Register 6 Channel 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_rl6_ch_9
{
    uint32_t U;
    struct _hw_ipu_dc_rl6_ch_9_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t COD_NEW_DATA_START_CHAN_R_9_0 : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t COD_NEW_DATA_START_CHAN_R_9_1 : 8; /*!< [31:24]  */
    } B;
} hw_ipu_dc_rl6_ch_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_RL6_CH_9 register
 */
/*@{*/
#define HW_IPU_DC_RL6_CH_9_ADDR(x) ((uintptr_t)(x) + 0x580D0U)

#define HW_IPU_DC_RL6_CH_9(x)    (*(__IO hw_ipu_dc_rl6_ch_9_t *) HW_IPU_DC_RL6_CH_9_ADDR(x))
#define HW_IPU_DC_RL6_CH_9_RD(x) (HW_IPU_DC_RL6_CH_9(x).U)
#define HW_IPU_DC_RL6_CH_9_WR(x, v) (HW_IPU_DC_RL6_CH_9(x).U = (v))
#define HW_IPU_DC_RL6_CH_9_SET(x, v) (HW_IPU_DC_RL6_CH_9_WR(x, HW_IPU_DC_RL6_CH_9_RD(x) |  (v)))
#define HW_IPU_DC_RL6_CH_9_CLR(x, v) (HW_IPU_DC_RL6_CH_9_WR(x, HW_IPU_DC_RL6_CH_9_RD(x) & ~(v)))
#define HW_IPU_DC_RL6_CH_9_TOG(x, v) (HW_IPU_DC_RL6_CH_9_WR(x, HW_IPU_DC_RL6_CH_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_RL6_CH_9 bitfields
 */

/*!
 * @name Register IPU_DC_RL6_CH_9, field COD_NEW_DATA_START_CHAN_R_9_0[15:8] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #9,
 * first region)
 */
/*@{*/
#define BP_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0 (8U) /*!< Bit position for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0. */
#define BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0. */
#define BS_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0 (8U) /*!< Bit field size in bits for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0. */

/*! @brief Read current value of the IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0 field. */
#define BR_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0(x) (HW_IPU_DC_RL6_CH_9(x).B.COD_NEW_DATA_START_CHAN_R_9_0)

/*! @brief Format value for bitfield IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0. */
#define BF_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0) & BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0)

/*! @brief Set the COD_NEW_DATA_START_CHAN_R_9_0 field to a new value. */
#define BW_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0(x, v) (HW_IPU_DC_RL6_CH_9_WR(x, (HW_IPU_DC_RL6_CH_9_RD(x) & ~BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0) | BF_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_RL6_CH_9, field COD_NEW_DATA_START_CHAN_R_9_1[31:24] (RW)
 *
 * This field is a pointer to the address within the microcode memory where the
 * routine that handles the new data event resides (associated with channel #9,
 * second region)
 */
/*@{*/
#define BP_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1 (24U) /*!< Bit position for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1. */
#define BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1 (0xFF000000U) /*!< Bit mask for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1. */
#define BS_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1 (8U) /*!< Bit field size in bits for IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1. */

/*! @brief Read current value of the IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1 field. */
#define BR_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1(x) (HW_IPU_DC_RL6_CH_9(x).B.COD_NEW_DATA_START_CHAN_R_9_1)

/*! @brief Format value for bitfield IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1. */
#define BF_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1) & BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1)

/*! @brief Set the COD_NEW_DATA_START_CHAN_R_9_1 field to a new value. */
#define BW_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1(x, v) (HW_IPU_DC_RL6_CH_9_WR(x, (HW_IPU_DC_RL6_CH_9_RD(x) & ~BM_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1) | BF_IPU_DC_RL6_CH_9_COD_NEW_DATA_START_CHAN_R_9_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_GEN - DC General Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_GEN - DC General Register (RW)
 *
 * Reset value: 0x00000060U
 */
typedef union _hw_ipu_dc_gen
{
    uint32_t U;
    struct _hw_ipu_dc_gen_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t SYNC_1_6 : 2;         /*!< [2:1]  */
        uint32_t RESERVED1 : 1;        /*!< [3]  */
        uint32_t MASK_EN : 1;          /*!< [4]  */
        uint32_t MASK4CHAN_5 : 1;      /*!< [5]  */
        uint32_t SYNC_PRIORITY_5 : 1;  /*!< [6]  */
        uint32_t SYNC_PRIORITY_1 : 1;  /*!< [7]  */
        uint32_t DC_CH5_TYPE : 1;      /*!< [8]  */
        uint32_t RESERVED2 : 7;        /*!< [15:9]  */
        uint32_t DC_BKDIV : 8;         /*!< [23:16]  */
        uint32_t DC_BK_EN : 1;         /*!< [24]  */
        uint32_t RESERVED3 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_dc_gen_t;

/*!
 * @name Constants and macros for entire IPU_DC_GEN register
 */
/*@{*/
#define HW_IPU_DC_GEN_ADDR(x)    ((uintptr_t)(x) + 0x580D4U)

#define HW_IPU_DC_GEN(x)         (*(__IO hw_ipu_dc_gen_t *) HW_IPU_DC_GEN_ADDR(x))
#define HW_IPU_DC_GEN_RD(x)      (HW_IPU_DC_GEN(x).U)
#define HW_IPU_DC_GEN_WR(x, v)   (HW_IPU_DC_GEN(x).U = (v))
#define HW_IPU_DC_GEN_SET(x, v)  (HW_IPU_DC_GEN_WR(x, HW_IPU_DC_GEN_RD(x) |  (v)))
#define HW_IPU_DC_GEN_CLR(x, v)  (HW_IPU_DC_GEN_WR(x, HW_IPU_DC_GEN_RD(x) & ~(v)))
#define HW_IPU_DC_GEN_TOG(x, v)  (HW_IPU_DC_GEN_WR(x, HW_IPU_DC_GEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_GEN bitfields
 */

/*!
 * @name Register IPU_DC_GEN, field SYNC_1_6[2:1] (RW)
 *
 * This field
 *
 * Values:
 * - 00 - Channel 1 of the DC handles async flow
 * - 01 - Illegal
 * - 10 - Channel 1 of the DC handles sync flow
 * - 11 - illegal
 */
/*@{*/
#define BP_IPU_DC_GEN_SYNC_1_6 (1U)        /*!< Bit position for IPU_DC_GEN_SYNC_1_6. */
#define BM_IPU_DC_GEN_SYNC_1_6 (0x00000006U) /*!< Bit mask for IPU_DC_GEN_SYNC_1_6. */
#define BS_IPU_DC_GEN_SYNC_1_6 (2U)        /*!< Bit field size in bits for IPU_DC_GEN_SYNC_1_6. */

/*! @brief Read current value of the IPU_DC_GEN_SYNC_1_6 field. */
#define BR_IPU_DC_GEN_SYNC_1_6(x) (HW_IPU_DC_GEN(x).B.SYNC_1_6)

/*! @brief Format value for bitfield IPU_DC_GEN_SYNC_1_6. */
#define BF_IPU_DC_GEN_SYNC_1_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_SYNC_1_6) & BM_IPU_DC_GEN_SYNC_1_6)

/*! @brief Set the SYNC_1_6 field to a new value. */
#define BW_IPU_DC_GEN_SYNC_1_6(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_SYNC_1_6) | BF_IPU_DC_GEN_SYNC_1_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field MASK_EN[4] (RW)
 *
 * Enable of the mask channel
 *
 * Values:
 * - 1 - mask channel is enabled
 * - 0 - mask channel is disabled
 */
/*@{*/
#define BP_IPU_DC_GEN_MASK_EN (4U)         /*!< Bit position for IPU_DC_GEN_MASK_EN. */
#define BM_IPU_DC_GEN_MASK_EN (0x00000010U) /*!< Bit mask for IPU_DC_GEN_MASK_EN. */
#define BS_IPU_DC_GEN_MASK_EN (1U)         /*!< Bit field size in bits for IPU_DC_GEN_MASK_EN. */

/*! @brief Read current value of the IPU_DC_GEN_MASK_EN field. */
#define BR_IPU_DC_GEN_MASK_EN(x) (HW_IPU_DC_GEN(x).B.MASK_EN)

/*! @brief Format value for bitfield IPU_DC_GEN_MASK_EN. */
#define BF_IPU_DC_GEN_MASK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_MASK_EN) & BM_IPU_DC_GEN_MASK_EN)

/*! @brief Set the MASK_EN field to a new value. */
#define BW_IPU_DC_GEN_MASK_EN(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_MASK_EN) | BF_IPU_DC_GEN_MASK_EN(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field MASK4CHAN_5[5] (RW)
 *
 * Sync flow can be associated with a mask channel. Only one sync flow can have
 * a mask. This bit is ignored if MASK_EN is clear
 *
 * Values:
 * - 1 - mask channel is associated to the sync flow via DP
 * - 0 - mask channel is associated to the sync flow via DC (without DP)
 */
/*@{*/
#define BP_IPU_DC_GEN_MASK4CHAN_5 (5U)     /*!< Bit position for IPU_DC_GEN_MASK4CHAN_5. */
#define BM_IPU_DC_GEN_MASK4CHAN_5 (0x00000020U) /*!< Bit mask for IPU_DC_GEN_MASK4CHAN_5. */
#define BS_IPU_DC_GEN_MASK4CHAN_5 (1U)     /*!< Bit field size in bits for IPU_DC_GEN_MASK4CHAN_5. */

/*! @brief Read current value of the IPU_DC_GEN_MASK4CHAN_5 field. */
#define BR_IPU_DC_GEN_MASK4CHAN_5(x) (HW_IPU_DC_GEN(x).B.MASK4CHAN_5)

/*! @brief Format value for bitfield IPU_DC_GEN_MASK4CHAN_5. */
#define BF_IPU_DC_GEN_MASK4CHAN_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_MASK4CHAN_5) & BM_IPU_DC_GEN_MASK4CHAN_5)

/*! @brief Set the MASK4CHAN_5 field to a new value. */
#define BW_IPU_DC_GEN_MASK4CHAN_5(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_MASK4CHAN_5) | BF_IPU_DC_GEN_MASK4CHAN_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field SYNC_PRIORITY_5[6] (RW)
 *
 * When 2 sync flows are running, this bit sets the priority of channel #5. both
 * SYNC_PRIORITY_5 and SYNC_PRIORITY_1 should not have the value of 0 This bit
 * should be
 *
 * Values:
 * - 1 - high priority
 * - 0 - low Priority
 */
/*@{*/
#define BP_IPU_DC_GEN_SYNC_PRIORITY_5 (6U) /*!< Bit position for IPU_DC_GEN_SYNC_PRIORITY_5. */
#define BM_IPU_DC_GEN_SYNC_PRIORITY_5 (0x00000040U) /*!< Bit mask for IPU_DC_GEN_SYNC_PRIORITY_5. */
#define BS_IPU_DC_GEN_SYNC_PRIORITY_5 (1U) /*!< Bit field size in bits for IPU_DC_GEN_SYNC_PRIORITY_5. */

/*! @brief Read current value of the IPU_DC_GEN_SYNC_PRIORITY_5 field. */
#define BR_IPU_DC_GEN_SYNC_PRIORITY_5(x) (HW_IPU_DC_GEN(x).B.SYNC_PRIORITY_5)

/*! @brief Format value for bitfield IPU_DC_GEN_SYNC_PRIORITY_5. */
#define BF_IPU_DC_GEN_SYNC_PRIORITY_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_SYNC_PRIORITY_5) & BM_IPU_DC_GEN_SYNC_PRIORITY_5)

/*! @brief Set the SYNC_PRIORITY_5 field to a new value. */
#define BW_IPU_DC_GEN_SYNC_PRIORITY_5(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_SYNC_PRIORITY_5) | BF_IPU_DC_GEN_SYNC_PRIORITY_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field SYNC_PRIORITY_1[7] (RW)
 *
 * When 2 sync flows are running, this bit sets the priority of channel #1. both
 * SYNC_PRIORITY_5 and SYNC_PRIORITY_1 should not have the value of 0 This bit
 * should be
 *
 * Values:
 * - 1 - high Priority
 * - 0 - low Priority
 */
/*@{*/
#define BP_IPU_DC_GEN_SYNC_PRIORITY_1 (7U) /*!< Bit position for IPU_DC_GEN_SYNC_PRIORITY_1. */
#define BM_IPU_DC_GEN_SYNC_PRIORITY_1 (0x00000080U) /*!< Bit mask for IPU_DC_GEN_SYNC_PRIORITY_1. */
#define BS_IPU_DC_GEN_SYNC_PRIORITY_1 (1U) /*!< Bit field size in bits for IPU_DC_GEN_SYNC_PRIORITY_1. */

/*! @brief Read current value of the IPU_DC_GEN_SYNC_PRIORITY_1 field. */
#define BR_IPU_DC_GEN_SYNC_PRIORITY_1(x) (HW_IPU_DC_GEN(x).B.SYNC_PRIORITY_1)

/*! @brief Format value for bitfield IPU_DC_GEN_SYNC_PRIORITY_1. */
#define BF_IPU_DC_GEN_SYNC_PRIORITY_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_SYNC_PRIORITY_1) & BM_IPU_DC_GEN_SYNC_PRIORITY_1)

/*! @brief Set the SYNC_PRIORITY_1 field to a new value. */
#define BW_IPU_DC_GEN_SYNC_PRIORITY_1(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_SYNC_PRIORITY_1) | BF_IPU_DC_GEN_SYNC_PRIORITY_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field DC_CH5_TYPE[8] (RW)
 *
 * Channel 5 is used for synchronous flow. When this channel is used for
 * accessing asynchronous display that is activated in a synchronous way
 *
 * Values:
 * - 1 - Enable the asynchronous interface via channel 5
 * - 0 - normal mode, synchronous flow via channel 5
 */
/*@{*/
#define BP_IPU_DC_GEN_DC_CH5_TYPE (8U)     /*!< Bit position for IPU_DC_GEN_DC_CH5_TYPE. */
#define BM_IPU_DC_GEN_DC_CH5_TYPE (0x00000100U) /*!< Bit mask for IPU_DC_GEN_DC_CH5_TYPE. */
#define BS_IPU_DC_GEN_DC_CH5_TYPE (1U)     /*!< Bit field size in bits for IPU_DC_GEN_DC_CH5_TYPE. */

/*! @brief Read current value of the IPU_DC_GEN_DC_CH5_TYPE field. */
#define BR_IPU_DC_GEN_DC_CH5_TYPE(x) (HW_IPU_DC_GEN(x).B.DC_CH5_TYPE)

/*! @brief Format value for bitfield IPU_DC_GEN_DC_CH5_TYPE. */
#define BF_IPU_DC_GEN_DC_CH5_TYPE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_DC_CH5_TYPE) & BM_IPU_DC_GEN_DC_CH5_TYPE)

/*! @brief Set the DC_CH5_TYPE field to a new value. */
#define BW_IPU_DC_GEN_DC_CH5_TYPE(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_DC_CH5_TYPE) | BF_IPU_DC_GEN_DC_CH5_TYPE(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field DC_BKDIV[23:16] (RW)
 *
 * Blinking Rate This field defines the blinking rate. The blinking occurs every
 * N-th frame While N is defined by DC_BKDIV
 */
/*@{*/
#define BP_IPU_DC_GEN_DC_BKDIV (16U)       /*!< Bit position for IPU_DC_GEN_DC_BKDIV. */
#define BM_IPU_DC_GEN_DC_BKDIV (0x00FF0000U) /*!< Bit mask for IPU_DC_GEN_DC_BKDIV. */
#define BS_IPU_DC_GEN_DC_BKDIV (8U)        /*!< Bit field size in bits for IPU_DC_GEN_DC_BKDIV. */

/*! @brief Read current value of the IPU_DC_GEN_DC_BKDIV field. */
#define BR_IPU_DC_GEN_DC_BKDIV(x) (HW_IPU_DC_GEN(x).B.DC_BKDIV)

/*! @brief Format value for bitfield IPU_DC_GEN_DC_BKDIV. */
#define BF_IPU_DC_GEN_DC_BKDIV(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_DC_BKDIV) & BM_IPU_DC_GEN_DC_BKDIV)

/*! @brief Set the DC_BKDIV field to a new value. */
#define BW_IPU_DC_GEN_DC_BKDIV(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_DC_BKDIV) | BF_IPU_DC_GEN_DC_BKDIV(v)))
/*@}*/

/*!
 * @name Register IPU_DC_GEN, field DC_BK_EN[24] (RW)
 *
 * Cursor blinking enable
 *
 * Values:
 * - 1 - blinking is enabled
 * - 0 - blinking is disabled
 */
/*@{*/
#define BP_IPU_DC_GEN_DC_BK_EN (24U)       /*!< Bit position for IPU_DC_GEN_DC_BK_EN. */
#define BM_IPU_DC_GEN_DC_BK_EN (0x01000000U) /*!< Bit mask for IPU_DC_GEN_DC_BK_EN. */
#define BS_IPU_DC_GEN_DC_BK_EN (1U)        /*!< Bit field size in bits for IPU_DC_GEN_DC_BK_EN. */

/*! @brief Read current value of the IPU_DC_GEN_DC_BK_EN field. */
#define BR_IPU_DC_GEN_DC_BK_EN(x) (HW_IPU_DC_GEN(x).B.DC_BK_EN)

/*! @brief Format value for bitfield IPU_DC_GEN_DC_BK_EN. */
#define BF_IPU_DC_GEN_DC_BK_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_GEN_DC_BK_EN) & BM_IPU_DC_GEN_DC_BK_EN)

/*! @brief Set the DC_BK_EN field to a new value. */
#define BW_IPU_DC_GEN_DC_BK_EN(x, v) (HW_IPU_DC_GEN_WR(x, (HW_IPU_DC_GEN_RD(x) & ~BM_IPU_DC_GEN_DC_BK_EN) | BF_IPU_DC_GEN_DC_BK_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF1_0 - DC Display Configuration 1 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF1_0 - DC Display Configuration 1 Register 0 (RW)
 *
 * Reset value: 0x00000042U
 */
typedef union _hw_ipu_dc_disp_conf1_0
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf1_0_bitfields
    {
        uint32_t DISP_TYP_0 : 2;       /*!< [1:0]  */
        uint32_t ADDR_INCREMENT_0 : 2; /*!< [3:2]  */
        uint32_t ADDR_BE_L_INC_0 : 2;  /*!< [5:4]  */
        uint32_t MCU_ACC_LB_MASK_0 : 1; /*!< [6]  */
        uint32_t DISP_RD_VALUE_PTR_0 : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dc_disp_conf1_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF1_0 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF1_0_ADDR(x) ((uintptr_t)(x) + 0x580D8U)

#define HW_IPU_DC_DISP_CONF1_0(x) (*(__IO hw_ipu_dc_disp_conf1_0_t *) HW_IPU_DC_DISP_CONF1_0_ADDR(x))
#define HW_IPU_DC_DISP_CONF1_0_RD(x) (HW_IPU_DC_DISP_CONF1_0(x).U)
#define HW_IPU_DC_DISP_CONF1_0_WR(x, v) (HW_IPU_DC_DISP_CONF1_0(x).U = (v))
#define HW_IPU_DC_DISP_CONF1_0_SET(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, HW_IPU_DC_DISP_CONF1_0_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF1_0_CLR(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, HW_IPU_DC_DISP_CONF1_0_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF1_0_TOG(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, HW_IPU_DC_DISP_CONF1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF1_0 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF1_0, field DISP_TYP_0[1:0] (RW)
 *
 * This field defines the type of the display
 *
 * Values:
 * - 00 - Serial accesses display
 * - 01 - Reserved
 * - 10 - parallel display, without byte_enable support
 * - 11 - parallel display, with byte_enable support
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_0_DISP_TYP_0 (0U) /*!< Bit position for IPU_DC_DISP_CONF1_0_DISP_TYP_0. */
#define BM_IPU_DC_DISP_CONF1_0_DISP_TYP_0 (0x00000003U) /*!< Bit mask for IPU_DC_DISP_CONF1_0_DISP_TYP_0. */
#define BS_IPU_DC_DISP_CONF1_0_DISP_TYP_0 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_0_DISP_TYP_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_0_DISP_TYP_0 field. */
#define BR_IPU_DC_DISP_CONF1_0_DISP_TYP_0(x) (HW_IPU_DC_DISP_CONF1_0(x).B.DISP_TYP_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_0_DISP_TYP_0. */
#define BF_IPU_DC_DISP_CONF1_0_DISP_TYP_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_0_DISP_TYP_0) & BM_IPU_DC_DISP_CONF1_0_DISP_TYP_0)

/*! @brief Set the DISP_TYP_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_0_DISP_TYP_0(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, (HW_IPU_DC_DISP_CONF1_0_RD(x) & ~BM_IPU_DC_DISP_CONF1_0_DISP_TYP_0) | BF_IPU_DC_DISP_CONF1_0_DISP_TYP_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_0, field ADDR_INCREMENT_0[3:2] (RW)
 *
 * This field is the increment step for auto increment mode
 *
 * Values:
 * - 00 - Increment the address by 1
 * - 01 - Increment the address by 2
 * - 10 - Increment the address by 3
 * - 11 - Increment the address by 4
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0 (2U) /*!< Bit position for IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0. */
#define BM_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0 (0x0000000CU) /*!< Bit mask for IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0. */
#define BS_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0 field. */
#define BR_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0(x) (HW_IPU_DC_DISP_CONF1_0(x).B.ADDR_INCREMENT_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0. */
#define BF_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0) & BM_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0)

/*! @brief Set the ADDR_INCREMENT_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, (HW_IPU_DC_DISP_CONF1_0_RD(x) & ~BM_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0) | BF_IPU_DC_DISP_CONF1_0_ADDR_INCREMENT_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_0, field ADDR_BE_L_INC_0[5:4] (RW)
 *
 * This bits define the increment mode when the latest access was done with some
 * of the byte enable signals are low, in that case different increment should
 * be done instead of the normal auto increment of the address IF
 * MCU_ACC_LB_MASK_0 is 0 then only 00 and 10 values are allowed.
 *
 * Values:
 * - 00 - No increment
 * - 01 - Increment by 1
 * - 10 - Increment by 2
 * - 11 - Increment by 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0 (4U) /*!< Bit position for IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0. */
#define BM_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0 (0x00000030U) /*!< Bit mask for IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0. */
#define BS_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0 field. */
#define BR_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0(x) (HW_IPU_DC_DISP_CONF1_0(x).B.ADDR_BE_L_INC_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0. */
#define BF_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0) & BM_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0)

/*! @brief Set the ADDR_BE_L_INC_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, (HW_IPU_DC_DISP_CONF1_0_RD(x) & ~BM_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0) | BF_IPU_DC_DISP_CONF1_0_ADDR_BE_L_INC_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_0, field MCU_ACC_LB_MASK_0[6] (RW)
 *
 * The DC compares between the current access to the a calculated address. The
 * calculated address is the next consecutive address following the last address.
 * This bit defines the comparing mode
 *
 * Values:
 * - 1 - The 2 addresses are fully compared
 * - 0 - The 2 addresses are compared, but the ADDR[0] bit of the new address is
 *     ignored
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0 (6U) /*!< Bit position for IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0. */
#define BM_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0 (0x00000040U) /*!< Bit mask for IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0. */
#define BS_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0 field. */
#define BR_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0(x) (HW_IPU_DC_DISP_CONF1_0(x).B.MCU_ACC_LB_MASK_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0. */
#define BF_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0) & BM_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0)

/*! @brief Set the MCU_ACC_LB_MASK_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, (HW_IPU_DC_DISP_CONF1_0_RD(x) & ~BM_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0) | BF_IPU_DC_DISP_CONF1_0_MCU_ACC_LB_MASK_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_0, field DISP_RD_VALUE_PTR_0[7] (RW)
 *
 * When the display works in wait for status mode. The IPU polls the display and
 * compare the value to the value stored on the status DI_READ_DATA_ACK_VALUE
 * and mask it with DI_READ_DATA_MASK. The DC holds 2 sets of mask and value. This
 * field holds a pointer to the corresponding set of mask and value.
 *
 * Values:
 * - 1 - DI_READ_DATA_ACK_VALUE_1 & DI_READ_DATA_MASK_1 are used for display 0
 * - 0 - DI_READ_DATA_ACK_VALUE_0 & DI_READ_DATA_MASK_0 are used for display 0
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0 (7U) /*!< Bit position for IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0. */
#define BM_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0 (0x00000080U) /*!< Bit mask for IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0. */
#define BS_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0 field. */
#define BR_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0(x) (HW_IPU_DC_DISP_CONF1_0(x).B.DISP_RD_VALUE_PTR_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0. */
#define BF_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0) & BM_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0)

/*! @brief Set the DISP_RD_VALUE_PTR_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0(x, v) (HW_IPU_DC_DISP_CONF1_0_WR(x, (HW_IPU_DC_DISP_CONF1_0_RD(x) & ~BM_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0) | BF_IPU_DC_DISP_CONF1_0_DISP_RD_VALUE_PTR_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF1_1 - DC Display Configuration 1 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF1_1 - DC Display Configuration 1 Register 1 (RW)
 *
 * Reset value: 0x00000042U
 */
typedef union _hw_ipu_dc_disp_conf1_1
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf1_1_bitfields
    {
        uint32_t DISP_TYP_1 : 2;       /*!< [1:0]  */
        uint32_t ADDR_INCREMENT_1 : 2; /*!< [3:2]  */
        uint32_t ADDR_BE_L_INC_1 : 2;  /*!< [5:4]  */
        uint32_t MCU_ACC_LB_MASK_1 : 1; /*!< [6]  */
        uint32_t DISP_RD_VALUE_PTR_1 : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dc_disp_conf1_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF1_1 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF1_1_ADDR(x) ((uintptr_t)(x) + 0x580DCU)

#define HW_IPU_DC_DISP_CONF1_1(x) (*(__IO hw_ipu_dc_disp_conf1_1_t *) HW_IPU_DC_DISP_CONF1_1_ADDR(x))
#define HW_IPU_DC_DISP_CONF1_1_RD(x) (HW_IPU_DC_DISP_CONF1_1(x).U)
#define HW_IPU_DC_DISP_CONF1_1_WR(x, v) (HW_IPU_DC_DISP_CONF1_1(x).U = (v))
#define HW_IPU_DC_DISP_CONF1_1_SET(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, HW_IPU_DC_DISP_CONF1_1_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF1_1_CLR(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, HW_IPU_DC_DISP_CONF1_1_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF1_1_TOG(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, HW_IPU_DC_DISP_CONF1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF1_1 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF1_1, field DISP_TYP_1[1:0] (RW)
 *
 * This field defines the type of the display
 *
 * Values:
 * - 00 - Serial accesses display
 * - 01 - Reserved
 * - 10 - parallel display, without byte_enable support
 * - 11 - parallel display, with byte_enable support
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_1_DISP_TYP_1 (0U) /*!< Bit position for IPU_DC_DISP_CONF1_1_DISP_TYP_1. */
#define BM_IPU_DC_DISP_CONF1_1_DISP_TYP_1 (0x00000003U) /*!< Bit mask for IPU_DC_DISP_CONF1_1_DISP_TYP_1. */
#define BS_IPU_DC_DISP_CONF1_1_DISP_TYP_1 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_1_DISP_TYP_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_1_DISP_TYP_1 field. */
#define BR_IPU_DC_DISP_CONF1_1_DISP_TYP_1(x) (HW_IPU_DC_DISP_CONF1_1(x).B.DISP_TYP_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_1_DISP_TYP_1. */
#define BF_IPU_DC_DISP_CONF1_1_DISP_TYP_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_1_DISP_TYP_1) & BM_IPU_DC_DISP_CONF1_1_DISP_TYP_1)

/*! @brief Set the DISP_TYP_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_1_DISP_TYP_1(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, (HW_IPU_DC_DISP_CONF1_1_RD(x) & ~BM_IPU_DC_DISP_CONF1_1_DISP_TYP_1) | BF_IPU_DC_DISP_CONF1_1_DISP_TYP_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_1, field ADDR_INCREMENT_1[3:2] (RW)
 *
 * This field is the increment step for auto increment mode
 *
 * Values:
 * - 00 - Increment the address by 1
 * - 01 - Increment the address by 2
 * - 10 - Increment the address by 3
 * - 11 - Increment the address by 4
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1 (2U) /*!< Bit position for IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1. */
#define BM_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1 (0x0000000CU) /*!< Bit mask for IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1. */
#define BS_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1 field. */
#define BR_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1(x) (HW_IPU_DC_DISP_CONF1_1(x).B.ADDR_INCREMENT_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1. */
#define BF_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1) & BM_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1)

/*! @brief Set the ADDR_INCREMENT_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, (HW_IPU_DC_DISP_CONF1_1_RD(x) & ~BM_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1) | BF_IPU_DC_DISP_CONF1_1_ADDR_INCREMENT_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_1, field ADDR_BE_L_INC_1[5:4] (RW)
 *
 * This bits define the increment mode when the latest access was done with some
 * of the byte enable signals are low, in that case different increment should
 * be done instead of the normal auto increment of the address IF
 * MCU_ACC_LB_MASK_1 is 0 then only 00 and 10 values are allowed.
 *
 * Values:
 * - 00 - No increment
 * - 01 - Increment by 1
 * - 10 - Increment by 2
 * - 11 - Increment by 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1 (4U) /*!< Bit position for IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1. */
#define BM_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1 (0x00000030U) /*!< Bit mask for IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1. */
#define BS_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1 field. */
#define BR_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1(x) (HW_IPU_DC_DISP_CONF1_1(x).B.ADDR_BE_L_INC_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1. */
#define BF_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1) & BM_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1)

/*! @brief Set the ADDR_BE_L_INC_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, (HW_IPU_DC_DISP_CONF1_1_RD(x) & ~BM_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1) | BF_IPU_DC_DISP_CONF1_1_ADDR_BE_L_INC_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_1, field MCU_ACC_LB_MASK_1[6] (RW)
 *
 * The DC compares between the current access to the a calculated address. The
 * calculated address is the next consecutive address following the last address.
 * This bit defines the comparing mode
 *
 * Values:
 * - 1 - The 2 addresses are fully compared
 * - 0 - The 2 addresses are compared, but the ADDR[0] bit of the new address is
 *     ignored
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1 (6U) /*!< Bit position for IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1. */
#define BM_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1 (0x00000040U) /*!< Bit mask for IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1. */
#define BS_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1 field. */
#define BR_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1(x) (HW_IPU_DC_DISP_CONF1_1(x).B.MCU_ACC_LB_MASK_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1. */
#define BF_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1) & BM_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1)

/*! @brief Set the MCU_ACC_LB_MASK_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, (HW_IPU_DC_DISP_CONF1_1_RD(x) & ~BM_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1) | BF_IPU_DC_DISP_CONF1_1_MCU_ACC_LB_MASK_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_1, field DISP_RD_VALUE_PTR_1[7] (RW)
 *
 * When the display works in wait for status mode. The IPU polls the display and
 * compare the value to the value stored on the status DI_READ_DATA_ACK_VALUE
 * and mask it with DI_READ_DATA_MASK. The DC holds 2 sets of mask and value. This
 * field holds a pointer to the corresponding set of mask and value.
 *
 * Values:
 * - 1 - DI_READ_DATA_ACK_VALUE_1 & DI_READ_DATA_MASK_1 are used for display 1
 * - 0 - DI_READ_DATA_ACK_VALUE_0 & DI_READ_DATA_MASK_0 are used for display 1
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1 (7U) /*!< Bit position for IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1. */
#define BM_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1 (0x00000080U) /*!< Bit mask for IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1. */
#define BS_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1 field. */
#define BR_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1(x) (HW_IPU_DC_DISP_CONF1_1(x).B.DISP_RD_VALUE_PTR_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1. */
#define BF_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1) & BM_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1)

/*! @brief Set the DISP_RD_VALUE_PTR_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1(x, v) (HW_IPU_DC_DISP_CONF1_1_WR(x, (HW_IPU_DC_DISP_CONF1_1_RD(x) & ~BM_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1) | BF_IPU_DC_DISP_CONF1_1_DISP_RD_VALUE_PTR_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF1_2 - DC Display Configuration 1 Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF1_2 - DC Display Configuration 1 Register 2 (RW)
 *
 * Reset value: 0x00000042U
 */
typedef union _hw_ipu_dc_disp_conf1_2
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf1_2_bitfields
    {
        uint32_t DISP_TYP_2 : 2;       /*!< [1:0]  */
        uint32_t ADDR_INCREMENT_2 : 2; /*!< [3:2]  */
        uint32_t ADDR_BE_L_INC_2 : 2;  /*!< [5:4]  */
        uint32_t MCU_ACC_LB_MASK_2 : 1; /*!< [6]  */
        uint32_t DISP_RD_VALUE_PTR_2 : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dc_disp_conf1_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF1_2 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF1_2_ADDR(x) ((uintptr_t)(x) + 0x580E0U)

#define HW_IPU_DC_DISP_CONF1_2(x) (*(__IO hw_ipu_dc_disp_conf1_2_t *) HW_IPU_DC_DISP_CONF1_2_ADDR(x))
#define HW_IPU_DC_DISP_CONF1_2_RD(x) (HW_IPU_DC_DISP_CONF1_2(x).U)
#define HW_IPU_DC_DISP_CONF1_2_WR(x, v) (HW_IPU_DC_DISP_CONF1_2(x).U = (v))
#define HW_IPU_DC_DISP_CONF1_2_SET(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, HW_IPU_DC_DISP_CONF1_2_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF1_2_CLR(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, HW_IPU_DC_DISP_CONF1_2_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF1_2_TOG(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, HW_IPU_DC_DISP_CONF1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF1_2 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF1_2, field DISP_TYP_2[1:0] (RW)
 *
 * This field defines the type of the display
 *
 * Values:
 * - 00 - Serial accesses display
 * - 01 - Reserved
 * - 10 - parallel display, without byte_enable support
 * - 11 - parallel display, with byte_enable support
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_2_DISP_TYP_2 (0U) /*!< Bit position for IPU_DC_DISP_CONF1_2_DISP_TYP_2. */
#define BM_IPU_DC_DISP_CONF1_2_DISP_TYP_2 (0x00000003U) /*!< Bit mask for IPU_DC_DISP_CONF1_2_DISP_TYP_2. */
#define BS_IPU_DC_DISP_CONF1_2_DISP_TYP_2 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_2_DISP_TYP_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_2_DISP_TYP_2 field. */
#define BR_IPU_DC_DISP_CONF1_2_DISP_TYP_2(x) (HW_IPU_DC_DISP_CONF1_2(x).B.DISP_TYP_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_2_DISP_TYP_2. */
#define BF_IPU_DC_DISP_CONF1_2_DISP_TYP_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_2_DISP_TYP_2) & BM_IPU_DC_DISP_CONF1_2_DISP_TYP_2)

/*! @brief Set the DISP_TYP_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_2_DISP_TYP_2(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, (HW_IPU_DC_DISP_CONF1_2_RD(x) & ~BM_IPU_DC_DISP_CONF1_2_DISP_TYP_2) | BF_IPU_DC_DISP_CONF1_2_DISP_TYP_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_2, field ADDR_INCREMENT_2[3:2] (RW)
 *
 * This field is the increment step for auto increment mode
 *
 * Values:
 * - 00 - Increment the address by 1
 * - 01 - Increment the address by 2
 * - 10 - Increment the address by 3
 * - 11 - Increment the address by 4
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2 (2U) /*!< Bit position for IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2. */
#define BM_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2 (0x0000000CU) /*!< Bit mask for IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2. */
#define BS_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2 field. */
#define BR_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2(x) (HW_IPU_DC_DISP_CONF1_2(x).B.ADDR_INCREMENT_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2. */
#define BF_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2) & BM_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2)

/*! @brief Set the ADDR_INCREMENT_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, (HW_IPU_DC_DISP_CONF1_2_RD(x) & ~BM_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2) | BF_IPU_DC_DISP_CONF1_2_ADDR_INCREMENT_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_2, field ADDR_BE_L_INC_2[5:4] (RW)
 *
 * This bits define the increment mode when the latest access was done with some
 * of the byte enable signals are low, in that case different increment should
 * be done instead of the normal auto increment of the address IF
 * MCU_ACC_LB_MASK_2 is 0 then only 00 and 10 values are allowed.
 *
 * Values:
 * - 00 - No increment
 * - 01 - Increment by 1
 * - 10 - Increment by 2
 * - 11 - Increment by 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2 (4U) /*!< Bit position for IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2. */
#define BM_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2 (0x00000030U) /*!< Bit mask for IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2. */
#define BS_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2 field. */
#define BR_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2(x) (HW_IPU_DC_DISP_CONF1_2(x).B.ADDR_BE_L_INC_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2. */
#define BF_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2) & BM_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2)

/*! @brief Set the ADDR_BE_L_INC_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, (HW_IPU_DC_DISP_CONF1_2_RD(x) & ~BM_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2) | BF_IPU_DC_DISP_CONF1_2_ADDR_BE_L_INC_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_2, field MCU_ACC_LB_MASK_2[6] (RW)
 *
 * The DC compares between the current access to the a calculated address. The
 * calculated address is the next consecutive address following the last address.
 * This bit defines the comparing mode
 *
 * Values:
 * - 1 - The 2 addresses are fully compared
 * - 0 - The 2 addresses are compared, but the ADDR[0] bit of the new address is
 *     ignored
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2 (6U) /*!< Bit position for IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2. */
#define BM_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2 (0x00000040U) /*!< Bit mask for IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2. */
#define BS_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2 field. */
#define BR_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2(x) (HW_IPU_DC_DISP_CONF1_2(x).B.MCU_ACC_LB_MASK_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2. */
#define BF_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2) & BM_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2)

/*! @brief Set the MCU_ACC_LB_MASK_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, (HW_IPU_DC_DISP_CONF1_2_RD(x) & ~BM_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2) | BF_IPU_DC_DISP_CONF1_2_MCU_ACC_LB_MASK_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_2, field DISP_RD_VALUE_PTR_2[7] (RW)
 *
 * When the display works in wait for status mode. The IPU polls the display and
 * compare the value to the value stored on the status DI_READ_DATA_ACK_VALUE
 * and mask it with DI_READ_DATA_MASK. The DC holds 2 sets of mask and value. This
 * field holds a pointer to the corresponding set of mask and value.
 *
 * Values:
 * - 1 - DI_READ_DATA_ACK_VALUE_1 & DI_READ_DATA_MASK_1 are used for display 2
 * - 0 - DI_READ_DATA_ACK_VALUE_0 & DI_READ_DATA_MASK_0 are used for display 2
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2 (7U) /*!< Bit position for IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2. */
#define BM_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2 (0x00000080U) /*!< Bit mask for IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2. */
#define BS_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2 field. */
#define BR_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2(x) (HW_IPU_DC_DISP_CONF1_2(x).B.DISP_RD_VALUE_PTR_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2. */
#define BF_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2) & BM_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2)

/*! @brief Set the DISP_RD_VALUE_PTR_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2(x, v) (HW_IPU_DC_DISP_CONF1_2_WR(x, (HW_IPU_DC_DISP_CONF1_2_RD(x) & ~BM_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2) | BF_IPU_DC_DISP_CONF1_2_DISP_RD_VALUE_PTR_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF1_3 - DC Display Configuration 1 Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF1_3 - DC Display Configuration 1 Register 3 (RW)
 *
 * Reset value: 0x00000042U
 */
typedef union _hw_ipu_dc_disp_conf1_3
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf1_3_bitfields
    {
        uint32_t DISP_TYP_3 : 2;       /*!< [1:0]  */
        uint32_t ADDR_INCREMENT_3 : 2; /*!< [3:2]  */
        uint32_t ADDR_BE_L_INC_3 : 2;  /*!< [5:4]  */
        uint32_t MCU_ACC_LB_MASK_3 : 1; /*!< [6]  */
        uint32_t DISP_RD_VALUE_PTR_3 : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dc_disp_conf1_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF1_3 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF1_3_ADDR(x) ((uintptr_t)(x) + 0x580E4U)

#define HW_IPU_DC_DISP_CONF1_3(x) (*(__IO hw_ipu_dc_disp_conf1_3_t *) HW_IPU_DC_DISP_CONF1_3_ADDR(x))
#define HW_IPU_DC_DISP_CONF1_3_RD(x) (HW_IPU_DC_DISP_CONF1_3(x).U)
#define HW_IPU_DC_DISP_CONF1_3_WR(x, v) (HW_IPU_DC_DISP_CONF1_3(x).U = (v))
#define HW_IPU_DC_DISP_CONF1_3_SET(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, HW_IPU_DC_DISP_CONF1_3_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF1_3_CLR(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, HW_IPU_DC_DISP_CONF1_3_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF1_3_TOG(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, HW_IPU_DC_DISP_CONF1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF1_3 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF1_3, field DISP_TYP_3[1:0] (RW)
 *
 * This field defines the type of the display
 *
 * Values:
 * - 00 - Serial accesses display
 * - 01 - Reserved
 * - 10 - parallel display, without byte_enable support
 * - 11 - parallel display, with byte_enable support
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_3_DISP_TYP_3 (0U) /*!< Bit position for IPU_DC_DISP_CONF1_3_DISP_TYP_3. */
#define BM_IPU_DC_DISP_CONF1_3_DISP_TYP_3 (0x00000003U) /*!< Bit mask for IPU_DC_DISP_CONF1_3_DISP_TYP_3. */
#define BS_IPU_DC_DISP_CONF1_3_DISP_TYP_3 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_3_DISP_TYP_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_3_DISP_TYP_3 field. */
#define BR_IPU_DC_DISP_CONF1_3_DISP_TYP_3(x) (HW_IPU_DC_DISP_CONF1_3(x).B.DISP_TYP_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_3_DISP_TYP_3. */
#define BF_IPU_DC_DISP_CONF1_3_DISP_TYP_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_3_DISP_TYP_3) & BM_IPU_DC_DISP_CONF1_3_DISP_TYP_3)

/*! @brief Set the DISP_TYP_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_3_DISP_TYP_3(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, (HW_IPU_DC_DISP_CONF1_3_RD(x) & ~BM_IPU_DC_DISP_CONF1_3_DISP_TYP_3) | BF_IPU_DC_DISP_CONF1_3_DISP_TYP_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_3, field ADDR_INCREMENT_3[3:2] (RW)
 *
 * This field is the increment step for auto increment mode
 *
 * Values:
 * - 00 - Increment the address by 1
 * - 01 - Increment the address by 2
 * - 10 - Increment the address by 3
 * - 11 - Increment the address by 4
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3 (2U) /*!< Bit position for IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3. */
#define BM_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3 (0x0000000CU) /*!< Bit mask for IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3. */
#define BS_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3 field. */
#define BR_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3(x) (HW_IPU_DC_DISP_CONF1_3(x).B.ADDR_INCREMENT_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3. */
#define BF_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3) & BM_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3)

/*! @brief Set the ADDR_INCREMENT_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, (HW_IPU_DC_DISP_CONF1_3_RD(x) & ~BM_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3) | BF_IPU_DC_DISP_CONF1_3_ADDR_INCREMENT_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_3, field ADDR_BE_L_INC_3[5:4] (RW)
 *
 * This bits define the increment mode when the latest access was done with some
 * of the byte enable signals are low, in that case different increment should
 * be done instead of the normal auto increment of the address IF
 * MCU_ACC_LB_MASK_3 is 0 then only 00 and 10 values are allowed.
 *
 * Values:
 * - 00 - No increment
 * - 01 - Increment by 1
 * - 10 - Increment by 2
 * - 11 - Increment by 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3 (4U) /*!< Bit position for IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3. */
#define BM_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3 (0x00000030U) /*!< Bit mask for IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3. */
#define BS_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3 (2U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3 field. */
#define BR_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3(x) (HW_IPU_DC_DISP_CONF1_3(x).B.ADDR_BE_L_INC_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3. */
#define BF_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3) & BM_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3)

/*! @brief Set the ADDR_BE_L_INC_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, (HW_IPU_DC_DISP_CONF1_3_RD(x) & ~BM_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3) | BF_IPU_DC_DISP_CONF1_3_ADDR_BE_L_INC_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_3, field MCU_ACC_LB_MASK_3[6] (RW)
 *
 * The DC compares between the current access to the a calculated address. The
 * calculated address is the next consecutive address following the last address.
 * This bit defines the comparing mode
 *
 * Values:
 * - 1 - The 2 addresses are fully compared
 * - 0 - The 2 addresses are compared, but the ADDR[0] bit of the new address is
 *     ignored
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3 (6U) /*!< Bit position for IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3. */
#define BM_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3 (0x00000040U) /*!< Bit mask for IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3. */
#define BS_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3 field. */
#define BR_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3(x) (HW_IPU_DC_DISP_CONF1_3(x).B.MCU_ACC_LB_MASK_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3. */
#define BF_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3) & BM_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3)

/*! @brief Set the MCU_ACC_LB_MASK_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, (HW_IPU_DC_DISP_CONF1_3_RD(x) & ~BM_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3) | BF_IPU_DC_DISP_CONF1_3_MCU_ACC_LB_MASK_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_DISP_CONF1_3, field DISP_RD_VALUE_PTR_3[7] (RW)
 *
 * When the display works in wait for status mode. The IPU polls the display and
 * compare the value to the value stored on the status DI_READ_DATA_ACK_VALUE
 * and mask it with DI_READ_DATA_MASK. The DC holds 2 sets of mask and value. This
 * field holds a pointer to the corresponding set of mask and value.
 *
 * Values:
 * - 1 - DI_READ_DATA_ACK_VALUE_1 & DI_READ_DATA_MASK_1 are used for display 3
 * - 0 - DI_READ_DATA_ACK_VALUE_0 & DI_READ_DATA_MASK_0 are used for display 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3 (7U) /*!< Bit position for IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3. */
#define BM_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3 (0x00000080U) /*!< Bit mask for IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3. */
#define BS_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3 (1U) /*!< Bit field size in bits for IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3 field. */
#define BR_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3(x) (HW_IPU_DC_DISP_CONF1_3(x).B.DISP_RD_VALUE_PTR_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3. */
#define BF_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3) & BM_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3)

/*! @brief Set the DISP_RD_VALUE_PTR_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3(x, v) (HW_IPU_DC_DISP_CONF1_3_WR(x, (HW_IPU_DC_DISP_CONF1_3_RD(x) & ~BM_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3) | BF_IPU_DC_DISP_CONF1_3_DISP_RD_VALUE_PTR_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF2_0 - DC Display Configuration 2 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF2_0 - DC Display Configuration 2 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_disp_conf2_0
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf2_0_bitfields
    {
        uint32_t SL_0 : 29;            /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_disp_conf2_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF2_0 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF2_0_ADDR(x) ((uintptr_t)(x) + 0x580E8U)

#define HW_IPU_DC_DISP_CONF2_0(x) (*(__IO hw_ipu_dc_disp_conf2_0_t *) HW_IPU_DC_DISP_CONF2_0_ADDR(x))
#define HW_IPU_DC_DISP_CONF2_0_RD(x) (HW_IPU_DC_DISP_CONF2_0(x).U)
#define HW_IPU_DC_DISP_CONF2_0_WR(x, v) (HW_IPU_DC_DISP_CONF2_0(x).U = (v))
#define HW_IPU_DC_DISP_CONF2_0_SET(x, v) (HW_IPU_DC_DISP_CONF2_0_WR(x, HW_IPU_DC_DISP_CONF2_0_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF2_0_CLR(x, v) (HW_IPU_DC_DISP_CONF2_0_WR(x, HW_IPU_DC_DISP_CONF2_0_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF2_0_TOG(x, v) (HW_IPU_DC_DISP_CONF2_0_WR(x, HW_IPU_DC_DISP_CONF2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF2_0 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF2_0, field SL_0[28:0] (RW)
 *
 * Stride line of display 0
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF2_0_SL_0 (0U)   /*!< Bit position for IPU_DC_DISP_CONF2_0_SL_0. */
#define BM_IPU_DC_DISP_CONF2_0_SL_0 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_DISP_CONF2_0_SL_0. */
#define BS_IPU_DC_DISP_CONF2_0_SL_0 (29U)  /*!< Bit field size in bits for IPU_DC_DISP_CONF2_0_SL_0. */

/*! @brief Read current value of the IPU_DC_DISP_CONF2_0_SL_0 field. */
#define BR_IPU_DC_DISP_CONF2_0_SL_0(x) (HW_IPU_DC_DISP_CONF2_0(x).B.SL_0)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF2_0_SL_0. */
#define BF_IPU_DC_DISP_CONF2_0_SL_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF2_0_SL_0) & BM_IPU_DC_DISP_CONF2_0_SL_0)

/*! @brief Set the SL_0 field to a new value. */
#define BW_IPU_DC_DISP_CONF2_0_SL_0(x, v) (HW_IPU_DC_DISP_CONF2_0_WR(x, (HW_IPU_DC_DISP_CONF2_0_RD(x) & ~BM_IPU_DC_DISP_CONF2_0_SL_0) | BF_IPU_DC_DISP_CONF2_0_SL_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF2_1 - DC Display Configuration 2 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF2_1 - DC Display Configuration 2 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_disp_conf2_1
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf2_1_bitfields
    {
        uint32_t SL_1 : 29;            /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_disp_conf2_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF2_1 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF2_1_ADDR(x) ((uintptr_t)(x) + 0x580ECU)

#define HW_IPU_DC_DISP_CONF2_1(x) (*(__IO hw_ipu_dc_disp_conf2_1_t *) HW_IPU_DC_DISP_CONF2_1_ADDR(x))
#define HW_IPU_DC_DISP_CONF2_1_RD(x) (HW_IPU_DC_DISP_CONF2_1(x).U)
#define HW_IPU_DC_DISP_CONF2_1_WR(x, v) (HW_IPU_DC_DISP_CONF2_1(x).U = (v))
#define HW_IPU_DC_DISP_CONF2_1_SET(x, v) (HW_IPU_DC_DISP_CONF2_1_WR(x, HW_IPU_DC_DISP_CONF2_1_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF2_1_CLR(x, v) (HW_IPU_DC_DISP_CONF2_1_WR(x, HW_IPU_DC_DISP_CONF2_1_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF2_1_TOG(x, v) (HW_IPU_DC_DISP_CONF2_1_WR(x, HW_IPU_DC_DISP_CONF2_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF2_1 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF2_1, field SL_1[28:0] (RW)
 *
 * Stride line of display 1
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF2_1_SL_1 (0U)   /*!< Bit position for IPU_DC_DISP_CONF2_1_SL_1. */
#define BM_IPU_DC_DISP_CONF2_1_SL_1 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_DISP_CONF2_1_SL_1. */
#define BS_IPU_DC_DISP_CONF2_1_SL_1 (29U)  /*!< Bit field size in bits for IPU_DC_DISP_CONF2_1_SL_1. */

/*! @brief Read current value of the IPU_DC_DISP_CONF2_1_SL_1 field. */
#define BR_IPU_DC_DISP_CONF2_1_SL_1(x) (HW_IPU_DC_DISP_CONF2_1(x).B.SL_1)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF2_1_SL_1. */
#define BF_IPU_DC_DISP_CONF2_1_SL_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF2_1_SL_1) & BM_IPU_DC_DISP_CONF2_1_SL_1)

/*! @brief Set the SL_1 field to a new value. */
#define BW_IPU_DC_DISP_CONF2_1_SL_1(x, v) (HW_IPU_DC_DISP_CONF2_1_WR(x, (HW_IPU_DC_DISP_CONF2_1_RD(x) & ~BM_IPU_DC_DISP_CONF2_1_SL_1) | BF_IPU_DC_DISP_CONF2_1_SL_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF2_2 - DC Display Configuration 2 Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF2_2 - DC Display Configuration 2 Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_disp_conf2_2
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf2_2_bitfields
    {
        uint32_t SL_2 : 29;            /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_disp_conf2_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF2_2 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF2_2_ADDR(x) ((uintptr_t)(x) + 0x580F0U)

#define HW_IPU_DC_DISP_CONF2_2(x) (*(__IO hw_ipu_dc_disp_conf2_2_t *) HW_IPU_DC_DISP_CONF2_2_ADDR(x))
#define HW_IPU_DC_DISP_CONF2_2_RD(x) (HW_IPU_DC_DISP_CONF2_2(x).U)
#define HW_IPU_DC_DISP_CONF2_2_WR(x, v) (HW_IPU_DC_DISP_CONF2_2(x).U = (v))
#define HW_IPU_DC_DISP_CONF2_2_SET(x, v) (HW_IPU_DC_DISP_CONF2_2_WR(x, HW_IPU_DC_DISP_CONF2_2_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF2_2_CLR(x, v) (HW_IPU_DC_DISP_CONF2_2_WR(x, HW_IPU_DC_DISP_CONF2_2_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF2_2_TOG(x, v) (HW_IPU_DC_DISP_CONF2_2_WR(x, HW_IPU_DC_DISP_CONF2_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF2_2 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF2_2, field SL_2[28:0] (RW)
 *
 * Stride line of display 2
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF2_2_SL_2 (0U)   /*!< Bit position for IPU_DC_DISP_CONF2_2_SL_2. */
#define BM_IPU_DC_DISP_CONF2_2_SL_2 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_DISP_CONF2_2_SL_2. */
#define BS_IPU_DC_DISP_CONF2_2_SL_2 (29U)  /*!< Bit field size in bits for IPU_DC_DISP_CONF2_2_SL_2. */

/*! @brief Read current value of the IPU_DC_DISP_CONF2_2_SL_2 field. */
#define BR_IPU_DC_DISP_CONF2_2_SL_2(x) (HW_IPU_DC_DISP_CONF2_2(x).B.SL_2)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF2_2_SL_2. */
#define BF_IPU_DC_DISP_CONF2_2_SL_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF2_2_SL_2) & BM_IPU_DC_DISP_CONF2_2_SL_2)

/*! @brief Set the SL_2 field to a new value. */
#define BW_IPU_DC_DISP_CONF2_2_SL_2(x, v) (HW_IPU_DC_DISP_CONF2_2_WR(x, (HW_IPU_DC_DISP_CONF2_2_RD(x) & ~BM_IPU_DC_DISP_CONF2_2_SL_2) | BF_IPU_DC_DISP_CONF2_2_SL_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DISP_CONF2_3 - DC Display Configuration 2 Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DISP_CONF2_3 - DC Display Configuration 2 Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_disp_conf2_3
{
    uint32_t U;
    struct _hw_ipu_dc_disp_conf2_3_bitfields
    {
        uint32_t SL_3 : 29;            /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_disp_conf2_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_DISP_CONF2_3 register
 */
/*@{*/
#define HW_IPU_DC_DISP_CONF2_3_ADDR(x) ((uintptr_t)(x) + 0x580F4U)

#define HW_IPU_DC_DISP_CONF2_3(x) (*(__IO hw_ipu_dc_disp_conf2_3_t *) HW_IPU_DC_DISP_CONF2_3_ADDR(x))
#define HW_IPU_DC_DISP_CONF2_3_RD(x) (HW_IPU_DC_DISP_CONF2_3(x).U)
#define HW_IPU_DC_DISP_CONF2_3_WR(x, v) (HW_IPU_DC_DISP_CONF2_3(x).U = (v))
#define HW_IPU_DC_DISP_CONF2_3_SET(x, v) (HW_IPU_DC_DISP_CONF2_3_WR(x, HW_IPU_DC_DISP_CONF2_3_RD(x) |  (v)))
#define HW_IPU_DC_DISP_CONF2_3_CLR(x, v) (HW_IPU_DC_DISP_CONF2_3_WR(x, HW_IPU_DC_DISP_CONF2_3_RD(x) & ~(v)))
#define HW_IPU_DC_DISP_CONF2_3_TOG(x, v) (HW_IPU_DC_DISP_CONF2_3_WR(x, HW_IPU_DC_DISP_CONF2_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DISP_CONF2_3 bitfields
 */

/*!
 * @name Register IPU_DC_DISP_CONF2_3, field SL_3[28:0] (RW)
 *
 * Stride line of display 3
 */
/*@{*/
#define BP_IPU_DC_DISP_CONF2_3_SL_3 (0U)   /*!< Bit position for IPU_DC_DISP_CONF2_3_SL_3. */
#define BM_IPU_DC_DISP_CONF2_3_SL_3 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_DISP_CONF2_3_SL_3. */
#define BS_IPU_DC_DISP_CONF2_3_SL_3 (29U)  /*!< Bit field size in bits for IPU_DC_DISP_CONF2_3_SL_3. */

/*! @brief Read current value of the IPU_DC_DISP_CONF2_3_SL_3 field. */
#define BR_IPU_DC_DISP_CONF2_3_SL_3(x) (HW_IPU_DC_DISP_CONF2_3(x).B.SL_3)

/*! @brief Format value for bitfield IPU_DC_DISP_CONF2_3_SL_3. */
#define BF_IPU_DC_DISP_CONF2_3_SL_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DISP_CONF2_3_SL_3) & BM_IPU_DC_DISP_CONF2_3_SL_3)

/*! @brief Set the SL_3 field to a new value. */
#define BW_IPU_DC_DISP_CONF2_3_SL_3(x, v) (HW_IPU_DC_DISP_CONF2_3_WR(x, (HW_IPU_DC_DISP_CONF2_3_RD(x) & ~BM_IPU_DC_DISP_CONF2_3_SL_3) | BF_IPU_DC_DISP_CONF2_3_SL_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DI0_CONF_1 - DC DI0Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DI0_CONF_1 - DC DI0Configuration Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_di0_conf_1
{
    uint32_t U;
    struct _hw_ipu_dc_di0_conf_1_bitfields
    {
        uint32_t DI_READ_DATA_MASK_0 : 32; /*!< [31:0]  */
    } B;
} hw_ipu_dc_di0_conf_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_DI0_CONF_1 register
 */
/*@{*/
#define HW_IPU_DC_DI0_CONF_1_ADDR(x) ((uintptr_t)(x) + 0x580F8U)

#define HW_IPU_DC_DI0_CONF_1(x)  (*(__IO hw_ipu_dc_di0_conf_1_t *) HW_IPU_DC_DI0_CONF_1_ADDR(x))
#define HW_IPU_DC_DI0_CONF_1_RD(x) (HW_IPU_DC_DI0_CONF_1(x).U)
#define HW_IPU_DC_DI0_CONF_1_WR(x, v) (HW_IPU_DC_DI0_CONF_1(x).U = (v))
#define HW_IPU_DC_DI0_CONF_1_SET(x, v) (HW_IPU_DC_DI0_CONF_1_WR(x, HW_IPU_DC_DI0_CONF_1_RD(x) |  (v)))
#define HW_IPU_DC_DI0_CONF_1_CLR(x, v) (HW_IPU_DC_DI0_CONF_1_WR(x, HW_IPU_DC_DI0_CONF_1_RD(x) & ~(v)))
#define HW_IPU_DC_DI0_CONF_1_TOG(x, v) (HW_IPU_DC_DI0_CONF_1_WR(x, HW_IPU_DC_DI0_CONF_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DI0_CONF_1 bitfields
 */

/*!
 * @name Register IPU_DC_DI0_CONF_1, field DI_READ_DATA_MASK_0[31:0] (RW)
 *
 * This field defines the mask value of the data read from the display.
 */
/*@{*/
#define BP_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0 (0U) /*!< Bit position for IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0. */
#define BM_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0 (0xFFFFFFFFU) /*!< Bit mask for IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0. */
#define BS_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0 (32U) /*!< Bit field size in bits for IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0. */

/*! @brief Read current value of the IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0 field. */
#define BR_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0(x) (HW_IPU_DC_DI0_CONF_1(x).U)

/*! @brief Format value for bitfield IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0. */
#define BF_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0) & BM_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0)

/*! @brief Set the DI_READ_DATA_MASK_0 field to a new value. */
#define BW_IPU_DC_DI0_CONF_1_DI_READ_DATA_MASK_0(x, v) (HW_IPU_DC_DI0_CONF_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DI0_CONF_2 - DC DI0Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DI0_CONF_2 - DC DI0Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_di0_conf_2
{
    uint32_t U;
    struct _hw_ipu_dc_di0_conf_2_bitfields
    {
        uint32_t DI_READ_DATA_ACK_VALUE_0 : 32; /*!< [31:0]  */
    } B;
} hw_ipu_dc_di0_conf_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_DI0_CONF_2 register
 */
/*@{*/
#define HW_IPU_DC_DI0_CONF_2_ADDR(x) ((uintptr_t)(x) + 0x580FCU)

#define HW_IPU_DC_DI0_CONF_2(x)  (*(__IO hw_ipu_dc_di0_conf_2_t *) HW_IPU_DC_DI0_CONF_2_ADDR(x))
#define HW_IPU_DC_DI0_CONF_2_RD(x) (HW_IPU_DC_DI0_CONF_2(x).U)
#define HW_IPU_DC_DI0_CONF_2_WR(x, v) (HW_IPU_DC_DI0_CONF_2(x).U = (v))
#define HW_IPU_DC_DI0_CONF_2_SET(x, v) (HW_IPU_DC_DI0_CONF_2_WR(x, HW_IPU_DC_DI0_CONF_2_RD(x) |  (v)))
#define HW_IPU_DC_DI0_CONF_2_CLR(x, v) (HW_IPU_DC_DI0_CONF_2_WR(x, HW_IPU_DC_DI0_CONF_2_RD(x) & ~(v)))
#define HW_IPU_DC_DI0_CONF_2_TOG(x, v) (HW_IPU_DC_DI0_CONF_2_WR(x, HW_IPU_DC_DI0_CONF_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DI0_CONF_2 bitfields
 */

/*!
 * @name Register IPU_DC_DI0_CONF_2, field DI_READ_DATA_ACK_VALUE_0[31:0] (RW)
 *
 * This is the expected data to be read from the display. The value reads from
 * the display is anded with the DI_READ_DATA_MASK_0 and compared with the
 * DI_READ_DATA_ACK_VALUE_0. This field is used for the READ_STATUS task of the DC
 */
/*@{*/
#define BP_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0 (0U) /*!< Bit position for IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0. */
#define BM_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0 (0xFFFFFFFFU) /*!< Bit mask for IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0. */
#define BS_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0 (32U) /*!< Bit field size in bits for IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0. */

/*! @brief Read current value of the IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0 field. */
#define BR_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0(x) (HW_IPU_DC_DI0_CONF_2(x).U)

/*! @brief Format value for bitfield IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0. */
#define BF_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0) & BM_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0)

/*! @brief Set the DI_READ_DATA_ACK_VALUE_0 field to a new value. */
#define BW_IPU_DC_DI0_CONF_2_DI_READ_DATA_ACK_VALUE_0(x, v) (HW_IPU_DC_DI0_CONF_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DI1_CONF_1 - DC DI1Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DI1_CONF_1 - DC DI1Configuration Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_di1_conf_1
{
    uint32_t U;
    struct _hw_ipu_dc_di1_conf_1_bitfields
    {
        uint32_t DI_READ_DATA_MASK_1 : 32; /*!< [31:0]  */
    } B;
} hw_ipu_dc_di1_conf_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_DI1_CONF_1 register
 */
/*@{*/
#define HW_IPU_DC_DI1_CONF_1_ADDR(x) ((uintptr_t)(x) + 0x58100U)

#define HW_IPU_DC_DI1_CONF_1(x)  (*(__IO hw_ipu_dc_di1_conf_1_t *) HW_IPU_DC_DI1_CONF_1_ADDR(x))
#define HW_IPU_DC_DI1_CONF_1_RD(x) (HW_IPU_DC_DI1_CONF_1(x).U)
#define HW_IPU_DC_DI1_CONF_1_WR(x, v) (HW_IPU_DC_DI1_CONF_1(x).U = (v))
#define HW_IPU_DC_DI1_CONF_1_SET(x, v) (HW_IPU_DC_DI1_CONF_1_WR(x, HW_IPU_DC_DI1_CONF_1_RD(x) |  (v)))
#define HW_IPU_DC_DI1_CONF_1_CLR(x, v) (HW_IPU_DC_DI1_CONF_1_WR(x, HW_IPU_DC_DI1_CONF_1_RD(x) & ~(v)))
#define HW_IPU_DC_DI1_CONF_1_TOG(x, v) (HW_IPU_DC_DI1_CONF_1_WR(x, HW_IPU_DC_DI1_CONF_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DI1_CONF_1 bitfields
 */

/*!
 * @name Register IPU_DC_DI1_CONF_1, field DI_READ_DATA_MASK_1[31:0] (RW)
 *
 * This field defines the mask value of the data read from the display.
 */
/*@{*/
#define BP_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1 (0U) /*!< Bit position for IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1. */
#define BM_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1 (0xFFFFFFFFU) /*!< Bit mask for IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1. */
#define BS_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1 (32U) /*!< Bit field size in bits for IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1. */

/*! @brief Read current value of the IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1 field. */
#define BR_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1(x) (HW_IPU_DC_DI1_CONF_1(x).U)

/*! @brief Format value for bitfield IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1. */
#define BF_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1) & BM_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1)

/*! @brief Set the DI_READ_DATA_MASK_1 field to a new value. */
#define BW_IPU_DC_DI1_CONF_1_DI_READ_DATA_MASK_1(x, v) (HW_IPU_DC_DI1_CONF_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_DI1_CONF_2 - DC DI1Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_DI1_CONF_2 - DC DI1Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_di1_conf_2
{
    uint32_t U;
    struct _hw_ipu_dc_di1_conf_2_bitfields
    {
        uint32_t DI_READ_DATA_ACK_VALUE_1 : 32; /*!< [31:0]  */
    } B;
} hw_ipu_dc_di1_conf_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_DI1_CONF_2 register
 */
/*@{*/
#define HW_IPU_DC_DI1_CONF_2_ADDR(x) ((uintptr_t)(x) + 0x58104U)

#define HW_IPU_DC_DI1_CONF_2(x)  (*(__IO hw_ipu_dc_di1_conf_2_t *) HW_IPU_DC_DI1_CONF_2_ADDR(x))
#define HW_IPU_DC_DI1_CONF_2_RD(x) (HW_IPU_DC_DI1_CONF_2(x).U)
#define HW_IPU_DC_DI1_CONF_2_WR(x, v) (HW_IPU_DC_DI1_CONF_2(x).U = (v))
#define HW_IPU_DC_DI1_CONF_2_SET(x, v) (HW_IPU_DC_DI1_CONF_2_WR(x, HW_IPU_DC_DI1_CONF_2_RD(x) |  (v)))
#define HW_IPU_DC_DI1_CONF_2_CLR(x, v) (HW_IPU_DC_DI1_CONF_2_WR(x, HW_IPU_DC_DI1_CONF_2_RD(x) & ~(v)))
#define HW_IPU_DC_DI1_CONF_2_TOG(x, v) (HW_IPU_DC_DI1_CONF_2_WR(x, HW_IPU_DC_DI1_CONF_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_DI1_CONF_2 bitfields
 */

/*!
 * @name Register IPU_DC_DI1_CONF_2, field DI_READ_DATA_ACK_VALUE_1[31:0] (RW)
 *
 * This is the expected data to be read from the display. The value reads from
 * the display is anded with the DI_READ_DATA_MASK_1 and compared with the
 * DI_READ_DATA_ACK_VALUE_1 This field is used for the READ_STATUS task of the DC
 */
/*@{*/
#define BP_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1 (0U) /*!< Bit position for IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1. */
#define BM_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1 (0xFFFFFFFFU) /*!< Bit mask for IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1. */
#define BS_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1 (32U) /*!< Bit field size in bits for IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1. */

/*! @brief Read current value of the IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1 field. */
#define BR_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1(x) (HW_IPU_DC_DI1_CONF_2(x).U)

/*! @brief Format value for bitfield IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1. */
#define BF_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1) & BM_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1)

/*! @brief Set the DI_READ_DATA_ACK_VALUE_1 field to a new value. */
#define BW_IPU_DC_DI1_CONF_2_DI_READ_DATA_ACK_VALUE_1(x, v) (HW_IPU_DC_DI1_CONF_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_0 - DC Mapping Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_0 - DC Mapping Configuration Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_0
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_0_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_0 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_0 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_0 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_1 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_1 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_1 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_0 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_0_ADDR(x) ((uintptr_t)(x) + 0x58108U)

#define HW_IPU_DC_MAP_CONF_0(x)  (*(__IO hw_ipu_dc_map_conf_0_t *) HW_IPU_DC_MAP_CONF_0_ADDR(x))
#define HW_IPU_DC_MAP_CONF_0_RD(x) (HW_IPU_DC_MAP_CONF_0(x).U)
#define HW_IPU_DC_MAP_CONF_0_WR(x, v) (HW_IPU_DC_MAP_CONF_0(x).U = (v))
#define HW_IPU_DC_MAP_CONF_0_SET(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, HW_IPU_DC_MAP_CONF_0_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_0_CLR(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, HW_IPU_DC_MAP_CONF_0_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_0_TOG(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, HW_IPU_DC_MAP_CONF_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_0 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE0_0[4:0] (RW)
 *
 * Mapping pointer #0 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0 (0U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE0_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0)

/*! @brief Set the MAPPING_PNTR_BYTE0_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE1_0[9:5] (RW)
 *
 * Mapping pointer #0 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0 (5U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE1_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0)

/*! @brief Set the MAPPING_PNTR_BYTE1_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE2_0[14:10] (RW)
 *
 * Mapping pointer #0 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0 (10U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE2_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0)

/*! @brief Set the MAPPING_PNTR_BYTE2_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE0_1[20:16] (RW)
 *
 * Mapping pointer #1 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1 (16U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE0_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1)

/*! @brief Set the MAPPING_PNTR_BYTE0_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE0_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE1_1[25:21] (RW)
 *
 * Mapping pointer #1 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1 (21U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE1_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1)

/*! @brief Set the MAPPING_PNTR_BYTE1_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE1_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_0, field MAPPING_PNTR_BYTE2_1[30:26] (RW)
 *
 * Mapping pointer #1 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1 (26U) /*!< Bit position for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1. */
#define BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1. */
#define BS_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1 field. */
#define BR_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1(x) (HW_IPU_DC_MAP_CONF_0(x).B.MAPPING_PNTR_BYTE2_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1. */
#define BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1) & BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1)

/*! @brief Set the MAPPING_PNTR_BYTE2_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1(x, v) (HW_IPU_DC_MAP_CONF_0_WR(x, (HW_IPU_DC_MAP_CONF_0_RD(x) & ~BM_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1) | BF_IPU_DC_MAP_CONF_0_MAPPING_PNTR_BYTE2_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_1 - DC Mapping Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_1 - DC Mapping Configuration Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_1
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_1_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_2 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_2 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_2 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_3 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_3 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_3 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_1 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_1_ADDR(x) ((uintptr_t)(x) + 0x5810CU)

#define HW_IPU_DC_MAP_CONF_1(x)  (*(__IO hw_ipu_dc_map_conf_1_t *) HW_IPU_DC_MAP_CONF_1_ADDR(x))
#define HW_IPU_DC_MAP_CONF_1_RD(x) (HW_IPU_DC_MAP_CONF_1(x).U)
#define HW_IPU_DC_MAP_CONF_1_WR(x, v) (HW_IPU_DC_MAP_CONF_1(x).U = (v))
#define HW_IPU_DC_MAP_CONF_1_SET(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, HW_IPU_DC_MAP_CONF_1_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_1_CLR(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, HW_IPU_DC_MAP_CONF_1_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_1_TOG(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, HW_IPU_DC_MAP_CONF_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_1 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE0_2[4:0] (RW)
 *
 * Mapping pointer #1 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2 (0U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE0_2)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2)

/*! @brief Set the MAPPING_PNTR_BYTE0_2 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE1_2[9:5] (RW)
 *
 * Mapping pointer #1 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2 (5U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE1_2)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2)

/*! @brief Set the MAPPING_PNTR_BYTE1_2 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE2_2[14:10] (RW)
 *
 * Mapping pointer #1 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2 (10U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE2_2)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2)

/*! @brief Set the MAPPING_PNTR_BYTE2_2 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE0_3[20:16] (RW)
 *
 * Mapping pointer #3 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3 (16U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE0_3)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3)

/*! @brief Set the MAPPING_PNTR_BYTE0_3 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE0_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE1_3[25:21] (RW)
 *
 * Mapping pointer #3 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3 (21U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE1_3)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3)

/*! @brief Set the MAPPING_PNTR_BYTE1_3 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE1_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_1, field MAPPING_PNTR_BYTE2_3[30:26] (RW)
 *
 * Mapping pointer #3 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3 (26U) /*!< Bit position for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3. */
#define BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3. */
#define BS_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3 field. */
#define BR_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3(x) (HW_IPU_DC_MAP_CONF_1(x).B.MAPPING_PNTR_BYTE2_3)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3. */
#define BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3) & BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3)

/*! @brief Set the MAPPING_PNTR_BYTE2_3 field to a new value. */
#define BW_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3(x, v) (HW_IPU_DC_MAP_CONF_1_WR(x, (HW_IPU_DC_MAP_CONF_1_RD(x) & ~BM_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3) | BF_IPU_DC_MAP_CONF_1_MAPPING_PNTR_BYTE2_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_2 - DC Mapping Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_2 - DC Mapping Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_2
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_2_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_4 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_4 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_4 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_5 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_5 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_5 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_2 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_2_ADDR(x) ((uintptr_t)(x) + 0x58110U)

#define HW_IPU_DC_MAP_CONF_2(x)  (*(__IO hw_ipu_dc_map_conf_2_t *) HW_IPU_DC_MAP_CONF_2_ADDR(x))
#define HW_IPU_DC_MAP_CONF_2_RD(x) (HW_IPU_DC_MAP_CONF_2(x).U)
#define HW_IPU_DC_MAP_CONF_2_WR(x, v) (HW_IPU_DC_MAP_CONF_2(x).U = (v))
#define HW_IPU_DC_MAP_CONF_2_SET(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, HW_IPU_DC_MAP_CONF_2_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_2_CLR(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, HW_IPU_DC_MAP_CONF_2_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_2_TOG(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, HW_IPU_DC_MAP_CONF_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_2 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE0_4[4:0] (RW)
 *
 * Mapping pointer #4 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4 (0U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE0_4)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4)

/*! @brief Set the MAPPING_PNTR_BYTE0_4 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE1_4[9:5] (RW)
 *
 * Mapping pointer #4 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4 (5U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE1_4)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4)

/*! @brief Set the MAPPING_PNTR_BYTE1_4 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE2_4[14:10] (RW)
 *
 * Mapping pointer #4 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4 (10U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE2_4)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4)

/*! @brief Set the MAPPING_PNTR_BYTE2_4 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE0_5[20:16] (RW)
 *
 * Mapping pointer #5 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5 (16U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE0_5)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5)

/*! @brief Set the MAPPING_PNTR_BYTE0_5 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE0_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE1_5[25:21] (RW)
 *
 * Mapping pointer #5 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5 (21U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE1_5)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5)

/*! @brief Set the MAPPING_PNTR_BYTE1_5 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE1_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_2, field MAPPING_PNTR_BYTE2_5[30:26] (RW)
 *
 * Mapping pointer #5 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5 (26U) /*!< Bit position for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5. */
#define BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5. */
#define BS_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5 field. */
#define BR_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5(x) (HW_IPU_DC_MAP_CONF_2(x).B.MAPPING_PNTR_BYTE2_5)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5. */
#define BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5) & BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5)

/*! @brief Set the MAPPING_PNTR_BYTE2_5 field to a new value. */
#define BW_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5(x, v) (HW_IPU_DC_MAP_CONF_2_WR(x, (HW_IPU_DC_MAP_CONF_2_RD(x) & ~BM_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5) | BF_IPU_DC_MAP_CONF_2_MAPPING_PNTR_BYTE2_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_3 - DC Mapping Configuration Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_3 - DC Mapping Configuration Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_3
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_3_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_6 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_6 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_6 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_7 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_7 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_7 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_3 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_3_ADDR(x) ((uintptr_t)(x) + 0x58114U)

#define HW_IPU_DC_MAP_CONF_3(x)  (*(__IO hw_ipu_dc_map_conf_3_t *) HW_IPU_DC_MAP_CONF_3_ADDR(x))
#define HW_IPU_DC_MAP_CONF_3_RD(x) (HW_IPU_DC_MAP_CONF_3(x).U)
#define HW_IPU_DC_MAP_CONF_3_WR(x, v) (HW_IPU_DC_MAP_CONF_3(x).U = (v))
#define HW_IPU_DC_MAP_CONF_3_SET(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, HW_IPU_DC_MAP_CONF_3_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_3_CLR(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, HW_IPU_DC_MAP_CONF_3_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_3_TOG(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, HW_IPU_DC_MAP_CONF_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_3 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE0_6[4:0] (RW)
 *
 * Mapping pointer #6 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6 (0U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE0_6)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6)

/*! @brief Set the MAPPING_PNTR_BYTE0_6 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE1_6[9:5] (RW)
 *
 * Mapping pointer #6 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6 (5U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE1_6)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6)

/*! @brief Set the MAPPING_PNTR_BYTE1_6 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE2_6[14:10] (RW)
 *
 * Mapping pointer #6 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6 (10U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE2_6)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6)

/*! @brief Set the MAPPING_PNTR_BYTE2_6 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE0_7[20:16] (RW)
 *
 * Mapping pointer #7 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7 (16U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE0_7)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7)

/*! @brief Set the MAPPING_PNTR_BYTE0_7 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE0_7(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE1_7[25:21] (RW)
 *
 * Mapping pointer #7 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7 (21U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE1_7)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7)

/*! @brief Set the MAPPING_PNTR_BYTE1_7 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE1_7(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_3, field MAPPING_PNTR_BYTE2_7[30:26] (RW)
 *
 * Mapping pointer #7 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7 (26U) /*!< Bit position for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7. */
#define BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7. */
#define BS_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7 field. */
#define BR_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7(x) (HW_IPU_DC_MAP_CONF_3(x).B.MAPPING_PNTR_BYTE2_7)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7. */
#define BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7) & BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7)

/*! @brief Set the MAPPING_PNTR_BYTE2_7 field to a new value. */
#define BW_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7(x, v) (HW_IPU_DC_MAP_CONF_3_WR(x, (HW_IPU_DC_MAP_CONF_3_RD(x) & ~BM_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7) | BF_IPU_DC_MAP_CONF_3_MAPPING_PNTR_BYTE2_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_4 - DC Mapping Configuration Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_4 - DC Mapping Configuration Register 4 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_4
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_4_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_8 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_8 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_8 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_9 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_1 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_9 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_4_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_4 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_4_ADDR(x) ((uintptr_t)(x) + 0x58118U)

#define HW_IPU_DC_MAP_CONF_4(x)  (*(__IO hw_ipu_dc_map_conf_4_t *) HW_IPU_DC_MAP_CONF_4_ADDR(x))
#define HW_IPU_DC_MAP_CONF_4_RD(x) (HW_IPU_DC_MAP_CONF_4(x).U)
#define HW_IPU_DC_MAP_CONF_4_WR(x, v) (HW_IPU_DC_MAP_CONF_4(x).U = (v))
#define HW_IPU_DC_MAP_CONF_4_SET(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, HW_IPU_DC_MAP_CONF_4_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_4_CLR(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, HW_IPU_DC_MAP_CONF_4_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_4_TOG(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, HW_IPU_DC_MAP_CONF_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_4 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE0_8[4:0] (RW)
 *
 * Mapping pointer #8 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8 (0U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE0_8)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8)

/*! @brief Set the MAPPING_PNTR_BYTE0_8 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE1_8[9:5] (RW)
 *
 * Mapping pointer #8 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8 (5U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE1_8)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8)

/*! @brief Set the MAPPING_PNTR_BYTE1_8 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE2_8[14:10] (RW)
 *
 * Mapping pointer #8 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8 (10U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE2_8)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8)

/*! @brief Set the MAPPING_PNTR_BYTE2_8 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE0_9[20:16] (RW)
 *
 * Mapping pointer #9 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9 (16U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE0_9)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9)

/*! @brief Set the MAPPING_PNTR_BYTE0_9 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE0_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE1_1[25:21] (RW)
 *
 * Mapping pointer #9 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1 (21U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE1_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1)

/*! @brief Set the MAPPING_PNTR_BYTE1_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE1_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_4, field MAPPING_PNTR_BYTE2_9[30:26] (RW)
 *
 * Mapping pointer #9 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9 (26U) /*!< Bit position for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9. */
#define BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9. */
#define BS_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9 field. */
#define BR_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9(x) (HW_IPU_DC_MAP_CONF_4(x).B.MAPPING_PNTR_BYTE2_9)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9. */
#define BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9) & BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9)

/*! @brief Set the MAPPING_PNTR_BYTE2_9 field to a new value. */
#define BW_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9(x, v) (HW_IPU_DC_MAP_CONF_4_WR(x, (HW_IPU_DC_MAP_CONF_4_RD(x) & ~BM_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9) | BF_IPU_DC_MAP_CONF_4_MAPPING_PNTR_BYTE2_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_5 - DC Mapping Configuration Register 5
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_5 - DC Mapping Configuration Register 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_5
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_5_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_10 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_10 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_10 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_11 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_11 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_11 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_5_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_5 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_5_ADDR(x) ((uintptr_t)(x) + 0x5811CU)

#define HW_IPU_DC_MAP_CONF_5(x)  (*(__IO hw_ipu_dc_map_conf_5_t *) HW_IPU_DC_MAP_CONF_5_ADDR(x))
#define HW_IPU_DC_MAP_CONF_5_RD(x) (HW_IPU_DC_MAP_CONF_5(x).U)
#define HW_IPU_DC_MAP_CONF_5_WR(x, v) (HW_IPU_DC_MAP_CONF_5(x).U = (v))
#define HW_IPU_DC_MAP_CONF_5_SET(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, HW_IPU_DC_MAP_CONF_5_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_5_CLR(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, HW_IPU_DC_MAP_CONF_5_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_5_TOG(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, HW_IPU_DC_MAP_CONF_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_5 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE0_10[4:0] (RW)
 *
 * Mapping pointer #10 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10 (0U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE0_10)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10)

/*! @brief Set the MAPPING_PNTR_BYTE0_10 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_10(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE1_10[9:5] (RW)
 *
 * Mapping pointer #10 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10 (5U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE1_10)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10)

/*! @brief Set the MAPPING_PNTR_BYTE1_10 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_10(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE2_10[14:10] (RW)
 *
 * Mapping pointer #10 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10 (10U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE2_10)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10)

/*! @brief Set the MAPPING_PNTR_BYTE2_10 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_10(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE0_11[20:16] (RW)
 *
 * Mapping pointer #11 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11 (16U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE0_11)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11)

/*! @brief Set the MAPPING_PNTR_BYTE0_11 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE0_11(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE1_11[25:21] (RW)
 *
 * Mapping pointer #11 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11 (21U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE1_11)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11)

/*! @brief Set the MAPPING_PNTR_BYTE1_11 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE1_11(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_5, field MAPPING_PNTR_BYTE2_11[30:26] (RW)
 *
 * Mapping pointer #11 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11 (26U) /*!< Bit position for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11. */
#define BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11. */
#define BS_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11 field. */
#define BR_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11(x) (HW_IPU_DC_MAP_CONF_5(x).B.MAPPING_PNTR_BYTE2_11)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11. */
#define BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11) & BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11)

/*! @brief Set the MAPPING_PNTR_BYTE2_11 field to a new value. */
#define BW_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11(x, v) (HW_IPU_DC_MAP_CONF_5_WR(x, (HW_IPU_DC_MAP_CONF_5_RD(x) & ~BM_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11) | BF_IPU_DC_MAP_CONF_5_MAPPING_PNTR_BYTE2_11(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_6 - DC Mapping Configuration Register 6
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_6 - DC Mapping Configuration Register 6 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_6
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_6_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_12 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_12 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_12 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_13 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_13 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_13 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_6_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_6 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_6_ADDR(x) ((uintptr_t)(x) + 0x58120U)

#define HW_IPU_DC_MAP_CONF_6(x)  (*(__IO hw_ipu_dc_map_conf_6_t *) HW_IPU_DC_MAP_CONF_6_ADDR(x))
#define HW_IPU_DC_MAP_CONF_6_RD(x) (HW_IPU_DC_MAP_CONF_6(x).U)
#define HW_IPU_DC_MAP_CONF_6_WR(x, v) (HW_IPU_DC_MAP_CONF_6(x).U = (v))
#define HW_IPU_DC_MAP_CONF_6_SET(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, HW_IPU_DC_MAP_CONF_6_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_6_CLR(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, HW_IPU_DC_MAP_CONF_6_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_6_TOG(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, HW_IPU_DC_MAP_CONF_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_6 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE0_12[4:0] (RW)
 *
 * Mapping pointer #12 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12 (0U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE0_12)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12)

/*! @brief Set the MAPPING_PNTR_BYTE0_12 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_12(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE1_12[9:5] (RW)
 *
 * Mapping pointer #12 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12 (5U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE1_12)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12)

/*! @brief Set the MAPPING_PNTR_BYTE1_12 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_12(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE2_12[14:10] (RW)
 *
 * Mapping pointer #12 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12 (10U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE2_12)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12)

/*! @brief Set the MAPPING_PNTR_BYTE2_12 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_12(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE0_13[20:16] (RW)
 *
 * Mapping pointer #13 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13 (16U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE0_13)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13)

/*! @brief Set the MAPPING_PNTR_BYTE0_13 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE0_13(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE1_13[25:21] (RW)
 *
 * Mapping pointer #13 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13 (21U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE1_13)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13)

/*! @brief Set the MAPPING_PNTR_BYTE1_13 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE1_13(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_6, field MAPPING_PNTR_BYTE2_13[30:26] (RW)
 *
 * Mapping pointer #13 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13 (26U) /*!< Bit position for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13. */
#define BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13. */
#define BS_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13 field. */
#define BR_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13(x) (HW_IPU_DC_MAP_CONF_6(x).B.MAPPING_PNTR_BYTE2_13)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13. */
#define BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13) & BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13)

/*! @brief Set the MAPPING_PNTR_BYTE2_13 field to a new value. */
#define BW_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13(x, v) (HW_IPU_DC_MAP_CONF_6_WR(x, (HW_IPU_DC_MAP_CONF_6_RD(x) & ~BM_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13) | BF_IPU_DC_MAP_CONF_6_MAPPING_PNTR_BYTE2_13(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_7 - DC Mapping Configuration Register 7
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_7 - DC Mapping Configuration Register 7 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_7
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_7_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_14 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_14 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_14 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_15 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_15 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_15 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_7_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_7 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_7_ADDR(x) ((uintptr_t)(x) + 0x58124U)

#define HW_IPU_DC_MAP_CONF_7(x)  (*(__IO hw_ipu_dc_map_conf_7_t *) HW_IPU_DC_MAP_CONF_7_ADDR(x))
#define HW_IPU_DC_MAP_CONF_7_RD(x) (HW_IPU_DC_MAP_CONF_7(x).U)
#define HW_IPU_DC_MAP_CONF_7_WR(x, v) (HW_IPU_DC_MAP_CONF_7(x).U = (v))
#define HW_IPU_DC_MAP_CONF_7_SET(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, HW_IPU_DC_MAP_CONF_7_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_7_CLR(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, HW_IPU_DC_MAP_CONF_7_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_7_TOG(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, HW_IPU_DC_MAP_CONF_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_7 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE0_14[4:0] (RW)
 *
 * Mapping pointer #14 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14 (0U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE0_14)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14)

/*! @brief Set the MAPPING_PNTR_BYTE0_14 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_14(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE1_14[9:5] (RW)
 *
 * Mapping pointer #14 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14 (5U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE1_14)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14)

/*! @brief Set the MAPPING_PNTR_BYTE1_14 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_14(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE2_14[14:10] (RW)
 *
 * Mapping pointer #14 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14 (10U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE2_14)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14)

/*! @brief Set the MAPPING_PNTR_BYTE2_14 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_14(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE0_15[20:16] (RW)
 *
 * Mapping pointer #15 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15 (16U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE0_15)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15)

/*! @brief Set the MAPPING_PNTR_BYTE0_15 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE0_15(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE1_15[25:21] (RW)
 *
 * Mapping pointer #15 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15 (21U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE1_15)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15)

/*! @brief Set the MAPPING_PNTR_BYTE1_15 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE1_15(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_7, field MAPPING_PNTR_BYTE2_15[30:26] (RW)
 *
 * Mapping pointer #15 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15 (26U) /*!< Bit position for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15. */
#define BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15. */
#define BS_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15 field. */
#define BR_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15(x) (HW_IPU_DC_MAP_CONF_7(x).B.MAPPING_PNTR_BYTE2_15)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15. */
#define BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15) & BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15)

/*! @brief Set the MAPPING_PNTR_BYTE2_15 field to a new value. */
#define BW_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15(x, v) (HW_IPU_DC_MAP_CONF_7_WR(x, (HW_IPU_DC_MAP_CONF_7_RD(x) & ~BM_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15) | BF_IPU_DC_MAP_CONF_7_MAPPING_PNTR_BYTE2_15(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_8 - DC Mapping Configuration Register 8
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_8 - DC Mapping Configuration Register 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_8
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_8_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_16 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_16 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_16 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_17 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_17 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_17 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_8_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_8 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_8_ADDR(x) ((uintptr_t)(x) + 0x58128U)

#define HW_IPU_DC_MAP_CONF_8(x)  (*(__IO hw_ipu_dc_map_conf_8_t *) HW_IPU_DC_MAP_CONF_8_ADDR(x))
#define HW_IPU_DC_MAP_CONF_8_RD(x) (HW_IPU_DC_MAP_CONF_8(x).U)
#define HW_IPU_DC_MAP_CONF_8_WR(x, v) (HW_IPU_DC_MAP_CONF_8(x).U = (v))
#define HW_IPU_DC_MAP_CONF_8_SET(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, HW_IPU_DC_MAP_CONF_8_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_8_CLR(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, HW_IPU_DC_MAP_CONF_8_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_8_TOG(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, HW_IPU_DC_MAP_CONF_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_8 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE0_16[4:0] (RW)
 *
 * Mapping pointer #16 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16 (0U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE0_16)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16)

/*! @brief Set the MAPPING_PNTR_BYTE0_16 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_16(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE1_16[9:5] (RW)
 *
 * Mapping pointer #16 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16 (5U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE1_16)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16)

/*! @brief Set the MAPPING_PNTR_BYTE1_16 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_16(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE2_16[14:10] (RW)
 *
 * Mapping pointer #16 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16 (10U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE2_16)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16)

/*! @brief Set the MAPPING_PNTR_BYTE2_16 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_16(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE0_17[20:16] (RW)
 *
 * Mapping pointer #17 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17 (16U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE0_17)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17)

/*! @brief Set the MAPPING_PNTR_BYTE0_17 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE0_17(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE1_17[25:21] (RW)
 *
 * Mapping pointer #17 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17 (21U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE1_17)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17)

/*! @brief Set the MAPPING_PNTR_BYTE1_17 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE1_17(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_8, field MAPPING_PNTR_BYTE2_17[30:26] (RW)
 *
 * Mapping pointer #17 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17 (26U) /*!< Bit position for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17. */
#define BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17. */
#define BS_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17 field. */
#define BR_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17(x) (HW_IPU_DC_MAP_CONF_8(x).B.MAPPING_PNTR_BYTE2_17)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17. */
#define BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17) & BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17)

/*! @brief Set the MAPPING_PNTR_BYTE2_17 field to a new value. */
#define BW_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17(x, v) (HW_IPU_DC_MAP_CONF_8_WR(x, (HW_IPU_DC_MAP_CONF_8_RD(x) & ~BM_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17) | BF_IPU_DC_MAP_CONF_8_MAPPING_PNTR_BYTE2_17(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_9 - DC Mapping Configuration Register 9
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_9 - DC Mapping Configuration Register 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_9
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_9_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_18 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_18 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_18 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_19 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_19 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_19 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_9_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_9 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_9_ADDR(x) ((uintptr_t)(x) + 0x5812CU)

#define HW_IPU_DC_MAP_CONF_9(x)  (*(__IO hw_ipu_dc_map_conf_9_t *) HW_IPU_DC_MAP_CONF_9_ADDR(x))
#define HW_IPU_DC_MAP_CONF_9_RD(x) (HW_IPU_DC_MAP_CONF_9(x).U)
#define HW_IPU_DC_MAP_CONF_9_WR(x, v) (HW_IPU_DC_MAP_CONF_9(x).U = (v))
#define HW_IPU_DC_MAP_CONF_9_SET(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, HW_IPU_DC_MAP_CONF_9_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_9_CLR(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, HW_IPU_DC_MAP_CONF_9_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_9_TOG(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, HW_IPU_DC_MAP_CONF_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_9 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE0_18[4:0] (RW)
 *
 * Mapping pointer #18 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18 (0U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE0_18)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18)

/*! @brief Set the MAPPING_PNTR_BYTE0_18 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_18(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE1_18[9:5] (RW)
 *
 * Mapping pointer #18 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18 (5U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE1_18)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18)

/*! @brief Set the MAPPING_PNTR_BYTE1_18 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_18(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE2_18[14:10] (RW)
 *
 * Mapping pointer #18 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18 (10U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE2_18)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18)

/*! @brief Set the MAPPING_PNTR_BYTE2_18 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_18(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE0_19[20:16] (RW)
 *
 * Mapping pointer #19 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19 (16U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE0_19)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19)

/*! @brief Set the MAPPING_PNTR_BYTE0_19 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE0_19(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE1_19[25:21] (RW)
 *
 * Mapping pointer #19 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19 (21U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE1_19)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19)

/*! @brief Set the MAPPING_PNTR_BYTE1_19 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE1_19(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_9, field MAPPING_PNTR_BYTE2_19[30:26] (RW)
 *
 * Mapping pointer #19 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19 (26U) /*!< Bit position for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19. */
#define BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19. */
#define BS_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19 field. */
#define BR_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19(x) (HW_IPU_DC_MAP_CONF_9(x).B.MAPPING_PNTR_BYTE2_19)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19. */
#define BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19) & BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19)

/*! @brief Set the MAPPING_PNTR_BYTE2_19 field to a new value. */
#define BW_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19(x, v) (HW_IPU_DC_MAP_CONF_9_WR(x, (HW_IPU_DC_MAP_CONF_9_RD(x) & ~BM_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19) | BF_IPU_DC_MAP_CONF_9_MAPPING_PNTR_BYTE2_19(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_10 - DC Mapping Configuration Register 10
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_10 - DC Mapping Configuration Register 10 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_10
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_10_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_20 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_20 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_20 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_21 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_21 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_21 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_10_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_10 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_10_ADDR(x) ((uintptr_t)(x) + 0x58130U)

#define HW_IPU_DC_MAP_CONF_10(x) (*(__IO hw_ipu_dc_map_conf_10_t *) HW_IPU_DC_MAP_CONF_10_ADDR(x))
#define HW_IPU_DC_MAP_CONF_10_RD(x) (HW_IPU_DC_MAP_CONF_10(x).U)
#define HW_IPU_DC_MAP_CONF_10_WR(x, v) (HW_IPU_DC_MAP_CONF_10(x).U = (v))
#define HW_IPU_DC_MAP_CONF_10_SET(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, HW_IPU_DC_MAP_CONF_10_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_10_CLR(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, HW_IPU_DC_MAP_CONF_10_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_10_TOG(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, HW_IPU_DC_MAP_CONF_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_10 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE0_20[4:0] (RW)
 *
 * Mapping pointer #20 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20 (0U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE0_20)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20)

/*! @brief Set the MAPPING_PNTR_BYTE0_20 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_20(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE1_20[9:5] (RW)
 *
 * Mapping pointer #20 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20 (5U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE1_20)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20)

/*! @brief Set the MAPPING_PNTR_BYTE1_20 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_20(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE2_20[14:10] (RW)
 *
 * Mapping pointer #20 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20 (10U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE2_20)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20)

/*! @brief Set the MAPPING_PNTR_BYTE2_20 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_20(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE0_21[20:16] (RW)
 *
 * Mapping pointer #21 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21 (16U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE0_21)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21)

/*! @brief Set the MAPPING_PNTR_BYTE0_21 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE0_21(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE1_21[25:21] (RW)
 *
 * Mapping pointer #21 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21 (21U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE1_21)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21)

/*! @brief Set the MAPPING_PNTR_BYTE1_21 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE1_21(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_10, field MAPPING_PNTR_BYTE2_21[30:26] (RW)
 *
 * Mapping pointer #21 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21 (26U) /*!< Bit position for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21. */
#define BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21. */
#define BS_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21 field. */
#define BR_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21(x) (HW_IPU_DC_MAP_CONF_10(x).B.MAPPING_PNTR_BYTE2_21)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21. */
#define BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21) & BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21)

/*! @brief Set the MAPPING_PNTR_BYTE2_21 field to a new value. */
#define BW_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21(x, v) (HW_IPU_DC_MAP_CONF_10_WR(x, (HW_IPU_DC_MAP_CONF_10_RD(x) & ~BM_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21) | BF_IPU_DC_MAP_CONF_10_MAPPING_PNTR_BYTE2_21(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_11 - DC Mapping Configuration Register 11
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_11 - DC Mapping Configuration Register 11 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_11
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_11_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_22 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_22 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_22 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_23 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_23 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_23 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_11_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_11 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_11_ADDR(x) ((uintptr_t)(x) + 0x58134U)

#define HW_IPU_DC_MAP_CONF_11(x) (*(__IO hw_ipu_dc_map_conf_11_t *) HW_IPU_DC_MAP_CONF_11_ADDR(x))
#define HW_IPU_DC_MAP_CONF_11_RD(x) (HW_IPU_DC_MAP_CONF_11(x).U)
#define HW_IPU_DC_MAP_CONF_11_WR(x, v) (HW_IPU_DC_MAP_CONF_11(x).U = (v))
#define HW_IPU_DC_MAP_CONF_11_SET(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, HW_IPU_DC_MAP_CONF_11_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_11_CLR(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, HW_IPU_DC_MAP_CONF_11_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_11_TOG(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, HW_IPU_DC_MAP_CONF_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_11 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE0_22[4:0] (RW)
 *
 * Mapping pointer #22 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22 (0U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE0_22)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22)

/*! @brief Set the MAPPING_PNTR_BYTE0_22 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_22(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE1_22[9:5] (RW)
 *
 * Mapping pointer #22 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22 (5U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE1_22)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22)

/*! @brief Set the MAPPING_PNTR_BYTE1_22 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_22(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE2_22[14:10] (RW)
 *
 * Mapping pointer #22 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22 (10U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE2_22)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22)

/*! @brief Set the MAPPING_PNTR_BYTE2_22 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_22(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE0_23[20:16] (RW)
 *
 * Mapping pointer #23 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23 (16U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE0_23)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23)

/*! @brief Set the MAPPING_PNTR_BYTE0_23 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE0_23(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE1_23[25:21] (RW)
 *
 * Mapping pointer #23 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23 (21U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE1_23)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23)

/*! @brief Set the MAPPING_PNTR_BYTE1_23 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE1_23(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_11, field MAPPING_PNTR_BYTE2_23[30:26] (RW)
 *
 * Mapping pointer #23 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23 (26U) /*!< Bit position for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23. */
#define BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23. */
#define BS_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23 field. */
#define BR_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23(x) (HW_IPU_DC_MAP_CONF_11(x).B.MAPPING_PNTR_BYTE2_23)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23. */
#define BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23) & BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23)

/*! @brief Set the MAPPING_PNTR_BYTE2_23 field to a new value. */
#define BW_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23(x, v) (HW_IPU_DC_MAP_CONF_11_WR(x, (HW_IPU_DC_MAP_CONF_11_RD(x) & ~BM_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23) | BF_IPU_DC_MAP_CONF_11_MAPPING_PNTR_BYTE2_23(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_12 - DC Mapping Configuration Register 12
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_12 - DC Mapping Configuration Register 12 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_12
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_12_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_24 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_24 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_24 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_25 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_25 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_25 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_12_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_12 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_12_ADDR(x) ((uintptr_t)(x) + 0x58138U)

#define HW_IPU_DC_MAP_CONF_12(x) (*(__IO hw_ipu_dc_map_conf_12_t *) HW_IPU_DC_MAP_CONF_12_ADDR(x))
#define HW_IPU_DC_MAP_CONF_12_RD(x) (HW_IPU_DC_MAP_CONF_12(x).U)
#define HW_IPU_DC_MAP_CONF_12_WR(x, v) (HW_IPU_DC_MAP_CONF_12(x).U = (v))
#define HW_IPU_DC_MAP_CONF_12_SET(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, HW_IPU_DC_MAP_CONF_12_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_12_CLR(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, HW_IPU_DC_MAP_CONF_12_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_12_TOG(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, HW_IPU_DC_MAP_CONF_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_12 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE0_24[4:0] (RW)
 *
 * Mapping pointer #24 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24 (0U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE0_24)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24)

/*! @brief Set the MAPPING_PNTR_BYTE0_24 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_24(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE1_24[9:5] (RW)
 *
 * Mapping pointer #24 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24 (5U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE1_24)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24)

/*! @brief Set the MAPPING_PNTR_BYTE1_24 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_24(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE2_24[14:10] (RW)
 *
 * Mapping pointer #24 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24 (10U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE2_24)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24)

/*! @brief Set the MAPPING_PNTR_BYTE2_24 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_24(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE0_25[20:16] (RW)
 *
 * Mapping pointer #25 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25 (16U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE0_25)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25)

/*! @brief Set the MAPPING_PNTR_BYTE0_25 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE0_25(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE1_25[25:21] (RW)
 *
 * Mapping pointer #25 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25 (21U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE1_25)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25)

/*! @brief Set the MAPPING_PNTR_BYTE1_25 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE1_25(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_12, field MAPPING_PNTR_BYTE2_25[30:26] (RW)
 *
 * Mapping pointer #25 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25 (26U) /*!< Bit position for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25. */
#define BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25. */
#define BS_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25 field. */
#define BR_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25(x) (HW_IPU_DC_MAP_CONF_12(x).B.MAPPING_PNTR_BYTE2_25)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25. */
#define BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25) & BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25)

/*! @brief Set the MAPPING_PNTR_BYTE2_25 field to a new value. */
#define BW_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25(x, v) (HW_IPU_DC_MAP_CONF_12_WR(x, (HW_IPU_DC_MAP_CONF_12_RD(x) & ~BM_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25) | BF_IPU_DC_MAP_CONF_12_MAPPING_PNTR_BYTE2_25(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_13 - DC Mapping Configuration Register 13
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_13 - DC Mapping Configuration Register 13 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_13
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_13_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE0_26 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_26 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_26 : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_27 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_27 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_27 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_13_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_13 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_13_ADDR(x) ((uintptr_t)(x) + 0x5813CU)

#define HW_IPU_DC_MAP_CONF_13(x) (*(__IO hw_ipu_dc_map_conf_13_t *) HW_IPU_DC_MAP_CONF_13_ADDR(x))
#define HW_IPU_DC_MAP_CONF_13_RD(x) (HW_IPU_DC_MAP_CONF_13(x).U)
#define HW_IPU_DC_MAP_CONF_13_WR(x, v) (HW_IPU_DC_MAP_CONF_13(x).U = (v))
#define HW_IPU_DC_MAP_CONF_13_SET(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, HW_IPU_DC_MAP_CONF_13_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_13_CLR(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, HW_IPU_DC_MAP_CONF_13_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_13_TOG(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, HW_IPU_DC_MAP_CONF_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_13 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE0_26[4:0] (RW)
 *
 * Mapping pointer #26 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26 (0U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE0_26)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26)

/*! @brief Set the MAPPING_PNTR_BYTE0_26 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_26(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE1_26[9:5] (RW)
 *
 * Mapping pointer #26 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26 (5U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE1_26)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26)

/*! @brief Set the MAPPING_PNTR_BYTE1_26 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_26(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE2_26[14:10] (RW)
 *
 * Mapping pointer #26 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26 (10U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26 (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE2_26)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26)

/*! @brief Set the MAPPING_PNTR_BYTE2_26 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_26(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE0_27[20:16] (RW)
 *
 * Mapping pointer #27 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27 (16U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE0_27)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27)

/*! @brief Set the MAPPING_PNTR_BYTE0_27 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE0_27(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE1_27[25:21] (RW)
 *
 * Mapping pointer #27 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27 (21U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE1_27)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27)

/*! @brief Set the MAPPING_PNTR_BYTE1_27 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE1_27(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_13, field MAPPING_PNTR_BYTE2_27[30:26] (RW)
 *
 * Mapping pointer #27 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27 (26U) /*!< Bit position for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27. */
#define BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27. */
#define BS_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27 field. */
#define BR_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27(x) (HW_IPU_DC_MAP_CONF_13(x).B.MAPPING_PNTR_BYTE2_27)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27. */
#define BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27) & BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27)

/*! @brief Set the MAPPING_PNTR_BYTE2_27 field to a new value. */
#define BW_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27(x, v) (HW_IPU_DC_MAP_CONF_13_WR(x, (HW_IPU_DC_MAP_CONF_13_RD(x) & ~BM_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27) | BF_IPU_DC_MAP_CONF_13_MAPPING_PNTR_BYTE2_27(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_14 - DC Mapping Configuration Register 14
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_14 - DC Mapping Configuration Register 14 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_14
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_14_bitfields
    {
        uint32_t MAPPING_PNTR_BYTE2_28 : 5; /*!< [4:0]  */
        uint32_t MAPPING_PNTR_BYTE1_28 : 5; /*!< [9:5]  */
        uint32_t MAPPING_PNTR_BYTE2_28f : 5; /*!< [14:10]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t MAPPING_PNTR_BYTE0_29 : 5; /*!< [20:16]  */
        uint32_t MAPPING_PNTR_BYTE1_29 : 5; /*!< [25:21]  */
        uint32_t MAPPING_PNTR_BYTE2_29 : 5; /*!< [30:26]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_ipu_dc_map_conf_14_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_14 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_14_ADDR(x) ((uintptr_t)(x) + 0x58140U)

#define HW_IPU_DC_MAP_CONF_14(x) (*(__IO hw_ipu_dc_map_conf_14_t *) HW_IPU_DC_MAP_CONF_14_ADDR(x))
#define HW_IPU_DC_MAP_CONF_14_RD(x) (HW_IPU_DC_MAP_CONF_14(x).U)
#define HW_IPU_DC_MAP_CONF_14_WR(x, v) (HW_IPU_DC_MAP_CONF_14(x).U = (v))
#define HW_IPU_DC_MAP_CONF_14_SET(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, HW_IPU_DC_MAP_CONF_14_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_14_CLR(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, HW_IPU_DC_MAP_CONF_14_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_14_TOG(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, HW_IPU_DC_MAP_CONF_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_14 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE2_28[4:0] (RW)
 *
 * Mapping pointer #28 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28 (0U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28 (0x0000001FU) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28 field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE2_28)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28)

/*! @brief Set the MAPPING_PNTR_BYTE2_28 field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE1_28[9:5] (RW)
 *
 * Mapping pointer #28 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28 (5U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28 (0x000003E0U) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28 field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE1_28)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28)

/*! @brief Set the MAPPING_PNTR_BYTE1_28 field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_28(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE2_28f[14:10] (RW)
 *
 * Mapping pointer #28 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f (10U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f (0x00007C00U) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE2_28f)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f)

/*! @brief Set the MAPPING_PNTR_BYTE2_28f field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_28f(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE0_29[20:16] (RW)
 *
 * Mapping pointer #29 for Byte 0 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #0
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29 (16U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29 (0x001F0000U) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29 field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE0_29)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29)

/*! @brief Set the MAPPING_PNTR_BYTE0_29 field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE0_29(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE1_29[25:21] (RW)
 *
 * Mapping pointer #29 for Byte 1 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #1
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29 (21U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29 (0x03E00000U) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29 field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE1_29)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29)

/*! @brief Set the MAPPING_PNTR_BYTE1_29 field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE1_29(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_14, field MAPPING_PNTR_BYTE2_29[30:26] (RW)
 *
 * Mapping pointer #29 for Byte 2 This field is a pointer to the set of
 * MD_OFFSET_<i> and MD_MASK_<i> used for mapping byte #2
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29 (26U) /*!< Bit position for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29. */
#define BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29 (0x7C000000U) /*!< Bit mask for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29. */
#define BS_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29 field. */
#define BR_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29(x) (HW_IPU_DC_MAP_CONF_14(x).B.MAPPING_PNTR_BYTE2_29)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29. */
#define BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29) & BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29)

/*! @brief Set the MAPPING_PNTR_BYTE2_29 field to a new value. */
#define BW_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29(x, v) (HW_IPU_DC_MAP_CONF_14_WR(x, (HW_IPU_DC_MAP_CONF_14_RD(x) & ~BM_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29) | BF_IPU_DC_MAP_CONF_14_MAPPING_PNTR_BYTE2_29(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_15 - DC Mapping Configuration Register 15
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_15 - DC Mapping Configuration Register 15 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_15
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_15_bitfields
    {
        uint32_t MD_MASK_0 : 8;        /*!< [7:0]  */
        uint32_t MD_OFFSET_0 : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_1 : 8;        /*!< [23:16]  */
        uint32_t MD_OFFSET_1 : 5;      /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_15_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_15 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_15_ADDR(x) ((uintptr_t)(x) + 0x58144U)

#define HW_IPU_DC_MAP_CONF_15(x) (*(__IO hw_ipu_dc_map_conf_15_t *) HW_IPU_DC_MAP_CONF_15_ADDR(x))
#define HW_IPU_DC_MAP_CONF_15_RD(x) (HW_IPU_DC_MAP_CONF_15(x).U)
#define HW_IPU_DC_MAP_CONF_15_WR(x, v) (HW_IPU_DC_MAP_CONF_15(x).U = (v))
#define HW_IPU_DC_MAP_CONF_15_SET(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, HW_IPU_DC_MAP_CONF_15_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_15_CLR(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, HW_IPU_DC_MAP_CONF_15_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_15_TOG(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, HW_IPU_DC_MAP_CONF_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_15 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_15, field MD_MASK_0[7:0] (RW)
 *
 * Mapping unit's mask value #0 This field defines the mask value #0 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_15_MD_MASK_0 (0U) /*!< Bit position for IPU_DC_MAP_CONF_15_MD_MASK_0. */
#define BM_IPU_DC_MAP_CONF_15_MD_MASK_0 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_15_MD_MASK_0. */
#define BS_IPU_DC_MAP_CONF_15_MD_MASK_0 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_15_MD_MASK_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_15_MD_MASK_0 field. */
#define BR_IPU_DC_MAP_CONF_15_MD_MASK_0(x) (HW_IPU_DC_MAP_CONF_15(x).B.MD_MASK_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_15_MD_MASK_0. */
#define BF_IPU_DC_MAP_CONF_15_MD_MASK_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_15_MD_MASK_0) & BM_IPU_DC_MAP_CONF_15_MD_MASK_0)

/*! @brief Set the MD_MASK_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_15_MD_MASK_0(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, (HW_IPU_DC_MAP_CONF_15_RD(x) & ~BM_IPU_DC_MAP_CONF_15_MD_MASK_0) | BF_IPU_DC_MAP_CONF_15_MD_MASK_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_15, field MD_OFFSET_0[12:8] (RW)
 *
 * Mapping unit's offset parameter #0 This field defines the offset parameter #0
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_15_MD_OFFSET_0 (8U) /*!< Bit position for IPU_DC_MAP_CONF_15_MD_OFFSET_0. */
#define BM_IPU_DC_MAP_CONF_15_MD_OFFSET_0 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_15_MD_OFFSET_0. */
#define BS_IPU_DC_MAP_CONF_15_MD_OFFSET_0 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_15_MD_OFFSET_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_15_MD_OFFSET_0 field. */
#define BR_IPU_DC_MAP_CONF_15_MD_OFFSET_0(x) (HW_IPU_DC_MAP_CONF_15(x).B.MD_OFFSET_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_15_MD_OFFSET_0. */
#define BF_IPU_DC_MAP_CONF_15_MD_OFFSET_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_15_MD_OFFSET_0) & BM_IPU_DC_MAP_CONF_15_MD_OFFSET_0)

/*! @brief Set the MD_OFFSET_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_15_MD_OFFSET_0(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, (HW_IPU_DC_MAP_CONF_15_RD(x) & ~BM_IPU_DC_MAP_CONF_15_MD_OFFSET_0) | BF_IPU_DC_MAP_CONF_15_MD_OFFSET_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_15, field MD_MASK_1[23:16] (RW)
 *
 * Mapping unit's mask value #1 This field defines the mask value #1 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_15_MD_MASK_1 (16U) /*!< Bit position for IPU_DC_MAP_CONF_15_MD_MASK_1. */
#define BM_IPU_DC_MAP_CONF_15_MD_MASK_1 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_15_MD_MASK_1. */
#define BS_IPU_DC_MAP_CONF_15_MD_MASK_1 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_15_MD_MASK_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_15_MD_MASK_1 field. */
#define BR_IPU_DC_MAP_CONF_15_MD_MASK_1(x) (HW_IPU_DC_MAP_CONF_15(x).B.MD_MASK_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_15_MD_MASK_1. */
#define BF_IPU_DC_MAP_CONF_15_MD_MASK_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_15_MD_MASK_1) & BM_IPU_DC_MAP_CONF_15_MD_MASK_1)

/*! @brief Set the MD_MASK_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_15_MD_MASK_1(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, (HW_IPU_DC_MAP_CONF_15_RD(x) & ~BM_IPU_DC_MAP_CONF_15_MD_MASK_1) | BF_IPU_DC_MAP_CONF_15_MD_MASK_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_15, field MD_OFFSET_1[28:24] (RW)
 *
 * Mapping unit's offset parameter #1 This field defines the offset parameter #1
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_15_MD_OFFSET_1 (24U) /*!< Bit position for IPU_DC_MAP_CONF_15_MD_OFFSET_1. */
#define BM_IPU_DC_MAP_CONF_15_MD_OFFSET_1 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_15_MD_OFFSET_1. */
#define BS_IPU_DC_MAP_CONF_15_MD_OFFSET_1 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_15_MD_OFFSET_1. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_15_MD_OFFSET_1 field. */
#define BR_IPU_DC_MAP_CONF_15_MD_OFFSET_1(x) (HW_IPU_DC_MAP_CONF_15(x).B.MD_OFFSET_1)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_15_MD_OFFSET_1. */
#define BF_IPU_DC_MAP_CONF_15_MD_OFFSET_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_15_MD_OFFSET_1) & BM_IPU_DC_MAP_CONF_15_MD_OFFSET_1)

/*! @brief Set the MD_OFFSET_1 field to a new value. */
#define BW_IPU_DC_MAP_CONF_15_MD_OFFSET_1(x, v) (HW_IPU_DC_MAP_CONF_15_WR(x, (HW_IPU_DC_MAP_CONF_15_RD(x) & ~BM_IPU_DC_MAP_CONF_15_MD_OFFSET_1) | BF_IPU_DC_MAP_CONF_15_MD_OFFSET_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_16 - DC Mapping Configuration Register 16
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_16 - DC Mapping Configuration Register 16 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_16
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_16_bitfields
    {
        uint32_t MD_MASK_0 : 8;        /*!< [7:0]  */
        uint32_t MD_OFFSET_2 : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_3 : 8;        /*!< [23:16]  */
        uint32_t MD_OFFSET_3 : 5;      /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_16_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_16 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_16_ADDR(x) ((uintptr_t)(x) + 0x58148U)

#define HW_IPU_DC_MAP_CONF_16(x) (*(__IO hw_ipu_dc_map_conf_16_t *) HW_IPU_DC_MAP_CONF_16_ADDR(x))
#define HW_IPU_DC_MAP_CONF_16_RD(x) (HW_IPU_DC_MAP_CONF_16(x).U)
#define HW_IPU_DC_MAP_CONF_16_WR(x, v) (HW_IPU_DC_MAP_CONF_16(x).U = (v))
#define HW_IPU_DC_MAP_CONF_16_SET(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, HW_IPU_DC_MAP_CONF_16_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_16_CLR(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, HW_IPU_DC_MAP_CONF_16_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_16_TOG(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, HW_IPU_DC_MAP_CONF_16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_16 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_16, field MD_MASK_0[7:0] (RW)
 *
 * Mapping unit's mask value #2 This field defines the mask value #2 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_16_MD_MASK_0 (0U) /*!< Bit position for IPU_DC_MAP_CONF_16_MD_MASK_0. */
#define BM_IPU_DC_MAP_CONF_16_MD_MASK_0 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_16_MD_MASK_0. */
#define BS_IPU_DC_MAP_CONF_16_MD_MASK_0 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_16_MD_MASK_0. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_16_MD_MASK_0 field. */
#define BR_IPU_DC_MAP_CONF_16_MD_MASK_0(x) (HW_IPU_DC_MAP_CONF_16(x).B.MD_MASK_0)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_16_MD_MASK_0. */
#define BF_IPU_DC_MAP_CONF_16_MD_MASK_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_16_MD_MASK_0) & BM_IPU_DC_MAP_CONF_16_MD_MASK_0)

/*! @brief Set the MD_MASK_0 field to a new value. */
#define BW_IPU_DC_MAP_CONF_16_MD_MASK_0(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, (HW_IPU_DC_MAP_CONF_16_RD(x) & ~BM_IPU_DC_MAP_CONF_16_MD_MASK_0) | BF_IPU_DC_MAP_CONF_16_MD_MASK_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_16, field MD_OFFSET_2[12:8] (RW)
 *
 * Mapping unit's offset parameter #2 This field defines the offset parameter #2
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_16_MD_OFFSET_2 (8U) /*!< Bit position for IPU_DC_MAP_CONF_16_MD_OFFSET_2. */
#define BM_IPU_DC_MAP_CONF_16_MD_OFFSET_2 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_16_MD_OFFSET_2. */
#define BS_IPU_DC_MAP_CONF_16_MD_OFFSET_2 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_16_MD_OFFSET_2. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_16_MD_OFFSET_2 field. */
#define BR_IPU_DC_MAP_CONF_16_MD_OFFSET_2(x) (HW_IPU_DC_MAP_CONF_16(x).B.MD_OFFSET_2)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_16_MD_OFFSET_2. */
#define BF_IPU_DC_MAP_CONF_16_MD_OFFSET_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_16_MD_OFFSET_2) & BM_IPU_DC_MAP_CONF_16_MD_OFFSET_2)

/*! @brief Set the MD_OFFSET_2 field to a new value. */
#define BW_IPU_DC_MAP_CONF_16_MD_OFFSET_2(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, (HW_IPU_DC_MAP_CONF_16_RD(x) & ~BM_IPU_DC_MAP_CONF_16_MD_OFFSET_2) | BF_IPU_DC_MAP_CONF_16_MD_OFFSET_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_16, field MD_MASK_3[23:16] (RW)
 *
 * Mapping unit's mask value #3 This field defines the mask value #3 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_16_MD_MASK_3 (16U) /*!< Bit position for IPU_DC_MAP_CONF_16_MD_MASK_3. */
#define BM_IPU_DC_MAP_CONF_16_MD_MASK_3 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_16_MD_MASK_3. */
#define BS_IPU_DC_MAP_CONF_16_MD_MASK_3 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_16_MD_MASK_3. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_16_MD_MASK_3 field. */
#define BR_IPU_DC_MAP_CONF_16_MD_MASK_3(x) (HW_IPU_DC_MAP_CONF_16(x).B.MD_MASK_3)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_16_MD_MASK_3. */
#define BF_IPU_DC_MAP_CONF_16_MD_MASK_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_16_MD_MASK_3) & BM_IPU_DC_MAP_CONF_16_MD_MASK_3)

/*! @brief Set the MD_MASK_3 field to a new value. */
#define BW_IPU_DC_MAP_CONF_16_MD_MASK_3(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, (HW_IPU_DC_MAP_CONF_16_RD(x) & ~BM_IPU_DC_MAP_CONF_16_MD_MASK_3) | BF_IPU_DC_MAP_CONF_16_MD_MASK_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_16, field MD_OFFSET_3[28:24] (RW)
 *
 * Mapping unit's offset parameter #3 This field defines the offset parameter #3
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_16_MD_OFFSET_3 (24U) /*!< Bit position for IPU_DC_MAP_CONF_16_MD_OFFSET_3. */
#define BM_IPU_DC_MAP_CONF_16_MD_OFFSET_3 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_16_MD_OFFSET_3. */
#define BS_IPU_DC_MAP_CONF_16_MD_OFFSET_3 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_16_MD_OFFSET_3. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_16_MD_OFFSET_3 field. */
#define BR_IPU_DC_MAP_CONF_16_MD_OFFSET_3(x) (HW_IPU_DC_MAP_CONF_16(x).B.MD_OFFSET_3)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_16_MD_OFFSET_3. */
#define BF_IPU_DC_MAP_CONF_16_MD_OFFSET_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_16_MD_OFFSET_3) & BM_IPU_DC_MAP_CONF_16_MD_OFFSET_3)

/*! @brief Set the MD_OFFSET_3 field to a new value. */
#define BW_IPU_DC_MAP_CONF_16_MD_OFFSET_3(x, v) (HW_IPU_DC_MAP_CONF_16_WR(x, (HW_IPU_DC_MAP_CONF_16_RD(x) & ~BM_IPU_DC_MAP_CONF_16_MD_OFFSET_3) | BF_IPU_DC_MAP_CONF_16_MD_OFFSET_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_17 - DC Mapping Configuration Register 17
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_17 - DC Mapping Configuration Register 17 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_17
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_17_bitfields
    {
        uint32_t MD_MASK_4 : 8;        /*!< [7:0]  */
        uint32_t MD_OFFSET_4 : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_5 : 8;        /*!< [23:16]  */
        uint32_t MD_OFFSET_5 : 5;      /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_17_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_17 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_17_ADDR(x) ((uintptr_t)(x) + 0x5814CU)

#define HW_IPU_DC_MAP_CONF_17(x) (*(__IO hw_ipu_dc_map_conf_17_t *) HW_IPU_DC_MAP_CONF_17_ADDR(x))
#define HW_IPU_DC_MAP_CONF_17_RD(x) (HW_IPU_DC_MAP_CONF_17(x).U)
#define HW_IPU_DC_MAP_CONF_17_WR(x, v) (HW_IPU_DC_MAP_CONF_17(x).U = (v))
#define HW_IPU_DC_MAP_CONF_17_SET(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, HW_IPU_DC_MAP_CONF_17_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_17_CLR(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, HW_IPU_DC_MAP_CONF_17_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_17_TOG(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, HW_IPU_DC_MAP_CONF_17_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_17 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_17, field MD_MASK_4[7:0] (RW)
 *
 * Mapping unit's mask value #4 This field defines the mask value #4 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_17_MD_MASK_4 (0U) /*!< Bit position for IPU_DC_MAP_CONF_17_MD_MASK_4. */
#define BM_IPU_DC_MAP_CONF_17_MD_MASK_4 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_17_MD_MASK_4. */
#define BS_IPU_DC_MAP_CONF_17_MD_MASK_4 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_17_MD_MASK_4. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_17_MD_MASK_4 field. */
#define BR_IPU_DC_MAP_CONF_17_MD_MASK_4(x) (HW_IPU_DC_MAP_CONF_17(x).B.MD_MASK_4)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_17_MD_MASK_4. */
#define BF_IPU_DC_MAP_CONF_17_MD_MASK_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_17_MD_MASK_4) & BM_IPU_DC_MAP_CONF_17_MD_MASK_4)

/*! @brief Set the MD_MASK_4 field to a new value. */
#define BW_IPU_DC_MAP_CONF_17_MD_MASK_4(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, (HW_IPU_DC_MAP_CONF_17_RD(x) & ~BM_IPU_DC_MAP_CONF_17_MD_MASK_4) | BF_IPU_DC_MAP_CONF_17_MD_MASK_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_17, field MD_OFFSET_4[12:8] (RW)
 *
 * Mapping unit's offset parameter #4 This field defines the offset parameter #4
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_17_MD_OFFSET_4 (8U) /*!< Bit position for IPU_DC_MAP_CONF_17_MD_OFFSET_4. */
#define BM_IPU_DC_MAP_CONF_17_MD_OFFSET_4 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_17_MD_OFFSET_4. */
#define BS_IPU_DC_MAP_CONF_17_MD_OFFSET_4 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_17_MD_OFFSET_4. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_17_MD_OFFSET_4 field. */
#define BR_IPU_DC_MAP_CONF_17_MD_OFFSET_4(x) (HW_IPU_DC_MAP_CONF_17(x).B.MD_OFFSET_4)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_17_MD_OFFSET_4. */
#define BF_IPU_DC_MAP_CONF_17_MD_OFFSET_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_17_MD_OFFSET_4) & BM_IPU_DC_MAP_CONF_17_MD_OFFSET_4)

/*! @brief Set the MD_OFFSET_4 field to a new value. */
#define BW_IPU_DC_MAP_CONF_17_MD_OFFSET_4(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, (HW_IPU_DC_MAP_CONF_17_RD(x) & ~BM_IPU_DC_MAP_CONF_17_MD_OFFSET_4) | BF_IPU_DC_MAP_CONF_17_MD_OFFSET_4(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_17, field MD_MASK_5[23:16] (RW)
 *
 * Mapping unit's mask value #5 This field defines the mask value #5 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_17_MD_MASK_5 (16U) /*!< Bit position for IPU_DC_MAP_CONF_17_MD_MASK_5. */
#define BM_IPU_DC_MAP_CONF_17_MD_MASK_5 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_17_MD_MASK_5. */
#define BS_IPU_DC_MAP_CONF_17_MD_MASK_5 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_17_MD_MASK_5. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_17_MD_MASK_5 field. */
#define BR_IPU_DC_MAP_CONF_17_MD_MASK_5(x) (HW_IPU_DC_MAP_CONF_17(x).B.MD_MASK_5)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_17_MD_MASK_5. */
#define BF_IPU_DC_MAP_CONF_17_MD_MASK_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_17_MD_MASK_5) & BM_IPU_DC_MAP_CONF_17_MD_MASK_5)

/*! @brief Set the MD_MASK_5 field to a new value. */
#define BW_IPU_DC_MAP_CONF_17_MD_MASK_5(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, (HW_IPU_DC_MAP_CONF_17_RD(x) & ~BM_IPU_DC_MAP_CONF_17_MD_MASK_5) | BF_IPU_DC_MAP_CONF_17_MD_MASK_5(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_17, field MD_OFFSET_5[28:24] (RW)
 *
 * Mapping unit's offset parameter #5 This field defines the offset parameter #5
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_17_MD_OFFSET_5 (24U) /*!< Bit position for IPU_DC_MAP_CONF_17_MD_OFFSET_5. */
#define BM_IPU_DC_MAP_CONF_17_MD_OFFSET_5 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_17_MD_OFFSET_5. */
#define BS_IPU_DC_MAP_CONF_17_MD_OFFSET_5 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_17_MD_OFFSET_5. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_17_MD_OFFSET_5 field. */
#define BR_IPU_DC_MAP_CONF_17_MD_OFFSET_5(x) (HW_IPU_DC_MAP_CONF_17(x).B.MD_OFFSET_5)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_17_MD_OFFSET_5. */
#define BF_IPU_DC_MAP_CONF_17_MD_OFFSET_5(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_17_MD_OFFSET_5) & BM_IPU_DC_MAP_CONF_17_MD_OFFSET_5)

/*! @brief Set the MD_OFFSET_5 field to a new value. */
#define BW_IPU_DC_MAP_CONF_17_MD_OFFSET_5(x, v) (HW_IPU_DC_MAP_CONF_17_WR(x, (HW_IPU_DC_MAP_CONF_17_RD(x) & ~BM_IPU_DC_MAP_CONF_17_MD_OFFSET_5) | BF_IPU_DC_MAP_CONF_17_MD_OFFSET_5(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_18 - DC Mapping Configuration Register 18
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_18 - DC Mapping Configuration Register 18 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_18
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_18_bitfields
    {
        uint32_t MD_MASK_6 : 8;        /*!< [7:0]  */
        uint32_t MD_OFFSET_6 : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_7 : 8;        /*!< [23:16]  */
        uint32_t MD_OFFSET_7 : 5;      /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_18_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_18 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_18_ADDR(x) ((uintptr_t)(x) + 0x58150U)

#define HW_IPU_DC_MAP_CONF_18(x) (*(__IO hw_ipu_dc_map_conf_18_t *) HW_IPU_DC_MAP_CONF_18_ADDR(x))
#define HW_IPU_DC_MAP_CONF_18_RD(x) (HW_IPU_DC_MAP_CONF_18(x).U)
#define HW_IPU_DC_MAP_CONF_18_WR(x, v) (HW_IPU_DC_MAP_CONF_18(x).U = (v))
#define HW_IPU_DC_MAP_CONF_18_SET(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, HW_IPU_DC_MAP_CONF_18_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_18_CLR(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, HW_IPU_DC_MAP_CONF_18_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_18_TOG(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, HW_IPU_DC_MAP_CONF_18_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_18 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_18, field MD_MASK_6[7:0] (RW)
 *
 * Mapping unit's mask value #6 This field defines the mask value #6 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_18_MD_MASK_6 (0U) /*!< Bit position for IPU_DC_MAP_CONF_18_MD_MASK_6. */
#define BM_IPU_DC_MAP_CONF_18_MD_MASK_6 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_18_MD_MASK_6. */
#define BS_IPU_DC_MAP_CONF_18_MD_MASK_6 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_18_MD_MASK_6. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_18_MD_MASK_6 field. */
#define BR_IPU_DC_MAP_CONF_18_MD_MASK_6(x) (HW_IPU_DC_MAP_CONF_18(x).B.MD_MASK_6)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_18_MD_MASK_6. */
#define BF_IPU_DC_MAP_CONF_18_MD_MASK_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_18_MD_MASK_6) & BM_IPU_DC_MAP_CONF_18_MD_MASK_6)

/*! @brief Set the MD_MASK_6 field to a new value. */
#define BW_IPU_DC_MAP_CONF_18_MD_MASK_6(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, (HW_IPU_DC_MAP_CONF_18_RD(x) & ~BM_IPU_DC_MAP_CONF_18_MD_MASK_6) | BF_IPU_DC_MAP_CONF_18_MD_MASK_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_18, field MD_OFFSET_6[12:8] (RW)
 *
 * Mapping unit's offset parameter #6 This field defines the offset parameter #6
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_18_MD_OFFSET_6 (8U) /*!< Bit position for IPU_DC_MAP_CONF_18_MD_OFFSET_6. */
#define BM_IPU_DC_MAP_CONF_18_MD_OFFSET_6 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_18_MD_OFFSET_6. */
#define BS_IPU_DC_MAP_CONF_18_MD_OFFSET_6 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_18_MD_OFFSET_6. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_18_MD_OFFSET_6 field. */
#define BR_IPU_DC_MAP_CONF_18_MD_OFFSET_6(x) (HW_IPU_DC_MAP_CONF_18(x).B.MD_OFFSET_6)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_18_MD_OFFSET_6. */
#define BF_IPU_DC_MAP_CONF_18_MD_OFFSET_6(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_18_MD_OFFSET_6) & BM_IPU_DC_MAP_CONF_18_MD_OFFSET_6)

/*! @brief Set the MD_OFFSET_6 field to a new value. */
#define BW_IPU_DC_MAP_CONF_18_MD_OFFSET_6(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, (HW_IPU_DC_MAP_CONF_18_RD(x) & ~BM_IPU_DC_MAP_CONF_18_MD_OFFSET_6) | BF_IPU_DC_MAP_CONF_18_MD_OFFSET_6(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_18, field MD_MASK_7[23:16] (RW)
 *
 * Mapping unit's mask value #7 This field defines the mask value #7 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_18_MD_MASK_7 (16U) /*!< Bit position for IPU_DC_MAP_CONF_18_MD_MASK_7. */
#define BM_IPU_DC_MAP_CONF_18_MD_MASK_7 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_18_MD_MASK_7. */
#define BS_IPU_DC_MAP_CONF_18_MD_MASK_7 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_18_MD_MASK_7. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_18_MD_MASK_7 field. */
#define BR_IPU_DC_MAP_CONF_18_MD_MASK_7(x) (HW_IPU_DC_MAP_CONF_18(x).B.MD_MASK_7)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_18_MD_MASK_7. */
#define BF_IPU_DC_MAP_CONF_18_MD_MASK_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_18_MD_MASK_7) & BM_IPU_DC_MAP_CONF_18_MD_MASK_7)

/*! @brief Set the MD_MASK_7 field to a new value. */
#define BW_IPU_DC_MAP_CONF_18_MD_MASK_7(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, (HW_IPU_DC_MAP_CONF_18_RD(x) & ~BM_IPU_DC_MAP_CONF_18_MD_MASK_7) | BF_IPU_DC_MAP_CONF_18_MD_MASK_7(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_18, field MD_OFFSET_7[28:24] (RW)
 *
 * Mapping unit's offset parameter #7 This field defines the offset parameter #7
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_18_MD_OFFSET_7 (24U) /*!< Bit position for IPU_DC_MAP_CONF_18_MD_OFFSET_7. */
#define BM_IPU_DC_MAP_CONF_18_MD_OFFSET_7 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_18_MD_OFFSET_7. */
#define BS_IPU_DC_MAP_CONF_18_MD_OFFSET_7 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_18_MD_OFFSET_7. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_18_MD_OFFSET_7 field. */
#define BR_IPU_DC_MAP_CONF_18_MD_OFFSET_7(x) (HW_IPU_DC_MAP_CONF_18(x).B.MD_OFFSET_7)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_18_MD_OFFSET_7. */
#define BF_IPU_DC_MAP_CONF_18_MD_OFFSET_7(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_18_MD_OFFSET_7) & BM_IPU_DC_MAP_CONF_18_MD_OFFSET_7)

/*! @brief Set the MD_OFFSET_7 field to a new value. */
#define BW_IPU_DC_MAP_CONF_18_MD_OFFSET_7(x, v) (HW_IPU_DC_MAP_CONF_18_WR(x, (HW_IPU_DC_MAP_CONF_18_RD(x) & ~BM_IPU_DC_MAP_CONF_18_MD_OFFSET_7) | BF_IPU_DC_MAP_CONF_18_MD_OFFSET_7(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_19 - DC Mapping Configuration Register 19
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_19 - DC Mapping Configuration Register 19 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_19
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_19_bitfields
    {
        uint32_t MD_MASK_8 : 8;        /*!< [7:0]  */
        uint32_t MD_OFFSET_8 : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_9 : 8;        /*!< [23:16]  */
        uint32_t MD_OFFSET_9 : 5;      /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_19_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_19 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_19_ADDR(x) ((uintptr_t)(x) + 0x58154U)

#define HW_IPU_DC_MAP_CONF_19(x) (*(__IO hw_ipu_dc_map_conf_19_t *) HW_IPU_DC_MAP_CONF_19_ADDR(x))
#define HW_IPU_DC_MAP_CONF_19_RD(x) (HW_IPU_DC_MAP_CONF_19(x).U)
#define HW_IPU_DC_MAP_CONF_19_WR(x, v) (HW_IPU_DC_MAP_CONF_19(x).U = (v))
#define HW_IPU_DC_MAP_CONF_19_SET(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, HW_IPU_DC_MAP_CONF_19_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_19_CLR(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, HW_IPU_DC_MAP_CONF_19_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_19_TOG(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, HW_IPU_DC_MAP_CONF_19_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_19 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_19, field MD_MASK_8[7:0] (RW)
 *
 * Mapping unit's mask value #8 This field defines the mask value #8 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_19_MD_MASK_8 (0U) /*!< Bit position for IPU_DC_MAP_CONF_19_MD_MASK_8. */
#define BM_IPU_DC_MAP_CONF_19_MD_MASK_8 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_19_MD_MASK_8. */
#define BS_IPU_DC_MAP_CONF_19_MD_MASK_8 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_19_MD_MASK_8. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_19_MD_MASK_8 field. */
#define BR_IPU_DC_MAP_CONF_19_MD_MASK_8(x) (HW_IPU_DC_MAP_CONF_19(x).B.MD_MASK_8)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_19_MD_MASK_8. */
#define BF_IPU_DC_MAP_CONF_19_MD_MASK_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_19_MD_MASK_8) & BM_IPU_DC_MAP_CONF_19_MD_MASK_8)

/*! @brief Set the MD_MASK_8 field to a new value. */
#define BW_IPU_DC_MAP_CONF_19_MD_MASK_8(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, (HW_IPU_DC_MAP_CONF_19_RD(x) & ~BM_IPU_DC_MAP_CONF_19_MD_MASK_8) | BF_IPU_DC_MAP_CONF_19_MD_MASK_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_19, field MD_OFFSET_8[12:8] (RW)
 *
 * Mapping unit's offset parameter #8 This field defines the offset parameter #8
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_19_MD_OFFSET_8 (8U) /*!< Bit position for IPU_DC_MAP_CONF_19_MD_OFFSET_8. */
#define BM_IPU_DC_MAP_CONF_19_MD_OFFSET_8 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_19_MD_OFFSET_8. */
#define BS_IPU_DC_MAP_CONF_19_MD_OFFSET_8 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_19_MD_OFFSET_8. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_19_MD_OFFSET_8 field. */
#define BR_IPU_DC_MAP_CONF_19_MD_OFFSET_8(x) (HW_IPU_DC_MAP_CONF_19(x).B.MD_OFFSET_8)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_19_MD_OFFSET_8. */
#define BF_IPU_DC_MAP_CONF_19_MD_OFFSET_8(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_19_MD_OFFSET_8) & BM_IPU_DC_MAP_CONF_19_MD_OFFSET_8)

/*! @brief Set the MD_OFFSET_8 field to a new value. */
#define BW_IPU_DC_MAP_CONF_19_MD_OFFSET_8(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, (HW_IPU_DC_MAP_CONF_19_RD(x) & ~BM_IPU_DC_MAP_CONF_19_MD_OFFSET_8) | BF_IPU_DC_MAP_CONF_19_MD_OFFSET_8(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_19, field MD_MASK_9[23:16] (RW)
 *
 * Mapping unit's mask value #9 This field defines the mask value #9 within the
 * 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_19_MD_MASK_9 (16U) /*!< Bit position for IPU_DC_MAP_CONF_19_MD_MASK_9. */
#define BM_IPU_DC_MAP_CONF_19_MD_MASK_9 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_19_MD_MASK_9. */
#define BS_IPU_DC_MAP_CONF_19_MD_MASK_9 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_19_MD_MASK_9. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_19_MD_MASK_9 field. */
#define BR_IPU_DC_MAP_CONF_19_MD_MASK_9(x) (HW_IPU_DC_MAP_CONF_19(x).B.MD_MASK_9)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_19_MD_MASK_9. */
#define BF_IPU_DC_MAP_CONF_19_MD_MASK_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_19_MD_MASK_9) & BM_IPU_DC_MAP_CONF_19_MD_MASK_9)

/*! @brief Set the MD_MASK_9 field to a new value. */
#define BW_IPU_DC_MAP_CONF_19_MD_MASK_9(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, (HW_IPU_DC_MAP_CONF_19_RD(x) & ~BM_IPU_DC_MAP_CONF_19_MD_MASK_9) | BF_IPU_DC_MAP_CONF_19_MD_MASK_9(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_19, field MD_OFFSET_9[28:24] (RW)
 *
 * Mapping unit's offset parameter #9 This field defines the offset parameter #9
 * within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_19_MD_OFFSET_9 (24U) /*!< Bit position for IPU_DC_MAP_CONF_19_MD_OFFSET_9. */
#define BM_IPU_DC_MAP_CONF_19_MD_OFFSET_9 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_19_MD_OFFSET_9. */
#define BS_IPU_DC_MAP_CONF_19_MD_OFFSET_9 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_19_MD_OFFSET_9. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_19_MD_OFFSET_9 field. */
#define BR_IPU_DC_MAP_CONF_19_MD_OFFSET_9(x) (HW_IPU_DC_MAP_CONF_19(x).B.MD_OFFSET_9)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_19_MD_OFFSET_9. */
#define BF_IPU_DC_MAP_CONF_19_MD_OFFSET_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_19_MD_OFFSET_9) & BM_IPU_DC_MAP_CONF_19_MD_OFFSET_9)

/*! @brief Set the MD_OFFSET_9 field to a new value. */
#define BW_IPU_DC_MAP_CONF_19_MD_OFFSET_9(x, v) (HW_IPU_DC_MAP_CONF_19_WR(x, (HW_IPU_DC_MAP_CONF_19_RD(x) & ~BM_IPU_DC_MAP_CONF_19_MD_OFFSET_9) | BF_IPU_DC_MAP_CONF_19_MD_OFFSET_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_20 - DC Mapping Configuration Register 20
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_20 - DC Mapping Configuration Register 20 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_20
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_20_bitfields
    {
        uint32_t MD_MASK_10 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_10 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_11 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_11 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_20_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_20 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_20_ADDR(x) ((uintptr_t)(x) + 0x58158U)

#define HW_IPU_DC_MAP_CONF_20(x) (*(__IO hw_ipu_dc_map_conf_20_t *) HW_IPU_DC_MAP_CONF_20_ADDR(x))
#define HW_IPU_DC_MAP_CONF_20_RD(x) (HW_IPU_DC_MAP_CONF_20(x).U)
#define HW_IPU_DC_MAP_CONF_20_WR(x, v) (HW_IPU_DC_MAP_CONF_20(x).U = (v))
#define HW_IPU_DC_MAP_CONF_20_SET(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, HW_IPU_DC_MAP_CONF_20_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_20_CLR(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, HW_IPU_DC_MAP_CONF_20_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_20_TOG(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, HW_IPU_DC_MAP_CONF_20_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_20 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_20, field MD_MASK_10[7:0] (RW)
 *
 * Mapping unit's mask value #10 This field defines the mask value #10 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_20_MD_MASK_10 (0U) /*!< Bit position for IPU_DC_MAP_CONF_20_MD_MASK_10. */
#define BM_IPU_DC_MAP_CONF_20_MD_MASK_10 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_20_MD_MASK_10. */
#define BS_IPU_DC_MAP_CONF_20_MD_MASK_10 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_20_MD_MASK_10. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_20_MD_MASK_10 field. */
#define BR_IPU_DC_MAP_CONF_20_MD_MASK_10(x) (HW_IPU_DC_MAP_CONF_20(x).B.MD_MASK_10)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_20_MD_MASK_10. */
#define BF_IPU_DC_MAP_CONF_20_MD_MASK_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_20_MD_MASK_10) & BM_IPU_DC_MAP_CONF_20_MD_MASK_10)

/*! @brief Set the MD_MASK_10 field to a new value. */
#define BW_IPU_DC_MAP_CONF_20_MD_MASK_10(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, (HW_IPU_DC_MAP_CONF_20_RD(x) & ~BM_IPU_DC_MAP_CONF_20_MD_MASK_10) | BF_IPU_DC_MAP_CONF_20_MD_MASK_10(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_20, field MD_OFFSET_10[12:8] (RW)
 *
 * Mapping unit's offset parameter #10 This field defines the offset parameter
 * #10 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_20_MD_OFFSET_10 (8U) /*!< Bit position for IPU_DC_MAP_CONF_20_MD_OFFSET_10. */
#define BM_IPU_DC_MAP_CONF_20_MD_OFFSET_10 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_20_MD_OFFSET_10. */
#define BS_IPU_DC_MAP_CONF_20_MD_OFFSET_10 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_20_MD_OFFSET_10. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_20_MD_OFFSET_10 field. */
#define BR_IPU_DC_MAP_CONF_20_MD_OFFSET_10(x) (HW_IPU_DC_MAP_CONF_20(x).B.MD_OFFSET_10)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_20_MD_OFFSET_10. */
#define BF_IPU_DC_MAP_CONF_20_MD_OFFSET_10(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_20_MD_OFFSET_10) & BM_IPU_DC_MAP_CONF_20_MD_OFFSET_10)

/*! @brief Set the MD_OFFSET_10 field to a new value. */
#define BW_IPU_DC_MAP_CONF_20_MD_OFFSET_10(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, (HW_IPU_DC_MAP_CONF_20_RD(x) & ~BM_IPU_DC_MAP_CONF_20_MD_OFFSET_10) | BF_IPU_DC_MAP_CONF_20_MD_OFFSET_10(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_20, field MD_MASK_11[23:16] (RW)
 *
 * Mapping unit's mask value #11 This field defines the mask value #11 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_20_MD_MASK_11 (16U) /*!< Bit position for IPU_DC_MAP_CONF_20_MD_MASK_11. */
#define BM_IPU_DC_MAP_CONF_20_MD_MASK_11 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_20_MD_MASK_11. */
#define BS_IPU_DC_MAP_CONF_20_MD_MASK_11 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_20_MD_MASK_11. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_20_MD_MASK_11 field. */
#define BR_IPU_DC_MAP_CONF_20_MD_MASK_11(x) (HW_IPU_DC_MAP_CONF_20(x).B.MD_MASK_11)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_20_MD_MASK_11. */
#define BF_IPU_DC_MAP_CONF_20_MD_MASK_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_20_MD_MASK_11) & BM_IPU_DC_MAP_CONF_20_MD_MASK_11)

/*! @brief Set the MD_MASK_11 field to a new value. */
#define BW_IPU_DC_MAP_CONF_20_MD_MASK_11(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, (HW_IPU_DC_MAP_CONF_20_RD(x) & ~BM_IPU_DC_MAP_CONF_20_MD_MASK_11) | BF_IPU_DC_MAP_CONF_20_MD_MASK_11(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_20, field MD_OFFSET_11[28:24] (RW)
 *
 * Mapping unit's offset parameter #11 This field defines the offset parameter
 * #11 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_20_MD_OFFSET_11 (24U) /*!< Bit position for IPU_DC_MAP_CONF_20_MD_OFFSET_11. */
#define BM_IPU_DC_MAP_CONF_20_MD_OFFSET_11 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_20_MD_OFFSET_11. */
#define BS_IPU_DC_MAP_CONF_20_MD_OFFSET_11 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_20_MD_OFFSET_11. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_20_MD_OFFSET_11 field. */
#define BR_IPU_DC_MAP_CONF_20_MD_OFFSET_11(x) (HW_IPU_DC_MAP_CONF_20(x).B.MD_OFFSET_11)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_20_MD_OFFSET_11. */
#define BF_IPU_DC_MAP_CONF_20_MD_OFFSET_11(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_20_MD_OFFSET_11) & BM_IPU_DC_MAP_CONF_20_MD_OFFSET_11)

/*! @brief Set the MD_OFFSET_11 field to a new value. */
#define BW_IPU_DC_MAP_CONF_20_MD_OFFSET_11(x, v) (HW_IPU_DC_MAP_CONF_20_WR(x, (HW_IPU_DC_MAP_CONF_20_RD(x) & ~BM_IPU_DC_MAP_CONF_20_MD_OFFSET_11) | BF_IPU_DC_MAP_CONF_20_MD_OFFSET_11(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_21 - DC Mapping Configuration Register 21
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_21 - DC Mapping Configuration Register 21 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_21
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_21_bitfields
    {
        uint32_t MD_MASK_12 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_12 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_13 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_13 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_21_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_21 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_21_ADDR(x) ((uintptr_t)(x) + 0x5815CU)

#define HW_IPU_DC_MAP_CONF_21(x) (*(__IO hw_ipu_dc_map_conf_21_t *) HW_IPU_DC_MAP_CONF_21_ADDR(x))
#define HW_IPU_DC_MAP_CONF_21_RD(x) (HW_IPU_DC_MAP_CONF_21(x).U)
#define HW_IPU_DC_MAP_CONF_21_WR(x, v) (HW_IPU_DC_MAP_CONF_21(x).U = (v))
#define HW_IPU_DC_MAP_CONF_21_SET(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, HW_IPU_DC_MAP_CONF_21_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_21_CLR(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, HW_IPU_DC_MAP_CONF_21_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_21_TOG(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, HW_IPU_DC_MAP_CONF_21_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_21 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_21, field MD_MASK_12[7:0] (RW)
 *
 * Mapping unit's mask value #12 This field defines the mask value #12 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_21_MD_MASK_12 (0U) /*!< Bit position for IPU_DC_MAP_CONF_21_MD_MASK_12. */
#define BM_IPU_DC_MAP_CONF_21_MD_MASK_12 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_21_MD_MASK_12. */
#define BS_IPU_DC_MAP_CONF_21_MD_MASK_12 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_21_MD_MASK_12. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_21_MD_MASK_12 field. */
#define BR_IPU_DC_MAP_CONF_21_MD_MASK_12(x) (HW_IPU_DC_MAP_CONF_21(x).B.MD_MASK_12)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_21_MD_MASK_12. */
#define BF_IPU_DC_MAP_CONF_21_MD_MASK_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_21_MD_MASK_12) & BM_IPU_DC_MAP_CONF_21_MD_MASK_12)

/*! @brief Set the MD_MASK_12 field to a new value. */
#define BW_IPU_DC_MAP_CONF_21_MD_MASK_12(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, (HW_IPU_DC_MAP_CONF_21_RD(x) & ~BM_IPU_DC_MAP_CONF_21_MD_MASK_12) | BF_IPU_DC_MAP_CONF_21_MD_MASK_12(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_21, field MD_OFFSET_12[12:8] (RW)
 *
 * Mapping unit's offset parameter #12 This field defines the offset parameter
 * #12 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_21_MD_OFFSET_12 (8U) /*!< Bit position for IPU_DC_MAP_CONF_21_MD_OFFSET_12. */
#define BM_IPU_DC_MAP_CONF_21_MD_OFFSET_12 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_21_MD_OFFSET_12. */
#define BS_IPU_DC_MAP_CONF_21_MD_OFFSET_12 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_21_MD_OFFSET_12. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_21_MD_OFFSET_12 field. */
#define BR_IPU_DC_MAP_CONF_21_MD_OFFSET_12(x) (HW_IPU_DC_MAP_CONF_21(x).B.MD_OFFSET_12)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_21_MD_OFFSET_12. */
#define BF_IPU_DC_MAP_CONF_21_MD_OFFSET_12(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_21_MD_OFFSET_12) & BM_IPU_DC_MAP_CONF_21_MD_OFFSET_12)

/*! @brief Set the MD_OFFSET_12 field to a new value. */
#define BW_IPU_DC_MAP_CONF_21_MD_OFFSET_12(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, (HW_IPU_DC_MAP_CONF_21_RD(x) & ~BM_IPU_DC_MAP_CONF_21_MD_OFFSET_12) | BF_IPU_DC_MAP_CONF_21_MD_OFFSET_12(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_21, field MD_MASK_13[23:16] (RW)
 *
 * Mapping unit's mask value #13 This field defines the mask value #13 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_21_MD_MASK_13 (16U) /*!< Bit position for IPU_DC_MAP_CONF_21_MD_MASK_13. */
#define BM_IPU_DC_MAP_CONF_21_MD_MASK_13 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_21_MD_MASK_13. */
#define BS_IPU_DC_MAP_CONF_21_MD_MASK_13 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_21_MD_MASK_13. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_21_MD_MASK_13 field. */
#define BR_IPU_DC_MAP_CONF_21_MD_MASK_13(x) (HW_IPU_DC_MAP_CONF_21(x).B.MD_MASK_13)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_21_MD_MASK_13. */
#define BF_IPU_DC_MAP_CONF_21_MD_MASK_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_21_MD_MASK_13) & BM_IPU_DC_MAP_CONF_21_MD_MASK_13)

/*! @brief Set the MD_MASK_13 field to a new value. */
#define BW_IPU_DC_MAP_CONF_21_MD_MASK_13(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, (HW_IPU_DC_MAP_CONF_21_RD(x) & ~BM_IPU_DC_MAP_CONF_21_MD_MASK_13) | BF_IPU_DC_MAP_CONF_21_MD_MASK_13(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_21, field MD_OFFSET_13[28:24] (RW)
 *
 * Mapping unit's offset parameter #13 This field defines the offset parameter
 * #13 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_21_MD_OFFSET_13 (24U) /*!< Bit position for IPU_DC_MAP_CONF_21_MD_OFFSET_13. */
#define BM_IPU_DC_MAP_CONF_21_MD_OFFSET_13 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_21_MD_OFFSET_13. */
#define BS_IPU_DC_MAP_CONF_21_MD_OFFSET_13 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_21_MD_OFFSET_13. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_21_MD_OFFSET_13 field. */
#define BR_IPU_DC_MAP_CONF_21_MD_OFFSET_13(x) (HW_IPU_DC_MAP_CONF_21(x).B.MD_OFFSET_13)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_21_MD_OFFSET_13. */
#define BF_IPU_DC_MAP_CONF_21_MD_OFFSET_13(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_21_MD_OFFSET_13) & BM_IPU_DC_MAP_CONF_21_MD_OFFSET_13)

/*! @brief Set the MD_OFFSET_13 field to a new value. */
#define BW_IPU_DC_MAP_CONF_21_MD_OFFSET_13(x, v) (HW_IPU_DC_MAP_CONF_21_WR(x, (HW_IPU_DC_MAP_CONF_21_RD(x) & ~BM_IPU_DC_MAP_CONF_21_MD_OFFSET_13) | BF_IPU_DC_MAP_CONF_21_MD_OFFSET_13(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_22 - DC Mapping Configuration Register 22
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_22 - DC Mapping Configuration Register 22 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_22
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_22_bitfields
    {
        uint32_t MD_MASK_14 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_14 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_15 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_15 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_22_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_22 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_22_ADDR(x) ((uintptr_t)(x) + 0x58160U)

#define HW_IPU_DC_MAP_CONF_22(x) (*(__IO hw_ipu_dc_map_conf_22_t *) HW_IPU_DC_MAP_CONF_22_ADDR(x))
#define HW_IPU_DC_MAP_CONF_22_RD(x) (HW_IPU_DC_MAP_CONF_22(x).U)
#define HW_IPU_DC_MAP_CONF_22_WR(x, v) (HW_IPU_DC_MAP_CONF_22(x).U = (v))
#define HW_IPU_DC_MAP_CONF_22_SET(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, HW_IPU_DC_MAP_CONF_22_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_22_CLR(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, HW_IPU_DC_MAP_CONF_22_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_22_TOG(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, HW_IPU_DC_MAP_CONF_22_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_22 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_22, field MD_MASK_14[7:0] (RW)
 *
 * Mapping unit's mask value #14 This field defines the mask value #14 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_22_MD_MASK_14 (0U) /*!< Bit position for IPU_DC_MAP_CONF_22_MD_MASK_14. */
#define BM_IPU_DC_MAP_CONF_22_MD_MASK_14 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_22_MD_MASK_14. */
#define BS_IPU_DC_MAP_CONF_22_MD_MASK_14 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_22_MD_MASK_14. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_22_MD_MASK_14 field. */
#define BR_IPU_DC_MAP_CONF_22_MD_MASK_14(x) (HW_IPU_DC_MAP_CONF_22(x).B.MD_MASK_14)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_22_MD_MASK_14. */
#define BF_IPU_DC_MAP_CONF_22_MD_MASK_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_22_MD_MASK_14) & BM_IPU_DC_MAP_CONF_22_MD_MASK_14)

/*! @brief Set the MD_MASK_14 field to a new value. */
#define BW_IPU_DC_MAP_CONF_22_MD_MASK_14(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, (HW_IPU_DC_MAP_CONF_22_RD(x) & ~BM_IPU_DC_MAP_CONF_22_MD_MASK_14) | BF_IPU_DC_MAP_CONF_22_MD_MASK_14(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_22, field MD_OFFSET_14[12:8] (RW)
 *
 * Mapping unit's offset parameter #14 This field defines the offset parameter
 * #14 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_22_MD_OFFSET_14 (8U) /*!< Bit position for IPU_DC_MAP_CONF_22_MD_OFFSET_14. */
#define BM_IPU_DC_MAP_CONF_22_MD_OFFSET_14 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_22_MD_OFFSET_14. */
#define BS_IPU_DC_MAP_CONF_22_MD_OFFSET_14 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_22_MD_OFFSET_14. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_22_MD_OFFSET_14 field. */
#define BR_IPU_DC_MAP_CONF_22_MD_OFFSET_14(x) (HW_IPU_DC_MAP_CONF_22(x).B.MD_OFFSET_14)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_22_MD_OFFSET_14. */
#define BF_IPU_DC_MAP_CONF_22_MD_OFFSET_14(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_22_MD_OFFSET_14) & BM_IPU_DC_MAP_CONF_22_MD_OFFSET_14)

/*! @brief Set the MD_OFFSET_14 field to a new value. */
#define BW_IPU_DC_MAP_CONF_22_MD_OFFSET_14(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, (HW_IPU_DC_MAP_CONF_22_RD(x) & ~BM_IPU_DC_MAP_CONF_22_MD_OFFSET_14) | BF_IPU_DC_MAP_CONF_22_MD_OFFSET_14(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_22, field MD_MASK_15[23:16] (RW)
 *
 * Mapping unit's mask value #15 This field defines the mask value #15 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_22_MD_MASK_15 (16U) /*!< Bit position for IPU_DC_MAP_CONF_22_MD_MASK_15. */
#define BM_IPU_DC_MAP_CONF_22_MD_MASK_15 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_22_MD_MASK_15. */
#define BS_IPU_DC_MAP_CONF_22_MD_MASK_15 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_22_MD_MASK_15. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_22_MD_MASK_15 field. */
#define BR_IPU_DC_MAP_CONF_22_MD_MASK_15(x) (HW_IPU_DC_MAP_CONF_22(x).B.MD_MASK_15)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_22_MD_MASK_15. */
#define BF_IPU_DC_MAP_CONF_22_MD_MASK_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_22_MD_MASK_15) & BM_IPU_DC_MAP_CONF_22_MD_MASK_15)

/*! @brief Set the MD_MASK_15 field to a new value. */
#define BW_IPU_DC_MAP_CONF_22_MD_MASK_15(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, (HW_IPU_DC_MAP_CONF_22_RD(x) & ~BM_IPU_DC_MAP_CONF_22_MD_MASK_15) | BF_IPU_DC_MAP_CONF_22_MD_MASK_15(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_22, field MD_OFFSET_15[28:24] (RW)
 *
 * Mapping unit's offset parameter #15 This field defines the offset parameter
 * #15 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_22_MD_OFFSET_15 (24U) /*!< Bit position for IPU_DC_MAP_CONF_22_MD_OFFSET_15. */
#define BM_IPU_DC_MAP_CONF_22_MD_OFFSET_15 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_22_MD_OFFSET_15. */
#define BS_IPU_DC_MAP_CONF_22_MD_OFFSET_15 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_22_MD_OFFSET_15. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_22_MD_OFFSET_15 field. */
#define BR_IPU_DC_MAP_CONF_22_MD_OFFSET_15(x) (HW_IPU_DC_MAP_CONF_22(x).B.MD_OFFSET_15)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_22_MD_OFFSET_15. */
#define BF_IPU_DC_MAP_CONF_22_MD_OFFSET_15(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_22_MD_OFFSET_15) & BM_IPU_DC_MAP_CONF_22_MD_OFFSET_15)

/*! @brief Set the MD_OFFSET_15 field to a new value. */
#define BW_IPU_DC_MAP_CONF_22_MD_OFFSET_15(x, v) (HW_IPU_DC_MAP_CONF_22_WR(x, (HW_IPU_DC_MAP_CONF_22_RD(x) & ~BM_IPU_DC_MAP_CONF_22_MD_OFFSET_15) | BF_IPU_DC_MAP_CONF_22_MD_OFFSET_15(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_23 - DC Mapping Configuration Register 23
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_23 - DC Mapping Configuration Register 23 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_23
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_23_bitfields
    {
        uint32_t MD_MASK_16 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_16 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_17 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_17 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_23_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_23 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_23_ADDR(x) ((uintptr_t)(x) + 0x58164U)

#define HW_IPU_DC_MAP_CONF_23(x) (*(__IO hw_ipu_dc_map_conf_23_t *) HW_IPU_DC_MAP_CONF_23_ADDR(x))
#define HW_IPU_DC_MAP_CONF_23_RD(x) (HW_IPU_DC_MAP_CONF_23(x).U)
#define HW_IPU_DC_MAP_CONF_23_WR(x, v) (HW_IPU_DC_MAP_CONF_23(x).U = (v))
#define HW_IPU_DC_MAP_CONF_23_SET(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, HW_IPU_DC_MAP_CONF_23_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_23_CLR(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, HW_IPU_DC_MAP_CONF_23_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_23_TOG(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, HW_IPU_DC_MAP_CONF_23_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_23 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_23, field MD_MASK_16[7:0] (RW)
 *
 * Mapping unit's mask value #16 This field defines the mask value #16 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_23_MD_MASK_16 (0U) /*!< Bit position for IPU_DC_MAP_CONF_23_MD_MASK_16. */
#define BM_IPU_DC_MAP_CONF_23_MD_MASK_16 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_23_MD_MASK_16. */
#define BS_IPU_DC_MAP_CONF_23_MD_MASK_16 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_23_MD_MASK_16. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_23_MD_MASK_16 field. */
#define BR_IPU_DC_MAP_CONF_23_MD_MASK_16(x) (HW_IPU_DC_MAP_CONF_23(x).B.MD_MASK_16)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_23_MD_MASK_16. */
#define BF_IPU_DC_MAP_CONF_23_MD_MASK_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_23_MD_MASK_16) & BM_IPU_DC_MAP_CONF_23_MD_MASK_16)

/*! @brief Set the MD_MASK_16 field to a new value. */
#define BW_IPU_DC_MAP_CONF_23_MD_MASK_16(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, (HW_IPU_DC_MAP_CONF_23_RD(x) & ~BM_IPU_DC_MAP_CONF_23_MD_MASK_16) | BF_IPU_DC_MAP_CONF_23_MD_MASK_16(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_23, field MD_OFFSET_16[12:8] (RW)
 *
 * Mapping unit's offset parameter #16 This field defines the offset parameter
 * #16 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_23_MD_OFFSET_16 (8U) /*!< Bit position for IPU_DC_MAP_CONF_23_MD_OFFSET_16. */
#define BM_IPU_DC_MAP_CONF_23_MD_OFFSET_16 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_23_MD_OFFSET_16. */
#define BS_IPU_DC_MAP_CONF_23_MD_OFFSET_16 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_23_MD_OFFSET_16. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_23_MD_OFFSET_16 field. */
#define BR_IPU_DC_MAP_CONF_23_MD_OFFSET_16(x) (HW_IPU_DC_MAP_CONF_23(x).B.MD_OFFSET_16)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_23_MD_OFFSET_16. */
#define BF_IPU_DC_MAP_CONF_23_MD_OFFSET_16(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_23_MD_OFFSET_16) & BM_IPU_DC_MAP_CONF_23_MD_OFFSET_16)

/*! @brief Set the MD_OFFSET_16 field to a new value. */
#define BW_IPU_DC_MAP_CONF_23_MD_OFFSET_16(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, (HW_IPU_DC_MAP_CONF_23_RD(x) & ~BM_IPU_DC_MAP_CONF_23_MD_OFFSET_16) | BF_IPU_DC_MAP_CONF_23_MD_OFFSET_16(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_23, field MD_MASK_17[23:16] (RW)
 *
 * Mapping unit's mask value #17 This field defines the mask value #17 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_23_MD_MASK_17 (16U) /*!< Bit position for IPU_DC_MAP_CONF_23_MD_MASK_17. */
#define BM_IPU_DC_MAP_CONF_23_MD_MASK_17 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_23_MD_MASK_17. */
#define BS_IPU_DC_MAP_CONF_23_MD_MASK_17 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_23_MD_MASK_17. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_23_MD_MASK_17 field. */
#define BR_IPU_DC_MAP_CONF_23_MD_MASK_17(x) (HW_IPU_DC_MAP_CONF_23(x).B.MD_MASK_17)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_23_MD_MASK_17. */
#define BF_IPU_DC_MAP_CONF_23_MD_MASK_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_23_MD_MASK_17) & BM_IPU_DC_MAP_CONF_23_MD_MASK_17)

/*! @brief Set the MD_MASK_17 field to a new value. */
#define BW_IPU_DC_MAP_CONF_23_MD_MASK_17(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, (HW_IPU_DC_MAP_CONF_23_RD(x) & ~BM_IPU_DC_MAP_CONF_23_MD_MASK_17) | BF_IPU_DC_MAP_CONF_23_MD_MASK_17(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_23, field MD_OFFSET_17[28:24] (RW)
 *
 * Mapping unit's offset parameter #17 This field defines the offset parameter
 * #17 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_23_MD_OFFSET_17 (24U) /*!< Bit position for IPU_DC_MAP_CONF_23_MD_OFFSET_17. */
#define BM_IPU_DC_MAP_CONF_23_MD_OFFSET_17 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_23_MD_OFFSET_17. */
#define BS_IPU_DC_MAP_CONF_23_MD_OFFSET_17 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_23_MD_OFFSET_17. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_23_MD_OFFSET_17 field. */
#define BR_IPU_DC_MAP_CONF_23_MD_OFFSET_17(x) (HW_IPU_DC_MAP_CONF_23(x).B.MD_OFFSET_17)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_23_MD_OFFSET_17. */
#define BF_IPU_DC_MAP_CONF_23_MD_OFFSET_17(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_23_MD_OFFSET_17) & BM_IPU_DC_MAP_CONF_23_MD_OFFSET_17)

/*! @brief Set the MD_OFFSET_17 field to a new value. */
#define BW_IPU_DC_MAP_CONF_23_MD_OFFSET_17(x, v) (HW_IPU_DC_MAP_CONF_23_WR(x, (HW_IPU_DC_MAP_CONF_23_RD(x) & ~BM_IPU_DC_MAP_CONF_23_MD_OFFSET_17) | BF_IPU_DC_MAP_CONF_23_MD_OFFSET_17(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_24 - DC Mapping Configuration Register 24
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_24 - DC Mapping Configuration Register 24 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_24
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_24_bitfields
    {
        uint32_t MD_MASK_18 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_18 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_19 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_19 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_24_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_24 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_24_ADDR(x) ((uintptr_t)(x) + 0x58168U)

#define HW_IPU_DC_MAP_CONF_24(x) (*(__IO hw_ipu_dc_map_conf_24_t *) HW_IPU_DC_MAP_CONF_24_ADDR(x))
#define HW_IPU_DC_MAP_CONF_24_RD(x) (HW_IPU_DC_MAP_CONF_24(x).U)
#define HW_IPU_DC_MAP_CONF_24_WR(x, v) (HW_IPU_DC_MAP_CONF_24(x).U = (v))
#define HW_IPU_DC_MAP_CONF_24_SET(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, HW_IPU_DC_MAP_CONF_24_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_24_CLR(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, HW_IPU_DC_MAP_CONF_24_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_24_TOG(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, HW_IPU_DC_MAP_CONF_24_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_24 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_24, field MD_MASK_18[7:0] (RW)
 *
 * Mapping unit's mask value #18 This field defines the mask value #18 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_24_MD_MASK_18 (0U) /*!< Bit position for IPU_DC_MAP_CONF_24_MD_MASK_18. */
#define BM_IPU_DC_MAP_CONF_24_MD_MASK_18 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_24_MD_MASK_18. */
#define BS_IPU_DC_MAP_CONF_24_MD_MASK_18 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_24_MD_MASK_18. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_24_MD_MASK_18 field. */
#define BR_IPU_DC_MAP_CONF_24_MD_MASK_18(x) (HW_IPU_DC_MAP_CONF_24(x).B.MD_MASK_18)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_24_MD_MASK_18. */
#define BF_IPU_DC_MAP_CONF_24_MD_MASK_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_24_MD_MASK_18) & BM_IPU_DC_MAP_CONF_24_MD_MASK_18)

/*! @brief Set the MD_MASK_18 field to a new value. */
#define BW_IPU_DC_MAP_CONF_24_MD_MASK_18(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, (HW_IPU_DC_MAP_CONF_24_RD(x) & ~BM_IPU_DC_MAP_CONF_24_MD_MASK_18) | BF_IPU_DC_MAP_CONF_24_MD_MASK_18(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_24, field MD_OFFSET_18[12:8] (RW)
 *
 * Mapping unit's offset parameter #18 This field defines the offset parameter
 * #18 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_24_MD_OFFSET_18 (8U) /*!< Bit position for IPU_DC_MAP_CONF_24_MD_OFFSET_18. */
#define BM_IPU_DC_MAP_CONF_24_MD_OFFSET_18 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_24_MD_OFFSET_18. */
#define BS_IPU_DC_MAP_CONF_24_MD_OFFSET_18 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_24_MD_OFFSET_18. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_24_MD_OFFSET_18 field. */
#define BR_IPU_DC_MAP_CONF_24_MD_OFFSET_18(x) (HW_IPU_DC_MAP_CONF_24(x).B.MD_OFFSET_18)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_24_MD_OFFSET_18. */
#define BF_IPU_DC_MAP_CONF_24_MD_OFFSET_18(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_24_MD_OFFSET_18) & BM_IPU_DC_MAP_CONF_24_MD_OFFSET_18)

/*! @brief Set the MD_OFFSET_18 field to a new value. */
#define BW_IPU_DC_MAP_CONF_24_MD_OFFSET_18(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, (HW_IPU_DC_MAP_CONF_24_RD(x) & ~BM_IPU_DC_MAP_CONF_24_MD_OFFSET_18) | BF_IPU_DC_MAP_CONF_24_MD_OFFSET_18(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_24, field MD_MASK_19[23:16] (RW)
 *
 * Mapping unit's mask value #19 This field defines the mask value #19 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_24_MD_MASK_19 (16U) /*!< Bit position for IPU_DC_MAP_CONF_24_MD_MASK_19. */
#define BM_IPU_DC_MAP_CONF_24_MD_MASK_19 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_24_MD_MASK_19. */
#define BS_IPU_DC_MAP_CONF_24_MD_MASK_19 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_24_MD_MASK_19. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_24_MD_MASK_19 field. */
#define BR_IPU_DC_MAP_CONF_24_MD_MASK_19(x) (HW_IPU_DC_MAP_CONF_24(x).B.MD_MASK_19)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_24_MD_MASK_19. */
#define BF_IPU_DC_MAP_CONF_24_MD_MASK_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_24_MD_MASK_19) & BM_IPU_DC_MAP_CONF_24_MD_MASK_19)

/*! @brief Set the MD_MASK_19 field to a new value. */
#define BW_IPU_DC_MAP_CONF_24_MD_MASK_19(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, (HW_IPU_DC_MAP_CONF_24_RD(x) & ~BM_IPU_DC_MAP_CONF_24_MD_MASK_19) | BF_IPU_DC_MAP_CONF_24_MD_MASK_19(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_24, field MD_OFFSET_19[28:24] (RW)
 *
 * Mapping unit's offset parameter #19 This field defines the offset parameter
 * #19 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_24_MD_OFFSET_19 (24U) /*!< Bit position for IPU_DC_MAP_CONF_24_MD_OFFSET_19. */
#define BM_IPU_DC_MAP_CONF_24_MD_OFFSET_19 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_24_MD_OFFSET_19. */
#define BS_IPU_DC_MAP_CONF_24_MD_OFFSET_19 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_24_MD_OFFSET_19. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_24_MD_OFFSET_19 field. */
#define BR_IPU_DC_MAP_CONF_24_MD_OFFSET_19(x) (HW_IPU_DC_MAP_CONF_24(x).B.MD_OFFSET_19)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_24_MD_OFFSET_19. */
#define BF_IPU_DC_MAP_CONF_24_MD_OFFSET_19(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_24_MD_OFFSET_19) & BM_IPU_DC_MAP_CONF_24_MD_OFFSET_19)

/*! @brief Set the MD_OFFSET_19 field to a new value. */
#define BW_IPU_DC_MAP_CONF_24_MD_OFFSET_19(x, v) (HW_IPU_DC_MAP_CONF_24_WR(x, (HW_IPU_DC_MAP_CONF_24_RD(x) & ~BM_IPU_DC_MAP_CONF_24_MD_OFFSET_19) | BF_IPU_DC_MAP_CONF_24_MD_OFFSET_19(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_25 - DC Mapping Configuration Register 25
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_25 - DC Mapping Configuration Register 25 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_25
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_25_bitfields
    {
        uint32_t MD_MASK_20 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_20 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_21 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_21 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_25_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_25 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_25_ADDR(x) ((uintptr_t)(x) + 0x5816CU)

#define HW_IPU_DC_MAP_CONF_25(x) (*(__IO hw_ipu_dc_map_conf_25_t *) HW_IPU_DC_MAP_CONF_25_ADDR(x))
#define HW_IPU_DC_MAP_CONF_25_RD(x) (HW_IPU_DC_MAP_CONF_25(x).U)
#define HW_IPU_DC_MAP_CONF_25_WR(x, v) (HW_IPU_DC_MAP_CONF_25(x).U = (v))
#define HW_IPU_DC_MAP_CONF_25_SET(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, HW_IPU_DC_MAP_CONF_25_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_25_CLR(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, HW_IPU_DC_MAP_CONF_25_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_25_TOG(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, HW_IPU_DC_MAP_CONF_25_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_25 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_25, field MD_MASK_20[7:0] (RW)
 *
 * Mapping unit's mask value #20 This field defines the mask value #20 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_25_MD_MASK_20 (0U) /*!< Bit position for IPU_DC_MAP_CONF_25_MD_MASK_20. */
#define BM_IPU_DC_MAP_CONF_25_MD_MASK_20 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_25_MD_MASK_20. */
#define BS_IPU_DC_MAP_CONF_25_MD_MASK_20 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_25_MD_MASK_20. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_25_MD_MASK_20 field. */
#define BR_IPU_DC_MAP_CONF_25_MD_MASK_20(x) (HW_IPU_DC_MAP_CONF_25(x).B.MD_MASK_20)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_25_MD_MASK_20. */
#define BF_IPU_DC_MAP_CONF_25_MD_MASK_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_25_MD_MASK_20) & BM_IPU_DC_MAP_CONF_25_MD_MASK_20)

/*! @brief Set the MD_MASK_20 field to a new value. */
#define BW_IPU_DC_MAP_CONF_25_MD_MASK_20(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, (HW_IPU_DC_MAP_CONF_25_RD(x) & ~BM_IPU_DC_MAP_CONF_25_MD_MASK_20) | BF_IPU_DC_MAP_CONF_25_MD_MASK_20(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_25, field MD_OFFSET_20[12:8] (RW)
 *
 * Mapping unit's offset parameter #20 This field defines the offset parameter
 * #20 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_25_MD_OFFSET_20 (8U) /*!< Bit position for IPU_DC_MAP_CONF_25_MD_OFFSET_20. */
#define BM_IPU_DC_MAP_CONF_25_MD_OFFSET_20 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_25_MD_OFFSET_20. */
#define BS_IPU_DC_MAP_CONF_25_MD_OFFSET_20 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_25_MD_OFFSET_20. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_25_MD_OFFSET_20 field. */
#define BR_IPU_DC_MAP_CONF_25_MD_OFFSET_20(x) (HW_IPU_DC_MAP_CONF_25(x).B.MD_OFFSET_20)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_25_MD_OFFSET_20. */
#define BF_IPU_DC_MAP_CONF_25_MD_OFFSET_20(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_25_MD_OFFSET_20) & BM_IPU_DC_MAP_CONF_25_MD_OFFSET_20)

/*! @brief Set the MD_OFFSET_20 field to a new value. */
#define BW_IPU_DC_MAP_CONF_25_MD_OFFSET_20(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, (HW_IPU_DC_MAP_CONF_25_RD(x) & ~BM_IPU_DC_MAP_CONF_25_MD_OFFSET_20) | BF_IPU_DC_MAP_CONF_25_MD_OFFSET_20(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_25, field MD_MASK_21[23:16] (RW)
 *
 * Mapping unit's mask value #21 This field defines the mask value #21 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_25_MD_MASK_21 (16U) /*!< Bit position for IPU_DC_MAP_CONF_25_MD_MASK_21. */
#define BM_IPU_DC_MAP_CONF_25_MD_MASK_21 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_25_MD_MASK_21. */
#define BS_IPU_DC_MAP_CONF_25_MD_MASK_21 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_25_MD_MASK_21. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_25_MD_MASK_21 field. */
#define BR_IPU_DC_MAP_CONF_25_MD_MASK_21(x) (HW_IPU_DC_MAP_CONF_25(x).B.MD_MASK_21)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_25_MD_MASK_21. */
#define BF_IPU_DC_MAP_CONF_25_MD_MASK_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_25_MD_MASK_21) & BM_IPU_DC_MAP_CONF_25_MD_MASK_21)

/*! @brief Set the MD_MASK_21 field to a new value. */
#define BW_IPU_DC_MAP_CONF_25_MD_MASK_21(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, (HW_IPU_DC_MAP_CONF_25_RD(x) & ~BM_IPU_DC_MAP_CONF_25_MD_MASK_21) | BF_IPU_DC_MAP_CONF_25_MD_MASK_21(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_25, field MD_OFFSET_21[28:24] (RW)
 *
 * Mapping unit's offset parameter #21 This field defines the offset parameter
 * #21 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_25_MD_OFFSET_21 (24U) /*!< Bit position for IPU_DC_MAP_CONF_25_MD_OFFSET_21. */
#define BM_IPU_DC_MAP_CONF_25_MD_OFFSET_21 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_25_MD_OFFSET_21. */
#define BS_IPU_DC_MAP_CONF_25_MD_OFFSET_21 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_25_MD_OFFSET_21. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_25_MD_OFFSET_21 field. */
#define BR_IPU_DC_MAP_CONF_25_MD_OFFSET_21(x) (HW_IPU_DC_MAP_CONF_25(x).B.MD_OFFSET_21)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_25_MD_OFFSET_21. */
#define BF_IPU_DC_MAP_CONF_25_MD_OFFSET_21(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_25_MD_OFFSET_21) & BM_IPU_DC_MAP_CONF_25_MD_OFFSET_21)

/*! @brief Set the MD_OFFSET_21 field to a new value. */
#define BW_IPU_DC_MAP_CONF_25_MD_OFFSET_21(x, v) (HW_IPU_DC_MAP_CONF_25_WR(x, (HW_IPU_DC_MAP_CONF_25_RD(x) & ~BM_IPU_DC_MAP_CONF_25_MD_OFFSET_21) | BF_IPU_DC_MAP_CONF_25_MD_OFFSET_21(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_MAP_CONF_26 - DC Mapping Configuration Register 26
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_MAP_CONF_26 - DC Mapping Configuration Register 26 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_map_conf_26
{
    uint32_t U;
    struct _hw_ipu_dc_map_conf_26_bitfields
    {
        uint32_t MD_MASK_22 : 8;       /*!< [7:0]  */
        uint32_t MD_OFFSET_22 : 5;     /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t MD_MASK_23 : 8;       /*!< [23:16]  */
        uint32_t MD_OFFSET_23 : 5;     /*!< [28:24]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_map_conf_26_t;

/*!
 * @name Constants and macros for entire IPU_DC_MAP_CONF_26 register
 */
/*@{*/
#define HW_IPU_DC_MAP_CONF_26_ADDR(x) ((uintptr_t)(x) + 0x58170U)

#define HW_IPU_DC_MAP_CONF_26(x) (*(__IO hw_ipu_dc_map_conf_26_t *) HW_IPU_DC_MAP_CONF_26_ADDR(x))
#define HW_IPU_DC_MAP_CONF_26_RD(x) (HW_IPU_DC_MAP_CONF_26(x).U)
#define HW_IPU_DC_MAP_CONF_26_WR(x, v) (HW_IPU_DC_MAP_CONF_26(x).U = (v))
#define HW_IPU_DC_MAP_CONF_26_SET(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, HW_IPU_DC_MAP_CONF_26_RD(x) |  (v)))
#define HW_IPU_DC_MAP_CONF_26_CLR(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, HW_IPU_DC_MAP_CONF_26_RD(x) & ~(v)))
#define HW_IPU_DC_MAP_CONF_26_TOG(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, HW_IPU_DC_MAP_CONF_26_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_MAP_CONF_26 bitfields
 */

/*!
 * @name Register IPU_DC_MAP_CONF_26, field MD_MASK_22[7:0] (RW)
 *
 * Mapping unit's mask value #22 This field defines the mask value #22 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_26_MD_MASK_22 (0U) /*!< Bit position for IPU_DC_MAP_CONF_26_MD_MASK_22. */
#define BM_IPU_DC_MAP_CONF_26_MD_MASK_22 (0x000000FFU) /*!< Bit mask for IPU_DC_MAP_CONF_26_MD_MASK_22. */
#define BS_IPU_DC_MAP_CONF_26_MD_MASK_22 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_26_MD_MASK_22. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_26_MD_MASK_22 field. */
#define BR_IPU_DC_MAP_CONF_26_MD_MASK_22(x) (HW_IPU_DC_MAP_CONF_26(x).B.MD_MASK_22)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_26_MD_MASK_22. */
#define BF_IPU_DC_MAP_CONF_26_MD_MASK_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_26_MD_MASK_22) & BM_IPU_DC_MAP_CONF_26_MD_MASK_22)

/*! @brief Set the MD_MASK_22 field to a new value. */
#define BW_IPU_DC_MAP_CONF_26_MD_MASK_22(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, (HW_IPU_DC_MAP_CONF_26_RD(x) & ~BM_IPU_DC_MAP_CONF_26_MD_MASK_22) | BF_IPU_DC_MAP_CONF_26_MD_MASK_22(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_26, field MD_OFFSET_22[12:8] (RW)
 *
 * Mapping unit's offset parameter #22 This field defines the offset parameter
 * #22 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_26_MD_OFFSET_22 (8U) /*!< Bit position for IPU_DC_MAP_CONF_26_MD_OFFSET_22. */
#define BM_IPU_DC_MAP_CONF_26_MD_OFFSET_22 (0x00001F00U) /*!< Bit mask for IPU_DC_MAP_CONF_26_MD_OFFSET_22. */
#define BS_IPU_DC_MAP_CONF_26_MD_OFFSET_22 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_26_MD_OFFSET_22. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_26_MD_OFFSET_22 field. */
#define BR_IPU_DC_MAP_CONF_26_MD_OFFSET_22(x) (HW_IPU_DC_MAP_CONF_26(x).B.MD_OFFSET_22)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_26_MD_OFFSET_22. */
#define BF_IPU_DC_MAP_CONF_26_MD_OFFSET_22(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_26_MD_OFFSET_22) & BM_IPU_DC_MAP_CONF_26_MD_OFFSET_22)

/*! @brief Set the MD_OFFSET_22 field to a new value. */
#define BW_IPU_DC_MAP_CONF_26_MD_OFFSET_22(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, (HW_IPU_DC_MAP_CONF_26_RD(x) & ~BM_IPU_DC_MAP_CONF_26_MD_OFFSET_22) | BF_IPU_DC_MAP_CONF_26_MD_OFFSET_22(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_26, field MD_MASK_23[23:16] (RW)
 *
 * Mapping unit's mask value #23 This field defines the mask value #23 within
 * the 8bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_26_MD_MASK_23 (16U) /*!< Bit position for IPU_DC_MAP_CONF_26_MD_MASK_23. */
#define BM_IPU_DC_MAP_CONF_26_MD_MASK_23 (0x00FF0000U) /*!< Bit mask for IPU_DC_MAP_CONF_26_MD_MASK_23. */
#define BS_IPU_DC_MAP_CONF_26_MD_MASK_23 (8U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_26_MD_MASK_23. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_26_MD_MASK_23 field. */
#define BR_IPU_DC_MAP_CONF_26_MD_MASK_23(x) (HW_IPU_DC_MAP_CONF_26(x).B.MD_MASK_23)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_26_MD_MASK_23. */
#define BF_IPU_DC_MAP_CONF_26_MD_MASK_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_26_MD_MASK_23) & BM_IPU_DC_MAP_CONF_26_MD_MASK_23)

/*! @brief Set the MD_MASK_23 field to a new value. */
#define BW_IPU_DC_MAP_CONF_26_MD_MASK_23(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, (HW_IPU_DC_MAP_CONF_26_RD(x) & ~BM_IPU_DC_MAP_CONF_26_MD_MASK_23) | BF_IPU_DC_MAP_CONF_26_MD_MASK_23(v)))
/*@}*/

/*!
 * @name Register IPU_DC_MAP_CONF_26, field MD_OFFSET_23[28:24] (RW)
 *
 * Mapping unit's offset parameter #23 This field defines the offset parameter
 * #23 within the 24bit word coming from the DC.
 */
/*@{*/
#define BP_IPU_DC_MAP_CONF_26_MD_OFFSET_23 (24U) /*!< Bit position for IPU_DC_MAP_CONF_26_MD_OFFSET_23. */
#define BM_IPU_DC_MAP_CONF_26_MD_OFFSET_23 (0x1F000000U) /*!< Bit mask for IPU_DC_MAP_CONF_26_MD_OFFSET_23. */
#define BS_IPU_DC_MAP_CONF_26_MD_OFFSET_23 (5U) /*!< Bit field size in bits for IPU_DC_MAP_CONF_26_MD_OFFSET_23. */

/*! @brief Read current value of the IPU_DC_MAP_CONF_26_MD_OFFSET_23 field. */
#define BR_IPU_DC_MAP_CONF_26_MD_OFFSET_23(x) (HW_IPU_DC_MAP_CONF_26(x).B.MD_OFFSET_23)

/*! @brief Format value for bitfield IPU_DC_MAP_CONF_26_MD_OFFSET_23. */
#define BF_IPU_DC_MAP_CONF_26_MD_OFFSET_23(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_MAP_CONF_26_MD_OFFSET_23) & BM_IPU_DC_MAP_CONF_26_MD_OFFSET_23)

/*! @brief Set the MD_OFFSET_23 field to a new value. */
#define BW_IPU_DC_MAP_CONF_26_MD_OFFSET_23(x, v) (HW_IPU_DC_MAP_CONF_26_WR(x, (HW_IPU_DC_MAP_CONF_26_RD(x) & ~BM_IPU_DC_MAP_CONF_26_MD_OFFSET_23) | BF_IPU_DC_MAP_CONF_26_MD_OFFSET_23(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE0_0 - DC User General Data Event 0 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE0_0 - DC User General Data Event 0 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde0_0
{
    uint32_t U;
    struct _hw_ipu_dc_ugde0_0_bitfields
    {
        uint32_t ID_CODED_0 : 3;       /*!< [2:0]  */
        uint32_t COD_EV_PRIORITY_0 : 4; /*!< [6:3]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t COD_EV_START_0 : 8;   /*!< [15:8]  */
        uint32_t COD_ODD_START_0 : 8;  /*!< [23:16]  */
        uint32_t RESERVED1 : 1;        /*!< [24]  */
        uint32_t ODD_EN_0 : 1;         /*!< [25]  */
        uint32_t AUTORESTART_0 : 1;    /*!< [26]  */
        uint32_t NF_NL_0 : 2;          /*!< [28:27]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde0_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE0_0 register
 */
/*@{*/
#define HW_IPU_DC_UGDE0_0_ADDR(x) ((uintptr_t)(x) + 0x58174U)

#define HW_IPU_DC_UGDE0_0(x)     (*(__IO hw_ipu_dc_ugde0_0_t *) HW_IPU_DC_UGDE0_0_ADDR(x))
#define HW_IPU_DC_UGDE0_0_RD(x)  (HW_IPU_DC_UGDE0_0(x).U)
#define HW_IPU_DC_UGDE0_0_WR(x, v) (HW_IPU_DC_UGDE0_0(x).U = (v))
#define HW_IPU_DC_UGDE0_0_SET(x, v) (HW_IPU_DC_UGDE0_0_WR(x, HW_IPU_DC_UGDE0_0_RD(x) |  (v)))
#define HW_IPU_DC_UGDE0_0_CLR(x, v) (HW_IPU_DC_UGDE0_0_WR(x, HW_IPU_DC_UGDE0_0_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE0_0_TOG(x, v) (HW_IPU_DC_UGDE0_0_WR(x, HW_IPU_DC_UGDE0_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE0_0 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE0_0, field ID_CODED_0[2:0] (RW)
 *
 * This field defines the number of DC channel number that user's general event
 * #0 will be associated to.
 *
 * Values:
 * - 000 - DC channel_0
 * - 001 - DC channel_1
 * - 010 - DC channel_2
 * - 011 - DC channel_5 (DP_SYNC)
 * - 100 - DC channel_6 (DP ASYNC)
 * - 101 - Reserved
 * - 110 - Reserved.
 * - 111 - Reserved.
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_ID_CODED_0 (0U)  /*!< Bit position for IPU_DC_UGDE0_0_ID_CODED_0. */
#define BM_IPU_DC_UGDE0_0_ID_CODED_0 (0x00000007U) /*!< Bit mask for IPU_DC_UGDE0_0_ID_CODED_0. */
#define BS_IPU_DC_UGDE0_0_ID_CODED_0 (3U)  /*!< Bit field size in bits for IPU_DC_UGDE0_0_ID_CODED_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_ID_CODED_0 field. */
#define BR_IPU_DC_UGDE0_0_ID_CODED_0(x) (HW_IPU_DC_UGDE0_0(x).B.ID_CODED_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_ID_CODED_0. */
#define BF_IPU_DC_UGDE0_0_ID_CODED_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_ID_CODED_0) & BM_IPU_DC_UGDE0_0_ID_CODED_0)

/*! @brief Set the ID_CODED_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_ID_CODED_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_ID_CODED_0) | BF_IPU_DC_UGDE0_0_ID_CODED_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field COD_EV_PRIORITY_0[6:3] (RW)
 *
 * This field defines the priority of the user general event #0 The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0 (3U) /*!< Bit position for IPU_DC_UGDE0_0_COD_EV_PRIORITY_0. */
#define BM_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0 (0x00000078U) /*!< Bit mask for IPU_DC_UGDE0_0_COD_EV_PRIORITY_0. */
#define BS_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0 (4U) /*!< Bit field size in bits for IPU_DC_UGDE0_0_COD_EV_PRIORITY_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_COD_EV_PRIORITY_0 field. */
#define BR_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0(x) (HW_IPU_DC_UGDE0_0(x).B.COD_EV_PRIORITY_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_COD_EV_PRIORITY_0. */
#define BF_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0) & BM_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0)

/*! @brief Set the COD_EV_PRIORITY_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0) | BF_IPU_DC_UGDE0_0_COD_EV_PRIORITY_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field COD_EV_START_0[15:8] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #0. When ODD_MODE is enabled, only the
 * even events will use this pointer When ODD_MODE is disabled, all the events will
 * use this pointer
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_COD_EV_START_0 (8U) /*!< Bit position for IPU_DC_UGDE0_0_COD_EV_START_0. */
#define BM_IPU_DC_UGDE0_0_COD_EV_START_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_UGDE0_0_COD_EV_START_0. */
#define BS_IPU_DC_UGDE0_0_COD_EV_START_0 (8U) /*!< Bit field size in bits for IPU_DC_UGDE0_0_COD_EV_START_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_COD_EV_START_0 field. */
#define BR_IPU_DC_UGDE0_0_COD_EV_START_0(x) (HW_IPU_DC_UGDE0_0(x).B.COD_EV_START_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_COD_EV_START_0. */
#define BF_IPU_DC_UGDE0_0_COD_EV_START_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_COD_EV_START_0) & BM_IPU_DC_UGDE0_0_COD_EV_START_0)

/*! @brief Set the COD_EV_START_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_COD_EV_START_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_COD_EV_START_0) | BF_IPU_DC_UGDE0_0_COD_EV_START_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field COD_ODD_START_0[23:16] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #0. When ODD_MODE is enabled, only the odd
 * events will use this pointer When ODD_MODE is disabled this field is ignored
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_COD_ODD_START_0 (16U) /*!< Bit position for IPU_DC_UGDE0_0_COD_ODD_START_0. */
#define BM_IPU_DC_UGDE0_0_COD_ODD_START_0 (0x00FF0000U) /*!< Bit mask for IPU_DC_UGDE0_0_COD_ODD_START_0. */
#define BS_IPU_DC_UGDE0_0_COD_ODD_START_0 (8U) /*!< Bit field size in bits for IPU_DC_UGDE0_0_COD_ODD_START_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_COD_ODD_START_0 field. */
#define BR_IPU_DC_UGDE0_0_COD_ODD_START_0(x) (HW_IPU_DC_UGDE0_0(x).B.COD_ODD_START_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_COD_ODD_START_0. */
#define BF_IPU_DC_UGDE0_0_COD_ODD_START_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_COD_ODD_START_0) & BM_IPU_DC_UGDE0_0_COD_ODD_START_0)

/*! @brief Set the COD_ODD_START_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_COD_ODD_START_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_COD_ODD_START_0) | BF_IPU_DC_UGDE0_0_COD_ODD_START_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field ODD_EN_0[25] (RW)
 *
 * The user's general event #0 may be split into 2 internal signals. One one
 * mode all the events are sent on one signal, on the second mode odd events are
 * sent over one signal while even events are sent over the other signal (ODD_MODE)
 *
 * Values:
 * - 1 - ODD_MODE is enabled
 * - 0 - ODD_MODE is disabled
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_ODD_EN_0 (25U)   /*!< Bit position for IPU_DC_UGDE0_0_ODD_EN_0. */
#define BM_IPU_DC_UGDE0_0_ODD_EN_0 (0x02000000U) /*!< Bit mask for IPU_DC_UGDE0_0_ODD_EN_0. */
#define BS_IPU_DC_UGDE0_0_ODD_EN_0 (1U)    /*!< Bit field size in bits for IPU_DC_UGDE0_0_ODD_EN_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_ODD_EN_0 field. */
#define BR_IPU_DC_UGDE0_0_ODD_EN_0(x) (HW_IPU_DC_UGDE0_0(x).B.ODD_EN_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_ODD_EN_0. */
#define BF_IPU_DC_UGDE0_0_ODD_EN_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_ODD_EN_0) & BM_IPU_DC_UGDE0_0_ODD_EN_0)

/*! @brief Set the ODD_EN_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_ODD_EN_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_ODD_EN_0) | BF_IPU_DC_UGDE0_0_ODD_EN_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field AUTORESTART_0[26] (RW)
 *
 * User's general event #0 auto restart mode
 *
 * Values:
 * - 0 - disable
 * - 1 - User's general event #0's counter is automatically restarted.
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_AUTORESTART_0 (26U) /*!< Bit position for IPU_DC_UGDE0_0_AUTORESTART_0. */
#define BM_IPU_DC_UGDE0_0_AUTORESTART_0 (0x04000000U) /*!< Bit mask for IPU_DC_UGDE0_0_AUTORESTART_0. */
#define BS_IPU_DC_UGDE0_0_AUTORESTART_0 (1U) /*!< Bit field size in bits for IPU_DC_UGDE0_0_AUTORESTART_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_AUTORESTART_0 field. */
#define BR_IPU_DC_UGDE0_0_AUTORESTART_0(x) (HW_IPU_DC_UGDE0_0(x).B.AUTORESTART_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_AUTORESTART_0. */
#define BF_IPU_DC_UGDE0_0_AUTORESTART_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_AUTORESTART_0) & BM_IPU_DC_UGDE0_0_AUTORESTART_0)

/*! @brief Set the AUTORESTART_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_AUTORESTART_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_AUTORESTART_0) | BF_IPU_DC_UGDE0_0_AUTORESTART_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE0_0, field NF_NL_0[28:27] (RW)
 *
 * the user may attach his general event #0 to New-line New-Frame and New-field
 * events. One of these event triggers the user's general event #0's counter. The
 * actual internal trigger is the pixel following the occurrence of the selected
 * event.
 *
 * Values:
 * - 00 - New Line
 * - 01 - New Frame
 * - 10 - New Field
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE0_0_NF_NL_0 (27U)    /*!< Bit position for IPU_DC_UGDE0_0_NF_NL_0. */
#define BM_IPU_DC_UGDE0_0_NF_NL_0 (0x18000000U) /*!< Bit mask for IPU_DC_UGDE0_0_NF_NL_0. */
#define BS_IPU_DC_UGDE0_0_NF_NL_0 (2U)     /*!< Bit field size in bits for IPU_DC_UGDE0_0_NF_NL_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_0_NF_NL_0 field. */
#define BR_IPU_DC_UGDE0_0_NF_NL_0(x) (HW_IPU_DC_UGDE0_0(x).B.NF_NL_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_0_NF_NL_0. */
#define BF_IPU_DC_UGDE0_0_NF_NL_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_0_NF_NL_0) & BM_IPU_DC_UGDE0_0_NF_NL_0)

/*! @brief Set the NF_NL_0 field to a new value. */
#define BW_IPU_DC_UGDE0_0_NF_NL_0(x, v) (HW_IPU_DC_UGDE0_0_WR(x, (HW_IPU_DC_UGDE0_0_RD(x) & ~BM_IPU_DC_UGDE0_0_NF_NL_0) | BF_IPU_DC_UGDE0_0_NF_NL_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE0_1 - DC User General Data Event 0 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE0_1 - DC User General Data Event 0 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde0_1
{
    uint32_t U;
    struct _hw_ipu_dc_ugde0_1_bitfields
    {
        uint32_t STEP_0 : 29;          /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde0_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE0_1 register
 */
/*@{*/
#define HW_IPU_DC_UGDE0_1_ADDR(x) ((uintptr_t)(x) + 0x58178U)

#define HW_IPU_DC_UGDE0_1(x)     (*(__IO hw_ipu_dc_ugde0_1_t *) HW_IPU_DC_UGDE0_1_ADDR(x))
#define HW_IPU_DC_UGDE0_1_RD(x)  (HW_IPU_DC_UGDE0_1(x).U)
#define HW_IPU_DC_UGDE0_1_WR(x, v) (HW_IPU_DC_UGDE0_1(x).U = (v))
#define HW_IPU_DC_UGDE0_1_SET(x, v) (HW_IPU_DC_UGDE0_1_WR(x, HW_IPU_DC_UGDE0_1_RD(x) |  (v)))
#define HW_IPU_DC_UGDE0_1_CLR(x, v) (HW_IPU_DC_UGDE0_1_WR(x, HW_IPU_DC_UGDE0_1_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE0_1_TOG(x, v) (HW_IPU_DC_UGDE0_1_WR(x, HW_IPU_DC_UGDE0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE0_1 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE0_1, field STEP_0[28:0] (RW)
 *
 * This field holds the pre defined value that the counter counts too.
 */
/*@{*/
#define BP_IPU_DC_UGDE0_1_STEP_0 (0U)      /*!< Bit position for IPU_DC_UGDE0_1_STEP_0. */
#define BM_IPU_DC_UGDE0_1_STEP_0 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE0_1_STEP_0. */
#define BS_IPU_DC_UGDE0_1_STEP_0 (29U)     /*!< Bit field size in bits for IPU_DC_UGDE0_1_STEP_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_1_STEP_0 field. */
#define BR_IPU_DC_UGDE0_1_STEP_0(x) (HW_IPU_DC_UGDE0_1(x).B.STEP_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_1_STEP_0. */
#define BF_IPU_DC_UGDE0_1_STEP_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_1_STEP_0) & BM_IPU_DC_UGDE0_1_STEP_0)

/*! @brief Set the STEP_0 field to a new value. */
#define BW_IPU_DC_UGDE0_1_STEP_0(x, v) (HW_IPU_DC_UGDE0_1_WR(x, (HW_IPU_DC_UGDE0_1_RD(x) & ~BM_IPU_DC_UGDE0_1_STEP_0) | BF_IPU_DC_UGDE0_1_STEP_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE0_2 - DC User General Data Event 0 Register2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE0_2 - DC User General Data Event 0 Register2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde0_2
{
    uint32_t U;
    struct _hw_ipu_dc_ugde0_2_bitfields
    {
        uint32_t OFFSET_DT_0 : 29;     /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde0_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE0_2 register
 */
/*@{*/
#define HW_IPU_DC_UGDE0_2_ADDR(x) ((uintptr_t)(x) + 0x5817CU)

#define HW_IPU_DC_UGDE0_2(x)     (*(__IO hw_ipu_dc_ugde0_2_t *) HW_IPU_DC_UGDE0_2_ADDR(x))
#define HW_IPU_DC_UGDE0_2_RD(x)  (HW_IPU_DC_UGDE0_2(x).U)
#define HW_IPU_DC_UGDE0_2_WR(x, v) (HW_IPU_DC_UGDE0_2(x).U = (v))
#define HW_IPU_DC_UGDE0_2_SET(x, v) (HW_IPU_DC_UGDE0_2_WR(x, HW_IPU_DC_UGDE0_2_RD(x) |  (v)))
#define HW_IPU_DC_UGDE0_2_CLR(x, v) (HW_IPU_DC_UGDE0_2_WR(x, HW_IPU_DC_UGDE0_2_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE0_2_TOG(x, v) (HW_IPU_DC_UGDE0_2_WR(x, HW_IPU_DC_UGDE0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE0_2 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE0_2, field OFFSET_DT_0[28:0] (RW)
 *
 * This field defines the offset value from which the counter of user general
 * event #0 will start counting from
 */
/*@{*/
#define BP_IPU_DC_UGDE0_2_OFFSET_DT_0 (0U) /*!< Bit position for IPU_DC_UGDE0_2_OFFSET_DT_0. */
#define BM_IPU_DC_UGDE0_2_OFFSET_DT_0 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE0_2_OFFSET_DT_0. */
#define BS_IPU_DC_UGDE0_2_OFFSET_DT_0 (29U) /*!< Bit field size in bits for IPU_DC_UGDE0_2_OFFSET_DT_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_2_OFFSET_DT_0 field. */
#define BR_IPU_DC_UGDE0_2_OFFSET_DT_0(x) (HW_IPU_DC_UGDE0_2(x).B.OFFSET_DT_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_2_OFFSET_DT_0. */
#define BF_IPU_DC_UGDE0_2_OFFSET_DT_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_2_OFFSET_DT_0) & BM_IPU_DC_UGDE0_2_OFFSET_DT_0)

/*! @brief Set the OFFSET_DT_0 field to a new value. */
#define BW_IPU_DC_UGDE0_2_OFFSET_DT_0(x, v) (HW_IPU_DC_UGDE0_2_WR(x, (HW_IPU_DC_UGDE0_2_RD(x) & ~BM_IPU_DC_UGDE0_2_OFFSET_DT_0) | BF_IPU_DC_UGDE0_2_OFFSET_DT_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE0_3 - DC User General Data Event 0 Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE0_3 - DC User General Data Event 0 Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde0_3
{
    uint32_t U;
    struct _hw_ipu_dc_ugde0_3_bitfields
    {
        uint32_t STEP_REPEAT_0 : 29;   /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde0_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE0_3 register
 */
/*@{*/
#define HW_IPU_DC_UGDE0_3_ADDR(x) ((uintptr_t)(x) + 0x58180U)

#define HW_IPU_DC_UGDE0_3(x)     (*(__IO hw_ipu_dc_ugde0_3_t *) HW_IPU_DC_UGDE0_3_ADDR(x))
#define HW_IPU_DC_UGDE0_3_RD(x)  (HW_IPU_DC_UGDE0_3(x).U)
#define HW_IPU_DC_UGDE0_3_WR(x, v) (HW_IPU_DC_UGDE0_3(x).U = (v))
#define HW_IPU_DC_UGDE0_3_SET(x, v) (HW_IPU_DC_UGDE0_3_WR(x, HW_IPU_DC_UGDE0_3_RD(x) |  (v)))
#define HW_IPU_DC_UGDE0_3_CLR(x, v) (HW_IPU_DC_UGDE0_3_WR(x, HW_IPU_DC_UGDE0_3_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE0_3_TOG(x, v) (HW_IPU_DC_UGDE0_3_WR(x, HW_IPU_DC_UGDE0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE0_3 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE0_3, field STEP_REPEAT_0[28:0] (RW)
 *
 * When auto reload mode is disabled this field defines the number of events
 * that will be generated by the user general event #0 mechanism
 */
/*@{*/
#define BP_IPU_DC_UGDE0_3_STEP_REPEAT_0 (0U) /*!< Bit position for IPU_DC_UGDE0_3_STEP_REPEAT_0. */
#define BM_IPU_DC_UGDE0_3_STEP_REPEAT_0 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE0_3_STEP_REPEAT_0. */
#define BS_IPU_DC_UGDE0_3_STEP_REPEAT_0 (29U) /*!< Bit field size in bits for IPU_DC_UGDE0_3_STEP_REPEAT_0. */

/*! @brief Read current value of the IPU_DC_UGDE0_3_STEP_REPEAT_0 field. */
#define BR_IPU_DC_UGDE0_3_STEP_REPEAT_0(x) (HW_IPU_DC_UGDE0_3(x).B.STEP_REPEAT_0)

/*! @brief Format value for bitfield IPU_DC_UGDE0_3_STEP_REPEAT_0. */
#define BF_IPU_DC_UGDE0_3_STEP_REPEAT_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE0_3_STEP_REPEAT_0) & BM_IPU_DC_UGDE0_3_STEP_REPEAT_0)

/*! @brief Set the STEP_REPEAT_0 field to a new value. */
#define BW_IPU_DC_UGDE0_3_STEP_REPEAT_0(x, v) (HW_IPU_DC_UGDE0_3_WR(x, (HW_IPU_DC_UGDE0_3_RD(x) & ~BM_IPU_DC_UGDE0_3_STEP_REPEAT_0) | BF_IPU_DC_UGDE0_3_STEP_REPEAT_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE1_0 - DC User General Data Event 1Register0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE1_0 - DC User General Data Event 1Register0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde1_0
{
    uint32_t U;
    struct _hw_ipu_dc_ugde1_0_bitfields
    {
        uint32_t ID_CODED_1 : 3;       /*!< [2:0]  */
        uint32_t COD_EV_PRIORITY_1 : 4; /*!< [6:3]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t COD_EV_START_1 : 8;   /*!< [15:8]  */
        uint32_t COD_ODD_START_1 : 8;  /*!< [23:16]  */
        uint32_t RESERVED1 : 1;        /*!< [24]  */
        uint32_t ODD_EN_1 : 1;         /*!< [25]  */
        uint32_t AUTORESTART_1 : 1;    /*!< [26]  */
        uint32_t NF_NL_1 : 2;          /*!< [28:27]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde1_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE1_0 register
 */
/*@{*/
#define HW_IPU_DC_UGDE1_0_ADDR(x) ((uintptr_t)(x) + 0x58184U)

#define HW_IPU_DC_UGDE1_0(x)     (*(__IO hw_ipu_dc_ugde1_0_t *) HW_IPU_DC_UGDE1_0_ADDR(x))
#define HW_IPU_DC_UGDE1_0_RD(x)  (HW_IPU_DC_UGDE1_0(x).U)
#define HW_IPU_DC_UGDE1_0_WR(x, v) (HW_IPU_DC_UGDE1_0(x).U = (v))
#define HW_IPU_DC_UGDE1_0_SET(x, v) (HW_IPU_DC_UGDE1_0_WR(x, HW_IPU_DC_UGDE1_0_RD(x) |  (v)))
#define HW_IPU_DC_UGDE1_0_CLR(x, v) (HW_IPU_DC_UGDE1_0_WR(x, HW_IPU_DC_UGDE1_0_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE1_0_TOG(x, v) (HW_IPU_DC_UGDE1_0_WR(x, HW_IPU_DC_UGDE1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE1_0 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE1_0, field ID_CODED_1[2:0] (RW)
 *
 * This field defines the number of DC channel number that user's general event
 * #1 will be associated to
 *
 * Values:
 * - 000 - DC channel_0
 * - 001 - DC channel_1
 * - 010 - DC channel_2
 * - 011 - DC channel_5 (DP_SYNC)
 * - 100 - DC channel_6 (DP ASYNC)
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_ID_CODED_1 (0U)  /*!< Bit position for IPU_DC_UGDE1_0_ID_CODED_1. */
#define BM_IPU_DC_UGDE1_0_ID_CODED_1 (0x00000007U) /*!< Bit mask for IPU_DC_UGDE1_0_ID_CODED_1. */
#define BS_IPU_DC_UGDE1_0_ID_CODED_1 (3U)  /*!< Bit field size in bits for IPU_DC_UGDE1_0_ID_CODED_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_ID_CODED_1 field. */
#define BR_IPU_DC_UGDE1_0_ID_CODED_1(x) (HW_IPU_DC_UGDE1_0(x).B.ID_CODED_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_ID_CODED_1. */
#define BF_IPU_DC_UGDE1_0_ID_CODED_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_ID_CODED_1) & BM_IPU_DC_UGDE1_0_ID_CODED_1)

/*! @brief Set the ID_CODED_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_ID_CODED_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_ID_CODED_1) | BF_IPU_DC_UGDE1_0_ID_CODED_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field COD_EV_PRIORITY_1[6:3] (RW)
 *
 * This field defines the priority of the user general event #1 The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1 (3U) /*!< Bit position for IPU_DC_UGDE1_0_COD_EV_PRIORITY_1. */
#define BM_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1 (0x00000078U) /*!< Bit mask for IPU_DC_UGDE1_0_COD_EV_PRIORITY_1. */
#define BS_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1 (4U) /*!< Bit field size in bits for IPU_DC_UGDE1_0_COD_EV_PRIORITY_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_COD_EV_PRIORITY_1 field. */
#define BR_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1(x) (HW_IPU_DC_UGDE1_0(x).B.COD_EV_PRIORITY_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_COD_EV_PRIORITY_1. */
#define BF_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1) & BM_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1)

/*! @brief Set the COD_EV_PRIORITY_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1) | BF_IPU_DC_UGDE1_0_COD_EV_PRIORITY_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field COD_EV_START_1[15:8] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #1. When ODD_MODE is enabled, only the
 * even events will use this pointer When ODD_MODE is disabled, all the events will
 * use this pointer
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_COD_EV_START_1 (8U) /*!< Bit position for IPU_DC_UGDE1_0_COD_EV_START_1. */
#define BM_IPU_DC_UGDE1_0_COD_EV_START_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_UGDE1_0_COD_EV_START_1. */
#define BS_IPU_DC_UGDE1_0_COD_EV_START_1 (8U) /*!< Bit field size in bits for IPU_DC_UGDE1_0_COD_EV_START_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_COD_EV_START_1 field. */
#define BR_IPU_DC_UGDE1_0_COD_EV_START_1(x) (HW_IPU_DC_UGDE1_0(x).B.COD_EV_START_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_COD_EV_START_1. */
#define BF_IPU_DC_UGDE1_0_COD_EV_START_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_COD_EV_START_1) & BM_IPU_DC_UGDE1_0_COD_EV_START_1)

/*! @brief Set the COD_EV_START_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_COD_EV_START_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_COD_EV_START_1) | BF_IPU_DC_UGDE1_0_COD_EV_START_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field COD_ODD_START_1[23:16] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #1. When ODD_MODE is enabled, only the odd
 * events will use this pointer When ODD_MODE is disabled this field is ignored
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_COD_ODD_START_1 (16U) /*!< Bit position for IPU_DC_UGDE1_0_COD_ODD_START_1. */
#define BM_IPU_DC_UGDE1_0_COD_ODD_START_1 (0x00FF0000U) /*!< Bit mask for IPU_DC_UGDE1_0_COD_ODD_START_1. */
#define BS_IPU_DC_UGDE1_0_COD_ODD_START_1 (8U) /*!< Bit field size in bits for IPU_DC_UGDE1_0_COD_ODD_START_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_COD_ODD_START_1 field. */
#define BR_IPU_DC_UGDE1_0_COD_ODD_START_1(x) (HW_IPU_DC_UGDE1_0(x).B.COD_ODD_START_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_COD_ODD_START_1. */
#define BF_IPU_DC_UGDE1_0_COD_ODD_START_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_COD_ODD_START_1) & BM_IPU_DC_UGDE1_0_COD_ODD_START_1)

/*! @brief Set the COD_ODD_START_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_COD_ODD_START_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_COD_ODD_START_1) | BF_IPU_DC_UGDE1_0_COD_ODD_START_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field ODD_EN_1[25] (RW)
 *
 * The user's general event #1 may be split into 2 internal signals. One one
 * mode all the events are sent on one signal, on the second mode odd events are
 * sent over one signal while even events are sent over the other signal (ODD_MODE)
 *
 * Values:
 * - 1 - ODD_MODE is enabled
 * - 0 - ODD_MODE is disabled
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_ODD_EN_1 (25U)   /*!< Bit position for IPU_DC_UGDE1_0_ODD_EN_1. */
#define BM_IPU_DC_UGDE1_0_ODD_EN_1 (0x02000000U) /*!< Bit mask for IPU_DC_UGDE1_0_ODD_EN_1. */
#define BS_IPU_DC_UGDE1_0_ODD_EN_1 (1U)    /*!< Bit field size in bits for IPU_DC_UGDE1_0_ODD_EN_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_ODD_EN_1 field. */
#define BR_IPU_DC_UGDE1_0_ODD_EN_1(x) (HW_IPU_DC_UGDE1_0(x).B.ODD_EN_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_ODD_EN_1. */
#define BF_IPU_DC_UGDE1_0_ODD_EN_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_ODD_EN_1) & BM_IPU_DC_UGDE1_0_ODD_EN_1)

/*! @brief Set the ODD_EN_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_ODD_EN_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_ODD_EN_1) | BF_IPU_DC_UGDE1_0_ODD_EN_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field AUTORESTART_1[26] (RW)
 *
 * User's general event #1 auto restart mode
 *
 * Values:
 * - 0 - disable
 * - 1 - User's general event #1's counter is automatically restarted.
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_AUTORESTART_1 (26U) /*!< Bit position for IPU_DC_UGDE1_0_AUTORESTART_1. */
#define BM_IPU_DC_UGDE1_0_AUTORESTART_1 (0x04000000U) /*!< Bit mask for IPU_DC_UGDE1_0_AUTORESTART_1. */
#define BS_IPU_DC_UGDE1_0_AUTORESTART_1 (1U) /*!< Bit field size in bits for IPU_DC_UGDE1_0_AUTORESTART_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_AUTORESTART_1 field. */
#define BR_IPU_DC_UGDE1_0_AUTORESTART_1(x) (HW_IPU_DC_UGDE1_0(x).B.AUTORESTART_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_AUTORESTART_1. */
#define BF_IPU_DC_UGDE1_0_AUTORESTART_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_AUTORESTART_1) & BM_IPU_DC_UGDE1_0_AUTORESTART_1)

/*! @brief Set the AUTORESTART_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_AUTORESTART_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_AUTORESTART_1) | BF_IPU_DC_UGDE1_0_AUTORESTART_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE1_0, field NF_NL_1[28:27] (RW)
 *
 * the user may attach his general event #1 to New-line New-Frame and New-field
 * events. One of these event triggers the user's general event #1's counter. The
 * actual internal trigger is the pixel following the occurrence of the selected
 * event.
 *
 * Values:
 * - 00 - New Line
 * - 01 - New Frame
 * - 10 - New Field
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE1_0_NF_NL_1 (27U)    /*!< Bit position for IPU_DC_UGDE1_0_NF_NL_1. */
#define BM_IPU_DC_UGDE1_0_NF_NL_1 (0x18000000U) /*!< Bit mask for IPU_DC_UGDE1_0_NF_NL_1. */
#define BS_IPU_DC_UGDE1_0_NF_NL_1 (2U)     /*!< Bit field size in bits for IPU_DC_UGDE1_0_NF_NL_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_0_NF_NL_1 field. */
#define BR_IPU_DC_UGDE1_0_NF_NL_1(x) (HW_IPU_DC_UGDE1_0(x).B.NF_NL_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_0_NF_NL_1. */
#define BF_IPU_DC_UGDE1_0_NF_NL_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_0_NF_NL_1) & BM_IPU_DC_UGDE1_0_NF_NL_1)

/*! @brief Set the NF_NL_1 field to a new value. */
#define BW_IPU_DC_UGDE1_0_NF_NL_1(x, v) (HW_IPU_DC_UGDE1_0_WR(x, (HW_IPU_DC_UGDE1_0_RD(x) & ~BM_IPU_DC_UGDE1_0_NF_NL_1) | BF_IPU_DC_UGDE1_0_NF_NL_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE1_1 - DC User General Data Event 1 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE1_1 - DC User General Data Event 1 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde1_1
{
    uint32_t U;
    struct _hw_ipu_dc_ugde1_1_bitfields
    {
        uint32_t STEP_1 : 29;          /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde1_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE1_1 register
 */
/*@{*/
#define HW_IPU_DC_UGDE1_1_ADDR(x) ((uintptr_t)(x) + 0x58188U)

#define HW_IPU_DC_UGDE1_1(x)     (*(__IO hw_ipu_dc_ugde1_1_t *) HW_IPU_DC_UGDE1_1_ADDR(x))
#define HW_IPU_DC_UGDE1_1_RD(x)  (HW_IPU_DC_UGDE1_1(x).U)
#define HW_IPU_DC_UGDE1_1_WR(x, v) (HW_IPU_DC_UGDE1_1(x).U = (v))
#define HW_IPU_DC_UGDE1_1_SET(x, v) (HW_IPU_DC_UGDE1_1_WR(x, HW_IPU_DC_UGDE1_1_RD(x) |  (v)))
#define HW_IPU_DC_UGDE1_1_CLR(x, v) (HW_IPU_DC_UGDE1_1_WR(x, HW_IPU_DC_UGDE1_1_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE1_1_TOG(x, v) (HW_IPU_DC_UGDE1_1_WR(x, HW_IPU_DC_UGDE1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE1_1 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE1_1, field STEP_1[28:0] (RW)
 *
 * This field hold the pre defined value that the counter counts too
 */
/*@{*/
#define BP_IPU_DC_UGDE1_1_STEP_1 (0U)      /*!< Bit position for IPU_DC_UGDE1_1_STEP_1. */
#define BM_IPU_DC_UGDE1_1_STEP_1 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE1_1_STEP_1. */
#define BS_IPU_DC_UGDE1_1_STEP_1 (29U)     /*!< Bit field size in bits for IPU_DC_UGDE1_1_STEP_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_1_STEP_1 field. */
#define BR_IPU_DC_UGDE1_1_STEP_1(x) (HW_IPU_DC_UGDE1_1(x).B.STEP_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_1_STEP_1. */
#define BF_IPU_DC_UGDE1_1_STEP_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_1_STEP_1) & BM_IPU_DC_UGDE1_1_STEP_1)

/*! @brief Set the STEP_1 field to a new value. */
#define BW_IPU_DC_UGDE1_1_STEP_1(x, v) (HW_IPU_DC_UGDE1_1_WR(x, (HW_IPU_DC_UGDE1_1_RD(x) & ~BM_IPU_DC_UGDE1_1_STEP_1) | BF_IPU_DC_UGDE1_1_STEP_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE1_2 - DC User General Data Event 1Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE1_2 - DC User General Data Event 1Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde1_2
{
    uint32_t U;
    struct _hw_ipu_dc_ugde1_2_bitfields
    {
        uint32_t OFFSET_DT_1 : 29;     /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde1_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE1_2 register
 */
/*@{*/
#define HW_IPU_DC_UGDE1_2_ADDR(x) ((uintptr_t)(x) + 0x5818CU)

#define HW_IPU_DC_UGDE1_2(x)     (*(__IO hw_ipu_dc_ugde1_2_t *) HW_IPU_DC_UGDE1_2_ADDR(x))
#define HW_IPU_DC_UGDE1_2_RD(x)  (HW_IPU_DC_UGDE1_2(x).U)
#define HW_IPU_DC_UGDE1_2_WR(x, v) (HW_IPU_DC_UGDE1_2(x).U = (v))
#define HW_IPU_DC_UGDE1_2_SET(x, v) (HW_IPU_DC_UGDE1_2_WR(x, HW_IPU_DC_UGDE1_2_RD(x) |  (v)))
#define HW_IPU_DC_UGDE1_2_CLR(x, v) (HW_IPU_DC_UGDE1_2_WR(x, HW_IPU_DC_UGDE1_2_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE1_2_TOG(x, v) (HW_IPU_DC_UGDE1_2_WR(x, HW_IPU_DC_UGDE1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE1_2 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE1_2, field OFFSET_DT_1[28:0] (RW)
 *
 * This field defines the offset value from which the counter of user general
 * event #1 will start counting from
 */
/*@{*/
#define BP_IPU_DC_UGDE1_2_OFFSET_DT_1 (0U) /*!< Bit position for IPU_DC_UGDE1_2_OFFSET_DT_1. */
#define BM_IPU_DC_UGDE1_2_OFFSET_DT_1 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE1_2_OFFSET_DT_1. */
#define BS_IPU_DC_UGDE1_2_OFFSET_DT_1 (29U) /*!< Bit field size in bits for IPU_DC_UGDE1_2_OFFSET_DT_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_2_OFFSET_DT_1 field. */
#define BR_IPU_DC_UGDE1_2_OFFSET_DT_1(x) (HW_IPU_DC_UGDE1_2(x).B.OFFSET_DT_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_2_OFFSET_DT_1. */
#define BF_IPU_DC_UGDE1_2_OFFSET_DT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_2_OFFSET_DT_1) & BM_IPU_DC_UGDE1_2_OFFSET_DT_1)

/*! @brief Set the OFFSET_DT_1 field to a new value. */
#define BW_IPU_DC_UGDE1_2_OFFSET_DT_1(x, v) (HW_IPU_DC_UGDE1_2_WR(x, (HW_IPU_DC_UGDE1_2_RD(x) & ~BM_IPU_DC_UGDE1_2_OFFSET_DT_1) | BF_IPU_DC_UGDE1_2_OFFSET_DT_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE1_3 - DC User General Data Event 1Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE1_3 - DC User General Data Event 1Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde1_3
{
    uint32_t U;
    struct _hw_ipu_dc_ugde1_3_bitfields
    {
        uint32_t STEP_REPEAT_1 : 29;   /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde1_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE1_3 register
 */
/*@{*/
#define HW_IPU_DC_UGDE1_3_ADDR(x) ((uintptr_t)(x) + 0x58190U)

#define HW_IPU_DC_UGDE1_3(x)     (*(__IO hw_ipu_dc_ugde1_3_t *) HW_IPU_DC_UGDE1_3_ADDR(x))
#define HW_IPU_DC_UGDE1_3_RD(x)  (HW_IPU_DC_UGDE1_3(x).U)
#define HW_IPU_DC_UGDE1_3_WR(x, v) (HW_IPU_DC_UGDE1_3(x).U = (v))
#define HW_IPU_DC_UGDE1_3_SET(x, v) (HW_IPU_DC_UGDE1_3_WR(x, HW_IPU_DC_UGDE1_3_RD(x) |  (v)))
#define HW_IPU_DC_UGDE1_3_CLR(x, v) (HW_IPU_DC_UGDE1_3_WR(x, HW_IPU_DC_UGDE1_3_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE1_3_TOG(x, v) (HW_IPU_DC_UGDE1_3_WR(x, HW_IPU_DC_UGDE1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE1_3 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE1_3, field STEP_REPEAT_1[28:0] (RW)
 *
 * When auto reload mode is disabled this field defines the number of events
 * that will be generated by the user general event #1 mechanism
 */
/*@{*/
#define BP_IPU_DC_UGDE1_3_STEP_REPEAT_1 (0U) /*!< Bit position for IPU_DC_UGDE1_3_STEP_REPEAT_1. */
#define BM_IPU_DC_UGDE1_3_STEP_REPEAT_1 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE1_3_STEP_REPEAT_1. */
#define BS_IPU_DC_UGDE1_3_STEP_REPEAT_1 (29U) /*!< Bit field size in bits for IPU_DC_UGDE1_3_STEP_REPEAT_1. */

/*! @brief Read current value of the IPU_DC_UGDE1_3_STEP_REPEAT_1 field. */
#define BR_IPU_DC_UGDE1_3_STEP_REPEAT_1(x) (HW_IPU_DC_UGDE1_3(x).B.STEP_REPEAT_1)

/*! @brief Format value for bitfield IPU_DC_UGDE1_3_STEP_REPEAT_1. */
#define BF_IPU_DC_UGDE1_3_STEP_REPEAT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE1_3_STEP_REPEAT_1) & BM_IPU_DC_UGDE1_3_STEP_REPEAT_1)

/*! @brief Set the STEP_REPEAT_1 field to a new value. */
#define BW_IPU_DC_UGDE1_3_STEP_REPEAT_1(x, v) (HW_IPU_DC_UGDE1_3_WR(x, (HW_IPU_DC_UGDE1_3_RD(x) & ~BM_IPU_DC_UGDE1_3_STEP_REPEAT_1) | BF_IPU_DC_UGDE1_3_STEP_REPEAT_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE2_0 - DC User General Data Event 2 Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE2_0 - DC User General Data Event 2 Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde2_0
{
    uint32_t U;
    struct _hw_ipu_dc_ugde2_0_bitfields
    {
        uint32_t ID_CODED_2 : 3;       /*!< [2:0]  */
        uint32_t COD_EV_PRIORITY_2 : 4; /*!< [6:3]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t COD_EV_START_2 : 8;   /*!< [15:8]  */
        uint32_t COD_ODD_START_2 : 8;  /*!< [23:16]  */
        uint32_t RESERVED1 : 1;        /*!< [24]  */
        uint32_t ODD_EN_2 : 1;         /*!< [25]  */
        uint32_t AUTORESTART_2 : 1;    /*!< [26]  */
        uint32_t NF_NL_2 : 2;          /*!< [28:27]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde2_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE2_0 register
 */
/*@{*/
#define HW_IPU_DC_UGDE2_0_ADDR(x) ((uintptr_t)(x) + 0x58194U)

#define HW_IPU_DC_UGDE2_0(x)     (*(__IO hw_ipu_dc_ugde2_0_t *) HW_IPU_DC_UGDE2_0_ADDR(x))
#define HW_IPU_DC_UGDE2_0_RD(x)  (HW_IPU_DC_UGDE2_0(x).U)
#define HW_IPU_DC_UGDE2_0_WR(x, v) (HW_IPU_DC_UGDE2_0(x).U = (v))
#define HW_IPU_DC_UGDE2_0_SET(x, v) (HW_IPU_DC_UGDE2_0_WR(x, HW_IPU_DC_UGDE2_0_RD(x) |  (v)))
#define HW_IPU_DC_UGDE2_0_CLR(x, v) (HW_IPU_DC_UGDE2_0_WR(x, HW_IPU_DC_UGDE2_0_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE2_0_TOG(x, v) (HW_IPU_DC_UGDE2_0_WR(x, HW_IPU_DC_UGDE2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE2_0 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE2_0, field ID_CODED_2[2:0] (RW)
 *
 * This field defines the number of DC channel number that user's general event
 * #2 will be associated to
 *
 * Values:
 * - 000 - DC channel_0
 * - 001 - DC channel_1
 * - 010 - DC channel_2
 * - 011 - DC channel_5 (DP_SYNC)
 * - 100 - DC channel_6 (DP ASYNC)
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_ID_CODED_2 (0U)  /*!< Bit position for IPU_DC_UGDE2_0_ID_CODED_2. */
#define BM_IPU_DC_UGDE2_0_ID_CODED_2 (0x00000007U) /*!< Bit mask for IPU_DC_UGDE2_0_ID_CODED_2. */
#define BS_IPU_DC_UGDE2_0_ID_CODED_2 (3U)  /*!< Bit field size in bits for IPU_DC_UGDE2_0_ID_CODED_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_ID_CODED_2 field. */
#define BR_IPU_DC_UGDE2_0_ID_CODED_2(x) (HW_IPU_DC_UGDE2_0(x).B.ID_CODED_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_ID_CODED_2. */
#define BF_IPU_DC_UGDE2_0_ID_CODED_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_ID_CODED_2) & BM_IPU_DC_UGDE2_0_ID_CODED_2)

/*! @brief Set the ID_CODED_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_ID_CODED_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_ID_CODED_2) | BF_IPU_DC_UGDE2_0_ID_CODED_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field COD_EV_PRIORITY_2[6:3] (RW)
 *
 * This field defines the priority of the user general event #2 The priority
 * between the events should be set to a unique value. i.e. two events must not have
 * the same priority (except 0000 - disable)
 *
 * Values:
 * - 0000 - disable
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2 (3U) /*!< Bit position for IPU_DC_UGDE2_0_COD_EV_PRIORITY_2. */
#define BM_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2 (0x00000078U) /*!< Bit mask for IPU_DC_UGDE2_0_COD_EV_PRIORITY_2. */
#define BS_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2 (4U) /*!< Bit field size in bits for IPU_DC_UGDE2_0_COD_EV_PRIORITY_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_COD_EV_PRIORITY_2 field. */
#define BR_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2(x) (HW_IPU_DC_UGDE2_0(x).B.COD_EV_PRIORITY_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_COD_EV_PRIORITY_2. */
#define BF_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2) & BM_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2)

/*! @brief Set the COD_EV_PRIORITY_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2) | BF_IPU_DC_UGDE2_0_COD_EV_PRIORITY_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field COD_EV_START_2[15:8] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #2. When ODD_MODE is enabled, only the
 * even events will use this pointer When ODD_MODE is disabled, all the events will
 * use this pointer
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_COD_EV_START_2 (8U) /*!< Bit position for IPU_DC_UGDE2_0_COD_EV_START_2. */
#define BM_IPU_DC_UGDE2_0_COD_EV_START_2 (0x0000FF00U) /*!< Bit mask for IPU_DC_UGDE2_0_COD_EV_START_2. */
#define BS_IPU_DC_UGDE2_0_COD_EV_START_2 (8U) /*!< Bit field size in bits for IPU_DC_UGDE2_0_COD_EV_START_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_COD_EV_START_2 field. */
#define BR_IPU_DC_UGDE2_0_COD_EV_START_2(x) (HW_IPU_DC_UGDE2_0(x).B.COD_EV_START_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_COD_EV_START_2. */
#define BF_IPU_DC_UGDE2_0_COD_EV_START_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_COD_EV_START_2) & BM_IPU_DC_UGDE2_0_COD_EV_START_2)

/*! @brief Set the COD_EV_START_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_COD_EV_START_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_COD_EV_START_2) | BF_IPU_DC_UGDE2_0_COD_EV_START_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field COD_ODD_START_2[23:16] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #2 When ODD_MODE is enabled, only the odd
 * events will use this pointer When ODD_MODE is disabled this field is ignored
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_COD_ODD_START_2 (16U) /*!< Bit position for IPU_DC_UGDE2_0_COD_ODD_START_2. */
#define BM_IPU_DC_UGDE2_0_COD_ODD_START_2 (0x00FF0000U) /*!< Bit mask for IPU_DC_UGDE2_0_COD_ODD_START_2. */
#define BS_IPU_DC_UGDE2_0_COD_ODD_START_2 (8U) /*!< Bit field size in bits for IPU_DC_UGDE2_0_COD_ODD_START_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_COD_ODD_START_2 field. */
#define BR_IPU_DC_UGDE2_0_COD_ODD_START_2(x) (HW_IPU_DC_UGDE2_0(x).B.COD_ODD_START_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_COD_ODD_START_2. */
#define BF_IPU_DC_UGDE2_0_COD_ODD_START_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_COD_ODD_START_2) & BM_IPU_DC_UGDE2_0_COD_ODD_START_2)

/*! @brief Set the COD_ODD_START_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_COD_ODD_START_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_COD_ODD_START_2) | BF_IPU_DC_UGDE2_0_COD_ODD_START_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field ODD_EN_2[25] (RW)
 *
 * The user's general event #2 may be split into 2 internal signals. One one
 * mode all the events are sent on one signal, on the second mode odd events are
 * sent over one signal while even events are sent over the other signal (ODD_MODE)
 *
 * Values:
 * - 1 - ODD_MODE is enabled
 * - 0 - ODD_MODE is disabled
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_ODD_EN_2 (25U)   /*!< Bit position for IPU_DC_UGDE2_0_ODD_EN_2. */
#define BM_IPU_DC_UGDE2_0_ODD_EN_2 (0x02000000U) /*!< Bit mask for IPU_DC_UGDE2_0_ODD_EN_2. */
#define BS_IPU_DC_UGDE2_0_ODD_EN_2 (1U)    /*!< Bit field size in bits for IPU_DC_UGDE2_0_ODD_EN_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_ODD_EN_2 field. */
#define BR_IPU_DC_UGDE2_0_ODD_EN_2(x) (HW_IPU_DC_UGDE2_0(x).B.ODD_EN_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_ODD_EN_2. */
#define BF_IPU_DC_UGDE2_0_ODD_EN_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_ODD_EN_2) & BM_IPU_DC_UGDE2_0_ODD_EN_2)

/*! @brief Set the ODD_EN_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_ODD_EN_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_ODD_EN_2) | BF_IPU_DC_UGDE2_0_ODD_EN_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field AUTORESTART_2[26] (RW)
 *
 * User's general event #2 auto restart mode
 *
 * Values:
 * - 0 - disable
 * - 1 - User's general event #2's counter is automatically restarted.
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_AUTORESTART_2 (26U) /*!< Bit position for IPU_DC_UGDE2_0_AUTORESTART_2. */
#define BM_IPU_DC_UGDE2_0_AUTORESTART_2 (0x04000000U) /*!< Bit mask for IPU_DC_UGDE2_0_AUTORESTART_2. */
#define BS_IPU_DC_UGDE2_0_AUTORESTART_2 (1U) /*!< Bit field size in bits for IPU_DC_UGDE2_0_AUTORESTART_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_AUTORESTART_2 field. */
#define BR_IPU_DC_UGDE2_0_AUTORESTART_2(x) (HW_IPU_DC_UGDE2_0(x).B.AUTORESTART_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_AUTORESTART_2. */
#define BF_IPU_DC_UGDE2_0_AUTORESTART_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_AUTORESTART_2) & BM_IPU_DC_UGDE2_0_AUTORESTART_2)

/*! @brief Set the AUTORESTART_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_AUTORESTART_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_AUTORESTART_2) | BF_IPU_DC_UGDE2_0_AUTORESTART_2(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE2_0, field NF_NL_2[28:27] (RW)
 *
 * the user may attach his general event #2 to New-line New-Frame and New-field
 * events. One of these event triggers the user's general event #2's counter. The
 * actual internal trigger is the pixel following the occurrence of the selected
 * event.
 *
 * Values:
 * - 00 - New Line
 * - 01 - New Frame
 * - 10 - New Field
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE2_0_NF_NL_2 (27U)    /*!< Bit position for IPU_DC_UGDE2_0_NF_NL_2. */
#define BM_IPU_DC_UGDE2_0_NF_NL_2 (0x18000000U) /*!< Bit mask for IPU_DC_UGDE2_0_NF_NL_2. */
#define BS_IPU_DC_UGDE2_0_NF_NL_2 (2U)     /*!< Bit field size in bits for IPU_DC_UGDE2_0_NF_NL_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_0_NF_NL_2 field. */
#define BR_IPU_DC_UGDE2_0_NF_NL_2(x) (HW_IPU_DC_UGDE2_0(x).B.NF_NL_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_0_NF_NL_2. */
#define BF_IPU_DC_UGDE2_0_NF_NL_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_0_NF_NL_2) & BM_IPU_DC_UGDE2_0_NF_NL_2)

/*! @brief Set the NF_NL_2 field to a new value. */
#define BW_IPU_DC_UGDE2_0_NF_NL_2(x, v) (HW_IPU_DC_UGDE2_0_WR(x, (HW_IPU_DC_UGDE2_0_RD(x) & ~BM_IPU_DC_UGDE2_0_NF_NL_2) | BF_IPU_DC_UGDE2_0_NF_NL_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE2_1 - DC User General Data Event 2 Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE2_1 - DC User General Data Event 2 Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde2_1
{
    uint32_t U;
    struct _hw_ipu_dc_ugde2_1_bitfields
    {
        uint32_t STEP_2 : 29;          /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde2_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE2_1 register
 */
/*@{*/
#define HW_IPU_DC_UGDE2_1_ADDR(x) ((uintptr_t)(x) + 0x58198U)

#define HW_IPU_DC_UGDE2_1(x)     (*(__IO hw_ipu_dc_ugde2_1_t *) HW_IPU_DC_UGDE2_1_ADDR(x))
#define HW_IPU_DC_UGDE2_1_RD(x)  (HW_IPU_DC_UGDE2_1(x).U)
#define HW_IPU_DC_UGDE2_1_WR(x, v) (HW_IPU_DC_UGDE2_1(x).U = (v))
#define HW_IPU_DC_UGDE2_1_SET(x, v) (HW_IPU_DC_UGDE2_1_WR(x, HW_IPU_DC_UGDE2_1_RD(x) |  (v)))
#define HW_IPU_DC_UGDE2_1_CLR(x, v) (HW_IPU_DC_UGDE2_1_WR(x, HW_IPU_DC_UGDE2_1_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE2_1_TOG(x, v) (HW_IPU_DC_UGDE2_1_WR(x, HW_IPU_DC_UGDE2_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE2_1 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE2_1, field STEP_2[28:0] (RW)
 *
 * This field hold the pre defined value that the counter counts too
 */
/*@{*/
#define BP_IPU_DC_UGDE2_1_STEP_2 (0U)      /*!< Bit position for IPU_DC_UGDE2_1_STEP_2. */
#define BM_IPU_DC_UGDE2_1_STEP_2 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE2_1_STEP_2. */
#define BS_IPU_DC_UGDE2_1_STEP_2 (29U)     /*!< Bit field size in bits for IPU_DC_UGDE2_1_STEP_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_1_STEP_2 field. */
#define BR_IPU_DC_UGDE2_1_STEP_2(x) (HW_IPU_DC_UGDE2_1(x).B.STEP_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_1_STEP_2. */
#define BF_IPU_DC_UGDE2_1_STEP_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_1_STEP_2) & BM_IPU_DC_UGDE2_1_STEP_2)

/*! @brief Set the STEP_2 field to a new value. */
#define BW_IPU_DC_UGDE2_1_STEP_2(x, v) (HW_IPU_DC_UGDE2_1_WR(x, (HW_IPU_DC_UGDE2_1_RD(x) & ~BM_IPU_DC_UGDE2_1_STEP_2) | BF_IPU_DC_UGDE2_1_STEP_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE2_2 - DC User General Data Event 2Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE2_2 - DC User General Data Event 2Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde2_2
{
    uint32_t U;
    struct _hw_ipu_dc_ugde2_2_bitfields
    {
        uint32_t OFFSET_DT_2 : 29;     /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde2_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE2_2 register
 */
/*@{*/
#define HW_IPU_DC_UGDE2_2_ADDR(x) ((uintptr_t)(x) + 0x5819CU)

#define HW_IPU_DC_UGDE2_2(x)     (*(__IO hw_ipu_dc_ugde2_2_t *) HW_IPU_DC_UGDE2_2_ADDR(x))
#define HW_IPU_DC_UGDE2_2_RD(x)  (HW_IPU_DC_UGDE2_2(x).U)
#define HW_IPU_DC_UGDE2_2_WR(x, v) (HW_IPU_DC_UGDE2_2(x).U = (v))
#define HW_IPU_DC_UGDE2_2_SET(x, v) (HW_IPU_DC_UGDE2_2_WR(x, HW_IPU_DC_UGDE2_2_RD(x) |  (v)))
#define HW_IPU_DC_UGDE2_2_CLR(x, v) (HW_IPU_DC_UGDE2_2_WR(x, HW_IPU_DC_UGDE2_2_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE2_2_TOG(x, v) (HW_IPU_DC_UGDE2_2_WR(x, HW_IPU_DC_UGDE2_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE2_2 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE2_2, field OFFSET_DT_2[28:0] (RW)
 *
 * This field defines the offset value from which the counter of user general
 * event #2 will start counting from
 */
/*@{*/
#define BP_IPU_DC_UGDE2_2_OFFSET_DT_2 (0U) /*!< Bit position for IPU_DC_UGDE2_2_OFFSET_DT_2. */
#define BM_IPU_DC_UGDE2_2_OFFSET_DT_2 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE2_2_OFFSET_DT_2. */
#define BS_IPU_DC_UGDE2_2_OFFSET_DT_2 (29U) /*!< Bit field size in bits for IPU_DC_UGDE2_2_OFFSET_DT_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_2_OFFSET_DT_2 field. */
#define BR_IPU_DC_UGDE2_2_OFFSET_DT_2(x) (HW_IPU_DC_UGDE2_2(x).B.OFFSET_DT_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_2_OFFSET_DT_2. */
#define BF_IPU_DC_UGDE2_2_OFFSET_DT_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_2_OFFSET_DT_2) & BM_IPU_DC_UGDE2_2_OFFSET_DT_2)

/*! @brief Set the OFFSET_DT_2 field to a new value. */
#define BW_IPU_DC_UGDE2_2_OFFSET_DT_2(x, v) (HW_IPU_DC_UGDE2_2_WR(x, (HW_IPU_DC_UGDE2_2_RD(x) & ~BM_IPU_DC_UGDE2_2_OFFSET_DT_2) | BF_IPU_DC_UGDE2_2_OFFSET_DT_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE2_3 - DC User General Data Event 2Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE2_3 - DC User General Data Event 2Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde2_3
{
    uint32_t U;
    struct _hw_ipu_dc_ugde2_3_bitfields
    {
        uint32_t STEP_REPEAT_2 : 29;   /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde2_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE2_3 register
 */
/*@{*/
#define HW_IPU_DC_UGDE2_3_ADDR(x) ((uintptr_t)(x) + 0x581A0U)

#define HW_IPU_DC_UGDE2_3(x)     (*(__IO hw_ipu_dc_ugde2_3_t *) HW_IPU_DC_UGDE2_3_ADDR(x))
#define HW_IPU_DC_UGDE2_3_RD(x)  (HW_IPU_DC_UGDE2_3(x).U)
#define HW_IPU_DC_UGDE2_3_WR(x, v) (HW_IPU_DC_UGDE2_3(x).U = (v))
#define HW_IPU_DC_UGDE2_3_SET(x, v) (HW_IPU_DC_UGDE2_3_WR(x, HW_IPU_DC_UGDE2_3_RD(x) |  (v)))
#define HW_IPU_DC_UGDE2_3_CLR(x, v) (HW_IPU_DC_UGDE2_3_WR(x, HW_IPU_DC_UGDE2_3_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE2_3_TOG(x, v) (HW_IPU_DC_UGDE2_3_WR(x, HW_IPU_DC_UGDE2_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE2_3 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE2_3, field STEP_REPEAT_2[28:0] (RW)
 *
 * When auto reload mode is disabled this field defines the number of events
 * that will be generated by the user general event #2 mechanism
 */
/*@{*/
#define BP_IPU_DC_UGDE2_3_STEP_REPEAT_2 (0U) /*!< Bit position for IPU_DC_UGDE2_3_STEP_REPEAT_2. */
#define BM_IPU_DC_UGDE2_3_STEP_REPEAT_2 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE2_3_STEP_REPEAT_2. */
#define BS_IPU_DC_UGDE2_3_STEP_REPEAT_2 (29U) /*!< Bit field size in bits for IPU_DC_UGDE2_3_STEP_REPEAT_2. */

/*! @brief Read current value of the IPU_DC_UGDE2_3_STEP_REPEAT_2 field. */
#define BR_IPU_DC_UGDE2_3_STEP_REPEAT_2(x) (HW_IPU_DC_UGDE2_3(x).B.STEP_REPEAT_2)

/*! @brief Format value for bitfield IPU_DC_UGDE2_3_STEP_REPEAT_2. */
#define BF_IPU_DC_UGDE2_3_STEP_REPEAT_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE2_3_STEP_REPEAT_2) & BM_IPU_DC_UGDE2_3_STEP_REPEAT_2)

/*! @brief Set the STEP_REPEAT_2 field to a new value. */
#define BW_IPU_DC_UGDE2_3_STEP_REPEAT_2(x, v) (HW_IPU_DC_UGDE2_3_WR(x, (HW_IPU_DC_UGDE2_3_RD(x) & ~BM_IPU_DC_UGDE2_3_STEP_REPEAT_2) | BF_IPU_DC_UGDE2_3_STEP_REPEAT_2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE3_0 - DC User General Data Event 3Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE3_0 - DC User General Data Event 3Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde3_0
{
    uint32_t U;
    struct _hw_ipu_dc_ugde3_0_bitfields
    {
        uint32_t ID_CODED_3 : 3;       /*!< [2:0]  */
        uint32_t COD_EV_PRIORITY_3 : 4; /*!< [6:3]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t COD_EV_START_3 : 8;   /*!< [15:8]  */
        uint32_t COD_ODD_START_3 : 8;  /*!< [23:16]  */
        uint32_t RESERVED1 : 1;        /*!< [24]  */
        uint32_t ODD_EN_3 : 1;         /*!< [25]  */
        uint32_t AUTORESTART_3 : 1;    /*!< [26]  */
        uint32_t NF_NL_3 : 2;          /*!< [28:27]  */
        uint32_t RESERVED2 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde3_0_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE3_0 register
 */
/*@{*/
#define HW_IPU_DC_UGDE3_0_ADDR(x) ((uintptr_t)(x) + 0x581A4U)

#define HW_IPU_DC_UGDE3_0(x)     (*(__IO hw_ipu_dc_ugde3_0_t *) HW_IPU_DC_UGDE3_0_ADDR(x))
#define HW_IPU_DC_UGDE3_0_RD(x)  (HW_IPU_DC_UGDE3_0(x).U)
#define HW_IPU_DC_UGDE3_0_WR(x, v) (HW_IPU_DC_UGDE3_0(x).U = (v))
#define HW_IPU_DC_UGDE3_0_SET(x, v) (HW_IPU_DC_UGDE3_0_WR(x, HW_IPU_DC_UGDE3_0_RD(x) |  (v)))
#define HW_IPU_DC_UGDE3_0_CLR(x, v) (HW_IPU_DC_UGDE3_0_WR(x, HW_IPU_DC_UGDE3_0_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE3_0_TOG(x, v) (HW_IPU_DC_UGDE3_0_WR(x, HW_IPU_DC_UGDE3_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE3_0 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE3_0, field ID_CODED_3[2:0] (RW)
 *
 * This field defines the number of DC channel number that user's general event
 * #3 will be associated to
 *
 * Values:
 * - 000 - DC channel_0
 * - 001 - DC channel_1
 * - 010 - DC channel_2
 * - 011 - DC channel_5 (DP_SYNC)
 * - 100 - DC channel_6 (DP ASYNC)
 * - 101 - Reserved
 * - 110 - Reserved
 * - 111 - Reserved.
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_ID_CODED_3 (0U)  /*!< Bit position for IPU_DC_UGDE3_0_ID_CODED_3. */
#define BM_IPU_DC_UGDE3_0_ID_CODED_3 (0x00000007U) /*!< Bit mask for IPU_DC_UGDE3_0_ID_CODED_3. */
#define BS_IPU_DC_UGDE3_0_ID_CODED_3 (3U)  /*!< Bit field size in bits for IPU_DC_UGDE3_0_ID_CODED_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_ID_CODED_3 field. */
#define BR_IPU_DC_UGDE3_0_ID_CODED_3(x) (HW_IPU_DC_UGDE3_0(x).B.ID_CODED_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_ID_CODED_3. */
#define BF_IPU_DC_UGDE3_0_ID_CODED_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_ID_CODED_3) & BM_IPU_DC_UGDE3_0_ID_CODED_3)

/*! @brief Set the ID_CODED_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_ID_CODED_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_ID_CODED_3) | BF_IPU_DC_UGDE3_0_ID_CODED_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field COD_EV_PRIORITY_3[6:3] (RW)
 *
 * This field defines the priority of the user general event #3
 *
 * Values:
 * - 0000 - disableThe priority between the events should be set to a unique
 *     value. i.e. two events must not have the same priority (except 0000 - disable)
 * - 0001 - Priority #1 (lowest)
 * - 0010 - Priority #2
 * - 1101 - Priority #13 (highest)
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3 (3U) /*!< Bit position for IPU_DC_UGDE3_0_COD_EV_PRIORITY_3. */
#define BM_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3 (0x00000078U) /*!< Bit mask for IPU_DC_UGDE3_0_COD_EV_PRIORITY_3. */
#define BS_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3 (4U) /*!< Bit field size in bits for IPU_DC_UGDE3_0_COD_EV_PRIORITY_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_COD_EV_PRIORITY_3 field. */
#define BR_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3(x) (HW_IPU_DC_UGDE3_0(x).B.COD_EV_PRIORITY_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_COD_EV_PRIORITY_3. */
#define BF_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3) & BM_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3)

/*! @brief Set the COD_EV_PRIORITY_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3) | BF_IPU_DC_UGDE3_0_COD_EV_PRIORITY_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field COD_EV_START_3[15:8] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #3. When ODD_MODE is enabled, only the
 * even events will use this pointer When ODD_MODE is disabled, all the events will
 * use this pointer
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_COD_EV_START_3 (8U) /*!< Bit position for IPU_DC_UGDE3_0_COD_EV_START_3. */
#define BM_IPU_DC_UGDE3_0_COD_EV_START_3 (0x0000FF00U) /*!< Bit mask for IPU_DC_UGDE3_0_COD_EV_START_3. */
#define BS_IPU_DC_UGDE3_0_COD_EV_START_3 (8U) /*!< Bit field size in bits for IPU_DC_UGDE3_0_COD_EV_START_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_COD_EV_START_3 field. */
#define BR_IPU_DC_UGDE3_0_COD_EV_START_3(x) (HW_IPU_DC_UGDE3_0(x).B.COD_EV_START_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_COD_EV_START_3. */
#define BF_IPU_DC_UGDE3_0_COD_EV_START_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_COD_EV_START_3) & BM_IPU_DC_UGDE3_0_COD_EV_START_3)

/*! @brief Set the COD_EV_START_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_COD_EV_START_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_COD_EV_START_3) | BF_IPU_DC_UGDE3_0_COD_EV_START_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field COD_ODD_START_3[23:16] (RW)
 *
 * This field holds a pointer in the microcode holding the routine to be
 * performed following the user general event #3. When ODD_MODE is enabled, only the odd
 * events will use this pointer When ODD_MODE is disabled this field is ignored
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_COD_ODD_START_3 (16U) /*!< Bit position for IPU_DC_UGDE3_0_COD_ODD_START_3. */
#define BM_IPU_DC_UGDE3_0_COD_ODD_START_3 (0x00FF0000U) /*!< Bit mask for IPU_DC_UGDE3_0_COD_ODD_START_3. */
#define BS_IPU_DC_UGDE3_0_COD_ODD_START_3 (8U) /*!< Bit field size in bits for IPU_DC_UGDE3_0_COD_ODD_START_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_COD_ODD_START_3 field. */
#define BR_IPU_DC_UGDE3_0_COD_ODD_START_3(x) (HW_IPU_DC_UGDE3_0(x).B.COD_ODD_START_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_COD_ODD_START_3. */
#define BF_IPU_DC_UGDE3_0_COD_ODD_START_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_COD_ODD_START_3) & BM_IPU_DC_UGDE3_0_COD_ODD_START_3)

/*! @brief Set the COD_ODD_START_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_COD_ODD_START_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_COD_ODD_START_3) | BF_IPU_DC_UGDE3_0_COD_ODD_START_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field ODD_EN_3[25] (RW)
 *
 * The user's general event #3 may be split into 2 internal signals. One one
 * mode all the events are sent on one signal, on the second mode odd events are
 * sent over one signal while even events are sent over the other signal (ODD_MODE)
 *
 * Values:
 * - 1 - ODD_MODE is enabled
 * - 0 - ODD_MODE is disabled
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_ODD_EN_3 (25U)   /*!< Bit position for IPU_DC_UGDE3_0_ODD_EN_3. */
#define BM_IPU_DC_UGDE3_0_ODD_EN_3 (0x02000000U) /*!< Bit mask for IPU_DC_UGDE3_0_ODD_EN_3. */
#define BS_IPU_DC_UGDE3_0_ODD_EN_3 (1U)    /*!< Bit field size in bits for IPU_DC_UGDE3_0_ODD_EN_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_ODD_EN_3 field. */
#define BR_IPU_DC_UGDE3_0_ODD_EN_3(x) (HW_IPU_DC_UGDE3_0(x).B.ODD_EN_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_ODD_EN_3. */
#define BF_IPU_DC_UGDE3_0_ODD_EN_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_ODD_EN_3) & BM_IPU_DC_UGDE3_0_ODD_EN_3)

/*! @brief Set the ODD_EN_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_ODD_EN_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_ODD_EN_3) | BF_IPU_DC_UGDE3_0_ODD_EN_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field AUTORESTART_3[26] (RW)
 *
 * User's general event #3 auto restart mode
 *
 * Values:
 * - 0 - disable
 * - 1 - User's general event #3's counter is automatically restarted.
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_AUTORESTART_3 (26U) /*!< Bit position for IPU_DC_UGDE3_0_AUTORESTART_3. */
#define BM_IPU_DC_UGDE3_0_AUTORESTART_3 (0x04000000U) /*!< Bit mask for IPU_DC_UGDE3_0_AUTORESTART_3. */
#define BS_IPU_DC_UGDE3_0_AUTORESTART_3 (1U) /*!< Bit field size in bits for IPU_DC_UGDE3_0_AUTORESTART_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_AUTORESTART_3 field. */
#define BR_IPU_DC_UGDE3_0_AUTORESTART_3(x) (HW_IPU_DC_UGDE3_0(x).B.AUTORESTART_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_AUTORESTART_3. */
#define BF_IPU_DC_UGDE3_0_AUTORESTART_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_AUTORESTART_3) & BM_IPU_DC_UGDE3_0_AUTORESTART_3)

/*! @brief Set the AUTORESTART_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_AUTORESTART_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_AUTORESTART_3) | BF_IPU_DC_UGDE3_0_AUTORESTART_3(v)))
/*@}*/

/*!
 * @name Register IPU_DC_UGDE3_0, field NF_NL_3[28:27] (RW)
 *
 * the user may attach his general event #3 to New-line New-Frame and New-field
 * events. One of these event triggers the user's general event #3's counter. The
 * actual internal trigger is the pixel following the occurrence of the selected
 * event.
 *
 * Values:
 * - 00 - New Line
 * - 01 - New Frame
 * - 10 - New Field
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DC_UGDE3_0_NF_NL_3 (27U)    /*!< Bit position for IPU_DC_UGDE3_0_NF_NL_3. */
#define BM_IPU_DC_UGDE3_0_NF_NL_3 (0x18000000U) /*!< Bit mask for IPU_DC_UGDE3_0_NF_NL_3. */
#define BS_IPU_DC_UGDE3_0_NF_NL_3 (2U)     /*!< Bit field size in bits for IPU_DC_UGDE3_0_NF_NL_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_0_NF_NL_3 field. */
#define BR_IPU_DC_UGDE3_0_NF_NL_3(x) (HW_IPU_DC_UGDE3_0(x).B.NF_NL_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_0_NF_NL_3. */
#define BF_IPU_DC_UGDE3_0_NF_NL_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_0_NF_NL_3) & BM_IPU_DC_UGDE3_0_NF_NL_3)

/*! @brief Set the NF_NL_3 field to a new value. */
#define BW_IPU_DC_UGDE3_0_NF_NL_3(x, v) (HW_IPU_DC_UGDE3_0_WR(x, (HW_IPU_DC_UGDE3_0_RD(x) & ~BM_IPU_DC_UGDE3_0_NF_NL_3) | BF_IPU_DC_UGDE3_0_NF_NL_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE3_1 - DC User General Data Event 3Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE3_1 - DC User General Data Event 3Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde3_1
{
    uint32_t U;
    struct _hw_ipu_dc_ugde3_1_bitfields
    {
        uint32_t STEP_3 : 29;          /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde3_1_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE3_1 register
 */
/*@{*/
#define HW_IPU_DC_UGDE3_1_ADDR(x) ((uintptr_t)(x) + 0x581A8U)

#define HW_IPU_DC_UGDE3_1(x)     (*(__IO hw_ipu_dc_ugde3_1_t *) HW_IPU_DC_UGDE3_1_ADDR(x))
#define HW_IPU_DC_UGDE3_1_RD(x)  (HW_IPU_DC_UGDE3_1(x).U)
#define HW_IPU_DC_UGDE3_1_WR(x, v) (HW_IPU_DC_UGDE3_1(x).U = (v))
#define HW_IPU_DC_UGDE3_1_SET(x, v) (HW_IPU_DC_UGDE3_1_WR(x, HW_IPU_DC_UGDE3_1_RD(x) |  (v)))
#define HW_IPU_DC_UGDE3_1_CLR(x, v) (HW_IPU_DC_UGDE3_1_WR(x, HW_IPU_DC_UGDE3_1_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE3_1_TOG(x, v) (HW_IPU_DC_UGDE3_1_WR(x, HW_IPU_DC_UGDE3_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE3_1 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE3_1, field STEP_3[28:0] (RW)
 *
 * This field hold the pre defined value that the counter counts too
 */
/*@{*/
#define BP_IPU_DC_UGDE3_1_STEP_3 (0U)      /*!< Bit position for IPU_DC_UGDE3_1_STEP_3. */
#define BM_IPU_DC_UGDE3_1_STEP_3 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE3_1_STEP_3. */
#define BS_IPU_DC_UGDE3_1_STEP_3 (29U)     /*!< Bit field size in bits for IPU_DC_UGDE3_1_STEP_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_1_STEP_3 field. */
#define BR_IPU_DC_UGDE3_1_STEP_3(x) (HW_IPU_DC_UGDE3_1(x).B.STEP_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_1_STEP_3. */
#define BF_IPU_DC_UGDE3_1_STEP_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_1_STEP_3) & BM_IPU_DC_UGDE3_1_STEP_3)

/*! @brief Set the STEP_3 field to a new value. */
#define BW_IPU_DC_UGDE3_1_STEP_3(x, v) (HW_IPU_DC_UGDE3_1_WR(x, (HW_IPU_DC_UGDE3_1_RD(x) & ~BM_IPU_DC_UGDE3_1_STEP_3) | BF_IPU_DC_UGDE3_1_STEP_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE3_2 - DC User General Data Event 3Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE3_2 - DC User General Data Event 3Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde3_2
{
    uint32_t U;
    struct _hw_ipu_dc_ugde3_2_bitfields
    {
        uint32_t OFFSET_DT_3 : 29;     /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde3_2_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE3_2 register
 */
/*@{*/
#define HW_IPU_DC_UGDE3_2_ADDR(x) ((uintptr_t)(x) + 0x581ACU)

#define HW_IPU_DC_UGDE3_2(x)     (*(__IO hw_ipu_dc_ugde3_2_t *) HW_IPU_DC_UGDE3_2_ADDR(x))
#define HW_IPU_DC_UGDE3_2_RD(x)  (HW_IPU_DC_UGDE3_2(x).U)
#define HW_IPU_DC_UGDE3_2_WR(x, v) (HW_IPU_DC_UGDE3_2(x).U = (v))
#define HW_IPU_DC_UGDE3_2_SET(x, v) (HW_IPU_DC_UGDE3_2_WR(x, HW_IPU_DC_UGDE3_2_RD(x) |  (v)))
#define HW_IPU_DC_UGDE3_2_CLR(x, v) (HW_IPU_DC_UGDE3_2_WR(x, HW_IPU_DC_UGDE3_2_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE3_2_TOG(x, v) (HW_IPU_DC_UGDE3_2_WR(x, HW_IPU_DC_UGDE3_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE3_2 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE3_2, field OFFSET_DT_3[28:0] (RW)
 *
 * This field defines the offset value from which the counter of user general
 * event #3 will start counting from
 */
/*@{*/
#define BP_IPU_DC_UGDE3_2_OFFSET_DT_3 (0U) /*!< Bit position for IPU_DC_UGDE3_2_OFFSET_DT_3. */
#define BM_IPU_DC_UGDE3_2_OFFSET_DT_3 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE3_2_OFFSET_DT_3. */
#define BS_IPU_DC_UGDE3_2_OFFSET_DT_3 (29U) /*!< Bit field size in bits for IPU_DC_UGDE3_2_OFFSET_DT_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_2_OFFSET_DT_3 field. */
#define BR_IPU_DC_UGDE3_2_OFFSET_DT_3(x) (HW_IPU_DC_UGDE3_2(x).B.OFFSET_DT_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_2_OFFSET_DT_3. */
#define BF_IPU_DC_UGDE3_2_OFFSET_DT_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_2_OFFSET_DT_3) & BM_IPU_DC_UGDE3_2_OFFSET_DT_3)

/*! @brief Set the OFFSET_DT_3 field to a new value. */
#define BW_IPU_DC_UGDE3_2_OFFSET_DT_3(x, v) (HW_IPU_DC_UGDE3_2_WR(x, (HW_IPU_DC_UGDE3_2_RD(x) & ~BM_IPU_DC_UGDE3_2_OFFSET_DT_3) | BF_IPU_DC_UGDE3_2_OFFSET_DT_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_UGDE3_3 - DC User General Data Event 3Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_UGDE3_3 - DC User General Data Event 3Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_ugde3_3
{
    uint32_t U;
    struct _hw_ipu_dc_ugde3_3_bitfields
    {
        uint32_t STEP_REPEAT_3 : 29;   /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_ugde3_3_t;

/*!
 * @name Constants and macros for entire IPU_DC_UGDE3_3 register
 */
/*@{*/
#define HW_IPU_DC_UGDE3_3_ADDR(x) ((uintptr_t)(x) + 0x581B0U)

#define HW_IPU_DC_UGDE3_3(x)     (*(__IO hw_ipu_dc_ugde3_3_t *) HW_IPU_DC_UGDE3_3_ADDR(x))
#define HW_IPU_DC_UGDE3_3_RD(x)  (HW_IPU_DC_UGDE3_3(x).U)
#define HW_IPU_DC_UGDE3_3_WR(x, v) (HW_IPU_DC_UGDE3_3(x).U = (v))
#define HW_IPU_DC_UGDE3_3_SET(x, v) (HW_IPU_DC_UGDE3_3_WR(x, HW_IPU_DC_UGDE3_3_RD(x) |  (v)))
#define HW_IPU_DC_UGDE3_3_CLR(x, v) (HW_IPU_DC_UGDE3_3_WR(x, HW_IPU_DC_UGDE3_3_RD(x) & ~(v)))
#define HW_IPU_DC_UGDE3_3_TOG(x, v) (HW_IPU_DC_UGDE3_3_WR(x, HW_IPU_DC_UGDE3_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_UGDE3_3 bitfields
 */

/*!
 * @name Register IPU_DC_UGDE3_3, field STEP_REPEAT_3[28:0] (RW)
 *
 * When auto reload mode is disabled this field defines the number of events
 * that will be generated by the user general event #3 mechanism
 */
/*@{*/
#define BP_IPU_DC_UGDE3_3_STEP_REPEAT_3 (0U) /*!< Bit position for IPU_DC_UGDE3_3_STEP_REPEAT_3. */
#define BM_IPU_DC_UGDE3_3_STEP_REPEAT_3 (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_UGDE3_3_STEP_REPEAT_3. */
#define BS_IPU_DC_UGDE3_3_STEP_REPEAT_3 (29U) /*!< Bit field size in bits for IPU_DC_UGDE3_3_STEP_REPEAT_3. */

/*! @brief Read current value of the IPU_DC_UGDE3_3_STEP_REPEAT_3 field. */
#define BR_IPU_DC_UGDE3_3_STEP_REPEAT_3(x) (HW_IPU_DC_UGDE3_3(x).B.STEP_REPEAT_3)

/*! @brief Format value for bitfield IPU_DC_UGDE3_3_STEP_REPEAT_3. */
#define BF_IPU_DC_UGDE3_3_STEP_REPEAT_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_UGDE3_3_STEP_REPEAT_3) & BM_IPU_DC_UGDE3_3_STEP_REPEAT_3)

/*! @brief Set the STEP_REPEAT_3 field to a new value. */
#define BW_IPU_DC_UGDE3_3_STEP_REPEAT_3(x, v) (HW_IPU_DC_UGDE3_3_WR(x, (HW_IPU_DC_UGDE3_3_RD(x) & ~BM_IPU_DC_UGDE3_3_STEP_REPEAT_3) | BF_IPU_DC_UGDE3_3_STEP_REPEAT_3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_LLA0 - DC Low Level Access Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_LLA0 - DC Low Level Access Control Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_lla0
{
    uint32_t U;
    struct _hw_ipu_dc_lla0_bitfields
    {
        uint32_t MCU_RS_0_0 : 8;       /*!< [7:0]  */
        uint32_t MCU_RS_1_0 : 8;       /*!< [15:8]  */
        uint32_t MCU_RS_2_0 : 8;       /*!< [23:16]  */
        uint32_t MCU_RS_3_0 : 8;       /*!< [31:24]  */
    } B;
} hw_ipu_dc_lla0_t;

/*!
 * @name Constants and macros for entire IPU_DC_LLA0 register
 */
/*@{*/
#define HW_IPU_DC_LLA0_ADDR(x)   ((uintptr_t)(x) + 0x581B4U)

#define HW_IPU_DC_LLA0(x)        (*(__IO hw_ipu_dc_lla0_t *) HW_IPU_DC_LLA0_ADDR(x))
#define HW_IPU_DC_LLA0_RD(x)     (HW_IPU_DC_LLA0(x).U)
#define HW_IPU_DC_LLA0_WR(x, v)  (HW_IPU_DC_LLA0(x).U = (v))
#define HW_IPU_DC_LLA0_SET(x, v) (HW_IPU_DC_LLA0_WR(x, HW_IPU_DC_LLA0_RD(x) |  (v)))
#define HW_IPU_DC_LLA0_CLR(x, v) (HW_IPU_DC_LLA0_WR(x, HW_IPU_DC_LLA0_RD(x) & ~(v)))
#define HW_IPU_DC_LLA0_TOG(x, v) (HW_IPU_DC_LLA0_WR(x, HW_IPU_DC_LLA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_LLA0 bitfields
 */

/*!
 * @name Register IPU_DC_LLA0, field MCU_RS_0_0[7:0] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_0 routine for the
 * display defined at DISP_ID_8, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA0_MCU_RS_0_0 (0U)     /*!< Bit position for IPU_DC_LLA0_MCU_RS_0_0. */
#define BM_IPU_DC_LLA0_MCU_RS_0_0 (0x000000FFU) /*!< Bit mask for IPU_DC_LLA0_MCU_RS_0_0. */
#define BS_IPU_DC_LLA0_MCU_RS_0_0 (8U)     /*!< Bit field size in bits for IPU_DC_LLA0_MCU_RS_0_0. */

/*! @brief Read current value of the IPU_DC_LLA0_MCU_RS_0_0 field. */
#define BR_IPU_DC_LLA0_MCU_RS_0_0(x) (HW_IPU_DC_LLA0(x).B.MCU_RS_0_0)

/*! @brief Format value for bitfield IPU_DC_LLA0_MCU_RS_0_0. */
#define BF_IPU_DC_LLA0_MCU_RS_0_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA0_MCU_RS_0_0) & BM_IPU_DC_LLA0_MCU_RS_0_0)

/*! @brief Set the MCU_RS_0_0 field to a new value. */
#define BW_IPU_DC_LLA0_MCU_RS_0_0(x, v) (HW_IPU_DC_LLA0_WR(x, (HW_IPU_DC_LLA0_RD(x) & ~BM_IPU_DC_LLA0_MCU_RS_0_0) | BF_IPU_DC_LLA0_MCU_RS_0_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA0, field MCU_RS_1_0[15:8] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_1 routine for the
 * display defined at DISP_ID_8, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA0_MCU_RS_1_0 (8U)     /*!< Bit position for IPU_DC_LLA0_MCU_RS_1_0. */
#define BM_IPU_DC_LLA0_MCU_RS_1_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_LLA0_MCU_RS_1_0. */
#define BS_IPU_DC_LLA0_MCU_RS_1_0 (8U)     /*!< Bit field size in bits for IPU_DC_LLA0_MCU_RS_1_0. */

/*! @brief Read current value of the IPU_DC_LLA0_MCU_RS_1_0 field. */
#define BR_IPU_DC_LLA0_MCU_RS_1_0(x) (HW_IPU_DC_LLA0(x).B.MCU_RS_1_0)

/*! @brief Format value for bitfield IPU_DC_LLA0_MCU_RS_1_0. */
#define BF_IPU_DC_LLA0_MCU_RS_1_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA0_MCU_RS_1_0) & BM_IPU_DC_LLA0_MCU_RS_1_0)

/*! @brief Set the MCU_RS_1_0 field to a new value. */
#define BW_IPU_DC_LLA0_MCU_RS_1_0(x, v) (HW_IPU_DC_LLA0_WR(x, (HW_IPU_DC_LLA0_RD(x) & ~BM_IPU_DC_LLA0_MCU_RS_1_0) | BF_IPU_DC_LLA0_MCU_RS_1_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA0, field MCU_RS_2_0[23:16] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_2 routine for the
 * display defined at DISP_ID_8, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA0_MCU_RS_2_0 (16U)    /*!< Bit position for IPU_DC_LLA0_MCU_RS_2_0. */
#define BM_IPU_DC_LLA0_MCU_RS_2_0 (0x00FF0000U) /*!< Bit mask for IPU_DC_LLA0_MCU_RS_2_0. */
#define BS_IPU_DC_LLA0_MCU_RS_2_0 (8U)     /*!< Bit field size in bits for IPU_DC_LLA0_MCU_RS_2_0. */

/*! @brief Read current value of the IPU_DC_LLA0_MCU_RS_2_0 field. */
#define BR_IPU_DC_LLA0_MCU_RS_2_0(x) (HW_IPU_DC_LLA0(x).B.MCU_RS_2_0)

/*! @brief Format value for bitfield IPU_DC_LLA0_MCU_RS_2_0. */
#define BF_IPU_DC_LLA0_MCU_RS_2_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA0_MCU_RS_2_0) & BM_IPU_DC_LLA0_MCU_RS_2_0)

/*! @brief Set the MCU_RS_2_0 field to a new value. */
#define BW_IPU_DC_LLA0_MCU_RS_2_0(x, v) (HW_IPU_DC_LLA0_WR(x, (HW_IPU_DC_LLA0_RD(x) & ~BM_IPU_DC_LLA0_MCU_RS_2_0) | BF_IPU_DC_LLA0_MCU_RS_2_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA0, field MCU_RS_3_0[31:24] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_3 routine for the
 * display defined at DISP_ID_8, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA0_MCU_RS_3_0 (24U)    /*!< Bit position for IPU_DC_LLA0_MCU_RS_3_0. */
#define BM_IPU_DC_LLA0_MCU_RS_3_0 (0xFF000000U) /*!< Bit mask for IPU_DC_LLA0_MCU_RS_3_0. */
#define BS_IPU_DC_LLA0_MCU_RS_3_0 (8U)     /*!< Bit field size in bits for IPU_DC_LLA0_MCU_RS_3_0. */

/*! @brief Read current value of the IPU_DC_LLA0_MCU_RS_3_0 field. */
#define BR_IPU_DC_LLA0_MCU_RS_3_0(x) (HW_IPU_DC_LLA0(x).B.MCU_RS_3_0)

/*! @brief Format value for bitfield IPU_DC_LLA0_MCU_RS_3_0. */
#define BF_IPU_DC_LLA0_MCU_RS_3_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA0_MCU_RS_3_0) & BM_IPU_DC_LLA0_MCU_RS_3_0)

/*! @brief Set the MCU_RS_3_0 field to a new value. */
#define BW_IPU_DC_LLA0_MCU_RS_3_0(x, v) (HW_IPU_DC_LLA0_WR(x, (HW_IPU_DC_LLA0_RD(x) & ~BM_IPU_DC_LLA0_MCU_RS_3_0) | BF_IPU_DC_LLA0_MCU_RS_3_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_LLA1 - DC Low Level Access Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_LLA1 - DC Low Level Access Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_lla1
{
    uint32_t U;
    struct _hw_ipu_dc_lla1_bitfields
    {
        uint32_t MCU_RS_0_1 : 8;       /*!< [7:0]  */
        uint32_t MCU_RS_1_1 : 8;       /*!< [15:8]  */
        uint32_t MCU_RS_2_1 : 8;       /*!< [23:16]  */
        uint32_t MCU_RS_3_1 : 8;       /*!< [31:24]  */
    } B;
} hw_ipu_dc_lla1_t;

/*!
 * @name Constants and macros for entire IPU_DC_LLA1 register
 */
/*@{*/
#define HW_IPU_DC_LLA1_ADDR(x)   ((uintptr_t)(x) + 0x581B8U)

#define HW_IPU_DC_LLA1(x)        (*(__IO hw_ipu_dc_lla1_t *) HW_IPU_DC_LLA1_ADDR(x))
#define HW_IPU_DC_LLA1_RD(x)     (HW_IPU_DC_LLA1(x).U)
#define HW_IPU_DC_LLA1_WR(x, v)  (HW_IPU_DC_LLA1(x).U = (v))
#define HW_IPU_DC_LLA1_SET(x, v) (HW_IPU_DC_LLA1_WR(x, HW_IPU_DC_LLA1_RD(x) |  (v)))
#define HW_IPU_DC_LLA1_CLR(x, v) (HW_IPU_DC_LLA1_WR(x, HW_IPU_DC_LLA1_RD(x) & ~(v)))
#define HW_IPU_DC_LLA1_TOG(x, v) (HW_IPU_DC_LLA1_WR(x, HW_IPU_DC_LLA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_LLA1 bitfields
 */

/*!
 * @name Register IPU_DC_LLA1, field MCU_RS_0_1[7:0] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_0 routine for the
 * display defined at DISP_ID_9, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA1_MCU_RS_0_1 (0U)     /*!< Bit position for IPU_DC_LLA1_MCU_RS_0_1. */
#define BM_IPU_DC_LLA1_MCU_RS_0_1 (0x000000FFU) /*!< Bit mask for IPU_DC_LLA1_MCU_RS_0_1. */
#define BS_IPU_DC_LLA1_MCU_RS_0_1 (8U)     /*!< Bit field size in bits for IPU_DC_LLA1_MCU_RS_0_1. */

/*! @brief Read current value of the IPU_DC_LLA1_MCU_RS_0_1 field. */
#define BR_IPU_DC_LLA1_MCU_RS_0_1(x) (HW_IPU_DC_LLA1(x).B.MCU_RS_0_1)

/*! @brief Format value for bitfield IPU_DC_LLA1_MCU_RS_0_1. */
#define BF_IPU_DC_LLA1_MCU_RS_0_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA1_MCU_RS_0_1) & BM_IPU_DC_LLA1_MCU_RS_0_1)

/*! @brief Set the MCU_RS_0_1 field to a new value. */
#define BW_IPU_DC_LLA1_MCU_RS_0_1(x, v) (HW_IPU_DC_LLA1_WR(x, (HW_IPU_DC_LLA1_RD(x) & ~BM_IPU_DC_LLA1_MCU_RS_0_1) | BF_IPU_DC_LLA1_MCU_RS_0_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA1, field MCU_RS_1_1[15:8] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_1 routine for the
 * display defined at DISP_ID_9, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA1_MCU_RS_1_1 (8U)     /*!< Bit position for IPU_DC_LLA1_MCU_RS_1_1. */
#define BM_IPU_DC_LLA1_MCU_RS_1_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_LLA1_MCU_RS_1_1. */
#define BS_IPU_DC_LLA1_MCU_RS_1_1 (8U)     /*!< Bit field size in bits for IPU_DC_LLA1_MCU_RS_1_1. */

/*! @brief Read current value of the IPU_DC_LLA1_MCU_RS_1_1 field. */
#define BR_IPU_DC_LLA1_MCU_RS_1_1(x) (HW_IPU_DC_LLA1(x).B.MCU_RS_1_1)

/*! @brief Format value for bitfield IPU_DC_LLA1_MCU_RS_1_1. */
#define BF_IPU_DC_LLA1_MCU_RS_1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA1_MCU_RS_1_1) & BM_IPU_DC_LLA1_MCU_RS_1_1)

/*! @brief Set the MCU_RS_1_1 field to a new value. */
#define BW_IPU_DC_LLA1_MCU_RS_1_1(x, v) (HW_IPU_DC_LLA1_WR(x, (HW_IPU_DC_LLA1_RD(x) & ~BM_IPU_DC_LLA1_MCU_RS_1_1) | BF_IPU_DC_LLA1_MCU_RS_1_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA1, field MCU_RS_2_1[23:16] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_2 routine for the
 * display defined at DISP_ID_9, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA1_MCU_RS_2_1 (16U)    /*!< Bit position for IPU_DC_LLA1_MCU_RS_2_1. */
#define BM_IPU_DC_LLA1_MCU_RS_2_1 (0x00FF0000U) /*!< Bit mask for IPU_DC_LLA1_MCU_RS_2_1. */
#define BS_IPU_DC_LLA1_MCU_RS_2_1 (8U)     /*!< Bit field size in bits for IPU_DC_LLA1_MCU_RS_2_1. */

/*! @brief Read current value of the IPU_DC_LLA1_MCU_RS_2_1 field. */
#define BR_IPU_DC_LLA1_MCU_RS_2_1(x) (HW_IPU_DC_LLA1(x).B.MCU_RS_2_1)

/*! @brief Format value for bitfield IPU_DC_LLA1_MCU_RS_2_1. */
#define BF_IPU_DC_LLA1_MCU_RS_2_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA1_MCU_RS_2_1) & BM_IPU_DC_LLA1_MCU_RS_2_1)

/*! @brief Set the MCU_RS_2_1 field to a new value. */
#define BW_IPU_DC_LLA1_MCU_RS_2_1(x, v) (HW_IPU_DC_LLA1_WR(x, (HW_IPU_DC_LLA1_RD(x) & ~BM_IPU_DC_LLA1_MCU_RS_2_1) | BF_IPU_DC_LLA1_MCU_RS_2_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_LLA1, field MCU_RS_3_1[31:24] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_3 routine for the
 * display defined at DISP_ID_9, when in Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_LLA1_MCU_RS_3_1 (24U)    /*!< Bit position for IPU_DC_LLA1_MCU_RS_3_1. */
#define BM_IPU_DC_LLA1_MCU_RS_3_1 (0xFF000000U) /*!< Bit mask for IPU_DC_LLA1_MCU_RS_3_1. */
#define BS_IPU_DC_LLA1_MCU_RS_3_1 (8U)     /*!< Bit field size in bits for IPU_DC_LLA1_MCU_RS_3_1. */

/*! @brief Read current value of the IPU_DC_LLA1_MCU_RS_3_1 field. */
#define BR_IPU_DC_LLA1_MCU_RS_3_1(x) (HW_IPU_DC_LLA1(x).B.MCU_RS_3_1)

/*! @brief Format value for bitfield IPU_DC_LLA1_MCU_RS_3_1. */
#define BF_IPU_DC_LLA1_MCU_RS_3_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_LLA1_MCU_RS_3_1) & BM_IPU_DC_LLA1_MCU_RS_3_1)

/*! @brief Set the MCU_RS_3_1 field to a new value. */
#define BW_IPU_DC_LLA1_MCU_RS_3_1(x, v) (HW_IPU_DC_LLA1_WR(x, (HW_IPU_DC_LLA1_RD(x) & ~BM_IPU_DC_LLA1_MCU_RS_3_1) | BF_IPU_DC_LLA1_MCU_RS_3_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_R_LLA0 - DC Read Low Level Read Access Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_R_LLA0 - DC Read Low Level Read Access Control Register 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_r_lla0
{
    uint32_t U;
    struct _hw_ipu_dc_r_lla0_bitfields
    {
        uint32_t MCU_RS_R_0_0 : 8;     /*!< [7:0]  */
        uint32_t MCU_RS_R_1_0 : 8;     /*!< [15:8]  */
        uint32_t MCU_RS_2_0 : 8;       /*!< [23:16]  */
        uint32_t MCU_RS_3_0 : 8;       /*!< [31:24]  */
    } B;
} hw_ipu_dc_r_lla0_t;

/*!
 * @name Constants and macros for entire IPU_DC_R_LLA0 register
 */
/*@{*/
#define HW_IPU_DC_R_LLA0_ADDR(x) ((uintptr_t)(x) + 0x581BCU)

#define HW_IPU_DC_R_LLA0(x)      (*(__IO hw_ipu_dc_r_lla0_t *) HW_IPU_DC_R_LLA0_ADDR(x))
#define HW_IPU_DC_R_LLA0_RD(x)   (HW_IPU_DC_R_LLA0(x).U)
#define HW_IPU_DC_R_LLA0_WR(x, v) (HW_IPU_DC_R_LLA0(x).U = (v))
#define HW_IPU_DC_R_LLA0_SET(x, v) (HW_IPU_DC_R_LLA0_WR(x, HW_IPU_DC_R_LLA0_RD(x) |  (v)))
#define HW_IPU_DC_R_LLA0_CLR(x, v) (HW_IPU_DC_R_LLA0_WR(x, HW_IPU_DC_R_LLA0_RD(x) & ~(v)))
#define HW_IPU_DC_R_LLA0_TOG(x, v) (HW_IPU_DC_R_LLA0_WR(x, HW_IPU_DC_R_LLA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_R_LLA0 bitfields
 */

/*!
 * @name Register IPU_DC_R_LLA0, field MCU_RS_R_0_0[7:0] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_0 routine for the
 * display defined at DISP_ID_8, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA0_MCU_RS_R_0_0 (0U) /*!< Bit position for IPU_DC_R_LLA0_MCU_RS_R_0_0. */
#define BM_IPU_DC_R_LLA0_MCU_RS_R_0_0 (0x000000FFU) /*!< Bit mask for IPU_DC_R_LLA0_MCU_RS_R_0_0. */
#define BS_IPU_DC_R_LLA0_MCU_RS_R_0_0 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA0_MCU_RS_R_0_0. */

/*! @brief Read current value of the IPU_DC_R_LLA0_MCU_RS_R_0_0 field. */
#define BR_IPU_DC_R_LLA0_MCU_RS_R_0_0(x) (HW_IPU_DC_R_LLA0(x).B.MCU_RS_R_0_0)

/*! @brief Format value for bitfield IPU_DC_R_LLA0_MCU_RS_R_0_0. */
#define BF_IPU_DC_R_LLA0_MCU_RS_R_0_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA0_MCU_RS_R_0_0) & BM_IPU_DC_R_LLA0_MCU_RS_R_0_0)

/*! @brief Set the MCU_RS_R_0_0 field to a new value. */
#define BW_IPU_DC_R_LLA0_MCU_RS_R_0_0(x, v) (HW_IPU_DC_R_LLA0_WR(x, (HW_IPU_DC_R_LLA0_RD(x) & ~BM_IPU_DC_R_LLA0_MCU_RS_R_0_0) | BF_IPU_DC_R_LLA0_MCU_RS_R_0_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA0, field MCU_RS_R_1_0[15:8] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_1 routine for the
 * display defined at DISP_ID_8, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA0_MCU_RS_R_1_0 (8U) /*!< Bit position for IPU_DC_R_LLA0_MCU_RS_R_1_0. */
#define BM_IPU_DC_R_LLA0_MCU_RS_R_1_0 (0x0000FF00U) /*!< Bit mask for IPU_DC_R_LLA0_MCU_RS_R_1_0. */
#define BS_IPU_DC_R_LLA0_MCU_RS_R_1_0 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA0_MCU_RS_R_1_0. */

/*! @brief Read current value of the IPU_DC_R_LLA0_MCU_RS_R_1_0 field. */
#define BR_IPU_DC_R_LLA0_MCU_RS_R_1_0(x) (HW_IPU_DC_R_LLA0(x).B.MCU_RS_R_1_0)

/*! @brief Format value for bitfield IPU_DC_R_LLA0_MCU_RS_R_1_0. */
#define BF_IPU_DC_R_LLA0_MCU_RS_R_1_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA0_MCU_RS_R_1_0) & BM_IPU_DC_R_LLA0_MCU_RS_R_1_0)

/*! @brief Set the MCU_RS_R_1_0 field to a new value. */
#define BW_IPU_DC_R_LLA0_MCU_RS_R_1_0(x, v) (HW_IPU_DC_R_LLA0_WR(x, (HW_IPU_DC_R_LLA0_RD(x) & ~BM_IPU_DC_R_LLA0_MCU_RS_R_1_0) | BF_IPU_DC_R_LLA0_MCU_RS_R_1_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA0, field MCU_RS_2_0[23:16] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_2 routine for the
 * display defined at DISP_ID_8, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA0_MCU_RS_2_0 (16U)  /*!< Bit position for IPU_DC_R_LLA0_MCU_RS_2_0. */
#define BM_IPU_DC_R_LLA0_MCU_RS_2_0 (0x00FF0000U) /*!< Bit mask for IPU_DC_R_LLA0_MCU_RS_2_0. */
#define BS_IPU_DC_R_LLA0_MCU_RS_2_0 (8U)   /*!< Bit field size in bits for IPU_DC_R_LLA0_MCU_RS_2_0. */

/*! @brief Read current value of the IPU_DC_R_LLA0_MCU_RS_2_0 field. */
#define BR_IPU_DC_R_LLA0_MCU_RS_2_0(x) (HW_IPU_DC_R_LLA0(x).B.MCU_RS_2_0)

/*! @brief Format value for bitfield IPU_DC_R_LLA0_MCU_RS_2_0. */
#define BF_IPU_DC_R_LLA0_MCU_RS_2_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA0_MCU_RS_2_0) & BM_IPU_DC_R_LLA0_MCU_RS_2_0)

/*! @brief Set the MCU_RS_2_0 field to a new value. */
#define BW_IPU_DC_R_LLA0_MCU_RS_2_0(x, v) (HW_IPU_DC_R_LLA0_WR(x, (HW_IPU_DC_R_LLA0_RD(x) & ~BM_IPU_DC_R_LLA0_MCU_RS_2_0) | BF_IPU_DC_R_LLA0_MCU_RS_2_0(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA0, field MCU_RS_3_0[31:24] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_3 routine for the
 * display defined at DISP_ID_8, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA0_MCU_RS_3_0 (24U)  /*!< Bit position for IPU_DC_R_LLA0_MCU_RS_3_0. */
#define BM_IPU_DC_R_LLA0_MCU_RS_3_0 (0xFF000000U) /*!< Bit mask for IPU_DC_R_LLA0_MCU_RS_3_0. */
#define BS_IPU_DC_R_LLA0_MCU_RS_3_0 (8U)   /*!< Bit field size in bits for IPU_DC_R_LLA0_MCU_RS_3_0. */

/*! @brief Read current value of the IPU_DC_R_LLA0_MCU_RS_3_0 field. */
#define BR_IPU_DC_R_LLA0_MCU_RS_3_0(x) (HW_IPU_DC_R_LLA0(x).B.MCU_RS_3_0)

/*! @brief Format value for bitfield IPU_DC_R_LLA0_MCU_RS_3_0. */
#define BF_IPU_DC_R_LLA0_MCU_RS_3_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA0_MCU_RS_3_0) & BM_IPU_DC_R_LLA0_MCU_RS_3_0)

/*! @brief Set the MCU_RS_3_0 field to a new value. */
#define BW_IPU_DC_R_LLA0_MCU_RS_3_0(x, v) (HW_IPU_DC_R_LLA0_WR(x, (HW_IPU_DC_R_LLA0_RD(x) & ~BM_IPU_DC_R_LLA0_MCU_RS_3_0) | BF_IPU_DC_R_LLA0_MCU_RS_3_0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_R_LLA1 - DC Read Low Level Read Access Control Register1
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_R_LLA1 - DC Read Low Level Read Access Control Register1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_r_lla1
{
    uint32_t U;
    struct _hw_ipu_dc_r_lla1_bitfields
    {
        uint32_t MCU_RS_R_0_1 : 8;     /*!< [7:0]  */
        uint32_t MCU_RS_R_1_1 : 8;     /*!< [15:8]  */
        uint32_t MCU_RS_R_2_1 : 8;     /*!< [23:16]  */
        uint32_t MCU_RS_R_3_1 : 8;     /*!< [31:24]  */
    } B;
} hw_ipu_dc_r_lla1_t;

/*!
 * @name Constants and macros for entire IPU_DC_R_LLA1 register
 */
/*@{*/
#define HW_IPU_DC_R_LLA1_ADDR(x) ((uintptr_t)(x) + 0x581C0U)

#define HW_IPU_DC_R_LLA1(x)      (*(__IO hw_ipu_dc_r_lla1_t *) HW_IPU_DC_R_LLA1_ADDR(x))
#define HW_IPU_DC_R_LLA1_RD(x)   (HW_IPU_DC_R_LLA1(x).U)
#define HW_IPU_DC_R_LLA1_WR(x, v) (HW_IPU_DC_R_LLA1(x).U = (v))
#define HW_IPU_DC_R_LLA1_SET(x, v) (HW_IPU_DC_R_LLA1_WR(x, HW_IPU_DC_R_LLA1_RD(x) |  (v)))
#define HW_IPU_DC_R_LLA1_CLR(x, v) (HW_IPU_DC_R_LLA1_WR(x, HW_IPU_DC_R_LLA1_RD(x) & ~(v)))
#define HW_IPU_DC_R_LLA1_TOG(x, v) (HW_IPU_DC_R_LLA1_WR(x, HW_IPU_DC_R_LLA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_R_LLA1 bitfields
 */

/*!
 * @name Register IPU_DC_R_LLA1, field MCU_RS_R_0_1[7:0] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_0 routine for the
 * display defined at DISP_ID_9, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA1_MCU_RS_R_0_1 (0U) /*!< Bit position for IPU_DC_R_LLA1_MCU_RS_R_0_1. */
#define BM_IPU_DC_R_LLA1_MCU_RS_R_0_1 (0x000000FFU) /*!< Bit mask for IPU_DC_R_LLA1_MCU_RS_R_0_1. */
#define BS_IPU_DC_R_LLA1_MCU_RS_R_0_1 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA1_MCU_RS_R_0_1. */

/*! @brief Read current value of the IPU_DC_R_LLA1_MCU_RS_R_0_1 field. */
#define BR_IPU_DC_R_LLA1_MCU_RS_R_0_1(x) (HW_IPU_DC_R_LLA1(x).B.MCU_RS_R_0_1)

/*! @brief Format value for bitfield IPU_DC_R_LLA1_MCU_RS_R_0_1. */
#define BF_IPU_DC_R_LLA1_MCU_RS_R_0_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA1_MCU_RS_R_0_1) & BM_IPU_DC_R_LLA1_MCU_RS_R_0_1)

/*! @brief Set the MCU_RS_R_0_1 field to a new value. */
#define BW_IPU_DC_R_LLA1_MCU_RS_R_0_1(x, v) (HW_IPU_DC_R_LLA1_WR(x, (HW_IPU_DC_R_LLA1_RD(x) & ~BM_IPU_DC_R_LLA1_MCU_RS_R_0_1) | BF_IPU_DC_R_LLA1_MCU_RS_R_0_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA1, field MCU_RS_R_1_1[15:8] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_1 routine for the
 * display defined at DISP_ID_9, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA1_MCU_RS_R_1_1 (8U) /*!< Bit position for IPU_DC_R_LLA1_MCU_RS_R_1_1. */
#define BM_IPU_DC_R_LLA1_MCU_RS_R_1_1 (0x0000FF00U) /*!< Bit mask for IPU_DC_R_LLA1_MCU_RS_R_1_1. */
#define BS_IPU_DC_R_LLA1_MCU_RS_R_1_1 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA1_MCU_RS_R_1_1. */

/*! @brief Read current value of the IPU_DC_R_LLA1_MCU_RS_R_1_1 field. */
#define BR_IPU_DC_R_LLA1_MCU_RS_R_1_1(x) (HW_IPU_DC_R_LLA1(x).B.MCU_RS_R_1_1)

/*! @brief Format value for bitfield IPU_DC_R_LLA1_MCU_RS_R_1_1. */
#define BF_IPU_DC_R_LLA1_MCU_RS_R_1_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA1_MCU_RS_R_1_1) & BM_IPU_DC_R_LLA1_MCU_RS_R_1_1)

/*! @brief Set the MCU_RS_R_1_1 field to a new value. */
#define BW_IPU_DC_R_LLA1_MCU_RS_R_1_1(x, v) (HW_IPU_DC_R_LLA1_WR(x, (HW_IPU_DC_R_LLA1_RD(x) & ~BM_IPU_DC_R_LLA1_MCU_RS_R_1_1) | BF_IPU_DC_R_LLA1_MCU_RS_R_1_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA1, field MCU_RS_R_2_1[23:16] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_2 routine for the
 * display defined at DISP_ID_9, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA1_MCU_RS_R_2_1 (16U) /*!< Bit position for IPU_DC_R_LLA1_MCU_RS_R_2_1. */
#define BM_IPU_DC_R_LLA1_MCU_RS_R_2_1 (0x00FF0000U) /*!< Bit mask for IPU_DC_R_LLA1_MCU_RS_R_2_1. */
#define BS_IPU_DC_R_LLA1_MCU_RS_R_2_1 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA1_MCU_RS_R_2_1. */

/*! @brief Read current value of the IPU_DC_R_LLA1_MCU_RS_R_2_1 field. */
#define BR_IPU_DC_R_LLA1_MCU_RS_R_2_1(x) (HW_IPU_DC_R_LLA1(x).B.MCU_RS_R_2_1)

/*! @brief Format value for bitfield IPU_DC_R_LLA1_MCU_RS_R_2_1. */
#define BF_IPU_DC_R_LLA1_MCU_RS_R_2_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA1_MCU_RS_R_2_1) & BM_IPU_DC_R_LLA1_MCU_RS_R_2_1)

/*! @brief Set the MCU_RS_R_2_1 field to a new value. */
#define BW_IPU_DC_R_LLA1_MCU_RS_R_2_1(x, v) (HW_IPU_DC_R_LLA1_WR(x, (HW_IPU_DC_R_LLA1_RD(x) & ~BM_IPU_DC_R_LLA1_MCU_RS_R_2_1) | BF_IPU_DC_R_LLA1_MCU_RS_R_2_1(v)))
/*@}*/

/*!
 * @name Register IPU_DC_R_LLA1, field MCU_RS_R_3_1[31:24] (RW)
 *
 * This field holds a pointer in the microcode handling the RS_3 routine for the
 * display defined at DISP_ID_9, when in Read Low level access mode,
 */
/*@{*/
#define BP_IPU_DC_R_LLA1_MCU_RS_R_3_1 (24U) /*!< Bit position for IPU_DC_R_LLA1_MCU_RS_R_3_1. */
#define BM_IPU_DC_R_LLA1_MCU_RS_R_3_1 (0xFF000000U) /*!< Bit mask for IPU_DC_R_LLA1_MCU_RS_R_3_1. */
#define BS_IPU_DC_R_LLA1_MCU_RS_R_3_1 (8U) /*!< Bit field size in bits for IPU_DC_R_LLA1_MCU_RS_R_3_1. */

/*! @brief Read current value of the IPU_DC_R_LLA1_MCU_RS_R_3_1 field. */
#define BR_IPU_DC_R_LLA1_MCU_RS_R_3_1(x) (HW_IPU_DC_R_LLA1(x).B.MCU_RS_R_3_1)

/*! @brief Format value for bitfield IPU_DC_R_LLA1_MCU_RS_R_3_1. */
#define BF_IPU_DC_R_LLA1_MCU_RS_R_3_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_R_LLA1_MCU_RS_R_3_1) & BM_IPU_DC_R_LLA1_MCU_RS_R_3_1)

/*! @brief Set the MCU_RS_R_3_1 field to a new value. */
#define BW_IPU_DC_R_LLA1_MCU_RS_R_3_1(x, v) (HW_IPU_DC_R_LLA1_WR(x, (HW_IPU_DC_R_LLA1_RD(x) & ~BM_IPU_DC_R_LLA1_MCU_RS_R_3_1) | BF_IPU_DC_R_LLA1_MCU_RS_R_3_1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_WR_CH_ADDR_5_ALT - DC Write Channel 5 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_WR_CH_ADDR_5_ALT - DC Write Channel 5 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dc_wr_ch_addr_5_alt
{
    uint32_t U;
    struct _hw_ipu_dc_wr_ch_addr_5_alt_bitfields
    {
        uint32_t ST_ADDR_5_ALT : 29;   /*!< [28:0]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dc_wr_ch_addr_5_alt_t;

/*!
 * @name Constants and macros for entire IPU_DC_WR_CH_ADDR_5_ALT register
 */
/*@{*/
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_ADDR(x) ((uintptr_t)(x) + 0x581C4U)

#define HW_IPU_DC_WR_CH_ADDR_5_ALT(x) (*(__IO hw_ipu_dc_wr_ch_addr_5_alt_t *) HW_IPU_DC_WR_CH_ADDR_5_ALT_ADDR(x))
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_RD(x) (HW_IPU_DC_WR_CH_ADDR_5_ALT(x).U)
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_WR(x, v) (HW_IPU_DC_WR_CH_ADDR_5_ALT(x).U = (v))
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_SET(x, v) (HW_IPU_DC_WR_CH_ADDR_5_ALT_WR(x, HW_IPU_DC_WR_CH_ADDR_5_ALT_RD(x) |  (v)))
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_CLR(x, v) (HW_IPU_DC_WR_CH_ADDR_5_ALT_WR(x, HW_IPU_DC_WR_CH_ADDR_5_ALT_RD(x) & ~(v)))
#define HW_IPU_DC_WR_CH_ADDR_5_ALT_TOG(x, v) (HW_IPU_DC_WR_CH_ADDR_5_ALT_WR(x, HW_IPU_DC_WR_CH_ADDR_5_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DC_WR_CH_ADDR_5_ALT bitfields
 */

/*!
 * @name Register IPU_DC_WR_CH_ADDR_5_ALT, field ST_ADDR_5_ALT[28:0] (RW)
 *
 * This field defines the start address within the display's memory space where
 * the write transactions will be done to for channel #5, when alternate flow is
 * performed via channel #5
 */
/*@{*/
#define BP_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT (0U) /*!< Bit position for IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT. */
#define BM_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT (0x1FFFFFFFU) /*!< Bit mask for IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT. */
#define BS_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT (29U) /*!< Bit field size in bits for IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT. */

/*! @brief Read current value of the IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT field. */
#define BR_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT(x) (HW_IPU_DC_WR_CH_ADDR_5_ALT(x).B.ST_ADDR_5_ALT)

/*! @brief Format value for bitfield IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT. */
#define BF_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT) & BM_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT)

/*! @brief Set the ST_ADDR_5_ALT field to a new value. */
#define BW_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT(x, v) (HW_IPU_DC_WR_CH_ADDR_5_ALT_WR(x, (HW_IPU_DC_WR_CH_ADDR_5_ALT_RD(x) & ~BM_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT) | BF_IPU_DC_WR_CH_ADDR_5_ALT_ST_ADDR_5_ALT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DC_STAT - DC Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DC_STAT - DC Status Register (RO)
 *
 * Reset value: 0x000000AAU
 */
typedef union _hw_ipu_dc_stat
{
    uint32_t U;
    struct _hw_ipu_dc_stat_bitfields
    {
        uint32_t DC_TRIPLE_BUF_CNT_FULL_0 : 1; /*!< [0]  */
        uint32_t DC_TRIPLE_BUF_CNT_EMPTY_0 : 1; /*!< [1]  */
        uint32_t DC_TRIPLE_BUF_DATA_FULL_0 : 1; /*!< [2]  */
        uint32_t DC_TRIPLE_BUF_DATA_EMPTY_0 : 1; /*!< [3]  */
        uint32_t DC_TRIPLE_BUF_CNT_FULL_1 : 1; /*!< [4]  */
        uint32_t DC_TRIPLE_BUF_CNT_EMPTY_1 : 1; /*!< [5]  */
        uint32_t DC_TRIPLE_BUF_DATA_FULL_1 : 1; /*!< [6]  */
        uint32_t DC_TRIPLE_BUF_DATA_EMPTY_1 : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_ipu_dc_stat_t;

/*!
 * @name Constants and macros for entire IPU_DC_STAT register
 */
/*@{*/
#define HW_IPU_DC_STAT_ADDR(x)   ((uintptr_t)(x) + 0x581C8U)

#define HW_IPU_DC_STAT(x)        (*(__I hw_ipu_dc_stat_t *) HW_IPU_DC_STAT_ADDR(x))
#define HW_IPU_DC_STAT_RD(x)     (HW_IPU_DC_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DC_STAT bitfields
 */

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_CNT_FULL_0[0] (RO)
 *
 * This bit indicates a FIFO full state on the DC FIFO accessing DI0 when write
 * to the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0 (0U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0 (0x00000001U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_0(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_CNT_FULL_0)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_CNT_EMPTY_0[1] (RO)
 *
 * This bit indicates a FIFO empty state on the DC FIFO accessing DI0 when write
 * to the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0 (1U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0 (0x00000002U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_0(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_CNT_EMPTY_0)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_DATA_FULL_0[2] (RO)
 *
 * This bit indicates a FIFO full state on the DC FIFO accessing DI0 when read
 * from the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0 (2U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0 (0x00000004U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_0(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_DATA_FULL_0)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_DATA_EMPTY_0[3] (RO)
 *
 * This bit indicates a FIFO empty state on the DC FIFO accessing DI0 when read
 * from the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0 (3U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0 (0x00000008U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_0(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_DATA_EMPTY_0)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_CNT_FULL_1[4] (RO)
 *
 * This bit indicates a FIFO full state on the DC FIFO accessing DI1 when write
 * to the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1 (4U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1 (0x00000010U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_FULL_1(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_CNT_FULL_1)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_CNT_EMPTY_1[5] (RO)
 *
 * This bit indicates a FIFO empty state on the DC FIFO accessing DI1 when write
 * to the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1 (5U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1 (0x00000020U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_CNT_EMPTY_1(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_CNT_EMPTY_1)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_DATA_FULL_1[6] (RO)
 *
 * This bit indicates a FIFO empty state on the DC FIFO accessing DI1 when read
 * from the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1 (6U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1 (0x00000040U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_FULL_1(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_DATA_FULL_1)
/*@}*/

/*!
 * @name Register IPU_DC_STAT, field DC_TRIPLE_BUF_DATA_EMPTY_1[7] (RO)
 *
 * This bit indicates a FIFO full state on the DC FIFO accessing DI1 when write
 * to the display flow is used
 */
/*@{*/
#define BP_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1 (7U) /*!< Bit position for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1. */
#define BM_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1 (0x00000080U) /*!< Bit mask for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1. */
#define BS_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1 (1U) /*!< Bit field size in bits for IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1. */

/*! @brief Read current value of the IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1 field. */
#define BR_IPU_DC_STAT_DC_TRIPLE_BUF_DATA_EMPTY_1(x) (HW_IPU_DC_STAT(x).B.DC_TRIPLE_BUF_DATA_EMPTY_1)
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_RD_CHAN - DMFC Read Channel Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_RD_CHAN - DMFC Read Channel Register (RW)
 *
 * Reset value: 0x00000200U
 */
typedef union _hw_ipu_dmfc_rd_chan
{
    uint32_t U;
    struct _hw_ipu_dmfc_rd_chan_bitfields
    {
        uint32_t RESERVED0 : 6;        /*!< [5:0]  */
        uint32_t dmfc_burst_size_0 : 2; /*!< [7:6]  */
        uint32_t RESERVED1 : 9;        /*!< [16:8]  */
        uint32_t dmfc_wm_en_0 : 1;     /*!< [17]  */
        uint32_t dmfc_wm_set_0 : 3;    /*!< [20:18]  */
        uint32_t dmfc_wm_clr_0 : 3;    /*!< [23:21]  */
        uint32_t dmfc_ppw_c : 2;       /*!< [25:24]  */
        uint32_t RESERVED2 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_dmfc_rd_chan_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_RD_CHAN register
 */
/*@{*/
#define HW_IPU_DMFC_RD_CHAN_ADDR(x) ((uintptr_t)(x) + 0x60000U)

#define HW_IPU_DMFC_RD_CHAN(x)   (*(__IO hw_ipu_dmfc_rd_chan_t *) HW_IPU_DMFC_RD_CHAN_ADDR(x))
#define HW_IPU_DMFC_RD_CHAN_RD(x) (HW_IPU_DMFC_RD_CHAN(x).U)
#define HW_IPU_DMFC_RD_CHAN_WR(x, v) (HW_IPU_DMFC_RD_CHAN(x).U = (v))
#define HW_IPU_DMFC_RD_CHAN_SET(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, HW_IPU_DMFC_RD_CHAN_RD(x) |  (v)))
#define HW_IPU_DMFC_RD_CHAN_CLR(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, HW_IPU_DMFC_RD_CHAN_RD(x) & ~(v)))
#define HW_IPU_DMFC_RD_CHAN_TOG(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, HW_IPU_DMFC_RD_CHAN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_RD_CHAN bitfields
 */

/*!
 * @name Register IPU_DMFC_RD_CHAN, field dmfc_burst_size_0[7:6] (RW)
 *
 * Read burst Size This field defines the burst size of the DMFC's read
 * accesses. This settings must match the settings in the corresponding IDMAC channel's
 * settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, going to the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_RD_CHAN_dmfc_burst_size_0 (6U) /*!< Bit position for IPU_DMFC_RD_CHAN_dmfc_burst_size_0. */
#define BM_IPU_DMFC_RD_CHAN_dmfc_burst_size_0 (0x000000C0U) /*!< Bit mask for IPU_DMFC_RD_CHAN_dmfc_burst_size_0. */
#define BS_IPU_DMFC_RD_CHAN_dmfc_burst_size_0 (2U) /*!< Bit field size in bits for IPU_DMFC_RD_CHAN_dmfc_burst_size_0. */

/*! @brief Read current value of the IPU_DMFC_RD_CHAN_dmfc_burst_size_0 field. */
#define BR_IPU_DMFC_RD_CHAN_dmfc_burst_size_0(x) (HW_IPU_DMFC_RD_CHAN(x).B.dmfc_burst_size_0)

/*! @brief Format value for bitfield IPU_DMFC_RD_CHAN_dmfc_burst_size_0. */
#define BF_IPU_DMFC_RD_CHAN_dmfc_burst_size_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_RD_CHAN_dmfc_burst_size_0) & BM_IPU_DMFC_RD_CHAN_dmfc_burst_size_0)

/*! @brief Set the dmfc_burst_size_0 field to a new value. */
#define BW_IPU_DMFC_RD_CHAN_dmfc_burst_size_0(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, (HW_IPU_DMFC_RD_CHAN_RD(x) & ~BM_IPU_DMFC_RD_CHAN_dmfc_burst_size_0) | BF_IPU_DMFC_RD_CHAN_dmfc_burst_size_0(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_RD_CHAN, field dmfc_wm_en_0[17] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_RD_CHAN_dmfc_wm_en_0 (17U) /*!< Bit position for IPU_DMFC_RD_CHAN_dmfc_wm_en_0. */
#define BM_IPU_DMFC_RD_CHAN_dmfc_wm_en_0 (0x00020000U) /*!< Bit mask for IPU_DMFC_RD_CHAN_dmfc_wm_en_0. */
#define BS_IPU_DMFC_RD_CHAN_dmfc_wm_en_0 (1U) /*!< Bit field size in bits for IPU_DMFC_RD_CHAN_dmfc_wm_en_0. */

/*! @brief Read current value of the IPU_DMFC_RD_CHAN_dmfc_wm_en_0 field. */
#define BR_IPU_DMFC_RD_CHAN_dmfc_wm_en_0(x) (HW_IPU_DMFC_RD_CHAN(x).B.dmfc_wm_en_0)

/*! @brief Format value for bitfield IPU_DMFC_RD_CHAN_dmfc_wm_en_0. */
#define BF_IPU_DMFC_RD_CHAN_dmfc_wm_en_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_RD_CHAN_dmfc_wm_en_0) & BM_IPU_DMFC_RD_CHAN_dmfc_wm_en_0)

/*! @brief Set the dmfc_wm_en_0 field to a new value. */
#define BW_IPU_DMFC_RD_CHAN_dmfc_wm_en_0(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, (HW_IPU_DMFC_RD_CHAN_RD(x) & ~BM_IPU_DMFC_RD_CHAN_dmfc_wm_en_0) | BF_IPU_DMFC_RD_CHAN_dmfc_wm_en_0(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_RD_CHAN, field dmfc_wm_set_0[20:18] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC read FIFO.
 * Crossing this level will send the watermark signal to the IDMAC. The WM level
 * is the amount of free bursts at the FIFO (dmfc_wm_clr_0 > dmfc_wm_set_0)
 */
/*@{*/
#define BP_IPU_DMFC_RD_CHAN_dmfc_wm_set_0 (18U) /*!< Bit position for IPU_DMFC_RD_CHAN_dmfc_wm_set_0. */
#define BM_IPU_DMFC_RD_CHAN_dmfc_wm_set_0 (0x001C0000U) /*!< Bit mask for IPU_DMFC_RD_CHAN_dmfc_wm_set_0. */
#define BS_IPU_DMFC_RD_CHAN_dmfc_wm_set_0 (3U) /*!< Bit field size in bits for IPU_DMFC_RD_CHAN_dmfc_wm_set_0. */

/*! @brief Read current value of the IPU_DMFC_RD_CHAN_dmfc_wm_set_0 field. */
#define BR_IPU_DMFC_RD_CHAN_dmfc_wm_set_0(x) (HW_IPU_DMFC_RD_CHAN(x).B.dmfc_wm_set_0)

/*! @brief Format value for bitfield IPU_DMFC_RD_CHAN_dmfc_wm_set_0. */
#define BF_IPU_DMFC_RD_CHAN_dmfc_wm_set_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_RD_CHAN_dmfc_wm_set_0) & BM_IPU_DMFC_RD_CHAN_dmfc_wm_set_0)

/*! @brief Set the dmfc_wm_set_0 field to a new value. */
#define BW_IPU_DMFC_RD_CHAN_dmfc_wm_set_0(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, (HW_IPU_DMFC_RD_CHAN_RD(x) & ~BM_IPU_DMFC_RD_CHAN_dmfc_wm_set_0) | BF_IPU_DMFC_RD_CHAN_dmfc_wm_set_0(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_RD_CHAN, field dmfc_wm_clr_0[23:21] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC read
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of free bursts at the FIFO (dmfc_wm_clr_0 > dmfc_wm_set_0)
 */
/*@{*/
#define BP_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0 (21U) /*!< Bit position for IPU_DMFC_RD_CHAN_dmfc_wm_clr_0. */
#define BM_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0 (0x00E00000U) /*!< Bit mask for IPU_DMFC_RD_CHAN_dmfc_wm_clr_0. */
#define BS_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0 (3U) /*!< Bit field size in bits for IPU_DMFC_RD_CHAN_dmfc_wm_clr_0. */

/*! @brief Read current value of the IPU_DMFC_RD_CHAN_dmfc_wm_clr_0 field. */
#define BR_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0(x) (HW_IPU_DMFC_RD_CHAN(x).B.dmfc_wm_clr_0)

/*! @brief Format value for bitfield IPU_DMFC_RD_CHAN_dmfc_wm_clr_0. */
#define BF_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0) & BM_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0)

/*! @brief Set the dmfc_wm_clr_0 field to a new value. */
#define BW_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, (HW_IPU_DMFC_RD_CHAN_RD(x) & ~BM_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0) | BF_IPU_DMFC_RD_CHAN_dmfc_wm_clr_0(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_RD_CHAN, field dmfc_ppw_c[25:24] (RW)
 *
 * Pixel Per Word coded. This field defines the size of the read data from the
 * display.
 *
 * Values:
 * - 00 - 8 bit per pixel
 * - 01 - 16 bit per pixel
 * - 10 - 24 (rgb) bit per pixel or 32 bit per pixel
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DMFC_RD_CHAN_dmfc_ppw_c (24U) /*!< Bit position for IPU_DMFC_RD_CHAN_dmfc_ppw_c. */
#define BM_IPU_DMFC_RD_CHAN_dmfc_ppw_c (0x03000000U) /*!< Bit mask for IPU_DMFC_RD_CHAN_dmfc_ppw_c. */
#define BS_IPU_DMFC_RD_CHAN_dmfc_ppw_c (2U) /*!< Bit field size in bits for IPU_DMFC_RD_CHAN_dmfc_ppw_c. */

/*! @brief Read current value of the IPU_DMFC_RD_CHAN_dmfc_ppw_c field. */
#define BR_IPU_DMFC_RD_CHAN_dmfc_ppw_c(x) (HW_IPU_DMFC_RD_CHAN(x).B.dmfc_ppw_c)

/*! @brief Format value for bitfield IPU_DMFC_RD_CHAN_dmfc_ppw_c. */
#define BF_IPU_DMFC_RD_CHAN_dmfc_ppw_c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_RD_CHAN_dmfc_ppw_c) & BM_IPU_DMFC_RD_CHAN_dmfc_ppw_c)

/*! @brief Set the dmfc_ppw_c field to a new value. */
#define BW_IPU_DMFC_RD_CHAN_dmfc_ppw_c(x, v) (HW_IPU_DMFC_RD_CHAN_WR(x, (HW_IPU_DMFC_RD_CHAN_RD(x) & ~BM_IPU_DMFC_RD_CHAN_dmfc_ppw_c) | BF_IPU_DMFC_RD_CHAN_dmfc_ppw_c(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_WR_CHAN - DMFC Write Channel Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_WR_CHAN - DMFC Write Channel Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_wr_chan
{
    uint32_t U;
    struct _hw_ipu_dmfc_wr_chan_bitfields
    {
        uint32_t dmfc_st_addr_1 : 3;   /*!< [2:0]  */
        uint32_t dmfc_fifo_size_1 : 3; /*!< [5:3]  */
        uint32_t dmfc_burst_size_1 : 2; /*!< [7:6]  */
        uint32_t dmfc_st_addr_2 : 3;   /*!< [10:8]  */
        uint32_t dmfc_fifo_size_2 : 3; /*!< [13:11]  */
        uint32_t dmfc_burst_size_2 : 2; /*!< [15:14]  */
        uint32_t dmfc_st_addr_1c : 3;  /*!< [18:16]  */
        uint32_t dmfc_fifo_size_1c : 3; /*!< [21:19]  */
        uint32_t dmfc_burst_size_1c : 2; /*!< [23:22]  */
        uint32_t dmfc_st_addr_2c : 3;  /*!< [26:24]  */
        uint32_t dmfc_fifo_size_2c : 3; /*!< [29:27]  */
        uint32_t dmfc_burst_size_2c : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dmfc_wr_chan_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_WR_CHAN register
 */
/*@{*/
#define HW_IPU_DMFC_WR_CHAN_ADDR(x) ((uintptr_t)(x) + 0x60004U)

#define HW_IPU_DMFC_WR_CHAN(x)   (*(__IO hw_ipu_dmfc_wr_chan_t *) HW_IPU_DMFC_WR_CHAN_ADDR(x))
#define HW_IPU_DMFC_WR_CHAN_RD(x) (HW_IPU_DMFC_WR_CHAN(x).U)
#define HW_IPU_DMFC_WR_CHAN_WR(x, v) (HW_IPU_DMFC_WR_CHAN(x).U = (v))
#define HW_IPU_DMFC_WR_CHAN_SET(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, HW_IPU_DMFC_WR_CHAN_RD(x) |  (v)))
#define HW_IPU_DMFC_WR_CHAN_CLR(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, HW_IPU_DMFC_WR_CHAN_RD(x) & ~(v)))
#define HW_IPU_DMFC_WR_CHAN_TOG(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, HW_IPU_DMFC_WR_CHAN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_WR_CHAN bitfields
 */

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_st_addr_1[2:0] (RW)
 *
 * DMFC Start Address for IDMAC's channel 28 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 28. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_1 (0U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_st_addr_1. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1 (0x00000007U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_st_addr_1. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_st_addr_1 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_st_addr_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_st_addr_1 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_st_addr_1(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_st_addr_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_st_addr_1. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_1) & BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1)

/*! @brief Set the dmfc_st_addr_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_st_addr_1(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1) | BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_fifo_size_1[5:3] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 28 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 28
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1 (3U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1 (0x00000038U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_fifo_size_1 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_fifo_size_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_fifo_size_1. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1) & BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1)

/*! @brief Set the dmfc_fifo_size_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1) | BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_burst_size_1[7:6] (RW)
 *
 * Burst size of IDMAC's channel 28 This field defines the burst size of the
 * IDMAC's channel 28 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 1hbit
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_1 (6U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_burst_size_1. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1 (0x000000C0U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_burst_size_1. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_burst_size_1 (2U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_burst_size_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_burst_size_1 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_burst_size_1(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_burst_size_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_burst_size_1. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_1) & BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1)

/*! @brief Set the dmfc_burst_size_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_burst_size_1(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1) | BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_st_addr_2[10:8] (RW)
 *
 * DMFC Start Address for IDMAC's channel 41 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 41. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_2 (8U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_st_addr_2. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2 (0x00000700U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_st_addr_2. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_st_addr_2 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_st_addr_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_st_addr_2 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_st_addr_2(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_st_addr_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_st_addr_2. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_2) & BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2)

/*! @brief Set the dmfc_st_addr_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_st_addr_2(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2) | BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_fifo_size_2[13:11] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 41 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 41
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2 (11U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2 (0x00003800U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_fifo_size_2 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_fifo_size_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_fifo_size_2. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2) & BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2)

/*! @brief Set the dmfc_fifo_size_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2) | BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_burst_size_2[15:14] (RW)
 *
 * Burst size of IDMAC's channel 41 This field defines the burst size of the
 * IDMAC's channel 41 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_2 (14U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_burst_size_2. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2 (0x0000C000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_burst_size_2. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_burst_size_2 (2U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_burst_size_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_burst_size_2 field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_burst_size_2(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_burst_size_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_burst_size_2. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_2) & BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2)

/*! @brief Set the dmfc_burst_size_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_burst_size_2(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2) | BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_st_addr_1c[18:16] (RW)
 *
 * DMFC Start Address for IDMAC's channel 42 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 42. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c (16U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_st_addr_1c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c (0x00070000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_st_addr_1c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_st_addr_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_st_addr_1c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_st_addr_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_st_addr_1c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c) & BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c)

/*! @brief Set the dmfc_st_addr_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c) | BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_fifo_size_1c[21:19] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 42 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 42
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c (19U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c (0x00380000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_fifo_size_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c) & BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c)

/*! @brief Set the dmfc_fifo_size_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c) | BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_burst_size_1c[23:22] (RW)
 *
 * Burst size of IDMAC's channel 42 This field defines the burst size of the
 * IDMAC's channel 42 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c (22U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_burst_size_1c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c (0x00C00000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_burst_size_1c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c (2U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_burst_size_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_burst_size_1c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_burst_size_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_burst_size_1c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c) & BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c)

/*! @brief Set the dmfc_burst_size_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c) | BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_st_addr_2c[26:24] (RW)
 *
 * DMFC Start Address for IDMAC's channel 43 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 43. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c (24U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_st_addr_2c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c (0x07000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_st_addr_2c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_st_addr_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_st_addr_2c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_st_addr_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_st_addr_2c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c) & BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c)

/*! @brief Set the dmfc_st_addr_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c) | BF_IPU_DMFC_WR_CHAN_dmfc_st_addr_2c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_fifo_size_2c[29:27] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 43 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 43
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c (27U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c (0x38000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_fifo_size_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c) & BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c)

/*! @brief Set the dmfc_fifo_size_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c) | BF_IPU_DMFC_WR_CHAN_dmfc_fifo_size_2c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN, field dmfc_burst_size_2c[31:30] (RW)
 *
 * Burst size of IDMAC's channel 43 This field defines the burst size of the
 * IDMAC's channel 43 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c (30U) /*!< Bit position for IPU_DMFC_WR_CHAN_dmfc_burst_size_2c. */
#define BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c (0xC0000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_dmfc_burst_size_2c. */
#define BS_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c (2U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_dmfc_burst_size_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_dmfc_burst_size_2c field. */
#define BR_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c(x) (HW_IPU_DMFC_WR_CHAN(x).B.dmfc_burst_size_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_dmfc_burst_size_2c. */
#define BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c) & BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c)

/*! @brief Set the dmfc_burst_size_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c(x, v) (HW_IPU_DMFC_WR_CHAN_WR(x, (HW_IPU_DMFC_WR_CHAN_RD(x) & ~BM_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c) | BF_IPU_DMFC_WR_CHAN_dmfc_burst_size_2c(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_WR_CHAN_DEF - DMFC Write Channel Definition Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_WR_CHAN_DEF - DMFC Write Channel Definition Register (RW)
 *
 * Reset value: 0x20202020U
 */
typedef union _hw_ipu_dmfc_wr_chan_def
{
    uint32_t U;
    struct _hw_ipu_dmfc_wr_chan_def_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t dmfc_wm_en_1 : 1;     /*!< [1]  */
        uint32_t dmfc_wm_set_1 : 3;    /*!< [4:2]  */
        uint32_t dmfc_wm_clr_1 : 3;    /*!< [7:5]  */
        uint32_t RESERVED1 : 1;        /*!< [8]  */
        uint32_t dmfc_wm_en_2 : 1;     /*!< [9]  */
        uint32_t dmfc_wm_set_2 : 3;    /*!< [12:10]  */
        uint32_t dmfc_wm_clr_2 : 3;    /*!< [15:13]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t dmfc_wm_en_1c : 1;    /*!< [17]  */
        uint32_t dmfc_wm_set_1c : 3;   /*!< [20:18]  */
        uint32_t dmfc_wm_clr_1c : 3;   /*!< [23:21]  */
        uint32_t RESERVED3 : 1;        /*!< [24]  */
        uint32_t dmfc_wm_en_2c : 1;    /*!< [25]  */
        uint32_t dmfc_wm_set_2c : 3;   /*!< [28:26]  */
        uint32_t dmfc_wm_clr_2c : 3;   /*!< [31:29]  */
    } B;
} hw_ipu_dmfc_wr_chan_def_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_WR_CHAN_DEF register
 */
/*@{*/
#define HW_IPU_DMFC_WR_CHAN_DEF_ADDR(x) ((uintptr_t)(x) + 0x60008U)

#define HW_IPU_DMFC_WR_CHAN_DEF(x) (*(__IO hw_ipu_dmfc_wr_chan_def_t *) HW_IPU_DMFC_WR_CHAN_DEF_ADDR(x))
#define HW_IPU_DMFC_WR_CHAN_DEF_RD(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).U)
#define HW_IPU_DMFC_WR_CHAN_DEF_WR(x, v) (HW_IPU_DMFC_WR_CHAN_DEF(x).U = (v))
#define HW_IPU_DMFC_WR_CHAN_DEF_SET(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_RD(x) |  (v)))
#define HW_IPU_DMFC_WR_CHAN_DEF_CLR(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~(v)))
#define HW_IPU_DMFC_WR_CHAN_DEF_TOG(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_WR_CHAN_DEF bitfields
 */

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_en_1[1] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1 (1U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1 (0x00000002U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1 (1U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_en_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1)

/*! @brief Set the dmfc_wm_en_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_set_1[4:2] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1 (2U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1 (0x0000001CU) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_set_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1)

/*! @brief Set the dmfc_wm_set_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_clr_1[7:5] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1 (5U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1 (0x000000E0U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_clr_1)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1)

/*! @brief Set the dmfc_wm_clr_1 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_en_2[9] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2 (9U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2 (0x00000200U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2 (1U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_en_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2)

/*! @brief Set the dmfc_wm_en_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_set_2[12:10] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2 (10U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2 (0x00001C00U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_set_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2)

/*! @brief Set the dmfc_wm_set_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_clr_2[15:13] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2 (13U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2 (0x0000E000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2 (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2 field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_clr_2)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2)

/*! @brief Set the dmfc_wm_clr_2 field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_en_1c[17] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c (17U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c (0x00020000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c (1U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_en_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c)

/*! @brief Set the dmfc_wm_en_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_set_1c[20:18] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c (18U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c (0x001C0000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_set_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c)

/*! @brief Set the dmfc_wm_set_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_clr_1c[23:21] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c (21U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c (0x00E00000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_clr_1c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c)

/*! @brief Set the dmfc_wm_clr_1c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_1c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_en_2c[25] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c (25U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c (0x02000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c (1U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_en_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c)

/*! @brief Set the dmfc_wm_en_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_en_2c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_set_2c[28:26] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c (26U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c (0x1C000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_set_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c)

/*! @brief Set the dmfc_wm_set_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_set_2c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF, field dmfc_wm_clr_2c[31:29] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c (29U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c. */
#define BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c (0xE0000000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c. */
#define BS_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c(x) (HW_IPU_DMFC_WR_CHAN_DEF(x).B.dmfc_wm_clr_2c)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c. */
#define BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c) & BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c)

/*! @brief Set the dmfc_wm_clr_2c field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c) | BF_IPU_DMFC_WR_CHAN_DEF_dmfc_wm_clr_2c(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_DP_CHAN - DMFC Display Processor Channel Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_DP_CHAN - DMFC Display Processor Channel Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_dp_chan
{
    uint32_t U;
    struct _hw_ipu_dmfc_dp_chan_bitfields
    {
        uint32_t dmfc_st_addr_5b : 3;  /*!< [2:0]  */
        uint32_t dmfc_fifo_size_5b : 3; /*!< [5:3]  */
        uint32_t dmfc_burst_size_5b : 2; /*!< [7:6]  */
        uint32_t dmfc_st_addr_5f : 3;  /*!< [10:8]  */
        uint32_t dmfc_fifo_size_5f : 3; /*!< [13:11]  */
        uint32_t dmfc_burst_size_5f : 2; /*!< [15:14]  */
        uint32_t dmfc_st_addr_6b : 3;  /*!< [18:16]  */
        uint32_t dmfc_fifo_size_6b : 3; /*!< [21:19]  */
        uint32_t dmfc_burst_size_6b : 2; /*!< [23:22]  */
        uint32_t dmfc_st_addr_6f : 3;  /*!< [26:24]  */
        uint32_t dmfc_fifo_size_6f : 3; /*!< [29:27]  */
        uint32_t dmfc_burst_size_6f : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dmfc_dp_chan_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_DP_CHAN register
 */
/*@{*/
#define HW_IPU_DMFC_DP_CHAN_ADDR(x) ((uintptr_t)(x) + 0x6000CU)

#define HW_IPU_DMFC_DP_CHAN(x)   (*(__IO hw_ipu_dmfc_dp_chan_t *) HW_IPU_DMFC_DP_CHAN_ADDR(x))
#define HW_IPU_DMFC_DP_CHAN_RD(x) (HW_IPU_DMFC_DP_CHAN(x).U)
#define HW_IPU_DMFC_DP_CHAN_WR(x, v) (HW_IPU_DMFC_DP_CHAN(x).U = (v))
#define HW_IPU_DMFC_DP_CHAN_SET(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, HW_IPU_DMFC_DP_CHAN_RD(x) |  (v)))
#define HW_IPU_DMFC_DP_CHAN_CLR(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, HW_IPU_DMFC_DP_CHAN_RD(x) & ~(v)))
#define HW_IPU_DMFC_DP_CHAN_TOG(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, HW_IPU_DMFC_DP_CHAN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_DP_CHAN bitfields
 */

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_st_addr_5b[2:0] (RW)
 *
 * DMFC Start Address for IDMAC's channel 23 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 23. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b (0U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_st_addr_5b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b (0x00000007U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_st_addr_5b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_st_addr_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_st_addr_5b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_st_addr_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_st_addr_5b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b) & BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b)

/*! @brief Set the dmfc_st_addr_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b) | BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_fifo_size_5b[5:3] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 23 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 23
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b (3U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b (0x00000038U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_fifo_size_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b) & BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b)

/*! @brief Set the dmfc_fifo_size_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b) | BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_burst_size_5b[7:6] (RW)
 *
 * Burst size of IDMAC's channel 23 This field defines the burst size of the
 * IDMAC's channel 23 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b (6U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_burst_size_5b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b (0x000000C0U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_burst_size_5b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_burst_size_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_burst_size_5b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_burst_size_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_burst_size_5b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b) & BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b)

/*! @brief Set the dmfc_burst_size_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b) | BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_st_addr_5f[10:8] (RW)
 *
 * DMFC Start Address for IDMAC's channel 27 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 27. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f (8U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_st_addr_5f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f (0x00000700U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_st_addr_5f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_st_addr_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_st_addr_5f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_st_addr_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_st_addr_5f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f) & BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f)

/*! @brief Set the dmfc_st_addr_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f) | BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_fifo_size_5f[13:11] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 27 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 27
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f (11U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f (0x00003800U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_fifo_size_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f) & BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f)

/*! @brief Set the dmfc_fifo_size_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f) | BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_burst_size_5f[15:14] (RW)
 *
 * Burst size of IDMAC's channel 27 This field defines the burst size of the
 * IDMAC's channel 27 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f (14U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_burst_size_5f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f (0x0000C000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_burst_size_5f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_burst_size_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_burst_size_5f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_burst_size_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_burst_size_5f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f) & BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f)

/*! @brief Set the dmfc_burst_size_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f) | BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_st_addr_6b[18:16] (RW)
 *
 * DMFC Start Address for IDMAC's channel 24 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 24. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b (16U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_st_addr_6b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b (0x00070000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_st_addr_6b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_st_addr_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_st_addr_6b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_st_addr_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_st_addr_6b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b) & BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b)

/*! @brief Set the dmfc_st_addr_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b) | BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_fifo_size_6b[21:19] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 24 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 24
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b (19U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b (0x00380000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_fifo_size_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b) & BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b)

/*! @brief Set the dmfc_fifo_size_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b) | BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_burst_size_6b[23:22] (RW)
 *
 * Burst size of IDMAC's channel 24 This field defines the burst size of the
 * IDMAC's channel 24 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b (22U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_burst_size_6b. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b (0x00C00000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_burst_size_6b. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_burst_size_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_burst_size_6b field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_burst_size_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_burst_size_6b. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b) & BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b)

/*! @brief Set the dmfc_burst_size_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b) | BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_st_addr_6f[26:24] (RW)
 *
 * DMFC Start Address for IDMAC's channel 29 This field defines the base address
 * at the DMFC's FIFO of the partition allocated to the channel connected to
 * IDMAC's channel 29. The FIFO is partitioned to 8 equal segments. Each segment is
 * 64X128 words The value of this field is the number of the segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f (24U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_st_addr_6f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f (0x07000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_st_addr_6f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_st_addr_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_st_addr_6f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_st_addr_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_st_addr_6f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f) & BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f)

/*! @brief Set the dmfc_st_addr_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f) | BF_IPU_DMFC_DP_CHAN_dmfc_st_addr_6f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_fifo_size_6f[29:27] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 29 This field defines the FIFO partition
 * for the DMFC channel connected to IDMAC's channel 29
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f (27U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f (0x38000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_fifo_size_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f) & BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f)

/*! @brief Set the dmfc_fifo_size_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f) | BF_IPU_DMFC_DP_CHAN_dmfc_fifo_size_6f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN, field dmfc_burst_size_6f[31:30] (RW)
 *
 * Burst size of IDMAC's channel 29 This field defines the burst size of the
 * IDMAC's channel 29 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f (30U) /*!< Bit position for IPU_DMFC_DP_CHAN_dmfc_burst_size_6f. */
#define BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f (0xC0000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_dmfc_burst_size_6f. */
#define BS_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_dmfc_burst_size_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_dmfc_burst_size_6f field. */
#define BR_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f(x) (HW_IPU_DMFC_DP_CHAN(x).B.dmfc_burst_size_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_dmfc_burst_size_6f. */
#define BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f) & BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f)

/*! @brief Set the dmfc_burst_size_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f(x, v) (HW_IPU_DMFC_DP_CHAN_WR(x, (HW_IPU_DMFC_DP_CHAN_RD(x) & ~BM_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f) | BF_IPU_DMFC_DP_CHAN_dmfc_burst_size_6f(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_DP_CHAN_DEF - DMFC Display Processor Channel Definition Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_DP_CHAN_DEF - DMFC Display Processor Channel Definition Register (RW)
 *
 * Reset value: 0x20202020U
 */
typedef union _hw_ipu_dmfc_dp_chan_def
{
    uint32_t U;
    struct _hw_ipu_dmfc_dp_chan_def_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t dmfc_wm_en_5b : 1;    /*!< [1]  */
        uint32_t dmfc_wm_set_5b : 3;   /*!< [4:2]  */
        uint32_t dmfc_wm_clr_5b : 3;   /*!< [7:5]  */
        uint32_t RESERVED1 : 1;        /*!< [8]  */
        uint32_t dmfc_wm_en_5f : 1;    /*!< [9]  */
        uint32_t dmfc_wm_set_5f : 3;   /*!< [12:10]  */
        uint32_t dmfc_wm_clr_5f : 3;   /*!< [15:13]  */
        uint32_t RESERVED2 : 1;        /*!< [16]  */
        uint32_t dmfc_wm_en_6b : 1;    /*!< [17]  */
        uint32_t dmfc_wm_set_6b : 3;   /*!< [20:18]  */
        uint32_t dmfc_wm_clr_6b : 3;   /*!< [23:21]  */
        uint32_t RESERVED3 : 1;        /*!< [24]  */
        uint32_t dmfc_wm_en_6f : 1;    /*!< [25]  */
        uint32_t dmfc_wm_set_6f : 3;   /*!< [28:26]  */
        uint32_t dmfc_wm_clr_6f : 3;   /*!< [31:29]  */
    } B;
} hw_ipu_dmfc_dp_chan_def_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_DP_CHAN_DEF register
 */
/*@{*/
#define HW_IPU_DMFC_DP_CHAN_DEF_ADDR(x) ((uintptr_t)(x) + 0x60010U)

#define HW_IPU_DMFC_DP_CHAN_DEF(x) (*(__IO hw_ipu_dmfc_dp_chan_def_t *) HW_IPU_DMFC_DP_CHAN_DEF_ADDR(x))
#define HW_IPU_DMFC_DP_CHAN_DEF_RD(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).U)
#define HW_IPU_DMFC_DP_CHAN_DEF_WR(x, v) (HW_IPU_DMFC_DP_CHAN_DEF(x).U = (v))
#define HW_IPU_DMFC_DP_CHAN_DEF_SET(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_RD(x) |  (v)))
#define HW_IPU_DMFC_DP_CHAN_DEF_CLR(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~(v)))
#define HW_IPU_DMFC_DP_CHAN_DEF_TOG(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_DP_CHAN_DEF bitfields
 */

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_en_5b[1] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b (1U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b (0x00000002U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_en_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b)

/*! @brief Set the dmfc_wm_en_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_set_5b[4:2] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b (2U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b (0x0000001CU) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_set_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b)

/*! @brief Set the dmfc_wm_set_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_clr_5b[7:5] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b (5U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b (0x000000E0U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_clr_5b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b)

/*! @brief Set the dmfc_wm_clr_5b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_en_5f[9] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f (9U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f (0x00000200U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_en_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f)

/*! @brief Set the dmfc_wm_en_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_set_5f[12:10] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f (10U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f (0x00001C00U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_set_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f)

/*! @brief Set the dmfc_wm_set_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_clr_5f[15:13] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f (13U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f (0x0000E000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_clr_5f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f)

/*! @brief Set the dmfc_wm_clr_5f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_5f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_en_6b[17] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b (17U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b (0x00020000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_en_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b)

/*! @brief Set the dmfc_wm_en_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_set_6b[20:18] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b (18U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b (0x001C0000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_set_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b)

/*! @brief Set the dmfc_wm_set_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_clr_6b[23:21] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b (21U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b (0x00E00000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_clr_6b)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b)

/*! @brief Set the dmfc_wm_clr_6b field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6b(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_en_6f[25] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f (25U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f (0x02000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_en_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f)

/*! @brief Set the dmfc_wm_en_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_en_6f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_set_6f[28:26] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f (26U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f (0x1C000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_set_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f)

/*! @brief Set the dmfc_wm_set_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_set_6f(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF, field dmfc_wm_clr_6f[31:29] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f (29U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f. */
#define BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f (0xE0000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f. */
#define BS_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f(x) (HW_IPU_DMFC_DP_CHAN_DEF(x).B.dmfc_wm_clr_6f)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f. */
#define BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f) & BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f)

/*! @brief Set the dmfc_wm_clr_6f field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f) | BF_IPU_DMFC_DP_CHAN_DEF_dmfc_wm_clr_6f(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_GENERAL_1 - DMFC General 1 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_GENERAL_1 - DMFC General 1 Register (RW)
 *
 * Reset value: 0x00000003U
 */
typedef union _hw_ipu_dmfc_general_1
{
    uint32_t U;
    struct _hw_ipu_dmfc_general_1_bitfields
    {
        uint32_t dmfc_dcdp_sync_pr : 2; /*!< [1:0]  */
        uint32_t RESERVED0 : 3;        /*!< [4:2]  */
        uint32_t dmfc_burst_size_9 : 2; /*!< [6:5]  */
        uint32_t RESERVED1 : 2;        /*!< [8:7]  */
        uint32_t dmfc_wm_en_9 : 1;     /*!< [9]  */
        uint32_t dmfc_wm_set_9 : 3;    /*!< [12:10]  */
        uint32_t dmfc_wm_clr_9 : 3;    /*!< [15:13]  */
        uint32_t WAIT4EOT_1 : 1;       /*!< [16]  */
        uint32_t WAIT4EOT_2 : 1;       /*!< [17]  */
        uint32_t WAIT4EOT_3 : 1;       /*!< [18]  */
        uint32_t WAIT4EOT_4 : 1;       /*!< [19]  */
        uint32_t WAIT4EOT_5B : 1;      /*!< [20]  */
        uint32_t WAIT4EOT_5F : 1;      /*!< [21]  */
        uint32_t WAIT4EOT_6B : 1;      /*!< [22]  */
        uint32_t WAIT4EOT_6F : 1;      /*!< [23]  */
        uint32_t WAIT4EOT_9 : 1;       /*!< [24]  */
        uint32_t RESERVED2 : 7;        /*!< [31:25]  */
    } B;
} hw_ipu_dmfc_general_1_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_GENERAL_1 register
 */
/*@{*/
#define HW_IPU_DMFC_GENERAL_1_ADDR(x) ((uintptr_t)(x) + 0x60014U)

#define HW_IPU_DMFC_GENERAL_1(x) (*(__IO hw_ipu_dmfc_general_1_t *) HW_IPU_DMFC_GENERAL_1_ADDR(x))
#define HW_IPU_DMFC_GENERAL_1_RD(x) (HW_IPU_DMFC_GENERAL_1(x).U)
#define HW_IPU_DMFC_GENERAL_1_WR(x, v) (HW_IPU_DMFC_GENERAL_1(x).U = (v))
#define HW_IPU_DMFC_GENERAL_1_SET(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, HW_IPU_DMFC_GENERAL_1_RD(x) |  (v)))
#define HW_IPU_DMFC_GENERAL_1_CLR(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, HW_IPU_DMFC_GENERAL_1_RD(x) & ~(v)))
#define HW_IPU_DMFC_GENERAL_1_TOG(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, HW_IPU_DMFC_GENERAL_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_GENERAL_1 bitfields
 */

/*!
 * @name Register IPU_DMFC_GENERAL_1, field dmfc_dcdp_sync_pr[1:0] (RW)
 *
 * DMFC's memory access priority settings for simultaneous synchronous flows
 * from DC & DP
 *
 * Values:
 * - 00 - Forbidden - should not be used.
 * - 01 - DC has higher priority over DP
 * - 10 - DP has higher priority over DC
 * - 11 - Round Robin
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr (0U) /*!< Bit position for IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr. */
#define BM_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr (0x00000003U) /*!< Bit mask for IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr. */
#define BS_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr (2U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr field. */
#define BR_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr(x) (HW_IPU_DMFC_GENERAL_1(x).B.dmfc_dcdp_sync_pr)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr. */
#define BF_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr) & BM_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr)

/*! @brief Set the dmfc_dcdp_sync_pr field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr) | BF_IPU_DMFC_GENERAL_1_dmfc_dcdp_sync_pr(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field dmfc_burst_size_9[6:5] (RW)
 *
 * Burst size of IDMAC's channel 44 This field defines the burst size of the
 * IDMAC's channel 44 write accesses. This settings must match the settings in the
 * corresponding IDMAC channel's settings. This channel is targeted for MASK - the
 * FIFO size is always 32X128; The base address is always the upper half of the
 * 8th segment
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_dmfc_burst_size_9 (5U) /*!< Bit position for IPU_DMFC_GENERAL_1_dmfc_burst_size_9. */
#define BM_IPU_DMFC_GENERAL_1_dmfc_burst_size_9 (0x00000060U) /*!< Bit mask for IPU_DMFC_GENERAL_1_dmfc_burst_size_9. */
#define BS_IPU_DMFC_GENERAL_1_dmfc_burst_size_9 (2U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_dmfc_burst_size_9. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_dmfc_burst_size_9 field. */
#define BR_IPU_DMFC_GENERAL_1_dmfc_burst_size_9(x) (HW_IPU_DMFC_GENERAL_1(x).B.dmfc_burst_size_9)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_dmfc_burst_size_9. */
#define BF_IPU_DMFC_GENERAL_1_dmfc_burst_size_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_dmfc_burst_size_9) & BM_IPU_DMFC_GENERAL_1_dmfc_burst_size_9)

/*! @brief Set the dmfc_burst_size_9 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_dmfc_burst_size_9(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_dmfc_burst_size_9) | BF_IPU_DMFC_GENERAL_1_dmfc_burst_size_9(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field dmfc_wm_en_9[9] (RW)
 *
 * Watermark enable. This bit enables the watermark feature of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_dmfc_wm_en_9 (9U) /*!< Bit position for IPU_DMFC_GENERAL_1_dmfc_wm_en_9. */
#define BM_IPU_DMFC_GENERAL_1_dmfc_wm_en_9 (0x00000200U) /*!< Bit mask for IPU_DMFC_GENERAL_1_dmfc_wm_en_9. */
#define BS_IPU_DMFC_GENERAL_1_dmfc_wm_en_9 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_dmfc_wm_en_9. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_dmfc_wm_en_9 field. */
#define BR_IPU_DMFC_GENERAL_1_dmfc_wm_en_9(x) (HW_IPU_DMFC_GENERAL_1(x).B.dmfc_wm_en_9)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_dmfc_wm_en_9. */
#define BF_IPU_DMFC_GENERAL_1_dmfc_wm_en_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_dmfc_wm_en_9) & BM_IPU_DMFC_GENERAL_1_dmfc_wm_en_9)

/*! @brief Set the dmfc_wm_en_9 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_dmfc_wm_en_9(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_dmfc_wm_en_9) | BF_IPU_DMFC_GENERAL_1_dmfc_wm_en_9(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field dmfc_wm_set_9[12:10] (RW)
 *
 * Watermark Set This field defines the watermark's level of the DMFC write
 * FIFO. Crossing this level will send the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_dmfc_wm_set_9 (10U) /*!< Bit position for IPU_DMFC_GENERAL_1_dmfc_wm_set_9. */
#define BM_IPU_DMFC_GENERAL_1_dmfc_wm_set_9 (0x00001C00U) /*!< Bit mask for IPU_DMFC_GENERAL_1_dmfc_wm_set_9. */
#define BS_IPU_DMFC_GENERAL_1_dmfc_wm_set_9 (3U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_dmfc_wm_set_9. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_dmfc_wm_set_9 field. */
#define BR_IPU_DMFC_GENERAL_1_dmfc_wm_set_9(x) (HW_IPU_DMFC_GENERAL_1(x).B.dmfc_wm_set_9)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_dmfc_wm_set_9. */
#define BF_IPU_DMFC_GENERAL_1_dmfc_wm_set_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_dmfc_wm_set_9) & BM_IPU_DMFC_GENERAL_1_dmfc_wm_set_9)

/*! @brief Set the dmfc_wm_set_9 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_dmfc_wm_set_9(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_dmfc_wm_set_9) | BF_IPU_DMFC_GENERAL_1_dmfc_wm_set_9(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field dmfc_wm_clr_9[15:13] (RW)
 *
 * Watermark Clear This field defines the watermark's level of the DMFC's write
 * FIFO. Crossing this level will clear the watermark signal to the IDMAC. The WM
 * level is the amount of occupied bursts at the FIFO (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9 (13U) /*!< Bit position for IPU_DMFC_GENERAL_1_dmfc_wm_clr_9. */
#define BM_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9 (0x0000E000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_dmfc_wm_clr_9. */
#define BS_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9 (3U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_dmfc_wm_clr_9. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_dmfc_wm_clr_9 field. */
#define BR_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9(x) (HW_IPU_DMFC_GENERAL_1(x).B.dmfc_wm_clr_9)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_dmfc_wm_clr_9. */
#define BF_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9) & BM_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9)

/*! @brief Set the dmfc_wm_clr_9 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9) | BF_IPU_DMFC_GENERAL_1_dmfc_wm_clr_9(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_1[16] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #1 is in wait4eot mode
 * - 0 - FIFO #1 is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_1 (16U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_1. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_1 (0x00010000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_1. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_1 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_1. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_1 field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_1(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_1)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_1. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_1) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_1)

/*! @brief Set the WAIT4EOT_1 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_1(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_1) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_1(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_2[17] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #2 is in wait4eot mode
 * - 0 - FIFO #2 is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_2 (17U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_2. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_2 (0x00020000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_2. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_2 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_2. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_2 field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_2(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_2)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_2. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_2) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_2)

/*! @brief Set the WAIT4EOT_2 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_2(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_2) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_2(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_3[18] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #3 is in wait4eot mode
 * - 0 - FIFO #3 is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_3 (18U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_3. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_3 (0x00040000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_3. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_3 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_3. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_3 field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_3(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_3)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_3. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_3) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_3)

/*! @brief Set the WAIT4EOT_3 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_3(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_3) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_3(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_4[19] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #4 is in wait4eot mode
 * - 0 - FIFO #4 is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_4 (19U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_4. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_4 (0x00080000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_4. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_4 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_4. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_4 field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_4(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_4)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_4. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_4(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_4) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_4)

/*! @brief Set the WAIT4EOT_4 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_4(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_4) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_4(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_5B[20] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #5B is in wait4eot mode
 * - 0 - FIFO #5B is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_5B (20U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_5B. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5B (0x00100000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_5B. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_5B (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_5B. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_5B field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_5B(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_5B)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_5B. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_5B(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_5B) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5B)

/*! @brief Set the WAIT4EOT_5B field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_5B(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5B) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_5B(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_5F[21] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #5F is in wait4eot mode
 * - 0 - FIFO #5F is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_5F (21U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_5F. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5F (0x00200000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_5F. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_5F (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_5F. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_5F field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_5F(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_5F)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_5F. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_5F(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_5F) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5F)

/*! @brief Set the WAIT4EOT_5F field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_5F(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_5F) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_5F(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_6B[22] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #6B is in wait4eot mode
 * - 0 - FIFO #6B is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_6B (22U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_6B. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6B (0x00400000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_6B. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_6B (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_6B. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_6B field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_6B(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_6B)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_6B. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_6B(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_6B) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6B)

/*! @brief Set the WAIT4EOT_6B field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_6B(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6B) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_6B(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_6F[23] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #6F is in wait4eot mode
 * - 0 - FIFO #6F is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_6F (23U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_6F. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6F (0x00800000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_6F. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_6F (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_6F. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_6F field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_6F(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_6F)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_6F. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_6F(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_6F) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6F)

/*! @brief Set the WAIT4EOT_6F field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_6F(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_6F) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_6F(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_1, field WAIT4EOT_9[24] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #9 is in wait4eot mode
 * - 0 - FIFO #9 is in normal mode
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_1_WAIT4EOT_9 (24U) /*!< Bit position for IPU_DMFC_GENERAL_1_WAIT4EOT_9. */
#define BM_IPU_DMFC_GENERAL_1_WAIT4EOT_9 (0x01000000U) /*!< Bit mask for IPU_DMFC_GENERAL_1_WAIT4EOT_9. */
#define BS_IPU_DMFC_GENERAL_1_WAIT4EOT_9 (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_1_WAIT4EOT_9. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_1_WAIT4EOT_9 field. */
#define BR_IPU_DMFC_GENERAL_1_WAIT4EOT_9(x) (HW_IPU_DMFC_GENERAL_1(x).B.WAIT4EOT_9)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_1_WAIT4EOT_9. */
#define BF_IPU_DMFC_GENERAL_1_WAIT4EOT_9(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_1_WAIT4EOT_9) & BM_IPU_DMFC_GENERAL_1_WAIT4EOT_9)

/*! @brief Set the WAIT4EOT_9 field to a new value. */
#define BW_IPU_DMFC_GENERAL_1_WAIT4EOT_9(x, v) (HW_IPU_DMFC_GENERAL_1_WR(x, (HW_IPU_DMFC_GENERAL_1_RD(x) & ~BM_IPU_DMFC_GENERAL_1_WAIT4EOT_9) | BF_IPU_DMFC_GENERAL_1_WAIT4EOT_9(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_GENERAL_2 - DMFC General 2 Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_GENERAL_2 - DMFC General 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_general_2
{
    uint32_t U;
    struct _hw_ipu_dmfc_general_2_bitfields
    {
        uint32_t dmfc_frame_width_rd : 13; /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t dmfc_frame_height_rd : 13; /*!< [28:16]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_ipu_dmfc_general_2_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_GENERAL_2 register
 */
/*@{*/
#define HW_IPU_DMFC_GENERAL_2_ADDR(x) ((uintptr_t)(x) + 0x60018U)

#define HW_IPU_DMFC_GENERAL_2(x) (*(__IO hw_ipu_dmfc_general_2_t *) HW_IPU_DMFC_GENERAL_2_ADDR(x))
#define HW_IPU_DMFC_GENERAL_2_RD(x) (HW_IPU_DMFC_GENERAL_2(x).U)
#define HW_IPU_DMFC_GENERAL_2_WR(x, v) (HW_IPU_DMFC_GENERAL_2(x).U = (v))
#define HW_IPU_DMFC_GENERAL_2_SET(x, v) (HW_IPU_DMFC_GENERAL_2_WR(x, HW_IPU_DMFC_GENERAL_2_RD(x) |  (v)))
#define HW_IPU_DMFC_GENERAL_2_CLR(x, v) (HW_IPU_DMFC_GENERAL_2_WR(x, HW_IPU_DMFC_GENERAL_2_RD(x) & ~(v)))
#define HW_IPU_DMFC_GENERAL_2_TOG(x, v) (HW_IPU_DMFC_GENERAL_2_WR(x, HW_IPU_DMFC_GENERAL_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_GENERAL_2 bitfields
 */

/*!
 * @name Register IPU_DMFC_GENERAL_2, field dmfc_frame_width_rd[12:0] (RW)
 *
 * Frame width for read channel from the display to the IDMAC; Units are pixels
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd (0U) /*!< Bit position for IPU_DMFC_GENERAL_2_dmfc_frame_width_rd. */
#define BM_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd (0x00001FFFU) /*!< Bit mask for IPU_DMFC_GENERAL_2_dmfc_frame_width_rd. */
#define BS_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd (13U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_2_dmfc_frame_width_rd. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_2_dmfc_frame_width_rd field. */
#define BR_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd(x) (HW_IPU_DMFC_GENERAL_2(x).B.dmfc_frame_width_rd)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_2_dmfc_frame_width_rd. */
#define BF_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd) & BM_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd)

/*! @brief Set the dmfc_frame_width_rd field to a new value. */
#define BW_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd(x, v) (HW_IPU_DMFC_GENERAL_2_WR(x, (HW_IPU_DMFC_GENERAL_2_RD(x) & ~BM_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd) | BF_IPU_DMFC_GENERAL_2_dmfc_frame_width_rd(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL_2, field dmfc_frame_height_rd[28:16] (RW)
 *
 * Frame height for read channel from the display to the IDMAC; Units are pixels
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd (16U) /*!< Bit position for IPU_DMFC_GENERAL_2_dmfc_frame_height_rd. */
#define BM_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd (0x1FFF0000U) /*!< Bit mask for IPU_DMFC_GENERAL_2_dmfc_frame_height_rd. */
#define BS_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd (13U) /*!< Bit field size in bits for IPU_DMFC_GENERAL_2_dmfc_frame_height_rd. */

/*! @brief Read current value of the IPU_DMFC_GENERAL_2_dmfc_frame_height_rd field. */
#define BR_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd(x) (HW_IPU_DMFC_GENERAL_2(x).B.dmfc_frame_height_rd)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL_2_dmfc_frame_height_rd. */
#define BF_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd) & BM_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd)

/*! @brief Set the dmfc_frame_height_rd field to a new value. */
#define BW_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd(x, v) (HW_IPU_DMFC_GENERAL_2_WR(x, (HW_IPU_DMFC_GENERAL_2_RD(x) & ~BM_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd) | BF_IPU_DMFC_GENERAL_2_dmfc_frame_height_rd(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_IC_CTRL - DMFC IC Interface Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_IC_CTRL - DMFC IC Interface Control Register (RW)
 *
 * Reset value: 0x00000002U
 */
typedef union _hw_ipu_dmfc_ic_ctrl
{
    uint32_t U;
    struct _hw_ipu_dmfc_ic_ctrl_bitfields
    {
        uint32_t dmfc_ic_in_port : 3;  /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t dmfc_ic_ppw_c : 2;    /*!< [5:4]  */
        uint32_t dmfc_ic_frame_width_rd : 13; /*!< [18:6]  */
        uint32_t dmfc_ic_frame_height_rd : 13; /*!< [31:19]  */
    } B;
} hw_ipu_dmfc_ic_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_IC_CTRL register
 */
/*@{*/
#define HW_IPU_DMFC_IC_CTRL_ADDR(x) ((uintptr_t)(x) + 0x6001CU)

#define HW_IPU_DMFC_IC_CTRL(x)   (*(__IO hw_ipu_dmfc_ic_ctrl_t *) HW_IPU_DMFC_IC_CTRL_ADDR(x))
#define HW_IPU_DMFC_IC_CTRL_RD(x) (HW_IPU_DMFC_IC_CTRL(x).U)
#define HW_IPU_DMFC_IC_CTRL_WR(x, v) (HW_IPU_DMFC_IC_CTRL(x).U = (v))
#define HW_IPU_DMFC_IC_CTRL_SET(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, HW_IPU_DMFC_IC_CTRL_RD(x) |  (v)))
#define HW_IPU_DMFC_IC_CTRL_CLR(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, HW_IPU_DMFC_IC_CTRL_RD(x) & ~(v)))
#define HW_IPU_DMFC_IC_CTRL_TOG(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, HW_IPU_DMFC_IC_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_IC_CTRL bitfields
 */

/*!
 * @name Register IPU_DMFC_IC_CTRL, field dmfc_ic_in_port[2:0] (RW)
 *
 * DMFC input port When data is coming from the IC, the IC channel replaces one
 * of the IDMAC's channels connected to the DMFC. This field defines which
 * IDMAC's channel is replaced by the IC channel.
 *
 * Values:
 * - 000 - CH28
 * - 001 - CH41
 * - 010 - Reserved, IC channel is disabled
 * - 011 - Reserved, IC channel is disabled
 * - 100 - CH23
 * - 101 - CH27
 * - 110 - CH24
 * - 111 - CH29
 */
/*@{*/
#define BP_IPU_DMFC_IC_CTRL_dmfc_ic_in_port (0U) /*!< Bit position for IPU_DMFC_IC_CTRL_dmfc_ic_in_port. */
#define BM_IPU_DMFC_IC_CTRL_dmfc_ic_in_port (0x00000007U) /*!< Bit mask for IPU_DMFC_IC_CTRL_dmfc_ic_in_port. */
#define BS_IPU_DMFC_IC_CTRL_dmfc_ic_in_port (3U) /*!< Bit field size in bits for IPU_DMFC_IC_CTRL_dmfc_ic_in_port. */

/*! @brief Read current value of the IPU_DMFC_IC_CTRL_dmfc_ic_in_port field. */
#define BR_IPU_DMFC_IC_CTRL_dmfc_ic_in_port(x) (HW_IPU_DMFC_IC_CTRL(x).B.dmfc_ic_in_port)

/*! @brief Format value for bitfield IPU_DMFC_IC_CTRL_dmfc_ic_in_port. */
#define BF_IPU_DMFC_IC_CTRL_dmfc_ic_in_port(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_IC_CTRL_dmfc_ic_in_port) & BM_IPU_DMFC_IC_CTRL_dmfc_ic_in_port)

/*! @brief Set the dmfc_ic_in_port field to a new value. */
#define BW_IPU_DMFC_IC_CTRL_dmfc_ic_in_port(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, (HW_IPU_DMFC_IC_CTRL_RD(x) & ~BM_IPU_DMFC_IC_CTRL_dmfc_ic_in_port) | BF_IPU_DMFC_IC_CTRL_dmfc_ic_in_port(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_IC_CTRL, field dmfc_ic_ppw_c[5:4] (RW)
 *
 * Pixel Per Word coded from IC. This field defines the size of the data coming
 * from the IC.
 *
 * Values:
 * - 00 - 8 bit per pixel
 * - 01 - 16 bit per pixel
 * - 10 - 24 bit per pixel
 * - 11 - Reserved
 */
/*@{*/
#define BP_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c (4U) /*!< Bit position for IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c. */
#define BM_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c (0x00000030U) /*!< Bit mask for IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c. */
#define BS_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c (2U) /*!< Bit field size in bits for IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c. */

/*! @brief Read current value of the IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c field. */
#define BR_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c(x) (HW_IPU_DMFC_IC_CTRL(x).B.dmfc_ic_ppw_c)

/*! @brief Format value for bitfield IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c. */
#define BF_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c) & BM_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c)

/*! @brief Set the dmfc_ic_ppw_c field to a new value. */
#define BW_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, (HW_IPU_DMFC_IC_CTRL_RD(x) & ~BM_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c) | BF_IPU_DMFC_IC_CTRL_dmfc_ic_ppw_c(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_IC_CTRL, field dmfc_ic_frame_width_rd[18:6] (RW)
 *
 * Frame's width for the channel coming from IC. Units are pixels
 */
/*@{*/
#define BP_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd (6U) /*!< Bit position for IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd. */
#define BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd (0x0007FFC0U) /*!< Bit mask for IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd. */
#define BS_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd (13U) /*!< Bit field size in bits for IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd. */

/*! @brief Read current value of the IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd field. */
#define BR_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd(x) (HW_IPU_DMFC_IC_CTRL(x).B.dmfc_ic_frame_width_rd)

/*! @brief Format value for bitfield IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd. */
#define BF_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd) & BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd)

/*! @brief Set the dmfc_ic_frame_width_rd field to a new value. */
#define BW_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, (HW_IPU_DMFC_IC_CTRL_RD(x) & ~BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd) | BF_IPU_DMFC_IC_CTRL_dmfc_ic_frame_width_rd(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_IC_CTRL, field dmfc_ic_frame_height_rd[31:19] (RW)
 *
 * Frame's height for the channel coming from IC. Units are lines
 */
/*@{*/
#define BP_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd (19U) /*!< Bit position for IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd. */
#define BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd (0xFFF80000U) /*!< Bit mask for IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd. */
#define BS_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd (13U) /*!< Bit field size in bits for IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd. */

/*! @brief Read current value of the IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd field. */
#define BR_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd(x) (HW_IPU_DMFC_IC_CTRL(x).B.dmfc_ic_frame_height_rd)

/*! @brief Format value for bitfield IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd. */
#define BF_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd) & BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd)

/*! @brief Set the dmfc_ic_frame_height_rd field to a new value. */
#define BW_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd(x, v) (HW_IPU_DMFC_IC_CTRL_WR(x, (HW_IPU_DMFC_IC_CTRL_RD(x) & ~BM_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd) | BF_IPU_DMFC_IC_CTRL_dmfc_ic_frame_height_rd(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_WR_CHAN_ALT - DMFC Write Channel Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_WR_CHAN_ALT - DMFC Write Channel Alternate Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_wr_chan_alt
{
    uint32_t U;
    struct _hw_ipu_dmfc_wr_chan_alt_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t dmfc_st_addr_2_alt : 3; /*!< [10:8]  */
        uint32_t dmfc_fifo_size_2_alt : 3; /*!< [13:11]  */
        uint32_t dmfc_burst_size_2_alt : 2; /*!< [15:14]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dmfc_wr_chan_alt_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_WR_CHAN_ALT register
 */
/*@{*/
#define HW_IPU_DMFC_WR_CHAN_ALT_ADDR(x) ((uintptr_t)(x) + 0x60020U)

#define HW_IPU_DMFC_WR_CHAN_ALT(x) (*(__IO hw_ipu_dmfc_wr_chan_alt_t *) HW_IPU_DMFC_WR_CHAN_ALT_ADDR(x))
#define HW_IPU_DMFC_WR_CHAN_ALT_RD(x) (HW_IPU_DMFC_WR_CHAN_ALT(x).U)
#define HW_IPU_DMFC_WR_CHAN_ALT_WR(x, v) (HW_IPU_DMFC_WR_CHAN_ALT(x).U = (v))
#define HW_IPU_DMFC_WR_CHAN_ALT_SET(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_ALT_RD(x) |  (v)))
#define HW_IPU_DMFC_WR_CHAN_ALT_CLR(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_ALT_RD(x) & ~(v)))
#define HW_IPU_DMFC_WR_CHAN_ALT_TOG(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_WR_CHAN_ALT bitfields
 */

/*!
 * @name Register IPU_DMFC_WR_CHAN_ALT, field dmfc_st_addr_2_alt[10:8] (RW)
 *
 * DMFC Start Address for IDMAC's channel 41 (for alternate flow) This field
 * defines the base address at the DMFC's FIFO of the partition allocated to the
 * channel connected to IDMAC's channel 41. The FIFO is partitioned to 8 equal
 * segments. Each segment is 64X128 words The value of this field is the number of the
 * segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt (8U) /*!< Bit position for IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt (0x00000700U) /*!< Bit mask for IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt(x) (HW_IPU_DMFC_WR_CHAN_ALT(x).B.dmfc_st_addr_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt) & BM_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt)

/*! @brief Set the dmfc_st_addr_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt) | BF_IPU_DMFC_WR_CHAN_ALT_dmfc_st_addr_2_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_ALT, field dmfc_fifo_size_2_alt[13:11] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 41 (for alternate flow) This field defines
 * the FIFO partition for the DMFC channel connected to IDMAC's channel 41
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt (11U) /*!< Bit position for IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt (0x00003800U) /*!< Bit mask for IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt(x) (HW_IPU_DMFC_WR_CHAN_ALT(x).B.dmfc_fifo_size_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt) & BM_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt)

/*! @brief Set the dmfc_fifo_size_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt) | BF_IPU_DMFC_WR_CHAN_ALT_dmfc_fifo_size_2_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_ALT, field dmfc_burst_size_2_alt[15:14] (RW)
 *
 * Burst size of IDMAC's channel 41 (for alternate flow) This field defines the
 * burst size of the IDMAC's channel 41 write accesses. This settings must match
 * the settings in the corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt (14U) /*!< Bit position for IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt (0x0000C000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt (2U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt(x) (HW_IPU_DMFC_WR_CHAN_ALT(x).B.dmfc_burst_size_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt) & BM_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt)

/*! @brief Set the dmfc_burst_size_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt) | BF_IPU_DMFC_WR_CHAN_ALT_dmfc_burst_size_2_alt(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_WR_CHAN_DEF_ALT - DMFC Write Channel Definition Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_WR_CHAN_DEF_ALT - DMFC Write Channel Definition Alternate Register (RW)
 *
 * Reset value: 0x00002000U
 */
typedef union _hw_ipu_dmfc_wr_chan_def_alt
{
    uint32_t U;
    struct _hw_ipu_dmfc_wr_chan_def_alt_bitfields
    {
        uint32_t RESERVED0 : 9;        /*!< [8:0]  */
        uint32_t dmfc_wm_en_2_alt : 1; /*!< [9]  */
        uint32_t dmfc_wm_set_2_alt : 3; /*!< [12:10]  */
        uint32_t dmfc_wm_clr_2_alt : 3; /*!< [15:13]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_dmfc_wr_chan_def_alt_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_WR_CHAN_DEF_ALT register
 */
/*@{*/
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_ADDR(x) ((uintptr_t)(x) + 0x60024U)

#define HW_IPU_DMFC_WR_CHAN_DEF_ALT(x) (*(__IO hw_ipu_dmfc_wr_chan_def_alt_t *) HW_IPU_DMFC_WR_CHAN_DEF_ALT_ADDR(x))
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) (HW_IPU_DMFC_WR_CHAN_DEF_ALT(x).U)
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT(x).U = (v))
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_SET(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) |  (v)))
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_CLR(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) & ~(v)))
#define HW_IPU_DMFC_WR_CHAN_DEF_ALT_TOG(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_WR_CHAN_DEF_ALT bitfields
 */

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF_ALT, field dmfc_wm_en_2_alt[9] (RW)
 *
 * Watermark enable. (for alternate flow) This bit enables the watermark feature
 * of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt (9U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt (0x00000200U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt (1U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt(x) (HW_IPU_DMFC_WR_CHAN_DEF_ALT(x).B.dmfc_wm_en_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt) & BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt)

/*! @brief Set the dmfc_wm_en_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt) | BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_en_2_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF_ALT, field dmfc_wm_set_2_alt[12:10] (RW)
 *
 * Watermark Set (for alternate flow) This field defines the watermark's level
 * of the DMFC write FIFO. Crossing this level will send the watermark signal to
 * the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt (10U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt (0x00001C00U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt(x) (HW_IPU_DMFC_WR_CHAN_DEF_ALT(x).B.dmfc_wm_set_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt) & BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt)

/*! @brief Set the dmfc_wm_set_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt) | BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_set_2_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_WR_CHAN_DEF_ALT, field dmfc_wm_clr_2_alt[15:13] (RW)
 *
 * Watermark Clear (for alternate flow) This field defines the watermark's level
 * of the DMFC's write FIFO. Crossing this level will clear the watermark signal
 * to the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt (13U) /*!< Bit position for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt. */
#define BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt (0x0000E000U) /*!< Bit mask for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt. */
#define BS_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt (3U) /*!< Bit field size in bits for IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt. */

/*! @brief Read current value of the IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt field. */
#define BR_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt(x) (HW_IPU_DMFC_WR_CHAN_DEF_ALT(x).B.dmfc_wm_clr_2_alt)

/*! @brief Format value for bitfield IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt. */
#define BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt) & BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt)

/*! @brief Set the dmfc_wm_clr_2_alt field to a new value. */
#define BW_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt(x, v) (HW_IPU_DMFC_WR_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_WR_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt) | BF_IPU_DMFC_WR_CHAN_DEF_ALT_dmfc_wm_clr_2_alt(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_DP_CHAN_ALT - DMFC MFC Display Processor Channel Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_DP_CHAN_ALT - DMFC MFC Display Processor Channel Alternate Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_dp_chan_alt
{
    uint32_t U;
    struct _hw_ipu_dmfc_dp_chan_alt_bitfields
    {
        uint32_t dmfc_st_addr_5b_alt : 3; /*!< [2:0]  */
        uint32_t dmfc_fifo_size_5b_alt : 3; /*!< [5:3]  */
        uint32_t dmfc_burst_size_5b_alt : 2; /*!< [7:6]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t dmfc_st_addr_6b_alt : 3; /*!< [18:16]  */
        uint32_t dmfc_fifo_size_6b_alt : 3; /*!< [21:19]  */
        uint32_t dmfc_burst_size_6b_alt : 2; /*!< [23:22]  */
        uint32_t dmfc_st_addr_6f_alt : 3; /*!< [26:24]  */
        uint32_t dmfc_fifo_size_6f_alt : 3; /*!< [29:27]  */
        uint32_t dmfc_burst_size_6f_alt : 2; /*!< [31:30]  */
    } B;
} hw_ipu_dmfc_dp_chan_alt_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_DP_CHAN_ALT register
 */
/*@{*/
#define HW_IPU_DMFC_DP_CHAN_ALT_ADDR(x) ((uintptr_t)(x) + 0x60028U)

#define HW_IPU_DMFC_DP_CHAN_ALT(x) (*(__IO hw_ipu_dmfc_dp_chan_alt_t *) HW_IPU_DMFC_DP_CHAN_ALT_ADDR(x))
#define HW_IPU_DMFC_DP_CHAN_ALT_RD(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).U)
#define HW_IPU_DMFC_DP_CHAN_ALT_WR(x, v) (HW_IPU_DMFC_DP_CHAN_ALT(x).U = (v))
#define HW_IPU_DMFC_DP_CHAN_ALT_SET(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_ALT_RD(x) |  (v)))
#define HW_IPU_DMFC_DP_CHAN_ALT_CLR(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~(v)))
#define HW_IPU_DMFC_DP_CHAN_ALT_TOG(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_DP_CHAN_ALT bitfields
 */

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_st_addr_5b_alt[2:0] (RW)
 *
 * DMFC Start Address for IDMAC's channel 23 (for alternate flow) This field
 * defines the base address at the DMFC's FIFO of the partition allocated to the
 * channel connected to IDMAC's channel 23. The FIFO is partitioned to 8 equal
 * segments. Each segment is 64X128 words The value of this field is the number of the
 * segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt (0U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt (0x00000007U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_st_addr_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt)

/*! @brief Set the dmfc_st_addr_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_fifo_size_5b_alt[5:3] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 23 (for alternate flow) This field defines
 * the FIFO partition for the DMFC channel connected to IDMAC's channel 23
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt (3U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt (0x00000038U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_fifo_size_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt)

/*! @brief Set the dmfc_fifo_size_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_burst_size_5b_alt[7:6] (RW)
 *
 * Burst size of IDMAC's channel 23 (for alternate flow) This field defines the
 * burst size of the IDMAC's channel 23 write accesses. This settings must match
 * the settings in the corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt (6U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt (0x000000C0U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_burst_size_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt)

/*! @brief Set the dmfc_burst_size_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_st_addr_6b_alt[18:16] (RW)
 *
 * DMFC Start Address for IDMAC's channel 24 (for alternate flow) This field
 * defines the base address at the DMFC's FIFO of the partition allocated to the
 * channel connected to IDMAC's channel 24. The FIFO is partitioned to 8 equal
 * segments. Each segment is 64X128 words The value of this field is the number of the
 * segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt (16U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt (0x00070000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_st_addr_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt)

/*! @brief Set the dmfc_st_addr_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_fifo_size_6b_alt[21:19] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 24 (for alternate flow) This field defines
 * the FIFO partition for the DMFC channel connected to IDMAC's channel 24
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt (19U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt (0x00380000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_fifo_size_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt)

/*! @brief Set the dmfc_fifo_size_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_burst_size_6b_alt[23:22] (RW)
 *
 * Burst size of IDMAC's channel 24 (for alternate flow) This field defines the
 * burst size of the IDMAC's channel 24 write accesses. This settings must match
 * the settings in the corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt (22U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt (0x00C00000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_burst_size_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt)

/*! @brief Set the dmfc_burst_size_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_st_addr_6f_alt[26:24] (RW)
 *
 * DMFC Start Address for IDMAC's channel 29 (for alternate flow) This field
 * defines the base address at the DMFC's FIFO of the partition allocated to the
 * channel connected to IDMAC's channel 29. The FIFO is partitioned to 8 equal
 * segments. Each segment is 64X128 words The value of this field is the number of the
 * segment
 *
 * Values:
 * - 000 - Segment 0
 * - 001 - Segment 1
 * - 111 - Segment 7
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt (24U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt (0x07000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_st_addr_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt)

/*! @brief Set the dmfc_st_addr_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_st_addr_6f_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_fifo_size_6f_alt[29:27] (RW)
 *
 * DMFC FIFO size for IDMAC's channel 29 (for alternate flow) This field defines
 * the FIFO partition for the DMFC channel connected to IDMAC's channel 29
 *
 * Values:
 * - 000 - All (512X128 words) the DMFC's FIFO is allocated to this channel
 * - 001 - 256X128 words are allocated to this channel
 * - 010 - 128X128 words are allocated to this channel
 * - 011 - 64X128 words are allocated to this channel
 * - 100 - 32X128 words are allocated to this channel
 * - 101 - 16X128 words are allocated to this channel
 * - 110 - 8X128 words are allocated to this channel
 * - 111 - 4X128 words are allocated to this channel
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt (27U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt (0x38000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_fifo_size_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt)

/*! @brief Set the dmfc_fifo_size_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_fifo_size_6f_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_ALT, field dmfc_burst_size_6f_alt[31:30] (RW)
 *
 * Burst size of IDMAC's channel 29 (for alternate flow) This field defines the
 * burst size of the IDMAC's channel 29 write accesses. This settings must match
 * the settings in the corresponding IDMAC channel's settings.
 *
 * Values:
 * - 00 - 32 words of 128 bit (4 pixels of 32 bit each, coming from the IDMAC)
 * - 01 - 16 words of 128 bit
 * - 10 - 8 words of 128 bit
 * - 11 - 4 words of 128 bit
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt (30U) /*!< Bit position for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt (0xC0000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt (2U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_ALT(x).B.dmfc_burst_size_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt) & BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt)

/*! @brief Set the dmfc_burst_size_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt) | BF_IPU_DMFC_DP_CHAN_ALT_dmfc_burst_size_6f_alt(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_DP_CHAN_DEF_ALT - DMFC Display Channel Definition Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_DP_CHAN_DEF_ALT - DMFC Display Channel Definition Alternate Register (RW)
 *
 * Reset value: 0x20200020U
 */
typedef union _hw_ipu_dmfc_dp_chan_def_alt
{
    uint32_t U;
    struct _hw_ipu_dmfc_dp_chan_def_alt_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t dmfc_wm_en_5b_alt : 1; /*!< [1]  */
        uint32_t dmfc_wm_set_5b_alt : 3; /*!< [4:2]  */
        uint32_t dmfc_wm_clr_5b_alt : 3; /*!< [7:5]  */
        uint32_t RESERVED1 : 9;        /*!< [16:8]  */
        uint32_t dmfc_wm_en_6b_alt : 1; /*!< [17]  */
        uint32_t dmfc_wm_set_6b_alt : 3; /*!< [20:18]  */
        uint32_t dmfc_wm_clr_6b_alt : 3; /*!< [23:21]  */
        uint32_t RESERVED2 : 1;        /*!< [24]  */
        uint32_t dmfc_wm_en_6f_alt : 1; /*!< [25]  */
        uint32_t dmfc_wm_set_6f_alt : 3; /*!< [28:26]  */
        uint32_t dmfc_wm_clr_6f_alt : 3; /*!< [31:29]  */
    } B;
} hw_ipu_dmfc_dp_chan_def_alt_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_DP_CHAN_DEF_ALT register
 */
/*@{*/
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_ADDR(x) ((uintptr_t)(x) + 0x6002CU)

#define HW_IPU_DMFC_DP_CHAN_DEF_ALT(x) (*(__IO hw_ipu_dmfc_dp_chan_def_alt_t *) HW_IPU_DMFC_DP_CHAN_DEF_ALT_ADDR(x))
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).U)
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).U = (v))
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_SET(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) |  (v)))
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_CLR(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~(v)))
#define HW_IPU_DMFC_DP_CHAN_DEF_ALT_TOG(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_DP_CHAN_DEF_ALT bitfields
 */

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_en_5b_alt[1] (RW)
 *
 * Watermark enable. (for alternate flow) This bit enables the watermark feature
 * of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt (1U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt (0x00000002U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_en_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt)

/*! @brief Set the dmfc_wm_en_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_set_5b_alt[4:2] (RW)
 *
 * Watermark Set (for alternate flow) This field defines the watermark's level
 * of the DMFC write FIFO. Crossing this level will send the watermark signal to
 * the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt (2U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt (0x0000001CU) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_set_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt)

/*! @brief Set the dmfc_wm_set_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_clr_5b_alt[7:5] (RW)
 *
 * Watermark Clear (for alternate flow) This field defines the watermark's level
 * of the DMFC's write FIFO. Crossing this level will clear the watermark signal
 * to the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt (5U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt (0x000000E0U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_clr_5b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt)

/*! @brief Set the dmfc_wm_clr_5b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_5b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_en_6b_alt[17] (RW)
 *
 * Watermark enable. (for alternate flow) This bit enables the watermark feature
 * of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt (17U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt (0x00020000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_en_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt)

/*! @brief Set the dmfc_wm_en_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_set_6b_alt[20:18] (RW)
 *
 * Watermark Set (for alternate flow) This field defines the watermark's level
 * of the DMFC write FIFO. Crossing this level will send the watermark signal to
 * the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt (18U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt (0x001C0000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_set_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt)

/*! @brief Set the dmfc_wm_set_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_clr_6b_alt[23:21] (RW)
 *
 * Watermark Clear (for alternate flow) This field defines the watermark's level
 * of the DMFC's write FIFO. Crossing this level will clear the watermark signal
 * to the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt (21U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt (0x00E00000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_clr_6b_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt)

/*! @brief Set the dmfc_wm_clr_6b_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6b_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_en_6f_alt[25] (RW)
 *
 * Watermark enable. (for alternate flow) This bit enables the watermark feature
 * of the FIFO
 *
 * Values:
 * - 1 - WM feature is enabled
 * - 0 - WM feature is disabled
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt (25U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt (0x02000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt (1U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_en_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt)

/*! @brief Set the dmfc_wm_en_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_en_6f_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_set_6f_alt[28:26] (RW)
 *
 * Watermark Set (for alternate flow) This field defines the watermark's level
 * of the DMFC write FIFO. Crossing this level will send the watermark signal to
 * the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt (26U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt (0x1C000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_set_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt)

/*! @brief Set the dmfc_wm_set_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_set_6f_alt(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_DP_CHAN_DEF_ALT, field dmfc_wm_clr_6f_alt[31:29] (RW)
 *
 * Watermark Clear (for alternate flow) This field defines the watermark's level
 * of the DMFC's write FIFO. Crossing this level will clear the watermark signal
 * to the IDMAC. The WM level is the amount of occupied bursts at the FIFO
 * (dmfc_wm_clr > dmfc_wm_set)
 */
/*@{*/
#define BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt (29U) /*!< Bit position for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt. */
#define BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt (0xE0000000U) /*!< Bit mask for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt. */
#define BS_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt (3U) /*!< Bit field size in bits for IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt. */

/*! @brief Read current value of the IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt field. */
#define BR_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt(x) (HW_IPU_DMFC_DP_CHAN_DEF_ALT(x).B.dmfc_wm_clr_6f_alt)

/*! @brief Format value for bitfield IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt. */
#define BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt) & BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt)

/*! @brief Set the dmfc_wm_clr_6f_alt field to a new value. */
#define BW_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt(x, v) (HW_IPU_DMFC_DP_CHAN_DEF_ALT_WR(x, (HW_IPU_DMFC_DP_CHAN_DEF_ALT_RD(x) & ~BM_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt) | BF_IPU_DMFC_DP_CHAN_DEF_ALT_dmfc_wm_clr_6f_alt(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_GENERAL1_ALT - DMFC General 1 Alternate Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_GENERAL1_ALT - DMFC General 1 Alternate Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_dmfc_general1_alt
{
    uint32_t U;
    struct _hw_ipu_dmfc_general1_alt_bitfields
    {
        uint32_t RESERVED0 : 17;       /*!< [16:0]  */
        uint32_t WAIT4EOT_2_ALT : 1;   /*!< [17]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t WAIT4EOT_5B_ALT : 1;  /*!< [20]  */
        uint32_t RESERVED2 : 1;        /*!< [21]  */
        uint32_t WAIT4EOT_6B_ALT : 1;  /*!< [22]  */
        uint32_t WAIT4EOT_6F_ALT : 1;  /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_dmfc_general1_alt_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_GENERAL1_ALT register
 */
/*@{*/
#define HW_IPU_DMFC_GENERAL1_ALT_ADDR(x) ((uintptr_t)(x) + 0x60030U)

#define HW_IPU_DMFC_GENERAL1_ALT(x) (*(__IO hw_ipu_dmfc_general1_alt_t *) HW_IPU_DMFC_GENERAL1_ALT_ADDR(x))
#define HW_IPU_DMFC_GENERAL1_ALT_RD(x) (HW_IPU_DMFC_GENERAL1_ALT(x).U)
#define HW_IPU_DMFC_GENERAL1_ALT_WR(x, v) (HW_IPU_DMFC_GENERAL1_ALT(x).U = (v))
#define HW_IPU_DMFC_GENERAL1_ALT_SET(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, HW_IPU_DMFC_GENERAL1_ALT_RD(x) |  (v)))
#define HW_IPU_DMFC_GENERAL1_ALT_CLR(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, HW_IPU_DMFC_GENERAL1_ALT_RD(x) & ~(v)))
#define HW_IPU_DMFC_GENERAL1_ALT_TOG(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, HW_IPU_DMFC_GENERAL1_ALT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_GENERAL1_ALT bitfields
 */

/*!
 * @name Register IPU_DMFC_GENERAL1_ALT, field WAIT4EOT_2_ALT[17] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #2 is in wait4eot mode (for alternate flow)
 * - 0 - FIFO #2 is in normal mode (for alternate flow)
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT (17U) /*!< Bit position for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT. */
#define BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT (0x00020000U) /*!< Bit mask for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT. */
#define BS_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT. */

/*! @brief Read current value of the IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT field. */
#define BR_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT(x) (HW_IPU_DMFC_GENERAL1_ALT(x).B.WAIT4EOT_2_ALT)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT. */
#define BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT) & BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT)

/*! @brief Set the WAIT4EOT_2_ALT field to a new value. */
#define BW_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, (HW_IPU_DMFC_GENERAL1_ALT_RD(x) & ~BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT) | BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_2_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL1_ALT, field WAIT4EOT_5B_ALT[20] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #5B is in wait4eot mode (for alternate flow)
 * - 0 - FIFO #5B is in normal mode (for alternate flow)
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT (20U) /*!< Bit position for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT. */
#define BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT (0x00100000U) /*!< Bit mask for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT. */
#define BS_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT. */

/*! @brief Read current value of the IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT field. */
#define BR_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT(x) (HW_IPU_DMFC_GENERAL1_ALT(x).B.WAIT4EOT_5B_ALT)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT. */
#define BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT) & BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT)

/*! @brief Set the WAIT4EOT_5B_ALT field to a new value. */
#define BW_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, (HW_IPU_DMFC_GENERAL1_ALT_RD(x) & ~BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT) | BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_5B_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL1_ALT, field WAIT4EOT_6B_ALT[22] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #6B is in wait4eot mode (for alternate flow)
 * - 0 - FIFO #6B is in normal mode (for alternate flow)
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT (22U) /*!< Bit position for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT. */
#define BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT (0x00400000U) /*!< Bit mask for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT. */
#define BS_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT. */

/*! @brief Read current value of the IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT field. */
#define BR_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT(x) (HW_IPU_DMFC_GENERAL1_ALT(x).B.WAIT4EOT_6B_ALT)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT. */
#define BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT) & BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT)

/*! @brief Set the WAIT4EOT_6B_ALT field to a new value. */
#define BW_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, (HW_IPU_DMFC_GENERAL1_ALT_RD(x) & ~BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT) | BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6B_ALT(v)))
/*@}*/

/*!
 * @name Register IPU_DMFC_GENERAL1_ALT, field WAIT4EOT_6F_ALT[23] (RW)
 *
 * In normal operation the DMFC sends requests to the IDMAC whenever there is
 * room in the FIFO. When this bit is set the DMFC sends the request only after the
 * current transfer is terminated, (wait4eot mode) When the FIFO is larger then
 * the size of the line, the user should work in wait4eot mode.
 *
 * Values:
 * - 1 - FIFO #6F is in wait4eot mode (for alternate flow)
 * - 0 - FIFO #6F is in normal mode (for alternate flow)
 */
/*@{*/
#define BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT (23U) /*!< Bit position for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT. */
#define BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT (0x00800000U) /*!< Bit mask for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT. */
#define BS_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT (1U) /*!< Bit field size in bits for IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT. */

/*! @brief Read current value of the IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT field. */
#define BR_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT(x) (HW_IPU_DMFC_GENERAL1_ALT(x).B.WAIT4EOT_6F_ALT)

/*! @brief Format value for bitfield IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT. */
#define BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT) & BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT)

/*! @brief Set the WAIT4EOT_6F_ALT field to a new value. */
#define BW_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT(x, v) (HW_IPU_DMFC_GENERAL1_ALT_WR(x, (HW_IPU_DMFC_GENERAL1_ALT_RD(x) & ~BM_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT) | BF_IPU_DMFC_GENERAL1_ALT_WAIT4EOT_6F_ALT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_DMFC_STAT - DMFC Status Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_DMFC_STAT - DMFC Status Register (RO)
 *
 * Reset value: 0x02FFF000U
 *
 * This register contains DMFC's status bits. All the bits in this register are
 * read-only.
 */
typedef union _hw_ipu_dmfc_stat
{
    uint32_t U;
    struct _hw_ipu_dmfc_stat_bitfields
    {
        uint32_t DMFC_FIFO_FULL_i : 12; /*!< [11:0]  */
        uint32_t DMFC_FIFO_EMPTY_i : 12; /*!< [23:12]  */
        uint32_t DMFC_IC_BUFFER_FULL : 1; /*!< [24]  */
        uint32_t DMFC_IC_BUFFER_EMPTY : 1; /*!< [25]  */
        uint32_t RESERVED0 : 6;        /*!< [31:26]  */
    } B;
} hw_ipu_dmfc_stat_t;

/*!
 * @name Constants and macros for entire IPU_DMFC_STAT register
 */
/*@{*/
#define HW_IPU_DMFC_STAT_ADDR(x) ((uintptr_t)(x) + 0x60034U)

#define HW_IPU_DMFC_STAT(x)      (*(__I hw_ipu_dmfc_stat_t *) HW_IPU_DMFC_STAT_ADDR(x))
#define HW_IPU_DMFC_STAT_RD(x)   (HW_IPU_DMFC_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_DMFC_STAT bitfields
 */

/*!
 * @name Register IPU_DMFC_STAT, field DMFC_FIFO_FULL_i[11:0] (RO)
 *
 * This bit indicates on a DMFC FIFO#<i> full condition. Mapping of these bit to
 * an actual FIFO number is as follows: bit 0 => 0 bit 1=> 1 bit 2 => 2 bit 3
 * =>1c bit 4 => 2c bit 5 => 5b bit 6 => 5f bit 7 => 6b bit 8 => 6f bit 9 => 9 bit
 * 10 => 10 (ARM platform access) bit 11 => 11 (ARM platform access)
 *
 * Values:
 * - 0 - FIFO #<i> is not full
 * - 1 - FIFO #<i> is full
 */
/*@{*/
#define BP_IPU_DMFC_STAT_DMFC_FIFO_FULL_i (0U) /*!< Bit position for IPU_DMFC_STAT_DMFC_FIFO_FULL_i. */
#define BM_IPU_DMFC_STAT_DMFC_FIFO_FULL_i (0x00000FFFU) /*!< Bit mask for IPU_DMFC_STAT_DMFC_FIFO_FULL_i. */
#define BS_IPU_DMFC_STAT_DMFC_FIFO_FULL_i (12U) /*!< Bit field size in bits for IPU_DMFC_STAT_DMFC_FIFO_FULL_i. */

/*! @brief Read current value of the IPU_DMFC_STAT_DMFC_FIFO_FULL_i field. */
#define BR_IPU_DMFC_STAT_DMFC_FIFO_FULL_i(x) (HW_IPU_DMFC_STAT(x).B.DMFC_FIFO_FULL_i)
/*@}*/

/*!
 * @name Register IPU_DMFC_STAT, field DMFC_FIFO_EMPTY_i[23:12] (RO)
 *
 * This bit indicates on a DMFC FIFO#<i> empty condition. Mapping of these bit
 * to an actual FIFO number is as follows: bit 0 => 0 bit 1=> 1 bit 2 => 2 bit 3
 * =>1c bit 4 => 2c bit 5 => 5b bit 6 => 5f bit 7 => 6b bit 8 => 6f bit 9 => 9 bit
 * 10 => 10 (ARM platform access) bit 11 => 11 (ARM platform access)
 *
 * Values:
 * - 0 - FIFO #<i> is not empty
 * - 1 - FIFO #<i> is empty
 */
/*@{*/
#define BP_IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i (12U) /*!< Bit position for IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i. */
#define BM_IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i (0x00FFF000U) /*!< Bit mask for IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i. */
#define BS_IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i (12U) /*!< Bit field size in bits for IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i. */

/*! @brief Read current value of the IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i field. */
#define BR_IPU_DMFC_STAT_DMFC_FIFO_EMPTY_i(x) (HW_IPU_DMFC_STAT(x).B.DMFC_FIFO_EMPTY_i)
/*@}*/

/*!
 * @name Register IPU_DMFC_STAT, field DMFC_IC_BUFFER_FULL[24] (RO)
 *
 * This bit indicates on a IC FIFO, inside the DMFC, full condition.
 *
 * Values:
 * - 0 - IC FIFO not full
 * - 1 - IC FIFO is full
 */
/*@{*/
#define BP_IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL (24U) /*!< Bit position for IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL. */
#define BM_IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL (0x01000000U) /*!< Bit mask for IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL. */
#define BS_IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL (1U) /*!< Bit field size in bits for IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL. */

/*! @brief Read current value of the IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL field. */
#define BR_IPU_DMFC_STAT_DMFC_IC_BUFFER_FULL(x) (HW_IPU_DMFC_STAT(x).B.DMFC_IC_BUFFER_FULL)
/*@}*/

/*!
 * @name Register IPU_DMFC_STAT, field DMFC_IC_BUFFER_EMPTY[25] (RO)
 *
 * This bit indicates on a IC FIFO, inside the DMFC, empty condition.
 *
 * Values:
 * - 0 - IC FIFO not empty
 * - 1 - IC FIFO is empty
 */
/*@{*/
#define BP_IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY (25U) /*!< Bit position for IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY. */
#define BM_IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY (0x02000000U) /*!< Bit mask for IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY. */
#define BS_IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY (1U) /*!< Bit field size in bits for IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY. */

/*! @brief Read current value of the IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY field. */
#define BR_IPU_DMFC_STAT_DMFC_IC_BUFFER_EMPTY(x) (HW_IPU_DMFC_STAT(x).B.DMFC_IC_BUFFER_EMPTY)
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_FSIZE - VDI Field Size Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_FSIZE - VDI Field Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register used to control size of VDI C input fields.
 */
typedef union _hw_ipu_vdi_fsize
{
    uint32_t U;
    struct _hw_ipu_vdi_fsize_bitfields
    {
        uint32_t VDI_FWIDTH : 11;      /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t VDI_FHEIGHT : 11;     /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_vdi_fsize_t;

/*!
 * @name Constants and macros for entire IPU_VDI_FSIZE register
 */
/*@{*/
#define HW_IPU_VDI_FSIZE_ADDR(x) ((uintptr_t)(x) + 0x68000U)

#define HW_IPU_VDI_FSIZE(x)      (*(__IO hw_ipu_vdi_fsize_t *) HW_IPU_VDI_FSIZE_ADDR(x))
#define HW_IPU_VDI_FSIZE_RD(x)   (HW_IPU_VDI_FSIZE(x).U)
#define HW_IPU_VDI_FSIZE_WR(x, v) (HW_IPU_VDI_FSIZE(x).U = (v))
#define HW_IPU_VDI_FSIZE_SET(x, v) (HW_IPU_VDI_FSIZE_WR(x, HW_IPU_VDI_FSIZE_RD(x) |  (v)))
#define HW_IPU_VDI_FSIZE_CLR(x, v) (HW_IPU_VDI_FSIZE_WR(x, HW_IPU_VDI_FSIZE_RD(x) & ~(v)))
#define HW_IPU_VDI_FSIZE_TOG(x, v) (HW_IPU_VDI_FSIZE_WR(x, HW_IPU_VDI_FSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_FSIZE bitfields
 */

/*!
 * @name Register IPU_VDI_FSIZE, field VDI_FWIDTH[10:0] (RW)
 *
 * Frame width. The value to be written to this register is the frame's width
 * minus 1. The Frame width should not be smaller than 16. The width must be even.
 * When VDI_CMB_EN bit is clear The Frame width should not be greater than
 * 720968. When VDI_CMB_EN bit is set: The Frame width should not be greater than 1920.
 */
/*@{*/
#define BP_IPU_VDI_FSIZE_VDI_FWIDTH (0U)   /*!< Bit position for IPU_VDI_FSIZE_VDI_FWIDTH. */
#define BM_IPU_VDI_FSIZE_VDI_FWIDTH (0x000007FFU) /*!< Bit mask for IPU_VDI_FSIZE_VDI_FWIDTH. */
#define BS_IPU_VDI_FSIZE_VDI_FWIDTH (11U)  /*!< Bit field size in bits for IPU_VDI_FSIZE_VDI_FWIDTH. */

/*! @brief Read current value of the IPU_VDI_FSIZE_VDI_FWIDTH field. */
#define BR_IPU_VDI_FSIZE_VDI_FWIDTH(x) (HW_IPU_VDI_FSIZE(x).B.VDI_FWIDTH)

/*! @brief Format value for bitfield IPU_VDI_FSIZE_VDI_FWIDTH. */
#define BF_IPU_VDI_FSIZE_VDI_FWIDTH(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_FSIZE_VDI_FWIDTH) & BM_IPU_VDI_FSIZE_VDI_FWIDTH)

/*! @brief Set the VDI_FWIDTH field to a new value. */
#define BW_IPU_VDI_FSIZE_VDI_FWIDTH(x, v) (HW_IPU_VDI_FSIZE_WR(x, (HW_IPU_VDI_FSIZE_RD(x) & ~BM_IPU_VDI_FSIZE_VDI_FWIDTH) | BF_IPU_VDI_FSIZE_VDI_FWIDTH(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_FSIZE, field VDI_FHEIGHT[26:16] (RW)
 *
 * Frame height The value to be written to this register is the frame's height
 * minus 1. The frame height should not be smaller than 16. When VDI_CMB_EN bit is
 * clear: The frame height should not be greater than 1080. The frame's height
 * must be even (which means that both fields have the same height) The frame's
 * height in 4:2:0 format, must be multiple of 4 (which means that both chroma
 * fields have the same height) When VDI_CMB_EN bit is set: The frame height should
 * not be greater than 1200.
 */
/*@{*/
#define BP_IPU_VDI_FSIZE_VDI_FHEIGHT (16U) /*!< Bit position for IPU_VDI_FSIZE_VDI_FHEIGHT. */
#define BM_IPU_VDI_FSIZE_VDI_FHEIGHT (0x07FF0000U) /*!< Bit mask for IPU_VDI_FSIZE_VDI_FHEIGHT. */
#define BS_IPU_VDI_FSIZE_VDI_FHEIGHT (11U) /*!< Bit field size in bits for IPU_VDI_FSIZE_VDI_FHEIGHT. */

/*! @brief Read current value of the IPU_VDI_FSIZE_VDI_FHEIGHT field. */
#define BR_IPU_VDI_FSIZE_VDI_FHEIGHT(x) (HW_IPU_VDI_FSIZE(x).B.VDI_FHEIGHT)

/*! @brief Format value for bitfield IPU_VDI_FSIZE_VDI_FHEIGHT. */
#define BF_IPU_VDI_FSIZE_VDI_FHEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_FSIZE_VDI_FHEIGHT) & BM_IPU_VDI_FSIZE_VDI_FHEIGHT)

/*! @brief Set the VDI_FHEIGHT field to a new value. */
#define BW_IPU_VDI_FSIZE_VDI_FHEIGHT(x, v) (HW_IPU_VDI_FSIZE_WR(x, (HW_IPU_VDI_FSIZE_RD(x) & ~BM_IPU_VDI_FSIZE_VDI_FHEIGHT) | BF_IPU_VDI_FSIZE_VDI_FHEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_C - VDI Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_C - VDI Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register used to control modes of operations of VDI C module.
 */
typedef union _hw_ipu_vdi_c
{
    uint32_t U;
    struct _hw_ipu_vdi_c_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t VDI_CH_422 : 1;       /*!< [1]  */
        uint32_t VDI_MOT_SEL : 2;      /*!< [3:2]  */
        uint32_t VDI_BURST_SIZE1 : 4;  /*!< [7:4]  */
        uint32_t VDI_BURST_SIZE2 : 4;  /*!< [11:8]  */
        uint32_t VDI_BURST_SIZE3 : 4;  /*!< [15:12]  */
        uint32_t VDI_VWM1_SET : 3;     /*!< [18:16]  */
        uint32_t VDI_VWM1_CLR : 3;     /*!< [21:19]  */
        uint32_t VDI_VWM3_SET : 3;     /*!< [24:22]  */
        uint32_t VDI_VWM3_CLR : 3;     /*!< [27:25]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_vdi_c_t;

/*!
 * @name Constants and macros for entire IPU_VDI_C register
 */
/*@{*/
#define HW_IPU_VDI_C_ADDR(x)     ((uintptr_t)(x) + 0x68004U)

#define HW_IPU_VDI_C(x)          (*(__IO hw_ipu_vdi_c_t *) HW_IPU_VDI_C_ADDR(x))
#define HW_IPU_VDI_C_RD(x)       (HW_IPU_VDI_C(x).U)
#define HW_IPU_VDI_C_WR(x, v)    (HW_IPU_VDI_C(x).U = (v))
#define HW_IPU_VDI_C_SET(x, v)   (HW_IPU_VDI_C_WR(x, HW_IPU_VDI_C_RD(x) |  (v)))
#define HW_IPU_VDI_C_CLR(x, v)   (HW_IPU_VDI_C_WR(x, HW_IPU_VDI_C_RD(x) & ~(v)))
#define HW_IPU_VDI_C_TOG(x, v)   (HW_IPU_VDI_C_WR(x, HW_IPU_VDI_C_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_C bitfields
 */

/*!
 * @name Register IPU_VDI_C, field VDI_CH_422[1] (RW)
 *
 * Chroma format at input and output of VDIC.
 *
 * Values:
 * - 0 - Chroma format is 420.
 * - 1 - Chroma format is 422.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_CH_422 (1U)       /*!< Bit position for IPU_VDI_C_VDI_CH_422. */
#define BM_IPU_VDI_C_VDI_CH_422 (0x00000002U) /*!< Bit mask for IPU_VDI_C_VDI_CH_422. */
#define BS_IPU_VDI_C_VDI_CH_422 (1U)       /*!< Bit field size in bits for IPU_VDI_C_VDI_CH_422. */

/*! @brief Read current value of the IPU_VDI_C_VDI_CH_422 field. */
#define BR_IPU_VDI_C_VDI_CH_422(x) (HW_IPU_VDI_C(x).B.VDI_CH_422)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_CH_422. */
#define BF_IPU_VDI_C_VDI_CH_422(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_CH_422) & BM_IPU_VDI_C_VDI_CH_422)

/*! @brief Set the VDI_CH_422 field to a new value. */
#define BW_IPU_VDI_C_VDI_CH_422(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_CH_422) | BF_IPU_VDI_C_VDI_CH_422(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_MOT_SEL[3:2] (RW)
 *
 * Motion select.
 *
 * Values:
 * - 0 - Motion determined by ROM "1" (shared toward medium/high motion).
 * - 1 - Motion determined by ROM "2" (This option will not work well for high
 *     motion).
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_MOT_SEL (2U)      /*!< Bit position for IPU_VDI_C_VDI_MOT_SEL. */
#define BM_IPU_VDI_C_VDI_MOT_SEL (0x0000000CU) /*!< Bit mask for IPU_VDI_C_VDI_MOT_SEL. */
#define BS_IPU_VDI_C_VDI_MOT_SEL (2U)      /*!< Bit field size in bits for IPU_VDI_C_VDI_MOT_SEL. */

/*! @brief Read current value of the IPU_VDI_C_VDI_MOT_SEL field. */
#define BR_IPU_VDI_C_VDI_MOT_SEL(x) (HW_IPU_VDI_C(x).B.VDI_MOT_SEL)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_MOT_SEL. */
#define BF_IPU_VDI_C_VDI_MOT_SEL(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_MOT_SEL) & BM_IPU_VDI_C_VDI_MOT_SEL)

/*! @brief Set the VDI_MOT_SEL field to a new value. */
#define BW_IPU_VDI_C_VDI_MOT_SEL(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_MOT_SEL) | BF_IPU_VDI_C_VDI_MOT_SEL(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_BURST_SIZE1[7:4] (RW)
 *
 * Burst Size for channels 1 or 4 (channels 1 and 4 are not working
 * simultaneously). The VDIC's burst size is restrict by the IDMAC's restriction - This value
 * must match the IDMAC settings and follow the IDMAC's restrictions
 *
 * Values:
 * - 0 - Burst size is 1 access.
 * - 1 - Burst size is 2 accesses.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_BURST_SIZE1 (4U)  /*!< Bit position for IPU_VDI_C_VDI_BURST_SIZE1. */
#define BM_IPU_VDI_C_VDI_BURST_SIZE1 (0x000000F0U) /*!< Bit mask for IPU_VDI_C_VDI_BURST_SIZE1. */
#define BS_IPU_VDI_C_VDI_BURST_SIZE1 (4U)  /*!< Bit field size in bits for IPU_VDI_C_VDI_BURST_SIZE1. */

/*! @brief Read current value of the IPU_VDI_C_VDI_BURST_SIZE1 field. */
#define BR_IPU_VDI_C_VDI_BURST_SIZE1(x) (HW_IPU_VDI_C(x).B.VDI_BURST_SIZE1)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_BURST_SIZE1. */
#define BF_IPU_VDI_C_VDI_BURST_SIZE1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_BURST_SIZE1) & BM_IPU_VDI_C_VDI_BURST_SIZE1)

/*! @brief Set the VDI_BURST_SIZE1 field to a new value. */
#define BW_IPU_VDI_C_VDI_BURST_SIZE1(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_BURST_SIZE1) | BF_IPU_VDI_C_VDI_BURST_SIZE1(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_BURST_SIZE2[11:8] (RW)
 *
 * Burst Size for channel 2. The VDIC's burst size is restrict by the IDMAC's
 * restriction - This value must match the IDMAC settings and follow the IDMAC's
 * restrictions
 *
 * Values:
 * - 0 - Burst size is 1 access.
 * - 1 - Burst size is 2 accesses.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_BURST_SIZE2 (8U)  /*!< Bit position for IPU_VDI_C_VDI_BURST_SIZE2. */
#define BM_IPU_VDI_C_VDI_BURST_SIZE2 (0x00000F00U) /*!< Bit mask for IPU_VDI_C_VDI_BURST_SIZE2. */
#define BS_IPU_VDI_C_VDI_BURST_SIZE2 (4U)  /*!< Bit field size in bits for IPU_VDI_C_VDI_BURST_SIZE2. */

/*! @brief Read current value of the IPU_VDI_C_VDI_BURST_SIZE2 field. */
#define BR_IPU_VDI_C_VDI_BURST_SIZE2(x) (HW_IPU_VDI_C(x).B.VDI_BURST_SIZE2)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_BURST_SIZE2. */
#define BF_IPU_VDI_C_VDI_BURST_SIZE2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_BURST_SIZE2) & BM_IPU_VDI_C_VDI_BURST_SIZE2)

/*! @brief Set the VDI_BURST_SIZE2 field to a new value. */
#define BW_IPU_VDI_C_VDI_BURST_SIZE2(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_BURST_SIZE2) | BF_IPU_VDI_C_VDI_BURST_SIZE2(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_BURST_SIZE3[15:12] (RW)
 *
 * Burst Size for channel 3. The VDIC's burst size is restrict by the IDMAC's
 * restriction - This value must match the IDMAC settings and follow the IDMAC's
 * restrictions
 *
 * Values:
 * - 0 - Burst size is 1 access.
 * - 1 - Burst size is 2 accesses.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_BURST_SIZE3 (12U) /*!< Bit position for IPU_VDI_C_VDI_BURST_SIZE3. */
#define BM_IPU_VDI_C_VDI_BURST_SIZE3 (0x0000F000U) /*!< Bit mask for IPU_VDI_C_VDI_BURST_SIZE3. */
#define BS_IPU_VDI_C_VDI_BURST_SIZE3 (4U)  /*!< Bit field size in bits for IPU_VDI_C_VDI_BURST_SIZE3. */

/*! @brief Read current value of the IPU_VDI_C_VDI_BURST_SIZE3 field. */
#define BR_IPU_VDI_C_VDI_BURST_SIZE3(x) (HW_IPU_VDI_C(x).B.VDI_BURST_SIZE3)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_BURST_SIZE3. */
#define BF_IPU_VDI_C_VDI_BURST_SIZE3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_BURST_SIZE3) & BM_IPU_VDI_C_VDI_BURST_SIZE3)

/*! @brief Set the VDI_BURST_SIZE3 field to a new value. */
#define BW_IPU_VDI_C_VDI_BURST_SIZE3(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_BURST_SIZE3) | BF_IPU_VDI_C_VDI_BURST_SIZE3(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_VWM1_SET[18:16] (RW)
 *
 * VDIC WaterMark "set" level for channel 1 or channel 2 (channels 1 and 4 are
 * not working simultaneously).
 *
 * Values:
 * - 0 - set watermark level when FIFO1 is full on 1/8 of their size.
 * - 1 - set watermark level when FIFO1 is full on 2/8 of their size.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_VWM1_SET (16U)    /*!< Bit position for IPU_VDI_C_VDI_VWM1_SET. */
#define BM_IPU_VDI_C_VDI_VWM1_SET (0x00070000U) /*!< Bit mask for IPU_VDI_C_VDI_VWM1_SET. */
#define BS_IPU_VDI_C_VDI_VWM1_SET (3U)     /*!< Bit field size in bits for IPU_VDI_C_VDI_VWM1_SET. */

/*! @brief Read current value of the IPU_VDI_C_VDI_VWM1_SET field. */
#define BR_IPU_VDI_C_VDI_VWM1_SET(x) (HW_IPU_VDI_C(x).B.VDI_VWM1_SET)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_VWM1_SET. */
#define BF_IPU_VDI_C_VDI_VWM1_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_VWM1_SET) & BM_IPU_VDI_C_VDI_VWM1_SET)

/*! @brief Set the VDI_VWM1_SET field to a new value. */
#define BW_IPU_VDI_C_VDI_VWM1_SET(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_VWM1_SET) | BF_IPU_VDI_C_VDI_VWM1_SET(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_VWM1_CLR[21:19] (RW)
 *
 * VDIC WaterMark "clear" level for channel 1 or channel 4 (channels 1 and 4 are
 * not working simultaneously).
 *
 * Values:
 * - 0 - clear watermark level when FIFO1 is full on 1/8 of their size.
 * - 1 - clear watermark level when FIFO1 is full on 2/8 of their size.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_VWM1_CLR (19U)    /*!< Bit position for IPU_VDI_C_VDI_VWM1_CLR. */
#define BM_IPU_VDI_C_VDI_VWM1_CLR (0x00380000U) /*!< Bit mask for IPU_VDI_C_VDI_VWM1_CLR. */
#define BS_IPU_VDI_C_VDI_VWM1_CLR (3U)     /*!< Bit field size in bits for IPU_VDI_C_VDI_VWM1_CLR. */

/*! @brief Read current value of the IPU_VDI_C_VDI_VWM1_CLR field. */
#define BR_IPU_VDI_C_VDI_VWM1_CLR(x) (HW_IPU_VDI_C(x).B.VDI_VWM1_CLR)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_VWM1_CLR. */
#define BF_IPU_VDI_C_VDI_VWM1_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_VWM1_CLR) & BM_IPU_VDI_C_VDI_VWM1_CLR)

/*! @brief Set the VDI_VWM1_CLR field to a new value. */
#define BW_IPU_VDI_C_VDI_VWM1_CLR(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_VWM1_CLR) | BF_IPU_VDI_C_VDI_VWM1_CLR(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_VWM3_SET[24:22] (RW)
 *
 * VDIC WaterMark "set" level for channel 3.
 *
 * Values:
 * - 0 - set watermark level when FIFO3 is full on 1/8 of their size.
 * - 1 - set watermark level when FIFO3 is full on 2/8 of their size.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_VWM3_SET (22U)    /*!< Bit position for IPU_VDI_C_VDI_VWM3_SET. */
#define BM_IPU_VDI_C_VDI_VWM3_SET (0x01C00000U) /*!< Bit mask for IPU_VDI_C_VDI_VWM3_SET. */
#define BS_IPU_VDI_C_VDI_VWM3_SET (3U)     /*!< Bit field size in bits for IPU_VDI_C_VDI_VWM3_SET. */

/*! @brief Read current value of the IPU_VDI_C_VDI_VWM3_SET field. */
#define BR_IPU_VDI_C_VDI_VWM3_SET(x) (HW_IPU_VDI_C(x).B.VDI_VWM3_SET)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_VWM3_SET. */
#define BF_IPU_VDI_C_VDI_VWM3_SET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_VWM3_SET) & BM_IPU_VDI_C_VDI_VWM3_SET)

/*! @brief Set the VDI_VWM3_SET field to a new value. */
#define BW_IPU_VDI_C_VDI_VWM3_SET(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_VWM3_SET) | BF_IPU_VDI_C_VDI_VWM3_SET(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C, field VDI_VWM3_CLR[27:25] (RW)
 *
 * VDIC WaterMark "clear" level for channel 3.
 *
 * Values:
 * - 0 - clear watermark level when FIFO3 is full on 1/8 of their size.
 * - 1 - clear watermark level when FIFO3 is full on 2/8 of their size.
 */
/*@{*/
#define BP_IPU_VDI_C_VDI_VWM3_CLR (25U)    /*!< Bit position for IPU_VDI_C_VDI_VWM3_CLR. */
#define BM_IPU_VDI_C_VDI_VWM3_CLR (0x0E000000U) /*!< Bit mask for IPU_VDI_C_VDI_VWM3_CLR. */
#define BS_IPU_VDI_C_VDI_VWM3_CLR (3U)     /*!< Bit field size in bits for IPU_VDI_C_VDI_VWM3_CLR. */

/*! @brief Read current value of the IPU_VDI_C_VDI_VWM3_CLR field. */
#define BR_IPU_VDI_C_VDI_VWM3_CLR(x) (HW_IPU_VDI_C(x).B.VDI_VWM3_CLR)

/*! @brief Format value for bitfield IPU_VDI_C_VDI_VWM3_CLR. */
#define BF_IPU_VDI_C_VDI_VWM3_CLR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C_VDI_VWM3_CLR) & BM_IPU_VDI_C_VDI_VWM3_CLR)

/*! @brief Set the VDI_VWM3_CLR field to a new value. */
#define BW_IPU_VDI_C_VDI_VWM3_CLR(x, v) (HW_IPU_VDI_C_WR(x, (HW_IPU_VDI_C_RD(x) & ~BM_IPU_VDI_C_VDI_VWM3_CLR) | BF_IPU_VDI_C_VDI_VWM3_CLR(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_C2_ - VDI Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_C2_ - VDI Control Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register used to control modes of operations of VDIC module.
 */
typedef union _hw_ipu_vdi_c2_
{
    uint32_t U;
    struct _hw_ipu_vdi_c2__bitfields
    {
        uint32_t VDI_CMB_EN : 1;       /*!< [0]  */
        uint32_t VDI_KEY_COLOR_EN : 1; /*!< [1]  */
        uint32_t VDI_GLB_A_EN : 1;     /*!< [2]  */
        uint32_t VDI_PLANE_1_EN : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_ipu_vdi_c2__t;

/*!
 * @name Constants and macros for entire IPU_VDI_C2_ register
 */
/*@{*/
#define HW_IPU_VDI_C2__ADDR(x)   ((uintptr_t)(x) + 0x68008U)

#define HW_IPU_VDI_C2_(x)        (*(__IO hw_ipu_vdi_c2__t *) HW_IPU_VDI_C2__ADDR(x))
#define HW_IPU_VDI_C2__RD(x)     (HW_IPU_VDI_C2_(x).U)
#define HW_IPU_VDI_C2__WR(x, v)  (HW_IPU_VDI_C2_(x).U = (v))
#define HW_IPU_VDI_C2__SET(x, v) (HW_IPU_VDI_C2__WR(x, HW_IPU_VDI_C2__RD(x) |  (v)))
#define HW_IPU_VDI_C2__CLR(x, v) (HW_IPU_VDI_C2__WR(x, HW_IPU_VDI_C2__RD(x) & ~(v)))
#define HW_IPU_VDI_C2__TOG(x, v) (HW_IPU_VDI_C2__WR(x, HW_IPU_VDI_C2__RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_C2_ bitfields
 */

/*!
 * @name Register IPU_VDI_C2_, field VDI_CMB_EN[0] (RW)
 *
 * Combining enable
 *
 * Values:
 * - 0 - Combining disabled. The VDIC works in de-interlacing mode
 * - 1 - Combining enabled. The de-interlacing mode is not functional
 */
/*@{*/
#define BP_IPU_VDI_C2__VDI_CMB_EN (0U)     /*!< Bit position for IPU_VDI_C2__VDI_CMB_EN. */
#define BM_IPU_VDI_C2__VDI_CMB_EN (0x00000001U) /*!< Bit mask for IPU_VDI_C2__VDI_CMB_EN. */
#define BS_IPU_VDI_C2__VDI_CMB_EN (1U)     /*!< Bit field size in bits for IPU_VDI_C2__VDI_CMB_EN. */

/*! @brief Read current value of the IPU_VDI_C2__VDI_CMB_EN field. */
#define BR_IPU_VDI_C2__VDI_CMB_EN(x) (HW_IPU_VDI_C2_(x).B.VDI_CMB_EN)

/*! @brief Format value for bitfield IPU_VDI_C2__VDI_CMB_EN. */
#define BF_IPU_VDI_C2__VDI_CMB_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C2__VDI_CMB_EN) & BM_IPU_VDI_C2__VDI_CMB_EN)

/*! @brief Set the VDI_CMB_EN field to a new value. */
#define BW_IPU_VDI_C2__VDI_CMB_EN(x, v) (HW_IPU_VDI_C2__WR(x, (HW_IPU_VDI_C2__RD(x) & ~BM_IPU_VDI_C2__VDI_CMB_EN) | BF_IPU_VDI_C2__VDI_CMB_EN(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C2_, field VDI_KEY_COLOR_EN[1] (RW)
 *
 * Key Color Enable
 *
 * Values:
 * - 0 - Key Color disabled.
 * - 1 - Key color enabled
 */
/*@{*/
#define BP_IPU_VDI_C2__VDI_KEY_COLOR_EN (1U) /*!< Bit position for IPU_VDI_C2__VDI_KEY_COLOR_EN. */
#define BM_IPU_VDI_C2__VDI_KEY_COLOR_EN (0x00000002U) /*!< Bit mask for IPU_VDI_C2__VDI_KEY_COLOR_EN. */
#define BS_IPU_VDI_C2__VDI_KEY_COLOR_EN (1U) /*!< Bit field size in bits for IPU_VDI_C2__VDI_KEY_COLOR_EN. */

/*! @brief Read current value of the IPU_VDI_C2__VDI_KEY_COLOR_EN field. */
#define BR_IPU_VDI_C2__VDI_KEY_COLOR_EN(x) (HW_IPU_VDI_C2_(x).B.VDI_KEY_COLOR_EN)

/*! @brief Format value for bitfield IPU_VDI_C2__VDI_KEY_COLOR_EN. */
#define BF_IPU_VDI_C2__VDI_KEY_COLOR_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C2__VDI_KEY_COLOR_EN) & BM_IPU_VDI_C2__VDI_KEY_COLOR_EN)

/*! @brief Set the VDI_KEY_COLOR_EN field to a new value. */
#define BW_IPU_VDI_C2__VDI_KEY_COLOR_EN(x, v) (HW_IPU_VDI_C2__WR(x, (HW_IPU_VDI_C2__RD(x) & ~BM_IPU_VDI_C2__VDI_KEY_COLOR_EN) | BF_IPU_VDI_C2__VDI_KEY_COLOR_EN(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C2_, field VDI_GLB_A_EN[2] (RW)
 *
 * Global alpha enable
 *
 * Values:
 * - 0 - Alpha is local
 * - 1 - Alpha is global
 */
/*@{*/
#define BP_IPU_VDI_C2__VDI_GLB_A_EN (2U)   /*!< Bit position for IPU_VDI_C2__VDI_GLB_A_EN. */
#define BM_IPU_VDI_C2__VDI_GLB_A_EN (0x00000004U) /*!< Bit mask for IPU_VDI_C2__VDI_GLB_A_EN. */
#define BS_IPU_VDI_C2__VDI_GLB_A_EN (1U)   /*!< Bit field size in bits for IPU_VDI_C2__VDI_GLB_A_EN. */

/*! @brief Read current value of the IPU_VDI_C2__VDI_GLB_A_EN field. */
#define BR_IPU_VDI_C2__VDI_GLB_A_EN(x) (HW_IPU_VDI_C2_(x).B.VDI_GLB_A_EN)

/*! @brief Format value for bitfield IPU_VDI_C2__VDI_GLB_A_EN. */
#define BF_IPU_VDI_C2__VDI_GLB_A_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C2__VDI_GLB_A_EN) & BM_IPU_VDI_C2__VDI_GLB_A_EN)

/*! @brief Set the VDI_GLB_A_EN field to a new value. */
#define BW_IPU_VDI_C2__VDI_GLB_A_EN(x, v) (HW_IPU_VDI_C2__WR(x, (HW_IPU_VDI_C2__RD(x) & ~BM_IPU_VDI_C2__VDI_GLB_A_EN) | BF_IPU_VDI_C2__VDI_GLB_A_EN(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_C2_, field VDI_PLANE_1_EN[3] (RW)
 *
 * Plane 1 enable
 *
 * Values:
 * - 0 - plane #1 is disabled
 * - 1 - plane #1 is enabled
 */
/*@{*/
#define BP_IPU_VDI_C2__VDI_PLANE_1_EN (3U) /*!< Bit position for IPU_VDI_C2__VDI_PLANE_1_EN. */
#define BM_IPU_VDI_C2__VDI_PLANE_1_EN (0x00000008U) /*!< Bit mask for IPU_VDI_C2__VDI_PLANE_1_EN. */
#define BS_IPU_VDI_C2__VDI_PLANE_1_EN (1U) /*!< Bit field size in bits for IPU_VDI_C2__VDI_PLANE_1_EN. */

/*! @brief Read current value of the IPU_VDI_C2__VDI_PLANE_1_EN field. */
#define BR_IPU_VDI_C2__VDI_PLANE_1_EN(x) (HW_IPU_VDI_C2_(x).B.VDI_PLANE_1_EN)

/*! @brief Format value for bitfield IPU_VDI_C2__VDI_PLANE_1_EN. */
#define BF_IPU_VDI_C2__VDI_PLANE_1_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_C2__VDI_PLANE_1_EN) & BM_IPU_VDI_C2__VDI_PLANE_1_EN)

/*! @brief Set the VDI_PLANE_1_EN field to a new value. */
#define BW_IPU_VDI_C2__VDI_PLANE_1_EN(x, v) (HW_IPU_VDI_C2__WR(x, (HW_IPU_VDI_C2__RD(x) & ~BM_IPU_VDI_C2__VDI_PLANE_1_EN) | BF_IPU_VDI_C2__VDI_PLANE_1_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_CMDP_1 - VDI Combining Parameters Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_CMDP_1 - VDI Combining Parameters Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds combining paramemters.
 */
typedef union _hw_ipu_vdi_cmdp_1
{
    uint32_t U;
    struct _hw_ipu_vdi_cmdp_1_bitfields
    {
        uint32_t VDI_KEY_COLOR_B : 8;  /*!< [7:0]  */
        uint32_t VDI_KEY_COLOR_G : 8;  /*!< [15:8]  */
        uint32_t VDI_KEY_COLOR_R : 8;  /*!< [23:16]  */
        uint32_t VDI_ALPHA : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_vdi_cmdp_1_t;

/*!
 * @name Constants and macros for entire IPU_VDI_CMDP_1 register
 */
/*@{*/
#define HW_IPU_VDI_CMDP_1_ADDR(x) ((uintptr_t)(x) + 0x6800CU)

#define HW_IPU_VDI_CMDP_1(x)     (*(__IO hw_ipu_vdi_cmdp_1_t *) HW_IPU_VDI_CMDP_1_ADDR(x))
#define HW_IPU_VDI_CMDP_1_RD(x)  (HW_IPU_VDI_CMDP_1(x).U)
#define HW_IPU_VDI_CMDP_1_WR(x, v) (HW_IPU_VDI_CMDP_1(x).U = (v))
#define HW_IPU_VDI_CMDP_1_SET(x, v) (HW_IPU_VDI_CMDP_1_WR(x, HW_IPU_VDI_CMDP_1_RD(x) |  (v)))
#define HW_IPU_VDI_CMDP_1_CLR(x, v) (HW_IPU_VDI_CMDP_1_WR(x, HW_IPU_VDI_CMDP_1_RD(x) & ~(v)))
#define HW_IPU_VDI_CMDP_1_TOG(x, v) (HW_IPU_VDI_CMDP_1_WR(x, HW_IPU_VDI_CMDP_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_CMDP_1 bitfields
 */

/*!
 * @name Register IPU_VDI_CMDP_1, field VDI_KEY_COLOR_B[7:0] (RW)
 *
 * Blue component of Key Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B (0U) /*!< Bit position for IPU_VDI_CMDP_1_VDI_KEY_COLOR_B. */
#define BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B (0x000000FFU) /*!< Bit mask for IPU_VDI_CMDP_1_VDI_KEY_COLOR_B. */
#define BS_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_1_VDI_KEY_COLOR_B. */

/*! @brief Read current value of the IPU_VDI_CMDP_1_VDI_KEY_COLOR_B field. */
#define BR_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B(x) (HW_IPU_VDI_CMDP_1(x).B.VDI_KEY_COLOR_B)

/*! @brief Format value for bitfield IPU_VDI_CMDP_1_VDI_KEY_COLOR_B. */
#define BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B) & BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B)

/*! @brief Set the VDI_KEY_COLOR_B field to a new value. */
#define BW_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B(x, v) (HW_IPU_VDI_CMDP_1_WR(x, (HW_IPU_VDI_CMDP_1_RD(x) & ~BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B) | BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_B(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_CMDP_1, field VDI_KEY_COLOR_G[15:8] (RW)
 *
 * Green component of Key Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G (8U) /*!< Bit position for IPU_VDI_CMDP_1_VDI_KEY_COLOR_G. */
#define BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G (0x0000FF00U) /*!< Bit mask for IPU_VDI_CMDP_1_VDI_KEY_COLOR_G. */
#define BS_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_1_VDI_KEY_COLOR_G. */

/*! @brief Read current value of the IPU_VDI_CMDP_1_VDI_KEY_COLOR_G field. */
#define BR_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G(x) (HW_IPU_VDI_CMDP_1(x).B.VDI_KEY_COLOR_G)

/*! @brief Format value for bitfield IPU_VDI_CMDP_1_VDI_KEY_COLOR_G. */
#define BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G) & BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G)

/*! @brief Set the VDI_KEY_COLOR_G field to a new value. */
#define BW_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G(x, v) (HW_IPU_VDI_CMDP_1_WR(x, (HW_IPU_VDI_CMDP_1_RD(x) & ~BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G) | BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_G(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_CMDP_1, field VDI_KEY_COLOR_R[23:16] (RW)
 *
 * Red component of Key Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R (16U) /*!< Bit position for IPU_VDI_CMDP_1_VDI_KEY_COLOR_R. */
#define BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R (0x00FF0000U) /*!< Bit mask for IPU_VDI_CMDP_1_VDI_KEY_COLOR_R. */
#define BS_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_1_VDI_KEY_COLOR_R. */

/*! @brief Read current value of the IPU_VDI_CMDP_1_VDI_KEY_COLOR_R field. */
#define BR_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R(x) (HW_IPU_VDI_CMDP_1(x).B.VDI_KEY_COLOR_R)

/*! @brief Format value for bitfield IPU_VDI_CMDP_1_VDI_KEY_COLOR_R. */
#define BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R) & BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R)

/*! @brief Set the VDI_KEY_COLOR_R field to a new value. */
#define BW_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R(x, v) (HW_IPU_VDI_CMDP_1_WR(x, (HW_IPU_VDI_CMDP_1_RD(x) & ~BM_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R) | BF_IPU_VDI_CMDP_1_VDI_KEY_COLOR_R(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_CMDP_1, field VDI_ALPHA[31:24] (RW)
 *
 * Global Alpha Actual value of the alpha is VDI_ALPHA + VDI_ALPHA[7]
 */
/*@{*/
#define BP_IPU_VDI_CMDP_1_VDI_ALPHA (24U)  /*!< Bit position for IPU_VDI_CMDP_1_VDI_ALPHA. */
#define BM_IPU_VDI_CMDP_1_VDI_ALPHA (0xFF000000U) /*!< Bit mask for IPU_VDI_CMDP_1_VDI_ALPHA. */
#define BS_IPU_VDI_CMDP_1_VDI_ALPHA (8U)   /*!< Bit field size in bits for IPU_VDI_CMDP_1_VDI_ALPHA. */

/*! @brief Read current value of the IPU_VDI_CMDP_1_VDI_ALPHA field. */
#define BR_IPU_VDI_CMDP_1_VDI_ALPHA(x) (HW_IPU_VDI_CMDP_1(x).B.VDI_ALPHA)

/*! @brief Format value for bitfield IPU_VDI_CMDP_1_VDI_ALPHA. */
#define BF_IPU_VDI_CMDP_1_VDI_ALPHA(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_1_VDI_ALPHA) & BM_IPU_VDI_CMDP_1_VDI_ALPHA)

/*! @brief Set the VDI_ALPHA field to a new value. */
#define BW_IPU_VDI_CMDP_1_VDI_ALPHA(x, v) (HW_IPU_VDI_CMDP_1_WR(x, (HW_IPU_VDI_CMDP_1_RD(x) & ~BM_IPU_VDI_CMDP_1_VDI_ALPHA) | BF_IPU_VDI_CMDP_1_VDI_ALPHA(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_CMDP_2 - VDI Combining Parameters Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_CMDP_2 - VDI Combining Parameters Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds combining paramemters.
 */
typedef union _hw_ipu_vdi_cmdp_2
{
    uint32_t U;
    struct _hw_ipu_vdi_cmdp_2_bitfields
    {
        uint32_t VDI_KEY_COLOR_B : 8;  /*!< [7:0]  */
        uint32_t VDI_KEY_COLOR_G : 8;  /*!< [15:8]  */
        uint32_t VDI_KEY_COLOR_R : 8;  /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_ipu_vdi_cmdp_2_t;

/*!
 * @name Constants and macros for entire IPU_VDI_CMDP_2 register
 */
/*@{*/
#define HW_IPU_VDI_CMDP_2_ADDR(x) ((uintptr_t)(x) + 0x68010U)

#define HW_IPU_VDI_CMDP_2(x)     (*(__IO hw_ipu_vdi_cmdp_2_t *) HW_IPU_VDI_CMDP_2_ADDR(x))
#define HW_IPU_VDI_CMDP_2_RD(x)  (HW_IPU_VDI_CMDP_2(x).U)
#define HW_IPU_VDI_CMDP_2_WR(x, v) (HW_IPU_VDI_CMDP_2(x).U = (v))
#define HW_IPU_VDI_CMDP_2_SET(x, v) (HW_IPU_VDI_CMDP_2_WR(x, HW_IPU_VDI_CMDP_2_RD(x) |  (v)))
#define HW_IPU_VDI_CMDP_2_CLR(x, v) (HW_IPU_VDI_CMDP_2_WR(x, HW_IPU_VDI_CMDP_2_RD(x) & ~(v)))
#define HW_IPU_VDI_CMDP_2_TOG(x, v) (HW_IPU_VDI_CMDP_2_WR(x, HW_IPU_VDI_CMDP_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_CMDP_2 bitfields
 */

/*!
 * @name Register IPU_VDI_CMDP_2, field VDI_KEY_COLOR_B[7:0] (RW)
 *
 * Blue component of background Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B (0U) /*!< Bit position for IPU_VDI_CMDP_2_VDI_KEY_COLOR_B. */
#define BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B (0x000000FFU) /*!< Bit mask for IPU_VDI_CMDP_2_VDI_KEY_COLOR_B. */
#define BS_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_2_VDI_KEY_COLOR_B. */

/*! @brief Read current value of the IPU_VDI_CMDP_2_VDI_KEY_COLOR_B field. */
#define BR_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B(x) (HW_IPU_VDI_CMDP_2(x).B.VDI_KEY_COLOR_B)

/*! @brief Format value for bitfield IPU_VDI_CMDP_2_VDI_KEY_COLOR_B. */
#define BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B) & BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B)

/*! @brief Set the VDI_KEY_COLOR_B field to a new value. */
#define BW_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B(x, v) (HW_IPU_VDI_CMDP_2_WR(x, (HW_IPU_VDI_CMDP_2_RD(x) & ~BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B) | BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_B(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_CMDP_2, field VDI_KEY_COLOR_G[15:8] (RW)
 *
 * Green component of background Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G (8U) /*!< Bit position for IPU_VDI_CMDP_2_VDI_KEY_COLOR_G. */
#define BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G (0x0000FF00U) /*!< Bit mask for IPU_VDI_CMDP_2_VDI_KEY_COLOR_G. */
#define BS_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_2_VDI_KEY_COLOR_G. */

/*! @brief Read current value of the IPU_VDI_CMDP_2_VDI_KEY_COLOR_G field. */
#define BR_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G(x) (HW_IPU_VDI_CMDP_2(x).B.VDI_KEY_COLOR_G)

/*! @brief Format value for bitfield IPU_VDI_CMDP_2_VDI_KEY_COLOR_G. */
#define BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G) & BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G)

/*! @brief Set the VDI_KEY_COLOR_G field to a new value. */
#define BW_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G(x, v) (HW_IPU_VDI_CMDP_2_WR(x, (HW_IPU_VDI_CMDP_2_RD(x) & ~BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G) | BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_G(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_CMDP_2, field VDI_KEY_COLOR_R[23:16] (RW)
 *
 * Red component of background Color
 */
/*@{*/
#define BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R (16U) /*!< Bit position for IPU_VDI_CMDP_2_VDI_KEY_COLOR_R. */
#define BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R (0x00FF0000U) /*!< Bit mask for IPU_VDI_CMDP_2_VDI_KEY_COLOR_R. */
#define BS_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R (8U) /*!< Bit field size in bits for IPU_VDI_CMDP_2_VDI_KEY_COLOR_R. */

/*! @brief Read current value of the IPU_VDI_CMDP_2_VDI_KEY_COLOR_R field. */
#define BR_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R(x) (HW_IPU_VDI_CMDP_2(x).B.VDI_KEY_COLOR_R)

/*! @brief Format value for bitfield IPU_VDI_CMDP_2_VDI_KEY_COLOR_R. */
#define BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R) & BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R)

/*! @brief Set the VDI_KEY_COLOR_R field to a new value. */
#define BW_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R(x, v) (HW_IPU_VDI_CMDP_2_WR(x, (HW_IPU_VDI_CMDP_2_RD(x) & ~BM_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R) | BF_IPU_VDI_CMDP_2_VDI_KEY_COLOR_R(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_PS_1 - VDI Plane Size Register 1
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_PS_1 - VDI Plane Size Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds the plane size's paramemters.
 */
typedef union _hw_ipu_vdi_ps_1
{
    uint32_t U;
    struct _hw_ipu_vdi_ps_1_bitfields
    {
        uint32_t VDI_FWIDTH1 : 11;     /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t VDI_FHEIGHT1 : 11;    /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_vdi_ps_1_t;

/*!
 * @name Constants and macros for entire IPU_VDI_PS_1 register
 */
/*@{*/
#define HW_IPU_VDI_PS_1_ADDR(x)  ((uintptr_t)(x) + 0x68014U)

#define HW_IPU_VDI_PS_1(x)       (*(__IO hw_ipu_vdi_ps_1_t *) HW_IPU_VDI_PS_1_ADDR(x))
#define HW_IPU_VDI_PS_1_RD(x)    (HW_IPU_VDI_PS_1(x).U)
#define HW_IPU_VDI_PS_1_WR(x, v) (HW_IPU_VDI_PS_1(x).U = (v))
#define HW_IPU_VDI_PS_1_SET(x, v) (HW_IPU_VDI_PS_1_WR(x, HW_IPU_VDI_PS_1_RD(x) |  (v)))
#define HW_IPU_VDI_PS_1_CLR(x, v) (HW_IPU_VDI_PS_1_WR(x, HW_IPU_VDI_PS_1_RD(x) & ~(v)))
#define HW_IPU_VDI_PS_1_TOG(x, v) (HW_IPU_VDI_PS_1_WR(x, HW_IPU_VDI_PS_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_PS_1 bitfields
 */

/*!
 * @name Register IPU_VDI_PS_1, field VDI_FWIDTH1[10:0] (RW)
 *
 * Plane 1 width. The value to be written to this register is the plane's width
 * minus 1. The Plane width should not be smaller than 16. The Plane width should
 * not be greater than 1920. The width must be even.
 */
/*@{*/
#define BP_IPU_VDI_PS_1_VDI_FWIDTH1 (0U)   /*!< Bit position for IPU_VDI_PS_1_VDI_FWIDTH1. */
#define BM_IPU_VDI_PS_1_VDI_FWIDTH1 (0x000007FFU) /*!< Bit mask for IPU_VDI_PS_1_VDI_FWIDTH1. */
#define BS_IPU_VDI_PS_1_VDI_FWIDTH1 (11U)  /*!< Bit field size in bits for IPU_VDI_PS_1_VDI_FWIDTH1. */

/*! @brief Read current value of the IPU_VDI_PS_1_VDI_FWIDTH1 field. */
#define BR_IPU_VDI_PS_1_VDI_FWIDTH1(x) (HW_IPU_VDI_PS_1(x).B.VDI_FWIDTH1)

/*! @brief Format value for bitfield IPU_VDI_PS_1_VDI_FWIDTH1. */
#define BF_IPU_VDI_PS_1_VDI_FWIDTH1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_1_VDI_FWIDTH1) & BM_IPU_VDI_PS_1_VDI_FWIDTH1)

/*! @brief Set the VDI_FWIDTH1 field to a new value. */
#define BW_IPU_VDI_PS_1_VDI_FWIDTH1(x, v) (HW_IPU_VDI_PS_1_WR(x, (HW_IPU_VDI_PS_1_RD(x) & ~BM_IPU_VDI_PS_1_VDI_FWIDTH1) | BF_IPU_VDI_PS_1_VDI_FWIDTH1(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_PS_1, field VDI_FHEIGHT1[26:16] (RW)
 *
 * Plane 1 height The value to be written to this register is the plane's height
 * minus 1. The Plane height should not be smaller than 16. The Plane height
 * should not be greater than 1200. The Plane's height must be even
 */
/*@{*/
#define BP_IPU_VDI_PS_1_VDI_FHEIGHT1 (16U) /*!< Bit position for IPU_VDI_PS_1_VDI_FHEIGHT1. */
#define BM_IPU_VDI_PS_1_VDI_FHEIGHT1 (0x07FF0000U) /*!< Bit mask for IPU_VDI_PS_1_VDI_FHEIGHT1. */
#define BS_IPU_VDI_PS_1_VDI_FHEIGHT1 (11U) /*!< Bit field size in bits for IPU_VDI_PS_1_VDI_FHEIGHT1. */

/*! @brief Read current value of the IPU_VDI_PS_1_VDI_FHEIGHT1 field. */
#define BR_IPU_VDI_PS_1_VDI_FHEIGHT1(x) (HW_IPU_VDI_PS_1(x).B.VDI_FHEIGHT1)

/*! @brief Format value for bitfield IPU_VDI_PS_1_VDI_FHEIGHT1. */
#define BF_IPU_VDI_PS_1_VDI_FHEIGHT1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_1_VDI_FHEIGHT1) & BM_IPU_VDI_PS_1_VDI_FHEIGHT1)

/*! @brief Set the VDI_FHEIGHT1 field to a new value. */
#define BW_IPU_VDI_PS_1_VDI_FHEIGHT1(x, v) (HW_IPU_VDI_PS_1_WR(x, (HW_IPU_VDI_PS_1_RD(x) & ~BM_IPU_VDI_PS_1_VDI_FHEIGHT1) | BF_IPU_VDI_PS_1_VDI_FHEIGHT1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_PS_2 - VDI Plane Size Register 2
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_PS_2 - VDI Plane Size Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds the plane's offset paramemters.
 */
typedef union _hw_ipu_vdi_ps_2
{
    uint32_t U;
    struct _hw_ipu_vdi_ps_2_bitfields
    {
        uint32_t VDI_OFFSET_HOR1 : 11; /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t VDI_OFFSET_VER1 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_vdi_ps_2_t;

/*!
 * @name Constants and macros for entire IPU_VDI_PS_2 register
 */
/*@{*/
#define HW_IPU_VDI_PS_2_ADDR(x)  ((uintptr_t)(x) + 0x68018U)

#define HW_IPU_VDI_PS_2(x)       (*(__IO hw_ipu_vdi_ps_2_t *) HW_IPU_VDI_PS_2_ADDR(x))
#define HW_IPU_VDI_PS_2_RD(x)    (HW_IPU_VDI_PS_2(x).U)
#define HW_IPU_VDI_PS_2_WR(x, v) (HW_IPU_VDI_PS_2(x).U = (v))
#define HW_IPU_VDI_PS_2_SET(x, v) (HW_IPU_VDI_PS_2_WR(x, HW_IPU_VDI_PS_2_RD(x) |  (v)))
#define HW_IPU_VDI_PS_2_CLR(x, v) (HW_IPU_VDI_PS_2_WR(x, HW_IPU_VDI_PS_2_RD(x) & ~(v)))
#define HW_IPU_VDI_PS_2_TOG(x, v) (HW_IPU_VDI_PS_2_WR(x, HW_IPU_VDI_PS_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_PS_2 bitfields
 */

/*!
 * @name Register IPU_VDI_PS_2, field VDI_OFFSET_HOR1[10:0] (RW)
 *
 * Horizontal offset of plane 1
 */
/*@{*/
#define BP_IPU_VDI_PS_2_VDI_OFFSET_HOR1 (0U) /*!< Bit position for IPU_VDI_PS_2_VDI_OFFSET_HOR1. */
#define BM_IPU_VDI_PS_2_VDI_OFFSET_HOR1 (0x000007FFU) /*!< Bit mask for IPU_VDI_PS_2_VDI_OFFSET_HOR1. */
#define BS_IPU_VDI_PS_2_VDI_OFFSET_HOR1 (11U) /*!< Bit field size in bits for IPU_VDI_PS_2_VDI_OFFSET_HOR1. */

/*! @brief Read current value of the IPU_VDI_PS_2_VDI_OFFSET_HOR1 field. */
#define BR_IPU_VDI_PS_2_VDI_OFFSET_HOR1(x) (HW_IPU_VDI_PS_2(x).B.VDI_OFFSET_HOR1)

/*! @brief Format value for bitfield IPU_VDI_PS_2_VDI_OFFSET_HOR1. */
#define BF_IPU_VDI_PS_2_VDI_OFFSET_HOR1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_2_VDI_OFFSET_HOR1) & BM_IPU_VDI_PS_2_VDI_OFFSET_HOR1)

/*! @brief Set the VDI_OFFSET_HOR1 field to a new value. */
#define BW_IPU_VDI_PS_2_VDI_OFFSET_HOR1(x, v) (HW_IPU_VDI_PS_2_WR(x, (HW_IPU_VDI_PS_2_RD(x) & ~BM_IPU_VDI_PS_2_VDI_OFFSET_HOR1) | BF_IPU_VDI_PS_2_VDI_OFFSET_HOR1(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_PS_2, field VDI_OFFSET_VER1[26:16] (RW)
 *
 * Vertical offset of plane 1
 */
/*@{*/
#define BP_IPU_VDI_PS_2_VDI_OFFSET_VER1 (16U) /*!< Bit position for IPU_VDI_PS_2_VDI_OFFSET_VER1. */
#define BM_IPU_VDI_PS_2_VDI_OFFSET_VER1 (0x07FF0000U) /*!< Bit mask for IPU_VDI_PS_2_VDI_OFFSET_VER1. */
#define BS_IPU_VDI_PS_2_VDI_OFFSET_VER1 (11U) /*!< Bit field size in bits for IPU_VDI_PS_2_VDI_OFFSET_VER1. */

/*! @brief Read current value of the IPU_VDI_PS_2_VDI_OFFSET_VER1 field. */
#define BR_IPU_VDI_PS_2_VDI_OFFSET_VER1(x) (HW_IPU_VDI_PS_2(x).B.VDI_OFFSET_VER1)

/*! @brief Format value for bitfield IPU_VDI_PS_2_VDI_OFFSET_VER1. */
#define BF_IPU_VDI_PS_2_VDI_OFFSET_VER1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_2_VDI_OFFSET_VER1) & BM_IPU_VDI_PS_2_VDI_OFFSET_VER1)

/*! @brief Set the VDI_OFFSET_VER1 field to a new value. */
#define BW_IPU_VDI_PS_2_VDI_OFFSET_VER1(x, v) (HW_IPU_VDI_PS_2_WR(x, (HW_IPU_VDI_PS_2_RD(x) & ~BM_IPU_VDI_PS_2_VDI_OFFSET_VER1) | BF_IPU_VDI_PS_2_VDI_OFFSET_VER1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_PS_3 - VDI Plane Size Register 3
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_PS_3 - VDI Plane Size Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds the plane size's paramemters.
 */
typedef union _hw_ipu_vdi_ps_3
{
    uint32_t U;
    struct _hw_ipu_vdi_ps_3_bitfields
    {
        uint32_t VDI_FWIDTH3 : 11;     /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t VDI_FHEIGHT3 : 11;    /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_vdi_ps_3_t;

/*!
 * @name Constants and macros for entire IPU_VDI_PS_3 register
 */
/*@{*/
#define HW_IPU_VDI_PS_3_ADDR(x)  ((uintptr_t)(x) + 0x6801CU)

#define HW_IPU_VDI_PS_3(x)       (*(__IO hw_ipu_vdi_ps_3_t *) HW_IPU_VDI_PS_3_ADDR(x))
#define HW_IPU_VDI_PS_3_RD(x)    (HW_IPU_VDI_PS_3(x).U)
#define HW_IPU_VDI_PS_3_WR(x, v) (HW_IPU_VDI_PS_3(x).U = (v))
#define HW_IPU_VDI_PS_3_SET(x, v) (HW_IPU_VDI_PS_3_WR(x, HW_IPU_VDI_PS_3_RD(x) |  (v)))
#define HW_IPU_VDI_PS_3_CLR(x, v) (HW_IPU_VDI_PS_3_WR(x, HW_IPU_VDI_PS_3_RD(x) & ~(v)))
#define HW_IPU_VDI_PS_3_TOG(x, v) (HW_IPU_VDI_PS_3_WR(x, HW_IPU_VDI_PS_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_PS_3 bitfields
 */

/*!
 * @name Register IPU_VDI_PS_3, field VDI_FWIDTH3[10:0] (RW)
 *
 * Plane 3 width. The value to be written to this register is the plane's width
 * minus 1. The Plane width should not be smaller than 16. The Plane width should
 * not be greater than 1920. The width must be even.
 */
/*@{*/
#define BP_IPU_VDI_PS_3_VDI_FWIDTH3 (0U)   /*!< Bit position for IPU_VDI_PS_3_VDI_FWIDTH3. */
#define BM_IPU_VDI_PS_3_VDI_FWIDTH3 (0x000007FFU) /*!< Bit mask for IPU_VDI_PS_3_VDI_FWIDTH3. */
#define BS_IPU_VDI_PS_3_VDI_FWIDTH3 (11U)  /*!< Bit field size in bits for IPU_VDI_PS_3_VDI_FWIDTH3. */

/*! @brief Read current value of the IPU_VDI_PS_3_VDI_FWIDTH3 field. */
#define BR_IPU_VDI_PS_3_VDI_FWIDTH3(x) (HW_IPU_VDI_PS_3(x).B.VDI_FWIDTH3)

/*! @brief Format value for bitfield IPU_VDI_PS_3_VDI_FWIDTH3. */
#define BF_IPU_VDI_PS_3_VDI_FWIDTH3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_3_VDI_FWIDTH3) & BM_IPU_VDI_PS_3_VDI_FWIDTH3)

/*! @brief Set the VDI_FWIDTH3 field to a new value. */
#define BW_IPU_VDI_PS_3_VDI_FWIDTH3(x, v) (HW_IPU_VDI_PS_3_WR(x, (HW_IPU_VDI_PS_3_RD(x) & ~BM_IPU_VDI_PS_3_VDI_FWIDTH3) | BF_IPU_VDI_PS_3_VDI_FWIDTH3(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_PS_3, field VDI_FHEIGHT3[26:16] (RW)
 *
 * Plane 3 height The value to be written to this register is the plane's height
 * minus 1. The Plane height should not be smaller than 16. The Plane height
 * should not be greater than 1200. The Plane's height must be even
 */
/*@{*/
#define BP_IPU_VDI_PS_3_VDI_FHEIGHT3 (16U) /*!< Bit position for IPU_VDI_PS_3_VDI_FHEIGHT3. */
#define BM_IPU_VDI_PS_3_VDI_FHEIGHT3 (0x07FF0000U) /*!< Bit mask for IPU_VDI_PS_3_VDI_FHEIGHT3. */
#define BS_IPU_VDI_PS_3_VDI_FHEIGHT3 (11U) /*!< Bit field size in bits for IPU_VDI_PS_3_VDI_FHEIGHT3. */

/*! @brief Read current value of the IPU_VDI_PS_3_VDI_FHEIGHT3 field. */
#define BR_IPU_VDI_PS_3_VDI_FHEIGHT3(x) (HW_IPU_VDI_PS_3(x).B.VDI_FHEIGHT3)

/*! @brief Format value for bitfield IPU_VDI_PS_3_VDI_FHEIGHT3. */
#define BF_IPU_VDI_PS_3_VDI_FHEIGHT3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_3_VDI_FHEIGHT3) & BM_IPU_VDI_PS_3_VDI_FHEIGHT3)

/*! @brief Set the VDI_FHEIGHT3 field to a new value. */
#define BW_IPU_VDI_PS_3_VDI_FHEIGHT3(x, v) (HW_IPU_VDI_PS_3_WR(x, (HW_IPU_VDI_PS_3_RD(x) & ~BM_IPU_VDI_PS_3_VDI_FHEIGHT3) | BF_IPU_VDI_PS_3_VDI_FHEIGHT3(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_VDI_PS_4 - VDI Plane Size Register 4
 ******************************************************************************/

/*!
 * @brief HW_IPU_VDI_PS_4 - VDI Plane Size Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register holds the plane's offset paramemters.
 */
typedef union _hw_ipu_vdi_ps_4
{
    uint32_t U;
    struct _hw_ipu_vdi_ps_4_bitfields
    {
        uint32_t VDI_OFFSET_HOR3 : 11; /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t VDI_OFFSET_VER3 : 11; /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_ipu_vdi_ps_4_t;

/*!
 * @name Constants and macros for entire IPU_VDI_PS_4 register
 */
/*@{*/
#define HW_IPU_VDI_PS_4_ADDR(x)  ((uintptr_t)(x) + 0x68020U)

#define HW_IPU_VDI_PS_4(x)       (*(__IO hw_ipu_vdi_ps_4_t *) HW_IPU_VDI_PS_4_ADDR(x))
#define HW_IPU_VDI_PS_4_RD(x)    (HW_IPU_VDI_PS_4(x).U)
#define HW_IPU_VDI_PS_4_WR(x, v) (HW_IPU_VDI_PS_4(x).U = (v))
#define HW_IPU_VDI_PS_4_SET(x, v) (HW_IPU_VDI_PS_4_WR(x, HW_IPU_VDI_PS_4_RD(x) |  (v)))
#define HW_IPU_VDI_PS_4_CLR(x, v) (HW_IPU_VDI_PS_4_WR(x, HW_IPU_VDI_PS_4_RD(x) & ~(v)))
#define HW_IPU_VDI_PS_4_TOG(x, v) (HW_IPU_VDI_PS_4_WR(x, HW_IPU_VDI_PS_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_VDI_PS_4 bitfields
 */

/*!
 * @name Register IPU_VDI_PS_4, field VDI_OFFSET_HOR3[10:0] (RW)
 *
 * Horizontal offset of plane 3
 */
/*@{*/
#define BP_IPU_VDI_PS_4_VDI_OFFSET_HOR3 (0U) /*!< Bit position for IPU_VDI_PS_4_VDI_OFFSET_HOR3. */
#define BM_IPU_VDI_PS_4_VDI_OFFSET_HOR3 (0x000007FFU) /*!< Bit mask for IPU_VDI_PS_4_VDI_OFFSET_HOR3. */
#define BS_IPU_VDI_PS_4_VDI_OFFSET_HOR3 (11U) /*!< Bit field size in bits for IPU_VDI_PS_4_VDI_OFFSET_HOR3. */

/*! @brief Read current value of the IPU_VDI_PS_4_VDI_OFFSET_HOR3 field. */
#define BR_IPU_VDI_PS_4_VDI_OFFSET_HOR3(x) (HW_IPU_VDI_PS_4(x).B.VDI_OFFSET_HOR3)

/*! @brief Format value for bitfield IPU_VDI_PS_4_VDI_OFFSET_HOR3. */
#define BF_IPU_VDI_PS_4_VDI_OFFSET_HOR3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_4_VDI_OFFSET_HOR3) & BM_IPU_VDI_PS_4_VDI_OFFSET_HOR3)

/*! @brief Set the VDI_OFFSET_HOR3 field to a new value. */
#define BW_IPU_VDI_PS_4_VDI_OFFSET_HOR3(x, v) (HW_IPU_VDI_PS_4_WR(x, (HW_IPU_VDI_PS_4_RD(x) & ~BM_IPU_VDI_PS_4_VDI_OFFSET_HOR3) | BF_IPU_VDI_PS_4_VDI_OFFSET_HOR3(v)))
/*@}*/

/*!
 * @name Register IPU_VDI_PS_4, field VDI_OFFSET_VER3[26:16] (RW)
 *
 * Vertical offset of plane 3
 */
/*@{*/
#define BP_IPU_VDI_PS_4_VDI_OFFSET_VER3 (16U) /*!< Bit position for IPU_VDI_PS_4_VDI_OFFSET_VER3. */
#define BM_IPU_VDI_PS_4_VDI_OFFSET_VER3 (0x07FF0000U) /*!< Bit mask for IPU_VDI_PS_4_VDI_OFFSET_VER3. */
#define BS_IPU_VDI_PS_4_VDI_OFFSET_VER3 (11U) /*!< Bit field size in bits for IPU_VDI_PS_4_VDI_OFFSET_VER3. */

/*! @brief Read current value of the IPU_VDI_PS_4_VDI_OFFSET_VER3 field. */
#define BR_IPU_VDI_PS_4_VDI_OFFSET_VER3(x) (HW_IPU_VDI_PS_4(x).B.VDI_OFFSET_VER3)

/*! @brief Format value for bitfield IPU_VDI_PS_4_VDI_OFFSET_VER3. */
#define BF_IPU_VDI_PS_4_VDI_OFFSET_VER3(v) ((uint32_t)((uint32_t)(v) << BP_IPU_VDI_PS_4_VDI_OFFSET_VER3) & BM_IPU_VDI_PS_4_VDI_OFFSET_VER3)

/*! @brief Set the VDI_OFFSET_VER3 field to a new value. */
#define BW_IPU_VDI_PS_4_VDI_OFFSET_VER3(x, v) (HW_IPU_VDI_PS_4_WR(x, (HW_IPU_VDI_PS_4_RD(x) & ~BM_IPU_VDI_PS_4_VDI_OFFSET_VER3) | BF_IPU_VDI_PS_4_VDI_OFFSET_VER3(v)))
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_ipu_t - module struct
 ******************************************************************************/
/*!
 * @brief All IPU module registers.
 */
#pragma pack(1)
typedef struct _hw_ipu
{
    __IO hw_ipu_conf_t CONF;               /*!< [0x0] Configuration Register */
    __IO hw_ipu_sisg_ctrl0_t SISG_CTRL0;   /*!< [0x4] SISG Control 0 Register */
    __IO hw_ipu_sisg_ctrl1_t SISG_CTRL1;   /*!< [0x8] SISG Control 1 Register */
    __IO hw_ipu_sisg_set_i_t SISG_SET_i;   /*!< [0xC] SISG Set<i> Register */
    uint8_t _reserved0[20];
    __IO hw_ipu_sisg_clr_i_t SISG_CLR_i;   /*!< [0x24] SISG Clear <i> Register */
    uint8_t _reserved1[20];
    __IO hw_ipu_int_ctrl_1_t INT_CTRL_1;   /*!< [0x3C] Interrupt Control Register 1 */
    __IO hw_ipu_int_ctrl_2_t INT_CTRL_2;   /*!< [0x40] Interrupt Control Register 2 */
    __IO hw_ipu_int_ctrl_3_t INT_CTRL_3;   /*!< [0x44] Interrupt Control Register 3 */
    __IO hw_ipu_int_ctrl_4_t INT_CTRL_4;   /*!< [0x48] Interrupt Control Register 4 */
    __IO hw_ipu_int_ctrl_5_t INT_CTRL_5;   /*!< [0x4C] Interrupt Control Register 5 */
    __IO hw_ipu_int_ctrl_6_t INT_CTRL_6;   /*!< [0x50] Interrupt Control Register 6 */
    __IO hw_ipu_int_ctrl_7_t INT_CTRL_7;   /*!< [0x54] Interrupt Control Register 7 */
    __IO hw_ipu_int_ctrl_8_t INT_CTRL_8;   /*!< [0x58] Interrupt Control Register 8 */
    __IO hw_ipu_int_ctrl_9_t INT_CTRL_9;   /*!< [0x5C] Interrupt Control Register 9 */
    __IO hw_ipu_int_ctrl_10_t INT_CTRL_10; /*!< [0x60] Interrupt Control Register 10 */
    __IO hw_ipu_int_ctrl_11_t INT_CTRL_11; /*!< [0x64] Interrupt Control Register 11 */
    __IO hw_ipu_int_ctrl_12_t INT_CTRL_12; /*!< [0x68] Interrupt Control Register 12 */
    __IO hw_ipu_int_ctrl_13_t INT_CTRL_13; /*!< [0x6C] Interrupt Control Register 13 */
    __IO hw_ipu_int_ctrl_14_t INT_CTRL_14; /*!< [0x70] Interrupt Control Register 14 */
    __IO hw_ipu_int_ctrl_15_t INT_CTRL_15; /*!< [0x74] Interrupt Control Register15 */
    __IO hw_ipu_sdma_event_1_t SDMA_EVENT_1; /*!< [0x78] SDMA Event Control Register 1 */
    __IO hw_ipu_sdma_event_2_t SDMA_EVENT_2; /*!< [0x7C] SDMA Event Control Register 2 */
    __IO hw_ipu_sdma_event_3_t SDMA_EVENT_3; /*!< [0x80] SDMA Event Control Register 3 */
    __IO hw_ipu_sdma_event_4_t SDMA_EVENT_4; /*!< [0x84] SDMA Event Control Register 4 */
    __IO hw_ipu_sdma_event_7_t SDMA_EVENT_7; /*!< [0x88] SDMA Event Control Register 7 */
    __IO hw_ipu_sdma_event_8_t SDMA_EVENT_8; /*!< [0x8C] SDMA Event Control Register 8 */
    __IO hw_ipu_sdma_event_11_t SDMA_EVENT_11; /*!< [0x90] SDMA Event Control Register 11 */
    __IO hw_ipu_sdma_event_12_t SDMA_EVENT_12; /*!< [0x94] SDMA Event Control Register 12 */
    __IO hw_ipu_sdma_event_13_t SDMA_EVENT_13; /*!< [0x98] SDMA Event Control Register 13 */
    __IO hw_ipu_sdma_event_14_t SDMA_EVENT_14; /*!< [0x9C] SDMA Event Control Register 14 */
    __IO hw_ipu_srm_pri1_t SRM_PRI1;       /*!< [0xA0] Shadow Registers Memory Priority 1 Register */
    __IO hw_ipu_srm_pri2_t SRM_PRI2;       /*!< [0xA4] Shadow Registers Memory Priority 2 Register */
    __IO hw_ipu_fs_proc_flow1_t FS_PROC_FLOW1; /*!< [0xA8] FSU Processing Flow 1 Register */
    __IO hw_ipu_fs_proc_flow2_t FS_PROC_FLOW2; /*!< [0xAC] FSU Processing Flow 2 Register */
    __IO hw_ipu_fs_proc_flow3_t FS_PROC_FLOW3; /*!< [0xB0] FSU Processing Flow 3 Register */
    __IO hw_ipu_fs_disp_flow1_t FS_DISP_FLOW1; /*!< [0xB4] FSU Displaying Flow 1 Register */
    __IO hw_ipu_fs_disp_flow2_t FS_DISP_FLOW2; /*!< [0xB8] FSU Displaying Flow 2 Register */
    __IO hw_ipu_skip_t SKIP;               /*!< [0xBC] SKIP Register */
    __I hw_ipu_disp_alt_conf_t DISP_ALT_CONF; /*!< [0xC0] Display Alternate Configuration Register */
    __IO hw_ipu_disp_gen_t DISP_GEN;       /*!< [0xC4] Display General Control Register */
    __IO hw_ipu_disp_alt1_t DISP_ALT1;     /*!< [0xC8] Display Alternate Flow Control Register 1 */
    __IO hw_ipu_disp_alt2_t DISP_ALT2;     /*!< [0xCC] Display Alternate Flow Control Register 2 */
    __IO hw_ipu_disp_alt3_t DISP_ALT3;     /*!< [0xD0] Display Alternate Flow Control Register 3 */
    __IO hw_ipu_disp_alt4_t DISP_ALT4;     /*!< [0xD4] Display Alternate Flow Control Register 4 */
    uint8_t _reserved2[4];
    __IO hw_ipu_mem_rst_t MEM_RST;         /*!< [0xDC] Memory Reset Control Register */
    __IO hw_ipu_pm_t PM;                   /*!< [0xE0] Power Modes Control Register */
    __IO hw_ipu_gpr_t GPR;                 /*!< [0xE4] General Purpose Register */
    uint8_t _reserved3[104];
    __IO hw_ipu_ch_db_mode_sel0_t CH_DB_MODE_SEL0; /*!< [0x150] Channel Double Buffer Mode Select 0 Register */
    __IO hw_ipu_ch_db_mode_sel1_t CH_DB_MODE_SEL1; /*!< [0x154] Channel Double Buffer Mode Select 1 Register */
    uint8_t _reserved4[16];
    __IO hw_ipu_alt_ch_db_mode_sel0_t ALT_CH_DB_MODE_SEL0; /*!< [0x168] Alternate Channel Double Buffer Mode Select 0 Register */
    __IO hw_ipu_alt_ch_db_mode_sel1_t ALT_CH_DB_MODE_SEL1; /*!< [0x16C] Alternate Channel Double Buffer Mode Select1 Register */
    uint8_t _reserved5[8];
    __IO hw_ipu_alt_ch_trb_mode_sel0_t ALT_CH_TRB_MODE_SEL0; /*!< [0x178] Alternate Channel Triple Buffer Mode Select 0 Register */
    __I hw_ipu_alt_ch_trb_mode_sel1_t ALT_CH_TRB_MODE_SEL1; /*!< [0x17C] Alternate Channel Triple Buffer Mode Select 1 Register */
    uint8_t _reserved6[128];
    __IO hw_ipu_int_stat_1_t INT_STAT_1;   /*!< [0x200] Interrupt Status Register 1 */
    __IO hw_ipu_int_stat_2_t INT_STAT_2;   /*!< [0x204] Interrupt Status Register2 */
    __IO hw_ipu_int_stat_3_t INT_STAT_3;   /*!< [0x208] Interrupt Status Register 3 */
    __IO hw_ipu_int_stat_4_t INT_STAT_4;   /*!< [0x20C] Interrupt Status Register 4 */
    __IO hw_ipu_int_stat_5_t INT_STAT_5;   /*!< [0x210] Interrupt Status Register 5 */
    __IO hw_ipu_int_stat_6_t INT_STAT_6;   /*!< [0x214] Interrupt Status Register 6 */
    __IO hw_ipu_int_stat_7_t INT_STAT_7;   /*!< [0x218] Interrupt Status Register7 1 */
    __IO hw_ipu_int_stat_8_t INT_STAT_8;   /*!< [0x21C] Interrupt Status Register 8 */
    __IO hw_ipu_int_stat_9_t INT_STAT_9;   /*!< [0x220] Interrupt Status Register 9 */
    __IO hw_ipu_int_stat_10_t INT_STAT_10; /*!< [0x224] Interrupt Status Register 10 */
    __IO hw_ipu_int_stat_11_t INT_STAT_11; /*!< [0x228] Interrupt Status Register 11 */
    __IO hw_ipu_int_stat_12_t INT_STAT_12; /*!< [0x22C] Interrupt Status Register 12 */
    __IO hw_ipu_int_stat_13_t INT_STAT_13; /*!< [0x230] Interrupt Status Register 13 */
    __IO hw_ipu_int_stat_14_t INT_STAT_14; /*!< [0x234] Interrupt Status Register 14 */
    __IO hw_ipu_int_stat_15_t INT_STAT_15; /*!< [0x238] Interrupt Status Register 15 */
    __I hw_ipu_cur_buf_0_t CUR_BUF_0;      /*!< [0x23C] Current Buffer Register 0 */
    __I hw_ipu_cur_buf_1_t CUR_BUF_1;      /*!< [0x240] Current Buffer Register 1 */
    __I hw_ipu_alt_cur_0_t ALT_CUR_0;      /*!< [0x244] Alternate Current Buffer Register 0 */
    __I hw_ipu_alt_cur_1_t ALT_CUR_1;      /*!< [0x248] Alternate Current Buffer Register 1 */
    __I hw_ipu_srm_stat_t SRM_STAT;        /*!< [0x24C] Shadow Registers Memory Status Register */
    __I hw_ipu_proc_tasks_stat_t PROC_TASKS_STAT; /*!< [0x250] Processing Status Tasks Register */
    __I hw_ipu_disp_tasks_stat_t DISP_TASKS_STAT; /*!< [0x254] Display Tasks Status Register */
    __I hw_ipu_triple_cur_buf_0_t TRIPLE_CUR_BUF_0; /*!< [0x258] Triple Current Buffer Register 0 */
    __I hw_ipu_triple_cur_buf_1_t TRIPLE_CUR_BUF_1; /*!< [0x25C] Triple Current Buffer Register 1 */
    __I hw_ipu_triple_cur_buf_2_t TRIPLE_CUR_BUF_2; /*!< [0x260] Triple Current Buffer Register 2 */
    __I hw_ipu_triple_cur_buf_3_t TRIPLE_CUR_BUF_3; /*!< [0x264] Triple Current Buffer Register 3 */
    __IO hw_ipu_ch_buf0_rdy0_t CH_BUF0_RDY0; /*!< [0x268] IPU Channels Buffer 0 Ready 0 Register */
    __IO hw_ipu_ch_buf0_rdy1_t CH_BUF0_RDY1; /*!< [0x26C] IPU Channels Buffer 0 Ready 1 Register */
    __IO hw_ipu_ch_buf1_rdy0_t CH_BUF1_RDY0; /*!< [0x270] IPU Channels Buffer 1 Ready 0 Register */
    __IO hw_ipu_ch_buf1_rdy1_t CH_BUF1_RDY1; /*!< [0x274] IPU Channels Buffer 1 Ready 1Register */
    __IO hw_ipu_alt_ch_buf0_rdy0_t ALT_CH_BUF0_RDY0; /*!< [0x278] IPU Alternate Channels Buffer 0 Ready 0 Register */
    __IO hw_ipu_alt_ch_buf0_rdy1_t ALT_CH_BUF0_RDY1; /*!< [0x27C] IPU Alternate Channels Buffer 0 Ready 1 Register */
    __IO hw_ipu_alt_ch_buf1_rdy0_t ALT_CH_BUF1_RDY0; /*!< [0x280] IPU Alternate Channels Buffer1 Ready 0 Register */
    __IO hw_ipu_alt_ch_buf1_rdy1_t ALT_CH_BUF1_RDY1; /*!< [0x284] IPU Alternate Channels Buffer 1 Ready 1 Register */
    __IO hw_ipu_ch_buf2_rdy0_t CH_BUF2_RDY0; /*!< [0x288] IPU Channels Buffer 2 Ready 0 Register */
    __IO hw_ipu_ch_buf2_rdy1_t CH_BUF2_RDY1; /*!< [0x28C] IPU Channels Buffer 2 Ready 1 Register */
    uint8_t _reserved7[32112];
    __IO hw_ipu_idmac_conf_t IDMAC_CONF;   /*!< [0x8000] IDMAC Configuration Register */
    __IO hw_ipu_idmac_ch_en_1_t IDMAC_CH_EN_1; /*!< [0x8004] IDMAC Channel Enable 1 Register */
    __IO hw_ipu_idmac_ch_en_2_t IDMAC_CH_EN_2; /*!< [0x8008] IDMAC Channel Enable 2 Register */
    __IO hw_ipu_idmac_sep_alpha_t IDMAC_SEP_ALPHA; /*!< [0x800C] IDMAC Separate Alpha Indication Register */
    __IO hw_ipu_idmac_alt_sep_alpha_t IDMAC_ALT_SEP_ALPHA; /*!< [0x8010] IDMAC Alternate Separate Alpha Indication Register */
    __IO hw_ipu_idmac_ch_pri_1_t IDMAC_CH_PRI_1; /*!< [0x8014] IDMAC Channel Priority 1 Register */
    __IO hw_ipu_idmac_ch_pri_2_t IDMAC_CH_PRI_2; /*!< [0x8018] IDMAC Channel Priority 2 Register */
    __IO hw_ipu_idmac_wm_en_1_t IDMAC_WM_EN_1; /*!< [0x801C] IDMAC Channel Watermark Enable 1 Register */
    __IO hw_ipu_idmac_wm_en_2_t IDMAC_WM_EN_2; /*!< [0x8020] IDMAC Channel Watermark Enable 2 Register */
    __IO hw_ipu_idmac_lock_en_1_t IDMAC_LOCK_EN_1; /*!< [0x8024] IDMAC Channel Lock Enable 1Register */
    __IO hw_ipu_idmac_lock_en_2_t IDMAC_LOCK_EN_2; /*!< [0x8028] IDMAC Channel Lock Enable 2Register */
    __IO hw_ipu_idmac_sub_addr_0_t IDMAC_SUB_ADDR_0; /*!< [0x802C] IDMAC Channel Alternate Address 0 Register */
    __IO hw_ipu_idmac_sub_addr_1_t IDMAC_SUB_ADDR_1; /*!< [0x8030] IDMAC Channel Alternate Address 1 Register */
    __IO hw_ipu_idmac_sub_addr_2_t IDMAC_SUB_ADDR_2; /*!< [0x8034] IDMAC Channel Alternate Address 2 Register */
    __IO hw_ipu_idmac_sub_addr_3_t IDMAC_SUB_ADDR_3; /*!< [0x8038] IDMAC Channel Alternate Address 3 Register */
    __IO hw_ipu_idmac_sub_addr_4_t IDMAC_SUB_ADDR_4; /*!< [0x803C] IDMAC Channel Alternate Address 4 Register */
    __IO hw_ipu_idmac_bndm_en_1_t IDMAC_BNDM_EN_1; /*!< [0x8040] IDMAC Band Mode Enable 1 Register */
    __IO hw_ipu_idmac_bndm_en_2_t IDMAC_BNDM_EN_2; /*!< [0x8044] IDMAC Band Mode Enable 2 Register */
    __IO hw_ipu_idmac_sc_cord_t IDMAC_SC_CORD; /*!< [0x8048] IDMAC Scroll Coordinations Register */
    __IO hw_ipu_idmac_sc_cord_1_t IDMAC_SC_CORD_1; /*!< [0x804C] IDMAC Scroll Coordinations Register 1 */
    uint8_t _reserved8[176];
    __I hw_ipu_idmac_ch_busy_1_t IDMAC_CH_BUSY_1; /*!< [0x8100] IDMAC Channel Busy 1 Register */
    __I hw_ipu_idmac_ch_busy_2_t IDMAC_CH_BUSY_2; /*!< [0x8104] IDMAC Channel Busy 2 Register */
    uint8_t _reserved9[65272];
    __IO hw_ipu_dp_com_conf_sync_t DP_COM_CONF_SYNC; /*!< [0x18000] DP Common Configuration Sync Flow Register */
    __IO hw_ipu_dp_graph_wind_ctrl_sync_t DP_Graph_Wind_CTRL_SYNC; /*!< [0x18004] DP Graphic Window Control Sync Flow Register */
    __IO hw_ipu_dp_fg_pos_sync_t DP_FG_POS_SYNC; /*!< [0x18008] DP Partial Plane Window Position Sync Flow Register */
    __IO hw_ipu_dp_cur_pos_sync_t DP_CUR_POS_SYNC; /*!< [0x1800C] DP Cursor Position and Size Sync Flow Register */
    __IO hw_ipu_dp_cur_map_sync_t DP_CUR_MAP_SYNC; /*!< [0x18010] DP Color Cursor Mapping Sync Flow Register */
    __IO hw_ipu_dp_gamma_c_sync_i_t DP_GAMMA_C_SYNC_i; /*!< [0x18014] DP Gamma Constants Sync Flow Register i */
    uint8_t _reserved10[28];
    __IO hw_ipu_dp_gamma_s_sync_i_t DP_GAMMA_S_SYNC_i; /*!< [0x18034] DP Gamma Correction Slope Sync Flow Register i */
    uint8_t _reserved11[12];
    __IO hw_ipu_dp_csca_sync_i_t DP_CSCA_SYNC_i; /*!< [0x18044] DP Color Space Conversion Control Sync Flow Registers */
    uint8_t _reserved12[12];
    __IO hw_ipu_dp_scs_sync_0_t DP_SCS_SYNC_0; /*!< [0x18054] DP Color Conversion Control Sync Flow Register 0 */
    __IO hw_ipu_dp_scs_sync_1_t DP_SCS_SYNC_1; /*!< [0x18058] DP Color Conversion Control Sync Flow Register 1 */
    __IO hw_ipu_dp_cur_pos_alt_t DP_CUR_POS_ALT; /*!< [0x1805C] DP Cursor Position and Size Alternate Register */
    __IO hw_ipu_dp_com_conf_async0_t DP_COM_CONF_ASYNC0; /*!< [0x18060] DP Common Configuration Async 0 Flow Register */
    __IO hw_ipu_dp_graph_wind_ctrl_async0_t DP_GRAPH_WIND_CTRL_ASYNC0; /*!< [0x18064] DP Graphic Window Control Async 0 Flow Register */
    __IO hw_ipu_dp_fg_pos_async0_t DP_FG_POS_ASYNC0; /*!< [0x18068] DP Partial Plane Window Position Async 0 Flow Register */
    __IO hw_ipu_dp_cur_pos_async0_t DP_CUR_POS_ASYNC0; /*!< [0x1806C] DP Cursor Position and Size Async 0 Flow Register */
    __IO hw_ipu_dp_cur_map_async0_t DP_CUR_MAP_ASYNC0; /*!< [0x18070] DP Color Cursor Mapping Async 0 Flow Register */
    __IO hw_ipu_dp_gamma_c_async0_i_t DP_GAMMA_C_ASYNC0_i; /*!< [0x18074] DP Gamma Constant Async 0 Flow Register i */
    uint8_t _reserved13[28];
    __IO hw_ipu_dp_gamma_s_async0_i_t DP_GAMMA_S_ASYNC0_i; /*!< [0x18094] DP Gamma Correction Slope Async 0 Flow Register i */
    uint8_t _reserved14[12];
    __IO hw_ipu_dp_csca_async0_i_t DP_CSCA_ASYNC0_i; /*!< [0x180A4] DP Color Space Conversion Control Async 0 Flow Register i */
    uint8_t _reserved15[12];
    __IO hw_ipu_dp_csc_async0_0_t DP_CSC_ASYNC0_0; /*!< [0x180B4] DP Color Conversion Control Async 0 Flow Register 0 */
    __IO hw_ipu_dp_csc_async_1_t DP_CSC_ASYNC_1; /*!< [0x180B8] DP Color Conversion Control Async 1 Flow Register */
    union {
        __IO hw_ipu_dp_com_conf_async1_t DP_COM_CONF_ASYNC1; /*!< [0x180BC] DP Common Configuration Async 1 Flow Register */
        __IO hw_ipu_dp_debug_cnt_t DP_DEBUG_CNT; /*!< [0x180BC] DP Debug Control Register */
    };
    union {
        __I hw_ipu_dp_debug_stat_t DP_DEBUG_STAT; /*!< [0x180C0] DP Debug Status Register */
        __IO hw_ipu_dp_graph_wind_ctrl_async1_t DP_GRAPH_WIND_CTRL_ASYNC1; /*!< [0x180C0] DP Graphic Window Control Async 1 Flow Register */
    };
    __IO hw_ipu_dp_fg_pos_async1_t DP_FG_POS_ASYNC1; /*!< [0x180C4] DP Partial Plane Window Position Async 1 Flow Register */
    __IO hw_ipu_dp_cur_pos_async1_t DP_CUR_POS_ASYNC1; /*!< [0x180C8] DP Cursor Postion and Size Async 1 Flow Register */
    __IO hw_ipu_dp_cur_map_async1_t DP_CUR_MAP_ASYNC1; /*!< [0x180CC] DP Color Cursor Mapping Async 1 Flow Register */
    __IO hw_ipu_dp_gamma_c_async1_i_t DP_GAMMA_C_ASYNC1_i; /*!< [0x180D0] DP Gamma Constants Async 1 Flow Register i */
    uint8_t _reserved16[28];
    __IO hw_ipu_dp_gamma_s_asyn1_i_t DP_GAMMA_S_ASYN1_i; /*!< [0x180F0] DP Gamma Correction Slope Async 1 Flow Register i */
    uint8_t _reserved17[12];
    __IO hw_ipu_dp_csca_async1_i_t DP_CSCA_ASYNC1_i; /*!< [0x18100] DP Color Space Converstion Control Async 1 Flow Register i */
    uint8_t _reserved18[12];
    __IO hw_ipu_dp_csc_async1_0_t DP_CSC_ASYNC1_0; /*!< [0x18110] DP Color Conversion Control Async 1 Flow Register 0 */
    __IO hw_ipu_dp_csc_async1_1_t DP_CSC_ASYNC1_1; /*!< [0x18114] DP Color Conversion Control Async 1 Flow Register 1 */
    uint8_t _reserved19[32488];
    __IO hw_ipu_ic_conf_t IC_CONF;         /*!< [0x20000] IC Configuration Register */
    __IO hw_ipu_ic_prp_enc_rsc_t IC_PRP_ENC_RSC; /*!< [0x20004] IC Preprocessing Encoder Resizing Coefficients Register */
    __IO hw_ipu_ic_prp_vf_rsc_t IC_PRP_VF_RSC; /*!< [0x20008] IC Preprocessing View-Finder Resizing Coefficients Register */
    __IO hw_ipu_ic_pp_rsc_t IC_PP_RSC;     /*!< [0x2000C] IC Postprocessing Encoder Resizing Coefficients Register */
    __IO hw_ipu_ic_cmbp_1_t IC_CMBP_1;     /*!< [0x20010] IC Combining Parameters Register 1 */
    __IO hw_ipu_ic_cmbp_2_t IC_CMBP_2;     /*!< [0x20014] IC Combining Parameters Register 2 */
    __IO hw_ipu_ic_idmac_1_t IC_IDMAC_1;   /*!< [0x20018] IC IDMAC Parameters 1 Register */
    __IO hw_ipu_ic_idmac_2_t IC_IDMAC_2;   /*!< [0x2001C] IC IDMAC Parameters 2 Register */
    __IO hw_ipu_ic_idmac_3_t IC_IDMAC_3;   /*!< [0x20020] IC IDMAC Parameters 3Register */
    __IO hw_ipu_ic_idmac_4_t IC_IDMAC_4;   /*!< [0x20024] IC IDMAC Parameters 4 Register */
    uint8_t _reserved20[65496];
    __IO hw_ipu_csi0_sens_conf_t CSI0_SENS_CONF; /*!< [0x30000] CSI0 Sensor Configuration Register */
    __IO hw_ipu_csi0_sens_frm_size_t CSI0_SENS_FRM_SIZE; /*!< [0x30004] CSI0 Sense Frame Size Register */
    __IO hw_ipu_csi0_act_frm_size_t CSI0_ACT_FRM_SIZE; /*!< [0x30008] CSI0 Actual Frame Size Register */
    __IO hw_ipu_csi0_out_frm_ctrl_t CSI0_OUT_FRM_CTRL; /*!< [0x3000C] CSI0 Output Control Register */
    __IO hw_ipu_csi0_tst_ctrl_t CSI0_TST_CTRL; /*!< [0x30010] CSIO Test Control Register */
    __IO hw_ipu_csi0_ccir_code_1_t CSI0_CCIR_CODE_1; /*!< [0x30014] CSIO CCIR Code Register 1 */
    __IO hw_ipu_csi0_ccir_code_2_t CSI0_CCIR_CODE_2; /*!< [0x30018] CSIO CCIR Code Register 2 */
    __IO hw_ipu_csi0_ccir_code_3_t CSI0_CCIR_CODE_3; /*!< [0x3001C] CSIO CCIR Code Register 3 */
    __IO hw_ipu_csi0_di_t CSI0_DI;         /*!< [0x30020] CSI0 Data Identifier Register */
    __IO hw_ipu_csi0_skip_t CSI0_SKIP;     /*!< [0x30024] CSI0 SKIP Register */
    __IO hw_ipu_csio_cpd_ctrl_t CSIO_CPD_CTRL; /*!< [0x30028] CSI0 Compander Control Register */
    __IO hw_ipu_csio_cpd_rc_i_t CSIO_CPD_RC_i; /*!< [0x3002C] CSI0 Red Component Compander Constants Register <i> */
    uint8_t _reserved21[28];
    __IO hw_ipu_csio_cpd_rs_i_t CSIO_CPD_RS_i; /*!< [0x3004C] CSI0 Red Component Compander SLOPE Register <i> */
    uint8_t _reserved22[12];
    __IO hw_ipu_csio_cpd_grc_i_t CSIO_CPD_GRC_i; /*!< [0x3005C] CSI0 GR Component Compander Constants Register <i> */
    uint8_t _reserved23[28];
    __IO hw_ipu_csio_cpd_grs_i_t CSIO_CPD_GRS_i; /*!< [0x3007C] CSI0 GR Component Compander SLOPE Register <i> */
    uint8_t _reserved24[12];
    __IO hw_ipu_csio_cpd_gbc_i_t CSIO_CPD_GBC_i; /*!< [0x3008C] CSI0 GB Component Compander Constants Register <i> */
    uint8_t _reserved25[28];
    __IO hw_ipu_csio_cpd_gbs_i_t CSIO_CPD_GBS_i; /*!< [0x300AC] CSI0 GB Component Compander SLOPE Register <i> */
    uint8_t _reserved26[12];
    __IO hw_ipu_csio_cpd_bc_i_t CSIO_CPD_BC_i; /*!< [0x300BC] CSI0 Blue Component Compander Constants Register <i> */
    uint8_t _reserved27[28];
    __IO hw_ipu_csio_cpd_bs_i_t CSIO_CPD_BS_i; /*!< [0x300DC] CSI0 Blue Component Compander SLOPE Register <i> */
    uint8_t _reserved28[12];
    __IO hw_ipu_csi0_cpd_offset1_t CSI0_CPD_OFFSET1; /*!< [0x300EC] CSI0 Compander Offset Register 1 */
    __IO hw_ipu_csi0_cpd_offset2_t CSI0_CPD_OFFSET2; /*!< [0x300F0] CSI0 Compander Offset Register 2 */
    uint8_t _reserved29[32524];
    __IO hw_ipu_csi1_sens_conf_t CSI1_SENS_CONF; /*!< [0x38000] CSI1 Sensor Configuration Register */
    __IO hw_ipu_csi1_sens_frm_size_t CSI1_SENS_FRM_SIZE; /*!< [0x38004] CSI1 Sense Frame Size Register */
    __IO hw_ipu_csi1_act_frm_size_t CSI1_ACT_FRM_SIZE; /*!< [0x38008] CSI1 Actual Frame Size Register */
    __IO hw_ipu_csi1_out_frm_ctrl_t CSI1_OUT_FRM_CTRL; /*!< [0x3800C] CSI1 Output Control Register */
    __IO hw_ipu_csi1_tst_ctrl_t CSI1_TST_CTRL; /*!< [0x38010] CSI1 Test Control Register */
    __IO hw_ipu_csi1_ccir_code_1_t CSI1_CCIR_CODE_1; /*!< [0x38014] CSI1 CCIR Code Register 1 */
    __IO hw_ipu_csi1_ccir_code_2_t CSI1_CCIR_CODE_2; /*!< [0x38018] CSI1 CCIR Code Register 2 */
    __IO hw_ipu_csi1_ccir_code_3_t CSI1_CCIR_CODE_3; /*!< [0x3801C] CSI1 CCIR Code Register 3 */
    __IO hw_ipu_csi1_di_t CSI1_DI;         /*!< [0x38020] CSI1 Data Identifier Register */
    __IO hw_ipu_csi1_skip_t CSI1_SKIP;     /*!< [0x38024] CSI1 SKIP Register */
    __I hw_ipu_csi1_cpd_ctrl_t CSI1_CPD_CTRL; /*!< [0x38028] CSI1 Compander Control Register */
    __IO hw_ipu_csi1_cpd_rc_i_t CSI1_CPD_RC_i; /*!< [0x3802C] CSI1 Red Component Compander Constants Register <i> */
    uint8_t _reserved30[28];
    __IO hw_ipu_csi1_cpd_rs_i_t CSI1_CPD_RS_i; /*!< [0x3804C] CSI1 Red Component Compander SLOPE Register <i> */
    uint8_t _reserved31[12];
    __IO hw_ipu_csi1_cpd_grc_i_t CSI1_CPD_GRC_i; /*!< [0x3805C] CSI1 GR Component Compander Constants Register <i> */
    uint8_t _reserved32[28];
    __IO hw_ipu_csi1_cpd_grs_i_t CSI1_CPD_GRS_i; /*!< [0x3807C] CSI1 GR Component Compander SLOPE Register <i> */
    uint8_t _reserved33[12];
    __IO hw_ipu_csi1_cpd_gbc_i_t CSI1_CPD_GBC_i; /*!< [0x3808C] CSI1 GB Component Compander Constants Register <i> */
    uint8_t _reserved34[28];
    __IO hw_ipu_csi1_cpd_gbs_i_t CSI1_CPD_GBS_i; /*!< [0x380AC] CSI1 GB Component Compander SLOPE Register <i> */
    uint8_t _reserved35[12];
    __IO hw_ipu_csi1_cpd_bc_i_t CSI1_CPD_BC_i; /*!< [0x380BC] CSI1 Blue Component Compander Constants Register <i> */
    uint8_t _reserved36[28];
    __IO hw_ipu_csi1_cpd_bs_i_t CSI1_CPD_BS_i; /*!< [0x380DC] CSI1 Blue Component Compander SLOPE Register <i> */
    uint8_t _reserved37[12];
    __IO hw_ipu_csi1_cpd_offset1_t CSI1_CPD_OFFSET1; /*!< [0x380EC] CSI1 Compander Offset Register 1 */
    __IO hw_ipu_csi1_cpd_offset2_t CSI1_CPD_OFFSET2; /*!< [0x380F0] CSI1 Compander Offset Register 2 */
    uint8_t _reserved38[32524];
    __IO hw_ipu_di0_general_t DI0_GENERAL; /*!< [0x40000] DI0 General Register */
    __IO hw_ipu_di0_bs_clkgen0_t DI0_BS_CLKGEN0; /*!< [0x40004] DI0 Base Sync Clock Gen 0 Register */
    __IO hw_ipu_di0_bs_clkgen1_t DI0_BS_CLKGEN1; /*!< [0x40008] DI0 Base Sync Clock Gen 1 Register */
    __IO hw_ipu_di0_sw_gen0_1_t DI0_SW_GEN0_1; /*!< [0x4000C] DI0 Sync Wave Gen 1 Register 0 */
    __IO hw_ipu_di0_sw_gen0_2_t DI0_SW_GEN0_2; /*!< [0x40010] DI0 Sync Wave Gen 2 Register 0 */
    __IO hw_ipu_di0_sw_gen0_3_t DI0_SW_GEN0_3; /*!< [0x40014] DI0 Sync Wave Gen 3 Register 0 */
    __IO hw_ipu_di0_sw_gen0_4_t DI0_SW_GEN0_4; /*!< [0x40018] DI0 Sync Wave Gen 4 Register 0 */
    __IO hw_ipu_di0_sw_gen0_5_t DI0_SW_GEN0_5; /*!< [0x4001C] DI0 Sync Wave Gen 5 Register 0 */
    __IO hw_ipu_di0_sw_gen0_6_t DI0_SW_GEN0_6; /*!< [0x40020] DI0 Sync Wave Gen 6 Register 0 */
    __IO hw_ipu_di0_sw_gen0_7_t DI0_SW_GEN0_7; /*!< [0x40024] DI0 Sync Wave Gen 7 Register 0 */
    __IO hw_ipu_di0_sw_gen0_8_t DI0_SW_GEN0_8; /*!< [0x40028] DI0 Sync Wave Gen 8 Register 0 */
    __IO hw_ipu_di0_sw_gen0_9_t DI0_SW_GEN0_9; /*!< [0x4002C] DI0 Sync Wave Gen 9 Register 0 */
    __IO hw_ipu_di0_sw_gen1_1_t DI0_SW_GEN1_1; /*!< [0x40030] DI0 Sync Wave Gen 1 Register 1 */
    __IO hw_ipu_di0_sw_gen1_2_t DI0_SW_GEN1_2; /*!< [0x40034] DI0 Sync Wave Gen 2 Register 1 */
    __IO hw_ipu_di0_sw_gen1_3_t DI0_SW_GEN1_3; /*!< [0x40038] DI0 Sync Wave Gen 3 Register 1 */
    __IO hw_ipu_di0_sw_gen1_4_t DI0_SW_GEN1_4; /*!< [0x4003C] DI0 Sync Wave Gen 4 Register 1 */
    __IO hw_ipu_di0_sw_gen1_5_t DI0_SW_GEN1_5; /*!< [0x40040] DI0 Sync Wave Gen 5 Register 1 */
    __IO hw_ipu_di0_sw_gen1_6_t DI0_SW_GEN1_6; /*!< [0x40044] DI0 Sync Wave Gen 6 Register 1 */
    __IO hw_ipu_di0_sw_gen1_7_t DI0_SW_GEN1_7; /*!< [0x40048] DI0 Sync Wave Gen 7 Register 1 */
    __IO hw_ipu_di0_sw_gen1_8_t DI0_SW_GEN1_8; /*!< [0x4004C] DI0 Sync Wave Gen 8 Register 1 */
    __IO hw_ipu_di0_sw_gen1_9_t DI0_SW_GEN1_9; /*!< [0x40050] DI0 Sync Wave Gen 9 Register 1 */
    __IO hw_ipu_di0_sync_as_gen_t DI0_SYNC_AS_GEN; /*!< [0x40054] DI0 Sync Assistance Gen Register */
    __IO hw_ipu_di0_dw_gen_i_t DI0_DW_GEN_i; /*!< [0x40058] DI0 Data Wave Gen <i> Register */
    uint8_t _reserved39[44];
    __IO hw_ipu_di0_dw_set0_i_t DI0_DW_SET0_i; /*!< [0x40088] DI0 Data Wave Set 0 <i> Register */
    uint8_t _reserved40[44];
    __IO hw_ipu_di0_dw_set1_i_t DI0_DW_SET1_i; /*!< [0x400B8] DI0 Data Wave Set 1 <i> Register */
    uint8_t _reserved41[44];
    __IO hw_ipu_di0_dw_set2_i_t DI0_DW_SET2_i; /*!< [0x400E8] DI0 Data Wave Set 2 <i> Register */
    uint8_t _reserved42[44];
    __IO hw_ipu_di0_dw_set3_i_t DI0_DW_SET3_i; /*!< [0x40118] DI0 Data Wave Set 3 <i> Register */
    uint8_t _reserved43[44];
    __IO hw_ipu_di0_stp_rep_i_t DI0_STP_REP_i; /*!< [0x40148] DI0 Step Repeat <i> Registers */
    uint8_t _reserved44[12];
    __IO hw_ipu_di0_stp_rep_9_t DI0_STP_REP_9; /*!< [0x40158] DI0 Step Repeat 9 Registers */
    __IO hw_ipu_di0_ser_conf_t DI0_SER_CONF; /*!< [0x4015C] DI0 Serial Display Control Register */
    __IO hw_ipu_di0_ssc_t DI0_SSC;         /*!< [0x40160] DI0 Special Signals Control Register */
    __IO hw_ipu_di0_pol_t DI0_POL;         /*!< [0x40164] DI0 Polarity Register */
    __IO hw_ipu_di0_aw0_t DI0_AW0;         /*!< [0x40168] DI0 Active Window 0 Register */
    __IO hw_ipu_di0_aw1_t DI0_AW1;         /*!< [0x4016C] DI0 Active Window 1 Register */
    __IO hw_ipu_di0_scr_conf_t DI0_SCR_CONF; /*!< [0x40170] DI0 Screen Configuration Register */
    __I hw_ipu_di0_stat_t DI0_STAT;        /*!< [0x40174] DI0 Status Register */
    uint8_t _reserved45[32392];
    __IO hw_ipu_di1_general_t DI1_GENERAL; /*!< [0x48000] DI1General Register */
    __IO hw_ipu_di1_bs_clkgen0_t DI1_BS_CLKGEN0; /*!< [0x48004] DI1 Base Sync Clock Gen 0 Register */
    __IO hw_ipu_di1_bs_clkgen1_t DI1_BS_CLKGEN1; /*!< [0x48008] DI1 Base Sync Clock Gen 1 Register */
    __IO hw_ipu_di1_sw_gen0_1_t DI1_SW_GEN0_1; /*!< [0x4800C] DI1 Sync Wave Gen 1 Register 0 */
    __IO hw_ipu_di1_sw_gen0_2_t DI1_SW_GEN0_2; /*!< [0x48010] DI1 Sync Wave Gen 2 Register 0 */
    __IO hw_ipu_di1_sw_gen0_3_t DI1_SW_GEN0_3; /*!< [0x48014] DI1 Sync Wave Gen 3 Register 0 */
    __IO hw_ipu_di1_sw_gen0_4_t DI1_SW_GEN0_4; /*!< [0x48018] DI1 Sync Wave Gen 4 Register 0 */
    __IO hw_ipu_di1_sw_gen0_5_t DI1_SW_GEN0_5; /*!< [0x4801C] DI1 Sync Wave Gen 5 Register 0 */
    __IO hw_ipu_di1_sw_gen0_6_t DI1_SW_GEN0_6; /*!< [0x48020] DI1 Sync Wave Gen 6 Register 0 */
    __IO hw_ipu_di1_sw_gen0_7_t DI1_SW_GEN0_7; /*!< [0x48024] DI1 Sync Wave Gen 7 Register 0 */
    __IO hw_ipu_di1_sw_gen0_8_t DI1_SW_GEN0_8; /*!< [0x48028] DI1 Sync Wave Gen 8 Register 0 */
    __IO hw_ipu_di1_sw_gen0_9_t DI1_SW_GEN0_9; /*!< [0x4802C] DI1Sync Wave Gen 9 Register 0 */
    __IO hw_ipu_di1_sw_gen1_1_t DI1_SW_GEN1_1; /*!< [0x48030] DI1 Sync Wave Gen 1 Register 1 */
    __IO hw_ipu_di1_sw_gen1_2_t DI1_SW_GEN1_2; /*!< [0x48034] DI1 Sync Wave Gen 2 Register 1 */
    __IO hw_ipu_di1_sw_gen1_3_t DI1_SW_GEN1_3; /*!< [0x48038] DI1 Sync Wave Gen 3 Register 1 */
    __IO hw_ipu_di1_sw_gen1_4_t DI1_SW_GEN1_4; /*!< [0x4803C] DI1 Sync Wave Gen 4 Register 1 */
    __IO hw_ipu_di1_sw_gen1_5_t DI1_SW_GEN1_5; /*!< [0x48040] DI1 Sync Wave Gen 5 Register 1 */
    __IO hw_ipu_di1_sw_gen1_6_t DI1_SW_GEN1_6; /*!< [0x48044] DI1 Sync Wave Gen 6 Register 1 */
    __IO hw_ipu_di1_sw_gen1_7_t DI1_SW_GEN1_7; /*!< [0x48048] DI1Sync Wave Gen 7 Register 1 */
    __IO hw_ipu_di1_sw_gen1_8_t DI1_SW_GEN1_8; /*!< [0x4804C] DI1 Sync Wave Gen 8 Register 1 */
    __IO hw_ipu_di1_sw_gen1_9_t DI1_SW_GEN1_9; /*!< [0x48050] DI1 Sync Wave Gen 9 Register 1 */
    __IO hw_ipu_di1_sync_as_gen_t DI1_SYNC_AS_GEN; /*!< [0x48054] DI1 Sync Assistance Gen Register */
    __IO hw_ipu_di1_dw_gen_i_t DI1_DW_GEN_i; /*!< [0x48058] DI1 Data Wave Gen <i> Register */
    uint8_t _reserved46[44];
    __IO hw_ipu_di1_dw_set0_i_t DI1_DW_SET0_i; /*!< [0x48088] DI1 Data Wave Set 0 <i> Register */
    uint8_t _reserved47[44];
    __IO hw_ipu_di1_dw_set1_i_t DI1_DW_SET1_i; /*!< [0x480B8] DI1 Data Wave Set 1 <i> Register */
    uint8_t _reserved48[44];
    __IO hw_ipu_di1_dw_set2_i_t DI1_DW_SET2_i; /*!< [0x480E8] DI1 Data Wave Set 2 <i> Register */
    uint8_t _reserved49[44];
    __IO hw_ipu_di1_dw_set3_i_t DI1_DW_SET3_i; /*!< [0x48118] DI1 Data Wave Set 3 <i> Register */
    uint8_t _reserved50[44];
    __IO hw_ipu_d1_stp_rep_i_t D1_STP_REP_i; /*!< [0x48148] DI1 Step Repeat <i> Registers */
    uint8_t _reserved51[12];
    __IO hw_ipu_di1_stp_rep_9_t DI1_STP_REP_9; /*!< [0x48158] DI1Step Repeat 9 Registers */
    __IO hw_ipu_di1_ser_conf_t DI1_SER_CONF; /*!< [0x4815C] DI1 Serial Display Control Register */
    __IO hw_ipu_di1_ssc_t DI1_SSC;         /*!< [0x48160] DI1 Special Signals Control Register */
    __IO hw_ipu_di1_pol_t DI1_POL;         /*!< [0x48164] DI1 Polarity Register */
    __IO hw_ipu_di1_aw0_t DI1_AW0;         /*!< [0x48168] DI1Active Window 0 Register */
    __IO hw_ipu_di1_aw1_t DI1_AW1;         /*!< [0x4816C] DI1 Active Window 1 Register */
    __IO hw_ipu_di1_scr_conf_t DI1_SCR_CONF; /*!< [0x48170] DI1 Screen Configuration Register */
    __I hw_ipu_di1_stat_t DI1_STAT;        /*!< [0x48174] DI1 Status Register */
    uint8_t _reserved52[32392];
    __IO hw_ipu_smfc_map_t SMFC_MAP;       /*!< [0x50000] SMFC Mapping Register */
    __IO hw_ipu_smfc_wmc_t SMFC_WMC;       /*!< [0x50004] SMFC Watermark Control Register */
    __IO hw_ipu_smfc_bs_t SMFC_BS;         /*!< [0x50008] SMFC Burst Size Register */
    uint8_t _reserved53[32756];
    __IO hw_ipu_dc_read_ch_conf_t DC_READ_CH_CONF; /*!< [0x58000] DC Read Channel Configuration Register */
    __IO hw_ipu_dc_read_sh_addr_t DC_READ_SH_ADDR; /*!< [0x58004] DC Read Channel Start Address Register */
    __IO hw_ipu_dc_rl0_ch_0_t DC_RL0_CH_0; /*!< [0x58008] DC Routine Link Register 0 Channel 0 */
    __IO hw_ipu_dc_rl1_ch_0_t DC_RL1_CH_0; /*!< [0x5800C] DC Routine Link Register 1 Channel 0 */
    __IO hw_ipu_dc_rl2_ch_0_t DC_RL2_CH_0; /*!< [0x58010] DC Routine Link Register2 Channel 0 */
    __IO hw_ipu_dc_rl3_ch_0_t DC_RL3_CH_0; /*!< [0x58014] DC Routine Link Registe3 Channel 0 */
    __IO hw_ipu_dc_rl4_ch_0_t DC_RL4_CH_0; /*!< [0x58018] DC Routine Link Register 4 Channel 0 */
    __IO hw_ipu_dc_wr_ch_conf_1_t DC_WR_CH_CONF_1; /*!< [0x5801C] DC Write Channel 1 Configuration Register */
    __IO hw_ipu_dc_wr_ch_addr_1_t DC_WR_CH_ADDR_1; /*!< [0x58020] DC Write Channel 1 Address Configuration Register */
    __IO hw_ipu_dc_rl0_ch_1_t DC_RL0_CH_1; /*!< [0x58024] DC Routine Link Register 0 Channel 1 */
    __IO hw_ipu_dc_rl1_ch_1_t DC_RL1_CH_1; /*!< [0x58028] DC Routine Link Register 1 Channel 1 */
    __IO hw_ipu_dc_rl2_ch_1_t DC_RL2_CH_1; /*!< [0x5802C] DC Routine Link Register 2 Channel 1 */
    __IO hw_ipu_dc_rl3_ch_1_t DC_RL3_CH_1; /*!< [0x58030] DC Routine Link Register 3 Channel 1 */
    __IO hw_ipu_dc_rl4_ch_1_t DC_RL4_CH_1; /*!< [0x58034] DC Routine Link Register 4 Channel 1 */
    __IO hw_ipu_dc_wr_ch_conf_2_t DC_WR_CH_CONF_2; /*!< [0x58038] DC Write Channel 2 Configuration Register */
    __IO hw_ipu_dc_wr_ch_addr_2_t DC_WR_CH_ADDR_2; /*!< [0x5803C] DC Write Channel 2 Address Configuration Register */
    __IO hw_ipu_dc_rl0_ch_2_t DC_RL0_CH_2; /*!< [0x58040] DC Routine Link Register 0 Channel 2 */
    __IO hw_ipu_dc_rl1_ch_2_t DC_RL1_CH_2; /*!< [0x58044] DC Routine Link Register 1 Channel 2 */
    __IO hw_ipu_dc_rl2_ch_2_t DC_RL2_CH_2; /*!< [0x58048] DC Routine Link Register 2 Channel 2 */
    __IO hw_ipu_dc_rl3_ch_2_t DC_RL3_CH_2; /*!< [0x5804C] DC Routine Link Register 3 Channel 2 */
    __IO hw_ipu_dc_rl4_ch_2_t DC_RL4_CH_2; /*!< [0x58050] DC Routine Link Register 4 Channel 2 */
    __IO hw_ipu_dc_cmd_ch_conf_3_t DC_CMD_CH_CONF_3; /*!< [0x58054] DC Command Channel 3 Configuration Register */
    __IO hw_ipu_dc_cmd_ch_conf_4_t DC_CMD_CH_CONF_4; /*!< [0x58058] DC Command Channel 4 Configuration Register */
    __IO hw_ipu_dc_wr_ch_conf_5_t DC_WR_CH_CONF_5; /*!< [0x5805C] DC Write Channel 5Configuration Register */
    __IO hw_ipu_dc_wr_ch_addr_5_t DC_WR_CH_ADDR_5; /*!< [0x58060] DC Write Channel 5Address Configuration Register */
    __IO hw_ipu_dc_rl0_ch_5_t DC_RL0_CH_5; /*!< [0x58064] DC Routine Link Register 0 Channel 5 */
    __IO hw_ipu_dc_rl1_ch_5_t DC_RL1_CH_5; /*!< [0x58068] DC Routine Link Register 1 Channel 5 */
    __IO hw_ipu_dc_rl2_ch_5_t DC_RL2_CH_5; /*!< [0x5806C] DC Routine Link Register 2 Channel 5 */
    __IO hw_ipu_dc_rl3_ch_5_t DC_RL3_CH_5; /*!< [0x58070] DC Routine Link Register3 Channel 5 */
    __IO hw_ipu_dc_rl4_ch_5_t DC_RL4_CH_5; /*!< [0x58074] DC Routine Link Register 4 Channel 5 */
    __IO hw_ipu_dc_wr_ch_conf_6_t DC_WR_CH_CONF_6; /*!< [0x58078] DC Write Channel 6 Configuration Register */
    __IO hw_ipu_dc_wr_ch_addr_6_t DC_WR_CH_ADDR_6; /*!< [0x5807C] DC Write Channel 6 Address Configuration Register */
    __IO hw_ipu_dc_rl0_ch_6_t DC_RL0_CH_6; /*!< [0x58080] DC Routine Link Register 0Channel 6 */
    __IO hw_ipu_dc_rl1_ch_6_t DC_RL1_CH_6; /*!< [0x58084] DC Routine Link Register 1 Channel 6 */
    __IO hw_ipu_dc_rl2_ch_6_t DC_RL2_CH_6; /*!< [0x58088] DC Routine Link Register 2 Channel 6 */
    __IO hw_ipu_dc_rl3_ch_6_t DC_RL3_CH_6; /*!< [0x5808C] DC Routine Link Register 3 Channel 6 */
    __IO hw_ipu_dc_rl4_ch_6_t DC_RL4_CH_6; /*!< [0x58090] DC Routine Link Register 4 Channel 6 */
    __IO hw_ipu_dc_wr_ch_conf1_8_t DC_WR_CH_CONF1_8; /*!< [0x58094] DC Write Channel 8 Configuration 1Register */
    __IO hw_ipu_dc_wr_ch_conf2_8_t DC_WR_CH_CONF2_8; /*!< [0x58098] DC Write Channel 8 Configuration 2 Register */
    __IO hw_ipu_dc_rl1_ch_8_t DC_RL1_CH_8; /*!< [0x5809C] DC Routine Link Register 1 Channel 8 */
    __IO hw_ipu_dc_rl2_ch_8_t DC_RL2_CH_8; /*!< [0x580A0] DC Routine Link Register 2 Channel 8 */
    __IO hw_ipu_dc_rl3_ch_8_t DC_RL3_CH_8; /*!< [0x580A4] DC Routine Link Register 3 Channel 8 */
    __IO hw_ipu_dc_rl4_ch_8_t DC_RL4_CH_8; /*!< [0x580A8] DC Routine Link Register 4 Channel 8 */
    __IO hw_ipu_dc_rl5_ch_8_t DC_RL5_CH_8; /*!< [0x580AC] DC Routine Link Register 5 Channel 8 */
    __IO hw_ipu_dc_rl6_ch_8_t DC_RL6_CH_8; /*!< [0x580B0] DC Routine Link Register 6 Channel 8 */
    __IO hw_ipu_dc_wr_ch_conf1_9_t DC_WR_CH_CONF1_9; /*!< [0x580B4] DC Write Channel 9 Configuration 1Register */
    __IO hw_ipu_dc_wr_ch_conf2_9_t DC_WR_CH_CONF2_9; /*!< [0x580B8] DC Write Channel 9Configuration 2Register */
    __IO hw_ipu_dc_rl1_ch_9_t DC_RL1_CH_9; /*!< [0x580BC] DC Routine Link Register 1 Channel 9 */
    __IO hw_ipu_dc_rl2_ch_9_t DC_RL2_CH_9; /*!< [0x580C0] DC Routine Link Register 2 Channel 9 */
    __IO hw_ipu_dc_rl3_ch_9_t DC_RL3_CH_9; /*!< [0x580C4] DC Routine Link Register 3Channel 9 */
    __IO hw_ipu_dc_rl4_ch_9_t DC_RL4_CH_9; /*!< [0x580C8] DC Routine Link Register 4 Channel 9 */
    __IO hw_ipu_dc_rl5_ch_9_t DC_RL5_CH_9; /*!< [0x580CC] DC Routine Link Register 5 Channel 9 */
    __IO hw_ipu_dc_rl6_ch_9_t DC_RL6_CH_9; /*!< [0x580D0] DC Routine Link Register 6 Channel 9 */
    __IO hw_ipu_dc_gen_t DC_GEN;           /*!< [0x580D4] DC General Register */
    __IO hw_ipu_dc_disp_conf1_0_t DC_DISP_CONF1_0; /*!< [0x580D8] DC Display Configuration 1 Register 0 */
    __IO hw_ipu_dc_disp_conf1_1_t DC_DISP_CONF1_1; /*!< [0x580DC] DC Display Configuration 1 Register 1 */
    __IO hw_ipu_dc_disp_conf1_2_t DC_DISP_CONF1_2; /*!< [0x580E0] DC Display Configuration 1 Register 2 */
    __IO hw_ipu_dc_disp_conf1_3_t DC_DISP_CONF1_3; /*!< [0x580E4] DC Display Configuration 1 Register 3 */
    __IO hw_ipu_dc_disp_conf2_0_t DC_DISP_CONF2_0; /*!< [0x580E8] DC Display Configuration 2 Register 0 */
    __IO hw_ipu_dc_disp_conf2_1_t DC_DISP_CONF2_1; /*!< [0x580EC] DC Display Configuration 2 Register 1 */
    __IO hw_ipu_dc_disp_conf2_2_t DC_DISP_CONF2_2; /*!< [0x580F0] DC Display Configuration 2 Register 2 */
    __IO hw_ipu_dc_disp_conf2_3_t DC_DISP_CONF2_3; /*!< [0x580F4] DC Display Configuration 2 Register 3 */
    __IO hw_ipu_dc_di0_conf_1_t DC_DI0_CONF_1; /*!< [0x580F8] DC DI0Configuration Register 1 */
    __IO hw_ipu_dc_di0_conf_2_t DC_DI0_CONF_2; /*!< [0x580FC] DC DI0Configuration Register 2 */
    __IO hw_ipu_dc_di1_conf_1_t DC_DI1_CONF_1; /*!< [0x58100] DC DI1Configuration Register 1 */
    __IO hw_ipu_dc_di1_conf_2_t DC_DI1_CONF_2; /*!< [0x58104] DC DI1Configuration Register 2 */
    __IO hw_ipu_dc_map_conf_0_t DC_MAP_CONF_0; /*!< [0x58108] DC Mapping Configuration Register 0 */
    __IO hw_ipu_dc_map_conf_1_t DC_MAP_CONF_1; /*!< [0x5810C] DC Mapping Configuration Register 1 */
    __IO hw_ipu_dc_map_conf_2_t DC_MAP_CONF_2; /*!< [0x58110] DC Mapping Configuration Register 2 */
    __IO hw_ipu_dc_map_conf_3_t DC_MAP_CONF_3; /*!< [0x58114] DC Mapping Configuration Register 3 */
    __IO hw_ipu_dc_map_conf_4_t DC_MAP_CONF_4; /*!< [0x58118] DC Mapping Configuration Register 4 */
    __IO hw_ipu_dc_map_conf_5_t DC_MAP_CONF_5; /*!< [0x5811C] DC Mapping Configuration Register 5 */
    __IO hw_ipu_dc_map_conf_6_t DC_MAP_CONF_6; /*!< [0x58120] DC Mapping Configuration Register 6 */
    __IO hw_ipu_dc_map_conf_7_t DC_MAP_CONF_7; /*!< [0x58124] DC Mapping Configuration Register 7 */
    __IO hw_ipu_dc_map_conf_8_t DC_MAP_CONF_8; /*!< [0x58128] DC Mapping Configuration Register 8 */
    __IO hw_ipu_dc_map_conf_9_t DC_MAP_CONF_9; /*!< [0x5812C] DC Mapping Configuration Register 9 */
    __IO hw_ipu_dc_map_conf_10_t DC_MAP_CONF_10; /*!< [0x58130] DC Mapping Configuration Register 10 */
    __IO hw_ipu_dc_map_conf_11_t DC_MAP_CONF_11; /*!< [0x58134] DC Mapping Configuration Register 11 */
    __IO hw_ipu_dc_map_conf_12_t DC_MAP_CONF_12; /*!< [0x58138] DC Mapping Configuration Register 12 */
    __IO hw_ipu_dc_map_conf_13_t DC_MAP_CONF_13; /*!< [0x5813C] DC Mapping Configuration Register 13 */
    __IO hw_ipu_dc_map_conf_14_t DC_MAP_CONF_14; /*!< [0x58140] DC Mapping Configuration Register 14 */
    __IO hw_ipu_dc_map_conf_15_t DC_MAP_CONF_15; /*!< [0x58144] DC Mapping Configuration Register 15 */
    __IO hw_ipu_dc_map_conf_16_t DC_MAP_CONF_16; /*!< [0x58148] DC Mapping Configuration Register 16 */
    __IO hw_ipu_dc_map_conf_17_t DC_MAP_CONF_17; /*!< [0x5814C] DC Mapping Configuration Register 17 */
    __IO hw_ipu_dc_map_conf_18_t DC_MAP_CONF_18; /*!< [0x58150] DC Mapping Configuration Register 18 */
    __IO hw_ipu_dc_map_conf_19_t DC_MAP_CONF_19; /*!< [0x58154] DC Mapping Configuration Register 19 */
    __IO hw_ipu_dc_map_conf_20_t DC_MAP_CONF_20; /*!< [0x58158] DC Mapping Configuration Register 20 */
    __IO hw_ipu_dc_map_conf_21_t DC_MAP_CONF_21; /*!< [0x5815C] DC Mapping Configuration Register 21 */
    __IO hw_ipu_dc_map_conf_22_t DC_MAP_CONF_22; /*!< [0x58160] DC Mapping Configuration Register 22 */
    __IO hw_ipu_dc_map_conf_23_t DC_MAP_CONF_23; /*!< [0x58164] DC Mapping Configuration Register 23 */
    __IO hw_ipu_dc_map_conf_24_t DC_MAP_CONF_24; /*!< [0x58168] DC Mapping Configuration Register 24 */
    __IO hw_ipu_dc_map_conf_25_t DC_MAP_CONF_25; /*!< [0x5816C] DC Mapping Configuration Register 25 */
    __IO hw_ipu_dc_map_conf_26_t DC_MAP_CONF_26; /*!< [0x58170] DC Mapping Configuration Register 26 */
    __IO hw_ipu_dc_ugde0_0_t DC_UGDE0_0;   /*!< [0x58174] DC User General Data Event 0 Register 0 */
    __IO hw_ipu_dc_ugde0_1_t DC_UGDE0_1;   /*!< [0x58178] DC User General Data Event 0 Register 1 */
    __IO hw_ipu_dc_ugde0_2_t DC_UGDE0_2;   /*!< [0x5817C] DC User General Data Event 0 Register2 */
    __IO hw_ipu_dc_ugde0_3_t DC_UGDE0_3;   /*!< [0x58180] DC User General Data Event 0 Register 3 */
    __IO hw_ipu_dc_ugde1_0_t DC_UGDE1_0;   /*!< [0x58184] DC User General Data Event 1Register0 */
    __IO hw_ipu_dc_ugde1_1_t DC_UGDE1_1;   /*!< [0x58188] DC User General Data Event 1 Register 1 */
    __IO hw_ipu_dc_ugde1_2_t DC_UGDE1_2;   /*!< [0x5818C] DC User General Data Event 1Register 2 */
    __IO hw_ipu_dc_ugde1_3_t DC_UGDE1_3;   /*!< [0x58190] DC User General Data Event 1Register 3 */
    __IO hw_ipu_dc_ugde2_0_t DC_UGDE2_0;   /*!< [0x58194] DC User General Data Event 2 Register 0 */
    __IO hw_ipu_dc_ugde2_1_t DC_UGDE2_1;   /*!< [0x58198] DC User General Data Event 2 Register 1 */
    __IO hw_ipu_dc_ugde2_2_t DC_UGDE2_2;   /*!< [0x5819C] DC User General Data Event 2Register 2 */
    __IO hw_ipu_dc_ugde2_3_t DC_UGDE2_3;   /*!< [0x581A0] DC User General Data Event 2Register 3 */
    __IO hw_ipu_dc_ugde3_0_t DC_UGDE3_0;   /*!< [0x581A4] DC User General Data Event 3Register 0 */
    __IO hw_ipu_dc_ugde3_1_t DC_UGDE3_1;   /*!< [0x581A8] DC User General Data Event 3Register 1 */
    __IO hw_ipu_dc_ugde3_2_t DC_UGDE3_2;   /*!< [0x581AC] DC User General Data Event 3Register 2 */
    __IO hw_ipu_dc_ugde3_3_t DC_UGDE3_3;   /*!< [0x581B0] DC User General Data Event 3Register 2 */
    __IO hw_ipu_dc_lla0_t DC_LLA0;         /*!< [0x581B4] DC Low Level Access Control Register 0 */
    __IO hw_ipu_dc_lla1_t DC_LLA1;         /*!< [0x581B8] DC Low Level Access Control Register 1 */
    __IO hw_ipu_dc_r_lla0_t DC_R_LLA0;     /*!< [0x581BC] DC Read Low Level Read Access Control Register 0 */
    __IO hw_ipu_dc_r_lla1_t DC_R_LLA1;     /*!< [0x581C0] DC Read Low Level Read Access Control Register1 */
    __IO hw_ipu_dc_wr_ch_addr_5_alt_t DC_WR_CH_ADDR_5_ALT; /*!< [0x581C4] DC Write Channel 5 Configuration Register */
    __I hw_ipu_dc_stat_t DC_STAT;          /*!< [0x581C8] DC Status Register */
    uint8_t _reserved54[32308];
    __IO hw_ipu_dmfc_rd_chan_t DMFC_RD_CHAN; /*!< [0x60000] DMFC Read Channel Register */
    __IO hw_ipu_dmfc_wr_chan_t DMFC_WR_CHAN; /*!< [0x60004] DMFC Write Channel Register */
    __IO hw_ipu_dmfc_wr_chan_def_t DMFC_WR_CHAN_DEF; /*!< [0x60008] DMFC Write Channel Definition Register */
    __IO hw_ipu_dmfc_dp_chan_t DMFC_DP_CHAN; /*!< [0x6000C] DMFC Display Processor Channel Register */
    __IO hw_ipu_dmfc_dp_chan_def_t DMFC_DP_CHAN_DEF; /*!< [0x60010] DMFC Display Processor Channel Definition Register */
    __IO hw_ipu_dmfc_general_1_t DMFC_GENERAL_1; /*!< [0x60014] DMFC General 1 Register */
    __IO hw_ipu_dmfc_general_2_t DMFC_GENERAL_2; /*!< [0x60018] DMFC General 2 Register */
    __IO hw_ipu_dmfc_ic_ctrl_t DMFC_IC_CTRL; /*!< [0x6001C] DMFC IC Interface Control Register */
    __IO hw_ipu_dmfc_wr_chan_alt_t DMFC_WR_CHAN_ALT; /*!< [0x60020] DMFC Write Channel Alternate Register */
    __IO hw_ipu_dmfc_wr_chan_def_alt_t DMFC_WR_CHAN_DEF_ALT; /*!< [0x60024] DMFC Write Channel Definition Alternate Register */
    __IO hw_ipu_dmfc_dp_chan_alt_t DMFC_DP_CHAN_ALT; /*!< [0x60028] DMFC MFC Display Processor Channel Alternate Register */
    __IO hw_ipu_dmfc_dp_chan_def_alt_t DMFC_DP_CHAN_DEF_ALT; /*!< [0x6002C] DMFC Display Channel Definition Alternate Register */
    __IO hw_ipu_dmfc_general1_alt_t DMFC_GENERAL1_ALT; /*!< [0x60030] DMFC General 1 Alternate Register */
    __I hw_ipu_dmfc_stat_t DMFC_STAT;      /*!< [0x60034] DMFC Status Register */
    uint8_t _reserved55[32712];
    __IO hw_ipu_vdi_fsize_t VDI_FSIZE;     /*!< [0x68000] VDI Field Size Register */
    __IO hw_ipu_vdi_c_t VDI_C;             /*!< [0x68004] VDI Control Register */
    __IO hw_ipu_vdi_c2__t VDI_C2_;         /*!< [0x68008] VDI Control Register 2 */
    __IO hw_ipu_vdi_cmdp_1_t VDI_CMDP_1;   /*!< [0x6800C] VDI Combining Parameters Register 1 */
    __IO hw_ipu_vdi_cmdp_2_t VDI_CMDP_2;   /*!< [0x68010] VDI Combining Parameters Register 2 */
    __IO hw_ipu_vdi_ps_1_t VDI_PS_1;       /*!< [0x68014] VDI Plane Size Register 1 */
    __IO hw_ipu_vdi_ps_2_t VDI_PS_2;       /*!< [0x68018] VDI Plane Size Register 2 */
    __IO hw_ipu_vdi_ps_3_t VDI_PS_3;       /*!< [0x6801C] VDI Plane Size Register 3 */
    __IO hw_ipu_vdi_ps_4_t VDI_PS_4;       /*!< [0x68020] VDI Plane Size Register 4 */
} hw_ipu_t;
#pragma pack()

/*! @brief Macro to access all IPU registers. */
/*! @param x IPU module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_IPU_REGS(IPU1_BASE)</code>. */
#define HW_IPU_REGS(x) (*(hw_ipu_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP IPU_PR
 *
 * IPU PRG
 *
 * Registers defined in this header file:
 * - HW_IPU_PR_CTRL - IPU PR Control Register
 * - HW_IPU_PR_STATUS - IPU PR STATUS Register
 * - HW_IPU_PR_QOS - IPU PR QOS Register
 * - HW_IPU_PR_REG_UPDATE - IPU PR Control Register
 * - HW_IPU_PR_STRIDE0 - IPU PR Stride Register
 * - HW_IPU_PR_STRIDE1 - IPU PR Stride Register
 * - HW_IPU_PR_STRIDE2 - IPU PR Stride Register
 * - HW_IPU_PR_CORP_LINE - IPU PR Stride Register
 * - HW_IPU_PR_ADDR_THD - IPU PR Address Thresh Hold Register
 * - HW_IPU_PR_CH0_BADDR - IPU PR Start Base Address Register
 * - HW_IPU_PR_CH1_BADDR - IPU PR Start Base Address Register
 * - HW_IPU_PR_CH2_BADDR - IPU PR Start Base Address Register
 * - HW_IPU_PR_CH0_OFFSET - IPU PR Start Offset Address Register
 * - HW_IPU_PR_CH1_OFFSET - IPU PR Start Offset Address Register
 * - HW_IPU_PR_CH2_OFFSET - IPU PR Start Offset Address Register
 * - HW_IPU_PR_CH0_ILO - IPU PRG Interlace Offset Address Register
 * - HW_IPU_PR_CH1_ILO - IPU PRG Interlace Offset Address Register
 * - HW_IPU_PR_CH2_ILO - IPU PRG Interlace Offset Address Register
 * - HW_IPU_PR_CH0_HEIGHT - IPU PRG Interlace Offset Address Register
 * - HW_IPU_PR_CH1_HEIGHT - IPU PRG Interlace Offset Address Register
 * - HW_IPU_PR_CH2_HEIGHT - IPU PRG Interlace Offset Address Register
 *
 * - hw_ipu_pr_t - Struct containing all module registers.
 */

#define HW_IPU_PR_INSTANCE_COUNT (1U) /*!< Number of instances of the IPU_PR module. */
#define HW_IPU_PR (0U) /*!< Instance number for IPU_PR. */
#define IPU_PR_BASE           (0x0U) /*!< Base address for IPU_PR. */
/*! Array initializer of IPU_PR base addresses. */
#define IPU_PR_BASE_ADDRS     { IPU_PR_BASE }

/*******************************************************************************
 * HW_IPU_PR_CTRL - IPU PR Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CTRL - IPU PR Control Register (RW)
 *
 * Reset value: 0x00000007U
 */
typedef union _hw_ipu_pr_ctrl
{
    uint32_t U;
    struct _hw_ipu_pr_ctrl_bitfields
    {
        uint32_t CH0_BYPASS : 1;       /*!< [0] Channel 0 Bypass */
        uint32_t CH1_BYPASS : 1;       /*!< [1] Channel 1 Bypass */
        uint32_t CH2_BYPASS : 1;       /*!< [2] Channel 2 Bypass */
        uint32_t RESERVED0 : 5;        /*!< [7:3]  */
        uint32_t SOFT_CH0_ARID : 2;    /*!< [9:8]  */
        uint32_t SOFT_CH1_ARID : 2;    /*!< [11:10]  */
        uint32_t SOFT_CH2_ARID : 2;    /*!< [13:12]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t CH0_SO : 1;           /*!< [16] Channel 0 Scan Order Enable */
        uint32_t CH1_SO : 1;           /*!< [17] Channel 1 Scan Order Enable */
        uint32_t CH2_SO : 1;           /*!< [18] Channel 2 Scan Order Enable */
        uint32_t CH0_VFLIP : 1;        /*!< [19] Channel 0 Vertical Flip Enable */
        uint32_t CH1_VFLIP : 1;        /*!< [20] Channel 1 Vertical Flip Enable */
        uint32_t CH2_VFLIP : 1;        /*!< [21] Channel 2 Vertical Flip Enable */
        uint32_t CH0_BLOCK_MODE : 1;   /*!< [22] Channel 0 Block Mode Enable */
        uint32_t CH1_BLOCK_MODE : 1;   /*!< [23] Channel 1 Block Mode Enable */
        uint32_t CH2_BLOCK_MODE : 1;   /*!< [24] Channel 2 Block Mode Enable */
        uint32_t CH0_CNT_LOAD_EN : 1;  /*!< [25] Channel 0 Count Re-load
                                        * Enable */
        uint32_t CH1_CNT_LOAD_EN : 1;  /*!< [26] Channel 1 Count Re-load
                                        * Enable */
        uint32_t CH2_CNT_LOAD_EN : 1;  /*!< [27] Channel 2 Count Re-load
                                        * Enable */
        uint32_t RESERVED2 : 2;        /*!< [29:28]  */
        uint32_t SOFTRST : 1;          /*!< [30] Software Reset */
        uint32_t SHADOW_EN : 1;        /*!< [31] Shadow Register Enable */
    } B;
} hw_ipu_pr_ctrl_t;

/*!
 * @name Constants and macros for entire IPU_PR_CTRL register
 */
/*@{*/
#define HW_IPU_PR_CTRL_ADDR(x)   ((uintptr_t)(x) + 0x0U)

#define HW_IPU_PR_CTRL(x)        (*(__IO hw_ipu_pr_ctrl_t *) HW_IPU_PR_CTRL_ADDR(x))
#define HW_IPU_PR_CTRL_RD(x)     (HW_IPU_PR_CTRL(x).U)
#define HW_IPU_PR_CTRL_WR(x, v)  (HW_IPU_PR_CTRL(x).U = (v))
#define HW_IPU_PR_CTRL_SET(x, v) (HW_IPU_PR_CTRL_WR(x, HW_IPU_PR_CTRL_RD(x) |  (v)))
#define HW_IPU_PR_CTRL_CLR(x, v) (HW_IPU_PR_CTRL_WR(x, HW_IPU_PR_CTRL_RD(x) & ~(v)))
#define HW_IPU_PR_CTRL_TOG(x, v) (HW_IPU_PR_CTRL_WR(x, HW_IPU_PR_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CTRL bitfields
 */

/*!
 * @name Register IPU_PR_CTRL, field CH0_BYPASS[0] (RW)
 *
 * Values:
 * - 0 - Compare the ARID[1:0] and SOFT_ARID[1:0], the hit arid channel will be
 *     done Address re-mapping.
 * - 1 - Bypass all read channel address
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH0_BYPASS (0U)     /*!< Bit position for IPU_PR_CTRL_CH0_BYPASS. */
#define BM_IPU_PR_CTRL_CH0_BYPASS (0x00000001U) /*!< Bit mask for IPU_PR_CTRL_CH0_BYPASS. */
#define BS_IPU_PR_CTRL_CH0_BYPASS (1U)     /*!< Bit field size in bits for IPU_PR_CTRL_CH0_BYPASS. */

/*! @brief Read current value of the IPU_PR_CTRL_CH0_BYPASS field. */
#define BR_IPU_PR_CTRL_CH0_BYPASS(x) (HW_IPU_PR_CTRL(x).B.CH0_BYPASS)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH0_BYPASS. */
#define BF_IPU_PR_CTRL_CH0_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH0_BYPASS) & BM_IPU_PR_CTRL_CH0_BYPASS)

/*! @brief Set the CH0_BYPASS field to a new value. */
#define BW_IPU_PR_CTRL_CH0_BYPASS(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH0_BYPASS) | BF_IPU_PR_CTRL_CH0_BYPASS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH1_BYPASS[1] (RW)
 *
 * Values:
 * - 0 - Compare the ARID[1:0] and SOFT_ARID[1:0], the hit arid channel will be
 *     done Address re-mapping.
 * - 1 - Bypass all read channel address
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH1_BYPASS (1U)     /*!< Bit position for IPU_PR_CTRL_CH1_BYPASS. */
#define BM_IPU_PR_CTRL_CH1_BYPASS (0x00000002U) /*!< Bit mask for IPU_PR_CTRL_CH1_BYPASS. */
#define BS_IPU_PR_CTRL_CH1_BYPASS (1U)     /*!< Bit field size in bits for IPU_PR_CTRL_CH1_BYPASS. */

/*! @brief Read current value of the IPU_PR_CTRL_CH1_BYPASS field. */
#define BR_IPU_PR_CTRL_CH1_BYPASS(x) (HW_IPU_PR_CTRL(x).B.CH1_BYPASS)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH1_BYPASS. */
#define BF_IPU_PR_CTRL_CH1_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH1_BYPASS) & BM_IPU_PR_CTRL_CH1_BYPASS)

/*! @brief Set the CH1_BYPASS field to a new value. */
#define BW_IPU_PR_CTRL_CH1_BYPASS(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH1_BYPASS) | BF_IPU_PR_CTRL_CH1_BYPASS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH2_BYPASS[2] (RW)
 *
 * Values:
 * - 0 - Compare the ARID[1:0] and SOFT_ARID[1:0], the hit arid channel will be
 *     done Address re-mapping.
 * - 1 - Bypass all read channel address
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH2_BYPASS (2U)     /*!< Bit position for IPU_PR_CTRL_CH2_BYPASS. */
#define BM_IPU_PR_CTRL_CH2_BYPASS (0x00000004U) /*!< Bit mask for IPU_PR_CTRL_CH2_BYPASS. */
#define BS_IPU_PR_CTRL_CH2_BYPASS (1U)     /*!< Bit field size in bits for IPU_PR_CTRL_CH2_BYPASS. */

/*! @brief Read current value of the IPU_PR_CTRL_CH2_BYPASS field. */
#define BR_IPU_PR_CTRL_CH2_BYPASS(x) (HW_IPU_PR_CTRL(x).B.CH2_BYPASS)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH2_BYPASS. */
#define BF_IPU_PR_CTRL_CH2_BYPASS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH2_BYPASS) & BM_IPU_PR_CTRL_CH2_BYPASS)

/*! @brief Set the CH2_BYPASS field to a new value. */
#define BW_IPU_PR_CTRL_CH2_BYPASS(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH2_BYPASS) | BF_IPU_PR_CTRL_CH2_BYPASS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field SOFT_CH0_ARID[9:8] (RW)
 *
 * Soft arid[1:0]
 */
/*@{*/
#define BP_IPU_PR_CTRL_SOFT_CH0_ARID (8U)  /*!< Bit position for IPU_PR_CTRL_SOFT_CH0_ARID. */
#define BM_IPU_PR_CTRL_SOFT_CH0_ARID (0x00000300U) /*!< Bit mask for IPU_PR_CTRL_SOFT_CH0_ARID. */
#define BS_IPU_PR_CTRL_SOFT_CH0_ARID (2U)  /*!< Bit field size in bits for IPU_PR_CTRL_SOFT_CH0_ARID. */

/*! @brief Read current value of the IPU_PR_CTRL_SOFT_CH0_ARID field. */
#define BR_IPU_PR_CTRL_SOFT_CH0_ARID(x) (HW_IPU_PR_CTRL(x).B.SOFT_CH0_ARID)

/*! @brief Format value for bitfield IPU_PR_CTRL_SOFT_CH0_ARID. */
#define BF_IPU_PR_CTRL_SOFT_CH0_ARID(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_SOFT_CH0_ARID) & BM_IPU_PR_CTRL_SOFT_CH0_ARID)

/*! @brief Set the SOFT_CH0_ARID field to a new value. */
#define BW_IPU_PR_CTRL_SOFT_CH0_ARID(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_SOFT_CH0_ARID) | BF_IPU_PR_CTRL_SOFT_CH0_ARID(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field SOFT_CH1_ARID[11:10] (RW)
 *
 * Soft arid[1:0]
 */
/*@{*/
#define BP_IPU_PR_CTRL_SOFT_CH1_ARID (10U) /*!< Bit position for IPU_PR_CTRL_SOFT_CH1_ARID. */
#define BM_IPU_PR_CTRL_SOFT_CH1_ARID (0x00000C00U) /*!< Bit mask for IPU_PR_CTRL_SOFT_CH1_ARID. */
#define BS_IPU_PR_CTRL_SOFT_CH1_ARID (2U)  /*!< Bit field size in bits for IPU_PR_CTRL_SOFT_CH1_ARID. */

/*! @brief Read current value of the IPU_PR_CTRL_SOFT_CH1_ARID field. */
#define BR_IPU_PR_CTRL_SOFT_CH1_ARID(x) (HW_IPU_PR_CTRL(x).B.SOFT_CH1_ARID)

/*! @brief Format value for bitfield IPU_PR_CTRL_SOFT_CH1_ARID. */
#define BF_IPU_PR_CTRL_SOFT_CH1_ARID(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_SOFT_CH1_ARID) & BM_IPU_PR_CTRL_SOFT_CH1_ARID)

/*! @brief Set the SOFT_CH1_ARID field to a new value. */
#define BW_IPU_PR_CTRL_SOFT_CH1_ARID(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_SOFT_CH1_ARID) | BF_IPU_PR_CTRL_SOFT_CH1_ARID(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field SOFT_CH2_ARID[13:12] (RW)
 *
 * Soft arid[1:0]
 */
/*@{*/
#define BP_IPU_PR_CTRL_SOFT_CH2_ARID (12U) /*!< Bit position for IPU_PR_CTRL_SOFT_CH2_ARID. */
#define BM_IPU_PR_CTRL_SOFT_CH2_ARID (0x00003000U) /*!< Bit mask for IPU_PR_CTRL_SOFT_CH2_ARID. */
#define BS_IPU_PR_CTRL_SOFT_CH2_ARID (2U)  /*!< Bit field size in bits for IPU_PR_CTRL_SOFT_CH2_ARID. */

/*! @brief Read current value of the IPU_PR_CTRL_SOFT_CH2_ARID field. */
#define BR_IPU_PR_CTRL_SOFT_CH2_ARID(x) (HW_IPU_PR_CTRL(x).B.SOFT_CH2_ARID)

/*! @brief Format value for bitfield IPU_PR_CTRL_SOFT_CH2_ARID. */
#define BF_IPU_PR_CTRL_SOFT_CH2_ARID(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_SOFT_CH2_ARID) & BM_IPU_PR_CTRL_SOFT_CH2_ARID)

/*! @brief Set the SOFT_CH2_ARID field to a new value. */
#define BW_IPU_PR_CTRL_SOFT_CH2_ARID(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_SOFT_CH2_ARID) | BF_IPU_PR_CTRL_SOFT_CH2_ARID(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH0_SO[16] (RW)
 *
 * Values:
 * - 0 - Interlace mode
 * - 1 - Progressive mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH0_SO (16U)        /*!< Bit position for IPU_PR_CTRL_CH0_SO. */
#define BM_IPU_PR_CTRL_CH0_SO (0x00010000U) /*!< Bit mask for IPU_PR_CTRL_CH0_SO. */
#define BS_IPU_PR_CTRL_CH0_SO (1U)         /*!< Bit field size in bits for IPU_PR_CTRL_CH0_SO. */

/*! @brief Read current value of the IPU_PR_CTRL_CH0_SO field. */
#define BR_IPU_PR_CTRL_CH0_SO(x) (HW_IPU_PR_CTRL(x).B.CH0_SO)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH0_SO. */
#define BF_IPU_PR_CTRL_CH0_SO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH0_SO) & BM_IPU_PR_CTRL_CH0_SO)

/*! @brief Set the CH0_SO field to a new value. */
#define BW_IPU_PR_CTRL_CH0_SO(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH0_SO) | BF_IPU_PR_CTRL_CH0_SO(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH1_SO[17] (RW)
 *
 * Values:
 * - 0 - Interlace mode
 * - 1 - Progressive mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH1_SO (17U)        /*!< Bit position for IPU_PR_CTRL_CH1_SO. */
#define BM_IPU_PR_CTRL_CH1_SO (0x00020000U) /*!< Bit mask for IPU_PR_CTRL_CH1_SO. */
#define BS_IPU_PR_CTRL_CH1_SO (1U)         /*!< Bit field size in bits for IPU_PR_CTRL_CH1_SO. */

/*! @brief Read current value of the IPU_PR_CTRL_CH1_SO field. */
#define BR_IPU_PR_CTRL_CH1_SO(x) (HW_IPU_PR_CTRL(x).B.CH1_SO)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH1_SO. */
#define BF_IPU_PR_CTRL_CH1_SO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH1_SO) & BM_IPU_PR_CTRL_CH1_SO)

/*! @brief Set the CH1_SO field to a new value. */
#define BW_IPU_PR_CTRL_CH1_SO(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH1_SO) | BF_IPU_PR_CTRL_CH1_SO(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH2_SO[18] (RW)
 *
 * Values:
 * - 0 - Interlace mode
 * - 1 - Progressive mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH2_SO (18U)        /*!< Bit position for IPU_PR_CTRL_CH2_SO. */
#define BM_IPU_PR_CTRL_CH2_SO (0x00040000U) /*!< Bit mask for IPU_PR_CTRL_CH2_SO. */
#define BS_IPU_PR_CTRL_CH2_SO (1U)         /*!< Bit field size in bits for IPU_PR_CTRL_CH2_SO. */

/*! @brief Read current value of the IPU_PR_CTRL_CH2_SO field. */
#define BR_IPU_PR_CTRL_CH2_SO(x) (HW_IPU_PR_CTRL(x).B.CH2_SO)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH2_SO. */
#define BF_IPU_PR_CTRL_CH2_SO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH2_SO) & BM_IPU_PR_CTRL_CH2_SO)

/*! @brief Set the CH2_SO field to a new value. */
#define BW_IPU_PR_CTRL_CH2_SO(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH2_SO) | BF_IPU_PR_CTRL_CH2_SO(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH0_VFLIP[19] (RW)
 *
 * Values:
 * - 0 - Enable vertical flip
 * - 1 - Disable vertical flip
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH0_VFLIP (19U)     /*!< Bit position for IPU_PR_CTRL_CH0_VFLIP. */
#define BM_IPU_PR_CTRL_CH0_VFLIP (0x00080000U) /*!< Bit mask for IPU_PR_CTRL_CH0_VFLIP. */
#define BS_IPU_PR_CTRL_CH0_VFLIP (1U)      /*!< Bit field size in bits for IPU_PR_CTRL_CH0_VFLIP. */

/*! @brief Read current value of the IPU_PR_CTRL_CH0_VFLIP field. */
#define BR_IPU_PR_CTRL_CH0_VFLIP(x) (HW_IPU_PR_CTRL(x).B.CH0_VFLIP)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH0_VFLIP. */
#define BF_IPU_PR_CTRL_CH0_VFLIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH0_VFLIP) & BM_IPU_PR_CTRL_CH0_VFLIP)

/*! @brief Set the CH0_VFLIP field to a new value. */
#define BW_IPU_PR_CTRL_CH0_VFLIP(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH0_VFLIP) | BF_IPU_PR_CTRL_CH0_VFLIP(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH1_VFLIP[20] (RW)
 *
 * Values:
 * - 0 - Enable vertical flip
 * - 1 - Disable vertical flip
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH1_VFLIP (20U)     /*!< Bit position for IPU_PR_CTRL_CH1_VFLIP. */
#define BM_IPU_PR_CTRL_CH1_VFLIP (0x00100000U) /*!< Bit mask for IPU_PR_CTRL_CH1_VFLIP. */
#define BS_IPU_PR_CTRL_CH1_VFLIP (1U)      /*!< Bit field size in bits for IPU_PR_CTRL_CH1_VFLIP. */

/*! @brief Read current value of the IPU_PR_CTRL_CH1_VFLIP field. */
#define BR_IPU_PR_CTRL_CH1_VFLIP(x) (HW_IPU_PR_CTRL(x).B.CH1_VFLIP)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH1_VFLIP. */
#define BF_IPU_PR_CTRL_CH1_VFLIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH1_VFLIP) & BM_IPU_PR_CTRL_CH1_VFLIP)

/*! @brief Set the CH1_VFLIP field to a new value. */
#define BW_IPU_PR_CTRL_CH1_VFLIP(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH1_VFLIP) | BF_IPU_PR_CTRL_CH1_VFLIP(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH2_VFLIP[21] (RW)
 *
 * Values:
 * - 0 - Enable vertical flip
 * - 1 - Disable vertical flip
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH2_VFLIP (21U)     /*!< Bit position for IPU_PR_CTRL_CH2_VFLIP. */
#define BM_IPU_PR_CTRL_CH2_VFLIP (0x00200000U) /*!< Bit mask for IPU_PR_CTRL_CH2_VFLIP. */
#define BS_IPU_PR_CTRL_CH2_VFLIP (1U)      /*!< Bit field size in bits for IPU_PR_CTRL_CH2_VFLIP. */

/*! @brief Read current value of the IPU_PR_CTRL_CH2_VFLIP field. */
#define BR_IPU_PR_CTRL_CH2_VFLIP(x) (HW_IPU_PR_CTRL(x).B.CH2_VFLIP)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH2_VFLIP. */
#define BF_IPU_PR_CTRL_CH2_VFLIP(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH2_VFLIP) & BM_IPU_PR_CTRL_CH2_VFLIP)

/*! @brief Set the CH2_VFLIP field to a new value. */
#define BW_IPU_PR_CTRL_CH2_VFLIP(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH2_VFLIP) | BF_IPU_PR_CTRL_CH2_VFLIP(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH0_BLOCK_MODE[22] (RW)
 *
 * Values:
 * - 0 - Scan mode
 * - 1 - Block mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH0_BLOCK_MODE (22U) /*!< Bit position for IPU_PR_CTRL_CH0_BLOCK_MODE. */
#define BM_IPU_PR_CTRL_CH0_BLOCK_MODE (0x00400000U) /*!< Bit mask for IPU_PR_CTRL_CH0_BLOCK_MODE. */
#define BS_IPU_PR_CTRL_CH0_BLOCK_MODE (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH0_BLOCK_MODE. */

/*! @brief Read current value of the IPU_PR_CTRL_CH0_BLOCK_MODE field. */
#define BR_IPU_PR_CTRL_CH0_BLOCK_MODE(x) (HW_IPU_PR_CTRL(x).B.CH0_BLOCK_MODE)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH0_BLOCK_MODE. */
#define BF_IPU_PR_CTRL_CH0_BLOCK_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH0_BLOCK_MODE) & BM_IPU_PR_CTRL_CH0_BLOCK_MODE)

/*! @brief Set the CH0_BLOCK_MODE field to a new value. */
#define BW_IPU_PR_CTRL_CH0_BLOCK_MODE(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH0_BLOCK_MODE) | BF_IPU_PR_CTRL_CH0_BLOCK_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH1_BLOCK_MODE[23] (RW)
 *
 * Values:
 * - 0 - Scan mode
 * - 1 - Block mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH1_BLOCK_MODE (23U) /*!< Bit position for IPU_PR_CTRL_CH1_BLOCK_MODE. */
#define BM_IPU_PR_CTRL_CH1_BLOCK_MODE (0x00800000U) /*!< Bit mask for IPU_PR_CTRL_CH1_BLOCK_MODE. */
#define BS_IPU_PR_CTRL_CH1_BLOCK_MODE (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH1_BLOCK_MODE. */

/*! @brief Read current value of the IPU_PR_CTRL_CH1_BLOCK_MODE field. */
#define BR_IPU_PR_CTRL_CH1_BLOCK_MODE(x) (HW_IPU_PR_CTRL(x).B.CH1_BLOCK_MODE)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH1_BLOCK_MODE. */
#define BF_IPU_PR_CTRL_CH1_BLOCK_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH1_BLOCK_MODE) & BM_IPU_PR_CTRL_CH1_BLOCK_MODE)

/*! @brief Set the CH1_BLOCK_MODE field to a new value. */
#define BW_IPU_PR_CTRL_CH1_BLOCK_MODE(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH1_BLOCK_MODE) | BF_IPU_PR_CTRL_CH1_BLOCK_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH2_BLOCK_MODE[24] (RW)
 *
 * Values:
 * - 0 - Scan mode
 * - 1 - Block mode
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH2_BLOCK_MODE (24U) /*!< Bit position for IPU_PR_CTRL_CH2_BLOCK_MODE. */
#define BM_IPU_PR_CTRL_CH2_BLOCK_MODE (0x01000000U) /*!< Bit mask for IPU_PR_CTRL_CH2_BLOCK_MODE. */
#define BS_IPU_PR_CTRL_CH2_BLOCK_MODE (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH2_BLOCK_MODE. */

/*! @brief Read current value of the IPU_PR_CTRL_CH2_BLOCK_MODE field. */
#define BR_IPU_PR_CTRL_CH2_BLOCK_MODE(x) (HW_IPU_PR_CTRL(x).B.CH2_BLOCK_MODE)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH2_BLOCK_MODE. */
#define BF_IPU_PR_CTRL_CH2_BLOCK_MODE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH2_BLOCK_MODE) & BM_IPU_PR_CTRL_CH2_BLOCK_MODE)

/*! @brief Set the CH2_BLOCK_MODE field to a new value. */
#define BW_IPU_PR_CTRL_CH2_BLOCK_MODE(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH2_BLOCK_MODE) | BF_IPU_PR_CTRL_CH2_BLOCK_MODE(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH0_CNT_LOAD_EN[25] (RW)
 *
 * It will be used, only when the REG_UPDATE bit is set.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH0_CNT_LOAD_EN (25U) /*!< Bit position for IPU_PR_CTRL_CH0_CNT_LOAD_EN. */
#define BM_IPU_PR_CTRL_CH0_CNT_LOAD_EN (0x02000000U) /*!< Bit mask for IPU_PR_CTRL_CH0_CNT_LOAD_EN. */
#define BS_IPU_PR_CTRL_CH0_CNT_LOAD_EN (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH0_CNT_LOAD_EN. */

/*! @brief Read current value of the IPU_PR_CTRL_CH0_CNT_LOAD_EN field. */
#define BR_IPU_PR_CTRL_CH0_CNT_LOAD_EN(x) (HW_IPU_PR_CTRL(x).B.CH0_CNT_LOAD_EN)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH0_CNT_LOAD_EN. */
#define BF_IPU_PR_CTRL_CH0_CNT_LOAD_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH0_CNT_LOAD_EN) & BM_IPU_PR_CTRL_CH0_CNT_LOAD_EN)

/*! @brief Set the CH0_CNT_LOAD_EN field to a new value. */
#define BW_IPU_PR_CTRL_CH0_CNT_LOAD_EN(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH0_CNT_LOAD_EN) | BF_IPU_PR_CTRL_CH0_CNT_LOAD_EN(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH1_CNT_LOAD_EN[26] (RW)
 *
 * It will be used, only when the REG_UPDATE bit is set.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH1_CNT_LOAD_EN (26U) /*!< Bit position for IPU_PR_CTRL_CH1_CNT_LOAD_EN. */
#define BM_IPU_PR_CTRL_CH1_CNT_LOAD_EN (0x04000000U) /*!< Bit mask for IPU_PR_CTRL_CH1_CNT_LOAD_EN. */
#define BS_IPU_PR_CTRL_CH1_CNT_LOAD_EN (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH1_CNT_LOAD_EN. */

/*! @brief Read current value of the IPU_PR_CTRL_CH1_CNT_LOAD_EN field. */
#define BR_IPU_PR_CTRL_CH1_CNT_LOAD_EN(x) (HW_IPU_PR_CTRL(x).B.CH1_CNT_LOAD_EN)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH1_CNT_LOAD_EN. */
#define BF_IPU_PR_CTRL_CH1_CNT_LOAD_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH1_CNT_LOAD_EN) & BM_IPU_PR_CTRL_CH1_CNT_LOAD_EN)

/*! @brief Set the CH1_CNT_LOAD_EN field to a new value. */
#define BW_IPU_PR_CTRL_CH1_CNT_LOAD_EN(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH1_CNT_LOAD_EN) | BF_IPU_PR_CTRL_CH1_CNT_LOAD_EN(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field CH2_CNT_LOAD_EN[27] (RW)
 *
 * It will be used, only when the REG_UPDATE bit is set.
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_IPU_PR_CTRL_CH2_CNT_LOAD_EN (27U) /*!< Bit position for IPU_PR_CTRL_CH2_CNT_LOAD_EN. */
#define BM_IPU_PR_CTRL_CH2_CNT_LOAD_EN (0x08000000U) /*!< Bit mask for IPU_PR_CTRL_CH2_CNT_LOAD_EN. */
#define BS_IPU_PR_CTRL_CH2_CNT_LOAD_EN (1U) /*!< Bit field size in bits for IPU_PR_CTRL_CH2_CNT_LOAD_EN. */

/*! @brief Read current value of the IPU_PR_CTRL_CH2_CNT_LOAD_EN field. */
#define BR_IPU_PR_CTRL_CH2_CNT_LOAD_EN(x) (HW_IPU_PR_CTRL(x).B.CH2_CNT_LOAD_EN)

/*! @brief Format value for bitfield IPU_PR_CTRL_CH2_CNT_LOAD_EN. */
#define BF_IPU_PR_CTRL_CH2_CNT_LOAD_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_CH2_CNT_LOAD_EN) & BM_IPU_PR_CTRL_CH2_CNT_LOAD_EN)

/*! @brief Set the CH2_CNT_LOAD_EN field to a new value. */
#define BW_IPU_PR_CTRL_CH2_CNT_LOAD_EN(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_CH2_CNT_LOAD_EN) | BF_IPU_PR_CTRL_CH2_CNT_LOAD_EN(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field SOFTRST[30] (RW)
 *
 * High active. When write 1, all logical will be reset, except the configure
 * registers.
 */
/*@{*/
#define BP_IPU_PR_CTRL_SOFTRST (30U)       /*!< Bit position for IPU_PR_CTRL_SOFTRST. */
#define BM_IPU_PR_CTRL_SOFTRST (0x40000000U) /*!< Bit mask for IPU_PR_CTRL_SOFTRST. */
#define BS_IPU_PR_CTRL_SOFTRST (1U)        /*!< Bit field size in bits for IPU_PR_CTRL_SOFTRST. */

/*! @brief Read current value of the IPU_PR_CTRL_SOFTRST field. */
#define BR_IPU_PR_CTRL_SOFTRST(x) (HW_IPU_PR_CTRL(x).B.SOFTRST)

/*! @brief Format value for bitfield IPU_PR_CTRL_SOFTRST. */
#define BF_IPU_PR_CTRL_SOFTRST(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_SOFTRST) & BM_IPU_PR_CTRL_SOFTRST)

/*! @brief Set the SOFTRST field to a new value. */
#define BW_IPU_PR_CTRL_SOFTRST(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_SOFTRST) | BF_IPU_PR_CTRL_SOFTRST(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CTRL, field SHADOW_EN[31] (RW)
 *
 * When this bit set to 1, all bit register will be updated to shadow register
 * each end of frame .When this bit set to 0, only REG_UPDATE bit is one, all
 * register bits will be updated to shadow register.
 */
/*@{*/
#define BP_IPU_PR_CTRL_SHADOW_EN (31U)     /*!< Bit position for IPU_PR_CTRL_SHADOW_EN. */
#define BM_IPU_PR_CTRL_SHADOW_EN (0x80000000U) /*!< Bit mask for IPU_PR_CTRL_SHADOW_EN. */
#define BS_IPU_PR_CTRL_SHADOW_EN (1U)      /*!< Bit field size in bits for IPU_PR_CTRL_SHADOW_EN. */

/*! @brief Read current value of the IPU_PR_CTRL_SHADOW_EN field. */
#define BR_IPU_PR_CTRL_SHADOW_EN(x) (HW_IPU_PR_CTRL(x).B.SHADOW_EN)

/*! @brief Format value for bitfield IPU_PR_CTRL_SHADOW_EN. */
#define BF_IPU_PR_CTRL_SHADOW_EN(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CTRL_SHADOW_EN) & BM_IPU_PR_CTRL_SHADOW_EN)

/*! @brief Set the SHADOW_EN field to a new value. */
#define BW_IPU_PR_CTRL_SHADOW_EN(x, v) (HW_IPU_PR_CTRL_WR(x, (HW_IPU_PR_CTRL_RD(x) & ~BM_IPU_PR_CTRL_SHADOW_EN) | BF_IPU_PR_CTRL_SHADOW_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_STATUS - IPU PR STATUS Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_STATUS - IPU PR STATUS Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_status
{
    uint32_t U;
    struct _hw_ipu_pr_status_bitfields
    {
        uint32_t CH0_BUFFER0_READY : 1; /*!< [0] Buffer0 Ready Status */
        uint32_t CH0_BUFFER1_READY : 1; /*!< [1] Buffer1 Ready Status */
        uint32_t CH1_BUFFER0_READY : 1; /*!< [2] Buffer0 Ready Status */
        uint32_t CH1_BUFFER1_READY : 1; /*!< [3] Buffer1 Ready Status */
        uint32_t CH2_BUFFER0_READY : 1; /*!< [4] Buffer0 Ready Status */
        uint32_t CH2_BUFFER1_READY : 1; /*!< [5] Buffer1 Ready Status */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_ipu_pr_status_t;

/*!
 * @name Constants and macros for entire IPU_PR_STATUS register
 */
/*@{*/
#define HW_IPU_PR_STATUS_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_IPU_PR_STATUS(x)      (*(__I hw_ipu_pr_status_t *) HW_IPU_PR_STATUS_ADDR(x))
#define HW_IPU_PR_STATUS_RD(x)   (HW_IPU_PR_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual IPU_PR_STATUS bitfields
 */

/*!
 * @name Register IPU_PR_STATUS, field CH0_BUFFER0_READY[0] (RO)
 *
 * Values:
 * - 1 - Buffer0 is filled.
 * - 0 - Buffer0 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH0_BUFFER0_READY (0U) /*!< Bit position for IPU_PR_STATUS_CH0_BUFFER0_READY. */
#define BM_IPU_PR_STATUS_CH0_BUFFER0_READY (0x00000001U) /*!< Bit mask for IPU_PR_STATUS_CH0_BUFFER0_READY. */
#define BS_IPU_PR_STATUS_CH0_BUFFER0_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH0_BUFFER0_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH0_BUFFER0_READY field. */
#define BR_IPU_PR_STATUS_CH0_BUFFER0_READY(x) (HW_IPU_PR_STATUS(x).B.CH0_BUFFER0_READY)
/*@}*/

/*!
 * @name Register IPU_PR_STATUS, field CH0_BUFFER1_READY[1] (RO)
 *
 * Values:
 * - 1 - Buffer1 is filled.
 * - 0 - Buffer1 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH0_BUFFER1_READY (1U) /*!< Bit position for IPU_PR_STATUS_CH0_BUFFER1_READY. */
#define BM_IPU_PR_STATUS_CH0_BUFFER1_READY (0x00000002U) /*!< Bit mask for IPU_PR_STATUS_CH0_BUFFER1_READY. */
#define BS_IPU_PR_STATUS_CH0_BUFFER1_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH0_BUFFER1_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH0_BUFFER1_READY field. */
#define BR_IPU_PR_STATUS_CH0_BUFFER1_READY(x) (HW_IPU_PR_STATUS(x).B.CH0_BUFFER1_READY)
/*@}*/

/*!
 * @name Register IPU_PR_STATUS, field CH1_BUFFER0_READY[2] (RO)
 *
 * Values:
 * - 1 - Buffer0 is filled.
 * - 0 - Buffer0 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH1_BUFFER0_READY (2U) /*!< Bit position for IPU_PR_STATUS_CH1_BUFFER0_READY. */
#define BM_IPU_PR_STATUS_CH1_BUFFER0_READY (0x00000004U) /*!< Bit mask for IPU_PR_STATUS_CH1_BUFFER0_READY. */
#define BS_IPU_PR_STATUS_CH1_BUFFER0_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH1_BUFFER0_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH1_BUFFER0_READY field. */
#define BR_IPU_PR_STATUS_CH1_BUFFER0_READY(x) (HW_IPU_PR_STATUS(x).B.CH1_BUFFER0_READY)
/*@}*/

/*!
 * @name Register IPU_PR_STATUS, field CH1_BUFFER1_READY[3] (RO)
 *
 * Values:
 * - 1 - Buffer1 is filled.
 * - 0 - Buffer1 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH1_BUFFER1_READY (3U) /*!< Bit position for IPU_PR_STATUS_CH1_BUFFER1_READY. */
#define BM_IPU_PR_STATUS_CH1_BUFFER1_READY (0x00000008U) /*!< Bit mask for IPU_PR_STATUS_CH1_BUFFER1_READY. */
#define BS_IPU_PR_STATUS_CH1_BUFFER1_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH1_BUFFER1_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH1_BUFFER1_READY field. */
#define BR_IPU_PR_STATUS_CH1_BUFFER1_READY(x) (HW_IPU_PR_STATUS(x).B.CH1_BUFFER1_READY)
/*@}*/

/*!
 * @name Register IPU_PR_STATUS, field CH2_BUFFER0_READY[4] (RO)
 *
 * Values:
 * - 1 - Buffer0 is filled.
 * - 0 - Buffer0 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH2_BUFFER0_READY (4U) /*!< Bit position for IPU_PR_STATUS_CH2_BUFFER0_READY. */
#define BM_IPU_PR_STATUS_CH2_BUFFER0_READY (0x00000010U) /*!< Bit mask for IPU_PR_STATUS_CH2_BUFFER0_READY. */
#define BS_IPU_PR_STATUS_CH2_BUFFER0_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH2_BUFFER0_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH2_BUFFER0_READY field. */
#define BR_IPU_PR_STATUS_CH2_BUFFER0_READY(x) (HW_IPU_PR_STATUS(x).B.CH2_BUFFER0_READY)
/*@}*/

/*!
 * @name Register IPU_PR_STATUS, field CH2_BUFFER1_READY[5] (RO)
 *
 * Values:
 * - 1 - Buffer1 is filled.
 * - 0 - Buffer1 is not filled.
 */
/*@{*/
#define BP_IPU_PR_STATUS_CH2_BUFFER1_READY (5U) /*!< Bit position for IPU_PR_STATUS_CH2_BUFFER1_READY. */
#define BM_IPU_PR_STATUS_CH2_BUFFER1_READY (0x00000020U) /*!< Bit mask for IPU_PR_STATUS_CH2_BUFFER1_READY. */
#define BS_IPU_PR_STATUS_CH2_BUFFER1_READY (1U) /*!< Bit field size in bits for IPU_PR_STATUS_CH2_BUFFER1_READY. */

/*! @brief Read current value of the IPU_PR_STATUS_CH2_BUFFER1_READY field. */
#define BR_IPU_PR_STATUS_CH2_BUFFER1_READY(x) (HW_IPU_PR_STATUS(x).B.CH2_BUFFER1_READY)
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_QOS - IPU PR QOS Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_QOS - IPU PR QOS Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_qos
{
    uint32_t U;
    struct _hw_ipu_pr_qos_bitfields
    {
        uint32_t ARID0_QOS : 4;        /*!< [3:0]  */
        uint32_t ARID1_QOS : 4;        /*!< [7:4]  */
        uint32_t ARID2_QOS : 4;        /*!< [11:8]  */
        uint32_t ARID3_QOS : 4;        /*!< [15:12]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_ipu_pr_qos_t;

/*!
 * @name Constants and macros for entire IPU_PR_QOS register
 */
/*@{*/
#define HW_IPU_PR_QOS_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_IPU_PR_QOS(x)         (*(__IO hw_ipu_pr_qos_t *) HW_IPU_PR_QOS_ADDR(x))
#define HW_IPU_PR_QOS_RD(x)      (HW_IPU_PR_QOS(x).U)
#define HW_IPU_PR_QOS_WR(x, v)   (HW_IPU_PR_QOS(x).U = (v))
#define HW_IPU_PR_QOS_SET(x, v)  (HW_IPU_PR_QOS_WR(x, HW_IPU_PR_QOS_RD(x) |  (v)))
#define HW_IPU_PR_QOS_CLR(x, v)  (HW_IPU_PR_QOS_WR(x, HW_IPU_PR_QOS_RD(x) & ~(v)))
#define HW_IPU_PR_QOS_TOG(x, v)  (HW_IPU_PR_QOS_WR(x, HW_IPU_PR_QOS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_QOS bitfields
 */

/*!
 * @name Register IPU_PR_QOS, field ARID0_QOS[3:0] (RW)
 *
 * Read AXI ID = 00 Quality of Service (QoS) priority
 */
/*@{*/
#define BP_IPU_PR_QOS_ARID0_QOS (0U)       /*!< Bit position for IPU_PR_QOS_ARID0_QOS. */
#define BM_IPU_PR_QOS_ARID0_QOS (0x0000000FU) /*!< Bit mask for IPU_PR_QOS_ARID0_QOS. */
#define BS_IPU_PR_QOS_ARID0_QOS (4U)       /*!< Bit field size in bits for IPU_PR_QOS_ARID0_QOS. */

/*! @brief Read current value of the IPU_PR_QOS_ARID0_QOS field. */
#define BR_IPU_PR_QOS_ARID0_QOS(x) (HW_IPU_PR_QOS(x).B.ARID0_QOS)

/*! @brief Format value for bitfield IPU_PR_QOS_ARID0_QOS. */
#define BF_IPU_PR_QOS_ARID0_QOS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_QOS_ARID0_QOS) & BM_IPU_PR_QOS_ARID0_QOS)

/*! @brief Set the ARID0_QOS field to a new value. */
#define BW_IPU_PR_QOS_ARID0_QOS(x, v) (HW_IPU_PR_QOS_WR(x, (HW_IPU_PR_QOS_RD(x) & ~BM_IPU_PR_QOS_ARID0_QOS) | BF_IPU_PR_QOS_ARID0_QOS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_QOS, field ARID1_QOS[7:4] (RW)
 *
 * Read AXI ID = 01 Quality of Service (QoS) priority
 */
/*@{*/
#define BP_IPU_PR_QOS_ARID1_QOS (4U)       /*!< Bit position for IPU_PR_QOS_ARID1_QOS. */
#define BM_IPU_PR_QOS_ARID1_QOS (0x000000F0U) /*!< Bit mask for IPU_PR_QOS_ARID1_QOS. */
#define BS_IPU_PR_QOS_ARID1_QOS (4U)       /*!< Bit field size in bits for IPU_PR_QOS_ARID1_QOS. */

/*! @brief Read current value of the IPU_PR_QOS_ARID1_QOS field. */
#define BR_IPU_PR_QOS_ARID1_QOS(x) (HW_IPU_PR_QOS(x).B.ARID1_QOS)

/*! @brief Format value for bitfield IPU_PR_QOS_ARID1_QOS. */
#define BF_IPU_PR_QOS_ARID1_QOS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_QOS_ARID1_QOS) & BM_IPU_PR_QOS_ARID1_QOS)

/*! @brief Set the ARID1_QOS field to a new value. */
#define BW_IPU_PR_QOS_ARID1_QOS(x, v) (HW_IPU_PR_QOS_WR(x, (HW_IPU_PR_QOS_RD(x) & ~BM_IPU_PR_QOS_ARID1_QOS) | BF_IPU_PR_QOS_ARID1_QOS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_QOS, field ARID2_QOS[11:8] (RW)
 *
 * Read AXI ID = 02 Quality of Service (QoS) priority
 */
/*@{*/
#define BP_IPU_PR_QOS_ARID2_QOS (8U)       /*!< Bit position for IPU_PR_QOS_ARID2_QOS. */
#define BM_IPU_PR_QOS_ARID2_QOS (0x00000F00U) /*!< Bit mask for IPU_PR_QOS_ARID2_QOS. */
#define BS_IPU_PR_QOS_ARID2_QOS (4U)       /*!< Bit field size in bits for IPU_PR_QOS_ARID2_QOS. */

/*! @brief Read current value of the IPU_PR_QOS_ARID2_QOS field. */
#define BR_IPU_PR_QOS_ARID2_QOS(x) (HW_IPU_PR_QOS(x).B.ARID2_QOS)

/*! @brief Format value for bitfield IPU_PR_QOS_ARID2_QOS. */
#define BF_IPU_PR_QOS_ARID2_QOS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_QOS_ARID2_QOS) & BM_IPU_PR_QOS_ARID2_QOS)

/*! @brief Set the ARID2_QOS field to a new value. */
#define BW_IPU_PR_QOS_ARID2_QOS(x, v) (HW_IPU_PR_QOS_WR(x, (HW_IPU_PR_QOS_RD(x) & ~BM_IPU_PR_QOS_ARID2_QOS) | BF_IPU_PR_QOS_ARID2_QOS(v)))
/*@}*/

/*!
 * @name Register IPU_PR_QOS, field ARID3_QOS[15:12] (RW)
 *
 * Read AXI ID = 03 Quality of Service (QoS) priority
 */
/*@{*/
#define BP_IPU_PR_QOS_ARID3_QOS (12U)      /*!< Bit position for IPU_PR_QOS_ARID3_QOS. */
#define BM_IPU_PR_QOS_ARID3_QOS (0x0000F000U) /*!< Bit mask for IPU_PR_QOS_ARID3_QOS. */
#define BS_IPU_PR_QOS_ARID3_QOS (4U)       /*!< Bit field size in bits for IPU_PR_QOS_ARID3_QOS. */

/*! @brief Read current value of the IPU_PR_QOS_ARID3_QOS field. */
#define BR_IPU_PR_QOS_ARID3_QOS(x) (HW_IPU_PR_QOS(x).B.ARID3_QOS)

/*! @brief Format value for bitfield IPU_PR_QOS_ARID3_QOS. */
#define BF_IPU_PR_QOS_ARID3_QOS(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_QOS_ARID3_QOS) & BM_IPU_PR_QOS_ARID3_QOS)

/*! @brief Set the ARID3_QOS field to a new value. */
#define BW_IPU_PR_QOS_ARID3_QOS(x, v) (HW_IPU_PR_QOS_WR(x, (HW_IPU_PR_QOS_RD(x) & ~BM_IPU_PR_QOS_ARID3_QOS) | BF_IPU_PR_QOS_ARID3_QOS(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_REG_UPDATE - IPU PR Control Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_REG_UPDATE - IPU PR Control Register (WO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_reg_update
{
    uint32_t U;
    struct _hw_ipu_pr_reg_update_bitfields
    {
        uint32_t REG_UPDATE : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_ipu_pr_reg_update_t;

/*!
 * @name Constants and macros for entire IPU_PR_REG_UPDATE register
 */
/*@{*/
#define HW_IPU_PR_REG_UPDATE_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_IPU_PR_REG_UPDATE(x)  (*(__O hw_ipu_pr_reg_update_t *) HW_IPU_PR_REG_UPDATE_ADDR(x))
#define HW_IPU_PR_REG_UPDATE_WR(x, v) (HW_IPU_PR_REG_UPDATE(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_REG_UPDATE bitfields
 */

/*!
 * @name Register IPU_PR_REG_UPDATE, field REG_UPDATE[0] (WO)
 *
 * Write this bit is set, all register bits will be updated to shadow register.
 * This bit will be automatically cleared.
 */
/*@{*/
#define BP_IPU_PR_REG_UPDATE_REG_UPDATE (0U) /*!< Bit position for IPU_PR_REG_UPDATE_REG_UPDATE. */
#define BM_IPU_PR_REG_UPDATE_REG_UPDATE (0x00000001U) /*!< Bit mask for IPU_PR_REG_UPDATE_REG_UPDATE. */
#define BS_IPU_PR_REG_UPDATE_REG_UPDATE (1U) /*!< Bit field size in bits for IPU_PR_REG_UPDATE_REG_UPDATE. */

/*! @brief Format value for bitfield IPU_PR_REG_UPDATE_REG_UPDATE. */
#define BF_IPU_PR_REG_UPDATE_REG_UPDATE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_REG_UPDATE_REG_UPDATE) & BM_IPU_PR_REG_UPDATE_REG_UPDATE)
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_STRIDE0 - IPU PR Stride Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_STRIDE0 - IPU PR Stride Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_stride0
{
    uint32_t U;
    struct _hw_ipu_pr_stride0_bitfields
    {
        uint32_t STRIDE0 : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_pr_stride0_t;

/*!
 * @name Constants and macros for entire IPU_PR_STRIDE0 register
 */
/*@{*/
#define HW_IPU_PR_STRIDE0_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_IPU_PR_STRIDE0(x)     (*(__IO hw_ipu_pr_stride0_t *) HW_IPU_PR_STRIDE0_ADDR(x))
#define HW_IPU_PR_STRIDE0_RD(x)  (HW_IPU_PR_STRIDE0(x).U)
#define HW_IPU_PR_STRIDE0_WR(x, v) (HW_IPU_PR_STRIDE0(x).U = (v))
#define HW_IPU_PR_STRIDE0_SET(x, v) (HW_IPU_PR_STRIDE0_WR(x, HW_IPU_PR_STRIDE0_RD(x) |  (v)))
#define HW_IPU_PR_STRIDE0_CLR(x, v) (HW_IPU_PR_STRIDE0_WR(x, HW_IPU_PR_STRIDE0_RD(x) & ~(v)))
#define HW_IPU_PR_STRIDE0_TOG(x, v) (HW_IPU_PR_STRIDE0_WR(x, HW_IPU_PR_STRIDE0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_STRIDE0 bitfields
 */

/*!
 * @name Register IPU_PR_STRIDE0, field STRIDE0[13:0] (RW)
 *
 * The Frame buffer parameter. Indicates the stride of the frame buffer. The
 * width of the frame buffer is the stride.
 */
/*@{*/
#define BP_IPU_PR_STRIDE0_STRIDE0 (0U)     /*!< Bit position for IPU_PR_STRIDE0_STRIDE0. */
#define BM_IPU_PR_STRIDE0_STRIDE0 (0x00003FFFU) /*!< Bit mask for IPU_PR_STRIDE0_STRIDE0. */
#define BS_IPU_PR_STRIDE0_STRIDE0 (14U)    /*!< Bit field size in bits for IPU_PR_STRIDE0_STRIDE0. */

/*! @brief Read current value of the IPU_PR_STRIDE0_STRIDE0 field. */
#define BR_IPU_PR_STRIDE0_STRIDE0(x) (HW_IPU_PR_STRIDE0(x).B.STRIDE0)

/*! @brief Format value for bitfield IPU_PR_STRIDE0_STRIDE0. */
#define BF_IPU_PR_STRIDE0_STRIDE0(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_STRIDE0_STRIDE0) & BM_IPU_PR_STRIDE0_STRIDE0)

/*! @brief Set the STRIDE0 field to a new value. */
#define BW_IPU_PR_STRIDE0_STRIDE0(x, v) (HW_IPU_PR_STRIDE0_WR(x, (HW_IPU_PR_STRIDE0_RD(x) & ~BM_IPU_PR_STRIDE0_STRIDE0) | BF_IPU_PR_STRIDE0_STRIDE0(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_STRIDE1 - IPU PR Stride Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_STRIDE1 - IPU PR Stride Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_stride1
{
    uint32_t U;
    struct _hw_ipu_pr_stride1_bitfields
    {
        uint32_t STRIDE1 : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_pr_stride1_t;

/*!
 * @name Constants and macros for entire IPU_PR_STRIDE1 register
 */
/*@{*/
#define HW_IPU_PR_STRIDE1_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_IPU_PR_STRIDE1(x)     (*(__IO hw_ipu_pr_stride1_t *) HW_IPU_PR_STRIDE1_ADDR(x))
#define HW_IPU_PR_STRIDE1_RD(x)  (HW_IPU_PR_STRIDE1(x).U)
#define HW_IPU_PR_STRIDE1_WR(x, v) (HW_IPU_PR_STRIDE1(x).U = (v))
#define HW_IPU_PR_STRIDE1_SET(x, v) (HW_IPU_PR_STRIDE1_WR(x, HW_IPU_PR_STRIDE1_RD(x) |  (v)))
#define HW_IPU_PR_STRIDE1_CLR(x, v) (HW_IPU_PR_STRIDE1_WR(x, HW_IPU_PR_STRIDE1_RD(x) & ~(v)))
#define HW_IPU_PR_STRIDE1_TOG(x, v) (HW_IPU_PR_STRIDE1_WR(x, HW_IPU_PR_STRIDE1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_STRIDE1 bitfields
 */

/*!
 * @name Register IPU_PR_STRIDE1, field STRIDE1[13:0] (RW)
 *
 * The Frame buffer parameter. Indicates the stride of the frame buffer. The
 * width of the frame buffer is the stride.
 */
/*@{*/
#define BP_IPU_PR_STRIDE1_STRIDE1 (0U)     /*!< Bit position for IPU_PR_STRIDE1_STRIDE1. */
#define BM_IPU_PR_STRIDE1_STRIDE1 (0x00003FFFU) /*!< Bit mask for IPU_PR_STRIDE1_STRIDE1. */
#define BS_IPU_PR_STRIDE1_STRIDE1 (14U)    /*!< Bit field size in bits for IPU_PR_STRIDE1_STRIDE1. */

/*! @brief Read current value of the IPU_PR_STRIDE1_STRIDE1 field. */
#define BR_IPU_PR_STRIDE1_STRIDE1(x) (HW_IPU_PR_STRIDE1(x).B.STRIDE1)

/*! @brief Format value for bitfield IPU_PR_STRIDE1_STRIDE1. */
#define BF_IPU_PR_STRIDE1_STRIDE1(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_STRIDE1_STRIDE1) & BM_IPU_PR_STRIDE1_STRIDE1)

/*! @brief Set the STRIDE1 field to a new value. */
#define BW_IPU_PR_STRIDE1_STRIDE1(x, v) (HW_IPU_PR_STRIDE1_WR(x, (HW_IPU_PR_STRIDE1_RD(x) & ~BM_IPU_PR_STRIDE1_STRIDE1) | BF_IPU_PR_STRIDE1_STRIDE1(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_STRIDE2 - IPU PR Stride Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_STRIDE2 - IPU PR Stride Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_stride2
{
    uint32_t U;
    struct _hw_ipu_pr_stride2_bitfields
    {
        uint32_t STRIDE2 : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_ipu_pr_stride2_t;

/*!
 * @name Constants and macros for entire IPU_PR_STRIDE2 register
 */
/*@{*/
#define HW_IPU_PR_STRIDE2_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_IPU_PR_STRIDE2(x)     (*(__IO hw_ipu_pr_stride2_t *) HW_IPU_PR_STRIDE2_ADDR(x))
#define HW_IPU_PR_STRIDE2_RD(x)  (HW_IPU_PR_STRIDE2(x).U)
#define HW_IPU_PR_STRIDE2_WR(x, v) (HW_IPU_PR_STRIDE2(x).U = (v))
#define HW_IPU_PR_STRIDE2_SET(x, v) (HW_IPU_PR_STRIDE2_WR(x, HW_IPU_PR_STRIDE2_RD(x) |  (v)))
#define HW_IPU_PR_STRIDE2_CLR(x, v) (HW_IPU_PR_STRIDE2_WR(x, HW_IPU_PR_STRIDE2_RD(x) & ~(v)))
#define HW_IPU_PR_STRIDE2_TOG(x, v) (HW_IPU_PR_STRIDE2_WR(x, HW_IPU_PR_STRIDE2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_STRIDE2 bitfields
 */

/*!
 * @name Register IPU_PR_STRIDE2, field STRIDE2[13:0] (RW)
 *
 * The Frame buffer parameter. Indicates the stride of the frame buffer. The
 * width of the frame buffer is the stride.
 */
/*@{*/
#define BP_IPU_PR_STRIDE2_STRIDE2 (0U)     /*!< Bit position for IPU_PR_STRIDE2_STRIDE2. */
#define BM_IPU_PR_STRIDE2_STRIDE2 (0x00003FFFU) /*!< Bit mask for IPU_PR_STRIDE2_STRIDE2. */
#define BS_IPU_PR_STRIDE2_STRIDE2 (14U)    /*!< Bit field size in bits for IPU_PR_STRIDE2_STRIDE2. */

/*! @brief Read current value of the IPU_PR_STRIDE2_STRIDE2 field. */
#define BR_IPU_PR_STRIDE2_STRIDE2(x) (HW_IPU_PR_STRIDE2(x).B.STRIDE2)

/*! @brief Format value for bitfield IPU_PR_STRIDE2_STRIDE2. */
#define BF_IPU_PR_STRIDE2_STRIDE2(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_STRIDE2_STRIDE2) & BM_IPU_PR_STRIDE2_STRIDE2)

/*! @brief Set the STRIDE2 field to a new value. */
#define BW_IPU_PR_STRIDE2_STRIDE2(x, v) (HW_IPU_PR_STRIDE2_WR(x, (HW_IPU_PR_STRIDE2_RD(x) & ~BM_IPU_PR_STRIDE2_STRIDE2) | BF_IPU_PR_STRIDE2_STRIDE2(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CORP_LINE - IPU PR Stride Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CORP_LINE - IPU PR Stride Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_corp_line
{
    uint32_t U;
    struct _hw_ipu_pr_corp_line_bitfields
    {
        uint32_t CH0_CROP_LINE : 2;    /*!< [1:0] Vertical Crop Line */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t CH1_CROP_LINE : 2;    /*!< [5:4] Vertical Crop Line */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t CH2_CROP_LINE : 2;    /*!< [9:8] Vertical Crop Line */
        uint32_t RESERVED2 : 22;       /*!< [31:10]  */
    } B;
} hw_ipu_pr_corp_line_t;

/*!
 * @name Constants and macros for entire IPU_PR_CORP_LINE register
 */
/*@{*/
#define HW_IPU_PR_CORP_LINE_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_IPU_PR_CORP_LINE(x)   (*(__IO hw_ipu_pr_corp_line_t *) HW_IPU_PR_CORP_LINE_ADDR(x))
#define HW_IPU_PR_CORP_LINE_RD(x) (HW_IPU_PR_CORP_LINE(x).U)
#define HW_IPU_PR_CORP_LINE_WR(x, v) (HW_IPU_PR_CORP_LINE(x).U = (v))
#define HW_IPU_PR_CORP_LINE_SET(x, v) (HW_IPU_PR_CORP_LINE_WR(x, HW_IPU_PR_CORP_LINE_RD(x) |  (v)))
#define HW_IPU_PR_CORP_LINE_CLR(x, v) (HW_IPU_PR_CORP_LINE_WR(x, HW_IPU_PR_CORP_LINE_RD(x) & ~(v)))
#define HW_IPU_PR_CORP_LINE_TOG(x, v) (HW_IPU_PR_CORP_LINE_WR(x, HW_IPU_PR_CORP_LINE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CORP_LINE bitfields
 */

/*!
 * @name Register IPU_PR_CORP_LINE, field CH0_CROP_LINE[1:0] (RW)
 *
 * The max 4 lines. It indicates cropping line per field, when CH1_SO is set to
 * 1 (Interlace enable).
 *
 * Values:
 * - 0 - No crop in vertical
 * - 1 - 1 line crop
 * - 10 - 2 line crop
 * - 11 - 3 line crop
 */
/*@{*/
#define BP_IPU_PR_CORP_LINE_CH0_CROP_LINE (0U) /*!< Bit position for IPU_PR_CORP_LINE_CH0_CROP_LINE. */
#define BM_IPU_PR_CORP_LINE_CH0_CROP_LINE (0x00000003U) /*!< Bit mask for IPU_PR_CORP_LINE_CH0_CROP_LINE. */
#define BS_IPU_PR_CORP_LINE_CH0_CROP_LINE (2U) /*!< Bit field size in bits for IPU_PR_CORP_LINE_CH0_CROP_LINE. */

/*! @brief Read current value of the IPU_PR_CORP_LINE_CH0_CROP_LINE field. */
#define BR_IPU_PR_CORP_LINE_CH0_CROP_LINE(x) (HW_IPU_PR_CORP_LINE(x).B.CH0_CROP_LINE)

/*! @brief Format value for bitfield IPU_PR_CORP_LINE_CH0_CROP_LINE. */
#define BF_IPU_PR_CORP_LINE_CH0_CROP_LINE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CORP_LINE_CH0_CROP_LINE) & BM_IPU_PR_CORP_LINE_CH0_CROP_LINE)

/*! @brief Set the CH0_CROP_LINE field to a new value. */
#define BW_IPU_PR_CORP_LINE_CH0_CROP_LINE(x, v) (HW_IPU_PR_CORP_LINE_WR(x, (HW_IPU_PR_CORP_LINE_RD(x) & ~BM_IPU_PR_CORP_LINE_CH0_CROP_LINE) | BF_IPU_PR_CORP_LINE_CH0_CROP_LINE(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CORP_LINE, field CH1_CROP_LINE[5:4] (RW)
 *
 * The max 4 lines. It indicates cropping line per field, when CH1_SO is set to
 * 1 (Interlace enable).
 *
 * Values:
 * - 0 - No crop in vertical
 * - 1 - 1 line crop
 * - 10 - 2 line crop
 * - 11 - 3 line crop
 */
/*@{*/
#define BP_IPU_PR_CORP_LINE_CH1_CROP_LINE (4U) /*!< Bit position for IPU_PR_CORP_LINE_CH1_CROP_LINE. */
#define BM_IPU_PR_CORP_LINE_CH1_CROP_LINE (0x00000030U) /*!< Bit mask for IPU_PR_CORP_LINE_CH1_CROP_LINE. */
#define BS_IPU_PR_CORP_LINE_CH1_CROP_LINE (2U) /*!< Bit field size in bits for IPU_PR_CORP_LINE_CH1_CROP_LINE. */

/*! @brief Read current value of the IPU_PR_CORP_LINE_CH1_CROP_LINE field. */
#define BR_IPU_PR_CORP_LINE_CH1_CROP_LINE(x) (HW_IPU_PR_CORP_LINE(x).B.CH1_CROP_LINE)

/*! @brief Format value for bitfield IPU_PR_CORP_LINE_CH1_CROP_LINE. */
#define BF_IPU_PR_CORP_LINE_CH1_CROP_LINE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CORP_LINE_CH1_CROP_LINE) & BM_IPU_PR_CORP_LINE_CH1_CROP_LINE)

/*! @brief Set the CH1_CROP_LINE field to a new value. */
#define BW_IPU_PR_CORP_LINE_CH1_CROP_LINE(x, v) (HW_IPU_PR_CORP_LINE_WR(x, (HW_IPU_PR_CORP_LINE_RD(x) & ~BM_IPU_PR_CORP_LINE_CH1_CROP_LINE) | BF_IPU_PR_CORP_LINE_CH1_CROP_LINE(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CORP_LINE, field CH2_CROP_LINE[9:8] (RW)
 *
 * The max 4 lines. It indicates cropping line per field, when CH1_SO is set to
 * 1 (Interlace enable).
 *
 * Values:
 * - 0 - No crop in vertical
 * - 1 - 1 line crop
 * - 10 - 2 line crop
 * - 11 - 3 line crop
 */
/*@{*/
#define BP_IPU_PR_CORP_LINE_CH2_CROP_LINE (8U) /*!< Bit position for IPU_PR_CORP_LINE_CH2_CROP_LINE. */
#define BM_IPU_PR_CORP_LINE_CH2_CROP_LINE (0x00000300U) /*!< Bit mask for IPU_PR_CORP_LINE_CH2_CROP_LINE. */
#define BS_IPU_PR_CORP_LINE_CH2_CROP_LINE (2U) /*!< Bit field size in bits for IPU_PR_CORP_LINE_CH2_CROP_LINE. */

/*! @brief Read current value of the IPU_PR_CORP_LINE_CH2_CROP_LINE field. */
#define BR_IPU_PR_CORP_LINE_CH2_CROP_LINE(x) (HW_IPU_PR_CORP_LINE(x).B.CH2_CROP_LINE)

/*! @brief Format value for bitfield IPU_PR_CORP_LINE_CH2_CROP_LINE. */
#define BF_IPU_PR_CORP_LINE_CH2_CROP_LINE(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CORP_LINE_CH2_CROP_LINE) & BM_IPU_PR_CORP_LINE_CH2_CROP_LINE)

/*! @brief Set the CH2_CROP_LINE field to a new value. */
#define BW_IPU_PR_CORP_LINE_CH2_CROP_LINE(x, v) (HW_IPU_PR_CORP_LINE_WR(x, (HW_IPU_PR_CORP_LINE_RD(x) & ~BM_IPU_PR_CORP_LINE_CH2_CROP_LINE) | BF_IPU_PR_CORP_LINE_CH2_CROP_LINE(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_ADDR_THD - IPU PR Address Thresh Hold Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_ADDR_THD - IPU PR Address Thresh Hold Register (RW)
 *
 * Reset value: 0x10000000U
 */
typedef union _hw_ipu_pr_addr_thd
{
    uint32_t U;
    struct _hw_ipu_pr_addr_thd_bitfields
    {
        uint32_t MEM_ADDR_THD : 32;    /*!< [31:0]  */
    } B;
} hw_ipu_pr_addr_thd_t;

/*!
 * @name Constants and macros for entire IPU_PR_ADDR_THD register
 */
/*@{*/
#define HW_IPU_PR_ADDR_THD_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_IPU_PR_ADDR_THD(x)    (*(__IO hw_ipu_pr_addr_thd_t *) HW_IPU_PR_ADDR_THD_ADDR(x))
#define HW_IPU_PR_ADDR_THD_RD(x) (HW_IPU_PR_ADDR_THD(x).U)
#define HW_IPU_PR_ADDR_THD_WR(x, v) (HW_IPU_PR_ADDR_THD(x).U = (v))
#define HW_IPU_PR_ADDR_THD_SET(x, v) (HW_IPU_PR_ADDR_THD_WR(x, HW_IPU_PR_ADDR_THD_RD(x) |  (v)))
#define HW_IPU_PR_ADDR_THD_CLR(x, v) (HW_IPU_PR_ADDR_THD_WR(x, HW_IPU_PR_ADDR_THD_RD(x) & ~(v)))
#define HW_IPU_PR_ADDR_THD_TOG(x, v) (HW_IPU_PR_ADDR_THD_WR(x, HW_IPU_PR_ADDR_THD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_ADDR_THD bitfields
 */

/*!
 * @name Register IPU_PR_ADDR_THD, field MEM_ADDR_THD[31:0] (RW)
 *
 * Read address thresh hold, when the read address more than MEM_ADDR_THD, the
 * corroding channel will be force bypass.
 */
/*@{*/
#define BP_IPU_PR_ADDR_THD_MEM_ADDR_THD (0U) /*!< Bit position for IPU_PR_ADDR_THD_MEM_ADDR_THD. */
#define BM_IPU_PR_ADDR_THD_MEM_ADDR_THD (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_ADDR_THD_MEM_ADDR_THD. */
#define BS_IPU_PR_ADDR_THD_MEM_ADDR_THD (32U) /*!< Bit field size in bits for IPU_PR_ADDR_THD_MEM_ADDR_THD. */

/*! @brief Read current value of the IPU_PR_ADDR_THD_MEM_ADDR_THD field. */
#define BR_IPU_PR_ADDR_THD_MEM_ADDR_THD(x) (HW_IPU_PR_ADDR_THD(x).U)

/*! @brief Format value for bitfield IPU_PR_ADDR_THD_MEM_ADDR_THD. */
#define BF_IPU_PR_ADDR_THD_MEM_ADDR_THD(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_ADDR_THD_MEM_ADDR_THD) & BM_IPU_PR_ADDR_THD_MEM_ADDR_THD)

/*! @brief Set the MEM_ADDR_THD field to a new value. */
#define BW_IPU_PR_ADDR_THD_MEM_ADDR_THD(x, v) (HW_IPU_PR_ADDR_THD_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH0_BADDR - IPU PR Start Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH0_BADDR - IPU PR Start Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch0_baddr
{
    uint32_t U;
    struct _hw_ipu_pr_ch0_baddr_bitfields
    {
        uint32_t CH0_BADDR : 32;       /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch0_baddr_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH0_BADDR register
 */
/*@{*/
#define HW_IPU_PR_CH0_BADDR_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_IPU_PR_CH0_BADDR(x)   (*(__IO hw_ipu_pr_ch0_baddr_t *) HW_IPU_PR_CH0_BADDR_ADDR(x))
#define HW_IPU_PR_CH0_BADDR_RD(x) (HW_IPU_PR_CH0_BADDR(x).U)
#define HW_IPU_PR_CH0_BADDR_WR(x, v) (HW_IPU_PR_CH0_BADDR(x).U = (v))
#define HW_IPU_PR_CH0_BADDR_SET(x, v) (HW_IPU_PR_CH0_BADDR_WR(x, HW_IPU_PR_CH0_BADDR_RD(x) |  (v)))
#define HW_IPU_PR_CH0_BADDR_CLR(x, v) (HW_IPU_PR_CH0_BADDR_WR(x, HW_IPU_PR_CH0_BADDR_RD(x) & ~(v)))
#define HW_IPU_PR_CH0_BADDR_TOG(x, v) (HW_IPU_PR_CH0_BADDR_WR(x, HW_IPU_PR_CH0_BADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH0_BADDR bitfields
 */

/*!
 * @name Register IPU_PR_CH0_BADDR, field CH0_BADDR[31:0] (RW)
 *
 * Frame buffer start address
 */
/*@{*/
#define BP_IPU_PR_CH0_BADDR_CH0_BADDR (0U) /*!< Bit position for IPU_PR_CH0_BADDR_CH0_BADDR. */
#define BM_IPU_PR_CH0_BADDR_CH0_BADDR (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH0_BADDR_CH0_BADDR. */
#define BS_IPU_PR_CH0_BADDR_CH0_BADDR (32U) /*!< Bit field size in bits for IPU_PR_CH0_BADDR_CH0_BADDR. */

/*! @brief Read current value of the IPU_PR_CH0_BADDR_CH0_BADDR field. */
#define BR_IPU_PR_CH0_BADDR_CH0_BADDR(x) (HW_IPU_PR_CH0_BADDR(x).U)

/*! @brief Format value for bitfield IPU_PR_CH0_BADDR_CH0_BADDR. */
#define BF_IPU_PR_CH0_BADDR_CH0_BADDR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH0_BADDR_CH0_BADDR) & BM_IPU_PR_CH0_BADDR_CH0_BADDR)

/*! @brief Set the CH0_BADDR field to a new value. */
#define BW_IPU_PR_CH0_BADDR_CH0_BADDR(x, v) (HW_IPU_PR_CH0_BADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH1_BADDR - IPU PR Start Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH1_BADDR - IPU PR Start Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch1_baddr
{
    uint32_t U;
    struct _hw_ipu_pr_ch1_baddr_bitfields
    {
        uint32_t CH1_BADDR : 32;       /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch1_baddr_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH1_BADDR register
 */
/*@{*/
#define HW_IPU_PR_CH1_BADDR_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_IPU_PR_CH1_BADDR(x)   (*(__IO hw_ipu_pr_ch1_baddr_t *) HW_IPU_PR_CH1_BADDR_ADDR(x))
#define HW_IPU_PR_CH1_BADDR_RD(x) (HW_IPU_PR_CH1_BADDR(x).U)
#define HW_IPU_PR_CH1_BADDR_WR(x, v) (HW_IPU_PR_CH1_BADDR(x).U = (v))
#define HW_IPU_PR_CH1_BADDR_SET(x, v) (HW_IPU_PR_CH1_BADDR_WR(x, HW_IPU_PR_CH1_BADDR_RD(x) |  (v)))
#define HW_IPU_PR_CH1_BADDR_CLR(x, v) (HW_IPU_PR_CH1_BADDR_WR(x, HW_IPU_PR_CH1_BADDR_RD(x) & ~(v)))
#define HW_IPU_PR_CH1_BADDR_TOG(x, v) (HW_IPU_PR_CH1_BADDR_WR(x, HW_IPU_PR_CH1_BADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH1_BADDR bitfields
 */

/*!
 * @name Register IPU_PR_CH1_BADDR, field CH1_BADDR[31:0] (RW)
 *
 * Frame buffer start address
 */
/*@{*/
#define BP_IPU_PR_CH1_BADDR_CH1_BADDR (0U) /*!< Bit position for IPU_PR_CH1_BADDR_CH1_BADDR. */
#define BM_IPU_PR_CH1_BADDR_CH1_BADDR (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH1_BADDR_CH1_BADDR. */
#define BS_IPU_PR_CH1_BADDR_CH1_BADDR (32U) /*!< Bit field size in bits for IPU_PR_CH1_BADDR_CH1_BADDR. */

/*! @brief Read current value of the IPU_PR_CH1_BADDR_CH1_BADDR field. */
#define BR_IPU_PR_CH1_BADDR_CH1_BADDR(x) (HW_IPU_PR_CH1_BADDR(x).U)

/*! @brief Format value for bitfield IPU_PR_CH1_BADDR_CH1_BADDR. */
#define BF_IPU_PR_CH1_BADDR_CH1_BADDR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH1_BADDR_CH1_BADDR) & BM_IPU_PR_CH1_BADDR_CH1_BADDR)

/*! @brief Set the CH1_BADDR field to a new value. */
#define BW_IPU_PR_CH1_BADDR_CH1_BADDR(x, v) (HW_IPU_PR_CH1_BADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH2_BADDR - IPU PR Start Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH2_BADDR - IPU PR Start Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch2_baddr
{
    uint32_t U;
    struct _hw_ipu_pr_ch2_baddr_bitfields
    {
        uint32_t CH2_BADDR : 32;       /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch2_baddr_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH2_BADDR register
 */
/*@{*/
#define HW_IPU_PR_CH2_BADDR_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_IPU_PR_CH2_BADDR(x)   (*(__IO hw_ipu_pr_ch2_baddr_t *) HW_IPU_PR_CH2_BADDR_ADDR(x))
#define HW_IPU_PR_CH2_BADDR_RD(x) (HW_IPU_PR_CH2_BADDR(x).U)
#define HW_IPU_PR_CH2_BADDR_WR(x, v) (HW_IPU_PR_CH2_BADDR(x).U = (v))
#define HW_IPU_PR_CH2_BADDR_SET(x, v) (HW_IPU_PR_CH2_BADDR_WR(x, HW_IPU_PR_CH2_BADDR_RD(x) |  (v)))
#define HW_IPU_PR_CH2_BADDR_CLR(x, v) (HW_IPU_PR_CH2_BADDR_WR(x, HW_IPU_PR_CH2_BADDR_RD(x) & ~(v)))
#define HW_IPU_PR_CH2_BADDR_TOG(x, v) (HW_IPU_PR_CH2_BADDR_WR(x, HW_IPU_PR_CH2_BADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH2_BADDR bitfields
 */

/*!
 * @name Register IPU_PR_CH2_BADDR, field CH2_BADDR[31:0] (RW)
 *
 * Frame buffer start address
 */
/*@{*/
#define BP_IPU_PR_CH2_BADDR_CH2_BADDR (0U) /*!< Bit position for IPU_PR_CH2_BADDR_CH2_BADDR. */
#define BM_IPU_PR_CH2_BADDR_CH2_BADDR (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH2_BADDR_CH2_BADDR. */
#define BS_IPU_PR_CH2_BADDR_CH2_BADDR (32U) /*!< Bit field size in bits for IPU_PR_CH2_BADDR_CH2_BADDR. */

/*! @brief Read current value of the IPU_PR_CH2_BADDR_CH2_BADDR field. */
#define BR_IPU_PR_CH2_BADDR_CH2_BADDR(x) (HW_IPU_PR_CH2_BADDR(x).U)

/*! @brief Format value for bitfield IPU_PR_CH2_BADDR_CH2_BADDR. */
#define BF_IPU_PR_CH2_BADDR_CH2_BADDR(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH2_BADDR_CH2_BADDR) & BM_IPU_PR_CH2_BADDR_CH2_BADDR)

/*! @brief Set the CH2_BADDR field to a new value. */
#define BW_IPU_PR_CH2_BADDR_CH2_BADDR(x, v) (HW_IPU_PR_CH2_BADDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH0_OFFSET - IPU PR Start Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH0_OFFSET - IPU PR Start Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch0_offset
{
    uint32_t U;
    struct _hw_ipu_pr_ch0_offset_bitfields
    {
        uint32_t CH0_OFFSET : 32;      /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch0_offset_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH0_OFFSET register
 */
/*@{*/
#define HW_IPU_PR_CH0_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_IPU_PR_CH0_OFFSET(x)  (*(__IO hw_ipu_pr_ch0_offset_t *) HW_IPU_PR_CH0_OFFSET_ADDR(x))
#define HW_IPU_PR_CH0_OFFSET_RD(x) (HW_IPU_PR_CH0_OFFSET(x).U)
#define HW_IPU_PR_CH0_OFFSET_WR(x, v) (HW_IPU_PR_CH0_OFFSET(x).U = (v))
#define HW_IPU_PR_CH0_OFFSET_SET(x, v) (HW_IPU_PR_CH0_OFFSET_WR(x, HW_IPU_PR_CH0_OFFSET_RD(x) |  (v)))
#define HW_IPU_PR_CH0_OFFSET_CLR(x, v) (HW_IPU_PR_CH0_OFFSET_WR(x, HW_IPU_PR_CH0_OFFSET_RD(x) & ~(v)))
#define HW_IPU_PR_CH0_OFFSET_TOG(x, v) (HW_IPU_PR_CH0_OFFSET_WR(x, HW_IPU_PR_CH0_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH0_OFFSET bitfields
 */

/*!
 * @name Register IPU_PR_CH0_OFFSET, field CH0_OFFSET[31:0] (RW)
 *
 * The offset address is based on the frame buffer start address. It will be set
 * when PRG need to crop. The value should be: CH0_CROP_LINE multiply STRIDE0,
 * and then add the horizontal coordinate multiply BPP.
 */
/*@{*/
#define BP_IPU_PR_CH0_OFFSET_CH0_OFFSET (0U) /*!< Bit position for IPU_PR_CH0_OFFSET_CH0_OFFSET. */
#define BM_IPU_PR_CH0_OFFSET_CH0_OFFSET (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH0_OFFSET_CH0_OFFSET. */
#define BS_IPU_PR_CH0_OFFSET_CH0_OFFSET (32U) /*!< Bit field size in bits for IPU_PR_CH0_OFFSET_CH0_OFFSET. */

/*! @brief Read current value of the IPU_PR_CH0_OFFSET_CH0_OFFSET field. */
#define BR_IPU_PR_CH0_OFFSET_CH0_OFFSET(x) (HW_IPU_PR_CH0_OFFSET(x).U)

/*! @brief Format value for bitfield IPU_PR_CH0_OFFSET_CH0_OFFSET. */
#define BF_IPU_PR_CH0_OFFSET_CH0_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH0_OFFSET_CH0_OFFSET) & BM_IPU_PR_CH0_OFFSET_CH0_OFFSET)

/*! @brief Set the CH0_OFFSET field to a new value. */
#define BW_IPU_PR_CH0_OFFSET_CH0_OFFSET(x, v) (HW_IPU_PR_CH0_OFFSET_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH1_OFFSET - IPU PR Start Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH1_OFFSET - IPU PR Start Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch1_offset
{
    uint32_t U;
    struct _hw_ipu_pr_ch1_offset_bitfields
    {
        uint32_t CH1_OFFSET : 32;      /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch1_offset_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH1_OFFSET register
 */
/*@{*/
#define HW_IPU_PR_CH1_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_IPU_PR_CH1_OFFSET(x)  (*(__IO hw_ipu_pr_ch1_offset_t *) HW_IPU_PR_CH1_OFFSET_ADDR(x))
#define HW_IPU_PR_CH1_OFFSET_RD(x) (HW_IPU_PR_CH1_OFFSET(x).U)
#define HW_IPU_PR_CH1_OFFSET_WR(x, v) (HW_IPU_PR_CH1_OFFSET(x).U = (v))
#define HW_IPU_PR_CH1_OFFSET_SET(x, v) (HW_IPU_PR_CH1_OFFSET_WR(x, HW_IPU_PR_CH1_OFFSET_RD(x) |  (v)))
#define HW_IPU_PR_CH1_OFFSET_CLR(x, v) (HW_IPU_PR_CH1_OFFSET_WR(x, HW_IPU_PR_CH1_OFFSET_RD(x) & ~(v)))
#define HW_IPU_PR_CH1_OFFSET_TOG(x, v) (HW_IPU_PR_CH1_OFFSET_WR(x, HW_IPU_PR_CH1_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH1_OFFSET bitfields
 */

/*!
 * @name Register IPU_PR_CH1_OFFSET, field CH1_OFFSET[31:0] (RW)
 *
 * The offset address is based on the frame buffer start address. It will be set
 * when PRG need to crop. The value should be: CH1_CROP_LINE multiply STRIDE1,
 * and then add the horizontal coordinate multiply BPP.
 */
/*@{*/
#define BP_IPU_PR_CH1_OFFSET_CH1_OFFSET (0U) /*!< Bit position for IPU_PR_CH1_OFFSET_CH1_OFFSET. */
#define BM_IPU_PR_CH1_OFFSET_CH1_OFFSET (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH1_OFFSET_CH1_OFFSET. */
#define BS_IPU_PR_CH1_OFFSET_CH1_OFFSET (32U) /*!< Bit field size in bits for IPU_PR_CH1_OFFSET_CH1_OFFSET. */

/*! @brief Read current value of the IPU_PR_CH1_OFFSET_CH1_OFFSET field. */
#define BR_IPU_PR_CH1_OFFSET_CH1_OFFSET(x) (HW_IPU_PR_CH1_OFFSET(x).U)

/*! @brief Format value for bitfield IPU_PR_CH1_OFFSET_CH1_OFFSET. */
#define BF_IPU_PR_CH1_OFFSET_CH1_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH1_OFFSET_CH1_OFFSET) & BM_IPU_PR_CH1_OFFSET_CH1_OFFSET)

/*! @brief Set the CH1_OFFSET field to a new value. */
#define BW_IPU_PR_CH1_OFFSET_CH1_OFFSET(x, v) (HW_IPU_PR_CH1_OFFSET_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH2_OFFSET - IPU PR Start Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH2_OFFSET - IPU PR Start Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch2_offset
{
    uint32_t U;
    struct _hw_ipu_pr_ch2_offset_bitfields
    {
        uint32_t CH2_OFFSET : 32;      /*!< [31:0]  */
    } B;
} hw_ipu_pr_ch2_offset_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH2_OFFSET register
 */
/*@{*/
#define HW_IPU_PR_CH2_OFFSET_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_IPU_PR_CH2_OFFSET(x)  (*(__IO hw_ipu_pr_ch2_offset_t *) HW_IPU_PR_CH2_OFFSET_ADDR(x))
#define HW_IPU_PR_CH2_OFFSET_RD(x) (HW_IPU_PR_CH2_OFFSET(x).U)
#define HW_IPU_PR_CH2_OFFSET_WR(x, v) (HW_IPU_PR_CH2_OFFSET(x).U = (v))
#define HW_IPU_PR_CH2_OFFSET_SET(x, v) (HW_IPU_PR_CH2_OFFSET_WR(x, HW_IPU_PR_CH2_OFFSET_RD(x) |  (v)))
#define HW_IPU_PR_CH2_OFFSET_CLR(x, v) (HW_IPU_PR_CH2_OFFSET_WR(x, HW_IPU_PR_CH2_OFFSET_RD(x) & ~(v)))
#define HW_IPU_PR_CH2_OFFSET_TOG(x, v) (HW_IPU_PR_CH2_OFFSET_WR(x, HW_IPU_PR_CH2_OFFSET_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH2_OFFSET bitfields
 */

/*!
 * @name Register IPU_PR_CH2_OFFSET, field CH2_OFFSET[31:0] (RW)
 *
 * The offset address is based on the frame buffer start address. It will be set
 * when PRG need to crop. The value should be: CH2_CROP_LINE multiply STRIDE2,
 * and then add the horizontal coordinate multiply BPP.
 */
/*@{*/
#define BP_IPU_PR_CH2_OFFSET_CH2_OFFSET (0U) /*!< Bit position for IPU_PR_CH2_OFFSET_CH2_OFFSET. */
#define BM_IPU_PR_CH2_OFFSET_CH2_OFFSET (0xFFFFFFFFU) /*!< Bit mask for IPU_PR_CH2_OFFSET_CH2_OFFSET. */
#define BS_IPU_PR_CH2_OFFSET_CH2_OFFSET (32U) /*!< Bit field size in bits for IPU_PR_CH2_OFFSET_CH2_OFFSET. */

/*! @brief Read current value of the IPU_PR_CH2_OFFSET_CH2_OFFSET field. */
#define BR_IPU_PR_CH2_OFFSET_CH2_OFFSET(x) (HW_IPU_PR_CH2_OFFSET(x).U)

/*! @brief Format value for bitfield IPU_PR_CH2_OFFSET_CH2_OFFSET. */
#define BF_IPU_PR_CH2_OFFSET_CH2_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH2_OFFSET_CH2_OFFSET) & BM_IPU_PR_CH2_OFFSET_CH2_OFFSET)

/*! @brief Set the CH2_OFFSET field to a new value. */
#define BW_IPU_PR_CH2_OFFSET_CH2_OFFSET(x, v) (HW_IPU_PR_CH2_OFFSET_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH0_ILO - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH0_ILO - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch0_ilo
{
    uint32_t U;
    struct _hw_ipu_pr_ch0_ilo_bitfields
    {
        uint32_t CH0_ILO : 23;         /*!< [22:0] Interlace Offset Address */
        uint32_t RESERVED0 : 9;        /*!< [31:23]  */
    } B;
} hw_ipu_pr_ch0_ilo_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH0_ILO register
 */
/*@{*/
#define HW_IPU_PR_CH0_ILO_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_IPU_PR_CH0_ILO(x)     (*(__IO hw_ipu_pr_ch0_ilo_t *) HW_IPU_PR_CH0_ILO_ADDR(x))
#define HW_IPU_PR_CH0_ILO_RD(x)  (HW_IPU_PR_CH0_ILO(x).U)
#define HW_IPU_PR_CH0_ILO_WR(x, v) (HW_IPU_PR_CH0_ILO(x).U = (v))
#define HW_IPU_PR_CH0_ILO_SET(x, v) (HW_IPU_PR_CH0_ILO_WR(x, HW_IPU_PR_CH0_ILO_RD(x) |  (v)))
#define HW_IPU_PR_CH0_ILO_CLR(x, v) (HW_IPU_PR_CH0_ILO_WR(x, HW_IPU_PR_CH0_ILO_RD(x) & ~(v)))
#define HW_IPU_PR_CH0_ILO_TOG(x, v) (HW_IPU_PR_CH0_ILO_WR(x, HW_IPU_PR_CH0_ILO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH0_ILO bitfields
 */

/*!
 * @name Register IPU_PR_CH0_ILO, field CH0_ILO[22:0] (RW)
 *
 * This value is signed.
 */
/*@{*/
#define BP_IPU_PR_CH0_ILO_CH0_ILO (0U)     /*!< Bit position for IPU_PR_CH0_ILO_CH0_ILO. */
#define BM_IPU_PR_CH0_ILO_CH0_ILO (0x007FFFFFU) /*!< Bit mask for IPU_PR_CH0_ILO_CH0_ILO. */
#define BS_IPU_PR_CH0_ILO_CH0_ILO (23U)    /*!< Bit field size in bits for IPU_PR_CH0_ILO_CH0_ILO. */

/*! @brief Read current value of the IPU_PR_CH0_ILO_CH0_ILO field. */
#define BR_IPU_PR_CH0_ILO_CH0_ILO(x) (HW_IPU_PR_CH0_ILO(x).B.CH0_ILO)

/*! @brief Format value for bitfield IPU_PR_CH0_ILO_CH0_ILO. */
#define BF_IPU_PR_CH0_ILO_CH0_ILO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH0_ILO_CH0_ILO) & BM_IPU_PR_CH0_ILO_CH0_ILO)

/*! @brief Set the CH0_ILO field to a new value. */
#define BW_IPU_PR_CH0_ILO_CH0_ILO(x, v) (HW_IPU_PR_CH0_ILO_WR(x, (HW_IPU_PR_CH0_ILO_RD(x) & ~BM_IPU_PR_CH0_ILO_CH0_ILO) | BF_IPU_PR_CH0_ILO_CH0_ILO(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH1_ILO - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH1_ILO - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch1_ilo
{
    uint32_t U;
    struct _hw_ipu_pr_ch1_ilo_bitfields
    {
        uint32_t CH1_ILO : 23;         /*!< [22:0]  */
        uint32_t RESERVED0 : 9;        /*!< [31:23]  */
    } B;
} hw_ipu_pr_ch1_ilo_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH1_ILO register
 */
/*@{*/
#define HW_IPU_PR_CH1_ILO_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_IPU_PR_CH1_ILO(x)     (*(__IO hw_ipu_pr_ch1_ilo_t *) HW_IPU_PR_CH1_ILO_ADDR(x))
#define HW_IPU_PR_CH1_ILO_RD(x)  (HW_IPU_PR_CH1_ILO(x).U)
#define HW_IPU_PR_CH1_ILO_WR(x, v) (HW_IPU_PR_CH1_ILO(x).U = (v))
#define HW_IPU_PR_CH1_ILO_SET(x, v) (HW_IPU_PR_CH1_ILO_WR(x, HW_IPU_PR_CH1_ILO_RD(x) |  (v)))
#define HW_IPU_PR_CH1_ILO_CLR(x, v) (HW_IPU_PR_CH1_ILO_WR(x, HW_IPU_PR_CH1_ILO_RD(x) & ~(v)))
#define HW_IPU_PR_CH1_ILO_TOG(x, v) (HW_IPU_PR_CH1_ILO_WR(x, HW_IPU_PR_CH1_ILO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH1_ILO bitfields
 */

/*!
 * @name Register IPU_PR_CH1_ILO, field CH1_ILO[22:0] (RW)
 *
 * Interlace offset address. This value is signed.
 */
/*@{*/
#define BP_IPU_PR_CH1_ILO_CH1_ILO (0U)     /*!< Bit position for IPU_PR_CH1_ILO_CH1_ILO. */
#define BM_IPU_PR_CH1_ILO_CH1_ILO (0x007FFFFFU) /*!< Bit mask for IPU_PR_CH1_ILO_CH1_ILO. */
#define BS_IPU_PR_CH1_ILO_CH1_ILO (23U)    /*!< Bit field size in bits for IPU_PR_CH1_ILO_CH1_ILO. */

/*! @brief Read current value of the IPU_PR_CH1_ILO_CH1_ILO field. */
#define BR_IPU_PR_CH1_ILO_CH1_ILO(x) (HW_IPU_PR_CH1_ILO(x).B.CH1_ILO)

/*! @brief Format value for bitfield IPU_PR_CH1_ILO_CH1_ILO. */
#define BF_IPU_PR_CH1_ILO_CH1_ILO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH1_ILO_CH1_ILO) & BM_IPU_PR_CH1_ILO_CH1_ILO)

/*! @brief Set the CH1_ILO field to a new value. */
#define BW_IPU_PR_CH1_ILO_CH1_ILO(x, v) (HW_IPU_PR_CH1_ILO_WR(x, (HW_IPU_PR_CH1_ILO_RD(x) & ~BM_IPU_PR_CH1_ILO_CH1_ILO) | BF_IPU_PR_CH1_ILO_CH1_ILO(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH2_ILO - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH2_ILO - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch2_ilo
{
    uint32_t U;
    struct _hw_ipu_pr_ch2_ilo_bitfields
    {
        uint32_t CH2_ILO : 23;         /*!< [22:0] Interlace Offset Address */
        uint32_t RESERVED0 : 9;        /*!< [31:23]  */
    } B;
} hw_ipu_pr_ch2_ilo_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH2_ILO register
 */
/*@{*/
#define HW_IPU_PR_CH2_ILO_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_IPU_PR_CH2_ILO(x)     (*(__IO hw_ipu_pr_ch2_ilo_t *) HW_IPU_PR_CH2_ILO_ADDR(x))
#define HW_IPU_PR_CH2_ILO_RD(x)  (HW_IPU_PR_CH2_ILO(x).U)
#define HW_IPU_PR_CH2_ILO_WR(x, v) (HW_IPU_PR_CH2_ILO(x).U = (v))
#define HW_IPU_PR_CH2_ILO_SET(x, v) (HW_IPU_PR_CH2_ILO_WR(x, HW_IPU_PR_CH2_ILO_RD(x) |  (v)))
#define HW_IPU_PR_CH2_ILO_CLR(x, v) (HW_IPU_PR_CH2_ILO_WR(x, HW_IPU_PR_CH2_ILO_RD(x) & ~(v)))
#define HW_IPU_PR_CH2_ILO_TOG(x, v) (HW_IPU_PR_CH2_ILO_WR(x, HW_IPU_PR_CH2_ILO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH2_ILO bitfields
 */

/*!
 * @name Register IPU_PR_CH2_ILO, field CH2_ILO[22:0] (RW)
 *
 * This value is signed.
 */
/*@{*/
#define BP_IPU_PR_CH2_ILO_CH2_ILO (0U)     /*!< Bit position for IPU_PR_CH2_ILO_CH2_ILO. */
#define BM_IPU_PR_CH2_ILO_CH2_ILO (0x007FFFFFU) /*!< Bit mask for IPU_PR_CH2_ILO_CH2_ILO. */
#define BS_IPU_PR_CH2_ILO_CH2_ILO (23U)    /*!< Bit field size in bits for IPU_PR_CH2_ILO_CH2_ILO. */

/*! @brief Read current value of the IPU_PR_CH2_ILO_CH2_ILO field. */
#define BR_IPU_PR_CH2_ILO_CH2_ILO(x) (HW_IPU_PR_CH2_ILO(x).B.CH2_ILO)

/*! @brief Format value for bitfield IPU_PR_CH2_ILO_CH2_ILO. */
#define BF_IPU_PR_CH2_ILO_CH2_ILO(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH2_ILO_CH2_ILO) & BM_IPU_PR_CH2_ILO_CH2_ILO)

/*! @brief Set the CH2_ILO field to a new value. */
#define BW_IPU_PR_CH2_ILO_CH2_ILO(x, v) (HW_IPU_PR_CH2_ILO_WR(x, (HW_IPU_PR_CH2_ILO_RD(x) & ~BM_IPU_PR_CH2_ILO_CH2_ILO) | BF_IPU_PR_CH2_ILO_CH2_ILO(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH0_HEIGHT - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH0_HEIGHT - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch0_height
{
    uint32_t U;
    struct _hw_ipu_pr_ch0_height_bitfields
    {
        uint32_t CH0_PRE_HEIGHT : 12;  /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CH0_IPU_HEIGHT : 12;  /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_pr_ch0_height_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH0_HEIGHT register
 */
/*@{*/
#define HW_IPU_PR_CH0_HEIGHT_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_IPU_PR_CH0_HEIGHT(x)  (*(__IO hw_ipu_pr_ch0_height_t *) HW_IPU_PR_CH0_HEIGHT_ADDR(x))
#define HW_IPU_PR_CH0_HEIGHT_RD(x) (HW_IPU_PR_CH0_HEIGHT(x).U)
#define HW_IPU_PR_CH0_HEIGHT_WR(x, v) (HW_IPU_PR_CH0_HEIGHT(x).U = (v))
#define HW_IPU_PR_CH0_HEIGHT_SET(x, v) (HW_IPU_PR_CH0_HEIGHT_WR(x, HW_IPU_PR_CH0_HEIGHT_RD(x) |  (v)))
#define HW_IPU_PR_CH0_HEIGHT_CLR(x, v) (HW_IPU_PR_CH0_HEIGHT_WR(x, HW_IPU_PR_CH0_HEIGHT_RD(x) & ~(v)))
#define HW_IPU_PR_CH0_HEIGHT_TOG(x, v) (HW_IPU_PR_CH0_HEIGHT_WR(x, HW_IPU_PR_CH0_HEIGHT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH0_HEIGHT bitfields
 */

/*!
 * @name Register IPU_PR_CH0_HEIGHT, field CH0_PRE_HEIGHT[11:0] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT (0U) /*!< Bit position for IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT. */
#define BM_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT (0x00000FFFU) /*!< Bit mask for IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT. */
#define BS_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT field. */
#define BR_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT(x) (HW_IPU_PR_CH0_HEIGHT(x).B.CH0_PRE_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT. */
#define BF_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT) & BM_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT)

/*! @brief Set the CH0_PRE_HEIGHT field to a new value. */
#define BW_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT(x, v) (HW_IPU_PR_CH0_HEIGHT_WR(x, (HW_IPU_PR_CH0_HEIGHT_RD(x) & ~BM_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT) | BF_IPU_PR_CH0_HEIGHT_CH0_PRE_HEIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CH0_HEIGHT, field CH0_IPU_HEIGHT[27:16] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT (16U) /*!< Bit position for IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT. */
#define BM_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT. */
#define BS_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT field. */
#define BR_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT(x) (HW_IPU_PR_CH0_HEIGHT(x).B.CH0_IPU_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT. */
#define BF_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT) & BM_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT)

/*! @brief Set the CH0_IPU_HEIGHT field to a new value. */
#define BW_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT(x, v) (HW_IPU_PR_CH0_HEIGHT_WR(x, (HW_IPU_PR_CH0_HEIGHT_RD(x) & ~BM_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT) | BF_IPU_PR_CH0_HEIGHT_CH0_IPU_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH1_HEIGHT - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH1_HEIGHT - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch1_height
{
    uint32_t U;
    struct _hw_ipu_pr_ch1_height_bitfields
    {
        uint32_t CH1_HEIGHT : 12;      /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CH1_IPU_HEIGHT : 12;  /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_pr_ch1_height_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH1_HEIGHT register
 */
/*@{*/
#define HW_IPU_PR_CH1_HEIGHT_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_IPU_PR_CH1_HEIGHT(x)  (*(__IO hw_ipu_pr_ch1_height_t *) HW_IPU_PR_CH1_HEIGHT_ADDR(x))
#define HW_IPU_PR_CH1_HEIGHT_RD(x) (HW_IPU_PR_CH1_HEIGHT(x).U)
#define HW_IPU_PR_CH1_HEIGHT_WR(x, v) (HW_IPU_PR_CH1_HEIGHT(x).U = (v))
#define HW_IPU_PR_CH1_HEIGHT_SET(x, v) (HW_IPU_PR_CH1_HEIGHT_WR(x, HW_IPU_PR_CH1_HEIGHT_RD(x) |  (v)))
#define HW_IPU_PR_CH1_HEIGHT_CLR(x, v) (HW_IPU_PR_CH1_HEIGHT_WR(x, HW_IPU_PR_CH1_HEIGHT_RD(x) & ~(v)))
#define HW_IPU_PR_CH1_HEIGHT_TOG(x, v) (HW_IPU_PR_CH1_HEIGHT_WR(x, HW_IPU_PR_CH1_HEIGHT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH1_HEIGHT bitfields
 */

/*!
 * @name Register IPU_PR_CH1_HEIGHT, field CH1_HEIGHT[11:0] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH1_HEIGHT_CH1_HEIGHT (0U) /*!< Bit position for IPU_PR_CH1_HEIGHT_CH1_HEIGHT. */
#define BM_IPU_PR_CH1_HEIGHT_CH1_HEIGHT (0x00000FFFU) /*!< Bit mask for IPU_PR_CH1_HEIGHT_CH1_HEIGHT. */
#define BS_IPU_PR_CH1_HEIGHT_CH1_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH1_HEIGHT_CH1_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH1_HEIGHT_CH1_HEIGHT field. */
#define BR_IPU_PR_CH1_HEIGHT_CH1_HEIGHT(x) (HW_IPU_PR_CH1_HEIGHT(x).B.CH1_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH1_HEIGHT_CH1_HEIGHT. */
#define BF_IPU_PR_CH1_HEIGHT_CH1_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH1_HEIGHT_CH1_HEIGHT) & BM_IPU_PR_CH1_HEIGHT_CH1_HEIGHT)

/*! @brief Set the CH1_HEIGHT field to a new value. */
#define BW_IPU_PR_CH1_HEIGHT_CH1_HEIGHT(x, v) (HW_IPU_PR_CH1_HEIGHT_WR(x, (HW_IPU_PR_CH1_HEIGHT_RD(x) & ~BM_IPU_PR_CH1_HEIGHT_CH1_HEIGHT) | BF_IPU_PR_CH1_HEIGHT_CH1_HEIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CH1_HEIGHT, field CH1_IPU_HEIGHT[27:16] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT (16U) /*!< Bit position for IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT. */
#define BM_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT. */
#define BS_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT field. */
#define BR_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT(x) (HW_IPU_PR_CH1_HEIGHT(x).B.CH1_IPU_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT. */
#define BF_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT) & BM_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT)

/*! @brief Set the CH1_IPU_HEIGHT field to a new value. */
#define BW_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT(x, v) (HW_IPU_PR_CH1_HEIGHT_WR(x, (HW_IPU_PR_CH1_HEIGHT_RD(x) & ~BM_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT) | BF_IPU_PR_CH1_HEIGHT_CH1_IPU_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * HW_IPU_PR_CH2_HEIGHT - IPU PRG Interlace Offset Address Register
 ******************************************************************************/

/*!
 * @brief HW_IPU_PR_CH2_HEIGHT - IPU PRG Interlace Offset Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ipu_pr_ch2_height
{
    uint32_t U;
    struct _hw_ipu_pr_ch2_height_bitfields
    {
        uint32_t CH2_HEIGHT : 12;      /*!< [11:0]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CH2_IPU_HEIGHT : 12;  /*!< [27:16]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_ipu_pr_ch2_height_t;

/*!
 * @name Constants and macros for entire IPU_PR_CH2_HEIGHT register
 */
/*@{*/
#define HW_IPU_PR_CH2_HEIGHT_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_IPU_PR_CH2_HEIGHT(x)  (*(__IO hw_ipu_pr_ch2_height_t *) HW_IPU_PR_CH2_HEIGHT_ADDR(x))
#define HW_IPU_PR_CH2_HEIGHT_RD(x) (HW_IPU_PR_CH2_HEIGHT(x).U)
#define HW_IPU_PR_CH2_HEIGHT_WR(x, v) (HW_IPU_PR_CH2_HEIGHT(x).U = (v))
#define HW_IPU_PR_CH2_HEIGHT_SET(x, v) (HW_IPU_PR_CH2_HEIGHT_WR(x, HW_IPU_PR_CH2_HEIGHT_RD(x) |  (v)))
#define HW_IPU_PR_CH2_HEIGHT_CLR(x, v) (HW_IPU_PR_CH2_HEIGHT_WR(x, HW_IPU_PR_CH2_HEIGHT_RD(x) & ~(v)))
#define HW_IPU_PR_CH2_HEIGHT_TOG(x, v) (HW_IPU_PR_CH2_HEIGHT_WR(x, HW_IPU_PR_CH2_HEIGHT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual IPU_PR_CH2_HEIGHT bitfields
 */

/*!
 * @name Register IPU_PR_CH2_HEIGHT, field CH2_HEIGHT[11:0] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH2_HEIGHT_CH2_HEIGHT (0U) /*!< Bit position for IPU_PR_CH2_HEIGHT_CH2_HEIGHT. */
#define BM_IPU_PR_CH2_HEIGHT_CH2_HEIGHT (0x00000FFFU) /*!< Bit mask for IPU_PR_CH2_HEIGHT_CH2_HEIGHT. */
#define BS_IPU_PR_CH2_HEIGHT_CH2_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH2_HEIGHT_CH2_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH2_HEIGHT_CH2_HEIGHT field. */
#define BR_IPU_PR_CH2_HEIGHT_CH2_HEIGHT(x) (HW_IPU_PR_CH2_HEIGHT(x).B.CH2_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH2_HEIGHT_CH2_HEIGHT. */
#define BF_IPU_PR_CH2_HEIGHT_CH2_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH2_HEIGHT_CH2_HEIGHT) & BM_IPU_PR_CH2_HEIGHT_CH2_HEIGHT)

/*! @brief Set the CH2_HEIGHT field to a new value. */
#define BW_IPU_PR_CH2_HEIGHT_CH2_HEIGHT(x, v) (HW_IPU_PR_CH2_HEIGHT_WR(x, (HW_IPU_PR_CH2_HEIGHT_RD(x) & ~BM_IPU_PR_CH2_HEIGHT_CH2_HEIGHT) | BF_IPU_PR_CH2_HEIGHT_CH2_HEIGHT(v)))
/*@}*/

/*!
 * @name Register IPU_PR_CH2_HEIGHT, field CH2_IPU_HEIGHT[27:16] (RW)
 *
 * Number of pixels in one column of the channel frame. FH
 *
 * Values:
 * - 000000000000 - 0001 line
 * - 000000000001 - 0002 line
 * - 111111111111 - 4096 lines
 */
/*@{*/
#define BP_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT (16U) /*!< Bit position for IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT. */
#define BM_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT (0x0FFF0000U) /*!< Bit mask for IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT. */
#define BS_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT (12U) /*!< Bit field size in bits for IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT. */

/*! @brief Read current value of the IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT field. */
#define BR_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT(x) (HW_IPU_PR_CH2_HEIGHT(x).B.CH2_IPU_HEIGHT)

/*! @brief Format value for bitfield IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT. */
#define BF_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT(v) ((uint32_t)((uint32_t)(v) << BP_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT) & BM_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT)

/*! @brief Set the CH2_IPU_HEIGHT field to a new value. */
#define BW_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT(x, v) (HW_IPU_PR_CH2_HEIGHT_WR(x, (HW_IPU_PR_CH2_HEIGHT_RD(x) & ~BM_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT) | BF_IPU_PR_CH2_HEIGHT_CH2_IPU_HEIGHT(v)))
/*@}*/

/*******************************************************************************
 * hw_ipu_pr_t - module struct
 ******************************************************************************/
/*!
 * @brief All IPU_PR module registers.
 */
#pragma pack(1)
typedef struct _hw_ipu_pr
{
    __IO hw_ipu_pr_ctrl_t CTRL;            /*!< [0x0] IPU PR Control Register */
    __I hw_ipu_pr_status_t STATUS;         /*!< [0x4] IPU PR STATUS Register */
    __IO hw_ipu_pr_qos_t QOS;              /*!< [0x8] IPU PR QOS Register */
    __O hw_ipu_pr_reg_update_t REG_UPDATE; /*!< [0xC] IPU PR Control Register */
    __IO hw_ipu_pr_stride0_t STRIDE0;      /*!< [0x10] IPU PR Stride Register */
    __IO hw_ipu_pr_stride1_t STRIDE1;      /*!< [0x14] IPU PR Stride Register */
    __IO hw_ipu_pr_stride2_t STRIDE2;      /*!< [0x18] IPU PR Stride Register */
    __IO hw_ipu_pr_corp_line_t CORP_LINE;  /*!< [0x1C] IPU PR Stride Register */
    __IO hw_ipu_pr_addr_thd_t ADDR_THD;    /*!< [0x20] IPU PR Address Thresh Hold Register */
    __IO hw_ipu_pr_ch0_baddr_t CH0_BADDR;  /*!< [0x24] IPU PR Start Base Address Register */
    __IO hw_ipu_pr_ch1_baddr_t CH1_BADDR;  /*!< [0x28] IPU PR Start Base Address Register */
    __IO hw_ipu_pr_ch2_baddr_t CH2_BADDR;  /*!< [0x2C] IPU PR Start Base Address Register */
    __IO hw_ipu_pr_ch0_offset_t CH0_OFFSET; /*!< [0x30] IPU PR Start Offset Address Register */
    __IO hw_ipu_pr_ch1_offset_t CH1_OFFSET; /*!< [0x34] IPU PR Start Offset Address Register */
    __IO hw_ipu_pr_ch2_offset_t CH2_OFFSET; /*!< [0x38] IPU PR Start Offset Address Register */
    __IO hw_ipu_pr_ch0_ilo_t CH0_ILO;      /*!< [0x3C] IPU PRG Interlace Offset Address Register */
    __IO hw_ipu_pr_ch1_ilo_t CH1_ILO;      /*!< [0x40] IPU PRG Interlace Offset Address Register */
    __IO hw_ipu_pr_ch2_ilo_t CH2_ILO;      /*!< [0x44] IPU PRG Interlace Offset Address Register */
    __IO hw_ipu_pr_ch0_height_t CH0_HEIGHT; /*!< [0x48] IPU PRG Interlace Offset Address Register */
    __IO hw_ipu_pr_ch1_height_t CH1_HEIGHT; /*!< [0x4C] IPU PRG Interlace Offset Address Register */
    __IO hw_ipu_pr_ch2_height_t CH2_HEIGHT; /*!< [0x50] IPU PRG Interlace Offset Address Register */
} hw_ipu_pr_t;
#pragma pack()

/*! @brief Macro to access all IPU_PR registers. */
/*! @param x IPU_PR module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_IPU_PR_REGS(IPU_PR_BASE)</code>. */
#define HW_IPU_PR_REGS(x) (*(hw_ipu_pr_t *)(x))

/*
 * iMX6DP KPP
 *
 * KPP Registers
 *
 * Registers defined in this header file:
 * - HW_KPP_KPCR - Keypad Control Register
 * - HW_KPP_KPSR - Keypad Status Register
 * - HW_KPP_KDDR - Keypad Data Direction Register
 * - HW_KPP_KPDR - Keypad Data Register
 *
 * - hw_kpp_t - Struct containing all module registers.
 */

#define HW_KPP_INSTANCE_COUNT (1U) /*!< Number of instances of the KPP module. */
#define HW_KPP (0U) /*!< Instance number for KPP. */
#define KPP_BASE              (0x20B8000U) /*!< Base address for KPP. */
/*! Array initializer of KPP base addresses. */
#define KPP_BASE_ADDRS        { KPP_BASE }

/*******************************************************************************
 * HW_KPP_KPCR - Keypad Control Register
 ******************************************************************************/

/*!
 * @brief HW_KPP_KPCR - Keypad Control Register (RW)
 *
 * Reset value: 0x0000U
 *
 * The Keypad Control Register determines which of the eight possible column
 * strobes are to be open drain when configured as outputs, and which of the eight
 * row sense lines are considered in generating an interrupt to the core. It is up
 * to the programmer to ensure that pins being used for functions other than the
 * keypad are properly disabled. The KPP_KPCR register is byte- or
 * half-word-addressable.
 */
typedef union _hw_kpp_kpcr
{
    uint16_t U;
    struct _hw_kpp_kpcr_bitfields
    {
        uint16_t KRE : 8;              /*!< [7:0]  */
        uint16_t KCO : 8;              /*!< [15:8]  */
    } B;
} hw_kpp_kpcr_t;

/*!
 * @name Constants and macros for entire KPP_KPCR register
 */
/*@{*/
#define HW_KPP_KPCR_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_KPP_KPCR(x)           (*(__IO hw_kpp_kpcr_t *) HW_KPP_KPCR_ADDR(x))
#define HW_KPP_KPCR_RD(x)        (HW_KPP_KPCR(x).U)
#define HW_KPP_KPCR_WR(x, v)     (HW_KPP_KPCR(x).U = (v))
#define HW_KPP_KPCR_SET(x, v)    (HW_KPP_KPCR_WR(x, HW_KPP_KPCR_RD(x) |  (v)))
#define HW_KPP_KPCR_CLR(x, v)    (HW_KPP_KPCR_WR(x, HW_KPP_KPCR_RD(x) & ~(v)))
#define HW_KPP_KPCR_TOG(x, v)    (HW_KPP_KPCR_WR(x, HW_KPP_KPCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual KPP_KPCR bitfields
 */

/*!
 * @name Register KPP_KPCR, field KRE[7:0] (RW)
 *
 * Keypad Row Enable. Setting a row enable control bit in this register enables
 * the corresponding row line to participate in interrupt generation. Likewise,
 * clearing a bit disables that row from being used to generate an interrupt. This
 * register is cleared by a reset, disabling all rows. The row-enable logic is
 * independent of the programmed direction of the pin. Writing a "0" to the data
 * register of the pins configured as outputs will cause a keypad interrupt to be
 * generated if the row enable associated with that bit is set.
 *
 * Values:
 * - 0 - Row is not included in the keypad key press detect.
 * - 1 - Row is included in the keypad key press detect.
 */
/*@{*/
#define BP_KPP_KPCR_KRE      (0U)          /*!< Bit position for KPP_KPCR_KRE. */
#define BM_KPP_KPCR_KRE      (0x00FFU)     /*!< Bit mask for KPP_KPCR_KRE. */
#define BS_KPP_KPCR_KRE      (8U)          /*!< Bit field size in bits for KPP_KPCR_KRE. */

/*! @brief Read current value of the KPP_KPCR_KRE field. */
#define BR_KPP_KPCR_KRE(x)   (HW_KPP_KPCR(x).B.KRE)

/*! @brief Format value for bitfield KPP_KPCR_KRE. */
#define BF_KPP_KPCR_KRE(v)   ((uint16_t)((uint16_t)(v) << BP_KPP_KPCR_KRE) & BM_KPP_KPCR_KRE)

/*! @brief Set the KRE field to a new value. */
#define BW_KPP_KPCR_KRE(x, v) (HW_KPP_KPCR_WR(x, (HW_KPP_KPCR_RD(x) & ~BM_KPP_KPCR_KRE) | BF_KPP_KPCR_KRE(v)))
/*@}*/

/*!
 * @name Register KPP_KPCR, field KCO[15:8] (RW)
 *
 * Keypad Column Strobe Open-Drain Enable. Setting a column open-drain enable
 * bit (KCO7-KCO0) disables the pull-up driver on that pin. Clearing the bit allows
 * the pin to drive to the high state. This bit has no effect when the pin is
 * configured as an input. Configuration of external port control logic (for
 * example, IOMUX) should be done properly so that the KPP controls an open-drain
 * enable of the pin.
 *
 * Values:
 * - 0 - Column strobe output is totem pole drive.
 * - 1 - Column strobe output is open drain.
 */
/*@{*/
#define BP_KPP_KPCR_KCO      (8U)          /*!< Bit position for KPP_KPCR_KCO. */
#define BM_KPP_KPCR_KCO      (0xFF00U)     /*!< Bit mask for KPP_KPCR_KCO. */
#define BS_KPP_KPCR_KCO      (8U)          /*!< Bit field size in bits for KPP_KPCR_KCO. */

#define BV_KPP_KPCR_KCO_TOTEM_POLE     (0U)          /*!< Bit field value for KPP_KPCR_KCO: Column strobe output is totem pole drive. */
#define BV_KPP_KPCR_KCO_OPEN_DRAIN     (0x1U)        /*!< Bit field value for KPP_KPCR_KCO: Column strobe output is open drain. */

/*! @brief Read current value of the KPP_KPCR_KCO field. */
#define BR_KPP_KPCR_KCO(x)   (HW_KPP_KPCR(x).B.KCO)

/*! @brief Format value for bitfield KPP_KPCR_KCO. */
#define BF_KPP_KPCR_KCO(v)   ((uint16_t)((uint16_t)(v) << BP_KPP_KPCR_KCO) & BM_KPP_KPCR_KCO)

/*! @brief Set the KCO field to a new value. */
#define BW_KPP_KPCR_KCO(x, v) (HW_KPP_KPCR_WR(x, (HW_KPP_KPCR_RD(x) & ~BM_KPP_KPCR_KCO) | BF_KPP_KPCR_KCO(v)))
/*@}*/

/*******************************************************************************
 * HW_KPP_KPSR - Keypad Status Register
 ******************************************************************************/

/*!
 * @brief HW_KPP_KPSR - Keypad Status Register (RW)
 *
 * Reset value: 0x0400U
 *
 * The Keypad Status Register reflects the state of the key press detect
 * circuit. The KPP_KPSR register is byte- or half-word-addressable.
 */
typedef union _hw_kpp_kpsr
{
    uint16_t U;
    struct _hw_kpp_kpsr_bitfields
    {
        uint16_t KPKD : 1;             /*!< [0]  */
        uint16_t KPKR : 1;             /*!< [1]  */
        uint16_t KDSC : 1;             /*!< [2]  */
        uint16_t KRSS : 1;             /*!< [3]  */
        uint16_t RESERVED0 : 4;        /*!< [7:4]  */
        uint16_t KDIE : 1;             /*!< [8]  */
        uint16_t KRIE : 1;             /*!< [9]  */
        uint16_t RESERVED1 : 6;        /*!< [15:10]  */
    } B;
} hw_kpp_kpsr_t;

/*!
 * @name Constants and macros for entire KPP_KPSR register
 */
/*@{*/
#define HW_KPP_KPSR_ADDR(x)      ((uintptr_t)(x) + 0x2U)

#define HW_KPP_KPSR(x)           (*(__IO hw_kpp_kpsr_t *) HW_KPP_KPSR_ADDR(x))
#define HW_KPP_KPSR_RD(x)        (HW_KPP_KPSR(x).U)
#define HW_KPP_KPSR_WR(x, v)     (HW_KPP_KPSR(x).U = (v))
#define HW_KPP_KPSR_SET(x, v)    (HW_KPP_KPSR_WR(x, HW_KPP_KPSR_RD(x) |  (v)))
#define HW_KPP_KPSR_CLR(x, v)    (HW_KPP_KPSR_WR(x, HW_KPP_KPSR_RD(x) & ~(v)))
#define HW_KPP_KPSR_TOG(x, v)    (HW_KPP_KPSR_WR(x, HW_KPP_KPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual KPP_KPSR bitfields
 */

/*!
 * @name Register KPP_KPSR, field KPKD[0] (W1C)
 *
 * Keypad Key Depress. The keypad key depress (KPKD) status bit is set when one
 * or more enabled rows are detected low after synchronization. The KPKD status
 * bit remains set until cleared by the software. The KPKD bit may be used to
 * generate a maskable key depress interrupt. If desired, the software may clear the
 * key press synchronizer chain to allow a repeated interrupt to be generated
 * while a key remains pressed. In this case, a new interrupt will be generated
 * after the synchronizer delay (4 cycles of the low frequency reference clock
 * elapses if a key remains pressed. This functionality can be used to detect a long
 * key press. This allows detection of additional key presses of the same key or
 * other keys. Due to the logic function of the release and depress synchronizer
 * chains, it is possible to see the re-assertion of a status flag (KPKD or KPKR)
 * if it is cleared by the software prior to the system exiting the state it
 * represents.
 *
 * Values:
 * - 0 - No key presses detected
 * - 1 - A key has been depressed
 */
/*@{*/
#define BP_KPP_KPSR_KPKD     (0U)          /*!< Bit position for KPP_KPSR_KPKD. */
#define BM_KPP_KPSR_KPKD     (0x0001U)     /*!< Bit mask for KPP_KPSR_KPKD. */
#define BS_KPP_KPSR_KPKD     (1U)          /*!< Bit field size in bits for KPP_KPSR_KPKD. */

/*! @brief Read current value of the KPP_KPSR_KPKD field. */
#define BR_KPP_KPSR_KPKD(x)  (HW_KPP_KPSR(x).B.KPKD)

/*! @brief Format value for bitfield KPP_KPSR_KPKD. */
#define BF_KPP_KPSR_KPKD(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KPKD) & BM_KPP_KPSR_KPKD)

/*! @brief Set the KPKD field to a new value. */
#define BW_KPP_KPSR_KPKD(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KPKD | BM_KPP_KPSR_KPKR)) | BF_KPP_KPSR_KPKD(v)))
/*@}*/

/*!
 * @name Register KPP_KPSR, field KPKR[1] (W1C)
 *
 * Keypad Key Release. The keypad key release (KPKR) status bit is set when all
 * enabled rows are detected high after synchronization (the KPKR status bit will
 * be set when cleared by a reset). The KPKR bit may be used to generate a
 * maskable key release interrupt. The key release synchronizer may be set high by
 * software after scanning the keypad to ensure a known state. Due to the logic
 * function of the release and depress synchronizer chains, it is possible to see the
 * re-assertion of a status flag (KPKD or KPKR) if it is cleared by software
 * prior to the system exiting the state it represents. Reset value of register is
 * "0" as long as reset is asserted. However when reset is de-asserted, the value
 * of the register depends upon the external row pins and can become "1".
 *
 * Values:
 * - 0 - No key release detected
 * - 1 - All keys have been released
 */
/*@{*/
#define BP_KPP_KPSR_KPKR     (1U)          /*!< Bit position for KPP_KPSR_KPKR. */
#define BM_KPP_KPSR_KPKR     (0x0002U)     /*!< Bit mask for KPP_KPSR_KPKR. */
#define BS_KPP_KPSR_KPKR     (1U)          /*!< Bit field size in bits for KPP_KPSR_KPKR. */

/*! @brief Read current value of the KPP_KPSR_KPKR field. */
#define BR_KPP_KPSR_KPKR(x)  (HW_KPP_KPSR(x).B.KPKR)

/*! @brief Format value for bitfield KPP_KPSR_KPKR. */
#define BF_KPP_KPSR_KPKR(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KPKR) & BM_KPP_KPSR_KPKR)

/*! @brief Set the KPKR field to a new value. */
#define BW_KPP_KPSR_KPKR(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KPKR | BM_KPP_KPSR_KPKD)) | BF_KPP_KPSR_KPKR(v)))
/*@}*/

/*!
 * @name Register KPP_KPSR, field KDSC[2] (WORZ)
 *
 * Key Depress Synchronizer Clear. Self-clear bit. The Key depress synchronizer
 * is cleared by writing a logic "1" into this bit. Reads return a value of "0".
 *
 * Values:
 * - 0 - No effect
 * - 1 - Set bits that clear the keypad depress synchronizer chain
 */
/*@{*/
#define BP_KPP_KPSR_KDSC     (2U)          /*!< Bit position for KPP_KPSR_KDSC. */
#define BM_KPP_KPSR_KDSC     (0x0004U)     /*!< Bit mask for KPP_KPSR_KDSC. */
#define BS_KPP_KPSR_KDSC     (1U)          /*!< Bit field size in bits for KPP_KPSR_KDSC. */

/*! @brief Format value for bitfield KPP_KPSR_KDSC. */
#define BF_KPP_KPSR_KDSC(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KDSC) & BM_KPP_KPSR_KDSC)

/*! @brief Set the KDSC field to a new value. */
#define BW_KPP_KPSR_KDSC(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KDSC | BM_KPP_KPSR_KPKD | BM_KPP_KPSR_KPKR)) | BF_KPP_KPSR_KDSC(v)))
/*@}*/

/*!
 * @name Register KPP_KPSR, field KRSS[3] (WORZ)
 *
 * Key Release Synchronizer Set. Self-clear bit. The Key release synchronizer is
 * set by writing a logic one into this bit. Reads return a value of "0".
 *
 * Values:
 * - 0 - No effect
 * - 1 - Set bits which sets keypad release synchronizer chain
 */
/*@{*/
#define BP_KPP_KPSR_KRSS     (3U)          /*!< Bit position for KPP_KPSR_KRSS. */
#define BM_KPP_KPSR_KRSS     (0x0008U)     /*!< Bit mask for KPP_KPSR_KRSS. */
#define BS_KPP_KPSR_KRSS     (1U)          /*!< Bit field size in bits for KPP_KPSR_KRSS. */

/*! @brief Format value for bitfield KPP_KPSR_KRSS. */
#define BF_KPP_KPSR_KRSS(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KRSS) & BM_KPP_KPSR_KRSS)

/*! @brief Set the KRSS field to a new value. */
#define BW_KPP_KPSR_KRSS(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KRSS | BM_KPP_KPSR_KPKD | BM_KPP_KPSR_KPKR)) | BF_KPP_KPSR_KRSS(v)))
/*@}*/

/*!
 * @name Register KPP_KPSR, field KDIE[8] (RW)
 *
 * Keypad Key Depress Interrupt Enable. Software should ensure that the
 * interrupt for a Key Release event is masked until it has entered the key pressed
 * state, and vice-versa, unless this activity is desired (as might be the case when a
 * repeated interrupt is to be generated). The synchronizer chains are capable
 * of being initialized to detect repeated key presses or releases. If they are
 * not initialized when the corresponding event flag is cleared, false interrupts
 * may be generated for depress (or release) events shorter than the length of the
 * corresponding chain.
 *
 * Values:
 * - 0 - No interrupt request is generated when KPKD is set.
 * - 1 - An interrupt request is generated when KPKD is set.
 */
/*@{*/
#define BP_KPP_KPSR_KDIE     (8U)          /*!< Bit position for KPP_KPSR_KDIE. */
#define BM_KPP_KPSR_KDIE     (0x0100U)     /*!< Bit mask for KPP_KPSR_KDIE. */
#define BS_KPP_KPSR_KDIE     (1U)          /*!< Bit field size in bits for KPP_KPSR_KDIE. */

/*! @brief Read current value of the KPP_KPSR_KDIE field. */
#define BR_KPP_KPSR_KDIE(x)  (HW_KPP_KPSR(x).B.KDIE)

/*! @brief Format value for bitfield KPP_KPSR_KDIE. */
#define BF_KPP_KPSR_KDIE(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KDIE) & BM_KPP_KPSR_KDIE)

/*! @brief Set the KDIE field to a new value. */
#define BW_KPP_KPSR_KDIE(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KDIE | BM_KPP_KPSR_KPKD | BM_KPP_KPSR_KPKR)) | BF_KPP_KPSR_KDIE(v)))
/*@}*/

/*!
 * @name Register KPP_KPSR, field KRIE[9] (RW)
 *
 * Keypad Release Interrupt Enable. The software should ensure that the
 * interrupt for a Key Release event is masked until it has entered the key pressed
 * state, and vice versa, unless this activity is desired (as might be the case when a
 * repeated interrupt is to be generated). The synchronizer chains are capable
 * of being initialized to detect repeated key presses or releases. If they are
 * not initialized when the corresponding event flag is cleared, false interrupts
 * may be generated for depress (or release) events shorter than the length of the
 * corresponding chain.
 *
 * Values:
 * - 0 - No interrupt request is generated when KPKR is set.
 * - 1 - An interrupt request is generated when KPKR is set.
 */
/*@{*/
#define BP_KPP_KPSR_KRIE     (9U)          /*!< Bit position for KPP_KPSR_KRIE. */
#define BM_KPP_KPSR_KRIE     (0x0200U)     /*!< Bit mask for KPP_KPSR_KRIE. */
#define BS_KPP_KPSR_KRIE     (1U)          /*!< Bit field size in bits for KPP_KPSR_KRIE. */

/*! @brief Read current value of the KPP_KPSR_KRIE field. */
#define BR_KPP_KPSR_KRIE(x)  (HW_KPP_KPSR(x).B.KRIE)

/*! @brief Format value for bitfield KPP_KPSR_KRIE. */
#define BF_KPP_KPSR_KRIE(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KPSR_KRIE) & BM_KPP_KPSR_KRIE)

/*! @brief Set the KRIE field to a new value. */
#define BW_KPP_KPSR_KRIE(x, v) (HW_KPP_KPSR_WR(x, (HW_KPP_KPSR_RD(x) & ~(BM_KPP_KPSR_KRIE | BM_KPP_KPSR_KPKD | BM_KPP_KPSR_KPKR)) | BF_KPP_KPSR_KRIE(v)))
/*@}*/

/*******************************************************************************
 * HW_KPP_KDDR - Keypad Data Direction Register
 ******************************************************************************/

/*!
 * @brief HW_KPP_KDDR - Keypad Data Direction Register (RW)
 *
 * Reset value: 0x0000U
 *
 * The bits in the KPP_KDDR control the direction of the keypad port pins. The
 * upper eight bits in the register affect the pins designated as column strobes,
 * while the lower eight bits affect the row sense pins. Setting any bit in this
 * register configures the corresponding pin as an output. Clearing any bit in
 * this register configures the corresponding port pin as an input. For the Keypad
 * Row DDR, an internal pull-up is enabled if the corresponding bit is clear.
 * This register is cleared by a reset, configuring all pins as inputs. The KPP_KDDR
 * register is byte- or half-word addressable. When a pin is used as row pin for
 * keypad purposes, all corresponding pull-ups should be enabled at the upper
 * level (for example, IOMUX) when the bit in KRDD is cleared.
 */
typedef union _hw_kpp_kddr
{
    uint16_t U;
    struct _hw_kpp_kddr_bitfields
    {
        uint16_t KRDD : 8;             /*!< [7:0]  */
        uint16_t KCDD : 8;             /*!< [15:8]  */
    } B;
} hw_kpp_kddr_t;

/*!
 * @name Constants and macros for entire KPP_KDDR register
 */
/*@{*/
#define HW_KPP_KDDR_ADDR(x)      ((uintptr_t)(x) + 0x4U)

#define HW_KPP_KDDR(x)           (*(__IO hw_kpp_kddr_t *) HW_KPP_KDDR_ADDR(x))
#define HW_KPP_KDDR_RD(x)        (HW_KPP_KDDR(x).U)
#define HW_KPP_KDDR_WR(x, v)     (HW_KPP_KDDR(x).U = (v))
#define HW_KPP_KDDR_SET(x, v)    (HW_KPP_KDDR_WR(x, HW_KPP_KDDR_RD(x) |  (v)))
#define HW_KPP_KDDR_CLR(x, v)    (HW_KPP_KDDR_WR(x, HW_KPP_KDDR_RD(x) & ~(v)))
#define HW_KPP_KDDR_TOG(x, v)    (HW_KPP_KDDR_WR(x, HW_KPP_KDDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual KPP_KDDR bitfields
 */

/*!
 * @name Register KPP_KDDR, field KRDD[7:0] (RW)
 *
 * Keypad Row Data Direction. Setting a bit configures the corresponding ROWn
 * pin as an output (where n = 7 through 0).
 *
 * Values:
 * - 0 - ROWn pin configured as an input.
 * - 1 - ROWn pin configured as an output.
 */
/*@{*/
#define BP_KPP_KDDR_KRDD     (0U)          /*!< Bit position for KPP_KDDR_KRDD. */
#define BM_KPP_KDDR_KRDD     (0x00FFU)     /*!< Bit mask for KPP_KDDR_KRDD. */
#define BS_KPP_KDDR_KRDD     (8U)          /*!< Bit field size in bits for KPP_KDDR_KRDD. */

#define BV_KPP_KDDR_KRDD_INPUT         (0U)          /*!< Bit field value for KPP_KDDR_KRDD: ROWn pin configured as an input. */
#define BV_KPP_KDDR_KRDD_OUTPUT        (0x1U)        /*!< Bit field value for KPP_KDDR_KRDD: ROWn pin configured as an output. */

/*! @brief Read current value of the KPP_KDDR_KRDD field. */
#define BR_KPP_KDDR_KRDD(x)  (HW_KPP_KDDR(x).B.KRDD)

/*! @brief Format value for bitfield KPP_KDDR_KRDD. */
#define BF_KPP_KDDR_KRDD(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KDDR_KRDD) & BM_KPP_KDDR_KRDD)

/*! @brief Set the KRDD field to a new value. */
#define BW_KPP_KDDR_KRDD(x, v) (HW_KPP_KDDR_WR(x, (HW_KPP_KDDR_RD(x) & ~BM_KPP_KDDR_KRDD) | BF_KPP_KDDR_KRDD(v)))
/*@}*/

/*!
 * @name Register KPP_KDDR, field KCDD[15:8] (RW)
 *
 * Keypad Column Data Direction Register. Setting a bit configures the
 * corresponding COLn pin as an output (where n = 7 through 0).
 *
 * Values:
 * - 0 - COLn pin is configured as an input.
 * - 1 - COLn pin is configured as an output.
 */
/*@{*/
#define BP_KPP_KDDR_KCDD     (8U)          /*!< Bit position for KPP_KDDR_KCDD. */
#define BM_KPP_KDDR_KCDD     (0xFF00U)     /*!< Bit mask for KPP_KDDR_KCDD. */
#define BS_KPP_KDDR_KCDD     (8U)          /*!< Bit field size in bits for KPP_KDDR_KCDD. */

#define BV_KPP_KDDR_KCDD_INPUT         (0U)          /*!< Bit field value for KPP_KDDR_KCDD: COLn pin is configured as an input. */
#define BV_KPP_KDDR_KCDD_OUTPUT        (0x1U)        /*!< Bit field value for KPP_KDDR_KCDD: COLn pin is configured as an output. */

/*! @brief Read current value of the KPP_KDDR_KCDD field. */
#define BR_KPP_KDDR_KCDD(x)  (HW_KPP_KDDR(x).B.KCDD)

/*! @brief Format value for bitfield KPP_KDDR_KCDD. */
#define BF_KPP_KDDR_KCDD(v)  ((uint16_t)((uint16_t)(v) << BP_KPP_KDDR_KCDD) & BM_KPP_KDDR_KCDD)

/*! @brief Set the KCDD field to a new value. */
#define BW_KPP_KDDR_KCDD(x, v) (HW_KPP_KDDR_WR(x, (HW_KPP_KDDR_RD(x) & ~BM_KPP_KDDR_KCDD) | BF_KPP_KDDR_KCDD(v)))
/*@}*/

/*******************************************************************************
 * HW_KPP_KPDR - Keypad Data Register
 ******************************************************************************/

/*!
 * @brief HW_KPP_KPDR - Keypad Data Register (RW)
 *
 * Reset value: 0x0000U
 *
 * This 16-bit register is used to access the column and row data. Data written
 * to this register is stored in an internal latch, and for each pin configured
 * as an output, the stored data is driven onto the pin. A read of this register
 * returns the value on the pin for those bits configured as inputs. Otherwise,
 * the value read is the value stored in the register. The KPP_KPDR register is
 * byte- or half-word addressable. This register is not initialized by a reset.
 * Valid data should be written to this register before any bits are configured as
 * outputs.
 */
typedef union _hw_kpp_kpdr
{
    uint16_t U;
    struct _hw_kpp_kpdr_bitfields
    {
        uint16_t KRD : 8;              /*!< [7:0]  */
        uint16_t KCD : 8;              /*!< [15:8]  */
    } B;
} hw_kpp_kpdr_t;

/*!
 * @name Constants and macros for entire KPP_KPDR register
 */
/*@{*/
#define HW_KPP_KPDR_ADDR(x)      ((uintptr_t)(x) + 0x6U)

#define HW_KPP_KPDR(x)           (*(__IO hw_kpp_kpdr_t *) HW_KPP_KPDR_ADDR(x))
#define HW_KPP_KPDR_RD(x)        (HW_KPP_KPDR(x).U)
#define HW_KPP_KPDR_WR(x, v)     (HW_KPP_KPDR(x).U = (v))
#define HW_KPP_KPDR_SET(x, v)    (HW_KPP_KPDR_WR(x, HW_KPP_KPDR_RD(x) |  (v)))
#define HW_KPP_KPDR_CLR(x, v)    (HW_KPP_KPDR_WR(x, HW_KPP_KPDR_RD(x) & ~(v)))
#define HW_KPP_KPDR_TOG(x, v)    (HW_KPP_KPDR_WR(x, HW_KPP_KPDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual KPP_KPDR bitfields
 */

/*!
 * @name Register KPP_KPDR, field KRD[7:0] (RW)
 *
 * Keypad Row Data. A read of these bits returns the value on the pin for those
 * bits configured as inputs. Otherwise, the value read is the value stored in
 * the register. 0 Read/Write "0" from/to row ports 1 Read/Write "1" from/to row
 * ports
 */
/*@{*/
#define BP_KPP_KPDR_KRD      (0U)          /*!< Bit position for KPP_KPDR_KRD. */
#define BM_KPP_KPDR_KRD      (0x00FFU)     /*!< Bit mask for KPP_KPDR_KRD. */
#define BS_KPP_KPDR_KRD      (8U)          /*!< Bit field size in bits for KPP_KPDR_KRD. */

/*! @brief Read current value of the KPP_KPDR_KRD field. */
#define BR_KPP_KPDR_KRD(x)   (HW_KPP_KPDR(x).B.KRD)

/*! @brief Format value for bitfield KPP_KPDR_KRD. */
#define BF_KPP_KPDR_KRD(v)   ((uint16_t)((uint16_t)(v) << BP_KPP_KPDR_KRD) & BM_KPP_KPDR_KRD)

/*! @brief Set the KRD field to a new value. */
#define BW_KPP_KPDR_KRD(x, v) (HW_KPP_KPDR_WR(x, (HW_KPP_KPDR_RD(x) & ~BM_KPP_KPDR_KRD) | BF_KPP_KPDR_KRD(v)))
/*@}*/

/*!
 * @name Register KPP_KPDR, field KCD[15:8] (RW)
 *
 * Keypad Column Data. A read of these bits returns the value on the pin for
 * those bits configured as inputs. Otherwise, the value read is the value stored in
 * the register. 0 Read/Write "0" from/to column ports 1 Read/Write "1" from/to
 * column ports
 */
/*@{*/
#define BP_KPP_KPDR_KCD      (8U)          /*!< Bit position for KPP_KPDR_KCD. */
#define BM_KPP_KPDR_KCD      (0xFF00U)     /*!< Bit mask for KPP_KPDR_KCD. */
#define BS_KPP_KPDR_KCD      (8U)          /*!< Bit field size in bits for KPP_KPDR_KCD. */

/*! @brief Read current value of the KPP_KPDR_KCD field. */
#define BR_KPP_KPDR_KCD(x)   (HW_KPP_KPDR(x).B.KCD)

/*! @brief Format value for bitfield KPP_KPDR_KCD. */
#define BF_KPP_KPDR_KCD(v)   ((uint16_t)((uint16_t)(v) << BP_KPP_KPDR_KCD) & BM_KPP_KPDR_KCD)

/*! @brief Set the KCD field to a new value. */
#define BW_KPP_KPDR_KCD(x, v) (HW_KPP_KPDR_WR(x, (HW_KPP_KPDR_RD(x) & ~BM_KPP_KPDR_KCD) | BF_KPP_KPDR_KCD(v)))
/*@}*/

/*******************************************************************************
 * hw_kpp_t - module struct
 ******************************************************************************/
/*!
 * @brief All KPP module registers.
 */
#pragma pack(1)
typedef struct _hw_kpp
{
    __IO hw_kpp_kpcr_t KPCR;               /*!< [0x0] Keypad Control Register */
    __IO hw_kpp_kpsr_t KPSR;               /*!< [0x2] Keypad Status Register */
    __IO hw_kpp_kddr_t KDDR;               /*!< [0x4] Keypad Data Direction Register */
    __IO hw_kpp_kpdr_t KPDR;               /*!< [0x6] Keypad Data Register */
} hw_kpp_t;
#pragma pack()

/*! @brief Macro to access all KPP registers. */
/*! @param x KPP module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_KPP_REGS(KPP_BASE)</code>. */
#define HW_KPP_REGS(x) (*(hw_kpp_t *)(x))

/*
 * iMX6DP LDB
 *
 * LDB
 *
 * Registers defined in this header file:
 * - HW_LDB_CTRL - LDB Control Register
 *
 * - hw_ldb_t - Struct containing all module registers.
 */

#define HW_LDB_INSTANCE_COUNT (1U) /*!< Number of instances of the LDB module. */
#define HW_LDB (0U) /*!< Instance number for LDB. */
#define LDB_BASE              (0x20E0008U) /*!< Base address for LDB. */
/*! Array initializer of LDB base addresses. */
#define LDB_BASE_ADDRS        { LDB_BASE }

/*******************************************************************************
 * HW_LDB_CTRL - LDB Control Register
 ******************************************************************************/

/*!
 * @brief HW_LDB_CTRL - LDB Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The register is implemented in the IOMUX Controller block (IOMUXC), as the
 * register IOMUXC_GPR2.
 */
typedef union _hw_ldb_ctrl
{
    uint32_t U;
    struct _hw_ldb_ctrl_bitfields
    {
        uint32_t ch0_mode : 2;         /*!< [1:0]  */
        uint32_t ch1_mode : 2;         /*!< [3:2]  */
        uint32_t split_mode_en : 1;    /*!< [4]  */
        uint32_t data_width_ch0 : 1;   /*!< [5]  */
        uint32_t bit_mapping_ch0 : 1;  /*!< [6]  */
        uint32_t data_width_ch1 : 1;   /*!< [7]  */
        uint32_t bit_mapping_ch1 : 1;  /*!< [8]  */
        uint32_t di0_vs_polarity : 1;  /*!< [9]  */
        uint32_t di1_vs_polarity : 1;  /*!< [10]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t lvds_clk_shift : 3;   /*!< [18:16]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t counter_reset_val : 2; /*!< [21:20]  */
        uint32_t RESERVED2 : 10;       /*!< [31:22]  */
    } B;
} hw_ldb_ctrl_t;

/*!
 * @name Constants and macros for entire LDB_CTRL register
 */
/*@{*/
#define HW_LDB_CTRL_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_LDB_CTRL(x)           (*(__IO hw_ldb_ctrl_t *) HW_LDB_CTRL_ADDR(x))
#define HW_LDB_CTRL_RD(x)        (HW_LDB_CTRL(x).U)
#define HW_LDB_CTRL_WR(x, v)     (HW_LDB_CTRL(x).U = (v))
#define HW_LDB_CTRL_SET(x, v)    (HW_LDB_CTRL_WR(x, HW_LDB_CTRL_RD(x) |  (v)))
#define HW_LDB_CTRL_CLR(x, v)    (HW_LDB_CTRL_WR(x, HW_LDB_CTRL_RD(x) & ~(v)))
#define HW_LDB_CTRL_TOG(x, v)    (HW_LDB_CTRL_WR(x, HW_LDB_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LDB_CTRL bitfields
 */

/*!
 * @name Register LDB_CTRL, field ch0_mode[1:0] (RW)
 *
 * LVDS channel 0 operation mode
 *
 * Values:
 * - 00 - Channel disabled.
 * - 01 - Channel enabled, routed to DI0
 * - 10 - Channel disabled.
 * - 11 - Channel enabled, routed to DI1.
 */
/*@{*/
#define BP_LDB_CTRL_ch0_mode (0U)          /*!< Bit position for LDB_CTRL_ch0_mode. */
#define BM_LDB_CTRL_ch0_mode (0x00000003U) /*!< Bit mask for LDB_CTRL_ch0_mode. */
#define BS_LDB_CTRL_ch0_mode (2U)          /*!< Bit field size in bits for LDB_CTRL_ch0_mode. */

/*! @brief Read current value of the LDB_CTRL_ch0_mode field. */
#define BR_LDB_CTRL_ch0_mode(x) (HW_LDB_CTRL(x).B.ch0_mode)

/*! @brief Format value for bitfield LDB_CTRL_ch0_mode. */
#define BF_LDB_CTRL_ch0_mode(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_ch0_mode) & BM_LDB_CTRL_ch0_mode)

/*! @brief Set the ch0_mode field to a new value. */
#define BW_LDB_CTRL_ch0_mode(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_ch0_mode) | BF_LDB_CTRL_ch0_mode(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field ch1_mode[3:2] (RW)
 *
 * LVDS channel 1 operation mode
 *
 * Values:
 * - 00 - Channel disabled.
 * - 01 - Channel enabled, routed to DI0
 * - 10 - Channel disabled.
 * - 11 - Channel enabled, routed to DI1.
 */
/*@{*/
#define BP_LDB_CTRL_ch1_mode (2U)          /*!< Bit position for LDB_CTRL_ch1_mode. */
#define BM_LDB_CTRL_ch1_mode (0x0000000CU) /*!< Bit mask for LDB_CTRL_ch1_mode. */
#define BS_LDB_CTRL_ch1_mode (2U)          /*!< Bit field size in bits for LDB_CTRL_ch1_mode. */

/*! @brief Read current value of the LDB_CTRL_ch1_mode field. */
#define BR_LDB_CTRL_ch1_mode(x) (HW_LDB_CTRL(x).B.ch1_mode)

/*! @brief Format value for bitfield LDB_CTRL_ch1_mode. */
#define BF_LDB_CTRL_ch1_mode(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_ch1_mode) & BM_LDB_CTRL_ch1_mode)

/*! @brief Set the ch1_mode field to a new value. */
#define BW_LDB_CTRL_ch1_mode(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_ch1_mode) | BF_LDB_CTRL_ch1_mode(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field split_mode_en[4] (RW)
 *
 * Enable split mode. In this mode both channels should be enabled and working
 * with the same DI (ch0_mode and ch1_mode should both be either '01' or '11')
 *
 * Values:
 * - 0 - Split mode is disabled.
 * - 1 - Split mode is enabled.
 */
/*@{*/
#define BP_LDB_CTRL_split_mode_en (4U)     /*!< Bit position for LDB_CTRL_split_mode_en. */
#define BM_LDB_CTRL_split_mode_en (0x00000010U) /*!< Bit mask for LDB_CTRL_split_mode_en. */
#define BS_LDB_CTRL_split_mode_en (1U)     /*!< Bit field size in bits for LDB_CTRL_split_mode_en. */

/*! @brief Read current value of the LDB_CTRL_split_mode_en field. */
#define BR_LDB_CTRL_split_mode_en(x) (HW_LDB_CTRL(x).B.split_mode_en)

/*! @brief Format value for bitfield LDB_CTRL_split_mode_en. */
#define BF_LDB_CTRL_split_mode_en(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_split_mode_en) & BM_LDB_CTRL_split_mode_en)

/*! @brief Set the split_mode_en field to a new value. */
#define BW_LDB_CTRL_split_mode_en(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_split_mode_en) | BF_LDB_CTRL_split_mode_en(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field data_width_ch0[5] (RW)
 *
 * Data width for LVDS channel 0. This bit must be set when using JEIDA standard
 * (bit_mapping_ch0 is set)
 *
 * Values:
 * - 0 - Data width is 18 bits wide (lvds0_tx3 is not used)
 * - 1 - Data width is 24 bits wide.
 */
/*@{*/
#define BP_LDB_CTRL_data_width_ch0 (5U)    /*!< Bit position for LDB_CTRL_data_width_ch0. */
#define BM_LDB_CTRL_data_width_ch0 (0x00000020U) /*!< Bit mask for LDB_CTRL_data_width_ch0. */
#define BS_LDB_CTRL_data_width_ch0 (1U)    /*!< Bit field size in bits for LDB_CTRL_data_width_ch0. */

/*! @brief Read current value of the LDB_CTRL_data_width_ch0 field. */
#define BR_LDB_CTRL_data_width_ch0(x) (HW_LDB_CTRL(x).B.data_width_ch0)

/*! @brief Format value for bitfield LDB_CTRL_data_width_ch0. */
#define BF_LDB_CTRL_data_width_ch0(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_data_width_ch0) & BM_LDB_CTRL_data_width_ch0)

/*! @brief Set the data_width_ch0 field to a new value. */
#define BW_LDB_CTRL_data_width_ch0(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_data_width_ch0) | BF_LDB_CTRL_data_width_ch0(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field bit_mapping_ch0[6] (RW)
 *
 * Data mapping for LVDS channel 0.
 *
 * Values:
 * - 0 - Use SPWG standard.
 * - 1 - Use JEIDA standard.
 */
/*@{*/
#define BP_LDB_CTRL_bit_mapping_ch0 (6U)   /*!< Bit position for LDB_CTRL_bit_mapping_ch0. */
#define BM_LDB_CTRL_bit_mapping_ch0 (0x00000040U) /*!< Bit mask for LDB_CTRL_bit_mapping_ch0. */
#define BS_LDB_CTRL_bit_mapping_ch0 (1U)   /*!< Bit field size in bits for LDB_CTRL_bit_mapping_ch0. */

/*! @brief Read current value of the LDB_CTRL_bit_mapping_ch0 field. */
#define BR_LDB_CTRL_bit_mapping_ch0(x) (HW_LDB_CTRL(x).B.bit_mapping_ch0)

/*! @brief Format value for bitfield LDB_CTRL_bit_mapping_ch0. */
#define BF_LDB_CTRL_bit_mapping_ch0(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_bit_mapping_ch0) & BM_LDB_CTRL_bit_mapping_ch0)

/*! @brief Set the bit_mapping_ch0 field to a new value. */
#define BW_LDB_CTRL_bit_mapping_ch0(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_bit_mapping_ch0) | BF_LDB_CTRL_bit_mapping_ch0(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field data_width_ch1[7] (RW)
 *
 * Data width for LVDS channel 1. This bit must be set when using JEIDA standard
 * (bit_mapping_ch1 is set)
 *
 * Values:
 * - 0 - Data width is 18 bits wide (lvds1_tx3 is not used)
 * - 1 - Data width is 24 bits wide.
 */
/*@{*/
#define BP_LDB_CTRL_data_width_ch1 (7U)    /*!< Bit position for LDB_CTRL_data_width_ch1. */
#define BM_LDB_CTRL_data_width_ch1 (0x00000080U) /*!< Bit mask for LDB_CTRL_data_width_ch1. */
#define BS_LDB_CTRL_data_width_ch1 (1U)    /*!< Bit field size in bits for LDB_CTRL_data_width_ch1. */

/*! @brief Read current value of the LDB_CTRL_data_width_ch1 field. */
#define BR_LDB_CTRL_data_width_ch1(x) (HW_LDB_CTRL(x).B.data_width_ch1)

/*! @brief Format value for bitfield LDB_CTRL_data_width_ch1. */
#define BF_LDB_CTRL_data_width_ch1(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_data_width_ch1) & BM_LDB_CTRL_data_width_ch1)

/*! @brief Set the data_width_ch1 field to a new value. */
#define BW_LDB_CTRL_data_width_ch1(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_data_width_ch1) | BF_LDB_CTRL_data_width_ch1(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field bit_mapping_ch1[8] (RW)
 *
 * Data mapping for LVDS channel 1.
 *
 * Values:
 * - 0 - Use SPWG standard.
 * - 1 - Use JEIDA standard.
 */
/*@{*/
#define BP_LDB_CTRL_bit_mapping_ch1 (8U)   /*!< Bit position for LDB_CTRL_bit_mapping_ch1. */
#define BM_LDB_CTRL_bit_mapping_ch1 (0x00000100U) /*!< Bit mask for LDB_CTRL_bit_mapping_ch1. */
#define BS_LDB_CTRL_bit_mapping_ch1 (1U)   /*!< Bit field size in bits for LDB_CTRL_bit_mapping_ch1. */

/*! @brief Read current value of the LDB_CTRL_bit_mapping_ch1 field. */
#define BR_LDB_CTRL_bit_mapping_ch1(x) (HW_LDB_CTRL(x).B.bit_mapping_ch1)

/*! @brief Format value for bitfield LDB_CTRL_bit_mapping_ch1. */
#define BF_LDB_CTRL_bit_mapping_ch1(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_bit_mapping_ch1) & BM_LDB_CTRL_bit_mapping_ch1)

/*! @brief Set the bit_mapping_ch1 field to a new value. */
#define BW_LDB_CTRL_bit_mapping_ch1(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_bit_mapping_ch1) | BF_LDB_CTRL_bit_mapping_ch1(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field di0_vs_polarity[9] (RW)
 *
 * Vsync polarity for IPU's DI0 interface.
 *
 * Values:
 * - 0 - ipu_di0_vsync is active high.
 * - 1 - ipu_di0_vsync is active low.
 */
/*@{*/
#define BP_LDB_CTRL_di0_vs_polarity (9U)   /*!< Bit position for LDB_CTRL_di0_vs_polarity. */
#define BM_LDB_CTRL_di0_vs_polarity (0x00000200U) /*!< Bit mask for LDB_CTRL_di0_vs_polarity. */
#define BS_LDB_CTRL_di0_vs_polarity (1U)   /*!< Bit field size in bits for LDB_CTRL_di0_vs_polarity. */

/*! @brief Read current value of the LDB_CTRL_di0_vs_polarity field. */
#define BR_LDB_CTRL_di0_vs_polarity(x) (HW_LDB_CTRL(x).B.di0_vs_polarity)

/*! @brief Format value for bitfield LDB_CTRL_di0_vs_polarity. */
#define BF_LDB_CTRL_di0_vs_polarity(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_di0_vs_polarity) & BM_LDB_CTRL_di0_vs_polarity)

/*! @brief Set the di0_vs_polarity field to a new value. */
#define BW_LDB_CTRL_di0_vs_polarity(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_di0_vs_polarity) | BF_LDB_CTRL_di0_vs_polarity(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field di1_vs_polarity[10] (RW)
 *
 * Vsync polarity for IPU's DI1 interface.
 *
 * Values:
 * - 0 - ipu_di1_vsync is active high.
 * - 1 - ipu_di1_vsync is active low.
 */
/*@{*/
#define BP_LDB_CTRL_di1_vs_polarity (10U)  /*!< Bit position for LDB_CTRL_di1_vs_polarity. */
#define BM_LDB_CTRL_di1_vs_polarity (0x00000400U) /*!< Bit mask for LDB_CTRL_di1_vs_polarity. */
#define BS_LDB_CTRL_di1_vs_polarity (1U)   /*!< Bit field size in bits for LDB_CTRL_di1_vs_polarity. */

/*! @brief Read current value of the LDB_CTRL_di1_vs_polarity field. */
#define BR_LDB_CTRL_di1_vs_polarity(x) (HW_LDB_CTRL(x).B.di1_vs_polarity)

/*! @brief Format value for bitfield LDB_CTRL_di1_vs_polarity. */
#define BF_LDB_CTRL_di1_vs_polarity(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_di1_vs_polarity) & BM_LDB_CTRL_di1_vs_polarity)

/*! @brief Set the di1_vs_polarity field to a new value. */
#define BW_LDB_CTRL_di1_vs_polarity(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_di1_vs_polarity) | BF_LDB_CTRL_di1_vs_polarity(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field lvds_clk_shift[18:16] (RW)
 *
 * Shifts the LVDS output clock in relation to the data. Used for debug purposes
 * only. In normal functional operation must be '000'
 *
 * Values:
 * - 000 - Output clock is '1100011' (normal operation)
 * - 001 - Output clock is '1110001'
 * - 010 - Output clock is '1111000'
 * - 011 - Output clock is '1000111'
 * - 100 - Output clock is '0001111'
 * - 101 - Output clock is '0011111'
 * - 110 - Output clock is '0111100'
 * - 111 - Output clock is '1100011'
 */
/*@{*/
#define BP_LDB_CTRL_lvds_clk_shift (16U)   /*!< Bit position for LDB_CTRL_lvds_clk_shift. */
#define BM_LDB_CTRL_lvds_clk_shift (0x00070000U) /*!< Bit mask for LDB_CTRL_lvds_clk_shift. */
#define BS_LDB_CTRL_lvds_clk_shift (3U)    /*!< Bit field size in bits for LDB_CTRL_lvds_clk_shift. */

/*! @brief Read current value of the LDB_CTRL_lvds_clk_shift field. */
#define BR_LDB_CTRL_lvds_clk_shift(x) (HW_LDB_CTRL(x).B.lvds_clk_shift)

/*! @brief Format value for bitfield LDB_CTRL_lvds_clk_shift. */
#define BF_LDB_CTRL_lvds_clk_shift(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_lvds_clk_shift) & BM_LDB_CTRL_lvds_clk_shift)

/*! @brief Set the lvds_clk_shift field to a new value. */
#define BW_LDB_CTRL_lvds_clk_shift(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_lvds_clk_shift) | BF_LDB_CTRL_lvds_clk_shift(v)))
/*@}*/

/*!
 * @name Register LDB_CTRL, field counter_reset_val[21:20] (RW)
 *
 * Reset value for the LDB counter which determines when the shift registers are
 * loaded with data. Used for debug purposes only. In normal functional
 * operation must be '00'
 *
 * Values:
 * - 00 - Reset value is 5
 * - 01 - Reset value is 3
 * - 10 - Reset value is 4
 * - 11 - Reset value is 6
 */
/*@{*/
#define BP_LDB_CTRL_counter_reset_val (20U) /*!< Bit position for LDB_CTRL_counter_reset_val. */
#define BM_LDB_CTRL_counter_reset_val (0x00300000U) /*!< Bit mask for LDB_CTRL_counter_reset_val. */
#define BS_LDB_CTRL_counter_reset_val (2U) /*!< Bit field size in bits for LDB_CTRL_counter_reset_val. */

/*! @brief Read current value of the LDB_CTRL_counter_reset_val field. */
#define BR_LDB_CTRL_counter_reset_val(x) (HW_LDB_CTRL(x).B.counter_reset_val)

/*! @brief Format value for bitfield LDB_CTRL_counter_reset_val. */
#define BF_LDB_CTRL_counter_reset_val(v) ((uint32_t)((uint32_t)(v) << BP_LDB_CTRL_counter_reset_val) & BM_LDB_CTRL_counter_reset_val)

/*! @brief Set the counter_reset_val field to a new value. */
#define BW_LDB_CTRL_counter_reset_val(x, v) (HW_LDB_CTRL_WR(x, (HW_LDB_CTRL_RD(x) & ~BM_LDB_CTRL_counter_reset_val) | BF_LDB_CTRL_counter_reset_val(v)))
/*@}*/

/*******************************************************************************
 * hw_ldb_t - module struct
 ******************************************************************************/
/*!
 * @brief All LDB module registers.
 */
#pragma pack(1)
typedef struct _hw_ldb
{
    __IO hw_ldb_ctrl_t CTRL;               /*!< [0x0] LDB Control Register */
} hw_ldb_t;
#pragma pack()

/*! @brief Macro to access all LDB registers. */
/*! @param x LDB module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_LDB_REGS(LDB_BASE)</code>. */
#define HW_LDB_REGS(x) (*(hw_ldb_t *)(x))

/*
 * iMX6DP MIPI_CSI
 *
 * MIPI_CSI
 *
 * Registers defined in this header file:
 * - HW_MIPI_CSI_VERSION - Controller Version Identification Register
 * - HW_MIPI_CSI_N_LANES - Number of Active Data Lanes
 * - HW_MIPI_CSI_PHY_SHUTDOWNZ - Phy shutdown control
 * - HW_MIPI_CSI_DPHY_RSTZ - Phy reset control
 * - HW_MIPI_CSI_CSI2_RESETN - CSI2 controller reset
 * - HW_MIPI_CSI_PHY_STATE - General settings for all blocks
 * - HW_MIPI_CSI_DATA_IDS_1 - Data IDs for which IDI reports line boundary matching errors
 * - HW_MIPI_CSI_DATA_IDS_2 - Data IDs for which IDI reports line boundary matching errors
 * - HW_MIPI_CSI_ERR1 - Error state register 1
 * - HW_MIPI_CSI_ERR2 - Error state register 2
 * - HW_MIPI_CSI_MASK1 - Masks for errors 1
 * - HW_MIPI_CSI_MASK2 - Masks for errors 2
 * - HW_MIPI_CSI_PHY_TST_CRTL0 - D-PHY Test interface control 0
 * - HW_MIPI_CSI_PHY_TST_CTRL1 - D-PHY Test interface control 1
 *
 * - hw_mipi_csi_t - Struct containing all module registers.
 */

#define HW_MIPI_CSI_INSTANCE_COUNT (1U) /*!< Number of instances of the MIPI_CSI module. */
#define HW_MIPI_CSI (0U) /*!< Instance number for MIPI_CSI. */
#define MIPI_CSI_BASE         (0x21DC000U) /*!< Base address for MIPI_CSI. */
/*! Array initializer of MIPI_CSI base addresses. */
#define MIPI_CSI_BASE_ADDRS   { MIPI_CSI_BASE }

/*******************************************************************************
 * HW_MIPI_CSI_VERSION - Controller Version Identification Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_VERSION - Controller Version Identification Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_version
{
    uint32_t U;
    struct _hw_mipi_csi_version_bitfields
    {
        uint32_t VERSION : 32;         /*!< [31:0]  */
    } B;
} hw_mipi_csi_version_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_VERSION register
 */
/*@{*/
#define HW_MIPI_CSI_VERSION_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_MIPI_CSI_VERSION(x)   (*(__I hw_mipi_csi_version_t *) HW_MIPI_CSI_VERSION_ADDR(x))
#define HW_MIPI_CSI_VERSION_RD(x) (HW_MIPI_CSI_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_VERSION bitfields
 */

/*!
 * @name Register MIPI_CSI_VERSION, field VERSION[31:0] (RO)
 *
 * Version of the CSI-2 Host Controller Default Value: CSI_VERSION_ID
 */
/*@{*/
#define BP_MIPI_CSI_VERSION_VERSION (0U)   /*!< Bit position for MIPI_CSI_VERSION_VERSION. */
#define BM_MIPI_CSI_VERSION_VERSION (0xFFFFFFFFU) /*!< Bit mask for MIPI_CSI_VERSION_VERSION. */
#define BS_MIPI_CSI_VERSION_VERSION (32U)  /*!< Bit field size in bits for MIPI_CSI_VERSION_VERSION. */

/*! @brief Read current value of the MIPI_CSI_VERSION_VERSION field. */
#define BR_MIPI_CSI_VERSION_VERSION(x) (HW_MIPI_CSI_VERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_N_LANES - Number of Active Data Lanes
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_N_LANES - Number of Active Data Lanes (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_n_lanes
{
    uint32_t U;
    struct _hw_mipi_csi_n_lanes_bitfields
    {
        uint32_t N_LANES : 2;          /*!< [1:0]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_mipi_csi_n_lanes_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_N_LANES register
 */
/*@{*/
#define HW_MIPI_CSI_N_LANES_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_MIPI_CSI_N_LANES(x)   (*(__IO hw_mipi_csi_n_lanes_t *) HW_MIPI_CSI_N_LANES_ADDR(x))
#define HW_MIPI_CSI_N_LANES_RD(x) (HW_MIPI_CSI_N_LANES(x).U)
#define HW_MIPI_CSI_N_LANES_WR(x, v) (HW_MIPI_CSI_N_LANES(x).U = (v))
#define HW_MIPI_CSI_N_LANES_SET(x, v) (HW_MIPI_CSI_N_LANES_WR(x, HW_MIPI_CSI_N_LANES_RD(x) |  (v)))
#define HW_MIPI_CSI_N_LANES_CLR(x, v) (HW_MIPI_CSI_N_LANES_WR(x, HW_MIPI_CSI_N_LANES_RD(x) & ~(v)))
#define HW_MIPI_CSI_N_LANES_TOG(x, v) (HW_MIPI_CSI_N_LANES_WR(x, HW_MIPI_CSI_N_LANES_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_N_LANES bitfields
 */

/*!
 * @name Register MIPI_CSI_N_LANES, field N_LANES[1:0] (RW)
 *
 * Number of Active Data Lanes Can only be updated when the PHY lane is in stop
 * state. Default Value: CSI_N_LANES
 *
 * Values:
 * - 00 - 1 Data Lane (Lane 0)
 * - 01 - 2 Data Lanes (Lane 0, and 1)
 * - 10 - 3 Data Lanes (Lane 0,1 and 2)
 * - 11 - 4 Data Lanes (All)
 */
/*@{*/
#define BP_MIPI_CSI_N_LANES_N_LANES (0U)   /*!< Bit position for MIPI_CSI_N_LANES_N_LANES. */
#define BM_MIPI_CSI_N_LANES_N_LANES (0x00000003U) /*!< Bit mask for MIPI_CSI_N_LANES_N_LANES. */
#define BS_MIPI_CSI_N_LANES_N_LANES (2U)   /*!< Bit field size in bits for MIPI_CSI_N_LANES_N_LANES. */

/*! @brief Read current value of the MIPI_CSI_N_LANES_N_LANES field. */
#define BR_MIPI_CSI_N_LANES_N_LANES(x) (HW_MIPI_CSI_N_LANES(x).B.N_LANES)

/*! @brief Format value for bitfield MIPI_CSI_N_LANES_N_LANES. */
#define BF_MIPI_CSI_N_LANES_N_LANES(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_N_LANES_N_LANES) & BM_MIPI_CSI_N_LANES_N_LANES)

/*! @brief Set the N_LANES field to a new value. */
#define BW_MIPI_CSI_N_LANES_N_LANES(x, v) (HW_MIPI_CSI_N_LANES_WR(x, (HW_MIPI_CSI_N_LANES_RD(x) & ~BM_MIPI_CSI_N_LANES_N_LANES) | BF_MIPI_CSI_N_LANES_N_LANES(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_PHY_SHUTDOWNZ - Phy shutdown control
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_PHY_SHUTDOWNZ - Phy shutdown control (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_phy_shutdownz
{
    uint32_t U;
    struct _hw_mipi_csi_phy_shutdownz_bitfields
    {
        uint32_t PHY_SHUTDOWNZ : 1;    /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_mipi_csi_phy_shutdownz_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_PHY_SHUTDOWNZ register
 */
/*@{*/
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_MIPI_CSI_PHY_SHUTDOWNZ(x) (*(__IO hw_mipi_csi_phy_shutdownz_t *) HW_MIPI_CSI_PHY_SHUTDOWNZ_ADDR(x))
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_RD(x) (HW_MIPI_CSI_PHY_SHUTDOWNZ(x).U)
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_WR(x, v) (HW_MIPI_CSI_PHY_SHUTDOWNZ(x).U = (v))
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_SET(x, v) (HW_MIPI_CSI_PHY_SHUTDOWNZ_WR(x, HW_MIPI_CSI_PHY_SHUTDOWNZ_RD(x) |  (v)))
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_CLR(x, v) (HW_MIPI_CSI_PHY_SHUTDOWNZ_WR(x, HW_MIPI_CSI_PHY_SHUTDOWNZ_RD(x) & ~(v)))
#define HW_MIPI_CSI_PHY_SHUTDOWNZ_TOG(x, v) (HW_MIPI_CSI_PHY_SHUTDOWNZ_WR(x, HW_MIPI_CSI_PHY_SHUTDOWNZ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_PHY_SHUTDOWNZ bitfields
 */

/*!
 * @name Register MIPI_CSI_PHY_SHUTDOWNZ, field PHY_SHUTDOWNZ[0] (RW)
 *
 * Shutdown input. This line is used to place the complete module in power down.
 * All analog blocks are in power down mode and digital logic is cleared. Active
 * Low Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ (0U) /*!< Bit position for MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ. */
#define BM_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ (0x00000001U) /*!< Bit mask for MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ. */
#define BS_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ. */

/*! @brief Read current value of the MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ field. */
#define BR_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ(x) (HW_MIPI_CSI_PHY_SHUTDOWNZ(x).B.PHY_SHUTDOWNZ)

/*! @brief Format value for bitfield MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ. */
#define BF_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ) & BM_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ)

/*! @brief Set the PHY_SHUTDOWNZ field to a new value. */
#define BW_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ(x, v) (HW_MIPI_CSI_PHY_SHUTDOWNZ_WR(x, (HW_MIPI_CSI_PHY_SHUTDOWNZ_RD(x) & ~BM_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ) | BF_MIPI_CSI_PHY_SHUTDOWNZ_PHY_SHUTDOWNZ(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_DPHY_RSTZ - Phy reset control
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_DPHY_RSTZ - Phy reset control (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_dphy_rstz
{
    uint32_t U;
    struct _hw_mipi_csi_dphy_rstz_bitfields
    {
        uint32_t DPHY_RSTZ : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_mipi_csi_dphy_rstz_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_DPHY_RSTZ register
 */
/*@{*/
#define HW_MIPI_CSI_DPHY_RSTZ_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_MIPI_CSI_DPHY_RSTZ(x) (*(__IO hw_mipi_csi_dphy_rstz_t *) HW_MIPI_CSI_DPHY_RSTZ_ADDR(x))
#define HW_MIPI_CSI_DPHY_RSTZ_RD(x) (HW_MIPI_CSI_DPHY_RSTZ(x).U)
#define HW_MIPI_CSI_DPHY_RSTZ_WR(x, v) (HW_MIPI_CSI_DPHY_RSTZ(x).U = (v))
#define HW_MIPI_CSI_DPHY_RSTZ_SET(x, v) (HW_MIPI_CSI_DPHY_RSTZ_WR(x, HW_MIPI_CSI_DPHY_RSTZ_RD(x) |  (v)))
#define HW_MIPI_CSI_DPHY_RSTZ_CLR(x, v) (HW_MIPI_CSI_DPHY_RSTZ_WR(x, HW_MIPI_CSI_DPHY_RSTZ_RD(x) & ~(v)))
#define HW_MIPI_CSI_DPHY_RSTZ_TOG(x, v) (HW_MIPI_CSI_DPHY_RSTZ_WR(x, HW_MIPI_CSI_DPHY_RSTZ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_DPHY_RSTZ bitfields
 */

/*!
 * @name Register MIPI_CSI_DPHY_RSTZ, field DPHY_RSTZ[0] (RW)
 *
 * DPHY reset output. Active Low Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ (0U) /*!< Bit position for MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ. */
#define BM_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ (0x00000001U) /*!< Bit mask for MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ. */
#define BS_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ (1U) /*!< Bit field size in bits for MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ. */

/*! @brief Read current value of the MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ field. */
#define BR_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ(x) (HW_MIPI_CSI_DPHY_RSTZ(x).B.DPHY_RSTZ)

/*! @brief Format value for bitfield MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ. */
#define BF_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ) & BM_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ)

/*! @brief Set the DPHY_RSTZ field to a new value. */
#define BW_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ(x, v) (HW_MIPI_CSI_DPHY_RSTZ_WR(x, (HW_MIPI_CSI_DPHY_RSTZ_RD(x) & ~BM_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ) | BF_MIPI_CSI_DPHY_RSTZ_DPHY_RSTZ(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_CSI2_RESETN - CSI2 controller reset
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_CSI2_RESETN - CSI2 controller reset (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_csi2_resetn
{
    uint32_t U;
    struct _hw_mipi_csi_csi2_resetn_bitfields
    {
        uint32_t CSI2_RESETN : 1;      /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_mipi_csi_csi2_resetn_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_CSI2_RESETN register
 */
/*@{*/
#define HW_MIPI_CSI_CSI2_RESETN_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_MIPI_CSI_CSI2_RESETN(x) (*(__IO hw_mipi_csi_csi2_resetn_t *) HW_MIPI_CSI_CSI2_RESETN_ADDR(x))
#define HW_MIPI_CSI_CSI2_RESETN_RD(x) (HW_MIPI_CSI_CSI2_RESETN(x).U)
#define HW_MIPI_CSI_CSI2_RESETN_WR(x, v) (HW_MIPI_CSI_CSI2_RESETN(x).U = (v))
#define HW_MIPI_CSI_CSI2_RESETN_SET(x, v) (HW_MIPI_CSI_CSI2_RESETN_WR(x, HW_MIPI_CSI_CSI2_RESETN_RD(x) |  (v)))
#define HW_MIPI_CSI_CSI2_RESETN_CLR(x, v) (HW_MIPI_CSI_CSI2_RESETN_WR(x, HW_MIPI_CSI_CSI2_RESETN_RD(x) & ~(v)))
#define HW_MIPI_CSI_CSI2_RESETN_TOG(x, v) (HW_MIPI_CSI_CSI2_RESETN_WR(x, HW_MIPI_CSI_CSI2_RESETN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_CSI2_RESETN bitfields
 */

/*!
 * @name Register MIPI_CSI_CSI2_RESETN, field CSI2_RESETN[0] (RW)
 *
 * CSI-2 controller reset output. Active Low Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_CSI2_RESETN_CSI2_RESETN (0U) /*!< Bit position for MIPI_CSI_CSI2_RESETN_CSI2_RESETN. */
#define BM_MIPI_CSI_CSI2_RESETN_CSI2_RESETN (0x00000001U) /*!< Bit mask for MIPI_CSI_CSI2_RESETN_CSI2_RESETN. */
#define BS_MIPI_CSI_CSI2_RESETN_CSI2_RESETN (1U) /*!< Bit field size in bits for MIPI_CSI_CSI2_RESETN_CSI2_RESETN. */

/*! @brief Read current value of the MIPI_CSI_CSI2_RESETN_CSI2_RESETN field. */
#define BR_MIPI_CSI_CSI2_RESETN_CSI2_RESETN(x) (HW_MIPI_CSI_CSI2_RESETN(x).B.CSI2_RESETN)

/*! @brief Format value for bitfield MIPI_CSI_CSI2_RESETN_CSI2_RESETN. */
#define BF_MIPI_CSI_CSI2_RESETN_CSI2_RESETN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_CSI2_RESETN_CSI2_RESETN) & BM_MIPI_CSI_CSI2_RESETN_CSI2_RESETN)

/*! @brief Set the CSI2_RESETN field to a new value. */
#define BW_MIPI_CSI_CSI2_RESETN_CSI2_RESETN(x, v) (HW_MIPI_CSI_CSI2_RESETN_WR(x, (HW_MIPI_CSI_CSI2_RESETN_RD(x) & ~BM_MIPI_CSI_CSI2_RESETN_CSI2_RESETN) | BF_MIPI_CSI_CSI2_RESETN_CSI2_RESETN(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_PHY_STATE - General settings for all blocks
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_PHY_STATE - General settings for all blocks (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_phy_state
{
    uint32_t U;
    struct _hw_mipi_csi_phy_state_bitfields
    {
        uint32_t phy_rxulpsesc_0 : 1;  /*!< [0]  */
        uint32_t phy_rxulpsesc_1 : 1;  /*!< [1]  */
        uint32_t phy_rxulpsesc_2 : 1;  /*!< [2]  */
        uint32_t phy_rxulpsesc_3 : 1;  /*!< [3]  */
        uint32_t phy_stopstatedata_0 : 1; /*!< [4]  */
        uint32_t phy_stopstatedata_1 : 1; /*!< [5]  */
        uint32_t phy_stopstatedata_2 : 1; /*!< [6]  */
        uint32_t phy_stopstatedata_3 : 1; /*!< [7]  */
        uint32_t phy_rxclkactivehs : 1; /*!< [8]  */
        uint32_t phy_rxulpsclknot : 1; /*!< [9]  */
        uint32_t phy_stopstateclk : 1; /*!< [10]  */
        uint32_t bypass_2ecc_tst : 1;  /*!< [11]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_mipi_csi_phy_state_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_PHY_STATE register
 */
/*@{*/
#define HW_MIPI_CSI_PHY_STATE_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_MIPI_CSI_PHY_STATE(x) (*(__IO hw_mipi_csi_phy_state_t *) HW_MIPI_CSI_PHY_STATE_ADDR(x))
#define HW_MIPI_CSI_PHY_STATE_RD(x) (HW_MIPI_CSI_PHY_STATE(x).U)
#define HW_MIPI_CSI_PHY_STATE_WR(x, v) (HW_MIPI_CSI_PHY_STATE(x).U = (v))
#define HW_MIPI_CSI_PHY_STATE_SET(x, v) (HW_MIPI_CSI_PHY_STATE_WR(x, HW_MIPI_CSI_PHY_STATE_RD(x) |  (v)))
#define HW_MIPI_CSI_PHY_STATE_CLR(x, v) (HW_MIPI_CSI_PHY_STATE_WR(x, HW_MIPI_CSI_PHY_STATE_RD(x) & ~(v)))
#define HW_MIPI_CSI_PHY_STATE_TOG(x, v) (HW_MIPI_CSI_PHY_STATE_WR(x, HW_MIPI_CSI_PHY_STATE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_PHY_STATE bitfields
 */

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxulpsesc_0[0] (RO)
 *
 * Lane module 0 has entered the Ultra Low Power mode Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxulpsesc_0 (0U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxulpsesc_0. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxulpsesc_0 (0x00000001U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxulpsesc_0. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxulpsesc_0 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxulpsesc_0. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxulpsesc_0 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxulpsesc_0(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxulpsesc_0)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxulpsesc_1[1] (RO)
 *
 * Lane module 1 has entered the Ultra Low Power mode Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxulpsesc_1 (1U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxulpsesc_1. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxulpsesc_1 (0x00000002U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxulpsesc_1. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxulpsesc_1 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxulpsesc_1. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxulpsesc_1 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxulpsesc_1(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxulpsesc_1)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxulpsesc_2[2] (RO)
 *
 * Lane module 2 has entered the Ultra Low Power mode Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxulpsesc_2 (2U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxulpsesc_2. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxulpsesc_2 (0x00000004U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxulpsesc_2. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxulpsesc_2 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxulpsesc_2. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxulpsesc_2 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxulpsesc_2(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxulpsesc_2)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxulpsesc_3[3] (RO)
 *
 * Lane module 3 has entered the Ultra Low Power mode Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxulpsesc_3 (3U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxulpsesc_3. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxulpsesc_3 (0x00000008U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxulpsesc_3. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxulpsesc_3 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxulpsesc_3. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxulpsesc_3 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxulpsesc_3(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxulpsesc_3)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_stopstatedata_0[4] (RO)
 *
 * Data Lane 0 in Stop state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_stopstatedata_0 (4U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_stopstatedata_0. */
#define BM_MIPI_CSI_PHY_STATE_phy_stopstatedata_0 (0x00000010U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_stopstatedata_0. */
#define BS_MIPI_CSI_PHY_STATE_phy_stopstatedata_0 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_stopstatedata_0. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_stopstatedata_0 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_stopstatedata_0(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_stopstatedata_0)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_stopstatedata_1[5] (RO)
 *
 * Data Lane 1 in Stop state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_stopstatedata_1 (5U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_stopstatedata_1. */
#define BM_MIPI_CSI_PHY_STATE_phy_stopstatedata_1 (0x00000020U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_stopstatedata_1. */
#define BS_MIPI_CSI_PHY_STATE_phy_stopstatedata_1 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_stopstatedata_1. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_stopstatedata_1 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_stopstatedata_1(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_stopstatedata_1)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_stopstatedata_2[6] (RO)
 *
 * Data Lane 2 in Stop state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_stopstatedata_2 (6U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_stopstatedata_2. */
#define BM_MIPI_CSI_PHY_STATE_phy_stopstatedata_2 (0x00000040U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_stopstatedata_2. */
#define BS_MIPI_CSI_PHY_STATE_phy_stopstatedata_2 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_stopstatedata_2. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_stopstatedata_2 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_stopstatedata_2(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_stopstatedata_2)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_stopstatedata_3[7] (RO)
 *
 * Data Lane 3 in Stop state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_stopstatedata_3 (7U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_stopstatedata_3. */
#define BM_MIPI_CSI_PHY_STATE_phy_stopstatedata_3 (0x00000080U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_stopstatedata_3. */
#define BS_MIPI_CSI_PHY_STATE_phy_stopstatedata_3 (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_stopstatedata_3. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_stopstatedata_3 field. */
#define BR_MIPI_CSI_PHY_STATE_phy_stopstatedata_3(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_stopstatedata_3)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxclkactivehs[8] (RO)
 *
 * Indicates that the clock lane is actively receiving a DDR clock Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxclkactivehs (8U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxclkactivehs. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxclkactivehs (0x00000100U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxclkactivehs. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxclkactivehs (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxclkactivehs. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxclkactivehs field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxclkactivehs(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxclkactivehs)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_rxulpsclknot[9] (RO)
 *
 * Active Low. This signal indicates that the Clock Lane module has entered the
 * Ultra Low Power state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_rxulpsclknot (9U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_rxulpsclknot. */
#define BM_MIPI_CSI_PHY_STATE_phy_rxulpsclknot (0x00000200U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_rxulpsclknot. */
#define BS_MIPI_CSI_PHY_STATE_phy_rxulpsclknot (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_rxulpsclknot. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_rxulpsclknot field. */
#define BR_MIPI_CSI_PHY_STATE_phy_rxulpsclknot(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_rxulpsclknot)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field phy_stopstateclk[10] (RO)
 *
 * Clock Lane in Stop state Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_phy_stopstateclk (10U) /*!< Bit position for MIPI_CSI_PHY_STATE_phy_stopstateclk. */
#define BM_MIPI_CSI_PHY_STATE_phy_stopstateclk (0x00000400U) /*!< Bit mask for MIPI_CSI_PHY_STATE_phy_stopstateclk. */
#define BS_MIPI_CSI_PHY_STATE_phy_stopstateclk (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_phy_stopstateclk. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_phy_stopstateclk field. */
#define BR_MIPI_CSI_PHY_STATE_phy_stopstateclk(x) (HW_MIPI_CSI_PHY_STATE(x).B.phy_stopstateclk)
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_STATE, field bypass_2ecc_tst[11] (RW)
 *
 * Payload Bypass test mode for double ECC errors Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_STATE_bypass_2ecc_tst (11U) /*!< Bit position for MIPI_CSI_PHY_STATE_bypass_2ecc_tst. */
#define BM_MIPI_CSI_PHY_STATE_bypass_2ecc_tst (0x00000800U) /*!< Bit mask for MIPI_CSI_PHY_STATE_bypass_2ecc_tst. */
#define BS_MIPI_CSI_PHY_STATE_bypass_2ecc_tst (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_STATE_bypass_2ecc_tst. */

/*! @brief Read current value of the MIPI_CSI_PHY_STATE_bypass_2ecc_tst field. */
#define BR_MIPI_CSI_PHY_STATE_bypass_2ecc_tst(x) (HW_MIPI_CSI_PHY_STATE(x).B.bypass_2ecc_tst)

/*! @brief Format value for bitfield MIPI_CSI_PHY_STATE_bypass_2ecc_tst. */
#define BF_MIPI_CSI_PHY_STATE_bypass_2ecc_tst(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_STATE_bypass_2ecc_tst) & BM_MIPI_CSI_PHY_STATE_bypass_2ecc_tst)

/*! @brief Set the bypass_2ecc_tst field to a new value. */
#define BW_MIPI_CSI_PHY_STATE_bypass_2ecc_tst(x, v) (HW_MIPI_CSI_PHY_STATE_WR(x, (HW_MIPI_CSI_PHY_STATE_RD(x) & ~BM_MIPI_CSI_PHY_STATE_bypass_2ecc_tst) | BF_MIPI_CSI_PHY_STATE_bypass_2ecc_tst(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_DATA_IDS_1 - Data IDs for which IDI reports line boundary matching errors
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_DATA_IDS_1 - Data IDs for which IDI reports line boundary matching errors (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_data_ids_1
{
    uint32_t U;
    struct _hw_mipi_csi_data_ids_1_bitfields
    {
        uint32_t di0_dt : 6;           /*!< [5:0]  */
        uint32_t di0_vc : 2;           /*!< [7:6]  */
        uint32_t di1_dt : 6;           /*!< [13:8]  */
        uint32_t di1_vc : 2;           /*!< [15:14]  */
        uint32_t di2_dt : 6;           /*!< [21:16]  */
        uint32_t di2_vc : 2;           /*!< [23:22]  */
        uint32_t di3_dt : 6;           /*!< [29:24]  */
        uint32_t di3_vc : 2;           /*!< [31:30]  */
    } B;
} hw_mipi_csi_data_ids_1_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_DATA_IDS_1 register
 */
/*@{*/
#define HW_MIPI_CSI_DATA_IDS_1_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_MIPI_CSI_DATA_IDS_1(x) (*(__IO hw_mipi_csi_data_ids_1_t *) HW_MIPI_CSI_DATA_IDS_1_ADDR(x))
#define HW_MIPI_CSI_DATA_IDS_1_RD(x) (HW_MIPI_CSI_DATA_IDS_1(x).U)
#define HW_MIPI_CSI_DATA_IDS_1_WR(x, v) (HW_MIPI_CSI_DATA_IDS_1(x).U = (v))
#define HW_MIPI_CSI_DATA_IDS_1_SET(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, HW_MIPI_CSI_DATA_IDS_1_RD(x) |  (v)))
#define HW_MIPI_CSI_DATA_IDS_1_CLR(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~(v)))
#define HW_MIPI_CSI_DATA_IDS_1_TOG(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, HW_MIPI_CSI_DATA_IDS_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_DATA_IDS_1 bitfields
 */

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di0_dt[5:0] (RW)
 *
 * Data ID 0 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di0_dt (0U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di0_dt. */
#define BM_MIPI_CSI_DATA_IDS_1_di0_dt (0x0000003FU) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di0_dt. */
#define BS_MIPI_CSI_DATA_IDS_1_di0_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di0_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di0_dt field. */
#define BR_MIPI_CSI_DATA_IDS_1_di0_dt(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di0_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di0_dt. */
#define BF_MIPI_CSI_DATA_IDS_1_di0_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di0_dt) & BM_MIPI_CSI_DATA_IDS_1_di0_dt)

/*! @brief Set the di0_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di0_dt(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di0_dt) | BF_MIPI_CSI_DATA_IDS_1_di0_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di0_vc[7:6] (RW)
 *
 * Data ID 0 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di0_vc (6U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di0_vc. */
#define BM_MIPI_CSI_DATA_IDS_1_di0_vc (0x000000C0U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di0_vc. */
#define BS_MIPI_CSI_DATA_IDS_1_di0_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di0_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di0_vc field. */
#define BR_MIPI_CSI_DATA_IDS_1_di0_vc(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di0_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di0_vc. */
#define BF_MIPI_CSI_DATA_IDS_1_di0_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di0_vc) & BM_MIPI_CSI_DATA_IDS_1_di0_vc)

/*! @brief Set the di0_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di0_vc(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di0_vc) | BF_MIPI_CSI_DATA_IDS_1_di0_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di1_dt[13:8] (RW)
 *
 * Data ID 1 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di1_dt (8U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di1_dt. */
#define BM_MIPI_CSI_DATA_IDS_1_di1_dt (0x00003F00U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di1_dt. */
#define BS_MIPI_CSI_DATA_IDS_1_di1_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di1_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di1_dt field. */
#define BR_MIPI_CSI_DATA_IDS_1_di1_dt(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di1_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di1_dt. */
#define BF_MIPI_CSI_DATA_IDS_1_di1_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di1_dt) & BM_MIPI_CSI_DATA_IDS_1_di1_dt)

/*! @brief Set the di1_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di1_dt(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di1_dt) | BF_MIPI_CSI_DATA_IDS_1_di1_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di1_vc[15:14] (RW)
 *
 * Data ID 1 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di1_vc (14U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di1_vc. */
#define BM_MIPI_CSI_DATA_IDS_1_di1_vc (0x0000C000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di1_vc. */
#define BS_MIPI_CSI_DATA_IDS_1_di1_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di1_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di1_vc field. */
#define BR_MIPI_CSI_DATA_IDS_1_di1_vc(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di1_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di1_vc. */
#define BF_MIPI_CSI_DATA_IDS_1_di1_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di1_vc) & BM_MIPI_CSI_DATA_IDS_1_di1_vc)

/*! @brief Set the di1_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di1_vc(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di1_vc) | BF_MIPI_CSI_DATA_IDS_1_di1_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di2_dt[21:16] (RW)
 *
 * DATA ID 2 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di2_dt (16U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di2_dt. */
#define BM_MIPI_CSI_DATA_IDS_1_di2_dt (0x003F0000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di2_dt. */
#define BS_MIPI_CSI_DATA_IDS_1_di2_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di2_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di2_dt field. */
#define BR_MIPI_CSI_DATA_IDS_1_di2_dt(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di2_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di2_dt. */
#define BF_MIPI_CSI_DATA_IDS_1_di2_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di2_dt) & BM_MIPI_CSI_DATA_IDS_1_di2_dt)

/*! @brief Set the di2_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di2_dt(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di2_dt) | BF_MIPI_CSI_DATA_IDS_1_di2_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di2_vc[23:22] (RW)
 *
 * DATA ID 2 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di2_vc (22U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di2_vc. */
#define BM_MIPI_CSI_DATA_IDS_1_di2_vc (0x00C00000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di2_vc. */
#define BS_MIPI_CSI_DATA_IDS_1_di2_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di2_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di2_vc field. */
#define BR_MIPI_CSI_DATA_IDS_1_di2_vc(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di2_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di2_vc. */
#define BF_MIPI_CSI_DATA_IDS_1_di2_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di2_vc) & BM_MIPI_CSI_DATA_IDS_1_di2_vc)

/*! @brief Set the di2_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di2_vc(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di2_vc) | BF_MIPI_CSI_DATA_IDS_1_di2_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di3_dt[29:24] (RW)
 *
 * Data ID 3 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di3_dt (24U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di3_dt. */
#define BM_MIPI_CSI_DATA_IDS_1_di3_dt (0x3F000000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di3_dt. */
#define BS_MIPI_CSI_DATA_IDS_1_di3_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di3_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di3_dt field. */
#define BR_MIPI_CSI_DATA_IDS_1_di3_dt(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di3_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di3_dt. */
#define BF_MIPI_CSI_DATA_IDS_1_di3_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di3_dt) & BM_MIPI_CSI_DATA_IDS_1_di3_dt)

/*! @brief Set the di3_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di3_dt(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di3_dt) | BF_MIPI_CSI_DATA_IDS_1_di3_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_1, field di3_vc[31:30] (RW)
 *
 * Data ID 3 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_1_di3_vc (30U) /*!< Bit position for MIPI_CSI_DATA_IDS_1_di3_vc. */
#define BM_MIPI_CSI_DATA_IDS_1_di3_vc (0xC0000000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_1_di3_vc. */
#define BS_MIPI_CSI_DATA_IDS_1_di3_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_1_di3_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_1_di3_vc field. */
#define BR_MIPI_CSI_DATA_IDS_1_di3_vc(x) (HW_MIPI_CSI_DATA_IDS_1(x).B.di3_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_1_di3_vc. */
#define BF_MIPI_CSI_DATA_IDS_1_di3_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_1_di3_vc) & BM_MIPI_CSI_DATA_IDS_1_di3_vc)

/*! @brief Set the di3_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_1_di3_vc(x, v) (HW_MIPI_CSI_DATA_IDS_1_WR(x, (HW_MIPI_CSI_DATA_IDS_1_RD(x) & ~BM_MIPI_CSI_DATA_IDS_1_di3_vc) | BF_MIPI_CSI_DATA_IDS_1_di3_vc(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_DATA_IDS_2 - Data IDs for which IDI reports line boundary matching errors
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_DATA_IDS_2 - Data IDs for which IDI reports line boundary matching errors (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_data_ids_2
{
    uint32_t U;
    struct _hw_mipi_csi_data_ids_2_bitfields
    {
        uint32_t di4_dt : 6;           /*!< [5:0]  */
        uint32_t di4_vc : 2;           /*!< [7:6]  */
        uint32_t di5_dt : 6;           /*!< [13:8]  */
        uint32_t di5_vc : 2;           /*!< [15:14]  */
        uint32_t di6_dt : 6;           /*!< [21:16]  */
        uint32_t di6_vc : 2;           /*!< [23:22]  */
        uint32_t di7_dt : 6;           /*!< [29:24]  */
        uint32_t di7_vc : 2;           /*!< [31:30]  */
    } B;
} hw_mipi_csi_data_ids_2_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_DATA_IDS_2 register
 */
/*@{*/
#define HW_MIPI_CSI_DATA_IDS_2_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_MIPI_CSI_DATA_IDS_2(x) (*(__IO hw_mipi_csi_data_ids_2_t *) HW_MIPI_CSI_DATA_IDS_2_ADDR(x))
#define HW_MIPI_CSI_DATA_IDS_2_RD(x) (HW_MIPI_CSI_DATA_IDS_2(x).U)
#define HW_MIPI_CSI_DATA_IDS_2_WR(x, v) (HW_MIPI_CSI_DATA_IDS_2(x).U = (v))
#define HW_MIPI_CSI_DATA_IDS_2_SET(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, HW_MIPI_CSI_DATA_IDS_2_RD(x) |  (v)))
#define HW_MIPI_CSI_DATA_IDS_2_CLR(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~(v)))
#define HW_MIPI_CSI_DATA_IDS_2_TOG(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, HW_MIPI_CSI_DATA_IDS_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_DATA_IDS_2 bitfields
 */

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di4_dt[5:0] (RW)
 *
 * Data ID 4 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di4_dt (0U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di4_dt. */
#define BM_MIPI_CSI_DATA_IDS_2_di4_dt (0x0000003FU) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di4_dt. */
#define BS_MIPI_CSI_DATA_IDS_2_di4_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di4_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di4_dt field. */
#define BR_MIPI_CSI_DATA_IDS_2_di4_dt(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di4_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di4_dt. */
#define BF_MIPI_CSI_DATA_IDS_2_di4_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di4_dt) & BM_MIPI_CSI_DATA_IDS_2_di4_dt)

/*! @brief Set the di4_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di4_dt(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di4_dt) | BF_MIPI_CSI_DATA_IDS_2_di4_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di4_vc[7:6] (RW)
 *
 * Data ID 4 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di4_vc (6U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di4_vc. */
#define BM_MIPI_CSI_DATA_IDS_2_di4_vc (0x000000C0U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di4_vc. */
#define BS_MIPI_CSI_DATA_IDS_2_di4_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di4_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di4_vc field. */
#define BR_MIPI_CSI_DATA_IDS_2_di4_vc(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di4_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di4_vc. */
#define BF_MIPI_CSI_DATA_IDS_2_di4_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di4_vc) & BM_MIPI_CSI_DATA_IDS_2_di4_vc)

/*! @brief Set the di4_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di4_vc(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di4_vc) | BF_MIPI_CSI_DATA_IDS_2_di4_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di5_dt[13:8] (RW)
 *
 * Data ID 5 Data Type D efault Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di5_dt (8U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di5_dt. */
#define BM_MIPI_CSI_DATA_IDS_2_di5_dt (0x00003F00U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di5_dt. */
#define BS_MIPI_CSI_DATA_IDS_2_di5_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di5_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di5_dt field. */
#define BR_MIPI_CSI_DATA_IDS_2_di5_dt(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di5_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di5_dt. */
#define BF_MIPI_CSI_DATA_IDS_2_di5_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di5_dt) & BM_MIPI_CSI_DATA_IDS_2_di5_dt)

/*! @brief Set the di5_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di5_dt(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di5_dt) | BF_MIPI_CSI_DATA_IDS_2_di5_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di5_vc[15:14] (RW)
 *
 * Data ID 5 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di5_vc (14U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di5_vc. */
#define BM_MIPI_CSI_DATA_IDS_2_di5_vc (0x0000C000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di5_vc. */
#define BS_MIPI_CSI_DATA_IDS_2_di5_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di5_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di5_vc field. */
#define BR_MIPI_CSI_DATA_IDS_2_di5_vc(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di5_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di5_vc. */
#define BF_MIPI_CSI_DATA_IDS_2_di5_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di5_vc) & BM_MIPI_CSI_DATA_IDS_2_di5_vc)

/*! @brief Set the di5_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di5_vc(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di5_vc) | BF_MIPI_CSI_DATA_IDS_2_di5_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di6_dt[21:16] (RW)
 *
 * Data ID 6 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di6_dt (16U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di6_dt. */
#define BM_MIPI_CSI_DATA_IDS_2_di6_dt (0x003F0000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di6_dt. */
#define BS_MIPI_CSI_DATA_IDS_2_di6_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di6_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di6_dt field. */
#define BR_MIPI_CSI_DATA_IDS_2_di6_dt(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di6_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di6_dt. */
#define BF_MIPI_CSI_DATA_IDS_2_di6_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di6_dt) & BM_MIPI_CSI_DATA_IDS_2_di6_dt)

/*! @brief Set the di6_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di6_dt(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di6_dt) | BF_MIPI_CSI_DATA_IDS_2_di6_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di6_vc[23:22] (RW)
 *
 * Data ID 6 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di6_vc (22U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di6_vc. */
#define BM_MIPI_CSI_DATA_IDS_2_di6_vc (0x00C00000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di6_vc. */
#define BS_MIPI_CSI_DATA_IDS_2_di6_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di6_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di6_vc field. */
#define BR_MIPI_CSI_DATA_IDS_2_di6_vc(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di6_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di6_vc. */
#define BF_MIPI_CSI_DATA_IDS_2_di6_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di6_vc) & BM_MIPI_CSI_DATA_IDS_2_di6_vc)

/*! @brief Set the di6_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di6_vc(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di6_vc) | BF_MIPI_CSI_DATA_IDS_2_di6_vc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di7_dt[29:24] (RW)
 *
 * Data ID 7 Data Type Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di7_dt (24U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di7_dt. */
#define BM_MIPI_CSI_DATA_IDS_2_di7_dt (0x3F000000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di7_dt. */
#define BS_MIPI_CSI_DATA_IDS_2_di7_dt (6U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di7_dt. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di7_dt field. */
#define BR_MIPI_CSI_DATA_IDS_2_di7_dt(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di7_dt)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di7_dt. */
#define BF_MIPI_CSI_DATA_IDS_2_di7_dt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di7_dt) & BM_MIPI_CSI_DATA_IDS_2_di7_dt)

/*! @brief Set the di7_dt field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di7_dt(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di7_dt) | BF_MIPI_CSI_DATA_IDS_2_di7_dt(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_DATA_IDS_2, field di7_vc[31:30] (RW)
 *
 * Data ID 7 Virtual channel Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_DATA_IDS_2_di7_vc (30U) /*!< Bit position for MIPI_CSI_DATA_IDS_2_di7_vc. */
#define BM_MIPI_CSI_DATA_IDS_2_di7_vc (0xC0000000U) /*!< Bit mask for MIPI_CSI_DATA_IDS_2_di7_vc. */
#define BS_MIPI_CSI_DATA_IDS_2_di7_vc (2U) /*!< Bit field size in bits for MIPI_CSI_DATA_IDS_2_di7_vc. */

/*! @brief Read current value of the MIPI_CSI_DATA_IDS_2_di7_vc field. */
#define BR_MIPI_CSI_DATA_IDS_2_di7_vc(x) (HW_MIPI_CSI_DATA_IDS_2(x).B.di7_vc)

/*! @brief Format value for bitfield MIPI_CSI_DATA_IDS_2_di7_vc. */
#define BF_MIPI_CSI_DATA_IDS_2_di7_vc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_DATA_IDS_2_di7_vc) & BM_MIPI_CSI_DATA_IDS_2_di7_vc)

/*! @brief Set the di7_vc field to a new value. */
#define BW_MIPI_CSI_DATA_IDS_2_di7_vc(x, v) (HW_MIPI_CSI_DATA_IDS_2_WR(x, (HW_MIPI_CSI_DATA_IDS_2_RD(x) & ~BM_MIPI_CSI_DATA_IDS_2_di7_vc) | BF_MIPI_CSI_DATA_IDS_2_di7_vc(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_ERR1 - Error state register 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_ERR1 - Error state register 1 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_err1
{
    uint32_t U;
    struct _hw_mipi_csi_err1_bitfields
    {
        uint32_t phy_errsotsynchs_0 : 1; /*!< [0]  */
        uint32_t phy_errsotsynchs_1 : 1; /*!< [1]  */
        uint32_t phy_errsotsynchs_2 : 1; /*!< [2]  */
        uint32_t phy_errsotsynchs_3 : 1; /*!< [3]  */
        uint32_t err_f_bndry_match_vc0 : 1; /*!< [4]  */
        uint32_t err_f_bndry_match_vc1 : 1; /*!< [5]  */
        uint32_t err_f_bndry_match_vc2 : 1; /*!< [6]  */
        uint32_t err_f_bndry_match_vc3 : 1; /*!< [7]  */
        uint32_t err_f_seq_vc0 : 1;    /*!< [8]  */
        uint32_t err_f_seq_vc1 : 1;    /*!< [9]  */
        uint32_t err_f_seq_vc2 : 1;    /*!< [10]  */
        uint32_t err_f_seq_vc3 : 1;    /*!< [11]  */
        uint32_t err_frame_data_vc0 : 1; /*!< [12]  */
        uint32_t err_frame_data_vc1 : 1; /*!< [13]  */
        uint32_t err_frame_data_vc2 : 1; /*!< [14]  */
        uint32_t err_frame_data_vc3 : 1; /*!< [15]  */
        uint32_t err_l_bndry_match_di0 : 1; /*!< [16]  */
        uint32_t err_l_bndry_match_di1 : 1; /*!< [17]  */
        uint32_t err_l_bndry_match_di2 : 1; /*!< [18]  */
        uint32_t err_l_bndry_match_di3 : 1; /*!< [19]  */
        uint32_t err_l_seq_di0 : 1;    /*!< [20]  */
        uint32_t err_l_seq_di1 : 1;    /*!< [21]  */
        uint32_t err_l_seq_di2 : 1;    /*!< [22]  */
        uint32_t err_l_seq_di3 : 1;    /*!< [23]  */
        uint32_t vc0_err_crc : 1;      /*!< [24]  */
        uint32_t vc1_err_crc : 1;      /*!< [25]  */
        uint32_t vc2_err_crc : 1;      /*!< [26]  */
        uint32_t vc3_err_crc : 1;      /*!< [27]  */
        uint32_t err_ecc_double : 1;   /*!< [28]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_mipi_csi_err1_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_ERR1 register
 */
/*@{*/
#define HW_MIPI_CSI_ERR1_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_MIPI_CSI_ERR1(x)      (*(__I hw_mipi_csi_err1_t *) HW_MIPI_CSI_ERR1_ADDR(x))
#define HW_MIPI_CSI_ERR1_RD(x)   (HW_MIPI_CSI_ERR1(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_ERR1 bitfields
 */

/*!
 * @name Register MIPI_CSI_ERR1, field phy_errsotsynchs_0[0] (RO)
 *
 * Start of Transmission Error on data lane 0 (no synchronization achieved)
 * Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_phy_errsotsynchs_0 (0U) /*!< Bit position for MIPI_CSI_ERR1_phy_errsotsynchs_0. */
#define BM_MIPI_CSI_ERR1_phy_errsotsynchs_0 (0x00000001U) /*!< Bit mask for MIPI_CSI_ERR1_phy_errsotsynchs_0. */
#define BS_MIPI_CSI_ERR1_phy_errsotsynchs_0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_phy_errsotsynchs_0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_phy_errsotsynchs_0 field. */
#define BR_MIPI_CSI_ERR1_phy_errsotsynchs_0(x) (HW_MIPI_CSI_ERR1(x).B.phy_errsotsynchs_0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field phy_errsotsynchs_1[1] (RO)
 *
 * Start of Transmission Error on data lane 1 (no synchronization achieved)
 * Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_phy_errsotsynchs_1 (1U) /*!< Bit position for MIPI_CSI_ERR1_phy_errsotsynchs_1. */
#define BM_MIPI_CSI_ERR1_phy_errsotsynchs_1 (0x00000002U) /*!< Bit mask for MIPI_CSI_ERR1_phy_errsotsynchs_1. */
#define BS_MIPI_CSI_ERR1_phy_errsotsynchs_1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_phy_errsotsynchs_1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_phy_errsotsynchs_1 field. */
#define BR_MIPI_CSI_ERR1_phy_errsotsynchs_1(x) (HW_MIPI_CSI_ERR1(x).B.phy_errsotsynchs_1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field phy_errsotsynchs_2[2] (RO)
 *
 * Start of Transmission Error on data lane 2 (no synchronization achieved)
 * Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_phy_errsotsynchs_2 (2U) /*!< Bit position for MIPI_CSI_ERR1_phy_errsotsynchs_2. */
#define BM_MIPI_CSI_ERR1_phy_errsotsynchs_2 (0x00000004U) /*!< Bit mask for MIPI_CSI_ERR1_phy_errsotsynchs_2. */
#define BS_MIPI_CSI_ERR1_phy_errsotsynchs_2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_phy_errsotsynchs_2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_phy_errsotsynchs_2 field. */
#define BR_MIPI_CSI_ERR1_phy_errsotsynchs_2(x) (HW_MIPI_CSI_ERR1(x).B.phy_errsotsynchs_2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field phy_errsotsynchs_3[3] (RO)
 *
 * Start of Transmission Error on data lane 3 (no synchronization achieved)
 * Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_phy_errsotsynchs_3 (3U) /*!< Bit position for MIPI_CSI_ERR1_phy_errsotsynchs_3. */
#define BM_MIPI_CSI_ERR1_phy_errsotsynchs_3 (0x00000008U) /*!< Bit mask for MIPI_CSI_ERR1_phy_errsotsynchs_3. */
#define BS_MIPI_CSI_ERR1_phy_errsotsynchs_3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_phy_errsotsynchs_3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_phy_errsotsynchs_3 field. */
#define BR_MIPI_CSI_ERR1_phy_errsotsynchs_3(x) (HW_MIPI_CSI_ERR1(x).B.phy_errsotsynchs_3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_bndry_match_vc0[4] (RO)
 *
 * Error matching Frame Start with Frame End for Virtual Channel 0 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_bndry_match_vc0 (4U) /*!< Bit position for MIPI_CSI_ERR1_err_f_bndry_match_vc0. */
#define BM_MIPI_CSI_ERR1_err_f_bndry_match_vc0 (0x00000010U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_bndry_match_vc0. */
#define BS_MIPI_CSI_ERR1_err_f_bndry_match_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_bndry_match_vc0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_bndry_match_vc0 field. */
#define BR_MIPI_CSI_ERR1_err_f_bndry_match_vc0(x) (HW_MIPI_CSI_ERR1(x).B.err_f_bndry_match_vc0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_bndry_match_vc1[5] (RO)
 *
 * Error matching Frame Start with Frame End for Virtual Channel 1 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_bndry_match_vc1 (5U) /*!< Bit position for MIPI_CSI_ERR1_err_f_bndry_match_vc1. */
#define BM_MIPI_CSI_ERR1_err_f_bndry_match_vc1 (0x00000020U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_bndry_match_vc1. */
#define BS_MIPI_CSI_ERR1_err_f_bndry_match_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_bndry_match_vc1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_bndry_match_vc1 field. */
#define BR_MIPI_CSI_ERR1_err_f_bndry_match_vc1(x) (HW_MIPI_CSI_ERR1(x).B.err_f_bndry_match_vc1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_bndry_match_vc2[6] (RO)
 *
 * Error matching Frame Start with Frame End for Virtual Channel 2 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_bndry_match_vc2 (6U) /*!< Bit position for MIPI_CSI_ERR1_err_f_bndry_match_vc2. */
#define BM_MIPI_CSI_ERR1_err_f_bndry_match_vc2 (0x00000040U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_bndry_match_vc2. */
#define BS_MIPI_CSI_ERR1_err_f_bndry_match_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_bndry_match_vc2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_bndry_match_vc2 field. */
#define BR_MIPI_CSI_ERR1_err_f_bndry_match_vc2(x) (HW_MIPI_CSI_ERR1(x).B.err_f_bndry_match_vc2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_bndry_match_vc3[7] (RO)
 *
 * Error matching Frame Start with Frame End for Virtual Channel 3 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_bndry_match_vc3 (7U) /*!< Bit position for MIPI_CSI_ERR1_err_f_bndry_match_vc3. */
#define BM_MIPI_CSI_ERR1_err_f_bndry_match_vc3 (0x00000080U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_bndry_match_vc3. */
#define BS_MIPI_CSI_ERR1_err_f_bndry_match_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_bndry_match_vc3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_bndry_match_vc3 field. */
#define BR_MIPI_CSI_ERR1_err_f_bndry_match_vc3(x) (HW_MIPI_CSI_ERR1(x).B.err_f_bndry_match_vc3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_seq_vc0[8] (RO)
 *
 * Incorrect Frame Sequence detected in Virtual Channel 0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_seq_vc0 (8U) /*!< Bit position for MIPI_CSI_ERR1_err_f_seq_vc0. */
#define BM_MIPI_CSI_ERR1_err_f_seq_vc0 (0x00000100U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_seq_vc0. */
#define BS_MIPI_CSI_ERR1_err_f_seq_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_seq_vc0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_seq_vc0 field. */
#define BR_MIPI_CSI_ERR1_err_f_seq_vc0(x) (HW_MIPI_CSI_ERR1(x).B.err_f_seq_vc0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_seq_vc1[9] (RO)
 *
 * Incorrect Frame Sequence detected in Virtual Channel 1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_seq_vc1 (9U) /*!< Bit position for MIPI_CSI_ERR1_err_f_seq_vc1. */
#define BM_MIPI_CSI_ERR1_err_f_seq_vc1 (0x00000200U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_seq_vc1. */
#define BS_MIPI_CSI_ERR1_err_f_seq_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_seq_vc1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_seq_vc1 field. */
#define BR_MIPI_CSI_ERR1_err_f_seq_vc1(x) (HW_MIPI_CSI_ERR1(x).B.err_f_seq_vc1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_seq_vc2[10] (RO)
 *
 * Incorrect Frame Sequence detected in Virtual Channel 2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_seq_vc2 (10U) /*!< Bit position for MIPI_CSI_ERR1_err_f_seq_vc2. */
#define BM_MIPI_CSI_ERR1_err_f_seq_vc2 (0x00000400U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_seq_vc2. */
#define BS_MIPI_CSI_ERR1_err_f_seq_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_seq_vc2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_seq_vc2 field. */
#define BR_MIPI_CSI_ERR1_err_f_seq_vc2(x) (HW_MIPI_CSI_ERR1(x).B.err_f_seq_vc2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_f_seq_vc3[11] (RO)
 *
 * Incorrect Frame Sequence detected in Virtual Channel 3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_f_seq_vc3 (11U) /*!< Bit position for MIPI_CSI_ERR1_err_f_seq_vc3. */
#define BM_MIPI_CSI_ERR1_err_f_seq_vc3 (0x00000800U) /*!< Bit mask for MIPI_CSI_ERR1_err_f_seq_vc3. */
#define BS_MIPI_CSI_ERR1_err_f_seq_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_f_seq_vc3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_f_seq_vc3 field. */
#define BR_MIPI_CSI_ERR1_err_f_seq_vc3(x) (HW_MIPI_CSI_ERR1(x).B.err_f_seq_vc3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_frame_data_vc0[12] (RO)
 *
 * Last received frame, in Virtual Channel 0, had at least one CRC error Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_frame_data_vc0 (12U) /*!< Bit position for MIPI_CSI_ERR1_err_frame_data_vc0. */
#define BM_MIPI_CSI_ERR1_err_frame_data_vc0 (0x00001000U) /*!< Bit mask for MIPI_CSI_ERR1_err_frame_data_vc0. */
#define BS_MIPI_CSI_ERR1_err_frame_data_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_frame_data_vc0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_frame_data_vc0 field. */
#define BR_MIPI_CSI_ERR1_err_frame_data_vc0(x) (HW_MIPI_CSI_ERR1(x).B.err_frame_data_vc0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_frame_data_vc1[13] (RO)
 *
 * Last received frame, in Virtual Channel 1, had at least one CRC error Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_frame_data_vc1 (13U) /*!< Bit position for MIPI_CSI_ERR1_err_frame_data_vc1. */
#define BM_MIPI_CSI_ERR1_err_frame_data_vc1 (0x00002000U) /*!< Bit mask for MIPI_CSI_ERR1_err_frame_data_vc1. */
#define BS_MIPI_CSI_ERR1_err_frame_data_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_frame_data_vc1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_frame_data_vc1 field. */
#define BR_MIPI_CSI_ERR1_err_frame_data_vc1(x) (HW_MIPI_CSI_ERR1(x).B.err_frame_data_vc1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_frame_data_vc2[14] (RO)
 *
 * Last received frame, in Virtual Channel 2, had at least one CRC error Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_frame_data_vc2 (14U) /*!< Bit position for MIPI_CSI_ERR1_err_frame_data_vc2. */
#define BM_MIPI_CSI_ERR1_err_frame_data_vc2 (0x00004000U) /*!< Bit mask for MIPI_CSI_ERR1_err_frame_data_vc2. */
#define BS_MIPI_CSI_ERR1_err_frame_data_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_frame_data_vc2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_frame_data_vc2 field. */
#define BR_MIPI_CSI_ERR1_err_frame_data_vc2(x) (HW_MIPI_CSI_ERR1(x).B.err_frame_data_vc2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_frame_data_vc3[15] (RO)
 *
 * Last received frame, in Virtual Channel 3, had at least one CRC error Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_frame_data_vc3 (15U) /*!< Bit position for MIPI_CSI_ERR1_err_frame_data_vc3. */
#define BM_MIPI_CSI_ERR1_err_frame_data_vc3 (0x00008000U) /*!< Bit mask for MIPI_CSI_ERR1_err_frame_data_vc3. */
#define BS_MIPI_CSI_ERR1_err_frame_data_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_frame_data_vc3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_frame_data_vc3 field. */
#define BR_MIPI_CSI_ERR1_err_frame_data_vc3(x) (HW_MIPI_CSI_ERR1(x).B.err_frame_data_vc3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_bndry_match_di0[16] (RO)
 *
 * Error matching Line Start with Line End for vc0 and dt0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_bndry_match_di0 (16U) /*!< Bit position for MIPI_CSI_ERR1_err_l_bndry_match_di0. */
#define BM_MIPI_CSI_ERR1_err_l_bndry_match_di0 (0x00010000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_bndry_match_di0. */
#define BS_MIPI_CSI_ERR1_err_l_bndry_match_di0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_bndry_match_di0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_bndry_match_di0 field. */
#define BR_MIPI_CSI_ERR1_err_l_bndry_match_di0(x) (HW_MIPI_CSI_ERR1(x).B.err_l_bndry_match_di0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_bndry_match_di1[17] (RO)
 *
 * Error matching Line Start with Line End for vc1 and dt1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_bndry_match_di1 (17U) /*!< Bit position for MIPI_CSI_ERR1_err_l_bndry_match_di1. */
#define BM_MIPI_CSI_ERR1_err_l_bndry_match_di1 (0x00020000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_bndry_match_di1. */
#define BS_MIPI_CSI_ERR1_err_l_bndry_match_di1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_bndry_match_di1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_bndry_match_di1 field. */
#define BR_MIPI_CSI_ERR1_err_l_bndry_match_di1(x) (HW_MIPI_CSI_ERR1(x).B.err_l_bndry_match_di1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_bndry_match_di2[18] (RO)
 *
 * Error matching Line Start with Line End for vc2 and dt2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_bndry_match_di2 (18U) /*!< Bit position for MIPI_CSI_ERR1_err_l_bndry_match_di2. */
#define BM_MIPI_CSI_ERR1_err_l_bndry_match_di2 (0x00040000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_bndry_match_di2. */
#define BS_MIPI_CSI_ERR1_err_l_bndry_match_di2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_bndry_match_di2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_bndry_match_di2 field. */
#define BR_MIPI_CSI_ERR1_err_l_bndry_match_di2(x) (HW_MIPI_CSI_ERR1(x).B.err_l_bndry_match_di2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_bndry_match_di3[19] (RO)
 *
 * Error matching Line Start with Line End for vc3 and dt3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_bndry_match_di3 (19U) /*!< Bit position for MIPI_CSI_ERR1_err_l_bndry_match_di3. */
#define BM_MIPI_CSI_ERR1_err_l_bndry_match_di3 (0x00080000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_bndry_match_di3. */
#define BS_MIPI_CSI_ERR1_err_l_bndry_match_di3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_bndry_match_di3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_bndry_match_di3 field. */
#define BR_MIPI_CSI_ERR1_err_l_bndry_match_di3(x) (HW_MIPI_CSI_ERR1(x).B.err_l_bndry_match_di3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_seq_di0[20] (RO)
 *
 * Error in the sequence of lines for vc0 and dt0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_seq_di0 (20U) /*!< Bit position for MIPI_CSI_ERR1_err_l_seq_di0. */
#define BM_MIPI_CSI_ERR1_err_l_seq_di0 (0x00100000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_seq_di0. */
#define BS_MIPI_CSI_ERR1_err_l_seq_di0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_seq_di0. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_seq_di0 field. */
#define BR_MIPI_CSI_ERR1_err_l_seq_di0(x) (HW_MIPI_CSI_ERR1(x).B.err_l_seq_di0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_seq_di1[21] (RO)
 *
 * Error in the sequence of lines for vc1 and dt1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_seq_di1 (21U) /*!< Bit position for MIPI_CSI_ERR1_err_l_seq_di1. */
#define BM_MIPI_CSI_ERR1_err_l_seq_di1 (0x00200000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_seq_di1. */
#define BS_MIPI_CSI_ERR1_err_l_seq_di1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_seq_di1. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_seq_di1 field. */
#define BR_MIPI_CSI_ERR1_err_l_seq_di1(x) (HW_MIPI_CSI_ERR1(x).B.err_l_seq_di1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_seq_di2[22] (RO)
 *
 * Error in the sequence of lines for vc2 and dt2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_seq_di2 (22U) /*!< Bit position for MIPI_CSI_ERR1_err_l_seq_di2. */
#define BM_MIPI_CSI_ERR1_err_l_seq_di2 (0x00400000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_seq_di2. */
#define BS_MIPI_CSI_ERR1_err_l_seq_di2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_seq_di2. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_seq_di2 field. */
#define BR_MIPI_CSI_ERR1_err_l_seq_di2(x) (HW_MIPI_CSI_ERR1(x).B.err_l_seq_di2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_l_seq_di3[23] (RO)
 *
 * Error in the sequence of lines for vc3 and dt3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_l_seq_di3 (23U) /*!< Bit position for MIPI_CSI_ERR1_err_l_seq_di3. */
#define BM_MIPI_CSI_ERR1_err_l_seq_di3 (0x00800000U) /*!< Bit mask for MIPI_CSI_ERR1_err_l_seq_di3. */
#define BS_MIPI_CSI_ERR1_err_l_seq_di3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_l_seq_di3. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_l_seq_di3 field. */
#define BR_MIPI_CSI_ERR1_err_l_seq_di3(x) (HW_MIPI_CSI_ERR1(x).B.err_l_seq_di3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field vc0_err_crc[24] (RO)
 *
 * Checksum Error detected on Virtual Channel 0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_vc0_err_crc (24U) /*!< Bit position for MIPI_CSI_ERR1_vc0_err_crc. */
#define BM_MIPI_CSI_ERR1_vc0_err_crc (0x01000000U) /*!< Bit mask for MIPI_CSI_ERR1_vc0_err_crc. */
#define BS_MIPI_CSI_ERR1_vc0_err_crc (1U)  /*!< Bit field size in bits for MIPI_CSI_ERR1_vc0_err_crc. */

/*! @brief Read current value of the MIPI_CSI_ERR1_vc0_err_crc field. */
#define BR_MIPI_CSI_ERR1_vc0_err_crc(x) (HW_MIPI_CSI_ERR1(x).B.vc0_err_crc)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field vc1_err_crc[25] (RO)
 *
 * Checksum Error detected on Virtual Channel 1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_vc1_err_crc (25U) /*!< Bit position for MIPI_CSI_ERR1_vc1_err_crc. */
#define BM_MIPI_CSI_ERR1_vc1_err_crc (0x02000000U) /*!< Bit mask for MIPI_CSI_ERR1_vc1_err_crc. */
#define BS_MIPI_CSI_ERR1_vc1_err_crc (1U)  /*!< Bit field size in bits for MIPI_CSI_ERR1_vc1_err_crc. */

/*! @brief Read current value of the MIPI_CSI_ERR1_vc1_err_crc field. */
#define BR_MIPI_CSI_ERR1_vc1_err_crc(x) (HW_MIPI_CSI_ERR1(x).B.vc1_err_crc)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field vc2_err_crc[26] (RO)
 *
 * Checksum Error detected on Virtual Channel 2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_vc2_err_crc (26U) /*!< Bit position for MIPI_CSI_ERR1_vc2_err_crc. */
#define BM_MIPI_CSI_ERR1_vc2_err_crc (0x04000000U) /*!< Bit mask for MIPI_CSI_ERR1_vc2_err_crc. */
#define BS_MIPI_CSI_ERR1_vc2_err_crc (1U)  /*!< Bit field size in bits for MIPI_CSI_ERR1_vc2_err_crc. */

/*! @brief Read current value of the MIPI_CSI_ERR1_vc2_err_crc field. */
#define BR_MIPI_CSI_ERR1_vc2_err_crc(x) (HW_MIPI_CSI_ERR1(x).B.vc2_err_crc)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field vc3_err_crc[27] (RO)
 *
 * Checksum Error detected on Virtual Channel 3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_vc3_err_crc (27U) /*!< Bit position for MIPI_CSI_ERR1_vc3_err_crc. */
#define BM_MIPI_CSI_ERR1_vc3_err_crc (0x08000000U) /*!< Bit mask for MIPI_CSI_ERR1_vc3_err_crc. */
#define BS_MIPI_CSI_ERR1_vc3_err_crc (1U)  /*!< Bit field size in bits for MIPI_CSI_ERR1_vc3_err_crc. */

/*! @brief Read current value of the MIPI_CSI_ERR1_vc3_err_crc field. */
#define BR_MIPI_CSI_ERR1_vc3_err_crc(x) (HW_MIPI_CSI_ERR1(x).B.vc3_err_crc)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR1, field err_ecc_double[28] (RO)
 *
 * Header ECC contains 2 errors. Unrecoverable. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR1_err_ecc_double (28U) /*!< Bit position for MIPI_CSI_ERR1_err_ecc_double. */
#define BM_MIPI_CSI_ERR1_err_ecc_double (0x10000000U) /*!< Bit mask for MIPI_CSI_ERR1_err_ecc_double. */
#define BS_MIPI_CSI_ERR1_err_ecc_double (1U) /*!< Bit field size in bits for MIPI_CSI_ERR1_err_ecc_double. */

/*! @brief Read current value of the MIPI_CSI_ERR1_err_ecc_double field. */
#define BR_MIPI_CSI_ERR1_err_ecc_double(x) (HW_MIPI_CSI_ERR1(x).B.err_ecc_double)
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_ERR2 - Error state register 2
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_ERR2 - Error state register 2 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_err2
{
    uint32_t U;
    struct _hw_mipi_csi_err2_bitfields
    {
        uint32_t phy_erresc_0 : 1;     /*!< [0]  */
        uint32_t phy_erresc_1 : 1;     /*!< [1]  */
        uint32_t phy_erresc_2 : 1;     /*!< [2]  */
        uint32_t phy_erresc_3 : 1;     /*!< [3]  */
        uint32_t phy_errsoths_0 : 1;   /*!< [4]  */
        uint32_t phy_errsoths_1 : 1;   /*!< [5]  */
        uint32_t phy_errsoths_2 : 1;   /*!< [6]  */
        uint32_t phy_errsoths_3 : 1;   /*!< [7]  */
        uint32_t vc0_err_ecc_corrected : 1; /*!< [8]  */
        uint32_t vc1_err_ecc_corrected : 1; /*!< [9]  */
        uint32_t vc2_err_ecc_corrected : 1; /*!< [10]  */
        uint32_t vc3_err_ecc_corrected : 1; /*!< [11]  */
        uint32_t err_id_vc0 : 1;       /*!< [12]  */
        uint32_t err_id_vc1 : 1;       /*!< [13]  */
        uint32_t err_id_vc2 : 1;       /*!< [14]  */
        uint32_t err_id_vc3 : 1;       /*!< [15]  */
        uint32_t err_l_bndry_match_di4 : 1; /*!< [16]  */
        uint32_t err_l_bndry_match_di5 : 1; /*!< [17]  */
        uint32_t err_l_bndry_match_di6 : 1; /*!< [18]  */
        uint32_t err_l_bndry_match_di7 : 1; /*!< [19]  */
        uint32_t err_l_seq_di4 : 1;    /*!< [20]  */
        uint32_t err_l_seq_di5 : 1;    /*!< [21]  */
        uint32_t err_l_seq_di6 : 1;    /*!< [22]  */
        uint32_t err_l_seq_di7 : 1;    /*!< [23]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_mipi_csi_err2_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_ERR2 register
 */
/*@{*/
#define HW_MIPI_CSI_ERR2_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_MIPI_CSI_ERR2(x)      (*(__I hw_mipi_csi_err2_t *) HW_MIPI_CSI_ERR2_ADDR(x))
#define HW_MIPI_CSI_ERR2_RD(x)   (HW_MIPI_CSI_ERR2(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_ERR2 bitfields
 */

/*!
 * @name Register MIPI_CSI_ERR2, field phy_erresc_0[0] (RO)
 *
 * Escape Entry Error (ULPM) on data lane 0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_erresc_0 (0U) /*!< Bit position for MIPI_CSI_ERR2_phy_erresc_0. */
#define BM_MIPI_CSI_ERR2_phy_erresc_0 (0x00000001U) /*!< Bit mask for MIPI_CSI_ERR2_phy_erresc_0. */
#define BS_MIPI_CSI_ERR2_phy_erresc_0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_erresc_0. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_erresc_0 field. */
#define BR_MIPI_CSI_ERR2_phy_erresc_0(x) (HW_MIPI_CSI_ERR2(x).B.phy_erresc_0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_erresc_1[1] (RO)
 *
 * Escape Entry Error (ULPM) on data lane 1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_erresc_1 (1U) /*!< Bit position for MIPI_CSI_ERR2_phy_erresc_1. */
#define BM_MIPI_CSI_ERR2_phy_erresc_1 (0x00000002U) /*!< Bit mask for MIPI_CSI_ERR2_phy_erresc_1. */
#define BS_MIPI_CSI_ERR2_phy_erresc_1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_erresc_1. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_erresc_1 field. */
#define BR_MIPI_CSI_ERR2_phy_erresc_1(x) (HW_MIPI_CSI_ERR2(x).B.phy_erresc_1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_erresc_2[2] (RO)
 *
 * Escape Entry Error (ULPM) on data lane 2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_erresc_2 (2U) /*!< Bit position for MIPI_CSI_ERR2_phy_erresc_2. */
#define BM_MIPI_CSI_ERR2_phy_erresc_2 (0x00000004U) /*!< Bit mask for MIPI_CSI_ERR2_phy_erresc_2. */
#define BS_MIPI_CSI_ERR2_phy_erresc_2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_erresc_2. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_erresc_2 field. */
#define BR_MIPI_CSI_ERR2_phy_erresc_2(x) (HW_MIPI_CSI_ERR2(x).B.phy_erresc_2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_erresc_3[3] (RO)
 *
 * Escape Entry Error (ULPM) on data lane 3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_erresc_3 (3U) /*!< Bit position for MIPI_CSI_ERR2_phy_erresc_3. */
#define BM_MIPI_CSI_ERR2_phy_erresc_3 (0x00000008U) /*!< Bit mask for MIPI_CSI_ERR2_phy_erresc_3. */
#define BS_MIPI_CSI_ERR2_phy_erresc_3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_erresc_3. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_erresc_3 field. */
#define BR_MIPI_CSI_ERR2_phy_erresc_3(x) (HW_MIPI_CSI_ERR2(x).B.phy_erresc_3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_errsoths_0[4] (RO)
 *
 * Start of Transmission Error on data lane 0 (synchronization can still be
 * achieved) Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_errsoths_0 (4U) /*!< Bit position for MIPI_CSI_ERR2_phy_errsoths_0. */
#define BM_MIPI_CSI_ERR2_phy_errsoths_0 (0x00000010U) /*!< Bit mask for MIPI_CSI_ERR2_phy_errsoths_0. */
#define BS_MIPI_CSI_ERR2_phy_errsoths_0 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_errsoths_0. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_errsoths_0 field. */
#define BR_MIPI_CSI_ERR2_phy_errsoths_0(x) (HW_MIPI_CSI_ERR2(x).B.phy_errsoths_0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_errsoths_1[5] (RO)
 *
 * Start of Transmission Error on data lane 1 (synchronization can still be
 * achieved) Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_errsoths_1 (5U) /*!< Bit position for MIPI_CSI_ERR2_phy_errsoths_1. */
#define BM_MIPI_CSI_ERR2_phy_errsoths_1 (0x00000020U) /*!< Bit mask for MIPI_CSI_ERR2_phy_errsoths_1. */
#define BS_MIPI_CSI_ERR2_phy_errsoths_1 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_errsoths_1. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_errsoths_1 field. */
#define BR_MIPI_CSI_ERR2_phy_errsoths_1(x) (HW_MIPI_CSI_ERR2(x).B.phy_errsoths_1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_errsoths_2[6] (RO)
 *
 * Start of Transmission Error on data lane 2 (synchronization can still be
 * achieved) Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_errsoths_2 (6U) /*!< Bit position for MIPI_CSI_ERR2_phy_errsoths_2. */
#define BM_MIPI_CSI_ERR2_phy_errsoths_2 (0x00000040U) /*!< Bit mask for MIPI_CSI_ERR2_phy_errsoths_2. */
#define BS_MIPI_CSI_ERR2_phy_errsoths_2 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_errsoths_2. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_errsoths_2 field. */
#define BR_MIPI_CSI_ERR2_phy_errsoths_2(x) (HW_MIPI_CSI_ERR2(x).B.phy_errsoths_2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field phy_errsoths_3[7] (RO)
 *
 * Start of Transmission Error on data lane 3 (synchronization can still be
 * achieved) Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_phy_errsoths_3 (7U) /*!< Bit position for MIPI_CSI_ERR2_phy_errsoths_3. */
#define BM_MIPI_CSI_ERR2_phy_errsoths_3 (0x00000080U) /*!< Bit mask for MIPI_CSI_ERR2_phy_errsoths_3. */
#define BS_MIPI_CSI_ERR2_phy_errsoths_3 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_phy_errsoths_3. */

/*! @brief Read current value of the MIPI_CSI_ERR2_phy_errsoths_3 field. */
#define BR_MIPI_CSI_ERR2_phy_errsoths_3(x) (HW_MIPI_CSI_ERR2(x).B.phy_errsoths_3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field vc0_err_ecc_corrected[8] (RO)
 *
 * Header error detected and corrected on Virtual Channel 0 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_vc0_err_ecc_corrected (8U) /*!< Bit position for MIPI_CSI_ERR2_vc0_err_ecc_corrected. */
#define BM_MIPI_CSI_ERR2_vc0_err_ecc_corrected (0x00000100U) /*!< Bit mask for MIPI_CSI_ERR2_vc0_err_ecc_corrected. */
#define BS_MIPI_CSI_ERR2_vc0_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_vc0_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_ERR2_vc0_err_ecc_corrected field. */
#define BR_MIPI_CSI_ERR2_vc0_err_ecc_corrected(x) (HW_MIPI_CSI_ERR2(x).B.vc0_err_ecc_corrected)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field vc1_err_ecc_corrected[9] (RO)
 *
 * Header error detected and corrected on Virtual Channel 1 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_vc1_err_ecc_corrected (9U) /*!< Bit position for MIPI_CSI_ERR2_vc1_err_ecc_corrected. */
#define BM_MIPI_CSI_ERR2_vc1_err_ecc_corrected (0x00000200U) /*!< Bit mask for MIPI_CSI_ERR2_vc1_err_ecc_corrected. */
#define BS_MIPI_CSI_ERR2_vc1_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_vc1_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_ERR2_vc1_err_ecc_corrected field. */
#define BR_MIPI_CSI_ERR2_vc1_err_ecc_corrected(x) (HW_MIPI_CSI_ERR2(x).B.vc1_err_ecc_corrected)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field vc2_err_ecc_corrected[10] (RO)
 *
 * Header error detected and corrected on Virtual Channel 2 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_vc2_err_ecc_corrected (10U) /*!< Bit position for MIPI_CSI_ERR2_vc2_err_ecc_corrected. */
#define BM_MIPI_CSI_ERR2_vc2_err_ecc_corrected (0x00000400U) /*!< Bit mask for MIPI_CSI_ERR2_vc2_err_ecc_corrected. */
#define BS_MIPI_CSI_ERR2_vc2_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_vc2_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_ERR2_vc2_err_ecc_corrected field. */
#define BR_MIPI_CSI_ERR2_vc2_err_ecc_corrected(x) (HW_MIPI_CSI_ERR2(x).B.vc2_err_ecc_corrected)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field vc3_err_ecc_corrected[11] (RO)
 *
 * Header error detected and corrected on Virtual Channel 3 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_vc3_err_ecc_corrected (11U) /*!< Bit position for MIPI_CSI_ERR2_vc3_err_ecc_corrected. */
#define BM_MIPI_CSI_ERR2_vc3_err_ecc_corrected (0x00000800U) /*!< Bit mask for MIPI_CSI_ERR2_vc3_err_ecc_corrected. */
#define BS_MIPI_CSI_ERR2_vc3_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_vc3_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_ERR2_vc3_err_ecc_corrected field. */
#define BR_MIPI_CSI_ERR2_vc3_err_ecc_corrected(x) (HW_MIPI_CSI_ERR2(x).B.vc3_err_ecc_corrected)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_id_vc0[12] (RO)
 *
 * Unrecognized or unimplemented data type detected in Virtual Channel 0 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_id_vc0 (12U)  /*!< Bit position for MIPI_CSI_ERR2_err_id_vc0. */
#define BM_MIPI_CSI_ERR2_err_id_vc0 (0x00001000U) /*!< Bit mask for MIPI_CSI_ERR2_err_id_vc0. */
#define BS_MIPI_CSI_ERR2_err_id_vc0 (1U)   /*!< Bit field size in bits for MIPI_CSI_ERR2_err_id_vc0. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_id_vc0 field. */
#define BR_MIPI_CSI_ERR2_err_id_vc0(x) (HW_MIPI_CSI_ERR2(x).B.err_id_vc0)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_id_vc1[13] (RO)
 *
 * Unrecognized or unimplemented data type detected in Virtual Channel 1 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_id_vc1 (13U)  /*!< Bit position for MIPI_CSI_ERR2_err_id_vc1. */
#define BM_MIPI_CSI_ERR2_err_id_vc1 (0x00002000U) /*!< Bit mask for MIPI_CSI_ERR2_err_id_vc1. */
#define BS_MIPI_CSI_ERR2_err_id_vc1 (1U)   /*!< Bit field size in bits for MIPI_CSI_ERR2_err_id_vc1. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_id_vc1 field. */
#define BR_MIPI_CSI_ERR2_err_id_vc1(x) (HW_MIPI_CSI_ERR2(x).B.err_id_vc1)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_id_vc2[14] (RO)
 *
 * Unrecognized or unimplemented data type detected in Virtual Channel 2 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_id_vc2 (14U)  /*!< Bit position for MIPI_CSI_ERR2_err_id_vc2. */
#define BM_MIPI_CSI_ERR2_err_id_vc2 (0x00004000U) /*!< Bit mask for MIPI_CSI_ERR2_err_id_vc2. */
#define BS_MIPI_CSI_ERR2_err_id_vc2 (1U)   /*!< Bit field size in bits for MIPI_CSI_ERR2_err_id_vc2. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_id_vc2 field. */
#define BR_MIPI_CSI_ERR2_err_id_vc2(x) (HW_MIPI_CSI_ERR2(x).B.err_id_vc2)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_id_vc3[15] (RO)
 *
 * Unrecognized or unimplemented data type detected in Virtual Channel 3 Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_id_vc3 (15U)  /*!< Bit position for MIPI_CSI_ERR2_err_id_vc3. */
#define BM_MIPI_CSI_ERR2_err_id_vc3 (0x00008000U) /*!< Bit mask for MIPI_CSI_ERR2_err_id_vc3. */
#define BS_MIPI_CSI_ERR2_err_id_vc3 (1U)   /*!< Bit field size in bits for MIPI_CSI_ERR2_err_id_vc3. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_id_vc3 field. */
#define BR_MIPI_CSI_ERR2_err_id_vc3(x) (HW_MIPI_CSI_ERR2(x).B.err_id_vc3)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_bndry_match_di4[16] (RO)
 *
 * Error matching Line Start with Line End for vc4 and dt4 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_bndry_match_di4 (16U) /*!< Bit position for MIPI_CSI_ERR2_err_l_bndry_match_di4. */
#define BM_MIPI_CSI_ERR2_err_l_bndry_match_di4 (0x00010000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_bndry_match_di4. */
#define BS_MIPI_CSI_ERR2_err_l_bndry_match_di4 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_bndry_match_di4. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_bndry_match_di4 field. */
#define BR_MIPI_CSI_ERR2_err_l_bndry_match_di4(x) (HW_MIPI_CSI_ERR2(x).B.err_l_bndry_match_di4)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_bndry_match_di5[17] (RO)
 *
 * Error matching Line Start with Line End for vc5 and dt5 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_bndry_match_di5 (17U) /*!< Bit position for MIPI_CSI_ERR2_err_l_bndry_match_di5. */
#define BM_MIPI_CSI_ERR2_err_l_bndry_match_di5 (0x00020000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_bndry_match_di5. */
#define BS_MIPI_CSI_ERR2_err_l_bndry_match_di5 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_bndry_match_di5. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_bndry_match_di5 field. */
#define BR_MIPI_CSI_ERR2_err_l_bndry_match_di5(x) (HW_MIPI_CSI_ERR2(x).B.err_l_bndry_match_di5)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_bndry_match_di6[18] (RO)
 *
 * Error matching Line Start with Line End for vc6 and dt6 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_bndry_match_di6 (18U) /*!< Bit position for MIPI_CSI_ERR2_err_l_bndry_match_di6. */
#define BM_MIPI_CSI_ERR2_err_l_bndry_match_di6 (0x00040000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_bndry_match_di6. */
#define BS_MIPI_CSI_ERR2_err_l_bndry_match_di6 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_bndry_match_di6. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_bndry_match_di6 field. */
#define BR_MIPI_CSI_ERR2_err_l_bndry_match_di6(x) (HW_MIPI_CSI_ERR2(x).B.err_l_bndry_match_di6)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_bndry_match_di7[19] (RO)
 *
 * Error matching Line Start with Line End for vc7 and dt7 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_bndry_match_di7 (19U) /*!< Bit position for MIPI_CSI_ERR2_err_l_bndry_match_di7. */
#define BM_MIPI_CSI_ERR2_err_l_bndry_match_di7 (0x00080000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_bndry_match_di7. */
#define BS_MIPI_CSI_ERR2_err_l_bndry_match_di7 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_bndry_match_di7. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_bndry_match_di7 field. */
#define BR_MIPI_CSI_ERR2_err_l_bndry_match_di7(x) (HW_MIPI_CSI_ERR2(x).B.err_l_bndry_match_di7)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_seq_di4[20] (RO)
 *
 * Error in the sequence of lines for vc4 and dt4 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_seq_di4 (20U) /*!< Bit position for MIPI_CSI_ERR2_err_l_seq_di4. */
#define BM_MIPI_CSI_ERR2_err_l_seq_di4 (0x00100000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_seq_di4. */
#define BS_MIPI_CSI_ERR2_err_l_seq_di4 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_seq_di4. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_seq_di4 field. */
#define BR_MIPI_CSI_ERR2_err_l_seq_di4(x) (HW_MIPI_CSI_ERR2(x).B.err_l_seq_di4)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_seq_di5[21] (RO)
 *
 * Error in the sequence of lines for vc5 and dt5 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_seq_di5 (21U) /*!< Bit position for MIPI_CSI_ERR2_err_l_seq_di5. */
#define BM_MIPI_CSI_ERR2_err_l_seq_di5 (0x00200000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_seq_di5. */
#define BS_MIPI_CSI_ERR2_err_l_seq_di5 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_seq_di5. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_seq_di5 field. */
#define BR_MIPI_CSI_ERR2_err_l_seq_di5(x) (HW_MIPI_CSI_ERR2(x).B.err_l_seq_di5)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_seq_di6[22] (RO)
 *
 * Error in the sequence of lines for vc6 and dt6 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_seq_di6 (22U) /*!< Bit position for MIPI_CSI_ERR2_err_l_seq_di6. */
#define BM_MIPI_CSI_ERR2_err_l_seq_di6 (0x00400000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_seq_di6. */
#define BS_MIPI_CSI_ERR2_err_l_seq_di6 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_seq_di6. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_seq_di6 field. */
#define BR_MIPI_CSI_ERR2_err_l_seq_di6(x) (HW_MIPI_CSI_ERR2(x).B.err_l_seq_di6)
/*@}*/

/*!
 * @name Register MIPI_CSI_ERR2, field err_l_seq_di7[23] (RO)
 *
 * Error in the sequence of lines for vc7 and dt7 Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_ERR2_err_l_seq_di7 (23U) /*!< Bit position for MIPI_CSI_ERR2_err_l_seq_di7. */
#define BM_MIPI_CSI_ERR2_err_l_seq_di7 (0x00800000U) /*!< Bit mask for MIPI_CSI_ERR2_err_l_seq_di7. */
#define BS_MIPI_CSI_ERR2_err_l_seq_di7 (1U) /*!< Bit field size in bits for MIPI_CSI_ERR2_err_l_seq_di7. */

/*! @brief Read current value of the MIPI_CSI_ERR2_err_l_seq_di7 field. */
#define BR_MIPI_CSI_ERR2_err_l_seq_di7(x) (HW_MIPI_CSI_ERR2(x).B.err_l_seq_di7)
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_MASK1 - Masks for errors 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_MASK1 - Masks for errors 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_mask1
{
    uint32_t U;
    struct _hw_mipi_csi_mask1_bitfields
    {
        uint32_t mask_phy_errsotsynchs_0 : 1; /*!< [0]  */
        uint32_t mask_phy_errsotsynchs_1 : 1; /*!< [1]  */
        uint32_t mask_phy_errsotsynchs_2 : 1; /*!< [2]  */
        uint32_t mask_phy_errsotsynchs_3 : 1; /*!< [3]  */
        uint32_t mask_err_f_bndry_match_vc0 : 1; /*!< [4]  */
        uint32_t mask_err_f_bndry_match_vc1 : 1; /*!< [5]  */
        uint32_t mask_err_f_bndry_match_vc2 : 1; /*!< [6]  */
        uint32_t mask_err_f_bndry_match_vc3 : 1; /*!< [7]  */
        uint32_t mask_err_f_seq_vc0 : 1; /*!< [8]  */
        uint32_t mask_err_f_seq_vc1 : 1; /*!< [9]  */
        uint32_t mask_err_f_seq_vc2 : 1; /*!< [10]  */
        uint32_t mask_err_f_seq_vc3 : 1; /*!< [11]  */
        uint32_t mask_err_frame_data_vc0 : 1; /*!< [12]  */
        uint32_t mask_err_frame_data_vc1 : 1; /*!< [13]  */
        uint32_t mask_err_frame_data_vc2 : 1; /*!< [14]  */
        uint32_t mask_err_frame_data_vc3 : 1; /*!< [15]  */
        uint32_t mask_err_l_bndry_match_di0 : 1; /*!< [16]  */
        uint32_t mask_err_l_bndry_match_di1 : 1; /*!< [17]  */
        uint32_t mask_err_l_bndry_match_di2 : 1; /*!< [18]  */
        uint32_t mask_err_l_bndry_match_di3 : 1; /*!< [19]  */
        uint32_t mask_err_l_seq_di0 : 1; /*!< [20]  */
        uint32_t mask_err_l_seq_di1 : 1; /*!< [21]  */
        uint32_t mask_err_l_seq_di2 : 1; /*!< [22]  */
        uint32_t mask_err_l_seq_di3 : 1; /*!< [23]  */
        uint32_t mask_vc0_err_crc : 1; /*!< [24]  */
        uint32_t mask_vc1_err_crc : 1; /*!< [25]  */
        uint32_t mask_vc2_err_crc : 1; /*!< [26]  */
        uint32_t mask_vc3_err_crc : 1; /*!< [27]  */
        uint32_t mask_err_ecc_double : 1; /*!< [28]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_mipi_csi_mask1_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_MASK1 register
 */
/*@{*/
#define HW_MIPI_CSI_MASK1_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_MIPI_CSI_MASK1(x)     (*(__IO hw_mipi_csi_mask1_t *) HW_MIPI_CSI_MASK1_ADDR(x))
#define HW_MIPI_CSI_MASK1_RD(x)  (HW_MIPI_CSI_MASK1(x).U)
#define HW_MIPI_CSI_MASK1_WR(x, v) (HW_MIPI_CSI_MASK1(x).U = (v))
#define HW_MIPI_CSI_MASK1_SET(x, v) (HW_MIPI_CSI_MASK1_WR(x, HW_MIPI_CSI_MASK1_RD(x) |  (v)))
#define HW_MIPI_CSI_MASK1_CLR(x, v) (HW_MIPI_CSI_MASK1_WR(x, HW_MIPI_CSI_MASK1_RD(x) & ~(v)))
#define HW_MIPI_CSI_MASK1_TOG(x, v) (HW_MIPI_CSI_MASK1_WR(x, HW_MIPI_CSI_MASK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_MASK1 bitfields
 */

/*!
 * @name Register MIPI_CSI_MASK1, field mask_phy_errsotsynchs_0[0] (RW)
 *
 * Mask for phy_errsotsynchs_0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0 (0U) /*!< Bit position for MIPI_CSI_MASK1_mask_phy_errsotsynchs_0. */
#define BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0 (0x00000001U) /*!< Bit mask for MIPI_CSI_MASK1_mask_phy_errsotsynchs_0. */
#define BS_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_phy_errsotsynchs_0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_phy_errsotsynchs_0 field. */
#define BR_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0(x) (HW_MIPI_CSI_MASK1(x).B.mask_phy_errsotsynchs_0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_phy_errsotsynchs_0. */
#define BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0) & BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0)

/*! @brief Set the mask_phy_errsotsynchs_0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0) | BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_phy_errsotsynchs_1[1] (RW)
 *
 * Mask for phy_errsotsynchs_1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1 (1U) /*!< Bit position for MIPI_CSI_MASK1_mask_phy_errsotsynchs_1. */
#define BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1 (0x00000002U) /*!< Bit mask for MIPI_CSI_MASK1_mask_phy_errsotsynchs_1. */
#define BS_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_phy_errsotsynchs_1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_phy_errsotsynchs_1 field. */
#define BR_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1(x) (HW_MIPI_CSI_MASK1(x).B.mask_phy_errsotsynchs_1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_phy_errsotsynchs_1. */
#define BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1) & BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1)

/*! @brief Set the mask_phy_errsotsynchs_1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1) | BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_phy_errsotsynchs_2[2] (RW)
 *
 * Mask for phy_errsotsynchs_2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2 (2U) /*!< Bit position for MIPI_CSI_MASK1_mask_phy_errsotsynchs_2. */
#define BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2 (0x00000004U) /*!< Bit mask for MIPI_CSI_MASK1_mask_phy_errsotsynchs_2. */
#define BS_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_phy_errsotsynchs_2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_phy_errsotsynchs_2 field. */
#define BR_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2(x) (HW_MIPI_CSI_MASK1(x).B.mask_phy_errsotsynchs_2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_phy_errsotsynchs_2. */
#define BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2) & BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2)

/*! @brief Set the mask_phy_errsotsynchs_2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2) | BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_phy_errsotsynchs_3[3] (RW)
 *
 * Mask for phy_errsotsynchs_3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3 (3U) /*!< Bit position for MIPI_CSI_MASK1_mask_phy_errsotsynchs_3. */
#define BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3 (0x00000008U) /*!< Bit mask for MIPI_CSI_MASK1_mask_phy_errsotsynchs_3. */
#define BS_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_phy_errsotsynchs_3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_phy_errsotsynchs_3 field. */
#define BR_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3(x) (HW_MIPI_CSI_MASK1(x).B.mask_phy_errsotsynchs_3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_phy_errsotsynchs_3. */
#define BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3) & BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3)

/*! @brief Set the mask_phy_errsotsynchs_3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3) | BF_MIPI_CSI_MASK1_mask_phy_errsotsynchs_3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_bndry_match_vc0[4] (RW)
 *
 * Mask for err_f_bndry_match_vc0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0 (4U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0. */
#define BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0 (0x00000010U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0. */
#define BS_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_bndry_match_vc0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0. */
#define BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0) & BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0)

/*! @brief Set the mask_err_f_bndry_match_vc0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0) | BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_bndry_match_vc1[5] (RW)
 *
 * Mask for err_f_bndry_match_vc1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1 (5U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1. */
#define BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1 (0x00000020U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1. */
#define BS_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_bndry_match_vc1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1. */
#define BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1) & BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1)

/*! @brief Set the mask_err_f_bndry_match_vc1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1) | BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_bndry_match_vc2[6] (RW)
 *
 * Mask for err_f_bndry_match_vc2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2 (6U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2. */
#define BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2 (0x00000040U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2. */
#define BS_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_bndry_match_vc2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2. */
#define BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2) & BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2)

/*! @brief Set the mask_err_f_bndry_match_vc2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2) | BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_bndry_match_vc3[7] (RW)
 *
 * Mask for err_f_bndry_match_vc3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3 (7U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3. */
#define BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3 (0x00000080U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3. */
#define BS_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_bndry_match_vc3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3. */
#define BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3) & BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3)

/*! @brief Set the mask_err_f_bndry_match_vc3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3) | BF_MIPI_CSI_MASK1_mask_err_f_bndry_match_vc3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_seq_vc0[8] (RW)
 *
 * Mask for err_f_seq_vc0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_seq_vc0 (8U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_seq_vc0. */
#define BM_MIPI_CSI_MASK1_mask_err_f_seq_vc0 (0x00000100U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_seq_vc0. */
#define BS_MIPI_CSI_MASK1_mask_err_f_seq_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_seq_vc0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_seq_vc0 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_seq_vc0(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_seq_vc0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_seq_vc0. */
#define BF_MIPI_CSI_MASK1_mask_err_f_seq_vc0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_seq_vc0) & BM_MIPI_CSI_MASK1_mask_err_f_seq_vc0)

/*! @brief Set the mask_err_f_seq_vc0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_seq_vc0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_seq_vc0) | BF_MIPI_CSI_MASK1_mask_err_f_seq_vc0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_seq_vc1[9] (RW)
 *
 * Mask for err_f_seq_vc1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_seq_vc1 (9U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_seq_vc1. */
#define BM_MIPI_CSI_MASK1_mask_err_f_seq_vc1 (0x00000200U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_seq_vc1. */
#define BS_MIPI_CSI_MASK1_mask_err_f_seq_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_seq_vc1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_seq_vc1 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_seq_vc1(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_seq_vc1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_seq_vc1. */
#define BF_MIPI_CSI_MASK1_mask_err_f_seq_vc1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_seq_vc1) & BM_MIPI_CSI_MASK1_mask_err_f_seq_vc1)

/*! @brief Set the mask_err_f_seq_vc1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_seq_vc1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_seq_vc1) | BF_MIPI_CSI_MASK1_mask_err_f_seq_vc1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_seq_vc2[10] (RW)
 *
 * Mask for err_f_seq_vc2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_seq_vc2 (10U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_seq_vc2. */
#define BM_MIPI_CSI_MASK1_mask_err_f_seq_vc2 (0x00000400U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_seq_vc2. */
#define BS_MIPI_CSI_MASK1_mask_err_f_seq_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_seq_vc2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_seq_vc2 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_seq_vc2(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_seq_vc2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_seq_vc2. */
#define BF_MIPI_CSI_MASK1_mask_err_f_seq_vc2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_seq_vc2) & BM_MIPI_CSI_MASK1_mask_err_f_seq_vc2)

/*! @brief Set the mask_err_f_seq_vc2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_seq_vc2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_seq_vc2) | BF_MIPI_CSI_MASK1_mask_err_f_seq_vc2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_f_seq_vc3[11] (RW)
 *
 * Mask for err_f_seq_vc3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_f_seq_vc3 (11U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_f_seq_vc3. */
#define BM_MIPI_CSI_MASK1_mask_err_f_seq_vc3 (0x00000800U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_f_seq_vc3. */
#define BS_MIPI_CSI_MASK1_mask_err_f_seq_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_f_seq_vc3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_f_seq_vc3 field. */
#define BR_MIPI_CSI_MASK1_mask_err_f_seq_vc3(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_f_seq_vc3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_f_seq_vc3. */
#define BF_MIPI_CSI_MASK1_mask_err_f_seq_vc3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_f_seq_vc3) & BM_MIPI_CSI_MASK1_mask_err_f_seq_vc3)

/*! @brief Set the mask_err_f_seq_vc3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_f_seq_vc3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_f_seq_vc3) | BF_MIPI_CSI_MASK1_mask_err_f_seq_vc3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_frame_data_vc0[12] (RW)
 *
 * Mask for err_frame_data_vc0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_frame_data_vc0 (12U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_frame_data_vc0. */
#define BM_MIPI_CSI_MASK1_mask_err_frame_data_vc0 (0x00001000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_frame_data_vc0. */
#define BS_MIPI_CSI_MASK1_mask_err_frame_data_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_frame_data_vc0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_frame_data_vc0 field. */
#define BR_MIPI_CSI_MASK1_mask_err_frame_data_vc0(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_frame_data_vc0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_frame_data_vc0. */
#define BF_MIPI_CSI_MASK1_mask_err_frame_data_vc0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_frame_data_vc0) & BM_MIPI_CSI_MASK1_mask_err_frame_data_vc0)

/*! @brief Set the mask_err_frame_data_vc0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_frame_data_vc0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_frame_data_vc0) | BF_MIPI_CSI_MASK1_mask_err_frame_data_vc0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_frame_data_vc1[13] (RW)
 *
 * Mask for err_frame_data_vc1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_frame_data_vc1 (13U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_frame_data_vc1. */
#define BM_MIPI_CSI_MASK1_mask_err_frame_data_vc1 (0x00002000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_frame_data_vc1. */
#define BS_MIPI_CSI_MASK1_mask_err_frame_data_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_frame_data_vc1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_frame_data_vc1 field. */
#define BR_MIPI_CSI_MASK1_mask_err_frame_data_vc1(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_frame_data_vc1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_frame_data_vc1. */
#define BF_MIPI_CSI_MASK1_mask_err_frame_data_vc1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_frame_data_vc1) & BM_MIPI_CSI_MASK1_mask_err_frame_data_vc1)

/*! @brief Set the mask_err_frame_data_vc1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_frame_data_vc1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_frame_data_vc1) | BF_MIPI_CSI_MASK1_mask_err_frame_data_vc1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_frame_data_vc2[14] (RW)
 *
 * Mask for err_frame_data_vc2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_frame_data_vc2 (14U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_frame_data_vc2. */
#define BM_MIPI_CSI_MASK1_mask_err_frame_data_vc2 (0x00004000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_frame_data_vc2. */
#define BS_MIPI_CSI_MASK1_mask_err_frame_data_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_frame_data_vc2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_frame_data_vc2 field. */
#define BR_MIPI_CSI_MASK1_mask_err_frame_data_vc2(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_frame_data_vc2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_frame_data_vc2. */
#define BF_MIPI_CSI_MASK1_mask_err_frame_data_vc2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_frame_data_vc2) & BM_MIPI_CSI_MASK1_mask_err_frame_data_vc2)

/*! @brief Set the mask_err_frame_data_vc2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_frame_data_vc2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_frame_data_vc2) | BF_MIPI_CSI_MASK1_mask_err_frame_data_vc2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_frame_data_vc3[15] (RW)
 *
 * Mask for err_frame_data_vc3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_frame_data_vc3 (15U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_frame_data_vc3. */
#define BM_MIPI_CSI_MASK1_mask_err_frame_data_vc3 (0x00008000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_frame_data_vc3. */
#define BS_MIPI_CSI_MASK1_mask_err_frame_data_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_frame_data_vc3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_frame_data_vc3 field. */
#define BR_MIPI_CSI_MASK1_mask_err_frame_data_vc3(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_frame_data_vc3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_frame_data_vc3. */
#define BF_MIPI_CSI_MASK1_mask_err_frame_data_vc3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_frame_data_vc3) & BM_MIPI_CSI_MASK1_mask_err_frame_data_vc3)

/*! @brief Set the mask_err_frame_data_vc3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_frame_data_vc3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_frame_data_vc3) | BF_MIPI_CSI_MASK1_mask_err_frame_data_vc3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_bndry_match_di0[16] (RW)
 *
 * Mask for err_l_bndry_match_di0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0 (16U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_bndry_match_di0. */
#define BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0 (0x00010000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_bndry_match_di0. */
#define BS_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_bndry_match_di0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_bndry_match_di0 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_bndry_match_di0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_bndry_match_di0. */
#define BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0) & BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0)

/*! @brief Set the mask_err_l_bndry_match_di0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0) | BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_bndry_match_di1[17] (RW)
 *
 * Mask for err_l_bndry_match_di1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1 (17U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_bndry_match_di1. */
#define BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1 (0x00020000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_bndry_match_di1. */
#define BS_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_bndry_match_di1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_bndry_match_di1 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_bndry_match_di1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_bndry_match_di1. */
#define BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1) & BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1)

/*! @brief Set the mask_err_l_bndry_match_di1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1) | BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_bndry_match_di2[18] (RW)
 *
 * Mask for err_l_bndry_match_di2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2 (18U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_bndry_match_di2. */
#define BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2 (0x00040000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_bndry_match_di2. */
#define BS_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_bndry_match_di2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_bndry_match_di2 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_bndry_match_di2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_bndry_match_di2. */
#define BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2) & BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2)

/*! @brief Set the mask_err_l_bndry_match_di2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2) | BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_bndry_match_di3[19] (RW)
 *
 * Mask for err_l_bndry_match_di3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3 (19U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_bndry_match_di3. */
#define BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3 (0x00080000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_bndry_match_di3. */
#define BS_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_bndry_match_di3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_bndry_match_di3 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_bndry_match_di3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_bndry_match_di3. */
#define BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3) & BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3)

/*! @brief Set the mask_err_l_bndry_match_di3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3) | BF_MIPI_CSI_MASK1_mask_err_l_bndry_match_di3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_seq_di0[20] (RW)
 *
 * Mask for err_l_seq_di0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_seq_di0 (20U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_seq_di0. */
#define BM_MIPI_CSI_MASK1_mask_err_l_seq_di0 (0x00100000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_seq_di0. */
#define BS_MIPI_CSI_MASK1_mask_err_l_seq_di0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_seq_di0. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_seq_di0 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_seq_di0(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_seq_di0)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_seq_di0. */
#define BF_MIPI_CSI_MASK1_mask_err_l_seq_di0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_seq_di0) & BM_MIPI_CSI_MASK1_mask_err_l_seq_di0)

/*! @brief Set the mask_err_l_seq_di0 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_seq_di0(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_seq_di0) | BF_MIPI_CSI_MASK1_mask_err_l_seq_di0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_seq_di1[21] (RW)
 *
 * Mask for err_l_seq_di1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_seq_di1 (21U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_seq_di1. */
#define BM_MIPI_CSI_MASK1_mask_err_l_seq_di1 (0x00200000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_seq_di1. */
#define BS_MIPI_CSI_MASK1_mask_err_l_seq_di1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_seq_di1. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_seq_di1 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_seq_di1(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_seq_di1)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_seq_di1. */
#define BF_MIPI_CSI_MASK1_mask_err_l_seq_di1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_seq_di1) & BM_MIPI_CSI_MASK1_mask_err_l_seq_di1)

/*! @brief Set the mask_err_l_seq_di1 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_seq_di1(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_seq_di1) | BF_MIPI_CSI_MASK1_mask_err_l_seq_di1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_seq_di2[22] (RW)
 *
 * Mask for err_l_seq_di2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_seq_di2 (22U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_seq_di2. */
#define BM_MIPI_CSI_MASK1_mask_err_l_seq_di2 (0x00400000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_seq_di2. */
#define BS_MIPI_CSI_MASK1_mask_err_l_seq_di2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_seq_di2. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_seq_di2 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_seq_di2(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_seq_di2)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_seq_di2. */
#define BF_MIPI_CSI_MASK1_mask_err_l_seq_di2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_seq_di2) & BM_MIPI_CSI_MASK1_mask_err_l_seq_di2)

/*! @brief Set the mask_err_l_seq_di2 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_seq_di2(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_seq_di2) | BF_MIPI_CSI_MASK1_mask_err_l_seq_di2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_l_seq_di3[23] (RW)
 *
 * Mask for err_l_seq_di3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_l_seq_di3 (23U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_l_seq_di3. */
#define BM_MIPI_CSI_MASK1_mask_err_l_seq_di3 (0x00800000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_l_seq_di3. */
#define BS_MIPI_CSI_MASK1_mask_err_l_seq_di3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_l_seq_di3. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_l_seq_di3 field. */
#define BR_MIPI_CSI_MASK1_mask_err_l_seq_di3(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_l_seq_di3)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_l_seq_di3. */
#define BF_MIPI_CSI_MASK1_mask_err_l_seq_di3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_l_seq_di3) & BM_MIPI_CSI_MASK1_mask_err_l_seq_di3)

/*! @brief Set the mask_err_l_seq_di3 field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_l_seq_di3(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_l_seq_di3) | BF_MIPI_CSI_MASK1_mask_err_l_seq_di3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_vc0_err_crc[24] (RW)
 *
 * Mask for vc0_err_crc. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_vc0_err_crc (24U) /*!< Bit position for MIPI_CSI_MASK1_mask_vc0_err_crc. */
#define BM_MIPI_CSI_MASK1_mask_vc0_err_crc (0x01000000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_vc0_err_crc. */
#define BS_MIPI_CSI_MASK1_mask_vc0_err_crc (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_vc0_err_crc. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_vc0_err_crc field. */
#define BR_MIPI_CSI_MASK1_mask_vc0_err_crc(x) (HW_MIPI_CSI_MASK1(x).B.mask_vc0_err_crc)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_vc0_err_crc. */
#define BF_MIPI_CSI_MASK1_mask_vc0_err_crc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_vc0_err_crc) & BM_MIPI_CSI_MASK1_mask_vc0_err_crc)

/*! @brief Set the mask_vc0_err_crc field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_vc0_err_crc(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_vc0_err_crc) | BF_MIPI_CSI_MASK1_mask_vc0_err_crc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_vc1_err_crc[25] (RW)
 *
 * Mask for vc1_err_crc. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_vc1_err_crc (25U) /*!< Bit position for MIPI_CSI_MASK1_mask_vc1_err_crc. */
#define BM_MIPI_CSI_MASK1_mask_vc1_err_crc (0x02000000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_vc1_err_crc. */
#define BS_MIPI_CSI_MASK1_mask_vc1_err_crc (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_vc1_err_crc. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_vc1_err_crc field. */
#define BR_MIPI_CSI_MASK1_mask_vc1_err_crc(x) (HW_MIPI_CSI_MASK1(x).B.mask_vc1_err_crc)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_vc1_err_crc. */
#define BF_MIPI_CSI_MASK1_mask_vc1_err_crc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_vc1_err_crc) & BM_MIPI_CSI_MASK1_mask_vc1_err_crc)

/*! @brief Set the mask_vc1_err_crc field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_vc1_err_crc(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_vc1_err_crc) | BF_MIPI_CSI_MASK1_mask_vc1_err_crc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_vc2_err_crc[26] (RW)
 *
 * Mask for vc2_err_crc. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_vc2_err_crc (26U) /*!< Bit position for MIPI_CSI_MASK1_mask_vc2_err_crc. */
#define BM_MIPI_CSI_MASK1_mask_vc2_err_crc (0x04000000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_vc2_err_crc. */
#define BS_MIPI_CSI_MASK1_mask_vc2_err_crc (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_vc2_err_crc. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_vc2_err_crc field. */
#define BR_MIPI_CSI_MASK1_mask_vc2_err_crc(x) (HW_MIPI_CSI_MASK1(x).B.mask_vc2_err_crc)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_vc2_err_crc. */
#define BF_MIPI_CSI_MASK1_mask_vc2_err_crc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_vc2_err_crc) & BM_MIPI_CSI_MASK1_mask_vc2_err_crc)

/*! @brief Set the mask_vc2_err_crc field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_vc2_err_crc(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_vc2_err_crc) | BF_MIPI_CSI_MASK1_mask_vc2_err_crc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_vc3_err_crc[27] (RW)
 *
 * Mask for vc3_err_crc. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_vc3_err_crc (27U) /*!< Bit position for MIPI_CSI_MASK1_mask_vc3_err_crc. */
#define BM_MIPI_CSI_MASK1_mask_vc3_err_crc (0x08000000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_vc3_err_crc. */
#define BS_MIPI_CSI_MASK1_mask_vc3_err_crc (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_vc3_err_crc. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_vc3_err_crc field. */
#define BR_MIPI_CSI_MASK1_mask_vc3_err_crc(x) (HW_MIPI_CSI_MASK1(x).B.mask_vc3_err_crc)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_vc3_err_crc. */
#define BF_MIPI_CSI_MASK1_mask_vc3_err_crc(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_vc3_err_crc) & BM_MIPI_CSI_MASK1_mask_vc3_err_crc)

/*! @brief Set the mask_vc3_err_crc field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_vc3_err_crc(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_vc3_err_crc) | BF_MIPI_CSI_MASK1_mask_vc3_err_crc(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK1, field mask_err_ecc_double[28] (RW)
 *
 * Mask for err_ecc_double. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK1_mask_err_ecc_double (28U) /*!< Bit position for MIPI_CSI_MASK1_mask_err_ecc_double. */
#define BM_MIPI_CSI_MASK1_mask_err_ecc_double (0x10000000U) /*!< Bit mask for MIPI_CSI_MASK1_mask_err_ecc_double. */
#define BS_MIPI_CSI_MASK1_mask_err_ecc_double (1U) /*!< Bit field size in bits for MIPI_CSI_MASK1_mask_err_ecc_double. */

/*! @brief Read current value of the MIPI_CSI_MASK1_mask_err_ecc_double field. */
#define BR_MIPI_CSI_MASK1_mask_err_ecc_double(x) (HW_MIPI_CSI_MASK1(x).B.mask_err_ecc_double)

/*! @brief Format value for bitfield MIPI_CSI_MASK1_mask_err_ecc_double. */
#define BF_MIPI_CSI_MASK1_mask_err_ecc_double(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK1_mask_err_ecc_double) & BM_MIPI_CSI_MASK1_mask_err_ecc_double)

/*! @brief Set the mask_err_ecc_double field to a new value. */
#define BW_MIPI_CSI_MASK1_mask_err_ecc_double(x, v) (HW_MIPI_CSI_MASK1_WR(x, (HW_MIPI_CSI_MASK1_RD(x) & ~BM_MIPI_CSI_MASK1_mask_err_ecc_double) | BF_MIPI_CSI_MASK1_mask_err_ecc_double(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_MASK2 - Masks for errors 2
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_MASK2 - Masks for errors 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_mask2
{
    uint32_t U;
    struct _hw_mipi_csi_mask2_bitfields
    {
        uint32_t mask_phy_erresc_0 : 1; /*!< [0]  */
        uint32_t mask_phy_erresc_1 : 1; /*!< [1]  */
        uint32_t mask_phy_erresc_2 : 1; /*!< [2]  */
        uint32_t mask_phy_erresc_3 : 1; /*!< [3]  */
        uint32_t mask_phy_errsoths_0 : 1; /*!< [4]  */
        uint32_t mask_phy_errsoths_1 : 1; /*!< [5]  */
        uint32_t mask_phy_errsoths_2 : 1; /*!< [6]  */
        uint32_t mask_phy_errsoths_3 : 1; /*!< [7]  */
        uint32_t mask_vc0_err_ecc_corrected : 1; /*!< [8]  */
        uint32_t mask_vc1_err_ecc_corrected : 1; /*!< [9]  */
        uint32_t mask_vc2_err_ecc_corrected : 1; /*!< [10]  */
        uint32_t mask_vc3_err_ecc_corrected : 1; /*!< [11]  */
        uint32_t mask_err_id_vc0 : 1;  /*!< [12]  */
        uint32_t mask_err_id_vc1 : 1;  /*!< [13]  */
        uint32_t mask_err_id_vc2 : 1;  /*!< [14]  */
        uint32_t mask_err_id_vc3 : 1;  /*!< [15]  */
        uint32_t mask_err_l_bndry_match_di4 : 1; /*!< [16]  */
        uint32_t mask_err_l_bndry_match_di5 : 1; /*!< [17]  */
        uint32_t mask_err_l_bndry_match_di6 : 1; /*!< [18]  */
        uint32_t mask_err_l_bndry_match_di7 : 1; /*!< [19]  */
        uint32_t mask_err_l_seq_di4 : 1; /*!< [20]  */
        uint32_t mask_err_l_seq_di5 : 1; /*!< [21]  */
        uint32_t mask_err_l_seq_di6 : 1; /*!< [22]  */
        uint32_t mask_err_l_seq_di7 : 1; /*!< [23]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_mipi_csi_mask2_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_MASK2 register
 */
/*@{*/
#define HW_MIPI_CSI_MASK2_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_MIPI_CSI_MASK2(x)     (*(__IO hw_mipi_csi_mask2_t *) HW_MIPI_CSI_MASK2_ADDR(x))
#define HW_MIPI_CSI_MASK2_RD(x)  (HW_MIPI_CSI_MASK2(x).U)
#define HW_MIPI_CSI_MASK2_WR(x, v) (HW_MIPI_CSI_MASK2(x).U = (v))
#define HW_MIPI_CSI_MASK2_SET(x, v) (HW_MIPI_CSI_MASK2_WR(x, HW_MIPI_CSI_MASK2_RD(x) |  (v)))
#define HW_MIPI_CSI_MASK2_CLR(x, v) (HW_MIPI_CSI_MASK2_WR(x, HW_MIPI_CSI_MASK2_RD(x) & ~(v)))
#define HW_MIPI_CSI_MASK2_TOG(x, v) (HW_MIPI_CSI_MASK2_WR(x, HW_MIPI_CSI_MASK2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_MASK2 bitfields
 */

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_erresc_0[0] (RW)
 *
 * Mask for phy_erresc_0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_erresc_0 (0U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_erresc_0. */
#define BM_MIPI_CSI_MASK2_mask_phy_erresc_0 (0x00000001U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_erresc_0. */
#define BS_MIPI_CSI_MASK2_mask_phy_erresc_0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_erresc_0. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_erresc_0 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_erresc_0(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_erresc_0)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_erresc_0. */
#define BF_MIPI_CSI_MASK2_mask_phy_erresc_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_erresc_0) & BM_MIPI_CSI_MASK2_mask_phy_erresc_0)

/*! @brief Set the mask_phy_erresc_0 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_erresc_0(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_erresc_0) | BF_MIPI_CSI_MASK2_mask_phy_erresc_0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_erresc_1[1] (RW)
 *
 * Mask for phy_erresc_1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_erresc_1 (1U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_erresc_1. */
#define BM_MIPI_CSI_MASK2_mask_phy_erresc_1 (0x00000002U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_erresc_1. */
#define BS_MIPI_CSI_MASK2_mask_phy_erresc_1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_erresc_1. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_erresc_1 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_erresc_1(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_erresc_1)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_erresc_1. */
#define BF_MIPI_CSI_MASK2_mask_phy_erresc_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_erresc_1) & BM_MIPI_CSI_MASK2_mask_phy_erresc_1)

/*! @brief Set the mask_phy_erresc_1 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_erresc_1(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_erresc_1) | BF_MIPI_CSI_MASK2_mask_phy_erresc_1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_erresc_2[2] (RW)
 *
 * Mask for phy_erresc_2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_erresc_2 (2U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_erresc_2. */
#define BM_MIPI_CSI_MASK2_mask_phy_erresc_2 (0x00000004U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_erresc_2. */
#define BS_MIPI_CSI_MASK2_mask_phy_erresc_2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_erresc_2. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_erresc_2 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_erresc_2(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_erresc_2)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_erresc_2. */
#define BF_MIPI_CSI_MASK2_mask_phy_erresc_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_erresc_2) & BM_MIPI_CSI_MASK2_mask_phy_erresc_2)

/*! @brief Set the mask_phy_erresc_2 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_erresc_2(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_erresc_2) | BF_MIPI_CSI_MASK2_mask_phy_erresc_2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_erresc_3[3] (RW)
 *
 * Mask for phy_erresc_3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_erresc_3 (3U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_erresc_3. */
#define BM_MIPI_CSI_MASK2_mask_phy_erresc_3 (0x00000008U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_erresc_3. */
#define BS_MIPI_CSI_MASK2_mask_phy_erresc_3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_erresc_3. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_erresc_3 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_erresc_3(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_erresc_3)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_erresc_3. */
#define BF_MIPI_CSI_MASK2_mask_phy_erresc_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_erresc_3) & BM_MIPI_CSI_MASK2_mask_phy_erresc_3)

/*! @brief Set the mask_phy_erresc_3 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_erresc_3(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_erresc_3) | BF_MIPI_CSI_MASK2_mask_phy_erresc_3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_errsoths_0[4] (RW)
 *
 * Mask for phy_errsoths_0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_errsoths_0 (4U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_errsoths_0. */
#define BM_MIPI_CSI_MASK2_mask_phy_errsoths_0 (0x00000010U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_errsoths_0. */
#define BS_MIPI_CSI_MASK2_mask_phy_errsoths_0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_errsoths_0. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_errsoths_0 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_errsoths_0(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_errsoths_0)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_errsoths_0. */
#define BF_MIPI_CSI_MASK2_mask_phy_errsoths_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_errsoths_0) & BM_MIPI_CSI_MASK2_mask_phy_errsoths_0)

/*! @brief Set the mask_phy_errsoths_0 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_errsoths_0(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_errsoths_0) | BF_MIPI_CSI_MASK2_mask_phy_errsoths_0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_errsoths_1[5] (RW)
 *
 * Mask for phy_errsoths_1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_errsoths_1 (5U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_errsoths_1. */
#define BM_MIPI_CSI_MASK2_mask_phy_errsoths_1 (0x00000020U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_errsoths_1. */
#define BS_MIPI_CSI_MASK2_mask_phy_errsoths_1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_errsoths_1. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_errsoths_1 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_errsoths_1(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_errsoths_1)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_errsoths_1. */
#define BF_MIPI_CSI_MASK2_mask_phy_errsoths_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_errsoths_1) & BM_MIPI_CSI_MASK2_mask_phy_errsoths_1)

/*! @brief Set the mask_phy_errsoths_1 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_errsoths_1(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_errsoths_1) | BF_MIPI_CSI_MASK2_mask_phy_errsoths_1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_errsoths_2[6] (RW)
 *
 * Mask for phy_errsoths_2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_errsoths_2 (6U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_errsoths_2. */
#define BM_MIPI_CSI_MASK2_mask_phy_errsoths_2 (0x00000040U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_errsoths_2. */
#define BS_MIPI_CSI_MASK2_mask_phy_errsoths_2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_errsoths_2. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_errsoths_2 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_errsoths_2(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_errsoths_2)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_errsoths_2. */
#define BF_MIPI_CSI_MASK2_mask_phy_errsoths_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_errsoths_2) & BM_MIPI_CSI_MASK2_mask_phy_errsoths_2)

/*! @brief Set the mask_phy_errsoths_2 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_errsoths_2(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_errsoths_2) | BF_MIPI_CSI_MASK2_mask_phy_errsoths_2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_phy_errsoths_3[7] (RW)
 *
 * Mask for phy_errsoths_3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_phy_errsoths_3 (7U) /*!< Bit position for MIPI_CSI_MASK2_mask_phy_errsoths_3. */
#define BM_MIPI_CSI_MASK2_mask_phy_errsoths_3 (0x00000080U) /*!< Bit mask for MIPI_CSI_MASK2_mask_phy_errsoths_3. */
#define BS_MIPI_CSI_MASK2_mask_phy_errsoths_3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_phy_errsoths_3. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_phy_errsoths_3 field. */
#define BR_MIPI_CSI_MASK2_mask_phy_errsoths_3(x) (HW_MIPI_CSI_MASK2(x).B.mask_phy_errsoths_3)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_phy_errsoths_3. */
#define BF_MIPI_CSI_MASK2_mask_phy_errsoths_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_phy_errsoths_3) & BM_MIPI_CSI_MASK2_mask_phy_errsoths_3)

/*! @brief Set the mask_phy_errsoths_3 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_phy_errsoths_3(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_phy_errsoths_3) | BF_MIPI_CSI_MASK2_mask_phy_errsoths_3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_vc0_err_ecc_corrected[8] (RW)
 *
 * Mask for vc0_err_ecc_corrected. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected (8U) /*!< Bit position for MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected. */
#define BM_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected (0x00000100U) /*!< Bit mask for MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected. */
#define BS_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected field. */
#define BR_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected(x) (HW_MIPI_CSI_MASK2(x).B.mask_vc0_err_ecc_corrected)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected. */
#define BF_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected) & BM_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected)

/*! @brief Set the mask_vc0_err_ecc_corrected field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected) | BF_MIPI_CSI_MASK2_mask_vc0_err_ecc_corrected(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_vc1_err_ecc_corrected[9] (RW)
 *
 * Mask for vc1_err_ecc_corrected. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected (9U) /*!< Bit position for MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected. */
#define BM_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected (0x00000200U) /*!< Bit mask for MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected. */
#define BS_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected field. */
#define BR_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected(x) (HW_MIPI_CSI_MASK2(x).B.mask_vc1_err_ecc_corrected)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected. */
#define BF_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected) & BM_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected)

/*! @brief Set the mask_vc1_err_ecc_corrected field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected) | BF_MIPI_CSI_MASK2_mask_vc1_err_ecc_corrected(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_vc2_err_ecc_corrected[10] (RW)
 *
 * Mask for vc2_err_ecc_corrected. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected (10U) /*!< Bit position for MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected. */
#define BM_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected (0x00000400U) /*!< Bit mask for MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected. */
#define BS_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected field. */
#define BR_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected(x) (HW_MIPI_CSI_MASK2(x).B.mask_vc2_err_ecc_corrected)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected. */
#define BF_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected) & BM_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected)

/*! @brief Set the mask_vc2_err_ecc_corrected field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected) | BF_MIPI_CSI_MASK2_mask_vc2_err_ecc_corrected(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_vc3_err_ecc_corrected[11] (RW)
 *
 * Mask for vc3_err_ecc_corrected. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected (11U) /*!< Bit position for MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected. */
#define BM_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected (0x00000800U) /*!< Bit mask for MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected. */
#define BS_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected field. */
#define BR_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected(x) (HW_MIPI_CSI_MASK2(x).B.mask_vc3_err_ecc_corrected)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected. */
#define BF_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected) & BM_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected)

/*! @brief Set the mask_vc3_err_ecc_corrected field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected) | BF_MIPI_CSI_MASK2_mask_vc3_err_ecc_corrected(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_id_vc0[12] (RW)
 *
 * Mask for err_id_vc0. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_id_vc0 (12U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_id_vc0. */
#define BM_MIPI_CSI_MASK2_mask_err_id_vc0 (0x00001000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_id_vc0. */
#define BS_MIPI_CSI_MASK2_mask_err_id_vc0 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_id_vc0. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_id_vc0 field. */
#define BR_MIPI_CSI_MASK2_mask_err_id_vc0(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_id_vc0)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_id_vc0. */
#define BF_MIPI_CSI_MASK2_mask_err_id_vc0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_id_vc0) & BM_MIPI_CSI_MASK2_mask_err_id_vc0)

/*! @brief Set the mask_err_id_vc0 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_id_vc0(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_id_vc0) | BF_MIPI_CSI_MASK2_mask_err_id_vc0(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_id_vc1[13] (RW)
 *
 * Mask for err_id_vc1. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_id_vc1 (13U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_id_vc1. */
#define BM_MIPI_CSI_MASK2_mask_err_id_vc1 (0x00002000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_id_vc1. */
#define BS_MIPI_CSI_MASK2_mask_err_id_vc1 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_id_vc1. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_id_vc1 field. */
#define BR_MIPI_CSI_MASK2_mask_err_id_vc1(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_id_vc1)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_id_vc1. */
#define BF_MIPI_CSI_MASK2_mask_err_id_vc1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_id_vc1) & BM_MIPI_CSI_MASK2_mask_err_id_vc1)

/*! @brief Set the mask_err_id_vc1 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_id_vc1(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_id_vc1) | BF_MIPI_CSI_MASK2_mask_err_id_vc1(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_id_vc2[14] (RW)
 *
 * Mask for err_id_vc2. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_id_vc2 (14U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_id_vc2. */
#define BM_MIPI_CSI_MASK2_mask_err_id_vc2 (0x00004000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_id_vc2. */
#define BS_MIPI_CSI_MASK2_mask_err_id_vc2 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_id_vc2. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_id_vc2 field. */
#define BR_MIPI_CSI_MASK2_mask_err_id_vc2(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_id_vc2)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_id_vc2. */
#define BF_MIPI_CSI_MASK2_mask_err_id_vc2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_id_vc2) & BM_MIPI_CSI_MASK2_mask_err_id_vc2)

/*! @brief Set the mask_err_id_vc2 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_id_vc2(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_id_vc2) | BF_MIPI_CSI_MASK2_mask_err_id_vc2(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_id_vc3[15] (RW)
 *
 * Mask for err_id_vc3. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_id_vc3 (15U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_id_vc3. */
#define BM_MIPI_CSI_MASK2_mask_err_id_vc3 (0x00008000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_id_vc3. */
#define BS_MIPI_CSI_MASK2_mask_err_id_vc3 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_id_vc3. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_id_vc3 field. */
#define BR_MIPI_CSI_MASK2_mask_err_id_vc3(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_id_vc3)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_id_vc3. */
#define BF_MIPI_CSI_MASK2_mask_err_id_vc3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_id_vc3) & BM_MIPI_CSI_MASK2_mask_err_id_vc3)

/*! @brief Set the mask_err_id_vc3 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_id_vc3(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_id_vc3) | BF_MIPI_CSI_MASK2_mask_err_id_vc3(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_bndry_match_di4[16] (RW)
 *
 * Mask for err_l_bndry_match_di4. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4 (16U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_bndry_match_di4. */
#define BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4 (0x00010000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_bndry_match_di4. */
#define BS_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_bndry_match_di4. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_bndry_match_di4 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_bndry_match_di4)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_bndry_match_di4. */
#define BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4) & BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4)

/*! @brief Set the mask_err_l_bndry_match_di4 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4) | BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di4(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_bndry_match_di5[17] (RW)
 *
 * Mask for err_l_bndry_match_di5. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5 (17U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_bndry_match_di5. */
#define BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5 (0x00020000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_bndry_match_di5. */
#define BS_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_bndry_match_di5. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_bndry_match_di5 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_bndry_match_di5)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_bndry_match_di5. */
#define BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5) & BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5)

/*! @brief Set the mask_err_l_bndry_match_di5 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5) | BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di5(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_bndry_match_di6[18] (RW)
 *
 * Mask for err_l_bndry_match_di6. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6 (18U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_bndry_match_di6. */
#define BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6 (0x00040000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_bndry_match_di6. */
#define BS_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_bndry_match_di6. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_bndry_match_di6 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_bndry_match_di6)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_bndry_match_di6. */
#define BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6) & BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6)

/*! @brief Set the mask_err_l_bndry_match_di6 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6) | BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di6(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_bndry_match_di7[19] (RW)
 *
 * Mask for err_l_bndry_match_di7. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7 (19U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_bndry_match_di7. */
#define BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7 (0x00080000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_bndry_match_di7. */
#define BS_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_bndry_match_di7. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_bndry_match_di7 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_bndry_match_di7)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_bndry_match_di7. */
#define BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7) & BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7)

/*! @brief Set the mask_err_l_bndry_match_di7 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7) | BF_MIPI_CSI_MASK2_mask_err_l_bndry_match_di7(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_seq_di4[20] (RW)
 *
 * Mask for err_l_seq_di4. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_seq_di4 (20U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_seq_di4. */
#define BM_MIPI_CSI_MASK2_mask_err_l_seq_di4 (0x00100000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_seq_di4. */
#define BS_MIPI_CSI_MASK2_mask_err_l_seq_di4 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_seq_di4. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_seq_di4 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_seq_di4(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_seq_di4)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_seq_di4. */
#define BF_MIPI_CSI_MASK2_mask_err_l_seq_di4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_seq_di4) & BM_MIPI_CSI_MASK2_mask_err_l_seq_di4)

/*! @brief Set the mask_err_l_seq_di4 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_seq_di4(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_seq_di4) | BF_MIPI_CSI_MASK2_mask_err_l_seq_di4(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_seq_di5[21] (RW)
 *
 * Mask for err_l_seq_di5. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_seq_di5 (21U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_seq_di5. */
#define BM_MIPI_CSI_MASK2_mask_err_l_seq_di5 (0x00200000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_seq_di5. */
#define BS_MIPI_CSI_MASK2_mask_err_l_seq_di5 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_seq_di5. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_seq_di5 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_seq_di5(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_seq_di5)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_seq_di5. */
#define BF_MIPI_CSI_MASK2_mask_err_l_seq_di5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_seq_di5) & BM_MIPI_CSI_MASK2_mask_err_l_seq_di5)

/*! @brief Set the mask_err_l_seq_di5 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_seq_di5(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_seq_di5) | BF_MIPI_CSI_MASK2_mask_err_l_seq_di5(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_seq_di6[22] (RW)
 *
 * Mask for err_l_seq_di6. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_seq_di6 (22U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_seq_di6. */
#define BM_MIPI_CSI_MASK2_mask_err_l_seq_di6 (0x00400000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_seq_di6. */
#define BS_MIPI_CSI_MASK2_mask_err_l_seq_di6 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_seq_di6. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_seq_di6 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_seq_di6(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_seq_di6)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_seq_di6. */
#define BF_MIPI_CSI_MASK2_mask_err_l_seq_di6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_seq_di6) & BM_MIPI_CSI_MASK2_mask_err_l_seq_di6)

/*! @brief Set the mask_err_l_seq_di6 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_seq_di6(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_seq_di6) | BF_MIPI_CSI_MASK2_mask_err_l_seq_di6(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_MASK2, field mask_err_l_seq_di7[23] (RW)
 *
 * Mask for err_l_seq_di7. Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_MASK2_mask_err_l_seq_di7 (23U) /*!< Bit position for MIPI_CSI_MASK2_mask_err_l_seq_di7. */
#define BM_MIPI_CSI_MASK2_mask_err_l_seq_di7 (0x00800000U) /*!< Bit mask for MIPI_CSI_MASK2_mask_err_l_seq_di7. */
#define BS_MIPI_CSI_MASK2_mask_err_l_seq_di7 (1U) /*!< Bit field size in bits for MIPI_CSI_MASK2_mask_err_l_seq_di7. */

/*! @brief Read current value of the MIPI_CSI_MASK2_mask_err_l_seq_di7 field. */
#define BR_MIPI_CSI_MASK2_mask_err_l_seq_di7(x) (HW_MIPI_CSI_MASK2(x).B.mask_err_l_seq_di7)

/*! @brief Format value for bitfield MIPI_CSI_MASK2_mask_err_l_seq_di7. */
#define BF_MIPI_CSI_MASK2_mask_err_l_seq_di7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_MASK2_mask_err_l_seq_di7) & BM_MIPI_CSI_MASK2_mask_err_l_seq_di7)

/*! @brief Set the mask_err_l_seq_di7 field to a new value. */
#define BW_MIPI_CSI_MASK2_mask_err_l_seq_di7(x, v) (HW_MIPI_CSI_MASK2_WR(x, (HW_MIPI_CSI_MASK2_RD(x) & ~BM_MIPI_CSI_MASK2_mask_err_l_seq_di7) | BF_MIPI_CSI_MASK2_mask_err_l_seq_di7(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_PHY_TST_CRTL0 - D-PHY Test interface control 0
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_PHY_TST_CRTL0 - D-PHY Test interface control 0 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_phy_tst_crtl0
{
    uint32_t U;
    struct _hw_mipi_csi_phy_tst_crtl0_bitfields
    {
        uint32_t phy_testclr : 1;      /*!< [0]  */
        uint32_t phy_testclk : 1;      /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_mipi_csi_phy_tst_crtl0_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_PHY_TST_CRTL0 register
 */
/*@{*/
#define HW_MIPI_CSI_PHY_TST_CRTL0_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_MIPI_CSI_PHY_TST_CRTL0(x) (*(__IO hw_mipi_csi_phy_tst_crtl0_t *) HW_MIPI_CSI_PHY_TST_CRTL0_ADDR(x))
#define HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) (HW_MIPI_CSI_PHY_TST_CRTL0(x).U)
#define HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0(x).U = (v))
#define HW_MIPI_CSI_PHY_TST_CRTL0_SET(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) |  (v)))
#define HW_MIPI_CSI_PHY_TST_CRTL0_CLR(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) & ~(v)))
#define HW_MIPI_CSI_PHY_TST_CRTL0_TOG(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_PHY_TST_CRTL0 bitfields
 */

/*!
 * @name Register MIPI_CSI_PHY_TST_CRTL0, field phy_testclr[0] (RW)
 *
 * PHY test interface clear. Used when active performs vendor specific interface
 * initialization(Active High). Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_TST_CRTL0_phy_testclr (0U) /*!< Bit position for MIPI_CSI_PHY_TST_CRTL0_phy_testclr. */
#define BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclr (0x00000001U) /*!< Bit mask for MIPI_CSI_PHY_TST_CRTL0_phy_testclr. */
#define BS_MIPI_CSI_PHY_TST_CRTL0_phy_testclr (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_TST_CRTL0_phy_testclr. */

/*! @brief Read current value of the MIPI_CSI_PHY_TST_CRTL0_phy_testclr field. */
#define BR_MIPI_CSI_PHY_TST_CRTL0_phy_testclr(x) (HW_MIPI_CSI_PHY_TST_CRTL0(x).B.phy_testclr)

/*! @brief Format value for bitfield MIPI_CSI_PHY_TST_CRTL0_phy_testclr. */
#define BF_MIPI_CSI_PHY_TST_CRTL0_phy_testclr(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_TST_CRTL0_phy_testclr) & BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclr)

/*! @brief Set the phy_testclr field to a new value. */
#define BW_MIPI_CSI_PHY_TST_CRTL0_phy_testclr(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, (HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) & ~BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclr) | BF_MIPI_CSI_PHY_TST_CRTL0_phy_testclr(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_TST_CRTL0, field phy_testclk[1] (RW)
 *
 * PHY test interface strobe signal. Used to clock TESTDIN bus into the D-PHY.
 * In conjunction with TESTEN signal controls the operation selection. Default
 * Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_TST_CRTL0_phy_testclk (1U) /*!< Bit position for MIPI_CSI_PHY_TST_CRTL0_phy_testclk. */
#define BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclk (0x00000002U) /*!< Bit mask for MIPI_CSI_PHY_TST_CRTL0_phy_testclk. */
#define BS_MIPI_CSI_PHY_TST_CRTL0_phy_testclk (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_TST_CRTL0_phy_testclk. */

/*! @brief Read current value of the MIPI_CSI_PHY_TST_CRTL0_phy_testclk field. */
#define BR_MIPI_CSI_PHY_TST_CRTL0_phy_testclk(x) (HW_MIPI_CSI_PHY_TST_CRTL0(x).B.phy_testclk)

/*! @brief Format value for bitfield MIPI_CSI_PHY_TST_CRTL0_phy_testclk. */
#define BF_MIPI_CSI_PHY_TST_CRTL0_phy_testclk(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_TST_CRTL0_phy_testclk) & BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclk)

/*! @brief Set the phy_testclk field to a new value. */
#define BW_MIPI_CSI_PHY_TST_CRTL0_phy_testclk(x, v) (HW_MIPI_CSI_PHY_TST_CRTL0_WR(x, (HW_MIPI_CSI_PHY_TST_CRTL0_RD(x) & ~BM_MIPI_CSI_PHY_TST_CRTL0_phy_testclk) | BF_MIPI_CSI_PHY_TST_CRTL0_phy_testclk(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_CSI_PHY_TST_CTRL1 - D-PHY Test interface control 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_CSI_PHY_TST_CTRL1 - D-PHY Test interface control 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_csi_phy_tst_ctrl1
{
    uint32_t U;
    struct _hw_mipi_csi_phy_tst_ctrl1_bitfields
    {
        uint32_t phy_testdin : 8;      /*!< [7:0]  */
        uint32_t phy_testdout : 8;     /*!< [15:8]  */
        uint32_t phy_testen : 1;       /*!< [16]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_mipi_csi_phy_tst_ctrl1_t;

/*!
 * @name Constants and macros for entire MIPI_CSI_PHY_TST_CTRL1 register
 */
/*@{*/
#define HW_MIPI_CSI_PHY_TST_CTRL1_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_MIPI_CSI_PHY_TST_CTRL1(x) (*(__IO hw_mipi_csi_phy_tst_ctrl1_t *) HW_MIPI_CSI_PHY_TST_CTRL1_ADDR(x))
#define HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) (HW_MIPI_CSI_PHY_TST_CTRL1(x).U)
#define HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1(x).U = (v))
#define HW_MIPI_CSI_PHY_TST_CTRL1_SET(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) |  (v)))
#define HW_MIPI_CSI_PHY_TST_CTRL1_CLR(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) & ~(v)))
#define HW_MIPI_CSI_PHY_TST_CTRL1_TOG(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_CSI_PHY_TST_CTRL1 bitfields
 */

/*!
 * @name Register MIPI_CSI_PHY_TST_CTRL1, field phy_testdin[7:0] (RW)
 *
 * PHY test interface input 8-bit data bus for internal register programming and
 * test functionalities access Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_TST_CTRL1_phy_testdin (0U) /*!< Bit position for MIPI_CSI_PHY_TST_CTRL1_phy_testdin. */
#define BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdin (0x000000FFU) /*!< Bit mask for MIPI_CSI_PHY_TST_CTRL1_phy_testdin. */
#define BS_MIPI_CSI_PHY_TST_CTRL1_phy_testdin (8U) /*!< Bit field size in bits for MIPI_CSI_PHY_TST_CTRL1_phy_testdin. */

/*! @brief Read current value of the MIPI_CSI_PHY_TST_CTRL1_phy_testdin field. */
#define BR_MIPI_CSI_PHY_TST_CTRL1_phy_testdin(x) (HW_MIPI_CSI_PHY_TST_CTRL1(x).B.phy_testdin)

/*! @brief Format value for bitfield MIPI_CSI_PHY_TST_CTRL1_phy_testdin. */
#define BF_MIPI_CSI_PHY_TST_CTRL1_phy_testdin(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_TST_CTRL1_phy_testdin) & BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdin)

/*! @brief Set the phy_testdin field to a new value. */
#define BW_MIPI_CSI_PHY_TST_CTRL1_phy_testdin(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdin) | BF_MIPI_CSI_PHY_TST_CTRL1_phy_testdin(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_TST_CTRL1, field phy_testdout[15:8] (RW)
 *
 * PHY output 8-bit data bus for read-back and internal probing functionalities.
 * Default Value: 0
 */
/*@{*/
#define BP_MIPI_CSI_PHY_TST_CTRL1_phy_testdout (8U) /*!< Bit position for MIPI_CSI_PHY_TST_CTRL1_phy_testdout. */
#define BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdout (0x0000FF00U) /*!< Bit mask for MIPI_CSI_PHY_TST_CTRL1_phy_testdout. */
#define BS_MIPI_CSI_PHY_TST_CTRL1_phy_testdout (8U) /*!< Bit field size in bits for MIPI_CSI_PHY_TST_CTRL1_phy_testdout. */

/*! @brief Read current value of the MIPI_CSI_PHY_TST_CTRL1_phy_testdout field. */
#define BR_MIPI_CSI_PHY_TST_CTRL1_phy_testdout(x) (HW_MIPI_CSI_PHY_TST_CTRL1(x).B.phy_testdout)

/*! @brief Format value for bitfield MIPI_CSI_PHY_TST_CTRL1_phy_testdout. */
#define BF_MIPI_CSI_PHY_TST_CTRL1_phy_testdout(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_TST_CTRL1_phy_testdout) & BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdout)

/*! @brief Set the phy_testdout field to a new value. */
#define BW_MIPI_CSI_PHY_TST_CTRL1_phy_testdout(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_CSI_PHY_TST_CTRL1_phy_testdout) | BF_MIPI_CSI_PHY_TST_CTRL1_phy_testdout(v)))
/*@}*/

/*!
 * @name Register MIPI_CSI_PHY_TST_CTRL1, field phy_testen[16] (RW)
 *
 * PHY test interface operation selector:
 *
 * Values:
 * - 1 - configures address write operation on the falling edge of TESTCLK
 * - 0 - configures a data write operation on the rising edge of TESTCLK
 */
/*@{*/
#define BP_MIPI_CSI_PHY_TST_CTRL1_phy_testen (16U) /*!< Bit position for MIPI_CSI_PHY_TST_CTRL1_phy_testen. */
#define BM_MIPI_CSI_PHY_TST_CTRL1_phy_testen (0x00010000U) /*!< Bit mask for MIPI_CSI_PHY_TST_CTRL1_phy_testen. */
#define BS_MIPI_CSI_PHY_TST_CTRL1_phy_testen (1U) /*!< Bit field size in bits for MIPI_CSI_PHY_TST_CTRL1_phy_testen. */

/*! @brief Read current value of the MIPI_CSI_PHY_TST_CTRL1_phy_testen field. */
#define BR_MIPI_CSI_PHY_TST_CTRL1_phy_testen(x) (HW_MIPI_CSI_PHY_TST_CTRL1(x).B.phy_testen)

/*! @brief Format value for bitfield MIPI_CSI_PHY_TST_CTRL1_phy_testen. */
#define BF_MIPI_CSI_PHY_TST_CTRL1_phy_testen(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_CSI_PHY_TST_CTRL1_phy_testen) & BM_MIPI_CSI_PHY_TST_CTRL1_phy_testen)

/*! @brief Set the phy_testen field to a new value. */
#define BW_MIPI_CSI_PHY_TST_CTRL1_phy_testen(x, v) (HW_MIPI_CSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_CSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_CSI_PHY_TST_CTRL1_phy_testen) | BF_MIPI_CSI_PHY_TST_CTRL1_phy_testen(v)))
/*@}*/

/*******************************************************************************
 * hw_mipi_csi_t - module struct
 ******************************************************************************/
/*!
 * @brief All MIPI_CSI module registers.
 */
#pragma pack(1)
typedef struct _hw_mipi_csi
{
    __I hw_mipi_csi_version_t VERSION;     /*!< [0x0] Controller Version Identification Register */
    __IO hw_mipi_csi_n_lanes_t N_LANES;    /*!< [0x4] Number of Active Data Lanes */
    __IO hw_mipi_csi_phy_shutdownz_t PHY_SHUTDOWNZ; /*!< [0x8] Phy shutdown control */
    __IO hw_mipi_csi_dphy_rstz_t DPHY_RSTZ; /*!< [0xC] Phy reset control */
    __IO hw_mipi_csi_csi2_resetn_t CSI2_RESETN; /*!< [0x10] CSI2 controller reset */
    __IO hw_mipi_csi_phy_state_t PHY_STATE; /*!< [0x14] General settings for all blocks */
    __IO hw_mipi_csi_data_ids_1_t DATA_IDS_1; /*!< [0x18] Data IDs for which IDI reports line boundary matching errors */
    __IO hw_mipi_csi_data_ids_2_t DATA_IDS_2; /*!< [0x1C] Data IDs for which IDI reports line boundary matching errors */
    __I hw_mipi_csi_err1_t ERR1;           /*!< [0x20] Error state register 1 */
    __I hw_mipi_csi_err2_t ERR2;           /*!< [0x24] Error state register 2 */
    __IO hw_mipi_csi_mask1_t MASK1;        /*!< [0x28] Masks for errors 1 */
    __IO hw_mipi_csi_mask2_t MASK2;        /*!< [0x2C] Masks for errors 2 */
    __IO hw_mipi_csi_phy_tst_crtl0_t PHY_TST_CRTL0; /*!< [0x30] D-PHY Test interface control 0 */
    __IO hw_mipi_csi_phy_tst_ctrl1_t PHY_TST_CTRL1; /*!< [0x34] D-PHY Test interface control 1 */
} hw_mipi_csi_t;
#pragma pack()

/*! @brief Macro to access all MIPI_CSI registers. */
/*! @param x MIPI_CSI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_MIPI_CSI_REGS(MIPI_CSI_BASE)</code>. */
#define HW_MIPI_CSI_REGS(x) (*(hw_mipi_csi_t *)(x))

/*
 * iMX6DP MIPI_DSI
 *
 * MIPI_DSI
 *
 * Registers defined in this header file:
 * - HW_MIPI_DSI_VERSION - Version of the DSI host ctrl
 * - HW_MIPI_DSI_PWR_UP - Core power up
 * - HW_MIPI_DSI_CLKMGR_CFG - Number of active data lanes
 * - HW_MIPI_DSI_DPI_CFG - DPI interface configuration
 * - HW_MIPI_DSI_DBI_CFG - DBI interface configuration
 * - HW_MIPI_DSI_DBIS_CMDSIZE - DBI command size configuration
 * - HW_MIPI_DSI_PCKHDL_CFG - Packet handler configuration
 * - HW_MIPI_DSI_VID_MODE_CFG - Video Mode Configuration
 * - HW_MIPI_DSI_VID_PKT_CFG - Video packet configuration
 * - HW_MIPI_DSI_CMD_MODE_CFG - Command mode configuration
 * - HW_MIPI_DSI_TMR_LINE_CFG - Line timer configuration
 * - HW_MIPI_DSI_VTIMING_CFG - Vertical timing configuration
 * - HW_MIPI_DSI_PHY_TMR_CFG - D-PHY timing configuration
 * - HW_MIPI_DSI_GEN_HDR - Generic packet Header configuration
 * - HW_MIPI_DSI_GEN_PLD_DATA - Generic payload data in/out
 * - HW_MIPI_DSI_CMD_PKT_STATUS - Command packet status
 * - HW_MIPI_DSI_TO_CNT_CFG0 - Time Out timers configuration
 * - HW_MIPI_DSI_ERROR_ST0 - Interrupt status register 0
 * - HW_MIPI_DSI_ERROR_ST1 - Interrupt status register 1
 * - HW_MIPI_DSI_ERROR_MSK0 - Masks Interrupt generation trigged by ERROR_ST0 register
 * - HW_MIPI_DSI_ERROR_MSK1 - Masks Interrupt generation trigged by ERROR_ST1 register
 * - HW_MIPI_DSI_PHY_RSTZ - D-PHY reset control
 * - HW_MIPI_DSI_PHY_IF_CFG_ - D-PHY interface configuration
 * - HW_MIPI_DSI_PHY_IF_CTRL - D-PHY PPI interface control
 * - HW_MIPI_DSI_PHY_STATUS - D-PHY PPI status interface
 * - HW_MIPI_DSI_PHY_TST_CTRL0 - D-PHY Test interface control 0
 * - HW_MIPI_DSI_PHY_TST_CTRL1 - D-PHY Test interface control 1
 *
 * - hw_mipi_dsi_t - Struct containing all module registers.
 */

#define HW_MIPI_DSI_INSTANCE_COUNT (1U) /*!< Number of instances of the MIPI_DSI module. */
#define HW_MIPI_DSI (0U) /*!< Instance number for MIPI_DSI. */
#define MIPI_DSI_BASE         (0x21E0000U) /*!< Base address for MIPI_DSI. */
/*! Array initializer of MIPI_DSI base addresses. */
#define MIPI_DSI_BASE_ADDRS   { MIPI_DSI_BASE }

/*******************************************************************************
 * HW_MIPI_DSI_VERSION - Version of the DSI host ctrl
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_VERSION - Version of the DSI host ctrl (RO)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x0 Memory Access: R
 */
typedef union _hw_mipi_dsi_version
{
    uint32_t U;
    struct _hw_mipi_dsi_version_bitfields
    {
        uint32_t version : 32;         /*!< [31:0]  */
    } B;
} hw_mipi_dsi_version_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_VERSION register
 */
/*@{*/
#define HW_MIPI_DSI_VERSION_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_MIPI_DSI_VERSION(x)   (*(__I hw_mipi_dsi_version_t *) HW_MIPI_DSI_VERSION_ADDR(x))
#define HW_MIPI_DSI_VERSION_RD(x) (HW_MIPI_DSI_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_VERSION bitfields
 */

/*!
 * @name Register MIPI_DSI_VERSION, field version[31:0] (RO)
 *
 * Version of the DSI host controller
 */
/*@{*/
#define BP_MIPI_DSI_VERSION_version (0U)   /*!< Bit position for MIPI_DSI_VERSION_version. */
#define BM_MIPI_DSI_VERSION_version (0xFFFFFFFFU) /*!< Bit mask for MIPI_DSI_VERSION_version. */
#define BS_MIPI_DSI_VERSION_version (32U)  /*!< Bit field size in bits for MIPI_DSI_VERSION_version. */

/*! @brief Read current value of the MIPI_DSI_VERSION_version field. */
#define BR_MIPI_DSI_VERSION_version(x) (HW_MIPI_DSI_VERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PWR_UP - Core power up
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PWR_UP - Core power up (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x4 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_pwr_up
{
    uint32_t U;
    struct _hw_mipi_dsi_pwr_up_bitfields
    {
        uint32_t shutdownz : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_mipi_dsi_pwr_up_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PWR_UP register
 */
/*@{*/
#define HW_MIPI_DSI_PWR_UP_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_MIPI_DSI_PWR_UP(x)    (*(__IO hw_mipi_dsi_pwr_up_t *) HW_MIPI_DSI_PWR_UP_ADDR(x))
#define HW_MIPI_DSI_PWR_UP_RD(x) (HW_MIPI_DSI_PWR_UP(x).U)
#define HW_MIPI_DSI_PWR_UP_WR(x, v) (HW_MIPI_DSI_PWR_UP(x).U = (v))
#define HW_MIPI_DSI_PWR_UP_SET(x, v) (HW_MIPI_DSI_PWR_UP_WR(x, HW_MIPI_DSI_PWR_UP_RD(x) |  (v)))
#define HW_MIPI_DSI_PWR_UP_CLR(x, v) (HW_MIPI_DSI_PWR_UP_WR(x, HW_MIPI_DSI_PWR_UP_RD(x) & ~(v)))
#define HW_MIPI_DSI_PWR_UP_TOG(x, v) (HW_MIPI_DSI_PWR_UP_WR(x, HW_MIPI_DSI_PWR_UP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PWR_UP bitfields
 */

/*!
 * @name Register MIPI_DSI_PWR_UP, field shutdownz[0] (RW)
 *
 * Core power up
 *
 * Values:
 * - 0 - reset;
 * - 1 - power up)
 */
/*@{*/
#define BP_MIPI_DSI_PWR_UP_shutdownz (0U)  /*!< Bit position for MIPI_DSI_PWR_UP_shutdownz. */
#define BM_MIPI_DSI_PWR_UP_shutdownz (0x00000001U) /*!< Bit mask for MIPI_DSI_PWR_UP_shutdownz. */
#define BS_MIPI_DSI_PWR_UP_shutdownz (1U)  /*!< Bit field size in bits for MIPI_DSI_PWR_UP_shutdownz. */

/*! @brief Read current value of the MIPI_DSI_PWR_UP_shutdownz field. */
#define BR_MIPI_DSI_PWR_UP_shutdownz(x) (HW_MIPI_DSI_PWR_UP(x).B.shutdownz)

/*! @brief Format value for bitfield MIPI_DSI_PWR_UP_shutdownz. */
#define BF_MIPI_DSI_PWR_UP_shutdownz(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PWR_UP_shutdownz) & BM_MIPI_DSI_PWR_UP_shutdownz)

/*! @brief Set the shutdownz field to a new value. */
#define BW_MIPI_DSI_PWR_UP_shutdownz(x, v) (HW_MIPI_DSI_PWR_UP_WR(x, (HW_MIPI_DSI_PWR_UP_RD(x) & ~BM_MIPI_DSI_PWR_UP_shutdownz) | BF_MIPI_DSI_PWR_UP_shutdownz(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_CLKMGR_CFG - Number of active data lanes
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_CLKMGR_CFG - Number of active data lanes (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x8 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_clkmgr_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_clkmgr_cfg_bitfields
    {
        uint32_t TX_ESC_CLK_DIVIDSION : 8; /*!< [7:0]  */
        uint32_t TO_CLK_DIVIDSION : 8; /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_mipi_dsi_clkmgr_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_CLKMGR_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_CLKMGR_CFG_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_MIPI_DSI_CLKMGR_CFG(x) (*(__IO hw_mipi_dsi_clkmgr_cfg_t *) HW_MIPI_DSI_CLKMGR_CFG_ADDR(x))
#define HW_MIPI_DSI_CLKMGR_CFG_RD(x) (HW_MIPI_DSI_CLKMGR_CFG(x).U)
#define HW_MIPI_DSI_CLKMGR_CFG_WR(x, v) (HW_MIPI_DSI_CLKMGR_CFG(x).U = (v))
#define HW_MIPI_DSI_CLKMGR_CFG_SET(x, v) (HW_MIPI_DSI_CLKMGR_CFG_WR(x, HW_MIPI_DSI_CLKMGR_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_CLKMGR_CFG_CLR(x, v) (HW_MIPI_DSI_CLKMGR_CFG_WR(x, HW_MIPI_DSI_CLKMGR_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_CLKMGR_CFG_TOG(x, v) (HW_MIPI_DSI_CLKMGR_CFG_WR(x, HW_MIPI_DSI_CLKMGR_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_CLKMGR_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_CLKMGR_CFG, field TX_ESC_CLK_DIVIDSION[7:0] (RW)
 *
 * Division factor for TX ESCAPE clock source (lanebyteclk pin), values 0 and 1
 * stop TX_ESC clock generation.
 */
/*@{*/
#define BP_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION (0U) /*!< Bit position for MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION. */
#define BM_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION (0x000000FFU) /*!< Bit mask for MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION. */
#define BS_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION (8U) /*!< Bit field size in bits for MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION. */

/*! @brief Read current value of the MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION field. */
#define BR_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION(x) (HW_MIPI_DSI_CLKMGR_CFG(x).B.TX_ESC_CLK_DIVIDSION)

/*! @brief Format value for bitfield MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION. */
#define BF_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION) & BM_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION)

/*! @brief Set the TX_ESC_CLK_DIVIDSION field to a new value. */
#define BW_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION(x, v) (HW_MIPI_DSI_CLKMGR_CFG_WR(x, (HW_MIPI_DSI_CLKMGR_CFG_RD(x) & ~BM_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION) | BF_MIPI_DSI_CLKMGR_CFG_TX_ESC_CLK_DIVIDSION(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CLKMGR_CFG, field TO_CLK_DIVIDSION[15:8] (RW)
 *
 * Division factor for Time Out clock used as timing unit in the configuration
 * of HS to LP and LP to HS transition error.
 */
/*@{*/
#define BP_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION (8U) /*!< Bit position for MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION. */
#define BM_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION (0x0000FF00U) /*!< Bit mask for MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION. */
#define BS_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION (8U) /*!< Bit field size in bits for MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION. */

/*! @brief Read current value of the MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION field. */
#define BR_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION(x) (HW_MIPI_DSI_CLKMGR_CFG(x).B.TO_CLK_DIVIDSION)

/*! @brief Format value for bitfield MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION. */
#define BF_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION) & BM_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION)

/*! @brief Set the TO_CLK_DIVIDSION field to a new value. */
#define BW_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION(x, v) (HW_MIPI_DSI_CLKMGR_CFG_WR(x, (HW_MIPI_DSI_CLKMGR_CFG_RD(x) & ~BM_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION) | BF_MIPI_DSI_CLKMGR_CFG_TO_CLK_DIVIDSION(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_DPI_CFG - DPI interface configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_DPI_CFG - DPI interface configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0xc Memory Access: R/W
 */
typedef union _hw_mipi_dsi_dpi_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_dpi_cfg_bitfields
    {
        uint32_t dpi_vid : 2;          /*!< [1:0]  */
        uint32_t dpi_color_coding : 3; /*!< [4:2]  */
        uint32_t dataen_active_low : 1; /*!< [5]  */
        uint32_t vsync_active_low : 1; /*!< [6]  */
        uint32_t hsync_active_low : 1; /*!< [7]  */
        uint32_t shutd_active_low : 1; /*!< [8]  */
        uint32_t colorm_active_low : 1; /*!< [9]  */
        uint32_t en18_loosely : 1;     /*!< [10]  */
        uint32_t RESERVED0 : 21;       /*!< [31:11]  */
    } B;
} hw_mipi_dsi_dpi_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_DPI_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_DPI_CFG_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_MIPI_DSI_DPI_CFG(x)   (*(__IO hw_mipi_dsi_dpi_cfg_t *) HW_MIPI_DSI_DPI_CFG_ADDR(x))
#define HW_MIPI_DSI_DPI_CFG_RD(x) (HW_MIPI_DSI_DPI_CFG(x).U)
#define HW_MIPI_DSI_DPI_CFG_WR(x, v) (HW_MIPI_DSI_DPI_CFG(x).U = (v))
#define HW_MIPI_DSI_DPI_CFG_SET(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, HW_MIPI_DSI_DPI_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_DPI_CFG_CLR(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, HW_MIPI_DSI_DPI_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_DPI_CFG_TOG(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, HW_MIPI_DSI_DPI_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_DPI_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_DPI_CFG, field dpi_vid[1:0] (RW)
 *
 * Configures the DPI Virtual Channel ID that will be indexed to the Video mode
 * packets.
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_dpi_vid (0U)   /*!< Bit position for MIPI_DSI_DPI_CFG_dpi_vid. */
#define BM_MIPI_DSI_DPI_CFG_dpi_vid (0x00000003U) /*!< Bit mask for MIPI_DSI_DPI_CFG_dpi_vid. */
#define BS_MIPI_DSI_DPI_CFG_dpi_vid (2U)   /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_dpi_vid. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_dpi_vid field. */
#define BR_MIPI_DSI_DPI_CFG_dpi_vid(x) (HW_MIPI_DSI_DPI_CFG(x).B.dpi_vid)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_dpi_vid. */
#define BF_MIPI_DSI_DPI_CFG_dpi_vid(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_dpi_vid) & BM_MIPI_DSI_DPI_CFG_dpi_vid)

/*! @brief Set the dpi_vid field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_dpi_vid(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_dpi_vid) | BF_MIPI_DSI_DPI_CFG_dpi_vid(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field dpi_color_coding[4:2] (RW)
 *
 * DPI color coding.
 *
 * Values:
 * - 0 - 16bit config1
 * - 1 - 16bit config2;
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_dpi_color_coding (2U) /*!< Bit position for MIPI_DSI_DPI_CFG_dpi_color_coding. */
#define BM_MIPI_DSI_DPI_CFG_dpi_color_coding (0x0000001CU) /*!< Bit mask for MIPI_DSI_DPI_CFG_dpi_color_coding. */
#define BS_MIPI_DSI_DPI_CFG_dpi_color_coding (3U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_dpi_color_coding. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_dpi_color_coding field. */
#define BR_MIPI_DSI_DPI_CFG_dpi_color_coding(x) (HW_MIPI_DSI_DPI_CFG(x).B.dpi_color_coding)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_dpi_color_coding. */
#define BF_MIPI_DSI_DPI_CFG_dpi_color_coding(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_dpi_color_coding) & BM_MIPI_DSI_DPI_CFG_dpi_color_coding)

/*! @brief Set the dpi_color_coding field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_dpi_color_coding(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_dpi_color_coding) | BF_MIPI_DSI_DPI_CFG_dpi_color_coding(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field dataen_active_low[5] (RW)
 *
 * Set to configure Data enable pin (dpidaten) as Active low
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_dataen_active_low (5U) /*!< Bit position for MIPI_DSI_DPI_CFG_dataen_active_low. */
#define BM_MIPI_DSI_DPI_CFG_dataen_active_low (0x00000020U) /*!< Bit mask for MIPI_DSI_DPI_CFG_dataen_active_low. */
#define BS_MIPI_DSI_DPI_CFG_dataen_active_low (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_dataen_active_low. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_dataen_active_low field. */
#define BR_MIPI_DSI_DPI_CFG_dataen_active_low(x) (HW_MIPI_DSI_DPI_CFG(x).B.dataen_active_low)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_dataen_active_low. */
#define BF_MIPI_DSI_DPI_CFG_dataen_active_low(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_dataen_active_low) & BM_MIPI_DSI_DPI_CFG_dataen_active_low)

/*! @brief Set the dataen_active_low field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_dataen_active_low(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_dataen_active_low) | BF_MIPI_DSI_DPI_CFG_dataen_active_low(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field vsync_active_low[6] (RW)
 *
 * Set to configure Vertical Synchronism pin (dpivsync) as Active low
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_vsync_active_low (6U) /*!< Bit position for MIPI_DSI_DPI_CFG_vsync_active_low. */
#define BM_MIPI_DSI_DPI_CFG_vsync_active_low (0x00000040U) /*!< Bit mask for MIPI_DSI_DPI_CFG_vsync_active_low. */
#define BS_MIPI_DSI_DPI_CFG_vsync_active_low (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_vsync_active_low. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_vsync_active_low field. */
#define BR_MIPI_DSI_DPI_CFG_vsync_active_low(x) (HW_MIPI_DSI_DPI_CFG(x).B.vsync_active_low)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_vsync_active_low. */
#define BF_MIPI_DSI_DPI_CFG_vsync_active_low(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_vsync_active_low) & BM_MIPI_DSI_DPI_CFG_vsync_active_low)

/*! @brief Set the vsync_active_low field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_vsync_active_low(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_vsync_active_low) | BF_MIPI_DSI_DPI_CFG_vsync_active_low(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field hsync_active_low[7] (RW)
 *
 * Set to configure Horizontal Synchronism pin (dpihsync) as Active low
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_hsync_active_low (7U) /*!< Bit position for MIPI_DSI_DPI_CFG_hsync_active_low. */
#define BM_MIPI_DSI_DPI_CFG_hsync_active_low (0x00000080U) /*!< Bit mask for MIPI_DSI_DPI_CFG_hsync_active_low. */
#define BS_MIPI_DSI_DPI_CFG_hsync_active_low (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_hsync_active_low. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_hsync_active_low field. */
#define BR_MIPI_DSI_DPI_CFG_hsync_active_low(x) (HW_MIPI_DSI_DPI_CFG(x).B.hsync_active_low)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_hsync_active_low. */
#define BF_MIPI_DSI_DPI_CFG_hsync_active_low(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_hsync_active_low) & BM_MIPI_DSI_DPI_CFG_hsync_active_low)

/*! @brief Set the hsync_active_low field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_hsync_active_low(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_hsync_active_low) | BF_MIPI_DSI_DPI_CFG_hsync_active_low(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field shutd_active_low[8] (RW)
 *
 * Set to configure Shut Down pin (dpishutdn) as Active low
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_shutd_active_low (8U) /*!< Bit position for MIPI_DSI_DPI_CFG_shutd_active_low. */
#define BM_MIPI_DSI_DPI_CFG_shutd_active_low (0x00000100U) /*!< Bit mask for MIPI_DSI_DPI_CFG_shutd_active_low. */
#define BS_MIPI_DSI_DPI_CFG_shutd_active_low (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_shutd_active_low. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_shutd_active_low field. */
#define BR_MIPI_DSI_DPI_CFG_shutd_active_low(x) (HW_MIPI_DSI_DPI_CFG(x).B.shutd_active_low)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_shutd_active_low. */
#define BF_MIPI_DSI_DPI_CFG_shutd_active_low(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_shutd_active_low) & BM_MIPI_DSI_DPI_CFG_shutd_active_low)

/*! @brief Set the shutd_active_low field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_shutd_active_low(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_shutd_active_low) | BF_MIPI_DSI_DPI_CFG_shutd_active_low(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field colorm_active_low[9] (RW)
 *
 * Set to configure Color Mode pin (dpicolcorm) as Active low
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_colorm_active_low (9U) /*!< Bit position for MIPI_DSI_DPI_CFG_colorm_active_low. */
#define BM_MIPI_DSI_DPI_CFG_colorm_active_low (0x00000200U) /*!< Bit mask for MIPI_DSI_DPI_CFG_colorm_active_low. */
#define BS_MIPI_DSI_DPI_CFG_colorm_active_low (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_colorm_active_low. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_colorm_active_low field. */
#define BR_MIPI_DSI_DPI_CFG_colorm_active_low(x) (HW_MIPI_DSI_DPI_CFG(x).B.colorm_active_low)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_colorm_active_low. */
#define BF_MIPI_DSI_DPI_CFG_colorm_active_low(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_colorm_active_low) & BM_MIPI_DSI_DPI_CFG_colorm_active_low)

/*! @brief Set the colorm_active_low field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_colorm_active_low(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_colorm_active_low) | BF_MIPI_DSI_DPI_CFG_colorm_active_low(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DPI_CFG, field en18_loosely[10] (RW)
 *
 * Enable 18 loosely packet pixel stream.
 */
/*@{*/
#define BP_MIPI_DSI_DPI_CFG_en18_loosely (10U) /*!< Bit position for MIPI_DSI_DPI_CFG_en18_loosely. */
#define BM_MIPI_DSI_DPI_CFG_en18_loosely (0x00000400U) /*!< Bit mask for MIPI_DSI_DPI_CFG_en18_loosely. */
#define BS_MIPI_DSI_DPI_CFG_en18_loosely (1U) /*!< Bit field size in bits for MIPI_DSI_DPI_CFG_en18_loosely. */

/*! @brief Read current value of the MIPI_DSI_DPI_CFG_en18_loosely field. */
#define BR_MIPI_DSI_DPI_CFG_en18_loosely(x) (HW_MIPI_DSI_DPI_CFG(x).B.en18_loosely)

/*! @brief Format value for bitfield MIPI_DSI_DPI_CFG_en18_loosely. */
#define BF_MIPI_DSI_DPI_CFG_en18_loosely(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DPI_CFG_en18_loosely) & BM_MIPI_DSI_DPI_CFG_en18_loosely)

/*! @brief Set the en18_loosely field to a new value. */
#define BW_MIPI_DSI_DPI_CFG_en18_loosely(x, v) (HW_MIPI_DSI_DPI_CFG_WR(x, (HW_MIPI_DSI_DPI_CFG_RD(x) & ~BM_MIPI_DSI_DPI_CFG_en18_loosely) | BF_MIPI_DSI_DPI_CFG_en18_loosely(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_DBI_CFG - DBI interface configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_DBI_CFG - DBI interface configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x10 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_dbi_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_dbi_cfg_bitfields
    {
        uint32_t dbi_vid : 2;          /*!< [1:0]  */
        uint32_t in_dbi_conf : 4;      /*!< [5:2]  */
        uint32_t lut_size_conf : 2;    /*!< [7:6]  */
        uint32_t partitioning_en : 1;  /*!< [8]  */
        uint32_t out_dbi_conf : 4;     /*!< [12:9]  */
        uint32_t RESERVED0 : 19;       /*!< [31:13]  */
    } B;
} hw_mipi_dsi_dbi_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_DBI_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_DBI_CFG_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_MIPI_DSI_DBI_CFG(x)   (*(__IO hw_mipi_dsi_dbi_cfg_t *) HW_MIPI_DSI_DBI_CFG_ADDR(x))
#define HW_MIPI_DSI_DBI_CFG_RD(x) (HW_MIPI_DSI_DBI_CFG(x).U)
#define HW_MIPI_DSI_DBI_CFG_WR(x, v) (HW_MIPI_DSI_DBI_CFG(x).U = (v))
#define HW_MIPI_DSI_DBI_CFG_SET(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, HW_MIPI_DSI_DBI_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_DBI_CFG_CLR(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, HW_MIPI_DSI_DBI_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_DBI_CFG_TOG(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, HW_MIPI_DSI_DBI_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_DBI_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_DBI_CFG, field dbi_vid[1:0] (RW)
 *
 * Configures the DBI Virtual Channel ID that will be indexed to the DCS packets.
 */
/*@{*/
#define BP_MIPI_DSI_DBI_CFG_dbi_vid (0U)   /*!< Bit position for MIPI_DSI_DBI_CFG_dbi_vid. */
#define BM_MIPI_DSI_DBI_CFG_dbi_vid (0x00000003U) /*!< Bit mask for MIPI_DSI_DBI_CFG_dbi_vid. */
#define BS_MIPI_DSI_DBI_CFG_dbi_vid (2U)   /*!< Bit field size in bits for MIPI_DSI_DBI_CFG_dbi_vid. */

/*! @brief Read current value of the MIPI_DSI_DBI_CFG_dbi_vid field. */
#define BR_MIPI_DSI_DBI_CFG_dbi_vid(x) (HW_MIPI_DSI_DBI_CFG(x).B.dbi_vid)

/*! @brief Format value for bitfield MIPI_DSI_DBI_CFG_dbi_vid. */
#define BF_MIPI_DSI_DBI_CFG_dbi_vid(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBI_CFG_dbi_vid) & BM_MIPI_DSI_DBI_CFG_dbi_vid)

/*! @brief Set the dbi_vid field to a new value. */
#define BW_MIPI_DSI_DBI_CFG_dbi_vid(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, (HW_MIPI_DSI_DBI_CFG_RD(x) & ~BM_MIPI_DSI_DBI_CFG_dbi_vid) | BF_MIPI_DSI_DBI_CFG_dbi_vid(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DBI_CFG, field in_dbi_conf[5:2] (RW)
 *
 * Configures DBI input pixel data configuration;
 *
 * Values:
 * - 0 - 8bit 8bpp;
 * - 1 - 8bit 12bpp;
 * - 10 - 16bit 18bpp, option2;
 * - 11 - 16bit 24bpp, option1;
 */
/*@{*/
#define BP_MIPI_DSI_DBI_CFG_in_dbi_conf (2U) /*!< Bit position for MIPI_DSI_DBI_CFG_in_dbi_conf. */
#define BM_MIPI_DSI_DBI_CFG_in_dbi_conf (0x0000003CU) /*!< Bit mask for MIPI_DSI_DBI_CFG_in_dbi_conf. */
#define BS_MIPI_DSI_DBI_CFG_in_dbi_conf (4U) /*!< Bit field size in bits for MIPI_DSI_DBI_CFG_in_dbi_conf. */

/*! @brief Read current value of the MIPI_DSI_DBI_CFG_in_dbi_conf field. */
#define BR_MIPI_DSI_DBI_CFG_in_dbi_conf(x) (HW_MIPI_DSI_DBI_CFG(x).B.in_dbi_conf)

/*! @brief Format value for bitfield MIPI_DSI_DBI_CFG_in_dbi_conf. */
#define BF_MIPI_DSI_DBI_CFG_in_dbi_conf(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBI_CFG_in_dbi_conf) & BM_MIPI_DSI_DBI_CFG_in_dbi_conf)

/*! @brief Set the in_dbi_conf field to a new value. */
#define BW_MIPI_DSI_DBI_CFG_in_dbi_conf(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, (HW_MIPI_DSI_DBI_CFG_RD(x) & ~BM_MIPI_DSI_DBI_CFG_in_dbi_conf) | BF_MIPI_DSI_DBI_CFG_in_dbi_conf(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DBI_CFG, field lut_size_conf[7:6] (RW)
 *
 * Configures the size used to transport Write Lut commands;
 *
 * Values:
 * - 0 - 16-bit color display;
 * - 1 - 18-bit color display;
 */
/*@{*/
#define BP_MIPI_DSI_DBI_CFG_lut_size_conf (6U) /*!< Bit position for MIPI_DSI_DBI_CFG_lut_size_conf. */
#define BM_MIPI_DSI_DBI_CFG_lut_size_conf (0x000000C0U) /*!< Bit mask for MIPI_DSI_DBI_CFG_lut_size_conf. */
#define BS_MIPI_DSI_DBI_CFG_lut_size_conf (2U) /*!< Bit field size in bits for MIPI_DSI_DBI_CFG_lut_size_conf. */

/*! @brief Read current value of the MIPI_DSI_DBI_CFG_lut_size_conf field. */
#define BR_MIPI_DSI_DBI_CFG_lut_size_conf(x) (HW_MIPI_DSI_DBI_CFG(x).B.lut_size_conf)

/*! @brief Format value for bitfield MIPI_DSI_DBI_CFG_lut_size_conf. */
#define BF_MIPI_DSI_DBI_CFG_lut_size_conf(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBI_CFG_lut_size_conf) & BM_MIPI_DSI_DBI_CFG_lut_size_conf)

/*! @brief Set the lut_size_conf field to a new value. */
#define BW_MIPI_DSI_DBI_CFG_lut_size_conf(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, (HW_MIPI_DSI_DBI_CFG_RD(x) & ~BM_MIPI_DSI_DBI_CFG_lut_size_conf) | BF_MIPI_DSI_DBI_CFG_lut_size_conf(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DBI_CFG, field partitioning_en[8] (RW)
 *
 * Enables write memory continue through input command (system needs to ensure
 * correct partitioning of Long Write commands)
 */
/*@{*/
#define BP_MIPI_DSI_DBI_CFG_partitioning_en (8U) /*!< Bit position for MIPI_DSI_DBI_CFG_partitioning_en. */
#define BM_MIPI_DSI_DBI_CFG_partitioning_en (0x00000100U) /*!< Bit mask for MIPI_DSI_DBI_CFG_partitioning_en. */
#define BS_MIPI_DSI_DBI_CFG_partitioning_en (1U) /*!< Bit field size in bits for MIPI_DSI_DBI_CFG_partitioning_en. */

/*! @brief Read current value of the MIPI_DSI_DBI_CFG_partitioning_en field. */
#define BR_MIPI_DSI_DBI_CFG_partitioning_en(x) (HW_MIPI_DSI_DBI_CFG(x).B.partitioning_en)

/*! @brief Format value for bitfield MIPI_DSI_DBI_CFG_partitioning_en. */
#define BF_MIPI_DSI_DBI_CFG_partitioning_en(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBI_CFG_partitioning_en) & BM_MIPI_DSI_DBI_CFG_partitioning_en)

/*! @brief Set the partitioning_en field to a new value. */
#define BW_MIPI_DSI_DBI_CFG_partitioning_en(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, (HW_MIPI_DSI_DBI_CFG_RD(x) & ~BM_MIPI_DSI_DBI_CFG_partitioning_en) | BF_MIPI_DSI_DBI_CFG_partitioning_en(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DBI_CFG, field out_dbi_conf[12:9] (RW)
 *
 * Configures the DBI output pixel data configuration;
 *
 * Values:
 * - 0 - 8bit 8bpp;
 * - 1 - 8bit 12bpp;
 * - 10 - 16bit 18bpp, option2;
 * - 11 - 16bit 24bpp, option1;
 */
/*@{*/
#define BP_MIPI_DSI_DBI_CFG_out_dbi_conf (9U) /*!< Bit position for MIPI_DSI_DBI_CFG_out_dbi_conf. */
#define BM_MIPI_DSI_DBI_CFG_out_dbi_conf (0x00001E00U) /*!< Bit mask for MIPI_DSI_DBI_CFG_out_dbi_conf. */
#define BS_MIPI_DSI_DBI_CFG_out_dbi_conf (4U) /*!< Bit field size in bits for MIPI_DSI_DBI_CFG_out_dbi_conf. */

/*! @brief Read current value of the MIPI_DSI_DBI_CFG_out_dbi_conf field. */
#define BR_MIPI_DSI_DBI_CFG_out_dbi_conf(x) (HW_MIPI_DSI_DBI_CFG(x).B.out_dbi_conf)

/*! @brief Format value for bitfield MIPI_DSI_DBI_CFG_out_dbi_conf. */
#define BF_MIPI_DSI_DBI_CFG_out_dbi_conf(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBI_CFG_out_dbi_conf) & BM_MIPI_DSI_DBI_CFG_out_dbi_conf)

/*! @brief Set the out_dbi_conf field to a new value. */
#define BW_MIPI_DSI_DBI_CFG_out_dbi_conf(x, v) (HW_MIPI_DSI_DBI_CFG_WR(x, (HW_MIPI_DSI_DBI_CFG_RD(x) & ~BM_MIPI_DSI_DBI_CFG_out_dbi_conf) | BF_MIPI_DSI_DBI_CFG_out_dbi_conf(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_DBIS_CMDSIZE - DBI command size configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_DBIS_CMDSIZE - DBI command size configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x14 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_dbis_cmdsize
{
    uint32_t U;
    struct _hw_mipi_dsi_dbis_cmdsize_bitfields
    {
        uint32_t wr_cmd_size : 16;     /*!< [15:0]  */
        uint32_t allowed_cmd_size : 16; /*!< [31:16]  */
    } B;
} hw_mipi_dsi_dbis_cmdsize_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_DBIS_CMDSIZE register
 */
/*@{*/
#define HW_MIPI_DSI_DBIS_CMDSIZE_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_MIPI_DSI_DBIS_CMDSIZE(x) (*(__IO hw_mipi_dsi_dbis_cmdsize_t *) HW_MIPI_DSI_DBIS_CMDSIZE_ADDR(x))
#define HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) (HW_MIPI_DSI_DBIS_CMDSIZE(x).U)
#define HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE(x).U = (v))
#define HW_MIPI_DSI_DBIS_CMDSIZE_SET(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) |  (v)))
#define HW_MIPI_DSI_DBIS_CMDSIZE_CLR(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) & ~(v)))
#define HW_MIPI_DSI_DBIS_CMDSIZE_TOG(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_DBIS_CMDSIZE bitfields
 */

/*!
 * @name Register MIPI_DSI_DBIS_CMDSIZE, field wr_cmd_size[15:0] (RW)
 *
 * Configures the size of the DCS write memory commands. Size of DSI packet
 * payload is the actual payload size minus 1 since the DCS command is in the DSI
 * packet payload.
 */
/*@{*/
#define BP_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size (0U) /*!< Bit position for MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size. */
#define BM_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size (0x0000FFFFU) /*!< Bit mask for MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size. */
#define BS_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size (16U) /*!< Bit field size in bits for MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size. */

/*! @brief Read current value of the MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size field. */
#define BR_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size(x) (HW_MIPI_DSI_DBIS_CMDSIZE(x).B.wr_cmd_size)

/*! @brief Format value for bitfield MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size. */
#define BF_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size) & BM_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size)

/*! @brief Set the wr_cmd_size field to a new value. */
#define BW_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, (HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) & ~BM_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size) | BF_MIPI_DSI_DBIS_CMDSIZE_wr_cmd_size(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_DBIS_CMDSIZE, field allowed_cmd_size[31:16] (RW)
 *
 * Configures the maximum allowed size of a DCS write memory command. This
 * register is used to partition a write memory command into several write memory
 * continues. It is only used if bit 'partitioning_en' is disabled. Size of DSI
 * packet payload is the actual payload size minus 1 since the DCS command is in the
 * DSI packet payload.
 */
/*@{*/
#define BP_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size (16U) /*!< Bit position for MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size. */
#define BM_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size (0xFFFF0000U) /*!< Bit mask for MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size. */
#define BS_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size (16U) /*!< Bit field size in bits for MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size. */

/*! @brief Read current value of the MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size field. */
#define BR_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size(x) (HW_MIPI_DSI_DBIS_CMDSIZE(x).B.allowed_cmd_size)

/*! @brief Format value for bitfield MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size. */
#define BF_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size) & BM_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size)

/*! @brief Set the allowed_cmd_size field to a new value. */
#define BW_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size(x, v) (HW_MIPI_DSI_DBIS_CMDSIZE_WR(x, (HW_MIPI_DSI_DBIS_CMDSIZE_RD(x) & ~BM_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size) | BF_MIPI_DSI_DBIS_CMDSIZE_allowed_cmd_size(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PCKHDL_CFG - Packet handler configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PCKHDL_CFG - Packet handler configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x18 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_pckhdl_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_pckhdl_cfg_bitfields
    {
        uint32_t en_EOTp_tx : 1;       /*!< [0]  */
        uint32_t en_EOTn_rx : 1;       /*!< [1]  */
        uint32_t en_BTA : 1;           /*!< [2]  */
        uint32_t en_ECC_rx : 1;        /*!< [3]  */
        uint32_t en_CRC_rx : 1;        /*!< [4]  */
        uint32_t gen_vid_rx : 2;       /*!< [6:5]  */
        uint32_t RESERVED0 : 25;       /*!< [31:7]  */
    } B;
} hw_mipi_dsi_pckhdl_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PCKHDL_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_PCKHDL_CFG_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_MIPI_DSI_PCKHDL_CFG(x) (*(__IO hw_mipi_dsi_pckhdl_cfg_t *) HW_MIPI_DSI_PCKHDL_CFG_ADDR(x))
#define HW_MIPI_DSI_PCKHDL_CFG_RD(x) (HW_MIPI_DSI_PCKHDL_CFG(x).U)
#define HW_MIPI_DSI_PCKHDL_CFG_WR(x, v) (HW_MIPI_DSI_PCKHDL_CFG(x).U = (v))
#define HW_MIPI_DSI_PCKHDL_CFG_SET(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, HW_MIPI_DSI_PCKHDL_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_PCKHDL_CFG_CLR(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_PCKHDL_CFG_TOG(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, HW_MIPI_DSI_PCKHDL_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PCKHDL_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field en_EOTp_tx[0] (RW)
 *
 * Enables EOTp transmission
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx (0U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_en_EOTp_tx. */
#define BM_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx (0x00000001U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_en_EOTp_tx. */
#define BS_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx (1U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_en_EOTp_tx. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_en_EOTp_tx field. */
#define BR_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.en_EOTp_tx)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_en_EOTp_tx. */
#define BF_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx) & BM_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx)

/*! @brief Set the en_EOTp_tx field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx) | BF_MIPI_DSI_PCKHDL_CFG_en_EOTp_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field en_EOTn_rx[1] (RW)
 *
 * Enables EOTp reception
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx (1U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_en_EOTn_rx. */
#define BM_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx (0x00000002U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_en_EOTn_rx. */
#define BS_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx (1U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_en_EOTn_rx. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_en_EOTn_rx field. */
#define BR_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.en_EOTn_rx)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_en_EOTn_rx. */
#define BF_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx) & BM_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx)

/*! @brief Set the en_EOTn_rx field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx) | BF_MIPI_DSI_PCKHDL_CFG_en_EOTn_rx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field en_BTA[2] (RW)
 *
 * Enables Bus Turn-Around request
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_en_BTA (2U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_en_BTA. */
#define BM_MIPI_DSI_PCKHDL_CFG_en_BTA (0x00000004U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_en_BTA. */
#define BS_MIPI_DSI_PCKHDL_CFG_en_BTA (1U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_en_BTA. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_en_BTA field. */
#define BR_MIPI_DSI_PCKHDL_CFG_en_BTA(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.en_BTA)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_en_BTA. */
#define BF_MIPI_DSI_PCKHDL_CFG_en_BTA(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_en_BTA) & BM_MIPI_DSI_PCKHDL_CFG_en_BTA)

/*! @brief Set the en_BTA field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_en_BTA(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_en_BTA) | BF_MIPI_DSI_PCKHDL_CFG_en_BTA(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field en_ECC_rx[3] (RW)
 *
 * Enables ECC reception, error correction and reporting
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_en_ECC_rx (3U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_en_ECC_rx. */
#define BM_MIPI_DSI_PCKHDL_CFG_en_ECC_rx (0x00000008U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_en_ECC_rx. */
#define BS_MIPI_DSI_PCKHDL_CFG_en_ECC_rx (1U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_en_ECC_rx. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_en_ECC_rx field. */
#define BR_MIPI_DSI_PCKHDL_CFG_en_ECC_rx(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.en_ECC_rx)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_en_ECC_rx. */
#define BF_MIPI_DSI_PCKHDL_CFG_en_ECC_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_en_ECC_rx) & BM_MIPI_DSI_PCKHDL_CFG_en_ECC_rx)

/*! @brief Set the en_ECC_rx field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_en_ECC_rx(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_en_ECC_rx) | BF_MIPI_DSI_PCKHDL_CFG_en_ECC_rx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field en_CRC_rx[4] (RW)
 *
 * Enables CRC reception and error reporting
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_en_CRC_rx (4U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_en_CRC_rx. */
#define BM_MIPI_DSI_PCKHDL_CFG_en_CRC_rx (0x00000010U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_en_CRC_rx. */
#define BS_MIPI_DSI_PCKHDL_CFG_en_CRC_rx (1U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_en_CRC_rx. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_en_CRC_rx field. */
#define BR_MIPI_DSI_PCKHDL_CFG_en_CRC_rx(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.en_CRC_rx)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_en_CRC_rx. */
#define BF_MIPI_DSI_PCKHDL_CFG_en_CRC_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_en_CRC_rx) & BM_MIPI_DSI_PCKHDL_CFG_en_CRC_rx)

/*! @brief Set the en_CRC_rx field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_en_CRC_rx(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_en_CRC_rx) | BF_MIPI_DSI_PCKHDL_CFG_en_CRC_rx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PCKHDL_CFG, field gen_vid_rx[6:5] (RW)
 *
 * Generic interface read-back Virtual Channel identification
 */
/*@{*/
#define BP_MIPI_DSI_PCKHDL_CFG_gen_vid_rx (5U) /*!< Bit position for MIPI_DSI_PCKHDL_CFG_gen_vid_rx. */
#define BM_MIPI_DSI_PCKHDL_CFG_gen_vid_rx (0x00000060U) /*!< Bit mask for MIPI_DSI_PCKHDL_CFG_gen_vid_rx. */
#define BS_MIPI_DSI_PCKHDL_CFG_gen_vid_rx (2U) /*!< Bit field size in bits for MIPI_DSI_PCKHDL_CFG_gen_vid_rx. */

/*! @brief Read current value of the MIPI_DSI_PCKHDL_CFG_gen_vid_rx field. */
#define BR_MIPI_DSI_PCKHDL_CFG_gen_vid_rx(x) (HW_MIPI_DSI_PCKHDL_CFG(x).B.gen_vid_rx)

/*! @brief Format value for bitfield MIPI_DSI_PCKHDL_CFG_gen_vid_rx. */
#define BF_MIPI_DSI_PCKHDL_CFG_gen_vid_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PCKHDL_CFG_gen_vid_rx) & BM_MIPI_DSI_PCKHDL_CFG_gen_vid_rx)

/*! @brief Set the gen_vid_rx field to a new value. */
#define BW_MIPI_DSI_PCKHDL_CFG_gen_vid_rx(x, v) (HW_MIPI_DSI_PCKHDL_CFG_WR(x, (HW_MIPI_DSI_PCKHDL_CFG_RD(x) & ~BM_MIPI_DSI_PCKHDL_CFG_gen_vid_rx) | BF_MIPI_DSI_PCKHDL_CFG_gen_vid_rx(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_VID_MODE_CFG - Video Mode Configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_VID_MODE_CFG - Video Mode Configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x1c Memory Access: R/W
 */
typedef union _hw_mipi_dsi_vid_mode_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_vid_mode_cfg_bitfields
    {
        uint32_t en_video_mode : 1;    /*!< [0]  */
        uint32_t vid_mode_type : 2;    /*!< [2:1]  */
        uint32_t en_lp_vsa : 1;        /*!< [3]  */
        uint32_t en_lp_vbp : 1;        /*!< [4]  */
        uint32_t en_lp_vfp : 1;        /*!< [5]  */
        uint32_t en_lp_vact : 1;       /*!< [6]  */
        uint32_t en_lp_hbp : 1;        /*!< [7]  */
        uint32_t en_lp_hfp : 1;        /*!< [8]  */
        uint32_t en_multi_pkt : 1;     /*!< [9]  */
        uint32_t en_null_pkt : 1;      /*!< [10]  */
        uint32_t frame_BTA_ack : 1;    /*!< [11]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_mipi_dsi_vid_mode_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_VID_MODE_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_VID_MODE_CFG_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_MIPI_DSI_VID_MODE_CFG(x) (*(__IO hw_mipi_dsi_vid_mode_cfg_t *) HW_MIPI_DSI_VID_MODE_CFG_ADDR(x))
#define HW_MIPI_DSI_VID_MODE_CFG_RD(x) (HW_MIPI_DSI_VID_MODE_CFG(x).U)
#define HW_MIPI_DSI_VID_MODE_CFG_WR(x, v) (HW_MIPI_DSI_VID_MODE_CFG(x).U = (v))
#define HW_MIPI_DSI_VID_MODE_CFG_SET(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, HW_MIPI_DSI_VID_MODE_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_VID_MODE_CFG_CLR(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_VID_MODE_CFG_TOG(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, HW_MIPI_DSI_VID_MODE_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_VID_MODE_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_video_mode[0] (RW)
 *
 * Enables DPI Video mode transmission
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_video_mode (0U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_video_mode. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_video_mode (0x00000001U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_video_mode. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_video_mode (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_video_mode. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_video_mode field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_video_mode(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_video_mode)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_video_mode. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_video_mode(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_video_mode) & BM_MIPI_DSI_VID_MODE_CFG_en_video_mode)

/*! @brief Set the en_video_mode field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_video_mode(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_video_mode) | BF_MIPI_DSI_VID_MODE_CFG_en_video_mode(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field vid_mode_type[2:1] (RW)
 *
 * Selects video mode transmission type. 0: Non-burst with Sync pulses; 1:
 * Non-burst with Sync events; 2-3: Burst with Sync pulses.
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_vid_mode_type (1U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_vid_mode_type. */
#define BM_MIPI_DSI_VID_MODE_CFG_vid_mode_type (0x00000006U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_vid_mode_type. */
#define BS_MIPI_DSI_VID_MODE_CFG_vid_mode_type (2U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_vid_mode_type. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_vid_mode_type field. */
#define BR_MIPI_DSI_VID_MODE_CFG_vid_mode_type(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.vid_mode_type)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_vid_mode_type. */
#define BF_MIPI_DSI_VID_MODE_CFG_vid_mode_type(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_vid_mode_type) & BM_MIPI_DSI_VID_MODE_CFG_vid_mode_type)

/*! @brief Set the vid_mode_type field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_vid_mode_type(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_vid_mode_type) | BF_MIPI_DSI_VID_MODE_CFG_vid_mode_type(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_vsa[3] (RW)
 *
 * Enables return to Low Power inside VSA period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_vsa (3U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_vsa. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_vsa (0x00000008U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_vsa. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_vsa (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_vsa. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_vsa field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_vsa(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_vsa)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_vsa. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_vsa(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_vsa) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_vsa)

/*! @brief Set the en_lp_vsa field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_vsa(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_vsa) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_vsa(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_vbp[4] (RW)
 *
 * Enables return to Low Power inside VBP period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_vbp (4U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_vbp. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_vbp (0x00000010U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_vbp. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_vbp (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_vbp. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_vbp field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_vbp(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_vbp)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_vbp. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_vbp(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_vbp) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_vbp)

/*! @brief Set the en_lp_vbp field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_vbp(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_vbp) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_vbp(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_vfp[5] (RW)
 *
 * Enables return to Low Power inside VFP period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_vfp (5U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_vfp. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_vfp (0x00000020U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_vfp. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_vfp (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_vfp. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_vfp field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_vfp(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_vfp)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_vfp. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_vfp(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_vfp) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_vfp)

/*! @brief Set the en_lp_vfp field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_vfp(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_vfp) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_vfp(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_vact[6] (RW)
 *
 * Enables return to Low Power inside VACT period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_vact (6U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_vact. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_vact (0x00000040U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_vact. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_vact (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_vact. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_vact field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_vact(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_vact)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_vact. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_vact(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_vact) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_vact)

/*! @brief Set the en_lp_vact field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_vact(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_vact) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_vact(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_hbp[7] (RW)
 *
 * Enables return to Low Power inside HBP period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_hbp (7U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_hbp. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_hbp (0x00000080U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_hbp. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_hbp (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_hbp. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_hbp field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_hbp(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_hbp)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_hbp. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_hbp(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_hbp) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_hbp)

/*! @brief Set the en_lp_hbp field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_hbp(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_hbp) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_hbp(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_lp_hfp[8] (RW)
 *
 * Enables return to Low Power inside HFP period when timing allows
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_lp_hfp (8U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_lp_hfp. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_lp_hfp (0x00000100U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_lp_hfp. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_lp_hfp (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_lp_hfp. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_lp_hfp field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_lp_hfp(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_lp_hfp)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_lp_hfp. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_lp_hfp(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_lp_hfp) & BM_MIPI_DSI_VID_MODE_CFG_en_lp_hfp)

/*! @brief Set the en_lp_hfp field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_lp_hfp(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_lp_hfp) | BF_MIPI_DSI_VID_MODE_CFG_en_lp_hfp(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_multi_pkt[9] (RW)
 *
 * Enables the tranmission of multi video packets in the HACT period
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_multi_pkt (9U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_multi_pkt. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_multi_pkt (0x00000200U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_multi_pkt. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_multi_pkt (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_multi_pkt. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_multi_pkt field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_multi_pkt(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_multi_pkt)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_multi_pkt. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_multi_pkt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_multi_pkt) & BM_MIPI_DSI_VID_MODE_CFG_en_multi_pkt)

/*! @brief Set the en_multi_pkt field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_multi_pkt(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_multi_pkt) | BF_MIPI_DSI_VID_MODE_CFG_en_multi_pkt(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field en_null_pkt[10] (RW)
 *
 * Enables the tranmission of null packets in the HACT period
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_en_null_pkt (10U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_en_null_pkt. */
#define BM_MIPI_DSI_VID_MODE_CFG_en_null_pkt (0x00000400U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_en_null_pkt. */
#define BS_MIPI_DSI_VID_MODE_CFG_en_null_pkt (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_en_null_pkt. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_en_null_pkt field. */
#define BR_MIPI_DSI_VID_MODE_CFG_en_null_pkt(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.en_null_pkt)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_en_null_pkt. */
#define BF_MIPI_DSI_VID_MODE_CFG_en_null_pkt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_en_null_pkt) & BM_MIPI_DSI_VID_MODE_CFG_en_null_pkt)

/*! @brief Set the en_null_pkt field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_en_null_pkt(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_en_null_pkt) | BF_MIPI_DSI_VID_MODE_CFG_en_null_pkt(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_MODE_CFG, field frame_BTA_ack[11] (RW)
 *
 * Enables the request for an acknowledge response at the end of a frame
 */
/*@{*/
#define BP_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack (11U) /*!< Bit position for MIPI_DSI_VID_MODE_CFG_frame_BTA_ack. */
#define BM_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack (0x00000800U) /*!< Bit mask for MIPI_DSI_VID_MODE_CFG_frame_BTA_ack. */
#define BS_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack (1U) /*!< Bit field size in bits for MIPI_DSI_VID_MODE_CFG_frame_BTA_ack. */

/*! @brief Read current value of the MIPI_DSI_VID_MODE_CFG_frame_BTA_ack field. */
#define BR_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack(x) (HW_MIPI_DSI_VID_MODE_CFG(x).B.frame_BTA_ack)

/*! @brief Format value for bitfield MIPI_DSI_VID_MODE_CFG_frame_BTA_ack. */
#define BF_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack) & BM_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack)

/*! @brief Set the frame_BTA_ack field to a new value. */
#define BW_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack(x, v) (HW_MIPI_DSI_VID_MODE_CFG_WR(x, (HW_MIPI_DSI_VID_MODE_CFG_RD(x) & ~BM_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack) | BF_MIPI_DSI_VID_MODE_CFG_frame_BTA_ack(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_VID_PKT_CFG - Video packet configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_VID_PKT_CFG - Video packet configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x20 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_vid_pkt_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_vid_pkt_cfg_bitfields
    {
        uint32_t vid_pkt_size : 11;    /*!< [10:0]  */
        uint32_t num_chunks : 10;      /*!< [20:11]  */
        uint32_t null_pkt_size : 10;   /*!< [30:21]  */
        uint32_t RESERVED0 : 1;        /*!< [31]  */
    } B;
} hw_mipi_dsi_vid_pkt_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_VID_PKT_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_VID_PKT_CFG_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_MIPI_DSI_VID_PKT_CFG(x) (*(__IO hw_mipi_dsi_vid_pkt_cfg_t *) HW_MIPI_DSI_VID_PKT_CFG_ADDR(x))
#define HW_MIPI_DSI_VID_PKT_CFG_RD(x) (HW_MIPI_DSI_VID_PKT_CFG(x).U)
#define HW_MIPI_DSI_VID_PKT_CFG_WR(x, v) (HW_MIPI_DSI_VID_PKT_CFG(x).U = (v))
#define HW_MIPI_DSI_VID_PKT_CFG_SET(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, HW_MIPI_DSI_VID_PKT_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_VID_PKT_CFG_CLR(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, HW_MIPI_DSI_VID_PKT_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_VID_PKT_CFG_TOG(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, HW_MIPI_DSI_VID_PKT_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_VID_PKT_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_VID_PKT_CFG, field vid_pkt_size[10:0] (RW)
 *
 * Configures the number of pixel on a single video packet. (If using 18 bit
 * mode and not enabling loosely packet stream this value must be a multiple of 4)
 */
/*@{*/
#define BP_MIPI_DSI_VID_PKT_CFG_vid_pkt_size (0U) /*!< Bit position for MIPI_DSI_VID_PKT_CFG_vid_pkt_size. */
#define BM_MIPI_DSI_VID_PKT_CFG_vid_pkt_size (0x000007FFU) /*!< Bit mask for MIPI_DSI_VID_PKT_CFG_vid_pkt_size. */
#define BS_MIPI_DSI_VID_PKT_CFG_vid_pkt_size (11U) /*!< Bit field size in bits for MIPI_DSI_VID_PKT_CFG_vid_pkt_size. */

/*! @brief Read current value of the MIPI_DSI_VID_PKT_CFG_vid_pkt_size field. */
#define BR_MIPI_DSI_VID_PKT_CFG_vid_pkt_size(x) (HW_MIPI_DSI_VID_PKT_CFG(x).B.vid_pkt_size)

/*! @brief Format value for bitfield MIPI_DSI_VID_PKT_CFG_vid_pkt_size. */
#define BF_MIPI_DSI_VID_PKT_CFG_vid_pkt_size(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_PKT_CFG_vid_pkt_size) & BM_MIPI_DSI_VID_PKT_CFG_vid_pkt_size)

/*! @brief Set the vid_pkt_size field to a new value. */
#define BW_MIPI_DSI_VID_PKT_CFG_vid_pkt_size(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, (HW_MIPI_DSI_VID_PKT_CFG_RD(x) & ~BM_MIPI_DSI_VID_PKT_CFG_vid_pkt_size) | BF_MIPI_DSI_VID_PKT_CFG_vid_pkt_size(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_PKT_CFG, field num_chunks[20:11] (RW)
 *
 * Configures the number of chunks to be transmitted during a Line period. (A
 * chunk is a video packet or a null packet)
 */
/*@{*/
#define BP_MIPI_DSI_VID_PKT_CFG_num_chunks (11U) /*!< Bit position for MIPI_DSI_VID_PKT_CFG_num_chunks. */
#define BM_MIPI_DSI_VID_PKT_CFG_num_chunks (0x001FF800U) /*!< Bit mask for MIPI_DSI_VID_PKT_CFG_num_chunks. */
#define BS_MIPI_DSI_VID_PKT_CFG_num_chunks (10U) /*!< Bit field size in bits for MIPI_DSI_VID_PKT_CFG_num_chunks. */

/*! @brief Read current value of the MIPI_DSI_VID_PKT_CFG_num_chunks field. */
#define BR_MIPI_DSI_VID_PKT_CFG_num_chunks(x) (HW_MIPI_DSI_VID_PKT_CFG(x).B.num_chunks)

/*! @brief Format value for bitfield MIPI_DSI_VID_PKT_CFG_num_chunks. */
#define BF_MIPI_DSI_VID_PKT_CFG_num_chunks(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_PKT_CFG_num_chunks) & BM_MIPI_DSI_VID_PKT_CFG_num_chunks)

/*! @brief Set the num_chunks field to a new value. */
#define BW_MIPI_DSI_VID_PKT_CFG_num_chunks(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, (HW_MIPI_DSI_VID_PKT_CFG_RD(x) & ~BM_MIPI_DSI_VID_PKT_CFG_num_chunks) | BF_MIPI_DSI_VID_PKT_CFG_num_chunks(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VID_PKT_CFG, field null_pkt_size[30:21] (RW)
 *
 * Configures the number of bytes in a null packet
 */
/*@{*/
#define BP_MIPI_DSI_VID_PKT_CFG_null_pkt_size (21U) /*!< Bit position for MIPI_DSI_VID_PKT_CFG_null_pkt_size. */
#define BM_MIPI_DSI_VID_PKT_CFG_null_pkt_size (0x7FE00000U) /*!< Bit mask for MIPI_DSI_VID_PKT_CFG_null_pkt_size. */
#define BS_MIPI_DSI_VID_PKT_CFG_null_pkt_size (10U) /*!< Bit field size in bits for MIPI_DSI_VID_PKT_CFG_null_pkt_size. */

/*! @brief Read current value of the MIPI_DSI_VID_PKT_CFG_null_pkt_size field. */
#define BR_MIPI_DSI_VID_PKT_CFG_null_pkt_size(x) (HW_MIPI_DSI_VID_PKT_CFG(x).B.null_pkt_size)

/*! @brief Format value for bitfield MIPI_DSI_VID_PKT_CFG_null_pkt_size. */
#define BF_MIPI_DSI_VID_PKT_CFG_null_pkt_size(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VID_PKT_CFG_null_pkt_size) & BM_MIPI_DSI_VID_PKT_CFG_null_pkt_size)

/*! @brief Set the null_pkt_size field to a new value. */
#define BW_MIPI_DSI_VID_PKT_CFG_null_pkt_size(x, v) (HW_MIPI_DSI_VID_PKT_CFG_WR(x, (HW_MIPI_DSI_VID_PKT_CFG_RD(x) & ~BM_MIPI_DSI_VID_PKT_CFG_null_pkt_size) | BF_MIPI_DSI_VID_PKT_CFG_null_pkt_size(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_CMD_MODE_CFG - Command mode configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_CMD_MODE_CFG - Command mode configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x24 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_cmd_mode_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_cmd_mode_cfg_bitfields
    {
        uint32_t en_cmd_mode : 1;      /*!< [0]  */
        uint32_t gen_sw_0p_tx : 1;     /*!< [1]  */
        uint32_t gen_sw_1p_tx : 1;     /*!< [2]  */
        uint32_t gen_sw_2p_tx : 1;     /*!< [3]  */
        uint32_t gen_sr_0p_tx : 1;     /*!< [4]  */
        uint32_t gen_sr_1p_tx : 1;     /*!< [5]  */
        uint32_t gen_sr_2p_tx : 1;     /*!< [6]  */
        uint32_t dcs_sw_0p_tx : 1;     /*!< [7]  */
        uint32_t dcs_sw_1p_tx : 1;     /*!< [8]  */
        uint32_t dcs_sw_2p_tx : 1;     /*!< [9]  */
        uint32_t max_rd_pkt_size : 1;  /*!< [10]  */
        uint32_t gen_lw_tx : 1;        /*!< [11]  */
        uint32_t dcs_lw_tx : 1;        /*!< [12]  */
        uint32_t en_ack_rqst : 1;      /*!< [13]  */
        uint32_t en_tear_fx : 1;       /*!< [14]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_mipi_dsi_cmd_mode_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_CMD_MODE_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_CMD_MODE_CFG_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_MIPI_DSI_CMD_MODE_CFG(x) (*(__IO hw_mipi_dsi_cmd_mode_cfg_t *) HW_MIPI_DSI_CMD_MODE_CFG_ADDR(x))
#define HW_MIPI_DSI_CMD_MODE_CFG_RD(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).U)
#define HW_MIPI_DSI_CMD_MODE_CFG_WR(x, v) (HW_MIPI_DSI_CMD_MODE_CFG(x).U = (v))
#define HW_MIPI_DSI_CMD_MODE_CFG_SET(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, HW_MIPI_DSI_CMD_MODE_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_CMD_MODE_CFG_CLR(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_CMD_MODE_CFG_TOG(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, HW_MIPI_DSI_CMD_MODE_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_CMD_MODE_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field en_cmd_mode[0] (RW)
 *
 * Enables the Command Mode Protocol for transmissions.
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode (0U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_en_cmd_mode. */
#define BM_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode (0x00000001U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_en_cmd_mode. */
#define BS_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_en_cmd_mode. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_en_cmd_mode field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.en_cmd_mode)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_en_cmd_mode. */
#define BF_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode) & BM_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode)

/*! @brief Set the en_cmd_mode field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode) | BF_MIPI_DSI_CMD_MODE_CFG_en_cmd_mode(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sw_0p_tx[1] (RW)
 *
 * Configures the Generic Short Write Packet with 0 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx (1U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx (0x00000002U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sw_0p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx)

/*! @brief Set the gen_sw_0p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_0p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sw_1p_tx[2] (RW)
 *
 * Configures the Generic Short Write Packet with 1 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx (2U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx (0x00000004U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sw_1p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx)

/*! @brief Set the gen_sw_1p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_1p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sw_2p_tx[3] (RW)
 *
 * Configures the Generic Short Write Packet with 2 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx (3U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx (0x00000008U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sw_2p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx)

/*! @brief Set the gen_sw_2p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sw_2p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sr_0p_tx[4] (RW)
 *
 * Configures the Generic Short Read Packet with 0 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx (4U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx (0x00000010U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sr_0p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx)

/*! @brief Set the gen_sr_0p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_0p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sr_1p_tx[5] (RW)
 *
 * Configures the Generic Short Read Packet with 1 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx (5U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx (0x00000020U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sr_1p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx)

/*! @brief Set the gen_sr_1p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_1p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_sr_2p_tx[6] (RW)
 *
 * Configures the Generic Short Read Packet with 2 Parameters command
 * transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx (6U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx (0x00000040U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_sr_2p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx)

/*! @brief Set the gen_sr_2p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_sr_2p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field dcs_sw_0p_tx[7] (RW)
 *
 * Configures the DCS Short Write Packet with 0 Parameters command transmission
 * type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx (7U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx (0x00000080U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.dcs_sw_0p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx)

/*! @brief Set the dcs_sw_0p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_0p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field dcs_sw_1p_tx[8] (RW)
 *
 * Configures the DCS Short Write Packet with 1 Parameters command transmission
 * type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx (8U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx (0x00000100U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.dcs_sw_1p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx)

/*! @brief Set the dcs_sw_1p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_1p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field dcs_sw_2p_tx[9] (RW)
 *
 * Configures the DCS Short Write Packet with 2 Parameters command transmission
 * type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx (9U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx (0x00000200U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.dcs_sw_2p_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx) & BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx)

/*! @brief Set the dcs_sw_2p_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx) | BF_MIPI_DSI_CMD_MODE_CFG_dcs_sw_2p_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field max_rd_pkt_size[10] (RW)
 *
 * Configures the Maximum Read Packet Size command transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size (10U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size. */
#define BM_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size (0x00000400U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size. */
#define BS_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.max_rd_pkt_size)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size. */
#define BF_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size) & BM_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size)

/*! @brief Set the max_rd_pkt_size field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size) | BF_MIPI_DSI_CMD_MODE_CFG_max_rd_pkt_size(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field gen_lw_tx[11] (RW)
 *
 * Configures the Generic Long Write Packet command transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx (11U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_gen_lw_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx (0x00000800U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_gen_lw_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_gen_lw_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_gen_lw_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.gen_lw_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_gen_lw_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx) & BM_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx)

/*! @brief Set the gen_lw_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx) | BF_MIPI_DSI_CMD_MODE_CFG_gen_lw_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field dcs_lw_tx[12] (RW)
 *
 * Configures the DCS Long Write Packet command transmission type.
 *
 * Values:
 * - 0 - High Speed;
 * - 1 - Low Power
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx (12U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx (0x00001000U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.dcs_lw_tx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx) & BM_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx)

/*! @brief Set the dcs_lw_tx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx) | BF_MIPI_DSI_CMD_MODE_CFG_dcs_lw_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field en_ack_rqst[13] (RW)
 *
 * Enables the acknowledge request after each packet transmission
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst (13U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_en_ack_rqst. */
#define BM_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst (0x00002000U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_en_ack_rqst. */
#define BS_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_en_ack_rqst. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_en_ack_rqst field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.en_ack_rqst)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_en_ack_rqst. */
#define BF_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst) & BM_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst)

/*! @brief Set the en_ack_rqst field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst) | BF_MIPI_DSI_CMD_MODE_CFG_en_ack_rqst(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_MODE_CFG, field en_tear_fx[14] (RW)
 *
 * Enables the tearing effect acknowledge request
 */
/*@{*/
#define BP_MIPI_DSI_CMD_MODE_CFG_en_tear_fx (14U) /*!< Bit position for MIPI_DSI_CMD_MODE_CFG_en_tear_fx. */
#define BM_MIPI_DSI_CMD_MODE_CFG_en_tear_fx (0x00004000U) /*!< Bit mask for MIPI_DSI_CMD_MODE_CFG_en_tear_fx. */
#define BS_MIPI_DSI_CMD_MODE_CFG_en_tear_fx (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_MODE_CFG_en_tear_fx. */

/*! @brief Read current value of the MIPI_DSI_CMD_MODE_CFG_en_tear_fx field. */
#define BR_MIPI_DSI_CMD_MODE_CFG_en_tear_fx(x) (HW_MIPI_DSI_CMD_MODE_CFG(x).B.en_tear_fx)

/*! @brief Format value for bitfield MIPI_DSI_CMD_MODE_CFG_en_tear_fx. */
#define BF_MIPI_DSI_CMD_MODE_CFG_en_tear_fx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_MODE_CFG_en_tear_fx) & BM_MIPI_DSI_CMD_MODE_CFG_en_tear_fx)

/*! @brief Set the en_tear_fx field to a new value. */
#define BW_MIPI_DSI_CMD_MODE_CFG_en_tear_fx(x, v) (HW_MIPI_DSI_CMD_MODE_CFG_WR(x, (HW_MIPI_DSI_CMD_MODE_CFG_RD(x) & ~BM_MIPI_DSI_CMD_MODE_CFG_en_tear_fx) | BF_MIPI_DSI_CMD_MODE_CFG_en_tear_fx(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_TMR_LINE_CFG - Line timer configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_TMR_LINE_CFG - Line timer configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x28 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_tmr_line_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_tmr_line_cfg_bitfields
    {
        uint32_t hsa_time : 9;         /*!< [8:0]  */
        uint32_t hbp_time : 9;         /*!< [17:9]  */
        uint32_t hline_time : 14;      /*!< [31:18]  */
    } B;
} hw_mipi_dsi_tmr_line_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_TMR_LINE_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_TMR_LINE_CFG_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_MIPI_DSI_TMR_LINE_CFG(x) (*(__IO hw_mipi_dsi_tmr_line_cfg_t *) HW_MIPI_DSI_TMR_LINE_CFG_ADDR(x))
#define HW_MIPI_DSI_TMR_LINE_CFG_RD(x) (HW_MIPI_DSI_TMR_LINE_CFG(x).U)
#define HW_MIPI_DSI_TMR_LINE_CFG_WR(x, v) (HW_MIPI_DSI_TMR_LINE_CFG(x).U = (v))
#define HW_MIPI_DSI_TMR_LINE_CFG_SET(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, HW_MIPI_DSI_TMR_LINE_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_TMR_LINE_CFG_CLR(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, HW_MIPI_DSI_TMR_LINE_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_TMR_LINE_CFG_TOG(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, HW_MIPI_DSI_TMR_LINE_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_TMR_LINE_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_TMR_LINE_CFG, field hsa_time[8:0] (RW)
 *
 * Configures the Horizontal Synchronism Active period in lane byte clock cycles
 */
/*@{*/
#define BP_MIPI_DSI_TMR_LINE_CFG_hsa_time (0U) /*!< Bit position for MIPI_DSI_TMR_LINE_CFG_hsa_time. */
#define BM_MIPI_DSI_TMR_LINE_CFG_hsa_time (0x000001FFU) /*!< Bit mask for MIPI_DSI_TMR_LINE_CFG_hsa_time. */
#define BS_MIPI_DSI_TMR_LINE_CFG_hsa_time (9U) /*!< Bit field size in bits for MIPI_DSI_TMR_LINE_CFG_hsa_time. */

/*! @brief Read current value of the MIPI_DSI_TMR_LINE_CFG_hsa_time field. */
#define BR_MIPI_DSI_TMR_LINE_CFG_hsa_time(x) (HW_MIPI_DSI_TMR_LINE_CFG(x).B.hsa_time)

/*! @brief Format value for bitfield MIPI_DSI_TMR_LINE_CFG_hsa_time. */
#define BF_MIPI_DSI_TMR_LINE_CFG_hsa_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_TMR_LINE_CFG_hsa_time) & BM_MIPI_DSI_TMR_LINE_CFG_hsa_time)

/*! @brief Set the hsa_time field to a new value. */
#define BW_MIPI_DSI_TMR_LINE_CFG_hsa_time(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, (HW_MIPI_DSI_TMR_LINE_CFG_RD(x) & ~BM_MIPI_DSI_TMR_LINE_CFG_hsa_time) | BF_MIPI_DSI_TMR_LINE_CFG_hsa_time(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_TMR_LINE_CFG, field hbp_time[17:9] (RW)
 *
 * Configures the Horizontal Back Porch period in lane byte clock cycles
 */
/*@{*/
#define BP_MIPI_DSI_TMR_LINE_CFG_hbp_time (9U) /*!< Bit position for MIPI_DSI_TMR_LINE_CFG_hbp_time. */
#define BM_MIPI_DSI_TMR_LINE_CFG_hbp_time (0x0003FE00U) /*!< Bit mask for MIPI_DSI_TMR_LINE_CFG_hbp_time. */
#define BS_MIPI_DSI_TMR_LINE_CFG_hbp_time (9U) /*!< Bit field size in bits for MIPI_DSI_TMR_LINE_CFG_hbp_time. */

/*! @brief Read current value of the MIPI_DSI_TMR_LINE_CFG_hbp_time field. */
#define BR_MIPI_DSI_TMR_LINE_CFG_hbp_time(x) (HW_MIPI_DSI_TMR_LINE_CFG(x).B.hbp_time)

/*! @brief Format value for bitfield MIPI_DSI_TMR_LINE_CFG_hbp_time. */
#define BF_MIPI_DSI_TMR_LINE_CFG_hbp_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_TMR_LINE_CFG_hbp_time) & BM_MIPI_DSI_TMR_LINE_CFG_hbp_time)

/*! @brief Set the hbp_time field to a new value. */
#define BW_MIPI_DSI_TMR_LINE_CFG_hbp_time(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, (HW_MIPI_DSI_TMR_LINE_CFG_RD(x) & ~BM_MIPI_DSI_TMR_LINE_CFG_hbp_time) | BF_MIPI_DSI_TMR_LINE_CFG_hbp_time(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_TMR_LINE_CFG, field hline_time[31:18] (RW)
 *
 * Configures the size of the total line counted in lane byte cycles
 */
/*@{*/
#define BP_MIPI_DSI_TMR_LINE_CFG_hline_time (18U) /*!< Bit position for MIPI_DSI_TMR_LINE_CFG_hline_time. */
#define BM_MIPI_DSI_TMR_LINE_CFG_hline_time (0xFFFC0000U) /*!< Bit mask for MIPI_DSI_TMR_LINE_CFG_hline_time. */
#define BS_MIPI_DSI_TMR_LINE_CFG_hline_time (14U) /*!< Bit field size in bits for MIPI_DSI_TMR_LINE_CFG_hline_time. */

/*! @brief Read current value of the MIPI_DSI_TMR_LINE_CFG_hline_time field. */
#define BR_MIPI_DSI_TMR_LINE_CFG_hline_time(x) (HW_MIPI_DSI_TMR_LINE_CFG(x).B.hline_time)

/*! @brief Format value for bitfield MIPI_DSI_TMR_LINE_CFG_hline_time. */
#define BF_MIPI_DSI_TMR_LINE_CFG_hline_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_TMR_LINE_CFG_hline_time) & BM_MIPI_DSI_TMR_LINE_CFG_hline_time)

/*! @brief Set the hline_time field to a new value. */
#define BW_MIPI_DSI_TMR_LINE_CFG_hline_time(x, v) (HW_MIPI_DSI_TMR_LINE_CFG_WR(x, (HW_MIPI_DSI_TMR_LINE_CFG_RD(x) & ~BM_MIPI_DSI_TMR_LINE_CFG_hline_time) | BF_MIPI_DSI_TMR_LINE_CFG_hline_time(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_VTIMING_CFG - Vertical timing configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_VTIMING_CFG - Vertical timing configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x2c Memory Access: R/W
 */
typedef union _hw_mipi_dsi_vtiming_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_vtiming_cfg_bitfields
    {
        uint32_t vsa_lines : 4;        /*!< [3:0]  */
        uint32_t vbp_lines : 6;        /*!< [9:4]  */
        uint32_t vfp_lines : 6;        /*!< [15:10]  */
        uint32_t v_active_lines : 11;  /*!< [26:16]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_mipi_dsi_vtiming_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_VTIMING_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_VTIMING_CFG_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_MIPI_DSI_VTIMING_CFG(x) (*(__IO hw_mipi_dsi_vtiming_cfg_t *) HW_MIPI_DSI_VTIMING_CFG_ADDR(x))
#define HW_MIPI_DSI_VTIMING_CFG_RD(x) (HW_MIPI_DSI_VTIMING_CFG(x).U)
#define HW_MIPI_DSI_VTIMING_CFG_WR(x, v) (HW_MIPI_DSI_VTIMING_CFG(x).U = (v))
#define HW_MIPI_DSI_VTIMING_CFG_SET(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, HW_MIPI_DSI_VTIMING_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_VTIMING_CFG_CLR(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, HW_MIPI_DSI_VTIMING_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_VTIMING_CFG_TOG(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, HW_MIPI_DSI_VTIMING_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_VTIMING_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_VTIMING_CFG, field vsa_lines[3:0] (RW)
 *
 * Configures the Vertical Synchronism Active period measured in horizontal lines
 */
/*@{*/
#define BP_MIPI_DSI_VTIMING_CFG_vsa_lines (0U) /*!< Bit position for MIPI_DSI_VTIMING_CFG_vsa_lines. */
#define BM_MIPI_DSI_VTIMING_CFG_vsa_lines (0x0000000FU) /*!< Bit mask for MIPI_DSI_VTIMING_CFG_vsa_lines. */
#define BS_MIPI_DSI_VTIMING_CFG_vsa_lines (4U) /*!< Bit field size in bits for MIPI_DSI_VTIMING_CFG_vsa_lines. */

/*! @brief Read current value of the MIPI_DSI_VTIMING_CFG_vsa_lines field. */
#define BR_MIPI_DSI_VTIMING_CFG_vsa_lines(x) (HW_MIPI_DSI_VTIMING_CFG(x).B.vsa_lines)

/*! @brief Format value for bitfield MIPI_DSI_VTIMING_CFG_vsa_lines. */
#define BF_MIPI_DSI_VTIMING_CFG_vsa_lines(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VTIMING_CFG_vsa_lines) & BM_MIPI_DSI_VTIMING_CFG_vsa_lines)

/*! @brief Set the vsa_lines field to a new value. */
#define BW_MIPI_DSI_VTIMING_CFG_vsa_lines(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, (HW_MIPI_DSI_VTIMING_CFG_RD(x) & ~BM_MIPI_DSI_VTIMING_CFG_vsa_lines) | BF_MIPI_DSI_VTIMING_CFG_vsa_lines(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VTIMING_CFG, field vbp_lines[9:4] (RW)
 *
 * Configures the Vertical Back Porch period measured in horizontal lines
 */
/*@{*/
#define BP_MIPI_DSI_VTIMING_CFG_vbp_lines (4U) /*!< Bit position for MIPI_DSI_VTIMING_CFG_vbp_lines. */
#define BM_MIPI_DSI_VTIMING_CFG_vbp_lines (0x000003F0U) /*!< Bit mask for MIPI_DSI_VTIMING_CFG_vbp_lines. */
#define BS_MIPI_DSI_VTIMING_CFG_vbp_lines (6U) /*!< Bit field size in bits for MIPI_DSI_VTIMING_CFG_vbp_lines. */

/*! @brief Read current value of the MIPI_DSI_VTIMING_CFG_vbp_lines field. */
#define BR_MIPI_DSI_VTIMING_CFG_vbp_lines(x) (HW_MIPI_DSI_VTIMING_CFG(x).B.vbp_lines)

/*! @brief Format value for bitfield MIPI_DSI_VTIMING_CFG_vbp_lines. */
#define BF_MIPI_DSI_VTIMING_CFG_vbp_lines(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VTIMING_CFG_vbp_lines) & BM_MIPI_DSI_VTIMING_CFG_vbp_lines)

/*! @brief Set the vbp_lines field to a new value. */
#define BW_MIPI_DSI_VTIMING_CFG_vbp_lines(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, (HW_MIPI_DSI_VTIMING_CFG_RD(x) & ~BM_MIPI_DSI_VTIMING_CFG_vbp_lines) | BF_MIPI_DSI_VTIMING_CFG_vbp_lines(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VTIMING_CFG, field vfp_lines[15:10] (RW)
 *
 * Configures the Vertical Front Porch period measured in horizontal lines
 */
/*@{*/
#define BP_MIPI_DSI_VTIMING_CFG_vfp_lines (10U) /*!< Bit position for MIPI_DSI_VTIMING_CFG_vfp_lines. */
#define BM_MIPI_DSI_VTIMING_CFG_vfp_lines (0x0000FC00U) /*!< Bit mask for MIPI_DSI_VTIMING_CFG_vfp_lines. */
#define BS_MIPI_DSI_VTIMING_CFG_vfp_lines (6U) /*!< Bit field size in bits for MIPI_DSI_VTIMING_CFG_vfp_lines. */

/*! @brief Read current value of the MIPI_DSI_VTIMING_CFG_vfp_lines field. */
#define BR_MIPI_DSI_VTIMING_CFG_vfp_lines(x) (HW_MIPI_DSI_VTIMING_CFG(x).B.vfp_lines)

/*! @brief Format value for bitfield MIPI_DSI_VTIMING_CFG_vfp_lines. */
#define BF_MIPI_DSI_VTIMING_CFG_vfp_lines(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VTIMING_CFG_vfp_lines) & BM_MIPI_DSI_VTIMING_CFG_vfp_lines)

/*! @brief Set the vfp_lines field to a new value. */
#define BW_MIPI_DSI_VTIMING_CFG_vfp_lines(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, (HW_MIPI_DSI_VTIMING_CFG_RD(x) & ~BM_MIPI_DSI_VTIMING_CFG_vfp_lines) | BF_MIPI_DSI_VTIMING_CFG_vfp_lines(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_VTIMING_CFG, field v_active_lines[26:16] (RW)
 *
 * Configures the Vertical Active period measured in horizontal lines
 */
/*@{*/
#define BP_MIPI_DSI_VTIMING_CFG_v_active_lines (16U) /*!< Bit position for MIPI_DSI_VTIMING_CFG_v_active_lines. */
#define BM_MIPI_DSI_VTIMING_CFG_v_active_lines (0x07FF0000U) /*!< Bit mask for MIPI_DSI_VTIMING_CFG_v_active_lines. */
#define BS_MIPI_DSI_VTIMING_CFG_v_active_lines (11U) /*!< Bit field size in bits for MIPI_DSI_VTIMING_CFG_v_active_lines. */

/*! @brief Read current value of the MIPI_DSI_VTIMING_CFG_v_active_lines field. */
#define BR_MIPI_DSI_VTIMING_CFG_v_active_lines(x) (HW_MIPI_DSI_VTIMING_CFG(x).B.v_active_lines)

/*! @brief Format value for bitfield MIPI_DSI_VTIMING_CFG_v_active_lines. */
#define BF_MIPI_DSI_VTIMING_CFG_v_active_lines(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_VTIMING_CFG_v_active_lines) & BM_MIPI_DSI_VTIMING_CFG_v_active_lines)

/*! @brief Set the v_active_lines field to a new value. */
#define BW_MIPI_DSI_VTIMING_CFG_v_active_lines(x, v) (HW_MIPI_DSI_VTIMING_CFG_WR(x, (HW_MIPI_DSI_VTIMING_CFG_RD(x) & ~BM_MIPI_DSI_VTIMING_CFG_v_active_lines) | BF_MIPI_DSI_VTIMING_CFG_v_active_lines(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_TMR_CFG - D-PHY timing configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_TMR_CFG - D-PHY timing configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x30 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_tmr_cfg
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_tmr_cfg_bitfields
    {
        uint32_t bta_time : 12;        /*!< [11:0]  */
        uint32_t phy_lp2hs_time : 8;   /*!< [19:12]  */
        uint32_t phy_hs2lp_time : 8;   /*!< [27:20]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_mipi_dsi_phy_tmr_cfg_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_TMR_CFG register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_TMR_CFG_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_MIPI_DSI_PHY_TMR_CFG(x) (*(__IO hw_mipi_dsi_phy_tmr_cfg_t *) HW_MIPI_DSI_PHY_TMR_CFG_ADDR(x))
#define HW_MIPI_DSI_PHY_TMR_CFG_RD(x) (HW_MIPI_DSI_PHY_TMR_CFG(x).U)
#define HW_MIPI_DSI_PHY_TMR_CFG_WR(x, v) (HW_MIPI_DSI_PHY_TMR_CFG(x).U = (v))
#define HW_MIPI_DSI_PHY_TMR_CFG_SET(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, HW_MIPI_DSI_PHY_TMR_CFG_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_TMR_CFG_CLR(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, HW_MIPI_DSI_PHY_TMR_CFG_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_TMR_CFG_TOG(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, HW_MIPI_DSI_PHY_TMR_CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_TMR_CFG bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_TMR_CFG, field bta_time[11:0] (RW)
 *
 * Configures the maximum time required to perform the Bus Turn Around operation
 * measured in lane byte clock cycles
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TMR_CFG_bta_time (0U) /*!< Bit position for MIPI_DSI_PHY_TMR_CFG_bta_time. */
#define BM_MIPI_DSI_PHY_TMR_CFG_bta_time (0x00000FFFU) /*!< Bit mask for MIPI_DSI_PHY_TMR_CFG_bta_time. */
#define BS_MIPI_DSI_PHY_TMR_CFG_bta_time (12U) /*!< Bit field size in bits for MIPI_DSI_PHY_TMR_CFG_bta_time. */

/*! @brief Read current value of the MIPI_DSI_PHY_TMR_CFG_bta_time field. */
#define BR_MIPI_DSI_PHY_TMR_CFG_bta_time(x) (HW_MIPI_DSI_PHY_TMR_CFG(x).B.bta_time)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TMR_CFG_bta_time. */
#define BF_MIPI_DSI_PHY_TMR_CFG_bta_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TMR_CFG_bta_time) & BM_MIPI_DSI_PHY_TMR_CFG_bta_time)

/*! @brief Set the bta_time field to a new value. */
#define BW_MIPI_DSI_PHY_TMR_CFG_bta_time(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, (HW_MIPI_DSI_PHY_TMR_CFG_RD(x) & ~BM_MIPI_DSI_PHY_TMR_CFG_bta_time) | BF_MIPI_DSI_PHY_TMR_CFG_bta_time(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_TMR_CFG, field phy_lp2hs_time[19:12] (RW)
 *
 * Configures the maximum time that the PHY takes to go from Low Power to High
 * Speed transmission measured in lane byte clock cycles
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time (12U) /*!< Bit position for MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time. */
#define BM_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time (0x000FF000U) /*!< Bit mask for MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time. */
#define BS_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time (8U) /*!< Bit field size in bits for MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time. */

/*! @brief Read current value of the MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time field. */
#define BR_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time(x) (HW_MIPI_DSI_PHY_TMR_CFG(x).B.phy_lp2hs_time)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time. */
#define BF_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time) & BM_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time)

/*! @brief Set the phy_lp2hs_time field to a new value. */
#define BW_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, (HW_MIPI_DSI_PHY_TMR_CFG_RD(x) & ~BM_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time) | BF_MIPI_DSI_PHY_TMR_CFG_phy_lp2hs_time(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_TMR_CFG, field phy_hs2lp_time[27:20] (RW)
 *
 * Configures the maximum time that the PHY takes to go from High Speed to Low
 * Power transmission measured in lane byte clock cycles
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time (20U) /*!< Bit position for MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time. */
#define BM_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time (0x0FF00000U) /*!< Bit mask for MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time. */
#define BS_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time (8U) /*!< Bit field size in bits for MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time. */

/*! @brief Read current value of the MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time field. */
#define BR_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time(x) (HW_MIPI_DSI_PHY_TMR_CFG(x).B.phy_hs2lp_time)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time. */
#define BF_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time) & BM_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time)

/*! @brief Set the phy_hs2lp_time field to a new value. */
#define BW_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time(x, v) (HW_MIPI_DSI_PHY_TMR_CFG_WR(x, (HW_MIPI_DSI_PHY_TMR_CFG_RD(x) & ~BM_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time) | BF_MIPI_DSI_PHY_TMR_CFG_phy_hs2lp_time(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_GEN_HDR - Generic packet Header configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_GEN_HDR - Generic packet Header configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x34 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_gen_hdr
{
    uint32_t U;
    struct _hw_mipi_dsi_gen_hdr_bitfields
    {
        uint32_t gen_htype : 8;        /*!< [7:0]  */
        uint32_t gen_hdata : 16;       /*!< [23:8]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_mipi_dsi_gen_hdr_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_GEN_HDR register
 */
/*@{*/
#define HW_MIPI_DSI_GEN_HDR_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_MIPI_DSI_GEN_HDR(x)   (*(__IO hw_mipi_dsi_gen_hdr_t *) HW_MIPI_DSI_GEN_HDR_ADDR(x))
#define HW_MIPI_DSI_GEN_HDR_RD(x) (HW_MIPI_DSI_GEN_HDR(x).U)
#define HW_MIPI_DSI_GEN_HDR_WR(x, v) (HW_MIPI_DSI_GEN_HDR(x).U = (v))
#define HW_MIPI_DSI_GEN_HDR_SET(x, v) (HW_MIPI_DSI_GEN_HDR_WR(x, HW_MIPI_DSI_GEN_HDR_RD(x) |  (v)))
#define HW_MIPI_DSI_GEN_HDR_CLR(x, v) (HW_MIPI_DSI_GEN_HDR_WR(x, HW_MIPI_DSI_GEN_HDR_RD(x) & ~(v)))
#define HW_MIPI_DSI_GEN_HDR_TOG(x, v) (HW_MIPI_DSI_GEN_HDR_WR(x, HW_MIPI_DSI_GEN_HDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_GEN_HDR bitfields
 */

/*!
 * @name Register MIPI_DSI_GEN_HDR, field gen_htype[7:0] (RW)
 *
 * Configures the packet type to be transmitted through the generic interface.
 * Writing to this register triggers packet transmission (Payload must be written
 * in advance)
 */
/*@{*/
#define BP_MIPI_DSI_GEN_HDR_gen_htype (0U) /*!< Bit position for MIPI_DSI_GEN_HDR_gen_htype. */
#define BM_MIPI_DSI_GEN_HDR_gen_htype (0x000000FFU) /*!< Bit mask for MIPI_DSI_GEN_HDR_gen_htype. */
#define BS_MIPI_DSI_GEN_HDR_gen_htype (8U) /*!< Bit field size in bits for MIPI_DSI_GEN_HDR_gen_htype. */

/*! @brief Read current value of the MIPI_DSI_GEN_HDR_gen_htype field. */
#define BR_MIPI_DSI_GEN_HDR_gen_htype(x) (HW_MIPI_DSI_GEN_HDR(x).B.gen_htype)

/*! @brief Format value for bitfield MIPI_DSI_GEN_HDR_gen_htype. */
#define BF_MIPI_DSI_GEN_HDR_gen_htype(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_GEN_HDR_gen_htype) & BM_MIPI_DSI_GEN_HDR_gen_htype)

/*! @brief Set the gen_htype field to a new value. */
#define BW_MIPI_DSI_GEN_HDR_gen_htype(x, v) (HW_MIPI_DSI_GEN_HDR_WR(x, (HW_MIPI_DSI_GEN_HDR_RD(x) & ~BM_MIPI_DSI_GEN_HDR_gen_htype) | BF_MIPI_DSI_GEN_HDR_gen_htype(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_GEN_HDR, field gen_hdata[23:8] (RW)
 *
 * Configures the packet data to be transmitted through the generic interface
 */
/*@{*/
#define BP_MIPI_DSI_GEN_HDR_gen_hdata (8U) /*!< Bit position for MIPI_DSI_GEN_HDR_gen_hdata. */
#define BM_MIPI_DSI_GEN_HDR_gen_hdata (0x00FFFF00U) /*!< Bit mask for MIPI_DSI_GEN_HDR_gen_hdata. */
#define BS_MIPI_DSI_GEN_HDR_gen_hdata (16U) /*!< Bit field size in bits for MIPI_DSI_GEN_HDR_gen_hdata. */

/*! @brief Read current value of the MIPI_DSI_GEN_HDR_gen_hdata field. */
#define BR_MIPI_DSI_GEN_HDR_gen_hdata(x) (HW_MIPI_DSI_GEN_HDR(x).B.gen_hdata)

/*! @brief Format value for bitfield MIPI_DSI_GEN_HDR_gen_hdata. */
#define BF_MIPI_DSI_GEN_HDR_gen_hdata(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_GEN_HDR_gen_hdata) & BM_MIPI_DSI_GEN_HDR_gen_hdata)

/*! @brief Set the gen_hdata field to a new value. */
#define BW_MIPI_DSI_GEN_HDR_gen_hdata(x, v) (HW_MIPI_DSI_GEN_HDR_WR(x, (HW_MIPI_DSI_GEN_HDR_RD(x) & ~BM_MIPI_DSI_GEN_HDR_gen_hdata) | BF_MIPI_DSI_GEN_HDR_gen_hdata(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_GEN_PLD_DATA - Generic payload data in/out
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_GEN_PLD_DATA - Generic payload data in/out (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x38 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_gen_pld_data
{
    uint32_t U;
    struct _hw_mipi_dsi_gen_pld_data_bitfields
    {
        uint32_t gen_pld_data : 32;    /*!< [31:0]  */
    } B;
} hw_mipi_dsi_gen_pld_data_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_GEN_PLD_DATA register
 */
/*@{*/
#define HW_MIPI_DSI_GEN_PLD_DATA_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_MIPI_DSI_GEN_PLD_DATA(x) (*(__IO hw_mipi_dsi_gen_pld_data_t *) HW_MIPI_DSI_GEN_PLD_DATA_ADDR(x))
#define HW_MIPI_DSI_GEN_PLD_DATA_RD(x) (HW_MIPI_DSI_GEN_PLD_DATA(x).U)
#define HW_MIPI_DSI_GEN_PLD_DATA_WR(x, v) (HW_MIPI_DSI_GEN_PLD_DATA(x).U = (v))
#define HW_MIPI_DSI_GEN_PLD_DATA_SET(x, v) (HW_MIPI_DSI_GEN_PLD_DATA_WR(x, HW_MIPI_DSI_GEN_PLD_DATA_RD(x) |  (v)))
#define HW_MIPI_DSI_GEN_PLD_DATA_CLR(x, v) (HW_MIPI_DSI_GEN_PLD_DATA_WR(x, HW_MIPI_DSI_GEN_PLD_DATA_RD(x) & ~(v)))
#define HW_MIPI_DSI_GEN_PLD_DATA_TOG(x, v) (HW_MIPI_DSI_GEN_PLD_DATA_WR(x, HW_MIPI_DSI_GEN_PLD_DATA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_GEN_PLD_DATA bitfields
 */

/*!
 * @name Register MIPI_DSI_GEN_PLD_DATA, field gen_pld_data[31:0] (RW)
 *
 * This register contains the input/output generic packet data. Write access to
 * it writes the content of the packet payload. Read access reads the incoming
 * generic read data
 */
/*@{*/
#define BP_MIPI_DSI_GEN_PLD_DATA_gen_pld_data (0U) /*!< Bit position for MIPI_DSI_GEN_PLD_DATA_gen_pld_data. */
#define BM_MIPI_DSI_GEN_PLD_DATA_gen_pld_data (0xFFFFFFFFU) /*!< Bit mask for MIPI_DSI_GEN_PLD_DATA_gen_pld_data. */
#define BS_MIPI_DSI_GEN_PLD_DATA_gen_pld_data (32U) /*!< Bit field size in bits for MIPI_DSI_GEN_PLD_DATA_gen_pld_data. */

/*! @brief Read current value of the MIPI_DSI_GEN_PLD_DATA_gen_pld_data field. */
#define BR_MIPI_DSI_GEN_PLD_DATA_gen_pld_data(x) (HW_MIPI_DSI_GEN_PLD_DATA(x).U)

/*! @brief Format value for bitfield MIPI_DSI_GEN_PLD_DATA_gen_pld_data. */
#define BF_MIPI_DSI_GEN_PLD_DATA_gen_pld_data(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_GEN_PLD_DATA_gen_pld_data) & BM_MIPI_DSI_GEN_PLD_DATA_gen_pld_data)

/*! @brief Set the gen_pld_data field to a new value. */
#define BW_MIPI_DSI_GEN_PLD_DATA_gen_pld_data(x, v) (HW_MIPI_DSI_GEN_PLD_DATA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_CMD_PKT_STATUS - Command packet status
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_CMD_PKT_STATUS - Command packet status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x3c Memory Access: R/W
 */
typedef union _hw_mipi_dsi_cmd_pkt_status
{
    uint32_t U;
    struct _hw_mipi_dsi_cmd_pkt_status_bitfields
    {
        uint32_t gen_cmd_empty : 1;    /*!< [0]  */
        uint32_t gen_cmd_full : 1;     /*!< [1]  */
        uint32_t gen_pld_w_empty : 1;  /*!< [2]  */
        uint32_t gen_pld_w_full : 1;   /*!< [3]  */
        uint32_t gen_pld_r_empty : 1;  /*!< [4]  */
        uint32_t gen_pld_r_full : 1;   /*!< [5]  */
        uint32_t gen_rd_cmd_busy : 1;  /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t dbi_cmd_empty : 1;    /*!< [8]  */
        uint32_t dbi_cmd_full : 1;     /*!< [9]  */
        uint32_t dbi_pld_w_empty : 1;  /*!< [10]  */
        uint32_t dbi_pld_w_full : 1;   /*!< [11]  */
        uint32_t dbi_pld_r_empty : 1;  /*!< [12]  */
        uint32_t dbi_pld_r_full : 1;   /*!< [13]  */
        uint32_t dbi_rd_cmd_busy : 1;  /*!< [14]  */
        uint32_t RESERVED1 : 17;       /*!< [31:15]  */
    } B;
} hw_mipi_dsi_cmd_pkt_status_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_CMD_PKT_STATUS register
 */
/*@{*/
#define HW_MIPI_DSI_CMD_PKT_STATUS_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_MIPI_DSI_CMD_PKT_STATUS(x) (*(__IO hw_mipi_dsi_cmd_pkt_status_t *) HW_MIPI_DSI_CMD_PKT_STATUS_ADDR(x))
#define HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).U)
#define HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS(x).U = (v))
#define HW_MIPI_DSI_CMD_PKT_STATUS_SET(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) |  (v)))
#define HW_MIPI_DSI_CMD_PKT_STATUS_CLR(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~(v)))
#define HW_MIPI_DSI_CMD_PKT_STATUS_TOG(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_CMD_PKT_STATUS bitfields
 */

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_cmd_empty[0] (RW)
 *
 * Reports the empty status of the generic command FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty (0U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty (0x00000001U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_cmd_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty)

/*! @brief Set the gen_cmd_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_cmd_full[1] (RW)
 *
 * Reports the full status of the generic command FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full (1U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full (0x00000002U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_cmd_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full)

/*! @brief Set the gen_cmd_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_cmd_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_pld_w_empty[2] (RW)
 *
 * Reports the empty status of the generic write payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty (2U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty (0x00000004U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_pld_w_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty)

/*! @brief Set the gen_pld_w_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_pld_w_full[3] (RW)
 *
 * Reports the full status of the generic write payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full (3U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full (0x00000008U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_pld_w_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full)

/*! @brief Set the gen_pld_w_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_w_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_pld_r_empty[4] (RW)
 *
 * Reports the empty status of the generic read payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty (4U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty (0x00000010U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_pld_r_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty)

/*! @brief Set the gen_pld_r_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_pld_r_full[5] (RW)
 *
 * Reports the full status of the generic read payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full (5U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full (0x00000020U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_pld_r_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full)

/*! @brief Set the gen_pld_r_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_pld_r_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field gen_rd_cmd_busy[6] (RW)
 *
 * Set when a read command is issued and cleared once the entire response is
 * stored in the FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy (6U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy (0x00000040U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.gen_rd_cmd_busy)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy) & BM_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy)

/*! @brief Set the gen_rd_cmd_busy field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy) | BF_MIPI_DSI_CMD_PKT_STATUS_gen_rd_cmd_busy(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_cmd_empty[8] (RW)
 *
 * Reports the empty status of the DBI command FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty (8U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty (0x00000100U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_cmd_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty)

/*! @brief Set the dbi_cmd_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_cmd_full[9] (RW)
 *
 * Reports the full status of the DBI command FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full (9U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full (0x00000200U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_cmd_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full)

/*! @brief Set the dbi_cmd_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_cmd_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_pld_w_empty[10] (RW)
 *
 * Reports the empty status of the DBI write payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty (10U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty (0x00000400U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_pld_w_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty)

/*! @brief Set the dbi_pld_w_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_pld_w_full[11] (RW)
 *
 * Reports the full status of the DBI write payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full (11U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full (0x00000800U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_pld_w_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full)

/*! @brief Set the dbi_pld_w_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_w_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_pld_r_empty[12] (RW)
 *
 * Reports the empty status of the DBI read payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty (12U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty (0x00001000U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_pld_r_empty)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty)

/*! @brief Set the dbi_pld_r_empty field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_empty(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_pld_r_full[13] (RW)
 *
 * Reports the full status of the DBI read payload FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full (13U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full (0x00002000U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_pld_r_full)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full)

/*! @brief Set the dbi_pld_r_full field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_pld_r_full(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_CMD_PKT_STATUS, field dbi_rd_cmd_busy[14] (RW)
 *
 * Set when a read command is issued and cleared once the entire response is
 * stored in the FIFO
 */
/*@{*/
#define BP_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy (14U) /*!< Bit position for MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy. */
#define BM_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy (0x00004000U) /*!< Bit mask for MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy. */
#define BS_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy (1U) /*!< Bit field size in bits for MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy. */

/*! @brief Read current value of the MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy field. */
#define BR_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy(x) (HW_MIPI_DSI_CMD_PKT_STATUS(x).B.dbi_rd_cmd_busy)

/*! @brief Format value for bitfield MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy. */
#define BF_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy) & BM_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy)

/*! @brief Set the dbi_rd_cmd_busy field to a new value. */
#define BW_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy(x, v) (HW_MIPI_DSI_CMD_PKT_STATUS_WR(x, (HW_MIPI_DSI_CMD_PKT_STATUS_RD(x) & ~BM_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy) | BF_MIPI_DSI_CMD_PKT_STATUS_dbi_rd_cmd_busy(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_TO_CNT_CFG0 - Time Out timers configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_TO_CNT_CFG0 - Time Out timers configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x40 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_to_cnt_cfg0
{
    uint32_t U;
    struct _hw_mipi_dsi_to_cnt_cfg0_bitfields
    {
        uint32_t hstx_to_cnt : 16;     /*!< [15:0]  */
        uint32_t lprx_to_cnt : 16;     /*!< [31:16]  */
    } B;
} hw_mipi_dsi_to_cnt_cfg0_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_TO_CNT_CFG0 register
 */
/*@{*/
#define HW_MIPI_DSI_TO_CNT_CFG0_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_MIPI_DSI_TO_CNT_CFG0(x) (*(__IO hw_mipi_dsi_to_cnt_cfg0_t *) HW_MIPI_DSI_TO_CNT_CFG0_ADDR(x))
#define HW_MIPI_DSI_TO_CNT_CFG0_RD(x) (HW_MIPI_DSI_TO_CNT_CFG0(x).U)
#define HW_MIPI_DSI_TO_CNT_CFG0_WR(x, v) (HW_MIPI_DSI_TO_CNT_CFG0(x).U = (v))
#define HW_MIPI_DSI_TO_CNT_CFG0_SET(x, v) (HW_MIPI_DSI_TO_CNT_CFG0_WR(x, HW_MIPI_DSI_TO_CNT_CFG0_RD(x) |  (v)))
#define HW_MIPI_DSI_TO_CNT_CFG0_CLR(x, v) (HW_MIPI_DSI_TO_CNT_CFG0_WR(x, HW_MIPI_DSI_TO_CNT_CFG0_RD(x) & ~(v)))
#define HW_MIPI_DSI_TO_CNT_CFG0_TOG(x, v) (HW_MIPI_DSI_TO_CNT_CFG0_WR(x, HW_MIPI_DSI_TO_CNT_CFG0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_TO_CNT_CFG0 bitfields
 */

/*!
 * @name Register MIPI_DSI_TO_CNT_CFG0, field hstx_to_cnt[15:0] (RW)
 *
 * Configures the time out counter that will trigger a High Speed Transmission
 * Time Out Contention Detection (Measured in TO_CLK_DIVISION cycles)
 */
/*@{*/
#define BP_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt (0U) /*!< Bit position for MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt. */
#define BM_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt (0x0000FFFFU) /*!< Bit mask for MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt. */
#define BS_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt (16U) /*!< Bit field size in bits for MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt. */

/*! @brief Read current value of the MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt field. */
#define BR_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt(x) (HW_MIPI_DSI_TO_CNT_CFG0(x).B.hstx_to_cnt)

/*! @brief Format value for bitfield MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt. */
#define BF_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt) & BM_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt)

/*! @brief Set the hstx_to_cnt field to a new value. */
#define BW_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt(x, v) (HW_MIPI_DSI_TO_CNT_CFG0_WR(x, (HW_MIPI_DSI_TO_CNT_CFG0_RD(x) & ~BM_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt) | BF_MIPI_DSI_TO_CNT_CFG0_hstx_to_cnt(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_TO_CNT_CFG0, field lprx_to_cnt[31:16] (RW)
 *
 * Configures the time out counter that will trigger a Low Power Reception Time
 * Out Contention Detection. (Measured in TO_CLK_DIVISION cycles)
 */
/*@{*/
#define BP_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt (16U) /*!< Bit position for MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt. */
#define BM_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt (0xFFFF0000U) /*!< Bit mask for MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt. */
#define BS_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt (16U) /*!< Bit field size in bits for MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt. */

/*! @brief Read current value of the MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt field. */
#define BR_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt(x) (HW_MIPI_DSI_TO_CNT_CFG0(x).B.lprx_to_cnt)

/*! @brief Format value for bitfield MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt. */
#define BF_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt) & BM_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt)

/*! @brief Set the lprx_to_cnt field to a new value. */
#define BW_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt(x, v) (HW_MIPI_DSI_TO_CNT_CFG0_WR(x, (HW_MIPI_DSI_TO_CNT_CFG0_RD(x) & ~BM_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt) | BF_MIPI_DSI_TO_CNT_CFG0_lprx_to_cnt(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_ERROR_ST0 - Interrupt status register 0
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_ERROR_ST0 - Interrupt status register 0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x44 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_error_st0
{
    uint32_t U;
    struct _hw_mipi_dsi_error_st0_bitfields
    {
        uint32_t ack_with_err_0 : 1;   /*!< [0]  */
        uint32_t ack_with_err_1 : 1;   /*!< [1]  */
        uint32_t ack_with_err_2 : 1;   /*!< [2]  */
        uint32_t ack_with_err_3 : 1;   /*!< [3]  */
        uint32_t ack_with_err_4 : 1;   /*!< [4]  */
        uint32_t ack_with_err_5 : 1;   /*!< [5]  */
        uint32_t ack_with_err_6 : 1;   /*!< [6]  */
        uint32_t ack_with_err_7 : 1;   /*!< [7]  */
        uint32_t ack_with_err_8 : 1;   /*!< [8]  */
        uint32_t ack_with_err_9 : 1;   /*!< [9]  */
        uint32_t ack_with_err_10 : 1;  /*!< [10]  */
        uint32_t ack_with_err_11 : 1;  /*!< [11]  */
        uint32_t ack_with_err_12 : 1;  /*!< [12]  */
        uint32_t ack_with_err_13 : 1;  /*!< [13]  */
        uint32_t ack_with_err_14 : 1;  /*!< [14]  */
        uint32_t ack_with_err_15 : 1;  /*!< [15]  */
        uint32_t dphy_errors_0 : 1;    /*!< [16]  */
        uint32_t dphy_errors_1 : 1;    /*!< [17]  */
        uint32_t dphy_errors_2 : 1;    /*!< [18]  */
        uint32_t dphy_errors_3 : 1;    /*!< [19]  */
        uint32_t dphy_errors_4 : 1;    /*!< [20]  */
        uint32_t RESERVED0 : 11;       /*!< [31:21]  */
    } B;
} hw_mipi_dsi_error_st0_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_ERROR_ST0 register
 */
/*@{*/
#define HW_MIPI_DSI_ERROR_ST0_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_MIPI_DSI_ERROR_ST0(x) (*(__IO hw_mipi_dsi_error_st0_t *) HW_MIPI_DSI_ERROR_ST0_ADDR(x))
#define HW_MIPI_DSI_ERROR_ST0_RD(x) (HW_MIPI_DSI_ERROR_ST0(x).U)
#define HW_MIPI_DSI_ERROR_ST0_WR(x, v) (HW_MIPI_DSI_ERROR_ST0(x).U = (v))
#define HW_MIPI_DSI_ERROR_ST0_SET(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, HW_MIPI_DSI_ERROR_ST0_RD(x) |  (v)))
#define HW_MIPI_DSI_ERROR_ST0_CLR(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, HW_MIPI_DSI_ERROR_ST0_RD(x) & ~(v)))
#define HW_MIPI_DSI_ERROR_ST0_TOG(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, HW_MIPI_DSI_ERROR_ST0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_ERROR_ST0 bitfields
 */

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_0[0] (RW)
 *
 * Retrieves SoT Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_0 (0U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_0. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_0 (0x00000001U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_0. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_0 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_0. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_0 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_0(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_0)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_0. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_0) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_0)

/*! @brief Set the ack_with_err_0 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_0(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_0) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_0(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_1[1] (RW)
 *
 * Retrieves SoT Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_1 (1U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_1. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_1 (0x00000002U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_1. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_1 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_1. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_1 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_1(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_1)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_1. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_1) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_1)

/*! @brief Set the ack_with_err_1 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_1(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_1) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_1(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_2[2] (RW)
 *
 * Retrieves EoT Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_2 (2U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_2. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_2 (0x00000004U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_2. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_2 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_2. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_2 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_2(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_2)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_2. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_2) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_2)

/*! @brief Set the ack_with_err_2 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_2(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_2) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_2(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_3[3] (RW)
 *
 * Retrieves Escape Mode Entry Command Error from Display Acknowledge Error
 * Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_3 (3U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_3. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_3 (0x00000008U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_3. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_3 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_3. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_3 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_3(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_3)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_3. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_3) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_3)

/*! @brief Set the ack_with_err_3 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_3(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_3) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_3(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_4[4] (RW)
 *
 * Retrieves Low-Power Transmit Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_4 (4U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_4. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_4 (0x00000010U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_4. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_4 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_4. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_4 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_4(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_4)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_4. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_4) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_4)

/*! @brief Set the ack_with_err_4 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_4(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_4) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_4(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_5[5] (RW)
 *
 * Retrieves HS Receive Timeout Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_5 (5U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_5. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_5 (0x00000020U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_5. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_5 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_5. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_5 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_5(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_5)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_5. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_5) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_5)

/*! @brief Set the ack_with_err_5 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_5(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_5) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_5(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_6[6] (RW)
 *
 * Retrieves False Control Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_6 (6U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_6. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_6 (0x00000040U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_6. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_6 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_6. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_6 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_6(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_6)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_6. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_6) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_6)

/*! @brief Set the ack_with_err_6 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_6(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_6) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_6(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_7[7] (RW)
 *
 * Retrieves Reserved (specific to device) from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_7 (7U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_7. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_7 (0x00000080U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_7. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_7 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_7. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_7 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_7(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_7)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_7. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_7) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_7)

/*! @brief Set the ack_with_err_7 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_7(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_7) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_7(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_8[8] (RW)
 *
 * Retrieves ECC Error, single-bit (detected and corrected) from Display
 * Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_8 (8U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_8. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_8 (0x00000100U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_8. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_8 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_8. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_8 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_8(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_8)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_8. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_8) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_8)

/*! @brief Set the ack_with_err_8 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_8(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_8) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_8(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_9[9] (RW)
 *
 * Retrieves ECC Error, multi-bit (detected, not corrected) from Display
 * Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_9 (9U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_9. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_9 (0x00000200U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_9. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_9 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_9. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_9 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_9(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_9)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_9. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_9) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_9)

/*! @brief Set the ack_with_err_9 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_9(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_9) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_9(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_10[10] (RW)
 *
 * Retrieves Checksum Error (Long packet only) from Display Acknowledge Error
 * Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_10 (10U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_10. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_10 (0x00000400U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_10. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_10 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_10. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_10 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_10(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_10)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_10. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_10) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_10)

/*! @brief Set the ack_with_err_10 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_10(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_10) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_10(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_11[11] (RW)
 *
 * Retrieves DSI Data Type Not Recognized from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_11 (11U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_11. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_11 (0x00000800U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_11. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_11 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_11. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_11 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_11(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_11)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_11. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_11) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_11)

/*! @brief Set the ack_with_err_11 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_11(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_11) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_11(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_12[12] (RW)
 *
 * Retrieves DSI VC ID Invalid from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_12 (12U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_12. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_12 (0x00001000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_12. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_12 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_12. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_12 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_12(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_12)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_12. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_12) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_12)

/*! @brief Set the ack_with_err_12 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_12(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_12) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_12(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_13[13] (RW)
 *
 * Retrieves Invalid Transmission Length from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_13 (13U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_13. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_13 (0x00002000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_13. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_13 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_13. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_13 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_13(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_13)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_13. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_13) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_13)

/*! @brief Set the ack_with_err_13 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_13(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_13) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_13(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_14[14] (RW)
 *
 * Retrieves Reserved (specific to device) from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_14 (14U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_14. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_14 (0x00004000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_14. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_14 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_14. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_14 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_14(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_14)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_14. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_14) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_14)

/*! @brief Set the ack_with_err_14 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_14(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_14) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_14(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field ack_with_err_15[15] (RW)
 *
 * Retrieves DSI Protocol Violation from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_ack_with_err_15 (15U) /*!< Bit position for MIPI_DSI_ERROR_ST0_ack_with_err_15. */
#define BM_MIPI_DSI_ERROR_ST0_ack_with_err_15 (0x00008000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_ack_with_err_15. */
#define BS_MIPI_DSI_ERROR_ST0_ack_with_err_15 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_ack_with_err_15. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_ack_with_err_15 field. */
#define BR_MIPI_DSI_ERROR_ST0_ack_with_err_15(x) (HW_MIPI_DSI_ERROR_ST0(x).B.ack_with_err_15)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_ack_with_err_15. */
#define BF_MIPI_DSI_ERROR_ST0_ack_with_err_15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_ack_with_err_15) & BM_MIPI_DSI_ERROR_ST0_ack_with_err_15)

/*! @brief Set the ack_with_err_15 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_ack_with_err_15(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_ack_with_err_15) | BF_MIPI_DSI_ERROR_ST0_ack_with_err_15(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field dphy_errors_0[16] (RW)
 *
 * ErrEsc Escape Entry Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_dphy_errors_0 (16U) /*!< Bit position for MIPI_DSI_ERROR_ST0_dphy_errors_0. */
#define BM_MIPI_DSI_ERROR_ST0_dphy_errors_0 (0x00010000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_dphy_errors_0. */
#define BS_MIPI_DSI_ERROR_ST0_dphy_errors_0 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_dphy_errors_0. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_dphy_errors_0 field. */
#define BR_MIPI_DSI_ERROR_ST0_dphy_errors_0(x) (HW_MIPI_DSI_ERROR_ST0(x).B.dphy_errors_0)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_dphy_errors_0. */
#define BF_MIPI_DSI_ERROR_ST0_dphy_errors_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_dphy_errors_0) & BM_MIPI_DSI_ERROR_ST0_dphy_errors_0)

/*! @brief Set the dphy_errors_0 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_dphy_errors_0(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_dphy_errors_0) | BF_MIPI_DSI_ERROR_ST0_dphy_errors_0(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field dphy_errors_1[17] (RW)
 *
 * ErrSyncEsc Low-Power Data Transmission Synchronization Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_dphy_errors_1 (17U) /*!< Bit position for MIPI_DSI_ERROR_ST0_dphy_errors_1. */
#define BM_MIPI_DSI_ERROR_ST0_dphy_errors_1 (0x00020000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_dphy_errors_1. */
#define BS_MIPI_DSI_ERROR_ST0_dphy_errors_1 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_dphy_errors_1. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_dphy_errors_1 field. */
#define BR_MIPI_DSI_ERROR_ST0_dphy_errors_1(x) (HW_MIPI_DSI_ERROR_ST0(x).B.dphy_errors_1)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_dphy_errors_1. */
#define BF_MIPI_DSI_ERROR_ST0_dphy_errors_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_dphy_errors_1) & BM_MIPI_DSI_ERROR_ST0_dphy_errors_1)

/*! @brief Set the dphy_errors_1 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_dphy_errors_1(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_dphy_errors_1) | BF_MIPI_DSI_ERROR_ST0_dphy_errors_1(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field dphy_errors_2[18] (RW)
 *
 * ErrControl Control Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_dphy_errors_2 (18U) /*!< Bit position for MIPI_DSI_ERROR_ST0_dphy_errors_2. */
#define BM_MIPI_DSI_ERROR_ST0_dphy_errors_2 (0x00040000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_dphy_errors_2. */
#define BS_MIPI_DSI_ERROR_ST0_dphy_errors_2 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_dphy_errors_2. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_dphy_errors_2 field. */
#define BR_MIPI_DSI_ERROR_ST0_dphy_errors_2(x) (HW_MIPI_DSI_ERROR_ST0(x).B.dphy_errors_2)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_dphy_errors_2. */
#define BF_MIPI_DSI_ERROR_ST0_dphy_errors_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_dphy_errors_2) & BM_MIPI_DSI_ERROR_ST0_dphy_errors_2)

/*! @brief Set the dphy_errors_2 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_dphy_errors_2(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_dphy_errors_2) | BF_MIPI_DSI_ERROR_ST0_dphy_errors_2(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field dphy_errors_3[19] (RW)
 *
 * ErrContentionLP0 LP0 Contention Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_dphy_errors_3 (19U) /*!< Bit position for MIPI_DSI_ERROR_ST0_dphy_errors_3. */
#define BM_MIPI_DSI_ERROR_ST0_dphy_errors_3 (0x00080000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_dphy_errors_3. */
#define BS_MIPI_DSI_ERROR_ST0_dphy_errors_3 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_dphy_errors_3. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_dphy_errors_3 field. */
#define BR_MIPI_DSI_ERROR_ST0_dphy_errors_3(x) (HW_MIPI_DSI_ERROR_ST0(x).B.dphy_errors_3)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_dphy_errors_3. */
#define BF_MIPI_DSI_ERROR_ST0_dphy_errors_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_dphy_errors_3) & BM_MIPI_DSI_ERROR_ST0_dphy_errors_3)

/*! @brief Set the dphy_errors_3 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_dphy_errors_3(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_dphy_errors_3) | BF_MIPI_DSI_ERROR_ST0_dphy_errors_3(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST0, field dphy_errors_4[20] (RW)
 *
 * ErrContentionLP1 LP1 Contention Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST0_dphy_errors_4 (20U) /*!< Bit position for MIPI_DSI_ERROR_ST0_dphy_errors_4. */
#define BM_MIPI_DSI_ERROR_ST0_dphy_errors_4 (0x00100000U) /*!< Bit mask for MIPI_DSI_ERROR_ST0_dphy_errors_4. */
#define BS_MIPI_DSI_ERROR_ST0_dphy_errors_4 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST0_dphy_errors_4. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST0_dphy_errors_4 field. */
#define BR_MIPI_DSI_ERROR_ST0_dphy_errors_4(x) (HW_MIPI_DSI_ERROR_ST0(x).B.dphy_errors_4)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST0_dphy_errors_4. */
#define BF_MIPI_DSI_ERROR_ST0_dphy_errors_4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST0_dphy_errors_4) & BM_MIPI_DSI_ERROR_ST0_dphy_errors_4)

/*! @brief Set the dphy_errors_4 field to a new value. */
#define BW_MIPI_DSI_ERROR_ST0_dphy_errors_4(x, v) (HW_MIPI_DSI_ERROR_ST0_WR(x, (HW_MIPI_DSI_ERROR_ST0_RD(x) & ~BM_MIPI_DSI_ERROR_ST0_dphy_errors_4) | BF_MIPI_DSI_ERROR_ST0_dphy_errors_4(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_ERROR_ST1 - Interrupt status register 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_ERROR_ST1 - Interrupt status register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x48 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_error_st1
{
    uint32_t U;
    struct _hw_mipi_dsi_error_st1_bitfields
    {
        uint32_t to_hs_tx : 1;         /*!< [0]  */
        uint32_t to_lp_rx : 1;         /*!< [1]  */
        uint32_t ecc_sinlge_err : 1;   /*!< [2]  */
        uint32_t ecc_multi_err : 1;    /*!< [3]  */
        uint32_t crc_err : 1;          /*!< [4]  */
        uint32_t pkt_size_err : 1;     /*!< [5]  */
        uint32_t eopt_err : 1;         /*!< [6]  */
        uint32_t dpi_pld_wr_err : 1;   /*!< [7]  */
        uint32_t gen_cmd_wr_err : 1;   /*!< [8]  */
        uint32_t gen_pld_wr_err : 1;   /*!< [9]  */
        uint32_t gen_pld_send_err : 1; /*!< [10]  */
        uint32_t gen_pld_rd_err : 1;   /*!< [11]  */
        uint32_t gen_pld_recv_err : 1; /*!< [12]  */
        uint32_t dbi_cmd_wr_err : 1;   /*!< [13]  */
        uint32_t dbi_pld_wr_err : 1;   /*!< [14]  */
        uint32_t dbi_pld_rd_err : 1;   /*!< [15]  */
        uint32_t dbi_pld_recv_err : 1; /*!< [16]  */
        uint32_t dbi_illegal_comm_err : 1; /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_mipi_dsi_error_st1_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_ERROR_ST1 register
 */
/*@{*/
#define HW_MIPI_DSI_ERROR_ST1_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_MIPI_DSI_ERROR_ST1(x) (*(__IO hw_mipi_dsi_error_st1_t *) HW_MIPI_DSI_ERROR_ST1_ADDR(x))
#define HW_MIPI_DSI_ERROR_ST1_RD(x) (HW_MIPI_DSI_ERROR_ST1(x).U)
#define HW_MIPI_DSI_ERROR_ST1_WR(x, v) (HW_MIPI_DSI_ERROR_ST1(x).U = (v))
#define HW_MIPI_DSI_ERROR_ST1_SET(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, HW_MIPI_DSI_ERROR_ST1_RD(x) |  (v)))
#define HW_MIPI_DSI_ERROR_ST1_CLR(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, HW_MIPI_DSI_ERROR_ST1_RD(x) & ~(v)))
#define HW_MIPI_DSI_ERROR_ST1_TOG(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, HW_MIPI_DSI_ERROR_ST1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_ERROR_ST1 bitfields
 */

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field to_hs_tx[0] (RW)
 *
 * High Speed Transmission Time Out Counter reached the end and Contention
 * Detection as been detected
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_to_hs_tx (0U) /*!< Bit position for MIPI_DSI_ERROR_ST1_to_hs_tx. */
#define BM_MIPI_DSI_ERROR_ST1_to_hs_tx (0x00000001U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_to_hs_tx. */
#define BS_MIPI_DSI_ERROR_ST1_to_hs_tx (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_to_hs_tx. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_to_hs_tx field. */
#define BR_MIPI_DSI_ERROR_ST1_to_hs_tx(x) (HW_MIPI_DSI_ERROR_ST1(x).B.to_hs_tx)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_to_hs_tx. */
#define BF_MIPI_DSI_ERROR_ST1_to_hs_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_to_hs_tx) & BM_MIPI_DSI_ERROR_ST1_to_hs_tx)

/*! @brief Set the to_hs_tx field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_to_hs_tx(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_to_hs_tx) | BF_MIPI_DSI_ERROR_ST1_to_hs_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field to_lp_rx[1] (RW)
 *
 * Low Power Reception Time Out Counter reached the end and Contention Detection
 * as been detected
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_to_lp_rx (1U) /*!< Bit position for MIPI_DSI_ERROR_ST1_to_lp_rx. */
#define BM_MIPI_DSI_ERROR_ST1_to_lp_rx (0x00000002U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_to_lp_rx. */
#define BS_MIPI_DSI_ERROR_ST1_to_lp_rx (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_to_lp_rx. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_to_lp_rx field. */
#define BR_MIPI_DSI_ERROR_ST1_to_lp_rx(x) (HW_MIPI_DSI_ERROR_ST1(x).B.to_lp_rx)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_to_lp_rx. */
#define BF_MIPI_DSI_ERROR_ST1_to_lp_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_to_lp_rx) & BM_MIPI_DSI_ERROR_ST1_to_lp_rx)

/*! @brief Set the to_lp_rx field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_to_lp_rx(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_to_lp_rx) | BF_MIPI_DSI_ERROR_ST1_to_lp_rx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field ecc_sinlge_err[2] (RW)
 *
 * ECC single error was detected and corrected in a received packet
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_ecc_sinlge_err (2U) /*!< Bit position for MIPI_DSI_ERROR_ST1_ecc_sinlge_err. */
#define BM_MIPI_DSI_ERROR_ST1_ecc_sinlge_err (0x00000004U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_ecc_sinlge_err. */
#define BS_MIPI_DSI_ERROR_ST1_ecc_sinlge_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_ecc_sinlge_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_ecc_sinlge_err field. */
#define BR_MIPI_DSI_ERROR_ST1_ecc_sinlge_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.ecc_sinlge_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_ecc_sinlge_err. */
#define BF_MIPI_DSI_ERROR_ST1_ecc_sinlge_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_ecc_sinlge_err) & BM_MIPI_DSI_ERROR_ST1_ecc_sinlge_err)

/*! @brief Set the ecc_sinlge_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_ecc_sinlge_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_ecc_sinlge_err) | BF_MIPI_DSI_ERROR_ST1_ecc_sinlge_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field ecc_multi_err[3] (RW)
 *
 * ECC multiple error was detected in a received packet
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_ecc_multi_err (3U) /*!< Bit position for MIPI_DSI_ERROR_ST1_ecc_multi_err. */
#define BM_MIPI_DSI_ERROR_ST1_ecc_multi_err (0x00000008U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_ecc_multi_err. */
#define BS_MIPI_DSI_ERROR_ST1_ecc_multi_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_ecc_multi_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_ecc_multi_err field. */
#define BR_MIPI_DSI_ERROR_ST1_ecc_multi_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.ecc_multi_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_ecc_multi_err. */
#define BF_MIPI_DSI_ERROR_ST1_ecc_multi_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_ecc_multi_err) & BM_MIPI_DSI_ERROR_ST1_ecc_multi_err)

/*! @brief Set the ecc_multi_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_ecc_multi_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_ecc_multi_err) | BF_MIPI_DSI_ERROR_ST1_ecc_multi_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field crc_err[4] (RW)
 *
 * CRC error was detected in the received packet payload
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_crc_err (4U) /*!< Bit position for MIPI_DSI_ERROR_ST1_crc_err. */
#define BM_MIPI_DSI_ERROR_ST1_crc_err (0x00000010U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_crc_err. */
#define BS_MIPI_DSI_ERROR_ST1_crc_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_crc_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_crc_err field. */
#define BR_MIPI_DSI_ERROR_ST1_crc_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.crc_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_crc_err. */
#define BF_MIPI_DSI_ERROR_ST1_crc_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_crc_err) & BM_MIPI_DSI_ERROR_ST1_crc_err)

/*! @brief Set the crc_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_crc_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_crc_err) | BF_MIPI_DSI_ERROR_ST1_crc_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field pkt_size_err[5] (RW)
 *
 * Packet size error was detected during packet reception
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_pkt_size_err (5U) /*!< Bit position for MIPI_DSI_ERROR_ST1_pkt_size_err. */
#define BM_MIPI_DSI_ERROR_ST1_pkt_size_err (0x00000020U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_pkt_size_err. */
#define BS_MIPI_DSI_ERROR_ST1_pkt_size_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_pkt_size_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_pkt_size_err field. */
#define BR_MIPI_DSI_ERROR_ST1_pkt_size_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.pkt_size_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_pkt_size_err. */
#define BF_MIPI_DSI_ERROR_ST1_pkt_size_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_pkt_size_err) & BM_MIPI_DSI_ERROR_ST1_pkt_size_err)

/*! @brief Set the pkt_size_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_pkt_size_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_pkt_size_err) | BF_MIPI_DSI_ERROR_ST1_pkt_size_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field eopt_err[6] (RW)
 *
 * EOTp Packet not received at the end of the incoming peripheral transmission
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_eopt_err (6U) /*!< Bit position for MIPI_DSI_ERROR_ST1_eopt_err. */
#define BM_MIPI_DSI_ERROR_ST1_eopt_err (0x00000040U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_eopt_err. */
#define BS_MIPI_DSI_ERROR_ST1_eopt_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_eopt_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_eopt_err field. */
#define BR_MIPI_DSI_ERROR_ST1_eopt_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.eopt_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_eopt_err. */
#define BF_MIPI_DSI_ERROR_ST1_eopt_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_eopt_err) & BM_MIPI_DSI_ERROR_ST1_eopt_err)

/*! @brief Set the eopt_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_eopt_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_eopt_err) | BF_MIPI_DSI_ERROR_ST1_eopt_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dpi_pld_wr_err[7] (RW)
 *
 * During a DPI pixel line storage the payload FIFO went full and data stored is
 * corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err (7U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dpi_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err (0x00000080U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dpi_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dpi_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dpi_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dpi_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dpi_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err) & BM_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err)

/*! @brief Set the dpi_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err) | BF_MIPI_DSI_ERROR_ST1_dpi_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field gen_cmd_wr_err[8] (RW)
 *
 * System tried to write a command through the generic interface and FIFO was
 * full, therefore the command was not written
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err (8U) /*!< Bit position for MIPI_DSI_ERROR_ST1_gen_cmd_wr_err. */
#define BM_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err (0x00000100U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_gen_cmd_wr_err. */
#define BS_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_gen_cmd_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_gen_cmd_wr_err field. */
#define BR_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.gen_cmd_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_gen_cmd_wr_err. */
#define BF_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err) & BM_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err)

/*! @brief Set the gen_cmd_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err) | BF_MIPI_DSI_ERROR_ST1_gen_cmd_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field gen_pld_wr_err[9] (RW)
 *
 * System tried to write a payload data through the generic interface and FIFO
 * was full, therefore the payload was not written
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_gen_pld_wr_err (9U) /*!< Bit position for MIPI_DSI_ERROR_ST1_gen_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_ST1_gen_pld_wr_err (0x00000200U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_gen_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_ST1_gen_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_gen_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_gen_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_ST1_gen_pld_wr_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.gen_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_gen_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_ST1_gen_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_gen_pld_wr_err) & BM_MIPI_DSI_ERROR_ST1_gen_pld_wr_err)

/*! @brief Set the gen_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_gen_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_gen_pld_wr_err) | BF_MIPI_DSI_ERROR_ST1_gen_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field gen_pld_send_err[10] (RW)
 *
 * During a generic interface packet build, the payload FIFO went empty and data
 * was sent corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_gen_pld_send_err (10U) /*!< Bit position for MIPI_DSI_ERROR_ST1_gen_pld_send_err. */
#define BM_MIPI_DSI_ERROR_ST1_gen_pld_send_err (0x00000400U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_gen_pld_send_err. */
#define BS_MIPI_DSI_ERROR_ST1_gen_pld_send_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_gen_pld_send_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_gen_pld_send_err field. */
#define BR_MIPI_DSI_ERROR_ST1_gen_pld_send_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.gen_pld_send_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_gen_pld_send_err. */
#define BF_MIPI_DSI_ERROR_ST1_gen_pld_send_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_gen_pld_send_err) & BM_MIPI_DSI_ERROR_ST1_gen_pld_send_err)

/*! @brief Set the gen_pld_send_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_gen_pld_send_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_gen_pld_send_err) | BF_MIPI_DSI_ERROR_ST1_gen_pld_send_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field gen_pld_rd_err[11] (RW)
 *
 * During a DCS read data, the payload FIFO went empty and data was send to the
 * interface corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_gen_pld_rd_err (11U) /*!< Bit position for MIPI_DSI_ERROR_ST1_gen_pld_rd_err. */
#define BM_MIPI_DSI_ERROR_ST1_gen_pld_rd_err (0x00000800U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_gen_pld_rd_err. */
#define BS_MIPI_DSI_ERROR_ST1_gen_pld_rd_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_gen_pld_rd_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_gen_pld_rd_err field. */
#define BR_MIPI_DSI_ERROR_ST1_gen_pld_rd_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.gen_pld_rd_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_gen_pld_rd_err. */
#define BF_MIPI_DSI_ERROR_ST1_gen_pld_rd_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_gen_pld_rd_err) & BM_MIPI_DSI_ERROR_ST1_gen_pld_rd_err)

/*! @brief Set the gen_pld_rd_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_gen_pld_rd_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_gen_pld_rd_err) | BF_MIPI_DSI_ERROR_ST1_gen_pld_rd_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field gen_pld_recv_err[12] (RW)
 *
 * During a generic interface packet read back, the payload FIFO went full and
 * received data was corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_gen_pld_recv_err (12U) /*!< Bit position for MIPI_DSI_ERROR_ST1_gen_pld_recv_err. */
#define BM_MIPI_DSI_ERROR_ST1_gen_pld_recv_err (0x00001000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_gen_pld_recv_err. */
#define BS_MIPI_DSI_ERROR_ST1_gen_pld_recv_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_gen_pld_recv_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_gen_pld_recv_err field. */
#define BR_MIPI_DSI_ERROR_ST1_gen_pld_recv_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.gen_pld_recv_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_gen_pld_recv_err. */
#define BF_MIPI_DSI_ERROR_ST1_gen_pld_recv_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_gen_pld_recv_err) & BM_MIPI_DSI_ERROR_ST1_gen_pld_recv_err)

/*! @brief Set the gen_pld_recv_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_gen_pld_recv_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_gen_pld_recv_err) | BF_MIPI_DSI_ERROR_ST1_gen_pld_recv_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dbi_cmd_wr_err[13] (RW)
 *
 * System tried to write a command through the DBI but the command FIFO was
 * full, therefore the command was not written
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err (13U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err. */
#define BM_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err (0x00002000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err. */
#define BS_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dbi_cmd_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err. */
#define BF_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err) & BM_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err)

/*! @brief Set the dbi_cmd_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err) | BF_MIPI_DSI_ERROR_ST1_dbi_cmd_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dbi_pld_wr_err[14] (RW)
 *
 * System tried to write payload data through the DBI interface and the FIFO was
 * full, therefore the Command was not written
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err (14U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dbi_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err (0x00004000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dbi_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dbi_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dbi_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dbi_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dbi_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err) & BM_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err)

/*! @brief Set the dbi_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err) | BF_MIPI_DSI_ERROR_ST1_dbi_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dbi_pld_rd_err[15] (RW)
 *
 * During a DCS read data, the payload FIFO went empty and data was send to the
 * interface corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err (15U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dbi_pld_rd_err. */
#define BM_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err (0x00008000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dbi_pld_rd_err. */
#define BS_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dbi_pld_rd_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dbi_pld_rd_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dbi_pld_rd_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dbi_pld_rd_err. */
#define BF_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err) & BM_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err)

/*! @brief Set the dbi_pld_rd_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err) | BF_MIPI_DSI_ERROR_ST1_dbi_pld_rd_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dbi_pld_recv_err[16] (RW)
 *
 * During a DBI read back packet, the payload FIFO went full and received data
 * was corrupted
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err (16U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dbi_pld_recv_err. */
#define BM_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err (0x00010000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dbi_pld_recv_err. */
#define BS_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dbi_pld_recv_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dbi_pld_recv_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dbi_pld_recv_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dbi_pld_recv_err. */
#define BF_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err) & BM_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err)

/*! @brief Set the dbi_pld_recv_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err) | BF_MIPI_DSI_ERROR_ST1_dbi_pld_recv_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_ST1, field dbi_illegal_comm_err[17] (RW)
 *
 * Attempt to write an illegal command on the DPI interface and core blocked by
 * transmission
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err (17U) /*!< Bit position for MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err. */
#define BM_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err (0x00020000U) /*!< Bit mask for MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err. */
#define BS_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err field. */
#define BR_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err(x) (HW_MIPI_DSI_ERROR_ST1(x).B.dbi_illegal_comm_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err. */
#define BF_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err) & BM_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err)

/*! @brief Set the dbi_illegal_comm_err field to a new value. */
#define BW_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err(x, v) (HW_MIPI_DSI_ERROR_ST1_WR(x, (HW_MIPI_DSI_ERROR_ST1_RD(x) & ~BM_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err) | BF_MIPI_DSI_ERROR_ST1_dbi_illegal_comm_err(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_ERROR_MSK0 - Masks Interrupt generation trigged by ERROR_ST0 register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_ERROR_MSK0 - Masks Interrupt generation trigged by ERROR_ST0 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x4c Memory Access: R/W
 */
typedef union _hw_mipi_dsi_error_msk0
{
    uint32_t U;
    struct _hw_mipi_dsi_error_msk0_bitfields
    {
        uint32_t ack_with_err_0 : 1;   /*!< [0]  */
        uint32_t ack_with_err_1 : 1;   /*!< [1]  */
        uint32_t ack_with_err_2 : 1;   /*!< [2]  */
        uint32_t ack_with_err_3 : 1;   /*!< [3]  */
        uint32_t ack_with_err_4 : 1;   /*!< [4]  */
        uint32_t ack_with_err_5 : 1;   /*!< [5]  */
        uint32_t ack_with_err_6 : 1;   /*!< [6]  */
        uint32_t ack_with_err_7 : 1;   /*!< [7]  */
        uint32_t ack_with_err_8 : 1;   /*!< [8]  */
        uint32_t ack_with_err_9 : 1;   /*!< [9]  */
        uint32_t ack_with_err_10 : 1;  /*!< [10]  */
        uint32_t ack_with_err_11 : 1;  /*!< [11]  */
        uint32_t ack_with_err_12 : 1;  /*!< [12]  */
        uint32_t ack_with_err_13 : 1;  /*!< [13]  */
        uint32_t ack_with_err_14 : 1;  /*!< [14]  */
        uint32_t ack_with_err_15 : 1;  /*!< [15]  */
        uint32_t dphy_errors_0 : 1;    /*!< [16]  */
        uint32_t dphy_errors_1 : 1;    /*!< [17]  */
        uint32_t dphy_errors_2 : 1;    /*!< [18]  */
        uint32_t dphy_errors_3 : 1;    /*!< [19]  */
        uint32_t dphy_errors_4 : 1;    /*!< [20]  */
        uint32_t RESERVED0 : 11;       /*!< [31:21]  */
    } B;
} hw_mipi_dsi_error_msk0_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_ERROR_MSK0 register
 */
/*@{*/
#define HW_MIPI_DSI_ERROR_MSK0_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_MIPI_DSI_ERROR_MSK0(x) (*(__IO hw_mipi_dsi_error_msk0_t *) HW_MIPI_DSI_ERROR_MSK0_ADDR(x))
#define HW_MIPI_DSI_ERROR_MSK0_RD(x) (HW_MIPI_DSI_ERROR_MSK0(x).U)
#define HW_MIPI_DSI_ERROR_MSK0_WR(x, v) (HW_MIPI_DSI_ERROR_MSK0(x).U = (v))
#define HW_MIPI_DSI_ERROR_MSK0_SET(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, HW_MIPI_DSI_ERROR_MSK0_RD(x) |  (v)))
#define HW_MIPI_DSI_ERROR_MSK0_CLR(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~(v)))
#define HW_MIPI_DSI_ERROR_MSK0_TOG(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, HW_MIPI_DSI_ERROR_MSK0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_ERROR_MSK0 bitfields
 */

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_0[0] (RW)
 *
 * Masks SoT Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_0 (0U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_0. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_0 (0x00000001U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_0. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_0 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_0. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_0 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_0(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_0)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_0. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_0) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_0)

/*! @brief Set the ack_with_err_0 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_0(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_0) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_0(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_1[1] (RW)
 *
 * Masks SoT Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_1 (1U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_1. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_1 (0x00000002U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_1. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_1 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_1. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_1 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_1(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_1)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_1. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_1) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_1)

/*! @brief Set the ack_with_err_1 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_1(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_1) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_1(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_2[2] (RW)
 *
 * Masks EoT Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_2 (2U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_2. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_2 (0x00000004U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_2. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_2 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_2. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_2 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_2(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_2)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_2. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_2) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_2)

/*! @brief Set the ack_with_err_2 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_2(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_2) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_2(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_3[3] (RW)
 *
 * Masks Escape Mode Entry Command Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_3 (3U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_3. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_3 (0x00000008U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_3. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_3 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_3. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_3 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_3(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_3)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_3. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_3) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_3)

/*! @brief Set the ack_with_err_3 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_3(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_3) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_3(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_4[4] (RW)
 *
 * Masks Low-Power Transmit Sync Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_4 (4U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_4. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_4 (0x00000010U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_4. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_4 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_4. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_4 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_4(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_4)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_4. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_4) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_4)

/*! @brief Set the ack_with_err_4 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_4(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_4) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_4(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_5[5] (RW)
 *
 * Masks HS Receive Timeout Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_5 (5U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_5. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_5 (0x00000020U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_5. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_5 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_5. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_5 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_5(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_5)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_5. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_5) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_5)

/*! @brief Set the ack_with_err_5 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_5(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_5) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_5(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_6[6] (RW)
 *
 * Masks False Control Error from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_6 (6U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_6. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_6 (0x00000040U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_6. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_6 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_6. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_6 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_6(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_6)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_6. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_6) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_6)

/*! @brief Set the ack_with_err_6 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_6(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_6) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_6(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_7[7] (RW)
 *
 * Masks Reserved (specific to device) from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_7 (7U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_7. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_7 (0x00000080U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_7. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_7 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_7. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_7 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_7(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_7)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_7. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_7) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_7)

/*! @brief Set the ack_with_err_7 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_7(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_7) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_7(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_8[8] (RW)
 *
 * Masks ECC Error, single-bit (detected and corrected) from Display Acknowledge
 * Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_8 (8U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_8. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_8 (0x00000100U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_8. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_8 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_8. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_8 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_8(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_8)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_8. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_8) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_8)

/*! @brief Set the ack_with_err_8 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_8(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_8) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_8(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_9[9] (RW)
 *
 * Masks ECC Error, multi-bit (detected, not corrected) from Display Acknowledge
 * Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_9 (9U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_9. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_9 (0x00000200U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_9. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_9 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_9. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_9 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_9(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_9)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_9. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_9) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_9)

/*! @brief Set the ack_with_err_9 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_9(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_9) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_9(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_10[10] (RW)
 *
 * Masks Checksum Error (Long packet only) from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_10 (10U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_10. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_10 (0x00000400U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_10. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_10 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_10. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_10 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_10(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_10)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_10. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_10) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_10)

/*! @brief Set the ack_with_err_10 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_10(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_10) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_10(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_11[11] (RW)
 *
 * Masks DSI Data Type Not Recognized from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_11 (11U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_11. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_11 (0x00000800U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_11. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_11 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_11. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_11 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_11(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_11)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_11. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_11) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_11)

/*! @brief Set the ack_with_err_11 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_11(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_11) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_11(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_12[12] (RW)
 *
 * Masks DSI VC ID Invalid from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_12 (12U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_12. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_12 (0x00001000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_12. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_12 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_12. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_12 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_12(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_12)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_12. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_12) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_12)

/*! @brief Set the ack_with_err_12 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_12(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_12) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_12(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_13[13] (RW)
 *
 * Masks Invalid Transmission Length from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_13 (13U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_13. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_13 (0x00002000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_13. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_13 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_13. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_13 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_13(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_13)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_13. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_13) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_13)

/*! @brief Set the ack_with_err_13 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_13(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_13) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_13(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_14[14] (RW)
 *
 * Masks Reserved (specific to device) from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_14 (14U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_14. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_14 (0x00004000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_14. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_14 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_14. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_14 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_14(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_14)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_14. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_14) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_14)

/*! @brief Set the ack_with_err_14 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_14(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_14) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_14(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field ack_with_err_15[15] (RW)
 *
 * Masks DSI Protocol Violation from Display Acknowledge Error Report
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_ack_with_err_15 (15U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_ack_with_err_15. */
#define BM_MIPI_DSI_ERROR_MSK0_ack_with_err_15 (0x00008000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_ack_with_err_15. */
#define BS_MIPI_DSI_ERROR_MSK0_ack_with_err_15 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_ack_with_err_15. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_ack_with_err_15 field. */
#define BR_MIPI_DSI_ERROR_MSK0_ack_with_err_15(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.ack_with_err_15)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_ack_with_err_15. */
#define BF_MIPI_DSI_ERROR_MSK0_ack_with_err_15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_ack_with_err_15) & BM_MIPI_DSI_ERROR_MSK0_ack_with_err_15)

/*! @brief Set the ack_with_err_15 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_ack_with_err_15(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_ack_with_err_15) | BF_MIPI_DSI_ERROR_MSK0_ack_with_err_15(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field dphy_errors_0[16] (RW)
 *
 * ErrEsc Escape Entry Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_dphy_errors_0 (16U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_dphy_errors_0. */
#define BM_MIPI_DSI_ERROR_MSK0_dphy_errors_0 (0x00010000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_dphy_errors_0. */
#define BS_MIPI_DSI_ERROR_MSK0_dphy_errors_0 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_dphy_errors_0. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_dphy_errors_0 field. */
#define BR_MIPI_DSI_ERROR_MSK0_dphy_errors_0(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.dphy_errors_0)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_dphy_errors_0. */
#define BF_MIPI_DSI_ERROR_MSK0_dphy_errors_0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_dphy_errors_0) & BM_MIPI_DSI_ERROR_MSK0_dphy_errors_0)

/*! @brief Set the dphy_errors_0 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_dphy_errors_0(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_dphy_errors_0) | BF_MIPI_DSI_ERROR_MSK0_dphy_errors_0(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field dphy_errors_1[17] (RW)
 *
 * ErrSyncEsc Low-Power Data Transmission Synchronization Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_dphy_errors_1 (17U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_dphy_errors_1. */
#define BM_MIPI_DSI_ERROR_MSK0_dphy_errors_1 (0x00020000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_dphy_errors_1. */
#define BS_MIPI_DSI_ERROR_MSK0_dphy_errors_1 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_dphy_errors_1. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_dphy_errors_1 field. */
#define BR_MIPI_DSI_ERROR_MSK0_dphy_errors_1(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.dphy_errors_1)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_dphy_errors_1. */
#define BF_MIPI_DSI_ERROR_MSK0_dphy_errors_1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_dphy_errors_1) & BM_MIPI_DSI_ERROR_MSK0_dphy_errors_1)

/*! @brief Set the dphy_errors_1 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_dphy_errors_1(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_dphy_errors_1) | BF_MIPI_DSI_ERROR_MSK0_dphy_errors_1(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field dphy_errors_2[18] (RW)
 *
 * ErrControl Control Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_dphy_errors_2 (18U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_dphy_errors_2. */
#define BM_MIPI_DSI_ERROR_MSK0_dphy_errors_2 (0x00040000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_dphy_errors_2. */
#define BS_MIPI_DSI_ERROR_MSK0_dphy_errors_2 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_dphy_errors_2. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_dphy_errors_2 field. */
#define BR_MIPI_DSI_ERROR_MSK0_dphy_errors_2(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.dphy_errors_2)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_dphy_errors_2. */
#define BF_MIPI_DSI_ERROR_MSK0_dphy_errors_2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_dphy_errors_2) & BM_MIPI_DSI_ERROR_MSK0_dphy_errors_2)

/*! @brief Set the dphy_errors_2 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_dphy_errors_2(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_dphy_errors_2) | BF_MIPI_DSI_ERROR_MSK0_dphy_errors_2(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field dphy_errors_3[19] (RW)
 *
 * ErrContentionLP0 LP0 Contention Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_dphy_errors_3 (19U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_dphy_errors_3. */
#define BM_MIPI_DSI_ERROR_MSK0_dphy_errors_3 (0x00080000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_dphy_errors_3. */
#define BS_MIPI_DSI_ERROR_MSK0_dphy_errors_3 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_dphy_errors_3. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_dphy_errors_3 field. */
#define BR_MIPI_DSI_ERROR_MSK0_dphy_errors_3(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.dphy_errors_3)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_dphy_errors_3. */
#define BF_MIPI_DSI_ERROR_MSK0_dphy_errors_3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_dphy_errors_3) & BM_MIPI_DSI_ERROR_MSK0_dphy_errors_3)

/*! @brief Set the dphy_errors_3 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_dphy_errors_3(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_dphy_errors_3) | BF_MIPI_DSI_ERROR_MSK0_dphy_errors_3(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK0, field dphy_errors_4[20] (RW)
 *
 * ErrContentionLP1 LP1 Contention Error from Lane 0
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK0_dphy_errors_4 (20U) /*!< Bit position for MIPI_DSI_ERROR_MSK0_dphy_errors_4. */
#define BM_MIPI_DSI_ERROR_MSK0_dphy_errors_4 (0x00100000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK0_dphy_errors_4. */
#define BS_MIPI_DSI_ERROR_MSK0_dphy_errors_4 (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK0_dphy_errors_4. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK0_dphy_errors_4 field. */
#define BR_MIPI_DSI_ERROR_MSK0_dphy_errors_4(x) (HW_MIPI_DSI_ERROR_MSK0(x).B.dphy_errors_4)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK0_dphy_errors_4. */
#define BF_MIPI_DSI_ERROR_MSK0_dphy_errors_4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK0_dphy_errors_4) & BM_MIPI_DSI_ERROR_MSK0_dphy_errors_4)

/*! @brief Set the dphy_errors_4 field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK0_dphy_errors_4(x, v) (HW_MIPI_DSI_ERROR_MSK0_WR(x, (HW_MIPI_DSI_ERROR_MSK0_RD(x) & ~BM_MIPI_DSI_ERROR_MSK0_dphy_errors_4) | BF_MIPI_DSI_ERROR_MSK0_dphy_errors_4(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_ERROR_MSK1 - Masks Interrupt generation trigged by ERROR_ST1 register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_ERROR_MSK1 - Masks Interrupt generation trigged by ERROR_ST1 register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x50 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_error_msk1
{
    uint32_t U;
    struct _hw_mipi_dsi_error_msk1_bitfields
    {
        uint32_t to_hs_tx : 1;         /*!< [0]  */
        uint32_t to_lp_rx : 1;         /*!< [1]  */
        uint32_t ecc_sinlge_err : 1;   /*!< [2]  */
        uint32_t ecc_multi_err : 1;    /*!< [3]  */
        uint32_t crc_err : 1;          /*!< [4]  */
        uint32_t pkt_size_err : 1;     /*!< [5]  */
        uint32_t eopt_err : 1;         /*!< [6]  */
        uint32_t dpi_pld_wr_err : 1;   /*!< [7]  */
        uint32_t gen_cmd_wr_err : 1;   /*!< [8]  */
        uint32_t gen_pld_wr_err : 1;   /*!< [9]  */
        uint32_t gen_pld_send_err : 1; /*!< [10]  */
        uint32_t gen_pld_rd_err : 1;   /*!< [11]  */
        uint32_t gen_pld_recv_err : 1; /*!< [12]  */
        uint32_t dbi_cmd_wr_err : 1;   /*!< [13]  */
        uint32_t dbi_pld_wr_err : 1;   /*!< [14]  */
        uint32_t dbi_pld_rd_err : 1;   /*!< [15]  */
        uint32_t dbi_pld_recv_err : 1; /*!< [16]  */
        uint32_t dbi_illegal_comm_err : 1; /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_mipi_dsi_error_msk1_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_ERROR_MSK1 register
 */
/*@{*/
#define HW_MIPI_DSI_ERROR_MSK1_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_MIPI_DSI_ERROR_MSK1(x) (*(__IO hw_mipi_dsi_error_msk1_t *) HW_MIPI_DSI_ERROR_MSK1_ADDR(x))
#define HW_MIPI_DSI_ERROR_MSK1_RD(x) (HW_MIPI_DSI_ERROR_MSK1(x).U)
#define HW_MIPI_DSI_ERROR_MSK1_WR(x, v) (HW_MIPI_DSI_ERROR_MSK1(x).U = (v))
#define HW_MIPI_DSI_ERROR_MSK1_SET(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, HW_MIPI_DSI_ERROR_MSK1_RD(x) |  (v)))
#define HW_MIPI_DSI_ERROR_MSK1_CLR(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~(v)))
#define HW_MIPI_DSI_ERROR_MSK1_TOG(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, HW_MIPI_DSI_ERROR_MSK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_ERROR_MSK1 bitfields
 */

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field to_hs_tx[0] (RW)
 *
 * Masks High Speed Transmission Time Out Counter error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_to_hs_tx (0U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_to_hs_tx. */
#define BM_MIPI_DSI_ERROR_MSK1_to_hs_tx (0x00000001U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_to_hs_tx. */
#define BS_MIPI_DSI_ERROR_MSK1_to_hs_tx (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_to_hs_tx. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_to_hs_tx field. */
#define BR_MIPI_DSI_ERROR_MSK1_to_hs_tx(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.to_hs_tx)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_to_hs_tx. */
#define BF_MIPI_DSI_ERROR_MSK1_to_hs_tx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_to_hs_tx) & BM_MIPI_DSI_ERROR_MSK1_to_hs_tx)

/*! @brief Set the to_hs_tx field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_to_hs_tx(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_to_hs_tx) | BF_MIPI_DSI_ERROR_MSK1_to_hs_tx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field to_lp_rx[1] (RW)
 *
 * Masks Low Power Reception Time Out Counter error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_to_lp_rx (1U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_to_lp_rx. */
#define BM_MIPI_DSI_ERROR_MSK1_to_lp_rx (0x00000002U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_to_lp_rx. */
#define BS_MIPI_DSI_ERROR_MSK1_to_lp_rx (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_to_lp_rx. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_to_lp_rx field. */
#define BR_MIPI_DSI_ERROR_MSK1_to_lp_rx(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.to_lp_rx)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_to_lp_rx. */
#define BF_MIPI_DSI_ERROR_MSK1_to_lp_rx(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_to_lp_rx) & BM_MIPI_DSI_ERROR_MSK1_to_lp_rx)

/*! @brief Set the to_lp_rx field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_to_lp_rx(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_to_lp_rx) | BF_MIPI_DSI_ERROR_MSK1_to_lp_rx(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field ecc_sinlge_err[2] (RW)
 *
 * Masks ECC single error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err (2U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_ecc_sinlge_err. */
#define BM_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err (0x00000004U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_ecc_sinlge_err. */
#define BS_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_ecc_sinlge_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_ecc_sinlge_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.ecc_sinlge_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_ecc_sinlge_err. */
#define BF_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err) & BM_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err)

/*! @brief Set the ecc_sinlge_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err) | BF_MIPI_DSI_ERROR_MSK1_ecc_sinlge_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field ecc_multi_err[3] (RW)
 *
 * Masks ECC multiple error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_ecc_multi_err (3U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_ecc_multi_err. */
#define BM_MIPI_DSI_ERROR_MSK1_ecc_multi_err (0x00000008U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_ecc_multi_err. */
#define BS_MIPI_DSI_ERROR_MSK1_ecc_multi_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_ecc_multi_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_ecc_multi_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_ecc_multi_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.ecc_multi_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_ecc_multi_err. */
#define BF_MIPI_DSI_ERROR_MSK1_ecc_multi_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_ecc_multi_err) & BM_MIPI_DSI_ERROR_MSK1_ecc_multi_err)

/*! @brief Set the ecc_multi_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_ecc_multi_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_ecc_multi_err) | BF_MIPI_DSI_ERROR_MSK1_ecc_multi_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field crc_err[4] (RW)
 *
 * Masks CRC error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_crc_err (4U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_crc_err. */
#define BM_MIPI_DSI_ERROR_MSK1_crc_err (0x00000010U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_crc_err. */
#define BS_MIPI_DSI_ERROR_MSK1_crc_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_crc_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_crc_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_crc_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.crc_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_crc_err. */
#define BF_MIPI_DSI_ERROR_MSK1_crc_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_crc_err) & BM_MIPI_DSI_ERROR_MSK1_crc_err)

/*! @brief Set the crc_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_crc_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_crc_err) | BF_MIPI_DSI_ERROR_MSK1_crc_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field pkt_size_err[5] (RW)
 *
 * Masks Packet size error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_pkt_size_err (5U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_pkt_size_err. */
#define BM_MIPI_DSI_ERROR_MSK1_pkt_size_err (0x00000020U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_pkt_size_err. */
#define BS_MIPI_DSI_ERROR_MSK1_pkt_size_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_pkt_size_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_pkt_size_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_pkt_size_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.pkt_size_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_pkt_size_err. */
#define BF_MIPI_DSI_ERROR_MSK1_pkt_size_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_pkt_size_err) & BM_MIPI_DSI_ERROR_MSK1_pkt_size_err)

/*! @brief Set the pkt_size_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_pkt_size_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_pkt_size_err) | BF_MIPI_DSI_ERROR_MSK1_pkt_size_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field eopt_err[6] (RW)
 *
 * Masks EOTp Packet not received error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_eopt_err (6U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_eopt_err. */
#define BM_MIPI_DSI_ERROR_MSK1_eopt_err (0x00000040U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_eopt_err. */
#define BS_MIPI_DSI_ERROR_MSK1_eopt_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_eopt_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_eopt_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_eopt_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.eopt_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_eopt_err. */
#define BF_MIPI_DSI_ERROR_MSK1_eopt_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_eopt_err) & BM_MIPI_DSI_ERROR_MSK1_eopt_err)

/*! @brief Set the eopt_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_eopt_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_eopt_err) | BF_MIPI_DSI_ERROR_MSK1_eopt_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dpi_pld_wr_err[7] (RW)
 *
 * Masks DPI pixel line payload FIFO full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err (7U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err (0x00000080U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dpi_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err) & BM_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err)

/*! @brief Set the dpi_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err) | BF_MIPI_DSI_ERROR_MSK1_dpi_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field gen_cmd_wr_err[8] (RW)
 *
 * Masks command FIFO of generic interface full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err (8U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err. */
#define BM_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err (0x00000100U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err. */
#define BS_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.gen_cmd_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err. */
#define BF_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err) & BM_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err)

/*! @brief Set the gen_cmd_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err) | BF_MIPI_DSI_ERROR_MSK1_gen_cmd_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field gen_pld_wr_err[9] (RW)
 *
 * Masks payload data FIFO of generic interface full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err (9U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_gen_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err (0x00000200U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_gen_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_gen_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_gen_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.gen_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_gen_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err) & BM_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err)

/*! @brief Set the gen_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err) | BF_MIPI_DSI_ERROR_MSK1_gen_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field gen_pld_send_err[10] (RW)
 *
 * Masks generic interface packet build FIFO empty error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_gen_pld_send_err (10U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_gen_pld_send_err. */
#define BM_MIPI_DSI_ERROR_MSK1_gen_pld_send_err (0x00000400U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_gen_pld_send_err. */
#define BS_MIPI_DSI_ERROR_MSK1_gen_pld_send_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_gen_pld_send_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_gen_pld_send_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_gen_pld_send_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.gen_pld_send_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_gen_pld_send_err. */
#define BF_MIPI_DSI_ERROR_MSK1_gen_pld_send_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_gen_pld_send_err) & BM_MIPI_DSI_ERROR_MSK1_gen_pld_send_err)

/*! @brief Set the gen_pld_send_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_gen_pld_send_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_gen_pld_send_err) | BF_MIPI_DSI_ERROR_MSK1_gen_pld_send_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field gen_pld_rd_err[11] (RW)
 *
 * Masks DCS read data payload FIFO empty error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err (11U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_gen_pld_rd_err. */
#define BM_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err (0x00000800U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_gen_pld_rd_err. */
#define BS_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_gen_pld_rd_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_gen_pld_rd_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.gen_pld_rd_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_gen_pld_rd_err. */
#define BF_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err) & BM_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err)

/*! @brief Set the gen_pld_rd_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err) | BF_MIPI_DSI_ERROR_MSK1_gen_pld_rd_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field gen_pld_recv_err[12] (RW)
 *
 * Masks generic interface packet read back FIFO full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err (12U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_gen_pld_recv_err. */
#define BM_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err (0x00001000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_gen_pld_recv_err. */
#define BS_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_gen_pld_recv_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_gen_pld_recv_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.gen_pld_recv_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_gen_pld_recv_err. */
#define BF_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err) & BM_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err)

/*! @brief Set the gen_pld_recv_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err) | BF_MIPI_DSI_ERROR_MSK1_gen_pld_recv_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dbi_cmd_wr_err[13] (RW)
 *
 * Masks DBI command FIFO full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err (13U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err (0x00002000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dbi_cmd_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err) & BM_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err)

/*! @brief Set the dbi_cmd_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err) | BF_MIPI_DSI_ERROR_MSK1_dbi_cmd_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dbi_pld_wr_err[14] (RW)
 *
 * Masks write payload data DBI FIFO full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err (14U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err (0x00004000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dbi_pld_wr_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err) & BM_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err)

/*! @brief Set the dbi_pld_wr_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err) | BF_MIPI_DSI_ERROR_MSK1_dbi_pld_wr_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dbi_pld_rd_err[15] (RW)
 *
 * Masks payload DBI FIFO empty error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err (15U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err (0x00008000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dbi_pld_rd_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err) & BM_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err)

/*! @brief Set the dbi_pld_rd_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err) | BF_MIPI_DSI_ERROR_MSK1_dbi_pld_rd_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dbi_pld_recv_err[16] (RW)
 *
 * Masks DBI read back packet payload FIFO full error
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err (16U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err (0x00010000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dbi_pld_recv_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err) & BM_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err)

/*! @brief Set the dbi_pld_recv_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err) | BF_MIPI_DSI_ERROR_MSK1_dbi_pld_recv_err(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_ERROR_MSK1, field dbi_illegal_comm_err[17] (RW)
 *
 * Masks error attempt to write an illegal command on DPI
 */
/*@{*/
#define BP_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err (17U) /*!< Bit position for MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err. */
#define BM_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err (0x00020000U) /*!< Bit mask for MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err. */
#define BS_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err (1U) /*!< Bit field size in bits for MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err. */

/*! @brief Read current value of the MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err field. */
#define BR_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err(x) (HW_MIPI_DSI_ERROR_MSK1(x).B.dbi_illegal_comm_err)

/*! @brief Format value for bitfield MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err. */
#define BF_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err) & BM_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err)

/*! @brief Set the dbi_illegal_comm_err field to a new value. */
#define BW_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err(x, v) (HW_MIPI_DSI_ERROR_MSK1_WR(x, (HW_MIPI_DSI_ERROR_MSK1_RD(x) & ~BM_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err) | BF_MIPI_DSI_ERROR_MSK1_dbi_illegal_comm_err(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_RSTZ - D-PHY reset control
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_RSTZ - D-PHY reset control (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x54 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_rstz
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_rstz_bitfields
    {
        uint32_t phy_shutdownz : 1;    /*!< [0]  */
        uint32_t phy_rstz : 1;         /*!< [1]  */
        uint32_t phy_enableclk : 1;    /*!< [2]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_mipi_dsi_phy_rstz_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_RSTZ register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_RSTZ_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_MIPI_DSI_PHY_RSTZ(x)  (*(__IO hw_mipi_dsi_phy_rstz_t *) HW_MIPI_DSI_PHY_RSTZ_ADDR(x))
#define HW_MIPI_DSI_PHY_RSTZ_RD(x) (HW_MIPI_DSI_PHY_RSTZ(x).U)
#define HW_MIPI_DSI_PHY_RSTZ_WR(x, v) (HW_MIPI_DSI_PHY_RSTZ(x).U = (v))
#define HW_MIPI_DSI_PHY_RSTZ_SET(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, HW_MIPI_DSI_PHY_RSTZ_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_RSTZ_CLR(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, HW_MIPI_DSI_PHY_RSTZ_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_RSTZ_TOG(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, HW_MIPI_DSI_PHY_RSTZ_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_RSTZ bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_RSTZ, field phy_shutdownz[0] (RW)
 *
 * D-PHY Shutdown disable when 1, used to place the complete D-PHY macro in
 * power down
 */
/*@{*/
#define BP_MIPI_DSI_PHY_RSTZ_phy_shutdownz (0U) /*!< Bit position for MIPI_DSI_PHY_RSTZ_phy_shutdownz. */
#define BM_MIPI_DSI_PHY_RSTZ_phy_shutdownz (0x00000001U) /*!< Bit mask for MIPI_DSI_PHY_RSTZ_phy_shutdownz. */
#define BS_MIPI_DSI_PHY_RSTZ_phy_shutdownz (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_RSTZ_phy_shutdownz. */

/*! @brief Read current value of the MIPI_DSI_PHY_RSTZ_phy_shutdownz field. */
#define BR_MIPI_DSI_PHY_RSTZ_phy_shutdownz(x) (HW_MIPI_DSI_PHY_RSTZ(x).B.phy_shutdownz)

/*! @brief Format value for bitfield MIPI_DSI_PHY_RSTZ_phy_shutdownz. */
#define BF_MIPI_DSI_PHY_RSTZ_phy_shutdownz(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_RSTZ_phy_shutdownz) & BM_MIPI_DSI_PHY_RSTZ_phy_shutdownz)

/*! @brief Set the phy_shutdownz field to a new value. */
#define BW_MIPI_DSI_PHY_RSTZ_phy_shutdownz(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, (HW_MIPI_DSI_PHY_RSTZ_RD(x) & ~BM_MIPI_DSI_PHY_RSTZ_phy_shutdownz) | BF_MIPI_DSI_PHY_RSTZ_phy_shutdownz(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_RSTZ, field phy_rstz[1] (RW)
 *
 * D-PHY Reset disable when 1, used to place the digital section of D-PHY in
 * reset state
 */
/*@{*/
#define BP_MIPI_DSI_PHY_RSTZ_phy_rstz (1U) /*!< Bit position for MIPI_DSI_PHY_RSTZ_phy_rstz. */
#define BM_MIPI_DSI_PHY_RSTZ_phy_rstz (0x00000002U) /*!< Bit mask for MIPI_DSI_PHY_RSTZ_phy_rstz. */
#define BS_MIPI_DSI_PHY_RSTZ_phy_rstz (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_RSTZ_phy_rstz. */

/*! @brief Read current value of the MIPI_DSI_PHY_RSTZ_phy_rstz field. */
#define BR_MIPI_DSI_PHY_RSTZ_phy_rstz(x) (HW_MIPI_DSI_PHY_RSTZ(x).B.phy_rstz)

/*! @brief Format value for bitfield MIPI_DSI_PHY_RSTZ_phy_rstz. */
#define BF_MIPI_DSI_PHY_RSTZ_phy_rstz(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_RSTZ_phy_rstz) & BM_MIPI_DSI_PHY_RSTZ_phy_rstz)

/*! @brief Set the phy_rstz field to a new value. */
#define BW_MIPI_DSI_PHY_RSTZ_phy_rstz(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, (HW_MIPI_DSI_PHY_RSTZ_RD(x) & ~BM_MIPI_DSI_PHY_RSTZ_phy_rstz) | BF_MIPI_DSI_PHY_RSTZ_phy_rstz(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_RSTZ, field phy_enableclk[2] (RW)
 *
 * Enables D-PHY Clock Lane Module when 1
 */
/*@{*/
#define BP_MIPI_DSI_PHY_RSTZ_phy_enableclk (2U) /*!< Bit position for MIPI_DSI_PHY_RSTZ_phy_enableclk. */
#define BM_MIPI_DSI_PHY_RSTZ_phy_enableclk (0x00000004U) /*!< Bit mask for MIPI_DSI_PHY_RSTZ_phy_enableclk. */
#define BS_MIPI_DSI_PHY_RSTZ_phy_enableclk (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_RSTZ_phy_enableclk. */

/*! @brief Read current value of the MIPI_DSI_PHY_RSTZ_phy_enableclk field. */
#define BR_MIPI_DSI_PHY_RSTZ_phy_enableclk(x) (HW_MIPI_DSI_PHY_RSTZ(x).B.phy_enableclk)

/*! @brief Format value for bitfield MIPI_DSI_PHY_RSTZ_phy_enableclk. */
#define BF_MIPI_DSI_PHY_RSTZ_phy_enableclk(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_RSTZ_phy_enableclk) & BM_MIPI_DSI_PHY_RSTZ_phy_enableclk)

/*! @brief Set the phy_enableclk field to a new value. */
#define BW_MIPI_DSI_PHY_RSTZ_phy_enableclk(x, v) (HW_MIPI_DSI_PHY_RSTZ_WR(x, (HW_MIPI_DSI_PHY_RSTZ_RD(x) & ~BM_MIPI_DSI_PHY_RSTZ_phy_enableclk) | BF_MIPI_DSI_PHY_RSTZ_phy_enableclk(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_IF_CFG_ - D-PHY interface configuration
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_IF_CFG_ - D-PHY interface configuration (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x58 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_if_cfg_
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_if_cfg__bitfields
    {
        uint32_t n_lanes : 2;          /*!< [1:0]  */
        uint32_t phy_stop_wait_time : 8; /*!< [9:2]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_mipi_dsi_phy_if_cfg__t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_IF_CFG_ register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_IF_CFG__ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_MIPI_DSI_PHY_IF_CFG_(x) (*(__IO hw_mipi_dsi_phy_if_cfg__t *) HW_MIPI_DSI_PHY_IF_CFG__ADDR(x))
#define HW_MIPI_DSI_PHY_IF_CFG__RD(x) (HW_MIPI_DSI_PHY_IF_CFG_(x).U)
#define HW_MIPI_DSI_PHY_IF_CFG__WR(x, v) (HW_MIPI_DSI_PHY_IF_CFG_(x).U = (v))
#define HW_MIPI_DSI_PHY_IF_CFG__SET(x, v) (HW_MIPI_DSI_PHY_IF_CFG__WR(x, HW_MIPI_DSI_PHY_IF_CFG__RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_IF_CFG__CLR(x, v) (HW_MIPI_DSI_PHY_IF_CFG__WR(x, HW_MIPI_DSI_PHY_IF_CFG__RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_IF_CFG__TOG(x, v) (HW_MIPI_DSI_PHY_IF_CFG__WR(x, HW_MIPI_DSI_PHY_IF_CFG__RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_IF_CFG_ bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_IF_CFG_, field n_lanes[1:0] (RW)
 *
 * Number of active data lanes.
 *
 * Values:
 * - 00 - 1 Data Lane (Lane 0)
 * - 01 - 2 Data Lanes (Lane 0, and Lane 1)
 * - 10 - Reserved
 * - 11 - Reserved
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CFG__n_lanes (0U) /*!< Bit position for MIPI_DSI_PHY_IF_CFG__n_lanes. */
#define BM_MIPI_DSI_PHY_IF_CFG__n_lanes (0x00000003U) /*!< Bit mask for MIPI_DSI_PHY_IF_CFG__n_lanes. */
#define BS_MIPI_DSI_PHY_IF_CFG__n_lanes (2U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CFG__n_lanes. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CFG__n_lanes field. */
#define BR_MIPI_DSI_PHY_IF_CFG__n_lanes(x) (HW_MIPI_DSI_PHY_IF_CFG_(x).B.n_lanes)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CFG__n_lanes. */
#define BF_MIPI_DSI_PHY_IF_CFG__n_lanes(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CFG__n_lanes) & BM_MIPI_DSI_PHY_IF_CFG__n_lanes)

/*! @brief Set the n_lanes field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CFG__n_lanes(x, v) (HW_MIPI_DSI_PHY_IF_CFG__WR(x, (HW_MIPI_DSI_PHY_IF_CFG__RD(x) & ~BM_MIPI_DSI_PHY_IF_CFG__n_lanes) | BF_MIPI_DSI_PHY_IF_CFG__n_lanes(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CFG_, field phy_stop_wait_time[9:2] (RW)
 *
 * Configures minimum wait period to request an HS transmission after the stop
 * state accounted in clock lane cycles
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time (2U) /*!< Bit position for MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time. */
#define BM_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time (0x000003FCU) /*!< Bit mask for MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time. */
#define BS_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time (8U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time field. */
#define BR_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time(x) (HW_MIPI_DSI_PHY_IF_CFG_(x).B.phy_stop_wait_time)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time. */
#define BF_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time) & BM_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time)

/*! @brief Set the phy_stop_wait_time field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time(x, v) (HW_MIPI_DSI_PHY_IF_CFG__WR(x, (HW_MIPI_DSI_PHY_IF_CFG__RD(x) & ~BM_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time) | BF_MIPI_DSI_PHY_IF_CFG__phy_stop_wait_time(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_IF_CTRL - D-PHY PPI interface control
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_IF_CTRL - D-PHY PPI interface control (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x5c Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_if_ctrl
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_if_ctrl_bitfields
    {
        uint32_t phy_txrequestclkhs : 1; /*!< [0]  */
        uint32_t phy_txrequlpsclk : 1; /*!< [1]  */
        uint32_t phy_txexitulpsclk : 1; /*!< [2]  */
        uint32_t phy_txrequlpslan : 1; /*!< [3]  */
        uint32_t phy_txexitulpslan : 1; /*!< [4]  */
        uint32_t phy_tx_triggers : 4;  /*!< [8:5]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_mipi_dsi_phy_if_ctrl_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_IF_CTRL register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_IF_CTRL_ADDR(x) ((uintptr_t)(x) + 0x5CU)

#define HW_MIPI_DSI_PHY_IF_CTRL(x) (*(__IO hw_mipi_dsi_phy_if_ctrl_t *) HW_MIPI_DSI_PHY_IF_CTRL_ADDR(x))
#define HW_MIPI_DSI_PHY_IF_CTRL_RD(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).U)
#define HW_MIPI_DSI_PHY_IF_CTRL_WR(x, v) (HW_MIPI_DSI_PHY_IF_CTRL(x).U = (v))
#define HW_MIPI_DSI_PHY_IF_CTRL_SET(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, HW_MIPI_DSI_PHY_IF_CTRL_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_IF_CTRL_CLR(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_IF_CTRL_TOG(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, HW_MIPI_DSI_PHY_IF_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_IF_CTRL bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_txrequestclkhs[0] (RW)
 *
 * Controls D-PHY PPI txrequestclkHS
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs (0U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs (0x00000001U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_txrequestclkhs)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs) & BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs)

/*! @brief Set the phy_txrequestclkhs field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs) | BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequestclkhs(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_txrequlpsclk[1] (RW)
 *
 * ULPS mode Request on Clock Lane
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk (1U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk (0x00000002U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_txrequlpsclk)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk) & BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk)

/*! @brief Set the phy_txrequlpsclk field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk) | BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpsclk(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_txexitulpsclk[2] (RW)
 *
 * ULPS mode Exit on Clock Lane
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk (2U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk (0x00000004U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_txexitulpsclk)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk) & BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk)

/*! @brief Set the phy_txexitulpsclk field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk) | BF_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpsclk(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_txrequlpslan[3] (RW)
 *
 * ULPS mode Request on all active data lanes
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan (3U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan (0x00000008U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_txrequlpslan)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan) & BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan)

/*! @brief Set the phy_txrequlpslan field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan) | BF_MIPI_DSI_PHY_IF_CTRL_phy_txrequlpslan(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_txexitulpslan[4] (RW)
 *
 * ULPS mode Exit on on all active data lanes
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan (4U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan (0x00000010U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_txexitulpslan)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan) & BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan)

/*! @brief Set the phy_txexitulpslan field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan) | BF_MIPI_DSI_PHY_IF_CTRL_phy_txexitulpslan(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_IF_CTRL, field phy_tx_triggers[8:5] (RW)
 *
 * Controls the trigger transmissions
 */
/*@{*/
#define BP_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers (5U) /*!< Bit position for MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers. */
#define BM_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers (0x000001E0U) /*!< Bit mask for MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers. */
#define BS_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers (4U) /*!< Bit field size in bits for MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers. */

/*! @brief Read current value of the MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers field. */
#define BR_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers(x) (HW_MIPI_DSI_PHY_IF_CTRL(x).B.phy_tx_triggers)

/*! @brief Format value for bitfield MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers. */
#define BF_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers) & BM_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers)

/*! @brief Set the phy_tx_triggers field to a new value. */
#define BW_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers(x, v) (HW_MIPI_DSI_PHY_IF_CTRL_WR(x, (HW_MIPI_DSI_PHY_IF_CTRL_RD(x) & ~BM_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers) | BF_MIPI_DSI_PHY_IF_CTRL_phy_tx_triggers(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_STATUS - D-PHY PPI status interface
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_STATUS - D-PHY PPI status interface (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x60 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_status
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_status_bitfields
    {
        uint32_t phylock : 1;          /*!< [0]  */
        uint32_t phydirection : 1;     /*!< [1]  */
        uint32_t phystopstateclklane : 1; /*!< [2]  */
        uint32_t phyrxulpsclknot : 1;  /*!< [3]  */
        uint32_t phystopstate0lane : 1; /*!< [4]  */
        uint32_t ulpsactivenot0lane : 1; /*!< [5]  */
        uint32_t rxulpsesc0lane : 1;   /*!< [6]  */
        uint32_t phystopstate1lane : 1; /*!< [7]  */
        uint32_t ulpsactivenot1lane : 1; /*!< [8]  */
        uint32_t phystopstate2lane : 1; /*!< [9]  */
        uint32_t ulpsactivenot2lane : 1; /*!< [10]  */
        uint32_t phystopstate3lane : 1; /*!< [11]  */
        uint32_t ulpsactivenot3lane : 1; /*!< [12]  */
        uint32_t RESERVED0 : 19;       /*!< [31:13]  */
    } B;
} hw_mipi_dsi_phy_status_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_STATUS register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_STATUS_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_MIPI_DSI_PHY_STATUS(x) (*(__IO hw_mipi_dsi_phy_status_t *) HW_MIPI_DSI_PHY_STATUS_ADDR(x))
#define HW_MIPI_DSI_PHY_STATUS_RD(x) (HW_MIPI_DSI_PHY_STATUS(x).U)
#define HW_MIPI_DSI_PHY_STATUS_WR(x, v) (HW_MIPI_DSI_PHY_STATUS(x).U = (v))
#define HW_MIPI_DSI_PHY_STATUS_SET(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, HW_MIPI_DSI_PHY_STATUS_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_STATUS_CLR(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, HW_MIPI_DSI_PHY_STATUS_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_STATUS_TOG(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, HW_MIPI_DSI_PHY_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_STATUS bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phylock[0] (RW)
 *
 * Reports status of phylock D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phylock (0U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phylock. */
#define BM_MIPI_DSI_PHY_STATUS_phylock (0x00000001U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phylock. */
#define BS_MIPI_DSI_PHY_STATUS_phylock (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phylock. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phylock field. */
#define BR_MIPI_DSI_PHY_STATUS_phylock(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phylock)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phylock. */
#define BF_MIPI_DSI_PHY_STATUS_phylock(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phylock) & BM_MIPI_DSI_PHY_STATUS_phylock)

/*! @brief Set the phylock field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phylock(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phylock) | BF_MIPI_DSI_PHY_STATUS_phylock(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phydirection[1] (RW)
 *
 * Reports status of phydirection D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phydirection (1U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phydirection. */
#define BM_MIPI_DSI_PHY_STATUS_phydirection (0x00000002U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phydirection. */
#define BS_MIPI_DSI_PHY_STATUS_phydirection (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phydirection. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phydirection field. */
#define BR_MIPI_DSI_PHY_STATUS_phydirection(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phydirection)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phydirection. */
#define BF_MIPI_DSI_PHY_STATUS_phydirection(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phydirection) & BM_MIPI_DSI_PHY_STATUS_phydirection)

/*! @brief Set the phydirection field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phydirection(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phydirection) | BF_MIPI_DSI_PHY_STATUS_phydirection(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phystopstateclklane[2] (RW)
 *
 * Reports status of phystopstateclklane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phystopstateclklane (2U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phystopstateclklane. */
#define BM_MIPI_DSI_PHY_STATUS_phystopstateclklane (0x00000004U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phystopstateclklane. */
#define BS_MIPI_DSI_PHY_STATUS_phystopstateclklane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phystopstateclklane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phystopstateclklane field. */
#define BR_MIPI_DSI_PHY_STATUS_phystopstateclklane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phystopstateclklane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phystopstateclklane. */
#define BF_MIPI_DSI_PHY_STATUS_phystopstateclklane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phystopstateclklane) & BM_MIPI_DSI_PHY_STATUS_phystopstateclklane)

/*! @brief Set the phystopstateclklane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phystopstateclklane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phystopstateclklane) | BF_MIPI_DSI_PHY_STATUS_phystopstateclklane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phyrxulpsclknot[3] (RW)
 *
 * Reports status of phyrxulpsclknot D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phyrxulpsclknot (3U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phyrxulpsclknot. */
#define BM_MIPI_DSI_PHY_STATUS_phyrxulpsclknot (0x00000008U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phyrxulpsclknot. */
#define BS_MIPI_DSI_PHY_STATUS_phyrxulpsclknot (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phyrxulpsclknot. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phyrxulpsclknot field. */
#define BR_MIPI_DSI_PHY_STATUS_phyrxulpsclknot(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phyrxulpsclknot)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phyrxulpsclknot. */
#define BF_MIPI_DSI_PHY_STATUS_phyrxulpsclknot(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phyrxulpsclknot) & BM_MIPI_DSI_PHY_STATUS_phyrxulpsclknot)

/*! @brief Set the phyrxulpsclknot field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phyrxulpsclknot(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phyrxulpsclknot) | BF_MIPI_DSI_PHY_STATUS_phyrxulpsclknot(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phystopstate0lane[4] (RW)
 *
 * Reports status of phystopstate0lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phystopstate0lane (4U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phystopstate0lane. */
#define BM_MIPI_DSI_PHY_STATUS_phystopstate0lane (0x00000010U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phystopstate0lane. */
#define BS_MIPI_DSI_PHY_STATUS_phystopstate0lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phystopstate0lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phystopstate0lane field. */
#define BR_MIPI_DSI_PHY_STATUS_phystopstate0lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phystopstate0lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phystopstate0lane. */
#define BF_MIPI_DSI_PHY_STATUS_phystopstate0lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phystopstate0lane) & BM_MIPI_DSI_PHY_STATUS_phystopstate0lane)

/*! @brief Set the phystopstate0lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phystopstate0lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phystopstate0lane) | BF_MIPI_DSI_PHY_STATUS_phystopstate0lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field ulpsactivenot0lane[5] (RW)
 *
 * Reports status of ulpsactivenot0lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane (5U) /*!< Bit position for MIPI_DSI_PHY_STATUS_ulpsactivenot0lane. */
#define BM_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane (0x00000020U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_ulpsactivenot0lane. */
#define BS_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_ulpsactivenot0lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_ulpsactivenot0lane field. */
#define BR_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.ulpsactivenot0lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_ulpsactivenot0lane. */
#define BF_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane) & BM_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane)

/*! @brief Set the ulpsactivenot0lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane) | BF_MIPI_DSI_PHY_STATUS_ulpsactivenot0lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field rxulpsesc0lane[6] (RW)
 *
 * Reports status of rxulpsEsc0lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_rxulpsesc0lane (6U) /*!< Bit position for MIPI_DSI_PHY_STATUS_rxulpsesc0lane. */
#define BM_MIPI_DSI_PHY_STATUS_rxulpsesc0lane (0x00000040U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_rxulpsesc0lane. */
#define BS_MIPI_DSI_PHY_STATUS_rxulpsesc0lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_rxulpsesc0lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_rxulpsesc0lane field. */
#define BR_MIPI_DSI_PHY_STATUS_rxulpsesc0lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.rxulpsesc0lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_rxulpsesc0lane. */
#define BF_MIPI_DSI_PHY_STATUS_rxulpsesc0lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_rxulpsesc0lane) & BM_MIPI_DSI_PHY_STATUS_rxulpsesc0lane)

/*! @brief Set the rxulpsesc0lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_rxulpsesc0lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_rxulpsesc0lane) | BF_MIPI_DSI_PHY_STATUS_rxulpsesc0lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phystopstate1lane[7] (RW)
 *
 * Reports status of phystopstate1lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phystopstate1lane (7U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phystopstate1lane. */
#define BM_MIPI_DSI_PHY_STATUS_phystopstate1lane (0x00000080U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phystopstate1lane. */
#define BS_MIPI_DSI_PHY_STATUS_phystopstate1lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phystopstate1lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phystopstate1lane field. */
#define BR_MIPI_DSI_PHY_STATUS_phystopstate1lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phystopstate1lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phystopstate1lane. */
#define BF_MIPI_DSI_PHY_STATUS_phystopstate1lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phystopstate1lane) & BM_MIPI_DSI_PHY_STATUS_phystopstate1lane)

/*! @brief Set the phystopstate1lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phystopstate1lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phystopstate1lane) | BF_MIPI_DSI_PHY_STATUS_phystopstate1lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field ulpsactivenot1lane[8] (RW)
 *
 * Reports status of ulpsactivenot1lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane (8U) /*!< Bit position for MIPI_DSI_PHY_STATUS_ulpsactivenot1lane. */
#define BM_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane (0x00000100U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_ulpsactivenot1lane. */
#define BS_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_ulpsactivenot1lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_ulpsactivenot1lane field. */
#define BR_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.ulpsactivenot1lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_ulpsactivenot1lane. */
#define BF_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane) & BM_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane)

/*! @brief Set the ulpsactivenot1lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane) | BF_MIPI_DSI_PHY_STATUS_ulpsactivenot1lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phystopstate2lane[9] (RW)
 *
 * Reports status of phystopstate2lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phystopstate2lane (9U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phystopstate2lane. */
#define BM_MIPI_DSI_PHY_STATUS_phystopstate2lane (0x00000200U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phystopstate2lane. */
#define BS_MIPI_DSI_PHY_STATUS_phystopstate2lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phystopstate2lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phystopstate2lane field. */
#define BR_MIPI_DSI_PHY_STATUS_phystopstate2lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phystopstate2lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phystopstate2lane. */
#define BF_MIPI_DSI_PHY_STATUS_phystopstate2lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phystopstate2lane) & BM_MIPI_DSI_PHY_STATUS_phystopstate2lane)

/*! @brief Set the phystopstate2lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phystopstate2lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phystopstate2lane) | BF_MIPI_DSI_PHY_STATUS_phystopstate2lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field ulpsactivenot2lane[10] (RW)
 *
 * Reports status of ulpsactivenot2lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane (10U) /*!< Bit position for MIPI_DSI_PHY_STATUS_ulpsactivenot2lane. */
#define BM_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane (0x00000400U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_ulpsactivenot2lane. */
#define BS_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_ulpsactivenot2lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_ulpsactivenot2lane field. */
#define BR_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.ulpsactivenot2lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_ulpsactivenot2lane. */
#define BF_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane) & BM_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane)

/*! @brief Set the ulpsactivenot2lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane) | BF_MIPI_DSI_PHY_STATUS_ulpsactivenot2lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field phystopstate3lane[11] (RW)
 *
 * Reports status of phystopstate3lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_phystopstate3lane (11U) /*!< Bit position for MIPI_DSI_PHY_STATUS_phystopstate3lane. */
#define BM_MIPI_DSI_PHY_STATUS_phystopstate3lane (0x00000800U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_phystopstate3lane. */
#define BS_MIPI_DSI_PHY_STATUS_phystopstate3lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_phystopstate3lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_phystopstate3lane field. */
#define BR_MIPI_DSI_PHY_STATUS_phystopstate3lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.phystopstate3lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_phystopstate3lane. */
#define BF_MIPI_DSI_PHY_STATUS_phystopstate3lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_phystopstate3lane) & BM_MIPI_DSI_PHY_STATUS_phystopstate3lane)

/*! @brief Set the phystopstate3lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_phystopstate3lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_phystopstate3lane) | BF_MIPI_DSI_PHY_STATUS_phystopstate3lane(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_STATUS, field ulpsactivenot3lane[12] (RW)
 *
 * Reports status of ulpsactivenot3lane D-PHY pin
 */
/*@{*/
#define BP_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane (12U) /*!< Bit position for MIPI_DSI_PHY_STATUS_ulpsactivenot3lane. */
#define BM_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane (0x00001000U) /*!< Bit mask for MIPI_DSI_PHY_STATUS_ulpsactivenot3lane. */
#define BS_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_STATUS_ulpsactivenot3lane. */

/*! @brief Read current value of the MIPI_DSI_PHY_STATUS_ulpsactivenot3lane field. */
#define BR_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane(x) (HW_MIPI_DSI_PHY_STATUS(x).B.ulpsactivenot3lane)

/*! @brief Format value for bitfield MIPI_DSI_PHY_STATUS_ulpsactivenot3lane. */
#define BF_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane) & BM_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane)

/*! @brief Set the ulpsactivenot3lane field to a new value. */
#define BW_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane(x, v) (HW_MIPI_DSI_PHY_STATUS_WR(x, (HW_MIPI_DSI_PHY_STATUS_RD(x) & ~BM_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane) | BF_MIPI_DSI_PHY_STATUS_ulpsactivenot3lane(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_TST_CTRL0 - D-PHY Test interface control 0
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_TST_CTRL0 - D-PHY Test interface control 0 (RW)
 *
 * Reset value: 0x00000001U
 *
 * Size: 32 bits Offset: 0x64 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_tst_ctrl0
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_tst_ctrl0_bitfields
    {
        uint32_t phy_testclr : 1;      /*!< [0]  */
        uint32_t phy_testclk : 1;      /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_mipi_dsi_phy_tst_ctrl0_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_TST_CTRL0 register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_TST_CTRL0_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_MIPI_DSI_PHY_TST_CTRL0(x) (*(__IO hw_mipi_dsi_phy_tst_ctrl0_t *) HW_MIPI_DSI_PHY_TST_CTRL0_ADDR(x))
#define HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) (HW_MIPI_DSI_PHY_TST_CTRL0(x).U)
#define HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0(x).U = (v))
#define HW_MIPI_DSI_PHY_TST_CTRL0_SET(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_TST_CTRL0_CLR(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_TST_CTRL0_TOG(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_TST_CTRL0 bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_TST_CTRL0, field phy_testclr[0] (RW)
 *
 * PHY test interface clear. When active performs vendor specific interface
 * initialization (Active High)
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TST_CTRL0_phy_testclr (0U) /*!< Bit position for MIPI_DSI_PHY_TST_CTRL0_phy_testclr. */
#define BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclr (0x00000001U) /*!< Bit mask for MIPI_DSI_PHY_TST_CTRL0_phy_testclr. */
#define BS_MIPI_DSI_PHY_TST_CTRL0_phy_testclr (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_TST_CTRL0_phy_testclr. */

/*! @brief Read current value of the MIPI_DSI_PHY_TST_CTRL0_phy_testclr field. */
#define BR_MIPI_DSI_PHY_TST_CTRL0_phy_testclr(x) (HW_MIPI_DSI_PHY_TST_CTRL0(x).B.phy_testclr)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TST_CTRL0_phy_testclr. */
#define BF_MIPI_DSI_PHY_TST_CTRL0_phy_testclr(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TST_CTRL0_phy_testclr) & BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclr)

/*! @brief Set the phy_testclr field to a new value. */
#define BW_MIPI_DSI_PHY_TST_CTRL0_phy_testclr(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, (HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) & ~BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclr) | BF_MIPI_DSI_PHY_TST_CTRL0_phy_testclr(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_TST_CTRL0, field phy_testclk[1] (RW)
 *
 * PHY test interface strobe signal. Used to clock TESTDIN bus into the D-PHY.
 * In conjunction with TESTEN signal controls the operation selection
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TST_CTRL0_phy_testclk (1U) /*!< Bit position for MIPI_DSI_PHY_TST_CTRL0_phy_testclk. */
#define BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclk (0x00000002U) /*!< Bit mask for MIPI_DSI_PHY_TST_CTRL0_phy_testclk. */
#define BS_MIPI_DSI_PHY_TST_CTRL0_phy_testclk (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_TST_CTRL0_phy_testclk. */

/*! @brief Read current value of the MIPI_DSI_PHY_TST_CTRL0_phy_testclk field. */
#define BR_MIPI_DSI_PHY_TST_CTRL0_phy_testclk(x) (HW_MIPI_DSI_PHY_TST_CTRL0(x).B.phy_testclk)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TST_CTRL0_phy_testclk. */
#define BF_MIPI_DSI_PHY_TST_CTRL0_phy_testclk(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TST_CTRL0_phy_testclk) & BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclk)

/*! @brief Set the phy_testclk field to a new value. */
#define BW_MIPI_DSI_PHY_TST_CTRL0_phy_testclk(x, v) (HW_MIPI_DSI_PHY_TST_CTRL0_WR(x, (HW_MIPI_DSI_PHY_TST_CTRL0_RD(x) & ~BM_MIPI_DSI_PHY_TST_CTRL0_phy_testclk) | BF_MIPI_DSI_PHY_TST_CTRL0_phy_testclk(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_DSI_PHY_TST_CTRL1 - D-PHY Test interface control 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_DSI_PHY_TST_CTRL1 - D-PHY Test interface control 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Size: 32 bits Offset: 0x68 Memory Access: R/W
 */
typedef union _hw_mipi_dsi_phy_tst_ctrl1
{
    uint32_t U;
    struct _hw_mipi_dsi_phy_tst_ctrl1_bitfields
    {
        uint32_t phy_testdin : 8;      /*!< [7:0]  */
        uint32_t phy_testdout : 8;     /*!< [15:8]  */
        uint32_t phy_testen : 1;       /*!< [16]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_mipi_dsi_phy_tst_ctrl1_t;

/*!
 * @name Constants and macros for entire MIPI_DSI_PHY_TST_CTRL1 register
 */
/*@{*/
#define HW_MIPI_DSI_PHY_TST_CTRL1_ADDR(x) ((uintptr_t)(x) + 0x68U)

#define HW_MIPI_DSI_PHY_TST_CTRL1(x) (*(__IO hw_mipi_dsi_phy_tst_ctrl1_t *) HW_MIPI_DSI_PHY_TST_CTRL1_ADDR(x))
#define HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) (HW_MIPI_DSI_PHY_TST_CTRL1(x).U)
#define HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1(x).U = (v))
#define HW_MIPI_DSI_PHY_TST_CTRL1_SET(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) |  (v)))
#define HW_MIPI_DSI_PHY_TST_CTRL1_CLR(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) & ~(v)))
#define HW_MIPI_DSI_PHY_TST_CTRL1_TOG(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_DSI_PHY_TST_CTRL1 bitfields
 */

/*!
 * @name Register MIPI_DSI_PHY_TST_CTRL1, field phy_testdin[7:0] (RW)
 *
 * PHY test interface input 8-bit data bus for internal register programming and
 * test functionalities access
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TST_CTRL1_phy_testdin (0U) /*!< Bit position for MIPI_DSI_PHY_TST_CTRL1_phy_testdin. */
#define BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdin (0x000000FFU) /*!< Bit mask for MIPI_DSI_PHY_TST_CTRL1_phy_testdin. */
#define BS_MIPI_DSI_PHY_TST_CTRL1_phy_testdin (8U) /*!< Bit field size in bits for MIPI_DSI_PHY_TST_CTRL1_phy_testdin. */

/*! @brief Read current value of the MIPI_DSI_PHY_TST_CTRL1_phy_testdin field. */
#define BR_MIPI_DSI_PHY_TST_CTRL1_phy_testdin(x) (HW_MIPI_DSI_PHY_TST_CTRL1(x).B.phy_testdin)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TST_CTRL1_phy_testdin. */
#define BF_MIPI_DSI_PHY_TST_CTRL1_phy_testdin(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TST_CTRL1_phy_testdin) & BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdin)

/*! @brief Set the phy_testdin field to a new value. */
#define BW_MIPI_DSI_PHY_TST_CTRL1_phy_testdin(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdin) | BF_MIPI_DSI_PHY_TST_CTRL1_phy_testdin(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_TST_CTRL1, field phy_testdout[15:8] (RW)
 *
 * PHY output 8-bit data bus for read-back and internal probing functionalities
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TST_CTRL1_phy_testdout (8U) /*!< Bit position for MIPI_DSI_PHY_TST_CTRL1_phy_testdout. */
#define BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdout (0x0000FF00U) /*!< Bit mask for MIPI_DSI_PHY_TST_CTRL1_phy_testdout. */
#define BS_MIPI_DSI_PHY_TST_CTRL1_phy_testdout (8U) /*!< Bit field size in bits for MIPI_DSI_PHY_TST_CTRL1_phy_testdout. */

/*! @brief Read current value of the MIPI_DSI_PHY_TST_CTRL1_phy_testdout field. */
#define BR_MIPI_DSI_PHY_TST_CTRL1_phy_testdout(x) (HW_MIPI_DSI_PHY_TST_CTRL1(x).B.phy_testdout)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TST_CTRL1_phy_testdout. */
#define BF_MIPI_DSI_PHY_TST_CTRL1_phy_testdout(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TST_CTRL1_phy_testdout) & BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdout)

/*! @brief Set the phy_testdout field to a new value. */
#define BW_MIPI_DSI_PHY_TST_CTRL1_phy_testdout(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_DSI_PHY_TST_CTRL1_phy_testdout) | BF_MIPI_DSI_PHY_TST_CTRL1_phy_testdout(v)))
/*@}*/

/*!
 * @name Register MIPI_DSI_PHY_TST_CTRL1, field phy_testen[16] (RW)
 *
 * PHY test interface operation selector: when 1 configures address write
 * operation on the falling edge of TESTCLK; when 0 configures a data write operation
 * on the rising edge of TESTCLK
 */
/*@{*/
#define BP_MIPI_DSI_PHY_TST_CTRL1_phy_testen (16U) /*!< Bit position for MIPI_DSI_PHY_TST_CTRL1_phy_testen. */
#define BM_MIPI_DSI_PHY_TST_CTRL1_phy_testen (0x00010000U) /*!< Bit mask for MIPI_DSI_PHY_TST_CTRL1_phy_testen. */
#define BS_MIPI_DSI_PHY_TST_CTRL1_phy_testen (1U) /*!< Bit field size in bits for MIPI_DSI_PHY_TST_CTRL1_phy_testen. */

/*! @brief Read current value of the MIPI_DSI_PHY_TST_CTRL1_phy_testen field. */
#define BR_MIPI_DSI_PHY_TST_CTRL1_phy_testen(x) (HW_MIPI_DSI_PHY_TST_CTRL1(x).B.phy_testen)

/*! @brief Format value for bitfield MIPI_DSI_PHY_TST_CTRL1_phy_testen. */
#define BF_MIPI_DSI_PHY_TST_CTRL1_phy_testen(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_DSI_PHY_TST_CTRL1_phy_testen) & BM_MIPI_DSI_PHY_TST_CTRL1_phy_testen)

/*! @brief Set the phy_testen field to a new value. */
#define BW_MIPI_DSI_PHY_TST_CTRL1_phy_testen(x, v) (HW_MIPI_DSI_PHY_TST_CTRL1_WR(x, (HW_MIPI_DSI_PHY_TST_CTRL1_RD(x) & ~BM_MIPI_DSI_PHY_TST_CTRL1_phy_testen) | BF_MIPI_DSI_PHY_TST_CTRL1_phy_testen(v)))
/*@}*/

/*******************************************************************************
 * hw_mipi_dsi_t - module struct
 ******************************************************************************/
/*!
 * @brief All MIPI_DSI module registers.
 */
#pragma pack(1)
typedef struct _hw_mipi_dsi
{
    __I hw_mipi_dsi_version_t VERSION;     /*!< [0x0] Version of the DSI host ctrl */
    __IO hw_mipi_dsi_pwr_up_t PWR_UP;      /*!< [0x4] Core power up */
    __IO hw_mipi_dsi_clkmgr_cfg_t CLKMGR_CFG; /*!< [0x8] Number of active data lanes */
    __IO hw_mipi_dsi_dpi_cfg_t DPI_CFG;    /*!< [0xC] DPI interface configuration */
    __IO hw_mipi_dsi_dbi_cfg_t DBI_CFG;    /*!< [0x10] DBI interface configuration */
    __IO hw_mipi_dsi_dbis_cmdsize_t DBIS_CMDSIZE; /*!< [0x14] DBI command size configuration */
    __IO hw_mipi_dsi_pckhdl_cfg_t PCKHDL_CFG; /*!< [0x18] Packet handler configuration */
    __IO hw_mipi_dsi_vid_mode_cfg_t VID_MODE_CFG; /*!< [0x1C] Video Mode Configuration */
    __IO hw_mipi_dsi_vid_pkt_cfg_t VID_PKT_CFG; /*!< [0x20] Video packet configuration */
    __IO hw_mipi_dsi_cmd_mode_cfg_t CMD_MODE_CFG; /*!< [0x24] Command mode configuration */
    __IO hw_mipi_dsi_tmr_line_cfg_t TMR_LINE_CFG; /*!< [0x28] Line timer configuration */
    __IO hw_mipi_dsi_vtiming_cfg_t VTIMING_CFG; /*!< [0x2C] Vertical timing configuration */
    __IO hw_mipi_dsi_phy_tmr_cfg_t PHY_TMR_CFG; /*!< [0x30] D-PHY timing configuration */
    __IO hw_mipi_dsi_gen_hdr_t GEN_HDR;    /*!< [0x34] Generic packet Header configuration */
    __IO hw_mipi_dsi_gen_pld_data_t GEN_PLD_DATA; /*!< [0x38] Generic payload data in/out */
    __IO hw_mipi_dsi_cmd_pkt_status_t CMD_PKT_STATUS; /*!< [0x3C] Command packet status */
    __IO hw_mipi_dsi_to_cnt_cfg0_t TO_CNT_CFG0; /*!< [0x40] Time Out timers configuration */
    __IO hw_mipi_dsi_error_st0_t ERROR_ST0; /*!< [0x44] Interrupt status register 0 */
    __IO hw_mipi_dsi_error_st1_t ERROR_ST1; /*!< [0x48] Interrupt status register 1 */
    __IO hw_mipi_dsi_error_msk0_t ERROR_MSK0; /*!< [0x4C] Masks Interrupt generation trigged by ERROR_ST0 register */
    __IO hw_mipi_dsi_error_msk1_t ERROR_MSK1; /*!< [0x50] Masks Interrupt generation trigged by ERROR_ST1 register */
    __IO hw_mipi_dsi_phy_rstz_t PHY_RSTZ;  /*!< [0x54] D-PHY reset control */
    __IO hw_mipi_dsi_phy_if_cfg__t PHY_IF_CFG_; /*!< [0x58] D-PHY interface configuration */
    __IO hw_mipi_dsi_phy_if_ctrl_t PHY_IF_CTRL; /*!< [0x5C] D-PHY PPI interface control */
    __IO hw_mipi_dsi_phy_status_t PHY_STATUS; /*!< [0x60] D-PHY PPI status interface */
    __IO hw_mipi_dsi_phy_tst_ctrl0_t PHY_TST_CTRL0; /*!< [0x64] D-PHY Test interface control 0 */
    __IO hw_mipi_dsi_phy_tst_ctrl1_t PHY_TST_CTRL1; /*!< [0x68] D-PHY Test interface control 1 */
} hw_mipi_dsi_t;
#pragma pack()

/*! @brief Macro to access all MIPI_DSI registers. */
/*! @param x MIPI_DSI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_MIPI_DSI_REGS(MIPI_DSI_BASE)</code>. */
#define HW_MIPI_DSI_REGS(x) (*(hw_mipi_dsi_t *)(x))

/*
 * iMX6DP MIPI_HSI
 *
 * MIPI HSI Registers
 *
 * Registers defined in this header file:
 * - HW_MIPI_HSI_CTRL - HSI Control Register
 * - HW_MIPI_HSI_TX_CONF - HSI Tx Config Register
 * - HW_MIPI_HSI_RX_CONF - HSI Rx Config Register
 * - HW_MIPI_HSI_CAP - HSI Capability Register
 * - HW_MIPI_HSI_TX_WML0 - HSI Tx Water Mark Level 0 Register
 * - HW_MIPI_HSI_TX_TML1 - HSI Tx Water Mark Level 1 Register
 * - HW_MIPI_HSI_TX_ARB_PRI0 - HSI Tx Arbiter Priority 0 Register
 * - HW_MIPI_HSI_TX_ARB_PRI1 - HSI Tx Arbiter Priority 1 Register
 * - HW_MIPI_HSI_LINE_ST - HSI Line Status Register
 * - HW_MIPI_HSI_ID_BIT - HSI ID Bits Register
 * - HW_MIPI_HSI_FIFO_THR_CONF - Tx and Rx Fif0 Threshold Configuration Register
 * - HW_MIPI_HSI_CH_SFTRST - Tx and Rx Channel Soft Reset Register
 * - HW_MIPI_HSI_IRQSTAT - HSI Interrupt Status Register
 * - HW_MIPI_HSI_IRQSTAT_EN - HSI Interrupt Status Enable Register
 * - HW_MIPI_HSI_IRQSIG_EN - HSI Interrupt Signal Enable Register
 * - HW_MIPI_HSI_FIFO_THR_IRQSTAT - HSI FIFO Threshold Interrupt Status Register
 * - HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN - HSI FIFO Threshold Interrupt Status Enable Register
 * - HW_MIPI_HSI_FIFO_THR_IRQSIG_EN - HSI FIFO Threshold Interrupt Signal Enable Register
 * - HW_MIPI_HSI_TX_CHn_DP - Tx Channel n Data Port Register
 * - HW_MIPI_HSI_RX_CHn_DP - Rx Channel n Data Port Register
 * - HW_MIPI_HSI_ERR_IRQSTAT - HSI Error Interrupt Status Register
 * - HW_MIPI_HSI_ERR_IRQSTAT_EN - HSI Error Interrupt Status Enable Register
 * - HW_MIPI_HSI_ERR_IRQSIG_EN - HSI Error Interrupt Signal Enable Register
 * - HW_MIPI_HSI_TDMAn_CONF - Tx DMA Channel n Configuration Register
 * - HW_MIPI_HSI_RDMAn_CONF - Rx DMA Channel n Configuration Register
 * - HW_MIPI_HSI_TDMAn_STA_ADDR - Tx DMA Channel n Start Address Register
 * - HW_MIPI_HSI_RDMAn_STA_ADDR - Rx DMA Channel n Start Address Register
 * - HW_MIPI_HSI_DMA_IRQSTAT - DMA Interrupt Status Register
 * - HW_MIPI_HSI_DMA_IRQSTAT_EN - DMA Interrupt Enable Register
 * - HW_MIPI_HSI_DMA_IRQSIG_EN - DMA Interrupt Status Signal Enable Register
 * - HW_MIPI_HSI_DMA_ERR_IRQSTAT - DMA Error Interrupt Status Register
 * - HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN - DMA Error Interrupt Enable Register
 * - HW_MIPI_HSI_DMA_ERR_IRQSIG_EN - DMA Error Interrupt Signal Enable Register
 * - HW_MIPI_HSI_DMA_SINGLE_REQ_EN - DMA Single Request Enable Register
 * - HW_MIPI_HSI_TX_FIFO_SIZE_CONF0 - Tx Fifo Size Configuration Register 0
 * - HW_MIPI_HSI_TX_FIFO_SIZE_CONF1 - Tx Fifo Size Configuration Register 1
 * - HW_MIPI_HSI_RX_FIFO_SIZE_CONF0 - Rx Fifo Size Configuration Register 0
 * - HW_MIPI_HSI_RX_FIFO_SIZE_CONF1 - Rx Fifo Size Configuration Register 1
 * - HW_MIPI_HSI_TX_FIFO_STAT - Tx Fifo Status Register
 * - HW_MIPI_HSI_RX_FIFO_STAT - Rx Fifo Status Register
 * - HW_MIPI_HSI_AHB_MASTER_CONF - Ahb Master Config Register
 * - HW_MIPI_HSI_TX_BREAK_LEN - TX Break Length Register
 *
 * - hw_mipi_hsi_t - Struct containing all module registers.
 */

#define HW_MIPI_HSI_INSTANCE_COUNT (1U) /*!< Number of instances of the MIPI_HSI module. */
#define HW_MIPI_HSI (0U) /*!< Instance number for MIPI_HSI. */
#define MIPI_HSI_BASE         (0x2208000U) /*!< Base address for MIPI_HSI. */
/*! Array initializer of MIPI_HSI base addresses. */
#define MIPI_HSI_BASE_ADDRS   { MIPI_HSI_BASE }

/*******************************************************************************
 * HW_MIPI_HSI_CTRL - HSI Control Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_CTRL - HSI Control Register (RW)
 *
 * Reset value: 0xC8000000U
 *
 * This register contains module soft reset, clock gating, clock divisor and so
 * on.
 */
typedef union _hw_mipi_hsi_ctrl
{
    uint32_t U;
    struct _hw_mipi_hsi_ctrl_bitfields
    {
        uint32_t TX_CLK_DIVISOR : 4;   /*!< [3:0]  */
        uint32_t TX_BREAK : 1;         /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t DATA_TIMEOUT_CNT : 4; /*!< [11:8]  */
        uint32_t RX_TAIL_BIT_CNT : 2;  /*!< [13:12]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t RX_FRAME_BRST_CNT : 8; /*!< [23:16]  */
        uint32_t RX_DLY_SEL : 3;       /*!< [26:24]  */
        uint32_t DMA_DISABLE : 1;      /*!< [27]  */
        uint32_t RESERVED2 : 2;        /*!< [29:28]  */
        uint32_t CLKGATE : 1;          /*!< [30]  */
        uint32_t SFTRST : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_ctrl_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_CTRL register
 */
/*@{*/
#define HW_MIPI_HSI_CTRL_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_MIPI_HSI_CTRL(x)      (*(__IO hw_mipi_hsi_ctrl_t *) HW_MIPI_HSI_CTRL_ADDR(x))
#define HW_MIPI_HSI_CTRL_RD(x)   (HW_MIPI_HSI_CTRL(x).U)
#define HW_MIPI_HSI_CTRL_WR(x, v) (HW_MIPI_HSI_CTRL(x).U = (v))
#define HW_MIPI_HSI_CTRL_SET(x, v) (HW_MIPI_HSI_CTRL_WR(x, HW_MIPI_HSI_CTRL_RD(x) |  (v)))
#define HW_MIPI_HSI_CTRL_CLR(x, v) (HW_MIPI_HSI_CTRL_WR(x, HW_MIPI_HSI_CTRL_RD(x) & ~(v)))
#define HW_MIPI_HSI_CTRL_TOG(x, v) (HW_MIPI_HSI_CTRL_WR(x, HW_MIPI_HSI_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_CTRL bitfields
 */

/*!
 * @name Register MIPI_HSI_CTRL, field TX_CLK_DIVISOR[3:0] (RW)
 *
 * This register holds the divisor of the base clock (tx_refclk) frequency for
 * HSI Tx clock (internal clock used to drive Transmitter interface).
 *
 * Values:
 * - 1000 - tx_refclk divided by 256
 * - 0111 - tx_refclk divided by 128
 * - 0110 - tx_refclk divided by 64
 * - 0101 - tx_refclkdivided by 32
 * - 0100 - tx_refclk divided by 16
 * - 0011 - tx_refclk divided by 8
 * - 0010 - tx_refclk divided by 4
 * - 0001 - tx_refclk divided by 2
 * - 0000 - tx_refclk divided by 1
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_TX_CLK_DIVISOR (0U) /*!< Bit position for MIPI_HSI_CTRL_TX_CLK_DIVISOR. */
#define BM_MIPI_HSI_CTRL_TX_CLK_DIVISOR (0x0000000FU) /*!< Bit mask for MIPI_HSI_CTRL_TX_CLK_DIVISOR. */
#define BS_MIPI_HSI_CTRL_TX_CLK_DIVISOR (4U) /*!< Bit field size in bits for MIPI_HSI_CTRL_TX_CLK_DIVISOR. */

/*! @brief Read current value of the MIPI_HSI_CTRL_TX_CLK_DIVISOR field. */
#define BR_MIPI_HSI_CTRL_TX_CLK_DIVISOR(x) (HW_MIPI_HSI_CTRL(x).B.TX_CLK_DIVISOR)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_TX_CLK_DIVISOR. */
#define BF_MIPI_HSI_CTRL_TX_CLK_DIVISOR(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_TX_CLK_DIVISOR) & BM_MIPI_HSI_CTRL_TX_CLK_DIVISOR)

/*! @brief Set the TX_CLK_DIVISOR field to a new value. */
#define BW_MIPI_HSI_CTRL_TX_CLK_DIVISOR(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_TX_CLK_DIVISOR) | BF_MIPI_HSI_CTRL_TX_CLK_DIVISOR(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field TX_BREAK[4] (RW)
 *
 * Seeting this bit to one trigger a transmission break at HSI Tx. Once this bit
 * is set to one, the HSI controller will send a serise zeros on HSI_TX_DATA
 * port according to the tx break co unt. It will be automatically cleared, when the
 * send is finished.
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_TX_BREAK (4U)     /*!< Bit position for MIPI_HSI_CTRL_TX_BREAK. */
#define BM_MIPI_HSI_CTRL_TX_BREAK (0x00000010U) /*!< Bit mask for MIPI_HSI_CTRL_TX_BREAK. */
#define BS_MIPI_HSI_CTRL_TX_BREAK (1U)     /*!< Bit field size in bits for MIPI_HSI_CTRL_TX_BREAK. */

/*! @brief Read current value of the MIPI_HSI_CTRL_TX_BREAK field. */
#define BR_MIPI_HSI_CTRL_TX_BREAK(x) (HW_MIPI_HSI_CTRL(x).B.TX_BREAK)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_TX_BREAK. */
#define BF_MIPI_HSI_CTRL_TX_BREAK(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_TX_BREAK) & BM_MIPI_HSI_CTRL_TX_BREAK)

/*! @brief Set the TX_BREAK field to a new value. */
#define BW_MIPI_HSI_CTRL_TX_BREAK(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_TX_BREAK) | BF_MIPI_HSI_CTRL_TX_BREAK(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field DATA_TIMEOUT_CNT[11:8] (RW)
 *
 * This value determines the interval by which DATA timeouts are detected. This
 * data timeout counter logic is used only for Receive operations. The counter
 * should start counting when data in any of the RX channel fifo is less than the
 * threshold value and resets to zero when there is a threshold reached interrupt
 * from any of the RX buffers. The counter value should be zero, when RX fifo is
 * empty. An interrupt will be asserted to the host driver, when the counter
 * value reaches the data timeout counter value.
 *
 * Values:
 * - 1110 - HSI Tx Clock x 2 ^ 27
 * - 0001 - HSI Tx Clock x 2 ^ 14
 * - 0000 - HSI Tx Clock x 2 ^ 13
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT (8U) /*!< Bit position for MIPI_HSI_CTRL_DATA_TIMEOUT_CNT. */
#define BM_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT (0x00000F00U) /*!< Bit mask for MIPI_HSI_CTRL_DATA_TIMEOUT_CNT. */
#define BS_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT (4U) /*!< Bit field size in bits for MIPI_HSI_CTRL_DATA_TIMEOUT_CNT. */

/*! @brief Read current value of the MIPI_HSI_CTRL_DATA_TIMEOUT_CNT field. */
#define BR_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT(x) (HW_MIPI_HSI_CTRL(x).B.DATA_TIMEOUT_CNT)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_DATA_TIMEOUT_CNT. */
#define BF_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT) & BM_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT)

/*! @brief Set the DATA_TIMEOUT_CNT field to a new value. */
#define BW_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT) | BF_MIPI_HSI_CTRL_DATA_TIMEOUT_CNT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field RX_TAIL_BIT_CNT[13:12] (RW)
 *
 * The value determines the length of the Tailing bit counter. The receiver
 * shall start Receiver Tailing bit counter after the nth frame programmed in Rx
 * Frame Burst counter is received. The receiver shall then drive ready to logic one
 * if the receiver Tailing-bit counter has completed with no errors detected, and
 * the receiver has enough room for at least one new frame.
 *
 * Values:
 * - 00 - 800-> tx_refclk
 * - 01 - 400-> tx_refclk
 * - 10 - 200-> tx_refclk
 * - 11 - 100-> tx_refclk
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT (12U) /*!< Bit position for MIPI_HSI_CTRL_RX_TAIL_BIT_CNT. */
#define BM_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT (0x00003000U) /*!< Bit mask for MIPI_HSI_CTRL_RX_TAIL_BIT_CNT. */
#define BS_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT (2U) /*!< Bit field size in bits for MIPI_HSI_CTRL_RX_TAIL_BIT_CNT. */

/*! @brief Read current value of the MIPI_HSI_CTRL_RX_TAIL_BIT_CNT field. */
#define BR_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT(x) (HW_MIPI_HSI_CTRL(x).B.RX_TAIL_BIT_CNT)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_RX_TAIL_BIT_CNT. */
#define BF_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT) & BM_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT)

/*! @brief Set the RX_TAIL_BIT_CNT field to a new value. */
#define BW_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT) | BF_MIPI_HSI_CTRL_RX_TAIL_BIT_CNT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field RX_FRAME_BRST_CNT[23:16] (RW)
 *
 * This value is to limit the continous Frame transmission count in Pipelined
 * Data flow. The Receiver Frame Burst counter shall be able to support upto 256
 * frames of continous transfer. 7'h00 256 frames transmission count is set. 7'h01
 * 1 frames transmission count is set. 7'h02 2 frames transmission count is set.
 * 7'hff 255 frames transmission count is set.
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT (16U) /*!< Bit position for MIPI_HSI_CTRL_RX_FRAME_BRST_CNT. */
#define BM_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT (0x00FF0000U) /*!< Bit mask for MIPI_HSI_CTRL_RX_FRAME_BRST_CNT. */
#define BS_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT (8U) /*!< Bit field size in bits for MIPI_HSI_CTRL_RX_FRAME_BRST_CNT. */

/*! @brief Read current value of the MIPI_HSI_CTRL_RX_FRAME_BRST_CNT field. */
#define BR_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT(x) (HW_MIPI_HSI_CTRL(x).B.RX_FRAME_BRST_CNT)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_RX_FRAME_BRST_CNT. */
#define BF_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT) & BM_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT)

/*! @brief Set the RX_FRAME_BRST_CNT field to a new value. */
#define BW_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT) | BF_MIPI_HSI_CTRL_RX_FRAME_BRST_CNT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field RX_DLY_SEL[26:24] (RW)
 *
 * These values denote the tap delay values for reception of data and flag.
 *
 * Values:
 * - 000 - 0ns ;
 * - 001 - 1ns ;
 * - 010 - 2ns ;
 * - 011 - 3ns ;
 * - 100 - 4ns ;
 * - 101 - 5ns ;
 * - 110 - 6ns ;
 * - 111 - 7ns ;
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_RX_DLY_SEL (24U)  /*!< Bit position for MIPI_HSI_CTRL_RX_DLY_SEL. */
#define BM_MIPI_HSI_CTRL_RX_DLY_SEL (0x07000000U) /*!< Bit mask for MIPI_HSI_CTRL_RX_DLY_SEL. */
#define BS_MIPI_HSI_CTRL_RX_DLY_SEL (3U)   /*!< Bit field size in bits for MIPI_HSI_CTRL_RX_DLY_SEL. */

/*! @brief Read current value of the MIPI_HSI_CTRL_RX_DLY_SEL field. */
#define BR_MIPI_HSI_CTRL_RX_DLY_SEL(x) (HW_MIPI_HSI_CTRL(x).B.RX_DLY_SEL)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_RX_DLY_SEL. */
#define BF_MIPI_HSI_CTRL_RX_DLY_SEL(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_RX_DLY_SEL) & BM_MIPI_HSI_CTRL_RX_DLY_SEL)

/*! @brief Set the RX_DLY_SEL field to a new value. */
#define BW_MIPI_HSI_CTRL_RX_DLY_SEL(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_RX_DLY_SEL) | BF_MIPI_HSI_CTRL_RX_DLY_SEL(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field DMA_DISABLE[27] (RW)
 *
 * This bit must be set to zero for any DMA operation. When set to one it
 * disabel all the DMA channels.
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_DMA_DISABLE (27U) /*!< Bit position for MIPI_HSI_CTRL_DMA_DISABLE. */
#define BM_MIPI_HSI_CTRL_DMA_DISABLE (0x08000000U) /*!< Bit mask for MIPI_HSI_CTRL_DMA_DISABLE. */
#define BS_MIPI_HSI_CTRL_DMA_DISABLE (1U)  /*!< Bit field size in bits for MIPI_HSI_CTRL_DMA_DISABLE. */

/*! @brief Read current value of the MIPI_HSI_CTRL_DMA_DISABLE field. */
#define BR_MIPI_HSI_CTRL_DMA_DISABLE(x) (HW_MIPI_HSI_CTRL(x).B.DMA_DISABLE)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_DMA_DISABLE. */
#define BF_MIPI_HSI_CTRL_DMA_DISABLE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_DMA_DISABLE) & BM_MIPI_HSI_CTRL_DMA_DISABLE)

/*! @brief Set the DMA_DISABLE field to a new value. */
#define BW_MIPI_HSI_CTRL_DMA_DISABLE(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_DMA_DISABLE) | BF_MIPI_HSI_CTRL_DMA_DISABLE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field CLKGATE[30] (RW)
 *
 * This bit must be set to zero for normal operation. When set to one it gates
 * off the clocks to the block.
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_CLKGATE (30U)     /*!< Bit position for MIPI_HSI_CTRL_CLKGATE. */
#define BM_MIPI_HSI_CTRL_CLKGATE (0x40000000U) /*!< Bit mask for MIPI_HSI_CTRL_CLKGATE. */
#define BS_MIPI_HSI_CTRL_CLKGATE (1U)      /*!< Bit field size in bits for MIPI_HSI_CTRL_CLKGATE. */

/*! @brief Read current value of the MIPI_HSI_CTRL_CLKGATE field. */
#define BR_MIPI_HSI_CTRL_CLKGATE(x) (HW_MIPI_HSI_CTRL(x).B.CLKGATE)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_CLKGATE. */
#define BF_MIPI_HSI_CTRL_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_CLKGATE) & BM_MIPI_HSI_CTRL_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_MIPI_HSI_CTRL_CLKGATE(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_CLKGATE) | BF_MIPI_HSI_CTRL_CLKGATE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_CTRL, field SFTRST[31] (RW)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one
 * (default) to disable clocking with the HSI and hold it in its reset (lowest power)
 * state. This bit can be turned on and then off to reset the HSI block to its
 * default state.
 */
/*@{*/
#define BP_MIPI_HSI_CTRL_SFTRST (31U)      /*!< Bit position for MIPI_HSI_CTRL_SFTRST. */
#define BM_MIPI_HSI_CTRL_SFTRST (0x80000000U) /*!< Bit mask for MIPI_HSI_CTRL_SFTRST. */
#define BS_MIPI_HSI_CTRL_SFTRST (1U)       /*!< Bit field size in bits for MIPI_HSI_CTRL_SFTRST. */

/*! @brief Read current value of the MIPI_HSI_CTRL_SFTRST field. */
#define BR_MIPI_HSI_CTRL_SFTRST(x) (HW_MIPI_HSI_CTRL(x).B.SFTRST)

/*! @brief Format value for bitfield MIPI_HSI_CTRL_SFTRST. */
#define BF_MIPI_HSI_CTRL_SFTRST(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CTRL_SFTRST) & BM_MIPI_HSI_CTRL_SFTRST)

/*! @brief Set the SFTRST field to a new value. */
#define BW_MIPI_HSI_CTRL_SFTRST(x, v) (HW_MIPI_HSI_CTRL_WR(x, (HW_MIPI_HSI_CTRL_RD(x) & ~BM_MIPI_HSI_CTRL_SFTRST) | BF_MIPI_HSI_CTRL_SFTRST(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_CONF - HSI Tx Config Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_CONF - HSI Tx Config Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the configurations of tx channel enable/disable, tx
 * wakup and tx trans mode.
 */
typedef union _hw_mipi_hsi_tx_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_conf_bitfields
    {
        uint32_t TRANS_MODE : 1;       /*!< [0]  */
        uint32_t WAKEUP : 1;           /*!< [1]  */
        uint32_t RESERVED0 : 6;        /*!< [7:2]  */
        uint32_t TIMEOUT_CNT : 4;      /*!< [11:8]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t CH0_EN : 1;           /*!< [16]  */
        uint32_t CH1_EN : 1;           /*!< [17]  */
        uint32_t CH2_EN : 1;           /*!< [18]  */
        uint32_t CH3_EN : 1;           /*!< [19]  */
        uint32_t CH4_EN : 1;           /*!< [20]  */
        uint32_t CH5_EN : 1;           /*!< [21]  */
        uint32_t CH6_EN : 1;           /*!< [22]  */
        uint32_t CH7_EN : 1;           /*!< [23]  */
        uint32_t CH8_EN : 1;           /*!< [24]  */
        uint32_t CH9_EN : 1;           /*!< [25]  */
        uint32_t CH10_EN : 1;          /*!< [26]  */
        uint32_t CH11_EN : 1;          /*!< [27]  */
        uint32_t CH12_EN : 1;          /*!< [28]  */
        uint32_t CH13_EN : 1;          /*!< [29]  */
        uint32_t CH14_EN : 1;          /*!< [30]  */
        uint32_t CH15_EN : 1;          /*!< [31]  */
    } B;
} hw_mipi_hsi_tx_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_TX_CONF_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_MIPI_HSI_TX_CONF(x)   (*(__IO hw_mipi_hsi_tx_conf_t *) HW_MIPI_HSI_TX_CONF_ADDR(x))
#define HW_MIPI_HSI_TX_CONF_RD(x) (HW_MIPI_HSI_TX_CONF(x).U)
#define HW_MIPI_HSI_TX_CONF_WR(x, v) (HW_MIPI_HSI_TX_CONF(x).U = (v))
#define HW_MIPI_HSI_TX_CONF_SET(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, HW_MIPI_HSI_TX_CONF_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_CONF_CLR(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, HW_MIPI_HSI_TX_CONF_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_CONF_TOG(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, HW_MIPI_HSI_TX_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_CONF, field TRANS_MODE[0] (RW)
 *
 * Values:
 * - 0 - Stream Transmission Mode
 * - 1 - Frame Transmission Mode
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_TRANS_MODE (0U) /*!< Bit position for MIPI_HSI_TX_CONF_TRANS_MODE. */
#define BM_MIPI_HSI_TX_CONF_TRANS_MODE (0x00000001U) /*!< Bit mask for MIPI_HSI_TX_CONF_TRANS_MODE. */
#define BS_MIPI_HSI_TX_CONF_TRANS_MODE (1U) /*!< Bit field size in bits for MIPI_HSI_TX_CONF_TRANS_MODE. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_TRANS_MODE field. */
#define BR_MIPI_HSI_TX_CONF_TRANS_MODE(x) (HW_MIPI_HSI_TX_CONF(x).B.TRANS_MODE)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_TRANS_MODE. */
#define BF_MIPI_HSI_TX_CONF_TRANS_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_TRANS_MODE) & BM_MIPI_HSI_TX_CONF_TRANS_MODE)

/*! @brief Set the TRANS_MODE field to a new value. */
#define BW_MIPI_HSI_TX_CONF_TRANS_MODE(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_TRANS_MODE) | BF_MIPI_HSI_TX_CONF_TRANS_MODE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field WAKEUP[1] (RW)
 *
 * When this bit gets set to one, HSI transmitter sends HSI_TX_WAKE signal to Rx
 * of other device. For a transmit operation this bit should be one.
 *
 * Values:
 * - 0 - Transmitter is in Sleep State
 * - 1 - Transmitter is in Wakeup State.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_WAKEUP (1U)    /*!< Bit position for MIPI_HSI_TX_CONF_WAKEUP. */
#define BM_MIPI_HSI_TX_CONF_WAKEUP (0x00000002U) /*!< Bit mask for MIPI_HSI_TX_CONF_WAKEUP. */
#define BS_MIPI_HSI_TX_CONF_WAKEUP (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_WAKEUP. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_WAKEUP field. */
#define BR_MIPI_HSI_TX_CONF_WAKEUP(x) (HW_MIPI_HSI_TX_CONF(x).B.WAKEUP)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_WAKEUP. */
#define BF_MIPI_HSI_TX_CONF_WAKEUP(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_WAKEUP) & BM_MIPI_HSI_TX_CONF_WAKEUP)

/*! @brief Set the WAKEUP field to a new value. */
#define BW_MIPI_HSI_TX_CONF_WAKEUP(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_WAKEUP) | BF_MIPI_HSI_TX_CONF_WAKEUP(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field TIMEOUT_CNT[11:8] (RW)
 *
 * Values:
 * - 0000 - tx timeout value 2^14 tx_refclk
 * - 0001 - tx timeout value 2^15 tx_refclk
 * - 0010 - tx timeout value 2^16 tx_refclk
 * - 0011 - tx timeout value 2^17 tx_refclk
 * - 1110 - tx timeout value 2^28 tx_refclk
 * - 1111 - tx timeout value 2^29 tx_refclk
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_TIMEOUT_CNT (8U) /*!< Bit position for MIPI_HSI_TX_CONF_TIMEOUT_CNT. */
#define BM_MIPI_HSI_TX_CONF_TIMEOUT_CNT (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_CONF_TIMEOUT_CNT. */
#define BS_MIPI_HSI_TX_CONF_TIMEOUT_CNT (4U) /*!< Bit field size in bits for MIPI_HSI_TX_CONF_TIMEOUT_CNT. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_TIMEOUT_CNT field. */
#define BR_MIPI_HSI_TX_CONF_TIMEOUT_CNT(x) (HW_MIPI_HSI_TX_CONF(x).B.TIMEOUT_CNT)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_TIMEOUT_CNT. */
#define BF_MIPI_HSI_TX_CONF_TIMEOUT_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_TIMEOUT_CNT) & BM_MIPI_HSI_TX_CONF_TIMEOUT_CNT)

/*! @brief Set the TIMEOUT_CNT field to a new value. */
#define BW_MIPI_HSI_TX_CONF_TIMEOUT_CNT(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_TIMEOUT_CNT) | BF_MIPI_HSI_TX_CONF_TIMEOUT_CNT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH0_EN[16] (RW)
 *
 * Values:
 * - 1 - Tx Ch0 is Enabled.
 * - 0 - Tx Ch0 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH0_EN (16U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH0_EN. */
#define BM_MIPI_HSI_TX_CONF_CH0_EN (0x00010000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH0_EN. */
#define BS_MIPI_HSI_TX_CONF_CH0_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH0_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH0_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH0_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH0_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH0_EN. */
#define BF_MIPI_HSI_TX_CONF_CH0_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH0_EN) & BM_MIPI_HSI_TX_CONF_CH0_EN)

/*! @brief Set the CH0_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH0_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH0_EN) | BF_MIPI_HSI_TX_CONF_CH0_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH1_EN[17] (RW)
 *
 * Values:
 * - 1 - Tx Ch1 is Enabled.
 * - 0 - Tx Ch1 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH1_EN (17U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH1_EN. */
#define BM_MIPI_HSI_TX_CONF_CH1_EN (0x00020000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH1_EN. */
#define BS_MIPI_HSI_TX_CONF_CH1_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH1_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH1_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH1_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH1_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH1_EN. */
#define BF_MIPI_HSI_TX_CONF_CH1_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH1_EN) & BM_MIPI_HSI_TX_CONF_CH1_EN)

/*! @brief Set the CH1_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH1_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH1_EN) | BF_MIPI_HSI_TX_CONF_CH1_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH2_EN[18] (RW)
 *
 * Values:
 * - 1 - Tx Ch2 is Enabled.
 * - 0 - Tx Ch2 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH2_EN (18U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH2_EN. */
#define BM_MIPI_HSI_TX_CONF_CH2_EN (0x00040000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH2_EN. */
#define BS_MIPI_HSI_TX_CONF_CH2_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH2_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH2_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH2_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH2_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH2_EN. */
#define BF_MIPI_HSI_TX_CONF_CH2_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH2_EN) & BM_MIPI_HSI_TX_CONF_CH2_EN)

/*! @brief Set the CH2_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH2_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH2_EN) | BF_MIPI_HSI_TX_CONF_CH2_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH3_EN[19] (RW)
 *
 * Values:
 * - 1 - Tx Ch3 is Enabled.
 * - 0 - Tx Ch3 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH3_EN (19U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH3_EN. */
#define BM_MIPI_HSI_TX_CONF_CH3_EN (0x00080000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH3_EN. */
#define BS_MIPI_HSI_TX_CONF_CH3_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH3_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH3_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH3_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH3_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH3_EN. */
#define BF_MIPI_HSI_TX_CONF_CH3_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH3_EN) & BM_MIPI_HSI_TX_CONF_CH3_EN)

/*! @brief Set the CH3_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH3_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH3_EN) | BF_MIPI_HSI_TX_CONF_CH3_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH4_EN[20] (RW)
 *
 * Values:
 * - 1 - Tx Ch4 is Enabled.
 * - 0 - Tx Ch4 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH4_EN (20U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH4_EN. */
#define BM_MIPI_HSI_TX_CONF_CH4_EN (0x00100000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH4_EN. */
#define BS_MIPI_HSI_TX_CONF_CH4_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH4_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH4_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH4_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH4_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH4_EN. */
#define BF_MIPI_HSI_TX_CONF_CH4_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH4_EN) & BM_MIPI_HSI_TX_CONF_CH4_EN)

/*! @brief Set the CH4_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH4_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH4_EN) | BF_MIPI_HSI_TX_CONF_CH4_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH5_EN[21] (RW)
 *
 * Values:
 * - 1 - Tx Ch5 is Enabled.
 * - 0 - Tx Ch5 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH5_EN (21U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH5_EN. */
#define BM_MIPI_HSI_TX_CONF_CH5_EN (0x00200000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH5_EN. */
#define BS_MIPI_HSI_TX_CONF_CH5_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH5_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH5_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH5_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH5_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH5_EN. */
#define BF_MIPI_HSI_TX_CONF_CH5_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH5_EN) & BM_MIPI_HSI_TX_CONF_CH5_EN)

/*! @brief Set the CH5_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH5_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH5_EN) | BF_MIPI_HSI_TX_CONF_CH5_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH6_EN[22] (RW)
 *
 * Values:
 * - 1 - Tx Ch6 is Enabled.
 * - 0 - Tx Ch6 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH6_EN (22U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH6_EN. */
#define BM_MIPI_HSI_TX_CONF_CH6_EN (0x00400000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH6_EN. */
#define BS_MIPI_HSI_TX_CONF_CH6_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH6_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH6_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH6_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH6_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH6_EN. */
#define BF_MIPI_HSI_TX_CONF_CH6_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH6_EN) & BM_MIPI_HSI_TX_CONF_CH6_EN)

/*! @brief Set the CH6_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH6_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH6_EN) | BF_MIPI_HSI_TX_CONF_CH6_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH7_EN[23] (RW)
 *
 * Values:
 * - 1 - Tx Ch7 is Enabled.
 * - 0 - Tx Ch7 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH7_EN (23U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH7_EN. */
#define BM_MIPI_HSI_TX_CONF_CH7_EN (0x00800000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH7_EN. */
#define BS_MIPI_HSI_TX_CONF_CH7_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH7_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH7_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH7_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH7_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH7_EN. */
#define BF_MIPI_HSI_TX_CONF_CH7_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH7_EN) & BM_MIPI_HSI_TX_CONF_CH7_EN)

/*! @brief Set the CH7_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH7_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH7_EN) | BF_MIPI_HSI_TX_CONF_CH7_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH8_EN[24] (RW)
 *
 * Values:
 * - 1 - Tx Ch8 is Enabled.
 * - 0 - Tx Ch8 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH8_EN (24U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH8_EN. */
#define BM_MIPI_HSI_TX_CONF_CH8_EN (0x01000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH8_EN. */
#define BS_MIPI_HSI_TX_CONF_CH8_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH8_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH8_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH8_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH8_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH8_EN. */
#define BF_MIPI_HSI_TX_CONF_CH8_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH8_EN) & BM_MIPI_HSI_TX_CONF_CH8_EN)

/*! @brief Set the CH8_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH8_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH8_EN) | BF_MIPI_HSI_TX_CONF_CH8_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH9_EN[25] (RW)
 *
 * Values:
 * - 1 - Tx Ch9 is Enabled.
 * - 0 - Tx Ch9 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH9_EN (25U)   /*!< Bit position for MIPI_HSI_TX_CONF_CH9_EN. */
#define BM_MIPI_HSI_TX_CONF_CH9_EN (0x02000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH9_EN. */
#define BS_MIPI_HSI_TX_CONF_CH9_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH9_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH9_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH9_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH9_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH9_EN. */
#define BF_MIPI_HSI_TX_CONF_CH9_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH9_EN) & BM_MIPI_HSI_TX_CONF_CH9_EN)

/*! @brief Set the CH9_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH9_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH9_EN) | BF_MIPI_HSI_TX_CONF_CH9_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH10_EN[26] (RW)
 *
 * Values:
 * - 1 - Tx Ch10 is Enabled.
 * - 0 - Tx Ch10 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH10_EN (26U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH10_EN. */
#define BM_MIPI_HSI_TX_CONF_CH10_EN (0x04000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH10_EN. */
#define BS_MIPI_HSI_TX_CONF_CH10_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH10_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH10_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH10_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH10_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH10_EN. */
#define BF_MIPI_HSI_TX_CONF_CH10_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH10_EN) & BM_MIPI_HSI_TX_CONF_CH10_EN)

/*! @brief Set the CH10_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH10_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH10_EN) | BF_MIPI_HSI_TX_CONF_CH10_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH11_EN[27] (RW)
 *
 * Values:
 * - 1 - Tx Ch11 is Enabled.
 * - 0 - Tx Ch11 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH11_EN (27U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH11_EN. */
#define BM_MIPI_HSI_TX_CONF_CH11_EN (0x08000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH11_EN. */
#define BS_MIPI_HSI_TX_CONF_CH11_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH11_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH11_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH11_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH11_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH11_EN. */
#define BF_MIPI_HSI_TX_CONF_CH11_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH11_EN) & BM_MIPI_HSI_TX_CONF_CH11_EN)

/*! @brief Set the CH11_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH11_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH11_EN) | BF_MIPI_HSI_TX_CONF_CH11_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH12_EN[28] (RW)
 *
 * Values:
 * - 1 - Tx Ch12 is Enabled.
 * - 0 - Tx Ch12 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH12_EN (28U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH12_EN. */
#define BM_MIPI_HSI_TX_CONF_CH12_EN (0x10000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH12_EN. */
#define BS_MIPI_HSI_TX_CONF_CH12_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH12_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH12_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH12_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH12_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH12_EN. */
#define BF_MIPI_HSI_TX_CONF_CH12_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH12_EN) & BM_MIPI_HSI_TX_CONF_CH12_EN)

/*! @brief Set the CH12_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH12_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH12_EN) | BF_MIPI_HSI_TX_CONF_CH12_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH13_EN[29] (RW)
 *
 * Values:
 * - 1 - Tx Ch13 is Enabled.
 * - 0 - Tx Ch13 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH13_EN (29U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH13_EN. */
#define BM_MIPI_HSI_TX_CONF_CH13_EN (0x20000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH13_EN. */
#define BS_MIPI_HSI_TX_CONF_CH13_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH13_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH13_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH13_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH13_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH13_EN. */
#define BF_MIPI_HSI_TX_CONF_CH13_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH13_EN) & BM_MIPI_HSI_TX_CONF_CH13_EN)

/*! @brief Set the CH13_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH13_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH13_EN) | BF_MIPI_HSI_TX_CONF_CH13_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH14_EN[30] (RW)
 *
 * Values:
 * - 1 - Tx Ch14 is Enabled.
 * - 0 - Tx Ch14 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH14_EN (30U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH14_EN. */
#define BM_MIPI_HSI_TX_CONF_CH14_EN (0x40000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH14_EN. */
#define BS_MIPI_HSI_TX_CONF_CH14_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH14_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH14_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH14_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH14_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH14_EN. */
#define BF_MIPI_HSI_TX_CONF_CH14_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH14_EN) & BM_MIPI_HSI_TX_CONF_CH14_EN)

/*! @brief Set the CH14_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH14_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH14_EN) | BF_MIPI_HSI_TX_CONF_CH14_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_CONF, field CH15_EN[31] (RW)
 *
 * Values:
 * - 1 - Tx Ch15 is Enabled.
 * - 0 - Tx Ch15 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CONF_CH15_EN (31U)  /*!< Bit position for MIPI_HSI_TX_CONF_CH15_EN. */
#define BM_MIPI_HSI_TX_CONF_CH15_EN (0x80000000U) /*!< Bit mask for MIPI_HSI_TX_CONF_CH15_EN. */
#define BS_MIPI_HSI_TX_CONF_CH15_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_TX_CONF_CH15_EN. */

/*! @brief Read current value of the MIPI_HSI_TX_CONF_CH15_EN field. */
#define BR_MIPI_HSI_TX_CONF_CH15_EN(x) (HW_MIPI_HSI_TX_CONF(x).B.CH15_EN)

/*! @brief Format value for bitfield MIPI_HSI_TX_CONF_CH15_EN. */
#define BF_MIPI_HSI_TX_CONF_CH15_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CONF_CH15_EN) & BM_MIPI_HSI_TX_CONF_CH15_EN)

/*! @brief Set the CH15_EN field to a new value. */
#define BW_MIPI_HSI_TX_CONF_CH15_EN(x, v) (HW_MIPI_HSI_TX_CONF_WR(x, (HW_MIPI_HSI_TX_CONF_RD(x) & ~BM_MIPI_HSI_TX_CONF_CH15_EN) | BF_MIPI_HSI_TX_CONF_CH15_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RX_CONF - HSI Rx Config Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RX_CONF - HSI Rx Config Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the configurations of rx channel enable/disable, rx
 * wakup and rx trans mode, rx data flow.
 */
typedef union _hw_mipi_hsi_rx_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_rx_conf_bitfields
    {
        uint32_t DATA_FLOW : 2;        /*!< [1:0]  */
        uint32_t WAKE : 1;             /*!< [2]  */
        uint32_t REC_MODE : 1;         /*!< [3]  */
        uint32_t TAIL_BIT_CNT_EN : 1;  /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t TIMEOUT_CNT : 7;      /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t CH0_EN : 1;           /*!< [16]  */
        uint32_t CH1_EN : 1;           /*!< [17]  */
        uint32_t CH2_EN : 1;           /*!< [18]  */
        uint32_t CH3_EN : 1;           /*!< [19]  */
        uint32_t CH4_EN : 1;           /*!< [20]  */
        uint32_t CH5_EN : 1;           /*!< [21]  */
        uint32_t CH6_EN : 1;           /*!< [22]  */
        uint32_t CH7_EN : 1;           /*!< [23]  */
        uint32_t CH8_EN : 1;           /*!< [24]  */
        uint32_t CH9_EN : 1;           /*!< [25]  */
        uint32_t CH10_EN : 1;          /*!< [26]  */
        uint32_t CH11_EN : 1;          /*!< [27]  */
        uint32_t CH12_EN : 1;          /*!< [28]  */
        uint32_t CH13_EN : 1;          /*!< [29]  */
        uint32_t CH14_EN : 1;          /*!< [30]  */
        uint32_t CH15_EN : 1;          /*!< [31]  */
    } B;
} hw_mipi_hsi_rx_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RX_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_RX_CONF_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_MIPI_HSI_RX_CONF(x)   (*(__IO hw_mipi_hsi_rx_conf_t *) HW_MIPI_HSI_RX_CONF_ADDR(x))
#define HW_MIPI_HSI_RX_CONF_RD(x) (HW_MIPI_HSI_RX_CONF(x).U)
#define HW_MIPI_HSI_RX_CONF_WR(x, v) (HW_MIPI_HSI_RX_CONF(x).U = (v))
#define HW_MIPI_HSI_RX_CONF_SET(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, HW_MIPI_HSI_RX_CONF_RD(x) |  (v)))
#define HW_MIPI_HSI_RX_CONF_CLR(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, HW_MIPI_HSI_RX_CONF_RD(x) & ~(v)))
#define HW_MIPI_HSI_RX_CONF_TOG(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, HW_MIPI_HSI_RX_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RX_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_RX_CONF, field DATA_FLOW[1:0] (RW)
 *
 * Values:
 * - 00 - Synchronized Data Flow
 * - 01 - Pipelined Data Flow
 * - 10 - Receiver Real-time Data Flow
 * - 11 - Reserved
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_DATA_FLOW (0U) /*!< Bit position for MIPI_HSI_RX_CONF_DATA_FLOW. */
#define BM_MIPI_HSI_RX_CONF_DATA_FLOW (0x00000003U) /*!< Bit mask for MIPI_HSI_RX_CONF_DATA_FLOW. */
#define BS_MIPI_HSI_RX_CONF_DATA_FLOW (2U) /*!< Bit field size in bits for MIPI_HSI_RX_CONF_DATA_FLOW. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_DATA_FLOW field. */
#define BR_MIPI_HSI_RX_CONF_DATA_FLOW(x) (HW_MIPI_HSI_RX_CONF(x).B.DATA_FLOW)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_DATA_FLOW. */
#define BF_MIPI_HSI_RX_CONF_DATA_FLOW(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_DATA_FLOW) & BM_MIPI_HSI_RX_CONF_DATA_FLOW)

/*! @brief Set the DATA_FLOW field to a new value. */
#define BW_MIPI_HSI_RX_CONF_DATA_FLOW(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_DATA_FLOW) | BF_MIPI_HSI_RX_CONF_DATA_FLOW(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field WAKE[2] (RW)
 *
 * Values:
 * - 0 - Receiver is in Sleep State
 * - 1 - Receiver is in Wakeup State
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_WAKE (2U)      /*!< Bit position for MIPI_HSI_RX_CONF_WAKE. */
#define BM_MIPI_HSI_RX_CONF_WAKE (0x00000004U) /*!< Bit mask for MIPI_HSI_RX_CONF_WAKE. */
#define BS_MIPI_HSI_RX_CONF_WAKE (1U)      /*!< Bit field size in bits for MIPI_HSI_RX_CONF_WAKE. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_WAKE field. */
#define BR_MIPI_HSI_RX_CONF_WAKE(x) (HW_MIPI_HSI_RX_CONF(x).B.WAKE)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_WAKE. */
#define BF_MIPI_HSI_RX_CONF_WAKE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_WAKE) & BM_MIPI_HSI_RX_CONF_WAKE)

/*! @brief Set the WAKE field to a new value. */
#define BW_MIPI_HSI_RX_CONF_WAKE(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_WAKE) | BF_MIPI_HSI_RX_CONF_WAKE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field REC_MODE[3] (RW)
 *
 * Values:
 * - 0 - Stream Receive Mode
 * - 1 - Frame Receive Mode
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_REC_MODE (3U)  /*!< Bit position for MIPI_HSI_RX_CONF_REC_MODE. */
#define BM_MIPI_HSI_RX_CONF_REC_MODE (0x00000008U) /*!< Bit mask for MIPI_HSI_RX_CONF_REC_MODE. */
#define BS_MIPI_HSI_RX_CONF_REC_MODE (1U)  /*!< Bit field size in bits for MIPI_HSI_RX_CONF_REC_MODE. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_REC_MODE field. */
#define BR_MIPI_HSI_RX_CONF_REC_MODE(x) (HW_MIPI_HSI_RX_CONF(x).B.REC_MODE)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_REC_MODE. */
#define BF_MIPI_HSI_RX_CONF_REC_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_REC_MODE) & BM_MIPI_HSI_RX_CONF_REC_MODE)

/*! @brief Set the REC_MODE field to a new value. */
#define BW_MIPI_HSI_RX_CONF_REC_MODE(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_REC_MODE) | BF_MIPI_HSI_RX_CONF_REC_MODE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field TAIL_BIT_CNT_EN[4] (RW)
 *
 * Values:
 * - 0 - Tailing bit counter disable
 * - 1 - Tailing bit counter Enable
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN (4U) /*!< Bit position for MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN. */
#define BM_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN (0x00000010U) /*!< Bit mask for MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN. */
#define BS_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN field. */
#define BR_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.TAIL_BIT_CNT_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN. */
#define BF_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN) & BM_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN)

/*! @brief Set the TAIL_BIT_CNT_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN) | BF_MIPI_HSI_RX_CONF_TAIL_BIT_CNT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field TIMEOUT_CNT[14:8] (RW)
 *
 * Receive Frame Timeout Counter: The counter shall be started when the first
 * bit of the Frame has been found. The counter shall be stopped once the receiver
 * has received the correct number of bits for a Frame. If the counter expires
 * before Frame reception is completed, the receiver will signal to the protocol
 * layer that it has found an incomplete Frame and asserts Rx Error Interrupt. 7'h0
 * 14800 ---> tx_refclk 7'h1 16400 ---> tx_refclk 7'h2 18000 ---> tx_refclk 7'h4
 * 19600 ---> tx_refclk 7'h8 21200 ---> tx_refclk 7'h10 22800 ---> tx_refclk
 * 7'h20 24400 ---> tx_refclk 7'h40 26000 ---> tx_refclk
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_TIMEOUT_CNT (8U) /*!< Bit position for MIPI_HSI_RX_CONF_TIMEOUT_CNT. */
#define BM_MIPI_HSI_RX_CONF_TIMEOUT_CNT (0x00007F00U) /*!< Bit mask for MIPI_HSI_RX_CONF_TIMEOUT_CNT. */
#define BS_MIPI_HSI_RX_CONF_TIMEOUT_CNT (7U) /*!< Bit field size in bits for MIPI_HSI_RX_CONF_TIMEOUT_CNT. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_TIMEOUT_CNT field. */
#define BR_MIPI_HSI_RX_CONF_TIMEOUT_CNT(x) (HW_MIPI_HSI_RX_CONF(x).B.TIMEOUT_CNT)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_TIMEOUT_CNT. */
#define BF_MIPI_HSI_RX_CONF_TIMEOUT_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_TIMEOUT_CNT) & BM_MIPI_HSI_RX_CONF_TIMEOUT_CNT)

/*! @brief Set the TIMEOUT_CNT field to a new value. */
#define BW_MIPI_HSI_RX_CONF_TIMEOUT_CNT(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_TIMEOUT_CNT) | BF_MIPI_HSI_RX_CONF_TIMEOUT_CNT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH0_EN[16] (RW)
 *
 * Values:
 * - 1 - Rx Ch0 is Enabled.
 * - 0 - Rx Ch0 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH0_EN (16U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH0_EN. */
#define BM_MIPI_HSI_RX_CONF_CH0_EN (0x00010000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH0_EN. */
#define BS_MIPI_HSI_RX_CONF_CH0_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH0_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH0_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH0_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH0_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH0_EN. */
#define BF_MIPI_HSI_RX_CONF_CH0_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH0_EN) & BM_MIPI_HSI_RX_CONF_CH0_EN)

/*! @brief Set the CH0_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH0_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH0_EN) | BF_MIPI_HSI_RX_CONF_CH0_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH1_EN[17] (RW)
 *
 * Values:
 * - 1 - Rx Ch1 is Enabled.
 * - 0 - Rx Ch1 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH1_EN (17U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH1_EN. */
#define BM_MIPI_HSI_RX_CONF_CH1_EN (0x00020000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH1_EN. */
#define BS_MIPI_HSI_RX_CONF_CH1_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH1_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH1_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH1_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH1_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH1_EN. */
#define BF_MIPI_HSI_RX_CONF_CH1_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH1_EN) & BM_MIPI_HSI_RX_CONF_CH1_EN)

/*! @brief Set the CH1_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH1_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH1_EN) | BF_MIPI_HSI_RX_CONF_CH1_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH2_EN[18] (RW)
 *
 * Values:
 * - 1 - Rx Ch2 is Enabled.
 * - 0 - Rx Ch2 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH2_EN (18U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH2_EN. */
#define BM_MIPI_HSI_RX_CONF_CH2_EN (0x00040000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH2_EN. */
#define BS_MIPI_HSI_RX_CONF_CH2_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH2_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH2_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH2_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH2_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH2_EN. */
#define BF_MIPI_HSI_RX_CONF_CH2_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH2_EN) & BM_MIPI_HSI_RX_CONF_CH2_EN)

/*! @brief Set the CH2_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH2_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH2_EN) | BF_MIPI_HSI_RX_CONF_CH2_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH3_EN[19] (RW)
 *
 * Values:
 * - 1 - Rx Ch3 is Enabled.
 * - 0 - Rx Ch3 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH3_EN (19U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH3_EN. */
#define BM_MIPI_HSI_RX_CONF_CH3_EN (0x00080000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH3_EN. */
#define BS_MIPI_HSI_RX_CONF_CH3_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH3_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH3_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH3_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH3_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH3_EN. */
#define BF_MIPI_HSI_RX_CONF_CH3_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH3_EN) & BM_MIPI_HSI_RX_CONF_CH3_EN)

/*! @brief Set the CH3_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH3_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH3_EN) | BF_MIPI_HSI_RX_CONF_CH3_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH4_EN[20] (RW)
 *
 * Values:
 * - 1 - Rx Ch4 is Enabled.
 * - 0 - Rx Ch4 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH4_EN (20U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH4_EN. */
#define BM_MIPI_HSI_RX_CONF_CH4_EN (0x00100000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH4_EN. */
#define BS_MIPI_HSI_RX_CONF_CH4_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH4_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH4_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH4_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH4_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH4_EN. */
#define BF_MIPI_HSI_RX_CONF_CH4_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH4_EN) & BM_MIPI_HSI_RX_CONF_CH4_EN)

/*! @brief Set the CH4_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH4_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH4_EN) | BF_MIPI_HSI_RX_CONF_CH4_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH5_EN[21] (RW)
 *
 * Values:
 * - 1 - Rx Ch5 is Enabled.
 * - 0 - Rx Ch5 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH5_EN (21U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH5_EN. */
#define BM_MIPI_HSI_RX_CONF_CH5_EN (0x00200000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH5_EN. */
#define BS_MIPI_HSI_RX_CONF_CH5_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH5_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH5_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH5_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH5_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH5_EN. */
#define BF_MIPI_HSI_RX_CONF_CH5_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH5_EN) & BM_MIPI_HSI_RX_CONF_CH5_EN)

/*! @brief Set the CH5_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH5_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH5_EN) | BF_MIPI_HSI_RX_CONF_CH5_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH6_EN[22] (RW)
 *
 * Values:
 * - 1 - Rx Ch6 is Enabled.
 * - 0 - Rx Ch6 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH6_EN (22U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH6_EN. */
#define BM_MIPI_HSI_RX_CONF_CH6_EN (0x00400000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH6_EN. */
#define BS_MIPI_HSI_RX_CONF_CH6_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH6_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH6_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH6_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH6_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH6_EN. */
#define BF_MIPI_HSI_RX_CONF_CH6_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH6_EN) & BM_MIPI_HSI_RX_CONF_CH6_EN)

/*! @brief Set the CH6_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH6_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH6_EN) | BF_MIPI_HSI_RX_CONF_CH6_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH7_EN[23] (RW)
 *
 * Values:
 * - 1 - Rx Ch7 is Enabled.
 * - 0 - Rx Ch7 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH7_EN (23U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH7_EN. */
#define BM_MIPI_HSI_RX_CONF_CH7_EN (0x00800000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH7_EN. */
#define BS_MIPI_HSI_RX_CONF_CH7_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH7_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH7_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH7_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH7_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH7_EN. */
#define BF_MIPI_HSI_RX_CONF_CH7_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH7_EN) & BM_MIPI_HSI_RX_CONF_CH7_EN)

/*! @brief Set the CH7_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH7_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH7_EN) | BF_MIPI_HSI_RX_CONF_CH7_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH8_EN[24] (RW)
 *
 * Values:
 * - 1 - Rx Ch8 is Enabled.
 * - 0 - Rx Ch8 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH8_EN (24U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH8_EN. */
#define BM_MIPI_HSI_RX_CONF_CH8_EN (0x01000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH8_EN. */
#define BS_MIPI_HSI_RX_CONF_CH8_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH8_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH8_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH8_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH8_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH8_EN. */
#define BF_MIPI_HSI_RX_CONF_CH8_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH8_EN) & BM_MIPI_HSI_RX_CONF_CH8_EN)

/*! @brief Set the CH8_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH8_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH8_EN) | BF_MIPI_HSI_RX_CONF_CH8_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH9_EN[25] (RW)
 *
 * Values:
 * - 1 - Rx Ch9 is Enabled.
 * - 0 - Rx Ch9 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH9_EN (25U)   /*!< Bit position for MIPI_HSI_RX_CONF_CH9_EN. */
#define BM_MIPI_HSI_RX_CONF_CH9_EN (0x02000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH9_EN. */
#define BS_MIPI_HSI_RX_CONF_CH9_EN (1U)    /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH9_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH9_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH9_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH9_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH9_EN. */
#define BF_MIPI_HSI_RX_CONF_CH9_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH9_EN) & BM_MIPI_HSI_RX_CONF_CH9_EN)

/*! @brief Set the CH9_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH9_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH9_EN) | BF_MIPI_HSI_RX_CONF_CH9_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH10_EN[26] (RW)
 *
 * Values:
 * - 1 - Rx Ch10 is Enabled.
 * - 0 - Rx Ch10 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH10_EN (26U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH10_EN. */
#define BM_MIPI_HSI_RX_CONF_CH10_EN (0x04000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH10_EN. */
#define BS_MIPI_HSI_RX_CONF_CH10_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH10_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH10_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH10_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH10_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH10_EN. */
#define BF_MIPI_HSI_RX_CONF_CH10_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH10_EN) & BM_MIPI_HSI_RX_CONF_CH10_EN)

/*! @brief Set the CH10_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH10_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH10_EN) | BF_MIPI_HSI_RX_CONF_CH10_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH11_EN[27] (RW)
 *
 * Values:
 * - 1 - Rx Ch11 is Enabled.
 * - 0 - Rx Ch11 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH11_EN (27U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH11_EN. */
#define BM_MIPI_HSI_RX_CONF_CH11_EN (0x08000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH11_EN. */
#define BS_MIPI_HSI_RX_CONF_CH11_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH11_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH11_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH11_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH11_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH11_EN. */
#define BF_MIPI_HSI_RX_CONF_CH11_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH11_EN) & BM_MIPI_HSI_RX_CONF_CH11_EN)

/*! @brief Set the CH11_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH11_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH11_EN) | BF_MIPI_HSI_RX_CONF_CH11_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH12_EN[28] (RW)
 *
 * Values:
 * - 1 - Rx Ch12 is Enabled.
 * - 0 - Rx Ch12 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH12_EN (28U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH12_EN. */
#define BM_MIPI_HSI_RX_CONF_CH12_EN (0x10000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH12_EN. */
#define BS_MIPI_HSI_RX_CONF_CH12_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH12_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH12_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH12_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH12_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH12_EN. */
#define BF_MIPI_HSI_RX_CONF_CH12_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH12_EN) & BM_MIPI_HSI_RX_CONF_CH12_EN)

/*! @brief Set the CH12_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH12_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH12_EN) | BF_MIPI_HSI_RX_CONF_CH12_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH13_EN[29] (RW)
 *
 * Values:
 * - 1 - Rx Ch13 is Enabled.
 * - 0 - Rx Ch13 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH13_EN (29U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH13_EN. */
#define BM_MIPI_HSI_RX_CONF_CH13_EN (0x20000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH13_EN. */
#define BS_MIPI_HSI_RX_CONF_CH13_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH13_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH13_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH13_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH13_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH13_EN. */
#define BF_MIPI_HSI_RX_CONF_CH13_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH13_EN) & BM_MIPI_HSI_RX_CONF_CH13_EN)

/*! @brief Set the CH13_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH13_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH13_EN) | BF_MIPI_HSI_RX_CONF_CH13_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH14_EN[30] (RW)
 *
 * Values:
 * - 1 - Rx Ch14 is Enabled.
 * - 0 - Rx Ch14 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH14_EN (30U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH14_EN. */
#define BM_MIPI_HSI_RX_CONF_CH14_EN (0x40000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH14_EN. */
#define BS_MIPI_HSI_RX_CONF_CH14_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH14_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH14_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH14_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH14_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH14_EN. */
#define BF_MIPI_HSI_RX_CONF_CH14_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH14_EN) & BM_MIPI_HSI_RX_CONF_CH14_EN)

/*! @brief Set the CH14_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH14_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH14_EN) | BF_MIPI_HSI_RX_CONF_CH14_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_CONF, field CH15_EN[31] (RW)
 *
 * Values:
 * - 1 - Rx Ch15 is Enabled.
 * - 0 - Rx Ch15 is Disabled.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CONF_CH15_EN (31U)  /*!< Bit position for MIPI_HSI_RX_CONF_CH15_EN. */
#define BM_MIPI_HSI_RX_CONF_CH15_EN (0x80000000U) /*!< Bit mask for MIPI_HSI_RX_CONF_CH15_EN. */
#define BS_MIPI_HSI_RX_CONF_CH15_EN (1U)   /*!< Bit field size in bits for MIPI_HSI_RX_CONF_CH15_EN. */

/*! @brief Read current value of the MIPI_HSI_RX_CONF_CH15_EN field. */
#define BR_MIPI_HSI_RX_CONF_CH15_EN(x) (HW_MIPI_HSI_RX_CONF(x).B.CH15_EN)

/*! @brief Format value for bitfield MIPI_HSI_RX_CONF_CH15_EN. */
#define BF_MIPI_HSI_RX_CONF_CH15_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CONF_CH15_EN) & BM_MIPI_HSI_RX_CONF_CH15_EN)

/*! @brief Set the CH15_EN field to a new value. */
#define BW_MIPI_HSI_RX_CONF_CH15_EN(x, v) (HW_MIPI_HSI_RX_CONF_WR(x, (HW_MIPI_HSI_RX_CONF_RD(x) & ~BM_MIPI_HSI_RX_CONF_CH15_EN) | BF_MIPI_HSI_RX_CONF_CH15_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_CAP - HSI Capability Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_CAP - HSI Capability Register (RO)
 *
 * Reset value: 0x00071FFFU
 *
 * This register contains the HSI controller Capability information.
 */
typedef union _hw_mipi_hsi_cap
{
    uint32_t U;
    struct _hw_mipi_hsi_cap_bitfields
    {
        uint32_t TX_CH_NU_SUPPORTE : 4; /*!< [3:0]  */
        uint32_t RX_CH_NU_SUPPORTE : 4; /*!< [7:4]  */
        uint32_t DMA_CH_NU_SUPPORT : 5; /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t TX_DMA_SUPPORT : 1;   /*!< [16]  */
        uint32_t RX_DMA_SUPPORT : 1;   /*!< [17]  */
        uint32_t WAKEUP_EVENT : 1;     /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_mipi_hsi_cap_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_CAP register
 */
/*@{*/
#define HW_MIPI_HSI_CAP_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_MIPI_HSI_CAP(x)       (*(__I hw_mipi_hsi_cap_t *) HW_MIPI_HSI_CAP_ADDR(x))
#define HW_MIPI_HSI_CAP_RD(x)    (HW_MIPI_HSI_CAP(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_CAP bitfields
 */

/*!
 * @name Register MIPI_HSI_CAP, field TX_CH_NU_SUPPORTE[3:0] (RO)
 *
 * Values:
 * - 0000 - 1 Tx channel supported
 * - 0001 - 2 Tx channels supported
 * - 1111 - 16 Tx channels supported
 */
/*@{*/
#define BP_MIPI_HSI_CAP_TX_CH_NU_SUPPORTE (0U) /*!< Bit position for MIPI_HSI_CAP_TX_CH_NU_SUPPORTE. */
#define BM_MIPI_HSI_CAP_TX_CH_NU_SUPPORTE (0x0000000FU) /*!< Bit mask for MIPI_HSI_CAP_TX_CH_NU_SUPPORTE. */
#define BS_MIPI_HSI_CAP_TX_CH_NU_SUPPORTE (4U) /*!< Bit field size in bits for MIPI_HSI_CAP_TX_CH_NU_SUPPORTE. */

/*! @brief Read current value of the MIPI_HSI_CAP_TX_CH_NU_SUPPORTE field. */
#define BR_MIPI_HSI_CAP_TX_CH_NU_SUPPORTE(x) (HW_MIPI_HSI_CAP(x).B.TX_CH_NU_SUPPORTE)
/*@}*/

/*!
 * @name Register MIPI_HSI_CAP, field RX_CH_NU_SUPPORTE[7:4] (RO)
 *
 * Values:
 * - 0000 - 1 Rx channel supported
 * - 0001 - 2 Rx channels supported
 * - 1111 - 16 Rx channels supported
 */
/*@{*/
#define BP_MIPI_HSI_CAP_RX_CH_NU_SUPPORTE (4U) /*!< Bit position for MIPI_HSI_CAP_RX_CH_NU_SUPPORTE. */
#define BM_MIPI_HSI_CAP_RX_CH_NU_SUPPORTE (0x000000F0U) /*!< Bit mask for MIPI_HSI_CAP_RX_CH_NU_SUPPORTE. */
#define BS_MIPI_HSI_CAP_RX_CH_NU_SUPPORTE (4U) /*!< Bit field size in bits for MIPI_HSI_CAP_RX_CH_NU_SUPPORTE. */

/*! @brief Read current value of the MIPI_HSI_CAP_RX_CH_NU_SUPPORTE field. */
#define BR_MIPI_HSI_CAP_RX_CH_NU_SUPPORTE(x) (HW_MIPI_HSI_CAP(x).B.RX_CH_NU_SUPPORTE)
/*@}*/

/*!
 * @name Register MIPI_HSI_CAP, field DMA_CH_NU_SUPPORT[12:8] (RO)
 *
 * Values:
 * - 00000 - 1 DMA supported
 * - 00001 - 2 DMA supported
 * - 00010 - 3 DMA supported
 * - 00011 - 4 DMA supported
 * - 00100 - 5 DMA supported
 * - 00101 - 6 DMA supported
 * - 11110 - 31 DMA supported
 * - 11111 - 32 DMA supported
 */
/*@{*/
#define BP_MIPI_HSI_CAP_DMA_CH_NU_SUPPORT (8U) /*!< Bit position for MIPI_HSI_CAP_DMA_CH_NU_SUPPORT. */
#define BM_MIPI_HSI_CAP_DMA_CH_NU_SUPPORT (0x00001F00U) /*!< Bit mask for MIPI_HSI_CAP_DMA_CH_NU_SUPPORT. */
#define BS_MIPI_HSI_CAP_DMA_CH_NU_SUPPORT (5U) /*!< Bit field size in bits for MIPI_HSI_CAP_DMA_CH_NU_SUPPORT. */

/*! @brief Read current value of the MIPI_HSI_CAP_DMA_CH_NU_SUPPORT field. */
#define BR_MIPI_HSI_CAP_DMA_CH_NU_SUPPORT(x) (HW_MIPI_HSI_CAP(x).B.DMA_CH_NU_SUPPORT)
/*@}*/

/*!
 * @name Register MIPI_HSI_CAP, field TX_DMA_SUPPORT[16] (RO)
 *
 * Values:
 * - 1 - DMA is supported.
 * - 0 - Not supported
 */
/*@{*/
#define BP_MIPI_HSI_CAP_TX_DMA_SUPPORT (16U) /*!< Bit position for MIPI_HSI_CAP_TX_DMA_SUPPORT. */
#define BM_MIPI_HSI_CAP_TX_DMA_SUPPORT (0x00010000U) /*!< Bit mask for MIPI_HSI_CAP_TX_DMA_SUPPORT. */
#define BS_MIPI_HSI_CAP_TX_DMA_SUPPORT (1U) /*!< Bit field size in bits for MIPI_HSI_CAP_TX_DMA_SUPPORT. */

/*! @brief Read current value of the MIPI_HSI_CAP_TX_DMA_SUPPORT field. */
#define BR_MIPI_HSI_CAP_TX_DMA_SUPPORT(x) (HW_MIPI_HSI_CAP(x).B.TX_DMA_SUPPORT)
/*@}*/

/*!
 * @name Register MIPI_HSI_CAP, field RX_DMA_SUPPORT[17] (RO)
 *
 * Values:
 * - 1 - DMA is supported.
 * - 0 - Not supported
 */
/*@{*/
#define BP_MIPI_HSI_CAP_RX_DMA_SUPPORT (17U) /*!< Bit position for MIPI_HSI_CAP_RX_DMA_SUPPORT. */
#define BM_MIPI_HSI_CAP_RX_DMA_SUPPORT (0x00020000U) /*!< Bit mask for MIPI_HSI_CAP_RX_DMA_SUPPORT. */
#define BS_MIPI_HSI_CAP_RX_DMA_SUPPORT (1U) /*!< Bit field size in bits for MIPI_HSI_CAP_RX_DMA_SUPPORT. */

/*! @brief Read current value of the MIPI_HSI_CAP_RX_DMA_SUPPORT field. */
#define BR_MIPI_HSI_CAP_RX_DMA_SUPPORT(x) (HW_MIPI_HSI_CAP(x).B.RX_DMA_SUPPORT)
/*@}*/

/*!
 * @name Register MIPI_HSI_CAP, field WAKEUP_EVENT[18] (RO)
 *
 * Values:
 * - 0 - Wakeup Event is supported
 * - 1 - Wakeup Event is not supported.
 */
/*@{*/
#define BP_MIPI_HSI_CAP_WAKEUP_EVENT (18U) /*!< Bit position for MIPI_HSI_CAP_WAKEUP_EVENT. */
#define BM_MIPI_HSI_CAP_WAKEUP_EVENT (0x00040000U) /*!< Bit mask for MIPI_HSI_CAP_WAKEUP_EVENT. */
#define BS_MIPI_HSI_CAP_WAKEUP_EVENT (1U)  /*!< Bit field size in bits for MIPI_HSI_CAP_WAKEUP_EVENT. */

/*! @brief Read current value of the MIPI_HSI_CAP_WAKEUP_EVENT field. */
#define BR_MIPI_HSI_CAP_WAKEUP_EVENT(x) (HW_MIPI_HSI_CAP(x).B.WAKEUP_EVENT)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_WML0 - HSI Tx Water Mark Level 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_WML0 - HSI Tx Water Mark Level 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains HSI controller Tx channel Water Mark Level information.
 */
typedef union _hw_mipi_hsi_tx_wml0
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_wml0_bitfields
    {
        uint32_t CH8 : 4;              /*!< [3:0]  */
        uint32_t CH9 : 4;              /*!< [7:4]  */
        uint32_t CH10 : 4;             /*!< [11:8]  */
        uint32_t CH11 : 4;             /*!< [15:12]  */
        uint32_t CH12 : 4;             /*!< [19:16]  */
        uint32_t CH13 : 4;             /*!< [23:20]  */
        uint32_t CH14 : 4;             /*!< [27:24]  */
        uint32_t CH15 : 4;             /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_wml0_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_WML0 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_WML0_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_MIPI_HSI_TX_WML0(x)   (*(__IO hw_mipi_hsi_tx_wml0_t *) HW_MIPI_HSI_TX_WML0_ADDR(x))
#define HW_MIPI_HSI_TX_WML0_RD(x) (HW_MIPI_HSI_TX_WML0(x).U)
#define HW_MIPI_HSI_TX_WML0_WR(x, v) (HW_MIPI_HSI_TX_WML0(x).U = (v))
#define HW_MIPI_HSI_TX_WML0_SET(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, HW_MIPI_HSI_TX_WML0_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_WML0_CLR(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, HW_MIPI_HSI_TX_WML0_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_WML0_TOG(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, HW_MIPI_HSI_TX_WML0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_WML0 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH8[3:0] (RW)
 *
 * This value denotes the WML of Tx Channel 8. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH8 (0U)       /*!< Bit position for MIPI_HSI_TX_WML0_CH8. */
#define BM_MIPI_HSI_TX_WML0_CH8 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_WML0_CH8. */
#define BS_MIPI_HSI_TX_WML0_CH8 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH8. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH8 field. */
#define BR_MIPI_HSI_TX_WML0_CH8(x) (HW_MIPI_HSI_TX_WML0(x).B.CH8)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH8. */
#define BF_MIPI_HSI_TX_WML0_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH8) & BM_MIPI_HSI_TX_WML0_CH8)

/*! @brief Set the CH8 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH8(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH8) | BF_MIPI_HSI_TX_WML0_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH9[7:4] (RW)
 *
 * This value denotes the WML of Tx Channel 9. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH9 (4U)       /*!< Bit position for MIPI_HSI_TX_WML0_CH9. */
#define BM_MIPI_HSI_TX_WML0_CH9 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH9. */
#define BS_MIPI_HSI_TX_WML0_CH9 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH9. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH9 field. */
#define BR_MIPI_HSI_TX_WML0_CH9(x) (HW_MIPI_HSI_TX_WML0(x).B.CH9)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH9. */
#define BF_MIPI_HSI_TX_WML0_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH9) & BM_MIPI_HSI_TX_WML0_CH9)

/*! @brief Set the CH9 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH9(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH9) | BF_MIPI_HSI_TX_WML0_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH10[11:8] (RW)
 *
 * This value denotes the WML of Tx Channel 10. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH10 (8U)      /*!< Bit position for MIPI_HSI_TX_WML0_CH10. */
#define BM_MIPI_HSI_TX_WML0_CH10 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH10. */
#define BS_MIPI_HSI_TX_WML0_CH10 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH10. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH10 field. */
#define BR_MIPI_HSI_TX_WML0_CH10(x) (HW_MIPI_HSI_TX_WML0(x).B.CH10)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH10. */
#define BF_MIPI_HSI_TX_WML0_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH10) & BM_MIPI_HSI_TX_WML0_CH10)

/*! @brief Set the CH10 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH10(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH10) | BF_MIPI_HSI_TX_WML0_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH11[15:12] (RW)
 *
 * This value denotes the WML of Tx Channel 11. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH11 (12U)     /*!< Bit position for MIPI_HSI_TX_WML0_CH11. */
#define BM_MIPI_HSI_TX_WML0_CH11 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH11. */
#define BS_MIPI_HSI_TX_WML0_CH11 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH11. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH11 field. */
#define BR_MIPI_HSI_TX_WML0_CH11(x) (HW_MIPI_HSI_TX_WML0(x).B.CH11)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH11. */
#define BF_MIPI_HSI_TX_WML0_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH11) & BM_MIPI_HSI_TX_WML0_CH11)

/*! @brief Set the CH11 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH11(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH11) | BF_MIPI_HSI_TX_WML0_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH12[19:16] (RW)
 *
 * This value denotes the WML of Tx Channel 12. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH12 (16U)     /*!< Bit position for MIPI_HSI_TX_WML0_CH12. */
#define BM_MIPI_HSI_TX_WML0_CH12 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH12. */
#define BS_MIPI_HSI_TX_WML0_CH12 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH12. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH12 field. */
#define BR_MIPI_HSI_TX_WML0_CH12(x) (HW_MIPI_HSI_TX_WML0(x).B.CH12)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH12. */
#define BF_MIPI_HSI_TX_WML0_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH12) & BM_MIPI_HSI_TX_WML0_CH12)

/*! @brief Set the CH12 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH12(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH12) | BF_MIPI_HSI_TX_WML0_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH13[23:20] (RW)
 *
 * This value denotes the WML of Tx Channel 13. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH13 (20U)     /*!< Bit position for MIPI_HSI_TX_WML0_CH13. */
#define BM_MIPI_HSI_TX_WML0_CH13 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH13. */
#define BS_MIPI_HSI_TX_WML0_CH13 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH13. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH13 field. */
#define BR_MIPI_HSI_TX_WML0_CH13(x) (HW_MIPI_HSI_TX_WML0(x).B.CH13)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH13. */
#define BF_MIPI_HSI_TX_WML0_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH13) & BM_MIPI_HSI_TX_WML0_CH13)

/*! @brief Set the CH13 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH13(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH13) | BF_MIPI_HSI_TX_WML0_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH14[27:24] (RW)
 *
 * This value denotes the WML of Tx Channel 14. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH14 (24U)     /*!< Bit position for MIPI_HSI_TX_WML0_CH14. */
#define BM_MIPI_HSI_TX_WML0_CH14 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH14. */
#define BS_MIPI_HSI_TX_WML0_CH14 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH14. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH14 field. */
#define BR_MIPI_HSI_TX_WML0_CH14(x) (HW_MIPI_HSI_TX_WML0(x).B.CH14)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH14. */
#define BF_MIPI_HSI_TX_WML0_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH14) & BM_MIPI_HSI_TX_WML0_CH14)

/*! @brief Set the CH14 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH14(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH14) | BF_MIPI_HSI_TX_WML0_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_WML0, field CH15[31:28] (RW)
 *
 * This value denotes the WML of Tx Channel 15. When > 1010 Reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_WML0_CH15 (28U)     /*!< Bit position for MIPI_HSI_TX_WML0_CH15. */
#define BM_MIPI_HSI_TX_WML0_CH15 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_WML0_CH15. */
#define BS_MIPI_HSI_TX_WML0_CH15 (4U)      /*!< Bit field size in bits for MIPI_HSI_TX_WML0_CH15. */

/*! @brief Read current value of the MIPI_HSI_TX_WML0_CH15 field. */
#define BR_MIPI_HSI_TX_WML0_CH15(x) (HW_MIPI_HSI_TX_WML0(x).B.CH15)

/*! @brief Format value for bitfield MIPI_HSI_TX_WML0_CH15. */
#define BF_MIPI_HSI_TX_WML0_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_WML0_CH15) & BM_MIPI_HSI_TX_WML0_CH15)

/*! @brief Set the CH15 field to a new value. */
#define BW_MIPI_HSI_TX_WML0_CH15(x, v) (HW_MIPI_HSI_TX_WML0_WR(x, (HW_MIPI_HSI_TX_WML0_RD(x) & ~BM_MIPI_HSI_TX_WML0_CH15) | BF_MIPI_HSI_TX_WML0_CH15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_TML1 - HSI Tx Water Mark Level 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_TML1 - HSI Tx Water Mark Level 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains HSI controller Tx channel Water Mark Level
 * information. This register contains HSI controller Tx channel bandwidth information.
 */
typedef union _hw_mipi_hsi_tx_tml1
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_tml1_bitfields
    {
        uint32_t CH0 : 4;              /*!< [3:0]  */
        uint32_t CH1 : 4;              /*!< [7:4]  */
        uint32_t CH2 : 4;              /*!< [11:8]  */
        uint32_t CH3 : 4;              /*!< [15:12]  */
        uint32_t CH4 : 4;              /*!< [19:16]  */
        uint32_t CH5 : 4;              /*!< [23:20]  */
        uint32_t CH6 : 4;              /*!< [27:24]  */
        uint32_t CH7 : 4;              /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_tml1_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_TML1 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_TML1_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_MIPI_HSI_TX_TML1(x)   (*(__IO hw_mipi_hsi_tx_tml1_t *) HW_MIPI_HSI_TX_TML1_ADDR(x))
#define HW_MIPI_HSI_TX_TML1_RD(x) (HW_MIPI_HSI_TX_TML1(x).U)
#define HW_MIPI_HSI_TX_TML1_WR(x, v) (HW_MIPI_HSI_TX_TML1(x).U = (v))
#define HW_MIPI_HSI_TX_TML1_SET(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, HW_MIPI_HSI_TX_TML1_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_TML1_CLR(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, HW_MIPI_HSI_TX_TML1_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_TML1_TOG(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, HW_MIPI_HSI_TX_TML1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_TML1 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH0[3:0] (RW)
 *
 * This value denotes the WML of Tx Channel 0. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH0 (0U)       /*!< Bit position for MIPI_HSI_TX_TML1_CH0. */
#define BM_MIPI_HSI_TX_TML1_CH0 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_TML1_CH0. */
#define BS_MIPI_HSI_TX_TML1_CH0 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH0. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH0 field. */
#define BR_MIPI_HSI_TX_TML1_CH0(x) (HW_MIPI_HSI_TX_TML1(x).B.CH0)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH0. */
#define BF_MIPI_HSI_TX_TML1_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH0) & BM_MIPI_HSI_TX_TML1_CH0)

/*! @brief Set the CH0 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH0(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH0) | BF_MIPI_HSI_TX_TML1_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH1[7:4] (RW)
 *
 * This value denotes the WML of Tx Channel 1. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH1 (4U)       /*!< Bit position for MIPI_HSI_TX_TML1_CH1. */
#define BM_MIPI_HSI_TX_TML1_CH1 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH1. */
#define BS_MIPI_HSI_TX_TML1_CH1 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH1. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH1 field. */
#define BR_MIPI_HSI_TX_TML1_CH1(x) (HW_MIPI_HSI_TX_TML1(x).B.CH1)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH1. */
#define BF_MIPI_HSI_TX_TML1_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH1) & BM_MIPI_HSI_TX_TML1_CH1)

/*! @brief Set the CH1 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH1(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH1) | BF_MIPI_HSI_TX_TML1_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH2[11:8] (RW)
 *
 * This value denotes the WML of Tx Channel 2. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH2 (8U)       /*!< Bit position for MIPI_HSI_TX_TML1_CH2. */
#define BM_MIPI_HSI_TX_TML1_CH2 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH2. */
#define BS_MIPI_HSI_TX_TML1_CH2 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH2. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH2 field. */
#define BR_MIPI_HSI_TX_TML1_CH2(x) (HW_MIPI_HSI_TX_TML1(x).B.CH2)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH2. */
#define BF_MIPI_HSI_TX_TML1_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH2) & BM_MIPI_HSI_TX_TML1_CH2)

/*! @brief Set the CH2 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH2(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH2) | BF_MIPI_HSI_TX_TML1_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH3[15:12] (RW)
 *
 * This value denotes the WML of Tx Channel 3. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH3 (12U)      /*!< Bit position for MIPI_HSI_TX_TML1_CH3. */
#define BM_MIPI_HSI_TX_TML1_CH3 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH3. */
#define BS_MIPI_HSI_TX_TML1_CH3 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH3. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH3 field. */
#define BR_MIPI_HSI_TX_TML1_CH3(x) (HW_MIPI_HSI_TX_TML1(x).B.CH3)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH3. */
#define BF_MIPI_HSI_TX_TML1_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH3) & BM_MIPI_HSI_TX_TML1_CH3)

/*! @brief Set the CH3 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH3(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH3) | BF_MIPI_HSI_TX_TML1_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH4[19:16] (RW)
 *
 * This value denotes the WML of Tx Channel 4. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH4 (16U)      /*!< Bit position for MIPI_HSI_TX_TML1_CH4. */
#define BM_MIPI_HSI_TX_TML1_CH4 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH4. */
#define BS_MIPI_HSI_TX_TML1_CH4 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH4. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH4 field. */
#define BR_MIPI_HSI_TX_TML1_CH4(x) (HW_MIPI_HSI_TX_TML1(x).B.CH4)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH4. */
#define BF_MIPI_HSI_TX_TML1_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH4) & BM_MIPI_HSI_TX_TML1_CH4)

/*! @brief Set the CH4 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH4(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH4) | BF_MIPI_HSI_TX_TML1_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH5[23:20] (RW)
 *
 * This value denotes the WML of Tx Channel 5. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH5 (20U)      /*!< Bit position for MIPI_HSI_TX_TML1_CH5. */
#define BM_MIPI_HSI_TX_TML1_CH5 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH5. */
#define BS_MIPI_HSI_TX_TML1_CH5 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH5. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH5 field. */
#define BR_MIPI_HSI_TX_TML1_CH5(x) (HW_MIPI_HSI_TX_TML1(x).B.CH5)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH5. */
#define BF_MIPI_HSI_TX_TML1_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH5) & BM_MIPI_HSI_TX_TML1_CH5)

/*! @brief Set the CH5 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH5(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH5) | BF_MIPI_HSI_TX_TML1_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH6[27:24] (RW)
 *
 * This value denotes the WML of Tx Channel 6. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH6 (24U)      /*!< Bit position for MIPI_HSI_TX_TML1_CH6. */
#define BM_MIPI_HSI_TX_TML1_CH6 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH6. */
#define BS_MIPI_HSI_TX_TML1_CH6 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH6. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH6 field. */
#define BR_MIPI_HSI_TX_TML1_CH6(x) (HW_MIPI_HSI_TX_TML1(x).B.CH6)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH6. */
#define BF_MIPI_HSI_TX_TML1_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH6) & BM_MIPI_HSI_TX_TML1_CH6)

/*! @brief Set the CH6 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH6(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH6) | BF_MIPI_HSI_TX_TML1_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_TML1, field CH7[31:28] (RW)
 *
 * This value denotes the WML of Tx Channel 7. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1
 * - 0001 - 2
 * - 0010 - 4
 * - 1000 - 256
 * - 1001 - 512
 * - 1010 - 1024
 */
/*@{*/
#define BP_MIPI_HSI_TX_TML1_CH7 (28U)      /*!< Bit position for MIPI_HSI_TX_TML1_CH7. */
#define BM_MIPI_HSI_TX_TML1_CH7 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_TML1_CH7. */
#define BS_MIPI_HSI_TX_TML1_CH7 (4U)       /*!< Bit field size in bits for MIPI_HSI_TX_TML1_CH7. */

/*! @brief Read current value of the MIPI_HSI_TX_TML1_CH7 field. */
#define BR_MIPI_HSI_TX_TML1_CH7(x) (HW_MIPI_HSI_TX_TML1(x).B.CH7)

/*! @brief Format value for bitfield MIPI_HSI_TX_TML1_CH7. */
#define BF_MIPI_HSI_TX_TML1_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_TML1_CH7) & BM_MIPI_HSI_TX_TML1_CH7)

/*! @brief Set the CH7 field to a new value. */
#define BW_MIPI_HSI_TX_TML1_CH7(x, v) (HW_MIPI_HSI_TX_TML1_WR(x, (HW_MIPI_HSI_TX_TML1_RD(x) & ~BM_MIPI_HSI_TX_TML1_CH7) | BF_MIPI_HSI_TX_TML1_CH7(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_ARB_PRI0 - HSI Tx Arbiter Priority 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_ARB_PRI0 - HSI Tx Arbiter Priority 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is HSI Tx Arbiter Priority Register.
 */
typedef union _hw_mipi_hsi_tx_arb_pri0
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_arb_pri0_bitfields
    {
        uint32_t CH0 : 4;              /*!< [3:0]  */
        uint32_t CH1 : 4;              /*!< [7:4]  */
        uint32_t CH2 : 4;              /*!< [11:8]  */
        uint32_t CH3 : 4;              /*!< [15:12]  */
        uint32_t CH4 : 4;              /*!< [19:16]  */
        uint32_t CH5 : 4;              /*!< [23:20]  */
        uint32_t CH6 : 4;              /*!< [27:24]  */
        uint32_t CH7 : 4;              /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_arb_pri0_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_ARB_PRI0 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_ARB_PRI0_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_MIPI_HSI_TX_ARB_PRI0(x) (*(__IO hw_mipi_hsi_tx_arb_pri0_t *) HW_MIPI_HSI_TX_ARB_PRI0_ADDR(x))
#define HW_MIPI_HSI_TX_ARB_PRI0_RD(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).U)
#define HW_MIPI_HSI_TX_ARB_PRI0_WR(x, v) (HW_MIPI_HSI_TX_ARB_PRI0(x).U = (v))
#define HW_MIPI_HSI_TX_ARB_PRI0_SET(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, HW_MIPI_HSI_TX_ARB_PRI0_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_ARB_PRI0_CLR(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_ARB_PRI0_TOG(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, HW_MIPI_HSI_TX_ARB_PRI0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_ARB_PRI0 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH0[3:0] (RW)
 *
 * This value denotes the priority of Tx Channel 0. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH0 (0U)   /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH0. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH0 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH0. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH0 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH0. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH0 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH0(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH0)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH0. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH0) & BM_MIPI_HSI_TX_ARB_PRI0_CH0)

/*! @brief Set the CH0 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH0(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH0) | BF_MIPI_HSI_TX_ARB_PRI0_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH1[7:4] (RW)
 *
 * This value denotes the priority of Tx Channel 1. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH1 (4U)   /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH1. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH1 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH1. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH1 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH1. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH1 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH1(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH1)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH1. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH1) & BM_MIPI_HSI_TX_ARB_PRI0_CH1)

/*! @brief Set the CH1 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH1(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH1) | BF_MIPI_HSI_TX_ARB_PRI0_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH2[11:8] (RW)
 *
 * This value denotes the priority of Tx Channel 2. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH2 (8U)   /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH2. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH2 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH2. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH2 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH2. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH2 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH2(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH2)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH2. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH2) & BM_MIPI_HSI_TX_ARB_PRI0_CH2)

/*! @brief Set the CH2 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH2(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH2) | BF_MIPI_HSI_TX_ARB_PRI0_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH3[15:12] (RW)
 *
 * This value denotes the priority of Tx Channel 3. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH3 (12U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH3. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH3 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH3. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH3 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH3. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH3 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH3(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH3)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH3. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH3) & BM_MIPI_HSI_TX_ARB_PRI0_CH3)

/*! @brief Set the CH3 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH3(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH3) | BF_MIPI_HSI_TX_ARB_PRI0_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH4[19:16] (RW)
 *
 * This value denotes the priority of Tx Channel 4. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH4 (16U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH4. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH4 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH4. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH4 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH4. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH4 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH4(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH4)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH4. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH4) & BM_MIPI_HSI_TX_ARB_PRI0_CH4)

/*! @brief Set the CH4 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH4(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH4) | BF_MIPI_HSI_TX_ARB_PRI0_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH5[23:20] (RW)
 *
 * This value denotes the priority of Tx Channel 5. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH5 (20U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH5. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH5 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH5. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH5 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH5. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH5 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH5(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH5)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH5. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH5) & BM_MIPI_HSI_TX_ARB_PRI0_CH5)

/*! @brief Set the CH5 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH5(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH5) | BF_MIPI_HSI_TX_ARB_PRI0_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH6[27:24] (RW)
 *
 * This value denotes the priority of Tx Channel 6. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH6 (24U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH6. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH6 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH6. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH6 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH6. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH6 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH6(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH6)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH6. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH6) & BM_MIPI_HSI_TX_ARB_PRI0_CH6)

/*! @brief Set the CH6 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH6(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH6) | BF_MIPI_HSI_TX_ARB_PRI0_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI0, field CH7[31:28] (RW)
 *
 * This value denotes the priority of Tx Channel 7. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI0_CH7 (28U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI0_CH7. */
#define BM_MIPI_HSI_TX_ARB_PRI0_CH7 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI0_CH7. */
#define BS_MIPI_HSI_TX_ARB_PRI0_CH7 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI0_CH7. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI0_CH7 field. */
#define BR_MIPI_HSI_TX_ARB_PRI0_CH7(x) (HW_MIPI_HSI_TX_ARB_PRI0(x).B.CH7)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI0_CH7. */
#define BF_MIPI_HSI_TX_ARB_PRI0_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI0_CH7) & BM_MIPI_HSI_TX_ARB_PRI0_CH7)

/*! @brief Set the CH7 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI0_CH7(x, v) (HW_MIPI_HSI_TX_ARB_PRI0_WR(x, (HW_MIPI_HSI_TX_ARB_PRI0_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI0_CH7) | BF_MIPI_HSI_TX_ARB_PRI0_CH7(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_ARB_PRI1 - HSI Tx Arbiter Priority 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_ARB_PRI1 - HSI Tx Arbiter Priority 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mipi_hsi_tx_arb_pri1
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_arb_pri1_bitfields
    {
        uint32_t CH8 : 4;              /*!< [3:0]  */
        uint32_t CH9 : 4;              /*!< [7:4]  */
        uint32_t CH10 : 4;             /*!< [11:8]  */
        uint32_t CH11 : 4;             /*!< [15:12]  */
        uint32_t CH12 : 4;             /*!< [19:16]  */
        uint32_t CH13 : 4;             /*!< [23:20]  */
        uint32_t CH14 : 4;             /*!< [27:24]  */
        uint32_t CH15 : 4;             /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_arb_pri1_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_ARB_PRI1 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_ARB_PRI1_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_MIPI_HSI_TX_ARB_PRI1(x) (*(__IO hw_mipi_hsi_tx_arb_pri1_t *) HW_MIPI_HSI_TX_ARB_PRI1_ADDR(x))
#define HW_MIPI_HSI_TX_ARB_PRI1_RD(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).U)
#define HW_MIPI_HSI_TX_ARB_PRI1_WR(x, v) (HW_MIPI_HSI_TX_ARB_PRI1(x).U = (v))
#define HW_MIPI_HSI_TX_ARB_PRI1_SET(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, HW_MIPI_HSI_TX_ARB_PRI1_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_ARB_PRI1_CLR(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_ARB_PRI1_TOG(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, HW_MIPI_HSI_TX_ARB_PRI1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_ARB_PRI1 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH8[3:0] (RW)
 *
 * This value denotes the priority of Tx Channel 8. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH8 (0U)   /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH8. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH8 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH8. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH8 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH8. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH8 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH8(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH8)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH8. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH8) & BM_MIPI_HSI_TX_ARB_PRI1_CH8)

/*! @brief Set the CH8 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH8(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH8) | BF_MIPI_HSI_TX_ARB_PRI1_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH9[7:4] (RW)
 *
 * This value denotes the priority of Tx Channel 9. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH9 (4U)   /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH9. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH9 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH9. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH9 (4U)   /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH9. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH9 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH9(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH9)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH9. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH9) & BM_MIPI_HSI_TX_ARB_PRI1_CH9)

/*! @brief Set the CH9 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH9(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH9) | BF_MIPI_HSI_TX_ARB_PRI1_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH10[11:8] (RW)
 *
 * This value denotes the priority of Tx Channel 10. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH10 (8U)  /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH10. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH10 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH10. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH10 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH10. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH10 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH10(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH10)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH10. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH10) & BM_MIPI_HSI_TX_ARB_PRI1_CH10)

/*! @brief Set the CH10 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH10(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH10) | BF_MIPI_HSI_TX_ARB_PRI1_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH11[15:12] (RW)
 *
 * This value denotes the priority of Tx Channel 11. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH11 (12U) /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH11. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH11 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH11. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH11 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH11. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH11 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH11(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH11)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH11. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH11) & BM_MIPI_HSI_TX_ARB_PRI1_CH11)

/*! @brief Set the CH11 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH11(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH11) | BF_MIPI_HSI_TX_ARB_PRI1_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH12[19:16] (RW)
 *
 * This value denotes the priority of Tx Channel 12. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH12 (16U) /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH12. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH12 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH12. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH12 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH12. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH12 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH12(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH12)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH12. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH12) & BM_MIPI_HSI_TX_ARB_PRI1_CH12)

/*! @brief Set the CH12 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH12(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH12) | BF_MIPI_HSI_TX_ARB_PRI1_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH13[23:20] (RW)
 *
 * This value denotes the priority of Tx Channel 13. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH13 (20U) /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH13. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH13 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH13. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH13 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH13. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH13 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH13(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH13)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH13. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH13) & BM_MIPI_HSI_TX_ARB_PRI1_CH13)

/*! @brief Set the CH13 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH13(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH13) | BF_MIPI_HSI_TX_ARB_PRI1_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH14[27:24] (RW)
 *
 * This value denotes the priority of Tx Channel 14. When > 1010 reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH14 (24U) /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH14. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH14 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH14. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH14 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH14. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH14 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH14(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH14)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH14. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH14) & BM_MIPI_HSI_TX_ARB_PRI1_CH14)

/*! @brief Set the CH14 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH14(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH14) | BF_MIPI_HSI_TX_ARB_PRI1_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_ARB_PRI1, field CH15[31:28] (RW)
 *
 * This value denotes the priority of Tx Channel 15. When > 1010 Reserved
 *
 * Values:
 * - 0000 - 1st prioirity
 * - 0001 - 2nd priority
 * - 0010 - 3rd priority
 * - 1101 - 14th priority
 * - 1110 - 15th priority
 * - 1111 - 16th priority
 */
/*@{*/
#define BP_MIPI_HSI_TX_ARB_PRI1_CH15 (28U) /*!< Bit position for MIPI_HSI_TX_ARB_PRI1_CH15. */
#define BM_MIPI_HSI_TX_ARB_PRI1_CH15 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_ARB_PRI1_CH15. */
#define BS_MIPI_HSI_TX_ARB_PRI1_CH15 (4U)  /*!< Bit field size in bits for MIPI_HSI_TX_ARB_PRI1_CH15. */

/*! @brief Read current value of the MIPI_HSI_TX_ARB_PRI1_CH15 field. */
#define BR_MIPI_HSI_TX_ARB_PRI1_CH15(x) (HW_MIPI_HSI_TX_ARB_PRI1(x).B.CH15)

/*! @brief Format value for bitfield MIPI_HSI_TX_ARB_PRI1_CH15. */
#define BF_MIPI_HSI_TX_ARB_PRI1_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_ARB_PRI1_CH15) & BM_MIPI_HSI_TX_ARB_PRI1_CH15)

/*! @brief Set the CH15 field to a new value. */
#define BW_MIPI_HSI_TX_ARB_PRI1_CH15(x, v) (HW_MIPI_HSI_TX_ARB_PRI1_WR(x, (HW_MIPI_HSI_TX_ARB_PRI1_RD(x) & ~BM_MIPI_HSI_TX_ARB_PRI1_CH15) | BF_MIPI_HSI_TX_ARB_PRI1_CH15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_LINE_ST - HSI Line Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_LINE_ST - HSI Line Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller line status for debug.
 */
typedef union _hw_mipi_hsi_line_st
{
    uint32_t U;
    struct _hw_mipi_hsi_line_st_bitfields
    {
        uint32_t TX_DATA_STATUS : 1;   /*!< [0]  */
        uint32_t TX_FLAG_STATUS : 1;   /*!< [1]  */
        uint32_t TX_READY_STATUS : 1;  /*!< [2]  */
        uint32_t TX_WAKEUP_STATUS : 1; /*!< [3]  */
        uint32_t RX_DATA_STATUS : 1;   /*!< [4]  */
        uint32_t RX_FLAG_STATUS : 1;   /*!< [5]  */
        uint32_t RX_READY_STATUS : 1;  /*!< [6]  */
        uint32_t RX_WAKEUP_STATUS : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_mipi_hsi_line_st_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_LINE_ST register
 */
/*@{*/
#define HW_MIPI_HSI_LINE_ST_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_MIPI_HSI_LINE_ST(x)   (*(__I hw_mipi_hsi_line_st_t *) HW_MIPI_HSI_LINE_ST_ADDR(x))
#define HW_MIPI_HSI_LINE_ST_RD(x) (HW_MIPI_HSI_LINE_ST(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_LINE_ST bitfields
 */

/*!
 * @name Register MIPI_HSI_LINE_ST, field TX_DATA_STATUS[0] (RO)
 *
 * This field reflects the tx_data pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_TX_DATA_STATUS (0U) /*!< Bit position for MIPI_HSI_LINE_ST_TX_DATA_STATUS. */
#define BM_MIPI_HSI_LINE_ST_TX_DATA_STATUS (0x00000001U) /*!< Bit mask for MIPI_HSI_LINE_ST_TX_DATA_STATUS. */
#define BS_MIPI_HSI_LINE_ST_TX_DATA_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_TX_DATA_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_TX_DATA_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_TX_DATA_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.TX_DATA_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field TX_FLAG_STATUS[1] (RO)
 *
 * This field reflects the tx_flag pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_TX_FLAG_STATUS (1U) /*!< Bit position for MIPI_HSI_LINE_ST_TX_FLAG_STATUS. */
#define BM_MIPI_HSI_LINE_ST_TX_FLAG_STATUS (0x00000002U) /*!< Bit mask for MIPI_HSI_LINE_ST_TX_FLAG_STATUS. */
#define BS_MIPI_HSI_LINE_ST_TX_FLAG_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_TX_FLAG_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_TX_FLAG_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_TX_FLAG_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.TX_FLAG_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field TX_READY_STATUS[2] (RO)
 *
 * This field reflects the tx_ready pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_TX_READY_STATUS (2U) /*!< Bit position for MIPI_HSI_LINE_ST_TX_READY_STATUS. */
#define BM_MIPI_HSI_LINE_ST_TX_READY_STATUS (0x00000004U) /*!< Bit mask for MIPI_HSI_LINE_ST_TX_READY_STATUS. */
#define BS_MIPI_HSI_LINE_ST_TX_READY_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_TX_READY_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_TX_READY_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_TX_READY_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.TX_READY_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field TX_WAKEUP_STATUS[3] (RO)
 *
 * This field reflects the tx_wake pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS (3U) /*!< Bit position for MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS. */
#define BM_MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS (0x00000008U) /*!< Bit mask for MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS. */
#define BS_MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_TX_WAKEUP_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.TX_WAKEUP_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field RX_DATA_STATUS[4] (RO)
 *
 * This field reflects the rx_data pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_RX_DATA_STATUS (4U) /*!< Bit position for MIPI_HSI_LINE_ST_RX_DATA_STATUS. */
#define BM_MIPI_HSI_LINE_ST_RX_DATA_STATUS (0x00000010U) /*!< Bit mask for MIPI_HSI_LINE_ST_RX_DATA_STATUS. */
#define BS_MIPI_HSI_LINE_ST_RX_DATA_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_RX_DATA_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_RX_DATA_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_RX_DATA_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.RX_DATA_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field RX_FLAG_STATUS[5] (RO)
 *
 * This field reflects the rx_flag pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_RX_FLAG_STATUS (5U) /*!< Bit position for MIPI_HSI_LINE_ST_RX_FLAG_STATUS. */
#define BM_MIPI_HSI_LINE_ST_RX_FLAG_STATUS (0x00000020U) /*!< Bit mask for MIPI_HSI_LINE_ST_RX_FLAG_STATUS. */
#define BS_MIPI_HSI_LINE_ST_RX_FLAG_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_RX_FLAG_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_RX_FLAG_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_RX_FLAG_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.RX_FLAG_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field RX_READY_STATUS[6] (RO)
 *
 * This field reflects the rx_rdy pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_RX_READY_STATUS (6U) /*!< Bit position for MIPI_HSI_LINE_ST_RX_READY_STATUS. */
#define BM_MIPI_HSI_LINE_ST_RX_READY_STATUS (0x00000040U) /*!< Bit mask for MIPI_HSI_LINE_ST_RX_READY_STATUS. */
#define BS_MIPI_HSI_LINE_ST_RX_READY_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_RX_READY_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_RX_READY_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_RX_READY_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.RX_READY_STATUS)
/*@}*/

/*!
 * @name Register MIPI_HSI_LINE_ST, field RX_WAKEUP_STATUS[7] (RO)
 *
 * This field reflects the rx_wake pin(only for debug).
 */
/*@{*/
#define BP_MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS (7U) /*!< Bit position for MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS. */
#define BM_MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS (0x00000080U) /*!< Bit mask for MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS. */
#define BS_MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS (1U) /*!< Bit field size in bits for MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS. */

/*! @brief Read current value of the MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS field. */
#define BR_MIPI_HSI_LINE_ST_RX_WAKEUP_STATUS(x) (HW_MIPI_HSI_LINE_ST(x).B.RX_WAKEUP_STATUS)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_ID_BIT - HSI ID Bits Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_ID_BIT - HSI ID Bits Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the configurations of tx channel enable/disable, , tx
 * wakup and tx trans mode.
 */
typedef union _hw_mipi_hsi_id_bit
{
    uint32_t U;
    struct _hw_mipi_hsi_id_bit_bitfields
    {
        uint32_t TX_CH : 3;            /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t RX_CH : 3;            /*!< [6:4]  */
        uint32_t RESERVED1 : 25;       /*!< [31:7]  */
    } B;
} hw_mipi_hsi_id_bit_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_ID_BIT register
 */
/*@{*/
#define HW_MIPI_HSI_ID_BIT_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_MIPI_HSI_ID_BIT(x)    (*(__IO hw_mipi_hsi_id_bit_t *) HW_MIPI_HSI_ID_BIT_ADDR(x))
#define HW_MIPI_HSI_ID_BIT_RD(x) (HW_MIPI_HSI_ID_BIT(x).U)
#define HW_MIPI_HSI_ID_BIT_WR(x, v) (HW_MIPI_HSI_ID_BIT(x).U = (v))
#define HW_MIPI_HSI_ID_BIT_SET(x, v) (HW_MIPI_HSI_ID_BIT_WR(x, HW_MIPI_HSI_ID_BIT_RD(x) |  (v)))
#define HW_MIPI_HSI_ID_BIT_CLR(x, v) (HW_MIPI_HSI_ID_BIT_WR(x, HW_MIPI_HSI_ID_BIT_RD(x) & ~(v)))
#define HW_MIPI_HSI_ID_BIT_TOG(x, v) (HW_MIPI_HSI_ID_BIT_WR(x, HW_MIPI_HSI_ID_BIT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_ID_BIT bitfields
 */

/*!
 * @name Register MIPI_HSI_ID_BIT, field TX_CH[2:0] (RW)
 *
 * This bit sets the number of channel ID bits per frame or stream for a
 * transmit operation.
 *
 * Values:
 * - 0 - 0 bit
 * - 1 - 1 bit
 */
/*@{*/
#define BP_MIPI_HSI_ID_BIT_TX_CH (0U)      /*!< Bit position for MIPI_HSI_ID_BIT_TX_CH. */
#define BM_MIPI_HSI_ID_BIT_TX_CH (0x00000007U) /*!< Bit mask for MIPI_HSI_ID_BIT_TX_CH. */
#define BS_MIPI_HSI_ID_BIT_TX_CH (3U)      /*!< Bit field size in bits for MIPI_HSI_ID_BIT_TX_CH. */

/*! @brief Read current value of the MIPI_HSI_ID_BIT_TX_CH field. */
#define BR_MIPI_HSI_ID_BIT_TX_CH(x) (HW_MIPI_HSI_ID_BIT(x).B.TX_CH)

/*! @brief Format value for bitfield MIPI_HSI_ID_BIT_TX_CH. */
#define BF_MIPI_HSI_ID_BIT_TX_CH(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ID_BIT_TX_CH) & BM_MIPI_HSI_ID_BIT_TX_CH)

/*! @brief Set the TX_CH field to a new value. */
#define BW_MIPI_HSI_ID_BIT_TX_CH(x, v) (HW_MIPI_HSI_ID_BIT_WR(x, (HW_MIPI_HSI_ID_BIT_RD(x) & ~BM_MIPI_HSI_ID_BIT_TX_CH) | BF_MIPI_HSI_ID_BIT_TX_CH(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ID_BIT, field RX_CH[6:4] (RW)
 *
 * This bit sets the number of channel ID bits per frame or stream for a Receive
 * operation.
 *
 * Values:
 * - 0 - 0 bit
 * - 1 - 1 bit
 */
/*@{*/
#define BP_MIPI_HSI_ID_BIT_RX_CH (4U)      /*!< Bit position for MIPI_HSI_ID_BIT_RX_CH. */
#define BM_MIPI_HSI_ID_BIT_RX_CH (0x00000070U) /*!< Bit mask for MIPI_HSI_ID_BIT_RX_CH. */
#define BS_MIPI_HSI_ID_BIT_RX_CH (3U)      /*!< Bit field size in bits for MIPI_HSI_ID_BIT_RX_CH. */

/*! @brief Read current value of the MIPI_HSI_ID_BIT_RX_CH field. */
#define BR_MIPI_HSI_ID_BIT_RX_CH(x) (HW_MIPI_HSI_ID_BIT(x).B.RX_CH)

/*! @brief Format value for bitfield MIPI_HSI_ID_BIT_RX_CH. */
#define BF_MIPI_HSI_ID_BIT_RX_CH(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ID_BIT_RX_CH) & BM_MIPI_HSI_ID_BIT_RX_CH)

/*! @brief Set the RX_CH field to a new value. */
#define BW_MIPI_HSI_ID_BIT_RX_CH(x, v) (HW_MIPI_HSI_ID_BIT_WR(x, (HW_MIPI_HSI_ID_BIT_RD(x) & ~BM_MIPI_HSI_ID_BIT_RX_CH) | BF_MIPI_HSI_ID_BIT_RX_CH(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_FIFO_THR_CONF - Tx and Rx Fif0 Threshold Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_FIFO_THR_CONF - Tx and Rx Fif0 Threshold Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register sets the threshold level for each Tx and Rx channel fifo
 */
typedef union _hw_mipi_hsi_fifo_thr_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_fifo_thr_conf_bitfields
    {
        uint32_t RX_CH0 : 1;           /*!< [0]  */
        uint32_t RX_CH1 : 1;           /*!< [1]  */
        uint32_t RX_CH2 : 1;           /*!< [2]  */
        uint32_t RX_CH3 : 1;           /*!< [3]  */
        uint32_t RX_CH4 : 1;           /*!< [4]  */
        uint32_t RX_CH5 : 1;           /*!< [5]  */
        uint32_t RX_CH6 : 1;           /*!< [6]  */
        uint32_t RX_CH7 : 1;           /*!< [7]  */
        uint32_t RX_CH8 : 1;           /*!< [8]  */
        uint32_t RX_CH9 : 1;           /*!< [9]  */
        uint32_t RX_CH10 : 1;          /*!< [10]  */
        uint32_t RX_CH11 : 1;          /*!< [11]  */
        uint32_t RX_CH12 : 1;          /*!< [12]  */
        uint32_t RX_CH13 : 1;          /*!< [13]  */
        uint32_t RX_CH14 : 1;          /*!< [14]  */
        uint32_t RX_CH15 : 1;          /*!< [15]  */
        uint32_t TX_CH0 : 1;           /*!< [16]  */
        uint32_t TX_CH1 : 1;           /*!< [17]  */
        uint32_t TX_CH2 : 1;           /*!< [18]  */
        uint32_t TX_CH3 : 1;           /*!< [19]  */
        uint32_t TX_CH4 : 1;           /*!< [20]  */
        uint32_t TX_CH5 : 1;           /*!< [21]  */
        uint32_t TX_CH6 : 1;           /*!< [22]  */
        uint32_t TX_CH7 : 1;           /*!< [23]  */
        uint32_t TX_CH8 : 1;           /*!< [24]  */
        uint32_t TX_CH9 : 1;           /*!< [25]  */
        uint32_t TX_CH10 : 1;          /*!< [26]  */
        uint32_t TX_CH11 : 1;          /*!< [27]  */
        uint32_t TX_CH12 : 1;          /*!< [28]  */
        uint32_t TX_CH13 : 1;          /*!< [29]  */
        uint32_t TX_CH14 : 1;          /*!< [30]  */
        uint32_t TX_CH15 : 1;          /*!< [31]  */
    } B;
} hw_mipi_hsi_fifo_thr_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_FIFO_THR_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_FIFO_THR_CONF_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_MIPI_HSI_FIFO_THR_CONF(x) (*(__IO hw_mipi_hsi_fifo_thr_conf_t *) HW_MIPI_HSI_FIFO_THR_CONF_ADDR(x))
#define HW_MIPI_HSI_FIFO_THR_CONF_RD(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).U)
#define HW_MIPI_HSI_FIFO_THR_CONF_WR(x, v) (HW_MIPI_HSI_FIFO_THR_CONF(x).U = (v))
#define HW_MIPI_HSI_FIFO_THR_CONF_SET(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, HW_MIPI_HSI_FIFO_THR_CONF_RD(x) |  (v)))
#define HW_MIPI_HSI_FIFO_THR_CONF_CLR(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~(v)))
#define HW_MIPI_HSI_FIFO_THR_CONF_TOG(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, HW_MIPI_HSI_FIFO_THR_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_FIFO_THR_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH0[0] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH0 (0U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH0. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH0 (0x00000001U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH0. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH0 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH0. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH0 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH0(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH0)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH0. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH0) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH0)

/*! @brief Set the RX_CH0 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH0(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH0) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH1[1] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH1 (1U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH1. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH1 (0x00000002U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH1. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH1 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH1. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH1 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH1(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH1)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH1. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH1) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH1)

/*! @brief Set the RX_CH1 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH1(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH1) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH2[2] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH2 (2U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH2. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH2 (0x00000004U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH2. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH2 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH2. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH2 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH2(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH2)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH2. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH2) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH2)

/*! @brief Set the RX_CH2 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH2(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH2) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH3[3] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH3 (3U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH3. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH3 (0x00000008U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH3. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH3 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH3. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH3 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH3(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH3)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH3. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH3) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH3)

/*! @brief Set the RX_CH3 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH3(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH3) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH4[4] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH4 (4U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH4. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH4 (0x00000010U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH4. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH4 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH4. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH4 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH4(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH4)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH4. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH4) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH4)

/*! @brief Set the RX_CH4 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH4(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH4) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH5[5] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH5 (5U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH5. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH5 (0x00000020U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH5. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH5 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH5. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH5 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH5(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH5)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH5. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH5) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH5)

/*! @brief Set the RX_CH5 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH5(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH5) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH6[6] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH6 (6U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH6. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH6 (0x00000040U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH6. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH6 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH6. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH6 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH6(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH6)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH6. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH6) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH6)

/*! @brief Set the RX_CH6 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH6(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH6) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH7[7] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH7 (7U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH7. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH7 (0x00000080U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH7. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH7 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH7. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH7 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH7(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH7)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH7. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH7) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH7)

/*! @brief Set the RX_CH7 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH7(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH7) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH8[8] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH8 (8U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH8. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH8 (0x00000100U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH8. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH8 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH8. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH8 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH8(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH8)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH8. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH8) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH8)

/*! @brief Set the RX_CH8 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH8(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH8) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH9[9] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH9 (9U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH9. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH9 (0x00000200U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH9. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH9 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH9. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH9 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH9(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH9)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH9. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH9) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH9)

/*! @brief Set the RX_CH9 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH9(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH9) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH10[10] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH10 (10U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH10. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH10 (0x00000400U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH10. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH10 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH10. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH10 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH10(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH10)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH10. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH10) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH10)

/*! @brief Set the RX_CH10 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH10(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH10) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH11[11] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH11 (11U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH11. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH11 (0x00000800U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH11. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH11 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH11. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH11 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH11(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH11)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH11. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH11) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH11)

/*! @brief Set the RX_CH11 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH11(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH11) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH12[12] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH12 (12U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH12. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH12 (0x00001000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH12. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH12 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH12. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH12 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH12(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH12)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH12. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH12) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH12)

/*! @brief Set the RX_CH12 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH12(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH12) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH13[13] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH13 (13U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH13. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH13 (0x00002000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH13. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH13 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH13. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH13 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH13(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH13)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH13. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH13) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH13)

/*! @brief Set the RX_CH13 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH13(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH13) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH14[14] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH14 (14U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH14. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH14 (0x00004000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH14. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH14 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH14. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH14 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH14(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH14)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH14. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH14) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH14)

/*! @brief Set the RX_CH14 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH14(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH14) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field RX_CH15[15] (RW)
 *
 * Values:
 * - 0 - Half Full (fifo size / 2)
 * - 1 - Almost Full (3/4th of fifo size)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_RX_CH15 (15U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_RX_CH15. */
#define BM_MIPI_HSI_FIFO_THR_CONF_RX_CH15 (0x00008000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_RX_CH15. */
#define BS_MIPI_HSI_FIFO_THR_CONF_RX_CH15 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_RX_CH15. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_RX_CH15 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_RX_CH15(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.RX_CH15)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_RX_CH15. */
#define BF_MIPI_HSI_FIFO_THR_CONF_RX_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_RX_CH15) & BM_MIPI_HSI_FIFO_THR_CONF_RX_CH15)

/*! @brief Set the RX_CH15 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_RX_CH15(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_RX_CH15) | BF_MIPI_HSI_FIFO_THR_CONF_RX_CH15(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH0[16] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH0 (16U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH0. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH0 (0x00010000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH0. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH0 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH0. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH0 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH0(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH0)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH0. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH0) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH0)

/*! @brief Set the TX_CH0 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH0(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH0) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH1[17] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH1 (17U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH1. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH1 (0x00020000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH1. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH1 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH1. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH1 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH1(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH1)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH1. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH1) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH1)

/*! @brief Set the TX_CH1 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH1(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH1) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH2[18] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH2 (18U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH2. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH2 (0x00040000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH2. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH2 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH2. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH2 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH2(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH2)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH2. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH2) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH2)

/*! @brief Set the TX_CH2 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH2(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH2) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH3[19] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH3 (19U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH3. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH3 (0x00080000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH3. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH3 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH3. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH3 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH3(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH3)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH3. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH3) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH3)

/*! @brief Set the TX_CH3 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH3(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH3) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH4[20] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH4 (20U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH4. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH4 (0x00100000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH4. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH4 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH4. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH4 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH4(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH4)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH4. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH4) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH4)

/*! @brief Set the TX_CH4 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH4(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH4) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH5[21] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH5 (21U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH5. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH5 (0x00200000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH5. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH5 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH5. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH5 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH5(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH5)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH5. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH5) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH5)

/*! @brief Set the TX_CH5 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH5(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH5) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH6[22] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH6 (22U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH6. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH6 (0x00400000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH6. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH6 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH6. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH6 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH6(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH6)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH6. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH6) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH6)

/*! @brief Set the TX_CH6 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH6(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH6) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH7[23] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH7 (23U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH7. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH7 (0x00800000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH7. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH7 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH7. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH7 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH7(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH7)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH7. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH7) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH7)

/*! @brief Set the TX_CH7 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH7(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH7) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH8[24] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH8 (24U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH8. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH8 (0x01000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH8. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH8 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH8. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH8 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH8(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH8)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH8. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH8) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH8)

/*! @brief Set the TX_CH8 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH8(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH8) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH9[25] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH9 (25U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH9. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH9 (0x02000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH9. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH9 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH9. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH9 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH9(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH9)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH9. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH9) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH9)

/*! @brief Set the TX_CH9 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH9(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH9) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH10[26] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH10 (26U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH10. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH10 (0x04000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH10. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH10 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH10. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH10 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH10(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH10)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH10. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH10) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH10)

/*! @brief Set the TX_CH10 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH10(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH10) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH11[27] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH11 (27U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH11. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH11 (0x08000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH11. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH11 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH11. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH11 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH11(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH11)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH11. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH11) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH11)

/*! @brief Set the TX_CH11 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH11(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH11) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH12[28] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH12 (28U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH12. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH12 (0x10000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH12. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH12 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH12. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH12 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH12(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH12)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH12. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH12) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH12)

/*! @brief Set the TX_CH12 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH12(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH12) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH13[29] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH13 (29U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH13. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH13 (0x20000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH13. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH13 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH13. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH13 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH13(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH13)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH13. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH13) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH13)

/*! @brief Set the TX_CH13 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH13(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH13) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH14[30] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH14 (30U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH14. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH14 (0x40000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH14. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH14 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH14. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH14 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH14(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH14)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH14. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH14) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH14)

/*! @brief Set the TX_CH14 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH14(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH14) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_CONF, field TX_CH15[31] (RW)
 *
 * Values:
 * - 0 - Half Empty (fifo size / 2)
 * - 1 - Almost Empty (fifo size / 4)
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_CONF_TX_CH15 (31U) /*!< Bit position for MIPI_HSI_FIFO_THR_CONF_TX_CH15. */
#define BM_MIPI_HSI_FIFO_THR_CONF_TX_CH15 (0x80000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_CONF_TX_CH15. */
#define BS_MIPI_HSI_FIFO_THR_CONF_TX_CH15 (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_CONF_TX_CH15. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_CONF_TX_CH15 field. */
#define BR_MIPI_HSI_FIFO_THR_CONF_TX_CH15(x) (HW_MIPI_HSI_FIFO_THR_CONF(x).B.TX_CH15)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_CONF_TX_CH15. */
#define BF_MIPI_HSI_FIFO_THR_CONF_TX_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_CONF_TX_CH15) & BM_MIPI_HSI_FIFO_THR_CONF_TX_CH15)

/*! @brief Set the TX_CH15 field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_CONF_TX_CH15(x, v) (HW_MIPI_HSI_FIFO_THR_CONF_WR(x, (HW_MIPI_HSI_FIFO_THR_CONF_RD(x) & ~BM_MIPI_HSI_FIFO_THR_CONF_TX_CH15) | BF_MIPI_HSI_FIFO_THR_CONF_TX_CH15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_CH_SFTRST - Tx and Rx Channel Soft Reset Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_CH_SFTRST - Tx and Rx Channel Soft Reset Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to reset each Tx and Rx Channel
 */
typedef union _hw_mipi_hsi_ch_sftrst
{
    uint32_t U;
    struct _hw_mipi_hsi_ch_sftrst_bitfields
    {
        uint32_t RX_CH0 : 1;           /*!< [0]  */
        uint32_t RX_CH1 : 1;           /*!< [1]  */
        uint32_t RX_CH2 : 1;           /*!< [2]  */
        uint32_t RX_CH3 : 1;           /*!< [3]  */
        uint32_t RX_CH4 : 1;           /*!< [4]  */
        uint32_t RX_CH5 : 1;           /*!< [5]  */
        uint32_t RX_CH6 : 1;           /*!< [6]  */
        uint32_t RX_CH7 : 1;           /*!< [7]  */
        uint32_t RX_CH8 : 1;           /*!< [8]  */
        uint32_t RX_CH9 : 1;           /*!< [9]  */
        uint32_t RX_CH10 : 1;          /*!< [10]  */
        uint32_t RX_CH11 : 1;          /*!< [11]  */
        uint32_t RX_CH12 : 1;          /*!< [12]  */
        uint32_t RX_CH13 : 1;          /*!< [13]  */
        uint32_t RX_CH14 : 1;          /*!< [14]  */
        uint32_t RX_CH15 : 1;          /*!< [15]  */
        uint32_t TX_CH0 : 1;           /*!< [16]  */
        uint32_t TX_CH1 : 1;           /*!< [17]  */
        uint32_t TX_CH2 : 1;           /*!< [18]  */
        uint32_t TX_CH3 : 1;           /*!< [19]  */
        uint32_t TX_CH4 : 1;           /*!< [20]  */
        uint32_t TX_CH5 : 1;           /*!< [21]  */
        uint32_t TX_CH6 : 1;           /*!< [22]  */
        uint32_t TX_CH7 : 1;           /*!< [23]  */
        uint32_t TX_CH8 : 1;           /*!< [24]  */
        uint32_t TX_CH9 : 1;           /*!< [25]  */
        uint32_t TX_CH10 : 1;          /*!< [26]  */
        uint32_t TX_CH11 : 1;          /*!< [27]  */
        uint32_t TX_CH12 : 1;          /*!< [28]  */
        uint32_t TX_CH13 : 1;          /*!< [29]  */
        uint32_t TX_CH14 : 1;          /*!< [30]  */
        uint32_t TX_CH15 : 1;          /*!< [31]  */
    } B;
} hw_mipi_hsi_ch_sftrst_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_CH_SFTRST register
 */
/*@{*/
#define HW_MIPI_HSI_CH_SFTRST_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_MIPI_HSI_CH_SFTRST(x) (*(__O hw_mipi_hsi_ch_sftrst_t *) HW_MIPI_HSI_CH_SFTRST_ADDR(x))
#define HW_MIPI_HSI_CH_SFTRST_WR(x, v) (HW_MIPI_HSI_CH_SFTRST(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_CH_SFTRST bitfields
 */

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH0[0] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 0 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH0 (0U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH0. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH0 (0x00000001U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH0. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH0 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH0. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH0. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH0) & BM_MIPI_HSI_CH_SFTRST_RX_CH0)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH1[1] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 1 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH1 (1U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH1. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH1 (0x00000002U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH1. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH1 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH1. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH1. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH1) & BM_MIPI_HSI_CH_SFTRST_RX_CH1)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH2[2] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 2 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH2 (2U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH2. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH2 (0x00000004U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH2. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH2 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH2. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH2. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH2) & BM_MIPI_HSI_CH_SFTRST_RX_CH2)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH3[3] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 3 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH3 (3U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH3. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH3 (0x00000008U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH3. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH3 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH3. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH3. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH3) & BM_MIPI_HSI_CH_SFTRST_RX_CH3)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH4[4] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 4 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH4 (4U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH4. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH4 (0x00000010U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH4. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH4 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH4. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH4. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH4) & BM_MIPI_HSI_CH_SFTRST_RX_CH4)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH5[5] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 5 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH5 (5U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH5. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH5 (0x00000020U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH5. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH5 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH5. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH5. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH5) & BM_MIPI_HSI_CH_SFTRST_RX_CH5)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH6[6] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 6 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH6 (6U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH6. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH6 (0x00000040U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH6. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH6 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH6. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH6. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH6) & BM_MIPI_HSI_CH_SFTRST_RX_CH6)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH7[7] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 7 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH7 (7U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH7. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH7 (0x00000080U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH7. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH7 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH7. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH7. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH7) & BM_MIPI_HSI_CH_SFTRST_RX_CH7)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH8[8] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 8 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH8 (8U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH8. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH8 (0x00000100U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH8. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH8 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH8. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH8. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH8) & BM_MIPI_HSI_CH_SFTRST_RX_CH8)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH9[9] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 9 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH9 (9U)  /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH9. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH9 (0x00000200U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH9. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH9 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH9. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH9. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH9) & BM_MIPI_HSI_CH_SFTRST_RX_CH9)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH10[10] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 10 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH10 (10U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH10. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH10 (0x00000400U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH10. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH10 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH10. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH10. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH10) & BM_MIPI_HSI_CH_SFTRST_RX_CH10)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH11[11] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 11 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH11 (11U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH11. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH11 (0x00000800U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH11. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH11 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH11. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH11. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH11) & BM_MIPI_HSI_CH_SFTRST_RX_CH11)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH12[12] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 12 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH12 (12U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH12. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH12 (0x00001000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH12. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH12 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH12. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH12. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH12) & BM_MIPI_HSI_CH_SFTRST_RX_CH12)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH13[13] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 13 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH13 (13U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH13. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH13 (0x00002000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH13. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH13 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH13. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH13. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH13) & BM_MIPI_HSI_CH_SFTRST_RX_CH13)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH14[14] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 14 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH14 (14U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH14. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH14 (0x00004000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH14. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH14 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH14. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH14. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH14) & BM_MIPI_HSI_CH_SFTRST_RX_CH14)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field RX_CH15[15] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Rx Channel 15 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_RX_CH15 (15U) /*!< Bit position for MIPI_HSI_CH_SFTRST_RX_CH15. */
#define BM_MIPI_HSI_CH_SFTRST_RX_CH15 (0x00008000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_RX_CH15. */
#define BS_MIPI_HSI_CH_SFTRST_RX_CH15 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_RX_CH15. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_RX_CH15. */
#define BF_MIPI_HSI_CH_SFTRST_RX_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_RX_CH15) & BM_MIPI_HSI_CH_SFTRST_RX_CH15)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH0[16] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 0 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH0 (16U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH0. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH0 (0x00010000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH0. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH0 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH0. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH0. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH0) & BM_MIPI_HSI_CH_SFTRST_TX_CH0)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH1[17] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 1 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH1 (17U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH1. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH1 (0x00020000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH1. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH1 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH1. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH1. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH1) & BM_MIPI_HSI_CH_SFTRST_TX_CH1)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH2[18] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 2 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH2 (18U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH2. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH2 (0x00040000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH2. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH2 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH2. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH2. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH2) & BM_MIPI_HSI_CH_SFTRST_TX_CH2)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH3[19] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 3 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH3 (19U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH3. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH3 (0x00080000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH3. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH3 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH3. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH3. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH3) & BM_MIPI_HSI_CH_SFTRST_TX_CH3)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH4[20] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 4 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH4 (20U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH4. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH4 (0x00100000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH4. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH4 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH4. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH4. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH4) & BM_MIPI_HSI_CH_SFTRST_TX_CH4)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH5[21] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 5 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH5 (21U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH5. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH5 (0x00200000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH5. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH5 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH5. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH5. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH5) & BM_MIPI_HSI_CH_SFTRST_TX_CH5)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH6[22] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 6 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH6 (22U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH6. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH6 (0x00400000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH6. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH6 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH6. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH6. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH6) & BM_MIPI_HSI_CH_SFTRST_TX_CH6)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH7[23] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 7 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH7 (23U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH7. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH7 (0x00800000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH7. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH7 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH7. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH7. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH7) & BM_MIPI_HSI_CH_SFTRST_TX_CH7)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH8[24] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 8 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH8 (24U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH8. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH8 (0x01000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH8. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH8 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH8. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH8. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH8) & BM_MIPI_HSI_CH_SFTRST_TX_CH8)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH9[25] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 9 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH9 (25U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH9. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH9 (0x02000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH9. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH9 (1U)  /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH9. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH9. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH9) & BM_MIPI_HSI_CH_SFTRST_TX_CH9)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH10[26] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 10 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH10 (26U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH10. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH10 (0x04000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH10. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH10 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH10. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH10. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH10) & BM_MIPI_HSI_CH_SFTRST_TX_CH10)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH11[27] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 11 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH11 (27U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH11. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH11 (0x08000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH11. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH11 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH11. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH11. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH11) & BM_MIPI_HSI_CH_SFTRST_TX_CH11)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH12[28] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 12 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH12 (28U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH12. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH12 (0x10000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH12. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH12 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH12. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH12. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH12) & BM_MIPI_HSI_CH_SFTRST_TX_CH12)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH13[29] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 13 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH13 (29U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH13. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH13 (0x20000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH13. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH13 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH13. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH13. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH13) & BM_MIPI_HSI_CH_SFTRST_TX_CH13)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH14[30] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 14 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH14 (30U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH14. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH14 (0x40000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH14. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH14 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH14. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH14. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH14) & BM_MIPI_HSI_CH_SFTRST_TX_CH14)
/*@}*/

/*!
 * @name Register MIPI_HSI_CH_SFTRST, field TX_CH15[31] (WO)
 *
 * Set this bit to zero to enable normal HSI operation. Set this bit to one to
 * reset Tx Channel 15 (DMA and Fifo). When the reset operation complete, this bit
 * will turn to zero automatically.
 */
/*@{*/
#define BP_MIPI_HSI_CH_SFTRST_TX_CH15 (31U) /*!< Bit position for MIPI_HSI_CH_SFTRST_TX_CH15. */
#define BM_MIPI_HSI_CH_SFTRST_TX_CH15 (0x80000000U) /*!< Bit mask for MIPI_HSI_CH_SFTRST_TX_CH15. */
#define BS_MIPI_HSI_CH_SFTRST_TX_CH15 (1U) /*!< Bit field size in bits for MIPI_HSI_CH_SFTRST_TX_CH15. */

/*! @brief Format value for bitfield MIPI_HSI_CH_SFTRST_TX_CH15. */
#define BF_MIPI_HSI_CH_SFTRST_TX_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_CH_SFTRST_TX_CH15) & BM_MIPI_HSI_CH_SFTRST_TX_CH15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_IRQSTAT - HSI Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_IRQSTAT - HSI Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is HSI controller Interrupt Status Register. This register contains the
 * HSI controller Interrupt Status.
 */
typedef union _hw_mipi_hsi_irqstat
{
    uint32_t U;
    struct _hw_mipi_hsi_irqstat_bitfields
    {
        uint32_t FIFO_THRESHOLD_INT : 1; /*!< [0]  */
        uint32_t RX_WAKEUP_INT : 1;    /*!< [1]  */
        uint32_t RX_TIMEOUT_INT : 1;   /*!< [2]  */
        uint32_t DMA_INT : 1;          /*!< [3]  */
        uint32_t DMA_ERR_INT : 1;      /*!< [4]  */
        uint32_t TX_TIMEOUT_ERR_INT : 1; /*!< [5]  */
        uint32_t RX_ERROR_INT : 1;     /*!< [6]  */
        uint32_t RX_BREAK_INT : 1;     /*!< [7]  */
        uint32_t TX_EMPTY_INT : 1;     /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_mipi_hsi_irqstat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_IRQSTAT register
 */
/*@{*/
#define HW_MIPI_HSI_IRQSTAT_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_MIPI_HSI_IRQSTAT(x)   (*(__IO hw_mipi_hsi_irqstat_t *) HW_MIPI_HSI_IRQSTAT_ADDR(x))
#define HW_MIPI_HSI_IRQSTAT_RD(x) (HW_MIPI_HSI_IRQSTAT(x).U)
#define HW_MIPI_HSI_IRQSTAT_WR(x, v) (HW_MIPI_HSI_IRQSTAT(x).U = (v))
#define HW_MIPI_HSI_IRQSTAT_SET(x, v) (HW_MIPI_HSI_IRQSTAT_WR(x, HW_MIPI_HSI_IRQSTAT_RD(x) |  (v)))
#define HW_MIPI_HSI_IRQSTAT_CLR(x, v) (HW_MIPI_HSI_IRQSTAT_WR(x, HW_MIPI_HSI_IRQSTAT_RD(x) & ~(v)))
#define HW_MIPI_HSI_IRQSTAT_TOG(x, v) (HW_MIPI_HSI_IRQSTAT_WR(x, HW_MIPI_HSI_IRQSTAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_IRQSTAT bitfields
 */

/*!
 * @name Register MIPI_HSI_IRQSTAT, field FIFO_THRESHOLD_INT[0] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in TX/Rx FIFO Interrupt Status
 * - 0 - Threshold amount of data not reached in TX/Rx FIFO Interrupt Status
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT (0U) /*!< Bit position for MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT. */
#define BM_MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT. */
#define BS_MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT field. */
#define BR_MIPI_HSI_IRQSTAT_FIFO_THRESHOLD_INT(x) (HW_MIPI_HSI_IRQSTAT(x).B.FIFO_THRESHOLD_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field RX_WAKEUP_INT[1] (WO)
 *
 * Values:
 * - 1 - Receiver Wakeup event is occurred
 * - 0 - Receiver Wakeup event is not occurred
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT (1U) /*!< Bit position for MIPI_HSI_IRQSTAT_RX_WAKEUP_INT. */
#define BM_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_IRQSTAT_RX_WAKEUP_INT. */
#define BS_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_RX_WAKEUP_INT. */

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_RX_WAKEUP_INT. */
#define BF_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT) & BM_MIPI_HSI_IRQSTAT_RX_WAKEUP_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field RX_TIMEOUT_INT[2] (RO)
 *
 * If any bit in the HSI Error Interrupt Status Register is set, then this bit
 * is set. on seeing this bit set, the ocp driver will read the Error Interrupt
 * Staus Register.
 *
 * Values:
 * - 0 - No Error.
 * - 1 - Error.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT (2U) /*!< Bit position for MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT. */
#define BM_MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT. */
#define BS_MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT field. */
#define BR_MIPI_HSI_IRQSTAT_RX_TIMEOUT_INT(x) (HW_MIPI_HSI_IRQSTAT(x).B.RX_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field DMA_INT[3] (RO)
 *
 * This bit is set when a Transmit or Receive Operation is completed for DMA.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_DMA_INT (3U)   /*!< Bit position for MIPI_HSI_IRQSTAT_DMA_INT. */
#define BM_MIPI_HSI_IRQSTAT_DMA_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_IRQSTAT_DMA_INT. */
#define BS_MIPI_HSI_IRQSTAT_DMA_INT (1U)   /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_DMA_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_DMA_INT field. */
#define BR_MIPI_HSI_IRQSTAT_DMA_INT(x) (HW_MIPI_HSI_IRQSTAT(x).B.DMA_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field DMA_ERR_INT[4] (RO)
 *
 * If any bit in the DMA Error Interrupt Status Register is set, then this bit
 * is set. on seeing this bit set, the ocp driver will read the Error Interrupt
 * Staus Register.
 *
 * Values:
 * - 0 - No Error.
 * - 1 - Error.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_DMA_ERR_INT (4U) /*!< Bit position for MIPI_HSI_IRQSTAT_DMA_ERR_INT. */
#define BM_MIPI_HSI_IRQSTAT_DMA_ERR_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_IRQSTAT_DMA_ERR_INT. */
#define BS_MIPI_HSI_IRQSTAT_DMA_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_DMA_ERR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_DMA_ERR_INT field. */
#define BR_MIPI_HSI_IRQSTAT_DMA_ERR_INT(x) (HW_MIPI_HSI_IRQSTAT(x).B.DMA_ERR_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field TX_TIMEOUT_ERR_INT[5] (WO)
 *
 * Values:
 * - 0 - No Error.
 * - 1 - Error.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT (5U) /*!< Bit position for MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT. */
#define BM_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT. */
#define BS_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT. */

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT. */
#define BF_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT) & BM_MIPI_HSI_IRQSTAT_TX_TIMEOUT_ERR_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field RX_ERROR_INT[6] (WO)
 *
 * Values:
 * - 0 - No Error.
 * - 1 - Error.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_RX_ERROR_INT (6U) /*!< Bit position for MIPI_HSI_IRQSTAT_RX_ERROR_INT. */
#define BM_MIPI_HSI_IRQSTAT_RX_ERROR_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_IRQSTAT_RX_ERROR_INT. */
#define BS_MIPI_HSI_IRQSTAT_RX_ERROR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_RX_ERROR_INT. */

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_RX_ERROR_INT. */
#define BF_MIPI_HSI_IRQSTAT_RX_ERROR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_RX_ERROR_INT) & BM_MIPI_HSI_IRQSTAT_RX_ERROR_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field RX_BREAK_INT[7] (WO)
 *
 * Values:
 * - 0 - No Error.
 * - 1 - Error.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_RX_BREAK_INT (7U) /*!< Bit position for MIPI_HSI_IRQSTAT_RX_BREAK_INT. */
#define BM_MIPI_HSI_IRQSTAT_RX_BREAK_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_IRQSTAT_RX_BREAK_INT. */
#define BS_MIPI_HSI_IRQSTAT_RX_BREAK_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_RX_BREAK_INT. */

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_RX_BREAK_INT. */
#define BF_MIPI_HSI_IRQSTAT_RX_BREAK_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_RX_BREAK_INT) & BM_MIPI_HSI_IRQSTAT_RX_BREAK_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT, field TX_EMPTY_INT[8] (RO)
 *
 * Values:
 * - 1 - All tx channel empty and tx state IDLE Interrupt Status
 * - 0 - not All tx channel empty and tx state IDLE Interrupt Status
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_TX_EMPTY_INT (8U) /*!< Bit position for MIPI_HSI_IRQSTAT_TX_EMPTY_INT. */
#define BM_MIPI_HSI_IRQSTAT_TX_EMPTY_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_IRQSTAT_TX_EMPTY_INT. */
#define BS_MIPI_HSI_IRQSTAT_TX_EMPTY_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_TX_EMPTY_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_TX_EMPTY_INT field. */
#define BR_MIPI_HSI_IRQSTAT_TX_EMPTY_INT(x) (HW_MIPI_HSI_IRQSTAT(x).B.TX_EMPTY_INT)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_IRQSTAT_EN - HSI Interrupt Status Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_IRQSTAT_EN - HSI Interrupt Status Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller Interrupt Status Enable.
 */
typedef union _hw_mipi_hsi_irqstat_en
{
    uint32_t U;
    struct _hw_mipi_hsi_irqstat_en_bitfields
    {
        uint32_t FIFO_THRESHOLD_INT : 1; /*!< [0]  */
        uint32_t RX_WAKEUP_INT : 1;    /*!< [1]  */
        uint32_t RX_TIMEOUT_INT : 1;   /*!< [2]  */
        uint32_t DMA_INT : 1;          /*!< [3]  */
        uint32_t DMA_ERR_INT : 1;      /*!< [4]  */
        uint32_t TX_TIMEOUT_ERR_INT : 1; /*!< [5]  */
        uint32_t RX_ERROR_INT : 1;     /*!< [6]  */
        uint32_t RX_BREAK_INT : 1;     /*!< [7]  */
        uint32_t TX_EMPTY_INT : 1;     /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_mipi_hsi_irqstat_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_IRQSTAT_EN register
 */
/*@{*/
#define HW_MIPI_HSI_IRQSTAT_EN_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_MIPI_HSI_IRQSTAT_EN(x) (*(__IO hw_mipi_hsi_irqstat_en_t *) HW_MIPI_HSI_IRQSTAT_EN_ADDR(x))
#define HW_MIPI_HSI_IRQSTAT_EN_RD(x) (HW_MIPI_HSI_IRQSTAT_EN(x).U)
#define HW_MIPI_HSI_IRQSTAT_EN_WR(x, v) (HW_MIPI_HSI_IRQSTAT_EN(x).U = (v))
#define HW_MIPI_HSI_IRQSTAT_EN_SET(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, HW_MIPI_HSI_IRQSTAT_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_IRQSTAT_EN_CLR(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_IRQSTAT_EN_TOG(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, HW_MIPI_HSI_IRQSTAT_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_IRQSTAT_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field FIFO_THRESHOLD_INT[0] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for FIFO_THRESHOLD_INT_STATUS interrupt.
 * - 0 - Interrupt status masked FIFO_THRESHOLD_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT (0U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.FIFO_THRESHOLD_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT) & BM_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT)

/*! @brief Set the FIFO_THRESHOLD_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT) | BF_MIPI_HSI_IRQSTAT_EN_FIFO_THRESHOLD_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field RX_WAKEUP_INT[1] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for RX_WAKEUP_INT_STATUS interrupt.
 * - 0 - Interrupt status masked RX_WAKEUP_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT (1U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.RX_WAKEUP_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT) & BM_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT)

/*! @brief Set the RX_WAKEUP_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT) | BF_MIPI_HSI_IRQSTAT_EN_RX_WAKEUP_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field RX_TIMEOUT_INT[2] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for RX_TIMEOUT_INT_STATUS interrupt.
 * - 0 - Interrupt status masked RX_TIMEOUT_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT (2U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.RX_TIMEOUT_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT) & BM_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT)

/*! @brief Set the RX_TIMEOUT_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT) | BF_MIPI_HSI_IRQSTAT_EN_RX_TIMEOUT_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field DMA_INT[3] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for DMA_INT_STATUS interrupt.
 * - 0 - Interrupt status masked DMA_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_DMA_INT (3U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_DMA_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_DMA_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_DMA_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_DMA_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_DMA_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_DMA_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_DMA_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.DMA_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_DMA_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_DMA_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_DMA_INT) & BM_MIPI_HSI_IRQSTAT_EN_DMA_INT)

/*! @brief Set the DMA_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_DMA_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_DMA_INT) | BF_MIPI_HSI_IRQSTAT_EN_DMA_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field DMA_ERR_INT[4] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for DMA_ERROR_INT_STATUS interrupt.
 * - 0 - Interrupt status masked DMA_ERROR_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT (4U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.DMA_ERR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT) & BM_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT)

/*! @brief Set the DMA_ERR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT) | BF_MIPI_HSI_IRQSTAT_EN_DMA_ERR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field TX_TIMEOUT_ERR_INT[5] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for TX_TIMEOUT_ERR status interrupt.
 * - 0 - Interrupt status masked TX_TIMEOUT_ERR status interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT (5U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.TX_TIMEOUT_ERR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT) & BM_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT)

/*! @brief Set the TX_TIMEOUT_ERR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT) | BF_MIPI_HSI_IRQSTAT_EN_TX_TIMEOUT_ERR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field RX_ERROR_INT[6] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for RX_ERROR status interrupt.
 * - 0 - Interrupt status masked RX_ERROR status interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT (6U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.RX_ERROR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT) & BM_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT)

/*! @brief Set the RX_ERROR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT) | BF_MIPI_HSI_IRQSTAT_EN_RX_ERROR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field RX_BREAK_INT[7] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for RX_BREAK status interrupt.
 * - 0 - Interrupt status masked RX_BREAK status interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT (7U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.RX_BREAK_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT) & BM_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT)

/*! @brief Set the RX_BREAK_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT) | BF_MIPI_HSI_IRQSTAT_EN_RX_BREAK_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSTAT_EN, field TX_EMPTY_INT[8] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for TX_EMPTY_INT_STATUS interrupt.
 * - 0 - Interrupt status masked TX_EMPTY_INT_STATUS interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT (8U) /*!< Bit position for MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT. */
#define BM_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT. */
#define BS_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT field. */
#define BR_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT(x) (HW_MIPI_HSI_IRQSTAT_EN(x).B.TX_EMPTY_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT. */
#define BF_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT) & BM_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT)

/*! @brief Set the TX_EMPTY_INT field to a new value. */
#define BW_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT(x, v) (HW_MIPI_HSI_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT) | BF_MIPI_HSI_IRQSTAT_EN_TX_EMPTY_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_IRQSIG_EN - HSI Interrupt Signal Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_IRQSIG_EN - HSI Interrupt Signal Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller Interrupt Signal Enable.
 */
typedef union _hw_mipi_hsi_irqsig_en
{
    uint32_t U;
    struct _hw_mipi_hsi_irqsig_en_bitfields
    {
        uint32_t FIFO_THRESHOLD_INT : 1; /*!< [0]  */
        uint32_t RX_WAKEUP_INT : 1;    /*!< [1]  */
        uint32_t RX_TIMEOUT_INT : 1;   /*!< [2]  */
        uint32_t DMA_INT : 1;          /*!< [3]  */
        uint32_t DMA_ERR_INT : 1;      /*!< [4]  */
        uint32_t TX_TIMEOUT_ERR_INT : 1; /*!< [5]  */
        uint32_t RX_ERROR_INT : 1;     /*!< [6]  */
        uint32_t RX_BREAK_INT : 1;     /*!< [7]  */
        uint32_t TX_EMPTY_INT : 1;     /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_mipi_hsi_irqsig_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_IRQSIG_EN register
 */
/*@{*/
#define HW_MIPI_HSI_IRQSIG_EN_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_MIPI_HSI_IRQSIG_EN(x) (*(__IO hw_mipi_hsi_irqsig_en_t *) HW_MIPI_HSI_IRQSIG_EN_ADDR(x))
#define HW_MIPI_HSI_IRQSIG_EN_RD(x) (HW_MIPI_HSI_IRQSIG_EN(x).U)
#define HW_MIPI_HSI_IRQSIG_EN_WR(x, v) (HW_MIPI_HSI_IRQSIG_EN(x).U = (v))
#define HW_MIPI_HSI_IRQSIG_EN_SET(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, HW_MIPI_HSI_IRQSIG_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_IRQSIG_EN_CLR(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_IRQSIG_EN_TOG(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, HW_MIPI_HSI_IRQSIG_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_IRQSIG_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field FIFO_THRESHOLD_INT[0] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for HSI FIFO_THRESHOLD interrupt.
 * - 0 - Interrupt signal masked for HSI FIFO_THRESHOLD interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT (0U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.FIFO_THRESHOLD_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT) & BM_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT)

/*! @brief Set the FIFO_THRESHOLD_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT) | BF_MIPI_HSI_IRQSIG_EN_FIFO_THRESHOLD_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field RX_WAKEUP_INT[1] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for HSI RX Wakeup interrupt.
 * - 0 - Interrupt signal masked for HSI RX Wakeup interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT (1U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.RX_WAKEUP_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT) & BM_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT)

/*! @brief Set the RX_WAKEUP_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT) | BF_MIPI_HSI_IRQSIG_EN_RX_WAKEUP_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field RX_TIMEOUT_INT[2] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for RX TIMEOUT interrupt.
 * - 0 - Interrupt signal masked for RX TIMEOUT interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT (2U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.RX_TIMEOUT_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT) & BM_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT)

/*! @brief Set the RX_TIMEOUT_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT) | BF_MIPI_HSI_IRQSIG_EN_RX_TIMEOUT_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field DMA_INT[3] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for DMA Completed interrupt.
 * - 0 - Interrupt signal masked for DMA Completed interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_DMA_INT (3U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_DMA_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_DMA_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_DMA_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_DMA_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_DMA_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_DMA_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_DMA_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.DMA_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_DMA_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_DMA_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_DMA_INT) & BM_MIPI_HSI_IRQSIG_EN_DMA_INT)

/*! @brief Set the DMA_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_DMA_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_DMA_INT) | BF_MIPI_HSI_IRQSIG_EN_DMA_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field DMA_ERR_INT[4] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for DMA Error interrupt.
 * - 0 - Interrupt signal masked for DMA Error interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT (4U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_DMA_ERR_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_DMA_ERR_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_DMA_ERR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_DMA_ERR_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.DMA_ERR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_DMA_ERR_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT) & BM_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT)

/*! @brief Set the DMA_ERR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT) | BF_MIPI_HSI_IRQSIG_EN_DMA_ERR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field TX_TIMEOUT_ERR_INT[5] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for TX Timeout Error interrupt.
 * - 0 - Interrupt signal masked for TX Timeout Error interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT (5U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.TX_TIMEOUT_ERR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT) & BM_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT)

/*! @brief Set the TX_TIMEOUT_ERR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT) | BF_MIPI_HSI_IRQSIG_EN_TX_TIMEOUT_ERR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field RX_ERROR_INT[6] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for RX Error interrupt.
 * - 0 - Interrupt signal masked for RX Error interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT (6U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_RX_ERROR_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_RX_ERROR_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_RX_ERROR_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_RX_ERROR_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.RX_ERROR_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_RX_ERROR_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT) & BM_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT)

/*! @brief Set the RX_ERROR_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT) | BF_MIPI_HSI_IRQSIG_EN_RX_ERROR_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field RX_BREAK_INT[7] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for RX_BREAK interrupt.
 * - 0 - Interrupt signal masked for RX_BREAK interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT (7U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_RX_BREAK_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_RX_BREAK_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_RX_BREAK_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_RX_BREAK_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.RX_BREAK_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_RX_BREAK_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT) & BM_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT)

/*! @brief Set the RX_BREAK_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT) | BF_MIPI_HSI_IRQSIG_EN_RX_BREAK_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_IRQSIG_EN, field TX_EMPTY_INT[8] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for HSI TX_EMPTY interrupt.
 * - 0 - Interrupt signal masked for HSI TX_EMPTY interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT (8U) /*!< Bit position for MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT. */
#define BM_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT. */
#define BS_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT (1U) /*!< Bit field size in bits for MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT. */

/*! @brief Read current value of the MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT field. */
#define BR_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT(x) (HW_MIPI_HSI_IRQSIG_EN(x).B.TX_EMPTY_INT)

/*! @brief Format value for bitfield MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT. */
#define BF_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT) & BM_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT)

/*! @brief Set the TX_EMPTY_INT field to a new value. */
#define BW_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT(x, v) (HW_MIPI_HSI_IRQSIG_EN_WR(x, (HW_MIPI_HSI_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT) | BF_MIPI_HSI_IRQSIG_EN_TX_EMPTY_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_FIFO_THR_IRQSTAT - HSI FIFO Threshold Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_FIFO_THR_IRQSTAT - HSI FIFO Threshold Interrupt Status Register (RO)
 *
 * Reset value: 0xFFFF0000U
 *
 * This register contains the HSI controller FIFO Threshold Interrupt Status.
 */
typedef union _hw_mipi_hsi_fifo_thr_irqstat
{
    uint32_t U;
    struct _hw_mipi_hsi_fifo_thr_irqstat_bitfields
    {
        uint32_t RX_CH0_INT : 1;       /*!< [0]  */
        uint32_t RX_CH1_INT : 1;       /*!< [1]  */
        uint32_t RX_CH2_INT : 1;       /*!< [2]  */
        uint32_t RX_CH3_INT : 1;       /*!< [3]  */
        uint32_t RX_CH4_INT : 1;       /*!< [4]  */
        uint32_t RX_CH5_INT : 1;       /*!< [5]  */
        uint32_t RX_CH6_INT : 1;       /*!< [6]  */
        uint32_t RX_CH7_INT : 1;       /*!< [7]  */
        uint32_t RX_CH8_INT : 1;       /*!< [8]  */
        uint32_t RX_CH9_INT : 1;       /*!< [9]  */
        uint32_t RX_CH10_INT : 1;      /*!< [10]  */
        uint32_t RX_CH11_INT : 1;      /*!< [11]  */
        uint32_t RX_CH12_INT : 1;      /*!< [12]  */
        uint32_t RX_CH13_INT : 1;      /*!< [13]  */
        uint32_t RX_CH14_INT : 1;      /*!< [14]  */
        uint32_t RX_CH15_INT : 1;      /*!< [15]  */
        uint32_t TX_CH0_INT : 1;       /*!< [16]  */
        uint32_t TX_CH1_INT : 1;       /*!< [17]  */
        uint32_t TX_CH2_INT : 1;       /*!< [18]  */
        uint32_t TX_CH3_INT : 1;       /*!< [19]  */
        uint32_t TX_CH4_INT : 1;       /*!< [20]  */
        uint32_t TX_CH5_INT : 1;       /*!< [21]  */
        uint32_t TX_CH6_INT : 1;       /*!< [22]  */
        uint32_t TX_CH7_INT : 1;       /*!< [23]  */
        uint32_t TX_CH8_INT : 1;       /*!< [24]  */
        uint32_t TX_CH9_INT : 1;       /*!< [25]  */
        uint32_t TX_CH10_INT : 1;      /*!< [26]  */
        uint32_t TX_CH11_INT : 1;      /*!< [27]  */
        uint32_t TX_CH12_INT : 1;      /*!< [28]  */
        uint32_t TX_CH13_INT : 1;      /*!< [29]  */
        uint32_t TX_CH14_INT : 1;      /*!< [30]  */
        uint32_t TX_CH15_INT : 1;      /*!< [31]  */
    } B;
} hw_mipi_hsi_fifo_thr_irqstat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_FIFO_THR_IRQSTAT register
 */
/*@{*/
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_MIPI_HSI_FIFO_THR_IRQSTAT(x) (*(__I hw_mipi_hsi_fifo_thr_irqstat_t *) HW_MIPI_HSI_FIFO_THR_IRQSTAT_ADDR(x))
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_RD(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_FIFO_THR_IRQSTAT bitfields
 */

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH0_INT[0] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 0 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 0 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT (0U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH0_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH1_INT[1] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 1 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 1 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT (1U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH1_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH2_INT[2] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 2 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 2 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT (2U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH2_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH3_INT[3] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 3 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 3 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT (3U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH3_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH4_INT[4] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 4 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 4 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT (4U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH4_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH5_INT[5] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 5 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 5 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT (5U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH5_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH6_INT[6] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 6 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 6 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT (6U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH6_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH7_INT[7] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 7 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 7 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT (7U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH7_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH8_INT[8] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 8 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 8 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT (8U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH8_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH9_INT[9] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 9 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 9 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT (9U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT (0x00000200U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH9_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH10_INT[10] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 10 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 10 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT (10U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT (0x00000400U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH10_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH11_INT[11] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 11 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 11 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT (11U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT (0x00000800U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH11_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH12_INT[12] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 12 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 12 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT (12U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT (0x00001000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH12_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH13_INT[13] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 13 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 13 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT (13U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT (0x00002000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH13_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH14_INT[14] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 14 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 14 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT (14U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT (0x00004000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH14_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field RX_CH15_INT[15] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Rx Channel 15 FIFO
 * - 0 - Threshold amount of data not reached in Rx Channel 15 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT (15U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT (0x00008000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_RX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.RX_CH15_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH0_INT[16] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 0 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 0 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT (16U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT (0x00010000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH0_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH1_INT[17] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 1 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 1 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT (17U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT (0x00020000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH1_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH2_INT[18] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 2 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 2 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT (18U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT (0x00040000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH2_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH3_INT[19] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 3 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 3 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT (19U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT (0x00080000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH3_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH4_INT[20] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 4 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 4 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT (20U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT (0x00100000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH4_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH5_INT[21] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 5 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 5 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT (21U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT (0x00200000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH5_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH6_INT[22] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 6 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 6 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT (22U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT (0x00400000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH6_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH7_INT[23] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 7 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 7 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT (23U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT (0x00800000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH7_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH8_INT[24] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 8 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 8 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT (24U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT (0x01000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH8_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH9_INT[25] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 9 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 9 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT (25U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT (0x02000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH9_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH10_INT[26] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 10 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 10 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT (26U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT (0x04000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH10_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH11_INT[27] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 11 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 11 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT (27U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT (0x08000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH11_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH12_INT[28] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 12 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 12 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT (28U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT (0x10000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH12_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH13_INT[29] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 13 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 13 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT (29U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT (0x20000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH13_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH14_INT[30] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 14 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 14 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT (30U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT (0x40000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH14_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT, field TX_CH15_INT[31] (RO)
 *
 * Values:
 * - 1 - Threshold amount of data reached in Tx Channel 15 FIFO
 * - 0 - Threshold amount of data not reached in Tx Channel 15 FIFO
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT (31U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT (0x80000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_TX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT(x).B.TX_CH15_INT)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN - HSI FIFO Threshold Interrupt Status Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN - HSI FIFO Threshold Interrupt Status Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller FIFO Threshold Interrupt Status
 * Enable.
 */
typedef union _hw_mipi_hsi_fifo_thr_irqstat_en
{
    uint32_t U;
    struct _hw_mipi_hsi_fifo_thr_irqstat_en_bitfields
    {
        uint32_t RX_CH0_INT : 1;       /*!< [0]  */
        uint32_t RX_CH1_INT : 1;       /*!< [1]  */
        uint32_t RX_CH2_INT : 1;       /*!< [2]  */
        uint32_t RX_CH3_INT : 1;       /*!< [3]  */
        uint32_t RX_CH4_INT : 1;       /*!< [4]  */
        uint32_t RX_CH5_INT : 1;       /*!< [5]  */
        uint32_t RX_CH6_INT : 1;       /*!< [6]  */
        uint32_t RX_CH7_INT : 1;       /*!< [7]  */
        uint32_t RX_CH8_INT : 1;       /*!< [8]  */
        uint32_t RX_CH9_INT : 1;       /*!< [9]  */
        uint32_t RX_CH10_INT : 1;      /*!< [10]  */
        uint32_t RX_CH11_INT : 1;      /*!< [11]  */
        uint32_t RX_CH12_INT : 1;      /*!< [12]  */
        uint32_t RX_CH13_INT : 1;      /*!< [13]  */
        uint32_t RX_CH14_INT : 1;      /*!< [14]  */
        uint32_t RX_CH15_INT : 1;      /*!< [15]  */
        uint32_t TX_CH0_INT : 1;       /*!< [16]  */
        uint32_t TX_CH1_INT : 1;       /*!< [17]  */
        uint32_t TX_CH2_INT : 1;       /*!< [18]  */
        uint32_t TX_CH3_INT : 1;       /*!< [19]  */
        uint32_t TX_CH4_INT : 1;       /*!< [20]  */
        uint32_t TX_CH5_INT : 1;       /*!< [21]  */
        uint32_t TX_CH6_INT : 1;       /*!< [22]  */
        uint32_t TX_CH7_INT : 1;       /*!< [23]  */
        uint32_t TX_CH8_INT : 1;       /*!< [24]  */
        uint32_t TX_CH9_INT : 1;       /*!< [25]  */
        uint32_t TX_CH10_INT : 1;      /*!< [26]  */
        uint32_t TX_CH11_INT : 1;      /*!< [27]  */
        uint32_t TX_CH12_INT : 1;      /*!< [28]  */
        uint32_t TX_CH13_INT : 1;      /*!< [29]  */
        uint32_t TX_CH14_INT : 1;      /*!< [30]  */
        uint32_t TX_CH15_INT : 1;      /*!< [31]  */
    } B;
} hw_mipi_hsi_fifo_thr_irqstat_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_FIFO_THR_IRQSTAT_EN register
 */
/*@{*/
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x) (*(__IO hw_mipi_hsi_fifo_thr_irqstat_en_t *) HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_ADDR(x))
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).U)
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).U = (v))
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_SET(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_CLR(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TOG(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_FIFO_THR_IRQSTAT_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH0_INT[0] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch0 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch0 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT (0U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH0_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT)

/*! @brief Set the RX_CH0_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH0_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH1_INT[1] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch1 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch1 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT (1U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH1_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT)

/*! @brief Set the RX_CH1_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH1_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH2_INT[2] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch2 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch2 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT (2U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH2_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT)

/*! @brief Set the RX_CH2_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH2_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH3_INT[3] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch3 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch3 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT (3U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH3_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT)

/*! @brief Set the RX_CH3_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH3_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH4_INT[4] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch4 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch4 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT (4U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH4_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT)

/*! @brief Set the RX_CH4_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH4_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH5_INT[5] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch5 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch5 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT (5U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH5_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT)

/*! @brief Set the RX_CH5_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH5_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH6_INT[6] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch6 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch6 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT (6U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH6_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT)

/*! @brief Set the RX_CH6_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH6_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH7_INT[7] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch7 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch7 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT (7U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH7_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT)

/*! @brief Set the RX_CH7_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH7_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH8_INT[8] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch8 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch8 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT (8U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH8_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT)

/*! @brief Set the RX_CH8_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH8_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH9_INT[9] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch9 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch9 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT (9U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT (0x00000200U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH9_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT)

/*! @brief Set the RX_CH9_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH9_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH10_INT[10] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch10 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch10 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT (10U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT (0x00000400U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH10_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT)

/*! @brief Set the RX_CH10_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH10_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH11_INT[11] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch11 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch11 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT (11U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT (0x00000800U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH11_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT)

/*! @brief Set the RX_CH11_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH11_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH12_INT[12] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch12 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch12 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT (12U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT (0x00001000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH12_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT)

/*! @brief Set the RX_CH12_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH12_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH13_INT[13] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch13 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch13 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT (13U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT (0x00002000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH13_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT)

/*! @brief Set the RX_CH13_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH13_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH14_INT[14] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch14 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch14 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT (14U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT (0x00004000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH14_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT)

/*! @brief Set the RX_CH14_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH14_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field RX_CH15_INT[15] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch15 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch15 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT (15U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT (0x00008000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.RX_CH15_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT)

/*! @brief Set the RX_CH15_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RX_CH15_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH0_INT[16] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch0 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch0 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT (16U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT (0x00010000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH0_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT)

/*! @brief Set the TX_CH0_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH0_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH1_INT[17] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch1 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch1 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT (17U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT (0x00020000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH1_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT)

/*! @brief Set the TX_CH1_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH1_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH2_INT[18] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch2 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch2 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT (18U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT (0x00040000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH2_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT)

/*! @brief Set the TX_CH2_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH2_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH3_INT[19] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch3 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch3 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT (19U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT (0x00080000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH3_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT)

/*! @brief Set the TX_CH3_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH3_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH4_INT[20] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch4 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch4 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT (20U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT (0x00100000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH4_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT)

/*! @brief Set the TX_CH4_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH4_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH5_INT[21] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch5 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch5 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT (21U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT (0x00200000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH5_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT)

/*! @brief Set the TX_CH5_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH5_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH6_INT[22] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch6 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch6 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT (22U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT (0x00400000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH6_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT)

/*! @brief Set the TX_CH6_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH6_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH7_INT[23] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch7 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch7 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT (23U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT (0x00800000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH7_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT)

/*! @brief Set the TX_CH7_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH7_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH8_INT[24] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch8 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch8 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT (24U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT (0x01000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH8_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT)

/*! @brief Set the TX_CH8_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH8_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH9_INT[25] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch9 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch9 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT (25U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT (0x02000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH9_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT)

/*! @brief Set the TX_CH9_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH9_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH10_INT[26] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch10 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch10 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT (26U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT (0x04000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH10_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT)

/*! @brief Set the TX_CH10_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH10_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH11_INT[27] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch11 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch11 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT (27U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT (0x08000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH11_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT)

/*! @brief Set the TX_CH11_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH11_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH12_INT[28] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch12 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch12 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT (28U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT (0x10000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH12_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT)

/*! @brief Set the TX_CH12_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH12_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH13_INT[29] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch13 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch13 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT (29U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT (0x20000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH13_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT)

/*! @brief Set the TX_CH13_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH13_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH14_INT[30] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch14 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch14 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT (30U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT (0x40000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH14_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT)

/*! @brief Set the TX_CH14_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH14_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSTAT_EN, field TX_CH15_INT[31] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch15 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch15 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT (31U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT (0x80000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN(x).B.TX_CH15_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT) & BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT)

/*! @brief Set the TX_CH15_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT) | BF_MIPI_HSI_FIFO_THR_IRQSTAT_EN_TX_CH15_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_FIFO_THR_IRQSIG_EN - HSI FIFO Threshold Interrupt Signal Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_FIFO_THR_IRQSIG_EN - HSI FIFO Threshold Interrupt Signal Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller FIFO Threshold Interrupt Enable.
 */
typedef union _hw_mipi_hsi_fifo_thr_irqsig_en
{
    uint32_t U;
    struct _hw_mipi_hsi_fifo_thr_irqsig_en_bitfields
    {
        uint32_t RX_CH0_INT : 1;       /*!< [0]  */
        uint32_t RX_CH1_INT : 1;       /*!< [1]  */
        uint32_t RX_CH2_INT : 1;       /*!< [2]  */
        uint32_t RX_CH3_INT : 1;       /*!< [3]  */
        uint32_t RX_CH4_INT : 1;       /*!< [4]  */
        uint32_t RX_CH5_INT : 1;       /*!< [5]  */
        uint32_t RX_CH6_INT : 1;       /*!< [6]  */
        uint32_t RX_CH7_INT : 1;       /*!< [7]  */
        uint32_t RX_CH8_INT : 1;       /*!< [8]  */
        uint32_t RX_CH9_INT : 1;       /*!< [9]  */
        uint32_t RX_CH10_INT : 1;      /*!< [10]  */
        uint32_t RX_CH11_INT : 1;      /*!< [11]  */
        uint32_t RX_CH12_INT : 1;      /*!< [12]  */
        uint32_t RX_CH13_INT : 1;      /*!< [13]  */
        uint32_t RX_CH14_INT : 1;      /*!< [14]  */
        uint32_t RX_CH15_INT : 1;      /*!< [15]  */
        uint32_t TX_CH0_INT : 1;       /*!< [16]  */
        uint32_t TX_CH1_INT : 1;       /*!< [17]  */
        uint32_t TX_CH2_INT : 1;       /*!< [18]  */
        uint32_t TX_CH3_INT : 1;       /*!< [19]  */
        uint32_t TX_CH4_INT : 1;       /*!< [20]  */
        uint32_t TX_CH5_INT : 1;       /*!< [21]  */
        uint32_t TX_CH6_INT : 1;       /*!< [22]  */
        uint32_t TX_CH7_INT : 1;       /*!< [23]  */
        uint32_t TX_CH8_INT : 1;       /*!< [24]  */
        uint32_t TX_CH9_INT : 1;       /*!< [25]  */
        uint32_t TX_CH10_INT : 1;      /*!< [26]  */
        uint32_t TX_CH11_INT : 1;      /*!< [27]  */
        uint32_t TX_CH12_INT : 1;      /*!< [28]  */
        uint32_t TX_CH13_INT : 1;      /*!< [29]  */
        uint32_t TX_CH14_INT : 1;      /*!< [30]  */
        uint32_t TX_CH15_INT : 1;      /*!< [31]  */
    } B;
} hw_mipi_hsi_fifo_thr_irqsig_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_FIFO_THR_IRQSIG_EN register
 */
/*@{*/
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x) (*(__IO hw_mipi_hsi_fifo_thr_irqsig_en_t *) HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_ADDR(x))
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).U)
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).U = (v))
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_SET(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_CLR(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TOG(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_FIFO_THR_IRQSIG_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH0_INT[0] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch0 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch0 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT (0U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT (0x00000001U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH0_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT)

/*! @brief Set the RX_CH0_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH0_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH1_INT[1] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch1 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch1 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT (1U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT (0x00000002U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH1_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT)

/*! @brief Set the RX_CH1_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH1_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH2_INT[2] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch2 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch2 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT (2U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT (0x00000004U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH2_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT)

/*! @brief Set the RX_CH2_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH2_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH3_INT[3] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch3 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch3 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT (3U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT (0x00000008U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH3_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT)

/*! @brief Set the RX_CH3_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH3_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH4_INT[4] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch4 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch4 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT (4U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT (0x00000010U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH4_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT)

/*! @brief Set the RX_CH4_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH4_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH5_INT[5] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch5 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch5 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT (5U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT (0x00000020U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH5_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT)

/*! @brief Set the RX_CH5_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH5_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH6_INT[6] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch6 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch6 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT (6U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT (0x00000040U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH6_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT)

/*! @brief Set the RX_CH6_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH6_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH7_INT[7] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch7 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch7 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT (7U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT (0x00000080U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH7_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT)

/*! @brief Set the RX_CH7_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH7_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH8_INT[8] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch8 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch8 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT (8U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT (0x00000100U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH8_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT)

/*! @brief Set the RX_CH8_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH8_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH9_INT[9] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch9 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch9 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT (9U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT (0x00000200U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH9_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT)

/*! @brief Set the RX_CH9_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH9_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH10_INT[10] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch10 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch10 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT (10U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT (0x00000400U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH10_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT)

/*! @brief Set the RX_CH10_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH10_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH11_INT[11] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch11 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch11 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT (11U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT (0x00000800U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH11_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT)

/*! @brief Set the RX_CH11_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH11_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH12_INT[12] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch12 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch12 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT (12U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT (0x00001000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH12_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT)

/*! @brief Set the RX_CH12_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH12_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH13_INT[13] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch13 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch13 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT (13U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT (0x00002000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH13_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT)

/*! @brief Set the RX_CH13_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH13_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH14_INT[14] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch14 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch14 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT (14U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT (0x00004000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH14_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT)

/*! @brief Set the RX_CH14_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH14_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field RX_CH15_INT[15] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Rx Ch15 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Rx Ch15 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT (15U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT (0x00008000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.RX_CH15_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT)

/*! @brief Set the RX_CH15_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_RX_CH15_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH0_INT[16] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch0 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch0 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT (16U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT (0x00010000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH0_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT)

/*! @brief Set the TX_CH0_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH0_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH1_INT[17] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch1 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch1 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT (17U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT (0x00020000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH1_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT)

/*! @brief Set the TX_CH1_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH1_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH2_INT[18] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch2 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch2 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT (18U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT (0x00040000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH2_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT)

/*! @brief Set the TX_CH2_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH2_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH3_INT[19] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch3 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch3 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT (19U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT (0x00080000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH3_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT)

/*! @brief Set the TX_CH3_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH3_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH4_INT[20] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch4 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch4 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT (20U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT (0x00100000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH4_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT)

/*! @brief Set the TX_CH4_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH4_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH5_INT[21] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch5 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch5 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT (21U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT (0x00200000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH5_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT)

/*! @brief Set the TX_CH5_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH5_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH6_INT[22] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch6 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch6 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT (22U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT (0x00400000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH6_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT)

/*! @brief Set the TX_CH6_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH6_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH7_INT[23] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch7 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch7 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT (23U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT (0x00800000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH7_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT)

/*! @brief Set the TX_CH7_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH7_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH8_INT[24] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch8 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch8 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT (24U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT (0x01000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH8_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT)

/*! @brief Set the TX_CH8_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH8_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH9_INT[25] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch9 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch9 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT (25U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT (0x02000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH9_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT)

/*! @brief Set the TX_CH9_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH9_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH10_INT[26] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch10 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch10 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT (26U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT (0x04000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH10_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT)

/*! @brief Set the TX_CH10_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH10_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH11_INT[27] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch11 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch11 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT (27U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT (0x08000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH11_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT)

/*! @brief Set the TX_CH11_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH11_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH12_INT[28] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch12 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch12 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT (28U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT (0x10000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH12_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT)

/*! @brief Set the TX_CH12_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH12_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH13_INT[29] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch13 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch13 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT (29U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT (0x20000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH13_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT)

/*! @brief Set the TX_CH13_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH13_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH14_INT[30] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch14 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch14 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT (30U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT (0x40000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH14_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT)

/*! @brief Set the TX_CH14_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH14_INT(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_FIFO_THR_IRQSIG_EN, field TX_CH15_INT[31] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for Tx Ch15 threshold Reached interrupt.
 * - 0 - Interrupt signal masked for Tx Ch15 threshold Reached interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT (31U) /*!< Bit position for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT. */
#define BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT (0x80000000U) /*!< Bit mask for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT. */
#define BS_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT (1U) /*!< Bit field size in bits for MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT. */

/*! @brief Read current value of the MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT field. */
#define BR_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT(x) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN(x).B.TX_CH15_INT)

/*! @brief Format value for bitfield MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT. */
#define BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT) & BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT)

/*! @brief Set the TX_CH15_INT field to a new value. */
#define BW_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT(x, v) (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_FIFO_THR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT) | BF_MIPI_HSI_FIFO_THR_IRQSIG_EN_TX_CH15_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_CHn_DP - Tx Channel n Data Port Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_CHn_DP - Tx Channel n Data Port Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register is connected to fifo data port for Tx Channel n.
 */
typedef union _hw_mipi_hsi_tx_chn_dp
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_chn_dp_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_mipi_hsi_tx_chn_dp_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_CHn_DP register
 */
/*@{*/
#define HW_MIPI_HSI_TX_CHn_DP_COUNT (16U)

#define HW_MIPI_HSI_TX_CHn_DP_ADDR(x, n) ((uintptr_t)(x) + 0x50U + (0x4U * (n)))

#define HW_MIPI_HSI_TX_CHn_DP(x, n) (*(__IO hw_mipi_hsi_tx_chn_dp_t *) HW_MIPI_HSI_TX_CHn_DP_ADDR(x, n))
#define HW_MIPI_HSI_TX_CHn_DP_RD(x, n) (HW_MIPI_HSI_TX_CHn_DP(x, n).U)
#define HW_MIPI_HSI_TX_CHn_DP_WR(x, n, v) (HW_MIPI_HSI_TX_CHn_DP(x, n).U = (v))
#define HW_MIPI_HSI_TX_CHn_DP_SET(x, n, v) (HW_MIPI_HSI_TX_CHn_DP_WR(x, n, HW_MIPI_HSI_TX_CHn_DP_RD(x, n) |  (v)))
#define HW_MIPI_HSI_TX_CHn_DP_CLR(x, n, v) (HW_MIPI_HSI_TX_CHn_DP_WR(x, n, HW_MIPI_HSI_TX_CHn_DP_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_TX_CHn_DP_TOG(x, n, v) (HW_MIPI_HSI_TX_CHn_DP_WR(x, n, HW_MIPI_HSI_TX_CHn_DP_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_CHn_DP bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_CHn_DP, field DATA[31:0] (RW)
 *
 * Software could Write/Read this bits to access Tx Channel n.
 */
/*@{*/
#define BP_MIPI_HSI_TX_CHn_DP_DATA (0U)    /*!< Bit position for MIPI_HSI_TX_CHn_DP_DATA. */
#define BM_MIPI_HSI_TX_CHn_DP_DATA (0xFFFFFFFFU) /*!< Bit mask for MIPI_HSI_TX_CHn_DP_DATA. */
#define BS_MIPI_HSI_TX_CHn_DP_DATA (32U)   /*!< Bit field size in bits for MIPI_HSI_TX_CHn_DP_DATA. */

/*! @brief Read current value of the MIPI_HSI_TX_CHn_DP_DATA field. */
#define BR_MIPI_HSI_TX_CHn_DP_DATA(x, n) (HW_MIPI_HSI_TX_CHn_DP(x, n).U)

/*! @brief Format value for bitfield MIPI_HSI_TX_CHn_DP_DATA. */
#define BF_MIPI_HSI_TX_CHn_DP_DATA(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_CHn_DP_DATA) & BM_MIPI_HSI_TX_CHn_DP_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_MIPI_HSI_TX_CHn_DP_DATA(x, n, v) (HW_MIPI_HSI_TX_CHn_DP_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RX_CHn_DP - Rx Channel n Data Port Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RX_CHn_DP - Rx Channel n Data Port Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register is connected to fifo data port for Rx Channel n.
 */
typedef union _hw_mipi_hsi_rx_chn_dp
{
    uint32_t U;
    struct _hw_mipi_hsi_rx_chn_dp_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_mipi_hsi_rx_chn_dp_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RX_CHn_DP register
 */
/*@{*/
#define HW_MIPI_HSI_RX_CHn_DP_COUNT (16U)

#define HW_MIPI_HSI_RX_CHn_DP_ADDR(x, n) ((uintptr_t)(x) + 0x90U + (0x4U * (n)))

#define HW_MIPI_HSI_RX_CHn_DP(x, n) (*(__IO hw_mipi_hsi_rx_chn_dp_t *) HW_MIPI_HSI_RX_CHn_DP_ADDR(x, n))
#define HW_MIPI_HSI_RX_CHn_DP_RD(x, n) (HW_MIPI_HSI_RX_CHn_DP(x, n).U)
#define HW_MIPI_HSI_RX_CHn_DP_WR(x, n, v) (HW_MIPI_HSI_RX_CHn_DP(x, n).U = (v))
#define HW_MIPI_HSI_RX_CHn_DP_SET(x, n, v) (HW_MIPI_HSI_RX_CHn_DP_WR(x, n, HW_MIPI_HSI_RX_CHn_DP_RD(x, n) |  (v)))
#define HW_MIPI_HSI_RX_CHn_DP_CLR(x, n, v) (HW_MIPI_HSI_RX_CHn_DP_WR(x, n, HW_MIPI_HSI_RX_CHn_DP_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_RX_CHn_DP_TOG(x, n, v) (HW_MIPI_HSI_RX_CHn_DP_WR(x, n, HW_MIPI_HSI_RX_CHn_DP_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RX_CHn_DP bitfields
 */

/*!
 * @name Register MIPI_HSI_RX_CHn_DP, field DATA[31:0] (RW)
 *
 * Software could Write/Read this bits to access Rx Channel n.
 */
/*@{*/
#define BP_MIPI_HSI_RX_CHn_DP_DATA (0U)    /*!< Bit position for MIPI_HSI_RX_CHn_DP_DATA. */
#define BM_MIPI_HSI_RX_CHn_DP_DATA (0xFFFFFFFFU) /*!< Bit mask for MIPI_HSI_RX_CHn_DP_DATA. */
#define BS_MIPI_HSI_RX_CHn_DP_DATA (32U)   /*!< Bit field size in bits for MIPI_HSI_RX_CHn_DP_DATA. */

/*! @brief Read current value of the MIPI_HSI_RX_CHn_DP_DATA field. */
#define BR_MIPI_HSI_RX_CHn_DP_DATA(x, n) (HW_MIPI_HSI_RX_CHn_DP(x, n).U)

/*! @brief Format value for bitfield MIPI_HSI_RX_CHn_DP_DATA. */
#define BF_MIPI_HSI_RX_CHn_DP_DATA(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_CHn_DP_DATA) & BM_MIPI_HSI_RX_CHn_DP_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_MIPI_HSI_RX_CHn_DP_DATA(x, n, v) (HW_MIPI_HSI_RX_CHn_DP_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_ERR_IRQSTAT - HSI Error Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_ERR_IRQSTAT - HSI Error Interrupt Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller Error Interrupt Status.
 */
typedef union _hw_mipi_hsi_err_irqstat
{
    uint32_t U;
    struct _hw_mipi_hsi_err_irqstat_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t RX_CH0_TIMEOUT_INT : 1; /*!< [16]  */
        uint32_t RX_CH1_TIMEOUT_INT : 1; /*!< [17]  */
        uint32_t RX_CH2_TIMEOUT_INT : 1; /*!< [18]  */
        uint32_t RX_CH3_TIMEOUT_INT : 1; /*!< [19]  */
        uint32_t RX_CH4_TIMEOUT_INT : 1; /*!< [20]  */
        uint32_t RX_CH5_TIMEOUT_INT : 1; /*!< [21]  */
        uint32_t RX_CH6_TIMEOUT_INT : 1; /*!< [22]  */
        uint32_t RX_CH7_TIMEOUT_INT : 1; /*!< [23]  */
        uint32_t RX_CH8_TIMEOUT_INT : 1; /*!< [24]  */
        uint32_t RX_CH9_TIMEOUT_INT : 1; /*!< [25]  */
        uint32_t RX_CH10_TIMEOUT_INT : 1; /*!< [26]  */
        uint32_t RX_CH11_TIMEOUT_INT : 1; /*!< [27]  */
        uint32_t RX_CH12_TIMEOUT_INT : 1; /*!< [28]  */
        uint32_t RX_CH13_TIMEOUT_INT : 1; /*!< [29]  */
        uint32_t RX_CH14_TIMEOUT_INT : 1; /*!< [30]  */
        uint32_t RX_CH15_TIMEOUT_INT : 1; /*!< [31]  */
    } B;
} hw_mipi_hsi_err_irqstat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_ERR_IRQSTAT register
 */
/*@{*/
#define HW_MIPI_HSI_ERR_IRQSTAT_ADDR(x) ((uintptr_t)(x) + 0xD0U)

#define HW_MIPI_HSI_ERR_IRQSTAT(x) (*(__I hw_mipi_hsi_err_irqstat_t *) HW_MIPI_HSI_ERR_IRQSTAT_ADDR(x))
#define HW_MIPI_HSI_ERR_IRQSTAT_RD(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_ERR_IRQSTAT bitfields
 */

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH0_TIMEOUT_INT[16] (RO)
 *
 * This status bit is set when data timeout counter for ch0 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch0 buffer and then read HSI Status register to find the
 * further status of the Rx ch0 Buffer. The host driver has to read the Rx ch0
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT (16U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT (0x00010000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH0_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH0_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH1_TIMEOUT_INT[17] (RO)
 *
 * This status bit is set when data timeout counter for ch1 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch1 buffer and then read HSI Status register to find the
 * further status of the Rx ch1 Buffer. The host driver has to read the Rx ch1
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT (17U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT (0x00020000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH1_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH1_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH2_TIMEOUT_INT[18] (RO)
 *
 * This status bit is set when data timeout counter for ch2 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch2 buffer and then read HSI Status register to find the
 * further status of the Rx ch2 Buffer. The host driver has to read the Rx ch2
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT (18U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT (0x00040000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH2_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH2_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH3_TIMEOUT_INT[19] (RO)
 *
 * This status bit is set when data timeout counter for ch3 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch3 buffer and then read HSI Status register to find the
 * further status of the Rx ch3 Buffer. The host driver has to read the Rx ch3
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT (19U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT (0x00080000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH3_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH3_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH4_TIMEOUT_INT[20] (RO)
 *
 * This status bit is set when data timeout counter for ch4 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch4 buffer and then read HSI Status register to find the
 * further status of the Rx ch4 Buffer. The host driver has to read the Rx ch4
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT (20U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT (0x00100000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH4_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH4_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH5_TIMEOUT_INT[21] (RO)
 *
 * This status bit is set when data timeout counter for ch5 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch5 buffer and then read HSI Status register to find the
 * further status of the Rx ch5 Buffer. The host driver has to read the Rx ch5
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT (21U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT (0x00200000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH5_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH5_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH6_TIMEOUT_INT[22] (RO)
 *
 * This status bit is set when data timeout counter for ch6 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch6 buffer and then read HSI Status register to find the
 * further status of the Rx ch6 Buffer. The host driver has to read the Rx ch6
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT (22U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT (0x00400000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH6_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH6_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH7_TIMEOUT_INT[23] (RO)
 *
 * This status bit is set when data timeout counter for ch7 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch7 buffer and then read HSI Status register to find the
 * further status of the Rx ch7 Buffer. The host driver has to read the Rx ch7
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT (23U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT (0x00800000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH7_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH7_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH8_TIMEOUT_INT[24] (RO)
 *
 * This status bit is set when data timeout counter for ch8 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch8 buffer and then read HSI Status register to find the
 * further status of the Rx ch8 Buffer. The host driver has to read the Rx ch8
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT (24U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT (0x01000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH8_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH8_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH9_TIMEOUT_INT[25] (RO)
 *
 * This status bit is set when data timeout counter for ch9 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch9 buffer and then read HSI Status register to find the
 * further status of the Rx ch9 Buffer. The host driver has to read the Rx ch9
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT (25U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT (0x02000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH9_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH9_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH10_TIMEOUT_INT[26] (RO)
 *
 * This status bit is set when data timeout counter for ch10 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch10 buffer and then read HSI Status register to find the
 * further status of the Rx ch10 Buffer. The host driver has to read the Rx ch10
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT (26U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT (0x04000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH10_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH10_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH11_TIMEOUT_INT[27] (RO)
 *
 * This status bit is set when data timeout counter for ch11 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch11 buffer and then read HSI Status register to find the
 * further status of the Rx ch11 Buffer. The host driver has to read the Rx ch11
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT (27U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT (0x08000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH11_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH11_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH12_TIMEOUT_INT[28] (RO)
 *
 * This status bit is set when data timeout counter for ch12 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch12 buffer and then read HSI Status register to find the
 * further status of the Rx ch12 Buffer. The host driver has to read the Rx ch12
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT (28U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT (0x10000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH12_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH12_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH13_TIMEOUT_INT[29] (RO)
 *
 * This status bit is set when data timeout counter for ch13 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch13 buffer and then read HSI Status register to find the
 * further status of the Rx ch13 Buffer. The host driver has to read the Rx ch13
 * fifo on Dword basis, till thefifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT (29U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT (0x20000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH13_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH13_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH14_TIMEOUT_INT[30] (RO)
 *
 * This status bit is set when data timeout counter for ch14 reaches the data
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch14 buffer and then read HSI Status register to find the
 * further status of the Rx ch14 Buffer. The host driver has to read the Rx ch14
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT (30U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT (0x40000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH14_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH14_TIMEOUT_INT)
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT, field RX_CH15_TIMEOUT_INT[31] (RO)
 *
 * This status bit is set when data timeout counter for ch15 reaches thedata
 * timeout counter value. On receiving the interrupt the host driver should read
 * 1Dword of data from Rx ch15 buffer and then read HSI Status register to find the
 * further status of the Rx ch15 Buffer. The host driver has to read the Rx ch15
 * fifo on Dword basis, till the fifo is completely empty.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT (31U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT. */
#define BM_MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT (0x80000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT. */
#define BS_MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_RX_CH15_TIMEOUT_INT(x) (HW_MIPI_HSI_ERR_IRQSTAT(x).B.RX_CH15_TIMEOUT_INT)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_ERR_IRQSTAT_EN - HSI Error Interrupt Status Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_ERR_IRQSTAT_EN - HSI Error Interrupt Status Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller Error Interrupt Status Enable.
 */
typedef union _hw_mipi_hsi_err_irqstat_en
{
    uint32_t U;
    struct _hw_mipi_hsi_err_irqstat_en_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t RX_CH0_TIMEOUT_INT_EN : 1; /*!< [16]  */
        uint32_t RX_CH1_TIMEOUT_INT_EN : 1; /*!< [17]  */
        uint32_t RX_CH2_TIMEOUT_INT_EN : 1; /*!< [18]  */
        uint32_t RX_CH3_TIMEOUT_INT_EN : 1; /*!< [19]  */
        uint32_t RX_CH4_TIMEOUT_INT_EN : 1; /*!< [20]  */
        uint32_t RX_CH5_TIMEOUT_INT_EN : 1; /*!< [21]  */
        uint32_t RX_CH6_TIMEOUT_INT_EN : 1; /*!< [22]  */
        uint32_t RX_CH7_TIMEOUT_INT_EN : 1; /*!< [23]  */
        uint32_t RX_CH8_TIMEOUT_INT_EN : 1; /*!< [24]  */
        uint32_t RX_CH9_TIMEOUT_INT_EN : 1; /*!< [25]  */
        uint32_t RX_CH10_TIMEOUT_INT_EN : 1; /*!< [26]  */
        uint32_t RX_CH11_TIMEOUT_INT_EN : 1; /*!< [27]  */
        uint32_t RX_CH12_TIMEOUT_INT_EN : 1; /*!< [28]  */
        uint32_t RX_CH13_TIMEOUT_INT_EN : 1; /*!< [29]  */
        uint32_t RX_CH14_TIMEOUT_INT_EN : 1; /*!< [30]  */
        uint32_t RX_CH15_TIMEOUT_INT_EN : 1; /*!< [31]  */
    } B;
} hw_mipi_hsi_err_irqstat_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_ERR_IRQSTAT_EN register
 */
/*@{*/
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_ADDR(x) ((uintptr_t)(x) + 0xD4U)

#define HW_MIPI_HSI_ERR_IRQSTAT_EN(x) (*(__IO hw_mipi_hsi_err_irqstat_en_t *) HW_MIPI_HSI_ERR_IRQSTAT_EN_ADDR(x))
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).U)
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).U = (v))
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_SET(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_CLR(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_ERR_IRQSTAT_EN_TOG(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_ERR_IRQSTAT_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH0_TIMEOUT_INT_EN[16] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch0 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch0 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN (16U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN (0x00010000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH0_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH0_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH0_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH1_TIMEOUT_INT_EN[17] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch1 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch1 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN (17U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN (0x00020000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH1_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH1_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH1_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH2_TIMEOUT_INT_EN[18] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch2 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch2 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN (18U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN (0x00040000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH2_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH2_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH2_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH3_TIMEOUT_INT_EN[19] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch3 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch3 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN (19U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN (0x00080000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH3_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH3_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH3_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH4_TIMEOUT_INT_EN[20] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch4 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch4 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN (20U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN (0x00100000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH4_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH4_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH4_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH5_TIMEOUT_INT_EN[21] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch5 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch5 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN (21U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN (0x00200000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH5_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH5_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH5_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH6_TIMEOUT_INT_EN[22] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch6 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch6 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN (22U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN (0x00400000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH6_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH6_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH6_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH7_TIMEOUT_INT_EN[23] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch7 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch7 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN (23U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN (0x00800000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH7_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH7_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH7_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH8_TIMEOUT_INT_EN[24] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch8 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch8 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN (24U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN (0x01000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH8_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH8_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH8_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH9_TIMEOUT_INT_EN[25] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch9 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch9 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN (25U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN (0x02000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH9_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH9_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH9_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH10_TIMEOUT_INT_EN[26] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch10 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch10 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN (26U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN (0x04000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH10_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH10_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH10_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH11_TIMEOUT_INT_EN[27] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch11 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch11 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN (27U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN (0x08000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH11_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH11_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH11_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH12_TIMEOUT_INT_EN[28] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch12 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch12 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN (28U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN (0x10000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH12_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH12_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH12_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH13_TIMEOUT_INT_EN[29] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch13 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch13 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN (29U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN (0x20000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH13_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH13_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH13_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH14_TIMEOUT_INT_EN[30] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch14 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch14 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN (30U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN (0x40000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH14_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH14_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH14_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSTAT_EN, field RX_CH15_TIMEOUT_INT_EN[31] (RW)
 *
 * Values:
 * - 1 - Interrupt status enabled for data timeout for ch15 interrupt.
 * - 0 - Interrupt status masked for data timeout for ch15 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN (31U) /*!< Bit position for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN (0x80000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSTAT_EN(x).B.RX_CH15_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH15_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSTAT_EN_RX_CH15_TIMEOUT_INT_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_ERR_IRQSIG_EN - HSI Error Interrupt Signal Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_ERR_IRQSIG_EN - HSI Error Interrupt Signal Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the HSI controller Error Interrupt Signal Enable.
 */
typedef union _hw_mipi_hsi_err_irqsig_en
{
    uint32_t U;
    struct _hw_mipi_hsi_err_irqsig_en_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t RX_CH0_TIMEOUT_INT_EN : 1; /*!< [16]  */
        uint32_t RX_CH1_TIMEOUT_INT_EN : 1; /*!< [17]  */
        uint32_t RX_CH2_TIMEOUT_INT_EN : 1; /*!< [18]  */
        uint32_t RX_CH3_TIMEOUT_INT_EN : 1; /*!< [19]  */
        uint32_t RX_CH4_TIMEOUT_INT_EN : 1; /*!< [20]  */
        uint32_t RX_CH5_TIMEOUT_INT_EN : 1; /*!< [21]  */
        uint32_t RX_CH6_TIMEOUT_INT_EN : 1; /*!< [22]  */
        uint32_t RX_CH7_TIMEOUT_INT_EN : 1; /*!< [23]  */
        uint32_t RX_CH8_TIMEOUT_INT_EN : 1; /*!< [24]  */
        uint32_t RX_CH9_TIMEOUT_INT_EN : 1; /*!< [25]  */
        uint32_t RX_CH10_TIMEOUT_INT_EN : 1; /*!< [26]  */
        uint32_t RX_CH11_TIMEOUT_INT_EN : 1; /*!< [27]  */
        uint32_t RX_CH12_TIMEOUT_INT_EN : 1; /*!< [28]  */
        uint32_t RX_CH13_TIMEOUT_INT_EN : 1; /*!< [29]  */
        uint32_t RX_CH14_TIMEOUT_INT_EN : 1; /*!< [30]  */
        uint32_t RX_CH15_TIMEOUT_INT_EN : 1; /*!< [31]  */
    } B;
} hw_mipi_hsi_err_irqsig_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_ERR_IRQSIG_EN register
 */
/*@{*/
#define HW_MIPI_HSI_ERR_IRQSIG_EN_ADDR(x) ((uintptr_t)(x) + 0xD8U)

#define HW_MIPI_HSI_ERR_IRQSIG_EN(x) (*(__IO hw_mipi_hsi_err_irqsig_en_t *) HW_MIPI_HSI_ERR_IRQSIG_EN_ADDR(x))
#define HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).U)
#define HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).U = (v))
#define HW_MIPI_HSI_ERR_IRQSIG_EN_SET(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_ERR_IRQSIG_EN_CLR(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_ERR_IRQSIG_EN_TOG(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_ERR_IRQSIG_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH0_TIMEOUT_INT_EN[16] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch0 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch0 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN (16U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN (0x00010000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH0_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH0_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH0_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH1_TIMEOUT_INT_EN[17] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch1 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch1interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN (17U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN (0x00020000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH1_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH1_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH1_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH2_TIMEOUT_INT_EN[18] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch2 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch2 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN (18U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN (0x00040000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH2_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH2_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH2_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH3_TIMEOUT_INT_EN[19] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch3 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch3 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN (19U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN (0x00080000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH3_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH3_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH3_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH4_TIMEOUT_INT_EN[20] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch4 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch4 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN (20U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN (0x00100000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH4_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH4_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH4_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH5_TIMEOUT_INT_EN[21] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch5 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch5 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN (21U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN (0x00200000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH5_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH5_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH5_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH6_TIMEOUT_INT_EN[22] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch6 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch6 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN (22U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN (0x00400000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH6_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH6_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH6_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH7_TIMEOUT_INT_EN[23] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch7 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch7 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN (23U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN (0x00800000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH7_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH7_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH7_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH8_TIMEOUT_INT_EN[24] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch8 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch8 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN (24U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN (0x01000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH8_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH8_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH8_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH9_TIMEOUT_INT_EN[25] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch9 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch9 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN (25U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN (0x02000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH9_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH9_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH9_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH10_TIMEOUT_INT_EN[26] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch10 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch10 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN (26U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN (0x04000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH10_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH10_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH10_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH11_TIMEOUT_INT_EN[27] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch11 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch11 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN (27U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN (0x08000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH11_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH11_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH11_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH12_TIMEOUT_INT_EN[28] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch12 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch12 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN (28U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN (0x10000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH12_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH12_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH12_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH13_TIMEOUT_INT_EN[29] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch13 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch13 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN (29U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN (0x20000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH13_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH13_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH13_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH14_TIMEOUT_INT_EN[30] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch14 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch14 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN (30U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN (0x40000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH14_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH14_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH14_TIMEOUT_INT_EN(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_ERR_IRQSIG_EN, field RX_CH15_TIMEOUT_INT_EN[31] (RW)
 *
 * Setting this bit will enable interrupt generation on interrupt line.
 *
 * Values:
 * - 1 - Interrupt signal enabled for data timeout for ch15 interrupt.
 * - 0 - Interrupt signal masked for data timeout for ch15 interrupt.
 */
/*@{*/
#define BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN (31U) /*!< Bit position for MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN (0x80000000U) /*!< Bit mask for MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BS_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN (1U) /*!< Bit field size in bits for MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN. */

/*! @brief Read current value of the MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN field. */
#define BR_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN(x) (HW_MIPI_HSI_ERR_IRQSIG_EN(x).B.RX_CH15_TIMEOUT_INT_EN)

/*! @brief Format value for bitfield MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN. */
#define BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN) & BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN)

/*! @brief Set the RX_CH15_TIMEOUT_INT_EN field to a new value. */
#define BW_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN(x, v) (HW_MIPI_HSI_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN) | BF_MIPI_HSI_ERR_IRQSIG_EN_RX_CH15_TIMEOUT_INT_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TDMAn_CONF - Tx DMA Channel n Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TDMAn_CONF - Tx DMA Channel n Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the configurations of enable/disable, burst size and
 * transfer count for Tx DMA channel n.
 */
typedef union _hw_mipi_hsi_tdman_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_tdman_conf_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t TRANS_LENGTH : 20;    /*!< [24:5]  */
        uint32_t BURST_SIZE : 4;       /*!< [28:25]  */
        uint32_t RESERVED1 : 2;        /*!< [30:29]  */
        uint32_t ENABLE : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_tdman_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TDMAn_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_TDMAn_CONF_COUNT (16U)

#define HW_MIPI_HSI_TDMAn_CONF_ADDR(x, n) ((uintptr_t)(x) + 0xDCU + (0x4U * (n)))

#define HW_MIPI_HSI_TDMAn_CONF(x, n) (*(__IO hw_mipi_hsi_tdman_conf_t *) HW_MIPI_HSI_TDMAn_CONF_ADDR(x, n))
#define HW_MIPI_HSI_TDMAn_CONF_RD(x, n) (HW_MIPI_HSI_TDMAn_CONF(x, n).U)
#define HW_MIPI_HSI_TDMAn_CONF_WR(x, n, v) (HW_MIPI_HSI_TDMAn_CONF(x, n).U = (v))
#define HW_MIPI_HSI_TDMAn_CONF_SET(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, HW_MIPI_HSI_TDMAn_CONF_RD(x, n) |  (v)))
#define HW_MIPI_HSI_TDMAn_CONF_CLR(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, HW_MIPI_HSI_TDMAn_CONF_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_TDMAn_CONF_TOG(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, HW_MIPI_HSI_TDMAn_CONF_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TDMAn_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_TDMAn_CONF, field TRANS_LENGTH[24:5] (RW)
 *
 * Transfer data length for Tx DMA channel n. The unit is Dword. h1 1Dword to
 * transfer h2 2Dwords to transfer hfffff 1048575Dwords to transfer
 */
/*@{*/
#define BP_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH (5U) /*!< Bit position for MIPI_HSI_TDMAn_CONF_TRANS_LENGTH. */
#define BM_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH (0x01FFFFE0U) /*!< Bit mask for MIPI_HSI_TDMAn_CONF_TRANS_LENGTH. */
#define BS_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH (20U) /*!< Bit field size in bits for MIPI_HSI_TDMAn_CONF_TRANS_LENGTH. */

/*! @brief Read current value of the MIPI_HSI_TDMAn_CONF_TRANS_LENGTH field. */
#define BR_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH(x, n) (HW_MIPI_HSI_TDMAn_CONF(x, n).B.TRANS_LENGTH)

/*! @brief Format value for bitfield MIPI_HSI_TDMAn_CONF_TRANS_LENGTH. */
#define BF_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH) & BM_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH)

/*! @brief Set the TRANS_LENGTH field to a new value. */
#define BW_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, (HW_MIPI_HSI_TDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH) | BF_MIPI_HSI_TDMAn_CONF_TRANS_LENGTH(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TDMAn_CONF, field BURST_SIZE[28:25] (RW)
 *
 * Burst size for Tx DMA channel n. The unit is Dword. The burst size should not
 * be larger than relevant TRANS_LENGTH and FIFO_SIZE. h0 1Dword to transfer for
 * each burst h1 2Dword to transfer for each burst h2 4Dword to transfer for
 * each burst h10 1024Dword to transfer for each burst
 */
/*@{*/
#define BP_MIPI_HSI_TDMAn_CONF_BURST_SIZE (25U) /*!< Bit position for MIPI_HSI_TDMAn_CONF_BURST_SIZE. */
#define BM_MIPI_HSI_TDMAn_CONF_BURST_SIZE (0x1E000000U) /*!< Bit mask for MIPI_HSI_TDMAn_CONF_BURST_SIZE. */
#define BS_MIPI_HSI_TDMAn_CONF_BURST_SIZE (4U) /*!< Bit field size in bits for MIPI_HSI_TDMAn_CONF_BURST_SIZE. */

/*! @brief Read current value of the MIPI_HSI_TDMAn_CONF_BURST_SIZE field. */
#define BR_MIPI_HSI_TDMAn_CONF_BURST_SIZE(x, n) (HW_MIPI_HSI_TDMAn_CONF(x, n).B.BURST_SIZE)

/*! @brief Format value for bitfield MIPI_HSI_TDMAn_CONF_BURST_SIZE. */
#define BF_MIPI_HSI_TDMAn_CONF_BURST_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TDMAn_CONF_BURST_SIZE) & BM_MIPI_HSI_TDMAn_CONF_BURST_SIZE)

/*! @brief Set the BURST_SIZE field to a new value. */
#define BW_MIPI_HSI_TDMAn_CONF_BURST_SIZE(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, (HW_MIPI_HSI_TDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_TDMAn_CONF_BURST_SIZE) | BF_MIPI_HSI_TDMAn_CONF_BURST_SIZE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TDMAn_CONF, field ENABLE[31] (RW)
 *
 * Setting this bit enables the inernal Tx DMA channel n.
 */
/*@{*/
#define BP_MIPI_HSI_TDMAn_CONF_ENABLE (31U) /*!< Bit position for MIPI_HSI_TDMAn_CONF_ENABLE. */
#define BM_MIPI_HSI_TDMAn_CONF_ENABLE (0x80000000U) /*!< Bit mask for MIPI_HSI_TDMAn_CONF_ENABLE. */
#define BS_MIPI_HSI_TDMAn_CONF_ENABLE (1U) /*!< Bit field size in bits for MIPI_HSI_TDMAn_CONF_ENABLE. */

/*! @brief Read current value of the MIPI_HSI_TDMAn_CONF_ENABLE field. */
#define BR_MIPI_HSI_TDMAn_CONF_ENABLE(x, n) (HW_MIPI_HSI_TDMAn_CONF(x, n).B.ENABLE)

/*! @brief Format value for bitfield MIPI_HSI_TDMAn_CONF_ENABLE. */
#define BF_MIPI_HSI_TDMAn_CONF_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TDMAn_CONF_ENABLE) & BM_MIPI_HSI_TDMAn_CONF_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_MIPI_HSI_TDMAn_CONF_ENABLE(x, n, v) (HW_MIPI_HSI_TDMAn_CONF_WR(x, n, (HW_MIPI_HSI_TDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_TDMAn_CONF_ENABLE) | BF_MIPI_HSI_TDMAn_CONF_ENABLE(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RDMAn_CONF - Rx DMA Channel n Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RDMAn_CONF - Rx DMA Channel n Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the configurations of enable/disable, burst size and
 * transfer count for Rx DMA channel n.
 */
typedef union _hw_mipi_hsi_rdman_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_rdman_conf_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t TRANS_LENGTH : 20;    /*!< [24:5]  */
        uint32_t BURST_SIZE : 4;       /*!< [28:25]  */
        uint32_t RESERVED1 : 2;        /*!< [30:29]  */
        uint32_t ENABLE : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_rdman_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RDMAn_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_RDMAn_CONF_COUNT (16U)

#define HW_MIPI_HSI_RDMAn_CONF_ADDR(x, n) ((uintptr_t)(x) + 0x11CU + (0x4U * (n)))

#define HW_MIPI_HSI_RDMAn_CONF(x, n) (*(__IO hw_mipi_hsi_rdman_conf_t *) HW_MIPI_HSI_RDMAn_CONF_ADDR(x, n))
#define HW_MIPI_HSI_RDMAn_CONF_RD(x, n) (HW_MIPI_HSI_RDMAn_CONF(x, n).U)
#define HW_MIPI_HSI_RDMAn_CONF_WR(x, n, v) (HW_MIPI_HSI_RDMAn_CONF(x, n).U = (v))
#define HW_MIPI_HSI_RDMAn_CONF_SET(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, HW_MIPI_HSI_RDMAn_CONF_RD(x, n) |  (v)))
#define HW_MIPI_HSI_RDMAn_CONF_CLR(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, HW_MIPI_HSI_RDMAn_CONF_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_RDMAn_CONF_TOG(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, HW_MIPI_HSI_RDMAn_CONF_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RDMAn_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_RDMAn_CONF, field TRANS_LENGTH[24:5] (RW)
 *
 * Transfer data length for Rx DMA channel 0. The unit is Dword. h1 1Dword to
 * transfer h2 2Dwords to transfer hfffff 1048575Dwords to transfer
 */
/*@{*/
#define BP_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH (5U) /*!< Bit position for MIPI_HSI_RDMAn_CONF_TRANS_LENGTH. */
#define BM_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH (0x01FFFFE0U) /*!< Bit mask for MIPI_HSI_RDMAn_CONF_TRANS_LENGTH. */
#define BS_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH (20U) /*!< Bit field size in bits for MIPI_HSI_RDMAn_CONF_TRANS_LENGTH. */

/*! @brief Read current value of the MIPI_HSI_RDMAn_CONF_TRANS_LENGTH field. */
#define BR_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH(x, n) (HW_MIPI_HSI_RDMAn_CONF(x, n).B.TRANS_LENGTH)

/*! @brief Format value for bitfield MIPI_HSI_RDMAn_CONF_TRANS_LENGTH. */
#define BF_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH) & BM_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH)

/*! @brief Set the TRANS_LENGTH field to a new value. */
#define BW_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, (HW_MIPI_HSI_RDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH) | BF_MIPI_HSI_RDMAn_CONF_TRANS_LENGTH(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RDMAn_CONF, field BURST_SIZE[28:25] (RW)
 *
 * Burst size for Rx DMA channel n. The unit is Dword. The burst size should not
 * be larger than relevant TRANS_LENGTH and FIFO_SIZE. h0 1Dword to transfer for
 * each burst h1 2Dword to transfer for each burst h2 4Dword to transfer for
 * each burst h10 1024Dword to transfer for each burst
 */
/*@{*/
#define BP_MIPI_HSI_RDMAn_CONF_BURST_SIZE (25U) /*!< Bit position for MIPI_HSI_RDMAn_CONF_BURST_SIZE. */
#define BM_MIPI_HSI_RDMAn_CONF_BURST_SIZE (0x1E000000U) /*!< Bit mask for MIPI_HSI_RDMAn_CONF_BURST_SIZE. */
#define BS_MIPI_HSI_RDMAn_CONF_BURST_SIZE (4U) /*!< Bit field size in bits for MIPI_HSI_RDMAn_CONF_BURST_SIZE. */

/*! @brief Read current value of the MIPI_HSI_RDMAn_CONF_BURST_SIZE field. */
#define BR_MIPI_HSI_RDMAn_CONF_BURST_SIZE(x, n) (HW_MIPI_HSI_RDMAn_CONF(x, n).B.BURST_SIZE)

/*! @brief Format value for bitfield MIPI_HSI_RDMAn_CONF_BURST_SIZE. */
#define BF_MIPI_HSI_RDMAn_CONF_BURST_SIZE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RDMAn_CONF_BURST_SIZE) & BM_MIPI_HSI_RDMAn_CONF_BURST_SIZE)

/*! @brief Set the BURST_SIZE field to a new value. */
#define BW_MIPI_HSI_RDMAn_CONF_BURST_SIZE(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, (HW_MIPI_HSI_RDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_RDMAn_CONF_BURST_SIZE) | BF_MIPI_HSI_RDMAn_CONF_BURST_SIZE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RDMAn_CONF, field ENABLE[31] (RW)
 *
 * Setting this bit enables the inernal Rx DMA channel n.
 */
/*@{*/
#define BP_MIPI_HSI_RDMAn_CONF_ENABLE (31U) /*!< Bit position for MIPI_HSI_RDMAn_CONF_ENABLE. */
#define BM_MIPI_HSI_RDMAn_CONF_ENABLE (0x80000000U) /*!< Bit mask for MIPI_HSI_RDMAn_CONF_ENABLE. */
#define BS_MIPI_HSI_RDMAn_CONF_ENABLE (1U) /*!< Bit field size in bits for MIPI_HSI_RDMAn_CONF_ENABLE. */

/*! @brief Read current value of the MIPI_HSI_RDMAn_CONF_ENABLE field. */
#define BR_MIPI_HSI_RDMAn_CONF_ENABLE(x, n) (HW_MIPI_HSI_RDMAn_CONF(x, n).B.ENABLE)

/*! @brief Format value for bitfield MIPI_HSI_RDMAn_CONF_ENABLE. */
#define BF_MIPI_HSI_RDMAn_CONF_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RDMAn_CONF_ENABLE) & BM_MIPI_HSI_RDMAn_CONF_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_MIPI_HSI_RDMAn_CONF_ENABLE(x, n, v) (HW_MIPI_HSI_RDMAn_CONF_WR(x, n, (HW_MIPI_HSI_RDMAn_CONF_RD(x, n) & ~BM_MIPI_HSI_RDMAn_CONF_ENABLE) | BF_MIPI_HSI_RDMAn_CONF_ENABLE(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TDMAn_STA_ADDR - Tx DMA Channel n Start Address Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TDMAn_STA_ADDR - Tx DMA Channel n Start Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register containts the physical Start Address HSI for Tx DMA Channel n.
 */
typedef union _hw_mipi_hsi_tdman_sta_addr
{
    uint32_t U;
    struct _hw_mipi_hsi_tdman_sta_addr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t DS_ADDR : 30;         /*!< [31:2]  */
    } B;
} hw_mipi_hsi_tdman_sta_addr_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TDMAn_STA_ADDR register
 */
/*@{*/
#define HW_MIPI_HSI_TDMAn_STA_ADDR_COUNT (16U)

#define HW_MIPI_HSI_TDMAn_STA_ADDR_ADDR(x, n) ((uintptr_t)(x) + 0x15CU + (0x4U * (n)))

#define HW_MIPI_HSI_TDMAn_STA_ADDR(x, n) (*(__IO hw_mipi_hsi_tdman_sta_addr_t *) HW_MIPI_HSI_TDMAn_STA_ADDR_ADDR(x, n))
#define HW_MIPI_HSI_TDMAn_STA_ADDR_RD(x, n) (HW_MIPI_HSI_TDMAn_STA_ADDR(x, n).U)
#define HW_MIPI_HSI_TDMAn_STA_ADDR_WR(x, n, v) (HW_MIPI_HSI_TDMAn_STA_ADDR(x, n).U = (v))
#define HW_MIPI_HSI_TDMAn_STA_ADDR_SET(x, n, v) (HW_MIPI_HSI_TDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_TDMAn_STA_ADDR_RD(x, n) |  (v)))
#define HW_MIPI_HSI_TDMAn_STA_ADDR_CLR(x, n, v) (HW_MIPI_HSI_TDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_TDMAn_STA_ADDR_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_TDMAn_STA_ADDR_TOG(x, n, v) (HW_MIPI_HSI_TDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_TDMAn_STA_ADDR_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TDMAn_STA_ADDR bitfields
 */

/*!
 * @name Register MIPI_HSI_TDMAn_STA_ADDR, field DS_ADDR[31:2] (RW)
 *
 * The Physical Start Address for Tx DMA Channel n. DWord aligned
 */
/*@{*/
#define BP_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR (2U) /*!< Bit position for MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR. */
#define BM_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR (0xFFFFFFFCU) /*!< Bit mask for MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR. */
#define BS_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR (30U) /*!< Bit field size in bits for MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR. */

/*! @brief Read current value of the MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR field. */
#define BR_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR(x, n) (HW_MIPI_HSI_TDMAn_STA_ADDR(x, n).B.DS_ADDR)

/*! @brief Format value for bitfield MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR. */
#define BF_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR) & BM_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR)

/*! @brief Set the DS_ADDR field to a new value. */
#define BW_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR(x, n, v) (HW_MIPI_HSI_TDMAn_STA_ADDR_WR(x, n, (HW_MIPI_HSI_TDMAn_STA_ADDR_RD(x, n) & ~BM_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR) | BF_MIPI_HSI_TDMAn_STA_ADDR_DS_ADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RDMAn_STA_ADDR - Rx DMA Channel n Start Address Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RDMAn_STA_ADDR - Rx DMA Channel n Start Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register containts the physical Start Address HSI for Rx DMA Channel n.
 */
typedef union _hw_mipi_hsi_rdman_sta_addr
{
    uint32_t U;
    struct _hw_mipi_hsi_rdman_sta_addr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t DS_ADDR : 30;         /*!< [31:2]  */
    } B;
} hw_mipi_hsi_rdman_sta_addr_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RDMAn_STA_ADDR register
 */
/*@{*/
#define HW_MIPI_HSI_RDMAn_STA_ADDR_COUNT (16U)

#define HW_MIPI_HSI_RDMAn_STA_ADDR_ADDR(x, n) ((uintptr_t)(x) + 0x19CU + (0x4U * (n)))

#define HW_MIPI_HSI_RDMAn_STA_ADDR(x, n) (*(__IO hw_mipi_hsi_rdman_sta_addr_t *) HW_MIPI_HSI_RDMAn_STA_ADDR_ADDR(x, n))
#define HW_MIPI_HSI_RDMAn_STA_ADDR_RD(x, n) (HW_MIPI_HSI_RDMAn_STA_ADDR(x, n).U)
#define HW_MIPI_HSI_RDMAn_STA_ADDR_WR(x, n, v) (HW_MIPI_HSI_RDMAn_STA_ADDR(x, n).U = (v))
#define HW_MIPI_HSI_RDMAn_STA_ADDR_SET(x, n, v) (HW_MIPI_HSI_RDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_RDMAn_STA_ADDR_RD(x, n) |  (v)))
#define HW_MIPI_HSI_RDMAn_STA_ADDR_CLR(x, n, v) (HW_MIPI_HSI_RDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_RDMAn_STA_ADDR_RD(x, n) & ~(v)))
#define HW_MIPI_HSI_RDMAn_STA_ADDR_TOG(x, n, v) (HW_MIPI_HSI_RDMAn_STA_ADDR_WR(x, n, HW_MIPI_HSI_RDMAn_STA_ADDR_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RDMAn_STA_ADDR bitfields
 */

/*!
 * @name Register MIPI_HSI_RDMAn_STA_ADDR, field DS_ADDR[31:2] (RW)
 *
 * The Physical Start Address for Rx DMA Channel n. DWord aligned
 */
/*@{*/
#define BP_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR (2U) /*!< Bit position for MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR. */
#define BM_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR (0xFFFFFFFCU) /*!< Bit mask for MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR. */
#define BS_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR (30U) /*!< Bit field size in bits for MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR. */

/*! @brief Read current value of the MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR field. */
#define BR_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR(x, n) (HW_MIPI_HSI_RDMAn_STA_ADDR(x, n).B.DS_ADDR)

/*! @brief Format value for bitfield MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR. */
#define BF_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR) & BM_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR)

/*! @brief Set the DS_ADDR field to a new value. */
#define BW_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR(x, n, v) (HW_MIPI_HSI_RDMAn_STA_ADDR_WR(x, n, (HW_MIPI_HSI_RDMAn_STA_ADDR_RD(x, n) & ~BM_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR) | BF_MIPI_HSI_RDMAn_STA_ADDR_DS_ADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_IRQSTAT - DMA Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_IRQSTAT - DMA Interrupt Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains all the interrupt status for HSI internal DMA
 */
typedef union _hw_mipi_hsi_dma_irqstat
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_irqstat_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_irqstat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_IRQSTAT register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_IRQSTAT_ADDR(x) ((uintptr_t)(x) + 0x1DCU)

#define HW_MIPI_HSI_DMA_IRQSTAT(x) (*(__I hw_mipi_hsi_dma_irqstat_t *) HW_MIPI_HSI_DMA_IRQSTAT_ADDR(x))
#define HW_MIPI_HSI_DMA_IRQSTAT_RD(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_IRQSTAT bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA0[0] (RO)
 *
 * RDMA Channel 0 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA0. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA0. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA0(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA1[1] (RO)
 *
 * RDMA Channel 1 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA1. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA1. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA1(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA2[2] (RO)
 *
 * RDMA Channel 2 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA2. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA2. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA2(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA3[3] (RO)
 *
 * RDMA Channel 3 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA3. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA3. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA3(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA4[4] (RO)
 *
 * RDMA Channel 4 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA4. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA4. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA4(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA5[5] (RO)
 *
 * RDMA Channel 5 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA5. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA5. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA5(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA6[6] (RO)
 *
 * RDMA Channel 6 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA6. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA6. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA6(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA7[7] (RO)
 *
 * RDMA Channel 7 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA7. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA7. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA7(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA8[8] (RO)
 *
 * RDMA Channel 8 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA8. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA8. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA8(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA9[9] (RO)
 *
 * RDMA Channel 9 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA9. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA9. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA9(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA10[10] (RO)
 *
 * RDMA Channel 10 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA10. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA10. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA10(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA11[11] (RO)
 *
 * RDMA Channel 11 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA11. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA11. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA11(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA12[12] (RO)
 *
 * RDMA Channel 12 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA12. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA12. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA12(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA13[13] (RO)
 *
 * RDMA Channel 13 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA13. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA13. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA13(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA14[14] (RO)
 *
 * RDMA Channel 14 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA14. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA14. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA14(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field RDMA15[15] (RO)
 *
 * RDMA Channel 15 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_RDMA15. */
#define BM_MIPI_HSI_DMA_IRQSTAT_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_RDMA15. */
#define BS_MIPI_HSI_DMA_IRQSTAT_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_RDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_RDMA15(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.RDMA15)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA0[16] (RO)
 *
 * TDMA Channel 0 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA0. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA0. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA0(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA1[17] (RO)
 *
 * TDMA Channel 1 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA1. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA1. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA1(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA2[18] (RO)
 *
 * TDMA Channel 2 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA2. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA2. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA2(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA3[19] (RO)
 *
 * TDMA Channel 3 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA3. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA3. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA3(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA4[20] (RO)
 *
 * TDMA Channel 4 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA4. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA4. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA4(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA5[21] (RO)
 *
 * TDMA Channel 5 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA5. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA5. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA5(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA6[22] (RO)
 *
 * TDMA Channel 6 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA6. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA6. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA6(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA7[23] (RO)
 *
 * TDMA Channel 7 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA7. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA7. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA7(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA8[24] (RO)
 *
 * TDMA Channel 8 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA8. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA8. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA8(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA9[25] (RO)
 *
 * TDMA Channel 9 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA9. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA9. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA9(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA10[26] (RO)
 *
 * TDMA Channel 10 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA10. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA10. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA10(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA11[27] (RO)
 *
 * TDMA Channel 11 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA11. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA11. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA11(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA12[28] (RO)
 *
 * TDMA Channel 12 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA12. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA12. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA12(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA13[29] (RO)
 *
 * TDMA Channel 13 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA13. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA13. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA13(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA14[30] (RO)
 *
 * TDMA Channel 14 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA14. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA14. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA14(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT, field TDMA15[31] (RO)
 *
 * TDMA Channel 15 interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_TDMA15. */
#define BM_MIPI_HSI_DMA_IRQSTAT_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_TDMA15. */
#define BS_MIPI_HSI_DMA_IRQSTAT_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_TDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_TDMA15(x) (HW_MIPI_HSI_DMA_IRQSTAT(x).B.TDMA15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_IRQSTAT_EN - DMA Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_IRQSTAT_EN - DMA Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register is used to select which DMA interrupt could send to HIS
 * Interrupt Status Register
 */
typedef union _hw_mipi_hsi_dma_irqstat_en
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_irqstat_en_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_irqstat_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_IRQSTAT_EN register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_ADDR(x) ((uintptr_t)(x) + 0x1E0U)

#define HW_MIPI_HSI_DMA_IRQSTAT_EN(x) (*(__IO hw_mipi_hsi_dma_irqstat_en_t *) HW_MIPI_HSI_DMA_IRQSTAT_EN_ADDR(x))
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).U)
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).U = (v))
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_SET(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_CLR(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_DMA_IRQSTAT_EN_TOG(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_IRQSTAT_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA0[0] (RW)
 *
 * RDMA Channel 0 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA0. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA0. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA0. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0)

/*! @brief Set the RDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA1[1] (RW)
 *
 * RDMA Channel 1 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA1. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA1. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA1. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1)

/*! @brief Set the RDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA2[2] (RW)
 *
 * RDMA Channel 2 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA2. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA2. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA2. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2)

/*! @brief Set the RDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA3[3] (RW)
 *
 * RDMA Channel 3 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA3. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA3. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA3. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3)

/*! @brief Set the RDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA4[4] (RW)
 *
 * RDMA Channel 4 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA4. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA4. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA4. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4)

/*! @brief Set the RDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA5[5] (RW)
 *
 * RDMA Channel 5 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA5. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA5. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA5. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5)

/*! @brief Set the RDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA6[6] (RW)
 *
 * RDMA Channel 6 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA6. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA6. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA6. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6)

/*! @brief Set the RDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA7[7] (RW)
 *
 * RDMA Channel 7 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA7. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA7. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA7. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7)

/*! @brief Set the RDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA8[8] (RW)
 *
 * RDMA Channel 8 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA8. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA8. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA8. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8)

/*! @brief Set the RDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA9[9] (RW)
 *
 * RDMA Channel 9 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA9. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA9. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA9. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9)

/*! @brief Set the RDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA10[10] (RW)
 *
 * RDMA Channel 10 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA10. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA10. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA10. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10)

/*! @brief Set the RDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA11[11] (RW)
 *
 * RDMA Channel 11 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA11. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA11. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA11. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11)

/*! @brief Set the RDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA12[12] (RW)
 *
 * RDMA Channel 12 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA12. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA12. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA12. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12)

/*! @brief Set the RDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA13[13] (RW)
 *
 * RDMA Channel 13 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA13. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA13. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA13. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13)

/*! @brief Set the RDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA14[14] (RW)
 *
 * RDMA Channel 14 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA14. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA14. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA14. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14)

/*! @brief Set the RDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field RDMA15[15] (RW)
 *
 * RDMA Channel 15 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_RDMA15. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_RDMA15. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_RDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.RDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_RDMA15. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15) & BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15)

/*! @brief Set the RDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15) | BF_MIPI_HSI_DMA_IRQSTAT_EN_RDMA15(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA0[16] (RW)
 *
 * TDMA Channel 0 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA0. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA0. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA0. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0)

/*! @brief Set the TDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA1[17] (RW)
 *
 * TDMA Channel 1 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA1. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA1. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA1. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1)

/*! @brief Set the TDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA2[18] (RW)
 *
 * TDMA Channel 2 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA2. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA2. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA2. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2)

/*! @brief Set the TDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA3[19] (RW)
 *
 * TDMA Channel 3 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA3. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA3. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA3. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3)

/*! @brief Set the TDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA4[20] (RW)
 *
 * TDMA Channel 4 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA4. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA4. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA4. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4)

/*! @brief Set the TDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA5[21] (RW)
 *
 * TDMA Channel 5 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA5. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA5. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA5. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5)

/*! @brief Set the TDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA6[22] (RW)
 *
 * TDMA Channel 6 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA6. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA6. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA6. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6)

/*! @brief Set the TDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA7[23] (RW)
 *
 * TDMA Channel 7 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA7. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA7. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA7. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7)

/*! @brief Set the TDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA8[24] (RW)
 *
 * TDMA Channel 8 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA8. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA8. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA8. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8)

/*! @brief Set the TDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA9[25] (RW)
 *
 * TDMA Channel 9 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA9. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA9. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA9. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9)

/*! @brief Set the TDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA10[26] (RW)
 *
 * TDMA Channel 10 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA10. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA10. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA10. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10)

/*! @brief Set the TDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA11[27] (RW)
 *
 * TDMA Channel 11 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA11. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA11. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA11. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11)

/*! @brief Set the TDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA12[28] (RW)
 *
 * TDMA Channel 12 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA12. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA12. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA12. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12)

/*! @brief Set the TDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA13[29] (RW)
 *
 * TDMA Channel 13 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA13. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA13. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA13. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13)

/*! @brief Set the TDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA14[30] (RW)
 *
 * TDMA Channel 14 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA14. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA14. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA14. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14)

/*! @brief Set the TDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSTAT_EN, field TDMA15[31] (RW)
 *
 * TDMA Channel 15 interrupt Enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_IRQSTAT_EN_TDMA15. */
#define BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSTAT_EN_TDMA15. */
#define BS_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSTAT_EN_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSTAT_EN_TDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15(x) (HW_MIPI_HSI_DMA_IRQSTAT_EN(x).B.TDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSTAT_EN_TDMA15. */
#define BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15) & BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15)

/*! @brief Set the TDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15(x, v) (HW_MIPI_HSI_DMA_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15) | BF_MIPI_HSI_DMA_IRQSTAT_EN_TDMA15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_IRQSIG_EN - DMA Interrupt Status Signal Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_IRQSIG_EN - DMA Interrupt Status Signal Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register is used to select which DMA interrupt status could send to HIS
 * Interrupt Status Register
 */
typedef union _hw_mipi_hsi_dma_irqsig_en
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_irqsig_en_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_irqsig_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_IRQSIG_EN register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_IRQSIG_EN_ADDR(x) ((uintptr_t)(x) + 0x1E4U)

#define HW_MIPI_HSI_DMA_IRQSIG_EN(x) (*(__IO hw_mipi_hsi_dma_irqsig_en_t *) HW_MIPI_HSI_DMA_IRQSIG_EN_ADDR(x))
#define HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).U)
#define HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).U = (v))
#define HW_MIPI_HSI_DMA_IRQSIG_EN_SET(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_DMA_IRQSIG_EN_CLR(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_DMA_IRQSIG_EN_TOG(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_IRQSIG_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA0[0] (RW)
 *
 * RDMA Channel 0 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA0. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA0. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA0(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA0. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA0) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA0)

/*! @brief Set the RDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA0(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA0) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA1[1] (RW)
 *
 * RDMA Channel 1 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA1. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA1. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA1(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA1. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA1) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA1)

/*! @brief Set the RDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA1(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA1) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA2[2] (RW)
 *
 * RDMA Channel 2 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA2. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA2. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA2(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA2. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA2) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA2)

/*! @brief Set the RDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA2(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA2) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA3[3] (RW)
 *
 * RDMA Channel 3 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA3. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA3. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA3(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA3. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA3) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA3)

/*! @brief Set the RDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA3(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA3) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA4[4] (RW)
 *
 * RDMA Channel 4 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA4. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA4. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA4(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA4. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA4) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA4)

/*! @brief Set the RDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA4(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA4) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA5[5] (RW)
 *
 * RDMA Channel 5 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA5. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA5. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA5(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA5. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA5) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA5)

/*! @brief Set the RDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA5(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA5) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA6[6] (RW)
 *
 * RDMA Channel 6 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA6. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA6. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA6(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA6. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA6) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA6)

/*! @brief Set the RDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA6(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA6) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA7[7] (RW)
 *
 * RDMA Channel 7 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA7. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA7. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA7(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA7. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA7) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA7)

/*! @brief Set the RDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA7(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA7) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA8[8] (RW)
 *
 * RDMA Channel 8 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA8. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA8. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA8(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA8. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA8) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA8)

/*! @brief Set the RDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA8(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA8) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA9[9] (RW)
 *
 * RDMA Channel 9 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA9. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA9. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA9(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA9. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA9) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA9)

/*! @brief Set the RDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA9(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA9) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA10[10] (RW)
 *
 * RDMA Channel 10 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA10. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA10. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA10(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA10. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA10) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA10)

/*! @brief Set the RDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA10(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA10) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA11[11] (RW)
 *
 * RDMA Channel 11 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA11. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA11. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA11(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA11. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA11) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA11)

/*! @brief Set the RDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA11(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA11) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA12[12] (RW)
 *
 * RDMA Channel 12 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA12. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA12. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA12(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA12. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA12) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA12)

/*! @brief Set the RDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA12(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA12) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA13[13] (RW)
 *
 * RDMA Channel 13 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA13. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA13. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA13(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA13. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA13) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA13)

/*! @brief Set the RDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA13(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA13) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA14[14] (RW)
 *
 * RDMA Channel 14 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA14. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA14. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA14(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA14. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA14) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA14)

/*! @brief Set the RDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA14(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA14) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field RDMA15[15] (RW)
 *
 * RDMA Channel 15 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_RDMA15. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_RDMA15. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_RDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_RDMA15(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.RDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_RDMA15. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_RDMA15) & BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA15)

/*! @brief Set the RDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_RDMA15(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_RDMA15) | BF_MIPI_HSI_DMA_IRQSIG_EN_RDMA15(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA0[16] (RW)
 *
 * TDMA Channel 0 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA0. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA0. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA0 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA0(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA0. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA0) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA0)

/*! @brief Set the TDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA0(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA0) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA1[17] (RW)
 *
 * TDMA Channel 1 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA1. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA1. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA1 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA1(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA1. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA1) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA1)

/*! @brief Set the TDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA1(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA1) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA2[18] (RW)
 *
 * TDMA Channel 2 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA2. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA2. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA2 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA2(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA2. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA2) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA2)

/*! @brief Set the TDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA2(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA2) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA3[19] (RW)
 *
 * TDMA Channel 3 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA3. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA3. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA3 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA3(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA3. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA3) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA3)

/*! @brief Set the TDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA3(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA3) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA4[20] (RW)
 *
 * TDMA Channel 4 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA4. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA4. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA4 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA4(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA4. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA4) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA4)

/*! @brief Set the TDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA4(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA4) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA5[21] (RW)
 *
 * TDMA Channel 5 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA5. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA5. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA5 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA5(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA5. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA5) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA5)

/*! @brief Set the TDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA5(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA5) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA6[22] (RW)
 *
 * TDMA Channel 6 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA6. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA6. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA6 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA6(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA6. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA6) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA6)

/*! @brief Set the TDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA6(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA6) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA7[23] (RW)
 *
 * TDMA Channel 7 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA7. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA7. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA7 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA7(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA7. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA7) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA7)

/*! @brief Set the TDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA7(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA7) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA8[24] (RW)
 *
 * TDMA Channel 8 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA8. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA8. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA8 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA8(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA8. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA8) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA8)

/*! @brief Set the TDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA8(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA8) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA9[25] (RW)
 *
 * TDMA Channel 9 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA9. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA9. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA9 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA9(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA9. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA9) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA9)

/*! @brief Set the TDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA9(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA9) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA10[26] (RW)
 *
 * TDMA Channel 10 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA10. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA10. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA10 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA10(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA10. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA10) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA10)

/*! @brief Set the TDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA10(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA10) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA11[27] (RW)
 *
 * TDMA Channel 11 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA11. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA11. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA11 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA11(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA11. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA11) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA11)

/*! @brief Set the TDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA11(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA11) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA12[28] (RW)
 *
 * TDMA Channel 12 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA12. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA12. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA12 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA12(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA12. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA12) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA12)

/*! @brief Set the TDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA12(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA12) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA13[29] (RW)
 *
 * TDMA Channel 13 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA13. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA13. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA13 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA13(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA13. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA13) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA13)

/*! @brief Set the TDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA13(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA13) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA14[30] (RW)
 *
 * TDMA Channel 14 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA14. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA14. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA14 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA14(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA14. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA14) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA14)

/*! @brief Set the TDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA14(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA14) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_IRQSIG_EN, field TDMA15[31] (RW)
 *
 * TDMA Channel 15 interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_IRQSIG_EN_TDMA15. */
#define BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_IRQSIG_EN_TDMA15. */
#define BS_MIPI_HSI_DMA_IRQSIG_EN_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_IRQSIG_EN_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_IRQSIG_EN_TDMA15 field. */
#define BR_MIPI_HSI_DMA_IRQSIG_EN_TDMA15(x) (HW_MIPI_HSI_DMA_IRQSIG_EN(x).B.TDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_IRQSIG_EN_TDMA15. */
#define BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_IRQSIG_EN_TDMA15) & BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA15)

/*! @brief Set the TDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_IRQSIG_EN_TDMA15(x, v) (HW_MIPI_HSI_DMA_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_IRQSIG_EN_TDMA15) | BF_MIPI_HSI_DMA_IRQSIG_EN_TDMA15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_ERR_IRQSTAT - DMA Error Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_ERR_IRQSTAT - DMA Error Interrupt Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains all the error interrupt status for HSI internal DMA
 */
typedef union _hw_mipi_hsi_dma_err_irqstat
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_err_irqstat_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_err_irqstat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_ERR_IRQSTAT register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_ADDR(x) ((uintptr_t)(x) + 0x1E8U)

#define HW_MIPI_HSI_DMA_ERR_IRQSTAT(x) (*(__I hw_mipi_hsi_dma_err_irqstat_t *) HW_MIPI_HSI_DMA_ERR_IRQSTAT_ADDR(x))
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_RD(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_ERR_IRQSTAT bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA0[0] (RO)
 *
 * RDMA Channel 0 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA1[1] (RO)
 *
 * RDMA Channel 1 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA2[2] (RO)
 *
 * RDMA Channel 2 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA3[3] (RO)
 *
 * RDMA Channel 3 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA4[4] (RO)
 *
 * RDMA Channel 4 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA5[5] (RO)
 *
 * RDMA Channel 5 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA6[6] (RO)
 *
 * RDMA Channel 6 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA7[7] (RO)
 *
 * RDMA Channel 7 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA8[8] (RO)
 *
 * RDMA Channel 8 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA9[9] (RO)
 *
 * RDMA Channel 9 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA10[10] (RO)
 *
 * RDMA Channel 10 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA11[11] (RO)
 *
 * RDMA Channel 11 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA12[12] (RO)
 *
 * RDMA Channel 12 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA13[13] (RO)
 *
 * RDMA Channel 13 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA14[14] (RO)
 *
 * RDMA Channel 14 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field RDMA15[15] (RO)
 *
 * RDMA Channel 15 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_RDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.RDMA15)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA0[16] (RO)
 *
 * TDMA Channel 0 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA1[17] (RO)
 *
 * TDMA Channel 1 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA2[18] (RO)
 *
 * TDMA Channel 2 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA3[19] (RO)
 *
 * TDMA Channel 3 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA4[20] (RO)
 *
 * TDMA Channel 4 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA5[21] (RO)
 *
 * TDMA Channel 5 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA6[22] (RO)
 *
 * TDMA Channel 6 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA7[23] (RO)
 *
 * TDMA Channel 7 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA8[24] (RO)
 *
 * TDMA Channel 8 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA9[25] (RO)
 *
 * TDMA Channel 9 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA10[26] (RO)
 *
 * TDMA Channel 10 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA11[27] (RO)
 *
 * TDMA Channel 11 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA12[28] (RO)
 *
 * TDMA Channel 12 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA13[29] (RO)
 *
 * TDMA Channel 13 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA14[30] (RO)
 *
 * TDMA Channel 14 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT, field TDMA15[31] (RO)
 *
 * TDMA Channel 15 error interrupt status
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_TDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT(x).B.TDMA15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN - DMA Error Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN - DMA Error Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to select which DMA error interrupt could send to HIS
 * Interrupt Status Register
 */
typedef union _hw_mipi_hsi_dma_err_irqstat_en
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_err_irqstat_en_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_err_irqstat_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_ERR_IRQSTAT_EN register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_ADDR(x) ((uintptr_t)(x) + 0x1ECU)

#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x) (*(__IO hw_mipi_hsi_dma_err_irqstat_en_t *) HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_ADDR(x))
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).U)
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).U = (v))
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_SET(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_CLR(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TOG(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_ERR_IRQSTAT_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA0[0] (RW)
 *
 * RDMA Channel 0 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0)

/*! @brief Set the RDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA1[1] (RW)
 *
 * RDMA Channel 1 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1)

/*! @brief Set the RDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA2[2] (RW)
 *
 * RDMA Channel 2 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2)

/*! @brief Set the RDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA3[3] (RW)
 *
 * RDMA Channel 3 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3)

/*! @brief Set the RDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA4[4] (RW)
 *
 * RDMA Channel 4 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4)

/*! @brief Set the RDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA5[5] (RW)
 *
 * RDMA Channel 5 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5)

/*! @brief Set the RDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA6[6] (RW)
 *
 * RDMA Channel 6 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6)

/*! @brief Set the RDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA7[7] (RW)
 *
 * RDMA Channel 7 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7)

/*! @brief Set the RDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA8[8] (RW)
 *
 * RDMA Channel 8 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8)

/*! @brief Set the RDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA9[9] (RW)
 *
 * RDMA Channel 9 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9)

/*! @brief Set the RDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA10[10] (RW)
 *
 * RDMA Channel 10 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10)

/*! @brief Set the RDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA11[11] (RW)
 *
 * RDMA Channel 11 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11)

/*! @brief Set the RDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA12[12] (RW)
 *
 * RDMA Channel 12 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12)

/*! @brief Set the RDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA13[13] (RW)
 *
 * RDMA Channel 13 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13)

/*! @brief Set the RDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA14[14] (RW)
 *
 * RDMA Channel 14 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14)

/*! @brief Set the RDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field RDMA15[15] (RW)
 *
 * RDMA Channel 15 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.RDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15)

/*! @brief Set the RDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RDMA15(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA0[16] (RW)
 *
 * TDMA Channel 0 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0)

/*! @brief Set the TDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA1[17] (RW)
 *
 * TDMA Channel 1 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1)

/*! @brief Set the TDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA2[18] (RW)
 *
 * TDMA Channel 2 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2)

/*! @brief Set the TDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA3[19] (RW)
 *
 * TDMA Channel 3 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3)

/*! @brief Set the TDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA4[20] (RW)
 *
 * TDMA Channel 4 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4)

/*! @brief Set the TDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA5[21] (RW)
 *
 * TDMA Channel 5 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5)

/*! @brief Set the TDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA6[22] (RW)
 *
 * TDMA Channel 6 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6)

/*! @brief Set the TDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA7[23] (RW)
 *
 * TDMA Channel 7 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7)

/*! @brief Set the TDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA8[24] (RW)
 *
 * TDMA Channel 8 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8)

/*! @brief Set the TDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA9[25] (RW)
 *
 * TDMA Channel 9 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9)

/*! @brief Set the TDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA10[26] (RW)
 *
 * TDMA Channel 10 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10)

/*! @brief Set the TDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA11[27] (RW)
 *
 * TDMA Channel 11 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11)

/*! @brief Set the TDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA12[28] (RW)
 *
 * TDMA Channel 12 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12)

/*! @brief Set the TDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA13[29] (RW)
 *
 * TDMA Channel 13 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13)

/*! @brief Set the TDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA14[30] (RW)
 *
 * TDMA Channel 14 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14)

/*! @brief Set the TDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSTAT_EN, field TDMA15[31] (RW)
 *
 * TDMA Channel 15 error interrupt enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN(x).B.TDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15. */
#define BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15) & BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15)

/*! @brief Set the TDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSTAT_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15) | BF_MIPI_HSI_DMA_ERR_IRQSTAT_EN_TDMA15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_ERR_IRQSIG_EN - DMA Error Interrupt Signal Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_ERR_IRQSIG_EN - DMA Error Interrupt Signal Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This Register is used to select which DMA error interrupt status could send
 * to HIS Interrupt Status Register
 */
typedef union _hw_mipi_hsi_dma_err_irqsig_en
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_err_irqsig_en_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_err_irqsig_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_ERR_IRQSIG_EN register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_ADDR(x) ((uintptr_t)(x) + 0x1F0U)

#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x) (*(__IO hw_mipi_hsi_dma_err_irqsig_en_t *) HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_ADDR(x))
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).U)
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).U = (v))
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_SET(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) |  (v)))
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_CLR(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~(v)))
#define HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TOG(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_ERR_IRQSIG_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA0[0] (RW)
 *
 * RDMA Channel 0 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0)

/*! @brief Set the RDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA1[1] (RW)
 *
 * RDMA Channel 1 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1)

/*! @brief Set the RDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA2[2] (RW)
 *
 * RDMA Channel 2 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2)

/*! @brief Set the RDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA3[3] (RW)
 *
 * RDMA Channel 3 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3)

/*! @brief Set the RDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA4[4] (RW)
 *
 * RDMA Channel 4 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4)

/*! @brief Set the RDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA5[5] (RW)
 *
 * RDMA Channel 5 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5)

/*! @brief Set the RDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA6[6] (RW)
 *
 * RDMA Channel 6 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6)

/*! @brief Set the RDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA7[7] (RW)
 *
 * RDMA Channel 7 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7)

/*! @brief Set the RDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA8[8] (RW)
 *
 * RDMA Channel 8 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8)

/*! @brief Set the RDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA9[9] (RW)
 *
 * RDMA Channel 9 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9)

/*! @brief Set the RDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA10[10] (RW)
 *
 * RDMA Channel 10 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10)

/*! @brief Set the RDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA11[11] (RW)
 *
 * RDMA Channel 11 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11)

/*! @brief Set the RDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA12[12] (RW)
 *
 * RDMA Channel 12 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12)

/*! @brief Set the RDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA13[13] (RW)
 *
 * RDMA Channel 13 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13)

/*! @brief Set the RDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA14[14] (RW)
 *
 * RDMA Channel 14 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14)

/*! @brief Set the RDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field RDMA15[15] (RW)
 *
 * RDMA Channel 15 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.RDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15)

/*! @brief Set the RDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_RDMA15(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA0[16] (RW)
 *
 * TDMA Channel 0 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA0)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0)

/*! @brief Set the TDMA0 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA1[17] (RW)
 *
 * TDMA Channel 1 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA1)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1)

/*! @brief Set the TDMA1 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA2[18] (RW)
 *
 * TDMA Channel 2 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA2)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2)

/*! @brief Set the TDMA2 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA3[19] (RW)
 *
 * TDMA Channel 3 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA3)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3)

/*! @brief Set the TDMA3 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA4[20] (RW)
 *
 * TDMA Channel 4 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA4)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4)

/*! @brief Set the TDMA4 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA5[21] (RW)
 *
 * TDMA Channel 5 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA5)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5)

/*! @brief Set the TDMA5 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA6[22] (RW)
 *
 * TDMA Channel 6 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA6)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6)

/*! @brief Set the TDMA6 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA7[23] (RW)
 *
 * TDMA Channel 7 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA7)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7)

/*! @brief Set the TDMA7 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA7(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA8[24] (RW)
 *
 * TDMA Channel 8 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA8)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8)

/*! @brief Set the TDMA8 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA9[25] (RW)
 *
 * TDMA Channel 9 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA9)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9)

/*! @brief Set the TDMA9 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA10[26] (RW)
 *
 * TDMA Channel 10 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA10)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10)

/*! @brief Set the TDMA10 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA11[27] (RW)
 *
 * TDMA Channel 11 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA11)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11)

/*! @brief Set the TDMA11 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA12[28] (RW)
 *
 * TDMA Channel 12 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA12)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12)

/*! @brief Set the TDMA12 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA13[29] (RW)
 *
 * TDMA Channel 13 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA13)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13)

/*! @brief Set the TDMA13 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA14[30] (RW)
 *
 * TDMA Channel 14 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA14)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14)

/*! @brief Set the TDMA14 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_ERR_IRQSIG_EN, field TDMA15[31] (RW)
 *
 * TDMA Channel 15 error interrupt status enable
 */
/*@{*/
#define BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15. */
#define BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15. */
#define BS_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15 field. */
#define BR_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15(x) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN(x).B.TDMA15)

/*! @brief Format value for bitfield MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15. */
#define BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15) & BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15)

/*! @brief Set the TDMA15 field to a new value. */
#define BW_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15(x, v) (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_WR(x, (HW_MIPI_HSI_DMA_ERR_IRQSIG_EN_RD(x) & ~BM_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15) | BF_MIPI_HSI_DMA_ERR_IRQSIG_EN_TDMA15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_DMA_SINGLE_REQ_EN - DMA Single Request Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_DMA_SINGLE_REQ_EN - DMA Single Request Enable Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This Register is used to debug
 */
typedef union _hw_mipi_hsi_dma_single_req_en
{
    uint32_t U;
    struct _hw_mipi_hsi_dma_single_req_en_bitfields
    {
        uint32_t RDMA0 : 1;            /*!< [0]  */
        uint32_t RDMA1 : 1;            /*!< [1]  */
        uint32_t RDMA2 : 1;            /*!< [2]  */
        uint32_t RDMA3 : 1;            /*!< [3]  */
        uint32_t RDMA4 : 1;            /*!< [4]  */
        uint32_t RDMA5 : 1;            /*!< [5]  */
        uint32_t RDMA6 : 1;            /*!< [6]  */
        uint32_t RDMA7 : 1;            /*!< [7]  */
        uint32_t RDMA8 : 1;            /*!< [8]  */
        uint32_t RDMA9 : 1;            /*!< [9]  */
        uint32_t RDMA10 : 1;           /*!< [10]  */
        uint32_t RDMA11 : 1;           /*!< [11]  */
        uint32_t RDMA12 : 1;           /*!< [12]  */
        uint32_t RDMA13 : 1;           /*!< [13]  */
        uint32_t RDMA14 : 1;           /*!< [14]  */
        uint32_t RDMA15 : 1;           /*!< [15]  */
        uint32_t TDMA0 : 1;            /*!< [16]  */
        uint32_t TDMA1 : 1;            /*!< [17]  */
        uint32_t TDMA2 : 1;            /*!< [18]  */
        uint32_t TDMA3 : 1;            /*!< [19]  */
        uint32_t TDMA4 : 1;            /*!< [20]  */
        uint32_t TDMA5 : 1;            /*!< [21]  */
        uint32_t TDMA6 : 1;            /*!< [22]  */
        uint32_t TDMA7 : 1;            /*!< [23]  */
        uint32_t TDMA8 : 1;            /*!< [24]  */
        uint32_t TDMA9 : 1;            /*!< [25]  */
        uint32_t TDMA10 : 1;           /*!< [26]  */
        uint32_t TDMA11 : 1;           /*!< [27]  */
        uint32_t TDMA12 : 1;           /*!< [28]  */
        uint32_t TDMA13 : 1;           /*!< [29]  */
        uint32_t TDMA14 : 1;           /*!< [30]  */
        uint32_t TDMA15 : 1;           /*!< [31]  */
    } B;
} hw_mipi_hsi_dma_single_req_en_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_DMA_SINGLE_REQ_EN register
 */
/*@{*/
#define HW_MIPI_HSI_DMA_SINGLE_REQ_EN_ADDR(x) ((uintptr_t)(x) + 0x1F4U)

#define HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x) (*(__I hw_mipi_hsi_dma_single_req_en_t *) HW_MIPI_HSI_DMA_SINGLE_REQ_EN_ADDR(x))
#define HW_MIPI_HSI_DMA_SINGLE_REQ_EN_RD(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_DMA_SINGLE_REQ_EN bitfields
 */

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA0[0] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 0,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0 (0U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0 (0x00000001U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA0(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA1[1] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 1,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1 (1U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1 (0x00000002U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA1(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA2[2] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 2,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2 (2U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2 (0x00000004U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA2(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA3[3] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 3,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3 (3U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3 (0x00000008U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA3(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA4[4] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 4,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4 (4U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4 (0x00000010U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA4(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA5[5] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 5,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5 (5U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5 (0x00000020U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA5(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA6[6] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 6,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6 (6U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6 (0x00000040U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA6(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA7[7] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 7,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7 (7U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7 (0x00000080U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA7(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA8[8] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 8,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8 (8U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8 (0x00000100U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA8(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA9[9] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 9,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9 (9U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9 (0x00000200U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA9(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA10[10] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 10,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10 (10U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10 (0x00000400U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA10(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA11[11] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 11,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11 (11U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11 (0x00000800U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA11(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA12[12] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 12,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12 (12U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12 (0x00001000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA12(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA13[13] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 13,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13 (13U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13 (0x00002000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA13(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA14[14] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 14,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14 (14U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14 (0x00004000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA14(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field RDMA15[15] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Rx Dma Channle 15,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15 (15U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15 (0x00008000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_RDMA15(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.RDMA15)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA0[16] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 0,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0 (16U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0 (0x00010000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA0(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA0)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA1[17] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 1,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1 (17U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1 (0x00020000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA1(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA1)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA2[18] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 2,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2 (18U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2 (0x00040000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA2(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA2)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA3[19] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 3,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3 (19U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3 (0x00080000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA3(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA3)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA4[20] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 4,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4 (20U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4 (0x00100000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA4(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA4)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA5[21] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 5,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5 (21U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5 (0x00200000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA5(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA5)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA6[22] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 6,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6 (22U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6 (0x00400000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA6(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA6)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA7[23] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 7,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7 (23U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7 (0x00800000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA7(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA7)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA8[24] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 8,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8 (24U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8 (0x01000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA8(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA8)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA9[25] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 9,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9 (25U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9 (0x02000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA9(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA9)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA10[26] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 10,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10 (26U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10 (0x04000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA10(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA10)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA11[27] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 11,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11 (27U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11 (0x08000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA11(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA11)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA12[28] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 12,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12 (28U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12 (0x10000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA12(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA12)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA13[29] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 13,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13 (29U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13 (0x20000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA13(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA13)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA14[30] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 14,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14 (30U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14 (0x40000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA14(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA14)
/*@}*/

/*!
 * @name Register MIPI_HSI_DMA_SINGLE_REQ_EN, field TDMA15[31] (RO)
 *
 * When the remain DMA data less than one DMA burst size in Tx Dma Channle 15,
 * this bit will be set automatically
 */
/*@{*/
#define BP_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15 (31U) /*!< Bit position for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15. */
#define BM_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15 (0x80000000U) /*!< Bit mask for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15. */
#define BS_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15 (1U) /*!< Bit field size in bits for MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15. */

/*! @brief Read current value of the MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15 field. */
#define BR_MIPI_HSI_DMA_SINGLE_REQ_EN_TDMA15(x) (HW_MIPI_HSI_DMA_SINGLE_REQ_EN(x).B.TDMA15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_FIFO_SIZE_CONF0 - Tx Fifo Size Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_FIFO_SIZE_CONF0 - Tx Fifo Size Configuration Register 0 (RW)
 *
 * Reset value: 0x55555555U
 *
 * This register is used to config each Tx fifo size
 */
typedef union _hw_mipi_hsi_tx_fifo_size_conf0
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_fifo_size_conf0_bitfields
    {
        uint32_t CH8 : 4;              /*!< [3:0]  */
        uint32_t CH9 : 4;              /*!< [7:4]  */
        uint32_t CH10 : 4;             /*!< [11:8]  */
        uint32_t CH11 : 4;             /*!< [15:12]  */
        uint32_t CH12 : 4;             /*!< [19:16]  */
        uint32_t CH13 : 4;             /*!< [23:20]  */
        uint32_t CH14 : 4;             /*!< [27:24]  */
        uint32_t CH15 : 4;             /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_fifo_size_conf0_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_FIFO_SIZE_CONF0 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_ADDR(x) ((uintptr_t)(x) + 0x200U)

#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x) (*(__IO hw_mipi_hsi_tx_fifo_size_conf0_t *) HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_ADDR(x))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).U)
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).U = (v))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_SET(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CLR(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_TOG(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_FIFO_SIZE_CONF0 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH8[3:0] (RW)
 *
 * This field is used to set the buffer size for channel 8. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 8 buffer size is 1Dword
 * - 0001 - channel 8 buffer size is 2Dwords
 * - 0010 - channel 8 buffer size is 4Dwords
 * - 0011 - channel 8 buffer size is 8Dwords
 * - 0100 - channel 8 buffer size is 16Dwords
 * - 0101 - channel 8 buffer size is 32Dwords
 * - 0110 - channel 8 buffer size is 64Dwords
 * - 0111 - channel 8 buffer size is 128Dwords
 * - 1000 - channel 8 buffer size is 256Dwords
 * - 1001 - channel 8 buffer size is 512Dwords
 * - 1010 - channel 8 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8 (0U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH8)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8)

/*! @brief Set the CH8 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH9[7:4] (RW)
 *
 * This field is used to set the buffer size for channel 9. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 9 buffer size is 1Dword
 * - 0001 - channel 9 buffer size is 2Dwords
 * - 0010 - channel 9 buffer size is 4Dwords
 * - 0011 - channel 9 buffer size is 8Dwords
 * - 0100 - channel 9 buffer size is 16Dwords
 * - 0101 - channel 9 buffer size is 32Dwords
 * - 0110 - channel 9 buffer size is 64Dwords
 * - 0111 - channel 9 buffer size is 128Dwords
 * - 1000 - channel 9 buffer size is 256Dwords
 * - 1001 - channel 9 buffer size is 512Dwords
 * - 1010 - channel 9 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9 (4U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH9)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9)

/*! @brief Set the CH9 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH10[11:8] (RW)
 *
 * This field is used to set the buffer size for channel 10. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 10 buffer size is 1Dword
 * - 0001 - channel 10 buffer size is 2Dwords
 * - 0010 - channel 10 buffer size is 4Dwords
 * - 0011 - channel 10 buffer size is 8Dwords
 * - 0100 - channel 10 buffer size is 16Dwords
 * - 0101 - channel 10 buffer size is 32Dwords
 * - 0110 - channel 10 buffer size is 64Dwords
 * - 0111 - channel 10 buffer size is 128Dwords
 * - 1000 - channel 10 buffer size is 256Dwords
 * - 1001 - channel 10 buffer size is 512Dwords
 * - 1010 - channel 10 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10 (8U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH10)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10)

/*! @brief Set the CH10 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH11[15:12] (RW)
 *
 * This field is used to set the buffer size for channel 11. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 11 buffer size is 1Dword
 * - 0001 - channel 11 buffer size is 2Dwords
 * - 0010 - channel 11 buffer size is 4Dwords
 * - 0011 - channel 11 buffer size is 8Dwords
 * - 0100 - channel 11 buffer size is 16Dwords
 * - 0101 - channel 11 buffer size is 32Dwords
 * - 0110 - channel 11 buffer size is 64Dwords
 * - 0111 - channel 11 buffer size is 128Dwords
 * - 1000 - channel 11 buffer size is 256Dwords
 * - 1001 - channel 11 buffer size is 512Dwords
 * - 1010 - channel 11 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11 (12U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH11)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11)

/*! @brief Set the CH11 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH12[19:16] (RW)
 *
 * This field is used to set the buffer size for channel 12. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 12 buffer size is 1Dword
 * - 0001 - channel 12 buffer size is 2Dwords
 * - 0010 - channel 12 buffer size is 4Dwords
 * - 0011 - channel 12 buffer size is 8Dwords
 * - 0100 - channel 12 buffer size is 16Dwords
 * - 0101 - channel 12 buffer size is 32Dwords
 * - 0110 - channel 12 buffer size is 64Dwords
 * - 0111 - channel 12 buffer size is 128Dwords
 * - 1000 - channel 12 buffer size is 256Dwords
 * - 1001 - channel 12 buffer size is 512Dwords
 * - 1010 - channel 12 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12 (16U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH12)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12)

/*! @brief Set the CH12 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH13[23:20] (RW)
 *
 * This field is used to set the buffer size for channel 13. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 13 buffer size is 1Dword
 * - 0001 - channel 13 buffer size is 2Dwords
 * - 0010 - channel 13 buffer size is 4Dwords
 * - 0011 - channel 13 buffer size is 8Dwords
 * - 0100 - channel 13 buffer size is 16Dwords
 * - 0101 - channel 13 buffer size is 32Dwords
 * - 0110 - channel 13 buffer size is 64Dwords
 * - 0111 - channel 13 buffer size is 128Dwords
 * - 1000 - channel 13 buffer size is 256Dwords
 * - 1001 - channel 13 buffer size is 512Dwords
 * - 1010 - channel 13 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13 (20U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH13)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13)

/*! @brief Set the CH13 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH14[27:24] (RW)
 *
 * This field is used to set the buffer size for channel 14. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 14 buffer size is 1Dword
 * - 0001 - channel 14 buffer size is 2Dwords
 * - 0010 - channel 14 buffer size is 4Dwords
 * - 0011 - channel 14 buffer size is 8Dwords
 * - 0100 - channel 14 buffer size is 16Dwords
 * - 0101 - channel 14 buffer size is 32Dwords
 * - 0110 - channel 14 buffer size is 64Dwords
 * - 0111 - channel 14 buffer size is 128Dwords
 * - 1000 - channel 14 buffer size is 256Dwords
 * - 1001 - channel 14 buffer size is 512Dwords
 * - 1010 - channel 14 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14 (24U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH14)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14)

/*! @brief Set the CH14 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF0, field CH15[31:28] (RW)
 *
 * This field is used to set the buffer size for channel 15. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 15 buffer size is 1Dword
 * - 0001 - channel 15 buffer size is 2Dwords
 * - 0010 - channel 15 buffer size is 4Dwords
 * - 0011 - channel 15 buffer size is 8Dwords
 * - 0100 - channel 15 buffer size is 16Dwords
 * - 0101 - channel 15 buffer size is 32Dwords
 * - 0110 - channel 15 buffer size is 64Dwords
 * - 0111 - channel 15 buffer size is 128Dwords
 * - 1000 - channel 15 buffer size is 256Dwords
 * - 1001 - channel 15 buffer size is 512Dwords
 * - 1010 - channel 15 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15 (28U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0(x).B.CH15)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15)

/*! @brief Set the CH15 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF0_CH15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_FIFO_SIZE_CONF1 - Tx Fifo Size Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_FIFO_SIZE_CONF1 - Tx Fifo Size Configuration Register 1 (RW)
 *
 * Reset value: 0x55555555U
 *
 * This register is used to config each Tx fifo size
 */
typedef union _hw_mipi_hsi_tx_fifo_size_conf1
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_fifo_size_conf1_bitfields
    {
        uint32_t CH0 : 4;              /*!< [3:0]  */
        uint32_t CH1 : 4;              /*!< [7:4]  */
        uint32_t CH2 : 4;              /*!< [11:8]  */
        uint32_t CH3 : 4;              /*!< [15:12]  */
        uint32_t CH4 : 4;              /*!< [19:16]  */
        uint32_t CH5 : 4;              /*!< [23:20]  */
        uint32_t CH6 : 4;              /*!< [27:24]  */
        uint32_t CH7 : 4;              /*!< [31:28]  */
    } B;
} hw_mipi_hsi_tx_fifo_size_conf1_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_FIFO_SIZE_CONF1 register
 */
/*@{*/
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x) (*(__IO hw_mipi_hsi_tx_fifo_size_conf1_t *) HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_ADDR(x))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).U)
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).U = (v))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_SET(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CLR(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_TOG(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_FIFO_SIZE_CONF1 bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH0[3:0] (RW)
 *
 * This field is used to set the buffer size for channel 0. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 0 buffer size is 1Dword
 * - 0001 - channel 0 buffer size is 2Dwords
 * - 0010 - channel 0 buffer size is 4Dwords
 * - 0011 - channel 0 buffer size is 8Dwords
 * - 0100 - channel 0 buffer size is 16Dwords
 * - 0101 - channel 0 buffer size is 32Dwords
 * - 0110 - channel 0 buffer size is 64Dwords
 * - 0111 - channel 0 buffer size is 128Dwords
 * - 1000 - channel 0 buffer size is 256Dwords
 * - 1001 - channel 0 buffer size is 512Dwords
 * - 1010 - channel 0 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0 (0U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0 (0x0000000FU) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH0)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0)

/*! @brief Set the CH0 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH1[7:4] (RW)
 *
 * This field is used to set the buffer size for channel 1. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 1 buffer size is 1Dword
 * - 0001 - channel 1 buffer size is 2Dwords
 * - 0010 - channel 1 buffer size is 4Dwords
 * - 0011 - channel 1 buffer size is 8Dwords
 * - 0100 - channel 1 buffer size is 16Dwords
 * - 0101 - channel 1 buffer size is 32Dwords
 * - 0110 - channel 1 buffer size is 64Dwords
 * - 0111 - channel 1 buffer size is 128Dwords
 * - 1000 - channel 1 buffer size is 256Dwords
 * - 1001 - channel 1 buffer size is 512Dwords
 * - 1010 - channel 1 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1 (4U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1 (0x000000F0U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH1)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1)

/*! @brief Set the CH1 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH2[11:8] (RW)
 *
 * This field is used to set the buffer size for channel 2. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 2 buffer size is 1Dword
 * - 0001 - channel 2 buffer size is 2Dwords
 * - 0010 - channel 2 buffer size is 4Dwords
 * - 0011 - channel 2 buffer size is 8Dwords
 * - 0100 - channel 2 buffer size is 16Dwords
 * - 0101 - channel 2 buffer size is 32Dwords
 * - 0110 - channel 2 buffer size is 64Dwords
 * - 0111 - channel 2 buffer size is 128Dwords
 * - 1000 - channel 2 buffer size is 256Dwords
 * - 1001 - channel 2 buffer size is 512Dwords
 * - 1010 - channel 2 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2 (8U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2 (0x00000F00U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH2)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2)

/*! @brief Set the CH2 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH3[15:12] (RW)
 *
 * This field is used to set the buffer size for channel 3. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 3 buffer size is 1Dword
 * - 0001 - channel 3 buffer size is 2Dwords
 * - 0010 - channel 3 buffer size is 4Dwords
 * - 0011 - channel 3 buffer size is 8Dwords
 * - 0100 - channel 3 buffer size is 16Dwords
 * - 0101 - channel 3 buffer size is 32Dwords
 * - 0110 - channel 3 buffer size is 64Dwords
 * - 0111 - channel 3 buffer size is 128Dwords
 * - 1000 - channel 3 buffer size is 256Dwords
 * - 1001 - channel 3 buffer size is 512Dwords
 * - 1010 - channel 3 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3 (12U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3 (0x0000F000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH3)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3)

/*! @brief Set the CH3 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH4[19:16] (RW)
 *
 * This field is used to set the buffer size for channel 4. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 4 buffer size is 1Dword
 * - 0001 - channel 4 buffer size is 2Dwords
 * - 0010 - channel 4 buffer size is 4Dwords
 * - 0011 - channel 4 buffer size is 8Dwords
 * - 0100 - channel 4 buffer size is 16Dwords
 * - 0101 - channel 4 buffer size is 32Dwords
 * - 0110 - channel 4 buffer size is 64Dwords
 * - 0111 - channel 4 buffer size is 128Dwords
 * - 1000 - channel 4 buffer size is 256Dwords
 * - 1001 - channel 4 buffer size is 512Dwords
 * - 1010 - channel 4 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4 (16U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4 (0x000F0000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH4)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4)

/*! @brief Set the CH4 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH5[23:20] (RW)
 *
 * This field is used to set the buffer size for channel 5. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 5 buffer size is 1Dword
 * - 0001 - channel 5 buffer size is 2Dwords
 * - 0010 - channel 5 buffer size is 4Dwords
 * - 0011 - channel 5 buffer size is 8Dwords
 * - 0100 - channel 5 buffer size is 16Dwords
 * - 0101 - channel 5 buffer size is 32Dwords
 * - 0110 - channel 5 buffer size is 64Dwords
 * - 0111 - channel 5 buffer size is 128Dwords
 * - 1000 - channel 5 buffer size is 256Dwords
 * - 1001 - channel 5 buffer size is 512Dwords
 * - 1010 - channel 5 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5 (20U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5 (0x00F00000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH5)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5)

/*! @brief Set the CH5 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH6[27:24] (RW)
 *
 * This field is used to set the buffer size for channel 6. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 6 buffer size is 1Dword
 * - 0001 - channel 6 buffer size is 2Dwords
 * - 0010 - channel 6 buffer size is 4Dwords
 * - 0011 - channel 6 buffer size is 8Dwords
 * - 0100 - channel 6 buffer size is 16Dwords
 * - 0101 - channel 6 buffer size is 32Dwords
 * - 0110 - channel 6 buffer size is 64Dwords
 * - 0111 - channel 6 buffer size is 128Dwords
 * - 1000 - channel 6 buffer size is 256Dwords
 * - 1001 - channel 6 buffer size is 512Dwords
 * - 1010 - channel 6 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6 (24U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6 (0x0F000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH6)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6)

/*! @brief Set the CH6 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_SIZE_CONF1, field CH7[31:28] (RW)
 *
 * This field is used to set the buffer size for channel 7. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 7 buffer size is 1Dword
 * - 0001 - channel 7 buffer size is 2Dwords
 * - 0010 - channel 7 buffer size is 4Dwords
 * - 0011 - channel 7 buffer size is 8Dwords
 * - 0100 - channel 7 buffer size is 16Dwords
 * - 0101 - channel 7 buffer size is 32Dwords
 * - 0110 - channel 7 buffer size is 64Dwords
 * - 0111 - channel 7 buffer size is 128Dwords
 * - 1000 - channel 7 buffer size is 256Dwords
 * - 1001 - channel 7 buffer size is 512Dwords
 * - 1010 - channel 7 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7 (28U) /*!< Bit position for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7. */
#define BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7 (0xF0000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7. */
#define BS_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7 (4U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7 field. */
#define BR_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7(x) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1(x).B.CH7)

/*! @brief Format value for bitfield MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7. */
#define BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7) & BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7)

/*! @brief Set the CH7 field to a new value. */
#define BW_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7(x, v) (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_TX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7) | BF_MIPI_HSI_TX_FIFO_SIZE_CONF1_CH7(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RX_FIFO_SIZE_CONF0 - Rx Fifo Size Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RX_FIFO_SIZE_CONF0 - Rx Fifo Size Configuration Register 0 (RW)
 *
 * Reset value: 0x55555555U
 *
 * This register is used to config each Rx fifo size
 */
typedef union _hw_mipi_hsi_rx_fifo_size_conf0
{
    uint32_t U;
    struct _hw_mipi_hsi_rx_fifo_size_conf0_bitfields
    {
        uint32_t CH8 : 4;              /*!< [3:0]  */
        uint32_t CH9 : 4;              /*!< [7:4]  */
        uint32_t CH10 : 4;             /*!< [11:8]  */
        uint32_t CH11 : 4;             /*!< [15:12]  */
        uint32_t CH12 : 4;             /*!< [19:16]  */
        uint32_t CH13 : 4;             /*!< [23:20]  */
        uint32_t CH14 : 4;             /*!< [27:24]  */
        uint32_t CH15 : 4;             /*!< [31:28]  */
    } B;
} hw_mipi_hsi_rx_fifo_size_conf0_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RX_FIFO_SIZE_CONF0 register
 */
/*@{*/
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x) (*(__IO hw_mipi_hsi_rx_fifo_size_conf0_t *) HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_ADDR(x))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).U)
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).U = (v))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_SET(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) |  (v)))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CLR(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~(v)))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_TOG(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RX_FIFO_SIZE_CONF0 bitfields
 */

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH8[3:0] (RW)
 *
 * This field is used to set the buffer size for channel 8. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 8 buffer size is 1Dword
 * - 0001 - channel 8 buffer size is 2Dwords
 * - 0010 - channel 8 buffer size is 4Dwords
 * - 0011 - channel 8 buffer size is 8Dwords
 * - 0100 - channel 8 buffer size is 16Dwords
 * - 0101 - channel 8 buffer size is 32Dwords
 * - 0110 - channel 8 buffer size is 64Dwords
 * - 0111 - channel 8 buffer size is 128Dwords
 * - 1000 - channel 8 buffer size is 256Dwords
 * - 1001 - channel 8 buffer size is 512Dwords
 * - 1010 - channel 8 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8 (0U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8 (0x0000000FU) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH8)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8)

/*! @brief Set the CH8 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH8(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH9[7:4] (RW)
 *
 * This field is used to set the buffer size for channel 9. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 9 buffer size is 1Dword
 * - 0001 - channel 9 buffer size is 2Dwords
 * - 0010 - channel 9 buffer size is 4Dwords
 * - 0011 - channel 9 buffer size is 8Dwords
 * - 0100 - channel 9 buffer size is 16Dwords
 * - 0101 - channel 9 buffer size is 32Dwords
 * - 0110 - channel 9 buffer size is 64Dwords
 * - 0111 - channel 9 buffer size is 128Dwords
 * - 1000 - channel 9 buffer size is 256Dwords
 * - 1001 - channel 9 buffer size is 512Dwords
 * - 1010 - channel 9 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9 (4U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9 (0x000000F0U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH9)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9)

/*! @brief Set the CH9 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH9(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH10[11:8] (RW)
 *
 * This field is used to set the buffer size for channel 10. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 10 buffer size is 1Dword
 * - 0001 - channel 10 buffer size is 2Dwords
 * - 0010 - channel 10 buffer size is 4Dwords
 * - 0011 - channel 10 buffer size is 8Dwords
 * - 0100 - channel 10 buffer size is 16Dwords
 * - 0101 - channel 10 buffer size is 32Dwords
 * - 0110 - channel 10 buffer size is 64Dwords
 * - 0111 - channel 10 buffer size is 128Dwords
 * - 1000 - channel 10 buffer size is 256Dwords
 * - 1001 - channel 10 buffer size is 512Dwords
 * - 1010 - channel 10 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10 (8U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10 (0x00000F00U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH10)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10)

/*! @brief Set the CH10 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH10(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH11[15:12] (RW)
 *
 * This field is used to set the buffer size for channel 11. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 11 buffer size is 1Dword
 * - 0001 - channel 11 buffer size is 2Dwords
 * - 0010 - channel 11 buffer size is 4Dwords
 * - 0011 - channel 11 buffer size is 8Dwords
 * - 0100 - channel 11 buffer size is 16Dwords
 * - 0101 - channel 11 buffer size is 32Dwords
 * - 0110 - channel 11 buffer size is 64Dwords
 * - 0111 - channel 11 buffer size is 128Dwords
 * - 1000 - channel 11 buffer size is 256Dwords
 * - 1001 - channel 11 buffer size is 512Dwords
 * - 1010 - channel 11 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11 (12U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11 (0x0000F000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH11)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11)

/*! @brief Set the CH11 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH11(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH12[19:16] (RW)
 *
 * This field is used to set the buffer size for channel 12. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 12 buffer size is 1Dword
 * - 0001 - channel 12 buffer size is 2Dwords
 * - 0010 - channel 12 buffer size is 4Dwords
 * - 0011 - channel 12 buffer size is 8Dwords
 * - 0100 - channel 12 buffer size is 16Dwords
 * - 0101 - channel 12 buffer size is 32Dwords
 * - 0110 - channel 12 buffer size is 64Dwords
 * - 0111 - channel 12 buffer size is 128Dwords
 * - 1000 - channel 12 buffer size is 256Dwords
 * - 1001 - channel 12 buffer size is 512Dwords
 * - 1010 - channel 12 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12 (16U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12 (0x000F0000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH12)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12)

/*! @brief Set the CH12 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH12(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH13[23:20] (RW)
 *
 * This field is used to set the buffer size for channel 13. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 13 buffer size is 1Dword
 * - 0001 - channel 13 buffer size is 2Dwords
 * - 0010 - channel 13 buffer size is 4Dwords
 * - 0011 - channel 13 buffer size is 8Dwords
 * - 0100 - channel 13 buffer size is 16Dwords
 * - 0101 - channel 13 buffer size is 32Dwords
 * - 0110 - channel 13 buffer size is 64Dwords
 * - 0111 - channel 13 buffer size is 128Dwords
 * - 1000 - channel 13 buffer size is 256Dwords
 * - 1001 - channel 13 buffer size is 512Dwords
 * - 1010 - channel 13 buffer size is 1024Dwords
 * - 1111 - b1011 Reserved
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13 (20U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13 (0x00F00000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH13)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13)

/*! @brief Set the CH13 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH13(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH14[27:24] (RW)
 *
 * This field is used to set the buffer size for channel 14. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 14 buffer size is 1Dword
 * - 0001 - channel 14 buffer size is 2Dwords
 * - 0010 - channel 14 buffer size is 4Dwords
 * - 0011 - channel 14 buffer size is 8Dwords
 * - 0100 - channel 14 buffer size is 16Dwords
 * - 0101 - channel 14 buffer size is 32Dwords
 * - 0110 - channel 14 buffer size is 64Dwords
 * - 0111 - channel 14 buffer size is 128Dwords
 * - 1000 - channel 14 buffer size is 256Dwords
 * - 1001 - channel 14 buffer size is 512Dwords
 * - 1010 - channel 14 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14 (24U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14 (0x0F000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH14)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14)

/*! @brief Set the CH14 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH14(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF0, field CH15[31:28] (RW)
 *
 * This field is used to set the buffer size for channel 15. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 15 buffer size is 1Dword
 * - 0001 - channel 15 buffer size is 2Dwords
 * - 0010 - channel 15 buffer size is 4Dwords
 * - 0011 - channel 15 buffer size is 8Dwords
 * - 0100 - channel 15 buffer size is 16Dwords
 * - 0101 - channel 15 buffer size is 32Dwords
 * - 0110 - channel 15 buffer size is 64Dwords
 * - 0111 - channel 15 buffer size is 128Dwords
 * - 1000 - channel 15 buffer size is 256Dwords
 * - 1001 - channel 15 buffer size is 512Dwords
 * - 1010 - channel 15 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15 (28U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15 (0xF0000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0(x).B.CH15)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15)

/*! @brief Set the CH15 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF0_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF0_CH15(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RX_FIFO_SIZE_CONF1 - Rx Fifo Size Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RX_FIFO_SIZE_CONF1 - Rx Fifo Size Configuration Register 1 (RW)
 *
 * Reset value: 0x55555555U
 *
 * This register is used to config each Rx fifo size
 */
typedef union _hw_mipi_hsi_rx_fifo_size_conf1
{
    uint32_t U;
    struct _hw_mipi_hsi_rx_fifo_size_conf1_bitfields
    {
        uint32_t CH0 : 4;              /*!< [3:0]  */
        uint32_t CH1 : 4;              /*!< [7:4]  */
        uint32_t CH2 : 4;              /*!< [11:8]  */
        uint32_t CH3 : 4;              /*!< [15:12]  */
        uint32_t CH4 : 4;              /*!< [19:16]  */
        uint32_t CH5 : 4;              /*!< [23:20]  */
        uint32_t CH6 : 4;              /*!< [27:24]  */
        uint32_t CH7 : 4;              /*!< [31:28]  */
    } B;
} hw_mipi_hsi_rx_fifo_size_conf1_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RX_FIFO_SIZE_CONF1 register
 */
/*@{*/
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_ADDR(x) ((uintptr_t)(x) + 0x20CU)

#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x) (*(__IO hw_mipi_hsi_rx_fifo_size_conf1_t *) HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_ADDR(x))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).U)
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).U = (v))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_SET(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) |  (v)))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CLR(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~(v)))
#define HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_TOG(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RX_FIFO_SIZE_CONF1 bitfields
 */

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH0[3:0] (RW)
 *
 * This field is used to set the buffer size for channel 0. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 0 buffer size is 1Dword
 * - 0001 - channel 0 buffer size is 2Dwords
 * - 0010 - channel 0 buffer size is 4Dwords
 * - 0011 - channel 0 buffer size is 8Dwords
 * - 0100 - channel 0 buffer size is 16Dwords
 * - 0101 - channel 0 buffer size is 32Dwords
 * - 0110 - channel 0 buffer size is 64Dwords
 * - 0111 - channel 0 buffer size is 128Dwords
 * - 1000 - channel 0 buffer size is 256Dwords
 * - 1001 - channel 0 buffer size is 512Dwords
 * - 1010 - channel 0 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0 (0U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0 (0x0000000FU) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH0)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0)

/*! @brief Set the CH0 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH0(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH1[7:4] (RW)
 *
 * This field is used to set the buffer size for channel 1. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 1 buffer size is 1Dword
 * - 0001 - channel 1 buffer size is 2Dwords
 * - 0010 - channel 1 buffer size is 4Dwords
 * - 0011 - channel 1 buffer size is 8Dwords
 * - 0100 - channel 1 buffer size is 16Dwords
 * - 0101 - channel 1 buffer size is 32Dwords
 * - 0110 - channel 1 buffer size is 64Dwords
 * - 0111 - channel 1 buffer size is 128Dwords
 * - 1000 - channel 1 buffer size is 256Dwords
 * - 1001 - channel 1 buffer size is 512Dwords
 * - 1010 - channel 1 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1 (4U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1 (0x000000F0U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH1)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1)

/*! @brief Set the CH1 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH1(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH2[11:8] (RW)
 *
 * This field is used to set the buffer size for channel 2. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 2 buffer size is 1Dword
 * - 0001 - channel 2 buffer size is 2Dwords
 * - 0010 - channel 2 buffer size is 4Dwords
 * - 0011 - channel 2 buffer size is 8Dwords
 * - 0100 - channel 2 buffer size is 16Dwords
 * - 0101 - channel 2 buffer size is 32Dwords
 * - 0110 - channel 2 buffer size is 64Dwords
 * - 0111 - channel 2 buffer size is 128Dwords
 * - 1000 - channel 2 buffer size is 256Dwords
 * - 1001 - channel 2 buffer size is 512Dwords
 * - 1010 - channel 2 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2 (8U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2 (0x00000F00U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH2)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2)

/*! @brief Set the CH2 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH2(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH3[15:12] (RW)
 *
 * This field is used to set the buffer size for channel 3. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 3 buffer size is 1Dword
 * - 0001 - channel 3 buffer size is 2Dwords
 * - 0010 - channel 3 buffer size is 4Dwords
 * - 0011 - channel 3 buffer size is 8Dwords
 * - 0100 - channel 3 buffer size is 16Dwords
 * - 0101 - channel 3 buffer size is 32Dwords
 * - 0110 - channel 3 buffer size is 64Dwords
 * - 0111 - channel 3 buffer size is 128Dwords
 * - 1000 - channel 3 buffer size is 256Dwords
 * - 1001 - channel 3 buffer size is 512Dwords
 * - 1010 - channel 3 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3 (12U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3 (0x0000F000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH3)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3)

/*! @brief Set the CH3 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH3(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH4[19:16] (RW)
 *
 * This field is used to set the buffer size for channel 4. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 4 buffer size is 1Dword
 * - 0001 - channel 4 buffer size is 2Dwords
 * - 0010 - channel 4 buffer size is 4Dwords
 * - 0011 - channel 4 buffer size is 8Dwords
 * - 0100 - channel 4 buffer size is 16Dwords
 * - 0101 - channel 4 buffer size is 32Dwords
 * - 0110 - channel 4 buffer size is 64Dwords
 * - 0111 - channel 4 buffer size is 128Dwords
 * - 1000 - channel 4 buffer size is 256Dwords
 * - 1001 - channel 4 buffer size is 512Dwords
 * - 1010 - channel 4 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4 (16U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4 (0x000F0000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH4)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4)

/*! @brief Set the CH4 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH4(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH5[23:20] (RW)
 *
 * This field is used to set the buffer size for channel 5. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 5 buffer size is 1Dword
 * - 0001 - channel 5 buffer size is 2Dwords
 * - 0010 - channel 5 buffer size is 4Dwords
 * - 0011 - channel 5 buffer size is 8Dwords
 * - 0100 - channel 5 buffer size is 16Dwords
 * - 0101 - channel 5 buffer size is 32Dwords
 * - 0110 - channel 5 buffer size is 64Dwords
 * - 0111 - channel 5 buffer size is 128Dwords
 * - 1000 - channel 5 buffer size is 256Dwords
 * - 1001 - channel 5 buffer size is 512Dwords
 * - 1010 - channel 5 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5 (20U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5 (0x00F00000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH5)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5)

/*! @brief Set the CH5 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH5(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH6[27:24] (RW)
 *
 * This field is used to set the buffer size for channel 6. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 6 buffer size is 1Dword
 * - 0001 - channel 6 buffer size is 2Dwords
 * - 0010 - channel 6 buffer size is 4Dwords
 * - 0011 - channel 6 buffer size is 8Dwords
 * - 0100 - channel 6 buffer size is 16Dwords
 * - 0101 - channel 6 buffer size is 32Dwords
 * - 0110 - channel 6 buffer size is 64Dwords
 * - 0111 - channel 6 buffer size is 128Dwords
 * - 1000 - channel 6 buffer size is 256Dwords
 * - 1001 - channel 6 buffer size is 512Dwords
 * - 1010 - channel 6 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6 (24U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6 (0x0F000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH6)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6)

/*! @brief Set the CH6 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH6(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_SIZE_CONF1, field CH7[31:28] (RW)
 *
 * This field is used to set the buffer size for channel 7. All the allowed
 * combinations of bit setting are listed here .
 *
 * Values:
 * - 0000 - channel 7 buffer size is 1Dword
 * - 0001 - channel 7 buffer size is 2Dwords
 * - 0010 - channel 7 buffer size is 4Dwords
 * - 0011 - channel 7 buffer size is 8Dwords
 * - 0100 - channel 7 buffer size is 16Dwords
 * - 0101 - channel 7 buffer size is 32Dwords
 * - 0110 - channel 7 buffer size is 64Dwords
 * - 0111 - channel 7 buffer size is 128Dwords
 * - 1000 - channel 7 buffer size is 256Dwords
 * - 1001 - channel 7 buffer size is 512Dwords
 * - 1010 - channel 7 buffer size is 1024Dwords
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7 (28U) /*!< Bit position for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7. */
#define BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7 (0xF0000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7. */
#define BS_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7 (4U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7 field. */
#define BR_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7(x) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1(x).B.CH7)

/*! @brief Format value for bitfield MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7. */
#define BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7) & BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7)

/*! @brief Set the CH7 field to a new value. */
#define BW_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7(x, v) (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_WR(x, (HW_MIPI_HSI_RX_FIFO_SIZE_CONF1_RD(x) & ~BM_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7) | BF_MIPI_HSI_RX_FIFO_SIZE_CONF1_CH7(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_FIFO_STAT - Tx Fifo Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_FIFO_STAT - Tx Fifo Status Register (RO)
 *
 * Reset value: 0x55555555U
 *
 * This register containts full and empty status for each Tx channel fifo
 */
typedef union _hw_mipi_hsi_tx_fifo_stat
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_fifo_stat_bitfields
    {
        uint32_t CH0 : 2;              /*!< [1:0]  */
        uint32_t CH1 : 2;              /*!< [3:2]  */
        uint32_t CH2 : 2;              /*!< [5:4]  */
        uint32_t CH3 : 2;              /*!< [7:6]  */
        uint32_t CH4 : 2;              /*!< [9:8]  */
        uint32_t CH5 : 2;              /*!< [11:10]  */
        uint32_t CH6 : 2;              /*!< [13:12]  */
        uint32_t CH7 : 2;              /*!< [15:14]  */
        uint32_t CH8 : 2;              /*!< [17:16]  */
        uint32_t CH9 : 2;              /*!< [19:18]  */
        uint32_t CH10 : 2;             /*!< [21:20]  */
        uint32_t CH11 : 2;             /*!< [23:22]  */
        uint32_t CH12 : 2;             /*!< [25:24]  */
        uint32_t CH13 : 2;             /*!< [27:26]  */
        uint32_t CH14 : 2;             /*!< [29:28]  */
        uint32_t CH15 : 2;             /*!< [31:30]  */
    } B;
} hw_mipi_hsi_tx_fifo_stat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_FIFO_STAT register
 */
/*@{*/
#define HW_MIPI_HSI_TX_FIFO_STAT_ADDR(x) ((uintptr_t)(x) + 0x210U)

#define HW_MIPI_HSI_TX_FIFO_STAT(x) (*(__I hw_mipi_hsi_tx_fifo_stat_t *) HW_MIPI_HSI_TX_FIFO_STAT_ADDR(x))
#define HW_MIPI_HSI_TX_FIFO_STAT_RD(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_FIFO_STAT bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH0[1:0] (RO)
 *
 * Values:
 * - 00 - Tx channel 0 fifo not Empty and Full;
 * - 01 - Tx channel 0 fifo Empty;
 * - 10 - Tx channel 0 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH0 (0U)  /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH0. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH0 (0x00000003U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH0. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH0 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH0. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH0 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH0(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH0)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH1[3:2] (RO)
 *
 * Values:
 * - 00 - Tx channel 1 fifo not Empty and Full;
 * - 01 - Tx channel 1 fifo Empty;
 * - 10 - Tx channel 1 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH1 (2U)  /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH1. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH1 (0x0000000CU) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH1. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH1 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH1. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH1 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH1(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH1)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH2[5:4] (RO)
 *
 * Values:
 * - 00 - Tx channel 2 fifo not Empty and Full;
 * - 01 - Tx channel 2 fifo Empty;
 * - 10 - Tx channel 2 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH2 (4U)  /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH2. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH2 (0x00000030U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH2. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH2 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH2. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH2 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH2(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH2)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH3[7:6] (RO)
 *
 * Values:
 * - 00 - Tx channel 3 fifo not Empty and Full;
 * - 01 - Tx channel 3 fifo Empty;
 * - 10 - Tx channel 3 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH3 (6U)  /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH3. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH3 (0x000000C0U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH3. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH3 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH3. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH3 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH3(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH3)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH4[9:8] (RO)
 *
 * Values:
 * - 00 - Tx channel 4 fifo not Empty and Full;
 * - 01 - Tx channel 4 fifo Empty;
 * - 10 - Tx channel 4 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH4 (8U)  /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH4. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH4 (0x00000300U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH4. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH4 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH4. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH4 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH4(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH4)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH5[11:10] (RO)
 *
 * Values:
 * - 00 - Tx channel 5 fifo not Empty and Full;
 * - 01 - Tx channel 5 fifo Empty;
 * - 10 - Tx channel 5 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH5 (10U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH5. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH5 (0x00000C00U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH5. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH5 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH5. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH5 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH5(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH5)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH6[13:12] (RO)
 *
 * Values:
 * - 00 - Tx channel 6 fifo not Empty and Full;
 * - 01 - Tx channel 6 fifo Empty;
 * - 10 - Tx channel 6 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH6 (12U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH6. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH6 (0x00003000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH6. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH6 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH6. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH6 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH6(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH6)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH7[15:14] (RO)
 *
 * Values:
 * - 00 - Tx channel 7 fifo not Empty and Full;
 * - 01 - Tx channel 7 fifo Empty;
 * - 10 - Tx channel 7 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH7 (14U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH7. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH7 (0x0000C000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH7. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH7 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH7. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH7 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH7(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH7)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH8[17:16] (RO)
 *
 * Values:
 * - 00 - Tx channel 8 fifo not Empty and Full;
 * - 01 - Tx channel 8 fifo Empty;
 * - 10 - Tx channel 8 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH8 (16U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH8. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH8 (0x00030000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH8. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH8 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH8. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH8 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH8(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH8)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH9[19:18] (RO)
 *
 * Values:
 * - 00 - Tx channel 9 fifo not Empty and Full;
 * - 01 - Tx channel 9 fifo Empty;
 * - 10 - Tx channel 9 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH9 (18U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH9. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH9 (0x000C0000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH9. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH9 (2U)  /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH9. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH9 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH9(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH9)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH10[21:20] (RO)
 *
 * Values:
 * - 00 - Tx channel 10 fifo not Empty and Full;
 * - 01 - Tx channel 10 fifo Empty;
 * - 10 - Tx channel 10 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH10 (20U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH10. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH10 (0x00300000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH10. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH10 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH10. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH10 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH10(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH10)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH11[23:22] (RO)
 *
 * Values:
 * - 00 - Tx channel 11 fifo not Empty and Full;
 * - 01 - Tx channel 11 fifo Empty;
 * - 10 - Tx channel 11 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH11 (22U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH11. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH11 (0x00C00000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH11. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH11 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH11. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH11 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH11(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH11)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH12[25:24] (RO)
 *
 * Values:
 * - 00 - Tx channel 12 fifo not Empty and Full;
 * - 01 - Tx channel 12 fifo Empty;
 * - 10 - Tx channel 12 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH12 (24U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH12. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH12 (0x03000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH12. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH12 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH12. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH12 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH12(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH12)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH13[27:26] (RO)
 *
 * Values:
 * - 00 - Tx channel 13 fifo not Empty and Full;
 * - 01 - Tx channel 13 fifo Empty;
 * - 10 - Tx channel 13 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH13 (26U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH13. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH13 (0x0C000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH13. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH13 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH13. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH13 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH13(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH13)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH14[29:28] (RO)
 *
 * Values:
 * - 00 - Tx channel 14 fifo not Empty and Full;
 * - 01 - Tx channel 14 fifo Empty;
 * - 10 - Tx channel 14 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH14 (28U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH14. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH14 (0x30000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH14. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH14 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH14. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH14 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH14(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH14)
/*@}*/

/*!
 * @name Register MIPI_HSI_TX_FIFO_STAT, field CH15[31:30] (RO)
 *
 * Values:
 * - 00 - Tx channel 15 fifo not Empty and Full;
 * - 01 - Tx channel 15 fifo Empty;
 * - 10 - Tx channel 15 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_TX_FIFO_STAT_CH15 (30U) /*!< Bit position for MIPI_HSI_TX_FIFO_STAT_CH15. */
#define BM_MIPI_HSI_TX_FIFO_STAT_CH15 (0xC0000000U) /*!< Bit mask for MIPI_HSI_TX_FIFO_STAT_CH15. */
#define BS_MIPI_HSI_TX_FIFO_STAT_CH15 (2U) /*!< Bit field size in bits for MIPI_HSI_TX_FIFO_STAT_CH15. */

/*! @brief Read current value of the MIPI_HSI_TX_FIFO_STAT_CH15 field. */
#define BR_MIPI_HSI_TX_FIFO_STAT_CH15(x) (HW_MIPI_HSI_TX_FIFO_STAT(x).B.CH15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_RX_FIFO_STAT - Rx Fifo Status Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_RX_FIFO_STAT - Rx Fifo Status Register (RO)
 *
 * Reset value: 0x55555555U
 *
 * This register containts full and empty status for each Rx channel fifo
 */
typedef union _hw_mipi_hsi_rx_fifo_stat
{
    uint32_t U;
    struct _hw_mipi_hsi_rx_fifo_stat_bitfields
    {
        uint32_t CH0 : 2;              /*!< [1:0]  */
        uint32_t CH1 : 2;              /*!< [3:2]  */
        uint32_t CH2 : 2;              /*!< [5:4]  */
        uint32_t CH3 : 2;              /*!< [7:6]  */
        uint32_t CH4 : 2;              /*!< [9:8]  */
        uint32_t CH5 : 2;              /*!< [11:10]  */
        uint32_t CH6 : 2;              /*!< [13:12]  */
        uint32_t CH7 : 2;              /*!< [15:14]  */
        uint32_t CH8 : 2;              /*!< [17:16]  */
        uint32_t CH9 : 2;              /*!< [19:18]  */
        uint32_t CH10 : 2;             /*!< [21:20]  */
        uint32_t CH11 : 2;             /*!< [23:22]  */
        uint32_t CH12 : 2;             /*!< [25:24]  */
        uint32_t CH13 : 2;             /*!< [27:26]  */
        uint32_t CH14 : 2;             /*!< [29:28]  */
        uint32_t CH15 : 2;             /*!< [31:30]  */
    } B;
} hw_mipi_hsi_rx_fifo_stat_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_RX_FIFO_STAT register
 */
/*@{*/
#define HW_MIPI_HSI_RX_FIFO_STAT_ADDR(x) ((uintptr_t)(x) + 0x214U)

#define HW_MIPI_HSI_RX_FIFO_STAT(x) (*(__I hw_mipi_hsi_rx_fifo_stat_t *) HW_MIPI_HSI_RX_FIFO_STAT_ADDR(x))
#define HW_MIPI_HSI_RX_FIFO_STAT_RD(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_RX_FIFO_STAT bitfields
 */

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH0[1:0] (RO)
 *
 * Values:
 * - 00 - Rx channel 0 fifo not Empty and Full;
 * - 01 - Rx channel 0 fifo Empty;
 * - 10 - Rx channel 0 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH0 (0U)  /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH0. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH0 (0x00000003U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH0. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH0 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH0. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH0 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH0(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH0)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH1[3:2] (RO)
 *
 * Values:
 * - 00 - Rx channel 1 fifo not Empty and Full;
 * - 01 - Rx channel 1 fifo Empty;
 * - 10 - Rx channel 1 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH1 (2U)  /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH1. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH1 (0x0000000CU) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH1. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH1 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH1. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH1 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH1(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH1)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH2[5:4] (RO)
 *
 * Values:
 * - 00 - Rx channel 2 fifo not Empty and Full;
 * - 01 - Rx channel 2 fifo Empty;
 * - 10 - Rx channel 2 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH2 (4U)  /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH2. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH2 (0x00000030U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH2. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH2 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH2. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH2 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH2(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH2)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH3[7:6] (RO)
 *
 * Values:
 * - 00 - Rx channel 3 fifo not Empty and Full;
 * - 01 - Rx channel 3 fifo Empty;
 * - 10 - Rx channel 3 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH3 (6U)  /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH3. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH3 (0x000000C0U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH3. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH3 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH3. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH3 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH3(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH3)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH4[9:8] (RO)
 *
 * Values:
 * - 00 - Rx channel 4 fifo not Empty and Full;
 * - 01 - Rx channel 4 fifo Empty;
 * - 10 - Rx channel 4 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH4 (8U)  /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH4. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH4 (0x00000300U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH4. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH4 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH4. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH4 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH4(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH4)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH5[11:10] (RO)
 *
 * Values:
 * - 00 - Rx channel 5 fifo not Empty and Full;
 * - 01 - Rx channel 5 fifo Empty;
 * - 10 - Rx channel 5 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH5 (10U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH5. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH5 (0x00000C00U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH5. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH5 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH5. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH5 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH5(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH5)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH6[13:12] (RO)
 *
 * Values:
 * - 00 - Rx channel 6 fifo not Empty and Full;
 * - 01 - Rx channel 6 fifo Empty;
 * - 10 - Rx channel 6 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH6 (12U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH6. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH6 (0x00003000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH6. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH6 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH6. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH6 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH6(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH6)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH7[15:14] (RO)
 *
 * Values:
 * - 00 - Rx channel 7 fifo not Empty and Full;
 * - 01 - Rx channel 7 fifo Empty;
 * - 10 - Rx channel 7 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH7 (14U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH7. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH7 (0x0000C000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH7. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH7 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH7. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH7 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH7(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH7)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH8[17:16] (RO)
 *
 * Values:
 * - 00 - Rx channel 8 fifo not Empty and Full;
 * - 01 - Rx channel 8 fifo Empty;
 * - 10 - Rx channel 8 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH8 (16U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH8. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH8 (0x00030000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH8. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH8 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH8. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH8 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH8(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH8)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH9[19:18] (RO)
 *
 * Values:
 * - 00 - Rx channel 9 fifo not Empty and Full;
 * - 01 - Rx channel 9 fifo Empty;
 * - 10 - Rx channel 9 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH9 (18U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH9. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH9 (0x000C0000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH9. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH9 (2U)  /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH9. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH9 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH9(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH9)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH10[21:20] (RO)
 *
 * Values:
 * - 00 - Rx channel 10 fifo not Empty and Full;
 * - 01 - Rx channel 10 fifo Empty;
 * - 10 - Rx channel 10 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH10 (20U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH10. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH10 (0x00300000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH10. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH10 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH10. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH10 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH10(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH10)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH11[23:22] (RO)
 *
 * Values:
 * - 00 - Rx channel 11 fifo not Empty and Full;
 * - 01 - Rx channel 11 fifo Empty;
 * - 10 - Rx channel 11 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH11 (22U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH11. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH11 (0x00C00000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH11. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH11 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH11. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH11 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH11(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH11)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH12[25:24] (RO)
 *
 * Values:
 * - 00 - Rx channel 12 fifo not Empty and Full;
 * - 01 - Rx channel 12 fifo Empty;
 * - 10 - Rx channel 12 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH12 (24U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH12. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH12 (0x03000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH12. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH12 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH12. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH12 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH12(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH12)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH13[27:26] (RO)
 *
 * Values:
 * - 00 - Rx channel 13 fifo not Empty and Full;
 * - 01 - Rx channel 13 fifo Empty;
 * - 10 - Rx channel 13 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH13 (26U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH13. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH13 (0x0C000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH13. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH13 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH13. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH13 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH13(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH13)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH14[29:28] (RO)
 *
 * Values:
 * - 00 - Rx channel 14 fifo not Empty and Full;
 * - 01 - Rx channel 14 fifo Empty;
 * - 10 - Rx channel 14 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH14 (28U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH14. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH14 (0x30000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH14. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH14 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH14. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH14 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH14(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH14)
/*@}*/

/*!
 * @name Register MIPI_HSI_RX_FIFO_STAT, field CH15[31:30] (RO)
 *
 * Values:
 * - 00 - Rx channel 15 fifo not Empty and Full;
 * - 01 - Rx channel 15 fifo Empty;
 * - 10 - Rx channel 15 fifo Full;
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MIPI_HSI_RX_FIFO_STAT_CH15 (30U) /*!< Bit position for MIPI_HSI_RX_FIFO_STAT_CH15. */
#define BM_MIPI_HSI_RX_FIFO_STAT_CH15 (0xC0000000U) /*!< Bit mask for MIPI_HSI_RX_FIFO_STAT_CH15. */
#define BS_MIPI_HSI_RX_FIFO_STAT_CH15 (2U) /*!< Bit field size in bits for MIPI_HSI_RX_FIFO_STAT_CH15. */

/*! @brief Read current value of the MIPI_HSI_RX_FIFO_STAT_CH15 field. */
#define BR_MIPI_HSI_RX_FIFO_STAT_CH15(x) (HW_MIPI_HSI_RX_FIFO_STAT(x).B.CH15)
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_AHB_MASTER_CONF - Ahb Master Config Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_AHB_MASTER_CONF - Ahb Master Config Register (RW)
 *
 * Reset value: 0x00000180U
 *
 * This register used to config hsi internal ahb master
 */
typedef union _hw_mipi_hsi_ahb_master_conf
{
    uint32_t U;
    struct _hw_mipi_hsi_ahb_master_conf_bitfields
    {
        uint32_t DMA_INSERT_IDLE_NUM : 4; /*!< [3:0]  */
        uint32_t DMA_MODE : 2;         /*!< [5:4]  */
        uint32_t DP_HOLD_CYCLE : 4;    /*!< [9:6]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_mipi_hsi_ahb_master_conf_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_AHB_MASTER_CONF register
 */
/*@{*/
#define HW_MIPI_HSI_AHB_MASTER_CONF_ADDR(x) ((uintptr_t)(x) + 0x228U)

#define HW_MIPI_HSI_AHB_MASTER_CONF(x) (*(__IO hw_mipi_hsi_ahb_master_conf_t *) HW_MIPI_HSI_AHB_MASTER_CONF_ADDR(x))
#define HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) (HW_MIPI_HSI_AHB_MASTER_CONF(x).U)
#define HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF(x).U = (v))
#define HW_MIPI_HSI_AHB_MASTER_CONF_SET(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) |  (v)))
#define HW_MIPI_HSI_AHB_MASTER_CONF_CLR(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) & ~(v)))
#define HW_MIPI_HSI_AHB_MASTER_CONF_TOG(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_AHB_MASTER_CONF bitfields
 */

/*!
 * @name Register MIPI_HSI_AHB_MASTER_CONF, field DMA_INSERT_IDLE_NUM[3:0] (RW)
 *
 * These bits used to set the number of "IDLE" cycles when DMA_MODE == 2'b0x.
 */
/*@{*/
#define BP_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM (0U) /*!< Bit position for MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM. */
#define BM_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM (0x0000000FU) /*!< Bit mask for MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM. */
#define BS_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM (4U) /*!< Bit field size in bits for MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM. */

/*! @brief Read current value of the MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM field. */
#define BR_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM(x) (HW_MIPI_HSI_AHB_MASTER_CONF(x).B.DMA_INSERT_IDLE_NUM)

/*! @brief Format value for bitfield MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM. */
#define BF_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM) & BM_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM)

/*! @brief Set the DMA_INSERT_IDLE_NUM field to a new value. */
#define BW_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, (HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) & ~BM_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM) | BF_MIPI_HSI_AHB_MASTER_CONF_DMA_INSERT_IDLE_NUM(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_AHB_MASTER_CONF, field DMA_MODE[5:4] (RW)
 *
 * Values:
 * - 00 - Once AHB master get hgrant from bus, it will set htrans "IDLE" for
 *     serval ahb cycles.In the serval cycles, once it found dataport is accessing
 *     fifo, it will release bus.
 * - 01 - Once AHB master get hgrant from bus, it will set htrans "IDLE" for
 *     serval ahb cycles.After the serval cycles, once it found dataport is
 *     accessing fifo, it will keep on sending "IDLE" out untill dataport finish
 *     accessing fifo.
 * - 1x - Once AHB master get hgrant from bus, dataport can not access fifo
 *     untill a dma operation done.
 */
/*@{*/
#define BP_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE (4U) /*!< Bit position for MIPI_HSI_AHB_MASTER_CONF_DMA_MODE. */
#define BM_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE (0x00000030U) /*!< Bit mask for MIPI_HSI_AHB_MASTER_CONF_DMA_MODE. */
#define BS_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE (2U) /*!< Bit field size in bits for MIPI_HSI_AHB_MASTER_CONF_DMA_MODE. */

/*! @brief Read current value of the MIPI_HSI_AHB_MASTER_CONF_DMA_MODE field. */
#define BR_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE(x) (HW_MIPI_HSI_AHB_MASTER_CONF(x).B.DMA_MODE)

/*! @brief Format value for bitfield MIPI_HSI_AHB_MASTER_CONF_DMA_MODE. */
#define BF_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE) & BM_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE)

/*! @brief Set the DMA_MODE field to a new value. */
#define BW_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, (HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) & ~BM_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE) | BF_MIPI_HSI_AHB_MASTER_CONF_DMA_MODE(v)))
/*@}*/

/*!
 * @name Register MIPI_HSI_AHB_MASTER_CONF, field DP_HOLD_CYCLE[9:6] (RW)
 *
 * These bits used to set the number of cycles for DP access fifo.
 */
/*@{*/
#define BP_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE (6U) /*!< Bit position for MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE. */
#define BM_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE (0x000003C0U) /*!< Bit mask for MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE. */
#define BS_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE (4U) /*!< Bit field size in bits for MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE. */

/*! @brief Read current value of the MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE field. */
#define BR_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE(x) (HW_MIPI_HSI_AHB_MASTER_CONF(x).B.DP_HOLD_CYCLE)

/*! @brief Format value for bitfield MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE. */
#define BF_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE) & BM_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE)

/*! @brief Set the DP_HOLD_CYCLE field to a new value. */
#define BW_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE(x, v) (HW_MIPI_HSI_AHB_MASTER_CONF_WR(x, (HW_MIPI_HSI_AHB_MASTER_CONF_RD(x) & ~BM_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE) | BF_MIPI_HSI_AHB_MASTER_CONF_DP_HOLD_CYCLE(v)))
/*@}*/

/*******************************************************************************
 * HW_MIPI_HSI_TX_BREAK_LEN - TX Break Length Register
 ******************************************************************************/

/*!
 * @brief HW_MIPI_HSI_TX_BREAK_LEN - TX Break Length Register (RW)
 *
 * Reset value: 0x00000025U
 *
 * This register used to set tx break length
 */
typedef union _hw_mipi_hsi_tx_break_len
{
    uint32_t U;
    struct _hw_mipi_hsi_tx_break_len_bitfields
    {
        uint32_t COUNT : 6;            /*!< [5:0]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_mipi_hsi_tx_break_len_t;

/*!
 * @name Constants and macros for entire MIPI_HSI_TX_BREAK_LEN register
 */
/*@{*/
#define HW_MIPI_HSI_TX_BREAK_LEN_ADDR(x) ((uintptr_t)(x) + 0x22CU)

#define HW_MIPI_HSI_TX_BREAK_LEN(x) (*(__IO hw_mipi_hsi_tx_break_len_t *) HW_MIPI_HSI_TX_BREAK_LEN_ADDR(x))
#define HW_MIPI_HSI_TX_BREAK_LEN_RD(x) (HW_MIPI_HSI_TX_BREAK_LEN(x).U)
#define HW_MIPI_HSI_TX_BREAK_LEN_WR(x, v) (HW_MIPI_HSI_TX_BREAK_LEN(x).U = (v))
#define HW_MIPI_HSI_TX_BREAK_LEN_SET(x, v) (HW_MIPI_HSI_TX_BREAK_LEN_WR(x, HW_MIPI_HSI_TX_BREAK_LEN_RD(x) |  (v)))
#define HW_MIPI_HSI_TX_BREAK_LEN_CLR(x, v) (HW_MIPI_HSI_TX_BREAK_LEN_WR(x, HW_MIPI_HSI_TX_BREAK_LEN_RD(x) & ~(v)))
#define HW_MIPI_HSI_TX_BREAK_LEN_TOG(x, v) (HW_MIPI_HSI_TX_BREAK_LEN_WR(x, HW_MIPI_HSI_TX_BREAK_LEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MIPI_HSI_TX_BREAK_LEN bitfields
 */

/*!
 * @name Register MIPI_HSI_TX_BREAK_LEN, field COUNT[5:0] (RW)
 *
 * The tx break length count. 6'h00 64 6'h01 1 6'h3f 63
 */
/*@{*/
#define BP_MIPI_HSI_TX_BREAK_LEN_COUNT (0U) /*!< Bit position for MIPI_HSI_TX_BREAK_LEN_COUNT. */
#define BM_MIPI_HSI_TX_BREAK_LEN_COUNT (0x0000003FU) /*!< Bit mask for MIPI_HSI_TX_BREAK_LEN_COUNT. */
#define BS_MIPI_HSI_TX_BREAK_LEN_COUNT (6U) /*!< Bit field size in bits for MIPI_HSI_TX_BREAK_LEN_COUNT. */

/*! @brief Read current value of the MIPI_HSI_TX_BREAK_LEN_COUNT field. */
#define BR_MIPI_HSI_TX_BREAK_LEN_COUNT(x) (HW_MIPI_HSI_TX_BREAK_LEN(x).B.COUNT)

/*! @brief Format value for bitfield MIPI_HSI_TX_BREAK_LEN_COUNT. */
#define BF_MIPI_HSI_TX_BREAK_LEN_COUNT(v) ((uint32_t)((uint32_t)(v) << BP_MIPI_HSI_TX_BREAK_LEN_COUNT) & BM_MIPI_HSI_TX_BREAK_LEN_COUNT)

/*! @brief Set the COUNT field to a new value. */
#define BW_MIPI_HSI_TX_BREAK_LEN_COUNT(x, v) (HW_MIPI_HSI_TX_BREAK_LEN_WR(x, (HW_MIPI_HSI_TX_BREAK_LEN_RD(x) & ~BM_MIPI_HSI_TX_BREAK_LEN_COUNT) | BF_MIPI_HSI_TX_BREAK_LEN_COUNT(v)))
/*@}*/

/*******************************************************************************
 * hw_mipi_hsi_t - module struct
 ******************************************************************************/
/*!
 * @brief All MIPI_HSI module registers.
 */
#pragma pack(1)
typedef struct _hw_mipi_hsi
{
    __IO hw_mipi_hsi_ctrl_t CTRL;          /*!< [0x0] HSI Control Register */
    __IO hw_mipi_hsi_tx_conf_t TX_CONF;    /*!< [0x4] HSI Tx Config Register */
    __IO hw_mipi_hsi_rx_conf_t RX_CONF;    /*!< [0x8] HSI Rx Config Register */
    __I hw_mipi_hsi_cap_t CAP;             /*!< [0xC] HSI Capability Register */
    __IO hw_mipi_hsi_tx_wml0_t TX_WML0;    /*!< [0x10] HSI Tx Water Mark Level 0 Register */
    __IO hw_mipi_hsi_tx_tml1_t TX_TML1;    /*!< [0x14] HSI Tx Water Mark Level 1 Register */
    __IO hw_mipi_hsi_tx_arb_pri0_t TX_ARB_PRI0; /*!< [0x18] HSI Tx Arbiter Priority 0 Register */
    __IO hw_mipi_hsi_tx_arb_pri1_t TX_ARB_PRI1; /*!< [0x1C] HSI Tx Arbiter Priority 1 Register */
    __I hw_mipi_hsi_line_st_t LINE_ST;     /*!< [0x20] HSI Line Status Register */
    __IO hw_mipi_hsi_id_bit_t ID_BIT;      /*!< [0x24] HSI ID Bits Register */
    __IO hw_mipi_hsi_fifo_thr_conf_t FIFO_THR_CONF; /*!< [0x28] Tx and Rx Fif0 Threshold Configuration Register */
    __O hw_mipi_hsi_ch_sftrst_t CH_SFTRST; /*!< [0x2C] Tx and Rx Channel Soft Reset Register */
    __IO hw_mipi_hsi_irqstat_t IRQSTAT;    /*!< [0x30] HSI Interrupt Status Register */
    __IO hw_mipi_hsi_irqstat_en_t IRQSTAT_EN; /*!< [0x34] HSI Interrupt Status Enable Register */
    __IO hw_mipi_hsi_irqsig_en_t IRQSIG_EN; /*!< [0x38] HSI Interrupt Signal Enable Register */
    __I hw_mipi_hsi_fifo_thr_irqstat_t FIFO_THR_IRQSTAT; /*!< [0x3C] HSI FIFO Threshold Interrupt Status Register */
    __IO hw_mipi_hsi_fifo_thr_irqstat_en_t FIFO_THR_IRQSTAT_EN; /*!< [0x40] HSI FIFO Threshold Interrupt Status Enable Register */
    __IO hw_mipi_hsi_fifo_thr_irqsig_en_t FIFO_THR_IRQSIG_EN; /*!< [0x44] HSI FIFO Threshold Interrupt Signal Enable Register */
    uint8_t _reserved0[8];
    __IO hw_mipi_hsi_tx_chn_dp_t TX_CHn_DP[16]; /*!< [0x50] Tx Channel n Data Port Register */
    __IO hw_mipi_hsi_rx_chn_dp_t RX_CHn_DP[16]; /*!< [0x90] Rx Channel n Data Port Register */
    __I hw_mipi_hsi_err_irqstat_t ERR_IRQSTAT; /*!< [0xD0] HSI Error Interrupt Status Register */
    __IO hw_mipi_hsi_err_irqstat_en_t ERR_IRQSTAT_EN; /*!< [0xD4] HSI Error Interrupt Status Enable Register */
    __IO hw_mipi_hsi_err_irqsig_en_t ERR_IRQSIG_EN; /*!< [0xD8] HSI Error Interrupt Signal Enable Register */
    __IO hw_mipi_hsi_tdman_conf_t TDMAn_CONF[16]; /*!< [0xDC] Tx DMA Channel n Configuration Register */
    __IO hw_mipi_hsi_rdman_conf_t RDMAn_CONF[16]; /*!< [0x11C] Rx DMA Channel n Configuration Register */
    __IO hw_mipi_hsi_tdman_sta_addr_t TDMAn_STA_ADDR[16]; /*!< [0x15C] Tx DMA Channel n Start Address Register */
    __IO hw_mipi_hsi_rdman_sta_addr_t RDMAn_STA_ADDR[16]; /*!< [0x19C] Rx DMA Channel n Start Address Register */
    __I hw_mipi_hsi_dma_irqstat_t DMA_IRQSTAT; /*!< [0x1DC] DMA Interrupt Status Register */
    __IO hw_mipi_hsi_dma_irqstat_en_t DMA_IRQSTAT_EN; /*!< [0x1E0] DMA Interrupt Enable Register */
    __IO hw_mipi_hsi_dma_irqsig_en_t DMA_IRQSIG_EN; /*!< [0x1E4] DMA Interrupt Status Signal Enable Register */
    __I hw_mipi_hsi_dma_err_irqstat_t DMA_ERR_IRQSTAT; /*!< [0x1E8] DMA Error Interrupt Status Register */
    __IO hw_mipi_hsi_dma_err_irqstat_en_t DMA_ERR_IRQSTAT_EN; /*!< [0x1EC] DMA Error Interrupt Enable Register */
    __IO hw_mipi_hsi_dma_err_irqsig_en_t DMA_ERR_IRQSIG_EN; /*!< [0x1F0] DMA Error Interrupt Signal Enable Register */
    __I hw_mipi_hsi_dma_single_req_en_t DMA_SINGLE_REQ_EN; /*!< [0x1F4] DMA Single Request Enable Register */
    uint8_t _reserved1[8];
    __IO hw_mipi_hsi_tx_fifo_size_conf0_t TX_FIFO_SIZE_CONF0; /*!< [0x200] Tx Fifo Size Configuration Register 0 */
    __IO hw_mipi_hsi_tx_fifo_size_conf1_t TX_FIFO_SIZE_CONF1; /*!< [0x204] Tx Fifo Size Configuration Register 1 */
    __IO hw_mipi_hsi_rx_fifo_size_conf0_t RX_FIFO_SIZE_CONF0; /*!< [0x208] Rx Fifo Size Configuration Register 0 */
    __IO hw_mipi_hsi_rx_fifo_size_conf1_t RX_FIFO_SIZE_CONF1; /*!< [0x20C] Rx Fifo Size Configuration Register 1 */
    __I hw_mipi_hsi_tx_fifo_stat_t TX_FIFO_STAT; /*!< [0x210] Tx Fifo Status Register */
    __I hw_mipi_hsi_rx_fifo_stat_t RX_FIFO_STAT; /*!< [0x214] Rx Fifo Status Register */
    uint8_t _reserved2[16];
    __IO hw_mipi_hsi_ahb_master_conf_t AHB_MASTER_CONF; /*!< [0x228] Ahb Master Config Register */
    __IO hw_mipi_hsi_tx_break_len_t TX_BREAK_LEN; /*!< [0x22C] TX Break Length Register */
} hw_mipi_hsi_t;
#pragma pack()

/*! @brief Macro to access all MIPI_HSI registers. */
/*! @param x MIPI_HSI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_MIPI_HSI_REGS(MIPI_HSI_BASE)</code>. */
#define HW_MIPI_HSI_REGS(x) (*(hw_mipi_hsi_t *)(x))

/*
 * iMX6DP MLB
 *
 * MLB150
 *
 * Registers defined in this header file:
 * - HW_MLB_MLBC0 - MediaLB Control 0 Register
 * - HW_MLB_MLBPC0 - MediaLB 6-pin Control 0 Register
 * - HW_MLB_MLBPC2 - MediaLB 6-pin Control 2 Register
 * - HW_MLB_MS0 - MediaLB Channel Status 0 Register
 * - HW_MLB_MS1 - MediaLB Channel Status1 Register
 * - HW_MLB_MSS - MediaLB System Status Register
 * - HW_MLB_MSD - MediaLB System Data Register
 * - HW_MLB_MIEN - MediaLB Interrupt Enable Register
 * - HW_MLB_MLBPC1 - MediaLB 6-pin Control 1 Register
 * - HW_MLB_MLBC1 - MediaLB Control 1 Register
 * - HW_MLB_HCTL - HBI Control Register
 * - HW_MLB_HCMR0 - HBI Channel Mask 0 Register
 * - HW_MLB_HCMR1 - HBI Channel Mask 1 Register
 * - HW_MLB_HCER0 - HBI Channel Error 0 Register
 * - HW_MLB_HCER1 - HBI Channel Error 1 Register
 * - HW_MLB_HCBR0 - HBI Channel Busy 0 Register
 * - HW_MLB_HCBR1 - HBI Channel Busy 1 Register
 * - HW_MLB_MDAT0 - MIF Data 0 Register
 * - HW_MLB_MDAT1 - MIF Data 1 Register
 * - HW_MLB_MDAT2 - MIF Data 2 Register
 * - HW_MLB_MDAT3 - MIF Data 3 Register
 * - HW_MLB_MDWE0 - MIF Data Write Enable 0 Register
 * - HW_MLB_MDWE1 - MIF Data Write Enable 1 Register
 * - HW_MLB_MDWE2 - MIF Data Write Enable 2 Register
 * - HW_MLB_MDWE3 - MIF Data Write Enable 3 Register
 * - HW_MLB_MCTL - MIF Control Register
 * - HW_MLB_MADR - MIF Address Register
 * - HW_MLB_ACTL - AHB Control Register
 * - HW_MLB_ACSR0 - AHB Channel Status 0 Register
 * - HW_MLB_ACSR1 - AHB Channel Status 1 Register
 * - HW_MLB_ACMR0 - AHB Channel Mask 0 Register
 * - HW_MLB_ACMR1 - AHB Channel Mask 1 Register
 *
 * - hw_mlb_t - Struct containing all module registers.
 */

#define HW_MLB_INSTANCE_COUNT (1U) /*!< Number of instances of the MLB module. */
#define HW_MLB (0U) /*!< Instance number for MLB. */
#define MLB_BASE              (0x218C000U) /*!< Base address for MLB. */
/*! Array initializer of MLB base addresses. */
#define MLB_BASE_ADDRS        { MLB_BASE }

/*******************************************************************************
 * HW_MLB_MLBC0 - MediaLB Control 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MLBC0 - MediaLB Control 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mlbc0
{
    uint32_t U;
    struct _hw_mlb_mlbc0_bitfields
    {
        uint32_t MLBEN : 1;            /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t MLBCLK_2_0 : 3;       /*!< [4:2]  */
        uint32_t MLBPEN : 1;           /*!< [5]  */
        uint32_t RESERVED1 : 1;        /*!< [6]  */
        uint32_t MLBLK : 1;            /*!< [7]  */
        uint32_t RESERVED2 : 4;        /*!< [11:8]  */
        uint32_t ASYRETRY : 1;         /*!< [12]  */
        uint32_t RESERVED3 : 1;        /*!< [13]  */
        uint32_t CTLRETRY : 1;         /*!< [14]  */
        uint32_t FCNT : 3;             /*!< [17:15]  */
        uint32_t RESERVED4 : 14;       /*!< [31:18]  */
    } B;
} hw_mlb_mlbc0_t;

/*!
 * @name Constants and macros for entire MLB_MLBC0 register
 */
/*@{*/
#define HW_MLB_MLBC0_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_MLB_MLBC0(x)          (*(__IO hw_mlb_mlbc0_t *) HW_MLB_MLBC0_ADDR(x))
#define HW_MLB_MLBC0_RD(x)       (HW_MLB_MLBC0(x).U)
#define HW_MLB_MLBC0_WR(x, v)    (HW_MLB_MLBC0(x).U = (v))
#define HW_MLB_MLBC0_SET(x, v)   (HW_MLB_MLBC0_WR(x, HW_MLB_MLBC0_RD(x) |  (v)))
#define HW_MLB_MLBC0_CLR(x, v)   (HW_MLB_MLBC0_WR(x, HW_MLB_MLBC0_RD(x) & ~(v)))
#define HW_MLB_MLBC0_TOG(x, v)   (HW_MLB_MLBC0_WR(x, HW_MLB_MLBC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MLBC0 bitfields
 */

/*!
 * @name Register MLB_MLBC0, field MLBEN[0] (RW)
 *
 * MediaLB enable. When set, MLB_CLK (MediaLB clock), MLB_SIG (signal), and
 * MLB_DATA (data) are received and transmitted on the appropriate MediaLB pins.
 */
/*@{*/
#define BP_MLB_MLBC0_MLBEN   (0U)          /*!< Bit position for MLB_MLBC0_MLBEN. */
#define BM_MLB_MLBC0_MLBEN   (0x00000001U) /*!< Bit mask for MLB_MLBC0_MLBEN. */
#define BS_MLB_MLBC0_MLBEN   (1U)          /*!< Bit field size in bits for MLB_MLBC0_MLBEN. */

/*! @brief Read current value of the MLB_MLBC0_MLBEN field. */
#define BR_MLB_MLBC0_MLBEN(x) (HW_MLB_MLBC0(x).B.MLBEN)

/*! @brief Format value for bitfield MLB_MLBC0_MLBEN. */
#define BF_MLB_MLBC0_MLBEN(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_MLBEN) & BM_MLB_MLBC0_MLBEN)

/*! @brief Set the MLBEN field to a new value. */
#define BW_MLB_MLBC0_MLBEN(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_MLBEN) | BF_MLB_MLBC0_MLBEN(v)))
/*@}*/

/*!
 * @name Register MLB_MLBC0, field MLBCLK_2_0[4:2] (RW)
 *
 * MLB_CLK (MediaLB clock) speed select.
 *
 * Values:
 * - 000 - 256xFs (for MLBPEN = 0)
 * - 001 - 512xFs (for MLBPEN = 0)
 * - 010 - 1024xFs (for MLBPEN = 0)
 * - 011 - 2048xFs (for MLBPEN = 1)
 * - 100 - 3072xFs (for MLBPEN = 1)
 * - 101 - 4096xFs (for MLBPEN = 1)
 * - 110 - 6144xFs (for MLBPEN = 1)
 * - 111 - reserved
 */
/*@{*/
#define BP_MLB_MLBC0_MLBCLK_2_0 (2U)       /*!< Bit position for MLB_MLBC0_MLBCLK_2_0. */
#define BM_MLB_MLBC0_MLBCLK_2_0 (0x0000001CU) /*!< Bit mask for MLB_MLBC0_MLBCLK_2_0. */
#define BS_MLB_MLBC0_MLBCLK_2_0 (3U)       /*!< Bit field size in bits for MLB_MLBC0_MLBCLK_2_0. */

/*! @brief Read current value of the MLB_MLBC0_MLBCLK_2_0 field. */
#define BR_MLB_MLBC0_MLBCLK_2_0(x) (HW_MLB_MLBC0(x).B.MLBCLK_2_0)

/*! @brief Format value for bitfield MLB_MLBC0_MLBCLK_2_0. */
#define BF_MLB_MLBC0_MLBCLK_2_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_MLBCLK_2_0) & BM_MLB_MLBC0_MLBCLK_2_0)

/*! @brief Set the MLBCLK_2_0 field to a new value. */
#define BW_MLB_MLBC0_MLBCLK_2_0(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_MLBCLK_2_0) | BF_MLB_MLBC0_MLBCLK_2_0(v)))
/*@}*/

/*!
 * @name Register MLB_MLBC0, field MLBPEN[5] (RW)
 *
 * MediaLB 6-pin enable.
 *
 * Values:
 * - 0 - MediaLB 3-pin interface enabled
 * - 1 - MediaLB 6-pin interface enabled. MLB PLL and MLB PHY is enabled in this
 *     case.
 */
/*@{*/
#define BP_MLB_MLBC0_MLBPEN  (5U)          /*!< Bit position for MLB_MLBC0_MLBPEN. */
#define BM_MLB_MLBC0_MLBPEN  (0x00000020U) /*!< Bit mask for MLB_MLBC0_MLBPEN. */
#define BS_MLB_MLBC0_MLBPEN  (1U)          /*!< Bit field size in bits for MLB_MLBC0_MLBPEN. */

/*! @brief Read current value of the MLB_MLBC0_MLBPEN field. */
#define BR_MLB_MLBC0_MLBPEN(x) (HW_MLB_MLBC0(x).B.MLBPEN)

/*! @brief Format value for bitfield MLB_MLBC0_MLBPEN. */
#define BF_MLB_MLBC0_MLBPEN(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_MLBPEN) & BM_MLB_MLBC0_MLBPEN)

/*! @brief Set the MLBPEN field to a new value. */
#define BW_MLB_MLBC0_MLBPEN(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_MLBPEN) | BF_MLB_MLBC0_MLBPEN(v)))
/*@}*/

/*!
 * @name Register MLB_MLBC0, field MLBLK[7] (RO)
 *
 * MediaLB lock status. When set, indicates that the MediaLB block is
 * synchronized to the incoming MediaLB frame. If MLBLK is clear (unlocked), MLBLK is set
 * after FRAMESYNC is detected at the same position for three consecutive frames.
 * If MLBLK is set (locked), MLBLK is cleared after not receiving FRAMESYNC at
 * the expected time for two consecutive frames. While MLBLK is set, FRAMESYNC
 * patterns occurring at locations other than the expected one are ignored.
 * (read-only)
 */
/*@{*/
#define BP_MLB_MLBC0_MLBLK   (7U)          /*!< Bit position for MLB_MLBC0_MLBLK. */
#define BM_MLB_MLBC0_MLBLK   (0x00000080U) /*!< Bit mask for MLB_MLBC0_MLBLK. */
#define BS_MLB_MLBC0_MLBLK   (1U)          /*!< Bit field size in bits for MLB_MLBC0_MLBLK. */

/*! @brief Read current value of the MLB_MLBC0_MLBLK field. */
#define BR_MLB_MLBC0_MLBLK(x) (HW_MLB_MLBC0(x).B.MLBLK)
/*@}*/

/*!
 * @name Register MLB_MLBC0, field ASYRETRY[12] (RW)
 *
 * Asynchronous Tx packet retry. When set, an asynchronous packet that is
 * flagged with a Break or ProtocolError by the receiver is retransmitted. When
 * cleared, an asynchronous packet that is flagged with a Break or ProtocolError by the
 * receiver is skipped.
 */
/*@{*/
#define BP_MLB_MLBC0_ASYRETRY (12U)        /*!< Bit position for MLB_MLBC0_ASYRETRY. */
#define BM_MLB_MLBC0_ASYRETRY (0x00001000U) /*!< Bit mask for MLB_MLBC0_ASYRETRY. */
#define BS_MLB_MLBC0_ASYRETRY (1U)         /*!< Bit field size in bits for MLB_MLBC0_ASYRETRY. */

/*! @brief Read current value of the MLB_MLBC0_ASYRETRY field. */
#define BR_MLB_MLBC0_ASYRETRY(x) (HW_MLB_MLBC0(x).B.ASYRETRY)

/*! @brief Format value for bitfield MLB_MLBC0_ASYRETRY. */
#define BF_MLB_MLBC0_ASYRETRY(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_ASYRETRY) & BM_MLB_MLBC0_ASYRETRY)

/*! @brief Set the ASYRETRY field to a new value. */
#define BW_MLB_MLBC0_ASYRETRY(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_ASYRETRY) | BF_MLB_MLBC0_ASYRETRY(v)))
/*@}*/

/*!
 * @name Register MLB_MLBC0, field CTLRETRY[14] (RW)
 *
 * Control Tx packet retry. When set, a control packet that is flagged with a
 * Break or ProtocolError by the receiver is retransmitted. When cleared, a control
 * packet that is flagged with a Break or ProtocolError by the receiver is
 * skipped.
 */
/*@{*/
#define BP_MLB_MLBC0_CTLRETRY (14U)        /*!< Bit position for MLB_MLBC0_CTLRETRY. */
#define BM_MLB_MLBC0_CTLRETRY (0x00004000U) /*!< Bit mask for MLB_MLBC0_CTLRETRY. */
#define BS_MLB_MLBC0_CTLRETRY (1U)         /*!< Bit field size in bits for MLB_MLBC0_CTLRETRY. */

/*! @brief Read current value of the MLB_MLBC0_CTLRETRY field. */
#define BR_MLB_MLBC0_CTLRETRY(x) (HW_MLB_MLBC0(x).B.CTLRETRY)

/*! @brief Format value for bitfield MLB_MLBC0_CTLRETRY. */
#define BF_MLB_MLBC0_CTLRETRY(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_CTLRETRY) & BM_MLB_MLBC0_CTLRETRY)

/*! @brief Set the CTLRETRY field to a new value. */
#define BW_MLB_MLBC0_CTLRETRY(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_CTLRETRY) | BF_MLB_MLBC0_CTLRETRY(v)))
/*@}*/

/*!
 * @name Register MLB_MLBC0, field FCNT[17:15] (RW)
 *
 * The number of frames per sub-buffer for synchronous channels.
 *
 * Values:
 * - 000 - 1 frame per sub-buffer (Operation is the same as Standard mode.)
 * - 001 - 2 frames per sub-buffer
 * - 010 - 4 frames per sub-buffer
 * - 011 - 8 frames per sub-buffer
 * - 100 - 16 frames per sub-buffer
 * - 101 - 32 frames per sub-buffer
 * - 110 - 64 frames per sub-buffer
 * - 111 - Reserved
 */
/*@{*/
#define BP_MLB_MLBC0_FCNT    (15U)         /*!< Bit position for MLB_MLBC0_FCNT. */
#define BM_MLB_MLBC0_FCNT    (0x00038000U) /*!< Bit mask for MLB_MLBC0_FCNT. */
#define BS_MLB_MLBC0_FCNT    (3U)          /*!< Bit field size in bits for MLB_MLBC0_FCNT. */

/*! @brief Read current value of the MLB_MLBC0_FCNT field. */
#define BR_MLB_MLBC0_FCNT(x) (HW_MLB_MLBC0(x).B.FCNT)

/*! @brief Format value for bitfield MLB_MLBC0_FCNT. */
#define BF_MLB_MLBC0_FCNT(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC0_FCNT) & BM_MLB_MLBC0_FCNT)

/*! @brief Set the FCNT field to a new value. */
#define BW_MLB_MLBC0_FCNT(x, v) (HW_MLB_MLBC0_WR(x, (HW_MLB_MLBC0_RD(x) & ~BM_MLB_MLBC0_FCNT) | BF_MLB_MLBC0_FCNT(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_MLBPC0 - MediaLB 6-pin Control 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MLBPC0 - MediaLB 6-pin Control 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mlbpc0
{
    uint32_t U;
    struct _hw_mlb_mlbpc0_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t MCLKHYS : 1;          /*!< [11]  */
        uint32_t RESERVED1 : 20;       /*!< [31:12]  */
    } B;
} hw_mlb_mlbpc0_t;

/*!
 * @name Constants and macros for entire MLB_MLBPC0 register
 */
/*@{*/
#define HW_MLB_MLBPC0_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_MLB_MLBPC0(x)         (*(__IO hw_mlb_mlbpc0_t *) HW_MLB_MLBPC0_ADDR(x))
#define HW_MLB_MLBPC0_RD(x)      (HW_MLB_MLBPC0(x).U)
#define HW_MLB_MLBPC0_WR(x, v)   (HW_MLB_MLBPC0(x).U = (v))
#define HW_MLB_MLBPC0_SET(x, v)  (HW_MLB_MLBPC0_WR(x, HW_MLB_MLBPC0_RD(x) |  (v)))
#define HW_MLB_MLBPC0_CLR(x, v)  (HW_MLB_MLBPC0_WR(x, HW_MLB_MLBPC0_RD(x) & ~(v)))
#define HW_MLB_MLBPC0_TOG(x, v)  (HW_MLB_MLBPC0_WR(x, HW_MLB_MLBPC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MLBPC0 bitfields
 */

/*!
 * @name Register MLB_MLBPC0, field MCLKHYS[11] (RW)
 *
 * MediaLB (6-pin) hysteresis enable. When set, enables hysteresis on the
 * MLB_CLK (MediaLB clock). This value is driven on mlb_clk_hys_enable output pin and
 * has no internal function.
 */
/*@{*/
#define BP_MLB_MLBPC0_MCLKHYS (11U)        /*!< Bit position for MLB_MLBPC0_MCLKHYS. */
#define BM_MLB_MLBPC0_MCLKHYS (0x00000800U) /*!< Bit mask for MLB_MLBPC0_MCLKHYS. */
#define BS_MLB_MLBPC0_MCLKHYS (1U)         /*!< Bit field size in bits for MLB_MLBPC0_MCLKHYS. */

/*! @brief Read current value of the MLB_MLBPC0_MCLKHYS field. */
#define BR_MLB_MLBPC0_MCLKHYS(x) (HW_MLB_MLBPC0(x).B.MCLKHYS)

/*! @brief Format value for bitfield MLB_MLBPC0_MCLKHYS. */
#define BF_MLB_MLBPC0_MCLKHYS(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC0_MCLKHYS) & BM_MLB_MLBPC0_MCLKHYS)

/*! @brief Set the MCLKHYS field to a new value. */
#define BW_MLB_MLBPC0_MCLKHYS(x, v) (HW_MLB_MLBPC0_WR(x, (HW_MLB_MLBPC0_RD(x) & ~BM_MLB_MLBPC0_MCLKHYS) | BF_MLB_MLBPC0_MCLKHYS(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_MLBPC2 - MediaLB 6-pin Control 2 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MLBPC2 - MediaLB 6-pin Control 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mlbpc2
{
    uint32_t U;
    struct _hw_mlb_mlbpc2_bitfields
    {
        uint32_t SDOPC : 1;            /*!< [0]  */
        uint32_t SDRTO : 2;            /*!< [2:1]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_mlb_mlbpc2_t;

/*!
 * @name Constants and macros for entire MLB_MLBPC2 register
 */
/*@{*/
#define HW_MLB_MLBPC2_ADDR(x)    ((uintptr_t)(x) + 0xDU)

#define HW_MLB_MLBPC2(x)         (*(__IO hw_mlb_mlbpc2_t *) HW_MLB_MLBPC2_ADDR(x))
#define HW_MLB_MLBPC2_RD(x)      (HW_MLB_MLBPC2(x).U)
#define HW_MLB_MLBPC2_WR(x, v)   (HW_MLB_MLBPC2(x).U = (v))
#define HW_MLB_MLBPC2_SET(x, v)  (HW_MLB_MLBPC2_WR(x, HW_MLB_MLBPC2_RD(x) |  (v)))
#define HW_MLB_MLBPC2_CLR(x, v)  (HW_MLB_MLBPC2_WR(x, HW_MLB_MLBPC2_RD(x) & ~(v)))
#define HW_MLB_MLBPC2_TOG(x, v)  (HW_MLB_MLBPC2_WR(x, HW_MLB_MLBPC2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MLBPC2 bitfields
 */

/*!
 * @name Register MLB_MLBPC2, field SDOPC[0] (RW)
 *
 * MLB 3-pin interface: Signal/Data output phase control.
 *
 * Values:
 * - 0 - MLB_SIG / MLB_DATA launch at rising edge of MLB_CLK(default)
 * - 1 - MLB_SIG / MLB_DATA launch at falling edge of MLB_CLK
 */
/*@{*/
#define BP_MLB_MLBPC2_SDOPC  (0U)          /*!< Bit position for MLB_MLBPC2_SDOPC. */
#define BM_MLB_MLBPC2_SDOPC  (0x00000001U) /*!< Bit mask for MLB_MLBPC2_SDOPC. */
#define BS_MLB_MLBPC2_SDOPC  (1U)          /*!< Bit field size in bits for MLB_MLBPC2_SDOPC. */

/*! @brief Read current value of the MLB_MLBPC2_SDOPC field. */
#define BR_MLB_MLBPC2_SDOPC(x) (HW_MLB_MLBPC2(x).B.SDOPC)

/*! @brief Format value for bitfield MLB_MLBPC2_SDOPC. */
#define BF_MLB_MLBPC2_SDOPC(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC2_SDOPC) & BM_MLB_MLBPC2_SDOPC)

/*! @brief Set the SDOPC field to a new value. */
#define BW_MLB_MLBPC2_SDOPC(x, v) (HW_MLB_MLBPC2_WR(x, (HW_MLB_MLBPC2_RD(x) & ~BM_MLB_MLBPC2_SDOPC) | BF_MLB_MLBPC2_SDOPC(v)))
/*@}*/

/*!
 * @name Register MLB_MLBPC2, field SDRTO[2:1] (RW)
 *
 * MLB 6-pin interface: Signal/Data receiver threshold offset control.
 */
/*@{*/
#define BP_MLB_MLBPC2_SDRTO  (1U)          /*!< Bit position for MLB_MLBPC2_SDRTO. */
#define BM_MLB_MLBPC2_SDRTO  (0x00000006U) /*!< Bit mask for MLB_MLBPC2_SDRTO. */
#define BS_MLB_MLBPC2_SDRTO  (2U)          /*!< Bit field size in bits for MLB_MLBPC2_SDRTO. */

/*! @brief Read current value of the MLB_MLBPC2_SDRTO field. */
#define BR_MLB_MLBPC2_SDRTO(x) (HW_MLB_MLBPC2(x).B.SDRTO)

/*! @brief Format value for bitfield MLB_MLBPC2_SDRTO. */
#define BF_MLB_MLBPC2_SDRTO(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC2_SDRTO) & BM_MLB_MLBPC2_SDRTO)

/*! @brief Set the SDRTO field to a new value. */
#define BW_MLB_MLBPC2_SDRTO(x, v) (HW_MLB_MLBPC2_WR(x, (HW_MLB_MLBPC2_RD(x) & ~BM_MLB_MLBPC2_SDRTO) | BF_MLB_MLBPC2_SDRTO(v)))
/*@}*/
/*******************************************************************************
 * HW_MLB_MS0 - MediaLB Channel Status 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MS0 - MediaLB Channel Status 0 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_ms0
{
    uint32_t U;
    struct _hw_mlb_ms0_bitfields
    {
        uint32_t MCS_31_0 : 32;        /*!< [31:0]  */
    } B;
} hw_mlb_ms0_t;

/*!
 * @name Constants and macros for entire MLB_MS0 register
 */
/*@{*/
#define HW_MLB_MS0_ADDR(x)       ((uintptr_t)(x) + 0xCU)

#define HW_MLB_MS0(x)            (*(__I hw_mlb_ms0_t *) HW_MLB_MS0_ADDR(x))
#define HW_MLB_MS0_RD(x)         (HW_MLB_MS0(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_MS0 bitfields
 */

/*!
 * @name Register MLB_MS0, field MCS_31_0[31:0] (RO)
 *
 * MediaLB channel status. Indicates the channel status for MediaLB channels 31
 * to 0. Channel status bits are set by hardware and cleared by software. Status
 * is only set if the appropriate bits in the MIEN register are set.
 */
/*@{*/
#define BP_MLB_MS0_MCS_31_0  (0U)          /*!< Bit position for MLB_MS0_MCS_31_0. */
#define BM_MLB_MS0_MCS_31_0  (0xFFFFFFFFU) /*!< Bit mask for MLB_MS0_MCS_31_0. */
#define BS_MLB_MS0_MCS_31_0  (32U)         /*!< Bit field size in bits for MLB_MS0_MCS_31_0. */

/*! @brief Read current value of the MLB_MS0_MCS_31_0 field. */
#define BR_MLB_MS0_MCS_31_0(x) (HW_MLB_MS0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_MS1 - MediaLB Channel Status1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MS1 - MediaLB Channel Status1 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_ms1
{
    uint32_t U;
    struct _hw_mlb_ms1_bitfields
    {
        uint32_t MCS_63_32 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_ms1_t;

/*!
 * @name Constants and macros for entire MLB_MS1 register
 */
/*@{*/
#define HW_MLB_MS1_ADDR(x)       ((uintptr_t)(x) + 0x14U)

#define HW_MLB_MS1(x)            (*(__I hw_mlb_ms1_t *) HW_MLB_MS1_ADDR(x))
#define HW_MLB_MS1_RD(x)         (HW_MLB_MS1(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_MS1 bitfields
 */

/*!
 * @name Register MLB_MS1, field MCS_63_32[31:0] (RO)
 *
 * MediaLB channel status. Indicates the channel status for MediaLB channels 63
 * to 32. Channel status bits are set by hardware and cleared by software. Status
 * is only set if the appropriate bits in the MIEN register are set.
 */
/*@{*/
#define BP_MLB_MS1_MCS_63_32 (0U)          /*!< Bit position for MLB_MS1_MCS_63_32. */
#define BM_MLB_MS1_MCS_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_MS1_MCS_63_32. */
#define BS_MLB_MS1_MCS_63_32 (32U)         /*!< Bit field size in bits for MLB_MS1_MCS_63_32. */

/*! @brief Read current value of the MLB_MS1_MCS_63_32 field. */
#define BR_MLB_MS1_MCS_63_32(x) (HW_MLB_MS1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_MSS - MediaLB System Status Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MSS - MediaLB System Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mss
{
    uint32_t U;
    struct _hw_mlb_mss_bitfields
    {
        uint32_t RSTSYSCMD : 1;        /*!< [0]  */
        uint32_t LKSYSCMD : 1;         /*!< [1]  */
        uint32_t ULKSYSCMD : 1;        /*!< [2]  */
        uint32_t CSSYSCMD : 1;         /*!< [3]  */
        uint32_t SWSYSCMD : 1;         /*!< [4]  */
        uint32_t SERVREQ : 1;          /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_mlb_mss_t;

/*!
 * @name Constants and macros for entire MLB_MSS register
 */
/*@{*/
#define HW_MLB_MSS_ADDR(x)       ((uintptr_t)(x) + 0x20U)

#define HW_MLB_MSS(x)            (*(__IO hw_mlb_mss_t *) HW_MLB_MSS_ADDR(x))
#define HW_MLB_MSS_RD(x)         (HW_MLB_MSS(x).U)
#define HW_MLB_MSS_WR(x, v)      (HW_MLB_MSS(x).U = (v))
#define HW_MLB_MSS_SET(x, v)     (HW_MLB_MSS_WR(x, HW_MLB_MSS_RD(x) |  (v)))
#define HW_MLB_MSS_CLR(x, v)     (HW_MLB_MSS_WR(x, HW_MLB_MSS_RD(x) & ~(v)))
#define HW_MLB_MSS_TOG(x, v)     (HW_MLB_MSS_WR(x, HW_MLB_MSS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MSS bitfields
 */

/*!
 * @name Register MLB_MSS, field RSTSYSCMD[0] (RO)
 *
 * Reset system command detected (in the system quadlet). Set by hardware,
 * cleared by software.
 */
/*@{*/
#define BP_MLB_MSS_RSTSYSCMD (0U)          /*!< Bit position for MLB_MSS_RSTSYSCMD. */
#define BM_MLB_MSS_RSTSYSCMD (0x00000001U) /*!< Bit mask for MLB_MSS_RSTSYSCMD. */
#define BS_MLB_MSS_RSTSYSCMD (1U)          /*!< Bit field size in bits for MLB_MSS_RSTSYSCMD. */

/*! @brief Read current value of the MLB_MSS_RSTSYSCMD field. */
#define BR_MLB_MSS_RSTSYSCMD(x) (HW_MLB_MSS(x).B.RSTSYSCMD)
/*@}*/

/*!
 * @name Register MLB_MSS, field LKSYSCMD[1] (RO)
 *
 * Network lock system command detected (in the system quadlet). Set by
 * hardware, cleared by software.
 */
/*@{*/
#define BP_MLB_MSS_LKSYSCMD  (1U)          /*!< Bit position for MLB_MSS_LKSYSCMD. */
#define BM_MLB_MSS_LKSYSCMD  (0x00000002U) /*!< Bit mask for MLB_MSS_LKSYSCMD. */
#define BS_MLB_MSS_LKSYSCMD  (1U)          /*!< Bit field size in bits for MLB_MSS_LKSYSCMD. */

/*! @brief Read current value of the MLB_MSS_LKSYSCMD field. */
#define BR_MLB_MSS_LKSYSCMD(x) (HW_MLB_MSS(x).B.LKSYSCMD)
/*@}*/

/*!
 * @name Register MLB_MSS, field ULKSYSCMD[2] (RO)
 *
 * Network unlock system command detected (in the system quadlet). Set by
 * hardware, cleared by software.
 */
/*@{*/
#define BP_MLB_MSS_ULKSYSCMD (2U)          /*!< Bit position for MLB_MSS_ULKSYSCMD. */
#define BM_MLB_MSS_ULKSYSCMD (0x00000004U) /*!< Bit mask for MLB_MSS_ULKSYSCMD. */
#define BS_MLB_MSS_ULKSYSCMD (1U)          /*!< Bit field size in bits for MLB_MSS_ULKSYSCMD. */

/*! @brief Read current value of the MLB_MSS_ULKSYSCMD field. */
#define BR_MLB_MSS_ULKSYSCMD(x) (HW_MLB_MSS(x).B.ULKSYSCMD)
/*@}*/

/*!
 * @name Register MLB_MSS, field CSSYSCMD[3] (RO)
 *
 * Channel scan system command detected (in the system quadlet). Set by
 * hardware, cleared by software. If the node address specified in Data quadlet matches
 * the value in MLBC1.NDA, the device responds either "device present" or "device
 * present, request service" system response in the next system quadlet.
 */
/*@{*/
#define BP_MLB_MSS_CSSYSCMD  (3U)          /*!< Bit position for MLB_MSS_CSSYSCMD. */
#define BM_MLB_MSS_CSSYSCMD  (0x00000008U) /*!< Bit mask for MLB_MSS_CSSYSCMD. */
#define BS_MLB_MSS_CSSYSCMD  (1U)          /*!< Bit field size in bits for MLB_MSS_CSSYSCMD. */

/*! @brief Read current value of the MLB_MSS_CSSYSCMD field. */
#define BR_MLB_MSS_CSSYSCMD(x) (HW_MLB_MSS(x).B.CSSYSCMD)
/*@}*/

/*!
 * @name Register MLB_MSS, field SWSYSCMD[4] (RO)
 *
 * Software system command detected (in the system quadlet). Set by hardware,
 * cleared by software. Data is stored in the MSD register for this command.
 */
/*@{*/
#define BP_MLB_MSS_SWSYSCMD  (4U)          /*!< Bit position for MLB_MSS_SWSYSCMD. */
#define BM_MLB_MSS_SWSYSCMD  (0x00000010U) /*!< Bit mask for MLB_MSS_SWSYSCMD. */
#define BS_MLB_MSS_SWSYSCMD  (1U)          /*!< Bit field size in bits for MLB_MSS_SWSYSCMD. */

/*! @brief Read current value of the MLB_MSS_SWSYSCMD field. */
#define BR_MLB_MSS_SWSYSCMD(x) (HW_MLB_MSS(x).B.SWSYSCMD)
/*@}*/

/*!
 * @name Register MLB_MSS, field SERVREQ[5] (RW)
 *
 * Service request enabled. When set, the MediaLB block responds with a "device
 * present, request service" system response if a matching channel scan system
 * command is detected. When cleared, the MediaLB block responds with a "device
 * present" system response.
 */
/*@{*/
#define BP_MLB_MSS_SERVREQ   (5U)          /*!< Bit position for MLB_MSS_SERVREQ. */
#define BM_MLB_MSS_SERVREQ   (0x00000020U) /*!< Bit mask for MLB_MSS_SERVREQ. */
#define BS_MLB_MSS_SERVREQ   (1U)          /*!< Bit field size in bits for MLB_MSS_SERVREQ. */

/*! @brief Read current value of the MLB_MSS_SERVREQ field. */
#define BR_MLB_MSS_SERVREQ(x) (HW_MLB_MSS(x).B.SERVREQ)

/*! @brief Format value for bitfield MLB_MSS_SERVREQ. */
#define BF_MLB_MSS_SERVREQ(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MSS_SERVREQ) & BM_MLB_MSS_SERVREQ)

/*! @brief Set the SERVREQ field to a new value. */
#define BW_MLB_MSS_SERVREQ(x, v) (HW_MLB_MSS_WR(x, (HW_MLB_MSS_RD(x) & ~BM_MLB_MSS_SERVREQ) | BF_MLB_MSS_SERVREQ(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_MSD - MediaLB System Data Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MSD - MediaLB System Data Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_msd
{
    uint32_t U;
    struct _hw_mlb_msd_bitfields
    {
        uint32_t SD0_7_0 : 8;          /*!< [7:0]  */
        uint32_t SD1_7_0 : 8;          /*!< [15:8]  */
        uint32_t SD2_7_0 : 8;          /*!< [23:16]  */
        uint32_t SD3_7_0 : 8;          /*!< [31:24]  */
    } B;
} hw_mlb_msd_t;

/*!
 * @name Constants and macros for entire MLB_MSD register
 */
/*@{*/
#define HW_MLB_MSD_ADDR(x)       ((uintptr_t)(x) + 0x24U)

#define HW_MLB_MSD(x)            (*(__I hw_mlb_msd_t *) HW_MLB_MSD_ADDR(x))
#define HW_MLB_MSD_RD(x)         (HW_MLB_MSD(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_MSD bitfields
 */

/*!
 * @name Register MLB_MSD, field SD0_7_0[7:0] (RO)
 *
 * System data (byte 0). Updated with MediaLB Data[7:0] when a MediaLB software
 * system command is received in the system quadlet. If MSS.SWSYSCMD is already
 * set, then SD0 is not updated. (read-only)
 */
/*@{*/
#define BP_MLB_MSD_SD0_7_0   (0U)          /*!< Bit position for MLB_MSD_SD0_7_0. */
#define BM_MLB_MSD_SD0_7_0   (0x000000FFU) /*!< Bit mask for MLB_MSD_SD0_7_0. */
#define BS_MLB_MSD_SD0_7_0   (8U)          /*!< Bit field size in bits for MLB_MSD_SD0_7_0. */

/*! @brief Read current value of the MLB_MSD_SD0_7_0 field. */
#define BR_MLB_MSD_SD0_7_0(x) (HW_MLB_MSD(x).B.SD0_7_0)
/*@}*/

/*!
 * @name Register MLB_MSD, field SD1_7_0[15:8] (RO)
 *
 * System data (byte 1). Updated with MediaLB Data[15:8] when a MediaLB software
 * system command is received in the system quadlet. If MSS.SWSYSCMD is already
 * set, then SD1 is not updated. (read-only)
 */
/*@{*/
#define BP_MLB_MSD_SD1_7_0   (8U)          /*!< Bit position for MLB_MSD_SD1_7_0. */
#define BM_MLB_MSD_SD1_7_0   (0x0000FF00U) /*!< Bit mask for MLB_MSD_SD1_7_0. */
#define BS_MLB_MSD_SD1_7_0   (8U)          /*!< Bit field size in bits for MLB_MSD_SD1_7_0. */

/*! @brief Read current value of the MLB_MSD_SD1_7_0 field. */
#define BR_MLB_MSD_SD1_7_0(x) (HW_MLB_MSD(x).B.SD1_7_0)
/*@}*/

/*!
 * @name Register MLB_MSD, field SD2_7_0[23:16] (RO)
 *
 * System data (byte 2). Updated with MediaLB Data[23:16] when a MediaLB
 * software system command is received in the system quadlet. If MSS.SWSYSCMD is already
 * set, then SD2 is not updated. (read-only)
 */
/*@{*/
#define BP_MLB_MSD_SD2_7_0   (16U)         /*!< Bit position for MLB_MSD_SD2_7_0. */
#define BM_MLB_MSD_SD2_7_0   (0x00FF0000U) /*!< Bit mask for MLB_MSD_SD2_7_0. */
#define BS_MLB_MSD_SD2_7_0   (8U)          /*!< Bit field size in bits for MLB_MSD_SD2_7_0. */

/*! @brief Read current value of the MLB_MSD_SD2_7_0 field. */
#define BR_MLB_MSD_SD2_7_0(x) (HW_MLB_MSD(x).B.SD2_7_0)
/*@}*/

/*!
 * @name Register MLB_MSD, field SD3_7_0[31:24] (RO)
 *
 * System data (byte 3). Updated with MediaLB Data[31:24] when a MediaLB
 * software system command is received in the system quadlet. If MSS.SWSYSCMD is already
 * set, then SD3 is not updated. (read-only)
 */
/*@{*/
#define BP_MLB_MSD_SD3_7_0   (24U)         /*!< Bit position for MLB_MSD_SD3_7_0. */
#define BM_MLB_MSD_SD3_7_0   (0xFF000000U) /*!< Bit mask for MLB_MSD_SD3_7_0. */
#define BS_MLB_MSD_SD3_7_0   (8U)          /*!< Bit field size in bits for MLB_MSD_SD3_7_0. */

/*! @brief Read current value of the MLB_MSD_SD3_7_0 field. */
#define BR_MLB_MSD_SD3_7_0(x) (HW_MLB_MSD(x).B.SD3_7_0)
/*@}*/

/*******************************************************************************
 * HW_MLB_MIEN - MediaLB Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MIEN - MediaLB Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mien
{
    uint32_t U;
    struct _hw_mlb_mien_bitfields
    {
        uint32_t ISOC_PE : 1;          /*!< [0]  */
        uint32_t ISOC_BUFO : 1;        /*!< [1]  */
        uint32_t RESERVED0 : 14;       /*!< [15:2]  */
        uint32_t SYNC_PE : 1;          /*!< [16]  */
        uint32_t ARX_DONE : 1;         /*!< [17]  */
        uint32_t ARX_PE : 1;           /*!< [18]  */
        uint32_t ARX_BREAK : 1;        /*!< [19]  */
        uint32_t ATX_DONE : 1;         /*!< [20]  */
        uint32_t ATX_PE : 1;           /*!< [21]  */
        uint32_t ATX_BREAK : 1;        /*!< [22]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t CRX_DONE : 1;         /*!< [24]  */
        uint32_t CRX_PE : 1;           /*!< [25]  */
        uint32_t CRX_BREAK : 1;        /*!< [26]  */
        uint32_t CTX_DONE : 1;         /*!< [27]  */
        uint32_t CTX_PE : 1;           /*!< [28]  */
        uint32_t CTX_BREAK : 1;        /*!< [29]  */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_mlb_mien_t;

/*!
 * @name Constants and macros for entire MLB_MIEN register
 */
/*@{*/
#define HW_MLB_MIEN_ADDR(x)      ((uintptr_t)(x) + 0x2CU)

#define HW_MLB_MIEN(x)           (*(__IO hw_mlb_mien_t *) HW_MLB_MIEN_ADDR(x))
#define HW_MLB_MIEN_RD(x)        (HW_MLB_MIEN(x).U)
#define HW_MLB_MIEN_WR(x, v)     (HW_MLB_MIEN(x).U = (v))
#define HW_MLB_MIEN_SET(x, v)    (HW_MLB_MIEN_WR(x, HW_MLB_MIEN_RD(x) |  (v)))
#define HW_MLB_MIEN_CLR(x, v)    (HW_MLB_MIEN_WR(x, HW_MLB_MIEN_RD(x) & ~(v)))
#define HW_MLB_MIEN_TOG(x, v)    (HW_MLB_MIEN_WR(x, HW_MLB_MIEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MIEN bitfields
 */

/*!
 * @name Register MLB_MIEN, field ISOC_PE[0] (RW)
 *
 * Isochronous Rx protocol error enable. When set, a ProtocolError detected on
 * an isochronous Rx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ISOC_PE  (0U)          /*!< Bit position for MLB_MIEN_ISOC_PE. */
#define BM_MLB_MIEN_ISOC_PE  (0x00000001U) /*!< Bit mask for MLB_MIEN_ISOC_PE. */
#define BS_MLB_MIEN_ISOC_PE  (1U)          /*!< Bit field size in bits for MLB_MIEN_ISOC_PE. */

/*! @brief Read current value of the MLB_MIEN_ISOC_PE field. */
#define BR_MLB_MIEN_ISOC_PE(x) (HW_MLB_MIEN(x).B.ISOC_PE)

/*! @brief Format value for bitfield MLB_MIEN_ISOC_PE. */
#define BF_MLB_MIEN_ISOC_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ISOC_PE) & BM_MLB_MIEN_ISOC_PE)

/*! @brief Set the ISOC_PE field to a new value. */
#define BW_MLB_MIEN_ISOC_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ISOC_PE) | BF_MLB_MIEN_ISOC_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ISOC_BUFO[1] (RW)
 *
 * Isochronous Rx buffer overflow enable. When set, a buffer overflow on an
 * isochronous Rx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set. This occurs only when isochronous flow control is disabled.
 */
/*@{*/
#define BP_MLB_MIEN_ISOC_BUFO (1U)         /*!< Bit position for MLB_MIEN_ISOC_BUFO. */
#define BM_MLB_MIEN_ISOC_BUFO (0x00000002U) /*!< Bit mask for MLB_MIEN_ISOC_BUFO. */
#define BS_MLB_MIEN_ISOC_BUFO (1U)         /*!< Bit field size in bits for MLB_MIEN_ISOC_BUFO. */

/*! @brief Read current value of the MLB_MIEN_ISOC_BUFO field. */
#define BR_MLB_MIEN_ISOC_BUFO(x) (HW_MLB_MIEN(x).B.ISOC_BUFO)

/*! @brief Format value for bitfield MLB_MIEN_ISOC_BUFO. */
#define BF_MLB_MIEN_ISOC_BUFO(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ISOC_BUFO) & BM_MLB_MIEN_ISOC_BUFO)

/*! @brief Set the ISOC_BUFO field to a new value. */
#define BW_MLB_MIEN_ISOC_BUFO(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ISOC_BUFO) | BF_MLB_MIEN_ISOC_BUFO(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field SYNC_PE[16] (RW)
 *
 * Synchronous protocol error enable. When set, a ProtocolError detected on a
 * synchronous Rx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_SYNC_PE  (16U)         /*!< Bit position for MLB_MIEN_SYNC_PE. */
#define BM_MLB_MIEN_SYNC_PE  (0x00010000U) /*!< Bit mask for MLB_MIEN_SYNC_PE. */
#define BS_MLB_MIEN_SYNC_PE  (1U)          /*!< Bit field size in bits for MLB_MIEN_SYNC_PE. */

/*! @brief Read current value of the MLB_MIEN_SYNC_PE field. */
#define BR_MLB_MIEN_SYNC_PE(x) (HW_MLB_MIEN(x).B.SYNC_PE)

/*! @brief Format value for bitfield MLB_MIEN_SYNC_PE. */
#define BF_MLB_MIEN_SYNC_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_SYNC_PE) & BM_MLB_MIEN_SYNC_PE)

/*! @brief Set the SYNC_PE field to a new value. */
#define BW_MLB_MIEN_SYNC_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_SYNC_PE) | BF_MLB_MIEN_SYNC_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ARX_DONE[17] (RW)
 *
 * Asynchronous Rx done enable. When set, a packet received with no errors on an
 * asynchronous Rx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ARX_DONE (17U)         /*!< Bit position for MLB_MIEN_ARX_DONE. */
#define BM_MLB_MIEN_ARX_DONE (0x00020000U) /*!< Bit mask for MLB_MIEN_ARX_DONE. */
#define BS_MLB_MIEN_ARX_DONE (1U)          /*!< Bit field size in bits for MLB_MIEN_ARX_DONE. */

/*! @brief Read current value of the MLB_MIEN_ARX_DONE field. */
#define BR_MLB_MIEN_ARX_DONE(x) (HW_MLB_MIEN(x).B.ARX_DONE)

/*! @brief Format value for bitfield MLB_MIEN_ARX_DONE. */
#define BF_MLB_MIEN_ARX_DONE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ARX_DONE) & BM_MLB_MIEN_ARX_DONE)

/*! @brief Set the ARX_DONE field to a new value. */
#define BW_MLB_MIEN_ARX_DONE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ARX_DONE) | BF_MLB_MIEN_ARX_DONE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ARX_PE[18] (RW)
 *
 * Asynchronous Rx protocol error enable. When set, a ProtocolError detected on
 * an asynchronous Rx channel causes the appropriate channel bit in the MS0 or
 * MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ARX_PE   (18U)         /*!< Bit position for MLB_MIEN_ARX_PE. */
#define BM_MLB_MIEN_ARX_PE   (0x00040000U) /*!< Bit mask for MLB_MIEN_ARX_PE. */
#define BS_MLB_MIEN_ARX_PE   (1U)          /*!< Bit field size in bits for MLB_MIEN_ARX_PE. */

/*! @brief Read current value of the MLB_MIEN_ARX_PE field. */
#define BR_MLB_MIEN_ARX_PE(x) (HW_MLB_MIEN(x).B.ARX_PE)

/*! @brief Format value for bitfield MLB_MIEN_ARX_PE. */
#define BF_MLB_MIEN_ARX_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ARX_PE) & BM_MLB_MIEN_ARX_PE)

/*! @brief Set the ARX_PE field to a new value. */
#define BW_MLB_MIEN_ARX_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ARX_PE) | BF_MLB_MIEN_ARX_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ARX_BREAK[19] (RW)
 *
 * Asynchronous Rx break enable. When set, a AsyncBreak command received from
 * the transmitter on an asynchronous Rx channel causes the appropriate channel bit
 * in the MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ARX_BREAK (19U)        /*!< Bit position for MLB_MIEN_ARX_BREAK. */
#define BM_MLB_MIEN_ARX_BREAK (0x00080000U) /*!< Bit mask for MLB_MIEN_ARX_BREAK. */
#define BS_MLB_MIEN_ARX_BREAK (1U)         /*!< Bit field size in bits for MLB_MIEN_ARX_BREAK. */

/*! @brief Read current value of the MLB_MIEN_ARX_BREAK field. */
#define BR_MLB_MIEN_ARX_BREAK(x) (HW_MLB_MIEN(x).B.ARX_BREAK)

/*! @brief Format value for bitfield MLB_MIEN_ARX_BREAK. */
#define BF_MLB_MIEN_ARX_BREAK(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ARX_BREAK) & BM_MLB_MIEN_ARX_BREAK)

/*! @brief Set the ARX_BREAK field to a new value. */
#define BW_MLB_MIEN_ARX_BREAK(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ARX_BREAK) | BF_MLB_MIEN_ARX_BREAK(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ATX_DONE[20] (RW)
 *
 * Asynchronous Tx packet done enable. When set, a packet transmitted with no
 * errors on an asynchronous Tx channel causes the appropriate channel bit in the
 * MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ATX_DONE (20U)         /*!< Bit position for MLB_MIEN_ATX_DONE. */
#define BM_MLB_MIEN_ATX_DONE (0x00100000U) /*!< Bit mask for MLB_MIEN_ATX_DONE. */
#define BS_MLB_MIEN_ATX_DONE (1U)          /*!< Bit field size in bits for MLB_MIEN_ATX_DONE. */

/*! @brief Read current value of the MLB_MIEN_ATX_DONE field. */
#define BR_MLB_MIEN_ATX_DONE(x) (HW_MLB_MIEN(x).B.ATX_DONE)

/*! @brief Format value for bitfield MLB_MIEN_ATX_DONE. */
#define BF_MLB_MIEN_ATX_DONE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ATX_DONE) & BM_MLB_MIEN_ATX_DONE)

/*! @brief Set the ATX_DONE field to a new value. */
#define BW_MLB_MIEN_ATX_DONE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ATX_DONE) | BF_MLB_MIEN_ATX_DONE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ATX_PE[21] (RW)
 *
 * Asynchronous Tx protocol error enable. When set, a ProtocolError generated by
 * the receiver on an asynchronous Tx channel causes the appropriate channel bit
 * in the MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ATX_PE   (21U)         /*!< Bit position for MLB_MIEN_ATX_PE. */
#define BM_MLB_MIEN_ATX_PE   (0x00200000U) /*!< Bit mask for MLB_MIEN_ATX_PE. */
#define BS_MLB_MIEN_ATX_PE   (1U)          /*!< Bit field size in bits for MLB_MIEN_ATX_PE. */

/*! @brief Read current value of the MLB_MIEN_ATX_PE field. */
#define BR_MLB_MIEN_ATX_PE(x) (HW_MLB_MIEN(x).B.ATX_PE)

/*! @brief Format value for bitfield MLB_MIEN_ATX_PE. */
#define BF_MLB_MIEN_ATX_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ATX_PE) & BM_MLB_MIEN_ATX_PE)

/*! @brief Set the ATX_PE field to a new value. */
#define BW_MLB_MIEN_ATX_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ATX_PE) | BF_MLB_MIEN_ATX_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field ATX_BREAK[22] (RW)
 *
 * Asynchronous Tx break enable. When set, a ReceiverBreak response received
 * from the receiver on an asynchronous Tx channel causes the appropriate channel
 * bit in the MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_ATX_BREAK (22U)        /*!< Bit position for MLB_MIEN_ATX_BREAK. */
#define BM_MLB_MIEN_ATX_BREAK (0x00400000U) /*!< Bit mask for MLB_MIEN_ATX_BREAK. */
#define BS_MLB_MIEN_ATX_BREAK (1U)         /*!< Bit field size in bits for MLB_MIEN_ATX_BREAK. */

/*! @brief Read current value of the MLB_MIEN_ATX_BREAK field. */
#define BR_MLB_MIEN_ATX_BREAK(x) (HW_MLB_MIEN(x).B.ATX_BREAK)

/*! @brief Format value for bitfield MLB_MIEN_ATX_BREAK. */
#define BF_MLB_MIEN_ATX_BREAK(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_ATX_BREAK) & BM_MLB_MIEN_ATX_BREAK)

/*! @brief Set the ATX_BREAK field to a new value. */
#define BW_MLB_MIEN_ATX_BREAK(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_ATX_BREAK) | BF_MLB_MIEN_ATX_BREAK(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CRX_DONE[24] (RW)
 *
 * Control Rx packet done enable. When set, a packet received with no errors on
 * a control Rx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CRX_DONE (24U)         /*!< Bit position for MLB_MIEN_CRX_DONE. */
#define BM_MLB_MIEN_CRX_DONE (0x01000000U) /*!< Bit mask for MLB_MIEN_CRX_DONE. */
#define BS_MLB_MIEN_CRX_DONE (1U)          /*!< Bit field size in bits for MLB_MIEN_CRX_DONE. */

/*! @brief Read current value of the MLB_MIEN_CRX_DONE field. */
#define BR_MLB_MIEN_CRX_DONE(x) (HW_MLB_MIEN(x).B.CRX_DONE)

/*! @brief Format value for bitfield MLB_MIEN_CRX_DONE. */
#define BF_MLB_MIEN_CRX_DONE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CRX_DONE) & BM_MLB_MIEN_CRX_DONE)

/*! @brief Set the CRX_DONE field to a new value. */
#define BW_MLB_MIEN_CRX_DONE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CRX_DONE) | BF_MLB_MIEN_CRX_DONE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CRX_PE[25] (RW)
 *
 * Control Rx protocol error enable. When set, a ProtocolError detected on a
 * control Rx channel causes the appropriate channel bit in the MS0 or MS1 registers
 * to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CRX_PE   (25U)         /*!< Bit position for MLB_MIEN_CRX_PE. */
#define BM_MLB_MIEN_CRX_PE   (0x02000000U) /*!< Bit mask for MLB_MIEN_CRX_PE. */
#define BS_MLB_MIEN_CRX_PE   (1U)          /*!< Bit field size in bits for MLB_MIEN_CRX_PE. */

/*! @brief Read current value of the MLB_MIEN_CRX_PE field. */
#define BR_MLB_MIEN_CRX_PE(x) (HW_MLB_MIEN(x).B.CRX_PE)

/*! @brief Format value for bitfield MLB_MIEN_CRX_PE. */
#define BF_MLB_MIEN_CRX_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CRX_PE) & BM_MLB_MIEN_CRX_PE)

/*! @brief Set the CRX_PE field to a new value. */
#define BW_MLB_MIEN_CRX_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CRX_PE) | BF_MLB_MIEN_CRX_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CRX_BREAK[26] (RW)
 *
 * Control Rx break enable. When set, a ControlBreak command received from the
 * transmitter on a control Rx channel causes the appropriate channel bit in the
 * MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CRX_BREAK (26U)        /*!< Bit position for MLB_MIEN_CRX_BREAK. */
#define BM_MLB_MIEN_CRX_BREAK (0x04000000U) /*!< Bit mask for MLB_MIEN_CRX_BREAK. */
#define BS_MLB_MIEN_CRX_BREAK (1U)         /*!< Bit field size in bits for MLB_MIEN_CRX_BREAK. */

/*! @brief Read current value of the MLB_MIEN_CRX_BREAK field. */
#define BR_MLB_MIEN_CRX_BREAK(x) (HW_MLB_MIEN(x).B.CRX_BREAK)

/*! @brief Format value for bitfield MLB_MIEN_CRX_BREAK. */
#define BF_MLB_MIEN_CRX_BREAK(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CRX_BREAK) & BM_MLB_MIEN_CRX_BREAK)

/*! @brief Set the CRX_BREAK field to a new value. */
#define BW_MLB_MIEN_CRX_BREAK(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CRX_BREAK) | BF_MLB_MIEN_CRX_BREAK(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CTX_DONE[27] (RW)
 *
 * Control Tx packet done enable. When set, a packet transmitted with no errors
 * on a control Tx channel causes the appropriate channel bit in the MS0 or MS1
 * registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CTX_DONE (27U)         /*!< Bit position for MLB_MIEN_CTX_DONE. */
#define BM_MLB_MIEN_CTX_DONE (0x08000000U) /*!< Bit mask for MLB_MIEN_CTX_DONE. */
#define BS_MLB_MIEN_CTX_DONE (1U)          /*!< Bit field size in bits for MLB_MIEN_CTX_DONE. */

/*! @brief Read current value of the MLB_MIEN_CTX_DONE field. */
#define BR_MLB_MIEN_CTX_DONE(x) (HW_MLB_MIEN(x).B.CTX_DONE)

/*! @brief Format value for bitfield MLB_MIEN_CTX_DONE. */
#define BF_MLB_MIEN_CTX_DONE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CTX_DONE) & BM_MLB_MIEN_CTX_DONE)

/*! @brief Set the CTX_DONE field to a new value. */
#define BW_MLB_MIEN_CTX_DONE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CTX_DONE) | BF_MLB_MIEN_CTX_DONE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CTX_PE[28] (RW)
 *
 * Control Tx protocol error enable. When set, a ProtocolError generated by the
 * receiver on a control Tx channel causes the appropriate channel bit in the MS0
 * or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CTX_PE   (28U)         /*!< Bit position for MLB_MIEN_CTX_PE. */
#define BM_MLB_MIEN_CTX_PE   (0x10000000U) /*!< Bit mask for MLB_MIEN_CTX_PE. */
#define BS_MLB_MIEN_CTX_PE   (1U)          /*!< Bit field size in bits for MLB_MIEN_CTX_PE. */

/*! @brief Read current value of the MLB_MIEN_CTX_PE field. */
#define BR_MLB_MIEN_CTX_PE(x) (HW_MLB_MIEN(x).B.CTX_PE)

/*! @brief Format value for bitfield MLB_MIEN_CTX_PE. */
#define BF_MLB_MIEN_CTX_PE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CTX_PE) & BM_MLB_MIEN_CTX_PE)

/*! @brief Set the CTX_PE field to a new value. */
#define BW_MLB_MIEN_CTX_PE(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CTX_PE) | BF_MLB_MIEN_CTX_PE(v)))
/*@}*/

/*!
 * @name Register MLB_MIEN, field CTX_BREAK[29] (RW)
 *
 * Control Tx break enable. When set, a ReceiverBreak response received from the
 * receiver on a control Tx channel causes the appropriate channel bit in the
 * MS0 or MS1 registers to be set.
 */
/*@{*/
#define BP_MLB_MIEN_CTX_BREAK (29U)        /*!< Bit position for MLB_MIEN_CTX_BREAK. */
#define BM_MLB_MIEN_CTX_BREAK (0x20000000U) /*!< Bit mask for MLB_MIEN_CTX_BREAK. */
#define BS_MLB_MIEN_CTX_BREAK (1U)         /*!< Bit field size in bits for MLB_MIEN_CTX_BREAK. */

/*! @brief Read current value of the MLB_MIEN_CTX_BREAK field. */
#define BR_MLB_MIEN_CTX_BREAK(x) (HW_MLB_MIEN(x).B.CTX_BREAK)

/*! @brief Format value for bitfield MLB_MIEN_CTX_BREAK. */
#define BF_MLB_MIEN_CTX_BREAK(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MIEN_CTX_BREAK) & BM_MLB_MIEN_CTX_BREAK)

/*! @brief Set the CTX_BREAK field to a new value. */
#define BW_MLB_MIEN_CTX_BREAK(x, v) (HW_MLB_MIEN_WR(x, (HW_MLB_MIEN_RD(x) & ~BM_MLB_MIEN_CTX_BREAK) | BF_MLB_MIEN_CTX_BREAK(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_MLBPC1 - MediaLB 6-pin Control 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MLBPC1 - MediaLB 6-pin Control 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mlbpc1
{
    uint32_t U;
    struct _hw_mlb_mlbpc1_bitfields
    {
        uint32_t SDRCVBIAS_3_0 : 4;    /*!< [3:0]  */
        uint32_t SDXMTBIAS_3_0 : 4;    /*!< [7:4]  */
        uint32_t CKRCVBIAS_3_0 : 4;    /*!< [11:8]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_mlb_mlbpc1_t;

/*!
 * @name Constants and macros for entire MLB_MLBPC1 register
 */
/*@{*/
#define HW_MLB_MLBPC1_ADDR(x)    ((uintptr_t)(x) + 0x38U)

#define HW_MLB_MLBPC1(x)         (*(__IO hw_mlb_mlbpc1_t *) HW_MLB_MLBPC1_ADDR(x))
#define HW_MLB_MLBPC1_RD(x)      (HW_MLB_MLBPC1(x).U)
#define HW_MLB_MLBPC1_WR(x, v)   (HW_MLB_MLBPC1(x).U = (v))
#define HW_MLB_MLBPC1_SET(x, v)  (HW_MLB_MLBPC1_WR(x, HW_MLB_MLBPC1_RD(x) |  (v)))
#define HW_MLB_MLBPC1_CLR(x, v)  (HW_MLB_MLBPC1_WR(x, HW_MLB_MLBPC1_RD(x) & ~(v)))
#define HW_MLB_MLBPC1_TOG(x, v)  (HW_MLB_MLBPC1_WR(x, HW_MLB_MLBPC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MLBPC1 bitfields
 */

/*!
 * @name Register MLB_MLBPC1, field SDRCVBIAS_3_0[3:0] (RW)
 *
 * Signal/Data receiver bias control (for MediaLB 6-pin interface). Must be
 * written to 0xC when MediaLB 6-pin is initialized (final value needs to be
 * determined through characterization). This value is driven on MLB_SIG, MLB_SIG_N and
 * MLB_SIG_P output pins and has no internal function.
 */
/*@{*/
#define BP_MLB_MLBPC1_SDRCVBIAS_3_0 (0U)   /*!< Bit position for MLB_MLBPC1_SDRCVBIAS_3_0. */
#define BM_MLB_MLBPC1_SDRCVBIAS_3_0 (0x0000000FU) /*!< Bit mask for MLB_MLBPC1_SDRCVBIAS_3_0. */
#define BS_MLB_MLBPC1_SDRCVBIAS_3_0 (4U)   /*!< Bit field size in bits for MLB_MLBPC1_SDRCVBIAS_3_0. */

/*! @brief Read current value of the MLB_MLBPC1_SDRCVBIAS_3_0 field. */
#define BR_MLB_MLBPC1_SDRCVBIAS_3_0(x) (HW_MLB_MLBPC1(x).B.SDRCVBIAS_3_0)

/*! @brief Format value for bitfield MLB_MLBPC1_SDRCVBIAS_3_0. */
#define BF_MLB_MLBPC1_SDRCVBIAS_3_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC1_SDRCVBIAS_3_0) & BM_MLB_MLBPC1_SDRCVBIAS_3_0)

/*! @brief Set the SDRCVBIAS_3_0 field to a new value. */
#define BW_MLB_MLBPC1_SDRCVBIAS_3_0(x, v) (HW_MLB_MLBPC1_WR(x, (HW_MLB_MLBPC1_RD(x) & ~BM_MLB_MLBPC1_SDRCVBIAS_3_0) | BF_MLB_MLBPC1_SDRCVBIAS_3_0(v)))
/*@}*/

/*!
 * @name Register MLB_MLBPC1, field SDXMTBIAS_3_0[7:4] (RW)
 *
 * Signal/Data transmitter bias control (for MediaLB 6-pin interface). Must be
 * written to 0xC when MediaLB 6-pin is initialized (final value needs to be
 * determined through characterization). This value is driven on MLB_DATA, MLB_DATA_N
 * and MLB_DATA_P output pins and has no internal function.
 */
/*@{*/
#define BP_MLB_MLBPC1_SDXMTBIAS_3_0 (4U)   /*!< Bit position for MLB_MLBPC1_SDXMTBIAS_3_0. */
#define BM_MLB_MLBPC1_SDXMTBIAS_3_0 (0x000000F0U) /*!< Bit mask for MLB_MLBPC1_SDXMTBIAS_3_0. */
#define BS_MLB_MLBPC1_SDXMTBIAS_3_0 (4U)   /*!< Bit field size in bits for MLB_MLBPC1_SDXMTBIAS_3_0. */

/*! @brief Read current value of the MLB_MLBPC1_SDXMTBIAS_3_0 field. */
#define BR_MLB_MLBPC1_SDXMTBIAS_3_0(x) (HW_MLB_MLBPC1(x).B.SDXMTBIAS_3_0)

/*! @brief Format value for bitfield MLB_MLBPC1_SDXMTBIAS_3_0. */
#define BF_MLB_MLBPC1_SDXMTBIAS_3_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC1_SDXMTBIAS_3_0) & BM_MLB_MLBPC1_SDXMTBIAS_3_0)

/*! @brief Set the SDXMTBIAS_3_0 field to a new value. */
#define BW_MLB_MLBPC1_SDXMTBIAS_3_0(x, v) (HW_MLB_MLBPC1_WR(x, (HW_MLB_MLBPC1_RD(x) & ~BM_MLB_MLBPC1_SDXMTBIAS_3_0) | BF_MLB_MLBPC1_SDXMTBIAS_3_0(v)))
/*@}*/

/*!
 * @name Register MLB_MLBPC1, field CKRCVBIAS_3_0[11:8] (RW)
 *
 * Clock receiver bias control (for MediaLB 6-pin interface). Must be written to
 * 0xC when MediaLB 6-pin is initialized (final value needs to be determined
 * through characterization). This value is driven on MLB_CLK, MLB_CLK_N and
 * MLB_CLK_P output pins and has no internal function.
 */
/*@{*/
#define BP_MLB_MLBPC1_CKRCVBIAS_3_0 (8U)   /*!< Bit position for MLB_MLBPC1_CKRCVBIAS_3_0. */
#define BM_MLB_MLBPC1_CKRCVBIAS_3_0 (0x00000F00U) /*!< Bit mask for MLB_MLBPC1_CKRCVBIAS_3_0. */
#define BS_MLB_MLBPC1_CKRCVBIAS_3_0 (4U)   /*!< Bit field size in bits for MLB_MLBPC1_CKRCVBIAS_3_0. */

/*! @brief Read current value of the MLB_MLBPC1_CKRCVBIAS_3_0 field. */
#define BR_MLB_MLBPC1_CKRCVBIAS_3_0(x) (HW_MLB_MLBPC1(x).B.CKRCVBIAS_3_0)

/*! @brief Format value for bitfield MLB_MLBPC1_CKRCVBIAS_3_0. */
#define BF_MLB_MLBPC1_CKRCVBIAS_3_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBPC1_CKRCVBIAS_3_0) & BM_MLB_MLBPC1_CKRCVBIAS_3_0)

/*! @brief Set the CKRCVBIAS_3_0 field to a new value. */
#define BW_MLB_MLBPC1_CKRCVBIAS_3_0(x, v) (HW_MLB_MLBPC1_WR(x, (HW_MLB_MLBPC1_RD(x) & ~BM_MLB_MLBPC1_CKRCVBIAS_3_0) | BF_MLB_MLBPC1_CKRCVBIAS_3_0(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_MLBC1 - MediaLB Control 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MLBC1 - MediaLB Control 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mlbc1
{
    uint32_t U;
    struct _hw_mlb_mlbc1_bitfields
    {
        uint32_t RESERVED0 : 6;        /*!< [5:0]  */
        uint32_t LOCK : 1;             /*!< [6]  */
        uint32_t CLKM : 1;             /*!< [7]  */
        uint32_t NDA_7_0 : 8;          /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_mlb_mlbc1_t;

/*!
 * @name Constants and macros for entire MLB_MLBC1 register
 */
/*@{*/
#define HW_MLB_MLBC1_ADDR(x)     ((uintptr_t)(x) + 0x3CU)

#define HW_MLB_MLBC1(x)          (*(__IO hw_mlb_mlbc1_t *) HW_MLB_MLBC1_ADDR(x))
#define HW_MLB_MLBC1_RD(x)       (HW_MLB_MLBC1(x).U)
#define HW_MLB_MLBC1_WR(x, v)    (HW_MLB_MLBC1(x).U = (v))
#define HW_MLB_MLBC1_SET(x, v)   (HW_MLB_MLBC1_WR(x, HW_MLB_MLBC1_RD(x) |  (v)))
#define HW_MLB_MLBC1_CLR(x, v)   (HW_MLB_MLBC1_WR(x, HW_MLB_MLBC1_RD(x) & ~(v)))
#define HW_MLB_MLBC1_TOG(x, v)   (HW_MLB_MLBC1_WR(x, HW_MLB_MLBC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MLBC1 bitfields
 */

/*!
 * @name Register MLB_MLBC1, field LOCK[6] (RO)
 *
 * MediaLB lock error status. Set when MediaLB is unlocked; cleared by software.
 */
/*@{*/
#define BP_MLB_MLBC1_LOCK    (6U)          /*!< Bit position for MLB_MLBC1_LOCK. */
#define BM_MLB_MLBC1_LOCK    (0x00000040U) /*!< Bit mask for MLB_MLBC1_LOCK. */
#define BS_MLB_MLBC1_LOCK    (1U)          /*!< Bit field size in bits for MLB_MLBC1_LOCK. */

/*! @brief Read current value of the MLB_MLBC1_LOCK field. */
#define BR_MLB_MLBC1_LOCK(x) (HW_MLB_MLBC1(x).B.LOCK)
/*@}*/

/*!
 * @name Register MLB_MLBC1, field CLKM[7] (RO)
 *
 * MediaLB clock missing status. Set when MLB_CLK (MediaLB clock) is not
 * toggling at the pin; cleared by software.
 */
/*@{*/
#define BP_MLB_MLBC1_CLKM    (7U)          /*!< Bit position for MLB_MLBC1_CLKM. */
#define BM_MLB_MLBC1_CLKM    (0x00000080U) /*!< Bit mask for MLB_MLBC1_CLKM. */
#define BS_MLB_MLBC1_CLKM    (1U)          /*!< Bit field size in bits for MLB_MLBC1_CLKM. */

/*! @brief Read current value of the MLB_MLBC1_CLKM field. */
#define BR_MLB_MLBC1_CLKM(x) (HW_MLB_MLBC1(x).B.CLKM)
/*@}*/

/*!
 * @name Register MLB_MLBC1, field NDA_7_0[15:8] (RW)
 *
 * Node device address. Used for system commands directed to individual MediaLB
 * nodes.
 */
/*@{*/
#define BP_MLB_MLBC1_NDA_7_0 (8U)          /*!< Bit position for MLB_MLBC1_NDA_7_0. */
#define BM_MLB_MLBC1_NDA_7_0 (0x0000FF00U) /*!< Bit mask for MLB_MLBC1_NDA_7_0. */
#define BS_MLB_MLBC1_NDA_7_0 (8U)          /*!< Bit field size in bits for MLB_MLBC1_NDA_7_0. */

/*! @brief Read current value of the MLB_MLBC1_NDA_7_0 field. */
#define BR_MLB_MLBC1_NDA_7_0(x) (HW_MLB_MLBC1(x).B.NDA_7_0)

/*! @brief Format value for bitfield MLB_MLBC1_NDA_7_0. */
#define BF_MLB_MLBC1_NDA_7_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MLBC1_NDA_7_0) & BM_MLB_MLBC1_NDA_7_0)

/*! @brief Set the NDA_7_0 field to a new value. */
#define BW_MLB_MLBC1_NDA_7_0(x, v) (HW_MLB_MLBC1_WR(x, (HW_MLB_MLBC1_RD(x) & ~BM_MLB_MLBC1_NDA_7_0) | BF_MLB_MLBC1_NDA_7_0(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_HCTL - HBI Control Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCTL - HBI Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The HC can control and monitor general operation of the HBI block by reading
 * and writing the HBI Control Register (HCTL) through the I/O interface. Each
 * bit of HCTL is read/write.
 */
typedef union _hw_mlb_hctl
{
    uint32_t U;
    struct _hw_mlb_hctl_bitfields
    {
        uint32_t RST0 : 1;             /*!< [0]  */
        uint32_t RST1 : 1;             /*!< [1]  */
        uint32_t RESERVED0 : 13;       /*!< [14:2]  */
        uint32_t EN : 1;               /*!< [15]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_mlb_hctl_t;

/*!
 * @name Constants and macros for entire MLB_HCTL register
 */
/*@{*/
#define HW_MLB_HCTL_ADDR(x)      ((uintptr_t)(x) + 0x80U)

#define HW_MLB_HCTL(x)           (*(__IO hw_mlb_hctl_t *) HW_MLB_HCTL_ADDR(x))
#define HW_MLB_HCTL_RD(x)        (HW_MLB_HCTL(x).U)
#define HW_MLB_HCTL_WR(x, v)     (HW_MLB_HCTL(x).U = (v))
#define HW_MLB_HCTL_SET(x, v)    (HW_MLB_HCTL_WR(x, HW_MLB_HCTL_RD(x) |  (v)))
#define HW_MLB_HCTL_CLR(x, v)    (HW_MLB_HCTL_WR(x, HW_MLB_HCTL_RD(x) & ~(v)))
#define HW_MLB_HCTL_TOG(x, v)    (HW_MLB_HCTL_WR(x, HW_MLB_HCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_HCTL bitfields
 */

/*!
 * @name Register MLB_HCTL, field RST0[0] (RW)
 *
 * AGU0 software reset
 *
 * Values:
 * - 1 - reset
 * - 0 - active
 */
/*@{*/
#define BP_MLB_HCTL_RST0     (0U)          /*!< Bit position for MLB_HCTL_RST0. */
#define BM_MLB_HCTL_RST0     (0x00000001U) /*!< Bit mask for MLB_HCTL_RST0. */
#define BS_MLB_HCTL_RST0     (1U)          /*!< Bit field size in bits for MLB_HCTL_RST0. */

/*! @brief Read current value of the MLB_HCTL_RST0 field. */
#define BR_MLB_HCTL_RST0(x)  (HW_MLB_HCTL(x).B.RST0)

/*! @brief Format value for bitfield MLB_HCTL_RST0. */
#define BF_MLB_HCTL_RST0(v)  ((uint32_t)((uint32_t)(v) << BP_MLB_HCTL_RST0) & BM_MLB_HCTL_RST0)

/*! @brief Set the RST0 field to a new value. */
#define BW_MLB_HCTL_RST0(x, v) (HW_MLB_HCTL_WR(x, (HW_MLB_HCTL_RD(x) & ~BM_MLB_HCTL_RST0) | BF_MLB_HCTL_RST0(v)))
/*@}*/

/*!
 * @name Register MLB_HCTL, field RST1[1] (RW)
 *
 * AGU1 software reset
 *
 * Values:
 * - 1 - reset
 * - 0 - active
 */
/*@{*/
#define BP_MLB_HCTL_RST1     (1U)          /*!< Bit position for MLB_HCTL_RST1. */
#define BM_MLB_HCTL_RST1     (0x00000002U) /*!< Bit mask for MLB_HCTL_RST1. */
#define BS_MLB_HCTL_RST1     (1U)          /*!< Bit field size in bits for MLB_HCTL_RST1. */

/*! @brief Read current value of the MLB_HCTL_RST1 field. */
#define BR_MLB_HCTL_RST1(x)  (HW_MLB_HCTL(x).B.RST1)

/*! @brief Format value for bitfield MLB_HCTL_RST1. */
#define BF_MLB_HCTL_RST1(v)  ((uint32_t)((uint32_t)(v) << BP_MLB_HCTL_RST1) & BM_MLB_HCTL_RST1)

/*! @brief Set the RST1 field to a new value. */
#define BW_MLB_HCTL_RST1(x, v) (HW_MLB_HCTL_WR(x, (HW_MLB_HCTL_RD(x) & ~BM_MLB_HCTL_RST1) | BF_MLB_HCTL_RST1(v)))
/*@}*/

/*!
 * @name Register MLB_HCTL, field EN[15] (RW)
 *
 * HBI enable
 *
 * Values:
 * - 1 - enabled
 * - 0 - disabled
 */
/*@{*/
#define BP_MLB_HCTL_EN       (15U)         /*!< Bit position for MLB_HCTL_EN. */
#define BM_MLB_HCTL_EN       (0x00008000U) /*!< Bit mask for MLB_HCTL_EN. */
#define BS_MLB_HCTL_EN       (1U)          /*!< Bit field size in bits for MLB_HCTL_EN. */

/*! @brief Read current value of the MLB_HCTL_EN field. */
#define BR_MLB_HCTL_EN(x)    (HW_MLB_HCTL(x).B.EN)

/*! @brief Format value for bitfield MLB_HCTL_EN. */
#define BF_MLB_HCTL_EN(v)    ((uint32_t)((uint32_t)(v) << BP_MLB_HCTL_EN) & BM_MLB_HCTL_EN)

/*! @brief Set the EN field to a new value. */
#define BW_MLB_HCTL_EN(x, v) (HW_MLB_HCTL_WR(x, (HW_MLB_HCTL_RD(x) & ~BM_MLB_HCTL_EN) | BF_MLB_HCTL_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_HCMR0 - HBI Channel Mask 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCMR0 - HBI Channel Mask 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The HC can control which channel(s) are able to generate an HBI interrupt by
 * writing the HBI Channel Mask Registers (HCMRn). The HCMRn registers mask the
 * channel interrupt on the hbi_hintb signal (i.e. hbi_hintb will not become
 * active for any masked channel). Each bit of HCMRn is read/write.
 */
typedef union _hw_mlb_hcmr0
{
    uint32_t U;
    struct _hw_mlb_hcmr0_bitfields
    {
        uint32_t CHM_31_0_P : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_hcmr0_t;

/*!
 * @name Constants and macros for entire MLB_HCMR0 register
 */
/*@{*/
#define HW_MLB_HCMR0_ADDR(x)     ((uintptr_t)(x) + 0x88U)

#define HW_MLB_HCMR0(x)          (*(__IO hw_mlb_hcmr0_t *) HW_MLB_HCMR0_ADDR(x))
#define HW_MLB_HCMR0_RD(x)       (HW_MLB_HCMR0(x).U)
#define HW_MLB_HCMR0_WR(x, v)    (HW_MLB_HCMR0(x).U = (v))
#define HW_MLB_HCMR0_SET(x, v)   (HW_MLB_HCMR0_WR(x, HW_MLB_HCMR0_RD(x) |  (v)))
#define HW_MLB_HCMR0_CLR(x, v)   (HW_MLB_HCMR0_WR(x, HW_MLB_HCMR0_RD(x) & ~(v)))
#define HW_MLB_HCMR0_TOG(x, v)   (HW_MLB_HCMR0_WR(x, HW_MLB_HCMR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_HCMR0 bitfields
 */

/*!
 * @name Register MLB_HCMR0, field CHM_31_0_P[31:0] (RW)
 *
 * Bitwise channel mask bit
 *
 * Values:
 * - 0 - masked
 * - 1 - unmasked
 */
/*@{*/
#define BP_MLB_HCMR0_CHM_31_0_P (0U)       /*!< Bit position for MLB_HCMR0_CHM_31_0_P. */
#define BM_MLB_HCMR0_CHM_31_0_P (0xFFFFFFFFU) /*!< Bit mask for MLB_HCMR0_CHM_31_0_P. */
#define BS_MLB_HCMR0_CHM_31_0_P (32U)      /*!< Bit field size in bits for MLB_HCMR0_CHM_31_0_P. */

/*! @brief Read current value of the MLB_HCMR0_CHM_31_0_P field. */
#define BR_MLB_HCMR0_CHM_31_0_P(x) (HW_MLB_HCMR0(x).U)

/*! @brief Format value for bitfield MLB_HCMR0_CHM_31_0_P. */
#define BF_MLB_HCMR0_CHM_31_0_P(v) ((uint32_t)((uint32_t)(v) << BP_MLB_HCMR0_CHM_31_0_P) & BM_MLB_HCMR0_CHM_31_0_P)

/*! @brief Set the CHM_31_0_P field to a new value. */
#define BW_MLB_HCMR0_CHM_31_0_P(x, v) (HW_MLB_HCMR0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_HCMR1 - HBI Channel Mask 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCMR1 - HBI Channel Mask 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_hcmr1
{
    uint32_t U;
    struct _hw_mlb_hcmr1_bitfields
    {
        uint32_t CHM_63_32 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_hcmr1_t;

/*!
 * @name Constants and macros for entire MLB_HCMR1 register
 */
/*@{*/
#define HW_MLB_HCMR1_ADDR(x)     ((uintptr_t)(x) + 0x8CU)

#define HW_MLB_HCMR1(x)          (*(__IO hw_mlb_hcmr1_t *) HW_MLB_HCMR1_ADDR(x))
#define HW_MLB_HCMR1_RD(x)       (HW_MLB_HCMR1(x).U)
#define HW_MLB_HCMR1_WR(x, v)    (HW_MLB_HCMR1(x).U = (v))
#define HW_MLB_HCMR1_SET(x, v)   (HW_MLB_HCMR1_WR(x, HW_MLB_HCMR1_RD(x) |  (v)))
#define HW_MLB_HCMR1_CLR(x, v)   (HW_MLB_HCMR1_WR(x, HW_MLB_HCMR1_RD(x) & ~(v)))
#define HW_MLB_HCMR1_TOG(x, v)   (HW_MLB_HCMR1_WR(x, HW_MLB_HCMR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_HCMR1 bitfields
 */

/*!
 * @name Register MLB_HCMR1, field CHM_63_32[31:0] (RW)
 *
 * Bitwise channel mask bit
 *
 * Values:
 * - 0 - masked
 * - 1 - unmasked
 */
/*@{*/
#define BP_MLB_HCMR1_CHM_63_32 (0U)        /*!< Bit position for MLB_HCMR1_CHM_63_32. */
#define BM_MLB_HCMR1_CHM_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_HCMR1_CHM_63_32. */
#define BS_MLB_HCMR1_CHM_63_32 (32U)       /*!< Bit field size in bits for MLB_HCMR1_CHM_63_32. */

/*! @brief Read current value of the MLB_HCMR1_CHM_63_32 field. */
#define BR_MLB_HCMR1_CHM_63_32(x) (HW_MLB_HCMR1(x).U)

/*! @brief Format value for bitfield MLB_HCMR1_CHM_63_32. */
#define BF_MLB_HCMR1_CHM_63_32(v) ((uint32_t)((uint32_t)(v) << BP_MLB_HCMR1_CHM_63_32) & BM_MLB_HCMR1_CHM_63_32)

/*! @brief Set the CHM_63_32 field to a new value. */
#define BW_MLB_HCMR1_CHM_63_32(x, v) (HW_MLB_HCMR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_HCER0 - HBI Channel Error 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCER0 - HBI Channel Error 0 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The HBI Channel Error Registers (HCERn) indicate which channel(s) have
 * encountered fatal errors.
 */
typedef union _hw_mlb_hcer0
{
    uint32_t U;
    struct _hw_mlb_hcer0_bitfields
    {
        uint32_t CERR_31_0 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_hcer0_t;

/*!
 * @name Constants and macros for entire MLB_HCER0 register
 */
/*@{*/
#define HW_MLB_HCER0_ADDR(x)     ((uintptr_t)(x) + 0x90U)

#define HW_MLB_HCER0(x)          (*(__I hw_mlb_hcer0_t *) HW_MLB_HCER0_ADDR(x))
#define HW_MLB_HCER0_RD(x)       (HW_MLB_HCER0(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_HCER0 bitfields
 */

/*!
 * @name Register MLB_HCER0, field CERR_31_0[31:0] (RO)
 *
 * Bitwise channel error bit
 */
/*@{*/
#define BP_MLB_HCER0_CERR_31_0 (0U)        /*!< Bit position for MLB_HCER0_CERR_31_0. */
#define BM_MLB_HCER0_CERR_31_0 (0xFFFFFFFFU) /*!< Bit mask for MLB_HCER0_CERR_31_0. */
#define BS_MLB_HCER0_CERR_31_0 (32U)       /*!< Bit field size in bits for MLB_HCER0_CERR_31_0. */

/*! @brief Read current value of the MLB_HCER0_CERR_31_0 field. */
#define BR_MLB_HCER0_CERR_31_0(x) (HW_MLB_HCER0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_HCER1 - HBI Channel Error 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCER1 - HBI Channel Error 1 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * HCERn status bits are set when hardware detects hardware errors on the given
 * logical channel, including: Channel opened, but not enabled, Channel
 * programmed with invalid channel type, or Out-of-range PML for asynchronous or control
 * Tx channels
 */
typedef union _hw_mlb_hcer1
{
    uint32_t U;
    struct _hw_mlb_hcer1_bitfields
    {
        uint32_t CERR_63_32 : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_hcer1_t;

/*!
 * @name Constants and macros for entire MLB_HCER1 register
 */
/*@{*/
#define HW_MLB_HCER1_ADDR(x)     ((uintptr_t)(x) + 0x94U)

#define HW_MLB_HCER1(x)          (*(__I hw_mlb_hcer1_t *) HW_MLB_HCER1_ADDR(x))
#define HW_MLB_HCER1_RD(x)       (HW_MLB_HCER1(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_HCER1 bitfields
 */

/*!
 * @name Register MLB_HCER1, field CERR_63_32[31:0] (RO)
 *
 * Bitwise channel error bit
 */
/*@{*/
#define BP_MLB_HCER1_CERR_63_32 (0U)       /*!< Bit position for MLB_HCER1_CERR_63_32. */
#define BM_MLB_HCER1_CERR_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_HCER1_CERR_63_32. */
#define BS_MLB_HCER1_CERR_63_32 (32U)      /*!< Bit field size in bits for MLB_HCER1_CERR_63_32. */

/*! @brief Read current value of the MLB_HCER1_CERR_63_32 field. */
#define BR_MLB_HCER1_CERR_63_32(x) (HW_MLB_HCER1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_HCBR0 - HBI Channel Busy 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCBR0 - HBI Channel Busy 0 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The HC can determine which channel(s) are busy by reading the HBI Channel
 * Busy Registers (HCBRn). An HBI channel is busy if: it is currently loaded into
 * one of the two AGUs the channel is enabled, CE = 1 from the Channel Allocation
 * Table ( ), and the DMA is active When an HBI channel is busy, hardware may
 * write back its local copy of the channel descriptor at any time. System software
 * should not write a CDT descriptor for a channel that is busy. Only two HBI
 * channels can be busy at any given time. Each bit of HCBRn is read-only.
 */
typedef union _hw_mlb_hcbr0
{
    uint32_t U;
    struct _hw_mlb_hcbr0_bitfields
    {
        uint32_t CHB_31_0 : 32;        /*!< [31:0]  */
    } B;
} hw_mlb_hcbr0_t;

/*!
 * @name Constants and macros for entire MLB_HCBR0 register
 */
/*@{*/
#define HW_MLB_HCBR0_ADDR(x)     ((uintptr_t)(x) + 0x98U)

#define HW_MLB_HCBR0(x)          (*(__I hw_mlb_hcbr0_t *) HW_MLB_HCBR0_ADDR(x))
#define HW_MLB_HCBR0_RD(x)       (HW_MLB_HCBR0(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_HCBR0 bitfields
 */

/*!
 * @name Register MLB_HCBR0, field CHB_31_0[31:0] (RO)
 *
 * Bitwise channel busy bit
 *
 * Values:
 * - 0 - idle
 * - 1 - busy
 */
/*@{*/
#define BP_MLB_HCBR0_CHB_31_0 (0U)         /*!< Bit position for MLB_HCBR0_CHB_31_0. */
#define BM_MLB_HCBR0_CHB_31_0 (0xFFFFFFFFU) /*!< Bit mask for MLB_HCBR0_CHB_31_0. */
#define BS_MLB_HCBR0_CHB_31_0 (32U)        /*!< Bit field size in bits for MLB_HCBR0_CHB_31_0. */

/*! @brief Read current value of the MLB_HCBR0_CHB_31_0 field. */
#define BR_MLB_HCBR0_CHB_31_0(x) (HW_MLB_HCBR0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_HCBR1 - HBI Channel Busy 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_HCBR1 - HBI Channel Busy 1 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_hcbr1
{
    uint32_t U;
    struct _hw_mlb_hcbr1_bitfields
    {
        uint32_t CHB_63_32 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_hcbr1_t;

/*!
 * @name Constants and macros for entire MLB_HCBR1 register
 */
/*@{*/
#define HW_MLB_HCBR1_ADDR(x)     ((uintptr_t)(x) + 0x9CU)

#define HW_MLB_HCBR1(x)          (*(__I hw_mlb_hcbr1_t *) HW_MLB_HCBR1_ADDR(x))
#define HW_MLB_HCBR1_RD(x)       (HW_MLB_HCBR1(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_HCBR1 bitfields
 */

/*!
 * @name Register MLB_HCBR1, field CHB_63_32[31:0] (RO)
 *
 * Bitwise channel busy bit
 *
 * Values:
 * - 0 - idle
 * - 1 - busy
 */
/*@{*/
#define BP_MLB_HCBR1_CHB_63_32 (0U)        /*!< Bit position for MLB_HCBR1_CHB_63_32. */
#define BM_MLB_HCBR1_CHB_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_HCBR1_CHB_63_32. */
#define BS_MLB_HCBR1_CHB_63_32 (32U)       /*!< Bit field size in bits for MLB_HCBR1_CHB_63_32. */

/*! @brief Read current value of the MLB_HCBR1_CHB_63_32 field. */
#define BR_MLB_HCBR1_CHB_63_32(x) (HW_MLB_HCBR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_MDAT0 - MIF Data 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDAT0 - MIF Data 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdat0
{
    uint32_t U;
    struct _hw_mlb_mdat0_bitfields
    {
        uint32_t DATA_31_0 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_mdat0_t;

/*!
 * @name Constants and macros for entire MLB_MDAT0 register
 */
/*@{*/
#define HW_MLB_MDAT0_ADDR(x)     ((uintptr_t)(x) + 0xC0U)

#define HW_MLB_MDAT0(x)          (*(__IO hw_mlb_mdat0_t *) HW_MLB_MDAT0_ADDR(x))
#define HW_MLB_MDAT0_RD(x)       (HW_MLB_MDAT0(x).U)
#define HW_MLB_MDAT0_WR(x, v)    (HW_MLB_MDAT0(x).U = (v))
#define HW_MLB_MDAT0_SET(x, v)   (HW_MLB_MDAT0_WR(x, HW_MLB_MDAT0_RD(x) |  (v)))
#define HW_MLB_MDAT0_CLR(x, v)   (HW_MLB_MDAT0_WR(x, HW_MLB_MDAT0_RD(x) & ~(v)))
#define HW_MLB_MDAT0_TOG(x, v)   (HW_MLB_MDAT0_WR(x, HW_MLB_MDAT0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDAT0 bitfields
 */

/*!
 * @name Register MLB_MDAT0, field DATA_31_0[31:0] (RW)
 *
 * CTR data - bits[31:0] of 128-bit entry or DBR data - bits[7:0] of 8-bit entry
 */
/*@{*/
#define BP_MLB_MDAT0_DATA_31_0 (0U)        /*!< Bit position for MLB_MDAT0_DATA_31_0. */
#define BM_MLB_MDAT0_DATA_31_0 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDAT0_DATA_31_0. */
#define BS_MLB_MDAT0_DATA_31_0 (32U)       /*!< Bit field size in bits for MLB_MDAT0_DATA_31_0. */

/*! @brief Read current value of the MLB_MDAT0_DATA_31_0 field. */
#define BR_MLB_MDAT0_DATA_31_0(x) (HW_MLB_MDAT0(x).U)

/*! @brief Format value for bitfield MLB_MDAT0_DATA_31_0. */
#define BF_MLB_MDAT0_DATA_31_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDAT0_DATA_31_0) & BM_MLB_MDAT0_DATA_31_0)

/*! @brief Set the DATA_31_0 field to a new value. */
#define BW_MLB_MDAT0_DATA_31_0(x, v) (HW_MLB_MDAT0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDAT1 - MIF Data 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDAT1 - MIF Data 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdat1
{
    uint32_t U;
    struct _hw_mlb_mdat1_bitfields
    {
        uint32_t DATA_63_32 : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_mdat1_t;

/*!
 * @name Constants and macros for entire MLB_MDAT1 register
 */
/*@{*/
#define HW_MLB_MDAT1_ADDR(x)     ((uintptr_t)(x) + 0xC4U)

#define HW_MLB_MDAT1(x)          (*(__IO hw_mlb_mdat1_t *) HW_MLB_MDAT1_ADDR(x))
#define HW_MLB_MDAT1_RD(x)       (HW_MLB_MDAT1(x).U)
#define HW_MLB_MDAT1_WR(x, v)    (HW_MLB_MDAT1(x).U = (v))
#define HW_MLB_MDAT1_SET(x, v)   (HW_MLB_MDAT1_WR(x, HW_MLB_MDAT1_RD(x) |  (v)))
#define HW_MLB_MDAT1_CLR(x, v)   (HW_MLB_MDAT1_WR(x, HW_MLB_MDAT1_RD(x) & ~(v)))
#define HW_MLB_MDAT1_TOG(x, v)   (HW_MLB_MDAT1_WR(x, HW_MLB_MDAT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDAT1 bitfields
 */

/*!
 * @name Register MLB_MDAT1, field DATA_63_32[31:0] (RW)
 *
 * CTR data - bits[63:32] of 128-bit entry
 */
/*@{*/
#define BP_MLB_MDAT1_DATA_63_32 (0U)       /*!< Bit position for MLB_MDAT1_DATA_63_32. */
#define BM_MLB_MDAT1_DATA_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDAT1_DATA_63_32. */
#define BS_MLB_MDAT1_DATA_63_32 (32U)      /*!< Bit field size in bits for MLB_MDAT1_DATA_63_32. */

/*! @brief Read current value of the MLB_MDAT1_DATA_63_32 field. */
#define BR_MLB_MDAT1_DATA_63_32(x) (HW_MLB_MDAT1(x).U)

/*! @brief Format value for bitfield MLB_MDAT1_DATA_63_32. */
#define BF_MLB_MDAT1_DATA_63_32(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDAT1_DATA_63_32) & BM_MLB_MDAT1_DATA_63_32)

/*! @brief Set the DATA_63_32 field to a new value. */
#define BW_MLB_MDAT1_DATA_63_32(x, v) (HW_MLB_MDAT1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDAT2 - MIF Data 2 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDAT2 - MIF Data 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdat2
{
    uint32_t U;
    struct _hw_mlb_mdat2_bitfields
    {
        uint32_t DATA_95_64 : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_mdat2_t;

/*!
 * @name Constants and macros for entire MLB_MDAT2 register
 */
/*@{*/
#define HW_MLB_MDAT2_ADDR(x)     ((uintptr_t)(x) + 0xC8U)

#define HW_MLB_MDAT2(x)          (*(__IO hw_mlb_mdat2_t *) HW_MLB_MDAT2_ADDR(x))
#define HW_MLB_MDAT2_RD(x)       (HW_MLB_MDAT2(x).U)
#define HW_MLB_MDAT2_WR(x, v)    (HW_MLB_MDAT2(x).U = (v))
#define HW_MLB_MDAT2_SET(x, v)   (HW_MLB_MDAT2_WR(x, HW_MLB_MDAT2_RD(x) |  (v)))
#define HW_MLB_MDAT2_CLR(x, v)   (HW_MLB_MDAT2_WR(x, HW_MLB_MDAT2_RD(x) & ~(v)))
#define HW_MLB_MDAT2_TOG(x, v)   (HW_MLB_MDAT2_WR(x, HW_MLB_MDAT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDAT2 bitfields
 */

/*!
 * @name Register MLB_MDAT2, field DATA_95_64[31:0] (RW)
 *
 * CTR data - bits[95:64] of 128-bit entry
 */
/*@{*/
#define BP_MLB_MDAT2_DATA_95_64 (0U)       /*!< Bit position for MLB_MDAT2_DATA_95_64. */
#define BM_MLB_MDAT2_DATA_95_64 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDAT2_DATA_95_64. */
#define BS_MLB_MDAT2_DATA_95_64 (32U)      /*!< Bit field size in bits for MLB_MDAT2_DATA_95_64. */

/*! @brief Read current value of the MLB_MDAT2_DATA_95_64 field. */
#define BR_MLB_MDAT2_DATA_95_64(x) (HW_MLB_MDAT2(x).U)

/*! @brief Format value for bitfield MLB_MDAT2_DATA_95_64. */
#define BF_MLB_MDAT2_DATA_95_64(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDAT2_DATA_95_64) & BM_MLB_MDAT2_DATA_95_64)

/*! @brief Set the DATA_95_64 field to a new value. */
#define BW_MLB_MDAT2_DATA_95_64(x, v) (HW_MLB_MDAT2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDAT3 - MIF Data 3 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDAT3 - MIF Data 3 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdat3
{
    uint32_t U;
    struct _hw_mlb_mdat3_bitfields
    {
        uint32_t DATA_127_96 : 32;     /*!< [31:0]  */
    } B;
} hw_mlb_mdat3_t;

/*!
 * @name Constants and macros for entire MLB_MDAT3 register
 */
/*@{*/
#define HW_MLB_MDAT3_ADDR(x)     ((uintptr_t)(x) + 0xCCU)

#define HW_MLB_MDAT3(x)          (*(__IO hw_mlb_mdat3_t *) HW_MLB_MDAT3_ADDR(x))
#define HW_MLB_MDAT3_RD(x)       (HW_MLB_MDAT3(x).U)
#define HW_MLB_MDAT3_WR(x, v)    (HW_MLB_MDAT3(x).U = (v))
#define HW_MLB_MDAT3_SET(x, v)   (HW_MLB_MDAT3_WR(x, HW_MLB_MDAT3_RD(x) |  (v)))
#define HW_MLB_MDAT3_CLR(x, v)   (HW_MLB_MDAT3_WR(x, HW_MLB_MDAT3_RD(x) & ~(v)))
#define HW_MLB_MDAT3_TOG(x, v)   (HW_MLB_MDAT3_WR(x, HW_MLB_MDAT3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDAT3 bitfields
 */

/*!
 * @name Register MLB_MDAT3, field DATA_127_96[31:0] (RW)
 *
 * CTR data - bits[127:96] of 128-bit entry
 */
/*@{*/
#define BP_MLB_MDAT3_DATA_127_96 (0U)      /*!< Bit position for MLB_MDAT3_DATA_127_96. */
#define BM_MLB_MDAT3_DATA_127_96 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDAT3_DATA_127_96. */
#define BS_MLB_MDAT3_DATA_127_96 (32U)     /*!< Bit field size in bits for MLB_MDAT3_DATA_127_96. */

/*! @brief Read current value of the MLB_MDAT3_DATA_127_96 field. */
#define BR_MLB_MDAT3_DATA_127_96(x) (HW_MLB_MDAT3(x).U)

/*! @brief Format value for bitfield MLB_MDAT3_DATA_127_96. */
#define BF_MLB_MDAT3_DATA_127_96(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDAT3_DATA_127_96) & BM_MLB_MDAT3_DATA_127_96)

/*! @brief Set the DATA_127_96 field to a new value. */
#define BW_MLB_MDAT3_DATA_127_96(x, v) (HW_MLB_MDAT3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDWE0 - MIF Data Write Enable 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDWE0 - MIF Data Write Enable 0 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdwe0
{
    uint32_t U;
    struct _hw_mlb_mdwe0_bitfields
    {
        uint32_t MASK_31_0 : 32;       /*!< [31:0]  */
    } B;
} hw_mlb_mdwe0_t;

/*!
 * @name Constants and macros for entire MLB_MDWE0 register
 */
/*@{*/
#define HW_MLB_MDWE0_ADDR(x)     ((uintptr_t)(x) + 0xD0U)

#define HW_MLB_MDWE0(x)          (*(__IO hw_mlb_mdwe0_t *) HW_MLB_MDWE0_ADDR(x))
#define HW_MLB_MDWE0_RD(x)       (HW_MLB_MDWE0(x).U)
#define HW_MLB_MDWE0_WR(x, v)    (HW_MLB_MDWE0(x).U = (v))
#define HW_MLB_MDWE0_SET(x, v)   (HW_MLB_MDWE0_WR(x, HW_MLB_MDWE0_RD(x) |  (v)))
#define HW_MLB_MDWE0_CLR(x, v)   (HW_MLB_MDWE0_WR(x, HW_MLB_MDWE0_RD(x) & ~(v)))
#define HW_MLB_MDWE0_TOG(x, v)   (HW_MLB_MDWE0_WR(x, HW_MLB_MDWE0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDWE0 bitfields
 */

/*!
 * @name Register MLB_MDWE0, field MASK_31_0[31:0] (RW)
 *
 * Bitwise write enable for CTR data - bits[31:0]
 *
 * Values:
 * - 0 - disabled
 * - 1 - enabled
 */
/*@{*/
#define BP_MLB_MDWE0_MASK_31_0 (0U)        /*!< Bit position for MLB_MDWE0_MASK_31_0. */
#define BM_MLB_MDWE0_MASK_31_0 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDWE0_MASK_31_0. */
#define BS_MLB_MDWE0_MASK_31_0 (32U)       /*!< Bit field size in bits for MLB_MDWE0_MASK_31_0. */

/*! @brief Read current value of the MLB_MDWE0_MASK_31_0 field. */
#define BR_MLB_MDWE0_MASK_31_0(x) (HW_MLB_MDWE0(x).U)

/*! @brief Format value for bitfield MLB_MDWE0_MASK_31_0. */
#define BF_MLB_MDWE0_MASK_31_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDWE0_MASK_31_0) & BM_MLB_MDWE0_MASK_31_0)

/*! @brief Set the MASK_31_0 field to a new value. */
#define BW_MLB_MDWE0_MASK_31_0(x, v) (HW_MLB_MDWE0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDWE1 - MIF Data Write Enable 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDWE1 - MIF Data Write Enable 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdwe1
{
    uint32_t U;
    struct _hw_mlb_mdwe1_bitfields
    {
        uint32_t MASK_63_32 : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_mdwe1_t;

/*!
 * @name Constants and macros for entire MLB_MDWE1 register
 */
/*@{*/
#define HW_MLB_MDWE1_ADDR(x)     ((uintptr_t)(x) + 0xD4U)

#define HW_MLB_MDWE1(x)          (*(__IO hw_mlb_mdwe1_t *) HW_MLB_MDWE1_ADDR(x))
#define HW_MLB_MDWE1_RD(x)       (HW_MLB_MDWE1(x).U)
#define HW_MLB_MDWE1_WR(x, v)    (HW_MLB_MDWE1(x).U = (v))
#define HW_MLB_MDWE1_SET(x, v)   (HW_MLB_MDWE1_WR(x, HW_MLB_MDWE1_RD(x) |  (v)))
#define HW_MLB_MDWE1_CLR(x, v)   (HW_MLB_MDWE1_WR(x, HW_MLB_MDWE1_RD(x) & ~(v)))
#define HW_MLB_MDWE1_TOG(x, v)   (HW_MLB_MDWE1_WR(x, HW_MLB_MDWE1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDWE1 bitfields
 */

/*!
 * @name Register MLB_MDWE1, field MASK_63_32[31:0] (RW)
 *
 * Bitwise write enable for CTR data - bits[63:32]
 *
 * Values:
 * - 0 - disabled
 * - 1 - enabled
 */
/*@{*/
#define BP_MLB_MDWE1_MASK_63_32 (0U)       /*!< Bit position for MLB_MDWE1_MASK_63_32. */
#define BM_MLB_MDWE1_MASK_63_32 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDWE1_MASK_63_32. */
#define BS_MLB_MDWE1_MASK_63_32 (32U)      /*!< Bit field size in bits for MLB_MDWE1_MASK_63_32. */

/*! @brief Read current value of the MLB_MDWE1_MASK_63_32 field. */
#define BR_MLB_MDWE1_MASK_63_32(x) (HW_MLB_MDWE1(x).U)

/*! @brief Format value for bitfield MLB_MDWE1_MASK_63_32. */
#define BF_MLB_MDWE1_MASK_63_32(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDWE1_MASK_63_32) & BM_MLB_MDWE1_MASK_63_32)

/*! @brief Set the MASK_63_32 field to a new value. */
#define BW_MLB_MDWE1_MASK_63_32(x, v) (HW_MLB_MDWE1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDWE2 - MIF Data Write Enable 2 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDWE2 - MIF Data Write Enable 2 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdwe2
{
    uint32_t U;
    struct _hw_mlb_mdwe2_bitfields
    {
        uint32_t MASK_95_64 : 32;      /*!< [31:0]  */
    } B;
} hw_mlb_mdwe2_t;

/*!
 * @name Constants and macros for entire MLB_MDWE2 register
 */
/*@{*/
#define HW_MLB_MDWE2_ADDR(x)     ((uintptr_t)(x) + 0xD8U)

#define HW_MLB_MDWE2(x)          (*(__IO hw_mlb_mdwe2_t *) HW_MLB_MDWE2_ADDR(x))
#define HW_MLB_MDWE2_RD(x)       (HW_MLB_MDWE2(x).U)
#define HW_MLB_MDWE2_WR(x, v)    (HW_MLB_MDWE2(x).U = (v))
#define HW_MLB_MDWE2_SET(x, v)   (HW_MLB_MDWE2_WR(x, HW_MLB_MDWE2_RD(x) |  (v)))
#define HW_MLB_MDWE2_CLR(x, v)   (HW_MLB_MDWE2_WR(x, HW_MLB_MDWE2_RD(x) & ~(v)))
#define HW_MLB_MDWE2_TOG(x, v)   (HW_MLB_MDWE2_WR(x, HW_MLB_MDWE2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDWE2 bitfields
 */

/*!
 * @name Register MLB_MDWE2, field MASK_95_64[31:0] (RW)
 *
 * Bitwise write enable for CTR data - bits[95:64]
 *
 * Values:
 * - 0 - disabled
 * - 1 - enabled
 */
/*@{*/
#define BP_MLB_MDWE2_MASK_95_64 (0U)       /*!< Bit position for MLB_MDWE2_MASK_95_64. */
#define BM_MLB_MDWE2_MASK_95_64 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDWE2_MASK_95_64. */
#define BS_MLB_MDWE2_MASK_95_64 (32U)      /*!< Bit field size in bits for MLB_MDWE2_MASK_95_64. */

/*! @brief Read current value of the MLB_MDWE2_MASK_95_64 field. */
#define BR_MLB_MDWE2_MASK_95_64(x) (HW_MLB_MDWE2(x).U)

/*! @brief Format value for bitfield MLB_MDWE2_MASK_95_64. */
#define BF_MLB_MDWE2_MASK_95_64(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDWE2_MASK_95_64) & BM_MLB_MDWE2_MASK_95_64)

/*! @brief Set the MASK_95_64 field to a new value. */
#define BW_MLB_MDWE2_MASK_95_64(x, v) (HW_MLB_MDWE2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MDWE3 - MIF Data Write Enable 3 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MDWE3 - MIF Data Write Enable 3 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mdwe3
{
    uint32_t U;
    struct _hw_mlb_mdwe3_bitfields
    {
        uint32_t MASK_127_96 : 32;     /*!< [31:0]  */
    } B;
} hw_mlb_mdwe3_t;

/*!
 * @name Constants and macros for entire MLB_MDWE3 register
 */
/*@{*/
#define HW_MLB_MDWE3_ADDR(x)     ((uintptr_t)(x) + 0xDCU)

#define HW_MLB_MDWE3(x)          (*(__IO hw_mlb_mdwe3_t *) HW_MLB_MDWE3_ADDR(x))
#define HW_MLB_MDWE3_RD(x)       (HW_MLB_MDWE3(x).U)
#define HW_MLB_MDWE3_WR(x, v)    (HW_MLB_MDWE3(x).U = (v))
#define HW_MLB_MDWE3_SET(x, v)   (HW_MLB_MDWE3_WR(x, HW_MLB_MDWE3_RD(x) |  (v)))
#define HW_MLB_MDWE3_CLR(x, v)   (HW_MLB_MDWE3_WR(x, HW_MLB_MDWE3_RD(x) & ~(v)))
#define HW_MLB_MDWE3_TOG(x, v)   (HW_MLB_MDWE3_WR(x, HW_MLB_MDWE3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MDWE3 bitfields
 */

/*!
 * @name Register MLB_MDWE3, field MASK_127_96[31:0] (RW)
 *
 * Bitwise write enable for CTR data - bits[127:96]
 *
 * Values:
 * - 0 - disabled
 * - 1 - enabled
 */
/*@{*/
#define BP_MLB_MDWE3_MASK_127_96 (0U)      /*!< Bit position for MLB_MDWE3_MASK_127_96. */
#define BM_MLB_MDWE3_MASK_127_96 (0xFFFFFFFFU) /*!< Bit mask for MLB_MDWE3_MASK_127_96. */
#define BS_MLB_MDWE3_MASK_127_96 (32U)     /*!< Bit field size in bits for MLB_MDWE3_MASK_127_96. */

/*! @brief Read current value of the MLB_MDWE3_MASK_127_96 field. */
#define BR_MLB_MDWE3_MASK_127_96(x) (HW_MLB_MDWE3(x).U)

/*! @brief Format value for bitfield MLB_MDWE3_MASK_127_96. */
#define BF_MLB_MDWE3_MASK_127_96(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MDWE3_MASK_127_96) & BM_MLB_MDWE3_MASK_127_96)

/*! @brief Set the MASK_127_96 field to a new value. */
#define BW_MLB_MDWE3_MASK_127_96(x, v) (HW_MLB_MDWE3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_MCTL - MIF Control Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MCTL - MIF Control Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_mctl
{
    uint32_t U;
    struct _hw_mlb_mctl_bitfields
    {
        uint32_t XCMP : 1;             /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_mlb_mctl_t;

/*!
 * @name Constants and macros for entire MLB_MCTL register
 */
/*@{*/
#define HW_MLB_MCTL_ADDR(x)      ((uintptr_t)(x) + 0xE0U)

#define HW_MLB_MCTL(x)           (*(__I hw_mlb_mctl_t *) HW_MLB_MCTL_ADDR(x))
#define HW_MLB_MCTL_RD(x)        (HW_MLB_MCTL(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_MCTL bitfields
 */

/*!
 * @name Register MLB_MCTL, field XCMP[0] (RO)
 *
 * Transfer complete (write 0 to clear)
 */
/*@{*/
#define BP_MLB_MCTL_XCMP     (0U)          /*!< Bit position for MLB_MCTL_XCMP. */
#define BM_MLB_MCTL_XCMP     (0x00000001U) /*!< Bit mask for MLB_MCTL_XCMP. */
#define BS_MLB_MCTL_XCMP     (1U)          /*!< Bit field size in bits for MLB_MCTL_XCMP. */

/*! @brief Read current value of the MLB_MCTL_XCMP field. */
#define BR_MLB_MCTL_XCMP(x)  (HW_MLB_MCTL(x).B.XCMP)
/*@}*/

/*******************************************************************************
 * HW_MLB_MADR - MIF Address Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_MADR - MIF Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_madr
{
    uint32_t U;
    struct _hw_mlb_madr_bitfields
    {
        uint32_t ADDR_7_0 : 8;         /*!< [7:0]  */
        uint32_t ADDR_13_8 : 6;        /*!< [13:8]  */
        uint32_t RESERVED0 : 16;       /*!< [29:14]  */
        uint32_t TB : 1;               /*!< [30]  */
        uint32_t WNR : 1;              /*!< [31]  */
    } B;
} hw_mlb_madr_t;

/*!
 * @name Constants and macros for entire MLB_MADR register
 */
/*@{*/
#define HW_MLB_MADR_ADDR(x)      ((uintptr_t)(x) + 0xE4U)

#define HW_MLB_MADR(x)           (*(__IO hw_mlb_madr_t *) HW_MLB_MADR_ADDR(x))
#define HW_MLB_MADR_RD(x)        (HW_MLB_MADR(x).U)
#define HW_MLB_MADR_WR(x, v)     (HW_MLB_MADR(x).U = (v))
#define HW_MLB_MADR_SET(x, v)    (HW_MLB_MADR_WR(x, HW_MLB_MADR_RD(x) |  (v)))
#define HW_MLB_MADR_CLR(x, v)    (HW_MLB_MADR_WR(x, HW_MLB_MADR_RD(x) & ~(v)))
#define HW_MLB_MADR_TOG(x, v)    (HW_MLB_MADR_WR(x, HW_MLB_MADR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_MADR bitfields
 */

/*!
 * @name Register MLB_MADR, field ADDR_7_0[7:0] (RW)
 *
 * CTR address of 128-bit entry or DBR address of 8-bit entry - bits[7:0]
 */
/*@{*/
#define BP_MLB_MADR_ADDR_7_0 (0U)          /*!< Bit position for MLB_MADR_ADDR_7_0. */
#define BM_MLB_MADR_ADDR_7_0 (0x000000FFU) /*!< Bit mask for MLB_MADR_ADDR_7_0. */
#define BS_MLB_MADR_ADDR_7_0 (8U)          /*!< Bit field size in bits for MLB_MADR_ADDR_7_0. */

/*! @brief Read current value of the MLB_MADR_ADDR_7_0 field. */
#define BR_MLB_MADR_ADDR_7_0(x) (HW_MLB_MADR(x).B.ADDR_7_0)

/*! @brief Format value for bitfield MLB_MADR_ADDR_7_0. */
#define BF_MLB_MADR_ADDR_7_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MADR_ADDR_7_0) & BM_MLB_MADR_ADDR_7_0)

/*! @brief Set the ADDR_7_0 field to a new value. */
#define BW_MLB_MADR_ADDR_7_0(x, v) (HW_MLB_MADR_WR(x, (HW_MLB_MADR_RD(x) & ~BM_MLB_MADR_ADDR_7_0) | BF_MLB_MADR_ADDR_7_0(v)))
/*@}*/

/*!
 * @name Register MLB_MADR, field ADDR_13_8[13:8] (RW)
 *
 * DBR address of 8-bit entry - bits[13:8]
 */
/*@{*/
#define BP_MLB_MADR_ADDR_13_8 (8U)         /*!< Bit position for MLB_MADR_ADDR_13_8. */
#define BM_MLB_MADR_ADDR_13_8 (0x00003F00U) /*!< Bit mask for MLB_MADR_ADDR_13_8. */
#define BS_MLB_MADR_ADDR_13_8 (6U)         /*!< Bit field size in bits for MLB_MADR_ADDR_13_8. */

/*! @brief Read current value of the MLB_MADR_ADDR_13_8 field. */
#define BR_MLB_MADR_ADDR_13_8(x) (HW_MLB_MADR(x).B.ADDR_13_8)

/*! @brief Format value for bitfield MLB_MADR_ADDR_13_8. */
#define BF_MLB_MADR_ADDR_13_8(v) ((uint32_t)((uint32_t)(v) << BP_MLB_MADR_ADDR_13_8) & BM_MLB_MADR_ADDR_13_8)

/*! @brief Set the ADDR_13_8 field to a new value. */
#define BW_MLB_MADR_ADDR_13_8(x, v) (HW_MLB_MADR_WR(x, (HW_MLB_MADR_RD(x) & ~BM_MLB_MADR_ADDR_13_8) | BF_MLB_MADR_ADDR_13_8(v)))
/*@}*/

/*!
 * @name Register MLB_MADR, field TB[30] (RW)
 *
 * Target location bit
 *
 * Values:
 * - 0 - selects CTR
 * - 1 - selects DBR
 */
/*@{*/
#define BP_MLB_MADR_TB       (30U)         /*!< Bit position for MLB_MADR_TB. */
#define BM_MLB_MADR_TB       (0x40000000U) /*!< Bit mask for MLB_MADR_TB. */
#define BS_MLB_MADR_TB       (1U)          /*!< Bit field size in bits for MLB_MADR_TB. */

/*! @brief Read current value of the MLB_MADR_TB field. */
#define BR_MLB_MADR_TB(x)    (HW_MLB_MADR(x).B.TB)

/*! @brief Format value for bitfield MLB_MADR_TB. */
#define BF_MLB_MADR_TB(v)    ((uint32_t)((uint32_t)(v) << BP_MLB_MADR_TB) & BM_MLB_MADR_TB)

/*! @brief Set the TB field to a new value. */
#define BW_MLB_MADR_TB(x, v) (HW_MLB_MADR_WR(x, (HW_MLB_MADR_RD(x) & ~BM_MLB_MADR_TB) | BF_MLB_MADR_TB(v)))
/*@}*/

/*!
 * @name Register MLB_MADR, field WNR[31] (RW)
 *
 * Write-Not-Read selection
 *
 * Values:
 * - 0 - read
 * - 1 - write
 */
/*@{*/
#define BP_MLB_MADR_WNR      (31U)         /*!< Bit position for MLB_MADR_WNR. */
#define BM_MLB_MADR_WNR      (0x80000000U) /*!< Bit mask for MLB_MADR_WNR. */
#define BS_MLB_MADR_WNR      (1U)          /*!< Bit field size in bits for MLB_MADR_WNR. */

/*! @brief Read current value of the MLB_MADR_WNR field. */
#define BR_MLB_MADR_WNR(x)   (HW_MLB_MADR(x).B.WNR)

/*! @brief Format value for bitfield MLB_MADR_WNR. */
#define BF_MLB_MADR_WNR(v)   ((uint32_t)((uint32_t)(v) << BP_MLB_MADR_WNR) & BM_MLB_MADR_WNR)

/*! @brief Set the WNR field to a new value. */
#define BW_MLB_MADR_WNR(x, v) (HW_MLB_MADR_WR(x, (HW_MLB_MADR_RD(x) & ~BM_MLB_MADR_WNR) | BF_MLB_MADR_WNR(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_ACTL - AHB Control Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_ACTL - AHB Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The AHB Control (ACTL) register is written by the HC to configure the AMBA
 * AHB block for channel interrupts. ACTL contains three configuration fields, one
 * is used to select the DMA mode, one is used to mux channel interrupts onto a
 * single interrupt signal, and the last selects the method of clearing channel
 * interrupts (either software or hardware).
 */
typedef union _hw_mlb_actl
{
    uint32_t U;
    struct _hw_mlb_actl_bitfields
    {
        uint32_t SCE : 1;              /*!< [0]  */
        uint32_t SMX : 1;              /*!< [1]  */
        uint32_t DMA_MODE : 1;         /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t MPB : 1;              /*!< [4]  */
        uint32_t RESERVED1 : 27;       /*!< [31:5]  */
    } B;
} hw_mlb_actl_t;

/*!
 * @name Constants and macros for entire MLB_ACTL register
 */
/*@{*/
#define HW_MLB_ACTL_ADDR(x)      ((uintptr_t)(x) + 0x3C0U)

#define HW_MLB_ACTL(x)           (*(__IO hw_mlb_actl_t *) HW_MLB_ACTL_ADDR(x))
#define HW_MLB_ACTL_RD(x)        (HW_MLB_ACTL(x).U)
#define HW_MLB_ACTL_WR(x, v)     (HW_MLB_ACTL(x).U = (v))
#define HW_MLB_ACTL_SET(x, v)    (HW_MLB_ACTL_WR(x, HW_MLB_ACTL_RD(x) |  (v)))
#define HW_MLB_ACTL_CLR(x, v)    (HW_MLB_ACTL_WR(x, HW_MLB_ACTL_RD(x) & ~(v)))
#define HW_MLB_ACTL_TOG(x, v)    (HW_MLB_ACTL_WR(x, HW_MLB_ACTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_ACTL bitfields
 */

/*!
 * @name Register MLB_ACTL, field SCE[0] (RW)
 *
 * Software clear enable:
 *
 * Values:
 * - 0 - Hardware clears interrupt after a ACSRn register read
 * - 1 - Software clears interrupt
 */
/*@{*/
#define BP_MLB_ACTL_SCE      (0U)          /*!< Bit position for MLB_ACTL_SCE. */
#define BM_MLB_ACTL_SCE      (0x00000001U) /*!< Bit mask for MLB_ACTL_SCE. */
#define BS_MLB_ACTL_SCE      (1U)          /*!< Bit field size in bits for MLB_ACTL_SCE. */

/*! @brief Read current value of the MLB_ACTL_SCE field. */
#define BR_MLB_ACTL_SCE(x)   (HW_MLB_ACTL(x).B.SCE)

/*! @brief Format value for bitfield MLB_ACTL_SCE. */
#define BF_MLB_ACTL_SCE(v)   ((uint32_t)((uint32_t)(v) << BP_MLB_ACTL_SCE) & BM_MLB_ACTL_SCE)

/*! @brief Set the SCE field to a new value. */
#define BW_MLB_ACTL_SCE(x, v) (HW_MLB_ACTL_WR(x, (HW_MLB_ACTL_RD(x) & ~BM_MLB_ACTL_SCE) | BF_MLB_ACTL_SCE(v)))
/*@}*/

/*!
 * @name Register MLB_ACTL, field SMX[1] (RW)
 *
 * AHB interrupt mux enable:
 *
 * Values:
 * - 0 - ACSR0 generates an interrupt on ahb_int[0]; ACSR1 generates an
 *     interrupt on ahb_int[1]
 * - 1 - ACSR0 and ACSR1 generate an interrupts on ahb_int[0] only
 */
/*@{*/
#define BP_MLB_ACTL_SMX      (1U)          /*!< Bit position for MLB_ACTL_SMX. */
#define BM_MLB_ACTL_SMX      (0x00000002U) /*!< Bit mask for MLB_ACTL_SMX. */
#define BS_MLB_ACTL_SMX      (1U)          /*!< Bit field size in bits for MLB_ACTL_SMX. */

/*! @brief Read current value of the MLB_ACTL_SMX field. */
#define BR_MLB_ACTL_SMX(x)   (HW_MLB_ACTL(x).B.SMX)

/*! @brief Format value for bitfield MLB_ACTL_SMX. */
#define BF_MLB_ACTL_SMX(v)   ((uint32_t)((uint32_t)(v) << BP_MLB_ACTL_SMX) & BM_MLB_ACTL_SMX)

/*! @brief Set the SMX field to a new value. */
#define BW_MLB_ACTL_SMX(x, v) (HW_MLB_ACTL_WR(x, (HW_MLB_ACTL_RD(x) & ~BM_MLB_ACTL_SMX) | BF_MLB_ACTL_SMX(v)))
/*@}*/

/*!
 * @name Register MLB_ACTL, field DMA_MODE[2] (RW)
 *
 * DMA Mode:
 *
 * Values:
 * - 0 - DMA Mode 0
 * - 1 - DMA Mode 1
 */
/*@{*/
#define BP_MLB_ACTL_DMA_MODE (2U)          /*!< Bit position for MLB_ACTL_DMA_MODE. */
#define BM_MLB_ACTL_DMA_MODE (0x00000004U) /*!< Bit mask for MLB_ACTL_DMA_MODE. */
#define BS_MLB_ACTL_DMA_MODE (1U)          /*!< Bit field size in bits for MLB_ACTL_DMA_MODE. */

/*! @brief Read current value of the MLB_ACTL_DMA_MODE field. */
#define BR_MLB_ACTL_DMA_MODE(x) (HW_MLB_ACTL(x).B.DMA_MODE)

/*! @brief Format value for bitfield MLB_ACTL_DMA_MODE. */
#define BF_MLB_ACTL_DMA_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MLB_ACTL_DMA_MODE) & BM_MLB_ACTL_DMA_MODE)

/*! @brief Set the DMA_MODE field to a new value. */
#define BW_MLB_ACTL_DMA_MODE(x, v) (HW_MLB_ACTL_WR(x, (HW_MLB_ACTL_RD(x) & ~BM_MLB_ACTL_DMA_MODE) | BF_MLB_ACTL_DMA_MODE(v)))
/*@}*/

/*!
 * @name Register MLB_ACTL, field MPB[4] (RW)
 *
 * DMA Packet buffering mode.
 *
 * Values:
 * - 0 - Single-packet mode
 * - 1 - Multiple-packet mode
 */
/*@{*/
#define BP_MLB_ACTL_MPB      (4U)          /*!< Bit position for MLB_ACTL_MPB. */
#define BM_MLB_ACTL_MPB      (0x00000010U) /*!< Bit mask for MLB_ACTL_MPB. */
#define BS_MLB_ACTL_MPB      (1U)          /*!< Bit field size in bits for MLB_ACTL_MPB. */

/*! @brief Read current value of the MLB_ACTL_MPB field. */
#define BR_MLB_ACTL_MPB(x)   (HW_MLB_ACTL(x).B.MPB)

/*! @brief Format value for bitfield MLB_ACTL_MPB. */
#define BF_MLB_ACTL_MPB(v)   ((uint32_t)((uint32_t)(v) << BP_MLB_ACTL_MPB) & BM_MLB_ACTL_MPB)

/*! @brief Set the MPB field to a new value. */
#define BW_MLB_ACTL_MPB(x, v) (HW_MLB_ACTL_WR(x, (HW_MLB_ACTL_RD(x) & ~BM_MLB_ACTL_MPB) | BF_MLB_ACTL_MPB(v)))
/*@}*/

/*******************************************************************************
 * HW_MLB_ACSR0 - AHB Channel Status 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_ACSR0 - AHB Channel Status 0 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The AHB Channel Status (ACSRn) registers contain interrupt bits for each of
 * the 64 physical channels. When an ACSRn register bit is set, it indicates that
 * the corresponding physical channel has an interrupt pending. An AHB interrupt
 * is triggered when either DNEn or ERRn is set within the AHB Channel
 * Descriptor. The HC is notified of the channel interrupt via ahb_int[1:0]. When an
 * interrupt occurs in ACSR0 (for channels 31 to 0) ahb_int[0] is set. When an
 * interrupt occurs in ACSR1 (for channels 63 to 32) ahb_int[1] is set. Interrupts in
 * ACSR0 and ACSR1 can be optionally muxed onto a single interrupt signal,
 * ahb_int[0], if ACTL.SMX = 1. If ACTL.SCE = 0, hardware automatically clears the
 * interrupt bit(s) after the HC reads the ACSRn register. Alternatively, if ACTL.SCE =
 * 1, software must write a 1 to the appropriate bit(s) of ACSRn to clear the
 * interrupt(s).
 */
typedef union _hw_mlb_acsr0
{
    uint32_t U;
    struct _hw_mlb_acsr0_bitfields
    {
        uint32_t CHS : 32;             /*!< [31:0]  */
    } B;
} hw_mlb_acsr0_t;

/*!
 * @name Constants and macros for entire MLB_ACSR0 register
 */
/*@{*/
#define HW_MLB_ACSR0_ADDR(x)     ((uintptr_t)(x) + 0x3D0U)

#define HW_MLB_ACSR0(x)          (*(__I hw_mlb_acsr0_t *) HW_MLB_ACSR0_ADDR(x))
#define HW_MLB_ACSR0_RD(x)       (HW_MLB_ACSR0(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_ACSR0 bitfields
 */

/*!
 * @name Register MLB_ACSR0, field CHS[31:0] (RO)
 *
 * Interrupt status for logical channels 31 to 0:
 *
 * Values:
 * - 0 - None
 * - 1 - Interrupt
 */
/*@{*/
#define BP_MLB_ACSR0_CHS     (0U)          /*!< Bit position for MLB_ACSR0_CHS. */
#define BM_MLB_ACSR0_CHS     (0xFFFFFFFFU) /*!< Bit mask for MLB_ACSR0_CHS. */
#define BS_MLB_ACSR0_CHS     (32U)         /*!< Bit field size in bits for MLB_ACSR0_CHS. */

/*! @brief Read current value of the MLB_ACSR0_CHS field. */
#define BR_MLB_ACSR0_CHS(x)  (HW_MLB_ACSR0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_ACSR1 - AHB Channel Status 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_ACSR1 - AHB Channel Status 1 Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_acsr1
{
    uint32_t U;
    struct _hw_mlb_acsr1_bitfields
    {
        uint32_t CHS : 32;             /*!< [31:0]  */
    } B;
} hw_mlb_acsr1_t;

/*!
 * @name Constants and macros for entire MLB_ACSR1 register
 */
/*@{*/
#define HW_MLB_ACSR1_ADDR(x)     ((uintptr_t)(x) + 0x3D4U)

#define HW_MLB_ACSR1(x)          (*(__I hw_mlb_acsr1_t *) HW_MLB_ACSR1_ADDR(x))
#define HW_MLB_ACSR1_RD(x)       (HW_MLB_ACSR1(x).U)
/*@}*/

/*
 * Constants & macros for individual MLB_ACSR1 bitfields
 */

/*!
 * @name Register MLB_ACSR1, field CHS[31:0] (RO)
 *
 * Interrupt status for logical channels 63 to 32:
 *
 * Values:
 * - 0 - None
 * - 1 - Interrupt
 */
/*@{*/
#define BP_MLB_ACSR1_CHS     (0U)          /*!< Bit position for MLB_ACSR1_CHS. */
#define BM_MLB_ACSR1_CHS     (0xFFFFFFFFU) /*!< Bit mask for MLB_ACSR1_CHS. */
#define BS_MLB_ACSR1_CHS     (32U)         /*!< Bit field size in bits for MLB_ACSR1_CHS. */

/*! @brief Read current value of the MLB_ACSR1_CHS field. */
#define BR_MLB_ACSR1_CHS(x)  (HW_MLB_ACSR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MLB_ACMR0 - AHB Channel Mask 0 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_ACMR0 - AHB Channel Mask 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Using the AHB Channel Mask (ACMRn) register, the HC can control which
 * channel(s) generate interrupts on ahb_int[1:0]. All ACMRn register bits default as
 * '0' ("masked"); therefore, the HC must initially write ACMRn to enable
 * interrupts. Each bit of ACMRn is read/write accessible.
 */
typedef union _hw_mlb_acmr0
{
    uint32_t U;
    struct _hw_mlb_acmr0_bitfields
    {
        uint32_t CHM_31_0 : 32;        /*!< [31:0]  */
    } B;
} hw_mlb_acmr0_t;

/*!
 * @name Constants and macros for entire MLB_ACMR0 register
 */
/*@{*/
#define HW_MLB_ACMR0_ADDR(x)     ((uintptr_t)(x) + 0x3D8U)

#define HW_MLB_ACMR0(x)          (*(__IO hw_mlb_acmr0_t *) HW_MLB_ACMR0_ADDR(x))
#define HW_MLB_ACMR0_RD(x)       (HW_MLB_ACMR0(x).U)
#define HW_MLB_ACMR0_WR(x, v)    (HW_MLB_ACMR0(x).U = (v))
#define HW_MLB_ACMR0_SET(x, v)   (HW_MLB_ACMR0_WR(x, HW_MLB_ACMR0_RD(x) |  (v)))
#define HW_MLB_ACMR0_CLR(x, v)   (HW_MLB_ACMR0_WR(x, HW_MLB_ACMR0_RD(x) & ~(v)))
#define HW_MLB_ACMR0_TOG(x, v)   (HW_MLB_ACMR0_WR(x, HW_MLB_ACMR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_ACMR0 bitfields
 */

/*!
 * @name Register MLB_ACMR0, field CHM_31_0[31:0] (RW)
 *
 * Bitwise channel mask bit:
 *
 * Values:
 * - 0 - Masked
 * - 1 - Unmasked
 */
/*@{*/
#define BP_MLB_ACMR0_CHM_31_0 (0U)         /*!< Bit position for MLB_ACMR0_CHM_31_0. */
#define BM_MLB_ACMR0_CHM_31_0 (0xFFFFFFFFU) /*!< Bit mask for MLB_ACMR0_CHM_31_0. */
#define BS_MLB_ACMR0_CHM_31_0 (32U)        /*!< Bit field size in bits for MLB_ACMR0_CHM_31_0. */

/*! @brief Read current value of the MLB_ACMR0_CHM_31_0 field. */
#define BR_MLB_ACMR0_CHM_31_0(x) (HW_MLB_ACMR0(x).U)

/*! @brief Format value for bitfield MLB_ACMR0_CHM_31_0. */
#define BF_MLB_ACMR0_CHM_31_0(v) ((uint32_t)((uint32_t)(v) << BP_MLB_ACMR0_CHM_31_0) & BM_MLB_ACMR0_CHM_31_0)

/*! @brief Set the CHM_31_0 field to a new value. */
#define BW_MLB_ACMR0_CHM_31_0(x, v) (HW_MLB_ACMR0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MLB_ACMR1 - AHB Channel Mask 1 Register
 ******************************************************************************/

/*!
 * @brief HW_MLB_ACMR1 - AHB Channel Mask 1 Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_mlb_acmr1
{
    uint32_t U;
    struct _hw_mlb_acmr1_bitfields
    {
        uint32_t CHM : 32;             /*!< [31:0]  */
    } B;
} hw_mlb_acmr1_t;

/*!
 * @name Constants and macros for entire MLB_ACMR1 register
 */
/*@{*/
#define HW_MLB_ACMR1_ADDR(x)     ((uintptr_t)(x) + 0x3DCU)

#define HW_MLB_ACMR1(x)          (*(__IO hw_mlb_acmr1_t *) HW_MLB_ACMR1_ADDR(x))
#define HW_MLB_ACMR1_RD(x)       (HW_MLB_ACMR1(x).U)
#define HW_MLB_ACMR1_WR(x, v)    (HW_MLB_ACMR1(x).U = (v))
#define HW_MLB_ACMR1_SET(x, v)   (HW_MLB_ACMR1_WR(x, HW_MLB_ACMR1_RD(x) |  (v)))
#define HW_MLB_ACMR1_CLR(x, v)   (HW_MLB_ACMR1_WR(x, HW_MLB_ACMR1_RD(x) & ~(v)))
#define HW_MLB_ACMR1_TOG(x, v)   (HW_MLB_ACMR1_WR(x, HW_MLB_ACMR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MLB_ACMR1 bitfields
 */

/*!
 * @name Register MLB_ACMR1, field CHM[31:0] (RW)
 *
 * Bitwise channel mask bit:
 *
 * Values:
 * - 0 - Masked
 * - 1 - Unmasked
 */
/*@{*/
#define BP_MLB_ACMR1_CHM     (0U)          /*!< Bit position for MLB_ACMR1_CHM. */
#define BM_MLB_ACMR1_CHM     (0xFFFFFFFFU) /*!< Bit mask for MLB_ACMR1_CHM. */
#define BS_MLB_ACMR1_CHM     (32U)         /*!< Bit field size in bits for MLB_ACMR1_CHM. */

/*! @brief Read current value of the MLB_ACMR1_CHM field. */
#define BR_MLB_ACMR1_CHM(x)  (HW_MLB_ACMR1(x).U)

/*! @brief Format value for bitfield MLB_ACMR1_CHM. */
#define BF_MLB_ACMR1_CHM(v)  ((uint32_t)((uint32_t)(v) << BP_MLB_ACMR1_CHM) & BM_MLB_ACMR1_CHM)

/*! @brief Set the CHM field to a new value. */
#define BW_MLB_ACMR1_CHM(x, v) (HW_MLB_ACMR1_WR(x, v))
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_mlb_t - module struct
 ******************************************************************************/
/*!
 * @brief All MLB module registers.
 */
#pragma pack(1)
typedef struct _hw_mlb
{
    __IO hw_mlb_mlbc0_t MLBC0;             /*!< [0x0] MediaLB Control 0 Register */
    uint8_t _reserved0[4];
    __IO hw_mlb_mlbpc0_t MLBPC0;           /*!< [0x8] MediaLB 6-pin Control 0 Register */
    union {
        struct {
            uint8_t _reserved0[1];
            __IO hw_mlb_mlbpc2_t MLBPC2;   /*!< [0xD] MediaLB 6-pin Control 2 Register */
        } MLBPC2;
        __I hw_mlb_ms0_t MS0;              /*!< [0xC] MediaLB Channel Status 0 Register */
    };
    uint8_t _reserved1[3];
    __I hw_mlb_ms1_t MS1;                  /*!< [0x14] MediaLB Channel Status1 Register */
    uint8_t _reserved2[8];
    __IO hw_mlb_mss_t MSS;                 /*!< [0x20] MediaLB System Status Register */
    __I hw_mlb_msd_t MSD;                  /*!< [0x24] MediaLB System Data Register */
    uint8_t _reserved3[4];
    __IO hw_mlb_mien_t MIEN;               /*!< [0x2C] MediaLB Interrupt Enable Register */
    uint8_t _reserved4[8];
    __IO hw_mlb_mlbpc1_t MLBPC1;           /*!< [0x38] MediaLB 6-pin Control 1 Register */
    __IO hw_mlb_mlbc1_t MLBC1;             /*!< [0x3C] MediaLB Control 1 Register */
    uint8_t _reserved5[64];
    __IO hw_mlb_hctl_t HCTL;               /*!< [0x80] HBI Control Register */
    uint8_t _reserved6[4];
    __IO hw_mlb_hcmr0_t HCMR0;             /*!< [0x88] HBI Channel Mask 0 Register */
    __IO hw_mlb_hcmr1_t HCMR1;             /*!< [0x8C] HBI Channel Mask 1 Register */
    __I hw_mlb_hcer0_t HCER0;              /*!< [0x90] HBI Channel Error 0 Register */
    __I hw_mlb_hcer1_t HCER1;              /*!< [0x94] HBI Channel Error 1 Register */
    __I hw_mlb_hcbr0_t HCBR0;              /*!< [0x98] HBI Channel Busy 0 Register */
    __I hw_mlb_hcbr1_t HCBR1;              /*!< [0x9C] HBI Channel Busy 1 Register */
    uint8_t _reserved7[32];
    __IO hw_mlb_mdat0_t MDAT0;             /*!< [0xC0] MIF Data 0 Register */
    __IO hw_mlb_mdat1_t MDAT1;             /*!< [0xC4] MIF Data 1 Register */
    __IO hw_mlb_mdat2_t MDAT2;             /*!< [0xC8] MIF Data 2 Register */
    __IO hw_mlb_mdat3_t MDAT3;             /*!< [0xCC] MIF Data 3 Register */
    __IO hw_mlb_mdwe0_t MDWE0;             /*!< [0xD0] MIF Data Write Enable 0 Register */
    __IO hw_mlb_mdwe1_t MDWE1;             /*!< [0xD4] MIF Data Write Enable 1 Register */
    __IO hw_mlb_mdwe2_t MDWE2;             /*!< [0xD8] MIF Data Write Enable 2 Register */
    __IO hw_mlb_mdwe3_t MDWE3;             /*!< [0xDC] MIF Data Write Enable 3 Register */
    __I hw_mlb_mctl_t MCTL;                /*!< [0xE0] MIF Control Register */
    __IO hw_mlb_madr_t MADR;               /*!< [0xE4] MIF Address Register */
    uint8_t _reserved8[728];
    __IO hw_mlb_actl_t ACTL;               /*!< [0x3C0] AHB Control Register */
    uint8_t _reserved9[12];
    __I hw_mlb_acsr0_t ACSR0;              /*!< [0x3D0] AHB Channel Status 0 Register */
    __I hw_mlb_acsr1_t ACSR1;              /*!< [0x3D4] AHB Channel Status 1 Register */
    __IO hw_mlb_acmr0_t ACMR0;             /*!< [0x3D8] AHB Channel Mask 0 Register */
    __IO hw_mlb_acmr1_t ACMR1;             /*!< [0x3DC] AHB Channel Mask 1 Register */
} hw_mlb_t;
#pragma pack()

/*! @brief Macro to access all MLB registers. */
/*! @param x MLB module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_MLB_REGS(MLB_BASE)</code>. */
#define HW_MLB_REGS(x) (*(hw_mlb_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP MMDC
 *
 * MMDC
 *
 * Registers defined in this header file:
 * - HW_MMDC_MDCTL - MMDC Core Control Register
 * - HW_MMDC_MDPDC - MMDC Core Power Down Control Register
 * - HW_MMDC_MDOTC - MMDC Core ODT Timing Control Register
 * - HW_MMDC_MDCFG0 - MMDC Core Timing Configuration Register 0
 * - HW_MMDC_MDCFG1 - MMDC Core Timing Configuration Register 1
 * - HW_MMDC_MDCFG2 - MMDC Core Timing Configuration Register 2
 * - HW_MMDC_MDMISC - MMDC Core Miscellaneous Register
 * - HW_MMDC_MDSCR - MMDC Core Special Command Register
 * - HW_MMDC_MDREF - MMDC Core Refresh Control Register
 * - HW_MMDC_MDRWD - MMDC Core Read/Write Command Delay Register
 * - HW_MMDC_MDOR - MMDC Core Out of Reset Delays Register
 * - HW_MMDC_MDMRR - MMDC Core MRR Data Register
 * - HW_MMDC_MDCFG3LP - MMDC Core Timing Configuration Register 3
 * - HW_MMDC_MDMR4 - MMDC Core MR4 Derating Register
 * - HW_MMDC_MDASP - MMDC Core Address Space Partition Register
 * - HW_MMDC_MAARCR - MMDC Core AXI Reordering Control Register
 * - HW_MMDC_MAPSR - MMDC Core Power Saving Control and Status Register
 * - HW_MMDC_MAEXIDR0 - MMDC Core Exclusive ID Monitor Register0
 * - HW_MMDC_MAEXIDR1 - MMDC Core Exclusive ID Monitor Register1
 * - HW_MMDC_MADPCR0 - MMDC Core Debug and Profiling Control Register 0
 * - HW_MMDC_MADPCR1 - MMDC Core Debug and Profiling Control Register 1
 * - HW_MMDC_MADPSR0 - MMDC Core Debug and Profiling Status Register 0
 * - HW_MMDC_MADPSR1 - MMDC Core Debug and Profiling Status Register 1
 * - HW_MMDC_MADPSR2 - MMDC Core Debug and Profiling Status Register 2
 * - HW_MMDC_MADPSR3 - MMDC Core Debug and Profiling Status Register 3
 * - HW_MMDC_MADPSR4 - MMDC Core Debug and Profiling Status Register 4
 * - HW_MMDC_MADPSR5 - MMDC Core Debug and Profiling Status Register 5
 * - HW_MMDC_MASBS0 - MMDC Core Step By Step Address Register
 * - HW_MMDC_MASBS1 - MMDC Core Step By Step Address Attributes Register
 * - HW_MMDC_MAGENP - MMDC Core General Purpose Register
 * - HW_MMDC_MPZQHWCTRL - MMDC PHY ZQ HW control register
 * - HW_MMDC_MPZQSWCTRL - MMDC PHY ZQ SW control register
 * - HW_MMDC_MPWLGCR - MMDC PHY Write Leveling Configuration and Error Status Register
 * - HW_MMDC_MPWLDECTRL0 - MMDC PHY Write Leveling Delay Control Register 0
 * - HW_MMDC_MPWLDECTRL1 - MMDC PHY Write Leveling Delay Control Register 1
 * - HW_MMDC_MPWLDLST - MMDC PHY Write Leveling delay-line Status Register
 * - HW_MMDC_MPODTCTRL - MMDC PHY ODT control register
 * - HW_MMDC_MPRDDQBY0DL - MMDC PHY Read DQ Byte0 Delay Register
 * - HW_MMDC_MPRDDQBY1DL - MMDC PHY Read DQ Byte1 Delay Register
 * - HW_MMDC_MPRDDQBY2DL - MMDC PHY Read DQ Byte2 Delay Register
 * - HW_MMDC_MPRDDQBY3DL - MMDC PHY Read DQ Byte3 Delay Register
 * - HW_MMDC_MPWRDQBY0DL - MMDC PHY Write DQ Byte0 Delay Register
 * - HW_MMDC_MPWRDQBY1DL - MMDC PHY Write DQ Byte1 Delay Register
 * - HW_MMDC_MPWRDQBY2DL - MMDC PHY Write DQ Byte2 Delay Register
 * - HW_MMDC_MPWRDQBY3DL - MMDC PHY Write DQ Byte3 Delay Register
 * - HW_MMDC_MPDGCTRL0 - MMDC PHY Read DQS Gating Control Register 0
 * - HW_MMDC_MPDGCTRL1 - MMDC PHY Read DQS Gating Control Register 1
 * - HW_MMDC_MPDGDLST0 - MMDC PHY Read DQS Gating delay-line Status Register
 * - HW_MMDC_MPRDDLCTL - MMDC PHY Read delay-lines Configuration Register
 * - HW_MMDC_MPRDDLST - MMDC PHY Read delay-lines Status Register
 * - HW_MMDC_MPWRDLCTL - MMDC PHY Write delay-lines Configuration Register
 * - HW_MMDC_MPWRDLST - MMDC PHY Write delay-lines Status Register
 * - HW_MMDC_MPSDCTRL - MMDC PHY CK Control Register
 * - HW_MMDC_MPZQLP2CTL - MMDC ZQ LPDDR2 HW Control Register
 * - HW_MMDC_MPRDDLHWCTL - MMDC PHY Read Delay HW Calibration Control Register
 * - HW_MMDC_MPWRDLHWCTL - MMDC PHY Write Delay HW Calibration Control Register
 * - HW_MMDC_MPRDDLHWST0 - MMDC PHY Read Delay HW Calibration Status Register 0
 * - HW_MMDC_MPRDDLHWST1 - MMDC PHY Read Delay HW Calibration Status Register 1
 * - HW_MMDC_MPWRDLHWST0 - MMDC PHY Write Delay HW Calibration Status Register 0
 * - HW_MMDC_MPWRDLHWST1 - MMDC PHY Write Delay HW Calibration Status Register 1
 * - HW_MMDC_MPWLHWERR - MMDC PHY Write Leveling HW Error Register
 * - HW_MMDC_MPDGHWST0 - MMDC PHY Read DQS Gating HW Status Register 0
 * - HW_MMDC_MPDGHWST1 - MMDC PHY Read DQS Gating HW Status Register 1
 * - HW_MMDC_MPDGHWST2 - MMDC PHY Read DQS Gating HW Status Register 2
 * - HW_MMDC_MPDGHWST3 - MMDC PHY Read DQS Gating HW Status Register 3
 * - HW_MMDC_MPPDCMPR1 - MMDC PHY Pre-defined Compare Register 1
 * - HW_MMDC_MPPDCMPR2 - MMDC PHY Pre-defined Compare and CA delay-line Configuration Register
 * - HW_MMDC_MPSWDAR0 - MMDC PHY SW Dummy Access Register
 * - HW_MMDC_MPSWDRDR0 - MMDC PHY SW Dummy Read Data Register 0
 * - HW_MMDC_MPSWDRDR1 - MMDC PHY SW Dummy Read Data Register 1
 * - HW_MMDC_MPSWDRDR2 - MMDC PHY SW Dummy Read Data Register 2
 * - HW_MMDC_MPSWDRDR3 - MMDC PHY SW Dummy Read Data Register 3
 * - HW_MMDC_MPSWDRDR4 - MMDC PHY SW Dummy Read Data Register 4
 * - HW_MMDC_MPSWDRDR5 - MMDC PHY SW Dummy Read Data Register 5
 * - HW_MMDC_MPSWDRDR6 - MMDC PHY SW Dummy Read Data Register 6
 * - HW_MMDC_MPSWDRDR7 - MMDC PHY SW Dummy Read Data Register 7
 * - HW_MMDC_MPMUR0 - MMDC PHY Measure Unit Register
 * - HW_MMDC_MPWRCADL - MMDC Write CA delay-line controller
 * - HW_MMDC_MPDCCR - MMDC Duty Cycle Control Register
 *
 * - hw_mmdc_t - Struct containing all module registers.
 */

#define HW_MMDC_INSTANCE_COUNT (2U) /*!< Number of instances of the MMDC module. */
#define HW_MMDC1 (0U) /*!< Instance number for MMDC1. */
#define HW_MMDC2 (1U) /*!< Instance number for MMDC2. */
#define MMDC1_BASE            (0x21B0000U) /*!< Base address for MMDC1. */
#define MMDC2_BASE            (0x21B4000U) /*!< Base address for MMDC2. */
/*! Array initializer of MMDC base addresses. */
#define MMDC_BASE_ADDRS       { MMDC1_BASE, MMDC2_BASE }

/*******************************************************************************
 * HW_MMDC_MDCTL - MMDC Core Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDCTL - MMDC Core Control Register (RW)
 *
 * Reset value: 0x03110000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdctl
{
    uint32_t U;
    struct _hw_mmdc_mdctl_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t DSIZ : 2;             /*!< [17:16]  */
        uint32_t RESERVED1 : 1;        /*!< [18]  */
        uint32_t BL : 1;               /*!< [19]  */
        uint32_t COL : 3;              /*!< [22:20]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t ROW : 3;              /*!< [26:24]  */
        uint32_t RESERVED3 : 3;        /*!< [29:27]  */
        uint32_t SDE_1 : 1;            /*!< [30]  */
        uint32_t SDE_0 : 1;            /*!< [31]  */
    } B;
} hw_mmdc_mdctl_t;

/*!
 * @name Constants and macros for entire MMDC_MDCTL register
 */
/*@{*/
#define HW_MMDC_MDCTL_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_MMDC_MDCTL(x)         (*(__IO hw_mmdc_mdctl_t *) HW_MMDC_MDCTL_ADDR(x))
#define HW_MMDC_MDCTL_RD(x)      (HW_MMDC_MDCTL(x).U)
#define HW_MMDC_MDCTL_WR(x, v)   (HW_MMDC_MDCTL(x).U = (v))
#define HW_MMDC_MDCTL_SET(x, v)  (HW_MMDC_MDCTL_WR(x, HW_MMDC_MDCTL_RD(x) |  (v)))
#define HW_MMDC_MDCTL_CLR(x, v)  (HW_MMDC_MDCTL_WR(x, HW_MMDC_MDCTL_RD(x) & ~(v)))
#define HW_MMDC_MDCTL_TOG(x, v)  (HW_MMDC_MDCTL_WR(x, HW_MMDC_MDCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDCTL bitfields
 */

/*!
 * @name Register MMDC_MDCTL, field DSIZ[17:16] (RW)
 *
 * DDR data bus size. This field determines the size of the data bus of the DDR
 * memory
 *
 * Values:
 * - 0 - 16-bit data bus
 * - 1 - 32-bit data bus
 */
/*@{*/
#define BP_MMDC_MDCTL_DSIZ   (16U)         /*!< Bit position for MMDC_MDCTL_DSIZ. */
#define BM_MMDC_MDCTL_DSIZ   (0x00030000U) /*!< Bit mask for MMDC_MDCTL_DSIZ. */
#define BS_MMDC_MDCTL_DSIZ   (2U)          /*!< Bit field size in bits for MMDC_MDCTL_DSIZ. */

/*! @brief Read current value of the MMDC_MDCTL_DSIZ field. */
#define BR_MMDC_MDCTL_DSIZ(x) (HW_MMDC_MDCTL(x).B.DSIZ)

/*! @brief Format value for bitfield MMDC_MDCTL_DSIZ. */
#define BF_MMDC_MDCTL_DSIZ(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_DSIZ) & BM_MMDC_MDCTL_DSIZ)

/*! @brief Set the DSIZ field to a new value. */
#define BW_MMDC_MDCTL_DSIZ(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_DSIZ) | BF_MMDC_MDCTL_DSIZ(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCTL, field BL[19] (RW)
 *
 * Burst Length. This field determines the burst length of the DDR device. In
 * LPDDR2 mode the MMDC supports burst length 4. In DDR3 mode the MMDC supports
 * burst length 8.
 *
 * Values:
 * - 0 - Burst Length 4 is used
 * - 1 - Burst Length 8 is used
 */
/*@{*/
#define BP_MMDC_MDCTL_BL     (19U)         /*!< Bit position for MMDC_MDCTL_BL. */
#define BM_MMDC_MDCTL_BL     (0x00080000U) /*!< Bit mask for MMDC_MDCTL_BL. */
#define BS_MMDC_MDCTL_BL     (1U)          /*!< Bit field size in bits for MMDC_MDCTL_BL. */

/*! @brief Read current value of the MMDC_MDCTL_BL field. */
#define BR_MMDC_MDCTL_BL(x)  (HW_MMDC_MDCTL(x).B.BL)

/*! @brief Format value for bitfield MMDC_MDCTL_BL. */
#define BF_MMDC_MDCTL_BL(v)  ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_BL) & BM_MMDC_MDCTL_BL)

/*! @brief Set the BL field to a new value. */
#define BW_MMDC_MDCTL_BL(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_BL) | BF_MMDC_MDCTL_BL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCTL, field COL[22:20] (RW)
 *
 * Column Address Width. This field specifies the number of column addresses
 * used by the memory array. It will determine how an incoming address will be
 * decoded.
 *
 * Values:
 * - 0 - 9 bits column
 * - 1 - 10 bits column
 * - 10 - 11 bits column
 * - 11 - 8 bits column
 * - 100 - 12 bits column
 */
/*@{*/
#define BP_MMDC_MDCTL_COL    (20U)         /*!< Bit position for MMDC_MDCTL_COL. */
#define BM_MMDC_MDCTL_COL    (0x00700000U) /*!< Bit mask for MMDC_MDCTL_COL. */
#define BS_MMDC_MDCTL_COL    (3U)          /*!< Bit field size in bits for MMDC_MDCTL_COL. */

/*! @brief Read current value of the MMDC_MDCTL_COL field. */
#define BR_MMDC_MDCTL_COL(x) (HW_MMDC_MDCTL(x).B.COL)

/*! @brief Format value for bitfield MMDC_MDCTL_COL. */
#define BF_MMDC_MDCTL_COL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_COL) & BM_MMDC_MDCTL_COL)

/*! @brief Set the COL field to a new value. */
#define BW_MMDC_MDCTL_COL(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_COL) | BF_MMDC_MDCTL_COL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCTL, field ROW[26:24] (RW)
 *
 * Row Address Width. This field specifies the number of row addresses used by
 * the memory array. It will affect the way an incoming address will be decoded.
 * Settings 110-111 are reserved
 *
 * Values:
 * - 000 - 11 bits Row
 * - 001 - 12 bits Row
 * - 010 - 13 bits Row
 * - 011 - 14 bits Row
 * - 100 - 15 bits Row
 * - 101 - 16 bits Row
 */
/*@{*/
#define BP_MMDC_MDCTL_ROW    (24U)         /*!< Bit position for MMDC_MDCTL_ROW. */
#define BM_MMDC_MDCTL_ROW    (0x07000000U) /*!< Bit mask for MMDC_MDCTL_ROW. */
#define BS_MMDC_MDCTL_ROW    (3U)          /*!< Bit field size in bits for MMDC_MDCTL_ROW. */

/*! @brief Read current value of the MMDC_MDCTL_ROW field. */
#define BR_MMDC_MDCTL_ROW(x) (HW_MMDC_MDCTL(x).B.ROW)

/*! @brief Format value for bitfield MMDC_MDCTL_ROW. */
#define BF_MMDC_MDCTL_ROW(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_ROW) & BM_MMDC_MDCTL_ROW)

/*! @brief Set the ROW field to a new value. */
#define BW_MMDC_MDCTL_ROW(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_ROW) | BF_MMDC_MDCTL_ROW(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCTL, field SDE_1[30] (RW)
 *
 * MMDC Enable CS1. This bit enables/disables accesses from the MMDC toward Chip
 * Select 1. The reset value of this bit is "0" (i.e No clocks and clock enable
 * will be driven to the memory). At the enabling point the MMDC will perform an
 * initialization process (including a delay on RESET and/or CKE) for both chip
 * selects. The initialization length depends on the configured memory type.
 *
 * Values:
 * - 0 - Disabled
 * - 1 - Enabled
 */
/*@{*/
#define BP_MMDC_MDCTL_SDE_1  (30U)         /*!< Bit position for MMDC_MDCTL_SDE_1. */
#define BM_MMDC_MDCTL_SDE_1  (0x40000000U) /*!< Bit mask for MMDC_MDCTL_SDE_1. */
#define BS_MMDC_MDCTL_SDE_1  (1U)          /*!< Bit field size in bits for MMDC_MDCTL_SDE_1. */

/*! @brief Read current value of the MMDC_MDCTL_SDE_1 field. */
#define BR_MMDC_MDCTL_SDE_1(x) (HW_MMDC_MDCTL(x).B.SDE_1)

/*! @brief Format value for bitfield MMDC_MDCTL_SDE_1. */
#define BF_MMDC_MDCTL_SDE_1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_SDE_1) & BM_MMDC_MDCTL_SDE_1)

/*! @brief Set the SDE_1 field to a new value. */
#define BW_MMDC_MDCTL_SDE_1(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_SDE_1) | BF_MMDC_MDCTL_SDE_1(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCTL, field SDE_0[31] (RW)
 *
 * MMDC Enable CS0. This bit enables/disables accesses from the MMDC toward Chip
 * Select 0. The reset value of this bit is "0" (i.e No clocks and clock enable
 * will be driven to the memory). At the enabling point the MMDC will perform an
 * initialization process (including a delay on RESET and/or CKE) for both chip
 * selects. The initialization length depends on the configured memory type.
 *
 * Values:
 * - 0 - Disabled
 * - 1 - Enabled
 */
/*@{*/
#define BP_MMDC_MDCTL_SDE_0  (31U)         /*!< Bit position for MMDC_MDCTL_SDE_0. */
#define BM_MMDC_MDCTL_SDE_0  (0x80000000U) /*!< Bit mask for MMDC_MDCTL_SDE_0. */
#define BS_MMDC_MDCTL_SDE_0  (1U)          /*!< Bit field size in bits for MMDC_MDCTL_SDE_0. */

/*! @brief Read current value of the MMDC_MDCTL_SDE_0 field. */
#define BR_MMDC_MDCTL_SDE_0(x) (HW_MMDC_MDCTL(x).B.SDE_0)

/*! @brief Format value for bitfield MMDC_MDCTL_SDE_0. */
#define BF_MMDC_MDCTL_SDE_0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCTL_SDE_0) & BM_MMDC_MDCTL_SDE_0)

/*! @brief Set the SDE_0 field to a new value. */
#define BW_MMDC_MDCTL_SDE_0(x, v) (HW_MMDC_MDCTL_WR(x, (HW_MMDC_MDCTL_RD(x) & ~BM_MMDC_MDCTL_SDE_0) | BF_MMDC_MDCTL_SDE_0(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDPDC - MMDC Core Power Down Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDPDC - MMDC Core Power Down Control Register (RW)
 *
 * Reset value: 0x00030012U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32 PRCT field encoding PRCT[2:0] Precharge Timer 000 Disabled (Bit
 * field reset value) 001 2 clocks 010 4 clocks 011 8 clocks 100 16 clocks 101 32
 * clocks 110 64 clocks 111 128 clocks PWDT field encoding PWDT[3:0] Power Down
 * Time-out 0000 Disabled (bit field reset value) 0001 16 cycles 0010 32 cycles
 * 0011 64 cycles 0100 128 cycles 0101 256 cycles 0110 512 cycles 0111 1024 cycles
 * 1000 2048 cycles 1001 4096 cycles 1010 8196 cycles 1011 16384 cycles 1100 32768
 * cycles 1101-1111 Reserved
 */
typedef union _hw_mmdc_mdpdc
{
    uint32_t U;
    struct _hw_mmdc_mdpdc_bitfields
    {
        uint32_t tCKSRE : 3;           /*!< [2:0]  */
        uint32_t tCKSRX : 3;           /*!< [5:3]  */
        uint32_t BOTH_CS_PD : 1;       /*!< [6]  */
        uint32_t SLOW_PD : 1;          /*!< [7]  */
        uint32_t PWDT_0 : 4;           /*!< [11:8]  */
        uint32_t PWDT_1 : 4;           /*!< [15:12]  */
        uint32_t tCKE : 3;             /*!< [18:16]  */
        uint32_t RESERVED0 : 5;        /*!< [23:19]  */
        uint32_t PRCT_0 : 3;           /*!< [26:24]  */
        uint32_t RESERVED1 : 1;        /*!< [27]  */
        uint32_t PRCT_1 : 3;           /*!< [30:28]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mdpdc_t;

/*!
 * @name Constants and macros for entire MMDC_MDPDC register
 */
/*@{*/
#define HW_MMDC_MDPDC_ADDR(x)    ((uintptr_t)(x) + 0x4U)

#define HW_MMDC_MDPDC(x)         (*(__IO hw_mmdc_mdpdc_t *) HW_MMDC_MDPDC_ADDR(x))
#define HW_MMDC_MDPDC_RD(x)      (HW_MMDC_MDPDC(x).U)
#define HW_MMDC_MDPDC_WR(x, v)   (HW_MMDC_MDPDC(x).U = (v))
#define HW_MMDC_MDPDC_SET(x, v)  (HW_MMDC_MDPDC_WR(x, HW_MMDC_MDPDC_RD(x) |  (v)))
#define HW_MMDC_MDPDC_CLR(x, v)  (HW_MMDC_MDPDC_WR(x, HW_MMDC_MDPDC_RD(x) & ~(v)))
#define HW_MMDC_MDPDC_TOG(x, v)  (HW_MMDC_MDPDC_WR(x, HW_MMDC_MDPDC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDPDC bitfields
 */

/*!
 * @name Register MMDC_MDPDC, field tCKSRE[2:0] (RW)
 *
 * Valid clock cycles after self-refresh entry. This field determines the amount
 * of clock cycles after self-refresh entry
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycles
 * - 110 - 6cycles
 * - 111 - 7cycles
 */
/*@{*/
#define BP_MMDC_MDPDC_tCKSRE (0U)          /*!< Bit position for MMDC_MDPDC_tCKSRE. */
#define BM_MMDC_MDPDC_tCKSRE (0x00000007U) /*!< Bit mask for MMDC_MDPDC_tCKSRE. */
#define BS_MMDC_MDPDC_tCKSRE (3U)          /*!< Bit field size in bits for MMDC_MDPDC_tCKSRE. */

/*! @brief Read current value of the MMDC_MDPDC_tCKSRE field. */
#define BR_MMDC_MDPDC_tCKSRE(x) (HW_MMDC_MDPDC(x).B.tCKSRE)

/*! @brief Format value for bitfield MMDC_MDPDC_tCKSRE. */
#define BF_MMDC_MDPDC_tCKSRE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_tCKSRE) & BM_MMDC_MDPDC_tCKSRE)

/*! @brief Set the tCKSRE field to a new value. */
#define BW_MMDC_MDPDC_tCKSRE(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_tCKSRE) | BF_MMDC_MDPDC_tCKSRE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field tCKSRX[5:3] (RW)
 *
 * Valid clock cycles before self-refresh exit. This field determines the amount
 * of clock cycles before self-refresh exit
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDPDC_tCKSRX (3U)          /*!< Bit position for MMDC_MDPDC_tCKSRX. */
#define BM_MMDC_MDPDC_tCKSRX (0x00000038U) /*!< Bit mask for MMDC_MDPDC_tCKSRX. */
#define BS_MMDC_MDPDC_tCKSRX (3U)          /*!< Bit field size in bits for MMDC_MDPDC_tCKSRX. */

/*! @brief Read current value of the MMDC_MDPDC_tCKSRX field. */
#define BR_MMDC_MDPDC_tCKSRX(x) (HW_MMDC_MDPDC(x).B.tCKSRX)

/*! @brief Format value for bitfield MMDC_MDPDC_tCKSRX. */
#define BF_MMDC_MDPDC_tCKSRX(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_tCKSRX) & BM_MMDC_MDPDC_tCKSRX)

/*! @brief Set the tCKSRX field to a new value. */
#define BW_MMDC_MDPDC_tCKSRX(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_tCKSRX) | BF_MMDC_MDPDC_tCKSRX(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field BOTH_CS_PD[6] (RW)
 *
 * Parallel power down entry to both chip selects. When power down timer is used
 * for both chip-selects (i.e PWDT_0 and PWDT1 don't equal "0") , then if this
 * bit is enabled, the MMDC will enter power down only if the amount of idle
 * cycles of both chip selects was obtained.
 *
 * Values:
 * - 0 - Each chip select can enter power down independently according to its
 *     configuration.
 * - 1 - Chip selects can enter power down only if the amount of idle cycles of
 *     both chip selects was obtained.
 */
/*@{*/
#define BP_MMDC_MDPDC_BOTH_CS_PD (6U)      /*!< Bit position for MMDC_MDPDC_BOTH_CS_PD. */
#define BM_MMDC_MDPDC_BOTH_CS_PD (0x00000040U) /*!< Bit mask for MMDC_MDPDC_BOTH_CS_PD. */
#define BS_MMDC_MDPDC_BOTH_CS_PD (1U)      /*!< Bit field size in bits for MMDC_MDPDC_BOTH_CS_PD. */

/*! @brief Read current value of the MMDC_MDPDC_BOTH_CS_PD field. */
#define BR_MMDC_MDPDC_BOTH_CS_PD(x) (HW_MMDC_MDPDC(x).B.BOTH_CS_PD)

/*! @brief Format value for bitfield MMDC_MDPDC_BOTH_CS_PD. */
#define BF_MMDC_MDPDC_BOTH_CS_PD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_BOTH_CS_PD) & BM_MMDC_MDPDC_BOTH_CS_PD)

/*! @brief Set the BOTH_CS_PD field to a new value. */
#define BW_MMDC_MDPDC_BOTH_CS_PD(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_BOTH_CS_PD) | BF_MMDC_MDPDC_BOTH_CS_PD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field SLOW_PD[7] (RW)
 *
 * Slow/fast power down. In DDR3 mode this field is referred to slow precharge
 * power-down. In LPDDR2 mode this field is not relevant. Memory should be
 * configured the same.
 *
 * Values:
 * - 0 - Fast mode.
 * - 1 - Slow mode.
 */
/*@{*/
#define BP_MMDC_MDPDC_SLOW_PD (7U)         /*!< Bit position for MMDC_MDPDC_SLOW_PD. */
#define BM_MMDC_MDPDC_SLOW_PD (0x00000080U) /*!< Bit mask for MMDC_MDPDC_SLOW_PD. */
#define BS_MMDC_MDPDC_SLOW_PD (1U)         /*!< Bit field size in bits for MMDC_MDPDC_SLOW_PD. */

/*! @brief Read current value of the MMDC_MDPDC_SLOW_PD field. */
#define BR_MMDC_MDPDC_SLOW_PD(x) (HW_MMDC_MDPDC(x).B.SLOW_PD)

/*! @brief Format value for bitfield MMDC_MDPDC_SLOW_PD. */
#define BF_MMDC_MDPDC_SLOW_PD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_SLOW_PD) & BM_MMDC_MDPDC_SLOW_PD)

/*! @brief Set the SLOW_PD field to a new value. */
#define BW_MMDC_MDPDC_SLOW_PD(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_SLOW_PD) | BF_MMDC_MDPDC_SLOW_PD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field PWDT_0[11:8] (RW)
 *
 * Power Down Timer - Chip Select 0. This field determines the amount of idle
 * cycle for which chip select 0 will be automatically get into precharge/active
 * power down. The amount of cycles are determined according to the PWDT Field
 * Encoding table above.
 */
/*@{*/
#define BP_MMDC_MDPDC_PWDT_0 (8U)          /*!< Bit position for MMDC_MDPDC_PWDT_0. */
#define BM_MMDC_MDPDC_PWDT_0 (0x00000F00U) /*!< Bit mask for MMDC_MDPDC_PWDT_0. */
#define BS_MMDC_MDPDC_PWDT_0 (4U)          /*!< Bit field size in bits for MMDC_MDPDC_PWDT_0. */

/*! @brief Read current value of the MMDC_MDPDC_PWDT_0 field. */
#define BR_MMDC_MDPDC_PWDT_0(x) (HW_MMDC_MDPDC(x).B.PWDT_0)

/*! @brief Format value for bitfield MMDC_MDPDC_PWDT_0. */
#define BF_MMDC_MDPDC_PWDT_0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_PWDT_0) & BM_MMDC_MDPDC_PWDT_0)

/*! @brief Set the PWDT_0 field to a new value. */
#define BW_MMDC_MDPDC_PWDT_0(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_PWDT_0) | BF_MMDC_MDPDC_PWDT_0(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field PWDT_1[15:12] (RW)
 *
 * Power Down Timer - Chip Select 1. This field determines the amount of idle
 * cycle for which chip select 1 will be automatically get into precharge/active
 * power down. The amount of cycles are determined according to the PWDT Field
 * Encoding table above.
 */
/*@{*/
#define BP_MMDC_MDPDC_PWDT_1 (12U)         /*!< Bit position for MMDC_MDPDC_PWDT_1. */
#define BM_MMDC_MDPDC_PWDT_1 (0x0000F000U) /*!< Bit mask for MMDC_MDPDC_PWDT_1. */
#define BS_MMDC_MDPDC_PWDT_1 (4U)          /*!< Bit field size in bits for MMDC_MDPDC_PWDT_1. */

/*! @brief Read current value of the MMDC_MDPDC_PWDT_1 field. */
#define BR_MMDC_MDPDC_PWDT_1(x) (HW_MMDC_MDPDC(x).B.PWDT_1)

/*! @brief Format value for bitfield MMDC_MDPDC_PWDT_1. */
#define BF_MMDC_MDPDC_PWDT_1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_PWDT_1) & BM_MMDC_MDPDC_PWDT_1)

/*! @brief Set the PWDT_1 field to a new value. */
#define BW_MMDC_MDPDC_PWDT_1(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_PWDT_1) | BF_MMDC_MDPDC_PWDT_1(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field tCKE[18:16] (RW)
 *
 * CKE minimum pulse width. This field determines the minimum pulse width of CKE.
 *
 * Values:
 * - 0 - 1 cycle
 * - 1 - 2 cycles
 * - 110 - 7 cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDPDC_tCKE   (16U)         /*!< Bit position for MMDC_MDPDC_tCKE. */
#define BM_MMDC_MDPDC_tCKE   (0x00070000U) /*!< Bit mask for MMDC_MDPDC_tCKE. */
#define BS_MMDC_MDPDC_tCKE   (3U)          /*!< Bit field size in bits for MMDC_MDPDC_tCKE. */

/*! @brief Read current value of the MMDC_MDPDC_tCKE field. */
#define BR_MMDC_MDPDC_tCKE(x) (HW_MMDC_MDPDC(x).B.tCKE)

/*! @brief Format value for bitfield MMDC_MDPDC_tCKE. */
#define BF_MMDC_MDPDC_tCKE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_tCKE) & BM_MMDC_MDPDC_tCKE)

/*! @brief Set the tCKE field to a new value. */
#define BW_MMDC_MDPDC_tCKE(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_tCKE) | BF_MMDC_MDPDC_tCKE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field PRCT_0[26:24] (RW)
 *
 * Precharge Timer - Chip Select 0. This field determines the amount of idle
 * cycle for which chip select 0 will be automatically precharged. The amount of
 * cycles are determined according to the table below.
 */
/*@{*/
#define BP_MMDC_MDPDC_PRCT_0 (24U)         /*!< Bit position for MMDC_MDPDC_PRCT_0. */
#define BM_MMDC_MDPDC_PRCT_0 (0x07000000U) /*!< Bit mask for MMDC_MDPDC_PRCT_0. */
#define BS_MMDC_MDPDC_PRCT_0 (3U)          /*!< Bit field size in bits for MMDC_MDPDC_PRCT_0. */

/*! @brief Read current value of the MMDC_MDPDC_PRCT_0 field. */
#define BR_MMDC_MDPDC_PRCT_0(x) (HW_MMDC_MDPDC(x).B.PRCT_0)

/*! @brief Format value for bitfield MMDC_MDPDC_PRCT_0. */
#define BF_MMDC_MDPDC_PRCT_0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_PRCT_0) & BM_MMDC_MDPDC_PRCT_0)

/*! @brief Set the PRCT_0 field to a new value. */
#define BW_MMDC_MDPDC_PRCT_0(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_PRCT_0) | BF_MMDC_MDPDC_PRCT_0(v)))
/*@}*/

/*!
 * @name Register MMDC_MDPDC, field PRCT_1[30:28] (RW)
 *
 * Precharge Timer - Chip Select 1. This field determines the amount of idle
 * cycle for which chip select 1 will be automatically precharged. The amount of
 * cycles are determined according to the PRCT Field Encoding table above.
 */
/*@{*/
#define BP_MMDC_MDPDC_PRCT_1 (28U)         /*!< Bit position for MMDC_MDPDC_PRCT_1. */
#define BM_MMDC_MDPDC_PRCT_1 (0x70000000U) /*!< Bit mask for MMDC_MDPDC_PRCT_1. */
#define BS_MMDC_MDPDC_PRCT_1 (3U)          /*!< Bit field size in bits for MMDC_MDPDC_PRCT_1. */

/*! @brief Read current value of the MMDC_MDPDC_PRCT_1 field. */
#define BR_MMDC_MDPDC_PRCT_1(x) (HW_MMDC_MDPDC(x).B.PRCT_1)

/*! @brief Format value for bitfield MMDC_MDPDC_PRCT_1. */
#define BF_MMDC_MDPDC_PRCT_1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDPDC_PRCT_1) & BM_MMDC_MDPDC_PRCT_1)

/*! @brief Set the PRCT_1 field to a new value. */
#define BW_MMDC_MDPDC_PRCT_1(x, v) (HW_MMDC_MDPDC_WR(x, (HW_MMDC_MDPDC_RD(x) & ~BM_MMDC_MDPDC_PRCT_1) | BF_MMDC_MDPDC_PRCT_1(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDOTC - MMDC Core ODT Timing Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDOTC - MMDC Core ODT Timing Control Register (RW)
 *
 * Reset value: 0x12272000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32 For further information see ODT ConfigurationThe MMDC supports two
 * DRAM_ODT signals (DRAM_ODT for each DRAM_CS) in DDR3 mode in order to allow
 * the DDR device to turn on/off its termination resistors. The MMDC suggests
 * various configuration for the assertion of the ODT signals as well as
 * configuration of several related timing. .
 */
typedef union _hw_mmdc_mdotc
{
    uint32_t U;
    struct _hw_mmdc_mdotc_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t tODT_idle_off : 5;    /*!< [8:4]  */
        uint32_t RESERVED1 : 3;        /*!< [11:9]  */
        uint32_t tODTLon : 3;          /*!< [14:12]  */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t tAXPD : 4;            /*!< [19:16]  */
        uint32_t tANPD : 4;            /*!< [23:20]  */
        uint32_t tAONPD : 3;           /*!< [26:24]  */
        uint32_t tAOFPD : 3;           /*!< [29:27]  */
        uint32_t RESERVED3 : 2;        /*!< [31:30]  */
    } B;
} hw_mmdc_mdotc_t;

/*!
 * @name Constants and macros for entire MMDC_MDOTC register
 */
/*@{*/
#define HW_MMDC_MDOTC_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_MMDC_MDOTC(x)         (*(__IO hw_mmdc_mdotc_t *) HW_MMDC_MDOTC_ADDR(x))
#define HW_MMDC_MDOTC_RD(x)      (HW_MMDC_MDOTC(x).U)
#define HW_MMDC_MDOTC_WR(x, v)   (HW_MMDC_MDOTC(x).U = (v))
#define HW_MMDC_MDOTC_SET(x, v)  (HW_MMDC_MDOTC_WR(x, HW_MMDC_MDOTC_RD(x) |  (v)))
#define HW_MMDC_MDOTC_CLR(x, v)  (HW_MMDC_MDOTC_WR(x, HW_MMDC_MDOTC_RD(x) & ~(v)))
#define HW_MMDC_MDOTC_TOG(x, v)  (HW_MMDC_MDOTC_WR(x, HW_MMDC_MDOTC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDOTC bitfields
 */

/*!
 * @name Register MMDC_MDOTC, field tODT_idle_off[8:4] (RW)
 *
 * ODT turn off latency. This field determines the Idle period before turning
 * memory ODT off. This field is not relevant in LPDDR2 mode.
 *
 * Values:
 * - 0 - 0 cycle (turned off at the earliest possible time)
 * - 1 - 1 cycle
 * - 10 - 2 cycles
 * - 11110 - 30 cycles
 * - 11111 - 31 cycles
 */
/*@{*/
#define BP_MMDC_MDOTC_tODT_idle_off (4U)   /*!< Bit position for MMDC_MDOTC_tODT_idle_off. */
#define BM_MMDC_MDOTC_tODT_idle_off (0x000001F0U) /*!< Bit mask for MMDC_MDOTC_tODT_idle_off. */
#define BS_MMDC_MDOTC_tODT_idle_off (5U)   /*!< Bit field size in bits for MMDC_MDOTC_tODT_idle_off. */

/*! @brief Read current value of the MMDC_MDOTC_tODT_idle_off field. */
#define BR_MMDC_MDOTC_tODT_idle_off(x) (HW_MMDC_MDOTC(x).B.tODT_idle_off)

/*! @brief Format value for bitfield MMDC_MDOTC_tODT_idle_off. */
#define BF_MMDC_MDOTC_tODT_idle_off(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tODT_idle_off) & BM_MMDC_MDOTC_tODT_idle_off)

/*! @brief Set the tODT_idle_off field to a new value. */
#define BW_MMDC_MDOTC_tODT_idle_off(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tODT_idle_off) | BF_MMDC_MDOTC_tODT_idle_off(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOTC, field tODTLon[14:12] (RW)
 *
 * ODT turn on latency. This field determines the delay between ODT signal and
 * the associated RTT, where according to JEDEC standard it equals WL(write
 * latency) - 2. Therefore, the value that is configured to tODTLon field should
 * correspond the value that is configured to MDCGFG1[tCWL] In LPDDR2 this field is not
 * relevant.
 *
 * Values:
 * - 0 - - 0x1 Reserved
 * - 10 - 2 cycles
 * - 11 - 3 cycles
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDOTC_tODTLon (12U)        /*!< Bit position for MMDC_MDOTC_tODTLon. */
#define BM_MMDC_MDOTC_tODTLon (0x00007000U) /*!< Bit mask for MMDC_MDOTC_tODTLon. */
#define BS_MMDC_MDOTC_tODTLon (3U)         /*!< Bit field size in bits for MMDC_MDOTC_tODTLon. */

/*! @brief Read current value of the MMDC_MDOTC_tODTLon field. */
#define BR_MMDC_MDOTC_tODTLon(x) (HW_MMDC_MDOTC(x).B.tODTLon)

/*! @brief Format value for bitfield MMDC_MDOTC_tODTLon. */
#define BF_MMDC_MDOTC_tODTLon(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tODTLon) & BM_MMDC_MDOTC_tODTLon)

/*! @brief Set the tODTLon field to a new value. */
#define BW_MMDC_MDOTC_tODTLon(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tODTLon) | BF_MMDC_MDOTC_tODTLon(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOTC, field tAXPD[19:16] (RW)
 *
 * Asynchronous ODT to power down exit delay. In DDR3 should be set to tCWL-1
 * This field is not relevant in LPDDR2 mode.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - 16 clocks
 */
/*@{*/
#define BP_MMDC_MDOTC_tAXPD  (16U)         /*!< Bit position for MMDC_MDOTC_tAXPD. */
#define BM_MMDC_MDOTC_tAXPD  (0x000F0000U) /*!< Bit mask for MMDC_MDOTC_tAXPD. */
#define BS_MMDC_MDOTC_tAXPD  (4U)          /*!< Bit field size in bits for MMDC_MDOTC_tAXPD. */

/*! @brief Read current value of the MMDC_MDOTC_tAXPD field. */
#define BR_MMDC_MDOTC_tAXPD(x) (HW_MMDC_MDOTC(x).B.tAXPD)

/*! @brief Format value for bitfield MMDC_MDOTC_tAXPD. */
#define BF_MMDC_MDOTC_tAXPD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tAXPD) & BM_MMDC_MDOTC_tAXPD)

/*! @brief Set the tAXPD field to a new value. */
#define BW_MMDC_MDOTC_tAXPD(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tAXPD) | BF_MMDC_MDOTC_tAXPD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOTC, field tANPD[23:20] (RW)
 *
 * Asynchronous ODT to power down entry delay. In DDR3 should be set to tCWL-1
 * This field is not relevant in LPDDR2 mode.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - 16 clocks
 */
/*@{*/
#define BP_MMDC_MDOTC_tANPD  (20U)         /*!< Bit position for MMDC_MDOTC_tANPD. */
#define BM_MMDC_MDOTC_tANPD  (0x00F00000U) /*!< Bit mask for MMDC_MDOTC_tANPD. */
#define BS_MMDC_MDOTC_tANPD  (4U)          /*!< Bit field size in bits for MMDC_MDOTC_tANPD. */

/*! @brief Read current value of the MMDC_MDOTC_tANPD field. */
#define BR_MMDC_MDOTC_tANPD(x) (HW_MMDC_MDOTC(x).B.tANPD)

/*! @brief Format value for bitfield MMDC_MDOTC_tANPD. */
#define BF_MMDC_MDOTC_tANPD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tANPD) & BM_MMDC_MDOTC_tANPD)

/*! @brief Set the tANPD field to a new value. */
#define BW_MMDC_MDOTC_tANPD(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tANPD) | BF_MMDC_MDOTC_tANPD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOTC, field tAONPD[26:24] (RW)
 *
 * Asynchronous RTT turn-on delay (power down with DLL frozen). This field
 * determines the time between termination cuircuit gets out of high impedance and
 * begins to turn on till ODT resistance are fully on. This field is not relevant in
 * LPDDR2 mode.
 *
 * Values:
 * - 0 - 1 cycle
 * - 1 - 2 cycles
 * - 110 - 7 cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDOTC_tAONPD (24U)         /*!< Bit position for MMDC_MDOTC_tAONPD. */
#define BM_MMDC_MDOTC_tAONPD (0x07000000U) /*!< Bit mask for MMDC_MDOTC_tAONPD. */
#define BS_MMDC_MDOTC_tAONPD (3U)          /*!< Bit field size in bits for MMDC_MDOTC_tAONPD. */

/*! @brief Read current value of the MMDC_MDOTC_tAONPD field. */
#define BR_MMDC_MDOTC_tAONPD(x) (HW_MMDC_MDOTC(x).B.tAONPD)

/*! @brief Format value for bitfield MMDC_MDOTC_tAONPD. */
#define BF_MMDC_MDOTC_tAONPD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tAONPD) & BM_MMDC_MDOTC_tAONPD)

/*! @brief Set the tAONPD field to a new value. */
#define BW_MMDC_MDOTC_tAONPD(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tAONPD) | BF_MMDC_MDOTC_tAONPD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOTC, field tAOFPD[29:27] (RW)
 *
 * Asynchronous RTT turn-off delay (power down with DLL frozen). This field
 * determines the time between termination cuircuit starts to turn off the ODT
 * resistance till termination has reached high impedance. This field is not relevant
 * in LPDDR2 mode.
 *
 * Values:
 * - 0 - 1 cycle
 * - 1 - 2 cycles
 * - 110 - 7 cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDOTC_tAOFPD (27U)         /*!< Bit position for MMDC_MDOTC_tAOFPD. */
#define BM_MMDC_MDOTC_tAOFPD (0x38000000U) /*!< Bit mask for MMDC_MDOTC_tAOFPD. */
#define BS_MMDC_MDOTC_tAOFPD (3U)          /*!< Bit field size in bits for MMDC_MDOTC_tAOFPD. */

/*! @brief Read current value of the MMDC_MDOTC_tAOFPD field. */
#define BR_MMDC_MDOTC_tAOFPD(x) (HW_MMDC_MDOTC(x).B.tAOFPD)

/*! @brief Format value for bitfield MMDC_MDOTC_tAOFPD. */
#define BF_MMDC_MDOTC_tAOFPD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOTC_tAOFPD) & BM_MMDC_MDOTC_tAOFPD)

/*! @brief Set the tAOFPD field to a new value. */
#define BW_MMDC_MDOTC_tAOFPD(x, v) (HW_MMDC_MDOTC_WR(x, (HW_MMDC_MDOTC_RD(x) & ~BM_MMDC_MDOTC_tAOFPD) | BF_MMDC_MDOTC_tAOFPD(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDCFG0 - MMDC Core Timing Configuration Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDCFG0 - MMDC Core Timing Configuration Register 0 (RW)
 *
 * Reset value: 0x323622D3U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdcfg0
{
    uint32_t U;
    struct _hw_mmdc_mdcfg0_bitfields
    {
        uint32_t tCL : 4;              /*!< [3:0]  */
        uint32_t tFAW : 5;             /*!< [8:4]  */
        uint32_t tXPDLL : 4;           /*!< [12:9]  */
        uint32_t tXP : 3;              /*!< [15:13]  */
        uint32_t tXS : 8;              /*!< [23:16]  */
        uint32_t tRFC : 8;             /*!< [31:24]  */
    } B;
} hw_mmdc_mdcfg0_t;

/*!
 * @name Constants and macros for entire MMDC_MDCFG0 register
 */
/*@{*/
#define HW_MMDC_MDCFG0_ADDR(x)   ((uintptr_t)(x) + 0xCU)

#define HW_MMDC_MDCFG0(x)        (*(__IO hw_mmdc_mdcfg0_t *) HW_MMDC_MDCFG0_ADDR(x))
#define HW_MMDC_MDCFG0_RD(x)     (HW_MMDC_MDCFG0(x).U)
#define HW_MMDC_MDCFG0_WR(x, v)  (HW_MMDC_MDCFG0(x).U = (v))
#define HW_MMDC_MDCFG0_SET(x, v) (HW_MMDC_MDCFG0_WR(x, HW_MMDC_MDCFG0_RD(x) |  (v)))
#define HW_MMDC_MDCFG0_CLR(x, v) (HW_MMDC_MDCFG0_WR(x, HW_MMDC_MDCFG0_RD(x) & ~(v)))
#define HW_MMDC_MDCFG0_TOG(x, v) (HW_MMDC_MDCFG0_WR(x, HW_MMDC_MDCFG0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDCFG0 bitfields
 */

/*!
 * @name Register MMDC_MDCFG0, field tCL[3:0] (RW)
 *
 * CAS Read Latency. In DDR3 mode this field is referred to CL. In LPDDR2 mode
 * this field is referred to RL. In LPDDR2 mode only the RL/WL pairs are allowed
 * as specified in MR2 register See DDR3 SDRAM Specification JESD79-3E (July 2010)
 * and LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a detailed
 * description of this parameter.
 *
 * Values:
 * - 0 - 3 cycles
 * - 1 - 4 cycles
 * - 10 - 5 cycles
 * - 11 - 6 cycles
 * - 100 - 7 cycles
 * - 101 - 8 cycles
 * - 110 - 9 cycles
 * - 111 - 10 cycles
 * - 1000 - 11 cycles
 * - 1001 - - 0xF Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG0_tCL   (0U)          /*!< Bit position for MMDC_MDCFG0_tCL. */
#define BM_MMDC_MDCFG0_tCL   (0x0000000FU) /*!< Bit mask for MMDC_MDCFG0_tCL. */
#define BS_MMDC_MDCFG0_tCL   (4U)          /*!< Bit field size in bits for MMDC_MDCFG0_tCL. */

/*! @brief Read current value of the MMDC_MDCFG0_tCL field. */
#define BR_MMDC_MDCFG0_tCL(x) (HW_MMDC_MDCFG0(x).B.tCL)

/*! @brief Format value for bitfield MMDC_MDCFG0_tCL. */
#define BF_MMDC_MDCFG0_tCL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tCL) & BM_MMDC_MDCFG0_tCL)

/*! @brief Set the tCL field to a new value. */
#define BW_MMDC_MDCFG0_tCL(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tCL) | BF_MMDC_MDCFG0_tCL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG0, field tFAW[8:4] (RW)
 *
 * Four Active Window (all banks). See DDR3 SDRAM Specification JESD79-3E (July
 * 2010) and LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a detailed
 * description of this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11110 - 31 clocks
 * - 11111 - 32 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG0_tFAW  (4U)          /*!< Bit position for MMDC_MDCFG0_tFAW. */
#define BM_MMDC_MDCFG0_tFAW  (0x000001F0U) /*!< Bit mask for MMDC_MDCFG0_tFAW. */
#define BS_MMDC_MDCFG0_tFAW  (5U)          /*!< Bit field size in bits for MMDC_MDCFG0_tFAW. */

/*! @brief Read current value of the MMDC_MDCFG0_tFAW field. */
#define BR_MMDC_MDCFG0_tFAW(x) (HW_MMDC_MDCFG0(x).B.tFAW)

/*! @brief Format value for bitfield MMDC_MDCFG0_tFAW. */
#define BF_MMDC_MDCFG0_tFAW(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tFAW) & BM_MMDC_MDCFG0_tFAW)

/*! @brief Set the tFAW field to a new value. */
#define BW_MMDC_MDCFG0_tFAW(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tFAW) | BF_MMDC_MDCFG0_tFAW(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG0, field tXPDLL[12:9] (RW)
 *
 * Exit precharge power down with DLL frozen to commands requiring DLL. This
 * field is not relevant in LPDDR2 mode. See DDR3 SDRAM Specification JESD79-3E
 * (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a
 * detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - 16 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG0_tXPDLL (9U)         /*!< Bit position for MMDC_MDCFG0_tXPDLL. */
#define BM_MMDC_MDCFG0_tXPDLL (0x00001E00U) /*!< Bit mask for MMDC_MDCFG0_tXPDLL. */
#define BS_MMDC_MDCFG0_tXPDLL (4U)         /*!< Bit field size in bits for MMDC_MDCFG0_tXPDLL. */

/*! @brief Read current value of the MMDC_MDCFG0_tXPDLL field. */
#define BR_MMDC_MDCFG0_tXPDLL(x) (HW_MMDC_MDCFG0(x).B.tXPDLL)

/*! @brief Format value for bitfield MMDC_MDCFG0_tXPDLL. */
#define BF_MMDC_MDCFG0_tXPDLL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tXPDLL) & BM_MMDC_MDCFG0_tXPDLL)

/*! @brief Set the tXPDLL field to a new value. */
#define BW_MMDC_MDCFG0_tXPDLL(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tXPDLL) | BF_MMDC_MDCFG0_tXPDLL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG0, field tXP[15:13] (RW)
 *
 * Exit power down with DLL-on to any valid command. Exit power down with
 * DLL-frozen to commands not requiring a locked DLL In LPDDR2 mode this field is
 * referred to Exit power-down to next valid command delay. See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February
 * 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 cycle
 * - 1 - 2 cycles
 * - 110 - 7 cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDCFG0_tXP   (13U)         /*!< Bit position for MMDC_MDCFG0_tXP. */
#define BM_MMDC_MDCFG0_tXP   (0x0000E000U) /*!< Bit mask for MMDC_MDCFG0_tXP. */
#define BS_MMDC_MDCFG0_tXP   (3U)          /*!< Bit field size in bits for MMDC_MDCFG0_tXP. */

/*! @brief Read current value of the MMDC_MDCFG0_tXP field. */
#define BR_MMDC_MDCFG0_tXP(x) (HW_MMDC_MDCFG0(x).B.tXP)

/*! @brief Format value for bitfield MMDC_MDCFG0_tXP. */
#define BF_MMDC_MDCFG0_tXP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tXP) & BM_MMDC_MDCFG0_tXP)

/*! @brief Set the tXP field to a new value. */
#define BW_MMDC_MDCFG0_tXP(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tXP) | BF_MMDC_MDCFG0_tXP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG0, field tXS[23:16] (RW)
 *
 * Exit self refresh to non READ command. In LPDDR2 it is called tXSR,
 * self-refresh exit to next valid command delay. See DDR3 SDRAM Specification JESD79-3E
 * (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a
 * detailed description of this parameter.
 *
 * Values:
 * - 0 - - 0x15 reserved
 * - 10110 - 23 clocks
 * - 10111 - 24 clocks
 * - 11111110 - 255 clocks
 * - 11111111 - 256 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG0_tXS   (16U)         /*!< Bit position for MMDC_MDCFG0_tXS. */
#define BM_MMDC_MDCFG0_tXS   (0x00FF0000U) /*!< Bit mask for MMDC_MDCFG0_tXS. */
#define BS_MMDC_MDCFG0_tXS   (8U)          /*!< Bit field size in bits for MMDC_MDCFG0_tXS. */

/*! @brief Read current value of the MMDC_MDCFG0_tXS field. */
#define BR_MMDC_MDCFG0_tXS(x) (HW_MMDC_MDCFG0(x).B.tXS)

/*! @brief Format value for bitfield MMDC_MDCFG0_tXS. */
#define BF_MMDC_MDCFG0_tXS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tXS) & BM_MMDC_MDCFG0_tXS)

/*! @brief Set the tXS field to a new value. */
#define BW_MMDC_MDCFG0_tXS(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tXS) | BF_MMDC_MDCFG0_tXS(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG0, field tRFC[31:24] (RW)
 *
 * Refresh command to Active or Refresh command time. See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February
 * 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11111110 - 255 clocks
 * - 11111111 - 256 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG0_tRFC  (24U)         /*!< Bit position for MMDC_MDCFG0_tRFC. */
#define BM_MMDC_MDCFG0_tRFC  (0xFF000000U) /*!< Bit mask for MMDC_MDCFG0_tRFC. */
#define BS_MMDC_MDCFG0_tRFC  (8U)          /*!< Bit field size in bits for MMDC_MDCFG0_tRFC. */

/*! @brief Read current value of the MMDC_MDCFG0_tRFC field. */
#define BR_MMDC_MDCFG0_tRFC(x) (HW_MMDC_MDCFG0(x).B.tRFC)

/*! @brief Format value for bitfield MMDC_MDCFG0_tRFC. */
#define BF_MMDC_MDCFG0_tRFC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG0_tRFC) & BM_MMDC_MDCFG0_tRFC)

/*! @brief Set the tRFC field to a new value. */
#define BW_MMDC_MDCFG0_tRFC(x, v) (HW_MMDC_MDCFG0_WR(x, (HW_MMDC_MDCFG0_RD(x) & ~BM_MMDC_MDCFG0_tRFC) | BF_MMDC_MDCFG0_tRFC(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDCFG1 - MMDC Core Timing Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDCFG1 - MMDC Core Timing Configuration Register 1 (RW)
 *
 * Reset value: 0xB6B18A23U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdcfg1
{
    uint32_t U;
    struct _hw_mmdc_mdcfg1_bitfields
    {
        uint32_t tCWL : 3;             /*!< [2:0]  */
        uint32_t RESERVED0 : 2;        /*!< [4:3]  */
        uint32_t tMRD : 4;             /*!< [8:5]  */
        uint32_t tWR : 3;              /*!< [11:9]  */
        uint32_t RESERVED1 : 3;        /*!< [14:12]  */
        uint32_t tRPA : 1;             /*!< [15]  */
        uint32_t tRAS : 5;             /*!< [20:16]  */
        uint32_t tRC : 5;              /*!< [25:21]  */
        uint32_t tRP : 3;              /*!< [28:26]  */
        uint32_t tRCD : 3;             /*!< [31:29]  */
    } B;
} hw_mmdc_mdcfg1_t;

/*!
 * @name Constants and macros for entire MMDC_MDCFG1 register
 */
/*@{*/
#define HW_MMDC_MDCFG1_ADDR(x)   ((uintptr_t)(x) + 0x10U)

#define HW_MMDC_MDCFG1(x)        (*(__IO hw_mmdc_mdcfg1_t *) HW_MMDC_MDCFG1_ADDR(x))
#define HW_MMDC_MDCFG1_RD(x)     (HW_MMDC_MDCFG1(x).U)
#define HW_MMDC_MDCFG1_WR(x, v)  (HW_MMDC_MDCFG1(x).U = (v))
#define HW_MMDC_MDCFG1_SET(x, v) (HW_MMDC_MDCFG1_WR(x, HW_MMDC_MDCFG1_RD(x) |  (v)))
#define HW_MMDC_MDCFG1_CLR(x, v) (HW_MMDC_MDCFG1_WR(x, HW_MMDC_MDCFG1_RD(x) & ~(v)))
#define HW_MMDC_MDCFG1_TOG(x, v) (HW_MMDC_MDCFG1_WR(x, HW_MMDC_MDCFG1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDCFG1 bitfields
 */

/*!
 * @name Register MMDC_MDCFG1, field tCWL[2:0] (RW)
 *
 * CAS Write Latency. In DDR3 mode this field is referred to CWL. In LPDDR2 mode
 * this field is referred to WL.
 *
 * Values:
 * - 0 - 2cycles ( DDR3) , 1 cycle (LPDDR2)
 * - 1 - 3cycles ( DDR3) , 2 cycles (LPDDR2)
 * - 10 - 4cycles ( DDR3) , 3 cycles (LPDDR2)
 * - 11 - 5cycles ( DDR3) , 4 cycles (LPDDR2)
 * - 100 - 6cycles ( DDR3) , 5 cycles (LPDDR2)
 * - 101 - 7cycles ( DDR3) , 6 cycles (LPDDR2)
 * - 110 - 8cycles ( DDR3) , 7 cycles (LPDDR2)
 * - 111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG1_tCWL  (0U)          /*!< Bit position for MMDC_MDCFG1_tCWL. */
#define BM_MMDC_MDCFG1_tCWL  (0x00000007U) /*!< Bit mask for MMDC_MDCFG1_tCWL. */
#define BS_MMDC_MDCFG1_tCWL  (3U)          /*!< Bit field size in bits for MMDC_MDCFG1_tCWL. */

/*! @brief Read current value of the MMDC_MDCFG1_tCWL field. */
#define BR_MMDC_MDCFG1_tCWL(x) (HW_MMDC_MDCFG1(x).B.tCWL)

/*! @brief Format value for bitfield MMDC_MDCFG1_tCWL. */
#define BF_MMDC_MDCFG1_tCWL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tCWL) & BM_MMDC_MDCFG1_tCWL)

/*! @brief Set the tCWL field to a new value. */
#define BW_MMDC_MDCFG1_tCWL(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tCWL) | BF_MMDC_MDCFG1_tCWL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tMRD[8:5] (RW)
 *
 * Mode Register Set command cycle (all banks). In DDR3 mode this field shoud be
 * set to max (tMRD,tMOD). In LPDDR2 mode this field should be set to
 * max(tMRR,tMRW) See DDR3 SDRAM Specification JESD79-3E (July 2010) and LPDDR2 SDRAM
 * Specification JESD209-2B (February 2010) for a detailed description of this
 * parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - 16 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG1_tMRD  (5U)          /*!< Bit position for MMDC_MDCFG1_tMRD. */
#define BM_MMDC_MDCFG1_tMRD  (0x000001E0U) /*!< Bit mask for MMDC_MDCFG1_tMRD. */
#define BS_MMDC_MDCFG1_tMRD  (4U)          /*!< Bit field size in bits for MMDC_MDCFG1_tMRD. */

/*! @brief Read current value of the MMDC_MDCFG1_tMRD field. */
#define BR_MMDC_MDCFG1_tMRD(x) (HW_MMDC_MDCFG1(x).B.tMRD)

/*! @brief Format value for bitfield MMDC_MDCFG1_tMRD. */
#define BF_MMDC_MDCFG1_tMRD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tMRD) & BM_MMDC_MDCFG1_tMRD)

/*! @brief Set the tMRD field to a new value. */
#define BW_MMDC_MDCFG1_tMRD(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tMRD) | BF_MMDC_MDCFG1_tMRD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tWR[11:9] (RW)
 *
 * WRITE recovery time (same bank). See DDR3 SDRAM Specification JESD79-3E (July
 * 2010) and LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a
 * detailed description of this parameter.
 *
 * Values:
 * - 0 - 1cycle
 * - 1 - 2cycles
 * - 10 - 3cycles
 * - 11 - 4cycles
 * - 100 - 5cycles
 * - 101 - 6cycles
 * - 110 - 7cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDCFG1_tWR   (9U)          /*!< Bit position for MMDC_MDCFG1_tWR. */
#define BM_MMDC_MDCFG1_tWR   (0x00000E00U) /*!< Bit mask for MMDC_MDCFG1_tWR. */
#define BS_MMDC_MDCFG1_tWR   (3U)          /*!< Bit field size in bits for MMDC_MDCFG1_tWR. */

/*! @brief Read current value of the MMDC_MDCFG1_tWR field. */
#define BR_MMDC_MDCFG1_tWR(x) (HW_MMDC_MDCFG1(x).B.tWR)

/*! @brief Format value for bitfield MMDC_MDCFG1_tWR. */
#define BF_MMDC_MDCFG1_tWR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tWR) & BM_MMDC_MDCFG1_tWR)

/*! @brief Set the tWR field to a new value. */
#define BW_MMDC_MDCFG1_tWR(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tWR) | BF_MMDC_MDCFG1_tWR(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tRPA[15] (RW)
 *
 * Precharge-all command period. (This field is valid only for DDR3 memories) In
 * LPDDR2 mode this parameter should be configured at tRPab_LP. See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B
 * (February 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - Will be equal to: tRP.
 * - 1 - Will be equal to: tRP+1.
 */
/*@{*/
#define BP_MMDC_MDCFG1_tRPA  (15U)         /*!< Bit position for MMDC_MDCFG1_tRPA. */
#define BM_MMDC_MDCFG1_tRPA  (0x00008000U) /*!< Bit mask for MMDC_MDCFG1_tRPA. */
#define BS_MMDC_MDCFG1_tRPA  (1U)          /*!< Bit field size in bits for MMDC_MDCFG1_tRPA. */

/*! @brief Read current value of the MMDC_MDCFG1_tRPA field. */
#define BR_MMDC_MDCFG1_tRPA(x) (HW_MMDC_MDCFG1(x).B.tRPA)

/*! @brief Format value for bitfield MMDC_MDCFG1_tRPA. */
#define BF_MMDC_MDCFG1_tRPA(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tRPA) & BM_MMDC_MDCFG1_tRPA)

/*! @brief Set the tRPA field to a new value. */
#define BW_MMDC_MDCFG1_tRPA(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tRPA) | BF_MMDC_MDCFG1_tRPA(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tRAS[20:16] (RW)
 *
 * Active to Precharge command period (same bank). See DDR3 SDRAM Specification
 * JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February
 * 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11110 - 31 clocks
 * - 11111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG1_tRAS  (16U)         /*!< Bit position for MMDC_MDCFG1_tRAS. */
#define BM_MMDC_MDCFG1_tRAS  (0x001F0000U) /*!< Bit mask for MMDC_MDCFG1_tRAS. */
#define BS_MMDC_MDCFG1_tRAS  (5U)          /*!< Bit field size in bits for MMDC_MDCFG1_tRAS. */

/*! @brief Read current value of the MMDC_MDCFG1_tRAS field. */
#define BR_MMDC_MDCFG1_tRAS(x) (HW_MMDC_MDCFG1(x).B.tRAS)

/*! @brief Format value for bitfield MMDC_MDCFG1_tRAS. */
#define BF_MMDC_MDCFG1_tRAS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tRAS) & BM_MMDC_MDCFG1_tRAS)

/*! @brief Set the tRAS field to a new value. */
#define BW_MMDC_MDCFG1_tRAS(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tRAS) | BF_MMDC_MDCFG1_tRAS(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tRC[25:21] (RW)
 *
 * Active to Active or Refresh command period (same bank). (This field is valid
 * only for DDR3 memories) In LPDDR2 mode this parameter should be configured at
 * tRC_LP. See DDR3 SDRAM Specification JESD79-3E (July 2010) and LPDDR2 SDRAM
 * Specification JESD209-2B (February 2010) for a detailed description of this
 * parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11110 - 31 clocks
 * - 11111 - 32 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG1_tRC   (21U)         /*!< Bit position for MMDC_MDCFG1_tRC. */
#define BM_MMDC_MDCFG1_tRC   (0x03E00000U) /*!< Bit mask for MMDC_MDCFG1_tRC. */
#define BS_MMDC_MDCFG1_tRC   (5U)          /*!< Bit field size in bits for MMDC_MDCFG1_tRC. */

/*! @brief Read current value of the MMDC_MDCFG1_tRC field. */
#define BR_MMDC_MDCFG1_tRC(x) (HW_MMDC_MDCFG1(x).B.tRC)

/*! @brief Format value for bitfield MMDC_MDCFG1_tRC. */
#define BF_MMDC_MDCFG1_tRC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tRC) & BM_MMDC_MDCFG1_tRC)

/*! @brief Set the tRC field to a new value. */
#define BW_MMDC_MDCFG1_tRC(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tRC) | BF_MMDC_MDCFG1_tRC(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tRP[28:26] (RW)
 *
 * Precharge command period (same bank). (This field is valid only for DDR3
 * memories) IIn LPDDR2 mode this parameter should be configured at tRPpb_LP. See
 * DDR3 SDRAM Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification
 * JESD209-2B (February 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11 - 4 clocks
 * - 100 - 5 clocks
 * - 101 - 6 clocks
 * - 110 - 7 clocks
 * - 111 - 8 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG1_tRP   (26U)         /*!< Bit position for MMDC_MDCFG1_tRP. */
#define BM_MMDC_MDCFG1_tRP   (0x1C000000U) /*!< Bit mask for MMDC_MDCFG1_tRP. */
#define BS_MMDC_MDCFG1_tRP   (3U)          /*!< Bit field size in bits for MMDC_MDCFG1_tRP. */

/*! @brief Read current value of the MMDC_MDCFG1_tRP field. */
#define BR_MMDC_MDCFG1_tRP(x) (HW_MMDC_MDCFG1(x).B.tRP)

/*! @brief Format value for bitfield MMDC_MDCFG1_tRP. */
#define BF_MMDC_MDCFG1_tRP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tRP) & BM_MMDC_MDCFG1_tRP)

/*! @brief Set the tRP field to a new value. */
#define BW_MMDC_MDCFG1_tRP(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tRP) | BF_MMDC_MDCFG1_tRP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG1, field tRCD[31:29] (RW)
 *
 * Active command to internal read or write delay time (same bank). (This field
 * is valid only for DDR3 memories) In LPDDR2 mode this parameter should be
 * configured at tRCD_LP. See DDR3 SDRAM Specification JESD79-3E (July 2010) and
 * LPDDR2 SDRAM Specification JESD209-2B (February 2010) for a detailed description of
 * this parameter.
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 11 - 4 clocks
 * - 100 - 5 clocks
 * - 101 - 6 clocks
 * - 110 - 7 clocks
 * - 111 - 8 clocks
 */
/*@{*/
#define BP_MMDC_MDCFG1_tRCD  (29U)         /*!< Bit position for MMDC_MDCFG1_tRCD. */
#define BM_MMDC_MDCFG1_tRCD  (0xE0000000U) /*!< Bit mask for MMDC_MDCFG1_tRCD. */
#define BS_MMDC_MDCFG1_tRCD  (3U)          /*!< Bit field size in bits for MMDC_MDCFG1_tRCD. */

/*! @brief Read current value of the MMDC_MDCFG1_tRCD field. */
#define BR_MMDC_MDCFG1_tRCD(x) (HW_MMDC_MDCFG1(x).B.tRCD)

/*! @brief Format value for bitfield MMDC_MDCFG1_tRCD. */
#define BF_MMDC_MDCFG1_tRCD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG1_tRCD) & BM_MMDC_MDCFG1_tRCD)

/*! @brief Set the tRCD field to a new value. */
#define BW_MMDC_MDCFG1_tRCD(x, v) (HW_MMDC_MDCFG1_WR(x, (HW_MMDC_MDCFG1_RD(x) & ~BM_MMDC_MDCFG1_tRCD) | BF_MMDC_MDCFG1_tRCD(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDCFG2 - MMDC Core Timing Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDCFG2 - MMDC Core Timing Configuration Register 2 (RW)
 *
 * Reset value: 0x00C70092U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdcfg2
{
    uint32_t U;
    struct _hw_mmdc_mdcfg2_bitfields
    {
        uint32_t tRRD : 3;             /*!< [2:0]  */
        uint32_t tWTR : 3;             /*!< [5:3]  */
        uint32_t tRTP : 3;             /*!< [8:6]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t tDLLK : 9;            /*!< [24:16]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_mmdc_mdcfg2_t;

/*!
 * @name Constants and macros for entire MMDC_MDCFG2 register
 */
/*@{*/
#define HW_MMDC_MDCFG2_ADDR(x)   ((uintptr_t)(x) + 0x14U)

#define HW_MMDC_MDCFG2(x)        (*(__IO hw_mmdc_mdcfg2_t *) HW_MMDC_MDCFG2_ADDR(x))
#define HW_MMDC_MDCFG2_RD(x)     (HW_MMDC_MDCFG2(x).U)
#define HW_MMDC_MDCFG2_WR(x, v)  (HW_MMDC_MDCFG2(x).U = (v))
#define HW_MMDC_MDCFG2_SET(x, v) (HW_MMDC_MDCFG2_WR(x, HW_MMDC_MDCFG2_RD(x) |  (v)))
#define HW_MMDC_MDCFG2_CLR(x, v) (HW_MMDC_MDCFG2_WR(x, HW_MMDC_MDCFG2_RD(x) & ~(v)))
#define HW_MMDC_MDCFG2_TOG(x, v) (HW_MMDC_MDCFG2_WR(x, HW_MMDC_MDCFG2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDCFG2 bitfields
 */

/*!
 * @name Register MMDC_MDCFG2, field tRRD[2:0] (RW)
 *
 * Active to Active command period (all banks). See DDR3 SDRAM Specification
 * JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February 2010)
 * for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1cycle
 * - 1 - 2cycles
 * - 10 - 3cycles
 * - 11 - 4cycles
 * - 100 - 5cycles
 * - 101 - 6cycles
 * - 110 - 7cycles
 * - 111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG2_tRRD  (0U)          /*!< Bit position for MMDC_MDCFG2_tRRD. */
#define BM_MMDC_MDCFG2_tRRD  (0x00000007U) /*!< Bit mask for MMDC_MDCFG2_tRRD. */
#define BS_MMDC_MDCFG2_tRRD  (3U)          /*!< Bit field size in bits for MMDC_MDCFG2_tRRD. */

/*! @brief Read current value of the MMDC_MDCFG2_tRRD field. */
#define BR_MMDC_MDCFG2_tRRD(x) (HW_MMDC_MDCFG2(x).B.tRRD)

/*! @brief Format value for bitfield MMDC_MDCFG2_tRRD. */
#define BF_MMDC_MDCFG2_tRRD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG2_tRRD) & BM_MMDC_MDCFG2_tRRD)

/*! @brief Set the tRRD field to a new value. */
#define BW_MMDC_MDCFG2_tRRD(x, v) (HW_MMDC_MDCFG2_WR(x, (HW_MMDC_MDCFG2_RD(x) & ~BM_MMDC_MDCFG2_tRRD) | BF_MMDC_MDCFG2_tRRD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG2, field tWTR[5:3] (RW)
 *
 * Internal WRITE to READ command delay (same bank). See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B (February
 * 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1cycle
 * - 1 - 2cycles
 * - 10 - 3cycles
 * - 11 - 4cycles
 * - 100 - 5cycles
 * - 101 - 6cycles
 * - 110 - 7cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDCFG2_tWTR  (3U)          /*!< Bit position for MMDC_MDCFG2_tWTR. */
#define BM_MMDC_MDCFG2_tWTR  (0x00000038U) /*!< Bit mask for MMDC_MDCFG2_tWTR. */
#define BS_MMDC_MDCFG2_tWTR  (3U)          /*!< Bit field size in bits for MMDC_MDCFG2_tWTR. */

/*! @brief Read current value of the MMDC_MDCFG2_tWTR field. */
#define BR_MMDC_MDCFG2_tWTR(x) (HW_MMDC_MDCFG2(x).B.tWTR)

/*! @brief Format value for bitfield MMDC_MDCFG2_tWTR. */
#define BF_MMDC_MDCFG2_tWTR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG2_tWTR) & BM_MMDC_MDCFG2_tWTR)

/*! @brief Set the tWTR field to a new value. */
#define BW_MMDC_MDCFG2_tWTR(x, v) (HW_MMDC_MDCFG2_WR(x, (HW_MMDC_MDCFG2_RD(x) & ~BM_MMDC_MDCFG2_tWTR) | BF_MMDC_MDCFG2_tWTR(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG2, field tRTP[8:6] (RW)
 *
 * Internal READ command to Precharge command delay (same bank). See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B
 * (February 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1cycle
 * - 1 - 2cycles
 * - 10 - 3cycles
 * - 11 - 4cycles
 * - 100 - 5cycles
 * - 101 - 6cycles
 * - 110 - 7cycles
 * - 111 - 8 cycles
 */
/*@{*/
#define BP_MMDC_MDCFG2_tRTP  (6U)          /*!< Bit position for MMDC_MDCFG2_tRTP. */
#define BM_MMDC_MDCFG2_tRTP  (0x000001C0U) /*!< Bit mask for MMDC_MDCFG2_tRTP. */
#define BS_MMDC_MDCFG2_tRTP  (3U)          /*!< Bit field size in bits for MMDC_MDCFG2_tRTP. */

/*! @brief Read current value of the MMDC_MDCFG2_tRTP field. */
#define BR_MMDC_MDCFG2_tRTP(x) (HW_MMDC_MDCFG2(x).B.tRTP)

/*! @brief Format value for bitfield MMDC_MDCFG2_tRTP. */
#define BF_MMDC_MDCFG2_tRTP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG2_tRTP) & BM_MMDC_MDCFG2_tRTP)

/*! @brief Set the tRTP field to a new value. */
#define BW_MMDC_MDCFG2_tRTP(x, v) (HW_MMDC_MDCFG2_WR(x, (HW_MMDC_MDCFG2_RD(x) & ~BM_MMDC_MDCFG2_tRTP) | BF_MMDC_MDCFG2_tRTP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG2, field tDLLK[24:16] (RW)
 *
 * DLL locking time. This field is not relevant in LPDDR2 mode. See DDR3 SDRAM
 * Specification JESD79-3E (July 2010) and LPDDR2 SDRAM Specification JESD209-2B
 * (February 2010) for a detailed description of this parameter.
 *
 * Values:
 * - 0 - 1 cycle.
 * - 1 - 2 cycles.
 * - 10 - 3 cycles.
 * - 11000111 - 200 cycles
 * - 111111110 - 511 cycles.
 * - 111111111 - 512 cycles (JEDEC value for DDR3).
 */
/*@{*/
#define BP_MMDC_MDCFG2_tDLLK (16U)         /*!< Bit position for MMDC_MDCFG2_tDLLK. */
#define BM_MMDC_MDCFG2_tDLLK (0x01FF0000U) /*!< Bit mask for MMDC_MDCFG2_tDLLK. */
#define BS_MMDC_MDCFG2_tDLLK (9U)          /*!< Bit field size in bits for MMDC_MDCFG2_tDLLK. */

/*! @brief Read current value of the MMDC_MDCFG2_tDLLK field. */
#define BR_MMDC_MDCFG2_tDLLK(x) (HW_MMDC_MDCFG2(x).B.tDLLK)

/*! @brief Format value for bitfield MMDC_MDCFG2_tDLLK. */
#define BF_MMDC_MDCFG2_tDLLK(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG2_tDLLK) & BM_MMDC_MDCFG2_tDLLK)

/*! @brief Set the tDLLK field to a new value. */
#define BW_MMDC_MDCFG2_tDLLK(x, v) (HW_MMDC_MDCFG2_WR(x, (HW_MMDC_MDCFG2_RD(x) & ~BM_MMDC_MDCFG2_tDLLK) | BF_MMDC_MDCFG2_tDLLK(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDMISC - MMDC Core Miscellaneous Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDMISC - MMDC Core Miscellaneous Register (RW)
 *
 * Reset value: 0x00001600U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdmisc
{
    uint32_t U;
    struct _hw_mmdc_mdmisc_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t RST : 1;              /*!< [1]  */
        uint32_t LPDDR2_2CH : 1;       /*!< [2]  */
        uint32_t DDR_TYPE : 2;         /*!< [4:3]  */
        uint32_t DDR_4_BANK : 1;       /*!< [5]  */
        uint32_t RALAT : 3;            /*!< [8:6]  */
        uint32_t MIF3_MODE : 2;        /*!< [10:9]  */
        uint32_t LPDDR2_S2 : 1;        /*!< [11]  */
        uint32_t BI_ON : 1;            /*!< [12]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t WALAT : 2;            /*!< [17:16]  */
        uint32_t LHD : 1;              /*!< [18]  */
        uint32_t ADDR_MIRROR : 1;      /*!< [19]  */
        uint32_t CALIB_PER_CS : 1;     /*!< [20]  */
        uint32_t RESERVED2 : 9;        /*!< [29:21]  */
        uint32_t CS1_RDY : 1;          /*!< [30]  */
        uint32_t CS0_RDY : 1;          /*!< [31]  */
    } B;
} hw_mmdc_mdmisc_t;

/*!
 * @name Constants and macros for entire MMDC_MDMISC register
 */
/*@{*/
#define HW_MMDC_MDMISC_ADDR(x)   ((uintptr_t)(x) + 0x18U)

#define HW_MMDC_MDMISC(x)        (*(__IO hw_mmdc_mdmisc_t *) HW_MMDC_MDMISC_ADDR(x))
#define HW_MMDC_MDMISC_RD(x)     (HW_MMDC_MDMISC(x).U)
#define HW_MMDC_MDMISC_WR(x, v)  (HW_MMDC_MDMISC(x).U = (v))
#define HW_MMDC_MDMISC_SET(x, v) (HW_MMDC_MDMISC_WR(x, HW_MMDC_MDMISC_RD(x) |  (v)))
#define HW_MMDC_MDMISC_CLR(x, v) (HW_MMDC_MDMISC_WR(x, HW_MMDC_MDMISC_RD(x) & ~(v)))
#define HW_MMDC_MDMISC_TOG(x, v) (HW_MMDC_MDMISC_WR(x, HW_MMDC_MDMISC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDMISC bitfields
 */

/*!
 * @name Register MMDC_MDMISC, field RST[1] (RW)
 *
 * Software Reset. When this bit is asserted then the internal FSMs and
 * registers of the MMDC will be initialized. This bit once asserted gets deasserted
 * automatically.
 *
 * Values:
 * - 0 - Do nothing.
 * - 1 - Assert reset to the MMDC.
 */
/*@{*/
#define BP_MMDC_MDMISC_RST   (1U)          /*!< Bit position for MMDC_MDMISC_RST. */
#define BM_MMDC_MDMISC_RST   (0x00000002U) /*!< Bit mask for MMDC_MDMISC_RST. */
#define BS_MMDC_MDMISC_RST   (1U)          /*!< Bit field size in bits for MMDC_MDMISC_RST. */

/*! @brief Read current value of the MMDC_MDMISC_RST field. */
#define BR_MMDC_MDMISC_RST(x) (HW_MMDC_MDMISC(x).B.RST)

/*! @brief Format value for bitfield MMDC_MDMISC_RST. */
#define BF_MMDC_MDMISC_RST(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_RST) & BM_MMDC_MDMISC_RST)

/*! @brief Set the RST field to a new value. */
#define BW_MMDC_MDMISC_RST(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_RST) | BF_MMDC_MDMISC_RST(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field LPDDR2_2CH[2] (RW)
 *
 * LPDDR2 2-channels mode. When this bit is set to "1" then dual channel mode is
 * activated. This field should be cleared for DDR3 mode.
 *
 * Values:
 * - 0 - 1-channel mode (DDR3)
 * - 1 - 2-channels mode (LPDDR2)
 */
/*@{*/
#define BP_MMDC_MDMISC_LPDDR2_2CH (2U)     /*!< Bit position for MMDC_MDMISC_LPDDR2_2CH. */
#define BM_MMDC_MDMISC_LPDDR2_2CH (0x00000004U) /*!< Bit mask for MMDC_MDMISC_LPDDR2_2CH. */
#define BS_MMDC_MDMISC_LPDDR2_2CH (1U)     /*!< Bit field size in bits for MMDC_MDMISC_LPDDR2_2CH. */

/*! @brief Read current value of the MMDC_MDMISC_LPDDR2_2CH field. */
#define BR_MMDC_MDMISC_LPDDR2_2CH(x) (HW_MMDC_MDMISC(x).B.LPDDR2_2CH)

/*! @brief Format value for bitfield MMDC_MDMISC_LPDDR2_2CH. */
#define BF_MMDC_MDMISC_LPDDR2_2CH(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_LPDDR2_2CH) & BM_MMDC_MDMISC_LPDDR2_2CH)

/*! @brief Set the LPDDR2_2CH field to a new value. */
#define BW_MMDC_MDMISC_LPDDR2_2CH(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_LPDDR2_2CH) | BF_MMDC_MDMISC_LPDDR2_2CH(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field DDR_TYPE[4:3] (RW)
 *
 * DDR TYPE. This field determines the type of the external DDR device.
 *
 * Values:
 * - 0 - DDR3 device is used. (Default)
 * - 1 - LPDDR2 device is used.
 * - 10 - Reserved.
 * - 11 - Reserved.
 */
/*@{*/
#define BP_MMDC_MDMISC_DDR_TYPE (3U)       /*!< Bit position for MMDC_MDMISC_DDR_TYPE. */
#define BM_MMDC_MDMISC_DDR_TYPE (0x00000018U) /*!< Bit mask for MMDC_MDMISC_DDR_TYPE. */
#define BS_MMDC_MDMISC_DDR_TYPE (2U)       /*!< Bit field size in bits for MMDC_MDMISC_DDR_TYPE. */

/*! @brief Read current value of the MMDC_MDMISC_DDR_TYPE field. */
#define BR_MMDC_MDMISC_DDR_TYPE(x) (HW_MMDC_MDMISC(x).B.DDR_TYPE)

/*! @brief Format value for bitfield MMDC_MDMISC_DDR_TYPE. */
#define BF_MMDC_MDMISC_DDR_TYPE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_DDR_TYPE) & BM_MMDC_MDMISC_DDR_TYPE)

/*! @brief Set the DDR_TYPE field to a new value. */
#define BW_MMDC_MDMISC_DDR_TYPE(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_DDR_TYPE) | BF_MMDC_MDMISC_DDR_TYPE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field DDR_4_BANK[5] (RW)
 *
 * Number of banks per DDR device. When this bit is set to "1" then the MMDC
 * will work with DDR device of 4 banks.
 *
 * Values:
 * - 0 - 8 banks device is being used. (Default)
 * - 1 - 4 banks device is being used
 */
/*@{*/
#define BP_MMDC_MDMISC_DDR_4_BANK (5U)     /*!< Bit position for MMDC_MDMISC_DDR_4_BANK. */
#define BM_MMDC_MDMISC_DDR_4_BANK (0x00000020U) /*!< Bit mask for MMDC_MDMISC_DDR_4_BANK. */
#define BS_MMDC_MDMISC_DDR_4_BANK (1U)     /*!< Bit field size in bits for MMDC_MDMISC_DDR_4_BANK. */

/*! @brief Read current value of the MMDC_MDMISC_DDR_4_BANK field. */
#define BR_MMDC_MDMISC_DDR_4_BANK(x) (HW_MMDC_MDMISC(x).B.DDR_4_BANK)

/*! @brief Format value for bitfield MMDC_MDMISC_DDR_4_BANK. */
#define BF_MMDC_MDMISC_DDR_4_BANK(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_DDR_4_BANK) & BM_MMDC_MDMISC_DDR_4_BANK)

/*! @brief Set the DDR_4_BANK field to a new value. */
#define BW_MMDC_MDMISC_DDR_4_BANK(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_DDR_4_BANK) | BF_MMDC_MDMISC_DDR_4_BANK(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field RALAT[8:6] (RW)
 *
 * Read Additional Latency. This field determines the additional read latency
 * which is added to CAS latency and internal delays for which the MMDC will
 * retrieve the read data from the internal FIFO. This field is used to compensate on
 * board/chip delays. In LPDDR2 mode 2 extra cycles will be added internally in
 * order to compensate tDQSCK delay.
 *
 * Values:
 * - 0 - no additional latency.
 * - 1 - 1 cycle additional latency.
 * - 10 - 2 cycles additional latency.
 * - 11 - 3 cycles additional latency.
 * - 100 - 4 cycles additional latency.
 * - 101 - 5 cycles additional latency.
 * - 110 - 6 cycles additional latency.
 * - 111 - 7 cycles additional latency.
 */
/*@{*/
#define BP_MMDC_MDMISC_RALAT (6U)          /*!< Bit position for MMDC_MDMISC_RALAT. */
#define BM_MMDC_MDMISC_RALAT (0x000001C0U) /*!< Bit mask for MMDC_MDMISC_RALAT. */
#define BS_MMDC_MDMISC_RALAT (3U)          /*!< Bit field size in bits for MMDC_MDMISC_RALAT. */

/*! @brief Read current value of the MMDC_MDMISC_RALAT field. */
#define BR_MMDC_MDMISC_RALAT(x) (HW_MMDC_MDMISC(x).B.RALAT)

/*! @brief Format value for bitfield MMDC_MDMISC_RALAT. */
#define BF_MMDC_MDMISC_RALAT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_RALAT) & BM_MMDC_MDMISC_RALAT)

/*! @brief Set the RALAT field to a new value. */
#define BW_MMDC_MDMISC_RALAT(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_RALAT) | BF_MMDC_MDMISC_RALAT(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field MIF3_MODE[10:9] (RW)
 *
 * Command prediction working mode. This field determines the level of command
 * prediction that will be used by the MMDC
 *
 * Values:
 * - 00 - Disable prediction.
 * - 01 - Enable prediction based on : Valid access on first pipe line stage.
 * - 10 - Enable prediction based on: Valid access on first pipe line stage,
 *     Valid access on axi bus.
 * - 11 - Enable prediction based on: Valid access on first pipe line stage,
 *     Valid access on axi bus, Next miss access from access queue.
 */
/*@{*/
#define BP_MMDC_MDMISC_MIF3_MODE (9U)      /*!< Bit position for MMDC_MDMISC_MIF3_MODE. */
#define BM_MMDC_MDMISC_MIF3_MODE (0x00000600U) /*!< Bit mask for MMDC_MDMISC_MIF3_MODE. */
#define BS_MMDC_MDMISC_MIF3_MODE (2U)      /*!< Bit field size in bits for MMDC_MDMISC_MIF3_MODE. */

/*! @brief Read current value of the MMDC_MDMISC_MIF3_MODE field. */
#define BR_MMDC_MDMISC_MIF3_MODE(x) (HW_MMDC_MDMISC(x).B.MIF3_MODE)

/*! @brief Format value for bitfield MMDC_MDMISC_MIF3_MODE. */
#define BF_MMDC_MDMISC_MIF3_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_MIF3_MODE) & BM_MMDC_MDMISC_MIF3_MODE)

/*! @brief Set the MIF3_MODE field to a new value. */
#define BW_MMDC_MDMISC_MIF3_MODE(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_MIF3_MODE) | BF_MMDC_MDMISC_MIF3_MODE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field LPDDR2_S2[11] (RW)
 *
 * LPDDR2 S2 device type indication. In case LPDDR2 device is used (DDR_TYPE =
 * 0x1), this bit will indicate whether S2 or S4 device is used. This bit should
 * be cleared in DDR3 mode
 *
 * Values:
 * - 0 - LPDDR2-S4 device is used.
 * - 1 - LPDDR2-S2 device is used.
 */
/*@{*/
#define BP_MMDC_MDMISC_LPDDR2_S2 (11U)     /*!< Bit position for MMDC_MDMISC_LPDDR2_S2. */
#define BM_MMDC_MDMISC_LPDDR2_S2 (0x00000800U) /*!< Bit mask for MMDC_MDMISC_LPDDR2_S2. */
#define BS_MMDC_MDMISC_LPDDR2_S2 (1U)      /*!< Bit field size in bits for MMDC_MDMISC_LPDDR2_S2. */

/*! @brief Read current value of the MMDC_MDMISC_LPDDR2_S2 field. */
#define BR_MMDC_MDMISC_LPDDR2_S2(x) (HW_MMDC_MDMISC(x).B.LPDDR2_S2)

/*! @brief Format value for bitfield MMDC_MDMISC_LPDDR2_S2. */
#define BF_MMDC_MDMISC_LPDDR2_S2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_LPDDR2_S2) & BM_MMDC_MDMISC_LPDDR2_S2)

/*! @brief Set the LPDDR2_S2 field to a new value. */
#define BW_MMDC_MDMISC_LPDDR2_S2(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_LPDDR2_S2) | BF_MMDC_MDMISC_LPDDR2_S2(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field BI_ON[12] (RW)
 *
 * Bank Interleaving On. This bit controls the organization of the bank, row and
 * column address bits. For further information see Address decodingMMDC
 * supports up to two consecutive chip selects, each with the same density. In
 * LPDDR2-2ch mode, up to two chip selects per channel are supported. .
 *
 * Values:
 * - 0 - Banks are not interleaved, and address will be decoded as
 *     bank-row-column
 * - 1 - Banks are interleaved, and address will be decoded as row-bank-column
 */
/*@{*/
#define BP_MMDC_MDMISC_BI_ON (12U)         /*!< Bit position for MMDC_MDMISC_BI_ON. */
#define BM_MMDC_MDMISC_BI_ON (0x00001000U) /*!< Bit mask for MMDC_MDMISC_BI_ON. */
#define BS_MMDC_MDMISC_BI_ON (1U)          /*!< Bit field size in bits for MMDC_MDMISC_BI_ON. */

/*! @brief Read current value of the MMDC_MDMISC_BI_ON field. */
#define BR_MMDC_MDMISC_BI_ON(x) (HW_MMDC_MDMISC(x).B.BI_ON)

/*! @brief Format value for bitfield MMDC_MDMISC_BI_ON. */
#define BF_MMDC_MDMISC_BI_ON(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_BI_ON) & BM_MMDC_MDMISC_BI_ON)

/*! @brief Set the BI_ON field to a new value. */
#define BW_MMDC_MDMISC_BI_ON(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_BI_ON) | BF_MMDC_MDMISC_BI_ON(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field WALAT[17:16] (RW)
 *
 * Write Additional latency. In case the write-leveling calibration process
 * indicates a delay of greater than one-eighth a clock cycle (between CK and any of
 * the DQS strobe lines), then this field must be configured accordingly. This
 * field will add delay on the obe I/O control, which will compensate on the
 * additional write leveling delay on DQS and prevent the DQS from being cropped. The
 * purpose of WALAT is to add time delay at the end of a burst write operation to
 * ensure that the JEDEC time specification for Write Post Amble Delay (tWPST) is
 * met (DQS strobe is held low at the end of a write burst for > 30% a clock
 * cycle before it is released). If the value of any of the WL_DL_ABS_OFFSETn
 * register fields are greater than '1F', WALAT should be set to '1' (cycle additional
 * delay). WALAT should be further increased for any full cycle delays added by
 * the WL_CYC_DELn register fields.
 *
 * Values:
 * - 0 - No additional latency required.
 * - 1 - 1 cycle additional delay
 * - 10 - 2 cycles additional delay
 * - 11 - 3 cycles additional delay
 */
/*@{*/
#define BP_MMDC_MDMISC_WALAT (16U)         /*!< Bit position for MMDC_MDMISC_WALAT. */
#define BM_MMDC_MDMISC_WALAT (0x00030000U) /*!< Bit mask for MMDC_MDMISC_WALAT. */
#define BS_MMDC_MDMISC_WALAT (2U)          /*!< Bit field size in bits for MMDC_MDMISC_WALAT. */

/*! @brief Read current value of the MMDC_MDMISC_WALAT field. */
#define BR_MMDC_MDMISC_WALAT(x) (HW_MMDC_MDMISC(x).B.WALAT)

/*! @brief Format value for bitfield MMDC_MDMISC_WALAT. */
#define BF_MMDC_MDMISC_WALAT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_WALAT) & BM_MMDC_MDMISC_WALAT)

/*! @brief Set the WALAT field to a new value. */
#define BW_MMDC_MDMISC_WALAT(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_WALAT) | BF_MMDC_MDMISC_WALAT(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field LHD[18] (RW)
 *
 * Latency hiding disable. This is a debug feature. When set to "1" the MMDC
 * will handle one read/write access at a time. Meaning that the MMDC pipe-line will
 * be limitted to 1 open access (next AXI address phase will be acknowledged if
 * the current AXI data phase had finished)
 *
 * Values:
 * - 0 - Latency hiding on.
 * - 1 - Latency hiding disable.
 */
/*@{*/
#define BP_MMDC_MDMISC_LHD   (18U)         /*!< Bit position for MMDC_MDMISC_LHD. */
#define BM_MMDC_MDMISC_LHD   (0x00040000U) /*!< Bit mask for MMDC_MDMISC_LHD. */
#define BS_MMDC_MDMISC_LHD   (1U)          /*!< Bit field size in bits for MMDC_MDMISC_LHD. */

/*! @brief Read current value of the MMDC_MDMISC_LHD field. */
#define BR_MMDC_MDMISC_LHD(x) (HW_MMDC_MDMISC(x).B.LHD)

/*! @brief Format value for bitfield MMDC_MDMISC_LHD. */
#define BF_MMDC_MDMISC_LHD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_LHD) & BM_MMDC_MDMISC_LHD)

/*! @brief Set the LHD field to a new value. */
#define BW_MMDC_MDMISC_LHD(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_LHD) | BF_MMDC_MDMISC_LHD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field ADDR_MIRROR[19] (RW)
 *
 * Address mirroring. This feature is not supported for LPDDR2 memories. But
 * only for DDR3 memories. For further information see Address mirroringWhen
 * enabling this feature, address bits DRAM_A3, DRAM_A4, DRAM_A5, DRAM_A6, DRAM_A7,
 * DRAM_A8, DRAM_SDBA0, and DRAM_SDBA1 behave differently according to the associated
 * chip select. .
 *
 * Values:
 * - 0 - Address mirroring disabled.
 * - 1 - Address mirroring enabled.
 */
/*@{*/
#define BP_MMDC_MDMISC_ADDR_MIRROR (19U)   /*!< Bit position for MMDC_MDMISC_ADDR_MIRROR. */
#define BM_MMDC_MDMISC_ADDR_MIRROR (0x00080000U) /*!< Bit mask for MMDC_MDMISC_ADDR_MIRROR. */
#define BS_MMDC_MDMISC_ADDR_MIRROR (1U)    /*!< Bit field size in bits for MMDC_MDMISC_ADDR_MIRROR. */

/*! @brief Read current value of the MMDC_MDMISC_ADDR_MIRROR field. */
#define BR_MMDC_MDMISC_ADDR_MIRROR(x) (HW_MMDC_MDMISC(x).B.ADDR_MIRROR)

/*! @brief Format value for bitfield MMDC_MDMISC_ADDR_MIRROR. */
#define BF_MMDC_MDMISC_ADDR_MIRROR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_ADDR_MIRROR) & BM_MMDC_MDMISC_ADDR_MIRROR)

/*! @brief Set the ADDR_MIRROR field to a new value. */
#define BW_MMDC_MDMISC_ADDR_MIRROR(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_ADDR_MIRROR) | BF_MMDC_MDMISC_ADDR_MIRROR(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field CALIB_PER_CS[20] (RW)
 *
 * Number of chip-select for calibration process. This bit determines the
 * chip-select index that the associated calibration is targetted to. Relevant for
 * read, write, write leveling and read DQS gating calibrations
 *
 * Values:
 * - 0 - Calibration is targetted to CS0
 * - 1 - Calibration is targetted to CS1
 */
/*@{*/
#define BP_MMDC_MDMISC_CALIB_PER_CS (20U)  /*!< Bit position for MMDC_MDMISC_CALIB_PER_CS. */
#define BM_MMDC_MDMISC_CALIB_PER_CS (0x00100000U) /*!< Bit mask for MMDC_MDMISC_CALIB_PER_CS. */
#define BS_MMDC_MDMISC_CALIB_PER_CS (1U)   /*!< Bit field size in bits for MMDC_MDMISC_CALIB_PER_CS. */

/*! @brief Read current value of the MMDC_MDMISC_CALIB_PER_CS field. */
#define BR_MMDC_MDMISC_CALIB_PER_CS(x) (HW_MMDC_MDMISC(x).B.CALIB_PER_CS)

/*! @brief Format value for bitfield MMDC_MDMISC_CALIB_PER_CS. */
#define BF_MMDC_MDMISC_CALIB_PER_CS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMISC_CALIB_PER_CS) & BM_MMDC_MDMISC_CALIB_PER_CS)

/*! @brief Set the CALIB_PER_CS field to a new value. */
#define BW_MMDC_MDMISC_CALIB_PER_CS(x, v) (HW_MMDC_MDMISC_WR(x, (HW_MMDC_MDMISC_RD(x) & ~BM_MMDC_MDMISC_CALIB_PER_CS) | BF_MMDC_MDMISC_CALIB_PER_CS(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field CS1_RDY[30] (RO)
 *
 * External status device on CS1. This is a read-only status bit, that indicates
 * whether the external memory is in wake-up period.
 *
 * Values:
 * - 0 - Device in wake-up period.
 * - 1 - Device is ready for initialization.
 */
/*@{*/
#define BP_MMDC_MDMISC_CS1_RDY (30U)       /*!< Bit position for MMDC_MDMISC_CS1_RDY. */
#define BM_MMDC_MDMISC_CS1_RDY (0x40000000U) /*!< Bit mask for MMDC_MDMISC_CS1_RDY. */
#define BS_MMDC_MDMISC_CS1_RDY (1U)        /*!< Bit field size in bits for MMDC_MDMISC_CS1_RDY. */

/*! @brief Read current value of the MMDC_MDMISC_CS1_RDY field. */
#define BR_MMDC_MDMISC_CS1_RDY(x) (HW_MMDC_MDMISC(x).B.CS1_RDY)
/*@}*/

/*!
 * @name Register MMDC_MDMISC, field CS0_RDY[31] (RO)
 *
 * External status device on CS0. This is a read-only status bit, that indicates
 * whether the external memory is in wake-up period.
 *
 * Values:
 * - 0 - Device in wake-up period.
 * - 1 - Device is ready for initialization.
 */
/*@{*/
#define BP_MMDC_MDMISC_CS0_RDY (31U)       /*!< Bit position for MMDC_MDMISC_CS0_RDY. */
#define BM_MMDC_MDMISC_CS0_RDY (0x80000000U) /*!< Bit mask for MMDC_MDMISC_CS0_RDY. */
#define BS_MMDC_MDMISC_CS0_RDY (1U)        /*!< Bit field size in bits for MMDC_MDMISC_CS0_RDY. */

/*! @brief Read current value of the MMDC_MDMISC_CS0_RDY field. */
#define BR_MMDC_MDMISC_CS0_RDY(x) (HW_MMDC_MDMISC(x).B.CS0_RDY)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDSCR - MMDC Core Special Command Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDSCR - MMDC Core Special Command Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to issue special commands manually toward the external
 * DDR device (such as load mode register, manual self refresh, manual precharge
 * and so on). Every write to this register will be interpreted as a command, and
 * a read from this register will show the last command that was executed. Every
 * write to this register will result in one special command, and the IP bus
 * will assert ips_xfr_wait as long as the special command is being carried out.
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdscr
{
    uint32_t U;
    struct _hw_mmdc_mdscr_bitfields
    {
        uint32_t CMD_BA : 3;           /*!< [2:0]  */
        uint32_t CMD_CS : 1;           /*!< [3]  */
        uint32_t CMD : 3;              /*!< [6:4]  */
        uint32_t RESERVED0 : 2;        /*!< [8:7]  */
        uint32_t WL_EN : 1;            /*!< [9]  */
        uint32_t MRR_READ_DATA_VALID : 1; /*!< [10]  */
        uint32_t RESERVED1 : 3;        /*!< [13:11]  */
        uint32_t CON_ACK : 1;          /*!< [14]  */
        uint32_t CON_REQ : 1;          /*!< [15]  */
        uint32_t CMD_ADDR_LSB_MR_ADDR : 8; /*!< [23:16]  */
        uint32_t CMD_ADDR_MSB_MR_OP : 8; /*!< [31:24]  */
    } B;
} hw_mmdc_mdscr_t;

/*!
 * @name Constants and macros for entire MMDC_MDSCR register
 */
/*@{*/
#define HW_MMDC_MDSCR_ADDR(x)    ((uintptr_t)(x) + 0x1CU)

#define HW_MMDC_MDSCR(x)         (*(__IO hw_mmdc_mdscr_t *) HW_MMDC_MDSCR_ADDR(x))
#define HW_MMDC_MDSCR_RD(x)      (HW_MMDC_MDSCR(x).U)
#define HW_MMDC_MDSCR_WR(x, v)   (HW_MMDC_MDSCR(x).U = (v))
#define HW_MMDC_MDSCR_SET(x, v)  (HW_MMDC_MDSCR_WR(x, HW_MMDC_MDSCR_RD(x) |  (v)))
#define HW_MMDC_MDSCR_CLR(x, v)  (HW_MMDC_MDSCR_WR(x, HW_MMDC_MDSCR_RD(x) & ~(v)))
#define HW_MMDC_MDSCR_TOG(x, v)  (HW_MMDC_MDSCR_WR(x, HW_MMDC_MDSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDSCR bitfields
 */

/*!
 * @name Register MMDC_MDSCR, field CMD_BA[2:0] (RW)
 *
 * Bank Address. This field determines the address of the bank within the
 * selected chip-select where the command is targetted to.
 *
 * Values:
 * - 0 - bank address 0
 * - 1 - bank address 1
 * - 10 - bank address 2
 * - 111 - bank address 7
 */
/*@{*/
#define BP_MMDC_MDSCR_CMD_BA (0U)          /*!< Bit position for MMDC_MDSCR_CMD_BA. */
#define BM_MMDC_MDSCR_CMD_BA (0x00000007U) /*!< Bit mask for MMDC_MDSCR_CMD_BA. */
#define BS_MMDC_MDSCR_CMD_BA (3U)          /*!< Bit field size in bits for MMDC_MDSCR_CMD_BA. */

/*! @brief Read current value of the MMDC_MDSCR_CMD_BA field. */
#define BR_MMDC_MDSCR_CMD_BA(x) (HW_MMDC_MDSCR(x).B.CMD_BA)

/*! @brief Format value for bitfield MMDC_MDSCR_CMD_BA. */
#define BF_MMDC_MDSCR_CMD_BA(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CMD_BA) & BM_MMDC_MDSCR_CMD_BA)

/*! @brief Set the CMD_BA field to a new value. */
#define BW_MMDC_MDSCR_CMD_BA(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CMD_BA) | BF_MMDC_MDSCR_CMD_BA(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CMD_CS[3] (RW)
 *
 * Chip Select. This field determines which chip select the command is targeted
 * to
 *
 * Values:
 * - 0 - to Chip-select 0
 * - 1 - to Chip-select 1
 */
/*@{*/
#define BP_MMDC_MDSCR_CMD_CS (3U)          /*!< Bit position for MMDC_MDSCR_CMD_CS. */
#define BM_MMDC_MDSCR_CMD_CS (0x00000008U) /*!< Bit mask for MMDC_MDSCR_CMD_CS. */
#define BS_MMDC_MDSCR_CMD_CS (1U)          /*!< Bit field size in bits for MMDC_MDSCR_CMD_CS. */

/*! @brief Read current value of the MMDC_MDSCR_CMD_CS field. */
#define BR_MMDC_MDSCR_CMD_CS(x) (HW_MMDC_MDSCR(x).B.CMD_CS)

/*! @brief Format value for bitfield MMDC_MDSCR_CMD_CS. */
#define BF_MMDC_MDSCR_CMD_CS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CMD_CS) & BM_MMDC_MDSCR_CMD_CS)

/*! @brief Set the CMD_CS field to a new value. */
#define BW_MMDC_MDSCR_CMD_CS(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CMD_CS) | BF_MMDC_MDSCR_CMD_CS(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CMD[6:4] (RW)
 *
 * Command. This field contains the command to be executed. This field will be
 * automatically cleared after the command will be send to the DDR memory.
 *
 * Values:
 * - 0 - Normal operation
 * - 1 - Precharge all, command is sent independently of bank status (set
 *     correct CMD_CS). Will be issued even if banks are closed. Mainly used for init
 *     sequence purpose.
 * - 10 - Auto-Refresh Command (set correct CMD_CS).
 * - 11 - Load Mode Register Command ( DDR3, set correct CMD_CS, CMD_BA,
 *     CMD_ADDR_LSB, CMD_ADDR_MSB), MRW Command (LPDDR2, set correct CMD_CS, MR_OP,
 *     MR_ADDR)
 * - 100 - ZQ calibration ( DDR3, set correct CMD_CS,
 *     {CMD_ADDR_MSB,CMD_ADDR_LSB} = 0x400 or 0x0 )
 * - 101 - Precharge all, only if banks open (set correct CMD_CS).
 * - 110 - MRR command (LPDDR2, set correct CMD_CS, MR_ADDR)
 * - 111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDSCR_CMD    (4U)          /*!< Bit position for MMDC_MDSCR_CMD. */
#define BM_MMDC_MDSCR_CMD    (0x00000070U) /*!< Bit mask for MMDC_MDSCR_CMD. */
#define BS_MMDC_MDSCR_CMD    (3U)          /*!< Bit field size in bits for MMDC_MDSCR_CMD. */

/*! @brief Read current value of the MMDC_MDSCR_CMD field. */
#define BR_MMDC_MDSCR_CMD(x) (HW_MMDC_MDSCR(x).B.CMD)

/*! @brief Format value for bitfield MMDC_MDSCR_CMD. */
#define BF_MMDC_MDSCR_CMD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CMD) & BM_MMDC_MDSCR_CMD)

/*! @brief Set the CMD field to a new value. */
#define BW_MMDC_MDSCR_CMD(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CMD) | BF_MMDC_MDSCR_CMD(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field WL_EN[9] (RW)
 *
 * DQS pads direction. This bit controls the DQS pads direction during
 * write-leveling calibration process. Before starting the write-leveling calibration
 * process this bit should be set to "1". It should be set to "0" when sending write
 * leveling exit command. For further information see Write leveling Calibration
 * Write leveling calibration can be executed automatically(HW) or manually (SW).
 * .
 *
 * Values:
 * - 0 - Exit write leveling mode or stay in normal mode.
 * - 1 - Write leveling entry command was sent.
 */
/*@{*/
#define BP_MMDC_MDSCR_WL_EN  (9U)          /*!< Bit position for MMDC_MDSCR_WL_EN. */
#define BM_MMDC_MDSCR_WL_EN  (0x00000200U) /*!< Bit mask for MMDC_MDSCR_WL_EN. */
#define BS_MMDC_MDSCR_WL_EN  (1U)          /*!< Bit field size in bits for MMDC_MDSCR_WL_EN. */

/*! @brief Read current value of the MMDC_MDSCR_WL_EN field. */
#define BR_MMDC_MDSCR_WL_EN(x) (HW_MMDC_MDSCR(x).B.WL_EN)

/*! @brief Format value for bitfield MMDC_MDSCR_WL_EN. */
#define BF_MMDC_MDSCR_WL_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_WL_EN) & BM_MMDC_MDSCR_WL_EN)

/*! @brief Set the WL_EN field to a new value. */
#define BW_MMDC_MDSCR_WL_EN(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_WL_EN) | BF_MMDC_MDSCR_WL_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field MRR_READ_DATA_VALID[10] (RO)
 *
 * MRR read data valid. This field indicates that read data is valid at MDMRR
 * register This field is relevant only for LPDDR2 mode
 *
 * Values:
 * - 0 - Cleared upon the assertion of MRR command
 * - 1 - Set after MRR data is valid and stored at MDMRR register.
 */
/*@{*/
#define BP_MMDC_MDSCR_MRR_READ_DATA_VALID (10U) /*!< Bit position for MMDC_MDSCR_MRR_READ_DATA_VALID. */
#define BM_MMDC_MDSCR_MRR_READ_DATA_VALID (0x00000400U) /*!< Bit mask for MMDC_MDSCR_MRR_READ_DATA_VALID. */
#define BS_MMDC_MDSCR_MRR_READ_DATA_VALID (1U) /*!< Bit field size in bits for MMDC_MDSCR_MRR_READ_DATA_VALID. */

/*! @brief Read current value of the MMDC_MDSCR_MRR_READ_DATA_VALID field. */
#define BR_MMDC_MDSCR_MRR_READ_DATA_VALID(x) (HW_MMDC_MDSCR(x).B.MRR_READ_DATA_VALID)
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CON_ACK[14] (RO)
 *
 * Configuration acknowledge. Whenever this bit is set, it is permitted to
 * configure MMDC IP registers.
 *
 * Values:
 * - 0 - Configuration of MMDC registers is forbidden.
 * - 1 - Configuration of MMDC registers is permitted.
 */
/*@{*/
#define BP_MMDC_MDSCR_CON_ACK (14U)        /*!< Bit position for MMDC_MDSCR_CON_ACK. */
#define BM_MMDC_MDSCR_CON_ACK (0x00004000U) /*!< Bit mask for MMDC_MDSCR_CON_ACK. */
#define BS_MMDC_MDSCR_CON_ACK (1U)         /*!< Bit field size in bits for MMDC_MDSCR_CON_ACK. */

/*! @brief Read current value of the MMDC_MDSCR_CON_ACK field. */
#define BR_MMDC_MDSCR_CON_ACK(x) (HW_MMDC_MDSCR(x).B.CON_ACK)
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CON_REQ[15] (RW)
 *
 * Configuration request. When this bit is set then the MMDC will clean the
 * pending AXI accesses and will prevent from further AXI accesses to be
 * acknowledged. This field guarantee safe configuration (or change configuration) of the
 * MMDC while no access is in process and prevents an unexpected behaviour. After
 * setting this bit, it is needed to poll on CON_ACK until it is set to "1". When
 * CON_ACK is asserted then configuration is permitted. After configuration is
 * completed then this bit must be deasserted in order to process further AXI
 * accesses. This bit is asserted at the end of the reset sequence, meaning that the
 * MMDC is waiting to configure and intialize the external memory before accepting
 * any AXI accesses. Configuration request/acknowledge mechanism should be used
 * for the following procedures: changing of timing parameters , during
 * calibration process or driving commands via MDSCR[CMD]
 *
 * Values:
 * - 0 - No request to configure MMDC.
 * - 1 - A request to configure MMDC is valid
 */
/*@{*/
#define BP_MMDC_MDSCR_CON_REQ (15U)        /*!< Bit position for MMDC_MDSCR_CON_REQ. */
#define BM_MMDC_MDSCR_CON_REQ (0x00008000U) /*!< Bit mask for MMDC_MDSCR_CON_REQ. */
#define BS_MMDC_MDSCR_CON_REQ (1U)         /*!< Bit field size in bits for MMDC_MDSCR_CON_REQ. */

/*! @brief Read current value of the MMDC_MDSCR_CON_REQ field. */
#define BR_MMDC_MDSCR_CON_REQ(x) (HW_MMDC_MDSCR(x).B.CON_REQ)

/*! @brief Format value for bitfield MMDC_MDSCR_CON_REQ. */
#define BF_MMDC_MDSCR_CON_REQ(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CON_REQ) & BM_MMDC_MDSCR_CON_REQ)

/*! @brief Set the CON_REQ field to a new value. */
#define BW_MMDC_MDSCR_CON_REQ(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CON_REQ) | BF_MMDC_MDSCR_CON_REQ(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CMD_ADDR_LSB_MR_ADDR[23:16] (RW)
 *
 * Command/Address LSB. This field indicates the LSB of the command/Address In
 * LPDDR2 this field indicates the MRR/MRW address
 */
/*@{*/
#define BP_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR (16U) /*!< Bit position for MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR. */
#define BM_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR (0x00FF0000U) /*!< Bit mask for MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR. */
#define BS_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR (8U) /*!< Bit field size in bits for MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR. */

/*! @brief Read current value of the MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR field. */
#define BR_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR(x) (HW_MMDC_MDSCR(x).B.CMD_ADDR_LSB_MR_ADDR)

/*! @brief Format value for bitfield MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR. */
#define BF_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR) & BM_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR)

/*! @brief Set the CMD_ADDR_LSB_MR_ADDR field to a new value. */
#define BW_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR) | BF_MMDC_MDSCR_CMD_ADDR_LSB_MR_ADDR(v)))
/*@}*/

/*!
 * @name Register MMDC_MDSCR, field CMD_ADDR_MSB_MR_OP[31:24] (RW)
 *
 * Command/Address MSB. This field indicates the MSB of the command/Address. In
 * LPDDR2 this field indicates the MRW operand
 */
/*@{*/
#define BP_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP (24U) /*!< Bit position for MMDC_MDSCR_CMD_ADDR_MSB_MR_OP. */
#define BM_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP (0xFF000000U) /*!< Bit mask for MMDC_MDSCR_CMD_ADDR_MSB_MR_OP. */
#define BS_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP (8U) /*!< Bit field size in bits for MMDC_MDSCR_CMD_ADDR_MSB_MR_OP. */

/*! @brief Read current value of the MMDC_MDSCR_CMD_ADDR_MSB_MR_OP field. */
#define BR_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP(x) (HW_MMDC_MDSCR(x).B.CMD_ADDR_MSB_MR_OP)

/*! @brief Format value for bitfield MMDC_MDSCR_CMD_ADDR_MSB_MR_OP. */
#define BF_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP) & BM_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP)

/*! @brief Set the CMD_ADDR_MSB_MR_OP field to a new value. */
#define BW_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP(x, v) (HW_MMDC_MDSCR_WR(x, (HW_MMDC_MDSCR_RD(x) & ~BM_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP) | BF_MMDC_MDSCR_CMD_ADDR_MSB_MR_OP(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDREF - MMDC Core Refresh Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDREF - MMDC Core Refresh Control Register (RW)
 *
 * Reset value: 0x0000C000U
 *
 * This register determines the refresh scheme that will be executed toward the
 * DDR device. It specifies how often a refresh cycle occurs and how many refresh
 * commands will be executed every refresh cycle. For further information see
 * Refresh SchemeThe MMDC supports various automatic refresh options which can be
 * configured via the MDREF register. . The following tables show examples of
 * possible refresh schemes. Refresh rate example for REF_SEL = 0 REFR[2:0] Number of
 * refresh commands every 64KHz Average periodic refresh rate (tREFI) System
 * Refresh period 0x0 1 15.6 us tRFC 0x1 2 7.8 us 2*tRFC 0x3 4 3.9us 4*tRFC 0x7 8
 * 1.95 us 8*tRFC Refresh rate example for REF_SEL = 1 REFR[2:0] Number of refresh
 * commands every 32KHz Average periodic refresh rate (tREFI) System Refresh
 * period 0x1 2 15.6 us 2*tRFC 0x3 4 7.8 us 4*tRFC 0x7 8 3.9us 8*tRFC Refresh rate
 * example for REF_SEL = 2@ 400MHz REFR[2:0] Number of refresh commands every
 * refresh cycle REF_CNT Average periodic refresh rate (tREFI) System Refresh period
 * 0x0 1 0x618 3.9 us tRFC 0x1 2 0xC30 3.9 us 2*tRFC 0x2 3 0x1248 3.9us 3*tRFC 0x3
 * 4 0x1860 3.9 us 4*tRFC Other refresh configurations are also allowed; the
 * configuration values in the tables above are only examples for obtaining the
 * desired average periodic refresh rate. If the required average periodic refresh
 * rate (tREFI) is kept, all of the rows will be refreshed in every refresh window.
 * Because the memory device issues additional refresh commands for every
 * refresh it receives, the tREFI remains the same across the device, regardless of its
 * number of rows. This is particularly relevant in the tRFC parameter, which
 * becomes bigger as the density increases. Supported Mode Of Operations: For
 * Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mdref
{
    uint32_t U;
    struct _hw_mmdc_mdref_bitfields
    {
        uint32_t START_REF : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 10;       /*!< [10:1]  */
        uint32_t REFR : 3;             /*!< [13:11]  */
        uint32_t REF_SEL : 2;          /*!< [15:14]  */
        uint32_t REF_CNT : 16;         /*!< [31:16]  */
    } B;
} hw_mmdc_mdref_t;

/*!
 * @name Constants and macros for entire MMDC_MDREF register
 */
/*@{*/
#define HW_MMDC_MDREF_ADDR(x)    ((uintptr_t)(x) + 0x20U)

#define HW_MMDC_MDREF(x)         (*(__IO hw_mmdc_mdref_t *) HW_MMDC_MDREF_ADDR(x))
#define HW_MMDC_MDREF_RD(x)      (HW_MMDC_MDREF(x).U)
#define HW_MMDC_MDREF_WR(x, v)   (HW_MMDC_MDREF(x).U = (v))
#define HW_MMDC_MDREF_SET(x, v)  (HW_MMDC_MDREF_WR(x, HW_MMDC_MDREF_RD(x) |  (v)))
#define HW_MMDC_MDREF_CLR(x, v)  (HW_MMDC_MDREF_WR(x, HW_MMDC_MDREF_RD(x) & ~(v)))
#define HW_MMDC_MDREF_TOG(x, v)  (HW_MMDC_MDREF_WR(x, HW_MMDC_MDREF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDREF bitfields
 */

/*!
 * @name Register MMDC_MDREF, field START_REF[0] (RW)
 *
 * Manual start of refresh cycle. When this field is set to '1' the MMDC will
 * start a refresh cycle immediately according to number of refresh commands that
 * are configured in 'REFR' field. This bit returns to zero automatically.
 *
 * Values:
 * - 0 - Do nothing.
 * - 1 - Start a refresh cycle.
 */
/*@{*/
#define BP_MMDC_MDREF_START_REF (0U)       /*!< Bit position for MMDC_MDREF_START_REF. */
#define BM_MMDC_MDREF_START_REF (0x00000001U) /*!< Bit mask for MMDC_MDREF_START_REF. */
#define BS_MMDC_MDREF_START_REF (1U)       /*!< Bit field size in bits for MMDC_MDREF_START_REF. */

/*! @brief Read current value of the MMDC_MDREF_START_REF field. */
#define BR_MMDC_MDREF_START_REF(x) (HW_MMDC_MDREF(x).B.START_REF)

/*! @brief Format value for bitfield MMDC_MDREF_START_REF. */
#define BF_MMDC_MDREF_START_REF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDREF_START_REF) & BM_MMDC_MDREF_START_REF)

/*! @brief Set the START_REF field to a new value. */
#define BW_MMDC_MDREF_START_REF(x, v) (HW_MMDC_MDREF_WR(x, (HW_MMDC_MDREF_RD(x) & ~BM_MMDC_MDREF_START_REF) | BF_MMDC_MDREF_START_REF(v)))
/*@}*/

/*!
 * @name Register MMDC_MDREF, field REFR[13:11] (RW)
 *
 * Refresh Rate. This field determines how many refresh commands will be issued
 * every refresh cycle. After every refresh command the MMDC won't drive any
 * command to the DDR device untill satisfying tRFC period
 *
 * Values:
 * - 0 - 1 refresh
 * - 1 - 2 refreshes
 * - 10 - 3 refreshes
 * - 11 - 4 refreshes
 * - 100 - 5 refreshes
 * - 101 - 6 refreshes
 * - 110 - 7 refreshes
 * - 111 - 8 refreshes
 */
/*@{*/
#define BP_MMDC_MDREF_REFR   (11U)         /*!< Bit position for MMDC_MDREF_REFR. */
#define BM_MMDC_MDREF_REFR   (0x00003800U) /*!< Bit mask for MMDC_MDREF_REFR. */
#define BS_MMDC_MDREF_REFR   (3U)          /*!< Bit field size in bits for MMDC_MDREF_REFR. */

/*! @brief Read current value of the MMDC_MDREF_REFR field. */
#define BR_MMDC_MDREF_REFR(x) (HW_MMDC_MDREF(x).B.REFR)

/*! @brief Format value for bitfield MMDC_MDREF_REFR. */
#define BF_MMDC_MDREF_REFR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDREF_REFR) & BM_MMDC_MDREF_REFR)

/*! @brief Set the REFR field to a new value. */
#define BW_MMDC_MDREF_REFR(x, v) (HW_MMDC_MDREF_WR(x, (HW_MMDC_MDREF_RD(x) & ~BM_MMDC_MDREF_REFR) | BF_MMDC_MDREF_REFR(v)))
/*@}*/

/*!
 * @name Register MMDC_MDREF, field REF_SEL[15:14] (RW)
 *
 * Refresh Selector. This bit selects the source of the clock that will trigger
 * each refresh cycle:
 *
 * Values:
 * - 0 - Periodic refresh cycles will be triggered in frequency of 64KHz.
 * - 1 - Periodic refresh cycles will be triggered in frequency of 32KHz.
 */
/*@{*/
#define BP_MMDC_MDREF_REF_SEL (14U)        /*!< Bit position for MMDC_MDREF_REF_SEL. */
#define BM_MMDC_MDREF_REF_SEL (0x0000C000U) /*!< Bit mask for MMDC_MDREF_REF_SEL. */
#define BS_MMDC_MDREF_REF_SEL (2U)         /*!< Bit field size in bits for MMDC_MDREF_REF_SEL. */

/*! @brief Read current value of the MMDC_MDREF_REF_SEL field. */
#define BR_MMDC_MDREF_REF_SEL(x) (HW_MMDC_MDREF(x).B.REF_SEL)

/*! @brief Format value for bitfield MMDC_MDREF_REF_SEL. */
#define BF_MMDC_MDREF_REF_SEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDREF_REF_SEL) & BM_MMDC_MDREF_REF_SEL)

/*! @brief Set the REF_SEL field to a new value. */
#define BW_MMDC_MDREF_REF_SEL(x, v) (HW_MMDC_MDREF_WR(x, (HW_MMDC_MDREF_RD(x) & ~BM_MMDC_MDREF_REF_SEL) | BF_MMDC_MDREF_REF_SEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MDREF, field REF_CNT[31:16] (RW)
 *
 * Refresh Counter at DDR clock period If REF_SEL equals '2' a refresh cycle
 * will begin every amount of DDR cycles configured in this field.
 *
 * Values:
 * - 0 - Reserved.
 * - 1 - 1 cycle.
 * - 1111111111111110 - 65534 cycles.
 * - 1111111111111111 - 65535 cycles.
 */
/*@{*/
#define BP_MMDC_MDREF_REF_CNT (16U)        /*!< Bit position for MMDC_MDREF_REF_CNT. */
#define BM_MMDC_MDREF_REF_CNT (0xFFFF0000U) /*!< Bit mask for MMDC_MDREF_REF_CNT. */
#define BS_MMDC_MDREF_REF_CNT (16U)        /*!< Bit field size in bits for MMDC_MDREF_REF_CNT. */

/*! @brief Read current value of the MMDC_MDREF_REF_CNT field. */
#define BR_MMDC_MDREF_REF_CNT(x) (HW_MMDC_MDREF(x).B.REF_CNT)

/*! @brief Format value for bitfield MMDC_MDREF_REF_CNT. */
#define BF_MMDC_MDREF_REF_CNT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDREF_REF_CNT) & BM_MMDC_MDREF_REF_CNT)

/*! @brief Set the REF_CNT field to a new value. */
#define BW_MMDC_MDREF_REF_CNT(x, v) (HW_MMDC_MDREF_WR(x, (HW_MMDC_MDREF_RD(x) & ~BM_MMDC_MDREF_REF_CNT) | BF_MMDC_MDREF_REF_CNT(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDRWD - MMDC Core Read/Write Command Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDRWD - MMDC Core Read/Write Command Delay Register (RW)
 *
 * Reset value: 0x0F9F26D2U
 *
 * This register determines the delay between back to back read and write
 * accesses. The register reset values are set to the minimum required value. As the
 * default values are set to achieve optimal results, changing them is discouraged.
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdrwd
{
    uint32_t U;
    struct _hw_mmdc_mdrwd_bitfields
    {
        uint32_t RTR_DIFF : 3;         /*!< [2:0]  */
        uint32_t RTW_DIFF : 3;         /*!< [5:3]  */
        uint32_t WTW_DIFF : 3;         /*!< [8:6]  */
        uint32_t WTR_DIFF : 3;         /*!< [11:9]  */
        uint32_t RTW_SAME : 3;         /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t tDAI : 13;            /*!< [28:16]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_mmdc_mdrwd_t;

/*!
 * @name Constants and macros for entire MMDC_MDRWD register
 */
/*@{*/
#define HW_MMDC_MDRWD_ADDR(x)    ((uintptr_t)(x) + 0x2CU)

#define HW_MMDC_MDRWD(x)         (*(__IO hw_mmdc_mdrwd_t *) HW_MMDC_MDRWD_ADDR(x))
#define HW_MMDC_MDRWD_RD(x)      (HW_MMDC_MDRWD(x).U)
#define HW_MMDC_MDRWD_WR(x, v)   (HW_MMDC_MDRWD(x).U = (v))
#define HW_MMDC_MDRWD_SET(x, v)  (HW_MMDC_MDRWD_WR(x, HW_MMDC_MDRWD_RD(x) |  (v)))
#define HW_MMDC_MDRWD_CLR(x, v)  (HW_MMDC_MDRWD_WR(x, HW_MMDC_MDRWD_RD(x) & ~(v)))
#define HW_MMDC_MDRWD_TOG(x, v)  (HW_MMDC_MDRWD_WR(x, HW_MMDC_MDRWD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDRWD bitfields
 */

/*!
 * @name Register MMDC_MDRWD, field RTR_DIFF[2:0] (RW)
 *
 * Read to read delay for different chip-select. This field controls the delay
 * between read to read commands toward different chip select. The total delay is
 * calculated according to: BL/2 + RTR_DIFF
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycle
 * - 10 - 2 cycles (Default)
 * - 11 - 3 cycles
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_RTR_DIFF (0U)        /*!< Bit position for MMDC_MDRWD_RTR_DIFF. */
#define BM_MMDC_MDRWD_RTR_DIFF (0x00000007U) /*!< Bit mask for MMDC_MDRWD_RTR_DIFF. */
#define BS_MMDC_MDRWD_RTR_DIFF (3U)        /*!< Bit field size in bits for MMDC_MDRWD_RTR_DIFF. */

/*! @brief Read current value of the MMDC_MDRWD_RTR_DIFF field. */
#define BR_MMDC_MDRWD_RTR_DIFF(x) (HW_MMDC_MDRWD(x).B.RTR_DIFF)

/*! @brief Format value for bitfield MMDC_MDRWD_RTR_DIFF. */
#define BF_MMDC_MDRWD_RTR_DIFF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_RTR_DIFF) & BM_MMDC_MDRWD_RTR_DIFF)

/*! @brief Set the RTR_DIFF field to a new value. */
#define BW_MMDC_MDRWD_RTR_DIFF(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_RTR_DIFF) | BF_MMDC_MDRWD_RTR_DIFF(v)))
/*@}*/

/*!
 * @name Register MMDC_MDRWD, field RTW_DIFF[5:3] (RW)
 *
 * Read to write delay for different chip-select. This field controls the delay
 * between read to write commands toward different chip select. The total delay
 * is calculated according to: BL/2 + RTW_DIFF + (tCL - tCWL) + RALAT
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycle
 * - 10 - 2 cycles (Default)
 * - 11 - 3 cycles
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_RTW_DIFF (3U)        /*!< Bit position for MMDC_MDRWD_RTW_DIFF. */
#define BM_MMDC_MDRWD_RTW_DIFF (0x00000038U) /*!< Bit mask for MMDC_MDRWD_RTW_DIFF. */
#define BS_MMDC_MDRWD_RTW_DIFF (3U)        /*!< Bit field size in bits for MMDC_MDRWD_RTW_DIFF. */

/*! @brief Read current value of the MMDC_MDRWD_RTW_DIFF field. */
#define BR_MMDC_MDRWD_RTW_DIFF(x) (HW_MMDC_MDRWD(x).B.RTW_DIFF)

/*! @brief Format value for bitfield MMDC_MDRWD_RTW_DIFF. */
#define BF_MMDC_MDRWD_RTW_DIFF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_RTW_DIFF) & BM_MMDC_MDRWD_RTW_DIFF)

/*! @brief Set the RTW_DIFF field to a new value. */
#define BW_MMDC_MDRWD_RTW_DIFF(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_RTW_DIFF) | BF_MMDC_MDRWD_RTW_DIFF(v)))
/*@}*/

/*!
 * @name Register MMDC_MDRWD, field WTW_DIFF[8:6] (RW)
 *
 * Write to write delay for different chip-select. This field controls the delay
 * between write to write commands toward different chip select. The total delay
 * is calculated according to: BL/2 + WTW_DIFF
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycle
 * - 10 - 2 cycles
 * - 11 - 3 cycles (Default)
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_WTW_DIFF (6U)        /*!< Bit position for MMDC_MDRWD_WTW_DIFF. */
#define BM_MMDC_MDRWD_WTW_DIFF (0x000001C0U) /*!< Bit mask for MMDC_MDRWD_WTW_DIFF. */
#define BS_MMDC_MDRWD_WTW_DIFF (3U)        /*!< Bit field size in bits for MMDC_MDRWD_WTW_DIFF. */

/*! @brief Read current value of the MMDC_MDRWD_WTW_DIFF field. */
#define BR_MMDC_MDRWD_WTW_DIFF(x) (HW_MMDC_MDRWD(x).B.WTW_DIFF)

/*! @brief Format value for bitfield MMDC_MDRWD_WTW_DIFF. */
#define BF_MMDC_MDRWD_WTW_DIFF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_WTW_DIFF) & BM_MMDC_MDRWD_WTW_DIFF)

/*! @brief Set the WTW_DIFF field to a new value. */
#define BW_MMDC_MDRWD_WTW_DIFF(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_WTW_DIFF) | BF_MMDC_MDRWD_WTW_DIFF(v)))
/*@}*/

/*!
 * @name Register MMDC_MDRWD, field WTR_DIFF[11:9] (RW)
 *
 * Write to read delay for different chip-select. This field controls the delay
 * between write to read commands toward different chip select. The total delay
 * is calculated according to: BL/2 + WTR_DIFF + (tCL-tCWL) + RALAT
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycle
 * - 10 - 2 cycles
 * - 11 - 3 cycles (Default)
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_WTR_DIFF (9U)        /*!< Bit position for MMDC_MDRWD_WTR_DIFF. */
#define BM_MMDC_MDRWD_WTR_DIFF (0x00000E00U) /*!< Bit mask for MMDC_MDRWD_WTR_DIFF. */
#define BS_MMDC_MDRWD_WTR_DIFF (3U)        /*!< Bit field size in bits for MMDC_MDRWD_WTR_DIFF. */

/*! @brief Read current value of the MMDC_MDRWD_WTR_DIFF field. */
#define BR_MMDC_MDRWD_WTR_DIFF(x) (HW_MMDC_MDRWD(x).B.WTR_DIFF)

/*! @brief Format value for bitfield MMDC_MDRWD_WTR_DIFF. */
#define BF_MMDC_MDRWD_WTR_DIFF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_WTR_DIFF) & BM_MMDC_MDRWD_WTR_DIFF)

/*! @brief Set the WTR_DIFF field to a new value. */
#define BW_MMDC_MDRWD_WTR_DIFF(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_WTR_DIFF) | BF_MMDC_MDRWD_WTR_DIFF(v)))
/*@}*/

/*!
 * @name Register MMDC_MDRWD, field RTW_SAME[14:12] (RW)
 *
 * Read to write delay for the same chip-select. This field controls the delay
 * between read to write commands toward the same chip select. The total delay is
 * calculated according to: BL/2 + RTW_SAME + (tCL-tCWL) + RALAT
 *
 * Values:
 * - 0 - 0 cycle
 * - 1 - 1 cycle
 * - 10 - 2 cycles (Default)
 * - 11 - 3 cycles
 * - 100 - 4 cycles
 * - 101 - 5 cycles
 * - 110 - 6 cycles
 * - 111 - 7 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_RTW_SAME (12U)       /*!< Bit position for MMDC_MDRWD_RTW_SAME. */
#define BM_MMDC_MDRWD_RTW_SAME (0x00007000U) /*!< Bit mask for MMDC_MDRWD_RTW_SAME. */
#define BS_MMDC_MDRWD_RTW_SAME (3U)        /*!< Bit field size in bits for MMDC_MDRWD_RTW_SAME. */

/*! @brief Read current value of the MMDC_MDRWD_RTW_SAME field. */
#define BR_MMDC_MDRWD_RTW_SAME(x) (HW_MMDC_MDRWD(x).B.RTW_SAME)

/*! @brief Format value for bitfield MMDC_MDRWD_RTW_SAME. */
#define BF_MMDC_MDRWD_RTW_SAME(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_RTW_SAME) & BM_MMDC_MDRWD_RTW_SAME)

/*! @brief Set the RTW_SAME field to a new value. */
#define BW_MMDC_MDRWD_RTW_SAME(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_RTW_SAME) | BF_MMDC_MDRWD_RTW_SAME(v)))
/*@}*/

/*!
 * @name Register MMDC_MDRWD, field tDAI[28:16] (RW)
 *
 * Device auto initialization period.(maximum) This field is relevant only to
 * LPDDR2 mode
 *
 * Values:
 * - 0 - 1 cycle
 * - 111110011111 - 4000 cycles (Default, JEDEC value for LPDDR2, gives 10us at
 *     400MHz clock).
 * - 1111111111111 - 8192 cycles
 */
/*@{*/
#define BP_MMDC_MDRWD_tDAI   (16U)         /*!< Bit position for MMDC_MDRWD_tDAI. */
#define BM_MMDC_MDRWD_tDAI   (0x1FFF0000U) /*!< Bit mask for MMDC_MDRWD_tDAI. */
#define BS_MMDC_MDRWD_tDAI   (13U)         /*!< Bit field size in bits for MMDC_MDRWD_tDAI. */

/*! @brief Read current value of the MMDC_MDRWD_tDAI field. */
#define BR_MMDC_MDRWD_tDAI(x) (HW_MMDC_MDRWD(x).B.tDAI)

/*! @brief Format value for bitfield MMDC_MDRWD_tDAI. */
#define BF_MMDC_MDRWD_tDAI(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDRWD_tDAI) & BM_MMDC_MDRWD_tDAI)

/*! @brief Set the tDAI field to a new value. */
#define BW_MMDC_MDRWD_tDAI(x, v) (HW_MMDC_MDRWD_WR(x, (HW_MMDC_MDRWD_RD(x) & ~BM_MMDC_MDRWD_tDAI) | BF_MMDC_MDRWD_tDAI(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDOR - MMDC Core Out of Reset Delays Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDOR - MMDC Core Out of Reset Delays Register (RW)
 *
 * Reset value: 0x009F0E0EU
 *
 * This register defines delays that must be kept when MMDC exits reset.
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdor
{
    uint32_t U;
    struct _hw_mmdc_mdor_bitfields
    {
        uint32_t RST_to_CKE : 6;       /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t SDE_to_RST : 6;       /*!< [13:8]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t tXPR : 8;             /*!< [23:16]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_mmdc_mdor_t;

/*!
 * @name Constants and macros for entire MMDC_MDOR register
 */
/*@{*/
#define HW_MMDC_MDOR_ADDR(x)     ((uintptr_t)(x) + 0x30U)

#define HW_MMDC_MDOR(x)          (*(__IO hw_mmdc_mdor_t *) HW_MMDC_MDOR_ADDR(x))
#define HW_MMDC_MDOR_RD(x)       (HW_MMDC_MDOR(x).U)
#define HW_MMDC_MDOR_WR(x, v)    (HW_MMDC_MDOR(x).U = (v))
#define HW_MMDC_MDOR_SET(x, v)   (HW_MMDC_MDOR_WR(x, HW_MMDC_MDOR_RD(x) |  (v)))
#define HW_MMDC_MDOR_CLR(x, v)   (HW_MMDC_MDOR_WR(x, HW_MMDC_MDOR_RD(x) & ~(v)))
#define HW_MMDC_MDOR_TOG(x, v)   (HW_MMDC_MDOR_WR(x, HW_MMDC_MDOR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDOR bitfields
 */

/*!
 * @name Register MMDC_MDOR, field RST_to_CKE[5:0] (RW)
 *
 * DDR3: Time from SDE enable to CKE rise. In case that DDR reset# is low, will
 * wait until it's high and thenwait this period until rising CKE. (JEDEC value
 * is 500 us) LPDDR2: Idle time ater first CKE assertion. (JEDEC value is 200 us)
 * Each cycle in this field is 15.258 us.
 *
 * Values:
 * - 0 - Reserved
 * - 1 - Reserved
 * - 10 - Reserved
 * - 11 - 1 cycles
 * - 10000 - 14 cycles (JEDEC value for LPDDR2) - total of 200 us
 * - 100011 - 33 cycles (JEDEC value for DDR3) - total of 500 us
 * - 111110 - 60 cycles
 * - 111111 - 61 cycles
 */
/*@{*/
#define BP_MMDC_MDOR_RST_to_CKE (0U)       /*!< Bit position for MMDC_MDOR_RST_to_CKE. */
#define BM_MMDC_MDOR_RST_to_CKE (0x0000003FU) /*!< Bit mask for MMDC_MDOR_RST_to_CKE. */
#define BS_MMDC_MDOR_RST_to_CKE (6U)       /*!< Bit field size in bits for MMDC_MDOR_RST_to_CKE. */

/*! @brief Read current value of the MMDC_MDOR_RST_to_CKE field. */
#define BR_MMDC_MDOR_RST_to_CKE(x) (HW_MMDC_MDOR(x).B.RST_to_CKE)

/*! @brief Format value for bitfield MMDC_MDOR_RST_to_CKE. */
#define BF_MMDC_MDOR_RST_to_CKE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOR_RST_to_CKE) & BM_MMDC_MDOR_RST_to_CKE)

/*! @brief Set the RST_to_CKE field to a new value. */
#define BW_MMDC_MDOR_RST_to_CKE(x, v) (HW_MMDC_MDOR_WR(x, (HW_MMDC_MDOR_RD(x) & ~BM_MMDC_MDOR_RST_to_CKE) | BF_MMDC_MDOR_RST_to_CKE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOR, field SDE_to_RST[13:8] (RW)
 *
 * DDR3: Time from SDE enable until DDR reset# is high. In LPDDR2 mode this
 * field is not relevant . Each cycle in this field is 15.258 us.
 *
 * Values:
 * - 0 - Reserved
 * - 1 - Reserved
 * - 10 - Reserved
 * - 11 - 1 cycles
 * - 100 - 2 cycles
 * - 10000 - 14 cycles (Jedec value for DDR3) - total of 200 us
 * - 111110 - 60 cycles
 * - 111111 - 61 cycles
 */
/*@{*/
#define BP_MMDC_MDOR_SDE_to_RST (8U)       /*!< Bit position for MMDC_MDOR_SDE_to_RST. */
#define BM_MMDC_MDOR_SDE_to_RST (0x00003F00U) /*!< Bit mask for MMDC_MDOR_SDE_to_RST. */
#define BS_MMDC_MDOR_SDE_to_RST (6U)       /*!< Bit field size in bits for MMDC_MDOR_SDE_to_RST. */

/*! @brief Read current value of the MMDC_MDOR_SDE_to_RST field. */
#define BR_MMDC_MDOR_SDE_to_RST(x) (HW_MMDC_MDOR(x).B.SDE_to_RST)

/*! @brief Format value for bitfield MMDC_MDOR_SDE_to_RST. */
#define BF_MMDC_MDOR_SDE_to_RST(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOR_SDE_to_RST) & BM_MMDC_MDOR_SDE_to_RST)

/*! @brief Set the SDE_to_RST field to a new value. */
#define BW_MMDC_MDOR_SDE_to_RST(x, v) (HW_MMDC_MDOR_WR(x, (HW_MMDC_MDOR_RD(x) & ~BM_MMDC_MDOR_SDE_to_RST) | BF_MMDC_MDOR_SDE_to_RST(v)))
/*@}*/

/*!
 * @name Register MMDC_MDOR, field tXPR[23:16] (RW)
 *
 * DDR3: CKE HIGH to a valid command. LPDDR2: Not relevant to this mode. Please
 * leave in default reset value. DDR3: As defined in timing parameter table.
 *
 * Values:
 * - 0 - Reserved
 * - 1 - 2 cycles
 * - 10 - 3 cycles
 * - 11111110 - 255 cycles
 * - 11111111 - 256 cycles
 */
/*@{*/
#define BP_MMDC_MDOR_tXPR    (16U)         /*!< Bit position for MMDC_MDOR_tXPR. */
#define BM_MMDC_MDOR_tXPR    (0x00FF0000U) /*!< Bit mask for MMDC_MDOR_tXPR. */
#define BS_MMDC_MDOR_tXPR    (8U)          /*!< Bit field size in bits for MMDC_MDOR_tXPR. */

/*! @brief Read current value of the MMDC_MDOR_tXPR field. */
#define BR_MMDC_MDOR_tXPR(x) (HW_MMDC_MDOR(x).B.tXPR)

/*! @brief Format value for bitfield MMDC_MDOR_tXPR. */
#define BF_MMDC_MDOR_tXPR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDOR_tXPR) & BM_MMDC_MDOR_tXPR)

/*! @brief Set the tXPR field to a new value. */
#define BW_MMDC_MDOR_tXPR(x, v) (HW_MMDC_MDOR_WR(x, (HW_MMDC_MDOR_RD(x) & ~BM_MMDC_MDOR_tXPR) | BF_MMDC_MDOR_tXPR(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDMRR - MMDC Core MRR Data Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDMRR - MMDC Core MRR Data Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains data that was collected after issuing MRR command. The
 * data in this register is valid only when MDSCR[MRR_READ_DATA_VALID] is set to
 * "1". This register is relevant only in LPDDR2 mode. For further information
 * see LPDDR2 Refresh Rate Update and Timing DeratingLPDDR2 devices may have a
 * temperature sensor that is used to determine an appropriate refresh rate and
 * whether AC timing derating is required. The status of the temprature sensor can be
 * read through MRR command from LPDDR2 MR4 register. . Supported Mode Of
 * Operations: For Channel 0: LP2_2ch_x16, LP2_2ch_x32 For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdmrr
{
    uint32_t U;
    struct _hw_mmdc_mdmrr_bitfields
    {
        uint32_t MRR_READ_DATA0 : 8;   /*!< [7:0]  */
        uint32_t MRR_READ_DATA1 : 8;   /*!< [15:8]  */
        uint32_t MRR_READ_DATA2 : 8;   /*!< [23:16]  */
        uint32_t MRR_READ_DATA3 : 8;   /*!< [31:24]  */
    } B;
} hw_mmdc_mdmrr_t;

/*!
 * @name Constants and macros for entire MMDC_MDMRR register
 */
/*@{*/
#define HW_MMDC_MDMRR_ADDR(x)    ((uintptr_t)(x) + 0x34U)

#define HW_MMDC_MDMRR(x)         (*(__I hw_mmdc_mdmrr_t *) HW_MMDC_MDMRR_ADDR(x))
#define HW_MMDC_MDMRR_RD(x)      (HW_MMDC_MDMRR(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MDMRR bitfields
 */

/*!
 * @name Register MMDC_MDMRR, field MRR_READ_DATA0[7:0] (RO)
 *
 * MRR DATA that arrived on DQ[7:0]
 */
/*@{*/
#define BP_MMDC_MDMRR_MRR_READ_DATA0 (0U)  /*!< Bit position for MMDC_MDMRR_MRR_READ_DATA0. */
#define BM_MMDC_MDMRR_MRR_READ_DATA0 (0x000000FFU) /*!< Bit mask for MMDC_MDMRR_MRR_READ_DATA0. */
#define BS_MMDC_MDMRR_MRR_READ_DATA0 (8U)  /*!< Bit field size in bits for MMDC_MDMRR_MRR_READ_DATA0. */

/*! @brief Read current value of the MMDC_MDMRR_MRR_READ_DATA0 field. */
#define BR_MMDC_MDMRR_MRR_READ_DATA0(x) (HW_MMDC_MDMRR(x).B.MRR_READ_DATA0)
/*@}*/

/*!
 * @name Register MMDC_MDMRR, field MRR_READ_DATA1[15:8] (RO)
 *
 * MRR DATA that arrived on DQ[15:8]
 */
/*@{*/
#define BP_MMDC_MDMRR_MRR_READ_DATA1 (8U)  /*!< Bit position for MMDC_MDMRR_MRR_READ_DATA1. */
#define BM_MMDC_MDMRR_MRR_READ_DATA1 (0x0000FF00U) /*!< Bit mask for MMDC_MDMRR_MRR_READ_DATA1. */
#define BS_MMDC_MDMRR_MRR_READ_DATA1 (8U)  /*!< Bit field size in bits for MMDC_MDMRR_MRR_READ_DATA1. */

/*! @brief Read current value of the MMDC_MDMRR_MRR_READ_DATA1 field. */
#define BR_MMDC_MDMRR_MRR_READ_DATA1(x) (HW_MMDC_MDMRR(x).B.MRR_READ_DATA1)
/*@}*/

/*!
 * @name Register MMDC_MDMRR, field MRR_READ_DATA2[23:16] (RO)
 *
 * MRR DATA that arrived on DQ[23:16]
 */
/*@{*/
#define BP_MMDC_MDMRR_MRR_READ_DATA2 (16U) /*!< Bit position for MMDC_MDMRR_MRR_READ_DATA2. */
#define BM_MMDC_MDMRR_MRR_READ_DATA2 (0x00FF0000U) /*!< Bit mask for MMDC_MDMRR_MRR_READ_DATA2. */
#define BS_MMDC_MDMRR_MRR_READ_DATA2 (8U)  /*!< Bit field size in bits for MMDC_MDMRR_MRR_READ_DATA2. */

/*! @brief Read current value of the MMDC_MDMRR_MRR_READ_DATA2 field. */
#define BR_MMDC_MDMRR_MRR_READ_DATA2(x) (HW_MMDC_MDMRR(x).B.MRR_READ_DATA2)
/*@}*/

/*!
 * @name Register MMDC_MDMRR, field MRR_READ_DATA3[31:24] (RO)
 *
 * MRR DATA that arrived on DQ[31:24]
 */
/*@{*/
#define BP_MMDC_MDMRR_MRR_READ_DATA3 (24U) /*!< Bit position for MMDC_MDMRR_MRR_READ_DATA3. */
#define BM_MMDC_MDMRR_MRR_READ_DATA3 (0xFF000000U) /*!< Bit mask for MMDC_MDMRR_MRR_READ_DATA3. */
#define BS_MMDC_MDMRR_MRR_READ_DATA3 (8U)  /*!< Bit field size in bits for MMDC_MDMRR_MRR_READ_DATA3. */

/*! @brief Read current value of the MMDC_MDMRR_MRR_READ_DATA3 field. */
#define BR_MMDC_MDMRR_MRR_READ_DATA3(x) (HW_MMDC_MDMRR(x).B.MRR_READ_DATA3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDCFG3LP - MMDC Core Timing Configuration Register 3
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDCFG3LP - MMDC Core Timing Configuration Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is relevant only for LPDDR2 mode. Supported Mode Of Operations:
 * For Channel 0: LP2_2ch_x16, LP2_2ch_x32 For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mdcfg3lp
{
    uint32_t U;
    struct _hw_mmdc_mdcfg3lp_bitfields
    {
        uint32_t tRPab_LP : 4;         /*!< [3:0]  */
        uint32_t tRPpb_LP : 4;         /*!< [7:4]  */
        uint32_t tRCD_LP : 4;          /*!< [11:8]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t RC_LP : 6;            /*!< [21:16]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_mmdc_mdcfg3lp_t;

/*!
 * @name Constants and macros for entire MMDC_MDCFG3LP register
 */
/*@{*/
#define HW_MMDC_MDCFG3LP_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_MMDC_MDCFG3LP(x)      (*(__IO hw_mmdc_mdcfg3lp_t *) HW_MMDC_MDCFG3LP_ADDR(x))
#define HW_MMDC_MDCFG3LP_RD(x)   (HW_MMDC_MDCFG3LP(x).U)
#define HW_MMDC_MDCFG3LP_WR(x, v) (HW_MMDC_MDCFG3LP(x).U = (v))
#define HW_MMDC_MDCFG3LP_SET(x, v) (HW_MMDC_MDCFG3LP_WR(x, HW_MMDC_MDCFG3LP_RD(x) |  (v)))
#define HW_MMDC_MDCFG3LP_CLR(x, v) (HW_MMDC_MDCFG3LP_WR(x, HW_MMDC_MDCFG3LP_RD(x) & ~(v)))
#define HW_MMDC_MDCFG3LP_TOG(x, v) (HW_MMDC_MDCFG3LP_WR(x, HW_MMDC_MDCFG3LP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDCFG3LP bitfields
 */

/*!
 * @name Register MMDC_MDCFG3LP, field tRPab_LP[3:0] (RW)
 *
 * Precharge (all banks) command period. (This field is valid only for LPDDR2
 * memories)
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG3LP_tRPab_LP (0U)     /*!< Bit position for MMDC_MDCFG3LP_tRPab_LP. */
#define BM_MMDC_MDCFG3LP_tRPab_LP (0x0000000FU) /*!< Bit mask for MMDC_MDCFG3LP_tRPab_LP. */
#define BS_MMDC_MDCFG3LP_tRPab_LP (4U)     /*!< Bit field size in bits for MMDC_MDCFG3LP_tRPab_LP. */

/*! @brief Read current value of the MMDC_MDCFG3LP_tRPab_LP field. */
#define BR_MMDC_MDCFG3LP_tRPab_LP(x) (HW_MMDC_MDCFG3LP(x).B.tRPab_LP)

/*! @brief Format value for bitfield MMDC_MDCFG3LP_tRPab_LP. */
#define BF_MMDC_MDCFG3LP_tRPab_LP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG3LP_tRPab_LP) & BM_MMDC_MDCFG3LP_tRPab_LP)

/*! @brief Set the tRPab_LP field to a new value. */
#define BW_MMDC_MDCFG3LP_tRPab_LP(x, v) (HW_MMDC_MDCFG3LP_WR(x, (HW_MMDC_MDCFG3LP_RD(x) & ~BM_MMDC_MDCFG3LP_tRPab_LP) | BF_MMDC_MDCFG3LP_tRPab_LP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG3LP, field tRPpb_LP[7:4] (RW)
 *
 * Precharge (per bank) command period (same bank). (This field is valid only
 * for LPDDR2 memories)
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG3LP_tRPpb_LP (4U)     /*!< Bit position for MMDC_MDCFG3LP_tRPpb_LP. */
#define BM_MMDC_MDCFG3LP_tRPpb_LP (0x000000F0U) /*!< Bit mask for MMDC_MDCFG3LP_tRPpb_LP. */
#define BS_MMDC_MDCFG3LP_tRPpb_LP (4U)     /*!< Bit field size in bits for MMDC_MDCFG3LP_tRPpb_LP. */

/*! @brief Read current value of the MMDC_MDCFG3LP_tRPpb_LP field. */
#define BR_MMDC_MDCFG3LP_tRPpb_LP(x) (HW_MMDC_MDCFG3LP(x).B.tRPpb_LP)

/*! @brief Format value for bitfield MMDC_MDCFG3LP_tRPpb_LP. */
#define BF_MMDC_MDCFG3LP_tRPpb_LP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG3LP_tRPpb_LP) & BM_MMDC_MDCFG3LP_tRPpb_LP)

/*! @brief Set the tRPpb_LP field to a new value. */
#define BW_MMDC_MDCFG3LP_tRPpb_LP(x, v) (HW_MMDC_MDCFG3LP_WR(x, (HW_MMDC_MDCFG3LP_RD(x) & ~BM_MMDC_MDCFG3LP_tRPpb_LP) | BF_MMDC_MDCFG3LP_tRPpb_LP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG3LP, field tRCD_LP[11:8] (RW)
 *
 * Active command to internal read or write delay time (same bank). (This field
 * is valid only for LPDDR2 memories)
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 1110 - 15 clocks
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG3LP_tRCD_LP (8U)      /*!< Bit position for MMDC_MDCFG3LP_tRCD_LP. */
#define BM_MMDC_MDCFG3LP_tRCD_LP (0x00000F00U) /*!< Bit mask for MMDC_MDCFG3LP_tRCD_LP. */
#define BS_MMDC_MDCFG3LP_tRCD_LP (4U)      /*!< Bit field size in bits for MMDC_MDCFG3LP_tRCD_LP. */

/*! @brief Read current value of the MMDC_MDCFG3LP_tRCD_LP field. */
#define BR_MMDC_MDCFG3LP_tRCD_LP(x) (HW_MMDC_MDCFG3LP(x).B.tRCD_LP)

/*! @brief Format value for bitfield MMDC_MDCFG3LP_tRCD_LP. */
#define BF_MMDC_MDCFG3LP_tRCD_LP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG3LP_tRCD_LP) & BM_MMDC_MDCFG3LP_tRCD_LP)

/*! @brief Set the tRCD_LP field to a new value. */
#define BW_MMDC_MDCFG3LP_tRCD_LP(x, v) (HW_MMDC_MDCFG3LP_WR(x, (HW_MMDC_MDCFG3LP_RD(x) & ~BM_MMDC_MDCFG3LP_tRCD_LP) | BF_MMDC_MDCFG3LP_tRCD_LP(v)))
/*@}*/

/*!
 * @name Register MMDC_MDCFG3LP, field RC_LP[21:16] (RW)
 *
 * Active to Active or Refresh command period (same bank). (This field is valid
 * only for LPDDR2 memories)
 *
 * Values:
 * - 0 - 1 clock
 * - 1 - 2 clocks
 * - 10 - 3 clocks
 * - 111110 - 63 clocks
 * - 111111 - Reserved
 */
/*@{*/
#define BP_MMDC_MDCFG3LP_RC_LP (16U)       /*!< Bit position for MMDC_MDCFG3LP_RC_LP. */
#define BM_MMDC_MDCFG3LP_RC_LP (0x003F0000U) /*!< Bit mask for MMDC_MDCFG3LP_RC_LP. */
#define BS_MMDC_MDCFG3LP_RC_LP (6U)        /*!< Bit field size in bits for MMDC_MDCFG3LP_RC_LP. */

/*! @brief Read current value of the MMDC_MDCFG3LP_RC_LP field. */
#define BR_MMDC_MDCFG3LP_RC_LP(x) (HW_MMDC_MDCFG3LP(x).B.RC_LP)

/*! @brief Format value for bitfield MMDC_MDCFG3LP_RC_LP. */
#define BF_MMDC_MDCFG3LP_RC_LP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDCFG3LP_RC_LP) & BM_MMDC_MDCFG3LP_RC_LP)

/*! @brief Set the RC_LP field to a new value. */
#define BW_MMDC_MDCFG3LP_RC_LP(x, v) (HW_MMDC_MDCFG3LP_WR(x, (HW_MMDC_MDCFG3LP_RD(x) & ~BM_MMDC_MDCFG3LP_RC_LP) | BF_MMDC_MDCFG3LP_RC_LP(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDMR4 - MMDC Core MR4 Derating Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDMR4 - MMDC Core MR4 Derating Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is relevant only for LPDDR2 mode. It is used to dynamically
 * change certain values depending on MR4 read result, which is based on memory
 * temperature sensor result. Supported Mode of Operations: For Channel 0:
 * LP2_2ch_x16, LP2_2ch_x32 For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mdmr4
{
    uint32_t U;
    struct _hw_mmdc_mdmr4_bitfields
    {
        uint32_t UPDATE_DE_REQ : 1;    /*!< [0]  */
        uint32_t UPDATE_DE_ACK : 1;    /*!< [1]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t tRCD_DE : 1;          /*!< [4]  */
        uint32_t tRC_DE : 1;           /*!< [5]  */
        uint32_t tRAS_DE : 1;          /*!< [6]  */
        uint32_t tRP_DE : 1;           /*!< [7]  */
        uint32_t tRRD_DE : 1;          /*!< [8]  */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_mmdc_mdmr4_t;

/*!
 * @name Constants and macros for entire MMDC_MDMR4 register
 */
/*@{*/
#define HW_MMDC_MDMR4_ADDR(x)    ((uintptr_t)(x) + 0x3CU)

#define HW_MMDC_MDMR4(x)         (*(__IO hw_mmdc_mdmr4_t *) HW_MMDC_MDMR4_ADDR(x))
#define HW_MMDC_MDMR4_RD(x)      (HW_MMDC_MDMR4(x).U)
#define HW_MMDC_MDMR4_WR(x, v)   (HW_MMDC_MDMR4(x).U = (v))
#define HW_MMDC_MDMR4_SET(x, v)  (HW_MMDC_MDMR4_WR(x, HW_MMDC_MDMR4_RD(x) |  (v)))
#define HW_MMDC_MDMR4_CLR(x, v)  (HW_MMDC_MDMR4_WR(x, HW_MMDC_MDMR4_RD(x) & ~(v)))
#define HW_MMDC_MDMR4_TOG(x, v)  (HW_MMDC_MDMR4_WR(x, HW_MMDC_MDMR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDMR4 bitfields
 */

/*!
 * @name Register MMDC_MDMR4, field UPDATE_DE_REQ[0] (RW)
 *
 * Update Derated Values Request. This read modify write field is automatically
 * cleared after the request is issued.
 *
 * Values:
 * - 0 - Do nothing.
 * - 1 - Request to update the following values: tRRD, tRCD, tRP, tRC, tRAS and
 *     refresh related fields(MDREF register): REF_CNT, REF_SEL, REFR
 */
/*@{*/
#define BP_MMDC_MDMR4_UPDATE_DE_REQ (0U)   /*!< Bit position for MMDC_MDMR4_UPDATE_DE_REQ. */
#define BM_MMDC_MDMR4_UPDATE_DE_REQ (0x00000001U) /*!< Bit mask for MMDC_MDMR4_UPDATE_DE_REQ. */
#define BS_MMDC_MDMR4_UPDATE_DE_REQ (1U)   /*!< Bit field size in bits for MMDC_MDMR4_UPDATE_DE_REQ. */

/*! @brief Read current value of the MMDC_MDMR4_UPDATE_DE_REQ field. */
#define BR_MMDC_MDMR4_UPDATE_DE_REQ(x) (HW_MMDC_MDMR4(x).B.UPDATE_DE_REQ)

/*! @brief Format value for bitfield MMDC_MDMR4_UPDATE_DE_REQ. */
#define BF_MMDC_MDMR4_UPDATE_DE_REQ(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_UPDATE_DE_REQ) & BM_MMDC_MDMR4_UPDATE_DE_REQ)

/*! @brief Set the UPDATE_DE_REQ field to a new value. */
#define BW_MMDC_MDMR4_UPDATE_DE_REQ(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_UPDATE_DE_REQ) | BF_MMDC_MDMR4_UPDATE_DE_REQ(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field UPDATE_DE_ACK[1] (RO)
 *
 * Update Derated Values Acknowledge. This read only bit will be cleared upon
 * UPDATE_DE_REQ assertion and will be set after the new values are taken.
 */
/*@{*/
#define BP_MMDC_MDMR4_UPDATE_DE_ACK (1U)   /*!< Bit position for MMDC_MDMR4_UPDATE_DE_ACK. */
#define BM_MMDC_MDMR4_UPDATE_DE_ACK (0x00000002U) /*!< Bit mask for MMDC_MDMR4_UPDATE_DE_ACK. */
#define BS_MMDC_MDMR4_UPDATE_DE_ACK (1U)   /*!< Bit field size in bits for MMDC_MDMR4_UPDATE_DE_ACK. */

/*! @brief Read current value of the MMDC_MDMR4_UPDATE_DE_ACK field. */
#define BR_MMDC_MDMR4_UPDATE_DE_ACK(x) (HW_MMDC_MDMR4(x).B.UPDATE_DE_ACK)
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field tRCD_DE[4] (RW)
 *
 * tRCD derating value.
 *
 * Values:
 * - 0 - Original tRCD is used.
 * - 1 - tRCD is derated in 1 cycle.
 */
/*@{*/
#define BP_MMDC_MDMR4_tRCD_DE (4U)         /*!< Bit position for MMDC_MDMR4_tRCD_DE. */
#define BM_MMDC_MDMR4_tRCD_DE (0x00000010U) /*!< Bit mask for MMDC_MDMR4_tRCD_DE. */
#define BS_MMDC_MDMR4_tRCD_DE (1U)         /*!< Bit field size in bits for MMDC_MDMR4_tRCD_DE. */

/*! @brief Read current value of the MMDC_MDMR4_tRCD_DE field. */
#define BR_MMDC_MDMR4_tRCD_DE(x) (HW_MMDC_MDMR4(x).B.tRCD_DE)

/*! @brief Format value for bitfield MMDC_MDMR4_tRCD_DE. */
#define BF_MMDC_MDMR4_tRCD_DE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_tRCD_DE) & BM_MMDC_MDMR4_tRCD_DE)

/*! @brief Set the tRCD_DE field to a new value. */
#define BW_MMDC_MDMR4_tRCD_DE(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_tRCD_DE) | BF_MMDC_MDMR4_tRCD_DE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field tRC_DE[5] (RW)
 *
 * tRC derating value.
 *
 * Values:
 * - 0 - Original tRC is used.
 * - 1 - tRC is derated in 1 cycle.
 */
/*@{*/
#define BP_MMDC_MDMR4_tRC_DE (5U)          /*!< Bit position for MMDC_MDMR4_tRC_DE. */
#define BM_MMDC_MDMR4_tRC_DE (0x00000020U) /*!< Bit mask for MMDC_MDMR4_tRC_DE. */
#define BS_MMDC_MDMR4_tRC_DE (1U)          /*!< Bit field size in bits for MMDC_MDMR4_tRC_DE. */

/*! @brief Read current value of the MMDC_MDMR4_tRC_DE field. */
#define BR_MMDC_MDMR4_tRC_DE(x) (HW_MMDC_MDMR4(x).B.tRC_DE)

/*! @brief Format value for bitfield MMDC_MDMR4_tRC_DE. */
#define BF_MMDC_MDMR4_tRC_DE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_tRC_DE) & BM_MMDC_MDMR4_tRC_DE)

/*! @brief Set the tRC_DE field to a new value. */
#define BW_MMDC_MDMR4_tRC_DE(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_tRC_DE) | BF_MMDC_MDMR4_tRC_DE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field tRAS_DE[6] (RW)
 *
 * tRAS derating value.
 *
 * Values:
 * - 0 - Original tRAS is used.
 * - 1 - tRAS is derated in 1 cycle.
 */
/*@{*/
#define BP_MMDC_MDMR4_tRAS_DE (6U)         /*!< Bit position for MMDC_MDMR4_tRAS_DE. */
#define BM_MMDC_MDMR4_tRAS_DE (0x00000040U) /*!< Bit mask for MMDC_MDMR4_tRAS_DE. */
#define BS_MMDC_MDMR4_tRAS_DE (1U)         /*!< Bit field size in bits for MMDC_MDMR4_tRAS_DE. */

/*! @brief Read current value of the MMDC_MDMR4_tRAS_DE field. */
#define BR_MMDC_MDMR4_tRAS_DE(x) (HW_MMDC_MDMR4(x).B.tRAS_DE)

/*! @brief Format value for bitfield MMDC_MDMR4_tRAS_DE. */
#define BF_MMDC_MDMR4_tRAS_DE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_tRAS_DE) & BM_MMDC_MDMR4_tRAS_DE)

/*! @brief Set the tRAS_DE field to a new value. */
#define BW_MMDC_MDMR4_tRAS_DE(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_tRAS_DE) | BF_MMDC_MDMR4_tRAS_DE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field tRP_DE[7] (RW)
 *
 * tRP derating value.
 *
 * Values:
 * - 0 - Original tRP is used.
 * - 1 - tRP is derated in 1 cycle.
 */
/*@{*/
#define BP_MMDC_MDMR4_tRP_DE (7U)          /*!< Bit position for MMDC_MDMR4_tRP_DE. */
#define BM_MMDC_MDMR4_tRP_DE (0x00000080U) /*!< Bit mask for MMDC_MDMR4_tRP_DE. */
#define BS_MMDC_MDMR4_tRP_DE (1U)          /*!< Bit field size in bits for MMDC_MDMR4_tRP_DE. */

/*! @brief Read current value of the MMDC_MDMR4_tRP_DE field. */
#define BR_MMDC_MDMR4_tRP_DE(x) (HW_MMDC_MDMR4(x).B.tRP_DE)

/*! @brief Format value for bitfield MMDC_MDMR4_tRP_DE. */
#define BF_MMDC_MDMR4_tRP_DE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_tRP_DE) & BM_MMDC_MDMR4_tRP_DE)

/*! @brief Set the tRP_DE field to a new value. */
#define BW_MMDC_MDMR4_tRP_DE(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_tRP_DE) | BF_MMDC_MDMR4_tRP_DE(v)))
/*@}*/

/*!
 * @name Register MMDC_MDMR4, field tRRD_DE[8] (RW)
 *
 * tRRD derating value.
 *
 * Values:
 * - 0 - Original tRRD is used.
 * - 1 - tRRD is derated in 1 cycle.
 */
/*@{*/
#define BP_MMDC_MDMR4_tRRD_DE (8U)         /*!< Bit position for MMDC_MDMR4_tRRD_DE. */
#define BM_MMDC_MDMR4_tRRD_DE (0x00000100U) /*!< Bit mask for MMDC_MDMR4_tRRD_DE. */
#define BS_MMDC_MDMR4_tRRD_DE (1U)         /*!< Bit field size in bits for MMDC_MDMR4_tRRD_DE. */

/*! @brief Read current value of the MMDC_MDMR4_tRRD_DE field. */
#define BR_MMDC_MDMR4_tRRD_DE(x) (HW_MMDC_MDMR4(x).B.tRRD_DE)

/*! @brief Format value for bitfield MMDC_MDMR4_tRRD_DE. */
#define BF_MMDC_MDMR4_tRRD_DE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDMR4_tRRD_DE) & BM_MMDC_MDMR4_tRRD_DE)

/*! @brief Set the tRRD_DE field to a new value. */
#define BW_MMDC_MDMR4_tRRD_DE(x, v) (HW_MMDC_MDMR4_WR(x, (HW_MMDC_MDMR4_RD(x) & ~BM_MMDC_MDMR4_tRRD_DE) | BF_MMDC_MDMR4_tRRD_DE(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MDASP - MMDC Core Address Space Partition Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MDASP - MMDC Core Address Space Partition Register (RW)
 *
 * Reset value: 0x0000003FU
 *
 * This register defines the partitioning between chip select 0 and chip select
 * 1. For further information see Chip select settingsMMDC drives the incoming
 * access to either CS0 or CS1 by comparing the 7 most significant address bits
 * (ARADDR[31:25]/AWADDR[31:25]) with MDASP[CS0_END]. . Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mdasp
{
    uint32_t U;
    struct _hw_mmdc_mdasp_bitfields
    {
        uint32_t CS0_END : 7;          /*!< [6:0]  */
        uint32_t RESERVED0 : 25;       /*!< [31:7]  */
    } B;
} hw_mmdc_mdasp_t;

/*!
 * @name Constants and macros for entire MMDC_MDASP register
 */
/*@{*/
#define HW_MMDC_MDASP_ADDR(x)    ((uintptr_t)(x) + 0x40U)

#define HW_MMDC_MDASP(x)         (*(__IO hw_mmdc_mdasp_t *) HW_MMDC_MDASP_ADDR(x))
#define HW_MMDC_MDASP_RD(x)      (HW_MMDC_MDASP(x).U)
#define HW_MMDC_MDASP_WR(x, v)   (HW_MMDC_MDASP(x).U = (v))
#define HW_MMDC_MDASP_SET(x, v)  (HW_MMDC_MDASP_WR(x, HW_MMDC_MDASP_RD(x) |  (v)))
#define HW_MMDC_MDASP_CLR(x, v)  (HW_MMDC_MDASP_WR(x, HW_MMDC_MDASP_RD(x) & ~(v)))
#define HW_MMDC_MDASP_TOG(x, v)  (HW_MMDC_MDASP_WR(x, HW_MMDC_MDASP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MDASP bitfields
 */

/*!
 * @name Register MMDC_MDASP, field CS0_END[6:0] (RW)
 *
 * CS0_END. Defines the absolute last address associated with CS0 with
 * increments of 256Mb. CS0_END=AXI_ADDRESS[31:25] bits. In DDR3 and 1-channel LPDDR2
 * mode: MMDCx_MDASP[CS0_END] should be set to DDR_CS_SIZE/32MB + 0x7 (DDR base
 * address begins at 0x10000000) In 2-channel LPDDR2 mode: MMDC0_MDASP[CS0_END] should
 * be set to DDR_CS_SIZE/32M + 0x3f (channel 0 base address begins at
 * 0x80000000) MMDC1_MDASP[CS0_END] should be set to DDR_CS_SIZE/32M + 0x7 (channel 1 base
 * address begins at 0x10000000) In 2-channel LPDDR2 with 4k-interleave mode:
 * MMDC0_MDASP[CS0_END] should be set to DDR_CS_SIZE/32M + 0x43 MMDC1_MDASP[CS0_END]
 * should be set to DDR_CS_SIZE/32M + 0x3
 */
/*@{*/
#define BP_MMDC_MDASP_CS0_END (0U)         /*!< Bit position for MMDC_MDASP_CS0_END. */
#define BM_MMDC_MDASP_CS0_END (0x0000007FU) /*!< Bit mask for MMDC_MDASP_CS0_END. */
#define BS_MMDC_MDASP_CS0_END (7U)         /*!< Bit field size in bits for MMDC_MDASP_CS0_END. */

/*! @brief Read current value of the MMDC_MDASP_CS0_END field. */
#define BR_MMDC_MDASP_CS0_END(x) (HW_MMDC_MDASP(x).B.CS0_END)

/*! @brief Format value for bitfield MMDC_MDASP_CS0_END. */
#define BF_MMDC_MDASP_CS0_END(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MDASP_CS0_END) & BM_MMDC_MDASP_CS0_END)

/*! @brief Set the CS0_END field to a new value. */
#define BW_MMDC_MDASP_CS0_END(x, v) (HW_MMDC_MDASP_WR(x, (HW_MMDC_MDASP_RD(x) & ~BM_MMDC_MDASP_CS0_END) | BF_MMDC_MDASP_CS0_END(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MAARCR - MMDC Core AXI Reordering Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MAARCR - MMDC Core AXI Reordering Control Register (RW)
 *
 * Reset value: 0x514201F0U
 *
 * This register determines the values of the weights used for the re-ordering
 * arbitration engine. For further information see Performance . Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_maarcr
{
    uint32_t U;
    struct _hw_mmdc_maarcr_bitfields
    {
        uint32_t ARCR_GUARD : 4;       /*!< [3:0]  */
        uint32_t ARCR_DYN_MAX : 4;     /*!< [7:4]  */
        uint32_t ARCR_DYN_JMP : 4;     /*!< [11:8]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t ARCR_ACC_HIT : 3;     /*!< [18:16]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t ARCR_PAG_HIT : 3;     /*!< [22:20]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t ARCR_RCH_EN : 1;      /*!< [24]  */
        uint32_t ARCR_REO_DIS : 1;     /*!< [25]  */
        uint32_t ARCR_ARB_REO_DIS : 1; /*!< [26]  */
        uint32_t RESERVED3 : 1;        /*!< [27]  */
        uint32_t ARCR_EXC_ERR_EN : 1;  /*!< [28]  */
        uint32_t RESERVED4 : 1;        /*!< [29]  */
        uint32_t ARCR_SEC_ERR_EN : 1;  /*!< [30]  */
        uint32_t ARCR_SEC_ERR_LOCK : 1; /*!< [31]  */
    } B;
} hw_mmdc_maarcr_t;

/*!
 * @name Constants and macros for entire MMDC_MAARCR register
 */
/*@{*/
#define HW_MMDC_MAARCR_ADDR(x)   ((uintptr_t)(x) + 0x400U)

#define HW_MMDC_MAARCR(x)        (*(__IO hw_mmdc_maarcr_t *) HW_MMDC_MAARCR_ADDR(x))
#define HW_MMDC_MAARCR_RD(x)     (HW_MMDC_MAARCR(x).U)
#define HW_MMDC_MAARCR_WR(x, v)  (HW_MMDC_MAARCR(x).U = (v))
#define HW_MMDC_MAARCR_SET(x, v) (HW_MMDC_MAARCR_WR(x, HW_MMDC_MAARCR_RD(x) |  (v)))
#define HW_MMDC_MAARCR_CLR(x, v) (HW_MMDC_MAARCR_WR(x, HW_MMDC_MAARCR_RD(x) & ~(v)))
#define HW_MMDC_MAARCR_TOG(x, v) (HW_MMDC_MAARCR_WR(x, HW_MMDC_MAARCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MAARCR bitfields
 */

/*!
 * @name Register MMDC_MAARCR, field ARCR_GUARD[3:0] (RW)
 *
 * ARCR Guard. After an access reached the maximum dynamic score value, it will
 * wait additional ARCR_GUARD arbitration cycles and then will gain the highest
 * priority in the optimization/reordering mechanism.
 *
 * Values:
 * - 0000 - 15 (default)
 * - 0001 - 16
 * - 1111 - 30
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_GUARD (0U)     /*!< Bit position for MMDC_MAARCR_ARCR_GUARD. */
#define BM_MMDC_MAARCR_ARCR_GUARD (0x0000000FU) /*!< Bit mask for MMDC_MAARCR_ARCR_GUARD. */
#define BS_MMDC_MAARCR_ARCR_GUARD (4U)     /*!< Bit field size in bits for MMDC_MAARCR_ARCR_GUARD. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_GUARD field. */
#define BR_MMDC_MAARCR_ARCR_GUARD(x) (HW_MMDC_MAARCR(x).B.ARCR_GUARD)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_GUARD. */
#define BF_MMDC_MAARCR_ARCR_GUARD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_GUARD) & BM_MMDC_MAARCR_ARCR_GUARD)

/*! @brief Set the ARCR_GUARD field to a new value. */
#define BW_MMDC_MAARCR_ARCR_GUARD(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_GUARD) | BF_MMDC_MAARCR_ARCR_GUARD(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_DYN_MAX[7:4] (RW)
 *
 * ARCR Dynamic Maximum. ARCR_DYN_MAX is the maximum dynamic score value that
 * each access inside the optimization/reordering mechanism can get.
 *
 * Values:
 * - 0000 - 0
 * - 0001 - 1
 * - 1111 - 15 (default)
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_DYN_MAX (4U)   /*!< Bit position for MMDC_MAARCR_ARCR_DYN_MAX. */
#define BM_MMDC_MAARCR_ARCR_DYN_MAX (0x000000F0U) /*!< Bit mask for MMDC_MAARCR_ARCR_DYN_MAX. */
#define BS_MMDC_MAARCR_ARCR_DYN_MAX (4U)   /*!< Bit field size in bits for MMDC_MAARCR_ARCR_DYN_MAX. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_DYN_MAX field. */
#define BR_MMDC_MAARCR_ARCR_DYN_MAX(x) (HW_MMDC_MAARCR(x).B.ARCR_DYN_MAX)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_DYN_MAX. */
#define BF_MMDC_MAARCR_ARCR_DYN_MAX(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_DYN_MAX) & BM_MMDC_MAARCR_ARCR_DYN_MAX)

/*! @brief Set the ARCR_DYN_MAX field to a new value. */
#define BW_MMDC_MAARCR_ARCR_DYN_MAX(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_DYN_MAX) | BF_MMDC_MAARCR_ARCR_DYN_MAX(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_DYN_JMP[11:8] (RW)
 *
 * ARCR Dynamic Jump. Each time an access wan't chosen by the
 * optimization/reordering mechanism then its dynamic score will be incremented by ARCR_DYN_JMP
 * value. Setting ARCR_DYN_JMP may cause starvation of low priority accesses
 * ARCR_DYN_JMP must be smaller than ARCR_DYN_MAX Default ARCR_DYN_JMP value is 0x0001 -
 * encoding 1
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_DYN_JMP (8U)   /*!< Bit position for MMDC_MAARCR_ARCR_DYN_JMP. */
#define BM_MMDC_MAARCR_ARCR_DYN_JMP (0x00000F00U) /*!< Bit mask for MMDC_MAARCR_ARCR_DYN_JMP. */
#define BS_MMDC_MAARCR_ARCR_DYN_JMP (4U)   /*!< Bit field size in bits for MMDC_MAARCR_ARCR_DYN_JMP. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_DYN_JMP field. */
#define BR_MMDC_MAARCR_ARCR_DYN_JMP(x) (HW_MMDC_MAARCR(x).B.ARCR_DYN_JMP)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_DYN_JMP. */
#define BF_MMDC_MAARCR_ARCR_DYN_JMP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_DYN_JMP) & BM_MMDC_MAARCR_ARCR_DYN_JMP)

/*! @brief Set the ARCR_DYN_JMP field to a new value. */
#define BW_MMDC_MAARCR_ARCR_DYN_JMP(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_DYN_JMP) | BF_MMDC_MAARCR_ARCR_DYN_JMP(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_ACC_HIT[18:16] (RW)
 *
 * ARCR Access Hit Rate. This value will be added by the optimization/reordering
 * mechanism to any pending access that has the same access type (read/write) as
 * the previous access. Default value of is ARCR_ACC_HIT 0x0010 - encoding 2.
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_ACC_HIT (16U)  /*!< Bit position for MMDC_MAARCR_ARCR_ACC_HIT. */
#define BM_MMDC_MAARCR_ARCR_ACC_HIT (0x00070000U) /*!< Bit mask for MMDC_MAARCR_ARCR_ACC_HIT. */
#define BS_MMDC_MAARCR_ARCR_ACC_HIT (3U)   /*!< Bit field size in bits for MMDC_MAARCR_ARCR_ACC_HIT. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_ACC_HIT field. */
#define BR_MMDC_MAARCR_ARCR_ACC_HIT(x) (HW_MMDC_MAARCR(x).B.ARCR_ACC_HIT)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_ACC_HIT. */
#define BF_MMDC_MAARCR_ARCR_ACC_HIT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_ACC_HIT) & BM_MMDC_MAARCR_ARCR_ACC_HIT)

/*! @brief Set the ARCR_ACC_HIT field to a new value. */
#define BW_MMDC_MAARCR_ARCR_ACC_HIT(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_ACC_HIT) | BF_MMDC_MAARCR_ARCR_ACC_HIT(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_PAG_HIT[22:20] (RW)
 *
 * ARCR Page Hit Rate. This value will be added by the optimization/reordering
 * mechanism to any pending access that is targeted to an open DDR row. Default
 * value of ARCR_PAG_HIT is 0x00100 - encoding 4.
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_PAG_HIT (20U)  /*!< Bit position for MMDC_MAARCR_ARCR_PAG_HIT. */
#define BM_MMDC_MAARCR_ARCR_PAG_HIT (0x00700000U) /*!< Bit mask for MMDC_MAARCR_ARCR_PAG_HIT. */
#define BS_MMDC_MAARCR_ARCR_PAG_HIT (3U)   /*!< Bit field size in bits for MMDC_MAARCR_ARCR_PAG_HIT. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_PAG_HIT field. */
#define BR_MMDC_MAARCR_ARCR_PAG_HIT(x) (HW_MMDC_MAARCR(x).B.ARCR_PAG_HIT)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_PAG_HIT. */
#define BF_MMDC_MAARCR_ARCR_PAG_HIT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_PAG_HIT) & BM_MMDC_MAARCR_ARCR_PAG_HIT)

/*! @brief Set the ARCR_PAG_HIT field to a new value. */
#define BW_MMDC_MAARCR_ARCR_PAG_HIT(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_PAG_HIT) | BF_MMDC_MAARCR_ARCR_PAG_HIT(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_RCH_EN[24] (RW)
 *
 * This bit defines whether Real time channel is activated and bypassed all
 * other pending accesses, So accesses with QoS=='F' will be granted the highest
 * priority in the optimization/reordering mechanism Default value is 0x1 - encoding
 * 1 (Enabled)
 *
 * Values:
 * - 0 - normal prioritization, no bypassing
 * - 1 - accesses with QoS=='F' bypass the arbitration
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_RCH_EN (24U)   /*!< Bit position for MMDC_MAARCR_ARCR_RCH_EN. */
#define BM_MMDC_MAARCR_ARCR_RCH_EN (0x01000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_RCH_EN. */
#define BS_MMDC_MAARCR_ARCR_RCH_EN (1U)    /*!< Bit field size in bits for MMDC_MAARCR_ARCR_RCH_EN. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_RCH_EN field. */
#define BR_MMDC_MAARCR_ARCR_RCH_EN(x) (HW_MMDC_MAARCR(x).B.ARCR_RCH_EN)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_RCH_EN. */
#define BF_MMDC_MAARCR_ARCR_RCH_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_RCH_EN) & BM_MMDC_MAARCR_ARCR_RCH_EN)

/*! @brief Set the ARCR_RCH_EN field to a new value. */
#define BW_MMDC_MAARCR_ARCR_RCH_EN(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_RCH_EN) | BF_MMDC_MAARCR_ARCR_RCH_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_REO_DIS[25] (RW)
 *
 * Values:
 * - 0 - MMDC reordering controls only enabled
 * - 1 - MMDC arbitration controls only disabled
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_REO_DIS (25U)  /*!< Bit position for MMDC_MAARCR_ARCR_REO_DIS. */
#define BM_MMDC_MAARCR_ARCR_REO_DIS (0x02000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_REO_DIS. */
#define BS_MMDC_MAARCR_ARCR_REO_DIS (1U)   /*!< Bit field size in bits for MMDC_MAARCR_ARCR_REO_DIS. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_REO_DIS field. */
#define BR_MMDC_MAARCR_ARCR_REO_DIS(x) (HW_MMDC_MAARCR(x).B.ARCR_REO_DIS)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_REO_DIS. */
#define BF_MMDC_MAARCR_ARCR_REO_DIS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_REO_DIS) & BM_MMDC_MAARCR_ARCR_REO_DIS)

/*! @brief Set the ARCR_REO_DIS field to a new value. */
#define BW_MMDC_MAARCR_ARCR_REO_DIS(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_REO_DIS) | BF_MMDC_MAARCR_ARCR_REO_DIS(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_ARB_REO_DIS[26] (RW)
 *
 * Values:
 * - 0 - MMDC arbitration and reordering controls enabled
 * - 1 - MMDC arbitration and reordering controls disabled
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_ARB_REO_DIS (26U) /*!< Bit position for MMDC_MAARCR_ARCR_ARB_REO_DIS. */
#define BM_MMDC_MAARCR_ARCR_ARB_REO_DIS (0x04000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_ARB_REO_DIS. */
#define BS_MMDC_MAARCR_ARCR_ARB_REO_DIS (1U) /*!< Bit field size in bits for MMDC_MAARCR_ARCR_ARB_REO_DIS. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_ARB_REO_DIS field. */
#define BR_MMDC_MAARCR_ARCR_ARB_REO_DIS(x) (HW_MMDC_MAARCR(x).B.ARCR_ARB_REO_DIS)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_ARB_REO_DIS. */
#define BF_MMDC_MAARCR_ARCR_ARB_REO_DIS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_ARB_REO_DIS) & BM_MMDC_MAARCR_ARCR_ARB_REO_DIS)

/*! @brief Set the ARCR_ARB_REO_DIS field to a new value. */
#define BW_MMDC_MAARCR_ARCR_ARB_REO_DIS(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_ARB_REO_DIS) | BF_MMDC_MAARCR_ARCR_ARB_REO_DIS(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_EXC_ERR_EN[28] (RW)
 *
 * This bit defines whether exclusive read/write access violation of AXI 6.2.4
 * rule result in SLV Error response or in OKAY response Default value is 0x1 -
 * encoding 1(response is SLV Error)
 *
 * Values:
 * - 0 - violation of AXI exclusive rules (6.2.4) result in OKAY response
 *     (rresp/bresp=2'b00)
 * - 1 - violation of AXI exclusive rules (6.2.4) result in SLAVE Error response
 *     (rresp/bresp=2'b10)
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_EXC_ERR_EN (28U) /*!< Bit position for MMDC_MAARCR_ARCR_EXC_ERR_EN. */
#define BM_MMDC_MAARCR_ARCR_EXC_ERR_EN (0x10000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_EXC_ERR_EN. */
#define BS_MMDC_MAARCR_ARCR_EXC_ERR_EN (1U) /*!< Bit field size in bits for MMDC_MAARCR_ARCR_EXC_ERR_EN. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_EXC_ERR_EN field. */
#define BR_MMDC_MAARCR_ARCR_EXC_ERR_EN(x) (HW_MMDC_MAARCR(x).B.ARCR_EXC_ERR_EN)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_EXC_ERR_EN. */
#define BF_MMDC_MAARCR_ARCR_EXC_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_EXC_ERR_EN) & BM_MMDC_MAARCR_ARCR_EXC_ERR_EN)

/*! @brief Set the ARCR_EXC_ERR_EN field to a new value. */
#define BW_MMDC_MAARCR_ARCR_EXC_ERR_EN(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_EXC_ERR_EN) | BF_MMDC_MAARCR_ARCR_EXC_ERR_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_SEC_ERR_EN[30] (RW)
 *
 * This bit defines whether security read/write access violation result in SLV
 * Error response or in OKAY response Default value is 0x1 - encoding 1(response
 * is SLV Error, rresp/bresp=2'b10)
 *
 * Values:
 * - 0 - security violation results in OKAY response (rresp/bresp=2'b00)
 * - 1 - security violation results in SLAVE Error response (rresp/bresp=2'b10)
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_SEC_ERR_EN (30U) /*!< Bit position for MMDC_MAARCR_ARCR_SEC_ERR_EN. */
#define BM_MMDC_MAARCR_ARCR_SEC_ERR_EN (0x40000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_SEC_ERR_EN. */
#define BS_MMDC_MAARCR_ARCR_SEC_ERR_EN (1U) /*!< Bit field size in bits for MMDC_MAARCR_ARCR_SEC_ERR_EN. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_SEC_ERR_EN field. */
#define BR_MMDC_MAARCR_ARCR_SEC_ERR_EN(x) (HW_MMDC_MAARCR(x).B.ARCR_SEC_ERR_EN)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_SEC_ERR_EN. */
#define BF_MMDC_MAARCR_ARCR_SEC_ERR_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_SEC_ERR_EN) & BM_MMDC_MAARCR_ARCR_SEC_ERR_EN)

/*! @brief Set the ARCR_SEC_ERR_EN field to a new value. */
#define BW_MMDC_MAARCR_ARCR_SEC_ERR_EN(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_SEC_ERR_EN) | BF_MMDC_MAARCR_ARCR_SEC_ERR_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MAARCR, field ARCR_SEC_ERR_LOCK[31] (RW)
 *
 * Once set, this bit locks ARCR_SEC_ERR_EN and prevents from its updating. This
 * bit can be only cleared by reset Default value is 0x0 - encoding 0 (unlocked)
 *
 * Values:
 * - 0 - ARCR_SEC_ERR_EN is unlocked, so can be updated any moment
 * - 1 - ARCR_SEC_ERR_EN is locked, so it can't be updated
 */
/*@{*/
#define BP_MMDC_MAARCR_ARCR_SEC_ERR_LOCK (31U) /*!< Bit position for MMDC_MAARCR_ARCR_SEC_ERR_LOCK. */
#define BM_MMDC_MAARCR_ARCR_SEC_ERR_LOCK (0x80000000U) /*!< Bit mask for MMDC_MAARCR_ARCR_SEC_ERR_LOCK. */
#define BS_MMDC_MAARCR_ARCR_SEC_ERR_LOCK (1U) /*!< Bit field size in bits for MMDC_MAARCR_ARCR_SEC_ERR_LOCK. */

/*! @brief Read current value of the MMDC_MAARCR_ARCR_SEC_ERR_LOCK field. */
#define BR_MMDC_MAARCR_ARCR_SEC_ERR_LOCK(x) (HW_MMDC_MAARCR(x).B.ARCR_SEC_ERR_LOCK)

/*! @brief Format value for bitfield MMDC_MAARCR_ARCR_SEC_ERR_LOCK. */
#define BF_MMDC_MAARCR_ARCR_SEC_ERR_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAARCR_ARCR_SEC_ERR_LOCK) & BM_MMDC_MAARCR_ARCR_SEC_ERR_LOCK)

/*! @brief Set the ARCR_SEC_ERR_LOCK field to a new value. */
#define BW_MMDC_MAARCR_ARCR_SEC_ERR_LOCK(x, v) (HW_MMDC_MAARCR_WR(x, (HW_MMDC_MAARCR_RD(x) & ~BM_MMDC_MAARCR_ARCR_SEC_ERR_LOCK) | BF_MMDC_MAARCR_ARCR_SEC_ERR_LOCK(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MAPSR - MMDC Core Power Saving Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MAPSR - MMDC Core Power Saving Control and Status Register (RW)
 *
 * Reset value: 0x00001007U
 *
 * The MAPSR determines the power saving features of MMDC. For further
 * information see Power Saving and Clock Frequency Change modes . Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mapsr
{
    uint32_t U;
    struct _hw_mmdc_mapsr_bitfields
    {
        uint32_t PSD : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t PSS : 1;              /*!< [4]  */
        uint32_t RIS : 1;              /*!< [5]  */
        uint32_t WIS : 1;              /*!< [6]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t PST : 8;              /*!< [15:8]  */
        uint32_t RESERVED2 : 4;        /*!< [19:16]  */
        uint32_t LPMD : 1;             /*!< [20]  */
        uint32_t DVFS : 1;             /*!< [21]  */
        uint32_t RESERVED3 : 2;        /*!< [23:22]  */
        uint32_t LPACK : 1;            /*!< [24]  */
        uint32_t DVACK : 1;            /*!< [25]  */
        uint32_t RESERVED4 : 6;        /*!< [31:26]  */
    } B;
} hw_mmdc_mapsr_t;

/*!
 * @name Constants and macros for entire MMDC_MAPSR register
 */
/*@{*/
#define HW_MMDC_MAPSR_ADDR(x)    ((uintptr_t)(x) + 0x404U)

#define HW_MMDC_MAPSR(x)         (*(__IO hw_mmdc_mapsr_t *) HW_MMDC_MAPSR_ADDR(x))
#define HW_MMDC_MAPSR_RD(x)      (HW_MMDC_MAPSR(x).U)
#define HW_MMDC_MAPSR_WR(x, v)   (HW_MMDC_MAPSR(x).U = (v))
#define HW_MMDC_MAPSR_SET(x, v)  (HW_MMDC_MAPSR_WR(x, HW_MMDC_MAPSR_RD(x) |  (v)))
#define HW_MMDC_MAPSR_CLR(x, v)  (HW_MMDC_MAPSR_WR(x, HW_MMDC_MAPSR_RD(x) & ~(v)))
#define HW_MMDC_MAPSR_TOG(x, v)  (HW_MMDC_MAPSR_WR(x, HW_MMDC_MAPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MAPSR bitfields
 */

/*!
 * @name Register MMDC_MAPSR, field PSD[0] (RW)
 *
 * Automatic Power Saving Disable. When the value of PSD is "0" (i.e automatic
 * power saving is enabled) then the PST is activated and MMDC will enter
 * automatically to self-refresh while the number of idle cycle reached. This bit must be
 * disabled (i.e set to "1") during calibration process
 *
 * Values:
 * - 0 - power saving enabled
 * - 1 - power saving disabled (default)
 */
/*@{*/
#define BP_MMDC_MAPSR_PSD    (0U)          /*!< Bit position for MMDC_MAPSR_PSD. */
#define BM_MMDC_MAPSR_PSD    (0x00000001U) /*!< Bit mask for MMDC_MAPSR_PSD. */
#define BS_MMDC_MAPSR_PSD    (1U)          /*!< Bit field size in bits for MMDC_MAPSR_PSD. */

/*! @brief Read current value of the MMDC_MAPSR_PSD field. */
#define BR_MMDC_MAPSR_PSD(x) (HW_MMDC_MAPSR(x).B.PSD)

/*! @brief Format value for bitfield MMDC_MAPSR_PSD. */
#define BF_MMDC_MAPSR_PSD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAPSR_PSD) & BM_MMDC_MAPSR_PSD)

/*! @brief Set the PSD field to a new value. */
#define BW_MMDC_MAPSR_PSD(x, v) (HW_MMDC_MAPSR_WR(x, (HW_MMDC_MAPSR_RD(x) & ~BM_MMDC_MAPSR_PSD) | BF_MMDC_MAPSR_PSD(v)))
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field PSS[4] (RO)
 *
 * Power Saving Status. This read only bit indicates whether the MMDC is in
 * automatic power saving mode.
 *
 * Values:
 * - 0 - not in power saving
 * - 1 - power saving
 */
/*@{*/
#define BP_MMDC_MAPSR_PSS    (4U)          /*!< Bit position for MMDC_MAPSR_PSS. */
#define BM_MMDC_MAPSR_PSS    (0x00000010U) /*!< Bit mask for MMDC_MAPSR_PSS. */
#define BS_MMDC_MAPSR_PSS    (1U)          /*!< Bit field size in bits for MMDC_MAPSR_PSS. */

/*! @brief Read current value of the MMDC_MAPSR_PSS field. */
#define BR_MMDC_MAPSR_PSS(x) (HW_MMDC_MAPSR(x).B.PSS)
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field RIS[5] (RO)
 *
 * Read Idle Status. This read only bit indicates whether read request buffer is
 * idle (empty) or not.
 *
 * Values:
 * - 0 - idle
 * - 1 - not idle
 */
/*@{*/
#define BP_MMDC_MAPSR_RIS    (5U)          /*!< Bit position for MMDC_MAPSR_RIS. */
#define BM_MMDC_MAPSR_RIS    (0x00000020U) /*!< Bit mask for MMDC_MAPSR_RIS. */
#define BS_MMDC_MAPSR_RIS    (1U)          /*!< Bit field size in bits for MMDC_MAPSR_RIS. */

/*! @brief Read current value of the MMDC_MAPSR_RIS field. */
#define BR_MMDC_MAPSR_RIS(x) (HW_MMDC_MAPSR(x).B.RIS)
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field WIS[6] (RO)
 *
 * Write Idle Status. This read only bit indicates whether write request buffer
 * is idle (empty) or not.
 *
 * Values:
 * - 0 - idle
 * - 1 - not idle
 */
/*@{*/
#define BP_MMDC_MAPSR_WIS    (6U)          /*!< Bit position for MMDC_MAPSR_WIS. */
#define BM_MMDC_MAPSR_WIS    (0x00000040U) /*!< Bit mask for MMDC_MAPSR_WIS. */
#define BS_MMDC_MAPSR_WIS    (1U)          /*!< Bit field size in bits for MMDC_MAPSR_WIS. */

/*! @brief Read current value of the MMDC_MAPSR_WIS field. */
#define BR_MMDC_MAPSR_WIS(x) (HW_MMDC_MAPSR(x).B.WIS)
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field PST[15:8] (RW)
 *
 * Automatic Power saving timer. Valid only when PSD is set to "0". When the
 * MMDC is idle for amount of cycles specified in that field then the DDR device
 * will be entered automatically into self-refresh mode. The real value which is
 * used is register-value multiplied by 64.
 *
 * Values:
 * - 00000000 - Reserved - this value is forbidden.
 * - 00000001 - timer is configured to 64 clock cycles.
 * - 00000010 - timer is configured to 128 clock cycles.
 * - 00010000 - (Default)- 1024 clock cycles.
 * - 11111111 - timer clock is configured to 16320 clock cycles.
 */
/*@{*/
#define BP_MMDC_MAPSR_PST    (8U)          /*!< Bit position for MMDC_MAPSR_PST. */
#define BM_MMDC_MAPSR_PST    (0x0000FF00U) /*!< Bit mask for MMDC_MAPSR_PST. */
#define BS_MMDC_MAPSR_PST    (8U)          /*!< Bit field size in bits for MMDC_MAPSR_PST. */

/*! @brief Read current value of the MMDC_MAPSR_PST field. */
#define BR_MMDC_MAPSR_PST(x) (HW_MMDC_MAPSR(x).B.PST)

/*! @brief Format value for bitfield MMDC_MAPSR_PST. */
#define BF_MMDC_MAPSR_PST(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAPSR_PST) & BM_MMDC_MAPSR_PST)

/*! @brief Set the PST field to a new value. */
#define BW_MMDC_MAPSR_PST(x, v) (HW_MMDC_MAPSR_WR(x, (HW_MMDC_MAPSR_RD(x) & ~BM_MMDC_MAPSR_PST) | BF_MMDC_MAPSR_PST(v)))
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field LPMD[20] (RW)
 *
 * General LPMD request. SW request for LPMD. Assertion of this bit will yield
 * in self-refresh entry sequence
 *
 * Values:
 * - 0 - no lpmd request
 * - 1 - lpmd request
 */
/*@{*/
#define BP_MMDC_MAPSR_LPMD   (20U)         /*!< Bit position for MMDC_MAPSR_LPMD. */
#define BM_MMDC_MAPSR_LPMD   (0x00100000U) /*!< Bit mask for MMDC_MAPSR_LPMD. */
#define BS_MMDC_MAPSR_LPMD   (1U)          /*!< Bit field size in bits for MMDC_MAPSR_LPMD. */

/*! @brief Read current value of the MMDC_MAPSR_LPMD field. */
#define BR_MMDC_MAPSR_LPMD(x) (HW_MMDC_MAPSR(x).B.LPMD)

/*! @brief Format value for bitfield MMDC_MAPSR_LPMD. */
#define BF_MMDC_MAPSR_LPMD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAPSR_LPMD) & BM_MMDC_MAPSR_LPMD)

/*! @brief Set the LPMD field to a new value. */
#define BW_MMDC_MAPSR_LPMD(x, v) (HW_MMDC_MAPSR_WR(x, (HW_MMDC_MAPSR_RD(x) & ~BM_MMDC_MAPSR_LPMD) | BF_MMDC_MAPSR_LPMD(v)))
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field DVFS[21] (RW)
 *
 * General DVFS request. SW request for DVFS. Assertion of this bit will yield
 * in self-refresh entry sequence
 *
 * Values:
 * - 0 - no dvfs request
 * - 1 - dvfs request
 */
/*@{*/
#define BP_MMDC_MAPSR_DVFS   (21U)         /*!< Bit position for MMDC_MAPSR_DVFS. */
#define BM_MMDC_MAPSR_DVFS   (0x00200000U) /*!< Bit mask for MMDC_MAPSR_DVFS. */
#define BS_MMDC_MAPSR_DVFS   (1U)          /*!< Bit field size in bits for MMDC_MAPSR_DVFS. */

/*! @brief Read current value of the MMDC_MAPSR_DVFS field. */
#define BR_MMDC_MAPSR_DVFS(x) (HW_MMDC_MAPSR(x).B.DVFS)

/*! @brief Format value for bitfield MMDC_MAPSR_DVFS. */
#define BF_MMDC_MAPSR_DVFS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAPSR_DVFS) & BM_MMDC_MAPSR_DVFS)

/*! @brief Set the DVFS field to a new value. */
#define BW_MMDC_MAPSR_DVFS(x, v) (HW_MMDC_MAPSR_WR(x, (HW_MMDC_MAPSR_RD(x) & ~BM_MMDC_MAPSR_DVFS) | BF_MMDC_MAPSR_DVFS(v)))
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field LPACK[24] (RO)
 *
 * General low-power acknowledge. This read only bit indicates whether a
 * low-power acknowledge was asserted and that MMDC is in self-refresh mode
 */
/*@{*/
#define BP_MMDC_MAPSR_LPACK  (24U)         /*!< Bit position for MMDC_MAPSR_LPACK. */
#define BM_MMDC_MAPSR_LPACK  (0x01000000U) /*!< Bit mask for MMDC_MAPSR_LPACK. */
#define BS_MMDC_MAPSR_LPACK  (1U)          /*!< Bit field size in bits for MMDC_MAPSR_LPACK. */

/*! @brief Read current value of the MMDC_MAPSR_LPACK field. */
#define BR_MMDC_MAPSR_LPACK(x) (HW_MMDC_MAPSR(x).B.LPACK)
/*@}*/

/*!
 * @name Register MMDC_MAPSR, field DVACK[25] (RO)
 *
 * General DVFS acknowledge. This read only bit indicates whether a dvfs
 * acknowledge was asserted and that MMDC is in self-refresh mode
 */
/*@{*/
#define BP_MMDC_MAPSR_DVACK  (25U)         /*!< Bit position for MMDC_MAPSR_DVACK. */
#define BM_MMDC_MAPSR_DVACK  (0x02000000U) /*!< Bit mask for MMDC_MAPSR_DVACK. */
#define BS_MMDC_MAPSR_DVACK  (1U)          /*!< Bit field size in bits for MMDC_MAPSR_DVACK. */

/*! @brief Read current value of the MMDC_MAPSR_DVACK field. */
#define BR_MMDC_MAPSR_DVACK(x) (HW_MMDC_MAPSR(x).B.DVACK)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MAEXIDR0 - MMDC Core Exclusive ID Monitor Register0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MAEXIDR0 - MMDC Core Exclusive ID Monitor Register0 (RW)
 *
 * Reset value: 0x00200000U
 *
 * This register defines the ID to be monitored for exclusive accesses of
 * monitor0 and monitor1. For further information see Exclusive accesses handlingThe
 * MMDC contains four exclusive monitors, each for dedicated ID as configured in
 * MAEXIDR0 and MAEXIDR1. . Supported Mode Of Operations: For Channel 0: All For
 * Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_maexidr0
{
    uint32_t U;
    struct _hw_mmdc_maexidr0_bitfields
    {
        uint32_t EXC_ID_MONITOR0 : 16; /*!< [15:0]  */
        uint32_t EXC_ID_MONITOR1 : 16; /*!< [31:16]  */
    } B;
} hw_mmdc_maexidr0_t;

/*!
 * @name Constants and macros for entire MMDC_MAEXIDR0 register
 */
/*@{*/
#define HW_MMDC_MAEXIDR0_ADDR(x) ((uintptr_t)(x) + 0x408U)

#define HW_MMDC_MAEXIDR0(x)      (*(__IO hw_mmdc_maexidr0_t *) HW_MMDC_MAEXIDR0_ADDR(x))
#define HW_MMDC_MAEXIDR0_RD(x)   (HW_MMDC_MAEXIDR0(x).U)
#define HW_MMDC_MAEXIDR0_WR(x, v) (HW_MMDC_MAEXIDR0(x).U = (v))
#define HW_MMDC_MAEXIDR0_SET(x, v) (HW_MMDC_MAEXIDR0_WR(x, HW_MMDC_MAEXIDR0_RD(x) |  (v)))
#define HW_MMDC_MAEXIDR0_CLR(x, v) (HW_MMDC_MAEXIDR0_WR(x, HW_MMDC_MAEXIDR0_RD(x) & ~(v)))
#define HW_MMDC_MAEXIDR0_TOG(x, v) (HW_MMDC_MAEXIDR0_WR(x, HW_MMDC_MAEXIDR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MAEXIDR0 bitfields
 */

/*!
 * @name Register MMDC_MAEXIDR0, field EXC_ID_MONITOR0[15:0] (RW)
 *
 * This field defines ID for Exclusive monitor#0. Default value is 0x0000
 */
/*@{*/
#define BP_MMDC_MAEXIDR0_EXC_ID_MONITOR0 (0U) /*!< Bit position for MMDC_MAEXIDR0_EXC_ID_MONITOR0. */
#define BM_MMDC_MAEXIDR0_EXC_ID_MONITOR0 (0x0000FFFFU) /*!< Bit mask for MMDC_MAEXIDR0_EXC_ID_MONITOR0. */
#define BS_MMDC_MAEXIDR0_EXC_ID_MONITOR0 (16U) /*!< Bit field size in bits for MMDC_MAEXIDR0_EXC_ID_MONITOR0. */

/*! @brief Read current value of the MMDC_MAEXIDR0_EXC_ID_MONITOR0 field. */
#define BR_MMDC_MAEXIDR0_EXC_ID_MONITOR0(x) (HW_MMDC_MAEXIDR0(x).B.EXC_ID_MONITOR0)

/*! @brief Format value for bitfield MMDC_MAEXIDR0_EXC_ID_MONITOR0. */
#define BF_MMDC_MAEXIDR0_EXC_ID_MONITOR0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAEXIDR0_EXC_ID_MONITOR0) & BM_MMDC_MAEXIDR0_EXC_ID_MONITOR0)

/*! @brief Set the EXC_ID_MONITOR0 field to a new value. */
#define BW_MMDC_MAEXIDR0_EXC_ID_MONITOR0(x, v) (HW_MMDC_MAEXIDR0_WR(x, (HW_MMDC_MAEXIDR0_RD(x) & ~BM_MMDC_MAEXIDR0_EXC_ID_MONITOR0) | BF_MMDC_MAEXIDR0_EXC_ID_MONITOR0(v)))
/*@}*/

/*!
 * @name Register MMDC_MAEXIDR0, field EXC_ID_MONITOR1[31:16] (RW)
 *
 * This field defines ID for Exclusive monitor#1. Default value is 0x0020
 */
/*@{*/
#define BP_MMDC_MAEXIDR0_EXC_ID_MONITOR1 (16U) /*!< Bit position for MMDC_MAEXIDR0_EXC_ID_MONITOR1. */
#define BM_MMDC_MAEXIDR0_EXC_ID_MONITOR1 (0xFFFF0000U) /*!< Bit mask for MMDC_MAEXIDR0_EXC_ID_MONITOR1. */
#define BS_MMDC_MAEXIDR0_EXC_ID_MONITOR1 (16U) /*!< Bit field size in bits for MMDC_MAEXIDR0_EXC_ID_MONITOR1. */

/*! @brief Read current value of the MMDC_MAEXIDR0_EXC_ID_MONITOR1 field. */
#define BR_MMDC_MAEXIDR0_EXC_ID_MONITOR1(x) (HW_MMDC_MAEXIDR0(x).B.EXC_ID_MONITOR1)

/*! @brief Format value for bitfield MMDC_MAEXIDR0_EXC_ID_MONITOR1. */
#define BF_MMDC_MAEXIDR0_EXC_ID_MONITOR1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAEXIDR0_EXC_ID_MONITOR1) & BM_MMDC_MAEXIDR0_EXC_ID_MONITOR1)

/*! @brief Set the EXC_ID_MONITOR1 field to a new value. */
#define BW_MMDC_MAEXIDR0_EXC_ID_MONITOR1(x, v) (HW_MMDC_MAEXIDR0_WR(x, (HW_MMDC_MAEXIDR0_RD(x) & ~BM_MMDC_MAEXIDR0_EXC_ID_MONITOR1) | BF_MMDC_MAEXIDR0_EXC_ID_MONITOR1(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MAEXIDR1 - MMDC Core Exclusive ID Monitor Register1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MAEXIDR1 - MMDC Core Exclusive ID Monitor Register1 (RW)
 *
 * Reset value: 0x00600040U
 *
 * This register defines the ID to be monitored for exclusive accesses of
 * monitor2 and monitor3. For further information see Exclusive accesses handlingThe
 * MMDC contains four exclusive monitors, each for dedicated ID as configured in
 * MAEXIDR0 and MAEXIDR1. . Supported Mode Of Operations: For Channel 0: All For
 * Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_maexidr1
{
    uint32_t U;
    struct _hw_mmdc_maexidr1_bitfields
    {
        uint32_t EXC_ID_MONITOR2 : 16; /*!< [15:0]  */
        uint32_t EXC_ID_MONITOR3 : 16; /*!< [31:16]  */
    } B;
} hw_mmdc_maexidr1_t;

/*!
 * @name Constants and macros for entire MMDC_MAEXIDR1 register
 */
/*@{*/
#define HW_MMDC_MAEXIDR1_ADDR(x) ((uintptr_t)(x) + 0x40CU)

#define HW_MMDC_MAEXIDR1(x)      (*(__IO hw_mmdc_maexidr1_t *) HW_MMDC_MAEXIDR1_ADDR(x))
#define HW_MMDC_MAEXIDR1_RD(x)   (HW_MMDC_MAEXIDR1(x).U)
#define HW_MMDC_MAEXIDR1_WR(x, v) (HW_MMDC_MAEXIDR1(x).U = (v))
#define HW_MMDC_MAEXIDR1_SET(x, v) (HW_MMDC_MAEXIDR1_WR(x, HW_MMDC_MAEXIDR1_RD(x) |  (v)))
#define HW_MMDC_MAEXIDR1_CLR(x, v) (HW_MMDC_MAEXIDR1_WR(x, HW_MMDC_MAEXIDR1_RD(x) & ~(v)))
#define HW_MMDC_MAEXIDR1_TOG(x, v) (HW_MMDC_MAEXIDR1_WR(x, HW_MMDC_MAEXIDR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MAEXIDR1 bitfields
 */

/*!
 * @name Register MMDC_MAEXIDR1, field EXC_ID_MONITOR2[15:0] (RW)
 *
 * This field defines ID for Exclusive monitor#2. Default value is 0x0040
 */
/*@{*/
#define BP_MMDC_MAEXIDR1_EXC_ID_MONITOR2 (0U) /*!< Bit position for MMDC_MAEXIDR1_EXC_ID_MONITOR2. */
#define BM_MMDC_MAEXIDR1_EXC_ID_MONITOR2 (0x0000FFFFU) /*!< Bit mask for MMDC_MAEXIDR1_EXC_ID_MONITOR2. */
#define BS_MMDC_MAEXIDR1_EXC_ID_MONITOR2 (16U) /*!< Bit field size in bits for MMDC_MAEXIDR1_EXC_ID_MONITOR2. */

/*! @brief Read current value of the MMDC_MAEXIDR1_EXC_ID_MONITOR2 field. */
#define BR_MMDC_MAEXIDR1_EXC_ID_MONITOR2(x) (HW_MMDC_MAEXIDR1(x).B.EXC_ID_MONITOR2)

/*! @brief Format value for bitfield MMDC_MAEXIDR1_EXC_ID_MONITOR2. */
#define BF_MMDC_MAEXIDR1_EXC_ID_MONITOR2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAEXIDR1_EXC_ID_MONITOR2) & BM_MMDC_MAEXIDR1_EXC_ID_MONITOR2)

/*! @brief Set the EXC_ID_MONITOR2 field to a new value. */
#define BW_MMDC_MAEXIDR1_EXC_ID_MONITOR2(x, v) (HW_MMDC_MAEXIDR1_WR(x, (HW_MMDC_MAEXIDR1_RD(x) & ~BM_MMDC_MAEXIDR1_EXC_ID_MONITOR2) | BF_MMDC_MAEXIDR1_EXC_ID_MONITOR2(v)))
/*@}*/

/*!
 * @name Register MMDC_MAEXIDR1, field EXC_ID_MONITOR3[31:16] (RW)
 *
 * This field defines ID for Exclusive monitor#3. Default value is 0x0060
 */
/*@{*/
#define BP_MMDC_MAEXIDR1_EXC_ID_MONITOR3 (16U) /*!< Bit position for MMDC_MAEXIDR1_EXC_ID_MONITOR3. */
#define BM_MMDC_MAEXIDR1_EXC_ID_MONITOR3 (0xFFFF0000U) /*!< Bit mask for MMDC_MAEXIDR1_EXC_ID_MONITOR3. */
#define BS_MMDC_MAEXIDR1_EXC_ID_MONITOR3 (16U) /*!< Bit field size in bits for MMDC_MAEXIDR1_EXC_ID_MONITOR3. */

/*! @brief Read current value of the MMDC_MAEXIDR1_EXC_ID_MONITOR3 field. */
#define BR_MMDC_MAEXIDR1_EXC_ID_MONITOR3(x) (HW_MMDC_MAEXIDR1(x).B.EXC_ID_MONITOR3)

/*! @brief Format value for bitfield MMDC_MAEXIDR1_EXC_ID_MONITOR3. */
#define BF_MMDC_MAEXIDR1_EXC_ID_MONITOR3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAEXIDR1_EXC_ID_MONITOR3) & BM_MMDC_MAEXIDR1_EXC_ID_MONITOR3)

/*! @brief Set the EXC_ID_MONITOR3 field to a new value. */
#define BW_MMDC_MAEXIDR1_EXC_ID_MONITOR3(x, v) (HW_MMDC_MAEXIDR1_WR(x, (HW_MMDC_MAEXIDR1_RD(x) & ~BM_MMDC_MAEXIDR1_EXC_ID_MONITOR3) | BF_MMDC_MAEXIDR1_EXC_ID_MONITOR3(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPCR0 - MMDC Core Debug and Profiling Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPCR0 - MMDC Core Debug and Profiling Control Register 0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_madpcr0
{
    uint32_t U;
    struct _hw_mmdc_madpcr0_bitfields
    {
        uint32_t DBG_EN : 1;           /*!< [0]  */
        uint32_t DBG_RST : 1;          /*!< [1]  */
        uint32_t PRF_FRZ : 1;          /*!< [2]  */
        uint32_t CYC_OVF : 1;          /*!< [3]  */
        uint32_t PROFILE_SEL : 1;      /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t SBS_EN : 1;           /*!< [8]  */
        uint32_t SBS : 1;              /*!< [9]  */
        uint32_t RESERVED1 : 22;       /*!< [31:10]  */
    } B;
} hw_mmdc_madpcr0_t;

/*!
 * @name Constants and macros for entire MMDC_MADPCR0 register
 */
/*@{*/
#define HW_MMDC_MADPCR0_ADDR(x)  ((uintptr_t)(x) + 0x410U)

#define HW_MMDC_MADPCR0(x)       (*(__IO hw_mmdc_madpcr0_t *) HW_MMDC_MADPCR0_ADDR(x))
#define HW_MMDC_MADPCR0_RD(x)    (HW_MMDC_MADPCR0(x).U)
#define HW_MMDC_MADPCR0_WR(x, v) (HW_MMDC_MADPCR0(x).U = (v))
#define HW_MMDC_MADPCR0_SET(x, v) (HW_MMDC_MADPCR0_WR(x, HW_MMDC_MADPCR0_RD(x) |  (v)))
#define HW_MMDC_MADPCR0_CLR(x, v) (HW_MMDC_MADPCR0_WR(x, HW_MMDC_MADPCR0_RD(x) & ~(v)))
#define HW_MMDC_MADPCR0_TOG(x, v) (HW_MMDC_MADPCR0_WR(x, HW_MMDC_MADPCR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPCR0 bitfields
 */

/*!
 * @name Register MMDC_MADPCR0, field DBG_EN[0] (RW)
 *
 * Debug and Profiling Enable. Enable debug and profiling mechanism. When this
 * bit is asserted then the MMDC will perform a profiling based on the ID that is
 * configured to MADPCR1. Upon assertion of PRF_FRZ the profiling will be froze
 * and the profiling results will be sampled to the status registers
 * (MADPSR0-MADPSR5). For further information see MMDC ProfilingThe profiling mechanism
 * provides the ability to calculate the DDR utilization together with read and write
 * accesses statistics towards DDR per given period of time. . default is "disable"
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_MMDC_MADPCR0_DBG_EN (0U)        /*!< Bit position for MMDC_MADPCR0_DBG_EN. */
#define BM_MMDC_MADPCR0_DBG_EN (0x00000001U) /*!< Bit mask for MMDC_MADPCR0_DBG_EN. */
#define BS_MMDC_MADPCR0_DBG_EN (1U)        /*!< Bit field size in bits for MMDC_MADPCR0_DBG_EN. */

/*! @brief Read current value of the MMDC_MADPCR0_DBG_EN field. */
#define BR_MMDC_MADPCR0_DBG_EN(x) (HW_MMDC_MADPCR0(x).B.DBG_EN)

/*! @brief Format value for bitfield MMDC_MADPCR0_DBG_EN. */
#define BF_MMDC_MADPCR0_DBG_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_DBG_EN) & BM_MMDC_MADPCR0_DBG_EN)

/*! @brief Set the DBG_EN field to a new value. */
#define BW_MMDC_MADPCR0_DBG_EN(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_DBG_EN | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_DBG_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field DBG_RST[1] (RW)
 *
 * Debug and Profiling Reset. Reset all debug and profiling counters and
 * components.
 *
 * Values:
 * - 0 - no reset
 * - 1 - reset
 */
/*@{*/
#define BP_MMDC_MADPCR0_DBG_RST (1U)       /*!< Bit position for MMDC_MADPCR0_DBG_RST. */
#define BM_MMDC_MADPCR0_DBG_RST (0x00000002U) /*!< Bit mask for MMDC_MADPCR0_DBG_RST. */
#define BS_MMDC_MADPCR0_DBG_RST (1U)       /*!< Bit field size in bits for MMDC_MADPCR0_DBG_RST. */

/*! @brief Read current value of the MMDC_MADPCR0_DBG_RST field. */
#define BR_MMDC_MADPCR0_DBG_RST(x) (HW_MMDC_MADPCR0(x).B.DBG_RST)

/*! @brief Format value for bitfield MMDC_MADPCR0_DBG_RST. */
#define BF_MMDC_MADPCR0_DBG_RST(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_DBG_RST) & BM_MMDC_MADPCR0_DBG_RST)

/*! @brief Set the DBG_RST field to a new value. */
#define BW_MMDC_MADPCR0_DBG_RST(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_DBG_RST | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_DBG_RST(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field PRF_FRZ[2] (RW)
 *
 * Profiling freeze. When this bit is asserted then the profiling mechanism will
 * be froze and the associated status registers ( MADPSR0-MADPSR5) will hold the
 * the current profiling values.
 *
 * Values:
 * - 0 - profiling counters are not frozen
 * - 1 - profiling counters are frozen
 */
/*@{*/
#define BP_MMDC_MADPCR0_PRF_FRZ (2U)       /*!< Bit position for MMDC_MADPCR0_PRF_FRZ. */
#define BM_MMDC_MADPCR0_PRF_FRZ (0x00000004U) /*!< Bit mask for MMDC_MADPCR0_PRF_FRZ. */
#define BS_MMDC_MADPCR0_PRF_FRZ (1U)       /*!< Bit field size in bits for MMDC_MADPCR0_PRF_FRZ. */

/*! @brief Read current value of the MMDC_MADPCR0_PRF_FRZ field. */
#define BR_MMDC_MADPCR0_PRF_FRZ(x) (HW_MMDC_MADPCR0(x).B.PRF_FRZ)

/*! @brief Format value for bitfield MMDC_MADPCR0_PRF_FRZ. */
#define BF_MMDC_MADPCR0_PRF_FRZ(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_PRF_FRZ) & BM_MMDC_MADPCR0_PRF_FRZ)

/*! @brief Set the PRF_FRZ field to a new value. */
#define BW_MMDC_MADPCR0_PRF_FRZ(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_PRF_FRZ | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_PRF_FRZ(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field CYC_OVF[3] (W1C)
 *
 * Total Profiling Cycles Count Overflow. When profiling mechanism is enabled
 * (DBG_EN is set to "1") then this bit is asserted when overflow of CYC_COUNT
 * occurred. Cleared by writing 1 to it.
 *
 * Values:
 * - 0 - no overflow
 * - 1 - overflow
 */
/*@{*/
#define BP_MMDC_MADPCR0_CYC_OVF (3U)       /*!< Bit position for MMDC_MADPCR0_CYC_OVF. */
#define BM_MMDC_MADPCR0_CYC_OVF (0x00000008U) /*!< Bit mask for MMDC_MADPCR0_CYC_OVF. */
#define BS_MMDC_MADPCR0_CYC_OVF (1U)       /*!< Bit field size in bits for MMDC_MADPCR0_CYC_OVF. */

/*! @brief Read current value of the MMDC_MADPCR0_CYC_OVF field. */
#define BR_MMDC_MADPCR0_CYC_OVF(x) (HW_MMDC_MADPCR0(x).B.CYC_OVF)

/*! @brief Format value for bitfield MMDC_MADPCR0_CYC_OVF. */
#define BF_MMDC_MADPCR0_CYC_OVF(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_CYC_OVF) & BM_MMDC_MADPCR0_CYC_OVF)

/*! @brief Set the CYC_OVF field to a new value. */
#define BW_MMDC_MADPCR0_CYC_OVF(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~BM_MMDC_MADPCR0_CYC_OVF) | BF_MMDC_MADPCR0_CYC_OVF(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field PROFILE_SEL[4] (RW)
 *
 * Profile source select bit Replaces axi_id with axi_user
 *
 * Values:
 * - 0 - Replace when NOC scheduler is enabled
 * - 1 - Replace when NOC scheduler is disabled
 */
/*@{*/
#define BP_MMDC_MADPCR0_PROFILE_SEL (4U)   /*!< Bit position for MMDC_MADPCR0_PROFILE_SEL. */
#define BM_MMDC_MADPCR0_PROFILE_SEL (0x00000010U) /*!< Bit mask for MMDC_MADPCR0_PROFILE_SEL. */
#define BS_MMDC_MADPCR0_PROFILE_SEL (1U)   /*!< Bit field size in bits for MMDC_MADPCR0_PROFILE_SEL. */

/*! @brief Read current value of the MMDC_MADPCR0_PROFILE_SEL field. */
#define BR_MMDC_MADPCR0_PROFILE_SEL(x) (HW_MMDC_MADPCR0(x).B.PROFILE_SEL)

/*! @brief Format value for bitfield MMDC_MADPCR0_PROFILE_SEL. */
#define BF_MMDC_MADPCR0_PROFILE_SEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_PROFILE_SEL) & BM_MMDC_MADPCR0_PROFILE_SEL)

/*! @brief Set the PROFILE_SEL field to a new value. */
#define BW_MMDC_MADPCR0_PROFILE_SEL(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_PROFILE_SEL | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_PROFILE_SEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field SBS_EN[8] (RW)
 *
 * Step By Step debug Enable. Enable step by step mode. Every time this
 * mechanism is enabled then setting SBS to "1" will dispatch one pending AXI access to
 * the DDR and in parallel its attributes will be observed in the status registes
 * (MASBS0 and MASBS1). For further information see Step By Step (SBS) software
 * monitorThe MMDC has a Step By Step (SBS) software debugging mechanism that
 * monitors each access that is driven to the MMDC. Once the "step by step" is
 * enabled (i.e. MADPCR0[SBS_EN] is "1") then all accesses to the DDR device will be
 * halted. .
 *
 * Values:
 * - 0 - disable
 * - 1 - enable
 */
/*@{*/
#define BP_MMDC_MADPCR0_SBS_EN (8U)        /*!< Bit position for MMDC_MADPCR0_SBS_EN. */
#define BM_MMDC_MADPCR0_SBS_EN (0x00000100U) /*!< Bit mask for MMDC_MADPCR0_SBS_EN. */
#define BS_MMDC_MADPCR0_SBS_EN (1U)        /*!< Bit field size in bits for MMDC_MADPCR0_SBS_EN. */

/*! @brief Read current value of the MMDC_MADPCR0_SBS_EN field. */
#define BR_MMDC_MADPCR0_SBS_EN(x) (HW_MMDC_MADPCR0(x).B.SBS_EN)

/*! @brief Format value for bitfield MMDC_MADPCR0_SBS_EN. */
#define BF_MMDC_MADPCR0_SBS_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_SBS_EN) & BM_MMDC_MADPCR0_SBS_EN)

/*! @brief Set the SBS_EN field to a new value. */
#define BW_MMDC_MADPCR0_SBS_EN(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_SBS_EN | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_SBS_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR0, field SBS[9] (RW)
 *
 * Step By Step trigger. If SBS_EN is set to "1" then dispatching AXI pending
 * access toward the DDR will done only if this bit is set to "1", otherwise no
 * access will be dispatched toward the DDR. This bit is cleared when the pending
 * access has been issued toward the DDR device.
 *
 * Values:
 * - 1 - Launch AXI pending access toward the DDR
 * - 0 - No access will be launched toward the DDR
 */
/*@{*/
#define BP_MMDC_MADPCR0_SBS  (9U)          /*!< Bit position for MMDC_MADPCR0_SBS. */
#define BM_MMDC_MADPCR0_SBS  (0x00000200U) /*!< Bit mask for MMDC_MADPCR0_SBS. */
#define BS_MMDC_MADPCR0_SBS  (1U)          /*!< Bit field size in bits for MMDC_MADPCR0_SBS. */

/*! @brief Read current value of the MMDC_MADPCR0_SBS field. */
#define BR_MMDC_MADPCR0_SBS(x) (HW_MMDC_MADPCR0(x).B.SBS)

/*! @brief Format value for bitfield MMDC_MADPCR0_SBS. */
#define BF_MMDC_MADPCR0_SBS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR0_SBS) & BM_MMDC_MADPCR0_SBS)

/*! @brief Set the SBS field to a new value. */
#define BW_MMDC_MADPCR0_SBS(x, v) (HW_MMDC_MADPCR0_WR(x, (HW_MMDC_MADPCR0_RD(x) & ~(BM_MMDC_MADPCR0_SBS | BM_MMDC_MADPCR0_CYC_OVF)) | BF_MMDC_MADPCR0_SBS(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPCR1 - MMDC Core Debug and Profiling Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPCR1 - MMDC Core Debug and Profiling Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_madpcr1
{
    uint32_t U;
    struct _hw_mmdc_madpcr1_bitfields
    {
        uint32_t PRF_AXI_ID : 16;      /*!< [15:0]  */
        uint32_t PRF_AXI_IDMASK : 16;  /*!< [31:16]  */
    } B;
} hw_mmdc_madpcr1_t;

/*!
 * @name Constants and macros for entire MMDC_MADPCR1 register
 */
/*@{*/
#define HW_MMDC_MADPCR1_ADDR(x)  ((uintptr_t)(x) + 0x414U)

#define HW_MMDC_MADPCR1(x)       (*(__IO hw_mmdc_madpcr1_t *) HW_MMDC_MADPCR1_ADDR(x))
#define HW_MMDC_MADPCR1_RD(x)    (HW_MMDC_MADPCR1(x).U)
#define HW_MMDC_MADPCR1_WR(x, v) (HW_MMDC_MADPCR1(x).U = (v))
#define HW_MMDC_MADPCR1_SET(x, v) (HW_MMDC_MADPCR1_WR(x, HW_MMDC_MADPCR1_RD(x) |  (v)))
#define HW_MMDC_MADPCR1_CLR(x, v) (HW_MMDC_MADPCR1_WR(x, HW_MMDC_MADPCR1_RD(x) & ~(v)))
#define HW_MMDC_MADPCR1_TOG(x, v) (HW_MMDC_MADPCR1_WR(x, HW_MMDC_MADPCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPCR1 bitfields
 */

/*!
 * @name Register MMDC_MADPCR1, field PRF_AXI_ID[15:0] (RW)
 *
 * Profiling AXI ID. AXI IDs that matches a bit-wise AND logic operation between
 * PRF_AXI_ID and PRF_AXI_ID_MASK are chosen for profiling. Default value is
 * 0x0, to choose any ID-s for profiling
 */
/*@{*/
#define BP_MMDC_MADPCR1_PRF_AXI_ID (0U)    /*!< Bit position for MMDC_MADPCR1_PRF_AXI_ID. */
#define BM_MMDC_MADPCR1_PRF_AXI_ID (0x0000FFFFU) /*!< Bit mask for MMDC_MADPCR1_PRF_AXI_ID. */
#define BS_MMDC_MADPCR1_PRF_AXI_ID (16U)   /*!< Bit field size in bits for MMDC_MADPCR1_PRF_AXI_ID. */

/*! @brief Read current value of the MMDC_MADPCR1_PRF_AXI_ID field. */
#define BR_MMDC_MADPCR1_PRF_AXI_ID(x) (HW_MMDC_MADPCR1(x).B.PRF_AXI_ID)

/*! @brief Format value for bitfield MMDC_MADPCR1_PRF_AXI_ID. */
#define BF_MMDC_MADPCR1_PRF_AXI_ID(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR1_PRF_AXI_ID) & BM_MMDC_MADPCR1_PRF_AXI_ID)

/*! @brief Set the PRF_AXI_ID field to a new value. */
#define BW_MMDC_MADPCR1_PRF_AXI_ID(x, v) (HW_MMDC_MADPCR1_WR(x, (HW_MMDC_MADPCR1_RD(x) & ~BM_MMDC_MADPCR1_PRF_AXI_ID) | BF_MMDC_MADPCR1_PRF_AXI_ID(v)))
/*@}*/

/*!
 * @name Register MMDC_MADPCR1, field PRF_AXI_IDMASK[31:16] (RW)
 *
 * Profiling AXI ID Mask. AXI ID bits which masked by this value are chosen for
 * profiling.
 *
 * Values:
 * - 1 - AXI ID specific bit is chosen for profiling
 * - 0 - AXI ID specific bit is ignored (don't care)
 */
/*@{*/
#define BP_MMDC_MADPCR1_PRF_AXI_IDMASK (16U) /*!< Bit position for MMDC_MADPCR1_PRF_AXI_IDMASK. */
#define BM_MMDC_MADPCR1_PRF_AXI_IDMASK (0xFFFF0000U) /*!< Bit mask for MMDC_MADPCR1_PRF_AXI_IDMASK. */
#define BS_MMDC_MADPCR1_PRF_AXI_IDMASK (16U) /*!< Bit field size in bits for MMDC_MADPCR1_PRF_AXI_IDMASK. */

/*! @brief Read current value of the MMDC_MADPCR1_PRF_AXI_IDMASK field. */
#define BR_MMDC_MADPCR1_PRF_AXI_IDMASK(x) (HW_MMDC_MADPCR1(x).B.PRF_AXI_IDMASK)

/*! @brief Format value for bitfield MMDC_MADPCR1_PRF_AXI_IDMASK. */
#define BF_MMDC_MADPCR1_PRF_AXI_IDMASK(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MADPCR1_PRF_AXI_IDMASK) & BM_MMDC_MADPCR1_PRF_AXI_IDMASK)

/*! @brief Set the PRF_AXI_IDMASK field to a new value. */
#define BW_MMDC_MADPCR1_PRF_AXI_IDMASK(x, v) (HW_MMDC_MADPCR1_WR(x, (HW_MMDC_MADPCR1_RD(x) & ~BM_MMDC_MADPCR1_PRF_AXI_IDMASK) | BF_MMDC_MADPCR1_PRF_AXI_IDMASK(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR0 - MMDC Core Debug and Profiling Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR0 - MMDC Core Debug and Profiling Status Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr0
{
    uint32_t U;
    struct _hw_mmdc_madpsr0_bitfields
    {
        uint32_t CYC_COUNT : 32;       /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr0_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR0 register
 */
/*@{*/
#define HW_MMDC_MADPSR0_ADDR(x)  ((uintptr_t)(x) + 0x418U)

#define HW_MMDC_MADPSR0(x)       (*(__I hw_mmdc_madpsr0_t *) HW_MMDC_MADPSR0_ADDR(x))
#define HW_MMDC_MADPSR0_RD(x)    (HW_MMDC_MADPSR0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR0 bitfields
 */

/*!
 * @name Register MMDC_MADPSR0, field CYC_COUNT[31:0] (RO)
 *
 * Total Profiling cycle Count. This field reflects the total cycle count in
 * case the profiling mechanism is enabled from assertion of DBG_EN and until
 * PRF_FRZ is asserted
 */
/*@{*/
#define BP_MMDC_MADPSR0_CYC_COUNT (0U)     /*!< Bit position for MMDC_MADPSR0_CYC_COUNT. */
#define BM_MMDC_MADPSR0_CYC_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR0_CYC_COUNT. */
#define BS_MMDC_MADPSR0_CYC_COUNT (32U)    /*!< Bit field size in bits for MMDC_MADPSR0_CYC_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR0_CYC_COUNT field. */
#define BR_MMDC_MADPSR0_CYC_COUNT(x) (HW_MMDC_MADPSR0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR1 - MMDC Core Debug and Profiling Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR1 - MMDC Core Debug and Profiling Status Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The register reflects the total cycles during which the MMDC state machines
 * were busy (both writes and reads). This information can be used for DDR
 * Utilization calculation. Supported Mode Of Operations: For Channel 0: All For Channel
 * 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr1
{
    uint32_t U;
    struct _hw_mmdc_madpsr1_bitfields
    {
        uint32_t BUSY_COUNT : 32;      /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr1_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR1 register
 */
/*@{*/
#define HW_MMDC_MADPSR1_ADDR(x)  ((uintptr_t)(x) + 0x41CU)

#define HW_MMDC_MADPSR1(x)       (*(__I hw_mmdc_madpsr1_t *) HW_MMDC_MADPSR1_ADDR(x))
#define HW_MMDC_MADPSR1_RD(x)    (HW_MMDC_MADPSR1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR1 bitfields
 */

/*!
 * @name Register MMDC_MADPSR1, field BUSY_COUNT[31:0] (RO)
 *
 * Profiling Busy Cycles Count. This field reflects the total number of cycles
 * where the MMDC read and write state machines were busy during the profiling
 * period. Can be used for DDR utilization calculations. Busy cycles are any MMDC
 * clock cycles where the internal state machine is not idle. If any read or write
 * requests are pending in the FIFOs, the MMDC is not idle.
 */
/*@{*/
#define BP_MMDC_MADPSR1_BUSY_COUNT (0U)    /*!< Bit position for MMDC_MADPSR1_BUSY_COUNT. */
#define BM_MMDC_MADPSR1_BUSY_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR1_BUSY_COUNT. */
#define BS_MMDC_MADPSR1_BUSY_COUNT (32U)   /*!< Bit field size in bits for MMDC_MADPSR1_BUSY_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR1_BUSY_COUNT field. */
#define BR_MMDC_MADPSR1_BUSY_COUNT(x) (HW_MMDC_MADPSR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR2 - MMDC Core Debug and Profiling Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR2 - MMDC Core Debug and Profiling Status Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects the total number of read accesses (per AXI ID) toward
 * MMDC. Supported Mode Of Operations: For Channel 0: All For Channel 1:
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr2
{
    uint32_t U;
    struct _hw_mmdc_madpsr2_bitfields
    {
        uint32_t RD_ACC_COUNT : 32;    /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr2_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR2 register
 */
/*@{*/
#define HW_MMDC_MADPSR2_ADDR(x)  ((uintptr_t)(x) + 0x420U)

#define HW_MMDC_MADPSR2(x)       (*(__I hw_mmdc_madpsr2_t *) HW_MMDC_MADPSR2_ADDR(x))
#define HW_MMDC_MADPSR2_RD(x)    (HW_MMDC_MADPSR2(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR2 bitfields
 */

/*!
 * @name Register MMDC_MADPSR2, field RD_ACC_COUNT[31:0] (RO)
 *
 * Profiling Read Access Count. This register reflects the total number of read
 * accesses (per AXI ID) toward MMDC.
 */
/*@{*/
#define BP_MMDC_MADPSR2_RD_ACC_COUNT (0U)  /*!< Bit position for MMDC_MADPSR2_RD_ACC_COUNT. */
#define BM_MMDC_MADPSR2_RD_ACC_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR2_RD_ACC_COUNT. */
#define BS_MMDC_MADPSR2_RD_ACC_COUNT (32U) /*!< Bit field size in bits for MMDC_MADPSR2_RD_ACC_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR2_RD_ACC_COUNT field. */
#define BR_MMDC_MADPSR2_RD_ACC_COUNT(x) (HW_MMDC_MADPSR2(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR3 - MMDC Core Debug and Profiling Status Register 3
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR3 - MMDC Core Debug and Profiling Status Register 3 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects the total number of write accesses (per AXI ID) toward
 * MMDC. Supported Mode Of Operations: For Channel 0: All For Channel 1:
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr3
{
    uint32_t U;
    struct _hw_mmdc_madpsr3_bitfields
    {
        uint32_t WR_ACC_COUNT : 32;    /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr3_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR3 register
 */
/*@{*/
#define HW_MMDC_MADPSR3_ADDR(x)  ((uintptr_t)(x) + 0x424U)

#define HW_MMDC_MADPSR3(x)       (*(__I hw_mmdc_madpsr3_t *) HW_MMDC_MADPSR3_ADDR(x))
#define HW_MMDC_MADPSR3_RD(x)    (HW_MMDC_MADPSR3(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR3 bitfields
 */

/*!
 * @name Register MMDC_MADPSR3, field WR_ACC_COUNT[31:0] (RO)
 *
 * Profiling Write Access Count. This register reflects the total number of
 * write accesses (per AXI ID) toward MMDC.
 */
/*@{*/
#define BP_MMDC_MADPSR3_WR_ACC_COUNT (0U)  /*!< Bit position for MMDC_MADPSR3_WR_ACC_COUNT. */
#define BM_MMDC_MADPSR3_WR_ACC_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR3_WR_ACC_COUNT. */
#define BS_MMDC_MADPSR3_WR_ACC_COUNT (32U) /*!< Bit field size in bits for MMDC_MADPSR3_WR_ACC_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR3_WR_ACC_COUNT field. */
#define BR_MMDC_MADPSR3_WR_ACC_COUNT(x) (HW_MMDC_MADPSR3(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR4 - MMDC Core Debug and Profiling Status Register 4
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR4 - MMDC Core Debug and Profiling Status Register 4 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects the total number of bytes that were transferred during
 * read access (per AXI ID) toward MMDC. Supported Mode Of Operations: For
 * Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr4
{
    uint32_t U;
    struct _hw_mmdc_madpsr4_bitfields
    {
        uint32_t RD_BYTES_COUNT : 32;  /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr4_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR4 register
 */
/*@{*/
#define HW_MMDC_MADPSR4_ADDR(x)  ((uintptr_t)(x) + 0x428U)

#define HW_MMDC_MADPSR4(x)       (*(__I hw_mmdc_madpsr4_t *) HW_MMDC_MADPSR4_ADDR(x))
#define HW_MMDC_MADPSR4_RD(x)    (HW_MMDC_MADPSR4(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR4 bitfields
 */

/*!
 * @name Register MMDC_MADPSR4, field RD_BYTES_COUNT[31:0] (RO)
 *
 * Profiling Read Bytes Count. This register reflects the total number of bytes
 * that were transferred during read access (per AXI ID) toward MMDC.
 */
/*@{*/
#define BP_MMDC_MADPSR4_RD_BYTES_COUNT (0U) /*!< Bit position for MMDC_MADPSR4_RD_BYTES_COUNT. */
#define BM_MMDC_MADPSR4_RD_BYTES_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR4_RD_BYTES_COUNT. */
#define BS_MMDC_MADPSR4_RD_BYTES_COUNT (32U) /*!< Bit field size in bits for MMDC_MADPSR4_RD_BYTES_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR4_RD_BYTES_COUNT field. */
#define BR_MMDC_MADPSR4_RD_BYTES_COUNT(x) (HW_MMDC_MADPSR4(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MADPSR5 - MMDC Core Debug and Profiling Status Register 5
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MADPSR5 - MMDC Core Debug and Profiling Status Register 5 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register reflects the total number of bytes that were transferred during
 * write access (per AXI ID) toward MMDC. Supported Mode Of Operations: For
 * Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_madpsr5
{
    uint32_t U;
    struct _hw_mmdc_madpsr5_bitfields
    {
        uint32_t WR_BYTES_COUNT : 32;  /*!< [31:0]  */
    } B;
} hw_mmdc_madpsr5_t;

/*!
 * @name Constants and macros for entire MMDC_MADPSR5 register
 */
/*@{*/
#define HW_MMDC_MADPSR5_ADDR(x)  ((uintptr_t)(x) + 0x42CU)

#define HW_MMDC_MADPSR5(x)       (*(__I hw_mmdc_madpsr5_t *) HW_MMDC_MADPSR5_ADDR(x))
#define HW_MMDC_MADPSR5_RD(x)    (HW_MMDC_MADPSR5(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MADPSR5 bitfields
 */

/*!
 * @name Register MMDC_MADPSR5, field WR_BYTES_COUNT[31:0] (RO)
 *
 * Profiling Write Bytes Count. This register reflects the total number of bytes
 * that were transferred during write access (per AXI ID) toward MMDC.
 */
/*@{*/
#define BP_MMDC_MADPSR5_WR_BYTES_COUNT (0U) /*!< Bit position for MMDC_MADPSR5_WR_BYTES_COUNT. */
#define BM_MMDC_MADPSR5_WR_BYTES_COUNT (0xFFFFFFFFU) /*!< Bit mask for MMDC_MADPSR5_WR_BYTES_COUNT. */
#define BS_MMDC_MADPSR5_WR_BYTES_COUNT (32U) /*!< Bit field size in bits for MMDC_MADPSR5_WR_BYTES_COUNT. */

/*! @brief Read current value of the MMDC_MADPSR5_WR_BYTES_COUNT field. */
#define BR_MMDC_MADPSR5_WR_BYTES_COUNT(x) (HW_MMDC_MADPSR5(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MASBS0 - MMDC Core Step By Step Address Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MASBS0 - MMDC Core Step By Step Address Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_masbs0
{
    uint32_t U;
    struct _hw_mmdc_masbs0_bitfields
    {
        uint32_t SBS_ADDR : 32;        /*!< [31:0]  */
    } B;
} hw_mmdc_masbs0_t;

/*!
 * @name Constants and macros for entire MMDC_MASBS0 register
 */
/*@{*/
#define HW_MMDC_MASBS0_ADDR(x)   ((uintptr_t)(x) + 0x430U)

#define HW_MMDC_MASBS0(x)        (*(__I hw_mmdc_masbs0_t *) HW_MMDC_MASBS0_ADDR(x))
#define HW_MMDC_MASBS0_RD(x)     (HW_MMDC_MASBS0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MASBS0 bitfields
 */

/*!
 * @name Register MMDC_MASBS0, field SBS_ADDR[31:0] (RO)
 *
 * Step By Step Address. These bits reflect the address of the pending request
 * in case of step by step mode.
 */
/*@{*/
#define BP_MMDC_MASBS0_SBS_ADDR (0U)       /*!< Bit position for MMDC_MASBS0_SBS_ADDR. */
#define BM_MMDC_MASBS0_SBS_ADDR (0xFFFFFFFFU) /*!< Bit mask for MMDC_MASBS0_SBS_ADDR. */
#define BS_MMDC_MASBS0_SBS_ADDR (32U)      /*!< Bit field size in bits for MMDC_MASBS0_SBS_ADDR. */

/*! @brief Read current value of the MMDC_MASBS0_SBS_ADDR field. */
#define BR_MMDC_MASBS0_SBS_ADDR(x) (HW_MMDC_MASBS0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MASBS1 - MMDC Core Step By Step Address Attributes Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MASBS1 - MMDC Core Step By Step Address Attributes Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_masbs1
{
    uint32_t U;
    struct _hw_mmdc_masbs1_bitfields
    {
        uint32_t SBS_VLD : 1;          /*!< [0]  */
        uint32_t SBS_TYPE : 1;         /*!< [1]  */
        uint32_t SBS_LOCK : 2;         /*!< [3:2]  */
        uint32_t SBS_PROT : 3;         /*!< [6:4]  */
        uint32_t SBS_SIZE : 3;         /*!< [9:7]  */
        uint32_t SBS_BURST : 2;        /*!< [11:10]  */
        uint32_t SBS_BUFF : 1;         /*!< [12]  */
        uint32_t SBS_LEN : 3;          /*!< [15:13]  */
        uint32_t SBS_AXI_ID : 16;      /*!< [31:16]  */
    } B;
} hw_mmdc_masbs1_t;

/*!
 * @name Constants and macros for entire MMDC_MASBS1 register
 */
/*@{*/
#define HW_MMDC_MASBS1_ADDR(x)   ((uintptr_t)(x) + 0x434U)

#define HW_MMDC_MASBS1(x)        (*(__I hw_mmdc_masbs1_t *) HW_MMDC_MASBS1_ADDR(x))
#define HW_MMDC_MASBS1_RD(x)     (HW_MMDC_MASBS1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MASBS1 bitfields
 */

/*!
 * @name Register MMDC_MASBS1, field SBS_VLD[0] (RO)
 *
 * Step By Step Valid. This bit reflects whether there is a pending request in
 * case of step by step mode.
 *
 * Values:
 * - 0 - not valid
 * - 1 - valid
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_VLD (0U)        /*!< Bit position for MMDC_MASBS1_SBS_VLD. */
#define BM_MMDC_MASBS1_SBS_VLD (0x00000001U) /*!< Bit mask for MMDC_MASBS1_SBS_VLD. */
#define BS_MMDC_MASBS1_SBS_VLD (1U)        /*!< Bit field size in bits for MMDC_MASBS1_SBS_VLD. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_VLD field. */
#define BR_MMDC_MASBS1_SBS_VLD(x) (HW_MMDC_MASBS1(x).B.SBS_VLD)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_TYPE[1] (RO)
 *
 * Step By Step Request Type. These bits reflect the type (read/write) of the
 * pending request in case of step by step mode.
 *
 * Values:
 * - 0 - write
 * - 1 - read
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_TYPE (1U)       /*!< Bit position for MMDC_MASBS1_SBS_TYPE. */
#define BM_MMDC_MASBS1_SBS_TYPE (0x00000002U) /*!< Bit mask for MMDC_MASBS1_SBS_TYPE. */
#define BS_MMDC_MASBS1_SBS_TYPE (1U)       /*!< Bit field size in bits for MMDC_MASBS1_SBS_TYPE. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_TYPE field. */
#define BR_MMDC_MASBS1_SBS_TYPE(x) (HW_MMDC_MASBS1(x).B.SBS_TYPE)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_LOCK[3:2] (RO)
 *
 * Step By Step Lock. These bits reflect the AXI LOCK of the pending request in
 * case of step by step mode.
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_LOCK (2U)       /*!< Bit position for MMDC_MASBS1_SBS_LOCK. */
#define BM_MMDC_MASBS1_SBS_LOCK (0x0000000CU) /*!< Bit mask for MMDC_MASBS1_SBS_LOCK. */
#define BS_MMDC_MASBS1_SBS_LOCK (2U)       /*!< Bit field size in bits for MMDC_MASBS1_SBS_LOCK. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_LOCK field. */
#define BR_MMDC_MASBS1_SBS_LOCK(x) (HW_MMDC_MASBS1(x).B.SBS_LOCK)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_PROT[6:4] (RO)
 *
 * Step By Step Protection. These bits reflect the AXI PROT of the pending
 * request in case of step by step mode.
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_PROT (4U)       /*!< Bit position for MMDC_MASBS1_SBS_PROT. */
#define BM_MMDC_MASBS1_SBS_PROT (0x00000070U) /*!< Bit mask for MMDC_MASBS1_SBS_PROT. */
#define BS_MMDC_MASBS1_SBS_PROT (3U)       /*!< Bit field size in bits for MMDC_MASBS1_SBS_PROT. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_PROT field. */
#define BR_MMDC_MASBS1_SBS_PROT(x) (HW_MMDC_MASBS1(x).B.SBS_PROT)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_SIZE[9:7] (RO)
 *
 * Step By Step Size. These bits reflect the AXI SIZE of the pending request in
 * case of step by step mode.
 *
 * Values:
 * - 000 - 8 bits
 * - 001 - 16 bits
 * - 010 - 32 bits
 * - 011 - 64 bits
 * - 100 - 128bits
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_SIZE (7U)       /*!< Bit position for MMDC_MASBS1_SBS_SIZE. */
#define BM_MMDC_MASBS1_SBS_SIZE (0x00000380U) /*!< Bit mask for MMDC_MASBS1_SBS_SIZE. */
#define BS_MMDC_MASBS1_SBS_SIZE (3U)       /*!< Bit field size in bits for MMDC_MASBS1_SBS_SIZE. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_SIZE field. */
#define BR_MMDC_MASBS1_SBS_SIZE(x) (HW_MMDC_MASBS1(x).B.SBS_SIZE)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_BURST[11:10] (RO)
 *
 * Step By Step Burst. These bits reflect the AXI BURST of the pending request
 * in case of step by step mode.
 *
 * Values:
 * - 00 - FIXED
 * - 01 - INCR burst
 * - 10 - WRAP burst
 * - 11 - reserved
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_BURST (10U)     /*!< Bit position for MMDC_MASBS1_SBS_BURST. */
#define BM_MMDC_MASBS1_SBS_BURST (0x00000C00U) /*!< Bit mask for MMDC_MASBS1_SBS_BURST. */
#define BS_MMDC_MASBS1_SBS_BURST (2U)      /*!< Bit field size in bits for MMDC_MASBS1_SBS_BURST. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_BURST field. */
#define BR_MMDC_MASBS1_SBS_BURST(x) (HW_MMDC_MASBS1(x).B.SBS_BURST)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_BUFF[12] (RO)
 *
 * Step By Step Buffered. This bit reflect the AXI CACHE[0] of the pending
 * request in case of step by step mode. Relevant only for write requests
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_BUFF (12U)      /*!< Bit position for MMDC_MASBS1_SBS_BUFF. */
#define BM_MMDC_MASBS1_SBS_BUFF (0x00001000U) /*!< Bit mask for MMDC_MASBS1_SBS_BUFF. */
#define BS_MMDC_MASBS1_SBS_BUFF (1U)       /*!< Bit field size in bits for MMDC_MASBS1_SBS_BUFF. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_BUFF field. */
#define BR_MMDC_MASBS1_SBS_BUFF(x) (HW_MMDC_MASBS1(x).B.SBS_BUFF)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_LEN[15:13] (RO)
 *
 * Step By Step Length. These bits reflect the AXI LENGTH of the pending request
 * in case of step by step mode.
 *
 * Values:
 * - 000 - burst of length 1
 * - 001 - burst of length 2
 * - 111 - burst of length 8
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_LEN (13U)       /*!< Bit position for MMDC_MASBS1_SBS_LEN. */
#define BM_MMDC_MASBS1_SBS_LEN (0x0000E000U) /*!< Bit mask for MMDC_MASBS1_SBS_LEN. */
#define BS_MMDC_MASBS1_SBS_LEN (3U)        /*!< Bit field size in bits for MMDC_MASBS1_SBS_LEN. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_LEN field. */
#define BR_MMDC_MASBS1_SBS_LEN(x) (HW_MMDC_MASBS1(x).B.SBS_LEN)
/*@}*/

/*!
 * @name Register MMDC_MASBS1, field SBS_AXI_ID[31:16] (RO)
 *
 * Step By Step AXI ID. These bits reflect the AXI ID of the pending request in
 * case of step by step mode.
 */
/*@{*/
#define BP_MMDC_MASBS1_SBS_AXI_ID (16U)    /*!< Bit position for MMDC_MASBS1_SBS_AXI_ID. */
#define BM_MMDC_MASBS1_SBS_AXI_ID (0xFFFF0000U) /*!< Bit mask for MMDC_MASBS1_SBS_AXI_ID. */
#define BS_MMDC_MASBS1_SBS_AXI_ID (16U)    /*!< Bit field size in bits for MMDC_MASBS1_SBS_AXI_ID. */

/*! @brief Read current value of the MMDC_MASBS1_SBS_AXI_ID field. */
#define BR_MMDC_MASBS1_SBS_AXI_ID(x) (HW_MMDC_MASBS1(x).B.SBS_AXI_ID)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MAGENP - MMDC Core General Purpose Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MAGENP - MMDC Core General Purpose Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is a general 32 bit read/write register. Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_magenp
{
    uint32_t U;
    struct _hw_mmdc_magenp_bitfields
    {
        uint32_t GP31_GP0 : 32;        /*!< [31:0]  */
    } B;
} hw_mmdc_magenp_t;

/*!
 * @name Constants and macros for entire MMDC_MAGENP register
 */
/*@{*/
#define HW_MMDC_MAGENP_ADDR(x)   ((uintptr_t)(x) + 0x440U)

#define HW_MMDC_MAGENP(x)        (*(__IO hw_mmdc_magenp_t *) HW_MMDC_MAGENP_ADDR(x))
#define HW_MMDC_MAGENP_RD(x)     (HW_MMDC_MAGENP(x).U)
#define HW_MMDC_MAGENP_WR(x, v)  (HW_MMDC_MAGENP(x).U = (v))
#define HW_MMDC_MAGENP_SET(x, v) (HW_MMDC_MAGENP_WR(x, HW_MMDC_MAGENP_RD(x) |  (v)))
#define HW_MMDC_MAGENP_CLR(x, v) (HW_MMDC_MAGENP_WR(x, HW_MMDC_MAGENP_RD(x) & ~(v)))
#define HW_MMDC_MAGENP_TOG(x, v) (HW_MMDC_MAGENP_WR(x, HW_MMDC_MAGENP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MAGENP bitfields
 */

/*!
 * @name Register MMDC_MAGENP, field GP31_GP0[31:0] (RW)
 *
 * General purpose read/write bits.
 */
/*@{*/
#define BP_MMDC_MAGENP_GP31_GP0 (0U)       /*!< Bit position for MMDC_MAGENP_GP31_GP0. */
#define BM_MMDC_MAGENP_GP31_GP0 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MAGENP_GP31_GP0. */
#define BS_MMDC_MAGENP_GP31_GP0 (32U)      /*!< Bit field size in bits for MMDC_MAGENP_GP31_GP0. */

/*! @brief Read current value of the MMDC_MAGENP_GP31_GP0 field. */
#define BR_MMDC_MAGENP_GP31_GP0(x) (HW_MMDC_MAGENP(x).U)

/*! @brief Format value for bitfield MMDC_MAGENP_GP31_GP0. */
#define BF_MMDC_MAGENP_GP31_GP0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MAGENP_GP31_GP0) & BM_MMDC_MAGENP_GP31_GP0)

/*! @brief Set the GP31_GP0 field to a new value. */
#define BW_MMDC_MAGENP_GP31_GP0(x, v) (HW_MMDC_MAGENP_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPZQHWCTRL - MMDC PHY ZQ HW control register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPZQHWCTRL - MMDC PHY ZQ HW control register (RW)
 *
 * Reset value: 0xA1380000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: This register
 * is reserved for channel 1. Channel 1 ZQ is also controlled by
 * MMDC0_MPZQHWCTRL.
 */
typedef union _hw_mmdc_mpzqhwctrl
{
    uint32_t U;
    struct _hw_mmdc_mpzqhwctrl_bitfields
    {
        uint32_t ZQ_MODE : 2;          /*!< [1:0]  */
        uint32_t ZQ_HW_PER : 4;        /*!< [5:2]  */
        uint32_t ZQ_HW_PU_RES : 5;     /*!< [10:6]  */
        uint32_t ZQ_HW_PD_RES : 5;     /*!< [15:11]  */
        uint32_t ZQ_HW_FOR : 1;        /*!< [16]  */
        uint32_t TZQ_INIT : 3;         /*!< [19:17]  */
        uint32_t TZQ_OPER : 3;         /*!< [22:20]  */
        uint32_t TZQ_CS : 3;           /*!< [25:23]  */
        uint32_t RESERVED0 : 1;        /*!< [26]  */
        uint32_t ZQ_EARLY_COMPARATOR_EN_TIMER : 5; /*!< [31:27]  */
    } B;
} hw_mmdc_mpzqhwctrl_t;

/*!
 * @name Constants and macros for entire MMDC_MPZQHWCTRL register
 */
/*@{*/
#define HW_MMDC_MPZQHWCTRL_ADDR(x) ((uintptr_t)(x) + 0x800U)

#define HW_MMDC_MPZQHWCTRL(x)    (*(__IO hw_mmdc_mpzqhwctrl_t *) HW_MMDC_MPZQHWCTRL_ADDR(x))
#define HW_MMDC_MPZQHWCTRL_RD(x) (HW_MMDC_MPZQHWCTRL(x).U)
#define HW_MMDC_MPZQHWCTRL_WR(x, v) (HW_MMDC_MPZQHWCTRL(x).U = (v))
#define HW_MMDC_MPZQHWCTRL_SET(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, HW_MMDC_MPZQHWCTRL_RD(x) |  (v)))
#define HW_MMDC_MPZQHWCTRL_CLR(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, HW_MMDC_MPZQHWCTRL_RD(x) & ~(v)))
#define HW_MMDC_MPZQHWCTRL_TOG(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, HW_MMDC_MPZQHWCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPZQHWCTRL bitfields
 */

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_MODE[1:0] (RW)
 *
 * ZQ calibration mode:
 *
 * Values:
 * - 0 - No ZQ calibration is issued. (Default)
 * - 1 - ZQ calibration is issued to i.MX ZQ calibration pad together with ZQ
 *     long command to the external DDR device only when exiting self refresh.
 * - 10 - ZQ calibration command long/short is issued only to the external DDR
 *     device periodically and when exiting self refresh
 * - 11 - ZQ calibration is issued to i.MX ZQ calibration pad together with ZQ
 *     calibration command long/short to the external DDR device periodically and
 *     when exiting self refresh
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_MODE (0U)    /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_MODE. */
#define BM_MMDC_MPZQHWCTRL_ZQ_MODE (0x00000003U) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_MODE. */
#define BS_MMDC_MPZQHWCTRL_ZQ_MODE (2U)    /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_MODE. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_MODE field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_MODE(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_MODE)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_ZQ_MODE. */
#define BF_MMDC_MPZQHWCTRL_ZQ_MODE(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_ZQ_MODE) & BM_MMDC_MPZQHWCTRL_ZQ_MODE)

/*! @brief Set the ZQ_MODE field to a new value. */
#define BW_MMDC_MPZQHWCTRL_ZQ_MODE(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_ZQ_MODE) | BF_MMDC_MPZQHWCTRL_ZQ_MODE(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_HW_PER[5:2] (RW)
 *
 * ZQ periodic calibration time. This field determines how often the periodic ZQ
 * calibration is performed. This field is applied for both ZQ short calibration
 * and ZQ automatic calibration process with i.MX ZQ calibration pad. Whenever
 * this timer is expired then according to ZQ_MODE the ZQ automatic calibration
 * process with the i.MX ZQ calibration pad will be issued and/or short/long
 * command will be issued to the external DDR device. This field is ignored if ZQ_MODE
 * equals "00"
 *
 * Values:
 * - 0000 - ZQ calibration is performed every 1 ms.
 * - 0001 - ZQ calibration is performed every 2 ms.
 * - 0010 - ZQ calibration is performed every 4 ms.
 * - 1010 - ZQ calibration is performed every 1 sec.
 * - 1110 - ZQ calibration is performed every 16 sec.
 * - 1111 - ZQ calibration is performed every 32 sec.
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_HW_PER (2U)  /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_HW_PER. */
#define BM_MMDC_MPZQHWCTRL_ZQ_HW_PER (0x0000003CU) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_HW_PER. */
#define BS_MMDC_MPZQHWCTRL_ZQ_HW_PER (4U)  /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_HW_PER. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_HW_PER field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_HW_PER(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_HW_PER)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_ZQ_HW_PER. */
#define BF_MMDC_MPZQHWCTRL_ZQ_HW_PER(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_ZQ_HW_PER) & BM_MMDC_MPZQHWCTRL_ZQ_HW_PER)

/*! @brief Set the ZQ_HW_PER field to a new value. */
#define BW_MMDC_MPZQHWCTRL_ZQ_HW_PER(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_ZQ_HW_PER) | BF_MMDC_MPZQHWCTRL_ZQ_HW_PER(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_HW_PU_RES[10:6] (RO)
 *
 * ZQ automatic calibration pull-up result. This field holds the pull-up
 * resistor value calculated at the end of the ZQ automatic calibration process with the
 * i.MX ZQ calibration pad. An offset can be applied to this result, see
 * MMDC_MPPDCMPR2[ZQ_PU_OFFSET]
 *
 * Values:
 * - 00000 - Min. resistance.
 * - 11111 - Max. resistance.
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_HW_PU_RES (6U) /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_HW_PU_RES. */
#define BM_MMDC_MPZQHWCTRL_ZQ_HW_PU_RES (0x000007C0U) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_HW_PU_RES. */
#define BS_MMDC_MPZQHWCTRL_ZQ_HW_PU_RES (5U) /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_HW_PU_RES. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_HW_PU_RES field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_HW_PU_RES(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_HW_PU_RES)
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_HW_PD_RES[15:11] (RO)
 *
 * ZQ HW calibration pull-down result. This field holds the pull-down resistor
 * value calculated at the end of the ZQ automatic calibration process with the
 * i.MX ZQ calibration pad. An offset can be applied to this result, see
 * MMDC_MPPDCMPR2[ZQ_PD_OFFSET].
 *
 * Values:
 * - 00000 - Max. resistance.
 * - 11111 - Min. resistance.
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_HW_PD_RES (11U) /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_HW_PD_RES. */
#define BM_MMDC_MPZQHWCTRL_ZQ_HW_PD_RES (0x0000F800U) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_HW_PD_RES. */
#define BS_MMDC_MPZQHWCTRL_ZQ_HW_PD_RES (5U) /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_HW_PD_RES. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_HW_PD_RES field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_HW_PD_RES(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_HW_PD_RES)
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_HW_FOR[16] (RW)
 *
 * Force ZQ automatic calibration process with the i.MX ZQ calibration pad. When
 * this bit is asserted then the MMDC will issue one ZQ automatic calibration
 * process with the i.MX ZQ calibration pad. It is the user responsibility to make
 * sure that all the accesses to DDR will be finished before asserting this bit
 * using CON_REQ/CON_ACK mechanism. HW will negate this bit upon completion of the
 * ZQ calibration process. Upon negation of this bit the ZQ HW calibration
 * pull-up and pull-down results (ZQ_HW_PU_RES and ZQ_HW_PD_RES respectively) are
 * valid In order to enable this bit ZQ_MODE must be set to either "1" or "3"
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_HW_FOR (16U) /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_HW_FOR. */
#define BM_MMDC_MPZQHWCTRL_ZQ_HW_FOR (0x00010000U) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_HW_FOR. */
#define BS_MMDC_MPZQHWCTRL_ZQ_HW_FOR (1U)  /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_HW_FOR. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_HW_FOR field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_HW_FOR(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_HW_FOR)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_ZQ_HW_FOR. */
#define BF_MMDC_MPZQHWCTRL_ZQ_HW_FOR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_ZQ_HW_FOR) & BM_MMDC_MPZQHWCTRL_ZQ_HW_FOR)

/*! @brief Set the ZQ_HW_FOR field to a new value. */
#define BW_MMDC_MPZQHWCTRL_ZQ_HW_FOR(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_ZQ_HW_FOR) | BF_MMDC_MPZQHWCTRL_ZQ_HW_FOR(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field TZQ_INIT[19:17] (RW)
 *
 * Device ZQ long/init time. This field holds the number of cycles that are
 * required by the external DDR device to perform ZQ long calibration right after
 * reset. Upon driving the command to the DDR device then no further accesses will
 * be issued to the DDR device till satisfying that time. In LPDDR2 the ZQ init
 * time is taken from MPZQLP2CTL[ZQ_LP2_HW_ZQINIT] This field should not be update
 * during ZQ calibration.
 *
 * Values:
 * - 000 - Reserved
 * - 001 - Reserved
 * - 010 - 128 cycles
 * - 011 - 256 cycles
 * - 100 - 512 cycles - Default (JEDEC value for DDR3)
 * - 101 - 1024 cycles
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_TZQ_INIT (17U)  /*!< Bit position for MMDC_MPZQHWCTRL_TZQ_INIT. */
#define BM_MMDC_MPZQHWCTRL_TZQ_INIT (0x000E0000U) /*!< Bit mask for MMDC_MPZQHWCTRL_TZQ_INIT. */
#define BS_MMDC_MPZQHWCTRL_TZQ_INIT (3U)   /*!< Bit field size in bits for MMDC_MPZQHWCTRL_TZQ_INIT. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_TZQ_INIT field. */
#define BR_MMDC_MPZQHWCTRL_TZQ_INIT(x) (HW_MMDC_MPZQHWCTRL(x).B.TZQ_INIT)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_TZQ_INIT. */
#define BF_MMDC_MPZQHWCTRL_TZQ_INIT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_TZQ_INIT) & BM_MMDC_MPZQHWCTRL_TZQ_INIT)

/*! @brief Set the TZQ_INIT field to a new value. */
#define BW_MMDC_MPZQHWCTRL_TZQ_INIT(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_TZQ_INIT) | BF_MMDC_MPZQHWCTRL_TZQ_INIT(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field TZQ_OPER[22:20] (RW)
 *
 * Device ZQ long/oper time. This field holds the number of cycles that are
 * required by the external DDR device to perform ZQ long calibration except the
 * first ZQ long command that is issued after reset. Upon driving the command to the
 * DDR device then no further accesses will be issued to the DDR device till
 * satisfying that time. In LPDDR2 the ZQ oper time is taken from
 * MPZQLP2CTL[ZQ_LP2_HW_ZQCL] This field should not be update during ZQ calibration.
 *
 * Values:
 * - 000 - Reserved
 * - 001 - Reserved
 * - 010 - 128 cycles
 * - 011 - 256 cycles - Default (JEDEC value for DDR3)
 * - 100 - 512 cycles
 * - 101 - 1024 cycles
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_TZQ_OPER (20U)  /*!< Bit position for MMDC_MPZQHWCTRL_TZQ_OPER. */
#define BM_MMDC_MPZQHWCTRL_TZQ_OPER (0x00700000U) /*!< Bit mask for MMDC_MPZQHWCTRL_TZQ_OPER. */
#define BS_MMDC_MPZQHWCTRL_TZQ_OPER (3U)   /*!< Bit field size in bits for MMDC_MPZQHWCTRL_TZQ_OPER. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_TZQ_OPER field. */
#define BR_MMDC_MPZQHWCTRL_TZQ_OPER(x) (HW_MMDC_MPZQHWCTRL(x).B.TZQ_OPER)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_TZQ_OPER. */
#define BF_MMDC_MPZQHWCTRL_TZQ_OPER(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_TZQ_OPER) & BM_MMDC_MPZQHWCTRL_TZQ_OPER)

/*! @brief Set the TZQ_OPER field to a new value. */
#define BW_MMDC_MPZQHWCTRL_TZQ_OPER(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_TZQ_OPER) | BF_MMDC_MPZQHWCTRL_TZQ_OPER(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field TZQ_CS[25:23] (RW)
 *
 * Device ZQ short time. This field holds the number of cycles that are required
 * by the external DDR device to perform ZQ short calibration. Upon driving the
 * command to the DDR device then no further accesses will be issued to the DDR
 * device till satisfying that time. In LPDDR2 the ZQ short time is taken from
 * MPZQLP2CTL[ZQ_LP2_HW_ZQCS] This field should not be update during ZQ calibration.
 *
 * Values:
 * - 000 - Reserved
 * - 001 - Reserved
 * - 010 - 128 cycles (Default)
 * - 011 - 256 cycles
 * - 100 - 512 cycles
 * - 101 - 1024 cycles
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_TZQ_CS (23U)    /*!< Bit position for MMDC_MPZQHWCTRL_TZQ_CS. */
#define BM_MMDC_MPZQHWCTRL_TZQ_CS (0x03800000U) /*!< Bit mask for MMDC_MPZQHWCTRL_TZQ_CS. */
#define BS_MMDC_MPZQHWCTRL_TZQ_CS (3U)     /*!< Bit field size in bits for MMDC_MPZQHWCTRL_TZQ_CS. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_TZQ_CS field. */
#define BR_MMDC_MPZQHWCTRL_TZQ_CS(x) (HW_MMDC_MPZQHWCTRL(x).B.TZQ_CS)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_TZQ_CS. */
#define BF_MMDC_MPZQHWCTRL_TZQ_CS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_TZQ_CS) & BM_MMDC_MPZQHWCTRL_TZQ_CS)

/*! @brief Set the TZQ_CS field to a new value. */
#define BW_MMDC_MPZQHWCTRL_TZQ_CS(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_TZQ_CS) | BF_MMDC_MPZQHWCTRL_TZQ_CS(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQHWCTRL, field ZQ_EARLY_COMPARATOR_EN_TIMER[31:27] (RW)
 *
 * ZQ early comparator enable timer. This timer defines the interval between the
 * warming up of the comparator of the i.MX ZQ calibration pad and the beginning
 * of the ZQ calibration process with the pad
 *
 * Values:
 * - 0 - - 0x6 Reserved
 * - 111 - 8 cycles
 * - 10100 - 21 cycles (Default)
 * - 11110 - 31 cycles
 * - 11111 - 32 cycles
 */
/*@{*/
#define BP_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER (27U) /*!< Bit position for MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER. */
#define BM_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER (0xF8000000U) /*!< Bit mask for MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER. */
#define BS_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER (5U) /*!< Bit field size in bits for MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER. */

/*! @brief Read current value of the MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER field. */
#define BR_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER(x) (HW_MMDC_MPZQHWCTRL(x).B.ZQ_EARLY_COMPARATOR_EN_TIMER)

/*! @brief Format value for bitfield MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER. */
#define BF_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER) & BM_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER)

/*! @brief Set the ZQ_EARLY_COMPARATOR_EN_TIMER field to a new value. */
#define BW_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER(x, v) (HW_MMDC_MPZQHWCTRL_WR(x, (HW_MMDC_MPZQHWCTRL_RD(x) & ~BM_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER) | BF_MMDC_MPZQHWCTRL_ZQ_EARLY_COMPARATOR_EN_TIMER(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPZQSWCTRL - MMDC PHY ZQ SW control register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPZQSWCTRL - MMDC PHY ZQ SW control register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: This register
 * is reserved. Channel 1 ZQ is also controlled by MMDC0_MPZQHWCTRL.
 */
typedef union _hw_mmdc_mpzqswctrl
{
    uint32_t U;
    struct _hw_mmdc_mpzqswctrl_bitfields
    {
        uint32_t ZQ_SW_FOR : 1;        /*!< [0]  */
        uint32_t ZQ_SW_RES : 1;        /*!< [1]  */
        uint32_t ZQ_SW_PU_VAL : 5;     /*!< [6:2]  */
        uint32_t ZQ_SW_PD_VAL : 5;     /*!< [11:7]  */
        uint32_t ZQ_SW_PD : 1;         /*!< [12]  */
        uint32_t USE_ZQ_SW_VAL : 1;    /*!< [13]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t ZQ_CMP_OUT_SMP : 2;   /*!< [17:16]  */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_mmdc_mpzqswctrl_t;

/*!
 * @name Constants and macros for entire MMDC_MPZQSWCTRL register
 */
/*@{*/
#define HW_MMDC_MPZQSWCTRL_ADDR(x) ((uintptr_t)(x) + 0x804U)

#define HW_MMDC_MPZQSWCTRL(x)    (*(__IO hw_mmdc_mpzqswctrl_t *) HW_MMDC_MPZQSWCTRL_ADDR(x))
#define HW_MMDC_MPZQSWCTRL_RD(x) (HW_MMDC_MPZQSWCTRL(x).U)
#define HW_MMDC_MPZQSWCTRL_WR(x, v) (HW_MMDC_MPZQSWCTRL(x).U = (v))
#define HW_MMDC_MPZQSWCTRL_SET(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, HW_MMDC_MPZQSWCTRL_RD(x) |  (v)))
#define HW_MMDC_MPZQSWCTRL_CLR(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, HW_MMDC_MPZQSWCTRL_RD(x) & ~(v)))
#define HW_MMDC_MPZQSWCTRL_TOG(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, HW_MMDC_MPZQSWCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPZQSWCTRL bitfields
 */

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_SW_FOR[0] (RW)
 *
 * ZQ SW calibration enable. This bit when asserted enables ZQ SW calibration.
 * HW negates this bit upon completion of the ZQ SW calibration. Upon negation of
 * this bit the ZQ SW calibration result (i.e ZQ_SW_RES) is valid
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_SW_FOR (0U)  /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_SW_FOR. */
#define BM_MMDC_MPZQSWCTRL_ZQ_SW_FOR (0x00000001U) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_SW_FOR. */
#define BS_MMDC_MPZQSWCTRL_ZQ_SW_FOR (1U)  /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_SW_FOR. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_SW_FOR field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_SW_FOR(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_SW_FOR)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_ZQ_SW_FOR. */
#define BF_MMDC_MPZQSWCTRL_ZQ_SW_FOR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_ZQ_SW_FOR) & BM_MMDC_MPZQSWCTRL_ZQ_SW_FOR)

/*! @brief Set the ZQ_SW_FOR field to a new value. */
#define BW_MMDC_MPZQSWCTRL_ZQ_SW_FOR(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_ZQ_SW_FOR) | BF_MMDC_MPZQSWCTRL_ZQ_SW_FOR(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_SW_RES[1] (RO)
 *
 * ZQ software calibration result. This bit reflects the ZQ calibration voltage
 * comparator value.
 *
 * Values:
 * - 0 - Current ZQ calibration voltage is less than VDD/2.
 * - 1 - Current ZQ calibration voltage is more than VDD/2
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_SW_RES (1U)  /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_SW_RES. */
#define BM_MMDC_MPZQSWCTRL_ZQ_SW_RES (0x00000002U) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_SW_RES. */
#define BS_MMDC_MPZQSWCTRL_ZQ_SW_RES (1U)  /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_SW_RES. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_SW_RES field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_SW_RES(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_SW_RES)
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_SW_PU_VAL[6:2] (RW)
 *
 * ZQ software pull-up resistence. This field determines the value of the PU
 * resistor during SW ZQ calibration.
 *
 * Values:
 * - 00000 - Min. resistance.
 * - 11111 - Max. resistance.
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL (2U) /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL. */
#define BM_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL (0x0000007CU) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL. */
#define BS_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL (5U) /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_SW_PU_VAL)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL. */
#define BF_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL) & BM_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL)

/*! @brief Set the ZQ_SW_PU_VAL field to a new value. */
#define BW_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL) | BF_MMDC_MPZQSWCTRL_ZQ_SW_PU_VAL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_SW_PD_VAL[11:7] (RW)
 *
 * ZQ software pull-down resistence. This field determines the value of the PD
 * resistor during SW ZQ calibration.
 *
 * Values:
 * - 00000 - Max. resistance.
 * - 11111 - Min. resistance.
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL (7U) /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL. */
#define BM_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL (0x00000F80U) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL. */
#define BS_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL (5U) /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_SW_PD_VAL)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL. */
#define BF_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL) & BM_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL)

/*! @brief Set the ZQ_SW_PD_VAL field to a new value. */
#define BW_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL) | BF_MMDC_MPZQSWCTRL_ZQ_SW_PD_VAL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_SW_PD[12] (RW)
 *
 * ZQ software PU/PD calibration. This bit determines the calibration stage (PU
 * or PD).
 *
 * Values:
 * - 0 - PU resistor calibration
 * - 1 - PD resistor calibration
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_SW_PD (12U)  /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_SW_PD. */
#define BM_MMDC_MPZQSWCTRL_ZQ_SW_PD (0x00001000U) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_SW_PD. */
#define BS_MMDC_MPZQSWCTRL_ZQ_SW_PD (1U)   /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_SW_PD. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_SW_PD field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_SW_PD(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_SW_PD)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_ZQ_SW_PD. */
#define BF_MMDC_MPZQSWCTRL_ZQ_SW_PD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_ZQ_SW_PD) & BM_MMDC_MPZQSWCTRL_ZQ_SW_PD)

/*! @brief Set the ZQ_SW_PD field to a new value. */
#define BW_MMDC_MPZQSWCTRL_ZQ_SW_PD(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_ZQ_SW_PD) | BF_MMDC_MPZQSWCTRL_ZQ_SW_PD(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field USE_ZQ_SW_VAL[13] (RW)
 *
 * Use SW ZQ configured value for I/O pads resistor controls. This bit selects
 * whether ZQ SW value or ZQ HW value will be driven to the I/O pads resistor
 * controls. By default this bit is cleared and MMDC drives the HW ZQ status bits on
 * the resistor controls of the I/O pads. This bit should not be updated during
 * ZQ calibration.
 *
 * Values:
 * - 0 - Fields ZQ_HW_PD_VAL & ZQ_HW_PU_VAL will be driven to I/O pads resistor
 *     controls.
 * - 1 - Fields ZQ_SW_PD_VAL & ZQ_SW_PU_VAL will be driven to I/O pads resistor
 *     controls.
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL (13U) /*!< Bit position for MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL. */
#define BM_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL (0x00002000U) /*!< Bit mask for MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL. */
#define BS_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL (1U) /*!< Bit field size in bits for MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL field. */
#define BR_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL(x) (HW_MMDC_MPZQSWCTRL(x).B.USE_ZQ_SW_VAL)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL. */
#define BF_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL) & BM_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL)

/*! @brief Set the USE_ZQ_SW_VAL field to a new value. */
#define BW_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL) | BF_MMDC_MPZQSWCTRL_USE_ZQ_SW_VAL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQSWCTRL, field ZQ_CMP_OUT_SMP[17:16] (RW)
 *
 * Defines the amount of cycles between driving the ZQ signals to the ZQ pad and
 * till sampling the comparator enable output while performing ZQ calibration
 * process with the i.MX ZQ calibration pad
 *
 * Values:
 * - 00 - 7 cycles
 * - 01 - 15 cycles
 * - 10 - 23 cycles
 * - 11 - 31 cycles
 */
/*@{*/
#define BP_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP (16U) /*!< Bit position for MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP. */
#define BM_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP (0x00030000U) /*!< Bit mask for MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP. */
#define BS_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP (2U) /*!< Bit field size in bits for MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP. */

/*! @brief Read current value of the MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP field. */
#define BR_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP(x) (HW_MMDC_MPZQSWCTRL(x).B.ZQ_CMP_OUT_SMP)

/*! @brief Format value for bitfield MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP. */
#define BF_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP) & BM_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP)

/*! @brief Set the ZQ_CMP_OUT_SMP field to a new value. */
#define BW_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP(x, v) (HW_MMDC_MPZQSWCTRL_WR(x, (HW_MMDC_MPZQSWCTRL_RD(x) & ~BM_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP) | BF_MMDC_MPZQSWCTRL_ZQ_CMP_OUT_SMP(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWLGCR - MMDC PHY Write Leveling Configuration and Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWLGCR - MMDC PHY Write Leveling Configuration and Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwlgcr
{
    uint32_t U;
    struct _hw_mmdc_mpwlgcr_bitfields
    {
        uint32_t HW_WL_EN : 1;         /*!< [0]  */
        uint32_t SW_WL_EN : 1;         /*!< [1]  */
        uint32_t SW_WL_CNT_EN : 1;     /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t WL_SW_RES0 : 1;       /*!< [4]  */
        uint32_t WL_SW_RES1 : 1;       /*!< [5]  */
        uint32_t WL_SW_RES2 : 1;       /*!< [6]  */
        uint32_t WL_SW_RES3 : 1;       /*!< [7]  */
        uint32_t WL_HW_ERR0 : 1;       /*!< [8]  */
        uint32_t WL_HW_ERR1 : 1;       /*!< [9]  */
        uint32_t WL_HW_ERR2 : 1;       /*!< [10]  */
        uint32_t WL_HW_ERR3 : 1;       /*!< [11]  */
        uint32_t RESERVED1 : 20;       /*!< [31:12]  */
    } B;
} hw_mmdc_mpwlgcr_t;

/*!
 * @name Constants and macros for entire MMDC_MPWLGCR register
 */
/*@{*/
#define HW_MMDC_MPWLGCR_ADDR(x)  ((uintptr_t)(x) + 0x808U)

#define HW_MMDC_MPWLGCR(x)       (*(__IO hw_mmdc_mpwlgcr_t *) HW_MMDC_MPWLGCR_ADDR(x))
#define HW_MMDC_MPWLGCR_RD(x)    (HW_MMDC_MPWLGCR(x).U)
#define HW_MMDC_MPWLGCR_WR(x, v) (HW_MMDC_MPWLGCR(x).U = (v))
#define HW_MMDC_MPWLGCR_SET(x, v) (HW_MMDC_MPWLGCR_WR(x, HW_MMDC_MPWLGCR_RD(x) |  (v)))
#define HW_MMDC_MPWLGCR_CLR(x, v) (HW_MMDC_MPWLGCR_WR(x, HW_MMDC_MPWLGCR_RD(x) & ~(v)))
#define HW_MMDC_MPWLGCR_TOG(x, v) (HW_MMDC_MPWLGCR_WR(x, HW_MMDC_MPWLGCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWLGCR bitfields
 */

/*!
 * @name Register MMDC_MPWLGCR, field HW_WL_EN[0] (RW)
 *
 * Write-Leveling HW (automatic) enable. If this bit is asserted then the MMDC
 * will perform the whole Write-Leveling sequence with the DDR device (assuming
 * that Write-Leveling procedure is already enabled in the DDR device through MRS
 * command). HW negates this bit upon completion of the HW write-leveling.
 * Negation of this bit also points that the write-leveling HW calibration results are
 * valid Before issuing the first DQS the MMDC counts 25 + 15 cycles automatically
 * as required by the standard.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_HW_WL_EN (0U)      /*!< Bit position for MMDC_MPWLGCR_HW_WL_EN. */
#define BM_MMDC_MPWLGCR_HW_WL_EN (0x00000001U) /*!< Bit mask for MMDC_MPWLGCR_HW_WL_EN. */
#define BS_MMDC_MPWLGCR_HW_WL_EN (1U)      /*!< Bit field size in bits for MMDC_MPWLGCR_HW_WL_EN. */

/*! @brief Read current value of the MMDC_MPWLGCR_HW_WL_EN field. */
#define BR_MMDC_MPWLGCR_HW_WL_EN(x) (HW_MMDC_MPWLGCR(x).B.HW_WL_EN)

/*! @brief Format value for bitfield MMDC_MPWLGCR_HW_WL_EN. */
#define BF_MMDC_MPWLGCR_HW_WL_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLGCR_HW_WL_EN) & BM_MMDC_MPWLGCR_HW_WL_EN)

/*! @brief Set the HW_WL_EN field to a new value. */
#define BW_MMDC_MPWLGCR_HW_WL_EN(x, v) (HW_MMDC_MPWLGCR_WR(x, (HW_MMDC_MPWLGCR_RD(x) & ~BM_MMDC_MPWLGCR_HW_WL_EN) | BF_MMDC_MPWLGCR_HW_WL_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field SW_WL_EN[1] (RW)
 *
 * Write-Leveling SW enable. If this bit is asserted then the MMDC will perform
 * one write-leveling iteration with the DDR device (assuming that Write-Leveling
 * procedure is already enabled in the DDR device through MRS command). HW
 * negate this bit upon completion of the SW write-leveling. Negation of this bit also
 * points that the write-leveling SW calibration result is valid If this bit and
 * the SW_WL_CNT_EN are enabled the MMDC counts 25 + 15 cycles before issuing
 * the SW write-leveling DQS.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_SW_WL_EN (1U)      /*!< Bit position for MMDC_MPWLGCR_SW_WL_EN. */
#define BM_MMDC_MPWLGCR_SW_WL_EN (0x00000002U) /*!< Bit mask for MMDC_MPWLGCR_SW_WL_EN. */
#define BS_MMDC_MPWLGCR_SW_WL_EN (1U)      /*!< Bit field size in bits for MMDC_MPWLGCR_SW_WL_EN. */

/*! @brief Read current value of the MMDC_MPWLGCR_SW_WL_EN field. */
#define BR_MMDC_MPWLGCR_SW_WL_EN(x) (HW_MMDC_MPWLGCR(x).B.SW_WL_EN)

/*! @brief Format value for bitfield MMDC_MPWLGCR_SW_WL_EN. */
#define BF_MMDC_MPWLGCR_SW_WL_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLGCR_SW_WL_EN) & BM_MMDC_MPWLGCR_SW_WL_EN)

/*! @brief Set the SW_WL_EN field to a new value. */
#define BW_MMDC_MPWLGCR_SW_WL_EN(x, v) (HW_MMDC_MPWLGCR_WR(x, (HW_MMDC_MPWLGCR_RD(x) & ~BM_MMDC_MPWLGCR_SW_WL_EN) | BF_MMDC_MPWLGCR_SW_WL_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field SW_WL_CNT_EN[2] (RW)
 *
 * SW write-leveling count down enable. This bit when asserted set a certain
 * delay of (25+15) cycles from the setting of SW_WL_EN and before driving the DQS
 * to the DDR device. This bit should be asserted before the first SW
 * write-leveling request and after issuing the write leveling MRS command
 *
 * Values:
 * - 0 - MMDC doesn't count 25+15 cycles before issuing write-leveling DQS.
 * - 1 - MMDC counts 25+15 cycles before issuing write-leveling DQS.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_SW_WL_CNT_EN (2U)  /*!< Bit position for MMDC_MPWLGCR_SW_WL_CNT_EN. */
#define BM_MMDC_MPWLGCR_SW_WL_CNT_EN (0x00000004U) /*!< Bit mask for MMDC_MPWLGCR_SW_WL_CNT_EN. */
#define BS_MMDC_MPWLGCR_SW_WL_CNT_EN (1U)  /*!< Bit field size in bits for MMDC_MPWLGCR_SW_WL_CNT_EN. */

/*! @brief Read current value of the MMDC_MPWLGCR_SW_WL_CNT_EN field. */
#define BR_MMDC_MPWLGCR_SW_WL_CNT_EN(x) (HW_MMDC_MPWLGCR(x).B.SW_WL_CNT_EN)

/*! @brief Format value for bitfield MMDC_MPWLGCR_SW_WL_CNT_EN. */
#define BF_MMDC_MPWLGCR_SW_WL_CNT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLGCR_SW_WL_CNT_EN) & BM_MMDC_MPWLGCR_SW_WL_CNT_EN)

/*! @brief Set the SW_WL_CNT_EN field to a new value. */
#define BW_MMDC_MPWLGCR_SW_WL_CNT_EN(x, v) (HW_MMDC_MPWLGCR_WR(x, (HW_MMDC_MPWLGCR_RD(x) & ~BM_MMDC_MPWLGCR_SW_WL_CNT_EN) | BF_MMDC_MPWLGCR_SW_WL_CNT_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_SW_RES0[4] (RO)
 *
 * Byte0 write-leveling software result. This bit reflects the value that is
 * driven by the DDR device on DQ0 during SW write-leveling.
 *
 * Values:
 * - 0 - DQS0 sampled low CK during SW write-leveling.
 * - 1 - DQS0 sampled high CK during SW write-leveling.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_SW_RES0 (4U)    /*!< Bit position for MMDC_MPWLGCR_WL_SW_RES0. */
#define BM_MMDC_MPWLGCR_WL_SW_RES0 (0x00000010U) /*!< Bit mask for MMDC_MPWLGCR_WL_SW_RES0. */
#define BS_MMDC_MPWLGCR_WL_SW_RES0 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_SW_RES0. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_SW_RES0 field. */
#define BR_MMDC_MPWLGCR_WL_SW_RES0(x) (HW_MMDC_MPWLGCR(x).B.WL_SW_RES0)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_SW_RES1[5] (RO)
 *
 * Byte1 write-leveling software result. This bit reflects the value that is
 * driven by the DDR device on DQ8 during SW write-leveling.
 *
 * Values:
 * - 0 - DQS1 sampled low CK during SW write-leveling.
 * - 1 - DQS1 sampled high CK during SW write-leveling.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_SW_RES1 (5U)    /*!< Bit position for MMDC_MPWLGCR_WL_SW_RES1. */
#define BM_MMDC_MPWLGCR_WL_SW_RES1 (0x00000020U) /*!< Bit mask for MMDC_MPWLGCR_WL_SW_RES1. */
#define BS_MMDC_MPWLGCR_WL_SW_RES1 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_SW_RES1. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_SW_RES1 field. */
#define BR_MMDC_MPWLGCR_WL_SW_RES1(x) (HW_MMDC_MPWLGCR(x).B.WL_SW_RES1)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_SW_RES2[6] (RO)
 *
 * Byte2 write-leveling software result. This bit reflects the value that is
 * driven by the DDR device on DQ16 during SW write-leveling.
 *
 * Values:
 * - 0 - DQS2 sampled low CK during SW write-leveling.
 * - 1 - DQS2 sampled high CK during SW write-leveling.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_SW_RES2 (6U)    /*!< Bit position for MMDC_MPWLGCR_WL_SW_RES2. */
#define BM_MMDC_MPWLGCR_WL_SW_RES2 (0x00000040U) /*!< Bit mask for MMDC_MPWLGCR_WL_SW_RES2. */
#define BS_MMDC_MPWLGCR_WL_SW_RES2 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_SW_RES2. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_SW_RES2 field. */
#define BR_MMDC_MPWLGCR_WL_SW_RES2(x) (HW_MMDC_MPWLGCR(x).B.WL_SW_RES2)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_SW_RES3[7] (RO)
 *
 * Byte3 write-leveling software result. This bit reflects the value that is
 * driven by the DDR device on DQ24 during SW write-leveling.
 *
 * Values:
 * - 0 - DQS3 sampled low CK during SW write-leveling.
 * - 1 - DQS3 sampled high CK during SW write-leveling.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_SW_RES3 (7U)    /*!< Bit position for MMDC_MPWLGCR_WL_SW_RES3. */
#define BM_MMDC_MPWLGCR_WL_SW_RES3 (0x00000080U) /*!< Bit mask for MMDC_MPWLGCR_WL_SW_RES3. */
#define BS_MMDC_MPWLGCR_WL_SW_RES3 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_SW_RES3. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_SW_RES3 field. */
#define BR_MMDC_MPWLGCR_WL_SW_RES3(x) (HW_MMDC_MPWLGCR(x).B.WL_SW_RES3)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_HW_ERR0[8] (RO)
 *
 * Byte0 write-leveling HW calibration error. This bit is asserted when an error
 * was found on byte0 during write-leveling HW calibration. This bit is valid
 * only upon completion of the write-leveling HW calibration (i.e. HW_WL_EN bit is
 * de-asserted)
 *
 * Values:
 * - 0 - No error was found on byte0 during write-leveling HW calibration.
 * - 1 - An error was found on byte0 during write-leveling HW calibration.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_HW_ERR0 (8U)    /*!< Bit position for MMDC_MPWLGCR_WL_HW_ERR0. */
#define BM_MMDC_MPWLGCR_WL_HW_ERR0 (0x00000100U) /*!< Bit mask for MMDC_MPWLGCR_WL_HW_ERR0. */
#define BS_MMDC_MPWLGCR_WL_HW_ERR0 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_HW_ERR0. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_HW_ERR0 field. */
#define BR_MMDC_MPWLGCR_WL_HW_ERR0(x) (HW_MMDC_MPWLGCR(x).B.WL_HW_ERR0)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_HW_ERR1[9] (RO)
 *
 * Byte1 write-leveling HW calibration error. This bit is asserted when an error
 * was found on byte1 during write-leveling HW calibration. This bit is valid
 * only upon completion of the write-leveling HW calibration (i.e. HW_WL_EN bit is
 * de-asserted)
 *
 * Values:
 * - 0 - No error was found on byte1 during write-leveling HW calibration.
 * - 1 - An error was found on byte1 during write-leveling HW calibration.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_HW_ERR1 (9U)    /*!< Bit position for MMDC_MPWLGCR_WL_HW_ERR1. */
#define BM_MMDC_MPWLGCR_WL_HW_ERR1 (0x00000200U) /*!< Bit mask for MMDC_MPWLGCR_WL_HW_ERR1. */
#define BS_MMDC_MPWLGCR_WL_HW_ERR1 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_HW_ERR1. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_HW_ERR1 field. */
#define BR_MMDC_MPWLGCR_WL_HW_ERR1(x) (HW_MMDC_MPWLGCR(x).B.WL_HW_ERR1)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_HW_ERR2[10] (RO)
 *
 * Byte2 write-leveling HW calibration error. This bit is asserted when an error
 * was found on byte2 during write-leveling HW calibration. This bit is valid
 * only upon completion of the write-leveling HW calibration (i.e. HW_WL_EN bit is
 * de-asserted)
 *
 * Values:
 * - 0 - No error was found on byte2 during write-leveling HW calibration.
 * - 1 - An error was found on byte2 during write-leveling HW calibration.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_HW_ERR2 (10U)   /*!< Bit position for MMDC_MPWLGCR_WL_HW_ERR2. */
#define BM_MMDC_MPWLGCR_WL_HW_ERR2 (0x00000400U) /*!< Bit mask for MMDC_MPWLGCR_WL_HW_ERR2. */
#define BS_MMDC_MPWLGCR_WL_HW_ERR2 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_HW_ERR2. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_HW_ERR2 field. */
#define BR_MMDC_MPWLGCR_WL_HW_ERR2(x) (HW_MMDC_MPWLGCR(x).B.WL_HW_ERR2)
/*@}*/

/*!
 * @name Register MMDC_MPWLGCR, field WL_HW_ERR3[11] (RO)
 *
 * Byte3 write-leveling HW calibration error. This bit is asserted when an error
 * was found on byte3 during write-leveling HW calibration. This bit is valid
 * only upon completion of the write-leveling HW calibration (i.e. HW_WL_EN bit is
 * de-asserted)
 *
 * Values:
 * - 0 - No error was found on byte3 during write-leveling HW calibration.
 * - 1 - An error was found on byte3 during write-leveling HW calibration.
 */
/*@{*/
#define BP_MMDC_MPWLGCR_WL_HW_ERR3 (11U)   /*!< Bit position for MMDC_MPWLGCR_WL_HW_ERR3. */
#define BM_MMDC_MPWLGCR_WL_HW_ERR3 (0x00000800U) /*!< Bit mask for MMDC_MPWLGCR_WL_HW_ERR3. */
#define BS_MMDC_MPWLGCR_WL_HW_ERR3 (1U)    /*!< Bit field size in bits for MMDC_MPWLGCR_WL_HW_ERR3. */

/*! @brief Read current value of the MMDC_MPWLGCR_WL_HW_ERR3 field. */
#define BR_MMDC_MPWLGCR_WL_HW_ERR3(x) (HW_MMDC_MPWLGCR(x).B.WL_HW_ERR3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWLDECTRL0 - MMDC PHY Write Leveling Delay Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWLDECTRL0 - MMDC PHY Write Leveling Delay Control Register 0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode OF Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwldectrl0
{
    uint32_t U;
    struct _hw_mmdc_mpwldectrl0_bitfields
    {
        uint32_t WL_DL_ABS_OFFSET0 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t WL_HC_DEL0 : 1;       /*!< [8]  */
        uint32_t WL_CYC_DEL0 : 2;      /*!< [10:9]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t WL_DL_ABS_OFFSET1 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t WL_HC_DEL1 : 1;       /*!< [24]  */
        uint32_t WL_CYC_DEL1 : 2;      /*!< [26:25]  */
        uint32_t RESERVED3 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpwldectrl0_t;

/*!
 * @name Constants and macros for entire MMDC_MPWLDECTRL0 register
 */
/*@{*/
#define HW_MMDC_MPWLDECTRL0_ADDR(x) ((uintptr_t)(x) + 0x80CU)

#define HW_MMDC_MPWLDECTRL0(x)   (*(__IO hw_mmdc_mpwldectrl0_t *) HW_MMDC_MPWLDECTRL0_ADDR(x))
#define HW_MMDC_MPWLDECTRL0_RD(x) (HW_MMDC_MPWLDECTRL0(x).U)
#define HW_MMDC_MPWLDECTRL0_WR(x, v) (HW_MMDC_MPWLDECTRL0(x).U = (v))
#define HW_MMDC_MPWLDECTRL0_SET(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, HW_MMDC_MPWLDECTRL0_RD(x) |  (v)))
#define HW_MMDC_MPWLDECTRL0_CLR(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, HW_MMDC_MPWLDECTRL0_RD(x) & ~(v)))
#define HW_MMDC_MPWLDECTRL0_TOG(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, HW_MMDC_MPWLDECTRL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWLDECTRL0 bitfields
 */

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_DL_ABS_OFFSET0[6:0] (RW)
 *
 * Absolute write-leveling delay offset for Byte 0. This field indicates the
 * absolute delay between CK and write DQS of Byte0 with fractions of a clock period
 * and up to half cycle. This value is process and frequency independent. The
 * value of the delay can be calculated using the following equation
 * (WR_DL_ABS_OFFSET1 / 256) * clock period When SW write-leveling is enabled (i.e. SW_WL_EN =
 * 1) then this value will be taken as is to the associated delay-line. When HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will indicate
 * (status) the value that is taken to the associated delay-line at the end of the
 * write-leveling calibration. The delay-line has a resolution that may vary
 * between device to device, therefore is some cases an increment of the delay by 1
 * step may be smaller than the delay-line resolution.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0 (0U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0. */
#define BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0 (0x0000007FU) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0. */
#define BS_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0 (7U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0 field. */
#define BR_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_DL_ABS_OFFSET0)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0. */
#define BF_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0) & BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0)

/*! @brief Set the WL_DL_ABS_OFFSET0 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0) | BF_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_HC_DEL0[8] (RW)
 *
 * Write leveling half cycle delay for Byte 0. This field indicates whether a
 * delay of half cycle between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_CYC_DEL. So the total delay is
 * the sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When SW write-leveling is enabled (i.e. SW_WL_EN = 1) then this value
 * will be taken as is and will be added to the associated delay that is
 * configured in WL_DL_OFFSET and WL_CYC_DEL. When HW write-leveling is enabled (i.e.
 * HW_WL_EN = 1 ) then this value will indicate (status) whether a delay of half
 * cycle was added or not to the associated WL_DL_OFFSET and WL_CYC_DEL.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - Half cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_HC_DEL0 (8U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_HC_DEL0. */
#define BM_MMDC_MPWLDECTRL0_WL_HC_DEL0 (0x00000100U) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_HC_DEL0. */
#define BS_MMDC_MPWLDECTRL0_WL_HC_DEL0 (1U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_HC_DEL0. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_HC_DEL0 field. */
#define BR_MMDC_MPWLDECTRL0_WL_HC_DEL0(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_HC_DEL0)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_HC_DEL0. */
#define BF_MMDC_MPWLDECTRL0_WL_HC_DEL0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_HC_DEL0) & BM_MMDC_MPWLDECTRL0_WL_HC_DEL0)

/*! @brief Set the WL_HC_DEL0 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_HC_DEL0(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_HC_DEL0) | BF_MMDC_MPWLDECTRL0_WL_HC_DEL0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_CYC_DEL0[10:9] (RW)
 *
 * Write leveling cycle delay for Byte 0. This field indicates whether a delay
 * of 1 or 2 cycles between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_HC_DEL. So the total delay is the
 * sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When both SW write-leveling is enabled (i.e. SW_WL_EN = 1) or HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will be taken as is
 * and will be added to the associated delay that is configured in WL_DL_OFFSET and
 * WL_HC_DEL. Note that in HW write-leveling this field is not used for
 * indication, as in WL_DL_OFFSET and WL_HC_DEL, but for configuration.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - 1 cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_CYC_DEL0 (9U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_CYC_DEL0. */
#define BM_MMDC_MPWLDECTRL0_WL_CYC_DEL0 (0x00000600U) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_CYC_DEL0. */
#define BS_MMDC_MPWLDECTRL0_WL_CYC_DEL0 (2U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_CYC_DEL0. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_CYC_DEL0 field. */
#define BR_MMDC_MPWLDECTRL0_WL_CYC_DEL0(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_CYC_DEL0)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_CYC_DEL0. */
#define BF_MMDC_MPWLDECTRL0_WL_CYC_DEL0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_CYC_DEL0) & BM_MMDC_MPWLDECTRL0_WL_CYC_DEL0)

/*! @brief Set the WL_CYC_DEL0 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_CYC_DEL0(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_CYC_DEL0) | BF_MMDC_MPWLDECTRL0_WL_CYC_DEL0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_DL_ABS_OFFSET1[22:16] (RW)
 *
 * Absolute write-leveling delay offset for Byte 1. This field indicates the
 * absolute delay between CK and write DQS of Byte1 with fractions of a clock period
 * and up to half cycle. This value is process and frequency independent. The
 * value of the delay can be calculated using the following equation
 * (WR_DL_ABS_OFFSET1 / 256) * clock period When SW write-leveling is enabled (i.e. SW_WL_EN =
 * 1) then this value will be taken as is to the associated delay-line. When HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will indicate
 * (status) the value that is taken to the associated delay-line at the end of the
 * write-leveling calibration. The delay-line has a resolution that may vary
 * between device to device, therefore is some cases an increment of the delay by 1
 * step may be smaller than the delay-line resolution.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1 (16U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1. */
#define BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1 (0x007F0000U) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1. */
#define BS_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1 (7U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1 field. */
#define BR_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_DL_ABS_OFFSET1)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1. */
#define BF_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1) & BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1)

/*! @brief Set the WL_DL_ABS_OFFSET1 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1) | BF_MMDC_MPWLDECTRL0_WL_DL_ABS_OFFSET1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_HC_DEL1[24] (RW)
 *
 * Write leveling half cycle delay for Byte 1. This field indicates whether a
 * delay of half cycle between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_CYC_DEL. So the total delay is
 * the sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When SW write-leveling is enabled (i.e. SW_WL_EN = 1) then this value
 * will be taken as is and will be added to the associated delay that is
 * configured in WL_DL_OFFSET and WL_CYC_DEL. When HW write-leveling is enabled (i.e.
 * HW_WL_EN = 1 ) then this value will indicate (status) whether a delay of half
 * cycle was added or not to the associated WL_DL_OFFSET and WL_CYC_DEL.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - Half cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_HC_DEL1 (24U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_HC_DEL1. */
#define BM_MMDC_MPWLDECTRL0_WL_HC_DEL1 (0x01000000U) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_HC_DEL1. */
#define BS_MMDC_MPWLDECTRL0_WL_HC_DEL1 (1U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_HC_DEL1. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_HC_DEL1 field. */
#define BR_MMDC_MPWLDECTRL0_WL_HC_DEL1(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_HC_DEL1)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_HC_DEL1. */
#define BF_MMDC_MPWLDECTRL0_WL_HC_DEL1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_HC_DEL1) & BM_MMDC_MPWLDECTRL0_WL_HC_DEL1)

/*! @brief Set the WL_HC_DEL1 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_HC_DEL1(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_HC_DEL1) | BF_MMDC_MPWLDECTRL0_WL_HC_DEL1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL0, field WL_CYC_DEL1[26:25] (RW)
 *
 * Write leveling cycle delay for Byte 1. This field indicates whether a delay
 * of 1 or 2 cycles between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_HC_DEL. So the total delay is the
 * sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When both SW write-leveling is enabled (i.e. SW_WL_EN = 1) or HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will be taken as is
 * and will be added to the associated delay that is configured in WL_DL_OFFSET and
 * WL_HC_DEL. Note that in HW write-leveling this field is not used for
 * indication, as in WL_DL_OFFSET and WL_HC_DEL, but for configuration.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - 1 cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL0_WL_CYC_DEL1 (25U) /*!< Bit position for MMDC_MPWLDECTRL0_WL_CYC_DEL1. */
#define BM_MMDC_MPWLDECTRL0_WL_CYC_DEL1 (0x06000000U) /*!< Bit mask for MMDC_MPWLDECTRL0_WL_CYC_DEL1. */
#define BS_MMDC_MPWLDECTRL0_WL_CYC_DEL1 (2U) /*!< Bit field size in bits for MMDC_MPWLDECTRL0_WL_CYC_DEL1. */

/*! @brief Read current value of the MMDC_MPWLDECTRL0_WL_CYC_DEL1 field. */
#define BR_MMDC_MPWLDECTRL0_WL_CYC_DEL1(x) (HW_MMDC_MPWLDECTRL0(x).B.WL_CYC_DEL1)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL0_WL_CYC_DEL1. */
#define BF_MMDC_MPWLDECTRL0_WL_CYC_DEL1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL0_WL_CYC_DEL1) & BM_MMDC_MPWLDECTRL0_WL_CYC_DEL1)

/*! @brief Set the WL_CYC_DEL1 field to a new value. */
#define BW_MMDC_MPWLDECTRL0_WL_CYC_DEL1(x, v) (HW_MMDC_MPWLDECTRL0_WR(x, (HW_MMDC_MPWLDECTRL0_RD(x) & ~BM_MMDC_MPWLDECTRL0_WL_CYC_DEL1) | BF_MMDC_MPWLDECTRL0_WL_CYC_DEL1(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWLDECTRL1 - MMDC PHY Write Leveling Delay Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWLDECTRL1 - MMDC PHY Write Leveling Delay Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwldectrl1
{
    uint32_t U;
    struct _hw_mmdc_mpwldectrl1_bitfields
    {
        uint32_t WL_DL_ABS_OFFSET2 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t WL_HC_DEL2 : 1;       /*!< [8]  */
        uint32_t WL_CYC_DEL2 : 2;      /*!< [10:9]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t WL_DL_ABS_OFFSET3 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t WL_HC_DEL3 : 1;       /*!< [24]  */
        uint32_t WL_CYC_DEL3 : 2;      /*!< [26:25]  */
        uint32_t RESERVED3 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpwldectrl1_t;

/*!
 * @name Constants and macros for entire MMDC_MPWLDECTRL1 register
 */
/*@{*/
#define HW_MMDC_MPWLDECTRL1_ADDR(x) ((uintptr_t)(x) + 0x810U)

#define HW_MMDC_MPWLDECTRL1(x)   (*(__IO hw_mmdc_mpwldectrl1_t *) HW_MMDC_MPWLDECTRL1_ADDR(x))
#define HW_MMDC_MPWLDECTRL1_RD(x) (HW_MMDC_MPWLDECTRL1(x).U)
#define HW_MMDC_MPWLDECTRL1_WR(x, v) (HW_MMDC_MPWLDECTRL1(x).U = (v))
#define HW_MMDC_MPWLDECTRL1_SET(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, HW_MMDC_MPWLDECTRL1_RD(x) |  (v)))
#define HW_MMDC_MPWLDECTRL1_CLR(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, HW_MMDC_MPWLDECTRL1_RD(x) & ~(v)))
#define HW_MMDC_MPWLDECTRL1_TOG(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, HW_MMDC_MPWLDECTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWLDECTRL1 bitfields
 */

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_DL_ABS_OFFSET2[6:0] (RW)
 *
 * Absolute write-leveling delay offset for Byte 2. This field indicates the
 * absolute delay between CK and write DQS of Byte1 with fractions of a clock period
 * and up to half cycle. This value is process and frequency independent. The
 * value of the delay can be calculated using the following equation
 * (WR_DL_ABS_OFFSET2 / 256) * clock period When SW write-leveling is enabled (i.e. SW_WL_EN =
 * 1) then this value will be taken as is to the associated delay-line. When HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will indicate
 * (status) the value that is taken to the associated delay-line at the end of the
 * write-leveling calibration. The delay-line has a resolution that may vary
 * between device to device, therefore is some cases an increment of the delay by 1
 * step may be smaller than the delay-line resolution.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2 (0U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2. */
#define BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2 (0x0000007FU) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2. */
#define BS_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2 (7U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2 field. */
#define BR_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_DL_ABS_OFFSET2)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2. */
#define BF_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2) & BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2)

/*! @brief Set the WL_DL_ABS_OFFSET2 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2) | BF_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_HC_DEL2[8] (RW)
 *
 * Write leveling half cycle delay for Byte 2. This field indicates whether a
 * delay of half cycle between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_CYC_DEL. So the total delay is
 * the sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When SW write-leveling is enabled (i.e. SW_WL_EN = 1) then this value
 * will be taken as is and will be added to the associated delay that is
 * configured in WL_DL_OFFSET and WL_CYC_DEL. When HW write-leveling is enabled (i.e.
 * HW_WL_EN = 1 ) then this value will indicate (status) whether a delay of half
 * cycle was added or not to the associated WL_DL_OFFSET and WL_CYC_DEL.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - Half cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_HC_DEL2 (8U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_HC_DEL2. */
#define BM_MMDC_MPWLDECTRL1_WL_HC_DEL2 (0x00000100U) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_HC_DEL2. */
#define BS_MMDC_MPWLDECTRL1_WL_HC_DEL2 (1U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_HC_DEL2. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_HC_DEL2 field. */
#define BR_MMDC_MPWLDECTRL1_WL_HC_DEL2(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_HC_DEL2)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_HC_DEL2. */
#define BF_MMDC_MPWLDECTRL1_WL_HC_DEL2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_HC_DEL2) & BM_MMDC_MPWLDECTRL1_WL_HC_DEL2)

/*! @brief Set the WL_HC_DEL2 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_HC_DEL2(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_HC_DEL2) | BF_MMDC_MPWLDECTRL1_WL_HC_DEL2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_CYC_DEL2[10:9] (RW)
 *
 * Write leveling cycle delay for Byte 2. This field indicates whether a delay
 * of 1 or 2 cycles between CK and write DQS is added to the delay that is
 * indicated in the associated WR_DL_ABS_OFFSET and WL_HC_DEL. So the total delay is the
 * sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When both SW write-leveling is enabled (i.e. SW_WL_EN = 1) or HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will be taken as is
 * and will be added to the associated delay that is configured in WL_DL_OFFSET and
 * WL_HC_DEL. Note that in HW write-leveling this field is not used for
 * indication, as in WL_DL_OFFSET and WL_HC_DEL, but for configuration.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - 1 cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_CYC_DEL2 (9U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_CYC_DEL2. */
#define BM_MMDC_MPWLDECTRL1_WL_CYC_DEL2 (0x00000600U) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_CYC_DEL2. */
#define BS_MMDC_MPWLDECTRL1_WL_CYC_DEL2 (2U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_CYC_DEL2. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_CYC_DEL2 field. */
#define BR_MMDC_MPWLDECTRL1_WL_CYC_DEL2(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_CYC_DEL2)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_CYC_DEL2. */
#define BF_MMDC_MPWLDECTRL1_WL_CYC_DEL2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_CYC_DEL2) & BM_MMDC_MPWLDECTRL1_WL_CYC_DEL2)

/*! @brief Set the WL_CYC_DEL2 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_CYC_DEL2(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_CYC_DEL2) | BF_MMDC_MPWLDECTRL1_WL_CYC_DEL2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_DL_ABS_OFFSET3[22:16] (RW)
 *
 * Absolute write-leveling delay offset for Byte 3. This field indicates the
 * absolute delay between CK and write DQS of Byte3 with fractions of a clock period
 * and up to half cycle. This value is process and frequency independent. The
 * value of the delay can be calculated using the following equation
 * (WL_DL_ABS_OFFSET3 / 256) * clock period When SW write-leveling is enabled (i.e. SW_WL_EN =
 * 1) then this value will be taken as is to the associated delay-line. When HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will indicate
 * (status) the value that is taken to the associated delay-line at the end of the
 * write-leveling calibration. The delay-line has a resolution that may vary
 * between device to device, therefore is some cases an increment of the delay by 1
 * step may be smaller than the delay-line resolution.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3 (16U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3. */
#define BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3 (0x007F0000U) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3. */
#define BS_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3 (7U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3 field. */
#define BR_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_DL_ABS_OFFSET3)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3. */
#define BF_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3) & BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3)

/*! @brief Set the WL_DL_ABS_OFFSET3 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3) | BF_MMDC_MPWLDECTRL1_WL_DL_ABS_OFFSET3(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_HC_DEL3[24] (RW)
 *
 * Write leveling half cycle delay for Byte 3. This field indicates whether a
 * delay of half cycle between CK and write DQS is added to the delay that is
 * indicated in the associated WL_DL_ABS_OFFSET and WL_CYC_DEL. So the total delay is
 * the sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When SW write-leveling is enabled (i.e. SW_WL_EN = 1) then this value
 * will be taken as is and will be added to the associated delay that is
 * configured in WL_DL_OFFSET and WL_CYC_DEL. When HW write-leveling is enabled (i.e.
 * HW_WL_EN = 1 ) then this value will indicate (status) whether a delay of half
 * cycle was added or not to the associated WL_DL_OFFSET and WL_CYC_DEL.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - Half cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_HC_DEL3 (24U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_HC_DEL3. */
#define BM_MMDC_MPWLDECTRL1_WL_HC_DEL3 (0x01000000U) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_HC_DEL3. */
#define BS_MMDC_MPWLDECTRL1_WL_HC_DEL3 (1U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_HC_DEL3. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_HC_DEL3 field. */
#define BR_MMDC_MPWLDECTRL1_WL_HC_DEL3(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_HC_DEL3)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_HC_DEL3. */
#define BF_MMDC_MPWLDECTRL1_WL_HC_DEL3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_HC_DEL3) & BM_MMDC_MPWLDECTRL1_WL_HC_DEL3)

/*! @brief Set the WL_HC_DEL3 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_HC_DEL3(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_HC_DEL3) | BF_MMDC_MPWLDECTRL1_WL_HC_DEL3(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWLDECTRL1, field WL_CYC_DEL3[26:25] (RW)
 *
 * Write leveling cycle delay for Byte 3. This field indicates whether a delay
 * of 1 or 2 cycles between CK and write DQS is added to the delay that is
 * indicated in the associated WL_DL_ABS_OFFSET and WL_HC_DEL. So the total delay is the
 * sum of (WL_DL_ABS_OFFSET/256*cycle) + (WL_HC_DEL*half cycle) +
 * (WL_CYC_DEL*cycle). When both SW write-leveling is enabled (i.e. SW_WL_EN = 1) or HW
 * write-leveling is enabled (i.e. HW_WL_EN = 1 ) then this value will be taken as is
 * and will be added to the associated delay that is configured in WL_DL_OFFSET and
 * WL_HC_DEL. Note that in HW write-leveling this field is not used for
 * indication, as in WL_DL_OFFSET and WL_HC_DEL, but for configuration.
 *
 * Values:
 * - 0 - No delay is added.
 * - 1 - 1 cycle delay is added.
 */
/*@{*/
#define BP_MMDC_MPWLDECTRL1_WL_CYC_DEL3 (25U) /*!< Bit position for MMDC_MPWLDECTRL1_WL_CYC_DEL3. */
#define BM_MMDC_MPWLDECTRL1_WL_CYC_DEL3 (0x06000000U) /*!< Bit mask for MMDC_MPWLDECTRL1_WL_CYC_DEL3. */
#define BS_MMDC_MPWLDECTRL1_WL_CYC_DEL3 (2U) /*!< Bit field size in bits for MMDC_MPWLDECTRL1_WL_CYC_DEL3. */

/*! @brief Read current value of the MMDC_MPWLDECTRL1_WL_CYC_DEL3 field. */
#define BR_MMDC_MPWLDECTRL1_WL_CYC_DEL3(x) (HW_MMDC_MPWLDECTRL1(x).B.WL_CYC_DEL3)

/*! @brief Format value for bitfield MMDC_MPWLDECTRL1_WL_CYC_DEL3. */
#define BF_MMDC_MPWLDECTRL1_WL_CYC_DEL3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWLDECTRL1_WL_CYC_DEL3) & BM_MMDC_MPWLDECTRL1_WL_CYC_DEL3)

/*! @brief Set the WL_CYC_DEL3 field to a new value. */
#define BW_MMDC_MPWLDECTRL1_WL_CYC_DEL3(x, v) (HW_MMDC_MPWLDECTRL1_WR(x, (HW_MMDC_MPWLDECTRL1_RD(x) & ~BM_MMDC_MPWLDECTRL1_WL_CYC_DEL3) | BF_MMDC_MPWLDECTRL1_WL_CYC_DEL3(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWLDLST - MMDC PHY Write Leveling delay-line Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWLDLST - MMDC PHY Write Leveling delay-line Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the status of the four write leveling delay-lines.
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwldlst
{
    uint32_t U;
    struct _hw_mmdc_mpwldlst_bitfields
    {
        uint32_t WL_DL_UNIT_NUM0 : 7;  /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t WL_DL_UNIT_NUM1 : 7;  /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t WL_DL_UNIT_NUM2 : 7;  /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t WL_DL_UNIT_NUM3 : 7;  /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpwldlst_t;

/*!
 * @name Constants and macros for entire MMDC_MPWLDLST register
 */
/*@{*/
#define HW_MMDC_MPWLDLST_ADDR(x) ((uintptr_t)(x) + 0x814U)

#define HW_MMDC_MPWLDLST(x)      (*(__I hw_mmdc_mpwldlst_t *) HW_MMDC_MPWLDLST_ADDR(x))
#define HW_MMDC_MPWLDLST_RD(x)   (HW_MMDC_MPWLDLST(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWLDLST bitfields
 */

/*!
 * @name Register MMDC_MPWLDLST, field WL_DL_UNIT_NUM0[6:0] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * leveling delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPWLDLST_WL_DL_UNIT_NUM0 (0U) /*!< Bit position for MMDC_MPWLDLST_WL_DL_UNIT_NUM0. */
#define BM_MMDC_MPWLDLST_WL_DL_UNIT_NUM0 (0x0000007FU) /*!< Bit mask for MMDC_MPWLDLST_WL_DL_UNIT_NUM0. */
#define BS_MMDC_MPWLDLST_WL_DL_UNIT_NUM0 (7U) /*!< Bit field size in bits for MMDC_MPWLDLST_WL_DL_UNIT_NUM0. */

/*! @brief Read current value of the MMDC_MPWLDLST_WL_DL_UNIT_NUM0 field. */
#define BR_MMDC_MPWLDLST_WL_DL_UNIT_NUM0(x) (HW_MMDC_MPWLDLST(x).B.WL_DL_UNIT_NUM0)
/*@}*/

/*!
 * @name Register MMDC_MPWLDLST, field WL_DL_UNIT_NUM1[14:8] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * leveling delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPWLDLST_WL_DL_UNIT_NUM1 (8U) /*!< Bit position for MMDC_MPWLDLST_WL_DL_UNIT_NUM1. */
#define BM_MMDC_MPWLDLST_WL_DL_UNIT_NUM1 (0x00007F00U) /*!< Bit mask for MMDC_MPWLDLST_WL_DL_UNIT_NUM1. */
#define BS_MMDC_MPWLDLST_WL_DL_UNIT_NUM1 (7U) /*!< Bit field size in bits for MMDC_MPWLDLST_WL_DL_UNIT_NUM1. */

/*! @brief Read current value of the MMDC_MPWLDLST_WL_DL_UNIT_NUM1 field. */
#define BR_MMDC_MPWLDLST_WL_DL_UNIT_NUM1(x) (HW_MMDC_MPWLDLST(x).B.WL_DL_UNIT_NUM1)
/*@}*/

/*!
 * @name Register MMDC_MPWLDLST, field WL_DL_UNIT_NUM2[22:16] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * leveling delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPWLDLST_WL_DL_UNIT_NUM2 (16U) /*!< Bit position for MMDC_MPWLDLST_WL_DL_UNIT_NUM2. */
#define BM_MMDC_MPWLDLST_WL_DL_UNIT_NUM2 (0x007F0000U) /*!< Bit mask for MMDC_MPWLDLST_WL_DL_UNIT_NUM2. */
#define BS_MMDC_MPWLDLST_WL_DL_UNIT_NUM2 (7U) /*!< Bit field size in bits for MMDC_MPWLDLST_WL_DL_UNIT_NUM2. */

/*! @brief Read current value of the MMDC_MPWLDLST_WL_DL_UNIT_NUM2 field. */
#define BR_MMDC_MPWLDLST_WL_DL_UNIT_NUM2(x) (HW_MMDC_MPWLDLST(x).B.WL_DL_UNIT_NUM2)
/*@}*/

/*!
 * @name Register MMDC_MPWLDLST, field WL_DL_UNIT_NUM3[30:24] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * leveling delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPWLDLST_WL_DL_UNIT_NUM3 (24U) /*!< Bit position for MMDC_MPWLDLST_WL_DL_UNIT_NUM3. */
#define BM_MMDC_MPWLDLST_WL_DL_UNIT_NUM3 (0x7F000000U) /*!< Bit mask for MMDC_MPWLDLST_WL_DL_UNIT_NUM3. */
#define BS_MMDC_MPWLDLST_WL_DL_UNIT_NUM3 (7U) /*!< Bit field size in bits for MMDC_MPWLDLST_WL_DL_UNIT_NUM3. */

/*! @brief Read current value of the MMDC_MPWLDLST_WL_DL_UNIT_NUM3 field. */
#define BR_MMDC_MPWLDLST_WL_DL_UNIT_NUM3(x) (HW_MMDC_MPWLDLST(x).B.WL_DL_UNIT_NUM3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPODTCTRL - MMDC PHY ODT control register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPODTCTRL - MMDC PHY ODT control register (RW)
 *
 * Reset value: 0x00000000U
 *
 * In LPDDR2 mode this register should be cleared, so no termination will be
 * activated Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32,
 * DDR3_x64 For Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpodtctrl
{
    uint32_t U;
    struct _hw_mmdc_mpodtctrl_bitfields
    {
        uint32_t ODT_WR_PAS_EN : 1;    /*!< [0]  */
        uint32_t ODT_WR_ACT_EN : 1;    /*!< [1]  */
        uint32_t ODT_RD_PAS_EN : 1;    /*!< [2]  */
        uint32_t ODT_RD_ACT_EN : 1;    /*!< [3]  */
        uint32_t ODT0_INT_RES : 3;     /*!< [6:4]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t ODT1_INT_RES : 3;     /*!< [10:8]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t ODT2_INT_RES : 3;     /*!< [14:12]  */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t ODT3_INT_RES : 3;     /*!< [18:16]  */
        uint32_t RESERVED3 : 13;       /*!< [31:19]  */
    } B;
} hw_mmdc_mpodtctrl_t;

/*!
 * @name Constants and macros for entire MMDC_MPODTCTRL register
 */
/*@{*/
#define HW_MMDC_MPODTCTRL_ADDR(x) ((uintptr_t)(x) + 0x818U)

#define HW_MMDC_MPODTCTRL(x)     (*(__IO hw_mmdc_mpodtctrl_t *) HW_MMDC_MPODTCTRL_ADDR(x))
#define HW_MMDC_MPODTCTRL_RD(x)  (HW_MMDC_MPODTCTRL(x).U)
#define HW_MMDC_MPODTCTRL_WR(x, v) (HW_MMDC_MPODTCTRL(x).U = (v))
#define HW_MMDC_MPODTCTRL_SET(x, v) (HW_MMDC_MPODTCTRL_WR(x, HW_MMDC_MPODTCTRL_RD(x) |  (v)))
#define HW_MMDC_MPODTCTRL_CLR(x, v) (HW_MMDC_MPODTCTRL_WR(x, HW_MMDC_MPODTCTRL_RD(x) & ~(v)))
#define HW_MMDC_MPODTCTRL_TOG(x, v) (HW_MMDC_MPODTCTRL_WR(x, HW_MMDC_MPODTCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPODTCTRL bitfields
 */

/*!
 * @name Register MMDC_MPODTCTRL, field ODT_WR_PAS_EN[0] (RW)
 *
 * Inactive write CS ODT enable. The bit determines if ODT pin of the inactive
 * CS will be asserted during write accesses.
 *
 * Values:
 * - 0 - Inactive CS ODT pin is disabled during write accesses to other CS.
 * - 1 - Inactive CS ODT pin is enabled during write accesses to other CS.
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT_WR_PAS_EN (0U) /*!< Bit position for MMDC_MPODTCTRL_ODT_WR_PAS_EN. */
#define BM_MMDC_MPODTCTRL_ODT_WR_PAS_EN (0x00000001U) /*!< Bit mask for MMDC_MPODTCTRL_ODT_WR_PAS_EN. */
#define BS_MMDC_MPODTCTRL_ODT_WR_PAS_EN (1U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT_WR_PAS_EN. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT_WR_PAS_EN field. */
#define BR_MMDC_MPODTCTRL_ODT_WR_PAS_EN(x) (HW_MMDC_MPODTCTRL(x).B.ODT_WR_PAS_EN)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT_WR_PAS_EN. */
#define BF_MMDC_MPODTCTRL_ODT_WR_PAS_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT_WR_PAS_EN) & BM_MMDC_MPODTCTRL_ODT_WR_PAS_EN)

/*! @brief Set the ODT_WR_PAS_EN field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT_WR_PAS_EN(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT_WR_PAS_EN) | BF_MMDC_MPODTCTRL_ODT_WR_PAS_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT_WR_ACT_EN[1] (RW)
 *
 * Active write CS ODT enable. The bit determines if ODT pin of the active CS
 * will be asserted during write accesses.
 *
 * Values:
 * - 0 - Active CS ODT pin is disabled during write access.
 * - 1 - Active CS ODT pin is enabled during write access.
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT_WR_ACT_EN (1U) /*!< Bit position for MMDC_MPODTCTRL_ODT_WR_ACT_EN. */
#define BM_MMDC_MPODTCTRL_ODT_WR_ACT_EN (0x00000002U) /*!< Bit mask for MMDC_MPODTCTRL_ODT_WR_ACT_EN. */
#define BS_MMDC_MPODTCTRL_ODT_WR_ACT_EN (1U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT_WR_ACT_EN. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT_WR_ACT_EN field. */
#define BR_MMDC_MPODTCTRL_ODT_WR_ACT_EN(x) (HW_MMDC_MPODTCTRL(x).B.ODT_WR_ACT_EN)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT_WR_ACT_EN. */
#define BF_MMDC_MPODTCTRL_ODT_WR_ACT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT_WR_ACT_EN) & BM_MMDC_MPODTCTRL_ODT_WR_ACT_EN)

/*! @brief Set the ODT_WR_ACT_EN field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT_WR_ACT_EN(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT_WR_ACT_EN) | BF_MMDC_MPODTCTRL_ODT_WR_ACT_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT_RD_PAS_EN[2] (RW)
 *
 * Inactive read CS ODT enable. The bit determines if ODT pin of the inactive CS
 * will be asserted during read accesses.
 *
 * Values:
 * - 0 - Inactive CS ODT pin is disabled during read accesses to other CS.
 * - 1 - Inactive CS ODT pin is enabled during read accesses to other CS.
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT_RD_PAS_EN (2U) /*!< Bit position for MMDC_MPODTCTRL_ODT_RD_PAS_EN. */
#define BM_MMDC_MPODTCTRL_ODT_RD_PAS_EN (0x00000004U) /*!< Bit mask for MMDC_MPODTCTRL_ODT_RD_PAS_EN. */
#define BS_MMDC_MPODTCTRL_ODT_RD_PAS_EN (1U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT_RD_PAS_EN. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT_RD_PAS_EN field. */
#define BR_MMDC_MPODTCTRL_ODT_RD_PAS_EN(x) (HW_MMDC_MPODTCTRL(x).B.ODT_RD_PAS_EN)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT_RD_PAS_EN. */
#define BF_MMDC_MPODTCTRL_ODT_RD_PAS_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT_RD_PAS_EN) & BM_MMDC_MPODTCTRL_ODT_RD_PAS_EN)

/*! @brief Set the ODT_RD_PAS_EN field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT_RD_PAS_EN(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT_RD_PAS_EN) | BF_MMDC_MPODTCTRL_ODT_RD_PAS_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT_RD_ACT_EN[3] (RW)
 *
 * Active read CS ODT enable. The bit determines if ODT pin of the active CS
 * will be asserted during read accesses.
 *
 * Values:
 * - 0 - Active CS ODT pin is disabled during read access.
 * - 1 - Active CS ODT pin is enabled during read access.
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT_RD_ACT_EN (3U) /*!< Bit position for MMDC_MPODTCTRL_ODT_RD_ACT_EN. */
#define BM_MMDC_MPODTCTRL_ODT_RD_ACT_EN (0x00000008U) /*!< Bit mask for MMDC_MPODTCTRL_ODT_RD_ACT_EN. */
#define BS_MMDC_MPODTCTRL_ODT_RD_ACT_EN (1U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT_RD_ACT_EN. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT_RD_ACT_EN field. */
#define BR_MMDC_MPODTCTRL_ODT_RD_ACT_EN(x) (HW_MMDC_MPODTCTRL(x).B.ODT_RD_ACT_EN)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT_RD_ACT_EN. */
#define BF_MMDC_MPODTCTRL_ODT_RD_ACT_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT_RD_ACT_EN) & BM_MMDC_MPODTCTRL_ODT_RD_ACT_EN)

/*! @brief Set the ODT_RD_ACT_EN field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT_RD_ACT_EN(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT_RD_ACT_EN) | BF_MMDC_MPODTCTRL_ODT_RD_ACT_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT0_INT_RES[6:4] (RW)
 *
 * On chip ODT byte0 resistor - This field determines the Rtt_Nom of the on chip
 * ODT byte0 resistor during read accesses.
 *
 * Values:
 * - 000 - Rtt_Nom Disabled.
 * - 001 - Rtt_Nom 120 Ohm
 * - 010 - Rtt_Nom 60 Ohm
 * - 011 - Rtt_Nom 40 Ohm
 * - 100 - Rtt_Nom 30 Ohm
 * - 101 - Rtt_Nom 24 Ohm
 * - 110 - Rtt_Nom 20 Ohm
 * - 111 - Rtt_Nom 17 Ohm
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT0_INT_RES (4U) /*!< Bit position for MMDC_MPODTCTRL_ODT0_INT_RES. */
#define BM_MMDC_MPODTCTRL_ODT0_INT_RES (0x00000070U) /*!< Bit mask for MMDC_MPODTCTRL_ODT0_INT_RES. */
#define BS_MMDC_MPODTCTRL_ODT0_INT_RES (3U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT0_INT_RES. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT0_INT_RES field. */
#define BR_MMDC_MPODTCTRL_ODT0_INT_RES(x) (HW_MMDC_MPODTCTRL(x).B.ODT0_INT_RES)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT0_INT_RES. */
#define BF_MMDC_MPODTCTRL_ODT0_INT_RES(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT0_INT_RES) & BM_MMDC_MPODTCTRL_ODT0_INT_RES)

/*! @brief Set the ODT0_INT_RES field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT0_INT_RES(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT0_INT_RES) | BF_MMDC_MPODTCTRL_ODT0_INT_RES(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT1_INT_RES[10:8] (RW)
 *
 * On chip ODT byte1 resistor - This field determines the Rtt_Nom of the on chip
 * ODT byte1 resistor during read accesses.
 *
 * Values:
 * - 0000 - Rtt_Nom Disabled.
 * - 001 - Rtt_Nom 120 Ohm
 * - 010 - Rtt_Nom 60 Ohm
 * - 011 - Rtt_Nom 40 Ohm
 * - 100 - Rtt_Nom 30 Ohm
 * - 101 - Rtt_Nom 24 Ohm
 * - 110 - Rtt_Nom 20 Ohm
 * - 111 - Rtt_Nom 17 Ohm
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT1_INT_RES (8U) /*!< Bit position for MMDC_MPODTCTRL_ODT1_INT_RES. */
#define BM_MMDC_MPODTCTRL_ODT1_INT_RES (0x00000700U) /*!< Bit mask for MMDC_MPODTCTRL_ODT1_INT_RES. */
#define BS_MMDC_MPODTCTRL_ODT1_INT_RES (3U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT1_INT_RES. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT1_INT_RES field. */
#define BR_MMDC_MPODTCTRL_ODT1_INT_RES(x) (HW_MMDC_MPODTCTRL(x).B.ODT1_INT_RES)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT1_INT_RES. */
#define BF_MMDC_MPODTCTRL_ODT1_INT_RES(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT1_INT_RES) & BM_MMDC_MPODTCTRL_ODT1_INT_RES)

/*! @brief Set the ODT1_INT_RES field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT1_INT_RES(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT1_INT_RES) | BF_MMDC_MPODTCTRL_ODT1_INT_RES(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT2_INT_RES[14:12] (RW)
 *
 * On chip ODT byte2 resistor - This field determines the Rtt_Nom of the on chip
 * ODT byte2 resistor during read accesses.
 *
 * Values:
 * - 000 - Rtt_Nom Disabled.
 * - 001 - Rtt_Nom 120 Ohm
 * - 010 - Rtt_Nom 60 Ohm
 * - 011 - Rtt_Nom 40 Ohm
 * - 100 - Rtt_Nom 30 Ohm
 * - 101 - Rtt_Nom 24 Ohm
 * - 110 - Rtt_Nom 20 Ohm
 * - 111 - Rtt_Nom 17 Ohm
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT2_INT_RES (12U) /*!< Bit position for MMDC_MPODTCTRL_ODT2_INT_RES. */
#define BM_MMDC_MPODTCTRL_ODT2_INT_RES (0x00007000U) /*!< Bit mask for MMDC_MPODTCTRL_ODT2_INT_RES. */
#define BS_MMDC_MPODTCTRL_ODT2_INT_RES (3U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT2_INT_RES. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT2_INT_RES field. */
#define BR_MMDC_MPODTCTRL_ODT2_INT_RES(x) (HW_MMDC_MPODTCTRL(x).B.ODT2_INT_RES)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT2_INT_RES. */
#define BF_MMDC_MPODTCTRL_ODT2_INT_RES(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT2_INT_RES) & BM_MMDC_MPODTCTRL_ODT2_INT_RES)

/*! @brief Set the ODT2_INT_RES field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT2_INT_RES(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT2_INT_RES) | BF_MMDC_MPODTCTRL_ODT2_INT_RES(v)))
/*@}*/

/*!
 * @name Register MMDC_MPODTCTRL, field ODT3_INT_RES[18:16] (RW)
 *
 * On chip ODT byte3 resistor - This field determines the Rtt_Nom of the on chip
 * ODT byte3 resistor during read accesses.
 *
 * Values:
 * - 000 - Rtt_Nom Disabled.
 * - 001 - Rtt_Nom 120 Ohm
 * - 010 - Rtt_Nom 60 Ohm
 * - 011 - Rtt_Nom 40 Ohm
 * - 100 - Rtt_Nom 30 Ohm
 * - 101 - Rtt_Nom 24 Ohm
 * - 110 - Rtt_Nom 20 Ohm
 * - 111 - Rtt_Nom 17 Ohm
 */
/*@{*/
#define BP_MMDC_MPODTCTRL_ODT3_INT_RES (16U) /*!< Bit position for MMDC_MPODTCTRL_ODT3_INT_RES. */
#define BM_MMDC_MPODTCTRL_ODT3_INT_RES (0x00070000U) /*!< Bit mask for MMDC_MPODTCTRL_ODT3_INT_RES. */
#define BS_MMDC_MPODTCTRL_ODT3_INT_RES (3U) /*!< Bit field size in bits for MMDC_MPODTCTRL_ODT3_INT_RES. */

/*! @brief Read current value of the MMDC_MPODTCTRL_ODT3_INT_RES field. */
#define BR_MMDC_MPODTCTRL_ODT3_INT_RES(x) (HW_MMDC_MPODTCTRL(x).B.ODT3_INT_RES)

/*! @brief Format value for bitfield MMDC_MPODTCTRL_ODT3_INT_RES. */
#define BF_MMDC_MPODTCTRL_ODT3_INT_RES(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPODTCTRL_ODT3_INT_RES) & BM_MMDC_MPODTCTRL_ODT3_INT_RES)

/*! @brief Set the ODT3_INT_RES field to a new value. */
#define BW_MMDC_MPODTCTRL_ODT3_INT_RES(x, v) (HW_MMDC_MPODTCTRL_WR(x, (HW_MMDC_MPODTCTRL_RD(x) & ~BM_MMDC_MPODTCTRL_ODT3_INT_RES) | BF_MMDC_MPODTCTRL_ODT3_INT_RES(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDQBY0DL - MMDC PHY Read DQ Byte0 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDQBY0DL - MMDC PHY Read DQ Byte0 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the read
 * DQ byte0 relative to the read DQS. This delay is in addition to the read data
 * calibration. If operating in 64-bit mode, there is an identical register that
 * is mapped at the second base address. Supported Mode Of Operations: For
 * Channel 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddqby0dl
{
    uint32_t U;
    struct _hw_mmdc_mprddqby0dl_bitfields
    {
        uint32_t rd_dq0_del : 3;       /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t rd_dq1_del : 3;       /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t rd_dq2_del : 3;       /*!< [10:8]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t rd_dq3_del : 3;       /*!< [14:12]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t rd_dq4_del : 3;       /*!< [18:16]  */
        uint32_t RESERVED4 : 1;        /*!< [19]  */
        uint32_t rd_dq5_del : 3;       /*!< [22:20]  */
        uint32_t RESERVED5 : 1;        /*!< [23]  */
        uint32_t rd_dq6_del : 3;       /*!< [26:24]  */
        uint32_t RESERVED6 : 1;        /*!< [27]  */
        uint32_t rd_dq7_del : 3;       /*!< [30:28]  */
        uint32_t RESERVED7 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddqby0dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDQBY0DL register
 */
/*@{*/
#define HW_MMDC_MPRDDQBY0DL_ADDR(x) ((uintptr_t)(x) + 0x81CU)

#define HW_MMDC_MPRDDQBY0DL(x)   (*(__IO hw_mmdc_mprddqby0dl_t *) HW_MMDC_MPRDDQBY0DL_ADDR(x))
#define HW_MMDC_MPRDDQBY0DL_RD(x) (HW_MMDC_MPRDDQBY0DL(x).U)
#define HW_MMDC_MPRDDQBY0DL_WR(x, v) (HW_MMDC_MPRDDQBY0DL(x).U = (v))
#define HW_MMDC_MPRDDQBY0DL_SET(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, HW_MMDC_MPRDDQBY0DL_RD(x) |  (v)))
#define HW_MMDC_MPRDDQBY0DL_CLR(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, HW_MMDC_MPRDDQBY0DL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDQBY0DL_TOG(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, HW_MMDC_MPRDDQBY0DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDQBY0DL bitfields
 */

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq0_del[2:0] (RW)
 *
 * Read dqs0 to dq0 delay fine-tuning. This field holds the number of delay
 * units that are added to dq0 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq0 delay
 * - 001 - Add dq0 delay of 1 delay unit
 * - 010 - Add dq0 delay of 2 delay units.
 * - 011 - Add dq0 delay of 3 delay units.
 * - 100 - Add dq0 delay of 4 delay units.
 * - 101 - Add dq0 delay of 5 delay units.
 * - 110 - Add dq0 delay of 6 delay units.
 * - 111 - Add dq0 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq0_del (0U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq0_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq0_del (0x00000007U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq0_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq0_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq0_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq0_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq0_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq0_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq0_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq0_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq0_del) & BM_MMDC_MPRDDQBY0DL_rd_dq0_del)

/*! @brief Set the rd_dq0_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq0_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq0_del) | BF_MMDC_MPRDDQBY0DL_rd_dq0_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq1_del[6:4] (RW)
 *
 * Read dqs0 to dq1 delay fine-tuning. This field holds the number of delay
 * units that are added to dq1 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq1 delay
 * - 001 - Add dq1 delay of 1 delay unit
 * - 010 - Add dq1 delay of 2 delay units.
 * - 011 - Add dq1 delay of 3 delay units.
 * - 100 - Add dq1 delay of 4 delay units.
 * - 101 - Add dq1 delay of 5 delay units.
 * - 110 - Add dq1 delay of 6 delay units.
 * - 111 - Add dq1 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq1_del (4U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq1_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq1_del (0x00000070U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq1_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq1_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq1_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq1_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq1_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq1_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq1_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq1_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq1_del) & BM_MMDC_MPRDDQBY0DL_rd_dq1_del)

/*! @brief Set the rd_dq1_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq1_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq1_del) | BF_MMDC_MPRDDQBY0DL_rd_dq1_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq2_del[10:8] (RW)
 *
 * Read dqs0 to dq2 delay fine-tuning. This field holds the number of delay
 * units that are added to dq2 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq2 delay
 * - 001 - Add dq2 delay of 1 delay unit
 * - 010 - Add dq2 delay of 2 delay units.
 * - 011 - Add dq2 delay of 3 delay units.
 * - 100 - Add dq2 delay of 4 delay units.
 * - 101 - Add dq2 delay of 5 delay units.
 * - 110 - Add dq2 delay of 6 delay units.
 * - 111 - Add dq2 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq2_del (8U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq2_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq2_del (0x00000700U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq2_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq2_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq2_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq2_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq2_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq2_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq2_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq2_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq2_del) & BM_MMDC_MPRDDQBY0DL_rd_dq2_del)

/*! @brief Set the rd_dq2_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq2_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq2_del) | BF_MMDC_MPRDDQBY0DL_rd_dq2_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq3_del[14:12] (RW)
 *
 * Read dqs0 to dq3 delay fine-tuning. This field holds the number of delay
 * units that are added to dq3 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq3 delay
 * - 001 - Add dq3 delay of 1 delay unit
 * - 010 - Add dq3 delay of 2 delay units.
 * - 011 - Add dq3 delay of 3 delay units.
 * - 100 - Add dq3 delay of 4 delay units.
 * - 101 - Add dq3 delay of 5 delay units.
 * - 110 - Add dq3 delay of 6 delay units.
 * - 111 - Add dq3 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq3_del (12U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq3_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq3_del (0x00007000U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq3_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq3_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq3_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq3_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq3_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq3_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq3_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq3_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq3_del) & BM_MMDC_MPRDDQBY0DL_rd_dq3_del)

/*! @brief Set the rd_dq3_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq3_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq3_del) | BF_MMDC_MPRDDQBY0DL_rd_dq3_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq4_del[18:16] (RW)
 *
 * Read dqs0 to dq4 delay fine-tuning. This field holds the number of delay
 * units that are added to dq4 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq4 delay
 * - 001 - Add dq4 delay of 1 delay unit
 * - 010 - Add dq4 delay of 2 delay units.
 * - 011 - Add dq4 delay of 3 delay units.
 * - 100 - Add dq4 delay of 4 delay units.
 * - 101 - Add dq4 delay of 5 delay units.
 * - 110 - Add dq4 delay of 6 delay units.
 * - 111 - Add dq4 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq4_del (16U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq4_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq4_del (0x00070000U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq4_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq4_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq4_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq4_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq4_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq4_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq4_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq4_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq4_del) & BM_MMDC_MPRDDQBY0DL_rd_dq4_del)

/*! @brief Set the rd_dq4_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq4_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq4_del) | BF_MMDC_MPRDDQBY0DL_rd_dq4_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq5_del[22:20] (RW)
 *
 * Read dqs0 to dq5 delay fine-tuning. This field holds the number of delay
 * units that are added to dq5 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq5 delay
 * - 001 - Add dq5 delay of 1 delay unit
 * - 010 - Add dq5 delay of 2 delay units.
 * - 011 - Add dq5 delay of 3 delay units.
 * - 100 - Add dq5 delay of 4 delay units.
 * - 101 - Add dq5 delay of 5 delay units.
 * - 110 - Add dq5 delay of 6 delay units.
 * - 111 - Add dq5 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq5_del (20U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq5_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq5_del (0x00700000U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq5_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq5_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq5_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq5_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq5_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq5_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq5_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq5_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq5_del) & BM_MMDC_MPRDDQBY0DL_rd_dq5_del)

/*! @brief Set the rd_dq5_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq5_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq5_del) | BF_MMDC_MPRDDQBY0DL_rd_dq5_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq6_del[26:24] (RW)
 *
 * Read dqs0 to dq6 delay fine-tuning. This field holds the number of delay
 * units that are added to dq6 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq6 delay
 * - 001 - Add dq6 delay of 1 delay unit
 * - 010 - Add dq6 delay of 2 delay units.
 * - 011 - Add dq6 delay of 3 delay units.
 * - 100 - Add dq6 delay of 4 delay units.
 * - 101 - Add dq6 delay of 5 delay units.
 * - 110 - Add dq6 delay of 6 delay units.
 * - 111 - Add dq6 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq6_del (24U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq6_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq6_del (0x07000000U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq6_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq6_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq6_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq6_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq6_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq6_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq6_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq6_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq6_del) & BM_MMDC_MPRDDQBY0DL_rd_dq6_del)

/*! @brief Set the rd_dq6_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq6_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq6_del) | BF_MMDC_MPRDDQBY0DL_rd_dq6_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY0DL, field rd_dq7_del[30:28] (RW)
 *
 * Read dqs0 to dq7 delay fine-tuning. This field holds the number of delay
 * units that are added to dq7 relative to dqs0.
 *
 * Values:
 * - 000 - No change in dq7 delay
 * - 001 - Add dq7 delay of 1 delay unit
 * - 010 - Add dq7 delay of 2 delay units.
 * - 011 - Add dq7 delay of 3 delay units.
 * - 100 - Add dq7 delay of 4 delay units.
 * - 101 - Add dq7 delay of 5 delay units.
 * - 110 - Add dq7 delay of 6 delay units.
 * - 111 - Add dq7 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY0DL_rd_dq7_del (28U) /*!< Bit position for MMDC_MPRDDQBY0DL_rd_dq7_del. */
#define BM_MMDC_MPRDDQBY0DL_rd_dq7_del (0x70000000U) /*!< Bit mask for MMDC_MPRDDQBY0DL_rd_dq7_del. */
#define BS_MMDC_MPRDDQBY0DL_rd_dq7_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY0DL_rd_dq7_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY0DL_rd_dq7_del field. */
#define BR_MMDC_MPRDDQBY0DL_rd_dq7_del(x) (HW_MMDC_MPRDDQBY0DL(x).B.rd_dq7_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY0DL_rd_dq7_del. */
#define BF_MMDC_MPRDDQBY0DL_rd_dq7_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY0DL_rd_dq7_del) & BM_MMDC_MPRDDQBY0DL_rd_dq7_del)

/*! @brief Set the rd_dq7_del field to a new value. */
#define BW_MMDC_MPRDDQBY0DL_rd_dq7_del(x, v) (HW_MMDC_MPRDDQBY0DL_WR(x, (HW_MMDC_MPRDDQBY0DL_RD(x) & ~BM_MMDC_MPRDDQBY0DL_rd_dq7_del) | BF_MMDC_MPRDDQBY0DL_rd_dq7_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDQBY1DL - MMDC PHY Read DQ Byte1 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDQBY1DL - MMDC PHY Read DQ Byte1 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the read
 * DQ byte1 relative to the read DQS Supported Mode Of Operations: For Channel 0:
 * All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddqby1dl
{
    uint32_t U;
    struct _hw_mmdc_mprddqby1dl_bitfields
    {
        uint32_t rd_dq8_del : 3;       /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t rd_dq9_del : 3;       /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t rd_dq10_del : 3;      /*!< [10:8]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t rd_dq11_del : 3;      /*!< [14:12]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t rd_dq12_del : 3;      /*!< [18:16]  */
        uint32_t RESERVED4 : 1;        /*!< [19]  */
        uint32_t rd_dq13_del : 3;      /*!< [22:20]  */
        uint32_t RESERVED5 : 1;        /*!< [23]  */
        uint32_t rd_dq14_del : 3;      /*!< [26:24]  */
        uint32_t RESERVED6 : 1;        /*!< [27]  */
        uint32_t rd_dq15_del : 3;      /*!< [30:28]  */
        uint32_t RESERVED7 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddqby1dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDQBY1DL register
 */
/*@{*/
#define HW_MMDC_MPRDDQBY1DL_ADDR(x) ((uintptr_t)(x) + 0x820U)

#define HW_MMDC_MPRDDQBY1DL(x)   (*(__IO hw_mmdc_mprddqby1dl_t *) HW_MMDC_MPRDDQBY1DL_ADDR(x))
#define HW_MMDC_MPRDDQBY1DL_RD(x) (HW_MMDC_MPRDDQBY1DL(x).U)
#define HW_MMDC_MPRDDQBY1DL_WR(x, v) (HW_MMDC_MPRDDQBY1DL(x).U = (v))
#define HW_MMDC_MPRDDQBY1DL_SET(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, HW_MMDC_MPRDDQBY1DL_RD(x) |  (v)))
#define HW_MMDC_MPRDDQBY1DL_CLR(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, HW_MMDC_MPRDDQBY1DL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDQBY1DL_TOG(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, HW_MMDC_MPRDDQBY1DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDQBY1DL bitfields
 */

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq8_del[2:0] (RW)
 *
 * Read dqs1 to dq8 delay fine-tuning. This field holds the number of delay
 * units that are added to dq8 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq8 delay
 * - 001 - Add dq8 delay of 1 delay unit
 * - 010 - Add dq8 delay of 2 delay units.
 * - 011 - Add dq8 delay of 3 delay units.
 * - 100 - Add dq8 delay of 4 delay units.
 * - 101 - Add dq8 delay of 5 delay units.
 * - 110 - Add dq8 delay of 6 delay units.
 * - 111 - Add dq8 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq8_del (0U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq8_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq8_del (0x00000007U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq8_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq8_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq8_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq8_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq8_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq8_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq8_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq8_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq8_del) & BM_MMDC_MPRDDQBY1DL_rd_dq8_del)

/*! @brief Set the rd_dq8_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq8_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq8_del) | BF_MMDC_MPRDDQBY1DL_rd_dq8_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq9_del[6:4] (RW)
 *
 * Read dqs1 to dq9 delay fine-tuning. This field holds the number of delay
 * units that are added to dq9 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq9 delay
 * - 001 - Add dq9 delay of 1 delay unit
 * - 010 - Add dq9 delay of 2 delay units.
 * - 011 - Add dq9 delay of 3 delay units.
 * - 100 - Add dq9 delay of 4 delay units.
 * - 101 - Add dq9 delay of 5 delay units.
 * - 110 - Add dq9 delay of 6 delay units.
 * - 111 - Add dq9 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq9_del (4U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq9_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq9_del (0x00000070U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq9_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq9_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq9_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq9_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq9_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq9_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq9_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq9_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq9_del) & BM_MMDC_MPRDDQBY1DL_rd_dq9_del)

/*! @brief Set the rd_dq9_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq9_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq9_del) | BF_MMDC_MPRDDQBY1DL_rd_dq9_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq10_del[10:8] (RW)
 *
 * Read dqs1 to dq10 delay fine-tuning. This field holds the number of delay
 * units that are added to dq10 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq10 delay
 * - 001 - Add dq10 delay of 1 delay unit
 * - 010 - Add dq10 delay of 2 delay units.
 * - 011 - Add dq10 delay of 3 delay units.
 * - 100 - Add dq10 delay of 4 delay units.
 * - 101 - Add dq10 delay of 5 delay unit
 * - 110 - Add dq10 delay of 6 delay units.
 * - 111 - Add dq10 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq10_del (8U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq10_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq10_del (0x00000700U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq10_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq10_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq10_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq10_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq10_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq10_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq10_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq10_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq10_del) & BM_MMDC_MPRDDQBY1DL_rd_dq10_del)

/*! @brief Set the rd_dq10_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq10_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq10_del) | BF_MMDC_MPRDDQBY1DL_rd_dq10_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq11_del[14:12] (RW)
 *
 * Read dqs1 to dq11 delay fine-tuning. This field holds the number of delay
 * units that are added to dq11 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq11 delay
 * - 001 - Add dq11 delay of 1 delay unit
 * - 010 - Add dq11 delay of 2 delay units.
 * - 011 - Add dq11 delay of 3 delay units.
 * - 100 - Add dq11 delay of 4 delay units.
 * - 101 - Add dq11 delay of 5 delay units.
 * - 110 - Add dq11 delay of 6 delay units.
 * - 111 - Add dq11 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq11_del (12U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq11_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq11_del (0x00007000U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq11_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq11_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq11_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq11_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq11_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq11_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq11_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq11_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq11_del) & BM_MMDC_MPRDDQBY1DL_rd_dq11_del)

/*! @brief Set the rd_dq11_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq11_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq11_del) | BF_MMDC_MPRDDQBY1DL_rd_dq11_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq12_del[18:16] (RW)
 *
 * Read dqs1 to dq12 delay fine-tuning. This field holds the number of delay
 * units that are added to dq12 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq12 delay
 * - 001 - Add dq12 delay of 1 delay unit
 * - 010 - Add dq12 delay of 2 delay units.
 * - 011 - Add dq12 delay of 3 delay units.
 * - 100 - Add dq12 delay of 4 delay units.
 * - 101 - Add dq12 delay of 5 delay units.
 * - 110 - Add dq12 delay of 6 delay units.
 * - 111 - Add dq12 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq12_del (16U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq12_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq12_del (0x00070000U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq12_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq12_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq12_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq12_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq12_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq12_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq12_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq12_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq12_del) & BM_MMDC_MPRDDQBY1DL_rd_dq12_del)

/*! @brief Set the rd_dq12_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq12_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq12_del) | BF_MMDC_MPRDDQBY1DL_rd_dq12_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq13_del[22:20] (RW)
 *
 * Read dqs1 to dq13 delay fine-tuning. This field holds the number of delay
 * units that are added to dq13 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq13 delay
 * - 001 - Add dq13 delay of 1 delay unit
 * - 010 - Add dq13 delay of 2 delay units.
 * - 011 - Add dq13 delay of 3 delay units.
 * - 100 - Add dq13 delay of 4 delay units.
 * - 101 - Add dq13 delay of 5 delay units.
 * - 110 - Add dq13 delay of 6 delay units.
 * - 111 - Add dq13 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq13_del (20U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq13_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq13_del (0x00700000U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq13_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq13_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq13_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq13_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq13_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq13_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq13_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq13_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq13_del) & BM_MMDC_MPRDDQBY1DL_rd_dq13_del)

/*! @brief Set the rd_dq13_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq13_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq13_del) | BF_MMDC_MPRDDQBY1DL_rd_dq13_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq14_del[26:24] (RW)
 *
 * Read dqs1 to dq14 delay fine-tuning. This field holds the number of delay
 * units that are added to dq14 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq14 delay
 * - 001 - Add dq14 delay of 1 delay unit
 * - 010 - Add dq14 delay of 2 delay units.
 * - 011 - Add dq14 delay of 3 delay units.
 * - 100 - Add dq14 delay of 4 delay units.
 * - 101 - Add dq14 delay of 5 delay units.
 * - 110 - Add dq14 delay of 6 delay units.
 * - 111 - Add dq14 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq14_del (24U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq14_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq14_del (0x07000000U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq14_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq14_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq14_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq14_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq14_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq14_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq14_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq14_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq14_del) & BM_MMDC_MPRDDQBY1DL_rd_dq14_del)

/*! @brief Set the rd_dq14_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq14_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq14_del) | BF_MMDC_MPRDDQBY1DL_rd_dq14_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY1DL, field rd_dq15_del[30:28] (RW)
 *
 * Read dqs1 to dq15 delay fine-tuning. This field holds the number of delay
 * units that are added to dq15 relative to dqs1.
 *
 * Values:
 * - 000 - No change in dq15 delay
 * - 001 - Add dq15 delay of 1 delay unit
 * - 010 - Add dq15 delay of 2 delay units.
 * - 011 - Add dq15 delay of 3 delay units.
 * - 100 - Add dq15 delay of 4 delay units.
 * - 101 - Add dq15 delay of 5 delay units.
 * - 110 - Add dq15 delay of 6 delay units.
 * - 111 - Add dq15 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY1DL_rd_dq15_del (28U) /*!< Bit position for MMDC_MPRDDQBY1DL_rd_dq15_del. */
#define BM_MMDC_MPRDDQBY1DL_rd_dq15_del (0x70000000U) /*!< Bit mask for MMDC_MPRDDQBY1DL_rd_dq15_del. */
#define BS_MMDC_MPRDDQBY1DL_rd_dq15_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY1DL_rd_dq15_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY1DL_rd_dq15_del field. */
#define BR_MMDC_MPRDDQBY1DL_rd_dq15_del(x) (HW_MMDC_MPRDDQBY1DL(x).B.rd_dq15_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY1DL_rd_dq15_del. */
#define BF_MMDC_MPRDDQBY1DL_rd_dq15_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY1DL_rd_dq15_del) & BM_MMDC_MPRDDQBY1DL_rd_dq15_del)

/*! @brief Set the rd_dq15_del field to a new value. */
#define BW_MMDC_MPRDDQBY1DL_rd_dq15_del(x, v) (HW_MMDC_MPRDDQBY1DL_WR(x, (HW_MMDC_MPRDDQBY1DL_RD(x) & ~BM_MMDC_MPRDDQBY1DL_rd_dq15_del) | BF_MMDC_MPRDDQBY1DL_rd_dq15_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDQBY2DL - MMDC PHY Read DQ Byte2 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDQBY2DL - MMDC PHY Read DQ Byte2 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the read
 * DQ byte2 relative to the read DQS Supported Mode Of Operations: For Channel 0:
 * All For Channel 1: DDR3_x64, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddqby2dl
{
    uint32_t U;
    struct _hw_mmdc_mprddqby2dl_bitfields
    {
        uint32_t rd_dq16_del : 3;      /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t rd_dq17_del : 3;      /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t rd_dq18_del : 3;      /*!< [10:8]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t rd_dq19_del : 3;      /*!< [14:12]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t rd_dq20_del : 3;      /*!< [18:16]  */
        uint32_t RESERVED4 : 1;        /*!< [19]  */
        uint32_t rd_dq21_del : 3;      /*!< [22:20]  */
        uint32_t RESERVED5 : 1;        /*!< [23]  */
        uint32_t rd_dq22_del : 3;      /*!< [26:24]  */
        uint32_t RESERVED6 : 1;        /*!< [27]  */
        uint32_t rd_dq23_del : 3;      /*!< [30:28]  */
        uint32_t RESERVED7 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddqby2dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDQBY2DL register
 */
/*@{*/
#define HW_MMDC_MPRDDQBY2DL_ADDR(x) ((uintptr_t)(x) + 0x824U)

#define HW_MMDC_MPRDDQBY2DL(x)   (*(__IO hw_mmdc_mprddqby2dl_t *) HW_MMDC_MPRDDQBY2DL_ADDR(x))
#define HW_MMDC_MPRDDQBY2DL_RD(x) (HW_MMDC_MPRDDQBY2DL(x).U)
#define HW_MMDC_MPRDDQBY2DL_WR(x, v) (HW_MMDC_MPRDDQBY2DL(x).U = (v))
#define HW_MMDC_MPRDDQBY2DL_SET(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, HW_MMDC_MPRDDQBY2DL_RD(x) |  (v)))
#define HW_MMDC_MPRDDQBY2DL_CLR(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, HW_MMDC_MPRDDQBY2DL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDQBY2DL_TOG(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, HW_MMDC_MPRDDQBY2DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDQBY2DL bitfields
 */

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq16_del[2:0] (RW)
 *
 * Read dqs2 to dq16 delay fine-tuning. This field holds the number of delay
 * units that are added to dq16 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq16 delay
 * - 001 - Add dq16 delay of 1 delay unit
 * - 010 - Add dq16 delay of 2 delay units.
 * - 011 - Add dq16 delay of 3 delay units.
 * - 100 - Add dq16 delay of 4 delay units.
 * - 101 - Add dq16 delay of 5 delay units.
 * - 110 - Add dq16 delay of 6 delay units.
 * - 111 - Add dq16 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq16_del (0U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq16_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq16_del (0x00000007U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq16_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq16_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq16_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq16_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq16_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq16_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq16_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq16_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq16_del) & BM_MMDC_MPRDDQBY2DL_rd_dq16_del)

/*! @brief Set the rd_dq16_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq16_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq16_del) | BF_MMDC_MPRDDQBY2DL_rd_dq16_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq17_del[6:4] (RW)
 *
 * Read dqs2 to dq17 delay fine-tuning. This field holds the number of delay
 * units that are added to dq17 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq17 delay
 * - 001 - Add dq17 delay of 1 delay unit
 * - 010 - Add dq17 delay of 2 delay units.
 * - 011 - Add dq17 delay of 3 delay units.
 * - 100 - Add dq17 delay of 4 delay units.
 * - 101 - Add dq17 delay of 5 delay units.
 * - 110 - Add dq17 delay of 6 delay units.
 * - 111 - Add dq17 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq17_del (4U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq17_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq17_del (0x00000070U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq17_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq17_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq17_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq17_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq17_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq17_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq17_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq17_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq17_del) & BM_MMDC_MPRDDQBY2DL_rd_dq17_del)

/*! @brief Set the rd_dq17_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq17_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq17_del) | BF_MMDC_MPRDDQBY2DL_rd_dq17_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq18_del[10:8] (RW)
 *
 * Read dqs2 to dq18 delay fine-tuning. This field holds the number of delay
 * units that are added to dq18 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq18 delay
 * - 001 - Add dq18 delay of 1 delay unit
 * - 010 - Add dq18 delay of 2 delay units.
 * - 011 - Add dq18 delay of 3 delay units.
 * - 100 - Add dq18 delay of 4 delay units.
 * - 101 - Add dq18 delay of 5 delay units.
 * - 110 - Add dq18 delay of 6 delay units.
 * - 111 - Add dq18 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq18_del (8U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq18_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq18_del (0x00000700U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq18_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq18_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq18_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq18_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq18_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq18_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq18_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq18_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq18_del) & BM_MMDC_MPRDDQBY2DL_rd_dq18_del)

/*! @brief Set the rd_dq18_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq18_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq18_del) | BF_MMDC_MPRDDQBY2DL_rd_dq18_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq19_del[14:12] (RW)
 *
 * Read dqs2 to dq19 delay fine-tuning. This field holds the number of delay
 * units that are added to dq19 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq19 delay
 * - 001 - Add dq19 delay of 1 delay unit
 * - 010 - Add dq19 delay of 2 delay units.
 * - 011 - Add dq19 delay of 3 delay units.
 * - 100 - Add dq19 delay of 4 delay units.
 * - 101 - Add dq19 delay of 5 delay units.
 * - 110 - Add dq19 delay of 6 delay units.
 * - 111 - Add dq19 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq19_del (12U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq19_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq19_del (0x00007000U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq19_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq19_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq19_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq19_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq19_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq19_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq19_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq19_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq19_del) & BM_MMDC_MPRDDQBY2DL_rd_dq19_del)

/*! @brief Set the rd_dq19_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq19_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq19_del) | BF_MMDC_MPRDDQBY2DL_rd_dq19_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq20_del[18:16] (RW)
 *
 * Read dqs2 to dq20 delay fine-tuning. This field holds the number of delay
 * units that are added to dq20 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq20 delay
 * - 001 - Add dq20 delay of 1 delay unit
 * - 010 - Add dq20 delay of 2 delay units.
 * - 011 - Add dq20 delay of 3 delay units.
 * - 100 - Add dq20 delay of 4 delay units.
 * - 101 - Add dq20 delay of 5 delay units.
 * - 110 - Add dq20 delay of 6 delay units.
 * - 111 - Add dq20 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq20_del (16U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq20_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq20_del (0x00070000U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq20_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq20_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq20_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq20_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq20_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq20_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq20_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq20_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq20_del) & BM_MMDC_MPRDDQBY2DL_rd_dq20_del)

/*! @brief Set the rd_dq20_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq20_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq20_del) | BF_MMDC_MPRDDQBY2DL_rd_dq20_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq21_del[22:20] (RW)
 *
 * Read dqs2 to dq21 delay fine-tuning. This field holds the number of delay
 * units that are added to dq21 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq21 delay
 * - 001 - Add dq21 delay of 1 delay unit
 * - 010 - Add dq21 delay of 2 delay units.
 * - 011 - Add dq21 delay of 3 delay units.
 * - 100 - Add dq21 delay of 4 delay units.
 * - 101 - Add dq21 delay of 5 delay units.
 * - 110 - Add dq21 delay of 6 delay units.
 * - 111 - Add dq21 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq21_del (20U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq21_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq21_del (0x00700000U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq21_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq21_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq21_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq21_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq21_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq21_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq21_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq21_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq21_del) & BM_MMDC_MPRDDQBY2DL_rd_dq21_del)

/*! @brief Set the rd_dq21_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq21_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq21_del) | BF_MMDC_MPRDDQBY2DL_rd_dq21_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq22_del[26:24] (RW)
 *
 * Read dqs2 to dq22 delay fine-tuning. This field holds the number of delay
 * units that are added to dq22 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq22 delay
 * - 001 - Add dq22 delay of 1 delay unit
 * - 010 - Add dq22 delay of 2 delay units.
 * - 011 - Add dq22 delay of 3 delay units.
 * - 100 - Add dq22 delay of 4 delay units.
 * - 101 - Add dq22 delay of 5 delay units.
 * - 110 - Add dq22 delay of 6 delay units.
 * - 111 - Add dq22 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq22_del (24U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq22_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq22_del (0x07000000U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq22_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq22_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq22_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq22_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq22_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq22_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq22_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq22_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq22_del) & BM_MMDC_MPRDDQBY2DL_rd_dq22_del)

/*! @brief Set the rd_dq22_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq22_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq22_del) | BF_MMDC_MPRDDQBY2DL_rd_dq22_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY2DL, field rd_dq23_del[30:28] (RW)
 *
 * Read dqs2 to dq23 delay fine-tuning. This field holds the number of delay
 * units that are added to dq23 relative to dqs2.
 *
 * Values:
 * - 000 - No change in dq23 delay
 * - 001 - Add dq23 delay of 1 delay unit
 * - 010 - Add dq23 delay of 2 delay units.
 * - 011 - Add dq23 delay of 3 delay units.
 * - 100 - Add dq23 delay of 4 delay units.
 * - 101 - Add dq23 delay of 5 delay units.
 * - 110 - Add dq23 delay of 6 delay units.
 * - 111 - Add dq23 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY2DL_rd_dq23_del (28U) /*!< Bit position for MMDC_MPRDDQBY2DL_rd_dq23_del. */
#define BM_MMDC_MPRDDQBY2DL_rd_dq23_del (0x70000000U) /*!< Bit mask for MMDC_MPRDDQBY2DL_rd_dq23_del. */
#define BS_MMDC_MPRDDQBY2DL_rd_dq23_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY2DL_rd_dq23_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY2DL_rd_dq23_del field. */
#define BR_MMDC_MPRDDQBY2DL_rd_dq23_del(x) (HW_MMDC_MPRDDQBY2DL(x).B.rd_dq23_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY2DL_rd_dq23_del. */
#define BF_MMDC_MPRDDQBY2DL_rd_dq23_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY2DL_rd_dq23_del) & BM_MMDC_MPRDDQBY2DL_rd_dq23_del)

/*! @brief Set the rd_dq23_del field to a new value. */
#define BW_MMDC_MPRDDQBY2DL_rd_dq23_del(x, v) (HW_MMDC_MPRDDQBY2DL_WR(x, (HW_MMDC_MPRDDQBY2DL_RD(x) & ~BM_MMDC_MPRDDQBY2DL_rd_dq23_del) | BF_MMDC_MPRDDQBY2DL_rd_dq23_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDQBY3DL - MMDC PHY Read DQ Byte3 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDQBY3DL - MMDC PHY Read DQ Byte3 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the read
 * DQ byte3 relative to the read DQS. The bit assignments and the bit field
 * descriptions for the register are shown below. Supported Mode Of Operations: For
 * Channel 0: All For Channel 1: DDR3_x64, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddqby3dl
{
    uint32_t U;
    struct _hw_mmdc_mprddqby3dl_bitfields
    {
        uint32_t rd_dq24_del : 3;      /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t rd_dq25_del : 3;      /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t rd_dq26_del : 3;      /*!< [10:8]  */
        uint32_t RESERVED2 : 1;        /*!< [11]  */
        uint32_t rd_dq27_del : 3;      /*!< [14:12]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t rd_dq28_del : 3;      /*!< [18:16]  */
        uint32_t RESERVED4 : 1;        /*!< [19]  */
        uint32_t rd_dq29_del : 3;      /*!< [22:20]  */
        uint32_t RESERVED5 : 1;        /*!< [23]  */
        uint32_t rd_dq30_del : 3;      /*!< [26:24]  */
        uint32_t RESERVED6 : 1;        /*!< [27]  */
        uint32_t rd_dq31_del : 3;      /*!< [30:28]  */
        uint32_t RESERVED7 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddqby3dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDQBY3DL register
 */
/*@{*/
#define HW_MMDC_MPRDDQBY3DL_ADDR(x) ((uintptr_t)(x) + 0x828U)

#define HW_MMDC_MPRDDQBY3DL(x)   (*(__IO hw_mmdc_mprddqby3dl_t *) HW_MMDC_MPRDDQBY3DL_ADDR(x))
#define HW_MMDC_MPRDDQBY3DL_RD(x) (HW_MMDC_MPRDDQBY3DL(x).U)
#define HW_MMDC_MPRDDQBY3DL_WR(x, v) (HW_MMDC_MPRDDQBY3DL(x).U = (v))
#define HW_MMDC_MPRDDQBY3DL_SET(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, HW_MMDC_MPRDDQBY3DL_RD(x) |  (v)))
#define HW_MMDC_MPRDDQBY3DL_CLR(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, HW_MMDC_MPRDDQBY3DL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDQBY3DL_TOG(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, HW_MMDC_MPRDDQBY3DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDQBY3DL bitfields
 */

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq24_del[2:0] (RW)
 *
 * Read dqs3 to dq24 delay fine-tuning. This field holds the number of delay
 * units that are added to dq24 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq24 delay
 * - 001 - Add dq24 delay of 1 delay unit
 * - 010 - Add dq24 delay of 2 delay units.
 * - 011 - Add dq24 delay of 3 delay units.
 * - 100 - Add dq24 delay of 4 delay units.
 * - 101 - Add dq24 delay of 5 delay units.
 * - 110 - Add dq24 delay of 6 delay units.
 * - 111 - Add dq24 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq24_del (0U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq24_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq24_del (0x00000007U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq24_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq24_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq24_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq24_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq24_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq24_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq24_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq24_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq24_del) & BM_MMDC_MPRDDQBY3DL_rd_dq24_del)

/*! @brief Set the rd_dq24_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq24_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq24_del) | BF_MMDC_MPRDDQBY3DL_rd_dq24_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq25_del[6:4] (RW)
 *
 * Read dqs3 to dq25 delay fine-tuning. This field holds the number of delay
 * units that are added to dq25 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq25 delay
 * - 001 - Add dq25 delay of 1 delay unit
 * - 010 - Add dq25 delay of 2 delay units.
 * - 011 - Add dq25 delay of 3 delay units.
 * - 100 - Add dq25 delay of 4 delay units.
 * - 101 - Add dq25 delay of 5 delay units.
 * - 110 - Add dq25 delay of 6 delay units.
 * - 111 - Add dq25 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq25_del (4U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq25_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq25_del (0x00000070U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq25_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq25_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq25_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq25_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq25_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq25_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq25_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq25_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq25_del) & BM_MMDC_MPRDDQBY3DL_rd_dq25_del)

/*! @brief Set the rd_dq25_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq25_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq25_del) | BF_MMDC_MPRDDQBY3DL_rd_dq25_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq26_del[10:8] (RW)
 *
 * Read dqs3 to dq26 delay fine-tuning. This field holds the number of delay
 * units that are added to dq26 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq26 delay
 * - 001 - Add dq26 delay of 1 delay unit
 * - 010 - Add dq26 delay of 2 delay units.
 * - 011 - Add dq26 delay of 3 delay units.
 * - 100 - Add dq26 delay of 4 delay units.
 * - 101 - Add dq26 delay of 5 delay units.
 * - 110 - Add dq26 delay of 6 delay units.
 * - 111 - Add dq26 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq26_del (8U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq26_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq26_del (0x00000700U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq26_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq26_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq26_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq26_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq26_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq26_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq26_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq26_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq26_del) & BM_MMDC_MPRDDQBY3DL_rd_dq26_del)

/*! @brief Set the rd_dq26_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq26_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq26_del) | BF_MMDC_MPRDDQBY3DL_rd_dq26_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq27_del[14:12] (RW)
 *
 * Read dqs3 to dq27 delay fine-tuning. This field holds the number of delay
 * units that are added to dq27 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq27 delay
 * - 001 - Add dq27 delay of 1 delay unit
 * - 010 - Add dq27 delay of 2 delay units.
 * - 011 - Add dq27 delay of 3 delay units.
 * - 100 - Add dq27 delay of 4 delay units.
 * - 101 - Add dq27 delay of 5 delay units.
 * - 110 - Add dq27 delay of 6 delay units.
 * - 111 - Add dq27 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq27_del (12U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq27_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq27_del (0x00007000U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq27_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq27_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq27_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq27_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq27_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq27_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq27_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq27_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq27_del) & BM_MMDC_MPRDDQBY3DL_rd_dq27_del)

/*! @brief Set the rd_dq27_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq27_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq27_del) | BF_MMDC_MPRDDQBY3DL_rd_dq27_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq28_del[18:16] (RW)
 *
 * Read dqs3 to dq28 delay fine-tuning. This field holds the number of delay
 * units that are added to dq28 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq28 delay
 * - 001 - Add dq28 delay of 1 delay unit
 * - 010 - Add dq28 delay of 2 delay units.
 * - 011 - Add dq28 delay of 3 delay units.
 * - 100 - Add dq28 delay of 4 delay units.
 * - 101 - Add dq28 delay of 5 delay units.
 * - 110 - Add dq28 delay of 6 delay units.
 * - 111 - Add dq28 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq28_del (16U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq28_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq28_del (0x00070000U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq28_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq28_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq28_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq28_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq28_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq28_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq28_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq28_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq28_del) & BM_MMDC_MPRDDQBY3DL_rd_dq28_del)

/*! @brief Set the rd_dq28_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq28_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq28_del) | BF_MMDC_MPRDDQBY3DL_rd_dq28_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq29_del[22:20] (RW)
 *
 * Read dqs3 to dq29 delay fine-tuning. This field holds the number of delay
 * units that are added to dq29 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq29 delay
 * - 001 - Add dq29 delay of 1 delay unit
 * - 010 - Add dq29 delay of 2 delay units.
 * - 011 - Add dq29 delay of 3 delay units.
 * - 100 - Add dq29 delay of 4 delay units.
 * - 101 - Add dq29 delay of 5 delay units.
 * - 110 - Add dq29 delay of 6 delay units.
 * - 111 - Add dq29 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq29_del (20U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq29_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq29_del (0x00700000U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq29_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq29_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq29_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq29_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq29_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq29_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq29_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq29_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq29_del) & BM_MMDC_MPRDDQBY3DL_rd_dq29_del)

/*! @brief Set the rd_dq29_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq29_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq29_del) | BF_MMDC_MPRDDQBY3DL_rd_dq29_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq30_del[26:24] (RW)
 *
 * Read dqs3 to dq30 delay fine-tuning. This field holds the number of delay
 * units that are added to dq30 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq30 delay
 * - 001 - Add dq30 delay of 1 delay unit
 * - 010 - Add dq30 delay of 2 delay units.
 * - 011 - Add dq30 delay of 3 delay units.
 * - 100 - Add dq30 delay of 4 delay units.
 * - 101 - Add dq30 delay of 5 delay units.
 * - 110 - Add dq30 delay of 6 delay units.
 * - 111 - Add dq30 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq30_del (24U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq30_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq30_del (0x07000000U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq30_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq30_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq30_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq30_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq30_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq30_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq30_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq30_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq30_del) & BM_MMDC_MPRDDQBY3DL_rd_dq30_del)

/*! @brief Set the rd_dq30_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq30_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq30_del) | BF_MMDC_MPRDDQBY3DL_rd_dq30_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDQBY3DL, field rd_dq31_del[30:28] (RW)
 *
 * Read dqs3 to dq31 delay fine-tuning. This field holds the number of delay
 * units that are added to dq31 relative to dqs3.
 *
 * Values:
 * - 000 - No change in dq31 delay
 * - 001 - Add dq31 delay of 1 delay unit
 * - 010 - Add dq31 delay of 2 delay units.
 * - 011 - Add dq31 delay of 3 delay units.
 * - 100 - Add dq31 delay of 4 delay units.
 * - 101 - Add dq31 delay of 5 delay units.
 * - 110 - Add dq31 delay of 6 delay units.
 * - 111 - Add dq31 delay of 7 delay units.
 */
/*@{*/
#define BP_MMDC_MPRDDQBY3DL_rd_dq31_del (28U) /*!< Bit position for MMDC_MPRDDQBY3DL_rd_dq31_del. */
#define BM_MMDC_MPRDDQBY3DL_rd_dq31_del (0x70000000U) /*!< Bit mask for MMDC_MPRDDQBY3DL_rd_dq31_del. */
#define BS_MMDC_MPRDDQBY3DL_rd_dq31_del (3U) /*!< Bit field size in bits for MMDC_MPRDDQBY3DL_rd_dq31_del. */

/*! @brief Read current value of the MMDC_MPRDDQBY3DL_rd_dq31_del field. */
#define BR_MMDC_MPRDDQBY3DL_rd_dq31_del(x) (HW_MMDC_MPRDDQBY3DL(x).B.rd_dq31_del)

/*! @brief Format value for bitfield MMDC_MPRDDQBY3DL_rd_dq31_del. */
#define BF_MMDC_MPRDDQBY3DL_rd_dq31_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDQBY3DL_rd_dq31_del) & BM_MMDC_MPRDDQBY3DL_rd_dq31_del)

/*! @brief Set the rd_dq31_del field to a new value. */
#define BW_MMDC_MPRDDQBY3DL_rd_dq31_del(x, v) (HW_MMDC_MPRDDQBY3DL_WR(x, (HW_MMDC_MPRDDQBY3DL_RD(x) & ~BM_MMDC_MPRDDQBY3DL_rd_dq31_del) | BF_MMDC_MPRDDQBY3DL_rd_dq31_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDQBY0DL - MMDC PHY Write DQ Byte0 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDQBY0DL - MMDC PHY Write DQ Byte0 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the write
 * DQ byte0 relative to the write DQS Supported Mode Of Operations: For Channel
 * 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdqby0dl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdqby0dl_bitfields
    {
        uint32_t wr_dq0_del : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t wr_dq1_del : 2;       /*!< [5:4]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t wr_dq2_del : 2;       /*!< [9:8]  */
        uint32_t RESERVED2 : 2;        /*!< [11:10]  */
        uint32_t wr_dq3_del : 2;       /*!< [13:12]  */
        uint32_t RESERVED3 : 2;        /*!< [15:14]  */
        uint32_t wr_dq4_del : 2;       /*!< [17:16]  */
        uint32_t RESERVED4 : 2;        /*!< [19:18]  */
        uint32_t wr_dq5_del : 2;       /*!< [21:20]  */
        uint32_t RESERVED5 : 2;        /*!< [23:22]  */
        uint32_t wr_dq6_del : 2;       /*!< [25:24]  */
        uint32_t RESERVED6 : 2;        /*!< [27:26]  */
        uint32_t wr_dq7_del : 2;       /*!< [29:28]  */
        uint32_t wr_dm0_del : 2;       /*!< [31:30]  */
    } B;
} hw_mmdc_mpwrdqby0dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDQBY0DL register
 */
/*@{*/
#define HW_MMDC_MPWRDQBY0DL_ADDR(x) ((uintptr_t)(x) + 0x82CU)

#define HW_MMDC_MPWRDQBY0DL(x)   (*(__IO hw_mmdc_mpwrdqby0dl_t *) HW_MMDC_MPWRDQBY0DL_ADDR(x))
#define HW_MMDC_MPWRDQBY0DL_RD(x) (HW_MMDC_MPWRDQBY0DL(x).U)
#define HW_MMDC_MPWRDQBY0DL_WR(x, v) (HW_MMDC_MPWRDQBY0DL(x).U = (v))
#define HW_MMDC_MPWRDQBY0DL_SET(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, HW_MMDC_MPWRDQBY0DL_RD(x) |  (v)))
#define HW_MMDC_MPWRDQBY0DL_CLR(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, HW_MMDC_MPWRDQBY0DL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDQBY0DL_TOG(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, HW_MMDC_MPWRDQBY0DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDQBY0DL bitfields
 */

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq0_del[1:0] (RW)
 *
 * Write dq0 delay fine-tuning. This field holds the number of delay units that
 * are added to dq0 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq0 delay
 * - 01 - Add dq0 delay of 1 delay unit.
 * - 10 - Add dq0 delay of 2 delay units.
 * - 11 - Add dq0 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq0_del (0U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq0_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq0_del (0x00000003U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq0_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq0_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq0_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq0_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq0_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq0_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq0_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq0_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq0_del) & BM_MMDC_MPWRDQBY0DL_wr_dq0_del)

/*! @brief Set the wr_dq0_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq0_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq0_del) | BF_MMDC_MPWRDQBY0DL_wr_dq0_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq1_del[5:4] (RW)
 *
 * Write dq1 delay fine-tuning. This field holds the number of delay units that
 * are added to dq1 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq1 delay
 * - 01 - Add dq1 delay of 1 delay unit.
 * - 10 - Add dq1 delay of 2 delay units.
 * - 11 - Add dq1 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq1_del (4U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq1_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq1_del (0x00000030U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq1_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq1_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq1_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq1_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq1_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq1_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq1_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq1_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq1_del) & BM_MMDC_MPWRDQBY0DL_wr_dq1_del)

/*! @brief Set the wr_dq1_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq1_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq1_del) | BF_MMDC_MPWRDQBY0DL_wr_dq1_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq2_del[9:8] (RW)
 *
 * Write dq2 delay fine-tuning. This field holds the number of delay units that
 * are added to dq2 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq2 delay
 * - 01 - Add dq2 delay of 1 delay unit.
 * - 10 - Add dq2 delay of 2 delay units.
 * - 11 - Add dq2 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq2_del (8U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq2_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq2_del (0x00000300U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq2_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq2_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq2_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq2_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq2_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq2_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq2_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq2_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq2_del) & BM_MMDC_MPWRDQBY0DL_wr_dq2_del)

/*! @brief Set the wr_dq2_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq2_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq2_del) | BF_MMDC_MPWRDQBY0DL_wr_dq2_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq3_del[13:12] (RW)
 *
 * Write dq3 delay fine-tuning. This field holds the number of delay units that
 * are added to dq3 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq3 delay
 * - 01 - Add dq3 delay of 1 delay unit.
 * - 10 - Add dq3 delay of 2 delay units.
 * - 11 - Add dq3 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq3_del (12U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq3_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq3_del (0x00003000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq3_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq3_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq3_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq3_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq3_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq3_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq3_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq3_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq3_del) & BM_MMDC_MPWRDQBY0DL_wr_dq3_del)

/*! @brief Set the wr_dq3_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq3_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq3_del) | BF_MMDC_MPWRDQBY0DL_wr_dq3_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq4_del[17:16] (RW)
 *
 * Write dq4 delay fine-tuning. This field holds the number of delay units that
 * are added to dq4 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq4 delay
 * - 01 - Add dq4 delay of 1 delay unit..
 * - 10 - Add dq4 delay of 2 delay units.
 * - 11 - Add dq4 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq4_del (16U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq4_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq4_del (0x00030000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq4_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq4_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq4_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq4_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq4_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq4_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq4_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq4_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq4_del) & BM_MMDC_MPWRDQBY0DL_wr_dq4_del)

/*! @brief Set the wr_dq4_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq4_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq4_del) | BF_MMDC_MPWRDQBY0DL_wr_dq4_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq5_del[21:20] (RW)
 *
 * Write dq5 delay fine-tuning. This field holds the number of delay units that
 * are added to dq5 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq5 delay
 * - 01 - Add dq5 delay of 1 delay unit.
 * - 10 - Add dq5 delay of 2 delay units.
 * - 11 - Add dq5 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq5_del (20U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq5_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq5_del (0x00300000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq5_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq5_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq5_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq5_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq5_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq5_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq5_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq5_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq5_del) & BM_MMDC_MPWRDQBY0DL_wr_dq5_del)

/*! @brief Set the wr_dq5_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq5_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq5_del) | BF_MMDC_MPWRDQBY0DL_wr_dq5_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq6_del[25:24] (RW)
 *
 * Write dq6 delay fine-tuning. This field holds the number of delay units that
 * are added to dq6 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq6 delay
 * - 01 - Add dq6 delay of 1 delay unit.
 * - 10 - Add dq6 delay of 2 delay units.
 * - 11 - Add dq6 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq6_del (24U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq6_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq6_del (0x03000000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq6_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq6_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq6_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq6_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq6_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq6_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq6_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq6_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq6_del) & BM_MMDC_MPWRDQBY0DL_wr_dq6_del)

/*! @brief Set the wr_dq6_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq6_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq6_del) | BF_MMDC_MPWRDQBY0DL_wr_dq6_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dq7_del[29:28] (RW)
 *
 * Write dq7 delay fine-tuning. This field holds the number of delay units that
 * are added to dq7 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dq7 delay
 * - 01 - Add dq7 delay of 1 delay unit.
 * - 10 - Add dq7 delay of 2 delay units.
 * - 11 - Add dq7 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dq7_del (28U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dq7_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dq7_del (0x30000000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dq7_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dq7_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dq7_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dq7_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dq7_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dq7_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dq7_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dq7_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dq7_del) & BM_MMDC_MPWRDQBY0DL_wr_dq7_del)

/*! @brief Set the wr_dq7_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dq7_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dq7_del) | BF_MMDC_MPWRDQBY0DL_wr_dq7_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY0DL, field wr_dm0_del[31:30] (RW)
 *
 * Write dm0 delay fine-tuning. This field holds the number of delay units that
 * are added to dm0 relative to dqs0.
 *
 * Values:
 * - 00 - No change in dm0 delay
 * - 01 - Add dm0 delay of 1 delay unit.
 * - 10 - Add dm0 delay of 2 delay units.
 * - 11 - Add dm0 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY0DL_wr_dm0_del (30U) /*!< Bit position for MMDC_MPWRDQBY0DL_wr_dm0_del. */
#define BM_MMDC_MPWRDQBY0DL_wr_dm0_del (0xC0000000U) /*!< Bit mask for MMDC_MPWRDQBY0DL_wr_dm0_del. */
#define BS_MMDC_MPWRDQBY0DL_wr_dm0_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY0DL_wr_dm0_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY0DL_wr_dm0_del field. */
#define BR_MMDC_MPWRDQBY0DL_wr_dm0_del(x) (HW_MMDC_MPWRDQBY0DL(x).B.wr_dm0_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY0DL_wr_dm0_del. */
#define BF_MMDC_MPWRDQBY0DL_wr_dm0_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY0DL_wr_dm0_del) & BM_MMDC_MPWRDQBY0DL_wr_dm0_del)

/*! @brief Set the wr_dm0_del field to a new value. */
#define BW_MMDC_MPWRDQBY0DL_wr_dm0_del(x, v) (HW_MMDC_MPWRDQBY0DL_WR(x, (HW_MMDC_MPWRDQBY0DL_RD(x) & ~BM_MMDC_MPWRDQBY0DL_wr_dm0_del) | BF_MMDC_MPWRDQBY0DL_wr_dm0_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDQBY1DL - MMDC PHY Write DQ Byte1 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDQBY1DL - MMDC PHY Write DQ Byte1 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the write
 * DQ byte1 relative to the write DQS Supported Mode Of Operations: For Channel
 * 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdqby1dl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdqby1dl_bitfields
    {
        uint32_t wr_dq8_del : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t wr_dq9_del : 2;       /*!< [5:4]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t wr_dq10_del : 2;      /*!< [9:8]  */
        uint32_t RESERVED2 : 2;        /*!< [11:10]  */
        uint32_t wr_dq11_del : 2;      /*!< [13:12]  */
        uint32_t RESERVED3 : 2;        /*!< [15:14]  */
        uint32_t wr_dq12_del : 2;      /*!< [17:16]  */
        uint32_t RESERVED4 : 2;        /*!< [19:18]  */
        uint32_t wr_dq13_del : 2;      /*!< [21:20]  */
        uint32_t RESERVED5 : 2;        /*!< [23:22]  */
        uint32_t wr_dq14_del : 2;      /*!< [25:24]  */
        uint32_t RESERVED6 : 2;        /*!< [27:26]  */
        uint32_t wr_dq15_del : 2;      /*!< [29:28]  */
        uint32_t wr_dm1_del : 2;       /*!< [31:30]  */
    } B;
} hw_mmdc_mpwrdqby1dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDQBY1DL register
 */
/*@{*/
#define HW_MMDC_MPWRDQBY1DL_ADDR(x) ((uintptr_t)(x) + 0x830U)

#define HW_MMDC_MPWRDQBY1DL(x)   (*(__IO hw_mmdc_mpwrdqby1dl_t *) HW_MMDC_MPWRDQBY1DL_ADDR(x))
#define HW_MMDC_MPWRDQBY1DL_RD(x) (HW_MMDC_MPWRDQBY1DL(x).U)
#define HW_MMDC_MPWRDQBY1DL_WR(x, v) (HW_MMDC_MPWRDQBY1DL(x).U = (v))
#define HW_MMDC_MPWRDQBY1DL_SET(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, HW_MMDC_MPWRDQBY1DL_RD(x) |  (v)))
#define HW_MMDC_MPWRDQBY1DL_CLR(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, HW_MMDC_MPWRDQBY1DL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDQBY1DL_TOG(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, HW_MMDC_MPWRDQBY1DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDQBY1DL bitfields
 */

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq8_del[1:0] (RW)
 *
 * Write dq8 delay fine-tuning. This field holds the number of delay units that
 * are added to dq8 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq8 delay
 * - 01 - Add dq8 delay of 1 delay unit.
 * - 10 - Add dq8 delay of 2 delay units.
 * - 11 - Add dq8 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq8_del (0U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq8_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq8_del (0x00000003U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq8_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq8_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq8_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq8_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq8_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq8_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq8_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq8_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq8_del) & BM_MMDC_MPWRDQBY1DL_wr_dq8_del)

/*! @brief Set the wr_dq8_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq8_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq8_del) | BF_MMDC_MPWRDQBY1DL_wr_dq8_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq9_del[5:4] (RW)
 *
 * Write dq9 delay fine-tuning. This field holds the number of delay units that
 * are added to dq9 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq9 delay
 * - 01 - Add dq9 delay of 1 delay unit.
 * - 10 - Add dq9 delay of 2 delay units.
 * - 11 - Add dq9 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq9_del (4U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq9_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq9_del (0x00000030U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq9_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq9_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq9_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq9_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq9_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq9_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq9_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq9_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq9_del) & BM_MMDC_MPWRDQBY1DL_wr_dq9_del)

/*! @brief Set the wr_dq9_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq9_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq9_del) | BF_MMDC_MPWRDQBY1DL_wr_dq9_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq10_del[9:8] (RW)
 *
 * Write dq10 delay fine-tuning. This field holds the number of delay units that
 * are added to dq10 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq10 delay
 * - 01 - Add dq10 delay of 1 delay unit.
 * - 10 - Add dq10 delay of 2 delay units.
 * - 11 - Add dq10 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq10_del (8U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq10_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq10_del (0x00000300U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq10_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq10_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq10_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq10_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq10_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq10_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq10_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq10_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq10_del) & BM_MMDC_MPWRDQBY1DL_wr_dq10_del)

/*! @brief Set the wr_dq10_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq10_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq10_del) | BF_MMDC_MPWRDQBY1DL_wr_dq10_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq11_del[13:12] (RW)
 *
 * Write dq11 delay fine-tuning. This field holds the number of delay units that
 * are added to dq11 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq11 delay
 * - 01 - Add dq11 delay of 1 delay unit.
 * - 10 - Add dq11 delay of 2 delay units.
 * - 11 - Add dq11 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq11_del (12U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq11_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq11_del (0x00003000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq11_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq11_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq11_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq11_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq11_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq11_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq11_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq11_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq11_del) & BM_MMDC_MPWRDQBY1DL_wr_dq11_del)

/*! @brief Set the wr_dq11_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq11_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq11_del) | BF_MMDC_MPWRDQBY1DL_wr_dq11_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq12_del[17:16] (RW)
 *
 * Write dq12 delay fine-tuning. This field holds the number of delay units that
 * are added to dq12 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq12 delay
 * - 01 - Add dq12 delay of 1 delay unit.
 * - 10 - Add dq12 delay of 2 delay units.
 * - 11 - Add dq12 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq12_del (16U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq12_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq12_del (0x00030000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq12_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq12_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq12_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq12_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq12_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq12_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq12_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq12_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq12_del) & BM_MMDC_MPWRDQBY1DL_wr_dq12_del)

/*! @brief Set the wr_dq12_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq12_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq12_del) | BF_MMDC_MPWRDQBY1DL_wr_dq12_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq13_del[21:20] (RW)
 *
 * Write dq13 delay fine-tuning. This field holds the number of delay units that
 * are added to dq13 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq13 delay
 * - 01 - Add dq13 delay of 1 delay unit.
 * - 10 - Add dq13 delay of 2 delay units.
 * - 11 - Add dq13 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq13_del (20U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq13_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq13_del (0x00300000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq13_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq13_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq13_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq13_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq13_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq13_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq13_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq13_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq13_del) & BM_MMDC_MPWRDQBY1DL_wr_dq13_del)

/*! @brief Set the wr_dq13_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq13_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq13_del) | BF_MMDC_MPWRDQBY1DL_wr_dq13_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq14_del[25:24] (RW)
 *
 * Write dq14 delay fine-tuning. This field holds the number of delay units that
 * are added to dq14 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq14 delay
 * - 01 - Add dq14 delay of 1 delay unit.
 * - 10 - Add dq14 delay of 2 delay units.
 * - 11 - Add dq14 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq14_del (24U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq14_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq14_del (0x03000000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq14_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq14_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq14_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq14_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq14_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq14_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq14_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq14_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq14_del) & BM_MMDC_MPWRDQBY1DL_wr_dq14_del)

/*! @brief Set the wr_dq14_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq14_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq14_del) | BF_MMDC_MPWRDQBY1DL_wr_dq14_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dq15_del[29:28] (RW)
 *
 * Write dq15 delay fine-tuning. This field holds the number of delay units that
 * are added to dq15 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dq15 delay
 * - 01 - Add dq15 delay of 1 delay unit.
 * - 10 - Add dq15 delay of 2 delay units.
 * - 11 - Add dq15 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dq15_del (28U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dq15_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dq15_del (0x30000000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dq15_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dq15_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dq15_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dq15_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dq15_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dq15_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dq15_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dq15_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dq15_del) & BM_MMDC_MPWRDQBY1DL_wr_dq15_del)

/*! @brief Set the wr_dq15_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dq15_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dq15_del) | BF_MMDC_MPWRDQBY1DL_wr_dq15_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY1DL, field wr_dm1_del[31:30] (RW)
 *
 * Write dm1 delay fine-tuning. This field holds the number of delay units that
 * are added to dm1 relative to dqs1.
 *
 * Values:
 * - 00 - No change in dm1 delay
 * - 01 - Add dm1 delay of 1 delay unit.
 * - 10 - Add dm1 delay of 2 delay units.
 * - 11 - Add dm1 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY1DL_wr_dm1_del (30U) /*!< Bit position for MMDC_MPWRDQBY1DL_wr_dm1_del. */
#define BM_MMDC_MPWRDQBY1DL_wr_dm1_del (0xC0000000U) /*!< Bit mask for MMDC_MPWRDQBY1DL_wr_dm1_del. */
#define BS_MMDC_MPWRDQBY1DL_wr_dm1_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY1DL_wr_dm1_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY1DL_wr_dm1_del field. */
#define BR_MMDC_MPWRDQBY1DL_wr_dm1_del(x) (HW_MMDC_MPWRDQBY1DL(x).B.wr_dm1_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY1DL_wr_dm1_del. */
#define BF_MMDC_MPWRDQBY1DL_wr_dm1_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY1DL_wr_dm1_del) & BM_MMDC_MPWRDQBY1DL_wr_dm1_del)

/*! @brief Set the wr_dm1_del field to a new value. */
#define BW_MMDC_MPWRDQBY1DL_wr_dm1_del(x, v) (HW_MMDC_MPWRDQBY1DL_WR(x, (HW_MMDC_MPWRDQBY1DL_RD(x) & ~BM_MMDC_MPWRDQBY1DL_wr_dm1_del) | BF_MMDC_MPWRDQBY1DL_wr_dm1_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDQBY2DL - MMDC PHY Write DQ Byte2 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDQBY2DL - MMDC PHY Write DQ Byte2 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the write
 * DQ byte2 relative to the write DQS Supported Mode Of Operations: For Channel
 * 0: All For Channel 1: DDR3_x64, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdqby2dl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdqby2dl_bitfields
    {
        uint32_t wr_dq16_del : 2;      /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t wr_dq17_del : 2;      /*!< [5:4]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t wr_dq18_del : 2;      /*!< [9:8]  */
        uint32_t RESERVED2 : 2;        /*!< [11:10]  */
        uint32_t wr_dq19_del : 2;      /*!< [13:12]  */
        uint32_t RESERVED3 : 2;        /*!< [15:14]  */
        uint32_t wr_dq20_del : 2;      /*!< [17:16]  */
        uint32_t RESERVED4 : 2;        /*!< [19:18]  */
        uint32_t wr_dq21_del : 2;      /*!< [21:20]  */
        uint32_t RESERVED5 : 2;        /*!< [23:22]  */
        uint32_t wr_dq22_del : 2;      /*!< [25:24]  */
        uint32_t RESERVED6 : 2;        /*!< [27:26]  */
        uint32_t wr_dq23_del : 2;      /*!< [29:28]  */
        uint32_t wr_dm2_del : 2;       /*!< [31:30]  */
    } B;
} hw_mmdc_mpwrdqby2dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDQBY2DL register
 */
/*@{*/
#define HW_MMDC_MPWRDQBY2DL_ADDR(x) ((uintptr_t)(x) + 0x834U)

#define HW_MMDC_MPWRDQBY2DL(x)   (*(__IO hw_mmdc_mpwrdqby2dl_t *) HW_MMDC_MPWRDQBY2DL_ADDR(x))
#define HW_MMDC_MPWRDQBY2DL_RD(x) (HW_MMDC_MPWRDQBY2DL(x).U)
#define HW_MMDC_MPWRDQBY2DL_WR(x, v) (HW_MMDC_MPWRDQBY2DL(x).U = (v))
#define HW_MMDC_MPWRDQBY2DL_SET(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, HW_MMDC_MPWRDQBY2DL_RD(x) |  (v)))
#define HW_MMDC_MPWRDQBY2DL_CLR(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, HW_MMDC_MPWRDQBY2DL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDQBY2DL_TOG(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, HW_MMDC_MPWRDQBY2DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDQBY2DL bitfields
 */

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq16_del[1:0] (RW)
 *
 * Write dq16 delay fine tuning. This field holds the number of delay units that
 * are added to dq16 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq16 delay
 * - 01 - Add dq16 delay of 1 delay unit.
 * - 10 - Add dq16 delay of 2 delay units.
 * - 11 - Add dq16 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq16_del (0U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq16_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq16_del (0x00000003U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq16_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq16_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq16_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq16_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq16_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq16_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq16_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq16_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq16_del) & BM_MMDC_MPWRDQBY2DL_wr_dq16_del)

/*! @brief Set the wr_dq16_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq16_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq16_del) | BF_MMDC_MPWRDQBY2DL_wr_dq16_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq17_del[5:4] (RW)
 *
 * Write dq17 delay fine tuning. This field holds the number of delay units that
 * are added to dq17 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq17 delay
 * - 01 - Add dq17 delay of 1 delay unit.
 * - 10 - Add dq17 delay of 2 delay units.
 * - 11 - Add dq17 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq17_del (4U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq17_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq17_del (0x00000030U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq17_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq17_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq17_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq17_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq17_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq17_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq17_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq17_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq17_del) & BM_MMDC_MPWRDQBY2DL_wr_dq17_del)

/*! @brief Set the wr_dq17_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq17_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq17_del) | BF_MMDC_MPWRDQBY2DL_wr_dq17_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq18_del[9:8] (RW)
 *
 * Write dq18 delay fine tuning. This field holds the number of delay units that
 * are added to dq18 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq18 delay
 * - 01 - Add dq18 delay of 1 delay unit.
 * - 10 - Add dq18 delay of 2 delay units.
 * - 11 - Add dq18 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq18_del (8U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq18_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq18_del (0x00000300U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq18_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq18_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq18_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq18_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq18_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq18_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq18_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq18_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq18_del) & BM_MMDC_MPWRDQBY2DL_wr_dq18_del)

/*! @brief Set the wr_dq18_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq18_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq18_del) | BF_MMDC_MPWRDQBY2DL_wr_dq18_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq19_del[13:12] (RW)
 *
 * Write dq19 delay fine tuning. This field holds the number of delay units that
 * are added to dq19 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq19 delay
 * - 01 - Add dq19 delay of 1 delay unit.
 * - 10 - Add dq19 delay of 2 delay units.
 * - 11 - Add dq19 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq19_del (12U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq19_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq19_del (0x00003000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq19_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq19_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq19_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq19_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq19_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq19_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq19_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq19_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq19_del) & BM_MMDC_MPWRDQBY2DL_wr_dq19_del)

/*! @brief Set the wr_dq19_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq19_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq19_del) | BF_MMDC_MPWRDQBY2DL_wr_dq19_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq20_del[17:16] (RW)
 *
 * Write dq20 delay fine tuning. This field holds the number of delay units that
 * are added to dq20 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq20 delay
 * - 01 - Add dq20 delay of 1 delay unit.
 * - 10 - Add dq20 delay of 2 delay units.
 * - 11 - Add dq20 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq20_del (16U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq20_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq20_del (0x00030000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq20_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq20_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq20_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq20_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq20_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq20_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq20_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq20_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq20_del) & BM_MMDC_MPWRDQBY2DL_wr_dq20_del)

/*! @brief Set the wr_dq20_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq20_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq20_del) | BF_MMDC_MPWRDQBY2DL_wr_dq20_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq21_del[21:20] (RW)
 *
 * Write dq21 delay fine tuning. This field holds the number of delay units that
 * are added to dq21 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq21 delay
 * - 01 - Add dq21 delay of 1 delay unit.
 * - 10 - Add dq21 delay of 2 delay units.
 * - 11 - Add dq21 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq21_del (20U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq21_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq21_del (0x00300000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq21_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq21_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq21_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq21_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq21_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq21_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq21_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq21_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq21_del) & BM_MMDC_MPWRDQBY2DL_wr_dq21_del)

/*! @brief Set the wr_dq21_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq21_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq21_del) | BF_MMDC_MPWRDQBY2DL_wr_dq21_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq22_del[25:24] (RW)
 *
 * Write dq22 delay fine tuning. This field holds the number of delay units that
 * are added to dq22 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq22 delay
 * - 01 - Add dq22 delay of 1 delay unit.
 * - 10 - Add dq22 delay of 2 delay units.
 * - 11 - Add dq22 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq22_del (24U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq22_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq22_del (0x03000000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq22_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq22_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq22_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq22_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq22_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq22_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq22_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq22_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq22_del) & BM_MMDC_MPWRDQBY2DL_wr_dq22_del)

/*! @brief Set the wr_dq22_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq22_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq22_del) | BF_MMDC_MPWRDQBY2DL_wr_dq22_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dq23_del[29:28] (RW)
 *
 * Write dq23 delay fine tuning. This field holds the number of delay units that
 * are added to dq23 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dq23 delay
 * - 01 - Add dq23 delay of 1 delay unit.
 * - 10 - Add dq23 delay of 2 delay units.
 * - 11 - Add dq23 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dq23_del (28U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dq23_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dq23_del (0x30000000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dq23_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dq23_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dq23_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dq23_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dq23_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dq23_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dq23_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dq23_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dq23_del) & BM_MMDC_MPWRDQBY2DL_wr_dq23_del)

/*! @brief Set the wr_dq23_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dq23_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dq23_del) | BF_MMDC_MPWRDQBY2DL_wr_dq23_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY2DL, field wr_dm2_del[31:30] (RW)
 *
 * Write dm2 delay fine-tuning. This field holds the number of delay units that
 * are added to dm2 relative to dqs2.
 *
 * Values:
 * - 00 - No change in dm2 delay
 * - 01 - Add dm2 delay of 1 delay unit.
 * - 10 - Add dm2 delay of 2 delay units.
 * - 11 - Add dm2 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY2DL_wr_dm2_del (30U) /*!< Bit position for MMDC_MPWRDQBY2DL_wr_dm2_del. */
#define BM_MMDC_MPWRDQBY2DL_wr_dm2_del (0xC0000000U) /*!< Bit mask for MMDC_MPWRDQBY2DL_wr_dm2_del. */
#define BS_MMDC_MPWRDQBY2DL_wr_dm2_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY2DL_wr_dm2_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY2DL_wr_dm2_del field. */
#define BR_MMDC_MPWRDQBY2DL_wr_dm2_del(x) (HW_MMDC_MPWRDQBY2DL(x).B.wr_dm2_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY2DL_wr_dm2_del. */
#define BF_MMDC_MPWRDQBY2DL_wr_dm2_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY2DL_wr_dm2_del) & BM_MMDC_MPWRDQBY2DL_wr_dm2_del)

/*! @brief Set the wr_dm2_del field to a new value. */
#define BW_MMDC_MPWRDQBY2DL_wr_dm2_del(x, v) (HW_MMDC_MPWRDQBY2DL_WR(x, (HW_MMDC_MPWRDQBY2DL_RD(x) & ~BM_MMDC_MPWRDQBY2DL_wr_dm2_del) | BF_MMDC_MPWRDQBY2DL_wr_dm2_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDQBY3DL - MMDC PHY Write DQ Byte3 Delay Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDQBY3DL - MMDC PHY Write DQ Byte3 Delay Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to every bit in the write
 * DQ byte3 relative to the write DQS Supported Mode Of Operations: For Channel
 * 0: All For Channel 1: DDR3_x64, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdqby3dl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdqby3dl_bitfields
    {
        uint32_t wr_dq24_del : 2;      /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t wr_dq25_del : 2;      /*!< [5:4]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t wr_dq26_del : 2;      /*!< [9:8]  */
        uint32_t RESERVED2 : 2;        /*!< [11:10]  */
        uint32_t wr_dq27_del : 2;      /*!< [13:12]  */
        uint32_t RESERVED3 : 2;        /*!< [15:14]  */
        uint32_t wr_dq28_del : 2;      /*!< [17:16]  */
        uint32_t RESERVED4 : 2;        /*!< [19:18]  */
        uint32_t wr_dq29_del : 2;      /*!< [21:20]  */
        uint32_t RESERVED5 : 2;        /*!< [23:22]  */
        uint32_t wr_dq30_del : 2;      /*!< [25:24]  */
        uint32_t RESERVED6 : 2;        /*!< [27:26]  */
        uint32_t wr_dq31_del : 2;      /*!< [29:28]  */
        uint32_t wr_dm3_del : 2;       /*!< [31:30]  */
    } B;
} hw_mmdc_mpwrdqby3dl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDQBY3DL register
 */
/*@{*/
#define HW_MMDC_MPWRDQBY3DL_ADDR(x) ((uintptr_t)(x) + 0x838U)

#define HW_MMDC_MPWRDQBY3DL(x)   (*(__IO hw_mmdc_mpwrdqby3dl_t *) HW_MMDC_MPWRDQBY3DL_ADDR(x))
#define HW_MMDC_MPWRDQBY3DL_RD(x) (HW_MMDC_MPWRDQBY3DL(x).U)
#define HW_MMDC_MPWRDQBY3DL_WR(x, v) (HW_MMDC_MPWRDQBY3DL(x).U = (v))
#define HW_MMDC_MPWRDQBY3DL_SET(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, HW_MMDC_MPWRDQBY3DL_RD(x) |  (v)))
#define HW_MMDC_MPWRDQBY3DL_CLR(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, HW_MMDC_MPWRDQBY3DL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDQBY3DL_TOG(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, HW_MMDC_MPWRDQBY3DL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDQBY3DL bitfields
 */

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq24_del[1:0] (RW)
 *
 * Write dq24 delay fine tuning. This field holds the number of delay units that
 * are added to dq24 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq24 delay
 * - 01 - Add dq24 delay of 1 delay unit.
 * - 10 - Add dq24 delay of 2 delay units.
 * - 11 - Add dq24 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq24_del (0U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq24_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq24_del (0x00000003U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq24_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq24_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq24_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq24_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq24_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq24_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq24_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq24_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq24_del) & BM_MMDC_MPWRDQBY3DL_wr_dq24_del)

/*! @brief Set the wr_dq24_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq24_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq24_del) | BF_MMDC_MPWRDQBY3DL_wr_dq24_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq25_del[5:4] (RW)
 *
 * Write dq25 delay fine tuning. This field holds the number of delay units that
 * are added to dq25 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq25 delay
 * - 01 - Add dq25 delay of 1 delay unit.
 * - 10 - Add dq25 delay of 2 delay units.
 * - 11 - Add dq25 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq25_del (4U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq25_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq25_del (0x00000030U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq25_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq25_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq25_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq25_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq25_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq25_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq25_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq25_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq25_del) & BM_MMDC_MPWRDQBY3DL_wr_dq25_del)

/*! @brief Set the wr_dq25_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq25_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq25_del) | BF_MMDC_MPWRDQBY3DL_wr_dq25_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq26_del[9:8] (RW)
 *
 * Write dq26 delay fine tuning. This field holds the number of delay units that
 * are added to dq26 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq26 delay
 * - 01 - Add dq26 delay of 1 delay unit.
 * - 10 - Add dq26 delay of 2 delay units.
 * - 11 - Add dq26 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq26_del (8U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq26_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq26_del (0x00000300U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq26_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq26_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq26_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq26_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq26_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq26_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq26_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq26_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq26_del) & BM_MMDC_MPWRDQBY3DL_wr_dq26_del)

/*! @brief Set the wr_dq26_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq26_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq26_del) | BF_MMDC_MPWRDQBY3DL_wr_dq26_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq27_del[13:12] (RW)
 *
 * Write dq27 delay fine tuning. This field holds the number of delay units that
 * are added to dq27 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq27 delay
 * - 01 - Add dq27 delay of 1 delay unit.
 * - 10 - Add dq27 delay of 2 delay units.
 * - 11 - Add dq27 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq27_del (12U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq27_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq27_del (0x00003000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq27_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq27_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq27_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq27_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq27_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq27_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq27_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq27_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq27_del) & BM_MMDC_MPWRDQBY3DL_wr_dq27_del)

/*! @brief Set the wr_dq27_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq27_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq27_del) | BF_MMDC_MPWRDQBY3DL_wr_dq27_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq28_del[17:16] (RW)
 *
 * Write dq28 delay fine tuning. This field holds the number of delay units that
 * are added to dq28 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq28 delay
 * - 01 - Add dq28 delay of 1 delay unit.
 * - 10 - Add dq28 delay of 2 delay units.
 * - 11 - Add dq28 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq28_del (16U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq28_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq28_del (0x00030000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq28_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq28_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq28_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq28_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq28_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq28_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq28_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq28_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq28_del) & BM_MMDC_MPWRDQBY3DL_wr_dq28_del)

/*! @brief Set the wr_dq28_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq28_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq28_del) | BF_MMDC_MPWRDQBY3DL_wr_dq28_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq29_del[21:20] (RW)
 *
 * Write dq29 delay fine tuning. This field holds the number of delay units that
 * are added to dq29 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq29 delay
 * - 01 - Add dq29 delay of 1 delay unit.
 * - 10 - Add dq29 delay of 2 delay units.
 * - 11 - Add dq29 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq29_del (20U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq29_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq29_del (0x00300000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq29_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq29_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq29_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq29_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq29_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq29_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq29_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq29_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq29_del) & BM_MMDC_MPWRDQBY3DL_wr_dq29_del)

/*! @brief Set the wr_dq29_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq29_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq29_del) | BF_MMDC_MPWRDQBY3DL_wr_dq29_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq30_del[25:24] (RW)
 *
 * Write dq30 delay fine tuning. This field holds the number of delay units that
 * are added to dq30 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq30 delay
 * - 01 - Add dq30 delay of 1 delay unit.
 * - 10 - Add dq30 delay of 2 delay units.
 * - 11 - Add dq30 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq30_del (24U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq30_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq30_del (0x03000000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq30_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq30_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq30_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq30_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq30_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq30_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq30_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq30_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq30_del) & BM_MMDC_MPWRDQBY3DL_wr_dq30_del)

/*! @brief Set the wr_dq30_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq30_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq30_del) | BF_MMDC_MPWRDQBY3DL_wr_dq30_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dq31_del[29:28] (RW)
 *
 * Write dq31 delay fine tuning. This field holds the number of delay units that
 * are added to dq31 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dq31 delay
 * - 01 - Add dq31 delay of 1 delay unit.
 * - 10 - Add dq31 delay of 2 delay units.
 * - 11 - Add dq31 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dq31_del (28U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dq31_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dq31_del (0x30000000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dq31_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dq31_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dq31_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dq31_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dq31_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dq31_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dq31_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dq31_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dq31_del) & BM_MMDC_MPWRDQBY3DL_wr_dq31_del)

/*! @brief Set the wr_dq31_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dq31_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dq31_del) | BF_MMDC_MPWRDQBY3DL_wr_dq31_del(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDQBY3DL, field wr_dm3_del[31:30] (RW)
 *
 * Write dm3 delay fine tuning. This field holds the number of delay units that
 * are added to dm3 relative to dqs3.
 *
 * Values:
 * - 00 - No change in dm3 delay
 * - 01 - Add dm3 delay of 1 delay unit.
 * - 10 - Add dm3 delay of 2 delay units.
 * - 11 - Add dm3 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRDQBY3DL_wr_dm3_del (30U) /*!< Bit position for MMDC_MPWRDQBY3DL_wr_dm3_del. */
#define BM_MMDC_MPWRDQBY3DL_wr_dm3_del (0xC0000000U) /*!< Bit mask for MMDC_MPWRDQBY3DL_wr_dm3_del. */
#define BS_MMDC_MPWRDQBY3DL_wr_dm3_del (2U) /*!< Bit field size in bits for MMDC_MPWRDQBY3DL_wr_dm3_del. */

/*! @brief Read current value of the MMDC_MPWRDQBY3DL_wr_dm3_del field. */
#define BR_MMDC_MPWRDQBY3DL_wr_dm3_del(x) (HW_MMDC_MPWRDQBY3DL(x).B.wr_dm3_del)

/*! @brief Format value for bitfield MMDC_MPWRDQBY3DL_wr_dm3_del. */
#define BF_MMDC_MPWRDQBY3DL_wr_dm3_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDQBY3DL_wr_dm3_del) & BM_MMDC_MPWRDQBY3DL_wr_dm3_del)

/*! @brief Set the wr_dm3_del field to a new value. */
#define BW_MMDC_MPWRDQBY3DL_wr_dm3_del(x, v) (HW_MMDC_MPWRDQBY3DL_WR(x, (HW_MMDC_MPWRDQBY3DL_RD(x) & ~BM_MMDC_MPWRDQBY3DL_wr_dm3_del) | BF_MMDC_MPWRDQBY3DL_wr_dm3_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGCTRL0 - MMDC PHY Read DQS Gating Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGCTRL0 - MMDC PHY Read DQS Gating Control Register 0 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdgctrl0
{
    uint32_t U;
    struct _hw_mmdc_mpdgctrl0_bitfields
    {
        uint32_t DG_DL_ABS_OFFSET0 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t DG_HC_DEL0 : 4;       /*!< [11:8]  */
        uint32_t HW_DG_ERR : 1;        /*!< [12]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t DG_DL_ABS_OFFSET1 : 7; /*!< [22:16]  */
        uint32_t DG_EXT_UP : 1;        /*!< [23]  */
        uint32_t DG_HC_DEL1 : 4;       /*!< [27:24]  */
        uint32_t HW_DG_EN : 1;         /*!< [28]  */
        uint32_t DG_DIS : 1;           /*!< [29]  */
        uint32_t DG_CMP_CYC : 1;       /*!< [30]  */
        uint32_t RST_RD_FIFO : 1;      /*!< [31]  */
    } B;
} hw_mmdc_mpdgctrl0_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGCTRL0 register
 */
/*@{*/
#define HW_MMDC_MPDGCTRL0_ADDR(x) ((uintptr_t)(x) + 0x83CU)

#define HW_MMDC_MPDGCTRL0(x)     (*(__IO hw_mmdc_mpdgctrl0_t *) HW_MMDC_MPDGCTRL0_ADDR(x))
#define HW_MMDC_MPDGCTRL0_RD(x)  (HW_MMDC_MPDGCTRL0(x).U)
#define HW_MMDC_MPDGCTRL0_WR(x, v) (HW_MMDC_MPDGCTRL0(x).U = (v))
#define HW_MMDC_MPDGCTRL0_SET(x, v) (HW_MMDC_MPDGCTRL0_WR(x, HW_MMDC_MPDGCTRL0_RD(x) |  (v)))
#define HW_MMDC_MPDGCTRL0_CLR(x, v) (HW_MMDC_MPDGCTRL0_WR(x, HW_MMDC_MPDGCTRL0_RD(x) & ~(v)))
#define HW_MMDC_MPDGCTRL0_TOG(x, v) (HW_MMDC_MPDGCTRL0_WR(x, HW_MMDC_MPDGCTRL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGCTRL0 bitfields
 */

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_DL_ABS_OFFSET0[6:0] (RW)
 *
 * Absolute read DQS gating delay offset for Byte0. This field indicates the
 * absolute delay between read DQS gate and the middle of the read DQS preamble of
 * Byte0 with fractions of a clock period and up to half cycle.The fraction is
 * process and frequency independent. The delay of the delay-line would be
 * (DG_DL_ABS_OFFSET0 / 256)* MMDC_CH0 AXI clock (fast clock). This field can also bit
 * written by HW. Upon completion of the automatic read DQS gating calibration this
 * field gets the value of the 7 LSB of ((HW_DG_LOW0 + HW_DG_UP0) /2). Note that
 * not all changes will have effect on the actual delay. If the requested change
 * is smaller than the delay-line resolution, then no change will occur.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0 (0U) /*!< Bit position for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0. */
#define BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0 (0x0000007FU) /*!< Bit mask for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0. */
#define BS_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0 (7U) /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0 field. */
#define BR_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0(x) (HW_MMDC_MPDGCTRL0(x).B.DG_DL_ABS_OFFSET0)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0. */
#define BF_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0) & BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0)

/*! @brief Set the DG_DL_ABS_OFFSET0 field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0) | BF_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_HC_DEL0[11:8] (RW)
 *
 * Read DQS gating half cycles delay for Byte0 (Channel 0 register) and Byte4 in
 * 64-bit mode (Channel 1 register) . This field indicates the delay in half
 * cycles between read DQS gate and the middle of the read DQS preamble of Byte0/4.
 * This delay is added to the delay that is generated by the read DQS1 gating
 * delay-line, So the total read DQS gating delay is (DG_HC_DEL#)*0.5*cycle +
 * (DG_DL_ABS_OFFSET#)*1/256*cycle Upon completion of the automatic read DQS gating
 * calibration this field gets the value of the 4 MSB of ((HW_DG_LOW1 + HW_DG_UP1)
 * /2).
 *
 * Values:
 * - 0000 - 0 cycles delay.
 * - 0001 - Half cycle delay.
 * - 0010 - 1 cycle delay
 * - 1101 - 6.5 cycles delay
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_HC_DEL0 (8U)  /*!< Bit position for MMDC_MPDGCTRL0_DG_HC_DEL0. */
#define BM_MMDC_MPDGCTRL0_DG_HC_DEL0 (0x00000F00U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_HC_DEL0. */
#define BS_MMDC_MPDGCTRL0_DG_HC_DEL0 (4U)  /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_HC_DEL0. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_HC_DEL0 field. */
#define BR_MMDC_MPDGCTRL0_DG_HC_DEL0(x) (HW_MMDC_MPDGCTRL0(x).B.DG_HC_DEL0)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_HC_DEL0. */
#define BF_MMDC_MPDGCTRL0_DG_HC_DEL0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_HC_DEL0) & BM_MMDC_MPDGCTRL0_DG_HC_DEL0)

/*! @brief Set the DG_HC_DEL0 field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_HC_DEL0(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_HC_DEL0) | BF_MMDC_MPDGCTRL0_DG_HC_DEL0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field HW_DG_ERR[12] (RO)
 *
 * HW DQS gating error. This bit valid is asserted when an error was found
 * during the read DQS gating HW calibration process. Error can occur when no valid
 * value was found during HW calibration. This bit is valid only after HW_DG_EN is
 * de-asserted.
 *
 * Values:
 * - 0 - No error was found during the DQS gating HW calibration process.
 * - 1 - An error was found during the DQS gating HW calibration process.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_HW_DG_ERR (12U)  /*!< Bit position for MMDC_MPDGCTRL0_HW_DG_ERR. */
#define BM_MMDC_MPDGCTRL0_HW_DG_ERR (0x00001000U) /*!< Bit mask for MMDC_MPDGCTRL0_HW_DG_ERR. */
#define BS_MMDC_MPDGCTRL0_HW_DG_ERR (1U)   /*!< Bit field size in bits for MMDC_MPDGCTRL0_HW_DG_ERR. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_HW_DG_ERR field. */
#define BR_MMDC_MPDGCTRL0_HW_DG_ERR(x) (HW_MMDC_MPDGCTRL0(x).B.HW_DG_ERR)
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_DL_ABS_OFFSET1[22:16] (RW)
 *
 * Absolute read DQS gating delay offset for Byte1. This field indicates the
 * absolute delay between read DQS gate and the middle of the read DQS preamble of
 * Byte1 with fractions of a clock period and up to half cycle. The fraction is
 * process and frequency independent. The delay of the delay-line would be
 * (DG_DL_ABS_OFFSET1 / 256)* MMDC_CH0 AXI clock (fast clock). This field can also bit
 * written by HW. Upon completion of the automatic read DQS gating calibration this
 * field gets the value of the 7 LSB of ((HW_DG_LOW1 + HW_DG_UP1) /2). Note that
 * not all changes will have effect on the actual delay. If the requested change
 * is smaller than the delay-line resolution, then no change will occur.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1 (16U) /*!< Bit position for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1. */
#define BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1 (0x007F0000U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1. */
#define BS_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1 (7U) /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1 field. */
#define BR_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1(x) (HW_MMDC_MPDGCTRL0(x).B.DG_DL_ABS_OFFSET1)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1. */
#define BF_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1) & BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1)

/*! @brief Set the DG_DL_ABS_OFFSET1 field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1) | BF_MMDC_MPDGCTRL0_DG_DL_ABS_OFFSET1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_EXT_UP[23] (RW)
 *
 * DG extend upper boundary. By default the upper boundary of DQS gating HW
 * calibration is set according to first failing comparison after at least one
 * passing comparison. If this bit is asserted then the upper boundary is set according
 * to the last passing comparison.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_EXT_UP (23U)  /*!< Bit position for MMDC_MPDGCTRL0_DG_EXT_UP. */
#define BM_MMDC_MPDGCTRL0_DG_EXT_UP (0x00800000U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_EXT_UP. */
#define BS_MMDC_MPDGCTRL0_DG_EXT_UP (1U)   /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_EXT_UP. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_EXT_UP field. */
#define BR_MMDC_MPDGCTRL0_DG_EXT_UP(x) (HW_MMDC_MPDGCTRL0(x).B.DG_EXT_UP)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_EXT_UP. */
#define BF_MMDC_MPDGCTRL0_DG_EXT_UP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_EXT_UP) & BM_MMDC_MPDGCTRL0_DG_EXT_UP)

/*! @brief Set the DG_EXT_UP field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_EXT_UP(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_EXT_UP) | BF_MMDC_MPDGCTRL0_DG_EXT_UP(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_HC_DEL1[27:24] (RW)
 *
 * Read DQS gating half cycles delay for Byte1 (channel 0 register) and Byte5 in
 * 64-bit mode (channel 1 register) . This field indicates the delay in half
 * cycles between read DQS gate and the middle of the read DQS preamble of Byte1.
 * This delay is added to the delay that is generated by the read DQS1 gating
 * delay-line, So the total read DQS gating delay is (DG_HC_DEL#)*0.5*cycle +
 * (DG_DL_ABS_OFFSET#)*1/256*cycle Upon completion of the automatic read DQS gating
 * calibration this field gets the value of the 4 MSB of ((HW_DG_LOW1 + HW_DG_UP1) /2).
 *
 * Values:
 * - 0000 - 0 cycles delay.
 * - 0001 - Half cycle delay.
 * - 0010 - 1 cycle delay
 * - 1101 - 6.5 cycles delay
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_HC_DEL1 (24U) /*!< Bit position for MMDC_MPDGCTRL0_DG_HC_DEL1. */
#define BM_MMDC_MPDGCTRL0_DG_HC_DEL1 (0x0F000000U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_HC_DEL1. */
#define BS_MMDC_MPDGCTRL0_DG_HC_DEL1 (4U)  /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_HC_DEL1. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_HC_DEL1 field. */
#define BR_MMDC_MPDGCTRL0_DG_HC_DEL1(x) (HW_MMDC_MPDGCTRL0(x).B.DG_HC_DEL1)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_HC_DEL1. */
#define BF_MMDC_MPDGCTRL0_DG_HC_DEL1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_HC_DEL1) & BM_MMDC_MPDGCTRL0_DG_HC_DEL1)

/*! @brief Set the DG_HC_DEL1 field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_HC_DEL1(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_HC_DEL1) | BF_MMDC_MPDGCTRL0_DG_HC_DEL1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field HW_DG_EN[28] (RW)
 *
 * Enable automatic read DQS gating calibration. If this bit is asserted then
 * the MMDC performs automatic read DQS gating calibration. HW negates this bit
 * upon completion of the automatic read DQS gating. Note: Before issuing the first
 * read command the MMDC counts 12 cycles. In LPDDR2 mode automatic (HW) read DQS
 * gating should be disabled and Pull-up/pull-down resistors on DQS/DQS# should
 * be enabled while ODT resistors must be disconnected.
 *
 * Values:
 * - 0 - Disable automatic read DQS gating calibration
 * - 1 - Start automatic read DQS gating calibration
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_HW_DG_EN (28U)   /*!< Bit position for MMDC_MPDGCTRL0_HW_DG_EN. */
#define BM_MMDC_MPDGCTRL0_HW_DG_EN (0x10000000U) /*!< Bit mask for MMDC_MPDGCTRL0_HW_DG_EN. */
#define BS_MMDC_MPDGCTRL0_HW_DG_EN (1U)    /*!< Bit field size in bits for MMDC_MPDGCTRL0_HW_DG_EN. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_HW_DG_EN field. */
#define BR_MMDC_MPDGCTRL0_HW_DG_EN(x) (HW_MMDC_MPDGCTRL0(x).B.HW_DG_EN)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_HW_DG_EN. */
#define BF_MMDC_MPDGCTRL0_HW_DG_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_HW_DG_EN) & BM_MMDC_MPDGCTRL0_HW_DG_EN)

/*! @brief Set the HW_DG_EN field to a new value. */
#define BW_MMDC_MPDGCTRL0_HW_DG_EN(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_HW_DG_EN) | BF_MMDC_MPDGCTRL0_HW_DG_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_DIS[29] (RW)
 *
 * Read DQS gating disable. If this bit is asserted then the MMDC disables the
 * read DQS gating mechanism. If this bits is asserted (read DQS gating is
 * disabled) then pulll-up and pull-down resistors suppose to be used on DQS and DQS#
 * respectively
 *
 * Values:
 * - 0 - Read DQS gating mechanism is enabled
 * - 1 - Read DQS gating mechanism is disabled
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_DIS (29U)     /*!< Bit position for MMDC_MPDGCTRL0_DG_DIS. */
#define BM_MMDC_MPDGCTRL0_DG_DIS (0x20000000U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_DIS. */
#define BS_MMDC_MPDGCTRL0_DG_DIS (1U)      /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_DIS. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_DIS field. */
#define BR_MMDC_MPDGCTRL0_DG_DIS(x) (HW_MMDC_MPDGCTRL0(x).B.DG_DIS)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_DIS. */
#define BF_MMDC_MPDGCTRL0_DG_DIS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_DIS) & BM_MMDC_MPDGCTRL0_DG_DIS)

/*! @brief Set the DG_DIS field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_DIS(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_DIS) | BF_MMDC_MPDGCTRL0_DG_DIS(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field DG_CMP_CYC[30] (RW)
 *
 * Read DQS gating sample cycle. If this bit is asserted then the MMDC waits 32
 * cycles before comparing the read data, Otherwise it waits 16 DDR cycles.
 *
 * Values:
 * - 0 - MMDC waits 16 DDR cycles
 * - 1 - MMDC waits 32 DDR cycles
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_DG_CMP_CYC (30U) /*!< Bit position for MMDC_MPDGCTRL0_DG_CMP_CYC. */
#define BM_MMDC_MPDGCTRL0_DG_CMP_CYC (0x40000000U) /*!< Bit mask for MMDC_MPDGCTRL0_DG_CMP_CYC. */
#define BS_MMDC_MPDGCTRL0_DG_CMP_CYC (1U)  /*!< Bit field size in bits for MMDC_MPDGCTRL0_DG_CMP_CYC. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_DG_CMP_CYC field. */
#define BR_MMDC_MPDGCTRL0_DG_CMP_CYC(x) (HW_MMDC_MPDGCTRL0(x).B.DG_CMP_CYC)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_DG_CMP_CYC. */
#define BF_MMDC_MPDGCTRL0_DG_CMP_CYC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_DG_CMP_CYC) & BM_MMDC_MPDGCTRL0_DG_CMP_CYC)

/*! @brief Set the DG_CMP_CYC field to a new value. */
#define BW_MMDC_MPDGCTRL0_DG_CMP_CYC(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_DG_CMP_CYC) | BF_MMDC_MPDGCTRL0_DG_CMP_CYC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL0, field RST_RD_FIFO[31] (RW)
 *
 * Reset Read Data FIFO and associated pointers. If this bit is asserted then
 * the MMDC resets the read data FIFO and the associated pointers. This bit is self
 * cleared after the FIFO reset is done.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL0_RST_RD_FIFO (31U) /*!< Bit position for MMDC_MPDGCTRL0_RST_RD_FIFO. */
#define BM_MMDC_MPDGCTRL0_RST_RD_FIFO (0x80000000U) /*!< Bit mask for MMDC_MPDGCTRL0_RST_RD_FIFO. */
#define BS_MMDC_MPDGCTRL0_RST_RD_FIFO (1U) /*!< Bit field size in bits for MMDC_MPDGCTRL0_RST_RD_FIFO. */

/*! @brief Read current value of the MMDC_MPDGCTRL0_RST_RD_FIFO field. */
#define BR_MMDC_MPDGCTRL0_RST_RD_FIFO(x) (HW_MMDC_MPDGCTRL0(x).B.RST_RD_FIFO)

/*! @brief Format value for bitfield MMDC_MPDGCTRL0_RST_RD_FIFO. */
#define BF_MMDC_MPDGCTRL0_RST_RD_FIFO(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL0_RST_RD_FIFO) & BM_MMDC_MPDGCTRL0_RST_RD_FIFO)

/*! @brief Set the RST_RD_FIFO field to a new value. */
#define BW_MMDC_MPDGCTRL0_RST_RD_FIFO(x, v) (HW_MMDC_MPDGCTRL0_WR(x, (HW_MMDC_MPDGCTRL0_RD(x) & ~BM_MMDC_MPDGCTRL0_RST_RD_FIFO) | BF_MMDC_MPDGCTRL0_RST_RD_FIFO(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGCTRL1 - MMDC PHY Read DQS Gating Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGCTRL1 - MMDC PHY Read DQS Gating Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdgctrl1
{
    uint32_t U;
    struct _hw_mmdc_mpdgctrl1_bitfields
    {
        uint32_t DG_DL_ABS_OFFSET2 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t DG_HC_DEL2 : 4;       /*!< [11:8]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t DG_DL_ABS_OFFSET3 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t DG_HC_DEL3 : 4;       /*!< [27:24]  */
        uint32_t RESERVED3 : 4;        /*!< [31:28]  */
    } B;
} hw_mmdc_mpdgctrl1_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGCTRL1 register
 */
/*@{*/
#define HW_MMDC_MPDGCTRL1_ADDR(x) ((uintptr_t)(x) + 0x840U)

#define HW_MMDC_MPDGCTRL1(x)     (*(__IO hw_mmdc_mpdgctrl1_t *) HW_MMDC_MPDGCTRL1_ADDR(x))
#define HW_MMDC_MPDGCTRL1_RD(x)  (HW_MMDC_MPDGCTRL1(x).U)
#define HW_MMDC_MPDGCTRL1_WR(x, v) (HW_MMDC_MPDGCTRL1(x).U = (v))
#define HW_MMDC_MPDGCTRL1_SET(x, v) (HW_MMDC_MPDGCTRL1_WR(x, HW_MMDC_MPDGCTRL1_RD(x) |  (v)))
#define HW_MMDC_MPDGCTRL1_CLR(x, v) (HW_MMDC_MPDGCTRL1_WR(x, HW_MMDC_MPDGCTRL1_RD(x) & ~(v)))
#define HW_MMDC_MPDGCTRL1_TOG(x, v) (HW_MMDC_MPDGCTRL1_WR(x, HW_MMDC_MPDGCTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGCTRL1 bitfields
 */

/*!
 * @name Register MMDC_MPDGCTRL1, field DG_DL_ABS_OFFSET2[6:0] (RW)
 *
 * Absolute read DQS gating delay offset for Byte2. This field indicates the
 * absolute delay between read DQS gate and the middle of the read DQS preamble of
 * Byte2 with fractions of a clock period and up to half cycle. The fraction is
 * process and frequency independent. The delay of the delay-line would be
 * (DG_DL_ABS_OFFSET2 / 256)* MMDC_CH0 AXI clock (fast clock). This field can also bit
 * written by HW. Upon completion of the automatic read DQS gating calibration this
 * field gets the value of the 7 LSB of ((HW_DG_LOW2 + HW_DG_UP2) /2). Note that
 * not all changes will have effect on the actual delay. If the requested change
 * is smaller than the delay-line resolution, then no change will occur.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2 (0U) /*!< Bit position for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2. */
#define BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2 (0x0000007FU) /*!< Bit mask for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2. */
#define BS_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2 (7U) /*!< Bit field size in bits for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2. */

/*! @brief Read current value of the MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2 field. */
#define BR_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2(x) (HW_MMDC_MPDGCTRL1(x).B.DG_DL_ABS_OFFSET2)

/*! @brief Format value for bitfield MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2. */
#define BF_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2) & BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2)

/*! @brief Set the DG_DL_ABS_OFFSET2 field to a new value. */
#define BW_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2(x, v) (HW_MMDC_MPDGCTRL1_WR(x, (HW_MMDC_MPDGCTRL1_RD(x) & ~BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2) | BF_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL1, field DG_HC_DEL2[11:8] (RW)
 *
 * Read DQS gating half cycles delay for Byte2 (Channel 0 register) and Byte6
 * for 64-bit mode(channel 1 register) . This field indicates the delay in half
 * cycles between read DQS gate and the middle of the read DQS preamble of Byte2/5.
 * This delay is added to the delay that is generated by the read DQS1 gating
 * delay-line, So the total read DQS gating delay is (DG_HC_DEL#)*0.5*cycle +
 * (DG_DL_ABS_OFFSET#)*1/256*cycle Upon completion of the automatic read DQS gating
 * calibration this field gets the value of the 4 MSB of ((HW_DG_LOW2 + HW_DG_UP2)
 * /2).
 *
 * Values:
 * - 0000 - 0 cycles delay.
 * - 0001 - Half cycle delay.
 * - 0010 - 1 cycle delay
 * - 1101 - 6.5 cycles delay
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MPDGCTRL1_DG_HC_DEL2 (8U)  /*!< Bit position for MMDC_MPDGCTRL1_DG_HC_DEL2. */
#define BM_MMDC_MPDGCTRL1_DG_HC_DEL2 (0x00000F00U) /*!< Bit mask for MMDC_MPDGCTRL1_DG_HC_DEL2. */
#define BS_MMDC_MPDGCTRL1_DG_HC_DEL2 (4U)  /*!< Bit field size in bits for MMDC_MPDGCTRL1_DG_HC_DEL2. */

/*! @brief Read current value of the MMDC_MPDGCTRL1_DG_HC_DEL2 field. */
#define BR_MMDC_MPDGCTRL1_DG_HC_DEL2(x) (HW_MMDC_MPDGCTRL1(x).B.DG_HC_DEL2)

/*! @brief Format value for bitfield MMDC_MPDGCTRL1_DG_HC_DEL2. */
#define BF_MMDC_MPDGCTRL1_DG_HC_DEL2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL1_DG_HC_DEL2) & BM_MMDC_MPDGCTRL1_DG_HC_DEL2)

/*! @brief Set the DG_HC_DEL2 field to a new value. */
#define BW_MMDC_MPDGCTRL1_DG_HC_DEL2(x, v) (HW_MMDC_MPDGCTRL1_WR(x, (HW_MMDC_MPDGCTRL1_RD(x) & ~BM_MMDC_MPDGCTRL1_DG_HC_DEL2) | BF_MMDC_MPDGCTRL1_DG_HC_DEL2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL1, field DG_DL_ABS_OFFSET3[22:16] (RW)
 *
 * Absolute read DQS gating delay offset for Byte3. This field indicates the
 * absolute delay between read DQS gate and the middle of the read DQS preamble of
 * Byte3 with fractions of a clock period and up to half cycle. The fraction is
 * process and frequency independent. The delay of the delay-line would be
 * (DG_DL_ABS_OFFSET3 / 256)* MMDC_CH0 AXI clock (fast clock). This field can also bit
 * written by HW. Upon completion of the automatic read DQS gating calibration this
 * field gets the value of the 7 LSB of ((HW_DG_LOW3 + HW_DG_UP3) /2). Note that
 * not all changes will have effect on the actual delay. If the requested change
 * is smaller than the delay-line resolution, then no change will occur.
 */
/*@{*/
#define BP_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3 (16U) /*!< Bit position for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3. */
#define BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3 (0x007F0000U) /*!< Bit mask for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3. */
#define BS_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3 (7U) /*!< Bit field size in bits for MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3. */

/*! @brief Read current value of the MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3 field. */
#define BR_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3(x) (HW_MMDC_MPDGCTRL1(x).B.DG_DL_ABS_OFFSET3)

/*! @brief Format value for bitfield MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3. */
#define BF_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3) & BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3)

/*! @brief Set the DG_DL_ABS_OFFSET3 field to a new value. */
#define BW_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3(x, v) (HW_MMDC_MPDGCTRL1_WR(x, (HW_MMDC_MPDGCTRL1_RD(x) & ~BM_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3) | BF_MMDC_MPDGCTRL1_DG_DL_ABS_OFFSET3(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDGCTRL1, field DG_HC_DEL3[27:24] (RW)
 *
 * Read DQS gating half cycles delay for Byte3 (Channel 0 register) and Byte7
 * for 64-bit data (Channel 1 register) . This field indicates the delay in half
 * cycles between read DQS gate and the middle of the read DQS preamble of Byte3/7.
 * This delay is added to the delay that is generated by the read DQS1 gating
 * delay-line, So the total read DQS gating delay is (DG_HC_DEL#)*0.5*cycle +
 * (DG_DL_ABS_OFFSET#)*1/256*cycle Upon completion of the automatic read DQS gating
 * calibration this field gets the value of the 4 MSB of ((HW_DG_LOW3 + HW_DG_UP3)
 * /2).
 *
 * Values:
 * - 0000 - 0 cycles delay.
 * - 0001 - Half cycle delay.
 * - 0010 - 1 cycle delay
 * - 1101 - 6.5 cycles delay
 * - 1110 - Reserved
 * - 1111 - Reserved
 */
/*@{*/
#define BP_MMDC_MPDGCTRL1_DG_HC_DEL3 (24U) /*!< Bit position for MMDC_MPDGCTRL1_DG_HC_DEL3. */
#define BM_MMDC_MPDGCTRL1_DG_HC_DEL3 (0x0F000000U) /*!< Bit mask for MMDC_MPDGCTRL1_DG_HC_DEL3. */
#define BS_MMDC_MPDGCTRL1_DG_HC_DEL3 (4U)  /*!< Bit field size in bits for MMDC_MPDGCTRL1_DG_HC_DEL3. */

/*! @brief Read current value of the MMDC_MPDGCTRL1_DG_HC_DEL3 field. */
#define BR_MMDC_MPDGCTRL1_DG_HC_DEL3(x) (HW_MMDC_MPDGCTRL1(x).B.DG_HC_DEL3)

/*! @brief Format value for bitfield MMDC_MPDGCTRL1_DG_HC_DEL3. */
#define BF_MMDC_MPDGCTRL1_DG_HC_DEL3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDGCTRL1_DG_HC_DEL3) & BM_MMDC_MPDGCTRL1_DG_HC_DEL3)

/*! @brief Set the DG_HC_DEL3 field to a new value. */
#define BW_MMDC_MPDGCTRL1_DG_HC_DEL3(x, v) (HW_MMDC_MPDGCTRL1_WR(x, (HW_MMDC_MPDGCTRL1_RD(x) & ~BM_MMDC_MPDGCTRL1_DG_HC_DEL3) | BF_MMDC_MPDGCTRL1_DG_HC_DEL3(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGDLST0 - MMDC PHY Read DQS Gating delay-line Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGDLST0 - MMDC PHY Read DQS Gating delay-line Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the status of the 4 dqs gating delay-lines. Supported
 * Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For Channel 1:
 * DDR3_x64
 */
typedef union _hw_mmdc_mpdgdlst0
{
    uint32_t U;
    struct _hw_mmdc_mpdgdlst0_bitfields
    {
        uint32_t DG_DL_UNIT_NUM0 : 7;  /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t DG_DL_UNIT_NUM1 : 7;  /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t DG_DL_UNIT_NUM2 : 7;  /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t DG_DL_UNIT_NUM3 : 7;  /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpdgdlst0_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGDLST0 register
 */
/*@{*/
#define HW_MMDC_MPDGDLST0_ADDR(x) ((uintptr_t)(x) + 0x844U)

#define HW_MMDC_MPDGDLST0(x)     (*(__I hw_mmdc_mpdgdlst0_t *) HW_MMDC_MPDGDLST0_ADDR(x))
#define HW_MMDC_MPDGDLST0_RD(x)  (HW_MMDC_MPDGDLST0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGDLST0 bitfields
 */

/*!
 * @name Register MMDC_MPDGDLST0, field DG_DL_UNIT_NUM0[6:0] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * DQS gating delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPDGDLST0_DG_DL_UNIT_NUM0 (0U) /*!< Bit position for MMDC_MPDGDLST0_DG_DL_UNIT_NUM0. */
#define BM_MMDC_MPDGDLST0_DG_DL_UNIT_NUM0 (0x0000007FU) /*!< Bit mask for MMDC_MPDGDLST0_DG_DL_UNIT_NUM0. */
#define BS_MMDC_MPDGDLST0_DG_DL_UNIT_NUM0 (7U) /*!< Bit field size in bits for MMDC_MPDGDLST0_DG_DL_UNIT_NUM0. */

/*! @brief Read current value of the MMDC_MPDGDLST0_DG_DL_UNIT_NUM0 field. */
#define BR_MMDC_MPDGDLST0_DG_DL_UNIT_NUM0(x) (HW_MMDC_MPDGDLST0(x).B.DG_DL_UNIT_NUM0)
/*@}*/

/*!
 * @name Register MMDC_MPDGDLST0, field DG_DL_UNIT_NUM1[14:8] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * DQS gating delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPDGDLST0_DG_DL_UNIT_NUM1 (8U) /*!< Bit position for MMDC_MPDGDLST0_DG_DL_UNIT_NUM1. */
#define BM_MMDC_MPDGDLST0_DG_DL_UNIT_NUM1 (0x00007F00U) /*!< Bit mask for MMDC_MPDGDLST0_DG_DL_UNIT_NUM1. */
#define BS_MMDC_MPDGDLST0_DG_DL_UNIT_NUM1 (7U) /*!< Bit field size in bits for MMDC_MPDGDLST0_DG_DL_UNIT_NUM1. */

/*! @brief Read current value of the MMDC_MPDGDLST0_DG_DL_UNIT_NUM1 field. */
#define BR_MMDC_MPDGDLST0_DG_DL_UNIT_NUM1(x) (HW_MMDC_MPDGDLST0(x).B.DG_DL_UNIT_NUM1)
/*@}*/

/*!
 * @name Register MMDC_MPDGDLST0, field DG_DL_UNIT_NUM2[22:16] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * DQS gating delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPDGDLST0_DG_DL_UNIT_NUM2 (16U) /*!< Bit position for MMDC_MPDGDLST0_DG_DL_UNIT_NUM2. */
#define BM_MMDC_MPDGDLST0_DG_DL_UNIT_NUM2 (0x007F0000U) /*!< Bit mask for MMDC_MPDGDLST0_DG_DL_UNIT_NUM2. */
#define BS_MMDC_MPDGDLST0_DG_DL_UNIT_NUM2 (7U) /*!< Bit field size in bits for MMDC_MPDGDLST0_DG_DL_UNIT_NUM2. */

/*! @brief Read current value of the MMDC_MPDGDLST0_DG_DL_UNIT_NUM2 field. */
#define BR_MMDC_MPDGDLST0_DG_DL_UNIT_NUM2(x) (HW_MMDC_MPDGDLST0(x).B.DG_DL_UNIT_NUM2)
/*@}*/

/*!
 * @name Register MMDC_MPDGDLST0, field DG_DL_UNIT_NUM3[30:24] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * DQS gating delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPDGDLST0_DG_DL_UNIT_NUM3 (24U) /*!< Bit position for MMDC_MPDGDLST0_DG_DL_UNIT_NUM3. */
#define BM_MMDC_MPDGDLST0_DG_DL_UNIT_NUM3 (0x7F000000U) /*!< Bit mask for MMDC_MPDGDLST0_DG_DL_UNIT_NUM3. */
#define BS_MMDC_MPDGDLST0_DG_DL_UNIT_NUM3 (7U) /*!< Bit field size in bits for MMDC_MPDGDLST0_DG_DL_UNIT_NUM3. */

/*! @brief Read current value of the MMDC_MPDGDLST0_DG_DL_UNIT_NUM3 field. */
#define BR_MMDC_MPDGDLST0_DG_DL_UNIT_NUM3(x) (HW_MMDC_MPDGDLST0(x).B.DG_DL_UNIT_NUM3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDLCTL - MMDC PHY Read delay-lines Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDLCTL - MMDC PHY Read delay-lines Configuration Register (RW)
 *
 * Reset value: 0x40404040U
 *
 * This register controls read delay-lines functionality; it determines DQS
 * delay relative to the associated DQ read access. The delay-line compensates for
 * process variations and produces a constant delay regardless of the process,
 * temperature and voltage. Supported Mode Of Operations: For Channel 0: All For
 * Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddlctl
{
    uint32_t U;
    struct _hw_mmdc_mprddlctl_bitfields
    {
        uint32_t RD_DL_ABS_OFFSET0 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t RD_DL_ABS_OFFSET1 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t RD_DL_ABS_OFFSET2 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t RD_DL_ABS_OFFSET3 : 7; /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddlctl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDLCTL register
 */
/*@{*/
#define HW_MMDC_MPRDDLCTL_ADDR(x) ((uintptr_t)(x) + 0x848U)

#define HW_MMDC_MPRDDLCTL(x)     (*(__IO hw_mmdc_mprddlctl_t *) HW_MMDC_MPRDDLCTL_ADDR(x))
#define HW_MMDC_MPRDDLCTL_RD(x)  (HW_MMDC_MPRDDLCTL(x).U)
#define HW_MMDC_MPRDDLCTL_WR(x, v) (HW_MMDC_MPRDDLCTL(x).U = (v))
#define HW_MMDC_MPRDDLCTL_SET(x, v) (HW_MMDC_MPRDDLCTL_WR(x, HW_MMDC_MPRDDLCTL_RD(x) |  (v)))
#define HW_MMDC_MPRDDLCTL_CLR(x, v) (HW_MMDC_MPRDDLCTL_WR(x, HW_MMDC_MPRDDLCTL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDLCTL_TOG(x, v) (HW_MMDC_MPRDDLCTL_WR(x, HW_MMDC_MPRDDLCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDLCTL bitfields
 */

/*!
 * @name Register MMDC_MPRDDLCTL, field RD_DL_ABS_OFFSET0[6:0] (RW)
 *
 * Absolute read delay offset for Byte0. This field indicates the absolute delay
 * between read DQS strobe and the read data of Byte0 with fractions of a clock
 * period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (RD_DL_ABS_OFFSET0 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the read
 * delay-line HW calibration this field gets the value of (HW_RD_DL_LOW0 +
 * HW_RD_DL_UP0) /2 Note that not all changes will have effect on the actual delay. If the
 * requested change is smaller than the delay-line resolution, then no change will
 * occur.
 */
/*@{*/
#define BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0 (0U) /*!< Bit position for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0. */
#define BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0 (0x0000007FU) /*!< Bit mask for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0. */
#define BS_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0 (7U) /*!< Bit field size in bits for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0. */

/*! @brief Read current value of the MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0 field. */
#define BR_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0(x) (HW_MMDC_MPRDDLCTL(x).B.RD_DL_ABS_OFFSET0)

/*! @brief Format value for bitfield MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0. */
#define BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0) & BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0)

/*! @brief Set the RD_DL_ABS_OFFSET0 field to a new value. */
#define BW_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0(x, v) (HW_MMDC_MPRDDLCTL_WR(x, (HW_MMDC_MPRDDLCTL_RD(x) & ~BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0) | BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDLCTL, field RD_DL_ABS_OFFSET1[14:8] (RW)
 *
 * Absolute read delay offset for Byte1. This field indicates the absolute delay
 * between read DQS strobe and the read data of Byte1 with fractions of a clock
 * period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (RD_DL_ABS_OFFSET1 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the read
 * delay-line HW calibration this field gets the value of (HW_RD_DL_LOW1 +
 * HW_RD_DL_UP1) /2 Note that not all changes will have effect on the actual delay. If the
 * requested change is smaller than the delay-line resolution, then no change will
 * occur.
 */
/*@{*/
#define BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1 (8U) /*!< Bit position for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1. */
#define BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1 (0x00007F00U) /*!< Bit mask for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1. */
#define BS_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1 (7U) /*!< Bit field size in bits for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1. */

/*! @brief Read current value of the MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1 field. */
#define BR_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1(x) (HW_MMDC_MPRDDLCTL(x).B.RD_DL_ABS_OFFSET1)

/*! @brief Format value for bitfield MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1. */
#define BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1) & BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1)

/*! @brief Set the RD_DL_ABS_OFFSET1 field to a new value. */
#define BW_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1(x, v) (HW_MMDC_MPRDDLCTL_WR(x, (HW_MMDC_MPRDDLCTL_RD(x) & ~BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1) | BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDLCTL, field RD_DL_ABS_OFFSET2[22:16] (RW)
 *
 * Absolute read delay offset for Byte2. This field indicates the absolute delay
 * between read DQS strobe and the read data of Byte2 with fractions of a clock
 * period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (RD_DL_ABS_OFFSET2 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the read
 * delay-line HW calibration this field gets the value of (HW_RD_DL_LOW2 +
 * HW_RD_DL_UP2) /2 Note that not all changes will have effect on the actual delay. If the
 * requested change is smaller than the delay-line resolution, then no change will
 * occur.
 */
/*@{*/
#define BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2 (16U) /*!< Bit position for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2. */
#define BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2 (0x007F0000U) /*!< Bit mask for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2. */
#define BS_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2 (7U) /*!< Bit field size in bits for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2. */

/*! @brief Read current value of the MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2 field. */
#define BR_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2(x) (HW_MMDC_MPRDDLCTL(x).B.RD_DL_ABS_OFFSET2)

/*! @brief Format value for bitfield MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2. */
#define BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2) & BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2)

/*! @brief Set the RD_DL_ABS_OFFSET2 field to a new value. */
#define BW_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2(x, v) (HW_MMDC_MPRDDLCTL_WR(x, (HW_MMDC_MPRDDLCTL_RD(x) & ~BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2) | BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDLCTL, field RD_DL_ABS_OFFSET3[30:24] (RW)
 *
 * Absolute read delay offset for Byte3. This field indicates the absolute delay
 * between read DQS strobe and the read data of Byte3 with fractions of a clock
 * period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (RD_DL_ABS_OFFSET3 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the read
 * delay-line HW calibration this field gets the value of (HW_RD_DL_LOW3 +
 * HW_RD_DL_UP3) /2 Note that not all changes will have effect on the actual delay. If the
 * requested change is smaller than the delay-line resolution, then no change will
 * occur.
 */
/*@{*/
#define BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3 (24U) /*!< Bit position for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3. */
#define BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3 (0x7F000000U) /*!< Bit mask for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3. */
#define BS_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3 (7U) /*!< Bit field size in bits for MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3. */

/*! @brief Read current value of the MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3 field. */
#define BR_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3(x) (HW_MMDC_MPRDDLCTL(x).B.RD_DL_ABS_OFFSET3)

/*! @brief Format value for bitfield MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3. */
#define BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3) & BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3)

/*! @brief Set the RD_DL_ABS_OFFSET3 field to a new value. */
#define BW_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3(x, v) (HW_MMDC_MPRDDLCTL_WR(x, (HW_MMDC_MPRDDLCTL_RD(x) & ~BM_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3) | BF_MMDC_MPRDDLCTL_RD_DL_ABS_OFFSET3(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDLST - MMDC PHY Read delay-lines Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDLST - MMDC PHY Read delay-lines Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the status of the 4 read delay-lines. Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddlst
{
    uint32_t U;
    struct _hw_mmdc_mprddlst_bitfields
    {
        uint32_t RD_DL_UNIT_NUM0 : 7;  /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t RD_DL_UNIT_NUM1 : 7;  /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t RD_DL_UNIT_NUM2 : 7;  /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t RD_DL_UNIT_NUM3 : 7;  /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddlst_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDLST register
 */
/*@{*/
#define HW_MMDC_MPRDDLST_ADDR(x) ((uintptr_t)(x) + 0x84CU)

#define HW_MMDC_MPRDDLST(x)      (*(__I hw_mmdc_mprddlst_t *) HW_MMDC_MPRDDLST_ADDR(x))
#define HW_MMDC_MPRDDLST_RD(x)   (HW_MMDC_MPRDDLST(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDLST bitfields
 */

/*!
 * @name Register MMDC_MPRDDLST, field RD_DL_UNIT_NUM0[6:0] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPRDDLST_RD_DL_UNIT_NUM0 (0U) /*!< Bit position for MMDC_MPRDDLST_RD_DL_UNIT_NUM0. */
#define BM_MMDC_MPRDDLST_RD_DL_UNIT_NUM0 (0x0000007FU) /*!< Bit mask for MMDC_MPRDDLST_RD_DL_UNIT_NUM0. */
#define BS_MMDC_MPRDDLST_RD_DL_UNIT_NUM0 (7U) /*!< Bit field size in bits for MMDC_MPRDDLST_RD_DL_UNIT_NUM0. */

/*! @brief Read current value of the MMDC_MPRDDLST_RD_DL_UNIT_NUM0 field. */
#define BR_MMDC_MPRDDLST_RD_DL_UNIT_NUM0(x) (HW_MMDC_MPRDDLST(x).B.RD_DL_UNIT_NUM0)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLST, field RD_DL_UNIT_NUM1[14:8] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPRDDLST_RD_DL_UNIT_NUM1 (8U) /*!< Bit position for MMDC_MPRDDLST_RD_DL_UNIT_NUM1. */
#define BM_MMDC_MPRDDLST_RD_DL_UNIT_NUM1 (0x00007F00U) /*!< Bit mask for MMDC_MPRDDLST_RD_DL_UNIT_NUM1. */
#define BS_MMDC_MPRDDLST_RD_DL_UNIT_NUM1 (7U) /*!< Bit field size in bits for MMDC_MPRDDLST_RD_DL_UNIT_NUM1. */

/*! @brief Read current value of the MMDC_MPRDDLST_RD_DL_UNIT_NUM1 field. */
#define BR_MMDC_MPRDDLST_RD_DL_UNIT_NUM1(x) (HW_MMDC_MPRDDLST(x).B.RD_DL_UNIT_NUM1)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLST, field RD_DL_UNIT_NUM2[22:16] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPRDDLST_RD_DL_UNIT_NUM2 (16U) /*!< Bit position for MMDC_MPRDDLST_RD_DL_UNIT_NUM2. */
#define BM_MMDC_MPRDDLST_RD_DL_UNIT_NUM2 (0x007F0000U) /*!< Bit mask for MMDC_MPRDDLST_RD_DL_UNIT_NUM2. */
#define BS_MMDC_MPRDDLST_RD_DL_UNIT_NUM2 (7U) /*!< Bit field size in bits for MMDC_MPRDDLST_RD_DL_UNIT_NUM2. */

/*! @brief Read current value of the MMDC_MPRDDLST_RD_DL_UNIT_NUM2 field. */
#define BR_MMDC_MPRDDLST_RD_DL_UNIT_NUM2(x) (HW_MMDC_MPRDDLST(x).B.RD_DL_UNIT_NUM2)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLST, field RD_DL_UNIT_NUM3[30:24] (RO)
 *
 * This field reflects the number of delay units that are actually used by read
 * delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPRDDLST_RD_DL_UNIT_NUM3 (24U) /*!< Bit position for MMDC_MPRDDLST_RD_DL_UNIT_NUM3. */
#define BM_MMDC_MPRDDLST_RD_DL_UNIT_NUM3 (0x7F000000U) /*!< Bit mask for MMDC_MPRDDLST_RD_DL_UNIT_NUM3. */
#define BS_MMDC_MPRDDLST_RD_DL_UNIT_NUM3 (7U) /*!< Bit field size in bits for MMDC_MPRDDLST_RD_DL_UNIT_NUM3. */

/*! @brief Read current value of the MMDC_MPRDDLST_RD_DL_UNIT_NUM3 field. */
#define BR_MMDC_MPRDDLST_RD_DL_UNIT_NUM3(x) (HW_MMDC_MPRDDLST(x).B.RD_DL_UNIT_NUM3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDLCTL - MMDC PHY Write delay-lines Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDLCTL - MMDC PHY Write delay-lines Configuration Register (RW)
 *
 * Reset value: 0x40404040U
 *
 * This register controls write delay-lines functionality, it determines DQ/DM
 * delay relative to the associated DQS in write access. The delay-line
 * compensates for process variations, and produces a constant delay regardless of the
 * process, temperature and voltage. Supported Mode Of Operations: For Channel 0: All
 * For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdlctl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdlctl_bitfields
    {
        uint32_t WR_DL_ABS_OFFSET0 : 7; /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t WR_DL_ABS_OFFSET1 : 7; /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t WR_DL_ABS_OFFSET2 : 7; /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t WR_DL_ABS_OFFSET3 : 7; /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpwrdlctl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDLCTL register
 */
/*@{*/
#define HW_MMDC_MPWRDLCTL_ADDR(x) ((uintptr_t)(x) + 0x850U)

#define HW_MMDC_MPWRDLCTL(x)     (*(__IO hw_mmdc_mpwrdlctl_t *) HW_MMDC_MPWRDLCTL_ADDR(x))
#define HW_MMDC_MPWRDLCTL_RD(x)  (HW_MMDC_MPWRDLCTL(x).U)
#define HW_MMDC_MPWRDLCTL_WR(x, v) (HW_MMDC_MPWRDLCTL(x).U = (v))
#define HW_MMDC_MPWRDLCTL_SET(x, v) (HW_MMDC_MPWRDLCTL_WR(x, HW_MMDC_MPWRDLCTL_RD(x) |  (v)))
#define HW_MMDC_MPWRDLCTL_CLR(x, v) (HW_MMDC_MPWRDLCTL_WR(x, HW_MMDC_MPWRDLCTL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDLCTL_TOG(x, v) (HW_MMDC_MPWRDLCTL_WR(x, HW_MMDC_MPWRDLCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDLCTL bitfields
 */

/*!
 * @name Register MMDC_MPWRDLCTL, field WR_DL_ABS_OFFSET0[6:0] (RW)
 *
 * Absolute write delay offset for Byte0. This field indicates the absolute
 * delay between write DQS strobe and the write data of Byte3 with fractions of a
 * clock period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (WR_DL_ABS_OFFSET0 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the write
 * delay-line HW calibration this field gets the value of (HW_WR_DL_LOW0 +
 * HW_WR_DL_UP0) /2 Note that not all changes of this value will affect the actual delay.
 * If the requested change is smaller than the delay-line resolution, then no
 * change will occur.
 */
/*@{*/
#define BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0 (0U) /*!< Bit position for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0. */
#define BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0 (0x0000007FU) /*!< Bit mask for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0. */
#define BS_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0 (7U) /*!< Bit field size in bits for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0. */

/*! @brief Read current value of the MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0 field. */
#define BR_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0(x) (HW_MMDC_MPWRDLCTL(x).B.WR_DL_ABS_OFFSET0)

/*! @brief Format value for bitfield MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0. */
#define BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0) & BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0)

/*! @brief Set the WR_DL_ABS_OFFSET0 field to a new value. */
#define BW_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0(x, v) (HW_MMDC_MPWRDLCTL_WR(x, (HW_MMDC_MPWRDLCTL_RD(x) & ~BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0) | BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET0(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDLCTL, field WR_DL_ABS_OFFSET1[14:8] (RW)
 *
 * Absolute write delay offset for Byte1. This field indicates the absolute
 * delay between write DQS strobe and the write data of Byte1 with fractions of a
 * clock period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (WR_DL_ABS_OFFSET1 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the write
 * delay-line HW calibration this field gets the value of (HW_WR_DL_LOW1 +
 * HW_WR_DL_UP1) /2 Note that not all changes of this value will affect the actual delay.
 * If the requested change is smaller than the delay-line resolution, then no
 * change will occur.
 */
/*@{*/
#define BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1 (8U) /*!< Bit position for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1. */
#define BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1 (0x00007F00U) /*!< Bit mask for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1. */
#define BS_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1 (7U) /*!< Bit field size in bits for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1. */

/*! @brief Read current value of the MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1 field. */
#define BR_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1(x) (HW_MMDC_MPWRDLCTL(x).B.WR_DL_ABS_OFFSET1)

/*! @brief Format value for bitfield MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1. */
#define BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1) & BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1)

/*! @brief Set the WR_DL_ABS_OFFSET1 field to a new value. */
#define BW_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1(x, v) (HW_MMDC_MPWRDLCTL_WR(x, (HW_MMDC_MPWRDLCTL_RD(x) & ~BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1) | BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDLCTL, field WR_DL_ABS_OFFSET2[22:16] (RW)
 *
 * Absolute write delay offset for Byte2. This field indicates the absolute
 * delay between write DQS strobe and the write data of Byte2 with fractions of a
 * clock period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (WR_DL_ABS_OFFSET2/ 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default val ue of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the write
 * delay-line HW calibration this field gets the value of (HW_WR_DL_LOW2 +
 * HW_WR_DL_UP2) /2 Note that not all changes will have effect on the actual delay. If
 * the requested change is smaller than the delay-line resolution, then no change
 * will occur.
 */
/*@{*/
#define BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2 (16U) /*!< Bit position for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2. */
#define BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2 (0x007F0000U) /*!< Bit mask for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2. */
#define BS_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2 (7U) /*!< Bit field size in bits for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2. */

/*! @brief Read current value of the MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2 field. */
#define BR_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2(x) (HW_MMDC_MPWRDLCTL(x).B.WR_DL_ABS_OFFSET2)

/*! @brief Format value for bitfield MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2. */
#define BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2) & BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2)

/*! @brief Set the WR_DL_ABS_OFFSET2 field to a new value. */
#define BW_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2(x, v) (HW_MMDC_MPWRDLCTL_WR(x, (HW_MMDC_MPWRDLCTL_RD(x) & ~BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2) | BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET2(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDLCTL, field WR_DL_ABS_OFFSET3[30:24] (RW)
 *
 * Absolute write delay offset for Byte3. This field indicates the absolute
 * delay between write DQS strobe and the write data of Byte3 with fractions of a
 * clock period and up to half cycle. The fraction is process and frequency
 * independent. The delay of the delay-line would be (WR_DL_ABS_OFFSET3 / 256) * MMDC_CH0
 * AXI clock (fast clock). So for the default value of 64 we get a quarter cycle
 * delay. This field can also bit written by HW. Upon completion of the write
 * delay-line HW calibration this field gets the value of (HW_WR_DL_LOW3 +
 * HW_WR_DL_UP3) /2 Note that not all changes will have effect on the actual delay. If
 * the requested change is smaller than the delay-line resolution, then no change
 * will occur.
 */
/*@{*/
#define BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3 (24U) /*!< Bit position for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3. */
#define BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3 (0x7F000000U) /*!< Bit mask for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3. */
#define BS_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3 (7U) /*!< Bit field size in bits for MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3. */

/*! @brief Read current value of the MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3 field. */
#define BR_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3(x) (HW_MMDC_MPWRDLCTL(x).B.WR_DL_ABS_OFFSET3)

/*! @brief Format value for bitfield MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3. */
#define BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3) & BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3)

/*! @brief Set the WR_DL_ABS_OFFSET3 field to a new value. */
#define BW_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3(x, v) (HW_MMDC_MPWRDLCTL_WR(x, (HW_MMDC_MPWRDLCTL_RD(x) & ~BM_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3) | BF_MMDC_MPWRDLCTL_WR_DL_ABS_OFFSET3(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDLST - MMDC PHY Write delay-lines Status Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDLST - MMDC PHY Write delay-lines Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the status of the 4 write delay-line. Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdlst
{
    uint32_t U;
    struct _hw_mmdc_mpwrdlst_bitfields
    {
        uint32_t WR_DL_UNIT_NUM0 : 7;  /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t WR_DL_UNIT_NUM1 : 7;  /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t WR_DL_UNIT_NUM2 : 7;  /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t WR_DL_UNIT_NUM3 : 7;  /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpwrdlst_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDLST register
 */
/*@{*/
#define HW_MMDC_MPWRDLST_ADDR(x) ((uintptr_t)(x) + 0x854U)

#define HW_MMDC_MPWRDLST(x)      (*(__I hw_mmdc_mpwrdlst_t *) HW_MMDC_MPWRDLST_ADDR(x))
#define HW_MMDC_MPWRDLST_RD(x)   (HW_MMDC_MPWRDLST(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDLST bitfields
 */

/*!
 * @name Register MMDC_MPWRDLST, field WR_DL_UNIT_NUM0[6:0] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPWRDLST_WR_DL_UNIT_NUM0 (0U) /*!< Bit position for MMDC_MPWRDLST_WR_DL_UNIT_NUM0. */
#define BM_MMDC_MPWRDLST_WR_DL_UNIT_NUM0 (0x0000007FU) /*!< Bit mask for MMDC_MPWRDLST_WR_DL_UNIT_NUM0. */
#define BS_MMDC_MPWRDLST_WR_DL_UNIT_NUM0 (7U) /*!< Bit field size in bits for MMDC_MPWRDLST_WR_DL_UNIT_NUM0. */

/*! @brief Read current value of the MMDC_MPWRDLST_WR_DL_UNIT_NUM0 field. */
#define BR_MMDC_MPWRDLST_WR_DL_UNIT_NUM0(x) (HW_MMDC_MPWRDLST(x).B.WR_DL_UNIT_NUM0)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLST, field WR_DL_UNIT_NUM1[14:8] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPWRDLST_WR_DL_UNIT_NUM1 (8U) /*!< Bit position for MMDC_MPWRDLST_WR_DL_UNIT_NUM1. */
#define BM_MMDC_MPWRDLST_WR_DL_UNIT_NUM1 (0x00007F00U) /*!< Bit mask for MMDC_MPWRDLST_WR_DL_UNIT_NUM1. */
#define BS_MMDC_MPWRDLST_WR_DL_UNIT_NUM1 (7U) /*!< Bit field size in bits for MMDC_MPWRDLST_WR_DL_UNIT_NUM1. */

/*! @brief Read current value of the MMDC_MPWRDLST_WR_DL_UNIT_NUM1 field. */
#define BR_MMDC_MPWRDLST_WR_DL_UNIT_NUM1(x) (HW_MMDC_MPWRDLST(x).B.WR_DL_UNIT_NUM1)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLST, field WR_DL_UNIT_NUM2[22:16] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPWRDLST_WR_DL_UNIT_NUM2 (16U) /*!< Bit position for MMDC_MPWRDLST_WR_DL_UNIT_NUM2. */
#define BM_MMDC_MPWRDLST_WR_DL_UNIT_NUM2 (0x007F0000U) /*!< Bit mask for MMDC_MPWRDLST_WR_DL_UNIT_NUM2. */
#define BS_MMDC_MPWRDLST_WR_DL_UNIT_NUM2 (7U) /*!< Bit field size in bits for MMDC_MPWRDLST_WR_DL_UNIT_NUM2. */

/*! @brief Read current value of the MMDC_MPWRDLST_WR_DL_UNIT_NUM2 field. */
#define BR_MMDC_MPWRDLST_WR_DL_UNIT_NUM2(x) (HW_MMDC_MPWRDLST(x).B.WR_DL_UNIT_NUM2)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLST, field WR_DL_UNIT_NUM3[30:24] (RO)
 *
 * This field reflects the number of delay units that are actually used by write
 * delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPWRDLST_WR_DL_UNIT_NUM3 (24U) /*!< Bit position for MMDC_MPWRDLST_WR_DL_UNIT_NUM3. */
#define BM_MMDC_MPWRDLST_WR_DL_UNIT_NUM3 (0x7F000000U) /*!< Bit mask for MMDC_MPWRDLST_WR_DL_UNIT_NUM3. */
#define BS_MMDC_MPWRDLST_WR_DL_UNIT_NUM3 (7U) /*!< Bit field size in bits for MMDC_MPWRDLST_WR_DL_UNIT_NUM3. */

/*! @brief Read current value of the MMDC_MPWRDLST_WR_DL_UNIT_NUM3 field. */
#define BR_MMDC_MPWRDLST_WR_DL_UNIT_NUM3(x) (HW_MMDC_MPWRDLST(x).B.WR_DL_UNIT_NUM3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSDCTRL - MMDC PHY CK Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSDCTRL - MMDC PHY CK Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls the fine tuning of the primary clock (CK0). Supported
 * Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpsdctrl
{
    uint32_t U;
    struct _hw_mmdc_mpsdctrl_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t SDclk0_del : 2;       /*!< [9:8]  */
        uint32_t RESERVED1 : 22;       /*!< [31:10]  */
    } B;
} hw_mmdc_mpsdctrl_t;

/*!
 * @name Constants and macros for entire MMDC_MPSDCTRL register
 */
/*@{*/
#define HW_MMDC_MPSDCTRL_ADDR(x) ((uintptr_t)(x) + 0x858U)

#define HW_MMDC_MPSDCTRL(x)      (*(__IO hw_mmdc_mpsdctrl_t *) HW_MMDC_MPSDCTRL_ADDR(x))
#define HW_MMDC_MPSDCTRL_RD(x)   (HW_MMDC_MPSDCTRL(x).U)
#define HW_MMDC_MPSDCTRL_WR(x, v) (HW_MMDC_MPSDCTRL(x).U = (v))
#define HW_MMDC_MPSDCTRL_SET(x, v) (HW_MMDC_MPSDCTRL_WR(x, HW_MMDC_MPSDCTRL_RD(x) |  (v)))
#define HW_MMDC_MPSDCTRL_CLR(x, v) (HW_MMDC_MPSDCTRL_WR(x, HW_MMDC_MPSDCTRL_RD(x) & ~(v)))
#define HW_MMDC_MPSDCTRL_TOG(x, v) (HW_MMDC_MPSDCTRL_WR(x, HW_MMDC_MPSDCTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSDCTRL bitfields
 */

/*!
 * @name Register MMDC_MPSDCTRL, field SDclk0_del[9:8] (RW)
 *
 * DDR clock0 delay fine tuning. This field holds the number of delay units that
 * are added to DDR clock (CK0). Note: In case of LPDDR2 2-ch mode this
 * registers controls the fine tuning of the clock that is driven to channel0 In case of
 * DDR3 the fine tuning of the secondary clock is controlled by 0x021B_4858[SDCLK]
 *
 * Values:
 * - 00 - No change in DDR clock0 delay
 * - 01 - Add DDR clock0 delay of 1 delay unit.
 * - 10 - Add DDR clock0 delay of 2 delay units.
 * - 11 - Add DDR clock0 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPSDCTRL_SDclk0_del (8U)   /*!< Bit position for MMDC_MPSDCTRL_SDclk0_del. */
#define BM_MMDC_MPSDCTRL_SDclk0_del (0x00000300U) /*!< Bit mask for MMDC_MPSDCTRL_SDclk0_del. */
#define BS_MMDC_MPSDCTRL_SDclk0_del (2U)   /*!< Bit field size in bits for MMDC_MPSDCTRL_SDclk0_del. */

/*! @brief Read current value of the MMDC_MPSDCTRL_SDclk0_del field. */
#define BR_MMDC_MPSDCTRL_SDclk0_del(x) (HW_MMDC_MPSDCTRL(x).B.SDclk0_del)

/*! @brief Format value for bitfield MMDC_MPSDCTRL_SDclk0_del. */
#define BF_MMDC_MPSDCTRL_SDclk0_del(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPSDCTRL_SDclk0_del) & BM_MMDC_MPSDCTRL_SDclk0_del)

/*! @brief Set the SDclk0_del field to a new value. */
#define BW_MMDC_MPSDCTRL_SDclk0_del(x, v) (HW_MMDC_MPSDCTRL_WR(x, (HW_MMDC_MPSDCTRL_RD(x) & ~BM_MMDC_MPSDCTRL_SDclk0_del) | BF_MMDC_MPSDCTRL_SDclk0_del(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPZQLP2CTL - MMDC ZQ LPDDR2 HW Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPZQLP2CTL - MMDC ZQ LPDDR2 HW Control Register (RW)
 *
 * Reset value: 0x1B5F0109U
 *
 * This register controls the idle time that takes the LPDDR2 device to perform
 * ZQ calibration Supported Mode Of Operations: For Channel 0: LP2_2ch_x16,
 * LP2_2ch_x32 For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpzqlp2ctl
{
    uint32_t U;
    struct _hw_mmdc_mpzqlp2ctl_bitfields
    {
        uint32_t ZQ_LP2_HW_ZQINIT : 9; /*!< [8:0]  */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t ZQ_LP2_HW_ZQCL : 8;   /*!< [23:16]  */
        uint32_t ZQ_LP2_HW_ZQCS : 7;   /*!< [30:24]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpzqlp2ctl_t;

/*!
 * @name Constants and macros for entire MMDC_MPZQLP2CTL register
 */
/*@{*/
#define HW_MMDC_MPZQLP2CTL_ADDR(x) ((uintptr_t)(x) + 0x85CU)

#define HW_MMDC_MPZQLP2CTL(x)    (*(__IO hw_mmdc_mpzqlp2ctl_t *) HW_MMDC_MPZQLP2CTL_ADDR(x))
#define HW_MMDC_MPZQLP2CTL_RD(x) (HW_MMDC_MPZQLP2CTL(x).U)
#define HW_MMDC_MPZQLP2CTL_WR(x, v) (HW_MMDC_MPZQLP2CTL(x).U = (v))
#define HW_MMDC_MPZQLP2CTL_SET(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, HW_MMDC_MPZQLP2CTL_RD(x) |  (v)))
#define HW_MMDC_MPZQLP2CTL_CLR(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, HW_MMDC_MPZQLP2CTL_RD(x) & ~(v)))
#define HW_MMDC_MPZQLP2CTL_TOG(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, HW_MMDC_MPZQLP2CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPZQLP2CTL bitfields
 */

/*!
 * @name Register MMDC_MPZQLP2CTL, field ZQ_LP2_HW_ZQINIT[8:0] (RW)
 *
 * This register defines the period in cycles that it takes the memory device to
 * perform a Init ZQ calibration. This is the period of time that the MMDC has
 * to wait after sending a init ZQ calibration and before sending other commands.
 *
 * Values:
 * - 110111 - 112 cycles
 * - 111000 - 114 cycles
 * - 100001001 - 532 cycles (Default, JEDEC value, tZQINIT, for LPDDR2, 1us @
 *     clock frequency 533MHz)
 * - 111111110 - 1022 cycles
 * - 111111111 - 1024 cycles
 */
/*@{*/
#define BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT (0U) /*!< Bit position for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT. */
#define BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT (0x000001FFU) /*!< Bit mask for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT. */
#define BS_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT (9U) /*!< Bit field size in bits for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT. */

/*! @brief Read current value of the MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT field. */
#define BR_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT(x) (HW_MMDC_MPZQLP2CTL(x).B.ZQ_LP2_HW_ZQINIT)

/*! @brief Format value for bitfield MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT. */
#define BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT) & BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT)

/*! @brief Set the ZQ_LP2_HW_ZQINIT field to a new value. */
#define BW_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, (HW_MMDC_MPZQLP2CTL_RD(x) & ~BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT) | BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQINIT(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQLP2CTL, field ZQ_LP2_HW_ZQCL[23:16] (RW)
 *
 * This register defines the period in cycles that it takes the memory device to
 * perform a short ZQ calibration. This is the period of time that the MMDC has
 * to wait after sending a long ZQ calibration and before sending other commands.
 *
 * Values:
 * - 110111 - 112 cycles
 * - 111000 - 114 cycles
 * - 1011111 - 192 cycles (Default, JEDEC value, tZQCL, for LPDDR2, 360ns @
 *     clock frequency 533MHz)
 * - 11111110 - 510 cycles
 * - 11111111 - 512 cycles
 */
/*@{*/
#define BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL (16U) /*!< Bit position for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL. */
#define BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL (0x00FF0000U) /*!< Bit mask for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL. */
#define BS_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL (8U) /*!< Bit field size in bits for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL. */

/*! @brief Read current value of the MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL field. */
#define BR_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL(x) (HW_MMDC_MPZQLP2CTL(x).B.ZQ_LP2_HW_ZQCL)

/*! @brief Format value for bitfield MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL. */
#define BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL) & BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL)

/*! @brief Set the ZQ_LP2_HW_ZQCL field to a new value. */
#define BW_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, (HW_MMDC_MPZQLP2CTL_RD(x) & ~BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL) | BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPZQLP2CTL, field ZQ_LP2_HW_ZQCS[30:24] (RW)
 *
 * This register defines the period in cycles that it takes the memory device to
 * perform a long ZQ calibration. This is the period of time that the MMDC has
 * to wait after sending a short ZQ calibration and before sending other commands.
 * This delay will also be used if ZQ reset is sent.
 *
 * Values:
 * - 11011 - 112 cycles (default)
 * - 11100 - 116 cycles
 * - 1111110 - 508 cycles
 * - 1111111 - 512 cycles
 */
/*@{*/
#define BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS (24U) /*!< Bit position for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS. */
#define BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS (0x7F000000U) /*!< Bit mask for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS. */
#define BS_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS (7U) /*!< Bit field size in bits for MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS. */

/*! @brief Read current value of the MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS field. */
#define BR_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS(x) (HW_MMDC_MPZQLP2CTL(x).B.ZQ_LP2_HW_ZQCS)

/*! @brief Format value for bitfield MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS. */
#define BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS) & BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS)

/*! @brief Set the ZQ_LP2_HW_ZQCS field to a new value. */
#define BW_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS(x, v) (HW_MMDC_MPZQLP2CTL_WR(x, (HW_MMDC_MPZQLP2CTL_RD(x) & ~BM_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS) | BF_MMDC_MPZQLP2CTL_ZQ_LP2_HW_ZQCS(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDLHWCTL - MMDC PHY Read Delay HW Calibration Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDLHWCTL - MMDC PHY Read Delay HW Calibration Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddlhwctl
{
    uint32_t U;
    struct _hw_mmdc_mprddlhwctl_bitfields
    {
        uint32_t HW_RD_DL_ERR0 : 1;    /*!< [0]  */
        uint32_t HW_RD_DL_ERR1 : 1;    /*!< [1]  */
        uint32_t HW_RD_DL_ERR2 : 1;    /*!< [2]  */
        uint32_t HW_RD_DL_ERR3 : 1;    /*!< [3]  */
        uint32_t HW_RD_DL_EN : 1;      /*!< [4]  */
        uint32_t HW_RD_DL_CMP_CYC : 1; /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_mmdc_mprddlhwctl_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDLHWCTL register
 */
/*@{*/
#define HW_MMDC_MPRDDLHWCTL_ADDR(x) ((uintptr_t)(x) + 0x860U)

#define HW_MMDC_MPRDDLHWCTL(x)   (*(__IO hw_mmdc_mprddlhwctl_t *) HW_MMDC_MPRDDLHWCTL_ADDR(x))
#define HW_MMDC_MPRDDLHWCTL_RD(x) (HW_MMDC_MPRDDLHWCTL(x).U)
#define HW_MMDC_MPRDDLHWCTL_WR(x, v) (HW_MMDC_MPRDDLHWCTL(x).U = (v))
#define HW_MMDC_MPRDDLHWCTL_SET(x, v) (HW_MMDC_MPRDDLHWCTL_WR(x, HW_MMDC_MPRDDLHWCTL_RD(x) |  (v)))
#define HW_MMDC_MPRDDLHWCTL_CLR(x, v) (HW_MMDC_MPRDDLHWCTL_WR(x, HW_MMDC_MPRDDLHWCTL_RD(x) & ~(v)))
#define HW_MMDC_MPRDDLHWCTL_TOG(x, v) (HW_MMDC_MPRDDLHWCTL_WR(x, HW_MMDC_MPRDDLHWCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDLHWCTL bitfields
 */

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_ERR0[0] (RO)
 *
 * Automatic (HW) read calibration error of Byte0. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of read
 * delay-line 0. In case this bit is zero at the end of the calibration process
 * then the boundary results can be found at MPRDDLHWST0 register. This bit is
 * valid only after HW_RD_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found in read delay-line 0 during the automatic (HW) read
 *     calibration process of read delay-line 0.
 * - 1 - An error was found in read delay-line 0 during the automatic (HW) read
 *     calibration process of read delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0 (0U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0 (0x00000001U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0 (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0 field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR0(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_ERR0)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_ERR1[1] (RO)
 *
 * Automatic (HW) read calibration error of Byte1. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of read
 * delay-line 1. In case this bit is zero at the end of the calibration process
 * then the boundary results can be found at MPRDDLHWST0 register. This bit is
 * valid only after HW_RD_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found in read delay-line 1 during the automatic (HW) read
 *     calibration process of read delay-line 1.
 * - 1 - An error was found in read delay-line 1 during the automatic (HW) read
 *     calibration process of read delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1 (1U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1 (0x00000002U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1 (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1 field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR1(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_ERR1)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_ERR2[2] (RO)
 *
 * Automatic (HW) read calibration error of Byte2. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of read
 * delay-line 2. In case this bit is zero at the end of the calibration process
 * then the boundary results can be found at MPRDDLHWST1 register. This bit is
 * valid only after HW_RD_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found in read delay-line 2 during the automatic (HW) read
 *     calibration process of read delay-line 2.
 * - 1 - An error was found in read delay-line 2 during the automatic (HW) read
 *     calibration process of read delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2 (2U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2 (0x00000004U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2 (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2 field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR2(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_ERR2)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_ERR3[3] (RO)
 *
 * Automatic (HW) read calibration error of Byte3. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of read
 * delay-line 3. In case this bit is zero at the end of the calibration process
 * then the boundary results can be found at MPRDDLHWST1 register. This bit is
 * valid only after HW_RD_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found in read delay-line 3 during the automatic (HW) read
 *     calibration process of read delay-line 3.
 * - 1 - An error was found in read delay-line 3 during the automatic (HW) read
 *     calibration process of read delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3 (3U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3 (0x00000008U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3 (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3 field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_ERR3(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_ERR3)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_EN[4] (RW)
 *
 * Enable automatic (HW) read calibration. If this bit is asserted then the MMDC
 * will perform an automatic read calibration. HW should negate this bit upon
 * completion of the calibration. Negation of this bit also points that the read
 * calibration results are valid Note: Before issuing the first read command MMDC
 * counts 12 cycles.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_EN (4U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_EN. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_EN (0x00000010U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_EN. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_EN (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_EN. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_EN field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_EN(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_EN)

/*! @brief Format value for bitfield MMDC_MPRDDLHWCTL_HW_RD_DL_EN. */
#define BF_MMDC_MPRDDLHWCTL_HW_RD_DL_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLHWCTL_HW_RD_DL_EN) & BM_MMDC_MPRDDLHWCTL_HW_RD_DL_EN)

/*! @brief Set the HW_RD_DL_EN field to a new value. */
#define BW_MMDC_MPRDDLHWCTL_HW_RD_DL_EN(x, v) (HW_MMDC_MPRDDLHWCTL_WR(x, (HW_MMDC_MPRDDLHWCTL_RD(x) & ~BM_MMDC_MPRDDLHWCTL_HW_RD_DL_EN) | BF_MMDC_MPRDDLHWCTL_HW_RD_DL_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWCTL, field HW_RD_DL_CMP_CYC[5] (RW)
 *
 * Automatic (HW) read sample cycle. If this bit is asserted then the MMDC will
 * compare the read data 32 cycles after the MMDC sent the read command enable
 * pulse else it compares the data after 16 cycles.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC (5U) /*!< Bit position for MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC. */
#define BM_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC (0x00000020U) /*!< Bit mask for MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC. */
#define BS_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC (1U) /*!< Bit field size in bits for MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC. */

/*! @brief Read current value of the MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC field. */
#define BR_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC(x) (HW_MMDC_MPRDDLHWCTL(x).B.HW_RD_DL_CMP_CYC)

/*! @brief Format value for bitfield MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC. */
#define BF_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC) & BM_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC)

/*! @brief Set the HW_RD_DL_CMP_CYC field to a new value. */
#define BW_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC(x, v) (HW_MMDC_MPRDDLHWCTL_WR(x, (HW_MMDC_MPRDDLHWCTL_RD(x) & ~BM_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC) | BF_MMDC_MPRDDLHWCTL_HW_RD_DL_CMP_CYC(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDLHWCTL - MMDC PHY Write Delay HW Calibration Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDLHWCTL - MMDC PHY Write Delay HW Calibration Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdlhwctl
{
    uint32_t U;
    struct _hw_mmdc_mpwrdlhwctl_bitfields
    {
        uint32_t HW_WR_DL_ERR0 : 1;    /*!< [0]  */
        uint32_t HW_WR_DL_ERR1 : 1;    /*!< [1]  */
        uint32_t HW_WR_DL_ERR2 : 1;    /*!< [2]  */
        uint32_t HW_WR_DL_ERR3 : 1;    /*!< [3]  */
        uint32_t HW_WR_DL_EN : 1;      /*!< [4]  */
        uint32_t HW_WR_DL_CMP_CYC : 1; /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_mmdc_mpwrdlhwctl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDLHWCTL register
 */
/*@{*/
#define HW_MMDC_MPWRDLHWCTL_ADDR(x) ((uintptr_t)(x) + 0x864U)

#define HW_MMDC_MPWRDLHWCTL(x)   (*(__IO hw_mmdc_mpwrdlhwctl_t *) HW_MMDC_MPWRDLHWCTL_ADDR(x))
#define HW_MMDC_MPWRDLHWCTL_RD(x) (HW_MMDC_MPWRDLHWCTL(x).U)
#define HW_MMDC_MPWRDLHWCTL_WR(x, v) (HW_MMDC_MPWRDLHWCTL(x).U = (v))
#define HW_MMDC_MPWRDLHWCTL_SET(x, v) (HW_MMDC_MPWRDLHWCTL_WR(x, HW_MMDC_MPWRDLHWCTL_RD(x) |  (v)))
#define HW_MMDC_MPWRDLHWCTL_CLR(x, v) (HW_MMDC_MPWRDLHWCTL_WR(x, HW_MMDC_MPWRDLHWCTL_RD(x) & ~(v)))
#define HW_MMDC_MPWRDLHWCTL_TOG(x, v) (HW_MMDC_MPWRDLHWCTL_WR(x, HW_MMDC_MPWRDLHWCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDLHWCTL bitfields
 */

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_ERR0[0] (RO)
 *
 * Automatic (HW) write calibration error of Byte0. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of
 * write delay-line 0. In case this bit is zero at the end of the calibration
 * process then the boundary results can be found at MPWRDLHWST0 register. This bit is
 * valid only after HW_WR_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found during the automatic (HW) write calibration process
 *     of write delay-line 0.
 * - 1 - An error was found during the automatic (HW) write calibration process
 *     of write delay-line 0.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0 (0U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0 (0x00000001U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0 (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0 field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR0(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_ERR0)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_ERR1[1] (RO)
 *
 * Automatic (HW) write calibration error of Byte1. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of
 * write delay-line 1. In case this bit is zero at the end of the calibration
 * process then the boundary results can be found at MPWRDLHWST0 register. This bit is
 * valid only after HW_WR_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found during the automatic (HW) write calibration process
 *     of write delay-line 1.
 * - 1 - An error was found during the automatic (HW) write calibration process
 *     of write delay-line 1.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1 (1U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1 (0x00000002U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1 (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1 field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR1(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_ERR1)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_ERR2[2] (RO)
 *
 * Automatic (HW) write calibration error of Byte2. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of
 * write delay-line 2. T In case this bit is zero at the end of the calibration
 * process then the boundary results can be found at MPWRDLHWST1 register. This bit
 * is valid only after HW_WR_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found during the automatic (HW) write calibration process
 *     of write delay-line 2.
 * - 1 - An error was found during the automatic (HW) write calibration process
 *     of write delay-line 2.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2 (2U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2 (0x00000004U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2 (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2 field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR2(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_ERR2)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_ERR3[3] (RO)
 *
 * Automatic (HW) write calibration error of Byte3. If this bit is asserted then
 * it indicates that an error was found during the HW calibration process of
 * write delay-line 3. In case this bit is zero at the end of the calibration
 * process then the boundary results can be found at MPWRDLHWST1 register. This bit is
 * valid only after HW_WR_DL_EN is de-asserted.
 *
 * Values:
 * - 0 - No error was found during the automatic (HW) write calibration process
 *     of write delay-line 3.
 * - 1 - An error was found during the automatic (HW) write calibration process
 *     of write delay-line 3.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3 (3U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3 (0x00000008U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3 (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3 field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_ERR3(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_ERR3)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_EN[4] (RW)
 *
 * Enable automatic (HW) write calibration. If this bit is asserted then the
 * MMDC will perform an automatic write calibration. HW should negate this bit upon
 * completion of the calibration. Negation of this bit also indicates that the
 * write calibration results are valid Note: Before issuing the first read command
 * MMDC counts 12 cycles.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_EN (4U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_EN. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_EN (0x00000010U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_EN. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_EN (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_EN. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_EN field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_EN(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_EN)

/*! @brief Format value for bitfield MMDC_MPWRDLHWCTL_HW_WR_DL_EN. */
#define BF_MMDC_MPWRDLHWCTL_HW_WR_DL_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLHWCTL_HW_WR_DL_EN) & BM_MMDC_MPWRDLHWCTL_HW_WR_DL_EN)

/*! @brief Set the HW_WR_DL_EN field to a new value. */
#define BW_MMDC_MPWRDLHWCTL_HW_WR_DL_EN(x, v) (HW_MMDC_MPWRDLHWCTL_WR(x, (HW_MMDC_MPWRDLHWCTL_RD(x) & ~BM_MMDC_MPWRDLHWCTL_HW_WR_DL_EN) | BF_MMDC_MPWRDLHWCTL_HW_WR_DL_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWCTL, field HW_WR_DL_CMP_CYC[5] (RW)
 *
 * Write sample cycle. If this bit is asserted then the MMDC will compare the
 * data 32 cycles after the MMDC sent the read command enable pulse else it
 * compares the data after 16 cycles.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC (5U) /*!< Bit position for MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC. */
#define BM_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC (0x00000020U) /*!< Bit mask for MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC. */
#define BS_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC (1U) /*!< Bit field size in bits for MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC. */

/*! @brief Read current value of the MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC field. */
#define BR_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC(x) (HW_MMDC_MPWRDLHWCTL(x).B.HW_WR_DL_CMP_CYC)

/*! @brief Format value for bitfield MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC. */
#define BF_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC) & BM_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC)

/*! @brief Set the HW_WR_DL_CMP_CYC field to a new value. */
#define BW_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC(x, v) (HW_MMDC_MPWRDLHWCTL_WR(x, (HW_MMDC_MPWRDLHWCTL_RD(x) & ~BM_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC) | BF_MMDC_MPWRDLHWCTL_HW_WR_DL_CMP_CYC(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDLHWST0 - MMDC PHY Read Delay HW Calibration Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDLHWST0 - MMDC PHY Read Delay HW Calibration Status Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddlhwst0
{
    uint32_t U;
    struct _hw_mmdc_mprddlhwst0_bitfields
    {
        uint32_t HW_RD_DL_LOW0 : 7;    /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t HW_RD_DL_UP0 : 7;     /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t HW_RD_DL_LOW1 : 7;    /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t HW_RD_DL_UP1 : 7;     /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddlhwst0_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDLHWST0 register
 */
/*@{*/
#define HW_MMDC_MPRDDLHWST0_ADDR(x) ((uintptr_t)(x) + 0x868U)

#define HW_MMDC_MPRDDLHWST0(x)   (*(__I hw_mmdc_mprddlhwst0_t *) HW_MMDC_MPRDDLHWST0_ADDR(x))
#define HW_MMDC_MPRDDLHWST0_RD(x) (HW_MMDC_MPRDDLHWST0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDLHWST0 bitfields
 */

/*!
 * @name Register MMDC_MPRDDLHWST0, field HW_RD_DL_LOW0[6:0] (RO)
 *
 * Automatic (HW) read calibration result of the lower boundary of Byte0. This
 * field holds the automatic (HW) read calibration result of the lower boundary of
 * Byte0.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST0_HW_RD_DL_LOW0 (0U) /*!< Bit position for MMDC_MPRDDLHWST0_HW_RD_DL_LOW0. */
#define BM_MMDC_MPRDDLHWST0_HW_RD_DL_LOW0 (0x0000007FU) /*!< Bit mask for MMDC_MPRDDLHWST0_HW_RD_DL_LOW0. */
#define BS_MMDC_MPRDDLHWST0_HW_RD_DL_LOW0 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST0_HW_RD_DL_LOW0. */

/*! @brief Read current value of the MMDC_MPRDDLHWST0_HW_RD_DL_LOW0 field. */
#define BR_MMDC_MPRDDLHWST0_HW_RD_DL_LOW0(x) (HW_MMDC_MPRDDLHWST0(x).B.HW_RD_DL_LOW0)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST0, field HW_RD_DL_UP0[14:8] (RO)
 *
 * Automatic (HW) read calibration result of the upper boundary of Byte0. This
 * field holds the automatic (HW) read calibration result of the upper boundary of
 * Byte0.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST0_HW_RD_DL_UP0 (8U) /*!< Bit position for MMDC_MPRDDLHWST0_HW_RD_DL_UP0. */
#define BM_MMDC_MPRDDLHWST0_HW_RD_DL_UP0 (0x00007F00U) /*!< Bit mask for MMDC_MPRDDLHWST0_HW_RD_DL_UP0. */
#define BS_MMDC_MPRDDLHWST0_HW_RD_DL_UP0 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST0_HW_RD_DL_UP0. */

/*! @brief Read current value of the MMDC_MPRDDLHWST0_HW_RD_DL_UP0 field. */
#define BR_MMDC_MPRDDLHWST0_HW_RD_DL_UP0(x) (HW_MMDC_MPRDDLHWST0(x).B.HW_RD_DL_UP0)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST0, field HW_RD_DL_LOW1[22:16] (RO)
 *
 * Automatic (HW) read calibration result of the lower boundary of Byte1. This
 * field holds the automatic (HW) read calibration result of the lower boundary of
 * Byte1
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST0_HW_RD_DL_LOW1 (16U) /*!< Bit position for MMDC_MPRDDLHWST0_HW_RD_DL_LOW1. */
#define BM_MMDC_MPRDDLHWST0_HW_RD_DL_LOW1 (0x007F0000U) /*!< Bit mask for MMDC_MPRDDLHWST0_HW_RD_DL_LOW1. */
#define BS_MMDC_MPRDDLHWST0_HW_RD_DL_LOW1 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST0_HW_RD_DL_LOW1. */

/*! @brief Read current value of the MMDC_MPRDDLHWST0_HW_RD_DL_LOW1 field. */
#define BR_MMDC_MPRDDLHWST0_HW_RD_DL_LOW1(x) (HW_MMDC_MPRDDLHWST0(x).B.HW_RD_DL_LOW1)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST0, field HW_RD_DL_UP1[30:24] (RO)
 *
 * Automatic (HW) read calibration result of the upper boundary of Byte1. This
 * field holds the automatic (HW) read calibration result of the upper boundary of
 * Byte1
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST0_HW_RD_DL_UP1 (24U) /*!< Bit position for MMDC_MPRDDLHWST0_HW_RD_DL_UP1. */
#define BM_MMDC_MPRDDLHWST0_HW_RD_DL_UP1 (0x7F000000U) /*!< Bit mask for MMDC_MPRDDLHWST0_HW_RD_DL_UP1. */
#define BS_MMDC_MPRDDLHWST0_HW_RD_DL_UP1 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST0_HW_RD_DL_UP1. */

/*! @brief Read current value of the MMDC_MPRDDLHWST0_HW_RD_DL_UP1 field. */
#define BR_MMDC_MPRDDLHWST0_HW_RD_DL_UP1(x) (HW_MMDC_MPRDDLHWST0(x).B.HW_RD_DL_UP1)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPRDDLHWST1 - MMDC PHY Read Delay HW Calibration Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPRDDLHWST1 - MMDC PHY Read Delay HW Calibration Status Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mprddlhwst1
{
    uint32_t U;
    struct _hw_mmdc_mprddlhwst1_bitfields
    {
        uint32_t HW_RD_DL_LOW2 : 7;    /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t HW_RD_DL_UP2 : 7;     /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t HW_RD_DL_LOW3 : 7;    /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t HW_RD_DL_UP3 : 7;     /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mprddlhwst1_t;

/*!
 * @name Constants and macros for entire MMDC_MPRDDLHWST1 register
 */
/*@{*/
#define HW_MMDC_MPRDDLHWST1_ADDR(x) ((uintptr_t)(x) + 0x86CU)

#define HW_MMDC_MPRDDLHWST1(x)   (*(__I hw_mmdc_mprddlhwst1_t *) HW_MMDC_MPRDDLHWST1_ADDR(x))
#define HW_MMDC_MPRDDLHWST1_RD(x) (HW_MMDC_MPRDDLHWST1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPRDDLHWST1 bitfields
 */

/*!
 * @name Register MMDC_MPRDDLHWST1, field HW_RD_DL_LOW2[6:0] (RO)
 *
 * Automatic (HW) read calibration result of the lower boundary of Byte2. This
 * field holds the automatic (HW) read calibration result of the lower boundary of
 * Byte2.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST1_HW_RD_DL_LOW2 (0U) /*!< Bit position for MMDC_MPRDDLHWST1_HW_RD_DL_LOW2. */
#define BM_MMDC_MPRDDLHWST1_HW_RD_DL_LOW2 (0x0000007FU) /*!< Bit mask for MMDC_MPRDDLHWST1_HW_RD_DL_LOW2. */
#define BS_MMDC_MPRDDLHWST1_HW_RD_DL_LOW2 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST1_HW_RD_DL_LOW2. */

/*! @brief Read current value of the MMDC_MPRDDLHWST1_HW_RD_DL_LOW2 field. */
#define BR_MMDC_MPRDDLHWST1_HW_RD_DL_LOW2(x) (HW_MMDC_MPRDDLHWST1(x).B.HW_RD_DL_LOW2)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST1, field HW_RD_DL_UP2[14:8] (RO)
 *
 * Automatic (HW) read calibration result of the upper boundary of Byte2. This
 * field holds the automatic (HW) read calibration result of the upper boundary of
 * Byte2.
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST1_HW_RD_DL_UP2 (8U) /*!< Bit position for MMDC_MPRDDLHWST1_HW_RD_DL_UP2. */
#define BM_MMDC_MPRDDLHWST1_HW_RD_DL_UP2 (0x00007F00U) /*!< Bit mask for MMDC_MPRDDLHWST1_HW_RD_DL_UP2. */
#define BS_MMDC_MPRDDLHWST1_HW_RD_DL_UP2 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST1_HW_RD_DL_UP2. */

/*! @brief Read current value of the MMDC_MPRDDLHWST1_HW_RD_DL_UP2 field. */
#define BR_MMDC_MPRDDLHWST1_HW_RD_DL_UP2(x) (HW_MMDC_MPRDDLHWST1(x).B.HW_RD_DL_UP2)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST1, field HW_RD_DL_LOW3[22:16] (RO)
 *
 * Automatic (HW) read calibration result of the lower boundary of Byte3. This
 * field holds the automatic (HW) read calibration result of the lower boundary of
 * Byte3
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST1_HW_RD_DL_LOW3 (16U) /*!< Bit position for MMDC_MPRDDLHWST1_HW_RD_DL_LOW3. */
#define BM_MMDC_MPRDDLHWST1_HW_RD_DL_LOW3 (0x007F0000U) /*!< Bit mask for MMDC_MPRDDLHWST1_HW_RD_DL_LOW3. */
#define BS_MMDC_MPRDDLHWST1_HW_RD_DL_LOW3 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST1_HW_RD_DL_LOW3. */

/*! @brief Read current value of the MMDC_MPRDDLHWST1_HW_RD_DL_LOW3 field. */
#define BR_MMDC_MPRDDLHWST1_HW_RD_DL_LOW3(x) (HW_MMDC_MPRDDLHWST1(x).B.HW_RD_DL_LOW3)
/*@}*/

/*!
 * @name Register MMDC_MPRDDLHWST1, field HW_RD_DL_UP3[30:24] (RO)
 *
 * Automatic (HW) read calibration result of the upper boundary of Byte3. This
 * field holds the automatic (HW) read calibration result of the upper boundary of
 * Byte3
 */
/*@{*/
#define BP_MMDC_MPRDDLHWST1_HW_RD_DL_UP3 (24U) /*!< Bit position for MMDC_MPRDDLHWST1_HW_RD_DL_UP3. */
#define BM_MMDC_MPRDDLHWST1_HW_RD_DL_UP3 (0x7F000000U) /*!< Bit mask for MMDC_MPRDDLHWST1_HW_RD_DL_UP3. */
#define BS_MMDC_MPRDDLHWST1_HW_RD_DL_UP3 (7U) /*!< Bit field size in bits for MMDC_MPRDDLHWST1_HW_RD_DL_UP3. */

/*! @brief Read current value of the MMDC_MPRDDLHWST1_HW_RD_DL_UP3 field. */
#define BR_MMDC_MPRDDLHWST1_HW_RD_DL_UP3(x) (HW_MMDC_MPRDDLHWST1(x).B.HW_RD_DL_UP3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDLHWST0 - MMDC PHY Write Delay HW Calibration Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDLHWST0 - MMDC PHY Write Delay HW Calibration Status Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdlhwst0
{
    uint32_t U;
    struct _hw_mmdc_mpwrdlhwst0_bitfields
    {
        uint32_t HW_WR_DL_LOW0 : 7;    /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t HW_WR_DL_UP0 : 7;     /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t HW_WR_DL_LOW1 : 7;    /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t HW_WR_DL_UP1 : 7;     /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpwrdlhwst0_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDLHWST0 register
 */
/*@{*/
#define HW_MMDC_MPWRDLHWST0_ADDR(x) ((uintptr_t)(x) + 0x870U)

#define HW_MMDC_MPWRDLHWST0(x)   (*(__I hw_mmdc_mpwrdlhwst0_t *) HW_MMDC_MPWRDLHWST0_ADDR(x))
#define HW_MMDC_MPWRDLHWST0_RD(x) (HW_MMDC_MPWRDLHWST0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDLHWST0 bitfields
 */

/*!
 * @name Register MMDC_MPWRDLHWST0, field HW_WR_DL_LOW0[6:0] (RO)
 *
 * Automatic (HW) write calibration result of the lower boundary of Byte0. This
 * field holds the automatic (HW) write calibration result of the lower boundary
 * of Byte0.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST0_HW_WR_DL_LOW0 (0U) /*!< Bit position for MMDC_MPWRDLHWST0_HW_WR_DL_LOW0. */
#define BM_MMDC_MPWRDLHWST0_HW_WR_DL_LOW0 (0x0000007FU) /*!< Bit mask for MMDC_MPWRDLHWST0_HW_WR_DL_LOW0. */
#define BS_MMDC_MPWRDLHWST0_HW_WR_DL_LOW0 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST0_HW_WR_DL_LOW0. */

/*! @brief Read current value of the MMDC_MPWRDLHWST0_HW_WR_DL_LOW0 field. */
#define BR_MMDC_MPWRDLHWST0_HW_WR_DL_LOW0(x) (HW_MMDC_MPWRDLHWST0(x).B.HW_WR_DL_LOW0)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST0, field HW_WR_DL_UP0[14:8] (RO)
 *
 * Automatic (HW) write calibration result of the upper boundary of Byte0. This
 * field holds the automatic (HW) write calibration result of the upper boundary
 * of Byte0.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST0_HW_WR_DL_UP0 (8U) /*!< Bit position for MMDC_MPWRDLHWST0_HW_WR_DL_UP0. */
#define BM_MMDC_MPWRDLHWST0_HW_WR_DL_UP0 (0x00007F00U) /*!< Bit mask for MMDC_MPWRDLHWST0_HW_WR_DL_UP0. */
#define BS_MMDC_MPWRDLHWST0_HW_WR_DL_UP0 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST0_HW_WR_DL_UP0. */

/*! @brief Read current value of the MMDC_MPWRDLHWST0_HW_WR_DL_UP0 field. */
#define BR_MMDC_MPWRDLHWST0_HW_WR_DL_UP0(x) (HW_MMDC_MPWRDLHWST0(x).B.HW_WR_DL_UP0)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST0, field HW_WR_DL_LOW1[22:16] (RO)
 *
 * Automatic (HW) write calibration result of the lower boundary of Byte1. This
 * field holds the automatic (HW) write calibration result of the lower boundary
 * of Byte1.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST0_HW_WR_DL_LOW1 (16U) /*!< Bit position for MMDC_MPWRDLHWST0_HW_WR_DL_LOW1. */
#define BM_MMDC_MPWRDLHWST0_HW_WR_DL_LOW1 (0x007F0000U) /*!< Bit mask for MMDC_MPWRDLHWST0_HW_WR_DL_LOW1. */
#define BS_MMDC_MPWRDLHWST0_HW_WR_DL_LOW1 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST0_HW_WR_DL_LOW1. */

/*! @brief Read current value of the MMDC_MPWRDLHWST0_HW_WR_DL_LOW1 field. */
#define BR_MMDC_MPWRDLHWST0_HW_WR_DL_LOW1(x) (HW_MMDC_MPWRDLHWST0(x).B.HW_WR_DL_LOW1)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST0, field HW_WR_DL_UP1[30:24] (RO)
 *
 * Automatic (HW) write automatic (HW) write calibration result of the upper
 * boundary of Byte1. This field holds the automatic (HW) write calibration result
 * of the upper boundary of Byte1.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST0_HW_WR_DL_UP1 (24U) /*!< Bit position for MMDC_MPWRDLHWST0_HW_WR_DL_UP1. */
#define BM_MMDC_MPWRDLHWST0_HW_WR_DL_UP1 (0x7F000000U) /*!< Bit mask for MMDC_MPWRDLHWST0_HW_WR_DL_UP1. */
#define BS_MMDC_MPWRDLHWST0_HW_WR_DL_UP1 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST0_HW_WR_DL_UP1. */

/*! @brief Read current value of the MMDC_MPWRDLHWST0_HW_WR_DL_UP1 field. */
#define BR_MMDC_MPWRDLHWST0_HW_WR_DL_UP1(x) (HW_MMDC_MPWRDLHWST0(x).B.HW_WR_DL_UP1)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRDLHWST1 - MMDC PHY Write Delay HW Calibration Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRDLHWST1 - MMDC PHY Write Delay HW Calibration Status Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrdlhwst1
{
    uint32_t U;
    struct _hw_mmdc_mpwrdlhwst1_bitfields
    {
        uint32_t HW_WR_DL_LOW2 : 7;    /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t HW_WR_DL_UP2 : 7;     /*!< [14:8]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t HW_WR_DL_LOW3 : 7;    /*!< [22:16]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t HW_WR_DL_UP3 : 7;     /*!< [30:24]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpwrdlhwst1_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRDLHWST1 register
 */
/*@{*/
#define HW_MMDC_MPWRDLHWST1_ADDR(x) ((uintptr_t)(x) + 0x874U)

#define HW_MMDC_MPWRDLHWST1(x)   (*(__I hw_mmdc_mpwrdlhwst1_t *) HW_MMDC_MPWRDLHWST1_ADDR(x))
#define HW_MMDC_MPWRDLHWST1_RD(x) (HW_MMDC_MPWRDLHWST1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRDLHWST1 bitfields
 */

/*!
 * @name Register MMDC_MPWRDLHWST1, field HW_WR_DL_LOW2[6:0] (RO)
 *
 * Automatic (HW) write calibration result of the lower boundary of Byte2. This
 * field holds the automatic (HW) write calibration result of the lower boundary
 * of Byte2.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST1_HW_WR_DL_LOW2 (0U) /*!< Bit position for MMDC_MPWRDLHWST1_HW_WR_DL_LOW2. */
#define BM_MMDC_MPWRDLHWST1_HW_WR_DL_LOW2 (0x0000007FU) /*!< Bit mask for MMDC_MPWRDLHWST1_HW_WR_DL_LOW2. */
#define BS_MMDC_MPWRDLHWST1_HW_WR_DL_LOW2 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST1_HW_WR_DL_LOW2. */

/*! @brief Read current value of the MMDC_MPWRDLHWST1_HW_WR_DL_LOW2 field. */
#define BR_MMDC_MPWRDLHWST1_HW_WR_DL_LOW2(x) (HW_MMDC_MPWRDLHWST1(x).B.HW_WR_DL_LOW2)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST1, field HW_WR_DL_UP2[14:8] (RO)
 *
 * Automatic (HW) write calibration result of the upper boundary of Byte2. This
 * field holds the automatic (HW) write calibration result of the upper boundary
 * of Byte2.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST1_HW_WR_DL_UP2 (8U) /*!< Bit position for MMDC_MPWRDLHWST1_HW_WR_DL_UP2. */
#define BM_MMDC_MPWRDLHWST1_HW_WR_DL_UP2 (0x00007F00U) /*!< Bit mask for MMDC_MPWRDLHWST1_HW_WR_DL_UP2. */
#define BS_MMDC_MPWRDLHWST1_HW_WR_DL_UP2 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST1_HW_WR_DL_UP2. */

/*! @brief Read current value of the MMDC_MPWRDLHWST1_HW_WR_DL_UP2 field. */
#define BR_MMDC_MPWRDLHWST1_HW_WR_DL_UP2(x) (HW_MMDC_MPWRDLHWST1(x).B.HW_WR_DL_UP2)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST1, field HW_WR_DL_LOW3[22:16] (RO)
 *
 * Automatic (HW) write calibration result of the lower boundary of Byte3. This
 * field holds the automatic (HW) write calibration result of the lower boundary
 * of Byte3.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST1_HW_WR_DL_LOW3 (16U) /*!< Bit position for MMDC_MPWRDLHWST1_HW_WR_DL_LOW3. */
#define BM_MMDC_MPWRDLHWST1_HW_WR_DL_LOW3 (0x007F0000U) /*!< Bit mask for MMDC_MPWRDLHWST1_HW_WR_DL_LOW3. */
#define BS_MMDC_MPWRDLHWST1_HW_WR_DL_LOW3 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST1_HW_WR_DL_LOW3. */

/*! @brief Read current value of the MMDC_MPWRDLHWST1_HW_WR_DL_LOW3 field. */
#define BR_MMDC_MPWRDLHWST1_HW_WR_DL_LOW3(x) (HW_MMDC_MPWRDLHWST1(x).B.HW_WR_DL_LOW3)
/*@}*/

/*!
 * @name Register MMDC_MPWRDLHWST1, field HW_WR_DL_UP3[30:24] (RO)
 *
 * Automatic (HW) write calibration result of the upper boundary of Byte3. This
 * field holds the automatic (HW) write calibration result of the upper boundary
 * of Byte3.
 */
/*@{*/
#define BP_MMDC_MPWRDLHWST1_HW_WR_DL_UP3 (24U) /*!< Bit position for MMDC_MPWRDLHWST1_HW_WR_DL_UP3. */
#define BM_MMDC_MPWRDLHWST1_HW_WR_DL_UP3 (0x7F000000U) /*!< Bit mask for MMDC_MPWRDLHWST1_HW_WR_DL_UP3. */
#define BS_MMDC_MPWRDLHWST1_HW_WR_DL_UP3 (7U) /*!< Bit field size in bits for MMDC_MPWRDLHWST1_HW_WR_DL_UP3. */

/*! @brief Read current value of the MMDC_MPWRDLHWST1_HW_WR_DL_UP3 field. */
#define BR_MMDC_MPWRDLHWST1_HW_WR_DL_UP3(x) (HW_MMDC_MPWRDLHWST1(x).B.HW_WR_DL_UP3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWLHWERR - MMDC PHY Write Leveling HW Error Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWLHWERR - MMDC PHY Write Leveling HW Error Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwlhwerr
{
    uint32_t U;
    struct _hw_mmdc_mpwlhwerr_bitfields
    {
        uint32_t HW_WL0_DQ : 8;        /*!< [7:0]  */
        uint32_t HW_WL1_DQ : 8;        /*!< [15:8]  */
        uint32_t HW_WL2_DQ : 8;        /*!< [23:16]  */
        uint32_t HW_WL3_DQ : 8;        /*!< [31:24]  */
    } B;
} hw_mmdc_mpwlhwerr_t;

/*!
 * @name Constants and macros for entire MMDC_MPWLHWERR register
 */
/*@{*/
#define HW_MMDC_MPWLHWERR_ADDR(x) ((uintptr_t)(x) + 0x878U)

#define HW_MMDC_MPWLHWERR(x)     (*(__I hw_mmdc_mpwlhwerr_t *) HW_MMDC_MPWLHWERR_ADDR(x))
#define HW_MMDC_MPWLHWERR_RD(x)  (HW_MMDC_MPWLHWERR(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWLHWERR bitfields
 */

/*!
 * @name Register MMDC_MPWLHWERR, field HW_WL0_DQ[7:0] (RO)
 *
 * HW write-leveling calibration result of Byte0. This field holds the results
 * for all the 8 write-leveling steps of Byte0. i.e. bit 0 holds the result of the
 * write-leveling calibration of 0 delay, bit 1holds the result of the
 * write-leveling calibration of 1/8delay till bit 7 that holds the result of the
 * write-leveling calibration of 7/8 delay
 */
/*@{*/
#define BP_MMDC_MPWLHWERR_HW_WL0_DQ (0U)   /*!< Bit position for MMDC_MPWLHWERR_HW_WL0_DQ. */
#define BM_MMDC_MPWLHWERR_HW_WL0_DQ (0x000000FFU) /*!< Bit mask for MMDC_MPWLHWERR_HW_WL0_DQ. */
#define BS_MMDC_MPWLHWERR_HW_WL0_DQ (8U)   /*!< Bit field size in bits for MMDC_MPWLHWERR_HW_WL0_DQ. */

/*! @brief Read current value of the MMDC_MPWLHWERR_HW_WL0_DQ field. */
#define BR_MMDC_MPWLHWERR_HW_WL0_DQ(x) (HW_MMDC_MPWLHWERR(x).B.HW_WL0_DQ)
/*@}*/

/*!
 * @name Register MMDC_MPWLHWERR, field HW_WL1_DQ[15:8] (RO)
 *
 * HW write-leveling calibration result of Byte1. This field holds the results
 * for all the 8 write-leveling steps of Byte1. i.e. bit 0 holds the result of the
 * write-leveling calibration of 0 delay, bit 1holds the result of the
 * write-leveling calibration of 1/8delay till bit 7 that holds the result of the
 * write-leveling calibration of 7/8 delay
 */
/*@{*/
#define BP_MMDC_MPWLHWERR_HW_WL1_DQ (8U)   /*!< Bit position for MMDC_MPWLHWERR_HW_WL1_DQ. */
#define BM_MMDC_MPWLHWERR_HW_WL1_DQ (0x0000FF00U) /*!< Bit mask for MMDC_MPWLHWERR_HW_WL1_DQ. */
#define BS_MMDC_MPWLHWERR_HW_WL1_DQ (8U)   /*!< Bit field size in bits for MMDC_MPWLHWERR_HW_WL1_DQ. */

/*! @brief Read current value of the MMDC_MPWLHWERR_HW_WL1_DQ field. */
#define BR_MMDC_MPWLHWERR_HW_WL1_DQ(x) (HW_MMDC_MPWLHWERR(x).B.HW_WL1_DQ)
/*@}*/

/*!
 * @name Register MMDC_MPWLHWERR, field HW_WL2_DQ[23:16] (RO)
 *
 * HW write-leveling calibration result of Byte2. This field holds the results
 * for all the 8 write-leveling steps of Byte2. i.e. bit 0 holds the result of the
 * write-leveling calibration of 0 delay, bit 1holds the result of the
 * write-leveling calibration of 1/8delay till bit 7 that holds the result of the
 * write-leveling calibration of 7/8 delay
 */
/*@{*/
#define BP_MMDC_MPWLHWERR_HW_WL2_DQ (16U)  /*!< Bit position for MMDC_MPWLHWERR_HW_WL2_DQ. */
#define BM_MMDC_MPWLHWERR_HW_WL2_DQ (0x00FF0000U) /*!< Bit mask for MMDC_MPWLHWERR_HW_WL2_DQ. */
#define BS_MMDC_MPWLHWERR_HW_WL2_DQ (8U)   /*!< Bit field size in bits for MMDC_MPWLHWERR_HW_WL2_DQ. */

/*! @brief Read current value of the MMDC_MPWLHWERR_HW_WL2_DQ field. */
#define BR_MMDC_MPWLHWERR_HW_WL2_DQ(x) (HW_MMDC_MPWLHWERR(x).B.HW_WL2_DQ)
/*@}*/

/*!
 * @name Register MMDC_MPWLHWERR, field HW_WL3_DQ[31:24] (RO)
 *
 * HW write-leveling calibration result of Byte3. This field holds the results
 * for all the 8 write-leveling steps of Byte3. i.e. bit 0 holds the result of the
 * write-leveling calibration of 0 delay, bit 1holds the result of the
 * write-leveling calibration of 1/8delay till bit 7 that holds the result of the
 * write-leveling calibration of 7/8 delay
 */
/*@{*/
#define BP_MMDC_MPWLHWERR_HW_WL3_DQ (24U)  /*!< Bit position for MMDC_MPWLHWERR_HW_WL3_DQ. */
#define BM_MMDC_MPWLHWERR_HW_WL3_DQ (0xFF000000U) /*!< Bit mask for MMDC_MPWLHWERR_HW_WL3_DQ. */
#define BS_MMDC_MPWLHWERR_HW_WL3_DQ (8U)   /*!< Bit field size in bits for MMDC_MPWLHWERR_HW_WL3_DQ. */

/*! @brief Read current value of the MMDC_MPWLHWERR_HW_WL3_DQ field. */
#define BR_MMDC_MPWLHWERR_HW_WL3_DQ(x) (HW_MMDC_MPWLHWERR(x).B.HW_WL3_DQ)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGHWST0 - MMDC PHY Read DQS Gating HW Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGHWST0 - MMDC PHY Read DQS Gating HW Status Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdghwst0
{
    uint32_t U;
    struct _hw_mmdc_mpdghwst0_bitfields
    {
        uint32_t HW_DG_LOW0 : 11;      /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t HW_DG_UP0 : 11;       /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpdghwst0_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGHWST0 register
 */
/*@{*/
#define HW_MMDC_MPDGHWST0_ADDR(x) ((uintptr_t)(x) + 0x87CU)

#define HW_MMDC_MPDGHWST0(x)     (*(__I hw_mmdc_mpdghwst0_t *) HW_MMDC_MPDGHWST0_ADDR(x))
#define HW_MMDC_MPDGHWST0_RD(x)  (HW_MMDC_MPDGHWST0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGHWST0 bitfields
 */

/*!
 * @name Register MMDC_MPDGHWST0, field HW_DG_LOW0[10:0] (RO)
 *
 * HW DQS gating calibration result of the lower boundary of Byte0. This field
 * holds the HW DQS gating calibration result of the lower boundary of Byte0.
 */
/*@{*/
#define BP_MMDC_MPDGHWST0_HW_DG_LOW0 (0U)  /*!< Bit position for MMDC_MPDGHWST0_HW_DG_LOW0. */
#define BM_MMDC_MPDGHWST0_HW_DG_LOW0 (0x000007FFU) /*!< Bit mask for MMDC_MPDGHWST0_HW_DG_LOW0. */
#define BS_MMDC_MPDGHWST0_HW_DG_LOW0 (11U) /*!< Bit field size in bits for MMDC_MPDGHWST0_HW_DG_LOW0. */

/*! @brief Read current value of the MMDC_MPDGHWST0_HW_DG_LOW0 field. */
#define BR_MMDC_MPDGHWST0_HW_DG_LOW0(x) (HW_MMDC_MPDGHWST0(x).B.HW_DG_LOW0)
/*@}*/

/*!
 * @name Register MMDC_MPDGHWST0, field HW_DG_UP0[26:16] (RO)
 *
 * HW DQS gating calibration result of the upper boundary of Byte0. This field
 * holds the HW DQS gating calibration result of the upper boundary of Byte0.
 */
/*@{*/
#define BP_MMDC_MPDGHWST0_HW_DG_UP0 (16U)  /*!< Bit position for MMDC_MPDGHWST0_HW_DG_UP0. */
#define BM_MMDC_MPDGHWST0_HW_DG_UP0 (0x07FF0000U) /*!< Bit mask for MMDC_MPDGHWST0_HW_DG_UP0. */
#define BS_MMDC_MPDGHWST0_HW_DG_UP0 (11U)  /*!< Bit field size in bits for MMDC_MPDGHWST0_HW_DG_UP0. */

/*! @brief Read current value of the MMDC_MPDGHWST0_HW_DG_UP0 field. */
#define BR_MMDC_MPDGHWST0_HW_DG_UP0(x) (HW_MMDC_MPDGHWST0(x).B.HW_DG_UP0)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGHWST1 - MMDC PHY Read DQS Gating HW Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGHWST1 - MMDC PHY Read DQS Gating HW Status Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdghwst1
{
    uint32_t U;
    struct _hw_mmdc_mpdghwst1_bitfields
    {
        uint32_t HW_DG_LOW1 : 11;      /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t HW_DG_UP1 : 11;       /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpdghwst1_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGHWST1 register
 */
/*@{*/
#define HW_MMDC_MPDGHWST1_ADDR(x) ((uintptr_t)(x) + 0x880U)

#define HW_MMDC_MPDGHWST1(x)     (*(__I hw_mmdc_mpdghwst1_t *) HW_MMDC_MPDGHWST1_ADDR(x))
#define HW_MMDC_MPDGHWST1_RD(x)  (HW_MMDC_MPDGHWST1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGHWST1 bitfields
 */

/*!
 * @name Register MMDC_MPDGHWST1, field HW_DG_LOW1[10:0] (RO)
 *
 * HW DQS gating calibration result of the lower boundary of Byte1. This field
 * holds the HW DQS gating calibration result of the lower boundary of Byte1.
 */
/*@{*/
#define BP_MMDC_MPDGHWST1_HW_DG_LOW1 (0U)  /*!< Bit position for MMDC_MPDGHWST1_HW_DG_LOW1. */
#define BM_MMDC_MPDGHWST1_HW_DG_LOW1 (0x000007FFU) /*!< Bit mask for MMDC_MPDGHWST1_HW_DG_LOW1. */
#define BS_MMDC_MPDGHWST1_HW_DG_LOW1 (11U) /*!< Bit field size in bits for MMDC_MPDGHWST1_HW_DG_LOW1. */

/*! @brief Read current value of the MMDC_MPDGHWST1_HW_DG_LOW1 field. */
#define BR_MMDC_MPDGHWST1_HW_DG_LOW1(x) (HW_MMDC_MPDGHWST1(x).B.HW_DG_LOW1)
/*@}*/

/*!
 * @name Register MMDC_MPDGHWST1, field HW_DG_UP1[26:16] (RO)
 *
 * HW DQS gating calibration result of the upper boundary of Byte1. This field
 * holds the HW DQS gating calibration result of the upper boundary of Byte1.
 */
/*@{*/
#define BP_MMDC_MPDGHWST1_HW_DG_UP1 (16U)  /*!< Bit position for MMDC_MPDGHWST1_HW_DG_UP1. */
#define BM_MMDC_MPDGHWST1_HW_DG_UP1 (0x07FF0000U) /*!< Bit mask for MMDC_MPDGHWST1_HW_DG_UP1. */
#define BS_MMDC_MPDGHWST1_HW_DG_UP1 (11U)  /*!< Bit field size in bits for MMDC_MPDGHWST1_HW_DG_UP1. */

/*! @brief Read current value of the MMDC_MPDGHWST1_HW_DG_UP1 field. */
#define BR_MMDC_MPDGHWST1_HW_DG_UP1(x) (HW_MMDC_MPDGHWST1(x).B.HW_DG_UP1)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGHWST2 - MMDC PHY Read DQS Gating HW Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGHWST2 - MMDC PHY Read DQS Gating HW Status Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdghwst2
{
    uint32_t U;
    struct _hw_mmdc_mpdghwst2_bitfields
    {
        uint32_t HW_DG_LOW2 : 11;      /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t HW_DG_UP2 : 11;       /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpdghwst2_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGHWST2 register
 */
/*@{*/
#define HW_MMDC_MPDGHWST2_ADDR(x) ((uintptr_t)(x) + 0x884U)

#define HW_MMDC_MPDGHWST2(x)     (*(__I hw_mmdc_mpdghwst2_t *) HW_MMDC_MPDGHWST2_ADDR(x))
#define HW_MMDC_MPDGHWST2_RD(x)  (HW_MMDC_MPDGHWST2(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGHWST2 bitfields
 */

/*!
 * @name Register MMDC_MPDGHWST2, field HW_DG_LOW2[10:0] (RO)
 *
 * HW DQS gating calibration result of the lower boundary of Byte2. This field
 * holds the HW DQS gating calibration result of the lower boundary of Byte2.
 */
/*@{*/
#define BP_MMDC_MPDGHWST2_HW_DG_LOW2 (0U)  /*!< Bit position for MMDC_MPDGHWST2_HW_DG_LOW2. */
#define BM_MMDC_MPDGHWST2_HW_DG_LOW2 (0x000007FFU) /*!< Bit mask for MMDC_MPDGHWST2_HW_DG_LOW2. */
#define BS_MMDC_MPDGHWST2_HW_DG_LOW2 (11U) /*!< Bit field size in bits for MMDC_MPDGHWST2_HW_DG_LOW2. */

/*! @brief Read current value of the MMDC_MPDGHWST2_HW_DG_LOW2 field. */
#define BR_MMDC_MPDGHWST2_HW_DG_LOW2(x) (HW_MMDC_MPDGHWST2(x).B.HW_DG_LOW2)
/*@}*/

/*!
 * @name Register MMDC_MPDGHWST2, field HW_DG_UP2[26:16] (RO)
 *
 * HW DQS gating calibration result of the upper boundary of Byte2. This field
 * holds the HW DQS gating calibration result of the upper boundary of Byte2.
 */
/*@{*/
#define BP_MMDC_MPDGHWST2_HW_DG_UP2 (16U)  /*!< Bit position for MMDC_MPDGHWST2_HW_DG_UP2. */
#define BM_MMDC_MPDGHWST2_HW_DG_UP2 (0x07FF0000U) /*!< Bit mask for MMDC_MPDGHWST2_HW_DG_UP2. */
#define BS_MMDC_MPDGHWST2_HW_DG_UP2 (11U)  /*!< Bit field size in bits for MMDC_MPDGHWST2_HW_DG_UP2. */

/*! @brief Read current value of the MMDC_MPDGHWST2_HW_DG_UP2 field. */
#define BR_MMDC_MPDGHWST2_HW_DG_UP2(x) (HW_MMDC_MPDGHWST2(x).B.HW_DG_UP2)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDGHWST3 - MMDC PHY Read DQS Gating HW Status Register 3
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDGHWST3 - MMDC PHY Read DQS Gating HW Status Register 3 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: DDR3_x16, DDR3_x32, DDR3_x64 For
 * Channel 1: DDR3_x64
 */
typedef union _hw_mmdc_mpdghwst3
{
    uint32_t U;
    struct _hw_mmdc_mpdghwst3_bitfields
    {
        uint32_t HW_DG_LOW3 : 11;      /*!< [10:0]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t HW_DG_UP3 : 11;       /*!< [26:16]  */
        uint32_t RESERVED1 : 5;        /*!< [31:27]  */
    } B;
} hw_mmdc_mpdghwst3_t;

/*!
 * @name Constants and macros for entire MMDC_MPDGHWST3 register
 */
/*@{*/
#define HW_MMDC_MPDGHWST3_ADDR(x) ((uintptr_t)(x) + 0x888U)

#define HW_MMDC_MPDGHWST3(x)     (*(__I hw_mmdc_mpdghwst3_t *) HW_MMDC_MPDGHWST3_ADDR(x))
#define HW_MMDC_MPDGHWST3_RD(x)  (HW_MMDC_MPDGHWST3(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDGHWST3 bitfields
 */

/*!
 * @name Register MMDC_MPDGHWST3, field HW_DG_LOW3[10:0] (RO)
 *
 * HW DQS gating calibration result of the lower boundary of Byte3. This field
 * holds the HW DQS gating calibration result of the lower boundary of Byte3.
 */
/*@{*/
#define BP_MMDC_MPDGHWST3_HW_DG_LOW3 (0U)  /*!< Bit position for MMDC_MPDGHWST3_HW_DG_LOW3. */
#define BM_MMDC_MPDGHWST3_HW_DG_LOW3 (0x000007FFU) /*!< Bit mask for MMDC_MPDGHWST3_HW_DG_LOW3. */
#define BS_MMDC_MPDGHWST3_HW_DG_LOW3 (11U) /*!< Bit field size in bits for MMDC_MPDGHWST3_HW_DG_LOW3. */

/*! @brief Read current value of the MMDC_MPDGHWST3_HW_DG_LOW3 field. */
#define BR_MMDC_MPDGHWST3_HW_DG_LOW3(x) (HW_MMDC_MPDGHWST3(x).B.HW_DG_LOW3)
/*@}*/

/*!
 * @name Register MMDC_MPDGHWST3, field HW_DG_UP3[26:16] (RO)
 *
 * HW DQS gating calibration result of the upper boundary of Byte3. This field
 * holds the HW DQS gating calibration result of the upper boundary of Byte3.
 */
/*@{*/
#define BP_MMDC_MPDGHWST3_HW_DG_UP3 (16U)  /*!< Bit position for MMDC_MPDGHWST3_HW_DG_UP3. */
#define BM_MMDC_MPDGHWST3_HW_DG_UP3 (0x07FF0000U) /*!< Bit mask for MMDC_MPDGHWST3_HW_DG_UP3. */
#define BS_MMDC_MPDGHWST3_HW_DG_UP3 (11U)  /*!< Bit field size in bits for MMDC_MPDGHWST3_HW_DG_UP3. */

/*! @brief Read current value of the MMDC_MPDGHWST3_HW_DG_UP3 field. */
#define BR_MMDC_MPDGHWST3_HW_DG_UP3(x) (HW_MMDC_MPDGHWST3(x).B.HW_DG_UP3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPPDCMPR1 - MMDC PHY Pre-defined Compare Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPPDCMPR1 - MMDC PHY Pre-defined Compare Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register holds the MMDC pre-defined compare value that will be used
 * during automatic read, read DQS gating and write calibration process. The compare
 * value can be the MPR value (as defined in the JEDEC) or can be programmed by
 * the PDV1 and PDV2 fields. In case of DDR3 (BL=8) the MMDC will duplicate
 * PDV1,PDV2 and drive that data on Beat4-7 of the same byte Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mppdcmpr1
{
    uint32_t U;
    struct _hw_mmdc_mppdcmpr1_bitfields
    {
        uint32_t PDV1 : 16;            /*!< [15:0]  */
        uint32_t PDV2 : 16;            /*!< [31:16]  */
    } B;
} hw_mmdc_mppdcmpr1_t;

/*!
 * @name Constants and macros for entire MMDC_MPPDCMPR1 register
 */
/*@{*/
#define HW_MMDC_MPPDCMPR1_ADDR(x) ((uintptr_t)(x) + 0x88CU)

#define HW_MMDC_MPPDCMPR1(x)     (*(__IO hw_mmdc_mppdcmpr1_t *) HW_MMDC_MPPDCMPR1_ADDR(x))
#define HW_MMDC_MPPDCMPR1_RD(x)  (HW_MMDC_MPPDCMPR1(x).U)
#define HW_MMDC_MPPDCMPR1_WR(x, v) (HW_MMDC_MPPDCMPR1(x).U = (v))
#define HW_MMDC_MPPDCMPR1_SET(x, v) (HW_MMDC_MPPDCMPR1_WR(x, HW_MMDC_MPPDCMPR1_RD(x) |  (v)))
#define HW_MMDC_MPPDCMPR1_CLR(x, v) (HW_MMDC_MPPDCMPR1_WR(x, HW_MMDC_MPPDCMPR1_RD(x) & ~(v)))
#define HW_MMDC_MPPDCMPR1_TOG(x, v) (HW_MMDC_MPPDCMPR1_WR(x, HW_MMDC_MPPDCMPR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPPDCMPR1 bitfields
 */

/*!
 * @name Register MMDC_MPPDCMPR1, field PDV1[15:0] (RW)
 *
 * MMDC Pre defined compare value2. This field holds the 2 LSB of the data that
 * will be driven to the DDR device during automatic read, read DQS gating and
 * write calibrations in case MPR(DDR3)/ DQ calibration (LPDDR2) mode are disabled
 * (MPR_CMP is disabled). Upon read access during the calibration the MMDC will
 * compare the read data with the data that is stored in this field. Before
 * issuing the read access, the MMDC will invert the value of this field and drive it
 * to the associated entry in the read comparison FIFO.
 */
/*@{*/
#define BP_MMDC_MPPDCMPR1_PDV1 (0U)        /*!< Bit position for MMDC_MPPDCMPR1_PDV1. */
#define BM_MMDC_MPPDCMPR1_PDV1 (0x0000FFFFU) /*!< Bit mask for MMDC_MPPDCMPR1_PDV1. */
#define BS_MMDC_MPPDCMPR1_PDV1 (16U)       /*!< Bit field size in bits for MMDC_MPPDCMPR1_PDV1. */

/*! @brief Read current value of the MMDC_MPPDCMPR1_PDV1 field. */
#define BR_MMDC_MPPDCMPR1_PDV1(x) (HW_MMDC_MPPDCMPR1(x).B.PDV1)

/*! @brief Format value for bitfield MMDC_MPPDCMPR1_PDV1. */
#define BF_MMDC_MPPDCMPR1_PDV1(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR1_PDV1) & BM_MMDC_MPPDCMPR1_PDV1)

/*! @brief Set the PDV1 field to a new value. */
#define BW_MMDC_MPPDCMPR1_PDV1(x, v) (HW_MMDC_MPPDCMPR1_WR(x, (HW_MMDC_MPPDCMPR1_RD(x) & ~BM_MMDC_MPPDCMPR1_PDV1) | BF_MMDC_MPPDCMPR1_PDV1(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR1, field PDV2[31:16] (RW)
 *
 * MMDC Pre defined compare value2. This field holds the 2 MSB of the data that
 * will be driven to the DDR device during automatic read, read DQS gating and
 * write calibrations in case MPR(DDR3)/ DQ calibration (LPDDR2) mode are disabled
 * (MPR_CMP is disabled). Upon read access during the calibration the MMDC will
 * compare the read data with the data that is stored in this field. Note : Before
 * issue the read access the MMDC will invert the value of this field and drive
 * it to the associate entry in the read comparison FIFO. For further information
 * see Section 19.14.3.1.2, "Calibration with pre-defined value , Section
 * 19.14.4.1.2, "Calibration with pre-defined value and Section 19.14.5.1, "HW
 * (automatic) Write Calibration
 */
/*@{*/
#define BP_MMDC_MPPDCMPR1_PDV2 (16U)       /*!< Bit position for MMDC_MPPDCMPR1_PDV2. */
#define BM_MMDC_MPPDCMPR1_PDV2 (0xFFFF0000U) /*!< Bit mask for MMDC_MPPDCMPR1_PDV2. */
#define BS_MMDC_MPPDCMPR1_PDV2 (16U)       /*!< Bit field size in bits for MMDC_MPPDCMPR1_PDV2. */

/*! @brief Read current value of the MMDC_MPPDCMPR1_PDV2 field. */
#define BR_MMDC_MPPDCMPR1_PDV2(x) (HW_MMDC_MPPDCMPR1(x).B.PDV2)

/*! @brief Format value for bitfield MMDC_MPPDCMPR1_PDV2. */
#define BF_MMDC_MPPDCMPR1_PDV2(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR1_PDV2) & BM_MMDC_MPPDCMPR1_PDV2)

/*! @brief Set the PDV2 field to a new value. */
#define BW_MMDC_MPPDCMPR1_PDV2(x, v) (HW_MMDC_MPPDCMPR1_WR(x, (HW_MMDC_MPPDCMPR1_RD(x) & ~BM_MMDC_MPPDCMPR1_PDV2) | BF_MMDC_MPPDCMPR1_PDV2(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPPDCMPR2 - MMDC PHY Pre-defined Compare and CA delay-line Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPPDCMPR2 - MMDC PHY Pre-defined Compare and CA delay-line Configuration Register (RW)
 *
 * Reset value: 0x00400000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mppdcmpr2
{
    uint32_t U;
    struct _hw_mmdc_mppdcmpr2_bitfields
    {
        uint32_t MPR_CMP : 1;          /*!< [0]  */
        uint32_t MPR_FULL_CMP : 1;     /*!< [1]  */
        uint32_t READ_LEVEL_PATTERN : 1; /*!< [2]  */
        uint32_t ZQ_OFFSET_EN : 1;     /*!< [3]  */
        uint32_t ZQ_PD_OFFSET : 4;     /*!< [7:4]  */
        uint32_t ZQ_PU_OFFSET : 4;     /*!< [11:8]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t CA_DL_ABS_OFFSET : 7; /*!< [22:16]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t PHY_CA_DL_UNIT : 7;   /*!< [30:24]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mppdcmpr2_t;

/*!
 * @name Constants and macros for entire MMDC_MPPDCMPR2 register
 */
/*@{*/
#define HW_MMDC_MPPDCMPR2_ADDR(x) ((uintptr_t)(x) + 0x890U)

#define HW_MMDC_MPPDCMPR2(x)     (*(__IO hw_mmdc_mppdcmpr2_t *) HW_MMDC_MPPDCMPR2_ADDR(x))
#define HW_MMDC_MPPDCMPR2_RD(x)  (HW_MMDC_MPPDCMPR2(x).U)
#define HW_MMDC_MPPDCMPR2_WR(x, v) (HW_MMDC_MPPDCMPR2(x).U = (v))
#define HW_MMDC_MPPDCMPR2_SET(x, v) (HW_MMDC_MPPDCMPR2_WR(x, HW_MMDC_MPPDCMPR2_RD(x) |  (v)))
#define HW_MMDC_MPPDCMPR2_CLR(x, v) (HW_MMDC_MPPDCMPR2_WR(x, HW_MMDC_MPPDCMPR2_RD(x) & ~(v)))
#define HW_MMDC_MPPDCMPR2_TOG(x, v) (HW_MMDC_MPPDCMPR2_WR(x, HW_MMDC_MPPDCMPR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPPDCMPR2 bitfields
 */

/*!
 * @name Register MMDC_MPPDCMPR2, field MPR_CMP[0] (RW)
 *
 * MPR(DDR3)/DQ calibration (LPDDR2) compare enable. This bit indicates whether
 * the MMDC will compare the read data during automatic read and read DQS
 * calibration processes to the pre-defined patterns that are driven by the DDR device
 * (READ_LEVEL_PATTERN as defined by JEDEC) or general pre-defined value that are
 * stored in PDV1 and PDV2. When this bit is disabled data is compared to the
 * data of the pre defined compare value field For further information see Read DQS
 * Gating CalibrationThe read DQS gating calibration is used to adjust the read
 * DQS gating with the middle of the read DQS preamble. and Read Calibration The
 * read calibration is used to adjust the read DQS with read data byte. .
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_MPR_CMP (0U)     /*!< Bit position for MMDC_MPPDCMPR2_MPR_CMP. */
#define BM_MMDC_MPPDCMPR2_MPR_CMP (0x00000001U) /*!< Bit mask for MMDC_MPPDCMPR2_MPR_CMP. */
#define BS_MMDC_MPPDCMPR2_MPR_CMP (1U)     /*!< Bit field size in bits for MMDC_MPPDCMPR2_MPR_CMP. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_MPR_CMP field. */
#define BR_MMDC_MPPDCMPR2_MPR_CMP(x) (HW_MMDC_MPPDCMPR2(x).B.MPR_CMP)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_MPR_CMP. */
#define BF_MMDC_MPPDCMPR2_MPR_CMP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_MPR_CMP) & BM_MMDC_MPPDCMPR2_MPR_CMP)

/*! @brief Set the MPR_CMP field to a new value. */
#define BW_MMDC_MPPDCMPR2_MPR_CMP(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_MPR_CMP) | BF_MMDC_MPPDCMPR2_MPR_CMP(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field MPR_FULL_CMP[1] (RW)
 *
 * MPR(DDR3)/DQ calibration (LPDDR2) full compare enable. In case MPR(DDR3)/DQ
 * calibration(LPDDR2) modes are used during the calibration process (MPR_CMP is
 * asserted) then this field indicates whether the MMDC will compare all the bits
 * of the data that is read from the DDR device to the MPR pre-defined pattern.
 * When this bit is de-asserted only LSB of each byte is compared.
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_MPR_FULL_CMP (1U) /*!< Bit position for MMDC_MPPDCMPR2_MPR_FULL_CMP. */
#define BM_MMDC_MPPDCMPR2_MPR_FULL_CMP (0x00000002U) /*!< Bit mask for MMDC_MPPDCMPR2_MPR_FULL_CMP. */
#define BS_MMDC_MPPDCMPR2_MPR_FULL_CMP (1U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_MPR_FULL_CMP. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_MPR_FULL_CMP field. */
#define BR_MMDC_MPPDCMPR2_MPR_FULL_CMP(x) (HW_MMDC_MPPDCMPR2(x).B.MPR_FULL_CMP)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_MPR_FULL_CMP. */
#define BF_MMDC_MPPDCMPR2_MPR_FULL_CMP(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_MPR_FULL_CMP) & BM_MMDC_MPPDCMPR2_MPR_FULL_CMP)

/*! @brief Set the MPR_FULL_CMP field to a new value. */
#define BW_MMDC_MPPDCMPR2_MPR_FULL_CMP(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_MPR_FULL_CMP) | BF_MMDC_MPPDCMPR2_MPR_FULL_CMP(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field READ_LEVEL_PATTERN[2] (RW)
 *
 * MPR(DDR3)/DQ calibration(LPDDR2) read compare pattern. In case MPR(DDR3)/DQ
 * calibration(LPDDR2) modes are used during the calibration process (MPR_CMP is
 * asserted) then this field indicates the read pattern for the comparison.
 *
 * Values:
 * - 0 - Compare with read pattern 1010
 * - 1 - Compare with read pattern 0011 (Used only in LPDDR2 mode)
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN (2U) /*!< Bit position for MMDC_MPPDCMPR2_READ_LEVEL_PATTERN. */
#define BM_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN (0x00000004U) /*!< Bit mask for MMDC_MPPDCMPR2_READ_LEVEL_PATTERN. */
#define BS_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN (1U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_READ_LEVEL_PATTERN. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_READ_LEVEL_PATTERN field. */
#define BR_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN(x) (HW_MMDC_MPPDCMPR2(x).B.READ_LEVEL_PATTERN)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_READ_LEVEL_PATTERN. */
#define BF_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN) & BM_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN)

/*! @brief Set the READ_LEVEL_PATTERN field to a new value. */
#define BW_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN) | BF_MMDC_MPPDCMPR2_READ_LEVEL_PATTERN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field ZQ_OFFSET_EN[3] (RW)
 *
 * Values:
 * - 0 - Hardware ZQ offset disabled
 * - 1 - Hardware ZQ offset enabled
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_ZQ_OFFSET_EN (3U) /*!< Bit position for MMDC_MPPDCMPR2_ZQ_OFFSET_EN. */
#define BM_MMDC_MPPDCMPR2_ZQ_OFFSET_EN (0x00000008U) /*!< Bit mask for MMDC_MPPDCMPR2_ZQ_OFFSET_EN. */
#define BS_MMDC_MPPDCMPR2_ZQ_OFFSET_EN (1U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_ZQ_OFFSET_EN. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_ZQ_OFFSET_EN field. */
#define BR_MMDC_MPPDCMPR2_ZQ_OFFSET_EN(x) (HW_MMDC_MPPDCMPR2(x).B.ZQ_OFFSET_EN)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_ZQ_OFFSET_EN. */
#define BF_MMDC_MPPDCMPR2_ZQ_OFFSET_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_ZQ_OFFSET_EN) & BM_MMDC_MPPDCMPR2_ZQ_OFFSET_EN)

/*! @brief Set the ZQ_OFFSET_EN field to a new value. */
#define BW_MMDC_MPPDCMPR2_ZQ_OFFSET_EN(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_ZQ_OFFSET_EN) | BF_MMDC_MPPDCMPR2_ZQ_OFFSET_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field ZQ_PD_OFFSET[7:4] (RW)
 *
 * Programmable offset from -7 to 7 added to the MMDC_MPZQHWCTRL[ZQ_HW_PD_RES]
 * field when ZQ_OFFSET_EN is enabled. Bit[7] determines direction: 'b0 = Offset
 * is added to ZQ_HW_PD_RES field 'b1 = Offset is subtracted from ZQ_HW_PD_RES
 * field Bits[6:4] = Amount of change to apply.
 *
 * Values:
 * - 0000 - Offset is added to ZQ_HW_PD_RES field
 * - 0001 - Offset is added to ZQ_HW_PD_RES field
 * - 0010 - Offset is added to ZQ_HW_PD_RES field
 * - 0011 - Offset is added to ZQ_HW_PD_RES field
 * - 0100 - Offset is added to ZQ_HW_PD_RES field
 * - 0101 - Offset is added to ZQ_HW_PD_RES field
 * - 0110 - Offset is added to ZQ_HW_PD_RES field
 * - 0111 - Offset is added to ZQ_HW_PD_RES field
 * - 1000 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1001 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1010 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1011 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1100 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1101 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1110 - Offset is subtracted from ZQ_HW_PD_RES field
 * - 1111 - Offset is subtracted from ZQ_HW_PD_RES field
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_ZQ_PD_OFFSET (4U) /*!< Bit position for MMDC_MPPDCMPR2_ZQ_PD_OFFSET. */
#define BM_MMDC_MPPDCMPR2_ZQ_PD_OFFSET (0x000000F0U) /*!< Bit mask for MMDC_MPPDCMPR2_ZQ_PD_OFFSET. */
#define BS_MMDC_MPPDCMPR2_ZQ_PD_OFFSET (4U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_ZQ_PD_OFFSET. */

#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_0 (0U)        /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_1 (0x1U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_2 (0x2U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_3 (0x3U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_4 (0x4U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_5 (0x5U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_6 (0x6U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PD_OFFSET_7 (0x7U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PD_OFFSET: Offset is added to ZQ_HW_PD_RES field */

/*! @brief Read current value of the MMDC_MPPDCMPR2_ZQ_PD_OFFSET field. */
#define BR_MMDC_MPPDCMPR2_ZQ_PD_OFFSET(x) (HW_MMDC_MPPDCMPR2(x).B.ZQ_PD_OFFSET)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_ZQ_PD_OFFSET. */
#define BF_MMDC_MPPDCMPR2_ZQ_PD_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_ZQ_PD_OFFSET) & BM_MMDC_MPPDCMPR2_ZQ_PD_OFFSET)

/*! @brief Set the ZQ_PD_OFFSET field to a new value. */
#define BW_MMDC_MPPDCMPR2_ZQ_PD_OFFSET(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_ZQ_PD_OFFSET) | BF_MMDC_MPPDCMPR2_ZQ_PD_OFFSET(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field ZQ_PU_OFFSET[11:8] (RW)
 *
 * Programmable offset from -7 to 7 added to the MMDC_MPZQHWCTRL[ZQ_HW_PU_RES]
 * field when ZQ_OFFSET_EN is enabled. Bit[11] determines direction: 'b0 = Offset
 * is added to ZQ_HW_PU_RES field 'b1 = Offset is subtracted from ZQ_HW_PU_RES
 * field Bits[10:8] = Amount of change to apply.
 *
 * Values:
 * - 0000 - Offset is added to ZQ_HW_PU_RES field
 * - 0001 - Offset is added to ZQ_HW_PU_RES field
 * - 0010 - Offset is added to ZQ_HW_PU_RES field
 * - 0011 - Offset is added to ZQ_HW_PU_RES field
 * - 0100 - Offset is added to ZQ_HW_PU_RES field
 * - 0101 - Offset is added to ZQ_HW_PU_RES field
 * - 0110 - Offset is added to ZQ_HW_PU_RES field
 * - 0111 - Offset is added to ZQ_HW_PU_RES field
 * - 1000 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1001 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1010 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1011 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1100 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1101 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1110 - Offset is subtracted from ZQ_HW_PU_RES field
 * - 1111 - Offset is subtracted from ZQ_HW_PU_RES field
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_ZQ_PU_OFFSET (8U) /*!< Bit position for MMDC_MPPDCMPR2_ZQ_PU_OFFSET. */
#define BM_MMDC_MPPDCMPR2_ZQ_PU_OFFSET (0x00000F00U) /*!< Bit mask for MMDC_MPPDCMPR2_ZQ_PU_OFFSET. */
#define BS_MMDC_MPPDCMPR2_ZQ_PU_OFFSET (4U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_ZQ_PU_OFFSET. */

#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_0 (0U)        /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_1 (0x1U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_2 (0x2U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_3 (0x3U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_4 (0x4U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_5 (0x5U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_6 (0x6U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */
#define BV_MMDC_MPPDCMPR2_ZQ_PU_OFFSET_7 (0x7U)      /*!< Bit field value for MMDC_MPPDCMPR2_ZQ_PU_OFFSET: Offset is added to ZQ_HW_PU_RES field */

/*! @brief Read current value of the MMDC_MPPDCMPR2_ZQ_PU_OFFSET field. */
#define BR_MMDC_MPPDCMPR2_ZQ_PU_OFFSET(x) (HW_MMDC_MPPDCMPR2(x).B.ZQ_PU_OFFSET)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_ZQ_PU_OFFSET. */
#define BF_MMDC_MPPDCMPR2_ZQ_PU_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_ZQ_PU_OFFSET) & BM_MMDC_MPPDCMPR2_ZQ_PU_OFFSET)

/*! @brief Set the ZQ_PU_OFFSET field to a new value. */
#define BW_MMDC_MPPDCMPR2_ZQ_PU_OFFSET(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_ZQ_PU_OFFSET) | BF_MMDC_MPPDCMPR2_ZQ_PU_OFFSET(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field CA_DL_ABS_OFFSET[22:16] (RW)
 *
 * Absolute CA (Command/Address of LPDDRR2) offset. This field indicates the
 * absolute delay between CA (Command/Address) bus and the DDR clock (CK) with
 * fractions of a clock period and up to half cycle. The fraction is process and
 * frequency independent. The delay of the delay-line would be (CA_DL_ABS_OFFSET /
 * 256) * MMDC_CH0 AXI clock (fast clock). So for the default value of 64 we get a
 * quarter cycle delay.
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET (16U) /*!< Bit position for MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET. */
#define BM_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET (0x007F0000U) /*!< Bit mask for MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET. */
#define BS_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET (7U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET field. */
#define BR_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET(x) (HW_MMDC_MPPDCMPR2(x).B.CA_DL_ABS_OFFSET)

/*! @brief Format value for bitfield MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET. */
#define BF_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET) & BM_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET)

/*! @brief Set the CA_DL_ABS_OFFSET field to a new value. */
#define BW_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET(x, v) (HW_MMDC_MPPDCMPR2_WR(x, (HW_MMDC_MPPDCMPR2_RD(x) & ~BM_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET) | BF_MMDC_MPPDCMPR2_CA_DL_ABS_OFFSET(v)))
/*@}*/

/*!
 * @name Register MMDC_MPPDCMPR2, field PHY_CA_DL_UNIT[30:24] (RO)
 *
 * This field reflects the number of delay units that are actually used by CA
 * (Command/Address of LPDDR2) delay-line
 */
/*@{*/
#define BP_MMDC_MPPDCMPR2_PHY_CA_DL_UNIT (24U) /*!< Bit position for MMDC_MPPDCMPR2_PHY_CA_DL_UNIT. */
#define BM_MMDC_MPPDCMPR2_PHY_CA_DL_UNIT (0x7F000000U) /*!< Bit mask for MMDC_MPPDCMPR2_PHY_CA_DL_UNIT. */
#define BS_MMDC_MPPDCMPR2_PHY_CA_DL_UNIT (7U) /*!< Bit field size in bits for MMDC_MPPDCMPR2_PHY_CA_DL_UNIT. */

/*! @brief Read current value of the MMDC_MPPDCMPR2_PHY_CA_DL_UNIT field. */
#define BR_MMDC_MPPDCMPR2_PHY_CA_DL_UNIT(x) (HW_MMDC_MPPDCMPR2(x).B.PHY_CA_DL_UNIT)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDAR0 - MMDC PHY SW Dummy Access Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDAR0 - MMDC PHY SW Dummy Access Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdar0
{
    uint32_t U;
    struct _hw_mmdc_mpswdar0_bitfields
    {
        uint32_t SW_DUMMY_WR : 1;      /*!< [0]  */
        uint32_t SW_DUMMY_RD : 1;      /*!< [1]  */
        uint32_t SW_DUM_CMP0 : 1;      /*!< [2]  */
        uint32_t SW_DUM_CMP1 : 1;      /*!< [3]  */
        uint32_t SW_DUM_CMP2 : 1;      /*!< [4]  */
        uint32_t SW_DUM_CMP3 : 1;      /*!< [5]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_mmdc_mpswdar0_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDAR0 register
 */
/*@{*/
#define HW_MMDC_MPSWDAR0_ADDR(x) ((uintptr_t)(x) + 0x894U)

#define HW_MMDC_MPSWDAR0(x)      (*(__IO hw_mmdc_mpswdar0_t *) HW_MMDC_MPSWDAR0_ADDR(x))
#define HW_MMDC_MPSWDAR0_RD(x)   (HW_MMDC_MPSWDAR0(x).U)
#define HW_MMDC_MPSWDAR0_WR(x, v) (HW_MMDC_MPSWDAR0(x).U = (v))
#define HW_MMDC_MPSWDAR0_SET(x, v) (HW_MMDC_MPSWDAR0_WR(x, HW_MMDC_MPSWDAR0_RD(x) |  (v)))
#define HW_MMDC_MPSWDAR0_CLR(x, v) (HW_MMDC_MPSWDAR0_WR(x, HW_MMDC_MPSWDAR0_RD(x) & ~(v)))
#define HW_MMDC_MPSWDAR0_TOG(x, v) (HW_MMDC_MPSWDAR0_WR(x, HW_MMDC_MPSWDAR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDAR0 bitfields
 */

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUMMY_WR[0] (RW)
 *
 * SW dummy write. When this bit is asserted the MMDC will generate internally
 * write access without intervention of the system toward bank 0, row 0, column 0,
 * while the data is driven from MPPDCMPR1[PDV1] and MPPDCMPR1[PDV2]. The bit is
 * de-asserted automatically upon completion of the access.
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUMMY_WR (0U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUMMY_WR. */
#define BM_MMDC_MPSWDAR0_SW_DUMMY_WR (0x00000001U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUMMY_WR. */
#define BS_MMDC_MPSWDAR0_SW_DUMMY_WR (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUMMY_WR. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUMMY_WR field. */
#define BR_MMDC_MPSWDAR0_SW_DUMMY_WR(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUMMY_WR)

/*! @brief Format value for bitfield MMDC_MPSWDAR0_SW_DUMMY_WR. */
#define BF_MMDC_MPSWDAR0_SW_DUMMY_WR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPSWDAR0_SW_DUMMY_WR) & BM_MMDC_MPSWDAR0_SW_DUMMY_WR)

/*! @brief Set the SW_DUMMY_WR field to a new value. */
#define BW_MMDC_MPSWDAR0_SW_DUMMY_WR(x, v) (HW_MMDC_MPSWDAR0_WR(x, (HW_MMDC_MPSWDAR0_RD(x) & ~BM_MMDC_MPSWDAR0_SW_DUMMY_WR) | BF_MMDC_MPSWDAR0_SW_DUMMY_WR(v)))
/*@}*/

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUMMY_RD[1] (RW)
 *
 * SW dummy read. When this bit is asserted the MMDC will generate internally
 * read access without intervention of the system toward bank 0, row 0, column 0.
 * If MPR_CMP = 1then the read data will be compared to
 * MPPDCMPR2[READ_LEVEL_PATTERN] . If MPR_CMP =0 then the read data will be compared to MPPDCMPR1[PDV1],
 * MPPDCMPR1[PDV2]. Upon completion of the access this bit is de-asserted
 * automatically and the read data and comparison results are valid at
 * MPSWDAR0[SW_DUM_CMP#] and MPSWDRDR0-MPSWDRDR7 respectively.
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUMMY_RD (1U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUMMY_RD. */
#define BM_MMDC_MPSWDAR0_SW_DUMMY_RD (0x00000002U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUMMY_RD. */
#define BS_MMDC_MPSWDAR0_SW_DUMMY_RD (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUMMY_RD. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUMMY_RD field. */
#define BR_MMDC_MPSWDAR0_SW_DUMMY_RD(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUMMY_RD)

/*! @brief Format value for bitfield MMDC_MPSWDAR0_SW_DUMMY_RD. */
#define BF_MMDC_MPSWDAR0_SW_DUMMY_RD(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPSWDAR0_SW_DUMMY_RD) & BM_MMDC_MPSWDAR0_SW_DUMMY_RD)

/*! @brief Set the SW_DUMMY_RD field to a new value. */
#define BW_MMDC_MPSWDAR0_SW_DUMMY_RD(x, v) (HW_MMDC_MPSWDAR0_WR(x, (HW_MMDC_MPSWDAR0_RD(x) & ~BM_MMDC_MPSWDAR0_SW_DUMMY_RD) | BF_MMDC_MPSWDAR0_SW_DUMMY_RD(v)))
/*@}*/

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUM_CMP0[2] (RO)
 *
 * SW dummy read byte0 compare results. This bit indicates the result of the
 * read data comparison of Byte0 at the completion of SW_DUMMY_RD. This bit is valid
 * only when SW_DUMMY_RD is de-assrted.
 *
 * Values:
 * - 0 - Dummy read fail
 * - 1 - Dummy read pass
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUM_CMP0 (2U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUM_CMP0. */
#define BM_MMDC_MPSWDAR0_SW_DUM_CMP0 (0x00000004U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUM_CMP0. */
#define BS_MMDC_MPSWDAR0_SW_DUM_CMP0 (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUM_CMP0. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUM_CMP0 field. */
#define BR_MMDC_MPSWDAR0_SW_DUM_CMP0(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUM_CMP0)
/*@}*/

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUM_CMP1[3] (RO)
 *
 * SW dummy read byte1 compare results. This bit indicates the result of the
 * read data comparison of Byte1 at the completion of SW_DUMMY_RD. This bit is valid
 * only when SW_DUMMY_RD is de-assrted.
 *
 * Values:
 * - 0 - Dummy read fail
 * - 1 - Dummy read pass
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUM_CMP1 (3U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUM_CMP1. */
#define BM_MMDC_MPSWDAR0_SW_DUM_CMP1 (0x00000008U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUM_CMP1. */
#define BS_MMDC_MPSWDAR0_SW_DUM_CMP1 (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUM_CMP1. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUM_CMP1 field. */
#define BR_MMDC_MPSWDAR0_SW_DUM_CMP1(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUM_CMP1)
/*@}*/

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUM_CMP2[4] (RO)
 *
 * SW dummy read byte2 compare results. This bit indicates the result of the
 * read data comparison of Byte2 at the completion of SW_DUMMY_RD. This bit is valid
 * only when SW_DUMMY_RD is de-assrted.
 *
 * Values:
 * - 0 - Dummy read fail
 * - 1 - Dummy read pass
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUM_CMP2 (4U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUM_CMP2. */
#define BM_MMDC_MPSWDAR0_SW_DUM_CMP2 (0x00000010U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUM_CMP2. */
#define BS_MMDC_MPSWDAR0_SW_DUM_CMP2 (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUM_CMP2. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUM_CMP2 field. */
#define BR_MMDC_MPSWDAR0_SW_DUM_CMP2(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUM_CMP2)
/*@}*/

/*!
 * @name Register MMDC_MPSWDAR0, field SW_DUM_CMP3[5] (RO)
 *
 * SW dummy read byte3 compare results. This bit indicates the result of the
 * read data comparison of Byte3 at the completion of SW_DUMMY_RD. This bit is valid
 * only when SW_DUMMY_RD is de-assrted.
 *
 * Values:
 * - 0 - Dummy read fail
 * - 1 - Dummy read pass
 */
/*@{*/
#define BP_MMDC_MPSWDAR0_SW_DUM_CMP3 (5U)  /*!< Bit position for MMDC_MPSWDAR0_SW_DUM_CMP3. */
#define BM_MMDC_MPSWDAR0_SW_DUM_CMP3 (0x00000020U) /*!< Bit mask for MMDC_MPSWDAR0_SW_DUM_CMP3. */
#define BS_MMDC_MPSWDAR0_SW_DUM_CMP3 (1U)  /*!< Bit field size in bits for MMDC_MPSWDAR0_SW_DUM_CMP3. */

/*! @brief Read current value of the MMDC_MPSWDAR0_SW_DUM_CMP3 field. */
#define BR_MMDC_MPSWDAR0_SW_DUM_CMP3(x) (HW_MMDC_MPSWDAR0(x).B.SW_DUM_CMP3)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR0 - MMDC PHY SW Dummy Read Data Register 0
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR0 - MMDC PHY SW Dummy Read Data Register 0 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr0
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr0_bitfields
    {
        uint32_t DUM_RD0 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr0_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR0 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR0_ADDR(x) ((uintptr_t)(x) + 0x898U)

#define HW_MMDC_MPSWDRDR0(x)     (*(__I hw_mmdc_mpswdrdr0_t *) HW_MMDC_MPSWDRDR0_ADDR(x))
#define HW_MMDC_MPSWDRDR0_RD(x)  (HW_MMDC_MPSWDRDR0(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR0 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR0, field DUM_RD0[31:0] (RO)
 *
 * Dummy read data0. This field holds the first data that is read from the DDR
 * during SW dummy read access (i.e. when SW_DUMMY_RD = 1). This field is valid
 * only when SW_DUMMY_RD is de-assrted
 */
/*@{*/
#define BP_MMDC_MPSWDRDR0_DUM_RD0 (0U)     /*!< Bit position for MMDC_MPSWDRDR0_DUM_RD0. */
#define BM_MMDC_MPSWDRDR0_DUM_RD0 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR0_DUM_RD0. */
#define BS_MMDC_MPSWDRDR0_DUM_RD0 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR0_DUM_RD0. */

/*! @brief Read current value of the MMDC_MPSWDRDR0_DUM_RD0 field. */
#define BR_MMDC_MPSWDRDR0_DUM_RD0(x) (HW_MMDC_MPSWDRDR0(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR1 - MMDC PHY SW Dummy Read Data Register 1
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR1 - MMDC PHY SW Dummy Read Data Register 1 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr1
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr1_bitfields
    {
        uint32_t DUM_RD1 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr1_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR1 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR1_ADDR(x) ((uintptr_t)(x) + 0x89CU)

#define HW_MMDC_MPSWDRDR1(x)     (*(__I hw_mmdc_mpswdrdr1_t *) HW_MMDC_MPSWDRDR1_ADDR(x))
#define HW_MMDC_MPSWDRDR1_RD(x)  (HW_MMDC_MPSWDRDR1(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR1 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR1, field DUM_RD1[31:0] (RO)
 *
 * Dummy read data1. This field holds the second data that is read from the DDR
 * during SW dummy read access (i.e. when SW_DUMMY_RD = 1). This field is valid
 * only when SW_DUMMY_RD is de-assrted
 */
/*@{*/
#define BP_MMDC_MPSWDRDR1_DUM_RD1 (0U)     /*!< Bit position for MMDC_MPSWDRDR1_DUM_RD1. */
#define BM_MMDC_MPSWDRDR1_DUM_RD1 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR1_DUM_RD1. */
#define BS_MMDC_MPSWDRDR1_DUM_RD1 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR1_DUM_RD1. */

/*! @brief Read current value of the MMDC_MPSWDRDR1_DUM_RD1 field. */
#define BR_MMDC_MPSWDRDR1_DUM_RD1(x) (HW_MMDC_MPSWDRDR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR2 - MMDC PHY SW Dummy Read Data Register 2
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR2 - MMDC PHY SW Dummy Read Data Register 2 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr2
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr2_bitfields
    {
        uint32_t DUM_RD2 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr2_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR2 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR2_ADDR(x) ((uintptr_t)(x) + 0x8A0U)

#define HW_MMDC_MPSWDRDR2(x)     (*(__I hw_mmdc_mpswdrdr2_t *) HW_MMDC_MPSWDRDR2_ADDR(x))
#define HW_MMDC_MPSWDRDR2_RD(x)  (HW_MMDC_MPSWDRDR2(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR2 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR2, field DUM_RD2[31:0] (RO)
 *
 * Dummy read data2. This field holds the third data that is read from the DDR
 * during SW dummy read access (i.e. when SW_DUMMY_RD = 1). This field is valid
 * only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR2_DUM_RD2 (0U)     /*!< Bit position for MMDC_MPSWDRDR2_DUM_RD2. */
#define BM_MMDC_MPSWDRDR2_DUM_RD2 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR2_DUM_RD2. */
#define BS_MMDC_MPSWDRDR2_DUM_RD2 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR2_DUM_RD2. */

/*! @brief Read current value of the MMDC_MPSWDRDR2_DUM_RD2 field. */
#define BR_MMDC_MPSWDRDR2_DUM_RD2(x) (HW_MMDC_MPSWDRDR2(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR3 - MMDC PHY SW Dummy Read Data Register 3
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR3 - MMDC PHY SW Dummy Read Data Register 3 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr3
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr3_bitfields
    {
        uint32_t DUM_RD3 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr3_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR3 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR3_ADDR(x) ((uintptr_t)(x) + 0x8A4U)

#define HW_MMDC_MPSWDRDR3(x)     (*(__I hw_mmdc_mpswdrdr3_t *) HW_MMDC_MPSWDRDR3_ADDR(x))
#define HW_MMDC_MPSWDRDR3_RD(x)  (HW_MMDC_MPSWDRDR3(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR3 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR3, field DUM_RD3[31:0] (RO)
 *
 * Dummy read data3. This field holds the forth data that is read from the DDR
 * during SW dummy read access (i.e. when SW_DUMMY_RD = 1). This field is valid
 * only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR3_DUM_RD3 (0U)     /*!< Bit position for MMDC_MPSWDRDR3_DUM_RD3. */
#define BM_MMDC_MPSWDRDR3_DUM_RD3 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR3_DUM_RD3. */
#define BS_MMDC_MPSWDRDR3_DUM_RD3 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR3_DUM_RD3. */

/*! @brief Read current value of the MMDC_MPSWDRDR3_DUM_RD3 field. */
#define BR_MMDC_MPSWDRDR3_DUM_RD3(x) (HW_MMDC_MPSWDRDR3(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR4 - MMDC PHY SW Dummy Read Data Register 4
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR4 - MMDC PHY SW Dummy Read Data Register 4 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr4
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr4_bitfields
    {
        uint32_t DUM_RD4 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr4_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR4 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR4_ADDR(x) ((uintptr_t)(x) + 0x8A8U)

#define HW_MMDC_MPSWDRDR4(x)     (*(__I hw_mmdc_mpswdrdr4_t *) HW_MMDC_MPSWDRDR4_ADDR(x))
#define HW_MMDC_MPSWDRDR4_RD(x)  (HW_MMDC_MPSWDRDR4(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR4 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR4, field DUM_RD4[31:0] (RO)
 *
 * Dummy read data4. This field holds the fifth data (only in case of burst
 * length 8 (BL =1 )) that is read from the DDR during SW dummy read access (i.e.
 * when SW_DUMMY_RD = 1). This field is valid only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR4_DUM_RD4 (0U)     /*!< Bit position for MMDC_MPSWDRDR4_DUM_RD4. */
#define BM_MMDC_MPSWDRDR4_DUM_RD4 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR4_DUM_RD4. */
#define BS_MMDC_MPSWDRDR4_DUM_RD4 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR4_DUM_RD4. */

/*! @brief Read current value of the MMDC_MPSWDRDR4_DUM_RD4 field. */
#define BR_MMDC_MPSWDRDR4_DUM_RD4(x) (HW_MMDC_MPSWDRDR4(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR5 - MMDC PHY SW Dummy Read Data Register 5
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR5 - MMDC PHY SW Dummy Read Data Register 5 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr5
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr5_bitfields
    {
        uint32_t DUM_RD5 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr5_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR5 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR5_ADDR(x) ((uintptr_t)(x) + 0x8ACU)

#define HW_MMDC_MPSWDRDR5(x)     (*(__I hw_mmdc_mpswdrdr5_t *) HW_MMDC_MPSWDRDR5_ADDR(x))
#define HW_MMDC_MPSWDRDR5_RD(x)  (HW_MMDC_MPSWDRDR5(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR5 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR5, field DUM_RD5[31:0] (RO)
 *
 * Dummy read data5. This field holds the sixth data (only in case of burst
 * length 8 (BL =1 )) that is read from the DDR during SW dummy read access (i.e.
 * when SW_DUMMY_RD = 1). This field is valid only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR5_DUM_RD5 (0U)     /*!< Bit position for MMDC_MPSWDRDR5_DUM_RD5. */
#define BM_MMDC_MPSWDRDR5_DUM_RD5 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR5_DUM_RD5. */
#define BS_MMDC_MPSWDRDR5_DUM_RD5 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR5_DUM_RD5. */

/*! @brief Read current value of the MMDC_MPSWDRDR5_DUM_RD5 field. */
#define BR_MMDC_MPSWDRDR5_DUM_RD5(x) (HW_MMDC_MPSWDRDR5(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR6 - MMDC PHY SW Dummy Read Data Register 6
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR6 - MMDC PHY SW Dummy Read Data Register 6 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr6
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr6_bitfields
    {
        uint32_t DUM_RD6 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr6_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR6 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR6_ADDR(x) ((uintptr_t)(x) + 0x8B0U)

#define HW_MMDC_MPSWDRDR6(x)     (*(__I hw_mmdc_mpswdrdr6_t *) HW_MMDC_MPSWDRDR6_ADDR(x))
#define HW_MMDC_MPSWDRDR6_RD(x)  (HW_MMDC_MPSWDRDR6(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR6 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR6, field DUM_RD6[31:0] (RO)
 *
 * Dummy read data6. This field holds the seventh data (only in case of burst
 * length 8 (BL =1 )) that is read from the DDR during SW dummy read access (i.e.
 * when SW_DUMMY_RD = 1). This field is valid only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR6_DUM_RD6 (0U)     /*!< Bit position for MMDC_MPSWDRDR6_DUM_RD6. */
#define BM_MMDC_MPSWDRDR6_DUM_RD6 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR6_DUM_RD6. */
#define BS_MMDC_MPSWDRDR6_DUM_RD6 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR6_DUM_RD6. */

/*! @brief Read current value of the MMDC_MPSWDRDR6_DUM_RD6 field. */
#define BR_MMDC_MPSWDRDR6_DUM_RD6(x) (HW_MMDC_MPSWDRDR6(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPSWDRDR7 - MMDC PHY SW Dummy Read Data Register 7
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPSWDRDR7 - MMDC PHY SW Dummy Read Data Register 7 (RO)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: DDR3_x64,
 * LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpswdrdr7
{
    uint32_t U;
    struct _hw_mmdc_mpswdrdr7_bitfields
    {
        uint32_t DUM_RD7 : 32;         /*!< [31:0]  */
    } B;
} hw_mmdc_mpswdrdr7_t;

/*!
 * @name Constants and macros for entire MMDC_MPSWDRDR7 register
 */
/*@{*/
#define HW_MMDC_MPSWDRDR7_ADDR(x) ((uintptr_t)(x) + 0x8B4U)

#define HW_MMDC_MPSWDRDR7(x)     (*(__I hw_mmdc_mpswdrdr7_t *) HW_MMDC_MPSWDRDR7_ADDR(x))
#define HW_MMDC_MPSWDRDR7_RD(x)  (HW_MMDC_MPSWDRDR7(x).U)
/*@}*/

/*
 * Constants & macros for individual MMDC_MPSWDRDR7 bitfields
 */

/*!
 * @name Register MMDC_MPSWDRDR7, field DUM_RD7[31:0] (RO)
 *
 * Dummy read data7. This field holds the eight data (only in case of burst
 * length 8 (BL =1 )) that is read from the DDR during SW dummy read access (i.e.
 * when SW_DUMMY_RD = 1). This field is valid only when SW_DUMMY_RD is de-assrted.
 */
/*@{*/
#define BP_MMDC_MPSWDRDR7_DUM_RD7 (0U)     /*!< Bit position for MMDC_MPSWDRDR7_DUM_RD7. */
#define BM_MMDC_MPSWDRDR7_DUM_RD7 (0xFFFFFFFFU) /*!< Bit mask for MMDC_MPSWDRDR7_DUM_RD7. */
#define BS_MMDC_MPSWDRDR7_DUM_RD7 (32U)    /*!< Bit field size in bits for MMDC_MPSWDRDR7_DUM_RD7. */

/*! @brief Read current value of the MMDC_MPSWDRDR7_DUM_RD7 field. */
#define BR_MMDC_MPSWDRDR7_DUM_RD7(x) (HW_MMDC_MPSWDRDR7(x).U)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPMUR0 - MMDC PHY Measure Unit Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPMUR0 - MMDC PHY Measure Unit Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Supported Mode Of Operations: For Channel 0: All For Channel 1: LP2_2ch_x16,
 * LP2_2ch_x32
 */
typedef union _hw_mmdc_mpmur0
{
    uint32_t U;
    struct _hw_mmdc_mpmur0_bitfields
    {
        uint32_t MU_BYP_VAL : 10;      /*!< [9:0]  */
        uint32_t MU_BYP_EN : 1;        /*!< [10]  */
        uint32_t FRC_MSR : 1;          /*!< [11]  */
        uint32_t RESERVED0 : 4;        /*!< [15:12]  */
        uint32_t MU_UNIT_DEL_NUM : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_mmdc_mpmur0_t;

/*!
 * @name Constants and macros for entire MMDC_MPMUR0 register
 */
/*@{*/
#define HW_MMDC_MPMUR0_ADDR(x)   ((uintptr_t)(x) + 0x8B8U)

#define HW_MMDC_MPMUR0(x)        (*(__IO hw_mmdc_mpmur0_t *) HW_MMDC_MPMUR0_ADDR(x))
#define HW_MMDC_MPMUR0_RD(x)     (HW_MMDC_MPMUR0(x).U)
#define HW_MMDC_MPMUR0_WR(x, v)  (HW_MMDC_MPMUR0(x).U = (v))
#define HW_MMDC_MPMUR0_SET(x, v) (HW_MMDC_MPMUR0_WR(x, HW_MMDC_MPMUR0_RD(x) |  (v)))
#define HW_MMDC_MPMUR0_CLR(x, v) (HW_MMDC_MPMUR0_WR(x, HW_MMDC_MPMUR0_RD(x) & ~(v)))
#define HW_MMDC_MPMUR0_TOG(x, v) (HW_MMDC_MPMUR0_WR(x, HW_MMDC_MPMUR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPMUR0 bitfields
 */

/*!
 * @name Register MMDC_MPMUR0, field MU_BYP_VAL[9:0] (RW)
 *
 * Number of delay units for measurement bypass. This field is used in debug
 * mode and holds the number of delay units that will be used by the delay-lines
 * when MU_BYP_EN is asserted.
 */
/*@{*/
#define BP_MMDC_MPMUR0_MU_BYP_VAL (0U)     /*!< Bit position for MMDC_MPMUR0_MU_BYP_VAL. */
#define BM_MMDC_MPMUR0_MU_BYP_VAL (0x000003FFU) /*!< Bit mask for MMDC_MPMUR0_MU_BYP_VAL. */
#define BS_MMDC_MPMUR0_MU_BYP_VAL (10U)    /*!< Bit field size in bits for MMDC_MPMUR0_MU_BYP_VAL. */

/*! @brief Read current value of the MMDC_MPMUR0_MU_BYP_VAL field. */
#define BR_MMDC_MPMUR0_MU_BYP_VAL(x) (HW_MMDC_MPMUR0(x).B.MU_BYP_VAL)

/*! @brief Format value for bitfield MMDC_MPMUR0_MU_BYP_VAL. */
#define BF_MMDC_MPMUR0_MU_BYP_VAL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPMUR0_MU_BYP_VAL) & BM_MMDC_MPMUR0_MU_BYP_VAL)

/*! @brief Set the MU_BYP_VAL field to a new value. */
#define BW_MMDC_MPMUR0_MU_BYP_VAL(x, v) (HW_MMDC_MPMUR0_WR(x, (HW_MMDC_MPMUR0_RD(x) & ~BM_MMDC_MPMUR0_MU_BYP_VAL) | BF_MMDC_MPMUR0_MU_BYP_VAL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPMUR0, field MU_BYP_EN[10] (RW)
 *
 * Measure unit bypass enable. This field is used in debug mode and when it is
 * asserted then the delay-lines will use the number of delay units that are
 * indicated at MU_BYP_VAL, otherwise the delay-lines will use the number of delay
 * units that was measured by the measurement unit and are indicated at
 * MU_UNIT_DEL_NUM
 *
 * Values:
 * - 0 - The delay-lines use delay units as indicated at MU_UNIT_DEL_NUM.
 * - 1 - The delay-lines use delay units as indicated at MU_BYPASS_VAL.
 */
/*@{*/
#define BP_MMDC_MPMUR0_MU_BYP_EN (10U)     /*!< Bit position for MMDC_MPMUR0_MU_BYP_EN. */
#define BM_MMDC_MPMUR0_MU_BYP_EN (0x00000400U) /*!< Bit mask for MMDC_MPMUR0_MU_BYP_EN. */
#define BS_MMDC_MPMUR0_MU_BYP_EN (1U)      /*!< Bit field size in bits for MMDC_MPMUR0_MU_BYP_EN. */

/*! @brief Read current value of the MMDC_MPMUR0_MU_BYP_EN field. */
#define BR_MMDC_MPMUR0_MU_BYP_EN(x) (HW_MMDC_MPMUR0(x).B.MU_BYP_EN)

/*! @brief Format value for bitfield MMDC_MPMUR0_MU_BYP_EN. */
#define BF_MMDC_MPMUR0_MU_BYP_EN(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPMUR0_MU_BYP_EN) & BM_MMDC_MPMUR0_MU_BYP_EN)

/*! @brief Set the MU_BYP_EN field to a new value. */
#define BW_MMDC_MPMUR0_MU_BYP_EN(x, v) (HW_MMDC_MPMUR0_WR(x, (HW_MMDC_MPMUR0_RD(x) & ~BM_MMDC_MPMUR0_MU_BYP_EN) | BF_MMDC_MPMUR0_MU_BYP_EN(v)))
/*@}*/

/*!
 * @name Register MMDC_MPMUR0, field FRC_MSR[11] (RW)
 *
 * Force measurement on delay-lines. When this bit is asserted then a
 * measurement process will be performed, where at the completion of the process the
 * delay-lines will issue the desired delay. Upon completion of the measurement process
 * the measure unit and the delay-lines will return to functional mode. This bit
 * is self cleared. This bit should be used only during manual (SW) calibration
 * and not while the DDR is functional (being accessed). After initial
 * calibration is done the hardware performs periodic measurements to track any operating
 * conditions changes. Hence, force measurements (FRC_MSR) should not be used. See
 * Calibration ProcessThe MMDC offers various calibration processes that are
 * used to obtain better timing accuracy, board skew compensation and I/O pad
 * driving strength adjustment. for more information. User should make sure that there
 * is no active accesses to/from DDR before asserting this bit.
 *
 * Values:
 * - 0 - No measurement is performed
 * - 1 - Perform measurement process
 */
/*@{*/
#define BP_MMDC_MPMUR0_FRC_MSR (11U)       /*!< Bit position for MMDC_MPMUR0_FRC_MSR. */
#define BM_MMDC_MPMUR0_FRC_MSR (0x00000800U) /*!< Bit mask for MMDC_MPMUR0_FRC_MSR. */
#define BS_MMDC_MPMUR0_FRC_MSR (1U)        /*!< Bit field size in bits for MMDC_MPMUR0_FRC_MSR. */

/*! @brief Read current value of the MMDC_MPMUR0_FRC_MSR field. */
#define BR_MMDC_MPMUR0_FRC_MSR(x) (HW_MMDC_MPMUR0(x).B.FRC_MSR)

/*! @brief Format value for bitfield MMDC_MPMUR0_FRC_MSR. */
#define BF_MMDC_MPMUR0_FRC_MSR(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPMUR0_FRC_MSR) & BM_MMDC_MPMUR0_FRC_MSR)

/*! @brief Set the FRC_MSR field to a new value. */
#define BW_MMDC_MPMUR0_FRC_MSR(x, v) (HW_MMDC_MPMUR0_WR(x, (HW_MMDC_MPMUR0_RD(x) & ~BM_MMDC_MPMUR0_FRC_MSR) | BF_MMDC_MPMUR0_FRC_MSR(v)))
/*@}*/

/*!
 * @name Register MMDC_MPMUR0, field MU_UNIT_DEL_NUM[25:16] (RO)
 *
 * Number of delay units measured per cycle. This field is used in debug mode
 * and holds the number of delay units that were measured by the measure unit per
 * DDR clock cycle. The delay-lines that are used in every calibration process use
 * that number for generating the desired delay.
 */
/*@{*/
#define BP_MMDC_MPMUR0_MU_UNIT_DEL_NUM (16U) /*!< Bit position for MMDC_MPMUR0_MU_UNIT_DEL_NUM. */
#define BM_MMDC_MPMUR0_MU_UNIT_DEL_NUM (0x03FF0000U) /*!< Bit mask for MMDC_MPMUR0_MU_UNIT_DEL_NUM. */
#define BS_MMDC_MPMUR0_MU_UNIT_DEL_NUM (10U) /*!< Bit field size in bits for MMDC_MPMUR0_MU_UNIT_DEL_NUM. */

/*! @brief Read current value of the MMDC_MPMUR0_MU_UNIT_DEL_NUM field. */
#define BR_MMDC_MPMUR0_MU_UNIT_DEL_NUM(x) (HW_MMDC_MPMUR0(x).B.MU_UNIT_DEL_NUM)
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPWRCADL - MMDC Write CA delay-line controller
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPWRCADL - MMDC Write CA delay-line controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to add fine-tuning adjustment to the CA
 * (command/Address of LPDDR2 bus) relative to the DDR clock Supported Mode Of Operations: For
 * Channel 0: LP2_2ch_x16, LP2_2ch_x32 For Channel 1: LP2_2ch_x16, LP2_2ch_x32
 */
typedef union _hw_mmdc_mpwrcadl
{
    uint32_t U;
    struct _hw_mmdc_mpwrcadl_bitfields
    {
        uint32_t WR_CA0_DEL : 2;       /*!< [1:0]  */
        uint32_t WR_CA1_DEL : 2;       /*!< [3:2]  */
        uint32_t WR_CA2_DEL : 2;       /*!< [5:4]  */
        uint32_t WR_CA3_DEL : 2;       /*!< [7:6]  */
        uint32_t WR_CA4_DEL : 2;       /*!< [9:8]  */
        uint32_t WR_CA5_DEL : 2;       /*!< [11:10]  */
        uint32_t WR_CA6_DEL : 2;       /*!< [13:12]  */
        uint32_t WR_CA7_DEL : 2;       /*!< [15:14]  */
        uint32_t WR_CA8_DEL : 2;       /*!< [17:16]  */
        uint32_t WR_CA9_DEL : 2;       /*!< [19:18]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_mmdc_mpwrcadl_t;

/*!
 * @name Constants and macros for entire MMDC_MPWRCADL register
 */
/*@{*/
#define HW_MMDC_MPWRCADL_ADDR(x) ((uintptr_t)(x) + 0x8BCU)

#define HW_MMDC_MPWRCADL(x)      (*(__IO hw_mmdc_mpwrcadl_t *) HW_MMDC_MPWRCADL_ADDR(x))
#define HW_MMDC_MPWRCADL_RD(x)   (HW_MMDC_MPWRCADL(x).U)
#define HW_MMDC_MPWRCADL_WR(x, v) (HW_MMDC_MPWRCADL(x).U = (v))
#define HW_MMDC_MPWRCADL_SET(x, v) (HW_MMDC_MPWRCADL_WR(x, HW_MMDC_MPWRCADL_RD(x) |  (v)))
#define HW_MMDC_MPWRCADL_CLR(x, v) (HW_MMDC_MPWRCADL_WR(x, HW_MMDC_MPWRCADL_RD(x) & ~(v)))
#define HW_MMDC_MPWRCADL_TOG(x, v) (HW_MMDC_MPWRCADL_WR(x, HW_MMDC_MPWRCADL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPWRCADL bitfields
 */

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA0_DEL[1:0] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 0 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 0
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA0 delay
 * - 01 - Add CA0 delay of 1 delay unit
 * - 10 - Add CA0 delay of 2 delay units.
 * - 11 - Add CA0 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA0_DEL (0U)   /*!< Bit position for MMDC_MPWRCADL_WR_CA0_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA0_DEL (0x00000003U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA0_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA0_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA0_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA0_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA0_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA0_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA0_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA0_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA0_DEL) & BM_MMDC_MPWRCADL_WR_CA0_DEL)

/*! @brief Set the WR_CA0_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA0_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA0_DEL) | BF_MMDC_MPWRCADL_WR_CA0_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA1_DEL[3:2] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 1 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 1
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA1 delay
 * - 01 - Add CA1 delay of 1 delay unit
 * - 10 - Add CA1 delay of 2 delay units.
 * - 11 - Add CA1 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA1_DEL (2U)   /*!< Bit position for MMDC_MPWRCADL_WR_CA1_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA1_DEL (0x0000000CU) /*!< Bit mask for MMDC_MPWRCADL_WR_CA1_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA1_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA1_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA1_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA1_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA1_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA1_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA1_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA1_DEL) & BM_MMDC_MPWRCADL_WR_CA1_DEL)

/*! @brief Set the WR_CA1_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA1_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA1_DEL) | BF_MMDC_MPWRCADL_WR_CA1_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA2_DEL[5:4] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 2 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 2
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA2 delay
 * - 01 - Add CA2 delay of 1 delay unit
 * - 10 - Add CA2 delay of 2 delay units.
 * - 11 - Add CA2 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA2_DEL (4U)   /*!< Bit position for MMDC_MPWRCADL_WR_CA2_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA2_DEL (0x00000030U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA2_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA2_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA2_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA2_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA2_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA2_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA2_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA2_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA2_DEL) & BM_MMDC_MPWRCADL_WR_CA2_DEL)

/*! @brief Set the WR_CA2_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA2_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA2_DEL) | BF_MMDC_MPWRCADL_WR_CA2_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA3_DEL[7:6] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 3 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 3
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA3 delay
 * - 01 - Add CA3 delay of 1 delay unit
 * - 10 - Add CA3 delay of 2 delay units.
 * - 11 - Add CA3 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA3_DEL (6U)   /*!< Bit position for MMDC_MPWRCADL_WR_CA3_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA3_DEL (0x000000C0U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA3_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA3_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA3_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA3_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA3_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA3_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA3_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA3_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA3_DEL) & BM_MMDC_MPWRCADL_WR_CA3_DEL)

/*! @brief Set the WR_CA3_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA3_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA3_DEL) | BF_MMDC_MPWRCADL_WR_CA3_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA4_DEL[9:8] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 4 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 4
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA4 delay
 * - 01 - Add CA4 delay of 1 delay unit
 * - 10 - Add CA4 delay of 2 delay units.
 * - 11 - Add CA4 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA4_DEL (8U)   /*!< Bit position for MMDC_MPWRCADL_WR_CA4_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA4_DEL (0x00000300U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA4_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA4_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA4_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA4_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA4_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA4_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA4_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA4_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA4_DEL) & BM_MMDC_MPWRCADL_WR_CA4_DEL)

/*! @brief Set the WR_CA4_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA4_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA4_DEL) | BF_MMDC_MPWRCADL_WR_CA4_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA5_DEL[11:10] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 5 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 5
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA5 delay
 * - 01 - Add CA5 delay of 1 delay unit
 * - 10 - Add CA5 delay of 2 delay units.
 * - 11 - Add CA5 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA5_DEL (10U)  /*!< Bit position for MMDC_MPWRCADL_WR_CA5_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA5_DEL (0x00000C00U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA5_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA5_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA5_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA5_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA5_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA5_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA5_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA5_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA5_DEL) & BM_MMDC_MPWRCADL_WR_CA5_DEL)

/*! @brief Set the WR_CA5_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA5_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA5_DEL) | BF_MMDC_MPWRCADL_WR_CA5_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA6_DEL[13:12] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 6 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 6
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA6 delay
 * - 01 - Add CA6 delay of 1 delay unit
 * - 10 - Add CA6 delay of 2 delay units.
 * - 11 - Add CA6 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA6_DEL (12U)  /*!< Bit position for MMDC_MPWRCADL_WR_CA6_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA6_DEL (0x00003000U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA6_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA6_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA6_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA6_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA6_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA6_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA6_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA6_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA6_DEL) & BM_MMDC_MPWRCADL_WR_CA6_DEL)

/*! @brief Set the WR_CA6_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA6_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA6_DEL) | BF_MMDC_MPWRCADL_WR_CA6_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA7_DEL[15:14] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 7 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 7
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA7 delay
 * - 01 - Add CA7 delay of 1 delay unit
 * - 10 - Add CA7 delay of 2 delay units.
 * - 11 - Add CA7 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA7_DEL (14U)  /*!< Bit position for MMDC_MPWRCADL_WR_CA7_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA7_DEL (0x0000C000U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA7_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA7_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA7_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA7_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA7_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA7_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA7_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA7_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA7_DEL) & BM_MMDC_MPWRCADL_WR_CA7_DEL)

/*! @brief Set the WR_CA7_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA7_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA7_DEL) | BF_MMDC_MPWRCADL_WR_CA7_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA8_DEL[17:16] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 8 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 8
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA8 delay
 * - 01 - Add CA8 delay of 1 delay unit
 * - 10 - Add CA8 delay of 2 delay units.
 * - 11 - Add CA8 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA8_DEL (16U)  /*!< Bit position for MMDC_MPWRCADL_WR_CA8_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA8_DEL (0x00030000U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA8_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA8_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA8_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA8_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA8_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA8_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA8_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA8_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA8_DEL) & BM_MMDC_MPWRCADL_WR_CA8_DEL)

/*! @brief Set the WR_CA8_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA8_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA8_DEL) | BF_MMDC_MPWRCADL_WR_CA8_DEL(v)))
/*@}*/

/*!
 * @name Register MMDC_MPWRCADL, field WR_CA9_DEL[19:18] (RW)
 *
 * CA (Command/Address LPDDR2 bus) bit 9 delay fine tuning. This field holds the
 * number of delay units that are added to CA (Command/Address bus) bit 9
 * relative to the clock.
 *
 * Values:
 * - 00 - No change in CA9 delay
 * - 01 - Add CA9 delay of 1 delay unit
 * - 10 - Add CA9 delay of 2 delay units.
 * - 11 - Add CA9 delay of 3 delay units.
 */
/*@{*/
#define BP_MMDC_MPWRCADL_WR_CA9_DEL (18U)  /*!< Bit position for MMDC_MPWRCADL_WR_CA9_DEL. */
#define BM_MMDC_MPWRCADL_WR_CA9_DEL (0x000C0000U) /*!< Bit mask for MMDC_MPWRCADL_WR_CA9_DEL. */
#define BS_MMDC_MPWRCADL_WR_CA9_DEL (2U)   /*!< Bit field size in bits for MMDC_MPWRCADL_WR_CA9_DEL. */

/*! @brief Read current value of the MMDC_MPWRCADL_WR_CA9_DEL field. */
#define BR_MMDC_MPWRCADL_WR_CA9_DEL(x) (HW_MMDC_MPWRCADL(x).B.WR_CA9_DEL)

/*! @brief Format value for bitfield MMDC_MPWRCADL_WR_CA9_DEL. */
#define BF_MMDC_MPWRCADL_WR_CA9_DEL(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPWRCADL_WR_CA9_DEL) & BM_MMDC_MPWRCADL_WR_CA9_DEL)

/*! @brief Set the WR_CA9_DEL field to a new value. */
#define BW_MMDC_MPWRCADL_WR_CA9_DEL(x, v) (HW_MMDC_MPWRCADL_WR(x, (HW_MMDC_MPWRCADL_RD(x) & ~BM_MMDC_MPWRCADL_WR_CA9_DEL) | BF_MMDC_MPWRCADL_WR_CA9_DEL(v)))
/*@}*/

/*******************************************************************************
 * HW_MMDC_MPDCCR - MMDC Duty Cycle Control Register
 ******************************************************************************/

/*!
 * @brief HW_MMDC_MPDCCR - MMDC Duty Cycle Control Register (RW)
 *
 * Reset value: 0x24922492U
 *
 * This register is used to control the duty cycle of the DQS and the primary
 * clock (CK0) . Programming of that register is permitted by entering the DDR
 * device into self-refresh mode through LPMD/DVFS mechanism Supported Mode Of
 * Operations: For Channel 0: All For Channel 1: DDR3_x64, LP2_2ch_x16, LP2_2ch_x32 If
 * the duty cycle is modified after DDR initialization, the DDR will have to be
 * placed in self-refresh mode. The duty cycle may be changed during initial DDR
 * initialization without having to be placed in self-refresh mode.
 */
typedef union _hw_mmdc_mpdccr
{
    uint32_t U;
    struct _hw_mmdc_mpdccr_bitfields
    {
        uint32_t WR_DQS0_FT_DCC : 3;   /*!< [2:0]  */
        uint32_t WR_DQS1_FT_DCC : 3;   /*!< [5:3]  */
        uint32_t WR_DQS2_FT_DCC : 3;   /*!< [8:6]  */
        uint32_t WR_DQS3_FT_DCC : 3;   /*!< [11:9]  */
        uint32_t CK_FT0_DCC : 3;       /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t CK_FT1_DCC : 3;       /*!< [18:16]  */
        uint32_t RD_DQS0_FT_DCC : 3;   /*!< [21:19]  */
        uint32_t RD_DQS1_FT_DCC : 3;   /*!< [24:22]  */
        uint32_t RD_DQS2_FT_DCC : 3;   /*!< [27:25]  */
        uint32_t RD_DQS3_FT_DCC : 3;   /*!< [30:28]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_mmdc_mpdccr_t;

/*!
 * @name Constants and macros for entire MMDC_MPDCCR register
 */
/*@{*/
#define HW_MMDC_MPDCCR_ADDR(x)   ((uintptr_t)(x) + 0x8C0U)

#define HW_MMDC_MPDCCR(x)        (*(__IO hw_mmdc_mpdccr_t *) HW_MMDC_MPDCCR_ADDR(x))
#define HW_MMDC_MPDCCR_RD(x)     (HW_MMDC_MPDCCR(x).U)
#define HW_MMDC_MPDCCR_WR(x, v)  (HW_MMDC_MPDCCR(x).U = (v))
#define HW_MMDC_MPDCCR_SET(x, v) (HW_MMDC_MPDCCR_WR(x, HW_MMDC_MPDCCR_RD(x) |  (v)))
#define HW_MMDC_MPDCCR_CLR(x, v) (HW_MMDC_MPDCCR_WR(x, HW_MMDC_MPDCCR_RD(x) & ~(v)))
#define HW_MMDC_MPDCCR_TOG(x, v) (HW_MMDC_MPDCCR_WR(x, HW_MMDC_MPDCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual MMDC_MPDCCR bitfields
 */

/*!
 * @name Register MMDC_MPDCCR, field WR_DQS0_FT_DCC[2:0] (RW)
 *
 * Write DQS duty cycle fine tuning control of Byte0. This field controls the
 * duty cycle of write DQS of Byte0 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_WR_DQS0_FT_DCC (0U) /*!< Bit position for MMDC_MPDCCR_WR_DQS0_FT_DCC. */
#define BM_MMDC_MPDCCR_WR_DQS0_FT_DCC (0x00000007U) /*!< Bit mask for MMDC_MPDCCR_WR_DQS0_FT_DCC. */
#define BS_MMDC_MPDCCR_WR_DQS0_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_WR_DQS0_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_WR_DQS0_FT_DCC field. */
#define BR_MMDC_MPDCCR_WR_DQS0_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.WR_DQS0_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_WR_DQS0_FT_DCC. */
#define BF_MMDC_MPDCCR_WR_DQS0_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_WR_DQS0_FT_DCC) & BM_MMDC_MPDCCR_WR_DQS0_FT_DCC)

/*! @brief Set the WR_DQS0_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_WR_DQS0_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_WR_DQS0_FT_DCC) | BF_MMDC_MPDCCR_WR_DQS0_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field WR_DQS1_FT_DCC[5:3] (RW)
 *
 * Write DQS duty cycle fine tuning control of Byte1. This field controls the
 * duty cycle of write DQS of Byte1 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_WR_DQS1_FT_DCC (3U) /*!< Bit position for MMDC_MPDCCR_WR_DQS1_FT_DCC. */
#define BM_MMDC_MPDCCR_WR_DQS1_FT_DCC (0x00000038U) /*!< Bit mask for MMDC_MPDCCR_WR_DQS1_FT_DCC. */
#define BS_MMDC_MPDCCR_WR_DQS1_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_WR_DQS1_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_WR_DQS1_FT_DCC field. */
#define BR_MMDC_MPDCCR_WR_DQS1_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.WR_DQS1_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_WR_DQS1_FT_DCC. */
#define BF_MMDC_MPDCCR_WR_DQS1_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_WR_DQS1_FT_DCC) & BM_MMDC_MPDCCR_WR_DQS1_FT_DCC)

/*! @brief Set the WR_DQS1_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_WR_DQS1_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_WR_DQS1_FT_DCC) | BF_MMDC_MPDCCR_WR_DQS1_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field WR_DQS2_FT_DCC[8:6] (RW)
 *
 * Write DQS duty cycle fine tuning control of Byte1. This field controls the
 * duty cycle of write DQS of Byte1 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_WR_DQS2_FT_DCC (6U) /*!< Bit position for MMDC_MPDCCR_WR_DQS2_FT_DCC. */
#define BM_MMDC_MPDCCR_WR_DQS2_FT_DCC (0x000001C0U) /*!< Bit mask for MMDC_MPDCCR_WR_DQS2_FT_DCC. */
#define BS_MMDC_MPDCCR_WR_DQS2_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_WR_DQS2_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_WR_DQS2_FT_DCC field. */
#define BR_MMDC_MPDCCR_WR_DQS2_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.WR_DQS2_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_WR_DQS2_FT_DCC. */
#define BF_MMDC_MPDCCR_WR_DQS2_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_WR_DQS2_FT_DCC) & BM_MMDC_MPDCCR_WR_DQS2_FT_DCC)

/*! @brief Set the WR_DQS2_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_WR_DQS2_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_WR_DQS2_FT_DCC) | BF_MMDC_MPDCCR_WR_DQS2_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field WR_DQS3_FT_DCC[11:9] (RW)
 *
 * Write DQS duty cycle fine tuning control of Byte0. This field controls the
 * duty cycle of write DQS of Byte0 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_WR_DQS3_FT_DCC (9U) /*!< Bit position for MMDC_MPDCCR_WR_DQS3_FT_DCC. */
#define BM_MMDC_MPDCCR_WR_DQS3_FT_DCC (0x00000E00U) /*!< Bit mask for MMDC_MPDCCR_WR_DQS3_FT_DCC. */
#define BS_MMDC_MPDCCR_WR_DQS3_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_WR_DQS3_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_WR_DQS3_FT_DCC field. */
#define BR_MMDC_MPDCCR_WR_DQS3_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.WR_DQS3_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_WR_DQS3_FT_DCC. */
#define BF_MMDC_MPDCCR_WR_DQS3_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_WR_DQS3_FT_DCC) & BM_MMDC_MPDCCR_WR_DQS3_FT_DCC)

/*! @brief Set the WR_DQS3_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_WR_DQS3_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_WR_DQS3_FT_DCC) | BF_MMDC_MPDCCR_WR_DQS3_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field CK_FT0_DCC[14:12] (RW)
 *
 * Primary duty cycle fine tuning control of DDR clock. This field controls the
 * duty cycle of the DDR clock Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_CK_FT0_DCC (12U)    /*!< Bit position for MMDC_MPDCCR_CK_FT0_DCC. */
#define BM_MMDC_MPDCCR_CK_FT0_DCC (0x00007000U) /*!< Bit mask for MMDC_MPDCCR_CK_FT0_DCC. */
#define BS_MMDC_MPDCCR_CK_FT0_DCC (3U)     /*!< Bit field size in bits for MMDC_MPDCCR_CK_FT0_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_CK_FT0_DCC field. */
#define BR_MMDC_MPDCCR_CK_FT0_DCC(x) (HW_MMDC_MPDCCR(x).B.CK_FT0_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_CK_FT0_DCC. */
#define BF_MMDC_MPDCCR_CK_FT0_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_CK_FT0_DCC) & BM_MMDC_MPDCCR_CK_FT0_DCC)

/*! @brief Set the CK_FT0_DCC field to a new value. */
#define BW_MMDC_MPDCCR_CK_FT0_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_CK_FT0_DCC) | BF_MMDC_MPDCCR_CK_FT0_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field CK_FT1_DCC[18:16] (RW)
 *
 * Secondary duty cycle fine tuning control of DDR clock. This field controls
 * the duty cycle of the DDR clock and is cascaded to CK_FT0_DCC Note all the other
 * options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_CK_FT1_DCC (16U)    /*!< Bit position for MMDC_MPDCCR_CK_FT1_DCC. */
#define BM_MMDC_MPDCCR_CK_FT1_DCC (0x00070000U) /*!< Bit mask for MMDC_MPDCCR_CK_FT1_DCC. */
#define BS_MMDC_MPDCCR_CK_FT1_DCC (3U)     /*!< Bit field size in bits for MMDC_MPDCCR_CK_FT1_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_CK_FT1_DCC field. */
#define BR_MMDC_MPDCCR_CK_FT1_DCC(x) (HW_MMDC_MPDCCR(x).B.CK_FT1_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_CK_FT1_DCC. */
#define BF_MMDC_MPDCCR_CK_FT1_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_CK_FT1_DCC) & BM_MMDC_MPDCCR_CK_FT1_DCC)

/*! @brief Set the CK_FT1_DCC field to a new value. */
#define BW_MMDC_MPDCCR_CK_FT1_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_CK_FT1_DCC) | BF_MMDC_MPDCCR_CK_FT1_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field RD_DQS0_FT_DCC[21:19] (RW)
 *
 * Read DQS duty cycle fine tuning control of Byte0. This field controls the
 * duty cycle of read DQS of Byte0 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_RD_DQS0_FT_DCC (19U) /*!< Bit position for MMDC_MPDCCR_RD_DQS0_FT_DCC. */
#define BM_MMDC_MPDCCR_RD_DQS0_FT_DCC (0x00380000U) /*!< Bit mask for MMDC_MPDCCR_RD_DQS0_FT_DCC. */
#define BS_MMDC_MPDCCR_RD_DQS0_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_RD_DQS0_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_RD_DQS0_FT_DCC field. */
#define BR_MMDC_MPDCCR_RD_DQS0_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.RD_DQS0_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_RD_DQS0_FT_DCC. */
#define BF_MMDC_MPDCCR_RD_DQS0_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_RD_DQS0_FT_DCC) & BM_MMDC_MPDCCR_RD_DQS0_FT_DCC)

/*! @brief Set the RD_DQS0_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_RD_DQS0_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_RD_DQS0_FT_DCC) | BF_MMDC_MPDCCR_RD_DQS0_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field RD_DQS1_FT_DCC[24:22] (RW)
 *
 * Read DQS duty cycle fine tuning control of Byte1. This field controls the
 * duty cycle of read DQS of Byte1 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_RD_DQS1_FT_DCC (22U) /*!< Bit position for MMDC_MPDCCR_RD_DQS1_FT_DCC. */
#define BM_MMDC_MPDCCR_RD_DQS1_FT_DCC (0x01C00000U) /*!< Bit mask for MMDC_MPDCCR_RD_DQS1_FT_DCC. */
#define BS_MMDC_MPDCCR_RD_DQS1_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_RD_DQS1_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_RD_DQS1_FT_DCC field. */
#define BR_MMDC_MPDCCR_RD_DQS1_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.RD_DQS1_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_RD_DQS1_FT_DCC. */
#define BF_MMDC_MPDCCR_RD_DQS1_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_RD_DQS1_FT_DCC) & BM_MMDC_MPDCCR_RD_DQS1_FT_DCC)

/*! @brief Set the RD_DQS1_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_RD_DQS1_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_RD_DQS1_FT_DCC) | BF_MMDC_MPDCCR_RD_DQS1_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field RD_DQS2_FT_DCC[27:25] (RW)
 *
 * Read DQS duty cycle fine tuning control of Byte2. This field controls the
 * duty cycle of read DQS of Byte2 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_RD_DQS2_FT_DCC (25U) /*!< Bit position for MMDC_MPDCCR_RD_DQS2_FT_DCC. */
#define BM_MMDC_MPDCCR_RD_DQS2_FT_DCC (0x0E000000U) /*!< Bit mask for MMDC_MPDCCR_RD_DQS2_FT_DCC. */
#define BS_MMDC_MPDCCR_RD_DQS2_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_RD_DQS2_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_RD_DQS2_FT_DCC field. */
#define BR_MMDC_MPDCCR_RD_DQS2_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.RD_DQS2_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_RD_DQS2_FT_DCC. */
#define BF_MMDC_MPDCCR_RD_DQS2_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_RD_DQS2_FT_DCC) & BM_MMDC_MPDCCR_RD_DQS2_FT_DCC)

/*! @brief Set the RD_DQS2_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_RD_DQS2_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_RD_DQS2_FT_DCC) | BF_MMDC_MPDCCR_RD_DQS2_FT_DCC(v)))
/*@}*/

/*!
 * @name Register MMDC_MPDCCR, field RD_DQS3_FT_DCC[30:28] (RW)
 *
 * Read DQS duty cycle fine tuning control of Byte3. This field controls the
 * duty cycle of read DQS of Byte3 Note all the other options are not allowed
 *
 * Values:
 * - 001 - 51.5% low 48.5% high
 * - 010 - 50% duty cycle (default)
 * - 100 - 48.5% low 51.5% high
 */
/*@{*/
#define BP_MMDC_MPDCCR_RD_DQS3_FT_DCC (28U) /*!< Bit position for MMDC_MPDCCR_RD_DQS3_FT_DCC. */
#define BM_MMDC_MPDCCR_RD_DQS3_FT_DCC (0x70000000U) /*!< Bit mask for MMDC_MPDCCR_RD_DQS3_FT_DCC. */
#define BS_MMDC_MPDCCR_RD_DQS3_FT_DCC (3U) /*!< Bit field size in bits for MMDC_MPDCCR_RD_DQS3_FT_DCC. */

/*! @brief Read current value of the MMDC_MPDCCR_RD_DQS3_FT_DCC field. */
#define BR_MMDC_MPDCCR_RD_DQS3_FT_DCC(x) (HW_MMDC_MPDCCR(x).B.RD_DQS3_FT_DCC)

/*! @brief Format value for bitfield MMDC_MPDCCR_RD_DQS3_FT_DCC. */
#define BF_MMDC_MPDCCR_RD_DQS3_FT_DCC(v) ((uint32_t)((uint32_t)(v) << BP_MMDC_MPDCCR_RD_DQS3_FT_DCC) & BM_MMDC_MPDCCR_RD_DQS3_FT_DCC)

/*! @brief Set the RD_DQS3_FT_DCC field to a new value. */
#define BW_MMDC_MPDCCR_RD_DQS3_FT_DCC(x, v) (HW_MMDC_MPDCCR_WR(x, (HW_MMDC_MPDCCR_RD(x) & ~BM_MMDC_MPDCCR_RD_DQS3_FT_DCC) | BF_MMDC_MPDCCR_RD_DQS3_FT_DCC(v)))
/*@}*/

/*******************************************************************************
 * hw_mmdc_t - module struct
 ******************************************************************************/
/*!
 * @brief All MMDC module registers.
 */
#pragma pack(1)
typedef struct _hw_mmdc
{
    __IO hw_mmdc_mdctl_t MDCTL;            /*!< [0x0] MMDC Core Control Register */
    __IO hw_mmdc_mdpdc_t MDPDC;            /*!< [0x4] MMDC Core Power Down Control Register */
    __IO hw_mmdc_mdotc_t MDOTC;            /*!< [0x8] MMDC Core ODT Timing Control Register */
    __IO hw_mmdc_mdcfg0_t MDCFG0;          /*!< [0xC] MMDC Core Timing Configuration Register 0 */
    __IO hw_mmdc_mdcfg1_t MDCFG1;          /*!< [0x10] MMDC Core Timing Configuration Register 1 */
    __IO hw_mmdc_mdcfg2_t MDCFG2;          /*!< [0x14] MMDC Core Timing Configuration Register 2 */
    __IO hw_mmdc_mdmisc_t MDMISC;          /*!< [0x18] MMDC Core Miscellaneous Register */
    __IO hw_mmdc_mdscr_t MDSCR;            /*!< [0x1C] MMDC Core Special Command Register */
    __IO hw_mmdc_mdref_t MDREF;            /*!< [0x20] MMDC Core Refresh Control Register */
    uint8_t _reserved0[8];
    __IO hw_mmdc_mdrwd_t MDRWD;            /*!< [0x2C] MMDC Core Read/Write Command Delay Register */
    __IO hw_mmdc_mdor_t MDOR;              /*!< [0x30] MMDC Core Out of Reset Delays Register */
    __I hw_mmdc_mdmrr_t MDMRR;             /*!< [0x34] MMDC Core MRR Data Register */
    __IO hw_mmdc_mdcfg3lp_t MDCFG3LP;      /*!< [0x38] MMDC Core Timing Configuration Register 3 */
    __IO hw_mmdc_mdmr4_t MDMR4;            /*!< [0x3C] MMDC Core MR4 Derating Register */
    __IO hw_mmdc_mdasp_t MDASP;            /*!< [0x40] MMDC Core Address Space Partition Register */
    uint8_t _reserved1[956];
    __IO hw_mmdc_maarcr_t MAARCR;          /*!< [0x400] MMDC Core AXI Reordering Control Register */
    __IO hw_mmdc_mapsr_t MAPSR;            /*!< [0x404] MMDC Core Power Saving Control and Status Register */
    __IO hw_mmdc_maexidr0_t MAEXIDR0;      /*!< [0x408] MMDC Core Exclusive ID Monitor Register0 */
    __IO hw_mmdc_maexidr1_t MAEXIDR1;      /*!< [0x40C] MMDC Core Exclusive ID Monitor Register1 */
    __IO hw_mmdc_madpcr0_t MADPCR0;        /*!< [0x410] MMDC Core Debug and Profiling Control Register 0 */
    __IO hw_mmdc_madpcr1_t MADPCR1;        /*!< [0x414] MMDC Core Debug and Profiling Control Register 1 */
    __I hw_mmdc_madpsr0_t MADPSR0;         /*!< [0x418] MMDC Core Debug and Profiling Status Register 0 */
    __I hw_mmdc_madpsr1_t MADPSR1;         /*!< [0x41C] MMDC Core Debug and Profiling Status Register 1 */
    __I hw_mmdc_madpsr2_t MADPSR2;         /*!< [0x420] MMDC Core Debug and Profiling Status Register 2 */
    __I hw_mmdc_madpsr3_t MADPSR3;         /*!< [0x424] MMDC Core Debug and Profiling Status Register 3 */
    __I hw_mmdc_madpsr4_t MADPSR4;         /*!< [0x428] MMDC Core Debug and Profiling Status Register 4 */
    __I hw_mmdc_madpsr5_t MADPSR5;         /*!< [0x42C] MMDC Core Debug and Profiling Status Register 5 */
    __I hw_mmdc_masbs0_t MASBS0;           /*!< [0x430] MMDC Core Step By Step Address Register */
    __I hw_mmdc_masbs1_t MASBS1;           /*!< [0x434] MMDC Core Step By Step Address Attributes Register */
    uint8_t _reserved2[8];
    __IO hw_mmdc_magenp_t MAGENP;          /*!< [0x440] MMDC Core General Purpose Register */
    uint8_t _reserved3[956];
    __IO hw_mmdc_mpzqhwctrl_t MPZQHWCTRL;  /*!< [0x800] MMDC PHY ZQ HW control register */
    __IO hw_mmdc_mpzqswctrl_t MPZQSWCTRL;  /*!< [0x804] MMDC PHY ZQ SW control register */
    __IO hw_mmdc_mpwlgcr_t MPWLGCR;        /*!< [0x808] MMDC PHY Write Leveling Configuration and Error Status Register */
    __IO hw_mmdc_mpwldectrl0_t MPWLDECTRL0; /*!< [0x80C] MMDC PHY Write Leveling Delay Control Register 0 */
    __IO hw_mmdc_mpwldectrl1_t MPWLDECTRL1; /*!< [0x810] MMDC PHY Write Leveling Delay Control Register 1 */
    __I hw_mmdc_mpwldlst_t MPWLDLST;       /*!< [0x814] MMDC PHY Write Leveling delay-line Status Register */
    __IO hw_mmdc_mpodtctrl_t MPODTCTRL;    /*!< [0x818] MMDC PHY ODT control register */
    __IO hw_mmdc_mprddqby0dl_t MPRDDQBY0DL; /*!< [0x81C] MMDC PHY Read DQ Byte0 Delay Register */
    __IO hw_mmdc_mprddqby1dl_t MPRDDQBY1DL; /*!< [0x820] MMDC PHY Read DQ Byte1 Delay Register */
    __IO hw_mmdc_mprddqby2dl_t MPRDDQBY2DL; /*!< [0x824] MMDC PHY Read DQ Byte2 Delay Register */
    __IO hw_mmdc_mprddqby3dl_t MPRDDQBY3DL; /*!< [0x828] MMDC PHY Read DQ Byte3 Delay Register */
    __IO hw_mmdc_mpwrdqby0dl_t MPWRDQBY0DL; /*!< [0x82C] MMDC PHY Write DQ Byte0 Delay Register */
    __IO hw_mmdc_mpwrdqby1dl_t MPWRDQBY1DL; /*!< [0x830] MMDC PHY Write DQ Byte1 Delay Register */
    __IO hw_mmdc_mpwrdqby2dl_t MPWRDQBY2DL; /*!< [0x834] MMDC PHY Write DQ Byte2 Delay Register */
    __IO hw_mmdc_mpwrdqby3dl_t MPWRDQBY3DL; /*!< [0x838] MMDC PHY Write DQ Byte3 Delay Register */
    __IO hw_mmdc_mpdgctrl0_t MPDGCTRL0;    /*!< [0x83C] MMDC PHY Read DQS Gating Control Register 0 */
    __IO hw_mmdc_mpdgctrl1_t MPDGCTRL1;    /*!< [0x840] MMDC PHY Read DQS Gating Control Register 1 */
    __I hw_mmdc_mpdgdlst0_t MPDGDLST0;     /*!< [0x844] MMDC PHY Read DQS Gating delay-line Status Register */
    __IO hw_mmdc_mprddlctl_t MPRDDLCTL;    /*!< [0x848] MMDC PHY Read delay-lines Configuration Register */
    __I hw_mmdc_mprddlst_t MPRDDLST;       /*!< [0x84C] MMDC PHY Read delay-lines Status Register */
    __IO hw_mmdc_mpwrdlctl_t MPWRDLCTL;    /*!< [0x850] MMDC PHY Write delay-lines Configuration Register */
    __I hw_mmdc_mpwrdlst_t MPWRDLST;       /*!< [0x854] MMDC PHY Write delay-lines Status Register */
    __IO hw_mmdc_mpsdctrl_t MPSDCTRL;      /*!< [0x858] MMDC PHY CK Control Register */
    __IO hw_mmdc_mpzqlp2ctl_t MPZQLP2CTL;  /*!< [0x85C] MMDC ZQ LPDDR2 HW Control Register */
    __IO hw_mmdc_mprddlhwctl_t MPRDDLHWCTL; /*!< [0x860] MMDC PHY Read Delay HW Calibration Control Register */
    __IO hw_mmdc_mpwrdlhwctl_t MPWRDLHWCTL; /*!< [0x864] MMDC PHY Write Delay HW Calibration Control Register */
    __I hw_mmdc_mprddlhwst0_t MPRDDLHWST0; /*!< [0x868] MMDC PHY Read Delay HW Calibration Status Register 0 */
    __I hw_mmdc_mprddlhwst1_t MPRDDLHWST1; /*!< [0x86C] MMDC PHY Read Delay HW Calibration Status Register 1 */
    __I hw_mmdc_mpwrdlhwst0_t MPWRDLHWST0; /*!< [0x870] MMDC PHY Write Delay HW Calibration Status Register 0 */
    __I hw_mmdc_mpwrdlhwst1_t MPWRDLHWST1; /*!< [0x874] MMDC PHY Write Delay HW Calibration Status Register 1 */
    __I hw_mmdc_mpwlhwerr_t MPWLHWERR;     /*!< [0x878] MMDC PHY Write Leveling HW Error Register */
    __I hw_mmdc_mpdghwst0_t MPDGHWST0;     /*!< [0x87C] MMDC PHY Read DQS Gating HW Status Register 0 */
    __I hw_mmdc_mpdghwst1_t MPDGHWST1;     /*!< [0x880] MMDC PHY Read DQS Gating HW Status Register 1 */
    __I hw_mmdc_mpdghwst2_t MPDGHWST2;     /*!< [0x884] MMDC PHY Read DQS Gating HW Status Register 2 */
    __I hw_mmdc_mpdghwst3_t MPDGHWST3;     /*!< [0x888] MMDC PHY Read DQS Gating HW Status Register 3 */
    __IO hw_mmdc_mppdcmpr1_t MPPDCMPR1;    /*!< [0x88C] MMDC PHY Pre-defined Compare Register 1 */
    __IO hw_mmdc_mppdcmpr2_t MPPDCMPR2;    /*!< [0x890] MMDC PHY Pre-defined Compare and CA delay-line Configuration Register */
    __IO hw_mmdc_mpswdar0_t MPSWDAR0;      /*!< [0x894] MMDC PHY SW Dummy Access Register */
    __I hw_mmdc_mpswdrdr0_t MPSWDRDR0;     /*!< [0x898] MMDC PHY SW Dummy Read Data Register 0 */
    __I hw_mmdc_mpswdrdr1_t MPSWDRDR1;     /*!< [0x89C] MMDC PHY SW Dummy Read Data Register 1 */
    __I hw_mmdc_mpswdrdr2_t MPSWDRDR2;     /*!< [0x8A0] MMDC PHY SW Dummy Read Data Register 2 */
    __I hw_mmdc_mpswdrdr3_t MPSWDRDR3;     /*!< [0x8A4] MMDC PHY SW Dummy Read Data Register 3 */
    __I hw_mmdc_mpswdrdr4_t MPSWDRDR4;     /*!< [0x8A8] MMDC PHY SW Dummy Read Data Register 4 */
    __I hw_mmdc_mpswdrdr5_t MPSWDRDR5;     /*!< [0x8AC] MMDC PHY SW Dummy Read Data Register 5 */
    __I hw_mmdc_mpswdrdr6_t MPSWDRDR6;     /*!< [0x8B0] MMDC PHY SW Dummy Read Data Register 6 */
    __I hw_mmdc_mpswdrdr7_t MPSWDRDR7;     /*!< [0x8B4] MMDC PHY SW Dummy Read Data Register 7 */
    __IO hw_mmdc_mpmur0_t MPMUR0;          /*!< [0x8B8] MMDC PHY Measure Unit Register */
    __IO hw_mmdc_mpwrcadl_t MPWRCADL;      /*!< [0x8BC] MMDC Write CA delay-line controller */
    __IO hw_mmdc_mpdccr_t MPDCCR;          /*!< [0x8C0] MMDC Duty Cycle Control Register */
} hw_mmdc_t;
#pragma pack()

/*! @brief Macro to access all MMDC registers. */
/*! @param x MMDC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_MMDC_REGS(MMDC1_BASE)</code>. */
#define HW_MMDC_REGS(x) (*(hw_mmdc_t *)(x))

/*
 * iMX6DP OCOTP
 *
 * OCOTP Register Reference Index
 *
 * Registers defined in this header file:
 * - HW_OCOTP_CTRL - OTP Controller Control Register
 * - HW_OCOTP_TIMING - OTP Controller Timing Register
 * - HW_OCOTP_DATA - OTP Controller Write Data Register
 * - HW_OCOTP_READ_CTRL - OTP Controller Write Data Register
 * - HW_OCOTP_READ_FUSE_DATA - OTP Controller Read Data Register
 * - HW_OCOTP_SW_STICKY - Sticky bit Register
 * - HW_OCOTP_SCS - Software Controllable Signals Register
 * - HW_OCOTP_VERSION - OTP Controller Version Register
 * - HW_OCOTP_LOCK - Value of OTP Bank0 Word0 (Lock controls)
 * - HW_OCOTP_CFG0 - Value of OTP Bank0 Word1 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG1 - Value of OTP Bank0 Word2 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG2 - Value of OTP Bank0 Word3 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG3 - Value of OTP Bank0 Word4 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG4 - Value of OTP Bank0 Word5 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG5 - Value of OTP Bank0 Word6 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_CFG6 - Value of OTP Bank0 Word7 (Configuration and Manufacturing Info.)
 * - HW_OCOTP_MEM0 - Value of OTP Bank1 Word0 (Memory Related Info.)
 * - HW_OCOTP_MEM1 - Value of OTP Bank1 Word1 (Memory Related Info.)
 * - HW_OCOTP_MEM2 - Value of OTP Bank1 Word2 (Memory Related Info.)
 * - HW_OCOTP_MEM3 - Value of OTP Bank1 Word3 (Memory Related Info.)
 * - HW_OCOTP_MEM4 - Value of OTP Bank1 Word4 (Memory Related Info.)
 * - HW_OCOTP_ANA0 - Value of OTP Bank1 Word5 (Memory Related Info.)
 * - HW_OCOTP_ANA1 - Value of OTP Bank1 Word6 (General Purpose Customer Defined Info.)
 * - HW_OCOTP_ANA2 - Value of OTP Bank1 Word7 (General Purpose Customer Defined Info.)
 * - HW_OCOTP_SRK0 - Shadow Register for OTP Bank3 Word0 (SRK Hash)
 * - HW_OCOTP_SRK1 - Shadow Register for OTP Bank3 Word1 (SRK Hash)
 * - HW_OCOTP_SRK2 - Shadow Register for OTP Bank3 Word2 (SRK Hash)
 * - HW_OCOTP_SRK3 - Shadow Register for OTP Bank3 Word3 (SRK Hash)
 * - HW_OCOTP_SRK4 - Shadow Register for OTP Bank3 Word4 (SRK Hash)
 * - HW_OCOTP_SRK5 - Shadow Register for OTP Bank3 Word5 (SRK Hash)
 * - HW_OCOTP_SRK6 - Shadow Register for OTP Bank3 Word6 (SRK Hash)
 * - HW_OCOTP_SRK7 - Shadow Register for OTP Bank3 Word7 (SRK Hash)
 * - HW_OCOTP_RESP0 - Value of OTP Bank4 Word0 (Secure JTAG Response Field)
 * - HW_OCOTP_HSJC_RESP1 - Value of OTP Bank4 Word1 (Secure JTAG Response Field)
 * - HW_OCOTP_MAC0 - Value of OTP Bank4 Word2 (MAC Address)
 * - HW_OCOTP_MAC1 - Value of OTP Bank4 Word3 (MAC Address)
 * - HW_OCOTP_GP1 - Value of OTP Bank4 Word6 (HW Capabilities)
 * - HW_OCOTP_GP2 - Value of OTP Bank4 Word7 (HW Capabilities)
 * - HW_OCOTP_MISC_CONF - Value of OTP Bank5 Word5 (HW Capabilities)
 * - HW_OCOTP_FIELD_RETURN - Value of OTP Bank5 Word6 (HW Capabilities)
 * - HW_OCOTP_SRK_REVOKE - Value of OTP Bank5 Word7 (HW Capabilities)
 *
 * - hw_ocotp_t - Struct containing all module registers.
 */

#define HW_OCOTP_INSTANCE_COUNT (1U) /*!< Number of instances of the OCOTP module. */
#define HW_OCOTP (0U) /*!< Instance number for OCOTP. */
#define OCOTP_BASE            (0x21BC000U) /*!< Base address for OCOTP. */
/*! Array initializer of OCOTP base addresses. */
#define OCOTP_BASE_ADDRS      { OCOTP_BASE }

/*******************************************************************************
 * HW_OCOTP_CTRL - OTP Controller Control Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CTRL - OTP Controller Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The OCOTP Control and Status Register specifies the copy state, as well as
 * the control required for random access of the OTP memory OCOTP_CTRL: 0x000 The
 * OCOTP Control and Status Register provides the necessary software interface for
 * performing read and write operations to the On-Chip OTP (One-Time
 * Programmable ROM). The control fields such as WR_UNLOCK, ADDR and BUSY/ERROR may be used
 * in conjuction with the HW_OCOTP_DATA register to perform write operations.
 * Read operations to the On-Chip OTP are involving ADDR, BUSY/ERROR bit field and
 * HW_OCOTP_READ_CTRL register. Read value is saved in HW_OCOTP_READ_FUSE_DATA
 * register. EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_ctrl
{
    uint32_t U;
    struct _hw_ocotp_ctrl_bitfields
    {
        uint32_t ADDR : 7;             /*!< [6:0]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t BUSY : 1;             /*!< [8]  */
        uint32_t ERROR : 1;            /*!< [9]  */
        uint32_t RELOAD_SHADOWS : 1;   /*!< [10]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t WR_UNLOCK : 16;       /*!< [31:16]  */
    } B;
} hw_ocotp_ctrl_t;

/*!
 * @name Constants and macros for entire OCOTP_CTRL register
 */
/*@{*/
#define HW_OCOTP_CTRL_ADDR(x)    ((uintptr_t)(x) + 0x0U)
#define HW_OCOTP_CTRL_SET_ADDR(x) (HW_OCOTP_CTRL_ADDR(x) + 0x4U)
#define HW_OCOTP_CTRL_CLR_ADDR(x) (HW_OCOTP_CTRL_ADDR(x) + 0x8U)
#define HW_OCOTP_CTRL_TOG_ADDR(x) (HW_OCOTP_CTRL_ADDR(x) + 0xCU)

#define HW_OCOTP_CTRL(x)         (*(__IO hw_ocotp_ctrl_t *) HW_OCOTP_CTRL_ADDR(x))
#define HW_OCOTP_CTRL_RD(x)      (HW_OCOTP_CTRL(x).U)
#define HW_OCOTP_CTRL_WR(x, v)   (HW_OCOTP_CTRL(x).U = (v))
#define HW_OCOTP_CTRL_SET(x, v)  ((*(uint32_t *) HW_OCOTP_CTRL_SET_ADDR(x)) = (v))
#define HW_OCOTP_CTRL_CLR(x, v)  ((*(uint32_t *) HW_OCOTP_CTRL_CLR_ADDR(x)) = (v))
#define HW_OCOTP_CTRL_TOG(x, v)  ((*(uint32_t *) HW_OCOTP_CTRL_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CTRL bitfields
 */

/*!
 * @name Register OCOTP_CTRL, field ADDR[6:0] (RW)
 *
 * OTP write and read access address register. Specifies one of 128 word address
 * locations (0x00 - 0x7f). If a valid access is accepted by the controller, the
 * controller makes an internal copy of this value. This internal copy will not
 * update until the access is complete.
 */
/*@{*/
#define BP_OCOTP_CTRL_ADDR   (0U)          /*!< Bit position for OCOTP_CTRL_ADDR. */
#define BM_OCOTP_CTRL_ADDR   (0x0000007FU) /*!< Bit mask for OCOTP_CTRL_ADDR. */
#define BS_OCOTP_CTRL_ADDR   (7U)          /*!< Bit field size in bits for OCOTP_CTRL_ADDR. */

/*! @brief Read current value of the OCOTP_CTRL_ADDR field. */
#define BR_OCOTP_CTRL_ADDR(x) (HW_OCOTP_CTRL(x).B.ADDR)

/*! @brief Format value for bitfield OCOTP_CTRL_ADDR. */
#define BF_OCOTP_CTRL_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CTRL_ADDR) & BM_OCOTP_CTRL_ADDR)

/*! @brief Set the ADDR field to a new value. */
#define BW_OCOTP_CTRL_ADDR(x, v) (HW_OCOTP_CTRL_WR(x, (HW_OCOTP_CTRL_RD(x) & ~BM_OCOTP_CTRL_ADDR) | BF_OCOTP_CTRL_ADDR(v)))
/*@}*/

/*!
 * @name Register OCOTP_CTRL, field BUSY[8] (RO)
 *
 * OTP controller status bit. When active, no new write access or read access to
 * OTP(including RELOAD_SHADOWS) can be performed. Cleared by controller when
 * access complete. After reset (or after setting RELOAD_SHADOWS), this bit is set
 * by the controller until the HW/SW and LOCK registers are successfully copied,
 * after which time it is automatically cleared by the controller.
 */
/*@{*/
#define BP_OCOTP_CTRL_BUSY   (8U)          /*!< Bit position for OCOTP_CTRL_BUSY. */
#define BM_OCOTP_CTRL_BUSY   (0x00000100U) /*!< Bit mask for OCOTP_CTRL_BUSY. */
#define BS_OCOTP_CTRL_BUSY   (1U)          /*!< Bit field size in bits for OCOTP_CTRL_BUSY. */

/*! @brief Read current value of the OCOTP_CTRL_BUSY field. */
#define BR_OCOTP_CTRL_BUSY(x) (HW_OCOTP_CTRL(x).B.BUSY)
/*@}*/

/*!
 * @name Register OCOTP_CTRL, field ERROR[9] (RW)
 *
 * Set by the controller when an access to a locked region(OTP or shadow
 * register) is requested. Must be cleared before any further access can be performed.
 * This bit can only be set by the controller. This bit is also set if the Pin
 * interface is active and software requests an access to the OTP. In this instance,
 * the ERROR bit cannot be cleared until the Pin interface access has completed.
 * Reset this bit by writing a one to the SCT clear address space and not by a
 * general write.
 */
/*@{*/
#define BP_OCOTP_CTRL_ERROR  (9U)          /*!< Bit position for OCOTP_CTRL_ERROR. */
#define BM_OCOTP_CTRL_ERROR  (0x00000200U) /*!< Bit mask for OCOTP_CTRL_ERROR. */
#define BS_OCOTP_CTRL_ERROR  (1U)          /*!< Bit field size in bits for OCOTP_CTRL_ERROR. */

/*! @brief Read current value of the OCOTP_CTRL_ERROR field. */
#define BR_OCOTP_CTRL_ERROR(x) (HW_OCOTP_CTRL(x).B.ERROR)

/*! @brief Format value for bitfield OCOTP_CTRL_ERROR. */
#define BF_OCOTP_CTRL_ERROR(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CTRL_ERROR) & BM_OCOTP_CTRL_ERROR)

/*! @brief Set the ERROR field to a new value. */
#define BW_OCOTP_CTRL_ERROR(x, v) (HW_OCOTP_CTRL_WR(x, (HW_OCOTP_CTRL_RD(x) & ~BM_OCOTP_CTRL_ERROR) | BF_OCOTP_CTRL_ERROR(v)))
/*@}*/

/*!
 * @name Register OCOTP_CTRL, field RELOAD_SHADOWS[10] (RW)
 *
 * Set to force re-loading the shadow registers (HW/SW capability and LOCK).
 * This operation will automatically set BUSY. Once the shadow registers have been
 * re-loaded, BUSY and RELOAD_SHADOWS are automatically cleared by the controller.
 */
/*@{*/
#define BP_OCOTP_CTRL_RELOAD_SHADOWS (10U) /*!< Bit position for OCOTP_CTRL_RELOAD_SHADOWS. */
#define BM_OCOTP_CTRL_RELOAD_SHADOWS (0x00000400U) /*!< Bit mask for OCOTP_CTRL_RELOAD_SHADOWS. */
#define BS_OCOTP_CTRL_RELOAD_SHADOWS (1U)  /*!< Bit field size in bits for OCOTP_CTRL_RELOAD_SHADOWS. */

/*! @brief Read current value of the OCOTP_CTRL_RELOAD_SHADOWS field. */
#define BR_OCOTP_CTRL_RELOAD_SHADOWS(x) (HW_OCOTP_CTRL(x).B.RELOAD_SHADOWS)

/*! @brief Format value for bitfield OCOTP_CTRL_RELOAD_SHADOWS. */
#define BF_OCOTP_CTRL_RELOAD_SHADOWS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CTRL_RELOAD_SHADOWS) & BM_OCOTP_CTRL_RELOAD_SHADOWS)

/*! @brief Set the RELOAD_SHADOWS field to a new value. */
#define BW_OCOTP_CTRL_RELOAD_SHADOWS(x, v) (HW_OCOTP_CTRL_WR(x, (HW_OCOTP_CTRL_RD(x) & ~BM_OCOTP_CTRL_RELOAD_SHADOWS) | BF_OCOTP_CTRL_RELOAD_SHADOWS(v)))
/*@}*/

/*!
 * @name Register OCOTP_CTRL, field WR_UNLOCK[31:16] (RW)
 *
 * Write 0x3E77 to enable OTP write accesses. NOTE: This register must be
 * unlocked on a write-by-write basis (a write is initiated when HW_OCOTP_DATA is
 * written), so the UNLOCK bitfield must contain the correct key value during all
 * writes to HW_OCOTP_DATA, otherwise a write shall not be initiated. This field is
 * automatically cleared after a successful write completion (clearing of BUSY).
 *
 * Values:
 * - 11111001110111 - Key needed to unlock HW_OCOTP_DATA register.
 */
/*@{*/
#define BP_OCOTP_CTRL_WR_UNLOCK (16U)      /*!< Bit position for OCOTP_CTRL_WR_UNLOCK. */
#define BM_OCOTP_CTRL_WR_UNLOCK (0xFFFF0000U) /*!< Bit mask for OCOTP_CTRL_WR_UNLOCK. */
#define BS_OCOTP_CTRL_WR_UNLOCK (16U)      /*!< Bit field size in bits for OCOTP_CTRL_WR_UNLOCK. */

#define BV_OCOTP_CTRL_WR_UNLOCK_KEY    (0x3E77U)     /*!< Bit field value for OCOTP_CTRL_WR_UNLOCK: Key needed to unlock HW_OCOTP_DATA register. */

/*! @brief Read current value of the OCOTP_CTRL_WR_UNLOCK field. */
#define BR_OCOTP_CTRL_WR_UNLOCK(x) (HW_OCOTP_CTRL(x).B.WR_UNLOCK)

/*! @brief Format value for bitfield OCOTP_CTRL_WR_UNLOCK. */
#define BF_OCOTP_CTRL_WR_UNLOCK(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CTRL_WR_UNLOCK) & BM_OCOTP_CTRL_WR_UNLOCK)

/*! @brief Set the WR_UNLOCK field to a new value. */
#define BW_OCOTP_CTRL_WR_UNLOCK(x, v) (HW_OCOTP_CTRL_WR(x, (HW_OCOTP_CTRL_RD(x) & ~BM_OCOTP_CTRL_WR_UNLOCK) | BF_OCOTP_CTRL_WR_UNLOCK(v)))
/*@}*/




/*******************************************************************************
 * HW_OCOTP_TIMING - OTP Controller Timing Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_TIMING - OTP Controller Timing Register (RW)
 *
 * Reset value: 0x01461299U
 *
 * The OCOTP Data Register is used for OTP Programming This register specifies
 * timing parameters for programming and reading the OCOTP fuse array. EXAMPLE
 * Empty Example.
 */
typedef union _hw_ocotp_timing
{
    uint32_t U;
    struct _hw_ocotp_timing_bitfields
    {
        uint32_t STROBE_PROG : 12;     /*!< [11:0]  */
        uint32_t RELAX : 4;            /*!< [15:12]  */
        uint32_t STROBE_READ : 6;      /*!< [21:16]  */
        uint32_t WAIT : 6;             /*!< [27:22]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_ocotp_timing_t;

/*!
 * @name Constants and macros for entire OCOTP_TIMING register
 */
/*@{*/
#define HW_OCOTP_TIMING_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_OCOTP_TIMING(x)       (*(__IO hw_ocotp_timing_t *) HW_OCOTP_TIMING_ADDR(x))
#define HW_OCOTP_TIMING_RD(x)    (HW_OCOTP_TIMING(x).U)
#define HW_OCOTP_TIMING_WR(x, v) (HW_OCOTP_TIMING(x).U = (v))
#define HW_OCOTP_TIMING_SET(x, v) (HW_OCOTP_TIMING_WR(x, HW_OCOTP_TIMING_RD(x) |  (v)))
#define HW_OCOTP_TIMING_CLR(x, v) (HW_OCOTP_TIMING_WR(x, HW_OCOTP_TIMING_RD(x) & ~(v)))
#define HW_OCOTP_TIMING_TOG(x, v) (HW_OCOTP_TIMING_WR(x, HW_OCOTP_TIMING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_TIMING bitfields
 */

/*!
 * @name Register OCOTP_TIMING, field STROBE_PROG[11:0] (RW)
 *
 * This count value specifies the strobe period in one time write OTP. Tpgm =
 * ((STROBE_PROG+1)- 2*(RELAX+1)) /ipg_clk_freq. It is given in number of ipg_clk
 * periods.
 */
/*@{*/
#define BP_OCOTP_TIMING_STROBE_PROG (0U)   /*!< Bit position for OCOTP_TIMING_STROBE_PROG. */
#define BM_OCOTP_TIMING_STROBE_PROG (0x00000FFFU) /*!< Bit mask for OCOTP_TIMING_STROBE_PROG. */
#define BS_OCOTP_TIMING_STROBE_PROG (12U)  /*!< Bit field size in bits for OCOTP_TIMING_STROBE_PROG. */

/*! @brief Read current value of the OCOTP_TIMING_STROBE_PROG field. */
#define BR_OCOTP_TIMING_STROBE_PROG(x) (HW_OCOTP_TIMING(x).B.STROBE_PROG)

/*! @brief Format value for bitfield OCOTP_TIMING_STROBE_PROG. */
#define BF_OCOTP_TIMING_STROBE_PROG(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_TIMING_STROBE_PROG) & BM_OCOTP_TIMING_STROBE_PROG)

/*! @brief Set the STROBE_PROG field to a new value. */
#define BW_OCOTP_TIMING_STROBE_PROG(x, v) (HW_OCOTP_TIMING_WR(x, (HW_OCOTP_TIMING_RD(x) & ~BM_OCOTP_TIMING_STROBE_PROG) | BF_OCOTP_TIMING_STROBE_PROG(v)))
/*@}*/

/*!
 * @name Register OCOTP_TIMING, field RELAX[15:12] (RW)
 *
 * This count value specifies the time to add to all default timing parameters
 * other than the Tpgm and Trd. It is given in number of ipg_clk periods.
 */
/*@{*/
#define BP_OCOTP_TIMING_RELAX (12U)        /*!< Bit position for OCOTP_TIMING_RELAX. */
#define BM_OCOTP_TIMING_RELAX (0x0000F000U) /*!< Bit mask for OCOTP_TIMING_RELAX. */
#define BS_OCOTP_TIMING_RELAX (4U)         /*!< Bit field size in bits for OCOTP_TIMING_RELAX. */

/*! @brief Read current value of the OCOTP_TIMING_RELAX field. */
#define BR_OCOTP_TIMING_RELAX(x) (HW_OCOTP_TIMING(x).B.RELAX)

/*! @brief Format value for bitfield OCOTP_TIMING_RELAX. */
#define BF_OCOTP_TIMING_RELAX(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_TIMING_RELAX) & BM_OCOTP_TIMING_RELAX)

/*! @brief Set the RELAX field to a new value. */
#define BW_OCOTP_TIMING_RELAX(x, v) (HW_OCOTP_TIMING_WR(x, (HW_OCOTP_TIMING_RD(x) & ~BM_OCOTP_TIMING_RELAX) | BF_OCOTP_TIMING_RELAX(v)))
/*@}*/

/*!
 * @name Register OCOTP_TIMING, field STROBE_READ[21:16] (RW)
 *
 * This count value specifies the strobe period in one time read OTP. Trd =
 * ((STROBE_READ+1)- 2*(RELAX+1)) /ipg_clk_freq. It is given in number of ipg_clk
 * periods.
 */
/*@{*/
#define BP_OCOTP_TIMING_STROBE_READ (16U)  /*!< Bit position for OCOTP_TIMING_STROBE_READ. */
#define BM_OCOTP_TIMING_STROBE_READ (0x003F0000U) /*!< Bit mask for OCOTP_TIMING_STROBE_READ. */
#define BS_OCOTP_TIMING_STROBE_READ (6U)   /*!< Bit field size in bits for OCOTP_TIMING_STROBE_READ. */

/*! @brief Read current value of the OCOTP_TIMING_STROBE_READ field. */
#define BR_OCOTP_TIMING_STROBE_READ(x) (HW_OCOTP_TIMING(x).B.STROBE_READ)

/*! @brief Format value for bitfield OCOTP_TIMING_STROBE_READ. */
#define BF_OCOTP_TIMING_STROBE_READ(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_TIMING_STROBE_READ) & BM_OCOTP_TIMING_STROBE_READ)

/*! @brief Set the STROBE_READ field to a new value. */
#define BW_OCOTP_TIMING_STROBE_READ(x, v) (HW_OCOTP_TIMING_WR(x, (HW_OCOTP_TIMING_RD(x) & ~BM_OCOTP_TIMING_STROBE_READ) | BF_OCOTP_TIMING_STROBE_READ(v)))
/*@}*/

/*!
 * @name Register OCOTP_TIMING, field WAIT[27:22] (RW)
 *
 * This count value specifies time interval between auto read and write access
 * in one time program. It is given in number of ipg_clk periods.
 */
/*@{*/
#define BP_OCOTP_TIMING_WAIT (22U)         /*!< Bit position for OCOTP_TIMING_WAIT. */
#define BM_OCOTP_TIMING_WAIT (0x0FC00000U) /*!< Bit mask for OCOTP_TIMING_WAIT. */
#define BS_OCOTP_TIMING_WAIT (6U)          /*!< Bit field size in bits for OCOTP_TIMING_WAIT. */

/*! @brief Read current value of the OCOTP_TIMING_WAIT field. */
#define BR_OCOTP_TIMING_WAIT(x) (HW_OCOTP_TIMING(x).B.WAIT)

/*! @brief Format value for bitfield OCOTP_TIMING_WAIT. */
#define BF_OCOTP_TIMING_WAIT(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_TIMING_WAIT) & BM_OCOTP_TIMING_WAIT)

/*! @brief Set the WAIT field to a new value. */
#define BW_OCOTP_TIMING_WAIT(x, v) (HW_OCOTP_TIMING_WR(x, (HW_OCOTP_TIMING_RD(x) & ~BM_OCOTP_TIMING_WAIT) | BF_OCOTP_TIMING_WAIT(v)))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_DATA - OTP Controller Write Data Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_DATA - OTP Controller Write Data Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The OCOTP Data Register is used for OTP Programming This register is used in
 * conjuction with HW_OCOTP_CTRL to perform one-time writes to the OTP. Please
 * see the "Software Write Sequence" section for operating details. EXAMPLE Empty
 * Example.
 */
typedef union _hw_ocotp_data
{
    uint32_t U;
    struct _hw_ocotp_data_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_data_t;

/*!
 * @name Constants and macros for entire OCOTP_DATA register
 */
/*@{*/
#define HW_OCOTP_DATA_ADDR(x)    ((uintptr_t)(x) + 0x20U)

#define HW_OCOTP_DATA(x)         (*(__IO hw_ocotp_data_t *) HW_OCOTP_DATA_ADDR(x))
#define HW_OCOTP_DATA_RD(x)      (HW_OCOTP_DATA(x).U)
#define HW_OCOTP_DATA_WR(x, v)   (HW_OCOTP_DATA(x).U = (v))
#define HW_OCOTP_DATA_SET(x, v)  (HW_OCOTP_DATA_WR(x, HW_OCOTP_DATA_RD(x) |  (v)))
#define HW_OCOTP_DATA_CLR(x, v)  (HW_OCOTP_DATA_WR(x, HW_OCOTP_DATA_RD(x) & ~(v)))
#define HW_OCOTP_DATA_TOG(x, v)  (HW_OCOTP_DATA_WR(x, HW_OCOTP_DATA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_DATA bitfields
 */

/*!
 * @name Register OCOTP_DATA, field DATA[31:0] (RW)
 *
 * Used to initiate a write to OTP. Please see the "Software Write Sequence"
 * section for operating details.
 */
/*@{*/
#define BP_OCOTP_DATA_DATA   (0U)          /*!< Bit position for OCOTP_DATA_DATA. */
#define BM_OCOTP_DATA_DATA   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_DATA_DATA. */
#define BS_OCOTP_DATA_DATA   (32U)         /*!< Bit field size in bits for OCOTP_DATA_DATA. */

/*! @brief Read current value of the OCOTP_DATA_DATA field. */
#define BR_OCOTP_DATA_DATA(x) (HW_OCOTP_DATA(x).U)

/*! @brief Format value for bitfield OCOTP_DATA_DATA. */
#define BF_OCOTP_DATA_DATA(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_DATA_DATA) & BM_OCOTP_DATA_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_OCOTP_DATA_DATA(x, v) (HW_OCOTP_DATA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_READ_CTRL - OTP Controller Write Data Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_READ_CTRL - OTP Controller Write Data Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The OCOTP Register is used for OTP Read This register is used in conjuction
 * with HW_OCOTP_CTRL to perform one time read to the OTP. Please see the
 * "Software read Sequence" section for operating details. EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_read_ctrl
{
    uint32_t U;
    struct _hw_ocotp_read_ctrl_bitfields
    {
        uint32_t READ_FUSE : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_ocotp_read_ctrl_t;

/*!
 * @name Constants and macros for entire OCOTP_READ_CTRL register
 */
/*@{*/
#define HW_OCOTP_READ_CTRL_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_OCOTP_READ_CTRL(x)    (*(__IO hw_ocotp_read_ctrl_t *) HW_OCOTP_READ_CTRL_ADDR(x))
#define HW_OCOTP_READ_CTRL_RD(x) (HW_OCOTP_READ_CTRL(x).U)
#define HW_OCOTP_READ_CTRL_WR(x, v) (HW_OCOTP_READ_CTRL(x).U = (v))
#define HW_OCOTP_READ_CTRL_SET(x, v) (HW_OCOTP_READ_CTRL_WR(x, HW_OCOTP_READ_CTRL_RD(x) |  (v)))
#define HW_OCOTP_READ_CTRL_CLR(x, v) (HW_OCOTP_READ_CTRL_WR(x, HW_OCOTP_READ_CTRL_RD(x) & ~(v)))
#define HW_OCOTP_READ_CTRL_TOG(x, v) (HW_OCOTP_READ_CTRL_WR(x, HW_OCOTP_READ_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_READ_CTRL bitfields
 */

/*!
 * @name Register OCOTP_READ_CTRL, field READ_FUSE[0] (RW)
 *
 * Used to initiate a read to OTP. Please see the "Software read Sequence"
 * section for operating details.
 */
/*@{*/
#define BP_OCOTP_READ_CTRL_READ_FUSE (0U)  /*!< Bit position for OCOTP_READ_CTRL_READ_FUSE. */
#define BM_OCOTP_READ_CTRL_READ_FUSE (0x00000001U) /*!< Bit mask for OCOTP_READ_CTRL_READ_FUSE. */
#define BS_OCOTP_READ_CTRL_READ_FUSE (1U)  /*!< Bit field size in bits for OCOTP_READ_CTRL_READ_FUSE. */

/*! @brief Read current value of the OCOTP_READ_CTRL_READ_FUSE field. */
#define BR_OCOTP_READ_CTRL_READ_FUSE(x) (HW_OCOTP_READ_CTRL(x).B.READ_FUSE)

/*! @brief Format value for bitfield OCOTP_READ_CTRL_READ_FUSE. */
#define BF_OCOTP_READ_CTRL_READ_FUSE(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_READ_CTRL_READ_FUSE) & BM_OCOTP_READ_CTRL_READ_FUSE)

/*! @brief Set the READ_FUSE field to a new value. */
#define BW_OCOTP_READ_CTRL_READ_FUSE(x, v) (HW_OCOTP_READ_CTRL_WR(x, (HW_OCOTP_READ_CTRL_RD(x) & ~BM_OCOTP_READ_CTRL_READ_FUSE) | BF_OCOTP_READ_CTRL_READ_FUSE(v)))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_READ_FUSE_DATA - OTP Controller Read Data Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_READ_FUSE_DATA - OTP Controller Read Data Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The OCOTP Data Register is used for OTP Read The data read from OTP EXAMPLE
 * Empty Example.
 */
typedef union _hw_ocotp_read_fuse_data
{
    uint32_t U;
    struct _hw_ocotp_read_fuse_data_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_read_fuse_data_t;

/*!
 * @name Constants and macros for entire OCOTP_READ_FUSE_DATA register
 */
/*@{*/
#define HW_OCOTP_READ_FUSE_DATA_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_OCOTP_READ_FUSE_DATA(x) (*(__IO hw_ocotp_read_fuse_data_t *) HW_OCOTP_READ_FUSE_DATA_ADDR(x))
#define HW_OCOTP_READ_FUSE_DATA_RD(x) (HW_OCOTP_READ_FUSE_DATA(x).U)
#define HW_OCOTP_READ_FUSE_DATA_WR(x, v) (HW_OCOTP_READ_FUSE_DATA(x).U = (v))
#define HW_OCOTP_READ_FUSE_DATA_SET(x, v) (HW_OCOTP_READ_FUSE_DATA_WR(x, HW_OCOTP_READ_FUSE_DATA_RD(x) |  (v)))
#define HW_OCOTP_READ_FUSE_DATA_CLR(x, v) (HW_OCOTP_READ_FUSE_DATA_WR(x, HW_OCOTP_READ_FUSE_DATA_RD(x) & ~(v)))
#define HW_OCOTP_READ_FUSE_DATA_TOG(x, v) (HW_OCOTP_READ_FUSE_DATA_WR(x, HW_OCOTP_READ_FUSE_DATA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_READ_FUSE_DATA bitfields
 */

/*!
 * @name Register OCOTP_READ_FUSE_DATA, field DATA[31:0] (RW)
 *
 * The data read from OTP
 */
/*@{*/
#define BP_OCOTP_READ_FUSE_DATA_DATA (0U)  /*!< Bit position for OCOTP_READ_FUSE_DATA_DATA. */
#define BM_OCOTP_READ_FUSE_DATA_DATA (0xFFFFFFFFU) /*!< Bit mask for OCOTP_READ_FUSE_DATA_DATA. */
#define BS_OCOTP_READ_FUSE_DATA_DATA (32U) /*!< Bit field size in bits for OCOTP_READ_FUSE_DATA_DATA. */

/*! @brief Read current value of the OCOTP_READ_FUSE_DATA_DATA field. */
#define BR_OCOTP_READ_FUSE_DATA_DATA(x) (HW_OCOTP_READ_FUSE_DATA(x).U)

/*! @brief Format value for bitfield OCOTP_READ_FUSE_DATA_DATA. */
#define BF_OCOTP_READ_FUSE_DATA_DATA(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_READ_FUSE_DATA_DATA) & BM_OCOTP_READ_FUSE_DATA_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_OCOTP_READ_FUSE_DATA_DATA(x, v) (HW_OCOTP_READ_FUSE_DATA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SW_STICKY - Sticky bit Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SW_STICKY - Sticky bit Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Some SW sticky bits . Some sticky bits are used by SW to lock some fuse area
 * , shadow registers and other features. EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_sw_sticky
{
    uint32_t U;
    struct _hw_ocotp_sw_sticky_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t SRK_REVOKE_LOCK : 1;  /*!< [1]  */
        uint32_t FIELD_RETURN_LOCK : 1; /*!< [2]  */
        uint32_t RESERVED1 : 29;       /*!< [31:3]  */
    } B;
} hw_ocotp_sw_sticky_t;

/*!
 * @name Constants and macros for entire OCOTP_SW_STICKY register
 */
/*@{*/
#define HW_OCOTP_SW_STICKY_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_OCOTP_SW_STICKY(x)    (*(__IO hw_ocotp_sw_sticky_t *) HW_OCOTP_SW_STICKY_ADDR(x))
#define HW_OCOTP_SW_STICKY_RD(x) (HW_OCOTP_SW_STICKY(x).U)
#define HW_OCOTP_SW_STICKY_WR(x, v) (HW_OCOTP_SW_STICKY(x).U = (v))
#define HW_OCOTP_SW_STICKY_SET(x, v) (HW_OCOTP_SW_STICKY_WR(x, HW_OCOTP_SW_STICKY_RD(x) |  (v)))
#define HW_OCOTP_SW_STICKY_CLR(x, v) (HW_OCOTP_SW_STICKY_WR(x, HW_OCOTP_SW_STICKY_RD(x) & ~(v)))
#define HW_OCOTP_SW_STICKY_TOG(x, v) (HW_OCOTP_SW_STICKY_WR(x, HW_OCOTP_SW_STICKY_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SW_STICKY bitfields
 */

/*!
 * @name Register OCOTP_SW_STICKY, field SRK_REVOKE_LOCK[1] (RW)
 *
 * Shadow register write and OTP write lock for SRK_REVOKE, MC_ERA and AP_BI_VER
 * regions. When set, the writing of these region's shadow register and OTP fuse
 * word are blocked. Once this bit is set, it is always high unless a POR is
 * issued.
 */
/*@{*/
#define BP_OCOTP_SW_STICKY_SRK_REVOKE_LOCK (1U) /*!< Bit position for OCOTP_SW_STICKY_SRK_REVOKE_LOCK. */
#define BM_OCOTP_SW_STICKY_SRK_REVOKE_LOCK (0x00000002U) /*!< Bit mask for OCOTP_SW_STICKY_SRK_REVOKE_LOCK. */
#define BS_OCOTP_SW_STICKY_SRK_REVOKE_LOCK (1U) /*!< Bit field size in bits for OCOTP_SW_STICKY_SRK_REVOKE_LOCK. */

/*! @brief Read current value of the OCOTP_SW_STICKY_SRK_REVOKE_LOCK field. */
#define BR_OCOTP_SW_STICKY_SRK_REVOKE_LOCK(x) (HW_OCOTP_SW_STICKY(x).B.SRK_REVOKE_LOCK)

/*! @brief Format value for bitfield OCOTP_SW_STICKY_SRK_REVOKE_LOCK. */
#define BF_OCOTP_SW_STICKY_SRK_REVOKE_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SW_STICKY_SRK_REVOKE_LOCK) & BM_OCOTP_SW_STICKY_SRK_REVOKE_LOCK)

/*! @brief Set the SRK_REVOKE_LOCK field to a new value. */
#define BW_OCOTP_SW_STICKY_SRK_REVOKE_LOCK(x, v) (HW_OCOTP_SW_STICKY_WR(x, (HW_OCOTP_SW_STICKY_RD(x) & ~BM_OCOTP_SW_STICKY_SRK_REVOKE_LOCK) | BF_OCOTP_SW_STICKY_SRK_REVOKE_LOCK(v)))
/*@}*/

/*!
 * @name Register OCOTP_SW_STICKY, field FIELD_RETURN_LOCK[2] (RW)
 *
 * Shadow register write and OTP write lock for FIELD_RETURN region. When set,
 * the writing of this region's shadow register and OTP fuse word are blocked.Once
 * this bit is set, it is always high unless a POR is issued.
 */
/*@{*/
#define BP_OCOTP_SW_STICKY_FIELD_RETURN_LOCK (2U) /*!< Bit position for OCOTP_SW_STICKY_FIELD_RETURN_LOCK. */
#define BM_OCOTP_SW_STICKY_FIELD_RETURN_LOCK (0x00000004U) /*!< Bit mask for OCOTP_SW_STICKY_FIELD_RETURN_LOCK. */
#define BS_OCOTP_SW_STICKY_FIELD_RETURN_LOCK (1U) /*!< Bit field size in bits for OCOTP_SW_STICKY_FIELD_RETURN_LOCK. */

/*! @brief Read current value of the OCOTP_SW_STICKY_FIELD_RETURN_LOCK field. */
#define BR_OCOTP_SW_STICKY_FIELD_RETURN_LOCK(x) (HW_OCOTP_SW_STICKY(x).B.FIELD_RETURN_LOCK)

/*! @brief Format value for bitfield OCOTP_SW_STICKY_FIELD_RETURN_LOCK. */
#define BF_OCOTP_SW_STICKY_FIELD_RETURN_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SW_STICKY_FIELD_RETURN_LOCK) & BM_OCOTP_SW_STICKY_FIELD_RETURN_LOCK)

/*! @brief Set the FIELD_RETURN_LOCK field to a new value. */
#define BW_OCOTP_SW_STICKY_FIELD_RETURN_LOCK(x, v) (HW_OCOTP_SW_STICKY_WR(x, (HW_OCOTP_SW_STICKY_RD(x) & ~BM_OCOTP_SW_STICKY_FIELD_RETURN_LOCK) | BF_OCOTP_SW_STICKY_FIELD_RETURN_LOCK(v)))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SCS - Software Controllable Signals Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SCS - Software Controllable Signals Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * HW_OCOTP_SCS: 0x060 This register holds volatile configuration values that
 * can be set and locked by trusted software. All values are returned to their
 * defualt values after POR. EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_scs
{
    uint32_t U;
    struct _hw_ocotp_scs_bitfields
    {
        uint32_t HAB_JDE : 1;          /*!< [0]  */
        uint32_t SPARE : 30;           /*!< [30:1]  */
        uint32_t LOCK : 1;             /*!< [31]  */
    } B;
} hw_ocotp_scs_t;

/*!
 * @name Constants and macros for entire OCOTP_SCS register
 */
/*@{*/
#define HW_OCOTP_SCS_ADDR(x)     ((uintptr_t)(x) + 0x60U)
#define HW_OCOTP_SCS_SET_ADDR(x) (HW_OCOTP_SCS_ADDR(x) + 0x4U)
#define HW_OCOTP_SCS_CLR_ADDR(x) (HW_OCOTP_SCS_ADDR(x) + 0x8U)
#define HW_OCOTP_SCS_TOG_ADDR(x) (HW_OCOTP_SCS_ADDR(x) + 0xCU)

#define HW_OCOTP_SCS(x)          (*(__IO hw_ocotp_scs_t *) HW_OCOTP_SCS_ADDR(x))
#define HW_OCOTP_SCS_RD(x)       (HW_OCOTP_SCS(x).U)
#define HW_OCOTP_SCS_WR(x, v)    (HW_OCOTP_SCS(x).U = (v))
#define HW_OCOTP_SCS_SET(x, v)   ((*(uint32_t *) HW_OCOTP_SCS_SET_ADDR(x)) = (v))
#define HW_OCOTP_SCS_CLR(x, v)   ((*(uint32_t *) HW_OCOTP_SCS_CLR_ADDR(x)) = (v))
#define HW_OCOTP_SCS_TOG(x, v)   ((*(uint32_t *) HW_OCOTP_SCS_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SCS bitfields
 */

/*!
 * @name Register OCOTP_SCS, field HAB_JDE[0] (RW)
 *
 * HAB JTAG Debug Enable. This bit is used by the HAB to enable JTAG debugging,
 * assuming that a properly signed command to do so is found and validated by the
 * HAB. The HAB must lock the register before passing control to the OS whether
 * or not JTAG debugging has been enabled. Once JTAG is enabled by this bit, it
 * can not be disabled unless the system is reset by POR. 0: JTAG debugging is not
 * enabled by the HAB (it may still be enabled by other mechanisms). 1: JTAG
 * debugging is enabled by the HAB (though this signal may be gated off).
 *
 * Values:
 * - 1 - JTAG debugging is enabled by the HAB (though this signal may be gated
 *     off)
 */
/*@{*/
#define BP_OCOTP_SCS_HAB_JDE (0U)          /*!< Bit position for OCOTP_SCS_HAB_JDE. */
#define BM_OCOTP_SCS_HAB_JDE (0x00000001U) /*!< Bit mask for OCOTP_SCS_HAB_JDE. */
#define BS_OCOTP_SCS_HAB_JDE (1U)          /*!< Bit field size in bits for OCOTP_SCS_HAB_JDE. */

/*! @brief Read current value of the OCOTP_SCS_HAB_JDE field. */
#define BR_OCOTP_SCS_HAB_JDE(x) (HW_OCOTP_SCS(x).B.HAB_JDE)

/*! @brief Format value for bitfield OCOTP_SCS_HAB_JDE. */
#define BF_OCOTP_SCS_HAB_JDE(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SCS_HAB_JDE) & BM_OCOTP_SCS_HAB_JDE)

/*! @brief Set the HAB_JDE field to a new value. */
#define BW_OCOTP_SCS_HAB_JDE(x, v) (HW_OCOTP_SCS_WR(x, (HW_OCOTP_SCS_RD(x) & ~BM_OCOTP_SCS_HAB_JDE) | BF_OCOTP_SCS_HAB_JDE(v)))
/*@}*/

/*!
 * @name Register OCOTP_SCS, field SPARE[30:1] (RW)
 *
 * Unallocated read/write bits for implementation specific software use.
 */
/*@{*/
#define BP_OCOTP_SCS_SPARE   (1U)          /*!< Bit position for OCOTP_SCS_SPARE. */
#define BM_OCOTP_SCS_SPARE   (0x7FFFFFFEU) /*!< Bit mask for OCOTP_SCS_SPARE. */
#define BS_OCOTP_SCS_SPARE   (30U)         /*!< Bit field size in bits for OCOTP_SCS_SPARE. */

/*! @brief Read current value of the OCOTP_SCS_SPARE field. */
#define BR_OCOTP_SCS_SPARE(x) (HW_OCOTP_SCS(x).B.SPARE)

/*! @brief Format value for bitfield OCOTP_SCS_SPARE. */
#define BF_OCOTP_SCS_SPARE(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SCS_SPARE) & BM_OCOTP_SCS_SPARE)

/*! @brief Set the SPARE field to a new value. */
#define BW_OCOTP_SCS_SPARE(x, v) (HW_OCOTP_SCS_WR(x, (HW_OCOTP_SCS_RD(x) & ~BM_OCOTP_SCS_SPARE) | BF_OCOTP_SCS_SPARE(v)))
/*@}*/

/*!
 * @name Register OCOTP_SCS, field LOCK[31] (RW)
 *
 * When set, all of the bits in this register are locked and can not be changed
 * through SW programming. This bit is only reset after a POR is issued.
 */
/*@{*/
#define BP_OCOTP_SCS_LOCK    (31U)         /*!< Bit position for OCOTP_SCS_LOCK. */
#define BM_OCOTP_SCS_LOCK    (0x80000000U) /*!< Bit mask for OCOTP_SCS_LOCK. */
#define BS_OCOTP_SCS_LOCK    (1U)          /*!< Bit field size in bits for OCOTP_SCS_LOCK. */

/*! @brief Read current value of the OCOTP_SCS_LOCK field. */
#define BR_OCOTP_SCS_LOCK(x) (HW_OCOTP_SCS(x).B.LOCK)

/*! @brief Format value for bitfield OCOTP_SCS_LOCK. */
#define BF_OCOTP_SCS_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SCS_LOCK) & BM_OCOTP_SCS_LOCK)

/*! @brief Set the LOCK field to a new value. */
#define BW_OCOTP_SCS_LOCK(x, v) (HW_OCOTP_SCS_WR(x, (HW_OCOTP_SCS_RD(x) & ~BM_OCOTP_SCS_LOCK) | BF_OCOTP_SCS_LOCK(v)))
/*@}*/




/*******************************************************************************
 * HW_OCOTP_VERSION - OTP Controller Version Register
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_VERSION - OTP Controller Version Register (RO)
 *
 * Reset value: 0x02000000U
 *
 * This register always returns a known read value for debug purposes it
 * indicates the version of the block. This register indicates the RTL version in use.
 * EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_version
{
    uint32_t U;
    struct _hw_ocotp_version_bitfields
    {
        uint32_t STEP : 16;            /*!< [15:0]  */
        uint32_t MINOR : 8;            /*!< [23:16]  */
        uint32_t MAJOR : 8;            /*!< [31:24]  */
    } B;
} hw_ocotp_version_t;

/*!
 * @name Constants and macros for entire OCOTP_VERSION register
 */
/*@{*/
#define HW_OCOTP_VERSION_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_OCOTP_VERSION(x)      (*(__I hw_ocotp_version_t *) HW_OCOTP_VERSION_ADDR(x))
#define HW_OCOTP_VERSION_RD(x)   (HW_OCOTP_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual OCOTP_VERSION bitfields
 */

/*!
 * @name Register OCOTP_VERSION, field STEP[15:0] (RO)
 *
 * Fixed read-only value reflecting the stepping of the RTL version.
 */
/*@{*/
#define BP_OCOTP_VERSION_STEP (0U)         /*!< Bit position for OCOTP_VERSION_STEP. */
#define BM_OCOTP_VERSION_STEP (0x0000FFFFU) /*!< Bit mask for OCOTP_VERSION_STEP. */
#define BS_OCOTP_VERSION_STEP (16U)        /*!< Bit field size in bits for OCOTP_VERSION_STEP. */

/*! @brief Read current value of the OCOTP_VERSION_STEP field. */
#define BR_OCOTP_VERSION_STEP(x) (HW_OCOTP_VERSION(x).B.STEP)
/*@}*/

/*!
 * @name Register OCOTP_VERSION, field MINOR[23:16] (RO)
 *
 * Fixed read-only value reflecting the MINOR field of the RTL version.
 */
/*@{*/
#define BP_OCOTP_VERSION_MINOR (16U)       /*!< Bit position for OCOTP_VERSION_MINOR. */
#define BM_OCOTP_VERSION_MINOR (0x00FF0000U) /*!< Bit mask for OCOTP_VERSION_MINOR. */
#define BS_OCOTP_VERSION_MINOR (8U)        /*!< Bit field size in bits for OCOTP_VERSION_MINOR. */

/*! @brief Read current value of the OCOTP_VERSION_MINOR field. */
#define BR_OCOTP_VERSION_MINOR(x) (HW_OCOTP_VERSION(x).B.MINOR)
/*@}*/

/*!
 * @name Register OCOTP_VERSION, field MAJOR[31:24] (RO)
 *
 * Fixed read-only value reflecting the MAJOR field of the RTL version.
 */
/*@{*/
#define BP_OCOTP_VERSION_MAJOR (24U)       /*!< Bit position for OCOTP_VERSION_MAJOR. */
#define BM_OCOTP_VERSION_MAJOR (0xFF000000U) /*!< Bit mask for OCOTP_VERSION_MAJOR. */
#define BS_OCOTP_VERSION_MAJOR (8U)        /*!< Bit field size in bits for OCOTP_VERSION_MAJOR. */

/*! @brief Read current value of the OCOTP_VERSION_MAJOR field. */
#define BR_OCOTP_VERSION_MAJOR(x) (HW_OCOTP_VERSION(x).B.MAJOR)
/*@}*/

/*******************************************************************************
 * HW_OCOTP_LOCK - Value of OTP Bank0 Word0 (Lock controls)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_LOCK - Value of OTP Bank0 Word0 (Lock controls) (RO)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 0 (ADDR = 0x00). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_lock
{
    uint32_t U;
    struct _hw_ocotp_lock_bitfields
    {
        uint32_t TESTER : 2;           /*!< [1:0]  */
        uint32_t BOOT_CFG : 2;         /*!< [3:2]  */
        uint32_t MEM_TRIM : 2;         /*!< [5:4]  */
        uint32_t SJC_RESP : 1;         /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t MAC_ADDR : 2;         /*!< [9:8]  */
        uint32_t GP1 : 2;              /*!< [11:10]  */
        uint32_t GP2 : 2;              /*!< [13:12]  */
        uint32_t SRK : 1;              /*!< [14]  */
        uint32_t RESERVED1 : 3;        /*!< [17:15]  */
        uint32_t ANALOG : 2;           /*!< [19:18]  */
        uint32_t RESERVED2 : 2;        /*!< [21:20]  */
        uint32_t MISC_CONF : 1;        /*!< [22]  */
        uint32_t RESERVED3 : 7;        /*!< [29:23]  */
        uint32_t UNALLOCATED : 2;      /*!< [31:30]  */
    } B;
} hw_ocotp_lock_t;

/*!
 * @name Constants and macros for entire OCOTP_LOCK register
 */
/*@{*/
#define HW_OCOTP_LOCK_ADDR(x)    ((uintptr_t)(x) + 0x400U)

#define HW_OCOTP_LOCK(x)         (*(__I hw_ocotp_lock_t *) HW_OCOTP_LOCK_ADDR(x))
#define HW_OCOTP_LOCK_RD(x)      (HW_OCOTP_LOCK(x).U)
/*@}*/

/*
 * Constants & macros for individual OCOTP_LOCK bitfields
 */

/*!
 * @name Register OCOTP_LOCK, field TESTER[1:0] (RO)
 *
 * Status of shadow register and OTP write lock for tester region. When bit 1 is
 * set, the writing of this region's shadow register is blocked. When bit 0 is
 * set, the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_TESTER (0U)          /*!< Bit position for OCOTP_LOCK_TESTER. */
#define BM_OCOTP_LOCK_TESTER (0x00000003U) /*!< Bit mask for OCOTP_LOCK_TESTER. */
#define BS_OCOTP_LOCK_TESTER (2U)          /*!< Bit field size in bits for OCOTP_LOCK_TESTER. */

/*! @brief Read current value of the OCOTP_LOCK_TESTER field. */
#define BR_OCOTP_LOCK_TESTER(x) (HW_OCOTP_LOCK(x).B.TESTER)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field BOOT_CFG[3:2] (RO)
 *
 * Status of shadow register and OTP write lock for boot_cfg region. When bit 1
 * is set, the writing of this region's shadow register is blocked. When bit 0 is
 * set, the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_BOOT_CFG (2U)        /*!< Bit position for OCOTP_LOCK_BOOT_CFG. */
#define BM_OCOTP_LOCK_BOOT_CFG (0x0000000CU) /*!< Bit mask for OCOTP_LOCK_BOOT_CFG. */
#define BS_OCOTP_LOCK_BOOT_CFG (2U)        /*!< Bit field size in bits for OCOTP_LOCK_BOOT_CFG. */

/*! @brief Read current value of the OCOTP_LOCK_BOOT_CFG field. */
#define BR_OCOTP_LOCK_BOOT_CFG(x) (HW_OCOTP_LOCK(x).B.BOOT_CFG)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field MEM_TRIM[5:4] (RO)
 *
 * Status of shadow register and OTP write lock for mem_trim region. When bit 1
 * is set, the writing of this region's shadow register is blocked. When bit 0 is
 * set, the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_MEM_TRIM (4U)        /*!< Bit position for OCOTP_LOCK_MEM_TRIM. */
#define BM_OCOTP_LOCK_MEM_TRIM (0x00000030U) /*!< Bit mask for OCOTP_LOCK_MEM_TRIM. */
#define BS_OCOTP_LOCK_MEM_TRIM (2U)        /*!< Bit field size in bits for OCOTP_LOCK_MEM_TRIM. */

/*! @brief Read current value of the OCOTP_LOCK_MEM_TRIM field. */
#define BR_OCOTP_LOCK_MEM_TRIM(x) (HW_OCOTP_LOCK(x).B.MEM_TRIM)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field SJC_RESP[6] (RO)
 *
 * Status of shadow register read and write, OTP read and write lock for
 * sjc_resp region. When set, the writing of this region's shadow register and OTP fuse
 * word are blocked. The read of this region's shadow register and OTP fuse word
 * are also blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_SJC_RESP (6U)        /*!< Bit position for OCOTP_LOCK_SJC_RESP. */
#define BM_OCOTP_LOCK_SJC_RESP (0x00000040U) /*!< Bit mask for OCOTP_LOCK_SJC_RESP. */
#define BS_OCOTP_LOCK_SJC_RESP (1U)        /*!< Bit field size in bits for OCOTP_LOCK_SJC_RESP. */

/*! @brief Read current value of the OCOTP_LOCK_SJC_RESP field. */
#define BR_OCOTP_LOCK_SJC_RESP(x) (HW_OCOTP_LOCK(x).B.SJC_RESP)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field MAC_ADDR[9:8] (RO)
 *
 * Status of shadow register and OTP write lock for mac_addr region. When bit 1
 * is set, the writing of this region's shadow register is blocked. When bit 0 is
 * set, the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_MAC_ADDR (8U)        /*!< Bit position for OCOTP_LOCK_MAC_ADDR. */
#define BM_OCOTP_LOCK_MAC_ADDR (0x00000300U) /*!< Bit mask for OCOTP_LOCK_MAC_ADDR. */
#define BS_OCOTP_LOCK_MAC_ADDR (2U)        /*!< Bit field size in bits for OCOTP_LOCK_MAC_ADDR. */

/*! @brief Read current value of the OCOTP_LOCK_MAC_ADDR field. */
#define BR_OCOTP_LOCK_MAC_ADDR(x) (HW_OCOTP_LOCK(x).B.MAC_ADDR)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field GP1[11:10] (RO)
 *
 * Status of shadow register and OTP write lock for gp2 region. When bit 1 is
 * set, the writing of this region's shadow register is blocked. When bit 0 is set,
 * the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_GP1    (10U)         /*!< Bit position for OCOTP_LOCK_GP1. */
#define BM_OCOTP_LOCK_GP1    (0x00000C00U) /*!< Bit mask for OCOTP_LOCK_GP1. */
#define BS_OCOTP_LOCK_GP1    (2U)          /*!< Bit field size in bits for OCOTP_LOCK_GP1. */

/*! @brief Read current value of the OCOTP_LOCK_GP1 field. */
#define BR_OCOTP_LOCK_GP1(x) (HW_OCOTP_LOCK(x).B.GP1)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field GP2[13:12] (RO)
 *
 * Status of shadow register and OTP write lock for gp2 region. When bit 1 is
 * set, the writing of this region's shadow register is blocked. When bit 0 is set,
 * the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_GP2    (12U)         /*!< Bit position for OCOTP_LOCK_GP2. */
#define BM_OCOTP_LOCK_GP2    (0x00003000U) /*!< Bit mask for OCOTP_LOCK_GP2. */
#define BS_OCOTP_LOCK_GP2    (2U)          /*!< Bit field size in bits for OCOTP_LOCK_GP2. */

/*! @brief Read current value of the OCOTP_LOCK_GP2 field. */
#define BR_OCOTP_LOCK_GP2(x) (HW_OCOTP_LOCK(x).B.GP2)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field SRK[14] (RO)
 *
 * Status of shadow register and OTP write lock for srk region. When set, the
 * writing of this region's shadow register and OTP fuse word are blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_SRK    (14U)         /*!< Bit position for OCOTP_LOCK_SRK. */
#define BM_OCOTP_LOCK_SRK    (0x00004000U) /*!< Bit mask for OCOTP_LOCK_SRK. */
#define BS_OCOTP_LOCK_SRK    (1U)          /*!< Bit field size in bits for OCOTP_LOCK_SRK. */

/*! @brief Read current value of the OCOTP_LOCK_SRK field. */
#define BR_OCOTP_LOCK_SRK(x) (HW_OCOTP_LOCK(x).B.SRK)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field ANALOG[19:18] (RO)
 *
 * Status of shadow register and OTP write lock for analog region. When bit 1 is
 * set, the writing of this region's shadow register is blocked. When bit 0 is
 * set, the writing of this region's OTP fuse word is blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_ANALOG (18U)         /*!< Bit position for OCOTP_LOCK_ANALOG. */
#define BM_OCOTP_LOCK_ANALOG (0x000C0000U) /*!< Bit mask for OCOTP_LOCK_ANALOG. */
#define BS_OCOTP_LOCK_ANALOG (2U)          /*!< Bit field size in bits for OCOTP_LOCK_ANALOG. */

/*! @brief Read current value of the OCOTP_LOCK_ANALOG field. */
#define BR_OCOTP_LOCK_ANALOG(x) (HW_OCOTP_LOCK(x).B.ANALOG)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field MISC_CONF[22] (RO)
 *
 * Status of shadow register and OTP write lock for misc_conf region. When set,
 * the writing of this region's shadow register and OTP fuse word are blocked.
 */
/*@{*/
#define BP_OCOTP_LOCK_MISC_CONF (22U)      /*!< Bit position for OCOTP_LOCK_MISC_CONF. */
#define BM_OCOTP_LOCK_MISC_CONF (0x00400000U) /*!< Bit mask for OCOTP_LOCK_MISC_CONF. */
#define BS_OCOTP_LOCK_MISC_CONF (1U)       /*!< Bit field size in bits for OCOTP_LOCK_MISC_CONF. */

/*! @brief Read current value of the OCOTP_LOCK_MISC_CONF field. */
#define BR_OCOTP_LOCK_MISC_CONF(x) (HW_OCOTP_LOCK(x).B.MISC_CONF)
/*@}*/

/*!
 * @name Register OCOTP_LOCK, field UNALLOCATED[31:30] (RO)
 *
 * Value of un-used portion of LOCK word
 */
/*@{*/
#define BP_OCOTP_LOCK_UNALLOCATED (30U)    /*!< Bit position for OCOTP_LOCK_UNALLOCATED. */
#define BM_OCOTP_LOCK_UNALLOCATED (0xC0000000U) /*!< Bit mask for OCOTP_LOCK_UNALLOCATED. */
#define BS_OCOTP_LOCK_UNALLOCATED (2U)     /*!< Bit field size in bits for OCOTP_LOCK_UNALLOCATED. */

/*! @brief Read current value of the OCOTP_LOCK_UNALLOCATED field. */
#define BR_OCOTP_LOCK_UNALLOCATED(x) (HW_OCOTP_LOCK(x).B.UNALLOCATED)
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG0 - Value of OTP Bank0 Word1 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG0 - Value of OTP Bank0 Word1 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 1 (ADDR = 0x01). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg0
{
    uint32_t U;
    struct _hw_ocotp_cfg0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg0_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG0 register
 */
/*@{*/
#define HW_OCOTP_CFG0_ADDR(x)    ((uintptr_t)(x) + 0x410U)

#define HW_OCOTP_CFG0(x)         (*(__IO hw_ocotp_cfg0_t *) HW_OCOTP_CFG0_ADDR(x))
#define HW_OCOTP_CFG0_RD(x)      (HW_OCOTP_CFG0(x).U)
#define HW_OCOTP_CFG0_WR(x, v)   (HW_OCOTP_CFG0(x).U = (v))
#define HW_OCOTP_CFG0_SET(x, v)  (HW_OCOTP_CFG0_WR(x, HW_OCOTP_CFG0_RD(x) |  (v)))
#define HW_OCOTP_CFG0_CLR(x, v)  (HW_OCOTP_CFG0_WR(x, HW_OCOTP_CFG0_RD(x) & ~(v)))
#define HW_OCOTP_CFG0_TOG(x, v)  (HW_OCOTP_CFG0_WR(x, HW_OCOTP_CFG0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG0 bitfields
 */

/*!
 * @name Register OCOTP_CFG0, field BITS[31:0] (RW)
 *
 * This register contains 32 bits of the Unique ID and SJC_CHALLENGE field.
 * Reflects value of OTP Bank 0, word 1 (ADDR = 0x01). These bits become read-only
 * after the HW_OCOTP_LOCK_TESTER[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG0_BITS   (0U)          /*!< Bit position for OCOTP_CFG0_BITS. */
#define BM_OCOTP_CFG0_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG0_BITS. */
#define BS_OCOTP_CFG0_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG0_BITS. */

/*! @brief Read current value of the OCOTP_CFG0_BITS field. */
#define BR_OCOTP_CFG0_BITS(x) (HW_OCOTP_CFG0(x).U)

/*! @brief Format value for bitfield OCOTP_CFG0_BITS. */
#define BF_OCOTP_CFG0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG0_BITS) & BM_OCOTP_CFG0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG0_BITS(x, v) (HW_OCOTP_CFG0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG1 - Value of OTP Bank0 Word2 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG1 - Value of OTP Bank0 Word2 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] shadowed memory mapped access to OTP Bank 0, word
 * 2 (ADDR = 0x02). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg1
{
    uint32_t U;
    struct _hw_ocotp_cfg1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg1_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG1 register
 */
/*@{*/
#define HW_OCOTP_CFG1_ADDR(x)    ((uintptr_t)(x) + 0x420U)

#define HW_OCOTP_CFG1(x)         (*(__IO hw_ocotp_cfg1_t *) HW_OCOTP_CFG1_ADDR(x))
#define HW_OCOTP_CFG1_RD(x)      (HW_OCOTP_CFG1(x).U)
#define HW_OCOTP_CFG1_WR(x, v)   (HW_OCOTP_CFG1(x).U = (v))
#define HW_OCOTP_CFG1_SET(x, v)  (HW_OCOTP_CFG1_WR(x, HW_OCOTP_CFG1_RD(x) |  (v)))
#define HW_OCOTP_CFG1_CLR(x, v)  (HW_OCOTP_CFG1_WR(x, HW_OCOTP_CFG1_RD(x) & ~(v)))
#define HW_OCOTP_CFG1_TOG(x, v)  (HW_OCOTP_CFG1_WR(x, HW_OCOTP_CFG1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG1 bitfields
 */

/*!
 * @name Register OCOTP_CFG1, field BITS[31:0] (RW)
 *
 * This register contains 32 bits of the Unique ID and SJC_CHALLENGE field.
 * Reflects value of OTP Bank 0, word 2 (ADDR = 0x02). These bits become read-only
 * after the HW_OCOTP_LOCK_TESTER[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG1_BITS   (0U)          /*!< Bit position for OCOTP_CFG1_BITS. */
#define BM_OCOTP_CFG1_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG1_BITS. */
#define BS_OCOTP_CFG1_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG1_BITS. */

/*! @brief Read current value of the OCOTP_CFG1_BITS field. */
#define BR_OCOTP_CFG1_BITS(x) (HW_OCOTP_CFG1(x).U)

/*! @brief Format value for bitfield OCOTP_CFG1_BITS. */
#define BF_OCOTP_CFG1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG1_BITS) & BM_OCOTP_CFG1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG1_BITS(x, v) (HW_OCOTP_CFG1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG2 - Value of OTP Bank0 Word3 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG2 - Value of OTP Bank0 Word3 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 3 (ADDR = 0x03). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg2
{
    uint32_t U;
    struct _hw_ocotp_cfg2_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg2_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG2 register
 */
/*@{*/
#define HW_OCOTP_CFG2_ADDR(x)    ((uintptr_t)(x) + 0x430U)

#define HW_OCOTP_CFG2(x)         (*(__IO hw_ocotp_cfg2_t *) HW_OCOTP_CFG2_ADDR(x))
#define HW_OCOTP_CFG2_RD(x)      (HW_OCOTP_CFG2(x).U)
#define HW_OCOTP_CFG2_WR(x, v)   (HW_OCOTP_CFG2(x).U = (v))
#define HW_OCOTP_CFG2_SET(x, v)  (HW_OCOTP_CFG2_WR(x, HW_OCOTP_CFG2_RD(x) |  (v)))
#define HW_OCOTP_CFG2_CLR(x, v)  (HW_OCOTP_CFG2_WR(x, HW_OCOTP_CFG2_RD(x) & ~(v)))
#define HW_OCOTP_CFG2_TOG(x, v)  (HW_OCOTP_CFG2_WR(x, HW_OCOTP_CFG2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG2 bitfields
 */

/*!
 * @name Register OCOTP_CFG2, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 0, word 3 (ADDR = 0x03). These bits become
 * read-only after the HW_OCOTP_LOCK_TESTER[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG2_BITS   (0U)          /*!< Bit position for OCOTP_CFG2_BITS. */
#define BM_OCOTP_CFG2_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG2_BITS. */
#define BS_OCOTP_CFG2_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG2_BITS. */

/*! @brief Read current value of the OCOTP_CFG2_BITS field. */
#define BR_OCOTP_CFG2_BITS(x) (HW_OCOTP_CFG2(x).U)

/*! @brief Format value for bitfield OCOTP_CFG2_BITS. */
#define BF_OCOTP_CFG2_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG2_BITS) & BM_OCOTP_CFG2_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG2_BITS(x, v) (HW_OCOTP_CFG2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG3 - Value of OTP Bank0 Word4 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG3 - Value of OTP Bank0 Word4 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Non-shadowed memory mapped access to OTP Bank 0,
 * word 4 (ADDR = 0x04). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg3
{
    uint32_t U;
    struct _hw_ocotp_cfg3_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg3_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG3 register
 */
/*@{*/
#define HW_OCOTP_CFG3_ADDR(x)    ((uintptr_t)(x) + 0x440U)

#define HW_OCOTP_CFG3(x)         (*(__IO hw_ocotp_cfg3_t *) HW_OCOTP_CFG3_ADDR(x))
#define HW_OCOTP_CFG3_RD(x)      (HW_OCOTP_CFG3(x).U)
#define HW_OCOTP_CFG3_WR(x, v)   (HW_OCOTP_CFG3(x).U = (v))
#define HW_OCOTP_CFG3_SET(x, v)  (HW_OCOTP_CFG3_WR(x, HW_OCOTP_CFG3_RD(x) |  (v)))
#define HW_OCOTP_CFG3_CLR(x, v)  (HW_OCOTP_CFG3_WR(x, HW_OCOTP_CFG3_RD(x) & ~(v)))
#define HW_OCOTP_CFG3_TOG(x, v)  (HW_OCOTP_CFG3_WR(x, HW_OCOTP_CFG3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG3 bitfields
 */

/*!
 * @name Register OCOTP_CFG3, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 0, word 4 (ADDR = 0x04). These bits become
 * read-only after the HW_OCOTP_LOCK_TESTER[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG3_BITS   (0U)          /*!< Bit position for OCOTP_CFG3_BITS. */
#define BM_OCOTP_CFG3_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG3_BITS. */
#define BS_OCOTP_CFG3_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG3_BITS. */

/*! @brief Read current value of the OCOTP_CFG3_BITS field. */
#define BR_OCOTP_CFG3_BITS(x) (HW_OCOTP_CFG3(x).U)

/*! @brief Format value for bitfield OCOTP_CFG3_BITS. */
#define BF_OCOTP_CFG3_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG3_BITS) & BM_OCOTP_CFG3_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG3_BITS(x, v) (HW_OCOTP_CFG3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG4 - Value of OTP Bank0 Word5 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG4 - Value of OTP Bank0 Word5 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 5 (ADDR = 0x05). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg4
{
    uint32_t U;
    struct _hw_ocotp_cfg4_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg4_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG4 register
 */
/*@{*/
#define HW_OCOTP_CFG4_ADDR(x)    ((uintptr_t)(x) + 0x450U)

#define HW_OCOTP_CFG4(x)         (*(__IO hw_ocotp_cfg4_t *) HW_OCOTP_CFG4_ADDR(x))
#define HW_OCOTP_CFG4_RD(x)      (HW_OCOTP_CFG4(x).U)
#define HW_OCOTP_CFG4_WR(x, v)   (HW_OCOTP_CFG4(x).U = (v))
#define HW_OCOTP_CFG4_SET(x, v)  (HW_OCOTP_CFG4_WR(x, HW_OCOTP_CFG4_RD(x) |  (v)))
#define HW_OCOTP_CFG4_CLR(x, v)  (HW_OCOTP_CFG4_WR(x, HW_OCOTP_CFG4_RD(x) & ~(v)))
#define HW_OCOTP_CFG4_TOG(x, v)  (HW_OCOTP_CFG4_WR(x, HW_OCOTP_CFG4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG4 bitfields
 */

/*!
 * @name Register OCOTP_CFG4, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 0, word 5 (ADDR = 0x05). These bits become
 * read-only after the HW_OCOTP_LOCK_BOOT_CFG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG4_BITS   (0U)          /*!< Bit position for OCOTP_CFG4_BITS. */
#define BM_OCOTP_CFG4_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG4_BITS. */
#define BS_OCOTP_CFG4_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG4_BITS. */

/*! @brief Read current value of the OCOTP_CFG4_BITS field. */
#define BR_OCOTP_CFG4_BITS(x) (HW_OCOTP_CFG4(x).U)

/*! @brief Format value for bitfield OCOTP_CFG4_BITS. */
#define BF_OCOTP_CFG4_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG4_BITS) & BM_OCOTP_CFG4_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG4_BITS(x, v) (HW_OCOTP_CFG4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG5 - Value of OTP Bank0 Word6 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG5 - Value of OTP Bank0 Word6 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 6 (ADDR = 0x06). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg5
{
    uint32_t U;
    struct _hw_ocotp_cfg5_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg5_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG5 register
 */
/*@{*/
#define HW_OCOTP_CFG5_ADDR(x)    ((uintptr_t)(x) + 0x460U)

#define HW_OCOTP_CFG5(x)         (*(__IO hw_ocotp_cfg5_t *) HW_OCOTP_CFG5_ADDR(x))
#define HW_OCOTP_CFG5_RD(x)      (HW_OCOTP_CFG5(x).U)
#define HW_OCOTP_CFG5_WR(x, v)   (HW_OCOTP_CFG5(x).U = (v))
#define HW_OCOTP_CFG5_SET(x, v)  (HW_OCOTP_CFG5_WR(x, HW_OCOTP_CFG5_RD(x) |  (v)))
#define HW_OCOTP_CFG5_CLR(x, v)  (HW_OCOTP_CFG5_WR(x, HW_OCOTP_CFG5_RD(x) & ~(v)))
#define HW_OCOTP_CFG5_TOG(x, v)  (HW_OCOTP_CFG5_WR(x, HW_OCOTP_CFG5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG5 bitfields
 */

/*!
 * @name Register OCOTP_CFG5, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 0, word 6 (ADDR = 0x06). These bits become
 * read-only after the HW_OCOTP_LOCK_BOOT_CFG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG5_BITS   (0U)          /*!< Bit position for OCOTP_CFG5_BITS. */
#define BM_OCOTP_CFG5_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG5_BITS. */
#define BS_OCOTP_CFG5_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG5_BITS. */

/*! @brief Read current value of the OCOTP_CFG5_BITS field. */
#define BR_OCOTP_CFG5_BITS(x) (HW_OCOTP_CFG5(x).U)

/*! @brief Format value for bitfield OCOTP_CFG5_BITS. */
#define BF_OCOTP_CFG5_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG5_BITS) & BM_OCOTP_CFG5_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG5_BITS(x, v) (HW_OCOTP_CFG5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_CFG6 - Value of OTP Bank0 Word7 (Configuration and Manufacturing Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_CFG6 - Value of OTP Bank0 Word7 (Configuration and Manufacturing Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 0, word
 * 7 (ADDR = 0x07). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_cfg6
{
    uint32_t U;
    struct _hw_ocotp_cfg6_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_cfg6_t;

/*!
 * @name Constants and macros for entire OCOTP_CFG6 register
 */
/*@{*/
#define HW_OCOTP_CFG6_ADDR(x)    ((uintptr_t)(x) + 0x470U)

#define HW_OCOTP_CFG6(x)         (*(__IO hw_ocotp_cfg6_t *) HW_OCOTP_CFG6_ADDR(x))
#define HW_OCOTP_CFG6_RD(x)      (HW_OCOTP_CFG6(x).U)
#define HW_OCOTP_CFG6_WR(x, v)   (HW_OCOTP_CFG6(x).U = (v))
#define HW_OCOTP_CFG6_SET(x, v)  (HW_OCOTP_CFG6_WR(x, HW_OCOTP_CFG6_RD(x) |  (v)))
#define HW_OCOTP_CFG6_CLR(x, v)  (HW_OCOTP_CFG6_WR(x, HW_OCOTP_CFG6_RD(x) & ~(v)))
#define HW_OCOTP_CFG6_TOG(x, v)  (HW_OCOTP_CFG6_WR(x, HW_OCOTP_CFG6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_CFG6 bitfields
 */

/*!
 * @name Register OCOTP_CFG6, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 0, word 7 (ADDR = 0x07). These bits become
 * read-only after the HW_OCOTP_LOCK_BOOT_CFG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_CFG6_BITS   (0U)          /*!< Bit position for OCOTP_CFG6_BITS. */
#define BM_OCOTP_CFG6_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_CFG6_BITS. */
#define BS_OCOTP_CFG6_BITS   (32U)         /*!< Bit field size in bits for OCOTP_CFG6_BITS. */

/*! @brief Read current value of the OCOTP_CFG6_BITS field. */
#define BR_OCOTP_CFG6_BITS(x) (HW_OCOTP_CFG6(x).U)

/*! @brief Format value for bitfield OCOTP_CFG6_BITS. */
#define BF_OCOTP_CFG6_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_CFG6_BITS) & BM_OCOTP_CFG6_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_CFG6_BITS(x, v) (HW_OCOTP_CFG6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MEM0 - Value of OTP Bank1 Word0 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MEM0 - Value of OTP Bank1 Word0 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 0 (ADDR = 0x08). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mem0
{
    uint32_t U;
    struct _hw_ocotp_mem0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mem0_t;

/*!
 * @name Constants and macros for entire OCOTP_MEM0 register
 */
/*@{*/
#define HW_OCOTP_MEM0_ADDR(x)    ((uintptr_t)(x) + 0x480U)

#define HW_OCOTP_MEM0(x)         (*(__IO hw_ocotp_mem0_t *) HW_OCOTP_MEM0_ADDR(x))
#define HW_OCOTP_MEM0_RD(x)      (HW_OCOTP_MEM0(x).U)
#define HW_OCOTP_MEM0_WR(x, v)   (HW_OCOTP_MEM0(x).U = (v))
#define HW_OCOTP_MEM0_SET(x, v)  (HW_OCOTP_MEM0_WR(x, HW_OCOTP_MEM0_RD(x) |  (v)))
#define HW_OCOTP_MEM0_CLR(x, v)  (HW_OCOTP_MEM0_WR(x, HW_OCOTP_MEM0_RD(x) & ~(v)))
#define HW_OCOTP_MEM0_TOG(x, v)  (HW_OCOTP_MEM0_WR(x, HW_OCOTP_MEM0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MEM0 bitfields
 */

/*!
 * @name Register OCOTP_MEM0, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 0 (ADDR = 0x08). These bits become
 * read-only after the HW_OCOTP_LOCK_MEM_TRIM[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_MEM0_BITS   (0U)          /*!< Bit position for OCOTP_MEM0_BITS. */
#define BM_OCOTP_MEM0_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MEM0_BITS. */
#define BS_OCOTP_MEM0_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MEM0_BITS. */

/*! @brief Read current value of the OCOTP_MEM0_BITS field. */
#define BR_OCOTP_MEM0_BITS(x) (HW_OCOTP_MEM0(x).U)

/*! @brief Format value for bitfield OCOTP_MEM0_BITS. */
#define BF_OCOTP_MEM0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MEM0_BITS) & BM_OCOTP_MEM0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MEM0_BITS(x, v) (HW_OCOTP_MEM0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MEM1 - Value of OTP Bank1 Word1 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MEM1 - Value of OTP Bank1 Word1 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 1 (ADDR = 0x09). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mem1
{
    uint32_t U;
    struct _hw_ocotp_mem1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mem1_t;

/*!
 * @name Constants and macros for entire OCOTP_MEM1 register
 */
/*@{*/
#define HW_OCOTP_MEM1_ADDR(x)    ((uintptr_t)(x) + 0x490U)

#define HW_OCOTP_MEM1(x)         (*(__IO hw_ocotp_mem1_t *) HW_OCOTP_MEM1_ADDR(x))
#define HW_OCOTP_MEM1_RD(x)      (HW_OCOTP_MEM1(x).U)
#define HW_OCOTP_MEM1_WR(x, v)   (HW_OCOTP_MEM1(x).U = (v))
#define HW_OCOTP_MEM1_SET(x, v)  (HW_OCOTP_MEM1_WR(x, HW_OCOTP_MEM1_RD(x) |  (v)))
#define HW_OCOTP_MEM1_CLR(x, v)  (HW_OCOTP_MEM1_WR(x, HW_OCOTP_MEM1_RD(x) & ~(v)))
#define HW_OCOTP_MEM1_TOG(x, v)  (HW_OCOTP_MEM1_WR(x, HW_OCOTP_MEM1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MEM1 bitfields
 */

/*!
 * @name Register OCOTP_MEM1, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 1 (ADDR = 0x09). These bits become
 * read-only after the HW_OCOTP_LOCK_MEM_TRIM[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_MEM1_BITS   (0U)          /*!< Bit position for OCOTP_MEM1_BITS. */
#define BM_OCOTP_MEM1_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MEM1_BITS. */
#define BS_OCOTP_MEM1_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MEM1_BITS. */

/*! @brief Read current value of the OCOTP_MEM1_BITS field. */
#define BR_OCOTP_MEM1_BITS(x) (HW_OCOTP_MEM1(x).U)

/*! @brief Format value for bitfield OCOTP_MEM1_BITS. */
#define BF_OCOTP_MEM1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MEM1_BITS) & BM_OCOTP_MEM1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MEM1_BITS(x, v) (HW_OCOTP_MEM1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MEM2 - Value of OTP Bank1 Word2 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MEM2 - Value of OTP Bank1 Word2 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 2 (ADDR = 0x0A). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mem2
{
    uint32_t U;
    struct _hw_ocotp_mem2_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mem2_t;

/*!
 * @name Constants and macros for entire OCOTP_MEM2 register
 */
/*@{*/
#define HW_OCOTP_MEM2_ADDR(x)    ((uintptr_t)(x) + 0x4A0U)

#define HW_OCOTP_MEM2(x)         (*(__IO hw_ocotp_mem2_t *) HW_OCOTP_MEM2_ADDR(x))
#define HW_OCOTP_MEM2_RD(x)      (HW_OCOTP_MEM2(x).U)
#define HW_OCOTP_MEM2_WR(x, v)   (HW_OCOTP_MEM2(x).U = (v))
#define HW_OCOTP_MEM2_SET(x, v)  (HW_OCOTP_MEM2_WR(x, HW_OCOTP_MEM2_RD(x) |  (v)))
#define HW_OCOTP_MEM2_CLR(x, v)  (HW_OCOTP_MEM2_WR(x, HW_OCOTP_MEM2_RD(x) & ~(v)))
#define HW_OCOTP_MEM2_TOG(x, v)  (HW_OCOTP_MEM2_WR(x, HW_OCOTP_MEM2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MEM2 bitfields
 */

/*!
 * @name Register OCOTP_MEM2, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 2 (ADDR = 0x0A). These bits become
 * read-only after the HW_OCOTP_LOCK_MEM_TRIM[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_MEM2_BITS   (0U)          /*!< Bit position for OCOTP_MEM2_BITS. */
#define BM_OCOTP_MEM2_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MEM2_BITS. */
#define BS_OCOTP_MEM2_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MEM2_BITS. */

/*! @brief Read current value of the OCOTP_MEM2_BITS field. */
#define BR_OCOTP_MEM2_BITS(x) (HW_OCOTP_MEM2(x).U)

/*! @brief Format value for bitfield OCOTP_MEM2_BITS. */
#define BF_OCOTP_MEM2_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MEM2_BITS) & BM_OCOTP_MEM2_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MEM2_BITS(x, v) (HW_OCOTP_MEM2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MEM3 - Value of OTP Bank1 Word3 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MEM3 - Value of OTP Bank1 Word3 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 3 (ADDR = 0x0B). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mem3
{
    uint32_t U;
    struct _hw_ocotp_mem3_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mem3_t;

/*!
 * @name Constants and macros for entire OCOTP_MEM3 register
 */
/*@{*/
#define HW_OCOTP_MEM3_ADDR(x)    ((uintptr_t)(x) + 0x4B0U)

#define HW_OCOTP_MEM3(x)         (*(__IO hw_ocotp_mem3_t *) HW_OCOTP_MEM3_ADDR(x))
#define HW_OCOTP_MEM3_RD(x)      (HW_OCOTP_MEM3(x).U)
#define HW_OCOTP_MEM3_WR(x, v)   (HW_OCOTP_MEM3(x).U = (v))
#define HW_OCOTP_MEM3_SET(x, v)  (HW_OCOTP_MEM3_WR(x, HW_OCOTP_MEM3_RD(x) |  (v)))
#define HW_OCOTP_MEM3_CLR(x, v)  (HW_OCOTP_MEM3_WR(x, HW_OCOTP_MEM3_RD(x) & ~(v)))
#define HW_OCOTP_MEM3_TOG(x, v)  (HW_OCOTP_MEM3_WR(x, HW_OCOTP_MEM3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MEM3 bitfields
 */

/*!
 * @name Register OCOTP_MEM3, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 3 (ADDR = 0x0B). These bits become
 * read-only after the HW_OCOTP_LOCK_MEM_TRIM[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_MEM3_BITS   (0U)          /*!< Bit position for OCOTP_MEM3_BITS. */
#define BM_OCOTP_MEM3_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MEM3_BITS. */
#define BS_OCOTP_MEM3_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MEM3_BITS. */

/*! @brief Read current value of the OCOTP_MEM3_BITS field. */
#define BR_OCOTP_MEM3_BITS(x) (HW_OCOTP_MEM3(x).U)

/*! @brief Format value for bitfield OCOTP_MEM3_BITS. */
#define BF_OCOTP_MEM3_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MEM3_BITS) & BM_OCOTP_MEM3_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MEM3_BITS(x, v) (HW_OCOTP_MEM3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MEM4 - Value of OTP Bank1 Word4 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MEM4 - Value of OTP Bank1 Word4 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 4 (ADDR = 0x0C). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mem4
{
    uint32_t U;
    struct _hw_ocotp_mem4_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mem4_t;

/*!
 * @name Constants and macros for entire OCOTP_MEM4 register
 */
/*@{*/
#define HW_OCOTP_MEM4_ADDR(x)    ((uintptr_t)(x) + 0x4C0U)

#define HW_OCOTP_MEM4(x)         (*(__IO hw_ocotp_mem4_t *) HW_OCOTP_MEM4_ADDR(x))
#define HW_OCOTP_MEM4_RD(x)      (HW_OCOTP_MEM4(x).U)
#define HW_OCOTP_MEM4_WR(x, v)   (HW_OCOTP_MEM4(x).U = (v))
#define HW_OCOTP_MEM4_SET(x, v)  (HW_OCOTP_MEM4_WR(x, HW_OCOTP_MEM4_RD(x) |  (v)))
#define HW_OCOTP_MEM4_CLR(x, v)  (HW_OCOTP_MEM4_WR(x, HW_OCOTP_MEM4_RD(x) & ~(v)))
#define HW_OCOTP_MEM4_TOG(x, v)  (HW_OCOTP_MEM4_WR(x, HW_OCOTP_MEM4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MEM4 bitfields
 */

/*!
 * @name Register OCOTP_MEM4, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 4 (ADDR = 0x0C). These bits become
 * read-only after the HW_OCOTP_LOCK_MEM_TRIM[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_MEM4_BITS   (0U)          /*!< Bit position for OCOTP_MEM4_BITS. */
#define BM_OCOTP_MEM4_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MEM4_BITS. */
#define BS_OCOTP_MEM4_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MEM4_BITS. */

/*! @brief Read current value of the OCOTP_MEM4_BITS field. */
#define BR_OCOTP_MEM4_BITS(x) (HW_OCOTP_MEM4(x).U)

/*! @brief Format value for bitfield OCOTP_MEM4_BITS. */
#define BF_OCOTP_MEM4_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MEM4_BITS) & BM_OCOTP_MEM4_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MEM4_BITS(x, v) (HW_OCOTP_MEM4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_ANA0 - Value of OTP Bank1 Word5 (Memory Related Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_ANA0 - Value of OTP Bank1 Word5 (Memory Related Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 5 (ADDR = 0x0D). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_ana0
{
    uint32_t U;
    struct _hw_ocotp_ana0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_ana0_t;

/*!
 * @name Constants and macros for entire OCOTP_ANA0 register
 */
/*@{*/
#define HW_OCOTP_ANA0_ADDR(x)    ((uintptr_t)(x) + 0x4D0U)

#define HW_OCOTP_ANA0(x)         (*(__IO hw_ocotp_ana0_t *) HW_OCOTP_ANA0_ADDR(x))
#define HW_OCOTP_ANA0_RD(x)      (HW_OCOTP_ANA0(x).U)
#define HW_OCOTP_ANA0_WR(x, v)   (HW_OCOTP_ANA0(x).U = (v))
#define HW_OCOTP_ANA0_SET(x, v)  (HW_OCOTP_ANA0_WR(x, HW_OCOTP_ANA0_RD(x) |  (v)))
#define HW_OCOTP_ANA0_CLR(x, v)  (HW_OCOTP_ANA0_WR(x, HW_OCOTP_ANA0_RD(x) & ~(v)))
#define HW_OCOTP_ANA0_TOG(x, v)  (HW_OCOTP_ANA0_WR(x, HW_OCOTP_ANA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_ANA0 bitfields
 */

/*!
 * @name Register OCOTP_ANA0, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 5 (ADDR = 0x0D). These bits become
 * read-only after the HW_OCOTP_LOCK_ANALOG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_ANA0_BITS   (0U)          /*!< Bit position for OCOTP_ANA0_BITS. */
#define BM_OCOTP_ANA0_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_ANA0_BITS. */
#define BS_OCOTP_ANA0_BITS   (32U)         /*!< Bit field size in bits for OCOTP_ANA0_BITS. */

/*! @brief Read current value of the OCOTP_ANA0_BITS field. */
#define BR_OCOTP_ANA0_BITS(x) (HW_OCOTP_ANA0(x).U)

/*! @brief Format value for bitfield OCOTP_ANA0_BITS. */
#define BF_OCOTP_ANA0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_ANA0_BITS) & BM_OCOTP_ANA0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_ANA0_BITS(x, v) (HW_OCOTP_ANA0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_ANA1 - Value of OTP Bank1 Word6 (General Purpose Customer Defined Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_ANA1 - Value of OTP Bank1 Word6 (General Purpose Customer Defined Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 6 (ADDR = 0x0E). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_ana1
{
    uint32_t U;
    struct _hw_ocotp_ana1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_ana1_t;

/*!
 * @name Constants and macros for entire OCOTP_ANA1 register
 */
/*@{*/
#define HW_OCOTP_ANA1_ADDR(x)    ((uintptr_t)(x) + 0x4E0U)

#define HW_OCOTP_ANA1(x)         (*(__IO hw_ocotp_ana1_t *) HW_OCOTP_ANA1_ADDR(x))
#define HW_OCOTP_ANA1_RD(x)      (HW_OCOTP_ANA1(x).U)
#define HW_OCOTP_ANA1_WR(x, v)   (HW_OCOTP_ANA1(x).U = (v))
#define HW_OCOTP_ANA1_SET(x, v)  (HW_OCOTP_ANA1_WR(x, HW_OCOTP_ANA1_RD(x) |  (v)))
#define HW_OCOTP_ANA1_CLR(x, v)  (HW_OCOTP_ANA1_WR(x, HW_OCOTP_ANA1_RD(x) & ~(v)))
#define HW_OCOTP_ANA1_TOG(x, v)  (HW_OCOTP_ANA1_WR(x, HW_OCOTP_ANA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_ANA1 bitfields
 */

/*!
 * @name Register OCOTP_ANA1, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 6 (ADDR = 0x0E). These bits become
 * read-only after the HW_OCOTP_LOCK_ANALOG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_ANA1_BITS   (0U)          /*!< Bit position for OCOTP_ANA1_BITS. */
#define BM_OCOTP_ANA1_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_ANA1_BITS. */
#define BS_OCOTP_ANA1_BITS   (32U)         /*!< Bit field size in bits for OCOTP_ANA1_BITS. */

/*! @brief Read current value of the OCOTP_ANA1_BITS field. */
#define BR_OCOTP_ANA1_BITS(x) (HW_OCOTP_ANA1(x).U)

/*! @brief Format value for bitfield OCOTP_ANA1_BITS. */
#define BF_OCOTP_ANA1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_ANA1_BITS) & BM_OCOTP_ANA1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_ANA1_BITS(x, v) (HW_OCOTP_ANA1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_ANA2 - Value of OTP Bank1 Word7 (General Purpose Customer Defined Info.)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_ANA2 - Value of OTP Bank1 Word7 (General Purpose Customer Defined Info.) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP bank 1, word
 * 7 (ADDR = 0x0F). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_ana2
{
    uint32_t U;
    struct _hw_ocotp_ana2_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_ana2_t;

/*!
 * @name Constants and macros for entire OCOTP_ANA2 register
 */
/*@{*/
#define HW_OCOTP_ANA2_ADDR(x)    ((uintptr_t)(x) + 0x4F0U)

#define HW_OCOTP_ANA2(x)         (*(__IO hw_ocotp_ana2_t *) HW_OCOTP_ANA2_ADDR(x))
#define HW_OCOTP_ANA2_RD(x)      (HW_OCOTP_ANA2(x).U)
#define HW_OCOTP_ANA2_WR(x, v)   (HW_OCOTP_ANA2(x).U = (v))
#define HW_OCOTP_ANA2_SET(x, v)  (HW_OCOTP_ANA2_WR(x, HW_OCOTP_ANA2_RD(x) |  (v)))
#define HW_OCOTP_ANA2_CLR(x, v)  (HW_OCOTP_ANA2_WR(x, HW_OCOTP_ANA2_RD(x) & ~(v)))
#define HW_OCOTP_ANA2_TOG(x, v)  (HW_OCOTP_ANA2_WR(x, HW_OCOTP_ANA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_ANA2 bitfields
 */

/*!
 * @name Register OCOTP_ANA2, field BITS[31:0] (RW)
 *
 * Reflects value of OTP bank 1, word 7 (ADDR = 0x0F). These bits become
 * read-only after the HW_OCOTP_LOCK_ANALOG[1] bit is set.
 */
/*@{*/
#define BP_OCOTP_ANA2_BITS   (0U)          /*!< Bit position for OCOTP_ANA2_BITS. */
#define BM_OCOTP_ANA2_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_ANA2_BITS. */
#define BS_OCOTP_ANA2_BITS   (32U)         /*!< Bit field size in bits for OCOTP_ANA2_BITS. */

/*! @brief Read current value of the OCOTP_ANA2_BITS field. */
#define BR_OCOTP_ANA2_BITS(x) (HW_OCOTP_ANA2(x).U)

/*! @brief Format value for bitfield OCOTP_ANA2_BITS. */
#define BF_OCOTP_ANA2_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_ANA2_BITS) & BM_OCOTP_ANA2_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_ANA2_BITS(x, v) (HW_OCOTP_ANA2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK0 - Shadow Register for OTP Bank3 Word0 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK0 - Shadow Register for OTP Bank3 Word0 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 0 (ADDR = 0x18). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk0
{
    uint32_t U;
    struct _hw_ocotp_srk0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk0_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK0 register
 */
/*@{*/
#define HW_OCOTP_SRK0_ADDR(x)    ((uintptr_t)(x) + 0x580U)

#define HW_OCOTP_SRK0(x)         (*(__IO hw_ocotp_srk0_t *) HW_OCOTP_SRK0_ADDR(x))
#define HW_OCOTP_SRK0_RD(x)      (HW_OCOTP_SRK0(x).U)
#define HW_OCOTP_SRK0_WR(x, v)   (HW_OCOTP_SRK0(x).U = (v))
#define HW_OCOTP_SRK0_SET(x, v)  (HW_OCOTP_SRK0_WR(x, HW_OCOTP_SRK0_RD(x) |  (v)))
#define HW_OCOTP_SRK0_CLR(x, v)  (HW_OCOTP_SRK0_WR(x, HW_OCOTP_SRK0_RD(x) & ~(v)))
#define HW_OCOTP_SRK0_TOG(x, v)  (HW_OCOTP_SRK0_WR(x, HW_OCOTP_SRK0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK0 bitfields
 */

/*!
 * @name Register OCOTP_SRK0, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word0 (Copy of OTP Bank 3,
 * word 0 (ADDR = 0x1C)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK0_BITS   (0U)          /*!< Bit position for OCOTP_SRK0_BITS. */
#define BM_OCOTP_SRK0_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK0_BITS. */
#define BS_OCOTP_SRK0_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK0_BITS. */

/*! @brief Read current value of the OCOTP_SRK0_BITS field. */
#define BR_OCOTP_SRK0_BITS(x) (HW_OCOTP_SRK0(x).U)

/*! @brief Format value for bitfield OCOTP_SRK0_BITS. */
#define BF_OCOTP_SRK0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK0_BITS) & BM_OCOTP_SRK0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK0_BITS(x, v) (HW_OCOTP_SRK0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK1 - Shadow Register for OTP Bank3 Word1 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK1 - Shadow Register for OTP Bank3 Word1 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 1 (ADDR = 0x19). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk1
{
    uint32_t U;
    struct _hw_ocotp_srk1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk1_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK1 register
 */
/*@{*/
#define HW_OCOTP_SRK1_ADDR(x)    ((uintptr_t)(x) + 0x590U)

#define HW_OCOTP_SRK1(x)         (*(__IO hw_ocotp_srk1_t *) HW_OCOTP_SRK1_ADDR(x))
#define HW_OCOTP_SRK1_RD(x)      (HW_OCOTP_SRK1(x).U)
#define HW_OCOTP_SRK1_WR(x, v)   (HW_OCOTP_SRK1(x).U = (v))
#define HW_OCOTP_SRK1_SET(x, v)  (HW_OCOTP_SRK1_WR(x, HW_OCOTP_SRK1_RD(x) |  (v)))
#define HW_OCOTP_SRK1_CLR(x, v)  (HW_OCOTP_SRK1_WR(x, HW_OCOTP_SRK1_RD(x) & ~(v)))
#define HW_OCOTP_SRK1_TOG(x, v)  (HW_OCOTP_SRK1_WR(x, HW_OCOTP_SRK1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK1 bitfields
 */

/*!
 * @name Register OCOTP_SRK1, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word1 (Copy of OTP Bank 3,
 * word 1 (ADDR = 0x1D)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK1_BITS   (0U)          /*!< Bit position for OCOTP_SRK1_BITS. */
#define BM_OCOTP_SRK1_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK1_BITS. */
#define BS_OCOTP_SRK1_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK1_BITS. */

/*! @brief Read current value of the OCOTP_SRK1_BITS field. */
#define BR_OCOTP_SRK1_BITS(x) (HW_OCOTP_SRK1(x).U)

/*! @brief Format value for bitfield OCOTP_SRK1_BITS. */
#define BF_OCOTP_SRK1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK1_BITS) & BM_OCOTP_SRK1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK1_BITS(x, v) (HW_OCOTP_SRK1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK2 - Shadow Register for OTP Bank3 Word2 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK2 - Shadow Register for OTP Bank3 Word2 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 2 (ADDR = 0x1A). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk2
{
    uint32_t U;
    struct _hw_ocotp_srk2_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk2_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK2 register
 */
/*@{*/
#define HW_OCOTP_SRK2_ADDR(x)    ((uintptr_t)(x) + 0x5A0U)

#define HW_OCOTP_SRK2(x)         (*(__IO hw_ocotp_srk2_t *) HW_OCOTP_SRK2_ADDR(x))
#define HW_OCOTP_SRK2_RD(x)      (HW_OCOTP_SRK2(x).U)
#define HW_OCOTP_SRK2_WR(x, v)   (HW_OCOTP_SRK2(x).U = (v))
#define HW_OCOTP_SRK2_SET(x, v)  (HW_OCOTP_SRK2_WR(x, HW_OCOTP_SRK2_RD(x) |  (v)))
#define HW_OCOTP_SRK2_CLR(x, v)  (HW_OCOTP_SRK2_WR(x, HW_OCOTP_SRK2_RD(x) & ~(v)))
#define HW_OCOTP_SRK2_TOG(x, v)  (HW_OCOTP_SRK2_WR(x, HW_OCOTP_SRK2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK2 bitfields
 */

/*!
 * @name Register OCOTP_SRK2, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word2 (Copy of OTP Bank 3,
 * word 2 (ADDR = 0x1E)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK2_BITS   (0U)          /*!< Bit position for OCOTP_SRK2_BITS. */
#define BM_OCOTP_SRK2_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK2_BITS. */
#define BS_OCOTP_SRK2_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK2_BITS. */

/*! @brief Read current value of the OCOTP_SRK2_BITS field. */
#define BR_OCOTP_SRK2_BITS(x) (HW_OCOTP_SRK2(x).U)

/*! @brief Format value for bitfield OCOTP_SRK2_BITS. */
#define BF_OCOTP_SRK2_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK2_BITS) & BM_OCOTP_SRK2_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK2_BITS(x, v) (HW_OCOTP_SRK2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK3 - Shadow Register for OTP Bank3 Word3 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK3 - Shadow Register for OTP Bank3 Word3 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 3 (ADDR = 0x1B). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk3
{
    uint32_t U;
    struct _hw_ocotp_srk3_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk3_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK3 register
 */
/*@{*/
#define HW_OCOTP_SRK3_ADDR(x)    ((uintptr_t)(x) + 0x5B0U)

#define HW_OCOTP_SRK3(x)         (*(__IO hw_ocotp_srk3_t *) HW_OCOTP_SRK3_ADDR(x))
#define HW_OCOTP_SRK3_RD(x)      (HW_OCOTP_SRK3(x).U)
#define HW_OCOTP_SRK3_WR(x, v)   (HW_OCOTP_SRK3(x).U = (v))
#define HW_OCOTP_SRK3_SET(x, v)  (HW_OCOTP_SRK3_WR(x, HW_OCOTP_SRK3_RD(x) |  (v)))
#define HW_OCOTP_SRK3_CLR(x, v)  (HW_OCOTP_SRK3_WR(x, HW_OCOTP_SRK3_RD(x) & ~(v)))
#define HW_OCOTP_SRK3_TOG(x, v)  (HW_OCOTP_SRK3_WR(x, HW_OCOTP_SRK3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK3 bitfields
 */

/*!
 * @name Register OCOTP_SRK3, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word3 (Copy of OTP Bank 3,
 * word 3 (ADDR = 0x1F)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK3_BITS   (0U)          /*!< Bit position for OCOTP_SRK3_BITS. */
#define BM_OCOTP_SRK3_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK3_BITS. */
#define BS_OCOTP_SRK3_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK3_BITS. */

/*! @brief Read current value of the OCOTP_SRK3_BITS field. */
#define BR_OCOTP_SRK3_BITS(x) (HW_OCOTP_SRK3(x).U)

/*! @brief Format value for bitfield OCOTP_SRK3_BITS. */
#define BF_OCOTP_SRK3_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK3_BITS) & BM_OCOTP_SRK3_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK3_BITS(x, v) (HW_OCOTP_SRK3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK4 - Shadow Register for OTP Bank3 Word4 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK4 - Shadow Register for OTP Bank3 Word4 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 4 (ADDR = 0x1C). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk4
{
    uint32_t U;
    struct _hw_ocotp_srk4_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk4_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK4 register
 */
/*@{*/
#define HW_OCOTP_SRK4_ADDR(x)    ((uintptr_t)(x) + 0x5C0U)

#define HW_OCOTP_SRK4(x)         (*(__IO hw_ocotp_srk4_t *) HW_OCOTP_SRK4_ADDR(x))
#define HW_OCOTP_SRK4_RD(x)      (HW_OCOTP_SRK4(x).U)
#define HW_OCOTP_SRK4_WR(x, v)   (HW_OCOTP_SRK4(x).U = (v))
#define HW_OCOTP_SRK4_SET(x, v)  (HW_OCOTP_SRK4_WR(x, HW_OCOTP_SRK4_RD(x) |  (v)))
#define HW_OCOTP_SRK4_CLR(x, v)  (HW_OCOTP_SRK4_WR(x, HW_OCOTP_SRK4_RD(x) & ~(v)))
#define HW_OCOTP_SRK4_TOG(x, v)  (HW_OCOTP_SRK4_WR(x, HW_OCOTP_SRK4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK4 bitfields
 */

/*!
 * @name Register OCOTP_SRK4, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word4 (Copy of OTP Bank 3,
 * word 4 (ADDR = 0x20)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK4_BITS   (0U)          /*!< Bit position for OCOTP_SRK4_BITS. */
#define BM_OCOTP_SRK4_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK4_BITS. */
#define BS_OCOTP_SRK4_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK4_BITS. */

/*! @brief Read current value of the OCOTP_SRK4_BITS field. */
#define BR_OCOTP_SRK4_BITS(x) (HW_OCOTP_SRK4(x).U)

/*! @brief Format value for bitfield OCOTP_SRK4_BITS. */
#define BF_OCOTP_SRK4_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK4_BITS) & BM_OCOTP_SRK4_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK4_BITS(x, v) (HW_OCOTP_SRK4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK5 - Shadow Register for OTP Bank3 Word5 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK5 - Shadow Register for OTP Bank3 Word5 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 5 (ADDR = 0x1D). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk5
{
    uint32_t U;
    struct _hw_ocotp_srk5_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk5_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK5 register
 */
/*@{*/
#define HW_OCOTP_SRK5_ADDR(x)    ((uintptr_t)(x) + 0x5D0U)

#define HW_OCOTP_SRK5(x)         (*(__IO hw_ocotp_srk5_t *) HW_OCOTP_SRK5_ADDR(x))
#define HW_OCOTP_SRK5_RD(x)      (HW_OCOTP_SRK5(x).U)
#define HW_OCOTP_SRK5_WR(x, v)   (HW_OCOTP_SRK5(x).U = (v))
#define HW_OCOTP_SRK5_SET(x, v)  (HW_OCOTP_SRK5_WR(x, HW_OCOTP_SRK5_RD(x) |  (v)))
#define HW_OCOTP_SRK5_CLR(x, v)  (HW_OCOTP_SRK5_WR(x, HW_OCOTP_SRK5_RD(x) & ~(v)))
#define HW_OCOTP_SRK5_TOG(x, v)  (HW_OCOTP_SRK5_WR(x, HW_OCOTP_SRK5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK5 bitfields
 */

/*!
 * @name Register OCOTP_SRK5, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word5 (Copy of OTP Bank 3,
 * word 5 (ADDR = 0x21)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK5_BITS   (0U)          /*!< Bit position for OCOTP_SRK5_BITS. */
#define BM_OCOTP_SRK5_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK5_BITS. */
#define BS_OCOTP_SRK5_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK5_BITS. */

/*! @brief Read current value of the OCOTP_SRK5_BITS field. */
#define BR_OCOTP_SRK5_BITS(x) (HW_OCOTP_SRK5(x).U)

/*! @brief Format value for bitfield OCOTP_SRK5_BITS. */
#define BF_OCOTP_SRK5_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK5_BITS) & BM_OCOTP_SRK5_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK5_BITS(x, v) (HW_OCOTP_SRK5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK6 - Shadow Register for OTP Bank3 Word6 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK6 - Shadow Register for OTP Bank3 Word6 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 6 (ADDR = 0x1E). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk6
{
    uint32_t U;
    struct _hw_ocotp_srk6_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk6_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK6 register
 */
/*@{*/
#define HW_OCOTP_SRK6_ADDR(x)    ((uintptr_t)(x) + 0x5E0U)

#define HW_OCOTP_SRK6(x)         (*(__IO hw_ocotp_srk6_t *) HW_OCOTP_SRK6_ADDR(x))
#define HW_OCOTP_SRK6_RD(x)      (HW_OCOTP_SRK6(x).U)
#define HW_OCOTP_SRK6_WR(x, v)   (HW_OCOTP_SRK6(x).U = (v))
#define HW_OCOTP_SRK6_SET(x, v)  (HW_OCOTP_SRK6_WR(x, HW_OCOTP_SRK6_RD(x) |  (v)))
#define HW_OCOTP_SRK6_CLR(x, v)  (HW_OCOTP_SRK6_WR(x, HW_OCOTP_SRK6_RD(x) & ~(v)))
#define HW_OCOTP_SRK6_TOG(x, v)  (HW_OCOTP_SRK6_WR(x, HW_OCOTP_SRK6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK6 bitfields
 */

/*!
 * @name Register OCOTP_SRK6, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word6 (Copy of OTP Bank 3,
 * word 6 (ADDR = 0x22)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK6_BITS   (0U)          /*!< Bit position for OCOTP_SRK6_BITS. */
#define BM_OCOTP_SRK6_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK6_BITS. */
#define BS_OCOTP_SRK6_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK6_BITS. */

/*! @brief Read current value of the OCOTP_SRK6_BITS field. */
#define BR_OCOTP_SRK6_BITS(x) (HW_OCOTP_SRK6(x).U)

/*! @brief Format value for bitfield OCOTP_SRK6_BITS. */
#define BF_OCOTP_SRK6_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK6_BITS) & BM_OCOTP_SRK6_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK6_BITS(x, v) (HW_OCOTP_SRK6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK7 - Shadow Register for OTP Bank3 Word7 (SRK Hash)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK7 - Shadow Register for OTP Bank3 Word7 (SRK Hash) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS]. Shadowed memory mapped access to OTP Bank 3, word
 * 7 (ADDR = 0x1F). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk7
{
    uint32_t U;
    struct _hw_ocotp_srk7_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk7_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK7 register
 */
/*@{*/
#define HW_OCOTP_SRK7_ADDR(x)    ((uintptr_t)(x) + 0x5F0U)

#define HW_OCOTP_SRK7(x)         (*(__IO hw_ocotp_srk7_t *) HW_OCOTP_SRK7_ADDR(x))
#define HW_OCOTP_SRK7_RD(x)      (HW_OCOTP_SRK7(x).U)
#define HW_OCOTP_SRK7_WR(x, v)   (HW_OCOTP_SRK7(x).U = (v))
#define HW_OCOTP_SRK7_SET(x, v)  (HW_OCOTP_SRK7_WR(x, HW_OCOTP_SRK7_RD(x) |  (v)))
#define HW_OCOTP_SRK7_CLR(x, v)  (HW_OCOTP_SRK7_WR(x, HW_OCOTP_SRK7_RD(x) & ~(v)))
#define HW_OCOTP_SRK7_TOG(x, v)  (HW_OCOTP_SRK7_WR(x, HW_OCOTP_SRK7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK7 bitfields
 */

/*!
 * @name Register OCOTP_SRK7, field BITS[31:0] (RW)
 *
 * Shadow register for the hash of the Super Root Key word7 (Copy of OTP Bank 3,
 * word 7 (ADDR = 0x23)). These bits become read-only after the
 * HW_OCOTP_LOCK_SRK bit is set.
 */
/*@{*/
#define BP_OCOTP_SRK7_BITS   (0U)          /*!< Bit position for OCOTP_SRK7_BITS. */
#define BM_OCOTP_SRK7_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK7_BITS. */
#define BS_OCOTP_SRK7_BITS   (32U)         /*!< Bit field size in bits for OCOTP_SRK7_BITS. */

/*! @brief Read current value of the OCOTP_SRK7_BITS field. */
#define BR_OCOTP_SRK7_BITS(x) (HW_OCOTP_SRK7(x).U)

/*! @brief Format value for bitfield OCOTP_SRK7_BITS. */
#define BF_OCOTP_SRK7_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK7_BITS) & BM_OCOTP_SRK7_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK7_BITS(x, v) (HW_OCOTP_SRK7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_RESP0 - Value of OTP Bank4 Word0 (Secure JTAG Response Field)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_RESP0 - Value of OTP Bank4 Word0 (Secure JTAG Response Field) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 0 (ADDR = 0x20). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_resp0
{
    uint32_t U;
    struct _hw_ocotp_resp0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_resp0_t;

/*!
 * @name Constants and macros for entire OCOTP_RESP0 register
 */
/*@{*/
#define HW_OCOTP_RESP0_ADDR(x)   ((uintptr_t)(x) + 0x600U)

#define HW_OCOTP_RESP0(x)        (*(__IO hw_ocotp_resp0_t *) HW_OCOTP_RESP0_ADDR(x))
#define HW_OCOTP_RESP0_RD(x)     (HW_OCOTP_RESP0(x).U)
#define HW_OCOTP_RESP0_WR(x, v)  (HW_OCOTP_RESP0(x).U = (v))
#define HW_OCOTP_RESP0_SET(x, v) (HW_OCOTP_RESP0_WR(x, HW_OCOTP_RESP0_RD(x) |  (v)))
#define HW_OCOTP_RESP0_CLR(x, v) (HW_OCOTP_RESP0_WR(x, HW_OCOTP_RESP0_RD(x) & ~(v)))
#define HW_OCOTP_RESP0_TOG(x, v) (HW_OCOTP_RESP0_WR(x, HW_OCOTP_RESP0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_RESP0 bitfields
 */

/*!
 * @name Register OCOTP_RESP0, field BITS[31:0] (RW)
 *
 * Shadow register for the SJC_RESP Key word0 (Copy of OTP Bank 4, word 0 (ADDR
 * = 0x20)). These bits can be not read and written after the
 * HW_OCOTP_LOCK_SJC_RESP bit is set. If read, returns 0xBADA_BADA and sets HW_OCOTP_CTRL[ERROR].
 */
/*@{*/
#define BP_OCOTP_RESP0_BITS  (0U)          /*!< Bit position for OCOTP_RESP0_BITS. */
#define BM_OCOTP_RESP0_BITS  (0xFFFFFFFFU) /*!< Bit mask for OCOTP_RESP0_BITS. */
#define BS_OCOTP_RESP0_BITS  (32U)         /*!< Bit field size in bits for OCOTP_RESP0_BITS. */

/*! @brief Read current value of the OCOTP_RESP0_BITS field. */
#define BR_OCOTP_RESP0_BITS(x) (HW_OCOTP_RESP0(x).U)

/*! @brief Format value for bitfield OCOTP_RESP0_BITS. */
#define BF_OCOTP_RESP0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_RESP0_BITS) & BM_OCOTP_RESP0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_RESP0_BITS(x, v) (HW_OCOTP_RESP0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_HSJC_RESP1 - Value of OTP Bank4 Word1 (Secure JTAG Response Field)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_HSJC_RESP1 - Value of OTP Bank4 Word1 (Secure JTAG Response Field) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 1 (ADDR = 0x21). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_hsjc_resp1
{
    uint32_t U;
    struct _hw_ocotp_hsjc_resp1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_hsjc_resp1_t;

/*!
 * @name Constants and macros for entire OCOTP_HSJC_RESP1 register
 */
/*@{*/
#define HW_OCOTP_HSJC_RESP1_ADDR(x) ((uintptr_t)(x) + 0x610U)

#define HW_OCOTP_HSJC_RESP1(x)   (*(__IO hw_ocotp_hsjc_resp1_t *) HW_OCOTP_HSJC_RESP1_ADDR(x))
#define HW_OCOTP_HSJC_RESP1_RD(x) (HW_OCOTP_HSJC_RESP1(x).U)
#define HW_OCOTP_HSJC_RESP1_WR(x, v) (HW_OCOTP_HSJC_RESP1(x).U = (v))
#define HW_OCOTP_HSJC_RESP1_SET(x, v) (HW_OCOTP_HSJC_RESP1_WR(x, HW_OCOTP_HSJC_RESP1_RD(x) |  (v)))
#define HW_OCOTP_HSJC_RESP1_CLR(x, v) (HW_OCOTP_HSJC_RESP1_WR(x, HW_OCOTP_HSJC_RESP1_RD(x) & ~(v)))
#define HW_OCOTP_HSJC_RESP1_TOG(x, v) (HW_OCOTP_HSJC_RESP1_WR(x, HW_OCOTP_HSJC_RESP1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_HSJC_RESP1 bitfields
 */

/*!
 * @name Register OCOTP_HSJC_RESP1, field BITS[31:0] (RW)
 *
 * Shadow register for the SJC_RESP Key word1 (Copy of OTP Bank 4, word 1 (ADDR
 * = 0x21)). These bits can be not read and written after the
 * HW_OCOTP_LOCK_SJC_RESP bit is set. If read, returns 0xBADA_BADA and sets HW_OCOTP_CTRL[ERROR].
 */
/*@{*/
#define BP_OCOTP_HSJC_RESP1_BITS (0U)      /*!< Bit position for OCOTP_HSJC_RESP1_BITS. */
#define BM_OCOTP_HSJC_RESP1_BITS (0xFFFFFFFFU) /*!< Bit mask for OCOTP_HSJC_RESP1_BITS. */
#define BS_OCOTP_HSJC_RESP1_BITS (32U)     /*!< Bit field size in bits for OCOTP_HSJC_RESP1_BITS. */

/*! @brief Read current value of the OCOTP_HSJC_RESP1_BITS field. */
#define BR_OCOTP_HSJC_RESP1_BITS(x) (HW_OCOTP_HSJC_RESP1(x).U)

/*! @brief Format value for bitfield OCOTP_HSJC_RESP1_BITS. */
#define BF_OCOTP_HSJC_RESP1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_HSJC_RESP1_BITS) & BM_OCOTP_HSJC_RESP1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_HSJC_RESP1_BITS(x, v) (HW_OCOTP_HSJC_RESP1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MAC0 - Value of OTP Bank4 Word2 (MAC Address)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MAC0 - Value of OTP Bank4 Word2 (MAC Address) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 2 (ADDR = 0x22). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mac0
{
    uint32_t U;
    struct _hw_ocotp_mac0_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mac0_t;

/*!
 * @name Constants and macros for entire OCOTP_MAC0 register
 */
/*@{*/
#define HW_OCOTP_MAC0_ADDR(x)    ((uintptr_t)(x) + 0x620U)

#define HW_OCOTP_MAC0(x)         (*(__IO hw_ocotp_mac0_t *) HW_OCOTP_MAC0_ADDR(x))
#define HW_OCOTP_MAC0_RD(x)      (HW_OCOTP_MAC0(x).U)
#define HW_OCOTP_MAC0_WR(x, v)   (HW_OCOTP_MAC0(x).U = (v))
#define HW_OCOTP_MAC0_SET(x, v)  (HW_OCOTP_MAC0_WR(x, HW_OCOTP_MAC0_RD(x) |  (v)))
#define HW_OCOTP_MAC0_CLR(x, v)  (HW_OCOTP_MAC0_WR(x, HW_OCOTP_MAC0_RD(x) & ~(v)))
#define HW_OCOTP_MAC0_TOG(x, v)  (HW_OCOTP_MAC0_WR(x, HW_OCOTP_MAC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MAC0 bitfields
 */

/*!
 * @name Register OCOTP_MAC0, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 4, word 2 (ADDR = 0x22).
 */
/*@{*/
#define BP_OCOTP_MAC0_BITS   (0U)          /*!< Bit position for OCOTP_MAC0_BITS. */
#define BM_OCOTP_MAC0_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MAC0_BITS. */
#define BS_OCOTP_MAC0_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MAC0_BITS. */

/*! @brief Read current value of the OCOTP_MAC0_BITS field. */
#define BR_OCOTP_MAC0_BITS(x) (HW_OCOTP_MAC0(x).U)

/*! @brief Format value for bitfield OCOTP_MAC0_BITS. */
#define BF_OCOTP_MAC0_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MAC0_BITS) & BM_OCOTP_MAC0_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MAC0_BITS(x, v) (HW_OCOTP_MAC0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MAC1 - Value of OTP Bank4 Word3 (MAC Address)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MAC1 - Value of OTP Bank4 Word3 (MAC Address) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 3 (ADDR = 0x23). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_mac1
{
    uint32_t U;
    struct _hw_ocotp_mac1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_mac1_t;

/*!
 * @name Constants and macros for entire OCOTP_MAC1 register
 */
/*@{*/
#define HW_OCOTP_MAC1_ADDR(x)    ((uintptr_t)(x) + 0x630U)

#define HW_OCOTP_MAC1(x)         (*(__IO hw_ocotp_mac1_t *) HW_OCOTP_MAC1_ADDR(x))
#define HW_OCOTP_MAC1_RD(x)      (HW_OCOTP_MAC1(x).U)
#define HW_OCOTP_MAC1_WR(x, v)   (HW_OCOTP_MAC1(x).U = (v))
#define HW_OCOTP_MAC1_SET(x, v)  (HW_OCOTP_MAC1_WR(x, HW_OCOTP_MAC1_RD(x) |  (v)))
#define HW_OCOTP_MAC1_CLR(x, v)  (HW_OCOTP_MAC1_WR(x, HW_OCOTP_MAC1_RD(x) & ~(v)))
#define HW_OCOTP_MAC1_TOG(x, v)  (HW_OCOTP_MAC1_WR(x, HW_OCOTP_MAC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MAC1 bitfields
 */

/*!
 * @name Register OCOTP_MAC1, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 4, word 3 (ADDR = 0x23).
 */
/*@{*/
#define BP_OCOTP_MAC1_BITS   (0U)          /*!< Bit position for OCOTP_MAC1_BITS. */
#define BM_OCOTP_MAC1_BITS   (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MAC1_BITS. */
#define BS_OCOTP_MAC1_BITS   (32U)         /*!< Bit field size in bits for OCOTP_MAC1_BITS. */

/*! @brief Read current value of the OCOTP_MAC1_BITS field. */
#define BR_OCOTP_MAC1_BITS(x) (HW_OCOTP_MAC1(x).U)

/*! @brief Format value for bitfield OCOTP_MAC1_BITS. */
#define BF_OCOTP_MAC1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MAC1_BITS) & BM_OCOTP_MAC1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MAC1_BITS(x, v) (HW_OCOTP_MAC1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_GP1 - Value of OTP Bank4 Word6 (HW Capabilities)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_GP1 - Value of OTP Bank4 Word6 (HW Capabilities) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 6 (ADDR = 0x26). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_gp1
{
    uint32_t U;
    struct _hw_ocotp_gp1_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_gp1_t;

/*!
 * @name Constants and macros for entire OCOTP_GP1 register
 */
/*@{*/
#define HW_OCOTP_GP1_ADDR(x)     ((uintptr_t)(x) + 0x660U)

#define HW_OCOTP_GP1(x)          (*(__IO hw_ocotp_gp1_t *) HW_OCOTP_GP1_ADDR(x))
#define HW_OCOTP_GP1_RD(x)       (HW_OCOTP_GP1(x).U)
#define HW_OCOTP_GP1_WR(x, v)    (HW_OCOTP_GP1(x).U = (v))
#define HW_OCOTP_GP1_SET(x, v)   (HW_OCOTP_GP1_WR(x, HW_OCOTP_GP1_RD(x) |  (v)))
#define HW_OCOTP_GP1_CLR(x, v)   (HW_OCOTP_GP1_WR(x, HW_OCOTP_GP1_RD(x) & ~(v)))
#define HW_OCOTP_GP1_TOG(x, v)   (HW_OCOTP_GP1_WR(x, HW_OCOTP_GP1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_GP1 bitfields
 */

/*!
 * @name Register OCOTP_GP1, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 4, word 6 (ADDR = 0x26).
 */
/*@{*/
#define BP_OCOTP_GP1_BITS    (0U)          /*!< Bit position for OCOTP_GP1_BITS. */
#define BM_OCOTP_GP1_BITS    (0xFFFFFFFFU) /*!< Bit mask for OCOTP_GP1_BITS. */
#define BS_OCOTP_GP1_BITS    (32U)         /*!< Bit field size in bits for OCOTP_GP1_BITS. */

/*! @brief Read current value of the OCOTP_GP1_BITS field. */
#define BR_OCOTP_GP1_BITS(x) (HW_OCOTP_GP1(x).U)

/*! @brief Format value for bitfield OCOTP_GP1_BITS. */
#define BF_OCOTP_GP1_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_GP1_BITS) & BM_OCOTP_GP1_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_GP1_BITS(x, v) (HW_OCOTP_GP1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_GP2 - Value of OTP Bank4 Word7 (HW Capabilities)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_GP2 - Value of OTP Bank4 Word7 (HW Capabilities) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 4, word
 * 7 (ADDR = 0x27). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_gp2
{
    uint32_t U;
    struct _hw_ocotp_gp2_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_gp2_t;

/*!
 * @name Constants and macros for entire OCOTP_GP2 register
 */
/*@{*/
#define HW_OCOTP_GP2_ADDR(x)     ((uintptr_t)(x) + 0x670U)

#define HW_OCOTP_GP2(x)          (*(__IO hw_ocotp_gp2_t *) HW_OCOTP_GP2_ADDR(x))
#define HW_OCOTP_GP2_RD(x)       (HW_OCOTP_GP2(x).U)
#define HW_OCOTP_GP2_WR(x, v)    (HW_OCOTP_GP2(x).U = (v))
#define HW_OCOTP_GP2_SET(x, v)   (HW_OCOTP_GP2_WR(x, HW_OCOTP_GP2_RD(x) |  (v)))
#define HW_OCOTP_GP2_CLR(x, v)   (HW_OCOTP_GP2_WR(x, HW_OCOTP_GP2_RD(x) & ~(v)))
#define HW_OCOTP_GP2_TOG(x, v)   (HW_OCOTP_GP2_WR(x, HW_OCOTP_GP2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_GP2 bitfields
 */

/*!
 * @name Register OCOTP_GP2, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 4, word 7 (ADDR = 0x27).
 */
/*@{*/
#define BP_OCOTP_GP2_BITS    (0U)          /*!< Bit position for OCOTP_GP2_BITS. */
#define BM_OCOTP_GP2_BITS    (0xFFFFFFFFU) /*!< Bit mask for OCOTP_GP2_BITS. */
#define BS_OCOTP_GP2_BITS    (32U)         /*!< Bit field size in bits for OCOTP_GP2_BITS. */

/*! @brief Read current value of the OCOTP_GP2_BITS field. */
#define BR_OCOTP_GP2_BITS(x) (HW_OCOTP_GP2(x).U)

/*! @brief Format value for bitfield OCOTP_GP2_BITS. */
#define BF_OCOTP_GP2_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_GP2_BITS) & BM_OCOTP_GP2_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_GP2_BITS(x, v) (HW_OCOTP_GP2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_MISC_CONF - Value of OTP Bank5 Word5 (HW Capabilities)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_MISC_CONF - Value of OTP Bank5 Word5 (HW Capabilities) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 5, word
 * 5 (ADDR = 0x2d). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_misc_conf
{
    uint32_t U;
    struct _hw_ocotp_misc_conf_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_misc_conf_t;

/*!
 * @name Constants and macros for entire OCOTP_MISC_CONF register
 */
/*@{*/
#define HW_OCOTP_MISC_CONF_ADDR(x) ((uintptr_t)(x) + 0x6D0U)

#define HW_OCOTP_MISC_CONF(x)    (*(__IO hw_ocotp_misc_conf_t *) HW_OCOTP_MISC_CONF_ADDR(x))
#define HW_OCOTP_MISC_CONF_RD(x) (HW_OCOTP_MISC_CONF(x).U)
#define HW_OCOTP_MISC_CONF_WR(x, v) (HW_OCOTP_MISC_CONF(x).U = (v))
#define HW_OCOTP_MISC_CONF_SET(x, v) (HW_OCOTP_MISC_CONF_WR(x, HW_OCOTP_MISC_CONF_RD(x) |  (v)))
#define HW_OCOTP_MISC_CONF_CLR(x, v) (HW_OCOTP_MISC_CONF_WR(x, HW_OCOTP_MISC_CONF_RD(x) & ~(v)))
#define HW_OCOTP_MISC_CONF_TOG(x, v) (HW_OCOTP_MISC_CONF_WR(x, HW_OCOTP_MISC_CONF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_MISC_CONF bitfields
 */

/*!
 * @name Register OCOTP_MISC_CONF, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 5, word 5 (ADDR = 0x2d).
 */
/*@{*/
#define BP_OCOTP_MISC_CONF_BITS (0U)       /*!< Bit position for OCOTP_MISC_CONF_BITS. */
#define BM_OCOTP_MISC_CONF_BITS (0xFFFFFFFFU) /*!< Bit mask for OCOTP_MISC_CONF_BITS. */
#define BS_OCOTP_MISC_CONF_BITS (32U)      /*!< Bit field size in bits for OCOTP_MISC_CONF_BITS. */

/*! @brief Read current value of the OCOTP_MISC_CONF_BITS field. */
#define BR_OCOTP_MISC_CONF_BITS(x) (HW_OCOTP_MISC_CONF(x).U)

/*! @brief Format value for bitfield OCOTP_MISC_CONF_BITS. */
#define BF_OCOTP_MISC_CONF_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_MISC_CONF_BITS) & BM_OCOTP_MISC_CONF_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_MISC_CONF_BITS(x, v) (HW_OCOTP_MISC_CONF_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_FIELD_RETURN - Value of OTP Bank5 Word6 (HW Capabilities)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_FIELD_RETURN - Value of OTP Bank5 Word6 (HW Capabilities) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 5, word
 * 6 (ADDR = 0x2e). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_field_return
{
    uint32_t U;
    struct _hw_ocotp_field_return_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_field_return_t;

/*!
 * @name Constants and macros for entire OCOTP_FIELD_RETURN register
 */
/*@{*/
#define HW_OCOTP_FIELD_RETURN_ADDR(x) ((uintptr_t)(x) + 0x6E0U)

#define HW_OCOTP_FIELD_RETURN(x) (*(__IO hw_ocotp_field_return_t *) HW_OCOTP_FIELD_RETURN_ADDR(x))
#define HW_OCOTP_FIELD_RETURN_RD(x) (HW_OCOTP_FIELD_RETURN(x).U)
#define HW_OCOTP_FIELD_RETURN_WR(x, v) (HW_OCOTP_FIELD_RETURN(x).U = (v))
#define HW_OCOTP_FIELD_RETURN_SET(x, v) (HW_OCOTP_FIELD_RETURN_WR(x, HW_OCOTP_FIELD_RETURN_RD(x) |  (v)))
#define HW_OCOTP_FIELD_RETURN_CLR(x, v) (HW_OCOTP_FIELD_RETURN_WR(x, HW_OCOTP_FIELD_RETURN_RD(x) & ~(v)))
#define HW_OCOTP_FIELD_RETURN_TOG(x, v) (HW_OCOTP_FIELD_RETURN_WR(x, HW_OCOTP_FIELD_RETURN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_FIELD_RETURN bitfields
 */

/*!
 * @name Register OCOTP_FIELD_RETURN, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 5, word 6 (ADDR = 0x2e).
 */
/*@{*/
#define BP_OCOTP_FIELD_RETURN_BITS (0U)    /*!< Bit position for OCOTP_FIELD_RETURN_BITS. */
#define BM_OCOTP_FIELD_RETURN_BITS (0xFFFFFFFFU) /*!< Bit mask for OCOTP_FIELD_RETURN_BITS. */
#define BS_OCOTP_FIELD_RETURN_BITS (32U)   /*!< Bit field size in bits for OCOTP_FIELD_RETURN_BITS. */

/*! @brief Read current value of the OCOTP_FIELD_RETURN_BITS field. */
#define BR_OCOTP_FIELD_RETURN_BITS(x) (HW_OCOTP_FIELD_RETURN(x).U)

/*! @brief Format value for bitfield OCOTP_FIELD_RETURN_BITS. */
#define BF_OCOTP_FIELD_RETURN_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_FIELD_RETURN_BITS) & BM_OCOTP_FIELD_RETURN_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_FIELD_RETURN_BITS(x, v) (HW_OCOTP_FIELD_RETURN_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_OCOTP_SRK_REVOKE - Value of OTP Bank5 Word7 (HW Capabilities)
 ******************************************************************************/

/*!
 * @brief HW_OCOTP_SRK_REVOKE - Value of OTP Bank5 Word7 (HW Capabilities) (RW)
 *
 * Reset value: 0x00000000U
 *
 * Copied from the OTP automatically after reset. Can be re-loaded by setting
 * HW_OCOTP_CTRL[RELOAD_SHADOWS] Shadowed memory mapped access to OTP Bank 5, word
 * 7 (ADDR = 0x2f). EXAMPLE Empty Example.
 */
typedef union _hw_ocotp_srk_revoke
{
    uint32_t U;
    struct _hw_ocotp_srk_revoke_bitfields
    {
        uint32_t BITS : 32;            /*!< [31:0]  */
    } B;
} hw_ocotp_srk_revoke_t;

/*!
 * @name Constants and macros for entire OCOTP_SRK_REVOKE register
 */
/*@{*/
#define HW_OCOTP_SRK_REVOKE_ADDR(x) ((uintptr_t)(x) + 0x6F0U)

#define HW_OCOTP_SRK_REVOKE(x)   (*(__IO hw_ocotp_srk_revoke_t *) HW_OCOTP_SRK_REVOKE_ADDR(x))
#define HW_OCOTP_SRK_REVOKE_RD(x) (HW_OCOTP_SRK_REVOKE(x).U)
#define HW_OCOTP_SRK_REVOKE_WR(x, v) (HW_OCOTP_SRK_REVOKE(x).U = (v))
#define HW_OCOTP_SRK_REVOKE_SET(x, v) (HW_OCOTP_SRK_REVOKE_WR(x, HW_OCOTP_SRK_REVOKE_RD(x) |  (v)))
#define HW_OCOTP_SRK_REVOKE_CLR(x, v) (HW_OCOTP_SRK_REVOKE_WR(x, HW_OCOTP_SRK_REVOKE_RD(x) & ~(v)))
#define HW_OCOTP_SRK_REVOKE_TOG(x, v) (HW_OCOTP_SRK_REVOKE_WR(x, HW_OCOTP_SRK_REVOKE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual OCOTP_SRK_REVOKE bitfields
 */

/*!
 * @name Register OCOTP_SRK_REVOKE, field BITS[31:0] (RW)
 *
 * Reflects value of OTP Bank 5, word 7 (ADDR = 0x2f).
 */
/*@{*/
#define BP_OCOTP_SRK_REVOKE_BITS (0U)      /*!< Bit position for OCOTP_SRK_REVOKE_BITS. */
#define BM_OCOTP_SRK_REVOKE_BITS (0xFFFFFFFFU) /*!< Bit mask for OCOTP_SRK_REVOKE_BITS. */
#define BS_OCOTP_SRK_REVOKE_BITS (32U)     /*!< Bit field size in bits for OCOTP_SRK_REVOKE_BITS. */

/*! @brief Read current value of the OCOTP_SRK_REVOKE_BITS field. */
#define BR_OCOTP_SRK_REVOKE_BITS(x) (HW_OCOTP_SRK_REVOKE(x).U)

/*! @brief Format value for bitfield OCOTP_SRK_REVOKE_BITS. */
#define BF_OCOTP_SRK_REVOKE_BITS(v) ((uint32_t)((uint32_t)(v) << BP_OCOTP_SRK_REVOKE_BITS) & BM_OCOTP_SRK_REVOKE_BITS)

/*! @brief Set the BITS field to a new value. */
#define BW_OCOTP_SRK_REVOKE_BITS(x, v) (HW_OCOTP_SRK_REVOKE_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_ocotp_t - module struct
 ******************************************************************************/
/*!
 * @brief All OCOTP module registers.
 */
#pragma pack(1)
typedef struct _hw_ocotp
{
    __IO hw_ocotp_ctrl_t CTRL;             /*!< [0x0] OTP Controller Control Register */
    uint8_t _reserved0[12];
    __IO hw_ocotp_timing_t TIMING;         /*!< [0x10] OTP Controller Timing Register */
    uint8_t _reserved1[12];
    __IO hw_ocotp_data_t DATA;             /*!< [0x20] OTP Controller Write Data Register */
    uint8_t _reserved2[12];
    __IO hw_ocotp_read_ctrl_t READ_CTRL;   /*!< [0x30] OTP Controller Write Data Register */
    uint8_t _reserved3[12];
    __IO hw_ocotp_read_fuse_data_t READ_FUSE_DATA; /*!< [0x40] OTP Controller Read Data Register */
    uint8_t _reserved4[12];
    __IO hw_ocotp_sw_sticky_t SW_STICKY;   /*!< [0x50] Sticky bit Register */
    uint8_t _reserved5[12];
    __IO hw_ocotp_scs_t SCS;               /*!< [0x60] Software Controllable Signals Register */
    uint8_t _reserved6[44];
    __I hw_ocotp_version_t VERSION;        /*!< [0x90] OTP Controller Version Register */
    uint8_t _reserved7[876];
    __I hw_ocotp_lock_t LOCK;              /*!< [0x400] Value of OTP Bank0 Word0 (Lock controls) */
    uint8_t _reserved8[12];
    __IO hw_ocotp_cfg0_t CFG0;             /*!< [0x410] Value of OTP Bank0 Word1 (Configuration and Manufacturing Info.) */
    uint8_t _reserved9[12];
    __IO hw_ocotp_cfg1_t CFG1;             /*!< [0x420] Value of OTP Bank0 Word2 (Configuration and Manufacturing Info.) */
    uint8_t _reserved10[12];
    __IO hw_ocotp_cfg2_t CFG2;             /*!< [0x430] Value of OTP Bank0 Word3 (Configuration and Manufacturing Info.) */
    uint8_t _reserved11[12];
    __IO hw_ocotp_cfg3_t CFG3;             /*!< [0x440] Value of OTP Bank0 Word4 (Configuration and Manufacturing Info.) */
    uint8_t _reserved12[12];
    __IO hw_ocotp_cfg4_t CFG4;             /*!< [0x450] Value of OTP Bank0 Word5 (Configuration and Manufacturing Info.) */
    uint8_t _reserved13[12];
    __IO hw_ocotp_cfg5_t CFG5;             /*!< [0x460] Value of OTP Bank0 Word6 (Configuration and Manufacturing Info.) */
    uint8_t _reserved14[12];
    __IO hw_ocotp_cfg6_t CFG6;             /*!< [0x470] Value of OTP Bank0 Word7 (Configuration and Manufacturing Info.) */
    uint8_t _reserved15[12];
    __IO hw_ocotp_mem0_t MEM0;             /*!< [0x480] Value of OTP Bank1 Word0 (Memory Related Info.) */
    uint8_t _reserved16[12];
    __IO hw_ocotp_mem1_t MEM1;             /*!< [0x490] Value of OTP Bank1 Word1 (Memory Related Info.) */
    uint8_t _reserved17[12];
    __IO hw_ocotp_mem2_t MEM2;             /*!< [0x4A0] Value of OTP Bank1 Word2 (Memory Related Info.) */
    uint8_t _reserved18[12];
    __IO hw_ocotp_mem3_t MEM3;             /*!< [0x4B0] Value of OTP Bank1 Word3 (Memory Related Info.) */
    uint8_t _reserved19[12];
    __IO hw_ocotp_mem4_t MEM4;             /*!< [0x4C0] Value of OTP Bank1 Word4 (Memory Related Info.) */
    uint8_t _reserved20[12];
    __IO hw_ocotp_ana0_t ANA0;             /*!< [0x4D0] Value of OTP Bank1 Word5 (Memory Related Info.) */
    uint8_t _reserved21[12];
    __IO hw_ocotp_ana1_t ANA1;             /*!< [0x4E0] Value of OTP Bank1 Word6 (General Purpose Customer Defined Info.) */
    uint8_t _reserved22[12];
    __IO hw_ocotp_ana2_t ANA2;             /*!< [0x4F0] Value of OTP Bank1 Word7 (General Purpose Customer Defined Info.) */
    uint8_t _reserved23[140];
    __IO hw_ocotp_srk0_t SRK0;             /*!< [0x580] Shadow Register for OTP Bank3 Word0 (SRK Hash) */
    uint8_t _reserved24[12];
    __IO hw_ocotp_srk1_t SRK1;             /*!< [0x590] Shadow Register for OTP Bank3 Word1 (SRK Hash) */
    uint8_t _reserved25[12];
    __IO hw_ocotp_srk2_t SRK2;             /*!< [0x5A0] Shadow Register for OTP Bank3 Word2 (SRK Hash) */
    uint8_t _reserved26[12];
    __IO hw_ocotp_srk3_t SRK3;             /*!< [0x5B0] Shadow Register for OTP Bank3 Word3 (SRK Hash) */
    uint8_t _reserved27[12];
    __IO hw_ocotp_srk4_t SRK4;             /*!< [0x5C0] Shadow Register for OTP Bank3 Word4 (SRK Hash) */
    uint8_t _reserved28[12];
    __IO hw_ocotp_srk5_t SRK5;             /*!< [0x5D0] Shadow Register for OTP Bank3 Word5 (SRK Hash) */
    uint8_t _reserved29[12];
    __IO hw_ocotp_srk6_t SRK6;             /*!< [0x5E0] Shadow Register for OTP Bank3 Word6 (SRK Hash) */
    uint8_t _reserved30[12];
    __IO hw_ocotp_srk7_t SRK7;             /*!< [0x5F0] Shadow Register for OTP Bank3 Word7 (SRK Hash) */
    uint8_t _reserved31[12];
    __IO hw_ocotp_resp0_t RESP0;           /*!< [0x600] Value of OTP Bank4 Word0 (Secure JTAG Response Field) */
    uint8_t _reserved32[12];
    __IO hw_ocotp_hsjc_resp1_t HSJC_RESP1; /*!< [0x610] Value of OTP Bank4 Word1 (Secure JTAG Response Field) */
    uint8_t _reserved33[12];
    __IO hw_ocotp_mac0_t MAC0;             /*!< [0x620] Value of OTP Bank4 Word2 (MAC Address) */
    uint8_t _reserved34[12];
    __IO hw_ocotp_mac1_t MAC1;             /*!< [0x630] Value of OTP Bank4 Word3 (MAC Address) */
    uint8_t _reserved35[44];
    __IO hw_ocotp_gp1_t GP1;               /*!< [0x660] Value of OTP Bank4 Word6 (HW Capabilities) */
    uint8_t _reserved36[12];
    __IO hw_ocotp_gp2_t GP2;               /*!< [0x670] Value of OTP Bank4 Word7 (HW Capabilities) */
    uint8_t _reserved37[92];
    __IO hw_ocotp_misc_conf_t MISC_CONF;   /*!< [0x6D0] Value of OTP Bank5 Word5 (HW Capabilities) */
    uint8_t _reserved38[12];
    __IO hw_ocotp_field_return_t FIELD_RETURN; /*!< [0x6E0] Value of OTP Bank5 Word6 (HW Capabilities) */
    uint8_t _reserved39[12];
    __IO hw_ocotp_srk_revoke_t SRK_REVOKE; /*!< [0x6F0] Value of OTP Bank5 Word7 (HW Capabilities) */
} hw_ocotp_t;
#pragma pack()

/*! @brief Macro to access all OCOTP registers. */
/*! @param x OCOTP module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_OCOTP_REGS(OCOTP_BASE)</code>. */
#define HW_OCOTP_REGS(x) (*(hw_ocotp_t *)(x))

/*
 * iMX6DP PCIE_EP
 *
 * PCIeEP
 *
 * Registers defined in this header file:
 * - HW_PCIE_EP_DeviceID - Device ID and Vendor ID Register
 * - HW_PCIE_EP_Command - Command and Status Register
 * - HW_PCIE_EP_BIST - BIST Register
 * - HW_PCIE_EP_BAR0 - Base Address 0
 * - HW_PCIE_EP_MASK0 - BAR 0 Mask Register
 * - HW_PCIE_EP_MASK1 - BAR 1 Mask Register
 * - HW_PCIE_EP_MASK2 - BAR 2 Mask Register
 * - HW_PCIE_EP_MASK3 - BAR 3 Mask Register
 * - HW_PCIE_EP_CISP - CardBus CIS Pointer Register
 * - HW_PCIE_EP_SSID - Subsystem ID and Subsystem Vendor ID Register
 * - HW_PCIE_EP_EROMBAR - Expansion ROM Base Address Register
 * - HW_PCIE_EP_EROMMASK - Expansion ROM BAR Mask Register
 * - HW_PCIE_EP_CAPPR - Capability Pointer Register
 * - HW_PCIE_EP_ILR - Interrupt Line and Pin Register
 * - HW_PCIE_EP_AER - AER Capability Header
 * - HW_PCIE_EP_UESR - Uncorrectable Error Status Register
 * - HW_PCIE_EP_UEMR - Uncorrectable Error Mask Register
 * - HW_PCIE_EP_UESevR - Uncorrectable Error Severity Register
 * - HW_PCIE_EP_CESR - Correctable Error Status Register
 * - HW_PCIE_EP_CEMR - Correctable Error Mask Register
 * - HW_PCIE_EP_ACCR - Advanced Capabilities and Control Register
 * - HW_PCIE_EP_HLR - Header Log Register
 * - HW_PCIE_EP_VCECHR - VC Extended Capability Header
 * - HW_PCIE_EP_PVCCR1 - Port VC Capability Register 1
 * - HW_PCIE_EP_PVCCR2 - Port VC Capability Register 2
 * - HW_PCIE_EP_PVCCSR - Port VC Control and Status Register
 * - HW_PCIE_EP_VCRCR - VC Resource Capability Register n
 * - HW_PCIE_EP_VCRConR - VC Resource Control Register n
 * - HW_PCIE_EP_VCRSR - VC Resource Status Register n
 *
 * - hw_pcie_ep_t - Struct containing all module registers.
 */

#define HW_PCIE_EP_INSTANCE_COUNT (1U) /*!< Number of instances of the PCIE_EP module. */
#define HW_PCIE_EP (0U) /*!< Instance number for PCIE_EP. */
#define PCIE_EP_BASE          (0x1FFC000U) /*!< Base address for PCIE_EP. */
/*! Array initializer of PCIE_EP base addresses. */
#define PCIE_EP_BASE_ADDRS    { PCIE_EP_BASE }

/*******************************************************************************
 * HW_PCIE_EP_DeviceID - Device ID and Vendor ID Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_DeviceID - Device ID and Vendor ID Register (RU)
 *
 * Reset value: 0xABCD16C3U
 *
 * Offset: 0x00 The default values of both Device ID and Vendor ID are hardware
 * configuration parameters. The application can overwrite the default values of
 * both Device ID and Vendor ID through the DBI.
 */
typedef union _hw_pcie_ep_deviceid
{
    uint32_t U;
    struct _hw_pcie_ep_deviceid_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_pcie_ep_deviceid_t;

/*!
 * @name Constants and macros for entire PCIE_EP_DeviceID register
 */
/*@{*/
#define HW_PCIE_EP_DeviceID_ADDR(x) ((uintptr_t)(x) + 0x0U)
#define HW_PCIE_EP_DeviceID(x)   (*(__I hw_pcie_ep_deviceid_t *) HW_PCIE_EP_DeviceID_ADDR(x))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_DeviceID bitfields
 */

/*******************************************************************************
 * HW_PCIE_EP_Command - Command and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_Command - Command and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x04 Bytes: 0-1
 */
typedef union _hw_pcie_ep_command
{
    uint32_t U;
    struct _hw_pcie_ep_command_bitfields
    {
        uint32_t I_O_Space_Enable : 1; /*!< [0]  */
        uint32_t Memory_Space_Enable : 1; /*!< [1]  */
        uint32_t Bus_Master_Enable : 1; /*!< [2]  */
        uint32_t Special_Cycle_Enable : 1; /*!< [3]  */
        uint32_t Memory_Write_and_Invalidate : 1; /*!< [4]  */
        uint32_t VGA_Palette_Snoop : 1; /*!< [5]  */
        uint32_t Parity_Error_Response : 1; /*!< [6]  */
        uint32_t IDSEL_Stepping : 1;   /*!< [7]  */
        uint32_t SERR_Enable : 1;      /*!< [8]  */
        uint32_t Fast_Back_to_Back_Enable : 1; /*!< [9]  */
        uint32_t INTx_Assertion_Disable : 1; /*!< [10]  */
        uint32_t RESERVED0 : 8;        /*!< [18:11]  */
        uint32_t INTx_Status : 1;      /*!< [19]  */
        uint32_t Capabilities_List : 1; /*!< [20]  */
        uint32_t SixtySix_MHz_Capable : 1; /*!< [21]  */
        uint32_t RESERVED1 : 1;        /*!< [22]  */
        uint32_t Fast_Back_to_Back_Capable : 1; /*!< [23]  */
        uint32_t Master_Data_Parity_Error : 1; /*!< [24]  */
        uint32_t DEVSEL_Timing : 2;    /*!< [26:25]  */
        uint32_t Signaled_Target_Abort : 1; /*!< [27]  */
        uint32_t Received_Target_Abort : 1; /*!< [28]  */
        uint32_t Received_Master_Abort : 1; /*!< [29]  */
        uint32_t Signaled_System_Error : 1; /*!< [30]  */
        uint32_t Detected_Parity_Error : 1; /*!< [31]  */
    } B;
} hw_pcie_ep_command_t;

/*!
 * @name Constants and macros for entire PCIE_EP_Command register
 */
/*@{*/
#define HW_PCIE_EP_Command_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_PCIE_EP_Command(x)    (*(__IO hw_pcie_ep_command_t *) HW_PCIE_EP_Command_ADDR(x))
#define HW_PCIE_EP_Command_RD(x) (HW_PCIE_EP_Command(x).U)
#define HW_PCIE_EP_Command_WR(x, v) (HW_PCIE_EP_Command(x).U = (v))
#define HW_PCIE_EP_Command_SET(x, v) (HW_PCIE_EP_Command_WR(x, HW_PCIE_EP_Command_RD(x) |  (v)))
#define HW_PCIE_EP_Command_CLR(x, v) (HW_PCIE_EP_Command_WR(x, HW_PCIE_EP_Command_RD(x) & ~(v)))
#define HW_PCIE_EP_Command_TOG(x, v) (HW_PCIE_EP_Command_WR(x, HW_PCIE_EP_Command_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_Command bitfields
 */

/*!
 * @name Register PCIE_EP_Command, field I_O_Space_Enable[0] (RW)
 *
 * I/O Space Enable
 */
/*@{*/
#define BP_PCIE_EP_Command_I_O_Space_Enable (0U) /*!< Bit position for PCIE_EP_Command_I_O_Space_Enable. */
#define BM_PCIE_EP_Command_I_O_Space_Enable (0x00000001U) /*!< Bit mask for PCIE_EP_Command_I_O_Space_Enable. */
#define BS_PCIE_EP_Command_I_O_Space_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_I_O_Space_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_I_O_Space_Enable field. */
#define BR_PCIE_EP_Command_I_O_Space_Enable(x) (HW_PCIE_EP_Command(x).B.I_O_Space_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_I_O_Space_Enable. */
#define BF_PCIE_EP_Command_I_O_Space_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_I_O_Space_Enable) & BM_PCIE_EP_Command_I_O_Space_Enable)

/*! @brief Set the I_O_Space_Enable field to a new value. */
#define BW_PCIE_EP_Command_I_O_Space_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_I_O_Space_Enable) | BF_PCIE_EP_Command_I_O_Space_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Memory_Space_Enable[1] (RW)
 *
 * Memory Space Enable
 */
/*@{*/
#define BP_PCIE_EP_Command_Memory_Space_Enable (1U) /*!< Bit position for PCIE_EP_Command_Memory_Space_Enable. */
#define BM_PCIE_EP_Command_Memory_Space_Enable (0x00000002U) /*!< Bit mask for PCIE_EP_Command_Memory_Space_Enable. */
#define BS_PCIE_EP_Command_Memory_Space_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_Memory_Space_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_Memory_Space_Enable field. */
#define BR_PCIE_EP_Command_Memory_Space_Enable(x) (HW_PCIE_EP_Command(x).B.Memory_Space_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_Memory_Space_Enable. */
#define BF_PCIE_EP_Command_Memory_Space_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Memory_Space_Enable) & BM_PCIE_EP_Command_Memory_Space_Enable)

/*! @brief Set the Memory_Space_Enable field to a new value. */
#define BW_PCIE_EP_Command_Memory_Space_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Memory_Space_Enable) | BF_PCIE_EP_Command_Memory_Space_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Bus_Master_Enable[2] (RW)
 *
 * Bus Master Enable
 */
/*@{*/
#define BP_PCIE_EP_Command_Bus_Master_Enable (2U) /*!< Bit position for PCIE_EP_Command_Bus_Master_Enable. */
#define BM_PCIE_EP_Command_Bus_Master_Enable (0x00000004U) /*!< Bit mask for PCIE_EP_Command_Bus_Master_Enable. */
#define BS_PCIE_EP_Command_Bus_Master_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_Bus_Master_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_Bus_Master_Enable field. */
#define BR_PCIE_EP_Command_Bus_Master_Enable(x) (HW_PCIE_EP_Command(x).B.Bus_Master_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_Bus_Master_Enable. */
#define BF_PCIE_EP_Command_Bus_Master_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Bus_Master_Enable) & BM_PCIE_EP_Command_Bus_Master_Enable)

/*! @brief Set the Bus_Master_Enable field to a new value. */
#define BW_PCIE_EP_Command_Bus_Master_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Bus_Master_Enable) | BF_PCIE_EP_Command_Bus_Master_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Special_Cycle_Enable[3] (RW)
 *
 * Special Cycle Enable Not applicable for PCI Express. Must be hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_Special_Cycle_Enable (3U) /*!< Bit position for PCIE_EP_Command_Special_Cycle_Enable. */
#define BM_PCIE_EP_Command_Special_Cycle_Enable (0x00000008U) /*!< Bit mask for PCIE_EP_Command_Special_Cycle_Enable. */
#define BS_PCIE_EP_Command_Special_Cycle_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_Special_Cycle_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_Special_Cycle_Enable field. */
#define BR_PCIE_EP_Command_Special_Cycle_Enable(x) (HW_PCIE_EP_Command(x).B.Special_Cycle_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_Special_Cycle_Enable. */
#define BF_PCIE_EP_Command_Special_Cycle_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Special_Cycle_Enable) & BM_PCIE_EP_Command_Special_Cycle_Enable)

/*! @brief Set the Special_Cycle_Enable field to a new value. */
#define BW_PCIE_EP_Command_Special_Cycle_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Special_Cycle_Enable) | BF_PCIE_EP_Command_Special_Cycle_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Memory_Write_and_Invalidate[4] (RW)
 *
 * Memory Write and Invalidate Not applicable for PCI Express. Must be hardwired
 * to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_Memory_Write_and_Invalidate (4U) /*!< Bit position for PCIE_EP_Command_Memory_Write_and_Invalidate. */
#define BM_PCIE_EP_Command_Memory_Write_and_Invalidate (0x00000010U) /*!< Bit mask for PCIE_EP_Command_Memory_Write_and_Invalidate. */
#define BS_PCIE_EP_Command_Memory_Write_and_Invalidate (1U) /*!< Bit field size in bits for PCIE_EP_Command_Memory_Write_and_Invalidate. */

/*! @brief Read current value of the PCIE_EP_Command_Memory_Write_and_Invalidate field. */
#define BR_PCIE_EP_Command_Memory_Write_and_Invalidate(x) (HW_PCIE_EP_Command(x).B.Memory_Write_and_Invalidate)

/*! @brief Format value for bitfield PCIE_EP_Command_Memory_Write_and_Invalidate. */
#define BF_PCIE_EP_Command_Memory_Write_and_Invalidate(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Memory_Write_and_Invalidate) & BM_PCIE_EP_Command_Memory_Write_and_Invalidate)

/*! @brief Set the Memory_Write_and_Invalidate field to a new value. */
#define BW_PCIE_EP_Command_Memory_Write_and_Invalidate(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Memory_Write_and_Invalidate) | BF_PCIE_EP_Command_Memory_Write_and_Invalidate(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field VGA_Palette_Snoop[5] (RW)
 *
 * VGA Palette Snoop Not applicable for PCI Express. Must be hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_VGA_Palette_Snoop (5U) /*!< Bit position for PCIE_EP_Command_VGA_Palette_Snoop. */
#define BM_PCIE_EP_Command_VGA_Palette_Snoop (0x00000020U) /*!< Bit mask for PCIE_EP_Command_VGA_Palette_Snoop. */
#define BS_PCIE_EP_Command_VGA_Palette_Snoop (1U) /*!< Bit field size in bits for PCIE_EP_Command_VGA_Palette_Snoop. */

/*! @brief Read current value of the PCIE_EP_Command_VGA_Palette_Snoop field. */
#define BR_PCIE_EP_Command_VGA_Palette_Snoop(x) (HW_PCIE_EP_Command(x).B.VGA_Palette_Snoop)

/*! @brief Format value for bitfield PCIE_EP_Command_VGA_Palette_Snoop. */
#define BF_PCIE_EP_Command_VGA_Palette_Snoop(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_VGA_Palette_Snoop) & BM_PCIE_EP_Command_VGA_Palette_Snoop)

/*! @brief Set the VGA_Palette_Snoop field to a new value. */
#define BW_PCIE_EP_Command_VGA_Palette_Snoop(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_VGA_Palette_Snoop) | BF_PCIE_EP_Command_VGA_Palette_Snoop(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Parity_Error_Response[6] (RW)
 *
 * Parity Error Response
 */
/*@{*/
#define BP_PCIE_EP_Command_Parity_Error_Response (6U) /*!< Bit position for PCIE_EP_Command_Parity_Error_Response. */
#define BM_PCIE_EP_Command_Parity_Error_Response (0x00000040U) /*!< Bit mask for PCIE_EP_Command_Parity_Error_Response. */
#define BS_PCIE_EP_Command_Parity_Error_Response (1U) /*!< Bit field size in bits for PCIE_EP_Command_Parity_Error_Response. */

/*! @brief Read current value of the PCIE_EP_Command_Parity_Error_Response field. */
#define BR_PCIE_EP_Command_Parity_Error_Response(x) (HW_PCIE_EP_Command(x).B.Parity_Error_Response)

/*! @brief Format value for bitfield PCIE_EP_Command_Parity_Error_Response. */
#define BF_PCIE_EP_Command_Parity_Error_Response(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Parity_Error_Response) & BM_PCIE_EP_Command_Parity_Error_Response)

/*! @brief Set the Parity_Error_Response field to a new value. */
#define BW_PCIE_EP_Command_Parity_Error_Response(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Parity_Error_Response) | BF_PCIE_EP_Command_Parity_Error_Response(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field IDSEL_Stepping[7] (RW)
 *
 * IDSEL Stepping/Wait Cycle Control Not applicable for PCI Express. Must be
 * hardwired to 0
 */
/*@{*/
#define BP_PCIE_EP_Command_IDSEL_Stepping (7U) /*!< Bit position for PCIE_EP_Command_IDSEL_Stepping. */
#define BM_PCIE_EP_Command_IDSEL_Stepping (0x00000080U) /*!< Bit mask for PCIE_EP_Command_IDSEL_Stepping. */
#define BS_PCIE_EP_Command_IDSEL_Stepping (1U) /*!< Bit field size in bits for PCIE_EP_Command_IDSEL_Stepping. */

/*! @brief Read current value of the PCIE_EP_Command_IDSEL_Stepping field. */
#define BR_PCIE_EP_Command_IDSEL_Stepping(x) (HW_PCIE_EP_Command(x).B.IDSEL_Stepping)

/*! @brief Format value for bitfield PCIE_EP_Command_IDSEL_Stepping. */
#define BF_PCIE_EP_Command_IDSEL_Stepping(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_IDSEL_Stepping) & BM_PCIE_EP_Command_IDSEL_Stepping)

/*! @brief Set the IDSEL_Stepping field to a new value. */
#define BW_PCIE_EP_Command_IDSEL_Stepping(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_IDSEL_Stepping) | BF_PCIE_EP_Command_IDSEL_Stepping(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field SERR_Enable[8] (RW)
 *
 * SERR# Enable
 */
/*@{*/
#define BP_PCIE_EP_Command_SERR_Enable (8U) /*!< Bit position for PCIE_EP_Command_SERR_Enable. */
#define BM_PCIE_EP_Command_SERR_Enable (0x00000100U) /*!< Bit mask for PCIE_EP_Command_SERR_Enable. */
#define BS_PCIE_EP_Command_SERR_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_SERR_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_SERR_Enable field. */
#define BR_PCIE_EP_Command_SERR_Enable(x) (HW_PCIE_EP_Command(x).B.SERR_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_SERR_Enable. */
#define BF_PCIE_EP_Command_SERR_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_SERR_Enable) & BM_PCIE_EP_Command_SERR_Enable)

/*! @brief Set the SERR_Enable field to a new value. */
#define BW_PCIE_EP_Command_SERR_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_SERR_Enable) | BF_PCIE_EP_Command_SERR_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Fast_Back_to_Back_Enable[9] (RW)
 *
 * Fast Back-to-Back Enable Not applicable for PCI Express. Must be hardwired to
 * 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_Fast_Back_to_Back_Enable (9U) /*!< Bit position for PCIE_EP_Command_Fast_Back_to_Back_Enable. */
#define BM_PCIE_EP_Command_Fast_Back_to_Back_Enable (0x00000200U) /*!< Bit mask for PCIE_EP_Command_Fast_Back_to_Back_Enable. */
#define BS_PCIE_EP_Command_Fast_Back_to_Back_Enable (1U) /*!< Bit field size in bits for PCIE_EP_Command_Fast_Back_to_Back_Enable. */

/*! @brief Read current value of the PCIE_EP_Command_Fast_Back_to_Back_Enable field. */
#define BR_PCIE_EP_Command_Fast_Back_to_Back_Enable(x) (HW_PCIE_EP_Command(x).B.Fast_Back_to_Back_Enable)

/*! @brief Format value for bitfield PCIE_EP_Command_Fast_Back_to_Back_Enable. */
#define BF_PCIE_EP_Command_Fast_Back_to_Back_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Fast_Back_to_Back_Enable) & BM_PCIE_EP_Command_Fast_Back_to_Back_Enable)

/*! @brief Set the Fast_Back_to_Back_Enable field to a new value. */
#define BW_PCIE_EP_Command_Fast_Back_to_Back_Enable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Fast_Back_to_Back_Enable) | BF_PCIE_EP_Command_Fast_Back_to_Back_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field INTx_Assertion_Disable[10] (RW)
 *
 * INTx Assertion Disable
 */
/*@{*/
#define BP_PCIE_EP_Command_INTx_Assertion_Disable (10U) /*!< Bit position for PCIE_EP_Command_INTx_Assertion_Disable. */
#define BM_PCIE_EP_Command_INTx_Assertion_Disable (0x00000400U) /*!< Bit mask for PCIE_EP_Command_INTx_Assertion_Disable. */
#define BS_PCIE_EP_Command_INTx_Assertion_Disable (1U) /*!< Bit field size in bits for PCIE_EP_Command_INTx_Assertion_Disable. */

/*! @brief Read current value of the PCIE_EP_Command_INTx_Assertion_Disable field. */
#define BR_PCIE_EP_Command_INTx_Assertion_Disable(x) (HW_PCIE_EP_Command(x).B.INTx_Assertion_Disable)

/*! @brief Format value for bitfield PCIE_EP_Command_INTx_Assertion_Disable. */
#define BF_PCIE_EP_Command_INTx_Assertion_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_INTx_Assertion_Disable) & BM_PCIE_EP_Command_INTx_Assertion_Disable)

/*! @brief Set the INTx_Assertion_Disable field to a new value. */
#define BW_PCIE_EP_Command_INTx_Assertion_Disable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_INTx_Assertion_Disable) | BF_PCIE_EP_Command_INTx_Assertion_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field INTx_Status[19] (RW)
 *
 * INTx Status
 */
/*@{*/
#define BP_PCIE_EP_Command_INTx_Status (19U) /*!< Bit position for PCIE_EP_Command_INTx_Status. */
#define BM_PCIE_EP_Command_INTx_Status (0x00080000U) /*!< Bit mask for PCIE_EP_Command_INTx_Status. */
#define BS_PCIE_EP_Command_INTx_Status (1U) /*!< Bit field size in bits for PCIE_EP_Command_INTx_Status. */

/*! @brief Read current value of the PCIE_EP_Command_INTx_Status field. */
#define BR_PCIE_EP_Command_INTx_Status(x) (HW_PCIE_EP_Command(x).B.INTx_Status)

/*! @brief Format value for bitfield PCIE_EP_Command_INTx_Status. */
#define BF_PCIE_EP_Command_INTx_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_INTx_Status) & BM_PCIE_EP_Command_INTx_Status)

/*! @brief Set the INTx_Status field to a new value. */
#define BW_PCIE_EP_Command_INTx_Status(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_INTx_Status) | BF_PCIE_EP_Command_INTx_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Capabilities_List[20] (RW)
 *
 * Capabilities List Indicates presence of an extended capability item.
 * Hardwired to 1.
 */
/*@{*/
#define BP_PCIE_EP_Command_Capabilities_List (20U) /*!< Bit position for PCIE_EP_Command_Capabilities_List. */
#define BM_PCIE_EP_Command_Capabilities_List (0x00100000U) /*!< Bit mask for PCIE_EP_Command_Capabilities_List. */
#define BS_PCIE_EP_Command_Capabilities_List (1U) /*!< Bit field size in bits for PCIE_EP_Command_Capabilities_List. */

/*! @brief Read current value of the PCIE_EP_Command_Capabilities_List field. */
#define BR_PCIE_EP_Command_Capabilities_List(x) (HW_PCIE_EP_Command(x).B.Capabilities_List)

/*! @brief Format value for bitfield PCIE_EP_Command_Capabilities_List. */
#define BF_PCIE_EP_Command_Capabilities_List(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Capabilities_List) & BM_PCIE_EP_Command_Capabilities_List)

/*! @brief Set the Capabilities_List field to a new value. */
#define BW_PCIE_EP_Command_Capabilities_List(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Capabilities_List) | BF_PCIE_EP_Command_Capabilities_List(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field SixtySix_MHz_Capable[21] (RW)
 *
 * 66 MHz Capable Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_SixtySix_MHz_Capable (21U) /*!< Bit position for PCIE_EP_Command_SixtySix_MHz_Capable. */
#define BM_PCIE_EP_Command_SixtySix_MHz_Capable (0x00200000U) /*!< Bit mask for PCIE_EP_Command_SixtySix_MHz_Capable. */
#define BS_PCIE_EP_Command_SixtySix_MHz_Capable (1U) /*!< Bit field size in bits for PCIE_EP_Command_SixtySix_MHz_Capable. */

/*! @brief Read current value of the PCIE_EP_Command_SixtySix_MHz_Capable field. */
#define BR_PCIE_EP_Command_SixtySix_MHz_Capable(x) (HW_PCIE_EP_Command(x).B.SixtySix_MHz_Capable)

/*! @brief Format value for bitfield PCIE_EP_Command_SixtySix_MHz_Capable. */
#define BF_PCIE_EP_Command_SixtySix_MHz_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_SixtySix_MHz_Capable) & BM_PCIE_EP_Command_SixtySix_MHz_Capable)

/*! @brief Set the SixtySix_MHz_Capable field to a new value. */
#define BW_PCIE_EP_Command_SixtySix_MHz_Capable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_SixtySix_MHz_Capable) | BF_PCIE_EP_Command_SixtySix_MHz_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Fast_Back_to_Back_Capable[23] (RW)
 *
 * Fast Back-to-Back Capable Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_Fast_Back_to_Back_Capable (23U) /*!< Bit position for PCIE_EP_Command_Fast_Back_to_Back_Capable. */
#define BM_PCIE_EP_Command_Fast_Back_to_Back_Capable (0x00800000U) /*!< Bit mask for PCIE_EP_Command_Fast_Back_to_Back_Capable. */
#define BS_PCIE_EP_Command_Fast_Back_to_Back_Capable (1U) /*!< Bit field size in bits for PCIE_EP_Command_Fast_Back_to_Back_Capable. */

/*! @brief Read current value of the PCIE_EP_Command_Fast_Back_to_Back_Capable field. */
#define BR_PCIE_EP_Command_Fast_Back_to_Back_Capable(x) (HW_PCIE_EP_Command(x).B.Fast_Back_to_Back_Capable)

/*! @brief Format value for bitfield PCIE_EP_Command_Fast_Back_to_Back_Capable. */
#define BF_PCIE_EP_Command_Fast_Back_to_Back_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Fast_Back_to_Back_Capable) & BM_PCIE_EP_Command_Fast_Back_to_Back_Capable)

/*! @brief Set the Fast_Back_to_Back_Capable field to a new value. */
#define BW_PCIE_EP_Command_Fast_Back_to_Back_Capable(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Fast_Back_to_Back_Capable) | BF_PCIE_EP_Command_Fast_Back_to_Back_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Master_Data_Parity_Error[24] (RW)
 *
 * Master Data Parity Error
 */
/*@{*/
#define BP_PCIE_EP_Command_Master_Data_Parity_Error (24U) /*!< Bit position for PCIE_EP_Command_Master_Data_Parity_Error. */
#define BM_PCIE_EP_Command_Master_Data_Parity_Error (0x01000000U) /*!< Bit mask for PCIE_EP_Command_Master_Data_Parity_Error. */
#define BS_PCIE_EP_Command_Master_Data_Parity_Error (1U) /*!< Bit field size in bits for PCIE_EP_Command_Master_Data_Parity_Error. */

/*! @brief Read current value of the PCIE_EP_Command_Master_Data_Parity_Error field. */
#define BR_PCIE_EP_Command_Master_Data_Parity_Error(x) (HW_PCIE_EP_Command(x).B.Master_Data_Parity_Error)

/*! @brief Format value for bitfield PCIE_EP_Command_Master_Data_Parity_Error. */
#define BF_PCIE_EP_Command_Master_Data_Parity_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Master_Data_Parity_Error) & BM_PCIE_EP_Command_Master_Data_Parity_Error)

/*! @brief Set the Master_Data_Parity_Error field to a new value. */
#define BW_PCIE_EP_Command_Master_Data_Parity_Error(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Master_Data_Parity_Error) | BF_PCIE_EP_Command_Master_Data_Parity_Error(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field DEVSEL_Timing[26:25] (RW)
 *
 * DEVSEL Timing Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_Command_DEVSEL_Timing (25U) /*!< Bit position for PCIE_EP_Command_DEVSEL_Timing. */
#define BM_PCIE_EP_Command_DEVSEL_Timing (0x06000000U) /*!< Bit mask for PCIE_EP_Command_DEVSEL_Timing. */
#define BS_PCIE_EP_Command_DEVSEL_Timing (2U) /*!< Bit field size in bits for PCIE_EP_Command_DEVSEL_Timing. */

/*! @brief Read current value of the PCIE_EP_Command_DEVSEL_Timing field. */
#define BR_PCIE_EP_Command_DEVSEL_Timing(x) (HW_PCIE_EP_Command(x).B.DEVSEL_Timing)

/*! @brief Format value for bitfield PCIE_EP_Command_DEVSEL_Timing. */
#define BF_PCIE_EP_Command_DEVSEL_Timing(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_DEVSEL_Timing) & BM_PCIE_EP_Command_DEVSEL_Timing)

/*! @brief Set the DEVSEL_Timing field to a new value. */
#define BW_PCIE_EP_Command_DEVSEL_Timing(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_DEVSEL_Timing) | BF_PCIE_EP_Command_DEVSEL_Timing(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Signaled_Target_Abort[27] (RW)
 *
 * Signaled Target Abort
 */
/*@{*/
#define BP_PCIE_EP_Command_Signaled_Target_Abort (27U) /*!< Bit position for PCIE_EP_Command_Signaled_Target_Abort. */
#define BM_PCIE_EP_Command_Signaled_Target_Abort (0x08000000U) /*!< Bit mask for PCIE_EP_Command_Signaled_Target_Abort. */
#define BS_PCIE_EP_Command_Signaled_Target_Abort (1U) /*!< Bit field size in bits for PCIE_EP_Command_Signaled_Target_Abort. */

/*! @brief Read current value of the PCIE_EP_Command_Signaled_Target_Abort field. */
#define BR_PCIE_EP_Command_Signaled_Target_Abort(x) (HW_PCIE_EP_Command(x).B.Signaled_Target_Abort)

/*! @brief Format value for bitfield PCIE_EP_Command_Signaled_Target_Abort. */
#define BF_PCIE_EP_Command_Signaled_Target_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Signaled_Target_Abort) & BM_PCIE_EP_Command_Signaled_Target_Abort)

/*! @brief Set the Signaled_Target_Abort field to a new value. */
#define BW_PCIE_EP_Command_Signaled_Target_Abort(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Signaled_Target_Abort) | BF_PCIE_EP_Command_Signaled_Target_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Received_Target_Abort[28] (RW)
 *
 * Received Target Abort
 */
/*@{*/
#define BP_PCIE_EP_Command_Received_Target_Abort (28U) /*!< Bit position for PCIE_EP_Command_Received_Target_Abort. */
#define BM_PCIE_EP_Command_Received_Target_Abort (0x10000000U) /*!< Bit mask for PCIE_EP_Command_Received_Target_Abort. */
#define BS_PCIE_EP_Command_Received_Target_Abort (1U) /*!< Bit field size in bits for PCIE_EP_Command_Received_Target_Abort. */

/*! @brief Read current value of the PCIE_EP_Command_Received_Target_Abort field. */
#define BR_PCIE_EP_Command_Received_Target_Abort(x) (HW_PCIE_EP_Command(x).B.Received_Target_Abort)

/*! @brief Format value for bitfield PCIE_EP_Command_Received_Target_Abort. */
#define BF_PCIE_EP_Command_Received_Target_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Received_Target_Abort) & BM_PCIE_EP_Command_Received_Target_Abort)

/*! @brief Set the Received_Target_Abort field to a new value. */
#define BW_PCIE_EP_Command_Received_Target_Abort(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Received_Target_Abort) | BF_PCIE_EP_Command_Received_Target_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Received_Master_Abort[29] (RW)
 *
 * Received Master Abort
 */
/*@{*/
#define BP_PCIE_EP_Command_Received_Master_Abort (29U) /*!< Bit position for PCIE_EP_Command_Received_Master_Abort. */
#define BM_PCIE_EP_Command_Received_Master_Abort (0x20000000U) /*!< Bit mask for PCIE_EP_Command_Received_Master_Abort. */
#define BS_PCIE_EP_Command_Received_Master_Abort (1U) /*!< Bit field size in bits for PCIE_EP_Command_Received_Master_Abort. */

/*! @brief Read current value of the PCIE_EP_Command_Received_Master_Abort field. */
#define BR_PCIE_EP_Command_Received_Master_Abort(x) (HW_PCIE_EP_Command(x).B.Received_Master_Abort)

/*! @brief Format value for bitfield PCIE_EP_Command_Received_Master_Abort. */
#define BF_PCIE_EP_Command_Received_Master_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Received_Master_Abort) & BM_PCIE_EP_Command_Received_Master_Abort)

/*! @brief Set the Received_Master_Abort field to a new value. */
#define BW_PCIE_EP_Command_Received_Master_Abort(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Received_Master_Abort) | BF_PCIE_EP_Command_Received_Master_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Signaled_System_Error[30] (RW)
 *
 * Signaled System Error
 */
/*@{*/
#define BP_PCIE_EP_Command_Signaled_System_Error (30U) /*!< Bit position for PCIE_EP_Command_Signaled_System_Error. */
#define BM_PCIE_EP_Command_Signaled_System_Error (0x40000000U) /*!< Bit mask for PCIE_EP_Command_Signaled_System_Error. */
#define BS_PCIE_EP_Command_Signaled_System_Error (1U) /*!< Bit field size in bits for PCIE_EP_Command_Signaled_System_Error. */

/*! @brief Read current value of the PCIE_EP_Command_Signaled_System_Error field. */
#define BR_PCIE_EP_Command_Signaled_System_Error(x) (HW_PCIE_EP_Command(x).B.Signaled_System_Error)

/*! @brief Format value for bitfield PCIE_EP_Command_Signaled_System_Error. */
#define BF_PCIE_EP_Command_Signaled_System_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Signaled_System_Error) & BM_PCIE_EP_Command_Signaled_System_Error)

/*! @brief Set the Signaled_System_Error field to a new value. */
#define BW_PCIE_EP_Command_Signaled_System_Error(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Signaled_System_Error) | BF_PCIE_EP_Command_Signaled_System_Error(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_Command, field Detected_Parity_Error[31] (RW)
 *
 * Detected Parity Error
 */
/*@{*/
#define BP_PCIE_EP_Command_Detected_Parity_Error (31U) /*!< Bit position for PCIE_EP_Command_Detected_Parity_Error. */
#define BM_PCIE_EP_Command_Detected_Parity_Error (0x80000000U) /*!< Bit mask for PCIE_EP_Command_Detected_Parity_Error. */
#define BS_PCIE_EP_Command_Detected_Parity_Error (1U) /*!< Bit field size in bits for PCIE_EP_Command_Detected_Parity_Error. */

/*! @brief Read current value of the PCIE_EP_Command_Detected_Parity_Error field. */
#define BR_PCIE_EP_Command_Detected_Parity_Error(x) (HW_PCIE_EP_Command(x).B.Detected_Parity_Error)

/*! @brief Format value for bitfield PCIE_EP_Command_Detected_Parity_Error. */
#define BF_PCIE_EP_Command_Detected_Parity_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_Command_Detected_Parity_Error) & BM_PCIE_EP_Command_Detected_Parity_Error)

/*! @brief Set the Detected_Parity_Error field to a new value. */
#define BW_PCIE_EP_Command_Detected_Parity_Error(x, v) (HW_PCIE_EP_Command_WR(x, (HW_PCIE_EP_Command_RD(x) & ~BM_PCIE_EP_Command_Detected_Parity_Error) | BF_PCIE_EP_Command_Detected_Parity_Error(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_BIST - BIST Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_BIST - BIST Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x0C Byte: 0
 */
typedef union _hw_pcie_ep_bist
{
    uint32_t U;
    struct _hw_pcie_ep_bist_bitfields
    {
        uint32_t Cache_Line_Size : 8;  /*!< [7:0]  */
        uint32_t Master_Latency_Timer : 8; /*!< [15:8]  */
        uint32_t Configuration_Header_Format : 7; /*!< [22:16]  */
        uint32_t Multi_Function_Device : 1; /*!< [23]  */
        uint32_t Not_supported_by__core : 8; /*!< [31:24]  */
    } B;
} hw_pcie_ep_bist_t;

/*!
 * @name Constants and macros for entire PCIE_EP_BIST register
 */
/*@{*/
#define HW_PCIE_EP_BIST_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_PCIE_EP_BIST(x)       (*(__IO hw_pcie_ep_bist_t *) HW_PCIE_EP_BIST_ADDR(x))
#define HW_PCIE_EP_BIST_RD(x)    (HW_PCIE_EP_BIST(x).U)
#define HW_PCIE_EP_BIST_WR(x, v) (HW_PCIE_EP_BIST(x).U = (v))
#define HW_PCIE_EP_BIST_SET(x, v) (HW_PCIE_EP_BIST_WR(x, HW_PCIE_EP_BIST_RD(x) |  (v)))
#define HW_PCIE_EP_BIST_CLR(x, v) (HW_PCIE_EP_BIST_WR(x, HW_PCIE_EP_BIST_RD(x) & ~(v)))
#define HW_PCIE_EP_BIST_TOG(x, v) (HW_PCIE_EP_BIST_WR(x, HW_PCIE_EP_BIST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_BIST bitfields
 */

/*!
 * @name Register PCIE_EP_BIST, field Cache_Line_Size[7:0] (RW)
 *
 * Cache Line Size The Cache Line Size register is RW for legacy compatibility
 * purposes and is not applicable to PCI Express device functionality. Writing to
 * the Cache Line Size register does not impact functionality of the core.
 */
/*@{*/
#define BP_PCIE_EP_BIST_Cache_Line_Size (0U) /*!< Bit position for PCIE_EP_BIST_Cache_Line_Size. */
#define BM_PCIE_EP_BIST_Cache_Line_Size (0x000000FFU) /*!< Bit mask for PCIE_EP_BIST_Cache_Line_Size. */
#define BS_PCIE_EP_BIST_Cache_Line_Size (8U) /*!< Bit field size in bits for PCIE_EP_BIST_Cache_Line_Size. */

/*! @brief Read current value of the PCIE_EP_BIST_Cache_Line_Size field. */
#define BR_PCIE_EP_BIST_Cache_Line_Size(x) (HW_PCIE_EP_BIST(x).B.Cache_Line_Size)

/*! @brief Format value for bitfield PCIE_EP_BIST_Cache_Line_Size. */
#define BF_PCIE_EP_BIST_Cache_Line_Size(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_BIST_Cache_Line_Size) & BM_PCIE_EP_BIST_Cache_Line_Size)

/*! @brief Set the Cache_Line_Size field to a new value. */
#define BW_PCIE_EP_BIST_Cache_Line_Size(x, v) (HW_PCIE_EP_BIST_WR(x, (HW_PCIE_EP_BIST_RD(x) & ~BM_PCIE_EP_BIST_Cache_Line_Size) | BF_PCIE_EP_BIST_Cache_Line_Size(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_BIST, field Master_Latency_Timer[15:8] (RW)
 *
 * Master Latency Timer Not applicable for PCI Express, hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_BIST_Master_Latency_Timer (8U) /*!< Bit position for PCIE_EP_BIST_Master_Latency_Timer. */
#define BM_PCIE_EP_BIST_Master_Latency_Timer (0x0000FF00U) /*!< Bit mask for PCIE_EP_BIST_Master_Latency_Timer. */
#define BS_PCIE_EP_BIST_Master_Latency_Timer (8U) /*!< Bit field size in bits for PCIE_EP_BIST_Master_Latency_Timer. */

/*! @brief Read current value of the PCIE_EP_BIST_Master_Latency_Timer field. */
#define BR_PCIE_EP_BIST_Master_Latency_Timer(x) (HW_PCIE_EP_BIST(x).B.Master_Latency_Timer)

/*! @brief Format value for bitfield PCIE_EP_BIST_Master_Latency_Timer. */
#define BF_PCIE_EP_BIST_Master_Latency_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_BIST_Master_Latency_Timer) & BM_PCIE_EP_BIST_Master_Latency_Timer)

/*! @brief Set the Master_Latency_Timer field to a new value. */
#define BW_PCIE_EP_BIST_Master_Latency_Timer(x, v) (HW_PCIE_EP_BIST_WR(x, (HW_PCIE_EP_BIST_RD(x) & ~BM_PCIE_EP_BIST_Master_Latency_Timer) | BF_PCIE_EP_BIST_Master_Latency_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_BIST, field Configuration_Header_Format[22:16] (RW)
 *
 * Configuration Header Format Hardwired to 0 for type 0.
 */
/*@{*/
#define BP_PCIE_EP_BIST_Configuration_Header_Format (16U) /*!< Bit position for PCIE_EP_BIST_Configuration_Header_Format. */
#define BM_PCIE_EP_BIST_Configuration_Header_Format (0x007F0000U) /*!< Bit mask for PCIE_EP_BIST_Configuration_Header_Format. */
#define BS_PCIE_EP_BIST_Configuration_Header_Format (7U) /*!< Bit field size in bits for PCIE_EP_BIST_Configuration_Header_Format. */

/*! @brief Read current value of the PCIE_EP_BIST_Configuration_Header_Format field. */
#define BR_PCIE_EP_BIST_Configuration_Header_Format(x) (HW_PCIE_EP_BIST(x).B.Configuration_Header_Format)

/*! @brief Format value for bitfield PCIE_EP_BIST_Configuration_Header_Format. */
#define BF_PCIE_EP_BIST_Configuration_Header_Format(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_BIST_Configuration_Header_Format) & BM_PCIE_EP_BIST_Configuration_Header_Format)

/*! @brief Set the Configuration_Header_Format field to a new value. */
#define BW_PCIE_EP_BIST_Configuration_Header_Format(x, v) (HW_PCIE_EP_BIST_WR(x, (HW_PCIE_EP_BIST_RD(x) & ~BM_PCIE_EP_BIST_Configuration_Header_Format) | BF_PCIE_EP_BIST_Configuration_Header_Format(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_BIST, field Multi_Function_Device[23] (RW)
 *
 * Multi Function Device The default value is 0 for a single function device
 * (`CX_NFUNC = 1) or 1 for a multi-function device (`CX_NFUNC != 1). The Multi
 * Function Device bit is writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_BIST_Multi_Function_Device (23U) /*!< Bit position for PCIE_EP_BIST_Multi_Function_Device. */
#define BM_PCIE_EP_BIST_Multi_Function_Device (0x00800000U) /*!< Bit mask for PCIE_EP_BIST_Multi_Function_Device. */
#define BS_PCIE_EP_BIST_Multi_Function_Device (1U) /*!< Bit field size in bits for PCIE_EP_BIST_Multi_Function_Device. */

/*! @brief Read current value of the PCIE_EP_BIST_Multi_Function_Device field. */
#define BR_PCIE_EP_BIST_Multi_Function_Device(x) (HW_PCIE_EP_BIST(x).B.Multi_Function_Device)

/*! @brief Format value for bitfield PCIE_EP_BIST_Multi_Function_Device. */
#define BF_PCIE_EP_BIST_Multi_Function_Device(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_BIST_Multi_Function_Device) & BM_PCIE_EP_BIST_Multi_Function_Device)

/*! @brief Set the Multi_Function_Device field to a new value. */
#define BW_PCIE_EP_BIST_Multi_Function_Device(x, v) (HW_PCIE_EP_BIST_WR(x, (HW_PCIE_EP_BIST_RD(x) & ~BM_PCIE_EP_BIST_Multi_Function_Device) | BF_PCIE_EP_BIST_Multi_Function_Device(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_BIST, field Not_supported_by__core[31:24] (RW)
 *
 * The BIST register functions are not supported by the core. All 8 bits of the
 * BIST register are hardwired to 0.
 */
/*@{*/
#define BP_PCIE_EP_BIST_Not_supported_by__core (24U) /*!< Bit position for PCIE_EP_BIST_Not_supported_by__core. */
#define BM_PCIE_EP_BIST_Not_supported_by__core (0xFF000000U) /*!< Bit mask for PCIE_EP_BIST_Not_supported_by__core. */
#define BS_PCIE_EP_BIST_Not_supported_by__core (8U) /*!< Bit field size in bits for PCIE_EP_BIST_Not_supported_by__core. */

/*! @brief Read current value of the PCIE_EP_BIST_Not_supported_by__core field. */
#define BR_PCIE_EP_BIST_Not_supported_by__core(x) (HW_PCIE_EP_BIST(x).B.Not_supported_by__core)

/*! @brief Format value for bitfield PCIE_EP_BIST_Not_supported_by__core. */
#define BF_PCIE_EP_BIST_Not_supported_by__core(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_BIST_Not_supported_by__core) & BM_PCIE_EP_BIST_Not_supported_by__core)

/*! @brief Set the Not_supported_by__core field to a new value. */
#define BW_PCIE_EP_BIST_Not_supported_by__core(x, v) (HW_PCIE_EP_BIST_WR(x, (HW_PCIE_EP_BIST_RD(x) & ~BM_PCIE_EP_BIST_Not_supported_by__core) | BF_PCIE_EP_BIST_Not_supported_by__core(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_BAR0 - Base Address 0
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_BAR0 - Base Address 0 (RO)
 *
 * Reset value: 0x0000000CU
 *
 * Offset: 0x10-0x24 The core provides three pairs of 32-bit BARs for each
 * implemented function. Each pair (BARs 0 and 1, BARs 2 and 3, BARs 4 and 5) can be
 * configured as follows: One 64-bit BAR: For example, BARs 0 and 1 are combined
 * to form a single 64-bit BAR. Two 32-bit BARs: For example, BARs 0 and 1 are two
 * independent 32-bit BARs. One 32-bit BAR: For example, BAR 0 is a 32-bit BAR
 * and BAR 1 is either disabled or removed from the core altogether to reduce gate
 * count. In addition, you can configure each BAR to have its incoming Requests
 * routed to either: RTRGT1 The following sections describe how to set up the BAR
 * types and sizes by programming values into the base address registers. For
 * more information about routing Requests to either RTRGT1 on a BAR-by- BAR basis,
 * see Receive FilteringThe core contains a filter module that is responsible
 * for the tasks listed here. . The contents of the six BARs determine the BAR
 * configuration. The reset values of the BARs are determined by hardware
 * configuration options. At runtime, application software can overwrite the BAR contents to
 * reconfigure the BARs (unless the affected BAR is removed during hardware
 * configuration). Application software must observe the rules listed below when
 * writing to the BARs. The rules for BAR configuration are the same for all three
 * pairs. Using BARs 0 and 1 as the example pair, the rules for BAR configuration
 * are: Any pair (for example, BARs 0 and 1) can be configured as one 64-bit BAR,
 * two 32-bit BARs, or one 32-bit BAR. BAR pairs cannot overlap to form a 64-bit
 * BAR. For example, you cannot combine BARs 1 and 2 to form a 64-bit BAR. An I/O
 * BAR must be a 32-bit BAR and cannot be prefetchable. If the device is
 * configured as a PCI Express Endpoint (not a Legacy Endpoint), then any memory that is
 * configured as prefetchable must be a 64-bit memory BAR. If BAR 0 is
 * configured as a 64-bit BAR: BAR 1 is the upper 32 bits of the combined 64-bit BAR
 * formed by BARs 0 and 1. Therefore, BAR 1 must be disabled and cannot be configured
 * independently. BAR 0 must be a memory BAR and can be either prefetchable or
 * non-prefetchable. The contents of the BAR 0 Mask register determine the number
 * of writable bits in the 64-bit BAR, subject to the restrictions described in
 * BAR Mask Registers . The BAR 1 Mask register contains the upper 32 bits of the
 * BAR 0 Mask value. BAR 0 can be disabled by writing 0 to bit 0 of the BAR 0 Mask
 * register If BAR 0 is configured as a 32-bit BAR: You can configure BAR 1 as
 * an independent 32-bit BAR BAR 0 can be configured as a memory BAR or an I/O
 * BAR. The contents of the BAR 0 Mask register determine the number of writable
 * bits in the 32-bit BAR 0, subject to the restrictions described in BAR Mask
 * Registers. BAR 0 can be disabled by writing 0 to bit 0 of the BAR 0 Mask register
 * When BAR 0 is configured as a 32-bit BAR, BAR 1 is available as an independent
 * 32-bit BAR according to the following rules: BAR 1 can be configured as a
 * memory BAR or an I/O BAR. The contents of the BAR 1 Mask register determine the
 * number of writable bits in the 32-bit BAR 1, subject to the restrictions
 * described in BAR Mask Registers. The same rules apply for pairs 2/3 and 4/5. Offset:
 * 0x10 (if included in the core hardware configuration)
 */
typedef union _hw_pcie_ep_bar0
{
    uint32_t U;
    struct _hw_pcie_ep_bar0_bitfields
    {
        uint32_t Mem_I_O : 1;          /*!< [0]  */
        uint32_t TYPE : 2;             /*!< [2:1]  */
        uint32_t PREF : 1;             /*!< [3]  */
        uint32_t ADDRESS : 28;         /*!< [31:4]  */
    } B;
} hw_pcie_ep_bar0_t;

/*!
 * @name Constants and macros for entire PCIE_EP_BAR0 register
 */
/*@{*/
#define HW_PCIE_EP_BAR0_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_PCIE_EP_BAR0(x)       (*(__I hw_pcie_ep_bar0_t *) HW_PCIE_EP_BAR0_ADDR(x))
#define HW_PCIE_EP_BAR0_RD(x)    (HW_PCIE_EP_BAR0(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_BAR0 bitfields
 */

/*!
 * @name Register PCIE_EP_BAR0, field Mem_I_O[0] (RO)
 *
 * Bits [3:0] are writable through the DBI.
 *
 * Values:
 * - 0 - = BAR 0 is a memory BAR
 * - 1 - = BAR 0 is an I/O BAR
 */
/*@{*/
#define BP_PCIE_EP_BAR0_Mem_I_O (0U)       /*!< Bit position for PCIE_EP_BAR0_Mem_I_O. */
#define BM_PCIE_EP_BAR0_Mem_I_O (0x00000001U) /*!< Bit mask for PCIE_EP_BAR0_Mem_I_O. */
#define BS_PCIE_EP_BAR0_Mem_I_O (1U)       /*!< Bit field size in bits for PCIE_EP_BAR0_Mem_I_O. */

/*! @brief Read current value of the PCIE_EP_BAR0_Mem_I_O field. */
#define BR_PCIE_EP_BAR0_Mem_I_O(x) (HW_PCIE_EP_BAR0(x).B.Mem_I_O)
/*@}*/

/*!
 * @name Register PCIE_EP_BAR0, field TYPE[2:1] (RO)
 *
 * If BAR 0 is an I/O BAR, bit 2 the least significant bit of the base address
 * and bit 1 is 0. Bits [3:0] are writable through the DBI. If BAR 0 is a memory
 * BAR, bits [2:1] determine the BAR type:
 *
 * Values:
 * - 00 - = 32-bit BAR
 * - 10 - = 64-bit BAR
 */
/*@{*/
#define BP_PCIE_EP_BAR0_TYPE (1U)          /*!< Bit position for PCIE_EP_BAR0_TYPE. */
#define BM_PCIE_EP_BAR0_TYPE (0x00000006U) /*!< Bit mask for PCIE_EP_BAR0_TYPE. */
#define BS_PCIE_EP_BAR0_TYPE (2U)          /*!< Bit field size in bits for PCIE_EP_BAR0_TYPE. */

/*! @brief Read current value of the PCIE_EP_BAR0_TYPE field. */
#define BR_PCIE_EP_BAR0_TYPE(x) (HW_PCIE_EP_BAR0(x).B.TYPE)
/*@}*/

/*!
 * @name Register PCIE_EP_BAR0, field PREF[3] (RO)
 *
 * If BAR 0 is an I/O BAR, bit 3 is the second least significant bit of the base
 * address. Bits [3:0] are writable through the DBI. If BAR 0 is a memory BAR,
 * bit 3 indicates if the memory region is prefetchable:
 *
 * Values:
 * - 0 - = Non-prefetchable
 * - 1 - = Prefetchable
 */
/*@{*/
#define BP_PCIE_EP_BAR0_PREF (3U)          /*!< Bit position for PCIE_EP_BAR0_PREF. */
#define BM_PCIE_EP_BAR0_PREF (0x00000008U) /*!< Bit mask for PCIE_EP_BAR0_PREF. */
#define BS_PCIE_EP_BAR0_PREF (1U)          /*!< Bit field size in bits for PCIE_EP_BAR0_PREF. */

/*! @brief Read current value of the PCIE_EP_BAR0_PREF field. */
#define BR_PCIE_EP_BAR0_PREF(x) (HW_PCIE_EP_BAR0(x).B.PREF)
/*@}*/

/*!
 * @name Register PCIE_EP_BAR0, field ADDRESS[31:4] (RO)
 *
 * BAR 0 base address bits (for a 64-bit BAR, the remaining upper address bits
 * are in BAR 1). The BAR 0 Mask value determines which address bits are masked.
 */
/*@{*/
#define BP_PCIE_EP_BAR0_ADDRESS (4U)       /*!< Bit position for PCIE_EP_BAR0_ADDRESS. */
#define BM_PCIE_EP_BAR0_ADDRESS (0xFFFFFFF0U) /*!< Bit mask for PCIE_EP_BAR0_ADDRESS. */
#define BS_PCIE_EP_BAR0_ADDRESS (28U)      /*!< Bit field size in bits for PCIE_EP_BAR0_ADDRESS. */

/*! @brief Read current value of the PCIE_EP_BAR0_ADDRESS field. */
#define BR_PCIE_EP_BAR0_ADDRESS(x) (HW_PCIE_EP_BAR0(x).B.ADDRESS)
/*@}*/
/*******************************************************************************
 * HW_PCIE_EP_MASK0 - BAR 0 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_MASK0 - BAR 0 Mask Register (RO)
 *
 * Reset value: 0x0000000CU
 *
 * The BAR masks are used for indicating the amount of memory each BAR requests
 * from host software. The application logic can overwrite the default values via
 * the DBI. The BAR Mask registers determine which bits in each BAR are
 * non-writable by host software, which determines the size of the address space claimed
 * by each BAR. The BAR Mask values indicate the range of low-order bits in each
 * implemented BAR not to use for address matching. The BAR Mask value also
 * indicates the range of low-order bits in the BAR that cannot be written from the
 * host. The application can write to all BAR bits to allow setting of memory, I/O,
 * and other standard BAR options. To disable any BAR, the application can write
 * a 0 to bit 0 of the corresponding BAR Mask register. To change the BAR Mask
 * value for a disabled BAR, the application must first enable the BAR by writing
 * 1 to bit 0. After enabling the BAR, the application can then write a new value
 * to the BAR Mask register. The BAR Mask registers are accessible through the
 * same address as the corresponding BAR registers, but requires dbi_cs2
 * assertions instead i.e. bit address 12 must be set. The BAR Mask registers are writable
 * only, not readable. If the BAR Mask value for a BAR is less than that
 * required for the BAR type, the core automatically uses the minimum value for the BAR
 * type: BAR bits [11:0] are always masked for a memory BAR. The core requires
 * each memory BAR to claim at least 4 KB. The PCI Express Base Specification
 * states that the minimum memory address range requested by a BAR is 128 bytes. In
 * the PCI Local Bus Specification, Rev 3.0 it is recommended that devices that
 * need less than 4 KB of Address Space should still consume 4 KB of address space
 * in order to minimize the number of bits in the address decoder. A Memory BAR
 * size of 256 bytes can be achieved by using a DBI2 write to BAR Mask. BAR bits
 * [7:0] are always masked for an I/O BAR. The core requires each I/O BAR to claim
 * at least 256 bytes. The PCI Local Bus Specification, Rev 3.0 allows I/O BARs
 * to consume between 4 bytes and 256 bytes of address space. The core only
 * permits I/O BARs to consume 256 bytes of address space. This restriction is used in
 * order to minimize the number of bits in the address decoder. The aperture of
 * the BAR is actually the larger of the written sizeor the system page size (set
 * by the operating system). In the case where the system page size is larger
 * than the requested bar size, the BAR is actually sized to the system page size .
 * This means that when the OS writes all 1s then reads back to determine the
 * size of the BAR, the OS will see the BAR size to be the system page size. The
 * application logic, most likely, will only have the original requested amount of
 * physical memory. A transaction will receive a UR if the transaction is from the
 * RC and it targets an address that is within the range of the allocated system
 * page size but above the implemented application memory. The figure below
 * shows an example configuration of the six BARs and their corresponding BAR Mask
 * registers. The example configuration includes: One 64-bit memory BAR
 * (non-prefetchable) One 32-bit memory BAR (non-prefetchable) One 32-bit I/O BAR Example
 * Base Address Register Configuration Offset: 0x10 (same as Base Address Register
 * 0, but requires dbi_cs2 for write access)
 */
typedef union _hw_pcie_ep_mask0
{
    uint32_t U;
    struct _hw_pcie_ep_mask0_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t MASK : 31;            /*!< [31:1]  */
    } B;
} hw_pcie_ep_mask0_t;

/*!
 * @name Constants and macros for entire PCIE_EP_MASK0 register
 */
/*@{*/
#define HW_PCIE_EP_MASK0_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_PCIE_EP_MASK0(x)      (*(__I hw_pcie_ep_mask0_t *) HW_PCIE_EP_MASK0_ADDR(x))
#define HW_PCIE_EP_MASK0_RD(x)   (HW_PCIE_EP_MASK0(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_MASK0 bitfields
 */

/*!
 * @name Register PCIE_EP_MASK0, field ENABLE[0] (RO)
 *
 * Bit 0 is interpreted as BAR Enable when writing to the BAR Mask register
 * rather than as a mask bit because bit 0 of a BAR is always masked from writing by
 * host software. BAR 0 Enable
 *
 * Values:
 * - 0 - BAR 0 is disabled
 * - 1 - BAR 0 is enabled
 */
/*@{*/
#define BP_PCIE_EP_MASK0_ENABLE (0U)       /*!< Bit position for PCIE_EP_MASK0_ENABLE. */
#define BM_PCIE_EP_MASK0_ENABLE (0x00000001U) /*!< Bit mask for PCIE_EP_MASK0_ENABLE. */
#define BS_PCIE_EP_MASK0_ENABLE (1U)       /*!< Bit field size in bits for PCIE_EP_MASK0_ENABLE. */

/*! @brief Read current value of the PCIE_EP_MASK0_ENABLE field. */
#define BR_PCIE_EP_MASK0_ENABLE(x) (HW_PCIE_EP_MASK0(x).B.ENABLE)
/*@}*/

/*!
 * @name Register PCIE_EP_MASK0, field MASK[31:1] (RO)
 *
 * Indicates which BAR 0 bits to mask (make non- writable) from host software,
 * which, in turn, determines the size of the BAR. For example, writing 0xFFF to
 * the BAR 0 Mask register claims a 4096- byte BAR by masking bits 11:0 of the BAR
 * from writing by host software. The BAR 1 Mask register contains the upper
 * bits of the BAR 0 Mask. The BAR 0 Mask register is invisible to host software and
 * not readable from the application. the BAR 0 Mask register is writable
 * through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_MASK0_MASK (1U)         /*!< Bit position for PCIE_EP_MASK0_MASK. */
#define BM_PCIE_EP_MASK0_MASK (0xFFFFFFFEU) /*!< Bit mask for PCIE_EP_MASK0_MASK. */
#define BS_PCIE_EP_MASK0_MASK (31U)        /*!< Bit field size in bits for PCIE_EP_MASK0_MASK. */

/*! @brief Read current value of the PCIE_EP_MASK0_MASK field. */
#define BR_PCIE_EP_MASK0_MASK(x) (HW_PCIE_EP_MASK0(x).B.MASK)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_MASK1 - BAR 1 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_MASK1 - BAR 1 Mask Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x14 (same as Base Address Register 1, but requires dbi_cs2 for write
 * access)
 */
typedef union _hw_pcie_ep_mask1
{
    uint32_t U;
    struct _hw_pcie_ep_mask1_bitfields
    {
        uint32_t MASK : 32;            /*!< [31:0]  */
    } B;
} hw_pcie_ep_mask1_t;

/*!
 * @name Constants and macros for entire PCIE_EP_MASK1 register
 */
/*@{*/
#define HW_PCIE_EP_MASK1_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_PCIE_EP_MASK1(x)      (*(__I hw_pcie_ep_mask1_t *) HW_PCIE_EP_MASK1_ADDR(x))
#define HW_PCIE_EP_MASK1_RD(x)   (HW_PCIE_EP_MASK1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_MASK1 bitfields
 */

/*!
 * @name Register PCIE_EP_MASK1, field MASK[31:0] (RO)
 *
 * Bits [31:1]: BAR 1 Mask value, interpreted the same way as BAR 0 Mask.
 * Default value is `BAR1_MASK_N. Bit 0: BAR 1 Enable (0 = BAR 1 is disabled; 1= BAR 1
 * is enabled). Default value is `BAR1_ENABLED_N. `BAR1_MASK_WRITABLE_N controls
 * application write access to the BAR 1 Mask register. Bits [31:0] are the upper
 * bits of the BAR 0 Mask value. `BAR0_MASK_WRITABLE_N controls application
 * write access to the full 64-bit BAR 0 Mask register.
 */
/*@{*/
#define BP_PCIE_EP_MASK1_MASK (0U)         /*!< Bit position for PCIE_EP_MASK1_MASK. */
#define BM_PCIE_EP_MASK1_MASK (0xFFFFFFFFU) /*!< Bit mask for PCIE_EP_MASK1_MASK. */
#define BS_PCIE_EP_MASK1_MASK (32U)        /*!< Bit field size in bits for PCIE_EP_MASK1_MASK. */

/*! @brief Read current value of the PCIE_EP_MASK1_MASK field. */
#define BR_PCIE_EP_MASK1_MASK(x) (HW_PCIE_EP_MASK1(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_MASK2 - BAR 2 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_MASK2 - BAR 2 Mask Register (RO)
 *
 * Reset value: 0x00000008U
 *
 * Offset: 0x18 (same as Base Address Register 2, but requires dbi_cs2 for write
 * access)
 */
typedef union _hw_pcie_ep_mask2
{
    uint32_t U;
    struct _hw_pcie_ep_mask2_bitfields
    {
        uint32_t BAR2_ENABLED_N : 1;   /*!< [0]  */
        uint32_t BAR2_MASK_N : 31;     /*!< [31:1]  */
    } B;
} hw_pcie_ep_mask2_t;

/*!
 * @name Constants and macros for entire PCIE_EP_MASK2 register
 */
/*@{*/
#define HW_PCIE_EP_MASK2_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_PCIE_EP_MASK2(x)      (*(__I hw_pcie_ep_mask2_t *) HW_PCIE_EP_MASK2_ADDR(x))
#define HW_PCIE_EP_MASK2_RD(x)   (HW_PCIE_EP_MASK2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_MASK2 bitfields
 */

/*!
 * @name Register PCIE_EP_MASK2, field BAR2_ENABLED_N[0] (RO)
 *
 * Bit 0 is interpreted as BAR Enable when writing to the BAR Mask register
 * rather than as a mask bit because bit 0 of a BAR is always masked from writing by
 * host software. BAR 2 Enable
 *
 * Values:
 * - 0 - BAR 2 is disabled
 * - 1 - BAR 2 is enabled
 */
/*@{*/
#define BP_PCIE_EP_MASK2_BAR2_ENABLED_N (0U) /*!< Bit position for PCIE_EP_MASK2_BAR2_ENABLED_N. */
#define BM_PCIE_EP_MASK2_BAR2_ENABLED_N (0x00000001U) /*!< Bit mask for PCIE_EP_MASK2_BAR2_ENABLED_N. */
#define BS_PCIE_EP_MASK2_BAR2_ENABLED_N (1U) /*!< Bit field size in bits for PCIE_EP_MASK2_BAR2_ENABLED_N. */

/*! @brief Read current value of the PCIE_EP_MASK2_BAR2_ENABLED_N field. */
#define BR_PCIE_EP_MASK2_BAR2_ENABLED_N(x) (HW_PCIE_EP_MASK2(x).B.BAR2_ENABLED_N)
/*@}*/

/*!
 * @name Register PCIE_EP_MASK2, field BAR2_MASK_N[31:1] (RO)
 *
 * Indicates which BAR 2 bits to mask (make non- writable) from host software,
 * which, in turn, determines the size of the BAR. For example, writing 0xFFF to
 * the BAR 2 Mask register claims a 4096-byte BAR by masking bits 11:0 of the BAR
 * from writing by host software. The BAR 2 Mask register is invisible to host
 * software and not readable from the application. the BAR 2 Mask register is
 * writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_MASK2_BAR2_MASK_N (1U)  /*!< Bit position for PCIE_EP_MASK2_BAR2_MASK_N. */
#define BM_PCIE_EP_MASK2_BAR2_MASK_N (0xFFFFFFFEU) /*!< Bit mask for PCIE_EP_MASK2_BAR2_MASK_N. */
#define BS_PCIE_EP_MASK2_BAR2_MASK_N (31U) /*!< Bit field size in bits for PCIE_EP_MASK2_BAR2_MASK_N. */

/*! @brief Read current value of the PCIE_EP_MASK2_BAR2_MASK_N field. */
#define BR_PCIE_EP_MASK2_BAR2_MASK_N(x) (HW_PCIE_EP_MASK2(x).B.BAR2_MASK_N)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_MASK3 - BAR 3 Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_MASK3 - BAR 3 Mask Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x1C (same as Base Address Register 3, but requires dbi_cs2 for write
 * access)
 */
typedef union _hw_pcie_ep_mask3
{
    uint32_t U;
    struct _hw_pcie_ep_mask3_bitfields
    {
        uint32_t MASK : 32;            /*!< [31:0]  */
    } B;
} hw_pcie_ep_mask3_t;

/*!
 * @name Constants and macros for entire PCIE_EP_MASK3 register
 */
/*@{*/
#define HW_PCIE_EP_MASK3_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_PCIE_EP_MASK3(x)      (*(__I hw_pcie_ep_mask3_t *) HW_PCIE_EP_MASK3_ADDR(x))
#define HW_PCIE_EP_MASK3_RD(x)   (HW_PCIE_EP_MASK3(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_MASK3 bitfields
 */

/*!
 * @name Register PCIE_EP_MASK3, field MASK[31:0] (RO)
 *
 * Bits [31:1]: BAR 3 Mask value, interpreted the same way as BAR 2 Mask.
 * Default value is `BAR3_MASK_N. Bit 0: BAR 3 Enable (0 = BAR 3 is disabled; 1= BAR 3
 * is enabled). Default value is `BAR3_ENABLED_N. `BAR3_MASK_WRITABLE_N controls
 * application can not write access to the BAR 3 Mask register. Bits [31:0] are
 * the upper bits of the BAR 2 Mask value. `BAR2_MASK_WRITABLE_N controls
 * application write access to the full 64-bit BAR 2 Mask register.
 */
/*@{*/
#define BP_PCIE_EP_MASK3_MASK (0U)         /*!< Bit position for PCIE_EP_MASK3_MASK. */
#define BM_PCIE_EP_MASK3_MASK (0xFFFFFFFFU) /*!< Bit mask for PCIE_EP_MASK3_MASK. */
#define BS_PCIE_EP_MASK3_MASK (32U)        /*!< Bit field size in bits for PCIE_EP_MASK3_MASK. */

/*! @brief Read current value of the PCIE_EP_MASK3_MASK field. */
#define BR_PCIE_EP_MASK3_MASK(x) (HW_PCIE_EP_MASK3(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_CISP - CardBus CIS Pointer Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_CISP - CardBus CIS Pointer Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x28
 */
typedef union _hw_pcie_ep_cisp
{
    uint32_t U;
    struct _hw_pcie_ep_cisp_bitfields
    {
        uint32_t CARDBUS_CIS_PTR_N : 32; /*!< [31:0]  */
    } B;
} hw_pcie_ep_cisp_t;

/*!
 * @name Constants and macros for entire PCIE_EP_CISP register
 */
/*@{*/
#define HW_PCIE_EP_CISP_ADDR(x)  ((uintptr_t)(x) + 0x28U)

#define HW_PCIE_EP_CISP(x)       (*(__I hw_pcie_ep_cisp_t *) HW_PCIE_EP_CISP_ADDR(x))
#define HW_PCIE_EP_CISP_RD(x)    (HW_PCIE_EP_CISP(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_CISP bitfields
 */

/*!
 * @name Register PCIE_EP_CISP, field CARDBUS_CIS_PTR_N[31:0] (RO)
 *
 * CardBus CIS Pointer Optional, writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_CISP_CARDBUS_CIS_PTR_N (0U) /*!< Bit position for PCIE_EP_CISP_CARDBUS_CIS_PTR_N. */
#define BM_PCIE_EP_CISP_CARDBUS_CIS_PTR_N (0xFFFFFFFFU) /*!< Bit mask for PCIE_EP_CISP_CARDBUS_CIS_PTR_N. */
#define BS_PCIE_EP_CISP_CARDBUS_CIS_PTR_N (32U) /*!< Bit field size in bits for PCIE_EP_CISP_CARDBUS_CIS_PTR_N. */

/*! @brief Read current value of the PCIE_EP_CISP_CARDBUS_CIS_PTR_N field. */
#define BR_PCIE_EP_CISP_CARDBUS_CIS_PTR_N(x) (HW_PCIE_EP_CISP(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_SSID - Subsystem ID and Subsystem Vendor ID Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_SSID - Subsystem ID and Subsystem Vendor ID Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x2C
 */
typedef union _hw_pcie_ep_ssid
{
    uint32_t U;
    struct _hw_pcie_ep_ssid_bitfields
    {
        uint32_t SUBSYS_VENDOR_ID_N : 16; /*!< [15:0]  */
        uint32_t SUBSYS_DEV_ID_N : 16; /*!< [31:16]  */
    } B;
} hw_pcie_ep_ssid_t;

/*!
 * @name Constants and macros for entire PCIE_EP_SSID register
 */
/*@{*/
#define HW_PCIE_EP_SSID_ADDR(x)  ((uintptr_t)(x) + 0x2CU)

#define HW_PCIE_EP_SSID(x)       (*(__I hw_pcie_ep_ssid_t *) HW_PCIE_EP_SSID_ADDR(x))
#define HW_PCIE_EP_SSID_RD(x)    (HW_PCIE_EP_SSID(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_SSID bitfields
 */

/*!
 * @name Register PCIE_EP_SSID, field SUBSYS_VENDOR_ID_N[15:0] (RO)
 *
 * Subsystem Vendor ID Writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_SSID_SUBSYS_VENDOR_ID_N (0U) /*!< Bit position for PCIE_EP_SSID_SUBSYS_VENDOR_ID_N. */
#define BM_PCIE_EP_SSID_SUBSYS_VENDOR_ID_N (0x0000FFFFU) /*!< Bit mask for PCIE_EP_SSID_SUBSYS_VENDOR_ID_N. */
#define BS_PCIE_EP_SSID_SUBSYS_VENDOR_ID_N (16U) /*!< Bit field size in bits for PCIE_EP_SSID_SUBSYS_VENDOR_ID_N. */

/*! @brief Read current value of the PCIE_EP_SSID_SUBSYS_VENDOR_ID_N field. */
#define BR_PCIE_EP_SSID_SUBSYS_VENDOR_ID_N(x) (HW_PCIE_EP_SSID(x).B.SUBSYS_VENDOR_ID_N)
/*@}*/

/*!
 * @name Register PCIE_EP_SSID, field SUBSYS_DEV_ID_N[31:16] (RO)
 *
 * Subsystem ID Writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_SSID_SUBSYS_DEV_ID_N (16U) /*!< Bit position for PCIE_EP_SSID_SUBSYS_DEV_ID_N. */
#define BM_PCIE_EP_SSID_SUBSYS_DEV_ID_N (0xFFFF0000U) /*!< Bit mask for PCIE_EP_SSID_SUBSYS_DEV_ID_N. */
#define BS_PCIE_EP_SSID_SUBSYS_DEV_ID_N (16U) /*!< Bit field size in bits for PCIE_EP_SSID_SUBSYS_DEV_ID_N. */

/*! @brief Read current value of the PCIE_EP_SSID_SUBSYS_DEV_ID_N field. */
#define BR_PCIE_EP_SSID_SUBSYS_DEV_ID_N(x) (HW_PCIE_EP_SSID(x).B.SUBSYS_DEV_ID_N)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_EROMBAR - Expansion ROM Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_EROMBAR - Expansion ROM Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x30
 */
typedef union _hw_pcie_ep_erombar
{
    uint32_t U;
    struct _hw_pcie_ep_erombar_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t RESERVED0 : 10;       /*!< [10:1]  */
        uint32_t ADDRESS : 21;         /*!< [31:11]  */
    } B;
} hw_pcie_ep_erombar_t;

/*!
 * @name Constants and macros for entire PCIE_EP_EROMBAR register
 */
/*@{*/
#define HW_PCIE_EP_EROMBAR_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_PCIE_EP_EROMBAR(x)    (*(__IO hw_pcie_ep_erombar_t *) HW_PCIE_EP_EROMBAR_ADDR(x))
#define HW_PCIE_EP_EROMBAR_RD(x) (HW_PCIE_EP_EROMBAR(x).U)
#define HW_PCIE_EP_EROMBAR_WR(x, v) (HW_PCIE_EP_EROMBAR(x).U = (v))
#define HW_PCIE_EP_EROMBAR_SET(x, v) (HW_PCIE_EP_EROMBAR_WR(x, HW_PCIE_EP_EROMBAR_RD(x) |  (v)))
#define HW_PCIE_EP_EROMBAR_CLR(x, v) (HW_PCIE_EP_EROMBAR_WR(x, HW_PCIE_EP_EROMBAR_RD(x) & ~(v)))
#define HW_PCIE_EP_EROMBAR_TOG(x, v) (HW_PCIE_EP_EROMBAR_WR(x, HW_PCIE_EP_EROMBAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_EROMBAR bitfields
 */

/*!
 * @name Register PCIE_EP_EROMBAR, field ENABLE[0] (RW)
 *
 * Expansion ROM Enable
 */
/*@{*/
#define BP_PCIE_EP_EROMBAR_ENABLE (0U)     /*!< Bit position for PCIE_EP_EROMBAR_ENABLE. */
#define BM_PCIE_EP_EROMBAR_ENABLE (0x00000001U) /*!< Bit mask for PCIE_EP_EROMBAR_ENABLE. */
#define BS_PCIE_EP_EROMBAR_ENABLE (1U)     /*!< Bit field size in bits for PCIE_EP_EROMBAR_ENABLE. */

/*! @brief Read current value of the PCIE_EP_EROMBAR_ENABLE field. */
#define BR_PCIE_EP_EROMBAR_ENABLE(x) (HW_PCIE_EP_EROMBAR(x).B.ENABLE)

/*! @brief Format value for bitfield PCIE_EP_EROMBAR_ENABLE. */
#define BF_PCIE_EP_EROMBAR_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_EROMBAR_ENABLE) & BM_PCIE_EP_EROMBAR_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_PCIE_EP_EROMBAR_ENABLE(x, v) (HW_PCIE_EP_EROMBAR_WR(x, (HW_PCIE_EP_EROMBAR_RD(x) & ~BM_PCIE_EP_EROMBAR_ENABLE) | BF_PCIE_EP_EROMBAR_ENABLE(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_EROMBAR, field ADDRESS[31:11] (RW)
 *
 * Expansion ROM Address
 */
/*@{*/
#define BP_PCIE_EP_EROMBAR_ADDRESS (11U)   /*!< Bit position for PCIE_EP_EROMBAR_ADDRESS. */
#define BM_PCIE_EP_EROMBAR_ADDRESS (0xFFFFF800U) /*!< Bit mask for PCIE_EP_EROMBAR_ADDRESS. */
#define BS_PCIE_EP_EROMBAR_ADDRESS (21U)   /*!< Bit field size in bits for PCIE_EP_EROMBAR_ADDRESS. */

/*! @brief Read current value of the PCIE_EP_EROMBAR_ADDRESS field. */
#define BR_PCIE_EP_EROMBAR_ADDRESS(x) (HW_PCIE_EP_EROMBAR(x).B.ADDRESS)

/*! @brief Format value for bitfield PCIE_EP_EROMBAR_ADDRESS. */
#define BF_PCIE_EP_EROMBAR_ADDRESS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_EROMBAR_ADDRESS) & BM_PCIE_EP_EROMBAR_ADDRESS)

/*! @brief Set the ADDRESS field to a new value. */
#define BW_PCIE_EP_EROMBAR_ADDRESS(x, v) (HW_PCIE_EP_EROMBAR_WR(x, (HW_PCIE_EP_EROMBAR_RD(x) & ~BM_PCIE_EP_EROMBAR_ADDRESS) | BF_PCIE_EP_EROMBAR_ADDRESS(v)))
/*@}*/
/*******************************************************************************
 * HW_PCIE_EP_EROMMASK - Expansion ROM BAR Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_EROMMASK - Expansion ROM BAR Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x30 (same as the Expansion ROM BAR, but requires dbi_cs2 for write
 * access)
 */
typedef union _hw_pcie_ep_erommask
{
    uint32_t U;
    struct _hw_pcie_ep_erommask_bitfields
    {
        uint32_t ROM_BAR_ENABLED_N : 1; /*!< [0]  */
        uint32_t ROM_MASK_N : 31;      /*!< [31:1]  */
    } B;
} hw_pcie_ep_erommask_t;

/*!
 * @name Constants and macros for entire PCIE_EP_EROMMASK register
 */
/*@{*/
#define HW_PCIE_EP_EROMMASK_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_PCIE_EP_EROMMASK(x)   (*(__IO hw_pcie_ep_erommask_t *) HW_PCIE_EP_EROMMASK_ADDR(x))
#define HW_PCIE_EP_EROMMASK_RD(x) (HW_PCIE_EP_EROMMASK(x).U)
#define HW_PCIE_EP_EROMMASK_WR(x, v) (HW_PCIE_EP_EROMMASK(x).U = (v))
#define HW_PCIE_EP_EROMMASK_SET(x, v) (HW_PCIE_EP_EROMMASK_WR(x, HW_PCIE_EP_EROMMASK_RD(x) |  (v)))
#define HW_PCIE_EP_EROMMASK_CLR(x, v) (HW_PCIE_EP_EROMMASK_WR(x, HW_PCIE_EP_EROMMASK_RD(x) & ~(v)))
#define HW_PCIE_EP_EROMMASK_TOG(x, v) (HW_PCIE_EP_EROMMASK_WR(x, HW_PCIE_EP_EROMMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_EROMMASK bitfields
 */

/*!
 * @name Register PCIE_EP_EROMMASK, field ROM_BAR_ENABLED_N[0] (RW)
 *
 * Expansion ROM BAR Enable
 *
 * Values:
 * - 0 - Expansion ROM BAR is disabled
 * - 1 - Expansion ROM BAR is enabled
 */
/*@{*/
#define BP_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N (0U) /*!< Bit position for PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N. */
#define BM_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N (0x00000001U) /*!< Bit mask for PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N. */
#define BS_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N (1U) /*!< Bit field size in bits for PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N. */

/*! @brief Read current value of the PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N field. */
#define BR_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N(x) (HW_PCIE_EP_EROMMASK(x).B.ROM_BAR_ENABLED_N)

/*! @brief Format value for bitfield PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N. */
#define BF_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N) & BM_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N)

/*! @brief Set the ROM_BAR_ENABLED_N field to a new value. */
#define BW_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N(x, v) (HW_PCIE_EP_EROMMASK_WR(x, (HW_PCIE_EP_EROMMASK_RD(x) & ~BM_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N) | BF_PCIE_EP_EROMMASK_ROM_BAR_ENABLED_N(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_EROMMASK, field ROM_MASK_N[31:1] (RW)
 *
 * Indicates which Expansion ROM BAR bits to mask (make non-writable) from host
 * software, which, in turn, determines the size of the BAR. For example, writing
 * 0xFFF to the Expansion ROM BAR Mask register claims a 4096-byte BAR by
 * masking bits 11:0 of the BAR from writing by host software. The maximum value is
 * 0xFFFFFF because the maximum space that can be claimed by an Expansion ROM BAR is
 * 16 MB. The Expansion ROM BAR Mask register is invisible to host software and
 * not readable from the application. Application access depends on the value of
 * the Expansion ROM BAR Mask register is writable through the DBI.
 */
/*@{*/
#define BP_PCIE_EP_EROMMASK_ROM_MASK_N (1U) /*!< Bit position for PCIE_EP_EROMMASK_ROM_MASK_N. */
#define BM_PCIE_EP_EROMMASK_ROM_MASK_N (0xFFFFFFFEU) /*!< Bit mask for PCIE_EP_EROMMASK_ROM_MASK_N. */
#define BS_PCIE_EP_EROMMASK_ROM_MASK_N (31U) /*!< Bit field size in bits for PCIE_EP_EROMMASK_ROM_MASK_N. */

/*! @brief Read current value of the PCIE_EP_EROMMASK_ROM_MASK_N field. */
#define BR_PCIE_EP_EROMMASK_ROM_MASK_N(x) (HW_PCIE_EP_EROMMASK(x).B.ROM_MASK_N)

/*! @brief Format value for bitfield PCIE_EP_EROMMASK_ROM_MASK_N. */
#define BF_PCIE_EP_EROMMASK_ROM_MASK_N(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_EROMMASK_ROM_MASK_N) & BM_PCIE_EP_EROMMASK_ROM_MASK_N)

/*! @brief Set the ROM_MASK_N field to a new value. */
#define BW_PCIE_EP_EROMMASK_ROM_MASK_N(x, v) (HW_PCIE_EP_EROMMASK_WR(x, (HW_PCIE_EP_EROMMASK_RD(x) & ~BM_PCIE_EP_EROMMASK_ROM_MASK_N) | BF_PCIE_EP_EROMMASK_ROM_MASK_N(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_CAPPR - Capability Pointer Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_CAPPR - Capability Pointer Register (RO)
 *
 * Reset value: 0x00000040U
 *
 * Offset: 0x34 Byte: 0
 */
typedef union _hw_pcie_ep_cappr
{
    uint32_t U;
    struct _hw_pcie_ep_cappr_bitfields
    {
        uint32_t CFG_NEXT_PTR : 8;     /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_pcie_ep_cappr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_CAPPR register
 */
/*@{*/
#define HW_PCIE_EP_CAPPR_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_PCIE_EP_CAPPR(x)      (*(__I hw_pcie_ep_cappr_t *) HW_PCIE_EP_CAPPR_ADDR(x))
#define HW_PCIE_EP_CAPPR_RD(x)   (HW_PCIE_EP_CAPPR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_CAPPR bitfields
 */

/*!
 * @name Register PCIE_EP_CAPPR, field CFG_NEXT_PTR[7:0] (RO)
 *
 * First Capability Pointer. See PF PCI Standard Capability Structures Register
 * Maps for more information.
 */
/*@{*/
#define BP_PCIE_EP_CAPPR_CFG_NEXT_PTR (0U) /*!< Bit position for PCIE_EP_CAPPR_CFG_NEXT_PTR. */
#define BM_PCIE_EP_CAPPR_CFG_NEXT_PTR (0x000000FFU) /*!< Bit mask for PCIE_EP_CAPPR_CFG_NEXT_PTR. */
#define BS_PCIE_EP_CAPPR_CFG_NEXT_PTR (8U) /*!< Bit field size in bits for PCIE_EP_CAPPR_CFG_NEXT_PTR. */

/*! @brief Read current value of the PCIE_EP_CAPPR_CFG_NEXT_PTR field. */
#define BR_PCIE_EP_CAPPR_CFG_NEXT_PTR(x) (HW_PCIE_EP_CAPPR(x).B.CFG_NEXT_PTR)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_ILR - Interrupt Line and Pin Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_ILR - Interrupt Line and Pin Register (RW)
 *
 * Reset value: 0x000001FFU
 *
 * Offset: 0x3C Byte: 0
 */
typedef union _hw_pcie_ep_ilr
{
    uint32_t U;
    struct _hw_pcie_ep_ilr_bitfields
    {
        uint32_t INTERRUPT_LINE : 8;   /*!< [7:0]  */
        uint32_t INT_PIN_MAPPING_N : 8; /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_pcie_ep_ilr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_ILR register
 */
/*@{*/
#define HW_PCIE_EP_ILR_ADDR(x)   ((uintptr_t)(x) + 0x3CU)

#define HW_PCIE_EP_ILR(x)        (*(__IO hw_pcie_ep_ilr_t *) HW_PCIE_EP_ILR_ADDR(x))
#define HW_PCIE_EP_ILR_RD(x)     (HW_PCIE_EP_ILR(x).U)
#define HW_PCIE_EP_ILR_WR(x, v)  (HW_PCIE_EP_ILR(x).U = (v))
#define HW_PCIE_EP_ILR_SET(x, v) (HW_PCIE_EP_ILR_WR(x, HW_PCIE_EP_ILR_RD(x) |  (v)))
#define HW_PCIE_EP_ILR_CLR(x, v) (HW_PCIE_EP_ILR_WR(x, HW_PCIE_EP_ILR_RD(x) & ~(v)))
#define HW_PCIE_EP_ILR_TOG(x, v) (HW_PCIE_EP_ILR_WR(x, HW_PCIE_EP_ILR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_ILR bitfields
 */

/*!
 * @name Register PCIE_EP_ILR, field INTERRUPT_LINE[7:0] (RW)
 *
 * Interrupt Line Value in this register is system architecture specific. POST
 * software will write the routing information into this register as it
 * initializes and configures the system.
 */
/*@{*/
#define BP_PCIE_EP_ILR_INTERRUPT_LINE (0U) /*!< Bit position for PCIE_EP_ILR_INTERRUPT_LINE. */
#define BM_PCIE_EP_ILR_INTERRUPT_LINE (0x000000FFU) /*!< Bit mask for PCIE_EP_ILR_INTERRUPT_LINE. */
#define BS_PCIE_EP_ILR_INTERRUPT_LINE (8U) /*!< Bit field size in bits for PCIE_EP_ILR_INTERRUPT_LINE. */

/*! @brief Read current value of the PCIE_EP_ILR_INTERRUPT_LINE field. */
#define BR_PCIE_EP_ILR_INTERRUPT_LINE(x) (HW_PCIE_EP_ILR(x).B.INTERRUPT_LINE)

/*! @brief Format value for bitfield PCIE_EP_ILR_INTERRUPT_LINE. */
#define BF_PCIE_EP_ILR_INTERRUPT_LINE(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ILR_INTERRUPT_LINE) & BM_PCIE_EP_ILR_INTERRUPT_LINE)

/*! @brief Set the INTERRUPT_LINE field to a new value. */
#define BW_PCIE_EP_ILR_INTERRUPT_LINE(x, v) (HW_PCIE_EP_ILR_WR(x, (HW_PCIE_EP_ILR_RD(x) & ~BM_PCIE_EP_ILR_INTERRUPT_LINE) | BF_PCIE_EP_ILR_INTERRUPT_LINE(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_ILR, field INT_PIN_MAPPING_N[15:8] (RW)
 *
 * Interrupt Pin Identifies the legacy interrupt Message that the device (or
 * device function) uses. In a single-function configuration, the core only uses
 * INTA. The Interrupt Pin register is writable through the DBI. Valid values are:
 *
 * Values:
 * - 0 - The device (or function) does not use legacy interrupt
 * - 1 - The device (or function) uses INTA
 * - 10 - The device (or function) uses INTB
 * - 11 - The device (or function) uses INTC
 * - 100 - The device (or function) uses INTD
 */
/*@{*/
#define BP_PCIE_EP_ILR_INT_PIN_MAPPING_N (8U) /*!< Bit position for PCIE_EP_ILR_INT_PIN_MAPPING_N. */
#define BM_PCIE_EP_ILR_INT_PIN_MAPPING_N (0x0000FF00U) /*!< Bit mask for PCIE_EP_ILR_INT_PIN_MAPPING_N. */
#define BS_PCIE_EP_ILR_INT_PIN_MAPPING_N (8U) /*!< Bit field size in bits for PCIE_EP_ILR_INT_PIN_MAPPING_N. */

/*! @brief Read current value of the PCIE_EP_ILR_INT_PIN_MAPPING_N field. */
#define BR_PCIE_EP_ILR_INT_PIN_MAPPING_N(x) (HW_PCIE_EP_ILR(x).B.INT_PIN_MAPPING_N)

/*! @brief Format value for bitfield PCIE_EP_ILR_INT_PIN_MAPPING_N. */
#define BF_PCIE_EP_ILR_INT_PIN_MAPPING_N(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ILR_INT_PIN_MAPPING_N) & BM_PCIE_EP_ILR_INT_PIN_MAPPING_N)

/*! @brief Set the INT_PIN_MAPPING_N field to a new value. */
#define BW_PCIE_EP_ILR_INT_PIN_MAPPING_N(x, v) (HW_PCIE_EP_ILR_WR(x, (HW_PCIE_EP_ILR_RD(x) & ~BM_PCIE_EP_ILR_INT_PIN_MAPPING_N) | BF_PCIE_EP_ILR_INT_PIN_MAPPING_N(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_AER - AER Capability Header
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_AER - AER Capability Header (RW)
 *
 * Reset value: 0x00000000U
 *
 * The core implements the following PCI Express Extended Capabilities
 * registers: ? Advanced Error Reporting Capability register set ? Virtual Channel
 * Capability register set - Address: 0x100
 */
typedef union _hw_pcie_ep_aer
{
    uint32_t U;
    struct _hw_pcie_ep_aer_bitfields
    {
        uint32_t PCI_Express_Extended_Capability_ID : 16; /*!< [15:0]  */
        uint32_t Capability_Version : 4; /*!< [19:16]  */
        uint32_t Next_Capability_Offset : 12; /*!< [31:20]  */
    } B;
} hw_pcie_ep_aer_t;

/*!
 * @name Constants and macros for entire PCIE_EP_AER register
 */
/*@{*/
#define HW_PCIE_EP_AER_ADDR(x)   ((uintptr_t)(x) + 0x100U)

#define HW_PCIE_EP_AER(x)        (*(__IO hw_pcie_ep_aer_t *) HW_PCIE_EP_AER_ADDR(x))
#define HW_PCIE_EP_AER_RD(x)     (HW_PCIE_EP_AER(x).U)
#define HW_PCIE_EP_AER_WR(x, v)  (HW_PCIE_EP_AER(x).U = (v))
#define HW_PCIE_EP_AER_SET(x, v) (HW_PCIE_EP_AER_WR(x, HW_PCIE_EP_AER_RD(x) |  (v)))
#define HW_PCIE_EP_AER_CLR(x, v) (HW_PCIE_EP_AER_WR(x, HW_PCIE_EP_AER_RD(x) & ~(v)))
#define HW_PCIE_EP_AER_TOG(x, v) (HW_PCIE_EP_AER_WR(x, HW_PCIE_EP_AER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_AER bitfields
 */

/*!
 * @name Register PCIE_EP_AER, field PCI_Express_Extended_Capability_ID[15:0] (RW)
 *
 * PCI Express Extended Capability ID Value is 0x1 for Advanced Error Reporting.
 */
/*@{*/
#define BP_PCIE_EP_AER_PCI_Express_Extended_Capability_ID (0U) /*!< Bit position for PCIE_EP_AER_PCI_Express_Extended_Capability_ID. */
#define BM_PCIE_EP_AER_PCI_Express_Extended_Capability_ID (0x0000FFFFU) /*!< Bit mask for PCIE_EP_AER_PCI_Express_Extended_Capability_ID. */
#define BS_PCIE_EP_AER_PCI_Express_Extended_Capability_ID (16U) /*!< Bit field size in bits for PCIE_EP_AER_PCI_Express_Extended_Capability_ID. */

/*! @brief Read current value of the PCIE_EP_AER_PCI_Express_Extended_Capability_ID field. */
#define BR_PCIE_EP_AER_PCI_Express_Extended_Capability_ID(x) (HW_PCIE_EP_AER(x).B.PCI_Express_Extended_Capability_ID)

/*! @brief Format value for bitfield PCIE_EP_AER_PCI_Express_Extended_Capability_ID. */
#define BF_PCIE_EP_AER_PCI_Express_Extended_Capability_ID(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_AER_PCI_Express_Extended_Capability_ID) & BM_PCIE_EP_AER_PCI_Express_Extended_Capability_ID)

/*! @brief Set the PCI_Express_Extended_Capability_ID field to a new value. */
#define BW_PCIE_EP_AER_PCI_Express_Extended_Capability_ID(x, v) (HW_PCIE_EP_AER_WR(x, (HW_PCIE_EP_AER_RD(x) & ~BM_PCIE_EP_AER_PCI_Express_Extended_Capability_ID) | BF_PCIE_EP_AER_PCI_Express_Extended_Capability_ID(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_AER, field Capability_Version[19:16] (RW)
 *
 * Capability Version
 */
/*@{*/
#define BP_PCIE_EP_AER_Capability_Version (16U) /*!< Bit position for PCIE_EP_AER_Capability_Version. */
#define BM_PCIE_EP_AER_Capability_Version (0x000F0000U) /*!< Bit mask for PCIE_EP_AER_Capability_Version. */
#define BS_PCIE_EP_AER_Capability_Version (4U) /*!< Bit field size in bits for PCIE_EP_AER_Capability_Version. */

/*! @brief Read current value of the PCIE_EP_AER_Capability_Version field. */
#define BR_PCIE_EP_AER_Capability_Version(x) (HW_PCIE_EP_AER(x).B.Capability_Version)

/*! @brief Format value for bitfield PCIE_EP_AER_Capability_Version. */
#define BF_PCIE_EP_AER_Capability_Version(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_AER_Capability_Version) & BM_PCIE_EP_AER_Capability_Version)

/*! @brief Set the Capability_Version field to a new value. */
#define BW_PCIE_EP_AER_Capability_Version(x, v) (HW_PCIE_EP_AER_WR(x, (HW_PCIE_EP_AER_RD(x) & ~BM_PCIE_EP_AER_Capability_Version) | BF_PCIE_EP_AER_Capability_Version(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_AER, field Next_Capability_Offset[31:20] (RW)
 *
 * Next Capability Offset
 */
/*@{*/
#define BP_PCIE_EP_AER_Next_Capability_Offset (20U) /*!< Bit position for PCIE_EP_AER_Next_Capability_Offset. */
#define BM_PCIE_EP_AER_Next_Capability_Offset (0xFFF00000U) /*!< Bit mask for PCIE_EP_AER_Next_Capability_Offset. */
#define BS_PCIE_EP_AER_Next_Capability_Offset (12U) /*!< Bit field size in bits for PCIE_EP_AER_Next_Capability_Offset. */

/*! @brief Read current value of the PCIE_EP_AER_Next_Capability_Offset field. */
#define BR_PCIE_EP_AER_Next_Capability_Offset(x) (HW_PCIE_EP_AER(x).B.Next_Capability_Offset)

/*! @brief Format value for bitfield PCIE_EP_AER_Next_Capability_Offset. */
#define BF_PCIE_EP_AER_Next_Capability_Offset(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_AER_Next_Capability_Offset) & BM_PCIE_EP_AER_Next_Capability_Offset)

/*! @brief Set the Next_Capability_Offset field to a new value. */
#define BW_PCIE_EP_AER_Next_Capability_Offset(x, v) (HW_PCIE_EP_AER_WR(x, (HW_PCIE_EP_AER_RD(x) & ~BM_PCIE_EP_AER_Next_Capability_Offset) | BF_PCIE_EP_AER_Next_Capability_Offset(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_UESR - Uncorrectable Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_UESR - Uncorrectable Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x04
 */
typedef union _hw_pcie_ep_uesr
{
    uint32_t U;
    struct _hw_pcie_ep_uesr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Status : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Status_ : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Status : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Status : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Status : 1; /*!< [14]  */
        uint32_t Completer_Abort_Status : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Status : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Status : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Status : 1; /*!< [18]  */
        uint32_t ECRC_Error_Status : 1; /*!< [19]  */
        uint32_t Unsupported_Request_Error_Status : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_ep_uesr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_UESR register
 */
/*@{*/
#define HW_PCIE_EP_UESR_ADDR(x)  ((uintptr_t)(x) + 0x104U)

#define HW_PCIE_EP_UESR(x)       (*(__IO hw_pcie_ep_uesr_t *) HW_PCIE_EP_UESR_ADDR(x))
#define HW_PCIE_EP_UESR_RD(x)    (HW_PCIE_EP_UESR(x).U)
#define HW_PCIE_EP_UESR_WR(x, v) (HW_PCIE_EP_UESR(x).U = (v))
#define HW_PCIE_EP_UESR_SET(x, v) (HW_PCIE_EP_UESR_WR(x, HW_PCIE_EP_UESR_RD(x) |  (v)))
#define HW_PCIE_EP_UESR_CLR(x, v) (HW_PCIE_EP_UESR_WR(x, HW_PCIE_EP_UESR_RD(x) & ~(v)))
#define HW_PCIE_EP_UESR_TOG(x, v) (HW_PCIE_EP_UESR_WR(x, HW_PCIE_EP_UESR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_UESR bitfields
 */

/*!
 * @name Register PCIE_EP_UESR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Status for PCI Express 1.0a)
 */
/*@{*/
#define BP_PCIE_EP_UESR_Undefined (0U)     /*!< Bit position for PCIE_EP_UESR_Undefined. */
#define BM_PCIE_EP_UESR_Undefined (0x00000001U) /*!< Bit mask for PCIE_EP_UESR_Undefined. */
#define BS_PCIE_EP_UESR_Undefined (1U)     /*!< Bit field size in bits for PCIE_EP_UESR_Undefined. */

/*! @brief Read current value of the PCIE_EP_UESR_Undefined field. */
#define BR_PCIE_EP_UESR_Undefined(x) (HW_PCIE_EP_UESR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_EP_UESR_Undefined. */
#define BF_PCIE_EP_UESR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Undefined) & BM_PCIE_EP_UESR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_EP_UESR_Undefined(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Undefined) | BF_PCIE_EP_UESR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Data_Link_Protocol_Error_Status[4] (RW)
 *
 * Data Link Protocol Error Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Data_Link_Protocol_Error_Status (4U) /*!< Bit position for PCIE_EP_UESR_Data_Link_Protocol_Error_Status. */
#define BM_PCIE_EP_UESR_Data_Link_Protocol_Error_Status (0x00000010U) /*!< Bit mask for PCIE_EP_UESR_Data_Link_Protocol_Error_Status. */
#define BS_PCIE_EP_UESR_Data_Link_Protocol_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Data_Link_Protocol_Error_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Data_Link_Protocol_Error_Status field. */
#define BR_PCIE_EP_UESR_Data_Link_Protocol_Error_Status(x) (HW_PCIE_EP_UESR(x).B.Data_Link_Protocol_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Data_Link_Protocol_Error_Status. */
#define BF_PCIE_EP_UESR_Data_Link_Protocol_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Data_Link_Protocol_Error_Status) & BM_PCIE_EP_UESR_Data_Link_Protocol_Error_Status)

/*! @brief Set the Data_Link_Protocol_Error_Status field to a new value. */
#define BW_PCIE_EP_UESR_Data_Link_Protocol_Error_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Data_Link_Protocol_Error_Status) | BF_PCIE_EP_UESR_Data_Link_Protocol_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Surprise_Down_Error_Status_[5] (RW)
 *
 * Surprise Down Error Status (not supported)
 */
/*@{*/
#define BP_PCIE_EP_UESR_Surprise_Down_Error_Status_ (5U) /*!< Bit position for PCIE_EP_UESR_Surprise_Down_Error_Status_. */
#define BM_PCIE_EP_UESR_Surprise_Down_Error_Status_ (0x00000020U) /*!< Bit mask for PCIE_EP_UESR_Surprise_Down_Error_Status_. */
#define BS_PCIE_EP_UESR_Surprise_Down_Error_Status_ (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Surprise_Down_Error_Status_. */

/*! @brief Read current value of the PCIE_EP_UESR_Surprise_Down_Error_Status_ field. */
#define BR_PCIE_EP_UESR_Surprise_Down_Error_Status_(x) (HW_PCIE_EP_UESR(x).B.Surprise_Down_Error_Status_)

/*! @brief Format value for bitfield PCIE_EP_UESR_Surprise_Down_Error_Status_. */
#define BF_PCIE_EP_UESR_Surprise_Down_Error_Status_(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Surprise_Down_Error_Status_) & BM_PCIE_EP_UESR_Surprise_Down_Error_Status_)

/*! @brief Set the Surprise_Down_Error_Status_ field to a new value. */
#define BW_PCIE_EP_UESR_Surprise_Down_Error_Status_(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Surprise_Down_Error_Status_) | BF_PCIE_EP_UESR_Surprise_Down_Error_Status_(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Poisoned_TLP_Status[12] (RW)
 *
 * Poisoned TLP Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Poisoned_TLP_Status (12U) /*!< Bit position for PCIE_EP_UESR_Poisoned_TLP_Status. */
#define BM_PCIE_EP_UESR_Poisoned_TLP_Status (0x00001000U) /*!< Bit mask for PCIE_EP_UESR_Poisoned_TLP_Status. */
#define BS_PCIE_EP_UESR_Poisoned_TLP_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Poisoned_TLP_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Poisoned_TLP_Status field. */
#define BR_PCIE_EP_UESR_Poisoned_TLP_Status(x) (HW_PCIE_EP_UESR(x).B.Poisoned_TLP_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Poisoned_TLP_Status. */
#define BF_PCIE_EP_UESR_Poisoned_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Poisoned_TLP_Status) & BM_PCIE_EP_UESR_Poisoned_TLP_Status)

/*! @brief Set the Poisoned_TLP_Status field to a new value. */
#define BW_PCIE_EP_UESR_Poisoned_TLP_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Poisoned_TLP_Status) | BF_PCIE_EP_UESR_Poisoned_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Flow_Control_Protocol_Error_Status[13] (RW)
 *
 * Flow Control Protocol Error Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status (13U) /*!< Bit position for PCIE_EP_UESR_Flow_Control_Protocol_Error_Status. */
#define BM_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status (0x00002000U) /*!< Bit mask for PCIE_EP_UESR_Flow_Control_Protocol_Error_Status. */
#define BS_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Flow_Control_Protocol_Error_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Flow_Control_Protocol_Error_Status field. */
#define BR_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status(x) (HW_PCIE_EP_UESR(x).B.Flow_Control_Protocol_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Flow_Control_Protocol_Error_Status. */
#define BF_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status) & BM_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status)

/*! @brief Set the Flow_Control_Protocol_Error_Status field to a new value. */
#define BW_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status) | BF_PCIE_EP_UESR_Flow_Control_Protocol_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Completion_Timeout_Status[14] (RW)
 *
 * Completion Timeout Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Completion_Timeout_Status (14U) /*!< Bit position for PCIE_EP_UESR_Completion_Timeout_Status. */
#define BM_PCIE_EP_UESR_Completion_Timeout_Status (0x00004000U) /*!< Bit mask for PCIE_EP_UESR_Completion_Timeout_Status. */
#define BS_PCIE_EP_UESR_Completion_Timeout_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Completion_Timeout_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Completion_Timeout_Status field. */
#define BR_PCIE_EP_UESR_Completion_Timeout_Status(x) (HW_PCIE_EP_UESR(x).B.Completion_Timeout_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Completion_Timeout_Status. */
#define BF_PCIE_EP_UESR_Completion_Timeout_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Completion_Timeout_Status) & BM_PCIE_EP_UESR_Completion_Timeout_Status)

/*! @brief Set the Completion_Timeout_Status field to a new value. */
#define BW_PCIE_EP_UESR_Completion_Timeout_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Completion_Timeout_Status) | BF_PCIE_EP_UESR_Completion_Timeout_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Completer_Abort_Status[15] (RW)
 *
 * Completer Abort Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Completer_Abort_Status (15U) /*!< Bit position for PCIE_EP_UESR_Completer_Abort_Status. */
#define BM_PCIE_EP_UESR_Completer_Abort_Status (0x00008000U) /*!< Bit mask for PCIE_EP_UESR_Completer_Abort_Status. */
#define BS_PCIE_EP_UESR_Completer_Abort_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Completer_Abort_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Completer_Abort_Status field. */
#define BR_PCIE_EP_UESR_Completer_Abort_Status(x) (HW_PCIE_EP_UESR(x).B.Completer_Abort_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Completer_Abort_Status. */
#define BF_PCIE_EP_UESR_Completer_Abort_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Completer_Abort_Status) & BM_PCIE_EP_UESR_Completer_Abort_Status)

/*! @brief Set the Completer_Abort_Status field to a new value. */
#define BW_PCIE_EP_UESR_Completer_Abort_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Completer_Abort_Status) | BF_PCIE_EP_UESR_Completer_Abort_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Unexpected_Completion_Status[16] (RW)
 *
 * Unexpected Completion Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Unexpected_Completion_Status (16U) /*!< Bit position for PCIE_EP_UESR_Unexpected_Completion_Status. */
#define BM_PCIE_EP_UESR_Unexpected_Completion_Status (0x00010000U) /*!< Bit mask for PCIE_EP_UESR_Unexpected_Completion_Status. */
#define BS_PCIE_EP_UESR_Unexpected_Completion_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Unexpected_Completion_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Unexpected_Completion_Status field. */
#define BR_PCIE_EP_UESR_Unexpected_Completion_Status(x) (HW_PCIE_EP_UESR(x).B.Unexpected_Completion_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Unexpected_Completion_Status. */
#define BF_PCIE_EP_UESR_Unexpected_Completion_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Unexpected_Completion_Status) & BM_PCIE_EP_UESR_Unexpected_Completion_Status)

/*! @brief Set the Unexpected_Completion_Status field to a new value. */
#define BW_PCIE_EP_UESR_Unexpected_Completion_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Unexpected_Completion_Status) | BF_PCIE_EP_UESR_Unexpected_Completion_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Receiver_Overflow_Status[17] (RW)
 *
 * Receiver Overflow Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Receiver_Overflow_Status (17U) /*!< Bit position for PCIE_EP_UESR_Receiver_Overflow_Status. */
#define BM_PCIE_EP_UESR_Receiver_Overflow_Status (0x00020000U) /*!< Bit mask for PCIE_EP_UESR_Receiver_Overflow_Status. */
#define BS_PCIE_EP_UESR_Receiver_Overflow_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Receiver_Overflow_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Receiver_Overflow_Status field. */
#define BR_PCIE_EP_UESR_Receiver_Overflow_Status(x) (HW_PCIE_EP_UESR(x).B.Receiver_Overflow_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Receiver_Overflow_Status. */
#define BF_PCIE_EP_UESR_Receiver_Overflow_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Receiver_Overflow_Status) & BM_PCIE_EP_UESR_Receiver_Overflow_Status)

/*! @brief Set the Receiver_Overflow_Status field to a new value. */
#define BW_PCIE_EP_UESR_Receiver_Overflow_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Receiver_Overflow_Status) | BF_PCIE_EP_UESR_Receiver_Overflow_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Malformed_TLP_Status[18] (RW)
 *
 * Malformed TLP Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Malformed_TLP_Status (18U) /*!< Bit position for PCIE_EP_UESR_Malformed_TLP_Status. */
#define BM_PCIE_EP_UESR_Malformed_TLP_Status (0x00040000U) /*!< Bit mask for PCIE_EP_UESR_Malformed_TLP_Status. */
#define BS_PCIE_EP_UESR_Malformed_TLP_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Malformed_TLP_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Malformed_TLP_Status field. */
#define BR_PCIE_EP_UESR_Malformed_TLP_Status(x) (HW_PCIE_EP_UESR(x).B.Malformed_TLP_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Malformed_TLP_Status. */
#define BF_PCIE_EP_UESR_Malformed_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Malformed_TLP_Status) & BM_PCIE_EP_UESR_Malformed_TLP_Status)

/*! @brief Set the Malformed_TLP_Status field to a new value. */
#define BW_PCIE_EP_UESR_Malformed_TLP_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Malformed_TLP_Status) | BF_PCIE_EP_UESR_Malformed_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field ECRC_Error_Status[19] (RW)
 *
 * ECRC Error Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_ECRC_Error_Status (19U) /*!< Bit position for PCIE_EP_UESR_ECRC_Error_Status. */
#define BM_PCIE_EP_UESR_ECRC_Error_Status (0x00080000U) /*!< Bit mask for PCIE_EP_UESR_ECRC_Error_Status. */
#define BS_PCIE_EP_UESR_ECRC_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_ECRC_Error_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_ECRC_Error_Status field. */
#define BR_PCIE_EP_UESR_ECRC_Error_Status(x) (HW_PCIE_EP_UESR(x).B.ECRC_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_ECRC_Error_Status. */
#define BF_PCIE_EP_UESR_ECRC_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_ECRC_Error_Status) & BM_PCIE_EP_UESR_ECRC_Error_Status)

/*! @brief Set the ECRC_Error_Status field to a new value. */
#define BW_PCIE_EP_UESR_ECRC_Error_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_ECRC_Error_Status) | BF_PCIE_EP_UESR_ECRC_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESR, field Unsupported_Request_Error_Status[20] (RW)
 *
 * Unsupported Request Error Status
 */
/*@{*/
#define BP_PCIE_EP_UESR_Unsupported_Request_Error_Status (20U) /*!< Bit position for PCIE_EP_UESR_Unsupported_Request_Error_Status. */
#define BM_PCIE_EP_UESR_Unsupported_Request_Error_Status (0x00100000U) /*!< Bit mask for PCIE_EP_UESR_Unsupported_Request_Error_Status. */
#define BS_PCIE_EP_UESR_Unsupported_Request_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_UESR_Unsupported_Request_Error_Status. */

/*! @brief Read current value of the PCIE_EP_UESR_Unsupported_Request_Error_Status field. */
#define BR_PCIE_EP_UESR_Unsupported_Request_Error_Status(x) (HW_PCIE_EP_UESR(x).B.Unsupported_Request_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_UESR_Unsupported_Request_Error_Status. */
#define BF_PCIE_EP_UESR_Unsupported_Request_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESR_Unsupported_Request_Error_Status) & BM_PCIE_EP_UESR_Unsupported_Request_Error_Status)

/*! @brief Set the Unsupported_Request_Error_Status field to a new value. */
#define BW_PCIE_EP_UESR_Unsupported_Request_Error_Status(x, v) (HW_PCIE_EP_UESR_WR(x, (HW_PCIE_EP_UESR_RD(x) & ~BM_PCIE_EP_UESR_Unsupported_Request_Error_Status) | BF_PCIE_EP_UESR_Unsupported_Request_Error_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_UEMR - Uncorrectable Error Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_UEMR - Uncorrectable Error Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x08
 */
typedef union _hw_pcie_ep_uemr
{
    uint32_t U;
    struct _hw_pcie_ep_uemr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Mask : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Mask : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Mask : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Mask : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Mask : 1; /*!< [14]  */
        uint32_t Completer_Abort_Mask : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Mask : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Mask : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Mask : 1; /*!< [18]  */
        uint32_t ECRC_Error_Mask : 1;  /*!< [19]  */
        uint32_t Unsupported_Request_Error_Mask : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_ep_uemr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_UEMR register
 */
/*@{*/
#define HW_PCIE_EP_UEMR_ADDR(x)  ((uintptr_t)(x) + 0x108U)

#define HW_PCIE_EP_UEMR(x)       (*(__IO hw_pcie_ep_uemr_t *) HW_PCIE_EP_UEMR_ADDR(x))
#define HW_PCIE_EP_UEMR_RD(x)    (HW_PCIE_EP_UEMR(x).U)
#define HW_PCIE_EP_UEMR_WR(x, v) (HW_PCIE_EP_UEMR(x).U = (v))
#define HW_PCIE_EP_UEMR_SET(x, v) (HW_PCIE_EP_UEMR_WR(x, HW_PCIE_EP_UEMR_RD(x) |  (v)))
#define HW_PCIE_EP_UEMR_CLR(x, v) (HW_PCIE_EP_UEMR_WR(x, HW_PCIE_EP_UEMR_RD(x) & ~(v)))
#define HW_PCIE_EP_UEMR_TOG(x, v) (HW_PCIE_EP_UEMR_WR(x, HW_PCIE_EP_UEMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_UEMR bitfields
 */

/*!
 * @name Register PCIE_EP_UEMR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Mask for PCI Express 1.0a)
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Undefined (0U)     /*!< Bit position for PCIE_EP_UEMR_Undefined. */
#define BM_PCIE_EP_UEMR_Undefined (0x00000001U) /*!< Bit mask for PCIE_EP_UEMR_Undefined. */
#define BS_PCIE_EP_UEMR_Undefined (1U)     /*!< Bit field size in bits for PCIE_EP_UEMR_Undefined. */

/*! @brief Read current value of the PCIE_EP_UEMR_Undefined field. */
#define BR_PCIE_EP_UEMR_Undefined(x) (HW_PCIE_EP_UEMR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Undefined. */
#define BF_PCIE_EP_UEMR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Undefined) & BM_PCIE_EP_UEMR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_EP_UEMR_Undefined(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Undefined) | BF_PCIE_EP_UEMR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Data_Link_Protocol_Error_Mask[4] (RW)
 *
 * Data Link Protocol Error Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask (4U) /*!< Bit position for PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask. */
#define BM_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask (0x00000010U) /*!< Bit mask for PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask. */
#define BS_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask field. */
#define BR_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask(x) (HW_PCIE_EP_UEMR(x).B.Data_Link_Protocol_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask. */
#define BF_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask) & BM_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask)

/*! @brief Set the Data_Link_Protocol_Error_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask) | BF_PCIE_EP_UEMR_Data_Link_Protocol_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Surprise_Down_Error_Mask[5] (RW)
 *
 * Surprise Down Error Mask (not supported)
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Surprise_Down_Error_Mask (5U) /*!< Bit position for PCIE_EP_UEMR_Surprise_Down_Error_Mask. */
#define BM_PCIE_EP_UEMR_Surprise_Down_Error_Mask (0x00000020U) /*!< Bit mask for PCIE_EP_UEMR_Surprise_Down_Error_Mask. */
#define BS_PCIE_EP_UEMR_Surprise_Down_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Surprise_Down_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Surprise_Down_Error_Mask field. */
#define BR_PCIE_EP_UEMR_Surprise_Down_Error_Mask(x) (HW_PCIE_EP_UEMR(x).B.Surprise_Down_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Surprise_Down_Error_Mask. */
#define BF_PCIE_EP_UEMR_Surprise_Down_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Surprise_Down_Error_Mask) & BM_PCIE_EP_UEMR_Surprise_Down_Error_Mask)

/*! @brief Set the Surprise_Down_Error_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Surprise_Down_Error_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Surprise_Down_Error_Mask) | BF_PCIE_EP_UEMR_Surprise_Down_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Poisoned_TLP_Mask[12] (RW)
 *
 * Poisoned TLP Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Poisoned_TLP_Mask (12U) /*!< Bit position for PCIE_EP_UEMR_Poisoned_TLP_Mask. */
#define BM_PCIE_EP_UEMR_Poisoned_TLP_Mask (0x00001000U) /*!< Bit mask for PCIE_EP_UEMR_Poisoned_TLP_Mask. */
#define BS_PCIE_EP_UEMR_Poisoned_TLP_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Poisoned_TLP_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Poisoned_TLP_Mask field. */
#define BR_PCIE_EP_UEMR_Poisoned_TLP_Mask(x) (HW_PCIE_EP_UEMR(x).B.Poisoned_TLP_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Poisoned_TLP_Mask. */
#define BF_PCIE_EP_UEMR_Poisoned_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Poisoned_TLP_Mask) & BM_PCIE_EP_UEMR_Poisoned_TLP_Mask)

/*! @brief Set the Poisoned_TLP_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Poisoned_TLP_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Poisoned_TLP_Mask) | BF_PCIE_EP_UEMR_Poisoned_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Flow_Control_Protocol_Error_Mask[13] (RW)
 *
 * Flow Control Protocol Error Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask (13U) /*!< Bit position for PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BM_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask (0x00002000U) /*!< Bit mask for PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BS_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask field. */
#define BR_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask(x) (HW_PCIE_EP_UEMR(x).B.Flow_Control_Protocol_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BF_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask) & BM_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask)

/*! @brief Set the Flow_Control_Protocol_Error_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask) | BF_PCIE_EP_UEMR_Flow_Control_Protocol_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Completion_Timeout_Mask[14] (RW)
 *
 * Completion Timeout Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Completion_Timeout_Mask (14U) /*!< Bit position for PCIE_EP_UEMR_Completion_Timeout_Mask. */
#define BM_PCIE_EP_UEMR_Completion_Timeout_Mask (0x00004000U) /*!< Bit mask for PCIE_EP_UEMR_Completion_Timeout_Mask. */
#define BS_PCIE_EP_UEMR_Completion_Timeout_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Completion_Timeout_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Completion_Timeout_Mask field. */
#define BR_PCIE_EP_UEMR_Completion_Timeout_Mask(x) (HW_PCIE_EP_UEMR(x).B.Completion_Timeout_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Completion_Timeout_Mask. */
#define BF_PCIE_EP_UEMR_Completion_Timeout_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Completion_Timeout_Mask) & BM_PCIE_EP_UEMR_Completion_Timeout_Mask)

/*! @brief Set the Completion_Timeout_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Completion_Timeout_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Completion_Timeout_Mask) | BF_PCIE_EP_UEMR_Completion_Timeout_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Completer_Abort_Mask[15] (RW)
 *
 * Completer Abort Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Completer_Abort_Mask (15U) /*!< Bit position for PCIE_EP_UEMR_Completer_Abort_Mask. */
#define BM_PCIE_EP_UEMR_Completer_Abort_Mask (0x00008000U) /*!< Bit mask for PCIE_EP_UEMR_Completer_Abort_Mask. */
#define BS_PCIE_EP_UEMR_Completer_Abort_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Completer_Abort_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Completer_Abort_Mask field. */
#define BR_PCIE_EP_UEMR_Completer_Abort_Mask(x) (HW_PCIE_EP_UEMR(x).B.Completer_Abort_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Completer_Abort_Mask. */
#define BF_PCIE_EP_UEMR_Completer_Abort_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Completer_Abort_Mask) & BM_PCIE_EP_UEMR_Completer_Abort_Mask)

/*! @brief Set the Completer_Abort_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Completer_Abort_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Completer_Abort_Mask) | BF_PCIE_EP_UEMR_Completer_Abort_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Unexpected_Completion_Mask[16] (RW)
 *
 * Unexpected Completion Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Unexpected_Completion_Mask (16U) /*!< Bit position for PCIE_EP_UEMR_Unexpected_Completion_Mask. */
#define BM_PCIE_EP_UEMR_Unexpected_Completion_Mask (0x00010000U) /*!< Bit mask for PCIE_EP_UEMR_Unexpected_Completion_Mask. */
#define BS_PCIE_EP_UEMR_Unexpected_Completion_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Unexpected_Completion_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Unexpected_Completion_Mask field. */
#define BR_PCIE_EP_UEMR_Unexpected_Completion_Mask(x) (HW_PCIE_EP_UEMR(x).B.Unexpected_Completion_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Unexpected_Completion_Mask. */
#define BF_PCIE_EP_UEMR_Unexpected_Completion_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Unexpected_Completion_Mask) & BM_PCIE_EP_UEMR_Unexpected_Completion_Mask)

/*! @brief Set the Unexpected_Completion_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Unexpected_Completion_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Unexpected_Completion_Mask) | BF_PCIE_EP_UEMR_Unexpected_Completion_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Receiver_Overflow_Mask[17] (RW)
 *
 * Receiver Overflow Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Receiver_Overflow_Mask (17U) /*!< Bit position for PCIE_EP_UEMR_Receiver_Overflow_Mask. */
#define BM_PCIE_EP_UEMR_Receiver_Overflow_Mask (0x00020000U) /*!< Bit mask for PCIE_EP_UEMR_Receiver_Overflow_Mask. */
#define BS_PCIE_EP_UEMR_Receiver_Overflow_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Receiver_Overflow_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Receiver_Overflow_Mask field. */
#define BR_PCIE_EP_UEMR_Receiver_Overflow_Mask(x) (HW_PCIE_EP_UEMR(x).B.Receiver_Overflow_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Receiver_Overflow_Mask. */
#define BF_PCIE_EP_UEMR_Receiver_Overflow_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Receiver_Overflow_Mask) & BM_PCIE_EP_UEMR_Receiver_Overflow_Mask)

/*! @brief Set the Receiver_Overflow_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Receiver_Overflow_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Receiver_Overflow_Mask) | BF_PCIE_EP_UEMR_Receiver_Overflow_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Malformed_TLP_Mask[18] (RW)
 *
 * Malformed TLP Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Malformed_TLP_Mask (18U) /*!< Bit position for PCIE_EP_UEMR_Malformed_TLP_Mask. */
#define BM_PCIE_EP_UEMR_Malformed_TLP_Mask (0x00040000U) /*!< Bit mask for PCIE_EP_UEMR_Malformed_TLP_Mask. */
#define BS_PCIE_EP_UEMR_Malformed_TLP_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Malformed_TLP_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Malformed_TLP_Mask field. */
#define BR_PCIE_EP_UEMR_Malformed_TLP_Mask(x) (HW_PCIE_EP_UEMR(x).B.Malformed_TLP_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Malformed_TLP_Mask. */
#define BF_PCIE_EP_UEMR_Malformed_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Malformed_TLP_Mask) & BM_PCIE_EP_UEMR_Malformed_TLP_Mask)

/*! @brief Set the Malformed_TLP_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Malformed_TLP_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Malformed_TLP_Mask) | BF_PCIE_EP_UEMR_Malformed_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field ECRC_Error_Mask[19] (RW)
 *
 * ECRC Error Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_ECRC_Error_Mask (19U) /*!< Bit position for PCIE_EP_UEMR_ECRC_Error_Mask. */
#define BM_PCIE_EP_UEMR_ECRC_Error_Mask (0x00080000U) /*!< Bit mask for PCIE_EP_UEMR_ECRC_Error_Mask. */
#define BS_PCIE_EP_UEMR_ECRC_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_ECRC_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_ECRC_Error_Mask field. */
#define BR_PCIE_EP_UEMR_ECRC_Error_Mask(x) (HW_PCIE_EP_UEMR(x).B.ECRC_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_ECRC_Error_Mask. */
#define BF_PCIE_EP_UEMR_ECRC_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_ECRC_Error_Mask) & BM_PCIE_EP_UEMR_ECRC_Error_Mask)

/*! @brief Set the ECRC_Error_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_ECRC_Error_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_ECRC_Error_Mask) | BF_PCIE_EP_UEMR_ECRC_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UEMR, field Unsupported_Request_Error_Mask[20] (RW)
 *
 * Unsupported Request Error Mask
 */
/*@{*/
#define BP_PCIE_EP_UEMR_Unsupported_Request_Error_Mask (20U) /*!< Bit position for PCIE_EP_UEMR_Unsupported_Request_Error_Mask. */
#define BM_PCIE_EP_UEMR_Unsupported_Request_Error_Mask (0x00100000U) /*!< Bit mask for PCIE_EP_UEMR_Unsupported_Request_Error_Mask. */
#define BS_PCIE_EP_UEMR_Unsupported_Request_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_UEMR_Unsupported_Request_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_UEMR_Unsupported_Request_Error_Mask field. */
#define BR_PCIE_EP_UEMR_Unsupported_Request_Error_Mask(x) (HW_PCIE_EP_UEMR(x).B.Unsupported_Request_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_UEMR_Unsupported_Request_Error_Mask. */
#define BF_PCIE_EP_UEMR_Unsupported_Request_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UEMR_Unsupported_Request_Error_Mask) & BM_PCIE_EP_UEMR_Unsupported_Request_Error_Mask)

/*! @brief Set the Unsupported_Request_Error_Mask field to a new value. */
#define BW_PCIE_EP_UEMR_Unsupported_Request_Error_Mask(x, v) (HW_PCIE_EP_UEMR_WR(x, (HW_PCIE_EP_UEMR_RD(x) & ~BM_PCIE_EP_UEMR_Unsupported_Request_Error_Mask) | BF_PCIE_EP_UEMR_Unsupported_Request_Error_Mask(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_UESevR - Uncorrectable Error Severity Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_UESevR - Uncorrectable Error Severity Register (RW)
 *
 * Reset value: 0x000C2031U
 *
 * Offset: 0x0C
 */
typedef union _hw_pcie_ep_uesevr
{
    uint32_t U;
    struct _hw_pcie_ep_uesevr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Severity : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Severity : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Severity : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Severity : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Severity : 1; /*!< [14]  */
        uint32_t Completer_Abort_Severity : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Severity : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Severity : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Severity : 1; /*!< [18]  */
        uint32_t ECRC_Error_Severity : 1; /*!< [19]  */
        uint32_t Unsupported_Request_Error_Severity : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_ep_uesevr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_UESevR register
 */
/*@{*/
#define HW_PCIE_EP_UESevR_ADDR(x) ((uintptr_t)(x) + 0x10CU)

#define HW_PCIE_EP_UESevR(x)     (*(__IO hw_pcie_ep_uesevr_t *) HW_PCIE_EP_UESevR_ADDR(x))
#define HW_PCIE_EP_UESevR_RD(x)  (HW_PCIE_EP_UESevR(x).U)
#define HW_PCIE_EP_UESevR_WR(x, v) (HW_PCIE_EP_UESevR(x).U = (v))
#define HW_PCIE_EP_UESevR_SET(x, v) (HW_PCIE_EP_UESevR_WR(x, HW_PCIE_EP_UESevR_RD(x) |  (v)))
#define HW_PCIE_EP_UESevR_CLR(x, v) (HW_PCIE_EP_UESevR_WR(x, HW_PCIE_EP_UESevR_RD(x) & ~(v)))
#define HW_PCIE_EP_UESevR_TOG(x, v) (HW_PCIE_EP_UESevR_WR(x, HW_PCIE_EP_UESevR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_UESevR bitfields
 */

/*!
 * @name Register PCIE_EP_UESevR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Severity for PCI Express
 * 1.0a)
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Undefined (0U)   /*!< Bit position for PCIE_EP_UESevR_Undefined. */
#define BM_PCIE_EP_UESevR_Undefined (0x00000001U) /*!< Bit mask for PCIE_EP_UESevR_Undefined. */
#define BS_PCIE_EP_UESevR_Undefined (1U)   /*!< Bit field size in bits for PCIE_EP_UESevR_Undefined. */

/*! @brief Read current value of the PCIE_EP_UESevR_Undefined field. */
#define BR_PCIE_EP_UESevR_Undefined(x) (HW_PCIE_EP_UESevR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Undefined. */
#define BF_PCIE_EP_UESevR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Undefined) & BM_PCIE_EP_UESevR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_EP_UESevR_Undefined(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Undefined) | BF_PCIE_EP_UESevR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Data_Link_Protocol_Error_Severity[4] (RW)
 *
 * Data Link Protocol Error Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity (4U) /*!< Bit position for PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity. */
#define BM_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity (0x00000010U) /*!< Bit mask for PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity. */
#define BS_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity field. */
#define BR_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity(x) (HW_PCIE_EP_UESevR(x).B.Data_Link_Protocol_Error_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity. */
#define BF_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity) & BM_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity)

/*! @brief Set the Data_Link_Protocol_Error_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity) | BF_PCIE_EP_UESevR_Data_Link_Protocol_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Surprise_Down_Error_Severity[5] (RW)
 *
 * Surprise Down Error Severity (not supported)
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Surprise_Down_Error_Severity (5U) /*!< Bit position for PCIE_EP_UESevR_Surprise_Down_Error_Severity. */
#define BM_PCIE_EP_UESevR_Surprise_Down_Error_Severity (0x00000020U) /*!< Bit mask for PCIE_EP_UESevR_Surprise_Down_Error_Severity. */
#define BS_PCIE_EP_UESevR_Surprise_Down_Error_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Surprise_Down_Error_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Surprise_Down_Error_Severity field. */
#define BR_PCIE_EP_UESevR_Surprise_Down_Error_Severity(x) (HW_PCIE_EP_UESevR(x).B.Surprise_Down_Error_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Surprise_Down_Error_Severity. */
#define BF_PCIE_EP_UESevR_Surprise_Down_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Surprise_Down_Error_Severity) & BM_PCIE_EP_UESevR_Surprise_Down_Error_Severity)

/*! @brief Set the Surprise_Down_Error_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Surprise_Down_Error_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Surprise_Down_Error_Severity) | BF_PCIE_EP_UESevR_Surprise_Down_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Poisoned_TLP_Severity[12] (RW)
 *
 * Poisoned TLP Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Poisoned_TLP_Severity (12U) /*!< Bit position for PCIE_EP_UESevR_Poisoned_TLP_Severity. */
#define BM_PCIE_EP_UESevR_Poisoned_TLP_Severity (0x00001000U) /*!< Bit mask for PCIE_EP_UESevR_Poisoned_TLP_Severity. */
#define BS_PCIE_EP_UESevR_Poisoned_TLP_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Poisoned_TLP_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Poisoned_TLP_Severity field. */
#define BR_PCIE_EP_UESevR_Poisoned_TLP_Severity(x) (HW_PCIE_EP_UESevR(x).B.Poisoned_TLP_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Poisoned_TLP_Severity. */
#define BF_PCIE_EP_UESevR_Poisoned_TLP_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Poisoned_TLP_Severity) & BM_PCIE_EP_UESevR_Poisoned_TLP_Severity)

/*! @brief Set the Poisoned_TLP_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Poisoned_TLP_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Poisoned_TLP_Severity) | BF_PCIE_EP_UESevR_Poisoned_TLP_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Flow_Control_Protocol_Error_Severity[13] (RW)
 *
 * Flow Control Protocol Error Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity (13U) /*!< Bit position for PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BM_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity (0x00002000U) /*!< Bit mask for PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BS_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity field. */
#define BR_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity(x) (HW_PCIE_EP_UESevR(x).B.Flow_Control_Protocol_Error_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BF_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity) & BM_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity)

/*! @brief Set the Flow_Control_Protocol_Error_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity) | BF_PCIE_EP_UESevR_Flow_Control_Protocol_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Completion_Timeout_Severity[14] (RW)
 *
 * Completion Timeout Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Completion_Timeout_Severity (14U) /*!< Bit position for PCIE_EP_UESevR_Completion_Timeout_Severity. */
#define BM_PCIE_EP_UESevR_Completion_Timeout_Severity (0x00004000U) /*!< Bit mask for PCIE_EP_UESevR_Completion_Timeout_Severity. */
#define BS_PCIE_EP_UESevR_Completion_Timeout_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Completion_Timeout_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Completion_Timeout_Severity field. */
#define BR_PCIE_EP_UESevR_Completion_Timeout_Severity(x) (HW_PCIE_EP_UESevR(x).B.Completion_Timeout_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Completion_Timeout_Severity. */
#define BF_PCIE_EP_UESevR_Completion_Timeout_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Completion_Timeout_Severity) & BM_PCIE_EP_UESevR_Completion_Timeout_Severity)

/*! @brief Set the Completion_Timeout_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Completion_Timeout_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Completion_Timeout_Severity) | BF_PCIE_EP_UESevR_Completion_Timeout_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Completer_Abort_Severity[15] (RW)
 *
 * Completer Abort Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Completer_Abort_Severity (15U) /*!< Bit position for PCIE_EP_UESevR_Completer_Abort_Severity. */
#define BM_PCIE_EP_UESevR_Completer_Abort_Severity (0x00008000U) /*!< Bit mask for PCIE_EP_UESevR_Completer_Abort_Severity. */
#define BS_PCIE_EP_UESevR_Completer_Abort_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Completer_Abort_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Completer_Abort_Severity field. */
#define BR_PCIE_EP_UESevR_Completer_Abort_Severity(x) (HW_PCIE_EP_UESevR(x).B.Completer_Abort_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Completer_Abort_Severity. */
#define BF_PCIE_EP_UESevR_Completer_Abort_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Completer_Abort_Severity) & BM_PCIE_EP_UESevR_Completer_Abort_Severity)

/*! @brief Set the Completer_Abort_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Completer_Abort_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Completer_Abort_Severity) | BF_PCIE_EP_UESevR_Completer_Abort_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Unexpected_Completion_Severity[16] (RW)
 *
 * Unexpected Completion Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Unexpected_Completion_Severity (16U) /*!< Bit position for PCIE_EP_UESevR_Unexpected_Completion_Severity. */
#define BM_PCIE_EP_UESevR_Unexpected_Completion_Severity (0x00010000U) /*!< Bit mask for PCIE_EP_UESevR_Unexpected_Completion_Severity. */
#define BS_PCIE_EP_UESevR_Unexpected_Completion_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Unexpected_Completion_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Unexpected_Completion_Severity field. */
#define BR_PCIE_EP_UESevR_Unexpected_Completion_Severity(x) (HW_PCIE_EP_UESevR(x).B.Unexpected_Completion_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Unexpected_Completion_Severity. */
#define BF_PCIE_EP_UESevR_Unexpected_Completion_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Unexpected_Completion_Severity) & BM_PCIE_EP_UESevR_Unexpected_Completion_Severity)

/*! @brief Set the Unexpected_Completion_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Unexpected_Completion_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Unexpected_Completion_Severity) | BF_PCIE_EP_UESevR_Unexpected_Completion_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Receiver_Overflow_Severity[17] (RW)
 *
 * Receiver Overflow Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Receiver_Overflow_Severity (17U) /*!< Bit position for PCIE_EP_UESevR_Receiver_Overflow_Severity. */
#define BM_PCIE_EP_UESevR_Receiver_Overflow_Severity (0x00020000U) /*!< Bit mask for PCIE_EP_UESevR_Receiver_Overflow_Severity. */
#define BS_PCIE_EP_UESevR_Receiver_Overflow_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Receiver_Overflow_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Receiver_Overflow_Severity field. */
#define BR_PCIE_EP_UESevR_Receiver_Overflow_Severity(x) (HW_PCIE_EP_UESevR(x).B.Receiver_Overflow_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Receiver_Overflow_Severity. */
#define BF_PCIE_EP_UESevR_Receiver_Overflow_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Receiver_Overflow_Severity) & BM_PCIE_EP_UESevR_Receiver_Overflow_Severity)

/*! @brief Set the Receiver_Overflow_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Receiver_Overflow_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Receiver_Overflow_Severity) | BF_PCIE_EP_UESevR_Receiver_Overflow_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Malformed_TLP_Severity[18] (RW)
 *
 * Malformed TLP Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Malformed_TLP_Severity (18U) /*!< Bit position for PCIE_EP_UESevR_Malformed_TLP_Severity. */
#define BM_PCIE_EP_UESevR_Malformed_TLP_Severity (0x00040000U) /*!< Bit mask for PCIE_EP_UESevR_Malformed_TLP_Severity. */
#define BS_PCIE_EP_UESevR_Malformed_TLP_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Malformed_TLP_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Malformed_TLP_Severity field. */
#define BR_PCIE_EP_UESevR_Malformed_TLP_Severity(x) (HW_PCIE_EP_UESevR(x).B.Malformed_TLP_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Malformed_TLP_Severity. */
#define BF_PCIE_EP_UESevR_Malformed_TLP_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Malformed_TLP_Severity) & BM_PCIE_EP_UESevR_Malformed_TLP_Severity)

/*! @brief Set the Malformed_TLP_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Malformed_TLP_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Malformed_TLP_Severity) | BF_PCIE_EP_UESevR_Malformed_TLP_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field ECRC_Error_Severity[19] (RW)
 *
 * ECRC Error Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_ECRC_Error_Severity (19U) /*!< Bit position for PCIE_EP_UESevR_ECRC_Error_Severity. */
#define BM_PCIE_EP_UESevR_ECRC_Error_Severity (0x00080000U) /*!< Bit mask for PCIE_EP_UESevR_ECRC_Error_Severity. */
#define BS_PCIE_EP_UESevR_ECRC_Error_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_ECRC_Error_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_ECRC_Error_Severity field. */
#define BR_PCIE_EP_UESevR_ECRC_Error_Severity(x) (HW_PCIE_EP_UESevR(x).B.ECRC_Error_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_ECRC_Error_Severity. */
#define BF_PCIE_EP_UESevR_ECRC_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_ECRC_Error_Severity) & BM_PCIE_EP_UESevR_ECRC_Error_Severity)

/*! @brief Set the ECRC_Error_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_ECRC_Error_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_ECRC_Error_Severity) | BF_PCIE_EP_UESevR_ECRC_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_UESevR, field Unsupported_Request_Error_Severity[20] (RW)
 *
 * Unsupported Request Error Severity
 */
/*@{*/
#define BP_PCIE_EP_UESevR_Unsupported_Request_Error_Severity (20U) /*!< Bit position for PCIE_EP_UESevR_Unsupported_Request_Error_Severity. */
#define BM_PCIE_EP_UESevR_Unsupported_Request_Error_Severity (0x00100000U) /*!< Bit mask for PCIE_EP_UESevR_Unsupported_Request_Error_Severity. */
#define BS_PCIE_EP_UESevR_Unsupported_Request_Error_Severity (1U) /*!< Bit field size in bits for PCIE_EP_UESevR_Unsupported_Request_Error_Severity. */

/*! @brief Read current value of the PCIE_EP_UESevR_Unsupported_Request_Error_Severity field. */
#define BR_PCIE_EP_UESevR_Unsupported_Request_Error_Severity(x) (HW_PCIE_EP_UESevR(x).B.Unsupported_Request_Error_Severity)

/*! @brief Format value for bitfield PCIE_EP_UESevR_Unsupported_Request_Error_Severity. */
#define BF_PCIE_EP_UESevR_Unsupported_Request_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_UESevR_Unsupported_Request_Error_Severity) & BM_PCIE_EP_UESevR_Unsupported_Request_Error_Severity)

/*! @brief Set the Unsupported_Request_Error_Severity field to a new value. */
#define BW_PCIE_EP_UESevR_Unsupported_Request_Error_Severity(x, v) (HW_PCIE_EP_UESevR_WR(x, (HW_PCIE_EP_UESevR_RD(x) & ~BM_PCIE_EP_UESevR_Unsupported_Request_Error_Severity) | BF_PCIE_EP_UESevR_Unsupported_Request_Error_Severity(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_CESR - Correctable Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_CESR - Correctable Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x10
 */
typedef union _hw_pcie_ep_cesr
{
    uint32_t U;
    struct _hw_pcie_ep_cesr_bitfields
    {
        uint32_t Receiver_Error_Status : 1; /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t Bad_TLP_Status : 1;   /*!< [6]  */
        uint32_t Bad_DLLP_Status : 1;  /*!< [7]  */
        uint32_t REPLAY_NUM_Rollover_Status : 1; /*!< [8]  */
        uint32_t RESERVED1 : 3;        /*!< [11:9]  */
        uint32_t Reply_Timer_Timeout_Status : 1; /*!< [12]  */
        uint32_t Advisory_Non_Fatal_Error_Status : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_pcie_ep_cesr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_CESR register
 */
/*@{*/
#define HW_PCIE_EP_CESR_ADDR(x)  ((uintptr_t)(x) + 0x110U)

#define HW_PCIE_EP_CESR(x)       (*(__IO hw_pcie_ep_cesr_t *) HW_PCIE_EP_CESR_ADDR(x))
#define HW_PCIE_EP_CESR_RD(x)    (HW_PCIE_EP_CESR(x).U)
#define HW_PCIE_EP_CESR_WR(x, v) (HW_PCIE_EP_CESR(x).U = (v))
#define HW_PCIE_EP_CESR_SET(x, v) (HW_PCIE_EP_CESR_WR(x, HW_PCIE_EP_CESR_RD(x) |  (v)))
#define HW_PCIE_EP_CESR_CLR(x, v) (HW_PCIE_EP_CESR_WR(x, HW_PCIE_EP_CESR_RD(x) & ~(v)))
#define HW_PCIE_EP_CESR_TOG(x, v) (HW_PCIE_EP_CESR_WR(x, HW_PCIE_EP_CESR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_CESR bitfields
 */

/*!
 * @name Register PCIE_EP_CESR, field Receiver_Error_Status[0] (RW)
 *
 * Receiver Error Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_Receiver_Error_Status (0U) /*!< Bit position for PCIE_EP_CESR_Receiver_Error_Status. */
#define BM_PCIE_EP_CESR_Receiver_Error_Status (0x00000001U) /*!< Bit mask for PCIE_EP_CESR_Receiver_Error_Status. */
#define BS_PCIE_EP_CESR_Receiver_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_Receiver_Error_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_Receiver_Error_Status field. */
#define BR_PCIE_EP_CESR_Receiver_Error_Status(x) (HW_PCIE_EP_CESR(x).B.Receiver_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_Receiver_Error_Status. */
#define BF_PCIE_EP_CESR_Receiver_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_Receiver_Error_Status) & BM_PCIE_EP_CESR_Receiver_Error_Status)

/*! @brief Set the Receiver_Error_Status field to a new value. */
#define BW_PCIE_EP_CESR_Receiver_Error_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_Receiver_Error_Status) | BF_PCIE_EP_CESR_Receiver_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CESR, field Bad_TLP_Status[6] (RW)
 *
 * Bad TLP Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_Bad_TLP_Status (6U) /*!< Bit position for PCIE_EP_CESR_Bad_TLP_Status. */
#define BM_PCIE_EP_CESR_Bad_TLP_Status (0x00000040U) /*!< Bit mask for PCIE_EP_CESR_Bad_TLP_Status. */
#define BS_PCIE_EP_CESR_Bad_TLP_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_Bad_TLP_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_Bad_TLP_Status field. */
#define BR_PCIE_EP_CESR_Bad_TLP_Status(x) (HW_PCIE_EP_CESR(x).B.Bad_TLP_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_Bad_TLP_Status. */
#define BF_PCIE_EP_CESR_Bad_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_Bad_TLP_Status) & BM_PCIE_EP_CESR_Bad_TLP_Status)

/*! @brief Set the Bad_TLP_Status field to a new value. */
#define BW_PCIE_EP_CESR_Bad_TLP_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_Bad_TLP_Status) | BF_PCIE_EP_CESR_Bad_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CESR, field Bad_DLLP_Status[7] (RW)
 *
 * Bad DLLP Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_Bad_DLLP_Status (7U) /*!< Bit position for PCIE_EP_CESR_Bad_DLLP_Status. */
#define BM_PCIE_EP_CESR_Bad_DLLP_Status (0x00000080U) /*!< Bit mask for PCIE_EP_CESR_Bad_DLLP_Status. */
#define BS_PCIE_EP_CESR_Bad_DLLP_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_Bad_DLLP_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_Bad_DLLP_Status field. */
#define BR_PCIE_EP_CESR_Bad_DLLP_Status(x) (HW_PCIE_EP_CESR(x).B.Bad_DLLP_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_Bad_DLLP_Status. */
#define BF_PCIE_EP_CESR_Bad_DLLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_Bad_DLLP_Status) & BM_PCIE_EP_CESR_Bad_DLLP_Status)

/*! @brief Set the Bad_DLLP_Status field to a new value. */
#define BW_PCIE_EP_CESR_Bad_DLLP_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_Bad_DLLP_Status) | BF_PCIE_EP_CESR_Bad_DLLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CESR, field REPLAY_NUM_Rollover_Status[8] (RW)
 *
 * REPLAY_NUM Rollover Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status (8U) /*!< Bit position for PCIE_EP_CESR_REPLAY_NUM_Rollover_Status. */
#define BM_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status (0x00000100U) /*!< Bit mask for PCIE_EP_CESR_REPLAY_NUM_Rollover_Status. */
#define BS_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_REPLAY_NUM_Rollover_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_REPLAY_NUM_Rollover_Status field. */
#define BR_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status(x) (HW_PCIE_EP_CESR(x).B.REPLAY_NUM_Rollover_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_REPLAY_NUM_Rollover_Status. */
#define BF_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status) & BM_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status)

/*! @brief Set the REPLAY_NUM_Rollover_Status field to a new value. */
#define BW_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status) | BF_PCIE_EP_CESR_REPLAY_NUM_Rollover_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CESR, field Reply_Timer_Timeout_Status[12] (RW)
 *
 * Reply Timer Timeout Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_Reply_Timer_Timeout_Status (12U) /*!< Bit position for PCIE_EP_CESR_Reply_Timer_Timeout_Status. */
#define BM_PCIE_EP_CESR_Reply_Timer_Timeout_Status (0x00001000U) /*!< Bit mask for PCIE_EP_CESR_Reply_Timer_Timeout_Status. */
#define BS_PCIE_EP_CESR_Reply_Timer_Timeout_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_Reply_Timer_Timeout_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_Reply_Timer_Timeout_Status field. */
#define BR_PCIE_EP_CESR_Reply_Timer_Timeout_Status(x) (HW_PCIE_EP_CESR(x).B.Reply_Timer_Timeout_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_Reply_Timer_Timeout_Status. */
#define BF_PCIE_EP_CESR_Reply_Timer_Timeout_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_Reply_Timer_Timeout_Status) & BM_PCIE_EP_CESR_Reply_Timer_Timeout_Status)

/*! @brief Set the Reply_Timer_Timeout_Status field to a new value. */
#define BW_PCIE_EP_CESR_Reply_Timer_Timeout_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_Reply_Timer_Timeout_Status) | BF_PCIE_EP_CESR_Reply_Timer_Timeout_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CESR, field Advisory_Non_Fatal_Error_Status[13] (RW)
 *
 * Advisory Non-Fatal Error Status
 */
/*@{*/
#define BP_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status (13U) /*!< Bit position for PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status. */
#define BM_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status (0x00002000U) /*!< Bit mask for PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status. */
#define BS_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status (1U) /*!< Bit field size in bits for PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status. */

/*! @brief Read current value of the PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status field. */
#define BR_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status(x) (HW_PCIE_EP_CESR(x).B.Advisory_Non_Fatal_Error_Status)

/*! @brief Format value for bitfield PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status. */
#define BF_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status) & BM_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status)

/*! @brief Set the Advisory_Non_Fatal_Error_Status field to a new value. */
#define BW_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status(x, v) (HW_PCIE_EP_CESR_WR(x, (HW_PCIE_EP_CESR_RD(x) & ~BM_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status) | BF_PCIE_EP_CESR_Advisory_Non_Fatal_Error_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_CEMR - Correctable Error Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_CEMR - Correctable Error Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x14
 */
typedef union _hw_pcie_ep_cemr
{
    uint32_t U;
    struct _hw_pcie_ep_cemr_bitfields
    {
        uint32_t Receiver_Error_Mask : 1; /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t Bad_TLP_Mask : 1;     /*!< [6]  */
        uint32_t Bad_DLLP_Mask : 1;    /*!< [7]  */
        uint32_t REPLAY_NUM_Rollover_Mask : 1; /*!< [8]  */
        uint32_t RESERVED1 : 3;        /*!< [11:9]  */
        uint32_t Reply_Timer_Timeout_Mask : 1; /*!< [12]  */
        uint32_t Advisory_Non_Fatal_Error_Mask : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_pcie_ep_cemr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_CEMR register
 */
/*@{*/
#define HW_PCIE_EP_CEMR_ADDR(x)  ((uintptr_t)(x) + 0x114U)

#define HW_PCIE_EP_CEMR(x)       (*(__IO hw_pcie_ep_cemr_t *) HW_PCIE_EP_CEMR_ADDR(x))
#define HW_PCIE_EP_CEMR_RD(x)    (HW_PCIE_EP_CEMR(x).U)
#define HW_PCIE_EP_CEMR_WR(x, v) (HW_PCIE_EP_CEMR(x).U = (v))
#define HW_PCIE_EP_CEMR_SET(x, v) (HW_PCIE_EP_CEMR_WR(x, HW_PCIE_EP_CEMR_RD(x) |  (v)))
#define HW_PCIE_EP_CEMR_CLR(x, v) (HW_PCIE_EP_CEMR_WR(x, HW_PCIE_EP_CEMR_RD(x) & ~(v)))
#define HW_PCIE_EP_CEMR_TOG(x, v) (HW_PCIE_EP_CEMR_WR(x, HW_PCIE_EP_CEMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_CEMR bitfields
 */

/*!
 * @name Register PCIE_EP_CEMR, field Receiver_Error_Mask[0] (RW)
 *
 * Receiver Error Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_Receiver_Error_Mask (0U) /*!< Bit position for PCIE_EP_CEMR_Receiver_Error_Mask. */
#define BM_PCIE_EP_CEMR_Receiver_Error_Mask (0x00000001U) /*!< Bit mask for PCIE_EP_CEMR_Receiver_Error_Mask. */
#define BS_PCIE_EP_CEMR_Receiver_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_CEMR_Receiver_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_Receiver_Error_Mask field. */
#define BR_PCIE_EP_CEMR_Receiver_Error_Mask(x) (HW_PCIE_EP_CEMR(x).B.Receiver_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_Receiver_Error_Mask. */
#define BF_PCIE_EP_CEMR_Receiver_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_Receiver_Error_Mask) & BM_PCIE_EP_CEMR_Receiver_Error_Mask)

/*! @brief Set the Receiver_Error_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_Receiver_Error_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_Receiver_Error_Mask) | BF_PCIE_EP_CEMR_Receiver_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CEMR, field Bad_TLP_Mask[6] (RW)
 *
 * Bad TLP Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_Bad_TLP_Mask (6U)  /*!< Bit position for PCIE_EP_CEMR_Bad_TLP_Mask. */
#define BM_PCIE_EP_CEMR_Bad_TLP_Mask (0x00000040U) /*!< Bit mask for PCIE_EP_CEMR_Bad_TLP_Mask. */
#define BS_PCIE_EP_CEMR_Bad_TLP_Mask (1U)  /*!< Bit field size in bits for PCIE_EP_CEMR_Bad_TLP_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_Bad_TLP_Mask field. */
#define BR_PCIE_EP_CEMR_Bad_TLP_Mask(x) (HW_PCIE_EP_CEMR(x).B.Bad_TLP_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_Bad_TLP_Mask. */
#define BF_PCIE_EP_CEMR_Bad_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_Bad_TLP_Mask) & BM_PCIE_EP_CEMR_Bad_TLP_Mask)

/*! @brief Set the Bad_TLP_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_Bad_TLP_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_Bad_TLP_Mask) | BF_PCIE_EP_CEMR_Bad_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CEMR, field Bad_DLLP_Mask[7] (RW)
 *
 * Bad DLLP Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_Bad_DLLP_Mask (7U) /*!< Bit position for PCIE_EP_CEMR_Bad_DLLP_Mask. */
#define BM_PCIE_EP_CEMR_Bad_DLLP_Mask (0x00000080U) /*!< Bit mask for PCIE_EP_CEMR_Bad_DLLP_Mask. */
#define BS_PCIE_EP_CEMR_Bad_DLLP_Mask (1U) /*!< Bit field size in bits for PCIE_EP_CEMR_Bad_DLLP_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_Bad_DLLP_Mask field. */
#define BR_PCIE_EP_CEMR_Bad_DLLP_Mask(x) (HW_PCIE_EP_CEMR(x).B.Bad_DLLP_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_Bad_DLLP_Mask. */
#define BF_PCIE_EP_CEMR_Bad_DLLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_Bad_DLLP_Mask) & BM_PCIE_EP_CEMR_Bad_DLLP_Mask)

/*! @brief Set the Bad_DLLP_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_Bad_DLLP_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_Bad_DLLP_Mask) | BF_PCIE_EP_CEMR_Bad_DLLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CEMR, field REPLAY_NUM_Rollover_Mask[8] (RW)
 *
 * REPLAY_NUM Rollover Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask (8U) /*!< Bit position for PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BM_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask (0x00000100U) /*!< Bit mask for PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BS_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask (1U) /*!< Bit field size in bits for PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask field. */
#define BR_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask(x) (HW_PCIE_EP_CEMR(x).B.REPLAY_NUM_Rollover_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BF_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask) & BM_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask)

/*! @brief Set the REPLAY_NUM_Rollover_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask) | BF_PCIE_EP_CEMR_REPLAY_NUM_Rollover_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CEMR, field Reply_Timer_Timeout_Mask[12] (RW)
 *
 * Reply Timer Timeout Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask (12U) /*!< Bit position for PCIE_EP_CEMR_Reply_Timer_Timeout_Mask. */
#define BM_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask (0x00001000U) /*!< Bit mask for PCIE_EP_CEMR_Reply_Timer_Timeout_Mask. */
#define BS_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask (1U) /*!< Bit field size in bits for PCIE_EP_CEMR_Reply_Timer_Timeout_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_Reply_Timer_Timeout_Mask field. */
#define BR_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask(x) (HW_PCIE_EP_CEMR(x).B.Reply_Timer_Timeout_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_Reply_Timer_Timeout_Mask. */
#define BF_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask) & BM_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask)

/*! @brief Set the Reply_Timer_Timeout_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask) | BF_PCIE_EP_CEMR_Reply_Timer_Timeout_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_CEMR, field Advisory_Non_Fatal_Error_Mask[13] (RW)
 *
 * Advisory Non-Fatal Error Mask
 */
/*@{*/
#define BP_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask (13U) /*!< Bit position for PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BM_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask (0x00002000U) /*!< Bit mask for PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BS_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask (1U) /*!< Bit field size in bits for PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask. */

/*! @brief Read current value of the PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask field. */
#define BR_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask(x) (HW_PCIE_EP_CEMR(x).B.Advisory_Non_Fatal_Error_Mask)

/*! @brief Format value for bitfield PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BF_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask) & BM_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask)

/*! @brief Set the Advisory_Non_Fatal_Error_Mask field to a new value. */
#define BW_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask(x, v) (HW_PCIE_EP_CEMR_WR(x, (HW_PCIE_EP_CEMR_RD(x) & ~BM_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask) | BF_PCIE_EP_CEMR_Advisory_Non_Fatal_Error_Mask(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_ACCR - Advanced Capabilities and Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_ACCR - Advanced Capabilities and Control Register (RW)
 *
 * Reset value: 0x000000A0U
 *
 * Offset: 0x18
 */
typedef union _hw_pcie_ep_accr
{
    uint32_t U;
    struct _hw_pcie_ep_accr_bitfields
    {
        uint32_t First_Error_Pointer : 5; /*!< [4:0]  */
        uint32_t ECRC_Generation_Capability : 1; /*!< [5]  */
        uint32_t ECRC_Generation_Enable : 1; /*!< [6]  */
        uint32_t ECRC_Check_Capable : 1; /*!< [7]  */
        uint32_t ECRC_Check_Enable : 1; /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_pcie_ep_accr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_ACCR register
 */
/*@{*/
#define HW_PCIE_EP_ACCR_ADDR(x)  ((uintptr_t)(x) + 0x118U)

#define HW_PCIE_EP_ACCR(x)       (*(__IO hw_pcie_ep_accr_t *) HW_PCIE_EP_ACCR_ADDR(x))
#define HW_PCIE_EP_ACCR_RD(x)    (HW_PCIE_EP_ACCR(x).U)
#define HW_PCIE_EP_ACCR_WR(x, v) (HW_PCIE_EP_ACCR(x).U = (v))
#define HW_PCIE_EP_ACCR_SET(x, v) (HW_PCIE_EP_ACCR_WR(x, HW_PCIE_EP_ACCR_RD(x) |  (v)))
#define HW_PCIE_EP_ACCR_CLR(x, v) (HW_PCIE_EP_ACCR_WR(x, HW_PCIE_EP_ACCR_RD(x) & ~(v)))
#define HW_PCIE_EP_ACCR_TOG(x, v) (HW_PCIE_EP_ACCR_WR(x, HW_PCIE_EP_ACCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_ACCR bitfields
 */

/*!
 * @name Register PCIE_EP_ACCR, field First_Error_Pointer[4:0] (RW)
 *
 * First Error Pointer
 */
/*@{*/
#define BP_PCIE_EP_ACCR_First_Error_Pointer (0U) /*!< Bit position for PCIE_EP_ACCR_First_Error_Pointer. */
#define BM_PCIE_EP_ACCR_First_Error_Pointer (0x0000001FU) /*!< Bit mask for PCIE_EP_ACCR_First_Error_Pointer. */
#define BS_PCIE_EP_ACCR_First_Error_Pointer (5U) /*!< Bit field size in bits for PCIE_EP_ACCR_First_Error_Pointer. */

/*! @brief Read current value of the PCIE_EP_ACCR_First_Error_Pointer field. */
#define BR_PCIE_EP_ACCR_First_Error_Pointer(x) (HW_PCIE_EP_ACCR(x).B.First_Error_Pointer)

/*! @brief Format value for bitfield PCIE_EP_ACCR_First_Error_Pointer. */
#define BF_PCIE_EP_ACCR_First_Error_Pointer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ACCR_First_Error_Pointer) & BM_PCIE_EP_ACCR_First_Error_Pointer)

/*! @brief Set the First_Error_Pointer field to a new value. */
#define BW_PCIE_EP_ACCR_First_Error_Pointer(x, v) (HW_PCIE_EP_ACCR_WR(x, (HW_PCIE_EP_ACCR_RD(x) & ~BM_PCIE_EP_ACCR_First_Error_Pointer) | BF_PCIE_EP_ACCR_First_Error_Pointer(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_ACCR, field ECRC_Generation_Capability[5] (RW)
 *
 * ECRC Generation Capability
 */
/*@{*/
#define BP_PCIE_EP_ACCR_ECRC_Generation_Capability (5U) /*!< Bit position for PCIE_EP_ACCR_ECRC_Generation_Capability. */
#define BM_PCIE_EP_ACCR_ECRC_Generation_Capability (0x00000020U) /*!< Bit mask for PCIE_EP_ACCR_ECRC_Generation_Capability. */
#define BS_PCIE_EP_ACCR_ECRC_Generation_Capability (1U) /*!< Bit field size in bits for PCIE_EP_ACCR_ECRC_Generation_Capability. */

/*! @brief Read current value of the PCIE_EP_ACCR_ECRC_Generation_Capability field. */
#define BR_PCIE_EP_ACCR_ECRC_Generation_Capability(x) (HW_PCIE_EP_ACCR(x).B.ECRC_Generation_Capability)

/*! @brief Format value for bitfield PCIE_EP_ACCR_ECRC_Generation_Capability. */
#define BF_PCIE_EP_ACCR_ECRC_Generation_Capability(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ACCR_ECRC_Generation_Capability) & BM_PCIE_EP_ACCR_ECRC_Generation_Capability)

/*! @brief Set the ECRC_Generation_Capability field to a new value. */
#define BW_PCIE_EP_ACCR_ECRC_Generation_Capability(x, v) (HW_PCIE_EP_ACCR_WR(x, (HW_PCIE_EP_ACCR_RD(x) & ~BM_PCIE_EP_ACCR_ECRC_Generation_Capability) | BF_PCIE_EP_ACCR_ECRC_Generation_Capability(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_ACCR, field ECRC_Generation_Enable[6] (RW)
 *
 * ECRC Generation Enable
 */
/*@{*/
#define BP_PCIE_EP_ACCR_ECRC_Generation_Enable (6U) /*!< Bit position for PCIE_EP_ACCR_ECRC_Generation_Enable. */
#define BM_PCIE_EP_ACCR_ECRC_Generation_Enable (0x00000040U) /*!< Bit mask for PCIE_EP_ACCR_ECRC_Generation_Enable. */
#define BS_PCIE_EP_ACCR_ECRC_Generation_Enable (1U) /*!< Bit field size in bits for PCIE_EP_ACCR_ECRC_Generation_Enable. */

/*! @brief Read current value of the PCIE_EP_ACCR_ECRC_Generation_Enable field. */
#define BR_PCIE_EP_ACCR_ECRC_Generation_Enable(x) (HW_PCIE_EP_ACCR(x).B.ECRC_Generation_Enable)

/*! @brief Format value for bitfield PCIE_EP_ACCR_ECRC_Generation_Enable. */
#define BF_PCIE_EP_ACCR_ECRC_Generation_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ACCR_ECRC_Generation_Enable) & BM_PCIE_EP_ACCR_ECRC_Generation_Enable)

/*! @brief Set the ECRC_Generation_Enable field to a new value. */
#define BW_PCIE_EP_ACCR_ECRC_Generation_Enable(x, v) (HW_PCIE_EP_ACCR_WR(x, (HW_PCIE_EP_ACCR_RD(x) & ~BM_PCIE_EP_ACCR_ECRC_Generation_Enable) | BF_PCIE_EP_ACCR_ECRC_Generation_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_ACCR, field ECRC_Check_Capable[7] (RW)
 *
 * ECRC Check Capable
 */
/*@{*/
#define BP_PCIE_EP_ACCR_ECRC_Check_Capable (7U) /*!< Bit position for PCIE_EP_ACCR_ECRC_Check_Capable. */
#define BM_PCIE_EP_ACCR_ECRC_Check_Capable (0x00000080U) /*!< Bit mask for PCIE_EP_ACCR_ECRC_Check_Capable. */
#define BS_PCIE_EP_ACCR_ECRC_Check_Capable (1U) /*!< Bit field size in bits for PCIE_EP_ACCR_ECRC_Check_Capable. */

/*! @brief Read current value of the PCIE_EP_ACCR_ECRC_Check_Capable field. */
#define BR_PCIE_EP_ACCR_ECRC_Check_Capable(x) (HW_PCIE_EP_ACCR(x).B.ECRC_Check_Capable)

/*! @brief Format value for bitfield PCIE_EP_ACCR_ECRC_Check_Capable. */
#define BF_PCIE_EP_ACCR_ECRC_Check_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ACCR_ECRC_Check_Capable) & BM_PCIE_EP_ACCR_ECRC_Check_Capable)

/*! @brief Set the ECRC_Check_Capable field to a new value. */
#define BW_PCIE_EP_ACCR_ECRC_Check_Capable(x, v) (HW_PCIE_EP_ACCR_WR(x, (HW_PCIE_EP_ACCR_RD(x) & ~BM_PCIE_EP_ACCR_ECRC_Check_Capable) | BF_PCIE_EP_ACCR_ECRC_Check_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_ACCR, field ECRC_Check_Enable[8] (RW)
 *
 * ECRC Check Enable
 */
/*@{*/
#define BP_PCIE_EP_ACCR_ECRC_Check_Enable (8U) /*!< Bit position for PCIE_EP_ACCR_ECRC_Check_Enable. */
#define BM_PCIE_EP_ACCR_ECRC_Check_Enable (0x00000100U) /*!< Bit mask for PCIE_EP_ACCR_ECRC_Check_Enable. */
#define BS_PCIE_EP_ACCR_ECRC_Check_Enable (1U) /*!< Bit field size in bits for PCIE_EP_ACCR_ECRC_Check_Enable. */

/*! @brief Read current value of the PCIE_EP_ACCR_ECRC_Check_Enable field. */
#define BR_PCIE_EP_ACCR_ECRC_Check_Enable(x) (HW_PCIE_EP_ACCR(x).B.ECRC_Check_Enable)

/*! @brief Format value for bitfield PCIE_EP_ACCR_ECRC_Check_Enable. */
#define BF_PCIE_EP_ACCR_ECRC_Check_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_ACCR_ECRC_Check_Enable) & BM_PCIE_EP_ACCR_ECRC_Check_Enable)

/*! @brief Set the ECRC_Check_Enable field to a new value. */
#define BW_PCIE_EP_ACCR_ECRC_Check_Enable(x, v) (HW_PCIE_EP_ACCR_WR(x, (HW_PCIE_EP_ACCR_RD(x) & ~BM_PCIE_EP_ACCR_ECRC_Check_Enable) | BF_PCIE_EP_ACCR_ECRC_Check_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_HLR - Header Log Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_HLR - Header Log Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x1C The Header Log registers collect the header for the TLP
 * corresponding to a detected error. See the PCI Express 3.0 Specification for details.
 * Each of the Header Log registers is type ROS; the default reset value of each
 * Header Log register is 0x00000000.
 */
typedef union _hw_pcie_ep_hlr
{
    uint32_t U;
    struct _hw_pcie_ep_hlr_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_pcie_ep_hlr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_HLR register
 */
/*@{*/
#define HW_PCIE_EP_HLR_ADDR(x)   ((uintptr_t)(x) + 0x11CU)

#define HW_PCIE_EP_HLR(x)        (*(__I hw_pcie_ep_hlr_t *) HW_PCIE_EP_HLR_ADDR(x))
#define HW_PCIE_EP_HLR_RD(x)     (HW_PCIE_EP_HLR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_HLR bitfields
 */

/*******************************************************************************
 * HW_PCIE_EP_VCECHR - VC Extended Capability Header
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_VCECHR - VC Extended Capability Header (RO)
 *
 * Reset value: 0x00000012U
 *
 * Offset: 0x140
 */
typedef union _hw_pcie_ep_vcechr
{
    uint32_t U;
    struct _hw_pcie_ep_vcechr_bitfields
    {
        uint32_t Extended_Capability : 16; /*!< [15:0]  */
        uint32_t Capability_Version : 4; /*!< [19:16]  */
        uint32_t Next_Capability_Offset : 12; /*!< [31:20]  */
    } B;
} hw_pcie_ep_vcechr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_VCECHR register
 */
/*@{*/
#define HW_PCIE_EP_VCECHR_ADDR(x) ((uintptr_t)(x) + 0x140U)

#define HW_PCIE_EP_VCECHR(x)     (*(__I hw_pcie_ep_vcechr_t *) HW_PCIE_EP_VCECHR_ADDR(x))
#define HW_PCIE_EP_VCECHR_RD(x)  (HW_PCIE_EP_VCECHR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_VCECHR bitfields
 */

/*!
 * @name Register PCIE_EP_VCECHR, field Extended_Capability[15:0] (RO)
 *
 * PCI Express Extended Capability The default value is 0x2 for VC Capability.
 */
/*@{*/
#define BP_PCIE_EP_VCECHR_Extended_Capability (0U) /*!< Bit position for PCIE_EP_VCECHR_Extended_Capability. */
#define BM_PCIE_EP_VCECHR_Extended_Capability (0x0000FFFFU) /*!< Bit mask for PCIE_EP_VCECHR_Extended_Capability. */
#define BS_PCIE_EP_VCECHR_Extended_Capability (16U) /*!< Bit field size in bits for PCIE_EP_VCECHR_Extended_Capability. */

/*! @brief Read current value of the PCIE_EP_VCECHR_Extended_Capability field. */
#define BR_PCIE_EP_VCECHR_Extended_Capability(x) (HW_PCIE_EP_VCECHR(x).B.Extended_Capability)
/*@}*/

/*!
 * @name Register PCIE_EP_VCECHR, field Capability_Version[19:16] (RO)
 *
 * Capability Version
 */
/*@{*/
#define BP_PCIE_EP_VCECHR_Capability_Version (16U) /*!< Bit position for PCIE_EP_VCECHR_Capability_Version. */
#define BM_PCIE_EP_VCECHR_Capability_Version (0x000F0000U) /*!< Bit mask for PCIE_EP_VCECHR_Capability_Version. */
#define BS_PCIE_EP_VCECHR_Capability_Version (4U) /*!< Bit field size in bits for PCIE_EP_VCECHR_Capability_Version. */

/*! @brief Read current value of the PCIE_EP_VCECHR_Capability_Version field. */
#define BR_PCIE_EP_VCECHR_Capability_Version(x) (HW_PCIE_EP_VCECHR(x).B.Capability_Version)
/*@}*/

/*!
 * @name Register PCIE_EP_VCECHR, field Next_Capability_Offset[31:20] (RO)
 *
 * Next Capability Offset
 */
/*@{*/
#define BP_PCIE_EP_VCECHR_Next_Capability_Offset (20U) /*!< Bit position for PCIE_EP_VCECHR_Next_Capability_Offset. */
#define BM_PCIE_EP_VCECHR_Next_Capability_Offset (0xFFF00000U) /*!< Bit mask for PCIE_EP_VCECHR_Next_Capability_Offset. */
#define BS_PCIE_EP_VCECHR_Next_Capability_Offset (12U) /*!< Bit field size in bits for PCIE_EP_VCECHR_Next_Capability_Offset. */

/*! @brief Read current value of the PCIE_EP_VCECHR_Next_Capability_Offset field. */
#define BR_PCIE_EP_VCECHR_Next_Capability_Offset(x) (HW_PCIE_EP_VCECHR(x).B.Next_Capability_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_PVCCR1 - Port VC Capability Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_PVCCR1 - Port VC Capability Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x4
 */
typedef union _hw_pcie_ep_pvccr1
{
    uint32_t U;
    struct _hw_pcie_ep_pvccr1_bitfields
    {
        uint32_t Extended_VC_Count : 3; /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t Low_Priority_Extended_VC_Count : 3; /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t Reference_Clock : 2;  /*!< [9:8]  */
        uint32_t Port_Arbitration_Table_Entry_Size : 2; /*!< [11:10]  */
        uint32_t RESERVED2 : 20;       /*!< [31:12]  */
    } B;
} hw_pcie_ep_pvccr1_t;

/*!
 * @name Constants and macros for entire PCIE_EP_PVCCR1 register
 */
/*@{*/
#define HW_PCIE_EP_PVCCR1_ADDR(x) ((uintptr_t)(x) + 0x144U)

#define HW_PCIE_EP_PVCCR1(x)     (*(__I hw_pcie_ep_pvccr1_t *) HW_PCIE_EP_PVCCR1_ADDR(x))
#define HW_PCIE_EP_PVCCR1_RD(x)  (HW_PCIE_EP_PVCCR1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_PVCCR1 bitfields
 */

/*!
 * @name Register PCIE_EP_PVCCR1, field Extended_VC_Count[2:0] (RO)
 *
 * Extended VC Count The default value is the one less than the number of VCs
 * that
 */
/*@{*/
#define BP_PCIE_EP_PVCCR1_Extended_VC_Count (0U) /*!< Bit position for PCIE_EP_PVCCR1_Extended_VC_Count. */
#define BM_PCIE_EP_PVCCR1_Extended_VC_Count (0x00000007U) /*!< Bit mask for PCIE_EP_PVCCR1_Extended_VC_Count. */
#define BS_PCIE_EP_PVCCR1_Extended_VC_Count (3U) /*!< Bit field size in bits for PCIE_EP_PVCCR1_Extended_VC_Count. */

/*! @brief Read current value of the PCIE_EP_PVCCR1_Extended_VC_Count field. */
#define BR_PCIE_EP_PVCCR1_Extended_VC_Count(x) (HW_PCIE_EP_PVCCR1(x).B.Extended_VC_Count)
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCR1, field Low_Priority_Extended_VC_Count[6:4] (RO)
 *
 * Low Priority Extended VC Count, writable through the DBI
 */
/*@{*/
#define BP_PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count (4U) /*!< Bit position for PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count. */
#define BM_PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count (0x00000070U) /*!< Bit mask for PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count. */
#define BS_PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count (3U) /*!< Bit field size in bits for PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count. */

/*! @brief Read current value of the PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count field. */
#define BR_PCIE_EP_PVCCR1_Low_Priority_Extended_VC_Count(x) (HW_PCIE_EP_PVCCR1(x).B.Low_Priority_Extended_VC_Count)
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCR1, field Reference_Clock[9:8] (RO)
 *
 * Reference Clock
 */
/*@{*/
#define BP_PCIE_EP_PVCCR1_Reference_Clock (8U) /*!< Bit position for PCIE_EP_PVCCR1_Reference_Clock. */
#define BM_PCIE_EP_PVCCR1_Reference_Clock (0x00000300U) /*!< Bit mask for PCIE_EP_PVCCR1_Reference_Clock. */
#define BS_PCIE_EP_PVCCR1_Reference_Clock (2U) /*!< Bit field size in bits for PCIE_EP_PVCCR1_Reference_Clock. */

/*! @brief Read current value of the PCIE_EP_PVCCR1_Reference_Clock field. */
#define BR_PCIE_EP_PVCCR1_Reference_Clock(x) (HW_PCIE_EP_PVCCR1(x).B.Reference_Clock)
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCR1, field Port_Arbitration_Table_Entry_Size[11:10] (RO)
 *
 * Port Arbitration Table Entry Size
 */
/*@{*/
#define BP_PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size (10U) /*!< Bit position for PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size. */
#define BM_PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size (0x00000C00U) /*!< Bit mask for PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size. */
#define BS_PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size (2U) /*!< Bit field size in bits for PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size. */

/*! @brief Read current value of the PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size field. */
#define BR_PCIE_EP_PVCCR1_Port_Arbitration_Table_Entry_Size(x) (HW_PCIE_EP_PVCCR1(x).B.Port_Arbitration_Table_Entry_Size)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_PVCCR2 - Port VC Capability Register 2
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_PVCCR2 - Port VC Capability Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x8
 */
typedef union _hw_pcie_ep_pvccr2
{
    uint32_t U;
    struct _hw_pcie_ep_pvccr2_bitfields
    {
        uint32_t VC_Arbitration_Capability : 8; /*!< [7:0]  */
        uint32_t RESERVED0 : 16;       /*!< [23:8]  */
        uint32_t VC_Arbitration_Table_Offset : 8; /*!< [31:24]  */
    } B;
} hw_pcie_ep_pvccr2_t;

/*!
 * @name Constants and macros for entire PCIE_EP_PVCCR2 register
 */
/*@{*/
#define HW_PCIE_EP_PVCCR2_ADDR(x) ((uintptr_t)(x) + 0x148U)

#define HW_PCIE_EP_PVCCR2(x)     (*(__I hw_pcie_ep_pvccr2_t *) HW_PCIE_EP_PVCCR2_ADDR(x))
#define HW_PCIE_EP_PVCCR2_RD(x)  (HW_PCIE_EP_PVCCR2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_PVCCR2 bitfields
 */

/*!
 * @name Register PCIE_EP_PVCCR2, field VC_Arbitration_Capability[7:0] (RO)
 *
 * VC Arbitration Capability Indicates which VC arbitration mode(s) the device
 * supports, writable through the DBI: •Bit 0: Device supports hardware fixed
 * arbitration scheme. For the core, the scheme is 16-phase weighted round robin
 * (WRR). •Bit 1: Device supports 32-phase WRR •Bit 2: Device supports 64-phase
 * WRR •Bit 3: Device supports 128-phase WRR •Bits 4-7: Reserved
 */
/*@{*/
#define BP_PCIE_EP_PVCCR2_VC_Arbitration_Capability (0U) /*!< Bit position for PCIE_EP_PVCCR2_VC_Arbitration_Capability. */
#define BM_PCIE_EP_PVCCR2_VC_Arbitration_Capability (0x000000FFU) /*!< Bit mask for PCIE_EP_PVCCR2_VC_Arbitration_Capability. */
#define BS_PCIE_EP_PVCCR2_VC_Arbitration_Capability (8U) /*!< Bit field size in bits for PCIE_EP_PVCCR2_VC_Arbitration_Capability. */

/*! @brief Read current value of the PCIE_EP_PVCCR2_VC_Arbitration_Capability field. */
#define BR_PCIE_EP_PVCCR2_VC_Arbitration_Capability(x) (HW_PCIE_EP_PVCCR2(x).B.VC_Arbitration_Capability)
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCR2, field VC_Arbitration_Table_Offset[31:24] (RO)
 *
 * VC Arbitration Table Offset (not supported) The default value is 0x00 (no
 * arbitration table present).
 */
/*@{*/
#define BP_PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset (24U) /*!< Bit position for PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset. */
#define BM_PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset (0xFF000000U) /*!< Bit mask for PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset. */
#define BS_PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset (8U) /*!< Bit field size in bits for PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset. */

/*! @brief Read current value of the PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset field. */
#define BR_PCIE_EP_PVCCR2_VC_Arbitration_Table_Offset(x) (HW_PCIE_EP_PVCCR2(x).B.VC_Arbitration_Table_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_PVCCSR - Port VC Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_PVCCSR - Port VC Control and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0xC Bytes: 0-1
 */
typedef union _hw_pcie_ep_pvccsr
{
    uint32_t U;
    struct _hw_pcie_ep_pvccsr_bitfields
    {
        uint32_t Load_VC_Arbitration_Table : 1; /*!< [0]  */
        uint32_t VC_Arbitration_Select : 3; /*!< [3:1]  */
        uint32_t RESERVED0 : 12;       /*!< [15:4]  */
        uint32_t Arbitration_Table_Status : 1; /*!< [16]  */
        uint32_t RESERVED1 : 15;       /*!< [31:17]  */
    } B;
} hw_pcie_ep_pvccsr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_PVCCSR register
 */
/*@{*/
#define HW_PCIE_EP_PVCCSR_ADDR(x) ((uintptr_t)(x) + 0x14CU)

#define HW_PCIE_EP_PVCCSR(x)     (*(__IO hw_pcie_ep_pvccsr_t *) HW_PCIE_EP_PVCCSR_ADDR(x))
#define HW_PCIE_EP_PVCCSR_RD(x)  (HW_PCIE_EP_PVCCSR(x).U)
#define HW_PCIE_EP_PVCCSR_WR(x, v) (HW_PCIE_EP_PVCCSR(x).U = (v))
#define HW_PCIE_EP_PVCCSR_SET(x, v) (HW_PCIE_EP_PVCCSR_WR(x, HW_PCIE_EP_PVCCSR_RD(x) |  (v)))
#define HW_PCIE_EP_PVCCSR_CLR(x, v) (HW_PCIE_EP_PVCCSR_WR(x, HW_PCIE_EP_PVCCSR_RD(x) & ~(v)))
#define HW_PCIE_EP_PVCCSR_TOG(x, v) (HW_PCIE_EP_PVCCSR_WR(x, HW_PCIE_EP_PVCCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_PVCCSR bitfields
 */

/*!
 * @name Register PCIE_EP_PVCCSR, field Load_VC_Arbitration_Table[0] (RW)
 *
 * Load VC Arbitration Table
 */
/*@{*/
#define BP_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table (0U) /*!< Bit position for PCIE_EP_PVCCSR_Load_VC_Arbitration_Table. */
#define BM_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table (0x00000001U) /*!< Bit mask for PCIE_EP_PVCCSR_Load_VC_Arbitration_Table. */
#define BS_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table (1U) /*!< Bit field size in bits for PCIE_EP_PVCCSR_Load_VC_Arbitration_Table. */

/*! @brief Read current value of the PCIE_EP_PVCCSR_Load_VC_Arbitration_Table field. */
#define BR_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table(x) (HW_PCIE_EP_PVCCSR(x).B.Load_VC_Arbitration_Table)

/*! @brief Format value for bitfield PCIE_EP_PVCCSR_Load_VC_Arbitration_Table. */
#define BF_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table) & BM_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table)

/*! @brief Set the Load_VC_Arbitration_Table field to a new value. */
#define BW_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table(x, v) (HW_PCIE_EP_PVCCSR_WR(x, (HW_PCIE_EP_PVCCSR_RD(x) & ~BM_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table) | BF_PCIE_EP_PVCCSR_Load_VC_Arbitration_Table(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCSR, field VC_Arbitration_Select[3:1] (RW)
 *
 * VC Arbitration Select
 */
/*@{*/
#define BP_PCIE_EP_PVCCSR_VC_Arbitration_Select (1U) /*!< Bit position for PCIE_EP_PVCCSR_VC_Arbitration_Select. */
#define BM_PCIE_EP_PVCCSR_VC_Arbitration_Select (0x0000000EU) /*!< Bit mask for PCIE_EP_PVCCSR_VC_Arbitration_Select. */
#define BS_PCIE_EP_PVCCSR_VC_Arbitration_Select (3U) /*!< Bit field size in bits for PCIE_EP_PVCCSR_VC_Arbitration_Select. */

/*! @brief Read current value of the PCIE_EP_PVCCSR_VC_Arbitration_Select field. */
#define BR_PCIE_EP_PVCCSR_VC_Arbitration_Select(x) (HW_PCIE_EP_PVCCSR(x).B.VC_Arbitration_Select)

/*! @brief Format value for bitfield PCIE_EP_PVCCSR_VC_Arbitration_Select. */
#define BF_PCIE_EP_PVCCSR_VC_Arbitration_Select(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_PVCCSR_VC_Arbitration_Select) & BM_PCIE_EP_PVCCSR_VC_Arbitration_Select)

/*! @brief Set the VC_Arbitration_Select field to a new value. */
#define BW_PCIE_EP_PVCCSR_VC_Arbitration_Select(x, v) (HW_PCIE_EP_PVCCSR_WR(x, (HW_PCIE_EP_PVCCSR_RD(x) & ~BM_PCIE_EP_PVCCSR_VC_Arbitration_Select) | BF_PCIE_EP_PVCCSR_VC_Arbitration_Select(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_PVCCSR, field Arbitration_Table_Status[16] (RW)
 *
 * Arbitration Table Status
 */
/*@{*/
#define BP_PCIE_EP_PVCCSR_Arbitration_Table_Status (16U) /*!< Bit position for PCIE_EP_PVCCSR_Arbitration_Table_Status. */
#define BM_PCIE_EP_PVCCSR_Arbitration_Table_Status (0x00010000U) /*!< Bit mask for PCIE_EP_PVCCSR_Arbitration_Table_Status. */
#define BS_PCIE_EP_PVCCSR_Arbitration_Table_Status (1U) /*!< Bit field size in bits for PCIE_EP_PVCCSR_Arbitration_Table_Status. */

/*! @brief Read current value of the PCIE_EP_PVCCSR_Arbitration_Table_Status field. */
#define BR_PCIE_EP_PVCCSR_Arbitration_Table_Status(x) (HW_PCIE_EP_PVCCSR(x).B.Arbitration_Table_Status)

/*! @brief Format value for bitfield PCIE_EP_PVCCSR_Arbitration_Table_Status. */
#define BF_PCIE_EP_PVCCSR_Arbitration_Table_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_PVCCSR_Arbitration_Table_Status) & BM_PCIE_EP_PVCCSR_Arbitration_Table_Status)

/*! @brief Set the Arbitration_Table_Status field to a new value. */
#define BW_PCIE_EP_PVCCSR_Arbitration_Table_Status(x, v) (HW_PCIE_EP_PVCCSR_WR(x, (HW_PCIE_EP_PVCCSR_RD(x) & ~BM_PCIE_EP_PVCCSR_Arbitration_Table_Status) | BF_PCIE_EP_PVCCSR_Arbitration_Table_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_VCRCR - VC Resource Capability Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_VCRCR - VC Resource Capability Register n (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x10
 */
typedef union _hw_pcie_ep_vcrcr
{
    uint32_t U;
    struct _hw_pcie_ep_vcrcr_bitfields
    {
        uint32_t Port_Arbitration_Capability : 8; /*!< [7:0]  */
        uint32_t RESERVED0 : 6;        /*!< [13:8]  */
        uint32_t Undefined : 1;        /*!< [14]  */
        uint32_t Reject_Snoop_Transactions : 1; /*!< [15]  */
        uint32_t Maximum_Time_Slots : 7; /*!< [22:16]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t Port_Arbitration_Table_Offset : 8; /*!< [31:24]  */
    } B;
} hw_pcie_ep_vcrcr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_VCRCR register
 */
/*@{*/
#define HW_PCIE_EP_VCRCR_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_PCIE_EP_VCRCR(x)      (*(__I hw_pcie_ep_vcrcr_t *) HW_PCIE_EP_VCRCR_ADDR(x))
#define HW_PCIE_EP_VCRCR_RD(x)   (HW_PCIE_EP_VCRCR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_VCRCR bitfields
 */

/*!
 * @name Register PCIE_EP_VCRCR, field Port_Arbitration_Capability[7:0] (RO)
 *
 * Port Arbitration Capability
 */
/*@{*/
#define BP_PCIE_EP_VCRCR_Port_Arbitration_Capability (0U) /*!< Bit position for PCIE_EP_VCRCR_Port_Arbitration_Capability. */
#define BM_PCIE_EP_VCRCR_Port_Arbitration_Capability (0x000000FFU) /*!< Bit mask for PCIE_EP_VCRCR_Port_Arbitration_Capability. */
#define BS_PCIE_EP_VCRCR_Port_Arbitration_Capability (8U) /*!< Bit field size in bits for PCIE_EP_VCRCR_Port_Arbitration_Capability. */

/*! @brief Read current value of the PCIE_EP_VCRCR_Port_Arbitration_Capability field. */
#define BR_PCIE_EP_VCRCR_Port_Arbitration_Capability(x) (HW_PCIE_EP_VCRCR(x).B.Port_Arbitration_Capability)
/*@}*/

/*!
 * @name Register PCIE_EP_VCRCR, field Undefined[14] (RO)
 *
 * Undefined for PCI Express 1.1 (Was Advanced Packet Switching for PCI Express
 * 1.0a)
 */
/*@{*/
#define BP_PCIE_EP_VCRCR_Undefined (14U)   /*!< Bit position for PCIE_EP_VCRCR_Undefined. */
#define BM_PCIE_EP_VCRCR_Undefined (0x00004000U) /*!< Bit mask for PCIE_EP_VCRCR_Undefined. */
#define BS_PCIE_EP_VCRCR_Undefined (1U)    /*!< Bit field size in bits for PCIE_EP_VCRCR_Undefined. */

/*! @brief Read current value of the PCIE_EP_VCRCR_Undefined field. */
#define BR_PCIE_EP_VCRCR_Undefined(x) (HW_PCIE_EP_VCRCR(x).B.Undefined)
/*@}*/

/*!
 * @name Register PCIE_EP_VCRCR, field Reject_Snoop_Transactions[15] (RO)
 *
 * Reject Snoop Transactions
 */
/*@{*/
#define BP_PCIE_EP_VCRCR_Reject_Snoop_Transactions (15U) /*!< Bit position for PCIE_EP_VCRCR_Reject_Snoop_Transactions. */
#define BM_PCIE_EP_VCRCR_Reject_Snoop_Transactions (0x00008000U) /*!< Bit mask for PCIE_EP_VCRCR_Reject_Snoop_Transactions. */
#define BS_PCIE_EP_VCRCR_Reject_Snoop_Transactions (1U) /*!< Bit field size in bits for PCIE_EP_VCRCR_Reject_Snoop_Transactions. */

/*! @brief Read current value of the PCIE_EP_VCRCR_Reject_Snoop_Transactions field. */
#define BR_PCIE_EP_VCRCR_Reject_Snoop_Transactions(x) (HW_PCIE_EP_VCRCR(x).B.Reject_Snoop_Transactions)
/*@}*/

/*!
 * @name Register PCIE_EP_VCRCR, field Maximum_Time_Slots[22:16] (RO)
 *
 * Maximum Time Slots
 */
/*@{*/
#define BP_PCIE_EP_VCRCR_Maximum_Time_Slots (16U) /*!< Bit position for PCIE_EP_VCRCR_Maximum_Time_Slots. */
#define BM_PCIE_EP_VCRCR_Maximum_Time_Slots (0x007F0000U) /*!< Bit mask for PCIE_EP_VCRCR_Maximum_Time_Slots. */
#define BS_PCIE_EP_VCRCR_Maximum_Time_Slots (7U) /*!< Bit field size in bits for PCIE_EP_VCRCR_Maximum_Time_Slots. */

/*! @brief Read current value of the PCIE_EP_VCRCR_Maximum_Time_Slots field. */
#define BR_PCIE_EP_VCRCR_Maximum_Time_Slots(x) (HW_PCIE_EP_VCRCR(x).B.Maximum_Time_Slots)
/*@}*/

/*!
 * @name Register PCIE_EP_VCRCR, field Port_Arbitration_Table_Offset[31:24] (RO)
 *
 * Port Arbitration Table Offset
 */
/*@{*/
#define BP_PCIE_EP_VCRCR_Port_Arbitration_Table_Offset (24U) /*!< Bit position for PCIE_EP_VCRCR_Port_Arbitration_Table_Offset. */
#define BM_PCIE_EP_VCRCR_Port_Arbitration_Table_Offset (0xFF000000U) /*!< Bit mask for PCIE_EP_VCRCR_Port_Arbitration_Table_Offset. */
#define BS_PCIE_EP_VCRCR_Port_Arbitration_Table_Offset (8U) /*!< Bit field size in bits for PCIE_EP_VCRCR_Port_Arbitration_Table_Offset. */

/*! @brief Read current value of the PCIE_EP_VCRCR_Port_Arbitration_Table_Offset field. */
#define BR_PCIE_EP_VCRCR_Port_Arbitration_Table_Offset(x) (HW_PCIE_EP_VCRCR(x).B.Port_Arbitration_Table_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_VCRConR - VC Resource Control Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_VCRConR - VC Resource Control Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x14
 */
typedef union _hw_pcie_ep_vcrconr
{
    uint32_t U;
    struct _hw_pcie_ep_vcrconr_bitfields
    {
        uint32_t TC_VC_Map : 8;        /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t Load_Port_Arbitration_Table : 1; /*!< [16]  */
        uint32_t Port_Arbitration_Select : 3; /*!< [19:17]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t VC_ID : 3;            /*!< [26:24]  */
        uint32_t RESERVED2 : 4;        /*!< [30:27]  */
        uint32_t VC_Enable : 1;        /*!< [31]  */
    } B;
} hw_pcie_ep_vcrconr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_VCRConR register
 */
/*@{*/
#define HW_PCIE_EP_VCRConR_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_PCIE_EP_VCRConR(x)    (*(__IO hw_pcie_ep_vcrconr_t *) HW_PCIE_EP_VCRConR_ADDR(x))
#define HW_PCIE_EP_VCRConR_RD(x) (HW_PCIE_EP_VCRConR(x).U)
#define HW_PCIE_EP_VCRConR_WR(x, v) (HW_PCIE_EP_VCRConR(x).U = (v))
#define HW_PCIE_EP_VCRConR_SET(x, v) (HW_PCIE_EP_VCRConR_WR(x, HW_PCIE_EP_VCRConR_RD(x) |  (v)))
#define HW_PCIE_EP_VCRConR_CLR(x, v) (HW_PCIE_EP_VCRConR_WR(x, HW_PCIE_EP_VCRConR_RD(x) & ~(v)))
#define HW_PCIE_EP_VCRConR_TOG(x, v) (HW_PCIE_EP_VCRConR_WR(x, HW_PCIE_EP_VCRConR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_VCRConR bitfields
 */

/*!
 * @name Register PCIE_EP_VCRConR, field TC_VC_Map[7:0] (RW)
 *
 * TC/VC Map Bit 0 is hardwired to 1; bits 7:1 are RW.
 */
/*@{*/
#define BP_PCIE_EP_VCRConR_TC_VC_Map (0U)  /*!< Bit position for PCIE_EP_VCRConR_TC_VC_Map. */
#define BM_PCIE_EP_VCRConR_TC_VC_Map (0x000000FFU) /*!< Bit mask for PCIE_EP_VCRConR_TC_VC_Map. */
#define BS_PCIE_EP_VCRConR_TC_VC_Map (8U)  /*!< Bit field size in bits for PCIE_EP_VCRConR_TC_VC_Map. */

/*! @brief Read current value of the PCIE_EP_VCRConR_TC_VC_Map field. */
#define BR_PCIE_EP_VCRConR_TC_VC_Map(x) (HW_PCIE_EP_VCRConR(x).B.TC_VC_Map)

/*! @brief Format value for bitfield PCIE_EP_VCRConR_TC_VC_Map. */
#define BF_PCIE_EP_VCRConR_TC_VC_Map(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_VCRConR_TC_VC_Map) & BM_PCIE_EP_VCRConR_TC_VC_Map)

/*! @brief Set the TC_VC_Map field to a new value. */
#define BW_PCIE_EP_VCRConR_TC_VC_Map(x, v) (HW_PCIE_EP_VCRConR_WR(x, (HW_PCIE_EP_VCRConR_RD(x) & ~BM_PCIE_EP_VCRConR_TC_VC_Map) | BF_PCIE_EP_VCRConR_TC_VC_Map(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_VCRConR, field Load_Port_Arbitration_Table[16] (RW)
 *
 * Load Port Arbitration Table
 */
/*@{*/
#define BP_PCIE_EP_VCRConR_Load_Port_Arbitration_Table (16U) /*!< Bit position for PCIE_EP_VCRConR_Load_Port_Arbitration_Table. */
#define BM_PCIE_EP_VCRConR_Load_Port_Arbitration_Table (0x00010000U) /*!< Bit mask for PCIE_EP_VCRConR_Load_Port_Arbitration_Table. */
#define BS_PCIE_EP_VCRConR_Load_Port_Arbitration_Table (1U) /*!< Bit field size in bits for PCIE_EP_VCRConR_Load_Port_Arbitration_Table. */

/*! @brief Read current value of the PCIE_EP_VCRConR_Load_Port_Arbitration_Table field. */
#define BR_PCIE_EP_VCRConR_Load_Port_Arbitration_Table(x) (HW_PCIE_EP_VCRConR(x).B.Load_Port_Arbitration_Table)

/*! @brief Format value for bitfield PCIE_EP_VCRConR_Load_Port_Arbitration_Table. */
#define BF_PCIE_EP_VCRConR_Load_Port_Arbitration_Table(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_VCRConR_Load_Port_Arbitration_Table) & BM_PCIE_EP_VCRConR_Load_Port_Arbitration_Table)

/*! @brief Set the Load_Port_Arbitration_Table field to a new value. */
#define BW_PCIE_EP_VCRConR_Load_Port_Arbitration_Table(x, v) (HW_PCIE_EP_VCRConR_WR(x, (HW_PCIE_EP_VCRConR_RD(x) & ~BM_PCIE_EP_VCRConR_Load_Port_Arbitration_Table) | BF_PCIE_EP_VCRConR_Load_Port_Arbitration_Table(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_VCRConR, field Port_Arbitration_Select[19:17] (RW)
 *
 * Port Arbitration Select
 */
/*@{*/
#define BP_PCIE_EP_VCRConR_Port_Arbitration_Select (17U) /*!< Bit position for PCIE_EP_VCRConR_Port_Arbitration_Select. */
#define BM_PCIE_EP_VCRConR_Port_Arbitration_Select (0x000E0000U) /*!< Bit mask for PCIE_EP_VCRConR_Port_Arbitration_Select. */
#define BS_PCIE_EP_VCRConR_Port_Arbitration_Select (3U) /*!< Bit field size in bits for PCIE_EP_VCRConR_Port_Arbitration_Select. */

/*! @brief Read current value of the PCIE_EP_VCRConR_Port_Arbitration_Select field. */
#define BR_PCIE_EP_VCRConR_Port_Arbitration_Select(x) (HW_PCIE_EP_VCRConR(x).B.Port_Arbitration_Select)

/*! @brief Format value for bitfield PCIE_EP_VCRConR_Port_Arbitration_Select. */
#define BF_PCIE_EP_VCRConR_Port_Arbitration_Select(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_VCRConR_Port_Arbitration_Select) & BM_PCIE_EP_VCRConR_Port_Arbitration_Select)

/*! @brief Set the Port_Arbitration_Select field to a new value. */
#define BW_PCIE_EP_VCRConR_Port_Arbitration_Select(x, v) (HW_PCIE_EP_VCRConR_WR(x, (HW_PCIE_EP_VCRConR_RD(x) & ~BM_PCIE_EP_VCRConR_Port_Arbitration_Select) | BF_PCIE_EP_VCRConR_Port_Arbitration_Select(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_VCRConR, field VC_ID[26:24] (RW)
 *
 * VC ID Hardwired to 0 for VC0.
 */
/*@{*/
#define BP_PCIE_EP_VCRConR_VC_ID (24U)     /*!< Bit position for PCIE_EP_VCRConR_VC_ID. */
#define BM_PCIE_EP_VCRConR_VC_ID (0x07000000U) /*!< Bit mask for PCIE_EP_VCRConR_VC_ID. */
#define BS_PCIE_EP_VCRConR_VC_ID (3U)      /*!< Bit field size in bits for PCIE_EP_VCRConR_VC_ID. */

/*! @brief Read current value of the PCIE_EP_VCRConR_VC_ID field. */
#define BR_PCIE_EP_VCRConR_VC_ID(x) (HW_PCIE_EP_VCRConR(x).B.VC_ID)

/*! @brief Format value for bitfield PCIE_EP_VCRConR_VC_ID. */
#define BF_PCIE_EP_VCRConR_VC_ID(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_VCRConR_VC_ID) & BM_PCIE_EP_VCRConR_VC_ID)

/*! @brief Set the VC_ID field to a new value. */
#define BW_PCIE_EP_VCRConR_VC_ID(x, v) (HW_PCIE_EP_VCRConR_WR(x, (HW_PCIE_EP_VCRConR_RD(x) & ~BM_PCIE_EP_VCRConR_VC_ID) | BF_PCIE_EP_VCRConR_VC_ID(v)))
/*@}*/

/*!
 * @name Register PCIE_EP_VCRConR, field VC_Enable[31] (RW)
 *
 * VC Enable Hardwired to 1 for the first VC.
 */
/*@{*/
#define BP_PCIE_EP_VCRConR_VC_Enable (31U) /*!< Bit position for PCIE_EP_VCRConR_VC_Enable. */
#define BM_PCIE_EP_VCRConR_VC_Enable (0x80000000U) /*!< Bit mask for PCIE_EP_VCRConR_VC_Enable. */
#define BS_PCIE_EP_VCRConR_VC_Enable (1U)  /*!< Bit field size in bits for PCIE_EP_VCRConR_VC_Enable. */

/*! @brief Read current value of the PCIE_EP_VCRConR_VC_Enable field. */
#define BR_PCIE_EP_VCRConR_VC_Enable(x) (HW_PCIE_EP_VCRConR(x).B.VC_Enable)

/*! @brief Format value for bitfield PCIE_EP_VCRConR_VC_Enable. */
#define BF_PCIE_EP_VCRConR_VC_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_EP_VCRConR_VC_Enable) & BM_PCIE_EP_VCRConR_VC_Enable)

/*! @brief Set the VC_Enable field to a new value. */
#define BW_PCIE_EP_VCRConR_VC_Enable(x, v) (HW_PCIE_EP_VCRConR_WR(x, (HW_PCIE_EP_VCRConR_RD(x) & ~BM_PCIE_EP_VCRConR_VC_Enable) | BF_PCIE_EP_VCRConR_VC_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_EP_VCRSR - VC Resource Status Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_EP_VCRSR - VC Resource Status Register n (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x18
 */
typedef union _hw_pcie_ep_vcrsr
{
    uint32_t U;
    struct _hw_pcie_ep_vcrsr_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t Port_Arbitration_Table_Status : 1; /*!< [16]  */
        uint32_t VC_Negotiation_Pending : 1; /*!< [17]  */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_pcie_ep_vcrsr_t;

/*!
 * @name Constants and macros for entire PCIE_EP_VCRSR register
 */
/*@{*/
#define HW_PCIE_EP_VCRSR_ADDR(x) ((uintptr_t)(x) + 0x158U)

#define HW_PCIE_EP_VCRSR(x)      (*(__I hw_pcie_ep_vcrsr_t *) HW_PCIE_EP_VCRSR_ADDR(x))
#define HW_PCIE_EP_VCRSR_RD(x)   (HW_PCIE_EP_VCRSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_EP_VCRSR bitfields
 */

/*!
 * @name Register PCIE_EP_VCRSR, field Port_Arbitration_Table_Status[16] (RO)
 *
 * Port Arbitration Table Status
 */
/*@{*/
#define BP_PCIE_EP_VCRSR_Port_Arbitration_Table_Status (16U) /*!< Bit position for PCIE_EP_VCRSR_Port_Arbitration_Table_Status. */
#define BM_PCIE_EP_VCRSR_Port_Arbitration_Table_Status (0x00010000U) /*!< Bit mask for PCIE_EP_VCRSR_Port_Arbitration_Table_Status. */
#define BS_PCIE_EP_VCRSR_Port_Arbitration_Table_Status (1U) /*!< Bit field size in bits for PCIE_EP_VCRSR_Port_Arbitration_Table_Status. */

/*! @brief Read current value of the PCIE_EP_VCRSR_Port_Arbitration_Table_Status field. */
#define BR_PCIE_EP_VCRSR_Port_Arbitration_Table_Status(x) (HW_PCIE_EP_VCRSR(x).B.Port_Arbitration_Table_Status)
/*@}*/

/*!
 * @name Register PCIE_EP_VCRSR, field VC_Negotiation_Pending[17] (RO)
 *
 * VC Negotiation Pending
 */
/*@{*/
#define BP_PCIE_EP_VCRSR_VC_Negotiation_Pending (17U) /*!< Bit position for PCIE_EP_VCRSR_VC_Negotiation_Pending. */
#define BM_PCIE_EP_VCRSR_VC_Negotiation_Pending (0x00020000U) /*!< Bit mask for PCIE_EP_VCRSR_VC_Negotiation_Pending. */
#define BS_PCIE_EP_VCRSR_VC_Negotiation_Pending (1U) /*!< Bit field size in bits for PCIE_EP_VCRSR_VC_Negotiation_Pending. */

/*! @brief Read current value of the PCIE_EP_VCRSR_VC_Negotiation_Pending field. */
#define BR_PCIE_EP_VCRSR_VC_Negotiation_Pending(x) (HW_PCIE_EP_VCRSR(x).B.VC_Negotiation_Pending)
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_pcie_ep_t - module struct
 ******************************************************************************/
/*!
 * @brief All PCIE_EP module registers.
 */
#pragma pack(1)
typedef struct _hw_pcie_ep
{
    __I hw_pcie_ep_deviceid_t DeviceID;    /*!< [0x0] Device ID and Vendor ID Register */
    __IO hw_pcie_ep_command_t Command;     /*!< [0x4] Command and Status Register */
    uint8_t _reserved0[4];
    __IO hw_pcie_ep_bist_t BIST;           /*!< [0xC] BIST Register */
    union {
        __I hw_pcie_ep_bar0_t BAR0;        /*!< [0x10] Base Address 0 */
        __I hw_pcie_ep_mask0_t MASK0;      /*!< [0x10] BAR 0 Mask Register */
    };
    __I hw_pcie_ep_mask1_t MASK1;          /*!< [0x14] BAR 1 Mask Register */
    __I hw_pcie_ep_mask2_t MASK2;          /*!< [0x18] BAR 2 Mask Register */
    __I hw_pcie_ep_mask3_t MASK3;          /*!< [0x1C] BAR 3 Mask Register */
    uint8_t _reserved1[8];
    __I hw_pcie_ep_cisp_t CISP;            /*!< [0x28] CardBus CIS Pointer Register */
    __I hw_pcie_ep_ssid_t SSID;            /*!< [0x2C] Subsystem ID and Subsystem Vendor ID Register */
    union {
        __IO hw_pcie_ep_erombar_t EROMBAR; /*!< [0x30] Expansion ROM Base Address Register */
        __IO hw_pcie_ep_erommask_t EROMMASK; /*!< [0x30] Expansion ROM BAR Mask Register */
    };
    __I hw_pcie_ep_cappr_t CAPPR;          /*!< [0x34] Capability Pointer Register */
    uint8_t _reserved2[4];
    __IO hw_pcie_ep_ilr_t ILR;             /*!< [0x3C] Interrupt Line and Pin Register */
    uint8_t _reserved3[192];
    __IO hw_pcie_ep_aer_t AER;             /*!< [0x100] AER Capability Header */
    __IO hw_pcie_ep_uesr_t UESR;           /*!< [0x104] Uncorrectable Error Status Register */
    __IO hw_pcie_ep_uemr_t UEMR;           /*!< [0x108] Uncorrectable Error Mask Register */
    __IO hw_pcie_ep_uesevr_t UESevR;       /*!< [0x10C] Uncorrectable Error Severity Register */
    __IO hw_pcie_ep_cesr_t CESR;           /*!< [0x110] Correctable Error Status Register */
    __IO hw_pcie_ep_cemr_t CEMR;           /*!< [0x114] Correctable Error Mask Register */
    __IO hw_pcie_ep_accr_t ACCR;           /*!< [0x118] Advanced Capabilities and Control Register */
    __I hw_pcie_ep_hlr_t HLR;              /*!< [0x11C] Header Log Register */
    uint8_t _reserved4[32];
    __I hw_pcie_ep_vcechr_t VCECHR;        /*!< [0x140] VC Extended Capability Header */
    __I hw_pcie_ep_pvccr1_t PVCCR1;        /*!< [0x144] Port VC Capability Register 1 */
    __I hw_pcie_ep_pvccr2_t PVCCR2;        /*!< [0x148] Port VC Capability Register 2 */
    __IO hw_pcie_ep_pvccsr_t PVCCSR;       /*!< [0x14C] Port VC Control and Status Register */
    __I hw_pcie_ep_vcrcr_t VCRCR;          /*!< [0x150] VC Resource Capability Register n */
    __IO hw_pcie_ep_vcrconr_t VCRConR;     /*!< [0x154] VC Resource Control Register n */
    __I hw_pcie_ep_vcrsr_t VCRSR;          /*!< [0x158] VC Resource Status Register n */
} hw_pcie_ep_t;
#pragma pack()

/*! @brief Macro to access all PCIE_EP registers. */
/*! @param x PCIE_EP module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PCIE_EP_REGS(PCIE_EP_BASE)</code>. */
#define HW_PCIE_EP_REGS(x) (*(hw_pcie_ep_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP PCIE_PL
 *
 * PCIE_PL
 *
 * Registers defined in this header file:
 * - HW_PCIE_PL_ALTRTR - Ack Latency Timer and Replay Timer Register
 * - HW_PCIE_PL_VSDR - Vendor Specific DLLP Register
 * - HW_PCIE_PL_PFLR - Port Force Link Register
 * - HW_PCIE_PL_AFLACR - Ack Frequency and L0-L1 ASPM Control Register
 * - HW_PCIE_PL_PLCR - Port Link Control Register
 * - HW_PCIE_PL_LSR - Lane Skew Register
 * - HW_PCIE_PL_SNR - Symbol Number Register
 * - HW_PCIE_PL_STRFM1 - Symbol Timer Register and Filter Mask Register 1
 * - HW_PCIE_PL_STRFM2 - Filter Mask Register 2
 * - HW_PCIE_PL_AMODNPSR - AMBA Multiple Outbound Decomposed NP Sub-Requests Control Register
 * - HW_PCIE_PL_DEBUG0 - Debug Register 0
 * - HW_PCIE_PL_DEBUG1 - Debug Register 1
 * - HW_PCIE_PL_TPFCSR - Transmit Posted FC Credit Status Register
 * - HW_PCIE_PL_TNFCSR - Transmit Non-Posted FC Credit Status Register
 * - HW_PCIE_PL_TCFCSR - Transmit Completion FC Credit Status Register
 * - HW_PCIE_PL_QSR - Queue Status Register
 * - HW_PCIE_PL_VCTAR1 - VC Transmit Arbitration Register 1
 * - HW_PCIE_PL_VCTAR2 - VC Transmit Arbitration Register 2
 * - HW_PCIE_PL_VC0PRQC - VC0 Posted Receive Queue Control
 * - HW_PCIE_PL_VC0NRQC - VC0 Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC0CRQC - VC0 Completion Receive Queue Control
 * - HW_PCIE_PL_VC1PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC1NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC1CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC2PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC2NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC2CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC3PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC3NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC3CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC4PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC4NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC4CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC5PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC5NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC5CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC6PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC6NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC6CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC7PRQC - VCn Posted Receive Queue Control
 * - HW_PCIE_PL_VC7NRQC - VCn Non-Posted Receive Queue Control
 * - HW_PCIE_PL_VC7CRQC - VCn Completion Receive Queue Control
 * - HW_PCIE_PL_VC0PBD - VC0 Posted Buffer Depth
 * - HW_PCIE_PL_VC0NPBD - VC0 Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC0CBD - VC0 Completion Buffer Depth
 * - HW_PCIE_PL_VC1PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC1NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC1CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC2PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC2NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC2CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC3PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC3NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC3CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC4PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC4NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC4CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC5PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC5NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC5CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC6PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC6NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC6CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_VC7PBD - VCn Posted Buffer Depth
 * - HW_PCIE_PL_VC7NPBD - VCn Non-Posted Buffer Depth
 * - HW_PCIE_PL_VC7CBD - VCn Completion Buffer Depth
 * - HW_PCIE_PL_G2CR - Gen2 Control Register
 * - HW_PCIE_PL_PHY_STATUS - PHY Status
 * - HW_PCIE_PL_PHY_CTRL - PHY Control
 * - HW_PCIE_PL_MRCCR0 - Master Response Composer Control Register 0
 * - HW_PCIE_PL_MRCCR1 - Master Response Composer Control Register 1
 * - HW_PCIE_PL_MSICA - MSI Controller Address
 * - HW_PCIE_PL_MSICUA - MSI Controller Upper Address
 * - HW_PCIE_PL_MSICI0_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI0_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI0_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI1_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI1_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI1_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI2_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI2_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI2_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI3_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI3_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI3_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI4_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI4_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI4_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI5_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI5_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI5_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI6_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI6_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI6_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICI7_ENB - MSI Controller Interrupt n Enable
 * - HW_PCIE_PL_MSICI7_MASK - MSI Controller Interrupt n Mask
 * - HW_PCIE_PL_MSICI7_STATUS - MSI Controller Interrupt n Status
 * - HW_PCIE_PL_MSICGPIO - MSI Controller General Purpose IO Register
 * - HW_PCIE_PL_iATUVR - iATU Viewport Register
 * - HW_PCIE_PL_iATURC1 - iATU Region Control 1 Register
 * - HW_PCIE_PL_iATURC2 - iATU Region Control 2 Register
 * - HW_PCIE_PL_iATURLBA - iATU Region Lower Base Address Register
 * - HW_PCIE_PL_iATURUBA - iATU Region Upper Base Address Register
 * - HW_PCIE_PL_iATURLA - iATU Region Limit Address Register
 * - HW_PCIE_PL_iATURLTA - iATU Region Lower Target Address Register
 * - HW_PCIE_PL_iATURUTA - iATU Region Upper Target Address Register
 *
 * - hw_pcie_pl_t - Struct containing all module registers.
 */

#define HW_PCIE_PL_INSTANCE_COUNT (1U) /*!< Number of instances of the PCIE_PL module. */
#define HW_PCIE_PL (0U) /*!< Instance number for PCIE_PL. */
#define PCIE_PL_BASE          (0x1FFC000U) /*!< Base address for PCIE_PL. */
/*! Array initializer of PCIE_PL base addresses. */
#define PCIE_PL_BASE_ADDRS    { PCIE_PL_BASE }

/*******************************************************************************
 * HW_PCIE_PL_ALTRTR - Ack Latency Timer and Replay Timer Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_ALTRTR - Ack Latency Timer and Replay Timer Register (RW)
 *
 * Reset value: 0x03B43677U
 *
 * Offset: 0x700
 */
typedef union _hw_pcie_pl_altrtr
{
    uint32_t U;
    struct _hw_pcie_pl_altrtr_bitfields
    {
        uint32_t Round_Trip_Latency_Time_Limit : 16; /*!< [15:0]  */
        uint32_t Replay_Time_Limit : 16; /*!< [31:16]  */
    } B;
} hw_pcie_pl_altrtr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_ALTRTR register
 */
/*@{*/
#define HW_PCIE_PL_ALTRTR_ADDR(x) ((uintptr_t)(x) + 0x700U)

#define HW_PCIE_PL_ALTRTR(x)     (*(__IO hw_pcie_pl_altrtr_t *) HW_PCIE_PL_ALTRTR_ADDR(x))
#define HW_PCIE_PL_ALTRTR_RD(x)  (HW_PCIE_PL_ALTRTR(x).U)
#define HW_PCIE_PL_ALTRTR_WR(x, v) (HW_PCIE_PL_ALTRTR(x).U = (v))
#define HW_PCIE_PL_ALTRTR_SET(x, v) (HW_PCIE_PL_ALTRTR_WR(x, HW_PCIE_PL_ALTRTR_RD(x) |  (v)))
#define HW_PCIE_PL_ALTRTR_CLR(x, v) (HW_PCIE_PL_ALTRTR_WR(x, HW_PCIE_PL_ALTRTR_RD(x) & ~(v)))
#define HW_PCIE_PL_ALTRTR_TOG(x, v) (HW_PCIE_PL_ALTRTR_WR(x, HW_PCIE_PL_ALTRTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_ALTRTR bitfields
 */

/*!
 * @name Register PCIE_PL_ALTRTR, field Round_Trip_Latency_Time_Limit[15:0] (RW)
 *
 * Round Trip Latency Time Limit The Ack/Nak latency timer expires when it
 * reaches this limit. The default value is 12429 / 2 = 5215. The default is then
 * updated based on the Negotiated Link Width and Max_Payload_Size. Note: If
 * operating at 5 Gb/s, then an additional 153 / 2 = 76 is added. This is for additional
 * internal processing for received TLPs and transmitted DLLPs.
 */
/*@{*/
#define BP_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit (0U) /*!< Bit position for PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit. */
#define BM_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit (0x0000FFFFU) /*!< Bit mask for PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit. */
#define BS_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit (16U) /*!< Bit field size in bits for PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit. */

/*! @brief Read current value of the PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit field. */
#define BR_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit(x) (HW_PCIE_PL_ALTRTR(x).B.Round_Trip_Latency_Time_Limit)

/*! @brief Format value for bitfield PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit. */
#define BF_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit) & BM_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit)

/*! @brief Set the Round_Trip_Latency_Time_Limit field to a new value. */
#define BW_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit(x, v) (HW_PCIE_PL_ALTRTR_WR(x, (HW_PCIE_PL_ALTRTR_RD(x) & ~BM_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit) | BF_PCIE_PL_ALTRTR_Round_Trip_Latency_Time_Limit(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_ALTRTR, field Replay_Time_Limit[31:16] (RW)
 *
 * Replay Time Limit The replay timer expires when it reaches this limit. The
 * core initiates a replay upon reception of a Nak or when the replay timer
 * expires. The default value is 4143 / 2 = 2071.. The default is then updated based on
 * the Negotiated Link Width and Max_Payload_Size. If operating at 5 Gb/s, then
 * an additional 51 / 2 = 26 is added. This is for additional internal processing
 * for received TLPs and transmitted DLLPs.
 */
/*@{*/
#define BP_PCIE_PL_ALTRTR_Replay_Time_Limit (16U) /*!< Bit position for PCIE_PL_ALTRTR_Replay_Time_Limit. */
#define BM_PCIE_PL_ALTRTR_Replay_Time_Limit (0xFFFF0000U) /*!< Bit mask for PCIE_PL_ALTRTR_Replay_Time_Limit. */
#define BS_PCIE_PL_ALTRTR_Replay_Time_Limit (16U) /*!< Bit field size in bits for PCIE_PL_ALTRTR_Replay_Time_Limit. */

/*! @brief Read current value of the PCIE_PL_ALTRTR_Replay_Time_Limit field. */
#define BR_PCIE_PL_ALTRTR_Replay_Time_Limit(x) (HW_PCIE_PL_ALTRTR(x).B.Replay_Time_Limit)

/*! @brief Format value for bitfield PCIE_PL_ALTRTR_Replay_Time_Limit. */
#define BF_PCIE_PL_ALTRTR_Replay_Time_Limit(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_ALTRTR_Replay_Time_Limit) & BM_PCIE_PL_ALTRTR_Replay_Time_Limit)

/*! @brief Set the Replay_Time_Limit field to a new value. */
#define BW_PCIE_PL_ALTRTR_Replay_Time_Limit(x, v) (HW_PCIE_PL_ALTRTR_WR(x, (HW_PCIE_PL_ALTRTR_RD(x) & ~BM_PCIE_PL_ALTRTR_Replay_Time_Limit) | BF_PCIE_PL_ALTRTR_Replay_Time_Limit(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VSDR - Vendor Specific DLLP Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VSDR - Vendor Specific DLLP Register (RW)
 *
 * Reset value: 0xFFFFFFFFU
 *
 * Offset: 0x700 + 0x4
 */
typedef union _hw_pcie_pl_vsdr
{
    uint32_t U;
    struct _hw_pcie_pl_vsdr_bitfields
    {
        uint32_t Vendor_Specific_DLLP : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_vsdr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VSDR register
 */
/*@{*/
#define HW_PCIE_PL_VSDR_ADDR(x)  ((uintptr_t)(x) + 0x704U)

#define HW_PCIE_PL_VSDR(x)       (*(__IO hw_pcie_pl_vsdr_t *) HW_PCIE_PL_VSDR_ADDR(x))
#define HW_PCIE_PL_VSDR_RD(x)    (HW_PCIE_PL_VSDR(x).U)
#define HW_PCIE_PL_VSDR_WR(x, v) (HW_PCIE_PL_VSDR(x).U = (v))
#define HW_PCIE_PL_VSDR_SET(x, v) (HW_PCIE_PL_VSDR_WR(x, HW_PCIE_PL_VSDR_RD(x) |  (v)))
#define HW_PCIE_PL_VSDR_CLR(x, v) (HW_PCIE_PL_VSDR_WR(x, HW_PCIE_PL_VSDR_RD(x) & ~(v)))
#define HW_PCIE_PL_VSDR_TOG(x, v) (HW_PCIE_PL_VSDR_WR(x, HW_PCIE_PL_VSDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VSDR bitfields
 */

/*!
 * @name Register PCIE_PL_VSDR, field Vendor_Specific_DLLP[31:0] (RW)
 *
 * Vendor Specific DLLP Register Used to send a specific PCI Express DLLP. The
 * application writes the 8-bit DLLP Type and 24-bits of Payload data into this
 * register, then sets bit 0 of PLCRPort Link Control Register to send the DLLP.
 */
/*@{*/
#define BP_PCIE_PL_VSDR_Vendor_Specific_DLLP (0U) /*!< Bit position for PCIE_PL_VSDR_Vendor_Specific_DLLP. */
#define BM_PCIE_PL_VSDR_Vendor_Specific_DLLP (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_VSDR_Vendor_Specific_DLLP. */
#define BS_PCIE_PL_VSDR_Vendor_Specific_DLLP (32U) /*!< Bit field size in bits for PCIE_PL_VSDR_Vendor_Specific_DLLP. */

/*! @brief Read current value of the PCIE_PL_VSDR_Vendor_Specific_DLLP field. */
#define BR_PCIE_PL_VSDR_Vendor_Specific_DLLP(x) (HW_PCIE_PL_VSDR(x).U)

/*! @brief Format value for bitfield PCIE_PL_VSDR_Vendor_Specific_DLLP. */
#define BF_PCIE_PL_VSDR_Vendor_Specific_DLLP(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VSDR_Vendor_Specific_DLLP) & BM_PCIE_PL_VSDR_Vendor_Specific_DLLP)

/*! @brief Set the Vendor_Specific_DLLP field to a new value. */
#define BW_PCIE_PL_VSDR_Vendor_Specific_DLLP(x, v) (HW_PCIE_PL_VSDR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_PFLR - Port Force Link Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_PFLR - Port Force Link Register (RW)
 *
 * Reset value: 0x07000004U
 *
 * Offset: 0x700 + 0x8
 */
typedef union _hw_pcie_pl_pflr
{
    uint32_t U;
    struct _hw_pcie_pl_pflr_bitfields
    {
        uint32_t Link_Number : 8;      /*!< [7:0]  */
        uint32_t RESERVED0 : 7;        /*!< [14:8]  */
        uint32_t Force_Link : 1;       /*!< [15]  */
        uint32_t Link_State : 6;       /*!< [21:16]  */
        uint32_t RESERVED1 : 2;        /*!< [23:22]  */
        uint32_t Low_Power_Entrance_Count : 8; /*!< [31:24]  */
    } B;
} hw_pcie_pl_pflr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_PFLR register
 */
/*@{*/
#define HW_PCIE_PL_PFLR_ADDR(x)  ((uintptr_t)(x) + 0x708U)

#define HW_PCIE_PL_PFLR(x)       (*(__IO hw_pcie_pl_pflr_t *) HW_PCIE_PL_PFLR_ADDR(x))
#define HW_PCIE_PL_PFLR_RD(x)    (HW_PCIE_PL_PFLR(x).U)
#define HW_PCIE_PL_PFLR_WR(x, v) (HW_PCIE_PL_PFLR(x).U = (v))
#define HW_PCIE_PL_PFLR_SET(x, v) (HW_PCIE_PL_PFLR_WR(x, HW_PCIE_PL_PFLR_RD(x) |  (v)))
#define HW_PCIE_PL_PFLR_CLR(x, v) (HW_PCIE_PL_PFLR_WR(x, HW_PCIE_PL_PFLR_RD(x) & ~(v)))
#define HW_PCIE_PL_PFLR_TOG(x, v) (HW_PCIE_PL_PFLR_WR(x, HW_PCIE_PL_PFLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_PFLR bitfields
 */

/*!
 * @name Register PCIE_PL_PFLR, field Link_Number[7:0] (RW)
 *
 * Link Number Not used for Endpoint
 */
/*@{*/
#define BP_PCIE_PL_PFLR_Link_Number (0U)   /*!< Bit position for PCIE_PL_PFLR_Link_Number. */
#define BM_PCIE_PL_PFLR_Link_Number (0x000000FFU) /*!< Bit mask for PCIE_PL_PFLR_Link_Number. */
#define BS_PCIE_PL_PFLR_Link_Number (8U)   /*!< Bit field size in bits for PCIE_PL_PFLR_Link_Number. */

/*! @brief Read current value of the PCIE_PL_PFLR_Link_Number field. */
#define BR_PCIE_PL_PFLR_Link_Number(x) (HW_PCIE_PL_PFLR(x).B.Link_Number)

/*! @brief Format value for bitfield PCIE_PL_PFLR_Link_Number. */
#define BF_PCIE_PL_PFLR_Link_Number(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PFLR_Link_Number) & BM_PCIE_PL_PFLR_Link_Number)

/*! @brief Set the Link_Number field to a new value. */
#define BW_PCIE_PL_PFLR_Link_Number(x, v) (HW_PCIE_PL_PFLR_WR(x, (HW_PCIE_PL_PFLR_RD(x) & ~BM_PCIE_PL_PFLR_Link_Number) | BF_PCIE_PL_PFLR_Link_Number(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PFLR, field Force_Link[15] (RW)
 *
 * Force Link Forces the Link to the state specified by the Link State field.
 * The Force Link pulse will trigger Link re-negotiation. * Reading from this
 * self-clearing register field always returns a 0.
 */
/*@{*/
#define BP_PCIE_PL_PFLR_Force_Link (15U)   /*!< Bit position for PCIE_PL_PFLR_Force_Link. */
#define BM_PCIE_PL_PFLR_Force_Link (0x00008000U) /*!< Bit mask for PCIE_PL_PFLR_Force_Link. */
#define BS_PCIE_PL_PFLR_Force_Link (1U)    /*!< Bit field size in bits for PCIE_PL_PFLR_Force_Link. */

/*! @brief Read current value of the PCIE_PL_PFLR_Force_Link field. */
#define BR_PCIE_PL_PFLR_Force_Link(x) (HW_PCIE_PL_PFLR(x).B.Force_Link)

/*! @brief Format value for bitfield PCIE_PL_PFLR_Force_Link. */
#define BF_PCIE_PL_PFLR_Force_Link(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PFLR_Force_Link) & BM_PCIE_PL_PFLR_Force_Link)

/*! @brief Set the Force_Link field to a new value. */
#define BW_PCIE_PL_PFLR_Force_Link(x, v) (HW_PCIE_PL_PFLR_WR(x, (HW_PCIE_PL_PFLR_RD(x) & ~BM_PCIE_PL_PFLR_Force_Link) | BF_PCIE_PL_PFLR_Force_Link(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PFLR, field Link_State[21:16] (RW)
 *
 * Link State The Link state that the core will be forced to when bit 15 (Force
 * Link) is set. State encoding is defined in xmlh_ltssm.v.
 */
/*@{*/
#define BP_PCIE_PL_PFLR_Link_State (16U)   /*!< Bit position for PCIE_PL_PFLR_Link_State. */
#define BM_PCIE_PL_PFLR_Link_State (0x003F0000U) /*!< Bit mask for PCIE_PL_PFLR_Link_State. */
#define BS_PCIE_PL_PFLR_Link_State (6U)    /*!< Bit field size in bits for PCIE_PL_PFLR_Link_State. */

/*! @brief Read current value of the PCIE_PL_PFLR_Link_State field. */
#define BR_PCIE_PL_PFLR_Link_State(x) (HW_PCIE_PL_PFLR(x).B.Link_State)

/*! @brief Format value for bitfield PCIE_PL_PFLR_Link_State. */
#define BF_PCIE_PL_PFLR_Link_State(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PFLR_Link_State) & BM_PCIE_PL_PFLR_Link_State)

/*! @brief Set the Link_State field to a new value. */
#define BW_PCIE_PL_PFLR_Link_State(x, v) (HW_PCIE_PL_PFLR_WR(x, (HW_PCIE_PL_PFLR_RD(x) & ~BM_PCIE_PL_PFLR_Link_State) | BF_PCIE_PL_PFLR_Link_State(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PFLR, field Low_Power_Entrance_Count[31:24] (RW)
 *
 * Low Power Entrance Count The Power Management state will wait for this many
 * clock cycles for the associated completion of a CfgWr to D-state register to go
 * low-power. This register is intended for applications that do not let the
 * core handle a completion for configuration request to the PMCSCR register. Note:
 * Only used in the DM core (in EP mode), EP core, and the upstream port of a
 * Switch.
 */
/*@{*/
#define BP_PCIE_PL_PFLR_Low_Power_Entrance_Count (24U) /*!< Bit position for PCIE_PL_PFLR_Low_Power_Entrance_Count. */
#define BM_PCIE_PL_PFLR_Low_Power_Entrance_Count (0xFF000000U) /*!< Bit mask for PCIE_PL_PFLR_Low_Power_Entrance_Count. */
#define BS_PCIE_PL_PFLR_Low_Power_Entrance_Count (8U) /*!< Bit field size in bits for PCIE_PL_PFLR_Low_Power_Entrance_Count. */

/*! @brief Read current value of the PCIE_PL_PFLR_Low_Power_Entrance_Count field. */
#define BR_PCIE_PL_PFLR_Low_Power_Entrance_Count(x) (HW_PCIE_PL_PFLR(x).B.Low_Power_Entrance_Count)

/*! @brief Format value for bitfield PCIE_PL_PFLR_Low_Power_Entrance_Count. */
#define BF_PCIE_PL_PFLR_Low_Power_Entrance_Count(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PFLR_Low_Power_Entrance_Count) & BM_PCIE_PL_PFLR_Low_Power_Entrance_Count)

/*! @brief Set the Low_Power_Entrance_Count field to a new value. */
#define BW_PCIE_PL_PFLR_Low_Power_Entrance_Count(x, v) (HW_PCIE_PL_PFLR_WR(x, (HW_PCIE_PL_PFLR_RD(x) & ~BM_PCIE_PL_PFLR_Low_Power_Entrance_Count) | BF_PCIE_PL_PFLR_Low_Power_Entrance_Count(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_AFLACR - Ack Frequency and L0-L1 ASPM Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_AFLACR - Ack Frequency and L0-L1 ASPM Control Register (RW)
 *
 * Reset value: 0x1B2C2C00U
 *
 * Offset: 0x700 + 0xC
 */
typedef union _hw_pcie_pl_aflacr
{
    uint32_t U;
    struct _hw_pcie_pl_aflacr_bitfields
    {
        uint32_t Ack_Frequency : 8;    /*!< [7:0]  */
        uint32_t N_FTS : 8;            /*!< [15:8]  */
        uint32_t Common_Clock_N_FTS : 8; /*!< [23:16]  */
        uint32_t L0s_Entrance_Latency : 3; /*!< [26:24]  */
        uint32_t L1_Entrance_Latency : 3; /*!< [29:27]  */
        uint32_t Enter_ASPM_L1 : 1;    /*!< [30]  */
        uint32_t RESERVED0 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_aflacr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_AFLACR register
 */
/*@{*/
#define HW_PCIE_PL_AFLACR_ADDR(x) ((uintptr_t)(x) + 0x70CU)

#define HW_PCIE_PL_AFLACR(x)     (*(__IO hw_pcie_pl_aflacr_t *) HW_PCIE_PL_AFLACR_ADDR(x))
#define HW_PCIE_PL_AFLACR_RD(x)  (HW_PCIE_PL_AFLACR(x).U)
#define HW_PCIE_PL_AFLACR_WR(x, v) (HW_PCIE_PL_AFLACR(x).U = (v))
#define HW_PCIE_PL_AFLACR_SET(x, v) (HW_PCIE_PL_AFLACR_WR(x, HW_PCIE_PL_AFLACR_RD(x) |  (v)))
#define HW_PCIE_PL_AFLACR_CLR(x, v) (HW_PCIE_PL_AFLACR_WR(x, HW_PCIE_PL_AFLACR_RD(x) & ~(v)))
#define HW_PCIE_PL_AFLACR_TOG(x, v) (HW_PCIE_PL_AFLACR_WR(x, HW_PCIE_PL_AFLACR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_AFLACR bitfields
 */

/*!
 * @name Register PCIE_PL_AFLACR, field Ack_Frequency[7:0] (RW)
 *
 * Ack Frequency The core accumulates the number of pending Ack's specified here
 * (up to 255) before sending an Ack DLLP see Link Layer: (Flow Control and
 * ACK/NAK DLLPs) for more details.
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_Ack_Frequency (0U) /*!< Bit position for PCIE_PL_AFLACR_Ack_Frequency. */
#define BM_PCIE_PL_AFLACR_Ack_Frequency (0x000000FFU) /*!< Bit mask for PCIE_PL_AFLACR_Ack_Frequency. */
#define BS_PCIE_PL_AFLACR_Ack_Frequency (8U) /*!< Bit field size in bits for PCIE_PL_AFLACR_Ack_Frequency. */

/*! @brief Read current value of the PCIE_PL_AFLACR_Ack_Frequency field. */
#define BR_PCIE_PL_AFLACR_Ack_Frequency(x) (HW_PCIE_PL_AFLACR(x).B.Ack_Frequency)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_Ack_Frequency. */
#define BF_PCIE_PL_AFLACR_Ack_Frequency(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_Ack_Frequency) & BM_PCIE_PL_AFLACR_Ack_Frequency)

/*! @brief Set the Ack_Frequency field to a new value. */
#define BW_PCIE_PL_AFLACR_Ack_Frequency(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_Ack_Frequency) | BF_PCIE_PL_AFLACR_Ack_Frequency(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_AFLACR, field N_FTS[15:8] (RW)
 *
 * N_FTS The number of Fast Training Sequence ordered sets to be transmitted
 * when transitioning from L0s to L0. The maximum number of FTS ordered-sets that a
 * component can request is 255. Note: The core does not support a value of zero;
 * a value of zero can cause the LTSSM to go into the recovery state when
 * exiting from L0s.
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_N_FTS (8U)       /*!< Bit position for PCIE_PL_AFLACR_N_FTS. */
#define BM_PCIE_PL_AFLACR_N_FTS (0x0000FF00U) /*!< Bit mask for PCIE_PL_AFLACR_N_FTS. */
#define BS_PCIE_PL_AFLACR_N_FTS (8U)       /*!< Bit field size in bits for PCIE_PL_AFLACR_N_FTS. */

/*! @brief Read current value of the PCIE_PL_AFLACR_N_FTS field. */
#define BR_PCIE_PL_AFLACR_N_FTS(x) (HW_PCIE_PL_AFLACR(x).B.N_FTS)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_N_FTS. */
#define BF_PCIE_PL_AFLACR_N_FTS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_N_FTS) & BM_PCIE_PL_AFLACR_N_FTS)

/*! @brief Set the N_FTS field to a new value. */
#define BW_PCIE_PL_AFLACR_N_FTS(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_N_FTS) | BF_PCIE_PL_AFLACR_N_FTS(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_AFLACR, field Common_Clock_N_FTS[23:16] (RW)
 *
 * Common Clock N_FTS This is the N_FTS when common clock is used. The number of
 * Fast Training Sequence ordered sets to be transmitted when transitioning from
 * L0s to L0. The maximum number of FTS ordered-sets that a component can
 * request is 255. This field is writable only if the parameters are selected as
 * follows during configuration of the core; CX_NFTS != CX_COMM_NFTS
 * DEFAULT_L0S_EXIT_LATENCY != DEFAULT_COMM_L0S_EXIT_LATENCY DEFAULT_L1_EXIT_LATENCY !=
 * DEFAULT_COMM_L1_EXIT_LATENCY otherwise, it will be hard coded to the value of the
 * CX_COMM_NFTS configuration parameter. Note: The core does not support a value of
 * zero; a value of zero can cause the LTSSM to go into the recovery state when
 * exiting from L0s.
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_Common_Clock_N_FTS (16U) /*!< Bit position for PCIE_PL_AFLACR_Common_Clock_N_FTS. */
#define BM_PCIE_PL_AFLACR_Common_Clock_N_FTS (0x00FF0000U) /*!< Bit mask for PCIE_PL_AFLACR_Common_Clock_N_FTS. */
#define BS_PCIE_PL_AFLACR_Common_Clock_N_FTS (8U) /*!< Bit field size in bits for PCIE_PL_AFLACR_Common_Clock_N_FTS. */

/*! @brief Read current value of the PCIE_PL_AFLACR_Common_Clock_N_FTS field. */
#define BR_PCIE_PL_AFLACR_Common_Clock_N_FTS(x) (HW_PCIE_PL_AFLACR(x).B.Common_Clock_N_FTS)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_Common_Clock_N_FTS. */
#define BF_PCIE_PL_AFLACR_Common_Clock_N_FTS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_Common_Clock_N_FTS) & BM_PCIE_PL_AFLACR_Common_Clock_N_FTS)

/*! @brief Set the Common_Clock_N_FTS field to a new value. */
#define BW_PCIE_PL_AFLACR_Common_Clock_N_FTS(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_Common_Clock_N_FTS) | BF_PCIE_PL_AFLACR_Common_Clock_N_FTS(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_AFLACR, field L0s_Entrance_Latency[26:24] (RW)
 *
 * L0s Entrance Latency Values correspond to:
 *
 * Values:
 * - 000 - 1 us
 * - 001 - 2 us
 * - 010 - 3 us
 * - 011 - 4 us
 * - 100 - 5 us
 * - 101 - 6 us
 * - 110 - 7 us
 * - 111 - 7 us
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_L0s_Entrance_Latency (24U) /*!< Bit position for PCIE_PL_AFLACR_L0s_Entrance_Latency. */
#define BM_PCIE_PL_AFLACR_L0s_Entrance_Latency (0x07000000U) /*!< Bit mask for PCIE_PL_AFLACR_L0s_Entrance_Latency. */
#define BS_PCIE_PL_AFLACR_L0s_Entrance_Latency (3U) /*!< Bit field size in bits for PCIE_PL_AFLACR_L0s_Entrance_Latency. */

/*! @brief Read current value of the PCIE_PL_AFLACR_L0s_Entrance_Latency field. */
#define BR_PCIE_PL_AFLACR_L0s_Entrance_Latency(x) (HW_PCIE_PL_AFLACR(x).B.L0s_Entrance_Latency)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_L0s_Entrance_Latency. */
#define BF_PCIE_PL_AFLACR_L0s_Entrance_Latency(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_L0s_Entrance_Latency) & BM_PCIE_PL_AFLACR_L0s_Entrance_Latency)

/*! @brief Set the L0s_Entrance_Latency field to a new value. */
#define BW_PCIE_PL_AFLACR_L0s_Entrance_Latency(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_L0s_Entrance_Latency) | BF_PCIE_PL_AFLACR_L0s_Entrance_Latency(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_AFLACR, field L1_Entrance_Latency[29:27] (RW)
 *
 * L1 Entrance Latency Values correspond to:
 *
 * Values:
 * - 000 - 1 us
 * - 001 - 2 us
 * - 010 - 4 us
 * - 011 - 8 us
 * - 100 - 16 us
 * - 101 - 32 us
 * - 110 - 64 us
 * - 111 - 64 us
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_L1_Entrance_Latency (27U) /*!< Bit position for PCIE_PL_AFLACR_L1_Entrance_Latency. */
#define BM_PCIE_PL_AFLACR_L1_Entrance_Latency (0x38000000U) /*!< Bit mask for PCIE_PL_AFLACR_L1_Entrance_Latency. */
#define BS_PCIE_PL_AFLACR_L1_Entrance_Latency (3U) /*!< Bit field size in bits for PCIE_PL_AFLACR_L1_Entrance_Latency. */

/*! @brief Read current value of the PCIE_PL_AFLACR_L1_Entrance_Latency field. */
#define BR_PCIE_PL_AFLACR_L1_Entrance_Latency(x) (HW_PCIE_PL_AFLACR(x).B.L1_Entrance_Latency)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_L1_Entrance_Latency. */
#define BF_PCIE_PL_AFLACR_L1_Entrance_Latency(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_L1_Entrance_Latency) & BM_PCIE_PL_AFLACR_L1_Entrance_Latency)

/*! @brief Set the L1_Entrance_Latency field to a new value. */
#define BW_PCIE_PL_AFLACR_L1_Entrance_Latency(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_L1_Entrance_Latency) | BF_PCIE_PL_AFLACR_L1_Entrance_Latency(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_AFLACR, field Enter_ASPM_L1[30] (RW)
 *
 * Enter ASPM L1 without receive in L0s. Allow core to enter ASPM L1 even when
 * link partner did not go to L0s (receive is not in L0s). When not set, core goes
 * to ASPM L1 only after idle period during which both receive and transmit are
 * in L0s.
 */
/*@{*/
#define BP_PCIE_PL_AFLACR_Enter_ASPM_L1 (30U) /*!< Bit position for PCIE_PL_AFLACR_Enter_ASPM_L1. */
#define BM_PCIE_PL_AFLACR_Enter_ASPM_L1 (0x40000000U) /*!< Bit mask for PCIE_PL_AFLACR_Enter_ASPM_L1. */
#define BS_PCIE_PL_AFLACR_Enter_ASPM_L1 (1U) /*!< Bit field size in bits for PCIE_PL_AFLACR_Enter_ASPM_L1. */

/*! @brief Read current value of the PCIE_PL_AFLACR_Enter_ASPM_L1 field. */
#define BR_PCIE_PL_AFLACR_Enter_ASPM_L1(x) (HW_PCIE_PL_AFLACR(x).B.Enter_ASPM_L1)

/*! @brief Format value for bitfield PCIE_PL_AFLACR_Enter_ASPM_L1. */
#define BF_PCIE_PL_AFLACR_Enter_ASPM_L1(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AFLACR_Enter_ASPM_L1) & BM_PCIE_PL_AFLACR_Enter_ASPM_L1)

/*! @brief Set the Enter_ASPM_L1 field to a new value. */
#define BW_PCIE_PL_AFLACR_Enter_ASPM_L1(x, v) (HW_PCIE_PL_AFLACR_WR(x, (HW_PCIE_PL_AFLACR_RD(x) & ~BM_PCIE_PL_AFLACR_Enter_ASPM_L1) | BF_PCIE_PL_AFLACR_Enter_ASPM_L1(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_PLCR - Port Link Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_PLCR - Port Link Control Register (RW)
 *
 * Reset value: 0x00010020U
 *
 * Offset: 0x700 + 0x10
 */
typedef union _hw_pcie_pl_plcr
{
    uint32_t U;
    struct _hw_pcie_pl_plcr_bitfields
    {
        uint32_t Vendor_Specific_DLLP_Request : 1; /*!< [0]  */
        uint32_t Scramble_Disable : 1; /*!< [1]  */
        uint32_t Loopback_Enable : 1;  /*!< [2]  */
        uint32_t Reset_Assert : 1;     /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t DLL_Link_Enable : 1;  /*!< [5]  */
        uint32_t RESERVED1 : 1;        /*!< [6]  */
        uint32_t Fast_Link_Mode : 1;   /*!< [7]  */
        uint32_t RESERVED2 : 8;        /*!< [15:8]  */
        uint32_t Link_Mode_Enable : 6; /*!< [21:16]  */
        uint32_t Crosslink_Enable : 1; /*!< [22]  */
        uint32_t Crosslink_Active : 1; /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_plcr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_PLCR register
 */
/*@{*/
#define HW_PCIE_PL_PLCR_ADDR(x)  ((uintptr_t)(x) + 0x710U)

#define HW_PCIE_PL_PLCR(x)       (*(__IO hw_pcie_pl_plcr_t *) HW_PCIE_PL_PLCR_ADDR(x))
#define HW_PCIE_PL_PLCR_RD(x)    (HW_PCIE_PL_PLCR(x).U)
#define HW_PCIE_PL_PLCR_WR(x, v) (HW_PCIE_PL_PLCR(x).U = (v))
#define HW_PCIE_PL_PLCR_SET(x, v) (HW_PCIE_PL_PLCR_WR(x, HW_PCIE_PL_PLCR_RD(x) |  (v)))
#define HW_PCIE_PL_PLCR_CLR(x, v) (HW_PCIE_PL_PLCR_WR(x, HW_PCIE_PL_PLCR_RD(x) & ~(v)))
#define HW_PCIE_PL_PLCR_TOG(x, v) (HW_PCIE_PL_PLCR_WR(x, HW_PCIE_PL_PLCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_PLCR bitfields
 */

/*!
 * @name Register PCIE_PL_PLCR, field Vendor_Specific_DLLP_Request[0] (RW)
 *
 * Vendor Specific DLLP Request When software writes a '1' to this bit, the core
 * transmits the DLLP contained in the VSDRVendor Specific DLLP Register . *
 * Reading from this self-clearing register field always returns a 0.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request (0U) /*!< Bit position for PCIE_PL_PLCR_Vendor_Specific_DLLP_Request. */
#define BM_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request (0x00000001U) /*!< Bit mask for PCIE_PL_PLCR_Vendor_Specific_DLLP_Request. */
#define BS_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Vendor_Specific_DLLP_Request. */

/*! @brief Read current value of the PCIE_PL_PLCR_Vendor_Specific_DLLP_Request field. */
#define BR_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request(x) (HW_PCIE_PL_PLCR(x).B.Vendor_Specific_DLLP_Request)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Vendor_Specific_DLLP_Request. */
#define BF_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request) & BM_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request)

/*! @brief Set the Vendor_Specific_DLLP_Request field to a new value. */
#define BW_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request) | BF_PCIE_PL_PLCR_Vendor_Specific_DLLP_Request(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Scramble_Disable[1] (RW)
 *
 * Scramble Disable Turns off data scrambling.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Scramble_Disable (1U) /*!< Bit position for PCIE_PL_PLCR_Scramble_Disable. */
#define BM_PCIE_PL_PLCR_Scramble_Disable (0x00000002U) /*!< Bit mask for PCIE_PL_PLCR_Scramble_Disable. */
#define BS_PCIE_PL_PLCR_Scramble_Disable (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Scramble_Disable. */

/*! @brief Read current value of the PCIE_PL_PLCR_Scramble_Disable field. */
#define BR_PCIE_PL_PLCR_Scramble_Disable(x) (HW_PCIE_PL_PLCR(x).B.Scramble_Disable)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Scramble_Disable. */
#define BF_PCIE_PL_PLCR_Scramble_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Scramble_Disable) & BM_PCIE_PL_PLCR_Scramble_Disable)

/*! @brief Set the Scramble_Disable field to a new value. */
#define BW_PCIE_PL_PLCR_Scramble_Disable(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Scramble_Disable) | BF_PCIE_PL_PLCR_Scramble_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Loopback_Enable[2] (RW)
 *
 * Loopback Enable Turns on loopback.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Loopback_Enable (2U) /*!< Bit position for PCIE_PL_PLCR_Loopback_Enable. */
#define BM_PCIE_PL_PLCR_Loopback_Enable (0x00000004U) /*!< Bit mask for PCIE_PL_PLCR_Loopback_Enable. */
#define BS_PCIE_PL_PLCR_Loopback_Enable (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Loopback_Enable. */

/*! @brief Read current value of the PCIE_PL_PLCR_Loopback_Enable field. */
#define BR_PCIE_PL_PLCR_Loopback_Enable(x) (HW_PCIE_PL_PLCR(x).B.Loopback_Enable)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Loopback_Enable. */
#define BF_PCIE_PL_PLCR_Loopback_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Loopback_Enable) & BM_PCIE_PL_PLCR_Loopback_Enable)

/*! @brief Set the Loopback_Enable field to a new value. */
#define BW_PCIE_PL_PLCR_Loopback_Enable(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Loopback_Enable) | BF_PCIE_PL_PLCR_Loopback_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Reset_Assert[3] (RW)
 *
 * Reset Assert Triggers a recovery and forces the LTSSM to the Hot Reset state
 * (downstream port only).
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Reset_Assert (3U)  /*!< Bit position for PCIE_PL_PLCR_Reset_Assert. */
#define BM_PCIE_PL_PLCR_Reset_Assert (0x00000008U) /*!< Bit mask for PCIE_PL_PLCR_Reset_Assert. */
#define BS_PCIE_PL_PLCR_Reset_Assert (1U)  /*!< Bit field size in bits for PCIE_PL_PLCR_Reset_Assert. */

/*! @brief Read current value of the PCIE_PL_PLCR_Reset_Assert field. */
#define BR_PCIE_PL_PLCR_Reset_Assert(x) (HW_PCIE_PL_PLCR(x).B.Reset_Assert)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Reset_Assert. */
#define BF_PCIE_PL_PLCR_Reset_Assert(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Reset_Assert) & BM_PCIE_PL_PLCR_Reset_Assert)

/*! @brief Set the Reset_Assert field to a new value. */
#define BW_PCIE_PL_PLCR_Reset_Assert(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Reset_Assert) | BF_PCIE_PL_PLCR_Reset_Assert(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field DLL_Link_Enable[5] (RW)
 *
 * DLL Link Enable Enables Link initialization. If DLL Link Enable = 0, the core
 * does not transmit InitFC DLLPs and does not establish a Link.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_DLL_Link_Enable (5U) /*!< Bit position for PCIE_PL_PLCR_DLL_Link_Enable. */
#define BM_PCIE_PL_PLCR_DLL_Link_Enable (0x00000020U) /*!< Bit mask for PCIE_PL_PLCR_DLL_Link_Enable. */
#define BS_PCIE_PL_PLCR_DLL_Link_Enable (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_DLL_Link_Enable. */

/*! @brief Read current value of the PCIE_PL_PLCR_DLL_Link_Enable field. */
#define BR_PCIE_PL_PLCR_DLL_Link_Enable(x) (HW_PCIE_PL_PLCR(x).B.DLL_Link_Enable)

/*! @brief Format value for bitfield PCIE_PL_PLCR_DLL_Link_Enable. */
#define BF_PCIE_PL_PLCR_DLL_Link_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_DLL_Link_Enable) & BM_PCIE_PL_PLCR_DLL_Link_Enable)

/*! @brief Set the DLL_Link_Enable field to a new value. */
#define BW_PCIE_PL_PLCR_DLL_Link_Enable(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_DLL_Link_Enable) | BF_PCIE_PL_PLCR_DLL_Link_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Fast_Link_Mode[7] (RW)
 *
 * Fast Link Mode Sets all internal timers to Fast Mode for speeding up
 * simulation. Forces the LTSSM training (link initialization) to use shorter time-outs
 * and to link up faster. The scaling factor is 1024 for all internal timers.
 * Note: Fast Link Mode can also be activated by setting the diag_ctrl_bus[2] pin to
 * '1'.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Fast_Link_Mode (7U) /*!< Bit position for PCIE_PL_PLCR_Fast_Link_Mode. */
#define BM_PCIE_PL_PLCR_Fast_Link_Mode (0x00000080U) /*!< Bit mask for PCIE_PL_PLCR_Fast_Link_Mode. */
#define BS_PCIE_PL_PLCR_Fast_Link_Mode (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Fast_Link_Mode. */

/*! @brief Read current value of the PCIE_PL_PLCR_Fast_Link_Mode field. */
#define BR_PCIE_PL_PLCR_Fast_Link_Mode(x) (HW_PCIE_PL_PLCR(x).B.Fast_Link_Mode)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Fast_Link_Mode. */
#define BF_PCIE_PL_PLCR_Fast_Link_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Fast_Link_Mode) & BM_PCIE_PL_PLCR_Fast_Link_Mode)

/*! @brief Set the Fast_Link_Mode field to a new value. */
#define BW_PCIE_PL_PLCR_Fast_Link_Mode(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Fast_Link_Mode) | BF_PCIE_PL_PLCR_Fast_Link_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Link_Mode_Enable[21:16] (RW)
 *
 * Link Mode Enable The default value is the number of Lanes supported in the
 * version of the core you are using.
 *
 * Values:
 * - 000001 - x1
 * - 000011 - x2
 * - 000111 - x4
 * - 001111 - x8
 * - 011111 - x16
 * - 111111 - x32 (not supported)
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Link_Mode_Enable (16U) /*!< Bit position for PCIE_PL_PLCR_Link_Mode_Enable. */
#define BM_PCIE_PL_PLCR_Link_Mode_Enable (0x003F0000U) /*!< Bit mask for PCIE_PL_PLCR_Link_Mode_Enable. */
#define BS_PCIE_PL_PLCR_Link_Mode_Enable (6U) /*!< Bit field size in bits for PCIE_PL_PLCR_Link_Mode_Enable. */

/*! @brief Read current value of the PCIE_PL_PLCR_Link_Mode_Enable field. */
#define BR_PCIE_PL_PLCR_Link_Mode_Enable(x) (HW_PCIE_PL_PLCR(x).B.Link_Mode_Enable)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Link_Mode_Enable. */
#define BF_PCIE_PL_PLCR_Link_Mode_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Link_Mode_Enable) & BM_PCIE_PL_PLCR_Link_Mode_Enable)

/*! @brief Set the Link_Mode_Enable field to a new value. */
#define BW_PCIE_PL_PLCR_Link_Mode_Enable(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Link_Mode_Enable) | BF_PCIE_PL_PLCR_Link_Mode_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Crosslink_Enable[22] (RW)
 *
 * Crosslink Enable
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Crosslink_Enable (22U) /*!< Bit position for PCIE_PL_PLCR_Crosslink_Enable. */
#define BM_PCIE_PL_PLCR_Crosslink_Enable (0x00400000U) /*!< Bit mask for PCIE_PL_PLCR_Crosslink_Enable. */
#define BS_PCIE_PL_PLCR_Crosslink_Enable (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Crosslink_Enable. */

/*! @brief Read current value of the PCIE_PL_PLCR_Crosslink_Enable field. */
#define BR_PCIE_PL_PLCR_Crosslink_Enable(x) (HW_PCIE_PL_PLCR(x).B.Crosslink_Enable)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Crosslink_Enable. */
#define BF_PCIE_PL_PLCR_Crosslink_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Crosslink_Enable) & BM_PCIE_PL_PLCR_Crosslink_Enable)

/*! @brief Set the Crosslink_Enable field to a new value. */
#define BW_PCIE_PL_PLCR_Crosslink_Enable(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Crosslink_Enable) | BF_PCIE_PL_PLCR_Crosslink_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_PLCR, field Crosslink_Active[23] (RW)
 *
 * Crosslink Active. Indicates a change from upstream to downstream or
 * downstream to upstream. Same as the xmlh_crosslink_active output.
 */
/*@{*/
#define BP_PCIE_PL_PLCR_Crosslink_Active (23U) /*!< Bit position for PCIE_PL_PLCR_Crosslink_Active. */
#define BM_PCIE_PL_PLCR_Crosslink_Active (0x00800000U) /*!< Bit mask for PCIE_PL_PLCR_Crosslink_Active. */
#define BS_PCIE_PL_PLCR_Crosslink_Active (1U) /*!< Bit field size in bits for PCIE_PL_PLCR_Crosslink_Active. */

/*! @brief Read current value of the PCIE_PL_PLCR_Crosslink_Active field. */
#define BR_PCIE_PL_PLCR_Crosslink_Active(x) (HW_PCIE_PL_PLCR(x).B.Crosslink_Active)

/*! @brief Format value for bitfield PCIE_PL_PLCR_Crosslink_Active. */
#define BF_PCIE_PL_PLCR_Crosslink_Active(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PLCR_Crosslink_Active) & BM_PCIE_PL_PLCR_Crosslink_Active)

/*! @brief Set the Crosslink_Active field to a new value. */
#define BW_PCIE_PL_PLCR_Crosslink_Active(x, v) (HW_PCIE_PL_PLCR_WR(x, (HW_PCIE_PL_PLCR_RD(x) & ~BM_PCIE_PL_PLCR_Crosslink_Active) | BF_PCIE_PL_PLCR_Crosslink_Active(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_LSR - Lane Skew Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_LSR - Lane Skew Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x14
 */
typedef union _hw_pcie_pl_lsr
{
    uint32_t U;
    struct _hw_pcie_pl_lsr_bitfields
    {
        uint32_t Insert_Lane_Skew_for_Transmit : 24; /*!< [23:0]  */
        uint32_t Flow_Control_Disable : 1; /*!< [24]  */
        uint32_t Ack_Nak_Disable : 1;  /*!< [25]  */
        uint32_t RESERVED0 : 5;        /*!< [30:26]  */
        uint32_t Disable_Lane_to_Lane_Deskew : 1; /*!< [31]  */
    } B;
} hw_pcie_pl_lsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_LSR register
 */
/*@{*/
#define HW_PCIE_PL_LSR_ADDR(x)   ((uintptr_t)(x) + 0x714U)

#define HW_PCIE_PL_LSR(x)        (*(__IO hw_pcie_pl_lsr_t *) HW_PCIE_PL_LSR_ADDR(x))
#define HW_PCIE_PL_LSR_RD(x)     (HW_PCIE_PL_LSR(x).U)
#define HW_PCIE_PL_LSR_WR(x, v)  (HW_PCIE_PL_LSR(x).U = (v))
#define HW_PCIE_PL_LSR_SET(x, v) (HW_PCIE_PL_LSR_WR(x, HW_PCIE_PL_LSR_RD(x) |  (v)))
#define HW_PCIE_PL_LSR_CLR(x, v) (HW_PCIE_PL_LSR_WR(x, HW_PCIE_PL_LSR_RD(x) & ~(v)))
#define HW_PCIE_PL_LSR_TOG(x, v) (HW_PCIE_PL_LSR_WR(x, HW_PCIE_PL_LSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_LSR bitfields
 */

/*!
 * @name Register PCIE_PL_LSR, field Insert_Lane_Skew_for_Transmit[23:0] (RW)
 *
 * Insert Lane Skew for Transmit (not supported for x16) Optional feature that
 * causes the core to insert skew between Lanes for test purposes. There are three
 * bits per Lane. The value is in units of one symbol time. For example, the
 * value 010b for a Lane forces a skew of two symbol times for that Lane. The
 * maximum skew value for any Lane is 5 symbol times.
 */
/*@{*/
#define BP_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit (0U) /*!< Bit position for PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit. */
#define BM_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit (0x00FFFFFFU) /*!< Bit mask for PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit. */
#define BS_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit (24U) /*!< Bit field size in bits for PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit. */

/*! @brief Read current value of the PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit field. */
#define BR_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit(x) (HW_PCIE_PL_LSR(x).B.Insert_Lane_Skew_for_Transmit)

/*! @brief Format value for bitfield PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit. */
#define BF_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit) & BM_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit)

/*! @brief Set the Insert_Lane_Skew_for_Transmit field to a new value. */
#define BW_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit(x, v) (HW_PCIE_PL_LSR_WR(x, (HW_PCIE_PL_LSR_RD(x) & ~BM_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit) | BF_PCIE_PL_LSR_Insert_Lane_Skew_for_Transmit(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_LSR, field Flow_Control_Disable[24] (RW)
 *
 * Flow Control Disable Prevents the core from sending FC DLLPs.
 */
/*@{*/
#define BP_PCIE_PL_LSR_Flow_Control_Disable (24U) /*!< Bit position for PCIE_PL_LSR_Flow_Control_Disable. */
#define BM_PCIE_PL_LSR_Flow_Control_Disable (0x01000000U) /*!< Bit mask for PCIE_PL_LSR_Flow_Control_Disable. */
#define BS_PCIE_PL_LSR_Flow_Control_Disable (1U) /*!< Bit field size in bits for PCIE_PL_LSR_Flow_Control_Disable. */

/*! @brief Read current value of the PCIE_PL_LSR_Flow_Control_Disable field. */
#define BR_PCIE_PL_LSR_Flow_Control_Disable(x) (HW_PCIE_PL_LSR(x).B.Flow_Control_Disable)

/*! @brief Format value for bitfield PCIE_PL_LSR_Flow_Control_Disable. */
#define BF_PCIE_PL_LSR_Flow_Control_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_LSR_Flow_Control_Disable) & BM_PCIE_PL_LSR_Flow_Control_Disable)

/*! @brief Set the Flow_Control_Disable field to a new value. */
#define BW_PCIE_PL_LSR_Flow_Control_Disable(x, v) (HW_PCIE_PL_LSR_WR(x, (HW_PCIE_PL_LSR_RD(x) & ~BM_PCIE_PL_LSR_Flow_Control_Disable) | BF_PCIE_PL_LSR_Flow_Control_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_LSR, field Ack_Nak_Disable[25] (RW)
 *
 * Ack/Nak Disable Prevents the core from sending Ack and Nak DLLPs.
 */
/*@{*/
#define BP_PCIE_PL_LSR_Ack_Nak_Disable (25U) /*!< Bit position for PCIE_PL_LSR_Ack_Nak_Disable. */
#define BM_PCIE_PL_LSR_Ack_Nak_Disable (0x02000000U) /*!< Bit mask for PCIE_PL_LSR_Ack_Nak_Disable. */
#define BS_PCIE_PL_LSR_Ack_Nak_Disable (1U) /*!< Bit field size in bits for PCIE_PL_LSR_Ack_Nak_Disable. */

/*! @brief Read current value of the PCIE_PL_LSR_Ack_Nak_Disable field. */
#define BR_PCIE_PL_LSR_Ack_Nak_Disable(x) (HW_PCIE_PL_LSR(x).B.Ack_Nak_Disable)

/*! @brief Format value for bitfield PCIE_PL_LSR_Ack_Nak_Disable. */
#define BF_PCIE_PL_LSR_Ack_Nak_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_LSR_Ack_Nak_Disable) & BM_PCIE_PL_LSR_Ack_Nak_Disable)

/*! @brief Set the Ack_Nak_Disable field to a new value. */
#define BW_PCIE_PL_LSR_Ack_Nak_Disable(x, v) (HW_PCIE_PL_LSR_WR(x, (HW_PCIE_PL_LSR_RD(x) & ~BM_PCIE_PL_LSR_Ack_Nak_Disable) | BF_PCIE_PL_LSR_Ack_Nak_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_LSR, field Disable_Lane_to_Lane_Deskew[31] (RW)
 *
 * Disable Lane-to-Lane Deskew Causes the core to disable the internal
 * Lane-to-Lane deskew logic.
 */
/*@{*/
#define BP_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew (31U) /*!< Bit position for PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew. */
#define BM_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew (0x80000000U) /*!< Bit mask for PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew. */
#define BS_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew (1U) /*!< Bit field size in bits for PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew. */

/*! @brief Read current value of the PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew field. */
#define BR_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew(x) (HW_PCIE_PL_LSR(x).B.Disable_Lane_to_Lane_Deskew)

/*! @brief Format value for bitfield PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew. */
#define BF_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew) & BM_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew)

/*! @brief Set the Disable_Lane_to_Lane_Deskew field to a new value. */
#define BW_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew(x, v) (HW_PCIE_PL_LSR_WR(x, (HW_PCIE_PL_LSR_RD(x) & ~BM_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew) | BF_PCIE_PL_LSR_Disable_Lane_to_Lane_Deskew(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_SNR - Symbol Number Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_SNR - Symbol Number Register (RW)
 *
 * Reset value: 0x0000830AU
 *
 * Offset: 0x700 + 0x18
 */
typedef union _hw_pcie_pl_snr
{
    uint32_t U;
    struct _hw_pcie_pl_snr_bitfields
    {
        uint32_t Number_of_TS_Symbols : 4; /*!< [3:0]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t Number_of_SKP_Symbols : 3; /*!< [10:8]  */
        uint32_t RESERVED1 : 3;        /*!< [13:11]  */
        uint32_t Timer_Modifier_for_Replay_Timer : 5; /*!< [18:14]  */
        uint32_t Timer_Modifier_for_Ack_Nak_Latency_Timer : 5; /*!< [23:19]
                                        * */
        uint32_t Timer_Modifier_for_Flow_Control_Watchdog_Timer : 5; /*!< [28:24]
                                        * */
        uint32_t Configuration_Requests : 3; /*!< [31:29]  */
    } B;
} hw_pcie_pl_snr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_SNR register
 */
/*@{*/
#define HW_PCIE_PL_SNR_ADDR(x)   ((uintptr_t)(x) + 0x718U)

#define HW_PCIE_PL_SNR(x)        (*(__IO hw_pcie_pl_snr_t *) HW_PCIE_PL_SNR_ADDR(x))
#define HW_PCIE_PL_SNR_RD(x)     (HW_PCIE_PL_SNR(x).U)
#define HW_PCIE_PL_SNR_WR(x, v)  (HW_PCIE_PL_SNR(x).U = (v))
#define HW_PCIE_PL_SNR_SET(x, v) (HW_PCIE_PL_SNR_WR(x, HW_PCIE_PL_SNR_RD(x) |  (v)))
#define HW_PCIE_PL_SNR_CLR(x, v) (HW_PCIE_PL_SNR_WR(x, HW_PCIE_PL_SNR_RD(x) & ~(v)))
#define HW_PCIE_PL_SNR_TOG(x, v) (HW_PCIE_PL_SNR_WR(x, HW_PCIE_PL_SNR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_SNR bitfields
 */

/*!
 * @name Register PCIE_PL_SNR, field Number_of_TS_Symbols[3:0] (RW)
 *
 * Number of TS Symbols Sets the number of TS identifier symbols that are sent
 * in TS1 and TS2 ordered sets.
 */
/*@{*/
#define BP_PCIE_PL_SNR_Number_of_TS_Symbols (0U) /*!< Bit position for PCIE_PL_SNR_Number_of_TS_Symbols. */
#define BM_PCIE_PL_SNR_Number_of_TS_Symbols (0x0000000FU) /*!< Bit mask for PCIE_PL_SNR_Number_of_TS_Symbols. */
#define BS_PCIE_PL_SNR_Number_of_TS_Symbols (4U) /*!< Bit field size in bits for PCIE_PL_SNR_Number_of_TS_Symbols. */

/*! @brief Read current value of the PCIE_PL_SNR_Number_of_TS_Symbols field. */
#define BR_PCIE_PL_SNR_Number_of_TS_Symbols(x) (HW_PCIE_PL_SNR(x).B.Number_of_TS_Symbols)

/*! @brief Format value for bitfield PCIE_PL_SNR_Number_of_TS_Symbols. */
#define BF_PCIE_PL_SNR_Number_of_TS_Symbols(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Number_of_TS_Symbols) & BM_PCIE_PL_SNR_Number_of_TS_Symbols)

/*! @brief Set the Number_of_TS_Symbols field to a new value. */
#define BW_PCIE_PL_SNR_Number_of_TS_Symbols(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Number_of_TS_Symbols) | BF_PCIE_PL_SNR_Number_of_TS_Symbols(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_SNR, field Number_of_SKP_Symbols[10:8] (RW)
 *
 * Number of SKP Symbols
 */
/*@{*/
#define BP_PCIE_PL_SNR_Number_of_SKP_Symbols (8U) /*!< Bit position for PCIE_PL_SNR_Number_of_SKP_Symbols. */
#define BM_PCIE_PL_SNR_Number_of_SKP_Symbols (0x00000700U) /*!< Bit mask for PCIE_PL_SNR_Number_of_SKP_Symbols. */
#define BS_PCIE_PL_SNR_Number_of_SKP_Symbols (3U) /*!< Bit field size in bits for PCIE_PL_SNR_Number_of_SKP_Symbols. */

/*! @brief Read current value of the PCIE_PL_SNR_Number_of_SKP_Symbols field. */
#define BR_PCIE_PL_SNR_Number_of_SKP_Symbols(x) (HW_PCIE_PL_SNR(x).B.Number_of_SKP_Symbols)

/*! @brief Format value for bitfield PCIE_PL_SNR_Number_of_SKP_Symbols. */
#define BF_PCIE_PL_SNR_Number_of_SKP_Symbols(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Number_of_SKP_Symbols) & BM_PCIE_PL_SNR_Number_of_SKP_Symbols)

/*! @brief Set the Number_of_SKP_Symbols field to a new value. */
#define BW_PCIE_PL_SNR_Number_of_SKP_Symbols(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Number_of_SKP_Symbols) | BF_PCIE_PL_SNR_Number_of_SKP_Symbols(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_SNR, field Timer_Modifier_for_Replay_Timer[18:14] (RW)
 *
 * Timer Modifier for Replay Timer Increases the timer value for the replay
 * timer, in increments of 64 clock cycles.
 */
/*@{*/
#define BP_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer (14U) /*!< Bit position for PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer. */
#define BM_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer (0x0007C000U) /*!< Bit mask for PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer. */
#define BS_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer (5U) /*!< Bit field size in bits for PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer. */

/*! @brief Read current value of the PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer field. */
#define BR_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer(x) (HW_PCIE_PL_SNR(x).B.Timer_Modifier_for_Replay_Timer)

/*! @brief Format value for bitfield PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer. */
#define BF_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer) & BM_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer)

/*! @brief Set the Timer_Modifier_for_Replay_Timer field to a new value. */
#define BW_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer) | BF_PCIE_PL_SNR_Timer_Modifier_for_Replay_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_SNR, field Timer_Modifier_for_Ack_Nak_Latency_Timer[23:19] (RW)
 *
 * Timer Modifier for Ack/Nak Latency Timer Increases the timer value for the
 * Ack/Nak latency timer, in increments of 64 clock cycles.
 */
/*@{*/
#define BP_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer (19U) /*!< Bit position for PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer. */
#define BM_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer (0x00F80000U) /*!< Bit mask for PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer. */
#define BS_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer (5U) /*!< Bit field size in bits for PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer. */

/*! @brief Read current value of the PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer field. */
#define BR_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer(x) (HW_PCIE_PL_SNR(x).B.Timer_Modifier_for_Ack_Nak_Latency_Timer)

/*! @brief Format value for bitfield PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer. */
#define BF_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer) & BM_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer)

/*! @brief Set the Timer_Modifier_for_Ack_Nak_Latency_Timer field to a new value. */
#define BW_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer) | BF_PCIE_PL_SNR_Timer_Modifier_for_Ack_Nak_Latency_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_SNR, field Timer_Modifier_for_Flow_Control_Watchdog_Timer[28:24] (RW)
 *
 * Timer Modifier for Flow Control Watchdog Timer Increases the timer value for
 * the Flow Control watchdog timer, in increments of 16 clock cycles.
 */
/*@{*/
#define BP_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer (24U) /*!< Bit position for PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer. */
#define BM_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer (0x1F000000U) /*!< Bit mask for PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer. */
#define BS_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer (5U) /*!< Bit field size in bits for PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer. */

/*! @brief Read current value of the PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer field. */
#define BR_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer(x) (HW_PCIE_PL_SNR(x).B.Timer_Modifier_for_Flow_Control_Watchdog_Timer)

/*! @brief Format value for bitfield PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer. */
#define BF_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer) & BM_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer)

/*! @brief Set the Timer_Modifier_for_Flow_Control_Watchdog_Timer field to a new value. */
#define BW_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer) | BF_PCIE_PL_SNR_Timer_Modifier_for_Flow_Control_Watchdog_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_SNR, field Configuration_Requests[31:29] (RW)
 *
 * Configuration Requests targeted at function numbers above this value will be
 * returned with UR (unsupported request).
 */
/*@{*/
#define BP_PCIE_PL_SNR_Configuration_Requests (29U) /*!< Bit position for PCIE_PL_SNR_Configuration_Requests. */
#define BM_PCIE_PL_SNR_Configuration_Requests (0xE0000000U) /*!< Bit mask for PCIE_PL_SNR_Configuration_Requests. */
#define BS_PCIE_PL_SNR_Configuration_Requests (3U) /*!< Bit field size in bits for PCIE_PL_SNR_Configuration_Requests. */

/*! @brief Read current value of the PCIE_PL_SNR_Configuration_Requests field. */
#define BR_PCIE_PL_SNR_Configuration_Requests(x) (HW_PCIE_PL_SNR(x).B.Configuration_Requests)

/*! @brief Format value for bitfield PCIE_PL_SNR_Configuration_Requests. */
#define BF_PCIE_PL_SNR_Configuration_Requests(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_SNR_Configuration_Requests) & BM_PCIE_PL_SNR_Configuration_Requests)

/*! @brief Set the Configuration_Requests field to a new value. */
#define BW_PCIE_PL_SNR_Configuration_Requests(x, v) (HW_PCIE_PL_SNR_WR(x, (HW_PCIE_PL_SNR_RD(x) & ~BM_PCIE_PL_SNR_Configuration_Requests) | BF_PCIE_PL_SNR_Configuration_Requests(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_STRFM1 - Symbol Timer Register and Filter Mask Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_STRFM1 - Symbol Timer Register and Filter Mask Register 1 (RW)
 *
 * Reset value: 0x00000640U
 *
 * Offset: 0x700 + 0x1C Filter Mask 1: Mask RADM Filtering and Error Handling
 * Rules Bits Name Name 31 CX_FLT_MASK_RC_CFG_DISCARD CX_FLT_MASK_RC_CFG_DISCARD 0
 * For RADM RC filter to not allow CFG transaction being received 1 For RADM RC
 * filter to allow CFG transaction being received 30 CX_FLT_MASK_RC_IO_DISCARD
 * CX_FLT_MASK_RC_IO_DISCARD 0 For RADM RC filter to not allow IO transaction being
 * received 1 For RADM RC filter to allow IO transaction being received 29
 * CX_FLT_MASK_MSG_DROP CX_FLT_MASK_MSG_DROP 0 Drop MSG TLP (except for Vendor MSG) 1
 * Do not Drop MSG (except for Vendor MSG) 28 CX_FLT_MASK_CPL_ECRC_DISCARD
 * CX_FLT_MASK_CPL_ECRC_DISCARD 0 Discard TLPs with ECRC errors for CPL type 1 Allow
 * TLPs with ECRC errors to be passed up for CPL type 27 CX_FLT_MASK_ECRC_DISCARD
 * CX_FLT_MASK_ECRC_DISCARD 0 Discard TLPs with ECRC errors 1 Allow TLPs with ECRC
 * errors to be passed up 26 CX_FLT_MASK_CPL_LEN_MATCH CX_FLT_MASK_CPL_LEN_MATCH
 * 0 Enforce length match for received CPL TLPs; a violation results in
 * cpl_abort, and possibly AER of unexp_cpl_err 1 MASK length match for received CPL TLPs
 * 25 CX_FLT_MASK_CPL_ATTR_MATCH CX_FLT_MASK_CPL_ATTR_MATCH 0 Enforce attribute
 * match for received CPL TLPs; a violation results in a malformed TLP error, and
 * possibly AER of unexp_cpl_err, cpl_rcvd_ur, cpl_rcvd_ca 1 Mask attribute match
 * for received CPL TLPs 24 CX_FLT_MASK_CPL_TC_MATCH CX_FLT_MASK_CPL_TC_MATCH 0
 * Enforce Traffic Class match for received CPL TLPs; a violation results in a
 * malformed TLP error, and possibly AER of unexp_cpl_err, cpl_rcvd_ur, cpl_rcvd_ca
 * 1 Mask Traffic Class match for received CPL TLPs 23
 * CX_FLT_MASK_CPL_FUNC_MATCH CX_FLT_MASK_CPL_FUNC_MATCH 0 Enforce function match for received CPL TLPs; a
 * violation results in cpl_abort, and possibly AER of unexp_cpl_err,
 * cpl_rcvd_ur, cpl_rcvd_ca 1 Mask function match for received CPL TLPs 22
 * CX_FLT_MASK_CPL_REQID_MATCH CX_FLT_MASK_CPL_REQID_MATCH 0 Enforce Req. Id match for received
 * CPL TLPs; a violation result in cpl_abort, and possibly AER of unexp_cpl_err,
 * cpl_rcvd_ur, cpl_rcvd_ca 1 Mask Req. Id match for received CPL TLPs 21
 * CX_FLT_MASK_CPL_TAGERR_MATCH CX_FLT_MASK_CPL_TAGERR_MATCH 0 Enforce Tag Error Rules
 * for received CPL TLPs; a violation result in cpl_abort, and possibly AER of
 * unexp_cpl_err, cpl_rcvd_ur, cpl_rcvd_ca 1 Mask Tag Error Rules for received CPL
 * TLPs 20 CX_FLT_MASK_LOCKED_RD_AS_UR CX_FLT_MASK_LOCKED_RD_AS_UR 0 Treat locked
 * Read TLPs as UR for EP; Supported for RC 1 Treat locked Read TLPs as Supported
 * for EP; UR for RC 19 CX_FLT_MASK_CFG_TYPE1_RE_AS_UR
 * CX_FLT_MASK_CFG_TYPE1_RE_AS_UR 0 Treat CFG type1 TLPs as UR for EP; Supported for RC 1 Treat CFG type1
 * TLPs as Supported for EP; UR for RC If CX_SRIOV_ENABLE is set then this bit is
 * set to allow the filter to process Type 1 Config requests if the EP consumes
 * more than one bus number. 18 CX_FLT_MASK_UR_OUTSIDE_BAR
 * CX_FLT_MASK_UR_OUTSIDE_BAR 0 Treat out-of-bar TLPs as UR 1 Treat out-of-bar TLPs as Supported
 * Requests 17 CX_FLT_MASK_UR_POIS CX_FLT_MASK_UR_POIS 0 Treat poisoned TLPs as UR 1
 * Treat poisoned TLPs as Supported Requests 16 CX_FLT_MASK_UR_FUNC_MISMATCH
 * CX_FLT_MASK_UR_FUNC_MISMATCH 0 Treat Function MisMatched TLPs as UR 1 Treat Function
 * MisMatched TLPs as Supported
 */
typedef union _hw_pcie_pl_strfm1
{
    uint32_t U;
    struct _hw_pcie_pl_strfm1_bitfields
    {
        uint32_t SKP_Interval_Value : 11; /*!< [10:0]  */
        uint32_t RESERVED0 : 4;        /*!< [14:11]  */
        uint32_t Disable_FC_Watchdog_Timer : 1; /*!< [15]  */
        uint32_t Mask_RADM_Filtering_and_Error_Handling_Rules : 16; /*!< [31:16]
                                        * */
    } B;
} hw_pcie_pl_strfm1_t;

/*!
 * @name Constants and macros for entire PCIE_PL_STRFM1 register
 */
/*@{*/
#define HW_PCIE_PL_STRFM1_ADDR(x) ((uintptr_t)(x) + 0x71CU)

#define HW_PCIE_PL_STRFM1(x)     (*(__IO hw_pcie_pl_strfm1_t *) HW_PCIE_PL_STRFM1_ADDR(x))
#define HW_PCIE_PL_STRFM1_RD(x)  (HW_PCIE_PL_STRFM1(x).U)
#define HW_PCIE_PL_STRFM1_WR(x, v) (HW_PCIE_PL_STRFM1(x).U = (v))
#define HW_PCIE_PL_STRFM1_SET(x, v) (HW_PCIE_PL_STRFM1_WR(x, HW_PCIE_PL_STRFM1_RD(x) |  (v)))
#define HW_PCIE_PL_STRFM1_CLR(x, v) (HW_PCIE_PL_STRFM1_WR(x, HW_PCIE_PL_STRFM1_RD(x) & ~(v)))
#define HW_PCIE_PL_STRFM1_TOG(x, v) (HW_PCIE_PL_STRFM1_WR(x, HW_PCIE_PL_STRFM1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_STRFM1 bitfields
 */

/*!
 * @name Register PCIE_PL_STRFM1, field SKP_Interval_Value[10:0] (RW)
 *
 * SKP Interval Value The number of symbol times to wait between transmitting
 * SKP ordered sets. Note that the core actually waits the number of symbol times
 * in this register plus 1 between transmitting SKP ordered sets. The application
 * must program this register accordingly. For example, if 1536 we're programmed
 * into this register (in a 250MHz core), then the core will actually transmit
 * Skp ordered sets once every 1537 symbol times. Also, the value programmed to
 * this register is actually clock ticks and not symbol times. In a 125MHz core,
 * programming the value programmed to this register should be scaled down by a
 * factor of 2 (since 1 clock tick=2 symbol times in this case).
 */
/*@{*/
#define BP_PCIE_PL_STRFM1_SKP_Interval_Value (0U) /*!< Bit position for PCIE_PL_STRFM1_SKP_Interval_Value. */
#define BM_PCIE_PL_STRFM1_SKP_Interval_Value (0x000007FFU) /*!< Bit mask for PCIE_PL_STRFM1_SKP_Interval_Value. */
#define BS_PCIE_PL_STRFM1_SKP_Interval_Value (11U) /*!< Bit field size in bits for PCIE_PL_STRFM1_SKP_Interval_Value. */

/*! @brief Read current value of the PCIE_PL_STRFM1_SKP_Interval_Value field. */
#define BR_PCIE_PL_STRFM1_SKP_Interval_Value(x) (HW_PCIE_PL_STRFM1(x).B.SKP_Interval_Value)

/*! @brief Format value for bitfield PCIE_PL_STRFM1_SKP_Interval_Value. */
#define BF_PCIE_PL_STRFM1_SKP_Interval_Value(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_STRFM1_SKP_Interval_Value) & BM_PCIE_PL_STRFM1_SKP_Interval_Value)

/*! @brief Set the SKP_Interval_Value field to a new value. */
#define BW_PCIE_PL_STRFM1_SKP_Interval_Value(x, v) (HW_PCIE_PL_STRFM1_WR(x, (HW_PCIE_PL_STRFM1_RD(x) & ~BM_PCIE_PL_STRFM1_SKP_Interval_Value) | BF_PCIE_PL_STRFM1_SKP_Interval_Value(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_STRFM1, field Disable_FC_Watchdog_Timer[15] (RW)
 *
 * Disable FC Watchdog Timer
 */
/*@{*/
#define BP_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer (15U) /*!< Bit position for PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer. */
#define BM_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer (0x00008000U) /*!< Bit mask for PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer. */
#define BS_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer (1U) /*!< Bit field size in bits for PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer. */

/*! @brief Read current value of the PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer field. */
#define BR_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer(x) (HW_PCIE_PL_STRFM1(x).B.Disable_FC_Watchdog_Timer)

/*! @brief Format value for bitfield PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer. */
#define BF_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer) & BM_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer)

/*! @brief Set the Disable_FC_Watchdog_Timer field to a new value. */
#define BW_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer(x, v) (HW_PCIE_PL_STRFM1_WR(x, (HW_PCIE_PL_STRFM1_RD(x) & ~BM_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer) | BF_PCIE_PL_STRFM1_Disable_FC_Watchdog_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_STRFM1, field Mask_RADM_Filtering_and_Error_Handling_Rules[31:16] (RW)
 *
 * Mask RADM Filtering and Error Handling Rules: Mask 1 There are several mask
 * bits to turn off the filtering and error handling rules In each case, 0 applies
 * the associated filtering rule and 1 masks the associated filtering rule. A
 * more detailed description for these bits is provided in Table 5-348. [31]: Mask
 * filtering of received Configuration Requests (RC mode only) [30]: Mask
 * filtering of received I/O Requests (RC mode only) [29]: Send Message TLPs to the
 * application on RTRGT1 and send decoded Message on the SII (1) or send decoded
 * Message on the SII, then drop the Message TLPs (0). The default value for this bit
 * is the inverse of `FLT_DROP_MSG. That is, if `FLT_DROP_MSG = 1, then the
 * default value of this bit is 0 (drop Message TLPs). Note that this bit only
 * controls message TLPs other than Vendor MSGs. Vendor MSGs are controlled by
 * STRFM2Filter Mask Register 2 , bits [1:0]. [28]: Mask ECRC error filtering for
 * Completions [27]: Mask ECRC error filtering [26]: Mask Length mismatch error for
 * received Completions [25]: Mask Attributes mismatch error for received Completions
 * [24]: Mask Traffic Class mismatch error for received Completions [23]: Mask
 * function mismatch error for received Completions [23]: Mask Requester ID
 * mismatch error for received Completions [21]: Mask Tag error rules for received
 * Completions [20]: Mask Locked Request filtering [19]: Mask Type 1 Configuration
 * Request filtering [18]: Mask BAR match filtering [17]: Mask poisoned TLP
 * filtering [16]: Mask function mismatch filtering for incoming Requests
 */
/*@{*/
#define BP_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules (16U) /*!< Bit position for PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BM_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules (0xFFFF0000U) /*!< Bit mask for PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BS_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules (16U) /*!< Bit field size in bits for PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules. */

/*! @brief Read current value of the PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules field. */
#define BR_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules(x) (HW_PCIE_PL_STRFM1(x).B.Mask_RADM_Filtering_and_Error_Handling_Rules)

/*! @brief Format value for bitfield PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BF_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules) & BM_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules)

/*! @brief Set the Mask_RADM_Filtering_and_Error_Handling_Rules field to a new value. */
#define BW_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules(x, v) (HW_PCIE_PL_STRFM1_WR(x, (HW_PCIE_PL_STRFM1_RD(x) & ~BM_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules) | BF_PCIE_PL_STRFM1_Mask_RADM_Filtering_and_Error_Handling_Rules(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_STRFM2 - Filter Mask Register 2
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_STRFM2 - Filter Mask Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x20
 */
typedef union _hw_pcie_pl_strfm2
{
    uint32_t U;
    struct _hw_pcie_pl_strfm2_bitfields
    {
        uint32_t Mask_RADM_Filtering_and_Error_Handling_Rules : 32; /*!< [31:0]
                                        * */
    } B;
} hw_pcie_pl_strfm2_t;

/*!
 * @name Constants and macros for entire PCIE_PL_STRFM2 register
 */
/*@{*/
#define HW_PCIE_PL_STRFM2_ADDR(x) ((uintptr_t)(x) + 0x720U)

#define HW_PCIE_PL_STRFM2(x)     (*(__IO hw_pcie_pl_strfm2_t *) HW_PCIE_PL_STRFM2_ADDR(x))
#define HW_PCIE_PL_STRFM2_RD(x)  (HW_PCIE_PL_STRFM2(x).U)
#define HW_PCIE_PL_STRFM2_WR(x, v) (HW_PCIE_PL_STRFM2(x).U = (v))
#define HW_PCIE_PL_STRFM2_SET(x, v) (HW_PCIE_PL_STRFM2_WR(x, HW_PCIE_PL_STRFM2_RD(x) |  (v)))
#define HW_PCIE_PL_STRFM2_CLR(x, v) (HW_PCIE_PL_STRFM2_WR(x, HW_PCIE_PL_STRFM2_RD(x) & ~(v)))
#define HW_PCIE_PL_STRFM2_TOG(x, v) (HW_PCIE_PL_STRFM2_WR(x, HW_PCIE_PL_STRFM2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_STRFM2 bitfields
 */

/*!
 * @name Register PCIE_PL_STRFM2, field Mask_RADM_Filtering_and_Error_Handling_Rules[31:0] (RW)
 *
 * Mask RADM Filtering and Error Handling Rules: Mask 2 It defaults to 0x0 There
 * are several mask bits used to turn off the filtering and error handling rules
 * . •[31:4]: Reserved •[3]: `CX_FLT_MASK_HANDLE_FLUSH - 0: Disable Core
 * Filter to handle flush request - 1: Enable Core Filter to handle flush request
 * •[2]: `CX_FLT_MASK_DABORT_4UCPL - 0: Enable DLLP abort for unexpected CPL - 1:
 * Do not enable DLLP abort for unexpected CPL •[1]: `CX_FLT_MASK_VENMSG1_DROP
 * - 0: Vendor MSG Type 1 dropped silently - 1: Vendor MSG Type 1 not dropped
 * •[0]: `CX_FLT_MASK_VENMSG0_DROP - 0: Vendor MSG Type 0 dropped with UR error
 * reporting - 1: Vendor MSG Type 0 not dropped
 */
/*@{*/
#define BP_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules (0U) /*!< Bit position for PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BM_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BS_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules (32U) /*!< Bit field size in bits for PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules. */

/*! @brief Read current value of the PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules field. */
#define BR_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules(x) (HW_PCIE_PL_STRFM2(x).U)

/*! @brief Format value for bitfield PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules. */
#define BF_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules) & BM_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules)

/*! @brief Set the Mask_RADM_Filtering_and_Error_Handling_Rules field to a new value. */
#define BW_PCIE_PL_STRFM2_Mask_RADM_Filtering_and_Error_Handling_Rules(x, v) (HW_PCIE_PL_STRFM2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_AMODNPSR - AMBA Multiple Outbound Decomposed NP Sub-Requests Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_AMODNPSR - AMBA Multiple Outbound Decomposed NP Sub-Requests Control Register (RW)
 *
 * Reset value: 0x00000001U
 *
 * Offset: 0x700 + 0x24
 */
typedef union _hw_pcie_pl_amodnpsr
{
    uint32_t U;
    struct _hw_pcie_pl_amodnpsr_bitfields
    {
        uint32_t Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests : 1; /*!< [0]
                                        * */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pcie_pl_amodnpsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_AMODNPSR register
 */
/*@{*/
#define HW_PCIE_PL_AMODNPSR_ADDR(x) ((uintptr_t)(x) + 0x724U)

#define HW_PCIE_PL_AMODNPSR(x)   (*(__IO hw_pcie_pl_amodnpsr_t *) HW_PCIE_PL_AMODNPSR_ADDR(x))
#define HW_PCIE_PL_AMODNPSR_RD(x) (HW_PCIE_PL_AMODNPSR(x).U)
#define HW_PCIE_PL_AMODNPSR_WR(x, v) (HW_PCIE_PL_AMODNPSR(x).U = (v))
#define HW_PCIE_PL_AMODNPSR_SET(x, v) (HW_PCIE_PL_AMODNPSR_WR(x, HW_PCIE_PL_AMODNPSR_RD(x) |  (v)))
#define HW_PCIE_PL_AMODNPSR_CLR(x, v) (HW_PCIE_PL_AMODNPSR_WR(x, HW_PCIE_PL_AMODNPSR_RD(x) & ~(v)))
#define HW_PCIE_PL_AMODNPSR_TOG(x, v) (HW_PCIE_PL_AMODNPSR_WR(x, HW_PCIE_PL_AMODNPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_AMODNPSR bitfields
 */

/*!
 * @name Register PCIE_PL_AMODNPSR, field Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests[0] (RW)
 *
 * Enable AMBA Multiple Outbound Decomposed NP Sub- Requests. This bit when set
 * to '0' disables the possibility of having multiple outstanding non-posted
 * requests that were derived from decomposition of an outbound AMBA request. See
 * Supported AXI Burst Operations for more details. You should not clear this
 * register unless your application master is requesting an amount of read data greater
 * than Max_Read_Request_Size, and the remote device (or switch) is reordering
 * completions that have different tags
 */
/*@{*/
#define BP_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests (0U) /*!< Bit position for PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests. */
#define BM_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests (0x00000001U) /*!< Bit mask for PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests. */
#define BS_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests (1U) /*!< Bit field size in bits for PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests. */

/*! @brief Read current value of the PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests field. */
#define BR_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests(x) (HW_PCIE_PL_AMODNPSR(x).B.Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests)

/*! @brief Format value for bitfield PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests. */
#define BF_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests) & BM_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests)

/*! @brief Set the Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests field to a new value. */
#define BW_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests(x, v) (HW_PCIE_PL_AMODNPSR_WR(x, (HW_PCIE_PL_AMODNPSR_RD(x) & ~BM_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests) | BF_PCIE_PL_AMODNPSR_Enable_AMBA_Multiple_Outbound_Decomposed_NP_SubRequests(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_DEBUG0 - Debug Register 0
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_DEBUG0 - Debug Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x28 [31:28]: rmlh_ts_link_ctrl Link control bits advertised
 * by link partner [27]: rmlh_ts_lane_num_is_k23 Currently receiving k237 (PAD)
 * in place of lane number [26]: rmlh_ts_link_num_is_k23 Currently receiving k237
 * (PAD) in place of link number [25]: rmlh_rcvd_idle[0] Receiver is receiving
 * logical idle [24]: rmlh_rcvd_idle[1] 2nd symbol is also idle (16bit PHY
 * interface only) [23:8]: mac_phy_txdata PIPE Transmit data [7:6]: mac_phy_txdatak PIPE
 * transmit K indication [5:0]: xmlh_ltssm_state LTSSM current state. See source
 * for encodings
 */
typedef union _hw_pcie_pl_debug0
{
    uint32_t U;
    struct _hw_pcie_pl_debug0_bitfields
    {
        uint32_t VALUE : 32;           /*!< [31:0]  */
    } B;
} hw_pcie_pl_debug0_t;

/*!
 * @name Constants and macros for entire PCIE_PL_DEBUG0 register
 */
/*@{*/
#define HW_PCIE_PL_DEBUG0_ADDR(x) ((uintptr_t)(x) + 0x728U)

#define HW_PCIE_PL_DEBUG0(x)     (*(__I hw_pcie_pl_debug0_t *) HW_PCIE_PL_DEBUG0_ADDR(x))
#define HW_PCIE_PL_DEBUG0_RD(x)  (HW_PCIE_PL_DEBUG0(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_DEBUG0 bitfields
 */

/*!
 * @name Register PCIE_PL_DEBUG0, field VALUE[31:0] (RO)
 *
 * The value on cxpl_debug_info[31:0].
 */
/*@{*/
#define BP_PCIE_PL_DEBUG0_VALUE (0U)       /*!< Bit position for PCIE_PL_DEBUG0_VALUE. */
#define BM_PCIE_PL_DEBUG0_VALUE (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_DEBUG0_VALUE. */
#define BS_PCIE_PL_DEBUG0_VALUE (32U)      /*!< Bit field size in bits for PCIE_PL_DEBUG0_VALUE. */

/*! @brief Read current value of the PCIE_PL_DEBUG0_VALUE field. */
#define BR_PCIE_PL_DEBUG0_VALUE(x) (HW_PCIE_PL_DEBUG0(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_DEBUG1 - Debug Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_DEBUG1 - Debug Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x2C [63]: xmlh_scrambler_disable Scrambling disabled for the
 * link [62]: xmlh_link_disable LTSSM in DISABLE state. Link inoperable [61]:
 * xmlh_link_in_training LTSSM performing link training [60]:
 * xmlh_rcvr_revrs_pol_en LTSSM testing for polarity reversal [59]: xmlh_training_rst_n
 * LTSSM-negotiated link reset [58:55]: 0000b Constant/reserved [54]: mac_phy_txdetectrx_loop
 * PIPE receiver detect/loopback request [53]: mac_phy_txelecidle[0] PIPE transmit
 * electrical idle request [52]: mac_phy_txcompliance[0] PIPE transmit
 * compliance request [51]: app_init_rst Application request to initiate training reset
 * [50:48]: 000b Constant/reserved [47:40]: rmlh_ts_link_num Link number
 * advertised/confirmed by link partner [39:38]: 00b Constant/reserved [37]:
 * xmtbyte_skip_sent A skip ordered set has been transmitted [36]: xmlh_link_up LTSSM reports
 * PHY link up [35]: rmlh_inskip_rcv Receiver reports skip reception [34]:
 * rmlh_ts1_rcvd TS1 training sequence received (pulse) [33]: rmlh_ts2_rcvd TS2 training
 * sequence received (pulse) [32]: rmlh_rcvd_lane_rev Receiver detected lane
 * reversal
 */
typedef union _hw_pcie_pl_debug1
{
    uint32_t U;
    struct _hw_pcie_pl_debug1_bitfields
    {
        uint32_t VALUE : 32;           /*!< [31:0]  */
    } B;
} hw_pcie_pl_debug1_t;

/*!
 * @name Constants and macros for entire PCIE_PL_DEBUG1 register
 */
/*@{*/
#define HW_PCIE_PL_DEBUG1_ADDR(x) ((uintptr_t)(x) + 0x72CU)

#define HW_PCIE_PL_DEBUG1(x)     (*(__I hw_pcie_pl_debug1_t *) HW_PCIE_PL_DEBUG1_ADDR(x))
#define HW_PCIE_PL_DEBUG1_RD(x)  (HW_PCIE_PL_DEBUG1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_DEBUG1 bitfields
 */

/*!
 * @name Register PCIE_PL_DEBUG1, field VALUE[31:0] (RO)
 *
 * The value on cxpl_debug_info[63:32].
 */
/*@{*/
#define BP_PCIE_PL_DEBUG1_VALUE (0U)       /*!< Bit position for PCIE_PL_DEBUG1_VALUE. */
#define BM_PCIE_PL_DEBUG1_VALUE (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_DEBUG1_VALUE. */
#define BS_PCIE_PL_DEBUG1_VALUE (32U)      /*!< Bit field size in bits for PCIE_PL_DEBUG1_VALUE. */

/*! @brief Read current value of the PCIE_PL_DEBUG1_VALUE field. */
#define BR_PCIE_PL_DEBUG1_VALUE(x) (HW_PCIE_PL_DEBUG1(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_TPFCSR - Transmit Posted FC Credit Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_TPFCSR - Transmit Posted FC Credit Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x30 *Default value depends on the number of advertised
 * credits for header and data {12'b0, xtlh_xadm_ph_cdts, xtlh_xadm_pd_cdts}; If the
 * number of advertised completion credits (both header and data) are infinite,
 * then the default would be {12'b0, 8'hFF, 12'hFFF}.
 */
typedef union _hw_pcie_pl_tpfcsr
{
    uint32_t U;
    struct _hw_pcie_pl_tpfcsr_bitfields
    {
        uint32_t Transmit_Posted_Data_FC_Credits : 12; /*!< [11:0]  */
        uint32_t Transmit_Posted_Header_FC_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_pcie_pl_tpfcsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_TPFCSR register
 */
/*@{*/
#define HW_PCIE_PL_TPFCSR_ADDR(x) ((uintptr_t)(x) + 0x730U)

#define HW_PCIE_PL_TPFCSR(x)     (*(__I hw_pcie_pl_tpfcsr_t *) HW_PCIE_PL_TPFCSR_ADDR(x))
#define HW_PCIE_PL_TPFCSR_RD(x)  (HW_PCIE_PL_TPFCSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_TPFCSR bitfields
 */

/*!
 * @name Register PCIE_PL_TPFCSR, field Transmit_Posted_Data_FC_Credits[11:0] (RO)
 *
 * Transmit Posted Data FC Credits The Posted Data credits advertised by the
 * receiver at the other end of the Link, updated with each UpdateFC DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits (0U) /*!< Bit position for PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits. */
#define BM_PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits. */
#define BS_PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits (12U) /*!< Bit field size in bits for PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits field. */
#define BR_PCIE_PL_TPFCSR_Transmit_Posted_Data_FC_Credits(x) (HW_PCIE_PL_TPFCSR(x).B.Transmit_Posted_Data_FC_Credits)
/*@}*/

/*!
 * @name Register PCIE_PL_TPFCSR, field Transmit_Posted_Header_FC_Credits[19:12] (RO)
 *
 * Transmit Posted Header FC Credits The Posted Header credits advertised by the
 * receiver at the other end of the Link, updated with each UpdateFC DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits (12U) /*!< Bit position for PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits. */
#define BM_PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits. */
#define BS_PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits (8U) /*!< Bit field size in bits for PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits field. */
#define BR_PCIE_PL_TPFCSR_Transmit_Posted_Header_FC_Credits(x) (HW_PCIE_PL_TPFCSR(x).B.Transmit_Posted_Header_FC_Credits)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_TNFCSR - Transmit Non-Posted FC Credit Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_TNFCSR - Transmit Non-Posted FC Credit Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x34 *Default value depends on the number of advertised
 * credits for header and data {12'b0, xtlh_xadm_nph_cdts, xtlh_xadm_npd_cdts}; If the
 * number of advertised completion credits (both header and data) are infinite,
 * then the default would be {12'b0, 8'hFF, 12'hFFF}.
 */
typedef union _hw_pcie_pl_tnfcsr
{
    uint32_t U;
    struct _hw_pcie_pl_tnfcsr_bitfields
    {
        uint32_t Transmit_Non_Posted_Data_FC_Credits : 12; /*!< [11:0]  */
        uint32_t Transmit_Non_Posted_Header_FC_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_pcie_pl_tnfcsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_TNFCSR register
 */
/*@{*/
#define HW_PCIE_PL_TNFCSR_ADDR(x) ((uintptr_t)(x) + 0x734U)

#define HW_PCIE_PL_TNFCSR(x)     (*(__I hw_pcie_pl_tnfcsr_t *) HW_PCIE_PL_TNFCSR_ADDR(x))
#define HW_PCIE_PL_TNFCSR_RD(x)  (HW_PCIE_PL_TNFCSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_TNFCSR bitfields
 */

/*!
 * @name Register PCIE_PL_TNFCSR, field Transmit_Non_Posted_Data_FC_Credits[11:0] (RO)
 *
 * Transmit Non-Posted Data FC Credits The Non-Posted Data credits advertised by
 * the receiver at the other end of the Link, updated with each UpdateFC DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits (0U) /*!< Bit position for PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits. */
#define BM_PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits. */
#define BS_PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits (12U) /*!< Bit field size in bits for PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits field. */
#define BR_PCIE_PL_TNFCSR_Transmit_Non_Posted_Data_FC_Credits(x) (HW_PCIE_PL_TNFCSR(x).B.Transmit_Non_Posted_Data_FC_Credits)
/*@}*/

/*!
 * @name Register PCIE_PL_TNFCSR, field Transmit_Non_Posted_Header_FC_Credits[19:12] (RO)
 *
 * Transmit Non-Posted Header FC Credits The Non-Posted Header credits
 * advertised by the receiver at the other end of the Link, updated with each UpdateFC
 * DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits (12U) /*!< Bit position for PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits. */
#define BM_PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits. */
#define BS_PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits (8U) /*!< Bit field size in bits for PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits field. */
#define BR_PCIE_PL_TNFCSR_Transmit_Non_Posted_Header_FC_Credits(x) (HW_PCIE_PL_TNFCSR(x).B.Transmit_Non_Posted_Header_FC_Credits)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_TCFCSR - Transmit Completion FC Credit Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_TCFCSR - Transmit Completion FC Credit Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x38 *Default value depends on the number of advertised
 * credits for header and data {12'b0, xtlh_xadm_cplh_cdts, xtlh_xadm_cpld_cdts}; If
 * the number of advertised completion credits (both header and data) are
 * infinite, then the default would be {12'b0, 8'hFF, 12'hFFF}.
 */
typedef union _hw_pcie_pl_tcfcsr
{
    uint32_t U;
    struct _hw_pcie_pl_tcfcsr_bitfields
    {
        uint32_t Transmit_Completion_Data_FC_Credits : 12; /*!< [11:0]  */
        uint32_t Transmit_Completion_Header_FC_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_pcie_pl_tcfcsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_TCFCSR register
 */
/*@{*/
#define HW_PCIE_PL_TCFCSR_ADDR(x) ((uintptr_t)(x) + 0x738U)

#define HW_PCIE_PL_TCFCSR(x)     (*(__I hw_pcie_pl_tcfcsr_t *) HW_PCIE_PL_TCFCSR_ADDR(x))
#define HW_PCIE_PL_TCFCSR_RD(x)  (HW_PCIE_PL_TCFCSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_TCFCSR bitfields
 */

/*!
 * @name Register PCIE_PL_TCFCSR, field Transmit_Completion_Data_FC_Credits[11:0] (RO)
 *
 * Transmit Completion Data FC Credits The Completion Data credits advertised by
 * the receiver at the other end of the Link, updated with each UpdateFC DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits (0U) /*!< Bit position for PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits. */
#define BM_PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits. */
#define BS_PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits (12U) /*!< Bit field size in bits for PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits field. */
#define BR_PCIE_PL_TCFCSR_Transmit_Completion_Data_FC_Credits(x) (HW_PCIE_PL_TCFCSR(x).B.Transmit_Completion_Data_FC_Credits)
/*@}*/

/*!
 * @name Register PCIE_PL_TCFCSR, field Transmit_Completion_Header_FC_Credits[19:12] (RO)
 *
 * Transmit Completion Header FC Credits The Completion Header credits
 * advertised by the receiver at the other end of the Link, updated with each UpdateFC
 * DLLP.
 */
/*@{*/
#define BP_PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits (12U) /*!< Bit position for PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits. */
#define BM_PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits. */
#define BS_PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits (8U) /*!< Bit field size in bits for PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits. */

/*! @brief Read current value of the PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits field. */
#define BR_PCIE_PL_TCFCSR_Transmit_Completion_Header_FC_Credits(x) (HW_PCIE_PL_TCFCSR(x).B.Transmit_Completion_Header_FC_Credits)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_QSR - Queue Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_QSR - Queue Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x3C
 */
typedef union _hw_pcie_pl_qsr
{
    uint32_t U;
    struct _hw_pcie_pl_qsr_bitfields
    {
        uint32_t Received_TLP_FC_Credits_Not_Returned : 1; /*!< [0]  */
        uint32_t Transmit_Retry_Buffer_Not_Empty : 1; /*!< [1]  */
        uint32_t Received_Queue_Not_Empty : 1; /*!< [2]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_pcie_pl_qsr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_QSR register
 */
/*@{*/
#define HW_PCIE_PL_QSR_ADDR(x)   ((uintptr_t)(x) + 0x73CU)

#define HW_PCIE_PL_QSR(x)        (*(__I hw_pcie_pl_qsr_t *) HW_PCIE_PL_QSR_ADDR(x))
#define HW_PCIE_PL_QSR_RD(x)     (HW_PCIE_PL_QSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_QSR bitfields
 */

/*!
 * @name Register PCIE_PL_QSR, field Received_TLP_FC_Credits_Not_Returned[0] (RO)
 *
 * Received TLP FC Credits Not Returned Indicates that the core has sent a TLP
 * but has not yet received an UpdateFC DLLP indicating that the credits for that
 * TLP have been restored by the receiver at the other end of the Link. Note:
 * This bit is for simulation only and will always be synthesized as 0.
 */
/*@{*/
#define BP_PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned (0U) /*!< Bit position for PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned. */
#define BM_PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned (0x00000001U) /*!< Bit mask for PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned. */
#define BS_PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned (1U) /*!< Bit field size in bits for PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned. */

/*! @brief Read current value of the PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned field. */
#define BR_PCIE_PL_QSR_Received_TLP_FC_Credits_Not_Returned(x) (HW_PCIE_PL_QSR(x).B.Received_TLP_FC_Credits_Not_Returned)
/*@}*/

/*!
 * @name Register PCIE_PL_QSR, field Transmit_Retry_Buffer_Not_Empty[1] (RO)
 *
 * Transmit Retry Buffer Not Empty Indicates that there is data in the transmit
 * retry buffer.
 */
/*@{*/
#define BP_PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty (1U) /*!< Bit position for PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty. */
#define BM_PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty (0x00000002U) /*!< Bit mask for PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty. */
#define BS_PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty (1U) /*!< Bit field size in bits for PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty. */

/*! @brief Read current value of the PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty field. */
#define BR_PCIE_PL_QSR_Transmit_Retry_Buffer_Not_Empty(x) (HW_PCIE_PL_QSR(x).B.Transmit_Retry_Buffer_Not_Empty)
/*@}*/

/*!
 * @name Register PCIE_PL_QSR, field Received_Queue_Not_Empty[2] (RO)
 *
 * Received Queue Not Empty Indicates there is data in one or more of the
 * receive buffers.
 */
/*@{*/
#define BP_PCIE_PL_QSR_Received_Queue_Not_Empty (2U) /*!< Bit position for PCIE_PL_QSR_Received_Queue_Not_Empty. */
#define BM_PCIE_PL_QSR_Received_Queue_Not_Empty (0x00000004U) /*!< Bit mask for PCIE_PL_QSR_Received_Queue_Not_Empty. */
#define BS_PCIE_PL_QSR_Received_Queue_Not_Empty (1U) /*!< Bit field size in bits for PCIE_PL_QSR_Received_Queue_Not_Empty. */

/*! @brief Read current value of the PCIE_PL_QSR_Received_Queue_Not_Empty field. */
#define BR_PCIE_PL_QSR_Received_Queue_Not_Empty(x) (HW_PCIE_PL_QSR(x).B.Received_Queue_Not_Empty)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VCTAR1 - VC Transmit Arbitration Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VCTAR1 - VC Transmit Arbitration Register 1 (RO)
 *
 * Reset value: 0x0000000FU
 *
 * Offset: 0x700 + 0x40 VC Transmit Arbitration Registers 1 and 2 specify the
 * weights assigned to VC0-VC7 to be used for WRR transmit arbitration for VCs in
 * the LPVC group. The following rules and restrictions apply regarding the values
 * programmed in VC Transmit Arbitration Registers 1 and 2: There are 8 bits
 * allocated for each weight value. No weight value for a VC in the LPVC group can
 * be less than 1. No weight value can be greater than the number of phases in the
 * selected arbitration scheme. The sum of the weights assigned to all VCs in
 * the LPVC group must equal the number of phases in the selected arbitration
 * scheme. For example, if 64-phase WRR arbitration is selected, the total of all WRR
 * Weight values for all VCs in the LPVC group must equal 64. Each of the VC
 * numbers listed in the bit field table is a VC ID, not the VC structure number. VC
 * Transmit Arbitration Registers 1 and 2 are hardwired to the default values set
 * by the configuration parameters listed in the Default columns of the bit
 * field table.
 */
typedef union _hw_pcie_pl_vctar1
{
    uint32_t U;
    struct _hw_pcie_pl_vctar1_bitfields
    {
        uint32_t WRR_Weight_for_VC0 : 8; /*!< [7:0]  */
        uint32_t WRR_Weight_for_VC1 : 8; /*!< [15:8]  */
        uint32_t WRR_Weight_for_VC2 : 8; /*!< [23:16]  */
        uint32_t WRR_Weight_for_VC3 : 8; /*!< [31:24]  */
    } B;
} hw_pcie_pl_vctar1_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VCTAR1 register
 */
/*@{*/
#define HW_PCIE_PL_VCTAR1_ADDR(x) ((uintptr_t)(x) + 0x740U)

#define HW_PCIE_PL_VCTAR1(x)     (*(__I hw_pcie_pl_vctar1_t *) HW_PCIE_PL_VCTAR1_ADDR(x))
#define HW_PCIE_PL_VCTAR1_RD(x)  (HW_PCIE_PL_VCTAR1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VCTAR1 bitfields
 */

/*!
 * @name Register PCIE_PL_VCTAR1, field WRR_Weight_for_VC0[7:0] (RO)
 *
 * WRR Weight for VC0
 */
/*@{*/
#define BP_PCIE_PL_VCTAR1_WRR_Weight_for_VC0 (0U) /*!< Bit position for PCIE_PL_VCTAR1_WRR_Weight_for_VC0. */
#define BM_PCIE_PL_VCTAR1_WRR_Weight_for_VC0 (0x000000FFU) /*!< Bit mask for PCIE_PL_VCTAR1_WRR_Weight_for_VC0. */
#define BS_PCIE_PL_VCTAR1_WRR_Weight_for_VC0 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR1_WRR_Weight_for_VC0. */

/*! @brief Read current value of the PCIE_PL_VCTAR1_WRR_Weight_for_VC0 field. */
#define BR_PCIE_PL_VCTAR1_WRR_Weight_for_VC0(x) (HW_PCIE_PL_VCTAR1(x).B.WRR_Weight_for_VC0)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR1, field WRR_Weight_for_VC1[15:8] (RO)
 *
 * WRR Weight for VC1
 */
/*@{*/
#define BP_PCIE_PL_VCTAR1_WRR_Weight_for_VC1 (8U) /*!< Bit position for PCIE_PL_VCTAR1_WRR_Weight_for_VC1. */
#define BM_PCIE_PL_VCTAR1_WRR_Weight_for_VC1 (0x0000FF00U) /*!< Bit mask for PCIE_PL_VCTAR1_WRR_Weight_for_VC1. */
#define BS_PCIE_PL_VCTAR1_WRR_Weight_for_VC1 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR1_WRR_Weight_for_VC1. */

/*! @brief Read current value of the PCIE_PL_VCTAR1_WRR_Weight_for_VC1 field. */
#define BR_PCIE_PL_VCTAR1_WRR_Weight_for_VC1(x) (HW_PCIE_PL_VCTAR1(x).B.WRR_Weight_for_VC1)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR1, field WRR_Weight_for_VC2[23:16] (RO)
 *
 * WRR Weight for VC2
 */
/*@{*/
#define BP_PCIE_PL_VCTAR1_WRR_Weight_for_VC2 (16U) /*!< Bit position for PCIE_PL_VCTAR1_WRR_Weight_for_VC2. */
#define BM_PCIE_PL_VCTAR1_WRR_Weight_for_VC2 (0x00FF0000U) /*!< Bit mask for PCIE_PL_VCTAR1_WRR_Weight_for_VC2. */
#define BS_PCIE_PL_VCTAR1_WRR_Weight_for_VC2 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR1_WRR_Weight_for_VC2. */

/*! @brief Read current value of the PCIE_PL_VCTAR1_WRR_Weight_for_VC2 field. */
#define BR_PCIE_PL_VCTAR1_WRR_Weight_for_VC2(x) (HW_PCIE_PL_VCTAR1(x).B.WRR_Weight_for_VC2)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR1, field WRR_Weight_for_VC3[31:24] (RO)
 *
 * WRR Weight for VC3
 */
/*@{*/
#define BP_PCIE_PL_VCTAR1_WRR_Weight_for_VC3 (24U) /*!< Bit position for PCIE_PL_VCTAR1_WRR_Weight_for_VC3. */
#define BM_PCIE_PL_VCTAR1_WRR_Weight_for_VC3 (0xFF000000U) /*!< Bit mask for PCIE_PL_VCTAR1_WRR_Weight_for_VC3. */
#define BS_PCIE_PL_VCTAR1_WRR_Weight_for_VC3 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR1_WRR_Weight_for_VC3. */

/*! @brief Read current value of the PCIE_PL_VCTAR1_WRR_Weight_for_VC3 field. */
#define BR_PCIE_PL_VCTAR1_WRR_Weight_for_VC3(x) (HW_PCIE_PL_VCTAR1(x).B.WRR_Weight_for_VC3)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VCTAR2 - VC Transmit Arbitration Register 2
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VCTAR2 - VC Transmit Arbitration Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x44 VC Transmit Arbitration Registers 1 and 2 specify the
 * weights assigned to VC0-VC7 to be used for WRR transmit arbitration for VCs in
 * the LPVC group. The following rules and restrictions apply regarding the values
 * programmed in VC Transmit Arbitration Registers 1 and 2: There are 8 bits
 * allocated for each weight value. No weight value for a VC in the LPVC group can
 * be less than 1. No weight value can be greater than the number of phases in the
 * selected arbitration scheme. The sum of the weights assigned to all VCs in
 * the LPVC group must equal the number of phases in the selected arbitration
 * scheme. For example, if 64-phase WRR arbitration is selected, the total of all WRR
 * Weight values for all VCs in the LPVC group must equal 64. Each of the VC
 * numbers listed in the bit field table is a VC ID, not the VC structure number. VC
 * Transmit Arbitration Registers 1 and 2 are hardwired to the default values set
 * by the configuration parameters listed in the Default columns of the bit
 * field table.
 */
typedef union _hw_pcie_pl_vctar2
{
    uint32_t U;
    struct _hw_pcie_pl_vctar2_bitfields
    {
        uint32_t WRR_Weight_for_VC4 : 8; /*!< [7:0]  */
        uint32_t WRR_Weight_for_VC5 : 8; /*!< [15:8]  */
        uint32_t WRR_Weight_for_VC6 : 8; /*!< [23:16]  */
        uint32_t WRR_Weight_for_VC7 : 8; /*!< [31:24]  */
    } B;
} hw_pcie_pl_vctar2_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VCTAR2 register
 */
/*@{*/
#define HW_PCIE_PL_VCTAR2_ADDR(x) ((uintptr_t)(x) + 0x744U)

#define HW_PCIE_PL_VCTAR2(x)     (*(__I hw_pcie_pl_vctar2_t *) HW_PCIE_PL_VCTAR2_ADDR(x))
#define HW_PCIE_PL_VCTAR2_RD(x)  (HW_PCIE_PL_VCTAR2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VCTAR2 bitfields
 */

/*!
 * @name Register PCIE_PL_VCTAR2, field WRR_Weight_for_VC4[7:0] (RO)
 *
 * WRR Weight for VC4
 */
/*@{*/
#define BP_PCIE_PL_VCTAR2_WRR_Weight_for_VC4 (0U) /*!< Bit position for PCIE_PL_VCTAR2_WRR_Weight_for_VC4. */
#define BM_PCIE_PL_VCTAR2_WRR_Weight_for_VC4 (0x000000FFU) /*!< Bit mask for PCIE_PL_VCTAR2_WRR_Weight_for_VC4. */
#define BS_PCIE_PL_VCTAR2_WRR_Weight_for_VC4 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR2_WRR_Weight_for_VC4. */

/*! @brief Read current value of the PCIE_PL_VCTAR2_WRR_Weight_for_VC4 field. */
#define BR_PCIE_PL_VCTAR2_WRR_Weight_for_VC4(x) (HW_PCIE_PL_VCTAR2(x).B.WRR_Weight_for_VC4)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR2, field WRR_Weight_for_VC5[15:8] (RO)
 *
 * WRR Weight for VC5
 */
/*@{*/
#define BP_PCIE_PL_VCTAR2_WRR_Weight_for_VC5 (8U) /*!< Bit position for PCIE_PL_VCTAR2_WRR_Weight_for_VC5. */
#define BM_PCIE_PL_VCTAR2_WRR_Weight_for_VC5 (0x0000FF00U) /*!< Bit mask for PCIE_PL_VCTAR2_WRR_Weight_for_VC5. */
#define BS_PCIE_PL_VCTAR2_WRR_Weight_for_VC5 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR2_WRR_Weight_for_VC5. */

/*! @brief Read current value of the PCIE_PL_VCTAR2_WRR_Weight_for_VC5 field. */
#define BR_PCIE_PL_VCTAR2_WRR_Weight_for_VC5(x) (HW_PCIE_PL_VCTAR2(x).B.WRR_Weight_for_VC5)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR2, field WRR_Weight_for_VC6[23:16] (RO)
 *
 * WRR Weight for VC6
 */
/*@{*/
#define BP_PCIE_PL_VCTAR2_WRR_Weight_for_VC6 (16U) /*!< Bit position for PCIE_PL_VCTAR2_WRR_Weight_for_VC6. */
#define BM_PCIE_PL_VCTAR2_WRR_Weight_for_VC6 (0x00FF0000U) /*!< Bit mask for PCIE_PL_VCTAR2_WRR_Weight_for_VC6. */
#define BS_PCIE_PL_VCTAR2_WRR_Weight_for_VC6 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR2_WRR_Weight_for_VC6. */

/*! @brief Read current value of the PCIE_PL_VCTAR2_WRR_Weight_for_VC6 field. */
#define BR_PCIE_PL_VCTAR2_WRR_Weight_for_VC6(x) (HW_PCIE_PL_VCTAR2(x).B.WRR_Weight_for_VC6)
/*@}*/

/*!
 * @name Register PCIE_PL_VCTAR2, field WRR_Weight_for_VC7[31:24] (RO)
 *
 * WRR Weight for VC7
 */
/*@{*/
#define BP_PCIE_PL_VCTAR2_WRR_Weight_for_VC7 (24U) /*!< Bit position for PCIE_PL_VCTAR2_WRR_Weight_for_VC7. */
#define BM_PCIE_PL_VCTAR2_WRR_Weight_for_VC7 (0xFF000000U) /*!< Bit mask for PCIE_PL_VCTAR2_WRR_Weight_for_VC7. */
#define BS_PCIE_PL_VCTAR2_WRR_Weight_for_VC7 (8U) /*!< Bit field size in bits for PCIE_PL_VCTAR2_WRR_Weight_for_VC7. */

/*! @brief Read current value of the PCIE_PL_VCTAR2_WRR_Weight_for_VC7 field. */
#define BR_PCIE_PL_VCTAR2_WRR_Weight_for_VC7(x) (HW_PCIE_PL_VCTAR2(x).B.WRR_Weight_for_VC7)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0PRQC - VC0 Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0PRQC - VC0 Posted Receive Queue Control (RW)
 *
 * Reset value: 0x0010C019U
 *
 * The data and header credits fields of the Receive Queue Control registers are
 * used in all receive buffer configurations. All other fields of the Receive
 * Queue Control and Depth registers are used only in the segmented- buffer
 * configuration. Offset: 0x700 + 0x48
 */
typedef union _hw_pcie_pl_vc0prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc0prqc_bitfields
    {
        uint32_t VC0_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VC0_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC0_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VC0 : 1; /*!< [30]  */
        uint32_t VC_Ordering_for_Receive_Queues : 1; /*!< [31]  */
    } B;
} hw_pcie_pl_vc0prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC0PRQC_ADDR(x) ((uintptr_t)(x) + 0x748U)

#define HW_PCIE_PL_VC0PRQC(x)    (*(__IO hw_pcie_pl_vc0prqc_t *) HW_PCIE_PL_VC0PRQC_ADDR(x))
#define HW_PCIE_PL_VC0PRQC_RD(x) (HW_PCIE_PL_VC0PRQC(x).U)
#define HW_PCIE_PL_VC0PRQC_WR(x, v) (HW_PCIE_PL_VC0PRQC(x).U = (v))
#define HW_PCIE_PL_VC0PRQC_SET(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, HW_PCIE_PL_VC0PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC0PRQC_CLR(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, HW_PCIE_PL_VC0PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC0PRQC_TOG(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, HW_PCIE_PL_VC0PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC0PRQC, field VC0_Posted_Data_Credits[11:0] (RW)
 *
 * VC0 Posted Data Credits The number of initial Posted data credits for VC0,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits. */
#define BM_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits. */
#define BS_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits(x) (HW_PCIE_PL_VC0PRQC(x).B.VC0_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits. */
#define BF_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits) & BM_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits)

/*! @brief Set the VC0_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, (HW_PCIE_PL_VC0PRQC_RD(x) & ~BM_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits) | BF_PCIE_PL_VC0PRQC_VC0_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0PRQC, field VC0_Posted_Header_Credits[19:12] (RW)
 *
 * VC0 Posted Header Credits The number of initial Posted header credits for
 * VC0, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits. */
#define BM_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits. */
#define BS_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits(x) (HW_PCIE_PL_VC0PRQC(x).B.VC0_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits. */
#define BF_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits) & BM_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits)

/*! @brief Set the VC0_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, (HW_PCIE_PL_VC0PRQC_RD(x) & ~BM_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits) | BF_PCIE_PL_VC0PRQC_VC0_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0PRQC, field VC0_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VC0 Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VC0, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC0PRQC(x).B.VC0_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode)

/*! @brief Set the VC0_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, (HW_PCIE_PL_VC0PRQC_RD(x) & ~BM_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC0PRQC_VC0_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0PRQC, field TLP_Type_Ordering_for_VC0[30] (RW)
 *
 * TLP Type Ordering for VC0 Determines the TLP type ordering rule for VC0
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI:
 *
 * Values:
 * - 1 - Ordering of received TLPs follows the rules in PCI Express 3.0
 *     Specification.
 * - 0 - Strict ordering for received TLPs: Posted, then Completion, then
 *     Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0 (30U) /*!< Bit position for PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0. */
#define BM_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0 (0x40000000U) /*!< Bit mask for PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0. */
#define BS_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0 (1U) /*!< Bit field size in bits for PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0. */

/*! @brief Read current value of the PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0 field. */
#define BR_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0(x) (HW_PCIE_PL_VC0PRQC(x).B.TLP_Type_Ordering_for_VC0)

/*! @brief Format value for bitfield PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0. */
#define BF_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0) & BM_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0)

/*! @brief Set the TLP_Type_Ordering_for_VC0 field to a new value. */
#define BW_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, (HW_PCIE_PL_VC0PRQC_RD(x) & ~BM_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0) | BF_PCIE_PL_VC0PRQC_TLP_Type_Ordering_for_VC0(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0PRQC, field VC_Ordering_for_Receive_Queues[31] (RW)
 *
 * VC Ordering for Receive Queues Determines the VC ordering rule for the
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI:
 *
 * Values:
 * - 1 - Strict ordering, higher numbered VCs have higher priority
 * - 0 - Round robin
 */
/*@{*/
#define BP_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues (31U) /*!< Bit position for PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues. */
#define BM_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues (0x80000000U) /*!< Bit mask for PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues. */
#define BS_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues (1U) /*!< Bit field size in bits for PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues. */

/*! @brief Read current value of the PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues field. */
#define BR_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues(x) (HW_PCIE_PL_VC0PRQC(x).B.VC_Ordering_for_Receive_Queues)

/*! @brief Format value for bitfield PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues. */
#define BF_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues) & BM_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues)

/*! @brief Set the VC_Ordering_for_Receive_Queues field to a new value. */
#define BW_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues(x, v) (HW_PCIE_PL_VC0PRQC_WR(x, (HW_PCIE_PL_VC0PRQC_RD(x) & ~BM_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues) | BF_PCIE_PL_VC0PRQC_VC_Ordering_for_Receive_Queues(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0NRQC - VC0 Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0NRQC - VC0 Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C
 */
typedef union _hw_pcie_pl_vc0nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc0nrqc_bitfields
    {
        uint32_t VC0_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VC0_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC0_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc0nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC0NRQC_ADDR(x) ((uintptr_t)(x) + 0x74CU)

#define HW_PCIE_PL_VC0NRQC(x)    (*(__IO hw_pcie_pl_vc0nrqc_t *) HW_PCIE_PL_VC0NRQC_ADDR(x))
#define HW_PCIE_PL_VC0NRQC_RD(x) (HW_PCIE_PL_VC0NRQC(x).U)
#define HW_PCIE_PL_VC0NRQC_WR(x, v) (HW_PCIE_PL_VC0NRQC(x).U = (v))
#define HW_PCIE_PL_VC0NRQC_SET(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, HW_PCIE_PL_VC0NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC0NRQC_CLR(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, HW_PCIE_PL_VC0NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC0NRQC_TOG(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, HW_PCIE_PL_VC0NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC0NRQC, field VC0_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VC0 Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VC0, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC0NRQC(x).B.VC0_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits) & BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits)

/*! @brief Set the VC0_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, (HW_PCIE_PL_VC0NRQC_RD(x) & ~BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits) | BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0NRQC, field VC0_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VC0 Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VC0, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC0NRQC(x).B.VC0_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits) & BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits)

/*! @brief Set the VC0_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, (HW_PCIE_PL_VC0NRQC_RD(x) & ~BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits) | BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0NRQC, field VC0_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VC0 Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VC0, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC0NRQC(x).B.VC0_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VC0_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC0NRQC_WR(x, (HW_PCIE_PL_VC0NRQC_RD(x) & ~BM_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC0NRQC_VC0_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0CRQC - VC0 Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0CRQC - VC0 Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50
 */
typedef union _hw_pcie_pl_vc0crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc0crqc_bitfields
    {
        uint32_t VC0_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VC0_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC0_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc0crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC0CRQC_ADDR(x) ((uintptr_t)(x) + 0x750U)

#define HW_PCIE_PL_VC0CRQC(x)    (*(__IO hw_pcie_pl_vc0crqc_t *) HW_PCIE_PL_VC0CRQC_ADDR(x))
#define HW_PCIE_PL_VC0CRQC_RD(x) (HW_PCIE_PL_VC0CRQC(x).U)
#define HW_PCIE_PL_VC0CRQC_WR(x, v) (HW_PCIE_PL_VC0CRQC(x).U = (v))
#define HW_PCIE_PL_VC0CRQC_SET(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, HW_PCIE_PL_VC0CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC0CRQC_CLR(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, HW_PCIE_PL_VC0CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC0CRQC_TOG(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, HW_PCIE_PL_VC0CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC0CRQC, field VC0_Completion_Data_Credits[11:0] (RW)
 *
 * VC0 Completion Data Credits The number of initial Completion data credits for
 * VC0, used for all receive queue buffer configurations. This field is not
 * writable through the DBI.
 */
/*@{*/
#define BP_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits. */
#define BM_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits. */
#define BS_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits(x) (HW_PCIE_PL_VC0CRQC(x).B.VC0_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits. */
#define BF_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits) & BM_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits)

/*! @brief Set the VC0_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, (HW_PCIE_PL_VC0CRQC_RD(x) & ~BM_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits) | BF_PCIE_PL_VC0CRQC_VC0_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0CRQC, field VC0_Completion_Header_Credits[19:12] (RW)
 *
 * VC0 Completion Header Credits The number of initial Completion header credits
 * for VC0, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits. */
#define BM_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits. */
#define BS_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits(x) (HW_PCIE_PL_VC0CRQC(x).B.VC0_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits. */
#define BF_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits) & BM_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits)

/*! @brief Set the VC0_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, (HW_PCIE_PL_VC0CRQC_RD(x) & ~BM_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits) | BF_PCIE_PL_VC0CRQC_VC0_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC0CRQC, field VC0_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VC0 Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VC0, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC0CRQC(x).B.VC0_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode)

/*! @brief Set the VC0_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC0CRQC_WR(x, (HW_PCIE_PL_VC0CRQC_RD(x) & ~BM_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC0CRQC_VC0_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc1prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc1prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC1PRQC_ADDR(x) ((uintptr_t)(x) + 0x754U)

#define HW_PCIE_PL_VC1PRQC(x)    (*(__IO hw_pcie_pl_vc1prqc_t *) HW_PCIE_PL_VC1PRQC_ADDR(x))
#define HW_PCIE_PL_VC1PRQC_RD(x) (HW_PCIE_PL_VC1PRQC(x).U)
#define HW_PCIE_PL_VC1PRQC_WR(x, v) (HW_PCIE_PL_VC1PRQC(x).U = (v))
#define HW_PCIE_PL_VC1PRQC_SET(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, HW_PCIE_PL_VC1PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC1PRQC_CLR(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, HW_PCIE_PL_VC1PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC1PRQC_TOG(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, HW_PCIE_PL_VC1PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC1PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC1PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, (HW_PCIE_PL_VC1PRQC_RD(x) & ~BM_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC1PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC1PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, (HW_PCIE_PL_VC1PRQC_RD(x) & ~BM_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC1PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC1PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, (HW_PCIE_PL_VC1PRQC_RD(x) & ~BM_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC1PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC1PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC1PRQC_WR(x, (HW_PCIE_PL_VC1PRQC_RD(x) & ~BM_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC1PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc1nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc1nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC1NRQC_ADDR(x) ((uintptr_t)(x) + 0x758U)

#define HW_PCIE_PL_VC1NRQC(x)    (*(__IO hw_pcie_pl_vc1nrqc_t *) HW_PCIE_PL_VC1NRQC_ADDR(x))
#define HW_PCIE_PL_VC1NRQC_RD(x) (HW_PCIE_PL_VC1NRQC(x).U)
#define HW_PCIE_PL_VC1NRQC_WR(x, v) (HW_PCIE_PL_VC1NRQC(x).U = (v))
#define HW_PCIE_PL_VC1NRQC_SET(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, HW_PCIE_PL_VC1NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC1NRQC_CLR(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, HW_PCIE_PL_VC1NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC1NRQC_TOG(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, HW_PCIE_PL_VC1NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC1NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC1NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, (HW_PCIE_PL_VC1NRQC_RD(x) & ~BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC1NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, (HW_PCIE_PL_VC1NRQC_RD(x) & ~BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC1NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC1NRQC_WR(x, (HW_PCIE_PL_VC1NRQC_RD(x) & ~BM_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC1NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc1crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc1crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC1CRQC_ADDR(x) ((uintptr_t)(x) + 0x75CU)

#define HW_PCIE_PL_VC1CRQC(x)    (*(__IO hw_pcie_pl_vc1crqc_t *) HW_PCIE_PL_VC1CRQC_ADDR(x))
#define HW_PCIE_PL_VC1CRQC_RD(x) (HW_PCIE_PL_VC1CRQC(x).U)
#define HW_PCIE_PL_VC1CRQC_WR(x, v) (HW_PCIE_PL_VC1CRQC(x).U = (v))
#define HW_PCIE_PL_VC1CRQC_SET(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, HW_PCIE_PL_VC1CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC1CRQC_CLR(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, HW_PCIE_PL_VC1CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC1CRQC_TOG(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, HW_PCIE_PL_VC1CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC1CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC1CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, (HW_PCIE_PL_VC1CRQC_RD(x) & ~BM_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC1CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC1CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, (HW_PCIE_PL_VC1CRQC_RD(x) & ~BM_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC1CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC1CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC1CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC1CRQC_WR(x, (HW_PCIE_PL_VC1CRQC_RD(x) & ~BM_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC1CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc2prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc2prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC2PRQC_ADDR(x) ((uintptr_t)(x) + 0x760U)

#define HW_PCIE_PL_VC2PRQC(x)    (*(__IO hw_pcie_pl_vc2prqc_t *) HW_PCIE_PL_VC2PRQC_ADDR(x))
#define HW_PCIE_PL_VC2PRQC_RD(x) (HW_PCIE_PL_VC2PRQC(x).U)
#define HW_PCIE_PL_VC2PRQC_WR(x, v) (HW_PCIE_PL_VC2PRQC(x).U = (v))
#define HW_PCIE_PL_VC2PRQC_SET(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, HW_PCIE_PL_VC2PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC2PRQC_CLR(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, HW_PCIE_PL_VC2PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC2PRQC_TOG(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, HW_PCIE_PL_VC2PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC2PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC2PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, (HW_PCIE_PL_VC2PRQC_RD(x) & ~BM_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC2PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC2PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, (HW_PCIE_PL_VC2PRQC_RD(x) & ~BM_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC2PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC2PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, (HW_PCIE_PL_VC2PRQC_RD(x) & ~BM_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC2PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC2PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC2PRQC_WR(x, (HW_PCIE_PL_VC2PRQC_RD(x) & ~BM_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC2PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc2nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc2nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC2NRQC_ADDR(x) ((uintptr_t)(x) + 0x764U)

#define HW_PCIE_PL_VC2NRQC(x)    (*(__IO hw_pcie_pl_vc2nrqc_t *) HW_PCIE_PL_VC2NRQC_ADDR(x))
#define HW_PCIE_PL_VC2NRQC_RD(x) (HW_PCIE_PL_VC2NRQC(x).U)
#define HW_PCIE_PL_VC2NRQC_WR(x, v) (HW_PCIE_PL_VC2NRQC(x).U = (v))
#define HW_PCIE_PL_VC2NRQC_SET(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, HW_PCIE_PL_VC2NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC2NRQC_CLR(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, HW_PCIE_PL_VC2NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC2NRQC_TOG(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, HW_PCIE_PL_VC2NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC2NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC2NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, (HW_PCIE_PL_VC2NRQC_RD(x) & ~BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC2NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, (HW_PCIE_PL_VC2NRQC_RD(x) & ~BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC2NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC2NRQC_WR(x, (HW_PCIE_PL_VC2NRQC_RD(x) & ~BM_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC2NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc2crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc2crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC2CRQC_ADDR(x) ((uintptr_t)(x) + 0x768U)

#define HW_PCIE_PL_VC2CRQC(x)    (*(__IO hw_pcie_pl_vc2crqc_t *) HW_PCIE_PL_VC2CRQC_ADDR(x))
#define HW_PCIE_PL_VC2CRQC_RD(x) (HW_PCIE_PL_VC2CRQC(x).U)
#define HW_PCIE_PL_VC2CRQC_WR(x, v) (HW_PCIE_PL_VC2CRQC(x).U = (v))
#define HW_PCIE_PL_VC2CRQC_SET(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, HW_PCIE_PL_VC2CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC2CRQC_CLR(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, HW_PCIE_PL_VC2CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC2CRQC_TOG(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, HW_PCIE_PL_VC2CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC2CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC2CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, (HW_PCIE_PL_VC2CRQC_RD(x) & ~BM_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC2CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC2CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, (HW_PCIE_PL_VC2CRQC_RD(x) & ~BM_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC2CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC2CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC2CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC2CRQC_WR(x, (HW_PCIE_PL_VC2CRQC_RD(x) & ~BM_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC2CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc3prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc3prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC3PRQC_ADDR(x) ((uintptr_t)(x) + 0x76CU)

#define HW_PCIE_PL_VC3PRQC(x)    (*(__IO hw_pcie_pl_vc3prqc_t *) HW_PCIE_PL_VC3PRQC_ADDR(x))
#define HW_PCIE_PL_VC3PRQC_RD(x) (HW_PCIE_PL_VC3PRQC(x).U)
#define HW_PCIE_PL_VC3PRQC_WR(x, v) (HW_PCIE_PL_VC3PRQC(x).U = (v))
#define HW_PCIE_PL_VC3PRQC_SET(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, HW_PCIE_PL_VC3PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC3PRQC_CLR(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, HW_PCIE_PL_VC3PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC3PRQC_TOG(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, HW_PCIE_PL_VC3PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC3PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC3PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, (HW_PCIE_PL_VC3PRQC_RD(x) & ~BM_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC3PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC3PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, (HW_PCIE_PL_VC3PRQC_RD(x) & ~BM_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC3PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC3PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, (HW_PCIE_PL_VC3PRQC_RD(x) & ~BM_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC3PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC3PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC3PRQC_WR(x, (HW_PCIE_PL_VC3PRQC_RD(x) & ~BM_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC3PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc3nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc3nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC3NRQC_ADDR(x) ((uintptr_t)(x) + 0x770U)

#define HW_PCIE_PL_VC3NRQC(x)    (*(__IO hw_pcie_pl_vc3nrqc_t *) HW_PCIE_PL_VC3NRQC_ADDR(x))
#define HW_PCIE_PL_VC3NRQC_RD(x) (HW_PCIE_PL_VC3NRQC(x).U)
#define HW_PCIE_PL_VC3NRQC_WR(x, v) (HW_PCIE_PL_VC3NRQC(x).U = (v))
#define HW_PCIE_PL_VC3NRQC_SET(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, HW_PCIE_PL_VC3NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC3NRQC_CLR(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, HW_PCIE_PL_VC3NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC3NRQC_TOG(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, HW_PCIE_PL_VC3NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC3NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC3NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, (HW_PCIE_PL_VC3NRQC_RD(x) & ~BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC3NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, (HW_PCIE_PL_VC3NRQC_RD(x) & ~BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC3NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC3NRQC_WR(x, (HW_PCIE_PL_VC3NRQC_RD(x) & ~BM_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC3NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc3crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc3crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC3CRQC_ADDR(x) ((uintptr_t)(x) + 0x774U)

#define HW_PCIE_PL_VC3CRQC(x)    (*(__IO hw_pcie_pl_vc3crqc_t *) HW_PCIE_PL_VC3CRQC_ADDR(x))
#define HW_PCIE_PL_VC3CRQC_RD(x) (HW_PCIE_PL_VC3CRQC(x).U)
#define HW_PCIE_PL_VC3CRQC_WR(x, v) (HW_PCIE_PL_VC3CRQC(x).U = (v))
#define HW_PCIE_PL_VC3CRQC_SET(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, HW_PCIE_PL_VC3CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC3CRQC_CLR(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, HW_PCIE_PL_VC3CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC3CRQC_TOG(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, HW_PCIE_PL_VC3CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC3CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC3CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, (HW_PCIE_PL_VC3CRQC_RD(x) & ~BM_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC3CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC3CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, (HW_PCIE_PL_VC3CRQC_RD(x) & ~BM_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC3CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC3CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC3CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC3CRQC_WR(x, (HW_PCIE_PL_VC3CRQC_RD(x) & ~BM_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC3CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc4prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc4prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC4PRQC_ADDR(x) ((uintptr_t)(x) + 0x778U)

#define HW_PCIE_PL_VC4PRQC(x)    (*(__IO hw_pcie_pl_vc4prqc_t *) HW_PCIE_PL_VC4PRQC_ADDR(x))
#define HW_PCIE_PL_VC4PRQC_RD(x) (HW_PCIE_PL_VC4PRQC(x).U)
#define HW_PCIE_PL_VC4PRQC_WR(x, v) (HW_PCIE_PL_VC4PRQC(x).U = (v))
#define HW_PCIE_PL_VC4PRQC_SET(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, HW_PCIE_PL_VC4PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC4PRQC_CLR(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, HW_PCIE_PL_VC4PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC4PRQC_TOG(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, HW_PCIE_PL_VC4PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC4PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC4PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, (HW_PCIE_PL_VC4PRQC_RD(x) & ~BM_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC4PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC4PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, (HW_PCIE_PL_VC4PRQC_RD(x) & ~BM_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC4PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC4PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, (HW_PCIE_PL_VC4PRQC_RD(x) & ~BM_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC4PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC4PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC4PRQC_WR(x, (HW_PCIE_PL_VC4PRQC_RD(x) & ~BM_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC4PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc4nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc4nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC4NRQC_ADDR(x) ((uintptr_t)(x) + 0x77CU)

#define HW_PCIE_PL_VC4NRQC(x)    (*(__IO hw_pcie_pl_vc4nrqc_t *) HW_PCIE_PL_VC4NRQC_ADDR(x))
#define HW_PCIE_PL_VC4NRQC_RD(x) (HW_PCIE_PL_VC4NRQC(x).U)
#define HW_PCIE_PL_VC4NRQC_WR(x, v) (HW_PCIE_PL_VC4NRQC(x).U = (v))
#define HW_PCIE_PL_VC4NRQC_SET(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, HW_PCIE_PL_VC4NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC4NRQC_CLR(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, HW_PCIE_PL_VC4NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC4NRQC_TOG(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, HW_PCIE_PL_VC4NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC4NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC4NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, (HW_PCIE_PL_VC4NRQC_RD(x) & ~BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC4NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, (HW_PCIE_PL_VC4NRQC_RD(x) & ~BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC4NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC4NRQC_WR(x, (HW_PCIE_PL_VC4NRQC_RD(x) & ~BM_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC4NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc4crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc4crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC4CRQC_ADDR(x) ((uintptr_t)(x) + 0x780U)

#define HW_PCIE_PL_VC4CRQC(x)    (*(__IO hw_pcie_pl_vc4crqc_t *) HW_PCIE_PL_VC4CRQC_ADDR(x))
#define HW_PCIE_PL_VC4CRQC_RD(x) (HW_PCIE_PL_VC4CRQC(x).U)
#define HW_PCIE_PL_VC4CRQC_WR(x, v) (HW_PCIE_PL_VC4CRQC(x).U = (v))
#define HW_PCIE_PL_VC4CRQC_SET(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, HW_PCIE_PL_VC4CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC4CRQC_CLR(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, HW_PCIE_PL_VC4CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC4CRQC_TOG(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, HW_PCIE_PL_VC4CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC4CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC4CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, (HW_PCIE_PL_VC4CRQC_RD(x) & ~BM_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC4CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC4CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, (HW_PCIE_PL_VC4CRQC_RD(x) & ~BM_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC4CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC4CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC4CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC4CRQC_WR(x, (HW_PCIE_PL_VC4CRQC_RD(x) & ~BM_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC4CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc5prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc5prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC5PRQC_ADDR(x) ((uintptr_t)(x) + 0x784U)

#define HW_PCIE_PL_VC5PRQC(x)    (*(__IO hw_pcie_pl_vc5prqc_t *) HW_PCIE_PL_VC5PRQC_ADDR(x))
#define HW_PCIE_PL_VC5PRQC_RD(x) (HW_PCIE_PL_VC5PRQC(x).U)
#define HW_PCIE_PL_VC5PRQC_WR(x, v) (HW_PCIE_PL_VC5PRQC(x).U = (v))
#define HW_PCIE_PL_VC5PRQC_SET(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, HW_PCIE_PL_VC5PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC5PRQC_CLR(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, HW_PCIE_PL_VC5PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC5PRQC_TOG(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, HW_PCIE_PL_VC5PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC5PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC5PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, (HW_PCIE_PL_VC5PRQC_RD(x) & ~BM_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC5PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC5PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, (HW_PCIE_PL_VC5PRQC_RD(x) & ~BM_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC5PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC5PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, (HW_PCIE_PL_VC5PRQC_RD(x) & ~BM_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC5PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC5PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC5PRQC_WR(x, (HW_PCIE_PL_VC5PRQC_RD(x) & ~BM_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC5PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc5nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc5nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC5NRQC_ADDR(x) ((uintptr_t)(x) + 0x788U)

#define HW_PCIE_PL_VC5NRQC(x)    (*(__IO hw_pcie_pl_vc5nrqc_t *) HW_PCIE_PL_VC5NRQC_ADDR(x))
#define HW_PCIE_PL_VC5NRQC_RD(x) (HW_PCIE_PL_VC5NRQC(x).U)
#define HW_PCIE_PL_VC5NRQC_WR(x, v) (HW_PCIE_PL_VC5NRQC(x).U = (v))
#define HW_PCIE_PL_VC5NRQC_SET(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, HW_PCIE_PL_VC5NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC5NRQC_CLR(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, HW_PCIE_PL_VC5NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC5NRQC_TOG(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, HW_PCIE_PL_VC5NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC5NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC5NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, (HW_PCIE_PL_VC5NRQC_RD(x) & ~BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC5NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, (HW_PCIE_PL_VC5NRQC_RD(x) & ~BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC5NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC5NRQC_WR(x, (HW_PCIE_PL_VC5NRQC_RD(x) & ~BM_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC5NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc5crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc5crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC5CRQC_ADDR(x) ((uintptr_t)(x) + 0x78CU)

#define HW_PCIE_PL_VC5CRQC(x)    (*(__IO hw_pcie_pl_vc5crqc_t *) HW_PCIE_PL_VC5CRQC_ADDR(x))
#define HW_PCIE_PL_VC5CRQC_RD(x) (HW_PCIE_PL_VC5CRQC(x).U)
#define HW_PCIE_PL_VC5CRQC_WR(x, v) (HW_PCIE_PL_VC5CRQC(x).U = (v))
#define HW_PCIE_PL_VC5CRQC_SET(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, HW_PCIE_PL_VC5CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC5CRQC_CLR(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, HW_PCIE_PL_VC5CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC5CRQC_TOG(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, HW_PCIE_PL_VC5CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC5CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC5CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, (HW_PCIE_PL_VC5CRQC_RD(x) & ~BM_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC5CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC5CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, (HW_PCIE_PL_VC5CRQC_RD(x) & ~BM_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC5CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC5CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC5CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC5CRQC_WR(x, (HW_PCIE_PL_VC5CRQC_RD(x) & ~BM_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC5CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc6prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc6prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC6PRQC_ADDR(x) ((uintptr_t)(x) + 0x790U)

#define HW_PCIE_PL_VC6PRQC(x)    (*(__IO hw_pcie_pl_vc6prqc_t *) HW_PCIE_PL_VC6PRQC_ADDR(x))
#define HW_PCIE_PL_VC6PRQC_RD(x) (HW_PCIE_PL_VC6PRQC(x).U)
#define HW_PCIE_PL_VC6PRQC_WR(x, v) (HW_PCIE_PL_VC6PRQC(x).U = (v))
#define HW_PCIE_PL_VC6PRQC_SET(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, HW_PCIE_PL_VC6PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC6PRQC_CLR(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, HW_PCIE_PL_VC6PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC6PRQC_TOG(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, HW_PCIE_PL_VC6PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC6PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC6PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, (HW_PCIE_PL_VC6PRQC_RD(x) & ~BM_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC6PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC6PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, (HW_PCIE_PL_VC6PRQC_RD(x) & ~BM_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC6PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC6PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, (HW_PCIE_PL_VC6PRQC_RD(x) & ~BM_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC6PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC6PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC6PRQC_WR(x, (HW_PCIE_PL_VC6PRQC_RD(x) & ~BM_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC6PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc6nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc6nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC6NRQC_ADDR(x) ((uintptr_t)(x) + 0x794U)

#define HW_PCIE_PL_VC6NRQC(x)    (*(__IO hw_pcie_pl_vc6nrqc_t *) HW_PCIE_PL_VC6NRQC_ADDR(x))
#define HW_PCIE_PL_VC6NRQC_RD(x) (HW_PCIE_PL_VC6NRQC(x).U)
#define HW_PCIE_PL_VC6NRQC_WR(x, v) (HW_PCIE_PL_VC6NRQC(x).U = (v))
#define HW_PCIE_PL_VC6NRQC_SET(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, HW_PCIE_PL_VC6NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC6NRQC_CLR(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, HW_PCIE_PL_VC6NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC6NRQC_TOG(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, HW_PCIE_PL_VC6NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC6NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC6NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, (HW_PCIE_PL_VC6NRQC_RD(x) & ~BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC6NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, (HW_PCIE_PL_VC6NRQC_RD(x) & ~BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC6NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC6NRQC_WR(x, (HW_PCIE_PL_VC6NRQC_RD(x) & ~BM_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC6NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc6crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc6crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC6CRQC_ADDR(x) ((uintptr_t)(x) + 0x798U)

#define HW_PCIE_PL_VC6CRQC(x)    (*(__IO hw_pcie_pl_vc6crqc_t *) HW_PCIE_PL_VC6CRQC_ADDR(x))
#define HW_PCIE_PL_VC6CRQC_RD(x) (HW_PCIE_PL_VC6CRQC(x).U)
#define HW_PCIE_PL_VC6CRQC_WR(x, v) (HW_PCIE_PL_VC6CRQC(x).U = (v))
#define HW_PCIE_PL_VC6CRQC_SET(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, HW_PCIE_PL_VC6CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC6CRQC_CLR(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, HW_PCIE_PL_VC6CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC6CRQC_TOG(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, HW_PCIE_PL_VC6CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC6CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC6CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, (HW_PCIE_PL_VC6CRQC_RD(x) & ~BM_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC6CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC6CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, (HW_PCIE_PL_VC6CRQC_RD(x) & ~BM_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC6CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC6CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC6CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC6CRQC_WR(x, (HW_PCIE_PL_VC6CRQC_RD(x) & ~BM_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC6CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7PRQC - VCn Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7PRQC - VCn Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x48 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7prqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc7prqc_bitfields
    {
        uint32_t VCn_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VC1_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 6;        /*!< [29:24]  */
        uint32_t TLP_Type_Ordering_for_VCn : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_pcie_pl_vc7prqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7PRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC7PRQC_ADDR(x) ((uintptr_t)(x) + 0x79CU)

#define HW_PCIE_PL_VC7PRQC(x)    (*(__IO hw_pcie_pl_vc7prqc_t *) HW_PCIE_PL_VC7PRQC_ADDR(x))
#define HW_PCIE_PL_VC7PRQC_RD(x) (HW_PCIE_PL_VC7PRQC(x).U)
#define HW_PCIE_PL_VC7PRQC_WR(x, v) (HW_PCIE_PL_VC7PRQC(x).U = (v))
#define HW_PCIE_PL_VC7PRQC_SET(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, HW_PCIE_PL_VC7PRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC7PRQC_CLR(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, HW_PCIE_PL_VC7PRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC7PRQC_TOG(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, HW_PCIE_PL_VC7PRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7PRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC7PRQC, field VCn_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Posted Data Credits The number of initial Posted data credits for VCn,
 * used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits. */
#define BM_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits. */
#define BS_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits(x) (HW_PCIE_PL_VC7PRQC(x).B.VCn_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits. */
#define BF_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits) & BM_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits)

/*! @brief Set the VCn_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, (HW_PCIE_PL_VC7PRQC_RD(x) & ~BM_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits) | BF_PCIE_PL_VC7PRQC_VCn_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7PRQC, field VCn_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Posted Header Credits The number of initial Posted header credits for
 * VCn, used for all receive queue buffer configurations. This field is not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits. */
#define BM_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits. */
#define BS_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits(x) (HW_PCIE_PL_VC7PRQC(x).B.VCn_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits. */
#define BF_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits) & BM_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits)

/*! @brief Set the VCn_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, (HW_PCIE_PL_VC7PRQC_RD(x) & ~BM_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits) | BF_PCIE_PL_VC7PRQC_VCn_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7PRQC, field VC1_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Posted TLP Queue Mode The operating mode of the Posted receive queue for
 * VCn, used only in the segmented-buffer configuration, writable through the
 * DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22: Cut-through Bit
 * 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC7PRQC(x).B.VC1_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode)

/*! @brief Set the VC1_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, (HW_PCIE_PL_VC7PRQC_RD(x) & ~BM_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC7PRQC_VC1_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7PRQC, field TLP_Type_Ordering_for_VCn[30] (RW)
 *
 * TLP Type Ordering for VCn Determines the TLP type ordering rule for VCn
 * receive queues, used only in the segmented-buffer configuration, writable through
 * the DBI: 1: Ordering of received TLPs follows the rules in PCI Express Base 3.0
 * Specification 0: Strict ordering for received TLPs: Posted, then Completion,
 * then Non-Posted
 */
/*@{*/
#define BP_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn (30U) /*!< Bit position for PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn. */
#define BM_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn (0x40000000U) /*!< Bit mask for PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn. */
#define BS_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn (1U) /*!< Bit field size in bits for PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn. */

/*! @brief Read current value of the PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn field. */
#define BR_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn(x) (HW_PCIE_PL_VC7PRQC(x).B.TLP_Type_Ordering_for_VCn)

/*! @brief Format value for bitfield PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn. */
#define BF_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn) & BM_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn)

/*! @brief Set the TLP_Type_Ordering_for_VCn field to a new value. */
#define BW_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn(x, v) (HW_PCIE_PL_VC7PRQC_WR(x, (HW_PCIE_PL_VC7PRQC_RD(x) & ~BM_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn) | BF_PCIE_PL_VC7PRQC_TLP_Type_Ordering_for_VCn(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7NRQC - VCn Non-Posted Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7NRQC - VCn Non-Posted Receive Queue Control (RW)
 *
 * Reset value: 0x00200000U
 *
 * Offset: 0x700 + 0x4C + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7nrqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc7nrqc_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Non_Posted_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Non_Posted_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc7nrqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7NRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC7NRQC_ADDR(x) ((uintptr_t)(x) + 0x7A0U)

#define HW_PCIE_PL_VC7NRQC(x)    (*(__IO hw_pcie_pl_vc7nrqc_t *) HW_PCIE_PL_VC7NRQC_ADDR(x))
#define HW_PCIE_PL_VC7NRQC_RD(x) (HW_PCIE_PL_VC7NRQC(x).U)
#define HW_PCIE_PL_VC7NRQC_WR(x, v) (HW_PCIE_PL_VC7NRQC(x).U = (v))
#define HW_PCIE_PL_VC7NRQC_SET(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, HW_PCIE_PL_VC7NRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC7NRQC_CLR(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, HW_PCIE_PL_VC7NRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC7NRQC_TOG(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, HW_PCIE_PL_VC7NRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7NRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC7NRQC, field VCn_Non_Posted_Data_Credits[11:0] (RW)
 *
 * VCn Non-Posted Data Credits The number of initial Non-Posted data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits. */
#define BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits. */
#define BS_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits field. */
#define BR_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits(x) (HW_PCIE_PL_VC7NRQC(x).B.VCn_Non_Posted_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits. */
#define BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits) & BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits)

/*! @brief Set the VCn_Non_Posted_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, (HW_PCIE_PL_VC7NRQC_RD(x) & ~BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits) | BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7NRQC, field VCn_Non_Posted_Header_Credits[19:12] (RW)
 *
 * VCn Non-Posted Header Credits The number of initial Non-Posted header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBId.
 */
/*@{*/
#define BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits. */
#define BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits. */
#define BS_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits field. */
#define BR_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits(x) (HW_PCIE_PL_VC7NRQC(x).B.VCn_Non_Posted_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits. */
#define BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits) & BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits)

/*! @brief Set the VCn_Non_Posted_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, (HW_PCIE_PL_VC7NRQC_RD(x) & ~BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits) | BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7NRQC, field VCn_Non_Posted_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Non-Posted TLP Queue Mode The operating mode of the Non-Posted receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode(x) (HW_PCIE_PL_VC7NRQC(x).B.VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode) & BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode)

/*! @brief Set the VCn_Non_Posted_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC7NRQC_WR(x, (HW_PCIE_PL_VC7NRQC_RD(x) & ~BM_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode) | BF_PCIE_PL_VC7NRQC_VCn_Non_Posted_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7CRQC - VCn Completion Receive Queue Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7CRQC - VCn Completion Receive Queue Control (RW)
 *
 * Reset value: 0x00800000U
 *
 * Offset: 0x700 + 0x50 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7crqc
{
    uint32_t U;
    struct _hw_pcie_pl_vc7crqc_bitfields
    {
        uint32_t VCn_Completion_Data_Credits : 12; /*!< [11:0]  */
        uint32_t VCn_Completion_Header_Credits : 8; /*!< [19:12]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t VCn_Completion_TLP_Queue_Mode : 3; /*!< [23:21]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_pcie_pl_vc7crqc_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7CRQC register
 */
/*@{*/
#define HW_PCIE_PL_VC7CRQC_ADDR(x) ((uintptr_t)(x) + 0x7A4U)

#define HW_PCIE_PL_VC7CRQC(x)    (*(__IO hw_pcie_pl_vc7crqc_t *) HW_PCIE_PL_VC7CRQC_ADDR(x))
#define HW_PCIE_PL_VC7CRQC_RD(x) (HW_PCIE_PL_VC7CRQC(x).U)
#define HW_PCIE_PL_VC7CRQC_WR(x, v) (HW_PCIE_PL_VC7CRQC(x).U = (v))
#define HW_PCIE_PL_VC7CRQC_SET(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, HW_PCIE_PL_VC7CRQC_RD(x) |  (v)))
#define HW_PCIE_PL_VC7CRQC_CLR(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, HW_PCIE_PL_VC7CRQC_RD(x) & ~(v)))
#define HW_PCIE_PL_VC7CRQC_TOG(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, HW_PCIE_PL_VC7CRQC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7CRQC bitfields
 */

/*!
 * @name Register PCIE_PL_VC7CRQC, field VCn_Completion_Data_Credits[11:0] (RW)
 *
 * VCn Completion Data Credits The number of initial Completion data credits for
 * VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits (0U) /*!< Bit position for PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits. */
#define BM_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits (0x00000FFFU) /*!< Bit mask for PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits. */
#define BS_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits (12U) /*!< Bit field size in bits for PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits field. */
#define BR_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits(x) (HW_PCIE_PL_VC7CRQC(x).B.VCn_Completion_Data_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits. */
#define BF_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits) & BM_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits)

/*! @brief Set the VCn_Completion_Data_Credits field to a new value. */
#define BW_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, (HW_PCIE_PL_VC7CRQC_RD(x) & ~BM_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits) | BF_PCIE_PL_VC7CRQC_VCn_Completion_Data_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7CRQC, field VCn_Completion_Header_Credits[19:12] (RW)
 *
 * VCn Completion Header Credits The number of initial Completion header credits
 * for VCn, used for all receive queue buffer configurations. This field is not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits (12U) /*!< Bit position for PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits. */
#define BM_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits (0x000FF000U) /*!< Bit mask for PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits. */
#define BS_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits (8U) /*!< Bit field size in bits for PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits. */

/*! @brief Read current value of the PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits field. */
#define BR_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits(x) (HW_PCIE_PL_VC7CRQC(x).B.VCn_Completion_Header_Credits)

/*! @brief Format value for bitfield PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits. */
#define BF_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits) & BM_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits)

/*! @brief Set the VCn_Completion_Header_Credits field to a new value. */
#define BW_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, (HW_PCIE_PL_VC7CRQC_RD(x) & ~BM_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits) | BF_PCIE_PL_VC7CRQC_VCn_Completion_Header_Credits(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_VC7CRQC, field VCn_Completion_TLP_Queue_Mode[23:21] (RW)
 *
 * VCn Completion TLP Queue Mode The operating mode of the Completion receive
 * queue for VCn, used only in the segmented-buffer configuration, writable through
 * the DBI. Only one bit can be set at a time: Bit 23: Bypass Bit 22:
 * Cut-through Bit 21: Store-and-forward
 */
/*@{*/
#define BP_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode (21U) /*!< Bit position for PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BM_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode (0x00E00000U) /*!< Bit mask for PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BS_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode (3U) /*!< Bit field size in bits for PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode. */

/*! @brief Read current value of the PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode field. */
#define BR_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode(x) (HW_PCIE_PL_VC7CRQC(x).B.VCn_Completion_TLP_Queue_Mode)

/*! @brief Format value for bitfield PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode. */
#define BF_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode) & BM_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode)

/*! @brief Set the VCn_Completion_TLP_Queue_Mode field to a new value. */
#define BW_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode(x, v) (HW_PCIE_PL_VC7CRQC_WR(x, (HW_PCIE_PL_VC7CRQC_RD(x) & ~BM_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode) | BF_PCIE_PL_VC7CRQC_VCn_Completion_TLP_Queue_Mode(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0PBD - VC0 Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0PBD - VC0 Posted Buffer Depth (RO)
 *
 * Reset value: 0x000D0065U
 *
 * The Buffer Depth registers are used only in the segmented-buffer
 * configuration. Writing to these registers is not possible (through the DBI) Offset: 0x700
 * + 0xA8
 */
typedef union _hw_pcie_pl_vc0pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc0pbd_bitfields
    {
        uint32_t VC0_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VC0_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc0pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC0PBD_ADDR(x) ((uintptr_t)(x) + 0x7A8U)

#define HW_PCIE_PL_VC0PBD(x)     (*(__I hw_pcie_pl_vc0pbd_t *) HW_PCIE_PL_VC0PBD_ADDR(x))
#define HW_PCIE_PL_VC0PBD_RD(x)  (HW_PCIE_PL_VC0PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC0PBD, field VC0_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VC0 Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VC0 when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC0PBD_VC0_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC0PBD(x).B.VC0_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC0PBD, field VC0_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VC0 Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VC0 when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC0PBD_VC0_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC0PBD(x).B.VC0_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0NPBD - VC0 Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0NPBD - VC0 Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x000D000DU
 *
 * Offset: 0x700 + 0xAC
 */
typedef union _hw_pcie_pl_vc0npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc0npbd_bitfields
    {
        uint32_t VC0_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VC0_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc0npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC0NPBD_ADDR(x) ((uintptr_t)(x) + 0x7ACU)

#define HW_PCIE_PL_VC0NPBD(x)    (*(__I hw_pcie_pl_vc0npbd_t *) HW_PCIE_PL_VC0NPBD_ADDR(x))
#define HW_PCIE_PL_VC0NPBD_RD(x) (HW_PCIE_PL_VC0NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC0NPBD, field VC0_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VC0 Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VC0 when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC0NPBD_VC0_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC0NPBD(x).B.VC0_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC0NPBD, field VC0_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VC0 Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VC0 when using the segmented-buffer configuration.Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC0NPBD_VC0_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC0NPBD(x).B.VC0_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC0CBD - VC0 Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC0CBD - VC0 Completion Buffer Depth (RO)
 *
 * Reset value: 0x00030003U
 *
 * Offset: 0x700 + 0xB0
 */
typedef union _hw_pcie_pl_vc0cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc0cbd_bitfields
    {
        uint32_t VC0_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VC0_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc0cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC0CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC0CBD_ADDR(x) ((uintptr_t)(x) + 0x7B0U)

#define HW_PCIE_PL_VC0CBD(x)     (*(__I hw_pcie_pl_vc0cbd_t *) HW_PCIE_PL_VC0CBD_ADDR(x))
#define HW_PCIE_PL_VC0CBD_RD(x)  (HW_PCIE_PL_VC0CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC0CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC0CBD, field VC0_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VC0 Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VC0 when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC0CBD_VC0_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC0CBD(x).B.VC0_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC0CBD, field VC0_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VC0 Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VC0 when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC0CBD_VC0_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC0CBD(x).B.VC0_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc1pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc1pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC1PBD_ADDR(x) ((uintptr_t)(x) + 0x7B4U)

#define HW_PCIE_PL_VC1PBD(x)     (*(__I hw_pcie_pl_vc1pbd_t *) HW_PCIE_PL_VC1PBD_ADDR(x))
#define HW_PCIE_PL_VC1PBD_RD(x)  (HW_PCIE_PL_VC1PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC1PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC1PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC1PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC1PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC1PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC1PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc1npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc1npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC1NPBD_ADDR(x) ((uintptr_t)(x) + 0x7B8U)

#define HW_PCIE_PL_VC1NPBD(x)    (*(__I hw_pcie_pl_vc1npbd_t *) HW_PCIE_PL_VC1NPBD_ADDR(x))
#define HW_PCIE_PL_VC1NPBD_RD(x) (HW_PCIE_PL_VC1NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC1NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC1NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC1NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC1NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC1NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC1NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC1CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC1CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc1cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc1cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc1cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC1CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC1CBD_ADDR(x) ((uintptr_t)(x) + 0x7BCU)

#define HW_PCIE_PL_VC1CBD(x)     (*(__I hw_pcie_pl_vc1cbd_t *) HW_PCIE_PL_VC1CBD_ADDR(x))
#define HW_PCIE_PL_VC1CBD_RD(x)  (HW_PCIE_PL_VC1CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC1CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC1CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC1CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC1CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC1CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC1CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC1CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc2pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc2pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC2PBD_ADDR(x) ((uintptr_t)(x) + 0x7C0U)

#define HW_PCIE_PL_VC2PBD(x)     (*(__I hw_pcie_pl_vc2pbd_t *) HW_PCIE_PL_VC2PBD_ADDR(x))
#define HW_PCIE_PL_VC2PBD_RD(x)  (HW_PCIE_PL_VC2PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC2PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC2PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC2PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC2PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC2PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC2PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc2npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc2npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC2NPBD_ADDR(x) ((uintptr_t)(x) + 0x7C4U)

#define HW_PCIE_PL_VC2NPBD(x)    (*(__I hw_pcie_pl_vc2npbd_t *) HW_PCIE_PL_VC2NPBD_ADDR(x))
#define HW_PCIE_PL_VC2NPBD_RD(x) (HW_PCIE_PL_VC2NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC2NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC2NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC2NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC2NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC2NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC2NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC2CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC2CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc2cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc2cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc2cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC2CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC2CBD_ADDR(x) ((uintptr_t)(x) + 0x7C8U)

#define HW_PCIE_PL_VC2CBD(x)     (*(__I hw_pcie_pl_vc2cbd_t *) HW_PCIE_PL_VC2CBD_ADDR(x))
#define HW_PCIE_PL_VC2CBD_RD(x)  (HW_PCIE_PL_VC2CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC2CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC2CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC2CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC2CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC2CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC2CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC2CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc3pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc3pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC3PBD_ADDR(x) ((uintptr_t)(x) + 0x7CCU)

#define HW_PCIE_PL_VC3PBD(x)     (*(__I hw_pcie_pl_vc3pbd_t *) HW_PCIE_PL_VC3PBD_ADDR(x))
#define HW_PCIE_PL_VC3PBD_RD(x)  (HW_PCIE_PL_VC3PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC3PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC3PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC3PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC3PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC3PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC3PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc3npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc3npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC3NPBD_ADDR(x) ((uintptr_t)(x) + 0x7D0U)

#define HW_PCIE_PL_VC3NPBD(x)    (*(__I hw_pcie_pl_vc3npbd_t *) HW_PCIE_PL_VC3NPBD_ADDR(x))
#define HW_PCIE_PL_VC3NPBD_RD(x) (HW_PCIE_PL_VC3NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC3NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC3NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC3NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC3NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC3NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC3NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC3CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC3CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc3cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc3cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc3cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC3CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC3CBD_ADDR(x) ((uintptr_t)(x) + 0x7D4U)

#define HW_PCIE_PL_VC3CBD(x)     (*(__I hw_pcie_pl_vc3cbd_t *) HW_PCIE_PL_VC3CBD_ADDR(x))
#define HW_PCIE_PL_VC3CBD_RD(x)  (HW_PCIE_PL_VC3CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC3CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC3CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC3CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC3CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC3CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC3CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC3CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc4pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc4pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC4PBD_ADDR(x) ((uintptr_t)(x) + 0x7D8U)

#define HW_PCIE_PL_VC4PBD(x)     (*(__I hw_pcie_pl_vc4pbd_t *) HW_PCIE_PL_VC4PBD_ADDR(x))
#define HW_PCIE_PL_VC4PBD_RD(x)  (HW_PCIE_PL_VC4PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC4PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC4PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC4PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC4PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC4PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC4PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc4npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc4npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC4NPBD_ADDR(x) ((uintptr_t)(x) + 0x7DCU)

#define HW_PCIE_PL_VC4NPBD(x)    (*(__I hw_pcie_pl_vc4npbd_t *) HW_PCIE_PL_VC4NPBD_ADDR(x))
#define HW_PCIE_PL_VC4NPBD_RD(x) (HW_PCIE_PL_VC4NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC4NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC4NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC4NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC4NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC4NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC4NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC4CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC4CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc4cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc4cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc4cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC4CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC4CBD_ADDR(x) ((uintptr_t)(x) + 0x7E0U)

#define HW_PCIE_PL_VC4CBD(x)     (*(__I hw_pcie_pl_vc4cbd_t *) HW_PCIE_PL_VC4CBD_ADDR(x))
#define HW_PCIE_PL_VC4CBD_RD(x)  (HW_PCIE_PL_VC4CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC4CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC4CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC4CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC4CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC4CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC4CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC4CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc5pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc5pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC5PBD_ADDR(x) ((uintptr_t)(x) + 0x7E4U)

#define HW_PCIE_PL_VC5PBD(x)     (*(__I hw_pcie_pl_vc5pbd_t *) HW_PCIE_PL_VC5PBD_ADDR(x))
#define HW_PCIE_PL_VC5PBD_RD(x)  (HW_PCIE_PL_VC5PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC5PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC5PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC5PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC5PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC5PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC5PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc5npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc5npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC5NPBD_ADDR(x) ((uintptr_t)(x) + 0x7E8U)

#define HW_PCIE_PL_VC5NPBD(x)    (*(__I hw_pcie_pl_vc5npbd_t *) HW_PCIE_PL_VC5NPBD_ADDR(x))
#define HW_PCIE_PL_VC5NPBD_RD(x) (HW_PCIE_PL_VC5NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC5NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC5NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC5NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC5NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC5NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC5NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC5CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC5CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc5cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc5cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc5cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC5CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC5CBD_ADDR(x) ((uintptr_t)(x) + 0x7ECU)

#define HW_PCIE_PL_VC5CBD(x)     (*(__I hw_pcie_pl_vc5cbd_t *) HW_PCIE_PL_VC5CBD_ADDR(x))
#define HW_PCIE_PL_VC5CBD_RD(x)  (HW_PCIE_PL_VC5CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC5CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC5CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC5CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC5CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC5CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC5CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC5CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc6pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc6pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC6PBD_ADDR(x) ((uintptr_t)(x) + 0x7F0U)

#define HW_PCIE_PL_VC6PBD(x)     (*(__I hw_pcie_pl_vc6pbd_t *) HW_PCIE_PL_VC6PBD_ADDR(x))
#define HW_PCIE_PL_VC6PBD_RD(x)  (HW_PCIE_PL_VC6PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC6PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC6PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC6PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC6PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC6PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC6PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc6npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc6npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC6NPBD_ADDR(x) ((uintptr_t)(x) + 0x7F4U)

#define HW_PCIE_PL_VC6NPBD(x)    (*(__I hw_pcie_pl_vc6npbd_t *) HW_PCIE_PL_VC6NPBD_ADDR(x))
#define HW_PCIE_PL_VC6NPBD_RD(x) (HW_PCIE_PL_VC6NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC6NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC6NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC6NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC6NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC6NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC6NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC6CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC6CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc6cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc6cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc6cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC6CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC6CBD_ADDR(x) ((uintptr_t)(x) + 0x7F8U)

#define HW_PCIE_PL_VC6CBD(x)     (*(__I hw_pcie_pl_vc6cbd_t *) HW_PCIE_PL_VC6CBD_ADDR(x))
#define HW_PCIE_PL_VC6CBD_RD(x)  (HW_PCIE_PL_VC6CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC6CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC6CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC6CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC6CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC6CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC6CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC6CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7PBD - VCn Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7PBD - VCn Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xA8 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7pbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc7pbd_bitfields
    {
        uint32_t VCn_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc7pbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7PBD register
 */
/*@{*/
#define HW_PCIE_PL_VC7PBD_ADDR(x) ((uintptr_t)(x) + 0x7FCU)

#define HW_PCIE_PL_VC7PBD(x)     (*(__I hw_pcie_pl_vc7pbd_t *) HW_PCIE_PL_VC7PBD_ADDR(x))
#define HW_PCIE_PL_VC7PBD_RD(x)  (HW_PCIE_PL_VC7PBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7PBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC7PBD, field VCn_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Posted Data Queue Depth Sets the number of entries in the Posted data
 * queue for VCn when using the segmented-buffer configuration.Not writable through
 * the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC7PBD_VCn_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC7PBD(x).B.VCn_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC7PBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Posted header
 * queue for VCn when using the segmented-buffer configuration.Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC7PBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC7PBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7NPBD - VCn Non-Posted Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7NPBD - VCn Non-Posted Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xAC + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7npbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc7npbd_bitfields
    {
        uint32_t VCn_Non_Posted_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Non_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc7npbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7NPBD register
 */
/*@{*/
#define HW_PCIE_PL_VC7NPBD_ADDR(x) ((uintptr_t)(x) + 0x800U)

#define HW_PCIE_PL_VC7NPBD(x)    (*(__I hw_pcie_pl_vc7npbd_t *) HW_PCIE_PL_VC7NPBD_ADDR(x))
#define HW_PCIE_PL_VC7NPBD_RD(x) (HW_PCIE_PL_VC7NPBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7NPBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC7NPBD, field VCn_Non_Posted_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Non-Posted Data Queue Depth Sets the number of entries in the Non-Posted
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BM_PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth. */
#define BS_PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC7NPBD_VCn_Non_Posted_Data_Queue_Depth(x) (HW_PCIE_PL_VC7NPBD(x).B.VCn_Non_Posted_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC7NPBD, field VCn_Non_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Non-Posted Header Queue Depth Sets the number of entries in the
 * Non-Posted header queue for VCn when using the segmented-buffer configuration. Not
 * writable through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC7NPBD_VCn_Non_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC7NPBD(x).B.VCn_Non_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_VC7CBD - VCn Completion Buffer Depth
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_VC7CBD - VCn Completion Buffer Depth (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0xB0 + C*n (n=[1:7])
 */
typedef union _hw_pcie_pl_vc7cbd
{
    uint32_t U;
    struct _hw_pcie_pl_vc7cbd_bitfields
    {
        uint32_t VCn_Completion_Data_Queue_Depth : 14; /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t VCn_Posted_Header_Queue_Depth : 10; /*!< [25:16]  */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_pcie_pl_vc7cbd_t;

/*!
 * @name Constants and macros for entire PCIE_PL_VC7CBD register
 */
/*@{*/
#define HW_PCIE_PL_VC7CBD_ADDR(x) ((uintptr_t)(x) + 0x804U)

#define HW_PCIE_PL_VC7CBD(x)     (*(__I hw_pcie_pl_vc7cbd_t *) HW_PCIE_PL_VC7CBD_ADDR(x))
#define HW_PCIE_PL_VC7CBD_RD(x)  (HW_PCIE_PL_VC7CBD(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_VC7CBD bitfields
 */

/*!
 * @name Register PCIE_PL_VC7CBD, field VCn_Completion_Data_Queue_Depth[13:0] (RO)
 *
 * VCn Completion Data Queue Depth Sets the number of entries in the Completion
 * data queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth (0U) /*!< Bit position for PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth. */
#define BM_PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth (0x00003FFFU) /*!< Bit mask for PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth. */
#define BS_PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth (14U) /*!< Bit field size in bits for PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth field. */
#define BR_PCIE_PL_VC7CBD_VCn_Completion_Data_Queue_Depth(x) (HW_PCIE_PL_VC7CBD(x).B.VCn_Completion_Data_Queue_Depth)
/*@}*/

/*!
 * @name Register PCIE_PL_VC7CBD, field VCn_Posted_Header_Queue_Depth[25:16] (RO)
 *
 * VCn Posted Header Queue Depth Sets the number of entries in the Completion
 * header queue for VCn when using the segmented-buffer configuration. Not writable
 * through the DBI
 */
/*@{*/
#define BP_PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth (16U) /*!< Bit position for PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth. */
#define BM_PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth (0x03FF0000U) /*!< Bit mask for PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth. */
#define BS_PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth (10U) /*!< Bit field size in bits for PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth. */

/*! @brief Read current value of the PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth field. */
#define BR_PCIE_PL_VC7CBD_VCn_Posted_Header_Queue_Depth(x) (HW_PCIE_PL_VC7CBD(x).B.VCn_Posted_Header_Queue_Depth)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_G2CR - Gen2 Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_G2CR - Gen2 Control Register (RW)
 *
 * Reset value: 0x00000001U
 *
 * The Port Logic Gen2 Control Register controls features specific to data rates
 * greater than 2.5 GT/s. The "Lane Enable" field is an exception in that it
 * applies regardless of the data rate. Offset: 0x700 + 0x10C
 */
typedef union _hw_pcie_pl_g2cr
{
    uint32_t U;
    struct _hw_pcie_pl_g2cr_bitfields
    {
        uint32_t N_FTS : 8;            /*!< [7:0]  */
        uint32_t Predetermined_Number_of_Lanes : 9; /*!< [16:8]  */
        uint32_t Directed_Speed_Change : 1; /*!< [17]  */
        uint32_t Config_PHY_Tx_Swing : 1; /*!< [18]  */
        uint32_t Config_Tx_Compliance_Receive_Bit : 1; /*!< [19]  */
        uint32_t De_emphasis_level : 1; /*!< [20]  */
        uint32_t RESERVED0 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_pl_g2cr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_G2CR register
 */
/*@{*/
#define HW_PCIE_PL_G2CR_ADDR(x)  ((uintptr_t)(x) + 0x80CU)

#define HW_PCIE_PL_G2CR(x)       (*(__IO hw_pcie_pl_g2cr_t *) HW_PCIE_PL_G2CR_ADDR(x))
#define HW_PCIE_PL_G2CR_RD(x)    (HW_PCIE_PL_G2CR(x).U)
#define HW_PCIE_PL_G2CR_WR(x, v) (HW_PCIE_PL_G2CR(x).U = (v))
#define HW_PCIE_PL_G2CR_SET(x, v) (HW_PCIE_PL_G2CR_WR(x, HW_PCIE_PL_G2CR_RD(x) |  (v)))
#define HW_PCIE_PL_G2CR_CLR(x, v) (HW_PCIE_PL_G2CR_WR(x, HW_PCIE_PL_G2CR_RD(x) & ~(v)))
#define HW_PCIE_PL_G2CR_TOG(x, v) (HW_PCIE_PL_G2CR_WR(x, HW_PCIE_PL_G2CR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_G2CR bitfields
 */

/*!
 * @name Register PCIE_PL_G2CR, field N_FTS[7:0] (RW)
 *
 * Sets the Number of Fast Training Sequences (N_FTS) that the core advertises
 * as its N_FTS during Gen2 Link training. This value is used to inform the Link
 * partner about the PHY's ability to recover synchronization after a low power
 * state. The number should be provided by the PHY vendor. Note: Do not set N_FTS
 * to zero; doing so can cause the LTSSM to go into the recovery state when
 * exiting from L0s.
 */
/*@{*/
#define BP_PCIE_PL_G2CR_N_FTS (0U)         /*!< Bit position for PCIE_PL_G2CR_N_FTS. */
#define BM_PCIE_PL_G2CR_N_FTS (0x000000FFU) /*!< Bit mask for PCIE_PL_G2CR_N_FTS. */
#define BS_PCIE_PL_G2CR_N_FTS (8U)         /*!< Bit field size in bits for PCIE_PL_G2CR_N_FTS. */

/*! @brief Read current value of the PCIE_PL_G2CR_N_FTS field. */
#define BR_PCIE_PL_G2CR_N_FTS(x) (HW_PCIE_PL_G2CR(x).B.N_FTS)

/*! @brief Format value for bitfield PCIE_PL_G2CR_N_FTS. */
#define BF_PCIE_PL_G2CR_N_FTS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_N_FTS) & BM_PCIE_PL_G2CR_N_FTS)

/*! @brief Set the N_FTS field to a new value. */
#define BW_PCIE_PL_G2CR_N_FTS(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_N_FTS) | BF_PCIE_PL_G2CR_N_FTS(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_G2CR, field Predetermined_Number_of_Lanes[16:8] (RW)
 *
 * Predetermined Number of Lanes Used to limit the effective link width to
 * ignore "broken" lanes that detect a receiver. Indicates the number of lanes to
 * check for exit from Electrical Idle in POLLING.ACTIVE and L2.IDLE. It is possible
 * that the LTSSM may detect a Receiver on a 'bad' or 'broken' lane during the
 * Detect Sub-state. However, it is also possible that such a lane may also fail to
 * exit Electrical Idle and therefore prevent a valid link from being
 * configured. Encoding is as follows: 0x01 = 1 lane
 */
/*@{*/
#define BP_PCIE_PL_G2CR_Predetermined_Number_of_Lanes (8U) /*!< Bit position for PCIE_PL_G2CR_Predetermined_Number_of_Lanes. */
#define BM_PCIE_PL_G2CR_Predetermined_Number_of_Lanes (0x0001FF00U) /*!< Bit mask for PCIE_PL_G2CR_Predetermined_Number_of_Lanes. */
#define BS_PCIE_PL_G2CR_Predetermined_Number_of_Lanes (9U) /*!< Bit field size in bits for PCIE_PL_G2CR_Predetermined_Number_of_Lanes. */

/*! @brief Read current value of the PCIE_PL_G2CR_Predetermined_Number_of_Lanes field. */
#define BR_PCIE_PL_G2CR_Predetermined_Number_of_Lanes(x) (HW_PCIE_PL_G2CR(x).B.Predetermined_Number_of_Lanes)

/*! @brief Format value for bitfield PCIE_PL_G2CR_Predetermined_Number_of_Lanes. */
#define BF_PCIE_PL_G2CR_Predetermined_Number_of_Lanes(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_Predetermined_Number_of_Lanes) & BM_PCIE_PL_G2CR_Predetermined_Number_of_Lanes)

/*! @brief Set the Predetermined_Number_of_Lanes field to a new value. */
#define BW_PCIE_PL_G2CR_Predetermined_Number_of_Lanes(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_Predetermined_Number_of_Lanes) | BF_PCIE_PL_G2CR_Predetermined_Number_of_Lanes(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_G2CR, field Directed_Speed_Change[17] (RW)
 *
 * Directed Speed Change Indicates to the LTSSM whether or not to initiate a
 * speed change to Gen2
 */
/*@{*/
#define BP_PCIE_PL_G2CR_Directed_Speed_Change (17U) /*!< Bit position for PCIE_PL_G2CR_Directed_Speed_Change. */
#define BM_PCIE_PL_G2CR_Directed_Speed_Change (0x00020000U) /*!< Bit mask for PCIE_PL_G2CR_Directed_Speed_Change. */
#define BS_PCIE_PL_G2CR_Directed_Speed_Change (1U) /*!< Bit field size in bits for PCIE_PL_G2CR_Directed_Speed_Change. */

/*! @brief Read current value of the PCIE_PL_G2CR_Directed_Speed_Change field. */
#define BR_PCIE_PL_G2CR_Directed_Speed_Change(x) (HW_PCIE_PL_G2CR(x).B.Directed_Speed_Change)

/*! @brief Format value for bitfield PCIE_PL_G2CR_Directed_Speed_Change. */
#define BF_PCIE_PL_G2CR_Directed_Speed_Change(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_Directed_Speed_Change) & BM_PCIE_PL_G2CR_Directed_Speed_Change)

/*! @brief Set the Directed_Speed_Change field to a new value. */
#define BW_PCIE_PL_G2CR_Directed_Speed_Change(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_Directed_Speed_Change) | BF_PCIE_PL_G2CR_Directed_Speed_Change(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_G2CR, field Config_PHY_Tx_Swing[18] (RW)
 *
 * Config PHY Tx Swing Indicates the voltage level the PHY should drive. When
 * set to 1, indicates Full Swing. When set to 0, indicates Low Swing
 */
/*@{*/
#define BP_PCIE_PL_G2CR_Config_PHY_Tx_Swing (18U) /*!< Bit position for PCIE_PL_G2CR_Config_PHY_Tx_Swing. */
#define BM_PCIE_PL_G2CR_Config_PHY_Tx_Swing (0x00040000U) /*!< Bit mask for PCIE_PL_G2CR_Config_PHY_Tx_Swing. */
#define BS_PCIE_PL_G2CR_Config_PHY_Tx_Swing (1U) /*!< Bit field size in bits for PCIE_PL_G2CR_Config_PHY_Tx_Swing. */

/*! @brief Read current value of the PCIE_PL_G2CR_Config_PHY_Tx_Swing field. */
#define BR_PCIE_PL_G2CR_Config_PHY_Tx_Swing(x) (HW_PCIE_PL_G2CR(x).B.Config_PHY_Tx_Swing)

/*! @brief Format value for bitfield PCIE_PL_G2CR_Config_PHY_Tx_Swing. */
#define BF_PCIE_PL_G2CR_Config_PHY_Tx_Swing(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_Config_PHY_Tx_Swing) & BM_PCIE_PL_G2CR_Config_PHY_Tx_Swing)

/*! @brief Set the Config_PHY_Tx_Swing field to a new value. */
#define BW_PCIE_PL_G2CR_Config_PHY_Tx_Swing(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_Config_PHY_Tx_Swing) | BF_PCIE_PL_G2CR_Config_PHY_Tx_Swing(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_G2CR, field Config_Tx_Compliance_Receive_Bit[19] (RW)
 *
 * Config Tx Compliance Receive Bit When set to 1, signals LTSSM to transmit TS
 * ordered sets with the compliance receive bit assert (equal to 1).
 */
/*@{*/
#define BP_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit (19U) /*!< Bit position for PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit. */
#define BM_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit (0x00080000U) /*!< Bit mask for PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit. */
#define BS_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit (1U) /*!< Bit field size in bits for PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit. */

/*! @brief Read current value of the PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit field. */
#define BR_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit(x) (HW_PCIE_PL_G2CR(x).B.Config_Tx_Compliance_Receive_Bit)

/*! @brief Format value for bitfield PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit. */
#define BF_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit) & BM_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit)

/*! @brief Set the Config_Tx_Compliance_Receive_Bit field to a new value. */
#define BW_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit) | BF_PCIE_PL_G2CR_Config_Tx_Compliance_Receive_Bit(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_G2CR, field De_emphasis_level[20] (RW)
 *
 * Used to set the de-emphasis level for upstream ports.
 */
/*@{*/
#define BP_PCIE_PL_G2CR_De_emphasis_level (20U) /*!< Bit position for PCIE_PL_G2CR_De_emphasis_level. */
#define BM_PCIE_PL_G2CR_De_emphasis_level (0x00100000U) /*!< Bit mask for PCIE_PL_G2CR_De_emphasis_level. */
#define BS_PCIE_PL_G2CR_De_emphasis_level (1U) /*!< Bit field size in bits for PCIE_PL_G2CR_De_emphasis_level. */

/*! @brief Read current value of the PCIE_PL_G2CR_De_emphasis_level field. */
#define BR_PCIE_PL_G2CR_De_emphasis_level(x) (HW_PCIE_PL_G2CR(x).B.De_emphasis_level)

/*! @brief Format value for bitfield PCIE_PL_G2CR_De_emphasis_level. */
#define BF_PCIE_PL_G2CR_De_emphasis_level(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_G2CR_De_emphasis_level) & BM_PCIE_PL_G2CR_De_emphasis_level)

/*! @brief Set the De_emphasis_level field to a new value. */
#define BW_PCIE_PL_G2CR_De_emphasis_level(x, v) (HW_PCIE_PL_G2CR_WR(x, (HW_PCIE_PL_G2CR_RD(x) & ~BM_PCIE_PL_G2CR_De_emphasis_level) | BF_PCIE_PL_G2CR_De_emphasis_level(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_PHY_STATUS - PHY Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_PHY_STATUS - PHY Status (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x110
 */
typedef union _hw_pcie_pl_phy_status
{
    uint32_t U;
    struct _hw_pcie_pl_phy_status_bitfields
    {
        uint32_t PHY_Status : 32;      /*!< [31:0]  */
    } B;
} hw_pcie_pl_phy_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_PHY_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_PHY_STATUS_ADDR(x) ((uintptr_t)(x) + 0x810U)

#define HW_PCIE_PL_PHY_STATUS(x) (*(__I hw_pcie_pl_phy_status_t *) HW_PCIE_PL_PHY_STATUS_ADDR(x))
#define HW_PCIE_PL_PHY_STATUS_RD(x) (HW_PCIE_PL_PHY_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_PHY_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_PHY_STATUS, field PHY_Status[31:0] (RO)
 *
 * PHY Status Data received directly from the phy_cfg_status bus.
 */
/*@{*/
#define BP_PCIE_PL_PHY_STATUS_PHY_Status (0U) /*!< Bit position for PCIE_PL_PHY_STATUS_PHY_Status. */
#define BM_PCIE_PL_PHY_STATUS_PHY_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_PHY_STATUS_PHY_Status. */
#define BS_PCIE_PL_PHY_STATUS_PHY_Status (32U) /*!< Bit field size in bits for PCIE_PL_PHY_STATUS_PHY_Status. */

/*! @brief Read current value of the PCIE_PL_PHY_STATUS_PHY_Status field. */
#define BR_PCIE_PL_PHY_STATUS_PHY_Status(x) (HW_PCIE_PL_PHY_STATUS(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_PHY_CTRL - PHY Control
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_PHY_CTRL - PHY Control (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x114
 */
typedef union _hw_pcie_pl_phy_ctrl
{
    uint32_t U;
    struct _hw_pcie_pl_phy_ctrl_bitfields
    {
        uint32_t PHY_Control : 32;     /*!< [31:0]  */
    } B;
} hw_pcie_pl_phy_ctrl_t;

/*!
 * @name Constants and macros for entire PCIE_PL_PHY_CTRL register
 */
/*@{*/
#define HW_PCIE_PL_PHY_CTRL_ADDR(x) ((uintptr_t)(x) + 0x814U)

#define HW_PCIE_PL_PHY_CTRL(x)   (*(__IO hw_pcie_pl_phy_ctrl_t *) HW_PCIE_PL_PHY_CTRL_ADDR(x))
#define HW_PCIE_PL_PHY_CTRL_RD(x) (HW_PCIE_PL_PHY_CTRL(x).U)
#define HW_PCIE_PL_PHY_CTRL_WR(x, v) (HW_PCIE_PL_PHY_CTRL(x).U = (v))
#define HW_PCIE_PL_PHY_CTRL_SET(x, v) (HW_PCIE_PL_PHY_CTRL_WR(x, HW_PCIE_PL_PHY_CTRL_RD(x) |  (v)))
#define HW_PCIE_PL_PHY_CTRL_CLR(x, v) (HW_PCIE_PL_PHY_CTRL_WR(x, HW_PCIE_PL_PHY_CTRL_RD(x) & ~(v)))
#define HW_PCIE_PL_PHY_CTRL_TOG(x, v) (HW_PCIE_PL_PHY_CTRL_WR(x, HW_PCIE_PL_PHY_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_PHY_CTRL bitfields
 */

/*!
 * @name Register PCIE_PL_PHY_CTRL, field PHY_Control[31:0] (RW)
 *
 * PHY Control Data sent directly to the cfg_phy_control bus.
 */
/*@{*/
#define BP_PCIE_PL_PHY_CTRL_PHY_Control (0U) /*!< Bit position for PCIE_PL_PHY_CTRL_PHY_Control. */
#define BM_PCIE_PL_PHY_CTRL_PHY_Control (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_PHY_CTRL_PHY_Control. */
#define BS_PCIE_PL_PHY_CTRL_PHY_Control (32U) /*!< Bit field size in bits for PCIE_PL_PHY_CTRL_PHY_Control. */

/*! @brief Read current value of the PCIE_PL_PHY_CTRL_PHY_Control field. */
#define BR_PCIE_PL_PHY_CTRL_PHY_Control(x) (HW_PCIE_PL_PHY_CTRL(x).U)

/*! @brief Format value for bitfield PCIE_PL_PHY_CTRL_PHY_Control. */
#define BF_PCIE_PL_PHY_CTRL_PHY_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_PHY_CTRL_PHY_Control) & BM_PCIE_PL_PHY_CTRL_PHY_Control)

/*! @brief Set the PHY_Control field to a new value. */
#define BW_PCIE_PL_PHY_CTRL_PHY_Control(x, v) (HW_PCIE_PL_PHY_CTRL_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MRCCR0 - Master Response Composer Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MRCCR0 - Master Response Composer Control Register 0 (RW)
 *
 * Reset value: 0x00000302U
 *
 * You must not modify these registers for AHB configurations, as this feature
 * is only supported for AXI. Offset: 0x700 + 0x118
 */
typedef union _hw_pcie_pl_mrccr0
{
    uint32_t U;
    struct _hw_pcie_pl_mrccr0_bitfields
    {
        uint32_t Remote_Read_Request_Size : 3; /*!< [2:0]  */
        uint32_t RESERVED0 : 5;        /*!< [7:3]  */
        uint32_t Remote_Max_Bridge_Tag : 8; /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_pcie_pl_mrccr0_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MRCCR0 register
 */
/*@{*/
#define HW_PCIE_PL_MRCCR0_ADDR(x) ((uintptr_t)(x) + 0x818U)

#define HW_PCIE_PL_MRCCR0(x)     (*(__IO hw_pcie_pl_mrccr0_t *) HW_PCIE_PL_MRCCR0_ADDR(x))
#define HW_PCIE_PL_MRCCR0_RD(x)  (HW_PCIE_PL_MRCCR0(x).U)
#define HW_PCIE_PL_MRCCR0_WR(x, v) (HW_PCIE_PL_MRCCR0(x).U = (v))
#define HW_PCIE_PL_MRCCR0_SET(x, v) (HW_PCIE_PL_MRCCR0_WR(x, HW_PCIE_PL_MRCCR0_RD(x) |  (v)))
#define HW_PCIE_PL_MRCCR0_CLR(x, v) (HW_PCIE_PL_MRCCR0_WR(x, HW_PCIE_PL_MRCCR0_RD(x) & ~(v)))
#define HW_PCIE_PL_MRCCR0_TOG(x, v) (HW_PCIE_PL_MRCCR0_WR(x, HW_PCIE_PL_MRCCR0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MRCCR0 bitfields
 */

/*!
 * @name Register PCIE_PL_MRCCR0, field Remote_Read_Request_Size[2:0] (RW)
 *
 * Remote Read Request Size Specifies the largest amount of data (bytes) that
 * will ever be requested (via an inbound MemRd TLP) by a remote device. Must never
 * be programmed with a value that exceeds the value represented by the
 * configuration parameter CX_REMOTE_RD_REQ_SIZE as the Master Response Composer RAM in
 * the AXI bridge is sized using CX_REMOTE_RD_REQ_SIZE. Must only be programmed
 * with the values 3'b000 to 3'b101. Any other value has the same effect as writing
 * a value of 3'b000. Encoding is as follows:
 *
 * Values:
 * - 000 - 128
 * - 001 - 256
 * - 010 - 512
 * - 011 - 1024
 * - 100 - 2048
 * - 101 - 4096 default: 128
 */
/*@{*/
#define BP_PCIE_PL_MRCCR0_Remote_Read_Request_Size (0U) /*!< Bit position for PCIE_PL_MRCCR0_Remote_Read_Request_Size. */
#define BM_PCIE_PL_MRCCR0_Remote_Read_Request_Size (0x00000007U) /*!< Bit mask for PCIE_PL_MRCCR0_Remote_Read_Request_Size. */
#define BS_PCIE_PL_MRCCR0_Remote_Read_Request_Size (3U) /*!< Bit field size in bits for PCIE_PL_MRCCR0_Remote_Read_Request_Size. */

/*! @brief Read current value of the PCIE_PL_MRCCR0_Remote_Read_Request_Size field. */
#define BR_PCIE_PL_MRCCR0_Remote_Read_Request_Size(x) (HW_PCIE_PL_MRCCR0(x).B.Remote_Read_Request_Size)

/*! @brief Format value for bitfield PCIE_PL_MRCCR0_Remote_Read_Request_Size. */
#define BF_PCIE_PL_MRCCR0_Remote_Read_Request_Size(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MRCCR0_Remote_Read_Request_Size) & BM_PCIE_PL_MRCCR0_Remote_Read_Request_Size)

/*! @brief Set the Remote_Read_Request_Size field to a new value. */
#define BW_PCIE_PL_MRCCR0_Remote_Read_Request_Size(x, v) (HW_PCIE_PL_MRCCR0_WR(x, (HW_PCIE_PL_MRCCR0_RD(x) & ~BM_PCIE_PL_MRCCR0_Remote_Read_Request_Size) | BF_PCIE_PL_MRCCR0_Remote_Read_Request_Size(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_MRCCR0, field Remote_Max_Bridge_Tag[15:8] (RW)
 *
 * Remote Max Bridge Tag Specifies the maximum number (-1) of Non-Posted AMBA
 * requests outstanding at one time issued from the bridge master. Excludes any
 * internally created TLP's as a result of decomposition. The core will
 * automatically derive this when bits[2:0] (Remote Read Request Size) are written to. It is
 * s saturated in core at CX_REMOTE_MAX_TAG since the TRGT_CPL_LUT has only this
 * many entries. Therefore it is important that the core is initially sized (at
 * configuration time pre-silicon) with the true maximum value of
 * CX_REMOTE_MAX_TAG to take advantage of the ability to dynamically increase
 * remote_max_bridge_tag from CX_REMOTE_MAX_BRIDGE_TAG to any new value up to a maximum of
 * CX_REMOTE_MAX_TAG
 */
/*@{*/
#define BP_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag (8U) /*!< Bit position for PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag. */
#define BM_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag (0x0000FF00U) /*!< Bit mask for PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag. */
#define BS_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag (8U) /*!< Bit field size in bits for PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag. */

/*! @brief Read current value of the PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag field. */
#define BR_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag(x) (HW_PCIE_PL_MRCCR0(x).B.Remote_Max_Bridge_Tag)

/*! @brief Format value for bitfield PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag. */
#define BF_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag) & BM_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag)

/*! @brief Set the Remote_Max_Bridge_Tag field to a new value. */
#define BW_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag(x, v) (HW_PCIE_PL_MRCCR0_WR(x, (HW_PCIE_PL_MRCCR0_RD(x) & ~BM_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag) | BF_PCIE_PL_MRCCR0_Remote_Max_Bridge_Tag(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MRCCR1 - Master Response Composer Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MRCCR1 - Master Response Composer Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x11C
 */
typedef union _hw_pcie_pl_mrccr1
{
    uint32_t U;
    struct _hw_pcie_pl_mrccr1_bitfields
    {
        uint32_t Segmented_Buffer_Controller_Initialize : 1; /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pcie_pl_mrccr1_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MRCCR1 register
 */
/*@{*/
#define HW_PCIE_PL_MRCCR1_ADDR(x) ((uintptr_t)(x) + 0x81CU)

#define HW_PCIE_PL_MRCCR1(x)     (*(__IO hw_pcie_pl_mrccr1_t *) HW_PCIE_PL_MRCCR1_ADDR(x))
#define HW_PCIE_PL_MRCCR1_RD(x)  (HW_PCIE_PL_MRCCR1(x).U)
#define HW_PCIE_PL_MRCCR1_WR(x, v) (HW_PCIE_PL_MRCCR1(x).U = (v))
#define HW_PCIE_PL_MRCCR1_SET(x, v) (HW_PCIE_PL_MRCCR1_WR(x, HW_PCIE_PL_MRCCR1_RD(x) |  (v)))
#define HW_PCIE_PL_MRCCR1_CLR(x, v) (HW_PCIE_PL_MRCCR1_WR(x, HW_PCIE_PL_MRCCR1_RD(x) & ~(v)))
#define HW_PCIE_PL_MRCCR1_TOG(x, v) (HW_PCIE_PL_MRCCR1_WR(x, HW_PCIE_PL_MRCCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MRCCR1 bitfields
 */

/*!
 * @name Register PCIE_PL_MRCCR1, field Segmented_Buffer_Controller_Initialize[0] (RW)
 *
 * Segmented Buffer Controller Initialize. Writing '1' to this (self-clearing
 * register) causes any changes in the Master Response Composer Control Register 0
 * to take place in the bridge hardware. The sbc_init register triggers the
 * initialization of the segmented buffer controller (DWC_sbc). When sbc_init is
 * written to, the segmented buffer controller (DWC_sbc) samples
 * cfg_remote_max_bridge_tag and starts the internal finite state machine (FSM). * Reading from this
 * self-clearing register field always returns a 0.
 */
/*@{*/
#define BP_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize (0U) /*!< Bit position for PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize. */
#define BM_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize (0x00000001U) /*!< Bit mask for PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize. */
#define BS_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize (1U) /*!< Bit field size in bits for PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize. */

/*! @brief Read current value of the PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize field. */
#define BR_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize(x) (HW_PCIE_PL_MRCCR1(x).B.Segmented_Buffer_Controller_Initialize)

/*! @brief Format value for bitfield PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize. */
#define BF_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize) & BM_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize)

/*! @brief Set the Segmented_Buffer_Controller_Initialize field to a new value. */
#define BW_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize(x, v) (HW_PCIE_PL_MRCCR1_WR(x, (HW_PCIE_PL_MRCCR1_RD(x) & ~BM_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize) | BF_PCIE_PL_MRCCR1_Segmented_Buffer_Controller_Initialize(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICA - MSI Controller Address
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICA - MSI Controller Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * See AHB/AXI MSI Controller (Optional in RC mode). These registers are not
 * part of the PCI Express MSI Capability Register structure which is detailed at
 * MSI Capability Register Details. Offset: 0x700 + 0x120
 */
typedef union _hw_pcie_pl_msica
{
    uint32_t U;
    struct _hw_pcie_pl_msica_bitfields
    {
        uint32_t MSI_Controller_Address : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msica_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICA register
 */
/*@{*/
#define HW_PCIE_PL_MSICA_ADDR(x) ((uintptr_t)(x) + 0x820U)

#define HW_PCIE_PL_MSICA(x)      (*(__IO hw_pcie_pl_msica_t *) HW_PCIE_PL_MSICA_ADDR(x))
#define HW_PCIE_PL_MSICA_RD(x)   (HW_PCIE_PL_MSICA(x).U)
#define HW_PCIE_PL_MSICA_WR(x, v) (HW_PCIE_PL_MSICA(x).U = (v))
#define HW_PCIE_PL_MSICA_SET(x, v) (HW_PCIE_PL_MSICA_WR(x, HW_PCIE_PL_MSICA_RD(x) |  (v)))
#define HW_PCIE_PL_MSICA_CLR(x, v) (HW_PCIE_PL_MSICA_WR(x, HW_PCIE_PL_MSICA_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICA_TOG(x, v) (HW_PCIE_PL_MSICA_WR(x, HW_PCIE_PL_MSICA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICA bitfields
 */

/*!
 * @name Register PCIE_PL_MSICA, field MSI_Controller_Address[31:0] (RW)
 *
 * MSI Controller Address System specified address for MSI memory write
 * transaction termination. Within the AHB/AXI Bridge, every received Memory Write
 * Request is examined to see if it targets the MSI Address that has been specified in
 * the MSI Controller Address Register and also to see if it satisfies the
 * definition of an MSI Interrupt Request. If these conditions are satisfied the Memory
 * Write Request is marked as an MSI Request.
 */
/*@{*/
#define BP_PCIE_PL_MSICA_MSI_Controller_Address (0U) /*!< Bit position for PCIE_PL_MSICA_MSI_Controller_Address. */
#define BM_PCIE_PL_MSICA_MSI_Controller_Address (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICA_MSI_Controller_Address. */
#define BS_PCIE_PL_MSICA_MSI_Controller_Address (32U) /*!< Bit field size in bits for PCIE_PL_MSICA_MSI_Controller_Address. */

/*! @brief Read current value of the PCIE_PL_MSICA_MSI_Controller_Address field. */
#define BR_PCIE_PL_MSICA_MSI_Controller_Address(x) (HW_PCIE_PL_MSICA(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICA_MSI_Controller_Address. */
#define BF_PCIE_PL_MSICA_MSI_Controller_Address(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICA_MSI_Controller_Address) & BM_PCIE_PL_MSICA_MSI_Controller_Address)

/*! @brief Set the MSI_Controller_Address field to a new value. */
#define BW_PCIE_PL_MSICA_MSI_Controller_Address(x, v) (HW_PCIE_PL_MSICA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICUA - MSI Controller Upper Address
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICUA - MSI Controller Upper Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x124
 */
typedef union _hw_pcie_pl_msicua
{
    uint32_t U;
    struct _hw_pcie_pl_msicua_bitfields
    {
        uint32_t MSI_Controller_Upper_Address : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msicua_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICUA register
 */
/*@{*/
#define HW_PCIE_PL_MSICUA_ADDR(x) ((uintptr_t)(x) + 0x824U)

#define HW_PCIE_PL_MSICUA(x)     (*(__IO hw_pcie_pl_msicua_t *) HW_PCIE_PL_MSICUA_ADDR(x))
#define HW_PCIE_PL_MSICUA_RD(x)  (HW_PCIE_PL_MSICUA(x).U)
#define HW_PCIE_PL_MSICUA_WR(x, v) (HW_PCIE_PL_MSICUA(x).U = (v))
#define HW_PCIE_PL_MSICUA_SET(x, v) (HW_PCIE_PL_MSICUA_WR(x, HW_PCIE_PL_MSICUA_RD(x) |  (v)))
#define HW_PCIE_PL_MSICUA_CLR(x, v) (HW_PCIE_PL_MSICUA_WR(x, HW_PCIE_PL_MSICUA_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICUA_TOG(x, v) (HW_PCIE_PL_MSICUA_WR(x, HW_PCIE_PL_MSICUA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICUA bitfields
 */

/*!
 * @name Register PCIE_PL_MSICUA, field MSI_Controller_Upper_Address[31:0] (RW)
 *
 * MSI Controller Upper Address System specified upper address for MSI memory
 * write transaction termination. Allows functions to support a 64- bit MSI address.
 */
/*@{*/
#define BP_PCIE_PL_MSICUA_MSI_Controller_Upper_Address (0U) /*!< Bit position for PCIE_PL_MSICUA_MSI_Controller_Upper_Address. */
#define BM_PCIE_PL_MSICUA_MSI_Controller_Upper_Address (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICUA_MSI_Controller_Upper_Address. */
#define BS_PCIE_PL_MSICUA_MSI_Controller_Upper_Address (32U) /*!< Bit field size in bits for PCIE_PL_MSICUA_MSI_Controller_Upper_Address. */

/*! @brief Read current value of the PCIE_PL_MSICUA_MSI_Controller_Upper_Address field. */
#define BR_PCIE_PL_MSICUA_MSI_Controller_Upper_Address(x) (HW_PCIE_PL_MSICUA(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICUA_MSI_Controller_Upper_Address. */
#define BF_PCIE_PL_MSICUA_MSI_Controller_Upper_Address(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICUA_MSI_Controller_Upper_Address) & BM_PCIE_PL_MSICUA_MSI_Controller_Upper_Address)

/*! @brief Set the MSI_Controller_Upper_Address field to a new value. */
#define BW_PCIE_PL_MSICUA_MSI_Controller_Upper_Address(x, v) (HW_PCIE_PL_MSICUA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI0_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI0_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici0_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici0_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici0_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI0_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI0_ENB_ADDR(x) ((uintptr_t)(x) + 0x828U)

#define HW_PCIE_PL_MSICI0_ENB(x) (*(__IO hw_pcie_pl_msici0_enb_t *) HW_PCIE_PL_MSICI0_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI0_ENB_RD(x) (HW_PCIE_PL_MSICI0_ENB(x).U)
#define HW_PCIE_PL_MSICI0_ENB_WR(x, v) (HW_PCIE_PL_MSICI0_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI0_ENB_SET(x, v) (HW_PCIE_PL_MSICI0_ENB_WR(x, HW_PCIE_PL_MSICI0_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI0_ENB_CLR(x, v) (HW_PCIE_PL_MSICI0_ENB_WR(x, HW_PCIE_PL_MSICI0_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI0_ENB_TOG(x, v) (HW_PCIE_PL_MSICI0_ENB_WR(x, HW_PCIE_PL_MSICI0_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI0_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI0_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI0_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI0_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI0_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI0_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI0_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici0_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici0_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici0_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI0_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI0_MASK_ADDR(x) ((uintptr_t)(x) + 0x82CU)

#define HW_PCIE_PL_MSICI0_MASK(x) (*(__IO hw_pcie_pl_msici0_mask_t *) HW_PCIE_PL_MSICI0_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI0_MASK_RD(x) (HW_PCIE_PL_MSICI0_MASK(x).U)
#define HW_PCIE_PL_MSICI0_MASK_WR(x, v) (HW_PCIE_PL_MSICI0_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI0_MASK_SET(x, v) (HW_PCIE_PL_MSICI0_MASK_WR(x, HW_PCIE_PL_MSICI0_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI0_MASK_CLR(x, v) (HW_PCIE_PL_MSICI0_MASK_WR(x, HW_PCIE_PL_MSICI0_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI0_MASK_TOG(x, v) (HW_PCIE_PL_MSICI0_MASK_WR(x, HW_PCIE_PL_MSICI0_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI0_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI0_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI0_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI0_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI0_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI0_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI0_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici0_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici0_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici0_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI0_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI0_STATUS_ADDR(x) ((uintptr_t)(x) + 0x830U)

#define HW_PCIE_PL_MSICI0_STATUS(x) (*(__IO hw_pcie_pl_msici0_status_t *) HW_PCIE_PL_MSICI0_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI0_STATUS_RD(x) (HW_PCIE_PL_MSICI0_STATUS(x).U)
#define HW_PCIE_PL_MSICI0_STATUS_WR(x, v) (HW_PCIE_PL_MSICI0_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI0_STATUS_SET(x, v) (HW_PCIE_PL_MSICI0_STATUS_WR(x, HW_PCIE_PL_MSICI0_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI0_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI0_STATUS_WR(x, HW_PCIE_PL_MSICI0_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI0_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI0_STATUS_WR(x, HW_PCIE_PL_MSICI0_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI0_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI0_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI0_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI0_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI0_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI1_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI1_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici1_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici1_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici1_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI1_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI1_ENB_ADDR(x) ((uintptr_t)(x) + 0x834U)

#define HW_PCIE_PL_MSICI1_ENB(x) (*(__IO hw_pcie_pl_msici1_enb_t *) HW_PCIE_PL_MSICI1_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI1_ENB_RD(x) (HW_PCIE_PL_MSICI1_ENB(x).U)
#define HW_PCIE_PL_MSICI1_ENB_WR(x, v) (HW_PCIE_PL_MSICI1_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI1_ENB_SET(x, v) (HW_PCIE_PL_MSICI1_ENB_WR(x, HW_PCIE_PL_MSICI1_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI1_ENB_CLR(x, v) (HW_PCIE_PL_MSICI1_ENB_WR(x, HW_PCIE_PL_MSICI1_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI1_ENB_TOG(x, v) (HW_PCIE_PL_MSICI1_ENB_WR(x, HW_PCIE_PL_MSICI1_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI1_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI1_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI1_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI1_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI1_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI1_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI1_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici1_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici1_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici1_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI1_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI1_MASK_ADDR(x) ((uintptr_t)(x) + 0x838U)

#define HW_PCIE_PL_MSICI1_MASK(x) (*(__IO hw_pcie_pl_msici1_mask_t *) HW_PCIE_PL_MSICI1_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI1_MASK_RD(x) (HW_PCIE_PL_MSICI1_MASK(x).U)
#define HW_PCIE_PL_MSICI1_MASK_WR(x, v) (HW_PCIE_PL_MSICI1_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI1_MASK_SET(x, v) (HW_PCIE_PL_MSICI1_MASK_WR(x, HW_PCIE_PL_MSICI1_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI1_MASK_CLR(x, v) (HW_PCIE_PL_MSICI1_MASK_WR(x, HW_PCIE_PL_MSICI1_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI1_MASK_TOG(x, v) (HW_PCIE_PL_MSICI1_MASK_WR(x, HW_PCIE_PL_MSICI1_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI1_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI1_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI1_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI1_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI1_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI1_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI1_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici1_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici1_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici1_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI1_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI1_STATUS_ADDR(x) ((uintptr_t)(x) + 0x83CU)

#define HW_PCIE_PL_MSICI1_STATUS(x) (*(__IO hw_pcie_pl_msici1_status_t *) HW_PCIE_PL_MSICI1_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI1_STATUS_RD(x) (HW_PCIE_PL_MSICI1_STATUS(x).U)
#define HW_PCIE_PL_MSICI1_STATUS_WR(x, v) (HW_PCIE_PL_MSICI1_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI1_STATUS_SET(x, v) (HW_PCIE_PL_MSICI1_STATUS_WR(x, HW_PCIE_PL_MSICI1_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI1_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI1_STATUS_WR(x, HW_PCIE_PL_MSICI1_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI1_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI1_STATUS_WR(x, HW_PCIE_PL_MSICI1_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI1_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI1_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI1_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI1_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI1_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI2_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI2_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici2_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici2_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici2_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI2_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI2_ENB_ADDR(x) ((uintptr_t)(x) + 0x840U)

#define HW_PCIE_PL_MSICI2_ENB(x) (*(__IO hw_pcie_pl_msici2_enb_t *) HW_PCIE_PL_MSICI2_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI2_ENB_RD(x) (HW_PCIE_PL_MSICI2_ENB(x).U)
#define HW_PCIE_PL_MSICI2_ENB_WR(x, v) (HW_PCIE_PL_MSICI2_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI2_ENB_SET(x, v) (HW_PCIE_PL_MSICI2_ENB_WR(x, HW_PCIE_PL_MSICI2_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI2_ENB_CLR(x, v) (HW_PCIE_PL_MSICI2_ENB_WR(x, HW_PCIE_PL_MSICI2_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI2_ENB_TOG(x, v) (HW_PCIE_PL_MSICI2_ENB_WR(x, HW_PCIE_PL_MSICI2_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI2_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI2_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI2_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI2_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI2_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI2_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI2_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici2_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici2_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici2_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI2_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI2_MASK_ADDR(x) ((uintptr_t)(x) + 0x844U)

#define HW_PCIE_PL_MSICI2_MASK(x) (*(__IO hw_pcie_pl_msici2_mask_t *) HW_PCIE_PL_MSICI2_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI2_MASK_RD(x) (HW_PCIE_PL_MSICI2_MASK(x).U)
#define HW_PCIE_PL_MSICI2_MASK_WR(x, v) (HW_PCIE_PL_MSICI2_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI2_MASK_SET(x, v) (HW_PCIE_PL_MSICI2_MASK_WR(x, HW_PCIE_PL_MSICI2_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI2_MASK_CLR(x, v) (HW_PCIE_PL_MSICI2_MASK_WR(x, HW_PCIE_PL_MSICI2_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI2_MASK_TOG(x, v) (HW_PCIE_PL_MSICI2_MASK_WR(x, HW_PCIE_PL_MSICI2_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI2_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI2_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI2_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI2_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI2_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI2_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI2_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici2_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici2_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici2_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI2_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI2_STATUS_ADDR(x) ((uintptr_t)(x) + 0x848U)

#define HW_PCIE_PL_MSICI2_STATUS(x) (*(__IO hw_pcie_pl_msici2_status_t *) HW_PCIE_PL_MSICI2_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI2_STATUS_RD(x) (HW_PCIE_PL_MSICI2_STATUS(x).U)
#define HW_PCIE_PL_MSICI2_STATUS_WR(x, v) (HW_PCIE_PL_MSICI2_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI2_STATUS_SET(x, v) (HW_PCIE_PL_MSICI2_STATUS_WR(x, HW_PCIE_PL_MSICI2_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI2_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI2_STATUS_WR(x, HW_PCIE_PL_MSICI2_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI2_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI2_STATUS_WR(x, HW_PCIE_PL_MSICI2_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI2_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI2_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI2_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI2_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI2_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI3_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI3_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici3_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici3_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici3_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI3_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI3_ENB_ADDR(x) ((uintptr_t)(x) + 0x84CU)

#define HW_PCIE_PL_MSICI3_ENB(x) (*(__IO hw_pcie_pl_msici3_enb_t *) HW_PCIE_PL_MSICI3_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI3_ENB_RD(x) (HW_PCIE_PL_MSICI3_ENB(x).U)
#define HW_PCIE_PL_MSICI3_ENB_WR(x, v) (HW_PCIE_PL_MSICI3_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI3_ENB_SET(x, v) (HW_PCIE_PL_MSICI3_ENB_WR(x, HW_PCIE_PL_MSICI3_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI3_ENB_CLR(x, v) (HW_PCIE_PL_MSICI3_ENB_WR(x, HW_PCIE_PL_MSICI3_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI3_ENB_TOG(x, v) (HW_PCIE_PL_MSICI3_ENB_WR(x, HW_PCIE_PL_MSICI3_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI3_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI3_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI3_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI3_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI3_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI3_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI3_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici3_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici3_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici3_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI3_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI3_MASK_ADDR(x) ((uintptr_t)(x) + 0x850U)

#define HW_PCIE_PL_MSICI3_MASK(x) (*(__IO hw_pcie_pl_msici3_mask_t *) HW_PCIE_PL_MSICI3_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI3_MASK_RD(x) (HW_PCIE_PL_MSICI3_MASK(x).U)
#define HW_PCIE_PL_MSICI3_MASK_WR(x, v) (HW_PCIE_PL_MSICI3_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI3_MASK_SET(x, v) (HW_PCIE_PL_MSICI3_MASK_WR(x, HW_PCIE_PL_MSICI3_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI3_MASK_CLR(x, v) (HW_PCIE_PL_MSICI3_MASK_WR(x, HW_PCIE_PL_MSICI3_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI3_MASK_TOG(x, v) (HW_PCIE_PL_MSICI3_MASK_WR(x, HW_PCIE_PL_MSICI3_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI3_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI3_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI3_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI3_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI3_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI3_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI3_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici3_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici3_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici3_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI3_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI3_STATUS_ADDR(x) ((uintptr_t)(x) + 0x854U)

#define HW_PCIE_PL_MSICI3_STATUS(x) (*(__IO hw_pcie_pl_msici3_status_t *) HW_PCIE_PL_MSICI3_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI3_STATUS_RD(x) (HW_PCIE_PL_MSICI3_STATUS(x).U)
#define HW_PCIE_PL_MSICI3_STATUS_WR(x, v) (HW_PCIE_PL_MSICI3_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI3_STATUS_SET(x, v) (HW_PCIE_PL_MSICI3_STATUS_WR(x, HW_PCIE_PL_MSICI3_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI3_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI3_STATUS_WR(x, HW_PCIE_PL_MSICI3_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI3_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI3_STATUS_WR(x, HW_PCIE_PL_MSICI3_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI3_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI3_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI3_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI3_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI3_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI4_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI4_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici4_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici4_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici4_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI4_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI4_ENB_ADDR(x) ((uintptr_t)(x) + 0x858U)

#define HW_PCIE_PL_MSICI4_ENB(x) (*(__IO hw_pcie_pl_msici4_enb_t *) HW_PCIE_PL_MSICI4_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI4_ENB_RD(x) (HW_PCIE_PL_MSICI4_ENB(x).U)
#define HW_PCIE_PL_MSICI4_ENB_WR(x, v) (HW_PCIE_PL_MSICI4_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI4_ENB_SET(x, v) (HW_PCIE_PL_MSICI4_ENB_WR(x, HW_PCIE_PL_MSICI4_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI4_ENB_CLR(x, v) (HW_PCIE_PL_MSICI4_ENB_WR(x, HW_PCIE_PL_MSICI4_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI4_ENB_TOG(x, v) (HW_PCIE_PL_MSICI4_ENB_WR(x, HW_PCIE_PL_MSICI4_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI4_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI4_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI4_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI4_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI4_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI4_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI4_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici4_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici4_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici4_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI4_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI4_MASK_ADDR(x) ((uintptr_t)(x) + 0x85CU)

#define HW_PCIE_PL_MSICI4_MASK(x) (*(__IO hw_pcie_pl_msici4_mask_t *) HW_PCIE_PL_MSICI4_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI4_MASK_RD(x) (HW_PCIE_PL_MSICI4_MASK(x).U)
#define HW_PCIE_PL_MSICI4_MASK_WR(x, v) (HW_PCIE_PL_MSICI4_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI4_MASK_SET(x, v) (HW_PCIE_PL_MSICI4_MASK_WR(x, HW_PCIE_PL_MSICI4_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI4_MASK_CLR(x, v) (HW_PCIE_PL_MSICI4_MASK_WR(x, HW_PCIE_PL_MSICI4_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI4_MASK_TOG(x, v) (HW_PCIE_PL_MSICI4_MASK_WR(x, HW_PCIE_PL_MSICI4_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI4_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI4_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI4_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI4_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI4_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI4_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI4_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici4_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici4_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici4_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI4_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI4_STATUS_ADDR(x) ((uintptr_t)(x) + 0x860U)

#define HW_PCIE_PL_MSICI4_STATUS(x) (*(__IO hw_pcie_pl_msici4_status_t *) HW_PCIE_PL_MSICI4_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI4_STATUS_RD(x) (HW_PCIE_PL_MSICI4_STATUS(x).U)
#define HW_PCIE_PL_MSICI4_STATUS_WR(x, v) (HW_PCIE_PL_MSICI4_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI4_STATUS_SET(x, v) (HW_PCIE_PL_MSICI4_STATUS_WR(x, HW_PCIE_PL_MSICI4_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI4_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI4_STATUS_WR(x, HW_PCIE_PL_MSICI4_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI4_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI4_STATUS_WR(x, HW_PCIE_PL_MSICI4_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI4_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI4_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI4_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI4_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI4_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI5_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI5_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici5_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici5_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici5_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI5_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI5_ENB_ADDR(x) ((uintptr_t)(x) + 0x864U)

#define HW_PCIE_PL_MSICI5_ENB(x) (*(__IO hw_pcie_pl_msici5_enb_t *) HW_PCIE_PL_MSICI5_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI5_ENB_RD(x) (HW_PCIE_PL_MSICI5_ENB(x).U)
#define HW_PCIE_PL_MSICI5_ENB_WR(x, v) (HW_PCIE_PL_MSICI5_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI5_ENB_SET(x, v) (HW_PCIE_PL_MSICI5_ENB_WR(x, HW_PCIE_PL_MSICI5_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI5_ENB_CLR(x, v) (HW_PCIE_PL_MSICI5_ENB_WR(x, HW_PCIE_PL_MSICI5_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI5_ENB_TOG(x, v) (HW_PCIE_PL_MSICI5_ENB_WR(x, HW_PCIE_PL_MSICI5_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI5_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI5_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI5_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI5_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI5_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI5_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI5_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici5_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici5_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici5_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI5_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI5_MASK_ADDR(x) ((uintptr_t)(x) + 0x868U)

#define HW_PCIE_PL_MSICI5_MASK(x) (*(__IO hw_pcie_pl_msici5_mask_t *) HW_PCIE_PL_MSICI5_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI5_MASK_RD(x) (HW_PCIE_PL_MSICI5_MASK(x).U)
#define HW_PCIE_PL_MSICI5_MASK_WR(x, v) (HW_PCIE_PL_MSICI5_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI5_MASK_SET(x, v) (HW_PCIE_PL_MSICI5_MASK_WR(x, HW_PCIE_PL_MSICI5_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI5_MASK_CLR(x, v) (HW_PCIE_PL_MSICI5_MASK_WR(x, HW_PCIE_PL_MSICI5_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI5_MASK_TOG(x, v) (HW_PCIE_PL_MSICI5_MASK_WR(x, HW_PCIE_PL_MSICI5_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI5_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI5_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI5_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI5_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI5_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI5_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI5_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici5_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici5_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici5_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI5_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI5_STATUS_ADDR(x) ((uintptr_t)(x) + 0x86CU)

#define HW_PCIE_PL_MSICI5_STATUS(x) (*(__IO hw_pcie_pl_msici5_status_t *) HW_PCIE_PL_MSICI5_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI5_STATUS_RD(x) (HW_PCIE_PL_MSICI5_STATUS(x).U)
#define HW_PCIE_PL_MSICI5_STATUS_WR(x, v) (HW_PCIE_PL_MSICI5_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI5_STATUS_SET(x, v) (HW_PCIE_PL_MSICI5_STATUS_WR(x, HW_PCIE_PL_MSICI5_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI5_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI5_STATUS_WR(x, HW_PCIE_PL_MSICI5_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI5_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI5_STATUS_WR(x, HW_PCIE_PL_MSICI5_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI5_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI5_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI5_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI5_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI5_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI6_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI6_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici6_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici6_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici6_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI6_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI6_ENB_ADDR(x) ((uintptr_t)(x) + 0x870U)

#define HW_PCIE_PL_MSICI6_ENB(x) (*(__IO hw_pcie_pl_msici6_enb_t *) HW_PCIE_PL_MSICI6_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI6_ENB_RD(x) (HW_PCIE_PL_MSICI6_ENB(x).U)
#define HW_PCIE_PL_MSICI6_ENB_WR(x, v) (HW_PCIE_PL_MSICI6_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI6_ENB_SET(x, v) (HW_PCIE_PL_MSICI6_ENB_WR(x, HW_PCIE_PL_MSICI6_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI6_ENB_CLR(x, v) (HW_PCIE_PL_MSICI6_ENB_WR(x, HW_PCIE_PL_MSICI6_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI6_ENB_TOG(x, v) (HW_PCIE_PL_MSICI6_ENB_WR(x, HW_PCIE_PL_MSICI6_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI6_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI6_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI6_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI6_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI6_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI6_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI6_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici6_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici6_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici6_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI6_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI6_MASK_ADDR(x) ((uintptr_t)(x) + 0x874U)

#define HW_PCIE_PL_MSICI6_MASK(x) (*(__IO hw_pcie_pl_msici6_mask_t *) HW_PCIE_PL_MSICI6_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI6_MASK_RD(x) (HW_PCIE_PL_MSICI6_MASK(x).U)
#define HW_PCIE_PL_MSICI6_MASK_WR(x, v) (HW_PCIE_PL_MSICI6_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI6_MASK_SET(x, v) (HW_PCIE_PL_MSICI6_MASK_WR(x, HW_PCIE_PL_MSICI6_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI6_MASK_CLR(x, v) (HW_PCIE_PL_MSICI6_MASK_WR(x, HW_PCIE_PL_MSICI6_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI6_MASK_TOG(x, v) (HW_PCIE_PL_MSICI6_MASK_WR(x, HW_PCIE_PL_MSICI6_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI6_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI6_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI6_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI6_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI6_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI6_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI6_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici6_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici6_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici6_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI6_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI6_STATUS_ADDR(x) ((uintptr_t)(x) + 0x878U)

#define HW_PCIE_PL_MSICI6_STATUS(x) (*(__IO hw_pcie_pl_msici6_status_t *) HW_PCIE_PL_MSICI6_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI6_STATUS_RD(x) (HW_PCIE_PL_MSICI6_STATUS(x).U)
#define HW_PCIE_PL_MSICI6_STATUS_WR(x, v) (HW_PCIE_PL_MSICI6_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI6_STATUS_SET(x, v) (HW_PCIE_PL_MSICI6_STATUS_WR(x, HW_PCIE_PL_MSICI6_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI6_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI6_STATUS_WR(x, HW_PCIE_PL_MSICI6_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI6_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI6_STATUS_WR(x, HW_PCIE_PL_MSICI6_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI6_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI6_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI6_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI6_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI6_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI7_ENB - MSI Controller Interrupt n Enable
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI7_ENB - MSI Controller Interrupt n Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x128 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici7_enb
{
    uint32_t U;
    struct _hw_pcie_pl_msici7_enb_bitfields
    {
        uint32_t MSI_Interruptn_Enable : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici7_enb_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI7_ENB register
 */
/*@{*/
#define HW_PCIE_PL_MSICI7_ENB_ADDR(x) ((uintptr_t)(x) + 0x87CU)

#define HW_PCIE_PL_MSICI7_ENB(x) (*(__IO hw_pcie_pl_msici7_enb_t *) HW_PCIE_PL_MSICI7_ENB_ADDR(x))
#define HW_PCIE_PL_MSICI7_ENB_RD(x) (HW_PCIE_PL_MSICI7_ENB(x).U)
#define HW_PCIE_PL_MSICI7_ENB_WR(x, v) (HW_PCIE_PL_MSICI7_ENB(x).U = (v))
#define HW_PCIE_PL_MSICI7_ENB_SET(x, v) (HW_PCIE_PL_MSICI7_ENB_WR(x, HW_PCIE_PL_MSICI7_ENB_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI7_ENB_CLR(x, v) (HW_PCIE_PL_MSICI7_ENB_WR(x, HW_PCIE_PL_MSICI7_ENB_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI7_ENB_TOG(x, v) (HW_PCIE_PL_MSICI7_ENB_WR(x, HW_PCIE_PL_MSICI7_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI7_ENB bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI7_ENB, field MSI_Interruptn_Enable[31:0] (RW)
 *
 * MSI Interrupt#n Enable Specifies which interrupts are enabled. If an MSI is
 * received from a disabled interrupt, no status bit gets set in MSI Controller
 * Interrupt Status Register. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable (0U) /*!< Bit position for PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable. */
#define BM_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable. */
#define BS_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable (32U) /*!< Bit field size in bits for PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable. */

/*! @brief Read current value of the PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable field. */
#define BR_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable(x) (HW_PCIE_PL_MSICI7_ENB(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable. */
#define BF_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable) & BM_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable)

/*! @brief Set the MSI_Interruptn_Enable field to a new value. */
#define BW_PCIE_PL_MSICI7_ENB_MSI_Interruptn_Enable(x, v) (HW_PCIE_PL_MSICI7_ENB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI7_MASK - MSI Controller Interrupt n Mask
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI7_MASK - MSI Controller Interrupt n Mask (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x12C + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici7_mask
{
    uint32_t U;
    struct _hw_pcie_pl_msici7_mask_bitfields
    {
        uint32_t MSI_Interruptn_Mask : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici7_mask_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI7_MASK register
 */
/*@{*/
#define HW_PCIE_PL_MSICI7_MASK_ADDR(x) ((uintptr_t)(x) + 0x880U)

#define HW_PCIE_PL_MSICI7_MASK(x) (*(__IO hw_pcie_pl_msici7_mask_t *) HW_PCIE_PL_MSICI7_MASK_ADDR(x))
#define HW_PCIE_PL_MSICI7_MASK_RD(x) (HW_PCIE_PL_MSICI7_MASK(x).U)
#define HW_PCIE_PL_MSICI7_MASK_WR(x, v) (HW_PCIE_PL_MSICI7_MASK(x).U = (v))
#define HW_PCIE_PL_MSICI7_MASK_SET(x, v) (HW_PCIE_PL_MSICI7_MASK_WR(x, HW_PCIE_PL_MSICI7_MASK_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI7_MASK_CLR(x, v) (HW_PCIE_PL_MSICI7_MASK_WR(x, HW_PCIE_PL_MSICI7_MASK_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI7_MASK_TOG(x, v) (HW_PCIE_PL_MSICI7_MASK_WR(x, HW_PCIE_PL_MSICI7_MASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI7_MASK bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI7_MASK, field MSI_Interruptn_Mask[31:0] (RW)
 *
 * MSI Interrupt#n Mask Allows enabled interrupts to be masked. If an MSI is
 * received for a masked interrupt, the corresponding status bit gets set in the
 * Interrupt Status Register but the msi_ctrl_int output is not set HIGH. Each bit
 * corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask (0U) /*!< Bit position for PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask. */
#define BM_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask. */
#define BS_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask (32U) /*!< Bit field size in bits for PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask. */

/*! @brief Read current value of the PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask field. */
#define BR_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask(x) (HW_PCIE_PL_MSICI7_MASK(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask. */
#define BF_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask) & BM_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask)

/*! @brief Set the MSI_Interruptn_Mask field to a new value. */
#define BW_PCIE_PL_MSICI7_MASK_MSI_Interruptn_Mask(x, v) (HW_PCIE_PL_MSICI7_MASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICI7_STATUS - MSI Controller Interrupt n Status
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICI7_STATUS - MSI Controller Interrupt n Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x130 + C*n (n=[0:7])
 */
typedef union _hw_pcie_pl_msici7_status
{
    uint32_t U;
    struct _hw_pcie_pl_msici7_status_bitfields
    {
        uint32_t MSI_Interruptn_Status : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msici7_status_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICI7_STATUS register
 */
/*@{*/
#define HW_PCIE_PL_MSICI7_STATUS_ADDR(x) ((uintptr_t)(x) + 0x884U)

#define HW_PCIE_PL_MSICI7_STATUS(x) (*(__IO hw_pcie_pl_msici7_status_t *) HW_PCIE_PL_MSICI7_STATUS_ADDR(x))
#define HW_PCIE_PL_MSICI7_STATUS_RD(x) (HW_PCIE_PL_MSICI7_STATUS(x).U)
#define HW_PCIE_PL_MSICI7_STATUS_WR(x, v) (HW_PCIE_PL_MSICI7_STATUS(x).U = (v))
#define HW_PCIE_PL_MSICI7_STATUS_SET(x, v) (HW_PCIE_PL_MSICI7_STATUS_WR(x, HW_PCIE_PL_MSICI7_STATUS_RD(x) |  (v)))
#define HW_PCIE_PL_MSICI7_STATUS_CLR(x, v) (HW_PCIE_PL_MSICI7_STATUS_WR(x, HW_PCIE_PL_MSICI7_STATUS_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICI7_STATUS_TOG(x, v) (HW_PCIE_PL_MSICI7_STATUS_WR(x, HW_PCIE_PL_MSICI7_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICI7_STATUS bitfields
 */

/*!
 * @name Register PCIE_PL_MSICI7_STATUS, field MSI_Interruptn_Status[31:0] (RW)
 *
 * MSI Interrupt#n Status If an MSI is detected for EP#n, one bit in this
 * register is set. The decoding of the data payload of the MSI Memory Write Request
 * determines which bit gets set. A status is bit is cleared by writing a 1 to the
 * bit. Each bit corresponds to a single MSI Interrupt Vector.
 */
/*@{*/
#define BP_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status (0U) /*!< Bit position for PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status. */
#define BM_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status. */
#define BS_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status (32U) /*!< Bit field size in bits for PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status. */

/*! @brief Read current value of the PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status field. */
#define BR_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status(x) (HW_PCIE_PL_MSICI7_STATUS(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status. */
#define BF_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status) & BM_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status)

/*! @brief Set the MSI_Interruptn_Status field to a new value. */
#define BW_PCIE_PL_MSICI7_STATUS_MSI_Interruptn_Status(x, v) (HW_PCIE_PL_MSICI7_STATUS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_MSICGPIO - MSI Controller General Purpose IO Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_MSICGPIO - MSI Controller General Purpose IO Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x188
 */
typedef union _hw_pcie_pl_msicgpio
{
    uint32_t U;
    struct _hw_pcie_pl_msicgpio_bitfields
    {
        uint32_t MSI_GPIO_Register : 32; /*!< [31:0]  */
    } B;
} hw_pcie_pl_msicgpio_t;

/*!
 * @name Constants and macros for entire PCIE_PL_MSICGPIO register
 */
/*@{*/
#define HW_PCIE_PL_MSICGPIO_ADDR(x) ((uintptr_t)(x) + 0x888U)

#define HW_PCIE_PL_MSICGPIO(x)   (*(__IO hw_pcie_pl_msicgpio_t *) HW_PCIE_PL_MSICGPIO_ADDR(x))
#define HW_PCIE_PL_MSICGPIO_RD(x) (HW_PCIE_PL_MSICGPIO(x).U)
#define HW_PCIE_PL_MSICGPIO_WR(x, v) (HW_PCIE_PL_MSICGPIO(x).U = (v))
#define HW_PCIE_PL_MSICGPIO_SET(x, v) (HW_PCIE_PL_MSICGPIO_WR(x, HW_PCIE_PL_MSICGPIO_RD(x) |  (v)))
#define HW_PCIE_PL_MSICGPIO_CLR(x, v) (HW_PCIE_PL_MSICGPIO_WR(x, HW_PCIE_PL_MSICGPIO_RD(x) & ~(v)))
#define HW_PCIE_PL_MSICGPIO_TOG(x, v) (HW_PCIE_PL_MSICGPIO_WR(x, HW_PCIE_PL_MSICGPIO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_MSICGPIO bitfields
 */

/*!
 * @name Register PCIE_PL_MSICGPIO, field MSI_GPIO_Register[31:0] (RW)
 *
 * MSI GPIO Register The contents of this register drives the top-level output
 * msi_ctrl_io[31:0]
 */
/*@{*/
#define BP_PCIE_PL_MSICGPIO_MSI_GPIO_Register (0U) /*!< Bit position for PCIE_PL_MSICGPIO_MSI_GPIO_Register. */
#define BM_PCIE_PL_MSICGPIO_MSI_GPIO_Register (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_MSICGPIO_MSI_GPIO_Register. */
#define BS_PCIE_PL_MSICGPIO_MSI_GPIO_Register (32U) /*!< Bit field size in bits for PCIE_PL_MSICGPIO_MSI_GPIO_Register. */

/*! @brief Read current value of the PCIE_PL_MSICGPIO_MSI_GPIO_Register field. */
#define BR_PCIE_PL_MSICGPIO_MSI_GPIO_Register(x) (HW_PCIE_PL_MSICGPIO(x).U)

/*! @brief Format value for bitfield PCIE_PL_MSICGPIO_MSI_GPIO_Register. */
#define BF_PCIE_PL_MSICGPIO_MSI_GPIO_Register(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_MSICGPIO_MSI_GPIO_Register) & BM_PCIE_PL_MSICGPIO_MSI_GPIO_Register)

/*! @brief Set the MSI_GPIO_Register field to a new value. */
#define BW_PCIE_PL_MSICGPIO_MSI_GPIO_Register(x, v) (HW_PCIE_PL_MSICGPIO_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATUVR - iATU Viewport Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATUVR - iATU Viewport Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * See Internal Address Translation (iATU)An internal ATU (iATU) is instantiated
 * inside the PCIe core. for more information on iATU operation. The iATU
 * registers are programmed through an index (Viewport) register to reduce the
 * footprint in the PCI Express Extended Configuration Space. The size of the required
 * port logic space does not depend on the number of regions defined as the
 * Viewport register is used to select which memory region is being accessed. There are
 * 28 bytes of register space implemented per address region per direction. The
 * number of address regions that are remapped by the iATU is 4 for inbound and 4
 * for outbound. However, only 32 bytes of the PCIe Extended Configuration Space
 * Address Map is used. Offset: 0x700 + 0x200 The viewport register has a "Region
 * Direction" bit to determine whether an inbound or outbound region is being
 * accessed and a "Region Index" field to determine which region to program/read
 * when accessing the other address translation registers in the iATU Register Map
 * below.. As an example, to access the Control, Base, Limit and Target registers
 * for Outbound region number 4: Write 0x00000004 to Address {0x700 + 0x200} to
 * index the Outbound Address Region #4 Then proceed to write to any of the other
 * registers in the iATU Register Map below. iATU Register Map Byte Offset
 * Description +0x200 iATU Viewport Register +0x204 iATU Region Control 1 Register
 * +0x208 iATU Region Control 2 Register +0x20C iATU Region Lower Base Address
 * Register +0x210 iATU Region Upper Base Address Register +0x214 iATU Region Limit
 * Address Register +0x218 iATU Region Lower Target Address Register +0x21C iATU
 * Region Upper Target Address Register Since AXI core is async to the core_clk,
 * the iATU registers may not be updated while operations are in progress on the
 * AXI Bridge Slave interface.
 */
typedef union _hw_pcie_pl_iatuvr
{
    uint32_t U;
    struct _hw_pcie_pl_iatuvr_bitfields
    {
        uint32_t Region_Index : 4;     /*!< [3:0]  */
        uint32_t RESERVED0 : 27;       /*!< [30:4]  */
        uint32_t Region_Direction : 1; /*!< [31]  */
    } B;
} hw_pcie_pl_iatuvr_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATUVR register
 */
/*@{*/
#define HW_PCIE_PL_iATUVR_ADDR(x) ((uintptr_t)(x) + 0x900U)

#define HW_PCIE_PL_iATUVR(x)     (*(__IO hw_pcie_pl_iatuvr_t *) HW_PCIE_PL_iATUVR_ADDR(x))
#define HW_PCIE_PL_iATUVR_RD(x)  (HW_PCIE_PL_iATUVR(x).U)
#define HW_PCIE_PL_iATUVR_WR(x, v) (HW_PCIE_PL_iATUVR(x).U = (v))
#define HW_PCIE_PL_iATUVR_SET(x, v) (HW_PCIE_PL_iATUVR_WR(x, HW_PCIE_PL_iATUVR_RD(x) |  (v)))
#define HW_PCIE_PL_iATUVR_CLR(x, v) (HW_PCIE_PL_iATUVR_WR(x, HW_PCIE_PL_iATUVR_RD(x) & ~(v)))
#define HW_PCIE_PL_iATUVR_TOG(x, v) (HW_PCIE_PL_iATUVR_WR(x, HW_PCIE_PL_iATUVR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATUVR bitfields
 */

/*!
 * @name Register PCIE_PL_iATUVR, field Region_Index[3:0] (RW)
 *
 * Region Index Defines which region is being accessed when writing to the
 * control, base, limit and target registers. Must not be set to a number greater than
 * CX_ATU_NUM_OUTBOUND_REGIONS - 1 when an outbound region is being accessed.
 * Must not be set to a value greater than 3 since there are 4 regions for both
 * inbound or outbound (4 each).
 */
/*@{*/
#define BP_PCIE_PL_iATUVR_Region_Index (0U) /*!< Bit position for PCIE_PL_iATUVR_Region_Index. */
#define BM_PCIE_PL_iATUVR_Region_Index (0x0000000FU) /*!< Bit mask for PCIE_PL_iATUVR_Region_Index. */
#define BS_PCIE_PL_iATUVR_Region_Index (4U) /*!< Bit field size in bits for PCIE_PL_iATUVR_Region_Index. */

/*! @brief Read current value of the PCIE_PL_iATUVR_Region_Index field. */
#define BR_PCIE_PL_iATUVR_Region_Index(x) (HW_PCIE_PL_iATUVR(x).B.Region_Index)

/*! @brief Format value for bitfield PCIE_PL_iATUVR_Region_Index. */
#define BF_PCIE_PL_iATUVR_Region_Index(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATUVR_Region_Index) & BM_PCIE_PL_iATUVR_Region_Index)

/*! @brief Set the Region_Index field to a new value. */
#define BW_PCIE_PL_iATUVR_Region_Index(x, v) (HW_PCIE_PL_iATUVR_WR(x, (HW_PCIE_PL_iATUVR_RD(x) & ~BM_PCIE_PL_iATUVR_Region_Index) | BF_PCIE_PL_iATUVR_Region_Index(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATUVR, field Region_Direction[31] (RW)
 *
 * Region Direction Defines the region being accessed as either
 *
 * Values:
 * - 0 - Outbound
 * - 1 - Inbound
 */
/*@{*/
#define BP_PCIE_PL_iATUVR_Region_Direction (31U) /*!< Bit position for PCIE_PL_iATUVR_Region_Direction. */
#define BM_PCIE_PL_iATUVR_Region_Direction (0x80000000U) /*!< Bit mask for PCIE_PL_iATUVR_Region_Direction. */
#define BS_PCIE_PL_iATUVR_Region_Direction (1U) /*!< Bit field size in bits for PCIE_PL_iATUVR_Region_Direction. */

/*! @brief Read current value of the PCIE_PL_iATUVR_Region_Direction field. */
#define BR_PCIE_PL_iATUVR_Region_Direction(x) (HW_PCIE_PL_iATUVR(x).B.Region_Direction)

/*! @brief Format value for bitfield PCIE_PL_iATUVR_Region_Direction. */
#define BF_PCIE_PL_iATUVR_Region_Direction(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATUVR_Region_Direction) & BM_PCIE_PL_iATUVR_Region_Direction)

/*! @brief Set the Region_Direction field to a new value. */
#define BW_PCIE_PL_iATUVR_Region_Direction(x, v) (HW_PCIE_PL_iATUVR_WR(x, (HW_PCIE_PL_iATUVR_RD(x) & ~BM_PCIE_PL_iATUVR_Region_Direction) | BF_PCIE_PL_iATUVR_Region_Direction(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURC1 - iATU Region Control 1 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURC1 - iATU Region Control 1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x204 footnote 1 - If all other enabled field-matches are
 * successful
 */
typedef union _hw_pcie_pl_iaturc1
{
    uint32_t U;
    struct _hw_pcie_pl_iaturc1_bitfields
    {
        uint32_t TYPE : 5;             /*!< [4:0]  */
        uint32_t TC : 3;               /*!< [7:5]  */
        uint32_t TD : 1;               /*!< [8]  */
        uint32_t ATTR : 2;             /*!< [10:9]  */
        uint32_t RESERVED0 : 5;        /*!< [15:11]  */
        uint32_t AT : 2;               /*!< [17:16]  */
        uint32_t RESERVED1 : 2;        /*!< [19:18]  */
        uint32_t Function_Number : 3;  /*!< [22:20]  */
        uint32_t RESERVED2 : 9;        /*!< [31:23]  */
    } B;
} hw_pcie_pl_iaturc1_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURC1 register
 */
/*@{*/
#define HW_PCIE_PL_iATURC1_ADDR(x) ((uintptr_t)(x) + 0x904U)

#define HW_PCIE_PL_iATURC1(x)    (*(__IO hw_pcie_pl_iaturc1_t *) HW_PCIE_PL_iATURC1_ADDR(x))
#define HW_PCIE_PL_iATURC1_RD(x) (HW_PCIE_PL_iATURC1(x).U)
#define HW_PCIE_PL_iATURC1_WR(x, v) (HW_PCIE_PL_iATURC1(x).U = (v))
#define HW_PCIE_PL_iATURC1_SET(x, v) (HW_PCIE_PL_iATURC1_WR(x, HW_PCIE_PL_iATURC1_RD(x) |  (v)))
#define HW_PCIE_PL_iATURC1_CLR(x, v) (HW_PCIE_PL_iATURC1_WR(x, HW_PCIE_PL_iATURC1_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURC1_TOG(x, v) (HW_PCIE_PL_iATURC1_WR(x, HW_PCIE_PL_iATURC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURC1 bitfields
 */

/*!
 * @name Register PCIE_PL_iATURC1, field TYPE[4:0] (RW)
 *
 * TYPE Outbound: When the address of an outbound TLP is matched to this region,
 * then the TYPE field of the TLP is changed to the value in this register.
 * Inbound: When the TYPE field of an inbound TLP is matched to this value, then
 * address translation will proceed1.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_TYPE (0U)       /*!< Bit position for PCIE_PL_iATURC1_TYPE. */
#define BM_PCIE_PL_iATURC1_TYPE (0x0000001FU) /*!< Bit mask for PCIE_PL_iATURC1_TYPE. */
#define BS_PCIE_PL_iATURC1_TYPE (5U)       /*!< Bit field size in bits for PCIE_PL_iATURC1_TYPE. */

/*! @brief Read current value of the PCIE_PL_iATURC1_TYPE field. */
#define BR_PCIE_PL_iATURC1_TYPE(x) (HW_PCIE_PL_iATURC1(x).B.TYPE)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_TYPE. */
#define BF_PCIE_PL_iATURC1_TYPE(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_TYPE) & BM_PCIE_PL_iATURC1_TYPE)

/*! @brief Set the TYPE field to a new value. */
#define BW_PCIE_PL_iATURC1_TYPE(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_TYPE) | BF_PCIE_PL_iATURC1_TYPE(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC1, field TC[7:5] (RW)
 *
 * TC Outbound: When the address of an outbound TLP is matched to this region,
 * then the TC field of the TLP is changed to the value in this register. Inbound:
 * When the TC field of an inbound TLP is matched to this value, then address
 * translation will proceed1. This check is only performed if the TC Match Enable
 * bit of the iATU Control 2 Register is set.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_TC (5U)         /*!< Bit position for PCIE_PL_iATURC1_TC. */
#define BM_PCIE_PL_iATURC1_TC (0x000000E0U) /*!< Bit mask for PCIE_PL_iATURC1_TC. */
#define BS_PCIE_PL_iATURC1_TC (3U)         /*!< Bit field size in bits for PCIE_PL_iATURC1_TC. */

/*! @brief Read current value of the PCIE_PL_iATURC1_TC field. */
#define BR_PCIE_PL_iATURC1_TC(x) (HW_PCIE_PL_iATURC1(x).B.TC)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_TC. */
#define BF_PCIE_PL_iATURC1_TC(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_TC) & BM_PCIE_PL_iATURC1_TC)

/*! @brief Set the TC field to a new value. */
#define BW_PCIE_PL_iATURC1_TC(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_TC) | BF_PCIE_PL_iATURC1_TC(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC1, field TD[8] (RW)
 *
 * TD Outbound: When the address of an outbound TLP is matched to this region,
 * then the TD field of the TLP is changed to the value in this register. Inbound:
 * When the TD field of an inbound TLP is matched to this value, then address
 * translation will proceed1. This check is only performed if the TD Match Enable
 * bit of the iATU Control 2 Register is set.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_TD (8U)         /*!< Bit position for PCIE_PL_iATURC1_TD. */
#define BM_PCIE_PL_iATURC1_TD (0x00000100U) /*!< Bit mask for PCIE_PL_iATURC1_TD. */
#define BS_PCIE_PL_iATURC1_TD (1U)         /*!< Bit field size in bits for PCIE_PL_iATURC1_TD. */

/*! @brief Read current value of the PCIE_PL_iATURC1_TD field. */
#define BR_PCIE_PL_iATURC1_TD(x) (HW_PCIE_PL_iATURC1(x).B.TD)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_TD. */
#define BF_PCIE_PL_iATURC1_TD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_TD) & BM_PCIE_PL_iATURC1_TD)

/*! @brief Set the TD field to a new value. */
#define BW_PCIE_PL_iATURC1_TD(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_TD) | BF_PCIE_PL_iATURC1_TD(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC1, field ATTR[10:9] (RW)
 *
 * ATTR Outbound: When the address of an outbound TLP is matched to this region,
 * then the ATTR field of the TLP is changed to the value in this register.
 * Inbound: When the ATTR field of an inbound TLP is matched to this value, then
 * address translation will proceed1. This check is only performed if the ATTR Match
 * Enable bit of the iATU Control 2 Register is set.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_ATTR (9U)       /*!< Bit position for PCIE_PL_iATURC1_ATTR. */
#define BM_PCIE_PL_iATURC1_ATTR (0x00000600U) /*!< Bit mask for PCIE_PL_iATURC1_ATTR. */
#define BS_PCIE_PL_iATURC1_ATTR (2U)       /*!< Bit field size in bits for PCIE_PL_iATURC1_ATTR. */

/*! @brief Read current value of the PCIE_PL_iATURC1_ATTR field. */
#define BR_PCIE_PL_iATURC1_ATTR(x) (HW_PCIE_PL_iATURC1(x).B.ATTR)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_ATTR. */
#define BF_PCIE_PL_iATURC1_ATTR(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_ATTR) & BM_PCIE_PL_iATURC1_ATTR)

/*! @brief Set the ATTR field to a new value. */
#define BW_PCIE_PL_iATURC1_ATTR(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_ATTR) | BF_PCIE_PL_iATURC1_ATTR(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC1, field AT[17:16] (RW)
 *
 * AT Outbound: When the address of an outbound TLP is matched to this region,
 * then the AT field of the TLP is changed to the value in this register. Only
 * valid when the ATS_ENABLE configuration parameter is 1. Inbound: When the TYPE
 * field of an inbound TLP is matched to this value, then address translation will
 * proceed1. This check is only performed if the "AT Match Enable" bit of the
 * "iATU Control 2 Register" is set. Only valid when the ATS_ENABLE configuration
 * parameter is 1.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_AT (16U)        /*!< Bit position for PCIE_PL_iATURC1_AT. */
#define BM_PCIE_PL_iATURC1_AT (0x00030000U) /*!< Bit mask for PCIE_PL_iATURC1_AT. */
#define BS_PCIE_PL_iATURC1_AT (2U)         /*!< Bit field size in bits for PCIE_PL_iATURC1_AT. */

/*! @brief Read current value of the PCIE_PL_iATURC1_AT field. */
#define BR_PCIE_PL_iATURC1_AT(x) (HW_PCIE_PL_iATURC1(x).B.AT)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_AT. */
#define BF_PCIE_PL_iATURC1_AT(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_AT) & BM_PCIE_PL_iATURC1_AT)

/*! @brief Set the AT field to a new value. */
#define BW_PCIE_PL_iATURC1_AT(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_AT) | BF_PCIE_PL_iATURC1_AT(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC1, field Function_Number[22:20] (RW)
 *
 * Function Number Outbound: When the address of an outbound TLP is matched to
 * this region, then the function number used in generating the 'Function' part of
 * the Requester ID (RID) field of the TLP is taken from this 3-bit register.
 * The value in this register must be 0x0 Inbound MEM/IO: When the Address and BAR
 * matching logic in the core indicate that a MEM/IO transaction matches a BAR in
 * the function corresponding to this value, then address translation will
 * proceed1. This check is only performed if the Function Number Match Enable bit of
 * the iATU Control 2 Register is set. Inbound CFG0/CFG1: When the destination
 * function number as specified in the routing ID of the TLP header matches the
 * function, then address translation will proceed1. This check is only performed if
 * the Function Number Match Enable bit of the iATU Control 2 Register is set.
 */
/*@{*/
#define BP_PCIE_PL_iATURC1_Function_Number (20U) /*!< Bit position for PCIE_PL_iATURC1_Function_Number. */
#define BM_PCIE_PL_iATURC1_Function_Number (0x00700000U) /*!< Bit mask for PCIE_PL_iATURC1_Function_Number. */
#define BS_PCIE_PL_iATURC1_Function_Number (3U) /*!< Bit field size in bits for PCIE_PL_iATURC1_Function_Number. */

/*! @brief Read current value of the PCIE_PL_iATURC1_Function_Number field. */
#define BR_PCIE_PL_iATURC1_Function_Number(x) (HW_PCIE_PL_iATURC1(x).B.Function_Number)

/*! @brief Format value for bitfield PCIE_PL_iATURC1_Function_Number. */
#define BF_PCIE_PL_iATURC1_Function_Number(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC1_Function_Number) & BM_PCIE_PL_iATURC1_Function_Number)

/*! @brief Set the Function_Number field to a new value. */
#define BW_PCIE_PL_iATURC1_Function_Number(x, v) (HW_PCIE_PL_iATURC1_WR(x, (HW_PCIE_PL_iATURC1_RD(x) & ~BM_PCIE_PL_iATURC1_Function_Number) | BF_PCIE_PL_iATURC1_Function_Number(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURC2 - iATU Region Control 2 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURC2 - iATU Region Control 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x208
 */
typedef union _hw_pcie_pl_iaturc2
{
    uint32_t U;
    struct _hw_pcie_pl_iaturc2_bitfields
    {
        uint32_t Message_Code : 8;     /*!< [7:0]  */
        uint32_t BAR_Number : 3;       /*!< [10:8]  */
        uint32_t RESERVED0 : 3;        /*!< [13:11]  */
        uint32_t TC_Match_Enable : 1;  /*!< [14]  */
        uint32_t TD_Match_Enable : 1;  /*!< [15]  */
        uint32_t ATTR_Match_Enable : 1; /*!< [16]  */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t AT_Match_Enable : 1;  /*!< [18]  */
        uint32_t Function_Number_Match_Enable : 1; /*!< [19]  */
        uint32_t Virtual_Function_Number_Match_Enable : 1; /*!< [20]  */
        uint32_t Message_Code_Match_Enable : 1; /*!< [21]  */
        uint32_t RESERVED2 : 2;        /*!< [23:22]  */
        uint32_t Response_Code : 2;    /*!< [25:24]  */
        uint32_t RESERVED3 : 1;        /*!< [26]  */
        uint32_t Fuzzy_Type_Match_Mode : 1; /*!< [27]  */
        uint32_t CFG_Shift_Mode : 1;   /*!< [28]  */
        uint32_t Invert_Mode : 1;      /*!< [29]  */
        uint32_t Match_Mode : 1;       /*!< [30]  */
        uint32_t Region_Enable : 1;    /*!< [31]  */
    } B;
} hw_pcie_pl_iaturc2_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURC2 register
 */
/*@{*/
#define HW_PCIE_PL_iATURC2_ADDR(x) ((uintptr_t)(x) + 0x908U)

#define HW_PCIE_PL_iATURC2(x)    (*(__IO hw_pcie_pl_iaturc2_t *) HW_PCIE_PL_iATURC2_ADDR(x))
#define HW_PCIE_PL_iATURC2_RD(x) (HW_PCIE_PL_iATURC2(x).U)
#define HW_PCIE_PL_iATURC2_WR(x, v) (HW_PCIE_PL_iATURC2(x).U = (v))
#define HW_PCIE_PL_iATURC2_SET(x, v) (HW_PCIE_PL_iATURC2_WR(x, HW_PCIE_PL_iATURC2_RD(x) |  (v)))
#define HW_PCIE_PL_iATURC2_CLR(x, v) (HW_PCIE_PL_iATURC2_WR(x, HW_PCIE_PL_iATURC2_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURC2_TOG(x, v) (HW_PCIE_PL_iATURC2_WR(x, HW_PCIE_PL_iATURC2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURC2 bitfields
 */

/*!
 * @name Register PCIE_PL_iATURC2, field Message_Code[7:0] (RW)
 *
 * Message Code Outbound: When the address of an outbound TLP is matched to this
 * region, and the translated TLP TYPE field is Msg or MsgD; then the Message
 * field of the TLP is changed to the value in this register. Inbound: When the
 * TYPE field of an inbound Msg/MsgD TLP is matched to this value, then address
 * translation will proceed1. This check is only performed if the Function Message
 * Code Match Enable bit of the iATURC2iATU Region Control 2 Register is set.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Message_Code (0U) /*!< Bit position for PCIE_PL_iATURC2_Message_Code. */
#define BM_PCIE_PL_iATURC2_Message_Code (0x000000FFU) /*!< Bit mask for PCIE_PL_iATURC2_Message_Code. */
#define BS_PCIE_PL_iATURC2_Message_Code (8U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Message_Code. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Message_Code field. */
#define BR_PCIE_PL_iATURC2_Message_Code(x) (HW_PCIE_PL_iATURC2(x).B.Message_Code)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Message_Code. */
#define BF_PCIE_PL_iATURC2_Message_Code(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Message_Code) & BM_PCIE_PL_iATURC2_Message_Code)

/*! @brief Set the Message_Code field to a new value. */
#define BW_PCIE_PL_iATURC2_Message_Code(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Message_Code) | BF_PCIE_PL_iATURC2_Message_Code(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field BAR_Number[10:8] (RW)
 *
 * BAR Number Outbound: Not used. Inbound: When the BAR number of an inbound MEM
 * or IO TLP - that is matched by the normal internal BAR address matching
 * mechanism - is the same as this field, address translation will proceed1.This check
 * is only performed if the Match Mode bit of the iATURC2iATU Region Control 2
 * Register is set. IO translation would require either 00100b or 00101b in the
 * inbound TLP TYPE; the BAR Number set in the range 000b - 101b and that BAR
 * configured as an IO BAR.
 *
 * Values:
 * - 000 - - BAR#0
 * - 001 - - BAR#1
 * - 010 - - BAR#2
 * - 011 - - BAR#3
 * - 100 - - BAR#4
 * - 101 - - BAR#5
 * - 110 - - ROM
 * - 111 - - reserved
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_BAR_Number (8U) /*!< Bit position for PCIE_PL_iATURC2_BAR_Number. */
#define BM_PCIE_PL_iATURC2_BAR_Number (0x00000700U) /*!< Bit mask for PCIE_PL_iATURC2_BAR_Number. */
#define BS_PCIE_PL_iATURC2_BAR_Number (3U) /*!< Bit field size in bits for PCIE_PL_iATURC2_BAR_Number. */

/*! @brief Read current value of the PCIE_PL_iATURC2_BAR_Number field. */
#define BR_PCIE_PL_iATURC2_BAR_Number(x) (HW_PCIE_PL_iATURC2(x).B.BAR_Number)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_BAR_Number. */
#define BF_PCIE_PL_iATURC2_BAR_Number(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_BAR_Number) & BM_PCIE_PL_iATURC2_BAR_Number)

/*! @brief Set the BAR_Number field to a new value. */
#define BW_PCIE_PL_iATURC2_BAR_Number(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_BAR_Number) | BF_PCIE_PL_iATURC2_BAR_Number(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field TC_Match_Enable[14] (RW)
 *
 * TC Match Enable Outbound: Not used. Inbound: Ensures that a successful TC TLP
 * field comparison match (see TC field of the PCIe CTRL Memory Map/Register
 * Definition) occurs for address translation to proceed.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_TC_Match_Enable (14U) /*!< Bit position for PCIE_PL_iATURC2_TC_Match_Enable. */
#define BM_PCIE_PL_iATURC2_TC_Match_Enable (0x00004000U) /*!< Bit mask for PCIE_PL_iATURC2_TC_Match_Enable. */
#define BS_PCIE_PL_iATURC2_TC_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_TC_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_TC_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_TC_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.TC_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_TC_Match_Enable. */
#define BF_PCIE_PL_iATURC2_TC_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_TC_Match_Enable) & BM_PCIE_PL_iATURC2_TC_Match_Enable)

/*! @brief Set the TC_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_TC_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_TC_Match_Enable) | BF_PCIE_PL_iATURC2_TC_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field TD_Match_Enable[15] (RW)
 *
 * TD Match Enable Outbound: Not used. Inbound: Ensures that a successful TD TLP
 * field comparison match (see TD field of the PCIe CTRL Memory Map/Register
 * Definition) occurs for address translation to proceed.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_TD_Match_Enable (15U) /*!< Bit position for PCIE_PL_iATURC2_TD_Match_Enable. */
#define BM_PCIE_PL_iATURC2_TD_Match_Enable (0x00008000U) /*!< Bit mask for PCIE_PL_iATURC2_TD_Match_Enable. */
#define BS_PCIE_PL_iATURC2_TD_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_TD_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_TD_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_TD_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.TD_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_TD_Match_Enable. */
#define BF_PCIE_PL_iATURC2_TD_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_TD_Match_Enable) & BM_PCIE_PL_iATURC2_TD_Match_Enable)

/*! @brief Set the TD_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_TD_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_TD_Match_Enable) | BF_PCIE_PL_iATURC2_TD_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field ATTR_Match_Enable[16] (RW)
 *
 * ATTR Match Enable Outbound: Not used. Inbound: Ensures that a successful ATTR
 * TLP field comparison match (see ATTR field of the PCIe CTRL Memory
 * Map/Register Definition) occurs for address translation to proceed.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_ATTR_Match_Enable (16U) /*!< Bit position for PCIE_PL_iATURC2_ATTR_Match_Enable. */
#define BM_PCIE_PL_iATURC2_ATTR_Match_Enable (0x00010000U) /*!< Bit mask for PCIE_PL_iATURC2_ATTR_Match_Enable. */
#define BS_PCIE_PL_iATURC2_ATTR_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_ATTR_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_ATTR_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_ATTR_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.ATTR_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_ATTR_Match_Enable. */
#define BF_PCIE_PL_iATURC2_ATTR_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_ATTR_Match_Enable) & BM_PCIE_PL_iATURC2_ATTR_Match_Enable)

/*! @brief Set the ATTR_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_ATTR_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_ATTR_Match_Enable) | BF_PCIE_PL_iATURC2_ATTR_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field AT_Match_Enable[18] (RW)
 *
 * AT Match Enable Outbound: Not used. Inbound: Ensures that a successful AT TLP
 * field comparison match (see AT field of the iATU Control 1 Register in PCIe
 * CTRL Memory Map/Register Definition) occurs for address translation to proceed.
 * Only valid when the ATS_RX_ENABLE configuration parameter is 1.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_AT_Match_Enable (18U) /*!< Bit position for PCIE_PL_iATURC2_AT_Match_Enable. */
#define BM_PCIE_PL_iATURC2_AT_Match_Enable (0x00040000U) /*!< Bit mask for PCIE_PL_iATURC2_AT_Match_Enable. */
#define BS_PCIE_PL_iATURC2_AT_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_AT_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_AT_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_AT_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.AT_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_AT_Match_Enable. */
#define BF_PCIE_PL_iATURC2_AT_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_AT_Match_Enable) & BM_PCIE_PL_iATURC2_AT_Match_Enable)

/*! @brief Set the AT_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_AT_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_AT_Match_Enable) | BF_PCIE_PL_iATURC2_AT_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Function_Number_Match_Enable[19] (RW)
 *
 * Function Number Match Enable Outbound: Not used. Inbound: Ensures that a
 * successful Function Number TLP field comparison match (see Function Number field
 * of the iATU Control 1 Register in PCIe CTRL Memory Map/Register Definition)
 * occurs (in MEM/IO and CFG0/CFG1 transactions) for address translation to proceed.
 * Note: This bit must not be set at the same time as 'Virtual Function Number
 * Match Enable'.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Function_Number_Match_Enable (19U) /*!< Bit position for PCIE_PL_iATURC2_Function_Number_Match_Enable. */
#define BM_PCIE_PL_iATURC2_Function_Number_Match_Enable (0x00080000U) /*!< Bit mask for PCIE_PL_iATURC2_Function_Number_Match_Enable. */
#define BS_PCIE_PL_iATURC2_Function_Number_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Function_Number_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Function_Number_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_Function_Number_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.Function_Number_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Function_Number_Match_Enable. */
#define BF_PCIE_PL_iATURC2_Function_Number_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Function_Number_Match_Enable) & BM_PCIE_PL_iATURC2_Function_Number_Match_Enable)

/*! @brief Set the Function_Number_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_Function_Number_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Function_Number_Match_Enable) | BF_PCIE_PL_iATURC2_Function_Number_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Virtual_Function_Number_Match_Enable[20] (RW)
 *
 * Virtual Function Number Match Enable Outbound: Not used. Inbound: Ensures
 * that a successful Virtual Function Number TLP field comparison match (see Virtual
 * Function Number field of the iATU Control 1 Register in PCIe CTRL Memory
 * Map/Register Definitionoccurs (in MEM/IO transactions) for address translation to
 * proceed. Note: This bit must not be set at the same time as 'Function Number
 * Match Enable'.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable (20U) /*!< Bit position for PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable. */
#define BM_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable (0x00100000U) /*!< Bit mask for PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable. */
#define BS_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.Virtual_Function_Number_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable. */
#define BF_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable) & BM_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable)

/*! @brief Set the Virtual_Function_Number_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable) | BF_PCIE_PL_iATURC2_Virtual_Function_Number_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Message_Code_Match_Enable[21] (RW)
 *
 * Message Code Match Enable Outbound: Not used. Inbound: Ensures that a
 * successful Message Code TLP field comparison match occurs in MSG transactions (see
 * Message Code field of the iATU Control 1 Register in PCIe CTRL Memory
 * Map/Register Definition) for address translation to proceed.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Message_Code_Match_Enable (21U) /*!< Bit position for PCIE_PL_iATURC2_Message_Code_Match_Enable. */
#define BM_PCIE_PL_iATURC2_Message_Code_Match_Enable (0x00200000U) /*!< Bit mask for PCIE_PL_iATURC2_Message_Code_Match_Enable. */
#define BS_PCIE_PL_iATURC2_Message_Code_Match_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Message_Code_Match_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Message_Code_Match_Enable field. */
#define BR_PCIE_PL_iATURC2_Message_Code_Match_Enable(x) (HW_PCIE_PL_iATURC2(x).B.Message_Code_Match_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Message_Code_Match_Enable. */
#define BF_PCIE_PL_iATURC2_Message_Code_Match_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Message_Code_Match_Enable) & BM_PCIE_PL_iATURC2_Message_Code_Match_Enable)

/*! @brief Set the Message_Code_Match_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_Message_Code_Match_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Message_Code_Match_Enable) | BF_PCIE_PL_iATURC2_Message_Code_Match_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Response_Code[25:24] (RW)
 *
 * Response Code Outbound: Not used. Inbound: Defines the type of response to
 * give for accesses matching this region. This overrides the normal RADM filter
 * response.
 *
 * Values:
 * - 00 - - Normal RADM filter response is used.
 * - 01 - - Unsupported Request (UR)
 * - 10 - - Completer Abort (CA)
 * - 11 - - Not used / undefined / reserved.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Response_Code (24U) /*!< Bit position for PCIE_PL_iATURC2_Response_Code. */
#define BM_PCIE_PL_iATURC2_Response_Code (0x03000000U) /*!< Bit mask for PCIE_PL_iATURC2_Response_Code. */
#define BS_PCIE_PL_iATURC2_Response_Code (2U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Response_Code. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Response_Code field. */
#define BR_PCIE_PL_iATURC2_Response_Code(x) (HW_PCIE_PL_iATURC2(x).B.Response_Code)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Response_Code. */
#define BF_PCIE_PL_iATURC2_Response_Code(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Response_Code) & BM_PCIE_PL_iATURC2_Response_Code)

/*! @brief Set the Response_Code field to a new value. */
#define BW_PCIE_PL_iATURC2_Response_Code(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Response_Code) | BF_PCIE_PL_iATURC2_Response_Code(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Fuzzy_Type_Match_Mode[27] (RW)
 *
 * Fuzzy Type Match Mode Outbound: Not used. Inbound: When enabled, the iATU
 * relaxes the matching of the TLP TYPE field against the expected TYPE field so
 * that CfgRd0 and CfgRd1 TLPs are seen as identical. Similarly with CfgWr0 and
 * CfgWr1. MRd and MRdLk TLPs are seen as identical The Routing field of Msg/MsgD
 * TLPs is ignored For example, CFG0 in the TYPE field in the iATURC1iATU Region
 * Control 1 Register will match against an inbound CfgRd0, CfgRd1, CfgWr0 or CfgWr1
 * TLP.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode (27U) /*!< Bit position for PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode. */
#define BM_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode (0x08000000U) /*!< Bit mask for PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode. */
#define BS_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode field. */
#define BR_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode(x) (HW_PCIE_PL_iATURC2(x).B.Fuzzy_Type_Match_Mode)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode. */
#define BF_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode) & BM_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode)

/*! @brief Set the Fuzzy_Type_Match_Mode field to a new value. */
#define BW_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode) | BF_PCIE_PL_iATURC2_Fuzzy_Type_Match_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field CFG_Shift_Mode[28] (RW)
 *
 * CFG Shift Mode This is useful for CFG transactions where the PCIe
 * configuration mechanism maps bits [27:12] of the address to the bus/device and function
 * number. This allows a CFG configuration space to be located in any 256MB window
 * of the application memory space using a 28-bit effective address. Outbound:
 * Shifts bits [27:12] of the untranslated address to form bits [31:16] of the
 * translated address. Inbound: Shifts bits [31:16] of the untranslated address to
 * form bits [27:12] of the translated address.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_CFG_Shift_Mode (28U) /*!< Bit position for PCIE_PL_iATURC2_CFG_Shift_Mode. */
#define BM_PCIE_PL_iATURC2_CFG_Shift_Mode (0x10000000U) /*!< Bit mask for PCIE_PL_iATURC2_CFG_Shift_Mode. */
#define BS_PCIE_PL_iATURC2_CFG_Shift_Mode (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_CFG_Shift_Mode. */

/*! @brief Read current value of the PCIE_PL_iATURC2_CFG_Shift_Mode field. */
#define BR_PCIE_PL_iATURC2_CFG_Shift_Mode(x) (HW_PCIE_PL_iATURC2(x).B.CFG_Shift_Mode)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_CFG_Shift_Mode. */
#define BF_PCIE_PL_iATURC2_CFG_Shift_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_CFG_Shift_Mode) & BM_PCIE_PL_iATURC2_CFG_Shift_Mode)

/*! @brief Set the CFG_Shift_Mode field to a new value. */
#define BW_PCIE_PL_iATURC2_CFG_Shift_Mode(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_CFG_Shift_Mode) | BF_PCIE_PL_iATURC2_CFG_Shift_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Invert_Mode[29] (RW)
 *
 * Invert Mode Outbound / Inbound: When set the address matching region is
 * inverted. Therefore, an address match occurs when the untranslated address is in
 * the region outside the defined range (Base Address to Limit Address).
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Invert_Mode (29U) /*!< Bit position for PCIE_PL_iATURC2_Invert_Mode. */
#define BM_PCIE_PL_iATURC2_Invert_Mode (0x20000000U) /*!< Bit mask for PCIE_PL_iATURC2_Invert_Mode. */
#define BS_PCIE_PL_iATURC2_Invert_Mode (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Invert_Mode. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Invert_Mode field. */
#define BR_PCIE_PL_iATURC2_Invert_Mode(x) (HW_PCIE_PL_iATURC2(x).B.Invert_Mode)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Invert_Mode. */
#define BF_PCIE_PL_iATURC2_Invert_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Invert_Mode) & BM_PCIE_PL_iATURC2_Invert_Mode)

/*! @brief Set the Invert_Mode field to a new value. */
#define BW_PCIE_PL_iATURC2_Invert_Mode(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Invert_Mode) | BF_PCIE_PL_iATURC2_Invert_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Match_Mode[30] (RW)
 *
 * Match Mode Outbound: Not used. Inbound MEM/IO: Determines Inbound matching
 * mode for MEM/IO TLPs. 0: Address Mode. The iATU operates using addresses as in
 * the Outbound direction. The Region Base and Limit Registers must be setup. 1:
 * BAR Mode. BAR matching is used. The 'BAR Number' field is relevant. Inbound
 * CFG0: Determines Inbound matching mode for CFG0 TLPs. 0: Routing ID match mode.
 * The iATU interprets the Routing ID (Bytes 8 to 11 of TLP header) as an address.
 * This corresponds to the upper 16 bits of the address in MEM/IO transactions.
 * The Routing ID of the TLP must be within the base and limit of the iATU region
 * for matching to proceed. 1: Accept Mode. The iATU accepts all CFG0
 * transactions as address matches. The routing ID in the CFG0 TLP is ignored. This is
 * useful as all received CFG0 TLPs should be processed regardless of the Bus number.
 * Inbound MSG/MSGD: Determines Inbound matching mode for MSG/MSGD TLPs. 0:
 * Address Mode. The iATU treats the 3rd DWORD and 4th DWORD of the inbound MSG/MSGD
 * TLP as an address and it is matched against the Region Base and Limit
 * Registers. 1: Vendor ID match mode. This mode is relevant for ID-routed Vendor Defined
 * Messages. The iATU ignores the Routing ID(Bus, Device, Function) in bits
 * [31:16] of the 3rd DWORD of the TLP header, but matches against the Vendor ID in
 * bits [15:0] of the 3rd DWORD of the TLP header. Bits [15:0] of the Region Upper
 * Base register should be programmed with the required Vendor ID. The lower
 * Base and Limit Register should be programmed to translate TLPs based on vendor
 * specific information in the 4th DWORD of the TLP header.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Match_Mode (30U) /*!< Bit position for PCIE_PL_iATURC2_Match_Mode. */
#define BM_PCIE_PL_iATURC2_Match_Mode (0x40000000U) /*!< Bit mask for PCIE_PL_iATURC2_Match_Mode. */
#define BS_PCIE_PL_iATURC2_Match_Mode (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Match_Mode. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Match_Mode field. */
#define BR_PCIE_PL_iATURC2_Match_Mode(x) (HW_PCIE_PL_iATURC2(x).B.Match_Mode)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Match_Mode. */
#define BF_PCIE_PL_iATURC2_Match_Mode(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Match_Mode) & BM_PCIE_PL_iATURC2_Match_Mode)

/*! @brief Set the Match_Mode field to a new value. */
#define BW_PCIE_PL_iATURC2_Match_Mode(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Match_Mode) | BF_PCIE_PL_iATURC2_Match_Mode(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURC2, field Region_Enable[31] (RW)
 *
 * Region Enable Outbound / Inbound: This bit must be set to '1' for address
 * translation to take place.
 */
/*@{*/
#define BP_PCIE_PL_iATURC2_Region_Enable (31U) /*!< Bit position for PCIE_PL_iATURC2_Region_Enable. */
#define BM_PCIE_PL_iATURC2_Region_Enable (0x80000000U) /*!< Bit mask for PCIE_PL_iATURC2_Region_Enable. */
#define BS_PCIE_PL_iATURC2_Region_Enable (1U) /*!< Bit field size in bits for PCIE_PL_iATURC2_Region_Enable. */

/*! @brief Read current value of the PCIE_PL_iATURC2_Region_Enable field. */
#define BR_PCIE_PL_iATURC2_Region_Enable(x) (HW_PCIE_PL_iATURC2(x).B.Region_Enable)

/*! @brief Format value for bitfield PCIE_PL_iATURC2_Region_Enable. */
#define BF_PCIE_PL_iATURC2_Region_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURC2_Region_Enable) & BM_PCIE_PL_iATURC2_Region_Enable)

/*! @brief Set the Region_Enable field to a new value. */
#define BW_PCIE_PL_iATURC2_Region_Enable(x, v) (HW_PCIE_PL_iATURC2_WR(x, (HW_PCIE_PL_iATURC2_RD(x) & ~BM_PCIE_PL_iATURC2_Region_Enable) | BF_PCIE_PL_iATURC2_Region_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURLBA - iATU Region Lower Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURLBA - iATU Region Lower Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The CX_ATU_MIN_REGION_SIZE configuration parameter (Value Range: 4 kB, 8 kB,
 * 16 kB, 32 kB, 64 kB defaults to 64 kB) specifies the minimum size of an
 * address translation region. For example, if set to 64 kB; the lower 16 bits of the
 * Base, Limit and Target registers are zero and all address regions are aligned
 * on 64 kB boundaries. More precisely, the lower log2(CX_ATU_MIN_REGION_SIZE)
 * bits are zero. Offset: 0x700 + 0x20C
 */
typedef union _hw_pcie_pl_iaturlba
{
    uint32_t U;
    struct _hw_pcie_pl_iaturlba_bitfields
    {
        uint32_t Address_lower : 16;   /*!< [15:0]  */
        uint32_t Address_upper : 16;   /*!< [31:16]  */
    } B;
} hw_pcie_pl_iaturlba_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURLBA register
 */
/*@{*/
#define HW_PCIE_PL_iATURLBA_ADDR(x) ((uintptr_t)(x) + 0x90CU)

#define HW_PCIE_PL_iATURLBA(x)   (*(__IO hw_pcie_pl_iaturlba_t *) HW_PCIE_PL_iATURLBA_ADDR(x))
#define HW_PCIE_PL_iATURLBA_RD(x) (HW_PCIE_PL_iATURLBA(x).U)
#define HW_PCIE_PL_iATURLBA_WR(x, v) (HW_PCIE_PL_iATURLBA(x).U = (v))
#define HW_PCIE_PL_iATURLBA_SET(x, v) (HW_PCIE_PL_iATURLBA_WR(x, HW_PCIE_PL_iATURLBA_RD(x) |  (v)))
#define HW_PCIE_PL_iATURLBA_CLR(x, v) (HW_PCIE_PL_iATURLBA_WR(x, HW_PCIE_PL_iATURLBA_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURLBA_TOG(x, v) (HW_PCIE_PL_iATURLBA_WR(x, HW_PCIE_PL_iATURLBA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURLBA bitfields
 */

/*!
 * @name Register PCIE_PL_iATURLBA, field Address_lower[15:0] (RW)
 *
 * Forms bits [15:0] of the start address of the address region to be
 * translated. The start address must be aligned to a CX_ATU_MIN_REGION_SIZE kB boundary,
 * so these bits are always 0. A write to this location is ignored by the PCIe
 * core.
 */
/*@{*/
#define BP_PCIE_PL_iATURLBA_Address_lower (0U) /*!< Bit position for PCIE_PL_iATURLBA_Address_lower. */
#define BM_PCIE_PL_iATURLBA_Address_lower (0x0000FFFFU) /*!< Bit mask for PCIE_PL_iATURLBA_Address_lower. */
#define BS_PCIE_PL_iATURLBA_Address_lower (16U) /*!< Bit field size in bits for PCIE_PL_iATURLBA_Address_lower. */

/*! @brief Read current value of the PCIE_PL_iATURLBA_Address_lower field. */
#define BR_PCIE_PL_iATURLBA_Address_lower(x) (HW_PCIE_PL_iATURLBA(x).B.Address_lower)

/*! @brief Format value for bitfield PCIE_PL_iATURLBA_Address_lower. */
#define BF_PCIE_PL_iATURLBA_Address_lower(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLBA_Address_lower) & BM_PCIE_PL_iATURLBA_Address_lower)

/*! @brief Set the Address_lower field to a new value. */
#define BW_PCIE_PL_iATURLBA_Address_lower(x, v) (HW_PCIE_PL_iATURLBA_WR(x, (HW_PCIE_PL_iATURLBA_RD(x) & ~BM_PCIE_PL_iATURLBA_Address_lower) | BF_PCIE_PL_iATURLBA_Address_lower(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURLBA, field Address_upper[31:16] (RW)
 *
 * Forms bits [31:16] of the start address of the address region to be
 * translated.
 */
/*@{*/
#define BP_PCIE_PL_iATURLBA_Address_upper (16U) /*!< Bit position for PCIE_PL_iATURLBA_Address_upper. */
#define BM_PCIE_PL_iATURLBA_Address_upper (0xFFFF0000U) /*!< Bit mask for PCIE_PL_iATURLBA_Address_upper. */
#define BS_PCIE_PL_iATURLBA_Address_upper (16U) /*!< Bit field size in bits for PCIE_PL_iATURLBA_Address_upper. */

/*! @brief Read current value of the PCIE_PL_iATURLBA_Address_upper field. */
#define BR_PCIE_PL_iATURLBA_Address_upper(x) (HW_PCIE_PL_iATURLBA(x).B.Address_upper)

/*! @brief Format value for bitfield PCIE_PL_iATURLBA_Address_upper. */
#define BF_PCIE_PL_iATURLBA_Address_upper(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLBA_Address_upper) & BM_PCIE_PL_iATURLBA_Address_upper)

/*! @brief Set the Address_upper field to a new value. */
#define BW_PCIE_PL_iATURLBA_Address_upper(x, v) (HW_PCIE_PL_iATURLBA_WR(x, (HW_PCIE_PL_iATURLBA_RD(x) & ~BM_PCIE_PL_iATURLBA_Address_upper) | BF_PCIE_PL_iATURLBA_Address_upper(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURUBA - iATU Region Upper Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURUBA - iATU Region Upper Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x210
 */
typedef union _hw_pcie_pl_iaturuba
{
    uint32_t U;
    struct _hw_pcie_pl_iaturuba_bitfields
    {
        uint32_t Address : 32;         /*!< [31:0]  */
    } B;
} hw_pcie_pl_iaturuba_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURUBA register
 */
/*@{*/
#define HW_PCIE_PL_iATURUBA_ADDR(x) ((uintptr_t)(x) + 0x910U)

#define HW_PCIE_PL_iATURUBA(x)   (*(__IO hw_pcie_pl_iaturuba_t *) HW_PCIE_PL_iATURUBA_ADDR(x))
#define HW_PCIE_PL_iATURUBA_RD(x) (HW_PCIE_PL_iATURUBA(x).U)
#define HW_PCIE_PL_iATURUBA_WR(x, v) (HW_PCIE_PL_iATURUBA(x).U = (v))
#define HW_PCIE_PL_iATURUBA_SET(x, v) (HW_PCIE_PL_iATURUBA_WR(x, HW_PCIE_PL_iATURUBA_RD(x) |  (v)))
#define HW_PCIE_PL_iATURUBA_CLR(x, v) (HW_PCIE_PL_iATURUBA_WR(x, HW_PCIE_PL_iATURUBA_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURUBA_TOG(x, v) (HW_PCIE_PL_iATURUBA_WR(x, HW_PCIE_PL_iATURUBA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURUBA bitfields
 */

/*!
 * @name Register PCIE_PL_iATURUBA, field Address[31:0] (RW)
 *
 * Outbound / Inbound: Forms bits [63:32] of the start (and end) address of the
 * address region to be translated. Outbound: In systems with a 32-bit address
 * space, this register is not used and therefore writing to this register has no
 * effect.
 */
/*@{*/
#define BP_PCIE_PL_iATURUBA_Address (0U)   /*!< Bit position for PCIE_PL_iATURUBA_Address. */
#define BM_PCIE_PL_iATURUBA_Address (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_iATURUBA_Address. */
#define BS_PCIE_PL_iATURUBA_Address (32U)  /*!< Bit field size in bits for PCIE_PL_iATURUBA_Address. */

/*! @brief Read current value of the PCIE_PL_iATURUBA_Address field. */
#define BR_PCIE_PL_iATURUBA_Address(x) (HW_PCIE_PL_iATURUBA(x).U)

/*! @brief Format value for bitfield PCIE_PL_iATURUBA_Address. */
#define BF_PCIE_PL_iATURUBA_Address(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURUBA_Address) & BM_PCIE_PL_iATURUBA_Address)

/*! @brief Set the Address field to a new value. */
#define BW_PCIE_PL_iATURUBA_Address(x, v) (HW_PCIE_PL_iATURUBA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURLA - iATU Region Limit Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURLA - iATU Region Limit Address Register (RW)
 *
 * Reset value: 0x0000FFFFU
 *
 * Offset: 0x700 + 0x214
 */
typedef union _hw_pcie_pl_iaturla
{
    uint32_t U;
    struct _hw_pcie_pl_iaturla_bitfields
    {
        uint32_t Address_lower : 16;   /*!< [15:0]  */
        uint32_t Address_upper : 16;   /*!< [31:16]  */
    } B;
} hw_pcie_pl_iaturla_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURLA register
 */
/*@{*/
#define HW_PCIE_PL_iATURLA_ADDR(x) ((uintptr_t)(x) + 0x914U)

#define HW_PCIE_PL_iATURLA(x)    (*(__IO hw_pcie_pl_iaturla_t *) HW_PCIE_PL_iATURLA_ADDR(x))
#define HW_PCIE_PL_iATURLA_RD(x) (HW_PCIE_PL_iATURLA(x).U)
#define HW_PCIE_PL_iATURLA_WR(x, v) (HW_PCIE_PL_iATURLA(x).U = (v))
#define HW_PCIE_PL_iATURLA_SET(x, v) (HW_PCIE_PL_iATURLA_WR(x, HW_PCIE_PL_iATURLA_RD(x) |  (v)))
#define HW_PCIE_PL_iATURLA_CLR(x, v) (HW_PCIE_PL_iATURLA_WR(x, HW_PCIE_PL_iATURLA_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURLA_TOG(x, v) (HW_PCIE_PL_iATURLA_WR(x, HW_PCIE_PL_iATURLA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURLA bitfields
 */

/*!
 * @name Register PCIE_PL_iATURLA, field Address_lower[15:0] (RW)
 *
 * Forms bits [15:0] of the end address of the address region to be translated.
 * The end address must be aligned to a CX_ATU_MIN_REGION_SIZE kB boundary, so
 * these bits are always 0. A write to this location is ignored by the PCIe core.
 */
/*@{*/
#define BP_PCIE_PL_iATURLA_Address_lower (0U) /*!< Bit position for PCIE_PL_iATURLA_Address_lower. */
#define BM_PCIE_PL_iATURLA_Address_lower (0x0000FFFFU) /*!< Bit mask for PCIE_PL_iATURLA_Address_lower. */
#define BS_PCIE_PL_iATURLA_Address_lower (16U) /*!< Bit field size in bits for PCIE_PL_iATURLA_Address_lower. */

/*! @brief Read current value of the PCIE_PL_iATURLA_Address_lower field. */
#define BR_PCIE_PL_iATURLA_Address_lower(x) (HW_PCIE_PL_iATURLA(x).B.Address_lower)

/*! @brief Format value for bitfield PCIE_PL_iATURLA_Address_lower. */
#define BF_PCIE_PL_iATURLA_Address_lower(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLA_Address_lower) & BM_PCIE_PL_iATURLA_Address_lower)

/*! @brief Set the Address_lower field to a new value. */
#define BW_PCIE_PL_iATURLA_Address_lower(x, v) (HW_PCIE_PL_iATURLA_WR(x, (HW_PCIE_PL_iATURLA_RD(x) & ~BM_PCIE_PL_iATURLA_Address_lower) | BF_PCIE_PL_iATURLA_Address_lower(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURLA, field Address_upper[31:16] (RW)
 *
 * Forms bits [31:16] of the end address of the address region to be translated.
 */
/*@{*/
#define BP_PCIE_PL_iATURLA_Address_upper (16U) /*!< Bit position for PCIE_PL_iATURLA_Address_upper. */
#define BM_PCIE_PL_iATURLA_Address_upper (0xFFFF0000U) /*!< Bit mask for PCIE_PL_iATURLA_Address_upper. */
#define BS_PCIE_PL_iATURLA_Address_upper (16U) /*!< Bit field size in bits for PCIE_PL_iATURLA_Address_upper. */

/*! @brief Read current value of the PCIE_PL_iATURLA_Address_upper field. */
#define BR_PCIE_PL_iATURLA_Address_upper(x) (HW_PCIE_PL_iATURLA(x).B.Address_upper)

/*! @brief Format value for bitfield PCIE_PL_iATURLA_Address_upper. */
#define BF_PCIE_PL_iATURLA_Address_upper(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLA_Address_upper) & BM_PCIE_PL_iATURLA_Address_upper)

/*! @brief Set the Address_upper field to a new value. */
#define BW_PCIE_PL_iATURLA_Address_upper(x, v) (HW_PCIE_PL_iATURLA_WR(x, (HW_PCIE_PL_iATURLA_RD(x) & ~BM_PCIE_PL_iATURLA_Address_upper) | BF_PCIE_PL_iATURLA_Address_upper(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURLTA - iATU Region Lower Target Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURLTA - iATU Region Lower Target Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x218
 */
typedef union _hw_pcie_pl_iaturlta
{
    uint32_t U;
    struct _hw_pcie_pl_iaturlta_bitfields
    {
        uint32_t Address_lower : 16;   /*!< [15:0]  */
        uint32_t Address_upper : 16;   /*!< [31:16]  */
    } B;
} hw_pcie_pl_iaturlta_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURLTA register
 */
/*@{*/
#define HW_PCIE_PL_iATURLTA_ADDR(x) ((uintptr_t)(x) + 0x918U)

#define HW_PCIE_PL_iATURLTA(x)   (*(__IO hw_pcie_pl_iaturlta_t *) HW_PCIE_PL_iATURLTA_ADDR(x))
#define HW_PCIE_PL_iATURLTA_RD(x) (HW_PCIE_PL_iATURLTA(x).U)
#define HW_PCIE_PL_iATURLTA_WR(x, v) (HW_PCIE_PL_iATURLTA(x).U = (v))
#define HW_PCIE_PL_iATURLTA_SET(x, v) (HW_PCIE_PL_iATURLTA_WR(x, HW_PCIE_PL_iATURLTA_RD(x) |  (v)))
#define HW_PCIE_PL_iATURLTA_CLR(x, v) (HW_PCIE_PL_iATURLTA_WR(x, HW_PCIE_PL_iATURLTA_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURLTA_TOG(x, v) (HW_PCIE_PL_iATURLTA_WR(x, HW_PCIE_PL_iATURLTA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURLTA bitfields
 */

/*!
 * @name Register PCIE_PL_iATURLTA, field Address_lower[15:0] (RW)
 *
 * Forms bits [15:0] of the start address of the new address of the translated
 * region. The start address must be aligned to a CX_ATU_MIN_REGION_SIZE kB
 * boundary, so these bits are always 0. A write to this location is ignored by the
 * PCIe core.
 */
/*@{*/
#define BP_PCIE_PL_iATURLTA_Address_lower (0U) /*!< Bit position for PCIE_PL_iATURLTA_Address_lower. */
#define BM_PCIE_PL_iATURLTA_Address_lower (0x0000FFFFU) /*!< Bit mask for PCIE_PL_iATURLTA_Address_lower. */
#define BS_PCIE_PL_iATURLTA_Address_lower (16U) /*!< Bit field size in bits for PCIE_PL_iATURLTA_Address_lower. */

/*! @brief Read current value of the PCIE_PL_iATURLTA_Address_lower field. */
#define BR_PCIE_PL_iATURLTA_Address_lower(x) (HW_PCIE_PL_iATURLTA(x).B.Address_lower)

/*! @brief Format value for bitfield PCIE_PL_iATURLTA_Address_lower. */
#define BF_PCIE_PL_iATURLTA_Address_lower(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLTA_Address_lower) & BM_PCIE_PL_iATURLTA_Address_lower)

/*! @brief Set the Address_lower field to a new value. */
#define BW_PCIE_PL_iATURLTA_Address_lower(x, v) (HW_PCIE_PL_iATURLTA_WR(x, (HW_PCIE_PL_iATURLTA_RD(x) & ~BM_PCIE_PL_iATURLTA_Address_lower) | BF_PCIE_PL_iATURLTA_Address_lower(v)))
/*@}*/

/*!
 * @name Register PCIE_PL_iATURLTA, field Address_upper[31:16] (RW)
 *
 * Forms bits [31:16] of the of the new address of the translated region.
 */
/*@{*/
#define BP_PCIE_PL_iATURLTA_Address_upper (16U) /*!< Bit position for PCIE_PL_iATURLTA_Address_upper. */
#define BM_PCIE_PL_iATURLTA_Address_upper (0xFFFF0000U) /*!< Bit mask for PCIE_PL_iATURLTA_Address_upper. */
#define BS_PCIE_PL_iATURLTA_Address_upper (16U) /*!< Bit field size in bits for PCIE_PL_iATURLTA_Address_upper. */

/*! @brief Read current value of the PCIE_PL_iATURLTA_Address_upper field. */
#define BR_PCIE_PL_iATURLTA_Address_upper(x) (HW_PCIE_PL_iATURLTA(x).B.Address_upper)

/*! @brief Format value for bitfield PCIE_PL_iATURLTA_Address_upper. */
#define BF_PCIE_PL_iATURLTA_Address_upper(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURLTA_Address_upper) & BM_PCIE_PL_iATURLTA_Address_upper)

/*! @brief Set the Address_upper field to a new value. */
#define BW_PCIE_PL_iATURLTA_Address_upper(x, v) (HW_PCIE_PL_iATURLTA_WR(x, (HW_PCIE_PL_iATURLTA_RD(x) & ~BM_PCIE_PL_iATURLTA_Address_upper) | BF_PCIE_PL_iATURLTA_Address_upper(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_PL_iATURUTA - iATU Region Upper Target Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_PL_iATURUTA - iATU Region Upper Target Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x700 + 0x21C
 */
typedef union _hw_pcie_pl_iaturuta
{
    uint32_t U;
    struct _hw_pcie_pl_iaturuta_bitfields
    {
        uint32_t Address : 32;         /*!< [31:0]  */
    } B;
} hw_pcie_pl_iaturuta_t;

/*!
 * @name Constants and macros for entire PCIE_PL_iATURUTA register
 */
/*@{*/
#define HW_PCIE_PL_iATURUTA_ADDR(x) ((uintptr_t)(x) + 0x91CU)

#define HW_PCIE_PL_iATURUTA(x)   (*(__IO hw_pcie_pl_iaturuta_t *) HW_PCIE_PL_iATURUTA_ADDR(x))
#define HW_PCIE_PL_iATURUTA_RD(x) (HW_PCIE_PL_iATURUTA(x).U)
#define HW_PCIE_PL_iATURUTA_WR(x, v) (HW_PCIE_PL_iATURUTA(x).U = (v))
#define HW_PCIE_PL_iATURUTA_SET(x, v) (HW_PCIE_PL_iATURUTA_WR(x, HW_PCIE_PL_iATURUTA_RD(x) |  (v)))
#define HW_PCIE_PL_iATURUTA_CLR(x, v) (HW_PCIE_PL_iATURUTA_WR(x, HW_PCIE_PL_iATURUTA_RD(x) & ~(v)))
#define HW_PCIE_PL_iATURUTA_TOG(x, v) (HW_PCIE_PL_iATURUTA_WR(x, HW_PCIE_PL_iATURUTA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_PL_iATURUTA bitfields
 */

/*!
 * @name Register PCIE_PL_iATURUTA, field Address[31:0] (RW)
 *
 * Outbound / Inbound: Forms bits [63:32] of the start address of the new
 * address of the translated region. Inbound: In systems with a 32-bit address space,
 * this register is not used and therefore writing to this register has no effect.
 */
/*@{*/
#define BP_PCIE_PL_iATURUTA_Address (0U)   /*!< Bit position for PCIE_PL_iATURUTA_Address. */
#define BM_PCIE_PL_iATURUTA_Address (0xFFFFFFFFU) /*!< Bit mask for PCIE_PL_iATURUTA_Address. */
#define BS_PCIE_PL_iATURUTA_Address (32U)  /*!< Bit field size in bits for PCIE_PL_iATURUTA_Address. */

/*! @brief Read current value of the PCIE_PL_iATURUTA_Address field. */
#define BR_PCIE_PL_iATURUTA_Address(x) (HW_PCIE_PL_iATURUTA(x).U)

/*! @brief Format value for bitfield PCIE_PL_iATURUTA_Address. */
#define BF_PCIE_PL_iATURUTA_Address(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_PL_iATURUTA_Address) & BM_PCIE_PL_iATURUTA_Address)

/*! @brief Set the Address field to a new value. */
#define BW_PCIE_PL_iATURUTA_Address(x, v) (HW_PCIE_PL_iATURUTA_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_pcie_pl_t - module struct
 ******************************************************************************/
/*!
 * @brief All PCIE_PL module registers.
 */
#pragma pack(1)
typedef struct _hw_pcie_pl
{
    uint8_t _reserved0[1792];
    __IO hw_pcie_pl_altrtr_t ALTRTR;       /*!< [0x700] Ack Latency Timer and Replay Timer Register */
    __IO hw_pcie_pl_vsdr_t VSDR;           /*!< [0x704] Vendor Specific DLLP Register */
    __IO hw_pcie_pl_pflr_t PFLR;           /*!< [0x708] Port Force Link Register */
    __IO hw_pcie_pl_aflacr_t AFLACR;       /*!< [0x70C] Ack Frequency and L0-L1 ASPM Control Register */
    __IO hw_pcie_pl_plcr_t PLCR;           /*!< [0x710] Port Link Control Register */
    __IO hw_pcie_pl_lsr_t LSR;             /*!< [0x714] Lane Skew Register */
    __IO hw_pcie_pl_snr_t SNR;             /*!< [0x718] Symbol Number Register */
    __IO hw_pcie_pl_strfm1_t STRFM1;       /*!< [0x71C] Symbol Timer Register and Filter Mask Register 1 */
    __IO hw_pcie_pl_strfm2_t STRFM2;       /*!< [0x720] Filter Mask Register 2 */
    __IO hw_pcie_pl_amodnpsr_t AMODNPSR;   /*!< [0x724] AMBA Multiple Outbound Decomposed NP Sub-Requests Control Register */
    __I hw_pcie_pl_debug0_t DEBUG0;        /*!< [0x728] Debug Register 0 */
    __I hw_pcie_pl_debug1_t DEBUG1;        /*!< [0x72C] Debug Register 1 */
    __I hw_pcie_pl_tpfcsr_t TPFCSR;        /*!< [0x730] Transmit Posted FC Credit Status Register */
    __I hw_pcie_pl_tnfcsr_t TNFCSR;        /*!< [0x734] Transmit Non-Posted FC Credit Status Register */
    __I hw_pcie_pl_tcfcsr_t TCFCSR;        /*!< [0x738] Transmit Completion FC Credit Status Register */
    __I hw_pcie_pl_qsr_t QSR;              /*!< [0x73C] Queue Status Register */
    __I hw_pcie_pl_vctar1_t VCTAR1;        /*!< [0x740] VC Transmit Arbitration Register 1 */
    __I hw_pcie_pl_vctar2_t VCTAR2;        /*!< [0x744] VC Transmit Arbitration Register 2 */
    __IO hw_pcie_pl_vc0prqc_t VC0PRQC;     /*!< [0x748] VC0 Posted Receive Queue Control */
    __IO hw_pcie_pl_vc0nrqc_t VC0NRQC;     /*!< [0x74C] VC0 Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc0crqc_t VC0CRQC;     /*!< [0x750] VC0 Completion Receive Queue Control */
    __IO hw_pcie_pl_vc1prqc_t VC1PRQC;     /*!< [0x754] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc1nrqc_t VC1NRQC;     /*!< [0x758] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc1crqc_t VC1CRQC;     /*!< [0x75C] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc2prqc_t VC2PRQC;     /*!< [0x760] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc2nrqc_t VC2NRQC;     /*!< [0x764] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc2crqc_t VC2CRQC;     /*!< [0x768] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc3prqc_t VC3PRQC;     /*!< [0x76C] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc3nrqc_t VC3NRQC;     /*!< [0x770] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc3crqc_t VC3CRQC;     /*!< [0x774] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc4prqc_t VC4PRQC;     /*!< [0x778] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc4nrqc_t VC4NRQC;     /*!< [0x77C] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc4crqc_t VC4CRQC;     /*!< [0x780] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc5prqc_t VC5PRQC;     /*!< [0x784] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc5nrqc_t VC5NRQC;     /*!< [0x788] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc5crqc_t VC5CRQC;     /*!< [0x78C] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc6prqc_t VC6PRQC;     /*!< [0x790] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc6nrqc_t VC6NRQC;     /*!< [0x794] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc6crqc_t VC6CRQC;     /*!< [0x798] VCn Completion Receive Queue Control */
    __IO hw_pcie_pl_vc7prqc_t VC7PRQC;     /*!< [0x79C] VCn Posted Receive Queue Control */
    __IO hw_pcie_pl_vc7nrqc_t VC7NRQC;     /*!< [0x7A0] VCn Non-Posted Receive Queue Control */
    __IO hw_pcie_pl_vc7crqc_t VC7CRQC;     /*!< [0x7A4] VCn Completion Receive Queue Control */
    __I hw_pcie_pl_vc0pbd_t VC0PBD;        /*!< [0x7A8] VC0 Posted Buffer Depth */
    __I hw_pcie_pl_vc0npbd_t VC0NPBD;      /*!< [0x7AC] VC0 Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc0cbd_t VC0CBD;        /*!< [0x7B0] VC0 Completion Buffer Depth */
    __I hw_pcie_pl_vc1pbd_t VC1PBD;        /*!< [0x7B4] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc1npbd_t VC1NPBD;      /*!< [0x7B8] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc1cbd_t VC1CBD;        /*!< [0x7BC] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc2pbd_t VC2PBD;        /*!< [0x7C0] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc2npbd_t VC2NPBD;      /*!< [0x7C4] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc2cbd_t VC2CBD;        /*!< [0x7C8] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc3pbd_t VC3PBD;        /*!< [0x7CC] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc3npbd_t VC3NPBD;      /*!< [0x7D0] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc3cbd_t VC3CBD;        /*!< [0x7D4] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc4pbd_t VC4PBD;        /*!< [0x7D8] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc4npbd_t VC4NPBD;      /*!< [0x7DC] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc4cbd_t VC4CBD;        /*!< [0x7E0] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc5pbd_t VC5PBD;        /*!< [0x7E4] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc5npbd_t VC5NPBD;      /*!< [0x7E8] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc5cbd_t VC5CBD;        /*!< [0x7EC] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc6pbd_t VC6PBD;        /*!< [0x7F0] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc6npbd_t VC6NPBD;      /*!< [0x7F4] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc6cbd_t VC6CBD;        /*!< [0x7F8] VCn Completion Buffer Depth */
    __I hw_pcie_pl_vc7pbd_t VC7PBD;        /*!< [0x7FC] VCn Posted Buffer Depth */
    __I hw_pcie_pl_vc7npbd_t VC7NPBD;      /*!< [0x800] VCn Non-Posted Buffer Depth */
    __I hw_pcie_pl_vc7cbd_t VC7CBD;        /*!< [0x804] VCn Completion Buffer Depth */
    uint8_t _reserved1[4];
    __IO hw_pcie_pl_g2cr_t G2CR;           /*!< [0x80C] Gen2 Control Register */
    __I hw_pcie_pl_phy_status_t PHY_STATUS; /*!< [0x810] PHY Status */
    __IO hw_pcie_pl_phy_ctrl_t PHY_CTRL;   /*!< [0x814] PHY Control */
    __IO hw_pcie_pl_mrccr0_t MRCCR0;       /*!< [0x818] Master Response Composer Control Register 0 */
    __IO hw_pcie_pl_mrccr1_t MRCCR1;       /*!< [0x81C] Master Response Composer Control Register 1 */
    __IO hw_pcie_pl_msica_t MSICA;         /*!< [0x820] MSI Controller Address */
    __IO hw_pcie_pl_msicua_t MSICUA;       /*!< [0x824] MSI Controller Upper Address */
    __IO hw_pcie_pl_msici0_enb_t MSICI0_ENB; /*!< [0x828] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici0_mask_t MSICI0_MASK; /*!< [0x82C] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici0_status_t MSICI0_STATUS; /*!< [0x830] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici1_enb_t MSICI1_ENB; /*!< [0x834] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici1_mask_t MSICI1_MASK; /*!< [0x838] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici1_status_t MSICI1_STATUS; /*!< [0x83C] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici2_enb_t MSICI2_ENB; /*!< [0x840] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici2_mask_t MSICI2_MASK; /*!< [0x844] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici2_status_t MSICI2_STATUS; /*!< [0x848] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici3_enb_t MSICI3_ENB; /*!< [0x84C] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici3_mask_t MSICI3_MASK; /*!< [0x850] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici3_status_t MSICI3_STATUS; /*!< [0x854] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici4_enb_t MSICI4_ENB; /*!< [0x858] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici4_mask_t MSICI4_MASK; /*!< [0x85C] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici4_status_t MSICI4_STATUS; /*!< [0x860] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici5_enb_t MSICI5_ENB; /*!< [0x864] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici5_mask_t MSICI5_MASK; /*!< [0x868] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici5_status_t MSICI5_STATUS; /*!< [0x86C] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici6_enb_t MSICI6_ENB; /*!< [0x870] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici6_mask_t MSICI6_MASK; /*!< [0x874] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici6_status_t MSICI6_STATUS; /*!< [0x878] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msici7_enb_t MSICI7_ENB; /*!< [0x87C] MSI Controller Interrupt n Enable */
    __IO hw_pcie_pl_msici7_mask_t MSICI7_MASK; /*!< [0x880] MSI Controller Interrupt n Mask */
    __IO hw_pcie_pl_msici7_status_t MSICI7_STATUS; /*!< [0x884] MSI Controller Interrupt n Status */
    __IO hw_pcie_pl_msicgpio_t MSICGPIO;   /*!< [0x888] MSI Controller General Purpose IO Register */
    uint8_t _reserved2[116];
    __IO hw_pcie_pl_iatuvr_t iATUVR;       /*!< [0x900] iATU Viewport Register */
    __IO hw_pcie_pl_iaturc1_t iATURC1;     /*!< [0x904] iATU Region Control 1 Register */
    __IO hw_pcie_pl_iaturc2_t iATURC2;     /*!< [0x908] iATU Region Control 2 Register */
    __IO hw_pcie_pl_iaturlba_t iATURLBA;   /*!< [0x90C] iATU Region Lower Base Address Register */
    __IO hw_pcie_pl_iaturuba_t iATURUBA;   /*!< [0x910] iATU Region Upper Base Address Register */
    __IO hw_pcie_pl_iaturla_t iATURLA;     /*!< [0x914] iATU Region Limit Address Register */
    __IO hw_pcie_pl_iaturlta_t iATURLTA;   /*!< [0x918] iATU Region Lower Target Address Register */
    __IO hw_pcie_pl_iaturuta_t iATURUTA;   /*!< [0x91C] iATU Region Upper Target Address Register */
} hw_pcie_pl_t;
#pragma pack()

/*! @brief Macro to access all PCIE_PL registers. */
/*! @param x PCIE_PL module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PCIE_PL_REGS(PCIE_PL_BASE)</code>. */
#define HW_PCIE_PL_REGS(x) (*(hw_pcie_pl_t *)(x))

/*
 * iMX6DP PCIE_RC
 *
 * PCIeRC
 *
 * Registers defined in this header file:
 * - HW_PCIE_RC_DeviceID - Device ID and Vendor ID Register
 * - HW_PCIE_RC_Command - Command and Status Register
 * - HW_PCIE_RC_RevID - Revision ID and Class Code Register
 * - HW_PCIE_RC_BIST - BIST Register
 * - HW_PCIE_RC_BAR0 - Base Address 0
 * - HW_PCIE_RC_BAR1 - Base Address 1
 * - HW_PCIE_RC_BNR - Bus Number Registers
 * - HW_PCIE_RC_IOBLSSR - I/O Base Limit Secondary Status Register
 * - HW_PCIE_RC_MEM_BLR - Memory Base and Memory Limit Register
 * - HW_PCIE_RC_PREF_MEM_BLR - Prefetchable Memory Base and Limit Register
 * - HW_PCIE_RC_PREF_BASE_U32 - Prefetchable Base Upper 32 Bits Register
 * - HW_PCIE_RC_PREF_LIM_U32 - Prefetchable Limit Upper 32 Bits Register
 * - HW_PCIE_RC_IO_BASE_LIM_U16 - I/O Base and Limit Upper 16 Bits Register
 * - HW_PCIE_RC_CAPPR - Capability Pointer Register
 * - HW_PCIE_RC_EROMBAR - Expansion ROM Base Address Register
 * - HW_PCIE_RC_EROMMASK - Expansion ROM BAR Mask Register
 * - HW_PCIE_RC_PMCR - Power Management Capability Register
 * - HW_PCIE_RC_PMCSR - Power Management Control and Status Register
 * - HW_PCIE_RC_CIDR - PCI Express Capability ID Register
 * - HW_PCIE_RC_DCR - Device Capabilities Register
 * - HW_PCIE_RC_DConR - Device Control Register
 * - HW_PCIE_RC_LCR - Link Capabilities Register
 * - HW_PCIE_RC_LCSR - Link Control and Status Register
 * - HW_PCIE_RC_SCR - Slot Capabilities Register
 * - HW_PCIE_RC_SCSR - Slot Control and Status Register
 * - HW_PCIE_RC_RCCR - Root Control and Capabilities Register
 * - HW_PCIE_RC_RSR - Root Status Register
 * - HW_PCIE_RC_DCR2 - Device Capabilities 2 Register
 * - HW_PCIE_RC_DCSR2 - Device Control and Status 2 Register
 * - HW_PCIE_RC_LCR2 - Link Capabilities 2 Register
 * - HW_PCIE_RC_LCSR2 - Link Control and Status 2 Register
 * - HW_PCIE_RC_AER - AER Capability Header
 * - HW_PCIE_RC_UESR - Uncorrectable Error Status Register
 * - HW_PCIE_RC_UEMR - Uncorrectable Error Mask Register
 * - HW_PCIE_RC_UESevR - Uncorrectable Error Severity Register
 * - HW_PCIE_RC_CESR - Correctable Error Status Register
 * - HW_PCIE_RC_CEMR - Correctable Error Mask Register
 * - HW_PCIE_RC_ACCR - Advanced Capabilities and Control Register
 * - HW_PCIE_RC_HLR - Header Log Register
 * - HW_PCIE_RC_RECR - Root Error Command Register
 * - HW_PCIE_RC_RESR - Root Error Status Register
 * - HW_PCIE_RC_ESIR - Error Source Identification Register
 * - HW_PCIE_RC_VCECHR - VC Extended Capability Header
 * - HW_PCIE_RC_PVCCR1 - Port VC Capability Register 1
 * - HW_PCIE_RC_PVCCR2 - Port VC Capability Register 2
 * - HW_PCIE_RC_PVCCSR - Port VC Control and Status Register
 * - HW_PCIE_RC_VCRCR - VC Resource Capability Register n
 * - HW_PCIE_RC_VCRConR - VC Resource Control Register n
 * - HW_PCIE_RC_VCRSR - VC Resource Status Register n
 *
 * - hw_pcie_rc_t - Struct containing all module registers.
 */

#define HW_PCIE_RC_INSTANCE_COUNT (1U) /*!< Number of instances of the PCIE_RC module. */
#define HW_PCIE_RC (0U) /*!< Instance number for PCIE_RC. */
#define PCIE_RC_BASE          (0x1FFC000U) /*!< Base address for PCIE_RC. */
/*! Array initializer of PCIE_RC base addresses. */
#define PCIE_RC_BASE_ADDRS    { PCIE_RC_BASE }

/*******************************************************************************
 * HW_PCIE_RC_DeviceID - Device ID and Vendor ID Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_DeviceID - Device ID and Vendor ID Register (RU)
 *
 * Reset value: 0xABCD16C3U
 *
 * Offset: 0x00 The default values of both Device ID and Vendor ID are hardware
 * configuration parameters. The application can overwrite the default values of
 * both Device ID and Vendor ID through the DBI.
 */
typedef union _hw_pcie_rc_deviceid
{
    uint32_t U;
    struct _hw_pcie_rc_deviceid_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_pcie_rc_deviceid_t;

/*!
 * @name Constants and macros for entire PCIE_RC_DeviceID register
 */
/*@{*/
#define HW_PCIE_RC_DeviceID_ADDR(x) ((uintptr_t)(x) + 0x0U)
#define HW_PCIE_RC_DeviceID(x)   (*(__I hw_pcie_rc_deviceid_t *) HW_PCIE_RC_DeviceID_ADDR(x))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_DeviceID bitfields
 */

/*******************************************************************************
 * HW_PCIE_RC_Command - Command and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_Command - Command and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x04 Bytes: 0-1
 */
typedef union _hw_pcie_rc_command
{
    uint32_t U;
    struct _hw_pcie_rc_command_bitfields
    {
        uint32_t I_O_Space_Enable : 1; /*!< [0]  */
        uint32_t Memory_Space_Enable : 1; /*!< [1]  */
        uint32_t Bus_Master_Enable : 1; /*!< [2]  */
        uint32_t Special_Cycle_Enable : 1; /*!< [3]  */
        uint32_t Memory_Write_and_Invalidate : 1; /*!< [4]  */
        uint32_t VGA_Palette_Snoop : 1; /*!< [5]  */
        uint32_t Parity_Error_Response : 1; /*!< [6]  */
        uint32_t IDSEL_Stepping : 1;   /*!< [7]  */
        uint32_t SERR_Enable : 1;      /*!< [8]  */
        uint32_t Fast_Back_to_Back_Enable : 1; /*!< [9]  */
        uint32_t INTx_Assertion_Disable : 1; /*!< [10]  */
        uint32_t RESERVED0 : 8;        /*!< [18:11]  */
        uint32_t INTx_Status : 1;      /*!< [19]  */
        uint32_t Capabilities_List : 1; /*!< [20]  */
        uint32_t SixtySix_MHz_Capable : 1; /*!< [21]  */
        uint32_t RESERVED1 : 1;        /*!< [22]  */
        uint32_t Fast_Back_to_Back_Capable : 1; /*!< [23]  */
        uint32_t Master_Data_Parity_Error : 1; /*!< [24]  */
        uint32_t DEVSEL_Timing : 2;    /*!< [26:25]  */
        uint32_t Signaled_Target_Abort : 1; /*!< [27]  */
        uint32_t Received_Target_Abort : 1; /*!< [28]  */
        uint32_t Received_Master_Abort : 1; /*!< [29]  */
        uint32_t Detected_Parity_Error : 1; /*!< [30]  */
        uint32_t Signaled_System_Error : 1; /*!< [31]  */
    } B;
} hw_pcie_rc_command_t;

/*!
 * @name Constants and macros for entire PCIE_RC_Command register
 */
/*@{*/
#define HW_PCIE_RC_Command_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_PCIE_RC_Command(x)    (*(__IO hw_pcie_rc_command_t *) HW_PCIE_RC_Command_ADDR(x))
#define HW_PCIE_RC_Command_RD(x) (HW_PCIE_RC_Command(x).U)
#define HW_PCIE_RC_Command_WR(x, v) (HW_PCIE_RC_Command(x).U = (v))
#define HW_PCIE_RC_Command_SET(x, v) (HW_PCIE_RC_Command_WR(x, HW_PCIE_RC_Command_RD(x) |  (v)))
#define HW_PCIE_RC_Command_CLR(x, v) (HW_PCIE_RC_Command_WR(x, HW_PCIE_RC_Command_RD(x) & ~(v)))
#define HW_PCIE_RC_Command_TOG(x, v) (HW_PCIE_RC_Command_WR(x, HW_PCIE_RC_Command_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_Command bitfields
 */

/*!
 * @name Register PCIE_RC_Command, field I_O_Space_Enable[0] (RW)
 *
 * I/O Space Enable
 */
/*@{*/
#define BP_PCIE_RC_Command_I_O_Space_Enable (0U) /*!< Bit position for PCIE_RC_Command_I_O_Space_Enable. */
#define BM_PCIE_RC_Command_I_O_Space_Enable (0x00000001U) /*!< Bit mask for PCIE_RC_Command_I_O_Space_Enable. */
#define BS_PCIE_RC_Command_I_O_Space_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_I_O_Space_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_I_O_Space_Enable field. */
#define BR_PCIE_RC_Command_I_O_Space_Enable(x) (HW_PCIE_RC_Command(x).B.I_O_Space_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_I_O_Space_Enable. */
#define BF_PCIE_RC_Command_I_O_Space_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_I_O_Space_Enable) & BM_PCIE_RC_Command_I_O_Space_Enable)

/*! @brief Set the I_O_Space_Enable field to a new value. */
#define BW_PCIE_RC_Command_I_O_Space_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_I_O_Space_Enable) | BF_PCIE_RC_Command_I_O_Space_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Memory_Space_Enable[1] (RW)
 *
 * Memory Space Enable
 */
/*@{*/
#define BP_PCIE_RC_Command_Memory_Space_Enable (1U) /*!< Bit position for PCIE_RC_Command_Memory_Space_Enable. */
#define BM_PCIE_RC_Command_Memory_Space_Enable (0x00000002U) /*!< Bit mask for PCIE_RC_Command_Memory_Space_Enable. */
#define BS_PCIE_RC_Command_Memory_Space_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_Memory_Space_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_Memory_Space_Enable field. */
#define BR_PCIE_RC_Command_Memory_Space_Enable(x) (HW_PCIE_RC_Command(x).B.Memory_Space_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_Memory_Space_Enable. */
#define BF_PCIE_RC_Command_Memory_Space_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Memory_Space_Enable) & BM_PCIE_RC_Command_Memory_Space_Enable)

/*! @brief Set the Memory_Space_Enable field to a new value. */
#define BW_PCIE_RC_Command_Memory_Space_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Memory_Space_Enable) | BF_PCIE_RC_Command_Memory_Space_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Bus_Master_Enable[2] (RW)
 *
 * Bus Master Enable
 */
/*@{*/
#define BP_PCIE_RC_Command_Bus_Master_Enable (2U) /*!< Bit position for PCIE_RC_Command_Bus_Master_Enable. */
#define BM_PCIE_RC_Command_Bus_Master_Enable (0x00000004U) /*!< Bit mask for PCIE_RC_Command_Bus_Master_Enable. */
#define BS_PCIE_RC_Command_Bus_Master_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_Bus_Master_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_Bus_Master_Enable field. */
#define BR_PCIE_RC_Command_Bus_Master_Enable(x) (HW_PCIE_RC_Command(x).B.Bus_Master_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_Bus_Master_Enable. */
#define BF_PCIE_RC_Command_Bus_Master_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Bus_Master_Enable) & BM_PCIE_RC_Command_Bus_Master_Enable)

/*! @brief Set the Bus_Master_Enable field to a new value. */
#define BW_PCIE_RC_Command_Bus_Master_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Bus_Master_Enable) | BF_PCIE_RC_Command_Bus_Master_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Special_Cycle_Enable[3] (RW)
 *
 * Special Cycle Enable Not applicable for PCI Express. Must be hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_Special_Cycle_Enable (3U) /*!< Bit position for PCIE_RC_Command_Special_Cycle_Enable. */
#define BM_PCIE_RC_Command_Special_Cycle_Enable (0x00000008U) /*!< Bit mask for PCIE_RC_Command_Special_Cycle_Enable. */
#define BS_PCIE_RC_Command_Special_Cycle_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_Special_Cycle_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_Special_Cycle_Enable field. */
#define BR_PCIE_RC_Command_Special_Cycle_Enable(x) (HW_PCIE_RC_Command(x).B.Special_Cycle_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_Special_Cycle_Enable. */
#define BF_PCIE_RC_Command_Special_Cycle_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Special_Cycle_Enable) & BM_PCIE_RC_Command_Special_Cycle_Enable)

/*! @brief Set the Special_Cycle_Enable field to a new value. */
#define BW_PCIE_RC_Command_Special_Cycle_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Special_Cycle_Enable) | BF_PCIE_RC_Command_Special_Cycle_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Memory_Write_and_Invalidate[4] (RW)
 *
 * Memory Write and Invalidate Not applicable for PCI Express. Must be hardwired
 * to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_Memory_Write_and_Invalidate (4U) /*!< Bit position for PCIE_RC_Command_Memory_Write_and_Invalidate. */
#define BM_PCIE_RC_Command_Memory_Write_and_Invalidate (0x00000010U) /*!< Bit mask for PCIE_RC_Command_Memory_Write_and_Invalidate. */
#define BS_PCIE_RC_Command_Memory_Write_and_Invalidate (1U) /*!< Bit field size in bits for PCIE_RC_Command_Memory_Write_and_Invalidate. */

/*! @brief Read current value of the PCIE_RC_Command_Memory_Write_and_Invalidate field. */
#define BR_PCIE_RC_Command_Memory_Write_and_Invalidate(x) (HW_PCIE_RC_Command(x).B.Memory_Write_and_Invalidate)

/*! @brief Format value for bitfield PCIE_RC_Command_Memory_Write_and_Invalidate. */
#define BF_PCIE_RC_Command_Memory_Write_and_Invalidate(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Memory_Write_and_Invalidate) & BM_PCIE_RC_Command_Memory_Write_and_Invalidate)

/*! @brief Set the Memory_Write_and_Invalidate field to a new value. */
#define BW_PCIE_RC_Command_Memory_Write_and_Invalidate(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Memory_Write_and_Invalidate) | BF_PCIE_RC_Command_Memory_Write_and_Invalidate(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field VGA_Palette_Snoop[5] (RW)
 *
 * VGA Palette Snoop Not applicable for PCI Express. Must be hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_VGA_Palette_Snoop (5U) /*!< Bit position for PCIE_RC_Command_VGA_Palette_Snoop. */
#define BM_PCIE_RC_Command_VGA_Palette_Snoop (0x00000020U) /*!< Bit mask for PCIE_RC_Command_VGA_Palette_Snoop. */
#define BS_PCIE_RC_Command_VGA_Palette_Snoop (1U) /*!< Bit field size in bits for PCIE_RC_Command_VGA_Palette_Snoop. */

/*! @brief Read current value of the PCIE_RC_Command_VGA_Palette_Snoop field. */
#define BR_PCIE_RC_Command_VGA_Palette_Snoop(x) (HW_PCIE_RC_Command(x).B.VGA_Palette_Snoop)

/*! @brief Format value for bitfield PCIE_RC_Command_VGA_Palette_Snoop. */
#define BF_PCIE_RC_Command_VGA_Palette_Snoop(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_VGA_Palette_Snoop) & BM_PCIE_RC_Command_VGA_Palette_Snoop)

/*! @brief Set the VGA_Palette_Snoop field to a new value. */
#define BW_PCIE_RC_Command_VGA_Palette_Snoop(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_VGA_Palette_Snoop) | BF_PCIE_RC_Command_VGA_Palette_Snoop(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Parity_Error_Response[6] (RW)
 *
 * Parity Error Response
 */
/*@{*/
#define BP_PCIE_RC_Command_Parity_Error_Response (6U) /*!< Bit position for PCIE_RC_Command_Parity_Error_Response. */
#define BM_PCIE_RC_Command_Parity_Error_Response (0x00000040U) /*!< Bit mask for PCIE_RC_Command_Parity_Error_Response. */
#define BS_PCIE_RC_Command_Parity_Error_Response (1U) /*!< Bit field size in bits for PCIE_RC_Command_Parity_Error_Response. */

/*! @brief Read current value of the PCIE_RC_Command_Parity_Error_Response field. */
#define BR_PCIE_RC_Command_Parity_Error_Response(x) (HW_PCIE_RC_Command(x).B.Parity_Error_Response)

/*! @brief Format value for bitfield PCIE_RC_Command_Parity_Error_Response. */
#define BF_PCIE_RC_Command_Parity_Error_Response(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Parity_Error_Response) & BM_PCIE_RC_Command_Parity_Error_Response)

/*! @brief Set the Parity_Error_Response field to a new value. */
#define BW_PCIE_RC_Command_Parity_Error_Response(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Parity_Error_Response) | BF_PCIE_RC_Command_Parity_Error_Response(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field IDSEL_Stepping[7] (RW)
 *
 * IDSEL Stepping/Wait Cycle Control Not applicable for PCI Express. Must be
 * hardwired to 0
 */
/*@{*/
#define BP_PCIE_RC_Command_IDSEL_Stepping (7U) /*!< Bit position for PCIE_RC_Command_IDSEL_Stepping. */
#define BM_PCIE_RC_Command_IDSEL_Stepping (0x00000080U) /*!< Bit mask for PCIE_RC_Command_IDSEL_Stepping. */
#define BS_PCIE_RC_Command_IDSEL_Stepping (1U) /*!< Bit field size in bits for PCIE_RC_Command_IDSEL_Stepping. */

/*! @brief Read current value of the PCIE_RC_Command_IDSEL_Stepping field. */
#define BR_PCIE_RC_Command_IDSEL_Stepping(x) (HW_PCIE_RC_Command(x).B.IDSEL_Stepping)

/*! @brief Format value for bitfield PCIE_RC_Command_IDSEL_Stepping. */
#define BF_PCIE_RC_Command_IDSEL_Stepping(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_IDSEL_Stepping) & BM_PCIE_RC_Command_IDSEL_Stepping)

/*! @brief Set the IDSEL_Stepping field to a new value. */
#define BW_PCIE_RC_Command_IDSEL_Stepping(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_IDSEL_Stepping) | BF_PCIE_RC_Command_IDSEL_Stepping(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field SERR_Enable[8] (RW)
 *
 * SERR# Enable
 */
/*@{*/
#define BP_PCIE_RC_Command_SERR_Enable (8U) /*!< Bit position for PCIE_RC_Command_SERR_Enable. */
#define BM_PCIE_RC_Command_SERR_Enable (0x00000100U) /*!< Bit mask for PCIE_RC_Command_SERR_Enable. */
#define BS_PCIE_RC_Command_SERR_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_SERR_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_SERR_Enable field. */
#define BR_PCIE_RC_Command_SERR_Enable(x) (HW_PCIE_RC_Command(x).B.SERR_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_SERR_Enable. */
#define BF_PCIE_RC_Command_SERR_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_SERR_Enable) & BM_PCIE_RC_Command_SERR_Enable)

/*! @brief Set the SERR_Enable field to a new value. */
#define BW_PCIE_RC_Command_SERR_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_SERR_Enable) | BF_PCIE_RC_Command_SERR_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Fast_Back_to_Back_Enable[9] (RW)
 *
 * Fast Back-to-Back Enable Not applicable for PCI Express. Must be hardwired to
 * 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_Fast_Back_to_Back_Enable (9U) /*!< Bit position for PCIE_RC_Command_Fast_Back_to_Back_Enable. */
#define BM_PCIE_RC_Command_Fast_Back_to_Back_Enable (0x00000200U) /*!< Bit mask for PCIE_RC_Command_Fast_Back_to_Back_Enable. */
#define BS_PCIE_RC_Command_Fast_Back_to_Back_Enable (1U) /*!< Bit field size in bits for PCIE_RC_Command_Fast_Back_to_Back_Enable. */

/*! @brief Read current value of the PCIE_RC_Command_Fast_Back_to_Back_Enable field. */
#define BR_PCIE_RC_Command_Fast_Back_to_Back_Enable(x) (HW_PCIE_RC_Command(x).B.Fast_Back_to_Back_Enable)

/*! @brief Format value for bitfield PCIE_RC_Command_Fast_Back_to_Back_Enable. */
#define BF_PCIE_RC_Command_Fast_Back_to_Back_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Fast_Back_to_Back_Enable) & BM_PCIE_RC_Command_Fast_Back_to_Back_Enable)

/*! @brief Set the Fast_Back_to_Back_Enable field to a new value. */
#define BW_PCIE_RC_Command_Fast_Back_to_Back_Enable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Fast_Back_to_Back_Enable) | BF_PCIE_RC_Command_Fast_Back_to_Back_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field INTx_Assertion_Disable[10] (RW)
 *
 * INTx Assertion Disable
 */
/*@{*/
#define BP_PCIE_RC_Command_INTx_Assertion_Disable (10U) /*!< Bit position for PCIE_RC_Command_INTx_Assertion_Disable. */
#define BM_PCIE_RC_Command_INTx_Assertion_Disable (0x00000400U) /*!< Bit mask for PCIE_RC_Command_INTx_Assertion_Disable. */
#define BS_PCIE_RC_Command_INTx_Assertion_Disable (1U) /*!< Bit field size in bits for PCIE_RC_Command_INTx_Assertion_Disable. */

/*! @brief Read current value of the PCIE_RC_Command_INTx_Assertion_Disable field. */
#define BR_PCIE_RC_Command_INTx_Assertion_Disable(x) (HW_PCIE_RC_Command(x).B.INTx_Assertion_Disable)

/*! @brief Format value for bitfield PCIE_RC_Command_INTx_Assertion_Disable. */
#define BF_PCIE_RC_Command_INTx_Assertion_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_INTx_Assertion_Disable) & BM_PCIE_RC_Command_INTx_Assertion_Disable)

/*! @brief Set the INTx_Assertion_Disable field to a new value. */
#define BW_PCIE_RC_Command_INTx_Assertion_Disable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_INTx_Assertion_Disable) | BF_PCIE_RC_Command_INTx_Assertion_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field INTx_Status[19] (RW)
 *
 * INTx Status
 */
/*@{*/
#define BP_PCIE_RC_Command_INTx_Status (19U) /*!< Bit position for PCIE_RC_Command_INTx_Status. */
#define BM_PCIE_RC_Command_INTx_Status (0x00080000U) /*!< Bit mask for PCIE_RC_Command_INTx_Status. */
#define BS_PCIE_RC_Command_INTx_Status (1U) /*!< Bit field size in bits for PCIE_RC_Command_INTx_Status. */

/*! @brief Read current value of the PCIE_RC_Command_INTx_Status field. */
#define BR_PCIE_RC_Command_INTx_Status(x) (HW_PCIE_RC_Command(x).B.INTx_Status)

/*! @brief Format value for bitfield PCIE_RC_Command_INTx_Status. */
#define BF_PCIE_RC_Command_INTx_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_INTx_Status) & BM_PCIE_RC_Command_INTx_Status)

/*! @brief Set the INTx_Status field to a new value. */
#define BW_PCIE_RC_Command_INTx_Status(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_INTx_Status) | BF_PCIE_RC_Command_INTx_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Capabilities_List[20] (RW)
 *
 * Capabilities List Indicates presence of an extended capability item.
 * Hardwired to 1.
 */
/*@{*/
#define BP_PCIE_RC_Command_Capabilities_List (20U) /*!< Bit position for PCIE_RC_Command_Capabilities_List. */
#define BM_PCIE_RC_Command_Capabilities_List (0x00100000U) /*!< Bit mask for PCIE_RC_Command_Capabilities_List. */
#define BS_PCIE_RC_Command_Capabilities_List (1U) /*!< Bit field size in bits for PCIE_RC_Command_Capabilities_List. */

/*! @brief Read current value of the PCIE_RC_Command_Capabilities_List field. */
#define BR_PCIE_RC_Command_Capabilities_List(x) (HW_PCIE_RC_Command(x).B.Capabilities_List)

/*! @brief Format value for bitfield PCIE_RC_Command_Capabilities_List. */
#define BF_PCIE_RC_Command_Capabilities_List(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Capabilities_List) & BM_PCIE_RC_Command_Capabilities_List)

/*! @brief Set the Capabilities_List field to a new value. */
#define BW_PCIE_RC_Command_Capabilities_List(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Capabilities_List) | BF_PCIE_RC_Command_Capabilities_List(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field SixtySix_MHz_Capable[21] (RW)
 *
 * 66 MHz Capable Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_SixtySix_MHz_Capable (21U) /*!< Bit position for PCIE_RC_Command_SixtySix_MHz_Capable. */
#define BM_PCIE_RC_Command_SixtySix_MHz_Capable (0x00200000U) /*!< Bit mask for PCIE_RC_Command_SixtySix_MHz_Capable. */
#define BS_PCIE_RC_Command_SixtySix_MHz_Capable (1U) /*!< Bit field size in bits for PCIE_RC_Command_SixtySix_MHz_Capable. */

/*! @brief Read current value of the PCIE_RC_Command_SixtySix_MHz_Capable field. */
#define BR_PCIE_RC_Command_SixtySix_MHz_Capable(x) (HW_PCIE_RC_Command(x).B.SixtySix_MHz_Capable)

/*! @brief Format value for bitfield PCIE_RC_Command_SixtySix_MHz_Capable. */
#define BF_PCIE_RC_Command_SixtySix_MHz_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_SixtySix_MHz_Capable) & BM_PCIE_RC_Command_SixtySix_MHz_Capable)

/*! @brief Set the SixtySix_MHz_Capable field to a new value. */
#define BW_PCIE_RC_Command_SixtySix_MHz_Capable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_SixtySix_MHz_Capable) | BF_PCIE_RC_Command_SixtySix_MHz_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Fast_Back_to_Back_Capable[23] (RW)
 *
 * Fast Back-to-Back Capable Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_Fast_Back_to_Back_Capable (23U) /*!< Bit position for PCIE_RC_Command_Fast_Back_to_Back_Capable. */
#define BM_PCIE_RC_Command_Fast_Back_to_Back_Capable (0x00800000U) /*!< Bit mask for PCIE_RC_Command_Fast_Back_to_Back_Capable. */
#define BS_PCIE_RC_Command_Fast_Back_to_Back_Capable (1U) /*!< Bit field size in bits for PCIE_RC_Command_Fast_Back_to_Back_Capable. */

/*! @brief Read current value of the PCIE_RC_Command_Fast_Back_to_Back_Capable field. */
#define BR_PCIE_RC_Command_Fast_Back_to_Back_Capable(x) (HW_PCIE_RC_Command(x).B.Fast_Back_to_Back_Capable)

/*! @brief Format value for bitfield PCIE_RC_Command_Fast_Back_to_Back_Capable. */
#define BF_PCIE_RC_Command_Fast_Back_to_Back_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Fast_Back_to_Back_Capable) & BM_PCIE_RC_Command_Fast_Back_to_Back_Capable)

/*! @brief Set the Fast_Back_to_Back_Capable field to a new value. */
#define BW_PCIE_RC_Command_Fast_Back_to_Back_Capable(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Fast_Back_to_Back_Capable) | BF_PCIE_RC_Command_Fast_Back_to_Back_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Master_Data_Parity_Error[24] (RW)
 *
 * Master Data Parity Error
 */
/*@{*/
#define BP_PCIE_RC_Command_Master_Data_Parity_Error (24U) /*!< Bit position for PCIE_RC_Command_Master_Data_Parity_Error. */
#define BM_PCIE_RC_Command_Master_Data_Parity_Error (0x01000000U) /*!< Bit mask for PCIE_RC_Command_Master_Data_Parity_Error. */
#define BS_PCIE_RC_Command_Master_Data_Parity_Error (1U) /*!< Bit field size in bits for PCIE_RC_Command_Master_Data_Parity_Error. */

/*! @brief Read current value of the PCIE_RC_Command_Master_Data_Parity_Error field. */
#define BR_PCIE_RC_Command_Master_Data_Parity_Error(x) (HW_PCIE_RC_Command(x).B.Master_Data_Parity_Error)

/*! @brief Format value for bitfield PCIE_RC_Command_Master_Data_Parity_Error. */
#define BF_PCIE_RC_Command_Master_Data_Parity_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Master_Data_Parity_Error) & BM_PCIE_RC_Command_Master_Data_Parity_Error)

/*! @brief Set the Master_Data_Parity_Error field to a new value. */
#define BW_PCIE_RC_Command_Master_Data_Parity_Error(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Master_Data_Parity_Error) | BF_PCIE_RC_Command_Master_Data_Parity_Error(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field DEVSEL_Timing[26:25] (RW)
 *
 * DEVSEL Timing Not applicable for PCI Express. Hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_Command_DEVSEL_Timing (25U) /*!< Bit position for PCIE_RC_Command_DEVSEL_Timing. */
#define BM_PCIE_RC_Command_DEVSEL_Timing (0x06000000U) /*!< Bit mask for PCIE_RC_Command_DEVSEL_Timing. */
#define BS_PCIE_RC_Command_DEVSEL_Timing (2U) /*!< Bit field size in bits for PCIE_RC_Command_DEVSEL_Timing. */

/*! @brief Read current value of the PCIE_RC_Command_DEVSEL_Timing field. */
#define BR_PCIE_RC_Command_DEVSEL_Timing(x) (HW_PCIE_RC_Command(x).B.DEVSEL_Timing)

/*! @brief Format value for bitfield PCIE_RC_Command_DEVSEL_Timing. */
#define BF_PCIE_RC_Command_DEVSEL_Timing(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_DEVSEL_Timing) & BM_PCIE_RC_Command_DEVSEL_Timing)

/*! @brief Set the DEVSEL_Timing field to a new value. */
#define BW_PCIE_RC_Command_DEVSEL_Timing(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_DEVSEL_Timing) | BF_PCIE_RC_Command_DEVSEL_Timing(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Signaled_Target_Abort[27] (RW)
 *
 * Signaled Target Abort
 */
/*@{*/
#define BP_PCIE_RC_Command_Signaled_Target_Abort (27U) /*!< Bit position for PCIE_RC_Command_Signaled_Target_Abort. */
#define BM_PCIE_RC_Command_Signaled_Target_Abort (0x08000000U) /*!< Bit mask for PCIE_RC_Command_Signaled_Target_Abort. */
#define BS_PCIE_RC_Command_Signaled_Target_Abort (1U) /*!< Bit field size in bits for PCIE_RC_Command_Signaled_Target_Abort. */

/*! @brief Read current value of the PCIE_RC_Command_Signaled_Target_Abort field. */
#define BR_PCIE_RC_Command_Signaled_Target_Abort(x) (HW_PCIE_RC_Command(x).B.Signaled_Target_Abort)

/*! @brief Format value for bitfield PCIE_RC_Command_Signaled_Target_Abort. */
#define BF_PCIE_RC_Command_Signaled_Target_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Signaled_Target_Abort) & BM_PCIE_RC_Command_Signaled_Target_Abort)

/*! @brief Set the Signaled_Target_Abort field to a new value. */
#define BW_PCIE_RC_Command_Signaled_Target_Abort(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Signaled_Target_Abort) | BF_PCIE_RC_Command_Signaled_Target_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Received_Target_Abort[28] (RW)
 *
 * Received Target Abort
 */
/*@{*/
#define BP_PCIE_RC_Command_Received_Target_Abort (28U) /*!< Bit position for PCIE_RC_Command_Received_Target_Abort. */
#define BM_PCIE_RC_Command_Received_Target_Abort (0x10000000U) /*!< Bit mask for PCIE_RC_Command_Received_Target_Abort. */
#define BS_PCIE_RC_Command_Received_Target_Abort (1U) /*!< Bit field size in bits for PCIE_RC_Command_Received_Target_Abort. */

/*! @brief Read current value of the PCIE_RC_Command_Received_Target_Abort field. */
#define BR_PCIE_RC_Command_Received_Target_Abort(x) (HW_PCIE_RC_Command(x).B.Received_Target_Abort)

/*! @brief Format value for bitfield PCIE_RC_Command_Received_Target_Abort. */
#define BF_PCIE_RC_Command_Received_Target_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Received_Target_Abort) & BM_PCIE_RC_Command_Received_Target_Abort)

/*! @brief Set the Received_Target_Abort field to a new value. */
#define BW_PCIE_RC_Command_Received_Target_Abort(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Received_Target_Abort) | BF_PCIE_RC_Command_Received_Target_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Received_Master_Abort[29] (RW)
 *
 * Received Master Abort
 */
/*@{*/
#define BP_PCIE_RC_Command_Received_Master_Abort (29U) /*!< Bit position for PCIE_RC_Command_Received_Master_Abort. */
#define BM_PCIE_RC_Command_Received_Master_Abort (0x20000000U) /*!< Bit mask for PCIE_RC_Command_Received_Master_Abort. */
#define BS_PCIE_RC_Command_Received_Master_Abort (1U) /*!< Bit field size in bits for PCIE_RC_Command_Received_Master_Abort. */

/*! @brief Read current value of the PCIE_RC_Command_Received_Master_Abort field. */
#define BR_PCIE_RC_Command_Received_Master_Abort(x) (HW_PCIE_RC_Command(x).B.Received_Master_Abort)

/*! @brief Format value for bitfield PCIE_RC_Command_Received_Master_Abort. */
#define BF_PCIE_RC_Command_Received_Master_Abort(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Received_Master_Abort) & BM_PCIE_RC_Command_Received_Master_Abort)

/*! @brief Set the Received_Master_Abort field to a new value. */
#define BW_PCIE_RC_Command_Received_Master_Abort(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Received_Master_Abort) | BF_PCIE_RC_Command_Received_Master_Abort(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Detected_Parity_Error[30] (RW)
 *
 * Detected Parity Error
 */
/*@{*/
#define BP_PCIE_RC_Command_Detected_Parity_Error (30U) /*!< Bit position for PCIE_RC_Command_Detected_Parity_Error. */
#define BM_PCIE_RC_Command_Detected_Parity_Error (0x40000000U) /*!< Bit mask for PCIE_RC_Command_Detected_Parity_Error. */
#define BS_PCIE_RC_Command_Detected_Parity_Error (1U) /*!< Bit field size in bits for PCIE_RC_Command_Detected_Parity_Error. */

/*! @brief Read current value of the PCIE_RC_Command_Detected_Parity_Error field. */
#define BR_PCIE_RC_Command_Detected_Parity_Error(x) (HW_PCIE_RC_Command(x).B.Detected_Parity_Error)

/*! @brief Format value for bitfield PCIE_RC_Command_Detected_Parity_Error. */
#define BF_PCIE_RC_Command_Detected_Parity_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Detected_Parity_Error) & BM_PCIE_RC_Command_Detected_Parity_Error)

/*! @brief Set the Detected_Parity_Error field to a new value. */
#define BW_PCIE_RC_Command_Detected_Parity_Error(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Detected_Parity_Error) | BF_PCIE_RC_Command_Detected_Parity_Error(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_Command, field Signaled_System_Error[31] (RW)
 *
 * Signaled System Error
 */
/*@{*/
#define BP_PCIE_RC_Command_Signaled_System_Error (31U) /*!< Bit position for PCIE_RC_Command_Signaled_System_Error. */
#define BM_PCIE_RC_Command_Signaled_System_Error (0x80000000U) /*!< Bit mask for PCIE_RC_Command_Signaled_System_Error. */
#define BS_PCIE_RC_Command_Signaled_System_Error (1U) /*!< Bit field size in bits for PCIE_RC_Command_Signaled_System_Error. */

/*! @brief Read current value of the PCIE_RC_Command_Signaled_System_Error field. */
#define BR_PCIE_RC_Command_Signaled_System_Error(x) (HW_PCIE_RC_Command(x).B.Signaled_System_Error)

/*! @brief Format value for bitfield PCIE_RC_Command_Signaled_System_Error. */
#define BF_PCIE_RC_Command_Signaled_System_Error(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_Command_Signaled_System_Error) & BM_PCIE_RC_Command_Signaled_System_Error)

/*! @brief Set the Signaled_System_Error field to a new value. */
#define BW_PCIE_RC_Command_Signaled_System_Error(x, v) (HW_PCIE_RC_Command_WR(x, (HW_PCIE_RC_Command_RD(x) & ~BM_PCIE_RC_Command_Signaled_System_Error) | BF_PCIE_RC_Command_Signaled_System_Error(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_RevID - Revision ID and Class Code Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_RevID - Revision ID and Class Code Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x08 Byte: 0
 */
typedef union _hw_pcie_rc_revid
{
    uint32_t U;
    struct _hw_pcie_rc_revid_bitfields
    {
        uint32_t CX_REVISION_ID_N : 8; /*!< [7:0]  */
        uint32_t IF_CODE_N : 8;        /*!< [15:8]  */
        uint32_t SUB_CLASS_CODE_N : 8; /*!< [23:16]  */
        uint32_t BASE_CLASS_CODE_N : 8; /*!< [31:24]  */
    } B;
} hw_pcie_rc_revid_t;

/*!
 * @name Constants and macros for entire PCIE_RC_RevID register
 */
/*@{*/
#define HW_PCIE_RC_RevID_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_PCIE_RC_RevID(x)      (*(__I hw_pcie_rc_revid_t *) HW_PCIE_RC_RevID_ADDR(x))
#define HW_PCIE_RC_RevID_RD(x)   (HW_PCIE_RC_RevID(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_RevID bitfields
 */

/*!
 * @name Register PCIE_RC_RevID, field CX_REVISION_ID_N[7:0] (RO)
 *
 * Revision ID, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_RevID_CX_REVISION_ID_N (0U) /*!< Bit position for PCIE_RC_RevID_CX_REVISION_ID_N. */
#define BM_PCIE_RC_RevID_CX_REVISION_ID_N (0x000000FFU) /*!< Bit mask for PCIE_RC_RevID_CX_REVISION_ID_N. */
#define BS_PCIE_RC_RevID_CX_REVISION_ID_N (8U) /*!< Bit field size in bits for PCIE_RC_RevID_CX_REVISION_ID_N. */

/*! @brief Read current value of the PCIE_RC_RevID_CX_REVISION_ID_N field. */
#define BR_PCIE_RC_RevID_CX_REVISION_ID_N(x) (HW_PCIE_RC_RevID(x).B.CX_REVISION_ID_N)
/*@}*/

/*!
 * @name Register PCIE_RC_RevID, field IF_CODE_N[15:8] (RO)
 *
 * Programming Interface, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_RevID_IF_CODE_N (8U)    /*!< Bit position for PCIE_RC_RevID_IF_CODE_N. */
#define BM_PCIE_RC_RevID_IF_CODE_N (0x0000FF00U) /*!< Bit mask for PCIE_RC_RevID_IF_CODE_N. */
#define BS_PCIE_RC_RevID_IF_CODE_N (8U)    /*!< Bit field size in bits for PCIE_RC_RevID_IF_CODE_N. */

/*! @brief Read current value of the PCIE_RC_RevID_IF_CODE_N field. */
#define BR_PCIE_RC_RevID_IF_CODE_N(x) (HW_PCIE_RC_RevID(x).B.IF_CODE_N)
/*@}*/

/*!
 * @name Register PCIE_RC_RevID, field SUB_CLASS_CODE_N[23:16] (RO)
 *
 * Subclass Code, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_RevID_SUB_CLASS_CODE_N (16U) /*!< Bit position for PCIE_RC_RevID_SUB_CLASS_CODE_N. */
#define BM_PCIE_RC_RevID_SUB_CLASS_CODE_N (0x00FF0000U) /*!< Bit mask for PCIE_RC_RevID_SUB_CLASS_CODE_N. */
#define BS_PCIE_RC_RevID_SUB_CLASS_CODE_N (8U) /*!< Bit field size in bits for PCIE_RC_RevID_SUB_CLASS_CODE_N. */

/*! @brief Read current value of the PCIE_RC_RevID_SUB_CLASS_CODE_N field. */
#define BR_PCIE_RC_RevID_SUB_CLASS_CODE_N(x) (HW_PCIE_RC_RevID(x).B.SUB_CLASS_CODE_N)
/*@}*/

/*!
 * @name Register PCIE_RC_RevID, field BASE_CLASS_CODE_N[31:24] (RO)
 *
 * Base Class Code, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_RevID_BASE_CLASS_CODE_N (24U) /*!< Bit position for PCIE_RC_RevID_BASE_CLASS_CODE_N. */
#define BM_PCIE_RC_RevID_BASE_CLASS_CODE_N (0xFF000000U) /*!< Bit mask for PCIE_RC_RevID_BASE_CLASS_CODE_N. */
#define BS_PCIE_RC_RevID_BASE_CLASS_CODE_N (8U) /*!< Bit field size in bits for PCIE_RC_RevID_BASE_CLASS_CODE_N. */

/*! @brief Read current value of the PCIE_RC_RevID_BASE_CLASS_CODE_N field. */
#define BR_PCIE_RC_RevID_BASE_CLASS_CODE_N(x) (HW_PCIE_RC_RevID(x).B.BASE_CLASS_CODE_N)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_BIST - BIST Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_BIST - BIST Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x0C Byte: 0
 */
typedef union _hw_pcie_rc_bist
{
    uint32_t U;
    struct _hw_pcie_rc_bist_bitfields
    {
        uint32_t Cache_Line_Size : 8;  /*!< [7:0]  */
        uint32_t Master_Latency_Timer : 8; /*!< [15:8]  */
        uint32_t Configuration_Header_Format : 7; /*!< [22:16]  */
        uint32_t Multi_Function_Device : 1; /*!< [23]  */
        uint32_t Not_supported_by__core : 8; /*!< [31:24]  */
    } B;
} hw_pcie_rc_bist_t;

/*!
 * @name Constants and macros for entire PCIE_RC_BIST register
 */
/*@{*/
#define HW_PCIE_RC_BIST_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_PCIE_RC_BIST(x)       (*(__IO hw_pcie_rc_bist_t *) HW_PCIE_RC_BIST_ADDR(x))
#define HW_PCIE_RC_BIST_RD(x)    (HW_PCIE_RC_BIST(x).U)
#define HW_PCIE_RC_BIST_WR(x, v) (HW_PCIE_RC_BIST(x).U = (v))
#define HW_PCIE_RC_BIST_SET(x, v) (HW_PCIE_RC_BIST_WR(x, HW_PCIE_RC_BIST_RD(x) |  (v)))
#define HW_PCIE_RC_BIST_CLR(x, v) (HW_PCIE_RC_BIST_WR(x, HW_PCIE_RC_BIST_RD(x) & ~(v)))
#define HW_PCIE_RC_BIST_TOG(x, v) (HW_PCIE_RC_BIST_WR(x, HW_PCIE_RC_BIST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_BIST bitfields
 */

/*!
 * @name Register PCIE_RC_BIST, field Cache_Line_Size[7:0] (RW)
 *
 * Cache Line Size The Cache Line Size register is RW for legacy compatibility
 * purposes and is not applicable to PCI Express device functionality. Writing to
 * the Cache Line Size register does not impact functionality of the core.
 */
/*@{*/
#define BP_PCIE_RC_BIST_Cache_Line_Size (0U) /*!< Bit position for PCIE_RC_BIST_Cache_Line_Size. */
#define BM_PCIE_RC_BIST_Cache_Line_Size (0x000000FFU) /*!< Bit mask for PCIE_RC_BIST_Cache_Line_Size. */
#define BS_PCIE_RC_BIST_Cache_Line_Size (8U) /*!< Bit field size in bits for PCIE_RC_BIST_Cache_Line_Size. */

/*! @brief Read current value of the PCIE_RC_BIST_Cache_Line_Size field. */
#define BR_PCIE_RC_BIST_Cache_Line_Size(x) (HW_PCIE_RC_BIST(x).B.Cache_Line_Size)

/*! @brief Format value for bitfield PCIE_RC_BIST_Cache_Line_Size. */
#define BF_PCIE_RC_BIST_Cache_Line_Size(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BIST_Cache_Line_Size) & BM_PCIE_RC_BIST_Cache_Line_Size)

/*! @brief Set the Cache_Line_Size field to a new value. */
#define BW_PCIE_RC_BIST_Cache_Line_Size(x, v) (HW_PCIE_RC_BIST_WR(x, (HW_PCIE_RC_BIST_RD(x) & ~BM_PCIE_RC_BIST_Cache_Line_Size) | BF_PCIE_RC_BIST_Cache_Line_Size(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BIST, field Master_Latency_Timer[15:8] (RW)
 *
 * Master Latency Timer Not applicable for PCI Express, hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_BIST_Master_Latency_Timer (8U) /*!< Bit position for PCIE_RC_BIST_Master_Latency_Timer. */
#define BM_PCIE_RC_BIST_Master_Latency_Timer (0x0000FF00U) /*!< Bit mask for PCIE_RC_BIST_Master_Latency_Timer. */
#define BS_PCIE_RC_BIST_Master_Latency_Timer (8U) /*!< Bit field size in bits for PCIE_RC_BIST_Master_Latency_Timer. */

/*! @brief Read current value of the PCIE_RC_BIST_Master_Latency_Timer field. */
#define BR_PCIE_RC_BIST_Master_Latency_Timer(x) (HW_PCIE_RC_BIST(x).B.Master_Latency_Timer)

/*! @brief Format value for bitfield PCIE_RC_BIST_Master_Latency_Timer. */
#define BF_PCIE_RC_BIST_Master_Latency_Timer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BIST_Master_Latency_Timer) & BM_PCIE_RC_BIST_Master_Latency_Timer)

/*! @brief Set the Master_Latency_Timer field to a new value. */
#define BW_PCIE_RC_BIST_Master_Latency_Timer(x, v) (HW_PCIE_RC_BIST_WR(x, (HW_PCIE_RC_BIST_RD(x) & ~BM_PCIE_RC_BIST_Master_Latency_Timer) | BF_PCIE_RC_BIST_Master_Latency_Timer(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BIST, field Configuration_Header_Format[22:16] (RW)
 *
 * Configuration Header Format Hardwired to 0 for type 0.
 */
/*@{*/
#define BP_PCIE_RC_BIST_Configuration_Header_Format (16U) /*!< Bit position for PCIE_RC_BIST_Configuration_Header_Format. */
#define BM_PCIE_RC_BIST_Configuration_Header_Format (0x007F0000U) /*!< Bit mask for PCIE_RC_BIST_Configuration_Header_Format. */
#define BS_PCIE_RC_BIST_Configuration_Header_Format (7U) /*!< Bit field size in bits for PCIE_RC_BIST_Configuration_Header_Format. */

/*! @brief Read current value of the PCIE_RC_BIST_Configuration_Header_Format field. */
#define BR_PCIE_RC_BIST_Configuration_Header_Format(x) (HW_PCIE_RC_BIST(x).B.Configuration_Header_Format)

/*! @brief Format value for bitfield PCIE_RC_BIST_Configuration_Header_Format. */
#define BF_PCIE_RC_BIST_Configuration_Header_Format(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BIST_Configuration_Header_Format) & BM_PCIE_RC_BIST_Configuration_Header_Format)

/*! @brief Set the Configuration_Header_Format field to a new value. */
#define BW_PCIE_RC_BIST_Configuration_Header_Format(x, v) (HW_PCIE_RC_BIST_WR(x, (HW_PCIE_RC_BIST_RD(x) & ~BM_PCIE_RC_BIST_Configuration_Header_Format) | BF_PCIE_RC_BIST_Configuration_Header_Format(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BIST, field Multi_Function_Device[23] (RW)
 *
 * Multi Function Device The default value is 0 for a single function device
 * (`CX_NFUNC = 1) or 1 for a multi-function device (`CX_NFUNC != 1). The Multi
 * Function Device bit is writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_BIST_Multi_Function_Device (23U) /*!< Bit position for PCIE_RC_BIST_Multi_Function_Device. */
#define BM_PCIE_RC_BIST_Multi_Function_Device (0x00800000U) /*!< Bit mask for PCIE_RC_BIST_Multi_Function_Device. */
#define BS_PCIE_RC_BIST_Multi_Function_Device (1U) /*!< Bit field size in bits for PCIE_RC_BIST_Multi_Function_Device. */

/*! @brief Read current value of the PCIE_RC_BIST_Multi_Function_Device field. */
#define BR_PCIE_RC_BIST_Multi_Function_Device(x) (HW_PCIE_RC_BIST(x).B.Multi_Function_Device)

/*! @brief Format value for bitfield PCIE_RC_BIST_Multi_Function_Device. */
#define BF_PCIE_RC_BIST_Multi_Function_Device(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BIST_Multi_Function_Device) & BM_PCIE_RC_BIST_Multi_Function_Device)

/*! @brief Set the Multi_Function_Device field to a new value. */
#define BW_PCIE_RC_BIST_Multi_Function_Device(x, v) (HW_PCIE_RC_BIST_WR(x, (HW_PCIE_RC_BIST_RD(x) & ~BM_PCIE_RC_BIST_Multi_Function_Device) | BF_PCIE_RC_BIST_Multi_Function_Device(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BIST, field Not_supported_by__core[31:24] (RW)
 *
 * The BIST register functions are not supported by the core. All 8 bits of the
 * BIST register are hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_BIST_Not_supported_by__core (24U) /*!< Bit position for PCIE_RC_BIST_Not_supported_by__core. */
#define BM_PCIE_RC_BIST_Not_supported_by__core (0xFF000000U) /*!< Bit mask for PCIE_RC_BIST_Not_supported_by__core. */
#define BS_PCIE_RC_BIST_Not_supported_by__core (8U) /*!< Bit field size in bits for PCIE_RC_BIST_Not_supported_by__core. */

/*! @brief Read current value of the PCIE_RC_BIST_Not_supported_by__core field. */
#define BR_PCIE_RC_BIST_Not_supported_by__core(x) (HW_PCIE_RC_BIST(x).B.Not_supported_by__core)

/*! @brief Format value for bitfield PCIE_RC_BIST_Not_supported_by__core. */
#define BF_PCIE_RC_BIST_Not_supported_by__core(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BIST_Not_supported_by__core) & BM_PCIE_RC_BIST_Not_supported_by__core)

/*! @brief Set the Not_supported_by__core field to a new value. */
#define BW_PCIE_RC_BIST_Not_supported_by__core(x, v) (HW_PCIE_RC_BIST_WR(x, (HW_PCIE_RC_BIST_RD(x) & ~BM_PCIE_RC_BIST_Not_supported_by__core) | BF_PCIE_RC_BIST_Not_supported_by__core(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_BAR0 - Base Address 0
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_BAR0 - Base Address 0 (RO)
 *
 * Reset value: 0x0000000CU
 *
 * Offset: 0x10-0x24 The core provides three pairs of 32-bit BARs for each
 * implemented function. Each pair (BARs 0 and 1, BARs 2 and 3, BARs 4 and 5) can be
 * configured as follows: One 64-bit BAR: For example, BARs 0 and 1 are combined
 * to form a single 64-bit BAR. Two 32-bit BARs: For example, BARs 0 and 1 are two
 * independent 32-bit BARs. One 32-bit BAR: For example, BAR 0 is a 32-bit BAR
 * and BAR 1 is either disabled or removed from the core altogether to reduce gate
 * count. In addition, you can configure each BAR to have its incoming Requests
 * routed to either: RTRGT1 The following sections describe how to set up the BAR
 * types and sizes by programming values into the base address registers. For
 * more information about routing Requests to either RTRGT1 on a BAR-by- BAR basis,
 * see Receive Filtering. The contents of the six BARs determine the BAR
 * configuration. The reset values of the BARs are determined by hardware configuration
 * options. At runtime, application software can overwrite the BAR contents to
 * reconfigure the BARs (unless the affected BAR is removed during hardware
 * configuration). Application software must observe the rules listed below when writing
 * to the BARs. The rules for BAR configuration are the same for all three
 * pairs. Using BARs 0 and 1 as the example pair, the rules for BAR configuration are:
 * Any pair (for example, BARs 0 and 1) can be configured as one 64-bit BAR, two
 * 32-bit BARs, or one 32-bit BAR. BAR pairs cannot overlap to form a 64-bit
 * BAR. For example, you cannot combine BARs 1 and 2 to form a 64-bit BAR. An I/O
 * BAR must be a 32-bit BAR and cannot be prefetchable. If the device is configured
 * as a PCI Express Endpoint (not a Legacy Endpoint), then any memory that is
 * configured as prefetchable must be a 64-bit memory BAR. If BAR 0 is configured
 * as a 64-bit BAR: BAR 1 is the upper 32 bits of the combined 64-bit BAR formed
 * by BARs 0 and 1. Therefore, BAR 1 must be disabled and cannot be configured
 * independently. BAR 0 must be a memory BAR and can be either prefetchable or
 * non-prefetchable. The contents of the BAR 0 Mask register determine the number of
 * writable bits in the 64-bit BAR, subject to the restrictions described in BAR
 * Mask Register. The BAR 1 Mask register contains the upper 32 bits of the BAR 0
 * Mask value. BAR 0 can be disabled by writing 0 to bit 0 of the BAR 0 Mask
 * register If BAR 0 is configured as a 32-bit BAR: You can configure BAR 1 as an
 * independent 32-bit BAR BAR 0 can be configured as a memory BAR or an I/O BAR. The
 * contents of the BAR 0 Mask register determine the number of writable bits in
 * the 32-bit BAR 0, subject to the restrictions described in BAR Mask Registers.
 * BAR 0 can be disabled by writing 0 to bit 0 of the BAR 0 Mask register When
 * BAR 0 is configured as a 32-bit BAR, BAR 1 is available as an independent
 * 32-bit BAR according to the following rules: BAR 1 can be configured as a memory
 * BAR or an I/O BAR. The contents of the BAR 1 Mask register determine the number
 * of writable bits in the 32-bit BAR 1, subject to the restrictions described in
 * BAR Mask Registers. The same rules apply for pairs 2/3 and 4/5. Offset: 0x10
 * (if included in the core hardware configuration)
 */
typedef union _hw_pcie_rc_bar0
{
    uint32_t U;
    struct _hw_pcie_rc_bar0_bitfields
    {
        uint32_t Mem_I_O : 1;          /*!< [0]  */
        uint32_t TYPE : 2;             /*!< [2:1]  */
        uint32_t PREF : 1;             /*!< [3]  */
        uint32_t ADDRESS : 28;         /*!< [31:4]  */
    } B;
} hw_pcie_rc_bar0_t;

/*!
 * @name Constants and macros for entire PCIE_RC_BAR0 register
 */
/*@{*/
#define HW_PCIE_RC_BAR0_ADDR(x)  ((uintptr_t)(x) + 0x10U)

#define HW_PCIE_RC_BAR0(x)       (*(__I hw_pcie_rc_bar0_t *) HW_PCIE_RC_BAR0_ADDR(x))
#define HW_PCIE_RC_BAR0_RD(x)    (HW_PCIE_RC_BAR0(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_BAR0 bitfields
 */

/*!
 * @name Register PCIE_RC_BAR0, field Mem_I_O[0] (RO)
 *
 * Bits [3:0] are writable through the DBI.
 *
 * Values:
 * - 0 - = BAR 0 is a memory BAR
 * - 1 - = BAR 0 is an I/O BAR
 */
/*@{*/
#define BP_PCIE_RC_BAR0_Mem_I_O (0U)       /*!< Bit position for PCIE_RC_BAR0_Mem_I_O. */
#define BM_PCIE_RC_BAR0_Mem_I_O (0x00000001U) /*!< Bit mask for PCIE_RC_BAR0_Mem_I_O. */
#define BS_PCIE_RC_BAR0_Mem_I_O (1U)       /*!< Bit field size in bits for PCIE_RC_BAR0_Mem_I_O. */

/*! @brief Read current value of the PCIE_RC_BAR0_Mem_I_O field. */
#define BR_PCIE_RC_BAR0_Mem_I_O(x) (HW_PCIE_RC_BAR0(x).B.Mem_I_O)
/*@}*/

/*!
 * @name Register PCIE_RC_BAR0, field TYPE[2:1] (RO)
 *
 * If BAR 0 is an I/O BAR, bit 2 the least significant bit of the base address
 * and bit 1 is 0. Bits [3:0] are writable through the DBI. If BAR 0 is a memory
 * BAR, bits [2:1] determine the BAR type:
 *
 * Values:
 * - 00 - = 32-bit BAR
 * - 10 - = 64-bit BAR
 */
/*@{*/
#define BP_PCIE_RC_BAR0_TYPE (1U)          /*!< Bit position for PCIE_RC_BAR0_TYPE. */
#define BM_PCIE_RC_BAR0_TYPE (0x00000006U) /*!< Bit mask for PCIE_RC_BAR0_TYPE. */
#define BS_PCIE_RC_BAR0_TYPE (2U)          /*!< Bit field size in bits for PCIE_RC_BAR0_TYPE. */

/*! @brief Read current value of the PCIE_RC_BAR0_TYPE field. */
#define BR_PCIE_RC_BAR0_TYPE(x) (HW_PCIE_RC_BAR0(x).B.TYPE)
/*@}*/

/*!
 * @name Register PCIE_RC_BAR0, field PREF[3] (RO)
 *
 * If BAR 0 is an I/O BAR, bit 3 is the second least significant bit of the base
 * address. Bits [3:0] are writable through the DBI. If BAR 0 is a memory BAR,
 * bit 3 indicates if the memory region is prefetchable:
 *
 * Values:
 * - 0 - = Non-prefetchable
 * - 1 - = Prefetchable
 */
/*@{*/
#define BP_PCIE_RC_BAR0_PREF (3U)          /*!< Bit position for PCIE_RC_BAR0_PREF. */
#define BM_PCIE_RC_BAR0_PREF (0x00000008U) /*!< Bit mask for PCIE_RC_BAR0_PREF. */
#define BS_PCIE_RC_BAR0_PREF (1U)          /*!< Bit field size in bits for PCIE_RC_BAR0_PREF. */

/*! @brief Read current value of the PCIE_RC_BAR0_PREF field. */
#define BR_PCIE_RC_BAR0_PREF(x) (HW_PCIE_RC_BAR0(x).B.PREF)
/*@}*/

/*!
 * @name Register PCIE_RC_BAR0, field ADDRESS[31:4] (RO)
 *
 * BAR 0 base address bits (for a 64-bit BAR, the remaining upper address bits
 * are in BAR 1). The BAR 0 Mask value determines which address bits are masked.
 */
/*@{*/
#define BP_PCIE_RC_BAR0_ADDRESS (4U)       /*!< Bit position for PCIE_RC_BAR0_ADDRESS. */
#define BM_PCIE_RC_BAR0_ADDRESS (0xFFFFFFF0U) /*!< Bit mask for PCIE_RC_BAR0_ADDRESS. */
#define BS_PCIE_RC_BAR0_ADDRESS (28U)      /*!< Bit field size in bits for PCIE_RC_BAR0_ADDRESS. */

/*! @brief Read current value of the PCIE_RC_BAR0_ADDRESS field. */
#define BR_PCIE_RC_BAR0_ADDRESS(x) (HW_PCIE_RC_BAR0(x).B.ADDRESS)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_BAR1 - Base Address 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_BAR1 - Base Address 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Address: 0x14
 */
typedef union _hw_pcie_rc_bar1
{
    uint32_t U;
    struct _hw_pcie_rc_bar1_bitfields
    {
        uint32_t ADDRESS : 32;         /*!< [31:0]  */
    } B;
} hw_pcie_rc_bar1_t;

/*!
 * @name Constants and macros for entire PCIE_RC_BAR1 register
 */
/*@{*/
#define HW_PCIE_RC_BAR1_ADDR(x)  ((uintptr_t)(x) + 0x14U)

#define HW_PCIE_RC_BAR1(x)       (*(__I hw_pcie_rc_bar1_t *) HW_PCIE_RC_BAR1_ADDR(x))
#define HW_PCIE_RC_BAR1_RD(x)    (HW_PCIE_RC_BAR1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_BAR1 bitfields
 */

/*!
 * @name Register PCIE_RC_BAR1, field ADDRESS[31:0] (RO)
 *
 * BAR 1 contains the upper 32 bits of the BAR 0 base address (bits [63:32]).
 */
/*@{*/
#define BP_PCIE_RC_BAR1_ADDRESS (0U)       /*!< Bit position for PCIE_RC_BAR1_ADDRESS. */
#define BM_PCIE_RC_BAR1_ADDRESS (0xFFFFFFFFU) /*!< Bit mask for PCIE_RC_BAR1_ADDRESS. */
#define BS_PCIE_RC_BAR1_ADDRESS (32U)      /*!< Bit field size in bits for PCIE_RC_BAR1_ADDRESS. */

/*! @brief Read current value of the PCIE_RC_BAR1_ADDRESS field. */
#define BR_PCIE_RC_BAR1_ADDRESS(x) (HW_PCIE_RC_BAR1(x).U)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_BNR - Bus Number Registers
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_BNR - Bus Number Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_pcie_rc_bnr
{
    uint32_t U;
    struct _hw_pcie_rc_bnr_bitfields
    {
        uint32_t PRIMARY_BUS_NUM : 8;  /*!< [7:0]  */
        uint32_t SECONDARY_BUS_NUM : 8; /*!< [15:8]  */
        uint32_t SUBORD_BUS_NUM : 8;   /*!< [23:16]  */
        uint32_t SECONDARY_LAT_TMR : 8; /*!< [31:24]  */
    } B;
} hw_pcie_rc_bnr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_BNR register
 */
/*@{*/
#define HW_PCIE_RC_BNR_ADDR(x)   ((uintptr_t)(x) + 0x18U)

#define HW_PCIE_RC_BNR(x)        (*(__IO hw_pcie_rc_bnr_t *) HW_PCIE_RC_BNR_ADDR(x))
#define HW_PCIE_RC_BNR_RD(x)     (HW_PCIE_RC_BNR(x).U)
#define HW_PCIE_RC_BNR_WR(x, v)  (HW_PCIE_RC_BNR(x).U = (v))
#define HW_PCIE_RC_BNR_SET(x, v) (HW_PCIE_RC_BNR_WR(x, HW_PCIE_RC_BNR_RD(x) |  (v)))
#define HW_PCIE_RC_BNR_CLR(x, v) (HW_PCIE_RC_BNR_WR(x, HW_PCIE_RC_BNR_RD(x) & ~(v)))
#define HW_PCIE_RC_BNR_TOG(x, v) (HW_PCIE_RC_BNR_WR(x, HW_PCIE_RC_BNR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_BNR bitfields
 */

/*!
 * @name Register PCIE_RC_BNR, field PRIMARY_BUS_NUM[7:0] (RW)
 *
 * Primary bus number.
 */
/*@{*/
#define BP_PCIE_RC_BNR_PRIMARY_BUS_NUM (0U) /*!< Bit position for PCIE_RC_BNR_PRIMARY_BUS_NUM. */
#define BM_PCIE_RC_BNR_PRIMARY_BUS_NUM (0x000000FFU) /*!< Bit mask for PCIE_RC_BNR_PRIMARY_BUS_NUM. */
#define BS_PCIE_RC_BNR_PRIMARY_BUS_NUM (8U) /*!< Bit field size in bits for PCIE_RC_BNR_PRIMARY_BUS_NUM. */

/*! @brief Read current value of the PCIE_RC_BNR_PRIMARY_BUS_NUM field. */
#define BR_PCIE_RC_BNR_PRIMARY_BUS_NUM(x) (HW_PCIE_RC_BNR(x).B.PRIMARY_BUS_NUM)

/*! @brief Format value for bitfield PCIE_RC_BNR_PRIMARY_BUS_NUM. */
#define BF_PCIE_RC_BNR_PRIMARY_BUS_NUM(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BNR_PRIMARY_BUS_NUM) & BM_PCIE_RC_BNR_PRIMARY_BUS_NUM)

/*! @brief Set the PRIMARY_BUS_NUM field to a new value. */
#define BW_PCIE_RC_BNR_PRIMARY_BUS_NUM(x, v) (HW_PCIE_RC_BNR_WR(x, (HW_PCIE_RC_BNR_RD(x) & ~BM_PCIE_RC_BNR_PRIMARY_BUS_NUM) | BF_PCIE_RC_BNR_PRIMARY_BUS_NUM(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BNR, field SECONDARY_BUS_NUM[15:8] (RW)
 *
 * Secondary bus number.
 */
/*@{*/
#define BP_PCIE_RC_BNR_SECONDARY_BUS_NUM (8U) /*!< Bit position for PCIE_RC_BNR_SECONDARY_BUS_NUM. */
#define BM_PCIE_RC_BNR_SECONDARY_BUS_NUM (0x0000FF00U) /*!< Bit mask for PCIE_RC_BNR_SECONDARY_BUS_NUM. */
#define BS_PCIE_RC_BNR_SECONDARY_BUS_NUM (8U) /*!< Bit field size in bits for PCIE_RC_BNR_SECONDARY_BUS_NUM. */

/*! @brief Read current value of the PCIE_RC_BNR_SECONDARY_BUS_NUM field. */
#define BR_PCIE_RC_BNR_SECONDARY_BUS_NUM(x) (HW_PCIE_RC_BNR(x).B.SECONDARY_BUS_NUM)

/*! @brief Format value for bitfield PCIE_RC_BNR_SECONDARY_BUS_NUM. */
#define BF_PCIE_RC_BNR_SECONDARY_BUS_NUM(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BNR_SECONDARY_BUS_NUM) & BM_PCIE_RC_BNR_SECONDARY_BUS_NUM)

/*! @brief Set the SECONDARY_BUS_NUM field to a new value. */
#define BW_PCIE_RC_BNR_SECONDARY_BUS_NUM(x, v) (HW_PCIE_RC_BNR_WR(x, (HW_PCIE_RC_BNR_RD(x) & ~BM_PCIE_RC_BNR_SECONDARY_BUS_NUM) | BF_PCIE_RC_BNR_SECONDARY_BUS_NUM(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BNR, field SUBORD_BUS_NUM[23:16] (RW)
 *
 * Subordinate bus number.
 */
/*@{*/
#define BP_PCIE_RC_BNR_SUBORD_BUS_NUM (16U) /*!< Bit position for PCIE_RC_BNR_SUBORD_BUS_NUM. */
#define BM_PCIE_RC_BNR_SUBORD_BUS_NUM (0x00FF0000U) /*!< Bit mask for PCIE_RC_BNR_SUBORD_BUS_NUM. */
#define BS_PCIE_RC_BNR_SUBORD_BUS_NUM (8U) /*!< Bit field size in bits for PCIE_RC_BNR_SUBORD_BUS_NUM. */

/*! @brief Read current value of the PCIE_RC_BNR_SUBORD_BUS_NUM field. */
#define BR_PCIE_RC_BNR_SUBORD_BUS_NUM(x) (HW_PCIE_RC_BNR(x).B.SUBORD_BUS_NUM)

/*! @brief Format value for bitfield PCIE_RC_BNR_SUBORD_BUS_NUM. */
#define BF_PCIE_RC_BNR_SUBORD_BUS_NUM(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_BNR_SUBORD_BUS_NUM) & BM_PCIE_RC_BNR_SUBORD_BUS_NUM)

/*! @brief Set the SUBORD_BUS_NUM field to a new value. */
#define BW_PCIE_RC_BNR_SUBORD_BUS_NUM(x, v) (HW_PCIE_RC_BNR_WR(x, (HW_PCIE_RC_BNR_RD(x) & ~BM_PCIE_RC_BNR_SUBORD_BUS_NUM) | BF_PCIE_RC_BNR_SUBORD_BUS_NUM(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_BNR, field SECONDARY_LAT_TMR[31:24] (RO)
 *
 * Secondary latency timer.
 */
/*@{*/
#define BP_PCIE_RC_BNR_SECONDARY_LAT_TMR (24U) /*!< Bit position for PCIE_RC_BNR_SECONDARY_LAT_TMR. */
#define BM_PCIE_RC_BNR_SECONDARY_LAT_TMR (0xFF000000U) /*!< Bit mask for PCIE_RC_BNR_SECONDARY_LAT_TMR. */
#define BS_PCIE_RC_BNR_SECONDARY_LAT_TMR (8U) /*!< Bit field size in bits for PCIE_RC_BNR_SECONDARY_LAT_TMR. */

/*! @brief Read current value of the PCIE_RC_BNR_SECONDARY_LAT_TMR field. */
#define BR_PCIE_RC_BNR_SECONDARY_LAT_TMR(x) (HW_PCIE_RC_BNR(x).B.SECONDARY_LAT_TMR)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_IOBLSSR - I/O Base Limit Secondary Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_IOBLSSR - I/O Base Limit Secondary Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_pcie_rc_ioblssr
{
    uint32_t U;
    struct _hw_pcie_rc_ioblssr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t IO_SB : 4;            /*!< [7:4]  */
        uint32_t RESERVED1 : 4;        /*!< [11:8]  */
        uint32_t IO_SL : 4;            /*!< [15:12]  */
        uint32_t RESERVED2 : 5;        /*!< [20:16]  */
        uint32_t CAP_66M : 1;          /*!< [21]  */
        uint32_t RESERVED3 : 1;        /*!< [22]  */
        uint32_t FAST_B2B_CAP : 1;     /*!< [23]  */
        uint32_t MSTR_DAT_PARITY_ERR : 1; /*!< [24]  */
        uint32_t RESERVED4 : 2;        /*!< [26:25]  */
        uint32_t SIG_TARGET_ABORT : 1; /*!< [27]  */
        uint32_t RX_TARGET_ABORT : 1;  /*!< [28]  */
        uint32_t RX_MASTER_ABORT : 1;  /*!< [29]  */
        uint32_t RX_SYS_ERR : 1;       /*!< [30]  */
        uint32_t DET_PARITY_ERR : 1;   /*!< [31]  */
    } B;
} hw_pcie_rc_ioblssr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_IOBLSSR register
 */
/*@{*/
#define HW_PCIE_RC_IOBLSSR_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_PCIE_RC_IOBLSSR(x)    (*(__IO hw_pcie_rc_ioblssr_t *) HW_PCIE_RC_IOBLSSR_ADDR(x))
#define HW_PCIE_RC_IOBLSSR_RD(x) (HW_PCIE_RC_IOBLSSR(x).U)
#define HW_PCIE_RC_IOBLSSR_WR(x, v) (HW_PCIE_RC_IOBLSSR(x).U = (v))
#define HW_PCIE_RC_IOBLSSR_SET(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, HW_PCIE_RC_IOBLSSR_RD(x) |  (v)))
#define HW_PCIE_RC_IOBLSSR_CLR(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, HW_PCIE_RC_IOBLSSR_RD(x) & ~(v)))
#define HW_PCIE_RC_IOBLSSR_TOG(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, HW_PCIE_RC_IOBLSSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_IOBLSSR bitfields
 */

/*!
 * @name Register PCIE_RC_IOBLSSR, field IO_SB[7:4] (RW)
 *
 * I/O Space Base.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_IO_SB (4U)      /*!< Bit position for PCIE_RC_IOBLSSR_IO_SB. */
#define BM_PCIE_RC_IOBLSSR_IO_SB (0x000000F0U) /*!< Bit mask for PCIE_RC_IOBLSSR_IO_SB. */
#define BS_PCIE_RC_IOBLSSR_IO_SB (4U)      /*!< Bit field size in bits for PCIE_RC_IOBLSSR_IO_SB. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_IO_SB field. */
#define BR_PCIE_RC_IOBLSSR_IO_SB(x) (HW_PCIE_RC_IOBLSSR(x).B.IO_SB)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_IO_SB. */
#define BF_PCIE_RC_IOBLSSR_IO_SB(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_IO_SB) & BM_PCIE_RC_IOBLSSR_IO_SB)

/*! @brief Set the IO_SB field to a new value. */
#define BW_PCIE_RC_IOBLSSR_IO_SB(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_IO_SB | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_IO_SB(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field IO_SL[15:12] (RW)
 *
 * I/O Space Limit.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_IO_SL (12U)     /*!< Bit position for PCIE_RC_IOBLSSR_IO_SL. */
#define BM_PCIE_RC_IOBLSSR_IO_SL (0x0000F000U) /*!< Bit mask for PCIE_RC_IOBLSSR_IO_SL. */
#define BS_PCIE_RC_IOBLSSR_IO_SL (4U)      /*!< Bit field size in bits for PCIE_RC_IOBLSSR_IO_SL. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_IO_SL field. */
#define BR_PCIE_RC_IOBLSSR_IO_SL(x) (HW_PCIE_RC_IOBLSSR(x).B.IO_SL)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_IO_SL. */
#define BF_PCIE_RC_IOBLSSR_IO_SL(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_IO_SL) & BM_PCIE_RC_IOBLSSR_IO_SL)

/*! @brief Set the IO_SL field to a new value. */
#define BW_PCIE_RC_IOBLSSR_IO_SL(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_IO_SL | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_IO_SL(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field CAP_66M[21] (RO)
 *
 * 66 MHz Capable. Not applicable to PCI Express, hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_CAP_66M (21U)   /*!< Bit position for PCIE_RC_IOBLSSR_CAP_66M. */
#define BM_PCIE_RC_IOBLSSR_CAP_66M (0x00200000U) /*!< Bit mask for PCIE_RC_IOBLSSR_CAP_66M. */
#define BS_PCIE_RC_IOBLSSR_CAP_66M (1U)    /*!< Bit field size in bits for PCIE_RC_IOBLSSR_CAP_66M. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_CAP_66M field. */
#define BR_PCIE_RC_IOBLSSR_CAP_66M(x) (HW_PCIE_RC_IOBLSSR(x).B.CAP_66M)
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field FAST_B2B_CAP[23] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_FAST_B2B_CAP (23U) /*!< Bit position for PCIE_RC_IOBLSSR_FAST_B2B_CAP. */
#define BM_PCIE_RC_IOBLSSR_FAST_B2B_CAP (0x00800000U) /*!< Bit mask for PCIE_RC_IOBLSSR_FAST_B2B_CAP. */
#define BS_PCIE_RC_IOBLSSR_FAST_B2B_CAP (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_FAST_B2B_CAP. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_FAST_B2B_CAP field. */
#define BR_PCIE_RC_IOBLSSR_FAST_B2B_CAP(x) (HW_PCIE_RC_IOBLSSR(x).B.FAST_B2B_CAP)
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field MSTR_DAT_PARITY_ERR[24] (W1C)
 *
 * Master Data Parity Error.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR (24U) /*!< Bit position for PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR. */
#define BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR (0x01000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR. */
#define BS_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR field. */
#define BR_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR(x) (HW_PCIE_RC_IOBLSSR(x).B.MSTR_DAT_PARITY_ERR)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR. */
#define BF_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR) & BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR)

/*! @brief Set the MSTR_DAT_PARITY_ERR field to a new value. */
#define BW_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field SIG_TARGET_ABORT[27] (W1C)
 *
 * Signaled Target Abort.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT (27U) /*!< Bit position for PCIE_RC_IOBLSSR_SIG_TARGET_ABORT. */
#define BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT (0x08000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_SIG_TARGET_ABORT. */
#define BS_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_SIG_TARGET_ABORT. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_SIG_TARGET_ABORT field. */
#define BR_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT(x) (HW_PCIE_RC_IOBLSSR(x).B.SIG_TARGET_ABORT)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_SIG_TARGET_ABORT. */
#define BF_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT) & BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT)

/*! @brief Set the SIG_TARGET_ABORT field to a new value. */
#define BW_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field RX_TARGET_ABORT[28] (W1C)
 *
 * Received Target Abort.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_RX_TARGET_ABORT (28U) /*!< Bit position for PCIE_RC_IOBLSSR_RX_TARGET_ABORT. */
#define BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT (0x10000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_RX_TARGET_ABORT. */
#define BS_PCIE_RC_IOBLSSR_RX_TARGET_ABORT (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_RX_TARGET_ABORT. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_RX_TARGET_ABORT field. */
#define BR_PCIE_RC_IOBLSSR_RX_TARGET_ABORT(x) (HW_PCIE_RC_IOBLSSR(x).B.RX_TARGET_ABORT)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_RX_TARGET_ABORT. */
#define BF_PCIE_RC_IOBLSSR_RX_TARGET_ABORT(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_RX_TARGET_ABORT) & BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT)

/*! @brief Set the RX_TARGET_ABORT field to a new value. */
#define BW_PCIE_RC_IOBLSSR_RX_TARGET_ABORT(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_RX_TARGET_ABORT(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field RX_MASTER_ABORT[29] (W1C)
 *
 * Received Master Abort.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_RX_MASTER_ABORT (29U) /*!< Bit position for PCIE_RC_IOBLSSR_RX_MASTER_ABORT. */
#define BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT (0x20000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_RX_MASTER_ABORT. */
#define BS_PCIE_RC_IOBLSSR_RX_MASTER_ABORT (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_RX_MASTER_ABORT. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_RX_MASTER_ABORT field. */
#define BR_PCIE_RC_IOBLSSR_RX_MASTER_ABORT(x) (HW_PCIE_RC_IOBLSSR(x).B.RX_MASTER_ABORT)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_RX_MASTER_ABORT. */
#define BF_PCIE_RC_IOBLSSR_RX_MASTER_ABORT(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_RX_MASTER_ABORT) & BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT)

/*! @brief Set the RX_MASTER_ABORT field to a new value. */
#define BW_PCIE_RC_IOBLSSR_RX_MASTER_ABORT(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_RX_MASTER_ABORT(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field RX_SYS_ERR[30] (W1C)
 *
 * Received System Error.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_RX_SYS_ERR (30U) /*!< Bit position for PCIE_RC_IOBLSSR_RX_SYS_ERR. */
#define BM_PCIE_RC_IOBLSSR_RX_SYS_ERR (0x40000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_RX_SYS_ERR. */
#define BS_PCIE_RC_IOBLSSR_RX_SYS_ERR (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_RX_SYS_ERR. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_RX_SYS_ERR field. */
#define BR_PCIE_RC_IOBLSSR_RX_SYS_ERR(x) (HW_PCIE_RC_IOBLSSR(x).B.RX_SYS_ERR)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_RX_SYS_ERR. */
#define BF_PCIE_RC_IOBLSSR_RX_SYS_ERR(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_RX_SYS_ERR) & BM_PCIE_RC_IOBLSSR_RX_SYS_ERR)

/*! @brief Set the RX_SYS_ERR field to a new value. */
#define BW_PCIE_RC_IOBLSSR_RX_SYS_ERR(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_RX_SYS_ERR | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)) | BF_PCIE_RC_IOBLSSR_RX_SYS_ERR(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IOBLSSR, field DET_PARITY_ERR[31] (W1C)
 *
 * Detected Parity Error.
 */
/*@{*/
#define BP_PCIE_RC_IOBLSSR_DET_PARITY_ERR (31U) /*!< Bit position for PCIE_RC_IOBLSSR_DET_PARITY_ERR. */
#define BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR (0x80000000U) /*!< Bit mask for PCIE_RC_IOBLSSR_DET_PARITY_ERR. */
#define BS_PCIE_RC_IOBLSSR_DET_PARITY_ERR (1U) /*!< Bit field size in bits for PCIE_RC_IOBLSSR_DET_PARITY_ERR. */

/*! @brief Read current value of the PCIE_RC_IOBLSSR_DET_PARITY_ERR field. */
#define BR_PCIE_RC_IOBLSSR_DET_PARITY_ERR(x) (HW_PCIE_RC_IOBLSSR(x).B.DET_PARITY_ERR)

/*! @brief Format value for bitfield PCIE_RC_IOBLSSR_DET_PARITY_ERR. */
#define BF_PCIE_RC_IOBLSSR_DET_PARITY_ERR(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IOBLSSR_DET_PARITY_ERR) & BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR)

/*! @brief Set the DET_PARITY_ERR field to a new value. */
#define BW_PCIE_RC_IOBLSSR_DET_PARITY_ERR(x, v) (HW_PCIE_RC_IOBLSSR_WR(x, (HW_PCIE_RC_IOBLSSR_RD(x) & ~(BM_PCIE_RC_IOBLSSR_DET_PARITY_ERR | BM_PCIE_RC_IOBLSSR_MSTR_DAT_PARITY_ERR | BM_PCIE_RC_IOBLSSR_SIG_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_TARGET_ABORT | BM_PCIE_RC_IOBLSSR_RX_MASTER_ABORT | BM_PCIE_RC_IOBLSSR_RX_SYS_ERR)) | BF_PCIE_RC_IOBLSSR_DET_PARITY_ERR(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_MEM_BLR - Memory Base and Memory Limit Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_MEM_BLR - Memory Base and Memory Limit Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_pcie_rc_mem_blr
{
    uint32_t U;
    struct _hw_pcie_rc_mem_blr_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t MEM_BASE_ADD : 8;     /*!< [15:8]  */
        uint32_t RESERVED1 : 8;        /*!< [23:16]  */
        uint32_t MEM_LIM_ADD : 8;      /*!< [31:24]  */
    } B;
} hw_pcie_rc_mem_blr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_MEM_BLR register
 */
/*@{*/
#define HW_PCIE_RC_MEM_BLR_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_PCIE_RC_MEM_BLR(x)    (*(__IO hw_pcie_rc_mem_blr_t *) HW_PCIE_RC_MEM_BLR_ADDR(x))
#define HW_PCIE_RC_MEM_BLR_RD(x) (HW_PCIE_RC_MEM_BLR(x).U)
#define HW_PCIE_RC_MEM_BLR_WR(x, v) (HW_PCIE_RC_MEM_BLR(x).U = (v))
#define HW_PCIE_RC_MEM_BLR_SET(x, v) (HW_PCIE_RC_MEM_BLR_WR(x, HW_PCIE_RC_MEM_BLR_RD(x) |  (v)))
#define HW_PCIE_RC_MEM_BLR_CLR(x, v) (HW_PCIE_RC_MEM_BLR_WR(x, HW_PCIE_RC_MEM_BLR_RD(x) & ~(v)))
#define HW_PCIE_RC_MEM_BLR_TOG(x, v) (HW_PCIE_RC_MEM_BLR_WR(x, HW_PCIE_RC_MEM_BLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_MEM_BLR bitfields
 */

/*!
 * @name Register PCIE_RC_MEM_BLR, field MEM_BASE_ADD[15:8] (RW)
 *
 * Memory Base Address.
 */
/*@{*/
#define BP_PCIE_RC_MEM_BLR_MEM_BASE_ADD (8U) /*!< Bit position for PCIE_RC_MEM_BLR_MEM_BASE_ADD. */
#define BM_PCIE_RC_MEM_BLR_MEM_BASE_ADD (0x0000FF00U) /*!< Bit mask for PCIE_RC_MEM_BLR_MEM_BASE_ADD. */
#define BS_PCIE_RC_MEM_BLR_MEM_BASE_ADD (8U) /*!< Bit field size in bits for PCIE_RC_MEM_BLR_MEM_BASE_ADD. */

/*! @brief Read current value of the PCIE_RC_MEM_BLR_MEM_BASE_ADD field. */
#define BR_PCIE_RC_MEM_BLR_MEM_BASE_ADD(x) (HW_PCIE_RC_MEM_BLR(x).B.MEM_BASE_ADD)

/*! @brief Format value for bitfield PCIE_RC_MEM_BLR_MEM_BASE_ADD. */
#define BF_PCIE_RC_MEM_BLR_MEM_BASE_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_MEM_BLR_MEM_BASE_ADD) & BM_PCIE_RC_MEM_BLR_MEM_BASE_ADD)

/*! @brief Set the MEM_BASE_ADD field to a new value. */
#define BW_PCIE_RC_MEM_BLR_MEM_BASE_ADD(x, v) (HW_PCIE_RC_MEM_BLR_WR(x, (HW_PCIE_RC_MEM_BLR_RD(x) & ~BM_PCIE_RC_MEM_BLR_MEM_BASE_ADD) | BF_PCIE_RC_MEM_BLR_MEM_BASE_ADD(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_MEM_BLR, field MEM_LIM_ADD[31:24] (RW)
 *
 * Memory Limit Address.
 */
/*@{*/
#define BP_PCIE_RC_MEM_BLR_MEM_LIM_ADD (24U) /*!< Bit position for PCIE_RC_MEM_BLR_MEM_LIM_ADD. */
#define BM_PCIE_RC_MEM_BLR_MEM_LIM_ADD (0xFF000000U) /*!< Bit mask for PCIE_RC_MEM_BLR_MEM_LIM_ADD. */
#define BS_PCIE_RC_MEM_BLR_MEM_LIM_ADD (8U) /*!< Bit field size in bits for PCIE_RC_MEM_BLR_MEM_LIM_ADD. */

/*! @brief Read current value of the PCIE_RC_MEM_BLR_MEM_LIM_ADD field. */
#define BR_PCIE_RC_MEM_BLR_MEM_LIM_ADD(x) (HW_PCIE_RC_MEM_BLR(x).B.MEM_LIM_ADD)

/*! @brief Format value for bitfield PCIE_RC_MEM_BLR_MEM_LIM_ADD. */
#define BF_PCIE_RC_MEM_BLR_MEM_LIM_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_MEM_BLR_MEM_LIM_ADD) & BM_PCIE_RC_MEM_BLR_MEM_LIM_ADD)

/*! @brief Set the MEM_LIM_ADD field to a new value. */
#define BW_PCIE_RC_MEM_BLR_MEM_LIM_ADD(x, v) (HW_PCIE_RC_MEM_BLR_WR(x, (HW_PCIE_RC_MEM_BLR_RD(x) & ~BM_PCIE_RC_MEM_BLR_MEM_LIM_ADD) | BF_PCIE_RC_MEM_BLR_MEM_LIM_ADD(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PREF_MEM_BLR - Prefetchable Memory Base and Limit Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PREF_MEM_BLR - Prefetchable Memory Base and Limit Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_pcie_rc_pref_mem_blr
{
    uint32_t U;
    struct _hw_pcie_rc_pref_mem_blr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t UPPER12_START_ADD : 12; /*!< [15:4]  */
        uint32_t RESERVED1 : 4;        /*!< [19:16]  */
        uint32_t UPPER12_END_ADD : 12; /*!< [31:20]  */
    } B;
} hw_pcie_rc_pref_mem_blr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PREF_MEM_BLR register
 */
/*@{*/
#define HW_PCIE_RC_PREF_MEM_BLR_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_PCIE_RC_PREF_MEM_BLR(x) (*(__IO hw_pcie_rc_pref_mem_blr_t *) HW_PCIE_RC_PREF_MEM_BLR_ADDR(x))
#define HW_PCIE_RC_PREF_MEM_BLR_RD(x) (HW_PCIE_RC_PREF_MEM_BLR(x).U)
#define HW_PCIE_RC_PREF_MEM_BLR_WR(x, v) (HW_PCIE_RC_PREF_MEM_BLR(x).U = (v))
#define HW_PCIE_RC_PREF_MEM_BLR_SET(x, v) (HW_PCIE_RC_PREF_MEM_BLR_WR(x, HW_PCIE_RC_PREF_MEM_BLR_RD(x) |  (v)))
#define HW_PCIE_RC_PREF_MEM_BLR_CLR(x, v) (HW_PCIE_RC_PREF_MEM_BLR_WR(x, HW_PCIE_RC_PREF_MEM_BLR_RD(x) & ~(v)))
#define HW_PCIE_RC_PREF_MEM_BLR_TOG(x, v) (HW_PCIE_RC_PREF_MEM_BLR_WR(x, HW_PCIE_RC_PREF_MEM_BLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PREF_MEM_BLR bitfields
 */

/*!
 * @name Register PCIE_RC_PREF_MEM_BLR, field UPPER12_START_ADD[15:4] (RW)
 *
 * Upper 12 bits of 32-bit Prefetchable Memory Start Address.
 */
/*@{*/
#define BP_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD (4U) /*!< Bit position for PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD. */
#define BM_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD (0x0000FFF0U) /*!< Bit mask for PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD. */
#define BS_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD (12U) /*!< Bit field size in bits for PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD. */

/*! @brief Read current value of the PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD field. */
#define BR_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD(x) (HW_PCIE_RC_PREF_MEM_BLR(x).B.UPPER12_START_ADD)

/*! @brief Format value for bitfield PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD. */
#define BF_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD) & BM_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD)

/*! @brief Set the UPPER12_START_ADD field to a new value. */
#define BW_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD(x, v) (HW_PCIE_RC_PREF_MEM_BLR_WR(x, (HW_PCIE_RC_PREF_MEM_BLR_RD(x) & ~BM_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD) | BF_PCIE_RC_PREF_MEM_BLR_UPPER12_START_ADD(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PREF_MEM_BLR, field UPPER12_END_ADD[31:20] (RW)
 *
 * Upper 12 bits of 32-bit Prefetchable Memory End Address.
 */
/*@{*/
#define BP_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD (20U) /*!< Bit position for PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD. */
#define BM_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD (0xFFF00000U) /*!< Bit mask for PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD. */
#define BS_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD (12U) /*!< Bit field size in bits for PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD. */

/*! @brief Read current value of the PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD field. */
#define BR_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD(x) (HW_PCIE_RC_PREF_MEM_BLR(x).B.UPPER12_END_ADD)

/*! @brief Format value for bitfield PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD. */
#define BF_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD) & BM_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD)

/*! @brief Set the UPPER12_END_ADD field to a new value. */
#define BW_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD(x, v) (HW_PCIE_RC_PREF_MEM_BLR_WR(x, (HW_PCIE_RC_PREF_MEM_BLR_RD(x) & ~BM_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD) | BF_PCIE_RC_PREF_MEM_BLR_UPPER12_END_ADD(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PREF_BASE_U32 - Prefetchable Base Upper 32 Bits Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PREF_BASE_U32 - Prefetchable Base Upper 32 Bits Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Prefetchable Base Upper 32 Bits Register
 */
typedef union _hw_pcie_rc_pref_base_u32
{
    uint32_t U;
    struct _hw_pcie_rc_pref_base_u32_bitfields
    {
        uint32_t UPPER32_BASE_PREF_MEM_ADD : 32; /*!< [31:0]  */
    } B;
} hw_pcie_rc_pref_base_u32_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PREF_BASE_U32 register
 */
/*@{*/
#define HW_PCIE_RC_PREF_BASE_U32_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_PCIE_RC_PREF_BASE_U32(x) (*(__IO hw_pcie_rc_pref_base_u32_t *) HW_PCIE_RC_PREF_BASE_U32_ADDR(x))
#define HW_PCIE_RC_PREF_BASE_U32_RD(x) (HW_PCIE_RC_PREF_BASE_U32(x).U)
#define HW_PCIE_RC_PREF_BASE_U32_WR(x, v) (HW_PCIE_RC_PREF_BASE_U32(x).U = (v))
#define HW_PCIE_RC_PREF_BASE_U32_SET(x, v) (HW_PCIE_RC_PREF_BASE_U32_WR(x, HW_PCIE_RC_PREF_BASE_U32_RD(x) |  (v)))
#define HW_PCIE_RC_PREF_BASE_U32_CLR(x, v) (HW_PCIE_RC_PREF_BASE_U32_WR(x, HW_PCIE_RC_PREF_BASE_U32_RD(x) & ~(v)))
#define HW_PCIE_RC_PREF_BASE_U32_TOG(x, v) (HW_PCIE_RC_PREF_BASE_U32_WR(x, HW_PCIE_RC_PREF_BASE_U32_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PREF_BASE_U32 bitfields
 */

/*!
 * @name Register PCIE_RC_PREF_BASE_U32, field UPPER32_BASE_PREF_MEM_ADD[31:0] (RW)
 *
 * Upper 32 Bits of Base Address of Prefetchable Memory Space. Used only when
 * 64-bit prefetchable memory addressing is enabled.
 */
/*@{*/
#define BP_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD (0U) /*!< Bit position for PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD. */
#define BM_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD (0xFFFFFFFFU) /*!< Bit mask for PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD. */
#define BS_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD (32U) /*!< Bit field size in bits for PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD. */

/*! @brief Read current value of the PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD field. */
#define BR_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD(x) (HW_PCIE_RC_PREF_BASE_U32(x).U)

/*! @brief Format value for bitfield PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD. */
#define BF_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD) & BM_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD)

/*! @brief Set the UPPER32_BASE_PREF_MEM_ADD field to a new value. */
#define BW_PCIE_RC_PREF_BASE_U32_UPPER32_BASE_PREF_MEM_ADD(x, v) (HW_PCIE_RC_PREF_BASE_U32_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PREF_LIM_U32 - Prefetchable Limit Upper 32 Bits Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PREF_LIM_U32 - Prefetchable Limit Upper 32 Bits Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Prefetchable Limit Upper 32 Bits Register
 */
typedef union _hw_pcie_rc_pref_lim_u32
{
    uint32_t U;
    struct _hw_pcie_rc_pref_lim_u32_bitfields
    {
        uint32_t UPPER32_LIM_PREF_MEM_ADD : 32; /*!< [31:0]  */
    } B;
} hw_pcie_rc_pref_lim_u32_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PREF_LIM_U32 register
 */
/*@{*/
#define HW_PCIE_RC_PREF_LIM_U32_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_PCIE_RC_PREF_LIM_U32(x) (*(__IO hw_pcie_rc_pref_lim_u32_t *) HW_PCIE_RC_PREF_LIM_U32_ADDR(x))
#define HW_PCIE_RC_PREF_LIM_U32_RD(x) (HW_PCIE_RC_PREF_LIM_U32(x).U)
#define HW_PCIE_RC_PREF_LIM_U32_WR(x, v) (HW_PCIE_RC_PREF_LIM_U32(x).U = (v))
#define HW_PCIE_RC_PREF_LIM_U32_SET(x, v) (HW_PCIE_RC_PREF_LIM_U32_WR(x, HW_PCIE_RC_PREF_LIM_U32_RD(x) |  (v)))
#define HW_PCIE_RC_PREF_LIM_U32_CLR(x, v) (HW_PCIE_RC_PREF_LIM_U32_WR(x, HW_PCIE_RC_PREF_LIM_U32_RD(x) & ~(v)))
#define HW_PCIE_RC_PREF_LIM_U32_TOG(x, v) (HW_PCIE_RC_PREF_LIM_U32_WR(x, HW_PCIE_RC_PREF_LIM_U32_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PREF_LIM_U32 bitfields
 */

/*!
 * @name Register PCIE_RC_PREF_LIM_U32, field UPPER32_LIM_PREF_MEM_ADD[31:0] (RW)
 *
 * Upper 32 Bits of Limit Address of Prefetchable Memory Space. Used only when
 * 64-bit prefetchable memory addressing is enabled.
 */
/*@{*/
#define BP_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD (0U) /*!< Bit position for PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD. */
#define BM_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD (0xFFFFFFFFU) /*!< Bit mask for PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD. */
#define BS_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD (32U) /*!< Bit field size in bits for PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD. */

/*! @brief Read current value of the PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD field. */
#define BR_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD(x) (HW_PCIE_RC_PREF_LIM_U32(x).U)

/*! @brief Format value for bitfield PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD. */
#define BF_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD) & BM_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD)

/*! @brief Set the UPPER32_LIM_PREF_MEM_ADD field to a new value. */
#define BW_PCIE_RC_PREF_LIM_U32_UPPER32_LIM_PREF_MEM_ADD(x, v) (HW_PCIE_RC_PREF_LIM_U32_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_IO_BASE_LIM_U16 - I/O Base and Limit Upper 16 Bits Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_IO_BASE_LIM_U16 - I/O Base and Limit Upper 16 Bits Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * I/O Base and Limit Upper 16 Bits Register
 */
typedef union _hw_pcie_rc_io_base_lim_u16
{
    uint32_t U;
    struct _hw_pcie_rc_io_base_lim_u16_bitfields
    {
        uint32_t UPPER16_IO_BASE : 16; /*!< [15:0]  */
        uint32_t UPPER16_IO_LIM : 16;  /*!< [31:16]  */
    } B;
} hw_pcie_rc_io_base_lim_u16_t;

/*!
 * @name Constants and macros for entire PCIE_RC_IO_BASE_LIM_U16 register
 */
/*@{*/
#define HW_PCIE_RC_IO_BASE_LIM_U16_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_PCIE_RC_IO_BASE_LIM_U16(x) (*(__IO hw_pcie_rc_io_base_lim_u16_t *) HW_PCIE_RC_IO_BASE_LIM_U16_ADDR(x))
#define HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) (HW_PCIE_RC_IO_BASE_LIM_U16(x).U)
#define HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16(x).U = (v))
#define HW_PCIE_RC_IO_BASE_LIM_U16_SET(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) |  (v)))
#define HW_PCIE_RC_IO_BASE_LIM_U16_CLR(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) & ~(v)))
#define HW_PCIE_RC_IO_BASE_LIM_U16_TOG(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_IO_BASE_LIM_U16 bitfields
 */

/*!
 * @name Register PCIE_RC_IO_BASE_LIM_U16, field UPPER16_IO_BASE[15:0] (RW)
 *
 * Upper 16 Bits of I/O Base (if 32-bit I/O decoding is supported for devices on
 * the secondary side).
 */
/*@{*/
#define BP_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE (0U) /*!< Bit position for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE. */
#define BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE (0x0000FFFFU) /*!< Bit mask for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE. */
#define BS_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE (16U) /*!< Bit field size in bits for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE. */

/*! @brief Read current value of the PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE field. */
#define BR_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE(x) (HW_PCIE_RC_IO_BASE_LIM_U16(x).B.UPPER16_IO_BASE)

/*! @brief Format value for bitfield PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE. */
#define BF_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE) & BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE)

/*! @brief Set the UPPER16_IO_BASE field to a new value. */
#define BW_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, (HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) & ~BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE) | BF_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_BASE(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_IO_BASE_LIM_U16, field UPPER16_IO_LIM[31:16] (RW)
 *
 * Upper 16 Bits of I/O Limit (if 32-bit I/O decoding is supported for devices
 * on the secondary side).
 */
/*@{*/
#define BP_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM (16U) /*!< Bit position for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM. */
#define BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM (0xFFFF0000U) /*!< Bit mask for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM. */
#define BS_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM (16U) /*!< Bit field size in bits for PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM. */

/*! @brief Read current value of the PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM field. */
#define BR_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM(x) (HW_PCIE_RC_IO_BASE_LIM_U16(x).B.UPPER16_IO_LIM)

/*! @brief Format value for bitfield PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM. */
#define BF_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM) & BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM)

/*! @brief Set the UPPER16_IO_LIM field to a new value. */
#define BW_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM(x, v) (HW_PCIE_RC_IO_BASE_LIM_U16_WR(x, (HW_PCIE_RC_IO_BASE_LIM_U16_RD(x) & ~BM_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM) | BF_PCIE_RC_IO_BASE_LIM_U16_UPPER16_IO_LIM(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_CAPPR - Capability Pointer Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_CAPPR - Capability Pointer Register (RO)
 *
 * Reset value: 0x00000040U
 *
 * Offset: 0x34 Byte: 0
 */
typedef union _hw_pcie_rc_cappr
{
    uint32_t U;
    struct _hw_pcie_rc_cappr_bitfields
    {
        uint32_t CFG_NEXT_PTR : 8;     /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_pcie_rc_cappr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_CAPPR register
 */
/*@{*/
#define HW_PCIE_RC_CAPPR_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_PCIE_RC_CAPPR(x)      (*(__I hw_pcie_rc_cappr_t *) HW_PCIE_RC_CAPPR_ADDR(x))
#define HW_PCIE_RC_CAPPR_RD(x)   (HW_PCIE_RC_CAPPR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_CAPPR bitfields
 */

/*!
 * @name Register PCIE_RC_CAPPR, field CFG_NEXT_PTR[7:0] (RO)
 *
 * First Capability Pointer.
 */
/*@{*/
#define BP_PCIE_RC_CAPPR_CFG_NEXT_PTR (0U) /*!< Bit position for PCIE_RC_CAPPR_CFG_NEXT_PTR. */
#define BM_PCIE_RC_CAPPR_CFG_NEXT_PTR (0x000000FFU) /*!< Bit mask for PCIE_RC_CAPPR_CFG_NEXT_PTR. */
#define BS_PCIE_RC_CAPPR_CFG_NEXT_PTR (8U) /*!< Bit field size in bits for PCIE_RC_CAPPR_CFG_NEXT_PTR. */

/*! @brief Read current value of the PCIE_RC_CAPPR_CFG_NEXT_PTR field. */
#define BR_PCIE_RC_CAPPR_CFG_NEXT_PTR(x) (HW_PCIE_RC_CAPPR(x).B.CFG_NEXT_PTR)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_EROMBAR - Expansion ROM Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_EROMBAR - Expansion ROM Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x38
 */
typedef union _hw_pcie_rc_erombar
{
    uint32_t U;
    struct _hw_pcie_rc_erombar_bitfields
    {
        uint32_t ENABLE : 1;           /*!< [0]  */
        uint32_t RESERVED0 : 10;       /*!< [10:1]  */
        uint32_t ADDRESS : 21;         /*!< [31:11]  */
    } B;
} hw_pcie_rc_erombar_t;

/*!
 * @name Constants and macros for entire PCIE_RC_EROMBAR register
 */
/*@{*/
#define HW_PCIE_RC_EROMBAR_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_PCIE_RC_EROMBAR(x)    (*(__IO hw_pcie_rc_erombar_t *) HW_PCIE_RC_EROMBAR_ADDR(x))
#define HW_PCIE_RC_EROMBAR_RD(x) (HW_PCIE_RC_EROMBAR(x).U)
#define HW_PCIE_RC_EROMBAR_WR(x, v) (HW_PCIE_RC_EROMBAR(x).U = (v))
#define HW_PCIE_RC_EROMBAR_SET(x, v) (HW_PCIE_RC_EROMBAR_WR(x, HW_PCIE_RC_EROMBAR_RD(x) |  (v)))
#define HW_PCIE_RC_EROMBAR_CLR(x, v) (HW_PCIE_RC_EROMBAR_WR(x, HW_PCIE_RC_EROMBAR_RD(x) & ~(v)))
#define HW_PCIE_RC_EROMBAR_TOG(x, v) (HW_PCIE_RC_EROMBAR_WR(x, HW_PCIE_RC_EROMBAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_EROMBAR bitfields
 */

/*!
 * @name Register PCIE_RC_EROMBAR, field ENABLE[0] (RW)
 *
 * Expansion ROM Enable
 */
/*@{*/
#define BP_PCIE_RC_EROMBAR_ENABLE (0U)     /*!< Bit position for PCIE_RC_EROMBAR_ENABLE. */
#define BM_PCIE_RC_EROMBAR_ENABLE (0x00000001U) /*!< Bit mask for PCIE_RC_EROMBAR_ENABLE. */
#define BS_PCIE_RC_EROMBAR_ENABLE (1U)     /*!< Bit field size in bits for PCIE_RC_EROMBAR_ENABLE. */

/*! @brief Read current value of the PCIE_RC_EROMBAR_ENABLE field. */
#define BR_PCIE_RC_EROMBAR_ENABLE(x) (HW_PCIE_RC_EROMBAR(x).B.ENABLE)

/*! @brief Format value for bitfield PCIE_RC_EROMBAR_ENABLE. */
#define BF_PCIE_RC_EROMBAR_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_EROMBAR_ENABLE) & BM_PCIE_RC_EROMBAR_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_PCIE_RC_EROMBAR_ENABLE(x, v) (HW_PCIE_RC_EROMBAR_WR(x, (HW_PCIE_RC_EROMBAR_RD(x) & ~BM_PCIE_RC_EROMBAR_ENABLE) | BF_PCIE_RC_EROMBAR_ENABLE(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_EROMBAR, field ADDRESS[31:11] (RW)
 *
 * Expansion ROM Address
 */
/*@{*/
#define BP_PCIE_RC_EROMBAR_ADDRESS (11U)   /*!< Bit position for PCIE_RC_EROMBAR_ADDRESS. */
#define BM_PCIE_RC_EROMBAR_ADDRESS (0xFFFFF800U) /*!< Bit mask for PCIE_RC_EROMBAR_ADDRESS. */
#define BS_PCIE_RC_EROMBAR_ADDRESS (21U)   /*!< Bit field size in bits for PCIE_RC_EROMBAR_ADDRESS. */

/*! @brief Read current value of the PCIE_RC_EROMBAR_ADDRESS field. */
#define BR_PCIE_RC_EROMBAR_ADDRESS(x) (HW_PCIE_RC_EROMBAR(x).B.ADDRESS)

/*! @brief Format value for bitfield PCIE_RC_EROMBAR_ADDRESS. */
#define BF_PCIE_RC_EROMBAR_ADDRESS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_EROMBAR_ADDRESS) & BM_PCIE_RC_EROMBAR_ADDRESS)

/*! @brief Set the ADDRESS field to a new value. */
#define BW_PCIE_RC_EROMBAR_ADDRESS(x, v) (HW_PCIE_RC_EROMBAR_WR(x, (HW_PCIE_RC_EROMBAR_RD(x) & ~BM_PCIE_RC_EROMBAR_ADDRESS) | BF_PCIE_RC_EROMBAR_ADDRESS(v)))
/*@}*/
/*******************************************************************************
 * HW_PCIE_RC_EROMMASK - Expansion ROM BAR Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_EROMMASK - Expansion ROM BAR Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x38 (same as the Expansion ROM BAR, but requires dbi_cs2 for write
 * access)
 */
typedef union _hw_pcie_rc_erommask
{
    uint32_t U;
    struct _hw_pcie_rc_erommask_bitfields
    {
        uint32_t ROM_BAR_ENABLED_N : 1; /*!< [0]  */
        uint32_t ROM_MASK_N : 31;      /*!< [31:1]  */
    } B;
} hw_pcie_rc_erommask_t;

/*!
 * @name Constants and macros for entire PCIE_RC_EROMMASK register
 */
/*@{*/
#define HW_PCIE_RC_EROMMASK_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_PCIE_RC_EROMMASK(x)   (*(__IO hw_pcie_rc_erommask_t *) HW_PCIE_RC_EROMMASK_ADDR(x))
#define HW_PCIE_RC_EROMMASK_RD(x) (HW_PCIE_RC_EROMMASK(x).U)
#define HW_PCIE_RC_EROMMASK_WR(x, v) (HW_PCIE_RC_EROMMASK(x).U = (v))
#define HW_PCIE_RC_EROMMASK_SET(x, v) (HW_PCIE_RC_EROMMASK_WR(x, HW_PCIE_RC_EROMMASK_RD(x) |  (v)))
#define HW_PCIE_RC_EROMMASK_CLR(x, v) (HW_PCIE_RC_EROMMASK_WR(x, HW_PCIE_RC_EROMMASK_RD(x) & ~(v)))
#define HW_PCIE_RC_EROMMASK_TOG(x, v) (HW_PCIE_RC_EROMMASK_WR(x, HW_PCIE_RC_EROMMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_EROMMASK bitfields
 */

/*!
 * @name Register PCIE_RC_EROMMASK, field ROM_BAR_ENABLED_N[0] (RW)
 *
 * Expansion ROM BAR Enable
 *
 * Values:
 * - 0 - Expansion ROM BAR is disabled
 * - 1 - Expansion ROM BAR is enabled
 */
/*@{*/
#define BP_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N (0U) /*!< Bit position for PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N. */
#define BM_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N (0x00000001U) /*!< Bit mask for PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N. */
#define BS_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N (1U) /*!< Bit field size in bits for PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N. */

/*! @brief Read current value of the PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N field. */
#define BR_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N(x) (HW_PCIE_RC_EROMMASK(x).B.ROM_BAR_ENABLED_N)

/*! @brief Format value for bitfield PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N. */
#define BF_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N) & BM_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N)

/*! @brief Set the ROM_BAR_ENABLED_N field to a new value. */
#define BW_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N(x, v) (HW_PCIE_RC_EROMMASK_WR(x, (HW_PCIE_RC_EROMMASK_RD(x) & ~BM_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N) | BF_PCIE_RC_EROMMASK_ROM_BAR_ENABLED_N(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_EROMMASK, field ROM_MASK_N[31:1] (RW)
 *
 * Indicates which Expansion ROM BAR bits to mask (make non-writable) from host
 * software, which, in turn, determines the size of the BAR. For example, writing
 * 0xFFF to the Expansion ROM BAR Mask register claims a 4096-byte BAR by
 * masking bits 11:0 of the BAR from writing by host software. The maximum value is
 * 0xFFFFFF because the maximum space that can be claimed by an Expansion ROM BAR is
 * 16 MB. The Expansion ROM BAR Mask register is invisible to host software and
 * not readable from the application. Application access depends on the value of
 * the Expansion ROM BAR Mask register is writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_EROMMASK_ROM_MASK_N (1U) /*!< Bit position for PCIE_RC_EROMMASK_ROM_MASK_N. */
#define BM_PCIE_RC_EROMMASK_ROM_MASK_N (0xFFFFFFFEU) /*!< Bit mask for PCIE_RC_EROMMASK_ROM_MASK_N. */
#define BS_PCIE_RC_EROMMASK_ROM_MASK_N (31U) /*!< Bit field size in bits for PCIE_RC_EROMMASK_ROM_MASK_N. */

/*! @brief Read current value of the PCIE_RC_EROMMASK_ROM_MASK_N field. */
#define BR_PCIE_RC_EROMMASK_ROM_MASK_N(x) (HW_PCIE_RC_EROMMASK(x).B.ROM_MASK_N)

/*! @brief Format value for bitfield PCIE_RC_EROMMASK_ROM_MASK_N. */
#define BF_PCIE_RC_EROMMASK_ROM_MASK_N(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_EROMMASK_ROM_MASK_N) & BM_PCIE_RC_EROMMASK_ROM_MASK_N)

/*! @brief Set the ROM_MASK_N field to a new value. */
#define BW_PCIE_RC_EROMMASK_ROM_MASK_N(x, v) (HW_PCIE_RC_EROMMASK_WR(x, (HW_PCIE_RC_EROMMASK_RD(x) & ~BM_PCIE_RC_EROMMASK_ROM_MASK_N) | BF_PCIE_RC_EROMMASK_ROM_MASK_N(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PMCR - Power Management Capability Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PMCR - Power Management Capability Register (RO)
 *
 * Reset value: 0xDBC35001U
 *
 * The core implements power management capabilities. The Capability Pointer
 * field in the configuration header points to the PCI Power Management registers as
 * the first extended capability by default. The extent of the power management
 * implementation in the core includes: Power Management register space Link
 * state information (provided to both the application logic and PHY interfaces)
 * Power management-ready clock and reset implementation The following sections
 * describe the PCI Power Management registers implemented in the core. See the PCI
 * Power Management specification and the PCI Express 3.0 Specification for more
 * details. Offset: `CFG_PM_CAP
 */
typedef union _hw_pcie_rc_pmcr
{
    uint32_t U;
    struct _hw_pcie_rc_pmcr_bitfields
    {
        uint32_t Power_Management_Capability_ID : 8; /*!< [7:0]  */
        uint32_t Next_Capability_Pointer : 8; /*!< [15:8]  */
        uint32_t Power_Management_specification_version : 3; /*!< [18:16]  */
        uint32_t PME_Clock : 1;        /*!< [19]  */
        uint32_t RESERVED0 : 1;        /*!< [20]  */
        uint32_t DSI : 1;              /*!< [21]  */
        uint32_t AUX_Current : 3;      /*!< [24:22]  */
        uint32_t D1_Support : 1;       /*!< [25]  */
        uint32_t D2_Support : 1;       /*!< [26]  */
        uint32_t PME_Support : 5;      /*!< [31:27]  */
    } B;
} hw_pcie_rc_pmcr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PMCR register
 */
/*@{*/
#define HW_PCIE_RC_PMCR_ADDR(x)  ((uintptr_t)(x) + 0x40U)

#define HW_PCIE_RC_PMCR(x)       (*(__I hw_pcie_rc_pmcr_t *) HW_PCIE_RC_PMCR_ADDR(x))
#define HW_PCIE_RC_PMCR_RD(x)    (HW_PCIE_RC_PMCR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PMCR bitfields
 */

/*!
 * @name Register PCIE_RC_PMCR, field Power_Management_Capability_ID[7:0] (RO)
 *
 * Power Management Capability ID
 */
/*@{*/
#define BP_PCIE_RC_PMCR_Power_Management_Capability_ID (0U) /*!< Bit position for PCIE_RC_PMCR_Power_Management_Capability_ID. */
#define BM_PCIE_RC_PMCR_Power_Management_Capability_ID (0x000000FFU) /*!< Bit mask for PCIE_RC_PMCR_Power_Management_Capability_ID. */
#define BS_PCIE_RC_PMCR_Power_Management_Capability_ID (8U) /*!< Bit field size in bits for PCIE_RC_PMCR_Power_Management_Capability_ID. */

/*! @brief Read current value of the PCIE_RC_PMCR_Power_Management_Capability_ID field. */
#define BR_PCIE_RC_PMCR_Power_Management_Capability_ID(x) (HW_PCIE_RC_PMCR(x).B.Power_Management_Capability_ID)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field Next_Capability_Pointer[15:8] (RO)
 *
 * Next Capability Pointer See and .
 */
/*@{*/
#define BP_PCIE_RC_PMCR_Next_Capability_Pointer (8U) /*!< Bit position for PCIE_RC_PMCR_Next_Capability_Pointer. */
#define BM_PCIE_RC_PMCR_Next_Capability_Pointer (0x0000FF00U) /*!< Bit mask for PCIE_RC_PMCR_Next_Capability_Pointer. */
#define BS_PCIE_RC_PMCR_Next_Capability_Pointer (8U) /*!< Bit field size in bits for PCIE_RC_PMCR_Next_Capability_Pointer. */

/*! @brief Read current value of the PCIE_RC_PMCR_Next_Capability_Pointer field. */
#define BR_PCIE_RC_PMCR_Next_Capability_Pointer(x) (HW_PCIE_RC_PMCR(x).B.Next_Capability_Pointer)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field Power_Management_specification_version[18:16] (RO)
 *
 * Power Management specification version, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCR_Power_Management_specification_version (16U) /*!< Bit position for PCIE_RC_PMCR_Power_Management_specification_version. */
#define BM_PCIE_RC_PMCR_Power_Management_specification_version (0x00070000U) /*!< Bit mask for PCIE_RC_PMCR_Power_Management_specification_version. */
#define BS_PCIE_RC_PMCR_Power_Management_specification_version (3U) /*!< Bit field size in bits for PCIE_RC_PMCR_Power_Management_specification_version. */

/*! @brief Read current value of the PCIE_RC_PMCR_Power_Management_specification_version field. */
#define BR_PCIE_RC_PMCR_Power_Management_specification_version(x) (HW_PCIE_RC_PMCR(x).B.Power_Management_specification_version)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field PME_Clock[19] (RO)
 *
 * PME Clock, hardwired to 0
 */
/*@{*/
#define BP_PCIE_RC_PMCR_PME_Clock (19U)    /*!< Bit position for PCIE_RC_PMCR_PME_Clock. */
#define BM_PCIE_RC_PMCR_PME_Clock (0x00080000U) /*!< Bit mask for PCIE_RC_PMCR_PME_Clock. */
#define BS_PCIE_RC_PMCR_PME_Clock (1U)     /*!< Bit field size in bits for PCIE_RC_PMCR_PME_Clock. */

/*! @brief Read current value of the PCIE_RC_PMCR_PME_Clock field. */
#define BR_PCIE_RC_PMCR_PME_Clock(x) (HW_PCIE_RC_PMCR(x).B.PME_Clock)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field DSI[21] (RO)
 *
 * Device Specific Initialization (DSI), writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCR_DSI  (21U)         /*!< Bit position for PCIE_RC_PMCR_DSI. */
#define BM_PCIE_RC_PMCR_DSI  (0x00200000U) /*!< Bit mask for PCIE_RC_PMCR_DSI. */
#define BS_PCIE_RC_PMCR_DSI  (1U)          /*!< Bit field size in bits for PCIE_RC_PMCR_DSI. */

/*! @brief Read current value of the PCIE_RC_PMCR_DSI field. */
#define BR_PCIE_RC_PMCR_DSI(x) (HW_PCIE_RC_PMCR(x).B.DSI)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field AUX_Current[24:22] (RO)
 *
 * AUX Current, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCR_AUX_Current (22U)  /*!< Bit position for PCIE_RC_PMCR_AUX_Current. */
#define BM_PCIE_RC_PMCR_AUX_Current (0x01C00000U) /*!< Bit mask for PCIE_RC_PMCR_AUX_Current. */
#define BS_PCIE_RC_PMCR_AUX_Current (3U)   /*!< Bit field size in bits for PCIE_RC_PMCR_AUX_Current. */

/*! @brief Read current value of the PCIE_RC_PMCR_AUX_Current field. */
#define BR_PCIE_RC_PMCR_AUX_Current(x) (HW_PCIE_RC_PMCR(x).B.AUX_Current)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field D1_Support[25] (RO)
 *
 * D1 Support, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCR_D1_Support (25U)   /*!< Bit position for PCIE_RC_PMCR_D1_Support. */
#define BM_PCIE_RC_PMCR_D1_Support (0x02000000U) /*!< Bit mask for PCIE_RC_PMCR_D1_Support. */
#define BS_PCIE_RC_PMCR_D1_Support (1U)    /*!< Bit field size in bits for PCIE_RC_PMCR_D1_Support. */

/*! @brief Read current value of the PCIE_RC_PMCR_D1_Support field. */
#define BR_PCIE_RC_PMCR_D1_Support(x) (HW_PCIE_RC_PMCR(x).B.D1_Support)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field D2_Support[26] (RO)
 *
 * D2 Support, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCR_D2_Support (26U)   /*!< Bit position for PCIE_RC_PMCR_D2_Support. */
#define BM_PCIE_RC_PMCR_D2_Support (0x04000000U) /*!< Bit mask for PCIE_RC_PMCR_D2_Support. */
#define BS_PCIE_RC_PMCR_D2_Support (1U)    /*!< Bit field size in bits for PCIE_RC_PMCR_D2_Support. */

/*! @brief Read current value of the PCIE_RC_PMCR_D2_Support field. */
#define BR_PCIE_RC_PMCR_D2_Support(x) (HW_PCIE_RC_PMCR(x).B.D2_Support)
/*@}*/

/*!
 * @name Register PCIE_RC_PMCR, field PME_Support[31:27] (RO)
 *
 * PME_Support Identifies the power states from which the core can generate PME
 * Messages. A value of 0 for any bit indicates that the device (or function) is
 * not capable of generating PME Messages while in that power state: Bit 11: If
 * set, PME Messages can be generated from D0 Bit 12: If set, PME Messages can be
 * generated from D1 Bit 13: If set, PME Messages can be generated from D2 Bit
 * 14: If set, PME Messages can be generated from D3hot Bit 15: If set, PME
 * Messages can be generated from D3cold The PME_Support field is writable through the
 * DBI.
 */
/*@{*/
#define BP_PCIE_RC_PMCR_PME_Support (27U)  /*!< Bit position for PCIE_RC_PMCR_PME_Support. */
#define BM_PCIE_RC_PMCR_PME_Support (0xF8000000U) /*!< Bit mask for PCIE_RC_PMCR_PME_Support. */
#define BS_PCIE_RC_PMCR_PME_Support (5U)   /*!< Bit field size in bits for PCIE_RC_PMCR_PME_Support. */

/*! @brief Read current value of the PCIE_RC_PMCR_PME_Support field. */
#define BR_PCIE_RC_PMCR_PME_Support(x) (HW_PCIE_RC_PMCR(x).B.PME_Support)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PMCSR - Power Management Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PMCSR - Power Management Control and Status Register (RW)
 *
 * Reset value: 0x00000004U
 *
 * Offset: `CFG_PM_CAP + 0x04
 */
typedef union _hw_pcie_rc_pmcsr
{
    uint32_t U;
    struct _hw_pcie_rc_pmcsr_bitfields
    {
        uint32_t Power_State : 2;      /*!< [1:0]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t No_Soft_Reset : 1;    /*!< [3]  */
        uint32_t RESERVED1 : 4;        /*!< [7:4]  */
        uint32_t PME_Enable : 1;       /*!< [8]  */
        uint32_t Data_Select : 4;      /*!< [12:9]  */
        uint32_t Data_Scale : 2;       /*!< [14:13]  */
        uint32_t PME_Status : 1;       /*!< [15]  */
        uint32_t RESERVED2 : 6;        /*!< [21:16]  */
        uint32_t B2_B3_Support : 1;    /*!< [22]  */
        uint32_t Bus_Power_Clock_Control_Enable : 1; /*!< [23]  */
        uint32_t Data_register_for_additional_information : 8; /*!< [31:24]
                                        * */
    } B;
} hw_pcie_rc_pmcsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PMCSR register
 */
/*@{*/
#define HW_PCIE_RC_PMCSR_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_PCIE_RC_PMCSR(x)      (*(__IO hw_pcie_rc_pmcsr_t *) HW_PCIE_RC_PMCSR_ADDR(x))
#define HW_PCIE_RC_PMCSR_RD(x)   (HW_PCIE_RC_PMCSR(x).U)
#define HW_PCIE_RC_PMCSR_WR(x, v) (HW_PCIE_RC_PMCSR(x).U = (v))
#define HW_PCIE_RC_PMCSR_SET(x, v) (HW_PCIE_RC_PMCSR_WR(x, HW_PCIE_RC_PMCSR_RD(x) |  (v)))
#define HW_PCIE_RC_PMCSR_CLR(x, v) (HW_PCIE_RC_PMCSR_WR(x, HW_PCIE_RC_PMCSR_RD(x) & ~(v)))
#define HW_PCIE_RC_PMCSR_TOG(x, v) (HW_PCIE_RC_PMCSR_WR(x, HW_PCIE_RC_PMCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PMCSR bitfields
 */

/*!
 * @name Register PCIE_RC_PMCSR, field Power_State[1:0] (RW)
 *
 * Power State The written value is ignored if the specific state is not
 * supported. Controls the device power state:
 *
 * Values:
 * - 00 - D0
 * - 01 - D1
 * - 10 - D2
 * - 11 - D3
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_Power_State (0U)  /*!< Bit position for PCIE_RC_PMCSR_Power_State. */
#define BM_PCIE_RC_PMCSR_Power_State (0x00000003U) /*!< Bit mask for PCIE_RC_PMCSR_Power_State. */
#define BS_PCIE_RC_PMCSR_Power_State (2U)  /*!< Bit field size in bits for PCIE_RC_PMCSR_Power_State. */

/*! @brief Read current value of the PCIE_RC_PMCSR_Power_State field. */
#define BR_PCIE_RC_PMCSR_Power_State(x) (HW_PCIE_RC_PMCSR(x).B.Power_State)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_Power_State. */
#define BF_PCIE_RC_PMCSR_Power_State(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_Power_State) & BM_PCIE_RC_PMCSR_Power_State)

/*! @brief Set the Power_State field to a new value. */
#define BW_PCIE_RC_PMCSR_Power_State(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_Power_State) | BF_PCIE_RC_PMCSR_Power_State(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field No_Soft_Reset[3] (RW)
 *
 * No Soft Reset, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_No_Soft_Reset (3U) /*!< Bit position for PCIE_RC_PMCSR_No_Soft_Reset. */
#define BM_PCIE_RC_PMCSR_No_Soft_Reset (0x00000008U) /*!< Bit mask for PCIE_RC_PMCSR_No_Soft_Reset. */
#define BS_PCIE_RC_PMCSR_No_Soft_Reset (1U) /*!< Bit field size in bits for PCIE_RC_PMCSR_No_Soft_Reset. */

/*! @brief Read current value of the PCIE_RC_PMCSR_No_Soft_Reset field. */
#define BR_PCIE_RC_PMCSR_No_Soft_Reset(x) (HW_PCIE_RC_PMCSR(x).B.No_Soft_Reset)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_No_Soft_Reset. */
#define BF_PCIE_RC_PMCSR_No_Soft_Reset(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_No_Soft_Reset) & BM_PCIE_RC_PMCSR_No_Soft_Reset)

/*! @brief Set the No_Soft_Reset field to a new value. */
#define BW_PCIE_RC_PMCSR_No_Soft_Reset(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_No_Soft_Reset) | BF_PCIE_RC_PMCSR_No_Soft_Reset(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field PME_Enable[8] (RW)
 *
 * PME Enable (sticky bit) A value of 1 indicates that the device is enabled to
 * generate PME.
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_PME_Enable (8U)   /*!< Bit position for PCIE_RC_PMCSR_PME_Enable. */
#define BM_PCIE_RC_PMCSR_PME_Enable (0x00000100U) /*!< Bit mask for PCIE_RC_PMCSR_PME_Enable. */
#define BS_PCIE_RC_PMCSR_PME_Enable (1U)   /*!< Bit field size in bits for PCIE_RC_PMCSR_PME_Enable. */

/*! @brief Read current value of the PCIE_RC_PMCSR_PME_Enable field. */
#define BR_PCIE_RC_PMCSR_PME_Enable(x) (HW_PCIE_RC_PMCSR(x).B.PME_Enable)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_PME_Enable. */
#define BF_PCIE_RC_PMCSR_PME_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_PME_Enable) & BM_PCIE_RC_PMCSR_PME_Enable)

/*! @brief Set the PME_Enable field to a new value. */
#define BW_PCIE_RC_PMCSR_PME_Enable(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_PME_Enable) | BF_PCIE_RC_PMCSR_PME_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field Data_Select[12:9] (RW)
 *
 * Data Select (not supported)
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_Data_Select (9U)  /*!< Bit position for PCIE_RC_PMCSR_Data_Select. */
#define BM_PCIE_RC_PMCSR_Data_Select (0x00001E00U) /*!< Bit mask for PCIE_RC_PMCSR_Data_Select. */
#define BS_PCIE_RC_PMCSR_Data_Select (4U)  /*!< Bit field size in bits for PCIE_RC_PMCSR_Data_Select. */

/*! @brief Read current value of the PCIE_RC_PMCSR_Data_Select field. */
#define BR_PCIE_RC_PMCSR_Data_Select(x) (HW_PCIE_RC_PMCSR(x).B.Data_Select)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_Data_Select. */
#define BF_PCIE_RC_PMCSR_Data_Select(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_Data_Select) & BM_PCIE_RC_PMCSR_Data_Select)

/*! @brief Set the Data_Select field to a new value. */
#define BW_PCIE_RC_PMCSR_Data_Select(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_Data_Select) | BF_PCIE_RC_PMCSR_Data_Select(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field Data_Scale[14:13] (RW)
 *
 * Data Scale (not supported)
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_Data_Scale (13U)  /*!< Bit position for PCIE_RC_PMCSR_Data_Scale. */
#define BM_PCIE_RC_PMCSR_Data_Scale (0x00006000U) /*!< Bit mask for PCIE_RC_PMCSR_Data_Scale. */
#define BS_PCIE_RC_PMCSR_Data_Scale (2U)   /*!< Bit field size in bits for PCIE_RC_PMCSR_Data_Scale. */

/*! @brief Read current value of the PCIE_RC_PMCSR_Data_Scale field. */
#define BR_PCIE_RC_PMCSR_Data_Scale(x) (HW_PCIE_RC_PMCSR(x).B.Data_Scale)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_Data_Scale. */
#define BF_PCIE_RC_PMCSR_Data_Scale(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_Data_Scale) & BM_PCIE_RC_PMCSR_Data_Scale)

/*! @brief Set the Data_Scale field to a new value. */
#define BW_PCIE_RC_PMCSR_Data_Scale(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_Data_Scale) | BF_PCIE_RC_PMCSR_Data_Scale(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field PME_Status[15] (RW)
 *
 * PME Status Indicates if a previously enabled PME event occurred or not.
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_PME_Status (15U)  /*!< Bit position for PCIE_RC_PMCSR_PME_Status. */
#define BM_PCIE_RC_PMCSR_PME_Status (0x00008000U) /*!< Bit mask for PCIE_RC_PMCSR_PME_Status. */
#define BS_PCIE_RC_PMCSR_PME_Status (1U)   /*!< Bit field size in bits for PCIE_RC_PMCSR_PME_Status. */

/*! @brief Read current value of the PCIE_RC_PMCSR_PME_Status field. */
#define BR_PCIE_RC_PMCSR_PME_Status(x) (HW_PCIE_RC_PMCSR(x).B.PME_Status)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_PME_Status. */
#define BF_PCIE_RC_PMCSR_PME_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_PME_Status) & BM_PCIE_RC_PMCSR_PME_Status)

/*! @brief Set the PME_Status field to a new value. */
#define BW_PCIE_RC_PMCSR_PME_Status(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_PME_Status) | BF_PCIE_RC_PMCSR_PME_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field B2_B3_Support[22] (RW)
 *
 * B2/B3 Support, hardwired to 0
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_B2_B3_Support (22U) /*!< Bit position for PCIE_RC_PMCSR_B2_B3_Support. */
#define BM_PCIE_RC_PMCSR_B2_B3_Support (0x00400000U) /*!< Bit mask for PCIE_RC_PMCSR_B2_B3_Support. */
#define BS_PCIE_RC_PMCSR_B2_B3_Support (1U) /*!< Bit field size in bits for PCIE_RC_PMCSR_B2_B3_Support. */

/*! @brief Read current value of the PCIE_RC_PMCSR_B2_B3_Support field. */
#define BR_PCIE_RC_PMCSR_B2_B3_Support(x) (HW_PCIE_RC_PMCSR(x).B.B2_B3_Support)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_B2_B3_Support. */
#define BF_PCIE_RC_PMCSR_B2_B3_Support(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_B2_B3_Support) & BM_PCIE_RC_PMCSR_B2_B3_Support)

/*! @brief Set the B2_B3_Support field to a new value. */
#define BW_PCIE_RC_PMCSR_B2_B3_Support(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_B2_B3_Support) | BF_PCIE_RC_PMCSR_B2_B3_Support(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field Bus_Power_Clock_Control_Enable[23] (RW)
 *
 * Bus Power/Clock Control Enable, hardwired to 0
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable (23U) /*!< Bit position for PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable. */
#define BM_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable (0x00800000U) /*!< Bit mask for PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable. */
#define BS_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable (1U) /*!< Bit field size in bits for PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable. */

/*! @brief Read current value of the PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable field. */
#define BR_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable(x) (HW_PCIE_RC_PMCSR(x).B.Bus_Power_Clock_Control_Enable)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable. */
#define BF_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable) & BM_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable)

/*! @brief Set the Bus_Power_Clock_Control_Enable field to a new value. */
#define BW_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable) | BF_PCIE_RC_PMCSR_Bus_Power_Clock_Control_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PMCSR, field Data_register_for_additional_information[31:24] (RW)
 *
 * Data register for additional information (not supported)
 */
/*@{*/
#define BP_PCIE_RC_PMCSR_Data_register_for_additional_information (24U) /*!< Bit position for PCIE_RC_PMCSR_Data_register_for_additional_information. */
#define BM_PCIE_RC_PMCSR_Data_register_for_additional_information (0xFF000000U) /*!< Bit mask for PCIE_RC_PMCSR_Data_register_for_additional_information. */
#define BS_PCIE_RC_PMCSR_Data_register_for_additional_information (8U) /*!< Bit field size in bits for PCIE_RC_PMCSR_Data_register_for_additional_information. */

/*! @brief Read current value of the PCIE_RC_PMCSR_Data_register_for_additional_information field. */
#define BR_PCIE_RC_PMCSR_Data_register_for_additional_information(x) (HW_PCIE_RC_PMCSR(x).B.Data_register_for_additional_information)

/*! @brief Format value for bitfield PCIE_RC_PMCSR_Data_register_for_additional_information. */
#define BF_PCIE_RC_PMCSR_Data_register_for_additional_information(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PMCSR_Data_register_for_additional_information) & BM_PCIE_RC_PMCSR_Data_register_for_additional_information)

/*! @brief Set the Data_register_for_additional_information field to a new value. */
#define BW_PCIE_RC_PMCSR_Data_register_for_additional_information(x, v) (HW_PCIE_RC_PMCSR_WR(x, (HW_PCIE_RC_PMCSR_RD(x) & ~BM_PCIE_RC_PMCSR_Data_register_for_additional_information) | BF_PCIE_RC_PMCSR_Data_register_for_additional_information(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_CIDR - PCI Express Capability ID Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_CIDR - PCI Express Capability ID Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The core implements the PCI Express Capability Structure as defined in the
 * PCI Express 3.0 Specification. Offset: CFG_PCIE_CAP + 0x00
 */
typedef union _hw_pcie_rc_cidr
{
    uint32_t U;
    struct _hw_pcie_rc_cidr_bitfields
    {
        uint32_t PCI_Express_Capability_ID : 8; /*!< [7:0]  */
        uint32_t Next_Capability_Pointer : 8; /*!< [15:8]  */
        uint32_t PCI_Express_Capability_Version : 4; /*!< [19:16]  */
        uint32_t Device_Port_Type : 4; /*!< [23:20]  */
        uint32_t Slot_Implemented : 1; /*!< [24]  */
        uint32_t Interrupt_Message_Number : 5; /*!< [29:25]  */
        uint32_t RESERVED0 : 2;        /*!< [31:30]  */
    } B;
} hw_pcie_rc_cidr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_CIDR register
 */
/*@{*/
#define HW_PCIE_RC_CIDR_ADDR(x)  ((uintptr_t)(x) + 0x70U)

#define HW_PCIE_RC_CIDR(x)       (*(__I hw_pcie_rc_cidr_t *) HW_PCIE_RC_CIDR_ADDR(x))
#define HW_PCIE_RC_CIDR_RD(x)    (HW_PCIE_RC_CIDR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_CIDR bitfields
 */

/*!
 * @name Register PCIE_RC_CIDR, field PCI_Express_Capability_ID[7:0] (RO)
 *
 * PCI Express Capability ID
 */
/*@{*/
#define BP_PCIE_RC_CIDR_PCI_Express_Capability_ID (0U) /*!< Bit position for PCIE_RC_CIDR_PCI_Express_Capability_ID. */
#define BM_PCIE_RC_CIDR_PCI_Express_Capability_ID (0x000000FFU) /*!< Bit mask for PCIE_RC_CIDR_PCI_Express_Capability_ID. */
#define BS_PCIE_RC_CIDR_PCI_Express_Capability_ID (8U) /*!< Bit field size in bits for PCIE_RC_CIDR_PCI_Express_Capability_ID. */

/*! @brief Read current value of the PCIE_RC_CIDR_PCI_Express_Capability_ID field. */
#define BR_PCIE_RC_CIDR_PCI_Express_Capability_ID(x) (HW_PCIE_RC_CIDR(x).B.PCI_Express_Capability_ID)
/*@}*/

/*!
 * @name Register PCIE_RC_CIDR, field Next_Capability_Pointer[15:8] (RO)
 *
 * Next Capability Pointer
 */
/*@{*/
#define BP_PCIE_RC_CIDR_Next_Capability_Pointer (8U) /*!< Bit position for PCIE_RC_CIDR_Next_Capability_Pointer. */
#define BM_PCIE_RC_CIDR_Next_Capability_Pointer (0x0000FF00U) /*!< Bit mask for PCIE_RC_CIDR_Next_Capability_Pointer. */
#define BS_PCIE_RC_CIDR_Next_Capability_Pointer (8U) /*!< Bit field size in bits for PCIE_RC_CIDR_Next_Capability_Pointer. */

/*! @brief Read current value of the PCIE_RC_CIDR_Next_Capability_Pointer field. */
#define BR_PCIE_RC_CIDR_Next_Capability_Pointer(x) (HW_PCIE_RC_CIDR(x).B.Next_Capability_Pointer)
/*@}*/

/*!
 * @name Register PCIE_RC_CIDR, field PCI_Express_Capability_Version[19:16] (RO)
 *
 * PCI Express Capability Version
 */
/*@{*/
#define BP_PCIE_RC_CIDR_PCI_Express_Capability_Version (16U) /*!< Bit position for PCIE_RC_CIDR_PCI_Express_Capability_Version. */
#define BM_PCIE_RC_CIDR_PCI_Express_Capability_Version (0x000F0000U) /*!< Bit mask for PCIE_RC_CIDR_PCI_Express_Capability_Version. */
#define BS_PCIE_RC_CIDR_PCI_Express_Capability_Version (4U) /*!< Bit field size in bits for PCIE_RC_CIDR_PCI_Express_Capability_Version. */

/*! @brief Read current value of the PCIE_RC_CIDR_PCI_Express_Capability_Version field. */
#define BR_PCIE_RC_CIDR_PCI_Express_Capability_Version(x) (HW_PCIE_RC_CIDR(x).B.PCI_Express_Capability_Version)
/*@}*/

/*!
 * @name Register PCIE_RC_CIDR, field Device_Port_Type[23:20] (RO)
 *
 * Device/Port Type Indicates the specific type of this PCI Express Function.
 * Supported encodings for RC and DM(RC mode) are: •4'b0100: Root Port of PCI
 * Express Root Complex Note: All other encodings (including those for PCI/PCI-X
 * bridges and RC Integrated Endpoint) are NOT supported.
 */
/*@{*/
#define BP_PCIE_RC_CIDR_Device_Port_Type (20U) /*!< Bit position for PCIE_RC_CIDR_Device_Port_Type. */
#define BM_PCIE_RC_CIDR_Device_Port_Type (0x00F00000U) /*!< Bit mask for PCIE_RC_CIDR_Device_Port_Type. */
#define BS_PCIE_RC_CIDR_Device_Port_Type (4U) /*!< Bit field size in bits for PCIE_RC_CIDR_Device_Port_Type. */

/*! @brief Read current value of the PCIE_RC_CIDR_Device_Port_Type field. */
#define BR_PCIE_RC_CIDR_Device_Port_Type(x) (HW_PCIE_RC_CIDR(x).B.Device_Port_Type)
/*@}*/

/*!
 * @name Register PCIE_RC_CIDR, field Slot_Implemented[24] (RO)
 *
 * Slot Implemented, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_CIDR_Slot_Implemented (24U) /*!< Bit position for PCIE_RC_CIDR_Slot_Implemented. */
#define BM_PCIE_RC_CIDR_Slot_Implemented (0x01000000U) /*!< Bit mask for PCIE_RC_CIDR_Slot_Implemented. */
#define BS_PCIE_RC_CIDR_Slot_Implemented (1U) /*!< Bit field size in bits for PCIE_RC_CIDR_Slot_Implemented. */

/*! @brief Read current value of the PCIE_RC_CIDR_Slot_Implemented field. */
#define BR_PCIE_RC_CIDR_Slot_Implemented(x) (HW_PCIE_RC_CIDR(x).B.Slot_Implemented)
/*@}*/

/*!
 * @name Register PCIE_RC_CIDR, field Interrupt_Message_Number[29:25] (RO)
 *
 * Interrupt Message Number Updated by hardware, writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_CIDR_Interrupt_Message_Number (25U) /*!< Bit position for PCIE_RC_CIDR_Interrupt_Message_Number. */
#define BM_PCIE_RC_CIDR_Interrupt_Message_Number (0x3E000000U) /*!< Bit mask for PCIE_RC_CIDR_Interrupt_Message_Number. */
#define BS_PCIE_RC_CIDR_Interrupt_Message_Number (5U) /*!< Bit field size in bits for PCIE_RC_CIDR_Interrupt_Message_Number. */

/*! @brief Read current value of the PCIE_RC_CIDR_Interrupt_Message_Number field. */
#define BR_PCIE_RC_CIDR_Interrupt_Message_Number(x) (HW_PCIE_RC_CIDR(x).B.Interrupt_Message_Number)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_DCR - Device Capabilities Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_DCR - Device Capabilities Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x04
 */
typedef union _hw_pcie_rc_dcr
{
    uint32_t U;
    struct _hw_pcie_rc_dcr_bitfields
    {
        uint32_t Max_Payload_Size_Supported : 3; /*!< [2:0]  */
        uint32_t Phantom_Function_Supported : 2; /*!< [4:3]  */
        uint32_t Extended_Tag_Field_Supported : 1; /*!< [5]  */
        uint32_t Endpoint_L0s_Acceptable_Latency : 3; /*!< [8:6]  */
        uint32_t Endpoint_L1_Acceptable_Latency : 3; /*!< [11:9]  */
        uint32_t RESERVED0 : 3;        /*!< [14:12]  */
        uint32_t Role_Based_Error_Reporting : 1; /*!< [15]  */
        uint32_t RESERVED1 : 2;        /*!< [17:16]  */
        uint32_t Captured_Slot_Power_Limit_Value : 8; /*!< [25:18]  */
        uint32_t Captured_Slot_Power_Limit_Scale : 2; /*!< [27:26]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_pcie_rc_dcr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_DCR register
 */
/*@{*/
#define HW_PCIE_RC_DCR_ADDR(x)   ((uintptr_t)(x) + 0x74U)

#define HW_PCIE_RC_DCR(x)        (*(__IO hw_pcie_rc_dcr_t *) HW_PCIE_RC_DCR_ADDR(x))
#define HW_PCIE_RC_DCR_RD(x)     (HW_PCIE_RC_DCR(x).U)
#define HW_PCIE_RC_DCR_WR(x, v)  (HW_PCIE_RC_DCR(x).U = (v))
#define HW_PCIE_RC_DCR_SET(x, v) (HW_PCIE_RC_DCR_WR(x, HW_PCIE_RC_DCR_RD(x) |  (v)))
#define HW_PCIE_RC_DCR_CLR(x, v) (HW_PCIE_RC_DCR_WR(x, HW_PCIE_RC_DCR_RD(x) & ~(v)))
#define HW_PCIE_RC_DCR_TOG(x, v) (HW_PCIE_RC_DCR_WR(x, HW_PCIE_RC_DCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_DCR bitfields
 */

/*!
 * @name Register PCIE_RC_DCR, field Max_Payload_Size_Supported[2:0] (RW)
 *
 * Max_Payload_Size Supported, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_DCR_Max_Payload_Size_Supported (0U) /*!< Bit position for PCIE_RC_DCR_Max_Payload_Size_Supported. */
#define BM_PCIE_RC_DCR_Max_Payload_Size_Supported (0x00000007U) /*!< Bit mask for PCIE_RC_DCR_Max_Payload_Size_Supported. */
#define BS_PCIE_RC_DCR_Max_Payload_Size_Supported (3U) /*!< Bit field size in bits for PCIE_RC_DCR_Max_Payload_Size_Supported. */

/*! @brief Read current value of the PCIE_RC_DCR_Max_Payload_Size_Supported field. */
#define BR_PCIE_RC_DCR_Max_Payload_Size_Supported(x) (HW_PCIE_RC_DCR(x).B.Max_Payload_Size_Supported)

/*! @brief Format value for bitfield PCIE_RC_DCR_Max_Payload_Size_Supported. */
#define BF_PCIE_RC_DCR_Max_Payload_Size_Supported(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Max_Payload_Size_Supported) & BM_PCIE_RC_DCR_Max_Payload_Size_Supported)

/*! @brief Set the Max_Payload_Size_Supported field to a new value. */
#define BW_PCIE_RC_DCR_Max_Payload_Size_Supported(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Max_Payload_Size_Supported) | BF_PCIE_RC_DCR_Max_Payload_Size_Supported(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Phantom_Function_Supported[4:3] (RW)
 *
 * Phantom Function Supported This field is writable through the DBI. However,
 * Phantom Function is not supported. Therefore, the application must not write
 * any value other than 0x0 to this field.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Phantom_Function_Supported (3U) /*!< Bit position for PCIE_RC_DCR_Phantom_Function_Supported. */
#define BM_PCIE_RC_DCR_Phantom_Function_Supported (0x00000018U) /*!< Bit mask for PCIE_RC_DCR_Phantom_Function_Supported. */
#define BS_PCIE_RC_DCR_Phantom_Function_Supported (2U) /*!< Bit field size in bits for PCIE_RC_DCR_Phantom_Function_Supported. */

/*! @brief Read current value of the PCIE_RC_DCR_Phantom_Function_Supported field. */
#define BR_PCIE_RC_DCR_Phantom_Function_Supported(x) (HW_PCIE_RC_DCR(x).B.Phantom_Function_Supported)

/*! @brief Format value for bitfield PCIE_RC_DCR_Phantom_Function_Supported. */
#define BF_PCIE_RC_DCR_Phantom_Function_Supported(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Phantom_Function_Supported) & BM_PCIE_RC_DCR_Phantom_Function_Supported)

/*! @brief Set the Phantom_Function_Supported field to a new value. */
#define BW_PCIE_RC_DCR_Phantom_Function_Supported(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Phantom_Function_Supported) | BF_PCIE_RC_DCR_Phantom_Function_Supported(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Extended_Tag_Field_Supported[5] (RW)
 *
 * Extended Tag Field Supported This bit is writable through the DBI. However,
 * if the core supports only 5 bits of TAG, then the application must not write a
 * 1 to this field because the hardware to support more than 32 tags are not
 * implemented.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Extended_Tag_Field_Supported (5U) /*!< Bit position for PCIE_RC_DCR_Extended_Tag_Field_Supported. */
#define BM_PCIE_RC_DCR_Extended_Tag_Field_Supported (0x00000020U) /*!< Bit mask for PCIE_RC_DCR_Extended_Tag_Field_Supported. */
#define BS_PCIE_RC_DCR_Extended_Tag_Field_Supported (1U) /*!< Bit field size in bits for PCIE_RC_DCR_Extended_Tag_Field_Supported. */

/*! @brief Read current value of the PCIE_RC_DCR_Extended_Tag_Field_Supported field. */
#define BR_PCIE_RC_DCR_Extended_Tag_Field_Supported(x) (HW_PCIE_RC_DCR(x).B.Extended_Tag_Field_Supported)

/*! @brief Format value for bitfield PCIE_RC_DCR_Extended_Tag_Field_Supported. */
#define BF_PCIE_RC_DCR_Extended_Tag_Field_Supported(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Extended_Tag_Field_Supported) & BM_PCIE_RC_DCR_Extended_Tag_Field_Supported)

/*! @brief Set the Extended_Tag_Field_Supported field to a new value. */
#define BW_PCIE_RC_DCR_Extended_Tag_Field_Supported(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Extended_Tag_Field_Supported) | BF_PCIE_RC_DCR_Extended_Tag_Field_Supported(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Endpoint_L0s_Acceptable_Latency[8:6] (RW)
 *
 * Endpoint L0s Acceptable Latency Must be 0x0 for non-Endpoint devices.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency (6U) /*!< Bit position for PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency. */
#define BM_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency (0x000001C0U) /*!< Bit mask for PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency. */
#define BS_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency (3U) /*!< Bit field size in bits for PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency. */

/*! @brief Read current value of the PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency field. */
#define BR_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency(x) (HW_PCIE_RC_DCR(x).B.Endpoint_L0s_Acceptable_Latency)

/*! @brief Format value for bitfield PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency. */
#define BF_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency) & BM_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency)

/*! @brief Set the Endpoint_L0s_Acceptable_Latency field to a new value. */
#define BW_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency) | BF_PCIE_RC_DCR_Endpoint_L0s_Acceptable_Latency(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Endpoint_L1_Acceptable_Latency[11:9] (RW)
 *
 * Endpoint L1 Acceptable Latency Must be 0x0 for non-Endpoint devices.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency (9U) /*!< Bit position for PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency. */
#define BM_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency (0x00000E00U) /*!< Bit mask for PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency. */
#define BS_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency (3U) /*!< Bit field size in bits for PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency. */

/*! @brief Read current value of the PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency field. */
#define BR_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency(x) (HW_PCIE_RC_DCR(x).B.Endpoint_L1_Acceptable_Latency)

/*! @brief Format value for bitfield PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency. */
#define BF_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency) & BM_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency)

/*! @brief Set the Endpoint_L1_Acceptable_Latency field to a new value. */
#define BW_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency) | BF_PCIE_RC_DCR_Endpoint_L1_Acceptable_Latency(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Role_Based_Error_Reporting[15] (RW)
 *
 * Role-Based Error Reporting, writable through the DBI. Required to be set for
 * device compliant to 1.1 spec and later.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Role_Based_Error_Reporting (15U) /*!< Bit position for PCIE_RC_DCR_Role_Based_Error_Reporting. */
#define BM_PCIE_RC_DCR_Role_Based_Error_Reporting (0x00008000U) /*!< Bit mask for PCIE_RC_DCR_Role_Based_Error_Reporting. */
#define BS_PCIE_RC_DCR_Role_Based_Error_Reporting (1U) /*!< Bit field size in bits for PCIE_RC_DCR_Role_Based_Error_Reporting. */

/*! @brief Read current value of the PCIE_RC_DCR_Role_Based_Error_Reporting field. */
#define BR_PCIE_RC_DCR_Role_Based_Error_Reporting(x) (HW_PCIE_RC_DCR(x).B.Role_Based_Error_Reporting)

/*! @brief Format value for bitfield PCIE_RC_DCR_Role_Based_Error_Reporting. */
#define BF_PCIE_RC_DCR_Role_Based_Error_Reporting(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Role_Based_Error_Reporting) & BM_PCIE_RC_DCR_Role_Based_Error_Reporting)

/*! @brief Set the Role_Based_Error_Reporting field to a new value. */
#define BW_PCIE_RC_DCR_Role_Based_Error_Reporting(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Role_Based_Error_Reporting) | BF_PCIE_RC_DCR_Role_Based_Error_Reporting(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Captured_Slot_Power_Limit_Value[25:18] (RW)
 *
 * Captured Slot Power Limit Value Upstream port only.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value (18U) /*!< Bit position for PCIE_RC_DCR_Captured_Slot_Power_Limit_Value. */
#define BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value (0x03FC0000U) /*!< Bit mask for PCIE_RC_DCR_Captured_Slot_Power_Limit_Value. */
#define BS_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value (8U) /*!< Bit field size in bits for PCIE_RC_DCR_Captured_Slot_Power_Limit_Value. */

/*! @brief Read current value of the PCIE_RC_DCR_Captured_Slot_Power_Limit_Value field. */
#define BR_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value(x) (HW_PCIE_RC_DCR(x).B.Captured_Slot_Power_Limit_Value)

/*! @brief Format value for bitfield PCIE_RC_DCR_Captured_Slot_Power_Limit_Value. */
#define BF_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value) & BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value)

/*! @brief Set the Captured_Slot_Power_Limit_Value field to a new value. */
#define BW_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value) | BF_PCIE_RC_DCR_Captured_Slot_Power_Limit_Value(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCR, field Captured_Slot_Power_Limit_Scale[27:26] (RW)
 *
 * Captured Slot Power Limit Scale Upstream port only.
 */
/*@{*/
#define BP_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale (26U) /*!< Bit position for PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale. */
#define BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale (0x0C000000U) /*!< Bit mask for PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale. */
#define BS_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale (2U) /*!< Bit field size in bits for PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale. */

/*! @brief Read current value of the PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale field. */
#define BR_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale(x) (HW_PCIE_RC_DCR(x).B.Captured_Slot_Power_Limit_Scale)

/*! @brief Format value for bitfield PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale. */
#define BF_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale) & BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale)

/*! @brief Set the Captured_Slot_Power_Limit_Scale field to a new value. */
#define BW_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale(x, v) (HW_PCIE_RC_DCR_WR(x, (HW_PCIE_RC_DCR_RD(x) & ~BM_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale) | BF_PCIE_RC_DCR_Captured_Slot_Power_Limit_Scale(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_DConR - Device Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_DConR - Device Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x08
 */
typedef union _hw_pcie_rc_dconr
{
    uint32_t U;
    struct _hw_pcie_rc_dconr_bitfields
    {
        uint32_t Correctable_Error_Reporting_Enable : 1; /*!< [0]  */
        uint32_t Non_Fatal_Error_Reporting_Enable : 1; /*!< [1]  */
        uint32_t Fatal_Error_Reporting_Enable : 1; /*!< [2]  */
        uint32_t Unsupported_Request_Reporting_Enable : 1; /*!< [3]  */
        uint32_t Enable_Relaxed_Ordering : 1; /*!< [4]  */
        uint32_t Max_Payload_Size : 3; /*!< [7:5]  */
        uint32_t Extended_Tag_Field_Enable : 1; /*!< [8]  */
        uint32_t Phantom_Function_Enable : 1; /*!< [9]  */
        uint32_t AUX_Power_PM_Enable : 1; /*!< [10]  */
        uint32_t Enable_No_Snoop : 1;  /*!< [11]  */
        uint32_t Max_Read_Request_Size : 3; /*!< [14:12]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t Correctable_Error_Detected : 1; /*!< [16]  */
        uint32_t Non_Fatal_Error_detected : 1; /*!< [17]  */
        uint32_t Fatal_Error_Detected : 1; /*!< [18]  */
        uint32_t Unsupported_Request_Detected : 1; /*!< [19]  */
        uint32_t Aux_Power_Detected : 1; /*!< [20]  */
        uint32_t Transaction_Pending : 1; /*!< [21]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_pcie_rc_dconr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_DConR register
 */
/*@{*/
#define HW_PCIE_RC_DConR_ADDR(x) ((uintptr_t)(x) + 0x78U)

#define HW_PCIE_RC_DConR(x)      (*(__IO hw_pcie_rc_dconr_t *) HW_PCIE_RC_DConR_ADDR(x))
#define HW_PCIE_RC_DConR_RD(x)   (HW_PCIE_RC_DConR(x).U)
#define HW_PCIE_RC_DConR_WR(x, v) (HW_PCIE_RC_DConR(x).U = (v))
#define HW_PCIE_RC_DConR_SET(x, v) (HW_PCIE_RC_DConR_WR(x, HW_PCIE_RC_DConR_RD(x) |  (v)))
#define HW_PCIE_RC_DConR_CLR(x, v) (HW_PCIE_RC_DConR_WR(x, HW_PCIE_RC_DConR_RD(x) & ~(v)))
#define HW_PCIE_RC_DConR_TOG(x, v) (HW_PCIE_RC_DConR_WR(x, HW_PCIE_RC_DConR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_DConR bitfields
 */

/*!
 * @name Register PCIE_RC_DConR, field Correctable_Error_Reporting_Enable[0] (RW)
 *
 * Correctable Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Correctable_Error_Reporting_Enable (0U) /*!< Bit position for PCIE_RC_DConR_Correctable_Error_Reporting_Enable. */
#define BM_PCIE_RC_DConR_Correctable_Error_Reporting_Enable (0x00000001U) /*!< Bit mask for PCIE_RC_DConR_Correctable_Error_Reporting_Enable. */
#define BS_PCIE_RC_DConR_Correctable_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Correctable_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Correctable_Error_Reporting_Enable field. */
#define BR_PCIE_RC_DConR_Correctable_Error_Reporting_Enable(x) (HW_PCIE_RC_DConR(x).B.Correctable_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Correctable_Error_Reporting_Enable. */
#define BF_PCIE_RC_DConR_Correctable_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Correctable_Error_Reporting_Enable) & BM_PCIE_RC_DConR_Correctable_Error_Reporting_Enable)

/*! @brief Set the Correctable_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Correctable_Error_Reporting_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Correctable_Error_Reporting_Enable) | BF_PCIE_RC_DConR_Correctable_Error_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Non_Fatal_Error_Reporting_Enable[1] (RW)
 *
 * Non-Fatal Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable (1U) /*!< Bit position for PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable. */
#define BM_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable (0x00000002U) /*!< Bit mask for PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable. */
#define BS_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable field. */
#define BR_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable(x) (HW_PCIE_RC_DConR(x).B.Non_Fatal_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable. */
#define BF_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable) & BM_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable)

/*! @brief Set the Non_Fatal_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable) | BF_PCIE_RC_DConR_Non_Fatal_Error_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Fatal_Error_Reporting_Enable[2] (RW)
 *
 * Fatal Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Fatal_Error_Reporting_Enable (2U) /*!< Bit position for PCIE_RC_DConR_Fatal_Error_Reporting_Enable. */
#define BM_PCIE_RC_DConR_Fatal_Error_Reporting_Enable (0x00000004U) /*!< Bit mask for PCIE_RC_DConR_Fatal_Error_Reporting_Enable. */
#define BS_PCIE_RC_DConR_Fatal_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Fatal_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Fatal_Error_Reporting_Enable field. */
#define BR_PCIE_RC_DConR_Fatal_Error_Reporting_Enable(x) (HW_PCIE_RC_DConR(x).B.Fatal_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Fatal_Error_Reporting_Enable. */
#define BF_PCIE_RC_DConR_Fatal_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Fatal_Error_Reporting_Enable) & BM_PCIE_RC_DConR_Fatal_Error_Reporting_Enable)

/*! @brief Set the Fatal_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Fatal_Error_Reporting_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Fatal_Error_Reporting_Enable) | BF_PCIE_RC_DConR_Fatal_Error_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Unsupported_Request_Reporting_Enable[3] (RW)
 *
 * Unsupported Request Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable (3U) /*!< Bit position for PCIE_RC_DConR_Unsupported_Request_Reporting_Enable. */
#define BM_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable (0x00000008U) /*!< Bit mask for PCIE_RC_DConR_Unsupported_Request_Reporting_Enable. */
#define BS_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Unsupported_Request_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Unsupported_Request_Reporting_Enable field. */
#define BR_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable(x) (HW_PCIE_RC_DConR(x).B.Unsupported_Request_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Unsupported_Request_Reporting_Enable. */
#define BF_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable) & BM_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable)

/*! @brief Set the Unsupported_Request_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable) | BF_PCIE_RC_DConR_Unsupported_Request_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Enable_Relaxed_Ordering[4] (RW)
 *
 * Enable Relaxed Ordering
 */
/*@{*/
#define BP_PCIE_RC_DConR_Enable_Relaxed_Ordering (4U) /*!< Bit position for PCIE_RC_DConR_Enable_Relaxed_Ordering. */
#define BM_PCIE_RC_DConR_Enable_Relaxed_Ordering (0x00000010U) /*!< Bit mask for PCIE_RC_DConR_Enable_Relaxed_Ordering. */
#define BS_PCIE_RC_DConR_Enable_Relaxed_Ordering (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Enable_Relaxed_Ordering. */

/*! @brief Read current value of the PCIE_RC_DConR_Enable_Relaxed_Ordering field. */
#define BR_PCIE_RC_DConR_Enable_Relaxed_Ordering(x) (HW_PCIE_RC_DConR(x).B.Enable_Relaxed_Ordering)

/*! @brief Format value for bitfield PCIE_RC_DConR_Enable_Relaxed_Ordering. */
#define BF_PCIE_RC_DConR_Enable_Relaxed_Ordering(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Enable_Relaxed_Ordering) & BM_PCIE_RC_DConR_Enable_Relaxed_Ordering)

/*! @brief Set the Enable_Relaxed_Ordering field to a new value. */
#define BW_PCIE_RC_DConR_Enable_Relaxed_Ordering(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Enable_Relaxed_Ordering) | BF_PCIE_RC_DConR_Enable_Relaxed_Ordering(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Max_Payload_Size[7:5] (RW)
 *
 * Max_Payload_Size
 */
/*@{*/
#define BP_PCIE_RC_DConR_Max_Payload_Size (5U) /*!< Bit position for PCIE_RC_DConR_Max_Payload_Size. */
#define BM_PCIE_RC_DConR_Max_Payload_Size (0x000000E0U) /*!< Bit mask for PCIE_RC_DConR_Max_Payload_Size. */
#define BS_PCIE_RC_DConR_Max_Payload_Size (3U) /*!< Bit field size in bits for PCIE_RC_DConR_Max_Payload_Size. */

/*! @brief Read current value of the PCIE_RC_DConR_Max_Payload_Size field. */
#define BR_PCIE_RC_DConR_Max_Payload_Size(x) (HW_PCIE_RC_DConR(x).B.Max_Payload_Size)

/*! @brief Format value for bitfield PCIE_RC_DConR_Max_Payload_Size. */
#define BF_PCIE_RC_DConR_Max_Payload_Size(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Max_Payload_Size) & BM_PCIE_RC_DConR_Max_Payload_Size)

/*! @brief Set the Max_Payload_Size field to a new value. */
#define BW_PCIE_RC_DConR_Max_Payload_Size(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Max_Payload_Size) | BF_PCIE_RC_DConR_Max_Payload_Size(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Extended_Tag_Field_Enable[8] (RW)
 *
 * Extended Tag Field Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Extended_Tag_Field_Enable (8U) /*!< Bit position for PCIE_RC_DConR_Extended_Tag_Field_Enable. */
#define BM_PCIE_RC_DConR_Extended_Tag_Field_Enable (0x00000100U) /*!< Bit mask for PCIE_RC_DConR_Extended_Tag_Field_Enable. */
#define BS_PCIE_RC_DConR_Extended_Tag_Field_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Extended_Tag_Field_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Extended_Tag_Field_Enable field. */
#define BR_PCIE_RC_DConR_Extended_Tag_Field_Enable(x) (HW_PCIE_RC_DConR(x).B.Extended_Tag_Field_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Extended_Tag_Field_Enable. */
#define BF_PCIE_RC_DConR_Extended_Tag_Field_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Extended_Tag_Field_Enable) & BM_PCIE_RC_DConR_Extended_Tag_Field_Enable)

/*! @brief Set the Extended_Tag_Field_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Extended_Tag_Field_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Extended_Tag_Field_Enable) | BF_PCIE_RC_DConR_Extended_Tag_Field_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Phantom_Function_Enable[9] (RW)
 *
 * Phantom Function Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_Phantom_Function_Enable (9U) /*!< Bit position for PCIE_RC_DConR_Phantom_Function_Enable. */
#define BM_PCIE_RC_DConR_Phantom_Function_Enable (0x00000200U) /*!< Bit mask for PCIE_RC_DConR_Phantom_Function_Enable. */
#define BS_PCIE_RC_DConR_Phantom_Function_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Phantom_Function_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_Phantom_Function_Enable field. */
#define BR_PCIE_RC_DConR_Phantom_Function_Enable(x) (HW_PCIE_RC_DConR(x).B.Phantom_Function_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_Phantom_Function_Enable. */
#define BF_PCIE_RC_DConR_Phantom_Function_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Phantom_Function_Enable) & BM_PCIE_RC_DConR_Phantom_Function_Enable)

/*! @brief Set the Phantom_Function_Enable field to a new value. */
#define BW_PCIE_RC_DConR_Phantom_Function_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Phantom_Function_Enable) | BF_PCIE_RC_DConR_Phantom_Function_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field AUX_Power_PM_Enable[10] (RW)
 *
 * AUX Power PM Enable
 */
/*@{*/
#define BP_PCIE_RC_DConR_AUX_Power_PM_Enable (10U) /*!< Bit position for PCIE_RC_DConR_AUX_Power_PM_Enable. */
#define BM_PCIE_RC_DConR_AUX_Power_PM_Enable (0x00000400U) /*!< Bit mask for PCIE_RC_DConR_AUX_Power_PM_Enable. */
#define BS_PCIE_RC_DConR_AUX_Power_PM_Enable (1U) /*!< Bit field size in bits for PCIE_RC_DConR_AUX_Power_PM_Enable. */

/*! @brief Read current value of the PCIE_RC_DConR_AUX_Power_PM_Enable field. */
#define BR_PCIE_RC_DConR_AUX_Power_PM_Enable(x) (HW_PCIE_RC_DConR(x).B.AUX_Power_PM_Enable)

/*! @brief Format value for bitfield PCIE_RC_DConR_AUX_Power_PM_Enable. */
#define BF_PCIE_RC_DConR_AUX_Power_PM_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_AUX_Power_PM_Enable) & BM_PCIE_RC_DConR_AUX_Power_PM_Enable)

/*! @brief Set the AUX_Power_PM_Enable field to a new value. */
#define BW_PCIE_RC_DConR_AUX_Power_PM_Enable(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_AUX_Power_PM_Enable) | BF_PCIE_RC_DConR_AUX_Power_PM_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Enable_No_Snoop[11] (RW)
 *
 * Enable No Snoop
 */
/*@{*/
#define BP_PCIE_RC_DConR_Enable_No_Snoop (11U) /*!< Bit position for PCIE_RC_DConR_Enable_No_Snoop. */
#define BM_PCIE_RC_DConR_Enable_No_Snoop (0x00000800U) /*!< Bit mask for PCIE_RC_DConR_Enable_No_Snoop. */
#define BS_PCIE_RC_DConR_Enable_No_Snoop (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Enable_No_Snoop. */

/*! @brief Read current value of the PCIE_RC_DConR_Enable_No_Snoop field. */
#define BR_PCIE_RC_DConR_Enable_No_Snoop(x) (HW_PCIE_RC_DConR(x).B.Enable_No_Snoop)

/*! @brief Format value for bitfield PCIE_RC_DConR_Enable_No_Snoop. */
#define BF_PCIE_RC_DConR_Enable_No_Snoop(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Enable_No_Snoop) & BM_PCIE_RC_DConR_Enable_No_Snoop)

/*! @brief Set the Enable_No_Snoop field to a new value. */
#define BW_PCIE_RC_DConR_Enable_No_Snoop(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Enable_No_Snoop) | BF_PCIE_RC_DConR_Enable_No_Snoop(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Max_Read_Request_Size[14:12] (RW)
 *
 * Max_Read_Request_Size
 */
/*@{*/
#define BP_PCIE_RC_DConR_Max_Read_Request_Size (12U) /*!< Bit position for PCIE_RC_DConR_Max_Read_Request_Size. */
#define BM_PCIE_RC_DConR_Max_Read_Request_Size (0x00007000U) /*!< Bit mask for PCIE_RC_DConR_Max_Read_Request_Size. */
#define BS_PCIE_RC_DConR_Max_Read_Request_Size (3U) /*!< Bit field size in bits for PCIE_RC_DConR_Max_Read_Request_Size. */

/*! @brief Read current value of the PCIE_RC_DConR_Max_Read_Request_Size field. */
#define BR_PCIE_RC_DConR_Max_Read_Request_Size(x) (HW_PCIE_RC_DConR(x).B.Max_Read_Request_Size)

/*! @brief Format value for bitfield PCIE_RC_DConR_Max_Read_Request_Size. */
#define BF_PCIE_RC_DConR_Max_Read_Request_Size(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Max_Read_Request_Size) & BM_PCIE_RC_DConR_Max_Read_Request_Size)

/*! @brief Set the Max_Read_Request_Size field to a new value. */
#define BW_PCIE_RC_DConR_Max_Read_Request_Size(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Max_Read_Request_Size) | BF_PCIE_RC_DConR_Max_Read_Request_Size(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Correctable_Error_Detected[16] (RW)
 *
 * Correctable Error Detected Errors are logged in this register regardless of
 * whether error reporting is enabled in the Device Control register.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Correctable_Error_Detected (16U) /*!< Bit position for PCIE_RC_DConR_Correctable_Error_Detected. */
#define BM_PCIE_RC_DConR_Correctable_Error_Detected (0x00010000U) /*!< Bit mask for PCIE_RC_DConR_Correctable_Error_Detected. */
#define BS_PCIE_RC_DConR_Correctable_Error_Detected (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Correctable_Error_Detected. */

/*! @brief Read current value of the PCIE_RC_DConR_Correctable_Error_Detected field. */
#define BR_PCIE_RC_DConR_Correctable_Error_Detected(x) (HW_PCIE_RC_DConR(x).B.Correctable_Error_Detected)

/*! @brief Format value for bitfield PCIE_RC_DConR_Correctable_Error_Detected. */
#define BF_PCIE_RC_DConR_Correctable_Error_Detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Correctable_Error_Detected) & BM_PCIE_RC_DConR_Correctable_Error_Detected)

/*! @brief Set the Correctable_Error_Detected field to a new value. */
#define BW_PCIE_RC_DConR_Correctable_Error_Detected(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Correctable_Error_Detected) | BF_PCIE_RC_DConR_Correctable_Error_Detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Non_Fatal_Error_detected[17] (RW)
 *
 * Non-Fatal Error detected Errors are logged in this register regardless of
 * whether error reporting is enabled in the Device Control register.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Non_Fatal_Error_detected (17U) /*!< Bit position for PCIE_RC_DConR_Non_Fatal_Error_detected. */
#define BM_PCIE_RC_DConR_Non_Fatal_Error_detected (0x00020000U) /*!< Bit mask for PCIE_RC_DConR_Non_Fatal_Error_detected. */
#define BS_PCIE_RC_DConR_Non_Fatal_Error_detected (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Non_Fatal_Error_detected. */

/*! @brief Read current value of the PCIE_RC_DConR_Non_Fatal_Error_detected field. */
#define BR_PCIE_RC_DConR_Non_Fatal_Error_detected(x) (HW_PCIE_RC_DConR(x).B.Non_Fatal_Error_detected)

/*! @brief Format value for bitfield PCIE_RC_DConR_Non_Fatal_Error_detected. */
#define BF_PCIE_RC_DConR_Non_Fatal_Error_detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Non_Fatal_Error_detected) & BM_PCIE_RC_DConR_Non_Fatal_Error_detected)

/*! @brief Set the Non_Fatal_Error_detected field to a new value. */
#define BW_PCIE_RC_DConR_Non_Fatal_Error_detected(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Non_Fatal_Error_detected) | BF_PCIE_RC_DConR_Non_Fatal_Error_detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Fatal_Error_Detected[18] (RW)
 *
 * Fatal Error Detected Errors are logged in this register regardless of whether
 * error reporting is enabled in the Device Control register.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Fatal_Error_Detected (18U) /*!< Bit position for PCIE_RC_DConR_Fatal_Error_Detected. */
#define BM_PCIE_RC_DConR_Fatal_Error_Detected (0x00040000U) /*!< Bit mask for PCIE_RC_DConR_Fatal_Error_Detected. */
#define BS_PCIE_RC_DConR_Fatal_Error_Detected (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Fatal_Error_Detected. */

/*! @brief Read current value of the PCIE_RC_DConR_Fatal_Error_Detected field. */
#define BR_PCIE_RC_DConR_Fatal_Error_Detected(x) (HW_PCIE_RC_DConR(x).B.Fatal_Error_Detected)

/*! @brief Format value for bitfield PCIE_RC_DConR_Fatal_Error_Detected. */
#define BF_PCIE_RC_DConR_Fatal_Error_Detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Fatal_Error_Detected) & BM_PCIE_RC_DConR_Fatal_Error_Detected)

/*! @brief Set the Fatal_Error_Detected field to a new value. */
#define BW_PCIE_RC_DConR_Fatal_Error_Detected(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Fatal_Error_Detected) | BF_PCIE_RC_DConR_Fatal_Error_Detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Unsupported_Request_Detected[19] (RW)
 *
 * Unsupported Request Detected Errors are logged in this register regardless of
 * whether error reporting is enabled in the Device Control register.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Unsupported_Request_Detected (19U) /*!< Bit position for PCIE_RC_DConR_Unsupported_Request_Detected. */
#define BM_PCIE_RC_DConR_Unsupported_Request_Detected (0x00080000U) /*!< Bit mask for PCIE_RC_DConR_Unsupported_Request_Detected. */
#define BS_PCIE_RC_DConR_Unsupported_Request_Detected (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Unsupported_Request_Detected. */

/*! @brief Read current value of the PCIE_RC_DConR_Unsupported_Request_Detected field. */
#define BR_PCIE_RC_DConR_Unsupported_Request_Detected(x) (HW_PCIE_RC_DConR(x).B.Unsupported_Request_Detected)

/*! @brief Format value for bitfield PCIE_RC_DConR_Unsupported_Request_Detected. */
#define BF_PCIE_RC_DConR_Unsupported_Request_Detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Unsupported_Request_Detected) & BM_PCIE_RC_DConR_Unsupported_Request_Detected)

/*! @brief Set the Unsupported_Request_Detected field to a new value. */
#define BW_PCIE_RC_DConR_Unsupported_Request_Detected(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Unsupported_Request_Detected) | BF_PCIE_RC_DConR_Unsupported_Request_Detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Aux_Power_Detected[20] (RW)
 *
 * Aux Power Detected From sys_aux_pwr_det input port.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Aux_Power_Detected (20U) /*!< Bit position for PCIE_RC_DConR_Aux_Power_Detected. */
#define BM_PCIE_RC_DConR_Aux_Power_Detected (0x00100000U) /*!< Bit mask for PCIE_RC_DConR_Aux_Power_Detected. */
#define BS_PCIE_RC_DConR_Aux_Power_Detected (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Aux_Power_Detected. */

/*! @brief Read current value of the PCIE_RC_DConR_Aux_Power_Detected field. */
#define BR_PCIE_RC_DConR_Aux_Power_Detected(x) (HW_PCIE_RC_DConR(x).B.Aux_Power_Detected)

/*! @brief Format value for bitfield PCIE_RC_DConR_Aux_Power_Detected. */
#define BF_PCIE_RC_DConR_Aux_Power_Detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Aux_Power_Detected) & BM_PCIE_RC_DConR_Aux_Power_Detected)

/*! @brief Set the Aux_Power_Detected field to a new value. */
#define BW_PCIE_RC_DConR_Aux_Power_Detected(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Aux_Power_Detected) | BF_PCIE_RC_DConR_Aux_Power_Detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DConR, field Transaction_Pending[21] (RW)
 *
 * Transaction Pending Hard-wired to 0.
 */
/*@{*/
#define BP_PCIE_RC_DConR_Transaction_Pending (21U) /*!< Bit position for PCIE_RC_DConR_Transaction_Pending. */
#define BM_PCIE_RC_DConR_Transaction_Pending (0x00200000U) /*!< Bit mask for PCIE_RC_DConR_Transaction_Pending. */
#define BS_PCIE_RC_DConR_Transaction_Pending (1U) /*!< Bit field size in bits for PCIE_RC_DConR_Transaction_Pending. */

/*! @brief Read current value of the PCIE_RC_DConR_Transaction_Pending field. */
#define BR_PCIE_RC_DConR_Transaction_Pending(x) (HW_PCIE_RC_DConR(x).B.Transaction_Pending)

/*! @brief Format value for bitfield PCIE_RC_DConR_Transaction_Pending. */
#define BF_PCIE_RC_DConR_Transaction_Pending(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DConR_Transaction_Pending) & BM_PCIE_RC_DConR_Transaction_Pending)

/*! @brief Set the Transaction_Pending field to a new value. */
#define BW_PCIE_RC_DConR_Transaction_Pending(x, v) (HW_PCIE_RC_DConR_WR(x, (HW_PCIE_RC_DConR_RD(x) & ~BM_PCIE_RC_DConR_Transaction_Pending) | BF_PCIE_RC_DConR_Transaction_Pending(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_LCR - Link Capabilities Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_LCR - Link Capabilities Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x0C
 */
typedef union _hw_pcie_rc_lcr
{
    uint32_t U;
    struct _hw_pcie_rc_lcr_bitfields
    {
        uint32_t Max_Link_Speeds : 4;  /*!< [3:0]  */
        uint32_t Maximum_Link_Width : 6; /*!< [9:4]  */
        uint32_t Active_State_Link_PM_Support : 2; /*!< [11:10]  */
        uint32_t L0s_Exit_Latency : 3; /*!< [14:12]  */
        uint32_t L1_Exit_Latency : 3;  /*!< [17:15]  */
        uint32_t Clock_Power_Management : 1; /*!< [18]  */
        uint32_t Surprise_Down_Error_Reporting_Capable : 1; /*!< [19]  */
        uint32_t Data_Link_Layer_Active_Reporting_Capable : 1; /*!< [20]  */
        uint32_t Link_Bandwidth_Notification_Capability : 1; /*!< [21]  */
        uint32_t RESERVED0 : 2;        /*!< [23:22]  */
        uint32_t Port_Number : 8;      /*!< [31:24]  */
    } B;
} hw_pcie_rc_lcr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_LCR register
 */
/*@{*/
#define HW_PCIE_RC_LCR_ADDR(x)   ((uintptr_t)(x) + 0x7CU)

#define HW_PCIE_RC_LCR(x)        (*(__I hw_pcie_rc_lcr_t *) HW_PCIE_RC_LCR_ADDR(x))
#define HW_PCIE_RC_LCR_RD(x)     (HW_PCIE_RC_LCR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_LCR bitfields
 */

/*!
 * @name Register PCIE_RC_LCR, field Max_Link_Speeds[3:0] (RO)
 *
 * Max Link Speeds Indicates the supported maximum Link speeds of the associated
 * Port. The encoding is the binary value of the bit location in the Supported
 * Link Speeds Vector (in the Link Capabilities 2 register) that corresponds to
 * the maximum Link speed. This field is writable through the DBI.
 *
 * Values:
 * - 0001 - Gen1 2.5 GT/s
 * - 0010 - Gen2 5.0 GT/s
 * - 0100 - Reserved
 */
/*@{*/
#define BP_PCIE_RC_LCR_Max_Link_Speeds (0U) /*!< Bit position for PCIE_RC_LCR_Max_Link_Speeds. */
#define BM_PCIE_RC_LCR_Max_Link_Speeds (0x0000000FU) /*!< Bit mask for PCIE_RC_LCR_Max_Link_Speeds. */
#define BS_PCIE_RC_LCR_Max_Link_Speeds (4U) /*!< Bit field size in bits for PCIE_RC_LCR_Max_Link_Speeds. */

/*! @brief Read current value of the PCIE_RC_LCR_Max_Link_Speeds field. */
#define BR_PCIE_RC_LCR_Max_Link_Speeds(x) (HW_PCIE_RC_LCR(x).B.Max_Link_Speeds)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Maximum_Link_Width[9:4] (RO)
 *
 * Maximum Link Width Writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Maximum_Link_Width (4U) /*!< Bit position for PCIE_RC_LCR_Maximum_Link_Width. */
#define BM_PCIE_RC_LCR_Maximum_Link_Width (0x000003F0U) /*!< Bit mask for PCIE_RC_LCR_Maximum_Link_Width. */
#define BS_PCIE_RC_LCR_Maximum_Link_Width (6U) /*!< Bit field size in bits for PCIE_RC_LCR_Maximum_Link_Width. */

/*! @brief Read current value of the PCIE_RC_LCR_Maximum_Link_Width field. */
#define BR_PCIE_RC_LCR_Maximum_Link_Width(x) (HW_PCIE_RC_LCR(x).B.Maximum_Link_Width)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Active_State_Link_PM_Support[11:10] (RO)
 *
 * Active State Link PM Support The default value is the value you specify
 * during core configuration, writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Active_State_Link_PM_Support (10U) /*!< Bit position for PCIE_RC_LCR_Active_State_Link_PM_Support. */
#define BM_PCIE_RC_LCR_Active_State_Link_PM_Support (0x00000C00U) /*!< Bit mask for PCIE_RC_LCR_Active_State_Link_PM_Support. */
#define BS_PCIE_RC_LCR_Active_State_Link_PM_Support (2U) /*!< Bit field size in bits for PCIE_RC_LCR_Active_State_Link_PM_Support. */

/*! @brief Read current value of the PCIE_RC_LCR_Active_State_Link_PM_Support field. */
#define BR_PCIE_RC_LCR_Active_State_Link_PM_Support(x) (HW_PCIE_RC_LCR(x).B.Active_State_Link_PM_Support)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field L0s_Exit_Latency[14:12] (RO)
 *
 * L0s Exit Latency Writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR_L0s_Exit_Latency (12U) /*!< Bit position for PCIE_RC_LCR_L0s_Exit_Latency. */
#define BM_PCIE_RC_LCR_L0s_Exit_Latency (0x00007000U) /*!< Bit mask for PCIE_RC_LCR_L0s_Exit_Latency. */
#define BS_PCIE_RC_LCR_L0s_Exit_Latency (3U) /*!< Bit field size in bits for PCIE_RC_LCR_L0s_Exit_Latency. */

/*! @brief Read current value of the PCIE_RC_LCR_L0s_Exit_Latency field. */
#define BR_PCIE_RC_LCR_L0s_Exit_Latency(x) (HW_PCIE_RC_LCR(x).B.L0s_Exit_Latency)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field L1_Exit_Latency[17:15] (RO)
 *
 * L1 Exit Latency Writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR_L1_Exit_Latency (15U) /*!< Bit position for PCIE_RC_LCR_L1_Exit_Latency. */
#define BM_PCIE_RC_LCR_L1_Exit_Latency (0x00038000U) /*!< Bit mask for PCIE_RC_LCR_L1_Exit_Latency. */
#define BS_PCIE_RC_LCR_L1_Exit_Latency (3U) /*!< Bit field size in bits for PCIE_RC_LCR_L1_Exit_Latency. */

/*! @brief Read current value of the PCIE_RC_LCR_L1_Exit_Latency field. */
#define BR_PCIE_RC_LCR_L1_Exit_Latency(x) (HW_PCIE_RC_LCR(x).B.L1_Exit_Latency)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Clock_Power_Management[18] (RO)
 *
 * Clock Power Management Component can tolerate the removal of refclk via
 * CLKREQ# (if supported). Hardwired to 0 for downstream ports. Writable through the
 * DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Clock_Power_Management (18U) /*!< Bit position for PCIE_RC_LCR_Clock_Power_Management. */
#define BM_PCIE_RC_LCR_Clock_Power_Management (0x00040000U) /*!< Bit mask for PCIE_RC_LCR_Clock_Power_Management. */
#define BS_PCIE_RC_LCR_Clock_Power_Management (1U) /*!< Bit field size in bits for PCIE_RC_LCR_Clock_Power_Management. */

/*! @brief Read current value of the PCIE_RC_LCR_Clock_Power_Management field. */
#define BR_PCIE_RC_LCR_Clock_Power_Management(x) (HW_PCIE_RC_LCR(x).B.Clock_Power_Management)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Surprise_Down_Error_Reporting_Capable[19] (RO)
 *
 * Surprise Down Error Reporting Capable Not supported, hardwired to 0x0.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable (19U) /*!< Bit position for PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable. */
#define BM_PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable (0x00080000U) /*!< Bit mask for PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable. */
#define BS_PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable (1U) /*!< Bit field size in bits for PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable. */

/*! @brief Read current value of the PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable field. */
#define BR_PCIE_RC_LCR_Surprise_Down_Error_Reporting_Capable(x) (HW_PCIE_RC_LCR(x).B.Surprise_Down_Error_Reporting_Capable)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Data_Link_Layer_Active_Reporting_Capable[20] (RO)
 *
 * Data Link Layer Active Reporting Capable Hardwired to 1 for Downstream Ports
 * and 0 for Upstream Ports.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable (20U) /*!< Bit position for PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable. */
#define BM_PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable (0x00100000U) /*!< Bit mask for PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable. */
#define BS_PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable (1U) /*!< Bit field size in bits for PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable. */

/*! @brief Read current value of the PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable field. */
#define BR_PCIE_RC_LCR_Data_Link_Layer_Active_Reporting_Capable(x) (HW_PCIE_RC_LCR(x).B.Data_Link_Layer_Active_Reporting_Capable)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Link_Bandwidth_Notification_Capability[21] (RO)
 *
 * Link Bandwidth Notification Capability Hardwired to 1 for Downstream Ports
 * and 0 for Upstream Ports.
 */
/*@{*/
#define BP_PCIE_RC_LCR_Link_Bandwidth_Notification_Capability (21U) /*!< Bit position for PCIE_RC_LCR_Link_Bandwidth_Notification_Capability. */
#define BM_PCIE_RC_LCR_Link_Bandwidth_Notification_Capability (0x00200000U) /*!< Bit mask for PCIE_RC_LCR_Link_Bandwidth_Notification_Capability. */
#define BS_PCIE_RC_LCR_Link_Bandwidth_Notification_Capability (1U) /*!< Bit field size in bits for PCIE_RC_LCR_Link_Bandwidth_Notification_Capability. */

/*! @brief Read current value of the PCIE_RC_LCR_Link_Bandwidth_Notification_Capability field. */
#define BR_PCIE_RC_LCR_Link_Bandwidth_Notification_Capability(x) (HW_PCIE_RC_LCR(x).B.Link_Bandwidth_Notification_Capability)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR, field Port_Number[31:24] (RO)
 *
 * Port Number
 */
/*@{*/
#define BP_PCIE_RC_LCR_Port_Number (24U)   /*!< Bit position for PCIE_RC_LCR_Port_Number. */
#define BM_PCIE_RC_LCR_Port_Number (0xFF000000U) /*!< Bit mask for PCIE_RC_LCR_Port_Number. */
#define BS_PCIE_RC_LCR_Port_Number (8U)    /*!< Bit field size in bits for PCIE_RC_LCR_Port_Number. */

/*! @brief Read current value of the PCIE_RC_LCR_Port_Number field. */
#define BR_PCIE_RC_LCR_Port_Number(x) (HW_PCIE_RC_LCR(x).B.Port_Number)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_LCSR - Link Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_LCSR - Link Control and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x10
 */
typedef union _hw_pcie_rc_lcsr
{
    uint32_t U;
    struct _hw_pcie_rc_lcsr_bitfields
    {
        uint32_t Active_State_Link_PM_Control : 2; /*!< [1:0]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t RCB : 1;              /*!< [3]  */
        uint32_t Link_Disable : 1;     /*!< [4]  */
        uint32_t Retrain_Link : 1;     /*!< [5]  */
        uint32_t Common_Clock_Configuration : 1; /*!< [6]  */
        uint32_t Extended_Synch : 1;   /*!< [7]  */
        uint32_t Enable_Clock_Power_Management : 1; /*!< [8]  */
        uint32_t Hardware_Autonomous_Width_Disable : 1; /*!< [9]  */
        uint32_t Link_Bandwidth_Management_Interrupt_Enable : 1; /*!< [10]  */
        uint32_t Link_Autonomous_Bandwidth_Interrupt_Enable : 1; /*!< [11]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t Link_Speed : 4;       /*!< [19:16]  */
        uint32_t Negotiated_Link_Width : 6; /*!< [25:20]  */
        uint32_t RESERVED2 : 1;        /*!< [26]  */
        uint32_t Link_Training : 1;    /*!< [27]  */
        uint32_t Slot_Clock_Configuration : 1; /*!< [28]  */
        uint32_t Data_Link_Layer_Active : 1; /*!< [29]  */
        uint32_t Link_Bandwidth_Management_Status : 1; /*!< [30]  */
        uint32_t Link_Autonomous_Bandwidth_Status : 1; /*!< [31]  */
    } B;
} hw_pcie_rc_lcsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_LCSR register
 */
/*@{*/
#define HW_PCIE_RC_LCSR_ADDR(x)  ((uintptr_t)(x) + 0x80U)

#define HW_PCIE_RC_LCSR(x)       (*(__IO hw_pcie_rc_lcsr_t *) HW_PCIE_RC_LCSR_ADDR(x))
#define HW_PCIE_RC_LCSR_RD(x)    (HW_PCIE_RC_LCSR(x).U)
#define HW_PCIE_RC_LCSR_WR(x, v) (HW_PCIE_RC_LCSR(x).U = (v))
#define HW_PCIE_RC_LCSR_SET(x, v) (HW_PCIE_RC_LCSR_WR(x, HW_PCIE_RC_LCSR_RD(x) |  (v)))
#define HW_PCIE_RC_LCSR_CLR(x, v) (HW_PCIE_RC_LCSR_WR(x, HW_PCIE_RC_LCSR_RD(x) & ~(v)))
#define HW_PCIE_RC_LCSR_TOG(x, v) (HW_PCIE_RC_LCSR_WR(x, HW_PCIE_RC_LCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_LCSR bitfields
 */

/*!
 * @name Register PCIE_RC_LCSR, field Active_State_Link_PM_Control[1:0] (RW)
 *
 * Active State Link PM Control
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Active_State_Link_PM_Control (0U) /*!< Bit position for PCIE_RC_LCSR_Active_State_Link_PM_Control. */
#define BM_PCIE_RC_LCSR_Active_State_Link_PM_Control (0x00000003U) /*!< Bit mask for PCIE_RC_LCSR_Active_State_Link_PM_Control. */
#define BS_PCIE_RC_LCSR_Active_State_Link_PM_Control (2U) /*!< Bit field size in bits for PCIE_RC_LCSR_Active_State_Link_PM_Control. */

/*! @brief Read current value of the PCIE_RC_LCSR_Active_State_Link_PM_Control field. */
#define BR_PCIE_RC_LCSR_Active_State_Link_PM_Control(x) (HW_PCIE_RC_LCSR(x).B.Active_State_Link_PM_Control)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Active_State_Link_PM_Control. */
#define BF_PCIE_RC_LCSR_Active_State_Link_PM_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Active_State_Link_PM_Control) & BM_PCIE_RC_LCSR_Active_State_Link_PM_Control)

/*! @brief Set the Active_State_Link_PM_Control field to a new value. */
#define BW_PCIE_RC_LCSR_Active_State_Link_PM_Control(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Active_State_Link_PM_Control) | BF_PCIE_RC_LCSR_Active_State_Link_PM_Control(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field RCB[3] (RW)
 *
 * Read Completion Boundary (RCB) RC: Writable through DBI
 */
/*@{*/
#define BP_PCIE_RC_LCSR_RCB  (3U)          /*!< Bit position for PCIE_RC_LCSR_RCB. */
#define BM_PCIE_RC_LCSR_RCB  (0x00000008U) /*!< Bit mask for PCIE_RC_LCSR_RCB. */
#define BS_PCIE_RC_LCSR_RCB  (1U)          /*!< Bit field size in bits for PCIE_RC_LCSR_RCB. */

/*! @brief Read current value of the PCIE_RC_LCSR_RCB field. */
#define BR_PCIE_RC_LCSR_RCB(x) (HW_PCIE_RC_LCSR(x).B.RCB)

/*! @brief Format value for bitfield PCIE_RC_LCSR_RCB. */
#define BF_PCIE_RC_LCSR_RCB(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_RCB) & BM_PCIE_RC_LCSR_RCB)

/*! @brief Set the RCB field to a new value. */
#define BW_PCIE_RC_LCSR_RCB(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_RCB) | BF_PCIE_RC_LCSR_RCB(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Disable[4] (RW)
 *
 * Link Disable This bit is reserved for PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Disable (4U)  /*!< Bit position for PCIE_RC_LCSR_Link_Disable. */
#define BM_PCIE_RC_LCSR_Link_Disable (0x00000010U) /*!< Bit mask for PCIE_RC_LCSR_Link_Disable. */
#define BS_PCIE_RC_LCSR_Link_Disable (1U)  /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Disable. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Disable field. */
#define BR_PCIE_RC_LCSR_Link_Disable(x) (HW_PCIE_RC_LCSR(x).B.Link_Disable)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Disable. */
#define BF_PCIE_RC_LCSR_Link_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Disable) & BM_PCIE_RC_LCSR_Link_Disable)

/*! @brief Set the Link_Disable field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Disable(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Disable) | BF_PCIE_RC_LCSR_Link_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Retrain_Link[5] (RW)
 *
 * Retrain Link This bit is reserved for PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Retrain_Link (5U)  /*!< Bit position for PCIE_RC_LCSR_Retrain_Link. */
#define BM_PCIE_RC_LCSR_Retrain_Link (0x00000020U) /*!< Bit mask for PCIE_RC_LCSR_Retrain_Link. */
#define BS_PCIE_RC_LCSR_Retrain_Link (1U)  /*!< Bit field size in bits for PCIE_RC_LCSR_Retrain_Link. */

/*! @brief Read current value of the PCIE_RC_LCSR_Retrain_Link field. */
#define BR_PCIE_RC_LCSR_Retrain_Link(x) (HW_PCIE_RC_LCSR(x).B.Retrain_Link)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Retrain_Link. */
#define BF_PCIE_RC_LCSR_Retrain_Link(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Retrain_Link) & BM_PCIE_RC_LCSR_Retrain_Link)

/*! @brief Set the Retrain_Link field to a new value. */
#define BW_PCIE_RC_LCSR_Retrain_Link(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Retrain_Link) | BF_PCIE_RC_LCSR_Retrain_Link(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Common_Clock_Configuration[6] (RW)
 *
 * Common Clock Configuration
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Common_Clock_Configuration (6U) /*!< Bit position for PCIE_RC_LCSR_Common_Clock_Configuration. */
#define BM_PCIE_RC_LCSR_Common_Clock_Configuration (0x00000040U) /*!< Bit mask for PCIE_RC_LCSR_Common_Clock_Configuration. */
#define BS_PCIE_RC_LCSR_Common_Clock_Configuration (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Common_Clock_Configuration. */

/*! @brief Read current value of the PCIE_RC_LCSR_Common_Clock_Configuration field. */
#define BR_PCIE_RC_LCSR_Common_Clock_Configuration(x) (HW_PCIE_RC_LCSR(x).B.Common_Clock_Configuration)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Common_Clock_Configuration. */
#define BF_PCIE_RC_LCSR_Common_Clock_Configuration(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Common_Clock_Configuration) & BM_PCIE_RC_LCSR_Common_Clock_Configuration)

/*! @brief Set the Common_Clock_Configuration field to a new value. */
#define BW_PCIE_RC_LCSR_Common_Clock_Configuration(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Common_Clock_Configuration) | BF_PCIE_RC_LCSR_Common_Clock_Configuration(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Extended_Synch[7] (RW)
 *
 * Extended Synch
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Extended_Synch (7U) /*!< Bit position for PCIE_RC_LCSR_Extended_Synch. */
#define BM_PCIE_RC_LCSR_Extended_Synch (0x00000080U) /*!< Bit mask for PCIE_RC_LCSR_Extended_Synch. */
#define BS_PCIE_RC_LCSR_Extended_Synch (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Extended_Synch. */

/*! @brief Read current value of the PCIE_RC_LCSR_Extended_Synch field. */
#define BR_PCIE_RC_LCSR_Extended_Synch(x) (HW_PCIE_RC_LCSR(x).B.Extended_Synch)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Extended_Synch. */
#define BF_PCIE_RC_LCSR_Extended_Synch(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Extended_Synch) & BM_PCIE_RC_LCSR_Extended_Synch)

/*! @brief Set the Extended_Synch field to a new value. */
#define BW_PCIE_RC_LCSR_Extended_Synch(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Extended_Synch) | BF_PCIE_RC_LCSR_Extended_Synch(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Enable_Clock_Power_Management[8] (RW)
 *
 * Enable Clock Power Management Hardwired to 0 if Clock Power Management is
 * disabled in the Link Capabilities register.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Enable_Clock_Power_Management (8U) /*!< Bit position for PCIE_RC_LCSR_Enable_Clock_Power_Management. */
#define BM_PCIE_RC_LCSR_Enable_Clock_Power_Management (0x00000100U) /*!< Bit mask for PCIE_RC_LCSR_Enable_Clock_Power_Management. */
#define BS_PCIE_RC_LCSR_Enable_Clock_Power_Management (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Enable_Clock_Power_Management. */

/*! @brief Read current value of the PCIE_RC_LCSR_Enable_Clock_Power_Management field. */
#define BR_PCIE_RC_LCSR_Enable_Clock_Power_Management(x) (HW_PCIE_RC_LCSR(x).B.Enable_Clock_Power_Management)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Enable_Clock_Power_Management. */
#define BF_PCIE_RC_LCSR_Enable_Clock_Power_Management(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Enable_Clock_Power_Management) & BM_PCIE_RC_LCSR_Enable_Clock_Power_Management)

/*! @brief Set the Enable_Clock_Power_Management field to a new value. */
#define BW_PCIE_RC_LCSR_Enable_Clock_Power_Management(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Enable_Clock_Power_Management) | BF_PCIE_RC_LCSR_Enable_Clock_Power_Management(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Hardware_Autonomous_Width_Disable[9] (RW)
 *
 * Hardware Autonomous Width Disable Not supported, hardwired to 0.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable (9U) /*!< Bit position for PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable. */
#define BM_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable (0x00000200U) /*!< Bit mask for PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable. */
#define BS_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable. */

/*! @brief Read current value of the PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable field. */
#define BR_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable(x) (HW_PCIE_RC_LCSR(x).B.Hardware_Autonomous_Width_Disable)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable. */
#define BF_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable) & BM_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable)

/*! @brief Set the Hardware_Autonomous_Width_Disable field to a new value. */
#define BW_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable) | BF_PCIE_RC_LCSR_Hardware_Autonomous_Width_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Bandwidth_Management_Interrupt_Enable[10] (RW)
 *
 * Link Bandwidth Management Interrupt Enable When set, this bit enables the
 * generation of an interrupt to indicate that the Link Bandwidth Management Status
 * bit has been set. This bit is not applicable and is reserved for Endpoints,
 * PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable (10U) /*!< Bit position for PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable. */
#define BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable (0x00000400U) /*!< Bit mask for PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable. */
#define BS_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable field. */
#define BR_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable(x) (HW_PCIE_RC_LCSR(x).B.Link_Bandwidth_Management_Interrupt_Enable)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable. */
#define BF_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable) & BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable)

/*! @brief Set the Link_Bandwidth_Management_Interrupt_Enable field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable) | BF_PCIE_RC_LCSR_Link_Bandwidth_Management_Interrupt_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Autonomous_Bandwidth_Interrupt_Enable[11] (RW)
 *
 * Link Autonomous Bandwidth Interrupt Enable When set, this bit enables the
 * generation of an interrupt to indicate that the Link Autonomous Bandwidth Status
 * bit has been set. This bit is not applicable and is reserved for Endpoints,
 * PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable (11U) /*!< Bit position for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable. */
#define BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable (0x00000800U) /*!< Bit mask for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable. */
#define BS_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable field. */
#define BR_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable(x) (HW_PCIE_RC_LCSR(x).B.Link_Autonomous_Bandwidth_Interrupt_Enable)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable. */
#define BF_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable) & BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable)

/*! @brief Set the Link_Autonomous_Bandwidth_Interrupt_Enable field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable) | BF_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Interrupt_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Speed[19:16] (RW)
 *
 * Link Speed Indicates the negotiated Link speed. The encoding is the binary
 * value of the bit location in the Supported Link Speeds Vector (in the Link
 * Capabilities 2 register) that corresponds to the current Link speed. Possible
 * values are:
 *
 * Values:
 * - 0001 - Gen1 2.5 GT/s
 * - 0010 - Gen2 5.0 GT/s
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Speed (16U)   /*!< Bit position for PCIE_RC_LCSR_Link_Speed. */
#define BM_PCIE_RC_LCSR_Link_Speed (0x000F0000U) /*!< Bit mask for PCIE_RC_LCSR_Link_Speed. */
#define BS_PCIE_RC_LCSR_Link_Speed (4U)    /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Speed. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Speed field. */
#define BR_PCIE_RC_LCSR_Link_Speed(x) (HW_PCIE_RC_LCSR(x).B.Link_Speed)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Speed. */
#define BF_PCIE_RC_LCSR_Link_Speed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Speed) & BM_PCIE_RC_LCSR_Link_Speed)

/*! @brief Set the Link_Speed field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Speed(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Speed) | BF_PCIE_RC_LCSR_Link_Speed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Negotiated_Link_Width[25:20] (RW)
 *
 * Negotiated Link Width Set automatically by hardware after Link
 * initialization. The value is undefined when link is not up.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Negotiated_Link_Width (20U) /*!< Bit position for PCIE_RC_LCSR_Negotiated_Link_Width. */
#define BM_PCIE_RC_LCSR_Negotiated_Link_Width (0x03F00000U) /*!< Bit mask for PCIE_RC_LCSR_Negotiated_Link_Width. */
#define BS_PCIE_RC_LCSR_Negotiated_Link_Width (6U) /*!< Bit field size in bits for PCIE_RC_LCSR_Negotiated_Link_Width. */

/*! @brief Read current value of the PCIE_RC_LCSR_Negotiated_Link_Width field. */
#define BR_PCIE_RC_LCSR_Negotiated_Link_Width(x) (HW_PCIE_RC_LCSR(x).B.Negotiated_Link_Width)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Negotiated_Link_Width. */
#define BF_PCIE_RC_LCSR_Negotiated_Link_Width(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Negotiated_Link_Width) & BM_PCIE_RC_LCSR_Negotiated_Link_Width)

/*! @brief Set the Negotiated_Link_Width field to a new value. */
#define BW_PCIE_RC_LCSR_Negotiated_Link_Width(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Negotiated_Link_Width) | BF_PCIE_RC_LCSR_Negotiated_Link_Width(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Training[27] (RW)
 *
 * Link Training This bit is not applicable and is reserved for Endpoints, PCI
 * Express to PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Training (27U) /*!< Bit position for PCIE_RC_LCSR_Link_Training. */
#define BM_PCIE_RC_LCSR_Link_Training (0x08000000U) /*!< Bit mask for PCIE_RC_LCSR_Link_Training. */
#define BS_PCIE_RC_LCSR_Link_Training (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Training. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Training field. */
#define BR_PCIE_RC_LCSR_Link_Training(x) (HW_PCIE_RC_LCSR(x).B.Link_Training)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Training. */
#define BF_PCIE_RC_LCSR_Link_Training(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Training) & BM_PCIE_RC_LCSR_Link_Training)

/*! @brief Set the Link_Training field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Training(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Training) | BF_PCIE_RC_LCSR_Link_Training(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Slot_Clock_Configuration[28] (RW)
 *
 * Slot Clock Configuration Indicates that the component uses the same physical
 * reference clock that the platform provides on the connector. The default value
 * is the value you select during hardware configuration, writable through the
 * DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Slot_Clock_Configuration (28U) /*!< Bit position for PCIE_RC_LCSR_Slot_Clock_Configuration. */
#define BM_PCIE_RC_LCSR_Slot_Clock_Configuration (0x10000000U) /*!< Bit mask for PCIE_RC_LCSR_Slot_Clock_Configuration. */
#define BS_PCIE_RC_LCSR_Slot_Clock_Configuration (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Slot_Clock_Configuration. */

/*! @brief Read current value of the PCIE_RC_LCSR_Slot_Clock_Configuration field. */
#define BR_PCIE_RC_LCSR_Slot_Clock_Configuration(x) (HW_PCIE_RC_LCSR(x).B.Slot_Clock_Configuration)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Slot_Clock_Configuration. */
#define BF_PCIE_RC_LCSR_Slot_Clock_Configuration(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Slot_Clock_Configuration) & BM_PCIE_RC_LCSR_Slot_Clock_Configuration)

/*! @brief Set the Slot_Clock_Configuration field to a new value. */
#define BW_PCIE_RC_LCSR_Slot_Clock_Configuration(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Slot_Clock_Configuration) | BF_PCIE_RC_LCSR_Slot_Clock_Configuration(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Data_Link_Layer_Active[29] (RW)
 *
 * Data Link Layer Active This bit must be implemented if the corresponding Data
 * Link Layer Link Active Reporting capability bit is implemented. Otherwise,
 * this bit must be hardwired to 0b.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Data_Link_Layer_Active (29U) /*!< Bit position for PCIE_RC_LCSR_Data_Link_Layer_Active. */
#define BM_PCIE_RC_LCSR_Data_Link_Layer_Active (0x20000000U) /*!< Bit mask for PCIE_RC_LCSR_Data_Link_Layer_Active. */
#define BS_PCIE_RC_LCSR_Data_Link_Layer_Active (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Data_Link_Layer_Active. */

/*! @brief Read current value of the PCIE_RC_LCSR_Data_Link_Layer_Active field. */
#define BR_PCIE_RC_LCSR_Data_Link_Layer_Active(x) (HW_PCIE_RC_LCSR(x).B.Data_Link_Layer_Active)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Data_Link_Layer_Active. */
#define BF_PCIE_RC_LCSR_Data_Link_Layer_Active(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Data_Link_Layer_Active) & BM_PCIE_RC_LCSR_Data_Link_Layer_Active)

/*! @brief Set the Data_Link_Layer_Active field to a new value. */
#define BW_PCIE_RC_LCSR_Data_Link_Layer_Active(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Data_Link_Layer_Active) | BF_PCIE_RC_LCSR_Data_Link_Layer_Active(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Bandwidth_Management_Status[30] (RW)
 *
 * Link Bandwidth Management Status This bit is set by hardware to indicate that
 * either of the following has occurred without the Port transitioning through
 * DL_Down status: •A Link retraining has completed following a write of 1b to
 * the Retrain Link bit. •Hardware has changed Link speed or width to attempt to
 * correct unreliable Link operation, either through an LTSSM timeout or a
 * higher level process. This bit must be set if the Physical Layer reports a speed or
 * width change was initiated by the Downstream component that was not indicated
 * as an autonomous change. : This bit is set following any write of 1b to the
 * Retrain Link bit, including when the Link is in the process of retraining for
 * some other reason. This bit is not applicable and is reserved for Endpoints,
 * PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Bandwidth_Management_Status (30U) /*!< Bit position for PCIE_RC_LCSR_Link_Bandwidth_Management_Status. */
#define BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Status (0x40000000U) /*!< Bit mask for PCIE_RC_LCSR_Link_Bandwidth_Management_Status. */
#define BS_PCIE_RC_LCSR_Link_Bandwidth_Management_Status (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Bandwidth_Management_Status. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Bandwidth_Management_Status field. */
#define BR_PCIE_RC_LCSR_Link_Bandwidth_Management_Status(x) (HW_PCIE_RC_LCSR(x).B.Link_Bandwidth_Management_Status)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Bandwidth_Management_Status. */
#define BF_PCIE_RC_LCSR_Link_Bandwidth_Management_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Bandwidth_Management_Status) & BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Status)

/*! @brief Set the Link_Bandwidth_Management_Status field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Bandwidth_Management_Status(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Bandwidth_Management_Status) | BF_PCIE_RC_LCSR_Link_Bandwidth_Management_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR, field Link_Autonomous_Bandwidth_Status[31] (RW)
 *
 * Link Autonomous Bandwidth Status This bit is set by hardware to indicate that
 * hardware has autonomously changed Link speed or width, without the Port
 * transitioning through DL_Down status, for reasons other than to attempt to correct
 * unreliable Link operation. This bit must be set if the Physical Layer reports
 * a speed or a width change was initiated by the Downstream component that was
 * indicated as an autonomous change. This bit is not applicable and is reserved
 * for Endpoints, PCI Express-to-PCI/PCI-X bridges.
 */
/*@{*/
#define BP_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status (31U) /*!< Bit position for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status. */
#define BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status (0x80000000U) /*!< Bit mask for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status. */
#define BS_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status (1U) /*!< Bit field size in bits for PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status. */

/*! @brief Read current value of the PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status field. */
#define BR_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status(x) (HW_PCIE_RC_LCSR(x).B.Link_Autonomous_Bandwidth_Status)

/*! @brief Format value for bitfield PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status. */
#define BF_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status) & BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status)

/*! @brief Set the Link_Autonomous_Bandwidth_Status field to a new value. */
#define BW_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status(x, v) (HW_PCIE_RC_LCSR_WR(x, (HW_PCIE_RC_LCSR_RD(x) & ~BM_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status) | BF_PCIE_RC_LCSR_Link_Autonomous_Bandwidth_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_SCR - Slot Capabilities Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_SCR - Slot Capabilities Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This section applies only to Downstream Ports (for example, RC. Offset:
 * `CFG_PCIE_CAP + 0x14
 */
typedef union _hw_pcie_rc_scr
{
    uint32_t U;
    struct _hw_pcie_rc_scr_bitfields
    {
        uint32_t Attention_Indicator_Present : 1; /*!< [0]  */
        uint32_t Power_Controller_Present_0 : 1; /*!< [1]  */
        uint32_t MRL_Sensor_Present : 1; /*!< [2]  */
        uint32_t Attention_Indicator_Present_1 : 1; /*!< [3]  */
        uint32_t Power_Indicator_Present : 1; /*!< [4]  */
        uint32_t Hot_Plug_Surprise : 1; /*!< [5]  */
        uint32_t Hot_Plug_Capable : 1; /*!< [6]  */
        uint32_t Slot_Power_Limit_Value : 8; /*!< [14:7]  */
        uint32_t Slot_Power_Limit_Scale : 2; /*!< [16:15]  */
        uint32_t Electromechanical_Interlock_Present : 1; /*!< [17]  */
        uint32_t No_Command_Complete_Support : 1; /*!< [18]  */
        uint32_t Physical_Slot_Number : 13; /*!< [31:19]  */
    } B;
} hw_pcie_rc_scr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_SCR register
 */
/*@{*/
#define HW_PCIE_RC_SCR_ADDR(x)   ((uintptr_t)(x) + 0x84U)

#define HW_PCIE_RC_SCR(x)        (*(__I hw_pcie_rc_scr_t *) HW_PCIE_RC_SCR_ADDR(x))
#define HW_PCIE_RC_SCR_RD(x)     (HW_PCIE_RC_SCR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_SCR bitfields
 */

/*!
 * @name Register PCIE_RC_SCR, field Attention_Indicator_Present[0] (RO)
 *
 * Attention Indicator Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Attention_Indicator_Present (0U) /*!< Bit position for PCIE_RC_SCR_Attention_Indicator_Present. */
#define BM_PCIE_RC_SCR_Attention_Indicator_Present (0x00000001U) /*!< Bit mask for PCIE_RC_SCR_Attention_Indicator_Present. */
#define BS_PCIE_RC_SCR_Attention_Indicator_Present (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Attention_Indicator_Present. */

/*! @brief Read current value of the PCIE_RC_SCR_Attention_Indicator_Present field. */
#define BR_PCIE_RC_SCR_Attention_Indicator_Present(x) (HW_PCIE_RC_SCR(x).B.Attention_Indicator_Present)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Power_Controller_Present_0[1] (RO)
 *
 * Power Controller Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Power_Controller_Present_0 (1U) /*!< Bit position for PCIE_RC_SCR_Power_Controller_Present_0. */
#define BM_PCIE_RC_SCR_Power_Controller_Present_0 (0x00000002U) /*!< Bit mask for PCIE_RC_SCR_Power_Controller_Present_0. */
#define BS_PCIE_RC_SCR_Power_Controller_Present_0 (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Power_Controller_Present_0. */

/*! @brief Read current value of the PCIE_RC_SCR_Power_Controller_Present_0 field. */
#define BR_PCIE_RC_SCR_Power_Controller_Present_0(x) (HW_PCIE_RC_SCR(x).B.Power_Controller_Present_0)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field MRL_Sensor_Present[2] (RO)
 *
 * MRL Sensor Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_MRL_Sensor_Present (2U) /*!< Bit position for PCIE_RC_SCR_MRL_Sensor_Present. */
#define BM_PCIE_RC_SCR_MRL_Sensor_Present (0x00000004U) /*!< Bit mask for PCIE_RC_SCR_MRL_Sensor_Present. */
#define BS_PCIE_RC_SCR_MRL_Sensor_Present (1U) /*!< Bit field size in bits for PCIE_RC_SCR_MRL_Sensor_Present. */

/*! @brief Read current value of the PCIE_RC_SCR_MRL_Sensor_Present field. */
#define BR_PCIE_RC_SCR_MRL_Sensor_Present(x) (HW_PCIE_RC_SCR(x).B.MRL_Sensor_Present)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Attention_Indicator_Present_1[3] (RO)
 *
 * Attention Indicator Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Attention_Indicator_Present_1 (3U) /*!< Bit position for PCIE_RC_SCR_Attention_Indicator_Present_1. */
#define BM_PCIE_RC_SCR_Attention_Indicator_Present_1 (0x00000008U) /*!< Bit mask for PCIE_RC_SCR_Attention_Indicator_Present_1. */
#define BS_PCIE_RC_SCR_Attention_Indicator_Present_1 (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Attention_Indicator_Present_1. */

/*! @brief Read current value of the PCIE_RC_SCR_Attention_Indicator_Present_1 field. */
#define BR_PCIE_RC_SCR_Attention_Indicator_Present_1(x) (HW_PCIE_RC_SCR(x).B.Attention_Indicator_Present_1)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Power_Indicator_Present[4] (RO)
 *
 * Power Indicator Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Power_Indicator_Present (4U) /*!< Bit position for PCIE_RC_SCR_Power_Indicator_Present. */
#define BM_PCIE_RC_SCR_Power_Indicator_Present (0x00000010U) /*!< Bit mask for PCIE_RC_SCR_Power_Indicator_Present. */
#define BS_PCIE_RC_SCR_Power_Indicator_Present (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Power_Indicator_Present. */

/*! @brief Read current value of the PCIE_RC_SCR_Power_Indicator_Present field. */
#define BR_PCIE_RC_SCR_Power_Indicator_Present(x) (HW_PCIE_RC_SCR(x).B.Power_Indicator_Present)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Hot_Plug_Surprise[5] (RO)
 *
 * Hot-Plug Surprise, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Hot_Plug_Surprise (5U) /*!< Bit position for PCIE_RC_SCR_Hot_Plug_Surprise. */
#define BM_PCIE_RC_SCR_Hot_Plug_Surprise (0x00000020U) /*!< Bit mask for PCIE_RC_SCR_Hot_Plug_Surprise. */
#define BS_PCIE_RC_SCR_Hot_Plug_Surprise (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Hot_Plug_Surprise. */

/*! @brief Read current value of the PCIE_RC_SCR_Hot_Plug_Surprise field. */
#define BR_PCIE_RC_SCR_Hot_Plug_Surprise(x) (HW_PCIE_RC_SCR(x).B.Hot_Plug_Surprise)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Hot_Plug_Capable[6] (RO)
 *
 * Hot-Plug Capable, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Hot_Plug_Capable (6U) /*!< Bit position for PCIE_RC_SCR_Hot_Plug_Capable. */
#define BM_PCIE_RC_SCR_Hot_Plug_Capable (0x00000040U) /*!< Bit mask for PCIE_RC_SCR_Hot_Plug_Capable. */
#define BS_PCIE_RC_SCR_Hot_Plug_Capable (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Hot_Plug_Capable. */

/*! @brief Read current value of the PCIE_RC_SCR_Hot_Plug_Capable field. */
#define BR_PCIE_RC_SCR_Hot_Plug_Capable(x) (HW_PCIE_RC_SCR(x).B.Hot_Plug_Capable)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Slot_Power_Limit_Value[14:7] (RO)
 *
 * Slot Power Limit Value, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Slot_Power_Limit_Value (7U) /*!< Bit position for PCIE_RC_SCR_Slot_Power_Limit_Value. */
#define BM_PCIE_RC_SCR_Slot_Power_Limit_Value (0x00007F80U) /*!< Bit mask for PCIE_RC_SCR_Slot_Power_Limit_Value. */
#define BS_PCIE_RC_SCR_Slot_Power_Limit_Value (8U) /*!< Bit field size in bits for PCIE_RC_SCR_Slot_Power_Limit_Value. */

/*! @brief Read current value of the PCIE_RC_SCR_Slot_Power_Limit_Value field. */
#define BR_PCIE_RC_SCR_Slot_Power_Limit_Value(x) (HW_PCIE_RC_SCR(x).B.Slot_Power_Limit_Value)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Slot_Power_Limit_Scale[16:15] (RO)
 *
 * Slot Power Limit Scale, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Slot_Power_Limit_Scale (15U) /*!< Bit position for PCIE_RC_SCR_Slot_Power_Limit_Scale. */
#define BM_PCIE_RC_SCR_Slot_Power_Limit_Scale (0x00018000U) /*!< Bit mask for PCIE_RC_SCR_Slot_Power_Limit_Scale. */
#define BS_PCIE_RC_SCR_Slot_Power_Limit_Scale (2U) /*!< Bit field size in bits for PCIE_RC_SCR_Slot_Power_Limit_Scale. */

/*! @brief Read current value of the PCIE_RC_SCR_Slot_Power_Limit_Scale field. */
#define BR_PCIE_RC_SCR_Slot_Power_Limit_Scale(x) (HW_PCIE_RC_SCR(x).B.Slot_Power_Limit_Scale)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Electromechanical_Interlock_Present[17] (RO)
 *
 * Electromechanical Interlock Present, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Electromechanical_Interlock_Present (17U) /*!< Bit position for PCIE_RC_SCR_Electromechanical_Interlock_Present. */
#define BM_PCIE_RC_SCR_Electromechanical_Interlock_Present (0x00020000U) /*!< Bit mask for PCIE_RC_SCR_Electromechanical_Interlock_Present. */
#define BS_PCIE_RC_SCR_Electromechanical_Interlock_Present (1U) /*!< Bit field size in bits for PCIE_RC_SCR_Electromechanical_Interlock_Present. */

/*! @brief Read current value of the PCIE_RC_SCR_Electromechanical_Interlock_Present field. */
#define BR_PCIE_RC_SCR_Electromechanical_Interlock_Present(x) (HW_PCIE_RC_SCR(x).B.Electromechanical_Interlock_Present)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field No_Command_Complete_Support[18] (RO)
 *
 * No Command Complete Support, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_No_Command_Complete_Support (18U) /*!< Bit position for PCIE_RC_SCR_No_Command_Complete_Support. */
#define BM_PCIE_RC_SCR_No_Command_Complete_Support (0x00040000U) /*!< Bit mask for PCIE_RC_SCR_No_Command_Complete_Support. */
#define BS_PCIE_RC_SCR_No_Command_Complete_Support (1U) /*!< Bit field size in bits for PCIE_RC_SCR_No_Command_Complete_Support. */

/*! @brief Read current value of the PCIE_RC_SCR_No_Command_Complete_Support field. */
#define BR_PCIE_RC_SCR_No_Command_Complete_Support(x) (HW_PCIE_RC_SCR(x).B.No_Command_Complete_Support)
/*@}*/

/*!
 * @name Register PCIE_RC_SCR, field Physical_Slot_Number[31:19] (RO)
 *
 * Physical Slot Number, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_SCR_Physical_Slot_Number (19U) /*!< Bit position for PCIE_RC_SCR_Physical_Slot_Number. */
#define BM_PCIE_RC_SCR_Physical_Slot_Number (0xFFF80000U) /*!< Bit mask for PCIE_RC_SCR_Physical_Slot_Number. */
#define BS_PCIE_RC_SCR_Physical_Slot_Number (13U) /*!< Bit field size in bits for PCIE_RC_SCR_Physical_Slot_Number. */

/*! @brief Read current value of the PCIE_RC_SCR_Physical_Slot_Number field. */
#define BR_PCIE_RC_SCR_Physical_Slot_Number(x) (HW_PCIE_RC_SCR(x).B.Physical_Slot_Number)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_SCSR - Slot Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_SCSR - Slot Control and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This section applies only to Downstream Ports (for example, RC. Offset:
 * `CFG_PCIE_CAP + 0x18
 */
typedef union _hw_pcie_rc_scsr
{
    uint32_t U;
    struct _hw_pcie_rc_scsr_bitfields
    {
        uint32_t Attention_Button_Pressed_Enable : 1; /*!< [0]  */
        uint32_t Power_Fault_Detected_Enable : 1; /*!< [1]  */
        uint32_t MRL_Sensor_Changed_Enable : 1; /*!< [2]  */
        uint32_t Presence_Detect_Changed_Enable : 1; /*!< [3]  */
        uint32_t Command_Completed_Interrupt_Enable : 1; /*!< [4]  */
        uint32_t Hot_Plug_Interrupt_Enable : 1; /*!< [5]  */
        uint32_t Attention_Indicator_Control : 2; /*!< [7:6]  */
        uint32_t Power_Indicator_Control : 2; /*!< [9:8]  */
        uint32_t Power_Controller_Control : 1; /*!< [10]  */
        uint32_t Electromechanical_Interlock_Control : 1; /*!< [11]  */
        uint32_t Data_Link_Layer_State_Changed_Enable : 1; /*!< [12]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t Attention_Button_Pressed : 1; /*!< [16]  */
        uint32_t Power_Fault_Detected : 1; /*!< [17]  */
        uint32_t MRL_Sensor_Changed : 1; /*!< [18]  */
        uint32_t Presence_Detect_Changed : 1; /*!< [19]  */
        uint32_t Command_Completed : 1; /*!< [20]  */
        uint32_t MRL_Sensor_State : 1; /*!< [21]  */
        uint32_t Presence_Detect_State : 1; /*!< [22]  */
        uint32_t Electromechanical_Interlock_Status : 1; /*!< [23]  */
        uint32_t Data_Link_Layer_State_Changed : 1; /*!< [24]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_pcie_rc_scsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_SCSR register
 */
/*@{*/
#define HW_PCIE_RC_SCSR_ADDR(x)  ((uintptr_t)(x) + 0x88U)

#define HW_PCIE_RC_SCSR(x)       (*(__IO hw_pcie_rc_scsr_t *) HW_PCIE_RC_SCSR_ADDR(x))
#define HW_PCIE_RC_SCSR_RD(x)    (HW_PCIE_RC_SCSR(x).U)
#define HW_PCIE_RC_SCSR_WR(x, v) (HW_PCIE_RC_SCSR(x).U = (v))
#define HW_PCIE_RC_SCSR_SET(x, v) (HW_PCIE_RC_SCSR_WR(x, HW_PCIE_RC_SCSR_RD(x) |  (v)))
#define HW_PCIE_RC_SCSR_CLR(x, v) (HW_PCIE_RC_SCSR_WR(x, HW_PCIE_RC_SCSR_RD(x) & ~(v)))
#define HW_PCIE_RC_SCSR_TOG(x, v) (HW_PCIE_RC_SCSR_WR(x, HW_PCIE_RC_SCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_SCSR bitfields
 */

/*!
 * @name Register PCIE_RC_SCSR, field Attention_Button_Pressed_Enable[0] (RW)
 *
 * Attention Button Pressed Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Attention_Button_Pressed_Enable (0U) /*!< Bit position for PCIE_RC_SCSR_Attention_Button_Pressed_Enable. */
#define BM_PCIE_RC_SCSR_Attention_Button_Pressed_Enable (0x00000001U) /*!< Bit mask for PCIE_RC_SCSR_Attention_Button_Pressed_Enable. */
#define BS_PCIE_RC_SCSR_Attention_Button_Pressed_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Attention_Button_Pressed_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Attention_Button_Pressed_Enable field. */
#define BR_PCIE_RC_SCSR_Attention_Button_Pressed_Enable(x) (HW_PCIE_RC_SCSR(x).B.Attention_Button_Pressed_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Attention_Button_Pressed_Enable. */
#define BF_PCIE_RC_SCSR_Attention_Button_Pressed_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Attention_Button_Pressed_Enable) & BM_PCIE_RC_SCSR_Attention_Button_Pressed_Enable)

/*! @brief Set the Attention_Button_Pressed_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Attention_Button_Pressed_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Attention_Button_Pressed_Enable) | BF_PCIE_RC_SCSR_Attention_Button_Pressed_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Power_Fault_Detected_Enable[1] (RW)
 *
 * Power Fault Detected Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Power_Fault_Detected_Enable (1U) /*!< Bit position for PCIE_RC_SCSR_Power_Fault_Detected_Enable. */
#define BM_PCIE_RC_SCSR_Power_Fault_Detected_Enable (0x00000002U) /*!< Bit mask for PCIE_RC_SCSR_Power_Fault_Detected_Enable. */
#define BS_PCIE_RC_SCSR_Power_Fault_Detected_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Power_Fault_Detected_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Power_Fault_Detected_Enable field. */
#define BR_PCIE_RC_SCSR_Power_Fault_Detected_Enable(x) (HW_PCIE_RC_SCSR(x).B.Power_Fault_Detected_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Power_Fault_Detected_Enable. */
#define BF_PCIE_RC_SCSR_Power_Fault_Detected_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Power_Fault_Detected_Enable) & BM_PCIE_RC_SCSR_Power_Fault_Detected_Enable)

/*! @brief Set the Power_Fault_Detected_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Power_Fault_Detected_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Power_Fault_Detected_Enable) | BF_PCIE_RC_SCSR_Power_Fault_Detected_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field MRL_Sensor_Changed_Enable[2] (RW)
 *
 * MRL Sensor Changed Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable (2U) /*!< Bit position for PCIE_RC_SCSR_MRL_Sensor_Changed_Enable. */
#define BM_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable (0x00000004U) /*!< Bit mask for PCIE_RC_SCSR_MRL_Sensor_Changed_Enable. */
#define BS_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_MRL_Sensor_Changed_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_MRL_Sensor_Changed_Enable field. */
#define BR_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable(x) (HW_PCIE_RC_SCSR(x).B.MRL_Sensor_Changed_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_MRL_Sensor_Changed_Enable. */
#define BF_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable) & BM_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable)

/*! @brief Set the MRL_Sensor_Changed_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable) | BF_PCIE_RC_SCSR_MRL_Sensor_Changed_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Presence_Detect_Changed_Enable[3] (RW)
 *
 * Presence Detect Changed Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Presence_Detect_Changed_Enable (3U) /*!< Bit position for PCIE_RC_SCSR_Presence_Detect_Changed_Enable. */
#define BM_PCIE_RC_SCSR_Presence_Detect_Changed_Enable (0x00000008U) /*!< Bit mask for PCIE_RC_SCSR_Presence_Detect_Changed_Enable. */
#define BS_PCIE_RC_SCSR_Presence_Detect_Changed_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Presence_Detect_Changed_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Presence_Detect_Changed_Enable field. */
#define BR_PCIE_RC_SCSR_Presence_Detect_Changed_Enable(x) (HW_PCIE_RC_SCSR(x).B.Presence_Detect_Changed_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Presence_Detect_Changed_Enable. */
#define BF_PCIE_RC_SCSR_Presence_Detect_Changed_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Presence_Detect_Changed_Enable) & BM_PCIE_RC_SCSR_Presence_Detect_Changed_Enable)

/*! @brief Set the Presence_Detect_Changed_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Presence_Detect_Changed_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Presence_Detect_Changed_Enable) | BF_PCIE_RC_SCSR_Presence_Detect_Changed_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Command_Completed_Interrupt_Enable[4] (RW)
 *
 * Command Completed Interrupt Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable (4U) /*!< Bit position for PCIE_RC_SCSR_Command_Completed_Interrupt_Enable. */
#define BM_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable (0x00000010U) /*!< Bit mask for PCIE_RC_SCSR_Command_Completed_Interrupt_Enable. */
#define BS_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Command_Completed_Interrupt_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Command_Completed_Interrupt_Enable field. */
#define BR_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable(x) (HW_PCIE_RC_SCSR(x).B.Command_Completed_Interrupt_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Command_Completed_Interrupt_Enable. */
#define BF_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable) & BM_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable)

/*! @brief Set the Command_Completed_Interrupt_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable) | BF_PCIE_RC_SCSR_Command_Completed_Interrupt_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Hot_Plug_Interrupt_Enable[5] (RW)
 *
 * Hot-Plug Interrupt Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable (5U) /*!< Bit position for PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable. */
#define BM_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable (0x00000020U) /*!< Bit mask for PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable. */
#define BS_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable field. */
#define BR_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable(x) (HW_PCIE_RC_SCSR(x).B.Hot_Plug_Interrupt_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable. */
#define BF_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable) & BM_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable)

/*! @brief Set the Hot_Plug_Interrupt_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable) | BF_PCIE_RC_SCSR_Hot_Plug_Interrupt_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Attention_Indicator_Control[7:6] (RW)
 *
 * Attention Indicator Control
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Attention_Indicator_Control (6U) /*!< Bit position for PCIE_RC_SCSR_Attention_Indicator_Control. */
#define BM_PCIE_RC_SCSR_Attention_Indicator_Control (0x000000C0U) /*!< Bit mask for PCIE_RC_SCSR_Attention_Indicator_Control. */
#define BS_PCIE_RC_SCSR_Attention_Indicator_Control (2U) /*!< Bit field size in bits for PCIE_RC_SCSR_Attention_Indicator_Control. */

/*! @brief Read current value of the PCIE_RC_SCSR_Attention_Indicator_Control field. */
#define BR_PCIE_RC_SCSR_Attention_Indicator_Control(x) (HW_PCIE_RC_SCSR(x).B.Attention_Indicator_Control)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Attention_Indicator_Control. */
#define BF_PCIE_RC_SCSR_Attention_Indicator_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Attention_Indicator_Control) & BM_PCIE_RC_SCSR_Attention_Indicator_Control)

/*! @brief Set the Attention_Indicator_Control field to a new value. */
#define BW_PCIE_RC_SCSR_Attention_Indicator_Control(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Attention_Indicator_Control) | BF_PCIE_RC_SCSR_Attention_Indicator_Control(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Power_Indicator_Control[9:8] (RW)
 *
 * Power Indicator Control
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Power_Indicator_Control (8U) /*!< Bit position for PCIE_RC_SCSR_Power_Indicator_Control. */
#define BM_PCIE_RC_SCSR_Power_Indicator_Control (0x00000300U) /*!< Bit mask for PCIE_RC_SCSR_Power_Indicator_Control. */
#define BS_PCIE_RC_SCSR_Power_Indicator_Control (2U) /*!< Bit field size in bits for PCIE_RC_SCSR_Power_Indicator_Control. */

/*! @brief Read current value of the PCIE_RC_SCSR_Power_Indicator_Control field. */
#define BR_PCIE_RC_SCSR_Power_Indicator_Control(x) (HW_PCIE_RC_SCSR(x).B.Power_Indicator_Control)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Power_Indicator_Control. */
#define BF_PCIE_RC_SCSR_Power_Indicator_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Power_Indicator_Control) & BM_PCIE_RC_SCSR_Power_Indicator_Control)

/*! @brief Set the Power_Indicator_Control field to a new value. */
#define BW_PCIE_RC_SCSR_Power_Indicator_Control(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Power_Indicator_Control) | BF_PCIE_RC_SCSR_Power_Indicator_Control(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Power_Controller_Control[10] (RW)
 *
 * Power Controller Control
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Power_Controller_Control (10U) /*!< Bit position for PCIE_RC_SCSR_Power_Controller_Control. */
#define BM_PCIE_RC_SCSR_Power_Controller_Control (0x00000400U) /*!< Bit mask for PCIE_RC_SCSR_Power_Controller_Control. */
#define BS_PCIE_RC_SCSR_Power_Controller_Control (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Power_Controller_Control. */

/*! @brief Read current value of the PCIE_RC_SCSR_Power_Controller_Control field. */
#define BR_PCIE_RC_SCSR_Power_Controller_Control(x) (HW_PCIE_RC_SCSR(x).B.Power_Controller_Control)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Power_Controller_Control. */
#define BF_PCIE_RC_SCSR_Power_Controller_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Power_Controller_Control) & BM_PCIE_RC_SCSR_Power_Controller_Control)

/*! @brief Set the Power_Controller_Control field to a new value. */
#define BW_PCIE_RC_SCSR_Power_Controller_Control(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Power_Controller_Control) | BF_PCIE_RC_SCSR_Power_Controller_Control(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Electromechanical_Interlock_Control[11] (RW)
 *
 * Electromechanical Interlock Control
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Electromechanical_Interlock_Control (11U) /*!< Bit position for PCIE_RC_SCSR_Electromechanical_Interlock_Control. */
#define BM_PCIE_RC_SCSR_Electromechanical_Interlock_Control (0x00000800U) /*!< Bit mask for PCIE_RC_SCSR_Electromechanical_Interlock_Control. */
#define BS_PCIE_RC_SCSR_Electromechanical_Interlock_Control (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Electromechanical_Interlock_Control. */

/*! @brief Read current value of the PCIE_RC_SCSR_Electromechanical_Interlock_Control field. */
#define BR_PCIE_RC_SCSR_Electromechanical_Interlock_Control(x) (HW_PCIE_RC_SCSR(x).B.Electromechanical_Interlock_Control)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Electromechanical_Interlock_Control. */
#define BF_PCIE_RC_SCSR_Electromechanical_Interlock_Control(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Electromechanical_Interlock_Control) & BM_PCIE_RC_SCSR_Electromechanical_Interlock_Control)

/*! @brief Set the Electromechanical_Interlock_Control field to a new value. */
#define BW_PCIE_RC_SCSR_Electromechanical_Interlock_Control(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Electromechanical_Interlock_Control) | BF_PCIE_RC_SCSR_Electromechanical_Interlock_Control(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Data_Link_Layer_State_Changed_Enable[12] (RW)
 *
 * Data Link Layer State Changed Enable
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable (12U) /*!< Bit position for PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable. */
#define BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable (0x00001000U) /*!< Bit mask for PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable. */
#define BS_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable. */

/*! @brief Read current value of the PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable field. */
#define BR_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable(x) (HW_PCIE_RC_SCSR(x).B.Data_Link_Layer_State_Changed_Enable)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable. */
#define BF_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable) & BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable)

/*! @brief Set the Data_Link_Layer_State_Changed_Enable field to a new value. */
#define BW_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable) | BF_PCIE_RC_SCSR_Data_Link_Layer_State_Changed_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Attention_Button_Pressed[16] (RW)
 *
 * Attention Button Pressed
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Attention_Button_Pressed (16U) /*!< Bit position for PCIE_RC_SCSR_Attention_Button_Pressed. */
#define BM_PCIE_RC_SCSR_Attention_Button_Pressed (0x00010000U) /*!< Bit mask for PCIE_RC_SCSR_Attention_Button_Pressed. */
#define BS_PCIE_RC_SCSR_Attention_Button_Pressed (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Attention_Button_Pressed. */

/*! @brief Read current value of the PCIE_RC_SCSR_Attention_Button_Pressed field. */
#define BR_PCIE_RC_SCSR_Attention_Button_Pressed(x) (HW_PCIE_RC_SCSR(x).B.Attention_Button_Pressed)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Attention_Button_Pressed. */
#define BF_PCIE_RC_SCSR_Attention_Button_Pressed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Attention_Button_Pressed) & BM_PCIE_RC_SCSR_Attention_Button_Pressed)

/*! @brief Set the Attention_Button_Pressed field to a new value. */
#define BW_PCIE_RC_SCSR_Attention_Button_Pressed(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Attention_Button_Pressed) | BF_PCIE_RC_SCSR_Attention_Button_Pressed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Power_Fault_Detected[17] (RW)
 *
 * Power Fault Detected
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Power_Fault_Detected (17U) /*!< Bit position for PCIE_RC_SCSR_Power_Fault_Detected. */
#define BM_PCIE_RC_SCSR_Power_Fault_Detected (0x00020000U) /*!< Bit mask for PCIE_RC_SCSR_Power_Fault_Detected. */
#define BS_PCIE_RC_SCSR_Power_Fault_Detected (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Power_Fault_Detected. */

/*! @brief Read current value of the PCIE_RC_SCSR_Power_Fault_Detected field. */
#define BR_PCIE_RC_SCSR_Power_Fault_Detected(x) (HW_PCIE_RC_SCSR(x).B.Power_Fault_Detected)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Power_Fault_Detected. */
#define BF_PCIE_RC_SCSR_Power_Fault_Detected(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Power_Fault_Detected) & BM_PCIE_RC_SCSR_Power_Fault_Detected)

/*! @brief Set the Power_Fault_Detected field to a new value. */
#define BW_PCIE_RC_SCSR_Power_Fault_Detected(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Power_Fault_Detected) | BF_PCIE_RC_SCSR_Power_Fault_Detected(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field MRL_Sensor_Changed[18] (RW)
 *
 * MRL Sensor Changed
 */
/*@{*/
#define BP_PCIE_RC_SCSR_MRL_Sensor_Changed (18U) /*!< Bit position for PCIE_RC_SCSR_MRL_Sensor_Changed. */
#define BM_PCIE_RC_SCSR_MRL_Sensor_Changed (0x00040000U) /*!< Bit mask for PCIE_RC_SCSR_MRL_Sensor_Changed. */
#define BS_PCIE_RC_SCSR_MRL_Sensor_Changed (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_MRL_Sensor_Changed. */

/*! @brief Read current value of the PCIE_RC_SCSR_MRL_Sensor_Changed field. */
#define BR_PCIE_RC_SCSR_MRL_Sensor_Changed(x) (HW_PCIE_RC_SCSR(x).B.MRL_Sensor_Changed)

/*! @brief Format value for bitfield PCIE_RC_SCSR_MRL_Sensor_Changed. */
#define BF_PCIE_RC_SCSR_MRL_Sensor_Changed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_MRL_Sensor_Changed) & BM_PCIE_RC_SCSR_MRL_Sensor_Changed)

/*! @brief Set the MRL_Sensor_Changed field to a new value. */
#define BW_PCIE_RC_SCSR_MRL_Sensor_Changed(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_MRL_Sensor_Changed) | BF_PCIE_RC_SCSR_MRL_Sensor_Changed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Presence_Detect_Changed[19] (RW)
 *
 * Presence Detect Changed
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Presence_Detect_Changed (19U) /*!< Bit position for PCIE_RC_SCSR_Presence_Detect_Changed. */
#define BM_PCIE_RC_SCSR_Presence_Detect_Changed (0x00080000U) /*!< Bit mask for PCIE_RC_SCSR_Presence_Detect_Changed. */
#define BS_PCIE_RC_SCSR_Presence_Detect_Changed (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Presence_Detect_Changed. */

/*! @brief Read current value of the PCIE_RC_SCSR_Presence_Detect_Changed field. */
#define BR_PCIE_RC_SCSR_Presence_Detect_Changed(x) (HW_PCIE_RC_SCSR(x).B.Presence_Detect_Changed)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Presence_Detect_Changed. */
#define BF_PCIE_RC_SCSR_Presence_Detect_Changed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Presence_Detect_Changed) & BM_PCIE_RC_SCSR_Presence_Detect_Changed)

/*! @brief Set the Presence_Detect_Changed field to a new value. */
#define BW_PCIE_RC_SCSR_Presence_Detect_Changed(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Presence_Detect_Changed) | BF_PCIE_RC_SCSR_Presence_Detect_Changed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Command_Completed[20] (RW)
 *
 * Command Completed
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Command_Completed (20U) /*!< Bit position for PCIE_RC_SCSR_Command_Completed. */
#define BM_PCIE_RC_SCSR_Command_Completed (0x00100000U) /*!< Bit mask for PCIE_RC_SCSR_Command_Completed. */
#define BS_PCIE_RC_SCSR_Command_Completed (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Command_Completed. */

/*! @brief Read current value of the PCIE_RC_SCSR_Command_Completed field. */
#define BR_PCIE_RC_SCSR_Command_Completed(x) (HW_PCIE_RC_SCSR(x).B.Command_Completed)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Command_Completed. */
#define BF_PCIE_RC_SCSR_Command_Completed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Command_Completed) & BM_PCIE_RC_SCSR_Command_Completed)

/*! @brief Set the Command_Completed field to a new value. */
#define BW_PCIE_RC_SCSR_Command_Completed(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Command_Completed) | BF_PCIE_RC_SCSR_Command_Completed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field MRL_Sensor_State[21] (RW)
 *
 * MRL Sensor State
 */
/*@{*/
#define BP_PCIE_RC_SCSR_MRL_Sensor_State (21U) /*!< Bit position for PCIE_RC_SCSR_MRL_Sensor_State. */
#define BM_PCIE_RC_SCSR_MRL_Sensor_State (0x00200000U) /*!< Bit mask for PCIE_RC_SCSR_MRL_Sensor_State. */
#define BS_PCIE_RC_SCSR_MRL_Sensor_State (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_MRL_Sensor_State. */

/*! @brief Read current value of the PCIE_RC_SCSR_MRL_Sensor_State field. */
#define BR_PCIE_RC_SCSR_MRL_Sensor_State(x) (HW_PCIE_RC_SCSR(x).B.MRL_Sensor_State)

/*! @brief Format value for bitfield PCIE_RC_SCSR_MRL_Sensor_State. */
#define BF_PCIE_RC_SCSR_MRL_Sensor_State(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_MRL_Sensor_State) & BM_PCIE_RC_SCSR_MRL_Sensor_State)

/*! @brief Set the MRL_Sensor_State field to a new value. */
#define BW_PCIE_RC_SCSR_MRL_Sensor_State(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_MRL_Sensor_State) | BF_PCIE_RC_SCSR_MRL_Sensor_State(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Presence_Detect_State[22] (RW)
 *
 * Presence Detect State
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Presence_Detect_State (22U) /*!< Bit position for PCIE_RC_SCSR_Presence_Detect_State. */
#define BM_PCIE_RC_SCSR_Presence_Detect_State (0x00400000U) /*!< Bit mask for PCIE_RC_SCSR_Presence_Detect_State. */
#define BS_PCIE_RC_SCSR_Presence_Detect_State (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Presence_Detect_State. */

/*! @brief Read current value of the PCIE_RC_SCSR_Presence_Detect_State field. */
#define BR_PCIE_RC_SCSR_Presence_Detect_State(x) (HW_PCIE_RC_SCSR(x).B.Presence_Detect_State)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Presence_Detect_State. */
#define BF_PCIE_RC_SCSR_Presence_Detect_State(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Presence_Detect_State) & BM_PCIE_RC_SCSR_Presence_Detect_State)

/*! @brief Set the Presence_Detect_State field to a new value. */
#define BW_PCIE_RC_SCSR_Presence_Detect_State(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Presence_Detect_State) | BF_PCIE_RC_SCSR_Presence_Detect_State(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Electromechanical_Interlock_Status[23] (RW)
 *
 * Electromechanical Interlock Status
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Electromechanical_Interlock_Status (23U) /*!< Bit position for PCIE_RC_SCSR_Electromechanical_Interlock_Status. */
#define BM_PCIE_RC_SCSR_Electromechanical_Interlock_Status (0x00800000U) /*!< Bit mask for PCIE_RC_SCSR_Electromechanical_Interlock_Status. */
#define BS_PCIE_RC_SCSR_Electromechanical_Interlock_Status (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Electromechanical_Interlock_Status. */

/*! @brief Read current value of the PCIE_RC_SCSR_Electromechanical_Interlock_Status field. */
#define BR_PCIE_RC_SCSR_Electromechanical_Interlock_Status(x) (HW_PCIE_RC_SCSR(x).B.Electromechanical_Interlock_Status)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Electromechanical_Interlock_Status. */
#define BF_PCIE_RC_SCSR_Electromechanical_Interlock_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Electromechanical_Interlock_Status) & BM_PCIE_RC_SCSR_Electromechanical_Interlock_Status)

/*! @brief Set the Electromechanical_Interlock_Status field to a new value. */
#define BW_PCIE_RC_SCSR_Electromechanical_Interlock_Status(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Electromechanical_Interlock_Status) | BF_PCIE_RC_SCSR_Electromechanical_Interlock_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_SCSR, field Data_Link_Layer_State_Changed[24] (RW)
 *
 * Data Link Layer State Changed
 */
/*@{*/
#define BP_PCIE_RC_SCSR_Data_Link_Layer_State_Changed (24U) /*!< Bit position for PCIE_RC_SCSR_Data_Link_Layer_State_Changed. */
#define BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed (0x01000000U) /*!< Bit mask for PCIE_RC_SCSR_Data_Link_Layer_State_Changed. */
#define BS_PCIE_RC_SCSR_Data_Link_Layer_State_Changed (1U) /*!< Bit field size in bits for PCIE_RC_SCSR_Data_Link_Layer_State_Changed. */

/*! @brief Read current value of the PCIE_RC_SCSR_Data_Link_Layer_State_Changed field. */
#define BR_PCIE_RC_SCSR_Data_Link_Layer_State_Changed(x) (HW_PCIE_RC_SCSR(x).B.Data_Link_Layer_State_Changed)

/*! @brief Format value for bitfield PCIE_RC_SCSR_Data_Link_Layer_State_Changed. */
#define BF_PCIE_RC_SCSR_Data_Link_Layer_State_Changed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_SCSR_Data_Link_Layer_State_Changed) & BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed)

/*! @brief Set the Data_Link_Layer_State_Changed field to a new value. */
#define BW_PCIE_RC_SCSR_Data_Link_Layer_State_Changed(x, v) (HW_PCIE_RC_SCSR_WR(x, (HW_PCIE_RC_SCSR_RD(x) & ~BM_PCIE_RC_SCSR_Data_Link_Layer_State_Changed) | BF_PCIE_RC_SCSR_Data_Link_Layer_State_Changed(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_RCCR - Root Control and Capabilities Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_RCCR - Root Control and Capabilities Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x1C
 */
typedef union _hw_pcie_rc_rccr
{
    uint32_t U;
    struct _hw_pcie_rc_rccr_bitfields
    {
        uint32_t System_Error_on_Correctable_Error_Enable : 1; /*!< [0]  */
        uint32_t System_Error_on_Non_fatal_Error_Enable : 1; /*!< [1]  */
        uint32_t System_Error_on_Fatal_Error_Enable : 1; /*!< [2]  */
        uint32_t PME_Interrupt_Enable : 1; /*!< [3]  */
        uint32_t CRS_Software_Visibility_Enable : 1; /*!< [4]  */
        uint32_t RESERVED0 : 11;       /*!< [15:5]  */
        uint32_t CRS_Software_Visibility : 1; /*!< [16]  */
        uint32_t RESERVED1 : 15;       /*!< [31:17]  */
    } B;
} hw_pcie_rc_rccr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_RCCR register
 */
/*@{*/
#define HW_PCIE_RC_RCCR_ADDR(x)  ((uintptr_t)(x) + 0x8CU)

#define HW_PCIE_RC_RCCR(x)       (*(__IO hw_pcie_rc_rccr_t *) HW_PCIE_RC_RCCR_ADDR(x))
#define HW_PCIE_RC_RCCR_RD(x)    (HW_PCIE_RC_RCCR(x).U)
#define HW_PCIE_RC_RCCR_WR(x, v) (HW_PCIE_RC_RCCR(x).U = (v))
#define HW_PCIE_RC_RCCR_SET(x, v) (HW_PCIE_RC_RCCR_WR(x, HW_PCIE_RC_RCCR_RD(x) |  (v)))
#define HW_PCIE_RC_RCCR_CLR(x, v) (HW_PCIE_RC_RCCR_WR(x, HW_PCIE_RC_RCCR_RD(x) & ~(v)))
#define HW_PCIE_RC_RCCR_TOG(x, v) (HW_PCIE_RC_RCCR_WR(x, HW_PCIE_RC_RCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_RCCR bitfields
 */

/*!
 * @name Register PCIE_RC_RCCR, field System_Error_on_Correctable_Error_Enable[0] (RW)
 *
 * System Error on Correctable Error Enable
 */
/*@{*/
#define BP_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable (0U) /*!< Bit position for PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable. */
#define BM_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable (0x00000001U) /*!< Bit mask for PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable. */
#define BS_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable. */

/*! @brief Read current value of the PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable field. */
#define BR_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable(x) (HW_PCIE_RC_RCCR(x).B.System_Error_on_Correctable_Error_Enable)

/*! @brief Format value for bitfield PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable. */
#define BF_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable) & BM_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable)

/*! @brief Set the System_Error_on_Correctable_Error_Enable field to a new value. */
#define BW_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable) | BF_PCIE_RC_RCCR_System_Error_on_Correctable_Error_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RCCR, field System_Error_on_Non_fatal_Error_Enable[1] (RW)
 *
 * System Error on Non-fatal Error Enable
 */
/*@{*/
#define BP_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable (1U) /*!< Bit position for PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable. */
#define BM_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable (0x00000002U) /*!< Bit mask for PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable. */
#define BS_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable. */

/*! @brief Read current value of the PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable field. */
#define BR_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable(x) (HW_PCIE_RC_RCCR(x).B.System_Error_on_Non_fatal_Error_Enable)

/*! @brief Format value for bitfield PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable. */
#define BF_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable) & BM_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable)

/*! @brief Set the System_Error_on_Non_fatal_Error_Enable field to a new value. */
#define BW_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable) | BF_PCIE_RC_RCCR_System_Error_on_Non_fatal_Error_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RCCR, field System_Error_on_Fatal_Error_Enable[2] (RW)
 *
 * System Error on Fatal Error Enable
 */
/*@{*/
#define BP_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable (2U) /*!< Bit position for PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable. */
#define BM_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable (0x00000004U) /*!< Bit mask for PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable. */
#define BS_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable. */

/*! @brief Read current value of the PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable field. */
#define BR_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable(x) (HW_PCIE_RC_RCCR(x).B.System_Error_on_Fatal_Error_Enable)

/*! @brief Format value for bitfield PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable. */
#define BF_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable) & BM_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable)

/*! @brief Set the System_Error_on_Fatal_Error_Enable field to a new value. */
#define BW_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable) | BF_PCIE_RC_RCCR_System_Error_on_Fatal_Error_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RCCR, field PME_Interrupt_Enable[3] (RW)
 *
 * PME Interrupt Enable
 */
/*@{*/
#define BP_PCIE_RC_RCCR_PME_Interrupt_Enable (3U) /*!< Bit position for PCIE_RC_RCCR_PME_Interrupt_Enable. */
#define BM_PCIE_RC_RCCR_PME_Interrupt_Enable (0x00000008U) /*!< Bit mask for PCIE_RC_RCCR_PME_Interrupt_Enable. */
#define BS_PCIE_RC_RCCR_PME_Interrupt_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_PME_Interrupt_Enable. */

/*! @brief Read current value of the PCIE_RC_RCCR_PME_Interrupt_Enable field. */
#define BR_PCIE_RC_RCCR_PME_Interrupt_Enable(x) (HW_PCIE_RC_RCCR(x).B.PME_Interrupt_Enable)

/*! @brief Format value for bitfield PCIE_RC_RCCR_PME_Interrupt_Enable. */
#define BF_PCIE_RC_RCCR_PME_Interrupt_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_PME_Interrupt_Enable) & BM_PCIE_RC_RCCR_PME_Interrupt_Enable)

/*! @brief Set the PME_Interrupt_Enable field to a new value. */
#define BW_PCIE_RC_RCCR_PME_Interrupt_Enable(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_PME_Interrupt_Enable) | BF_PCIE_RC_RCCR_PME_Interrupt_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RCCR, field CRS_Software_Visibility_Enable[4] (RW)
 *
 * CRS Software Visibility Enable Not supported, hardwired to 0x0.
 */
/*@{*/
#define BP_PCIE_RC_RCCR_CRS_Software_Visibility_Enable (4U) /*!< Bit position for PCIE_RC_RCCR_CRS_Software_Visibility_Enable. */
#define BM_PCIE_RC_RCCR_CRS_Software_Visibility_Enable (0x00000010U) /*!< Bit mask for PCIE_RC_RCCR_CRS_Software_Visibility_Enable. */
#define BS_PCIE_RC_RCCR_CRS_Software_Visibility_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_CRS_Software_Visibility_Enable. */

/*! @brief Read current value of the PCIE_RC_RCCR_CRS_Software_Visibility_Enable field. */
#define BR_PCIE_RC_RCCR_CRS_Software_Visibility_Enable(x) (HW_PCIE_RC_RCCR(x).B.CRS_Software_Visibility_Enable)

/*! @brief Format value for bitfield PCIE_RC_RCCR_CRS_Software_Visibility_Enable. */
#define BF_PCIE_RC_RCCR_CRS_Software_Visibility_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_CRS_Software_Visibility_Enable) & BM_PCIE_RC_RCCR_CRS_Software_Visibility_Enable)

/*! @brief Set the CRS_Software_Visibility_Enable field to a new value. */
#define BW_PCIE_RC_RCCR_CRS_Software_Visibility_Enable(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_CRS_Software_Visibility_Enable) | BF_PCIE_RC_RCCR_CRS_Software_Visibility_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RCCR, field CRS_Software_Visibility[16] (RW)
 *
 * CRS Software Visibility Not supported, hardwired to 0x0.
 */
/*@{*/
#define BP_PCIE_RC_RCCR_CRS_Software_Visibility (16U) /*!< Bit position for PCIE_RC_RCCR_CRS_Software_Visibility. */
#define BM_PCIE_RC_RCCR_CRS_Software_Visibility (0x00010000U) /*!< Bit mask for PCIE_RC_RCCR_CRS_Software_Visibility. */
#define BS_PCIE_RC_RCCR_CRS_Software_Visibility (1U) /*!< Bit field size in bits for PCIE_RC_RCCR_CRS_Software_Visibility. */

/*! @brief Read current value of the PCIE_RC_RCCR_CRS_Software_Visibility field. */
#define BR_PCIE_RC_RCCR_CRS_Software_Visibility(x) (HW_PCIE_RC_RCCR(x).B.CRS_Software_Visibility)

/*! @brief Format value for bitfield PCIE_RC_RCCR_CRS_Software_Visibility. */
#define BF_PCIE_RC_RCCR_CRS_Software_Visibility(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RCCR_CRS_Software_Visibility) & BM_PCIE_RC_RCCR_CRS_Software_Visibility)

/*! @brief Set the CRS_Software_Visibility field to a new value. */
#define BW_PCIE_RC_RCCR_CRS_Software_Visibility(x, v) (HW_PCIE_RC_RCCR_WR(x, (HW_PCIE_RC_RCCR_RD(x) & ~BM_PCIE_RC_RCCR_CRS_Software_Visibility) | BF_PCIE_RC_RCCR_CRS_Software_Visibility(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_RSR - Root Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_RSR - Root Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x20
 */
typedef union _hw_pcie_rc_rsr
{
    uint32_t U;
    struct _hw_pcie_rc_rsr_bitfields
    {
        uint32_t PME_Requester_ID : 16; /*!< [15:0]  */
        uint32_t PME_Status : 1;       /*!< [16]  */
        uint32_t PME_Pending : 1;      /*!< [17]  */
        uint32_t RESERVED0 : 14;       /*!< [31:18]  */
    } B;
} hw_pcie_rc_rsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_RSR register
 */
/*@{*/
#define HW_PCIE_RC_RSR_ADDR(x)   ((uintptr_t)(x) + 0x90U)

#define HW_PCIE_RC_RSR(x)        (*(__IO hw_pcie_rc_rsr_t *) HW_PCIE_RC_RSR_ADDR(x))
#define HW_PCIE_RC_RSR_RD(x)     (HW_PCIE_RC_RSR(x).U)
#define HW_PCIE_RC_RSR_WR(x, v)  (HW_PCIE_RC_RSR(x).U = (v))
#define HW_PCIE_RC_RSR_SET(x, v) (HW_PCIE_RC_RSR_WR(x, HW_PCIE_RC_RSR_RD(x) |  (v)))
#define HW_PCIE_RC_RSR_CLR(x, v) (HW_PCIE_RC_RSR_WR(x, HW_PCIE_RC_RSR_RD(x) & ~(v)))
#define HW_PCIE_RC_RSR_TOG(x, v) (HW_PCIE_RC_RSR_WR(x, HW_PCIE_RC_RSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_RSR bitfields
 */

/*!
 * @name Register PCIE_RC_RSR, field PME_Requester_ID[15:0] (W1C)
 *
 * PME Requester ID
 */
/*@{*/
#define BP_PCIE_RC_RSR_PME_Requester_ID (0U) /*!< Bit position for PCIE_RC_RSR_PME_Requester_ID. */
#define BM_PCIE_RC_RSR_PME_Requester_ID (0x0000FFFFU) /*!< Bit mask for PCIE_RC_RSR_PME_Requester_ID. */
#define BS_PCIE_RC_RSR_PME_Requester_ID (16U) /*!< Bit field size in bits for PCIE_RC_RSR_PME_Requester_ID. */

/*! @brief Read current value of the PCIE_RC_RSR_PME_Requester_ID field. */
#define BR_PCIE_RC_RSR_PME_Requester_ID(x) (HW_PCIE_RC_RSR(x).B.PME_Requester_ID)

/*! @brief Format value for bitfield PCIE_RC_RSR_PME_Requester_ID. */
#define BF_PCIE_RC_RSR_PME_Requester_ID(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RSR_PME_Requester_ID) & BM_PCIE_RC_RSR_PME_Requester_ID)

/*! @brief Set the PME_Requester_ID field to a new value. */
#define BW_PCIE_RC_RSR_PME_Requester_ID(x, v) (HW_PCIE_RC_RSR_WR(x, (HW_PCIE_RC_RSR_RD(x) & ~(BM_PCIE_RC_RSR_PME_Requester_ID | BM_PCIE_RC_RSR_PME_Status | BM_PCIE_RC_RSR_PME_Pending)) | BF_PCIE_RC_RSR_PME_Requester_ID(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RSR, field PME_Status[16] (W1C)
 *
 * PME Status
 */
/*@{*/
#define BP_PCIE_RC_RSR_PME_Status (16U)    /*!< Bit position for PCIE_RC_RSR_PME_Status. */
#define BM_PCIE_RC_RSR_PME_Status (0x00010000U) /*!< Bit mask for PCIE_RC_RSR_PME_Status. */
#define BS_PCIE_RC_RSR_PME_Status (1U)     /*!< Bit field size in bits for PCIE_RC_RSR_PME_Status. */

/*! @brief Read current value of the PCIE_RC_RSR_PME_Status field. */
#define BR_PCIE_RC_RSR_PME_Status(x) (HW_PCIE_RC_RSR(x).B.PME_Status)

/*! @brief Format value for bitfield PCIE_RC_RSR_PME_Status. */
#define BF_PCIE_RC_RSR_PME_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RSR_PME_Status) & BM_PCIE_RC_RSR_PME_Status)

/*! @brief Set the PME_Status field to a new value. */
#define BW_PCIE_RC_RSR_PME_Status(x, v) (HW_PCIE_RC_RSR_WR(x, (HW_PCIE_RC_RSR_RD(x) & ~(BM_PCIE_RC_RSR_PME_Status | BM_PCIE_RC_RSR_PME_Requester_ID | BM_PCIE_RC_RSR_PME_Pending)) | BF_PCIE_RC_RSR_PME_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RSR, field PME_Pending[17] (W1C)
 *
 * PME Pending
 */
/*@{*/
#define BP_PCIE_RC_RSR_PME_Pending (17U)   /*!< Bit position for PCIE_RC_RSR_PME_Pending. */
#define BM_PCIE_RC_RSR_PME_Pending (0x00020000U) /*!< Bit mask for PCIE_RC_RSR_PME_Pending. */
#define BS_PCIE_RC_RSR_PME_Pending (1U)    /*!< Bit field size in bits for PCIE_RC_RSR_PME_Pending. */

/*! @brief Read current value of the PCIE_RC_RSR_PME_Pending field. */
#define BR_PCIE_RC_RSR_PME_Pending(x) (HW_PCIE_RC_RSR(x).B.PME_Pending)

/*! @brief Format value for bitfield PCIE_RC_RSR_PME_Pending. */
#define BF_PCIE_RC_RSR_PME_Pending(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RSR_PME_Pending) & BM_PCIE_RC_RSR_PME_Pending)

/*! @brief Set the PME_Pending field to a new value. */
#define BW_PCIE_RC_RSR_PME_Pending(x, v) (HW_PCIE_RC_RSR_WR(x, (HW_PCIE_RC_RSR_RD(x) & ~(BM_PCIE_RC_RSR_PME_Pending | BM_PCIE_RC_RSR_PME_Requester_ID | BM_PCIE_RC_RSR_PME_Status)) | BF_PCIE_RC_RSR_PME_Pending(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_DCR2 - Device Capabilities 2 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_DCR2 - Device Capabilities 2 Register (RO)
 *
 * Reset value: 0x0000001FU
 *
 * Offset: `CFG_PCIE_CAP + 0x24
 */
typedef union _hw_pcie_rc_dcr2
{
    uint32_t U;
    struct _hw_pcie_rc_dcr2_bitfields
    {
        uint32_t Completion_Timeout_Ranges_Supported : 4; /*!< [3:0]  */
        uint32_t Completion_Timeout_Disable_Supported : 1; /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_pcie_rc_dcr2_t;

/*!
 * @name Constants and macros for entire PCIE_RC_DCR2 register
 */
/*@{*/
#define HW_PCIE_RC_DCR2_ADDR(x)  ((uintptr_t)(x) + 0x94U)

#define HW_PCIE_RC_DCR2(x)       (*(__I hw_pcie_rc_dcr2_t *) HW_PCIE_RC_DCR2_ADDR(x))
#define HW_PCIE_RC_DCR2_RD(x)    (HW_PCIE_RC_DCR2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_DCR2 bitfields
 */

/*!
 * @name Register PCIE_RC_DCR2, field Completion_Timeout_Ranges_Supported[3:0] (RO)
 *
 * Completion Timeout Ranges Supported This field is applicable only to Root
 * Ports, Endpoints that issue Requests on their own behalf, and PCI Express to
 * PCI/PCI-X Bridges that take ownership of Requests issued on PCI Express. the
 * default value is 0xf (A, B, C and D ranges supported)
 */
/*@{*/
#define BP_PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported (0U) /*!< Bit position for PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported. */
#define BM_PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported (0x0000000FU) /*!< Bit mask for PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported. */
#define BS_PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported (4U) /*!< Bit field size in bits for PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported. */

/*! @brief Read current value of the PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported field. */
#define BR_PCIE_RC_DCR2_Completion_Timeout_Ranges_Supported(x) (HW_PCIE_RC_DCR2(x).B.Completion_Timeout_Ranges_Supported)
/*@}*/

/*!
 * @name Register PCIE_RC_DCR2, field Completion_Timeout_Disable_Supported[4] (RO)
 *
 * Completion Timeout Disable Supported
 */
/*@{*/
#define BP_PCIE_RC_DCR2_Completion_Timeout_Disable_Supported (4U) /*!< Bit position for PCIE_RC_DCR2_Completion_Timeout_Disable_Supported. */
#define BM_PCIE_RC_DCR2_Completion_Timeout_Disable_Supported (0x00000010U) /*!< Bit mask for PCIE_RC_DCR2_Completion_Timeout_Disable_Supported. */
#define BS_PCIE_RC_DCR2_Completion_Timeout_Disable_Supported (1U) /*!< Bit field size in bits for PCIE_RC_DCR2_Completion_Timeout_Disable_Supported. */

/*! @brief Read current value of the PCIE_RC_DCR2_Completion_Timeout_Disable_Supported field. */
#define BR_PCIE_RC_DCR2_Completion_Timeout_Disable_Supported(x) (HW_PCIE_RC_DCR2(x).B.Completion_Timeout_Disable_Supported)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_DCSR2 - Device Control and Status 2 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_DCSR2 - Device Control and Status 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x28
 */
typedef union _hw_pcie_rc_dcsr2
{
    uint32_t U;
    struct _hw_pcie_rc_dcsr2_bitfields
    {
        uint32_t Completion_Timeout_Value : 4; /*!< [3:0]  */
        uint32_t Completion_Timeout_Disable : 1; /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_pcie_rc_dcsr2_t;

/*!
 * @name Constants and macros for entire PCIE_RC_DCSR2 register
 */
/*@{*/
#define HW_PCIE_RC_DCSR2_ADDR(x) ((uintptr_t)(x) + 0x98U)

#define HW_PCIE_RC_DCSR2(x)      (*(__IO hw_pcie_rc_dcsr2_t *) HW_PCIE_RC_DCSR2_ADDR(x))
#define HW_PCIE_RC_DCSR2_RD(x)   (HW_PCIE_RC_DCSR2(x).U)
#define HW_PCIE_RC_DCSR2_WR(x, v) (HW_PCIE_RC_DCSR2(x).U = (v))
#define HW_PCIE_RC_DCSR2_SET(x, v) (HW_PCIE_RC_DCSR2_WR(x, HW_PCIE_RC_DCSR2_RD(x) |  (v)))
#define HW_PCIE_RC_DCSR2_CLR(x, v) (HW_PCIE_RC_DCSR2_WR(x, HW_PCIE_RC_DCSR2_RD(x) & ~(v)))
#define HW_PCIE_RC_DCSR2_TOG(x, v) (HW_PCIE_RC_DCSR2_WR(x, HW_PCIE_RC_DCSR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_DCSR2 bitfields
 */

/*!
 * @name Register PCIE_RC_DCSR2, field Completion_Timeout_Value[3:0] (RW)
 *
 * Completion Timeout Value If the default range is chosen, the core will have a
 * timeout in the range of 16ms to 55ms. . following encodings apply: Values not
 * defined below are reserved.
 *
 * Values:
 * - 0000 - Default range: 50 us to 50 ms
 * - 0001 - 50 us to 100 us
 * - 0010 - 1 ms to 10 ms
 * - 0101 - 16 ms to 55 ms
 * - 0110 - 65 ms to 210 ms
 * - 1001 - 260 ms to 900 ms
 * - 1010 - 1 s to 3.5 s
 * - 1101 - 4 s to 13 s
 * - 1110 - 17 s to 64 s
 */
/*@{*/
#define BP_PCIE_RC_DCSR2_Completion_Timeout_Value (0U) /*!< Bit position for PCIE_RC_DCSR2_Completion_Timeout_Value. */
#define BM_PCIE_RC_DCSR2_Completion_Timeout_Value (0x0000000FU) /*!< Bit mask for PCIE_RC_DCSR2_Completion_Timeout_Value. */
#define BS_PCIE_RC_DCSR2_Completion_Timeout_Value (4U) /*!< Bit field size in bits for PCIE_RC_DCSR2_Completion_Timeout_Value. */

/*! @brief Read current value of the PCIE_RC_DCSR2_Completion_Timeout_Value field. */
#define BR_PCIE_RC_DCSR2_Completion_Timeout_Value(x) (HW_PCIE_RC_DCSR2(x).B.Completion_Timeout_Value)

/*! @brief Format value for bitfield PCIE_RC_DCSR2_Completion_Timeout_Value. */
#define BF_PCIE_RC_DCSR2_Completion_Timeout_Value(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCSR2_Completion_Timeout_Value) & BM_PCIE_RC_DCSR2_Completion_Timeout_Value)

/*! @brief Set the Completion_Timeout_Value field to a new value. */
#define BW_PCIE_RC_DCSR2_Completion_Timeout_Value(x, v) (HW_PCIE_RC_DCSR2_WR(x, (HW_PCIE_RC_DCSR2_RD(x) & ~BM_PCIE_RC_DCSR2_Completion_Timeout_Value) | BF_PCIE_RC_DCSR2_Completion_Timeout_Value(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_DCSR2, field Completion_Timeout_Disable[4] (RW)
 *
 * Completion Timeout Disable
 */
/*@{*/
#define BP_PCIE_RC_DCSR2_Completion_Timeout_Disable (4U) /*!< Bit position for PCIE_RC_DCSR2_Completion_Timeout_Disable. */
#define BM_PCIE_RC_DCSR2_Completion_Timeout_Disable (0x00000010U) /*!< Bit mask for PCIE_RC_DCSR2_Completion_Timeout_Disable. */
#define BS_PCIE_RC_DCSR2_Completion_Timeout_Disable (1U) /*!< Bit field size in bits for PCIE_RC_DCSR2_Completion_Timeout_Disable. */

/*! @brief Read current value of the PCIE_RC_DCSR2_Completion_Timeout_Disable field. */
#define BR_PCIE_RC_DCSR2_Completion_Timeout_Disable(x) (HW_PCIE_RC_DCSR2(x).B.Completion_Timeout_Disable)

/*! @brief Format value for bitfield PCIE_RC_DCSR2_Completion_Timeout_Disable. */
#define BF_PCIE_RC_DCSR2_Completion_Timeout_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_DCSR2_Completion_Timeout_Disable) & BM_PCIE_RC_DCSR2_Completion_Timeout_Disable)

/*! @brief Set the Completion_Timeout_Disable field to a new value. */
#define BW_PCIE_RC_DCSR2_Completion_Timeout_Disable(x, v) (HW_PCIE_RC_DCSR2_WR(x, (HW_PCIE_RC_DCSR2_RD(x) & ~BM_PCIE_RC_DCSR2_Completion_Timeout_Disable) | BF_PCIE_RC_DCSR2_Completion_Timeout_Disable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_LCR2 - Link Capabilities 2 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_LCR2 - Link Capabilities 2 Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 0x2C
 */
typedef union _hw_pcie_rc_lcr2
{
    uint32_t U;
    struct _hw_pcie_rc_lcr2_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t Supported_Link_Speeds_Vector : 7; /*!< [7:1]  */
        uint32_t Crosslink_Supported : 1; /*!< [8]  */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_pcie_rc_lcr2_t;

/*!
 * @name Constants and macros for entire PCIE_RC_LCR2 register
 */
/*@{*/
#define HW_PCIE_RC_LCR2_ADDR(x)  ((uintptr_t)(x) + 0x9CU)

#define HW_PCIE_RC_LCR2(x)       (*(__I hw_pcie_rc_lcr2_t *) HW_PCIE_RC_LCR2_ADDR(x))
#define HW_PCIE_RC_LCR2_RD(x)    (HW_PCIE_RC_LCR2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_LCR2 bitfields
 */

/*!
 * @name Register PCIE_RC_LCR2, field Supported_Link_Speeds_Vector[7:1] (RO)
 *
 * Supported Link Speeds Vector Indicates the supported Link speeds of the
 * associated Port. For each bit, a value of 1b indicates that the corresponding Link
 * speed is supported; otherwise, the Link speed is not supported. Bit
 * definitions are: Bit 1 2.5 GT/s Bit 2 5.0 GT/s Reserved Bits 7:4 reserved This field is
 * writable through the DBI.
 */
/*@{*/
#define BP_PCIE_RC_LCR2_Supported_Link_Speeds_Vector (1U) /*!< Bit position for PCIE_RC_LCR2_Supported_Link_Speeds_Vector. */
#define BM_PCIE_RC_LCR2_Supported_Link_Speeds_Vector (0x000000FEU) /*!< Bit mask for PCIE_RC_LCR2_Supported_Link_Speeds_Vector. */
#define BS_PCIE_RC_LCR2_Supported_Link_Speeds_Vector (7U) /*!< Bit field size in bits for PCIE_RC_LCR2_Supported_Link_Speeds_Vector. */

/*! @brief Read current value of the PCIE_RC_LCR2_Supported_Link_Speeds_Vector field. */
#define BR_PCIE_RC_LCR2_Supported_Link_Speeds_Vector(x) (HW_PCIE_RC_LCR2(x).B.Supported_Link_Speeds_Vector)
/*@}*/

/*!
 * @name Register PCIE_RC_LCR2, field Crosslink_Supported[8] (RO)
 *
 * Crosslink Supported
 */
/*@{*/
#define BP_PCIE_RC_LCR2_Crosslink_Supported (8U) /*!< Bit position for PCIE_RC_LCR2_Crosslink_Supported. */
#define BM_PCIE_RC_LCR2_Crosslink_Supported (0x00000100U) /*!< Bit mask for PCIE_RC_LCR2_Crosslink_Supported. */
#define BS_PCIE_RC_LCR2_Crosslink_Supported (1U) /*!< Bit field size in bits for PCIE_RC_LCR2_Crosslink_Supported. */

/*! @brief Read current value of the PCIE_RC_LCR2_Crosslink_Supported field. */
#define BR_PCIE_RC_LCR2_Crosslink_Supported(x) (HW_PCIE_RC_LCR2(x).B.Crosslink_Supported)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_LCSR2 - Link Control and Status 2 Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_LCSR2 - Link Control and Status 2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: `CFG_PCIE_CAP + 30
 */
typedef union _hw_pcie_rc_lcsr2
{
    uint32_t U;
    struct _hw_pcie_rc_lcsr2_bitfields
    {
        uint32_t Target_Link_Speed : 4; /*!< [3:0]  */
        uint32_t Enter_Compliance : 1; /*!< [4]  */
        uint32_t Hardware_Autonomous_Speed_Disable : 1; /*!< [5]  */
        uint32_t Selectable_Deemphasis : 1; /*!< [6]  */
        uint32_t Transmit_Margin : 3;  /*!< [9:7]  */
        uint32_t Enter_Modified_Compliance : 1; /*!< [10]  */
        uint32_t Compliance_SOS : 1;   /*!< [11]  */
        uint32_t Compliance_Pre_set_Deemphasis : 4; /*!< [15:12]  */
        uint32_t Current_Deemphasis_Level : 1; /*!< [16]  */
        uint32_t Equalization_Complete : 1; /*!< [17]  */
        uint32_t Equalization_Phase_1_Successful : 1; /*!< [18]  */
        uint32_t Equalization_Phase_2_Successful : 1; /*!< [19]  */
        uint32_t Equalization_Phase_3_Successful : 1; /*!< [20]  */
        uint32_t Link_Equalization_Request : 1; /*!< [21]  */
        uint32_t RESERVED0 : 10;       /*!< [31:22]  */
    } B;
} hw_pcie_rc_lcsr2_t;

/*!
 * @name Constants and macros for entire PCIE_RC_LCSR2 register
 */
/*@{*/
#define HW_PCIE_RC_LCSR2_ADDR(x) ((uintptr_t)(x) + 0xA0U)

#define HW_PCIE_RC_LCSR2(x)      (*(__IO hw_pcie_rc_lcsr2_t *) HW_PCIE_RC_LCSR2_ADDR(x))
#define HW_PCIE_RC_LCSR2_RD(x)   (HW_PCIE_RC_LCSR2(x).U)
#define HW_PCIE_RC_LCSR2_WR(x, v) (HW_PCIE_RC_LCSR2(x).U = (v))
#define HW_PCIE_RC_LCSR2_SET(x, v) (HW_PCIE_RC_LCSR2_WR(x, HW_PCIE_RC_LCSR2_RD(x) |  (v)))
#define HW_PCIE_RC_LCSR2_CLR(x, v) (HW_PCIE_RC_LCSR2_WR(x, HW_PCIE_RC_LCSR2_RD(x) & ~(v)))
#define HW_PCIE_RC_LCSR2_TOG(x, v) (HW_PCIE_RC_LCSR2_WR(x, HW_PCIE_RC_LCSR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_LCSR2 bitfields
 */

/*!
 * @name Register PCIE_RC_LCSR2, field Target_Link_Speed[3:0] (RW)
 *
 * Target Link Speed For Downstream ports, this field sets an upper limit on
 * link operational speed by restricting the values advertised by the upstream
 * component in its training sequences: The encoding is the binary value of the bit in
 * the Supported Link Speeds Vector (in the Link Capabilities 2 register) that
 * corresponds to the desired target Link speed. If a value is written to this
 * field that does not correspond to a speed included in the Supported Link Speeds
 * field, the result is undefined. The default value of this field is the highest
 * link speed supported by the component (as reported in the Max Link Speed field
 * of the Link Capabilities Register) unless the corresponding platform / form
 * factor requires a different default value. Components that support only the 2.5
 * GT/s speed are permitted to hardwire this field to 0000b. All other encodings
 * are reserved.
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Target_Link_Speed (0U) /*!< Bit position for PCIE_RC_LCSR2_Target_Link_Speed. */
#define BM_PCIE_RC_LCSR2_Target_Link_Speed (0x0000000FU) /*!< Bit mask for PCIE_RC_LCSR2_Target_Link_Speed. */
#define BS_PCIE_RC_LCSR2_Target_Link_Speed (4U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Target_Link_Speed. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Target_Link_Speed field. */
#define BR_PCIE_RC_LCSR2_Target_Link_Speed(x) (HW_PCIE_RC_LCSR2(x).B.Target_Link_Speed)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Target_Link_Speed. */
#define BF_PCIE_RC_LCSR2_Target_Link_Speed(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Target_Link_Speed) & BM_PCIE_RC_LCSR2_Target_Link_Speed)

/*! @brief Set the Target_Link_Speed field to a new value. */
#define BW_PCIE_RC_LCSR2_Target_Link_Speed(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Target_Link_Speed) | BF_PCIE_RC_LCSR2_Target_Link_Speed(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Enter_Compliance[4] (RW)
 *
 * Enter Compliance Software is permitted to force a link to enter Compliance
 * mode at the speed indicated in the Target Link Speed field by setting this bit
 * to 1b in both components on a link and then initiating a hot reset on the link.
 * The default value of this field following Fundamental Reset is 0b.
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Enter_Compliance (4U) /*!< Bit position for PCIE_RC_LCSR2_Enter_Compliance. */
#define BM_PCIE_RC_LCSR2_Enter_Compliance (0x00000010U) /*!< Bit mask for PCIE_RC_LCSR2_Enter_Compliance. */
#define BS_PCIE_RC_LCSR2_Enter_Compliance (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Enter_Compliance. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Enter_Compliance field. */
#define BR_PCIE_RC_LCSR2_Enter_Compliance(x) (HW_PCIE_RC_LCSR2(x).B.Enter_Compliance)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Enter_Compliance. */
#define BF_PCIE_RC_LCSR2_Enter_Compliance(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Enter_Compliance) & BM_PCIE_RC_LCSR2_Enter_Compliance)

/*! @brief Set the Enter_Compliance field to a new value. */
#define BW_PCIE_RC_LCSR2_Enter_Compliance(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Enter_Compliance) | BF_PCIE_RC_LCSR2_Enter_Compliance(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Hardware_Autonomous_Speed_Disable[5] (RW)
 *
 * Hardware Autonomous Speed Disable When cfg_hw_auto_sp_dis signal is asserted,
 * the application must disable hardware from changing the Link speed for
 * device-specific reasons other than attempting to correct unreliable Link operation
 * by reducing Link speed. Initial transition to the highest supported common link
 * speed is not blocked by this signal.
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable (5U) /*!< Bit position for PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable. */
#define BM_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable (0x00000020U) /*!< Bit mask for PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable. */
#define BS_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable field. */
#define BR_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable(x) (HW_PCIE_RC_LCSR2(x).B.Hardware_Autonomous_Speed_Disable)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable. */
#define BF_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable) & BM_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable)

/*! @brief Set the Hardware_Autonomous_Speed_Disable field to a new value. */
#define BW_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable) | BF_PCIE_RC_LCSR2_Hardware_Autonomous_Speed_Disable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Selectable_Deemphasis[6] (RW)
 *
 * Selectable De-emphasis When the Link is operating at 2.5 GT/s speed, the
 * setting of this bit has no effect. Components that support only the 2.5 GT/s speed
 * are permitted to hardwire this bit to 0b. Default value is
 * implementation-specific, unless a specific value is required for a selected form factor or
 * platform. When the Link is operating at 5.0 GT/s speed, selects the level of
 * de-emphasis:
 *
 * Values:
 * - 1 - -3.5 dB
 * - 0 - -6 dB
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Selectable_Deemphasis (6U) /*!< Bit position for PCIE_RC_LCSR2_Selectable_Deemphasis. */
#define BM_PCIE_RC_LCSR2_Selectable_Deemphasis (0x00000040U) /*!< Bit mask for PCIE_RC_LCSR2_Selectable_Deemphasis. */
#define BS_PCIE_RC_LCSR2_Selectable_Deemphasis (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Selectable_Deemphasis. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Selectable_Deemphasis field. */
#define BR_PCIE_RC_LCSR2_Selectable_Deemphasis(x) (HW_PCIE_RC_LCSR2(x).B.Selectable_Deemphasis)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Selectable_Deemphasis. */
#define BF_PCIE_RC_LCSR2_Selectable_Deemphasis(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Selectable_Deemphasis) & BM_PCIE_RC_LCSR2_Selectable_Deemphasis)

/*! @brief Set the Selectable_Deemphasis field to a new value. */
#define BW_PCIE_RC_LCSR2_Selectable_Deemphasis(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Selectable_Deemphasis) | BF_PCIE_RC_LCSR2_Selectable_Deemphasis(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Transmit_Margin[9:7] (RW)
 *
 * Transmit Margin This field is reset to 000b on entry to the LTSSM Polling.
 * Compliance substate. Components that support only the 2.5 GT/s speed are
 * permitted to hard-wire this bit to 0b. When operating in 5.0 GT/s mode with full
 * swing, the de-emphasis ratio must be maintained within +/- 1 dB from the
 * specification-defined operational value (either -3.5 or -6 dB). This field controls the
 * value of the non-de-emphasized voltage level at the Transmitter pins:
 *
 * Values:
 * - 000 - 800-1200 mV for full swing 400-600 mV for half- swing
 * - 011 - 200-400 mV for full-swing and 100-200 mV for halfswing
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Transmit_Margin (7U) /*!< Bit position for PCIE_RC_LCSR2_Transmit_Margin. */
#define BM_PCIE_RC_LCSR2_Transmit_Margin (0x00000380U) /*!< Bit mask for PCIE_RC_LCSR2_Transmit_Margin. */
#define BS_PCIE_RC_LCSR2_Transmit_Margin (3U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Transmit_Margin. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Transmit_Margin field. */
#define BR_PCIE_RC_LCSR2_Transmit_Margin(x) (HW_PCIE_RC_LCSR2(x).B.Transmit_Margin)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Transmit_Margin. */
#define BF_PCIE_RC_LCSR2_Transmit_Margin(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Transmit_Margin) & BM_PCIE_RC_LCSR2_Transmit_Margin)

/*! @brief Set the Transmit_Margin field to a new value. */
#define BW_PCIE_RC_LCSR2_Transmit_Margin(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Transmit_Margin) | BF_PCIE_RC_LCSR2_Transmit_Margin(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Enter_Modified_Compliance[10] (RW)
 *
 * Enter Modified Compliance When this bit is set to 1b, the device transmits
 * modified compliance pattern if the LTSSM enters Polling. Compliance state.
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Enter_Modified_Compliance (10U) /*!< Bit position for PCIE_RC_LCSR2_Enter_Modified_Compliance. */
#define BM_PCIE_RC_LCSR2_Enter_Modified_Compliance (0x00000400U) /*!< Bit mask for PCIE_RC_LCSR2_Enter_Modified_Compliance. */
#define BS_PCIE_RC_LCSR2_Enter_Modified_Compliance (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Enter_Modified_Compliance. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Enter_Modified_Compliance field. */
#define BR_PCIE_RC_LCSR2_Enter_Modified_Compliance(x) (HW_PCIE_RC_LCSR2(x).B.Enter_Modified_Compliance)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Enter_Modified_Compliance. */
#define BF_PCIE_RC_LCSR2_Enter_Modified_Compliance(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Enter_Modified_Compliance) & BM_PCIE_RC_LCSR2_Enter_Modified_Compliance)

/*! @brief Set the Enter_Modified_Compliance field to a new value. */
#define BW_PCIE_RC_LCSR2_Enter_Modified_Compliance(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Enter_Modified_Compliance) | BF_PCIE_RC_LCSR2_Enter_Modified_Compliance(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Compliance_SOS[11] (RW)
 *
 * Compliance SOS When set to 1b, the LTSSM is required to send SKP Ordered Sets
 * periodically in between the (modified) compliance patterns. GT/s speed are
 * permitted to hardwire this bit to 0b. When the Link is operating at 2.5 GT/s,
 * the setting of this bit has no effect. Components that support only 2.5
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Compliance_SOS (11U) /*!< Bit position for PCIE_RC_LCSR2_Compliance_SOS. */
#define BM_PCIE_RC_LCSR2_Compliance_SOS (0x00000800U) /*!< Bit mask for PCIE_RC_LCSR2_Compliance_SOS. */
#define BS_PCIE_RC_LCSR2_Compliance_SOS (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Compliance_SOS. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Compliance_SOS field. */
#define BR_PCIE_RC_LCSR2_Compliance_SOS(x) (HW_PCIE_RC_LCSR2(x).B.Compliance_SOS)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Compliance_SOS. */
#define BF_PCIE_RC_LCSR2_Compliance_SOS(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Compliance_SOS) & BM_PCIE_RC_LCSR2_Compliance_SOS)

/*! @brief Set the Compliance_SOS field to a new value. */
#define BW_PCIE_RC_LCSR2_Compliance_SOS(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Compliance_SOS) | BF_PCIE_RC_LCSR2_Compliance_SOS(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Compliance_Pre_set_Deemphasis[15:12] (RW)
 *
 * Compliance Pre-set/ De-emphasis
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis (12U) /*!< Bit position for PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis. */
#define BM_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis (0x0000F000U) /*!< Bit mask for PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis. */
#define BS_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis (4U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis field. */
#define BR_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis(x) (HW_PCIE_RC_LCSR2(x).B.Compliance_Pre_set_Deemphasis)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis. */
#define BF_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis) & BM_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis)

/*! @brief Set the Compliance_Pre_set_Deemphasis field to a new value. */
#define BW_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis) | BF_PCIE_RC_LCSR2_Compliance_Pre_set_Deemphasis(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Current_Deemphasis_Level[16] (RW)
 *
 * Current De-emphasis Level
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Current_Deemphasis_Level (16U) /*!< Bit position for PCIE_RC_LCSR2_Current_Deemphasis_Level. */
#define BM_PCIE_RC_LCSR2_Current_Deemphasis_Level (0x00010000U) /*!< Bit mask for PCIE_RC_LCSR2_Current_Deemphasis_Level. */
#define BS_PCIE_RC_LCSR2_Current_Deemphasis_Level (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Current_Deemphasis_Level. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Current_Deemphasis_Level field. */
#define BR_PCIE_RC_LCSR2_Current_Deemphasis_Level(x) (HW_PCIE_RC_LCSR2(x).B.Current_Deemphasis_Level)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Current_Deemphasis_Level. */
#define BF_PCIE_RC_LCSR2_Current_Deemphasis_Level(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Current_Deemphasis_Level) & BM_PCIE_RC_LCSR2_Current_Deemphasis_Level)

/*! @brief Set the Current_Deemphasis_Level field to a new value. */
#define BW_PCIE_RC_LCSR2_Current_Deemphasis_Level(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Current_Deemphasis_Level) | BF_PCIE_RC_LCSR2_Current_Deemphasis_Level(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Equalization_Complete[17] (RW)
 *
 * Equalization Complete
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Equalization_Complete (17U) /*!< Bit position for PCIE_RC_LCSR2_Equalization_Complete. */
#define BM_PCIE_RC_LCSR2_Equalization_Complete (0x00020000U) /*!< Bit mask for PCIE_RC_LCSR2_Equalization_Complete. */
#define BS_PCIE_RC_LCSR2_Equalization_Complete (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Equalization_Complete. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Equalization_Complete field. */
#define BR_PCIE_RC_LCSR2_Equalization_Complete(x) (HW_PCIE_RC_LCSR2(x).B.Equalization_Complete)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Equalization_Complete. */
#define BF_PCIE_RC_LCSR2_Equalization_Complete(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Equalization_Complete) & BM_PCIE_RC_LCSR2_Equalization_Complete)

/*! @brief Set the Equalization_Complete field to a new value. */
#define BW_PCIE_RC_LCSR2_Equalization_Complete(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Equalization_Complete) | BF_PCIE_RC_LCSR2_Equalization_Complete(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Equalization_Phase_1_Successful[18] (RW)
 *
 * Equalization Phase 1 Successful
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Equalization_Phase_1_Successful (18U) /*!< Bit position for PCIE_RC_LCSR2_Equalization_Phase_1_Successful. */
#define BM_PCIE_RC_LCSR2_Equalization_Phase_1_Successful (0x00040000U) /*!< Bit mask for PCIE_RC_LCSR2_Equalization_Phase_1_Successful. */
#define BS_PCIE_RC_LCSR2_Equalization_Phase_1_Successful (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Equalization_Phase_1_Successful. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Equalization_Phase_1_Successful field. */
#define BR_PCIE_RC_LCSR2_Equalization_Phase_1_Successful(x) (HW_PCIE_RC_LCSR2(x).B.Equalization_Phase_1_Successful)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Equalization_Phase_1_Successful. */
#define BF_PCIE_RC_LCSR2_Equalization_Phase_1_Successful(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Equalization_Phase_1_Successful) & BM_PCIE_RC_LCSR2_Equalization_Phase_1_Successful)

/*! @brief Set the Equalization_Phase_1_Successful field to a new value. */
#define BW_PCIE_RC_LCSR2_Equalization_Phase_1_Successful(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Equalization_Phase_1_Successful) | BF_PCIE_RC_LCSR2_Equalization_Phase_1_Successful(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Equalization_Phase_2_Successful[19] (RW)
 *
 * Equalization Phase 2 Successful
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Equalization_Phase_2_Successful (19U) /*!< Bit position for PCIE_RC_LCSR2_Equalization_Phase_2_Successful. */
#define BM_PCIE_RC_LCSR2_Equalization_Phase_2_Successful (0x00080000U) /*!< Bit mask for PCIE_RC_LCSR2_Equalization_Phase_2_Successful. */
#define BS_PCIE_RC_LCSR2_Equalization_Phase_2_Successful (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Equalization_Phase_2_Successful. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Equalization_Phase_2_Successful field. */
#define BR_PCIE_RC_LCSR2_Equalization_Phase_2_Successful(x) (HW_PCIE_RC_LCSR2(x).B.Equalization_Phase_2_Successful)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Equalization_Phase_2_Successful. */
#define BF_PCIE_RC_LCSR2_Equalization_Phase_2_Successful(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Equalization_Phase_2_Successful) & BM_PCIE_RC_LCSR2_Equalization_Phase_2_Successful)

/*! @brief Set the Equalization_Phase_2_Successful field to a new value. */
#define BW_PCIE_RC_LCSR2_Equalization_Phase_2_Successful(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Equalization_Phase_2_Successful) | BF_PCIE_RC_LCSR2_Equalization_Phase_2_Successful(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Equalization_Phase_3_Successful[20] (RW)
 *
 * Equalization Phase 3 Successful
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Equalization_Phase_3_Successful (20U) /*!< Bit position for PCIE_RC_LCSR2_Equalization_Phase_3_Successful. */
#define BM_PCIE_RC_LCSR2_Equalization_Phase_3_Successful (0x00100000U) /*!< Bit mask for PCIE_RC_LCSR2_Equalization_Phase_3_Successful. */
#define BS_PCIE_RC_LCSR2_Equalization_Phase_3_Successful (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Equalization_Phase_3_Successful. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Equalization_Phase_3_Successful field. */
#define BR_PCIE_RC_LCSR2_Equalization_Phase_3_Successful(x) (HW_PCIE_RC_LCSR2(x).B.Equalization_Phase_3_Successful)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Equalization_Phase_3_Successful. */
#define BF_PCIE_RC_LCSR2_Equalization_Phase_3_Successful(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Equalization_Phase_3_Successful) & BM_PCIE_RC_LCSR2_Equalization_Phase_3_Successful)

/*! @brief Set the Equalization_Phase_3_Successful field to a new value. */
#define BW_PCIE_RC_LCSR2_Equalization_Phase_3_Successful(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Equalization_Phase_3_Successful) | BF_PCIE_RC_LCSR2_Equalization_Phase_3_Successful(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_LCSR2, field Link_Equalization_Request[21] (RW)
 *
 * Link Equalization Request
 */
/*@{*/
#define BP_PCIE_RC_LCSR2_Link_Equalization_Request (21U) /*!< Bit position for PCIE_RC_LCSR2_Link_Equalization_Request. */
#define BM_PCIE_RC_LCSR2_Link_Equalization_Request (0x00200000U) /*!< Bit mask for PCIE_RC_LCSR2_Link_Equalization_Request. */
#define BS_PCIE_RC_LCSR2_Link_Equalization_Request (1U) /*!< Bit field size in bits for PCIE_RC_LCSR2_Link_Equalization_Request. */

/*! @brief Read current value of the PCIE_RC_LCSR2_Link_Equalization_Request field. */
#define BR_PCIE_RC_LCSR2_Link_Equalization_Request(x) (HW_PCIE_RC_LCSR2(x).B.Link_Equalization_Request)

/*! @brief Format value for bitfield PCIE_RC_LCSR2_Link_Equalization_Request. */
#define BF_PCIE_RC_LCSR2_Link_Equalization_Request(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_LCSR2_Link_Equalization_Request) & BM_PCIE_RC_LCSR2_Link_Equalization_Request)

/*! @brief Set the Link_Equalization_Request field to a new value. */
#define BW_PCIE_RC_LCSR2_Link_Equalization_Request(x, v) (HW_PCIE_RC_LCSR2_WR(x, (HW_PCIE_RC_LCSR2_RD(x) & ~BM_PCIE_RC_LCSR2_Link_Equalization_Request) | BF_PCIE_RC_LCSR2_Link_Equalization_Request(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_AER - AER Capability Header
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_AER - AER Capability Header (RW)
 *
 * Reset value: 0x00000000U
 *
 * The core implements the following PCI Express Extended Capabilities
 * registers: Advanced Error Reporting Capability register set Virtual Channel Capability
 * register set Address: 0x100
 */
typedef union _hw_pcie_rc_aer
{
    uint32_t U;
    struct _hw_pcie_rc_aer_bitfields
    {
        uint32_t PCI_Express_Extended_Capability_ID : 16; /*!< [15:0]  */
        uint32_t Capability_Version : 4; /*!< [19:16]  */
        uint32_t Next_Capability_Offset : 12; /*!< [31:20]  */
    } B;
} hw_pcie_rc_aer_t;

/*!
 * @name Constants and macros for entire PCIE_RC_AER register
 */
/*@{*/
#define HW_PCIE_RC_AER_ADDR(x)   ((uintptr_t)(x) + 0x100U)

#define HW_PCIE_RC_AER(x)        (*(__IO hw_pcie_rc_aer_t *) HW_PCIE_RC_AER_ADDR(x))
#define HW_PCIE_RC_AER_RD(x)     (HW_PCIE_RC_AER(x).U)
#define HW_PCIE_RC_AER_WR(x, v)  (HW_PCIE_RC_AER(x).U = (v))
#define HW_PCIE_RC_AER_SET(x, v) (HW_PCIE_RC_AER_WR(x, HW_PCIE_RC_AER_RD(x) |  (v)))
#define HW_PCIE_RC_AER_CLR(x, v) (HW_PCIE_RC_AER_WR(x, HW_PCIE_RC_AER_RD(x) & ~(v)))
#define HW_PCIE_RC_AER_TOG(x, v) (HW_PCIE_RC_AER_WR(x, HW_PCIE_RC_AER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_AER bitfields
 */

/*!
 * @name Register PCIE_RC_AER, field PCI_Express_Extended_Capability_ID[15:0] (RW)
 *
 * PCI Express Extended Capability ID Value is 0x1 for Advanced Error Reporting.
 */
/*@{*/
#define BP_PCIE_RC_AER_PCI_Express_Extended_Capability_ID (0U) /*!< Bit position for PCIE_RC_AER_PCI_Express_Extended_Capability_ID. */
#define BM_PCIE_RC_AER_PCI_Express_Extended_Capability_ID (0x0000FFFFU) /*!< Bit mask for PCIE_RC_AER_PCI_Express_Extended_Capability_ID. */
#define BS_PCIE_RC_AER_PCI_Express_Extended_Capability_ID (16U) /*!< Bit field size in bits for PCIE_RC_AER_PCI_Express_Extended_Capability_ID. */

/*! @brief Read current value of the PCIE_RC_AER_PCI_Express_Extended_Capability_ID field. */
#define BR_PCIE_RC_AER_PCI_Express_Extended_Capability_ID(x) (HW_PCIE_RC_AER(x).B.PCI_Express_Extended_Capability_ID)

/*! @brief Format value for bitfield PCIE_RC_AER_PCI_Express_Extended_Capability_ID. */
#define BF_PCIE_RC_AER_PCI_Express_Extended_Capability_ID(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_AER_PCI_Express_Extended_Capability_ID) & BM_PCIE_RC_AER_PCI_Express_Extended_Capability_ID)

/*! @brief Set the PCI_Express_Extended_Capability_ID field to a new value. */
#define BW_PCIE_RC_AER_PCI_Express_Extended_Capability_ID(x, v) (HW_PCIE_RC_AER_WR(x, (HW_PCIE_RC_AER_RD(x) & ~BM_PCIE_RC_AER_PCI_Express_Extended_Capability_ID) | BF_PCIE_RC_AER_PCI_Express_Extended_Capability_ID(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_AER, field Capability_Version[19:16] (RW)
 *
 * Capability Version
 */
/*@{*/
#define BP_PCIE_RC_AER_Capability_Version (16U) /*!< Bit position for PCIE_RC_AER_Capability_Version. */
#define BM_PCIE_RC_AER_Capability_Version (0x000F0000U) /*!< Bit mask for PCIE_RC_AER_Capability_Version. */
#define BS_PCIE_RC_AER_Capability_Version (4U) /*!< Bit field size in bits for PCIE_RC_AER_Capability_Version. */

/*! @brief Read current value of the PCIE_RC_AER_Capability_Version field. */
#define BR_PCIE_RC_AER_Capability_Version(x) (HW_PCIE_RC_AER(x).B.Capability_Version)

/*! @brief Format value for bitfield PCIE_RC_AER_Capability_Version. */
#define BF_PCIE_RC_AER_Capability_Version(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_AER_Capability_Version) & BM_PCIE_RC_AER_Capability_Version)

/*! @brief Set the Capability_Version field to a new value. */
#define BW_PCIE_RC_AER_Capability_Version(x, v) (HW_PCIE_RC_AER_WR(x, (HW_PCIE_RC_AER_RD(x) & ~BM_PCIE_RC_AER_Capability_Version) | BF_PCIE_RC_AER_Capability_Version(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_AER, field Next_Capability_Offset[31:20] (RW)
 *
 * Next Capability Offset
 */
/*@{*/
#define BP_PCIE_RC_AER_Next_Capability_Offset (20U) /*!< Bit position for PCIE_RC_AER_Next_Capability_Offset. */
#define BM_PCIE_RC_AER_Next_Capability_Offset (0xFFF00000U) /*!< Bit mask for PCIE_RC_AER_Next_Capability_Offset. */
#define BS_PCIE_RC_AER_Next_Capability_Offset (12U) /*!< Bit field size in bits for PCIE_RC_AER_Next_Capability_Offset. */

/*! @brief Read current value of the PCIE_RC_AER_Next_Capability_Offset field. */
#define BR_PCIE_RC_AER_Next_Capability_Offset(x) (HW_PCIE_RC_AER(x).B.Next_Capability_Offset)

/*! @brief Format value for bitfield PCIE_RC_AER_Next_Capability_Offset. */
#define BF_PCIE_RC_AER_Next_Capability_Offset(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_AER_Next_Capability_Offset) & BM_PCIE_RC_AER_Next_Capability_Offset)

/*! @brief Set the Next_Capability_Offset field to a new value. */
#define BW_PCIE_RC_AER_Next_Capability_Offset(x, v) (HW_PCIE_RC_AER_WR(x, (HW_PCIE_RC_AER_RD(x) & ~BM_PCIE_RC_AER_Next_Capability_Offset) | BF_PCIE_RC_AER_Next_Capability_Offset(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_UESR - Uncorrectable Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_UESR - Uncorrectable Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x04
 */
typedef union _hw_pcie_rc_uesr
{
    uint32_t U;
    struct _hw_pcie_rc_uesr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Status : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Status_ : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Status : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Status : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Status : 1; /*!< [14]  */
        uint32_t Completer_Abort_Status : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Status : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Status : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Status : 1; /*!< [18]  */
        uint32_t ECRC_Error_Status : 1; /*!< [19]  */
        uint32_t Unsupported_Request_Error_Status : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_rc_uesr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_UESR register
 */
/*@{*/
#define HW_PCIE_RC_UESR_ADDR(x)  ((uintptr_t)(x) + 0x104U)

#define HW_PCIE_RC_UESR(x)       (*(__IO hw_pcie_rc_uesr_t *) HW_PCIE_RC_UESR_ADDR(x))
#define HW_PCIE_RC_UESR_RD(x)    (HW_PCIE_RC_UESR(x).U)
#define HW_PCIE_RC_UESR_WR(x, v) (HW_PCIE_RC_UESR(x).U = (v))
#define HW_PCIE_RC_UESR_SET(x, v) (HW_PCIE_RC_UESR_WR(x, HW_PCIE_RC_UESR_RD(x) |  (v)))
#define HW_PCIE_RC_UESR_CLR(x, v) (HW_PCIE_RC_UESR_WR(x, HW_PCIE_RC_UESR_RD(x) & ~(v)))
#define HW_PCIE_RC_UESR_TOG(x, v) (HW_PCIE_RC_UESR_WR(x, HW_PCIE_RC_UESR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_UESR bitfields
 */

/*!
 * @name Register PCIE_RC_UESR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Status for PCI Express 1.0a)
 */
/*@{*/
#define BP_PCIE_RC_UESR_Undefined (0U)     /*!< Bit position for PCIE_RC_UESR_Undefined. */
#define BM_PCIE_RC_UESR_Undefined (0x00000001U) /*!< Bit mask for PCIE_RC_UESR_Undefined. */
#define BS_PCIE_RC_UESR_Undefined (1U)     /*!< Bit field size in bits for PCIE_RC_UESR_Undefined. */

/*! @brief Read current value of the PCIE_RC_UESR_Undefined field. */
#define BR_PCIE_RC_UESR_Undefined(x) (HW_PCIE_RC_UESR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_RC_UESR_Undefined. */
#define BF_PCIE_RC_UESR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Undefined) & BM_PCIE_RC_UESR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_RC_UESR_Undefined(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Undefined) | BF_PCIE_RC_UESR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Data_Link_Protocol_Error_Status[4] (RW)
 *
 * Data Link Protocol Error Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Data_Link_Protocol_Error_Status (4U) /*!< Bit position for PCIE_RC_UESR_Data_Link_Protocol_Error_Status. */
#define BM_PCIE_RC_UESR_Data_Link_Protocol_Error_Status (0x00000010U) /*!< Bit mask for PCIE_RC_UESR_Data_Link_Protocol_Error_Status. */
#define BS_PCIE_RC_UESR_Data_Link_Protocol_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Data_Link_Protocol_Error_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Data_Link_Protocol_Error_Status field. */
#define BR_PCIE_RC_UESR_Data_Link_Protocol_Error_Status(x) (HW_PCIE_RC_UESR(x).B.Data_Link_Protocol_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Data_Link_Protocol_Error_Status. */
#define BF_PCIE_RC_UESR_Data_Link_Protocol_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Data_Link_Protocol_Error_Status) & BM_PCIE_RC_UESR_Data_Link_Protocol_Error_Status)

/*! @brief Set the Data_Link_Protocol_Error_Status field to a new value. */
#define BW_PCIE_RC_UESR_Data_Link_Protocol_Error_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Data_Link_Protocol_Error_Status) | BF_PCIE_RC_UESR_Data_Link_Protocol_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Surprise_Down_Error_Status_[5] (RW)
 *
 * Surprise Down Error Status (not supported)
 */
/*@{*/
#define BP_PCIE_RC_UESR_Surprise_Down_Error_Status_ (5U) /*!< Bit position for PCIE_RC_UESR_Surprise_Down_Error_Status_. */
#define BM_PCIE_RC_UESR_Surprise_Down_Error_Status_ (0x00000020U) /*!< Bit mask for PCIE_RC_UESR_Surprise_Down_Error_Status_. */
#define BS_PCIE_RC_UESR_Surprise_Down_Error_Status_ (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Surprise_Down_Error_Status_. */

/*! @brief Read current value of the PCIE_RC_UESR_Surprise_Down_Error_Status_ field. */
#define BR_PCIE_RC_UESR_Surprise_Down_Error_Status_(x) (HW_PCIE_RC_UESR(x).B.Surprise_Down_Error_Status_)

/*! @brief Format value for bitfield PCIE_RC_UESR_Surprise_Down_Error_Status_. */
#define BF_PCIE_RC_UESR_Surprise_Down_Error_Status_(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Surprise_Down_Error_Status_) & BM_PCIE_RC_UESR_Surprise_Down_Error_Status_)

/*! @brief Set the Surprise_Down_Error_Status_ field to a new value. */
#define BW_PCIE_RC_UESR_Surprise_Down_Error_Status_(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Surprise_Down_Error_Status_) | BF_PCIE_RC_UESR_Surprise_Down_Error_Status_(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Poisoned_TLP_Status[12] (RW)
 *
 * Poisoned TLP Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Poisoned_TLP_Status (12U) /*!< Bit position for PCIE_RC_UESR_Poisoned_TLP_Status. */
#define BM_PCIE_RC_UESR_Poisoned_TLP_Status (0x00001000U) /*!< Bit mask for PCIE_RC_UESR_Poisoned_TLP_Status. */
#define BS_PCIE_RC_UESR_Poisoned_TLP_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Poisoned_TLP_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Poisoned_TLP_Status field. */
#define BR_PCIE_RC_UESR_Poisoned_TLP_Status(x) (HW_PCIE_RC_UESR(x).B.Poisoned_TLP_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Poisoned_TLP_Status. */
#define BF_PCIE_RC_UESR_Poisoned_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Poisoned_TLP_Status) & BM_PCIE_RC_UESR_Poisoned_TLP_Status)

/*! @brief Set the Poisoned_TLP_Status field to a new value. */
#define BW_PCIE_RC_UESR_Poisoned_TLP_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Poisoned_TLP_Status) | BF_PCIE_RC_UESR_Poisoned_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Flow_Control_Protocol_Error_Status[13] (RW)
 *
 * Flow Control Protocol Error Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status (13U) /*!< Bit position for PCIE_RC_UESR_Flow_Control_Protocol_Error_Status. */
#define BM_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status (0x00002000U) /*!< Bit mask for PCIE_RC_UESR_Flow_Control_Protocol_Error_Status. */
#define BS_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Flow_Control_Protocol_Error_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Flow_Control_Protocol_Error_Status field. */
#define BR_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status(x) (HW_PCIE_RC_UESR(x).B.Flow_Control_Protocol_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Flow_Control_Protocol_Error_Status. */
#define BF_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status) & BM_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status)

/*! @brief Set the Flow_Control_Protocol_Error_Status field to a new value. */
#define BW_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status) | BF_PCIE_RC_UESR_Flow_Control_Protocol_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Completion_Timeout_Status[14] (RW)
 *
 * Completion Timeout Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Completion_Timeout_Status (14U) /*!< Bit position for PCIE_RC_UESR_Completion_Timeout_Status. */
#define BM_PCIE_RC_UESR_Completion_Timeout_Status (0x00004000U) /*!< Bit mask for PCIE_RC_UESR_Completion_Timeout_Status. */
#define BS_PCIE_RC_UESR_Completion_Timeout_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Completion_Timeout_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Completion_Timeout_Status field. */
#define BR_PCIE_RC_UESR_Completion_Timeout_Status(x) (HW_PCIE_RC_UESR(x).B.Completion_Timeout_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Completion_Timeout_Status. */
#define BF_PCIE_RC_UESR_Completion_Timeout_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Completion_Timeout_Status) & BM_PCIE_RC_UESR_Completion_Timeout_Status)

/*! @brief Set the Completion_Timeout_Status field to a new value. */
#define BW_PCIE_RC_UESR_Completion_Timeout_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Completion_Timeout_Status) | BF_PCIE_RC_UESR_Completion_Timeout_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Completer_Abort_Status[15] (RW)
 *
 * Completer Abort Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Completer_Abort_Status (15U) /*!< Bit position for PCIE_RC_UESR_Completer_Abort_Status. */
#define BM_PCIE_RC_UESR_Completer_Abort_Status (0x00008000U) /*!< Bit mask for PCIE_RC_UESR_Completer_Abort_Status. */
#define BS_PCIE_RC_UESR_Completer_Abort_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Completer_Abort_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Completer_Abort_Status field. */
#define BR_PCIE_RC_UESR_Completer_Abort_Status(x) (HW_PCIE_RC_UESR(x).B.Completer_Abort_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Completer_Abort_Status. */
#define BF_PCIE_RC_UESR_Completer_Abort_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Completer_Abort_Status) & BM_PCIE_RC_UESR_Completer_Abort_Status)

/*! @brief Set the Completer_Abort_Status field to a new value. */
#define BW_PCIE_RC_UESR_Completer_Abort_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Completer_Abort_Status) | BF_PCIE_RC_UESR_Completer_Abort_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Unexpected_Completion_Status[16] (RW)
 *
 * Unexpected Completion Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Unexpected_Completion_Status (16U) /*!< Bit position for PCIE_RC_UESR_Unexpected_Completion_Status. */
#define BM_PCIE_RC_UESR_Unexpected_Completion_Status (0x00010000U) /*!< Bit mask for PCIE_RC_UESR_Unexpected_Completion_Status. */
#define BS_PCIE_RC_UESR_Unexpected_Completion_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Unexpected_Completion_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Unexpected_Completion_Status field. */
#define BR_PCIE_RC_UESR_Unexpected_Completion_Status(x) (HW_PCIE_RC_UESR(x).B.Unexpected_Completion_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Unexpected_Completion_Status. */
#define BF_PCIE_RC_UESR_Unexpected_Completion_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Unexpected_Completion_Status) & BM_PCIE_RC_UESR_Unexpected_Completion_Status)

/*! @brief Set the Unexpected_Completion_Status field to a new value. */
#define BW_PCIE_RC_UESR_Unexpected_Completion_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Unexpected_Completion_Status) | BF_PCIE_RC_UESR_Unexpected_Completion_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Receiver_Overflow_Status[17] (RW)
 *
 * Receiver Overflow Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Receiver_Overflow_Status (17U) /*!< Bit position for PCIE_RC_UESR_Receiver_Overflow_Status. */
#define BM_PCIE_RC_UESR_Receiver_Overflow_Status (0x00020000U) /*!< Bit mask for PCIE_RC_UESR_Receiver_Overflow_Status. */
#define BS_PCIE_RC_UESR_Receiver_Overflow_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Receiver_Overflow_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Receiver_Overflow_Status field. */
#define BR_PCIE_RC_UESR_Receiver_Overflow_Status(x) (HW_PCIE_RC_UESR(x).B.Receiver_Overflow_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Receiver_Overflow_Status. */
#define BF_PCIE_RC_UESR_Receiver_Overflow_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Receiver_Overflow_Status) & BM_PCIE_RC_UESR_Receiver_Overflow_Status)

/*! @brief Set the Receiver_Overflow_Status field to a new value. */
#define BW_PCIE_RC_UESR_Receiver_Overflow_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Receiver_Overflow_Status) | BF_PCIE_RC_UESR_Receiver_Overflow_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Malformed_TLP_Status[18] (RW)
 *
 * Malformed TLP Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Malformed_TLP_Status (18U) /*!< Bit position for PCIE_RC_UESR_Malformed_TLP_Status. */
#define BM_PCIE_RC_UESR_Malformed_TLP_Status (0x00040000U) /*!< Bit mask for PCIE_RC_UESR_Malformed_TLP_Status. */
#define BS_PCIE_RC_UESR_Malformed_TLP_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Malformed_TLP_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Malformed_TLP_Status field. */
#define BR_PCIE_RC_UESR_Malformed_TLP_Status(x) (HW_PCIE_RC_UESR(x).B.Malformed_TLP_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Malformed_TLP_Status. */
#define BF_PCIE_RC_UESR_Malformed_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Malformed_TLP_Status) & BM_PCIE_RC_UESR_Malformed_TLP_Status)

/*! @brief Set the Malformed_TLP_Status field to a new value. */
#define BW_PCIE_RC_UESR_Malformed_TLP_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Malformed_TLP_Status) | BF_PCIE_RC_UESR_Malformed_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field ECRC_Error_Status[19] (RW)
 *
 * ECRC Error Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_ECRC_Error_Status (19U) /*!< Bit position for PCIE_RC_UESR_ECRC_Error_Status. */
#define BM_PCIE_RC_UESR_ECRC_Error_Status (0x00080000U) /*!< Bit mask for PCIE_RC_UESR_ECRC_Error_Status. */
#define BS_PCIE_RC_UESR_ECRC_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_ECRC_Error_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_ECRC_Error_Status field. */
#define BR_PCIE_RC_UESR_ECRC_Error_Status(x) (HW_PCIE_RC_UESR(x).B.ECRC_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_ECRC_Error_Status. */
#define BF_PCIE_RC_UESR_ECRC_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_ECRC_Error_Status) & BM_PCIE_RC_UESR_ECRC_Error_Status)

/*! @brief Set the ECRC_Error_Status field to a new value. */
#define BW_PCIE_RC_UESR_ECRC_Error_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_ECRC_Error_Status) | BF_PCIE_RC_UESR_ECRC_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESR, field Unsupported_Request_Error_Status[20] (RW)
 *
 * Unsupported Request Error Status
 */
/*@{*/
#define BP_PCIE_RC_UESR_Unsupported_Request_Error_Status (20U) /*!< Bit position for PCIE_RC_UESR_Unsupported_Request_Error_Status. */
#define BM_PCIE_RC_UESR_Unsupported_Request_Error_Status (0x00100000U) /*!< Bit mask for PCIE_RC_UESR_Unsupported_Request_Error_Status. */
#define BS_PCIE_RC_UESR_Unsupported_Request_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_UESR_Unsupported_Request_Error_Status. */

/*! @brief Read current value of the PCIE_RC_UESR_Unsupported_Request_Error_Status field. */
#define BR_PCIE_RC_UESR_Unsupported_Request_Error_Status(x) (HW_PCIE_RC_UESR(x).B.Unsupported_Request_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_UESR_Unsupported_Request_Error_Status. */
#define BF_PCIE_RC_UESR_Unsupported_Request_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESR_Unsupported_Request_Error_Status) & BM_PCIE_RC_UESR_Unsupported_Request_Error_Status)

/*! @brief Set the Unsupported_Request_Error_Status field to a new value. */
#define BW_PCIE_RC_UESR_Unsupported_Request_Error_Status(x, v) (HW_PCIE_RC_UESR_WR(x, (HW_PCIE_RC_UESR_RD(x) & ~BM_PCIE_RC_UESR_Unsupported_Request_Error_Status) | BF_PCIE_RC_UESR_Unsupported_Request_Error_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_UEMR - Uncorrectable Error Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_UEMR - Uncorrectable Error Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x08
 */
typedef union _hw_pcie_rc_uemr
{
    uint32_t U;
    struct _hw_pcie_rc_uemr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Mask : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Mask : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Mask : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Mask : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Mask : 1; /*!< [14]  */
        uint32_t Completer_Abort_Mask : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Mask : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Mask : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Mask : 1; /*!< [18]  */
        uint32_t ECRC_Error_Mask : 1;  /*!< [19]  */
        uint32_t Unsupported_Request_Error_Mask : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_rc_uemr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_UEMR register
 */
/*@{*/
#define HW_PCIE_RC_UEMR_ADDR(x)  ((uintptr_t)(x) + 0x108U)

#define HW_PCIE_RC_UEMR(x)       (*(__IO hw_pcie_rc_uemr_t *) HW_PCIE_RC_UEMR_ADDR(x))
#define HW_PCIE_RC_UEMR_RD(x)    (HW_PCIE_RC_UEMR(x).U)
#define HW_PCIE_RC_UEMR_WR(x, v) (HW_PCIE_RC_UEMR(x).U = (v))
#define HW_PCIE_RC_UEMR_SET(x, v) (HW_PCIE_RC_UEMR_WR(x, HW_PCIE_RC_UEMR_RD(x) |  (v)))
#define HW_PCIE_RC_UEMR_CLR(x, v) (HW_PCIE_RC_UEMR_WR(x, HW_PCIE_RC_UEMR_RD(x) & ~(v)))
#define HW_PCIE_RC_UEMR_TOG(x, v) (HW_PCIE_RC_UEMR_WR(x, HW_PCIE_RC_UEMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_UEMR bitfields
 */

/*!
 * @name Register PCIE_RC_UEMR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Mask for PCI Express 1.0a)
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Undefined (0U)     /*!< Bit position for PCIE_RC_UEMR_Undefined. */
#define BM_PCIE_RC_UEMR_Undefined (0x00000001U) /*!< Bit mask for PCIE_RC_UEMR_Undefined. */
#define BS_PCIE_RC_UEMR_Undefined (1U)     /*!< Bit field size in bits for PCIE_RC_UEMR_Undefined. */

/*! @brief Read current value of the PCIE_RC_UEMR_Undefined field. */
#define BR_PCIE_RC_UEMR_Undefined(x) (HW_PCIE_RC_UEMR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Undefined. */
#define BF_PCIE_RC_UEMR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Undefined) & BM_PCIE_RC_UEMR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_RC_UEMR_Undefined(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Undefined) | BF_PCIE_RC_UEMR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Data_Link_Protocol_Error_Mask[4] (RW)
 *
 * Data Link Protocol Error Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask (4U) /*!< Bit position for PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask. */
#define BM_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask (0x00000010U) /*!< Bit mask for PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask. */
#define BS_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask field. */
#define BR_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask(x) (HW_PCIE_RC_UEMR(x).B.Data_Link_Protocol_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask. */
#define BF_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask) & BM_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask)

/*! @brief Set the Data_Link_Protocol_Error_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask) | BF_PCIE_RC_UEMR_Data_Link_Protocol_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Surprise_Down_Error_Mask[5] (RW)
 *
 * Surprise Down Error Mask (not supported)
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Surprise_Down_Error_Mask (5U) /*!< Bit position for PCIE_RC_UEMR_Surprise_Down_Error_Mask. */
#define BM_PCIE_RC_UEMR_Surprise_Down_Error_Mask (0x00000020U) /*!< Bit mask for PCIE_RC_UEMR_Surprise_Down_Error_Mask. */
#define BS_PCIE_RC_UEMR_Surprise_Down_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Surprise_Down_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Surprise_Down_Error_Mask field. */
#define BR_PCIE_RC_UEMR_Surprise_Down_Error_Mask(x) (HW_PCIE_RC_UEMR(x).B.Surprise_Down_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Surprise_Down_Error_Mask. */
#define BF_PCIE_RC_UEMR_Surprise_Down_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Surprise_Down_Error_Mask) & BM_PCIE_RC_UEMR_Surprise_Down_Error_Mask)

/*! @brief Set the Surprise_Down_Error_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Surprise_Down_Error_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Surprise_Down_Error_Mask) | BF_PCIE_RC_UEMR_Surprise_Down_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Poisoned_TLP_Mask[12] (RW)
 *
 * Poisoned TLP Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Poisoned_TLP_Mask (12U) /*!< Bit position for PCIE_RC_UEMR_Poisoned_TLP_Mask. */
#define BM_PCIE_RC_UEMR_Poisoned_TLP_Mask (0x00001000U) /*!< Bit mask for PCIE_RC_UEMR_Poisoned_TLP_Mask. */
#define BS_PCIE_RC_UEMR_Poisoned_TLP_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Poisoned_TLP_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Poisoned_TLP_Mask field. */
#define BR_PCIE_RC_UEMR_Poisoned_TLP_Mask(x) (HW_PCIE_RC_UEMR(x).B.Poisoned_TLP_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Poisoned_TLP_Mask. */
#define BF_PCIE_RC_UEMR_Poisoned_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Poisoned_TLP_Mask) & BM_PCIE_RC_UEMR_Poisoned_TLP_Mask)

/*! @brief Set the Poisoned_TLP_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Poisoned_TLP_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Poisoned_TLP_Mask) | BF_PCIE_RC_UEMR_Poisoned_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Flow_Control_Protocol_Error_Mask[13] (RW)
 *
 * Flow Control Protocol Error Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask (13U) /*!< Bit position for PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BM_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask (0x00002000U) /*!< Bit mask for PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BS_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask field. */
#define BR_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask(x) (HW_PCIE_RC_UEMR(x).B.Flow_Control_Protocol_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask. */
#define BF_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask) & BM_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask)

/*! @brief Set the Flow_Control_Protocol_Error_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask) | BF_PCIE_RC_UEMR_Flow_Control_Protocol_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Completion_Timeout_Mask[14] (RW)
 *
 * Completion Timeout Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Completion_Timeout_Mask (14U) /*!< Bit position for PCIE_RC_UEMR_Completion_Timeout_Mask. */
#define BM_PCIE_RC_UEMR_Completion_Timeout_Mask (0x00004000U) /*!< Bit mask for PCIE_RC_UEMR_Completion_Timeout_Mask. */
#define BS_PCIE_RC_UEMR_Completion_Timeout_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Completion_Timeout_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Completion_Timeout_Mask field. */
#define BR_PCIE_RC_UEMR_Completion_Timeout_Mask(x) (HW_PCIE_RC_UEMR(x).B.Completion_Timeout_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Completion_Timeout_Mask. */
#define BF_PCIE_RC_UEMR_Completion_Timeout_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Completion_Timeout_Mask) & BM_PCIE_RC_UEMR_Completion_Timeout_Mask)

/*! @brief Set the Completion_Timeout_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Completion_Timeout_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Completion_Timeout_Mask) | BF_PCIE_RC_UEMR_Completion_Timeout_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Completer_Abort_Mask[15] (RW)
 *
 * Completer Abort Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Completer_Abort_Mask (15U) /*!< Bit position for PCIE_RC_UEMR_Completer_Abort_Mask. */
#define BM_PCIE_RC_UEMR_Completer_Abort_Mask (0x00008000U) /*!< Bit mask for PCIE_RC_UEMR_Completer_Abort_Mask. */
#define BS_PCIE_RC_UEMR_Completer_Abort_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Completer_Abort_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Completer_Abort_Mask field. */
#define BR_PCIE_RC_UEMR_Completer_Abort_Mask(x) (HW_PCIE_RC_UEMR(x).B.Completer_Abort_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Completer_Abort_Mask. */
#define BF_PCIE_RC_UEMR_Completer_Abort_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Completer_Abort_Mask) & BM_PCIE_RC_UEMR_Completer_Abort_Mask)

/*! @brief Set the Completer_Abort_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Completer_Abort_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Completer_Abort_Mask) | BF_PCIE_RC_UEMR_Completer_Abort_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Unexpected_Completion_Mask[16] (RW)
 *
 * Unexpected Completion Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Unexpected_Completion_Mask (16U) /*!< Bit position for PCIE_RC_UEMR_Unexpected_Completion_Mask. */
#define BM_PCIE_RC_UEMR_Unexpected_Completion_Mask (0x00010000U) /*!< Bit mask for PCIE_RC_UEMR_Unexpected_Completion_Mask. */
#define BS_PCIE_RC_UEMR_Unexpected_Completion_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Unexpected_Completion_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Unexpected_Completion_Mask field. */
#define BR_PCIE_RC_UEMR_Unexpected_Completion_Mask(x) (HW_PCIE_RC_UEMR(x).B.Unexpected_Completion_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Unexpected_Completion_Mask. */
#define BF_PCIE_RC_UEMR_Unexpected_Completion_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Unexpected_Completion_Mask) & BM_PCIE_RC_UEMR_Unexpected_Completion_Mask)

/*! @brief Set the Unexpected_Completion_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Unexpected_Completion_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Unexpected_Completion_Mask) | BF_PCIE_RC_UEMR_Unexpected_Completion_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Receiver_Overflow_Mask[17] (RW)
 *
 * Receiver Overflow Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Receiver_Overflow_Mask (17U) /*!< Bit position for PCIE_RC_UEMR_Receiver_Overflow_Mask. */
#define BM_PCIE_RC_UEMR_Receiver_Overflow_Mask (0x00020000U) /*!< Bit mask for PCIE_RC_UEMR_Receiver_Overflow_Mask. */
#define BS_PCIE_RC_UEMR_Receiver_Overflow_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Receiver_Overflow_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Receiver_Overflow_Mask field. */
#define BR_PCIE_RC_UEMR_Receiver_Overflow_Mask(x) (HW_PCIE_RC_UEMR(x).B.Receiver_Overflow_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Receiver_Overflow_Mask. */
#define BF_PCIE_RC_UEMR_Receiver_Overflow_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Receiver_Overflow_Mask) & BM_PCIE_RC_UEMR_Receiver_Overflow_Mask)

/*! @brief Set the Receiver_Overflow_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Receiver_Overflow_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Receiver_Overflow_Mask) | BF_PCIE_RC_UEMR_Receiver_Overflow_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Malformed_TLP_Mask[18] (RW)
 *
 * Malformed TLP Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Malformed_TLP_Mask (18U) /*!< Bit position for PCIE_RC_UEMR_Malformed_TLP_Mask. */
#define BM_PCIE_RC_UEMR_Malformed_TLP_Mask (0x00040000U) /*!< Bit mask for PCIE_RC_UEMR_Malformed_TLP_Mask. */
#define BS_PCIE_RC_UEMR_Malformed_TLP_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Malformed_TLP_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Malformed_TLP_Mask field. */
#define BR_PCIE_RC_UEMR_Malformed_TLP_Mask(x) (HW_PCIE_RC_UEMR(x).B.Malformed_TLP_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Malformed_TLP_Mask. */
#define BF_PCIE_RC_UEMR_Malformed_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Malformed_TLP_Mask) & BM_PCIE_RC_UEMR_Malformed_TLP_Mask)

/*! @brief Set the Malformed_TLP_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Malformed_TLP_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Malformed_TLP_Mask) | BF_PCIE_RC_UEMR_Malformed_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field ECRC_Error_Mask[19] (RW)
 *
 * ECRC Error Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_ECRC_Error_Mask (19U) /*!< Bit position for PCIE_RC_UEMR_ECRC_Error_Mask. */
#define BM_PCIE_RC_UEMR_ECRC_Error_Mask (0x00080000U) /*!< Bit mask for PCIE_RC_UEMR_ECRC_Error_Mask. */
#define BS_PCIE_RC_UEMR_ECRC_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_ECRC_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_ECRC_Error_Mask field. */
#define BR_PCIE_RC_UEMR_ECRC_Error_Mask(x) (HW_PCIE_RC_UEMR(x).B.ECRC_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_ECRC_Error_Mask. */
#define BF_PCIE_RC_UEMR_ECRC_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_ECRC_Error_Mask) & BM_PCIE_RC_UEMR_ECRC_Error_Mask)

/*! @brief Set the ECRC_Error_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_ECRC_Error_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_ECRC_Error_Mask) | BF_PCIE_RC_UEMR_ECRC_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UEMR, field Unsupported_Request_Error_Mask[20] (RW)
 *
 * Unsupported Request Error Mask
 */
/*@{*/
#define BP_PCIE_RC_UEMR_Unsupported_Request_Error_Mask (20U) /*!< Bit position for PCIE_RC_UEMR_Unsupported_Request_Error_Mask. */
#define BM_PCIE_RC_UEMR_Unsupported_Request_Error_Mask (0x00100000U) /*!< Bit mask for PCIE_RC_UEMR_Unsupported_Request_Error_Mask. */
#define BS_PCIE_RC_UEMR_Unsupported_Request_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_UEMR_Unsupported_Request_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_UEMR_Unsupported_Request_Error_Mask field. */
#define BR_PCIE_RC_UEMR_Unsupported_Request_Error_Mask(x) (HW_PCIE_RC_UEMR(x).B.Unsupported_Request_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_UEMR_Unsupported_Request_Error_Mask. */
#define BF_PCIE_RC_UEMR_Unsupported_Request_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UEMR_Unsupported_Request_Error_Mask) & BM_PCIE_RC_UEMR_Unsupported_Request_Error_Mask)

/*! @brief Set the Unsupported_Request_Error_Mask field to a new value. */
#define BW_PCIE_RC_UEMR_Unsupported_Request_Error_Mask(x, v) (HW_PCIE_RC_UEMR_WR(x, (HW_PCIE_RC_UEMR_RD(x) & ~BM_PCIE_RC_UEMR_Unsupported_Request_Error_Mask) | BF_PCIE_RC_UEMR_Unsupported_Request_Error_Mask(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_UESevR - Uncorrectable Error Severity Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_UESevR - Uncorrectable Error Severity Register (RW)
 *
 * Reset value: 0x000C2031U
 *
 * Offset: 0x0C
 */
typedef union _hw_pcie_rc_uesevr
{
    uint32_t U;
    struct _hw_pcie_rc_uesevr_bitfields
    {
        uint32_t Undefined : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 3;        /*!< [3:1]  */
        uint32_t Data_Link_Protocol_Error_Severity : 1; /*!< [4]  */
        uint32_t Surprise_Down_Error_Severity : 1; /*!< [5]  */
        uint32_t RESERVED1 : 6;        /*!< [11:6]  */
        uint32_t Poisoned_TLP_Severity : 1; /*!< [12]  */
        uint32_t Flow_Control_Protocol_Error_Severity : 1; /*!< [13]  */
        uint32_t Completion_Timeout_Severity : 1; /*!< [14]  */
        uint32_t Completer_Abort_Severity : 1; /*!< [15]  */
        uint32_t Unexpected_Completion_Severity : 1; /*!< [16]  */
        uint32_t Receiver_Overflow_Severity : 1; /*!< [17]  */
        uint32_t Malformed_TLP_Severity : 1; /*!< [18]  */
        uint32_t ECRC_Error_Severity : 1; /*!< [19]  */
        uint32_t Unsupported_Request_Error_Severity : 1; /*!< [20]  */
        uint32_t RESERVED2 : 11;       /*!< [31:21]  */
    } B;
} hw_pcie_rc_uesevr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_UESevR register
 */
/*@{*/
#define HW_PCIE_RC_UESevR_ADDR(x) ((uintptr_t)(x) + 0x10CU)

#define HW_PCIE_RC_UESevR(x)     (*(__IO hw_pcie_rc_uesevr_t *) HW_PCIE_RC_UESevR_ADDR(x))
#define HW_PCIE_RC_UESevR_RD(x)  (HW_PCIE_RC_UESevR(x).U)
#define HW_PCIE_RC_UESevR_WR(x, v) (HW_PCIE_RC_UESevR(x).U = (v))
#define HW_PCIE_RC_UESevR_SET(x, v) (HW_PCIE_RC_UESevR_WR(x, HW_PCIE_RC_UESevR_RD(x) |  (v)))
#define HW_PCIE_RC_UESevR_CLR(x, v) (HW_PCIE_RC_UESevR_WR(x, HW_PCIE_RC_UESevR_RD(x) & ~(v)))
#define HW_PCIE_RC_UESevR_TOG(x, v) (HW_PCIE_RC_UESevR_WR(x, HW_PCIE_RC_UESevR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_UESevR bitfields
 */

/*!
 * @name Register PCIE_RC_UESevR, field Undefined[0] (RW)
 *
 * Undefined for PCI Express 1.1 (Was Training Error Severity for PCI Express
 * 1.0a)
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Undefined (0U)   /*!< Bit position for PCIE_RC_UESevR_Undefined. */
#define BM_PCIE_RC_UESevR_Undefined (0x00000001U) /*!< Bit mask for PCIE_RC_UESevR_Undefined. */
#define BS_PCIE_RC_UESevR_Undefined (1U)   /*!< Bit field size in bits for PCIE_RC_UESevR_Undefined. */

/*! @brief Read current value of the PCIE_RC_UESevR_Undefined field. */
#define BR_PCIE_RC_UESevR_Undefined(x) (HW_PCIE_RC_UESevR(x).B.Undefined)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Undefined. */
#define BF_PCIE_RC_UESevR_Undefined(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Undefined) & BM_PCIE_RC_UESevR_Undefined)

/*! @brief Set the Undefined field to a new value. */
#define BW_PCIE_RC_UESevR_Undefined(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Undefined) | BF_PCIE_RC_UESevR_Undefined(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Data_Link_Protocol_Error_Severity[4] (RW)
 *
 * Data Link Protocol Error Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity (4U) /*!< Bit position for PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity. */
#define BM_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity (0x00000010U) /*!< Bit mask for PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity. */
#define BS_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity field. */
#define BR_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity(x) (HW_PCIE_RC_UESevR(x).B.Data_Link_Protocol_Error_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity. */
#define BF_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity) & BM_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity)

/*! @brief Set the Data_Link_Protocol_Error_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity) | BF_PCIE_RC_UESevR_Data_Link_Protocol_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Surprise_Down_Error_Severity[5] (RW)
 *
 * Surprise Down Error Severity (not supported)
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Surprise_Down_Error_Severity (5U) /*!< Bit position for PCIE_RC_UESevR_Surprise_Down_Error_Severity. */
#define BM_PCIE_RC_UESevR_Surprise_Down_Error_Severity (0x00000020U) /*!< Bit mask for PCIE_RC_UESevR_Surprise_Down_Error_Severity. */
#define BS_PCIE_RC_UESevR_Surprise_Down_Error_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Surprise_Down_Error_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Surprise_Down_Error_Severity field. */
#define BR_PCIE_RC_UESevR_Surprise_Down_Error_Severity(x) (HW_PCIE_RC_UESevR(x).B.Surprise_Down_Error_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Surprise_Down_Error_Severity. */
#define BF_PCIE_RC_UESevR_Surprise_Down_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Surprise_Down_Error_Severity) & BM_PCIE_RC_UESevR_Surprise_Down_Error_Severity)

/*! @brief Set the Surprise_Down_Error_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Surprise_Down_Error_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Surprise_Down_Error_Severity) | BF_PCIE_RC_UESevR_Surprise_Down_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Poisoned_TLP_Severity[12] (RW)
 *
 * Poisoned TLP Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Poisoned_TLP_Severity (12U) /*!< Bit position for PCIE_RC_UESevR_Poisoned_TLP_Severity. */
#define BM_PCIE_RC_UESevR_Poisoned_TLP_Severity (0x00001000U) /*!< Bit mask for PCIE_RC_UESevR_Poisoned_TLP_Severity. */
#define BS_PCIE_RC_UESevR_Poisoned_TLP_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Poisoned_TLP_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Poisoned_TLP_Severity field. */
#define BR_PCIE_RC_UESevR_Poisoned_TLP_Severity(x) (HW_PCIE_RC_UESevR(x).B.Poisoned_TLP_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Poisoned_TLP_Severity. */
#define BF_PCIE_RC_UESevR_Poisoned_TLP_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Poisoned_TLP_Severity) & BM_PCIE_RC_UESevR_Poisoned_TLP_Severity)

/*! @brief Set the Poisoned_TLP_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Poisoned_TLP_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Poisoned_TLP_Severity) | BF_PCIE_RC_UESevR_Poisoned_TLP_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Flow_Control_Protocol_Error_Severity[13] (RW)
 *
 * Flow Control Protocol Error Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity (13U) /*!< Bit position for PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BM_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity (0x00002000U) /*!< Bit mask for PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BS_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity field. */
#define BR_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity(x) (HW_PCIE_RC_UESevR(x).B.Flow_Control_Protocol_Error_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity. */
#define BF_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity) & BM_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity)

/*! @brief Set the Flow_Control_Protocol_Error_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity) | BF_PCIE_RC_UESevR_Flow_Control_Protocol_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Completion_Timeout_Severity[14] (RW)
 *
 * Completion Timeout Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Completion_Timeout_Severity (14U) /*!< Bit position for PCIE_RC_UESevR_Completion_Timeout_Severity. */
#define BM_PCIE_RC_UESevR_Completion_Timeout_Severity (0x00004000U) /*!< Bit mask for PCIE_RC_UESevR_Completion_Timeout_Severity. */
#define BS_PCIE_RC_UESevR_Completion_Timeout_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Completion_Timeout_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Completion_Timeout_Severity field. */
#define BR_PCIE_RC_UESevR_Completion_Timeout_Severity(x) (HW_PCIE_RC_UESevR(x).B.Completion_Timeout_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Completion_Timeout_Severity. */
#define BF_PCIE_RC_UESevR_Completion_Timeout_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Completion_Timeout_Severity) & BM_PCIE_RC_UESevR_Completion_Timeout_Severity)

/*! @brief Set the Completion_Timeout_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Completion_Timeout_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Completion_Timeout_Severity) | BF_PCIE_RC_UESevR_Completion_Timeout_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Completer_Abort_Severity[15] (RW)
 *
 * Completer Abort Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Completer_Abort_Severity (15U) /*!< Bit position for PCIE_RC_UESevR_Completer_Abort_Severity. */
#define BM_PCIE_RC_UESevR_Completer_Abort_Severity (0x00008000U) /*!< Bit mask for PCIE_RC_UESevR_Completer_Abort_Severity. */
#define BS_PCIE_RC_UESevR_Completer_Abort_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Completer_Abort_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Completer_Abort_Severity field. */
#define BR_PCIE_RC_UESevR_Completer_Abort_Severity(x) (HW_PCIE_RC_UESevR(x).B.Completer_Abort_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Completer_Abort_Severity. */
#define BF_PCIE_RC_UESevR_Completer_Abort_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Completer_Abort_Severity) & BM_PCIE_RC_UESevR_Completer_Abort_Severity)

/*! @brief Set the Completer_Abort_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Completer_Abort_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Completer_Abort_Severity) | BF_PCIE_RC_UESevR_Completer_Abort_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Unexpected_Completion_Severity[16] (RW)
 *
 * Unexpected Completion Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Unexpected_Completion_Severity (16U) /*!< Bit position for PCIE_RC_UESevR_Unexpected_Completion_Severity. */
#define BM_PCIE_RC_UESevR_Unexpected_Completion_Severity (0x00010000U) /*!< Bit mask for PCIE_RC_UESevR_Unexpected_Completion_Severity. */
#define BS_PCIE_RC_UESevR_Unexpected_Completion_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Unexpected_Completion_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Unexpected_Completion_Severity field. */
#define BR_PCIE_RC_UESevR_Unexpected_Completion_Severity(x) (HW_PCIE_RC_UESevR(x).B.Unexpected_Completion_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Unexpected_Completion_Severity. */
#define BF_PCIE_RC_UESevR_Unexpected_Completion_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Unexpected_Completion_Severity) & BM_PCIE_RC_UESevR_Unexpected_Completion_Severity)

/*! @brief Set the Unexpected_Completion_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Unexpected_Completion_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Unexpected_Completion_Severity) | BF_PCIE_RC_UESevR_Unexpected_Completion_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Receiver_Overflow_Severity[17] (RW)
 *
 * Receiver Overflow Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Receiver_Overflow_Severity (17U) /*!< Bit position for PCIE_RC_UESevR_Receiver_Overflow_Severity. */
#define BM_PCIE_RC_UESevR_Receiver_Overflow_Severity (0x00020000U) /*!< Bit mask for PCIE_RC_UESevR_Receiver_Overflow_Severity. */
#define BS_PCIE_RC_UESevR_Receiver_Overflow_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Receiver_Overflow_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Receiver_Overflow_Severity field. */
#define BR_PCIE_RC_UESevR_Receiver_Overflow_Severity(x) (HW_PCIE_RC_UESevR(x).B.Receiver_Overflow_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Receiver_Overflow_Severity. */
#define BF_PCIE_RC_UESevR_Receiver_Overflow_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Receiver_Overflow_Severity) & BM_PCIE_RC_UESevR_Receiver_Overflow_Severity)

/*! @brief Set the Receiver_Overflow_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Receiver_Overflow_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Receiver_Overflow_Severity) | BF_PCIE_RC_UESevR_Receiver_Overflow_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Malformed_TLP_Severity[18] (RW)
 *
 * Malformed TLP Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Malformed_TLP_Severity (18U) /*!< Bit position for PCIE_RC_UESevR_Malformed_TLP_Severity. */
#define BM_PCIE_RC_UESevR_Malformed_TLP_Severity (0x00040000U) /*!< Bit mask for PCIE_RC_UESevR_Malformed_TLP_Severity. */
#define BS_PCIE_RC_UESevR_Malformed_TLP_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Malformed_TLP_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Malformed_TLP_Severity field. */
#define BR_PCIE_RC_UESevR_Malformed_TLP_Severity(x) (HW_PCIE_RC_UESevR(x).B.Malformed_TLP_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Malformed_TLP_Severity. */
#define BF_PCIE_RC_UESevR_Malformed_TLP_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Malformed_TLP_Severity) & BM_PCIE_RC_UESevR_Malformed_TLP_Severity)

/*! @brief Set the Malformed_TLP_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Malformed_TLP_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Malformed_TLP_Severity) | BF_PCIE_RC_UESevR_Malformed_TLP_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field ECRC_Error_Severity[19] (RW)
 *
 * ECRC Error Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_ECRC_Error_Severity (19U) /*!< Bit position for PCIE_RC_UESevR_ECRC_Error_Severity. */
#define BM_PCIE_RC_UESevR_ECRC_Error_Severity (0x00080000U) /*!< Bit mask for PCIE_RC_UESevR_ECRC_Error_Severity. */
#define BS_PCIE_RC_UESevR_ECRC_Error_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_ECRC_Error_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_ECRC_Error_Severity field. */
#define BR_PCIE_RC_UESevR_ECRC_Error_Severity(x) (HW_PCIE_RC_UESevR(x).B.ECRC_Error_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_ECRC_Error_Severity. */
#define BF_PCIE_RC_UESevR_ECRC_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_ECRC_Error_Severity) & BM_PCIE_RC_UESevR_ECRC_Error_Severity)

/*! @brief Set the ECRC_Error_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_ECRC_Error_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_ECRC_Error_Severity) | BF_PCIE_RC_UESevR_ECRC_Error_Severity(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_UESevR, field Unsupported_Request_Error_Severity[20] (RW)
 *
 * Unsupported Request Error Severity
 */
/*@{*/
#define BP_PCIE_RC_UESevR_Unsupported_Request_Error_Severity (20U) /*!< Bit position for PCIE_RC_UESevR_Unsupported_Request_Error_Severity. */
#define BM_PCIE_RC_UESevR_Unsupported_Request_Error_Severity (0x00100000U) /*!< Bit mask for PCIE_RC_UESevR_Unsupported_Request_Error_Severity. */
#define BS_PCIE_RC_UESevR_Unsupported_Request_Error_Severity (1U) /*!< Bit field size in bits for PCIE_RC_UESevR_Unsupported_Request_Error_Severity. */

/*! @brief Read current value of the PCIE_RC_UESevR_Unsupported_Request_Error_Severity field. */
#define BR_PCIE_RC_UESevR_Unsupported_Request_Error_Severity(x) (HW_PCIE_RC_UESevR(x).B.Unsupported_Request_Error_Severity)

/*! @brief Format value for bitfield PCIE_RC_UESevR_Unsupported_Request_Error_Severity. */
#define BF_PCIE_RC_UESevR_Unsupported_Request_Error_Severity(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_UESevR_Unsupported_Request_Error_Severity) & BM_PCIE_RC_UESevR_Unsupported_Request_Error_Severity)

/*! @brief Set the Unsupported_Request_Error_Severity field to a new value. */
#define BW_PCIE_RC_UESevR_Unsupported_Request_Error_Severity(x, v) (HW_PCIE_RC_UESevR_WR(x, (HW_PCIE_RC_UESevR_RD(x) & ~BM_PCIE_RC_UESevR_Unsupported_Request_Error_Severity) | BF_PCIE_RC_UESevR_Unsupported_Request_Error_Severity(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_CESR - Correctable Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_CESR - Correctable Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x10
 */
typedef union _hw_pcie_rc_cesr
{
    uint32_t U;
    struct _hw_pcie_rc_cesr_bitfields
    {
        uint32_t Receiver_Error_Status : 1; /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t Bad_TLP_Status : 1;   /*!< [6]  */
        uint32_t Bad_DLLP_Status : 1;  /*!< [7]  */
        uint32_t REPLAY_NUM_Rollover_Status : 1; /*!< [8]  */
        uint32_t RESERVED1 : 3;        /*!< [11:9]  */
        uint32_t Reply_Timer_Timeout_Status : 1; /*!< [12]  */
        uint32_t Advisory_Non_Fatal_Error_Status : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_pcie_rc_cesr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_CESR register
 */
/*@{*/
#define HW_PCIE_RC_CESR_ADDR(x)  ((uintptr_t)(x) + 0x110U)

#define HW_PCIE_RC_CESR(x)       (*(__IO hw_pcie_rc_cesr_t *) HW_PCIE_RC_CESR_ADDR(x))
#define HW_PCIE_RC_CESR_RD(x)    (HW_PCIE_RC_CESR(x).U)
#define HW_PCIE_RC_CESR_WR(x, v) (HW_PCIE_RC_CESR(x).U = (v))
#define HW_PCIE_RC_CESR_SET(x, v) (HW_PCIE_RC_CESR_WR(x, HW_PCIE_RC_CESR_RD(x) |  (v)))
#define HW_PCIE_RC_CESR_CLR(x, v) (HW_PCIE_RC_CESR_WR(x, HW_PCIE_RC_CESR_RD(x) & ~(v)))
#define HW_PCIE_RC_CESR_TOG(x, v) (HW_PCIE_RC_CESR_WR(x, HW_PCIE_RC_CESR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_CESR bitfields
 */

/*!
 * @name Register PCIE_RC_CESR, field Receiver_Error_Status[0] (RW)
 *
 * Receiver Error Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_Receiver_Error_Status (0U) /*!< Bit position for PCIE_RC_CESR_Receiver_Error_Status. */
#define BM_PCIE_RC_CESR_Receiver_Error_Status (0x00000001U) /*!< Bit mask for PCIE_RC_CESR_Receiver_Error_Status. */
#define BS_PCIE_RC_CESR_Receiver_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_Receiver_Error_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_Receiver_Error_Status field. */
#define BR_PCIE_RC_CESR_Receiver_Error_Status(x) (HW_PCIE_RC_CESR(x).B.Receiver_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_Receiver_Error_Status. */
#define BF_PCIE_RC_CESR_Receiver_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_Receiver_Error_Status) & BM_PCIE_RC_CESR_Receiver_Error_Status)

/*! @brief Set the Receiver_Error_Status field to a new value. */
#define BW_PCIE_RC_CESR_Receiver_Error_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_Receiver_Error_Status) | BF_PCIE_RC_CESR_Receiver_Error_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CESR, field Bad_TLP_Status[6] (RW)
 *
 * Bad TLP Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_Bad_TLP_Status (6U) /*!< Bit position for PCIE_RC_CESR_Bad_TLP_Status. */
#define BM_PCIE_RC_CESR_Bad_TLP_Status (0x00000040U) /*!< Bit mask for PCIE_RC_CESR_Bad_TLP_Status. */
#define BS_PCIE_RC_CESR_Bad_TLP_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_Bad_TLP_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_Bad_TLP_Status field. */
#define BR_PCIE_RC_CESR_Bad_TLP_Status(x) (HW_PCIE_RC_CESR(x).B.Bad_TLP_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_Bad_TLP_Status. */
#define BF_PCIE_RC_CESR_Bad_TLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_Bad_TLP_Status) & BM_PCIE_RC_CESR_Bad_TLP_Status)

/*! @brief Set the Bad_TLP_Status field to a new value. */
#define BW_PCIE_RC_CESR_Bad_TLP_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_Bad_TLP_Status) | BF_PCIE_RC_CESR_Bad_TLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CESR, field Bad_DLLP_Status[7] (RW)
 *
 * Bad DLLP Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_Bad_DLLP_Status (7U) /*!< Bit position for PCIE_RC_CESR_Bad_DLLP_Status. */
#define BM_PCIE_RC_CESR_Bad_DLLP_Status (0x00000080U) /*!< Bit mask for PCIE_RC_CESR_Bad_DLLP_Status. */
#define BS_PCIE_RC_CESR_Bad_DLLP_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_Bad_DLLP_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_Bad_DLLP_Status field. */
#define BR_PCIE_RC_CESR_Bad_DLLP_Status(x) (HW_PCIE_RC_CESR(x).B.Bad_DLLP_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_Bad_DLLP_Status. */
#define BF_PCIE_RC_CESR_Bad_DLLP_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_Bad_DLLP_Status) & BM_PCIE_RC_CESR_Bad_DLLP_Status)

/*! @brief Set the Bad_DLLP_Status field to a new value. */
#define BW_PCIE_RC_CESR_Bad_DLLP_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_Bad_DLLP_Status) | BF_PCIE_RC_CESR_Bad_DLLP_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CESR, field REPLAY_NUM_Rollover_Status[8] (RW)
 *
 * REPLAY_NUM Rollover Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status (8U) /*!< Bit position for PCIE_RC_CESR_REPLAY_NUM_Rollover_Status. */
#define BM_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status (0x00000100U) /*!< Bit mask for PCIE_RC_CESR_REPLAY_NUM_Rollover_Status. */
#define BS_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_REPLAY_NUM_Rollover_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_REPLAY_NUM_Rollover_Status field. */
#define BR_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status(x) (HW_PCIE_RC_CESR(x).B.REPLAY_NUM_Rollover_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_REPLAY_NUM_Rollover_Status. */
#define BF_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status) & BM_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status)

/*! @brief Set the REPLAY_NUM_Rollover_Status field to a new value. */
#define BW_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status) | BF_PCIE_RC_CESR_REPLAY_NUM_Rollover_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CESR, field Reply_Timer_Timeout_Status[12] (RW)
 *
 * Reply Timer Timeout Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_Reply_Timer_Timeout_Status (12U) /*!< Bit position for PCIE_RC_CESR_Reply_Timer_Timeout_Status. */
#define BM_PCIE_RC_CESR_Reply_Timer_Timeout_Status (0x00001000U) /*!< Bit mask for PCIE_RC_CESR_Reply_Timer_Timeout_Status. */
#define BS_PCIE_RC_CESR_Reply_Timer_Timeout_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_Reply_Timer_Timeout_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_Reply_Timer_Timeout_Status field. */
#define BR_PCIE_RC_CESR_Reply_Timer_Timeout_Status(x) (HW_PCIE_RC_CESR(x).B.Reply_Timer_Timeout_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_Reply_Timer_Timeout_Status. */
#define BF_PCIE_RC_CESR_Reply_Timer_Timeout_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_Reply_Timer_Timeout_Status) & BM_PCIE_RC_CESR_Reply_Timer_Timeout_Status)

/*! @brief Set the Reply_Timer_Timeout_Status field to a new value. */
#define BW_PCIE_RC_CESR_Reply_Timer_Timeout_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_Reply_Timer_Timeout_Status) | BF_PCIE_RC_CESR_Reply_Timer_Timeout_Status(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CESR, field Advisory_Non_Fatal_Error_Status[13] (RW)
 *
 * Advisory Non-Fatal Error Status
 */
/*@{*/
#define BP_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status (13U) /*!< Bit position for PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status. */
#define BM_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status (0x00002000U) /*!< Bit mask for PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status. */
#define BS_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status (1U) /*!< Bit field size in bits for PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status. */

/*! @brief Read current value of the PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status field. */
#define BR_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status(x) (HW_PCIE_RC_CESR(x).B.Advisory_Non_Fatal_Error_Status)

/*! @brief Format value for bitfield PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status. */
#define BF_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status) & BM_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status)

/*! @brief Set the Advisory_Non_Fatal_Error_Status field to a new value. */
#define BW_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status(x, v) (HW_PCIE_RC_CESR_WR(x, (HW_PCIE_RC_CESR_RD(x) & ~BM_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status) | BF_PCIE_RC_CESR_Advisory_Non_Fatal_Error_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_CEMR - Correctable Error Mask Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_CEMR - Correctable Error Mask Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x14
 */
typedef union _hw_pcie_rc_cemr
{
    uint32_t U;
    struct _hw_pcie_rc_cemr_bitfields
    {
        uint32_t Receiver_Error_Mask : 1; /*!< [0]  */
        uint32_t RESERVED0 : 5;        /*!< [5:1]  */
        uint32_t Bad_TLP_Mask : 1;     /*!< [6]  */
        uint32_t Bad_DLLP_Mask : 1;    /*!< [7]  */
        uint32_t REPLAY_NUM_Rollover_Mask : 1; /*!< [8]  */
        uint32_t RESERVED1 : 3;        /*!< [11:9]  */
        uint32_t Reply_Timer_Timeout_Mask : 1; /*!< [12]  */
        uint32_t Advisory_Non_Fatal_Error_Mask : 1; /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_pcie_rc_cemr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_CEMR register
 */
/*@{*/
#define HW_PCIE_RC_CEMR_ADDR(x)  ((uintptr_t)(x) + 0x114U)

#define HW_PCIE_RC_CEMR(x)       (*(__IO hw_pcie_rc_cemr_t *) HW_PCIE_RC_CEMR_ADDR(x))
#define HW_PCIE_RC_CEMR_RD(x)    (HW_PCIE_RC_CEMR(x).U)
#define HW_PCIE_RC_CEMR_WR(x, v) (HW_PCIE_RC_CEMR(x).U = (v))
#define HW_PCIE_RC_CEMR_SET(x, v) (HW_PCIE_RC_CEMR_WR(x, HW_PCIE_RC_CEMR_RD(x) |  (v)))
#define HW_PCIE_RC_CEMR_CLR(x, v) (HW_PCIE_RC_CEMR_WR(x, HW_PCIE_RC_CEMR_RD(x) & ~(v)))
#define HW_PCIE_RC_CEMR_TOG(x, v) (HW_PCIE_RC_CEMR_WR(x, HW_PCIE_RC_CEMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_CEMR bitfields
 */

/*!
 * @name Register PCIE_RC_CEMR, field Receiver_Error_Mask[0] (RW)
 *
 * Receiver Error Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_Receiver_Error_Mask (0U) /*!< Bit position for PCIE_RC_CEMR_Receiver_Error_Mask. */
#define BM_PCIE_RC_CEMR_Receiver_Error_Mask (0x00000001U) /*!< Bit mask for PCIE_RC_CEMR_Receiver_Error_Mask. */
#define BS_PCIE_RC_CEMR_Receiver_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_CEMR_Receiver_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_Receiver_Error_Mask field. */
#define BR_PCIE_RC_CEMR_Receiver_Error_Mask(x) (HW_PCIE_RC_CEMR(x).B.Receiver_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_Receiver_Error_Mask. */
#define BF_PCIE_RC_CEMR_Receiver_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_Receiver_Error_Mask) & BM_PCIE_RC_CEMR_Receiver_Error_Mask)

/*! @brief Set the Receiver_Error_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_Receiver_Error_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_Receiver_Error_Mask) | BF_PCIE_RC_CEMR_Receiver_Error_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CEMR, field Bad_TLP_Mask[6] (RW)
 *
 * Bad TLP Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_Bad_TLP_Mask (6U)  /*!< Bit position for PCIE_RC_CEMR_Bad_TLP_Mask. */
#define BM_PCIE_RC_CEMR_Bad_TLP_Mask (0x00000040U) /*!< Bit mask for PCIE_RC_CEMR_Bad_TLP_Mask. */
#define BS_PCIE_RC_CEMR_Bad_TLP_Mask (1U)  /*!< Bit field size in bits for PCIE_RC_CEMR_Bad_TLP_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_Bad_TLP_Mask field. */
#define BR_PCIE_RC_CEMR_Bad_TLP_Mask(x) (HW_PCIE_RC_CEMR(x).B.Bad_TLP_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_Bad_TLP_Mask. */
#define BF_PCIE_RC_CEMR_Bad_TLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_Bad_TLP_Mask) & BM_PCIE_RC_CEMR_Bad_TLP_Mask)

/*! @brief Set the Bad_TLP_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_Bad_TLP_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_Bad_TLP_Mask) | BF_PCIE_RC_CEMR_Bad_TLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CEMR, field Bad_DLLP_Mask[7] (RW)
 *
 * Bad DLLP Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_Bad_DLLP_Mask (7U) /*!< Bit position for PCIE_RC_CEMR_Bad_DLLP_Mask. */
#define BM_PCIE_RC_CEMR_Bad_DLLP_Mask (0x00000080U) /*!< Bit mask for PCIE_RC_CEMR_Bad_DLLP_Mask. */
#define BS_PCIE_RC_CEMR_Bad_DLLP_Mask (1U) /*!< Bit field size in bits for PCIE_RC_CEMR_Bad_DLLP_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_Bad_DLLP_Mask field. */
#define BR_PCIE_RC_CEMR_Bad_DLLP_Mask(x) (HW_PCIE_RC_CEMR(x).B.Bad_DLLP_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_Bad_DLLP_Mask. */
#define BF_PCIE_RC_CEMR_Bad_DLLP_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_Bad_DLLP_Mask) & BM_PCIE_RC_CEMR_Bad_DLLP_Mask)

/*! @brief Set the Bad_DLLP_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_Bad_DLLP_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_Bad_DLLP_Mask) | BF_PCIE_RC_CEMR_Bad_DLLP_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CEMR, field REPLAY_NUM_Rollover_Mask[8] (RW)
 *
 * REPLAY_NUM Rollover Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask (8U) /*!< Bit position for PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BM_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask (0x00000100U) /*!< Bit mask for PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BS_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask (1U) /*!< Bit field size in bits for PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask field. */
#define BR_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask(x) (HW_PCIE_RC_CEMR(x).B.REPLAY_NUM_Rollover_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask. */
#define BF_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask) & BM_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask)

/*! @brief Set the REPLAY_NUM_Rollover_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask) | BF_PCIE_RC_CEMR_REPLAY_NUM_Rollover_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CEMR, field Reply_Timer_Timeout_Mask[12] (RW)
 *
 * Reply Timer Timeout Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask (12U) /*!< Bit position for PCIE_RC_CEMR_Reply_Timer_Timeout_Mask. */
#define BM_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask (0x00001000U) /*!< Bit mask for PCIE_RC_CEMR_Reply_Timer_Timeout_Mask. */
#define BS_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask (1U) /*!< Bit field size in bits for PCIE_RC_CEMR_Reply_Timer_Timeout_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_Reply_Timer_Timeout_Mask field. */
#define BR_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask(x) (HW_PCIE_RC_CEMR(x).B.Reply_Timer_Timeout_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_Reply_Timer_Timeout_Mask. */
#define BF_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask) & BM_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask)

/*! @brief Set the Reply_Timer_Timeout_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask) | BF_PCIE_RC_CEMR_Reply_Timer_Timeout_Mask(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_CEMR, field Advisory_Non_Fatal_Error_Mask[13] (RW)
 *
 * Advisory Non-Fatal Error Mask
 */
/*@{*/
#define BP_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask (13U) /*!< Bit position for PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BM_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask (0x00002000U) /*!< Bit mask for PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BS_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask (1U) /*!< Bit field size in bits for PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask. */

/*! @brief Read current value of the PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask field. */
#define BR_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask(x) (HW_PCIE_RC_CEMR(x).B.Advisory_Non_Fatal_Error_Mask)

/*! @brief Format value for bitfield PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask. */
#define BF_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask) & BM_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask)

/*! @brief Set the Advisory_Non_Fatal_Error_Mask field to a new value. */
#define BW_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask(x, v) (HW_PCIE_RC_CEMR_WR(x, (HW_PCIE_RC_CEMR_RD(x) & ~BM_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask) | BF_PCIE_RC_CEMR_Advisory_Non_Fatal_Error_Mask(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_ACCR - Advanced Capabilities and Control Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_ACCR - Advanced Capabilities and Control Register (RW)
 *
 * Reset value: 0x000000A0U
 *
 * Offset: 0x18
 */
typedef union _hw_pcie_rc_accr
{
    uint32_t U;
    struct _hw_pcie_rc_accr_bitfields
    {
        uint32_t First_Error_Pointer : 5; /*!< [4:0]  */
        uint32_t ECRC_Generation_Capability : 1; /*!< [5]  */
        uint32_t ECRC_Generation_Enable : 1; /*!< [6]  */
        uint32_t ECRC_Check_Capable : 1; /*!< [7]  */
        uint32_t ECRC_Check_Enable : 1; /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_pcie_rc_accr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_ACCR register
 */
/*@{*/
#define HW_PCIE_RC_ACCR_ADDR(x)  ((uintptr_t)(x) + 0x118U)

#define HW_PCIE_RC_ACCR(x)       (*(__IO hw_pcie_rc_accr_t *) HW_PCIE_RC_ACCR_ADDR(x))
#define HW_PCIE_RC_ACCR_RD(x)    (HW_PCIE_RC_ACCR(x).U)
#define HW_PCIE_RC_ACCR_WR(x, v) (HW_PCIE_RC_ACCR(x).U = (v))
#define HW_PCIE_RC_ACCR_SET(x, v) (HW_PCIE_RC_ACCR_WR(x, HW_PCIE_RC_ACCR_RD(x) |  (v)))
#define HW_PCIE_RC_ACCR_CLR(x, v) (HW_PCIE_RC_ACCR_WR(x, HW_PCIE_RC_ACCR_RD(x) & ~(v)))
#define HW_PCIE_RC_ACCR_TOG(x, v) (HW_PCIE_RC_ACCR_WR(x, HW_PCIE_RC_ACCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_ACCR bitfields
 */

/*!
 * @name Register PCIE_RC_ACCR, field First_Error_Pointer[4:0] (RW)
 *
 * First Error Pointer
 */
/*@{*/
#define BP_PCIE_RC_ACCR_First_Error_Pointer (0U) /*!< Bit position for PCIE_RC_ACCR_First_Error_Pointer. */
#define BM_PCIE_RC_ACCR_First_Error_Pointer (0x0000001FU) /*!< Bit mask for PCIE_RC_ACCR_First_Error_Pointer. */
#define BS_PCIE_RC_ACCR_First_Error_Pointer (5U) /*!< Bit field size in bits for PCIE_RC_ACCR_First_Error_Pointer. */

/*! @brief Read current value of the PCIE_RC_ACCR_First_Error_Pointer field. */
#define BR_PCIE_RC_ACCR_First_Error_Pointer(x) (HW_PCIE_RC_ACCR(x).B.First_Error_Pointer)

/*! @brief Format value for bitfield PCIE_RC_ACCR_First_Error_Pointer. */
#define BF_PCIE_RC_ACCR_First_Error_Pointer(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_ACCR_First_Error_Pointer) & BM_PCIE_RC_ACCR_First_Error_Pointer)

/*! @brief Set the First_Error_Pointer field to a new value. */
#define BW_PCIE_RC_ACCR_First_Error_Pointer(x, v) (HW_PCIE_RC_ACCR_WR(x, (HW_PCIE_RC_ACCR_RD(x) & ~BM_PCIE_RC_ACCR_First_Error_Pointer) | BF_PCIE_RC_ACCR_First_Error_Pointer(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_ACCR, field ECRC_Generation_Capability[5] (RW)
 *
 * ECRC Generation Capability
 */
/*@{*/
#define BP_PCIE_RC_ACCR_ECRC_Generation_Capability (5U) /*!< Bit position for PCIE_RC_ACCR_ECRC_Generation_Capability. */
#define BM_PCIE_RC_ACCR_ECRC_Generation_Capability (0x00000020U) /*!< Bit mask for PCIE_RC_ACCR_ECRC_Generation_Capability. */
#define BS_PCIE_RC_ACCR_ECRC_Generation_Capability (1U) /*!< Bit field size in bits for PCIE_RC_ACCR_ECRC_Generation_Capability. */

/*! @brief Read current value of the PCIE_RC_ACCR_ECRC_Generation_Capability field. */
#define BR_PCIE_RC_ACCR_ECRC_Generation_Capability(x) (HW_PCIE_RC_ACCR(x).B.ECRC_Generation_Capability)

/*! @brief Format value for bitfield PCIE_RC_ACCR_ECRC_Generation_Capability. */
#define BF_PCIE_RC_ACCR_ECRC_Generation_Capability(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_ACCR_ECRC_Generation_Capability) & BM_PCIE_RC_ACCR_ECRC_Generation_Capability)

/*! @brief Set the ECRC_Generation_Capability field to a new value. */
#define BW_PCIE_RC_ACCR_ECRC_Generation_Capability(x, v) (HW_PCIE_RC_ACCR_WR(x, (HW_PCIE_RC_ACCR_RD(x) & ~BM_PCIE_RC_ACCR_ECRC_Generation_Capability) | BF_PCIE_RC_ACCR_ECRC_Generation_Capability(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_ACCR, field ECRC_Generation_Enable[6] (RW)
 *
 * ECRC Generation Enable
 */
/*@{*/
#define BP_PCIE_RC_ACCR_ECRC_Generation_Enable (6U) /*!< Bit position for PCIE_RC_ACCR_ECRC_Generation_Enable. */
#define BM_PCIE_RC_ACCR_ECRC_Generation_Enable (0x00000040U) /*!< Bit mask for PCIE_RC_ACCR_ECRC_Generation_Enable. */
#define BS_PCIE_RC_ACCR_ECRC_Generation_Enable (1U) /*!< Bit field size in bits for PCIE_RC_ACCR_ECRC_Generation_Enable. */

/*! @brief Read current value of the PCIE_RC_ACCR_ECRC_Generation_Enable field. */
#define BR_PCIE_RC_ACCR_ECRC_Generation_Enable(x) (HW_PCIE_RC_ACCR(x).B.ECRC_Generation_Enable)

/*! @brief Format value for bitfield PCIE_RC_ACCR_ECRC_Generation_Enable. */
#define BF_PCIE_RC_ACCR_ECRC_Generation_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_ACCR_ECRC_Generation_Enable) & BM_PCIE_RC_ACCR_ECRC_Generation_Enable)

/*! @brief Set the ECRC_Generation_Enable field to a new value. */
#define BW_PCIE_RC_ACCR_ECRC_Generation_Enable(x, v) (HW_PCIE_RC_ACCR_WR(x, (HW_PCIE_RC_ACCR_RD(x) & ~BM_PCIE_RC_ACCR_ECRC_Generation_Enable) | BF_PCIE_RC_ACCR_ECRC_Generation_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_ACCR, field ECRC_Check_Capable[7] (RW)
 *
 * ECRC Check Capable
 */
/*@{*/
#define BP_PCIE_RC_ACCR_ECRC_Check_Capable (7U) /*!< Bit position for PCIE_RC_ACCR_ECRC_Check_Capable. */
#define BM_PCIE_RC_ACCR_ECRC_Check_Capable (0x00000080U) /*!< Bit mask for PCIE_RC_ACCR_ECRC_Check_Capable. */
#define BS_PCIE_RC_ACCR_ECRC_Check_Capable (1U) /*!< Bit field size in bits for PCIE_RC_ACCR_ECRC_Check_Capable. */

/*! @brief Read current value of the PCIE_RC_ACCR_ECRC_Check_Capable field. */
#define BR_PCIE_RC_ACCR_ECRC_Check_Capable(x) (HW_PCIE_RC_ACCR(x).B.ECRC_Check_Capable)

/*! @brief Format value for bitfield PCIE_RC_ACCR_ECRC_Check_Capable. */
#define BF_PCIE_RC_ACCR_ECRC_Check_Capable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_ACCR_ECRC_Check_Capable) & BM_PCIE_RC_ACCR_ECRC_Check_Capable)

/*! @brief Set the ECRC_Check_Capable field to a new value. */
#define BW_PCIE_RC_ACCR_ECRC_Check_Capable(x, v) (HW_PCIE_RC_ACCR_WR(x, (HW_PCIE_RC_ACCR_RD(x) & ~BM_PCIE_RC_ACCR_ECRC_Check_Capable) | BF_PCIE_RC_ACCR_ECRC_Check_Capable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_ACCR, field ECRC_Check_Enable[8] (RW)
 *
 * ECRC Check Enable
 */
/*@{*/
#define BP_PCIE_RC_ACCR_ECRC_Check_Enable (8U) /*!< Bit position for PCIE_RC_ACCR_ECRC_Check_Enable. */
#define BM_PCIE_RC_ACCR_ECRC_Check_Enable (0x00000100U) /*!< Bit mask for PCIE_RC_ACCR_ECRC_Check_Enable. */
#define BS_PCIE_RC_ACCR_ECRC_Check_Enable (1U) /*!< Bit field size in bits for PCIE_RC_ACCR_ECRC_Check_Enable. */

/*! @brief Read current value of the PCIE_RC_ACCR_ECRC_Check_Enable field. */
#define BR_PCIE_RC_ACCR_ECRC_Check_Enable(x) (HW_PCIE_RC_ACCR(x).B.ECRC_Check_Enable)

/*! @brief Format value for bitfield PCIE_RC_ACCR_ECRC_Check_Enable. */
#define BF_PCIE_RC_ACCR_ECRC_Check_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_ACCR_ECRC_Check_Enable) & BM_PCIE_RC_ACCR_ECRC_Check_Enable)

/*! @brief Set the ECRC_Check_Enable field to a new value. */
#define BW_PCIE_RC_ACCR_ECRC_Check_Enable(x, v) (HW_PCIE_RC_ACCR_WR(x, (HW_PCIE_RC_ACCR_RD(x) & ~BM_PCIE_RC_ACCR_ECRC_Check_Enable) | BF_PCIE_RC_ACCR_ECRC_Check_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_HLR - Header Log Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_HLR - Header Log Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x1C The Header Log registers collect the header for the TLP
 * corresponding to a detected error. See the PCI Express 3.0 Specification for details.
 * Each of the Header Log registers is type ROS; the default reset value of each
 * Header Log register is 0x00000000.
 */
typedef union _hw_pcie_rc_hlr
{
    uint32_t U;
    struct _hw_pcie_rc_hlr_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_pcie_rc_hlr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_HLR register
 */
/*@{*/
#define HW_PCIE_RC_HLR_ADDR(x)   ((uintptr_t)(x) + 0x11CU)

#define HW_PCIE_RC_HLR(x)        (*(__I hw_pcie_rc_hlr_t *) HW_PCIE_RC_HLR_ADDR(x))
#define HW_PCIE_RC_HLR_RD(x)     (HW_PCIE_RC_HLR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_HLR bitfields
 */

/*******************************************************************************
 * HW_PCIE_RC_RECR - Root Error Command Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_RECR - Root Error Command Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x100 + 0x2C
 */
typedef union _hw_pcie_rc_recr
{
    uint32_t U;
    struct _hw_pcie_rc_recr_bitfields
    {
        uint32_t Correctable_Error_Reporting_Enable : 1; /*!< [0]  */
        uint32_t Non_Fatal_Error_Reporting_Enable : 1; /*!< [1]  */
        uint32_t Fatal_Error_Reporting_Enable : 1; /*!< [2]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_pcie_rc_recr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_RECR register
 */
/*@{*/
#define HW_PCIE_RC_RECR_ADDR(x)  ((uintptr_t)(x) + 0x12CU)

#define HW_PCIE_RC_RECR(x)       (*(__IO hw_pcie_rc_recr_t *) HW_PCIE_RC_RECR_ADDR(x))
#define HW_PCIE_RC_RECR_RD(x)    (HW_PCIE_RC_RECR(x).U)
#define HW_PCIE_RC_RECR_WR(x, v) (HW_PCIE_RC_RECR(x).U = (v))
#define HW_PCIE_RC_RECR_SET(x, v) (HW_PCIE_RC_RECR_WR(x, HW_PCIE_RC_RECR_RD(x) |  (v)))
#define HW_PCIE_RC_RECR_CLR(x, v) (HW_PCIE_RC_RECR_WR(x, HW_PCIE_RC_RECR_RD(x) & ~(v)))
#define HW_PCIE_RC_RECR_TOG(x, v) (HW_PCIE_RC_RECR_WR(x, HW_PCIE_RC_RECR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_RECR bitfields
 */

/*!
 * @name Register PCIE_RC_RECR, field Correctable_Error_Reporting_Enable[0] (RW)
 *
 * Correctable Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_RECR_Correctable_Error_Reporting_Enable (0U) /*!< Bit position for PCIE_RC_RECR_Correctable_Error_Reporting_Enable. */
#define BM_PCIE_RC_RECR_Correctable_Error_Reporting_Enable (0x00000001U) /*!< Bit mask for PCIE_RC_RECR_Correctable_Error_Reporting_Enable. */
#define BS_PCIE_RC_RECR_Correctable_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RECR_Correctable_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_RECR_Correctable_Error_Reporting_Enable field. */
#define BR_PCIE_RC_RECR_Correctable_Error_Reporting_Enable(x) (HW_PCIE_RC_RECR(x).B.Correctable_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_RECR_Correctable_Error_Reporting_Enable. */
#define BF_PCIE_RC_RECR_Correctable_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RECR_Correctable_Error_Reporting_Enable) & BM_PCIE_RC_RECR_Correctable_Error_Reporting_Enable)

/*! @brief Set the Correctable_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_RECR_Correctable_Error_Reporting_Enable(x, v) (HW_PCIE_RC_RECR_WR(x, (HW_PCIE_RC_RECR_RD(x) & ~BM_PCIE_RC_RECR_Correctable_Error_Reporting_Enable) | BF_PCIE_RC_RECR_Correctable_Error_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RECR, field Non_Fatal_Error_Reporting_Enable[1] (RW)
 *
 * Non-Fatal Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable (1U) /*!< Bit position for PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable. */
#define BM_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable (0x00000002U) /*!< Bit mask for PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable. */
#define BS_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable field. */
#define BR_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable(x) (HW_PCIE_RC_RECR(x).B.Non_Fatal_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable. */
#define BF_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable) & BM_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable)

/*! @brief Set the Non_Fatal_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable(x, v) (HW_PCIE_RC_RECR_WR(x, (HW_PCIE_RC_RECR_RD(x) & ~BM_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable) | BF_PCIE_RC_RECR_Non_Fatal_Error_Reporting_Enable(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RECR, field Fatal_Error_Reporting_Enable[2] (RW)
 *
 * Fatal Error Reporting Enable
 */
/*@{*/
#define BP_PCIE_RC_RECR_Fatal_Error_Reporting_Enable (2U) /*!< Bit position for PCIE_RC_RECR_Fatal_Error_Reporting_Enable. */
#define BM_PCIE_RC_RECR_Fatal_Error_Reporting_Enable (0x00000004U) /*!< Bit mask for PCIE_RC_RECR_Fatal_Error_Reporting_Enable. */
#define BS_PCIE_RC_RECR_Fatal_Error_Reporting_Enable (1U) /*!< Bit field size in bits for PCIE_RC_RECR_Fatal_Error_Reporting_Enable. */

/*! @brief Read current value of the PCIE_RC_RECR_Fatal_Error_Reporting_Enable field. */
#define BR_PCIE_RC_RECR_Fatal_Error_Reporting_Enable(x) (HW_PCIE_RC_RECR(x).B.Fatal_Error_Reporting_Enable)

/*! @brief Format value for bitfield PCIE_RC_RECR_Fatal_Error_Reporting_Enable. */
#define BF_PCIE_RC_RECR_Fatal_Error_Reporting_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RECR_Fatal_Error_Reporting_Enable) & BM_PCIE_RC_RECR_Fatal_Error_Reporting_Enable)

/*! @brief Set the Fatal_Error_Reporting_Enable field to a new value. */
#define BW_PCIE_RC_RECR_Fatal_Error_Reporting_Enable(x, v) (HW_PCIE_RC_RECR_WR(x, (HW_PCIE_RC_RECR_RD(x) & ~BM_PCIE_RC_RECR_Fatal_Error_Reporting_Enable) | BF_PCIE_RC_RECR_Fatal_Error_Reporting_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_RESR - Root Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_RESR - Root Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x100 + 0x30
 */
typedef union _hw_pcie_rc_resr
{
    uint32_t U;
    struct _hw_pcie_rc_resr_bitfields
    {
        uint32_t ERR_COR_Received : 1; /*!< [0]  */
        uint32_t Multiple_ERR_COR_Received : 1; /*!< [1]  */
        uint32_t ERR_FATAL_NONFATAL_Received : 1; /*!< [2]  */
        uint32_t Multiple_ERR_FATAL_NONFATAL_Received : 1; /*!< [3]  */
        uint32_t First_Uncorrectable_Fatal : 1; /*!< [4]  */
        uint32_t Non_Fatal_Error_Messages_Received : 1; /*!< [5]  */
        uint32_t Fatal_Error_Messages_Received : 1; /*!< [6]  */
        uint32_t RESERVED0 : 20;       /*!< [26:7]  */
        uint32_t Advanced_Error_Interrupt_Message_Number : 5; /*!< [31:27]  */
    } B;
} hw_pcie_rc_resr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_RESR register
 */
/*@{*/
#define HW_PCIE_RC_RESR_ADDR(x)  ((uintptr_t)(x) + 0x130U)

#define HW_PCIE_RC_RESR(x)       (*(__IO hw_pcie_rc_resr_t *) HW_PCIE_RC_RESR_ADDR(x))
#define HW_PCIE_RC_RESR_RD(x)    (HW_PCIE_RC_RESR(x).U)
#define HW_PCIE_RC_RESR_WR(x, v) (HW_PCIE_RC_RESR(x).U = (v))
#define HW_PCIE_RC_RESR_SET(x, v) (HW_PCIE_RC_RESR_WR(x, HW_PCIE_RC_RESR_RD(x) |  (v)))
#define HW_PCIE_RC_RESR_CLR(x, v) (HW_PCIE_RC_RESR_WR(x, HW_PCIE_RC_RESR_RD(x) & ~(v)))
#define HW_PCIE_RC_RESR_TOG(x, v) (HW_PCIE_RC_RESR_WR(x, HW_PCIE_RC_RESR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_RESR bitfields
 */

/*!
 * @name Register PCIE_RC_RESR, field ERR_COR_Received[0] (RW)
 *
 * ERR_COR Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_ERR_COR_Received (0U) /*!< Bit position for PCIE_RC_RESR_ERR_COR_Received. */
#define BM_PCIE_RC_RESR_ERR_COR_Received (0x00000001U) /*!< Bit mask for PCIE_RC_RESR_ERR_COR_Received. */
#define BS_PCIE_RC_RESR_ERR_COR_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_ERR_COR_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_ERR_COR_Received field. */
#define BR_PCIE_RC_RESR_ERR_COR_Received(x) (HW_PCIE_RC_RESR(x).B.ERR_COR_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_ERR_COR_Received. */
#define BF_PCIE_RC_RESR_ERR_COR_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_ERR_COR_Received) & BM_PCIE_RC_RESR_ERR_COR_Received)

/*! @brief Set the ERR_COR_Received field to a new value. */
#define BW_PCIE_RC_RESR_ERR_COR_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_ERR_COR_Received) | BF_PCIE_RC_RESR_ERR_COR_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field Multiple_ERR_COR_Received[1] (RW)
 *
 * Multiple ERR_COR Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_Multiple_ERR_COR_Received (1U) /*!< Bit position for PCIE_RC_RESR_Multiple_ERR_COR_Received. */
#define BM_PCIE_RC_RESR_Multiple_ERR_COR_Received (0x00000002U) /*!< Bit mask for PCIE_RC_RESR_Multiple_ERR_COR_Received. */
#define BS_PCIE_RC_RESR_Multiple_ERR_COR_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_Multiple_ERR_COR_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_Multiple_ERR_COR_Received field. */
#define BR_PCIE_RC_RESR_Multiple_ERR_COR_Received(x) (HW_PCIE_RC_RESR(x).B.Multiple_ERR_COR_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_Multiple_ERR_COR_Received. */
#define BF_PCIE_RC_RESR_Multiple_ERR_COR_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_Multiple_ERR_COR_Received) & BM_PCIE_RC_RESR_Multiple_ERR_COR_Received)

/*! @brief Set the Multiple_ERR_COR_Received field to a new value. */
#define BW_PCIE_RC_RESR_Multiple_ERR_COR_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_Multiple_ERR_COR_Received) | BF_PCIE_RC_RESR_Multiple_ERR_COR_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field ERR_FATAL_NONFATAL_Received[2] (RW)
 *
 * ERR_FATAL/NONFATAL Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received (2U) /*!< Bit position for PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received. */
#define BM_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received (0x00000004U) /*!< Bit mask for PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received. */
#define BS_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received field. */
#define BR_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received(x) (HW_PCIE_RC_RESR(x).B.ERR_FATAL_NONFATAL_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received. */
#define BF_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received) & BM_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received)

/*! @brief Set the ERR_FATAL_NONFATAL_Received field to a new value. */
#define BW_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received) | BF_PCIE_RC_RESR_ERR_FATAL_NONFATAL_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field Multiple_ERR_FATAL_NONFATAL_Received[3] (RW)
 *
 * Multiple ERR_FATAL/NONFATAL Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received (3U) /*!< Bit position for PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received. */
#define BM_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received (0x00000008U) /*!< Bit mask for PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received. */
#define BS_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received field. */
#define BR_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received(x) (HW_PCIE_RC_RESR(x).B.Multiple_ERR_FATAL_NONFATAL_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received. */
#define BF_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received) & BM_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received)

/*! @brief Set the Multiple_ERR_FATAL_NONFATAL_Received field to a new value. */
#define BW_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received) | BF_PCIE_RC_RESR_Multiple_ERR_FATAL_NONFATAL_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field First_Uncorrectable_Fatal[4] (RW)
 *
 * First Uncorrectable Fatal
 */
/*@{*/
#define BP_PCIE_RC_RESR_First_Uncorrectable_Fatal (4U) /*!< Bit position for PCIE_RC_RESR_First_Uncorrectable_Fatal. */
#define BM_PCIE_RC_RESR_First_Uncorrectable_Fatal (0x00000010U) /*!< Bit mask for PCIE_RC_RESR_First_Uncorrectable_Fatal. */
#define BS_PCIE_RC_RESR_First_Uncorrectable_Fatal (1U) /*!< Bit field size in bits for PCIE_RC_RESR_First_Uncorrectable_Fatal. */

/*! @brief Read current value of the PCIE_RC_RESR_First_Uncorrectable_Fatal field. */
#define BR_PCIE_RC_RESR_First_Uncorrectable_Fatal(x) (HW_PCIE_RC_RESR(x).B.First_Uncorrectable_Fatal)

/*! @brief Format value for bitfield PCIE_RC_RESR_First_Uncorrectable_Fatal. */
#define BF_PCIE_RC_RESR_First_Uncorrectable_Fatal(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_First_Uncorrectable_Fatal) & BM_PCIE_RC_RESR_First_Uncorrectable_Fatal)

/*! @brief Set the First_Uncorrectable_Fatal field to a new value. */
#define BW_PCIE_RC_RESR_First_Uncorrectable_Fatal(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_First_Uncorrectable_Fatal) | BF_PCIE_RC_RESR_First_Uncorrectable_Fatal(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field Non_Fatal_Error_Messages_Received[5] (RW)
 *
 * Non-Fatal Error Messages Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received (5U) /*!< Bit position for PCIE_RC_RESR_Non_Fatal_Error_Messages_Received. */
#define BM_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received (0x00000020U) /*!< Bit mask for PCIE_RC_RESR_Non_Fatal_Error_Messages_Received. */
#define BS_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_Non_Fatal_Error_Messages_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_Non_Fatal_Error_Messages_Received field. */
#define BR_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received(x) (HW_PCIE_RC_RESR(x).B.Non_Fatal_Error_Messages_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_Non_Fatal_Error_Messages_Received. */
#define BF_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received) & BM_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received)

/*! @brief Set the Non_Fatal_Error_Messages_Received field to a new value. */
#define BW_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received) | BF_PCIE_RC_RESR_Non_Fatal_Error_Messages_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field Fatal_Error_Messages_Received[6] (RW)
 *
 * Fatal Error Messages Received
 */
/*@{*/
#define BP_PCIE_RC_RESR_Fatal_Error_Messages_Received (6U) /*!< Bit position for PCIE_RC_RESR_Fatal_Error_Messages_Received. */
#define BM_PCIE_RC_RESR_Fatal_Error_Messages_Received (0x00000040U) /*!< Bit mask for PCIE_RC_RESR_Fatal_Error_Messages_Received. */
#define BS_PCIE_RC_RESR_Fatal_Error_Messages_Received (1U) /*!< Bit field size in bits for PCIE_RC_RESR_Fatal_Error_Messages_Received. */

/*! @brief Read current value of the PCIE_RC_RESR_Fatal_Error_Messages_Received field. */
#define BR_PCIE_RC_RESR_Fatal_Error_Messages_Received(x) (HW_PCIE_RC_RESR(x).B.Fatal_Error_Messages_Received)

/*! @brief Format value for bitfield PCIE_RC_RESR_Fatal_Error_Messages_Received. */
#define BF_PCIE_RC_RESR_Fatal_Error_Messages_Received(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_Fatal_Error_Messages_Received) & BM_PCIE_RC_RESR_Fatal_Error_Messages_Received)

/*! @brief Set the Fatal_Error_Messages_Received field to a new value. */
#define BW_PCIE_RC_RESR_Fatal_Error_Messages_Received(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_Fatal_Error_Messages_Received) | BF_PCIE_RC_RESR_Fatal_Error_Messages_Received(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_RESR, field Advanced_Error_Interrupt_Message_Number[31:27] (RW)
 *
 * Advanced Error Interrupt Message Number, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number (27U) /*!< Bit position for PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number. */
#define BM_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number (0xF8000000U) /*!< Bit mask for PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number. */
#define BS_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number (5U) /*!< Bit field size in bits for PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number. */

/*! @brief Read current value of the PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number field. */
#define BR_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number(x) (HW_PCIE_RC_RESR(x).B.Advanced_Error_Interrupt_Message_Number)

/*! @brief Format value for bitfield PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number. */
#define BF_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number) & BM_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number)

/*! @brief Set the Advanced_Error_Interrupt_Message_Number field to a new value. */
#define BW_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number(x, v) (HW_PCIE_RC_RESR_WR(x, (HW_PCIE_RC_RESR_RD(x) & ~BM_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number) | BF_PCIE_RC_RESR_Advanced_Error_Interrupt_Message_Number(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_ESIR - Error Source Identification Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_ESIR - Error Source Identification Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x100 + 0x34
 */
typedef union _hw_pcie_rc_esir
{
    uint32_t U;
    struct _hw_pcie_rc_esir_bitfields
    {
        uint32_t ERR_COR_SID : 16;     /*!< [15:0]  */
        uint32_t ERR_FATAL_NONFATAL_SID : 16; /*!< [31:16]  */
    } B;
} hw_pcie_rc_esir_t;

/*!
 * @name Constants and macros for entire PCIE_RC_ESIR register
 */
/*@{*/
#define HW_PCIE_RC_ESIR_ADDR(x)  ((uintptr_t)(x) + 0x134U)

#define HW_PCIE_RC_ESIR(x)       (*(__I hw_pcie_rc_esir_t *) HW_PCIE_RC_ESIR_ADDR(x))
#define HW_PCIE_RC_ESIR_RD(x)    (HW_PCIE_RC_ESIR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_ESIR bitfields
 */

/*!
 * @name Register PCIE_RC_ESIR, field ERR_COR_SID[15:0] (RO)
 *
 * ERR_COR Source Identification
 */
/*@{*/
#define BP_PCIE_RC_ESIR_ERR_COR_SID (0U)   /*!< Bit position for PCIE_RC_ESIR_ERR_COR_SID. */
#define BM_PCIE_RC_ESIR_ERR_COR_SID (0x0000FFFFU) /*!< Bit mask for PCIE_RC_ESIR_ERR_COR_SID. */
#define BS_PCIE_RC_ESIR_ERR_COR_SID (16U)  /*!< Bit field size in bits for PCIE_RC_ESIR_ERR_COR_SID. */

/*! @brief Read current value of the PCIE_RC_ESIR_ERR_COR_SID field. */
#define BR_PCIE_RC_ESIR_ERR_COR_SID(x) (HW_PCIE_RC_ESIR(x).B.ERR_COR_SID)
/*@}*/

/*!
 * @name Register PCIE_RC_ESIR, field ERR_FATAL_NONFATAL_SID[31:16] (RO)
 *
 * ERR_FATAL/NONFATAL Source Identification
 */
/*@{*/
#define BP_PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID (16U) /*!< Bit position for PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID. */
#define BM_PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID (0xFFFF0000U) /*!< Bit mask for PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID. */
#define BS_PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID (16U) /*!< Bit field size in bits for PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID. */

/*! @brief Read current value of the PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID field. */
#define BR_PCIE_RC_ESIR_ERR_FATAL_NONFATAL_SID(x) (HW_PCIE_RC_ESIR(x).B.ERR_FATAL_NONFATAL_SID)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_VCECHR - VC Extended Capability Header
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_VCECHR - VC Extended Capability Header (RO)
 *
 * Reset value: 0x00000012U
 *
 * Offset: 0x140
 */
typedef union _hw_pcie_rc_vcechr
{
    uint32_t U;
    struct _hw_pcie_rc_vcechr_bitfields
    {
        uint32_t Extended_Capability : 16; /*!< [15:0]  */
        uint32_t Capability_Version : 4; /*!< [19:16]  */
        uint32_t Next_Capability_Offset : 12; /*!< [31:20]  */
    } B;
} hw_pcie_rc_vcechr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_VCECHR register
 */
/*@{*/
#define HW_PCIE_RC_VCECHR_ADDR(x) ((uintptr_t)(x) + 0x140U)

#define HW_PCIE_RC_VCECHR(x)     (*(__I hw_pcie_rc_vcechr_t *) HW_PCIE_RC_VCECHR_ADDR(x))
#define HW_PCIE_RC_VCECHR_RD(x)  (HW_PCIE_RC_VCECHR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_VCECHR bitfields
 */

/*!
 * @name Register PCIE_RC_VCECHR, field Extended_Capability[15:0] (RO)
 *
 * PCI Express Extended Capability The default value is 0x2 for VC Capability.
 */
/*@{*/
#define BP_PCIE_RC_VCECHR_Extended_Capability (0U) /*!< Bit position for PCIE_RC_VCECHR_Extended_Capability. */
#define BM_PCIE_RC_VCECHR_Extended_Capability (0x0000FFFFU) /*!< Bit mask for PCIE_RC_VCECHR_Extended_Capability. */
#define BS_PCIE_RC_VCECHR_Extended_Capability (16U) /*!< Bit field size in bits for PCIE_RC_VCECHR_Extended_Capability. */

/*! @brief Read current value of the PCIE_RC_VCECHR_Extended_Capability field. */
#define BR_PCIE_RC_VCECHR_Extended_Capability(x) (HW_PCIE_RC_VCECHR(x).B.Extended_Capability)
/*@}*/

/*!
 * @name Register PCIE_RC_VCECHR, field Capability_Version[19:16] (RO)
 *
 * Capability Version
 */
/*@{*/
#define BP_PCIE_RC_VCECHR_Capability_Version (16U) /*!< Bit position for PCIE_RC_VCECHR_Capability_Version. */
#define BM_PCIE_RC_VCECHR_Capability_Version (0x000F0000U) /*!< Bit mask for PCIE_RC_VCECHR_Capability_Version. */
#define BS_PCIE_RC_VCECHR_Capability_Version (4U) /*!< Bit field size in bits for PCIE_RC_VCECHR_Capability_Version. */

/*! @brief Read current value of the PCIE_RC_VCECHR_Capability_Version field. */
#define BR_PCIE_RC_VCECHR_Capability_Version(x) (HW_PCIE_RC_VCECHR(x).B.Capability_Version)
/*@}*/

/*!
 * @name Register PCIE_RC_VCECHR, field Next_Capability_Offset[31:20] (RO)
 *
 * Next Capability Offset
 */
/*@{*/
#define BP_PCIE_RC_VCECHR_Next_Capability_Offset (20U) /*!< Bit position for PCIE_RC_VCECHR_Next_Capability_Offset. */
#define BM_PCIE_RC_VCECHR_Next_Capability_Offset (0xFFF00000U) /*!< Bit mask for PCIE_RC_VCECHR_Next_Capability_Offset. */
#define BS_PCIE_RC_VCECHR_Next_Capability_Offset (12U) /*!< Bit field size in bits for PCIE_RC_VCECHR_Next_Capability_Offset. */

/*! @brief Read current value of the PCIE_RC_VCECHR_Next_Capability_Offset field. */
#define BR_PCIE_RC_VCECHR_Next_Capability_Offset(x) (HW_PCIE_RC_VCECHR(x).B.Next_Capability_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PVCCR1 - Port VC Capability Register 1
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PVCCR1 - Port VC Capability Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x4
 */
typedef union _hw_pcie_rc_pvccr1
{
    uint32_t U;
    struct _hw_pcie_rc_pvccr1_bitfields
    {
        uint32_t Extended_VC_Count : 3; /*!< [2:0]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t Low_Priority_Extended_VC_Count : 3; /*!< [6:4]  */
        uint32_t RESERVED1 : 1;        /*!< [7]  */
        uint32_t Reference_Clock : 2;  /*!< [9:8]  */
        uint32_t Port_Arbitration_Table_Entry_Size : 2; /*!< [11:10]  */
        uint32_t RESERVED2 : 20;       /*!< [31:12]  */
    } B;
} hw_pcie_rc_pvccr1_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PVCCR1 register
 */
/*@{*/
#define HW_PCIE_RC_PVCCR1_ADDR(x) ((uintptr_t)(x) + 0x144U)

#define HW_PCIE_RC_PVCCR1(x)     (*(__I hw_pcie_rc_pvccr1_t *) HW_PCIE_RC_PVCCR1_ADDR(x))
#define HW_PCIE_RC_PVCCR1_RD(x)  (HW_PCIE_RC_PVCCR1(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PVCCR1 bitfields
 */

/*!
 * @name Register PCIE_RC_PVCCR1, field Extended_VC_Count[2:0] (RO)
 *
 * Extended VC Count The default value is the one less than the number of VCs
 * that
 */
/*@{*/
#define BP_PCIE_RC_PVCCR1_Extended_VC_Count (0U) /*!< Bit position for PCIE_RC_PVCCR1_Extended_VC_Count. */
#define BM_PCIE_RC_PVCCR1_Extended_VC_Count (0x00000007U) /*!< Bit mask for PCIE_RC_PVCCR1_Extended_VC_Count. */
#define BS_PCIE_RC_PVCCR1_Extended_VC_Count (3U) /*!< Bit field size in bits for PCIE_RC_PVCCR1_Extended_VC_Count. */

/*! @brief Read current value of the PCIE_RC_PVCCR1_Extended_VC_Count field. */
#define BR_PCIE_RC_PVCCR1_Extended_VC_Count(x) (HW_PCIE_RC_PVCCR1(x).B.Extended_VC_Count)
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCR1, field Low_Priority_Extended_VC_Count[6:4] (RO)
 *
 * Low Priority Extended VC Count, writable through the DBI
 */
/*@{*/
#define BP_PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count (4U) /*!< Bit position for PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count. */
#define BM_PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count (0x00000070U) /*!< Bit mask for PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count. */
#define BS_PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count (3U) /*!< Bit field size in bits for PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count. */

/*! @brief Read current value of the PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count field. */
#define BR_PCIE_RC_PVCCR1_Low_Priority_Extended_VC_Count(x) (HW_PCIE_RC_PVCCR1(x).B.Low_Priority_Extended_VC_Count)
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCR1, field Reference_Clock[9:8] (RO)
 *
 * Reference Clock
 */
/*@{*/
#define BP_PCIE_RC_PVCCR1_Reference_Clock (8U) /*!< Bit position for PCIE_RC_PVCCR1_Reference_Clock. */
#define BM_PCIE_RC_PVCCR1_Reference_Clock (0x00000300U) /*!< Bit mask for PCIE_RC_PVCCR1_Reference_Clock. */
#define BS_PCIE_RC_PVCCR1_Reference_Clock (2U) /*!< Bit field size in bits for PCIE_RC_PVCCR1_Reference_Clock. */

/*! @brief Read current value of the PCIE_RC_PVCCR1_Reference_Clock field. */
#define BR_PCIE_RC_PVCCR1_Reference_Clock(x) (HW_PCIE_RC_PVCCR1(x).B.Reference_Clock)
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCR1, field Port_Arbitration_Table_Entry_Size[11:10] (RO)
 *
 * Port Arbitration Table Entry Size
 */
/*@{*/
#define BP_PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size (10U) /*!< Bit position for PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size. */
#define BM_PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size (0x00000C00U) /*!< Bit mask for PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size. */
#define BS_PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size (2U) /*!< Bit field size in bits for PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size. */

/*! @brief Read current value of the PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size field. */
#define BR_PCIE_RC_PVCCR1_Port_Arbitration_Table_Entry_Size(x) (HW_PCIE_RC_PVCCR1(x).B.Port_Arbitration_Table_Entry_Size)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PVCCR2 - Port VC Capability Register 2
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PVCCR2 - Port VC Capability Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x8
 */
typedef union _hw_pcie_rc_pvccr2
{
    uint32_t U;
    struct _hw_pcie_rc_pvccr2_bitfields
    {
        uint32_t VC_Arbitration_Capability : 8; /*!< [7:0]  */
        uint32_t RESERVED0 : 16;       /*!< [23:8]  */
        uint32_t VC_Arbitration_Table_Offset : 8; /*!< [31:24]  */
    } B;
} hw_pcie_rc_pvccr2_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PVCCR2 register
 */
/*@{*/
#define HW_PCIE_RC_PVCCR2_ADDR(x) ((uintptr_t)(x) + 0x148U)

#define HW_PCIE_RC_PVCCR2(x)     (*(__I hw_pcie_rc_pvccr2_t *) HW_PCIE_RC_PVCCR2_ADDR(x))
#define HW_PCIE_RC_PVCCR2_RD(x)  (HW_PCIE_RC_PVCCR2(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PVCCR2 bitfields
 */

/*!
 * @name Register PCIE_RC_PVCCR2, field VC_Arbitration_Capability[7:0] (RO)
 *
 * VC Arbitration Capability Indicates which VC arbitration mode(s) the device
 * supports, writable through the DBI: •Bit 0: Device supports hardware fixed
 * arbitration scheme. For the core, the scheme is 16-phase weighted round robin
 * (WRR). •Bit 1: Device supports 32-phase WRR •Bit 2: Device supports 64-phase
 * WRR •Bit 3: Device supports 128-phase WRR •Bits 4-7: Reserved
 */
/*@{*/
#define BP_PCIE_RC_PVCCR2_VC_Arbitration_Capability (0U) /*!< Bit position for PCIE_RC_PVCCR2_VC_Arbitration_Capability. */
#define BM_PCIE_RC_PVCCR2_VC_Arbitration_Capability (0x000000FFU) /*!< Bit mask for PCIE_RC_PVCCR2_VC_Arbitration_Capability. */
#define BS_PCIE_RC_PVCCR2_VC_Arbitration_Capability (8U) /*!< Bit field size in bits for PCIE_RC_PVCCR2_VC_Arbitration_Capability. */

/*! @brief Read current value of the PCIE_RC_PVCCR2_VC_Arbitration_Capability field. */
#define BR_PCIE_RC_PVCCR2_VC_Arbitration_Capability(x) (HW_PCIE_RC_PVCCR2(x).B.VC_Arbitration_Capability)
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCR2, field VC_Arbitration_Table_Offset[31:24] (RO)
 *
 * VC Arbitration Table Offset (not supported) The default value is 0x00 (no
 * arbitration table present).
 */
/*@{*/
#define BP_PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset (24U) /*!< Bit position for PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset. */
#define BM_PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset (0xFF000000U) /*!< Bit mask for PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset. */
#define BS_PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset (8U) /*!< Bit field size in bits for PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset. */

/*! @brief Read current value of the PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset field. */
#define BR_PCIE_RC_PVCCR2_VC_Arbitration_Table_Offset(x) (HW_PCIE_RC_PVCCR2(x).B.VC_Arbitration_Table_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_PVCCSR - Port VC Control and Status Register
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_PVCCSR - Port VC Control and Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0xC Bytes: 0-1
 */
typedef union _hw_pcie_rc_pvccsr
{
    uint32_t U;
    struct _hw_pcie_rc_pvccsr_bitfields
    {
        uint32_t Load_VC_Arbitration_Table : 1; /*!< [0]  */
        uint32_t VC_Arbitration_Select : 3; /*!< [3:1]  */
        uint32_t RESERVED0 : 12;       /*!< [15:4]  */
        uint32_t Arbitration_Table_Status : 1; /*!< [16]  */
        uint32_t RESERVED1 : 15;       /*!< [31:17]  */
    } B;
} hw_pcie_rc_pvccsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_PVCCSR register
 */
/*@{*/
#define HW_PCIE_RC_PVCCSR_ADDR(x) ((uintptr_t)(x) + 0x14CU)

#define HW_PCIE_RC_PVCCSR(x)     (*(__IO hw_pcie_rc_pvccsr_t *) HW_PCIE_RC_PVCCSR_ADDR(x))
#define HW_PCIE_RC_PVCCSR_RD(x)  (HW_PCIE_RC_PVCCSR(x).U)
#define HW_PCIE_RC_PVCCSR_WR(x, v) (HW_PCIE_RC_PVCCSR(x).U = (v))
#define HW_PCIE_RC_PVCCSR_SET(x, v) (HW_PCIE_RC_PVCCSR_WR(x, HW_PCIE_RC_PVCCSR_RD(x) |  (v)))
#define HW_PCIE_RC_PVCCSR_CLR(x, v) (HW_PCIE_RC_PVCCSR_WR(x, HW_PCIE_RC_PVCCSR_RD(x) & ~(v)))
#define HW_PCIE_RC_PVCCSR_TOG(x, v) (HW_PCIE_RC_PVCCSR_WR(x, HW_PCIE_RC_PVCCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_PVCCSR bitfields
 */

/*!
 * @name Register PCIE_RC_PVCCSR, field Load_VC_Arbitration_Table[0] (RW)
 *
 * Load VC Arbitration Table
 */
/*@{*/
#define BP_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table (0U) /*!< Bit position for PCIE_RC_PVCCSR_Load_VC_Arbitration_Table. */
#define BM_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table (0x00000001U) /*!< Bit mask for PCIE_RC_PVCCSR_Load_VC_Arbitration_Table. */
#define BS_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table (1U) /*!< Bit field size in bits for PCIE_RC_PVCCSR_Load_VC_Arbitration_Table. */

/*! @brief Read current value of the PCIE_RC_PVCCSR_Load_VC_Arbitration_Table field. */
#define BR_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table(x) (HW_PCIE_RC_PVCCSR(x).B.Load_VC_Arbitration_Table)

/*! @brief Format value for bitfield PCIE_RC_PVCCSR_Load_VC_Arbitration_Table. */
#define BF_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table) & BM_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table)

/*! @brief Set the Load_VC_Arbitration_Table field to a new value. */
#define BW_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table(x, v) (HW_PCIE_RC_PVCCSR_WR(x, (HW_PCIE_RC_PVCCSR_RD(x) & ~BM_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table) | BF_PCIE_RC_PVCCSR_Load_VC_Arbitration_Table(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCSR, field VC_Arbitration_Select[3:1] (RW)
 *
 * VC Arbitration Select
 */
/*@{*/
#define BP_PCIE_RC_PVCCSR_VC_Arbitration_Select (1U) /*!< Bit position for PCIE_RC_PVCCSR_VC_Arbitration_Select. */
#define BM_PCIE_RC_PVCCSR_VC_Arbitration_Select (0x0000000EU) /*!< Bit mask for PCIE_RC_PVCCSR_VC_Arbitration_Select. */
#define BS_PCIE_RC_PVCCSR_VC_Arbitration_Select (3U) /*!< Bit field size in bits for PCIE_RC_PVCCSR_VC_Arbitration_Select. */

/*! @brief Read current value of the PCIE_RC_PVCCSR_VC_Arbitration_Select field. */
#define BR_PCIE_RC_PVCCSR_VC_Arbitration_Select(x) (HW_PCIE_RC_PVCCSR(x).B.VC_Arbitration_Select)

/*! @brief Format value for bitfield PCIE_RC_PVCCSR_VC_Arbitration_Select. */
#define BF_PCIE_RC_PVCCSR_VC_Arbitration_Select(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PVCCSR_VC_Arbitration_Select) & BM_PCIE_RC_PVCCSR_VC_Arbitration_Select)

/*! @brief Set the VC_Arbitration_Select field to a new value. */
#define BW_PCIE_RC_PVCCSR_VC_Arbitration_Select(x, v) (HW_PCIE_RC_PVCCSR_WR(x, (HW_PCIE_RC_PVCCSR_RD(x) & ~BM_PCIE_RC_PVCCSR_VC_Arbitration_Select) | BF_PCIE_RC_PVCCSR_VC_Arbitration_Select(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_PVCCSR, field Arbitration_Table_Status[16] (RW)
 *
 * Arbitration Table Status
 */
/*@{*/
#define BP_PCIE_RC_PVCCSR_Arbitration_Table_Status (16U) /*!< Bit position for PCIE_RC_PVCCSR_Arbitration_Table_Status. */
#define BM_PCIE_RC_PVCCSR_Arbitration_Table_Status (0x00010000U) /*!< Bit mask for PCIE_RC_PVCCSR_Arbitration_Table_Status. */
#define BS_PCIE_RC_PVCCSR_Arbitration_Table_Status (1U) /*!< Bit field size in bits for PCIE_RC_PVCCSR_Arbitration_Table_Status. */

/*! @brief Read current value of the PCIE_RC_PVCCSR_Arbitration_Table_Status field. */
#define BR_PCIE_RC_PVCCSR_Arbitration_Table_Status(x) (HW_PCIE_RC_PVCCSR(x).B.Arbitration_Table_Status)

/*! @brief Format value for bitfield PCIE_RC_PVCCSR_Arbitration_Table_Status. */
#define BF_PCIE_RC_PVCCSR_Arbitration_Table_Status(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_PVCCSR_Arbitration_Table_Status) & BM_PCIE_RC_PVCCSR_Arbitration_Table_Status)

/*! @brief Set the Arbitration_Table_Status field to a new value. */
#define BW_PCIE_RC_PVCCSR_Arbitration_Table_Status(x, v) (HW_PCIE_RC_PVCCSR_WR(x, (HW_PCIE_RC_PVCCSR_RD(x) & ~BM_PCIE_RC_PVCCSR_Arbitration_Table_Status) | BF_PCIE_RC_PVCCSR_Arbitration_Table_Status(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_VCRCR - VC Resource Capability Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_VCRCR - VC Resource Capability Register n (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x10
 */
typedef union _hw_pcie_rc_vcrcr
{
    uint32_t U;
    struct _hw_pcie_rc_vcrcr_bitfields
    {
        uint32_t Port_Arbitration_Capability : 8; /*!< [7:0]  */
        uint32_t RESERVED0 : 6;        /*!< [13:8]  */
        uint32_t Undefined : 1;        /*!< [14]  */
        uint32_t Reject_Snoop_Transactions : 1; /*!< [15]  */
        uint32_t Maximum_Time_Slots : 7; /*!< [22:16]  */
        uint32_t RESERVED1 : 1;        /*!< [23]  */
        uint32_t Port_Arbitration_Table_Offset : 8; /*!< [31:24]  */
    } B;
} hw_pcie_rc_vcrcr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_VCRCR register
 */
/*@{*/
#define HW_PCIE_RC_VCRCR_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_PCIE_RC_VCRCR(x)      (*(__I hw_pcie_rc_vcrcr_t *) HW_PCIE_RC_VCRCR_ADDR(x))
#define HW_PCIE_RC_VCRCR_RD(x)   (HW_PCIE_RC_VCRCR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_VCRCR bitfields
 */

/*!
 * @name Register PCIE_RC_VCRCR, field Port_Arbitration_Capability[7:0] (RO)
 *
 * Port Arbitration Capability
 */
/*@{*/
#define BP_PCIE_RC_VCRCR_Port_Arbitration_Capability (0U) /*!< Bit position for PCIE_RC_VCRCR_Port_Arbitration_Capability. */
#define BM_PCIE_RC_VCRCR_Port_Arbitration_Capability (0x000000FFU) /*!< Bit mask for PCIE_RC_VCRCR_Port_Arbitration_Capability. */
#define BS_PCIE_RC_VCRCR_Port_Arbitration_Capability (8U) /*!< Bit field size in bits for PCIE_RC_VCRCR_Port_Arbitration_Capability. */

/*! @brief Read current value of the PCIE_RC_VCRCR_Port_Arbitration_Capability field. */
#define BR_PCIE_RC_VCRCR_Port_Arbitration_Capability(x) (HW_PCIE_RC_VCRCR(x).B.Port_Arbitration_Capability)
/*@}*/

/*!
 * @name Register PCIE_RC_VCRCR, field Undefined[14] (RO)
 *
 * Undefined for PCI Express 1.1 (Was Advanced Packet Switching for PCI Express
 * 1.0a)
 */
/*@{*/
#define BP_PCIE_RC_VCRCR_Undefined (14U)   /*!< Bit position for PCIE_RC_VCRCR_Undefined. */
#define BM_PCIE_RC_VCRCR_Undefined (0x00004000U) /*!< Bit mask for PCIE_RC_VCRCR_Undefined. */
#define BS_PCIE_RC_VCRCR_Undefined (1U)    /*!< Bit field size in bits for PCIE_RC_VCRCR_Undefined. */

/*! @brief Read current value of the PCIE_RC_VCRCR_Undefined field. */
#define BR_PCIE_RC_VCRCR_Undefined(x) (HW_PCIE_RC_VCRCR(x).B.Undefined)
/*@}*/

/*!
 * @name Register PCIE_RC_VCRCR, field Reject_Snoop_Transactions[15] (RO)
 *
 * Reject Snoop Transactions
 */
/*@{*/
#define BP_PCIE_RC_VCRCR_Reject_Snoop_Transactions (15U) /*!< Bit position for PCIE_RC_VCRCR_Reject_Snoop_Transactions. */
#define BM_PCIE_RC_VCRCR_Reject_Snoop_Transactions (0x00008000U) /*!< Bit mask for PCIE_RC_VCRCR_Reject_Snoop_Transactions. */
#define BS_PCIE_RC_VCRCR_Reject_Snoop_Transactions (1U) /*!< Bit field size in bits for PCIE_RC_VCRCR_Reject_Snoop_Transactions. */

/*! @brief Read current value of the PCIE_RC_VCRCR_Reject_Snoop_Transactions field. */
#define BR_PCIE_RC_VCRCR_Reject_Snoop_Transactions(x) (HW_PCIE_RC_VCRCR(x).B.Reject_Snoop_Transactions)
/*@}*/

/*!
 * @name Register PCIE_RC_VCRCR, field Maximum_Time_Slots[22:16] (RO)
 *
 * Maximum Time Slots
 */
/*@{*/
#define BP_PCIE_RC_VCRCR_Maximum_Time_Slots (16U) /*!< Bit position for PCIE_RC_VCRCR_Maximum_Time_Slots. */
#define BM_PCIE_RC_VCRCR_Maximum_Time_Slots (0x007F0000U) /*!< Bit mask for PCIE_RC_VCRCR_Maximum_Time_Slots. */
#define BS_PCIE_RC_VCRCR_Maximum_Time_Slots (7U) /*!< Bit field size in bits for PCIE_RC_VCRCR_Maximum_Time_Slots. */

/*! @brief Read current value of the PCIE_RC_VCRCR_Maximum_Time_Slots field. */
#define BR_PCIE_RC_VCRCR_Maximum_Time_Slots(x) (HW_PCIE_RC_VCRCR(x).B.Maximum_Time_Slots)
/*@}*/

/*!
 * @name Register PCIE_RC_VCRCR, field Port_Arbitration_Table_Offset[31:24] (RO)
 *
 * Port Arbitration Table Offset
 */
/*@{*/
#define BP_PCIE_RC_VCRCR_Port_Arbitration_Table_Offset (24U) /*!< Bit position for PCIE_RC_VCRCR_Port_Arbitration_Table_Offset. */
#define BM_PCIE_RC_VCRCR_Port_Arbitration_Table_Offset (0xFF000000U) /*!< Bit mask for PCIE_RC_VCRCR_Port_Arbitration_Table_Offset. */
#define BS_PCIE_RC_VCRCR_Port_Arbitration_Table_Offset (8U) /*!< Bit field size in bits for PCIE_RC_VCRCR_Port_Arbitration_Table_Offset. */

/*! @brief Read current value of the PCIE_RC_VCRCR_Port_Arbitration_Table_Offset field. */
#define BR_PCIE_RC_VCRCR_Port_Arbitration_Table_Offset(x) (HW_PCIE_RC_VCRCR(x).B.Port_Arbitration_Table_Offset)
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_VCRConR - VC Resource Control Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_VCRConR - VC Resource Control Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x14
 */
typedef union _hw_pcie_rc_vcrconr
{
    uint32_t U;
    struct _hw_pcie_rc_vcrconr_bitfields
    {
        uint32_t TC_VC_Map : 8;        /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t Load_Port_Arbitration_Table : 1; /*!< [16]  */
        uint32_t Port_Arbitration_Select : 3; /*!< [19:17]  */
        uint32_t RESERVED1 : 4;        /*!< [23:20]  */
        uint32_t VC_ID : 3;            /*!< [26:24]  */
        uint32_t RESERVED2 : 4;        /*!< [30:27]  */
        uint32_t VC_Enable : 1;        /*!< [31]  */
    } B;
} hw_pcie_rc_vcrconr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_VCRConR register
 */
/*@{*/
#define HW_PCIE_RC_VCRConR_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_PCIE_RC_VCRConR(x)    (*(__IO hw_pcie_rc_vcrconr_t *) HW_PCIE_RC_VCRConR_ADDR(x))
#define HW_PCIE_RC_VCRConR_RD(x) (HW_PCIE_RC_VCRConR(x).U)
#define HW_PCIE_RC_VCRConR_WR(x, v) (HW_PCIE_RC_VCRConR(x).U = (v))
#define HW_PCIE_RC_VCRConR_SET(x, v) (HW_PCIE_RC_VCRConR_WR(x, HW_PCIE_RC_VCRConR_RD(x) |  (v)))
#define HW_PCIE_RC_VCRConR_CLR(x, v) (HW_PCIE_RC_VCRConR_WR(x, HW_PCIE_RC_VCRConR_RD(x) & ~(v)))
#define HW_PCIE_RC_VCRConR_TOG(x, v) (HW_PCIE_RC_VCRConR_WR(x, HW_PCIE_RC_VCRConR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_VCRConR bitfields
 */

/*!
 * @name Register PCIE_RC_VCRConR, field TC_VC_Map[7:0] (RW)
 *
 * TC/VC Map Bit 0 is hardwired to 1; bits 7:1 are RW.
 */
/*@{*/
#define BP_PCIE_RC_VCRConR_TC_VC_Map (0U)  /*!< Bit position for PCIE_RC_VCRConR_TC_VC_Map. */
#define BM_PCIE_RC_VCRConR_TC_VC_Map (0x000000FFU) /*!< Bit mask for PCIE_RC_VCRConR_TC_VC_Map. */
#define BS_PCIE_RC_VCRConR_TC_VC_Map (8U)  /*!< Bit field size in bits for PCIE_RC_VCRConR_TC_VC_Map. */

/*! @brief Read current value of the PCIE_RC_VCRConR_TC_VC_Map field. */
#define BR_PCIE_RC_VCRConR_TC_VC_Map(x) (HW_PCIE_RC_VCRConR(x).B.TC_VC_Map)

/*! @brief Format value for bitfield PCIE_RC_VCRConR_TC_VC_Map. */
#define BF_PCIE_RC_VCRConR_TC_VC_Map(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_VCRConR_TC_VC_Map) & BM_PCIE_RC_VCRConR_TC_VC_Map)

/*! @brief Set the TC_VC_Map field to a new value. */
#define BW_PCIE_RC_VCRConR_TC_VC_Map(x, v) (HW_PCIE_RC_VCRConR_WR(x, (HW_PCIE_RC_VCRConR_RD(x) & ~BM_PCIE_RC_VCRConR_TC_VC_Map) | BF_PCIE_RC_VCRConR_TC_VC_Map(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_VCRConR, field Load_Port_Arbitration_Table[16] (RW)
 *
 * Load Port Arbitration Table
 */
/*@{*/
#define BP_PCIE_RC_VCRConR_Load_Port_Arbitration_Table (16U) /*!< Bit position for PCIE_RC_VCRConR_Load_Port_Arbitration_Table. */
#define BM_PCIE_RC_VCRConR_Load_Port_Arbitration_Table (0x00010000U) /*!< Bit mask for PCIE_RC_VCRConR_Load_Port_Arbitration_Table. */
#define BS_PCIE_RC_VCRConR_Load_Port_Arbitration_Table (1U) /*!< Bit field size in bits for PCIE_RC_VCRConR_Load_Port_Arbitration_Table. */

/*! @brief Read current value of the PCIE_RC_VCRConR_Load_Port_Arbitration_Table field. */
#define BR_PCIE_RC_VCRConR_Load_Port_Arbitration_Table(x) (HW_PCIE_RC_VCRConR(x).B.Load_Port_Arbitration_Table)

/*! @brief Format value for bitfield PCIE_RC_VCRConR_Load_Port_Arbitration_Table. */
#define BF_PCIE_RC_VCRConR_Load_Port_Arbitration_Table(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_VCRConR_Load_Port_Arbitration_Table) & BM_PCIE_RC_VCRConR_Load_Port_Arbitration_Table)

/*! @brief Set the Load_Port_Arbitration_Table field to a new value. */
#define BW_PCIE_RC_VCRConR_Load_Port_Arbitration_Table(x, v) (HW_PCIE_RC_VCRConR_WR(x, (HW_PCIE_RC_VCRConR_RD(x) & ~BM_PCIE_RC_VCRConR_Load_Port_Arbitration_Table) | BF_PCIE_RC_VCRConR_Load_Port_Arbitration_Table(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_VCRConR, field Port_Arbitration_Select[19:17] (RW)
 *
 * Port Arbitration Select
 */
/*@{*/
#define BP_PCIE_RC_VCRConR_Port_Arbitration_Select (17U) /*!< Bit position for PCIE_RC_VCRConR_Port_Arbitration_Select. */
#define BM_PCIE_RC_VCRConR_Port_Arbitration_Select (0x000E0000U) /*!< Bit mask for PCIE_RC_VCRConR_Port_Arbitration_Select. */
#define BS_PCIE_RC_VCRConR_Port_Arbitration_Select (3U) /*!< Bit field size in bits for PCIE_RC_VCRConR_Port_Arbitration_Select. */

/*! @brief Read current value of the PCIE_RC_VCRConR_Port_Arbitration_Select field. */
#define BR_PCIE_RC_VCRConR_Port_Arbitration_Select(x) (HW_PCIE_RC_VCRConR(x).B.Port_Arbitration_Select)

/*! @brief Format value for bitfield PCIE_RC_VCRConR_Port_Arbitration_Select. */
#define BF_PCIE_RC_VCRConR_Port_Arbitration_Select(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_VCRConR_Port_Arbitration_Select) & BM_PCIE_RC_VCRConR_Port_Arbitration_Select)

/*! @brief Set the Port_Arbitration_Select field to a new value. */
#define BW_PCIE_RC_VCRConR_Port_Arbitration_Select(x, v) (HW_PCIE_RC_VCRConR_WR(x, (HW_PCIE_RC_VCRConR_RD(x) & ~BM_PCIE_RC_VCRConR_Port_Arbitration_Select) | BF_PCIE_RC_VCRConR_Port_Arbitration_Select(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_VCRConR, field VC_ID[26:24] (RW)
 *
 * VC ID Hardwired to 0 for VC0.
 */
/*@{*/
#define BP_PCIE_RC_VCRConR_VC_ID (24U)     /*!< Bit position for PCIE_RC_VCRConR_VC_ID. */
#define BM_PCIE_RC_VCRConR_VC_ID (0x07000000U) /*!< Bit mask for PCIE_RC_VCRConR_VC_ID. */
#define BS_PCIE_RC_VCRConR_VC_ID (3U)      /*!< Bit field size in bits for PCIE_RC_VCRConR_VC_ID. */

/*! @brief Read current value of the PCIE_RC_VCRConR_VC_ID field. */
#define BR_PCIE_RC_VCRConR_VC_ID(x) (HW_PCIE_RC_VCRConR(x).B.VC_ID)

/*! @brief Format value for bitfield PCIE_RC_VCRConR_VC_ID. */
#define BF_PCIE_RC_VCRConR_VC_ID(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_VCRConR_VC_ID) & BM_PCIE_RC_VCRConR_VC_ID)

/*! @brief Set the VC_ID field to a new value. */
#define BW_PCIE_RC_VCRConR_VC_ID(x, v) (HW_PCIE_RC_VCRConR_WR(x, (HW_PCIE_RC_VCRConR_RD(x) & ~BM_PCIE_RC_VCRConR_VC_ID) | BF_PCIE_RC_VCRConR_VC_ID(v)))
/*@}*/

/*!
 * @name Register PCIE_RC_VCRConR, field VC_Enable[31] (RW)
 *
 * VC Enable Hardwired to 1 for the first VC.
 */
/*@{*/
#define BP_PCIE_RC_VCRConR_VC_Enable (31U) /*!< Bit position for PCIE_RC_VCRConR_VC_Enable. */
#define BM_PCIE_RC_VCRConR_VC_Enable (0x80000000U) /*!< Bit mask for PCIE_RC_VCRConR_VC_Enable. */
#define BS_PCIE_RC_VCRConR_VC_Enable (1U)  /*!< Bit field size in bits for PCIE_RC_VCRConR_VC_Enable. */

/*! @brief Read current value of the PCIE_RC_VCRConR_VC_Enable field. */
#define BR_PCIE_RC_VCRConR_VC_Enable(x) (HW_PCIE_RC_VCRConR(x).B.VC_Enable)

/*! @brief Format value for bitfield PCIE_RC_VCRConR_VC_Enable. */
#define BF_PCIE_RC_VCRConR_VC_Enable(v) ((uint32_t)((uint32_t)(v) << BP_PCIE_RC_VCRConR_VC_Enable) & BM_PCIE_RC_VCRConR_VC_Enable)

/*! @brief Set the VC_Enable field to a new value. */
#define BW_PCIE_RC_VCRConR_VC_Enable(x, v) (HW_PCIE_RC_VCRConR_WR(x, (HW_PCIE_RC_VCRConR_RD(x) & ~BM_PCIE_RC_VCRConR_VC_Enable) | BF_PCIE_RC_VCRConR_VC_Enable(v)))
/*@}*/

/*******************************************************************************
 * HW_PCIE_RC_VCRSR - VC Resource Status Register n
 ******************************************************************************/

/*!
 * @brief HW_PCIE_RC_VCRSR - VC Resource Status Register n (RO)
 *
 * Reset value: 0x00000000U
 *
 * Offset: 0x140 + 0x18
 */
typedef union _hw_pcie_rc_vcrsr
{
    uint32_t U;
    struct _hw_pcie_rc_vcrsr_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t Port_Arbitration_Table_Status : 1; /*!< [16]  */
        uint32_t VC_Negotiation_Pending : 1; /*!< [17]  */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_pcie_rc_vcrsr_t;

/*!
 * @name Constants and macros for entire PCIE_RC_VCRSR register
 */
/*@{*/
#define HW_PCIE_RC_VCRSR_ADDR(x) ((uintptr_t)(x) + 0x158U)

#define HW_PCIE_RC_VCRSR(x)      (*(__I hw_pcie_rc_vcrsr_t *) HW_PCIE_RC_VCRSR_ADDR(x))
#define HW_PCIE_RC_VCRSR_RD(x)   (HW_PCIE_RC_VCRSR(x).U)
/*@}*/

/*
 * Constants & macros for individual PCIE_RC_VCRSR bitfields
 */

/*!
 * @name Register PCIE_RC_VCRSR, field Port_Arbitration_Table_Status[16] (RO)
 *
 * Port Arbitration Table Status
 */
/*@{*/
#define BP_PCIE_RC_VCRSR_Port_Arbitration_Table_Status (16U) /*!< Bit position for PCIE_RC_VCRSR_Port_Arbitration_Table_Status. */
#define BM_PCIE_RC_VCRSR_Port_Arbitration_Table_Status (0x00010000U) /*!< Bit mask for PCIE_RC_VCRSR_Port_Arbitration_Table_Status. */
#define BS_PCIE_RC_VCRSR_Port_Arbitration_Table_Status (1U) /*!< Bit field size in bits for PCIE_RC_VCRSR_Port_Arbitration_Table_Status. */

/*! @brief Read current value of the PCIE_RC_VCRSR_Port_Arbitration_Table_Status field. */
#define BR_PCIE_RC_VCRSR_Port_Arbitration_Table_Status(x) (HW_PCIE_RC_VCRSR(x).B.Port_Arbitration_Table_Status)
/*@}*/

/*!
 * @name Register PCIE_RC_VCRSR, field VC_Negotiation_Pending[17] (RO)
 *
 * VC Negotiation Pending
 */
/*@{*/
#define BP_PCIE_RC_VCRSR_VC_Negotiation_Pending (17U) /*!< Bit position for PCIE_RC_VCRSR_VC_Negotiation_Pending. */
#define BM_PCIE_RC_VCRSR_VC_Negotiation_Pending (0x00020000U) /*!< Bit mask for PCIE_RC_VCRSR_VC_Negotiation_Pending. */
#define BS_PCIE_RC_VCRSR_VC_Negotiation_Pending (1U) /*!< Bit field size in bits for PCIE_RC_VCRSR_VC_Negotiation_Pending. */

/*! @brief Read current value of the PCIE_RC_VCRSR_VC_Negotiation_Pending field. */
#define BR_PCIE_RC_VCRSR_VC_Negotiation_Pending(x) (HW_PCIE_RC_VCRSR(x).B.VC_Negotiation_Pending)
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_pcie_rc_t - module struct
 ******************************************************************************/
/*!
 * @brief All PCIE_RC module registers.
 */
#pragma pack(1)
typedef struct _hw_pcie_rc
{
    __I hw_pcie_rc_deviceid_t DeviceID;    /*!< [0x0] Device ID and Vendor ID Register */
    __IO hw_pcie_rc_command_t Command;     /*!< [0x4] Command and Status Register */
    __I hw_pcie_rc_revid_t RevID;          /*!< [0x8] Revision ID and Class Code Register */
    __IO hw_pcie_rc_bist_t BIST;           /*!< [0xC] BIST Register */
    __I hw_pcie_rc_bar0_t BAR0;            /*!< [0x10] Base Address 0 */
    __I hw_pcie_rc_bar1_t BAR1;            /*!< [0x14] Base Address 1 */
    __IO hw_pcie_rc_bnr_t BNR;             /*!< [0x18] Bus Number Registers */
    __IO hw_pcie_rc_ioblssr_t IOBLSSR;     /*!< [0x1C] I/O Base Limit Secondary Status Register */
    __IO hw_pcie_rc_mem_blr_t MEM_BLR;     /*!< [0x20] Memory Base and Memory Limit Register */
    __IO hw_pcie_rc_pref_mem_blr_t PREF_MEM_BLR; /*!< [0x24] Prefetchable Memory Base and Limit Register */
    __IO hw_pcie_rc_pref_base_u32_t PREF_BASE_U32; /*!< [0x28] Prefetchable Base Upper 32 Bits Register */
    __IO hw_pcie_rc_pref_lim_u32_t PREF_LIM_U32; /*!< [0x2C] Prefetchable Limit Upper 32 Bits Register */
    __IO hw_pcie_rc_io_base_lim_u16_t IO_BASE_LIM_U16; /*!< [0x30] I/O Base and Limit Upper 16 Bits Register */
    __I hw_pcie_rc_cappr_t CAPPR;          /*!< [0x34] Capability Pointer Register */
    union {
        __IO hw_pcie_rc_erombar_t EROMBAR; /*!< [0x38] Expansion ROM Base Address Register */
        __IO hw_pcie_rc_erommask_t EROMMASK; /*!< [0x38] Expansion ROM BAR Mask Register */
    };
    uint8_t _reserved0[4];
    __I hw_pcie_rc_pmcr_t PMCR;            /*!< [0x40] Power Management Capability Register */
    __IO hw_pcie_rc_pmcsr_t PMCSR;         /*!< [0x44] Power Management Control and Status Register */
    uint8_t _reserved1[40];
    __I hw_pcie_rc_cidr_t CIDR;            /*!< [0x70] PCI Express Capability ID Register */
    __IO hw_pcie_rc_dcr_t DCR;             /*!< [0x74] Device Capabilities Register */
    __IO hw_pcie_rc_dconr_t DConR;         /*!< [0x78] Device Control Register */
    __I hw_pcie_rc_lcr_t LCR;              /*!< [0x7C] Link Capabilities Register */
    __IO hw_pcie_rc_lcsr_t LCSR;           /*!< [0x80] Link Control and Status Register */
    __I hw_pcie_rc_scr_t SCR;              /*!< [0x84] Slot Capabilities Register */
    __IO hw_pcie_rc_scsr_t SCSR;           /*!< [0x88] Slot Control and Status Register */
    __IO hw_pcie_rc_rccr_t RCCR;           /*!< [0x8C] Root Control and Capabilities Register */
    __IO hw_pcie_rc_rsr_t RSR;             /*!< [0x90] Root Status Register */
    __I hw_pcie_rc_dcr2_t DCR2;            /*!< [0x94] Device Capabilities 2 Register */
    __IO hw_pcie_rc_dcsr2_t DCSR2;         /*!< [0x98] Device Control and Status 2 Register */
    __I hw_pcie_rc_lcr2_t LCR2;            /*!< [0x9C] Link Capabilities 2 Register */
    __IO hw_pcie_rc_lcsr2_t LCSR2;         /*!< [0xA0] Link Control and Status 2 Register */
    uint8_t _reserved2[92];
    __IO hw_pcie_rc_aer_t AER;             /*!< [0x100] AER Capability Header */
    __IO hw_pcie_rc_uesr_t UESR;           /*!< [0x104] Uncorrectable Error Status Register */
    __IO hw_pcie_rc_uemr_t UEMR;           /*!< [0x108] Uncorrectable Error Mask Register */
    __IO hw_pcie_rc_uesevr_t UESevR;       /*!< [0x10C] Uncorrectable Error Severity Register */
    __IO hw_pcie_rc_cesr_t CESR;           /*!< [0x110] Correctable Error Status Register */
    __IO hw_pcie_rc_cemr_t CEMR;           /*!< [0x114] Correctable Error Mask Register */
    __IO hw_pcie_rc_accr_t ACCR;           /*!< [0x118] Advanced Capabilities and Control Register */
    __I hw_pcie_rc_hlr_t HLR;              /*!< [0x11C] Header Log Register */
    uint8_t _reserved3[12];
    __IO hw_pcie_rc_recr_t RECR;           /*!< [0x12C] Root Error Command Register */
    __IO hw_pcie_rc_resr_t RESR;           /*!< [0x130] Root Error Status Register */
    __I hw_pcie_rc_esir_t ESIR;            /*!< [0x134] Error Source Identification Register */
    uint8_t _reserved4[8];
    __I hw_pcie_rc_vcechr_t VCECHR;        /*!< [0x140] VC Extended Capability Header */
    __I hw_pcie_rc_pvccr1_t PVCCR1;        /*!< [0x144] Port VC Capability Register 1 */
    __I hw_pcie_rc_pvccr2_t PVCCR2;        /*!< [0x148] Port VC Capability Register 2 */
    __IO hw_pcie_rc_pvccsr_t PVCCSR;       /*!< [0x14C] Port VC Control and Status Register */
    __I hw_pcie_rc_vcrcr_t VCRCR;          /*!< [0x150] VC Resource Capability Register n */
    __IO hw_pcie_rc_vcrconr_t VCRConR;     /*!< [0x154] VC Resource Control Register n */
    __I hw_pcie_rc_vcrsr_t VCRSR;          /*!< [0x158] VC Resource Status Register n */
} hw_pcie_rc_t;
#pragma pack()

/*! @brief Macro to access all PCIE_RC registers. */
/*! @param x PCIE_RC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PCIE_RC_REGS(PCIE_RC_BASE)</code>. */
#define HW_PCIE_RC_REGS(x) (*(hw_pcie_rc_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP PGC
 *
 * PGC
 *
 * Registers defined in this header file:
 * - HW_PGC_GPU_CTRL - PGC Control Register
 * - HW_PGC_GPU_PUPSCR - Power Up Sequence Control Register
 * - HW_PGC_GPU_PDNSCR - Pull Down Sequence Control Register
 * - HW_PGC_GPU_SR - Power Gating Controller Status Register
 * - HW_PGC_CPU_CTRL - PGC Control Register
 * - HW_PGC_CPU_PUPSCR - Power Up Sequence Control Register
 * - HW_PGC_CPU_PDNSCR - Pull Down Sequence Control Register
 * - HW_PGC_CPU_SR - Power Gating Controller Status Register
 *
 * - hw_pgc_t - Struct containing all module registers.
 */

#define HW_PGC_INSTANCE_COUNT (1U) /*!< Number of instances of the PGC module. */
#define HW_PGC (0U) /*!< Instance number for PGC. */
#define PGC_BASE              (0x20DC000U) /*!< Base address for PGC. */
/*! Array initializer of PGC base addresses. */
#define PGC_BASE_ADDRS        { PGC_BASE }

/*******************************************************************************
 * HW_PGC_GPU_CTRL - PGC Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_GPU_CTRL - PGC Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PGCR enables the response to a power-down request.
 */
typedef union _hw_pgc_gpu_ctrl
{
    uint32_t U;
    struct _hw_pgc_gpu_ctrl_bitfields
    {
        uint32_t PCR : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pgc_gpu_ctrl_t;

/*!
 * @name Constants and macros for entire PGC_GPU_CTRL register
 */
/*@{*/
#define HW_PGC_GPU_CTRL_ADDR(x)  ((uintptr_t)(x) + 0x260U)

#define HW_PGC_GPU_CTRL(x)       (*(__IO hw_pgc_gpu_ctrl_t *) HW_PGC_GPU_CTRL_ADDR(x))
#define HW_PGC_GPU_CTRL_RD(x)    (HW_PGC_GPU_CTRL(x).U)
#define HW_PGC_GPU_CTRL_WR(x, v) (HW_PGC_GPU_CTRL(x).U = (v))
#define HW_PGC_GPU_CTRL_SET(x, v) (HW_PGC_GPU_CTRL_WR(x, HW_PGC_GPU_CTRL_RD(x) |  (v)))
#define HW_PGC_GPU_CTRL_CLR(x, v) (HW_PGC_GPU_CTRL_WR(x, HW_PGC_GPU_CTRL_RD(x) & ~(v)))
#define HW_PGC_GPU_CTRL_TOG(x, v) (HW_PGC_GPU_CTRL_WR(x, HW_PGC_GPU_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_GPU_CTRL bitfields
 */

/*!
 * @name Register PGC_GPU_CTRL, field PCR[0] (RW)
 *
 * Power Control PCR must not change from power-down request (pdn_req) assertion
 * until the target subsystem is completely powered up.
 *
 * Values:
 * - 0 - Do not switch off power even if pdn_req is asserted.
 * - 1 - Switch off power when pdn_req is asserted.
 */
/*@{*/
#define BP_PGC_GPU_CTRL_PCR  (0U)          /*!< Bit position for PGC_GPU_CTRL_PCR. */
#define BM_PGC_GPU_CTRL_PCR  (0x00000001U) /*!< Bit mask for PGC_GPU_CTRL_PCR. */
#define BS_PGC_GPU_CTRL_PCR  (1U)          /*!< Bit field size in bits for PGC_GPU_CTRL_PCR. */

/*! @brief Read current value of the PGC_GPU_CTRL_PCR field. */
#define BR_PGC_GPU_CTRL_PCR(x) (HW_PGC_GPU_CTRL(x).B.PCR)

/*! @brief Format value for bitfield PGC_GPU_CTRL_PCR. */
#define BF_PGC_GPU_CTRL_PCR(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_CTRL_PCR) & BM_PGC_GPU_CTRL_PCR)

/*! @brief Set the PCR field to a new value. */
#define BW_PGC_GPU_CTRL_PCR(x, v) (HW_PGC_GPU_CTRL_WR(x, (HW_PGC_GPU_CTRL_RD(x) & ~BM_PGC_GPU_CTRL_PCR) | BF_PGC_GPU_CTRL_PCR(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_GPU_PUPSCR - Power Up Sequence Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_GPU_PUPSCR - Power Up Sequence Control Register (RW)
 *
 * Reset value: 0x00000F01U
 *
 * The PUPSCR contains the power-up timing parameters.
 */
typedef union _hw_pgc_gpu_pupscr
{
    uint32_t U;
    struct _hw_pgc_gpu_pupscr_bitfields
    {
        uint32_t SW : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t SW2ISO : 6;           /*!< [13:8]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_pgc_gpu_pupscr_t;

/*!
 * @name Constants and macros for entire PGC_GPU_PUPSCR register
 */
/*@{*/
#define HW_PGC_GPU_PUPSCR_ADDR(x) ((uintptr_t)(x) + 0x264U)

#define HW_PGC_GPU_PUPSCR(x)     (*(__IO hw_pgc_gpu_pupscr_t *) HW_PGC_GPU_PUPSCR_ADDR(x))
#define HW_PGC_GPU_PUPSCR_RD(x)  (HW_PGC_GPU_PUPSCR(x).U)
#define HW_PGC_GPU_PUPSCR_WR(x, v) (HW_PGC_GPU_PUPSCR(x).U = (v))
#define HW_PGC_GPU_PUPSCR_SET(x, v) (HW_PGC_GPU_PUPSCR_WR(x, HW_PGC_GPU_PUPSCR_RD(x) |  (v)))
#define HW_PGC_GPU_PUPSCR_CLR(x, v) (HW_PGC_GPU_PUPSCR_WR(x, HW_PGC_GPU_PUPSCR_RD(x) & ~(v)))
#define HW_PGC_GPU_PUPSCR_TOG(x, v) (HW_PGC_GPU_PUPSCR_WR(x, HW_PGC_GPU_PUPSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_GPU_PUPSCR bitfields
 */

/*!
 * @name Register PGC_GPU_PUPSCR, field SW[5:0] (RW)
 *
 * After a power-up request (pup_req assertion), the PGC waits a number of IPG
 * clocks equal to the value of SW before asserting power toggle on/off signal
 * (switch_b). SW must not be programmed to zero. The PGC clock is generated from
 * the IPG_CLK_ROOT. for frequency configuration of the IPG_CLK_ROOT. See Clock
 * Controller Module (CCM).
 */
/*@{*/
#define BP_PGC_GPU_PUPSCR_SW (0U)          /*!< Bit position for PGC_GPU_PUPSCR_SW. */
#define BM_PGC_GPU_PUPSCR_SW (0x0000003FU) /*!< Bit mask for PGC_GPU_PUPSCR_SW. */
#define BS_PGC_GPU_PUPSCR_SW (6U)          /*!< Bit field size in bits for PGC_GPU_PUPSCR_SW. */

/*! @brief Read current value of the PGC_GPU_PUPSCR_SW field. */
#define BR_PGC_GPU_PUPSCR_SW(x) (HW_PGC_GPU_PUPSCR(x).B.SW)

/*! @brief Format value for bitfield PGC_GPU_PUPSCR_SW. */
#define BF_PGC_GPU_PUPSCR_SW(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_PUPSCR_SW) & BM_PGC_GPU_PUPSCR_SW)

/*! @brief Set the SW field to a new value. */
#define BW_PGC_GPU_PUPSCR_SW(x, v) (HW_PGC_GPU_PUPSCR_WR(x, (HW_PGC_GPU_PUPSCR_RD(x) & ~BM_PGC_GPU_PUPSCR_SW) | BF_PGC_GPU_PUPSCR_SW(v)))
/*@}*/

/*!
 * @name Register PGC_GPU_PUPSCR, field SW2ISO[13:8] (RW)
 *
 * After asserting power toggle on/off signal (switch_b), the PGC waits a number
 * of IPG clocks equal to the value of SW2ISO before negating isolation. SW2ISO
 * must not be programmed to zero.
 */
/*@{*/
#define BP_PGC_GPU_PUPSCR_SW2ISO (8U)      /*!< Bit position for PGC_GPU_PUPSCR_SW2ISO. */
#define BM_PGC_GPU_PUPSCR_SW2ISO (0x00003F00U) /*!< Bit mask for PGC_GPU_PUPSCR_SW2ISO. */
#define BS_PGC_GPU_PUPSCR_SW2ISO (6U)      /*!< Bit field size in bits for PGC_GPU_PUPSCR_SW2ISO. */

/*! @brief Read current value of the PGC_GPU_PUPSCR_SW2ISO field. */
#define BR_PGC_GPU_PUPSCR_SW2ISO(x) (HW_PGC_GPU_PUPSCR(x).B.SW2ISO)

/*! @brief Format value for bitfield PGC_GPU_PUPSCR_SW2ISO. */
#define BF_PGC_GPU_PUPSCR_SW2ISO(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_PUPSCR_SW2ISO) & BM_PGC_GPU_PUPSCR_SW2ISO)

/*! @brief Set the SW2ISO field to a new value. */
#define BW_PGC_GPU_PUPSCR_SW2ISO(x, v) (HW_PGC_GPU_PUPSCR_WR(x, (HW_PGC_GPU_PUPSCR_RD(x) & ~BM_PGC_GPU_PUPSCR_SW2ISO) | BF_PGC_GPU_PUPSCR_SW2ISO(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_GPU_PDNSCR - Pull Down Sequence Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_GPU_PDNSCR - Pull Down Sequence Control Register (RW)
 *
 * Reset value: 0x00000101U
 *
 * The PDNSCR contains the power-down timing parameters.
 */
typedef union _hw_pgc_gpu_pdnscr
{
    uint32_t U;
    struct _hw_pgc_gpu_pdnscr_bitfields
    {
        uint32_t ISO : 6;              /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t ISO2SW : 6;           /*!< [13:8]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_pgc_gpu_pdnscr_t;

/*!
 * @name Constants and macros for entire PGC_GPU_PDNSCR register
 */
/*@{*/
#define HW_PGC_GPU_PDNSCR_ADDR(x) ((uintptr_t)(x) + 0x268U)

#define HW_PGC_GPU_PDNSCR(x)     (*(__IO hw_pgc_gpu_pdnscr_t *) HW_PGC_GPU_PDNSCR_ADDR(x))
#define HW_PGC_GPU_PDNSCR_RD(x)  (HW_PGC_GPU_PDNSCR(x).U)
#define HW_PGC_GPU_PDNSCR_WR(x, v) (HW_PGC_GPU_PDNSCR(x).U = (v))
#define HW_PGC_GPU_PDNSCR_SET(x, v) (HW_PGC_GPU_PDNSCR_WR(x, HW_PGC_GPU_PDNSCR_RD(x) |  (v)))
#define HW_PGC_GPU_PDNSCR_CLR(x, v) (HW_PGC_GPU_PDNSCR_WR(x, HW_PGC_GPU_PDNSCR_RD(x) & ~(v)))
#define HW_PGC_GPU_PDNSCR_TOG(x, v) (HW_PGC_GPU_PDNSCR_WR(x, HW_PGC_GPU_PDNSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_GPU_PDNSCR bitfields
 */

/*!
 * @name Register PGC_GPU_PDNSCR, field ISO[5:0] (RW)
 *
 * After a power-down request (pdn_req assertion), the PGC waits a number of IPG
 * clocks equal to the value of ISO before asserting isolation. ISO must not be
 * programmed to zero.
 */
/*@{*/
#define BP_PGC_GPU_PDNSCR_ISO (0U)         /*!< Bit position for PGC_GPU_PDNSCR_ISO. */
#define BM_PGC_GPU_PDNSCR_ISO (0x0000003FU) /*!< Bit mask for PGC_GPU_PDNSCR_ISO. */
#define BS_PGC_GPU_PDNSCR_ISO (6U)         /*!< Bit field size in bits for PGC_GPU_PDNSCR_ISO. */

/*! @brief Read current value of the PGC_GPU_PDNSCR_ISO field. */
#define BR_PGC_GPU_PDNSCR_ISO(x) (HW_PGC_GPU_PDNSCR(x).B.ISO)

/*! @brief Format value for bitfield PGC_GPU_PDNSCR_ISO. */
#define BF_PGC_GPU_PDNSCR_ISO(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_PDNSCR_ISO) & BM_PGC_GPU_PDNSCR_ISO)

/*! @brief Set the ISO field to a new value. */
#define BW_PGC_GPU_PDNSCR_ISO(x, v) (HW_PGC_GPU_PDNSCR_WR(x, (HW_PGC_GPU_PDNSCR_RD(x) & ~BM_PGC_GPU_PDNSCR_ISO) | BF_PGC_GPU_PDNSCR_ISO(v)))
/*@}*/

/*!
 * @name Register PGC_GPU_PDNSCR, field ISO2SW[13:8] (RW)
 *
 * After asserting isolation, the PGC waits a number of IPG clocks equal to the
 * value of ISO2SW before negating power toggle on/off signal (switch_b). ISO2SW
 * must not be programmed to zero.
 */
/*@{*/
#define BP_PGC_GPU_PDNSCR_ISO2SW (8U)      /*!< Bit position for PGC_GPU_PDNSCR_ISO2SW. */
#define BM_PGC_GPU_PDNSCR_ISO2SW (0x00003F00U) /*!< Bit mask for PGC_GPU_PDNSCR_ISO2SW. */
#define BS_PGC_GPU_PDNSCR_ISO2SW (6U)      /*!< Bit field size in bits for PGC_GPU_PDNSCR_ISO2SW. */

/*! @brief Read current value of the PGC_GPU_PDNSCR_ISO2SW field. */
#define BR_PGC_GPU_PDNSCR_ISO2SW(x) (HW_PGC_GPU_PDNSCR(x).B.ISO2SW)

/*! @brief Format value for bitfield PGC_GPU_PDNSCR_ISO2SW. */
#define BF_PGC_GPU_PDNSCR_ISO2SW(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_PDNSCR_ISO2SW) & BM_PGC_GPU_PDNSCR_ISO2SW)

/*! @brief Set the ISO2SW field to a new value. */
#define BW_PGC_GPU_PDNSCR_ISO2SW(x, v) (HW_PGC_GPU_PDNSCR_WR(x, (HW_PGC_GPU_PDNSCR_RD(x) & ~BM_PGC_GPU_PDNSCR_ISO2SW) | BF_PGC_GPU_PDNSCR_ISO2SW(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_GPU_SR - Power Gating Controller Status Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_GPU_SR - Power Gating Controller Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PDNSCR contains the power-down timing parameters.
 */
typedef union _hw_pgc_gpu_sr
{
    uint32_t U;
    struct _hw_pgc_gpu_sr_bitfields
    {
        uint32_t PSR : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pgc_gpu_sr_t;

/*!
 * @name Constants and macros for entire PGC_GPU_SR register
 */
/*@{*/
#define HW_PGC_GPU_SR_ADDR(x)    ((uintptr_t)(x) + 0x26CU)

#define HW_PGC_GPU_SR(x)         (*(__IO hw_pgc_gpu_sr_t *) HW_PGC_GPU_SR_ADDR(x))
#define HW_PGC_GPU_SR_RD(x)      (HW_PGC_GPU_SR(x).U)
#define HW_PGC_GPU_SR_WR(x, v)   (HW_PGC_GPU_SR(x).U = (v))
#define HW_PGC_GPU_SR_SET(x, v)  (HW_PGC_GPU_SR_WR(x, HW_PGC_GPU_SR_RD(x) |  (v)))
#define HW_PGC_GPU_SR_CLR(x, v)  (HW_PGC_GPU_SR_WR(x, HW_PGC_GPU_SR_RD(x) & ~(v)))
#define HW_PGC_GPU_SR_TOG(x, v)  (HW_PGC_GPU_SR_WR(x, HW_PGC_GPU_SR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_GPU_SR bitfields
 */

/*!
 * @name Register PGC_GPU_SR, field PSR[0] (RW)
 *
 * Power status. When in functional (or software-controlled debug) mode, PGC
 * hardware sets PSR as soon as any of the power control output changes its state to
 * one. Write one to clear this bit. Software should clear this bit after power
 * up; otherwise, PSR continues to reflect the power status of the initial power
 * down.
 *
 * Values:
 * - 0 - The target subsystem was not powered down for the previous power-down
 *     request.
 * - 1 - The target subsystem was powered down for the previous power-down
 *     request.
 */
/*@{*/
#define BP_PGC_GPU_SR_PSR    (0U)          /*!< Bit position for PGC_GPU_SR_PSR. */
#define BM_PGC_GPU_SR_PSR    (0x00000001U) /*!< Bit mask for PGC_GPU_SR_PSR. */
#define BS_PGC_GPU_SR_PSR    (1U)          /*!< Bit field size in bits for PGC_GPU_SR_PSR. */

/*! @brief Read current value of the PGC_GPU_SR_PSR field. */
#define BR_PGC_GPU_SR_PSR(x) (HW_PGC_GPU_SR(x).B.PSR)

/*! @brief Format value for bitfield PGC_GPU_SR_PSR. */
#define BF_PGC_GPU_SR_PSR(v) ((uint32_t)((uint32_t)(v) << BP_PGC_GPU_SR_PSR) & BM_PGC_GPU_SR_PSR)

/*! @brief Set the PSR field to a new value. */
#define BW_PGC_GPU_SR_PSR(x, v) (HW_PGC_GPU_SR_WR(x, (HW_PGC_GPU_SR_RD(x) & ~BM_PGC_GPU_SR_PSR) | BF_PGC_GPU_SR_PSR(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_CPU_CTRL - PGC Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_CPU_CTRL - PGC Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PGCR enables the response to a power-down request.
 */
typedef union _hw_pgc_cpu_ctrl
{
    uint32_t U;
    struct _hw_pgc_cpu_ctrl_bitfields
    {
        uint32_t PCR : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pgc_cpu_ctrl_t;

/*!
 * @name Constants and macros for entire PGC_CPU_CTRL register
 */
/*@{*/
#define HW_PGC_CPU_CTRL_ADDR(x)  ((uintptr_t)(x) + 0x2A0U)

#define HW_PGC_CPU_CTRL(x)       (*(__IO hw_pgc_cpu_ctrl_t *) HW_PGC_CPU_CTRL_ADDR(x))
#define HW_PGC_CPU_CTRL_RD(x)    (HW_PGC_CPU_CTRL(x).U)
#define HW_PGC_CPU_CTRL_WR(x, v) (HW_PGC_CPU_CTRL(x).U = (v))
#define HW_PGC_CPU_CTRL_SET(x, v) (HW_PGC_CPU_CTRL_WR(x, HW_PGC_CPU_CTRL_RD(x) |  (v)))
#define HW_PGC_CPU_CTRL_CLR(x, v) (HW_PGC_CPU_CTRL_WR(x, HW_PGC_CPU_CTRL_RD(x) & ~(v)))
#define HW_PGC_CPU_CTRL_TOG(x, v) (HW_PGC_CPU_CTRL_WR(x, HW_PGC_CPU_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_CPU_CTRL bitfields
 */

/*!
 * @name Register PGC_CPU_CTRL, field PCR[0] (RW)
 *
 * Power Control PCR must not change from power-down request (pdn_req) assertion
 * until the target subsystem is completely powered up.
 *
 * Values:
 * - 0 - Do not switch off power even if pdn_req is asserted.
 * - 1 - Switch off power when pdn_req is asserted.
 */
/*@{*/
#define BP_PGC_CPU_CTRL_PCR  (0U)          /*!< Bit position for PGC_CPU_CTRL_PCR. */
#define BM_PGC_CPU_CTRL_PCR  (0x00000001U) /*!< Bit mask for PGC_CPU_CTRL_PCR. */
#define BS_PGC_CPU_CTRL_PCR  (1U)          /*!< Bit field size in bits for PGC_CPU_CTRL_PCR. */

/*! @brief Read current value of the PGC_CPU_CTRL_PCR field. */
#define BR_PGC_CPU_CTRL_PCR(x) (HW_PGC_CPU_CTRL(x).B.PCR)

/*! @brief Format value for bitfield PGC_CPU_CTRL_PCR. */
#define BF_PGC_CPU_CTRL_PCR(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_CTRL_PCR) & BM_PGC_CPU_CTRL_PCR)

/*! @brief Set the PCR field to a new value. */
#define BW_PGC_CPU_CTRL_PCR(x, v) (HW_PGC_CPU_CTRL_WR(x, (HW_PGC_CPU_CTRL_RD(x) & ~BM_PGC_CPU_CTRL_PCR) | BF_PGC_CPU_CTRL_PCR(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_CPU_PUPSCR - Power Up Sequence Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_CPU_PUPSCR - Power Up Sequence Control Register (RW)
 *
 * Reset value: 0x00000F01U
 *
 * The PUPSCR contains the power-up timing parameters.
 */
typedef union _hw_pgc_cpu_pupscr
{
    uint32_t U;
    struct _hw_pgc_cpu_pupscr_bitfields
    {
        uint32_t SW : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t SW2ISO : 6;           /*!< [13:8]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_pgc_cpu_pupscr_t;

/*!
 * @name Constants and macros for entire PGC_CPU_PUPSCR register
 */
/*@{*/
#define HW_PGC_CPU_PUPSCR_ADDR(x) ((uintptr_t)(x) + 0x2A4U)

#define HW_PGC_CPU_PUPSCR(x)     (*(__IO hw_pgc_cpu_pupscr_t *) HW_PGC_CPU_PUPSCR_ADDR(x))
#define HW_PGC_CPU_PUPSCR_RD(x)  (HW_PGC_CPU_PUPSCR(x).U)
#define HW_PGC_CPU_PUPSCR_WR(x, v) (HW_PGC_CPU_PUPSCR(x).U = (v))
#define HW_PGC_CPU_PUPSCR_SET(x, v) (HW_PGC_CPU_PUPSCR_WR(x, HW_PGC_CPU_PUPSCR_RD(x) |  (v)))
#define HW_PGC_CPU_PUPSCR_CLR(x, v) (HW_PGC_CPU_PUPSCR_WR(x, HW_PGC_CPU_PUPSCR_RD(x) & ~(v)))
#define HW_PGC_CPU_PUPSCR_TOG(x, v) (HW_PGC_CPU_PUPSCR_WR(x, HW_PGC_CPU_PUPSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_CPU_PUPSCR bitfields
 */

/*!
 * @name Register PGC_CPU_PUPSCR, field SW[5:0] (RW)
 *
 * After a power-up request (pup_req assertion), the PGC waits a number of 32k
 * clocks equal to the value of SW before asserting. SW must not be programmed to
 * zero.
 */
/*@{*/
#define BP_PGC_CPU_PUPSCR_SW (0U)          /*!< Bit position for PGC_CPU_PUPSCR_SW. */
#define BM_PGC_CPU_PUPSCR_SW (0x0000003FU) /*!< Bit mask for PGC_CPU_PUPSCR_SW. */
#define BS_PGC_CPU_PUPSCR_SW (6U)          /*!< Bit field size in bits for PGC_CPU_PUPSCR_SW. */

/*! @brief Read current value of the PGC_CPU_PUPSCR_SW field. */
#define BR_PGC_CPU_PUPSCR_SW(x) (HW_PGC_CPU_PUPSCR(x).B.SW)

/*! @brief Format value for bitfield PGC_CPU_PUPSCR_SW. */
#define BF_PGC_CPU_PUPSCR_SW(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_PUPSCR_SW) & BM_PGC_CPU_PUPSCR_SW)

/*! @brief Set the SW field to a new value. */
#define BW_PGC_CPU_PUPSCR_SW(x, v) (HW_PGC_CPU_PUPSCR_WR(x, (HW_PGC_CPU_PUPSCR_RD(x) & ~BM_PGC_CPU_PUPSCR_SW) | BF_PGC_CPU_PUPSCR_SW(v)))
/*@}*/

/*!
 * @name Register PGC_CPU_PUPSCR, field SW2ISO[13:8] (RW)
 *
 * After asserting , the PGC waits a number of 32k clocks equal to the value of
 * SW2ISO before negating isolation. SW2ISO must not be programmed to zero. The
 * SW2ISO value should be chosen such that the delay before negating isolation is
 * greater than the LDO ramp-up time.
 */
/*@{*/
#define BP_PGC_CPU_PUPSCR_SW2ISO (8U)      /*!< Bit position for PGC_CPU_PUPSCR_SW2ISO. */
#define BM_PGC_CPU_PUPSCR_SW2ISO (0x00003F00U) /*!< Bit mask for PGC_CPU_PUPSCR_SW2ISO. */
#define BS_PGC_CPU_PUPSCR_SW2ISO (6U)      /*!< Bit field size in bits for PGC_CPU_PUPSCR_SW2ISO. */

/*! @brief Read current value of the PGC_CPU_PUPSCR_SW2ISO field. */
#define BR_PGC_CPU_PUPSCR_SW2ISO(x) (HW_PGC_CPU_PUPSCR(x).B.SW2ISO)

/*! @brief Format value for bitfield PGC_CPU_PUPSCR_SW2ISO. */
#define BF_PGC_CPU_PUPSCR_SW2ISO(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_PUPSCR_SW2ISO) & BM_PGC_CPU_PUPSCR_SW2ISO)

/*! @brief Set the SW2ISO field to a new value. */
#define BW_PGC_CPU_PUPSCR_SW2ISO(x, v) (HW_PGC_CPU_PUPSCR_WR(x, (HW_PGC_CPU_PUPSCR_RD(x) & ~BM_PGC_CPU_PUPSCR_SW2ISO) | BF_PGC_CPU_PUPSCR_SW2ISO(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_CPU_PDNSCR - Pull Down Sequence Control Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_CPU_PDNSCR - Pull Down Sequence Control Register (RW)
 *
 * Reset value: 0x00000101U
 *
 * The PDNSCR contains the power-down timing parameters.
 */
typedef union _hw_pgc_cpu_pdnscr
{
    uint32_t U;
    struct _hw_pgc_cpu_pdnscr_bitfields
    {
        uint32_t ISO : 6;              /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t ISO2SW : 6;           /*!< [13:8]  */
        uint32_t RESERVED1 : 18;       /*!< [31:14]  */
    } B;
} hw_pgc_cpu_pdnscr_t;

/*!
 * @name Constants and macros for entire PGC_CPU_PDNSCR register
 */
/*@{*/
#define HW_PGC_CPU_PDNSCR_ADDR(x) ((uintptr_t)(x) + 0x2A8U)

#define HW_PGC_CPU_PDNSCR(x)     (*(__IO hw_pgc_cpu_pdnscr_t *) HW_PGC_CPU_PDNSCR_ADDR(x))
#define HW_PGC_CPU_PDNSCR_RD(x)  (HW_PGC_CPU_PDNSCR(x).U)
#define HW_PGC_CPU_PDNSCR_WR(x, v) (HW_PGC_CPU_PDNSCR(x).U = (v))
#define HW_PGC_CPU_PDNSCR_SET(x, v) (HW_PGC_CPU_PDNSCR_WR(x, HW_PGC_CPU_PDNSCR_RD(x) |  (v)))
#define HW_PGC_CPU_PDNSCR_CLR(x, v) (HW_PGC_CPU_PDNSCR_WR(x, HW_PGC_CPU_PDNSCR_RD(x) & ~(v)))
#define HW_PGC_CPU_PDNSCR_TOG(x, v) (HW_PGC_CPU_PDNSCR_WR(x, HW_PGC_CPU_PDNSCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_CPU_PDNSCR bitfields
 */

/*!
 * @name Register PGC_CPU_PDNSCR, field ISO[5:0] (RW)
 *
 * After a power-down request (pdn_req assertion), the PGC waits a number of 32k
 * clocks equal to the value of ISO before asserting isolation. ISO must not be
 * programmed to zero.
 */
/*@{*/
#define BP_PGC_CPU_PDNSCR_ISO (0U)         /*!< Bit position for PGC_CPU_PDNSCR_ISO. */
#define BM_PGC_CPU_PDNSCR_ISO (0x0000003FU) /*!< Bit mask for PGC_CPU_PDNSCR_ISO. */
#define BS_PGC_CPU_PDNSCR_ISO (6U)         /*!< Bit field size in bits for PGC_CPU_PDNSCR_ISO. */

/*! @brief Read current value of the PGC_CPU_PDNSCR_ISO field. */
#define BR_PGC_CPU_PDNSCR_ISO(x) (HW_PGC_CPU_PDNSCR(x).B.ISO)

/*! @brief Format value for bitfield PGC_CPU_PDNSCR_ISO. */
#define BF_PGC_CPU_PDNSCR_ISO(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_PDNSCR_ISO) & BM_PGC_CPU_PDNSCR_ISO)

/*! @brief Set the ISO field to a new value. */
#define BW_PGC_CPU_PDNSCR_ISO(x, v) (HW_PGC_CPU_PDNSCR_WR(x, (HW_PGC_CPU_PDNSCR_RD(x) & ~BM_PGC_CPU_PDNSCR_ISO) | BF_PGC_CPU_PDNSCR_ISO(v)))
/*@}*/

/*!
 * @name Register PGC_CPU_PDNSCR, field ISO2SW[13:8] (RW)
 *
 * After asserting isolation, the PGC waits a number of 32k clocks equal to the
 * value of ISO2SW before negating . ISO2SW must not be programmed to zero.
 */
/*@{*/
#define BP_PGC_CPU_PDNSCR_ISO2SW (8U)      /*!< Bit position for PGC_CPU_PDNSCR_ISO2SW. */
#define BM_PGC_CPU_PDNSCR_ISO2SW (0x00003F00U) /*!< Bit mask for PGC_CPU_PDNSCR_ISO2SW. */
#define BS_PGC_CPU_PDNSCR_ISO2SW (6U)      /*!< Bit field size in bits for PGC_CPU_PDNSCR_ISO2SW. */

/*! @brief Read current value of the PGC_CPU_PDNSCR_ISO2SW field. */
#define BR_PGC_CPU_PDNSCR_ISO2SW(x) (HW_PGC_CPU_PDNSCR(x).B.ISO2SW)

/*! @brief Format value for bitfield PGC_CPU_PDNSCR_ISO2SW. */
#define BF_PGC_CPU_PDNSCR_ISO2SW(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_PDNSCR_ISO2SW) & BM_PGC_CPU_PDNSCR_ISO2SW)

/*! @brief Set the ISO2SW field to a new value. */
#define BW_PGC_CPU_PDNSCR_ISO2SW(x, v) (HW_PGC_CPU_PDNSCR_WR(x, (HW_PGC_CPU_PDNSCR_RD(x) & ~BM_PGC_CPU_PDNSCR_ISO2SW) | BF_PGC_CPU_PDNSCR_ISO2SW(v)))
/*@}*/

/*******************************************************************************
 * HW_PGC_CPU_SR - Power Gating Controller Status Register
 ******************************************************************************/

/*!
 * @brief HW_PGC_CPU_SR - Power Gating Controller Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PDNSCR contains the power-down timing parameters.
 */
typedef union _hw_pgc_cpu_sr
{
    uint32_t U;
    struct _hw_pgc_cpu_sr_bitfields
    {
        uint32_t PSR : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_pgc_cpu_sr_t;

/*!
 * @name Constants and macros for entire PGC_CPU_SR register
 */
/*@{*/
#define HW_PGC_CPU_SR_ADDR(x)    ((uintptr_t)(x) + 0x2ACU)

#define HW_PGC_CPU_SR(x)         (*(__IO hw_pgc_cpu_sr_t *) HW_PGC_CPU_SR_ADDR(x))
#define HW_PGC_CPU_SR_RD(x)      (HW_PGC_CPU_SR(x).U)
#define HW_PGC_CPU_SR_WR(x, v)   (HW_PGC_CPU_SR(x).U = (v))
#define HW_PGC_CPU_SR_SET(x, v)  (HW_PGC_CPU_SR_WR(x, HW_PGC_CPU_SR_RD(x) |  (v)))
#define HW_PGC_CPU_SR_CLR(x, v)  (HW_PGC_CPU_SR_WR(x, HW_PGC_CPU_SR_RD(x) & ~(v)))
#define HW_PGC_CPU_SR_TOG(x, v)  (HW_PGC_CPU_SR_WR(x, HW_PGC_CPU_SR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PGC_CPU_SR bitfields
 */

/*!
 * @name Register PGC_CPU_SR, field PSR[0] (RW)
 *
 * Power status. When in functional (or software-controlled debug) mode, PGC
 * hardware sets PSR as soon as any of the power control output changes its state to
 * one. Write one to clear this bit. Software should clear this bit after power
 * up; otherwise, PSR continues to reflect the power status of the initial power
 * down.
 *
 * Values:
 * - 0 - The target subsystem was not powered down for the previous power-down
 *     request.
 * - 1 - The target subsystem was powered down for the previous power-down
 *     request.
 */
/*@{*/
#define BP_PGC_CPU_SR_PSR    (0U)          /*!< Bit position for PGC_CPU_SR_PSR. */
#define BM_PGC_CPU_SR_PSR    (0x00000001U) /*!< Bit mask for PGC_CPU_SR_PSR. */
#define BS_PGC_CPU_SR_PSR    (1U)          /*!< Bit field size in bits for PGC_CPU_SR_PSR. */

/*! @brief Read current value of the PGC_CPU_SR_PSR field. */
#define BR_PGC_CPU_SR_PSR(x) (HW_PGC_CPU_SR(x).B.PSR)

/*! @brief Format value for bitfield PGC_CPU_SR_PSR. */
#define BF_PGC_CPU_SR_PSR(v) ((uint32_t)((uint32_t)(v) << BP_PGC_CPU_SR_PSR) & BM_PGC_CPU_SR_PSR)

/*! @brief Set the PSR field to a new value. */
#define BW_PGC_CPU_SR_PSR(x, v) (HW_PGC_CPU_SR_WR(x, (HW_PGC_CPU_SR_RD(x) & ~BM_PGC_CPU_SR_PSR) | BF_PGC_CPU_SR_PSR(v)))
/*@}*/

/*******************************************************************************
 * hw_pgc_t - module struct
 ******************************************************************************/
/*!
 * @brief All PGC module registers.
 */
#pragma pack(1)
typedef struct _hw_pgc
{
    uint8_t _reserved0[608];
    __IO hw_pgc_gpu_ctrl_t GPU_CTRL;       /*!< [0x260] PGC Control Register */
    __IO hw_pgc_gpu_pupscr_t GPU_PUPSCR;   /*!< [0x264] Power Up Sequence Control Register */
    __IO hw_pgc_gpu_pdnscr_t GPU_PDNSCR;   /*!< [0x268] Pull Down Sequence Control Register */
    __IO hw_pgc_gpu_sr_t GPU_SR;           /*!< [0x26C] Power Gating Controller Status Register */
    uint8_t _reserved1[48];
    __IO hw_pgc_cpu_ctrl_t CPU_CTRL;       /*!< [0x2A0] PGC Control Register */
    __IO hw_pgc_cpu_pupscr_t CPU_PUPSCR;   /*!< [0x2A4] Power Up Sequence Control Register */
    __IO hw_pgc_cpu_pdnscr_t CPU_PDNSCR;   /*!< [0x2A8] Pull Down Sequence Control Register */
    __IO hw_pgc_cpu_sr_t CPU_SR;           /*!< [0x2AC] Power Gating Controller Status Register */
} hw_pgc_t;
#pragma pack()

/*! @brief Macro to access all PGC registers. */
/*! @param x PGC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PGC_REGS(PGC_BASE)</code>. */
#define HW_PGC_REGS(x) (*(hw_pgc_t *)(x))

/*
 * iMX6DP PMU
 *
 * PMU
 *
 * Registers defined in this header file:
 * - HW_PMU_REG_1P1 - Regulator 1P1 Register
 * - HW_PMU_REG_3P0 - Regulator 3P0 Register
 * - HW_PMU_REG_2P5 - Regulator 2P5 Register
 * - HW_PMU_REG_CORE - Digital Regulator Core Register
 * - HW_PMU_MISC0 - Miscellaneous Register 0
 * - HW_PMU_MISC1 - Miscellaneous Register 1
 * - HW_PMU_MISC2 - Miscellaneous Control Register
 *
 * - hw_pmu_t - Struct containing all module registers.
 */

#define HW_PMU_INSTANCE_COUNT (1U) /*!< Number of instances of the PMU module. */
#define HW_PMU (0U) /*!< Instance number for PMU. */
#define PMU_BASE              (0x20C8000U) /*!< Base address for PMU. */
/*! Array initializer of PMU base addresses. */
#define PMU_BASE_ADDRS        { PMU_BASE }

/*******************************************************************************
 * HW_PMU_REG_1P1 - Regulator 1P1 Register
 ******************************************************************************/

/*!
 * @brief HW_PMU_REG_1P1 - Regulator 1P1 Register (RW)
 *
 * Reset value: 0x00001073U
 *
 * This register defines the control and status bits for the 1.1V regulator.
 * This regulator is designed to power the digital portions of the analog cells.
 */
typedef union _hw_pmu_reg_1p1
{
    uint32_t U;
    struct _hw_pmu_reg_1p1_bitfields
    {
        uint32_t ENABLE_LINREG : 1;    /*!< [0]  */
        uint32_t ENABLE_BO : 1;        /*!< [1]  */
        uint32_t ENABLE_ILIMIT : 1;    /*!< [2]  */
        uint32_t ENABLE_PULLDOWN : 1;  /*!< [3]  */
        uint32_t BO_OFFSET : 3;        /*!< [6:4]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t OUTPUT_TRG : 5;       /*!< [12:8]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t BO_VDD1P1 : 1;        /*!< [16]  */
        uint32_t OK_VDD1P1 : 1;        /*!< [17]  */
        uint32_t RESERVED2 : 14;       /*!< [31:18]  */
    } B;
} hw_pmu_reg_1p1_t;

/*!
 * @name Constants and macros for entire PMU_REG_1P1 register
 */
/*@{*/
#define HW_PMU_REG_1P1_ADDR(x)   ((uintptr_t)(x) + 0x110U)

#define HW_PMU_REG_1P1(x)        (*(__IO hw_pmu_reg_1p1_t *) HW_PMU_REG_1P1_ADDR(x))
#define HW_PMU_REG_1P1_RD(x)     (HW_PMU_REG_1P1(x).U)
#define HW_PMU_REG_1P1_WR(x, v)  (HW_PMU_REG_1P1(x).U = (v))
#define HW_PMU_REG_1P1_SET(x, v) (HW_PMU_REG_1P1_WR(x, HW_PMU_REG_1P1_RD(x) |  (v)))
#define HW_PMU_REG_1P1_CLR(x, v) (HW_PMU_REG_1P1_WR(x, HW_PMU_REG_1P1_RD(x) & ~(v)))
#define HW_PMU_REG_1P1_TOG(x, v) (HW_PMU_REG_1P1_WR(x, HW_PMU_REG_1P1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PMU_REG_1P1 bitfields
 */

/*!
 * @name Register PMU_REG_1P1, field ENABLE_LINREG[0] (RW)
 *
 * Control bit to enable the regulator output.
 */
/*@{*/
#define BP_PMU_REG_1P1_ENABLE_LINREG (0U)  /*!< Bit position for PMU_REG_1P1_ENABLE_LINREG. */
#define BM_PMU_REG_1P1_ENABLE_LINREG (0x00000001U) /*!< Bit mask for PMU_REG_1P1_ENABLE_LINREG. */
#define BS_PMU_REG_1P1_ENABLE_LINREG (1U)  /*!< Bit field size in bits for PMU_REG_1P1_ENABLE_LINREG. */

/*! @brief Read current value of the PMU_REG_1P1_ENABLE_LINREG field. */
#define BR_PMU_REG_1P1_ENABLE_LINREG(x) (HW_PMU_REG_1P1(x).B.ENABLE_LINREG)

/*! @brief Format value for bitfield PMU_REG_1P1_ENABLE_LINREG. */
#define BF_PMU_REG_1P1_ENABLE_LINREG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_ENABLE_LINREG) & BM_PMU_REG_1P1_ENABLE_LINREG)

/*! @brief Set the ENABLE_LINREG field to a new value. */
#define BW_PMU_REG_1P1_ENABLE_LINREG(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_ENABLE_LINREG) | BF_PMU_REG_1P1_ENABLE_LINREG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field ENABLE_BO[1] (RW)
 *
 * Control bit to enable the brownout circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_1P1_ENABLE_BO (1U)      /*!< Bit position for PMU_REG_1P1_ENABLE_BO. */
#define BM_PMU_REG_1P1_ENABLE_BO (0x00000002U) /*!< Bit mask for PMU_REG_1P1_ENABLE_BO. */
#define BS_PMU_REG_1P1_ENABLE_BO (1U)      /*!< Bit field size in bits for PMU_REG_1P1_ENABLE_BO. */

/*! @brief Read current value of the PMU_REG_1P1_ENABLE_BO field. */
#define BR_PMU_REG_1P1_ENABLE_BO(x) (HW_PMU_REG_1P1(x).B.ENABLE_BO)

/*! @brief Format value for bitfield PMU_REG_1P1_ENABLE_BO. */
#define BF_PMU_REG_1P1_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_ENABLE_BO) & BM_PMU_REG_1P1_ENABLE_BO)

/*! @brief Set the ENABLE_BO field to a new value. */
#define BW_PMU_REG_1P1_ENABLE_BO(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_ENABLE_BO) | BF_PMU_REG_1P1_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field ENABLE_ILIMIT[2] (RW)
 *
 * Control bit to enable the current-limit circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_1P1_ENABLE_ILIMIT (2U)  /*!< Bit position for PMU_REG_1P1_ENABLE_ILIMIT. */
#define BM_PMU_REG_1P1_ENABLE_ILIMIT (0x00000004U) /*!< Bit mask for PMU_REG_1P1_ENABLE_ILIMIT. */
#define BS_PMU_REG_1P1_ENABLE_ILIMIT (1U)  /*!< Bit field size in bits for PMU_REG_1P1_ENABLE_ILIMIT. */

/*! @brief Read current value of the PMU_REG_1P1_ENABLE_ILIMIT field. */
#define BR_PMU_REG_1P1_ENABLE_ILIMIT(x) (HW_PMU_REG_1P1(x).B.ENABLE_ILIMIT)

/*! @brief Format value for bitfield PMU_REG_1P1_ENABLE_ILIMIT. */
#define BF_PMU_REG_1P1_ENABLE_ILIMIT(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_ENABLE_ILIMIT) & BM_PMU_REG_1P1_ENABLE_ILIMIT)

/*! @brief Set the ENABLE_ILIMIT field to a new value. */
#define BW_PMU_REG_1P1_ENABLE_ILIMIT(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_ENABLE_ILIMIT) | BF_PMU_REG_1P1_ENABLE_ILIMIT(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field ENABLE_PULLDOWN[3] (RW)
 *
 * Control bit to enable the pull-down circuitry in the regulator
 */
/*@{*/
#define BP_PMU_REG_1P1_ENABLE_PULLDOWN (3U) /*!< Bit position for PMU_REG_1P1_ENABLE_PULLDOWN. */
#define BM_PMU_REG_1P1_ENABLE_PULLDOWN (0x00000008U) /*!< Bit mask for PMU_REG_1P1_ENABLE_PULLDOWN. */
#define BS_PMU_REG_1P1_ENABLE_PULLDOWN (1U) /*!< Bit field size in bits for PMU_REG_1P1_ENABLE_PULLDOWN. */

/*! @brief Read current value of the PMU_REG_1P1_ENABLE_PULLDOWN field. */
#define BR_PMU_REG_1P1_ENABLE_PULLDOWN(x) (HW_PMU_REG_1P1(x).B.ENABLE_PULLDOWN)

/*! @brief Format value for bitfield PMU_REG_1P1_ENABLE_PULLDOWN. */
#define BF_PMU_REG_1P1_ENABLE_PULLDOWN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_ENABLE_PULLDOWN) & BM_PMU_REG_1P1_ENABLE_PULLDOWN)

/*! @brief Set the ENABLE_PULLDOWN field to a new value. */
#define BW_PMU_REG_1P1_ENABLE_PULLDOWN(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_ENABLE_PULLDOWN) | BF_PMU_REG_1P1_ENABLE_PULLDOWN(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field BO_OFFSET[6:4] (RW)
 *
 * Control bits to adjust the regulator brownout offset voltage in 25mV steps.
 * The reset brown-offset is 175mV below the programmed target code. Brownout
 * target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of input
 * supply limitations or load operation.
 */
/*@{*/
#define BP_PMU_REG_1P1_BO_OFFSET (4U)      /*!< Bit position for PMU_REG_1P1_BO_OFFSET. */
#define BM_PMU_REG_1P1_BO_OFFSET (0x00000070U) /*!< Bit mask for PMU_REG_1P1_BO_OFFSET. */
#define BS_PMU_REG_1P1_BO_OFFSET (3U)      /*!< Bit field size in bits for PMU_REG_1P1_BO_OFFSET. */

/*! @brief Read current value of the PMU_REG_1P1_BO_OFFSET field. */
#define BR_PMU_REG_1P1_BO_OFFSET(x) (HW_PMU_REG_1P1(x).B.BO_OFFSET)

/*! @brief Format value for bitfield PMU_REG_1P1_BO_OFFSET. */
#define BF_PMU_REG_1P1_BO_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_BO_OFFSET) & BM_PMU_REG_1P1_BO_OFFSET)

/*! @brief Set the BO_OFFSET field to a new value. */
#define BW_PMU_REG_1P1_BO_OFFSET(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_BO_OFFSET) | BF_PMU_REG_1P1_BO_OFFSET(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field OUTPUT_TRG[12:8] (RW)
 *
 * Control bits to adjust the regulator output voltage. Each LSB is worth 25mV.
 * Programming examples are detailed below. Other output target voltages may be
 * interpolated from these examples. Choices must be in this range: 0x1b >=
 * output_trg >= 0x04 There may be reduced chip functionality or reliability at the
 * extremes of the programming range.
 *
 * Values:
 * - 100 - 0.8V
 * - 10000 - 1.1V
 * - 0x1 - 1.375V
 */
/*@{*/
#define BP_PMU_REG_1P1_OUTPUT_TRG (8U)     /*!< Bit position for PMU_REG_1P1_OUTPUT_TRG. */
#define BM_PMU_REG_1P1_OUTPUT_TRG (0x00001F00U) /*!< Bit mask for PMU_REG_1P1_OUTPUT_TRG. */
#define BS_PMU_REG_1P1_OUTPUT_TRG (5U)     /*!< Bit field size in bits for PMU_REG_1P1_OUTPUT_TRG. */

/*! @brief Read current value of the PMU_REG_1P1_OUTPUT_TRG field. */
#define BR_PMU_REG_1P1_OUTPUT_TRG(x) (HW_PMU_REG_1P1(x).B.OUTPUT_TRG)

/*! @brief Format value for bitfield PMU_REG_1P1_OUTPUT_TRG. */
#define BF_PMU_REG_1P1_OUTPUT_TRG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_1P1_OUTPUT_TRG) & BM_PMU_REG_1P1_OUTPUT_TRG)

/*! @brief Set the OUTPUT_TRG field to a new value. */
#define BW_PMU_REG_1P1_OUTPUT_TRG(x, v) (HW_PMU_REG_1P1_WR(x, (HW_PMU_REG_1P1_RD(x) & ~BM_PMU_REG_1P1_OUTPUT_TRG) | BF_PMU_REG_1P1_OUTPUT_TRG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field BO_VDD1P1[16] (RO)
 *
 * Status bit that signals when a brownout is detected on the regulator output.
 */
/*@{*/
#define BP_PMU_REG_1P1_BO_VDD1P1 (16U)     /*!< Bit position for PMU_REG_1P1_BO_VDD1P1. */
#define BM_PMU_REG_1P1_BO_VDD1P1 (0x00010000U) /*!< Bit mask for PMU_REG_1P1_BO_VDD1P1. */
#define BS_PMU_REG_1P1_BO_VDD1P1 (1U)      /*!< Bit field size in bits for PMU_REG_1P1_BO_VDD1P1. */

/*! @brief Read current value of the PMU_REG_1P1_BO_VDD1P1 field. */
#define BR_PMU_REG_1P1_BO_VDD1P1(x) (HW_PMU_REG_1P1(x).B.BO_VDD1P1)
/*@}*/

/*!
 * @name Register PMU_REG_1P1, field OK_VDD1P1[17] (RO)
 *
 * Status bit that signals when the regulator output is ok. 1 = regulator output
 * > brownout target
 */
/*@{*/
#define BP_PMU_REG_1P1_OK_VDD1P1 (17U)     /*!< Bit position for PMU_REG_1P1_OK_VDD1P1. */
#define BM_PMU_REG_1P1_OK_VDD1P1 (0x00020000U) /*!< Bit mask for PMU_REG_1P1_OK_VDD1P1. */
#define BS_PMU_REG_1P1_OK_VDD1P1 (1U)      /*!< Bit field size in bits for PMU_REG_1P1_OK_VDD1P1. */

/*! @brief Read current value of the PMU_REG_1P1_OK_VDD1P1 field. */
#define BR_PMU_REG_1P1_OK_VDD1P1(x) (HW_PMU_REG_1P1(x).B.OK_VDD1P1)
/*@}*/

/*******************************************************************************
 * HW_PMU_REG_3P0 - Regulator 3P0 Register
 ******************************************************************************/

/*!
 * @brief HW_PMU_REG_3P0 - Regulator 3P0 Register (RW)
 *
 * Reset value: 0x00000F74U
 *
 * This register defines the control and status bits for the 3.0V regulator
 * powered by the host USB VBUS pin.
 */
typedef union _hw_pmu_reg_3p0
{
    uint32_t U;
    struct _hw_pmu_reg_3p0_bitfields
    {
        uint32_t ENABLE_LINREG : 1;    /*!< [0]  */
        uint32_t ENABLE_BO : 1;        /*!< [1]  */
        uint32_t ENABLE_ILIMIT : 1;    /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t BO_OFFSET : 3;        /*!< [6:4]  */
        uint32_t VBUS_SEL : 1;         /*!< [7]  */
        uint32_t OUTPUT_TRG : 5;       /*!< [12:8]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t BO_VDD3P0 : 1;        /*!< [16]  */
        uint32_t OK_VDD3P0 : 1;        /*!< [17]  */
        uint32_t RESERVED2 : 14;       /*!< [31:18]  */
    } B;
} hw_pmu_reg_3p0_t;

/*!
 * @name Constants and macros for entire PMU_REG_3P0 register
 */
/*@{*/
#define HW_PMU_REG_3P0_ADDR(x)   ((uintptr_t)(x) + 0x120U)

#define HW_PMU_REG_3P0(x)        (*(__IO hw_pmu_reg_3p0_t *) HW_PMU_REG_3P0_ADDR(x))
#define HW_PMU_REG_3P0_RD(x)     (HW_PMU_REG_3P0(x).U)
#define HW_PMU_REG_3P0_WR(x, v)  (HW_PMU_REG_3P0(x).U = (v))
#define HW_PMU_REG_3P0_SET(x, v) (HW_PMU_REG_3P0_WR(x, HW_PMU_REG_3P0_RD(x) |  (v)))
#define HW_PMU_REG_3P0_CLR(x, v) (HW_PMU_REG_3P0_WR(x, HW_PMU_REG_3P0_RD(x) & ~(v)))
#define HW_PMU_REG_3P0_TOG(x, v) (HW_PMU_REG_3P0_WR(x, HW_PMU_REG_3P0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PMU_REG_3P0 bitfields
 */

/*!
 * @name Register PMU_REG_3P0, field ENABLE_LINREG[0] (RW)
 *
 * Control bit to enable the regulator output to be set by the programmed target
 * voltage setting and internal bandgap reference.
 */
/*@{*/
#define BP_PMU_REG_3P0_ENABLE_LINREG (0U)  /*!< Bit position for PMU_REG_3P0_ENABLE_LINREG. */
#define BM_PMU_REG_3P0_ENABLE_LINREG (0x00000001U) /*!< Bit mask for PMU_REG_3P0_ENABLE_LINREG. */
#define BS_PMU_REG_3P0_ENABLE_LINREG (1U)  /*!< Bit field size in bits for PMU_REG_3P0_ENABLE_LINREG. */

/*! @brief Read current value of the PMU_REG_3P0_ENABLE_LINREG field. */
#define BR_PMU_REG_3P0_ENABLE_LINREG(x) (HW_PMU_REG_3P0(x).B.ENABLE_LINREG)

/*! @brief Format value for bitfield PMU_REG_3P0_ENABLE_LINREG. */
#define BF_PMU_REG_3P0_ENABLE_LINREG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_ENABLE_LINREG) & BM_PMU_REG_3P0_ENABLE_LINREG)

/*! @brief Set the ENABLE_LINREG field to a new value. */
#define BW_PMU_REG_3P0_ENABLE_LINREG(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_ENABLE_LINREG) | BF_PMU_REG_3P0_ENABLE_LINREG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field ENABLE_BO[1] (RW)
 *
 * Control bit to enable the brownout circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_3P0_ENABLE_BO (1U)      /*!< Bit position for PMU_REG_3P0_ENABLE_BO. */
#define BM_PMU_REG_3P0_ENABLE_BO (0x00000002U) /*!< Bit mask for PMU_REG_3P0_ENABLE_BO. */
#define BS_PMU_REG_3P0_ENABLE_BO (1U)      /*!< Bit field size in bits for PMU_REG_3P0_ENABLE_BO. */

/*! @brief Read current value of the PMU_REG_3P0_ENABLE_BO field. */
#define BR_PMU_REG_3P0_ENABLE_BO(x) (HW_PMU_REG_3P0(x).B.ENABLE_BO)

/*! @brief Format value for bitfield PMU_REG_3P0_ENABLE_BO. */
#define BF_PMU_REG_3P0_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_ENABLE_BO) & BM_PMU_REG_3P0_ENABLE_BO)

/*! @brief Set the ENABLE_BO field to a new value. */
#define BW_PMU_REG_3P0_ENABLE_BO(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_ENABLE_BO) | BF_PMU_REG_3P0_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field ENABLE_ILIMIT[2] (RW)
 *
 * Control bit to enable the current-limit circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_3P0_ENABLE_ILIMIT (2U)  /*!< Bit position for PMU_REG_3P0_ENABLE_ILIMIT. */
#define BM_PMU_REG_3P0_ENABLE_ILIMIT (0x00000004U) /*!< Bit mask for PMU_REG_3P0_ENABLE_ILIMIT. */
#define BS_PMU_REG_3P0_ENABLE_ILIMIT (1U)  /*!< Bit field size in bits for PMU_REG_3P0_ENABLE_ILIMIT. */

/*! @brief Read current value of the PMU_REG_3P0_ENABLE_ILIMIT field. */
#define BR_PMU_REG_3P0_ENABLE_ILIMIT(x) (HW_PMU_REG_3P0(x).B.ENABLE_ILIMIT)

/*! @brief Format value for bitfield PMU_REG_3P0_ENABLE_ILIMIT. */
#define BF_PMU_REG_3P0_ENABLE_ILIMIT(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_ENABLE_ILIMIT) & BM_PMU_REG_3P0_ENABLE_ILIMIT)

/*! @brief Set the ENABLE_ILIMIT field to a new value. */
#define BW_PMU_REG_3P0_ENABLE_ILIMIT(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_ENABLE_ILIMIT) | BF_PMU_REG_3P0_ENABLE_ILIMIT(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field BO_OFFSET[6:4] (RW)
 *
 * Control bits to adjust the regulator brownout offset voltage in 25mV steps.
 * The reset brown-offset is 175mV below the programmed target code. Brownout
 * target = OUTPUT_TRG - BO_OFFSET. Some steps may not be relevant because of input
 * supply limitations or load operation.
 */
/*@{*/
#define BP_PMU_REG_3P0_BO_OFFSET (4U)      /*!< Bit position for PMU_REG_3P0_BO_OFFSET. */
#define BM_PMU_REG_3P0_BO_OFFSET (0x00000070U) /*!< Bit mask for PMU_REG_3P0_BO_OFFSET. */
#define BS_PMU_REG_3P0_BO_OFFSET (3U)      /*!< Bit field size in bits for PMU_REG_3P0_BO_OFFSET. */

/*! @brief Read current value of the PMU_REG_3P0_BO_OFFSET field. */
#define BR_PMU_REG_3P0_BO_OFFSET(x) (HW_PMU_REG_3P0(x).B.BO_OFFSET)

/*! @brief Format value for bitfield PMU_REG_3P0_BO_OFFSET. */
#define BF_PMU_REG_3P0_BO_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_BO_OFFSET) & BM_PMU_REG_3P0_BO_OFFSET)

/*! @brief Set the BO_OFFSET field to a new value. */
#define BW_PMU_REG_3P0_BO_OFFSET(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_BO_OFFSET) | BF_PMU_REG_3P0_BO_OFFSET(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field VBUS_SEL[7] (RW)
 *
 * Select input voltage source for LDO_3P0 from either USB_H1_VBUS or
 * USB_OTG_VBUS. If only one of the two VBUS voltages is present, it will automatically be
 * selected.
 *
 * Values:
 * - 0 - Utilize VBUS H1 for power
 * - 1 - Utilize VBUS OTG for power
 */
/*@{*/
#define BP_PMU_REG_3P0_VBUS_SEL (7U)       /*!< Bit position for PMU_REG_3P0_VBUS_SEL. */
#define BM_PMU_REG_3P0_VBUS_SEL (0x00000080U) /*!< Bit mask for PMU_REG_3P0_VBUS_SEL. */
#define BS_PMU_REG_3P0_VBUS_SEL (1U)       /*!< Bit field size in bits for PMU_REG_3P0_VBUS_SEL. */

#define BV_PMU_REG_3P0_VBUS_SEL_USB_H1_VBUS (0U)     /*!< Bit field value for PMU_REG_3P0_VBUS_SEL: Utilize VBUS H1 for power */
#define BV_PMU_REG_3P0_VBUS_SEL_USB_OTG_VBUS (0x1U)  /*!< Bit field value for PMU_REG_3P0_VBUS_SEL: Utilize VBUS OTG for power */

/*! @brief Read current value of the PMU_REG_3P0_VBUS_SEL field. */
#define BR_PMU_REG_3P0_VBUS_SEL(x) (HW_PMU_REG_3P0(x).B.VBUS_SEL)

/*! @brief Format value for bitfield PMU_REG_3P0_VBUS_SEL. */
#define BF_PMU_REG_3P0_VBUS_SEL(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_VBUS_SEL) & BM_PMU_REG_3P0_VBUS_SEL)

/*! @brief Set the VBUS_SEL field to a new value. */
#define BW_PMU_REG_3P0_VBUS_SEL(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_VBUS_SEL) | BF_PMU_REG_3P0_VBUS_SEL(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field OUTPUT_TRG[12:8] (RW)
 *
 * Control bits to adjust the regulator output voltage. Each LSB is worth 25mV.
 * Programming examples are detailed below. Other output target voltages may be
 * interpolated from these examples. There may be reduced chip functionality or
 * reliability at the extremes of the programming range.
 *
 * Values:
 * - 0 - 2.625V
 * - 1111 - 3.000V
 * - 11111 - 3.400V
 */
/*@{*/
#define BP_PMU_REG_3P0_OUTPUT_TRG (8U)     /*!< Bit position for PMU_REG_3P0_OUTPUT_TRG. */
#define BM_PMU_REG_3P0_OUTPUT_TRG (0x00001F00U) /*!< Bit mask for PMU_REG_3P0_OUTPUT_TRG. */
#define BS_PMU_REG_3P0_OUTPUT_TRG (5U)     /*!< Bit field size in bits for PMU_REG_3P0_OUTPUT_TRG. */

/*! @brief Read current value of the PMU_REG_3P0_OUTPUT_TRG field. */
#define BR_PMU_REG_3P0_OUTPUT_TRG(x) (HW_PMU_REG_3P0(x).B.OUTPUT_TRG)

/*! @brief Format value for bitfield PMU_REG_3P0_OUTPUT_TRG. */
#define BF_PMU_REG_3P0_OUTPUT_TRG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_3P0_OUTPUT_TRG) & BM_PMU_REG_3P0_OUTPUT_TRG)

/*! @brief Set the OUTPUT_TRG field to a new value. */
#define BW_PMU_REG_3P0_OUTPUT_TRG(x, v) (HW_PMU_REG_3P0_WR(x, (HW_PMU_REG_3P0_RD(x) & ~BM_PMU_REG_3P0_OUTPUT_TRG) | BF_PMU_REG_3P0_OUTPUT_TRG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field BO_VDD3P0[16] (RO)
 *
 * Status bit that signals when a brownout is detected on the regulator output.
 */
/*@{*/
#define BP_PMU_REG_3P0_BO_VDD3P0 (16U)     /*!< Bit position for PMU_REG_3P0_BO_VDD3P0. */
#define BM_PMU_REG_3P0_BO_VDD3P0 (0x00010000U) /*!< Bit mask for PMU_REG_3P0_BO_VDD3P0. */
#define BS_PMU_REG_3P0_BO_VDD3P0 (1U)      /*!< Bit field size in bits for PMU_REG_3P0_BO_VDD3P0. */

/*! @brief Read current value of the PMU_REG_3P0_BO_VDD3P0 field. */
#define BR_PMU_REG_3P0_BO_VDD3P0(x) (HW_PMU_REG_3P0(x).B.BO_VDD3P0)
/*@}*/

/*!
 * @name Register PMU_REG_3P0, field OK_VDD3P0[17] (RO)
 *
 * Status bit that signals when the regulator output is ok. 1 = regulator output
 * > brownout target
 */
/*@{*/
#define BP_PMU_REG_3P0_OK_VDD3P0 (17U)     /*!< Bit position for PMU_REG_3P0_OK_VDD3P0. */
#define BM_PMU_REG_3P0_OK_VDD3P0 (0x00020000U) /*!< Bit mask for PMU_REG_3P0_OK_VDD3P0. */
#define BS_PMU_REG_3P0_OK_VDD3P0 (1U)      /*!< Bit field size in bits for PMU_REG_3P0_OK_VDD3P0. */

/*! @brief Read current value of the PMU_REG_3P0_OK_VDD3P0 field. */
#define BR_PMU_REG_3P0_OK_VDD3P0(x) (HW_PMU_REG_3P0(x).B.OK_VDD3P0)
/*@}*/

/*******************************************************************************
 * HW_PMU_REG_2P5 - Regulator 2P5 Register
 ******************************************************************************/

/*!
 * @brief HW_PMU_REG_2P5 - Regulator 2P5 Register (RW)
 *
 * Reset value: 0x00005071U
 *
 * This register defines the control and status bits for the 2.5V regulator.
 */
typedef union _hw_pmu_reg_2p5
{
    uint32_t U;
    struct _hw_pmu_reg_2p5_bitfields
    {
        uint32_t ENABLE_LINREG : 1;    /*!< [0]  */
        uint32_t ENABLE_BO : 1;        /*!< [1]  */
        uint32_t ENABLE_ILIMIT : 1;    /*!< [2]  */
        uint32_t ENABLE_PULLDOWN : 1;  /*!< [3]  */
        uint32_t BO_OFFSET : 3;        /*!< [6:4]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t OUTPUT_TRG : 5;       /*!< [12:8]  */
        uint32_t RESERVED1 : 3;        /*!< [15:13]  */
        uint32_t BO_VDD2P5 : 1;        /*!< [16]  */
        uint32_t OK_VDD2P5 : 1;        /*!< [17]  */
        uint32_t ENABLE_WEAK_LINREG : 1; /*!< [18]  */
        uint32_t RESERVED2 : 13;       /*!< [31:19]  */
    } B;
} hw_pmu_reg_2p5_t;

/*!
 * @name Constants and macros for entire PMU_REG_2P5 register
 */
/*@{*/
#define HW_PMU_REG_2P5_ADDR(x)   ((uintptr_t)(x) + 0x130U)

#define HW_PMU_REG_2P5(x)        (*(__IO hw_pmu_reg_2p5_t *) HW_PMU_REG_2P5_ADDR(x))
#define HW_PMU_REG_2P5_RD(x)     (HW_PMU_REG_2P5(x).U)
#define HW_PMU_REG_2P5_WR(x, v)  (HW_PMU_REG_2P5(x).U = (v))
#define HW_PMU_REG_2P5_SET(x, v) (HW_PMU_REG_2P5_WR(x, HW_PMU_REG_2P5_RD(x) |  (v)))
#define HW_PMU_REG_2P5_CLR(x, v) (HW_PMU_REG_2P5_WR(x, HW_PMU_REG_2P5_RD(x) & ~(v)))
#define HW_PMU_REG_2P5_TOG(x, v) (HW_PMU_REG_2P5_WR(x, HW_PMU_REG_2P5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PMU_REG_2P5 bitfields
 */

/*!
 * @name Register PMU_REG_2P5, field ENABLE_LINREG[0] (RW)
 *
 * Control bit to enable the regulator output.
 */
/*@{*/
#define BP_PMU_REG_2P5_ENABLE_LINREG (0U)  /*!< Bit position for PMU_REG_2P5_ENABLE_LINREG. */
#define BM_PMU_REG_2P5_ENABLE_LINREG (0x00000001U) /*!< Bit mask for PMU_REG_2P5_ENABLE_LINREG. */
#define BS_PMU_REG_2P5_ENABLE_LINREG (1U)  /*!< Bit field size in bits for PMU_REG_2P5_ENABLE_LINREG. */

/*! @brief Read current value of the PMU_REG_2P5_ENABLE_LINREG field. */
#define BR_PMU_REG_2P5_ENABLE_LINREG(x) (HW_PMU_REG_2P5(x).B.ENABLE_LINREG)

/*! @brief Format value for bitfield PMU_REG_2P5_ENABLE_LINREG. */
#define BF_PMU_REG_2P5_ENABLE_LINREG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_ENABLE_LINREG) & BM_PMU_REG_2P5_ENABLE_LINREG)

/*! @brief Set the ENABLE_LINREG field to a new value. */
#define BW_PMU_REG_2P5_ENABLE_LINREG(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_ENABLE_LINREG) | BF_PMU_REG_2P5_ENABLE_LINREG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field ENABLE_BO[1] (RW)
 *
 * Control bit to enable the brownout circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_2P5_ENABLE_BO (1U)      /*!< Bit position for PMU_REG_2P5_ENABLE_BO. */
#define BM_PMU_REG_2P5_ENABLE_BO (0x00000002U) /*!< Bit mask for PMU_REG_2P5_ENABLE_BO. */
#define BS_PMU_REG_2P5_ENABLE_BO (1U)      /*!< Bit field size in bits for PMU_REG_2P5_ENABLE_BO. */

/*! @brief Read current value of the PMU_REG_2P5_ENABLE_BO field. */
#define BR_PMU_REG_2P5_ENABLE_BO(x) (HW_PMU_REG_2P5(x).B.ENABLE_BO)

/*! @brief Format value for bitfield PMU_REG_2P5_ENABLE_BO. */
#define BF_PMU_REG_2P5_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_ENABLE_BO) & BM_PMU_REG_2P5_ENABLE_BO)

/*! @brief Set the ENABLE_BO field to a new value. */
#define BW_PMU_REG_2P5_ENABLE_BO(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_ENABLE_BO) | BF_PMU_REG_2P5_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field ENABLE_ILIMIT[2] (RW)
 *
 * Control bit to enable the current-limit circuitry in the regulator.
 */
/*@{*/
#define BP_PMU_REG_2P5_ENABLE_ILIMIT (2U)  /*!< Bit position for PMU_REG_2P5_ENABLE_ILIMIT. */
#define BM_PMU_REG_2P5_ENABLE_ILIMIT (0x00000004U) /*!< Bit mask for PMU_REG_2P5_ENABLE_ILIMIT. */
#define BS_PMU_REG_2P5_ENABLE_ILIMIT (1U)  /*!< Bit field size in bits for PMU_REG_2P5_ENABLE_ILIMIT. */

/*! @brief Read current value of the PMU_REG_2P5_ENABLE_ILIMIT field. */
#define BR_PMU_REG_2P5_ENABLE_ILIMIT(x) (HW_PMU_REG_2P5(x).B.ENABLE_ILIMIT)

/*! @brief Format value for bitfield PMU_REG_2P5_ENABLE_ILIMIT. */
#define BF_PMU_REG_2P5_ENABLE_ILIMIT(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_ENABLE_ILIMIT) & BM_PMU_REG_2P5_ENABLE_ILIMIT)

/*! @brief Set the ENABLE_ILIMIT field to a new value. */
#define BW_PMU_REG_2P5_ENABLE_ILIMIT(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_ENABLE_ILIMIT) | BF_PMU_REG_2P5_ENABLE_ILIMIT(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field ENABLE_PULLDOWN[3] (RW)
 *
 * Control bit to enable the pull-down circuitry in the regulator
 */
/*@{*/
#define BP_PMU_REG_2P5_ENABLE_PULLDOWN (3U) /*!< Bit position for PMU_REG_2P5_ENABLE_PULLDOWN. */
#define BM_PMU_REG_2P5_ENABLE_PULLDOWN (0x00000008U) /*!< Bit mask for PMU_REG_2P5_ENABLE_PULLDOWN. */
#define BS_PMU_REG_2P5_ENABLE_PULLDOWN (1U) /*!< Bit field size in bits for PMU_REG_2P5_ENABLE_PULLDOWN. */

/*! @brief Read current value of the PMU_REG_2P5_ENABLE_PULLDOWN field. */
#define BR_PMU_REG_2P5_ENABLE_PULLDOWN(x) (HW_PMU_REG_2P5(x).B.ENABLE_PULLDOWN)

/*! @brief Format value for bitfield PMU_REG_2P5_ENABLE_PULLDOWN. */
#define BF_PMU_REG_2P5_ENABLE_PULLDOWN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_ENABLE_PULLDOWN) & BM_PMU_REG_2P5_ENABLE_PULLDOWN)

/*! @brief Set the ENABLE_PULLDOWN field to a new value. */
#define BW_PMU_REG_2P5_ENABLE_PULLDOWN(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_ENABLE_PULLDOWN) | BF_PMU_REG_2P5_ENABLE_PULLDOWN(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field BO_OFFSET[6:4] (RW)
 *
 * Control bits to adjust the regulator brownout offset voltage in 25mV steps.
 * The reset brown-offset is 175mV below the programmed target code. Brownout
 * target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of input
 * supply limitations or load operation.
 */
/*@{*/
#define BP_PMU_REG_2P5_BO_OFFSET (4U)      /*!< Bit position for PMU_REG_2P5_BO_OFFSET. */
#define BM_PMU_REG_2P5_BO_OFFSET (0x00000070U) /*!< Bit mask for PMU_REG_2P5_BO_OFFSET. */
#define BS_PMU_REG_2P5_BO_OFFSET (3U)      /*!< Bit field size in bits for PMU_REG_2P5_BO_OFFSET. */

/*! @brief Read current value of the PMU_REG_2P5_BO_OFFSET field. */
#define BR_PMU_REG_2P5_BO_OFFSET(x) (HW_PMU_REG_2P5(x).B.BO_OFFSET)

/*! @brief Format value for bitfield PMU_REG_2P5_BO_OFFSET. */
#define BF_PMU_REG_2P5_BO_OFFSET(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_BO_OFFSET) & BM_PMU_REG_2P5_BO_OFFSET)

/*! @brief Set the BO_OFFSET field to a new value. */
#define BW_PMU_REG_2P5_BO_OFFSET(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_BO_OFFSET) | BF_PMU_REG_2P5_BO_OFFSET(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field OUTPUT_TRG[12:8] (RW)
 *
 * Control bits to adjust the regulator output voltage. Each LSB is worth 25mV.
 * Programming examples are detailed below. Other output target voltages may be
 * interpolated from these examples. There may be reduced chip functionality or
 * reliability at the extremes of the programming range.
 *
 * Values:
 * - 0 - 2.10V
 * - 10000 - 2.50V
 * - 11111 - 2.875V
 */
/*@{*/
#define BP_PMU_REG_2P5_OUTPUT_TRG (8U)     /*!< Bit position for PMU_REG_2P5_OUTPUT_TRG. */
#define BM_PMU_REG_2P5_OUTPUT_TRG (0x00001F00U) /*!< Bit mask for PMU_REG_2P5_OUTPUT_TRG. */
#define BS_PMU_REG_2P5_OUTPUT_TRG (5U)     /*!< Bit field size in bits for PMU_REG_2P5_OUTPUT_TRG. */

/*! @brief Read current value of the PMU_REG_2P5_OUTPUT_TRG field. */
#define BR_PMU_REG_2P5_OUTPUT_TRG(x) (HW_PMU_REG_2P5(x).B.OUTPUT_TRG)

/*! @brief Format value for bitfield PMU_REG_2P5_OUTPUT_TRG. */
#define BF_PMU_REG_2P5_OUTPUT_TRG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_OUTPUT_TRG) & BM_PMU_REG_2P5_OUTPUT_TRG)

/*! @brief Set the OUTPUT_TRG field to a new value. */
#define BW_PMU_REG_2P5_OUTPUT_TRG(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_OUTPUT_TRG) | BF_PMU_REG_2P5_OUTPUT_TRG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field BO_VDD2P5[16] (RO)
 *
 * Status bit that signals when a brownout is detected on the regulator output.
 */
/*@{*/
#define BP_PMU_REG_2P5_BO_VDD2P5 (16U)     /*!< Bit position for PMU_REG_2P5_BO_VDD2P5. */
#define BM_PMU_REG_2P5_BO_VDD2P5 (0x00010000U) /*!< Bit mask for PMU_REG_2P5_BO_VDD2P5. */
#define BS_PMU_REG_2P5_BO_VDD2P5 (1U)      /*!< Bit field size in bits for PMU_REG_2P5_BO_VDD2P5. */

/*! @brief Read current value of the PMU_REG_2P5_BO_VDD2P5 field. */
#define BR_PMU_REG_2P5_BO_VDD2P5(x) (HW_PMU_REG_2P5(x).B.BO_VDD2P5)
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field OK_VDD2P5[17] (RO)
 *
 * Status bit that signals when the regulator output is ok. 1 = regulator output
 * > brownout target
 */
/*@{*/
#define BP_PMU_REG_2P5_OK_VDD2P5 (17U)     /*!< Bit position for PMU_REG_2P5_OK_VDD2P5. */
#define BM_PMU_REG_2P5_OK_VDD2P5 (0x00020000U) /*!< Bit mask for PMU_REG_2P5_OK_VDD2P5. */
#define BS_PMU_REG_2P5_OK_VDD2P5 (1U)      /*!< Bit field size in bits for PMU_REG_2P5_OK_VDD2P5. */

/*! @brief Read current value of the PMU_REG_2P5_OK_VDD2P5 field. */
#define BR_PMU_REG_2P5_OK_VDD2P5(x) (HW_PMU_REG_2P5(x).B.OK_VDD2P5)
/*@}*/

/*!
 * @name Register PMU_REG_2P5, field ENABLE_WEAK_LINREG[18] (RW)
 *
 * Enables the weak 2p5 regulator. This low power regulator is used when the
 * main 2p5 regulator is disabled to keep the 2.5V output roughly at 2.5V. Scales
 * directly with the value of VDDHIGH_IN.
 */
/*@{*/
#define BP_PMU_REG_2P5_ENABLE_WEAK_LINREG (18U) /*!< Bit position for PMU_REG_2P5_ENABLE_WEAK_LINREG. */
#define BM_PMU_REG_2P5_ENABLE_WEAK_LINREG (0x00040000U) /*!< Bit mask for PMU_REG_2P5_ENABLE_WEAK_LINREG. */
#define BS_PMU_REG_2P5_ENABLE_WEAK_LINREG (1U) /*!< Bit field size in bits for PMU_REG_2P5_ENABLE_WEAK_LINREG. */

/*! @brief Read current value of the PMU_REG_2P5_ENABLE_WEAK_LINREG field. */
#define BR_PMU_REG_2P5_ENABLE_WEAK_LINREG(x) (HW_PMU_REG_2P5(x).B.ENABLE_WEAK_LINREG)

/*! @brief Format value for bitfield PMU_REG_2P5_ENABLE_WEAK_LINREG. */
#define BF_PMU_REG_2P5_ENABLE_WEAK_LINREG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_2P5_ENABLE_WEAK_LINREG) & BM_PMU_REG_2P5_ENABLE_WEAK_LINREG)

/*! @brief Set the ENABLE_WEAK_LINREG field to a new value. */
#define BW_PMU_REG_2P5_ENABLE_WEAK_LINREG(x, v) (HW_PMU_REG_2P5_WR(x, (HW_PMU_REG_2P5_RD(x) & ~BM_PMU_REG_2P5_ENABLE_WEAK_LINREG) | BF_PMU_REG_2P5_ENABLE_WEAK_LINREG(v)))
/*@}*/

/*******************************************************************************
 * HW_PMU_REG_CORE - Digital Regulator Core Register
 ******************************************************************************/

/*!
 * @brief HW_PMU_REG_CORE - Digital Regulator Core Register (RW)
 *
 * Reset value: 0x00482412U
 *
 * This register defines the function of the digital regulators
 */
typedef union _hw_pmu_reg_core
{
    uint32_t U;
    struct _hw_pmu_reg_core_bitfields
    {
        uint32_t REG0_TARG : 5;        /*!< [4:0]  */
        uint32_t RESERVED0 : 4;        /*!< [8:5]  */
        uint32_t REG1_TARG : 5;        /*!< [13:9]  */
        uint32_t RESERVED1 : 4;        /*!< [17:14]  */
        uint32_t REG2_TARG : 5;        /*!< [22:18]  */
        uint32_t RESERVED2 : 6;        /*!< [28:23]  */
        uint32_t FET_ODRIVE : 1;       /*!< [29]  */
        uint32_t RESERVED3 : 2;        /*!< [31:30]  */
    } B;
} hw_pmu_reg_core_t;

/*!
 * @name Constants and macros for entire PMU_REG_CORE register
 */
/*@{*/
#define HW_PMU_REG_CORE_ADDR(x)  ((uintptr_t)(x) + 0x140U)

#define HW_PMU_REG_CORE(x)       (*(__IO hw_pmu_reg_core_t *) HW_PMU_REG_CORE_ADDR(x))
#define HW_PMU_REG_CORE_RD(x)    (HW_PMU_REG_CORE(x).U)
#define HW_PMU_REG_CORE_WR(x, v) (HW_PMU_REG_CORE(x).U = (v))
#define HW_PMU_REG_CORE_SET(x, v) (HW_PMU_REG_CORE_WR(x, HW_PMU_REG_CORE_RD(x) |  (v)))
#define HW_PMU_REG_CORE_CLR(x, v) (HW_PMU_REG_CORE_WR(x, HW_PMU_REG_CORE_RD(x) & ~(v)))
#define HW_PMU_REG_CORE_TOG(x, v) (HW_PMU_REG_CORE_WR(x, HW_PMU_REG_CORE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PMU_REG_CORE bitfields
 */

/*!
 * @name Register PMU_REG_CORE, field REG0_TARG[4:0] (RW)
 *
 * This field defines the target voltage for the ARM core power domain.
 * Single-bit increments reflect 25mV core voltage steps. Some steps may not be relevant
 * because of input supply limitations or load operation. This register is
 * capable of programming an over-voltage condition on the device. Consult the
 * datasheet Operating Ranges table for the allowed voltages.
 *
 * Values:
 * - 00000 - Power gated off
 * - 00001 - Target core voltage = 0.725V
 * - 00010 - Target core voltage = 0.750V
 * - 00011 - Target core voltage = 0.775V
 * - 10000 - Target core voltage = 1.100V
 * - 11110 - Target core voltage = 1.450V
 * - 11111 - Power FET switched full on. No regulation.
 */
/*@{*/
#define BP_PMU_REG_CORE_REG0_TARG (0U)     /*!< Bit position for PMU_REG_CORE_REG0_TARG. */
#define BM_PMU_REG_CORE_REG0_TARG (0x0000001FU) /*!< Bit mask for PMU_REG_CORE_REG0_TARG. */
#define BS_PMU_REG_CORE_REG0_TARG (5U)     /*!< Bit field size in bits for PMU_REG_CORE_REG0_TARG. */

/*! @brief Read current value of the PMU_REG_CORE_REG0_TARG field. */
#define BR_PMU_REG_CORE_REG0_TARG(x) (HW_PMU_REG_CORE(x).B.REG0_TARG)

/*! @brief Format value for bitfield PMU_REG_CORE_REG0_TARG. */
#define BF_PMU_REG_CORE_REG0_TARG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_CORE_REG0_TARG) & BM_PMU_REG_CORE_REG0_TARG)

/*! @brief Set the REG0_TARG field to a new value. */
#define BW_PMU_REG_CORE_REG0_TARG(x, v) (HW_PMU_REG_CORE_WR(x, (HW_PMU_REG_CORE_RD(x) & ~BM_PMU_REG_CORE_REG0_TARG) | BF_PMU_REG_CORE_REG0_TARG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_CORE, field REG1_TARG[13:9] (RW)
 *
 * This field defines the target voltage for the VPU/GPU power domain.
 * Single-bit increments reflect 25mV core voltage steps. Some steps may not be relevant
 * because of input supply limitations or load operation. This register is capable
 * of programming an over-voltage condition on the device. Consult the datasheet
 * Operating Ranges table for the allowed voltages.
 *
 * Values:
 * - 00000 - Power gated off
 * - 00001 - Target core voltage = 0.725V
 * - 00010 - Target core voltage = 0.750V
 * - 00011 - Target core voltage = 0.775V
 * - 10000 - Target core voltage = 1.100V
 * - 11110 - Target core voltage = 1.450V
 * - 11111 - Power FET switched full on. No regulation.
 */
/*@{*/
#define BP_PMU_REG_CORE_REG1_TARG (9U)     /*!< Bit position for PMU_REG_CORE_REG1_TARG. */
#define BM_PMU_REG_CORE_REG1_TARG (0x00003E00U) /*!< Bit mask for PMU_REG_CORE_REG1_TARG. */
#define BS_PMU_REG_CORE_REG1_TARG (5U)     /*!< Bit field size in bits for PMU_REG_CORE_REG1_TARG. */

/*! @brief Read current value of the PMU_REG_CORE_REG1_TARG field. */
#define BR_PMU_REG_CORE_REG1_TARG(x) (HW_PMU_REG_CORE(x).B.REG1_TARG)

/*! @brief Format value for bitfield PMU_REG_CORE_REG1_TARG. */
#define BF_PMU_REG_CORE_REG1_TARG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_CORE_REG1_TARG) & BM_PMU_REG_CORE_REG1_TARG)

/*! @brief Set the REG1_TARG field to a new value. */
#define BW_PMU_REG_CORE_REG1_TARG(x, v) (HW_PMU_REG_CORE_WR(x, (HW_PMU_REG_CORE_RD(x) & ~BM_PMU_REG_CORE_REG1_TARG) | BF_PMU_REG_CORE_REG1_TARG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_CORE, field REG2_TARG[22:18] (RW)
 *
 * This field defines the target voltage for the SOC power domain. Single-bit
 * increments reflect 25mV core voltage steps. Some steps may not be relevant
 * because of input supply limitations or load operation. This register is capable of
 * programming an over-voltage condition on the device. Consult the datasheet
 * Operating Ranges table for the allowed voltages.
 *
 * Values:
 * - 00000 - Power gated off
 * - 00001 - Target core voltage = 0.725V
 * - 00010 - Target core voltage = 0.750V
 * - 00011 - Target core voltage = 0.775V
 * - 10000 - Target core voltage = 1.100V
 * - 11110 - Target core voltage = 1.450V
 * - 11111 - Power FET switched full on. No regulation.
 */
/*@{*/
#define BP_PMU_REG_CORE_REG2_TARG (18U)    /*!< Bit position for PMU_REG_CORE_REG2_TARG. */
#define BM_PMU_REG_CORE_REG2_TARG (0x007C0000U) /*!< Bit mask for PMU_REG_CORE_REG2_TARG. */
#define BS_PMU_REG_CORE_REG2_TARG (5U)     /*!< Bit field size in bits for PMU_REG_CORE_REG2_TARG. */

/*! @brief Read current value of the PMU_REG_CORE_REG2_TARG field. */
#define BR_PMU_REG_CORE_REG2_TARG(x) (HW_PMU_REG_CORE(x).B.REG2_TARG)

/*! @brief Format value for bitfield PMU_REG_CORE_REG2_TARG. */
#define BF_PMU_REG_CORE_REG2_TARG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_CORE_REG2_TARG) & BM_PMU_REG_CORE_REG2_TARG)

/*! @brief Set the REG2_TARG field to a new value. */
#define BW_PMU_REG_CORE_REG2_TARG(x, v) (HW_PMU_REG_CORE_WR(x, (HW_PMU_REG_CORE_RD(x) & ~BM_PMU_REG_CORE_REG2_TARG) | BF_PMU_REG_CORE_REG2_TARG(v)))
/*@}*/

/*!
 * @name Register PMU_REG_CORE, field FET_ODRIVE[29] (RW)
 *
 * If set, increases the gate drive on power gating FETs to reduce leakage in
 * the off state. Care must be taken to apply this bit only when the input supply
 * voltage to the power FET is less than 1.1V. This bit should only be used in
 * low-power modes where the external input supply voltage is nominally 0.9V.
 */
/*@{*/
#define BP_PMU_REG_CORE_FET_ODRIVE (29U)   /*!< Bit position for PMU_REG_CORE_FET_ODRIVE. */
#define BM_PMU_REG_CORE_FET_ODRIVE (0x20000000U) /*!< Bit mask for PMU_REG_CORE_FET_ODRIVE. */
#define BS_PMU_REG_CORE_FET_ODRIVE (1U)    /*!< Bit field size in bits for PMU_REG_CORE_FET_ODRIVE. */

/*! @brief Read current value of the PMU_REG_CORE_FET_ODRIVE field. */
#define BR_PMU_REG_CORE_FET_ODRIVE(x) (HW_PMU_REG_CORE(x).B.FET_ODRIVE)

/*! @brief Format value for bitfield PMU_REG_CORE_FET_ODRIVE. */
#define BF_PMU_REG_CORE_FET_ODRIVE(v) ((uint32_t)((uint32_t)(v) << BP_PMU_REG_CORE_FET_ODRIVE) & BM_PMU_REG_CORE_FET_ODRIVE)

/*! @brief Set the FET_ODRIVE field to a new value. */
#define BW_PMU_REG_CORE_FET_ODRIVE(x, v) (HW_PMU_REG_CORE_WR(x, (HW_PMU_REG_CORE_RD(x) & ~BM_PMU_REG_CORE_FET_ODRIVE) | BF_PMU_REG_CORE_FET_ODRIVE(v)))
/*@}*/

/*******************************************************************************
 * HW_PMU_MISC0 - Miscellaneous Register 0
 ******************************************************************************/

/*!
 * @brief HW_PMU_MISC0 - Miscellaneous Register 0 (RW)
 *
 * Reset value: 0x04000000U
 *
 * This register defines the control and status bits for miscellaneous analog
 * blocks.
 */
typedef union _hw_pmu_misc0
{
    uint32_t U;
    struct _hw_pmu_misc0_bitfields
    {
        uint32_t REFTOP_PWD : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t REFTOP_SELFBIASOFF : 1; /*!< [3]  */
        uint32_t REFTOP_VBGADJ : 3;    /*!< [6:4]  */
        uint32_t REFTOP_VBGUP : 1;     /*!< [7]  */
        uint32_t RESERVED1 : 4;        /*!< [11:8]  */
        uint32_t STOP_MODE_CONFIG : 1; /*!< [12]  */
        uint32_t RESERVED2 : 1;        /*!< [13]  */
        uint32_t OSC_I : 2;            /*!< [15:14]  */
        uint32_t OSC_XTALOK : 1;       /*!< [16]  */
        uint32_t OSC_XTALOK_EN : 1;    /*!< [17]  */
        uint32_t WBCP_VPW_THRESH : 2;  /*!< [19:18]  */
        uint32_t RESERVED3 : 5;        /*!< [24:20]  */
        uint32_t CLKGATE_CTRL : 1;     /*!< [25]  */
        uint32_t CLKGATE_DELAY : 3;    /*!< [28:26]  */
        uint32_t RESERVED4 : 3;        /*!< [31:29]  */
    } B;
} hw_pmu_misc0_t;

/*!
 * @name Constants and macros for entire PMU_MISC0 register
 */
/*@{*/
#define HW_PMU_MISC0_ADDR(x)     ((uintptr_t)(x) + 0x150U)

#define HW_PMU_MISC0(x)          (*(__IO hw_pmu_misc0_t *) HW_PMU_MISC0_ADDR(x))
#define HW_PMU_MISC0_RD(x)       (HW_PMU_MISC0(x).U)
#define HW_PMU_MISC0_WR(x, v)    (HW_PMU_MISC0(x).U = (v))
#define HW_PMU_MISC0_SET(x, v)   (HW_PMU_MISC0_WR(x, HW_PMU_MISC0_RD(x) |  (v)))
#define HW_PMU_MISC0_CLR(x, v)   (HW_PMU_MISC0_WR(x, HW_PMU_MISC0_RD(x) & ~(v)))
#define HW_PMU_MISC0_TOG(x, v)   (HW_PMU_MISC0_WR(x, HW_PMU_MISC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PMU_MISC0 bitfields
 */

/*!
 * @name Register PMU_MISC0, field REFTOP_PWD[0] (RW)
 *
 * Control bit to power-down the analog bandgap reference circuitry. A note of
 * caution, the bandgap is necessary for correct operation of most of the LDO,
 * pll, and other analog functions on the die.
 */
/*@{*/
#define BP_PMU_MISC0_REFTOP_PWD (0U)       /*!< Bit position for PMU_MISC0_REFTOP_PWD. */
#define BM_PMU_MISC0_REFTOP_PWD (0x00000001U) /*!< Bit mask for PMU_MISC0_REFTOP_PWD. */
#define BS_PMU_MISC0_REFTOP_PWD (1U)       /*!< Bit field size in bits for PMU_MISC0_REFTOP_PWD. */

/*! @brief Read current value of the PMU_MISC0_REFTOP_PWD field. */
#define BR_PMU_MISC0_REFTOP_PWD(x) (HW_PMU_MISC0(x).B.REFTOP_PWD)

/*! @brief Format value for bitfield PMU_MISC0_REFTOP_PWD. */
#define BF_PMU_MISC0_REFTOP_PWD(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_REFTOP_PWD) & BM_PMU_MISC0_REFTOP_PWD)

/*! @brief Set the REFTOP_PWD field to a new value. */
#define BW_PMU_MISC0_REFTOP_PWD(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_REFTOP_PWD) | BF_PMU_MISC0_REFTOP_PWD(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field REFTOP_SELFBIASOFF[3] (RW)
 *
 * Control bit to disable the self-bias circuit in the analog bandgap. The
 * self-bias circuit is used by the bandgap during startup. This bit should be set
 * after the bandgap has stabilized and is necessary for best noise performance of
 * analog blocks using the outputs of the bandgap. Value should be returned to
 * zero before removing vddhigh_in or asserting bit 0 of this register (REFTOP_PWD)
 * to assure proper restart of the circuit.
 *
 * Values:
 * - 0 - Uses coarse bias currents for startup
 * - 1 - Uses bandgap-based bias currents for best performance.
 */
/*@{*/
#define BP_PMU_MISC0_REFTOP_SELFBIASOFF (3U) /*!< Bit position for PMU_MISC0_REFTOP_SELFBIASOFF. */
#define BM_PMU_MISC0_REFTOP_SELFBIASOFF (0x00000008U) /*!< Bit mask for PMU_MISC0_REFTOP_SELFBIASOFF. */
#define BS_PMU_MISC0_REFTOP_SELFBIASOFF (1U) /*!< Bit field size in bits for PMU_MISC0_REFTOP_SELFBIASOFF. */

/*! @brief Read current value of the PMU_MISC0_REFTOP_SELFBIASOFF field. */
#define BR_PMU_MISC0_REFTOP_SELFBIASOFF(x) (HW_PMU_MISC0(x).B.REFTOP_SELFBIASOFF)

/*! @brief Format value for bitfield PMU_MISC0_REFTOP_SELFBIASOFF. */
#define BF_PMU_MISC0_REFTOP_SELFBIASOFF(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_REFTOP_SELFBIASOFF) & BM_PMU_MISC0_REFTOP_SELFBIASOFF)

/*! @brief Set the REFTOP_SELFBIASOFF field to a new value. */
#define BW_PMU_MISC0_REFTOP_SELFBIASOFF(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_REFTOP_SELFBIASOFF) | BF_PMU_MISC0_REFTOP_SELFBIASOFF(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field REFTOP_VBGADJ[6:4] (RW)
 *
 * Values:
 * - 000 - Nominal VBG
 * - 001 - VBG+0.78%
 * - 010 - VBG+1.56%
 * - 011 - VBG+2.34%
 * - 100 - VBG-0.78%
 * - 101 - VBG-1.56%
 * - 110 - VBG-2.34%
 * - 111 - VBG-3.12%
 */
/*@{*/
#define BP_PMU_MISC0_REFTOP_VBGADJ (4U)    /*!< Bit position for PMU_MISC0_REFTOP_VBGADJ. */
#define BM_PMU_MISC0_REFTOP_VBGADJ (0x00000070U) /*!< Bit mask for PMU_MISC0_REFTOP_VBGADJ. */
#define BS_PMU_MISC0_REFTOP_VBGADJ (3U)    /*!< Bit field size in bits for PMU_MISC0_REFTOP_VBGADJ. */

/*! @brief Read current value of the PMU_MISC0_REFTOP_VBGADJ field. */
#define BR_PMU_MISC0_REFTOP_VBGADJ(x) (HW_PMU_MISC0(x).B.REFTOP_VBGADJ)

/*! @brief Format value for bitfield PMU_MISC0_REFTOP_VBGADJ. */
#define BF_PMU_MISC0_REFTOP_VBGADJ(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_REFTOP_VBGADJ) & BM_PMU_MISC0_REFTOP_VBGADJ)

/*! @brief Set the REFTOP_VBGADJ field to a new value. */
#define BW_PMU_MISC0_REFTOP_VBGADJ(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_REFTOP_VBGADJ) | BF_PMU_MISC0_REFTOP_VBGADJ(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field REFTOP_VBGUP[7] (RW)
 *
 * Status bit that signals the analog bandgap voltage is up and stable. 1 -
 * Stable.
 */
/*@{*/
#define BP_PMU_MISC0_REFTOP_VBGUP (7U)     /*!< Bit position for PMU_MISC0_REFTOP_VBGUP. */
#define BM_PMU_MISC0_REFTOP_VBGUP (0x00000080U) /*!< Bit mask for PMU_MISC0_REFTOP_VBGUP. */
#define BS_PMU_MISC0_REFTOP_VBGUP (1U)     /*!< Bit field size in bits for PMU_MISC0_REFTOP_VBGUP. */

/*! @brief Read current value of the PMU_MISC0_REFTOP_VBGUP field. */
#define BR_PMU_MISC0_REFTOP_VBGUP(x) (HW_PMU_MISC0(x).B.REFTOP_VBGUP)

/*! @brief Format value for bitfield PMU_MISC0_REFTOP_VBGUP. */
#define BF_PMU_MISC0_REFTOP_VBGUP(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_REFTOP_VBGUP) & BM_PMU_MISC0_REFTOP_VBGUP)

/*! @brief Set the REFTOP_VBGUP field to a new value. */
#define BW_PMU_MISC0_REFTOP_VBGUP(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_REFTOP_VBGUP) | BF_PMU_MISC0_REFTOP_VBGUP(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field STOP_MODE_CONFIG[12] (RW)
 *
 * Configure the analog behavior in stop mode.
 *
 * Values:
 * - 0 - Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode
 *     assertion
 * - 1 - Light Stop Mode - 0x1 All the analog domain except the LDO_1P1,
 *     LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can
 *     be configured not to power down the oscillator (XTALOSC). PLL3 can be
 *     disabled with register settings if desired.
 */
/*@{*/
#define BP_PMU_MISC0_STOP_MODE_CONFIG (12U) /*!< Bit position for PMU_MISC0_STOP_MODE_CONFIG. */
#define BM_PMU_MISC0_STOP_MODE_CONFIG (0x00001000U) /*!< Bit mask for PMU_MISC0_STOP_MODE_CONFIG. */
#define BS_PMU_MISC0_STOP_MODE_CONFIG (1U) /*!< Bit field size in bits for PMU_MISC0_STOP_MODE_CONFIG. */

#define BV_PMU_MISC0_STOP_MODE_CONFIG_DEEP (0U)      /*!< Bit field value for PMU_MISC0_STOP_MODE_CONFIG: Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode assertion */
#define BV_PMU_MISC0_STOP_MODE_CONFIG_LIGHT (0x1U)   /*!< Bit field value for PMU_MISC0_STOP_MODE_CONFIG: Light Stop Mode - 0x1 All the analog domain except the LDO_1P1, LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can be configured not to power down the oscillator (XTALOSC). PLL3 can be disabled with register settings if desired. */

/*! @brief Read current value of the PMU_MISC0_STOP_MODE_CONFIG field. */
#define BR_PMU_MISC0_STOP_MODE_CONFIG(x) (HW_PMU_MISC0(x).B.STOP_MODE_CONFIG)

/*! @brief Format value for bitfield PMU_MISC0_STOP_MODE_CONFIG. */
#define BF_PMU_MISC0_STOP_MODE_CONFIG(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_STOP_MODE_CONFIG) & BM_PMU_MISC0_STOP_MODE_CONFIG)

/*! @brief Set the STOP_MODE_CONFIG field to a new value. */
#define BW_PMU_MISC0_STOP_MODE_CONFIG(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_STOP_MODE_CONFIG) | BF_PMU_MISC0_STOP_MODE_CONFIG(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field OSC_I[15:14] (RW)
 *
 * This field determines the bias current in the 24MHz oscillator. The aim is to
 * start up with the highest bias current, which can be decreased after startup
 * if it is determined to be acceptable.Not related to PMU.
 *
 * Values:
 * - 00 - Nominal
 * - 01 - Decrease current by 12.5%
 * - 10 - Decrease current by 25.0%
 * - 11 - Decrease current by 37.5%
 */
/*@{*/
#define BP_PMU_MISC0_OSC_I   (14U)         /*!< Bit position for PMU_MISC0_OSC_I. */
#define BM_PMU_MISC0_OSC_I   (0x0000C000U) /*!< Bit mask for PMU_MISC0_OSC_I. */
#define BS_PMU_MISC0_OSC_I   (2U)          /*!< Bit field size in bits for PMU_MISC0_OSC_I. */

#define BV_PMU_MISC0_OSC_I_NOMINAL     (0U)          /*!< Bit field value for PMU_MISC0_OSC_I: Nominal */
#define BV_PMU_MISC0_OSC_I_MINUS_12_5_PERCENT (0x1U) /*!< Bit field value for PMU_MISC0_OSC_I: Decrease current by 12.5% */
#define BV_PMU_MISC0_OSC_I_MINUS_25_PERCENT (0x2U)   /*!< Bit field value for PMU_MISC0_OSC_I: Decrease current by 25.0% */
#define BV_PMU_MISC0_OSC_I_MINUS_37_5_PERCENT (0x3U) /*!< Bit field value for PMU_MISC0_OSC_I: Decrease current by 37.5% */

/*! @brief Read current value of the PMU_MISC0_OSC_I field. */
#define BR_PMU_MISC0_OSC_I(x) (HW_PMU_MISC0(x).B.OSC_I)

/*! @brief Format value for bitfield PMU_MISC0_OSC_I. */
#define BF_PMU_MISC0_OSC_I(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_OSC_I) & BM_PMU_MISC0_OSC_I)

/*! @brief Set the OSC_I field to a new value. */
#define BW_PMU_MISC0_OSC_I(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_OSC_I) | BF_PMU_MISC0_OSC_I(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field OSC_XTALOK[16] (RO)
 *
 * Status bit that signals that the output of the 24-MHz crystal oscillator is
 * stable. Generated from a timer and active detection of the actual frequency.Not
 * related to PMU, clocking content.
 */
/*@{*/
#define BP_PMU_MISC0_OSC_XTALOK (16U)      /*!< Bit position for PMU_MISC0_OSC_XTALOK. */
#define BM_PMU_MISC0_OSC_XTALOK (0x00010000U) /*!< Bit mask for PMU_MISC0_OSC_XTALOK. */
#define BS_PMU_MISC0_OSC_XTALOK (1U)       /*!< Bit field size in bits for PMU_MISC0_OSC_XTALOK. */

/*! @brief Read current value of the PMU_MISC0_OSC_XTALOK field. */
#define BR_PMU_MISC0_OSC_XTALOK(x) (HW_PMU_MISC0(x).B.OSC_XTALOK)
/*@}*/

/*!
 * @name Register PMU_MISC0, field OSC_XTALOK_EN[17] (RW)
 *
 * This bit enables the detector that signals when the 24MHz crystal oscillator
 * is stable. Not related to PMU, Clocking content
 */
/*@{*/
#define BP_PMU_MISC0_OSC_XTALOK_EN (17U)   /*!< Bit position for PMU_MISC0_OSC_XTALOK_EN. */
#define BM_PMU_MISC0_OSC_XTALOK_EN (0x00020000U) /*!< Bit mask for PMU_MISC0_OSC_XTALOK_EN. */
#define BS_PMU_MISC0_OSC_XTALOK_EN (1U)    /*!< Bit field size in bits for PMU_MISC0_OSC_XTALOK_EN. */

/*! @brief Read current value of the PMU_MISC0_OSC_XTALOK_EN field. */
#define BR_PMU_MISC0_OSC_XTALOK_EN(x) (HW_PMU_MISC0(x).B.OSC_XTALOK_EN)

/*! @brief Format value for bitfield PMU_MISC0_OSC_XTALOK_EN. */
#define BF_PMU_MISC0_OSC_XTALOK_EN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_OSC_XTALOK_EN) & BM_PMU_MISC0_OSC_XTALOK_EN)

/*! @brief Set the OSC_XTALOK_EN field to a new value. */
#define BW_PMU_MISC0_OSC_XTALOK_EN(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_OSC_XTALOK_EN) | BF_PMU_MISC0_OSC_XTALOK_EN(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field WBCP_VPW_THRESH[19:18] (RW)
 *
 * This signal alters the voltage that the pwell is charged pumped to.
 *
 * Values:
 * - 00 - Nominal output pwell bias voltage.
 * - 01 - Increase pwell output voltage by 25mV.
 * - 10 - Decrease pwell output pwell voltage by 25mV.
 * - 11 - Decrease pwell output pwell voltage by 50mV.
 */
/*@{*/
#define BP_PMU_MISC0_WBCP_VPW_THRESH (18U) /*!< Bit position for PMU_MISC0_WBCP_VPW_THRESH. */
#define BM_PMU_MISC0_WBCP_VPW_THRESH (0x000C0000U) /*!< Bit mask for PMU_MISC0_WBCP_VPW_THRESH. */
#define BS_PMU_MISC0_WBCP_VPW_THRESH (2U)  /*!< Bit field size in bits for PMU_MISC0_WBCP_VPW_THRESH. */

#define BV_PMU_MISC0_WBCP_VPW_THRESH_NOMINAL_BIAS (0U) /*!< Bit field value for PMU_MISC0_WBCP_VPW_THRESH: Nominal output pwell bias voltage. */
#define BV_PMU_MISC0_WBCP_VPW_THRESH_PLUS_25MV (0x1U) /*!< Bit field value for PMU_MISC0_WBCP_VPW_THRESH: Increase pwell output voltage by 25mV. */
#define BV_PMU_MISC0_WBCP_VPW_THRESH_MINUS_25MV (0x2U) /*!< Bit field value for PMU_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 25mV. */
#define BV_PMU_MISC0_WBCP_VPW_THRESH_MINUS_50MV (0x3U) /*!< Bit field value for PMU_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 50mV. */

/*! @brief Read current value of the PMU_MISC0_WBCP_VPW_THRESH field. */
#define BR_PMU_MISC0_WBCP_VPW_THRESH(x) (HW_PMU_MISC0(x).B.WBCP_VPW_THRESH)

/*! @brief Format value for bitfield PMU_MISC0_WBCP_VPW_THRESH. */
#define BF_PMU_MISC0_WBCP_VPW_THRESH(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_WBCP_VPW_THRESH) & BM_PMU_MISC0_WBCP_VPW_THRESH)

/*! @brief Set the WBCP_VPW_THRESH field to a new value. */
#define BW_PMU_MISC0_WBCP_VPW_THRESH(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_WBCP_VPW_THRESH) | BF_PMU_MISC0_WBCP_VPW_THRESH(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field CLKGATE_CTRL[25] (RW)
 *
 * This bit allows disabling the clock gate (always ungated) for the xtal 24MHz
 * clock that clocks the digital logic in the analog block. Do not change the
 * field during a low power event. This is not a field that the user would normally
 * need to modify. Not related to PMU.
 *
 * Values:
 * - 0 - Allow the logic to automatically gate the clock when the XTAL is
 *     powered down.
 * - 1 - Prevent the logic from ever gating off the clock.
 */
/*@{*/
#define BP_PMU_MISC0_CLKGATE_CTRL (25U)    /*!< Bit position for PMU_MISC0_CLKGATE_CTRL. */
#define BM_PMU_MISC0_CLKGATE_CTRL (0x02000000U) /*!< Bit mask for PMU_MISC0_CLKGATE_CTRL. */
#define BS_PMU_MISC0_CLKGATE_CTRL (1U)     /*!< Bit field size in bits for PMU_MISC0_CLKGATE_CTRL. */

#define BV_PMU_MISC0_CLKGATE_CTRL_ALLOW_AUTO_GATE (0U) /*!< Bit field value for PMU_MISC0_CLKGATE_CTRL: Allow the logic to automatically gate the clock when the XTAL is powered down. */
#define BV_PMU_MISC0_CLKGATE_CTRL_NO_AUTO_GATE (0x1U) /*!< Bit field value for PMU_MISC0_CLKGATE_CTRL: Prevent the logic from ever gating off the clock. */

/*! @brief Read current value of the PMU_MISC0_CLKGATE_CTRL field. */
#define BR_PMU_MISC0_CLKGATE_CTRL(x) (HW_PMU_MISC0(x).B.CLKGATE_CTRL)

/*! @brief Format value for bitfield PMU_MISC0_CLKGATE_CTRL. */
#define BF_PMU_MISC0_CLKGATE_CTRL(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_CLKGATE_CTRL) & BM_PMU_MISC0_CLKGATE_CTRL)

/*! @brief Set the CLKGATE_CTRL field to a new value. */
#define BW_PMU_MISC0_CLKGATE_CTRL(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_CLKGATE_CTRL) | BF_PMU_MISC0_CLKGATE_CTRL(v)))
/*@}*/

/*!
 * @name Register PMU_MISC0, field CLKGATE_DELAY[28:26] (RW)
 *
 * This field specifies the delay between powering up the XTAL 24MHz clock and
 * releasing the clock to the digital logic inside the analog block. Do not change
 * the field during a low power event. This is not a field that the user would
 * normally need to modify. Not related to PMU.
 *
 * Values:
 * - 000 - 0.5ms
 * - 001 - 1.0ms
 * - 010 - 2.0ms
 * - 011 - 3.0ms
 * - 100 - 4.0ms
 * - 101 - 5.0ms
 * - 110 - 6.0ms
 * - 111 - 7.0ms
 */
/*@{*/
#define BP_PMU_MISC0_CLKGATE_DELAY (26U)   /*!< Bit position for PMU_MISC0_CLKGATE_DELAY. */
#define BM_PMU_MISC0_CLKGATE_DELAY (0x1C000000U) /*!< Bit mask for PMU_MISC0_CLKGATE_DELAY. */
#define BS_PMU_MISC0_CLKGATE_DELAY (3U)    /*!< Bit field size in bits for PMU_MISC0_CLKGATE_DELAY. */

/*! @brief Read current value of the PMU_MISC0_CLKGATE_DELAY field. */
#define BR_PMU_MISC0_CLKGATE_DELAY(x) (HW_PMU_MISC0(x).B.CLKGATE_DELAY)

/*! @brief Format value for bitfield PMU_MISC0_CLKGATE_DELAY. */
#define BF_PMU_MISC0_CLKGATE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC0_CLKGATE_DELAY) & BM_PMU_MISC0_CLKGATE_DELAY)

/*! @brief Set the CLKGATE_DELAY field to a new value. */
#define BW_PMU_MISC0_CLKGATE_DELAY(x, v) (HW_PMU_MISC0_WR(x, (HW_PMU_MISC0_RD(x) & ~BM_PMU_MISC0_CLKGATE_DELAY) | BF_PMU_MISC0_CLKGATE_DELAY(v)))
/*@}*/

/*******************************************************************************
 * HW_PMU_MISC1 - Miscellaneous Register 1
 ******************************************************************************/

/*!
 * @brief HW_PMU_MISC1 - Miscellaneous Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines the control and status bits for miscellaneous analog
 * blocks. The LVDS1 and LVDS2 controls below control the behavior of the
 * anaclk1/1b and anaclk2/2b LVDS IO's.
 */
typedef union _hw_pmu_misc1
{
    uint32_t U;
    struct _hw_pmu_misc1_bitfields
    {
        uint32_t LVDS1_CLK_SEL : 5;    /*!< [4:0]  */
        uint32_t LVDS2_CLK_SEL : 5;    /*!< [9:5]  */
        uint32_t LVDSCLK1_OBEN : 1;    /*!< [10]  */
        uint32_t LVDSCLK2_OBEN : 1;    /*!< [11]  */
        uint32_t LVDSCLK1_IBEN : 1;    /*!< [12]  */
        uint32_t LVDSCLK2_IBEN : 1;    /*!< [13]  */
        uint32_t RESERVED0 : 15;       /*!< [28:14]  */
        uint32_t IRQ_TEMPSENSE : 1;    /*!< [29]  */
        uint32_t IRQ_ANA_BO : 1;       /*!< [30]  */
        uint32_t IRQ_DIG_BO : 1;       /*!< [31]  */
    } B;
} hw_pmu_misc1_t;

/*!
 * @name Constants and macros for entire PMU_MISC1 register
 */
/*@{*/
#define HW_PMU_MISC1_ADDR(x)     ((uintptr_t)(x) + 0x160U)
#define HW_PMU_MISC1_SET_ADDR(x) (HW_PMU_MISC1_ADDR(x) + 0x4U)
#define HW_PMU_MISC1_CLR_ADDR(x) (HW_PMU_MISC1_ADDR(x) + 0x8U)
#define HW_PMU_MISC1_TOG_ADDR(x) (HW_PMU_MISC1_ADDR(x) + 0xCU)

#define HW_PMU_MISC1(x)          (*(__IO hw_pmu_misc1_t *) HW_PMU_MISC1_ADDR(x))
#define HW_PMU_MISC1_RD(x)       (HW_PMU_MISC1(x).U)
#define HW_PMU_MISC1_WR(x, v)    (HW_PMU_MISC1(x).U = (v))
#define HW_PMU_MISC1_SET(x, v)   ((*(uint32_t *) HW_PMU_MISC1_SET_ADDR(x)) = (v))
#define HW_PMU_MISC1_CLR(x, v)   ((*(uint32_t *) HW_PMU_MISC1_CLR_ADDR(x)) = (v))
#define HW_PMU_MISC1_TOG(x, v)   ((*(uint32_t *) HW_PMU_MISC1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual PMU_MISC1 bitfields
 */

/*!
 * @name Register PMU_MISC1, field LVDS1_CLK_SEL[4:0] (RW)
 *
 * This field selects the clk to be routed to anaclk1/1b.Not related to PMU.
 *
 * Values:
 * - 00000 - Arm PLL
 * - 00001 - System PLL
 * - 00010 - ref_pfd4_clk == pll2_pfd0_clk
 * - 00011 - ref_pfd5_clk == pll2_pfd1_clk
 * - 00100 - ref_pfd6_clk == pll2_pfd2_clk
 * - 00101 - ref_pfd7_clk == pll2_pfd3_clk
 * - 00110 - Audio PLL
 * - 00111 - Video PLL
 * - 01000 - MLB PLL
 * - 01001 - ethernet ref clock (ENET_PLL)
 * - 01010 - PCIe ref clock (125M)
 * - 01011 - SATA ref clock (100M)
 * - 01100 - USB1 PLL clock
 * - 01101 - USB2 PLL clock
 * - 01110 - ref_pfd0_clk == pll3_pfd0_clk
 * - 01111 - ref_pfd1_clk == pll3_pfd1_clk
 * - 10000 - ref_pfd2_clk == pll3_pfd2_clk
 * - 10001 - ref_pfd3_clk == pll3_pfd3_clk
 * - 10010 - xtal (24M)
 * - 10011 - LVDS1 (loopback)
 * - 10100 - LVDS2 (not useful)
 */
/*@{*/
#define BP_PMU_MISC1_LVDS1_CLK_SEL (0U)    /*!< Bit position for PMU_MISC1_LVDS1_CLK_SEL. */
#define BM_PMU_MISC1_LVDS1_CLK_SEL (0x0000001FU) /*!< Bit mask for PMU_MISC1_LVDS1_CLK_SEL. */
#define BS_PMU_MISC1_LVDS1_CLK_SEL (5U)    /*!< Bit field size in bits for PMU_MISC1_LVDS1_CLK_SEL. */

#define BV_PMU_MISC1_LVDS1_CLK_SEL_ARM_PLL (0U)      /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: Arm PLL */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_SYS_PLL (0x1U)    /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: System PLL */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD4 (0x2U)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd4_clk == pll2_pfd0_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD5 (0x3U)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd5_clk == pll2_pfd1_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD6 (0x4U)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd6_clk == pll2_pfd2_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD7 (0x5U)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd7_clk == pll2_pfd3_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_AUDIO_PLL (0x6U)  /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: Audio PLL */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_VIDEO_PLL (0x7U)  /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: Video PLL */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_MLB_PLL (0x8U)    /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: MLB PLL */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_ETHERNET_REF (0x9U) /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ethernet ref clock (ENET_PLL) */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PCIE_REF (0xAU)   /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: PCIe ref clock (125M) */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_SATA_REF (0xBU)   /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: SATA ref clock (100M) */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_USB1_PLL (0xCU)   /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: USB1 PLL clock */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_USB2_PLL (0xDU)   /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: USB2 PLL clock */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD0 (0xEU)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd0_clk == pll3_pfd0_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD1 (0xFU)       /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd1_clk == pll3_pfd1_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD2 (0x10U)      /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd2_clk == pll3_pfd2_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_PFD3 (0x11U)      /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: ref_pfd3_clk == pll3_pfd3_clk */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_XTAL (0x12U)      /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: xtal (24M) */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_LVDS1 (0x13U)     /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: LVDS1 (loopback) */
#define BV_PMU_MISC1_LVDS1_CLK_SEL_LVDS2 (0x14U)     /*!< Bit field value for PMU_MISC1_LVDS1_CLK_SEL: LVDS2 (not useful) */

/*! @brief Read current value of the PMU_MISC1_LVDS1_CLK_SEL field. */
#define BR_PMU_MISC1_LVDS1_CLK_SEL(x) (HW_PMU_MISC1(x).B.LVDS1_CLK_SEL)

/*! @brief Format value for bitfield PMU_MISC1_LVDS1_CLK_SEL. */
#define BF_PMU_MISC1_LVDS1_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDS1_CLK_SEL) & BM_PMU_MISC1_LVDS1_CLK_SEL)

/*! @brief Set the LVDS1_CLK_SEL field to a new value. */
#define BW_PMU_MISC1_LVDS1_CLK_SEL(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDS1_CLK_SEL | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDS1_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field LVDS2_CLK_SEL[9:5] (RW)
 *
 * This field selects the clk to be routed to anaclk2/2b.Not related to PMU.
 *
 * Values:
 * - 00000 - Arm PLL
 * - 00001 - System PLL
 * - 00010 - ref_pfd4_clk == pll2_pfd0_clk
 * - 00011 - ref_pfd5_clk == pll2_pfd1_clk
 * - 00100 - ref_pfd6_clk == pll2_pfd2_clk
 * - 00101 - ref_pfd7_clk == pll2_pfd3_clk
 * - 00110 - Audio PLL
 * - 00111 - Video PLL
 * - 01000 - MLB PLL
 * - 01001 - ethernet ref clock (ENET_PLL)
 * - 01010 - PCIe ref clock (125M)
 * - 01011 - SATA ref clock (100M)
 * - 01100 - USB1 PLL clock
 * - 01101 - USB2 PLL clock
 * - 01110 - ref_pfd0_clk == pll3_pfd0_clk
 * - 01111 - ref_pfd1_clk == pll3_pfd1_clk
 * - 10000 - ref_pfd2_clk == pll3_pfd2_clk
 * - 10001 - ref_pfd3_clk == pll3_pfd3_clk
 * - 10010 - xtal (24M)
 * - 10011 - LVDS1 (loopback)
 * - 10100 - LVDS2 (not useful)
 */
/*@{*/
#define BP_PMU_MISC1_LVDS2_CLK_SEL (5U)    /*!< Bit position for PMU_MISC1_LVDS2_CLK_SEL. */
#define BM_PMU_MISC1_LVDS2_CLK_SEL (0x000003E0U) /*!< Bit mask for PMU_MISC1_LVDS2_CLK_SEL. */
#define BS_PMU_MISC1_LVDS2_CLK_SEL (5U)    /*!< Bit field size in bits for PMU_MISC1_LVDS2_CLK_SEL. */

#define BV_PMU_MISC1_LVDS2_CLK_SEL_ARM_PLL (0U)      /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: Arm PLL */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_SYS_PLL (0x1U)    /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: System PLL */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD4 (0x2U)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd4_clk == pll2_pfd0_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD5 (0x3U)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd5_clk == pll2_pfd1_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD6 (0x4U)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd6_clk == pll2_pfd2_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD7 (0x5U)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd7_clk == pll2_pfd3_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_AUDIO_PLL (0x6U)  /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: Audio PLL */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_VIDEO_PLL (0x7U)  /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: Video PLL */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_MLB_PLL (0x8U)    /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: MLB PLL */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_ETHERNET_REF (0x9U) /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ethernet ref clock (ENET_PLL) */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PCIE_REF (0xAU)   /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: PCIe ref clock (125M) */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_SATA_REF (0xBU)   /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: SATA ref clock (100M) */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_USB1_PLL (0xCU)   /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: USB1 PLL clock */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_USB2_PLL (0xDU)   /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: USB2 PLL clock */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD0 (0xEU)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd0_clk == pll3_pfd0_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD1 (0xFU)       /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd1_clk == pll3_pfd1_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD2 (0x10U)      /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd2_clk == pll3_pfd2_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_PFD3 (0x11U)      /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: ref_pfd3_clk == pll3_pfd3_clk */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_XTAL (0x12U)      /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: xtal (24M) */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_LVDS1 (0x13U)     /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: LVDS1 (loopback) */
#define BV_PMU_MISC1_LVDS2_CLK_SEL_LVDS2 (0x14U)     /*!< Bit field value for PMU_MISC1_LVDS2_CLK_SEL: LVDS2 (not useful) */

/*! @brief Read current value of the PMU_MISC1_LVDS2_CLK_SEL field. */
#define BR_PMU_MISC1_LVDS2_CLK_SEL(x) (HW_PMU_MISC1(x).B.LVDS2_CLK_SEL)

/*! @brief Format value for bitfield PMU_MISC1_LVDS2_CLK_SEL. */
#define BF_PMU_MISC1_LVDS2_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDS2_CLK_SEL) & BM_PMU_MISC1_LVDS2_CLK_SEL)

/*! @brief Set the LVDS2_CLK_SEL field to a new value. */
#define BW_PMU_MISC1_LVDS2_CLK_SEL(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDS2_CLK_SEL | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDS2_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field LVDSCLK1_OBEN[10] (RW)
 *
 * This enables the LVDS output buffer for anaclk1/1b. Do not enable input and
 * output buffers simultaneously.Not related to PMU, clocking content.
 */
/*@{*/
#define BP_PMU_MISC1_LVDSCLK1_OBEN (10U)   /*!< Bit position for PMU_MISC1_LVDSCLK1_OBEN. */
#define BM_PMU_MISC1_LVDSCLK1_OBEN (0x00000400U) /*!< Bit mask for PMU_MISC1_LVDSCLK1_OBEN. */
#define BS_PMU_MISC1_LVDSCLK1_OBEN (1U)    /*!< Bit field size in bits for PMU_MISC1_LVDSCLK1_OBEN. */

/*! @brief Read current value of the PMU_MISC1_LVDSCLK1_OBEN field. */
#define BR_PMU_MISC1_LVDSCLK1_OBEN(x) (HW_PMU_MISC1(x).B.LVDSCLK1_OBEN)

/*! @brief Format value for bitfield PMU_MISC1_LVDSCLK1_OBEN. */
#define BF_PMU_MISC1_LVDSCLK1_OBEN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDSCLK1_OBEN) & BM_PMU_MISC1_LVDSCLK1_OBEN)

/*! @brief Set the LVDSCLK1_OBEN field to a new value. */
#define BW_PMU_MISC1_LVDSCLK1_OBEN(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDSCLK1_OBEN | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDSCLK1_OBEN(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field LVDSCLK2_OBEN[11] (RW)
 *
 * This enables the LVDS output buffer for anaclk2/2b. Do not enable input and
 * output buffers simultaneously.Not related to PMU.
 */
/*@{*/
#define BP_PMU_MISC1_LVDSCLK2_OBEN (11U)   /*!< Bit position for PMU_MISC1_LVDSCLK2_OBEN. */
#define BM_PMU_MISC1_LVDSCLK2_OBEN (0x00000800U) /*!< Bit mask for PMU_MISC1_LVDSCLK2_OBEN. */
#define BS_PMU_MISC1_LVDSCLK2_OBEN (1U)    /*!< Bit field size in bits for PMU_MISC1_LVDSCLK2_OBEN. */

/*! @brief Read current value of the PMU_MISC1_LVDSCLK2_OBEN field. */
#define BR_PMU_MISC1_LVDSCLK2_OBEN(x) (HW_PMU_MISC1(x).B.LVDSCLK2_OBEN)

/*! @brief Format value for bitfield PMU_MISC1_LVDSCLK2_OBEN. */
#define BF_PMU_MISC1_LVDSCLK2_OBEN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDSCLK2_OBEN) & BM_PMU_MISC1_LVDSCLK2_OBEN)

/*! @brief Set the LVDSCLK2_OBEN field to a new value. */
#define BW_PMU_MISC1_LVDSCLK2_OBEN(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDSCLK2_OBEN | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDSCLK2_OBEN(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field LVDSCLK1_IBEN[12] (RW)
 *
 * This enables the LVDS input buffer for anaclk1/1b. Do not enable input and
 * output buffers simultaneously.Not related to PMU, Clocking content.
 */
/*@{*/
#define BP_PMU_MISC1_LVDSCLK1_IBEN (12U)   /*!< Bit position for PMU_MISC1_LVDSCLK1_IBEN. */
#define BM_PMU_MISC1_LVDSCLK1_IBEN (0x00001000U) /*!< Bit mask for PMU_MISC1_LVDSCLK1_IBEN. */
#define BS_PMU_MISC1_LVDSCLK1_IBEN (1U)    /*!< Bit field size in bits for PMU_MISC1_LVDSCLK1_IBEN. */

/*! @brief Read current value of the PMU_MISC1_LVDSCLK1_IBEN field. */
#define BR_PMU_MISC1_LVDSCLK1_IBEN(x) (HW_PMU_MISC1(x).B.LVDSCLK1_IBEN)

/*! @brief Format value for bitfield PMU_MISC1_LVDSCLK1_IBEN. */
#define BF_PMU_MISC1_LVDSCLK1_IBEN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDSCLK1_IBEN) & BM_PMU_MISC1_LVDSCLK1_IBEN)

/*! @brief Set the LVDSCLK1_IBEN field to a new value. */
#define BW_PMU_MISC1_LVDSCLK1_IBEN(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDSCLK1_IBEN | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDSCLK1_IBEN(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field LVDSCLK2_IBEN[13] (RW)
 *
 * This enables the LVDS input buffer for anaclk2/2b. Do not enable input and
 * output buffers simultaneously.Not related to PMU.
 */
/*@{*/
#define BP_PMU_MISC1_LVDSCLK2_IBEN (13U)   /*!< Bit position for PMU_MISC1_LVDSCLK2_IBEN. */
#define BM_PMU_MISC1_LVDSCLK2_IBEN (0x00002000U) /*!< Bit mask for PMU_MISC1_LVDSCLK2_IBEN. */
#define BS_PMU_MISC1_LVDSCLK2_IBEN (1U)    /*!< Bit field size in bits for PMU_MISC1_LVDSCLK2_IBEN. */

/*! @brief Read current value of the PMU_MISC1_LVDSCLK2_IBEN field. */
#define BR_PMU_MISC1_LVDSCLK2_IBEN(x) (HW_PMU_MISC1(x).B.LVDSCLK2_IBEN)

/*! @brief Format value for bitfield PMU_MISC1_LVDSCLK2_IBEN. */
#define BF_PMU_MISC1_LVDSCLK2_IBEN(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_LVDSCLK2_IBEN) & BM_PMU_MISC1_LVDSCLK2_IBEN)

/*! @brief Set the LVDSCLK2_IBEN field to a new value. */
#define BW_PMU_MISC1_LVDSCLK2_IBEN(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_LVDSCLK2_IBEN | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_LVDSCLK2_IBEN(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field IRQ_TEMPSENSE[29] (W1C)
 *
 * This status bit is set to one when when the temperature sensor interrupt
 * asserts. Not related to PMU, Temperature Monitor content.
 */
/*@{*/
#define BP_PMU_MISC1_IRQ_TEMPSENSE (29U)   /*!< Bit position for PMU_MISC1_IRQ_TEMPSENSE. */
#define BM_PMU_MISC1_IRQ_TEMPSENSE (0x20000000U) /*!< Bit mask for PMU_MISC1_IRQ_TEMPSENSE. */
#define BS_PMU_MISC1_IRQ_TEMPSENSE (1U)    /*!< Bit field size in bits for PMU_MISC1_IRQ_TEMPSENSE. */

/*! @brief Read current value of the PMU_MISC1_IRQ_TEMPSENSE field. */
#define BR_PMU_MISC1_IRQ_TEMPSENSE(x) (HW_PMU_MISC1(x).B.IRQ_TEMPSENSE)

/*! @brief Format value for bitfield PMU_MISC1_IRQ_TEMPSENSE. */
#define BF_PMU_MISC1_IRQ_TEMPSENSE(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_IRQ_TEMPSENSE) & BM_PMU_MISC1_IRQ_TEMPSENSE)

/*! @brief Set the IRQ_TEMPSENSE field to a new value. */
#define BW_PMU_MISC1_IRQ_TEMPSENSE(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_IRQ_TEMPSENSE(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field IRQ_ANA_BO[30] (W1C)
 *
 * This status bit is set to one when when any of the analog regulator brownout
 * interrupts assert. Check the regulator status bits to discover which regulator
 * interrupt asserted.
 */
/*@{*/
#define BP_PMU_MISC1_IRQ_ANA_BO (30U)      /*!< Bit position for PMU_MISC1_IRQ_ANA_BO. */
#define BM_PMU_MISC1_IRQ_ANA_BO (0x40000000U) /*!< Bit mask for PMU_MISC1_IRQ_ANA_BO. */
#define BS_PMU_MISC1_IRQ_ANA_BO (1U)       /*!< Bit field size in bits for PMU_MISC1_IRQ_ANA_BO. */

/*! @brief Read current value of the PMU_MISC1_IRQ_ANA_BO field. */
#define BR_PMU_MISC1_IRQ_ANA_BO(x) (HW_PMU_MISC1(x).B.IRQ_ANA_BO)

/*! @brief Format value for bitfield PMU_MISC1_IRQ_ANA_BO. */
#define BF_PMU_MISC1_IRQ_ANA_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_IRQ_ANA_BO) & BM_PMU_MISC1_IRQ_ANA_BO)

/*! @brief Set the IRQ_ANA_BO field to a new value. */
#define BW_PMU_MISC1_IRQ_ANA_BO(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_IRQ_ANA_BO | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_DIG_BO)) | BF_PMU_MISC1_IRQ_ANA_BO(v)))
/*@}*/

/*!
 * @name Register PMU_MISC1, field IRQ_DIG_BO[31] (W1C)
 *
 * This status bit is set to one when when any of the digital regulator brownout
 * interrupts assert. Check the regulator status bits to discover which
 * regulator interrupt asserted.
 */
/*@{*/
#define BP_PMU_MISC1_IRQ_DIG_BO (31U)      /*!< Bit position for PMU_MISC1_IRQ_DIG_BO. */
#define BM_PMU_MISC1_IRQ_DIG_BO (0x80000000U) /*!< Bit mask for PMU_MISC1_IRQ_DIG_BO. */
#define BS_PMU_MISC1_IRQ_DIG_BO (1U)       /*!< Bit field size in bits for PMU_MISC1_IRQ_DIG_BO. */

/*! @brief Read current value of the PMU_MISC1_IRQ_DIG_BO field. */
#define BR_PMU_MISC1_IRQ_DIG_BO(x) (HW_PMU_MISC1(x).B.IRQ_DIG_BO)

/*! @brief Format value for bitfield PMU_MISC1_IRQ_DIG_BO. */
#define BF_PMU_MISC1_IRQ_DIG_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC1_IRQ_DIG_BO) & BM_PMU_MISC1_IRQ_DIG_BO)

/*! @brief Set the IRQ_DIG_BO field to a new value. */
#define BW_PMU_MISC1_IRQ_DIG_BO(x, v) (HW_PMU_MISC1_WR(x, (HW_PMU_MISC1_RD(x) & ~(BM_PMU_MISC1_IRQ_DIG_BO | BM_PMU_MISC1_IRQ_TEMPSENSE | BM_PMU_MISC1_IRQ_ANA_BO)) | BF_PMU_MISC1_IRQ_DIG_BO(v)))
/*@}*/




/*******************************************************************************
 * HW_PMU_MISC2 - Miscellaneous Control Register
 ******************************************************************************/

/*!
 * @brief HW_PMU_MISC2 - Miscellaneous Control Register (RW)
 *
 * Reset value: 0x00272727U
 *
 * This register defines the control for miscellaneous PMU Analog blocks. This
 * register is shared with CCM.
 */
typedef union _hw_pmu_misc2
{
    uint32_t U;
    struct _hw_pmu_misc2_bitfields
    {
        uint32_t REG0_BO_OFFSET : 3;   /*!< [2:0]  */
        uint32_t REG0_BO_STATUS : 1;   /*!< [3]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t REG0_ENABLE_BO : 1;   /*!< [5]  */
        uint32_t RESERVED1 : 1;        /*!< [6]  */
        uint32_t PLL3_disable : 1;     /*!< [7]  */
        uint32_t REG1_BO_OFFSET : 3;   /*!< [10:8]  */
        uint32_t REG1_BO_STATUS : 1;   /*!< [11]  */
        uint32_t RESERVED2 : 1;        /*!< [12]  */
        uint32_t REG1_ENABLE_BO : 1;   /*!< [13]  */
        uint32_t RESERVED3 : 1;        /*!< [14]  */
        uint32_t AUDIO_DIV_LSB : 1;    /*!< [15]  */
        uint32_t REG2_BO_OFFSET : 3;   /*!< [18:16]  */
        uint32_t REG2_BO_STATUS : 1;   /*!< [19]  */
        uint32_t RESERVED4 : 1;        /*!< [20]  */
        uint32_t REG2_ENABLE_BO : 1;   /*!< [21]  */
        uint32_t REG2_OK : 1;          /*!< [22]  */
        uint32_t AUDIO_DIV_MSB : 1;    /*!< [23]  */
        uint32_t REG0_STEP_TIME : 2;   /*!< [25:24]  */
        uint32_t REG1_STEP_TIME : 2;   /*!< [27:26]  */
        uint32_t REG2_STEP_TIME : 2;   /*!< [29:28]  */
        uint32_t VIDEO_DIV : 2;        /*!< [31:30]  */
    } B;
} hw_pmu_misc2_t;

/*!
 * @name Constants and macros for entire PMU_MISC2 register
 */
/*@{*/
#define HW_PMU_MISC2_ADDR(x)     ((uintptr_t)(x) + 0x170U)
#define HW_PMU_MISC2_SET_ADDR(x) (HW_PMU_MISC2_ADDR(x) + 0x4U)
#define HW_PMU_MISC2_CLR_ADDR(x) (HW_PMU_MISC2_ADDR(x) + 0x8U)
#define HW_PMU_MISC2_TOG_ADDR(x) (HW_PMU_MISC2_ADDR(x) + 0xCU)

#define HW_PMU_MISC2(x)          (*(__IO hw_pmu_misc2_t *) HW_PMU_MISC2_ADDR(x))
#define HW_PMU_MISC2_RD(x)       (HW_PMU_MISC2(x).U)
#define HW_PMU_MISC2_WR(x, v)    (HW_PMU_MISC2(x).U = (v))
#define HW_PMU_MISC2_SET(x, v)   ((*(uint32_t *) HW_PMU_MISC2_SET_ADDR(x)) = (v))
#define HW_PMU_MISC2_CLR(x, v)   ((*(uint32_t *) HW_PMU_MISC2_CLR_ADDR(x)) = (v))
#define HW_PMU_MISC2_TOG(x, v)   ((*(uint32_t *) HW_PMU_MISC2_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual PMU_MISC2 bitfields
 */

/*!
 * @name Register PMU_MISC2, field REG0_BO_OFFSET[2:0] (RO)
 *
 * This field defines the brown out voltage offset for the CORE power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. Some steps may be irrelevant because of input supply limitations or
 * load operation.
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_PMU_MISC2_REG0_BO_OFFSET (0U)   /*!< Bit position for PMU_MISC2_REG0_BO_OFFSET. */
#define BM_PMU_MISC2_REG0_BO_OFFSET (0x00000007U) /*!< Bit mask for PMU_MISC2_REG0_BO_OFFSET. */
#define BS_PMU_MISC2_REG0_BO_OFFSET (3U)   /*!< Bit field size in bits for PMU_MISC2_REG0_BO_OFFSET. */

/*! @brief Read current value of the PMU_MISC2_REG0_BO_OFFSET field. */
#define BR_PMU_MISC2_REG0_BO_OFFSET(x) (HW_PMU_MISC2(x).B.REG0_BO_OFFSET)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG0_BO_STATUS[3] (RO)
 *
 * Reg0 brownout status bit.
 *
 * Values:
 * - 1 - Brownout, supply is below target minus brownout offset.
 */
/*@{*/
#define BP_PMU_MISC2_REG0_BO_STATUS (3U)   /*!< Bit position for PMU_MISC2_REG0_BO_STATUS. */
#define BM_PMU_MISC2_REG0_BO_STATUS (0x00000008U) /*!< Bit mask for PMU_MISC2_REG0_BO_STATUS. */
#define BS_PMU_MISC2_REG0_BO_STATUS (1U)   /*!< Bit field size in bits for PMU_MISC2_REG0_BO_STATUS. */

/*! @brief Read current value of the PMU_MISC2_REG0_BO_STATUS field. */
#define BR_PMU_MISC2_REG0_BO_STATUS(x) (HW_PMU_MISC2(x).B.REG0_BO_STATUS)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG0_ENABLE_BO[5] (RW)
 *
 * Enables the brownout detection.
 */
/*@{*/
#define BP_PMU_MISC2_REG0_ENABLE_BO (5U)   /*!< Bit position for PMU_MISC2_REG0_ENABLE_BO. */
#define BM_PMU_MISC2_REG0_ENABLE_BO (0x00000020U) /*!< Bit mask for PMU_MISC2_REG0_ENABLE_BO. */
#define BS_PMU_MISC2_REG0_ENABLE_BO (1U)   /*!< Bit field size in bits for PMU_MISC2_REG0_ENABLE_BO. */

/*! @brief Read current value of the PMU_MISC2_REG0_ENABLE_BO field. */
#define BR_PMU_MISC2_REG0_ENABLE_BO(x) (HW_PMU_MISC2(x).B.REG0_ENABLE_BO)

/*! @brief Format value for bitfield PMU_MISC2_REG0_ENABLE_BO. */
#define BF_PMU_MISC2_REG0_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG0_ENABLE_BO) & BM_PMU_MISC2_REG0_ENABLE_BO)

/*! @brief Set the REG0_ENABLE_BO field to a new value. */
#define BW_PMU_MISC2_REG0_ENABLE_BO(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG0_ENABLE_BO) | BF_PMU_MISC2_REG0_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field PLL3_disable[7] (RW)
 *
 * Default value of "0". Should be set to "1" to turn off the USB-PLL(PLL3) in
 * run mode. Not related to PMU. See Clock Controller Module (CCM) for more
 * information.
 */
/*@{*/
#define BP_PMU_MISC2_PLL3_disable (7U)     /*!< Bit position for PMU_MISC2_PLL3_disable. */
#define BM_PMU_MISC2_PLL3_disable (0x00000080U) /*!< Bit mask for PMU_MISC2_PLL3_disable. */
#define BS_PMU_MISC2_PLL3_disable (1U)     /*!< Bit field size in bits for PMU_MISC2_PLL3_disable. */

/*! @brief Read current value of the PMU_MISC2_PLL3_disable field. */
#define BR_PMU_MISC2_PLL3_disable(x) (HW_PMU_MISC2(x).B.PLL3_disable)

/*! @brief Format value for bitfield PMU_MISC2_PLL3_disable. */
#define BF_PMU_MISC2_PLL3_disable(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_PLL3_disable) & BM_PMU_MISC2_PLL3_disable)

/*! @brief Set the PLL3_disable field to a new value. */
#define BW_PMU_MISC2_PLL3_disable(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_PLL3_disable) | BF_PMU_MISC2_PLL3_disable(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG1_BO_OFFSET[10:8] (RO)
 *
 * This field defines the brown out voltage offset for the xPU power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. The reset brown-offset is 175mV below the programmed target code.
 * Brownout target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of
 * input supply limitations or load operation.
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_PMU_MISC2_REG1_BO_OFFSET (8U)   /*!< Bit position for PMU_MISC2_REG1_BO_OFFSET. */
#define BM_PMU_MISC2_REG1_BO_OFFSET (0x00000700U) /*!< Bit mask for PMU_MISC2_REG1_BO_OFFSET. */
#define BS_PMU_MISC2_REG1_BO_OFFSET (3U)   /*!< Bit field size in bits for PMU_MISC2_REG1_BO_OFFSET. */

/*! @brief Read current value of the PMU_MISC2_REG1_BO_OFFSET field. */
#define BR_PMU_MISC2_REG1_BO_OFFSET(x) (HW_PMU_MISC2(x).B.REG1_BO_OFFSET)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG1_BO_STATUS[11] (RO)
 *
 * Reg1 brownout status bit.
 *
 * Values:
 * - 1 - Brownout, supply is below target minus brownout offset.
 */
/*@{*/
#define BP_PMU_MISC2_REG1_BO_STATUS (11U)  /*!< Bit position for PMU_MISC2_REG1_BO_STATUS. */
#define BM_PMU_MISC2_REG1_BO_STATUS (0x00000800U) /*!< Bit mask for PMU_MISC2_REG1_BO_STATUS. */
#define BS_PMU_MISC2_REG1_BO_STATUS (1U)   /*!< Bit field size in bits for PMU_MISC2_REG1_BO_STATUS. */

/*! @brief Read current value of the PMU_MISC2_REG1_BO_STATUS field. */
#define BR_PMU_MISC2_REG1_BO_STATUS(x) (HW_PMU_MISC2(x).B.REG1_BO_STATUS)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG1_ENABLE_BO[13] (RW)
 *
 * Enables the brownout detection.
 */
/*@{*/
#define BP_PMU_MISC2_REG1_ENABLE_BO (13U)  /*!< Bit position for PMU_MISC2_REG1_ENABLE_BO. */
#define BM_PMU_MISC2_REG1_ENABLE_BO (0x00002000U) /*!< Bit mask for PMU_MISC2_REG1_ENABLE_BO. */
#define BS_PMU_MISC2_REG1_ENABLE_BO (1U)   /*!< Bit field size in bits for PMU_MISC2_REG1_ENABLE_BO. */

/*! @brief Read current value of the PMU_MISC2_REG1_ENABLE_BO field. */
#define BR_PMU_MISC2_REG1_ENABLE_BO(x) (HW_PMU_MISC2(x).B.REG1_ENABLE_BO)

/*! @brief Format value for bitfield PMU_MISC2_REG1_ENABLE_BO. */
#define BF_PMU_MISC2_REG1_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG1_ENABLE_BO) & BM_PMU_MISC2_REG1_ENABLE_BO)

/*! @brief Set the REG1_ENABLE_BO field to a new value. */
#define BW_PMU_MISC2_REG1_ENABLE_BO(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG1_ENABLE_BO) | BF_PMU_MISC2_REG1_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field AUDIO_DIV_LSB[15] (RW)
 *
 * LSB of Post-divider for Audio PLL. The output clock of the video PLL should
 * be gated prior to changing this divider to prevent glitches. This divider is
 * feed by PLL_AUDIOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4,
 * /8, and /16. LSB bit value pertains to the last bit, please program the MSB bit
 * (bit 23) as well, to change divider value Not related to PMU. See Clock
 * Controller Module (CCM) for more information.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 */
/*@{*/
#define BP_PMU_MISC2_AUDIO_DIV_LSB (15U)   /*!< Bit position for PMU_MISC2_AUDIO_DIV_LSB. */
#define BM_PMU_MISC2_AUDIO_DIV_LSB (0x00008000U) /*!< Bit mask for PMU_MISC2_AUDIO_DIV_LSB. */
#define BS_PMU_MISC2_AUDIO_DIV_LSB (1U)    /*!< Bit field size in bits for PMU_MISC2_AUDIO_DIV_LSB. */

/*! @brief Read current value of the PMU_MISC2_AUDIO_DIV_LSB field. */
#define BR_PMU_MISC2_AUDIO_DIV_LSB(x) (HW_PMU_MISC2(x).B.AUDIO_DIV_LSB)

/*! @brief Format value for bitfield PMU_MISC2_AUDIO_DIV_LSB. */
#define BF_PMU_MISC2_AUDIO_DIV_LSB(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_AUDIO_DIV_LSB) & BM_PMU_MISC2_AUDIO_DIV_LSB)

/*! @brief Set the AUDIO_DIV_LSB field to a new value. */
#define BW_PMU_MISC2_AUDIO_DIV_LSB(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_AUDIO_DIV_LSB) | BF_PMU_MISC2_AUDIO_DIV_LSB(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG2_BO_OFFSET[18:16] (RO)
 *
 * This field defines the brown out voltage offset for the xPU power domain.
 * IRQ_DIG_BO is also asserted. Single-bit increments reflect 25mV brownout voltage
 * steps. The reset brown-offset is 175mV below the programmed target code.
 * Brownout target = OUTPUT_TRG - BO_OFFSET. Some steps may be irrelevant because of
 * input supply limitations or load operation.
 *
 * Values:
 * - 100 - Brownout offset = 0.100V
 * - 111 - Brownout offset = 0.175V
 */
/*@{*/
#define BP_PMU_MISC2_REG2_BO_OFFSET (16U)  /*!< Bit position for PMU_MISC2_REG2_BO_OFFSET. */
#define BM_PMU_MISC2_REG2_BO_OFFSET (0x00070000U) /*!< Bit mask for PMU_MISC2_REG2_BO_OFFSET. */
#define BS_PMU_MISC2_REG2_BO_OFFSET (3U)   /*!< Bit field size in bits for PMU_MISC2_REG2_BO_OFFSET. */

/*! @brief Read current value of the PMU_MISC2_REG2_BO_OFFSET field. */
#define BR_PMU_MISC2_REG2_BO_OFFSET(x) (HW_PMU_MISC2(x).B.REG2_BO_OFFSET)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG2_BO_STATUS[19] (RO)
 *
 * Reg2 brownout status bit.
 */
/*@{*/
#define BP_PMU_MISC2_REG2_BO_STATUS (19U)  /*!< Bit position for PMU_MISC2_REG2_BO_STATUS. */
#define BM_PMU_MISC2_REG2_BO_STATUS (0x00080000U) /*!< Bit mask for PMU_MISC2_REG2_BO_STATUS. */
#define BS_PMU_MISC2_REG2_BO_STATUS (1U)   /*!< Bit field size in bits for PMU_MISC2_REG2_BO_STATUS. */

/*! @brief Read current value of the PMU_MISC2_REG2_BO_STATUS field. */
#define BR_PMU_MISC2_REG2_BO_STATUS(x) (HW_PMU_MISC2(x).B.REG2_BO_STATUS)
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG2_ENABLE_BO[21] (RW)
 *
 * Enables the brownout detection.
 */
/*@{*/
#define BP_PMU_MISC2_REG2_ENABLE_BO (21U)  /*!< Bit position for PMU_MISC2_REG2_ENABLE_BO. */
#define BM_PMU_MISC2_REG2_ENABLE_BO (0x00200000U) /*!< Bit mask for PMU_MISC2_REG2_ENABLE_BO. */
#define BS_PMU_MISC2_REG2_ENABLE_BO (1U)   /*!< Bit field size in bits for PMU_MISC2_REG2_ENABLE_BO. */

/*! @brief Read current value of the PMU_MISC2_REG2_ENABLE_BO field. */
#define BR_PMU_MISC2_REG2_ENABLE_BO(x) (HW_PMU_MISC2(x).B.REG2_ENABLE_BO)

/*! @brief Format value for bitfield PMU_MISC2_REG2_ENABLE_BO. */
#define BF_PMU_MISC2_REG2_ENABLE_BO(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG2_ENABLE_BO) & BM_PMU_MISC2_REG2_ENABLE_BO)

/*! @brief Set the REG2_ENABLE_BO field to a new value. */
#define BW_PMU_MISC2_REG2_ENABLE_BO(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG2_ENABLE_BO) | BF_PMU_MISC2_REG2_ENABLE_BO(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG2_OK[22] (RO)
 *
 * Signals that the voltage is above the brownout level for the SOC supply. 1 =
 * regulator output > brownout_target
 */
/*@{*/
#define BP_PMU_MISC2_REG2_OK (22U)         /*!< Bit position for PMU_MISC2_REG2_OK. */
#define BM_PMU_MISC2_REG2_OK (0x00400000U) /*!< Bit mask for PMU_MISC2_REG2_OK. */
#define BS_PMU_MISC2_REG2_OK (1U)          /*!< Bit field size in bits for PMU_MISC2_REG2_OK. */

/*! @brief Read current value of the PMU_MISC2_REG2_OK field. */
#define BR_PMU_MISC2_REG2_OK(x) (HW_PMU_MISC2(x).B.REG2_OK)
/*@}*/

/*!
 * @name Register PMU_MISC2, field AUDIO_DIV_MSB[23] (RW)
 *
 * MSB of Post-divider for Audio PLL. The output clock of the video PLL should
 * be gated prior to changing this divider to prevent glitches. This divider is
 * feed by PLL_AUDIOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4,
 * /8, and /16. MSB bit value pertains to the first bit, please program the LSB bit
 * (bit 15) as well to change divider value Not related to PMU. See Clock
 * Controller Module (CCM) for more information.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 */
/*@{*/
#define BP_PMU_MISC2_AUDIO_DIV_MSB (23U)   /*!< Bit position for PMU_MISC2_AUDIO_DIV_MSB. */
#define BM_PMU_MISC2_AUDIO_DIV_MSB (0x00800000U) /*!< Bit mask for PMU_MISC2_AUDIO_DIV_MSB. */
#define BS_PMU_MISC2_AUDIO_DIV_MSB (1U)    /*!< Bit field size in bits for PMU_MISC2_AUDIO_DIV_MSB. */

/*! @brief Read current value of the PMU_MISC2_AUDIO_DIV_MSB field. */
#define BR_PMU_MISC2_AUDIO_DIV_MSB(x) (HW_PMU_MISC2(x).B.AUDIO_DIV_MSB)

/*! @brief Format value for bitfield PMU_MISC2_AUDIO_DIV_MSB. */
#define BF_PMU_MISC2_AUDIO_DIV_MSB(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_AUDIO_DIV_MSB) & BM_PMU_MISC2_AUDIO_DIV_MSB)

/*! @brief Set the AUDIO_DIV_MSB field to a new value. */
#define BW_PMU_MISC2_AUDIO_DIV_MSB(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_AUDIO_DIV_MSB) | BF_PMU_MISC2_AUDIO_DIV_MSB(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG0_STEP_TIME[25:24] (RW)
 *
 * Number of clock periods (24MHz clock).
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_PMU_MISC2_REG0_STEP_TIME (24U)  /*!< Bit position for PMU_MISC2_REG0_STEP_TIME. */
#define BM_PMU_MISC2_REG0_STEP_TIME (0x03000000U) /*!< Bit mask for PMU_MISC2_REG0_STEP_TIME. */
#define BS_PMU_MISC2_REG0_STEP_TIME (2U)   /*!< Bit field size in bits for PMU_MISC2_REG0_STEP_TIME. */

#define BV_PMU_MISC2_REG0_STEP_TIME_64_CLOCKS (0U)   /*!< Bit field value for PMU_MISC2_REG0_STEP_TIME: 64 */
#define BV_PMU_MISC2_REG0_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for PMU_MISC2_REG0_STEP_TIME: 128 */
#define BV_PMU_MISC2_REG0_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for PMU_MISC2_REG0_STEP_TIME: 256 */
#define BV_PMU_MISC2_REG0_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for PMU_MISC2_REG0_STEP_TIME: 512 */

/*! @brief Read current value of the PMU_MISC2_REG0_STEP_TIME field. */
#define BR_PMU_MISC2_REG0_STEP_TIME(x) (HW_PMU_MISC2(x).B.REG0_STEP_TIME)

/*! @brief Format value for bitfield PMU_MISC2_REG0_STEP_TIME. */
#define BF_PMU_MISC2_REG0_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG0_STEP_TIME) & BM_PMU_MISC2_REG0_STEP_TIME)

/*! @brief Set the REG0_STEP_TIME field to a new value. */
#define BW_PMU_MISC2_REG0_STEP_TIME(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG0_STEP_TIME) | BF_PMU_MISC2_REG0_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG1_STEP_TIME[27:26] (RW)
 *
 * Number of clock periods (24MHz clock).
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_PMU_MISC2_REG1_STEP_TIME (26U)  /*!< Bit position for PMU_MISC2_REG1_STEP_TIME. */
#define BM_PMU_MISC2_REG1_STEP_TIME (0x0C000000U) /*!< Bit mask for PMU_MISC2_REG1_STEP_TIME. */
#define BS_PMU_MISC2_REG1_STEP_TIME (2U)   /*!< Bit field size in bits for PMU_MISC2_REG1_STEP_TIME. */

#define BV_PMU_MISC2_REG1_STEP_TIME_64_CLOCKS (0U)   /*!< Bit field value for PMU_MISC2_REG1_STEP_TIME: 64 */
#define BV_PMU_MISC2_REG1_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for PMU_MISC2_REG1_STEP_TIME: 128 */
#define BV_PMU_MISC2_REG1_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for PMU_MISC2_REG1_STEP_TIME: 256 */
#define BV_PMU_MISC2_REG1_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for PMU_MISC2_REG1_STEP_TIME: 512 */

/*! @brief Read current value of the PMU_MISC2_REG1_STEP_TIME field. */
#define BR_PMU_MISC2_REG1_STEP_TIME(x) (HW_PMU_MISC2(x).B.REG1_STEP_TIME)

/*! @brief Format value for bitfield PMU_MISC2_REG1_STEP_TIME. */
#define BF_PMU_MISC2_REG1_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG1_STEP_TIME) & BM_PMU_MISC2_REG1_STEP_TIME)

/*! @brief Set the REG1_STEP_TIME field to a new value. */
#define BW_PMU_MISC2_REG1_STEP_TIME(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG1_STEP_TIME) | BF_PMU_MISC2_REG1_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field REG2_STEP_TIME[29:28] (RW)
 *
 * Number of clock periods (24MHz clock).
 *
 * Values:
 * - 00 - 64
 * - 01 - 128
 * - 10 - 256
 * - 11 - 512
 */
/*@{*/
#define BP_PMU_MISC2_REG2_STEP_TIME (28U)  /*!< Bit position for PMU_MISC2_REG2_STEP_TIME. */
#define BM_PMU_MISC2_REG2_STEP_TIME (0x30000000U) /*!< Bit mask for PMU_MISC2_REG2_STEP_TIME. */
#define BS_PMU_MISC2_REG2_STEP_TIME (2U)   /*!< Bit field size in bits for PMU_MISC2_REG2_STEP_TIME. */

#define BV_PMU_MISC2_REG2_STEP_TIME_64_CLOCKS (0U)   /*!< Bit field value for PMU_MISC2_REG2_STEP_TIME: 64 */
#define BV_PMU_MISC2_REG2_STEP_TIME_128_CLOCKS (0x1U) /*!< Bit field value for PMU_MISC2_REG2_STEP_TIME: 128 */
#define BV_PMU_MISC2_REG2_STEP_TIME_256_CLOCKS (0x2U) /*!< Bit field value for PMU_MISC2_REG2_STEP_TIME: 256 */
#define BV_PMU_MISC2_REG2_STEP_TIME_512_CLOCKS (0x3U) /*!< Bit field value for PMU_MISC2_REG2_STEP_TIME: 512 */

/*! @brief Read current value of the PMU_MISC2_REG2_STEP_TIME field. */
#define BR_PMU_MISC2_REG2_STEP_TIME(x) (HW_PMU_MISC2(x).B.REG2_STEP_TIME)

/*! @brief Format value for bitfield PMU_MISC2_REG2_STEP_TIME. */
#define BF_PMU_MISC2_REG2_STEP_TIME(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_REG2_STEP_TIME) & BM_PMU_MISC2_REG2_STEP_TIME)

/*! @brief Set the REG2_STEP_TIME field to a new value. */
#define BW_PMU_MISC2_REG2_STEP_TIME(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_REG2_STEP_TIME) | BF_PMU_MISC2_REG2_STEP_TIME(v)))
/*@}*/

/*!
 * @name Register PMU_MISC2, field VIDEO_DIV[31:30] (RW)
 *
 * Post-divider for video. The output clock of the video PLL should be gated
 * prior to changing this divider to prevent glitches. This divider is feed by
 * PLL_VIDEOn[POST_DIV_SELECT] to achieve division ratios of /1, /2, /4, /8, and /16.
 * Not related to PMU. See Clock Controller Module (CCM) for more information.
 *
 * Values:
 * - 00 - divide by 1 (Default)
 * - 01 - divide by 2
 * - 10 - divide by 1
 * - 11 - divide by 4
 */
/*@{*/
#define BP_PMU_MISC2_VIDEO_DIV (30U)       /*!< Bit position for PMU_MISC2_VIDEO_DIV. */
#define BM_PMU_MISC2_VIDEO_DIV (0xC0000000U) /*!< Bit mask for PMU_MISC2_VIDEO_DIV. */
#define BS_PMU_MISC2_VIDEO_DIV (2U)        /*!< Bit field size in bits for PMU_MISC2_VIDEO_DIV. */

/*! @brief Read current value of the PMU_MISC2_VIDEO_DIV field. */
#define BR_PMU_MISC2_VIDEO_DIV(x) (HW_PMU_MISC2(x).B.VIDEO_DIV)

/*! @brief Format value for bitfield PMU_MISC2_VIDEO_DIV. */
#define BF_PMU_MISC2_VIDEO_DIV(v) ((uint32_t)((uint32_t)(v) << BP_PMU_MISC2_VIDEO_DIV) & BM_PMU_MISC2_VIDEO_DIV)

/*! @brief Set the VIDEO_DIV field to a new value. */
#define BW_PMU_MISC2_VIDEO_DIV(x, v) (HW_PMU_MISC2_WR(x, (HW_PMU_MISC2_RD(x) & ~BM_PMU_MISC2_VIDEO_DIV) | BF_PMU_MISC2_VIDEO_DIV(v)))
/*@}*/




/*******************************************************************************
 * hw_pmu_t - module struct
 ******************************************************************************/
/*!
 * @brief All PMU module registers.
 */
#pragma pack(1)
typedef struct _hw_pmu
{
    uint8_t _reserved0[272];
    __IO hw_pmu_reg_1p1_t REG_1P1;         /*!< [0x110] Regulator 1P1 Register */
    uint8_t _reserved1[12];
    __IO hw_pmu_reg_3p0_t REG_3P0;         /*!< [0x120] Regulator 3P0 Register */
    uint8_t _reserved2[12];
    __IO hw_pmu_reg_2p5_t REG_2P5;         /*!< [0x130] Regulator 2P5 Register */
    uint8_t _reserved3[12];
    __IO hw_pmu_reg_core_t REG_CORE;       /*!< [0x140] Digital Regulator Core Register */
    uint8_t _reserved4[12];
    __IO hw_pmu_misc0_t MISC0;             /*!< [0x150] Miscellaneous Register 0 */
    uint8_t _reserved5[12];
    __IO hw_pmu_misc1_t MISC1;             /*!< [0x160] Miscellaneous Register 1 */
    uint8_t _reserved6[12];
    __IO hw_pmu_misc2_t MISC2;             /*!< [0x170] Miscellaneous Control Register */
} hw_pmu_t;
#pragma pack()

/*! @brief Macro to access all PMU registers. */
/*! @param x PMU module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PMU_REGS(PMU_BASE)</code>. */
#define HW_PMU_REGS(x) (*(hw_pmu_t *)(x))

/*
 * iMX6DP PWM
 *
 * PWM
 *
 * Registers defined in this header file:
 * - HW_PWM_PWMCR - PWM Control Register
 * - HW_PWM_PWMSR - PWM Status Register
 * - HW_PWM_PWMIR - PWM Interrupt Register
 * - HW_PWM_PWMSAR - PWM Sample Register
 * - HW_PWM_PWMPR - PWM Period Register
 * - HW_PWM_PWMCNR - PWM Counter Register
 *
 * - hw_pwm_t - Struct containing all module registers.
 */

#define HW_PWM_INSTANCE_COUNT (4U) /*!< Number of instances of the PWM module. */
#define HW_PWM1 (0U) /*!< Instance number for PWM1. */
#define HW_PWM2 (1U) /*!< Instance number for PWM2. */
#define HW_PWM3 (2U) /*!< Instance number for PWM3. */
#define HW_PWM4 (3U) /*!< Instance number for PWM4. */
#define PWM1_BASE             (0x2080000U) /*!< Base address for PWM1. */
#define PWM2_BASE             (0x2084000U) /*!< Base address for PWM2. */
#define PWM3_BASE             (0x2088000U) /*!< Base address for PWM3. */
#define PWM4_BASE             (0x208C000U) /*!< Base address for PWM4. */
/*! Array initializer of PWM base addresses. */
#define PWM_BASE_ADDRS        { PWM1_BASE, PWM2_BASE, PWM3_BASE, PWM4_BASE }

/*******************************************************************************
 * HW_PWM_PWMCR - PWM Control Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMCR - PWM Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PWM control register (PWM_PWMCR) is used to configure the operating
 * settings of the PWM. It contains the prescaler for the clock division.
 */
typedef union _hw_pwm_pwmcr
{
    uint32_t U;
    struct _hw_pwm_pwmcr_bitfields
    {
        uint32_t EN : 1;               /*!< [0]  */
        uint32_t REPEAT : 2;           /*!< [2:1]  */
        uint32_t SWR : 1;              /*!< [3]  */
        uint32_t PRESCALER : 12;       /*!< [15:4]  */
        uint32_t CLKSRC : 2;           /*!< [17:16]  */
        uint32_t POUTC : 2;            /*!< [19:18]  */
        uint32_t HCTR : 1;             /*!< [20]  */
        uint32_t BCTR : 1;             /*!< [21]  */
        uint32_t DBGEN : 1;            /*!< [22]  */
        uint32_t WAITEN : 1;           /*!< [23]  */
        uint32_t DOZEN : 1;            /*!< [24]  */
        uint32_t STOPEN : 1;           /*!< [25]  */
        uint32_t FWM : 2;              /*!< [27:26]  */
        uint32_t RESERVED0 : 4;        /*!< [31:28]  */
    } B;
} hw_pwm_pwmcr_t;

/*!
 * @name Constants and macros for entire PWM_PWMCR register
 */
/*@{*/
#define HW_PWM_PWMCR_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_PWM_PWMCR(x)          (*(__IO hw_pwm_pwmcr_t *) HW_PWM_PWMCR_ADDR(x))
#define HW_PWM_PWMCR_RD(x)       (HW_PWM_PWMCR(x).U)
#define HW_PWM_PWMCR_WR(x, v)    (HW_PWM_PWMCR(x).U = (v))
#define HW_PWM_PWMCR_SET(x, v)   (HW_PWM_PWMCR_WR(x, HW_PWM_PWMCR_RD(x) |  (v)))
#define HW_PWM_PWMCR_CLR(x, v)   (HW_PWM_PWMCR_WR(x, HW_PWM_PWMCR_RD(x) & ~(v)))
#define HW_PWM_PWMCR_TOG(x, v)   (HW_PWM_PWMCR_WR(x, HW_PWM_PWMCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PWM_PWMCR bitfields
 */

/*!
 * @name Register PWM_PWMCR, field EN[0] (RW)
 *
 * PWM Enable. This bit enables the PWM. If this bit is not enabled, the clock
 * prescaler and the counter is reset. When the PWM is enabled, it begins a new
 * period, the output pin is set to start a new period while the prescaler and
 * counter are released and counting begins. To make the PWM work with softreset and
 * disable/enable, users can do software reset by seting the SWR bit, wait
 * software reset done, configure the registers, and then enable the PWM by setting
 * this bit to "1" Users can also disable/enable the PWM if PWM would like to be
 * stopped and resumed with same registers configurations .
 *
 * Values:
 * - 0 - PWM disabled
 * - 1 - PWM enabled
 */
/*@{*/
#define BP_PWM_PWMCR_EN      (0U)          /*!< Bit position for PWM_PWMCR_EN. */
#define BM_PWM_PWMCR_EN      (0x00000001U) /*!< Bit mask for PWM_PWMCR_EN. */
#define BS_PWM_PWMCR_EN      (1U)          /*!< Bit field size in bits for PWM_PWMCR_EN. */

/*! @brief Read current value of the PWM_PWMCR_EN field. */
#define BR_PWM_PWMCR_EN(x)   (HW_PWM_PWMCR(x).B.EN)

/*! @brief Format value for bitfield PWM_PWMCR_EN. */
#define BF_PWM_PWMCR_EN(v)   ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_EN) & BM_PWM_PWMCR_EN)

/*! @brief Set the EN field to a new value. */
#define BW_PWM_PWMCR_EN(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_EN) | BF_PWM_PWMCR_EN(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field REPEAT[2:1] (RW)
 *
 * Sample Repeat. This bit field determines the number of times each sample from
 * the FIFO is to be used.
 *
 * Values:
 * - 00 - Use each sample once
 * - 01 - Use each sample twice
 * - 10 - Use each sample four times
 * - 11 - Use each sample eight times
 */
/*@{*/
#define BP_PWM_PWMCR_REPEAT  (1U)          /*!< Bit position for PWM_PWMCR_REPEAT. */
#define BM_PWM_PWMCR_REPEAT  (0x00000006U) /*!< Bit mask for PWM_PWMCR_REPEAT. */
#define BS_PWM_PWMCR_REPEAT  (2U)          /*!< Bit field size in bits for PWM_PWMCR_REPEAT. */

/*! @brief Read current value of the PWM_PWMCR_REPEAT field. */
#define BR_PWM_PWMCR_REPEAT(x) (HW_PWM_PWMCR(x).B.REPEAT)

/*! @brief Format value for bitfield PWM_PWMCR_REPEAT. */
#define BF_PWM_PWMCR_REPEAT(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_REPEAT) & BM_PWM_PWMCR_REPEAT)

/*! @brief Set the REPEAT field to a new value. */
#define BW_PWM_PWMCR_REPEAT(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_REPEAT) | BF_PWM_PWMCR_REPEAT(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field SWR[3] (RW)
 *
 * Software Reset. PWM is reset when this bit is set to 1. It is a self clearing
 * bit. A write 1 to this bit is a single wait state write cycle. When the block
 * is in reset state this bit is set and is cleared when the reset procedure is
 * over. Setting this bit resets all the registers to their reset values except
 * for the STOPEN, DOZEN, WAITEN, and DBGEN bits in this control register.
 *
 * Values:
 * - 0 - PWM is out of reset
 * - 1 - PWM is undergoing reset
 */
/*@{*/
#define BP_PWM_PWMCR_SWR     (3U)          /*!< Bit position for PWM_PWMCR_SWR. */
#define BM_PWM_PWMCR_SWR     (0x00000008U) /*!< Bit mask for PWM_PWMCR_SWR. */
#define BS_PWM_PWMCR_SWR     (1U)          /*!< Bit field size in bits for PWM_PWMCR_SWR. */

/*! @brief Read current value of the PWM_PWMCR_SWR field. */
#define BR_PWM_PWMCR_SWR(x)  (HW_PWM_PWMCR(x).B.SWR)

/*! @brief Format value for bitfield PWM_PWMCR_SWR. */
#define BF_PWM_PWMCR_SWR(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_SWR) & BM_PWM_PWMCR_SWR)

/*! @brief Set the SWR field to a new value. */
#define BW_PWM_PWMCR_SWR(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_SWR) | BF_PWM_PWMCR_SWR(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field PRESCALER[15:4] (RW)
 *
 * Counter Clock Prescaler Value. This bit field determines the value by which
 * the clock will be divided before it goes to the counter.
 *
 * Values:
 * - 0 - Divide by 1
 * - 1 - Divide by 2
 * - 111111111111 - Divide by 4096
 */
/*@{*/
#define BP_PWM_PWMCR_PRESCALER (4U)        /*!< Bit position for PWM_PWMCR_PRESCALER. */
#define BM_PWM_PWMCR_PRESCALER (0x0000FFF0U) /*!< Bit mask for PWM_PWMCR_PRESCALER. */
#define BS_PWM_PWMCR_PRESCALER (12U)       /*!< Bit field size in bits for PWM_PWMCR_PRESCALER. */

/*! @brief Read current value of the PWM_PWMCR_PRESCALER field. */
#define BR_PWM_PWMCR_PRESCALER(x) (HW_PWM_PWMCR(x).B.PRESCALER)

/*! @brief Format value for bitfield PWM_PWMCR_PRESCALER. */
#define BF_PWM_PWMCR_PRESCALER(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_PRESCALER) & BM_PWM_PWMCR_PRESCALER)

/*! @brief Set the PRESCALER field to a new value. */
#define BW_PWM_PWMCR_PRESCALER(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_PRESCALER) | BF_PWM_PWMCR_PRESCALER(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field CLKSRC[17:16] (RW)
 *
 * Select Clock Source. These bits determine which clock input will be selected
 * for running the counter. After reset the system functional clock is selected.
 * The input clock can also be turned off if these bits are set to 00. This field
 * value should only be changed when the PWM is disabled
 *
 * Values:
 * - 00 - Clock is off
 * - 01 - ipg_clk
 * - 10 - ipg_clk_highfreq
 * - 11 - ipg_clk_32k
 */
/*@{*/
#define BP_PWM_PWMCR_CLKSRC  (16U)         /*!< Bit position for PWM_PWMCR_CLKSRC. */
#define BM_PWM_PWMCR_CLKSRC  (0x00030000U) /*!< Bit mask for PWM_PWMCR_CLKSRC. */
#define BS_PWM_PWMCR_CLKSRC  (2U)          /*!< Bit field size in bits for PWM_PWMCR_CLKSRC. */

/*! @brief Read current value of the PWM_PWMCR_CLKSRC field. */
#define BR_PWM_PWMCR_CLKSRC(x) (HW_PWM_PWMCR(x).B.CLKSRC)

/*! @brief Format value for bitfield PWM_PWMCR_CLKSRC. */
#define BF_PWM_PWMCR_CLKSRC(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_CLKSRC) & BM_PWM_PWMCR_CLKSRC)

/*! @brief Set the CLKSRC field to a new value. */
#define BW_PWM_PWMCR_CLKSRC(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_CLKSRC) | BF_PWM_PWMCR_CLKSRC(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field POUTC[19:18] (RW)
 *
 * PWM Output Configuration. This bit field determines the mode of PWM output on
 * the output pin.
 *
 * Values:
 * - 00 - Output pin is set at rollover and cleared at comparison
 * - 01 - Output pin is cleared at rollover and set at comparison
 * - 10 - PWM output is disconnected
 * - 11 - PWM output is disconnected
 */
/*@{*/
#define BP_PWM_PWMCR_POUTC   (18U)         /*!< Bit position for PWM_PWMCR_POUTC. */
#define BM_PWM_PWMCR_POUTC   (0x000C0000U) /*!< Bit mask for PWM_PWMCR_POUTC. */
#define BS_PWM_PWMCR_POUTC   (2U)          /*!< Bit field size in bits for PWM_PWMCR_POUTC. */

/*! @brief Read current value of the PWM_PWMCR_POUTC field. */
#define BR_PWM_PWMCR_POUTC(x) (HW_PWM_PWMCR(x).B.POUTC)

/*! @brief Format value for bitfield PWM_PWMCR_POUTC. */
#define BF_PWM_PWMCR_POUTC(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_POUTC) & BM_PWM_PWMCR_POUTC)

/*! @brief Set the POUTC field to a new value. */
#define BW_PWM_PWMCR_POUTC(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_POUTC) | BF_PWM_PWMCR_POUTC(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field HCTR[20] (RW)
 *
 * Half-word Data Swap Control. This bit determines which half word data from
 * the 32-bit IP Bus interface is written into the lower 16 bits of the sample
 * register.
 *
 * Values:
 * - 0 - Half word swapping does not take place
 * - 1 - Half words from write data bus are swapped
 */
/*@{*/
#define BP_PWM_PWMCR_HCTR    (20U)         /*!< Bit position for PWM_PWMCR_HCTR. */
#define BM_PWM_PWMCR_HCTR    (0x00100000U) /*!< Bit mask for PWM_PWMCR_HCTR. */
#define BS_PWM_PWMCR_HCTR    (1U)          /*!< Bit field size in bits for PWM_PWMCR_HCTR. */

/*! @brief Read current value of the PWM_PWMCR_HCTR field. */
#define BR_PWM_PWMCR_HCTR(x) (HW_PWM_PWMCR(x).B.HCTR)

/*! @brief Format value for bitfield PWM_PWMCR_HCTR. */
#define BF_PWM_PWMCR_HCTR(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_HCTR) & BM_PWM_PWMCR_HCTR)

/*! @brief Set the HCTR field to a new value. */
#define BW_PWM_PWMCR_HCTR(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_HCTR) | BF_PWM_PWMCR_HCTR(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field BCTR[21] (RW)
 *
 * Byte Data Swap Control. This bit determines the byte ordering of the 16-bit
 * data when it goes into the FIFO from the sample register.
 *
 * Values:
 * - 0 - byte ordering remains the same
 * - 1 - byte ordering is reversed
 */
/*@{*/
#define BP_PWM_PWMCR_BCTR    (21U)         /*!< Bit position for PWM_PWMCR_BCTR. */
#define BM_PWM_PWMCR_BCTR    (0x00200000U) /*!< Bit mask for PWM_PWMCR_BCTR. */
#define BS_PWM_PWMCR_BCTR    (1U)          /*!< Bit field size in bits for PWM_PWMCR_BCTR. */

/*! @brief Read current value of the PWM_PWMCR_BCTR field. */
#define BR_PWM_PWMCR_BCTR(x) (HW_PWM_PWMCR(x).B.BCTR)

/*! @brief Format value for bitfield PWM_PWMCR_BCTR. */
#define BF_PWM_PWMCR_BCTR(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_BCTR) & BM_PWM_PWMCR_BCTR)

/*! @brief Set the BCTR field to a new value. */
#define BW_PWM_PWMCR_BCTR(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_BCTR) | BF_PWM_PWMCR_BCTR(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field DBGEN[22] (RW)
 *
 * Debug Mode Enable. This bit keeps the PWM functional in debug mode. When this
 * bit is cleared, the input clock is gated off in debug mode. This bit is not
 * affected by software reset. It is cleared by hardware reset.
 *
 * Values:
 * - 0 - Inactive in debug mode
 * - 1 - Active in debug mode
 */
/*@{*/
#define BP_PWM_PWMCR_DBGEN   (22U)         /*!< Bit position for PWM_PWMCR_DBGEN. */
#define BM_PWM_PWMCR_DBGEN   (0x00400000U) /*!< Bit mask for PWM_PWMCR_DBGEN. */
#define BS_PWM_PWMCR_DBGEN   (1U)          /*!< Bit field size in bits for PWM_PWMCR_DBGEN. */

/*! @brief Read current value of the PWM_PWMCR_DBGEN field. */
#define BR_PWM_PWMCR_DBGEN(x) (HW_PWM_PWMCR(x).B.DBGEN)

/*! @brief Format value for bitfield PWM_PWMCR_DBGEN. */
#define BF_PWM_PWMCR_DBGEN(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_DBGEN) & BM_PWM_PWMCR_DBGEN)

/*! @brief Set the DBGEN field to a new value. */
#define BW_PWM_PWMCR_DBGEN(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_DBGEN) | BF_PWM_PWMCR_DBGEN(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field WAITEN[23] (RW)
 *
 * Wait Mode Enable. This bit keeps the PWM functional in wait mode. When this
 * bit is cleared, the input clock is gated off in wait mode. This bit is not
 * affected by software reset. It is cleared by hardware reset.
 *
 * Values:
 * - 0 - Inactive in wait mode
 * - 1 - Active in wait mode
 */
/*@{*/
#define BP_PWM_PWMCR_WAITEN  (23U)         /*!< Bit position for PWM_PWMCR_WAITEN. */
#define BM_PWM_PWMCR_WAITEN  (0x00800000U) /*!< Bit mask for PWM_PWMCR_WAITEN. */
#define BS_PWM_PWMCR_WAITEN  (1U)          /*!< Bit field size in bits for PWM_PWMCR_WAITEN. */

/*! @brief Read current value of the PWM_PWMCR_WAITEN field. */
#define BR_PWM_PWMCR_WAITEN(x) (HW_PWM_PWMCR(x).B.WAITEN)

/*! @brief Format value for bitfield PWM_PWMCR_WAITEN. */
#define BF_PWM_PWMCR_WAITEN(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_WAITEN) & BM_PWM_PWMCR_WAITEN)

/*! @brief Set the WAITEN field to a new value. */
#define BW_PWM_PWMCR_WAITEN(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_WAITEN) | BF_PWM_PWMCR_WAITEN(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field DOZEN[24] (RW)
 *
 * Doze Mode Enable. This bit keeps the PWM functional in doze mode. When this
 * bit is cleared, the input clock is gated off in doze mode. This bit is not
 * affected by software reset. It is cleared by hardware reset.
 *
 * Values:
 * - 0 - Inactive in doze mode
 * - 1 - Active in doze mode
 */
/*@{*/
#define BP_PWM_PWMCR_DOZEN   (24U)         /*!< Bit position for PWM_PWMCR_DOZEN. */
#define BM_PWM_PWMCR_DOZEN   (0x01000000U) /*!< Bit mask for PWM_PWMCR_DOZEN. */
#define BS_PWM_PWMCR_DOZEN   (1U)          /*!< Bit field size in bits for PWM_PWMCR_DOZEN. */

/*! @brief Read current value of the PWM_PWMCR_DOZEN field. */
#define BR_PWM_PWMCR_DOZEN(x) (HW_PWM_PWMCR(x).B.DOZEN)

/*! @brief Format value for bitfield PWM_PWMCR_DOZEN. */
#define BF_PWM_PWMCR_DOZEN(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_DOZEN) & BM_PWM_PWMCR_DOZEN)

/*! @brief Set the DOZEN field to a new value. */
#define BW_PWM_PWMCR_DOZEN(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_DOZEN) | BF_PWM_PWMCR_DOZEN(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field STOPEN[25] (RW)
 *
 * Stop Mode Enable. This bit keeps the PWM functional while in stop mode. When
 * this bit is cleared, the input clock is gated off in stop mode. This bit is
 * not affected by software reset. It is cleared by hardware reset.
 *
 * Values:
 * - 0 - Inactive in stop mode
 * - 1 - Active in stop mode
 */
/*@{*/
#define BP_PWM_PWMCR_STOPEN  (25U)         /*!< Bit position for PWM_PWMCR_STOPEN. */
#define BM_PWM_PWMCR_STOPEN  (0x02000000U) /*!< Bit mask for PWM_PWMCR_STOPEN. */
#define BS_PWM_PWMCR_STOPEN  (1U)          /*!< Bit field size in bits for PWM_PWMCR_STOPEN. */

/*! @brief Read current value of the PWM_PWMCR_STOPEN field. */
#define BR_PWM_PWMCR_STOPEN(x) (HW_PWM_PWMCR(x).B.STOPEN)

/*! @brief Format value for bitfield PWM_PWMCR_STOPEN. */
#define BF_PWM_PWMCR_STOPEN(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_STOPEN) & BM_PWM_PWMCR_STOPEN)

/*! @brief Set the STOPEN field to a new value. */
#define BW_PWM_PWMCR_STOPEN(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_STOPEN) | BF_PWM_PWMCR_STOPEN(v)))
/*@}*/

/*!
 * @name Register PWM_PWMCR, field FWM[27:26] (RW)
 *
 * FIFO Water Mark. These bits are used to set the data level at which the FIFO
 * empty flag will be set and the corresponding interrupt generated
 *
 * Values:
 * - 00 - FIFO empty flag is set when there are more than or equal to 1 empty
 *     slots in FIFO
 * - 01 - FIFO empty flag is set when there are more than or equal to 2 empty
 *     slots in FIFO
 * - 10 - FIFO empty flag is set when there are more than or equal to 3 empty
 *     slots in FIFO
 * - 11 - FIFO empty flag is set when there are more than or equal to 4 empty
 *     slots in FIFO
 */
/*@{*/
#define BP_PWM_PWMCR_FWM     (26U)         /*!< Bit position for PWM_PWMCR_FWM. */
#define BM_PWM_PWMCR_FWM     (0x0C000000U) /*!< Bit mask for PWM_PWMCR_FWM. */
#define BS_PWM_PWMCR_FWM     (2U)          /*!< Bit field size in bits for PWM_PWMCR_FWM. */

/*! @brief Read current value of the PWM_PWMCR_FWM field. */
#define BR_PWM_PWMCR_FWM(x)  (HW_PWM_PWMCR(x).B.FWM)

/*! @brief Format value for bitfield PWM_PWMCR_FWM. */
#define BF_PWM_PWMCR_FWM(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMCR_FWM) & BM_PWM_PWMCR_FWM)

/*! @brief Set the FWM field to a new value. */
#define BW_PWM_PWMCR_FWM(x, v) (HW_PWM_PWMCR_WR(x, (HW_PWM_PWMCR_RD(x) & ~BM_PWM_PWMCR_FWM) | BF_PWM_PWMCR_FWM(v)))
/*@}*/

/*******************************************************************************
 * HW_PWM_PWMSR - PWM Status Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMSR - PWM Status Register (RW)
 *
 * Reset value: 0x00000008U
 *
 * The PWM status register (PWM_PWMSR) contains seven bits which display the
 * state of the FIFO and the occurrence of rollover and compare events. The FIFOAV
 * bit is read-only but the other four bits can be cleared by writing 1 to them.
 * The FE, ROV, and CMP bits are associated with FIFO-Empty, Roll-over, and
 * Compare interrupts, respectively.
 */
typedef union _hw_pwm_pwmsr
{
    uint32_t U;
    struct _hw_pwm_pwmsr_bitfields
    {
        uint32_t FIFOAV : 3;           /*!< [2:0]  */
        uint32_t FE : 1;               /*!< [3]  */
        uint32_t ROV : 1;              /*!< [4]  */
        uint32_t CMP : 1;              /*!< [5]  */
        uint32_t FWE : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 25;       /*!< [31:7]  */
    } B;
} hw_pwm_pwmsr_t;

/*!
 * @name Constants and macros for entire PWM_PWMSR register
 */
/*@{*/
#define HW_PWM_PWMSR_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_PWM_PWMSR(x)          (*(__IO hw_pwm_pwmsr_t *) HW_PWM_PWMSR_ADDR(x))
#define HW_PWM_PWMSR_RD(x)       (HW_PWM_PWMSR(x).U)
#define HW_PWM_PWMSR_WR(x, v)    (HW_PWM_PWMSR(x).U = (v))
#define HW_PWM_PWMSR_SET(x, v)   (HW_PWM_PWMSR_WR(x, HW_PWM_PWMSR_RD(x) |  (v)))
#define HW_PWM_PWMSR_CLR(x, v)   (HW_PWM_PWMSR_WR(x, HW_PWM_PWMSR_RD(x) & ~(v)))
#define HW_PWM_PWMSR_TOG(x, v)   (HW_PWM_PWMSR_WR(x, HW_PWM_PWMSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PWM_PWMSR bitfields
 */

/*!
 * @name Register PWM_PWMSR, field FIFOAV[2:0] (RO)
 *
 * FIFO Available. These read-only bits indicate the data level remaining in the
 * FIFO. An attempted write to these bits will not affect their value and no
 * transfer error is generated.
 *
 * Values:
 * - 000 - No data available
 * - 001 - 1 word of data in FIFO
 * - 010 - 2 words of data in FIFO
 * - 011 - 3 words of data in FIFO
 * - 100 - 4 words of data in FIFO
 * - 101 - unused
 * - 110 - unused
 * - 111 - unused
 */
/*@{*/
#define BP_PWM_PWMSR_FIFOAV  (0U)          /*!< Bit position for PWM_PWMSR_FIFOAV. */
#define BM_PWM_PWMSR_FIFOAV  (0x00000007U) /*!< Bit mask for PWM_PWMSR_FIFOAV. */
#define BS_PWM_PWMSR_FIFOAV  (3U)          /*!< Bit field size in bits for PWM_PWMSR_FIFOAV. */

/*! @brief Read current value of the PWM_PWMSR_FIFOAV field. */
#define BR_PWM_PWMSR_FIFOAV(x) (HW_PWM_PWMSR(x).B.FIFOAV)
/*@}*/

/*!
 * @name Register PWM_PWMSR, field FE[3] (W1C)
 *
 * FIFO Empty Status Bit. This bit indicates the FIFO data level in comparison
 * to the water level set by FWM field in the control register.
 *
 * Values:
 * - 0 - Data level is above water mark
 * - 1 - When the data level falls below the mark set by FWM field
 */
/*@{*/
#define BP_PWM_PWMSR_FE      (3U)          /*!< Bit position for PWM_PWMSR_FE. */
#define BM_PWM_PWMSR_FE      (0x00000008U) /*!< Bit mask for PWM_PWMSR_FE. */
#define BS_PWM_PWMSR_FE      (1U)          /*!< Bit field size in bits for PWM_PWMSR_FE. */

/*! @brief Read current value of the PWM_PWMSR_FE field. */
#define BR_PWM_PWMSR_FE(x)   (HW_PWM_PWMSR(x).B.FE)

/*! @brief Format value for bitfield PWM_PWMSR_FE. */
#define BF_PWM_PWMSR_FE(v)   ((uint32_t)((uint32_t)(v) << BP_PWM_PWMSR_FE) & BM_PWM_PWMSR_FE)

/*! @brief Set the FE field to a new value. */
#define BW_PWM_PWMSR_FE(x, v) (HW_PWM_PWMSR_WR(x, (HW_PWM_PWMSR_RD(x) & ~(BM_PWM_PWMSR_FE | BM_PWM_PWMSR_ROV | BM_PWM_PWMSR_CMP | BM_PWM_PWMSR_FWE)) | BF_PWM_PWMSR_FE(v)))
/*@}*/

/*!
 * @name Register PWM_PWMSR, field ROV[4] (W1C)
 *
 * Roll-over Status. This bit shows that a roll-over event has occurred.
 *
 * Values:
 * - 0 - Roll-over event not occurred
 * - 1 - Roll-over event occurred
 */
/*@{*/
#define BP_PWM_PWMSR_ROV     (4U)          /*!< Bit position for PWM_PWMSR_ROV. */
#define BM_PWM_PWMSR_ROV     (0x00000010U) /*!< Bit mask for PWM_PWMSR_ROV. */
#define BS_PWM_PWMSR_ROV     (1U)          /*!< Bit field size in bits for PWM_PWMSR_ROV. */

/*! @brief Read current value of the PWM_PWMSR_ROV field. */
#define BR_PWM_PWMSR_ROV(x)  (HW_PWM_PWMSR(x).B.ROV)

/*! @brief Format value for bitfield PWM_PWMSR_ROV. */
#define BF_PWM_PWMSR_ROV(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMSR_ROV) & BM_PWM_PWMSR_ROV)

/*! @brief Set the ROV field to a new value. */
#define BW_PWM_PWMSR_ROV(x, v) (HW_PWM_PWMSR_WR(x, (HW_PWM_PWMSR_RD(x) & ~(BM_PWM_PWMSR_ROV | BM_PWM_PWMSR_FE | BM_PWM_PWMSR_CMP | BM_PWM_PWMSR_FWE)) | BF_PWM_PWMSR_ROV(v)))
/*@}*/

/*!
 * @name Register PWM_PWMSR, field CMP[5] (W1C)
 *
 * Compare Status. This bit shows that a compare event has occurred.
 *
 * Values:
 * - 0 - Compare event not occurred
 * - 1 - Compare event occurred
 */
/*@{*/
#define BP_PWM_PWMSR_CMP     (5U)          /*!< Bit position for PWM_PWMSR_CMP. */
#define BM_PWM_PWMSR_CMP     (0x00000020U) /*!< Bit mask for PWM_PWMSR_CMP. */
#define BS_PWM_PWMSR_CMP     (1U)          /*!< Bit field size in bits for PWM_PWMSR_CMP. */

/*! @brief Read current value of the PWM_PWMSR_CMP field. */
#define BR_PWM_PWMSR_CMP(x)  (HW_PWM_PWMSR(x).B.CMP)

/*! @brief Format value for bitfield PWM_PWMSR_CMP. */
#define BF_PWM_PWMSR_CMP(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMSR_CMP) & BM_PWM_PWMSR_CMP)

/*! @brief Set the CMP field to a new value. */
#define BW_PWM_PWMSR_CMP(x, v) (HW_PWM_PWMSR_WR(x, (HW_PWM_PWMSR_RD(x) & ~(BM_PWM_PWMSR_CMP | BM_PWM_PWMSR_FE | BM_PWM_PWMSR_ROV | BM_PWM_PWMSR_FWE)) | BF_PWM_PWMSR_CMP(v)))
/*@}*/

/*!
 * @name Register PWM_PWMSR, field FWE[6] (W1C)
 *
 * FIFO Write Error Status. This bit shows that an attempt has been made to
 * write FIFO when it is full.
 *
 * Values:
 * - 0 - FIFO write error not occurred
 * - 1 - FIFO write error occurred
 */
/*@{*/
#define BP_PWM_PWMSR_FWE     (6U)          /*!< Bit position for PWM_PWMSR_FWE. */
#define BM_PWM_PWMSR_FWE     (0x00000040U) /*!< Bit mask for PWM_PWMSR_FWE. */
#define BS_PWM_PWMSR_FWE     (1U)          /*!< Bit field size in bits for PWM_PWMSR_FWE. */

/*! @brief Read current value of the PWM_PWMSR_FWE field. */
#define BR_PWM_PWMSR_FWE(x)  (HW_PWM_PWMSR(x).B.FWE)

/*! @brief Format value for bitfield PWM_PWMSR_FWE. */
#define BF_PWM_PWMSR_FWE(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMSR_FWE) & BM_PWM_PWMSR_FWE)

/*! @brief Set the FWE field to a new value. */
#define BW_PWM_PWMSR_FWE(x, v) (HW_PWM_PWMSR_WR(x, (HW_PWM_PWMSR_RD(x) & ~(BM_PWM_PWMSR_FWE | BM_PWM_PWMSR_FE | BM_PWM_PWMSR_ROV | BM_PWM_PWMSR_CMP)) | BF_PWM_PWMSR_FWE(v)))
/*@}*/

/*******************************************************************************
 * HW_PWM_PWMIR - PWM Interrupt Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMIR - PWM Interrupt Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PWM Interrupt register (PWM_PWMIR) contains three bits which control the
 * generation of the compare, rollover and FIFO empty interrupts.
 */
typedef union _hw_pwm_pwmir
{
    uint32_t U;
    struct _hw_pwm_pwmir_bitfields
    {
        uint32_t FIE : 1;              /*!< [0]  */
        uint32_t RIE : 1;              /*!< [1]  */
        uint32_t CIE : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_pwm_pwmir_t;

/*!
 * @name Constants and macros for entire PWM_PWMIR register
 */
/*@{*/
#define HW_PWM_PWMIR_ADDR(x)     ((uintptr_t)(x) + 0x8U)

#define HW_PWM_PWMIR(x)          (*(__IO hw_pwm_pwmir_t *) HW_PWM_PWMIR_ADDR(x))
#define HW_PWM_PWMIR_RD(x)       (HW_PWM_PWMIR(x).U)
#define HW_PWM_PWMIR_WR(x, v)    (HW_PWM_PWMIR(x).U = (v))
#define HW_PWM_PWMIR_SET(x, v)   (HW_PWM_PWMIR_WR(x, HW_PWM_PWMIR_RD(x) |  (v)))
#define HW_PWM_PWMIR_CLR(x, v)   (HW_PWM_PWMIR_WR(x, HW_PWM_PWMIR_RD(x) & ~(v)))
#define HW_PWM_PWMIR_TOG(x, v)   (HW_PWM_PWMIR_WR(x, HW_PWM_PWMIR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PWM_PWMIR bitfields
 */

/*!
 * @name Register PWM_PWMIR, field FIE[0] (RW)
 *
 * FIFO Empty Interrupt Enable. This bit controls the generation of the FIFO
 * Empty interrupt.
 *
 * Values:
 * - 0 - FIFO Empty interrupt disabled
 * - 1 - FIFO Empty interrupt enabled
 */
/*@{*/
#define BP_PWM_PWMIR_FIE     (0U)          /*!< Bit position for PWM_PWMIR_FIE. */
#define BM_PWM_PWMIR_FIE     (0x00000001U) /*!< Bit mask for PWM_PWMIR_FIE. */
#define BS_PWM_PWMIR_FIE     (1U)          /*!< Bit field size in bits for PWM_PWMIR_FIE. */

/*! @brief Read current value of the PWM_PWMIR_FIE field. */
#define BR_PWM_PWMIR_FIE(x)  (HW_PWM_PWMIR(x).B.FIE)

/*! @brief Format value for bitfield PWM_PWMIR_FIE. */
#define BF_PWM_PWMIR_FIE(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMIR_FIE) & BM_PWM_PWMIR_FIE)

/*! @brief Set the FIE field to a new value. */
#define BW_PWM_PWMIR_FIE(x, v) (HW_PWM_PWMIR_WR(x, (HW_PWM_PWMIR_RD(x) & ~BM_PWM_PWMIR_FIE) | BF_PWM_PWMIR_FIE(v)))
/*@}*/

/*!
 * @name Register PWM_PWMIR, field RIE[1] (RW)
 *
 * Roll-over Interrupt Enable. This bit controls the generation of the Rollover
 * interrupt.
 *
 * Values:
 * - 0 - Roll-over interrupt not enabled
 * - 1 - Roll-over Interrupt enabled
 */
/*@{*/
#define BP_PWM_PWMIR_RIE     (1U)          /*!< Bit position for PWM_PWMIR_RIE. */
#define BM_PWM_PWMIR_RIE     (0x00000002U) /*!< Bit mask for PWM_PWMIR_RIE. */
#define BS_PWM_PWMIR_RIE     (1U)          /*!< Bit field size in bits for PWM_PWMIR_RIE. */

/*! @brief Read current value of the PWM_PWMIR_RIE field. */
#define BR_PWM_PWMIR_RIE(x)  (HW_PWM_PWMIR(x).B.RIE)

/*! @brief Format value for bitfield PWM_PWMIR_RIE. */
#define BF_PWM_PWMIR_RIE(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMIR_RIE) & BM_PWM_PWMIR_RIE)

/*! @brief Set the RIE field to a new value. */
#define BW_PWM_PWMIR_RIE(x, v) (HW_PWM_PWMIR_WR(x, (HW_PWM_PWMIR_RD(x) & ~BM_PWM_PWMIR_RIE) | BF_PWM_PWMIR_RIE(v)))
/*@}*/

/*!
 * @name Register PWM_PWMIR, field CIE[2] (RW)
 *
 * Compare Interrupt Enable. This bit controls the generation of the Compare
 * interrupt.
 *
 * Values:
 * - 0 - Compare Interrupt not enabled
 * - 1 - Compare Interrupt enabled
 */
/*@{*/
#define BP_PWM_PWMIR_CIE     (2U)          /*!< Bit position for PWM_PWMIR_CIE. */
#define BM_PWM_PWMIR_CIE     (0x00000004U) /*!< Bit mask for PWM_PWMIR_CIE. */
#define BS_PWM_PWMIR_CIE     (1U)          /*!< Bit field size in bits for PWM_PWMIR_CIE. */

/*! @brief Read current value of the PWM_PWMIR_CIE field. */
#define BR_PWM_PWMIR_CIE(x)  (HW_PWM_PWMIR(x).B.CIE)

/*! @brief Format value for bitfield PWM_PWMIR_CIE. */
#define BF_PWM_PWMIR_CIE(v)  ((uint32_t)((uint32_t)(v) << BP_PWM_PWMIR_CIE) & BM_PWM_PWMIR_CIE)

/*! @brief Set the CIE field to a new value. */
#define BW_PWM_PWMIR_CIE(x, v) (HW_PWM_PWMIR_WR(x, (HW_PWM_PWMIR_RD(x) & ~BM_PWM_PWMIR_CIE) | BF_PWM_PWMIR_CIE(v)))
/*@}*/

/*******************************************************************************
 * HW_PWM_PWMSAR - PWM Sample Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMSAR - PWM Sample Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The PWM sample register (PWM_PWMSAR) is the input to the FIFO. 16-bit words
 * are loaded into the FIFO. The FIFO can be written at any time, but can be read
 * only when the PWM is enabled. The PWM will run at the last set duty-cycle
 * setting if all the values of the FIFO has been utilized, until the FIFO is
 * reloaded or the PWM is disabled. When a new value is written, the duty cycle changes
 * after the current period is over. A value of zero in the sample register will
 * result in the PWMO output signal always being low/high (POUTC = 00 it will be
 * low and POUTC = 01 it will be high), and no output waveform will be produced.
 * If the value in this register is higher than the PERIOD + 1, the output will
 * never be set/reset depending on POUTC value.
 */
typedef union _hw_pwm_pwmsar
{
    uint32_t U;
    struct _hw_pwm_pwmsar_bitfields
    {
        uint32_t SAMPLE : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_pwm_pwmsar_t;

/*!
 * @name Constants and macros for entire PWM_PWMSAR register
 */
/*@{*/
#define HW_PWM_PWMSAR_ADDR(x)    ((uintptr_t)(x) + 0xCU)

#define HW_PWM_PWMSAR(x)         (*(__IO hw_pwm_pwmsar_t *) HW_PWM_PWMSAR_ADDR(x))
#define HW_PWM_PWMSAR_RD(x)      (HW_PWM_PWMSAR(x).U)
#define HW_PWM_PWMSAR_WR(x, v)   (HW_PWM_PWMSAR(x).U = (v))
#define HW_PWM_PWMSAR_SET(x, v)  (HW_PWM_PWMSAR_WR(x, HW_PWM_PWMSAR_RD(x) |  (v)))
#define HW_PWM_PWMSAR_CLR(x, v)  (HW_PWM_PWMSAR_WR(x, HW_PWM_PWMSAR_RD(x) & ~(v)))
#define HW_PWM_PWMSAR_TOG(x, v)  (HW_PWM_PWMSAR_WR(x, HW_PWM_PWMSAR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PWM_PWMSAR bitfields
 */

/*!
 * @name Register PWM_PWMSAR, field SAMPLE[15:0] (RW)
 *
 * Sample Value. This is the input to the 4x16 FIFO. The value in this register
 * denotes the value of the sample being currently used.
 */
/*@{*/
#define BP_PWM_PWMSAR_SAMPLE (0U)          /*!< Bit position for PWM_PWMSAR_SAMPLE. */
#define BM_PWM_PWMSAR_SAMPLE (0x0000FFFFU) /*!< Bit mask for PWM_PWMSAR_SAMPLE. */
#define BS_PWM_PWMSAR_SAMPLE (16U)         /*!< Bit field size in bits for PWM_PWMSAR_SAMPLE. */

/*! @brief Read current value of the PWM_PWMSAR_SAMPLE field. */
#define BR_PWM_PWMSAR_SAMPLE(x) (HW_PWM_PWMSAR(x).B.SAMPLE)

/*! @brief Format value for bitfield PWM_PWMSAR_SAMPLE. */
#define BF_PWM_PWMSAR_SAMPLE(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMSAR_SAMPLE) & BM_PWM_PWMSAR_SAMPLE)

/*! @brief Set the SAMPLE field to a new value. */
#define BW_PWM_PWMSAR_SAMPLE(x, v) (HW_PWM_PWMSAR_WR(x, (HW_PWM_PWMSAR_RD(x) & ~BM_PWM_PWMSAR_SAMPLE) | BF_PWM_PWMSAR_SAMPLE(v)))
/*@}*/

/*******************************************************************************
 * HW_PWM_PWMPR - PWM Period Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMPR - PWM Period Register (RW)
 *
 * Reset value: 0x0000FFFEU
 *
 * The PWM period register (PWM_PWMPR) determines the period of the PWM output
 * signal. After the counter value matches PERIOD + 1, the counter is reset to
 * start another period. PWMO (Hz) = PCLK(Hz) / (period +2) A value of zero in the
 * PWM_PWMPR will result in a period of two clock cycles for the output signal.
 * Writing 0xFFFF to this register will achieve the same result as writing 0xFFFE.
 * A change in the period value due to a write in PWM_PWMPR results in the
 * counter being reset to zero and the start of a new count period. Settings PWM_PWMPR
 * to 0xFFFF when PWMx_PWMCR REPEAT bits are set to non-zero values is not
 * allowed.
 */
typedef union _hw_pwm_pwmpr
{
    uint32_t U;
    struct _hw_pwm_pwmpr_bitfields
    {
        uint32_t PERIOD : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_pwm_pwmpr_t;

/*!
 * @name Constants and macros for entire PWM_PWMPR register
 */
/*@{*/
#define HW_PWM_PWMPR_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_PWM_PWMPR(x)          (*(__IO hw_pwm_pwmpr_t *) HW_PWM_PWMPR_ADDR(x))
#define HW_PWM_PWMPR_RD(x)       (HW_PWM_PWMPR(x).U)
#define HW_PWM_PWMPR_WR(x, v)    (HW_PWM_PWMPR(x).U = (v))
#define HW_PWM_PWMPR_SET(x, v)   (HW_PWM_PWMPR_WR(x, HW_PWM_PWMPR_RD(x) |  (v)))
#define HW_PWM_PWMPR_CLR(x, v)   (HW_PWM_PWMPR_WR(x, HW_PWM_PWMPR_RD(x) & ~(v)))
#define HW_PWM_PWMPR_TOG(x, v)   (HW_PWM_PWMPR_WR(x, HW_PWM_PWMPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual PWM_PWMPR bitfields
 */

/*!
 * @name Register PWM_PWMPR, field PERIOD[15:0] (RW)
 *
 * Period Value. These bits determine the Period of the count cycle. The counter
 * counts up to [Period Value] +1 and is then reset to 0x0000.
 */
/*@{*/
#define BP_PWM_PWMPR_PERIOD  (0U)          /*!< Bit position for PWM_PWMPR_PERIOD. */
#define BM_PWM_PWMPR_PERIOD  (0x0000FFFFU) /*!< Bit mask for PWM_PWMPR_PERIOD. */
#define BS_PWM_PWMPR_PERIOD  (16U)         /*!< Bit field size in bits for PWM_PWMPR_PERIOD. */

/*! @brief Read current value of the PWM_PWMPR_PERIOD field. */
#define BR_PWM_PWMPR_PERIOD(x) (HW_PWM_PWMPR(x).B.PERIOD)

/*! @brief Format value for bitfield PWM_PWMPR_PERIOD. */
#define BF_PWM_PWMPR_PERIOD(v) ((uint32_t)((uint32_t)(v) << BP_PWM_PWMPR_PERIOD) & BM_PWM_PWMPR_PERIOD)

/*! @brief Set the PERIOD field to a new value. */
#define BW_PWM_PWMPR_PERIOD(x, v) (HW_PWM_PWMPR_WR(x, (HW_PWM_PWMPR_RD(x) & ~BM_PWM_PWMPR_PERIOD) | BF_PWM_PWMPR_PERIOD(v)))
/*@}*/

/*******************************************************************************
 * HW_PWM_PWMCNR - PWM Counter Register
 ******************************************************************************/

/*!
 * @brief HW_PWM_PWMCNR - PWM Counter Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The read-only pulse-width modulator counter register (PWM_PWMCNR) contains
 * the current count value and can be read at any time without disturbing the
 * counter.
 */
typedef union _hw_pwm_pwmcnr
{
    uint32_t U;
    struct _hw_pwm_pwmcnr_bitfields
    {
        uint32_t COUNT : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_pwm_pwmcnr_t;

/*!
 * @name Constants and macros for entire PWM_PWMCNR register
 */
/*@{*/
#define HW_PWM_PWMCNR_ADDR(x)    ((uintptr_t)(x) + 0x14U)

#define HW_PWM_PWMCNR(x)         (*(__I hw_pwm_pwmcnr_t *) HW_PWM_PWMCNR_ADDR(x))
#define HW_PWM_PWMCNR_RD(x)      (HW_PWM_PWMCNR(x).U)
/*@}*/

/*
 * Constants & macros for individual PWM_PWMCNR bitfields
 */

/*!
 * @name Register PWM_PWMCNR, field COUNT[15:0] (RO)
 *
 * Counter Value. These bits are the counter register value and denotes the
 * current count state the counter register is in.
 */
/*@{*/
#define BP_PWM_PWMCNR_COUNT  (0U)          /*!< Bit position for PWM_PWMCNR_COUNT. */
#define BM_PWM_PWMCNR_COUNT  (0x0000FFFFU) /*!< Bit mask for PWM_PWMCNR_COUNT. */
#define BS_PWM_PWMCNR_COUNT  (16U)         /*!< Bit field size in bits for PWM_PWMCNR_COUNT. */

/*! @brief Read current value of the PWM_PWMCNR_COUNT field. */
#define BR_PWM_PWMCNR_COUNT(x) (HW_PWM_PWMCNR(x).B.COUNT)
/*@}*/

/*******************************************************************************
 * hw_pwm_t - module struct
 ******************************************************************************/
/*!
 * @brief All PWM module registers.
 */
#pragma pack(1)
typedef struct _hw_pwm
{
    __IO hw_pwm_pwmcr_t PWMCR;             /*!< [0x0] PWM Control Register */
    __IO hw_pwm_pwmsr_t PWMSR;             /*!< [0x4] PWM Status Register */
    __IO hw_pwm_pwmir_t PWMIR;             /*!< [0x8] PWM Interrupt Register */
    __IO hw_pwm_pwmsar_t PWMSAR;           /*!< [0xC] PWM Sample Register */
    __IO hw_pwm_pwmpr_t PWMPR;             /*!< [0x10] PWM Period Register */
    __I hw_pwm_pwmcnr_t PWMCNR;            /*!< [0x14] PWM Counter Register */
} hw_pwm_t;
#pragma pack()

/*! @brief Macro to access all PWM registers. */
/*! @param x PWM module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_PWM_REGS(PWM1_BASE)</code>. */
#define HW_PWM_REGS(x) (*(hw_pwm_t *)(x))

/*
 * iMX6DP ROMC
 *
 * ROMC
 *
 * Registers defined in this header file:
 * - HW_ROMC_ROMPATCHnD - ROMC Data Registers
 * - HW_ROMC_ROMPATCHCNTL - ROMC Control Register
 * - HW_ROMC_ROMPATCHENH - ROMC Enable Register High
 * - HW_ROMC_ROMPATCHENL - ROMC Enable Register Low
 * - HW_ROMC_ROMPATCHnA - ROMC Address Registers
 * - HW_ROMC_ROMPATCHSR - ROMC Status Register
 *
 * - hw_romc_t - Struct containing all module registers.
 */

#define HW_ROMC_INSTANCE_COUNT (1U) /*!< Number of instances of the ROMC module. */
#define HW_ROMC (0U) /*!< Instance number for ROMC. */
#define ROMC_BASE             (0x21AC000U) /*!< Base address for ROMC. */
/*! Array initializer of ROMC base addresses. */
#define ROMC_BASE_ADDRS       { ROMC_BASE }

/*******************************************************************************
 * HW_ROMC_ROMPATCHnD - ROMC Data Registers
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHnD - ROMC Data Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ROMC data registers (ROMC_ROMPATCH7D through ROMC_ROMPATCH0D) store the
 * data to use for the 8 1-word data fix events. Each register is associated with
 * an address comparator (7 through 0). When a data fixing event occurs, the
 * value in the data register corresponding to the comparator that has the address
 * match is put on the romc_hrdata[31:0] bus until romc_hready is asserted by the
 * ROM controller to terminate the access. A MUX external to the ROMC will select
 * this data over that of romc_hrdata[31:0] in returning read data to the ARM
 * core. The selection is done with the control bus rompatch_romc_hrdata_ovr[1:0]
 * with both bits asserted by the ROMC. If more than one address comparators match,
 * the highest-numbered one takes precedence, and the value in corresponding
 * data register is used for the patching event.
 */
typedef union _hw_romc_rompatchnd
{
    uint32_t U;
    struct _hw_romc_rompatchnd_bitfields
    {
        uint32_t DATAX : 32;           /*!< [31:0]  */
    } B;
} hw_romc_rompatchnd_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHnD register
 */
/*@{*/
#define HW_ROMC_ROMPATCHnD_COUNT (8U)

#define HW_ROMC_ROMPATCHnD_ADDR(x, n) ((uintptr_t)(x) + 0xD4U + (0x4U * (n)))

#define HW_ROMC_ROMPATCHnD(x, n) (*(__IO hw_romc_rompatchnd_t *) HW_ROMC_ROMPATCHnD_ADDR(x, n))
#define HW_ROMC_ROMPATCHnD_RD(x, n) (HW_ROMC_ROMPATCHnD(x, n).U)
#define HW_ROMC_ROMPATCHnD_WR(x, n, v) (HW_ROMC_ROMPATCHnD(x, n).U = (v))
#define HW_ROMC_ROMPATCHnD_SET(x, n, v) (HW_ROMC_ROMPATCHnD_WR(x, n, HW_ROMC_ROMPATCHnD_RD(x, n) |  (v)))
#define HW_ROMC_ROMPATCHnD_CLR(x, n, v) (HW_ROMC_ROMPATCHnD_WR(x, n, HW_ROMC_ROMPATCHnD_RD(x, n) & ~(v)))
#define HW_ROMC_ROMPATCHnD_TOG(x, n, v) (HW_ROMC_ROMPATCHnD_WR(x, n, HW_ROMC_ROMPATCHnD_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHnD bitfields
 */

/*!
 * @name Register ROMC_ROMPATCHnD, field DATAX[31:0] (RW)
 *
 * Data Fix Registers - Stores the data used for 1-word data fix operations. The
 * values stored within these registers do not affect the writes to the memory
 * system. They are selected over the read data from ROM when a data fix event
 * occurs. If any part of the 1-word data fix is read, then the entire word is
 * replaced. Therefore, a byte or half-word read will cause the ROMC to replace the
 * entire word. The word is word address aligned.
 */
/*@{*/
#define BP_ROMC_ROMPATCHnD_DATAX (0U)      /*!< Bit position for ROMC_ROMPATCHnD_DATAX. */
#define BM_ROMC_ROMPATCHnD_DATAX (0xFFFFFFFFU) /*!< Bit mask for ROMC_ROMPATCHnD_DATAX. */
#define BS_ROMC_ROMPATCHnD_DATAX (32U)     /*!< Bit field size in bits for ROMC_ROMPATCHnD_DATAX. */

/*! @brief Read current value of the ROMC_ROMPATCHnD_DATAX field. */
#define BR_ROMC_ROMPATCHnD_DATAX(x, n) (HW_ROMC_ROMPATCHnD(x, n).U)

/*! @brief Format value for bitfield ROMC_ROMPATCHnD_DATAX. */
#define BF_ROMC_ROMPATCHnD_DATAX(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHnD_DATAX) & BM_ROMC_ROMPATCHnD_DATAX)

/*! @brief Set the DATAX field to a new value. */
#define BW_ROMC_ROMPATCHnD_DATAX(x, n, v) (HW_ROMC_ROMPATCHnD_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_ROMC_ROMPATCHCNTL - ROMC Control Register
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHCNTL - ROMC Control Register (RW)
 *
 * Reset value: 0x08400000U
 *
 * The ROMC control register (ROMC_ROMPATCHCNTL) contains the block disable bit
 * and the data fix enable bits. The block disable bit provides a means to
 * disable the ROMC data fix and opcode patching functions, even when the address
 * comparators are enabled. The External Boot feature is not affected by this bit. The
 * eight data fix enable bits (0 through 7), when set, assign the associated
 * address comparators to data fix operations Bits 27 and 22 always read as 1s.
 */
typedef union _hw_romc_rompatchcntl
{
    uint32_t U;
    struct _hw_romc_rompatchcntl_bitfields
    {
        uint32_t DATAFIX : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 21;       /*!< [28:8]  */
        uint32_t DIS : 1;              /*!< [29]  */
        uint32_t RESERVED1 : 2;        /*!< [31:30]  */
    } B;
} hw_romc_rompatchcntl_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHCNTL register
 */
/*@{*/
#define HW_ROMC_ROMPATCHCNTL_ADDR(x) ((uintptr_t)(x) + 0xF4U)

#define HW_ROMC_ROMPATCHCNTL(x)  (*(__IO hw_romc_rompatchcntl_t *) HW_ROMC_ROMPATCHCNTL_ADDR(x))
#define HW_ROMC_ROMPATCHCNTL_RD(x) (HW_ROMC_ROMPATCHCNTL(x).U)
#define HW_ROMC_ROMPATCHCNTL_WR(x, v) (HW_ROMC_ROMPATCHCNTL(x).U = (v))
#define HW_ROMC_ROMPATCHCNTL_SET(x, v) (HW_ROMC_ROMPATCHCNTL_WR(x, HW_ROMC_ROMPATCHCNTL_RD(x) |  (v)))
#define HW_ROMC_ROMPATCHCNTL_CLR(x, v) (HW_ROMC_ROMPATCHCNTL_WR(x, HW_ROMC_ROMPATCHCNTL_RD(x) & ~(v)))
#define HW_ROMC_ROMPATCHCNTL_TOG(x, v) (HW_ROMC_ROMPATCHCNTL_WR(x, HW_ROMC_ROMPATCHCNTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHCNTL bitfields
 */

/*!
 * @name Register ROMC_ROMPATCHCNTL, field DATAFIX[7:0] (RW)
 *
 * Data Fix Enable - Controls the use of the first 8 address comparators for
 * 1-word data fix or for code patch routine.
 *
 * Values:
 * - 0 - Address comparator triggers a opcode patch
 * - 1 - Address comparator triggers a data fix
 */
/*@{*/
#define BP_ROMC_ROMPATCHCNTL_DATAFIX (0U)  /*!< Bit position for ROMC_ROMPATCHCNTL_DATAFIX. */
#define BM_ROMC_ROMPATCHCNTL_DATAFIX (0x000000FFU) /*!< Bit mask for ROMC_ROMPATCHCNTL_DATAFIX. */
#define BS_ROMC_ROMPATCHCNTL_DATAFIX (8U)  /*!< Bit field size in bits for ROMC_ROMPATCHCNTL_DATAFIX. */

/*! @brief Read current value of the ROMC_ROMPATCHCNTL_DATAFIX field. */
#define BR_ROMC_ROMPATCHCNTL_DATAFIX(x) (HW_ROMC_ROMPATCHCNTL(x).B.DATAFIX)

/*! @brief Format value for bitfield ROMC_ROMPATCHCNTL_DATAFIX. */
#define BF_ROMC_ROMPATCHCNTL_DATAFIX(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHCNTL_DATAFIX) & BM_ROMC_ROMPATCHCNTL_DATAFIX)

/*! @brief Set the DATAFIX field to a new value. */
#define BW_ROMC_ROMPATCHCNTL_DATAFIX(x, v) (HW_ROMC_ROMPATCHCNTL_WR(x, (HW_ROMC_ROMPATCHCNTL_RD(x) & ~BM_ROMC_ROMPATCHCNTL_DATAFIX) | BF_ROMC_ROMPATCHCNTL_DATAFIX(v)))
/*@}*/

/*!
 * @name Register ROMC_ROMPATCHCNTL, field DIS[29] (RW)
 *
 * ROMC Disable -- This bit, when set, disables all ROMC operations. This bit is
 * used to enable secure operations.
 *
 * Values:
 * - 0 - Does not affect any ROMC functions (default)
 * - 1 - Disable all ROMC functions: data fixing, and opcode patching
 */
/*@{*/
#define BP_ROMC_ROMPATCHCNTL_DIS (29U)     /*!< Bit position for ROMC_ROMPATCHCNTL_DIS. */
#define BM_ROMC_ROMPATCHCNTL_DIS (0x20000000U) /*!< Bit mask for ROMC_ROMPATCHCNTL_DIS. */
#define BS_ROMC_ROMPATCHCNTL_DIS (1U)      /*!< Bit field size in bits for ROMC_ROMPATCHCNTL_DIS. */

/*! @brief Read current value of the ROMC_ROMPATCHCNTL_DIS field. */
#define BR_ROMC_ROMPATCHCNTL_DIS(x) (HW_ROMC_ROMPATCHCNTL(x).B.DIS)

/*! @brief Format value for bitfield ROMC_ROMPATCHCNTL_DIS. */
#define BF_ROMC_ROMPATCHCNTL_DIS(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHCNTL_DIS) & BM_ROMC_ROMPATCHCNTL_DIS)

/*! @brief Set the DIS field to a new value. */
#define BW_ROMC_ROMPATCHCNTL_DIS(x, v) (HW_ROMC_ROMPATCHCNTL_WR(x, (HW_ROMC_ROMPATCHCNTL_RD(x) & ~BM_ROMC_ROMPATCHCNTL_DIS) | BF_ROMC_ROMPATCHCNTL_DIS(v)))
/*@}*/

/*******************************************************************************
 * HW_ROMC_ROMPATCHENH - ROMC Enable Register High
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHENH - ROMC Enable Register High (RU)
 *
 * Reset value: 0x00000000U
 *
 * The ROMC enable register high (ROMC_ROMPATCHENH) and ROMC enable register low
 * (ROMC_ROMPATCHENL) control whether or not the associated address comparator
 * can trigger a opcode patch or data fix event. This implementation of the ROMC
 * only has 16 comparators, therefore ROMC_ROMPATCHENH and the upper half of
 * ROMC_OMPATCHENL are read-only. ROMC_ROMPATCHENL[15:0] are associated with
 * comparators 15 through 0. ROMC_ROMPATCHENLH[31:0] would have been associated with
 * comparators 63 through 32.
 */
typedef union _hw_romc_rompatchenh
{
    uint32_t U;
    struct _hw_romc_rompatchenh_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_romc_rompatchenh_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHENH register
 */
/*@{*/
#define HW_ROMC_ROMPATCHENH_ADDR(x) ((uintptr_t)(x) + 0xF8U)
#define HW_ROMC_ROMPATCHENH(x)   (*(__I hw_romc_rompatchenh_t *) HW_ROMC_ROMPATCHENH_ADDR(x))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHENH bitfields
 */

/*******************************************************************************
 * HW_ROMC_ROMPATCHENL - ROMC Enable Register Low
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHENL - ROMC Enable Register Low (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ROMC enable register high (ROMC_ROMPATCHENH) and ROMC enable register low
 * (ROMC_ROMPATCHENL) control whether or not the associated address comparator
 * can trigger a opcode patch or data fix event. This implementation of the ROMC
 * only has 16 comparators, therefore ROMC_ROMPATCHENH and the upper half of
 * ROMC_ROMPATCHENL are read-only. ROMC_ROMPATCHENL[15:0] are associated with
 * comparators 15 through 0. ROMC_ROMPATCHENLH[31:0] would have been associated with
 * comparators 63 through 32.
 */
typedef union _hw_romc_rompatchenl
{
    uint32_t U;
    struct _hw_romc_rompatchenl_bitfields
    {
        uint32_t ENABLE : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_romc_rompatchenl_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHENL register
 */
/*@{*/
#define HW_ROMC_ROMPATCHENL_ADDR(x) ((uintptr_t)(x) + 0xFCU)

#define HW_ROMC_ROMPATCHENL(x)   (*(__IO hw_romc_rompatchenl_t *) HW_ROMC_ROMPATCHENL_ADDR(x))
#define HW_ROMC_ROMPATCHENL_RD(x) (HW_ROMC_ROMPATCHENL(x).U)
#define HW_ROMC_ROMPATCHENL_WR(x, v) (HW_ROMC_ROMPATCHENL(x).U = (v))
#define HW_ROMC_ROMPATCHENL_SET(x, v) (HW_ROMC_ROMPATCHENL_WR(x, HW_ROMC_ROMPATCHENL_RD(x) |  (v)))
#define HW_ROMC_ROMPATCHENL_CLR(x, v) (HW_ROMC_ROMPATCHENL_WR(x, HW_ROMC_ROMPATCHENL_RD(x) & ~(v)))
#define HW_ROMC_ROMPATCHENL_TOG(x, v) (HW_ROMC_ROMPATCHENL_WR(x, HW_ROMC_ROMPATCHENL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHENL bitfields
 */

/*!
 * @name Register ROMC_ROMPATCHENL, field ENABLE[15:0] (RW)
 *
 * Enable Address Comparator - This bit enables the corresponding address
 * comparator to trigger an event.
 *
 * Values:
 * - 0 - Address comparator disabled
 * - 1 - Address comparator enabled, ROMC will trigger a opcode patch or data
 *     fix event upon matching of the associated address
 */
/*@{*/
#define BP_ROMC_ROMPATCHENL_ENABLE (0U)    /*!< Bit position for ROMC_ROMPATCHENL_ENABLE. */
#define BM_ROMC_ROMPATCHENL_ENABLE (0x0000FFFFU) /*!< Bit mask for ROMC_ROMPATCHENL_ENABLE. */
#define BS_ROMC_ROMPATCHENL_ENABLE (16U)   /*!< Bit field size in bits for ROMC_ROMPATCHENL_ENABLE. */

/*! @brief Read current value of the ROMC_ROMPATCHENL_ENABLE field. */
#define BR_ROMC_ROMPATCHENL_ENABLE(x) (HW_ROMC_ROMPATCHENL(x).B.ENABLE)

/*! @brief Format value for bitfield ROMC_ROMPATCHENL_ENABLE. */
#define BF_ROMC_ROMPATCHENL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHENL_ENABLE) & BM_ROMC_ROMPATCHENL_ENABLE)

/*! @brief Set the ENABLE field to a new value. */
#define BW_ROMC_ROMPATCHENL_ENABLE(x, v) (HW_ROMC_ROMPATCHENL_WR(x, (HW_ROMC_ROMPATCHENL_RD(x) & ~BM_ROMC_ROMPATCHENL_ENABLE) | BF_ROMC_ROMPATCHENL_ENABLE(v)))
/*@}*/

/*******************************************************************************
 * HW_ROMC_ROMPATCHnA - ROMC Address Registers
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHnA - ROMC Address Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ROMC address registers (ROMC_ROMPATCHA0 through ROMC_ROMPATCHA15) store
 * the memory addresses where opcode patching begins and data fixing occurs. The
 * address registers ROMC_ROMPATCHA0 through ROMC_ROMPATCHA15 are each 21 bits
 * wide and dedicated to one 4 Mbyte memory space. Bits 21 through 2 are address
 * bits, to be compared with romc_haddr[21:2] for a match; bit 1 is also an address
 * bit used for half word selection. Bit 0 is the mode bit (set to 1 for THUMB
 * mode). 1-word data fixing can only be used on the first 8 of the address
 * comparators. ROMC_ROMPATCHA0 through ROMC_ROMPATCHA15 are associated each with
 * address comparators 0 through 15.
 */
typedef union _hw_romc_rompatchna
{
    uint32_t U;
    struct _hw_romc_rompatchna_bitfields
    {
        uint32_t THUMBX : 1;           /*!< [0]  */
        uint32_t ADDRX : 22;           /*!< [22:1]  */
        uint32_t RESERVED0 : 9;        /*!< [31:23]  */
    } B;
} hw_romc_rompatchna_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHnA register
 */
/*@{*/
#define HW_ROMC_ROMPATCHnA_COUNT (16U)

#define HW_ROMC_ROMPATCHnA_ADDR(x, n) ((uintptr_t)(x) + 0x100U + (0x4U * (n)))

#define HW_ROMC_ROMPATCHnA(x, n) (*(__IO hw_romc_rompatchna_t *) HW_ROMC_ROMPATCHnA_ADDR(x, n))
#define HW_ROMC_ROMPATCHnA_RD(x, n) (HW_ROMC_ROMPATCHnA(x, n).U)
#define HW_ROMC_ROMPATCHnA_WR(x, n, v) (HW_ROMC_ROMPATCHnA(x, n).U = (v))
#define HW_ROMC_ROMPATCHnA_SET(x, n, v) (HW_ROMC_ROMPATCHnA_WR(x, n, HW_ROMC_ROMPATCHnA_RD(x, n) |  (v)))
#define HW_ROMC_ROMPATCHnA_CLR(x, n, v) (HW_ROMC_ROMPATCHnA_WR(x, n, HW_ROMC_ROMPATCHnA_RD(x, n) & ~(v)))
#define HW_ROMC_ROMPATCHnA_TOG(x, n, v) (HW_ROMC_ROMPATCHnA_WR(x, n, HW_ROMC_ROMPATCHnA_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHnA bitfields
 */

/*!
 * @name Register ROMC_ROMPATCHnA, field THUMBX[0] (RW)
 *
 * THUMB Comparator Select - Indicates that this address will trigger a THUMB
 * opcode patch or an ARM opcode patch. If this watchpoint is selected to be a data
 * fix, then this bit is ignored as all data fixes are 1-word data fixes.
 *
 * Values:
 * - 0 - ARM patch
 * - 1 - THUMB patch (ignore if data fix)
 */
/*@{*/
#define BP_ROMC_ROMPATCHnA_THUMBX (0U)     /*!< Bit position for ROMC_ROMPATCHnA_THUMBX. */
#define BM_ROMC_ROMPATCHnA_THUMBX (0x00000001U) /*!< Bit mask for ROMC_ROMPATCHnA_THUMBX. */
#define BS_ROMC_ROMPATCHnA_THUMBX (1U)     /*!< Bit field size in bits for ROMC_ROMPATCHnA_THUMBX. */

/*! @brief Read current value of the ROMC_ROMPATCHnA_THUMBX field. */
#define BR_ROMC_ROMPATCHnA_THUMBX(x, n) (HW_ROMC_ROMPATCHnA(x, n).B.THUMBX)

/*! @brief Format value for bitfield ROMC_ROMPATCHnA_THUMBX. */
#define BF_ROMC_ROMPATCHnA_THUMBX(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHnA_THUMBX) & BM_ROMC_ROMPATCHnA_THUMBX)

/*! @brief Set the THUMBX field to a new value. */
#define BW_ROMC_ROMPATCHnA_THUMBX(x, n, v) (HW_ROMC_ROMPATCHnA_WR(x, n, (HW_ROMC_ROMPATCHnA_RD(x, n) & ~BM_ROMC_ROMPATCHnA_THUMBX) | BF_ROMC_ROMPATCHnA_THUMBX(v)))
/*@}*/

/*!
 * @name Register ROMC_ROMPATCHnA, field ADDRX[22:1] (RW)
 *
 * Address Comparator Registers - Indicates the memory address to be watched.
 * All 16 registers can be used for code patch address comparison. Only the first 8
 * registers can be used for a 1-word data fix address comparison. Bit 1 is
 * ignored if data fix. Only used in code patch
 */
/*@{*/
#define BP_ROMC_ROMPATCHnA_ADDRX (1U)      /*!< Bit position for ROMC_ROMPATCHnA_ADDRX. */
#define BM_ROMC_ROMPATCHnA_ADDRX (0x007FFFFEU) /*!< Bit mask for ROMC_ROMPATCHnA_ADDRX. */
#define BS_ROMC_ROMPATCHnA_ADDRX (22U)     /*!< Bit field size in bits for ROMC_ROMPATCHnA_ADDRX. */

/*! @brief Read current value of the ROMC_ROMPATCHnA_ADDRX field. */
#define BR_ROMC_ROMPATCHnA_ADDRX(x, n) (HW_ROMC_ROMPATCHnA(x, n).B.ADDRX)

/*! @brief Format value for bitfield ROMC_ROMPATCHnA_ADDRX. */
#define BF_ROMC_ROMPATCHnA_ADDRX(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHnA_ADDRX) & BM_ROMC_ROMPATCHnA_ADDRX)

/*! @brief Set the ADDRX field to a new value. */
#define BW_ROMC_ROMPATCHnA_ADDRX(x, n, v) (HW_ROMC_ROMPATCHnA_WR(x, n, (HW_ROMC_ROMPATCHnA_RD(x, n) & ~BM_ROMC_ROMPATCHnA_ADDRX) | BF_ROMC_ROMPATCHnA_ADDRX(v)))
/*@}*/

/*******************************************************************************
 * HW_ROMC_ROMPATCHSR - ROMC Status Register
 ******************************************************************************/

/*!
 * @brief HW_ROMC_ROMPATCHSR - ROMC Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ROMC status register (ROMC_ROMPATCHSR) indicates the current state of the
 * ROMC and the source number of the most recent address comparator event.
 */
typedef union _hw_romc_rompatchsr
{
    uint32_t U;
    struct _hw_romc_rompatchsr_bitfields
    {
        uint32_t SOURCE : 6;           /*!< [5:0]  */
        uint32_t RESERVED0 : 11;       /*!< [16:6]  */
        uint32_t SW : 1;               /*!< [17]  */
        uint32_t RESERVED1 : 14;       /*!< [31:18]  */
    } B;
} hw_romc_rompatchsr_t;

/*!
 * @name Constants and macros for entire ROMC_ROMPATCHSR register
 */
/*@{*/
#define HW_ROMC_ROMPATCHSR_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_ROMC_ROMPATCHSR(x)    (*(__IO hw_romc_rompatchsr_t *) HW_ROMC_ROMPATCHSR_ADDR(x))
#define HW_ROMC_ROMPATCHSR_RD(x) (HW_ROMC_ROMPATCHSR(x).U)
#define HW_ROMC_ROMPATCHSR_WR(x, v) (HW_ROMC_ROMPATCHSR(x).U = (v))
#define HW_ROMC_ROMPATCHSR_SET(x, v) (HW_ROMC_ROMPATCHSR_WR(x, HW_ROMC_ROMPATCHSR_RD(x) |  (v)))
#define HW_ROMC_ROMPATCHSR_CLR(x, v) (HW_ROMC_ROMPATCHSR_WR(x, HW_ROMC_ROMPATCHSR_RD(x) & ~(v)))
#define HW_ROMC_ROMPATCHSR_TOG(x, v) (HW_ROMC_ROMPATCHSR_WR(x, HW_ROMC_ROMPATCHSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual ROMC_ROMPATCHSR bitfields
 */

/*!
 * @name Register ROMC_ROMPATCHSR, field SOURCE[5:0] (RO)
 *
 * ROMC Source Number - Binary encoding of the number of the address comparator
 * which has an address match in the most recent patch event on ROMC AHB. If
 * multiple matches occurred, the highest priority source number is used.
 *
 * Values:
 * - 0 - Address Comparator 0 matched
 * - 1 - Address Comparator 1 matched
 */
/*@{*/
#define BP_ROMC_ROMPATCHSR_SOURCE (0U)     /*!< Bit position for ROMC_ROMPATCHSR_SOURCE. */
#define BM_ROMC_ROMPATCHSR_SOURCE (0x0000003FU) /*!< Bit mask for ROMC_ROMPATCHSR_SOURCE. */
#define BS_ROMC_ROMPATCHSR_SOURCE (6U)     /*!< Bit field size in bits for ROMC_ROMPATCHSR_SOURCE. */

/*! @brief Read current value of the ROMC_ROMPATCHSR_SOURCE field. */
#define BR_ROMC_ROMPATCHSR_SOURCE(x) (HW_ROMC_ROMPATCHSR(x).B.SOURCE)
/*@}*/

/*!
 * @name Register ROMC_ROMPATCHSR, field SW[17] (W1C)
 *
 * ROMC AHB Multiple Address Comparator matches Indicator - Indicates that
 * multiple address comparator matches occurred. Writing a 1 to this bit will clear
 * this it.
 *
 * Values:
 * - 0 - no event or comparator collisions
 * - 1 - a collision has occurred
 */
/*@{*/
#define BP_ROMC_ROMPATCHSR_SW (17U)        /*!< Bit position for ROMC_ROMPATCHSR_SW. */
#define BM_ROMC_ROMPATCHSR_SW (0x00020000U) /*!< Bit mask for ROMC_ROMPATCHSR_SW. */
#define BS_ROMC_ROMPATCHSR_SW (1U)         /*!< Bit field size in bits for ROMC_ROMPATCHSR_SW. */

/*! @brief Read current value of the ROMC_ROMPATCHSR_SW field. */
#define BR_ROMC_ROMPATCHSR_SW(x) (HW_ROMC_ROMPATCHSR(x).B.SW)

/*! @brief Format value for bitfield ROMC_ROMPATCHSR_SW. */
#define BF_ROMC_ROMPATCHSR_SW(v) ((uint32_t)((uint32_t)(v) << BP_ROMC_ROMPATCHSR_SW) & BM_ROMC_ROMPATCHSR_SW)

/*! @brief Set the SW field to a new value. */
#define BW_ROMC_ROMPATCHSR_SW(x, v) (HW_ROMC_ROMPATCHSR_WR(x, (HW_ROMC_ROMPATCHSR_RD(x) & ~BM_ROMC_ROMPATCHSR_SW) | BF_ROMC_ROMPATCHSR_SW(v)))
/*@}*/

/*******************************************************************************
 * hw_romc_t - module struct
 ******************************************************************************/
/*!
 * @brief All ROMC module registers.
 */
#pragma pack(1)
typedef struct _hw_romc
{
    uint8_t _reserved0[212];
    __IO hw_romc_rompatchnd_t ROMPATCHnD[8]; /*!< [0xD4] ROMC Data Registers */
    __IO hw_romc_rompatchcntl_t ROMPATCHCNTL; /*!< [0xF4] ROMC Control Register */
    __I hw_romc_rompatchenh_t ROMPATCHENH; /*!< [0xF8] ROMC Enable Register High */
    __IO hw_romc_rompatchenl_t ROMPATCHENL; /*!< [0xFC] ROMC Enable Register Low */
    __IO hw_romc_rompatchna_t ROMPATCHnA[16]; /*!< [0x100] ROMC Address Registers */
    uint8_t _reserved1[200];
    __IO hw_romc_rompatchsr_t ROMPATCHSR;  /*!< [0x208] ROMC Status Register */
} hw_romc_t;
#pragma pack()

/*! @brief Macro to access all ROMC registers. */
/*! @param x ROMC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_ROMC_REGS(ROMC_BASE)</code>. */
#define HW_ROMC_REGS(x) (*(hw_romc_t *)(x))

/*
 * iMX6DP SATA
 *
 * SATA
 *
 * Registers defined in this header file:
 * - HW_SATA_CAP - HBA Capabilites Register
 * - HW_SATA_GHC - Global HBA Control Register
 * - HW_SATA_IS - Interrupt Status Register
 * - HW_SATA_PI - Ports Implemented Register
 * - HW_SATA_VS - AHCl Version Register
 * - HW_SATA_CCC_CTL - Command Completion Coalescing Control
 * - HW_SATA_CCC_PORTS - Command Completion Coalescing Ports
 * - HW_SATA_CAP2 - HBA Capabilities Extended Register
 * - HW_SATA_BISTAFR - BIST Activate FIS Register
 * - HW_SATA_BISTCR - BIST Control Register
 * - HW_SATA_BISTFCTR - BIST FIS Count Register
 * - HW_SATA_BISTSR - BIST Status Register
 * - HW_SATA_OOBR - OOB Register
 * - HW_SATA_GPCR - General Purpose Control Register
 * - HW_SATA_GPSR - General Purpose Status Register
 * - HW_SATA_TIMER1MS - Timer 1-ms Register
 * - HW_SATA_TESTR - Test Register
 * - HW_SATA_VERSIONR - Version Register
 * - HW_SATA_P0CLB - Port0 Command List Base Address Register
 * - HW_SATA_P0FB - Port0 FIS Base Address Register
 * - HW_SATA_P0IS - Port0 Interrupt Status Register
 * - HW_SATA_P0IE - Port0 Interrupt Enable Register
 * - HW_SATA_P0CMD - Port0 Command Register
 * - HW_SATA_P0TFD - Port0 Task File Data Register
 * - HW_SATA_P0SIG - Port0 Signature Register
 * - HW_SATA_P0SSTS - Port0 Serial ATA Status Register
 * - HW_SATA_P0SCTL - Port0 Serial ATA Control {SControl} Register
 * - HW_SATA_P0SERR - Port0 Serial ATA Error Register
 * - HW_SATA_P0SACT - Port0 Serial ATA Active Register
 * - HW_SATA_P0CI - Port0 Command Issue Register
 * - HW_SATA_P0SNTF - Port0 Serial ATA Notification Register
 * - HW_SATA_P0DMACR - Port0 DMA Control Register
 * - HW_SATA_P0PHYCR - Port0 PHY Control Register
 * - HW_SATA_P0PHYSR - Port0 PHY Status Register
 *
 * - hw_sata_t - Struct containing all module registers.
 */

#define HW_SATA_INSTANCE_COUNT (1U) /*!< Number of instances of the SATA module. */
#define HW_SATA (0U) /*!< Instance number for SATA. */
#define SATA_BASE             (0x2200000U) /*!< Base address for SATA. */
/*! Array initializer of SATA base addresses. */
#define SATA_BASE_ADDRS       { SATA_BASE }

/*******************************************************************************
 * HW_SATA_CAP - HBA Capabilites Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_CAP - HBA Capabilites Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates basic capabilities of the SATA block to the software.
 */
typedef union _hw_sata_cap
{
    uint32_t U;
    struct _hw_sata_cap_bitfields
    {
        uint32_t NP : 5;               /*!< [4:0]  */
        uint32_t SXS : 1;              /*!< [5]  */
        uint32_t EMS : 1;              /*!< [6]  */
        uint32_t CCCS : 1;             /*!< [7]  */
        uint32_t NCS : 5;              /*!< [12:8]  */
        uint32_t PSC : 1;              /*!< [13]  */
        uint32_t SSC : 1;              /*!< [14]  */
        uint32_t PMD : 1;              /*!< [15]  */
        uint32_t RESERVED0 : 1;        /*!< [16]  */
        uint32_t SMP : 1;              /*!< [17]  */
        uint32_t SAM : 1;              /*!< [18]  */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t ISS : 4;              /*!< [23:20]  */
        uint32_t SCLO : 1;             /*!< [24]  */
        uint32_t SAL : 1;              /*!< [25]  */
        uint32_t SALP : 1;             /*!< [26]  */
        uint32_t SSS : 1;              /*!< [27]  */
        uint32_t SMPS : 1;             /*!< [28]  */
        uint32_t SSNTF : 1;            /*!< [29]  */
        uint32_t SNCQ : 1;             /*!< [30]  */
        uint32_t S64A : 1;             /*!< [31]  */
    } B;
} hw_sata_cap_t;

/*!
 * @name Constants and macros for entire SATA_CAP register
 */
/*@{*/
#define HW_SATA_CAP_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_SATA_CAP(x)           (*(__I hw_sata_cap_t *) HW_SATA_CAP_ADDR(x))
#define HW_SATA_CAP_RD(x)        (HW_SATA_CAP(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_CAP bitfields
 */

/*!
 * @name Register SATA_CAP, field NP[4:0] (RO)
 *
 * Number of Ports. 0's based value indicating the number of Ports supported by
 * the SATA block: The options for this field are: • 0x00: 1 Port • 0x01: 2
 * Ports • 0x02: 3 Ports Reset Value: 0x00
 */
/*@{*/
#define BP_SATA_CAP_NP       (0U)          /*!< Bit position for SATA_CAP_NP. */
#define BM_SATA_CAP_NP       (0x0000001FU) /*!< Bit mask for SATA_CAP_NP. */
#define BS_SATA_CAP_NP       (5U)          /*!< Bit field size in bits for SATA_CAP_NP. */

/*! @brief Read current value of the SATA_CAP_NP field. */
#define BR_SATA_CAP_NP(x)    (HW_SATA_CAP(x).B.NP)
/*@}*/

/*!
 * @name Register SATA_CAP, field SXS[5] (RO)
 *
 * Supports External SATA. The options for this field are: 1 Indicates that the
 * SATA block has one or more Ports that has a signal only connector (power is
 * not part of that connector) that is externally accessible. When this bit is set
 * to 1, the software can refer to the SATA_P 0 CMD[ESP] bit to determine whether
 * a specific Port has its signal connector externally accessible. 0 Indicates
 * that the SATA block has no Ports that have a signal only connector externally
 * accessible. Reset Value: Configurable
 *
 * Values:
 * - 1 - when any of the SATA_P 0 CMD[ESP]=1
 * - 0 - when all of the SATA_P 0 CMD[ESP]=0
 */
/*@{*/
#define BP_SATA_CAP_SXS      (5U)          /*!< Bit position for SATA_CAP_SXS. */
#define BM_SATA_CAP_SXS      (0x00000020U) /*!< Bit mask for SATA_CAP_SXS. */
#define BS_SATA_CAP_SXS      (1U)          /*!< Bit field size in bits for SATA_CAP_SXS. */

/*! @brief Read current value of the SATA_CAP_SXS field. */
#define BR_SATA_CAP_SXS(x)   (HW_SATA_CAP(x).B.SXS)
/*@}*/

/*!
 * @name Register SATA_CAP, field EMS[6] (RO)
 *
 * Enclosure Management Support. SATA block does not support enclosure
 * management.
 */
/*@{*/
#define BP_SATA_CAP_EMS      (6U)          /*!< Bit position for SATA_CAP_EMS. */
#define BM_SATA_CAP_EMS      (0x00000040U) /*!< Bit mask for SATA_CAP_EMS. */
#define BS_SATA_CAP_EMS      (1U)          /*!< Bit field size in bits for SATA_CAP_EMS. */

/*! @brief Read current value of the SATA_CAP_EMS field. */
#define BR_SATA_CAP_EMS(x)   (HW_SATA_CAP(x).B.EMS)
/*@}*/

/*!
 * @name Register SATA_CAP, field CCCS[7] (RO)
 *
 * Command Completion Coalescing Support. SATA block supports command completion
 * coalescing.
 */
/*@{*/
#define BP_SATA_CAP_CCCS     (7U)          /*!< Bit position for SATA_CAP_CCCS. */
#define BM_SATA_CAP_CCCS     (0x00000080U) /*!< Bit mask for SATA_CAP_CCCS. */
#define BS_SATA_CAP_CCCS     (1U)          /*!< Bit field size in bits for SATA_CAP_CCCS. */

/*! @brief Read current value of the SATA_CAP_CCCS field. */
#define BR_SATA_CAP_CCCS(x)  (HW_SATA_CAP(x).B.CCCS)
/*@}*/

/*!
 * @name Register SATA_CAP, field NCS[12:8] (RO)
 *
 * Number of Command Slots. SATA block supports 32 command slots per Port.
 */
/*@{*/
#define BP_SATA_CAP_NCS      (8U)          /*!< Bit position for SATA_CAP_NCS. */
#define BM_SATA_CAP_NCS      (0x00001F00U) /*!< Bit mask for SATA_CAP_NCS. */
#define BS_SATA_CAP_NCS      (5U)          /*!< Bit field size in bits for SATA_CAP_NCS. */

/*! @brief Read current value of the SATA_CAP_NCS field. */
#define BR_SATA_CAP_NCS(x)   (HW_SATA_CAP(x).B.NCS)
/*@}*/

/*!
 * @name Register SATA_CAP, field PSC[13] (RO)
 *
 * Partial State Capable. SATA block supports transitions to the interface
 * PARTIAL power management state.
 */
/*@{*/
#define BP_SATA_CAP_PSC      (13U)         /*!< Bit position for SATA_CAP_PSC. */
#define BM_SATA_CAP_PSC      (0x00002000U) /*!< Bit mask for SATA_CAP_PSC. */
#define BS_SATA_CAP_PSC      (1U)          /*!< Bit field size in bits for SATA_CAP_PSC. */

/*! @brief Read current value of the SATA_CAP_PSC field. */
#define BR_SATA_CAP_PSC(x)   (HW_SATA_CAP(x).B.PSC)
/*@}*/

/*!
 * @name Register SATA_CAP, field SSC[14] (RO)
 *
 * Slumber State Capable. SATA block supports transitions to the interface
 * SLUMBER power management state.
 */
/*@{*/
#define BP_SATA_CAP_SSC      (14U)         /*!< Bit position for SATA_CAP_SSC. */
#define BM_SATA_CAP_SSC      (0x00004000U) /*!< Bit mask for SATA_CAP_SSC. */
#define BS_SATA_CAP_SSC      (1U)          /*!< Bit field size in bits for SATA_CAP_SSC. */

/*! @brief Read current value of the SATA_CAP_SSC field. */
#define BR_SATA_CAP_SSC(x)   (HW_SATA_CAP(x).B.SSC)
/*@}*/

/*!
 * @name Register SATA_CAP, field PMD[15] (RO)
 *
 * PIO Multiple DRQ Block. SATA block supports multiple DRQ block data transfers
 * for the PIO command protocol.
 */
/*@{*/
#define BP_SATA_CAP_PMD      (15U)         /*!< Bit position for SATA_CAP_PMD. */
#define BM_SATA_CAP_PMD      (0x00008000U) /*!< Bit mask for SATA_CAP_PMD. */
#define BS_SATA_CAP_PMD      (1U)          /*!< Bit field size in bits for SATA_CAP_PMD. */

/*! @brief Read current value of the SATA_CAP_PMD field. */
#define BR_SATA_CAP_PMD(x)   (HW_SATA_CAP(x).B.PMD)
/*@}*/

/*!
 * @name Register SATA_CAP, field SMP[17] (RO)
 *
 * Supports Port Multiplier. SATA block supports command-based switching Port
 * Multiplier on any of its Ports.
 */
/*@{*/
#define BP_SATA_CAP_SMP      (17U)         /*!< Bit position for SATA_CAP_SMP. */
#define BM_SATA_CAP_SMP      (0x00020000U) /*!< Bit mask for SATA_CAP_SMP. */
#define BS_SATA_CAP_SMP      (1U)          /*!< Bit field size in bits for SATA_CAP_SMP. */

/*! @brief Read current value of the SATA_CAP_SMP field. */
#define BR_SATA_CAP_SMP(x)   (HW_SATA_CAP(x).B.SMP)
/*@}*/

/*!
 * @name Register SATA_CAP, field SAM[18] (RO)
 *
 * Supports AHCI Mode Only. SATA block supports AHCI mode only and does not
 * support legacy, task-file based register interface.
 */
/*@{*/
#define BP_SATA_CAP_SAM      (18U)         /*!< Bit position for SATA_CAP_SAM. */
#define BM_SATA_CAP_SAM      (0x00040000U) /*!< Bit mask for SATA_CAP_SAM. */
#define BS_SATA_CAP_SAM      (1U)          /*!< Bit field size in bits for SATA_CAP_SAM. */

/*! @brief Read current value of the SATA_CAP_SAM field. */
#define BR_SATA_CAP_SAM(x)   (HW_SATA_CAP(x).B.SAM)
/*@}*/

/*!
 * @name Register SATA_CAP, field ISS[23:20] (RU)
 *
 * Interface Speed Support. Reserved. Returns 0x2 on read.
 */
/*@{*/
#define BP_SATA_CAP_ISS      (20U)         /*!< Bit position for SATA_CAP_ISS. */
#define BM_SATA_CAP_ISS      (0x00F00000U) /*!< Bit mask for SATA_CAP_ISS. */
#define BS_SATA_CAP_ISS      (4U)          /*!< Bit field size in bits for SATA_CAP_ISS. */
/*@}*/

/*!
 * @name Register SATA_CAP, field SCLO[24] (RO)
 *
 * Supports Command List Override. SATA block supports the SATA_P 0 CMD[CLO] bit
 * functionality for Port Multiplier devices' enumeration.
 */
/*@{*/
#define BP_SATA_CAP_SCLO     (24U)         /*!< Bit position for SATA_CAP_SCLO. */
#define BM_SATA_CAP_SCLO     (0x01000000U) /*!< Bit mask for SATA_CAP_SCLO. */
#define BS_SATA_CAP_SCLO     (1U)          /*!< Bit field size in bits for SATA_CAP_SCLO. */

/*! @brief Read current value of the SATA_CAP_SCLO field. */
#define BR_SATA_CAP_SCLO(x)  (HW_SATA_CAP(x).B.SCLO)
/*@}*/

/*!
 * @name Register SATA_CAP, field SAL[25] (RO)
 *
 * Supports Activity LED. SATA block supports activity indication using signal p
 * 0 _act_led.
 */
/*@{*/
#define BP_SATA_CAP_SAL      (25U)         /*!< Bit position for SATA_CAP_SAL. */
#define BM_SATA_CAP_SAL      (0x02000000U) /*!< Bit mask for SATA_CAP_SAL. */
#define BS_SATA_CAP_SAL      (1U)          /*!< Bit field size in bits for SATA_CAP_SAL. */

/*! @brief Read current value of the SATA_CAP_SAL field. */
#define BR_SATA_CAP_SAL(x)   (HW_SATA_CAP(x).B.SAL)
/*@}*/

/*!
 * @name Register SATA_CAP, field SALP[26] (RO)
 *
 * Supports Aggressive Link Power Management. SATA block supports
 * auto-generating (Port-initiated) Link Layer requests to the PARTIAL or SLUMBER power
 * management states when there are no commands to process.
 */
/*@{*/
#define BP_SATA_CAP_SALP     (26U)         /*!< Bit position for SATA_CAP_SALP. */
#define BM_SATA_CAP_SALP     (0x04000000U) /*!< Bit mask for SATA_CAP_SALP. */
#define BS_SATA_CAP_SALP     (1U)          /*!< Bit field size in bits for SATA_CAP_SALP. */

/*! @brief Read current value of the SATA_CAP_SALP field. */
#define BR_SATA_CAP_SALP(x)  (HW_SATA_CAP(x).B.SALP)
/*@}*/

/*!
 * @name Register SATA_CAP, field SSS[27] (RO)
 *
 * Supports Staggered Spin-up. This bit is set by the system firmware/BIOS to
 * indicate platform support for staggered devices' spin-up. SATA block supports
 * this feature through the SATA_P 0 CMD[SUD] bit functionality.
 */
/*@{*/
#define BP_SATA_CAP_SSS      (27U)         /*!< Bit position for SATA_CAP_SSS. */
#define BM_SATA_CAP_SSS      (0x08000000U) /*!< Bit mask for SATA_CAP_SSS. */
#define BS_SATA_CAP_SSS      (1U)          /*!< Bit field size in bits for SATA_CAP_SSS. */

/*! @brief Read current value of the SATA_CAP_SSS field. */
#define BR_SATA_CAP_SSS(x)   (HW_SATA_CAP(x).B.SSS)
/*@}*/

/*!
 * @name Register SATA_CAP, field SMPS[28] (RO)
 *
 * Supports Mechanical Presence Switch. This bit is set by the system
 * firmware/BIOS when the platform supports mechanical presence switch for hot plug
 * operation. Dependencies: This field is implemented only when parameter (Macro
 * configuration parm) DEV_MP_SWITCH==Include. When this field is not implemented, this
 * field is reserved, and reads 1'b0.
 */
/*@{*/
#define BP_SATA_CAP_SMPS     (28U)         /*!< Bit position for SATA_CAP_SMPS. */
#define BM_SATA_CAP_SMPS     (0x10000000U) /*!< Bit mask for SATA_CAP_SMPS. */
#define BS_SATA_CAP_SMPS     (1U)          /*!< Bit field size in bits for SATA_CAP_SMPS. */

/*! @brief Read current value of the SATA_CAP_SMPS field. */
#define BR_SATA_CAP_SMPS(x)  (HW_SATA_CAP(x).B.SMPS)
/*@}*/

/*!
 * @name Register SATA_CAP, field SSNTF[29] (RO)
 *
 * Supports SNotification Register. SATA block supports SATA_P 0 SNTF
 * (SNotification) register and its associated functionality.
 */
/*@{*/
#define BP_SATA_CAP_SSNTF    (29U)         /*!< Bit position for SATA_CAP_SSNTF. */
#define BM_SATA_CAP_SSNTF    (0x20000000U) /*!< Bit mask for SATA_CAP_SSNTF. */
#define BS_SATA_CAP_SSNTF    (1U)          /*!< Bit field size in bits for SATA_CAP_SSNTF. */

/*! @brief Read current value of the SATA_CAP_SSNTF field. */
#define BR_SATA_CAP_SSNTF(x) (HW_SATA_CAP(x).B.SSNTF)
/*@}*/

/*!
 * @name Register SATA_CAP, field SNCQ[30] (RO)
 *
 * Supports Native Command Queuing. SATA block supports SATA native command
 * queueing by handling DMA Setup FIS natively.
 */
/*@{*/
#define BP_SATA_CAP_SNCQ     (30U)         /*!< Bit position for SATA_CAP_SNCQ. */
#define BM_SATA_CAP_SNCQ     (0x40000000U) /*!< Bit mask for SATA_CAP_SNCQ. */
#define BS_SATA_CAP_SNCQ     (1U)          /*!< Bit field size in bits for SATA_CAP_SNCQ. */

/*! @brief Read current value of the SATA_CAP_SNCQ field. */
#define BR_SATA_CAP_SNCQ(x)  (HW_SATA_CAP(x).B.SNCQ)
/*@}*/

/*!
 * @name Register SATA_CAP, field S64A[31] (RO)
 *
 * Supports 64-bit Addressing SATA block supports 64-bit addressable data
 * structures by utilizing PFFBU and P#CLBU registers. Reset Value: Configurable.
 *
 * Values:
 * - 1 - when M_HADDR_WIDTH=64
 * - 0 - when M_HADDR_WIDTH=32
 */
/*@{*/
#define BP_SATA_CAP_S64A     (31U)         /*!< Bit position for SATA_CAP_S64A. */
#define BM_SATA_CAP_S64A     (0x80000000U) /*!< Bit mask for SATA_CAP_S64A. */
#define BS_SATA_CAP_S64A     (1U)          /*!< Bit field size in bits for SATA_CAP_S64A. */

/*! @brief Read current value of the SATA_CAP_S64A field. */
#define BR_SATA_CAP_S64A(x)  (HW_SATA_CAP(x).B.S64A)
/*@}*/

/*******************************************************************************
 * HW_SATA_GHC - Global HBA Control Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_GHC - Global HBA Control Register (RW)
 *
 * Reset value: 0x80000000U
 *
 * This register controls various global actions of the SATA block.
 */
typedef union _hw_sata_ghc
{
    uint32_t U;
    struct _hw_sata_ghc_bitfields
    {
        uint32_t HR : 1;               /*!< [0]  */
        uint32_t IE : 1;               /*!< [1]  */
        uint32_t RESERVED0 : 29;       /*!< [30:2]  */
        uint32_t AE : 1;               /*!< [31]  */
    } B;
} hw_sata_ghc_t;

/*!
 * @name Constants and macros for entire SATA_GHC register
 */
/*@{*/
#define HW_SATA_GHC_ADDR(x)      ((uintptr_t)(x) + 0x4U)

#define HW_SATA_GHC(x)           (*(__IO hw_sata_ghc_t *) HW_SATA_GHC_ADDR(x))
#define HW_SATA_GHC_RD(x)        (HW_SATA_GHC(x).U)
#define HW_SATA_GHC_WR(x, v)     (HW_SATA_GHC(x).U = (v))
#define HW_SATA_GHC_SET(x, v)    (HW_SATA_GHC_WR(x, HW_SATA_GHC_RD(x) |  (v)))
#define HW_SATA_GHC_CLR(x, v)    (HW_SATA_GHC_WR(x, HW_SATA_GHC_RD(x) & ~(v)))
#define HW_SATA_GHC_TOG(x, v)    (HW_SATA_GHC_WR(x, HW_SATA_GHC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_GHC bitfields
 */

/*!
 * @name Register SATA_GHC, field HR[0] (WO)
 *
 * HBA Reset. When set by the software, this bit causes an internal Global reset
 * of the SATA block. All state machines that relate to data transfers and
 * queueing return to an idle state, and all the Ports are re-initialized by sending
 * COMRESET When staggered spin-up is not supported. When staggered spin-up is
 * supported, then the software must spin-up each Port after this reset has
 * completed. See Global ResetSoftware may globally reset SATA block by setting
 * SATA_GHC[HR]. When software sets the SATA_GHC[HR] bit, the SATA block performs an
 * internal reset action, then clears this bit when the reset is complete. for
 * details. The SATA block clears this bit when the reset action is done. A software
 * write of 0 has no effect.
 */
/*@{*/
#define BP_SATA_GHC_HR       (0U)          /*!< Bit position for SATA_GHC_HR. */
#define BM_SATA_GHC_HR       (0x00000001U) /*!< Bit mask for SATA_GHC_HR. */
#define BS_SATA_GHC_HR       (1U)          /*!< Bit field size in bits for SATA_GHC_HR. */

/*! @brief Format value for bitfield SATA_GHC_HR. */
#define BF_SATA_GHC_HR(v)    ((uint32_t)((uint32_t)(v) << BP_SATA_GHC_HR) & BM_SATA_GHC_HR)
/*@}*/

/*!
 * @name Register SATA_GHC, field IE[1] (RW)
 *
 * Interrupt Enable. This global bit enables interrupts from the SATA block.
 * When cleared, all interrupt sources from all the Ports are disabled (masked).
 * When set, interrupts are enabled and any SATA block interrupt event causes intrq
 * output assertion. This field is reset on Global reset (SATA_GHC[HR]=1).
 */
/*@{*/
#define BP_SATA_GHC_IE       (1U)          /*!< Bit position for SATA_GHC_IE. */
#define BM_SATA_GHC_IE       (0x00000002U) /*!< Bit mask for SATA_GHC_IE. */
#define BS_SATA_GHC_IE       (1U)          /*!< Bit field size in bits for SATA_GHC_IE. */

/*! @brief Read current value of the SATA_GHC_IE field. */
#define BR_SATA_GHC_IE(x)    (HW_SATA_GHC(x).B.IE)

/*! @brief Format value for bitfield SATA_GHC_IE. */
#define BF_SATA_GHC_IE(v)    ((uint32_t)((uint32_t)(v) << BP_SATA_GHC_IE) & BM_SATA_GHC_IE)

/*! @brief Set the IE field to a new value. */
#define BW_SATA_GHC_IE(x, v) (HW_SATA_GHC_WR(x, (HW_SATA_GHC_RD(x) & ~BM_SATA_GHC_IE) | BF_SATA_GHC_IE(v)))
/*@}*/

/*!
 * @name Register SATA_GHC, field AE[31] (RW)
 *
 * AHCI Enable. This bit is always set since SATA block supports only AHCI mode
 * as indicated by the SATA_CAP[SAM]=1.
 */
/*@{*/
#define BP_SATA_GHC_AE       (31U)         /*!< Bit position for SATA_GHC_AE. */
#define BM_SATA_GHC_AE       (0x80000000U) /*!< Bit mask for SATA_GHC_AE. */
#define BS_SATA_GHC_AE       (1U)          /*!< Bit field size in bits for SATA_GHC_AE. */

/*! @brief Read current value of the SATA_GHC_AE field. */
#define BR_SATA_GHC_AE(x)    (HW_SATA_GHC(x).B.AE)

/*! @brief Format value for bitfield SATA_GHC_AE. */
#define BF_SATA_GHC_AE(v)    ((uint32_t)((uint32_t)(v) << BP_SATA_GHC_AE) & BM_SATA_GHC_AE)

/*! @brief Set the AE field to a new value. */
#define BW_SATA_GHC_AE(x, v) (HW_SATA_GHC_WR(x, (HW_SATA_GHC_RD(x) & ~BM_SATA_GHC_AE) | BF_SATA_GHC_AE(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_IS - Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_IS - Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates which of the Ports within the SATA block have an
 * interrupt pending and require service. This register is reset on Global reset
 * (SATA_GHC[HR]=1). Size: 32 bits Address offset: 0x08 Read/write access: Read/Write
 * One to Clear Reset: 0x0000_00000
 */
typedef union _hw_sata_is
{
    uint32_t U;
    struct _hw_sata_is_bitfields
    {
        uint32_t IPS : 2;              /*!< [1:0]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_sata_is_t;

/*!
 * @name Constants and macros for entire SATA_IS register
 */
/*@{*/
#define HW_SATA_IS_ADDR(x)       ((uintptr_t)(x) + 0x8U)

#define HW_SATA_IS(x)            (*(__IO hw_sata_is_t *) HW_SATA_IS_ADDR(x))
#define HW_SATA_IS_RD(x)         (HW_SATA_IS(x).U)
#define HW_SATA_IS_WR(x, v)      (HW_SATA_IS(x).U = (v))
#define HW_SATA_IS_SET(x, v)     (HW_SATA_IS_WR(x, HW_SATA_IS_RD(x) |  (v)))
#define HW_SATA_IS_CLR(x, v)     (HW_SATA_IS_WR(x, HW_SATA_IS_RD(x) & ~(v)))
#define HW_SATA_IS_TOG(x, v)     (HW_SATA_IS_WR(x, HW_SATA_IS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_IS bitfields
 */

/*!
 * @name Register SATA_IS, field IPS[1:0] (W1C)
 *
 * Interrupt Pending Status. When bit 1is set, this indicates that Port 0 has an
 * interrupt pending. This bit is set when the Port has an interrupt event
 * pending and the interrupt source is enabled (see the definition of the SATA_P 0 IE
 * register). Bit 0 of the IPS field is not used.
 */
/*@{*/
#define BP_SATA_IS_IPS       (0U)          /*!< Bit position for SATA_IS_IPS. */
#define BM_SATA_IS_IPS       (0x00000003U) /*!< Bit mask for SATA_IS_IPS. */
#define BS_SATA_IS_IPS       (2U)          /*!< Bit field size in bits for SATA_IS_IPS. */

/*! @brief Read current value of the SATA_IS_IPS field. */
#define BR_SATA_IS_IPS(x)    (HW_SATA_IS(x).B.IPS)

/*! @brief Format value for bitfield SATA_IS_IPS. */
#define BF_SATA_IS_IPS(v)    ((uint32_t)((uint32_t)(v) << BP_SATA_IS_IPS) & BM_SATA_IS_IPS)

/*! @brief Set the IPS field to a new value. */
#define BW_SATA_IS_IPS(x, v) (HW_SATA_IS_WR(x, (HW_SATA_IS_RD(x) & ~BM_SATA_IS_IPS) | BF_SATA_IS_IPS(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_PI - Ports Implemented Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_PI - Ports Implemented Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates which Ports are exposed by the SATA block and are
 * available for the software to use. It is loaded by the BIOS. For example, when
 * the SATA block supports 8 Ports as indicated in the SATA_CAP[NP], only Ports 1,
 * 3, 5, and 7 could be available, while Ports 0, 2, 4, and 6 being unavailable.
 * The contents of this register are relevant to the SATA_CCC_PORTS (Command
 * Completion Coalescing Ports) register.
 */
typedef union _hw_sata_pi
{
    uint32_t U;
    struct _hw_sata_pi_bitfields
    {
        uint32_t PI : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_sata_pi_t;

/*!
 * @name Constants and macros for entire SATA_PI register
 */
/*@{*/
#define HW_SATA_PI_ADDR(x)       ((uintptr_t)(x) + 0xCU)

#define HW_SATA_PI(x)            (*(__I hw_sata_pi_t *) HW_SATA_PI_ADDR(x))
#define HW_SATA_PI_RD(x)         (HW_SATA_PI(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_PI bitfields
 */

/*!
 * @name Register SATA_PI, field PI[0] (RO)
 *
 * Ports Implemented. BIOS must set this bit to 1
 */
/*@{*/
#define BP_SATA_PI_PI        (0U)          /*!< Bit position for SATA_PI_PI. */
#define BM_SATA_PI_PI        (0x00000001U) /*!< Bit mask for SATA_PI_PI. */
#define BS_SATA_PI_PI        (1U)          /*!< Bit field size in bits for SATA_PI_PI. */

/*! @brief Read current value of the SATA_PI_PI field. */
#define BR_SATA_PI_PI(x)     (HW_SATA_PI(x).B.PI)
/*@}*/

/*******************************************************************************
 * HW_SATA_VS - AHCl Version Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_VS - AHCl Version Register (RO)
 *
 * Reset value: 0x00010300U
 *
 * This register indicates the major and minor version of the AHCI specification
 * that the SATA block implementation supports. The SATA block supports version
 * 1.30. The SATA block core currently complies fully with AHCI version 1.10 ,
 * and complies with AHCI version 1.3, except with respect to FIS-based switching.
 * FIS-based switching is not currently supported.
 */
typedef union _hw_sata_vs
{
    uint32_t U;
    struct _hw_sata_vs_bitfields
    {
        uint32_t MNR : 16;             /*!< [15:0]  */
        uint32_t MJR : 16;             /*!< [31:16]  */
    } B;
} hw_sata_vs_t;

/*!
 * @name Constants and macros for entire SATA_VS register
 */
/*@{*/
#define HW_SATA_VS_ADDR(x)       ((uintptr_t)(x) + 0x10U)

#define HW_SATA_VS(x)            (*(__I hw_sata_vs_t *) HW_SATA_VS_ADDR(x))
#define HW_SATA_VS_RD(x)         (HW_SATA_VS(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_VS bitfields
 */

/*!
 * @name Register SATA_VS, field MNR[15:0] (RO)
 *
 * Minor Version Number. Indicates that the minor AHCI version is 30.
 */
/*@{*/
#define BP_SATA_VS_MNR       (0U)          /*!< Bit position for SATA_VS_MNR. */
#define BM_SATA_VS_MNR       (0x0000FFFFU) /*!< Bit mask for SATA_VS_MNR. */
#define BS_SATA_VS_MNR       (16U)         /*!< Bit field size in bits for SATA_VS_MNR. */

/*! @brief Read current value of the SATA_VS_MNR field. */
#define BR_SATA_VS_MNR(x)    (HW_SATA_VS(x).B.MNR)
/*@}*/

/*!
 * @name Register SATA_VS, field MJR[31:16] (RO)
 *
 * Major Version Number. Indicates that the major AHCI version is 1.
 */
/*@{*/
#define BP_SATA_VS_MJR       (16U)         /*!< Bit position for SATA_VS_MJR. */
#define BM_SATA_VS_MJR       (0xFFFF0000U) /*!< Bit mask for SATA_VS_MJR. */
#define BS_SATA_VS_MJR       (16U)         /*!< Bit field size in bits for SATA_VS_MJR. */

/*! @brief Read current value of the SATA_VS_MJR field. */
#define BR_SATA_VS_MJR(x)    (HW_SATA_VS(x).B.MJR)
/*@}*/

/*******************************************************************************
 * HW_SATA_CCC_CTL - Command Completion Coalescing Control
 ******************************************************************************/

/*!
 * @brief HW_SATA_CCC_CTL - Command Completion Coalescing Control (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to configure the command completion coalescing (CCC)
 * feature for the SATA block core. It is reset on Global reset.
 */
typedef union _hw_sata_ccc_ctl
{
    uint32_t U;
    struct _hw_sata_ccc_ctl_bitfields
    {
        uint32_t EN : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t INT : 5;              /*!< [7:3]  */
        uint32_t CC : 8;               /*!< [15:8]  */
        uint32_t TV : 16;              /*!< [31:16]  */
    } B;
} hw_sata_ccc_ctl_t;

/*!
 * @name Constants and macros for entire SATA_CCC_CTL register
 */
/*@{*/
#define HW_SATA_CCC_CTL_ADDR(x)  ((uintptr_t)(x) + 0x14U)

#define HW_SATA_CCC_CTL(x)       (*(__IO hw_sata_ccc_ctl_t *) HW_SATA_CCC_CTL_ADDR(x))
#define HW_SATA_CCC_CTL_RD(x)    (HW_SATA_CCC_CTL(x).U)
#define HW_SATA_CCC_CTL_WR(x, v) (HW_SATA_CCC_CTL(x).U = (v))
#define HW_SATA_CCC_CTL_SET(x, v) (HW_SATA_CCC_CTL_WR(x, HW_SATA_CCC_CTL_RD(x) |  (v)))
#define HW_SATA_CCC_CTL_CLR(x, v) (HW_SATA_CCC_CTL_WR(x, HW_SATA_CCC_CTL_RD(x) & ~(v)))
#define HW_SATA_CCC_CTL_TOG(x, v) (HW_SATA_CCC_CTL_WR(x, HW_SATA_CCC_CTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_CCC_CTL bitfields
 */

/*!
 * @name Register SATA_CCC_CTL, field EN[0] (RW)
 *
 * Enable. When field SATA_CCC_CTL[EN]==1, the software can not change the
 * fields SATA_CCC_CTL[TV] and SATA_CCC_CTL[CC]. The options for this field are:
 *
 * Values:
 * - 0 - CCC feature is disabled and no CCC interrupts are generated.
 * - 1 - CCC feature is enabled and CCC interrupts may be generated based on the
 *     time-out or command completion conditions.
 */
/*@{*/
#define BP_SATA_CCC_CTL_EN   (0U)          /*!< Bit position for SATA_CCC_CTL_EN. */
#define BM_SATA_CCC_CTL_EN   (0x00000001U) /*!< Bit mask for SATA_CCC_CTL_EN. */
#define BS_SATA_CCC_CTL_EN   (1U)          /*!< Bit field size in bits for SATA_CCC_CTL_EN. */

/*! @brief Read current value of the SATA_CCC_CTL_EN field. */
#define BR_SATA_CCC_CTL_EN(x) (HW_SATA_CCC_CTL(x).B.EN)

/*! @brief Format value for bitfield SATA_CCC_CTL_EN. */
#define BF_SATA_CCC_CTL_EN(v) ((uint32_t)((uint32_t)(v) << BP_SATA_CCC_CTL_EN) & BM_SATA_CCC_CTL_EN)

/*! @brief Set the EN field to a new value. */
#define BW_SATA_CCC_CTL_EN(x, v) (HW_SATA_CCC_CTL_WR(x, (HW_SATA_CCC_CTL_RD(x) & ~BM_SATA_CCC_CTL_EN) | BF_SATA_CCC_CTL_EN(v)))
/*@}*/

/*!
 * @name Register SATA_CCC_CTL, field INT[7:3] (RW)
 *
 * Interrupt. Set this field to 0x01.
 */
/*@{*/
#define BP_SATA_CCC_CTL_INT  (3U)          /*!< Bit position for SATA_CCC_CTL_INT. */
#define BM_SATA_CCC_CTL_INT  (0x000000F8U) /*!< Bit mask for SATA_CCC_CTL_INT. */
#define BS_SATA_CCC_CTL_INT  (5U)          /*!< Bit field size in bits for SATA_CCC_CTL_INT. */

/*! @brief Read current value of the SATA_CCC_CTL_INT field. */
#define BR_SATA_CCC_CTL_INT(x) (HW_SATA_CCC_CTL(x).B.INT)

/*! @brief Format value for bitfield SATA_CCC_CTL_INT. */
#define BF_SATA_CCC_CTL_INT(v) ((uint32_t)((uint32_t)(v) << BP_SATA_CCC_CTL_INT) & BM_SATA_CCC_CTL_INT)

/*! @brief Set the INT field to a new value. */
#define BW_SATA_CCC_CTL_INT(x, v) (HW_SATA_CCC_CTL_WR(x, (HW_SATA_CCC_CTL_RD(x) & ~BM_SATA_CCC_CTL_INT) | BF_SATA_CCC_CTL_INT(v)))
/*@}*/

/*!
 * @name Register SATA_CCC_CTL, field CC[15:8] (RW)
 *
 * Command Completions. This field specifies the number of command completions
 * that are necessary to cause a CCC interrupt. The value 0x00 for this field
 * disables CCC interrupts being generated based on the number of commands completed.
 * In this case, CCC interrupts are only generated based on the timer. Software
 * loads this value prior to enabling CCC: Field access is: • RW when
 * SATA_CCC_CTL[EN]==0 • RO when SATA_CCC_CTL[EN]==1
 */
/*@{*/
#define BP_SATA_CCC_CTL_CC   (8U)          /*!< Bit position for SATA_CCC_CTL_CC. */
#define BM_SATA_CCC_CTL_CC   (0x0000FF00U) /*!< Bit mask for SATA_CCC_CTL_CC. */
#define BS_SATA_CCC_CTL_CC   (8U)          /*!< Bit field size in bits for SATA_CCC_CTL_CC. */

/*! @brief Read current value of the SATA_CCC_CTL_CC field. */
#define BR_SATA_CCC_CTL_CC(x) (HW_SATA_CCC_CTL(x).B.CC)

/*! @brief Format value for bitfield SATA_CCC_CTL_CC. */
#define BF_SATA_CCC_CTL_CC(v) ((uint32_t)((uint32_t)(v) << BP_SATA_CCC_CTL_CC) & BM_SATA_CCC_CTL_CC)

/*! @brief Set the CC field to a new value. */
#define BW_SATA_CCC_CTL_CC(x, v) (HW_SATA_CCC_CTL_WR(x, (HW_SATA_CCC_CTL_RD(x) & ~BM_SATA_CCC_CTL_CC) | BF_SATA_CCC_CTL_CC(v)))
/*@}*/

/*!
 * @name Register SATA_CCC_CTL, field TV[31:16] (RW)
 *
 * Time-out Value. This field specifies the CCC time-out value in 1ms intervals.
 * The software loads this value prior to enabling CCC. The options for this
 * field are: • RW when SATA_CCC_CTL[EN]==0. • RO when SATA_CCC_CTL[EN]==1. A
 * time-out value of 0x0000 is reserved and should not be used.
 */
/*@{*/
#define BP_SATA_CCC_CTL_TV   (16U)         /*!< Bit position for SATA_CCC_CTL_TV. */
#define BM_SATA_CCC_CTL_TV   (0xFFFF0000U) /*!< Bit mask for SATA_CCC_CTL_TV. */
#define BS_SATA_CCC_CTL_TV   (16U)         /*!< Bit field size in bits for SATA_CCC_CTL_TV. */

/*! @brief Read current value of the SATA_CCC_CTL_TV field. */
#define BR_SATA_CCC_CTL_TV(x) (HW_SATA_CCC_CTL(x).B.TV)

/*! @brief Format value for bitfield SATA_CCC_CTL_TV. */
#define BF_SATA_CCC_CTL_TV(v) ((uint32_t)((uint32_t)(v) << BP_SATA_CCC_CTL_TV) & BM_SATA_CCC_CTL_TV)

/*! @brief Set the TV field to a new value. */
#define BW_SATA_CCC_CTL_TV(x, v) (HW_SATA_CCC_CTL_WR(x, (HW_SATA_CCC_CTL_RD(x) & ~BM_SATA_CCC_CTL_TV) | BF_SATA_CCC_CTL_TV(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_CCC_PORTS - Command Completion Coalescing Ports
 ******************************************************************************/

/*!
 * @brief HW_SATA_CCC_PORTS - Command Completion Coalescing Ports (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register specifies the Ports that are coalesced as part of the command
 * completion coalescing (CCC) feature when SATA_CCC_CTL[EN]==1. It is reset on
 * Global reset.
 */
typedef union _hw_sata_ccc_ports
{
    uint32_t U;
    struct _hw_sata_ccc_ports_bitfields
    {
        uint32_t PRT : 32;             /*!< [31:0]  */
    } B;
} hw_sata_ccc_ports_t;

/*!
 * @name Constants and macros for entire SATA_CCC_PORTS register
 */
/*@{*/
#define HW_SATA_CCC_PORTS_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_SATA_CCC_PORTS(x)     (*(__IO hw_sata_ccc_ports_t *) HW_SATA_CCC_PORTS_ADDR(x))
#define HW_SATA_CCC_PORTS_RD(x)  (HW_SATA_CCC_PORTS(x).U)
#define HW_SATA_CCC_PORTS_WR(x, v) (HW_SATA_CCC_PORTS(x).U = (v))
#define HW_SATA_CCC_PORTS_SET(x, v) (HW_SATA_CCC_PORTS_WR(x, HW_SATA_CCC_PORTS_RD(x) |  (v)))
#define HW_SATA_CCC_PORTS_CLR(x, v) (HW_SATA_CCC_PORTS_WR(x, HW_SATA_CCC_PORTS_RD(x) & ~(v)))
#define HW_SATA_CCC_PORTS_TOG(x, v) (HW_SATA_CCC_PORTS_WR(x, HW_SATA_CCC_PORTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_CCC_PORTS bitfields
 */

/*!
 * @name Register SATA_CCC_PORTS, field PRT[31:0] (RW)
 *
 * Ports. This field is bit significant. Each bit corresponds to a particular
 * Port, where bit 0 corresponds to Port0. Bits set in this register must have the
 * corresponding bit set in the SATA_PI (Ports Implemented Register). The options
 * for this field are:
 *
 * Values:
 * - 1 - the corresponding Port is part of the CCC feature.
 * - 0 - the corresponding Port is not part of the CCC feature.
 */
/*@{*/
#define BP_SATA_CCC_PORTS_PRT (0U)         /*!< Bit position for SATA_CCC_PORTS_PRT. */
#define BM_SATA_CCC_PORTS_PRT (0xFFFFFFFFU) /*!< Bit mask for SATA_CCC_PORTS_PRT. */
#define BS_SATA_CCC_PORTS_PRT (32U)        /*!< Bit field size in bits for SATA_CCC_PORTS_PRT. */

/*! @brief Read current value of the SATA_CCC_PORTS_PRT field. */
#define BR_SATA_CCC_PORTS_PRT(x) (HW_SATA_CCC_PORTS(x).U)

/*! @brief Format value for bitfield SATA_CCC_PORTS_PRT. */
#define BF_SATA_CCC_PORTS_PRT(v) ((uint32_t)((uint32_t)(v) << BP_SATA_CCC_PORTS_PRT) & BM_SATA_CCC_PORTS_PRT)

/*! @brief Set the PRT field to a new value. */
#define BW_SATA_CCC_PORTS_PRT(x, v) (HW_SATA_CCC_PORTS_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SATA_CAP2 - HBA Capabilities Extended Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_CAP2 - HBA Capabilities Extended Register (RO)
 *
 * Reset value: 0x00000004U
 *
 * This register indicates capabilites of the SATA block core to the software.
 */
typedef union _hw_sata_cap2
{
    uint32_t U;
    struct _hw_sata_cap2_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t APST : 1;             /*!< [2]  */
        uint32_t RESERVED1 : 29;       /*!< [31:3]  */
    } B;
} hw_sata_cap2_t;

/*!
 * @name Constants and macros for entire SATA_CAP2 register
 */
/*@{*/
#define HW_SATA_CAP2_ADDR(x)     ((uintptr_t)(x) + 0x24U)

#define HW_SATA_CAP2(x)          (*(__I hw_sata_cap2_t *) HW_SATA_CAP2_ADDR(x))
#define HW_SATA_CAP2_RD(x)       (HW_SATA_CAP2(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_CAP2 bitfields
 */

/*!
 * @name Register SATA_CAP2, field APST[2] (RO)
 *
 * Automatic Partial to Slumber Transitions. SATA block supports automatic
 * Partial to Slumber transitions.
 */
/*@{*/
#define BP_SATA_CAP2_APST    (2U)          /*!< Bit position for SATA_CAP2_APST. */
#define BM_SATA_CAP2_APST    (0x00000004U) /*!< Bit mask for SATA_CAP2_APST. */
#define BS_SATA_CAP2_APST    (1U)          /*!< Bit field size in bits for SATA_CAP2_APST. */

/*! @brief Read current value of the SATA_CAP2_APST field. */
#define BR_SATA_CAP2_APST(x) (HW_SATA_CAP2(x).B.APST)
/*@}*/

/*******************************************************************************
 * HW_SATA_BISTAFR - BIST Activate FIS Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_BISTAFR - BIST Activate FIS Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the pattern definition (bits [23:16] of the first
 * DWORD) and data pattern (bits [7:0] of the second DWORD) fields of the received
 * BIST Activate FIS. These fields define the SATA block loopback responder mode
 * requested by the device. It is updated every time a new BIST Activate FIS is
 * received from the device. Reset on Global or Port reset.
 */
typedef union _hw_sata_bistafr
{
    uint32_t U;
    struct _hw_sata_bistafr_bitfields
    {
        uint32_t PD : 8;               /*!< [7:0]  */
        uint32_t NCP : 8;              /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sata_bistafr_t;

/*!
 * @name Constants and macros for entire SATA_BISTAFR register
 */
/*@{*/
#define HW_SATA_BISTAFR_ADDR(x)  ((uintptr_t)(x) + 0xA0U)

#define HW_SATA_BISTAFR(x)       (*(__I hw_sata_bistafr_t *) HW_SATA_BISTAFR_ADDR(x))
#define HW_SATA_BISTAFR_RD(x)    (HW_SATA_BISTAFR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_BISTAFR bitfields
 */

/*!
 * @name Register SATA_BISTAFR, field PD[7:0] (RO)
 *
 * Pattern Definition Indicates the pattern definition field of the received
 * BIST Activate FIS - bits [23:16] of the first DWORD. It is used to put the SATA
 * block in one of the following BIST modes: For far-end transmit only modes
 * SATA_BISTAFR[NCP] field contains the required data pattern.
 *
 * Values:
 * - 10000 - Far-end retimed
 * - 1000 - Far-end analog (when PHY supports this mode)
 * - 10000000 - Far-end transmit only
 * - 10100000 - Far-end transmit only with scrambler bypassed
 */
/*@{*/
#define BP_SATA_BISTAFR_PD   (0U)          /*!< Bit position for SATA_BISTAFR_PD. */
#define BM_SATA_BISTAFR_PD   (0x000000FFU) /*!< Bit mask for SATA_BISTAFR_PD. */
#define BS_SATA_BISTAFR_PD   (8U)          /*!< Bit field size in bits for SATA_BISTAFR_PD. */

/*! @brief Read current value of the SATA_BISTAFR_PD field. */
#define BR_SATA_BISTAFR_PD(x) (HW_SATA_BISTAFR(x).B.PD)
/*@}*/

/*!
 * @name Register SATA_BISTAFR, field NCP[15:8] (RO)
 *
 * Least significant byte of the received BIST Activate FIS second DWORD (bits
 * [7:0]). This value defines the required pattern for far-end transmit only mode
 * (SATA_BISTAFR[PD]=0x80 or 0xA0): When none of these values is decoded, the
 * simultaneous switching pattern is transmitted by default.
 *
 * Values:
 * - 11110001 - Low transition density pattern (LTDP)
 * - 10110101 - High transition density pattern (HTDP)
 * - 10101011 - Low frequency spectral component pattern (LFSCP)
 * - 1111111 - Simultaneous switching outputs pattern (SSOP)
 * - 10001011 - Lone Bit pattern (LBP)
 * - 1111000 - Mid frequency test pattern (MFTP)
 * - 1001010 - High frequency test pattern (HFTP)
 * - 1111110 - Low frequency test pattern (LFTP)
 */
/*@{*/
#define BP_SATA_BISTAFR_NCP  (8U)          /*!< Bit position for SATA_BISTAFR_NCP. */
#define BM_SATA_BISTAFR_NCP  (0x0000FF00U) /*!< Bit mask for SATA_BISTAFR_NCP. */
#define BS_SATA_BISTAFR_NCP  (8U)          /*!< Bit field size in bits for SATA_BISTAFR_NCP. */

/*! @brief Read current value of the SATA_BISTAFR_NCP field. */
#define BR_SATA_BISTAFR_NCP(x) (HW_SATA_BISTAFR(x).B.NCP)
/*@}*/

/*******************************************************************************
 * HW_SATA_BISTCR - BIST Control Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_BISTCR - BIST Control Register (RW)
 *
 * Reset value: 0x00000700U
 *
 * This register is used in BIST initiator modes. It is loaded by the host
 * software prior to sending BIST Activate FIS to the device (via TXBISTPD write). It
 * is reset on a Global or Port reset.
 */
typedef union _hw_sata_bistcr
{
    uint32_t U;
    struct _hw_sata_bistcr_bitfields
    {
        uint32_t PATTERN : 4;          /*!< [3:0]  */
        uint32_t PV : 1;               /*!< [4]  */
        uint32_t FLIP : 1;             /*!< [5]  */
        uint32_t ERREN : 1;            /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t LLC : 3;              /*!< [10:8]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t SDFE : 1;             /*!< [12]  */
        uint32_t RESERVED2 : 1;        /*!< [13]  */
        uint32_t QPHYINIT : 1;         /*!< [14]  */
        uint32_t RESERVED3 : 1;        /*!< [15]  */
        uint32_t NEALB : 1;            /*!< [16]  */
        uint32_t CNTCLR : 1;           /*!< [17]  */
        uint32_t TXO : 1;              /*!< [18]  */
        uint32_t RESERVED4 : 1;        /*!< [19]  */
        uint32_t FERLB : 1;            /*!< [20]  */
        uint32_t RESERVED5 : 11;       /*!< [31:21]  */
    } B;
} hw_sata_bistcr_t;

/*!
 * @name Constants and macros for entire SATA_BISTCR register
 */
/*@{*/
#define HW_SATA_BISTCR_ADDR(x)   ((uintptr_t)(x) + 0xA4U)

#define HW_SATA_BISTCR(x)        (*(__IO hw_sata_bistcr_t *) HW_SATA_BISTCR_ADDR(x))
#define HW_SATA_BISTCR_RD(x)     (HW_SATA_BISTCR(x).U)
#define HW_SATA_BISTCR_WR(x, v)  (HW_SATA_BISTCR(x).U = (v))
#define HW_SATA_BISTCR_SET(x, v) (HW_SATA_BISTCR_WR(x, HW_SATA_BISTCR_RD(x) |  (v)))
#define HW_SATA_BISTCR_CLR(x, v) (HW_SATA_BISTCR_WR(x, HW_SATA_BISTCR_RD(x) & ~(v)))
#define HW_SATA_BISTCR_TOG(x, v) (HW_SATA_BISTCR_WR(x, HW_SATA_BISTCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_BISTCR bitfields
 */

/*!
 * @name Register SATA_BISTCR, field PATTERN[3:0] (RW)
 *
 * This field defines one of the following SATA compliant patterns for far-end
 * retimed/ far-end analog/ near-end analog initiator modes, or non-compliant
 * patterns for transmit-only responder mode when initiated by the software writing
 * to the SATA_BISTCR[TXO] bit. If the value is none of the listed below,
 * Composite pattern (COMP) is transmitted by default.
 *
 * Values:
 * - 0000 - Simultaneous switching outputs pattern (SSOP)
 * - 0001 - High transition density pattern (HTDP)
 * - 0010 - Low transition density pattern (LTDP)
 * - 0011 - Low frequency spectral component pattern (LFSCP)
 * - 0100 - Composite pattern (COMP)
 * - 0101 - Lone bit pattern (LBP)
 * - 0110 - Mid frequency test pattern (MFTP)
 * - 0111 - High frequency test pattern (HFTP)
 * - 1000 - Low frequency test pattern (LFTP)
 */
/*@{*/
#define BP_SATA_BISTCR_PATTERN (0U)        /*!< Bit position for SATA_BISTCR_PATTERN. */
#define BM_SATA_BISTCR_PATTERN (0x0000000FU) /*!< Bit mask for SATA_BISTCR_PATTERN. */
#define BS_SATA_BISTCR_PATTERN (4U)        /*!< Bit field size in bits for SATA_BISTCR_PATTERN. */

/*! @brief Read current value of the SATA_BISTCR_PATTERN field. */
#define BR_SATA_BISTCR_PATTERN(x) (HW_SATA_BISTCR(x).B.PATTERN)

/*! @brief Format value for bitfield SATA_BISTCR_PATTERN. */
#define BF_SATA_BISTCR_PATTERN(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_PATTERN) & BM_SATA_BISTCR_PATTERN)

/*! @brief Set the PATTERN field to a new value. */
#define BW_SATA_BISTCR_PATTERN(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_PATTERN) | BF_SATA_BISTCR_PATTERN(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field PV[4] (RW)
 *
 * Pattern Version This bit is used to select either short or long version of
 * the SSOP, HTDP, LTDP, LFSCP, COMP patterns. The options for this field are:
 *
 * Values:
 * - 0 - Short pattern version
 * - 1 - Long pattern version
 */
/*@{*/
#define BP_SATA_BISTCR_PV    (4U)          /*!< Bit position for SATA_BISTCR_PV. */
#define BM_SATA_BISTCR_PV    (0x00000010U) /*!< Bit mask for SATA_BISTCR_PV. */
#define BS_SATA_BISTCR_PV    (1U)          /*!< Bit field size in bits for SATA_BISTCR_PV. */

/*! @brief Read current value of the SATA_BISTCR_PV field. */
#define BR_SATA_BISTCR_PV(x) (HW_SATA_BISTCR(x).B.PV)

/*! @brief Format value for bitfield SATA_BISTCR_PV. */
#define BF_SATA_BISTCR_PV(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_PV) & BM_SATA_BISTCR_PV)

/*! @brief Set the PV field to a new value. */
#define BW_SATA_BISTCR_PV(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_PV) | BF_SATA_BISTCR_PV(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field FLIP[5] (RW)
 *
 * Flip Disparity This bit is used to change disparity of the current test
 * pattern to the opposite every time its state is changed by the software.
 */
/*@{*/
#define BP_SATA_BISTCR_FLIP  (5U)          /*!< Bit position for SATA_BISTCR_FLIP. */
#define BM_SATA_BISTCR_FLIP  (0x00000020U) /*!< Bit mask for SATA_BISTCR_FLIP. */
#define BS_SATA_BISTCR_FLIP  (1U)          /*!< Bit field size in bits for SATA_BISTCR_FLIP. */

/*! @brief Read current value of the SATA_BISTCR_FLIP field. */
#define BR_SATA_BISTCR_FLIP(x) (HW_SATA_BISTCR(x).B.FLIP)

/*! @brief Format value for bitfield SATA_BISTCR_FLIP. */
#define BF_SATA_BISTCR_FLIP(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_FLIP) & BM_SATA_BISTCR_FLIP)

/*! @brief Set the FLIP field to a new value. */
#define BW_SATA_BISTCR_FLIP(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_FLIP) | BF_SATA_BISTCR_FLIP(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field ERREN[6] (RW)
 *
 * Error Enable. This bit is used to allow or filter (disable) [ internal errors
 * outside the FIS boundary to set corresponding SATA_P 0 SERR bits. The options
 * for this field are:
 *
 * Values:
 * - 0 - Filter errors outside the FIS, allow errors inside the FIS;
 * - 1 - Allow errors outside or inside the FIS.
 */
/*@{*/
#define BP_SATA_BISTCR_ERREN (6U)          /*!< Bit position for SATA_BISTCR_ERREN. */
#define BM_SATA_BISTCR_ERREN (0x00000040U) /*!< Bit mask for SATA_BISTCR_ERREN. */
#define BS_SATA_BISTCR_ERREN (1U)          /*!< Bit field size in bits for SATA_BISTCR_ERREN. */

/*! @brief Read current value of the SATA_BISTCR_ERREN field. */
#define BR_SATA_BISTCR_ERREN(x) (HW_SATA_BISTCR(x).B.ERREN)

/*! @brief Format value for bitfield SATA_BISTCR_ERREN. */
#define BF_SATA_BISTCR_ERREN(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_ERREN) & BM_SATA_BISTCR_ERREN)

/*! @brief Set the ERREN field to a new value. */
#define BW_SATA_BISTCR_ERREN(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_ERREN) | BF_SATA_BISTCR_ERREN(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field LLC[10:8] (RW)
 *
 * Link Layer Control This field controls the Port Link Layer functions:
 * scrambler, descrambler, and repeat primitive drop. Note the different meanings for
 * normal and BIST modes of operation: • Bit8-SCRAM The options for this field
 * are: 0 Scrambler disabled in normal mode, enabled in BIST mode 1 Scrambler
 * enabled in normal mode, disabled in BIST mode • Bit9-DESCRAM The options for this
 * field are: 0 Descrambler disabled in normal mode, enabled in BIST mode 1
 * Descrambler enabled in normal mode, disabled in BIST mode • Bit10-RPD The
 * options for this field are: 0 Repeat primitive drop function disabled in normal
 * mode, NA in BIST mode. 1 Repeat primitive drop function enabled in normal mode, NA
 * in BIST mode. The SCRAM bit is cleared (enabled) by the Port when the Port
 * enters a responder far-end transmit BIST mode with scrambling enabled
 * (SATA_BISTAFR[PD]=0x80). In normal mode, the functions scrambler, descrambler, or RPD
 * can be changed only during Port reset (SATA_P 0 SCTL[DET]=0x1)
 */
/*@{*/
#define BP_SATA_BISTCR_LLC   (8U)          /*!< Bit position for SATA_BISTCR_LLC. */
#define BM_SATA_BISTCR_LLC   (0x00000700U) /*!< Bit mask for SATA_BISTCR_LLC. */
#define BS_SATA_BISTCR_LLC   (3U)          /*!< Bit field size in bits for SATA_BISTCR_LLC. */

/*! @brief Read current value of the SATA_BISTCR_LLC field. */
#define BR_SATA_BISTCR_LLC(x) (HW_SATA_BISTCR(x).B.LLC)

/*! @brief Format value for bitfield SATA_BISTCR_LLC. */
#define BF_SATA_BISTCR_LLC(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_LLC) & BM_SATA_BISTCR_LLC)

/*! @brief Set the LLC field to a new value. */
#define BW_SATA_BISTCR_LLC(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_LLC) | BF_SATA_BISTCR_LLC(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field SDFE[12] (RW)
 *
 * Signal Detect Feature Enable Reset: PHY_INTERFACE_TYPE 1: Link layer feature
 * to handle unstable/absent phy_sig_det signal is enabled 0: Link layer feature
 * to handle unstable/absent phy_sig_det signal is disabled. This bit is set on
 * power-up or asynchronous reset if PHY_INTERFACE_TYPE = Synopsys_SATA_II (1) or
 * PHY_INTERFACE_TYPE = Synopsys_SATA_6G (2), otherwise, the bit is cleared until
 * it is set via programming. It is not affected by a Global reset or COMRESET.
 * For special handling in systems where phy_sig_det may not be present or stable
 * after OOB signalling and during normal operation . For these systems,
 * phy_rx_data_vld must not be tied high and must go low when no data is detected on the
 * wires.
 */
/*@{*/
#define BP_SATA_BISTCR_SDFE  (12U)         /*!< Bit position for SATA_BISTCR_SDFE. */
#define BM_SATA_BISTCR_SDFE  (0x00001000U) /*!< Bit mask for SATA_BISTCR_SDFE. */
#define BS_SATA_BISTCR_SDFE  (1U)          /*!< Bit field size in bits for SATA_BISTCR_SDFE. */

/*! @brief Read current value of the SATA_BISTCR_SDFE field. */
#define BR_SATA_BISTCR_SDFE(x) (HW_SATA_BISTCR(x).B.SDFE)

/*! @brief Format value for bitfield SATA_BISTCR_SDFE. */
#define BF_SATA_BISTCR_SDFE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_SDFE) & BM_SATA_BISTCR_SDFE)

/*! @brief Set the SDFE field to a new value. */
#define BW_SATA_BISTCR_SDFE(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_SDFE) | BF_SATA_BISTCR_SDFE(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field QPHYINIT[14] (RW)
 *
 * When set, this bit enables quick PHY initialization feature. The Link does
 * not require any ALIGNs to transition from OOB to normal operation. This bit is
 * available only when TX_OOB_MODE = Exclude (0) and ALIGN_MODE = Aligned (1),
 * otherwise it is reserved.
 */
/*@{*/
#define BP_SATA_BISTCR_QPHYINIT (14U)      /*!< Bit position for SATA_BISTCR_QPHYINIT. */
#define BM_SATA_BISTCR_QPHYINIT (0x00004000U) /*!< Bit mask for SATA_BISTCR_QPHYINIT. */
#define BS_SATA_BISTCR_QPHYINIT (1U)       /*!< Bit field size in bits for SATA_BISTCR_QPHYINIT. */

/*! @brief Read current value of the SATA_BISTCR_QPHYINIT field. */
#define BR_SATA_BISTCR_QPHYINIT(x) (HW_SATA_BISTCR(x).B.QPHYINIT)

/*! @brief Format value for bitfield SATA_BISTCR_QPHYINIT. */
#define BF_SATA_BISTCR_QPHYINIT(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_QPHYINIT) & BM_SATA_BISTCR_QPHYINIT)

/*! @brief Set the QPHYINIT field to a new value. */
#define BW_SATA_BISTCR_QPHYINIT(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_QPHYINIT) | BF_SATA_BISTCR_QPHYINIT(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field NEALB[16] (WO)
 *
 * Near-End Analog Loopback This mode should be initiated either in the PARTIAL
 * or SLUMBER power mode, or with the device disconnected from the Port PHY (Link
 * NOCOMM state). BIST Activate FIS is not sent to the device in this mode. This
 * bit places the Port PHY into near-end analog loopback mode. This field is
 * one-shot type and reads returns 0:
 *
 * Values:
 * - 1 - Near-end analog loopback request. SATA_BISTCR[PATTERN] field contains
 *     the appropriate pattern.
 */
/*@{*/
#define BP_SATA_BISTCR_NEALB (16U)         /*!< Bit position for SATA_BISTCR_NEALB. */
#define BM_SATA_BISTCR_NEALB (0x00010000U) /*!< Bit mask for SATA_BISTCR_NEALB. */
#define BS_SATA_BISTCR_NEALB (1U)          /*!< Bit field size in bits for SATA_BISTCR_NEALB. */

/*! @brief Format value for bitfield SATA_BISTCR_NEALB. */
#define BF_SATA_BISTCR_NEALB(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_NEALB) & BM_SATA_BISTCR_NEALB)
/*@}*/

/*!
 * @name Register SATA_BISTCR, field CNTCLR[17] (WO)
 *
 * Counter Clear This bit clears BIST error count registers. This field is
 * one-shot type and reads returns 0.
 *
 * Values:
 * - 1 - Clear SATA_BISTFCTR, and SATA_BISTSR registers.
 */
/*@{*/
#define BP_SATA_BISTCR_CNTCLR (17U)        /*!< Bit position for SATA_BISTCR_CNTCLR. */
#define BM_SATA_BISTCR_CNTCLR (0x00020000U) /*!< Bit mask for SATA_BISTCR_CNTCLR. */
#define BS_SATA_BISTCR_CNTCLR (1U)         /*!< Bit field size in bits for SATA_BISTCR_CNTCLR. */

/*! @brief Format value for bitfield SATA_BISTCR_CNTCLR. */
#define BF_SATA_BISTCR_CNTCLR(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_CNTCLR) & BM_SATA_BISTCR_CNTCLR)
/*@}*/

/*!
 * @name Register SATA_BISTCR, field TXO[18] (RW)
 *
 * Transmit Only. This bit is used to initiate transmission of one of the
 * non-compliant patterns defined by the SATA_BISTCR[PATTERN] value when the device is
 * disconnected.
 */
/*@{*/
#define BP_SATA_BISTCR_TXO   (18U)         /*!< Bit position for SATA_BISTCR_TXO. */
#define BM_SATA_BISTCR_TXO   (0x00040000U) /*!< Bit mask for SATA_BISTCR_TXO. */
#define BS_SATA_BISTCR_TXO   (1U)          /*!< Bit field size in bits for SATA_BISTCR_TXO. */

/*! @brief Read current value of the SATA_BISTCR_TXO field. */
#define BR_SATA_BISTCR_TXO(x) (HW_SATA_BISTCR(x).B.TXO)

/*! @brief Format value for bitfield SATA_BISTCR_TXO. */
#define BF_SATA_BISTCR_TXO(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_TXO) & BM_SATA_BISTCR_TXO)

/*! @brief Set the TXO field to a new value. */
#define BW_SATA_BISTCR_TXO(x, v) (HW_SATA_BISTCR_WR(x, (HW_SATA_BISTCR_RD(x) & ~BM_SATA_BISTCR_TXO) | BF_SATA_BISTCR_TXO(v)))
/*@}*/

/*!
 * @name Register SATA_BISTCR, field FERLB[20] (WO)
 *
 * Far-end Retimed Loopback. When set, this bit is used to put the SATA block
 * Link into Far-end Retimed mode, without the BIST Activate FIS, regardless
 * whether the device is connected or disconnected (Link in NOCOMM state). This field
 * is one-shot type and reads returns 0.
 */
/*@{*/
#define BP_SATA_BISTCR_FERLB (20U)         /*!< Bit position for SATA_BISTCR_FERLB. */
#define BM_SATA_BISTCR_FERLB (0x00100000U) /*!< Bit mask for SATA_BISTCR_FERLB. */
#define BS_SATA_BISTCR_FERLB (1U)          /*!< Bit field size in bits for SATA_BISTCR_FERLB. */

/*! @brief Format value for bitfield SATA_BISTCR_FERLB. */
#define BF_SATA_BISTCR_FERLB(v) ((uint32_t)((uint32_t)(v) << BP_SATA_BISTCR_FERLB) & BM_SATA_BISTCR_FERLB)
/*@}*/

/*******************************************************************************
 * HW_SATA_BISTFCTR - BIST FIS Count Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_BISTFCTR - BIST FIS Count Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the received BIST FIS count in the loopback initiator
 * far-end retimed, far-end analog and near-end analog modes. It is updated each
 * time a new BIST FIS is received. It is reset by Global reset, Port reset
 * (COMRESET) or by setting the SATA_BISTCR[CNTCLR] bit. This register does not roll
 * over and freezes when the FFFF_FFFFh value is reached. It takes approximately
 * 65 hours of continuous BIST operation to reach this value.
 */
typedef union _hw_sata_bistfctr
{
    uint32_t U;
    struct _hw_sata_bistfctr_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_sata_bistfctr_t;

/*!
 * @name Constants and macros for entire SATA_BISTFCTR register
 */
/*@{*/
#define HW_SATA_BISTFCTR_ADDR(x) ((uintptr_t)(x) + 0xA8U)

#define HW_SATA_BISTFCTR(x)      (*(__I hw_sata_bistfctr_t *) HW_SATA_BISTFCTR_ADDR(x))
#define HW_SATA_BISTFCTR_RD(x)   (HW_SATA_BISTFCTR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_BISTFCTR bitfields
 */

/*******************************************************************************
 * HW_SATA_BISTSR - BIST Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_BISTSR - BIST Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains errors detected in the received BIST FIS in the
 * loopback initiator far-end retimed, far- end analog and near-end analog modes. It is
 * updated each time a new BIST FIS is received. It is reset by Global reset,
 * Port reset (COMRESET) or by setting the SATA_BISTCR[CNTCLR] bit.
 */
typedef union _hw_sata_bistsr
{
    uint32_t U;
    struct _hw_sata_bistsr_bitfields
    {
        uint32_t FRAMERR : 16;         /*!< [15:0]  */
        uint32_t BRSTERR : 8;          /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_sata_bistsr_t;

/*!
 * @name Constants and macros for entire SATA_BISTSR register
 */
/*@{*/
#define HW_SATA_BISTSR_ADDR(x)   ((uintptr_t)(x) + 0xACU)

#define HW_SATA_BISTSR(x)        (*(__I hw_sata_bistsr_t *) HW_SATA_BISTSR_ADDR(x))
#define HW_SATA_BISTSR_RD(x)     (HW_SATA_BISTSR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_BISTSR bitfields
 */

/*!
 * @name Register SATA_BISTSR, field FRAMERR[15:0] (RO)
 *
 * Frame Error. This field contains the frame error count. It is accumulated
 * (new value is added to the old value) each time a new BIST frame with a CRC error
 * is received. The FRAMERR value does not roll over and freezes at FFFFh.
 */
/*@{*/
#define BP_SATA_BISTSR_FRAMERR (0U)        /*!< Bit position for SATA_BISTSR_FRAMERR. */
#define BM_SATA_BISTSR_FRAMERR (0x0000FFFFU) /*!< Bit mask for SATA_BISTSR_FRAMERR. */
#define BS_SATA_BISTSR_FRAMERR (16U)       /*!< Bit field size in bits for SATA_BISTSR_FRAMERR. */

/*! @brief Read current value of the SATA_BISTSR_FRAMERR field. */
#define BR_SATA_BISTSR_FRAMERR(x) (HW_SATA_BISTSR(x).B.FRAMERR)
/*@}*/

/*!
 * @name Register SATA_BISTSR, field BRSTERR[23:16] (RO)
 *
 * Burst Error. This field contains the burst error count. It is accumulated
 * each time a burst error condition is detected: DWORD error is detected in the
 * received frame and 1.5 seconds (27,000 frames) passed since the previous burst
 * error was detected. The BRSTERR value does not roll over and freezes at FFh.
 * This field is updated when parameter BIST_MODE=DWORD.
 */
/*@{*/
#define BP_SATA_BISTSR_BRSTERR (16U)       /*!< Bit position for SATA_BISTSR_BRSTERR. */
#define BM_SATA_BISTSR_BRSTERR (0x00FF0000U) /*!< Bit mask for SATA_BISTSR_BRSTERR. */
#define BS_SATA_BISTSR_BRSTERR (8U)        /*!< Bit field size in bits for SATA_BISTSR_BRSTERR. */

/*! @brief Read current value of the SATA_BISTSR_BRSTERR field. */
#define BR_SATA_BISTSR_BRSTERR(x) (HW_SATA_BISTSR(x).B.BRSTERR)
/*@}*/

/*******************************************************************************
 * HW_SATA_OOBR - OOB Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_OOBR - OOB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls the Link layer OOB detection counters. The default
 * values, MIN_COMWAKE, MAX_COMWAKE, MIN_COMINIT and MAX_COMINIT are calculated
 * based on the RXOOB_CLK parameter and loaded on power-up or asynchronous SATA block
 * reset.
 */
typedef union _hw_sata_oobr
{
    uint32_t U;
    struct _hw_sata_oobr_bitfields
    {
        uint32_t ciMax : 8;            /*!< [7:0]  */
        uint32_t ciMin : 8;            /*!< [15:8]  */
        uint32_t cwMax : 8;            /*!< [23:16]  */
        uint32_t cwMin : 7;            /*!< [30:24]  */
        uint32_t WE : 1;               /*!< [31]  */
    } B;
} hw_sata_oobr_t;

/*!
 * @name Constants and macros for entire SATA_OOBR register
 */
/*@{*/
#define HW_SATA_OOBR_ADDR(x)     ((uintptr_t)(x) + 0xBCU)

#define HW_SATA_OOBR(x)          (*(__IO hw_sata_oobr_t *) HW_SATA_OOBR_ADDR(x))
#define HW_SATA_OOBR_RD(x)       (HW_SATA_OOBR(x).U)
#define HW_SATA_OOBR_WR(x, v)    (HW_SATA_OOBR(x).U = (v))
#define HW_SATA_OOBR_SET(x, v)   (HW_SATA_OOBR_WR(x, HW_SATA_OOBR_RD(x) |  (v)))
#define HW_SATA_OOBR_CLR(x, v)   (HW_SATA_OOBR_WR(x, HW_SATA_OOBR_RD(x) & ~(v)))
#define HW_SATA_OOBR_TOG(x, v)   (HW_SATA_OOBR_WR(x, HW_SATA_OOBR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_OOBR bitfields
 */

/*!
 * @name Register SATA_OOBR, field ciMax[7:0] (RW)
 *
 * COMINIT Maximum Value This field is RW when WE=1 and RO when WE=0.
 */
/*@{*/
#define BP_SATA_OOBR_ciMax   (0U)          /*!< Bit position for SATA_OOBR_ciMax. */
#define BM_SATA_OOBR_ciMax   (0x000000FFU) /*!< Bit mask for SATA_OOBR_ciMax. */
#define BS_SATA_OOBR_ciMax   (8U)          /*!< Bit field size in bits for SATA_OOBR_ciMax. */

/*! @brief Read current value of the SATA_OOBR_ciMax field. */
#define BR_SATA_OOBR_ciMax(x) (HW_SATA_OOBR(x).B.ciMax)

/*! @brief Format value for bitfield SATA_OOBR_ciMax. */
#define BF_SATA_OOBR_ciMax(v) ((uint32_t)((uint32_t)(v) << BP_SATA_OOBR_ciMax) & BM_SATA_OOBR_ciMax)

/*! @brief Set the ciMax field to a new value. */
#define BW_SATA_OOBR_ciMax(x, v) (HW_SATA_OOBR_WR(x, (HW_SATA_OOBR_RD(x) & ~BM_SATA_OOBR_ciMax) | BF_SATA_OOBR_ciMax(v)))
/*@}*/

/*!
 * @name Register SATA_OOBR, field ciMin[15:8] (RW)
 *
 * COMINIT Minimum Value This field is RW when WE=1 and RO when WE=0.
 */
/*@{*/
#define BP_SATA_OOBR_ciMin   (8U)          /*!< Bit position for SATA_OOBR_ciMin. */
#define BM_SATA_OOBR_ciMin   (0x0000FF00U) /*!< Bit mask for SATA_OOBR_ciMin. */
#define BS_SATA_OOBR_ciMin   (8U)          /*!< Bit field size in bits for SATA_OOBR_ciMin. */

/*! @brief Read current value of the SATA_OOBR_ciMin field. */
#define BR_SATA_OOBR_ciMin(x) (HW_SATA_OOBR(x).B.ciMin)

/*! @brief Format value for bitfield SATA_OOBR_ciMin. */
#define BF_SATA_OOBR_ciMin(v) ((uint32_t)((uint32_t)(v) << BP_SATA_OOBR_ciMin) & BM_SATA_OOBR_ciMin)

/*! @brief Set the ciMin field to a new value. */
#define BW_SATA_OOBR_ciMin(x, v) (HW_SATA_OOBR_WR(x, (HW_SATA_OOBR_RD(x) & ~BM_SATA_OOBR_ciMin) | BF_SATA_OOBR_ciMin(v)))
/*@}*/

/*!
 * @name Register SATA_OOBR, field cwMax[23:16] (RW)
 *
 * COMWAKE Maximum Value This field is RW when WE=1 and RO when WE=0.
 */
/*@{*/
#define BP_SATA_OOBR_cwMax   (16U)         /*!< Bit position for SATA_OOBR_cwMax. */
#define BM_SATA_OOBR_cwMax   (0x00FF0000U) /*!< Bit mask for SATA_OOBR_cwMax. */
#define BS_SATA_OOBR_cwMax   (8U)          /*!< Bit field size in bits for SATA_OOBR_cwMax. */

/*! @brief Read current value of the SATA_OOBR_cwMax field. */
#define BR_SATA_OOBR_cwMax(x) (HW_SATA_OOBR(x).B.cwMax)

/*! @brief Format value for bitfield SATA_OOBR_cwMax. */
#define BF_SATA_OOBR_cwMax(v) ((uint32_t)((uint32_t)(v) << BP_SATA_OOBR_cwMax) & BM_SATA_OOBR_cwMax)

/*! @brief Set the cwMax field to a new value. */
#define BW_SATA_OOBR_cwMax(x, v) (HW_SATA_OOBR_WR(x, (HW_SATA_OOBR_RD(x) & ~BM_SATA_OOBR_cwMax) | BF_SATA_OOBR_cwMax(v)))
/*@}*/

/*!
 * @name Register SATA_OOBR, field cwMin[30:24] (RW)
 *
 * COMWAKE Minimum Value This field is RW when WE=1 and RO when WE=0.
 */
/*@{*/
#define BP_SATA_OOBR_cwMin   (24U)         /*!< Bit position for SATA_OOBR_cwMin. */
#define BM_SATA_OOBR_cwMin   (0x7F000000U) /*!< Bit mask for SATA_OOBR_cwMin. */
#define BS_SATA_OOBR_cwMin   (7U)          /*!< Bit field size in bits for SATA_OOBR_cwMin. */

/*! @brief Read current value of the SATA_OOBR_cwMin field. */
#define BR_SATA_OOBR_cwMin(x) (HW_SATA_OOBR(x).B.cwMin)

/*! @brief Format value for bitfield SATA_OOBR_cwMin. */
#define BF_SATA_OOBR_cwMin(v) ((uint32_t)((uint32_t)(v) << BP_SATA_OOBR_cwMin) & BM_SATA_OOBR_cwMin)

/*! @brief Set the cwMin field to a new value. */
#define BW_SATA_OOBR_cwMin(x, v) (HW_SATA_OOBR_WR(x, (HW_SATA_OOBR_RD(x) & ~BM_SATA_OOBR_cwMin) | BF_SATA_OOBR_cwMin(v)))
/*@}*/

/*!
 * @name Register SATA_OOBR, field WE[31] (RW)
 *
 * Write Enable This bit is cleared when COMRESET is detected. The options for
 * this field are:
 *
 * Values:
 * - 1 - SATA_OOBR bits [30:0] can be written
 * - 0 - SATA_OOBR bits [30:0] are read-only
 */
/*@{*/
#define BP_SATA_OOBR_WE      (31U)         /*!< Bit position for SATA_OOBR_WE. */
#define BM_SATA_OOBR_WE      (0x80000000U) /*!< Bit mask for SATA_OOBR_WE. */
#define BS_SATA_OOBR_WE      (1U)          /*!< Bit field size in bits for SATA_OOBR_WE. */

/*! @brief Read current value of the SATA_OOBR_WE field. */
#define BR_SATA_OOBR_WE(x)   (HW_SATA_OOBR(x).B.WE)

/*! @brief Format value for bitfield SATA_OOBR_WE. */
#define BF_SATA_OOBR_WE(v)   ((uint32_t)((uint32_t)(v) << BP_SATA_OOBR_WE) & BM_SATA_OOBR_WE)

/*! @brief Set the WE field to a new value. */
#define BW_SATA_OOBR_WE(x, v) (HW_SATA_OOBR_WR(x, (HW_SATA_OOBR_RD(x) & ~BM_SATA_OOBR_WE) | BF_SATA_OOBR_WE(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_GPCR - General Purpose Control Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_GPCR - General Purpose Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit register is used for general purpose control. This register only
 * exists when GP_CTRL parameter is set to "Include" otherwise this location is
 * reserved. The bits of this register are connected to the corresponding bits of
 * the gp_ctrl output. Resets on power-up (system reset) only to the GP_CTRL_DEF
 * value.
 */
typedef union _hw_sata_gpcr
{
    uint32_t U;
    struct _hw_sata_gpcr_bitfields
    {
        uint32_t GP_CONTROL : 32;      /*!< [31:0]  */
    } B;
} hw_sata_gpcr_t;

/*!
 * @name Constants and macros for entire SATA_GPCR register
 */
/*@{*/
#define HW_SATA_GPCR_ADDR(x)     ((uintptr_t)(x) + 0xD0U)

#define HW_SATA_GPCR(x)          (*(__IO hw_sata_gpcr_t *) HW_SATA_GPCR_ADDR(x))
#define HW_SATA_GPCR_RD(x)       (HW_SATA_GPCR(x).U)
#define HW_SATA_GPCR_WR(x, v)    (HW_SATA_GPCR(x).U = (v))
#define HW_SATA_GPCR_SET(x, v)   (HW_SATA_GPCR_WR(x, HW_SATA_GPCR_RD(x) |  (v)))
#define HW_SATA_GPCR_CLR(x, v)   (HW_SATA_GPCR_WR(x, HW_SATA_GPCR_RD(x) & ~(v)))
#define HW_SATA_GPCR_TOG(x, v)   (HW_SATA_GPCR_WR(x, HW_SATA_GPCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_GPCR bitfields
 */

/*!
 * @name Register SATA_GPCR, field GP_CONTROL[31:0] (RW)
 *
 * General Purpose Control. Present only when GP_CTRL=Include(1). Reset Value:
 * Configurable parameter GP_CTRL_DEF
 */
/*@{*/
#define BP_SATA_GPCR_GP_CONTROL (0U)       /*!< Bit position for SATA_GPCR_GP_CONTROL. */
#define BM_SATA_GPCR_GP_CONTROL (0xFFFFFFFFU) /*!< Bit mask for SATA_GPCR_GP_CONTROL. */
#define BS_SATA_GPCR_GP_CONTROL (32U)      /*!< Bit field size in bits for SATA_GPCR_GP_CONTROL. */

/*! @brief Read current value of the SATA_GPCR_GP_CONTROL field. */
#define BR_SATA_GPCR_GP_CONTROL(x) (HW_SATA_GPCR(x).U)

/*! @brief Format value for bitfield SATA_GPCR_GP_CONTROL. */
#define BF_SATA_GPCR_GP_CONTROL(v) ((uint32_t)((uint32_t)(v) << BP_SATA_GPCR_GP_CONTROL) & BM_SATA_GPCR_GP_CONTROL)

/*! @brief Set the GP_CONTROL field to a new value. */
#define BW_SATA_GPCR_GP_CONTROL(x, v) (HW_SATA_GPCR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SATA_GPSR - General Purpose Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_GPSR - General Purpose Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit register is used to monitor the general purpose status. This
 * register only exists when GP_STAT parameter is set to "Include", otherwise, this
 * location is reserved. The bits of this register reflect the state of the
 * corresponding bits of the gp_status input. Signals connected to the gp_status input
 * can be asynchronous to any of the DWC_ahsata clocks, however they must not
 * change faster than five hclk/aclk periods, otherwise the GPSR register may never
 * be updated with the intermediate changing values.
 */
typedef union _hw_sata_gpsr
{
    uint32_t U;
    struct _hw_sata_gpsr_bitfields
    {
        uint32_t GP_STATUS : 32;       /*!< [31:0]  */
    } B;
} hw_sata_gpsr_t;

/*!
 * @name Constants and macros for entire SATA_GPSR register
 */
/*@{*/
#define HW_SATA_GPSR_ADDR(x)     ((uintptr_t)(x) + 0xD4U)

#define HW_SATA_GPSR(x)          (*(__IO hw_sata_gpsr_t *) HW_SATA_GPSR_ADDR(x))
#define HW_SATA_GPSR_RD(x)       (HW_SATA_GPSR(x).U)
#define HW_SATA_GPSR_WR(x, v)    (HW_SATA_GPSR(x).U = (v))
#define HW_SATA_GPSR_SET(x, v)   (HW_SATA_GPSR_WR(x, HW_SATA_GPSR_RD(x) |  (v)))
#define HW_SATA_GPSR_CLR(x, v)   (HW_SATA_GPSR_WR(x, HW_SATA_GPSR_RD(x) & ~(v)))
#define HW_SATA_GPSR_TOG(x, v)   (HW_SATA_GPSR_WR(x, HW_SATA_GPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_GPSR bitfields
 */

/*!
 * @name Register SATA_GPSR, field GP_STATUS[31:0] (RW)
 *
 * General Purpose Status. Present only when GP_STAT=Include(1)
 */
/*@{*/
#define BP_SATA_GPSR_GP_STATUS (0U)        /*!< Bit position for SATA_GPSR_GP_STATUS. */
#define BM_SATA_GPSR_GP_STATUS (0xFFFFFFFFU) /*!< Bit mask for SATA_GPSR_GP_STATUS. */
#define BS_SATA_GPSR_GP_STATUS (32U)       /*!< Bit field size in bits for SATA_GPSR_GP_STATUS. */

/*! @brief Read current value of the SATA_GPSR_GP_STATUS field. */
#define BR_SATA_GPSR_GP_STATUS(x) (HW_SATA_GPSR(x).U)

/*! @brief Format value for bitfield SATA_GPSR_GP_STATUS. */
#define BF_SATA_GPSR_GP_STATUS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_GPSR_GP_STATUS) & BM_SATA_GPSR_GP_STATUS)

/*! @brief Set the GP_STATUS field to a new value. */
#define BW_SATA_GPSR_GP_STATUS(x, v) (HW_SATA_GPSR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SATA_TIMER1MS - Timer 1-ms Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_TIMER1MS - Timer 1-ms Register (RW)
 *
 * Reset value: 0x000186A0U
 *
 * This register is used to generate a 1-ms tick for the command completion
 * coalescing (CCC) logic, based on the AHB bus clock frequency. The Software must
 * initialize this register with the required value after power up before using the
 * CCC feature. This register is reset to 100,000 (TIMV value for 100-MHz hclk)
 * on power up and is not affected by Global reset.
 */
typedef union _hw_sata_timer1ms
{
    uint32_t U;
    struct _hw_sata_timer1ms_bitfields
    {
        uint32_t TIMV : 20;            /*!< [19:0]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_sata_timer1ms_t;

/*!
 * @name Constants and macros for entire SATA_TIMER1MS register
 */
/*@{*/
#define HW_SATA_TIMER1MS_ADDR(x) ((uintptr_t)(x) + 0xE0U)

#define HW_SATA_TIMER1MS(x)      (*(__IO hw_sata_timer1ms_t *) HW_SATA_TIMER1MS_ADDR(x))
#define HW_SATA_TIMER1MS_RD(x)   (HW_SATA_TIMER1MS(x).U)
#define HW_SATA_TIMER1MS_WR(x, v) (HW_SATA_TIMER1MS(x).U = (v))
#define HW_SATA_TIMER1MS_SET(x, v) (HW_SATA_TIMER1MS_WR(x, HW_SATA_TIMER1MS_RD(x) |  (v)))
#define HW_SATA_TIMER1MS_CLR(x, v) (HW_SATA_TIMER1MS_WR(x, HW_SATA_TIMER1MS_RD(x) & ~(v)))
#define HW_SATA_TIMER1MS_TOG(x, v) (HW_SATA_TIMER1MS_WR(x, HW_SATA_TIMER1MS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_TIMER1MS bitfields
 */

/*!
 * @name Register SATA_TIMER1MS, field TIMV[19:0] (RW)
 *
 * 1ms Timer Value This field contains the following value for the internal
 * timer to generate 1-ms tick: Fhclk*1000 where Fhclk = AHB clock frequency in MHz
 * The options for this field are: • RW when SATA_CCC_CTL[EN]==0 • RO when
 * SATA_CCC_CTL[EN]==1.
 */
/*@{*/
#define BP_SATA_TIMER1MS_TIMV (0U)         /*!< Bit position for SATA_TIMER1MS_TIMV. */
#define BM_SATA_TIMER1MS_TIMV (0x000FFFFFU) /*!< Bit mask for SATA_TIMER1MS_TIMV. */
#define BS_SATA_TIMER1MS_TIMV (20U)        /*!< Bit field size in bits for SATA_TIMER1MS_TIMV. */

/*! @brief Read current value of the SATA_TIMER1MS_TIMV field. */
#define BR_SATA_TIMER1MS_TIMV(x) (HW_SATA_TIMER1MS(x).B.TIMV)

/*! @brief Format value for bitfield SATA_TIMER1MS_TIMV. */
#define BF_SATA_TIMER1MS_TIMV(v) ((uint32_t)((uint32_t)(v) << BP_SATA_TIMER1MS_TIMV) & BM_SATA_TIMER1MS_TIMV)

/*! @brief Set the TIMV field to a new value. */
#define BW_SATA_TIMER1MS_TIMV(x, v) (HW_SATA_TIMER1MS_WR(x, (HW_SATA_TIMER1MS_RD(x) & ~BM_SATA_TIMER1MS_TIMV) | BF_SATA_TIMER1MS_TIMV(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_TESTR - Test Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_TESTR - Test Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to put the SATA block slave interface into a test mode
 * and to select a Port for BIST operation.
 */
typedef union _hw_sata_testr
{
    uint32_t U;
    struct _hw_sata_testr_bitfields
    {
        uint32_t TEST_IF : 1;          /*!< [0]  */
        uint32_t RESERVED0 : 15;       /*!< [15:1]  */
        uint32_t PSEL : 3;             /*!< [18:16]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_sata_testr_t;

/*!
 * @name Constants and macros for entire SATA_TESTR register
 */
/*@{*/
#define HW_SATA_TESTR_ADDR(x)    ((uintptr_t)(x) + 0xF4U)

#define HW_SATA_TESTR(x)         (*(__IO hw_sata_testr_t *) HW_SATA_TESTR_ADDR(x))
#define HW_SATA_TESTR_RD(x)      (HW_SATA_TESTR(x).U)
#define HW_SATA_TESTR_WR(x, v)   (HW_SATA_TESTR(x).U = (v))
#define HW_SATA_TESTR_SET(x, v)  (HW_SATA_TESTR_WR(x, HW_SATA_TESTR_RD(x) |  (v)))
#define HW_SATA_TESTR_CLR(x, v)  (HW_SATA_TESTR_WR(x, HW_SATA_TESTR_RD(x) & ~(v)))
#define HW_SATA_TESTR_TOG(x, v)  (HW_SATA_TESTR_WR(x, HW_SATA_TESTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_TESTR bitfields
 */

/*!
 * @name Register SATA_TESTR, field TEST_IF[0] (RW)
 *
 * TEST_IF: Test Interface Normal operation is disabled. The following registers
 * can be accessed in this mode: - SATA_GHC register IE bit - SATA_BISTAFR
 * register NCP and PD bits become read-write - SATA_BISTCR register LLC, ERREN, FLIP,
 * PV, PATTERN - SATA_BISTFCTR, SATA_BISTSR become read-write - SATA_P 0 CLB ,
 * SATA_P 0 FB registers - SATA_P 0 IS register RW1C and UFS bits become
 * read-write - SATA_P 0 IE register - SATA_P 0 CMD register ASP, ALPE, DLAE, ATAPI, PMA
 * bits - SATA_P 0 TFD, SATA_P 0 SIG registers become read-write - SATA_P 0 SCTL
 * register - SATA_P 0 SERR register RW1C bits become read-write bits - SATA_P 0
 * SACT, SATA_P 0 CI, SATA_P 0 SNTF registers become read-write - SATA_P 0 DMACR
 * register - SATA_P 0 PHYCR register - SATA_P 0 PHYSR register becomes read-write
 * Notes: • Interrupt is asserted when any of the SATA_IS register bits is set
 * after setting the corresponding SATA_P 0 IS and SATA_P 0 IE registers and
 * SATA_GHC[IE]=1. • SATA_CAP[SMPS], SATA_CAP[SSS], SATA_PI, SATA_P 0 CMD[ESP],
 * SATA_P 0 CMD[CPD], SATA_P 0 CMD[MPSP], and SATA_P 0 CMD[HPCP] register bits are
 * HwInit type and can not be used in Test mode. They are written once after
 * power-on reset and become read-only. • Global SATA block reset must be issued
 * (SATA_GHC[HR]=1) after TEST_WHEN bit is cleared following the Test mode
 * operation. This bit is used to put the SATA block slave interface into the test mode:
 * The options for this field are:
 *
 * Values:
 * - 0 - Normal mode: the read back value of some registers is a function of the
 *     SATA block state and does not match the value written.
 * - 1 - Test mode: the read back value of the registers matches the value
 *     written.
 */
/*@{*/
#define BP_SATA_TESTR_TEST_IF (0U)         /*!< Bit position for SATA_TESTR_TEST_IF. */
#define BM_SATA_TESTR_TEST_IF (0x00000001U) /*!< Bit mask for SATA_TESTR_TEST_IF. */
#define BS_SATA_TESTR_TEST_IF (1U)         /*!< Bit field size in bits for SATA_TESTR_TEST_IF. */

/*! @brief Read current value of the SATA_TESTR_TEST_IF field. */
#define BR_SATA_TESTR_TEST_IF(x) (HW_SATA_TESTR(x).B.TEST_IF)

/*! @brief Format value for bitfield SATA_TESTR_TEST_IF. */
#define BF_SATA_TESTR_TEST_IF(v) ((uint32_t)((uint32_t)(v) << BP_SATA_TESTR_TEST_IF) & BM_SATA_TESTR_TEST_IF)

/*! @brief Set the TEST_IF field to a new value. */
#define BW_SATA_TESTR_TEST_IF(x, v) (HW_SATA_TESTR_WR(x, (HW_SATA_TESTR_RD(x) & ~BM_SATA_TESTR_TEST_IF) | BF_SATA_TESTR_TEST_IF(v)))
/*@}*/

/*!
 * @name Register SATA_TESTR, field PSEL[18:16] (RW)
 *
 * Port Select This field is used to select a Port for BIST operation: The
 * options for this field are:
 *
 * Values:
 * - 0 - Port0 is selected
 * - 0 - Port1 is selected
 * - 0 - Port2 is selected
 * - 0 - Port3 is selected
 * - 0 - Port4 is selected
 * - 0 - Port5 is selected
 * - 0 - Port6 is selected
 * - 0 - Port7 is selected
 */
/*@{*/
#define BP_SATA_TESTR_PSEL   (16U)         /*!< Bit position for SATA_TESTR_PSEL. */
#define BM_SATA_TESTR_PSEL   (0x00070000U) /*!< Bit mask for SATA_TESTR_PSEL. */
#define BS_SATA_TESTR_PSEL   (3U)          /*!< Bit field size in bits for SATA_TESTR_PSEL. */

/*! @brief Read current value of the SATA_TESTR_PSEL field. */
#define BR_SATA_TESTR_PSEL(x) (HW_SATA_TESTR(x).B.PSEL)

/*! @brief Format value for bitfield SATA_TESTR_PSEL. */
#define BF_SATA_TESTR_PSEL(v) ((uint32_t)((uint32_t)(v) << BP_SATA_TESTR_PSEL) & BM_SATA_TESTR_PSEL)

/*! @brief Set the PSEL field to a new value. */
#define BW_SATA_TESTR_PSEL(x, v) (HW_SATA_TESTR_WR(x, (HW_SATA_TESTR_RD(x) & ~BM_SATA_TESTR_PSEL) | BF_SATA_TESTR_PSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_VERSIONR - Version Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_VERSIONR - Version Register (RO)
 *
 * Reset value: 0x3330302AU
 *
 * This 32-bit read-only register contains a hard-coded ASCII string that
 * represents the version level of the SATA block. This register contains the ASCII
 * string "300*" (hexadecimal 0x3330302A).
 */
typedef union _hw_sata_versionr
{
    uint32_t U;
    struct _hw_sata_versionr_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_sata_versionr_t;

/*!
 * @name Constants and macros for entire SATA_VERSIONR register
 */
/*@{*/
#define HW_SATA_VERSIONR_ADDR(x) ((uintptr_t)(x) + 0xF8U)

#define HW_SATA_VERSIONR(x)      (*(__I hw_sata_versionr_t *) HW_SATA_VERSIONR_ADDR(x))
#define HW_SATA_VERSIONR_RD(x)   (HW_SATA_VERSIONR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_VERSIONR bitfields
 */

/*******************************************************************************
 * HW_SATA_P0CLB - Port0 Command List Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0CLB - Port0 Command List Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sata_p0clb
{
    uint32_t U;
    struct _hw_sata_p0clb_bitfields
    {
        uint32_t RESERVED0 : 10;       /*!< [9:0]  */
        uint32_t CLB : 22;             /*!< [31:10]  */
    } B;
} hw_sata_p0clb_t;

/*!
 * @name Constants and macros for entire SATA_P0CLB register
 */
/*@{*/
#define HW_SATA_P0CLB_ADDR(x)    ((uintptr_t)(x) + 0x100U)

#define HW_SATA_P0CLB(x)         (*(__IO hw_sata_p0clb_t *) HW_SATA_P0CLB_ADDR(x))
#define HW_SATA_P0CLB_RD(x)      (HW_SATA_P0CLB(x).U)
#define HW_SATA_P0CLB_WR(x, v)   (HW_SATA_P0CLB(x).U = (v))
#define HW_SATA_P0CLB_SET(x, v)  (HW_SATA_P0CLB_WR(x, HW_SATA_P0CLB_RD(x) |  (v)))
#define HW_SATA_P0CLB_CLR(x, v)  (HW_SATA_P0CLB_WR(x, HW_SATA_P0CLB_RD(x) & ~(v)))
#define HW_SATA_P0CLB_TOG(x, v)  (HW_SATA_P0CLB_WR(x, HW_SATA_P0CLB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0CLB bitfields
 */

/*!
 * @name Register SATA_P0CLB, field CLB[31:10] (RW)
 *
 * Command List Base Address Indicates the 32-bit base physical address for the
 * command list for this Port. This base is used when fetching commands to
 * execute. The structure pointed to by this address range is 1 KB in length. This
 * address must be 1-KB-aligned as indicated by bits [9:0] being read only.
 */
/*@{*/
#define BP_SATA_P0CLB_CLB    (10U)         /*!< Bit position for SATA_P0CLB_CLB. */
#define BM_SATA_P0CLB_CLB    (0xFFFFFC00U) /*!< Bit mask for SATA_P0CLB_CLB. */
#define BS_SATA_P0CLB_CLB    (22U)         /*!< Bit field size in bits for SATA_P0CLB_CLB. */

/*! @brief Read current value of the SATA_P0CLB_CLB field. */
#define BR_SATA_P0CLB_CLB(x) (HW_SATA_P0CLB(x).B.CLB)

/*! @brief Format value for bitfield SATA_P0CLB_CLB. */
#define BF_SATA_P0CLB_CLB(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CLB_CLB) & BM_SATA_P0CLB_CLB)

/*! @brief Set the CLB field to a new value. */
#define BW_SATA_P0CLB_CLB(x, v) (HW_SATA_P0CLB_WR(x, (HW_SATA_P0CLB_RD(x) & ~BM_SATA_P0CLB_CLB) | BF_SATA_P0CLB_CLB(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0FB - Port0 FIS Base Address Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0FB - Port0 FIS Base Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sata_p0fb
{
    uint32_t U;
    struct _hw_sata_p0fb_bitfields
    {
        uint32_t RESERVED0 : 8;        /*!< [7:0]  */
        uint32_t FB : 24;              /*!< [31:8]  */
    } B;
} hw_sata_p0fb_t;

/*!
 * @name Constants and macros for entire SATA_P0FB register
 */
/*@{*/
#define HW_SATA_P0FB_ADDR(x)     ((uintptr_t)(x) + 0x108U)

#define HW_SATA_P0FB(x)          (*(__IO hw_sata_p0fb_t *) HW_SATA_P0FB_ADDR(x))
#define HW_SATA_P0FB_RD(x)       (HW_SATA_P0FB(x).U)
#define HW_SATA_P0FB_WR(x, v)    (HW_SATA_P0FB(x).U = (v))
#define HW_SATA_P0FB_SET(x, v)   (HW_SATA_P0FB_WR(x, HW_SATA_P0FB_RD(x) |  (v)))
#define HW_SATA_P0FB_CLR(x, v)   (HW_SATA_P0FB_WR(x, HW_SATA_P0FB_RD(x) & ~(v)))
#define HW_SATA_P0FB_TOG(x, v)   (HW_SATA_P0FB_WR(x, HW_SATA_P0FB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0FB bitfields
 */

/*!
 * @name Register SATA_P0FB, field FB[31:8] (RW)
 *
 * FIS Base Address. Indicates the 32-bit base physical address for received
 * FISes. The structure pointed to by this address range is 256 bytes in length.
 * This address must be 256byte-aligned as indicated by bits [7:0] being read only.
 * Reset: 0x000000
 */
/*@{*/
#define BP_SATA_P0FB_FB      (8U)          /*!< Bit position for SATA_P0FB_FB. */
#define BM_SATA_P0FB_FB      (0xFFFFFF00U) /*!< Bit mask for SATA_P0FB_FB. */
#define BS_SATA_P0FB_FB      (24U)         /*!< Bit field size in bits for SATA_P0FB_FB. */

/*! @brief Read current value of the SATA_P0FB_FB field. */
#define BR_SATA_P0FB_FB(x)   (HW_SATA_P0FB(x).B.FB)

/*! @brief Format value for bitfield SATA_P0FB_FB. */
#define BF_SATA_P0FB_FB(v)   ((uint32_t)((uint32_t)(v) << BP_SATA_P0FB_FB) & BM_SATA_P0FB_FB)

/*! @brief Set the FB field to a new value. */
#define BW_SATA_P0FB_FB(x, v) (HW_SATA_P0FB_WR(x, (HW_SATA_P0FB_RD(x) & ~BM_SATA_P0FB_FB) | BF_SATA_P0FB_FB(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0IS - Port0 Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0IS - Port0 Interrupt Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to generate SATA block interrupt when any of the bits
 * are set. Bits in this register are set by some internal conditions, and cleared
 * by the software writing ones in the positions it wants to clear. This
 * register is reset on Global SATA block reset.
 */
typedef union _hw_sata_p0is
{
    uint32_t U;
    struct _hw_sata_p0is_bitfields
    {
        uint32_t DHRS : 1;             /*!< [0]  */
        uint32_t PSS : 1;              /*!< [1]  */
        uint32_t DSS : 1;              /*!< [2]  */
        uint32_t SDBS : 1;             /*!< [3]  */
        uint32_t UFS : 1;              /*!< [4]  */
        uint32_t DPS : 1;              /*!< [5]  */
        uint32_t PCS : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 15;       /*!< [21:7]  */
        uint32_t PRCS : 1;             /*!< [22]  */
        uint32_t IPMS : 1;             /*!< [23]  */
        uint32_t OFS : 1;              /*!< [24]  */
        uint32_t RESERVED1 : 1;        /*!< [25]  */
        uint32_t INFS : 1;             /*!< [26]  */
        uint32_t IFS : 1;              /*!< [27]  */
        uint32_t HBDS : 1;             /*!< [28]  */
        uint32_t HBFS : 1;             /*!< [29]  */
        uint32_t TFES : 1;             /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_sata_p0is_t;

/*!
 * @name Constants and macros for entire SATA_P0IS register
 */
/*@{*/
#define HW_SATA_P0IS_ADDR(x)     ((uintptr_t)(x) + 0x110U)

#define HW_SATA_P0IS(x)          (*(__I hw_sata_p0is_t *) HW_SATA_P0IS_ADDR(x))
#define HW_SATA_P0IS_RD(x)       (HW_SATA_P0IS(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0IS bitfields
 */

/*!
 * @name Register SATA_P0IS, field DHRS[0] (RO)
 *
 * Device to Host Register FIS Interrupt A D2H Register FIS has been received
 * with the 'I' bit set, and has been copied into system memory.
 */
/*@{*/
#define BP_SATA_P0IS_DHRS    (0U)          /*!< Bit position for SATA_P0IS_DHRS. */
#define BM_SATA_P0IS_DHRS    (0x00000001U) /*!< Bit mask for SATA_P0IS_DHRS. */
#define BS_SATA_P0IS_DHRS    (1U)          /*!< Bit field size in bits for SATA_P0IS_DHRS. */

/*! @brief Read current value of the SATA_P0IS_DHRS field. */
#define BR_SATA_P0IS_DHRS(x) (HW_SATA_P0IS(x).B.DHRS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field PSS[1] (RO)
 *
 * PIO Setup FIS Interrupt. A PIO Setup FIS has been received with the 'I' bit
 * set, it has been copied into system memory, and the data related to that FIS
 * has been transferred. This bit is set even when the data transfer resulted in an
 * error.
 */
/*@{*/
#define BP_SATA_P0IS_PSS     (1U)          /*!< Bit position for SATA_P0IS_PSS. */
#define BM_SATA_P0IS_PSS     (0x00000002U) /*!< Bit mask for SATA_P0IS_PSS. */
#define BS_SATA_P0IS_PSS     (1U)          /*!< Bit field size in bits for SATA_P0IS_PSS. */

/*! @brief Read current value of the SATA_P0IS_PSS field. */
#define BR_SATA_P0IS_PSS(x)  (HW_SATA_P0IS(x).B.PSS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field DSS[2] (RO)
 *
 * DMA Setup FIS Interrupt A DMA Setup FIS has been received with the 'I' bit
 * set and has been copied into system memory.
 */
/*@{*/
#define BP_SATA_P0IS_DSS     (2U)          /*!< Bit position for SATA_P0IS_DSS. */
#define BM_SATA_P0IS_DSS     (0x00000004U) /*!< Bit mask for SATA_P0IS_DSS. */
#define BS_SATA_P0IS_DSS     (1U)          /*!< Bit field size in bits for SATA_P0IS_DSS. */

/*! @brief Read current value of the SATA_P0IS_DSS field. */
#define BR_SATA_P0IS_DSS(x)  (HW_SATA_P0IS(x).B.DSS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field SDBS[3] (RO)
 *
 * Set Device Bits Interrupt. A Set Device Bits FIS has been received with the
 * 'I' bit set and has been copied into system memory.
 */
/*@{*/
#define BP_SATA_P0IS_SDBS    (3U)          /*!< Bit position for SATA_P0IS_SDBS. */
#define BM_SATA_P0IS_SDBS    (0x00000008U) /*!< Bit mask for SATA_P0IS_SDBS. */
#define BS_SATA_P0IS_SDBS    (1U)          /*!< Bit field size in bits for SATA_P0IS_SDBS. */

/*! @brief Read current value of the SATA_P0IS_SDBS field. */
#define BR_SATA_P0IS_SDBS(x) (HW_SATA_P0IS(x).B.SDBS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field UFS[4] (RO)
 *
 * Unknown FIS Interrupt. When set to 1, indicates that an unknown FIS was
 * received and has been copied into system memory. This bit is cleared to 0 by the
 * software clearing the SATA_P 0 SERR[DIAG_F] bit to 0. The UFS bit does not
 * directly reflect the SATA_P 0 SERR[DIAG_F] bit. SATA_P 0 SERR[DIAG_F] bit is set
 * immediately when an unknown FIS is detected, whereas the UFS bit is set when
 * that FIS is posted to memory. The software should wait to act on an unknown FIS
 * until the UFS bit is set to 1 or the two bits may become out of sync.
 */
/*@{*/
#define BP_SATA_P0IS_UFS     (4U)          /*!< Bit position for SATA_P0IS_UFS. */
#define BM_SATA_P0IS_UFS     (0x00000010U) /*!< Bit mask for SATA_P0IS_UFS. */
#define BS_SATA_P0IS_UFS     (1U)          /*!< Bit field size in bits for SATA_P0IS_UFS. */

/*! @brief Read current value of the SATA_P0IS_UFS field. */
#define BR_SATA_P0IS_UFS(x)  (HW_SATA_P0IS(x).B.UFS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field DPS[5] (RO)
 *
 * Descriptor Processed A PRD with the I bit set has transferred all of its
 * data. This is an opportunistic interrupt and must not be used to definitively
 * indicate the end of a transfer. Two PRD interrupts could happen close in time
 * together such that the second interrupt is missed when the first PRD interrupt is
 * being cleared.
 */
/*@{*/
#define BP_SATA_P0IS_DPS     (5U)          /*!< Bit position for SATA_P0IS_DPS. */
#define BM_SATA_P0IS_DPS     (0x00000020U) /*!< Bit mask for SATA_P0IS_DPS. */
#define BS_SATA_P0IS_DPS     (1U)          /*!< Bit field size in bits for SATA_P0IS_DPS. */

/*! @brief Read current value of the SATA_P0IS_DPS field. */
#define BR_SATA_P0IS_DPS(x)  (HW_SATA_P0IS(x).B.DPS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field PCS[6] (RO)
 *
 * Port Connect Change Status This bit is cleared only when SATA_P 0
 * SERR[DIAG_X] is cleared. This bit reflects the state of the SATA_P 0 SERR[DIAG_X] bit:
 *
 * Values:
 * - 1 - Change in Current Connect Status;
 * - 0 - No change in Current Connect Status.
 */
/*@{*/
#define BP_SATA_P0IS_PCS     (6U)          /*!< Bit position for SATA_P0IS_PCS. */
#define BM_SATA_P0IS_PCS     (0x00000040U) /*!< Bit mask for SATA_P0IS_PCS. */
#define BS_SATA_P0IS_PCS     (1U)          /*!< Bit field size in bits for SATA_P0IS_PCS. */

/*! @brief Read current value of the SATA_P0IS_PCS field. */
#define BR_SATA_P0IS_PCS(x)  (HW_SATA_P0IS(x).B.PCS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field PRCS[22] (RO)
 *
 * PHY Ready Change Status This bit reflects the state of the SATA_P 0
 * SERR[DIAG_N] bit. When set to 1, indicates the internal p 0 _phy_ready signal changed
 * state. To clear this bit, the software must clear the SATA_P 0 SERR[DIAG_N] bit
 * to 0.
 */
/*@{*/
#define BP_SATA_P0IS_PRCS    (22U)         /*!< Bit position for SATA_P0IS_PRCS. */
#define BM_SATA_P0IS_PRCS    (0x00400000U) /*!< Bit mask for SATA_P0IS_PRCS. */
#define BS_SATA_P0IS_PRCS    (1U)          /*!< Bit field size in bits for SATA_P0IS_PRCS. */

/*! @brief Read current value of the SATA_P0IS_PRCS field. */
#define BR_SATA_P0IS_PRCS(x) (HW_SATA_P0IS(x).B.PRCS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field IPMS[23] (RO)
 *
 * Incorrect Port Multiplier Status. Indicates that the HBA received a FIS from
 * a device whose Port Multiplier field did not match what was expected. This bit
 * may be set during enumeration of devices on a Port Multiplier due to the
 * normal Port Multiplier enumeration process. The software must use the IPMS bit
 * only after enumeration is complete on the Port Multiplier.
 */
/*@{*/
#define BP_SATA_P0IS_IPMS    (23U)         /*!< Bit position for SATA_P0IS_IPMS. */
#define BM_SATA_P0IS_IPMS    (0x00800000U) /*!< Bit mask for SATA_P0IS_IPMS. */
#define BS_SATA_P0IS_IPMS    (1U)          /*!< Bit field size in bits for SATA_P0IS_IPMS. */

/*! @brief Read current value of the SATA_P0IS_IPMS field. */
#define BR_SATA_P0IS_IPMS(x) (HW_SATA_P0IS(x).B.IPMS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field OFS[24] (RO)
 *
 * Overflow Status This bit is set when command list overflow is detected during
 * read or write operation when the software builds command table that has fever
 * total bytes than the transaction given to the device. Port DMA transitions to
 * a fatal state until the software clears SATA_P 0 CMD[ST] bit or resets the
 * interface by way of Port or Global reset.
 */
/*@{*/
#define BP_SATA_P0IS_OFS     (24U)         /*!< Bit position for SATA_P0IS_OFS. */
#define BM_SATA_P0IS_OFS     (0x01000000U) /*!< Bit mask for SATA_P0IS_OFS. */
#define BS_SATA_P0IS_OFS     (1U)          /*!< Bit field size in bits for SATA_P0IS_OFS. */

/*! @brief Read current value of the SATA_P0IS_OFS field. */
#define BR_SATA_P0IS_OFS(x)  (HW_SATA_P0IS(x).B.OFS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field INFS[26] (RO)
 *
 * Interface Non-fatal Error Status This bit is set when any of the following
 * conditions is detected: • One or more of the following errors are detected
 * during non-data FIS transfer - 10B to 8B Decode Error (SATA_P 0 SERR[DIAG_B]) -
 * Protocol (SATA_P 0 SERR[ERR_P]) - CRC (SATA_P 0 SERR[DIAG_C]), - Handshake
 * (SATA_P 0 SERR[DIAG_H]) - PHY Not Ready (SATA_P 0 SERR[ERR_C]); • Command list
 * underflow during read operation (i.e. DMA read) when the software builds
 * command table that has more total bytes than the transaction given to the device.
 */
/*@{*/
#define BP_SATA_P0IS_INFS    (26U)         /*!< Bit position for SATA_P0IS_INFS. */
#define BM_SATA_P0IS_INFS    (0x04000000U) /*!< Bit mask for SATA_P0IS_INFS. */
#define BS_SATA_P0IS_INFS    (1U)          /*!< Bit field size in bits for SATA_P0IS_INFS. */

/*! @brief Read current value of the SATA_P0IS_INFS field. */
#define BR_SATA_P0IS_INFS(x) (HW_SATA_P0IS(x).B.INFS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field IFS[27] (RO)
 *
 * Interface Fatal Error Status This bit is set when any of the following
 * conditions is detected: • SYNC escape is received from the device during H2D
 * Register or Data FIS transmission; • One or more of the following errors are
 * detected during Data FIS transfer: - 10B to 8B Decode Error (SATA_P 0
 * SERR[DIAG_B]) - Protocol (SATA_P 0 SERR[ERR_P]) - CRC (SATA_P 0 SERR[DIAG_C]) - Handshake
 * (SATA_P 0 SERR[DIAG_H]) - PHY Not Ready (SATA_P 0 SERR[ERR_C]) • Unknown FIS
 * is received with good CRC, but the length exceeds 64 bytes; • PRD table
 * byte count is zero. Port DMA transitions to a fatal state until the software
 * clears SATA_P 0 CMD[ST] bit or resets the interface by way of Port or Global reset.
 */
/*@{*/
#define BP_SATA_P0IS_IFS     (27U)         /*!< Bit position for SATA_P0IS_IFS. */
#define BM_SATA_P0IS_IFS     (0x08000000U) /*!< Bit mask for SATA_P0IS_IFS. */
#define BS_SATA_P0IS_IFS     (1U)          /*!< Bit field size in bits for SATA_P0IS_IFS. */

/*! @brief Read current value of the SATA_P0IS_IFS field. */
#define BR_SATA_P0IS_IFS(x)  (HW_SATA_P0IS(x).B.IFS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field HBDS[28] (RO)
 *
 * Host Bus Data Error Status. This bit is always cleared to 0.
 */
/*@{*/
#define BP_SATA_P0IS_HBDS    (28U)         /*!< Bit position for SATA_P0IS_HBDS. */
#define BM_SATA_P0IS_HBDS    (0x10000000U) /*!< Bit mask for SATA_P0IS_HBDS. */
#define BS_SATA_P0IS_HBDS    (1U)          /*!< Bit field size in bits for SATA_P0IS_HBDS. */

/*! @brief Read current value of the SATA_P0IS_HBDS field. */
#define BR_SATA_P0IS_HBDS(x) (HW_SATA_P0IS(x).B.HBDS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field HBFS[29] (RO)
 *
 * Host Bus Fatal Error Status. This bit is set when SATA block AHB Master
 * detects an ERROR response from the slave.
 */
/*@{*/
#define BP_SATA_P0IS_HBFS    (29U)         /*!< Bit position for SATA_P0IS_HBFS. */
#define BM_SATA_P0IS_HBFS    (0x20000000U) /*!< Bit mask for SATA_P0IS_HBFS. */
#define BS_SATA_P0IS_HBFS    (1U)          /*!< Bit field size in bits for SATA_P0IS_HBFS. */

/*! @brief Read current value of the SATA_P0IS_HBFS field. */
#define BR_SATA_P0IS_HBFS(x) (HW_SATA_P0IS(x).B.HBFS)
/*@}*/

/*!
 * @name Register SATA_P0IS, field TFES[30] (RO)
 *
 * Task File Error Status. This bit is set whenever the SATA_P 0 TFD[STS]
 * register is updated by the device and the error bit (bit 0) is set.
 */
/*@{*/
#define BP_SATA_P0IS_TFES    (30U)         /*!< Bit position for SATA_P0IS_TFES. */
#define BM_SATA_P0IS_TFES    (0x40000000U) /*!< Bit mask for SATA_P0IS_TFES. */
#define BS_SATA_P0IS_TFES    (1U)          /*!< Bit field size in bits for SATA_P0IS_TFES. */

/*! @brief Read current value of the SATA_P0IS_TFES field. */
#define BR_SATA_P0IS_TFES(x) (HW_SATA_P0IS(x).B.TFES)
/*@}*/

/*******************************************************************************
 * HW_SATA_P0IE - Port0 Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0IE - Port0 Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register enables and disables the reporting of the corresponding
 * interrupt to the software. When a bit is set (1), and the corresponding interrupt
 * condition is active, then the SATA block intrq output is asserted. Interrupt
 * sources that are disabled (0) are still reflected in the status registers. This
 * register is symmetrical with the SATA_P 0 IS register. This register is reset on
 * Global SATA block reset.
 */
typedef union _hw_sata_p0ie
{
    uint32_t U;
    struct _hw_sata_p0ie_bitfields
    {
        uint32_t DHRE : 1;             /*!< [0]  */
        uint32_t PSE : 1;              /*!< [1]  */
        uint32_t DSE : 1;              /*!< [2]  */
        uint32_t SDBE : 1;             /*!< [3]  */
        uint32_t UFE : 1;              /*!< [4]  */
        uint32_t DPE : 1;              /*!< [5]  */
        uint32_t PCE : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 15;       /*!< [21:7]  */
        uint32_t PRCE : 1;             /*!< [22]  */
        uint32_t IPME : 1;             /*!< [23]  */
        uint32_t OFE : 1;              /*!< [24]  */
        uint32_t RESERVED1 : 1;        /*!< [25]  */
        uint32_t INFE : 1;             /*!< [26]  */
        uint32_t IFE : 1;              /*!< [27]  */
        uint32_t HBDE : 1;             /*!< [28]  */
        uint32_t HBFE : 1;             /*!< [29]  */
        uint32_t TFEE : 1;             /*!< [30]  */
        uint32_t CPDE : 1;             /*!< [31]  */
    } B;
} hw_sata_p0ie_t;

/*!
 * @name Constants and macros for entire SATA_P0IE register
 */
/*@{*/
#define HW_SATA_P0IE_ADDR(x)     ((uintptr_t)(x) + 0x114U)

#define HW_SATA_P0IE(x)          (*(__IO hw_sata_p0ie_t *) HW_SATA_P0IE_ADDR(x))
#define HW_SATA_P0IE_RD(x)       (HW_SATA_P0IE(x).U)
#define HW_SATA_P0IE_WR(x, v)    (HW_SATA_P0IE(x).U = (v))
#define HW_SATA_P0IE_SET(x, v)   (HW_SATA_P0IE_WR(x, HW_SATA_P0IE_RD(x) |  (v)))
#define HW_SATA_P0IE_CLR(x, v)   (HW_SATA_P0IE_WR(x, HW_SATA_P0IE_RD(x) & ~(v)))
#define HW_SATA_P0IE_TOG(x, v)   (HW_SATA_P0IE_WR(x, HW_SATA_P0IE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0IE bitfields
 */

/*!
 * @name Register SATA_P0IE, field DHRE[0] (RW)
 *
 * Device to Host Register FIS Interrupt Dependencies: when the following
 * conditions are true, the intrq output signal is asserted: • This bit=1 •
 * SATA_GHC[IE]=1 • SATA_P 0 IS[DHRS]=1
 */
/*@{*/
#define BP_SATA_P0IE_DHRE    (0U)          /*!< Bit position for SATA_P0IE_DHRE. */
#define BM_SATA_P0IE_DHRE    (0x00000001U) /*!< Bit mask for SATA_P0IE_DHRE. */
#define BS_SATA_P0IE_DHRE    (1U)          /*!< Bit field size in bits for SATA_P0IE_DHRE. */

/*! @brief Read current value of the SATA_P0IE_DHRE field. */
#define BR_SATA_P0IE_DHRE(x) (HW_SATA_P0IE(x).B.DHRE)

/*! @brief Format value for bitfield SATA_P0IE_DHRE. */
#define BF_SATA_P0IE_DHRE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_DHRE) & BM_SATA_P0IE_DHRE)

/*! @brief Set the DHRE field to a new value. */
#define BW_SATA_P0IE_DHRE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_DHRE) | BF_SATA_P0IE_DHRE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field PSE[1] (RW)
 *
 * PIO Setup FIS Interrupt Enable Dependencies: when the following conditions
 * are true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1
 * • SATA_P 0 IS[PSS]=1
 */
/*@{*/
#define BP_SATA_P0IE_PSE     (1U)          /*!< Bit position for SATA_P0IE_PSE. */
#define BM_SATA_P0IE_PSE     (0x00000002U) /*!< Bit mask for SATA_P0IE_PSE. */
#define BS_SATA_P0IE_PSE     (1U)          /*!< Bit field size in bits for SATA_P0IE_PSE. */

/*! @brief Read current value of the SATA_P0IE_PSE field. */
#define BR_SATA_P0IE_PSE(x)  (HW_SATA_P0IE(x).B.PSE)

/*! @brief Format value for bitfield SATA_P0IE_PSE. */
#define BF_SATA_P0IE_PSE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_PSE) & BM_SATA_P0IE_PSE)

/*! @brief Set the PSE field to a new value. */
#define BW_SATA_P0IE_PSE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_PSE) | BF_SATA_P0IE_PSE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field DSE[2] (RW)
 *
 * DMA Setup FIS Interrupt Enable Dependencies: when the following conditions
 * are true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1
 * • SATA_P 0 IS[DSS]=1
 */
/*@{*/
#define BP_SATA_P0IE_DSE     (2U)          /*!< Bit position for SATA_P0IE_DSE. */
#define BM_SATA_P0IE_DSE     (0x00000004U) /*!< Bit mask for SATA_P0IE_DSE. */
#define BS_SATA_P0IE_DSE     (1U)          /*!< Bit field size in bits for SATA_P0IE_DSE. */

/*! @brief Read current value of the SATA_P0IE_DSE field. */
#define BR_SATA_P0IE_DSE(x)  (HW_SATA_P0IE(x).B.DSE)

/*! @brief Format value for bitfield SATA_P0IE_DSE. */
#define BF_SATA_P0IE_DSE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_DSE) & BM_SATA_P0IE_DSE)

/*! @brief Set the DSE field to a new value. */
#define BW_SATA_P0IE_DSE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_DSE) | BF_SATA_P0IE_DSE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field SDBE[3] (RW)
 *
 * Set Device Bits FIS Interrupt Enable Dependencies: when the following
 * conditions are true, the intrq output signal is asserted: • This bit=1 •
 * SATA_GHC[IE]=1 • SATA_P 0 IS[SDBS]=1
 */
/*@{*/
#define BP_SATA_P0IE_SDBE    (3U)          /*!< Bit position for SATA_P0IE_SDBE. */
#define BM_SATA_P0IE_SDBE    (0x00000008U) /*!< Bit mask for SATA_P0IE_SDBE. */
#define BS_SATA_P0IE_SDBE    (1U)          /*!< Bit field size in bits for SATA_P0IE_SDBE. */

/*! @brief Read current value of the SATA_P0IE_SDBE field. */
#define BR_SATA_P0IE_SDBE(x) (HW_SATA_P0IE(x).B.SDBE)

/*! @brief Format value for bitfield SATA_P0IE_SDBE. */
#define BF_SATA_P0IE_SDBE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_SDBE) & BM_SATA_P0IE_SDBE)

/*! @brief Set the SDBE field to a new value. */
#define BW_SATA_P0IE_SDBE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_SDBE) | BF_SATA_P0IE_SDBE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field UFE[4] (RW)
 *
 * Unknown FIS Interrupt Enable Dependencies: when the following conditions are
 * true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1
 * • SATA_P 0 IS[UFS]=1
 */
/*@{*/
#define BP_SATA_P0IE_UFE     (4U)          /*!< Bit position for SATA_P0IE_UFE. */
#define BM_SATA_P0IE_UFE     (0x00000010U) /*!< Bit mask for SATA_P0IE_UFE. */
#define BS_SATA_P0IE_UFE     (1U)          /*!< Bit field size in bits for SATA_P0IE_UFE. */

/*! @brief Read current value of the SATA_P0IE_UFE field. */
#define BR_SATA_P0IE_UFE(x)  (HW_SATA_P0IE(x).B.UFE)

/*! @brief Format value for bitfield SATA_P0IE_UFE. */
#define BF_SATA_P0IE_UFE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_UFE) & BM_SATA_P0IE_UFE)

/*! @brief Set the UFE field to a new value. */
#define BW_SATA_P0IE_UFE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_UFE) | BF_SATA_P0IE_UFE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field DPE[5] (RW)
 *
 * Descriptor Processed Interrupt Enable Dependencies: when the following
 * conditions are true, the intrq output signal is asserted: • This bit=1 •
 * SATA_GHC[IE]=1 • SATA_P 0 IS[DPS]=1
 */
/*@{*/
#define BP_SATA_P0IE_DPE     (5U)          /*!< Bit position for SATA_P0IE_DPE. */
#define BM_SATA_P0IE_DPE     (0x00000020U) /*!< Bit mask for SATA_P0IE_DPE. */
#define BS_SATA_P0IE_DPE     (1U)          /*!< Bit field size in bits for SATA_P0IE_DPE. */

/*! @brief Read current value of the SATA_P0IE_DPE field. */
#define BR_SATA_P0IE_DPE(x)  (HW_SATA_P0IE(x).B.DPE)

/*! @brief Format value for bitfield SATA_P0IE_DPE. */
#define BF_SATA_P0IE_DPE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_DPE) & BM_SATA_P0IE_DPE)

/*! @brief Set the DPE field to a new value. */
#define BW_SATA_P0IE_DPE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_DPE) | BF_SATA_P0IE_DPE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field PCE[6] (RW)
 *
 * Port Change Interrupt Enable Dependencies: when the following conditions are
 * true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1
 * • SATA_P 0 IS[PCS]=1
 */
/*@{*/
#define BP_SATA_P0IE_PCE     (6U)          /*!< Bit position for SATA_P0IE_PCE. */
#define BM_SATA_P0IE_PCE     (0x00000040U) /*!< Bit mask for SATA_P0IE_PCE. */
#define BS_SATA_P0IE_PCE     (1U)          /*!< Bit field size in bits for SATA_P0IE_PCE. */

/*! @brief Read current value of the SATA_P0IE_PCE field. */
#define BR_SATA_P0IE_PCE(x)  (HW_SATA_P0IE(x).B.PCE)

/*! @brief Format value for bitfield SATA_P0IE_PCE. */
#define BF_SATA_P0IE_PCE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_PCE) & BM_SATA_P0IE_PCE)

/*! @brief Set the PCE field to a new value. */
#define BW_SATA_P0IE_PCE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_PCE) | BF_SATA_P0IE_PCE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field PRCE[22] (RW)
 *
 * PHY Ready Change Enable Dependencies: when the following conditions are true,
 * the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1 •
 * SATA_P 0 IS[PRCS]=1
 */
/*@{*/
#define BP_SATA_P0IE_PRCE    (22U)         /*!< Bit position for SATA_P0IE_PRCE. */
#define BM_SATA_P0IE_PRCE    (0x00400000U) /*!< Bit mask for SATA_P0IE_PRCE. */
#define BS_SATA_P0IE_PRCE    (1U)          /*!< Bit field size in bits for SATA_P0IE_PRCE. */

/*! @brief Read current value of the SATA_P0IE_PRCE field. */
#define BR_SATA_P0IE_PRCE(x) (HW_SATA_P0IE(x).B.PRCE)

/*! @brief Format value for bitfield SATA_P0IE_PRCE. */
#define BF_SATA_P0IE_PRCE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_PRCE) & BM_SATA_P0IE_PRCE)

/*! @brief Set the PRCE field to a new value. */
#define BW_SATA_P0IE_PRCE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_PRCE) | BF_SATA_P0IE_PRCE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field IPME[23] (RW)
 *
 * Incorrect Port Multiplier Enable Dependencies: when the following conditions
 * are true, the intrq output signal is asserted: • This bit=1 •
 * SATA_GHC[IE]=1 • SATA_P 0 IS[IPMS]=1
 */
/*@{*/
#define BP_SATA_P0IE_IPME    (23U)         /*!< Bit position for SATA_P0IE_IPME. */
#define BM_SATA_P0IE_IPME    (0x00800000U) /*!< Bit mask for SATA_P0IE_IPME. */
#define BS_SATA_P0IE_IPME    (1U)          /*!< Bit field size in bits for SATA_P0IE_IPME. */

/*! @brief Read current value of the SATA_P0IE_IPME field. */
#define BR_SATA_P0IE_IPME(x) (HW_SATA_P0IE(x).B.IPME)

/*! @brief Format value for bitfield SATA_P0IE_IPME. */
#define BF_SATA_P0IE_IPME(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_IPME) & BM_SATA_P0IE_IPME)

/*! @brief Set the IPME field to a new value. */
#define BW_SATA_P0IE_IPME(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_IPME) | BF_SATA_P0IE_IPME(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field OFE[24] (RW)
 *
 * Overflow Enable Dependencies: when the following conditions are true, the
 * intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1 • SATA_P 0
 * IS[OFS]=1
 */
/*@{*/
#define BP_SATA_P0IE_OFE     (24U)         /*!< Bit position for SATA_P0IE_OFE. */
#define BM_SATA_P0IE_OFE     (0x01000000U) /*!< Bit mask for SATA_P0IE_OFE. */
#define BS_SATA_P0IE_OFE     (1U)          /*!< Bit field size in bits for SATA_P0IE_OFE. */

/*! @brief Read current value of the SATA_P0IE_OFE field. */
#define BR_SATA_P0IE_OFE(x)  (HW_SATA_P0IE(x).B.OFE)

/*! @brief Format value for bitfield SATA_P0IE_OFE. */
#define BF_SATA_P0IE_OFE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_OFE) & BM_SATA_P0IE_OFE)

/*! @brief Set the OFE field to a new value. */
#define BW_SATA_P0IE_OFE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_OFE) | BF_SATA_P0IE_OFE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field INFE[26] (RW)
 *
 * Interface Non-Fatal Error Enable Dependencies: when the following conditions
 * are true, the intrq output signal is asserted: • This bit=1 •
 * SATA_GHC[IE]=1 • SATA_P 0 IS[INFS]=1
 */
/*@{*/
#define BP_SATA_P0IE_INFE    (26U)         /*!< Bit position for SATA_P0IE_INFE. */
#define BM_SATA_P0IE_INFE    (0x04000000U) /*!< Bit mask for SATA_P0IE_INFE. */
#define BS_SATA_P0IE_INFE    (1U)          /*!< Bit field size in bits for SATA_P0IE_INFE. */

/*! @brief Read current value of the SATA_P0IE_INFE field. */
#define BR_SATA_P0IE_INFE(x) (HW_SATA_P0IE(x).B.INFE)

/*! @brief Format value for bitfield SATA_P0IE_INFE. */
#define BF_SATA_P0IE_INFE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_INFE) & BM_SATA_P0IE_INFE)

/*! @brief Set the INFE field to a new value. */
#define BW_SATA_P0IE_INFE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_INFE) | BF_SATA_P0IE_INFE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field IFE[27] (RW)
 *
 * Dependencies: when the following conditions are true, the intrq output signal
 * is asserted: • This bit=1 • SATA_GHC[IE]=1 • SATA_P 0 IS[IFS]=1
 */
/*@{*/
#define BP_SATA_P0IE_IFE     (27U)         /*!< Bit position for SATA_P0IE_IFE. */
#define BM_SATA_P0IE_IFE     (0x08000000U) /*!< Bit mask for SATA_P0IE_IFE. */
#define BS_SATA_P0IE_IFE     (1U)          /*!< Bit field size in bits for SATA_P0IE_IFE. */

/*! @brief Read current value of the SATA_P0IE_IFE field. */
#define BR_SATA_P0IE_IFE(x)  (HW_SATA_P0IE(x).B.IFE)

/*! @brief Format value for bitfield SATA_P0IE_IFE. */
#define BF_SATA_P0IE_IFE(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_IFE) & BM_SATA_P0IE_IFE)

/*! @brief Set the IFE field to a new value. */
#define BW_SATA_P0IE_IFE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_IFE) | BF_SATA_P0IE_IFE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field HBDE[28] (RW)
 *
 * Host Bus Data Error Enable Dependencies: when the following conditions are
 * true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1 •
 * SATA_P 0 IS[HBDS]=1
 */
/*@{*/
#define BP_SATA_P0IE_HBDE    (28U)         /*!< Bit position for SATA_P0IE_HBDE. */
#define BM_SATA_P0IE_HBDE    (0x10000000U) /*!< Bit mask for SATA_P0IE_HBDE. */
#define BS_SATA_P0IE_HBDE    (1U)          /*!< Bit field size in bits for SATA_P0IE_HBDE. */

/*! @brief Read current value of the SATA_P0IE_HBDE field. */
#define BR_SATA_P0IE_HBDE(x) (HW_SATA_P0IE(x).B.HBDE)

/*! @brief Format value for bitfield SATA_P0IE_HBDE. */
#define BF_SATA_P0IE_HBDE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_HBDE) & BM_SATA_P0IE_HBDE)

/*! @brief Set the HBDE field to a new value. */
#define BW_SATA_P0IE_HBDE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_HBDE) | BF_SATA_P0IE_HBDE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field HBFE[29] (RW)
 *
 * Host Bus Fatal Error Enable Dependencies: when the following conditions are
 * true, the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1
 * • SATA_P 0 IS[HBFS]=1
 */
/*@{*/
#define BP_SATA_P0IE_HBFE    (29U)         /*!< Bit position for SATA_P0IE_HBFE. */
#define BM_SATA_P0IE_HBFE    (0x20000000U) /*!< Bit mask for SATA_P0IE_HBFE. */
#define BS_SATA_P0IE_HBFE    (1U)          /*!< Bit field size in bits for SATA_P0IE_HBFE. */

/*! @brief Read current value of the SATA_P0IE_HBFE field. */
#define BR_SATA_P0IE_HBFE(x) (HW_SATA_P0IE(x).B.HBFE)

/*! @brief Format value for bitfield SATA_P0IE_HBFE. */
#define BF_SATA_P0IE_HBFE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_HBFE) & BM_SATA_P0IE_HBFE)

/*! @brief Set the HBFE field to a new value. */
#define BW_SATA_P0IE_HBFE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_HBFE) | BF_SATA_P0IE_HBFE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field TFEE[30] (RW)
 *
 * Task File Error Enable Dependencies: when the following conditions are true,
 * the intrq output signal is asserted: • This bit=1 • SATA_GHC[IE]=1 •
 * SATA_P 0 IS[TFES]=1
 */
/*@{*/
#define BP_SATA_P0IE_TFEE    (30U)         /*!< Bit position for SATA_P0IE_TFEE. */
#define BM_SATA_P0IE_TFEE    (0x40000000U) /*!< Bit mask for SATA_P0IE_TFEE. */
#define BS_SATA_P0IE_TFEE    (1U)          /*!< Bit field size in bits for SATA_P0IE_TFEE. */

/*! @brief Read current value of the SATA_P0IE_TFEE field. */
#define BR_SATA_P0IE_TFEE(x) (HW_SATA_P0IE(x).B.TFEE)

/*! @brief Format value for bitfield SATA_P0IE_TFEE. */
#define BF_SATA_P0IE_TFEE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_TFEE) & BM_SATA_P0IE_TFEE)

/*! @brief Set the TFEE field to a new value. */
#define BW_SATA_P0IE_TFEE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_TFEE) | BF_SATA_P0IE_TFEE(v)))
/*@}*/

/*!
 * @name Register SATA_P0IE, field CPDE[31] (RW)
 *
 * Cold Port Detect Enable Read-only. Returns 0.
 */
/*@{*/
#define BP_SATA_P0IE_CPDE    (31U)         /*!< Bit position for SATA_P0IE_CPDE. */
#define BM_SATA_P0IE_CPDE    (0x80000000U) /*!< Bit mask for SATA_P0IE_CPDE. */
#define BS_SATA_P0IE_CPDE    (1U)          /*!< Bit field size in bits for SATA_P0IE_CPDE. */

/*! @brief Read current value of the SATA_P0IE_CPDE field. */
#define BR_SATA_P0IE_CPDE(x) (HW_SATA_P0IE(x).B.CPDE)

/*! @brief Format value for bitfield SATA_P0IE_CPDE. */
#define BF_SATA_P0IE_CPDE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0IE_CPDE) & BM_SATA_P0IE_CPDE)

/*! @brief Set the CPDE field to a new value. */
#define BW_SATA_P0IE_CPDE(x, v) (HW_SATA_P0IE_WR(x, (HW_SATA_P0IE_RD(x) & ~BM_SATA_P0IE_CPDE) | BF_SATA_P0IE_CPDE(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0CMD - Port0 Command Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0CMD - Port0 Command Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains bits controlling various Port functions. All RW bits
 * are reset on Global reset.
 */
typedef union _hw_sata_p0cmd
{
    uint32_t U;
    struct _hw_sata_p0cmd_bitfields
    {
        uint32_t ST : 1;               /*!< [0]  */
        uint32_t SUD : 1;              /*!< [1]  */
        uint32_t POD : 1;              /*!< [2]  */
        uint32_t CLO : 1;              /*!< [3]  */
        uint32_t FRE : 1;              /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t CCS : 5;              /*!< [12:8]  */
        uint32_t MPSS : 1;             /*!< [13]  */
        uint32_t FR : 1;               /*!< [14]  */
        uint32_t CR : 1;               /*!< [15]  */
        uint32_t CPS : 1;              /*!< [16]  */
        uint32_t PMA : 1;              /*!< [17]  */
        uint32_t HPCP : 1;             /*!< [18]  */
        uint32_t RESERVED1 : 2;        /*!< [20:19]  */
        uint32_t ESP : 1;              /*!< [21]  */
        uint32_t RESERVED2 : 1;        /*!< [22]  */
        uint32_t APSTE : 1;            /*!< [23]  */
        uint32_t ATAPI : 1;            /*!< [24]  */
        uint32_t DLAE : 1;             /*!< [25]  */
        uint32_t ALPE : 1;             /*!< [26]  */
        uint32_t ASP : 1;              /*!< [27]  */
        uint32_t ICC : 4;              /*!< [31:28]  */
    } B;
} hw_sata_p0cmd_t;

/*!
 * @name Constants and macros for entire SATA_P0CMD register
 */
/*@{*/
#define HW_SATA_P0CMD_ADDR(x)    ((uintptr_t)(x) + 0x118U)

#define HW_SATA_P0CMD(x)         (*(__IO hw_sata_p0cmd_t *) HW_SATA_P0CMD_ADDR(x))
#define HW_SATA_P0CMD_RD(x)      (HW_SATA_P0CMD(x).U)
#define HW_SATA_P0CMD_WR(x, v)   (HW_SATA_P0CMD(x).U = (v))
#define HW_SATA_P0CMD_SET(x, v)  (HW_SATA_P0CMD_WR(x, HW_SATA_P0CMD_RD(x) |  (v)))
#define HW_SATA_P0CMD_CLR(x, v)  (HW_SATA_P0CMD_WR(x, HW_SATA_P0CMD_RD(x) & ~(v)))
#define HW_SATA_P0CMD_TOG(x, v)  (HW_SATA_P0CMD_WR(x, HW_SATA_P0CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0CMD bitfields
 */

/*!
 * @name Register SATA_P0CMD, field ST[0] (RW)
 *
 * Start When set to 1, the Port processes the command list. When cleared, the
 * Port does not process the command list. Whenever this bit is changed from a 0
 * to a 1, the Port starts processing the command list at entry'0. Whenever this
 * bit is changed from a 1 to a 0, the SATA_P 0 CI register is cleared by the Port
 * upon transition into an idle state. Refer to AHCI specification, section
 * 10.3.1, for important restrictions on when this bit can be set to 1. Note: SATA_P
 * 0 SERR register must be cleared prior to setting ST bit to 1.
 */
/*@{*/
#define BP_SATA_P0CMD_ST     (0U)          /*!< Bit position for SATA_P0CMD_ST. */
#define BM_SATA_P0CMD_ST     (0x00000001U) /*!< Bit mask for SATA_P0CMD_ST. */
#define BS_SATA_P0CMD_ST     (1U)          /*!< Bit field size in bits for SATA_P0CMD_ST. */

/*! @brief Read current value of the SATA_P0CMD_ST field. */
#define BR_SATA_P0CMD_ST(x)  (HW_SATA_P0CMD(x).B.ST)

/*! @brief Format value for bitfield SATA_P0CMD_ST. */
#define BF_SATA_P0CMD_ST(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ST) & BM_SATA_P0CMD_ST)

/*! @brief Set the ST field to a new value. */
#define BW_SATA_P0CMD_ST(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ST) | BF_SATA_P0CMD_ST(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field SUD[1] (RW)
 *
 * Spin-Up Device This bit is read/write when staggered spin-up is supported as
 * indicated by the SATA_CAP[SSS]=1. This bit is read-only 1 when staggered
 * spin-up is not supported and SATA_CAP[SSS]=0. On an edge detect from 0 to 1, the
 * Port starts a COMRESET initialization sequence to the device. Clearing this bit
 * causes no action on the interface. Note: The SUD bit is read-only 0 on
 * power-up until SATA_CAP[SSS] bit is written with the required value.
 */
/*@{*/
#define BP_SATA_P0CMD_SUD    (1U)          /*!< Bit position for SATA_P0CMD_SUD. */
#define BM_SATA_P0CMD_SUD    (0x00000002U) /*!< Bit mask for SATA_P0CMD_SUD. */
#define BS_SATA_P0CMD_SUD    (1U)          /*!< Bit field size in bits for SATA_P0CMD_SUD. */

/*! @brief Read current value of the SATA_P0CMD_SUD field. */
#define BR_SATA_P0CMD_SUD(x) (HW_SATA_P0CMD(x).B.SUD)

/*! @brief Format value for bitfield SATA_P0CMD_SUD. */
#define BF_SATA_P0CMD_SUD(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_SUD) & BM_SATA_P0CMD_SUD)

/*! @brief Set the SUD field to a new value. */
#define BW_SATA_P0CMD_SUD(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_SUD) | BF_SATA_P0CMD_SUD(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field POD[2] (RW)
 *
 * Power On Device This bit is read/write when cold presence detection is
 * supported on this Port as indicated by SATA_P 0 CMD[CPD]=1. This bit is read-only 1
 * when cold presence detection is not supported and SATA_P 0 CMD[CPD]=0. When
 * set, the Port asserts the p 0 _cp_pod output pin so that it may be used to
 * provide power to a cold-presence detectable Port.
 */
/*@{*/
#define BP_SATA_P0CMD_POD    (2U)          /*!< Bit position for SATA_P0CMD_POD. */
#define BM_SATA_P0CMD_POD    (0x00000004U) /*!< Bit mask for SATA_P0CMD_POD. */
#define BS_SATA_P0CMD_POD    (1U)          /*!< Bit field size in bits for SATA_P0CMD_POD. */

/*! @brief Read current value of the SATA_P0CMD_POD field. */
#define BR_SATA_P0CMD_POD(x) (HW_SATA_P0CMD(x).B.POD)

/*! @brief Format value for bitfield SATA_P0CMD_POD. */
#define BF_SATA_P0CMD_POD(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_POD) & BM_SATA_P0CMD_POD)

/*! @brief Set the POD field to a new value. */
#define BW_SATA_P0CMD_POD(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_POD) | BF_SATA_P0CMD_POD(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field CLO[3] (RW)
 *
 * Command List Override Setting this bit to 1 causes the SATA_P 0 TFD[STS]
 * field BSY bit and the SATA_P 0 TFD[STS] field DRQ bit to be cleared. This allows a
 * software reset to be transmitted to the device regardless of whether the BSY
 * and DRQ bits are still set in the SATA_P 0 TFD[STS] field. This bit is cleared
 * to 0 when SATA_P 0 TFD[STS] BSY bit and SATA_P 0 TFD[STS] DRQ bit have been
 * cleared. A write to this register with a value of '0' has no effect. This bit
 * should only be set to 1 immediately prior to setting SATA_P 0 CMD[ST] bit to 1
 * from a previous value of 0. Setting this bit to 1 at any other time is not
 * supported and results in indeterminate behavior.
 */
/*@{*/
#define BP_SATA_P0CMD_CLO    (3U)          /*!< Bit position for SATA_P0CMD_CLO. */
#define BM_SATA_P0CMD_CLO    (0x00000008U) /*!< Bit mask for SATA_P0CMD_CLO. */
#define BS_SATA_P0CMD_CLO    (1U)          /*!< Bit field size in bits for SATA_P0CMD_CLO. */

/*! @brief Read current value of the SATA_P0CMD_CLO field. */
#define BR_SATA_P0CMD_CLO(x) (HW_SATA_P0CMD(x).B.CLO)

/*! @brief Format value for bitfield SATA_P0CMD_CLO. */
#define BF_SATA_P0CMD_CLO(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_CLO) & BM_SATA_P0CMD_CLO)

/*! @brief Set the CLO field to a new value. */
#define BW_SATA_P0CMD_CLO(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_CLO) | BF_SATA_P0CMD_CLO(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field FRE[4] (RW)
 *
 * FIS Receive Enable When set to 1, the Port may post received FISes into the
 * FIS receive area pointed to by SATA_P 0 FB . When cleared, received FISes are
 * not accepted by the Port, except for the first D2H register FIS after the
 * initialization sequence, and no FISes are posted to the FIS receive area. The
 * software must not set this bit until SATA_P 0 FB has been programmed with a valid
 * pointer to the FIS receive area When the software wishes to move the base, this
 * bit must first be cleared, and the software must wait for the SATA_P 0
 * CMD[FR] bit to be cleared.
 */
/*@{*/
#define BP_SATA_P0CMD_FRE    (4U)          /*!< Bit position for SATA_P0CMD_FRE. */
#define BM_SATA_P0CMD_FRE    (0x00000010U) /*!< Bit mask for SATA_P0CMD_FRE. */
#define BS_SATA_P0CMD_FRE    (1U)          /*!< Bit field size in bits for SATA_P0CMD_FRE. */

/*! @brief Read current value of the SATA_P0CMD_FRE field. */
#define BR_SATA_P0CMD_FRE(x) (HW_SATA_P0CMD(x).B.FRE)

/*! @brief Format value for bitfield SATA_P0CMD_FRE. */
#define BF_SATA_P0CMD_FRE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_FRE) & BM_SATA_P0CMD_FRE)

/*! @brief Set the FRE field to a new value. */
#define BW_SATA_P0CMD_FRE(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_FRE) | BF_SATA_P0CMD_FRE(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field CCS[12:8] (RW)
 *
 * Current Command Slot This field is set to the command slot value value of the
 * command that is currently being issued by the Port. • When SATA_P 0 CMD[ST]
 * transitions from 1 to 0, this field is recleared to 0x00. • After SATA_P 0
 * CMD[ST] transitions from 0 to 1, the highest priority slot to issue from next
 * is command slot 0. After the first command has been issued, the highest
 * priority slot to issue from next is SATA_P 0 CMD[CCS]+1.For example, after the Port
 * has issued its first command, when CCS=0x00 and SATA_P 0 CI is cleared to 0x3,
 * the next command issued is from command slot 1. This field is valid only when
 * SATA_P 0 CMD[ST] is set to 1.
 */
/*@{*/
#define BP_SATA_P0CMD_CCS    (8U)          /*!< Bit position for SATA_P0CMD_CCS. */
#define BM_SATA_P0CMD_CCS    (0x00001F00U) /*!< Bit mask for SATA_P0CMD_CCS. */
#define BS_SATA_P0CMD_CCS    (5U)          /*!< Bit field size in bits for SATA_P0CMD_CCS. */

/*! @brief Read current value of the SATA_P0CMD_CCS field. */
#define BR_SATA_P0CMD_CCS(x) (HW_SATA_P0CMD(x).B.CCS)

/*! @brief Format value for bitfield SATA_P0CMD_CCS. */
#define BF_SATA_P0CMD_CCS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_CCS) & BM_SATA_P0CMD_CCS)

/*! @brief Set the CCS field to a new value. */
#define BW_SATA_P0CMD_CCS(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_CCS) | BF_SATA_P0CMD_CCS(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field MPSS[13] (RW)
 *
 * Mechanical Presence Switch State The software must use this bit only when
 * both SATA_CAP[SMPS] and SATA_P 0 CMD[MPSP] are set. This bit reports the state of
 * a mechanical presence switch attached to this Port as indicated by the p 0
 * _mp_switch input state (assuming SATA_CAP[SMPS]=1 and SATA_P 0 CMD[MPSP]=1). The
 * options for this field are: When SATA_CAP[SMPS]=0 then this bit is cleared to
 * 0.
 *
 * Values:
 * - 0 - Switch is closed
 * - 1 - Switch is open
 */
/*@{*/
#define BP_SATA_P0CMD_MPSS   (13U)         /*!< Bit position for SATA_P0CMD_MPSS. */
#define BM_SATA_P0CMD_MPSS   (0x00002000U) /*!< Bit mask for SATA_P0CMD_MPSS. */
#define BS_SATA_P0CMD_MPSS   (1U)          /*!< Bit field size in bits for SATA_P0CMD_MPSS. */

/*! @brief Read current value of the SATA_P0CMD_MPSS field. */
#define BR_SATA_P0CMD_MPSS(x) (HW_SATA_P0CMD(x).B.MPSS)

/*! @brief Format value for bitfield SATA_P0CMD_MPSS. */
#define BF_SATA_P0CMD_MPSS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_MPSS) & BM_SATA_P0CMD_MPSS)

/*! @brief Set the MPSS field to a new value. */
#define BW_SATA_P0CMD_MPSS(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_MPSS) | BF_SATA_P0CMD_MPSS(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field FR[14] (RW)
 *
 * FIS Receive Running When set to '1', the FIS Receive DMA engine for the Port
 * is running. See AHCI specification section 10.3.2 for details on when this bit
 * is set and cleared by the Port.
 */
/*@{*/
#define BP_SATA_P0CMD_FR     (14U)         /*!< Bit position for SATA_P0CMD_FR. */
#define BM_SATA_P0CMD_FR     (0x00004000U) /*!< Bit mask for SATA_P0CMD_FR. */
#define BS_SATA_P0CMD_FR     (1U)          /*!< Bit field size in bits for SATA_P0CMD_FR. */

/*! @brief Read current value of the SATA_P0CMD_FR field. */
#define BR_SATA_P0CMD_FR(x)  (HW_SATA_P0CMD(x).B.FR)

/*! @brief Format value for bitfield SATA_P0CMD_FR. */
#define BF_SATA_P0CMD_FR(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_FR) & BM_SATA_P0CMD_FR)

/*! @brief Set the FR field to a new value. */
#define BW_SATA_P0CMD_FR(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_FR) | BF_SATA_P0CMD_FR(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field CR[15] (RW)
 *
 * Command List Running When this bit is set to '1', the command list DMA engine
 * for this Port is running. See AHCI state machine in AHCI specification
 * section 5.3.2 for details on when this bit is set and cleared by the Port.
 */
/*@{*/
#define BP_SATA_P0CMD_CR     (15U)         /*!< Bit position for SATA_P0CMD_CR. */
#define BM_SATA_P0CMD_CR     (0x00008000U) /*!< Bit mask for SATA_P0CMD_CR. */
#define BS_SATA_P0CMD_CR     (1U)          /*!< Bit field size in bits for SATA_P0CMD_CR. */

/*! @brief Read current value of the SATA_P0CMD_CR field. */
#define BR_SATA_P0CMD_CR(x)  (HW_SATA_P0CMD(x).B.CR)

/*! @brief Format value for bitfield SATA_P0CMD_CR. */
#define BF_SATA_P0CMD_CR(v)  ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_CR) & BM_SATA_P0CMD_CR)

/*! @brief Set the CR field to a new value. */
#define BW_SATA_P0CMD_CR(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_CR) | BF_SATA_P0CMD_CR(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field CPS[16] (RW)
 *
 * Cold Presence State This bit reports whether a device is currently detected
 * on this Port as indicated by the p 0 _cp_det input state (assuming SATA_P 0
 * CMD[CPD]=1). The options for this field are:
 *
 * Values:
 * - 1 - device is attached to this Port
 * - 0 - no device attached to this Port
 */
/*@{*/
#define BP_SATA_P0CMD_CPS    (16U)         /*!< Bit position for SATA_P0CMD_CPS. */
#define BM_SATA_P0CMD_CPS    (0x00010000U) /*!< Bit mask for SATA_P0CMD_CPS. */
#define BS_SATA_P0CMD_CPS    (1U)          /*!< Bit field size in bits for SATA_P0CMD_CPS. */

/*! @brief Read current value of the SATA_P0CMD_CPS field. */
#define BR_SATA_P0CMD_CPS(x) (HW_SATA_P0CMD(x).B.CPS)

/*! @brief Format value for bitfield SATA_P0CMD_CPS. */
#define BF_SATA_P0CMD_CPS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_CPS) & BM_SATA_P0CMD_CPS)

/*! @brief Set the CPS field to a new value. */
#define BW_SATA_P0CMD_CPS(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_CPS) | BF_SATA_P0CMD_CPS(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field PMA[17] (RW)
 *
 * Port Multiplier Attached The software is responsible for detecting whether a
 * Port Multiplier is present; the SATA block Port does not auto-detect the
 * presence of a Port Multiplier. The options for this field are:
 *
 * Values:
 * - 1 - A Port Multiplier is attached to this Port.
 * - 0 - A Port Multiplier is not attached to this Port.
 */
/*@{*/
#define BP_SATA_P0CMD_PMA    (17U)         /*!< Bit position for SATA_P0CMD_PMA. */
#define BM_SATA_P0CMD_PMA    (0x00020000U) /*!< Bit mask for SATA_P0CMD_PMA. */
#define BS_SATA_P0CMD_PMA    (1U)          /*!< Bit field size in bits for SATA_P0CMD_PMA. */

/*! @brief Read current value of the SATA_P0CMD_PMA field. */
#define BR_SATA_P0CMD_PMA(x) (HW_SATA_P0CMD(x).B.PMA)

/*! @brief Format value for bitfield SATA_P0CMD_PMA. */
#define BF_SATA_P0CMD_PMA(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_PMA) & BM_SATA_P0CMD_PMA)

/*! @brief Set the PMA field to a new value. */
#define BW_SATA_P0CMD_PMA(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_PMA) | BF_SATA_P0CMD_PMA(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field HPCP[18] (RW)
 *
 * Hot Plug Capable Port The HPCP bit is mutually exclusive with SATA_P 0
 * CMD[ESP]. The options for this field are:
 *
 * Values:
 * - 1 - Indicates that this Port's signal and power connectors are externally
 *     accessible via a joint signal-power connector for blindmate device hot plug.
 * - 0 - Indicates that this Port's signal and power connectors are not
 *     externally accessible.
 */
/*@{*/
#define BP_SATA_P0CMD_HPCP   (18U)         /*!< Bit position for SATA_P0CMD_HPCP. */
#define BM_SATA_P0CMD_HPCP   (0x00040000U) /*!< Bit mask for SATA_P0CMD_HPCP. */
#define BS_SATA_P0CMD_HPCP   (1U)          /*!< Bit field size in bits for SATA_P0CMD_HPCP. */

/*! @brief Read current value of the SATA_P0CMD_HPCP field. */
#define BR_SATA_P0CMD_HPCP(x) (HW_SATA_P0CMD(x).B.HPCP)

/*! @brief Format value for bitfield SATA_P0CMD_HPCP. */
#define BF_SATA_P0CMD_HPCP(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_HPCP) & BM_SATA_P0CMD_HPCP)

/*! @brief Set the HPCP field to a new value. */
#define BW_SATA_P0CMD_HPCP(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_HPCP) | BF_SATA_P0CMD_HPCP(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field ESP[21] (RW)
 *
 * External SATA Port When set to 1, indicates that this Port's signal only
 * connector is externally accessible. When set to 1, SATA_CAP[SXS] is also set to 1.
 * When cleared to 0, indicates that this Port's signal only connector is not
 * externally accessible. Note: The ESP bit is mutually exclusive with SATA_P 0
 * CMD[HPCP]
 */
/*@{*/
#define BP_SATA_P0CMD_ESP    (21U)         /*!< Bit position for SATA_P0CMD_ESP. */
#define BM_SATA_P0CMD_ESP    (0x00200000U) /*!< Bit mask for SATA_P0CMD_ESP. */
#define BS_SATA_P0CMD_ESP    (1U)          /*!< Bit field size in bits for SATA_P0CMD_ESP. */

/*! @brief Read current value of the SATA_P0CMD_ESP field. */
#define BR_SATA_P0CMD_ESP(x) (HW_SATA_P0CMD(x).B.ESP)

/*! @brief Format value for bitfield SATA_P0CMD_ESP. */
#define BF_SATA_P0CMD_ESP(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ESP) & BM_SATA_P0CMD_ESP)

/*! @brief Set the ESP field to a new value. */
#define BW_SATA_P0CMD_ESP(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ESP) | BF_SATA_P0CMD_ESP(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field APSTE[23] (RW)
 *
 * Device is ATAPI This bit is used by the Port to control whether to assert p 0
 * _act_led output when commands are active. The options for this field are:
 *
 * Values:
 * - 0 - non-ATAPI device
 * - 1 - ATAPI device
 */
/*@{*/
#define BP_SATA_P0CMD_APSTE  (23U)         /*!< Bit position for SATA_P0CMD_APSTE. */
#define BM_SATA_P0CMD_APSTE  (0x00800000U) /*!< Bit mask for SATA_P0CMD_APSTE. */
#define BS_SATA_P0CMD_APSTE  (1U)          /*!< Bit field size in bits for SATA_P0CMD_APSTE. */

/*! @brief Read current value of the SATA_P0CMD_APSTE field. */
#define BR_SATA_P0CMD_APSTE(x) (HW_SATA_P0CMD(x).B.APSTE)

/*! @brief Format value for bitfield SATA_P0CMD_APSTE. */
#define BF_SATA_P0CMD_APSTE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_APSTE) & BM_SATA_P0CMD_APSTE)

/*! @brief Set the APSTE field to a new value. */
#define BW_SATA_P0CMD_APSTE(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_APSTE) | BF_SATA_P0CMD_APSTE(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field ATAPI[24] (RW)
 *
 * ATAPI Device is ATAPI This bit is used by the Port to control whether to
 * assert p 0 _act_led output when commands are active. The options for this field
 * are:
 *
 * Values:
 * - 0 - non-ATAPI device
 * - 1 - ATAPI device
 */
/*@{*/
#define BP_SATA_P0CMD_ATAPI  (24U)         /*!< Bit position for SATA_P0CMD_ATAPI. */
#define BM_SATA_P0CMD_ATAPI  (0x01000000U) /*!< Bit mask for SATA_P0CMD_ATAPI. */
#define BS_SATA_P0CMD_ATAPI  (1U)          /*!< Bit field size in bits for SATA_P0CMD_ATAPI. */

/*! @brief Read current value of the SATA_P0CMD_ATAPI field. */
#define BR_SATA_P0CMD_ATAPI(x) (HW_SATA_P0CMD(x).B.ATAPI)

/*! @brief Format value for bitfield SATA_P0CMD_ATAPI. */
#define BF_SATA_P0CMD_ATAPI(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ATAPI) & BM_SATA_P0CMD_ATAPI)

/*! @brief Set the ATAPI field to a new value. */
#define BW_SATA_P0CMD_ATAPI(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ATAPI) | BF_SATA_P0CMD_ATAPI(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field DLAE[25] (RW)
 *
 * Drive LED on ATAPI Enable When set to 1, SATA_P 0 CMD[ATAPI]=1, and commands
 * are active, the Port asserts p 0 _act_led output.
 */
/*@{*/
#define BP_SATA_P0CMD_DLAE   (25U)         /*!< Bit position for SATA_P0CMD_DLAE. */
#define BM_SATA_P0CMD_DLAE   (0x02000000U) /*!< Bit mask for SATA_P0CMD_DLAE. */
#define BS_SATA_P0CMD_DLAE   (1U)          /*!< Bit field size in bits for SATA_P0CMD_DLAE. */

/*! @brief Read current value of the SATA_P0CMD_DLAE field. */
#define BR_SATA_P0CMD_DLAE(x) (HW_SATA_P0CMD(x).B.DLAE)

/*! @brief Format value for bitfield SATA_P0CMD_DLAE. */
#define BF_SATA_P0CMD_DLAE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_DLAE) & BM_SATA_P0CMD_DLAE)

/*! @brief Set the DLAE field to a new value. */
#define BW_SATA_P0CMD_DLAE(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_DLAE) | BF_SATA_P0CMD_DLAE(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field ALPE[26] (RW)
 *
 * Aggressive Link Power Management Enable When set to 1, the Port aggressively
 * enters a lower link power state (PARTIAL or SLUMBER) based on the setting of
 * the SATA_P 0 CMD[ASP] bit. When cleared to 0, aggressive power management state
 * transition is disabled.
 */
/*@{*/
#define BP_SATA_P0CMD_ALPE   (26U)         /*!< Bit position for SATA_P0CMD_ALPE. */
#define BM_SATA_P0CMD_ALPE   (0x04000000U) /*!< Bit mask for SATA_P0CMD_ALPE. */
#define BS_SATA_P0CMD_ALPE   (1U)          /*!< Bit field size in bits for SATA_P0CMD_ALPE. */

/*! @brief Read current value of the SATA_P0CMD_ALPE field. */
#define BR_SATA_P0CMD_ALPE(x) (HW_SATA_P0CMD(x).B.ALPE)

/*! @brief Format value for bitfield SATA_P0CMD_ALPE. */
#define BF_SATA_P0CMD_ALPE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ALPE) & BM_SATA_P0CMD_ALPE)

/*! @brief Set the ALPE field to a new value. */
#define BW_SATA_P0CMD_ALPE(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ALPE) | BF_SATA_P0CMD_ALPE(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field ASP[27] (RW)
 *
 * Aggressive Slumber/ Partial The options for this field are: • When set to
 * 1, and SATA_P 0 CMD[ALPE]=1, the Port aggressively enters the SLUMBER state
 * when one of the following conditions is true: - The Port clears the SATA_P 0 CI
 * and the SATA_P 0 SACT register is cleared. - The Port clears the SATA_P 0 SACT
 * register and SATA_P 0 CI is cleared. • When cleared to 0, and SATA_P 0
 * CMD[ALPE]=1, the Port aggressively enters the PARTIAL state when one of the
 * following conditions is true: - The Port clears the SATA_P 0 CI register and the
 * SATA_P 0 SACT register is cleared. - The Port clears the SATA_P 0 SACT register
 * and SATA_P 0 CI is cleared.
 */
/*@{*/
#define BP_SATA_P0CMD_ASP    (27U)         /*!< Bit position for SATA_P0CMD_ASP. */
#define BM_SATA_P0CMD_ASP    (0x08000000U) /*!< Bit mask for SATA_P0CMD_ASP. */
#define BS_SATA_P0CMD_ASP    (1U)          /*!< Bit field size in bits for SATA_P0CMD_ASP. */

/*! @brief Read current value of the SATA_P0CMD_ASP field. */
#define BR_SATA_P0CMD_ASP(x) (HW_SATA_P0CMD(x).B.ASP)

/*! @brief Format value for bitfield SATA_P0CMD_ASP. */
#define BF_SATA_P0CMD_ASP(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ASP) & BM_SATA_P0CMD_ASP)

/*! @brief Set the ASP field to a new value. */
#define BW_SATA_P0CMD_ASP(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ASP) | BF_SATA_P0CMD_ASP(v)))
/*@}*/

/*!
 * @name Register SATA_P0CMD, field ICC[31:28] (RW)
 *
 * Interface Communication Control This field is used to control power
 * management states of the interface. When the Link layer is currently in the L_IDLE
 * state, writes to this field cause the Port to initiate a transition to the
 * interface power management state requested. When the Link layer is not currently in
 * the L_IDLE state, writes to this field have no effect. • 0xF-0x7: Reserved
 * • 0x6: Slumber. This causes the Port to request a transition of the interface
 * to the Slumber state. The SATA device can reject the request and the interface
 * remains in its current state. • 0x5-0x3: Reserved • 0x2: Partial. This
 * causes the Port to request a transition of the interface to the Partial state.
 * The SATA device can reject the request and the interface remains in its current
 * state. • 0x1: Active. This causes the Port to request a transition of the
 * interface into the active state. • 0x0: No-Op/ Idle. This value indicates to
 * the software that the Port 0 is ready to accept a new interface control
 * command, although the transition to the previously selected state may not yet have
 * occurred. When the software writes a non-reserved value other than No-Op (0x0),
 * the Port performs the action and update this field back to Idle (0x0). When
 * the software writes to this field to change the state to a state the link is
 * already in (i.e., interface is in the active state and a request is made to go
 * to the active state), the Port takes no action and returns this field to Idle.
 * When the interface is in a low power state and the software wants to
 * transition to a different low power state, the software must first bring the link to
 * active and then initiate the transition to the desired low power state.
 */
/*@{*/
#define BP_SATA_P0CMD_ICC    (28U)         /*!< Bit position for SATA_P0CMD_ICC. */
#define BM_SATA_P0CMD_ICC    (0xF0000000U) /*!< Bit mask for SATA_P0CMD_ICC. */
#define BS_SATA_P0CMD_ICC    (4U)          /*!< Bit field size in bits for SATA_P0CMD_ICC. */

/*! @brief Read current value of the SATA_P0CMD_ICC field. */
#define BR_SATA_P0CMD_ICC(x) (HW_SATA_P0CMD(x).B.ICC)

/*! @brief Format value for bitfield SATA_P0CMD_ICC. */
#define BF_SATA_P0CMD_ICC(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0CMD_ICC) & BM_SATA_P0CMD_ICC)

/*! @brief Set the ICC field to a new value. */
#define BW_SATA_P0CMD_ICC(x, v) (HW_SATA_P0CMD_WR(x, (HW_SATA_P0CMD_RD(x) & ~BM_SATA_P0CMD_ICC) | BF_SATA_P0CMD_ICC(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0TFD - Port0 Task File Data Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0TFD - Port0 Task File Data Register (RO)
 *
 * Reset value: 0x0000007FU
 *
 * This register contains Error and Status registers updated every time a new
 * Register FIS, PIO Setup FIS, or Set Device Bits FIS is received from the device.
 * Reset on Global or Port reset (COMRESET).
 */
typedef union _hw_sata_p0tfd
{
    uint32_t U;
    struct _hw_sata_p0tfd_bitfields
    {
        uint32_t STS : 8;              /*!< [7:0]  */
        uint32_t ERR : 8;              /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sata_p0tfd_t;

/*!
 * @name Constants and macros for entire SATA_P0TFD register
 */
/*@{*/
#define HW_SATA_P0TFD_ADDR(x)    ((uintptr_t)(x) + 0x120U)

#define HW_SATA_P0TFD(x)         (*(__I hw_sata_p0tfd_t *) HW_SATA_P0TFD_ADDR(x))
#define HW_SATA_P0TFD_RD(x)      (HW_SATA_P0TFD(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0TFD bitfields
 */

/*!
 * @name Register SATA_P0TFD, field STS[7:0] (RO)
 *
 * Status This field contains the latest copy of the task file status register.
 * The bits that affect SATA block operation are: • Bit [7] BSY - Indicates the
 * interface is busy • Bits [6:4] cs - Command specific • Bit [3] DRQ -
 * Indicates a data transfer is requested • Bits [2:1] cs - Command specific •
 * Bit [0] ERR - Indicates an error during the transfer The Port updates the entire
 * 8-bit field, not just the bits noted above.
 */
/*@{*/
#define BP_SATA_P0TFD_STS    (0U)          /*!< Bit position for SATA_P0TFD_STS. */
#define BM_SATA_P0TFD_STS    (0x000000FFU) /*!< Bit mask for SATA_P0TFD_STS. */
#define BS_SATA_P0TFD_STS    (8U)          /*!< Bit field size in bits for SATA_P0TFD_STS. */

/*! @brief Read current value of the SATA_P0TFD_STS field. */
#define BR_SATA_P0TFD_STS(x) (HW_SATA_P0TFD(x).B.STS)
/*@}*/

/*!
 * @name Register SATA_P0TFD, field ERR[15:8] (RO)
 *
 * Error This field contains the latest copy of the task file error register.
 */
/*@{*/
#define BP_SATA_P0TFD_ERR    (8U)          /*!< Bit position for SATA_P0TFD_ERR. */
#define BM_SATA_P0TFD_ERR    (0x0000FF00U) /*!< Bit mask for SATA_P0TFD_ERR. */
#define BS_SATA_P0TFD_ERR    (8U)          /*!< Bit field size in bits for SATA_P0TFD_ERR. */

/*! @brief Read current value of the SATA_P0TFD_ERR field. */
#define BR_SATA_P0TFD_ERR(x) (HW_SATA_P0TFD(x).B.ERR)
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SIG - Port0 Signature Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SIG - Port0 Signature Register (RO)
 *
 * Reset value: 0xFFFFFFFFU
 */
typedef union _hw_sata_p0sig
{
    uint32_t U;
    struct _hw_sata_p0sig_bitfields
    {
        uint32_t SIG : 32;             /*!< [31:0]  */
    } B;
} hw_sata_p0sig_t;

/*!
 * @name Constants and macros for entire SATA_P0SIG register
 */
/*@{*/
#define HW_SATA_P0SIG_ADDR(x)    ((uintptr_t)(x) + 0x124U)

#define HW_SATA_P0SIG(x)         (*(__I hw_sata_p0sig_t *) HW_SATA_P0SIG_ADDR(x))
#define HW_SATA_P0SIG_RD(x)      (HW_SATA_P0SIG(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0SIG bitfields
 */

/*!
 * @name Register SATA_P0SIG, field SIG[31:0] (RO)
 *
 * Signature This field contains the signature received from a device on the
 * first D2H Register FIS. The bit order as follows: • Bits [31:24] - LBA High
 * (Cylinder High) Register • Bits [23:16] - LBA Mid (Cylinder Low) Register •
 * Bits [15:8] - LBA Low (Sector Number) Register • Bits [7:0] - Sector Count
 * Register This field is updated once after a reset sequence. Reset on Global or
 * Port reset.
 */
/*@{*/
#define BP_SATA_P0SIG_SIG    (0U)          /*!< Bit position for SATA_P0SIG_SIG. */
#define BM_SATA_P0SIG_SIG    (0xFFFFFFFFU) /*!< Bit mask for SATA_P0SIG_SIG. */
#define BS_SATA_P0SIG_SIG    (32U)         /*!< Bit field size in bits for SATA_P0SIG_SIG. */

/*! @brief Read current value of the SATA_P0SIG_SIG field. */
#define BR_SATA_P0SIG_SIG(x) (HW_SATA_P0SIG(x).U)
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SSTS - Port0 Serial ATA Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SSTS - Port0 Serial ATA Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit register conveys the current state of the interface and host. The
 * Port updates it continuously and asynchronously. When the Port transmits a
 * COMRESET to the device, this register is updated to its reset values (i.e.,
 * Global reset, Port reset, or COMINIT from the device
 */
typedef union _hw_sata_p0ssts
{
    uint32_t U;
    struct _hw_sata_p0ssts_bitfields
    {
        uint32_t DET : 4;              /*!< [3:0]  */
        uint32_t SPD : 4;              /*!< [7:4]  */
        uint32_t IPM : 4;              /*!< [11:8]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_sata_p0ssts_t;

/*!
 * @name Constants and macros for entire SATA_P0SSTS register
 */
/*@{*/
#define HW_SATA_P0SSTS_ADDR(x)   ((uintptr_t)(x) + 0x128U)

#define HW_SATA_P0SSTS(x)        (*(__I hw_sata_p0ssts_t *) HW_SATA_P0SSTS_ADDR(x))
#define HW_SATA_P0SSTS_RD(x)     (HW_SATA_P0SSTS(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0SSTS bitfields
 */

/*!
 * @name Register SATA_P0SSTS, field DET[3:0] (RU)
 *
 * Indicates the interface device detection and PHY state. The options for this
 * field are: 0x0: No device detected and PHY communication not established 0x1:
 * Device presence detected but PHY communication not established (COMINIT is
 * detected) 0x3: Device presence detected and PHY communication established ("PHY
 * Ready" is detected) 0x4: PHY in offline mode as a result of the interface being
 * disabled or running in a BIST loopback mode. All other values reserved.
 */
/*@{*/
#define BP_SATA_P0SSTS_DET   (0U)          /*!< Bit position for SATA_P0SSTS_DET. */
#define BM_SATA_P0SSTS_DET   (0x0000000FU) /*!< Bit mask for SATA_P0SSTS_DET. */
#define BS_SATA_P0SSTS_DET   (4U)          /*!< Bit field size in bits for SATA_P0SSTS_DET. */
/*@}*/

/*!
 * @name Register SATA_P0SSTS, field SPD[7:4] (RO)
 *
 * Current Interface Speed Indicates the negotiated interface communication
 * speed. The options for this field are:
 *
 * Values:
 * - 0 - Device not present or communication not established
 * - 1 - 1.5 Gb/s communication rate negotiated
 * - 10 - 3.0 Gb/s communication rate negotiated
 */
/*@{*/
#define BP_SATA_P0SSTS_SPD   (4U)          /*!< Bit position for SATA_P0SSTS_SPD. */
#define BM_SATA_P0SSTS_SPD   (0x000000F0U) /*!< Bit mask for SATA_P0SSTS_SPD. */
#define BS_SATA_P0SSTS_SPD   (4U)          /*!< Bit field size in bits for SATA_P0SSTS_SPD. */

/*! @brief Read current value of the SATA_P0SSTS_SPD field. */
#define BR_SATA_P0SSTS_SPD(x) (HW_SATA_P0SSTS(x).B.SPD)
/*@}*/

/*!
 * @name Register SATA_P0SSTS, field IPM[11:8] (RO)
 *
 * Interface Power Management Indicates the current interface state. The options
 * for this field are:
 *
 * Values:
 * - 0 - Device not present or communication not established
 * - 1 - Interface in active state
 * - 10 - Interface in Partial power management state
 * - 110 - Interface in Slumber power management state
 */
/*@{*/
#define BP_SATA_P0SSTS_IPM   (8U)          /*!< Bit position for SATA_P0SSTS_IPM. */
#define BM_SATA_P0SSTS_IPM   (0x00000F00U) /*!< Bit mask for SATA_P0SSTS_IPM. */
#define BS_SATA_P0SSTS_IPM   (4U)          /*!< Bit field size in bits for SATA_P0SSTS_IPM. */

/*! @brief Read current value of the SATA_P0SSTS_IPM field. */
#define BR_SATA_P0SSTS_IPM(x) (HW_SATA_P0SSTS(x).B.IPM)
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SCTL - Port0 Serial ATA Control {SControl} Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SCTL - Port0 Serial ATA Control {SControl} Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit read-write register is used by the software to control SATA
 * interface capabilities. Writes to this register result in an action being taken by
 * the Port PHY interface. Reads from the register return the last value written
 * to it. Reset on Global reset. These bits are static and should not be changed
 * frequently due to the clock crossing between the Transport and Link Layers.
 * The software must wait for at least seven periods of the slower clock (clk_asic
 * 0 or hclk) before changing this register
 */
typedef union _hw_sata_p0sctl
{
    uint32_t U;
    struct _hw_sata_p0sctl_bitfields
    {
        uint32_t DET : 4;              /*!< [3:0]  */
        uint32_t SPD : 4;              /*!< [7:4]  */
        uint32_t IPM : 4;              /*!< [11:8]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_sata_p0sctl_t;

/*!
 * @name Constants and macros for entire SATA_P0SCTL register
 */
/*@{*/
#define HW_SATA_P0SCTL_ADDR(x)   ((uintptr_t)(x) + 0x12CU)

#define HW_SATA_P0SCTL(x)        (*(__IO hw_sata_p0sctl_t *) HW_SATA_P0SCTL_ADDR(x))
#define HW_SATA_P0SCTL_RD(x)     (HW_SATA_P0SCTL(x).U)
#define HW_SATA_P0SCTL_WR(x, v)  (HW_SATA_P0SCTL(x).U = (v))
#define HW_SATA_P0SCTL_SET(x, v) (HW_SATA_P0SCTL_WR(x, HW_SATA_P0SCTL_RD(x) |  (v)))
#define HW_SATA_P0SCTL_CLR(x, v) (HW_SATA_P0SCTL_WR(x, HW_SATA_P0SCTL_RD(x) & ~(v)))
#define HW_SATA_P0SCTL_TOG(x, v) (HW_SATA_P0SCTL_WR(x, HW_SATA_P0SCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0SCTL bitfields
 */

/*!
 * @name Register SATA_P0SCTL, field DET[3:0] (RW)
 *
 * Device Detection Initialization Controls the Port's device detection and
 * interface initialization. The options for this field are: This field may only be
 * modified when SATA_P 0 CMD[ST] is 0. Changing this field while the SATA_P 0
 * CMD[ST]=1 results in undefined behavior. When SATA_P 0 CMD[ST] is set to 1, this
 * field should have a value of 0x0.
 *
 * Values:
 * - 0 - No device detection or initialization action requested
 * - 1 - Perform interface initialization sequence to establish communication.
 *     This results in the interface being reset and communication re initialized.
 * - 100 - Disable the Serial ATA interface and put the Port PHY in offline
 *     mode. All other values reserved.
 */
/*@{*/
#define BP_SATA_P0SCTL_DET   (0U)          /*!< Bit position for SATA_P0SCTL_DET. */
#define BM_SATA_P0SCTL_DET   (0x0000000FU) /*!< Bit mask for SATA_P0SCTL_DET. */
#define BS_SATA_P0SCTL_DET   (4U)          /*!< Bit field size in bits for SATA_P0SCTL_DET. */

/*! @brief Read current value of the SATA_P0SCTL_DET field. */
#define BR_SATA_P0SCTL_DET(x) (HW_SATA_P0SCTL(x).B.DET)

/*! @brief Format value for bitfield SATA_P0SCTL_DET. */
#define BF_SATA_P0SCTL_DET(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0SCTL_DET) & BM_SATA_P0SCTL_DET)

/*! @brief Set the DET field to a new value. */
#define BW_SATA_P0SCTL_DET(x, v) (HW_SATA_P0SCTL_WR(x, (HW_SATA_P0SCTL_RD(x) & ~BM_SATA_P0SCTL_DET) | BF_SATA_P0SCTL_DET(v)))
/*@}*/

/*!
 * @name Register SATA_P0SCTL, field SPD[7:4] (RW)
 *
 * Speed Allowed This field indicates the highest allowable speed of the Port
 * PHY interface. The options for this field are: When the host software must
 * change this field value, the host must also reset the Port (SATA_P 0 SCTL[DET] =
 * 0x1) at the same time to ensure proper speed negotiation.
 *
 * Values:
 * - 0 - No speed negotiation restrictions
 * - 1 - Limit speed negotiation to SATA 1.5 Gb/s communication rate
 * - 10 - Limit speed negotiation to SATA 3.0 Gb/s communication rate
 */
/*@{*/
#define BP_SATA_P0SCTL_SPD   (4U)          /*!< Bit position for SATA_P0SCTL_SPD. */
#define BM_SATA_P0SCTL_SPD   (0x000000F0U) /*!< Bit mask for SATA_P0SCTL_SPD. */
#define BS_SATA_P0SCTL_SPD   (4U)          /*!< Bit field size in bits for SATA_P0SCTL_SPD. */

/*! @brief Read current value of the SATA_P0SCTL_SPD field. */
#define BR_SATA_P0SCTL_SPD(x) (HW_SATA_P0SCTL(x).B.SPD)

/*! @brief Format value for bitfield SATA_P0SCTL_SPD. */
#define BF_SATA_P0SCTL_SPD(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0SCTL_SPD) & BM_SATA_P0SCTL_SPD)

/*! @brief Set the SPD field to a new value. */
#define BW_SATA_P0SCTL_SPD(x, v) (HW_SATA_P0SCTL_WR(x, (HW_SATA_P0SCTL_RD(x) & ~BM_SATA_P0SCTL_SPD) | BF_SATA_P0SCTL_SPD(v)))
/*@}*/

/*!
 * @name Register SATA_P0SCTL, field IPM[11:8] (RW)
 *
 * Interface Power Management Transitions Allowed This field indicates which
 * power states the Port PHY interface is allowed to transition to. When an
 * interface power management state is disabled, the Port does not initiate that state
 * and any request from the device to enter that state is rejected via PMNAKp The
 * options for this field are:
 *
 * Values:
 * - 0 - No interface power management state restrictions
 * - 1 - Transitions to the Partial state disabled
 * - 10 - Transitions to the Slumber state disabled
 * - 11 - Transitions to both Partial and Slumber states disabled
 */
/*@{*/
#define BP_SATA_P0SCTL_IPM   (8U)          /*!< Bit position for SATA_P0SCTL_IPM. */
#define BM_SATA_P0SCTL_IPM   (0x00000F00U) /*!< Bit mask for SATA_P0SCTL_IPM. */
#define BS_SATA_P0SCTL_IPM   (4U)          /*!< Bit field size in bits for SATA_P0SCTL_IPM. */

/*! @brief Read current value of the SATA_P0SCTL_IPM field. */
#define BR_SATA_P0SCTL_IPM(x) (HW_SATA_P0SCTL(x).B.IPM)

/*! @brief Format value for bitfield SATA_P0SCTL_IPM. */
#define BF_SATA_P0SCTL_IPM(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0SCTL_IPM) & BM_SATA_P0SCTL_IPM)

/*! @brief Set the IPM field to a new value. */
#define BW_SATA_P0SCTL_IPM(x, v) (HW_SATA_P0SCTL_WR(x, (HW_SATA_P0SCTL_RD(x) & ~BM_SATA_P0SCTL_IPM) | BF_SATA_P0SCTL_IPM(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SERR - Port0 Serial ATA Error Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SERR - Port0 Serial ATA Error Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This 32-bit register represents all the detected interface errors accumulated
 * since the last time it was cleared. The set bits in the SError register
 * indicate that the corresponding error condition became true one or more times since
 * the last time the bit was cleared. The set bits in this register are
 * explicitly cleared by a write operation to the register, Global reset, or Port reset
 * (COMRESET). The value written to clear the set error bits should have ones
 * encoded in the bit positions corresponding to the bits that are to be cleared. All
 * bits in the following table have a reset value of 0.
 */
typedef union _hw_sata_p0serr
{
    uint32_t U;
    struct _hw_sata_p0serr_bitfields
    {
        uint32_t ERR_I : 1;            /*!< [0]  */
        uint32_t ERR_M : 1;            /*!< [1]  */
        uint32_t RESERVED0 : 6;        /*!< [7:2]  */
        uint32_t ERR_T : 1;            /*!< [8]  */
        uint32_t ERR_C : 1;            /*!< [9]  */
        uint32_t ERR_P : 1;            /*!< [10]  */
        uint32_t ERR_E : 1;            /*!< [11]  */
        uint32_t RESERVED1 : 4;        /*!< [15:12]  */
        uint32_t DIAG_N : 1;           /*!< [16]  */
        uint32_t DIAG_I : 1;           /*!< [17]  */
        uint32_t DIAG_W : 1;           /*!< [18]  */
        uint32_t DIAG_B : 1;           /*!< [19]  */
        uint32_t DIAG_D : 1;           /*!< [20]  */
        uint32_t DIAG_C : 1;           /*!< [21]  */
        uint32_t DIAG_H : 1;           /*!< [22]  */
        uint32_t DIAG_S : 1;           /*!< [23]  */
        uint32_t DIAG_T : 1;           /*!< [24]  */
        uint32_t DIAG_F : 1;           /*!< [25]  */
        uint32_t DIAG_X : 1;           /*!< [26]  */
        uint32_t RESERVED2 : 5;        /*!< [31:27]  */
    } B;
} hw_sata_p0serr_t;

/*!
 * @name Constants and macros for entire SATA_P0SERR register
 */
/*@{*/
#define HW_SATA_P0SERR_ADDR(x)   ((uintptr_t)(x) + 0x130U)

#define HW_SATA_P0SERR(x)        (*(__I hw_sata_p0serr_t *) HW_SATA_P0SERR_ADDR(x))
#define HW_SATA_P0SERR_RD(x)     (HW_SATA_P0SERR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0SERR bitfields
 */

/*!
 * @name Register SATA_P0SERR, field ERR_I[0] (RO)
 *
 * This bit is set when any of the following SATA_P 0 SERR register bits is set
 * during non- Data FIS transfer: • DIAG_C (CRC) • DIAG_H (Handshake) •
 * ERR_C ("PHY Ready" negation)
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_I (0U)          /*!< Bit position for SATA_P0SERR_ERR_I. */
#define BM_SATA_P0SERR_ERR_I (0x00000001U) /*!< Bit mask for SATA_P0SERR_ERR_I. */
#define BS_SATA_P0SERR_ERR_I (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_I. */

/*! @brief Read current value of the SATA_P0SERR_ERR_I field. */
#define BR_SATA_P0SERR_ERR_I(x) (HW_SATA_P0SERR(x).B.ERR_I)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field ERR_M[1] (RO)
 *
 * Recovered Communication Error This bit is set to 1 when PHY Ready condition
 * is detected after interface initialization, but not after transition from
 * Partial or Slumber power management state to active state.
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_M (1U)          /*!< Bit position for SATA_P0SERR_ERR_M. */
#define BM_SATA_P0SERR_ERR_M (0x00000002U) /*!< Bit mask for SATA_P0SERR_ERR_M. */
#define BS_SATA_P0SERR_ERR_M (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_M. */

/*! @brief Read current value of the SATA_P0SERR_ERR_M field. */
#define BR_SATA_P0SERR_ERR_M(x) (HW_SATA_P0SERR(x).B.ERR_M)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field ERR_T[8] (RO)
 *
 * Non-Recovered Transient Data Integrity Error This bit is set when any of the
 * following SATA_P 0 SERR register bits is set during Data FIS transfer: ERR_P
 * (Protocol) • DIAG_C (CRC) • DIAG_H (Handshake) • ERR_C ("PHY Ready"
 * negation)
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_T (8U)          /*!< Bit position for SATA_P0SERR_ERR_T. */
#define BM_SATA_P0SERR_ERR_T (0x00000100U) /*!< Bit mask for SATA_P0SERR_ERR_T. */
#define BS_SATA_P0SERR_ERR_T (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_T. */

/*! @brief Read current value of the SATA_P0SERR_ERR_T field. */
#define BR_SATA_P0SERR_ERR_T(x) (HW_SATA_P0SERR(x).B.ERR_T)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field ERR_C[9] (RO)
 *
 * Non-Recovered Persistent Communication Error This bit is set to 1 when PHY
 * Ready signal is negated due to the loss of communication with the device or
 * problems with interface, but not after transition from active to Partial or
 * Slumber power management state.
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_C (9U)          /*!< Bit position for SATA_P0SERR_ERR_C. */
#define BM_SATA_P0SERR_ERR_C (0x00000200U) /*!< Bit mask for SATA_P0SERR_ERR_C. */
#define BS_SATA_P0SERR_ERR_C (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_C. */

/*! @brief Read current value of the SATA_P0SERR_ERR_C field. */
#define BR_SATA_P0SERR_ERR_C(x) (HW_SATA_P0SERR(x).B.ERR_C)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field ERR_P[10] (RO)
 *
 * Protocol Error This bit is set to 1 when any of the following conditions are
 * detected. • Transport state transition error (DIAG_T) • Link sequence
 * error (DIAG_S) • RxFIFO overflow • Link bad end error (WTRM instead of EOF is
 * received).
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_P (10U)         /*!< Bit position for SATA_P0SERR_ERR_P. */
#define BM_SATA_P0SERR_ERR_P (0x00000400U) /*!< Bit mask for SATA_P0SERR_ERR_P. */
#define BS_SATA_P0SERR_ERR_P (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_P. */

/*! @brief Read current value of the SATA_P0SERR_ERR_P field. */
#define BR_SATA_P0SERR_ERR_P(x) (HW_SATA_P0SERR(x).B.ERR_P)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field ERR_E[11] (RO)
 *
 * Internal Error This bit is set to 1 when one or more AHB bus ERROR responses
 * are detected on the master interface.
 */
/*@{*/
#define BP_SATA_P0SERR_ERR_E (11U)         /*!< Bit position for SATA_P0SERR_ERR_E. */
#define BM_SATA_P0SERR_ERR_E (0x00000800U) /*!< Bit mask for SATA_P0SERR_ERR_E. */
#define BS_SATA_P0SERR_ERR_E (1U)          /*!< Bit field size in bits for SATA_P0SERR_ERR_E. */

/*! @brief Read current value of the SATA_P0SERR_ERR_E field. */
#define BR_SATA_P0SERR_ERR_E(x) (HW_SATA_P0SERR(x).B.ERR_E)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_N[16] (RO)
 *
 * PHY Ready Change This bit indicates that the PHY Ready signal changed state.
 * This bit is reflected in the SATA_P 0 IS[PRCS] bit.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_N (16U)        /*!< Bit position for SATA_P0SERR_DIAG_N. */
#define BM_SATA_P0SERR_DIAG_N (0x00010000U) /*!< Bit mask for SATA_P0SERR_DIAG_N. */
#define BS_SATA_P0SERR_DIAG_N (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_N. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_N field. */
#define BR_SATA_P0SERR_DIAG_N(x) (HW_SATA_P0SERR(x).B.DIAG_N)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_I[17] (RO)
 *
 * PHY Internal Error This bit is set when the PHY detects some internal error
 * as indicated by the assertion of the p 0 _phy_rx_err input. The setting of this
 * bit is controlled by the SATA_BISTCR[ERREN] bit: when ERREN==0 (default),
 * only errors occurring inside the received FIS cause DIAG_I bit to be set; when
 * ERREN==1, any error inside or outside the FIS causes the DIAG_I bit to be set.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_I (17U)        /*!< Bit position for SATA_P0SERR_DIAG_I. */
#define BM_SATA_P0SERR_DIAG_I (0x00020000U) /*!< Bit mask for SATA_P0SERR_DIAG_I. */
#define BS_SATA_P0SERR_DIAG_I (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_I. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_I field. */
#define BR_SATA_P0SERR_DIAG_I(x) (HW_SATA_P0SERR(x).B.DIAG_I)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_W[18] (RO)
 *
 * Comm Wake This bit is set when PHY COMWAKE signal is detected.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_W (18U)        /*!< Bit position for SATA_P0SERR_DIAG_W. */
#define BM_SATA_P0SERR_DIAG_W (0x00040000U) /*!< Bit mask for SATA_P0SERR_DIAG_W. */
#define BS_SATA_P0SERR_DIAG_W (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_W. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_W field. */
#define BR_SATA_P0SERR_DIAG_W(x) (HW_SATA_P0SERR(x).B.DIAG_W)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_B[19] (RO)
 *
 * 10B to 8B Decode Error This bit indicates errors were detected by 10b8b
 * decoder. This bit indicates that one or more CRC errors were detected by the Link
 * layer during FIS reception. This bit is set only when an error is detected on
 * the received FIS data dword. This bit is not set when an error is detected on
 * the primitive, regardless whether it is inside or outside the FIS.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_B (19U)        /*!< Bit position for SATA_P0SERR_DIAG_B. */
#define BM_SATA_P0SERR_DIAG_B (0x00080000U) /*!< Bit mask for SATA_P0SERR_DIAG_B. */
#define BS_SATA_P0SERR_DIAG_B (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_B. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_B field. */
#define BR_SATA_P0SERR_DIAG_B(x) (HW_SATA_P0SERR(x).B.DIAG_B)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_D[20] (RO)
 *
 * Disparity Error This bit is always cleared to 0 since it is not used by the
 * AHCI specification.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_D (20U)        /*!< Bit position for SATA_P0SERR_DIAG_D. */
#define BM_SATA_P0SERR_DIAG_D (0x00100000U) /*!< Bit mask for SATA_P0SERR_DIAG_D. */
#define BS_SATA_P0SERR_DIAG_D (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_D. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_D field. */
#define BR_SATA_P0SERR_DIAG_D(x) (HW_SATA_P0SERR(x).B.DIAG_D)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_C[21] (RO)
 *
 * CRC Error
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_C (21U)        /*!< Bit position for SATA_P0SERR_DIAG_C. */
#define BM_SATA_P0SERR_DIAG_C (0x00200000U) /*!< Bit mask for SATA_P0SERR_DIAG_C. */
#define BS_SATA_P0SERR_DIAG_C (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_C. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_C field. */
#define BR_SATA_P0SERR_DIAG_C(x) (HW_SATA_P0SERR(x).B.DIAG_C)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_H[22] (RO)
 *
 * Handshake Error This bit indicates that one or more R_ERRp was received in
 * response to frame transmission. Such errors may be the result of a CRC error
 * detected by the device, a disparity or 8b/10b decoding error, or other error
 * condition leading to a negative handshake on a transmitted frame.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_H (22U)        /*!< Bit position for SATA_P0SERR_DIAG_H. */
#define BM_SATA_P0SERR_DIAG_H (0x00400000U) /*!< Bit mask for SATA_P0SERR_DIAG_H. */
#define BS_SATA_P0SERR_DIAG_H (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_H. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_H field. */
#define BR_SATA_P0SERR_DIAG_H(x) (HW_SATA_P0SERR(x).B.DIAG_H)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_S[23] (RO)
 *
 * Link Sequence Error This bit indicates that one or more Link state machine
 * error conditions was encountered. One of the conditions that cause this bit to
 * be set is device doing SYNC escape during FIS transmission.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_S (23U)        /*!< Bit position for SATA_P0SERR_DIAG_S. */
#define BM_SATA_P0SERR_DIAG_S (0x00800000U) /*!< Bit mask for SATA_P0SERR_DIAG_S. */
#define BS_SATA_P0SERR_DIAG_S (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_S. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_S field. */
#define BR_SATA_P0SERR_DIAG_S(x) (HW_SATA_P0SERR(x).B.DIAG_S)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_T[24] (RO)
 *
 * Transport State Transition Error This bit indicates that a Transport Layer
 * protocol violation was detected since the last time this bit was cleared. See
 * Transport Check (TCHK) for details.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_T (24U)        /*!< Bit position for SATA_P0SERR_DIAG_T. */
#define BM_SATA_P0SERR_DIAG_T (0x01000000U) /*!< Bit mask for SATA_P0SERR_DIAG_T. */
#define BS_SATA_P0SERR_DIAG_T (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_T. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_T field. */
#define BR_SATA_P0SERR_DIAG_T(x) (HW_SATA_P0SERR(x).B.DIAG_T)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_F[25] (RO)
 *
 * Unknown FIS Type This bit indicates that one or more FISes were received by
 * the Transport layer with good CRC, but had a type field that was not
 * recognized/known and the length was less than or equal to 64bytes. When the Unknown FIS
 * length exceeds 64 bytes, the DIAG_F bit is not set and the DIAG_T bit is set
 * instead.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_F (25U)        /*!< Bit position for SATA_P0SERR_DIAG_F. */
#define BM_SATA_P0SERR_DIAG_F (0x02000000U) /*!< Bit mask for SATA_P0SERR_DIAG_F. */
#define BS_SATA_P0SERR_DIAG_F (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_F. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_F field. */
#define BR_SATA_P0SERR_DIAG_F(x) (HW_SATA_P0SERR(x).B.DIAG_F)
/*@}*/

/*!
 * @name Register SATA_P0SERR, field DIAG_X[26] (RO)
 *
 * Exchanged This bit is set to 1 when PHY COMINIT signal is detected. This bit
 * is reflected in the SATA_P 0 IS[PCS] bit.
 */
/*@{*/
#define BP_SATA_P0SERR_DIAG_X (26U)        /*!< Bit position for SATA_P0SERR_DIAG_X. */
#define BM_SATA_P0SERR_DIAG_X (0x04000000U) /*!< Bit mask for SATA_P0SERR_DIAG_X. */
#define BS_SATA_P0SERR_DIAG_X (1U)         /*!< Bit field size in bits for SATA_P0SERR_DIAG_X. */

/*! @brief Read current value of the SATA_P0SERR_DIAG_X field. */
#define BR_SATA_P0SERR_DIAG_X(x) (HW_SATA_P0SERR(x).B.DIAG_X)
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SACT - Port0 Serial ATA Active Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SACT - Port0 Serial ATA Active Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sata_p0sact
{
    uint32_t U;
    struct _hw_sata_p0sact_bitfields
    {
        uint32_t DS : 32;              /*!< [31:0]  */
    } B;
} hw_sata_p0sact_t;

/*!
 * @name Constants and macros for entire SATA_P0SACT register
 */
/*@{*/
#define HW_SATA_P0SACT_ADDR(x)   ((uintptr_t)(x) + 0x134U)

#define HW_SATA_P0SACT(x)        (*(__IO hw_sata_p0sact_t *) HW_SATA_P0SACT_ADDR(x))
#define HW_SATA_P0SACT_RD(x)     (HW_SATA_P0SACT(x).U)
#define HW_SATA_P0SACT_WR(x, v)  (HW_SATA_P0SACT(x).U = (v))
#define HW_SATA_P0SACT_SET(x, v) (HW_SATA_P0SACT_WR(x, HW_SATA_P0SACT_RD(x) |  (v)))
#define HW_SATA_P0SACT_CLR(x, v) (HW_SATA_P0SACT_WR(x, HW_SATA_P0SACT_RD(x) & ~(v)))
#define HW_SATA_P0SACT_TOG(x, v) (HW_SATA_P0SACT_WR(x, HW_SATA_P0SACT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0SACT bitfields
 */

/*!
 * @name Register SATA_P0SACT, field DS[31:0] (RW)
 *
 * Device Status This field is bit significant. Each bit corresponds to the TAG
 * and command slot of a native queued command, where bit 0 corresponds to TAG 0
 * and command slot 0. Software sets this field prior to issuing a native queued
 * command for a particular command slot. Prior to writing SATA_P 0 CI[TAG] to 1,
 * the software sets DS[TAG] to 1 to indicate that a command with that TAG is
 * outstanding. This field is cleared to 0 when: • The software writes SATA_P 0
 * CMD[ST from a 1 to a 0 . • The device sends a Set Device Bits FIS to the
 * Port. The Port clears bits in this field that are set in the SActive field of the
 * Set Device Bits FIS. The Port clears only bits that correspond to native
 * queued commands that have completed successfully. This field is not cleared by the
 * following: • Port reset (COMRESET). • Software reset. Software must write
 * this field only when SATA_P 0 CMD[ST] bit is set to 1.
 */
/*@{*/
#define BP_SATA_P0SACT_DS    (0U)          /*!< Bit position for SATA_P0SACT_DS. */
#define BM_SATA_P0SACT_DS    (0xFFFFFFFFU) /*!< Bit mask for SATA_P0SACT_DS. */
#define BS_SATA_P0SACT_DS    (32U)         /*!< Bit field size in bits for SATA_P0SACT_DS. */

/*! @brief Read current value of the SATA_P0SACT_DS field. */
#define BR_SATA_P0SACT_DS(x) (HW_SATA_P0SACT(x).U)

/*! @brief Format value for bitfield SATA_P0SACT_DS. */
#define BF_SATA_P0SACT_DS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0SACT_DS) & BM_SATA_P0SACT_DS)

/*! @brief Set the DS field to a new value. */
#define BW_SATA_P0SACT_DS(x, v) (HW_SATA_P0SACT_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0CI - Port0 Command Issue Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0CI - Port0 Command Issue Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sata_p0ci
{
    uint32_t U;
    struct _hw_sata_p0ci_bitfields
    {
        uint32_t CI : 32;              /*!< [31:0]  */
    } B;
} hw_sata_p0ci_t;

/*!
 * @name Constants and macros for entire SATA_P0CI register
 */
/*@{*/
#define HW_SATA_P0CI_ADDR(x)     ((uintptr_t)(x) + 0x138U)

#define HW_SATA_P0CI(x)          (*(__IO hw_sata_p0ci_t *) HW_SATA_P0CI_ADDR(x))
#define HW_SATA_P0CI_RD(x)       (HW_SATA_P0CI(x).U)
#define HW_SATA_P0CI_WR(x, v)    (HW_SATA_P0CI(x).U = (v))
#define HW_SATA_P0CI_SET(x, v)   (HW_SATA_P0CI_WR(x, HW_SATA_P0CI_RD(x) |  (v)))
#define HW_SATA_P0CI_CLR(x, v)   (HW_SATA_P0CI_WR(x, HW_SATA_P0CI_RD(x) & ~(v)))
#define HW_SATA_P0CI_TOG(x, v)   (HW_SATA_P0CI_WR(x, HW_SATA_P0CI_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0CI bitfields
 */

/*!
 * @name Register SATA_P0CI, field CI[31:0] (RW)
 *
 * Command Issued This field is bit significant. Each bit corresponds to a
 * command slot, where bit 0 corresponds to command slot 0. This field is set by the
 * software to indicate to the Port that a command has been built in system memory
 * for a command slot and may be sent to the device. When the Port receives a
 * FIS which clears the BSY, DRQ, and ERR bits for the command, it clears the
 * corresponding bit in this register for that command slot. Bits in this field can
 * only be set to 1 by the software when SATA_P 0 CMD[ST] is set to 1. This field
 * is reset when SATA_P 0 CMD[ST] is written from a 1 to a 0 by the software.
 */
/*@{*/
#define BP_SATA_P0CI_CI      (0U)          /*!< Bit position for SATA_P0CI_CI. */
#define BM_SATA_P0CI_CI      (0xFFFFFFFFU) /*!< Bit mask for SATA_P0CI_CI. */
#define BS_SATA_P0CI_CI      (32U)         /*!< Bit field size in bits for SATA_P0CI_CI. */

/*! @brief Read current value of the SATA_P0CI_CI field. */
#define BR_SATA_P0CI_CI(x)   (HW_SATA_P0CI(x).U)

/*! @brief Format value for bitfield SATA_P0CI_CI. */
#define BF_SATA_P0CI_CI(v)   ((uint32_t)((uint32_t)(v) << BP_SATA_P0CI_CI) & BM_SATA_P0CI_CI)

/*! @brief Set the CI field to a new value. */
#define BW_SATA_P0CI_CI(x, v) (HW_SATA_P0CI_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0SNTF - Port0 Serial ATA Notification Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0SNTF - Port0 Serial ATA Notification Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to determine when asynchronous notification events have
 * occurred for directly connected devices and devices connected to a Port
 * Multiplier.
 */
typedef union _hw_sata_p0sntf
{
    uint32_t U;
    struct _hw_sata_p0sntf_bitfields
    {
        uint32_t PMN : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sata_p0sntf_t;

/*!
 * @name Constants and macros for entire SATA_P0SNTF register
 */
/*@{*/
#define HW_SATA_P0SNTF_ADDR(x)   ((uintptr_t)(x) + 0x13CU)

#define HW_SATA_P0SNTF(x)        (*(__IO hw_sata_p0sntf_t *) HW_SATA_P0SNTF_ADDR(x))
#define HW_SATA_P0SNTF_RD(x)     (HW_SATA_P0SNTF(x).U)
#define HW_SATA_P0SNTF_WR(x, v)  (HW_SATA_P0SNTF(x).U = (v))
#define HW_SATA_P0SNTF_SET(x, v) (HW_SATA_P0SNTF_WR(x, HW_SATA_P0SNTF_RD(x) |  (v)))
#define HW_SATA_P0SNTF_CLR(x, v) (HW_SATA_P0SNTF_WR(x, HW_SATA_P0SNTF_RD(x) & ~(v)))
#define HW_SATA_P0SNTF_TOG(x, v) (HW_SATA_P0SNTF_WR(x, HW_SATA_P0SNTF_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0SNTF bitfields
 */

/*!
 * @name Register SATA_P0SNTF, field PMN[15:0] (W1C)
 *
 * PM Notify This field indicates whether a particular device with the
 * corresponding PM Port number issued a Set Device Bits FIS to the SATA block Port with
 * the Notification bit set: • PM Port 0h sets bit 0, • PM Port 1h sets bit 1,
 * ... • PM Port Fh sets bit 15. Individual bits are cleared by the software
 * writing 1s to the corresponding bit positions. This field is reset on Global
 * reset, but it is not reset by Port reset (COMRESET) or software reset.
 */
/*@{*/
#define BP_SATA_P0SNTF_PMN   (0U)          /*!< Bit position for SATA_P0SNTF_PMN. */
#define BM_SATA_P0SNTF_PMN   (0x0000FFFFU) /*!< Bit mask for SATA_P0SNTF_PMN. */
#define BS_SATA_P0SNTF_PMN   (16U)         /*!< Bit field size in bits for SATA_P0SNTF_PMN. */

/*! @brief Read current value of the SATA_P0SNTF_PMN field. */
#define BR_SATA_P0SNTF_PMN(x) (HW_SATA_P0SNTF(x).B.PMN)

/*! @brief Format value for bitfield SATA_P0SNTF_PMN. */
#define BF_SATA_P0SNTF_PMN(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0SNTF_PMN) & BM_SATA_P0SNTF_PMN)

/*! @brief Set the PMN field to a new value. */
#define BW_SATA_P0SNTF_PMN(x, v) (HW_SATA_P0SNTF_WR(x, (HW_SATA_P0SNTF_RD(x) & ~BM_SATA_P0SNTF_PMN) | BF_SATA_P0SNTF_PMN(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0DMACR - Port0 DMA Control Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0DMACR - Port0 DMA Control Register (RW)
 *
 * Reset value: 0x00000044U
 *
 * This register contains bits for controlling the Port DMA engine. The software
 * can change the fields of this register only when SATA_P 0 CMD[ST]=0. Power-up
 * (system reset), Global reset, or Port reset (COMRESET) reset this register to
 * the default value.
 */
typedef union _hw_sata_p0dmacr
{
    uint32_t U;
    struct _hw_sata_p0dmacr_bitfields
    {
        uint32_t TXTS : 4;             /*!< [3:0]  */
        uint32_t RXTS : 4;             /*!< [7:4]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_sata_p0dmacr_t;

/*!
 * @name Constants and macros for entire SATA_P0DMACR register
 */
/*@{*/
#define HW_SATA_P0DMACR_ADDR(x)  ((uintptr_t)(x) + 0x170U)

#define HW_SATA_P0DMACR(x)       (*(__IO hw_sata_p0dmacr_t *) HW_SATA_P0DMACR_ADDR(x))
#define HW_SATA_P0DMACR_RD(x)    (HW_SATA_P0DMACR(x).U)
#define HW_SATA_P0DMACR_WR(x, v) (HW_SATA_P0DMACR(x).U = (v))
#define HW_SATA_P0DMACR_SET(x, v) (HW_SATA_P0DMACR_WR(x, HW_SATA_P0DMACR_RD(x) |  (v)))
#define HW_SATA_P0DMACR_CLR(x, v) (HW_SATA_P0DMACR_WR(x, HW_SATA_P0DMACR_RD(x) & ~(v)))
#define HW_SATA_P0DMACR_TOG(x, v) (HW_SATA_P0DMACR_WR(x, HW_SATA_P0DMACR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0DMACR bitfields
 */

/*!
 * @name Register SATA_P0DMACR, field TXTS[3:0] (RW)
 *
 * Transmit Transaction Size This field defines the DMA transaction size in
 * DWORDs for transmit (system bus read, device write) operation. The options for
 * this field are: This field is read-write when SATA_P 0 CMD[ST]=0 and read-only
 * when SATA_P 0 CMD[ST]=1. The maximum value of this field is determined by the
 * TxFIFO depth parameter. When the software attempts to write a value exceeding
 * this value, the maximum value would be set instead.
 *
 * Values:
 * - 0 - 1 DWORD
 * - 1 - 2 DWORD
 * - 10 - 4 DWORD
 * - 11 - 8 DWORD
 * - 100 - 16 DWORDs (maximum value when TXFIFO_DEPTH=32)
 * - 101 - 32 DWORDs (maximum value when TXFIFO_DEPTH=64)
 * - 110 - 64 DWORDs (maximum value when TXFIFO_DEPTH=128)
 * - 111 - 128 DWORDs (maximum value when TXFIFO_DEPTH=256)
 * - 1000 - 256 DWORDs (maximum value when TXFIFO_DEPTH=512)
 * - 1001 - 512 DWORDs (maximum value when TXFIFO_DEPTH=1024)
 * - 1010 - 1024 DWORDs (maximum value when TXFIFO_DEPTH=2048) All other values
 *     are reserved and should not be used.
 */
/*@{*/
#define BP_SATA_P0DMACR_TXTS (0U)          /*!< Bit position for SATA_P0DMACR_TXTS. */
#define BM_SATA_P0DMACR_TXTS (0x0000000FU) /*!< Bit mask for SATA_P0DMACR_TXTS. */
#define BS_SATA_P0DMACR_TXTS (4U)          /*!< Bit field size in bits for SATA_P0DMACR_TXTS. */

/*! @brief Read current value of the SATA_P0DMACR_TXTS field. */
#define BR_SATA_P0DMACR_TXTS(x) (HW_SATA_P0DMACR(x).B.TXTS)

/*! @brief Format value for bitfield SATA_P0DMACR_TXTS. */
#define BF_SATA_P0DMACR_TXTS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0DMACR_TXTS) & BM_SATA_P0DMACR_TXTS)

/*! @brief Set the TXTS field to a new value. */
#define BW_SATA_P0DMACR_TXTS(x, v) (HW_SATA_P0DMACR_WR(x, (HW_SATA_P0DMACR_RD(x) & ~BM_SATA_P0DMACR_TXTS) | BF_SATA_P0DMACR_TXTS(v)))
/*@}*/

/*!
 * @name Register SATA_P0DMACR, field RXTS[7:4] (RW)
 *
 * Receive Transaction Size This field defines the Port DMA transaction size in
 * DWORDs for receive (system bus write, device read) operation. This field is
 * read-write when SATA_P 0 CMD[ST]=0 and read-only when SATA_P 0 CMD[ST]=1. The
 * maximum value of this field is determined by the RxFIFO depth parameter. When
 * the software attempts to write a value exceeding this value, the maximum value
 * would be set instead.
 *
 * Values:
 * - 0 - 1 DWORD
 * - 1 - 2 DWORD
 * - 10 - 4 DWORD
 * - 11 - 8 DWORD
 * - 100 - 16 DWORDs (maximum value when RXFIFO_DEPTH=64)
 * - 101 - 32 DWORD
 * - 110 - 64 DWORDs (maximum value when RXFIFO_DEPTH=128)
 * - 111 - 128 DWORDs (maximum value when RXFIFO_DEPTH=256)
 * - 1000 - 256 DWORDs (maximum value when RXFIFO_DEPTH=512)
 * - 1001 - 12 DWORDs (maximum value when RXFIFO_DEPTH=1024)
 * - 1010 - 1024 DWORDs (maximum value when RXFIFO_DEPTH=2048) All other values
 *     are reserved and should not be used.
 */
/*@{*/
#define BP_SATA_P0DMACR_RXTS (4U)          /*!< Bit position for SATA_P0DMACR_RXTS. */
#define BM_SATA_P0DMACR_RXTS (0x000000F0U) /*!< Bit mask for SATA_P0DMACR_RXTS. */
#define BS_SATA_P0DMACR_RXTS (4U)          /*!< Bit field size in bits for SATA_P0DMACR_RXTS. */

/*! @brief Read current value of the SATA_P0DMACR_RXTS field. */
#define BR_SATA_P0DMACR_RXTS(x) (HW_SATA_P0DMACR(x).B.RXTS)

/*! @brief Format value for bitfield SATA_P0DMACR_RXTS. */
#define BF_SATA_P0DMACR_RXTS(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0DMACR_RXTS) & BM_SATA_P0DMACR_RXTS)

/*! @brief Set the RXTS field to a new value. */
#define BW_SATA_P0DMACR_RXTS(x, v) (HW_SATA_P0DMACR_WR(x, (HW_SATA_P0DMACR_RD(x) & ~BM_SATA_P0DMACR_RXTS) | BF_SATA_P0DMACR_RXTS(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0PHYCR - Port0 PHY Control Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0PHYCR - Port0 PHY Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used for Port PHY control. Bits of this register are
 * connected to the corresponding bits of the p 0 _phy_ctrl output Port. The SATA_P 0
 * PHYCR register supports only 32-bit write access
 */
typedef union _hw_sata_p0phycr
{
    uint32_t U;
    struct _hw_sata_p0phycr_bitfields
    {
        uint32_t CR_DATA_IN : 16;      /*!< [15:0]  */
        uint32_t CR_CAP_ADDR : 1;      /*!< [16]  */
        uint32_t CR_CAP_DATA : 1;      /*!< [17]  */
        uint32_t CR_WRITE : 1;         /*!< [18]  */
        uint32_t CR_READ : 1;          /*!< [19]  */
        uint32_t TEST_PDDQ : 1;        /*!< [20]  */
        uint32_t RESERVED0 : 11;       /*!< [31:21]  */
    } B;
} hw_sata_p0phycr_t;

/*!
 * @name Constants and macros for entire SATA_P0PHYCR register
 */
/*@{*/
#define HW_SATA_P0PHYCR_ADDR(x)  ((uintptr_t)(x) + 0x178U)

#define HW_SATA_P0PHYCR(x)       (*(__IO hw_sata_p0phycr_t *) HW_SATA_P0PHYCR_ADDR(x))
#define HW_SATA_P0PHYCR_RD(x)    (HW_SATA_P0PHYCR(x).U)
#define HW_SATA_P0PHYCR_WR(x, v) (HW_SATA_P0PHYCR(x).U = (v))
#define HW_SATA_P0PHYCR_SET(x, v) (HW_SATA_P0PHYCR_WR(x, HW_SATA_P0PHYCR_RD(x) |  (v)))
#define HW_SATA_P0PHYCR_CLR(x, v) (HW_SATA_P0PHYCR_WR(x, HW_SATA_P0PHYCR_RD(x) & ~(v)))
#define HW_SATA_P0PHYCR_TOG(x, v) (HW_SATA_P0PHYCR_WR(x, HW_SATA_P0PHYCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SATA_P0PHYCR bitfields
 */

/*!
 * @name Register SATA_P0PHYCR, field CR_DATA_IN[15:0] (RW)
 *
 * CR Address and Write Data Input Bus. Supplies and captures address and write
 * data.
 */
/*@{*/
#define BP_SATA_P0PHYCR_CR_DATA_IN (0U)    /*!< Bit position for SATA_P0PHYCR_CR_DATA_IN. */
#define BM_SATA_P0PHYCR_CR_DATA_IN (0x0000FFFFU) /*!< Bit mask for SATA_P0PHYCR_CR_DATA_IN. */
#define BS_SATA_P0PHYCR_CR_DATA_IN (16U)   /*!< Bit field size in bits for SATA_P0PHYCR_CR_DATA_IN. */

/*! @brief Read current value of the SATA_P0PHYCR_CR_DATA_IN field. */
#define BR_SATA_P0PHYCR_CR_DATA_IN(x) (HW_SATA_P0PHYCR(x).B.CR_DATA_IN)

/*! @brief Format value for bitfield SATA_P0PHYCR_CR_DATA_IN. */
#define BF_SATA_P0PHYCR_CR_DATA_IN(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_CR_DATA_IN) & BM_SATA_P0PHYCR_CR_DATA_IN)

/*! @brief Set the CR_DATA_IN field to a new value. */
#define BW_SATA_P0PHYCR_CR_DATA_IN(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_CR_DATA_IN) | BF_SATA_P0PHYCR_CR_DATA_IN(v)))
/*@}*/

/*!
 * @name Register SATA_P0PHYCR, field CR_CAP_ADDR[16] (RW)
 *
 * CR Capture Address. Captures phy_cr_data_in[15:0] into the Address register.
 */
/*@{*/
#define BP_SATA_P0PHYCR_CR_CAP_ADDR (16U)  /*!< Bit position for SATA_P0PHYCR_CR_CAP_ADDR. */
#define BM_SATA_P0PHYCR_CR_CAP_ADDR (0x00010000U) /*!< Bit mask for SATA_P0PHYCR_CR_CAP_ADDR. */
#define BS_SATA_P0PHYCR_CR_CAP_ADDR (1U)   /*!< Bit field size in bits for SATA_P0PHYCR_CR_CAP_ADDR. */

/*! @brief Read current value of the SATA_P0PHYCR_CR_CAP_ADDR field. */
#define BR_SATA_P0PHYCR_CR_CAP_ADDR(x) (HW_SATA_P0PHYCR(x).B.CR_CAP_ADDR)

/*! @brief Format value for bitfield SATA_P0PHYCR_CR_CAP_ADDR. */
#define BF_SATA_P0PHYCR_CR_CAP_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_CR_CAP_ADDR) & BM_SATA_P0PHYCR_CR_CAP_ADDR)

/*! @brief Set the CR_CAP_ADDR field to a new value. */
#define BW_SATA_P0PHYCR_CR_CAP_ADDR(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_CR_CAP_ADDR) | BF_SATA_P0PHYCR_CR_CAP_ADDR(v)))
/*@}*/

/*!
 * @name Register SATA_P0PHYCR, field CR_CAP_DATA[17] (RW)
 *
 * CR Capture Data. Captures phy_cr_data_in[15:0] into the Write Data register.
 */
/*@{*/
#define BP_SATA_P0PHYCR_CR_CAP_DATA (17U)  /*!< Bit position for SATA_P0PHYCR_CR_CAP_DATA. */
#define BM_SATA_P0PHYCR_CR_CAP_DATA (0x00020000U) /*!< Bit mask for SATA_P0PHYCR_CR_CAP_DATA. */
#define BS_SATA_P0PHYCR_CR_CAP_DATA (1U)   /*!< Bit field size in bits for SATA_P0PHYCR_CR_CAP_DATA. */

/*! @brief Read current value of the SATA_P0PHYCR_CR_CAP_DATA field. */
#define BR_SATA_P0PHYCR_CR_CAP_DATA(x) (HW_SATA_P0PHYCR(x).B.CR_CAP_DATA)

/*! @brief Format value for bitfield SATA_P0PHYCR_CR_CAP_DATA. */
#define BF_SATA_P0PHYCR_CR_CAP_DATA(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_CR_CAP_DATA) & BM_SATA_P0PHYCR_CR_CAP_DATA)

/*! @brief Set the CR_CAP_DATA field to a new value. */
#define BW_SATA_P0PHYCR_CR_CAP_DATA(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_CR_CAP_DATA) | BF_SATA_P0PHYCR_CR_CAP_DATA(v)))
/*@}*/

/*!
 * @name Register SATA_P0PHYCR, field CR_WRITE[18] (RW)
 *
 * CR Write. Writes the Write Data register to the referenced Address register.
 */
/*@{*/
#define BP_SATA_P0PHYCR_CR_WRITE (18U)     /*!< Bit position for SATA_P0PHYCR_CR_WRITE. */
#define BM_SATA_P0PHYCR_CR_WRITE (0x00040000U) /*!< Bit mask for SATA_P0PHYCR_CR_WRITE. */
#define BS_SATA_P0PHYCR_CR_WRITE (1U)      /*!< Bit field size in bits for SATA_P0PHYCR_CR_WRITE. */

/*! @brief Read current value of the SATA_P0PHYCR_CR_WRITE field. */
#define BR_SATA_P0PHYCR_CR_WRITE(x) (HW_SATA_P0PHYCR(x).B.CR_WRITE)

/*! @brief Format value for bitfield SATA_P0PHYCR_CR_WRITE. */
#define BF_SATA_P0PHYCR_CR_WRITE(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_CR_WRITE) & BM_SATA_P0PHYCR_CR_WRITE)

/*! @brief Set the CR_WRITE field to a new value. */
#define BW_SATA_P0PHYCR_CR_WRITE(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_CR_WRITE) | BF_SATA_P0PHYCR_CR_WRITE(v)))
/*@}*/

/*!
 * @name Register SATA_P0PHYCR, field CR_READ[19] (RW)
 *
 * CR Read. Reads from the referenced Address register.
 */
/*@{*/
#define BP_SATA_P0PHYCR_CR_READ (19U)      /*!< Bit position for SATA_P0PHYCR_CR_READ. */
#define BM_SATA_P0PHYCR_CR_READ (0x00080000U) /*!< Bit mask for SATA_P0PHYCR_CR_READ. */
#define BS_SATA_P0PHYCR_CR_READ (1U)       /*!< Bit field size in bits for SATA_P0PHYCR_CR_READ. */

/*! @brief Read current value of the SATA_P0PHYCR_CR_READ field. */
#define BR_SATA_P0PHYCR_CR_READ(x) (HW_SATA_P0PHYCR(x).B.CR_READ)

/*! @brief Format value for bitfield SATA_P0PHYCR_CR_READ. */
#define BF_SATA_P0PHYCR_CR_READ(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_CR_READ) & BM_SATA_P0PHYCR_CR_READ)

/*! @brief Set the CR_READ field to a new value. */
#define BW_SATA_P0PHYCR_CR_READ(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_CR_READ) | BF_SATA_P0PHYCR_CR_READ(v)))
/*@}*/

/*!
 * @name Register SATA_P0PHYCR, field TEST_PDDQ[20] (RW)
 *
 * Test IDDQ
 */
/*@{*/
#define BP_SATA_P0PHYCR_TEST_PDDQ (20U)    /*!< Bit position for SATA_P0PHYCR_TEST_PDDQ. */
#define BM_SATA_P0PHYCR_TEST_PDDQ (0x00100000U) /*!< Bit mask for SATA_P0PHYCR_TEST_PDDQ. */
#define BS_SATA_P0PHYCR_TEST_PDDQ (1U)     /*!< Bit field size in bits for SATA_P0PHYCR_TEST_PDDQ. */

/*! @brief Read current value of the SATA_P0PHYCR_TEST_PDDQ field. */
#define BR_SATA_P0PHYCR_TEST_PDDQ(x) (HW_SATA_P0PHYCR(x).B.TEST_PDDQ)

/*! @brief Format value for bitfield SATA_P0PHYCR_TEST_PDDQ. */
#define BF_SATA_P0PHYCR_TEST_PDDQ(v) ((uint32_t)((uint32_t)(v) << BP_SATA_P0PHYCR_TEST_PDDQ) & BM_SATA_P0PHYCR_TEST_PDDQ)

/*! @brief Set the TEST_PDDQ field to a new value. */
#define BW_SATA_P0PHYCR_TEST_PDDQ(x, v) (HW_SATA_P0PHYCR_WR(x, (HW_SATA_P0PHYCR_RD(x) & ~BM_SATA_P0PHYCR_TEST_PDDQ) | BF_SATA_P0PHYCR_TEST_PDDQ(v)))
/*@}*/

/*******************************************************************************
 * HW_SATA_P0PHYSR - Port0 PHY Status Register
 ******************************************************************************/

/*!
 * @brief HW_SATA_P0PHYSR - Port0 PHY Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to monitor PHY status. The bits of this register
 * reflect the state of the corresponding bits of the p 0 _phy_status input. Signals
 * connected to the p 0 _phy_status input can be asynchronous to any of the SATA
 * block clocks, however they must not change faster than five hclk periods,
 * otherwise the SATA_P 0 PHYSR register may never be updated with the intermediate
 * changing values.
 */
typedef union _hw_sata_p0physr
{
    uint32_t U;
    struct _hw_sata_p0physr_bitfields
    {
        uint32_t CR_DATA_OUT : 16;     /*!< [15:0]  */
        uint32_t RESERVED0 : 2;        /*!< [17:16]  */
        uint32_t CR_ACK : 1;           /*!< [18]  */
        uint32_t RESERVED1 : 13;       /*!< [31:19]  */
    } B;
} hw_sata_p0physr_t;

/*!
 * @name Constants and macros for entire SATA_P0PHYSR register
 */
/*@{*/
#define HW_SATA_P0PHYSR_ADDR(x)  ((uintptr_t)(x) + 0x17CU)

#define HW_SATA_P0PHYSR(x)       (*(__I hw_sata_p0physr_t *) HW_SATA_P0PHYSR_ADDR(x))
#define HW_SATA_P0PHYSR_RD(x)    (HW_SATA_P0PHYSR(x).U)
/*@}*/

/*
 * Constants & macros for individual SATA_P0PHYSR bitfields
 */

/*!
 * @name Register SATA_P0PHYSR, field CR_DATA_OUT[15:0] (RO)
 *
 * CR Data Output Bus. Always presents last read data.
 */
/*@{*/
#define BP_SATA_P0PHYSR_CR_DATA_OUT (0U)   /*!< Bit position for SATA_P0PHYSR_CR_DATA_OUT. */
#define BM_SATA_P0PHYSR_CR_DATA_OUT (0x0000FFFFU) /*!< Bit mask for SATA_P0PHYSR_CR_DATA_OUT. */
#define BS_SATA_P0PHYSR_CR_DATA_OUT (16U)  /*!< Bit field size in bits for SATA_P0PHYSR_CR_DATA_OUT. */

/*! @brief Read current value of the SATA_P0PHYSR_CR_DATA_OUT field. */
#define BR_SATA_P0PHYSR_CR_DATA_OUT(x) (HW_SATA_P0PHYSR(x).B.CR_DATA_OUT)
/*@}*/

/*!
 * @name Register SATA_P0PHYSR, field CR_ACK[18] (RO)
 *
 * CR Acknowledgement. Acknowledgement for the phy_cr_cap_addr, phy_cr_cap_data,
 * phy_cr_write, and phy_cr_read control signals.
 */
/*@{*/
#define BP_SATA_P0PHYSR_CR_ACK (18U)       /*!< Bit position for SATA_P0PHYSR_CR_ACK. */
#define BM_SATA_P0PHYSR_CR_ACK (0x00040000U) /*!< Bit mask for SATA_P0PHYSR_CR_ACK. */
#define BS_SATA_P0PHYSR_CR_ACK (1U)        /*!< Bit field size in bits for SATA_P0PHYSR_CR_ACK. */

/*! @brief Read current value of the SATA_P0PHYSR_CR_ACK field. */
#define BR_SATA_P0PHYSR_CR_ACK(x) (HW_SATA_P0PHYSR(x).B.CR_ACK)
/*@}*/

/*******************************************************************************
 * hw_sata_t - module struct
 ******************************************************************************/
/*!
 * @brief All SATA module registers.
 */
#pragma pack(1)
typedef struct _hw_sata
{
    __I hw_sata_cap_t CAP;                 /*!< [0x0] HBA Capabilites Register */
    __IO hw_sata_ghc_t GHC;                /*!< [0x4] Global HBA Control Register */
    __IO hw_sata_is_t IS;                  /*!< [0x8] Interrupt Status Register */
    __I hw_sata_pi_t PI;                   /*!< [0xC] Ports Implemented Register */
    __I hw_sata_vs_t VS;                   /*!< [0x10] AHCl Version Register */
    __IO hw_sata_ccc_ctl_t CCC_CTL;        /*!< [0x14] Command Completion Coalescing Control */
    __IO hw_sata_ccc_ports_t CCC_PORTS;    /*!< [0x18] Command Completion Coalescing Ports */
    uint8_t _reserved0[8];
    __I hw_sata_cap2_t CAP2;               /*!< [0x24] HBA Capabilities Extended Register */
    uint8_t _reserved1[120];
    __I hw_sata_bistafr_t BISTAFR;         /*!< [0xA0] BIST Activate FIS Register */
    __IO hw_sata_bistcr_t BISTCR;          /*!< [0xA4] BIST Control Register */
    __I hw_sata_bistfctr_t BISTFCTR;       /*!< [0xA8] BIST FIS Count Register */
    __I hw_sata_bistsr_t BISTSR;           /*!< [0xAC] BIST Status Register */
    uint8_t _reserved2[12];
    __IO hw_sata_oobr_t OOBR;              /*!< [0xBC] OOB Register */
    uint8_t _reserved3[16];
    __IO hw_sata_gpcr_t GPCR;              /*!< [0xD0] General Purpose Control Register */
    __IO hw_sata_gpsr_t GPSR;              /*!< [0xD4] General Purpose Status Register */
    uint8_t _reserved4[8];
    __IO hw_sata_timer1ms_t TIMER1MS;      /*!< [0xE0] Timer 1-ms Register */
    uint8_t _reserved5[16];
    __IO hw_sata_testr_t TESTR;            /*!< [0xF4] Test Register */
    __I hw_sata_versionr_t VERSIONR;       /*!< [0xF8] Version Register */
    uint8_t _reserved6[4];
    __IO hw_sata_p0clb_t P0CLB;            /*!< [0x100] Port0 Command List Base Address Register */
    uint8_t _reserved7[4];
    __IO hw_sata_p0fb_t P0FB;              /*!< [0x108] Port0 FIS Base Address Register */
    uint8_t _reserved8[4];
    __I hw_sata_p0is_t P0IS;               /*!< [0x110] Port0 Interrupt Status Register */
    __IO hw_sata_p0ie_t P0IE;              /*!< [0x114] Port0 Interrupt Enable Register */
    __IO hw_sata_p0cmd_t P0CMD;            /*!< [0x118] Port0 Command Register */
    uint8_t _reserved9[4];
    __I hw_sata_p0tfd_t P0TFD;             /*!< [0x120] Port0 Task File Data Register */
    __I hw_sata_p0sig_t P0SIG;             /*!< [0x124] Port0 Signature Register */
    __I hw_sata_p0ssts_t P0SSTS;           /*!< [0x128] Port0 Serial ATA Status Register */
    __IO hw_sata_p0sctl_t P0SCTL;          /*!< [0x12C] Port0 Serial ATA Control {SControl} Register */
    __I hw_sata_p0serr_t P0SERR;           /*!< [0x130] Port0 Serial ATA Error Register */
    __IO hw_sata_p0sact_t P0SACT;          /*!< [0x134] Port0 Serial ATA Active Register */
    __IO hw_sata_p0ci_t P0CI;              /*!< [0x138] Port0 Command Issue Register */
    __IO hw_sata_p0sntf_t P0SNTF;          /*!< [0x13C] Port0 Serial ATA Notification Register */
    uint8_t _reserved10[48];
    __IO hw_sata_p0dmacr_t P0DMACR;        /*!< [0x170] Port0 DMA Control Register */
    uint8_t _reserved11[4];
    __IO hw_sata_p0phycr_t P0PHYCR;        /*!< [0x178] Port0 PHY Control Register */
    __I hw_sata_p0physr_t P0PHYSR;         /*!< [0x17C] Port0 PHY Status Register */
} hw_sata_t;
#pragma pack()

/*! @brief Macro to access all SATA registers. */
/*! @param x SATA module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SATA_REGS(SATA_BASE)</code>. */
#define HW_SATA_REGS(x) (*(hw_sata_t *)(x))

/*
 * iMX6DP SDMAARM
 *
 * SDMA
 *
 * Registers defined in this header file:
 * - HW_SDMAARM_MC0PTR - ARM platform Channel 0 Pointer
 * - HW_SDMAARM_INTR - Channel Interrupts
 * - HW_SDMAARM_STOP_STAT - Channel Stop/Channel Status
 * - HW_SDMAARM_HSTART - Channel Start
 * - HW_SDMAARM_EVTOVR - Channel Event Override
 * - HW_SDMAARM_DSPOVR - Channel BP Override
 * - HW_SDMAARM_HOSTOVR - Channel ARM platform Override
 * - HW_SDMAARM_EVTPEND - Channel Event Pending
 * - HW_SDMAARM_RESET - Reset Register
 * - HW_SDMAARM_EVTERR - DMA Request Error Register
 * - HW_SDMAARM_INTRMASK - Channel ARM platform Interrupt Mask
 * - HW_SDMAARM_PSW - Schedule Status
 * - HW_SDMAARM_EVTERRDBG - DMA Request Error Register
 * - HW_SDMAARM_CONFIG - Configuration Register
 * - HW_SDMAARM_SDMA_LOCK - SDMA LOCK
 * - HW_SDMAARM_ONCE_ENB - OnCE Enable
 * - HW_SDMAARM_ONCE_DATA - OnCE Data Register
 * - HW_SDMAARM_ONCE_INSTR - OnCE Instruction Register
 * - HW_SDMAARM_ONCE_STAT - OnCE Status Register
 * - HW_SDMAARM_ONCE_CMD - OnCE Command Register
 * - HW_SDMAARM_ILLINSTADDR - Illegal Instruction Trap Address
 * - HW_SDMAARM_CHN0ADDR - Channel 0 Boot Address
 * - HW_SDMAARM_EVT_MIRROR - DMA Requests
 * - HW_SDMAARM_EVT_MIRROR2 - DMA Requests 2
 * - HW_SDMAARM_XTRIG_CONF1 - Cross-Trigger Events Configuration Register 1
 * - HW_SDMAARM_XTRIG_CONF2 - Cross-Trigger Events Configuration Register 2
 * - HW_SDMAARM_SDMA_CHNPRIn - Channel Priority Registers
 * - HW_SDMAARM_CHNENBLn - Channel Enable RAM
 *
 * - hw_sdmaarm_t - Struct containing all module registers.
 */

#define HW_SDMAARM_INSTANCE_COUNT (1U) /*!< Number of instances of the SDMAARM module. */
#define HW_SDMAARM (0U) /*!< Instance number for SDMAARM. */
#define SDMAARM_BASE          (0x20EC000U) /*!< Base address for SDMAARM. */
/*! Array initializer of SDMAARM base addresses. */
#define SDMAARM_BASE_ADDRS    { SDMAARM_BASE }

/*******************************************************************************
 * HW_SDMAARM_MC0PTR - ARM platform Channel 0 Pointer
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_MC0PTR - ARM platform Channel 0 Pointer (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_mc0ptr
{
    uint32_t U;
    struct _hw_sdmaarm_mc0ptr_bitfields
    {
        uint32_t MC0PTR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmaarm_mc0ptr_t;

/*!
 * @name Constants and macros for entire SDMAARM_MC0PTR register
 */
/*@{*/
#define HW_SDMAARM_MC0PTR_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_SDMAARM_MC0PTR(x)     (*(__IO hw_sdmaarm_mc0ptr_t *) HW_SDMAARM_MC0PTR_ADDR(x))
#define HW_SDMAARM_MC0PTR_RD(x)  (HW_SDMAARM_MC0PTR(x).U)
#define HW_SDMAARM_MC0PTR_WR(x, v) (HW_SDMAARM_MC0PTR(x).U = (v))
#define HW_SDMAARM_MC0PTR_SET(x, v) (HW_SDMAARM_MC0PTR_WR(x, HW_SDMAARM_MC0PTR_RD(x) |  (v)))
#define HW_SDMAARM_MC0PTR_CLR(x, v) (HW_SDMAARM_MC0PTR_WR(x, HW_SDMAARM_MC0PTR_RD(x) & ~(v)))
#define HW_SDMAARM_MC0PTR_TOG(x, v) (HW_SDMAARM_MC0PTR_WR(x, HW_SDMAARM_MC0PTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_MC0PTR bitfields
 */

/*!
 * @name Register SDMAARM_MC0PTR, field MC0PTR[31:0] (RW)
 *
 * Channel 0 Pointer contains the 32-bit address, in ARM platform memory, of
 * channel 0 control block (the boot channel). Appendix A fully describes the SDMA
 * Application Programming Interface (API). The ARM platform has a read/write
 * access and the SDMA has a read-only access.
 */
/*@{*/
#define BP_SDMAARM_MC0PTR_MC0PTR (0U)      /*!< Bit position for SDMAARM_MC0PTR_MC0PTR. */
#define BM_SDMAARM_MC0PTR_MC0PTR (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_MC0PTR_MC0PTR. */
#define BS_SDMAARM_MC0PTR_MC0PTR (32U)     /*!< Bit field size in bits for SDMAARM_MC0PTR_MC0PTR. */

/*! @brief Read current value of the SDMAARM_MC0PTR_MC0PTR field. */
#define BR_SDMAARM_MC0PTR_MC0PTR(x) (HW_SDMAARM_MC0PTR(x).U)

/*! @brief Format value for bitfield SDMAARM_MC0PTR_MC0PTR. */
#define BF_SDMAARM_MC0PTR_MC0PTR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_MC0PTR_MC0PTR) & BM_SDMAARM_MC0PTR_MC0PTR)

/*! @brief Set the MC0PTR field to a new value. */
#define BW_SDMAARM_MC0PTR_MC0PTR(x, v) (HW_SDMAARM_MC0PTR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_INTR - Channel Interrupts
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_INTR - Channel Interrupts (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_intr
{
    uint32_t U;
    struct _hw_sdmaarm_intr_bitfields
    {
        uint32_t HI : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_intr_t;

/*!
 * @name Constants and macros for entire SDMAARM_INTR register
 */
/*@{*/
#define HW_SDMAARM_INTR_ADDR(x)  ((uintptr_t)(x) + 0x4U)

#define HW_SDMAARM_INTR(x)       (*(__IO hw_sdmaarm_intr_t *) HW_SDMAARM_INTR_ADDR(x))
#define HW_SDMAARM_INTR_RD(x)    (HW_SDMAARM_INTR(x).U)
#define HW_SDMAARM_INTR_WR(x, v) (HW_SDMAARM_INTR(x).U = (v))
#define HW_SDMAARM_INTR_SET(x, v) (HW_SDMAARM_INTR_WR(x, HW_SDMAARM_INTR_RD(x) |  (v)))
#define HW_SDMAARM_INTR_CLR(x, v) (HW_SDMAARM_INTR_WR(x, HW_SDMAARM_INTR_RD(x) & ~(v)))
#define HW_SDMAARM_INTR_TOG(x, v) (HW_SDMAARM_INTR_WR(x, HW_SDMAARM_INTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_INTR bitfields
 */

/*!
 * @name Register SDMAARM_INTR, field HI[31:0] (W1C)
 *
 * The ARM platform Interrupts register contains the 32 HI[i] bits. If any bit
 * is set, it will cause an interrupt to the ARM platform. This register is a
 * "write-ones" register to the ARM platform. When the ARM platform sets a bit in
 * this register the corresponding HI[i] bit is cleared. The interrupt service
 * routine should clear individual channel bits when their interrupts are serviced,
 * failure to do so will cause continuous interrupts. The SDMA is responsible for
 * setting the HI[i] bit corresponding to the current channel when the
 * corresponding done instruction is executed.
 */
/*@{*/
#define BP_SDMAARM_INTR_HI   (0U)          /*!< Bit position for SDMAARM_INTR_HI. */
#define BM_SDMAARM_INTR_HI   (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_INTR_HI. */
#define BS_SDMAARM_INTR_HI   (32U)         /*!< Bit field size in bits for SDMAARM_INTR_HI. */

/*! @brief Read current value of the SDMAARM_INTR_HI field. */
#define BR_SDMAARM_INTR_HI(x) (HW_SDMAARM_INTR(x).U)

/*! @brief Format value for bitfield SDMAARM_INTR_HI. */
#define BF_SDMAARM_INTR_HI(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_INTR_HI) & BM_SDMAARM_INTR_HI)

/*! @brief Set the HI field to a new value. */
#define BW_SDMAARM_INTR_HI(x, v) (HW_SDMAARM_INTR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_STOP_STAT - Channel Stop/Channel Status
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_STOP_STAT - Channel Stop/Channel Status (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_stop_stat
{
    uint32_t U;
    struct _hw_sdmaarm_stop_stat_bitfields
    {
        uint32_t HE : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_stop_stat_t;

/*!
 * @name Constants and macros for entire SDMAARM_STOP_STAT register
 */
/*@{*/
#define HW_SDMAARM_STOP_STAT_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_SDMAARM_STOP_STAT(x)  (*(__IO hw_sdmaarm_stop_stat_t *) HW_SDMAARM_STOP_STAT_ADDR(x))
#define HW_SDMAARM_STOP_STAT_RD(x) (HW_SDMAARM_STOP_STAT(x).U)
#define HW_SDMAARM_STOP_STAT_WR(x, v) (HW_SDMAARM_STOP_STAT(x).U = (v))
#define HW_SDMAARM_STOP_STAT_SET(x, v) (HW_SDMAARM_STOP_STAT_WR(x, HW_SDMAARM_STOP_STAT_RD(x) |  (v)))
#define HW_SDMAARM_STOP_STAT_CLR(x, v) (HW_SDMAARM_STOP_STAT_WR(x, HW_SDMAARM_STOP_STAT_RD(x) & ~(v)))
#define HW_SDMAARM_STOP_STAT_TOG(x, v) (HW_SDMAARM_STOP_STAT_WR(x, HW_SDMAARM_STOP_STAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_STOP_STAT bitfields
 */

/*!
 * @name Register SDMAARM_STOP_STAT, field HE[31:0] (W1C)
 *
 * This 32-bit register gives access to the ARM platform Enable bits. There is
 * one bit for every channel. This register is a "write-ones" register to the ARM
 * platform. When the ARM platform writes 1 in bit i of this register, it clears
 * the HE[i] and HSTART[i] bits. Reading this register yields the current state
 * of the HE[i] bits.
 */
/*@{*/
#define BP_SDMAARM_STOP_STAT_HE (0U)       /*!< Bit position for SDMAARM_STOP_STAT_HE. */
#define BM_SDMAARM_STOP_STAT_HE (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_STOP_STAT_HE. */
#define BS_SDMAARM_STOP_STAT_HE (32U)      /*!< Bit field size in bits for SDMAARM_STOP_STAT_HE. */

/*! @brief Read current value of the SDMAARM_STOP_STAT_HE field. */
#define BR_SDMAARM_STOP_STAT_HE(x) (HW_SDMAARM_STOP_STAT(x).U)

/*! @brief Format value for bitfield SDMAARM_STOP_STAT_HE. */
#define BF_SDMAARM_STOP_STAT_HE(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_STOP_STAT_HE) & BM_SDMAARM_STOP_STAT_HE)

/*! @brief Set the HE field to a new value. */
#define BW_SDMAARM_STOP_STAT_HE(x, v) (HW_SDMAARM_STOP_STAT_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_HSTART - Channel Start
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_HSTART - Channel Start (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_hstart
{
    uint32_t U;
    struct _hw_sdmaarm_hstart_bitfields
    {
        uint32_t HSTART_HE : 32;       /*!< [31:0]  */
    } B;
} hw_sdmaarm_hstart_t;

/*!
 * @name Constants and macros for entire SDMAARM_HSTART register
 */
/*@{*/
#define HW_SDMAARM_HSTART_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_SDMAARM_HSTART(x)     (*(__IO hw_sdmaarm_hstart_t *) HW_SDMAARM_HSTART_ADDR(x))
#define HW_SDMAARM_HSTART_RD(x)  (HW_SDMAARM_HSTART(x).U)
#define HW_SDMAARM_HSTART_WR(x, v) (HW_SDMAARM_HSTART(x).U = (v))
#define HW_SDMAARM_HSTART_SET(x, v) (HW_SDMAARM_HSTART_WR(x, HW_SDMAARM_HSTART_RD(x) |  (v)))
#define HW_SDMAARM_HSTART_CLR(x, v) (HW_SDMAARM_HSTART_WR(x, HW_SDMAARM_HSTART_RD(x) & ~(v)))
#define HW_SDMAARM_HSTART_TOG(x, v) (HW_SDMAARM_HSTART_WR(x, HW_SDMAARM_HSTART_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_HSTART bitfields
 */

/*!
 * @name Register SDMAARM_HSTART, field HSTART_HE[31:0] (W1C)
 *
 * The HSTART_HE registers are 32 bits wide with one bit for every channel. When
 * a bit is written to 1, it enables the corresponding channel. Two physical
 * registers are accessed with that address (HSTART and HE), which enables the ARM
 * platform to trigger a channel a second time before the first trigger is
 * processed. This register is a "write-ones" register to the ARM platform. Neither
 * HSTART[i] bit can be set while the corresponding HE[i] bit is cleared. When the
 * ARM platform tries to set the HSTART[i] bit by writing a one (if the
 * corresponding HE[i] bit is clear), the bit in the HSTART[i] register will remain cleared
 * and the HE[i] bit will be set. If the corresponding HE[i] bit was already set,
 * the HSTART[i] bit will be set. The next time the SDMA channel i attempts to
 * clear the HE[i] bit by means of a done instruction, the bit in the HSTART[i]
 * register will be cleared and the HE[i] bit will take the old value of the
 * HSTART[i] bit. Reading this register yields the current state of the HSTART[i] bits.
 * This mechanism enables the ARM platform to pipeline two HSTART commands per
 * channel.
 */
/*@{*/
#define BP_SDMAARM_HSTART_HSTART_HE (0U)   /*!< Bit position for SDMAARM_HSTART_HSTART_HE. */
#define BM_SDMAARM_HSTART_HSTART_HE (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_HSTART_HSTART_HE. */
#define BS_SDMAARM_HSTART_HSTART_HE (32U)  /*!< Bit field size in bits for SDMAARM_HSTART_HSTART_HE. */

/*! @brief Read current value of the SDMAARM_HSTART_HSTART_HE field. */
#define BR_SDMAARM_HSTART_HSTART_HE(x) (HW_SDMAARM_HSTART(x).U)

/*! @brief Format value for bitfield SDMAARM_HSTART_HSTART_HE. */
#define BF_SDMAARM_HSTART_HSTART_HE(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_HSTART_HSTART_HE) & BM_SDMAARM_HSTART_HSTART_HE)

/*! @brief Set the HSTART_HE field to a new value. */
#define BW_SDMAARM_HSTART_HSTART_HE(x, v) (HW_SDMAARM_HSTART_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVTOVR - Channel Event Override
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVTOVR - Channel Event Override (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evtovr
{
    uint32_t U;
    struct _hw_sdmaarm_evtovr_bitfields
    {
        uint32_t EO : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_evtovr_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVTOVR register
 */
/*@{*/
#define HW_SDMAARM_EVTOVR_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_SDMAARM_EVTOVR(x)     (*(__IO hw_sdmaarm_evtovr_t *) HW_SDMAARM_EVTOVR_ADDR(x))
#define HW_SDMAARM_EVTOVR_RD(x)  (HW_SDMAARM_EVTOVR(x).U)
#define HW_SDMAARM_EVTOVR_WR(x, v) (HW_SDMAARM_EVTOVR(x).U = (v))
#define HW_SDMAARM_EVTOVR_SET(x, v) (HW_SDMAARM_EVTOVR_WR(x, HW_SDMAARM_EVTOVR_RD(x) |  (v)))
#define HW_SDMAARM_EVTOVR_CLR(x, v) (HW_SDMAARM_EVTOVR_WR(x, HW_SDMAARM_EVTOVR_RD(x) & ~(v)))
#define HW_SDMAARM_EVTOVR_TOG(x, v) (HW_SDMAARM_EVTOVR_WR(x, HW_SDMAARM_EVTOVR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVTOVR bitfields
 */

/*!
 * @name Register SDMAARM_EVTOVR, field EO[31:0] (RW)
 *
 * The Channel Event Override register contains the 32 EO[i] bits. A bit set in
 * this register causes the SDMA to ignore DMA requests when scheduling the
 * corresponding channel.
 */
/*@{*/
#define BP_SDMAARM_EVTOVR_EO (0U)          /*!< Bit position for SDMAARM_EVTOVR_EO. */
#define BM_SDMAARM_EVTOVR_EO (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_EVTOVR_EO. */
#define BS_SDMAARM_EVTOVR_EO (32U)         /*!< Bit field size in bits for SDMAARM_EVTOVR_EO. */

/*! @brief Read current value of the SDMAARM_EVTOVR_EO field. */
#define BR_SDMAARM_EVTOVR_EO(x) (HW_SDMAARM_EVTOVR(x).U)

/*! @brief Format value for bitfield SDMAARM_EVTOVR_EO. */
#define BF_SDMAARM_EVTOVR_EO(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_EVTOVR_EO) & BM_SDMAARM_EVTOVR_EO)

/*! @brief Set the EO field to a new value. */
#define BW_SDMAARM_EVTOVR_EO(x, v) (HW_SDMAARM_EVTOVR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_DSPOVR - Channel BP Override
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_DSPOVR - Channel BP Override (RW)
 *
 * Reset value: 0xFFFFFFFFU
 */
typedef union _hw_sdmaarm_dspovr
{
    uint32_t U;
    struct _hw_sdmaarm_dspovr_bitfields
    {
        uint32_t DO : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_dspovr_t;

/*!
 * @name Constants and macros for entire SDMAARM_DSPOVR register
 */
/*@{*/
#define HW_SDMAARM_DSPOVR_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_SDMAARM_DSPOVR(x)     (*(__IO hw_sdmaarm_dspovr_t *) HW_SDMAARM_DSPOVR_ADDR(x))
#define HW_SDMAARM_DSPOVR_RD(x)  (HW_SDMAARM_DSPOVR(x).U)
#define HW_SDMAARM_DSPOVR_WR(x, v) (HW_SDMAARM_DSPOVR(x).U = (v))
#define HW_SDMAARM_DSPOVR_SET(x, v) (HW_SDMAARM_DSPOVR_WR(x, HW_SDMAARM_DSPOVR_RD(x) |  (v)))
#define HW_SDMAARM_DSPOVR_CLR(x, v) (HW_SDMAARM_DSPOVR_WR(x, HW_SDMAARM_DSPOVR_RD(x) & ~(v)))
#define HW_SDMAARM_DSPOVR_TOG(x, v) (HW_SDMAARM_DSPOVR_WR(x, HW_SDMAARM_DSPOVR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_DSPOVR bitfields
 */

/*!
 * @name Register SDMAARM_DSPOVR, field DO[31:0] (RW)
 *
 * This register is reserved. All DO bits should be set to the reset value of 1.
 * A setting of 0 will prevent SDMA channels from starting according to the
 * condition described in Runnable Channels EvaluationThe EP register is used in
 * conjunction with several other 32-bit registers to determine the channels that are
 * runnable. .
 *
 * Values:
 * - 0 - - Reserved
 * - 1 - - Reset value.
 */
/*@{*/
#define BP_SDMAARM_DSPOVR_DO (0U)          /*!< Bit position for SDMAARM_DSPOVR_DO. */
#define BM_SDMAARM_DSPOVR_DO (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_DSPOVR_DO. */
#define BS_SDMAARM_DSPOVR_DO (32U)         /*!< Bit field size in bits for SDMAARM_DSPOVR_DO. */

/*! @brief Read current value of the SDMAARM_DSPOVR_DO field. */
#define BR_SDMAARM_DSPOVR_DO(x) (HW_SDMAARM_DSPOVR(x).U)

/*! @brief Format value for bitfield SDMAARM_DSPOVR_DO. */
#define BF_SDMAARM_DSPOVR_DO(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_DSPOVR_DO) & BM_SDMAARM_DSPOVR_DO)

/*! @brief Set the DO field to a new value. */
#define BW_SDMAARM_DSPOVR_DO(x, v) (HW_SDMAARM_DSPOVR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_HOSTOVR - Channel ARM platform Override
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_HOSTOVR - Channel ARM platform Override (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_hostovr
{
    uint32_t U;
    struct _hw_sdmaarm_hostovr_bitfields
    {
        uint32_t HO : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_hostovr_t;

/*!
 * @name Constants and macros for entire SDMAARM_HOSTOVR register
 */
/*@{*/
#define HW_SDMAARM_HOSTOVR_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_SDMAARM_HOSTOVR(x)    (*(__IO hw_sdmaarm_hostovr_t *) HW_SDMAARM_HOSTOVR_ADDR(x))
#define HW_SDMAARM_HOSTOVR_RD(x) (HW_SDMAARM_HOSTOVR(x).U)
#define HW_SDMAARM_HOSTOVR_WR(x, v) (HW_SDMAARM_HOSTOVR(x).U = (v))
#define HW_SDMAARM_HOSTOVR_SET(x, v) (HW_SDMAARM_HOSTOVR_WR(x, HW_SDMAARM_HOSTOVR_RD(x) |  (v)))
#define HW_SDMAARM_HOSTOVR_CLR(x, v) (HW_SDMAARM_HOSTOVR_WR(x, HW_SDMAARM_HOSTOVR_RD(x) & ~(v)))
#define HW_SDMAARM_HOSTOVR_TOG(x, v) (HW_SDMAARM_HOSTOVR_WR(x, HW_SDMAARM_HOSTOVR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_HOSTOVR bitfields
 */

/*!
 * @name Register SDMAARM_HOSTOVR, field HO[31:0] (RW)
 *
 * The Channel ARM platform Override register contains the 32 HO[i] bits. A bit
 * set in this register causes the SDMA to ignore the ARM platform enable bit
 * (HE) when scheduling the corresponding channel.
 */
/*@{*/
#define BP_SDMAARM_HOSTOVR_HO (0U)         /*!< Bit position for SDMAARM_HOSTOVR_HO. */
#define BM_SDMAARM_HOSTOVR_HO (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_HOSTOVR_HO. */
#define BS_SDMAARM_HOSTOVR_HO (32U)        /*!< Bit field size in bits for SDMAARM_HOSTOVR_HO. */

/*! @brief Read current value of the SDMAARM_HOSTOVR_HO field. */
#define BR_SDMAARM_HOSTOVR_HO(x) (HW_SDMAARM_HOSTOVR(x).U)

/*! @brief Format value for bitfield SDMAARM_HOSTOVR_HO. */
#define BF_SDMAARM_HOSTOVR_HO(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_HOSTOVR_HO) & BM_SDMAARM_HOSTOVR_HO)

/*! @brief Set the HO field to a new value. */
#define BW_SDMAARM_HOSTOVR_HO(x, v) (HW_SDMAARM_HOSTOVR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVTPEND - Channel Event Pending
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVTPEND - Channel Event Pending (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evtpend
{
    uint32_t U;
    struct _hw_sdmaarm_evtpend_bitfields
    {
        uint32_t EP : 32;              /*!< [31:0]  */
    } B;
} hw_sdmaarm_evtpend_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVTPEND register
 */
/*@{*/
#define HW_SDMAARM_EVTPEND_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_SDMAARM_EVTPEND(x)    (*(__IO hw_sdmaarm_evtpend_t *) HW_SDMAARM_EVTPEND_ADDR(x))
#define HW_SDMAARM_EVTPEND_RD(x) (HW_SDMAARM_EVTPEND(x).U)
#define HW_SDMAARM_EVTPEND_WR(x, v) (HW_SDMAARM_EVTPEND(x).U = (v))
#define HW_SDMAARM_EVTPEND_SET(x, v) (HW_SDMAARM_EVTPEND_WR(x, HW_SDMAARM_EVTPEND_RD(x) |  (v)))
#define HW_SDMAARM_EVTPEND_CLR(x, v) (HW_SDMAARM_EVTPEND_WR(x, HW_SDMAARM_EVTPEND_RD(x) & ~(v)))
#define HW_SDMAARM_EVTPEND_TOG(x, v) (HW_SDMAARM_EVTPEND_WR(x, HW_SDMAARM_EVTPEND_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVTPEND bitfields
 */

/*!
 * @name Register SDMAARM_EVTPEND, field EP[31:0] (W1C)
 *
 * The Channel Event Pending register contains the 32 EP[i] bits. Reading this
 * register enables the ARM platform to determine what channels are pending after
 * the reception of a DMA request. Setting a bit in this register causes the SDMA
 * to reevaluate scheduling as if a DMA request mapped on this channel had
 * occurred. This is useful for starting up channels, so that initialization is done
 * before awaiting the first request. The scheduler can also set bits in the
 * EVTPEND register according to the received DMA requests. The EP[i] bit may be
 * cleared by the done instruction when running the channel i script. This a
 * "write-ones" mechanism: Writing a '0' does not clear the corresponding bit.
 */
/*@{*/
#define BP_SDMAARM_EVTPEND_EP (0U)         /*!< Bit position for SDMAARM_EVTPEND_EP. */
#define BM_SDMAARM_EVTPEND_EP (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_EVTPEND_EP. */
#define BS_SDMAARM_EVTPEND_EP (32U)        /*!< Bit field size in bits for SDMAARM_EVTPEND_EP. */

/*! @brief Read current value of the SDMAARM_EVTPEND_EP field. */
#define BR_SDMAARM_EVTPEND_EP(x) (HW_SDMAARM_EVTPEND(x).U)

/*! @brief Format value for bitfield SDMAARM_EVTPEND_EP. */
#define BF_SDMAARM_EVTPEND_EP(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_EVTPEND_EP) & BM_SDMAARM_EVTPEND_EP)

/*! @brief Set the EP field to a new value. */
#define BW_SDMAARM_EVTPEND_EP(x, v) (HW_SDMAARM_EVTPEND_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_RESET - Reset Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_RESET - Reset Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_reset
{
    uint32_t U;
    struct _hw_sdmaarm_reset_bitfields
    {
        uint32_t RESET : 1;            /*!< [0]  */
        uint32_t RESCHED : 1;          /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_sdmaarm_reset_t;

/*!
 * @name Constants and macros for entire SDMAARM_RESET register
 */
/*@{*/
#define HW_SDMAARM_RESET_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_SDMAARM_RESET(x)      (*(__I hw_sdmaarm_reset_t *) HW_SDMAARM_RESET_ADDR(x))
#define HW_SDMAARM_RESET_RD(x)   (HW_SDMAARM_RESET(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_RESET bitfields
 */

/*!
 * @name Register SDMAARM_RESET, field RESET[0] (RO)
 *
 * When set, this bit causes the SDMA to be held in a software reset. The
 * internal reset signal is held low 16 cycles; the RESET bit is automatically cleared
 * when the internal reset signal rises.
 */
/*@{*/
#define BP_SDMAARM_RESET_RESET (0U)        /*!< Bit position for SDMAARM_RESET_RESET. */
#define BM_SDMAARM_RESET_RESET (0x00000001U) /*!< Bit mask for SDMAARM_RESET_RESET. */
#define BS_SDMAARM_RESET_RESET (1U)        /*!< Bit field size in bits for SDMAARM_RESET_RESET. */

/*! @brief Read current value of the SDMAARM_RESET_RESET field. */
#define BR_SDMAARM_RESET_RESET(x) (HW_SDMAARM_RESET(x).B.RESET)
/*@}*/

/*!
 * @name Register SDMAARM_RESET, field RESCHED[1] (RO)
 *
 * When set, this bit forces the SDMA to reschedule as if a script had executed
 * a done instruction. This enables the ARM platform to recover from a runaway
 * script on a channel by clearing its HE[i] bit via the STOP register, and then
 * forcing a reschedule via the RESCHED bit. The RESCHED bit is cleared when the
 * context switch starts.
 */
/*@{*/
#define BP_SDMAARM_RESET_RESCHED (1U)      /*!< Bit position for SDMAARM_RESET_RESCHED. */
#define BM_SDMAARM_RESET_RESCHED (0x00000002U) /*!< Bit mask for SDMAARM_RESET_RESCHED. */
#define BS_SDMAARM_RESET_RESCHED (1U)      /*!< Bit field size in bits for SDMAARM_RESET_RESCHED. */

/*! @brief Read current value of the SDMAARM_RESET_RESCHED field. */
#define BR_SDMAARM_RESET_RESCHED(x) (HW_SDMAARM_RESET(x).B.RESCHED)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVTERR - DMA Request Error Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVTERR - DMA Request Error Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evterr
{
    uint32_t U;
    struct _hw_sdmaarm_evterr_bitfields
    {
        uint32_t CHNERR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmaarm_evterr_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVTERR register
 */
/*@{*/
#define HW_SDMAARM_EVTERR_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_SDMAARM_EVTERR(x)     (*(__I hw_sdmaarm_evterr_t *) HW_SDMAARM_EVTERR_ADDR(x))
#define HW_SDMAARM_EVTERR_RD(x)  (HW_SDMAARM_EVTERR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVTERR bitfields
 */

/*!
 * @name Register SDMAARM_EVTERR, field CHNERR[31:0] (RO)
 *
 * This register is used by the SDMA to warn the ARM platform when an incoming
 * DMA request was detected and it triggers a channel that is already pending or
 * being serviced. This probably means there is an overflow of data for that
 * channel. An interrupt is sent to the ARM platform if the corresponding channel bit
 * is set in the INTRMASK register. This is a "write-ones" register for the
 * scheduler. It is only able to set the flags. The flags are cleared when the
 * register is read by the ARM platform or during SDMA reset. The CHNERR[i] bit is set
 * when a DMA request that triggers channel i is received through the
 * corresponding input pins and the EP[i] bit is already set; the EVTERR[i] bit is unaffected
 * if the ARM platform tries to set the EP[i] bit, whereas, that EP[i] bit is
 * already set.
 */
/*@{*/
#define BP_SDMAARM_EVTERR_CHNERR (0U)      /*!< Bit position for SDMAARM_EVTERR_CHNERR. */
#define BM_SDMAARM_EVTERR_CHNERR (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_EVTERR_CHNERR. */
#define BS_SDMAARM_EVTERR_CHNERR (32U)     /*!< Bit field size in bits for SDMAARM_EVTERR_CHNERR. */

/*! @brief Read current value of the SDMAARM_EVTERR_CHNERR field. */
#define BR_SDMAARM_EVTERR_CHNERR(x) (HW_SDMAARM_EVTERR(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_INTRMASK - Channel ARM platform Interrupt Mask
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_INTRMASK - Channel ARM platform Interrupt Mask (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_intrmask
{
    uint32_t U;
    struct _hw_sdmaarm_intrmask_bitfields
    {
        uint32_t HIMASK : 32;          /*!< [31:0]  */
    } B;
} hw_sdmaarm_intrmask_t;

/*!
 * @name Constants and macros for entire SDMAARM_INTRMASK register
 */
/*@{*/
#define HW_SDMAARM_INTRMASK_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_SDMAARM_INTRMASK(x)   (*(__IO hw_sdmaarm_intrmask_t *) HW_SDMAARM_INTRMASK_ADDR(x))
#define HW_SDMAARM_INTRMASK_RD(x) (HW_SDMAARM_INTRMASK(x).U)
#define HW_SDMAARM_INTRMASK_WR(x, v) (HW_SDMAARM_INTRMASK(x).U = (v))
#define HW_SDMAARM_INTRMASK_SET(x, v) (HW_SDMAARM_INTRMASK_WR(x, HW_SDMAARM_INTRMASK_RD(x) |  (v)))
#define HW_SDMAARM_INTRMASK_CLR(x, v) (HW_SDMAARM_INTRMASK_WR(x, HW_SDMAARM_INTRMASK_RD(x) & ~(v)))
#define HW_SDMAARM_INTRMASK_TOG(x, v) (HW_SDMAARM_INTRMASK_WR(x, HW_SDMAARM_INTRMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_INTRMASK bitfields
 */

/*!
 * @name Register SDMAARM_INTRMASK, field HIMASK[31:0] (RW)
 *
 * The Interrupt Mask Register contains 32 interrupt generation mask bits. If
 * bit HIMASK[i] is set, the HI[i] bit is set and an interrupt is sent to the ARM
 * platform when a DMA request error is detected on channel i (for example,
 * EVTERR[i] is set).
 */
/*@{*/
#define BP_SDMAARM_INTRMASK_HIMASK (0U)    /*!< Bit position for SDMAARM_INTRMASK_HIMASK. */
#define BM_SDMAARM_INTRMASK_HIMASK (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_INTRMASK_HIMASK. */
#define BS_SDMAARM_INTRMASK_HIMASK (32U)   /*!< Bit field size in bits for SDMAARM_INTRMASK_HIMASK. */

/*! @brief Read current value of the SDMAARM_INTRMASK_HIMASK field. */
#define BR_SDMAARM_INTRMASK_HIMASK(x) (HW_SDMAARM_INTRMASK(x).U)

/*! @brief Format value for bitfield SDMAARM_INTRMASK_HIMASK. */
#define BF_SDMAARM_INTRMASK_HIMASK(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_INTRMASK_HIMASK) & BM_SDMAARM_INTRMASK_HIMASK)

/*! @brief Set the HIMASK field to a new value. */
#define BW_SDMAARM_INTRMASK_HIMASK(x, v) (HW_SDMAARM_INTRMASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_PSW - Schedule Status
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_PSW - Schedule Status (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_psw
{
    uint32_t U;
    struct _hw_sdmaarm_psw_bitfields
    {
        uint32_t CCR : 4;              /*!< [3:0]  */
        uint32_t CCP : 4;              /*!< [7:4]  */
        uint32_t NCR : 5;              /*!< [12:8]  */
        uint32_t NCP : 3;              /*!< [15:13]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmaarm_psw_t;

/*!
 * @name Constants and macros for entire SDMAARM_PSW register
 */
/*@{*/
#define HW_SDMAARM_PSW_ADDR(x)   ((uintptr_t)(x) + 0x30U)

#define HW_SDMAARM_PSW(x)        (*(__I hw_sdmaarm_psw_t *) HW_SDMAARM_PSW_ADDR(x))
#define HW_SDMAARM_PSW_RD(x)     (HW_SDMAARM_PSW(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_PSW bitfields
 */

/*!
 * @name Register SDMAARM_PSW, field CCR[3:0] (RO)
 *
 * The Current Channel Register indicates the number of the channel that is
 * being executed by the SDMA. SDMA. In the case that the SDMA has finished running
 * the channel and has entered sleep state, CCR will indicate the previous running
 * channel.
 */
/*@{*/
#define BP_SDMAARM_PSW_CCR   (0U)          /*!< Bit position for SDMAARM_PSW_CCR. */
#define BM_SDMAARM_PSW_CCR   (0x0000000FU) /*!< Bit mask for SDMAARM_PSW_CCR. */
#define BS_SDMAARM_PSW_CCR   (4U)          /*!< Bit field size in bits for SDMAARM_PSW_CCR. */

/*! @brief Read current value of the SDMAARM_PSW_CCR field. */
#define BR_SDMAARM_PSW_CCR(x) (HW_SDMAARM_PSW(x).B.CCR)
/*@}*/

/*!
 * @name Register SDMAARM_PSW, field CCP[7:4] (RO)
 *
 * The Current Channel Priority indicates the priority of the current active
 * channel. When the priority is 0, no channel is running: The SDMA is idle and the
 * CCR value has no meaning. In the case that the SDMA has finished running the
 * channel and has entered sleep state, CCP will indicate the priority of previous
 * running channel.
 *
 * Values:
 * - 0 - No running channel
 * - 1 - Active channel priority
 */
/*@{*/
#define BP_SDMAARM_PSW_CCP   (4U)          /*!< Bit position for SDMAARM_PSW_CCP. */
#define BM_SDMAARM_PSW_CCP   (0x000000F0U) /*!< Bit mask for SDMAARM_PSW_CCP. */
#define BS_SDMAARM_PSW_CCP   (4U)          /*!< Bit field size in bits for SDMAARM_PSW_CCP. */

/*! @brief Read current value of the SDMAARM_PSW_CCP field. */
#define BR_SDMAARM_PSW_CCP(x) (HW_SDMAARM_PSW(x).B.CCP)
/*@}*/

/*!
 * @name Register SDMAARM_PSW, field NCR[12:8] (RO)
 *
 * The Next Channel Register indicates the number of the next scheduled pending
 * channel with the highest priority.
 */
/*@{*/
#define BP_SDMAARM_PSW_NCR   (8U)          /*!< Bit position for SDMAARM_PSW_NCR. */
#define BM_SDMAARM_PSW_NCR   (0x00001F00U) /*!< Bit mask for SDMAARM_PSW_NCR. */
#define BS_SDMAARM_PSW_NCR   (5U)          /*!< Bit field size in bits for SDMAARM_PSW_NCR. */

/*! @brief Read current value of the SDMAARM_PSW_NCR field. */
#define BR_SDMAARM_PSW_NCR(x) (HW_SDMAARM_PSW(x).B.NCR)
/*@}*/

/*!
 * @name Register SDMAARM_PSW, field NCP[15:13] (RO)
 *
 * The Next Channel Priority gives the next pending channel priority. When the
 * priority is 0, it means there is no pending channel and the NCR value has no
 * meaning.
 *
 * Values:
 * - 0 - No running channel
 * - 1 - Active channel priority
 */
/*@{*/
#define BP_SDMAARM_PSW_NCP   (13U)         /*!< Bit position for SDMAARM_PSW_NCP. */
#define BM_SDMAARM_PSW_NCP   (0x0000E000U) /*!< Bit mask for SDMAARM_PSW_NCP. */
#define BS_SDMAARM_PSW_NCP   (3U)          /*!< Bit field size in bits for SDMAARM_PSW_NCP. */

/*! @brief Read current value of the SDMAARM_PSW_NCP field. */
#define BR_SDMAARM_PSW_NCP(x) (HW_SDMAARM_PSW(x).B.NCP)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVTERRDBG - DMA Request Error Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVTERRDBG - DMA Request Error Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evterrdbg
{
    uint32_t U;
    struct _hw_sdmaarm_evterrdbg_bitfields
    {
        uint32_t CHNERR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmaarm_evterrdbg_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVTERRDBG register
 */
/*@{*/
#define HW_SDMAARM_EVTERRDBG_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_SDMAARM_EVTERRDBG(x)  (*(__I hw_sdmaarm_evterrdbg_t *) HW_SDMAARM_EVTERRDBG_ADDR(x))
#define HW_SDMAARM_EVTERRDBG_RD(x) (HW_SDMAARM_EVTERRDBG(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVTERRDBG bitfields
 */

/*!
 * @name Register SDMAARM_EVTERRDBG, field CHNERR[31:0] (RO)
 *
 * This register is the same as EVTERR, except reading it does not clear its
 * contents. This address is meant to be used in debug mode. The ARM platform OnCE
 * may check this register value without modifying it.
 */
/*@{*/
#define BP_SDMAARM_EVTERRDBG_CHNERR (0U)   /*!< Bit position for SDMAARM_EVTERRDBG_CHNERR. */
#define BM_SDMAARM_EVTERRDBG_CHNERR (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_EVTERRDBG_CHNERR. */
#define BS_SDMAARM_EVTERRDBG_CHNERR (32U)  /*!< Bit field size in bits for SDMAARM_EVTERRDBG_CHNERR. */

/*! @brief Read current value of the SDMAARM_EVTERRDBG_CHNERR field. */
#define BR_SDMAARM_EVTERRDBG_CHNERR(x) (HW_SDMAARM_EVTERRDBG(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_CONFIG - Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_CONFIG - Configuration Register (RW)
 *
 * Reset value: 0x00000003U
 */
typedef union _hw_sdmaarm_config
{
    uint32_t U;
    struct _hw_sdmaarm_config_bitfields
    {
        uint32_t CSM : 2;              /*!< [1:0]  */
        uint32_t RESERVED0 : 2;        /*!< [3:2]  */
        uint32_t ACR : 1;              /*!< [4]  */
        uint32_t RESERVED1 : 6;        /*!< [10:5]  */
        uint32_t RTDOBS : 1;           /*!< [11]  */
        uint32_t DSPDMA : 1;           /*!< [12]  */
        uint32_t RESERVED2 : 19;       /*!< [31:13]  */
    } B;
} hw_sdmaarm_config_t;

/*!
 * @name Constants and macros for entire SDMAARM_CONFIG register
 */
/*@{*/
#define HW_SDMAARM_CONFIG_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_SDMAARM_CONFIG(x)     (*(__IO hw_sdmaarm_config_t *) HW_SDMAARM_CONFIG_ADDR(x))
#define HW_SDMAARM_CONFIG_RD(x)  (HW_SDMAARM_CONFIG(x).U)
#define HW_SDMAARM_CONFIG_WR(x, v) (HW_SDMAARM_CONFIG(x).U = (v))
#define HW_SDMAARM_CONFIG_SET(x, v) (HW_SDMAARM_CONFIG_WR(x, HW_SDMAARM_CONFIG_RD(x) |  (v)))
#define HW_SDMAARM_CONFIG_CLR(x, v) (HW_SDMAARM_CONFIG_WR(x, HW_SDMAARM_CONFIG_RD(x) & ~(v)))
#define HW_SDMAARM_CONFIG_TOG(x, v) (HW_SDMAARM_CONFIG_WR(x, HW_SDMAARM_CONFIG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_CONFIG bitfields
 */

/*!
 * @name Register SDMAARM_CONFIG, field CSM[1:0] (RW)
 *
 * Selects the Context Switch Mode. The ARM platform has a read/write access.
 * The SDMA cannot modify that register. The value at reset is 3, which selects the
 * dynamic context switch by default. That register can be modified at anytime
 * but the new context switch configuration will only be taken into account at the
 * start of the next restore phase. NOTE: The first call to SDMA's channel 0
 * Bootload script after reset should use static context switch mode to ensure the
 * context RAM for channel 0 is initialized in the channel SAVE Phase. After
 * Channel 0 is run once, then any of the dynamic context modes can be used.
 *
 * Values:
 * - 0 - static
 * - 1 - dynamic low power
 */
/*@{*/
#define BP_SDMAARM_CONFIG_CSM (0U)         /*!< Bit position for SDMAARM_CONFIG_CSM. */
#define BM_SDMAARM_CONFIG_CSM (0x00000003U) /*!< Bit mask for SDMAARM_CONFIG_CSM. */
#define BS_SDMAARM_CONFIG_CSM (2U)         /*!< Bit field size in bits for SDMAARM_CONFIG_CSM. */

/*! @brief Read current value of the SDMAARM_CONFIG_CSM field. */
#define BR_SDMAARM_CONFIG_CSM(x) (HW_SDMAARM_CONFIG(x).B.CSM)

/*! @brief Format value for bitfield SDMAARM_CONFIG_CSM. */
#define BF_SDMAARM_CONFIG_CSM(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CONFIG_CSM) & BM_SDMAARM_CONFIG_CSM)

/*! @brief Set the CSM field to a new value. */
#define BW_SDMAARM_CONFIG_CSM(x, v) (HW_SDMAARM_CONFIG_WR(x, (HW_SDMAARM_CONFIG_RD(x) & ~BM_SDMAARM_CONFIG_CSM) | BF_SDMAARM_CONFIG_CSM(v)))
/*@}*/

/*!
 * @name Register SDMAARM_CONFIG, field ACR[4] (RW)
 *
 * ARM platform DMA / SDMA Core Clock Ratio. Selects the clock ratio between ARM
 * platform DMA interfaces (burst DMA and peripheral DMA) and the internal SDMA
 * core clock. The frequency selection is determined separately by the chip clock
 * controller. This bit has to match the configuration of the chip clock
 * controller that generates the clocks used in the SDMA.
 *
 * Values:
 * - 0 - ARM platform DMA interface frequency equals twice core frequency
 * - 1 - ARM platform DMA interface frequency equals core frequency
 */
/*@{*/
#define BP_SDMAARM_CONFIG_ACR (4U)         /*!< Bit position for SDMAARM_CONFIG_ACR. */
#define BM_SDMAARM_CONFIG_ACR (0x00000010U) /*!< Bit mask for SDMAARM_CONFIG_ACR. */
#define BS_SDMAARM_CONFIG_ACR (1U)         /*!< Bit field size in bits for SDMAARM_CONFIG_ACR. */

/*! @brief Read current value of the SDMAARM_CONFIG_ACR field. */
#define BR_SDMAARM_CONFIG_ACR(x) (HW_SDMAARM_CONFIG(x).B.ACR)

/*! @brief Format value for bitfield SDMAARM_CONFIG_ACR. */
#define BF_SDMAARM_CONFIG_ACR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CONFIG_ACR) & BM_SDMAARM_CONFIG_ACR)

/*! @brief Set the ACR field to a new value. */
#define BW_SDMAARM_CONFIG_ACR(x, v) (HW_SDMAARM_CONFIG_WR(x, (HW_SDMAARM_CONFIG_RD(x) & ~BM_SDMAARM_CONFIG_ACR) | BF_SDMAARM_CONFIG_ACR(v)))
/*@}*/

/*!
 * @name Register SDMAARM_CONFIG, field RTDOBS[11] (RW)
 *
 * Indicates if Real-Time Debug pins are used: They do not toggle by default in
 * order to reduce power consumption.
 *
 * Values:
 * - 0 - RTD pins disabled
 * - 1 - RTD pins enabled
 */
/*@{*/
#define BP_SDMAARM_CONFIG_RTDOBS (11U)     /*!< Bit position for SDMAARM_CONFIG_RTDOBS. */
#define BM_SDMAARM_CONFIG_RTDOBS (0x00000800U) /*!< Bit mask for SDMAARM_CONFIG_RTDOBS. */
#define BS_SDMAARM_CONFIG_RTDOBS (1U)      /*!< Bit field size in bits for SDMAARM_CONFIG_RTDOBS. */

/*! @brief Read current value of the SDMAARM_CONFIG_RTDOBS field. */
#define BR_SDMAARM_CONFIG_RTDOBS(x) (HW_SDMAARM_CONFIG(x).B.RTDOBS)

/*! @brief Format value for bitfield SDMAARM_CONFIG_RTDOBS. */
#define BF_SDMAARM_CONFIG_RTDOBS(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CONFIG_RTDOBS) & BM_SDMAARM_CONFIG_RTDOBS)

/*! @brief Set the RTDOBS field to a new value. */
#define BW_SDMAARM_CONFIG_RTDOBS(x, v) (HW_SDMAARM_CONFIG_WR(x, (HW_SDMAARM_CONFIG_RD(x) & ~BM_SDMAARM_CONFIG_RTDOBS) | BF_SDMAARM_CONFIG_RTDOBS(v)))
/*@}*/

/*!
 * @name Register SDMAARM_CONFIG, field DSPDMA[12] (RW)
 *
 * This bit's function is reserved and should be configured as zero.
 *
 * Values:
 * - 0 - - Reset Value
 * - 1 - - Reserved
 */
/*@{*/
#define BP_SDMAARM_CONFIG_DSPDMA (12U)     /*!< Bit position for SDMAARM_CONFIG_DSPDMA. */
#define BM_SDMAARM_CONFIG_DSPDMA (0x00001000U) /*!< Bit mask for SDMAARM_CONFIG_DSPDMA. */
#define BS_SDMAARM_CONFIG_DSPDMA (1U)      /*!< Bit field size in bits for SDMAARM_CONFIG_DSPDMA. */

/*! @brief Read current value of the SDMAARM_CONFIG_DSPDMA field. */
#define BR_SDMAARM_CONFIG_DSPDMA(x) (HW_SDMAARM_CONFIG(x).B.DSPDMA)

/*! @brief Format value for bitfield SDMAARM_CONFIG_DSPDMA. */
#define BF_SDMAARM_CONFIG_DSPDMA(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CONFIG_DSPDMA) & BM_SDMAARM_CONFIG_DSPDMA)

/*! @brief Set the DSPDMA field to a new value. */
#define BW_SDMAARM_CONFIG_DSPDMA(x, v) (HW_SDMAARM_CONFIG_WR(x, (HW_SDMAARM_CONFIG_RD(x) & ~BM_SDMAARM_CONFIG_DSPDMA) | BF_SDMAARM_CONFIG_DSPDMA(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_SDMA_LOCK - SDMA LOCK
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_SDMA_LOCK - SDMA LOCK (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_sdma_lock
{
    uint32_t U;
    struct _hw_sdmaarm_sdma_lock_bitfields
    {
        uint32_t LOCK : 1;             /*!< [0]  */
        uint32_t SRESET_LOCK_CLR : 1;  /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_sdmaarm_sdma_lock_t;

/*!
 * @name Constants and macros for entire SDMAARM_SDMA_LOCK register
 */
/*@{*/
#define HW_SDMAARM_SDMA_LOCK_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_SDMAARM_SDMA_LOCK(x)  (*(__IO hw_sdmaarm_sdma_lock_t *) HW_SDMAARM_SDMA_LOCK_ADDR(x))
#define HW_SDMAARM_SDMA_LOCK_RD(x) (HW_SDMAARM_SDMA_LOCK(x).U)
#define HW_SDMAARM_SDMA_LOCK_WR(x, v) (HW_SDMAARM_SDMA_LOCK(x).U = (v))
#define HW_SDMAARM_SDMA_LOCK_SET(x, v) (HW_SDMAARM_SDMA_LOCK_WR(x, HW_SDMAARM_SDMA_LOCK_RD(x) |  (v)))
#define HW_SDMAARM_SDMA_LOCK_CLR(x, v) (HW_SDMAARM_SDMA_LOCK_WR(x, HW_SDMAARM_SDMA_LOCK_RD(x) & ~(v)))
#define HW_SDMAARM_SDMA_LOCK_TOG(x, v) (HW_SDMAARM_SDMA_LOCK_WR(x, HW_SDMAARM_SDMA_LOCK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_SDMA_LOCK bitfields
 */

/*!
 * @name Register SDMAARM_SDMA_LOCK, field LOCK[0] (RW)
 *
 * The LOCK bit is used to restrict access to update SDMA script memory through
 * ROM channel zero scripts and through the OnCE interface under ARM platform
 * control. The LOCK bit is set: The SDMA_LOCK, ONCE_ENB,CH0ADDR, and ILLINSTADDR
 * registers cannot be written. These registers can be read, but writes are
 * ignored. SDMA software executing out of ROM or RAM may check the LOCK bit in the LOCK
 * register SDMA_LOCKLock Status Register to determine if certain operations are
 * allowed, such as up-loading new scripts. Once the LOCK bit is set to 1, only
 * a reset can clear it. The LOCK bit is cleared by a hardware reset. LOCK is
 * cleared by a software reset only if SRESET_LOCK_CLR is set.
 *
 * Values:
 * - 0 - LOCK disengaged.
 * - 1 - LOCK enabled.
 */
/*@{*/
#define BP_SDMAARM_SDMA_LOCK_LOCK (0U)     /*!< Bit position for SDMAARM_SDMA_LOCK_LOCK. */
#define BM_SDMAARM_SDMA_LOCK_LOCK (0x00000001U) /*!< Bit mask for SDMAARM_SDMA_LOCK_LOCK. */
#define BS_SDMAARM_SDMA_LOCK_LOCK (1U)     /*!< Bit field size in bits for SDMAARM_SDMA_LOCK_LOCK. */

/*! @brief Read current value of the SDMAARM_SDMA_LOCK_LOCK field. */
#define BR_SDMAARM_SDMA_LOCK_LOCK(x) (HW_SDMAARM_SDMA_LOCK(x).B.LOCK)

/*! @brief Format value for bitfield SDMAARM_SDMA_LOCK_LOCK. */
#define BF_SDMAARM_SDMA_LOCK_LOCK(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_SDMA_LOCK_LOCK) & BM_SDMAARM_SDMA_LOCK_LOCK)

/*! @brief Set the LOCK field to a new value. */
#define BW_SDMAARM_SDMA_LOCK_LOCK(x, v) (HW_SDMAARM_SDMA_LOCK_WR(x, (HW_SDMAARM_SDMA_LOCK_RD(x) & ~BM_SDMAARM_SDMA_LOCK_LOCK) | BF_SDMAARM_SDMA_LOCK_LOCK(v)))
/*@}*/

/*!
 * @name Register SDMAARM_SDMA_LOCK, field SRESET_LOCK_CLR[1] (RW)
 *
 * The SRESET_LOCK_CLR bit determine if the LOCK bit is cleared on a software
 * reset triggered by writing to the RESET register. This bit cannot be changed if
 * LOCK=1. SREST_LOCK_CLR is cleared by conditions that clear the LOCK bit.
 *
 * Values:
 * - 0 - Software Reset does not clear the LOCK bit.
 * - 1 - Software Reset clears the LOCK bit.
 */
/*@{*/
#define BP_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR (1U) /*!< Bit position for SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR. */
#define BM_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR (0x00000002U) /*!< Bit mask for SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR. */
#define BS_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR (1U) /*!< Bit field size in bits for SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR. */

/*! @brief Read current value of the SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR field. */
#define BR_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR(x) (HW_SDMAARM_SDMA_LOCK(x).B.SRESET_LOCK_CLR)

/*! @brief Format value for bitfield SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR. */
#define BF_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR) & BM_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR)

/*! @brief Set the SRESET_LOCK_CLR field to a new value. */
#define BW_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR(x, v) (HW_SDMAARM_SDMA_LOCK_WR(x, (HW_SDMAARM_SDMA_LOCK_RD(x) & ~BM_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR) | BF_SDMAARM_SDMA_LOCK_SRESET_LOCK_CLR(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ONCE_ENB - OnCE Enable
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ONCE_ENB - OnCE Enable (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_once_enb
{
    uint32_t U;
    struct _hw_sdmaarm_once_enb_bitfields
    {
        uint32_t ENB : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_sdmaarm_once_enb_t;

/*!
 * @name Constants and macros for entire SDMAARM_ONCE_ENB register
 */
/*@{*/
#define HW_SDMAARM_ONCE_ENB_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_SDMAARM_ONCE_ENB(x)   (*(__IO hw_sdmaarm_once_enb_t *) HW_SDMAARM_ONCE_ENB_ADDR(x))
#define HW_SDMAARM_ONCE_ENB_RD(x) (HW_SDMAARM_ONCE_ENB(x).U)
#define HW_SDMAARM_ONCE_ENB_WR(x, v) (HW_SDMAARM_ONCE_ENB(x).U = (v))
#define HW_SDMAARM_ONCE_ENB_SET(x, v) (HW_SDMAARM_ONCE_ENB_WR(x, HW_SDMAARM_ONCE_ENB_RD(x) |  (v)))
#define HW_SDMAARM_ONCE_ENB_CLR(x, v) (HW_SDMAARM_ONCE_ENB_WR(x, HW_SDMAARM_ONCE_ENB_RD(x) & ~(v)))
#define HW_SDMAARM_ONCE_ENB_TOG(x, v) (HW_SDMAARM_ONCE_ENB_WR(x, HW_SDMAARM_ONCE_ENB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ONCE_ENB bitfields
 */

/*!
 * @name Register SDMAARM_ONCE_ENB, field ENB[0] (RW)
 *
 * The OnCE Enable register selects the OnCE control source: When cleared (0),
 * the OnCE registers are accessed through the JTAG interface; when set (1), the
 * OnCE registers may be accessed by the ARM platform through the addresses
 * described, as follows. After reset, the OnCE registers are accessed through the JTAG
 * interface. Writing a 1 to ENB enables the ARM platform to access the ONCE_*
 * as any other SDMA control register. When cleared (0), all the ONCE_xxx
 * registers cannot be written. The value of ENB cannot be changed if the LOCK bit in the
 * SDMA_LOCK register is set.
 */
/*@{*/
#define BP_SDMAARM_ONCE_ENB_ENB (0U)       /*!< Bit position for SDMAARM_ONCE_ENB_ENB. */
#define BM_SDMAARM_ONCE_ENB_ENB (0x00000001U) /*!< Bit mask for SDMAARM_ONCE_ENB_ENB. */
#define BS_SDMAARM_ONCE_ENB_ENB (1U)       /*!< Bit field size in bits for SDMAARM_ONCE_ENB_ENB. */

/*! @brief Read current value of the SDMAARM_ONCE_ENB_ENB field. */
#define BR_SDMAARM_ONCE_ENB_ENB(x) (HW_SDMAARM_ONCE_ENB(x).B.ENB)

/*! @brief Format value for bitfield SDMAARM_ONCE_ENB_ENB. */
#define BF_SDMAARM_ONCE_ENB_ENB(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_ONCE_ENB_ENB) & BM_SDMAARM_ONCE_ENB_ENB)

/*! @brief Set the ENB field to a new value. */
#define BW_SDMAARM_ONCE_ENB_ENB(x, v) (HW_SDMAARM_ONCE_ENB_WR(x, (HW_SDMAARM_ONCE_ENB_RD(x) & ~BM_SDMAARM_ONCE_ENB_ENB) | BF_SDMAARM_ONCE_ENB_ENB(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ONCE_DATA - OnCE Data Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ONCE_DATA - OnCE Data Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_once_data
{
    uint32_t U;
    struct _hw_sdmaarm_once_data_bitfields
    {
        uint32_t DATA : 32;            /*!< [31:0]  */
    } B;
} hw_sdmaarm_once_data_t;

/*!
 * @name Constants and macros for entire SDMAARM_ONCE_DATA register
 */
/*@{*/
#define HW_SDMAARM_ONCE_DATA_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_SDMAARM_ONCE_DATA(x)  (*(__IO hw_sdmaarm_once_data_t *) HW_SDMAARM_ONCE_DATA_ADDR(x))
#define HW_SDMAARM_ONCE_DATA_RD(x) (HW_SDMAARM_ONCE_DATA(x).U)
#define HW_SDMAARM_ONCE_DATA_WR(x, v) (HW_SDMAARM_ONCE_DATA(x).U = (v))
#define HW_SDMAARM_ONCE_DATA_SET(x, v) (HW_SDMAARM_ONCE_DATA_WR(x, HW_SDMAARM_ONCE_DATA_RD(x) |  (v)))
#define HW_SDMAARM_ONCE_DATA_CLR(x, v) (HW_SDMAARM_ONCE_DATA_WR(x, HW_SDMAARM_ONCE_DATA_RD(x) & ~(v)))
#define HW_SDMAARM_ONCE_DATA_TOG(x, v) (HW_SDMAARM_ONCE_DATA_WR(x, HW_SDMAARM_ONCE_DATA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ONCE_DATA bitfields
 */

/*!
 * @name Register SDMAARM_ONCE_DATA, field DATA[31:0] (RW)
 *
 * Data register of the OnCE JTAG controller. Refer to OnCE and Real-Time
 * DebugThe On-Chip Emulation block (OnCE) is the debug interface to the SDMA. for
 * information on this register.
 */
/*@{*/
#define BP_SDMAARM_ONCE_DATA_DATA (0U)     /*!< Bit position for SDMAARM_ONCE_DATA_DATA. */
#define BM_SDMAARM_ONCE_DATA_DATA (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_ONCE_DATA_DATA. */
#define BS_SDMAARM_ONCE_DATA_DATA (32U)    /*!< Bit field size in bits for SDMAARM_ONCE_DATA_DATA. */

/*! @brief Read current value of the SDMAARM_ONCE_DATA_DATA field. */
#define BR_SDMAARM_ONCE_DATA_DATA(x) (HW_SDMAARM_ONCE_DATA(x).U)

/*! @brief Format value for bitfield SDMAARM_ONCE_DATA_DATA. */
#define BF_SDMAARM_ONCE_DATA_DATA(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_ONCE_DATA_DATA) & BM_SDMAARM_ONCE_DATA_DATA)

/*! @brief Set the DATA field to a new value. */
#define BW_SDMAARM_ONCE_DATA_DATA(x, v) (HW_SDMAARM_ONCE_DATA_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ONCE_INSTR - OnCE Instruction Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ONCE_INSTR - OnCE Instruction Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_once_instr
{
    uint32_t U;
    struct _hw_sdmaarm_once_instr_bitfields
    {
        uint32_t INSTR : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmaarm_once_instr_t;

/*!
 * @name Constants and macros for entire SDMAARM_ONCE_INSTR register
 */
/*@{*/
#define HW_SDMAARM_ONCE_INSTR_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_SDMAARM_ONCE_INSTR(x) (*(__IO hw_sdmaarm_once_instr_t *) HW_SDMAARM_ONCE_INSTR_ADDR(x))
#define HW_SDMAARM_ONCE_INSTR_RD(x) (HW_SDMAARM_ONCE_INSTR(x).U)
#define HW_SDMAARM_ONCE_INSTR_WR(x, v) (HW_SDMAARM_ONCE_INSTR(x).U = (v))
#define HW_SDMAARM_ONCE_INSTR_SET(x, v) (HW_SDMAARM_ONCE_INSTR_WR(x, HW_SDMAARM_ONCE_INSTR_RD(x) |  (v)))
#define HW_SDMAARM_ONCE_INSTR_CLR(x, v) (HW_SDMAARM_ONCE_INSTR_WR(x, HW_SDMAARM_ONCE_INSTR_RD(x) & ~(v)))
#define HW_SDMAARM_ONCE_INSTR_TOG(x, v) (HW_SDMAARM_ONCE_INSTR_WR(x, HW_SDMAARM_ONCE_INSTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ONCE_INSTR bitfields
 */

/*!
 * @name Register SDMAARM_ONCE_INSTR, field INSTR[15:0] (RW)
 *
 * Instruction register of the OnCE JTAG controller. Refer to OnCE and Real-Time
 * DebugThe On-Chip Emulation block (OnCE) is the debug interface to the SDMA.
 * for information on this register.
 */
/*@{*/
#define BP_SDMAARM_ONCE_INSTR_INSTR (0U)   /*!< Bit position for SDMAARM_ONCE_INSTR_INSTR. */
#define BM_SDMAARM_ONCE_INSTR_INSTR (0x0000FFFFU) /*!< Bit mask for SDMAARM_ONCE_INSTR_INSTR. */
#define BS_SDMAARM_ONCE_INSTR_INSTR (16U)  /*!< Bit field size in bits for SDMAARM_ONCE_INSTR_INSTR. */

/*! @brief Read current value of the SDMAARM_ONCE_INSTR_INSTR field. */
#define BR_SDMAARM_ONCE_INSTR_INSTR(x) (HW_SDMAARM_ONCE_INSTR(x).B.INSTR)

/*! @brief Format value for bitfield SDMAARM_ONCE_INSTR_INSTR. */
#define BF_SDMAARM_ONCE_INSTR_INSTR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_ONCE_INSTR_INSTR) & BM_SDMAARM_ONCE_INSTR_INSTR)

/*! @brief Set the INSTR field to a new value. */
#define BW_SDMAARM_ONCE_INSTR_INSTR(x, v) (HW_SDMAARM_ONCE_INSTR_WR(x, (HW_SDMAARM_ONCE_INSTR_RD(x) & ~BM_SDMAARM_ONCE_INSTR_INSTR) | BF_SDMAARM_ONCE_INSTR_INSTR(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ONCE_STAT - OnCE Status Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ONCE_STAT - OnCE Status Register (RO)
 *
 * Reset value: 0x0000E000U
 */
typedef union _hw_sdmaarm_once_stat
{
    uint32_t U;
    struct _hw_sdmaarm_once_stat_bitfields
    {
        uint32_t ECDR : 3;             /*!< [2:0]  */
        uint32_t RESERVED0 : 4;        /*!< [6:3]  */
        uint32_t MST : 1;              /*!< [7]  */
        uint32_t SWB : 1;              /*!< [8]  */
        uint32_t ODR : 1;              /*!< [9]  */
        uint32_t EDR : 1;              /*!< [10]  */
        uint32_t RCV : 1;              /*!< [11]  */
        uint32_t PST : 4;              /*!< [15:12]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmaarm_once_stat_t;

/*!
 * @name Constants and macros for entire SDMAARM_ONCE_STAT register
 */
/*@{*/
#define HW_SDMAARM_ONCE_STAT_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_SDMAARM_ONCE_STAT(x)  (*(__I hw_sdmaarm_once_stat_t *) HW_SDMAARM_ONCE_STAT_ADDR(x))
#define HW_SDMAARM_ONCE_STAT_RD(x) (HW_SDMAARM_ONCE_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ONCE_STAT bitfields
 */

/*!
 * @name Register SDMAARM_ONCE_STAT, field ECDR[2:0] (RO)
 *
 * Event Cell Debug Request. If the debug request comes from the event cell, the
 * reason for entering debug mode is given by the EDR bits. If all three bits of
 * the EDR are reset, then it did not generate any debug request. If the cell
 * did generate a debug request, then at least one of the EDR bits is set (the
 * meaning of the encoding is given below). The encoding of the EDR bits is useful to
 * find out more precisely why the debug request was generated. A debug request
 * from an event cell is generated for a specific combination of the addra_cond,
 * addrb_cond, and data_cond conditions. The value of those fields is given by
 * the EDR bits.
 *
 * Values:
 * - 0 - 1 matched addra_cond
 * - 1 - 1 matched addrb_cond
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_ECDR (0U)     /*!< Bit position for SDMAARM_ONCE_STAT_ECDR. */
#define BM_SDMAARM_ONCE_STAT_ECDR (0x00000007U) /*!< Bit mask for SDMAARM_ONCE_STAT_ECDR. */
#define BS_SDMAARM_ONCE_STAT_ECDR (3U)     /*!< Bit field size in bits for SDMAARM_ONCE_STAT_ECDR. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_ECDR field. */
#define BR_SDMAARM_ONCE_STAT_ECDR(x) (HW_SDMAARM_ONCE_STAT(x).B.ECDR)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field MST[7] (RO)
 *
 * This flag is raised when the OnCE is controlled from the ARM platform
 * peripheral interface.
 *
 * Values:
 * - 0 - The JTAG interface controls the OnCE.
 * - 1 - The ARM platform peripheral interface controls the OnCE.
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_MST (7U)      /*!< Bit position for SDMAARM_ONCE_STAT_MST. */
#define BM_SDMAARM_ONCE_STAT_MST (0x00000080U) /*!< Bit mask for SDMAARM_ONCE_STAT_MST. */
#define BS_SDMAARM_ONCE_STAT_MST (1U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_MST. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_MST field. */
#define BR_SDMAARM_ONCE_STAT_MST(x) (HW_SDMAARM_ONCE_STAT(x).B.MST)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field SWB[8] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after a software
 * breakpoint.
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_SWB (8U)      /*!< Bit position for SDMAARM_ONCE_STAT_SWB. */
#define BM_SDMAARM_ONCE_STAT_SWB (0x00000100U) /*!< Bit mask for SDMAARM_ONCE_STAT_SWB. */
#define BS_SDMAARM_ONCE_STAT_SWB (1U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_SWB. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_SWB field. */
#define BR_SDMAARM_ONCE_STAT_SWB(x) (HW_SDMAARM_ONCE_STAT(x).B.SWB)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field ODR[9] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after a OnCE debug
 * request.
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_ODR (9U)      /*!< Bit position for SDMAARM_ONCE_STAT_ODR. */
#define BM_SDMAARM_ONCE_STAT_ODR (0x00000200U) /*!< Bit mask for SDMAARM_ONCE_STAT_ODR. */
#define BS_SDMAARM_ONCE_STAT_ODR (1U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_ODR. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_ODR field. */
#define BR_SDMAARM_ONCE_STAT_ODR(x) (HW_SDMAARM_ONCE_STAT(x).B.ODR)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field EDR[10] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after an external
 * debug request.
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_EDR (10U)     /*!< Bit position for SDMAARM_ONCE_STAT_EDR. */
#define BM_SDMAARM_ONCE_STAT_EDR (0x00000400U) /*!< Bit mask for SDMAARM_ONCE_STAT_EDR. */
#define BS_SDMAARM_ONCE_STAT_EDR (1U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_EDR. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_EDR field. */
#define BR_SDMAARM_ONCE_STAT_EDR(x) (HW_SDMAARM_ONCE_STAT(x).B.EDR)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field RCV[11] (RO)
 *
 * After each write access to the real time buffer (RTB), the RCV bit is set.
 * This bit is cleared after execution of an rbuffer command and on a JTAG reset.
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_RCV (11U)     /*!< Bit position for SDMAARM_ONCE_STAT_RCV. */
#define BM_SDMAARM_ONCE_STAT_RCV (0x00000800U) /*!< Bit mask for SDMAARM_ONCE_STAT_RCV. */
#define BS_SDMAARM_ONCE_STAT_RCV (1U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_RCV. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_RCV field. */
#define BR_SDMAARM_ONCE_STAT_RCV(x) (HW_SDMAARM_ONCE_STAT(x).B.RCV)
/*@}*/

/*!
 * @name Register SDMAARM_ONCE_STAT, field PST[15:12] (RO)
 *
 * The Processor Status bits reflect the state of the SDMA RISC engine. Its
 * states are as follows: The "Program" state is the usual instruction execution
 * cycle. The "Data" state is inserted when there are wait-states during a load or a
 * store on the data bus (ld or st). The "Change of Flow" state is the second
 * cycle of any instruction that breaks the sequence of instructions (jumps and
 * channel switching instructions). The "Change of Flow in Loop" state is used when
 * an error causes a hardware loop exit. The "Debug" state means the SDMA is in
 * debug mode. The "Functional Unit" state is inserted when there are wait-states
 * during a load or a store on the functional units bus (ldf or stf). In "Sleep"
 * modes, no script is running (this is the RISC engine idle state). The "after
 * Reset" is slightly different because no context restoring phase will happen when
 * a channel is triggered: The script located at address 0 will be executed
 * (boot operation). The "in Sleep" states are the same as above except they do not
 * have any corresponding channel: They are used when entering debug mode after
 * reset. The reason is that it is necessary to return to the "Sleep after Reset"
 * state when leaving debug mode.
 *
 * Values:
 * - 0 - Program
 * - 1 - Data
 * - 10 - Change of Flow in Sleep
 * - 11 - Change Flow in Loop in Sleep
 */
/*@{*/
#define BP_SDMAARM_ONCE_STAT_PST (12U)     /*!< Bit position for SDMAARM_ONCE_STAT_PST. */
#define BM_SDMAARM_ONCE_STAT_PST (0x0000F000U) /*!< Bit mask for SDMAARM_ONCE_STAT_PST. */
#define BS_SDMAARM_ONCE_STAT_PST (4U)      /*!< Bit field size in bits for SDMAARM_ONCE_STAT_PST. */

/*! @brief Read current value of the SDMAARM_ONCE_STAT_PST field. */
#define BR_SDMAARM_ONCE_STAT_PST(x) (HW_SDMAARM_ONCE_STAT(x).B.PST)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ONCE_CMD - OnCE Command Register
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ONCE_CMD - OnCE Command Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_once_cmd
{
    uint32_t U;
    struct _hw_sdmaarm_once_cmd_bitfields
    {
        uint32_t CMD : 4;              /*!< [3:0]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_sdmaarm_once_cmd_t;

/*!
 * @name Constants and macros for entire SDMAARM_ONCE_CMD register
 */
/*@{*/
#define HW_SDMAARM_ONCE_CMD_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_SDMAARM_ONCE_CMD(x)   (*(__IO hw_sdmaarm_once_cmd_t *) HW_SDMAARM_ONCE_CMD_ADDR(x))
#define HW_SDMAARM_ONCE_CMD_RD(x) (HW_SDMAARM_ONCE_CMD(x).U)
#define HW_SDMAARM_ONCE_CMD_WR(x, v) (HW_SDMAARM_ONCE_CMD(x).U = (v))
#define HW_SDMAARM_ONCE_CMD_SET(x, v) (HW_SDMAARM_ONCE_CMD_WR(x, HW_SDMAARM_ONCE_CMD_RD(x) |  (v)))
#define HW_SDMAARM_ONCE_CMD_CLR(x, v) (HW_SDMAARM_ONCE_CMD_WR(x, HW_SDMAARM_ONCE_CMD_RD(x) & ~(v)))
#define HW_SDMAARM_ONCE_CMD_TOG(x, v) (HW_SDMAARM_ONCE_CMD_WR(x, HW_SDMAARM_ONCE_CMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ONCE_CMD bitfields
 */

/*!
 * @name Register SDMAARM_ONCE_CMD, field CMD[3:0] (RW)
 *
 * Writing to this register will cause the OnCE to execute the command that is
 * written. When needed, the ONCE_DATA and ONCE_INSTR registers should be loaded
 * with the correct value before writing the command to that register. For a list
 * of the OnCE commands and their usage, see OnCE and Real-Time DebugThe On-Chip
 * Emulation block (OnCE) is the debug interface to the SDMA. . 7-15 reserved
 *
 * Values:
 * - 0 - rstatus
 * - 1 - dmov
 */
/*@{*/
#define BP_SDMAARM_ONCE_CMD_CMD (0U)       /*!< Bit position for SDMAARM_ONCE_CMD_CMD. */
#define BM_SDMAARM_ONCE_CMD_CMD (0x0000000FU) /*!< Bit mask for SDMAARM_ONCE_CMD_CMD. */
#define BS_SDMAARM_ONCE_CMD_CMD (4U)       /*!< Bit field size in bits for SDMAARM_ONCE_CMD_CMD. */

/*! @brief Read current value of the SDMAARM_ONCE_CMD_CMD field. */
#define BR_SDMAARM_ONCE_CMD_CMD(x) (HW_SDMAARM_ONCE_CMD(x).B.CMD)

/*! @brief Format value for bitfield SDMAARM_ONCE_CMD_CMD. */
#define BF_SDMAARM_ONCE_CMD_CMD(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_ONCE_CMD_CMD) & BM_SDMAARM_ONCE_CMD_CMD)

/*! @brief Set the CMD field to a new value. */
#define BW_SDMAARM_ONCE_CMD_CMD(x, v) (HW_SDMAARM_ONCE_CMD_WR(x, (HW_SDMAARM_ONCE_CMD_RD(x) & ~BM_SDMAARM_ONCE_CMD_CMD) | BF_SDMAARM_ONCE_CMD_CMD(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_ILLINSTADDR - Illegal Instruction Trap Address
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_ILLINSTADDR - Illegal Instruction Trap Address (RW)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_sdmaarm_illinstaddr
{
    uint32_t U;
    struct _hw_sdmaarm_illinstaddr_bitfields
    {
        uint32_t ILLINSTADDR : 14;     /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_sdmaarm_illinstaddr_t;

/*!
 * @name Constants and macros for entire SDMAARM_ILLINSTADDR register
 */
/*@{*/
#define HW_SDMAARM_ILLINSTADDR_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_SDMAARM_ILLINSTADDR(x) (*(__IO hw_sdmaarm_illinstaddr_t *) HW_SDMAARM_ILLINSTADDR_ADDR(x))
#define HW_SDMAARM_ILLINSTADDR_RD(x) (HW_SDMAARM_ILLINSTADDR(x).U)
#define HW_SDMAARM_ILLINSTADDR_WR(x, v) (HW_SDMAARM_ILLINSTADDR(x).U = (v))
#define HW_SDMAARM_ILLINSTADDR_SET(x, v) (HW_SDMAARM_ILLINSTADDR_WR(x, HW_SDMAARM_ILLINSTADDR_RD(x) |  (v)))
#define HW_SDMAARM_ILLINSTADDR_CLR(x, v) (HW_SDMAARM_ILLINSTADDR_WR(x, HW_SDMAARM_ILLINSTADDR_RD(x) & ~(v)))
#define HW_SDMAARM_ILLINSTADDR_TOG(x, v) (HW_SDMAARM_ILLINSTADDR_WR(x, HW_SDMAARM_ILLINSTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_ILLINSTADDR bitfields
 */

/*!
 * @name Register SDMAARM_ILLINSTADDR, field ILLINSTADDR[13:0] (RW)
 *
 * The Illegal Instruction Trap Address is the address where the SDMA jumps when
 * an illegal instruction is executed. It is 0x0001 after reset. The value of
 * ILLINSTADDR cannot be changed if the LOCK bit in the SDMA_LOCK register is set.
 */
/*@{*/
#define BP_SDMAARM_ILLINSTADDR_ILLINSTADDR (0U) /*!< Bit position for SDMAARM_ILLINSTADDR_ILLINSTADDR. */
#define BM_SDMAARM_ILLINSTADDR_ILLINSTADDR (0x00003FFFU) /*!< Bit mask for SDMAARM_ILLINSTADDR_ILLINSTADDR. */
#define BS_SDMAARM_ILLINSTADDR_ILLINSTADDR (14U) /*!< Bit field size in bits for SDMAARM_ILLINSTADDR_ILLINSTADDR. */

/*! @brief Read current value of the SDMAARM_ILLINSTADDR_ILLINSTADDR field. */
#define BR_SDMAARM_ILLINSTADDR_ILLINSTADDR(x) (HW_SDMAARM_ILLINSTADDR(x).B.ILLINSTADDR)

/*! @brief Format value for bitfield SDMAARM_ILLINSTADDR_ILLINSTADDR. */
#define BF_SDMAARM_ILLINSTADDR_ILLINSTADDR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_ILLINSTADDR_ILLINSTADDR) & BM_SDMAARM_ILLINSTADDR_ILLINSTADDR)

/*! @brief Set the ILLINSTADDR field to a new value. */
#define BW_SDMAARM_ILLINSTADDR_ILLINSTADDR(x, v) (HW_SDMAARM_ILLINSTADDR_WR(x, (HW_SDMAARM_ILLINSTADDR_RD(x) & ~BM_SDMAARM_ILLINSTADDR_ILLINSTADDR) | BF_SDMAARM_ILLINSTADDR_ILLINSTADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_CHN0ADDR - Channel 0 Boot Address
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_CHN0ADDR - Channel 0 Boot Address (RW)
 *
 * Reset value: 0x00000050U
 */
typedef union _hw_sdmaarm_chn0addr
{
    uint32_t U;
    struct _hw_sdmaarm_chn0addr_bitfields
    {
        uint32_t CHN0ADDR : 14;        /*!< [13:0]  */
        uint32_t SMSZ : 1;             /*!< [14]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_sdmaarm_chn0addr_t;

/*!
 * @name Constants and macros for entire SDMAARM_CHN0ADDR register
 */
/*@{*/
#define HW_SDMAARM_CHN0ADDR_ADDR(x) ((uintptr_t)(x) + 0x5CU)

#define HW_SDMAARM_CHN0ADDR(x)   (*(__IO hw_sdmaarm_chn0addr_t *) HW_SDMAARM_CHN0ADDR_ADDR(x))
#define HW_SDMAARM_CHN0ADDR_RD(x) (HW_SDMAARM_CHN0ADDR(x).U)
#define HW_SDMAARM_CHN0ADDR_WR(x, v) (HW_SDMAARM_CHN0ADDR(x).U = (v))
#define HW_SDMAARM_CHN0ADDR_SET(x, v) (HW_SDMAARM_CHN0ADDR_WR(x, HW_SDMAARM_CHN0ADDR_RD(x) |  (v)))
#define HW_SDMAARM_CHN0ADDR_CLR(x, v) (HW_SDMAARM_CHN0ADDR_WR(x, HW_SDMAARM_CHN0ADDR_RD(x) & ~(v)))
#define HW_SDMAARM_CHN0ADDR_TOG(x, v) (HW_SDMAARM_CHN0ADDR_WR(x, HW_SDMAARM_CHN0ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_CHN0ADDR bitfields
 */

/*!
 * @name Register SDMAARM_CHN0ADDR, field CHN0ADDR[13:0] (RW)
 *
 * This 14-bit register is used by the boot code of the SDMA. After reset, it
 * points to the standard boot routine in ROM (channel 0 routine). By changing this
 * address, you can perform a boot sequence with your own routine. The very
 * first instructions of the boot code fetch the contents of this register (it is
 * also mapped in the SDMA memory space) and jump to the given address. The reset
 * value is 0x0050 (decimal 80). The value of CHN0ADDR cannot be changed if the
 * LOCK bit in the SDMA_LOCK register is set.
 */
/*@{*/
#define BP_SDMAARM_CHN0ADDR_CHN0ADDR (0U)  /*!< Bit position for SDMAARM_CHN0ADDR_CHN0ADDR. */
#define BM_SDMAARM_CHN0ADDR_CHN0ADDR (0x00003FFFU) /*!< Bit mask for SDMAARM_CHN0ADDR_CHN0ADDR. */
#define BS_SDMAARM_CHN0ADDR_CHN0ADDR (14U) /*!< Bit field size in bits for SDMAARM_CHN0ADDR_CHN0ADDR. */

/*! @brief Read current value of the SDMAARM_CHN0ADDR_CHN0ADDR field. */
#define BR_SDMAARM_CHN0ADDR_CHN0ADDR(x) (HW_SDMAARM_CHN0ADDR(x).B.CHN0ADDR)

/*! @brief Format value for bitfield SDMAARM_CHN0ADDR_CHN0ADDR. */
#define BF_SDMAARM_CHN0ADDR_CHN0ADDR(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CHN0ADDR_CHN0ADDR) & BM_SDMAARM_CHN0ADDR_CHN0ADDR)

/*! @brief Set the CHN0ADDR field to a new value. */
#define BW_SDMAARM_CHN0ADDR_CHN0ADDR(x, v) (HW_SDMAARM_CHN0ADDR_WR(x, (HW_SDMAARM_CHN0ADDR_RD(x) & ~BM_SDMAARM_CHN0ADDR_CHN0ADDR) | BF_SDMAARM_CHN0ADDR_CHN0ADDR(v)))
/*@}*/

/*!
 * @name Register SDMAARM_CHN0ADDR, field SMSZ[14] (RW)
 *
 * The bit 14 (Scratch Memory Size) determines if scratch memory must be
 * available after every channel context. After reset, it is equal to 0, which defines a
 * RAM space of 24 words for each channel. All of this area stores the channel
 * context. By setting this bit, 32 words are reserved for every channel context,
 * which gives eight additional words that can be used by the channel script to
 * store any type of data. Those words are never erased by the context switching
 * mechanism. The value of SMSZ cannot be changed if the LOCK bit in the SDMA_LOCK
 * register is set.
 *
 * Values:
 * - 0 - 24 words per context
 * - 1 - 32 words per context
 */
/*@{*/
#define BP_SDMAARM_CHN0ADDR_SMSZ (14U)     /*!< Bit position for SDMAARM_CHN0ADDR_SMSZ. */
#define BM_SDMAARM_CHN0ADDR_SMSZ (0x00004000U) /*!< Bit mask for SDMAARM_CHN0ADDR_SMSZ. */
#define BS_SDMAARM_CHN0ADDR_SMSZ (1U)      /*!< Bit field size in bits for SDMAARM_CHN0ADDR_SMSZ. */

/*! @brief Read current value of the SDMAARM_CHN0ADDR_SMSZ field. */
#define BR_SDMAARM_CHN0ADDR_SMSZ(x) (HW_SDMAARM_CHN0ADDR(x).B.SMSZ)

/*! @brief Format value for bitfield SDMAARM_CHN0ADDR_SMSZ. */
#define BF_SDMAARM_CHN0ADDR_SMSZ(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CHN0ADDR_SMSZ) & BM_SDMAARM_CHN0ADDR_SMSZ)

/*! @brief Set the SMSZ field to a new value. */
#define BW_SDMAARM_CHN0ADDR_SMSZ(x, v) (HW_SDMAARM_CHN0ADDR_WR(x, (HW_SDMAARM_CHN0ADDR_RD(x) & ~BM_SDMAARM_CHN0ADDR_SMSZ) | BF_SDMAARM_CHN0ADDR_SMSZ(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVT_MIRROR - DMA Requests
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVT_MIRROR - DMA Requests (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evt_mirror
{
    uint32_t U;
    struct _hw_sdmaarm_evt_mirror_bitfields
    {
        uint32_t EVENTS : 32;          /*!< [31:0]  */
    } B;
} hw_sdmaarm_evt_mirror_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVT_MIRROR register
 */
/*@{*/
#define HW_SDMAARM_EVT_MIRROR_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_SDMAARM_EVT_MIRROR(x) (*(__I hw_sdmaarm_evt_mirror_t *) HW_SDMAARM_EVT_MIRROR_ADDR(x))
#define HW_SDMAARM_EVT_MIRROR_RD(x) (HW_SDMAARM_EVT_MIRROR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVT_MIRROR bitfields
 */

/*!
 * @name Register SDMAARM_EVT_MIRROR, field EVENTS[31:0] (RO)
 *
 * This register reflects the DMA requests received by the SDMA for events 31-0.
 * The ARM platform and the SDMA have a read-only access. There is one bit
 * associated with each of 32 DMA request events. This information may be useful
 * during debug of the blocks that generate the DMA requests. The EVT_MIRROR register
 * is cleared following read access.
 *
 * Values:
 * - 0 - DMA request event not pending
 * - 1 - DMA request event pending
 */
/*@{*/
#define BP_SDMAARM_EVT_MIRROR_EVENTS (0U)  /*!< Bit position for SDMAARM_EVT_MIRROR_EVENTS. */
#define BM_SDMAARM_EVT_MIRROR_EVENTS (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_EVT_MIRROR_EVENTS. */
#define BS_SDMAARM_EVT_MIRROR_EVENTS (32U) /*!< Bit field size in bits for SDMAARM_EVT_MIRROR_EVENTS. */

/*! @brief Read current value of the SDMAARM_EVT_MIRROR_EVENTS field. */
#define BR_SDMAARM_EVT_MIRROR_EVENTS(x) (HW_SDMAARM_EVT_MIRROR(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_EVT_MIRROR2 - DMA Requests 2
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_EVT_MIRROR2 - DMA Requests 2 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_evt_mirror2
{
    uint32_t U;
    struct _hw_sdmaarm_evt_mirror2_bitfields
    {
        uint32_t EVENTS : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmaarm_evt_mirror2_t;

/*!
 * @name Constants and macros for entire SDMAARM_EVT_MIRROR2 register
 */
/*@{*/
#define HW_SDMAARM_EVT_MIRROR2_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_SDMAARM_EVT_MIRROR2(x) (*(__I hw_sdmaarm_evt_mirror2_t *) HW_SDMAARM_EVT_MIRROR2_ADDR(x))
#define HW_SDMAARM_EVT_MIRROR2_RD(x) (HW_SDMAARM_EVT_MIRROR2(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMAARM_EVT_MIRROR2 bitfields
 */

/*!
 * @name Register SDMAARM_EVT_MIRROR2, field EVENTS[15:0] (RO)
 *
 * This register reflects the DMA requests received by the SDMA for events
 * 47-32. The ARM platform and the SDMA have a read-only access. There is one bit
 * associated with each of DMA request events. This information may be useful during
 * debug of the blocks that generate the DMA requests. The EVT_MIRROR2 register
 * is cleared following read access.
 *
 * Values:
 * - 0 - - DMA request event not pending
 */
/*@{*/
#define BP_SDMAARM_EVT_MIRROR2_EVENTS (0U) /*!< Bit position for SDMAARM_EVT_MIRROR2_EVENTS. */
#define BM_SDMAARM_EVT_MIRROR2_EVENTS (0x0000FFFFU) /*!< Bit mask for SDMAARM_EVT_MIRROR2_EVENTS. */
#define BS_SDMAARM_EVT_MIRROR2_EVENTS (16U) /*!< Bit field size in bits for SDMAARM_EVT_MIRROR2_EVENTS. */

/*! @brief Read current value of the SDMAARM_EVT_MIRROR2_EVENTS field. */
#define BR_SDMAARM_EVT_MIRROR2_EVENTS(x) (HW_SDMAARM_EVT_MIRROR2(x).B.EVENTS)
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_XTRIG_CONF1 - Cross-Trigger Events Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_XTRIG_CONF1 - Cross-Trigger Events Configuration Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_xtrig_conf1
{
    uint32_t U;
    struct _hw_sdmaarm_xtrig_conf1_bitfields
    {
        uint32_t NUM0 : 6;             /*!< [5:0]  */
        uint32_t CNF0 : 1;             /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t NUM1 : 6;             /*!< [13:8]  */
        uint32_t CNF1 : 1;             /*!< [14]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t NUM2 : 6;             /*!< [21:16]  */
        uint32_t CNF2 : 1;             /*!< [22]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t NUM3 : 6;             /*!< [29:24]  */
        uint32_t CNF3 : 1;             /*!< [30]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_sdmaarm_xtrig_conf1_t;

/*!
 * @name Constants and macros for entire SDMAARM_XTRIG_CONF1 register
 */
/*@{*/
#define HW_SDMAARM_XTRIG_CONF1_ADDR(x) ((uintptr_t)(x) + 0x70U)

#define HW_SDMAARM_XTRIG_CONF1(x) (*(__IO hw_sdmaarm_xtrig_conf1_t *) HW_SDMAARM_XTRIG_CONF1_ADDR(x))
#define HW_SDMAARM_XTRIG_CONF1_RD(x) (HW_SDMAARM_XTRIG_CONF1(x).U)
#define HW_SDMAARM_XTRIG_CONF1_WR(x, v) (HW_SDMAARM_XTRIG_CONF1(x).U = (v))
#define HW_SDMAARM_XTRIG_CONF1_SET(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, HW_SDMAARM_XTRIG_CONF1_RD(x) |  (v)))
#define HW_SDMAARM_XTRIG_CONF1_CLR(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, HW_SDMAARM_XTRIG_CONF1_RD(x) & ~(v)))
#define HW_SDMAARM_XTRIG_CONF1_TOG(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, HW_SDMAARM_XTRIG_CONF1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_XTRIG_CONF1 bitfields
 */

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field NUM0[5:0] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_NUM0 (0U)   /*!< Bit position for SDMAARM_XTRIG_CONF1_NUM0. */
#define BM_SDMAARM_XTRIG_CONF1_NUM0 (0x0000003FU) /*!< Bit mask for SDMAARM_XTRIG_CONF1_NUM0. */
#define BS_SDMAARM_XTRIG_CONF1_NUM0 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_NUM0. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_NUM0 field. */
#define BR_SDMAARM_XTRIG_CONF1_NUM0(x) (HW_SDMAARM_XTRIG_CONF1(x).B.NUM0)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_NUM0. */
#define BF_SDMAARM_XTRIG_CONF1_NUM0(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_NUM0) & BM_SDMAARM_XTRIG_CONF1_NUM0)

/*! @brief Set the NUM0 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_NUM0(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_NUM0) | BF_SDMAARM_XTRIG_CONF1_NUM0(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field CNF0[6] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_CNF0 (6U)   /*!< Bit position for SDMAARM_XTRIG_CONF1_CNF0. */
#define BM_SDMAARM_XTRIG_CONF1_CNF0 (0x00000040U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_CNF0. */
#define BS_SDMAARM_XTRIG_CONF1_CNF0 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_CNF0. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_CNF0 field. */
#define BR_SDMAARM_XTRIG_CONF1_CNF0(x) (HW_SDMAARM_XTRIG_CONF1(x).B.CNF0)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_CNF0. */
#define BF_SDMAARM_XTRIG_CONF1_CNF0(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_CNF0) & BM_SDMAARM_XTRIG_CONF1_CNF0)

/*! @brief Set the CNF0 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_CNF0(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_CNF0) | BF_SDMAARM_XTRIG_CONF1_CNF0(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field NUM1[13:8] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_NUM1 (8U)   /*!< Bit position for SDMAARM_XTRIG_CONF1_NUM1. */
#define BM_SDMAARM_XTRIG_CONF1_NUM1 (0x00003F00U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_NUM1. */
#define BS_SDMAARM_XTRIG_CONF1_NUM1 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_NUM1. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_NUM1 field. */
#define BR_SDMAARM_XTRIG_CONF1_NUM1(x) (HW_SDMAARM_XTRIG_CONF1(x).B.NUM1)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_NUM1. */
#define BF_SDMAARM_XTRIG_CONF1_NUM1(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_NUM1) & BM_SDMAARM_XTRIG_CONF1_NUM1)

/*! @brief Set the NUM1 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_NUM1(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_NUM1) | BF_SDMAARM_XTRIG_CONF1_NUM1(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field CNF1[14] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_CNF1 (14U)  /*!< Bit position for SDMAARM_XTRIG_CONF1_CNF1. */
#define BM_SDMAARM_XTRIG_CONF1_CNF1 (0x00004000U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_CNF1. */
#define BS_SDMAARM_XTRIG_CONF1_CNF1 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_CNF1. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_CNF1 field. */
#define BR_SDMAARM_XTRIG_CONF1_CNF1(x) (HW_SDMAARM_XTRIG_CONF1(x).B.CNF1)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_CNF1. */
#define BF_SDMAARM_XTRIG_CONF1_CNF1(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_CNF1) & BM_SDMAARM_XTRIG_CONF1_CNF1)

/*! @brief Set the CNF1 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_CNF1(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_CNF1) | BF_SDMAARM_XTRIG_CONF1_CNF1(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field NUM2[21:16] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_NUM2 (16U)  /*!< Bit position for SDMAARM_XTRIG_CONF1_NUM2. */
#define BM_SDMAARM_XTRIG_CONF1_NUM2 (0x003F0000U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_NUM2. */
#define BS_SDMAARM_XTRIG_CONF1_NUM2 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_NUM2. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_NUM2 field. */
#define BR_SDMAARM_XTRIG_CONF1_NUM2(x) (HW_SDMAARM_XTRIG_CONF1(x).B.NUM2)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_NUM2. */
#define BF_SDMAARM_XTRIG_CONF1_NUM2(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_NUM2) & BM_SDMAARM_XTRIG_CONF1_NUM2)

/*! @brief Set the NUM2 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_NUM2(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_NUM2) | BF_SDMAARM_XTRIG_CONF1_NUM2(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field CNF2[22] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_CNF2 (22U)  /*!< Bit position for SDMAARM_XTRIG_CONF1_CNF2. */
#define BM_SDMAARM_XTRIG_CONF1_CNF2 (0x00400000U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_CNF2. */
#define BS_SDMAARM_XTRIG_CONF1_CNF2 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_CNF2. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_CNF2 field. */
#define BR_SDMAARM_XTRIG_CONF1_CNF2(x) (HW_SDMAARM_XTRIG_CONF1(x).B.CNF2)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_CNF2. */
#define BF_SDMAARM_XTRIG_CONF1_CNF2(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_CNF2) & BM_SDMAARM_XTRIG_CONF1_CNF2)

/*! @brief Set the CNF2 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_CNF2(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_CNF2) | BF_SDMAARM_XTRIG_CONF1_CNF2(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field NUM3[29:24] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_NUM3 (24U)  /*!< Bit position for SDMAARM_XTRIG_CONF1_NUM3. */
#define BM_SDMAARM_XTRIG_CONF1_NUM3 (0x3F000000U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_NUM3. */
#define BS_SDMAARM_XTRIG_CONF1_NUM3 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_NUM3. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_NUM3 field. */
#define BR_SDMAARM_XTRIG_CONF1_NUM3(x) (HW_SDMAARM_XTRIG_CONF1(x).B.NUM3)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_NUM3. */
#define BF_SDMAARM_XTRIG_CONF1_NUM3(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_NUM3) & BM_SDMAARM_XTRIG_CONF1_NUM3)

/*! @brief Set the NUM3 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_NUM3(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_NUM3) | BF_SDMAARM_XTRIG_CONF1_NUM3(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF1, field CNF3[30] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by the
 * reception of a DMA request or by the starting of a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF1_CNF3 (30U)  /*!< Bit position for SDMAARM_XTRIG_CONF1_CNF3. */
#define BM_SDMAARM_XTRIG_CONF1_CNF3 (0x40000000U) /*!< Bit mask for SDMAARM_XTRIG_CONF1_CNF3. */
#define BS_SDMAARM_XTRIG_CONF1_CNF3 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF1_CNF3. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF1_CNF3 field. */
#define BR_SDMAARM_XTRIG_CONF1_CNF3(x) (HW_SDMAARM_XTRIG_CONF1(x).B.CNF3)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF1_CNF3. */
#define BF_SDMAARM_XTRIG_CONF1_CNF3(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF1_CNF3) & BM_SDMAARM_XTRIG_CONF1_CNF3)

/*! @brief Set the CNF3 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF1_CNF3(x, v) (HW_SDMAARM_XTRIG_CONF1_WR(x, (HW_SDMAARM_XTRIG_CONF1_RD(x) & ~BM_SDMAARM_XTRIG_CONF1_CNF3) | BF_SDMAARM_XTRIG_CONF1_CNF3(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_XTRIG_CONF2 - Cross-Trigger Events Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_XTRIG_CONF2 - Cross-Trigger Events Configuration Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_xtrig_conf2
{
    uint32_t U;
    struct _hw_sdmaarm_xtrig_conf2_bitfields
    {
        uint32_t NUM4 : 6;             /*!< [5:0]  */
        uint32_t CNF4 : 1;             /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t NUM5 : 6;             /*!< [13:8]  */
        uint32_t CNF5 : 1;             /*!< [14]  */
        uint32_t RESERVED1 : 1;        /*!< [15]  */
        uint32_t NUM6 : 6;             /*!< [21:16]  */
        uint32_t CNF6 : 1;             /*!< [22]  */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t NUM7 : 6;             /*!< [29:24]  */
        uint32_t CNF7 : 1;             /*!< [30]  */
        uint32_t RESERVED3 : 1;        /*!< [31]  */
    } B;
} hw_sdmaarm_xtrig_conf2_t;

/*!
 * @name Constants and macros for entire SDMAARM_XTRIG_CONF2 register
 */
/*@{*/
#define HW_SDMAARM_XTRIG_CONF2_ADDR(x) ((uintptr_t)(x) + 0x74U)

#define HW_SDMAARM_XTRIG_CONF2(x) (*(__IO hw_sdmaarm_xtrig_conf2_t *) HW_SDMAARM_XTRIG_CONF2_ADDR(x))
#define HW_SDMAARM_XTRIG_CONF2_RD(x) (HW_SDMAARM_XTRIG_CONF2(x).U)
#define HW_SDMAARM_XTRIG_CONF2_WR(x, v) (HW_SDMAARM_XTRIG_CONF2(x).U = (v))
#define HW_SDMAARM_XTRIG_CONF2_SET(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, HW_SDMAARM_XTRIG_CONF2_RD(x) |  (v)))
#define HW_SDMAARM_XTRIG_CONF2_CLR(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, HW_SDMAARM_XTRIG_CONF2_RD(x) & ~(v)))
#define HW_SDMAARM_XTRIG_CONF2_TOG(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, HW_SDMAARM_XTRIG_CONF2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_XTRIG_CONF2 bitfields
 */

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field NUM4[5:0] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_NUM4 (0U)   /*!< Bit position for SDMAARM_XTRIG_CONF2_NUM4. */
#define BM_SDMAARM_XTRIG_CONF2_NUM4 (0x0000003FU) /*!< Bit mask for SDMAARM_XTRIG_CONF2_NUM4. */
#define BS_SDMAARM_XTRIG_CONF2_NUM4 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_NUM4. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_NUM4 field. */
#define BR_SDMAARM_XTRIG_CONF2_NUM4(x) (HW_SDMAARM_XTRIG_CONF2(x).B.NUM4)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_NUM4. */
#define BF_SDMAARM_XTRIG_CONF2_NUM4(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_NUM4) & BM_SDMAARM_XTRIG_CONF2_NUM4)

/*! @brief Set the NUM4 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_NUM4(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_NUM4) | BF_SDMAARM_XTRIG_CONF2_NUM4(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field CNF4[6] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_CNF4 (6U)   /*!< Bit position for SDMAARM_XTRIG_CONF2_CNF4. */
#define BM_SDMAARM_XTRIG_CONF2_CNF4 (0x00000040U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_CNF4. */
#define BS_SDMAARM_XTRIG_CONF2_CNF4 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_CNF4. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_CNF4 field. */
#define BR_SDMAARM_XTRIG_CONF2_CNF4(x) (HW_SDMAARM_XTRIG_CONF2(x).B.CNF4)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_CNF4. */
#define BF_SDMAARM_XTRIG_CONF2_CNF4(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_CNF4) & BM_SDMAARM_XTRIG_CONF2_CNF4)

/*! @brief Set the CNF4 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_CNF4(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_CNF4) | BF_SDMAARM_XTRIG_CONF2_CNF4(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field NUM5[13:8] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_NUM5 (8U)   /*!< Bit position for SDMAARM_XTRIG_CONF2_NUM5. */
#define BM_SDMAARM_XTRIG_CONF2_NUM5 (0x00003F00U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_NUM5. */
#define BS_SDMAARM_XTRIG_CONF2_NUM5 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_NUM5. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_NUM5 field. */
#define BR_SDMAARM_XTRIG_CONF2_NUM5(x) (HW_SDMAARM_XTRIG_CONF2(x).B.NUM5)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_NUM5. */
#define BF_SDMAARM_XTRIG_CONF2_NUM5(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_NUM5) & BM_SDMAARM_XTRIG_CONF2_NUM5)

/*! @brief Set the NUM5 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_NUM5(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_NUM5) | BF_SDMAARM_XTRIG_CONF2_NUM5(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field CNF5[14] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_CNF5 (14U)  /*!< Bit position for SDMAARM_XTRIG_CONF2_CNF5. */
#define BM_SDMAARM_XTRIG_CONF2_CNF5 (0x00004000U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_CNF5. */
#define BS_SDMAARM_XTRIG_CONF2_CNF5 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_CNF5. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_CNF5 field. */
#define BR_SDMAARM_XTRIG_CONF2_CNF5(x) (HW_SDMAARM_XTRIG_CONF2(x).B.CNF5)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_CNF5. */
#define BF_SDMAARM_XTRIG_CONF2_CNF5(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_CNF5) & BM_SDMAARM_XTRIG_CONF2_CNF5)

/*! @brief Set the CNF5 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_CNF5(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_CNF5) | BF_SDMAARM_XTRIG_CONF2_CNF5(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field NUM6[21:16] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_NUM6 (16U)  /*!< Bit position for SDMAARM_XTRIG_CONF2_NUM6. */
#define BM_SDMAARM_XTRIG_CONF2_NUM6 (0x003F0000U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_NUM6. */
#define BS_SDMAARM_XTRIG_CONF2_NUM6 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_NUM6. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_NUM6 field. */
#define BR_SDMAARM_XTRIG_CONF2_NUM6(x) (HW_SDMAARM_XTRIG_CONF2(x).B.NUM6)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_NUM6. */
#define BF_SDMAARM_XTRIG_CONF2_NUM6(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_NUM6) & BM_SDMAARM_XTRIG_CONF2_NUM6)

/*! @brief Set the NUM6 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_NUM6(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_NUM6) | BF_SDMAARM_XTRIG_CONF2_NUM6(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field CNF6[22] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_CNF6 (22U)  /*!< Bit position for SDMAARM_XTRIG_CONF2_CNF6. */
#define BM_SDMAARM_XTRIG_CONF2_CNF6 (0x00400000U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_CNF6. */
#define BS_SDMAARM_XTRIG_CONF2_CNF6 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_CNF6. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_CNF6 field. */
#define BR_SDMAARM_XTRIG_CONF2_CNF6(x) (HW_SDMAARM_XTRIG_CONF2(x).B.CNF6)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_CNF6. */
#define BF_SDMAARM_XTRIG_CONF2_CNF6(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_CNF6) & BM_SDMAARM_XTRIG_CONF2_CNF6)

/*! @brief Set the CNF6 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_CNF6(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_CNF6) | BF_SDMAARM_XTRIG_CONF2_CNF6(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field NUM7[29:24] (RW)
 *
 * Contains the number of the DMA request or channel that triggers the pulse on
 * the cross-trigger event line number i.
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_NUM7 (24U)  /*!< Bit position for SDMAARM_XTRIG_CONF2_NUM7. */
#define BM_SDMAARM_XTRIG_CONF2_NUM7 (0x3F000000U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_NUM7. */
#define BS_SDMAARM_XTRIG_CONF2_NUM7 (6U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_NUM7. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_NUM7 field. */
#define BR_SDMAARM_XTRIG_CONF2_NUM7(x) (HW_SDMAARM_XTRIG_CONF2(x).B.NUM7)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_NUM7. */
#define BF_SDMAARM_XTRIG_CONF2_NUM7(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_NUM7) & BM_SDMAARM_XTRIG_CONF2_NUM7)

/*! @brief Set the NUM7 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_NUM7(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_NUM7) | BF_SDMAARM_XTRIG_CONF2_NUM7(v)))
/*@}*/

/*!
 * @name Register SDMAARM_XTRIG_CONF2, field CNF7[30] (RW)
 *
 * Configuration of the SDMA event line number i that is connected to the
 * cross-trigger. It determines whether the event line pulse is generated by receiving
 * a DMA request or by starting a channel script execution.
 *
 * Values:
 * - 0 - channel
 * - 1 - DMA request
 */
/*@{*/
#define BP_SDMAARM_XTRIG_CONF2_CNF7 (30U)  /*!< Bit position for SDMAARM_XTRIG_CONF2_CNF7. */
#define BM_SDMAARM_XTRIG_CONF2_CNF7 (0x40000000U) /*!< Bit mask for SDMAARM_XTRIG_CONF2_CNF7. */
#define BS_SDMAARM_XTRIG_CONF2_CNF7 (1U)   /*!< Bit field size in bits for SDMAARM_XTRIG_CONF2_CNF7. */

/*! @brief Read current value of the SDMAARM_XTRIG_CONF2_CNF7 field. */
#define BR_SDMAARM_XTRIG_CONF2_CNF7(x) (HW_SDMAARM_XTRIG_CONF2(x).B.CNF7)

/*! @brief Format value for bitfield SDMAARM_XTRIG_CONF2_CNF7. */
#define BF_SDMAARM_XTRIG_CONF2_CNF7(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_XTRIG_CONF2_CNF7) & BM_SDMAARM_XTRIG_CONF2_CNF7)

/*! @brief Set the CNF7 field to a new value. */
#define BW_SDMAARM_XTRIG_CONF2_CNF7(x, v) (HW_SDMAARM_XTRIG_CONF2_WR(x, (HW_SDMAARM_XTRIG_CONF2_RD(x) & ~BM_SDMAARM_XTRIG_CONF2_CNF7) | BF_SDMAARM_XTRIG_CONF2_CNF7(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_SDMA_CHNPRIn - Channel Priority Registers
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_SDMA_CHNPRIn - Channel Priority Registers (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_sdma_chnprin
{
    uint32_t U;
    struct _hw_sdmaarm_sdma_chnprin_bitfields
    {
        uint32_t CHNPRIn : 3;          /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_sdmaarm_sdma_chnprin_t;

/*!
 * @name Constants and macros for entire SDMAARM_SDMA_CHNPRIn register
 */
/*@{*/
#define HW_SDMAARM_SDMA_CHNPRIn_COUNT (32U)

#define HW_SDMAARM_SDMA_CHNPRIn_ADDR(x, n) ((uintptr_t)(x) + 0x100U + (0x4U * (n)))

#define HW_SDMAARM_SDMA_CHNPRIn(x, n) (*(__IO hw_sdmaarm_sdma_chnprin_t *) HW_SDMAARM_SDMA_CHNPRIn_ADDR(x, n))
#define HW_SDMAARM_SDMA_CHNPRIn_RD(x, n) (HW_SDMAARM_SDMA_CHNPRIn(x, n).U)
#define HW_SDMAARM_SDMA_CHNPRIn_WR(x, n, v) (HW_SDMAARM_SDMA_CHNPRIn(x, n).U = (v))
#define HW_SDMAARM_SDMA_CHNPRIn_SET(x, n, v) (HW_SDMAARM_SDMA_CHNPRIn_WR(x, n, HW_SDMAARM_SDMA_CHNPRIn_RD(x, n) |  (v)))
#define HW_SDMAARM_SDMA_CHNPRIn_CLR(x, n, v) (HW_SDMAARM_SDMA_CHNPRIn_WR(x, n, HW_SDMAARM_SDMA_CHNPRIn_RD(x, n) & ~(v)))
#define HW_SDMAARM_SDMA_CHNPRIn_TOG(x, n, v) (HW_SDMAARM_SDMA_CHNPRIn_WR(x, n, HW_SDMAARM_SDMA_CHNPRIn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_SDMA_CHNPRIn bitfields
 */

/*!
 * @name Register SDMAARM_SDMA_CHNPRIn, field CHNPRIn[2:0] (RW)
 *
 * This contains the priority of channel number n. Useful values are between 1
 * and 7; 0 is reserved by the SDMA hardware to determine when there is no pending
 * channel. Reset value is 0, which prevents the channels from starting.
 */
/*@{*/
#define BP_SDMAARM_SDMA_CHNPRIn_CHNPRIn (0U) /*!< Bit position for SDMAARM_SDMA_CHNPRIn_CHNPRIn. */
#define BM_SDMAARM_SDMA_CHNPRIn_CHNPRIn (0x00000007U) /*!< Bit mask for SDMAARM_SDMA_CHNPRIn_CHNPRIn. */
#define BS_SDMAARM_SDMA_CHNPRIn_CHNPRIn (3U) /*!< Bit field size in bits for SDMAARM_SDMA_CHNPRIn_CHNPRIn. */

/*! @brief Read current value of the SDMAARM_SDMA_CHNPRIn_CHNPRIn field. */
#define BR_SDMAARM_SDMA_CHNPRIn_CHNPRIn(x, n) (HW_SDMAARM_SDMA_CHNPRIn(x, n).B.CHNPRIn)

/*! @brief Format value for bitfield SDMAARM_SDMA_CHNPRIn_CHNPRIn. */
#define BF_SDMAARM_SDMA_CHNPRIn_CHNPRIn(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_SDMA_CHNPRIn_CHNPRIn) & BM_SDMAARM_SDMA_CHNPRIn_CHNPRIn)

/*! @brief Set the CHNPRIn field to a new value. */
#define BW_SDMAARM_SDMA_CHNPRIn_CHNPRIn(x, n, v) (HW_SDMAARM_SDMA_CHNPRIn_WR(x, n, (HW_SDMAARM_SDMA_CHNPRIn_RD(x, n) & ~BM_SDMAARM_SDMA_CHNPRIn_CHNPRIn) | BF_SDMAARM_SDMA_CHNPRIn_CHNPRIn(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMAARM_CHNENBLn - Channel Enable RAM
 ******************************************************************************/

/*!
 * @brief HW_SDMAARM_CHNENBLn - Channel Enable RAM (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmaarm_chnenbln
{
    uint32_t U;
    struct _hw_sdmaarm_chnenbln_bitfields
    {
        uint32_t ENBLn : 32;           /*!< [31:0]  */
    } B;
} hw_sdmaarm_chnenbln_t;

/*!
 * @name Constants and macros for entire SDMAARM_CHNENBLn register
 */
/*@{*/
#define HW_SDMAARM_CHNENBLn_COUNT (48U)

#define HW_SDMAARM_CHNENBLn_ADDR(x, n) ((uintptr_t)(x) + 0x200U + (0x4U * (n)))

#define HW_SDMAARM_CHNENBLn(x, n) (*(__IO hw_sdmaarm_chnenbln_t *) HW_SDMAARM_CHNENBLn_ADDR(x, n))
#define HW_SDMAARM_CHNENBLn_RD(x, n) (HW_SDMAARM_CHNENBLn(x, n).U)
#define HW_SDMAARM_CHNENBLn_WR(x, n, v) (HW_SDMAARM_CHNENBLn(x, n).U = (v))
#define HW_SDMAARM_CHNENBLn_SET(x, n, v) (HW_SDMAARM_CHNENBLn_WR(x, n, HW_SDMAARM_CHNENBLn_RD(x, n) |  (v)))
#define HW_SDMAARM_CHNENBLn_CLR(x, n, v) (HW_SDMAARM_CHNENBLn_WR(x, n, HW_SDMAARM_CHNENBLn_RD(x, n) & ~(v)))
#define HW_SDMAARM_CHNENBLn_TOG(x, n, v) (HW_SDMAARM_CHNENBLn_WR(x, n, HW_SDMAARM_CHNENBLn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMAARM_CHNENBLn bitfields
 */

/*!
 * @name Register SDMAARM_CHNENBLn, field ENBLn[31:0] (RW)
 *
 * This 32-bit value selects the channels that are triggered by the DMA request
 * number n. If ENBLn[i] is set to 1, bit EP[i] will be set when the DMA request
 * n is received. These 48 32-bit registers are physically located in a RAM, with
 * no known reset value. It is thus essential for the ARM platform to program
 * them before any DMA request is triggered to the SDMA, otherwise an unpredictable
 * combination of channels may be started.
 */
/*@{*/
#define BP_SDMAARM_CHNENBLn_ENBLn (0U)     /*!< Bit position for SDMAARM_CHNENBLn_ENBLn. */
#define BM_SDMAARM_CHNENBLn_ENBLn (0xFFFFFFFFU) /*!< Bit mask for SDMAARM_CHNENBLn_ENBLn. */
#define BS_SDMAARM_CHNENBLn_ENBLn (32U)    /*!< Bit field size in bits for SDMAARM_CHNENBLn_ENBLn. */

/*! @brief Read current value of the SDMAARM_CHNENBLn_ENBLn field. */
#define BR_SDMAARM_CHNENBLn_ENBLn(x, n) (HW_SDMAARM_CHNENBLn(x, n).U)

/*! @brief Format value for bitfield SDMAARM_CHNENBLn_ENBLn. */
#define BF_SDMAARM_CHNENBLn_ENBLn(v) ((uint32_t)((uint32_t)(v) << BP_SDMAARM_CHNENBLn_ENBLn) & BM_SDMAARM_CHNENBLn_ENBLn)

/*! @brief Set the ENBLn field to a new value. */
#define BW_SDMAARM_CHNENBLn_ENBLn(x, n, v) (HW_SDMAARM_CHNENBLn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * hw_sdmaarm_t - module struct
 ******************************************************************************/
/*!
 * @brief All SDMAARM module registers.
 */
#pragma pack(1)
typedef struct _hw_sdmaarm
{
    __IO hw_sdmaarm_mc0ptr_t MC0PTR;       /*!< [0x0] ARM platform Channel 0 Pointer */
    __IO hw_sdmaarm_intr_t INTR;           /*!< [0x4] Channel Interrupts */
    __IO hw_sdmaarm_stop_stat_t STOP_STAT; /*!< [0x8] Channel Stop/Channel Status */
    __IO hw_sdmaarm_hstart_t HSTART;       /*!< [0xC] Channel Start */
    __IO hw_sdmaarm_evtovr_t EVTOVR;       /*!< [0x10] Channel Event Override */
    __IO hw_sdmaarm_dspovr_t DSPOVR;       /*!< [0x14] Channel BP Override */
    __IO hw_sdmaarm_hostovr_t HOSTOVR;     /*!< [0x18] Channel ARM platform Override */
    __IO hw_sdmaarm_evtpend_t EVTPEND;     /*!< [0x1C] Channel Event Pending */
    uint8_t _reserved0[4];
    __I hw_sdmaarm_reset_t RESET;          /*!< [0x24] Reset Register */
    __I hw_sdmaarm_evterr_t EVTERR;        /*!< [0x28] DMA Request Error Register */
    __IO hw_sdmaarm_intrmask_t INTRMASK;   /*!< [0x2C] Channel ARM platform Interrupt Mask */
    __I hw_sdmaarm_psw_t PSW;              /*!< [0x30] Schedule Status */
    __I hw_sdmaarm_evterrdbg_t EVTERRDBG;  /*!< [0x34] DMA Request Error Register */
    __IO hw_sdmaarm_config_t CONFIG;       /*!< [0x38] Configuration Register */
    __IO hw_sdmaarm_sdma_lock_t SDMA_LOCK; /*!< [0x3C] SDMA LOCK */
    __IO hw_sdmaarm_once_enb_t ONCE_ENB;   /*!< [0x40] OnCE Enable */
    __IO hw_sdmaarm_once_data_t ONCE_DATA; /*!< [0x44] OnCE Data Register */
    __IO hw_sdmaarm_once_instr_t ONCE_INSTR; /*!< [0x48] OnCE Instruction Register */
    __I hw_sdmaarm_once_stat_t ONCE_STAT;  /*!< [0x4C] OnCE Status Register */
    __IO hw_sdmaarm_once_cmd_t ONCE_CMD;   /*!< [0x50] OnCE Command Register */
    uint8_t _reserved1[4];
    __IO hw_sdmaarm_illinstaddr_t ILLINSTADDR; /*!< [0x58] Illegal Instruction Trap Address */
    __IO hw_sdmaarm_chn0addr_t CHN0ADDR;   /*!< [0x5C] Channel 0 Boot Address */
    __I hw_sdmaarm_evt_mirror_t EVT_MIRROR; /*!< [0x60] DMA Requests */
    __I hw_sdmaarm_evt_mirror2_t EVT_MIRROR2; /*!< [0x64] DMA Requests 2 */
    uint8_t _reserved2[8];
    __IO hw_sdmaarm_xtrig_conf1_t XTRIG_CONF1; /*!< [0x70] Cross-Trigger Events Configuration Register 1 */
    __IO hw_sdmaarm_xtrig_conf2_t XTRIG_CONF2; /*!< [0x74] Cross-Trigger Events Configuration Register 2 */
    uint8_t _reserved3[136];
    __IO hw_sdmaarm_sdma_chnprin_t SDMA_CHNPRIn[32]; /*!< [0x100] Channel Priority Registers */
    uint8_t _reserved4[128];
    __IO hw_sdmaarm_chnenbln_t CHNENBLn[48]; /*!< [0x200] Channel Enable RAM */
} hw_sdmaarm_t;
#pragma pack()

/*! @brief Macro to access all SDMAARM registers. */
/*! @param x SDMAARM module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SDMAARM_REGS(SDMAARM_BASE)</code>. */
#define HW_SDMAARM_REGS(x) (*(hw_sdmaarm_t *)(x))

/*
 * iMX6DP SDMABP
 *
 * SDMA
 *
 * Registers defined in this header file:
 * - HW_SDMABP_DC0PTR - Channel 0 Pointer
 * - HW_SDMABP_INTR - Channel Interrupts
 * - HW_SDMABP_STOP_STAT - Channel Stop/Channel Status
 * - HW_SDMABP_DSTART - Channel Start
 * - HW_SDMABP_EVTERR - DMA Request Error Register
 * - HW_SDMABP_INTRMASK - Channel DSP Interrupt Mask
 * - HW_SDMABP_EVTERRDBG - DMA Request Error Register
 *
 * - hw_sdmabp_t - Struct containing all module registers.
 */

#define HW_SDMABP_INSTANCE_COUNT (1U) /*!< Number of instances of the SDMABP module. */
#define HW_SDMABP (0U) /*!< Instance number for SDMABP. */
#define SDMABP_BASE           (0x20EC000U) /*!< Base address for SDMABP. */
/*! Array initializer of SDMABP base addresses. */
#define SDMABP_BASE_ADDRS     { SDMABP_BASE }

/*******************************************************************************
 * HW_SDMABP_DC0PTR - Channel 0 Pointer
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_DC0PTR - Channel 0 Pointer (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_dc0ptr
{
    uint32_t U;
    struct _hw_sdmabp_dc0ptr_bitfields
    {
        uint32_t DC0PTR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmabp_dc0ptr_t;

/*!
 * @name Constants and macros for entire SDMABP_DC0PTR register
 */
/*@{*/
#define HW_SDMABP_DC0PTR_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_SDMABP_DC0PTR(x)      (*(__IO hw_sdmabp_dc0ptr_t *) HW_SDMABP_DC0PTR_ADDR(x))
#define HW_SDMABP_DC0PTR_RD(x)   (HW_SDMABP_DC0PTR(x).U)
#define HW_SDMABP_DC0PTR_WR(x, v) (HW_SDMABP_DC0PTR(x).U = (v))
#define HW_SDMABP_DC0PTR_SET(x, v) (HW_SDMABP_DC0PTR_WR(x, HW_SDMABP_DC0PTR_RD(x) |  (v)))
#define HW_SDMABP_DC0PTR_CLR(x, v) (HW_SDMABP_DC0PTR_WR(x, HW_SDMABP_DC0PTR_RD(x) & ~(v)))
#define HW_SDMABP_DC0PTR_TOG(x, v) (HW_SDMABP_DC0PTR_WR(x, HW_SDMABP_DC0PTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMABP_DC0PTR bitfields
 */

/*!
 * @name Register SDMABP_DC0PTR, field DC0PTR[31:0] (RW)
 *
 * Channel 0 Pointer contains the 32-bit address, in BP memory, of the array of
 * channel control blocks starting with the one for channel 0 (the control
 * channel). This register should be initialized by the BP before it enables a channel
 * (for example, channel 0). See the API document SDMA Scripts User Manual for
 * the use of this register. The BP has a read/write access and the SDMA has a
 * read-only access.
 */
/*@{*/
#define BP_SDMABP_DC0PTR_DC0PTR (0U)       /*!< Bit position for SDMABP_DC0PTR_DC0PTR. */
#define BM_SDMABP_DC0PTR_DC0PTR (0xFFFFFFFFU) /*!< Bit mask for SDMABP_DC0PTR_DC0PTR. */
#define BS_SDMABP_DC0PTR_DC0PTR (32U)      /*!< Bit field size in bits for SDMABP_DC0PTR_DC0PTR. */

/*! @brief Read current value of the SDMABP_DC0PTR_DC0PTR field. */
#define BR_SDMABP_DC0PTR_DC0PTR(x) (HW_SDMABP_DC0PTR(x).U)

/*! @brief Format value for bitfield SDMABP_DC0PTR_DC0PTR. */
#define BF_SDMABP_DC0PTR_DC0PTR(v) ((uint32_t)((uint32_t)(v) << BP_SDMABP_DC0PTR_DC0PTR) & BM_SDMABP_DC0PTR_DC0PTR)

/*! @brief Set the DC0PTR field to a new value. */
#define BW_SDMABP_DC0PTR_DC0PTR(x, v) (HW_SDMABP_DC0PTR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMABP_INTR - Channel Interrupts
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_INTR - Channel Interrupts (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_intr
{
    uint32_t U;
    struct _hw_sdmabp_intr_bitfields
    {
        uint32_t DI : 32;              /*!< [31:0]  */
    } B;
} hw_sdmabp_intr_t;

/*!
 * @name Constants and macros for entire SDMABP_INTR register
 */
/*@{*/
#define HW_SDMABP_INTR_ADDR(x)   ((uintptr_t)(x) + 0x4U)

#define HW_SDMABP_INTR(x)        (*(__IO hw_sdmabp_intr_t *) HW_SDMABP_INTR_ADDR(x))
#define HW_SDMABP_INTR_RD(x)     (HW_SDMABP_INTR(x).U)
#define HW_SDMABP_INTR_WR(x, v)  (HW_SDMABP_INTR(x).U = (v))
#define HW_SDMABP_INTR_SET(x, v) (HW_SDMABP_INTR_WR(x, HW_SDMABP_INTR_RD(x) |  (v)))
#define HW_SDMABP_INTR_CLR(x, v) (HW_SDMABP_INTR_WR(x, HW_SDMABP_INTR_RD(x) & ~(v)))
#define HW_SDMABP_INTR_TOG(x, v) (HW_SDMABP_INTR_WR(x, HW_SDMABP_INTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMABP_INTR bitfields
 */

/*!
 * @name Register SDMABP_INTR, field DI[31:0] (W1C)
 *
 * The BP Interrupts register contains the 32 DI[i] bits. If any bit is set, it
 * will cause an interrupt to the BP. This register is a "write-ones" register to
 * the BP. When the BP sets a bit in this register, the corresponding DI[i] bit
 * is cleared. The interrupt service routine should clear individual channel bits
 * when their interrupts are serviced; failure to do so will cause continuous
 * interrupts. The SDMA is responsible for setting the DI[i] bit corresponding to
 * the current channel when the corresponding done instruction is executed.
 */
/*@{*/
#define BP_SDMABP_INTR_DI    (0U)          /*!< Bit position for SDMABP_INTR_DI. */
#define BM_SDMABP_INTR_DI    (0xFFFFFFFFU) /*!< Bit mask for SDMABP_INTR_DI. */
#define BS_SDMABP_INTR_DI    (32U)         /*!< Bit field size in bits for SDMABP_INTR_DI. */

/*! @brief Read current value of the SDMABP_INTR_DI field. */
#define BR_SDMABP_INTR_DI(x) (HW_SDMABP_INTR(x).U)

/*! @brief Format value for bitfield SDMABP_INTR_DI. */
#define BF_SDMABP_INTR_DI(v) ((uint32_t)((uint32_t)(v) << BP_SDMABP_INTR_DI) & BM_SDMABP_INTR_DI)

/*! @brief Set the DI field to a new value. */
#define BW_SDMABP_INTR_DI(x, v) (HW_SDMABP_INTR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMABP_STOP_STAT - Channel Stop/Channel Status
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_STOP_STAT - Channel Stop/Channel Status (W1C)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_stop_stat
{
    uint32_t U;
    struct _hw_sdmabp_stop_stat_bitfields
    {
        uint32_t DE : 32;              /*!< [31:0]  */
    } B;
} hw_sdmabp_stop_stat_t;

/*!
 * @name Constants and macros for entire SDMABP_STOP_STAT register
 */
/*@{*/
#define HW_SDMABP_STOP_STAT_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_SDMABP_STOP_STAT(x)   (*(__IO hw_sdmabp_stop_stat_t *) HW_SDMABP_STOP_STAT_ADDR(x))
#define HW_SDMABP_STOP_STAT_RD(x) (HW_SDMABP_STOP_STAT(x).U)
#define HW_SDMABP_STOP_STAT_WR(x, v) (HW_SDMABP_STOP_STAT(x).U = (v))
#define HW_SDMABP_STOP_STAT_SET(x, v) (HW_SDMABP_STOP_STAT_WR(x, HW_SDMABP_STOP_STAT_RD(x) |  (v)))
#define HW_SDMABP_STOP_STAT_CLR(x, v) (HW_SDMABP_STOP_STAT_WR(x, HW_SDMABP_STOP_STAT_RD(x) & ~(v)))
#define HW_SDMABP_STOP_STAT_TOG(x, v) (HW_SDMABP_STOP_STAT_WR(x, HW_SDMABP_STOP_STAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMABP_STOP_STAT bitfields
 */

/*!
 * @name Register SDMABP_STOP_STAT, field DE[31:0] (W1C)
 *
 * This 32-bit register gives access to the BP (DSP) Enable bits, DE. There is
 * one bit for every channel. This register is a "write-ones" register to the BP.
 * When the BP writes 1 in bit i of this register, it clears the DE[i] and
 * DSTART[i] bits. Reading this register yields the current state of the DE[i] bits.
 */
/*@{*/
#define BP_SDMABP_STOP_STAT_DE (0U)        /*!< Bit position for SDMABP_STOP_STAT_DE. */
#define BM_SDMABP_STOP_STAT_DE (0xFFFFFFFFU) /*!< Bit mask for SDMABP_STOP_STAT_DE. */
#define BS_SDMABP_STOP_STAT_DE (32U)       /*!< Bit field size in bits for SDMABP_STOP_STAT_DE. */

/*! @brief Read current value of the SDMABP_STOP_STAT_DE field. */
#define BR_SDMABP_STOP_STAT_DE(x) (HW_SDMABP_STOP_STAT(x).U)

/*! @brief Format value for bitfield SDMABP_STOP_STAT_DE. */
#define BF_SDMABP_STOP_STAT_DE(v) ((uint32_t)((uint32_t)(v) << BP_SDMABP_STOP_STAT_DE) & BM_SDMABP_STOP_STAT_DE)

/*! @brief Set the DE field to a new value. */
#define BW_SDMABP_STOP_STAT_DE(x, v) (HW_SDMABP_STOP_STAT_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMABP_DSTART - Channel Start
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_DSTART - Channel Start (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_dstart
{
    uint32_t U;
    struct _hw_sdmabp_dstart_bitfields
    {
        uint32_t DSTART_DE : 32;       /*!< [31:0]  */
    } B;
} hw_sdmabp_dstart_t;

/*!
 * @name Constants and macros for entire SDMABP_DSTART register
 */
/*@{*/
#define HW_SDMABP_DSTART_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_SDMABP_DSTART(x)      (*(__I hw_sdmabp_dstart_t *) HW_SDMABP_DSTART_ADDR(x))
#define HW_SDMABP_DSTART_RD(x)   (HW_SDMABP_DSTART(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMABP_DSTART bitfields
 */

/*!
 * @name Register SDMABP_DSTART, field DSTART_DE[31:0] (RO)
 *
 * The DSTART_DE registers are 32 bits wide with one bit for every channel. When
 * a bit is written to 1, it enables the corresponding channel. Two physical
 * registers are accessed with that address (DSTART and DE), which enables the BP to
 * trigger a channel a second time before the first trigger was processed. This
 * register is a "write-ones" register to the BP. Neither DSTART[i] bit can be
 * set while the corresponding DE[i] bit is cleared. When the BP tries to set the
 * DSTART[i] bit by writing a one (if the corresponding DE[i] bit is clear), the
 * bit in the DSTART[i] register will remain cleared and the DE[i] bit will be
 * set. If the corresponding DE[i] bit was already set, the DSTART[i] bit will be
 * set. The next time the SDMA channel i attempts to clear the DE[i] bit by means
 * of a done instruction, the bit in the DSTART[i] register will be cleared and
 * the DE[i] bit will take the old value of the DSTART[i] bit. Reading this
 * register yields the current state of the DSTART[i] bits. This mechanism enables the
 * BP to pipeline two DSTART commands per channel.
 */
/*@{*/
#define BP_SDMABP_DSTART_DSTART_DE (0U)    /*!< Bit position for SDMABP_DSTART_DSTART_DE. */
#define BM_SDMABP_DSTART_DSTART_DE (0xFFFFFFFFU) /*!< Bit mask for SDMABP_DSTART_DSTART_DE. */
#define BS_SDMABP_DSTART_DSTART_DE (32U)   /*!< Bit field size in bits for SDMABP_DSTART_DSTART_DE. */

/*! @brief Read current value of the SDMABP_DSTART_DSTART_DE field. */
#define BR_SDMABP_DSTART_DSTART_DE(x) (HW_SDMABP_DSTART(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMABP_EVTERR - DMA Request Error Register
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_EVTERR - DMA Request Error Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_evterr
{
    uint32_t U;
    struct _hw_sdmabp_evterr_bitfields
    {
        uint32_t CHNERR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmabp_evterr_t;

/*!
 * @name Constants and macros for entire SDMABP_EVTERR register
 */
/*@{*/
#define HW_SDMABP_EVTERR_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_SDMABP_EVTERR(x)      (*(__I hw_sdmabp_evterr_t *) HW_SDMABP_EVTERR_ADDR(x))
#define HW_SDMABP_EVTERR_RD(x)   (HW_SDMABP_EVTERR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMABP_EVTERR bitfields
 */

/*!
 * @name Register SDMABP_EVTERR, field CHNERR[31:0] (RO)
 *
 * This register is used by the SDMA to warn the BP when an incoming DMA request
 * was detected; it then triggers a channel that is already pending or being
 * serviced, which may mean there is an overflow of data for that channel. An
 * interrupt is sent to the BP if the corresponding channel bit is set in the INTRMASK
 * register. This is a "write-ones" register for the scheduler. It is only able
 * to set the flags. The flags are cleared when the register is read by the BP or
 * during an SDMA reset. The CHNERR[i] bit is set when a DMA request that
 * triggers channel i is received through the corresponding input pins and the EP[i] bit
 * is already set. The EVTERR[i] bit is unaffected if the BP tries to set the
 * EP[i] bit when that EP[i] bit is already set.
 */
/*@{*/
#define BP_SDMABP_EVTERR_CHNERR (0U)       /*!< Bit position for SDMABP_EVTERR_CHNERR. */
#define BM_SDMABP_EVTERR_CHNERR (0xFFFFFFFFU) /*!< Bit mask for SDMABP_EVTERR_CHNERR. */
#define BS_SDMABP_EVTERR_CHNERR (32U)      /*!< Bit field size in bits for SDMABP_EVTERR_CHNERR. */

/*! @brief Read current value of the SDMABP_EVTERR_CHNERR field. */
#define BR_SDMABP_EVTERR_CHNERR(x) (HW_SDMABP_EVTERR(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMABP_INTRMASK - Channel DSP Interrupt Mask
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_INTRMASK - Channel DSP Interrupt Mask (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_intrmask
{
    uint32_t U;
    struct _hw_sdmabp_intrmask_bitfields
    {
        uint32_t DIMASK : 32;          /*!< [31:0]  */
    } B;
} hw_sdmabp_intrmask_t;

/*!
 * @name Constants and macros for entire SDMABP_INTRMASK register
 */
/*@{*/
#define HW_SDMABP_INTRMASK_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_SDMABP_INTRMASK(x)    (*(__IO hw_sdmabp_intrmask_t *) HW_SDMABP_INTRMASK_ADDR(x))
#define HW_SDMABP_INTRMASK_RD(x) (HW_SDMABP_INTRMASK(x).U)
#define HW_SDMABP_INTRMASK_WR(x, v) (HW_SDMABP_INTRMASK(x).U = (v))
#define HW_SDMABP_INTRMASK_SET(x, v) (HW_SDMABP_INTRMASK_WR(x, HW_SDMABP_INTRMASK_RD(x) |  (v)))
#define HW_SDMABP_INTRMASK_CLR(x, v) (HW_SDMABP_INTRMASK_WR(x, HW_SDMABP_INTRMASK_RD(x) & ~(v)))
#define HW_SDMABP_INTRMASK_TOG(x, v) (HW_SDMABP_INTRMASK_WR(x, HW_SDMABP_INTRMASK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMABP_INTRMASK bitfields
 */

/*!
 * @name Register SDMABP_INTRMASK, field DIMASK[31:0] (RW)
 *
 * The Interrupt Mask Register contains 32 interrupt generation mask bits. If
 * bit DIMASK[i] is set, the DI[i] bit is set and an interrupt is sent to the BP
 * when a DMA request error is detected on channel i (for example, EVTERR[i] is
 * set).
 */
/*@{*/
#define BP_SDMABP_INTRMASK_DIMASK (0U)     /*!< Bit position for SDMABP_INTRMASK_DIMASK. */
#define BM_SDMABP_INTRMASK_DIMASK (0xFFFFFFFFU) /*!< Bit mask for SDMABP_INTRMASK_DIMASK. */
#define BS_SDMABP_INTRMASK_DIMASK (32U)    /*!< Bit field size in bits for SDMABP_INTRMASK_DIMASK. */

/*! @brief Read current value of the SDMABP_INTRMASK_DIMASK field. */
#define BR_SDMABP_INTRMASK_DIMASK(x) (HW_SDMABP_INTRMASK(x).U)

/*! @brief Format value for bitfield SDMABP_INTRMASK_DIMASK. */
#define BF_SDMABP_INTRMASK_DIMASK(v) ((uint32_t)((uint32_t)(v) << BP_SDMABP_INTRMASK_DIMASK) & BM_SDMABP_INTRMASK_DIMASK)

/*! @brief Set the DIMASK field to a new value. */
#define BW_SDMABP_INTRMASK_DIMASK(x, v) (HW_SDMABP_INTRMASK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMABP_EVTERRDBG - DMA Request Error Register
 ******************************************************************************/

/*!
 * @brief HW_SDMABP_EVTERRDBG - DMA Request Error Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmabp_evterrdbg
{
    uint32_t U;
    struct _hw_sdmabp_evterrdbg_bitfields
    {
        uint32_t CHNERR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmabp_evterrdbg_t;

/*!
 * @name Constants and macros for entire SDMABP_EVTERRDBG register
 */
/*@{*/
#define HW_SDMABP_EVTERRDBG_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_SDMABP_EVTERRDBG(x)   (*(__I hw_sdmabp_evterrdbg_t *) HW_SDMABP_EVTERRDBG_ADDR(x))
#define HW_SDMABP_EVTERRDBG_RD(x) (HW_SDMABP_EVTERRDBG(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMABP_EVTERRDBG bitfields
 */

/*!
 * @name Register SDMABP_EVTERRDBG, field CHNERR[31:0] (RO)
 *
 * This register is the same as EVTERR except reading it does not clear its
 * contents. This address is meant to be used in debug mode. The BP OnCE may check
 * this register value without modifying it.
 */
/*@{*/
#define BP_SDMABP_EVTERRDBG_CHNERR (0U)    /*!< Bit position for SDMABP_EVTERRDBG_CHNERR. */
#define BM_SDMABP_EVTERRDBG_CHNERR (0xFFFFFFFFU) /*!< Bit mask for SDMABP_EVTERRDBG_CHNERR. */
#define BS_SDMABP_EVTERRDBG_CHNERR (32U)   /*!< Bit field size in bits for SDMABP_EVTERRDBG_CHNERR. */

/*! @brief Read current value of the SDMABP_EVTERRDBG_CHNERR field. */
#define BR_SDMABP_EVTERRDBG_CHNERR(x) (HW_SDMABP_EVTERRDBG(x).U)
/*@}*/

/*******************************************************************************
 * hw_sdmabp_t - module struct
 ******************************************************************************/
/*!
 * @brief All SDMABP module registers.
 */
#pragma pack(1)
typedef struct _hw_sdmabp
{
    __IO hw_sdmabp_dc0ptr_t DC0PTR;        /*!< [0x0] Channel 0 Pointer */
    __IO hw_sdmabp_intr_t INTR;            /*!< [0x4] Channel Interrupts */
    __IO hw_sdmabp_stop_stat_t STOP_STAT;  /*!< [0x8] Channel Stop/Channel Status */
    __I hw_sdmabp_dstart_t DSTART;         /*!< [0xC] Channel Start */
    uint8_t _reserved0[24];
    __I hw_sdmabp_evterr_t EVTERR;         /*!< [0x28] DMA Request Error Register */
    __IO hw_sdmabp_intrmask_t INTRMASK;    /*!< [0x2C] Channel DSP Interrupt Mask */
    uint8_t _reserved1[4];
    __I hw_sdmabp_evterrdbg_t EVTERRDBG;   /*!< [0x34] DMA Request Error Register */
} hw_sdmabp_t;
#pragma pack()

/*! @brief Macro to access all SDMABP registers. */
/*! @param x SDMABP module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SDMABP_REGS(SDMABP_BASE)</code>. */
#define HW_SDMABP_REGS(x) (*(hw_sdmabp_t *)(x))

/*
 * iMX6DP SDMACORE
 *
 * SDMA
 *
 * Registers defined in this header file:
 * - HW_SDMACORE_MC0PTR - ARM platform Channel 0 Pointer
 * - HW_SDMACORE_CCPTR - Current Channel Pointer
 * - HW_SDMACORE_CCR - Current Channel Register
 * - HW_SDMACORE_NCR - Highest Pending Channel Register
 * - HW_SDMACORE_EVENTS - External DMA Requests Mirror
 * - HW_SDMACORE_CCPRI - Current Channel Priority
 * - HW_SDMACORE_NCPRI - Next Channel Priority
 * - HW_SDMACORE_ECOUNT - OnCE Event Cell Counter
 * - HW_SDMACORE_ECTL - OnCE Event Cell Control Register
 * - HW_SDMACORE_EAA - OnCE Event Address Register A
 * - HW_SDMACORE_EAB - OnCE Event Cell Address Register B
 * - HW_SDMACORE_EAM - OnCE Event Cell Address Mask
 * - HW_SDMACORE_ED - OnCE Event Cell Data Register
 * - HW_SDMACORE_EDM - OnCE Event Cell Data Mask
 * - HW_SDMACORE_RTB - OnCE Real-Time Buffer
 * - HW_SDMACORE_TB - OnCE Trace Buffer
 * - HW_SDMACORE_OSTAT - OnCE Status
 * - HW_SDMACORE_MCHN0ADDR - Channel 0 Boot Address
 * - HW_SDMACORE_ENDIANNESS - ENDIAN Status Register
 * - HW_SDMACORE_SDMA_LOCK - Lock Status Register
 * - HW_SDMACORE_EVENTS2 - External DMA Requests Mirror #2
 *
 * - hw_sdmacore_t - Struct containing all module registers.
 */

#define HW_SDMACORE_INSTANCE_COUNT (1U) /*!< Number of instances of the SDMACORE module. */
#define HW_SDMACORE (0U) /*!< Instance number for SDMACORE. */
#define SDMACORE_BASE         (0x20EC000U) /*!< Base address for SDMACORE. */
/*! Array initializer of SDMACORE base addresses. */
#define SDMACORE_BASE_ADDRS   { SDMACORE_BASE }

/*******************************************************************************
 * HW_SDMACORE_MC0PTR - ARM platform Channel 0 Pointer
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_MC0PTR - ARM platform Channel 0 Pointer (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_mc0ptr
{
    uint32_t U;
    struct _hw_sdmacore_mc0ptr_bitfields
    {
        uint32_t MC0PTR : 32;          /*!< [31:0]  */
    } B;
} hw_sdmacore_mc0ptr_t;

/*!
 * @name Constants and macros for entire SDMACORE_MC0PTR register
 */
/*@{*/
#define HW_SDMACORE_MC0PTR_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_SDMACORE_MC0PTR(x)    (*(__I hw_sdmacore_mc0ptr_t *) HW_SDMACORE_MC0PTR_ADDR(x))
#define HW_SDMACORE_MC0PTR_RD(x) (HW_SDMACORE_MC0PTR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_MC0PTR bitfields
 */

/*!
 * @name Register SDMACORE_MC0PTR, field MC0PTR[31:0] (RO)
 *
 * Contains the address-in the ARM platform memory space-of the initial SDMA
 * context and scripts that are loaded by the SDMA boot script running on channel 0.
 */
/*@{*/
#define BP_SDMACORE_MC0PTR_MC0PTR (0U)     /*!< Bit position for SDMACORE_MC0PTR_MC0PTR. */
#define BM_SDMACORE_MC0PTR_MC0PTR (0xFFFFFFFFU) /*!< Bit mask for SDMACORE_MC0PTR_MC0PTR. */
#define BS_SDMACORE_MC0PTR_MC0PTR (32U)    /*!< Bit field size in bits for SDMACORE_MC0PTR_MC0PTR. */

/*! @brief Read current value of the SDMACORE_MC0PTR_MC0PTR field. */
#define BR_SDMACORE_MC0PTR_MC0PTR(x) (HW_SDMACORE_MC0PTR(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_CCPTR - Current Channel Pointer
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_CCPTR - Current Channel Pointer (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ccptr
{
    uint32_t U;
    struct _hw_sdmacore_ccptr_bitfields
    {
        uint32_t CCPTR : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_ccptr_t;

/*!
 * @name Constants and macros for entire SDMACORE_CCPTR register
 */
/*@{*/
#define HW_SDMACORE_CCPTR_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_SDMACORE_CCPTR(x)     (*(__I hw_sdmacore_ccptr_t *) HW_SDMACORE_CCPTR_ADDR(x))
#define HW_SDMACORE_CCPTR_RD(x)  (HW_SDMACORE_CCPTR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_CCPTR bitfields
 */

/*!
 * @name Register SDMACORE_CCPTR, field CCPTR[15:0] (RO)
 *
 * Contains the start address of the context data for the current channel: Its
 * value is CONTEXT_BASE + 24* CCR or CONTEXT_BASE + 32* CCR where CONTEXT_BASE =
 * 0x0800. The value 24 or 32 is selected according to the programmed channel
 * scratch RAM size in the register shown in CHN0ADDRChannel 0 Boot Address .
 */
/*@{*/
#define BP_SDMACORE_CCPTR_CCPTR (0U)       /*!< Bit position for SDMACORE_CCPTR_CCPTR. */
#define BM_SDMACORE_CCPTR_CCPTR (0x0000FFFFU) /*!< Bit mask for SDMACORE_CCPTR_CCPTR. */
#define BS_SDMACORE_CCPTR_CCPTR (16U)      /*!< Bit field size in bits for SDMACORE_CCPTR_CCPTR. */

/*! @brief Read current value of the SDMACORE_CCPTR_CCPTR field. */
#define BR_SDMACORE_CCPTR_CCPTR(x) (HW_SDMACORE_CCPTR(x).B.CCPTR)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_CCR - Current Channel Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_CCR - Current Channel Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ccr
{
    uint32_t U;
    struct _hw_sdmacore_ccr_bitfields
    {
        uint32_t CCR : 5;              /*!< [4:0]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_sdmacore_ccr_t;

/*!
 * @name Constants and macros for entire SDMACORE_CCR register
 */
/*@{*/
#define HW_SDMACORE_CCR_ADDR(x)  ((uintptr_t)(x) + 0x8U)

#define HW_SDMACORE_CCR(x)       (*(__I hw_sdmacore_ccr_t *) HW_SDMACORE_CCR_ADDR(x))
#define HW_SDMACORE_CCR_RD(x)    (HW_SDMACORE_CCR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_CCR bitfields
 */

/*!
 * @name Register SDMACORE_CCR, field CCR[4:0] (RO)
 *
 * Contains the number of the current running channel whose context is
 * installed. In the case that the SDMA has finished running the channel and has entered
 * sleep state, CCR will indicate the previous running channel. The PST bits in
 * the OSTAT register indicate when the SDMA is in sleep state.
 */
/*@{*/
#define BP_SDMACORE_CCR_CCR  (0U)          /*!< Bit position for SDMACORE_CCR_CCR. */
#define BM_SDMACORE_CCR_CCR  (0x0000001FU) /*!< Bit mask for SDMACORE_CCR_CCR. */
#define BS_SDMACORE_CCR_CCR  (5U)          /*!< Bit field size in bits for SDMACORE_CCR_CCR. */

/*! @brief Read current value of the SDMACORE_CCR_CCR field. */
#define BR_SDMACORE_CCR_CCR(x) (HW_SDMACORE_CCR(x).B.CCR)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_NCR - Highest Pending Channel Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_NCR - Highest Pending Channel Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ncr
{
    uint32_t U;
    struct _hw_sdmacore_ncr_bitfields
    {
        uint32_t NCR : 5;              /*!< [4:0]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_sdmacore_ncr_t;

/*!
 * @name Constants and macros for entire SDMACORE_NCR register
 */
/*@{*/
#define HW_SDMACORE_NCR_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_SDMACORE_NCR(x)       (*(__I hw_sdmacore_ncr_t *) HW_SDMACORE_NCR_ADDR(x))
#define HW_SDMACORE_NCR_RD(x)    (HW_SDMACORE_NCR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_NCR bitfields
 */

/*!
 * @name Register SDMACORE_NCR, field NCR[4:0] (RO)
 *
 * Contains the number of the pending channel that the scheduler has selected to
 * run next.
 */
/*@{*/
#define BP_SDMACORE_NCR_NCR  (0U)          /*!< Bit position for SDMACORE_NCR_NCR. */
#define BM_SDMACORE_NCR_NCR  (0x0000001FU) /*!< Bit mask for SDMACORE_NCR_NCR. */
#define BS_SDMACORE_NCR_NCR  (5U)          /*!< Bit field size in bits for SDMACORE_NCR_NCR. */

/*! @brief Read current value of the SDMACORE_NCR_NCR field. */
#define BR_SDMACORE_NCR_NCR(x) (HW_SDMACORE_NCR(x).B.NCR)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EVENTS - External DMA Requests Mirror
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EVENTS - External DMA Requests Mirror (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is very useful in the case of DMA requests that are active when
 * a peripheral FIFO level is above the programmed watermark. The activation of
 * the DMA request (rising edge) is detected by the SDMA logic and it can enable
 * one or several channels. One of the channels accesses the peripheral and reads
 * or writes a number of data that matches the watermark level (for example, if
 * the watermark is four words, the channel reads or writes four words). If the
 * channel is effectively executed long after the DMA request was received,
 * reading or writing the watermark number of data may not be sufficient to reset the
 * DMA request (for example, if the FIFO watermark is four and at the channel
 * execution it already contains nine pieces of data). This means no new rising edge
 * may be detected by the SDMA, although there still remains transfers to
 * perform. Therefore, if the channel were terminated at that time, it would not be
 * restarted, causing potential overrun or underrun of the peripheral. The proposed
 * mechanism is for the channel to check this register after it has performed the
 * "watermark" number of accesses to the peripheral. If the bit for the DMA
 * request that triggers this channel is set, it means there is still another
 * watermark number of data to transfer. This goes on until the bit is cleared. The same
 * script can be used for multiple channels that require this behavior. The
 * script can determine its channel number from the CCR register and infer the
 * corresponding DMA request bit to check. It needs a reference table that is coherent
 * with the request-channel matrix that the ARM platform programmed.
 */
typedef union _hw_sdmacore_events
{
    uint32_t U;
    struct _hw_sdmacore_events_bitfields
    {
        uint32_t EVENTS : 32;          /*!< [31:0]  */
    } B;
} hw_sdmacore_events_t;

/*!
 * @name Constants and macros for entire SDMACORE_EVENTS register
 */
/*@{*/
#define HW_SDMACORE_EVENTS_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_SDMACORE_EVENTS(x)    (*(__I hw_sdmacore_events_t *) HW_SDMACORE_EVENTS_ADDR(x))
#define HW_SDMACORE_EVENTS_RD(x) (HW_SDMACORE_EVENTS(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EVENTS bitfields
 */

/*!
 * @name Register SDMACORE_EVENTS, field EVENTS[31:0] (RO)
 *
 * Reflects the status of the SDMA's external DMA requests. It is meant to allow
 * any channel to monitor the states of these SDMA inputs. This register
 * displays EVENTS 0-31. The EVENTS2 register displays events 32-47.
 */
/*@{*/
#define BP_SDMACORE_EVENTS_EVENTS (0U)     /*!< Bit position for SDMACORE_EVENTS_EVENTS. */
#define BM_SDMACORE_EVENTS_EVENTS (0xFFFFFFFFU) /*!< Bit mask for SDMACORE_EVENTS_EVENTS. */
#define BS_SDMACORE_EVENTS_EVENTS (32U)    /*!< Bit field size in bits for SDMACORE_EVENTS_EVENTS. */

/*! @brief Read current value of the SDMACORE_EVENTS_EVENTS field. */
#define BR_SDMACORE_EVENTS_EVENTS(x) (HW_SDMACORE_EVENTS(x).U)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_CCPRI - Current Channel Priority
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_CCPRI - Current Channel Priority (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ccpri
{
    uint32_t U;
    struct _hw_sdmacore_ccpri_bitfields
    {
        uint32_t CCPRI : 3;            /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_sdmacore_ccpri_t;

/*!
 * @name Constants and macros for entire SDMACORE_CCPRI register
 */
/*@{*/
#define HW_SDMACORE_CCPRI_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_SDMACORE_CCPRI(x)     (*(__I hw_sdmacore_ccpri_t *) HW_SDMACORE_CCPRI_ADDR(x))
#define HW_SDMACORE_CCPRI_RD(x)  (HW_SDMACORE_CCPRI(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_CCPRI bitfields
 */

/*!
 * @name Register SDMACORE_CCPRI, field CCPRI[2:0] (RO)
 *
 * Contains the 3-bit priority of the channel whose context is installed. It is
 * 0 when no channel is running. 1-7 current channel priority
 *
 * Values:
 * - 0 - no running channel
 */
/*@{*/
#define BP_SDMACORE_CCPRI_CCPRI (0U)       /*!< Bit position for SDMACORE_CCPRI_CCPRI. */
#define BM_SDMACORE_CCPRI_CCPRI (0x00000007U) /*!< Bit mask for SDMACORE_CCPRI_CCPRI. */
#define BS_SDMACORE_CCPRI_CCPRI (3U)       /*!< Bit field size in bits for SDMACORE_CCPRI_CCPRI. */

/*! @brief Read current value of the SDMACORE_CCPRI_CCPRI field. */
#define BR_SDMACORE_CCPRI_CCPRI(x) (HW_SDMACORE_CCPRI(x).B.CCPRI)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_NCPRI - Next Channel Priority
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_NCPRI - Next Channel Priority (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ncpri
{
    uint32_t U;
    struct _hw_sdmacore_ncpri_bitfields
    {
        uint32_t NCPRI : 3;            /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_sdmacore_ncpri_t;

/*!
 * @name Constants and macros for entire SDMACORE_NCPRI register
 */
/*@{*/
#define HW_SDMACORE_NCPRI_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_SDMACORE_NCPRI(x)     (*(__I hw_sdmacore_ncpri_t *) HW_SDMACORE_NCPRI_ADDR(x))
#define HW_SDMACORE_NCPRI_RD(x)  (HW_SDMACORE_NCPRI(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_NCPRI bitfields
 */

/*!
 * @name Register SDMACORE_NCPRI, field NCPRI[2:0] (RO)
 *
 * Contains the 3-bit priority of the channel the scheduler has selected to run
 * next. It is 0 when no other channel is pending.
 */
/*@{*/
#define BP_SDMACORE_NCPRI_NCPRI (0U)       /*!< Bit position for SDMACORE_NCPRI_NCPRI. */
#define BM_SDMACORE_NCPRI_NCPRI (0x00000007U) /*!< Bit mask for SDMACORE_NCPRI_NCPRI. */
#define BS_SDMACORE_NCPRI_NCPRI (3U)       /*!< Bit field size in bits for SDMACORE_NCPRI_NCPRI. */

/*! @brief Read current value of the SDMACORE_NCPRI_NCPRI field. */
#define BR_SDMACORE_NCPRI_NCPRI(x) (HW_SDMACORE_NCPRI(x).B.NCPRI)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_ECOUNT - OnCE Event Cell Counter
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_ECOUNT - OnCE Event Cell Counter (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ecount
{
    uint32_t U;
    struct _hw_sdmacore_ecount_bitfields
    {
        uint32_t ECOUNT : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_ecount_t;

/*!
 * @name Constants and macros for entire SDMACORE_ECOUNT register
 */
/*@{*/
#define HW_SDMACORE_ECOUNT_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_SDMACORE_ECOUNT(x)    (*(__IO hw_sdmacore_ecount_t *) HW_SDMACORE_ECOUNT_ADDR(x))
#define HW_SDMACORE_ECOUNT_RD(x) (HW_SDMACORE_ECOUNT(x).U)
#define HW_SDMACORE_ECOUNT_WR(x, v) (HW_SDMACORE_ECOUNT(x).U = (v))
#define HW_SDMACORE_ECOUNT_SET(x, v) (HW_SDMACORE_ECOUNT_WR(x, HW_SDMACORE_ECOUNT_RD(x) |  (v)))
#define HW_SDMACORE_ECOUNT_CLR(x, v) (HW_SDMACORE_ECOUNT_WR(x, HW_SDMACORE_ECOUNT_RD(x) & ~(v)))
#define HW_SDMACORE_ECOUNT_TOG(x, v) (HW_SDMACORE_ECOUNT_WR(x, HW_SDMACORE_ECOUNT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_ECOUNT bitfields
 */

/*!
 * @name Register SDMACORE_ECOUNT, field ECOUNT[15:0] (RW)
 *
 * The event cell counter contains the number of times minus one that an event
 * detection must occur before generating a debug request. This register should be
 * written before any attempt to use the event detection counter during an event
 * detection process. The counter is cleared on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_ECOUNT_ECOUNT (0U)     /*!< Bit position for SDMACORE_ECOUNT_ECOUNT. */
#define BM_SDMACORE_ECOUNT_ECOUNT (0x0000FFFFU) /*!< Bit mask for SDMACORE_ECOUNT_ECOUNT. */
#define BS_SDMACORE_ECOUNT_ECOUNT (16U)    /*!< Bit field size in bits for SDMACORE_ECOUNT_ECOUNT. */

/*! @brief Read current value of the SDMACORE_ECOUNT_ECOUNT field. */
#define BR_SDMACORE_ECOUNT_ECOUNT(x) (HW_SDMACORE_ECOUNT(x).B.ECOUNT)

/*! @brief Format value for bitfield SDMACORE_ECOUNT_ECOUNT. */
#define BF_SDMACORE_ECOUNT_ECOUNT(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECOUNT_ECOUNT) & BM_SDMACORE_ECOUNT_ECOUNT)

/*! @brief Set the ECOUNT field to a new value. */
#define BW_SDMACORE_ECOUNT_ECOUNT(x, v) (HW_SDMACORE_ECOUNT_WR(x, (HW_SDMACORE_ECOUNT_RD(x) & ~BM_SDMACORE_ECOUNT_ECOUNT) | BF_SDMACORE_ECOUNT_ECOUNT(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_ECTL - OnCE Event Cell Control Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_ECTL - OnCE Event Cell Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ectl
{
    uint32_t U;
    struct _hw_sdmacore_ectl_bitfields
    {
        uint32_t ATS : 2;              /*!< [1:0]  */
        uint32_t AATC : 2;             /*!< [3:2]  */
        uint32_t ABTC : 2;             /*!< [5:4]  */
        uint32_t ATC : 2;              /*!< [7:6]  */
        uint32_t DTC : 2;              /*!< [9:8]  */
        uint32_t ECTC : 2;             /*!< [11:10]  */
        uint32_t CNT : 1;              /*!< [12]  */
        uint32_t EN : 1;               /*!< [13]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_sdmacore_ectl_t;

/*!
 * @name Constants and macros for entire SDMACORE_ECTL register
 */
/*@{*/
#define HW_SDMACORE_ECTL_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_SDMACORE_ECTL(x)      (*(__IO hw_sdmacore_ectl_t *) HW_SDMACORE_ECTL_ADDR(x))
#define HW_SDMACORE_ECTL_RD(x)   (HW_SDMACORE_ECTL(x).U)
#define HW_SDMACORE_ECTL_WR(x, v) (HW_SDMACORE_ECTL(x).U = (v))
#define HW_SDMACORE_ECTL_SET(x, v) (HW_SDMACORE_ECTL_WR(x, HW_SDMACORE_ECTL_RD(x) |  (v)))
#define HW_SDMACORE_ECTL_CLR(x, v) (HW_SDMACORE_ECTL_WR(x, HW_SDMACORE_ECTL_RD(x) & ~(v)))
#define HW_SDMACORE_ECTL_TOG(x, v) (HW_SDMACORE_ECTL_WR(x, HW_SDMACORE_ECTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_ECTL bitfields
 */

/*!
 * @name Register SDMACORE_ECTL, field ATS[1:0] (RW)
 *
 * The access type select bits define the memory access type required on the
 * SDMA memory bus.
 *
 * Values:
 * - 00 - read ONLY
 * - 01 - write ONLY
 * - 10 - read or write
 * - 11 - -
 */
/*@{*/
#define BP_SDMACORE_ECTL_ATS (0U)          /*!< Bit position for SDMACORE_ECTL_ATS. */
#define BM_SDMACORE_ECTL_ATS (0x00000003U) /*!< Bit mask for SDMACORE_ECTL_ATS. */
#define BS_SDMACORE_ECTL_ATS (2U)          /*!< Bit field size in bits for SDMACORE_ECTL_ATS. */

/*! @brief Read current value of the SDMACORE_ECTL_ATS field. */
#define BR_SDMACORE_ECTL_ATS(x) (HW_SDMACORE_ECTL(x).B.ATS)

/*! @brief Format value for bitfield SDMACORE_ECTL_ATS. */
#define BF_SDMACORE_ECTL_ATS(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_ATS) & BM_SDMACORE_ECTL_ATS)

/*! @brief Set the ATS field to a new value. */
#define BW_SDMACORE_ECTL_ATS(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_ATS) | BF_SDMACORE_ECTL_ATS(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field AATC[3:2] (RW)
 *
 * The Address A Trigger Condition (AATC) controls the operations performed by
 * address comparator A. All operations are performed on unsigned values. This
 * comparator A outputs the addressA condition.
 *
 * Values:
 * - 00 - equal
 * - 01 - not equal
 * - 10 - greater than
 * - 11 - less than
 */
/*@{*/
#define BP_SDMACORE_ECTL_AATC (2U)         /*!< Bit position for SDMACORE_ECTL_AATC. */
#define BM_SDMACORE_ECTL_AATC (0x0000000CU) /*!< Bit mask for SDMACORE_ECTL_AATC. */
#define BS_SDMACORE_ECTL_AATC (2U)         /*!< Bit field size in bits for SDMACORE_ECTL_AATC. */

/*! @brief Read current value of the SDMACORE_ECTL_AATC field. */
#define BR_SDMACORE_ECTL_AATC(x) (HW_SDMACORE_ECTL(x).B.AATC)

/*! @brief Format value for bitfield SDMACORE_ECTL_AATC. */
#define BF_SDMACORE_ECTL_AATC(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_AATC) & BM_SDMACORE_ECTL_AATC)

/*! @brief Set the AATC field to a new value. */
#define BW_SDMACORE_ECTL_AATC(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_AATC) | BF_SDMACORE_ECTL_AATC(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field ABTC[5:4] (RW)
 *
 * The Address B Trigger Condition (ABTC) controls the operations performed by
 * address comparator B. All operations are performed on unsigned values. This
 * comparator B outputs the addressB condition.
 *
 * Values:
 * - 00 - equal
 * - 01 - not equal
 * - 10 - greater than
 * - 11 - less than
 */
/*@{*/
#define BP_SDMACORE_ECTL_ABTC (4U)         /*!< Bit position for SDMACORE_ECTL_ABTC. */
#define BM_SDMACORE_ECTL_ABTC (0x00000030U) /*!< Bit mask for SDMACORE_ECTL_ABTC. */
#define BS_SDMACORE_ECTL_ABTC (2U)         /*!< Bit field size in bits for SDMACORE_ECTL_ABTC. */

/*! @brief Read current value of the SDMACORE_ECTL_ABTC field. */
#define BR_SDMACORE_ECTL_ABTC(x) (HW_SDMACORE_ECTL(x).B.ABTC)

/*! @brief Format value for bitfield SDMACORE_ECTL_ABTC. */
#define BF_SDMACORE_ECTL_ABTC(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_ABTC) & BM_SDMACORE_ECTL_ABTC)

/*! @brief Set the ABTC field to a new value. */
#define BW_SDMACORE_ECTL_ABTC(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_ABTC) | BF_SDMACORE_ECTL_ABTC(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field ATC[7:6] (RW)
 *
 * The address trigger condition bits select how the two address conditions
 * (addressA and addressB) are combined to define the global address matching
 * condition. The supported combinations are described, as follows.
 *
 * Values:
 * - 00 - addressA ONLY
 * - 01 - addrA AND addrB
 * - 10 - addrA OR addrB
 * - 11 - reserved
 */
/*@{*/
#define BP_SDMACORE_ECTL_ATC (6U)          /*!< Bit position for SDMACORE_ECTL_ATC. */
#define BM_SDMACORE_ECTL_ATC (0x000000C0U) /*!< Bit mask for SDMACORE_ECTL_ATC. */
#define BS_SDMACORE_ECTL_ATC (2U)          /*!< Bit field size in bits for SDMACORE_ECTL_ATC. */

/*! @brief Read current value of the SDMACORE_ECTL_ATC field. */
#define BR_SDMACORE_ECTL_ATC(x) (HW_SDMACORE_ECTL(x).B.ATC)

/*! @brief Format value for bitfield SDMACORE_ECTL_ATC. */
#define BF_SDMACORE_ECTL_ATC(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_ATC) & BM_SDMACORE_ECTL_ATC)

/*! @brief Set the ATC field to a new value. */
#define BW_SDMACORE_ECTL_ATC(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_ATC) | BF_SDMACORE_ECTL_ATC(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field DTC[9:8] (RW)
 *
 * The data trigger condition bits define when data is considered matching after
 * comparison with the data register of the event detection unit. The operations
 * are performed on unsigned values.
 *
 * Values:
 * - 00 - equal
 * - 01 - not equal
 * - 10 - greater than
 * - 11 - less than
 */
/*@{*/
#define BP_SDMACORE_ECTL_DTC (8U)          /*!< Bit position for SDMACORE_ECTL_DTC. */
#define BM_SDMACORE_ECTL_DTC (0x00000300U) /*!< Bit mask for SDMACORE_ECTL_DTC. */
#define BS_SDMACORE_ECTL_DTC (2U)          /*!< Bit field size in bits for SDMACORE_ECTL_DTC. */

/*! @brief Read current value of the SDMACORE_ECTL_DTC field. */
#define BR_SDMACORE_ECTL_DTC(x) (HW_SDMACORE_ECTL(x).B.DTC)

/*! @brief Format value for bitfield SDMACORE_ECTL_DTC. */
#define BF_SDMACORE_ECTL_DTC(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_DTC) & BM_SDMACORE_ECTL_DTC)

/*! @brief Set the DTC field to a new value. */
#define BW_SDMACORE_ECTL_DTC(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_DTC) | BF_SDMACORE_ECTL_DTC(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field ECTC[11:10] (RW)
 *
 * The event cell trigger condition bits select the combination of address and
 * data matching conditions that generate the final address/data condition. During
 * program execution, if this event cell trigger condition goes to 1, a debug
 * request is sent to the SDMA. The EN bit must be set to enable the debug request
 * generation.
 *
 * Values:
 * - 00 - address ONLY
 * - 01 - data ONLY
 * - 10 - address AND data
 * - 11 - address OR data
 */
/*@{*/
#define BP_SDMACORE_ECTL_ECTC (10U)        /*!< Bit position for SDMACORE_ECTL_ECTC. */
#define BM_SDMACORE_ECTL_ECTC (0x00000C00U) /*!< Bit mask for SDMACORE_ECTL_ECTC. */
#define BS_SDMACORE_ECTL_ECTC (2U)         /*!< Bit field size in bits for SDMACORE_ECTL_ECTC. */

/*! @brief Read current value of the SDMACORE_ECTL_ECTC field. */
#define BR_SDMACORE_ECTL_ECTC(x) (HW_SDMACORE_ECTL(x).B.ECTC)

/*! @brief Format value for bitfield SDMACORE_ECTL_ECTC. */
#define BF_SDMACORE_ECTL_ECTC(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_ECTC) & BM_SDMACORE_ECTL_ECTC)

/*! @brief Set the ECTC field to a new value. */
#define BW_SDMACORE_ECTL_ECTC(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_ECTC) | BF_SDMACORE_ECTL_ECTC(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field CNT[12] (RW)
 *
 * Event Counter Enable. The event counter enable bit determines if the cell
 * counter is used during the event detection. In order to use the event counter
 * during an event detection process, the event cell counter register should be
 * loaded with a value equal to the number of times minus one that an event occurs
 * before a debug request is sent. After every event detection, the counter is
 * decreased. When the counter reaches the value 0, the event detection cell sends a
 * debug request to the core. The event counter register should be written and
 * the EN bit should be set before each new event detection process uses the event
 * counter.
 *
 * Values:
 * - 0 - Counter is disabled.
 * - 1 - Counter is enabled.
 */
/*@{*/
#define BP_SDMACORE_ECTL_CNT (12U)         /*!< Bit position for SDMACORE_ECTL_CNT. */
#define BM_SDMACORE_ECTL_CNT (0x00001000U) /*!< Bit mask for SDMACORE_ECTL_CNT. */
#define BS_SDMACORE_ECTL_CNT (1U)          /*!< Bit field size in bits for SDMACORE_ECTL_CNT. */

/*! @brief Read current value of the SDMACORE_ECTL_CNT field. */
#define BR_SDMACORE_ECTL_CNT(x) (HW_SDMACORE_ECTL(x).B.CNT)

/*! @brief Format value for bitfield SDMACORE_ECTL_CNT. */
#define BF_SDMACORE_ECTL_CNT(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_CNT) & BM_SDMACORE_ECTL_CNT)

/*! @brief Set the CNT field to a new value. */
#define BW_SDMACORE_ECTL_CNT(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_CNT) | BF_SDMACORE_ECTL_CNT(v)))
/*@}*/

/*!
 * @name Register SDMACORE_ECTL, field EN[13] (RW)
 *
 * Event Cell Enable. If the EN bit is set, the event cell is allowed to
 * generate debug requests (the cell is awakened). If it is cleared, the event detection
 * unit is disabled and no hardware breakpoint is generated, but matching
 * conditions are still reflected on the emulation pin.
 *
 * Values:
 * - 0 - Cell is disabled.
 * - 1 - Cell is enabled.
 */
/*@{*/
#define BP_SDMACORE_ECTL_EN  (13U)         /*!< Bit position for SDMACORE_ECTL_EN. */
#define BM_SDMACORE_ECTL_EN  (0x00002000U) /*!< Bit mask for SDMACORE_ECTL_EN. */
#define BS_SDMACORE_ECTL_EN  (1U)          /*!< Bit field size in bits for SDMACORE_ECTL_EN. */

/*! @brief Read current value of the SDMACORE_ECTL_EN field. */
#define BR_SDMACORE_ECTL_EN(x) (HW_SDMACORE_ECTL(x).B.EN)

/*! @brief Format value for bitfield SDMACORE_ECTL_EN. */
#define BF_SDMACORE_ECTL_EN(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ECTL_EN) & BM_SDMACORE_ECTL_EN)

/*! @brief Set the EN field to a new value. */
#define BW_SDMACORE_ECTL_EN(x, v) (HW_SDMACORE_ECTL_WR(x, (HW_SDMACORE_ECTL_RD(x) & ~BM_SDMACORE_ECTL_EN) | BF_SDMACORE_ECTL_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EAA - OnCE Event Address Register A
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EAA - OnCE Event Address Register A (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_eaa
{
    uint32_t U;
    struct _hw_sdmacore_eaa_bitfields
    {
        uint32_t EAA : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_eaa_t;

/*!
 * @name Constants and macros for entire SDMACORE_EAA register
 */
/*@{*/
#define HW_SDMACORE_EAA_ADDR(x)  ((uintptr_t)(x) + 0x24U)

#define HW_SDMACORE_EAA(x)       (*(__IO hw_sdmacore_eaa_t *) HW_SDMACORE_EAA_ADDR(x))
#define HW_SDMACORE_EAA_RD(x)    (HW_SDMACORE_EAA(x).U)
#define HW_SDMACORE_EAA_WR(x, v) (HW_SDMACORE_EAA(x).U = (v))
#define HW_SDMACORE_EAA_SET(x, v) (HW_SDMACORE_EAA_WR(x, HW_SDMACORE_EAA_RD(x) |  (v)))
#define HW_SDMACORE_EAA_CLR(x, v) (HW_SDMACORE_EAA_WR(x, HW_SDMACORE_EAA_RD(x) & ~(v)))
#define HW_SDMACORE_EAA_TOG(x, v) (HW_SDMACORE_EAA_WR(x, HW_SDMACORE_EAA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EAA bitfields
 */

/*!
 * @name Register SDMACORE_EAA, field EAA[15:0] (RW)
 *
 * Event Cell Address Register A computes an address A condition. It is cleared
 * on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_EAA_EAA  (0U)          /*!< Bit position for SDMACORE_EAA_EAA. */
#define BM_SDMACORE_EAA_EAA  (0x0000FFFFU) /*!< Bit mask for SDMACORE_EAA_EAA. */
#define BS_SDMACORE_EAA_EAA  (16U)         /*!< Bit field size in bits for SDMACORE_EAA_EAA. */

/*! @brief Read current value of the SDMACORE_EAA_EAA field. */
#define BR_SDMACORE_EAA_EAA(x) (HW_SDMACORE_EAA(x).B.EAA)

/*! @brief Format value for bitfield SDMACORE_EAA_EAA. */
#define BF_SDMACORE_EAA_EAA(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_EAA_EAA) & BM_SDMACORE_EAA_EAA)

/*! @brief Set the EAA field to a new value. */
#define BW_SDMACORE_EAA_EAA(x, v) (HW_SDMACORE_EAA_WR(x, (HW_SDMACORE_EAA_RD(x) & ~BM_SDMACORE_EAA_EAA) | BF_SDMACORE_EAA_EAA(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EAB - OnCE Event Cell Address Register B
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EAB - OnCE Event Cell Address Register B (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_eab
{
    uint32_t U;
    struct _hw_sdmacore_eab_bitfields
    {
        uint32_t EAB : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_eab_t;

/*!
 * @name Constants and macros for entire SDMACORE_EAB register
 */
/*@{*/
#define HW_SDMACORE_EAB_ADDR(x)  ((uintptr_t)(x) + 0x28U)

#define HW_SDMACORE_EAB(x)       (*(__IO hw_sdmacore_eab_t *) HW_SDMACORE_EAB_ADDR(x))
#define HW_SDMACORE_EAB_RD(x)    (HW_SDMACORE_EAB(x).U)
#define HW_SDMACORE_EAB_WR(x, v) (HW_SDMACORE_EAB(x).U = (v))
#define HW_SDMACORE_EAB_SET(x, v) (HW_SDMACORE_EAB_WR(x, HW_SDMACORE_EAB_RD(x) |  (v)))
#define HW_SDMACORE_EAB_CLR(x, v) (HW_SDMACORE_EAB_WR(x, HW_SDMACORE_EAB_RD(x) & ~(v)))
#define HW_SDMACORE_EAB_TOG(x, v) (HW_SDMACORE_EAB_WR(x, HW_SDMACORE_EAB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EAB bitfields
 */

/*!
 * @name Register SDMACORE_EAB, field EAB[15:0] (RW)
 *
 * Event Cell Address Register B computes an address B condition. It is cleared
 * on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_EAB_EAB  (0U)          /*!< Bit position for SDMACORE_EAB_EAB. */
#define BM_SDMACORE_EAB_EAB  (0x0000FFFFU) /*!< Bit mask for SDMACORE_EAB_EAB. */
#define BS_SDMACORE_EAB_EAB  (16U)         /*!< Bit field size in bits for SDMACORE_EAB_EAB. */

/*! @brief Read current value of the SDMACORE_EAB_EAB field. */
#define BR_SDMACORE_EAB_EAB(x) (HW_SDMACORE_EAB(x).B.EAB)

/*! @brief Format value for bitfield SDMACORE_EAB_EAB. */
#define BF_SDMACORE_EAB_EAB(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_EAB_EAB) & BM_SDMACORE_EAB_EAB)

/*! @brief Set the EAB field to a new value. */
#define BW_SDMACORE_EAB_EAB(x, v) (HW_SDMACORE_EAB_WR(x, (HW_SDMACORE_EAB_RD(x) & ~BM_SDMACORE_EAB_EAB) | BF_SDMACORE_EAB_EAB(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EAM - OnCE Event Cell Address Mask
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EAM - OnCE Event Cell Address Mask (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_eam
{
    uint32_t U;
    struct _hw_sdmacore_eam_bitfields
    {
        uint32_t EAM : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_eam_t;

/*!
 * @name Constants and macros for entire SDMACORE_EAM register
 */
/*@{*/
#define HW_SDMACORE_EAM_ADDR(x)  ((uintptr_t)(x) + 0x2CU)

#define HW_SDMACORE_EAM(x)       (*(__IO hw_sdmacore_eam_t *) HW_SDMACORE_EAM_ADDR(x))
#define HW_SDMACORE_EAM_RD(x)    (HW_SDMACORE_EAM(x).U)
#define HW_SDMACORE_EAM_WR(x, v) (HW_SDMACORE_EAM(x).U = (v))
#define HW_SDMACORE_EAM_SET(x, v) (HW_SDMACORE_EAM_WR(x, HW_SDMACORE_EAM_RD(x) |  (v)))
#define HW_SDMACORE_EAM_CLR(x, v) (HW_SDMACORE_EAM_WR(x, HW_SDMACORE_EAM_RD(x) & ~(v)))
#define HW_SDMACORE_EAM_TOG(x, v) (HW_SDMACORE_EAM_WR(x, HW_SDMACORE_EAM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EAM bitfields
 */

/*!
 * @name Register SDMACORE_EAM, field EAM[15:0] (RW)
 *
 * The Event Cell Address Mask contains a user-defined address mask value. This
 * mask is applied to the address value latched from the memory address bus
 * before performing the address comparison. There is a common address mask value for
 * both address comparators. If bit i of this register is set, then bit i of the
 * address value latched from the memory bus does not influence the result of the
 * address comparison. The register is cleared on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_EAM_EAM  (0U)          /*!< Bit position for SDMACORE_EAM_EAM. */
#define BM_SDMACORE_EAM_EAM  (0x0000FFFFU) /*!< Bit mask for SDMACORE_EAM_EAM. */
#define BS_SDMACORE_EAM_EAM  (16U)         /*!< Bit field size in bits for SDMACORE_EAM_EAM. */

/*! @brief Read current value of the SDMACORE_EAM_EAM field. */
#define BR_SDMACORE_EAM_EAM(x) (HW_SDMACORE_EAM(x).B.EAM)

/*! @brief Format value for bitfield SDMACORE_EAM_EAM. */
#define BF_SDMACORE_EAM_EAM(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_EAM_EAM) & BM_SDMACORE_EAM_EAM)

/*! @brief Set the EAM field to a new value. */
#define BW_SDMACORE_EAM_EAM(x, v) (HW_SDMACORE_EAM_WR(x, (HW_SDMACORE_EAM_RD(x) & ~BM_SDMACORE_EAM_EAM) | BF_SDMACORE_EAM_EAM(v)))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_ED - OnCE Event Cell Data Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_ED - OnCE Event Cell Data Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ed
{
    uint32_t U;
    struct _hw_sdmacore_ed_bitfields
    {
        uint32_t ED : 32;              /*!< [31:0]  */
    } B;
} hw_sdmacore_ed_t;

/*!
 * @name Constants and macros for entire SDMACORE_ED register
 */
/*@{*/
#define HW_SDMACORE_ED_ADDR(x)   ((uintptr_t)(x) + 0x30U)

#define HW_SDMACORE_ED(x)        (*(__IO hw_sdmacore_ed_t *) HW_SDMACORE_ED_ADDR(x))
#define HW_SDMACORE_ED_RD(x)     (HW_SDMACORE_ED(x).U)
#define HW_SDMACORE_ED_WR(x, v)  (HW_SDMACORE_ED(x).U = (v))
#define HW_SDMACORE_ED_SET(x, v) (HW_SDMACORE_ED_WR(x, HW_SDMACORE_ED_RD(x) |  (v)))
#define HW_SDMACORE_ED_CLR(x, v) (HW_SDMACORE_ED_WR(x, HW_SDMACORE_ED_RD(x) & ~(v)))
#define HW_SDMACORE_ED_TOG(x, v) (HW_SDMACORE_ED_WR(x, HW_SDMACORE_ED_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_ED bitfields
 */

/*!
 * @name Register SDMACORE_ED, field ED[31:0] (RW)
 *
 * The event cell data register contains a user defined data value. This data
 * value is an input for the data comparator which generates the data condition. It
 * is cleared on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_ED_ED    (0U)          /*!< Bit position for SDMACORE_ED_ED. */
#define BM_SDMACORE_ED_ED    (0xFFFFFFFFU) /*!< Bit mask for SDMACORE_ED_ED. */
#define BS_SDMACORE_ED_ED    (32U)         /*!< Bit field size in bits for SDMACORE_ED_ED. */

/*! @brief Read current value of the SDMACORE_ED_ED field. */
#define BR_SDMACORE_ED_ED(x) (HW_SDMACORE_ED(x).U)

/*! @brief Format value for bitfield SDMACORE_ED_ED. */
#define BF_SDMACORE_ED_ED(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_ED_ED) & BM_SDMACORE_ED_ED)

/*! @brief Set the ED field to a new value. */
#define BW_SDMACORE_ED_ED(x, v) (HW_SDMACORE_ED_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EDM - OnCE Event Cell Data Mask
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EDM - OnCE Event Cell Data Mask (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_edm
{
    uint32_t U;
    struct _hw_sdmacore_edm_bitfields
    {
        uint32_t EDM : 32;             /*!< [31:0]  */
    } B;
} hw_sdmacore_edm_t;

/*!
 * @name Constants and macros for entire SDMACORE_EDM register
 */
/*@{*/
#define HW_SDMACORE_EDM_ADDR(x)  ((uintptr_t)(x) + 0x34U)

#define HW_SDMACORE_EDM(x)       (*(__IO hw_sdmacore_edm_t *) HW_SDMACORE_EDM_ADDR(x))
#define HW_SDMACORE_EDM_RD(x)    (HW_SDMACORE_EDM(x).U)
#define HW_SDMACORE_EDM_WR(x, v) (HW_SDMACORE_EDM(x).U = (v))
#define HW_SDMACORE_EDM_SET(x, v) (HW_SDMACORE_EDM_WR(x, HW_SDMACORE_EDM_RD(x) |  (v)))
#define HW_SDMACORE_EDM_CLR(x, v) (HW_SDMACORE_EDM_WR(x, HW_SDMACORE_EDM_RD(x) & ~(v)))
#define HW_SDMACORE_EDM_TOG(x, v) (HW_SDMACORE_EDM_WR(x, HW_SDMACORE_EDM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EDM bitfields
 */

/*!
 * @name Register SDMACORE_EDM, field EDM[31:0] (RW)
 *
 * The event cell data mask register contains the user-defined data mask value.
 * This mask is applied to the data value latched from the memory bus before
 * performing the data comparison. Setting bit i of the event cell data mask register
 * means that bit i of the data value latched from the address bus does not
 * influence the result of the data comparison. The data mask is cleared on a JTAG
 * reset.
 */
/*@{*/
#define BP_SDMACORE_EDM_EDM  (0U)          /*!< Bit position for SDMACORE_EDM_EDM. */
#define BM_SDMACORE_EDM_EDM  (0xFFFFFFFFU) /*!< Bit mask for SDMACORE_EDM_EDM. */
#define BS_SDMACORE_EDM_EDM  (32U)         /*!< Bit field size in bits for SDMACORE_EDM_EDM. */

/*! @brief Read current value of the SDMACORE_EDM_EDM field. */
#define BR_SDMACORE_EDM_EDM(x) (HW_SDMACORE_EDM(x).U)

/*! @brief Format value for bitfield SDMACORE_EDM_EDM. */
#define BF_SDMACORE_EDM_EDM(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_EDM_EDM) & BM_SDMACORE_EDM_EDM)

/*! @brief Set the EDM field to a new value. */
#define BW_SDMACORE_EDM_EDM(x, v) (HW_SDMACORE_EDM_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_RTB - OnCE Real-Time Buffer
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_RTB - OnCE Real-Time Buffer (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_rtb
{
    uint32_t U;
    struct _hw_sdmacore_rtb_bitfields
    {
        uint32_t RTB : 32;             /*!< [31:0]  */
    } B;
} hw_sdmacore_rtb_t;

/*!
 * @name Constants and macros for entire SDMACORE_RTB register
 */
/*@{*/
#define HW_SDMACORE_RTB_ADDR(x)  ((uintptr_t)(x) + 0x38U)

#define HW_SDMACORE_RTB(x)       (*(__IO hw_sdmacore_rtb_t *) HW_SDMACORE_RTB_ADDR(x))
#define HW_SDMACORE_RTB_RD(x)    (HW_SDMACORE_RTB(x).U)
#define HW_SDMACORE_RTB_WR(x, v) (HW_SDMACORE_RTB(x).U = (v))
#define HW_SDMACORE_RTB_SET(x, v) (HW_SDMACORE_RTB_WR(x, HW_SDMACORE_RTB_RD(x) |  (v)))
#define HW_SDMACORE_RTB_CLR(x, v) (HW_SDMACORE_RTB_WR(x, HW_SDMACORE_RTB_RD(x) & ~(v)))
#define HW_SDMACORE_RTB_TOG(x, v) (HW_SDMACORE_RTB_WR(x, HW_SDMACORE_RTB_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SDMACORE_RTB bitfields
 */

/*!
 * @name Register SDMACORE_RTB, field RTB[31:0] (RW)
 *
 * The Real Time Buffer register stores and retrieves run time information
 * without putting the SDMA in debug mode. Writing to that register triggers a pulse
 * on a specific real-time debug pin whose connection depends on the chip
 * implementation. The RTB value can be accessed by the OnCE under ARM platform or JTAG
 * control using the rbuffer command.
 */
/*@{*/
#define BP_SDMACORE_RTB_RTB  (0U)          /*!< Bit position for SDMACORE_RTB_RTB. */
#define BM_SDMACORE_RTB_RTB  (0xFFFFFFFFU) /*!< Bit mask for SDMACORE_RTB_RTB. */
#define BS_SDMACORE_RTB_RTB  (32U)         /*!< Bit field size in bits for SDMACORE_RTB_RTB. */

/*! @brief Read current value of the SDMACORE_RTB_RTB field. */
#define BR_SDMACORE_RTB_RTB(x) (HW_SDMACORE_RTB(x).U)

/*! @brief Format value for bitfield SDMACORE_RTB_RTB. */
#define BF_SDMACORE_RTB_RTB(v) ((uint32_t)((uint32_t)(v) << BP_SDMACORE_RTB_RTB) & BM_SDMACORE_RTB_RTB)

/*! @brief Set the RTB field to a new value. */
#define BW_SDMACORE_RTB_RTB(x, v) (HW_SDMACORE_RTB_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_TB - OnCE Trace Buffer
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_TB - OnCE Trace Buffer (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_tb
{
    uint32_t U;
    struct _hw_sdmacore_tb_bitfields
    {
        uint32_t CHFADDR : 14;         /*!< [13:0]  */
        uint32_t TADDR : 14;           /*!< [27:14]  */
        uint32_t TBF : 1;              /*!< [28]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_sdmacore_tb_t;

/*!
 * @name Constants and macros for entire SDMACORE_TB register
 */
/*@{*/
#define HW_SDMACORE_TB_ADDR(x)   ((uintptr_t)(x) + 0x3CU)

#define HW_SDMACORE_TB(x)        (*(__I hw_sdmacore_tb_t *) HW_SDMACORE_TB_ADDR(x))
#define HW_SDMACORE_TB_RD(x)     (HW_SDMACORE_TB(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_TB bitfields
 */

/*!
 * @name Register SDMACORE_TB, field CHFADDR[13:0] (RO)
 *
 * The change of flow address is the address where the change of flow is taken
 * when executing a change of flow instruction.
 */
/*@{*/
#define BP_SDMACORE_TB_CHFADDR (0U)        /*!< Bit position for SDMACORE_TB_CHFADDR. */
#define BM_SDMACORE_TB_CHFADDR (0x00003FFFU) /*!< Bit mask for SDMACORE_TB_CHFADDR. */
#define BS_SDMACORE_TB_CHFADDR (14U)       /*!< Bit field size in bits for SDMACORE_TB_CHFADDR. */

/*! @brief Read current value of the SDMACORE_TB_CHFADDR field. */
#define BR_SDMACORE_TB_CHFADDR(x) (HW_SDMACORE_TB(x).B.CHFADDR)
/*@}*/

/*!
 * @name Register SDMACORE_TB, field TADDR[27:14] (RO)
 *
 * The target address is the address taken after the execution of the change of
 * flow instruction.
 */
/*@{*/
#define BP_SDMACORE_TB_TADDR (14U)         /*!< Bit position for SDMACORE_TB_TADDR. */
#define BM_SDMACORE_TB_TADDR (0x0FFFC000U) /*!< Bit mask for SDMACORE_TB_TADDR. */
#define BS_SDMACORE_TB_TADDR (14U)         /*!< Bit field size in bits for SDMACORE_TB_TADDR. */

/*! @brief Read current value of the SDMACORE_TB_TADDR field. */
#define BR_SDMACORE_TB_TADDR(x) (HW_SDMACORE_TB(x).B.TADDR)
/*@}*/

/*!
 * @name Register SDMACORE_TB, field TBF[28] (RO)
 *
 * The Trace Buffer Flag is set when the buffer contains the addresses of a
 * valid change of flow. The contents of the buffer should be ignored otherwise.
 *
 * Values:
 * - 0 - Invalid information
 * - 1 - Valid information
 */
/*@{*/
#define BP_SDMACORE_TB_TBF   (28U)         /*!< Bit position for SDMACORE_TB_TBF. */
#define BM_SDMACORE_TB_TBF   (0x10000000U) /*!< Bit mask for SDMACORE_TB_TBF. */
#define BS_SDMACORE_TB_TBF   (1U)          /*!< Bit field size in bits for SDMACORE_TB_TBF. */

/*! @brief Read current value of the SDMACORE_TB_TBF field. */
#define BR_SDMACORE_TB_TBF(x) (HW_SDMACORE_TB(x).B.TBF)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_OSTAT - OnCE Status
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_OSTAT - OnCE Status (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_ostat
{
    uint32_t U;
    struct _hw_sdmacore_ostat_bitfields
    {
        uint32_t ECDR : 3;             /*!< [2:0]  */
        uint32_t RESERVED0 : 4;        /*!< [6:3]  */
        uint32_t MST : 1;              /*!< [7]  */
        uint32_t SWB : 1;              /*!< [8]  */
        uint32_t ODR : 1;              /*!< [9]  */
        uint32_t EDR : 1;              /*!< [10]  */
        uint32_t RCV : 1;              /*!< [11]  */
        uint32_t PST : 4;              /*!< [15:12]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_ostat_t;

/*!
 * @name Constants and macros for entire SDMACORE_OSTAT register
 */
/*@{*/
#define HW_SDMACORE_OSTAT_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_SDMACORE_OSTAT(x)     (*(__I hw_sdmacore_ostat_t *) HW_SDMACORE_OSTAT_ADDR(x))
#define HW_SDMACORE_OSTAT_RD(x)  (HW_SDMACORE_OSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_OSTAT bitfields
 */

/*!
 * @name Register SDMACORE_OSTAT, field ECDR[2:0] (RO)
 *
 * Event Cell Debug Request. If the debug request comes from the event cell, the
 * reason for entering debug mode is given by the EDR bits. The encoding of the
 * EDR bits is useful to find out more precisely why the debug request was
 * generated. A debug request from an event cell is generated for a specific
 * combination of the addressA, addressB, and data conditions; the value of those fields is
 * given by the EDR bits. If all three bits of the EDR are reset, then it did
 * not generate any debug request. If the cell did generate a debug request, then
 * at least one EDR bit is set; the meaning of the encoding is as follows:
 *
 * Values:
 * - 0 - 1 matched addressA condition
 * - 1 - 1 matched addressB condition
 */
/*@{*/
#define BP_SDMACORE_OSTAT_ECDR (0U)        /*!< Bit position for SDMACORE_OSTAT_ECDR. */
#define BM_SDMACORE_OSTAT_ECDR (0x00000007U) /*!< Bit mask for SDMACORE_OSTAT_ECDR. */
#define BS_SDMACORE_OSTAT_ECDR (3U)        /*!< Bit field size in bits for SDMACORE_OSTAT_ECDR. */

/*! @brief Read current value of the SDMACORE_OSTAT_ECDR field. */
#define BR_SDMACORE_OSTAT_ECDR(x) (HW_SDMACORE_OSTAT(x).B.ECDR)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field MST[7] (RO)
 *
 * This flag is raised when the OnCE is controlled from the ARM platform
 * peripheral interface.
 *
 * Values:
 * - 0 - JTAG interface controls the OnCE.
 * - 1 - ARM platform peripheral interface controls the OnCE.
 */
/*@{*/
#define BP_SDMACORE_OSTAT_MST (7U)         /*!< Bit position for SDMACORE_OSTAT_MST. */
#define BM_SDMACORE_OSTAT_MST (0x00000080U) /*!< Bit mask for SDMACORE_OSTAT_MST. */
#define BS_SDMACORE_OSTAT_MST (1U)         /*!< Bit field size in bits for SDMACORE_OSTAT_MST. */

/*! @brief Read current value of the SDMACORE_OSTAT_MST field. */
#define BR_SDMACORE_OSTAT_MST(x) (HW_SDMACORE_OSTAT(x).B.MST)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field SWB[8] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after a software
 * breakpoint.
 */
/*@{*/
#define BP_SDMACORE_OSTAT_SWB (8U)         /*!< Bit position for SDMACORE_OSTAT_SWB. */
#define BM_SDMACORE_OSTAT_SWB (0x00000100U) /*!< Bit mask for SDMACORE_OSTAT_SWB. */
#define BS_SDMACORE_OSTAT_SWB (1U)         /*!< Bit field size in bits for SDMACORE_OSTAT_SWB. */

/*! @brief Read current value of the SDMACORE_OSTAT_SWB field. */
#define BR_SDMACORE_OSTAT_SWB(x) (HW_SDMACORE_OSTAT(x).B.SWB)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field ODR[9] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after a OnCE debug
 * request.
 */
/*@{*/
#define BP_SDMACORE_OSTAT_ODR (9U)         /*!< Bit position for SDMACORE_OSTAT_ODR. */
#define BM_SDMACORE_OSTAT_ODR (0x00000200U) /*!< Bit mask for SDMACORE_OSTAT_ODR. */
#define BS_SDMACORE_OSTAT_ODR (1U)         /*!< Bit field size in bits for SDMACORE_OSTAT_ODR. */

/*! @brief Read current value of the SDMACORE_OSTAT_ODR field. */
#define BR_SDMACORE_OSTAT_ODR(x) (HW_SDMACORE_OSTAT(x).B.ODR)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field EDR[10] (RO)
 *
 * This flag is raised when the SDMA has entered debug mode after an external
 * debug request.
 */
/*@{*/
#define BP_SDMACORE_OSTAT_EDR (10U)        /*!< Bit position for SDMACORE_OSTAT_EDR. */
#define BM_SDMACORE_OSTAT_EDR (0x00000400U) /*!< Bit mask for SDMACORE_OSTAT_EDR. */
#define BS_SDMACORE_OSTAT_EDR (1U)         /*!< Bit field size in bits for SDMACORE_OSTAT_EDR. */

/*! @brief Read current value of the SDMACORE_OSTAT_EDR field. */
#define BR_SDMACORE_OSTAT_EDR(x) (HW_SDMACORE_OSTAT(x).B.EDR)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field RCV[11] (RO)
 *
 * After each write access to the real time buffer (RTB), the RCV bit is set.
 * This bit is cleared after execution of an rbuffer command and on a JTAG reset.
 */
/*@{*/
#define BP_SDMACORE_OSTAT_RCV (11U)        /*!< Bit position for SDMACORE_OSTAT_RCV. */
#define BM_SDMACORE_OSTAT_RCV (0x00000800U) /*!< Bit mask for SDMACORE_OSTAT_RCV. */
#define BS_SDMACORE_OSTAT_RCV (1U)         /*!< Bit field size in bits for SDMACORE_OSTAT_RCV. */

/*! @brief Read current value of the SDMACORE_OSTAT_RCV field. */
#define BR_SDMACORE_OSTAT_RCV(x) (HW_SDMACORE_OSTAT(x).B.RCV)
/*@}*/

/*!
 * @name Register SDMACORE_OSTAT, field PST[15:12] (RO)
 *
 * The Processor Status bits reflect the state of the SDMA RISC engine. The
 * "Program" state is the usual instruction execution cycle. The "Data" state is
 * inserted when there are wait-states during a load or a store on the data bus (ld
 * or st). The "Change of Flow" state is the second cycle of any instruction that
 * breaks the sequence of instructions (jumps and channel-switching
 * instructions). The "Change of Flow in Loop" state is used when an error causes a hardware
 * loop exit. The "Debug" state means the SDMA is in debug mode. The "Functional
 * Unit" state is inserted when there are wait-states during a load or a store on
 * the functional units bus (ldf or stf). In "Sleep" modes, no script is running
 * (this is the RISC engine idle state). The "after Reset" is slightly different
 * because no context restoring phase will happen when a channel is triggered:
 * The script located at address 0 will be executed (boot operation). The "in
 * Sleep" states are the same as above except they do not have any corresponding
 * channel. They are used when entering debug mode after reset; the reason is that it
 * is necessary to return to the "Sleep after Reset" state when leaving debug
 * mode.
 *
 * Values:
 * - 0 - Program
 * - 1 - Data
 * - 10 - Change of Flow in Sleep
 * - 11 - Change Flow Loop Sleep
 */
/*@{*/
#define BP_SDMACORE_OSTAT_PST (12U)        /*!< Bit position for SDMACORE_OSTAT_PST. */
#define BM_SDMACORE_OSTAT_PST (0x0000F000U) /*!< Bit mask for SDMACORE_OSTAT_PST. */
#define BS_SDMACORE_OSTAT_PST (4U)         /*!< Bit field size in bits for SDMACORE_OSTAT_PST. */

/*! @brief Read current value of the SDMACORE_OSTAT_PST field. */
#define BR_SDMACORE_OSTAT_PST(x) (HW_SDMACORE_OSTAT(x).B.PST)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_MCHN0ADDR - Channel 0 Boot Address
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_MCHN0ADDR - Channel 0 Boot Address (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_mchn0addr
{
    uint32_t U;
    struct _hw_sdmacore_mchn0addr_bitfields
    {
        uint32_t CHN0ADDR : 14;        /*!< [13:0]  */
        uint32_t SMSZ : 1;             /*!< [14]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_sdmacore_mchn0addr_t;

/*!
 * @name Constants and macros for entire SDMACORE_MCHN0ADDR register
 */
/*@{*/
#define HW_SDMACORE_MCHN0ADDR_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_SDMACORE_MCHN0ADDR(x) (*(__I hw_sdmacore_mchn0addr_t *) HW_SDMACORE_MCHN0ADDR_ADDR(x))
#define HW_SDMACORE_MCHN0ADDR_RD(x) (HW_SDMACORE_MCHN0ADDR(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_MCHN0ADDR bitfields
 */

/*!
 * @name Register SDMACORE_MCHN0ADDR, field CHN0ADDR[13:0] (RO)
 *
 * Contains the address of the channel 0 routine programmed by the ARM platform;
 * it is loaded into a general register at the very start of the boot and the
 * SDMA jumps to the address it contains. By default, it points to the standard
 * boot routine in ROM.
 */
/*@{*/
#define BP_SDMACORE_MCHN0ADDR_CHN0ADDR (0U) /*!< Bit position for SDMACORE_MCHN0ADDR_CHN0ADDR. */
#define BM_SDMACORE_MCHN0ADDR_CHN0ADDR (0x00003FFFU) /*!< Bit mask for SDMACORE_MCHN0ADDR_CHN0ADDR. */
#define BS_SDMACORE_MCHN0ADDR_CHN0ADDR (14U) /*!< Bit field size in bits for SDMACORE_MCHN0ADDR_CHN0ADDR. */

/*! @brief Read current value of the SDMACORE_MCHN0ADDR_CHN0ADDR field. */
#define BR_SDMACORE_MCHN0ADDR_CHN0ADDR(x) (HW_SDMACORE_MCHN0ADDR(x).B.CHN0ADDR)
/*@}*/

/*!
 * @name Register SDMACORE_MCHN0ADDR, field SMSZ[14] (RO)
 *
 * The bit 14 (Scratch Memory Size) determines if scratch memory must be
 * available after every channel context. After reset, it is equal to 0, which defines a
 * RAM space of 24 words for each channel. All of this area stores the channel
 * context. By setting this bit, 32 words are reserved for every channel context,
 * which gives eight additional words that can be used by the channel script to
 * store any type of data. Those words are never erased by the context switching
 * mechanism.
 *
 * Values:
 * - 0 - 24 words per context
 * - 1 - 32 words per context
 */
/*@{*/
#define BP_SDMACORE_MCHN0ADDR_SMSZ (14U)   /*!< Bit position for SDMACORE_MCHN0ADDR_SMSZ. */
#define BM_SDMACORE_MCHN0ADDR_SMSZ (0x00004000U) /*!< Bit mask for SDMACORE_MCHN0ADDR_SMSZ. */
#define BS_SDMACORE_MCHN0ADDR_SMSZ (1U)    /*!< Bit field size in bits for SDMACORE_MCHN0ADDR_SMSZ. */

/*! @brief Read current value of the SDMACORE_MCHN0ADDR_SMSZ field. */
#define BR_SDMACORE_MCHN0ADDR_SMSZ(x) (HW_SDMACORE_MCHN0ADDR(x).B.SMSZ)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_ENDIANNESS - ENDIAN Status Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_ENDIANNESS - ENDIAN Status Register (RO)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_sdmacore_endianness
{
    uint32_t U;
    struct _hw_sdmacore_endianness_bitfields
    {
        uint32_t APEND : 1;            /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_sdmacore_endianness_t;

/*!
 * @name Constants and macros for entire SDMACORE_ENDIANNESS register
 */
/*@{*/
#define HW_SDMACORE_ENDIANNESS_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_SDMACORE_ENDIANNESS(x) (*(__I hw_sdmacore_endianness_t *) HW_SDMACORE_ENDIANNESS_ADDR(x))
#define HW_SDMACORE_ENDIANNESS_RD(x) (HW_SDMACORE_ENDIANNESS(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_ENDIANNESS bitfields
 */

/*!
 * @name Register SDMACORE_ENDIANNESS, field APEND[0] (RO)
 *
 * APEND indicates the endian mode of the Peripheral and Burst DMA interfaces.
 * This bit is tied to logic '1' indicating little-endian mode.
 *
 * Values:
 * - 0 - - ARM platform is in big-endian mode
 * - 1 - - ARM platform is in little-endian mode
 */
/*@{*/
#define BP_SDMACORE_ENDIANNESS_APEND (0U)  /*!< Bit position for SDMACORE_ENDIANNESS_APEND. */
#define BM_SDMACORE_ENDIANNESS_APEND (0x00000001U) /*!< Bit mask for SDMACORE_ENDIANNESS_APEND. */
#define BS_SDMACORE_ENDIANNESS_APEND (1U)  /*!< Bit field size in bits for SDMACORE_ENDIANNESS_APEND. */

/*! @brief Read current value of the SDMACORE_ENDIANNESS_APEND field. */
#define BR_SDMACORE_ENDIANNESS_APEND(x) (HW_SDMACORE_ENDIANNESS(x).B.APEND)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_SDMA_LOCK - Lock Status Register
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_SDMA_LOCK - Lock Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_sdma_lock
{
    uint32_t U;
    struct _hw_sdmacore_sdma_lock_bitfields
    {
        uint32_t LOCK : 1;             /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_sdmacore_sdma_lock_t;

/*!
 * @name Constants and macros for entire SDMACORE_SDMA_LOCK register
 */
/*@{*/
#define HW_SDMACORE_SDMA_LOCK_ADDR(x) ((uintptr_t)(x) + 0x4CU)

#define HW_SDMACORE_SDMA_LOCK(x) (*(__I hw_sdmacore_sdma_lock_t *) HW_SDMACORE_SDMA_LOCK_ADDR(x))
#define HW_SDMACORE_SDMA_LOCK_RD(x) (HW_SDMACORE_SDMA_LOCK(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_SDMA_LOCK bitfields
 */

/*!
 * @name Register SDMACORE_SDMA_LOCK, field LOCK[0] (RO)
 *
 * The LOCK bit reports the value of the LOCK bit in the SDMA_LOCK status
 * register. SDMA software may use this value to determine if certain operations such
 * as loading of new scripts is allowed.
 *
 * Values:
 * - 0 - - LOCK bit clear
 * - 1 - - LOCK bit set
 */
/*@{*/
#define BP_SDMACORE_SDMA_LOCK_LOCK (0U)    /*!< Bit position for SDMACORE_SDMA_LOCK_LOCK. */
#define BM_SDMACORE_SDMA_LOCK_LOCK (0x00000001U) /*!< Bit mask for SDMACORE_SDMA_LOCK_LOCK. */
#define BS_SDMACORE_SDMA_LOCK_LOCK (1U)    /*!< Bit field size in bits for SDMACORE_SDMA_LOCK_LOCK. */

/*! @brief Read current value of the SDMACORE_SDMA_LOCK_LOCK field. */
#define BR_SDMACORE_SDMA_LOCK_LOCK(x) (HW_SDMACORE_SDMA_LOCK(x).B.LOCK)
/*@}*/

/*******************************************************************************
 * HW_SDMACORE_EVENTS2 - External DMA Requests Mirror #2
 ******************************************************************************/

/*!
 * @brief HW_SDMACORE_EVENTS2 - External DMA Requests Mirror #2 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sdmacore_events2
{
    uint32_t U;
    struct _hw_sdmacore_events2_bitfields
    {
        uint32_t EVENTS : 16;          /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_sdmacore_events2_t;

/*!
 * @name Constants and macros for entire SDMACORE_EVENTS2 register
 */
/*@{*/
#define HW_SDMACORE_EVENTS2_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_SDMACORE_EVENTS2(x)   (*(__I hw_sdmacore_events2_t *) HW_SDMACORE_EVENTS2_ADDR(x))
#define HW_SDMACORE_EVENTS2_RD(x) (HW_SDMACORE_EVENTS2(x).U)
/*@}*/

/*
 * Constants & macros for individual SDMACORE_EVENTS2 bitfields
 */

/*!
 * @name Register SDMACORE_EVENTS2, field EVENTS[15:0] (RO)
 *
 * Reflects the status of the SDMA's external DMA requests. It is meant to allow
 * any channel to monitor the states of these SDMA inputs. This register
 * displays EVENTS 32-47. The separate EVENTS register displays events 0-31.
 */
/*@{*/
#define BP_SDMACORE_EVENTS2_EVENTS (0U)    /*!< Bit position for SDMACORE_EVENTS2_EVENTS. */
#define BM_SDMACORE_EVENTS2_EVENTS (0x0000FFFFU) /*!< Bit mask for SDMACORE_EVENTS2_EVENTS. */
#define BS_SDMACORE_EVENTS2_EVENTS (16U)   /*!< Bit field size in bits for SDMACORE_EVENTS2_EVENTS. */

/*! @brief Read current value of the SDMACORE_EVENTS2_EVENTS field. */
#define BR_SDMACORE_EVENTS2_EVENTS(x) (HW_SDMACORE_EVENTS2(x).B.EVENTS)
/*@}*/

/*******************************************************************************
 * hw_sdmacore_t - module struct
 ******************************************************************************/
/*!
 * @brief All SDMACORE module registers.
 */
#pragma pack(1)
typedef struct _hw_sdmacore
{
    __I hw_sdmacore_mc0ptr_t MC0PTR;       /*!< [0x0] ARM platform Channel 0 Pointer */
    __I hw_sdmacore_ccptr_t CCPTR;         /*!< [0x4] Current Channel Pointer */
    __I hw_sdmacore_ccr_t CCR;             /*!< [0x8] Current Channel Register */
    __I hw_sdmacore_ncr_t NCR;             /*!< [0xC] Highest Pending Channel Register */
    __I hw_sdmacore_events_t EVENTS;       /*!< [0x10] External DMA Requests Mirror */
    __I hw_sdmacore_ccpri_t CCPRI;         /*!< [0x14] Current Channel Priority */
    __I hw_sdmacore_ncpri_t NCPRI;         /*!< [0x18] Next Channel Priority */
    __IO hw_sdmacore_ecount_t ECOUNT;      /*!< [0x1C] OnCE Event Cell Counter */
    __IO hw_sdmacore_ectl_t ECTL;          /*!< [0x20] OnCE Event Cell Control Register */
    __IO hw_sdmacore_eaa_t EAA;            /*!< [0x24] OnCE Event Address Register A */
    __IO hw_sdmacore_eab_t EAB;            /*!< [0x28] OnCE Event Cell Address Register B */
    __IO hw_sdmacore_eam_t EAM;            /*!< [0x2C] OnCE Event Cell Address Mask */
    __IO hw_sdmacore_ed_t ED;              /*!< [0x30] OnCE Event Cell Data Register */
    __IO hw_sdmacore_edm_t EDM;            /*!< [0x34] OnCE Event Cell Data Mask */
    __IO hw_sdmacore_rtb_t RTB;            /*!< [0x38] OnCE Real-Time Buffer */
    __I hw_sdmacore_tb_t TB;               /*!< [0x3C] OnCE Trace Buffer */
    __I hw_sdmacore_ostat_t OSTAT;         /*!< [0x40] OnCE Status */
    __I hw_sdmacore_mchn0addr_t MCHN0ADDR; /*!< [0x44] Channel 0 Boot Address */
    __I hw_sdmacore_endianness_t ENDIANNESS; /*!< [0x48] ENDIAN Status Register */
    __I hw_sdmacore_sdma_lock_t SDMA_LOCK; /*!< [0x4C] Lock Status Register */
    __I hw_sdmacore_events2_t EVENTS2;     /*!< [0x50] External DMA Requests Mirror #2 */
} hw_sdmacore_t;
#pragma pack()

/*! @brief Macro to access all SDMACORE registers. */
/*! @param x SDMACORE module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SDMACORE_REGS(SDMACORE_BASE)</code>. */
#define HW_SDMACORE_REGS(x) (*(hw_sdmacore_t *)(x))

/*
 * iMX6DP SJC
 *
 * SJC Registers
 *
 * Registers defined in this header file:
 * - HW_SJC_GPUSR1 - General Purpose Unsecured Status Register 1
 * - HW_SJC_GPUSR2 - General Purpose Unsecured Status Register 2
 * - HW_SJC_GPUSR3 - General Purpose Unsecured Status Register 3
 * - HW_SJC_GPSSR - General Purpose Secured Status Register
 * - HW_SJC_DCR - Debug Control Register
 * - HW_SJC_SSR - Security Status Register
 * - HW_SJC_GPCCR - General Purpose Clocks Control Register
 *
 * - hw_sjc_t - Struct containing all module registers.
 */

#define HW_SJC_INSTANCE_COUNT (1U) /*!< Number of instances of the SJC module. */
#define HW_SJC (0U) /*!< Instance number for SJC. */
#define SJC_BASE              (0x0U) /*!< Base address for SJC. */
/*! Array initializer of SJC base addresses. */
#define SJC_BASE_ADDRS        { SJC_BASE }

/*******************************************************************************
 * HW_SJC_GPUSR1 - General Purpose Unsecured Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_SJC_GPUSR1 - General Purpose Unsecured Status Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The General Purpose Unsecured Status Register 1 is a read only registers used
 * to check the status of the different Cores and of the PLL. The rest of its
 * bits are for general purpose use.
 */
typedef union _hw_sjc_gpusr1
{
    uint32_t U;
    struct _hw_sjc_gpusr1_bitfields
    {
        uint32_t A_DBG : 1;            /*!< [0]  */
        uint32_t A_WFI : 1;            /*!< [1]  */
        uint32_t S_STAT : 3;           /*!< [4:2]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t PLL_LOCK : 1;         /*!< [8]  */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_sjc_gpusr1_t;

/*!
 * @name Constants and macros for entire SJC_GPUSR1 register
 */
/*@{*/
#define HW_SJC_GPUSR1_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_SJC_GPUSR1(x)         (*(__I hw_sjc_gpusr1_t *) HW_SJC_GPUSR1_ADDR(x))
#define HW_SJC_GPUSR1_RD(x)      (HW_SJC_GPUSR1(x).U)
/*@}*/

/*
 * Constants & macros for individual SJC_GPUSR1 bitfields
 */

/*!
 * @name Register SJC_GPUSR1, field A_DBG[0] (RO)
 *
 * ARM core debug status bit Bit 0 is the ARM core DBGACK (debug acknowledge)
 * DBGACK can be overwritten in the ARM core DCR to force a particular DBGACK
 * value. Consequently interpretation of the DBGACK value is highly dependent on the
 * debug sequence. When this bit is HIGH, ARM core is in debug.
 */
/*@{*/
#define BP_SJC_GPUSR1_A_DBG  (0U)          /*!< Bit position for SJC_GPUSR1_A_DBG. */
#define BM_SJC_GPUSR1_A_DBG  (0x00000001U) /*!< Bit mask for SJC_GPUSR1_A_DBG. */
#define BS_SJC_GPUSR1_A_DBG  (1U)          /*!< Bit field size in bits for SJC_GPUSR1_A_DBG. */

/*! @brief Read current value of the SJC_GPUSR1_A_DBG field. */
#define BR_SJC_GPUSR1_A_DBG(x) (HW_SJC_GPUSR1(x).B.A_DBG)
/*@}*/

/*!
 * @name Register SJC_GPUSR1, field A_WFI[1] (RO)
 *
 * ARM core wait-for interrupt bit Bit 1 is the ARM core standbywfi (stand by
 * wait-for interrupt). When this bit is HIGH, ARM core is in wait for interrupt
 * mode.
 */
/*@{*/
#define BP_SJC_GPUSR1_A_WFI  (1U)          /*!< Bit position for SJC_GPUSR1_A_WFI. */
#define BM_SJC_GPUSR1_A_WFI  (0x00000002U) /*!< Bit mask for SJC_GPUSR1_A_WFI. */
#define BS_SJC_GPUSR1_A_WFI  (1U)          /*!< Bit field size in bits for SJC_GPUSR1_A_WFI. */

/*! @brief Read current value of the SJC_GPUSR1_A_WFI field. */
#define BR_SJC_GPUSR1_A_WFI(x) (HW_SJC_GPUSR1(x).B.A_WFI)
/*@}*/

/*!
 * @name Register SJC_GPUSR1, field S_STAT[4:2] (RO)
 *
 * 3 LSBits of SDMA core statusH.
 */
/*@{*/
#define BP_SJC_GPUSR1_S_STAT (2U)          /*!< Bit position for SJC_GPUSR1_S_STAT. */
#define BM_SJC_GPUSR1_S_STAT (0x0000001CU) /*!< Bit mask for SJC_GPUSR1_S_STAT. */
#define BS_SJC_GPUSR1_S_STAT (3U)          /*!< Bit field size in bits for SJC_GPUSR1_S_STAT. */

/*! @brief Read current value of the SJC_GPUSR1_S_STAT field. */
#define BR_SJC_GPUSR1_S_STAT(x) (HW_SJC_GPUSR1(x).B.S_STAT)
/*@}*/

/*!
 * @name Register SJC_GPUSR1, field PLL_LOCK[8] (RO)
 *
 * PLL_LOCK A Combined PLL-Lock flag indicator, for all the PLL's.
 */
/*@{*/
#define BP_SJC_GPUSR1_PLL_LOCK (8U)        /*!< Bit position for SJC_GPUSR1_PLL_LOCK. */
#define BM_SJC_GPUSR1_PLL_LOCK (0x00000100U) /*!< Bit mask for SJC_GPUSR1_PLL_LOCK. */
#define BS_SJC_GPUSR1_PLL_LOCK (1U)        /*!< Bit field size in bits for SJC_GPUSR1_PLL_LOCK. */

/*! @brief Read current value of the SJC_GPUSR1_PLL_LOCK field. */
#define BR_SJC_GPUSR1_PLL_LOCK(x) (HW_SJC_GPUSR1(x).B.PLL_LOCK)
/*@}*/

/*******************************************************************************
 * HW_SJC_GPUSR2 - General Purpose Unsecured Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_SJC_GPUSR2 - General Purpose Unsecured Status Register 2 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sjc_gpusr2
{
    uint32_t U;
    struct _hw_sjc_gpusr2_bitfields
    {
        uint32_t STBYWFI : 4;          /*!< [3:0]  */
        uint32_t S_STAT : 4;           /*!< [7:4]  */
        uint32_t STBYWFE : 4;          /*!< [11:8]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_sjc_gpusr2_t;

/*!
 * @name Constants and macros for entire SJC_GPUSR2 register
 */
/*@{*/
#define HW_SJC_GPUSR2_ADDR(x)    ((uintptr_t)(x) + 0x4U)

#define HW_SJC_GPUSR2(x)         (*(__I hw_sjc_gpusr2_t *) HW_SJC_GPUSR2_ADDR(x))
#define HW_SJC_GPUSR2_RD(x)      (HW_SJC_GPUSR2(x).U)
/*@}*/

/*
 * Constants & macros for individual SJC_GPUSR2 bitfields
 */

/*!
 * @name Register SJC_GPUSR2, field STBYWFI[3:0] (RO)
 *
 * STBYWFI[3:0] These bits provide status of "Standby Wait-For-Interrupt" state
 * of all ARM cores.
 */
/*@{*/
#define BP_SJC_GPUSR2_STBYWFI (0U)         /*!< Bit position for SJC_GPUSR2_STBYWFI. */
#define BM_SJC_GPUSR2_STBYWFI (0x0000000FU) /*!< Bit mask for SJC_GPUSR2_STBYWFI. */
#define BS_SJC_GPUSR2_STBYWFI (4U)         /*!< Bit field size in bits for SJC_GPUSR2_STBYWFI. */

/*! @brief Read current value of the SJC_GPUSR2_STBYWFI field. */
#define BR_SJC_GPUSR2_STBYWFI(x) (HW_SJC_GPUSR2(x).B.STBYWFI)
/*@}*/

/*!
 * @name Register SJC_GPUSR2, field S_STAT[7:4] (RO)
 *
 * S_STAT[3:0] SDMA debug status bits: debug_core_state[3:0]
 */
/*@{*/
#define BP_SJC_GPUSR2_S_STAT (4U)          /*!< Bit position for SJC_GPUSR2_S_STAT. */
#define BM_SJC_GPUSR2_S_STAT (0x000000F0U) /*!< Bit mask for SJC_GPUSR2_S_STAT. */
#define BS_SJC_GPUSR2_S_STAT (4U)          /*!< Bit field size in bits for SJC_GPUSR2_S_STAT. */

/*! @brief Read current value of the SJC_GPUSR2_S_STAT field. */
#define BR_SJC_GPUSR2_S_STAT(x) (HW_SJC_GPUSR2(x).B.S_STAT)
/*@}*/

/*!
 * @name Register SJC_GPUSR2, field STBYWFE[11:8] (RO)
 *
 * STBYWFE[3:0] Reflecting the "Standby Wait For Event" signals of all cores.
 */
/*@{*/
#define BP_SJC_GPUSR2_STBYWFE (8U)         /*!< Bit position for SJC_GPUSR2_STBYWFE. */
#define BM_SJC_GPUSR2_STBYWFE (0x00000F00U) /*!< Bit mask for SJC_GPUSR2_STBYWFE. */
#define BS_SJC_GPUSR2_STBYWFE (4U)         /*!< Bit field size in bits for SJC_GPUSR2_STBYWFE. */

/*! @brief Read current value of the SJC_GPUSR2_STBYWFE field. */
#define BR_SJC_GPUSR2_STBYWFE(x) (HW_SJC_GPUSR2(x).B.STBYWFE)
/*@}*/

/*******************************************************************************
 * HW_SJC_GPUSR3 - General Purpose Unsecured Status Register 3
 ******************************************************************************/

/*!
 * @brief HW_SJC_GPUSR3 - General Purpose Unsecured Status Register 3 (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sjc_gpusr3
{
    uint32_t U;
    struct _hw_sjc_gpusr3_bitfields
    {
        uint32_t IPG_WAIT : 1;         /*!< [0]  */
        uint32_t IPG_STOP : 1;         /*!< [1]  */
        uint32_t SYS_WAIT : 1;         /*!< [2]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_sjc_gpusr3_t;

/*!
 * @name Constants and macros for entire SJC_GPUSR3 register
 */
/*@{*/
#define HW_SJC_GPUSR3_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_SJC_GPUSR3(x)         (*(__I hw_sjc_gpusr3_t *) HW_SJC_GPUSR3_ADDR(x))
#define HW_SJC_GPUSR3_RD(x)      (HW_SJC_GPUSR3(x).U)
/*@}*/

/*
 * Constants & macros for individual SJC_GPUSR3 bitfields
 */

/*!
 * @name Register SJC_GPUSR3, field IPG_WAIT[0] (RO)
 *
 * IPG_WAIT CCM's "ipg_wait" signal indication
 */
/*@{*/
#define BP_SJC_GPUSR3_IPG_WAIT (0U)        /*!< Bit position for SJC_GPUSR3_IPG_WAIT. */
#define BM_SJC_GPUSR3_IPG_WAIT (0x00000001U) /*!< Bit mask for SJC_GPUSR3_IPG_WAIT. */
#define BS_SJC_GPUSR3_IPG_WAIT (1U)        /*!< Bit field size in bits for SJC_GPUSR3_IPG_WAIT. */

/*! @brief Read current value of the SJC_GPUSR3_IPG_WAIT field. */
#define BR_SJC_GPUSR3_IPG_WAIT(x) (HW_SJC_GPUSR3(x).B.IPG_WAIT)
/*@}*/

/*!
 * @name Register SJC_GPUSR3, field IPG_STOP[1] (RO)
 *
 * IPG_STOP CCM's "ipg_stop" signal indication
 */
/*@{*/
#define BP_SJC_GPUSR3_IPG_STOP (1U)        /*!< Bit position for SJC_GPUSR3_IPG_STOP. */
#define BM_SJC_GPUSR3_IPG_STOP (0x00000002U) /*!< Bit mask for SJC_GPUSR3_IPG_STOP. */
#define BS_SJC_GPUSR3_IPG_STOP (1U)        /*!< Bit field size in bits for SJC_GPUSR3_IPG_STOP. */

/*! @brief Read current value of the SJC_GPUSR3_IPG_STOP field. */
#define BR_SJC_GPUSR3_IPG_STOP(x) (HW_SJC_GPUSR3(x).B.IPG_STOP)
/*@}*/

/*!
 * @name Register SJC_GPUSR3, field SYS_WAIT[2] (RO)
 *
 * System In wait Indication on System in wait mode (from CCM).
 */
/*@{*/
#define BP_SJC_GPUSR3_SYS_WAIT (2U)        /*!< Bit position for SJC_GPUSR3_SYS_WAIT. */
#define BM_SJC_GPUSR3_SYS_WAIT (0x00000004U) /*!< Bit mask for SJC_GPUSR3_SYS_WAIT. */
#define BS_SJC_GPUSR3_SYS_WAIT (1U)        /*!< Bit field size in bits for SJC_GPUSR3_SYS_WAIT. */

/*! @brief Read current value of the SJC_GPUSR3_SYS_WAIT field. */
#define BR_SJC_GPUSR3_SYS_WAIT(x) (HW_SJC_GPUSR3(x).B.SYS_WAIT)
/*@}*/

/*******************************************************************************
 * HW_SJC_GPSSR - General Purpose Secured Status Register
 ******************************************************************************/

/*!
 * @brief HW_SJC_GPSSR - General Purpose Secured Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The General Purpose Secured Status Register is a read-only register used to
 * check the status of the different critical information in the SoC. This
 * register cannot be accessed in secure modes.
 */
typedef union _hw_sjc_gpssr
{
    uint32_t U;
    struct _hw_sjc_gpssr_bitfields
    {
        uint32_t GPSSR : 32;           /*!< [31:0]  */
    } B;
} hw_sjc_gpssr_t;

/*!
 * @name Constants and macros for entire SJC_GPSSR register
 */
/*@{*/
#define HW_SJC_GPSSR_ADDR(x)     ((uintptr_t)(x) + 0xCU)

#define HW_SJC_GPSSR(x)          (*(__I hw_sjc_gpssr_t *) HW_SJC_GPSSR_ADDR(x))
#define HW_SJC_GPSSR_RD(x)       (HW_SJC_GPSSR(x).U)
/*@}*/

/*
 * Constants & macros for individual SJC_GPSSR bitfields
 */

/*!
 * @name Register SJC_GPSSR, field GPSSR[31:0] (RO)
 *
 * General Purpose Secured Status Register Register is used for testing and
 * debug.
 */
/*@{*/
#define BP_SJC_GPSSR_GPSSR   (0U)          /*!< Bit position for SJC_GPSSR_GPSSR. */
#define BM_SJC_GPSSR_GPSSR   (0xFFFFFFFFU) /*!< Bit mask for SJC_GPSSR_GPSSR. */
#define BS_SJC_GPSSR_GPSSR   (32U)         /*!< Bit field size in bits for SJC_GPSSR_GPSSR. */

/*! @brief Read current value of the SJC_GPSSR_GPSSR field. */
#define BR_SJC_GPSSR_GPSSR(x) (HW_SJC_GPSSR(x).U)
/*@}*/

/*******************************************************************************
 * HW_SJC_DCR - Debug Control Register
 ******************************************************************************/

/*!
 * @brief HW_SJC_DCR - Debug Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control propagation of debug request from DE_B pad
 * to the cores and debug signals from internal logic to the DE_B pad.
 */
typedef union _hw_sjc_dcr
{
    uint32_t U;
    struct _hw_sjc_dcr_bitfields
    {
        uint32_t DE_TO_ARM : 1;        /*!< [0]  */
        uint32_t DE_TO_SDMA : 1;       /*!< [1]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t DEBUG_OBS : 1;        /*!< [3]  */
        uint32_t RESERVED1 : 1;        /*!< [4]  */
        uint32_t DIRECT_SDMA_REQ_EN : 1; /*!< [5]  */
        uint32_t DIRECT_ARM_REQ_EN : 1; /*!< [6]  */
        uint32_t RESERVED2 : 25;       /*!< [31:7]  */
    } B;
} hw_sjc_dcr_t;

/*!
 * @name Constants and macros for entire SJC_DCR register
 */
/*@{*/
#define HW_SJC_DCR_ADDR(x)       ((uintptr_t)(x) + 0x10U)

#define HW_SJC_DCR(x)            (*(__IO hw_sjc_dcr_t *) HW_SJC_DCR_ADDR(x))
#define HW_SJC_DCR_RD(x)         (HW_SJC_DCR(x).U)
#define HW_SJC_DCR_WR(x, v)      (HW_SJC_DCR(x).U = (v))
#define HW_SJC_DCR_SET(x, v)     (HW_SJC_DCR_WR(x, HW_SJC_DCR_RD(x) |  (v)))
#define HW_SJC_DCR_CLR(x, v)     (HW_SJC_DCR_WR(x, HW_SJC_DCR_RD(x) & ~(v)))
#define HW_SJC_DCR_TOG(x, v)     (HW_SJC_DCR_WR(x, HW_SJC_DCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SJC_DCR bitfields
 */

/*!
 * @name Register SJC_DCR, field DE_TO_ARM[0] (RW)
 *
 * ARM platform debug request input propagation This bit controls the
 * propagation of debug request to ARM platform ("dbgreq"), when the JTAG state machine is
 * put in "ENTER_DEBUG" IR instruction.
 *
 * Values:
 * - 0 - Disable propagation of debug request to ARM platform
 * - 1 - Enable propagation of debug request to ARM platform
 */
/*@{*/
#define BP_SJC_DCR_DE_TO_ARM (0U)          /*!< Bit position for SJC_DCR_DE_TO_ARM. */
#define BM_SJC_DCR_DE_TO_ARM (0x00000001U) /*!< Bit mask for SJC_DCR_DE_TO_ARM. */
#define BS_SJC_DCR_DE_TO_ARM (1U)          /*!< Bit field size in bits for SJC_DCR_DE_TO_ARM. */

/*! @brief Read current value of the SJC_DCR_DE_TO_ARM field. */
#define BR_SJC_DCR_DE_TO_ARM(x) (HW_SJC_DCR(x).B.DE_TO_ARM)

/*! @brief Format value for bitfield SJC_DCR_DE_TO_ARM. */
#define BF_SJC_DCR_DE_TO_ARM(v) ((uint32_t)((uint32_t)(v) << BP_SJC_DCR_DE_TO_ARM) & BM_SJC_DCR_DE_TO_ARM)

/*! @brief Set the DE_TO_ARM field to a new value. */
#define BW_SJC_DCR_DE_TO_ARM(x, v) (HW_SJC_DCR_WR(x, (HW_SJC_DCR_RD(x) & ~BM_SJC_DCR_DE_TO_ARM) | BF_SJC_DCR_DE_TO_ARM(v)))
/*@}*/

/*!
 * @name Register SJC_DCR, field DE_TO_SDMA[1] (RW)
 *
 * SDMA debug request input propagation This bit controls the propagation of
 * debug request to SDMA, when the JTAG state machine is put in "ENTER_DEBUG" IR
 * instruction..
 *
 * Values:
 * - 0 - Disable propagation of debug request to SDMA
 * - 1 - Enable propagation of debug request to SDMA
 */
/*@{*/
#define BP_SJC_DCR_DE_TO_SDMA (1U)         /*!< Bit position for SJC_DCR_DE_TO_SDMA. */
#define BM_SJC_DCR_DE_TO_SDMA (0x00000002U) /*!< Bit mask for SJC_DCR_DE_TO_SDMA. */
#define BS_SJC_DCR_DE_TO_SDMA (1U)         /*!< Bit field size in bits for SJC_DCR_DE_TO_SDMA. */

/*! @brief Read current value of the SJC_DCR_DE_TO_SDMA field. */
#define BR_SJC_DCR_DE_TO_SDMA(x) (HW_SJC_DCR(x).B.DE_TO_SDMA)

/*! @brief Format value for bitfield SJC_DCR_DE_TO_SDMA. */
#define BF_SJC_DCR_DE_TO_SDMA(v) ((uint32_t)((uint32_t)(v) << BP_SJC_DCR_DE_TO_SDMA) & BM_SJC_DCR_DE_TO_SDMA)

/*! @brief Set the DE_TO_SDMA field to a new value. */
#define BW_SJC_DCR_DE_TO_SDMA(x, v) (HW_SJC_DCR_WR(x, (HW_SJC_DCR_RD(x) & ~BM_SJC_DCR_DE_TO_SDMA) | BF_SJC_DCR_DE_TO_SDMA(v)))
/*@}*/

/*!
 * @name Register SJC_DCR, field DEBUG_OBS[3] (RW)
 *
 * Debug observability This bit controls the propagation of the "system debug"
 * input to SJC (driven by the ECT logic), to the DE_B pad. (This logic can be
 * used to pass debug acknowledge event from ECT out to the PAD, for example). The
 * SJC's "system_debug" input is tied to logic HIGH value, therefore, set of
 * "debug_obs" bit, will result in unconditional assertion of DE_B pad.
 *
 * Values:
 * - 0 - Disable propagation of system debug to DE_B pin
 * - 1 - Unconditional assertion of pad DE_B
 */
/*@{*/
#define BP_SJC_DCR_DEBUG_OBS (3U)          /*!< Bit position for SJC_DCR_DEBUG_OBS. */
#define BM_SJC_DCR_DEBUG_OBS (0x00000008U) /*!< Bit mask for SJC_DCR_DEBUG_OBS. */
#define BS_SJC_DCR_DEBUG_OBS (1U)          /*!< Bit field size in bits for SJC_DCR_DEBUG_OBS. */

/*! @brief Read current value of the SJC_DCR_DEBUG_OBS field. */
#define BR_SJC_DCR_DEBUG_OBS(x) (HW_SJC_DCR(x).B.DEBUG_OBS)

/*! @brief Format value for bitfield SJC_DCR_DEBUG_OBS. */
#define BF_SJC_DCR_DEBUG_OBS(v) ((uint32_t)((uint32_t)(v) << BP_SJC_DCR_DEBUG_OBS) & BM_SJC_DCR_DEBUG_OBS)

/*! @brief Set the DEBUG_OBS field to a new value. */
#define BW_SJC_DCR_DEBUG_OBS(x, v) (HW_SJC_DCR_WR(x, (HW_SJC_DCR_RD(x) & ~BM_SJC_DCR_DEBUG_OBS) | BF_SJC_DCR_DEBUG_OBS(v)))
/*@}*/

/*!
 * @name Register SJC_DCR, field DIRECT_SDMA_REQ_EN[5] (RW)
 *
 * Debug enable of the sdma debug request This bit controls the propagation of
 * debug request DE_B to the sdma.
 *
 * Values:
 * - 0 - Disable propagation of system debug to (DE_B pin) to sdma.
 * - 1 - Enable propagation of system debug to (DE_B pin) to sdma.
 */
/*@{*/
#define BP_SJC_DCR_DIRECT_SDMA_REQ_EN (5U) /*!< Bit position for SJC_DCR_DIRECT_SDMA_REQ_EN. */
#define BM_SJC_DCR_DIRECT_SDMA_REQ_EN (0x00000020U) /*!< Bit mask for SJC_DCR_DIRECT_SDMA_REQ_EN. */
#define BS_SJC_DCR_DIRECT_SDMA_REQ_EN (1U) /*!< Bit field size in bits for SJC_DCR_DIRECT_SDMA_REQ_EN. */

/*! @brief Read current value of the SJC_DCR_DIRECT_SDMA_REQ_EN field. */
#define BR_SJC_DCR_DIRECT_SDMA_REQ_EN(x) (HW_SJC_DCR(x).B.DIRECT_SDMA_REQ_EN)

/*! @brief Format value for bitfield SJC_DCR_DIRECT_SDMA_REQ_EN. */
#define BF_SJC_DCR_DIRECT_SDMA_REQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_SJC_DCR_DIRECT_SDMA_REQ_EN) & BM_SJC_DCR_DIRECT_SDMA_REQ_EN)

/*! @brief Set the DIRECT_SDMA_REQ_EN field to a new value. */
#define BW_SJC_DCR_DIRECT_SDMA_REQ_EN(x, v) (HW_SJC_DCR_WR(x, (HW_SJC_DCR_RD(x) & ~BM_SJC_DCR_DIRECT_SDMA_REQ_EN) | BF_SJC_DCR_DIRECT_SDMA_REQ_EN(v)))
/*@}*/

/*!
 * @name Register SJC_DCR, field DIRECT_ARM_REQ_EN[6] (RW)
 *
 * Pass Debug Enable event from DE_B pin to ARM platform debug request
 * signal(s). This bit controls the propagation of debug request DE_B to the Arm platform.
 *
 * Values:
 * - 0 - Disable propagation of system debug to (DE_B pin) to Arm platform.
 * - 1 - Enable propagation of system debug to (DE_B pin) to Arm platform.
 */
/*@{*/
#define BP_SJC_DCR_DIRECT_ARM_REQ_EN (6U)  /*!< Bit position for SJC_DCR_DIRECT_ARM_REQ_EN. */
#define BM_SJC_DCR_DIRECT_ARM_REQ_EN (0x00000040U) /*!< Bit mask for SJC_DCR_DIRECT_ARM_REQ_EN. */
#define BS_SJC_DCR_DIRECT_ARM_REQ_EN (1U)  /*!< Bit field size in bits for SJC_DCR_DIRECT_ARM_REQ_EN. */

/*! @brief Read current value of the SJC_DCR_DIRECT_ARM_REQ_EN field. */
#define BR_SJC_DCR_DIRECT_ARM_REQ_EN(x) (HW_SJC_DCR(x).B.DIRECT_ARM_REQ_EN)

/*! @brief Format value for bitfield SJC_DCR_DIRECT_ARM_REQ_EN. */
#define BF_SJC_DCR_DIRECT_ARM_REQ_EN(v) ((uint32_t)((uint32_t)(v) << BP_SJC_DCR_DIRECT_ARM_REQ_EN) & BM_SJC_DCR_DIRECT_ARM_REQ_EN)

/*! @brief Set the DIRECT_ARM_REQ_EN field to a new value. */
#define BW_SJC_DCR_DIRECT_ARM_REQ_EN(x, v) (HW_SJC_DCR_WR(x, (HW_SJC_DCR_RD(x) & ~BM_SJC_DCR_DIRECT_ARM_REQ_EN) | BF_SJC_DCR_DIRECT_ARM_REQ_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_SJC_SSR - Security Status Register
 ******************************************************************************/

/*!
 * @brief HW_SJC_SSR - Security Status Register (RO)
 *
 * Reset value: 0x00000100U
 */
typedef union _hw_sjc_ssr
{
    uint32_t U;
    struct _hw_sjc_ssr_bitfields
    {
        uint32_t KTF : 1;              /*!< [0]  */
        uint32_t KTA : 1;              /*!< [1]  */
        uint32_t SWF : 1;              /*!< [2]  */
        uint32_t SWE : 1;              /*!< [3]  */
        uint32_t EBF : 1;              /*!< [4]  */
        uint32_t EBG : 1;              /*!< [5]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t FT : 1;               /*!< [8]  */
        uint32_t SJM : 2;              /*!< [10:9]  */
        uint32_t RSSTAT : 2;           /*!< [12:11]  */
        uint32_t RESERVED1 : 1;        /*!< [13]  */
        uint32_t BOOTIND : 1;          /*!< [14]  */
        uint32_t RESERVED2 : 17;       /*!< [31:15]  */
    } B;
} hw_sjc_ssr_t;

/*!
 * @name Constants and macros for entire SJC_SSR register
 */
/*@{*/
#define HW_SJC_SSR_ADDR(x)       ((uintptr_t)(x) + 0x14U)

#define HW_SJC_SSR(x)            (*(__I hw_sjc_ssr_t *) HW_SJC_SSR_ADDR(x))
#define HW_SJC_SSR_RD(x)         (HW_SJC_SSR(x).U)
/*@}*/

/*
 * Constants & macros for individual SJC_SSR bitfields
 */

/*!
 * @name Register SJC_SSR, field KTF[0] (RO)
 *
 * Kill Trace Enable fuse value
 *
 * Values:
 * - 0 - (intact) - kill trace is never active
 * - 1 - (burned) - kill trace functionality enabled
 */
/*@{*/
#define BP_SJC_SSR_KTF       (0U)          /*!< Bit position for SJC_SSR_KTF. */
#define BM_SJC_SSR_KTF       (0x00000001U) /*!< Bit mask for SJC_SSR_KTF. */
#define BS_SJC_SSR_KTF       (1U)          /*!< Bit field size in bits for SJC_SSR_KTF. */

/*! @brief Read current value of the SJC_SSR_KTF field. */
#define BR_SJC_SSR_KTF(x)    (HW_SJC_SSR(x).B.KTF)
/*@}*/

/*!
 * @name Register SJC_SSR, field KTA[1] (RO)
 *
 * Kill Trace is active
 *
 * Values:
 * - 1 - active
 * - 0 - not active
 */
/*@{*/
#define BP_SJC_SSR_KTA       (1U)          /*!< Bit position for SJC_SSR_KTA. */
#define BM_SJC_SSR_KTA       (0x00000002U) /*!< Bit mask for SJC_SSR_KTA. */
#define BS_SJC_SSR_KTA       (1U)          /*!< Bit field size in bits for SJC_SSR_KTA. */

/*! @brief Read current value of the SJC_SSR_KTA field. */
#define BR_SJC_SSR_KTA(x)    (HW_SJC_SSR(x).B.KTA)
/*@}*/

/*!
 * @name Register SJC_SSR, field SWF[2] (RO)
 *
 * Software JTAG enable fuse Status of the no SW disable JTAG fuse
 *
 * Values:
 * - 0 - (intact) - SW enable possible
 * - 1 - (intact) - no SW enable possible
 */
/*@{*/
#define BP_SJC_SSR_SWF       (2U)          /*!< Bit position for SJC_SSR_SWF. */
#define BM_SJC_SSR_SWF       (0x00000004U) /*!< Bit mask for SJC_SSR_SWF. */
#define BS_SJC_SSR_SWF       (1U)          /*!< Bit field size in bits for SJC_SSR_SWF. */

/*! @brief Read current value of the SJC_SSR_SWF field. */
#define BR_SJC_SSR_SWF(x)    (HW_SJC_SSR(x).B.SWF)
/*@}*/

/*!
 * @name Register SJC_SSR, field SWE[3] (RO)
 *
 * SW enable SW JTAG enable status
 *
 * Values:
 * - 1 - enabled
 * - 0 - disabled
 */
/*@{*/
#define BP_SJC_SSR_SWE       (3U)          /*!< Bit position for SJC_SSR_SWE. */
#define BM_SJC_SSR_SWE       (0x00000008U) /*!< Bit mask for SJC_SSR_SWE. */
#define BS_SJC_SSR_SWE       (1U)          /*!< Bit field size in bits for SJC_SSR_SWE. */

/*! @brief Read current value of the SJC_SSR_SWE field. */
#define BR_SJC_SSR_SWE(x)    (HW_SJC_SSR(x).B.SWE)
/*@}*/

/*!
 * @name Register SJC_SSR, field EBF[4] (RO)
 *
 * External Boot fuse Status of the external boot disable fuse
 *
 * Values:
 * - 0 - (intact) - external boot is allowed
 * - 1 - (burned) - external boot is disabled
 */
/*@{*/
#define BP_SJC_SSR_EBF       (4U)          /*!< Bit position for SJC_SSR_EBF. */
#define BM_SJC_SSR_EBF       (0x00000010U) /*!< Bit mask for SJC_SSR_EBF. */
#define BS_SJC_SSR_EBF       (1U)          /*!< Bit field size in bits for SJC_SSR_EBF. */

/*! @brief Read current value of the SJC_SSR_EBF field. */
#define BR_SJC_SSR_EBF(x)    (HW_SJC_SSR(x).B.EBF)
/*@}*/

/*!
 * @name Register SJC_SSR, field EBG[5] (RO)
 *
 * External boot granted External boot enabled, requested and granted
 *
 * Values:
 * - 1 - granted
 * - 0 - not granted
 */
/*@{*/
#define BP_SJC_SSR_EBG       (5U)          /*!< Bit position for SJC_SSR_EBG. */
#define BM_SJC_SSR_EBG       (0x00000020U) /*!< Bit mask for SJC_SSR_EBG. */
#define BS_SJC_SSR_EBG       (1U)          /*!< Bit field size in bits for SJC_SSR_EBG. */

/*! @brief Read current value of the SJC_SSR_EBG field. */
#define BR_SJC_SSR_EBG(x)    (HW_SJC_SSR(x).B.EBG)
/*@}*/

/*!
 * @name Register SJC_SSR, field FT[8] (RO)
 *
 * Fuse type Fuse type bit - e-fuse or laser fuse
 *
 * Values:
 * - 0 - E-fuse technology
 * - 1 - Laser fuse technology
 */
/*@{*/
#define BP_SJC_SSR_FT        (8U)          /*!< Bit position for SJC_SSR_FT. */
#define BM_SJC_SSR_FT        (0x00000100U) /*!< Bit mask for SJC_SSR_FT. */
#define BS_SJC_SSR_FT        (1U)          /*!< Bit field size in bits for SJC_SSR_FT. */

/*! @brief Read current value of the SJC_SSR_FT field. */
#define BR_SJC_SSR_FT(x)     (HW_SJC_SSR(x).B.FT)
/*@}*/

/*!
 * @name Register SJC_SSR, field SJM[10:9] (RO)
 *
 * SJC Secure mode Secure JTAG mode, as set by external fuses.
 *
 * Values:
 * - 00 - No debug (#1)
 * - 01 - Secure JTAG (#2)
 * - 10 - Reserved
 * - 11 - JTAG enabled (#3)
 */
/*@{*/
#define BP_SJC_SSR_SJM       (9U)          /*!< Bit position for SJC_SSR_SJM. */
#define BM_SJC_SSR_SJM       (0x00000600U) /*!< Bit mask for SJC_SSR_SJM. */
#define BS_SJC_SSR_SJM       (2U)          /*!< Bit field size in bits for SJC_SSR_SJM. */

/*! @brief Read current value of the SJC_SSR_SJM field. */
#define BR_SJC_SSR_SJM(x)    (HW_SJC_SSR(x).B.SJM)
/*@}*/

/*!
 * @name Register SJC_SSR, field RSSTAT[12:11] (RO)
 *
 * Response status Response status bits
 *
 * Values:
 * - 00 - Response wasn't entered
 * - 01 - Response was entered but not verified
 * - 10 - Response was entered and is incorrect
 * - 11 - Response is correct
 */
/*@{*/
#define BP_SJC_SSR_RSSTAT    (11U)         /*!< Bit position for SJC_SSR_RSSTAT. */
#define BM_SJC_SSR_RSSTAT    (0x00001800U) /*!< Bit mask for SJC_SSR_RSSTAT. */
#define BS_SJC_SSR_RSSTAT    (2U)          /*!< Bit field size in bits for SJC_SSR_RSSTAT. */

/*! @brief Read current value of the SJC_SSR_RSSTAT field. */
#define BR_SJC_SSR_RSSTAT(x) (HW_SJC_SSR(x).B.RSSTAT)
/*@}*/

/*!
 * @name Register SJC_SSR, field BOOTIND[14] (RO)
 *
 * Boot Indication Inverted Internal Boot indication, i.e inverse of SRC:
 * "src_int_boot" signal
 */
/*@{*/
#define BP_SJC_SSR_BOOTIND   (14U)         /*!< Bit position for SJC_SSR_BOOTIND. */
#define BM_SJC_SSR_BOOTIND   (0x00004000U) /*!< Bit mask for SJC_SSR_BOOTIND. */
#define BS_SJC_SSR_BOOTIND   (1U)          /*!< Bit field size in bits for SJC_SSR_BOOTIND. */

/*! @brief Read current value of the SJC_SSR_BOOTIND field. */
#define BR_SJC_SSR_BOOTIND(x) (HW_SJC_SSR(x).B.BOOTIND)
/*@}*/

/*******************************************************************************
 * HW_SJC_GPCCR - General Purpose Clocks Control Register
 ******************************************************************************/

/*!
 * @brief HW_SJC_GPCCR - General Purpose Clocks Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to configure clock related modes in SOC, see System
 * Configuration chapter for more information. Those bits are directly connected to
 * JTAG outputs. Bit 0 of GPCCR controls SDMA clocks invocation. When out of
 * reset, the SDMA is in sleep mode with no SDMA clock running. Unlike events, debug
 * requests does not wake SDMA if it is in sleep mode. The debug request is
 * recognized by the SDMA only when it exits sleep mode upon reception of an event. To
 * be able to enter debug mode even if no event is triggered, the SDMA clock on
 * bit needs to be set prior to sending the debug request (clear at reset).
 */
typedef union _hw_sjc_gpccr
{
    uint32_t U;
    struct _hw_sjc_gpccr_bitfields
    {
        uint32_t SCLKR : 1;            /*!< [0]  */
        uint32_t ACLKOFFDIS : 1;       /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_sjc_gpccr_t;

/*!
 * @name Constants and macros for entire SJC_GPCCR register
 */
/*@{*/
#define HW_SJC_GPCCR_ADDR(x)     ((uintptr_t)(x) + 0x18U)

#define HW_SJC_GPCCR(x)          (*(__IO hw_sjc_gpccr_t *) HW_SJC_GPCCR_ADDR(x))
#define HW_SJC_GPCCR_RD(x)       (HW_SJC_GPCCR(x).U)
#define HW_SJC_GPCCR_WR(x, v)    (HW_SJC_GPCCR(x).U = (v))
#define HW_SJC_GPCCR_SET(x, v)   (HW_SJC_GPCCR_WR(x, HW_SJC_GPCCR_RD(x) |  (v)))
#define HW_SJC_GPCCR_CLR(x, v)   (HW_SJC_GPCCR_WR(x, HW_SJC_GPCCR_RD(x) & ~(v)))
#define HW_SJC_GPCCR_TOG(x, v)   (HW_SJC_GPCCR_WR(x, HW_SJC_GPCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SJC_GPCCR bitfields
 */

/*!
 * @name Register SJC_GPCCR, field SCLKR[0] (RW)
 *
 * SDMA Clock ON Register - This bit forces the clock on of the SDMA
 */
/*@{*/
#define BP_SJC_GPCCR_SCLKR   (0U)          /*!< Bit position for SJC_GPCCR_SCLKR. */
#define BM_SJC_GPCCR_SCLKR   (0x00000001U) /*!< Bit mask for SJC_GPCCR_SCLKR. */
#define BS_SJC_GPCCR_SCLKR   (1U)          /*!< Bit field size in bits for SJC_GPCCR_SCLKR. */

/*! @brief Read current value of the SJC_GPCCR_SCLKR field. */
#define BR_SJC_GPCCR_SCLKR(x) (HW_SJC_GPCCR(x).B.SCLKR)

/*! @brief Format value for bitfield SJC_GPCCR_SCLKR. */
#define BF_SJC_GPCCR_SCLKR(v) ((uint32_t)((uint32_t)(v) << BP_SJC_GPCCR_SCLKR) & BM_SJC_GPCCR_SCLKR)

/*! @brief Set the SCLKR field to a new value. */
#define BW_SJC_GPCCR_SCLKR(x, v) (HW_SJC_GPCCR_WR(x, (HW_SJC_GPCCR_RD(x) & ~BM_SJC_GPCCR_SCLKR) | BF_SJC_GPCCR_SCLKR(v)))
/*@}*/

/*!
 * @name Register SJC_GPCCR, field ACLKOFFDIS[1] (RW)
 *
 * Disable/prevent ARM platform clock/power shutdown
 */
/*@{*/
#define BP_SJC_GPCCR_ACLKOFFDIS (1U)       /*!< Bit position for SJC_GPCCR_ACLKOFFDIS. */
#define BM_SJC_GPCCR_ACLKOFFDIS (0x00000002U) /*!< Bit mask for SJC_GPCCR_ACLKOFFDIS. */
#define BS_SJC_GPCCR_ACLKOFFDIS (1U)       /*!< Bit field size in bits for SJC_GPCCR_ACLKOFFDIS. */

/*! @brief Read current value of the SJC_GPCCR_ACLKOFFDIS field. */
#define BR_SJC_GPCCR_ACLKOFFDIS(x) (HW_SJC_GPCCR(x).B.ACLKOFFDIS)

/*! @brief Format value for bitfield SJC_GPCCR_ACLKOFFDIS. */
#define BF_SJC_GPCCR_ACLKOFFDIS(v) ((uint32_t)((uint32_t)(v) << BP_SJC_GPCCR_ACLKOFFDIS) & BM_SJC_GPCCR_ACLKOFFDIS)

/*! @brief Set the ACLKOFFDIS field to a new value. */
#define BW_SJC_GPCCR_ACLKOFFDIS(x, v) (HW_SJC_GPCCR_WR(x, (HW_SJC_GPCCR_RD(x) & ~BM_SJC_GPCCR_ACLKOFFDIS) | BF_SJC_GPCCR_ACLKOFFDIS(v)))
/*@}*/

/*******************************************************************************
 * hw_sjc_t - module struct
 ******************************************************************************/
/*!
 * @brief All SJC module registers.
 */
#pragma pack(1)
typedef struct _hw_sjc
{
    __I hw_sjc_gpusr1_t GPUSR1;            /*!< [0x0] General Purpose Unsecured Status Register 1 */
    __I hw_sjc_gpusr2_t GPUSR2;            /*!< [0x4] General Purpose Unsecured Status Register 2 */
    __I hw_sjc_gpusr3_t GPUSR3;            /*!< [0x8] General Purpose Unsecured Status Register 3 */
    __I hw_sjc_gpssr_t GPSSR;              /*!< [0xC] General Purpose Secured Status Register */
    __IO hw_sjc_dcr_t DCR;                 /*!< [0x10] Debug Control Register */
    __I hw_sjc_ssr_t SSR;                  /*!< [0x14] Security Status Register */
    __IO hw_sjc_gpccr_t GPCCR;             /*!< [0x18] General Purpose Clocks Control Register */
} hw_sjc_t;
#pragma pack()

/*! @brief Macro to access all SJC registers. */
/*! @param x SJC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SJC_REGS(SJC_BASE)</code>. */
#define HW_SJC_REGS(x) (*(hw_sjc_t *)(x))

/*
 * iMX6DP SNVS
 *
 * SNVS
 *
 * Registers defined in this header file:
 * - HW_SNVS_HPLR - SNVS_HP Lock Register
 * - HW_SNVS_HPCOMR - SNVS_HP Command Register
 * - HW_SNVS_HPCR - SNVS_HP Control Register
 * - HW_SNVS_HPSR - SNVS_HP Status Register
 * - HW_SNVS_HPRTCMR - SNVS_HP Real Time Counter MSB Register
 * - HW_SNVS_HPRTCLR - SNVS_HP Real Time Counter LSB Register
 * - HW_SNVS_HPTAMR - SNVS_HP Time Alarm MSB Register
 * - HW_SNVS_HPTALR - SNVS_HP Time Alarm LSB Register
 * - HW_SNVS_LPLR - SNVS_LP Lock Register
 * - HW_SNVS_LPCR - SNVS_LP Control Register
 * - HW_SNVS_LPSR - SNVS_LP Status Register
 * - HW_SNVS_LPSMCMR - SNVS_LP Secure Monotonic Counter MSB Register
 * - HW_SNVS_LPSMCLR - SNVS_LP Secure Monotonic Counter LSB Register
 * - HW_SNVS_LPGPR - SNVS_LP General Purpose Register
 * - HW_SNVS_HPVIDR1 - SNVS_HP Version ID Register 1
 * - HW_SNVS_HPVIDR2 - SNVS_HP Version ID Register 2
 *
 * - hw_snvs_t - Struct containing all module registers.
 */

#define HW_SNVS_INSTANCE_COUNT (1U) /*!< Number of instances of the SNVS module. */
#define HW_SNVS (0U) /*!< Instance number for SNVS. */
#define SNVS_BASE             (0x20CC000U) /*!< Base address for SNVS. */
/*! Array initializer of SNVS base addresses. */
#define SNVS_BASE_ADDRS       { SNVS_BASE }

/*******************************************************************************
 * HW_SNVS_HPLR - SNVS_HP Lock Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPLR - SNVS_HP Lock Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Lock Register contains lock bits for the SNVS registers. This is
 * a privileged write register.
 */
typedef union _hw_snvs_hplr
{
    uint32_t U;
    struct _hw_snvs_hplr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t MC_SL : 1;            /*!< [4]  */
        uint32_t GPR_SL : 1;           /*!< [5]  */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_snvs_hplr_t;

/*!
 * @name Constants and macros for entire SNVS_HPLR register
 */
/*@{*/
#define HW_SNVS_HPLR_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_SNVS_HPLR(x)          (*(__IO hw_snvs_hplr_t *) HW_SNVS_HPLR_ADDR(x))
#define HW_SNVS_HPLR_RD(x)       (HW_SNVS_HPLR(x).U)
#define HW_SNVS_HPLR_WR(x, v)    (HW_SNVS_HPLR(x).U = (v))
#define HW_SNVS_HPLR_SET(x, v)   (HW_SNVS_HPLR_WR(x, HW_SNVS_HPLR_RD(x) |  (v)))
#define HW_SNVS_HPLR_CLR(x, v)   (HW_SNVS_HPLR_WR(x, HW_SNVS_HPLR_RD(x) & ~(v)))
#define HW_SNVS_HPLR_TOG(x, v)   (HW_SNVS_HPLR_WR(x, HW_SNVS_HPLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPLR bitfields
 */

/*!
 * @name Register SNVS_HPLR, field MC_SL[4] (RW)
 *
 * Monotonic Counter Soft Lock When set, prevents any writes (increments) to the
 * MC Registers and MC_ENV bit. Once set, this bit can only be reset by the
 * system reset.
 *
 * Values:
 * - 0 - Write access (increment) is allowed
 * - 1 - Write access (increment) is not allowed
 */
/*@{*/
#define BP_SNVS_HPLR_MC_SL   (4U)          /*!< Bit position for SNVS_HPLR_MC_SL. */
#define BM_SNVS_HPLR_MC_SL   (0x00000010U) /*!< Bit mask for SNVS_HPLR_MC_SL. */
#define BS_SNVS_HPLR_MC_SL   (1U)          /*!< Bit field size in bits for SNVS_HPLR_MC_SL. */

/*! @brief Read current value of the SNVS_HPLR_MC_SL field. */
#define BR_SNVS_HPLR_MC_SL(x) (HW_SNVS_HPLR(x).B.MC_SL)

/*! @brief Format value for bitfield SNVS_HPLR_MC_SL. */
#define BF_SNVS_HPLR_MC_SL(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPLR_MC_SL) & BM_SNVS_HPLR_MC_SL)

/*! @brief Set the MC_SL field to a new value. */
#define BW_SNVS_HPLR_MC_SL(x, v) (HW_SNVS_HPLR_WR(x, (HW_SNVS_HPLR_RD(x) & ~BM_SNVS_HPLR_MC_SL) | BF_SNVS_HPLR_MC_SL(v)))
/*@}*/

/*!
 * @name Register SNVS_HPLR, field GPR_SL[5] (RW)
 *
 * General Purpose Register Soft Lock When set, prevents any writes to the GPR.
 * Once set, this bit can only be reset by the system reset.
 *
 * Values:
 * - 0 - Write access is allowed
 * - 1 - Write access is not allowed
 */
/*@{*/
#define BP_SNVS_HPLR_GPR_SL  (5U)          /*!< Bit position for SNVS_HPLR_GPR_SL. */
#define BM_SNVS_HPLR_GPR_SL  (0x00000020U) /*!< Bit mask for SNVS_HPLR_GPR_SL. */
#define BS_SNVS_HPLR_GPR_SL  (1U)          /*!< Bit field size in bits for SNVS_HPLR_GPR_SL. */

/*! @brief Read current value of the SNVS_HPLR_GPR_SL field. */
#define BR_SNVS_HPLR_GPR_SL(x) (HW_SNVS_HPLR(x).B.GPR_SL)

/*! @brief Format value for bitfield SNVS_HPLR_GPR_SL. */
#define BF_SNVS_HPLR_GPR_SL(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPLR_GPR_SL) & BM_SNVS_HPLR_GPR_SL)

/*! @brief Set the GPR_SL field to a new value. */
#define BW_SNVS_HPLR_GPR_SL(x, v) (HW_SNVS_HPLR_WR(x, (HW_SNVS_HPLR_RD(x) & ~BM_SNVS_HPLR_GPR_SL) | BF_SNVS_HPLR_GPR_SL(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPCOMR - SNVS_HP Command Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPCOMR - SNVS_HP Command Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Command Register contains the command, configuration, and control
 * bits for the SNVS block. This is a privileged write register.
 */
typedef union _hw_snvs_hpcomr
{
    uint32_t U;
    struct _hw_snvs_hpcomr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t LP_SWR : 1;           /*!< [4]  */
        uint32_t LP_SWR_DIS : 1;       /*!< [5]  */
        uint32_t RESERVED1 : 25;       /*!< [30:6]  */
        uint32_t NPSWA_EN : 1;         /*!< [31]  */
    } B;
} hw_snvs_hpcomr_t;

/*!
 * @name Constants and macros for entire SNVS_HPCOMR register
 */
/*@{*/
#define HW_SNVS_HPCOMR_ADDR(x)   ((uintptr_t)(x) + 0x4U)

#define HW_SNVS_HPCOMR(x)        (*(__IO hw_snvs_hpcomr_t *) HW_SNVS_HPCOMR_ADDR(x))
#define HW_SNVS_HPCOMR_RD(x)     (HW_SNVS_HPCOMR(x).U)
#define HW_SNVS_HPCOMR_WR(x, v)  (HW_SNVS_HPCOMR(x).U = (v))
#define HW_SNVS_HPCOMR_SET(x, v) (HW_SNVS_HPCOMR_WR(x, HW_SNVS_HPCOMR_RD(x) |  (v)))
#define HW_SNVS_HPCOMR_CLR(x, v) (HW_SNVS_HPCOMR_WR(x, HW_SNVS_HPCOMR_RD(x) & ~(v)))
#define HW_SNVS_HPCOMR_TOG(x, v) (HW_SNVS_HPCOMR_WR(x, HW_SNVS_HPCOMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPCOMR bitfields
 */

/*!
 * @name Register SNVS_HPCOMR, field LP_SWR[4] (WO)
 *
 * LP Software Reset When set, it resets the SNVS_LP section. This bit cannot be
 * set when the LP_SWR_DIS bit is set. This self-clearing bit is always read as
 * zero.
 *
 * Values:
 * - 0 - No Action
 * - 1 - Reset LP section
 */
/*@{*/
#define BP_SNVS_HPCOMR_LP_SWR (4U)         /*!< Bit position for SNVS_HPCOMR_LP_SWR. */
#define BM_SNVS_HPCOMR_LP_SWR (0x00000010U) /*!< Bit mask for SNVS_HPCOMR_LP_SWR. */
#define BS_SNVS_HPCOMR_LP_SWR (1U)         /*!< Bit field size in bits for SNVS_HPCOMR_LP_SWR. */

/*! @brief Format value for bitfield SNVS_HPCOMR_LP_SWR. */
#define BF_SNVS_HPCOMR_LP_SWR(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCOMR_LP_SWR) & BM_SNVS_HPCOMR_LP_SWR)
/*@}*/

/*!
 * @name Register SNVS_HPCOMR, field LP_SWR_DIS[5] (RW)
 *
 * LP Software Reset Disable When set, disables the LP software reset. Once set,
 * this bit can only be reset by the system reset.
 *
 * Values:
 * - 0 - LP software reset is enabled
 * - 1 - LP software reset is disabled
 */
/*@{*/
#define BP_SNVS_HPCOMR_LP_SWR_DIS (5U)     /*!< Bit position for SNVS_HPCOMR_LP_SWR_DIS. */
#define BM_SNVS_HPCOMR_LP_SWR_DIS (0x00000020U) /*!< Bit mask for SNVS_HPCOMR_LP_SWR_DIS. */
#define BS_SNVS_HPCOMR_LP_SWR_DIS (1U)     /*!< Bit field size in bits for SNVS_HPCOMR_LP_SWR_DIS. */

/*! @brief Read current value of the SNVS_HPCOMR_LP_SWR_DIS field. */
#define BR_SNVS_HPCOMR_LP_SWR_DIS(x) (HW_SNVS_HPCOMR(x).B.LP_SWR_DIS)

/*! @brief Format value for bitfield SNVS_HPCOMR_LP_SWR_DIS. */
#define BF_SNVS_HPCOMR_LP_SWR_DIS(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCOMR_LP_SWR_DIS) & BM_SNVS_HPCOMR_LP_SWR_DIS)

/*! @brief Set the LP_SWR_DIS field to a new value. */
#define BW_SNVS_HPCOMR_LP_SWR_DIS(x, v) (HW_SNVS_HPCOMR_WR(x, (HW_SNVS_HPCOMR_RD(x) & ~BM_SNVS_HPCOMR_LP_SWR_DIS) | BF_SNVS_HPCOMR_LP_SWR_DIS(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCOMR, field NPSWA_EN[31] (RW)
 *
 * Non-Privileged Software Access Enable When set, allows non-privileged
 * software to access all SNVS registers, including those that are privileged software
 * read/write access only. 0 Only privileged software can access privileged
 * registers 1 Any software can access privileged registers
 */
/*@{*/
#define BP_SNVS_HPCOMR_NPSWA_EN (31U)      /*!< Bit position for SNVS_HPCOMR_NPSWA_EN. */
#define BM_SNVS_HPCOMR_NPSWA_EN (0x80000000U) /*!< Bit mask for SNVS_HPCOMR_NPSWA_EN. */
#define BS_SNVS_HPCOMR_NPSWA_EN (1U)       /*!< Bit field size in bits for SNVS_HPCOMR_NPSWA_EN. */

/*! @brief Read current value of the SNVS_HPCOMR_NPSWA_EN field. */
#define BR_SNVS_HPCOMR_NPSWA_EN(x) (HW_SNVS_HPCOMR(x).B.NPSWA_EN)

/*! @brief Format value for bitfield SNVS_HPCOMR_NPSWA_EN. */
#define BF_SNVS_HPCOMR_NPSWA_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCOMR_NPSWA_EN) & BM_SNVS_HPCOMR_NPSWA_EN)

/*! @brief Set the NPSWA_EN field to a new value. */
#define BW_SNVS_HPCOMR_NPSWA_EN(x, v) (HW_SNVS_HPCOMR_WR(x, (HW_SNVS_HPCOMR_RD(x) & ~BM_SNVS_HPCOMR_NPSWA_EN) | BF_SNVS_HPCOMR_NPSWA_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPCR - SNVS_HP Control Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPCR - SNVS_HP Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Control Register contains various control bits of the HP section
 * of SNVS .
 */
typedef union _hw_snvs_hpcr
{
    uint32_t U;
    struct _hw_snvs_hpcr_bitfields
    {
        uint32_t RTC_EN : 1;           /*!< [0]  */
        uint32_t HPTA_EN : 1;          /*!< [1]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t PI_EN : 1;            /*!< [3]  */
        uint32_t PI_FREQ : 4;          /*!< [7:4]  */
        uint32_t HPCALB_EN : 1;        /*!< [8]  */
        uint32_t RESERVED1 : 1;        /*!< [9]  */
        uint32_t HPCALB_VAL : 5;       /*!< [14:10]  */
        uint32_t RESERVED2 : 17;       /*!< [31:15]  */
    } B;
} hw_snvs_hpcr_t;

/*!
 * @name Constants and macros for entire SNVS_HPCR register
 */
/*@{*/
#define HW_SNVS_HPCR_ADDR(x)     ((uintptr_t)(x) + 0x8U)

#define HW_SNVS_HPCR(x)          (*(__IO hw_snvs_hpcr_t *) HW_SNVS_HPCR_ADDR(x))
#define HW_SNVS_HPCR_RD(x)       (HW_SNVS_HPCR(x).U)
#define HW_SNVS_HPCR_WR(x, v)    (HW_SNVS_HPCR(x).U = (v))
#define HW_SNVS_HPCR_SET(x, v)   (HW_SNVS_HPCR_WR(x, HW_SNVS_HPCR_RD(x) |  (v)))
#define HW_SNVS_HPCR_CLR(x, v)   (HW_SNVS_HPCR_WR(x, HW_SNVS_HPCR_RD(x) & ~(v)))
#define HW_SNVS_HPCR_TOG(x, v)   (HW_SNVS_HPCR_WR(x, HW_SNVS_HPCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPCR bitfields
 */

/*!
 * @name Register SNVS_HPCR, field RTC_EN[0] (RW)
 *
 * HP Real Time Counter Enable
 *
 * Values:
 * - 0 - RTC is disabled
 * - 1 - RTC is enabled
 */
/*@{*/
#define BP_SNVS_HPCR_RTC_EN  (0U)          /*!< Bit position for SNVS_HPCR_RTC_EN. */
#define BM_SNVS_HPCR_RTC_EN  (0x00000001U) /*!< Bit mask for SNVS_HPCR_RTC_EN. */
#define BS_SNVS_HPCR_RTC_EN  (1U)          /*!< Bit field size in bits for SNVS_HPCR_RTC_EN. */

/*! @brief Read current value of the SNVS_HPCR_RTC_EN field. */
#define BR_SNVS_HPCR_RTC_EN(x) (HW_SNVS_HPCR(x).B.RTC_EN)

/*! @brief Format value for bitfield SNVS_HPCR_RTC_EN. */
#define BF_SNVS_HPCR_RTC_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_RTC_EN) & BM_SNVS_HPCR_RTC_EN)

/*! @brief Set the RTC_EN field to a new value. */
#define BW_SNVS_HPCR_RTC_EN(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_RTC_EN) | BF_SNVS_HPCR_RTC_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCR, field HPTA_EN[1] (RW)
 *
 * HP Time Alarm Enable When set, the time alarm interrupt is generated if the
 * value in the HP Time Alarm Registers is equal to the value of the HP Real Time
 * Counter.
 *
 * Values:
 * - 0 - HP Time Alarm Interrupt is disabled
 * - 1 - HP Time Alarm Interrupt is enabled
 */
/*@{*/
#define BP_SNVS_HPCR_HPTA_EN (1U)          /*!< Bit position for SNVS_HPCR_HPTA_EN. */
#define BM_SNVS_HPCR_HPTA_EN (0x00000002U) /*!< Bit mask for SNVS_HPCR_HPTA_EN. */
#define BS_SNVS_HPCR_HPTA_EN (1U)          /*!< Bit field size in bits for SNVS_HPCR_HPTA_EN. */

/*! @brief Read current value of the SNVS_HPCR_HPTA_EN field. */
#define BR_SNVS_HPCR_HPTA_EN(x) (HW_SNVS_HPCR(x).B.HPTA_EN)

/*! @brief Format value for bitfield SNVS_HPCR_HPTA_EN. */
#define BF_SNVS_HPCR_HPTA_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_HPTA_EN) & BM_SNVS_HPCR_HPTA_EN)

/*! @brief Set the HPTA_EN field to a new value. */
#define BW_SNVS_HPCR_HPTA_EN(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_HPTA_EN) | BF_SNVS_HPCR_HPTA_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCR, field PI_EN[3] (RW)
 *
 * HP Periodic Interrupt Enable The periodic interrupt can be generated only if
 * the HP Real Time Counter is enabled.
 *
 * Values:
 * - 0 - HP Periodic Interrupt is disabled
 * - 1 - HP Periodic Interrupt is enabled
 */
/*@{*/
#define BP_SNVS_HPCR_PI_EN   (3U)          /*!< Bit position for SNVS_HPCR_PI_EN. */
#define BM_SNVS_HPCR_PI_EN   (0x00000008U) /*!< Bit mask for SNVS_HPCR_PI_EN. */
#define BS_SNVS_HPCR_PI_EN   (1U)          /*!< Bit field size in bits for SNVS_HPCR_PI_EN. */

/*! @brief Read current value of the SNVS_HPCR_PI_EN field. */
#define BR_SNVS_HPCR_PI_EN(x) (HW_SNVS_HPCR(x).B.PI_EN)

/*! @brief Format value for bitfield SNVS_HPCR_PI_EN. */
#define BF_SNVS_HPCR_PI_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_PI_EN) & BM_SNVS_HPCR_PI_EN)

/*! @brief Set the PI_EN field to a new value. */
#define BW_SNVS_HPCR_PI_EN(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_PI_EN) | BF_SNVS_HPCR_PI_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCR, field PI_FREQ[7:4] (RW)
 *
 * Periodic Interrupt Frequency Defines frequency of the periodic interrupt. The
 * interrupt is generated when a zero-to-one or one-to-zero transition occurs on
 * the selected bit of the HP Real Time Counter and Real Time Counter and
 * Periodic Interrupt are both enabled (RTC_EN and PI_EN are set). It is recommended to
 * program this field when Periodic Interrupt is disabled (PI_EN is not set).
 * The possible frequencies are:
 *
 * Values:
 * - 0000 - - bit 0 of the RTC is selected as a source of the periodic interrupt
 * - 0001 - - bit 1 of the RTC is selected as a source of the periodic interrupt
 * - 0010 - - bit 2 of the RTC is selected as a source of the periodic interrupt
 * - 0011 - - bit 3 of the RTC is selected as a source of the periodic interrupt
 * - 0100 - - bit 4 of the RTC is selected as a source of the periodic interrupt
 * - 0101 - - bit 5 of the RTC is selected as a source of the periodic interrupt
 * - 0110 - - bit 6 of the RTC is selected as a source of the periodic interrupt
 * - 0111 - - bit 7 of the RTC is selected as a source of the periodic interrupt
 * - 1000 - - bit 8 of the RTC is selected as a source of the periodic interrupt
 * - 1001 - - bit 9 of the RTC is selected as a source of the periodic interrupt
 * - 1010 - - bit 10 of the RTC is selected as a source of the periodic interrupt
 * - 1011 - - bit 11 of the RTC is selected as a source of the periodic interrupt
 * - 1100 - - bit 12 of the RTC is selected as a source of the periodic interrupt
 * - 1101 - - bit 13 of the RTC is selected as a source of the periodic interrupt
 * - 1110 - - bit 14 of the RTC is selected as a source of the periodic interrupt
 * - 1111 - - bit 15 of the RTC is selected as a source of the periodic interrupt
 */
/*@{*/
#define BP_SNVS_HPCR_PI_FREQ (4U)          /*!< Bit position for SNVS_HPCR_PI_FREQ. */
#define BM_SNVS_HPCR_PI_FREQ (0x000000F0U) /*!< Bit mask for SNVS_HPCR_PI_FREQ. */
#define BS_SNVS_HPCR_PI_FREQ (4U)          /*!< Bit field size in bits for SNVS_HPCR_PI_FREQ. */

/*! @brief Read current value of the SNVS_HPCR_PI_FREQ field. */
#define BR_SNVS_HPCR_PI_FREQ(x) (HW_SNVS_HPCR(x).B.PI_FREQ)

/*! @brief Format value for bitfield SNVS_HPCR_PI_FREQ. */
#define BF_SNVS_HPCR_PI_FREQ(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_PI_FREQ) & BM_SNVS_HPCR_PI_FREQ)

/*! @brief Set the PI_FREQ field to a new value. */
#define BW_SNVS_HPCR_PI_FREQ(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_PI_FREQ) | BF_SNVS_HPCR_PI_FREQ(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCR, field HPCALB_EN[8] (RW)
 *
 * HP Real Time Counter Calibration Enabled Indicates that the time calibration
 * mechanism is enabled.
 *
 * Values:
 * - 0 - HP Timer calibration disabled
 * - 1 - HP Timer calibration enabled
 */
/*@{*/
#define BP_SNVS_HPCR_HPCALB_EN (8U)        /*!< Bit position for SNVS_HPCR_HPCALB_EN. */
#define BM_SNVS_HPCR_HPCALB_EN (0x00000100U) /*!< Bit mask for SNVS_HPCR_HPCALB_EN. */
#define BS_SNVS_HPCR_HPCALB_EN (1U)        /*!< Bit field size in bits for SNVS_HPCR_HPCALB_EN. */

/*! @brief Read current value of the SNVS_HPCR_HPCALB_EN field. */
#define BR_SNVS_HPCR_HPCALB_EN(x) (HW_SNVS_HPCR(x).B.HPCALB_EN)

/*! @brief Format value for bitfield SNVS_HPCR_HPCALB_EN. */
#define BF_SNVS_HPCR_HPCALB_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_HPCALB_EN) & BM_SNVS_HPCR_HPCALB_EN)

/*! @brief Set the HPCALB_EN field to a new value. */
#define BW_SNVS_HPCR_HPCALB_EN(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_HPCALB_EN) | BF_SNVS_HPCR_HPCALB_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_HPCR, field HPCALB_VAL[14:10] (RW)
 *
 * HP Calibration Value Defines signed calibration value for the HP Real Time
 * Counter. This field can be programmed only when RTC Calibration is disabled
 * (HPCALB_EN is not set). This is a 5-bit 2's complement value, hence the allowable
 * calibration values are in the range from -16 to +15 counts per 32768 ticks of
 * the counter.
 *
 * Values:
 * - 00000 - +0 counts per each 32768 ticks of the counter
 * - 00001 - +1 counts per each 32768 ticks of the counter
 * - 00010 - +2 counts per each 32768 ticks of the counter
 * - 01111 - +15 counts per each 32768 ticks of the counter
 * - 10000 - -16 counts per each 32768 ticks of the counter
 * - 10001 - -15 counts per each 32768 ticks of the counter
 * - 11110 - -2 counts per each 32768 ticks of the counter
 * - 11111 - -1 counts per each 32768 ticks of the counter
 */
/*@{*/
#define BP_SNVS_HPCR_HPCALB_VAL (10U)      /*!< Bit position for SNVS_HPCR_HPCALB_VAL. */
#define BM_SNVS_HPCR_HPCALB_VAL (0x00007C00U) /*!< Bit mask for SNVS_HPCR_HPCALB_VAL. */
#define BS_SNVS_HPCR_HPCALB_VAL (5U)       /*!< Bit field size in bits for SNVS_HPCR_HPCALB_VAL. */

/*! @brief Read current value of the SNVS_HPCR_HPCALB_VAL field. */
#define BR_SNVS_HPCR_HPCALB_VAL(x) (HW_SNVS_HPCR(x).B.HPCALB_VAL)

/*! @brief Format value for bitfield SNVS_HPCR_HPCALB_VAL. */
#define BF_SNVS_HPCR_HPCALB_VAL(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPCR_HPCALB_VAL) & BM_SNVS_HPCR_HPCALB_VAL)

/*! @brief Set the HPCALB_VAL field to a new value. */
#define BW_SNVS_HPCR_HPCALB_VAL(x, v) (HW_SNVS_HPCR_WR(x, (HW_SNVS_HPCR_RD(x) & ~BM_SNVS_HPCR_HPCALB_VAL) | BF_SNVS_HPCR_HPCALB_VAL(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPSR - SNVS_HP Status Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPSR - SNVS_HP Status Register (RW)
 *
 * Reset value: 0x80000000U
 *
 * The HP Status Register reflects the internal state of the SNVS.
 */
typedef union _hw_snvs_hpsr
{
    uint32_t U;
    struct _hw_snvs_hpsr_bitfields
    {
        uint32_t RESERVED0 : 6;        /*!< [5:0]  */
        uint32_t BTN : 1;              /*!< [6]  */
        uint32_t BI : 1;               /*!< [7]  */
        uint32_t RESERVED1 : 24;       /*!< [31:8]  */
    } B;
} hw_snvs_hpsr_t;

/*!
 * @name Constants and macros for entire SNVS_HPSR register
 */
/*@{*/
#define HW_SNVS_HPSR_ADDR(x)     ((uintptr_t)(x) + 0x14U)

#define HW_SNVS_HPSR(x)          (*(__IO hw_snvs_hpsr_t *) HW_SNVS_HPSR_ADDR(x))
#define HW_SNVS_HPSR_RD(x)       (HW_SNVS_HPSR(x).U)
#define HW_SNVS_HPSR_WR(x, v)    (HW_SNVS_HPSR(x).U = (v))
#define HW_SNVS_HPSR_SET(x, v)   (HW_SNVS_HPSR_WR(x, HW_SNVS_HPSR_RD(x) |  (v)))
#define HW_SNVS_HPSR_CLR(x, v)   (HW_SNVS_HPSR_WR(x, HW_SNVS_HPSR_RD(x) & ~(v)))
#define HW_SNVS_HPSR_TOG(x, v)   (HW_SNVS_HPSR_WR(x, HW_SNVS_HPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPSR bitfields
 */

/*!
 * @name Register SNVS_HPSR, field BTN[6] (RO)
 *
 * Value of the BTN input. This is the external button used for PMIC control. 0:
 * BTN not pressed 1: BTN pressed
 */
/*@{*/
#define BP_SNVS_HPSR_BTN     (6U)          /*!< Bit position for SNVS_HPSR_BTN. */
#define BM_SNVS_HPSR_BTN     (0x00000040U) /*!< Bit mask for SNVS_HPSR_BTN. */
#define BS_SNVS_HPSR_BTN     (1U)          /*!< Bit field size in bits for SNVS_HPSR_BTN. */

/*! @brief Read current value of the SNVS_HPSR_BTN field. */
#define BR_SNVS_HPSR_BTN(x)  (HW_SNVS_HPSR(x).B.BTN)
/*@}*/

/*!
 * @name Register SNVS_HPSR, field BI[7] (W1C)
 *
 * Button Interrupt. Signal ipi_snvs_btn_int_b was asserted.
 */
/*@{*/
#define BP_SNVS_HPSR_BI      (7U)          /*!< Bit position for SNVS_HPSR_BI. */
#define BM_SNVS_HPSR_BI      (0x00000080U) /*!< Bit mask for SNVS_HPSR_BI. */
#define BS_SNVS_HPSR_BI      (1U)          /*!< Bit field size in bits for SNVS_HPSR_BI. */

/*! @brief Read current value of the SNVS_HPSR_BI field. */
#define BR_SNVS_HPSR_BI(x)   (HW_SNVS_HPSR(x).B.BI)

/*! @brief Format value for bitfield SNVS_HPSR_BI. */
#define BF_SNVS_HPSR_BI(v)   ((uint32_t)((uint32_t)(v) << BP_SNVS_HPSR_BI) & BM_SNVS_HPSR_BI)

/*! @brief Set the BI field to a new value. */
#define BW_SNVS_HPSR_BI(x, v) (HW_SNVS_HPSR_WR(x, (HW_SNVS_HPSR_RD(x) & ~BM_SNVS_HPSR_BI) | BF_SNVS_HPSR_BI(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPRTCMR - SNVS_HP Real Time Counter MSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPRTCMR - SNVS_HP Real Time Counter MSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Real Time Counter MSB register contains the most significant bits
 * of the HP Real Time Counter.
 */
typedef union _hw_snvs_hprtcmr
{
    uint32_t U;
    struct _hw_snvs_hprtcmr_bitfields
    {
        uint32_t RTC : 15;             /*!< [14:0]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_snvs_hprtcmr_t;

/*!
 * @name Constants and macros for entire SNVS_HPRTCMR register
 */
/*@{*/
#define HW_SNVS_HPRTCMR_ADDR(x)  ((uintptr_t)(x) + 0x24U)

#define HW_SNVS_HPRTCMR(x)       (*(__IO hw_snvs_hprtcmr_t *) HW_SNVS_HPRTCMR_ADDR(x))
#define HW_SNVS_HPRTCMR_RD(x)    (HW_SNVS_HPRTCMR(x).U)
#define HW_SNVS_HPRTCMR_WR(x, v) (HW_SNVS_HPRTCMR(x).U = (v))
#define HW_SNVS_HPRTCMR_SET(x, v) (HW_SNVS_HPRTCMR_WR(x, HW_SNVS_HPRTCMR_RD(x) |  (v)))
#define HW_SNVS_HPRTCMR_CLR(x, v) (HW_SNVS_HPRTCMR_WR(x, HW_SNVS_HPRTCMR_RD(x) & ~(v)))
#define HW_SNVS_HPRTCMR_TOG(x, v) (HW_SNVS_HPRTCMR_WR(x, HW_SNVS_HPRTCMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPRTCMR bitfields
 */

/*!
 * @name Register SNVS_HPRTCMR, field RTC[14:0] (RW)
 *
 * HP Real Time Counter Most significant 15 bits. This register can be
 * programmed only when RTC is not active (RTC_EN bit is not set).
 */
/*@{*/
#define BP_SNVS_HPRTCMR_RTC  (0U)          /*!< Bit position for SNVS_HPRTCMR_RTC. */
#define BM_SNVS_HPRTCMR_RTC  (0x00007FFFU) /*!< Bit mask for SNVS_HPRTCMR_RTC. */
#define BS_SNVS_HPRTCMR_RTC  (15U)         /*!< Bit field size in bits for SNVS_HPRTCMR_RTC. */

/*! @brief Read current value of the SNVS_HPRTCMR_RTC field. */
#define BR_SNVS_HPRTCMR_RTC(x) (HW_SNVS_HPRTCMR(x).B.RTC)

/*! @brief Format value for bitfield SNVS_HPRTCMR_RTC. */
#define BF_SNVS_HPRTCMR_RTC(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPRTCMR_RTC) & BM_SNVS_HPRTCMR_RTC)

/*! @brief Set the RTC field to a new value. */
#define BW_SNVS_HPRTCMR_RTC(x, v) (HW_SNVS_HPRTCMR_WR(x, (HW_SNVS_HPRTCMR_RD(x) & ~BM_SNVS_HPRTCMR_RTC) | BF_SNVS_HPRTCMR_RTC(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPRTCLR - SNVS_HP Real Time Counter LSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPRTCLR - SNVS_HP Real Time Counter LSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Real Time Counter LSB register contains the 32 least significant
 * bits of the HP real time counter.
 */
typedef union _hw_snvs_hprtclr
{
    uint32_t U;
    struct _hw_snvs_hprtclr_bitfields
    {
        uint32_t RTC : 32;             /*!< [31:0]  */
    } B;
} hw_snvs_hprtclr_t;

/*!
 * @name Constants and macros for entire SNVS_HPRTCLR register
 */
/*@{*/
#define HW_SNVS_HPRTCLR_ADDR(x)  ((uintptr_t)(x) + 0x28U)

#define HW_SNVS_HPRTCLR(x)       (*(__IO hw_snvs_hprtclr_t *) HW_SNVS_HPRTCLR_ADDR(x))
#define HW_SNVS_HPRTCLR_RD(x)    (HW_SNVS_HPRTCLR(x).U)
#define HW_SNVS_HPRTCLR_WR(x, v) (HW_SNVS_HPRTCLR(x).U = (v))
#define HW_SNVS_HPRTCLR_SET(x, v) (HW_SNVS_HPRTCLR_WR(x, HW_SNVS_HPRTCLR_RD(x) |  (v)))
#define HW_SNVS_HPRTCLR_CLR(x, v) (HW_SNVS_HPRTCLR_WR(x, HW_SNVS_HPRTCLR_RD(x) & ~(v)))
#define HW_SNVS_HPRTCLR_TOG(x, v) (HW_SNVS_HPRTCLR_WR(x, HW_SNVS_HPRTCLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPRTCLR bitfields
 */

/*!
 * @name Register SNVS_HPRTCLR, field RTC[31:0] (RW)
 *
 * HP Real Time Counter Least significant 32 bits. This register can be
 * programmed only when RTC is not active (RTC_EN bit is not set).
 */
/*@{*/
#define BP_SNVS_HPRTCLR_RTC  (0U)          /*!< Bit position for SNVS_HPRTCLR_RTC. */
#define BM_SNVS_HPRTCLR_RTC  (0xFFFFFFFFU) /*!< Bit mask for SNVS_HPRTCLR_RTC. */
#define BS_SNVS_HPRTCLR_RTC  (32U)         /*!< Bit field size in bits for SNVS_HPRTCLR_RTC. */

/*! @brief Read current value of the SNVS_HPRTCLR_RTC field. */
#define BR_SNVS_HPRTCLR_RTC(x) (HW_SNVS_HPRTCLR(x).U)

/*! @brief Format value for bitfield SNVS_HPRTCLR_RTC. */
#define BF_SNVS_HPRTCLR_RTC(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPRTCLR_RTC) & BM_SNVS_HPRTCLR_RTC)

/*! @brief Set the RTC field to a new value. */
#define BW_SNVS_HPRTCLR_RTC(x, v) (HW_SNVS_HPRTCLR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPTAMR - SNVS_HP Time Alarm MSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPTAMR - SNVS_HP Time Alarm MSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Time Alarm MSB register contains the most significant bits of the
 * SNVS_HP Time Alarm value.
 */
typedef union _hw_snvs_hptamr
{
    uint32_t U;
    struct _hw_snvs_hptamr_bitfields
    {
        uint32_t HPTA : 15;            /*!< [14:0]  */
        uint32_t RESERVED0 : 17;       /*!< [31:15]  */
    } B;
} hw_snvs_hptamr_t;

/*!
 * @name Constants and macros for entire SNVS_HPTAMR register
 */
/*@{*/
#define HW_SNVS_HPTAMR_ADDR(x)   ((uintptr_t)(x) + 0x2CU)

#define HW_SNVS_HPTAMR(x)        (*(__IO hw_snvs_hptamr_t *) HW_SNVS_HPTAMR_ADDR(x))
#define HW_SNVS_HPTAMR_RD(x)     (HW_SNVS_HPTAMR(x).U)
#define HW_SNVS_HPTAMR_WR(x, v)  (HW_SNVS_HPTAMR(x).U = (v))
#define HW_SNVS_HPTAMR_SET(x, v) (HW_SNVS_HPTAMR_WR(x, HW_SNVS_HPTAMR_RD(x) |  (v)))
#define HW_SNVS_HPTAMR_CLR(x, v) (HW_SNVS_HPTAMR_WR(x, HW_SNVS_HPTAMR_RD(x) & ~(v)))
#define HW_SNVS_HPTAMR_TOG(x, v) (HW_SNVS_HPTAMR_WR(x, HW_SNVS_HPTAMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPTAMR bitfields
 */

/*!
 * @name Register SNVS_HPTAMR, field HPTA[14:0] (RW)
 *
 * HP Time Alarm Most significant 15 bits. This register can be programmed only
 * when HP time alarm is disabled (HPTA_EN bit is not set).
 */
/*@{*/
#define BP_SNVS_HPTAMR_HPTA  (0U)          /*!< Bit position for SNVS_HPTAMR_HPTA. */
#define BM_SNVS_HPTAMR_HPTA  (0x00007FFFU) /*!< Bit mask for SNVS_HPTAMR_HPTA. */
#define BS_SNVS_HPTAMR_HPTA  (15U)         /*!< Bit field size in bits for SNVS_HPTAMR_HPTA. */

/*! @brief Read current value of the SNVS_HPTAMR_HPTA field. */
#define BR_SNVS_HPTAMR_HPTA(x) (HW_SNVS_HPTAMR(x).B.HPTA)

/*! @brief Format value for bitfield SNVS_HPTAMR_HPTA. */
#define BF_SNVS_HPTAMR_HPTA(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPTAMR_HPTA) & BM_SNVS_HPTAMR_HPTA)

/*! @brief Set the HPTA field to a new value. */
#define BW_SNVS_HPTAMR_HPTA(x, v) (HW_SNVS_HPTAMR_WR(x, (HW_SNVS_HPTAMR_RD(x) & ~BM_SNVS_HPTAMR_HPTA) | BF_SNVS_HPTAMR_HPTA(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPTALR - SNVS_HP Time Alarm LSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPTALR - SNVS_HP Time Alarm LSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Time Alarm LSB register contains the 32 least significant bits of
 * the SNVS_HP Time Alarm value.
 */
typedef union _hw_snvs_hptalr
{
    uint32_t U;
    struct _hw_snvs_hptalr_bitfields
    {
        uint32_t HPTA : 32;            /*!< [31:0]  */
    } B;
} hw_snvs_hptalr_t;

/*!
 * @name Constants and macros for entire SNVS_HPTALR register
 */
/*@{*/
#define HW_SNVS_HPTALR_ADDR(x)   ((uintptr_t)(x) + 0x30U)

#define HW_SNVS_HPTALR(x)        (*(__IO hw_snvs_hptalr_t *) HW_SNVS_HPTALR_ADDR(x))
#define HW_SNVS_HPTALR_RD(x)     (HW_SNVS_HPTALR(x).U)
#define HW_SNVS_HPTALR_WR(x, v)  (HW_SNVS_HPTALR(x).U = (v))
#define HW_SNVS_HPTALR_SET(x, v) (HW_SNVS_HPTALR_WR(x, HW_SNVS_HPTALR_RD(x) |  (v)))
#define HW_SNVS_HPTALR_CLR(x, v) (HW_SNVS_HPTALR_WR(x, HW_SNVS_HPTALR_RD(x) & ~(v)))
#define HW_SNVS_HPTALR_TOG(x, v) (HW_SNVS_HPTALR_WR(x, HW_SNVS_HPTALR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_HPTALR bitfields
 */

/*!
 * @name Register SNVS_HPTALR, field HPTA[31:0] (RW)
 *
 * HP Time Alarm Least significant bits. This register can be programmed only
 * when HP time alarm is disabled (HPTA_EN bit is not set).
 */
/*@{*/
#define BP_SNVS_HPTALR_HPTA  (0U)          /*!< Bit position for SNVS_HPTALR_HPTA. */
#define BM_SNVS_HPTALR_HPTA  (0xFFFFFFFFU) /*!< Bit mask for SNVS_HPTALR_HPTA. */
#define BS_SNVS_HPTALR_HPTA  (32U)         /*!< Bit field size in bits for SNVS_HPTALR_HPTA. */

/*! @brief Read current value of the SNVS_HPTALR_HPTA field. */
#define BR_SNVS_HPTALR_HPTA(x) (HW_SNVS_HPTALR(x).U)

/*! @brief Format value for bitfield SNVS_HPTALR_HPTA. */
#define BF_SNVS_HPTALR_HPTA(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_HPTALR_HPTA) & BM_SNVS_HPTALR_HPTA)

/*! @brief Set the HPTA field to a new value. */
#define BW_SNVS_HPTALR_HPTA(x, v) (HW_SNVS_HPTALR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPLR - SNVS_LP Lock Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPLR - SNVS_LP Lock Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_LP Lock Register contains lock bits for the SNVS_LP registers.
 */
typedef union _hw_snvs_lplr
{
    uint32_t U;
    struct _hw_snvs_lplr_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t MC_HL : 1;            /*!< [4]  */
        uint32_t GPR_HL : 1;           /*!< [5]  */
        uint32_t RESERVED1 : 26;       /*!< [31:6]  */
    } B;
} hw_snvs_lplr_t;

/*!
 * @name Constants and macros for entire SNVS_LPLR register
 */
/*@{*/
#define HW_SNVS_LPLR_ADDR(x)     ((uintptr_t)(x) + 0x34U)

#define HW_SNVS_LPLR(x)          (*(__IO hw_snvs_lplr_t *) HW_SNVS_LPLR_ADDR(x))
#define HW_SNVS_LPLR_RD(x)       (HW_SNVS_LPLR(x).U)
#define HW_SNVS_LPLR_WR(x, v)    (HW_SNVS_LPLR(x).U = (v))
#define HW_SNVS_LPLR_SET(x, v)   (HW_SNVS_LPLR_WR(x, HW_SNVS_LPLR_RD(x) |  (v)))
#define HW_SNVS_LPLR_CLR(x, v)   (HW_SNVS_LPLR_WR(x, HW_SNVS_LPLR_RD(x) & ~(v)))
#define HW_SNVS_LPLR_TOG(x, v)   (HW_SNVS_LPLR_WR(x, HW_SNVS_LPLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPLR bitfields
 */

/*!
 * @name Register SNVS_LPLR, field MC_HL[4] (RW)
 *
 * Monotonic Counter Hard Lock When set, prevents any writes (increments) to the
 * MC Registers and MC_ENV bit. Once set, this bit can only be reset by the LP
 * POR.
 *
 * Values:
 * - 0 - Write access (increment) is allowed.
 * - 1 - Write access (increment) is not allowed.
 */
/*@{*/
#define BP_SNVS_LPLR_MC_HL   (4U)          /*!< Bit position for SNVS_LPLR_MC_HL. */
#define BM_SNVS_LPLR_MC_HL   (0x00000010U) /*!< Bit mask for SNVS_LPLR_MC_HL. */
#define BS_SNVS_LPLR_MC_HL   (1U)          /*!< Bit field size in bits for SNVS_LPLR_MC_HL. */

/*! @brief Read current value of the SNVS_LPLR_MC_HL field. */
#define BR_SNVS_LPLR_MC_HL(x) (HW_SNVS_LPLR(x).B.MC_HL)

/*! @brief Format value for bitfield SNVS_LPLR_MC_HL. */
#define BF_SNVS_LPLR_MC_HL(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPLR_MC_HL) & BM_SNVS_LPLR_MC_HL)

/*! @brief Set the MC_HL field to a new value. */
#define BW_SNVS_LPLR_MC_HL(x, v) (HW_SNVS_LPLR_WR(x, (HW_SNVS_LPLR_RD(x) & ~BM_SNVS_LPLR_MC_HL) | BF_SNVS_LPLR_MC_HL(v)))
/*@}*/

/*!
 * @name Register SNVS_LPLR, field GPR_HL[5] (RW)
 *
 * General Purpose Register Hard Lock When set, prevents any writes to the GPR.
 * Once set, this bit can only be reset by the LP POR.
 *
 * Values:
 * - 0 - Write access is allowed.
 * - 1 - Write access is not allowed.
 */
/*@{*/
#define BP_SNVS_LPLR_GPR_HL  (5U)          /*!< Bit position for SNVS_LPLR_GPR_HL. */
#define BM_SNVS_LPLR_GPR_HL  (0x00000020U) /*!< Bit mask for SNVS_LPLR_GPR_HL. */
#define BS_SNVS_LPLR_GPR_HL  (1U)          /*!< Bit field size in bits for SNVS_LPLR_GPR_HL. */

/*! @brief Read current value of the SNVS_LPLR_GPR_HL field. */
#define BR_SNVS_LPLR_GPR_HL(x) (HW_SNVS_LPLR(x).B.GPR_HL)

/*! @brief Format value for bitfield SNVS_LPLR_GPR_HL. */
#define BF_SNVS_LPLR_GPR_HL(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPLR_GPR_HL) & BM_SNVS_LPLR_GPR_HL)

/*! @brief Set the GPR_HL field to a new value. */
#define BW_SNVS_LPLR_GPR_HL(x, v) (HW_SNVS_LPLR_WR(x, (HW_SNVS_LPLR_RD(x) & ~BM_SNVS_LPLR_GPR_HL) | BF_SNVS_LPLR_GPR_HL(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPCR - SNVS_LP Control Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPCR - SNVS_LP Control Register (RW)
 *
 * Reset value: 0x00000020U
 *
 * The SNVS_LP Control Register contains various control bits of the LP section
 * of SNVS.
 */
typedef union _hw_snvs_lpcr
{
    uint32_t U;
    struct _hw_snvs_lpcr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t MC_ENV : 1;           /*!< [2]  */
        uint32_t RESERVED1 : 2;        /*!< [4:3]  */
        uint32_t DP_EN : 1;            /*!< [5]  */
        uint32_t TOP : 1;              /*!< [6]  */
        uint32_t PWR_GLITCH_EN : 1;    /*!< [7]  */
        uint32_t RESERVED2 : 8;        /*!< [15:8]  */
        uint32_t BTN_PRESS_TIME : 2;   /*!< [17:16]  */
        uint32_t DEBOUNCE : 2;         /*!< [19:18]  */
        uint32_t ON_TIME : 2;          /*!< [21:20]  */
        uint32_t PK_EN : 1;            /*!< [22]  */
        uint32_t PK_OVERRIDE : 1;      /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_snvs_lpcr_t;

/*!
 * @name Constants and macros for entire SNVS_LPCR register
 */
/*@{*/
#define HW_SNVS_LPCR_ADDR(x)     ((uintptr_t)(x) + 0x38U)

#define HW_SNVS_LPCR(x)          (*(__IO hw_snvs_lpcr_t *) HW_SNVS_LPCR_ADDR(x))
#define HW_SNVS_LPCR_RD(x)       (HW_SNVS_LPCR(x).U)
#define HW_SNVS_LPCR_WR(x, v)    (HW_SNVS_LPCR(x).U = (v))
#define HW_SNVS_LPCR_SET(x, v)   (HW_SNVS_LPCR_WR(x, HW_SNVS_LPCR_RD(x) |  (v)))
#define HW_SNVS_LPCR_CLR(x, v)   (HW_SNVS_LPCR_WR(x, HW_SNVS_LPCR_RD(x) & ~(v)))
#define HW_SNVS_LPCR_TOG(x, v)   (HW_SNVS_LPCR_WR(x, HW_SNVS_LPCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPCR bitfields
 */

/*!
 * @name Register SNVS_LPCR, field MC_ENV[2] (RW)
 *
 * Monotonic Counter Enable and Valid When set, the MC can be incremented (by
 * write transaction to the LPSMCMR or LPSMCLR). This bit cannot be changed once
 * MC_SL or MC_HL bit is set.
 *
 * Values:
 * - 0 - MC is disabled or invalid.
 * - 1 - MC is enabled and valid.
 */
/*@{*/
#define BP_SNVS_LPCR_MC_ENV  (2U)          /*!< Bit position for SNVS_LPCR_MC_ENV. */
#define BM_SNVS_LPCR_MC_ENV  (0x00000004U) /*!< Bit mask for SNVS_LPCR_MC_ENV. */
#define BS_SNVS_LPCR_MC_ENV  (1U)          /*!< Bit field size in bits for SNVS_LPCR_MC_ENV. */

/*! @brief Read current value of the SNVS_LPCR_MC_ENV field. */
#define BR_SNVS_LPCR_MC_ENV(x) (HW_SNVS_LPCR(x).B.MC_ENV)

/*! @brief Format value for bitfield SNVS_LPCR_MC_ENV. */
#define BF_SNVS_LPCR_MC_ENV(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_MC_ENV) & BM_SNVS_LPCR_MC_ENV)

/*! @brief Set the MC_ENV field to a new value. */
#define BW_SNVS_LPCR_MC_ENV(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_MC_ENV) | BF_SNVS_LPCR_MC_ENV(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field DP_EN[5] (RW)
 *
 * Dumb PMIC Enabled When set, software can control the system power. When
 * cleared, the system requires a Smart PMIC to automatically turn power off.
 *
 * Values:
 * - 0 - Smart PMIC enabled.
 * - 1 - Dumb PMIC enabled.
 */
/*@{*/
#define BP_SNVS_LPCR_DP_EN   (5U)          /*!< Bit position for SNVS_LPCR_DP_EN. */
#define BM_SNVS_LPCR_DP_EN   (0x00000020U) /*!< Bit mask for SNVS_LPCR_DP_EN. */
#define BS_SNVS_LPCR_DP_EN   (1U)          /*!< Bit field size in bits for SNVS_LPCR_DP_EN. */

/*! @brief Read current value of the SNVS_LPCR_DP_EN field. */
#define BR_SNVS_LPCR_DP_EN(x) (HW_SNVS_LPCR(x).B.DP_EN)

/*! @brief Format value for bitfield SNVS_LPCR_DP_EN. */
#define BF_SNVS_LPCR_DP_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_DP_EN) & BM_SNVS_LPCR_DP_EN)

/*! @brief Set the DP_EN field to a new value. */
#define BW_SNVS_LPCR_DP_EN(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_DP_EN) | BF_SNVS_LPCR_DP_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field TOP[6] (RW)
 *
 * Turn off System Power Asserting this bit causes a signal to be sent to the
 * Power Management IC to turn off the system power. This bit will clear once power
 * is off. This bit is only valid when the Dumb PMIC is enabled.
 *
 * Values:
 * - 0 - Leave system power on.
 * - 1 - Turn off system power.
 */
/*@{*/
#define BP_SNVS_LPCR_TOP     (6U)          /*!< Bit position for SNVS_LPCR_TOP. */
#define BM_SNVS_LPCR_TOP     (0x00000040U) /*!< Bit mask for SNVS_LPCR_TOP. */
#define BS_SNVS_LPCR_TOP     (1U)          /*!< Bit field size in bits for SNVS_LPCR_TOP. */

/*! @brief Read current value of the SNVS_LPCR_TOP field. */
#define BR_SNVS_LPCR_TOP(x)  (HW_SNVS_LPCR(x).B.TOP)

/*! @brief Format value for bitfield SNVS_LPCR_TOP. */
#define BF_SNVS_LPCR_TOP(v)  ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_TOP) & BM_SNVS_LPCR_TOP)

/*! @brief Set the TOP field to a new value. */
#define BW_SNVS_LPCR_TOP(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_TOP) | BF_SNVS_LPCR_TOP(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field PWR_GLITCH_EN[7] (RW)
 *
 * By default the detection of a power glitch does not cause the pmic_en_b
 * signal to be asserted. Setting the Power Glitch Enable bit to 1 enables the power
 * glitch event for the PMIC. 0 - disabled 1 - enabled
 */
/*@{*/
#define BP_SNVS_LPCR_PWR_GLITCH_EN (7U)    /*!< Bit position for SNVS_LPCR_PWR_GLITCH_EN. */
#define BM_SNVS_LPCR_PWR_GLITCH_EN (0x00000080U) /*!< Bit mask for SNVS_LPCR_PWR_GLITCH_EN. */
#define BS_SNVS_LPCR_PWR_GLITCH_EN (1U)    /*!< Bit field size in bits for SNVS_LPCR_PWR_GLITCH_EN. */

/*! @brief Read current value of the SNVS_LPCR_PWR_GLITCH_EN field. */
#define BR_SNVS_LPCR_PWR_GLITCH_EN(x) (HW_SNVS_LPCR(x).B.PWR_GLITCH_EN)

/*! @brief Format value for bitfield SNVS_LPCR_PWR_GLITCH_EN. */
#define BF_SNVS_LPCR_PWR_GLITCH_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_PWR_GLITCH_EN) & BM_SNVS_LPCR_PWR_GLITCH_EN)

/*! @brief Set the PWR_GLITCH_EN field to a new value. */
#define BW_SNVS_LPCR_PWR_GLITCH_EN(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_PWR_GLITCH_EN) | BF_SNVS_LPCR_PWR_GLITCH_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field BTN_PRESS_TIME[17:16] (RW)
 *
 * Button press time out values for PMIC Logic. 00 : 5 secs 01 : 10 secs 10 : 15
 * secs 11 : long press disabled (pmic_en_b will not be asserted regardlessof
 * how long BTN is asserted)
 */
/*@{*/
#define BP_SNVS_LPCR_BTN_PRESS_TIME (16U)  /*!< Bit position for SNVS_LPCR_BTN_PRESS_TIME. */
#define BM_SNVS_LPCR_BTN_PRESS_TIME (0x00030000U) /*!< Bit mask for SNVS_LPCR_BTN_PRESS_TIME. */
#define BS_SNVS_LPCR_BTN_PRESS_TIME (2U)   /*!< Bit field size in bits for SNVS_LPCR_BTN_PRESS_TIME. */

/*! @brief Read current value of the SNVS_LPCR_BTN_PRESS_TIME field. */
#define BR_SNVS_LPCR_BTN_PRESS_TIME(x) (HW_SNVS_LPCR(x).B.BTN_PRESS_TIME)

/*! @brief Format value for bitfield SNVS_LPCR_BTN_PRESS_TIME. */
#define BF_SNVS_LPCR_BTN_PRESS_TIME(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_BTN_PRESS_TIME) & BM_SNVS_LPCR_BTN_PRESS_TIME)

/*! @brief Set the BTN_PRESS_TIME field to a new value. */
#define BW_SNVS_LPCR_BTN_PRESS_TIME(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_BTN_PRESS_TIME) | BF_SNVS_LPCR_BTN_PRESS_TIME(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field DEBOUNCE[19:18] (RW)
 *
 * This field configures the amount of debounce time for the BTN input signal.
 * 00: 50msec debounce 01: 100msec debounce 10: 500msec debounce 11: 0msec debounce
 */
/*@{*/
#define BP_SNVS_LPCR_DEBOUNCE (18U)        /*!< Bit position for SNVS_LPCR_DEBOUNCE. */
#define BM_SNVS_LPCR_DEBOUNCE (0x000C0000U) /*!< Bit mask for SNVS_LPCR_DEBOUNCE. */
#define BS_SNVS_LPCR_DEBOUNCE (2U)         /*!< Bit field size in bits for SNVS_LPCR_DEBOUNCE. */

/*! @brief Read current value of the SNVS_LPCR_DEBOUNCE field. */
#define BR_SNVS_LPCR_DEBOUNCE(x) (HW_SNVS_LPCR(x).B.DEBOUNCE)

/*! @brief Format value for bitfield SNVS_LPCR_DEBOUNCE. */
#define BF_SNVS_LPCR_DEBOUNCE(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_DEBOUNCE) & BM_SNVS_LPCR_DEBOUNCE)

/*! @brief Set the DEBOUNCE field to a new value. */
#define BW_SNVS_LPCR_DEBOUNCE(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_DEBOUNCE) | BF_SNVS_LPCR_DEBOUNCE(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field ON_TIME[21:20] (RW)
 *
 * The ON_TIME field is used to configure the period of time after BTN is
 * asserted before pmic_en_b is asserted to turn on the SoCpower. 00: 500msec off->on
 * transition time 01: 50msec off->on transition time 10: 100msec off->on
 * transition time 11: 0msec off->on transition time
 */
/*@{*/
#define BP_SNVS_LPCR_ON_TIME (20U)         /*!< Bit position for SNVS_LPCR_ON_TIME. */
#define BM_SNVS_LPCR_ON_TIME (0x00300000U) /*!< Bit mask for SNVS_LPCR_ON_TIME. */
#define BS_SNVS_LPCR_ON_TIME (2U)          /*!< Bit field size in bits for SNVS_LPCR_ON_TIME. */

/*! @brief Read current value of the SNVS_LPCR_ON_TIME field. */
#define BR_SNVS_LPCR_ON_TIME(x) (HW_SNVS_LPCR(x).B.ON_TIME)

/*! @brief Format value for bitfield SNVS_LPCR_ON_TIME. */
#define BF_SNVS_LPCR_ON_TIME(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_ON_TIME) & BM_SNVS_LPCR_ON_TIME)

/*! @brief Set the ON_TIME field to a new value. */
#define BW_SNVS_LPCR_ON_TIME(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_ON_TIME) | BF_SNVS_LPCR_ON_TIME(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field PK_EN[22] (RW)
 *
 * PMIC On Request Enable. The value written to PK_EN will be asserted on output
 * signal snvs_lp_pk_en. That signal is used to turn off the pullup/pulldown
 * circuitry in the PMIC I/O pad.
 */
/*@{*/
#define BP_SNVS_LPCR_PK_EN   (22U)         /*!< Bit position for SNVS_LPCR_PK_EN. */
#define BM_SNVS_LPCR_PK_EN   (0x00400000U) /*!< Bit mask for SNVS_LPCR_PK_EN. */
#define BS_SNVS_LPCR_PK_EN   (1U)          /*!< Bit field size in bits for SNVS_LPCR_PK_EN. */

/*! @brief Read current value of the SNVS_LPCR_PK_EN field. */
#define BR_SNVS_LPCR_PK_EN(x) (HW_SNVS_LPCR(x).B.PK_EN)

/*! @brief Format value for bitfield SNVS_LPCR_PK_EN. */
#define BF_SNVS_LPCR_PK_EN(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_PK_EN) & BM_SNVS_LPCR_PK_EN)

/*! @brief Set the PK_EN field to a new value. */
#define BW_SNVS_LPCR_PK_EN(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_PK_EN) | BF_SNVS_LPCR_PK_EN(v)))
/*@}*/

/*!
 * @name Register SNVS_LPCR, field PK_OVERRIDE[23] (RW)
 *
 * PMIC On Request Override. The value written to PK_OVERRIDE will be asserted
 * on output signal snvs_lp_pk_override. That signal is used to override the IOMUX
 * control for the PMIC I/O pad.
 */
/*@{*/
#define BP_SNVS_LPCR_PK_OVERRIDE (23U)     /*!< Bit position for SNVS_LPCR_PK_OVERRIDE. */
#define BM_SNVS_LPCR_PK_OVERRIDE (0x00800000U) /*!< Bit mask for SNVS_LPCR_PK_OVERRIDE. */
#define BS_SNVS_LPCR_PK_OVERRIDE (1U)      /*!< Bit field size in bits for SNVS_LPCR_PK_OVERRIDE. */

/*! @brief Read current value of the SNVS_LPCR_PK_OVERRIDE field. */
#define BR_SNVS_LPCR_PK_OVERRIDE(x) (HW_SNVS_LPCR(x).B.PK_OVERRIDE)

/*! @brief Format value for bitfield SNVS_LPCR_PK_OVERRIDE. */
#define BF_SNVS_LPCR_PK_OVERRIDE(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPCR_PK_OVERRIDE) & BM_SNVS_LPCR_PK_OVERRIDE)

/*! @brief Set the PK_OVERRIDE field to a new value. */
#define BW_SNVS_LPCR_PK_OVERRIDE(x, v) (HW_SNVS_LPCR_WR(x, (HW_SNVS_LPCR_RD(x) & ~BM_SNVS_LPCR_PK_OVERRIDE) | BF_SNVS_LPCR_PK_OVERRIDE(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPSR - SNVS_LP Status Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPSR - SNVS_LP Status Register (RW)
 *
 * Reset value: 0x00000008U
 *
 * The SNVS_LP Status Register reflects the internal state and behavior of the
 * SNVS_LP.
 */
typedef union _hw_snvs_lpsr
{
    uint32_t U;
    struct _hw_snvs_lpsr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t MCR : 1;              /*!< [2]  */
        uint32_t RESERVED1 : 14;       /*!< [16:3]  */
        uint32_t EO : 1;               /*!< [17]  */
        uint32_t SPO : 1;              /*!< [18]  */
        uint32_t RESERVED2 : 13;       /*!< [31:19]  */
    } B;
} hw_snvs_lpsr_t;

/*!
 * @name Constants and macros for entire SNVS_LPSR register
 */
/*@{*/
#define HW_SNVS_LPSR_ADDR(x)     ((uintptr_t)(x) + 0x4CU)

#define HW_SNVS_LPSR(x)          (*(__IO hw_snvs_lpsr_t *) HW_SNVS_LPSR_ADDR(x))
#define HW_SNVS_LPSR_RD(x)       (HW_SNVS_LPSR(x).U)
#define HW_SNVS_LPSR_WR(x, v)    (HW_SNVS_LPSR(x).U = (v))
#define HW_SNVS_LPSR_SET(x, v)   (HW_SNVS_LPSR_WR(x, HW_SNVS_LPSR_RD(x) |  (v)))
#define HW_SNVS_LPSR_CLR(x, v)   (HW_SNVS_LPSR_WR(x, HW_SNVS_LPSR_RD(x) & ~(v)))
#define HW_SNVS_LPSR_TOG(x, v)   (HW_SNVS_LPSR_WR(x, HW_SNVS_LPSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPSR bitfields
 */

/*!
 * @name Register SNVS_LPSR, field MCR[2] (W1C)
 *
 * Monotonic Counter Rollover.
 *
 * Values:
 * - 0 - MC has not reached its maximum value.
 * - 1 - MC has reached its maximum value.
 */
/*@{*/
#define BP_SNVS_LPSR_MCR     (2U)          /*!< Bit position for SNVS_LPSR_MCR. */
#define BM_SNVS_LPSR_MCR     (0x00000004U) /*!< Bit mask for SNVS_LPSR_MCR. */
#define BS_SNVS_LPSR_MCR     (1U)          /*!< Bit field size in bits for SNVS_LPSR_MCR. */

/*! @brief Read current value of the SNVS_LPSR_MCR field. */
#define BR_SNVS_LPSR_MCR(x)  (HW_SNVS_LPSR(x).B.MCR)

/*! @brief Format value for bitfield SNVS_LPSR_MCR. */
#define BF_SNVS_LPSR_MCR(v)  ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSR_MCR) & BM_SNVS_LPSR_MCR)

/*! @brief Set the MCR field to a new value. */
#define BW_SNVS_LPSR_MCR(x, v) (HW_SNVS_LPSR_WR(x, (HW_SNVS_LPSR_RD(x) & ~(BM_SNVS_LPSR_MCR | BM_SNVS_LPSR_EO | BM_SNVS_LPSR_SPO)) | BF_SNVS_LPSR_MCR(v)))
/*@}*/

/*!
 * @name Register SNVS_LPSR, field EO[17] (W1C)
 *
 * Emergency Off This bit is set when a power off is requested.
 *
 * Values:
 * - 0 - Emergency off was not detected.
 * - 1 - Emergency off was detected.
 */
/*@{*/
#define BP_SNVS_LPSR_EO      (17U)         /*!< Bit position for SNVS_LPSR_EO. */
#define BM_SNVS_LPSR_EO      (0x00020000U) /*!< Bit mask for SNVS_LPSR_EO. */
#define BS_SNVS_LPSR_EO      (1U)          /*!< Bit field size in bits for SNVS_LPSR_EO. */

/*! @brief Read current value of the SNVS_LPSR_EO field. */
#define BR_SNVS_LPSR_EO(x)   (HW_SNVS_LPSR(x).B.EO)

/*! @brief Format value for bitfield SNVS_LPSR_EO. */
#define BF_SNVS_LPSR_EO(v)   ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSR_EO) & BM_SNVS_LPSR_EO)

/*! @brief Set the EO field to a new value. */
#define BW_SNVS_LPSR_EO(x, v) (HW_SNVS_LPSR_WR(x, (HW_SNVS_LPSR_RD(x) & ~(BM_SNVS_LPSR_EO | BM_SNVS_LPSR_MCR | BM_SNVS_LPSR_SPO)) | BF_SNVS_LPSR_EO(v)))
/*@}*/

/*!
 * @name Register SNVS_LPSR, field SPO[18] (W1C)
 *
 * Set Power Off The SPO bit is set when the set_pwr_off_irq interrupt is
 * triggered, which happens when software writes a 1 to the TOP bit in the LPCR or when
 * the power button is pressed longer than the configured debounce time. Writing
 * to the SPO bit will clear the set_pwr_off_irq interrupt.
 *
 * Values:
 * - 0 - Emergency Off was not detected.
 * - 1 - Emergency Off was detected..
 */
/*@{*/
#define BP_SNVS_LPSR_SPO     (18U)         /*!< Bit position for SNVS_LPSR_SPO. */
#define BM_SNVS_LPSR_SPO     (0x00040000U) /*!< Bit mask for SNVS_LPSR_SPO. */
#define BS_SNVS_LPSR_SPO     (1U)          /*!< Bit field size in bits for SNVS_LPSR_SPO. */

/*! @brief Read current value of the SNVS_LPSR_SPO field. */
#define BR_SNVS_LPSR_SPO(x)  (HW_SNVS_LPSR(x).B.SPO)

/*! @brief Format value for bitfield SNVS_LPSR_SPO. */
#define BF_SNVS_LPSR_SPO(v)  ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSR_SPO) & BM_SNVS_LPSR_SPO)

/*! @brief Set the SPO field to a new value. */
#define BW_SNVS_LPSR_SPO(x, v) (HW_SNVS_LPSR_WR(x, (HW_SNVS_LPSR_RD(x) & ~(BM_SNVS_LPSR_SPO | BM_SNVS_LPSR_MCR | BM_SNVS_LPSR_EO)) | BF_SNVS_LPSR_SPO(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPSMCMR - SNVS_LP Secure Monotonic Counter MSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPSMCMR - SNVS_LP Secure Monotonic Counter MSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_LP Secure Monotonic Counter MSB Register contains the monotonic
 * counter era bits and the most significant 16 bits of the monotonic counter. The
 * monotonic counter is incremented by one if there is a write command to the
 * LPSMCMR or LPSMCLR register.
 */
typedef union _hw_snvs_lpsmcmr
{
    uint32_t U;
    struct _hw_snvs_lpsmcmr_bitfields
    {
        uint32_t MON_COUNTER : 16;     /*!< [15:0]  */
        uint32_t MC_ERA_BITS : 16;     /*!< [31:16]  */
    } B;
} hw_snvs_lpsmcmr_t;

/*!
 * @name Constants and macros for entire SNVS_LPSMCMR register
 */
/*@{*/
#define HW_SNVS_LPSMCMR_ADDR(x)  ((uintptr_t)(x) + 0x5CU)

#define HW_SNVS_LPSMCMR(x)       (*(__IO hw_snvs_lpsmcmr_t *) HW_SNVS_LPSMCMR_ADDR(x))
#define HW_SNVS_LPSMCMR_RD(x)    (HW_SNVS_LPSMCMR(x).U)
#define HW_SNVS_LPSMCMR_WR(x, v) (HW_SNVS_LPSMCMR(x).U = (v))
#define HW_SNVS_LPSMCMR_SET(x, v) (HW_SNVS_LPSMCMR_WR(x, HW_SNVS_LPSMCMR_RD(x) |  (v)))
#define HW_SNVS_LPSMCMR_CLR(x, v) (HW_SNVS_LPSMCMR_WR(x, HW_SNVS_LPSMCMR_RD(x) & ~(v)))
#define HW_SNVS_LPSMCMR_TOG(x, v) (HW_SNVS_LPSMCMR_WR(x, HW_SNVS_LPSMCMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPSMCMR bitfields
 */

/*!
 * @name Register SNVS_LPSMCMR, field MON_COUNTER[15:0] (RW)
 *
 * Monotonic Counter Most Significant 16 Bits The MC is incremented by one when:
 * A write transaction to the LPSMCMR or LPSMCLR register is detected. The
 * MC_ENV bit is set. MC_SL and MC_HL bits are not set.
 */
/*@{*/
#define BP_SNVS_LPSMCMR_MON_COUNTER (0U)   /*!< Bit position for SNVS_LPSMCMR_MON_COUNTER. */
#define BM_SNVS_LPSMCMR_MON_COUNTER (0x0000FFFFU) /*!< Bit mask for SNVS_LPSMCMR_MON_COUNTER. */
#define BS_SNVS_LPSMCMR_MON_COUNTER (16U)  /*!< Bit field size in bits for SNVS_LPSMCMR_MON_COUNTER. */

/*! @brief Read current value of the SNVS_LPSMCMR_MON_COUNTER field. */
#define BR_SNVS_LPSMCMR_MON_COUNTER(x) (HW_SNVS_LPSMCMR(x).B.MON_COUNTER)

/*! @brief Format value for bitfield SNVS_LPSMCMR_MON_COUNTER. */
#define BF_SNVS_LPSMCMR_MON_COUNTER(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSMCMR_MON_COUNTER) & BM_SNVS_LPSMCMR_MON_COUNTER)

/*! @brief Set the MON_COUNTER field to a new value. */
#define BW_SNVS_LPSMCMR_MON_COUNTER(x, v) (HW_SNVS_LPSMCMR_WR(x, (HW_SNVS_LPSMCMR_RD(x) & ~BM_SNVS_LPSMCMR_MON_COUNTER) | BF_SNVS_LPSMCMR_MON_COUNTER(v)))
/*@}*/

/*!
 * @name Register SNVS_LPSMCMR, field MC_ERA_BITS[31:16] (RW)
 *
 * Monotonic Counter Era Bits These bits are inputs to the module and typically
 * connect to fuses.
 */
/*@{*/
#define BP_SNVS_LPSMCMR_MC_ERA_BITS (16U)  /*!< Bit position for SNVS_LPSMCMR_MC_ERA_BITS. */
#define BM_SNVS_LPSMCMR_MC_ERA_BITS (0xFFFF0000U) /*!< Bit mask for SNVS_LPSMCMR_MC_ERA_BITS. */
#define BS_SNVS_LPSMCMR_MC_ERA_BITS (16U)  /*!< Bit field size in bits for SNVS_LPSMCMR_MC_ERA_BITS. */

/*! @brief Read current value of the SNVS_LPSMCMR_MC_ERA_BITS field. */
#define BR_SNVS_LPSMCMR_MC_ERA_BITS(x) (HW_SNVS_LPSMCMR(x).B.MC_ERA_BITS)

/*! @brief Format value for bitfield SNVS_LPSMCMR_MC_ERA_BITS. */
#define BF_SNVS_LPSMCMR_MC_ERA_BITS(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSMCMR_MC_ERA_BITS) & BM_SNVS_LPSMCMR_MC_ERA_BITS)

/*! @brief Set the MC_ERA_BITS field to a new value. */
#define BW_SNVS_LPSMCMR_MC_ERA_BITS(x, v) (HW_SNVS_LPSMCMR_WR(x, (HW_SNVS_LPSMCMR_RD(x) & ~BM_SNVS_LPSMCMR_MC_ERA_BITS) | BF_SNVS_LPSMCMR_MC_ERA_BITS(v)))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPSMCLR - SNVS_LP Secure Monotonic Counter LSB Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPSMCLR - SNVS_LP Secure Monotonic Counter LSB Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_LP Secure Monotonic Counter LSB Register contains the 32 least
 * significant bits of the monotonic counter. The MC is incremented by one if there is
 * a write command to the LPSMCMR or LPSMCLR register.
 */
typedef union _hw_snvs_lpsmclr
{
    uint32_t U;
    struct _hw_snvs_lpsmclr_bitfields
    {
        uint32_t MON_COUNTER : 32;     /*!< [31:0]  */
    } B;
} hw_snvs_lpsmclr_t;

/*!
 * @name Constants and macros for entire SNVS_LPSMCLR register
 */
/*@{*/
#define HW_SNVS_LPSMCLR_ADDR(x)  ((uintptr_t)(x) + 0x60U)

#define HW_SNVS_LPSMCLR(x)       (*(__IO hw_snvs_lpsmclr_t *) HW_SNVS_LPSMCLR_ADDR(x))
#define HW_SNVS_LPSMCLR_RD(x)    (HW_SNVS_LPSMCLR(x).U)
#define HW_SNVS_LPSMCLR_WR(x, v) (HW_SNVS_LPSMCLR(x).U = (v))
#define HW_SNVS_LPSMCLR_SET(x, v) (HW_SNVS_LPSMCLR_WR(x, HW_SNVS_LPSMCLR_RD(x) |  (v)))
#define HW_SNVS_LPSMCLR_CLR(x, v) (HW_SNVS_LPSMCLR_WR(x, HW_SNVS_LPSMCLR_RD(x) & ~(v)))
#define HW_SNVS_LPSMCLR_TOG(x, v) (HW_SNVS_LPSMCLR_WR(x, HW_SNVS_LPSMCLR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPSMCLR bitfields
 */

/*!
 * @name Register SNVS_LPSMCLR, field MON_COUNTER[31:0] (RW)
 *
 * Monotonic Counter bits The MC is incremented by one when: A write transaction
 * to the LPSMCMR or LPSMCLR Register is detected. The MC_ENV bit is set. MC_SL
 * and MC_HL bits are not set.
 */
/*@{*/
#define BP_SNVS_LPSMCLR_MON_COUNTER (0U)   /*!< Bit position for SNVS_LPSMCLR_MON_COUNTER. */
#define BM_SNVS_LPSMCLR_MON_COUNTER (0xFFFFFFFFU) /*!< Bit mask for SNVS_LPSMCLR_MON_COUNTER. */
#define BS_SNVS_LPSMCLR_MON_COUNTER (32U)  /*!< Bit field size in bits for SNVS_LPSMCLR_MON_COUNTER. */

/*! @brief Read current value of the SNVS_LPSMCLR_MON_COUNTER field. */
#define BR_SNVS_LPSMCLR_MON_COUNTER(x) (HW_SNVS_LPSMCLR(x).U)

/*! @brief Format value for bitfield SNVS_LPSMCLR_MON_COUNTER. */
#define BF_SNVS_LPSMCLR_MON_COUNTER(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPSMCLR_MON_COUNTER) & BM_SNVS_LPSMCLR_MON_COUNTER)

/*! @brief Set the MON_COUNTER field to a new value. */
#define BW_SNVS_LPSMCLR_MON_COUNTER(x, v) (HW_SNVS_LPSMCLR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SNVS_LPGPR - SNVS_LP General Purpose Register
 ******************************************************************************/

/*!
 * @brief HW_SNVS_LPGPR - SNVS_LP General Purpose Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_LP General Purpose Register is a 32-bit read/write register located
 * in the low power domain. Since LPGPR is located in the battery-backed power
 * domain, LPGPR can be used by any application for retaining data during an SoC
 * power-down mode.
 */
typedef union _hw_snvs_lpgpr
{
    uint32_t U;
    struct _hw_snvs_lpgpr_bitfields
    {
        uint32_t GPR : 32;             /*!< [31:0]  */
    } B;
} hw_snvs_lpgpr_t;

/*!
 * @name Constants and macros for entire SNVS_LPGPR register
 */
/*@{*/
#define HW_SNVS_LPGPR_ADDR(x)    ((uintptr_t)(x) + 0x68U)

#define HW_SNVS_LPGPR(x)         (*(__IO hw_snvs_lpgpr_t *) HW_SNVS_LPGPR_ADDR(x))
#define HW_SNVS_LPGPR_RD(x)      (HW_SNVS_LPGPR(x).U)
#define HW_SNVS_LPGPR_WR(x, v)   (HW_SNVS_LPGPR(x).U = (v))
#define HW_SNVS_LPGPR_SET(x, v)  (HW_SNVS_LPGPR_WR(x, HW_SNVS_LPGPR_RD(x) |  (v)))
#define HW_SNVS_LPGPR_CLR(x, v)  (HW_SNVS_LPGPR_WR(x, HW_SNVS_LPGPR_RD(x) & ~(v)))
#define HW_SNVS_LPGPR_TOG(x, v)  (HW_SNVS_LPGPR_WR(x, HW_SNVS_LPGPR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SNVS_LPGPR bitfields
 */

/*!
 * @name Register SNVS_LPGPR, field GPR[31:0] (RW)
 *
 * General Purpose Register When GPR_SL or GPR_HL bit is set, the register
 * cannot be programmed.
 */
/*@{*/
#define BP_SNVS_LPGPR_GPR    (0U)          /*!< Bit position for SNVS_LPGPR_GPR. */
#define BM_SNVS_LPGPR_GPR    (0xFFFFFFFFU) /*!< Bit mask for SNVS_LPGPR_GPR. */
#define BS_SNVS_LPGPR_GPR    (32U)         /*!< Bit field size in bits for SNVS_LPGPR_GPR. */

/*! @brief Read current value of the SNVS_LPGPR_GPR field. */
#define BR_SNVS_LPGPR_GPR(x) (HW_SNVS_LPGPR(x).U)

/*! @brief Format value for bitfield SNVS_LPGPR_GPR. */
#define BF_SNVS_LPGPR_GPR(v) ((uint32_t)((uint32_t)(v) << BP_SNVS_LPGPR_GPR) & BM_SNVS_LPGPR_GPR)

/*! @brief Set the GPR field to a new value. */
#define BW_SNVS_LPGPR_GPR(x, v) (HW_SNVS_LPGPR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPVIDR1 - SNVS_HP Version ID Register 1
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPVIDR1 - SNVS_HP Version ID Register 1 (RO)
 *
 * Reset value: 0x003E0100U
 *
 * The SNVS_HP Version ID Register 1 is a read-only register that contains the
 * current version of the SNVS . The version consists of a module ID, a major
 * version number, and a minor version number.
 */
typedef union _hw_snvs_hpvidr1
{
    uint32_t U;
    struct _hw_snvs_hpvidr1_bitfields
    {
        uint32_t MINOR_REV : 8;        /*!< [7:0]  */
        uint32_t MAJOR_REV : 8;        /*!< [15:8]  */
        uint32_t IP_ID : 16;           /*!< [31:16]  */
    } B;
} hw_snvs_hpvidr1_t;

/*!
 * @name Constants and macros for entire SNVS_HPVIDR1 register
 */
/*@{*/
#define HW_SNVS_HPVIDR1_ADDR(x)  ((uintptr_t)(x) + 0xBF8U)

#define HW_SNVS_HPVIDR1(x)       (*(__I hw_snvs_hpvidr1_t *) HW_SNVS_HPVIDR1_ADDR(x))
#define HW_SNVS_HPVIDR1_RD(x)    (HW_SNVS_HPVIDR1(x).U)
/*@}*/

/*
 * Constants & macros for individual SNVS_HPVIDR1 bitfields
 */

/*!
 * @name Register SNVS_HPVIDR1, field MINOR_REV[7:0] (RO)
 *
 * SNVS block minor version number
 */
/*@{*/
#define BP_SNVS_HPVIDR1_MINOR_REV (0U)     /*!< Bit position for SNVS_HPVIDR1_MINOR_REV. */
#define BM_SNVS_HPVIDR1_MINOR_REV (0x000000FFU) /*!< Bit mask for SNVS_HPVIDR1_MINOR_REV. */
#define BS_SNVS_HPVIDR1_MINOR_REV (8U)     /*!< Bit field size in bits for SNVS_HPVIDR1_MINOR_REV. */

/*! @brief Read current value of the SNVS_HPVIDR1_MINOR_REV field. */
#define BR_SNVS_HPVIDR1_MINOR_REV(x) (HW_SNVS_HPVIDR1(x).B.MINOR_REV)
/*@}*/

/*!
 * @name Register SNVS_HPVIDR1, field MAJOR_REV[15:8] (RO)
 *
 * SNVS block major version number
 */
/*@{*/
#define BP_SNVS_HPVIDR1_MAJOR_REV (8U)     /*!< Bit position for SNVS_HPVIDR1_MAJOR_REV. */
#define BM_SNVS_HPVIDR1_MAJOR_REV (0x0000FF00U) /*!< Bit mask for SNVS_HPVIDR1_MAJOR_REV. */
#define BS_SNVS_HPVIDR1_MAJOR_REV (8U)     /*!< Bit field size in bits for SNVS_HPVIDR1_MAJOR_REV. */

/*! @brief Read current value of the SNVS_HPVIDR1_MAJOR_REV field. */
#define BR_SNVS_HPVIDR1_MAJOR_REV(x) (HW_SNVS_HPVIDR1(x).B.MAJOR_REV)
/*@}*/

/*!
 * @name Register SNVS_HPVIDR1, field IP_ID[31:16] (RO)
 *
 * SNVS block ID
 */
/*@{*/
#define BP_SNVS_HPVIDR1_IP_ID (16U)        /*!< Bit position for SNVS_HPVIDR1_IP_ID. */
#define BM_SNVS_HPVIDR1_IP_ID (0xFFFF0000U) /*!< Bit mask for SNVS_HPVIDR1_IP_ID. */
#define BS_SNVS_HPVIDR1_IP_ID (16U)        /*!< Bit field size in bits for SNVS_HPVIDR1_IP_ID. */

/*! @brief Read current value of the SNVS_HPVIDR1_IP_ID field. */
#define BR_SNVS_HPVIDR1_IP_ID(x) (HW_SNVS_HPVIDR1(x).B.IP_ID)
/*@}*/

/*******************************************************************************
 * HW_SNVS_HPVIDR2 - SNVS_HP Version ID Register 2
 ******************************************************************************/

/*!
 * @brief HW_SNVS_HPVIDR2 - SNVS_HP Version ID Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The SNVS_HP Version ID Register 2 is a read-only register that indicates the
 * current version of the SNVS. Version ID register 2 consists of the following
 * fields: integration options, ECO revision, and configuration options.
 */
typedef union _hw_snvs_hpvidr2
{
    uint32_t U;
    struct _hw_snvs_hpvidr2_bitfields
    {
        uint32_t CONFIG_OPT : 8;       /*!< [7:0]  */
        uint32_t ECO_REV : 8;          /*!< [15:8]  */
        uint32_t INTG_OPT : 8;         /*!< [23:16]  */
        uint32_t IP_ERA : 8;           /*!< [31:24] Era of the IP design */
    } B;
} hw_snvs_hpvidr2_t;

/*!
 * @name Constants and macros for entire SNVS_HPVIDR2 register
 */
/*@{*/
#define HW_SNVS_HPVIDR2_ADDR(x)  ((uintptr_t)(x) + 0xBFCU)

#define HW_SNVS_HPVIDR2(x)       (*(__I hw_snvs_hpvidr2_t *) HW_SNVS_HPVIDR2_ADDR(x))
#define HW_SNVS_HPVIDR2_RD(x)    (HW_SNVS_HPVIDR2(x).U)
/*@}*/

/*
 * Constants & macros for individual SNVS_HPVIDR2 bitfields
 */

/*!
 * @name Register SNVS_HPVIDR2, field CONFIG_OPT[7:0] (RO)
 *
 * SNVS Configuration Option
 */
/*@{*/
#define BP_SNVS_HPVIDR2_CONFIG_OPT (0U)    /*!< Bit position for SNVS_HPVIDR2_CONFIG_OPT. */
#define BM_SNVS_HPVIDR2_CONFIG_OPT (0x000000FFU) /*!< Bit mask for SNVS_HPVIDR2_CONFIG_OPT. */
#define BS_SNVS_HPVIDR2_CONFIG_OPT (8U)    /*!< Bit field size in bits for SNVS_HPVIDR2_CONFIG_OPT. */

/*! @brief Read current value of the SNVS_HPVIDR2_CONFIG_OPT field. */
#define BR_SNVS_HPVIDR2_CONFIG_OPT(x) (HW_SNVS_HPVIDR2(x).B.CONFIG_OPT)
/*@}*/

/*!
 * @name Register SNVS_HPVIDR2, field ECO_REV[15:8] (RO)
 *
 * SNVS ECO Revision
 */
/*@{*/
#define BP_SNVS_HPVIDR2_ECO_REV (8U)       /*!< Bit position for SNVS_HPVIDR2_ECO_REV. */
#define BM_SNVS_HPVIDR2_ECO_REV (0x0000FF00U) /*!< Bit mask for SNVS_HPVIDR2_ECO_REV. */
#define BS_SNVS_HPVIDR2_ECO_REV (8U)       /*!< Bit field size in bits for SNVS_HPVIDR2_ECO_REV. */

/*! @brief Read current value of the SNVS_HPVIDR2_ECO_REV field. */
#define BR_SNVS_HPVIDR2_ECO_REV(x) (HW_SNVS_HPVIDR2(x).B.ECO_REV)
/*@}*/

/*!
 * @name Register SNVS_HPVIDR2, field INTG_OPT[23:16] (RO)
 *
 * SNVS Integration Option
 */
/*@{*/
#define BP_SNVS_HPVIDR2_INTG_OPT (16U)     /*!< Bit position for SNVS_HPVIDR2_INTG_OPT. */
#define BM_SNVS_HPVIDR2_INTG_OPT (0x00FF0000U) /*!< Bit mask for SNVS_HPVIDR2_INTG_OPT. */
#define BS_SNVS_HPVIDR2_INTG_OPT (8U)      /*!< Bit field size in bits for SNVS_HPVIDR2_INTG_OPT. */

/*! @brief Read current value of the SNVS_HPVIDR2_INTG_OPT field. */
#define BR_SNVS_HPVIDR2_INTG_OPT(x) (HW_SNVS_HPVIDR2(x).B.INTG_OPT)
/*@}*/

/*!
 * @name Register SNVS_HPVIDR2, field IP_ERA[31:24] (RO)
 *
 * 00h - Era 1 or 2 03h - Era 3 04h - Era 4 05h - Era 5
 */
/*@{*/
#define BP_SNVS_HPVIDR2_IP_ERA (24U)       /*!< Bit position for SNVS_HPVIDR2_IP_ERA. */
#define BM_SNVS_HPVIDR2_IP_ERA (0xFF000000U) /*!< Bit mask for SNVS_HPVIDR2_IP_ERA. */
#define BS_SNVS_HPVIDR2_IP_ERA (8U)        /*!< Bit field size in bits for SNVS_HPVIDR2_IP_ERA. */

/*! @brief Read current value of the SNVS_HPVIDR2_IP_ERA field. */
#define BR_SNVS_HPVIDR2_IP_ERA(x) (HW_SNVS_HPVIDR2(x).B.IP_ERA)
/*@}*/

/*******************************************************************************
 * hw_snvs_t - module struct
 ******************************************************************************/
/*!
 * @brief All SNVS module registers.
 */
#pragma pack(1)
typedef struct _hw_snvs
{
    __IO hw_snvs_hplr_t HPLR;              /*!< [0x0] SNVS_HP Lock Register */
    __IO hw_snvs_hpcomr_t HPCOMR;          /*!< [0x4] SNVS_HP Command Register */
    __IO hw_snvs_hpcr_t HPCR;              /*!< [0x8] SNVS_HP Control Register */
    uint8_t _reserved0[8];
    __IO hw_snvs_hpsr_t HPSR;              /*!< [0x14] SNVS_HP Status Register */
    uint8_t _reserved1[12];
    __IO hw_snvs_hprtcmr_t HPRTCMR;        /*!< [0x24] SNVS_HP Real Time Counter MSB Register */
    __IO hw_snvs_hprtclr_t HPRTCLR;        /*!< [0x28] SNVS_HP Real Time Counter LSB Register */
    __IO hw_snvs_hptamr_t HPTAMR;          /*!< [0x2C] SNVS_HP Time Alarm MSB Register */
    __IO hw_snvs_hptalr_t HPTALR;          /*!< [0x30] SNVS_HP Time Alarm LSB Register */
    __IO hw_snvs_lplr_t LPLR;              /*!< [0x34] SNVS_LP Lock Register */
    __IO hw_snvs_lpcr_t LPCR;              /*!< [0x38] SNVS_LP Control Register */
    uint8_t _reserved2[16];
    __IO hw_snvs_lpsr_t LPSR;              /*!< [0x4C] SNVS_LP Status Register */
    uint8_t _reserved3[12];
    __IO hw_snvs_lpsmcmr_t LPSMCMR;        /*!< [0x5C] SNVS_LP Secure Monotonic Counter MSB Register */
    __IO hw_snvs_lpsmclr_t LPSMCLR;        /*!< [0x60] SNVS_LP Secure Monotonic Counter LSB Register */
    uint8_t _reserved4[4];
    __IO hw_snvs_lpgpr_t LPGPR;            /*!< [0x68] SNVS_LP General Purpose Register */
    uint8_t _reserved5[2956];
    __I hw_snvs_hpvidr1_t HPVIDR1;         /*!< [0xBF8] SNVS_HP Version ID Register 1 */
    __I hw_snvs_hpvidr2_t HPVIDR2;         /*!< [0xBFC] SNVS_HP Version ID Register 2 */
} hw_snvs_t;
#pragma pack()

/*! @brief Macro to access all SNVS registers. */
/*! @param x SNVS module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SNVS_REGS(SNVS_BASE)</code>. */
#define HW_SNVS_REGS(x) (*(hw_snvs_t *)(x))

/*
 * iMX6DP SPBA
 *
 * Temperature Monitor
 *
 * Registers defined in this header file:
 * - HW_SPBA_PRRn - Peripheral Rights Register
 *
 * - hw_spba_t - Struct containing all module registers.
 */

#define HW_SPBA_INSTANCE_COUNT (1U) /*!< Number of instances of the SPBA module. */
#define HW_SPBA (0U) /*!< Instance number for SPBA. */
#define SPBA_BASE             (0x203C000U) /*!< Base address for SPBA. */
/*! Array initializer of SPBA base addresses. */
#define SPBA_BASE_ADDRS       { SPBA_BASE }

/*******************************************************************************
 * HW_SPBA_PRRn - Peripheral Rights Register
 ******************************************************************************/

/*!
 * @brief HW_SPBA_PRRn - Peripheral Rights Register (RW)
 *
 * Reset value: 0x00000007U
 *
 * This register controls master ownership and access for a peripheral.
 */
typedef union _hw_spba_prrn
{
    uint32_t U;
    struct _hw_spba_prrn_bitfields
    {
        uint32_t RARA : 1;             /*!< [0]  */
        uint32_t RARB : 1;             /*!< [1]  */
        uint32_t RARC : 1;             /*!< [2]  */
        uint32_t RESERVED0 : 13;       /*!< [15:3]  */
        uint32_t ROI : 2;              /*!< [17:16]  */
        uint32_t RESERVED1 : 12;       /*!< [29:18]  */
        uint32_t RMO : 2;              /*!< [31:30]  */
    } B;
} hw_spba_prrn_t;

/*!
 * @name Constants and macros for entire SPBA_PRRn register
 */
/*@{*/
#define HW_SPBA_PRRn_COUNT (32U)

#define HW_SPBA_PRRn_ADDR(x, n)  ((uintptr_t)(x) + 0x0U + (0x4U * (n)))

#define HW_SPBA_PRRn(x, n)       (*(__IO hw_spba_prrn_t *) HW_SPBA_PRRn_ADDR(x, n))
#define HW_SPBA_PRRn_RD(x, n)    (HW_SPBA_PRRn(x, n).U)
#define HW_SPBA_PRRn_WR(x, n, v) (HW_SPBA_PRRn(x, n).U = (v))
#define HW_SPBA_PRRn_SET(x, n, v) (HW_SPBA_PRRn_WR(x, n, HW_SPBA_PRRn_RD(x, n) |  (v)))
#define HW_SPBA_PRRn_CLR(x, n, v) (HW_SPBA_PRRn_WR(x, n, HW_SPBA_PRRn_RD(x, n) & ~(v)))
#define HW_SPBA_PRRn_TOG(x, n, v) (HW_SPBA_PRRn_WR(x, n, HW_SPBA_PRRn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPBA_PRRn bitfields
 */

/*!
 * @name Register SPBA_PRRn, field RARA[0] (RW)
 *
 * Resource Access Right. Control and Status bit for master A. This field
 * indicates whether master A can access the peripheral. From 0 up to 3 masters can
 * have permission to access a resource (all the master can be granted on a
 * peripheral, but only one access at a time will be granted by SPBA).
 *
 * Values:
 * - 0 - Access to peripheral is not allowed.
 * - 1 - Access to peripheral is granted.
 */
/*@{*/
#define BP_SPBA_PRRn_RARA    (0U)          /*!< Bit position for SPBA_PRRn_RARA. */
#define BM_SPBA_PRRn_RARA    (0x00000001U) /*!< Bit mask for SPBA_PRRn_RARA. */
#define BS_SPBA_PRRn_RARA    (1U)          /*!< Bit field size in bits for SPBA_PRRn_RARA. */

#define BV_SPBA_PRRn_RARA_PROHIBITED   (0U)          /*!< Bit field value for SPBA_PRRn_RARA: Access to peripheral is not allowed. */
#define BV_SPBA_PRRn_RARA_ALLOWED      (0x1U)        /*!< Bit field value for SPBA_PRRn_RARA: Access to peripheral is granted. */

/*! @brief Read current value of the SPBA_PRRn_RARA field. */
#define BR_SPBA_PRRn_RARA(x, n) (HW_SPBA_PRRn(x, n).B.RARA)

/*! @brief Format value for bitfield SPBA_PRRn_RARA. */
#define BF_SPBA_PRRn_RARA(v) ((uint32_t)((uint32_t)(v) << BP_SPBA_PRRn_RARA) & BM_SPBA_PRRn_RARA)

/*! @brief Set the RARA field to a new value. */
#define BW_SPBA_PRRn_RARA(x, n, v) (HW_SPBA_PRRn_WR(x, n, (HW_SPBA_PRRn_RD(x, n) & ~BM_SPBA_PRRn_RARA) | BF_SPBA_PRRn_RARA(v)))
/*@}*/

/*!
 * @name Register SPBA_PRRn, field RARB[1] (RW)
 *
 * Resource Access Right. Control and Status bit for master B. This field
 * indicates whether master B can access the peripheral. From 0 up to 3 masters can
 * have permission to access a resource (all the master can be granted on a
 * peripheral, but only one access at a time will be granted by SPBA).
 *
 * Values:
 * - 0 - Access to peripheral is not allowed.
 * - 1 - Access to peripheral is granted.
 */
/*@{*/
#define BP_SPBA_PRRn_RARB    (1U)          /*!< Bit position for SPBA_PRRn_RARB. */
#define BM_SPBA_PRRn_RARB    (0x00000002U) /*!< Bit mask for SPBA_PRRn_RARB. */
#define BS_SPBA_PRRn_RARB    (1U)          /*!< Bit field size in bits for SPBA_PRRn_RARB. */

#define BV_SPBA_PRRn_RARB_PROHIBITED   (0U)          /*!< Bit field value for SPBA_PRRn_RARB: Access to peripheral is not allowed. */
#define BV_SPBA_PRRn_RARB_ALLOWED      (0x1U)        /*!< Bit field value for SPBA_PRRn_RARB: Access to peripheral is granted. */

/*! @brief Read current value of the SPBA_PRRn_RARB field. */
#define BR_SPBA_PRRn_RARB(x, n) (HW_SPBA_PRRn(x, n).B.RARB)

/*! @brief Format value for bitfield SPBA_PRRn_RARB. */
#define BF_SPBA_PRRn_RARB(v) ((uint32_t)((uint32_t)(v) << BP_SPBA_PRRn_RARB) & BM_SPBA_PRRn_RARB)

/*! @brief Set the RARB field to a new value. */
#define BW_SPBA_PRRn_RARB(x, n, v) (HW_SPBA_PRRn_WR(x, n, (HW_SPBA_PRRn_RD(x, n) & ~BM_SPBA_PRRn_RARB) | BF_SPBA_PRRn_RARB(v)))
/*@}*/

/*!
 * @name Register SPBA_PRRn, field RARC[2] (RW)
 *
 * Resource Access Right. Control and Status bit for master C. This field
 * indicates whether master C can access the peripheral. From 0 up to 3 masters can
 * have permission to access a resource (all the master can be granted on a
 * peripheral, but only one access at a time will be granted by SPBA).
 *
 * Values:
 * - 0 - Access to peripheral is not allowed.
 * - 1 - Access to peripheral is granted.
 */
/*@{*/
#define BP_SPBA_PRRn_RARC    (2U)          /*!< Bit position for SPBA_PRRn_RARC. */
#define BM_SPBA_PRRn_RARC    (0x00000004U) /*!< Bit mask for SPBA_PRRn_RARC. */
#define BS_SPBA_PRRn_RARC    (1U)          /*!< Bit field size in bits for SPBA_PRRn_RARC. */

#define BV_SPBA_PRRn_RARC_PROHIBITED   (0U)          /*!< Bit field value for SPBA_PRRn_RARC: Access to peripheral is not allowed. */
#define BV_SPBA_PRRn_RARC_ALLOWED      (0x1U)        /*!< Bit field value for SPBA_PRRn_RARC: Access to peripheral is granted. */

/*! @brief Read current value of the SPBA_PRRn_RARC field. */
#define BR_SPBA_PRRn_RARC(x, n) (HW_SPBA_PRRn(x, n).B.RARC)

/*! @brief Format value for bitfield SPBA_PRRn_RARC. */
#define BF_SPBA_PRRn_RARC(v) ((uint32_t)((uint32_t)(v) << BP_SPBA_PRRn_RARC) & BM_SPBA_PRRn_RARC)

/*! @brief Set the RARC field to a new value. */
#define BW_SPBA_PRRn_RARC(x, n, v) (HW_SPBA_PRRn_WR(x, n, (HW_SPBA_PRRn_RD(x, n) & ~BM_SPBA_PRRn_RARC) | BF_SPBA_PRRn_RARC(v)))
/*@}*/

/*!
 * @name Register SPBA_PRRn, field ROI[17:16] (RO)
 *
 * Resource Owner ID. This field indicates which master (one at a time) can
 * access to the PRR for rights modification. This is a read-only register. After
 * reset, ROI bits are cleared ("00" -> un-owned resource). A master performing a
 * write access to the an un-owned PRR will get its ID automatically written into
 * ROI, while modifying RARx bits. It can then read back the RMO, RAR, ROI bits to
 * make sure RMO returns the right value, ROI bits contain its ID and RARx bits
 * are correctly asserted. Then no other master (whom ID is different from the
 * one stored in ROI) will be able to modify RAR fields. Owner master of a
 * peripheral can assert its dead_owner signal, or write 1'b0 in the RARx to release the
 * ownership (ROI[1:0] reset to 2'b0).
 *
 * Values:
 * - 00 - Unowned resource.
 * - 01 - The resource is owned by master A port.
 * - 10 - The resource is owned by master B port.
 * - 11 - The resource is owned by master C port.
 */
/*@{*/
#define BP_SPBA_PRRn_ROI     (16U)         /*!< Bit position for SPBA_PRRn_ROI. */
#define BM_SPBA_PRRn_ROI     (0x00030000U) /*!< Bit mask for SPBA_PRRn_ROI. */
#define BS_SPBA_PRRn_ROI     (2U)          /*!< Bit field size in bits for SPBA_PRRn_ROI. */

#define BV_SPBA_PRRn_ROI_UNOWNED       (0U)          /*!< Bit field value for SPBA_PRRn_ROI: Unowned resource. */
#define BV_SPBA_PRRn_ROI_MASTER_A      (0x1U)        /*!< Bit field value for SPBA_PRRn_ROI: The resource is owned by master A port. */
#define BV_SPBA_PRRn_ROI_MASTER_B      (0x2U)        /*!< Bit field value for SPBA_PRRn_ROI: The resource is owned by master B port. */
#define BV_SPBA_PRRn_ROI_MASTER_C      (0x3U)        /*!< Bit field value for SPBA_PRRn_ROI: The resource is owned by master C port. */

/*! @brief Read current value of the SPBA_PRRn_ROI field. */
#define BR_SPBA_PRRn_ROI(x, n) (HW_SPBA_PRRn(x, n).B.ROI)
/*@}*/

/*!
 * @name Register SPBA_PRRn, field RMO[31:30] (RO)
 *
 * Requesting Master Owner. This 2-bit register field indicates if the
 * corresponding resource is owned by the requesting master or not. This register is reset
 * to 2'b0 if ROI = 2'b0.
 *
 * Values:
 * - 00 - The resource is unowned.
 * - 01 - Reserved.
 * - 10 - The resource is owned by another master.
 * - 11 - The resource is owned by the requesting master.
 */
/*@{*/
#define BP_SPBA_PRRn_RMO     (30U)         /*!< Bit position for SPBA_PRRn_RMO. */
#define BM_SPBA_PRRn_RMO     (0xC0000000U) /*!< Bit mask for SPBA_PRRn_RMO. */
#define BS_SPBA_PRRn_RMO     (2U)          /*!< Bit field size in bits for SPBA_PRRn_RMO. */

#define BV_SPBA_PRRn_RMO_UNOWNED       (0U)          /*!< Bit field value for SPBA_PRRn_RMO: The resource is unowned. */
#define BV_SPBA_PRRn_RMO_ANOTHER_MASTER (0x2U)       /*!< Bit field value for SPBA_PRRn_RMO: The resource is owned by another master. */
#define BV_SPBA_PRRn_RMO_REQUESTING_MASTER (0x3U)    /*!< Bit field value for SPBA_PRRn_RMO: The resource is owned by the requesting master. */

/*! @brief Read current value of the SPBA_PRRn_RMO field. */
#define BR_SPBA_PRRn_RMO(x, n) (HW_SPBA_PRRn(x, n).B.RMO)
/*@}*/

/*******************************************************************************
 * hw_spba_t - module struct
 ******************************************************************************/
/*!
 * @brief All SPBA module registers.
 */
#pragma pack(1)
typedef struct _hw_spba
{
    __IO hw_spba_prrn_t PRRn[32];          /*!< [0x0] Peripheral Rights Register */
} hw_spba_t;
#pragma pack()

/*! @brief Macro to access all SPBA registers. */
/*! @param x SPBA module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SPBA_REGS(SPBA_BASE)</code>. */
#define HW_SPBA_REGS(x) (*(hw_spba_t *)(x))

/*
 * iMX6DP SPDIF
 *
 * SPDIF
 *
 * Registers defined in this header file:
 * - HW_SPDIF_SCR - SPDIF Configuration Register
 * - HW_SPDIF_SRCD - CDText Control Register
 * - HW_SPDIF_SRPC - PhaseConfig Register
 * - HW_SPDIF_SIE - InterruptEn Register
 * - HW_SPDIF_SIC - InterruptClear Register
 * - HW_SPDIF_SIS - InterruptStat Register
 * - HW_SPDIF_SRL - SPDIFRxLeft Register
 * - HW_SPDIF_SRR - SPDIFRxRight Register
 * - HW_SPDIF_SRCSH - SPDIFRxCChannel_h Register
 * - HW_SPDIF_SRCSL - SPDIFRxCChannel_l Register
 * - HW_SPDIF_SRU - UchannelRx Register
 * - HW_SPDIF_SRQ - QchannelRx Register
 * - HW_SPDIF_STL - SPDIFTxLeft Register
 * - HW_SPDIF_STR - SPDIFTxRight Register
 * - HW_SPDIF_STCSCH - SPDIFTxCChannelCons_h Register
 * - HW_SPDIF_STCSCL - SPDIFTxCChannelCons_l Register
 * - HW_SPDIF_SRFM - FreqMeas Register
 * - HW_SPDIF_STC - SPDIFTxClk Register
 *
 * - hw_spdif_t - Struct containing all module registers.
 */

#define HW_SPDIF_INSTANCE_COUNT (1U) /*!< Number of instances of the SPDIF module. */
#define HW_SPDIF (0U) /*!< Instance number for SPDIF. */
#define SPDIF_BASE            (0x2004000U) /*!< Base address for SPDIF. */
/*! Array initializer of SPDIF base addresses. */
#define SPDIF_BASE_ADDRS      { SPDIF_BASE }

/*******************************************************************************
 * HW_SPDIF_SCR - SPDIF Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SCR - SPDIF Configuration Register (RW)
 *
 * Reset value: 0x00000400U
 */
typedef union _hw_spdif_scr
{
    uint32_t U;
    struct _hw_spdif_scr_bitfields
    {
        uint32_t USrc_Sel : 2;         /*!< [1:0]  */
        uint32_t TxSel : 3;            /*!< [4:2]  */
        uint32_t ValCtrl : 1;          /*!< [5]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t DMA_TX_En : 1;        /*!< [8]  */
        uint32_t DMA_Rx_En : 1;        /*!< [9]  */
        uint32_t TxFIFO_Ctrl : 2;      /*!< [11:10]  */
        uint32_t soft_reset : 1;       /*!< [12]  */
        uint32_t LOW_POWER : 1;        /*!< [13]  */
        uint32_t RESERVED1 : 1;        /*!< [14]  */
        uint32_t TxFIFOEmpty_Sel : 2;  /*!< [16:15]  */
        uint32_t TxAutoSync : 1;       /*!< [17]  */
        uint32_t RxAutoSync : 1;       /*!< [18]  */
        uint32_t RxFIFOFull_Sel : 2;   /*!< [20:19]  */
        uint32_t RxFIFO_Rst : 1;       /*!< [21]  */
        uint32_t RxFIFO_Off_On : 1;    /*!< [22]  */
        uint32_t RxFIFO_Ctrl : 1;      /*!< [23]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_scr_t;

/*!
 * @name Constants and macros for entire SPDIF_SCR register
 */
/*@{*/
#define HW_SPDIF_SCR_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_SPDIF_SCR(x)          (*(__IO hw_spdif_scr_t *) HW_SPDIF_SCR_ADDR(x))
#define HW_SPDIF_SCR_RD(x)       (HW_SPDIF_SCR(x).U)
#define HW_SPDIF_SCR_WR(x, v)    (HW_SPDIF_SCR(x).U = (v))
#define HW_SPDIF_SCR_SET(x, v)   (HW_SPDIF_SCR_WR(x, HW_SPDIF_SCR_RD(x) |  (v)))
#define HW_SPDIF_SCR_CLR(x, v)   (HW_SPDIF_SCR_WR(x, HW_SPDIF_SCR_RD(x) & ~(v)))
#define HW_SPDIF_SCR_TOG(x, v)   (HW_SPDIF_SCR_WR(x, HW_SPDIF_SCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_SCR bitfields
 */

/*!
 * @name Register SPDIF_SCR, field USrc_Sel[1:0] (RW)
 *
 * Values:
 * - 00 - No embedded U channel
 * - 01 - U channel from SPDIF receive block (CD mode)
 * - 10 - Reserved
 * - 11 - U channel from on chip transmitter
 */
/*@{*/
#define BP_SPDIF_SCR_USrc_Sel (0U)         /*!< Bit position for SPDIF_SCR_USrc_Sel. */
#define BM_SPDIF_SCR_USrc_Sel (0x00000003U) /*!< Bit mask for SPDIF_SCR_USrc_Sel. */
#define BS_SPDIF_SCR_USrc_Sel (2U)         /*!< Bit field size in bits for SPDIF_SCR_USrc_Sel. */

/*! @brief Read current value of the SPDIF_SCR_USrc_Sel field. */
#define BR_SPDIF_SCR_USrc_Sel(x) (HW_SPDIF_SCR(x).B.USrc_Sel)

/*! @brief Format value for bitfield SPDIF_SCR_USrc_Sel. */
#define BF_SPDIF_SCR_USrc_Sel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_USrc_Sel) & BM_SPDIF_SCR_USrc_Sel)

/*! @brief Set the USrc_Sel field to a new value. */
#define BW_SPDIF_SCR_USrc_Sel(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_USrc_Sel) | BF_SPDIF_SCR_USrc_Sel(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field TxSel[4:2] (RW)
 *
 * Values:
 * - 000 - Off and output 0
 * - 001 - Feed-through SPDIFIN
 * - 101 - Tx Normal operation
 */
/*@{*/
#define BP_SPDIF_SCR_TxSel   (2U)          /*!< Bit position for SPDIF_SCR_TxSel. */
#define BM_SPDIF_SCR_TxSel   (0x0000001CU) /*!< Bit mask for SPDIF_SCR_TxSel. */
#define BS_SPDIF_SCR_TxSel   (3U)          /*!< Bit field size in bits for SPDIF_SCR_TxSel. */

/*! @brief Read current value of the SPDIF_SCR_TxSel field. */
#define BR_SPDIF_SCR_TxSel(x) (HW_SPDIF_SCR(x).B.TxSel)

/*! @brief Format value for bitfield SPDIF_SCR_TxSel. */
#define BF_SPDIF_SCR_TxSel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_TxSel) & BM_SPDIF_SCR_TxSel)

/*! @brief Set the TxSel field to a new value. */
#define BW_SPDIF_SCR_TxSel(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_TxSel) | BF_SPDIF_SCR_TxSel(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field ValCtrl[5] (RW)
 *
 * Values:
 * - 0 - Outgoing Validity always set
 * - 1 - Outgoing Validity always clear
 */
/*@{*/
#define BP_SPDIF_SCR_ValCtrl (5U)          /*!< Bit position for SPDIF_SCR_ValCtrl. */
#define BM_SPDIF_SCR_ValCtrl (0x00000020U) /*!< Bit mask for SPDIF_SCR_ValCtrl. */
#define BS_SPDIF_SCR_ValCtrl (1U)          /*!< Bit field size in bits for SPDIF_SCR_ValCtrl. */

/*! @brief Read current value of the SPDIF_SCR_ValCtrl field. */
#define BR_SPDIF_SCR_ValCtrl(x) (HW_SPDIF_SCR(x).B.ValCtrl)

/*! @brief Format value for bitfield SPDIF_SCR_ValCtrl. */
#define BF_SPDIF_SCR_ValCtrl(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_ValCtrl) & BM_SPDIF_SCR_ValCtrl)

/*! @brief Set the ValCtrl field to a new value. */
#define BW_SPDIF_SCR_ValCtrl(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_ValCtrl) | BF_SPDIF_SCR_ValCtrl(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field DMA_TX_En[8] (RW)
 *
 * DMA Transmit Request Enable (Tx FIFO empty)
 */
/*@{*/
#define BP_SPDIF_SCR_DMA_TX_En (8U)        /*!< Bit position for SPDIF_SCR_DMA_TX_En. */
#define BM_SPDIF_SCR_DMA_TX_En (0x00000100U) /*!< Bit mask for SPDIF_SCR_DMA_TX_En. */
#define BS_SPDIF_SCR_DMA_TX_En (1U)        /*!< Bit field size in bits for SPDIF_SCR_DMA_TX_En. */

/*! @brief Read current value of the SPDIF_SCR_DMA_TX_En field. */
#define BR_SPDIF_SCR_DMA_TX_En(x) (HW_SPDIF_SCR(x).B.DMA_TX_En)

/*! @brief Format value for bitfield SPDIF_SCR_DMA_TX_En. */
#define BF_SPDIF_SCR_DMA_TX_En(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_DMA_TX_En) & BM_SPDIF_SCR_DMA_TX_En)

/*! @brief Set the DMA_TX_En field to a new value. */
#define BW_SPDIF_SCR_DMA_TX_En(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_DMA_TX_En) | BF_SPDIF_SCR_DMA_TX_En(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field DMA_Rx_En[9] (RW)
 *
 * DMA Receive Request Enable (RX FIFO full)
 */
/*@{*/
#define BP_SPDIF_SCR_DMA_Rx_En (9U)        /*!< Bit position for SPDIF_SCR_DMA_Rx_En. */
#define BM_SPDIF_SCR_DMA_Rx_En (0x00000200U) /*!< Bit mask for SPDIF_SCR_DMA_Rx_En. */
#define BS_SPDIF_SCR_DMA_Rx_En (1U)        /*!< Bit field size in bits for SPDIF_SCR_DMA_Rx_En. */

/*! @brief Read current value of the SPDIF_SCR_DMA_Rx_En field. */
#define BR_SPDIF_SCR_DMA_Rx_En(x) (HW_SPDIF_SCR(x).B.DMA_Rx_En)

/*! @brief Format value for bitfield SPDIF_SCR_DMA_Rx_En. */
#define BF_SPDIF_SCR_DMA_Rx_En(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_DMA_Rx_En) & BM_SPDIF_SCR_DMA_Rx_En)

/*! @brief Set the DMA_Rx_En field to a new value. */
#define BW_SPDIF_SCR_DMA_Rx_En(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_DMA_Rx_En) | BF_SPDIF_SCR_DMA_Rx_En(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field TxFIFO_Ctrl[11:10] (RW)
 *
 * Values:
 * - 00 - Send out digital zero on SPDIF Tx
 * - 01 - Tx Normal operation
 * - 10 - Reset to 1 sample remaining
 * - 11 - Reserved
 */
/*@{*/
#define BP_SPDIF_SCR_TxFIFO_Ctrl (10U)     /*!< Bit position for SPDIF_SCR_TxFIFO_Ctrl. */
#define BM_SPDIF_SCR_TxFIFO_Ctrl (0x00000C00U) /*!< Bit mask for SPDIF_SCR_TxFIFO_Ctrl. */
#define BS_SPDIF_SCR_TxFIFO_Ctrl (2U)      /*!< Bit field size in bits for SPDIF_SCR_TxFIFO_Ctrl. */

/*! @brief Read current value of the SPDIF_SCR_TxFIFO_Ctrl field. */
#define BR_SPDIF_SCR_TxFIFO_Ctrl(x) (HW_SPDIF_SCR(x).B.TxFIFO_Ctrl)

/*! @brief Format value for bitfield SPDIF_SCR_TxFIFO_Ctrl. */
#define BF_SPDIF_SCR_TxFIFO_Ctrl(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_TxFIFO_Ctrl) & BM_SPDIF_SCR_TxFIFO_Ctrl)

/*! @brief Set the TxFIFO_Ctrl field to a new value. */
#define BW_SPDIF_SCR_TxFIFO_Ctrl(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_TxFIFO_Ctrl) | BF_SPDIF_SCR_TxFIFO_Ctrl(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field soft_reset[12] (RW)
 *
 * When write 1 to this bit, it will cause SPDIF software reset. The software
 * reset will last 8 cycles. When in the reset process, return 1 when read. else
 * return 0 when read.
 */
/*@{*/
#define BP_SPDIF_SCR_soft_reset (12U)      /*!< Bit position for SPDIF_SCR_soft_reset. */
#define BM_SPDIF_SCR_soft_reset (0x00001000U) /*!< Bit mask for SPDIF_SCR_soft_reset. */
#define BS_SPDIF_SCR_soft_reset (1U)       /*!< Bit field size in bits for SPDIF_SCR_soft_reset. */

/*! @brief Read current value of the SPDIF_SCR_soft_reset field. */
#define BR_SPDIF_SCR_soft_reset(x) (HW_SPDIF_SCR(x).B.soft_reset)

/*! @brief Format value for bitfield SPDIF_SCR_soft_reset. */
#define BF_SPDIF_SCR_soft_reset(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_soft_reset) & BM_SPDIF_SCR_soft_reset)

/*! @brief Set the soft_reset field to a new value. */
#define BW_SPDIF_SCR_soft_reset(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_soft_reset) | BF_SPDIF_SCR_soft_reset(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field LOW_POWER[13] (RW)
 *
 * When write 1 to this bit, it will cause SPDIF enter low-power mode. return 1
 * when SPDIF in Low-Power mode.
 */
/*@{*/
#define BP_SPDIF_SCR_LOW_POWER (13U)       /*!< Bit position for SPDIF_SCR_LOW_POWER. */
#define BM_SPDIF_SCR_LOW_POWER (0x00002000U) /*!< Bit mask for SPDIF_SCR_LOW_POWER. */
#define BS_SPDIF_SCR_LOW_POWER (1U)        /*!< Bit field size in bits for SPDIF_SCR_LOW_POWER. */

/*! @brief Read current value of the SPDIF_SCR_LOW_POWER field. */
#define BR_SPDIF_SCR_LOW_POWER(x) (HW_SPDIF_SCR(x).B.LOW_POWER)

/*! @brief Format value for bitfield SPDIF_SCR_LOW_POWER. */
#define BF_SPDIF_SCR_LOW_POWER(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_LOW_POWER) & BM_SPDIF_SCR_LOW_POWER)

/*! @brief Set the LOW_POWER field to a new value. */
#define BW_SPDIF_SCR_LOW_POWER(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_LOW_POWER) | BF_SPDIF_SCR_LOW_POWER(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field TxFIFOEmpty_Sel[16:15] (RW)
 *
 * Values:
 * - 00 - Empty interrupt if 0 sample in Tx left and right FIFOs
 * - 01 - Empty interrupt if at most 4 sample in Tx left and right FIFOs
 * - 10 - Empty interrupt if at most 8 sample in Tx left and right FIFOs
 * - 11 - Empty interrupt if at most 12 sample in Tx left and right FIFOs
 */
/*@{*/
#define BP_SPDIF_SCR_TxFIFOEmpty_Sel (15U) /*!< Bit position for SPDIF_SCR_TxFIFOEmpty_Sel. */
#define BM_SPDIF_SCR_TxFIFOEmpty_Sel (0x00018000U) /*!< Bit mask for SPDIF_SCR_TxFIFOEmpty_Sel. */
#define BS_SPDIF_SCR_TxFIFOEmpty_Sel (2U)  /*!< Bit field size in bits for SPDIF_SCR_TxFIFOEmpty_Sel. */

/*! @brief Read current value of the SPDIF_SCR_TxFIFOEmpty_Sel field. */
#define BR_SPDIF_SCR_TxFIFOEmpty_Sel(x) (HW_SPDIF_SCR(x).B.TxFIFOEmpty_Sel)

/*! @brief Format value for bitfield SPDIF_SCR_TxFIFOEmpty_Sel. */
#define BF_SPDIF_SCR_TxFIFOEmpty_Sel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_TxFIFOEmpty_Sel) & BM_SPDIF_SCR_TxFIFOEmpty_Sel)

/*! @brief Set the TxFIFOEmpty_Sel field to a new value. */
#define BW_SPDIF_SCR_TxFIFOEmpty_Sel(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_TxFIFOEmpty_Sel) | BF_SPDIF_SCR_TxFIFOEmpty_Sel(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field TxAutoSync[17] (RW)
 *
 * Values:
 * - 0 - Tx FIFO auto sync off
 * - 1 - Tx FIFO auto sync on
 */
/*@{*/
#define BP_SPDIF_SCR_TxAutoSync (17U)      /*!< Bit position for SPDIF_SCR_TxAutoSync. */
#define BM_SPDIF_SCR_TxAutoSync (0x00020000U) /*!< Bit mask for SPDIF_SCR_TxAutoSync. */
#define BS_SPDIF_SCR_TxAutoSync (1U)       /*!< Bit field size in bits for SPDIF_SCR_TxAutoSync. */

/*! @brief Read current value of the SPDIF_SCR_TxAutoSync field. */
#define BR_SPDIF_SCR_TxAutoSync(x) (HW_SPDIF_SCR(x).B.TxAutoSync)

/*! @brief Format value for bitfield SPDIF_SCR_TxAutoSync. */
#define BF_SPDIF_SCR_TxAutoSync(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_TxAutoSync) & BM_SPDIF_SCR_TxAutoSync)

/*! @brief Set the TxAutoSync field to a new value. */
#define BW_SPDIF_SCR_TxAutoSync(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_TxAutoSync) | BF_SPDIF_SCR_TxAutoSync(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field RxAutoSync[18] (RW)
 *
 * Values:
 * - 0 - Rx FIFO auto sync off
 * - 1 - RxFIFO auto sync on
 */
/*@{*/
#define BP_SPDIF_SCR_RxAutoSync (18U)      /*!< Bit position for SPDIF_SCR_RxAutoSync. */
#define BM_SPDIF_SCR_RxAutoSync (0x00040000U) /*!< Bit mask for SPDIF_SCR_RxAutoSync. */
#define BS_SPDIF_SCR_RxAutoSync (1U)       /*!< Bit field size in bits for SPDIF_SCR_RxAutoSync. */

/*! @brief Read current value of the SPDIF_SCR_RxAutoSync field. */
#define BR_SPDIF_SCR_RxAutoSync(x) (HW_SPDIF_SCR(x).B.RxAutoSync)

/*! @brief Format value for bitfield SPDIF_SCR_RxAutoSync. */
#define BF_SPDIF_SCR_RxAutoSync(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_RxAutoSync) & BM_SPDIF_SCR_RxAutoSync)

/*! @brief Set the RxAutoSync field to a new value. */
#define BW_SPDIF_SCR_RxAutoSync(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_RxAutoSync) | BF_SPDIF_SCR_RxAutoSync(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field RxFIFOFull_Sel[20:19] (RW)
 *
 * Values:
 * - 00 - Full interrupt if at least 1 sample in Rx left and right FIFOs
 * - 01 - Full interrupt if at least 4 sample in Rx left and right FIFOs
 * - 10 - Full interrupt if at least 8 sample in Rx left and right FIFOs
 * - 11 - Full interrupt if at least 16 sample in Rx left and right FIFO
 */
/*@{*/
#define BP_SPDIF_SCR_RxFIFOFull_Sel (19U)  /*!< Bit position for SPDIF_SCR_RxFIFOFull_Sel. */
#define BM_SPDIF_SCR_RxFIFOFull_Sel (0x00180000U) /*!< Bit mask for SPDIF_SCR_RxFIFOFull_Sel. */
#define BS_SPDIF_SCR_RxFIFOFull_Sel (2U)   /*!< Bit field size in bits for SPDIF_SCR_RxFIFOFull_Sel. */

/*! @brief Read current value of the SPDIF_SCR_RxFIFOFull_Sel field. */
#define BR_SPDIF_SCR_RxFIFOFull_Sel(x) (HW_SPDIF_SCR(x).B.RxFIFOFull_Sel)

/*! @brief Format value for bitfield SPDIF_SCR_RxFIFOFull_Sel. */
#define BF_SPDIF_SCR_RxFIFOFull_Sel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_RxFIFOFull_Sel) & BM_SPDIF_SCR_RxFIFOFull_Sel)

/*! @brief Set the RxFIFOFull_Sel field to a new value. */
#define BW_SPDIF_SCR_RxFIFOFull_Sel(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_RxFIFOFull_Sel) | BF_SPDIF_SCR_RxFIFOFull_Sel(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field RxFIFO_Rst[21] (RW)
 *
 * Values:
 * - 0 - Normal operation
 * - 1 - Reset register to 1 sample remaining
 */
/*@{*/
#define BP_SPDIF_SCR_RxFIFO_Rst (21U)      /*!< Bit position for SPDIF_SCR_RxFIFO_Rst. */
#define BM_SPDIF_SCR_RxFIFO_Rst (0x00200000U) /*!< Bit mask for SPDIF_SCR_RxFIFO_Rst. */
#define BS_SPDIF_SCR_RxFIFO_Rst (1U)       /*!< Bit field size in bits for SPDIF_SCR_RxFIFO_Rst. */

/*! @brief Read current value of the SPDIF_SCR_RxFIFO_Rst field. */
#define BR_SPDIF_SCR_RxFIFO_Rst(x) (HW_SPDIF_SCR(x).B.RxFIFO_Rst)

/*! @brief Format value for bitfield SPDIF_SCR_RxFIFO_Rst. */
#define BF_SPDIF_SCR_RxFIFO_Rst(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_RxFIFO_Rst) & BM_SPDIF_SCR_RxFIFO_Rst)

/*! @brief Set the RxFIFO_Rst field to a new value. */
#define BW_SPDIF_SCR_RxFIFO_Rst(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_RxFIFO_Rst) | BF_SPDIF_SCR_RxFIFO_Rst(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field RxFIFO_Off_On[22] (RW)
 *
 * Values:
 * - 0 - SPDIF Rx FIFO is on
 * - 1 - SPDIF Rx FIFO is off. Does not accept data from interface
 */
/*@{*/
#define BP_SPDIF_SCR_RxFIFO_Off_On (22U)   /*!< Bit position for SPDIF_SCR_RxFIFO_Off_On. */
#define BM_SPDIF_SCR_RxFIFO_Off_On (0x00400000U) /*!< Bit mask for SPDIF_SCR_RxFIFO_Off_On. */
#define BS_SPDIF_SCR_RxFIFO_Off_On (1U)    /*!< Bit field size in bits for SPDIF_SCR_RxFIFO_Off_On. */

/*! @brief Read current value of the SPDIF_SCR_RxFIFO_Off_On field. */
#define BR_SPDIF_SCR_RxFIFO_Off_On(x) (HW_SPDIF_SCR(x).B.RxFIFO_Off_On)

/*! @brief Format value for bitfield SPDIF_SCR_RxFIFO_Off_On. */
#define BF_SPDIF_SCR_RxFIFO_Off_On(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_RxFIFO_Off_On) & BM_SPDIF_SCR_RxFIFO_Off_On)

/*! @brief Set the RxFIFO_Off_On field to a new value. */
#define BW_SPDIF_SCR_RxFIFO_Off_On(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_RxFIFO_Off_On) | BF_SPDIF_SCR_RxFIFO_Off_On(v)))
/*@}*/

/*!
 * @name Register SPDIF_SCR, field RxFIFO_Ctrl[23] (RW)
 *
 * Values:
 * - 0 - Normal operation
 * - 1 - Always read zero from Rx data register
 */
/*@{*/
#define BP_SPDIF_SCR_RxFIFO_Ctrl (23U)     /*!< Bit position for SPDIF_SCR_RxFIFO_Ctrl. */
#define BM_SPDIF_SCR_RxFIFO_Ctrl (0x00800000U) /*!< Bit mask for SPDIF_SCR_RxFIFO_Ctrl. */
#define BS_SPDIF_SCR_RxFIFO_Ctrl (1U)      /*!< Bit field size in bits for SPDIF_SCR_RxFIFO_Ctrl. */

/*! @brief Read current value of the SPDIF_SCR_RxFIFO_Ctrl field. */
#define BR_SPDIF_SCR_RxFIFO_Ctrl(x) (HW_SPDIF_SCR(x).B.RxFIFO_Ctrl)

/*! @brief Format value for bitfield SPDIF_SCR_RxFIFO_Ctrl. */
#define BF_SPDIF_SCR_RxFIFO_Ctrl(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SCR_RxFIFO_Ctrl) & BM_SPDIF_SCR_RxFIFO_Ctrl)

/*! @brief Set the RxFIFO_Ctrl field to a new value. */
#define BW_SPDIF_SCR_RxFIFO_Ctrl(x, v) (HW_SPDIF_SCR_WR(x, (HW_SPDIF_SCR_RD(x) & ~BM_SPDIF_SCR_RxFIFO_Ctrl) | BF_SPDIF_SCR_RxFIFO_Ctrl(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRCD - CDText Control Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRCD - CDText Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_spdif_srcd
{
    uint32_t U;
    struct _hw_spdif_srcd_bitfields
    {
        uint32_t RESERVED0 : 1;        /*!< [0]  */
        uint32_t USyncMode : 1;        /*!< [1]  */
        uint32_t RESERVED1 : 30;       /*!< [31:2] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srcd_t;

/*!
 * @name Constants and macros for entire SPDIF_SRCD register
 */
/*@{*/
#define HW_SPDIF_SRCD_ADDR(x)    ((uintptr_t)(x) + 0x4U)

#define HW_SPDIF_SRCD(x)         (*(__IO hw_spdif_srcd_t *) HW_SPDIF_SRCD_ADDR(x))
#define HW_SPDIF_SRCD_RD(x)      (HW_SPDIF_SRCD(x).U)
#define HW_SPDIF_SRCD_WR(x, v)   (HW_SPDIF_SRCD(x).U = (v))
#define HW_SPDIF_SRCD_SET(x, v)  (HW_SPDIF_SRCD_WR(x, HW_SPDIF_SRCD_RD(x) |  (v)))
#define HW_SPDIF_SRCD_CLR(x, v)  (HW_SPDIF_SRCD_WR(x, HW_SPDIF_SRCD_RD(x) & ~(v)))
#define HW_SPDIF_SRCD_TOG(x, v)  (HW_SPDIF_SRCD_WR(x, HW_SPDIF_SRCD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRCD bitfields
 */

/*!
 * @name Register SPDIF_SRCD, field USyncMode[1] (RW)
 *
 * Values:
 * - 0 - Non-CD data
 * - 1 - CD user channel subcode
 */
/*@{*/
#define BP_SPDIF_SRCD_USyncMode (1U)       /*!< Bit position for SPDIF_SRCD_USyncMode. */
#define BM_SPDIF_SRCD_USyncMode (0x00000002U) /*!< Bit mask for SPDIF_SRCD_USyncMode. */
#define BS_SPDIF_SRCD_USyncMode (1U)       /*!< Bit field size in bits for SPDIF_SRCD_USyncMode. */

/*! @brief Read current value of the SPDIF_SRCD_USyncMode field. */
#define BR_SPDIF_SRCD_USyncMode(x) (HW_SPDIF_SRCD(x).B.USyncMode)

/*! @brief Format value for bitfield SPDIF_SRCD_USyncMode. */
#define BF_SPDIF_SRCD_USyncMode(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SRCD_USyncMode) & BM_SPDIF_SRCD_USyncMode)

/*! @brief Set the USyncMode field to a new value. */
#define BW_SPDIF_SRCD_USyncMode(x, v) (HW_SPDIF_SRCD_WR(x, (HW_SPDIF_SRCD_RD(x) & ~BM_SPDIF_SRCD_USyncMode) | BF_SPDIF_SRCD_USyncMode(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRPC - PhaseConfig Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRPC - PhaseConfig Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_spdif_srpc
{
    uint32_t U;
    struct _hw_spdif_srpc_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t GainSel : 3;          /*!< [5:3]  */
        uint32_t LOCK : 1;             /*!< [6]  */
        uint32_t ClkSrc_Sel : 4;       /*!< [10:7]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srpc_t;

/*!
 * @name Constants and macros for entire SPDIF_SRPC register
 */
/*@{*/
#define HW_SPDIF_SRPC_ADDR(x)    ((uintptr_t)(x) + 0x8U)

#define HW_SPDIF_SRPC(x)         (*(__IO hw_spdif_srpc_t *) HW_SPDIF_SRPC_ADDR(x))
#define HW_SPDIF_SRPC_RD(x)      (HW_SPDIF_SRPC(x).U)
#define HW_SPDIF_SRPC_WR(x, v)   (HW_SPDIF_SRPC(x).U = (v))
#define HW_SPDIF_SRPC_SET(x, v)  (HW_SPDIF_SRPC_WR(x, HW_SPDIF_SRPC_RD(x) |  (v)))
#define HW_SPDIF_SRPC_CLR(x, v)  (HW_SPDIF_SRPC_WR(x, HW_SPDIF_SRPC_RD(x) & ~(v)))
#define HW_SPDIF_SRPC_TOG(x, v)  (HW_SPDIF_SRPC_WR(x, HW_SPDIF_SRPC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRPC bitfields
 */

/*!
 * @name Register SPDIF_SRPC, field GainSel[5:3] (RW)
 *
 * Gain selection:
 *
 * Values:
 * - 000 - 24*(2**10)
 * - 001 - 16*(2**10)
 * - 010 - 12*(2**10)
 * - 011 - 8*(2**10)
 * - 100 - 6*(2**10)
 * - 101 - 4*(2**10)
 * - 110 - 3*(2**10)
 */
/*@{*/
#define BP_SPDIF_SRPC_GainSel (3U)         /*!< Bit position for SPDIF_SRPC_GainSel. */
#define BM_SPDIF_SRPC_GainSel (0x00000038U) /*!< Bit mask for SPDIF_SRPC_GainSel. */
#define BS_SPDIF_SRPC_GainSel (3U)         /*!< Bit field size in bits for SPDIF_SRPC_GainSel. */

/*! @brief Read current value of the SPDIF_SRPC_GainSel field. */
#define BR_SPDIF_SRPC_GainSel(x) (HW_SPDIF_SRPC(x).B.GainSel)

/*! @brief Format value for bitfield SPDIF_SRPC_GainSel. */
#define BF_SPDIF_SRPC_GainSel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SRPC_GainSel) & BM_SPDIF_SRPC_GainSel)

/*! @brief Set the GainSel field to a new value. */
#define BW_SPDIF_SRPC_GainSel(x, v) (HW_SPDIF_SRPC_WR(x, (HW_SPDIF_SRPC_RD(x) & ~BM_SPDIF_SRPC_GainSel) | BF_SPDIF_SRPC_GainSel(v)))
/*@}*/

/*!
 * @name Register SPDIF_SRPC, field LOCK[6] (RO)
 *
 * LOCK bit to show that the internal DPLL is locked, read only
 */
/*@{*/
#define BP_SPDIF_SRPC_LOCK   (6U)          /*!< Bit position for SPDIF_SRPC_LOCK. */
#define BM_SPDIF_SRPC_LOCK   (0x00000040U) /*!< Bit mask for SPDIF_SRPC_LOCK. */
#define BS_SPDIF_SRPC_LOCK   (1U)          /*!< Bit field size in bits for SPDIF_SRPC_LOCK. */

/*! @brief Read current value of the SPDIF_SRPC_LOCK field. */
#define BR_SPDIF_SRPC_LOCK(x) (HW_SPDIF_SRPC(x).B.LOCK)
/*@}*/

/*!
 * @name Register SPDIF_SRPC, field ClkSrc_Sel[10:7] (RW)
 *
 * Clock source selection, all other settings not shown are reserved:
 *
 * Values:
 * - 0000 - if (DPLL Locked) SPDIF_RxClk else REF_CLK_32K (XTALOSC)
 * - 0001 - if (DPLL Locked) SPDIF_RxClk else tx_clk (SPDIF0_CLK_ROOT)
 * - 0010 - if (DPLL Locked) SPDIF_RxClk else ASRC_EXT_CLK
 * - 0011 - if (DPLL Locked) SPDIF_RxClk else SPDIF_EXT_CLK
 * - 0100 - if (DPLL Locked) SPDIF_Rxclk else ESAI_HCKT
 * - 0101 - REF_CLK_32K (XTALOSC)
 * - 0110 - tx_clk (SPDIF0_CLK_ROOT)
 * - 0111 - ASRC_CLK
 * - 1000 - SPDIF_EXT_CLK
 * - 1001 - ESAI_HCKT
 * - 1010 - if (DPLL Locked) SPDIF_RxClk else MLB Clock
 * - 1011 - if (DPLL Locked) SPDIF_RxClk else MLB PHY Clock
 * - 1100 - MLB Clock
 * - 1101 - MLB PHY Clock
 */
/*@{*/
#define BP_SPDIF_SRPC_ClkSrc_Sel (7U)      /*!< Bit position for SPDIF_SRPC_ClkSrc_Sel. */
#define BM_SPDIF_SRPC_ClkSrc_Sel (0x00000780U) /*!< Bit mask for SPDIF_SRPC_ClkSrc_Sel. */
#define BS_SPDIF_SRPC_ClkSrc_Sel (4U)      /*!< Bit field size in bits for SPDIF_SRPC_ClkSrc_Sel. */

/*! @brief Read current value of the SPDIF_SRPC_ClkSrc_Sel field. */
#define BR_SPDIF_SRPC_ClkSrc_Sel(x) (HW_SPDIF_SRPC(x).B.ClkSrc_Sel)

/*! @brief Format value for bitfield SPDIF_SRPC_ClkSrc_Sel. */
#define BF_SPDIF_SRPC_ClkSrc_Sel(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SRPC_ClkSrc_Sel) & BM_SPDIF_SRPC_ClkSrc_Sel)

/*! @brief Set the ClkSrc_Sel field to a new value. */
#define BW_SPDIF_SRPC_ClkSrc_Sel(x, v) (HW_SPDIF_SRPC_WR(x, (HW_SPDIF_SRPC_RD(x) & ~BM_SPDIF_SRPC_ClkSrc_Sel) | BF_SPDIF_SRPC_ClkSrc_Sel(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SIE - InterruptEn Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SIE - InterruptEn Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The InterruptEn register (SPDIF_SIE) provides control over the enabling of
 * interrupts.
 */
typedef union _hw_spdif_sie
{
    uint32_t U;
    struct _hw_spdif_sie_bitfields
    {
        uint32_t RxFIFOFul : 1;        /*!< [0]  */
        uint32_t TxEm : 1;             /*!< [1]  */
        uint32_t LockLoss : 1;         /*!< [2]  */
        uint32_t RxFIFOResyn : 1;      /*!< [3]  */
        uint32_t RxFIFOUnOv : 1;       /*!< [4]  */
        uint32_t UQErr : 1;            /*!< [5]  */
        uint32_t UQSync : 1;           /*!< [6]  */
        uint32_t QRxOv : 1;            /*!< [7]  */
        uint32_t QRxFul : 1;           /*!< [8]  */
        uint32_t URxOv : 1;            /*!< [9]  */
        uint32_t URxFul : 1;           /*!< [10]  */
        uint32_t RESERVED0 : 3;        /*!< [13:11]  */
        uint32_t BitErr : 1;           /*!< [14]  */
        uint32_t SymErr : 1;           /*!< [15]  */
        uint32_t ValNoGood : 1;        /*!< [16]  */
        uint32_t CNew : 1;             /*!< [17]  */
        uint32_t TxResyn : 1;          /*!< [18]  */
        uint32_t TxUnOv : 1;           /*!< [19]  */
        uint32_t Lock : 1;             /*!< [20]  */
        uint32_t RESERVED1 : 11;       /*!< [31:21] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_sie_t;

/*!
 * @name Constants and macros for entire SPDIF_SIE register
 */
/*@{*/
#define HW_SPDIF_SIE_ADDR(x)     ((uintptr_t)(x) + 0xCU)

#define HW_SPDIF_SIE(x)          (*(__IO hw_spdif_sie_t *) HW_SPDIF_SIE_ADDR(x))
#define HW_SPDIF_SIE_RD(x)       (HW_SPDIF_SIE(x).U)
#define HW_SPDIF_SIE_WR(x, v)    (HW_SPDIF_SIE(x).U = (v))
#define HW_SPDIF_SIE_SET(x, v)   (HW_SPDIF_SIE_WR(x, HW_SPDIF_SIE_RD(x) |  (v)))
#define HW_SPDIF_SIE_CLR(x, v)   (HW_SPDIF_SIE_WR(x, HW_SPDIF_SIE_RD(x) & ~(v)))
#define HW_SPDIF_SIE_TOG(x, v)   (HW_SPDIF_SIE_WR(x, HW_SPDIF_SIE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_SIE bitfields
 */

/*!
 * @name Register SPDIF_SIE, field RxFIFOFul[0] (RW)
 *
 * SPDIF Rx FIFO full, can't be cleared with reg. IntClear. To clear it, read
 * from Rx FIFO.
 */
/*@{*/
#define BP_SPDIF_SIE_RxFIFOFul (0U)        /*!< Bit position for SPDIF_SIE_RxFIFOFul. */
#define BM_SPDIF_SIE_RxFIFOFul (0x00000001U) /*!< Bit mask for SPDIF_SIE_RxFIFOFul. */
#define BS_SPDIF_SIE_RxFIFOFul (1U)        /*!< Bit field size in bits for SPDIF_SIE_RxFIFOFul. */

/*! @brief Read current value of the SPDIF_SIE_RxFIFOFul field. */
#define BR_SPDIF_SIE_RxFIFOFul(x) (HW_SPDIF_SIE(x).B.RxFIFOFul)

/*! @brief Format value for bitfield SPDIF_SIE_RxFIFOFul. */
#define BF_SPDIF_SIE_RxFIFOFul(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_RxFIFOFul) & BM_SPDIF_SIE_RxFIFOFul)

/*! @brief Set the RxFIFOFul field to a new value. */
#define BW_SPDIF_SIE_RxFIFOFul(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_RxFIFOFul) | BF_SPDIF_SIE_RxFIFOFul(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field TxEm[1] (RW)
 *
 * SPDIF Tx FIFO empty, can't be cleared with reg. IntClear. To clear it, write
 * toTx FIFO.
 */
/*@{*/
#define BP_SPDIF_SIE_TxEm    (1U)          /*!< Bit position for SPDIF_SIE_TxEm. */
#define BM_SPDIF_SIE_TxEm    (0x00000002U) /*!< Bit mask for SPDIF_SIE_TxEm. */
#define BS_SPDIF_SIE_TxEm    (1U)          /*!< Bit field size in bits for SPDIF_SIE_TxEm. */

/*! @brief Read current value of the SPDIF_SIE_TxEm field. */
#define BR_SPDIF_SIE_TxEm(x) (HW_SPDIF_SIE(x).B.TxEm)

/*! @brief Format value for bitfield SPDIF_SIE_TxEm. */
#define BF_SPDIF_SIE_TxEm(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_TxEm) & BM_SPDIF_SIE_TxEm)

/*! @brief Set the TxEm field to a new value. */
#define BW_SPDIF_SIE_TxEm(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_TxEm) | BF_SPDIF_SIE_TxEm(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field LockLoss[2] (RW)
 *
 * SPDIF receiver loss of lock
 */
/*@{*/
#define BP_SPDIF_SIE_LockLoss (2U)         /*!< Bit position for SPDIF_SIE_LockLoss. */
#define BM_SPDIF_SIE_LockLoss (0x00000004U) /*!< Bit mask for SPDIF_SIE_LockLoss. */
#define BS_SPDIF_SIE_LockLoss (1U)         /*!< Bit field size in bits for SPDIF_SIE_LockLoss. */

/*! @brief Read current value of the SPDIF_SIE_LockLoss field. */
#define BR_SPDIF_SIE_LockLoss(x) (HW_SPDIF_SIE(x).B.LockLoss)

/*! @brief Format value for bitfield SPDIF_SIE_LockLoss. */
#define BF_SPDIF_SIE_LockLoss(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_LockLoss) & BM_SPDIF_SIE_LockLoss)

/*! @brief Set the LockLoss field to a new value. */
#define BW_SPDIF_SIE_LockLoss(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_LockLoss) | BF_SPDIF_SIE_LockLoss(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field RxFIFOResyn[3] (RW)
 *
 * Rx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIE_RxFIFOResyn (3U)      /*!< Bit position for SPDIF_SIE_RxFIFOResyn. */
#define BM_SPDIF_SIE_RxFIFOResyn (0x00000008U) /*!< Bit mask for SPDIF_SIE_RxFIFOResyn. */
#define BS_SPDIF_SIE_RxFIFOResyn (1U)      /*!< Bit field size in bits for SPDIF_SIE_RxFIFOResyn. */

/*! @brief Read current value of the SPDIF_SIE_RxFIFOResyn field. */
#define BR_SPDIF_SIE_RxFIFOResyn(x) (HW_SPDIF_SIE(x).B.RxFIFOResyn)

/*! @brief Format value for bitfield SPDIF_SIE_RxFIFOResyn. */
#define BF_SPDIF_SIE_RxFIFOResyn(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_RxFIFOResyn) & BM_SPDIF_SIE_RxFIFOResyn)

/*! @brief Set the RxFIFOResyn field to a new value. */
#define BW_SPDIF_SIE_RxFIFOResyn(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_RxFIFOResyn) | BF_SPDIF_SIE_RxFIFOResyn(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field RxFIFOUnOv[4] (RW)
 *
 * Rx FIFO underrun/overrun
 */
/*@{*/
#define BP_SPDIF_SIE_RxFIFOUnOv (4U)       /*!< Bit position for SPDIF_SIE_RxFIFOUnOv. */
#define BM_SPDIF_SIE_RxFIFOUnOv (0x00000010U) /*!< Bit mask for SPDIF_SIE_RxFIFOUnOv. */
#define BS_SPDIF_SIE_RxFIFOUnOv (1U)       /*!< Bit field size in bits for SPDIF_SIE_RxFIFOUnOv. */

/*! @brief Read current value of the SPDIF_SIE_RxFIFOUnOv field. */
#define BR_SPDIF_SIE_RxFIFOUnOv(x) (HW_SPDIF_SIE(x).B.RxFIFOUnOv)

/*! @brief Format value for bitfield SPDIF_SIE_RxFIFOUnOv. */
#define BF_SPDIF_SIE_RxFIFOUnOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_RxFIFOUnOv) & BM_SPDIF_SIE_RxFIFOUnOv)

/*! @brief Set the RxFIFOUnOv field to a new value. */
#define BW_SPDIF_SIE_RxFIFOUnOv(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_RxFIFOUnOv) | BF_SPDIF_SIE_RxFIFOUnOv(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field UQErr[5] (RW)
 *
 * U/Q Channel framing error
 */
/*@{*/
#define BP_SPDIF_SIE_UQErr   (5U)          /*!< Bit position for SPDIF_SIE_UQErr. */
#define BM_SPDIF_SIE_UQErr   (0x00000020U) /*!< Bit mask for SPDIF_SIE_UQErr. */
#define BS_SPDIF_SIE_UQErr   (1U)          /*!< Bit field size in bits for SPDIF_SIE_UQErr. */

/*! @brief Read current value of the SPDIF_SIE_UQErr field. */
#define BR_SPDIF_SIE_UQErr(x) (HW_SPDIF_SIE(x).B.UQErr)

/*! @brief Format value for bitfield SPDIF_SIE_UQErr. */
#define BF_SPDIF_SIE_UQErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_UQErr) & BM_SPDIF_SIE_UQErr)

/*! @brief Set the UQErr field to a new value. */
#define BW_SPDIF_SIE_UQErr(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_UQErr) | BF_SPDIF_SIE_UQErr(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field UQSync[6] (RW)
 *
 * U/Q Channel sync found
 */
/*@{*/
#define BP_SPDIF_SIE_UQSync  (6U)          /*!< Bit position for SPDIF_SIE_UQSync. */
#define BM_SPDIF_SIE_UQSync  (0x00000040U) /*!< Bit mask for SPDIF_SIE_UQSync. */
#define BS_SPDIF_SIE_UQSync  (1U)          /*!< Bit field size in bits for SPDIF_SIE_UQSync. */

/*! @brief Read current value of the SPDIF_SIE_UQSync field. */
#define BR_SPDIF_SIE_UQSync(x) (HW_SPDIF_SIE(x).B.UQSync)

/*! @brief Format value for bitfield SPDIF_SIE_UQSync. */
#define BF_SPDIF_SIE_UQSync(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_UQSync) & BM_SPDIF_SIE_UQSync)

/*! @brief Set the UQSync field to a new value. */
#define BW_SPDIF_SIE_UQSync(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_UQSync) | BF_SPDIF_SIE_UQSync(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field QRxOv[7] (RW)
 *
 * Q Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIE_QRxOv   (7U)          /*!< Bit position for SPDIF_SIE_QRxOv. */
#define BM_SPDIF_SIE_QRxOv   (0x00000080U) /*!< Bit mask for SPDIF_SIE_QRxOv. */
#define BS_SPDIF_SIE_QRxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIE_QRxOv. */

/*! @brief Read current value of the SPDIF_SIE_QRxOv field. */
#define BR_SPDIF_SIE_QRxOv(x) (HW_SPDIF_SIE(x).B.QRxOv)

/*! @brief Format value for bitfield SPDIF_SIE_QRxOv. */
#define BF_SPDIF_SIE_QRxOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_QRxOv) & BM_SPDIF_SIE_QRxOv)

/*! @brief Set the QRxOv field to a new value. */
#define BW_SPDIF_SIE_QRxOv(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_QRxOv) | BF_SPDIF_SIE_QRxOv(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field QRxFul[8] (RW)
 *
 * Q Channel receive register full, can't be cleared with reg. IntClear. To
 * clear it, read from Q Rx reg.
 */
/*@{*/
#define BP_SPDIF_SIE_QRxFul  (8U)          /*!< Bit position for SPDIF_SIE_QRxFul. */
#define BM_SPDIF_SIE_QRxFul  (0x00000100U) /*!< Bit mask for SPDIF_SIE_QRxFul. */
#define BS_SPDIF_SIE_QRxFul  (1U)          /*!< Bit field size in bits for SPDIF_SIE_QRxFul. */

/*! @brief Read current value of the SPDIF_SIE_QRxFul field. */
#define BR_SPDIF_SIE_QRxFul(x) (HW_SPDIF_SIE(x).B.QRxFul)

/*! @brief Format value for bitfield SPDIF_SIE_QRxFul. */
#define BF_SPDIF_SIE_QRxFul(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_QRxFul) & BM_SPDIF_SIE_QRxFul)

/*! @brief Set the QRxFul field to a new value. */
#define BW_SPDIF_SIE_QRxFul(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_QRxFul) | BF_SPDIF_SIE_QRxFul(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field URxOv[9] (RW)
 *
 * U Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIE_URxOv   (9U)          /*!< Bit position for SPDIF_SIE_URxOv. */
#define BM_SPDIF_SIE_URxOv   (0x00000200U) /*!< Bit mask for SPDIF_SIE_URxOv. */
#define BS_SPDIF_SIE_URxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIE_URxOv. */

/*! @brief Read current value of the SPDIF_SIE_URxOv field. */
#define BR_SPDIF_SIE_URxOv(x) (HW_SPDIF_SIE(x).B.URxOv)

/*! @brief Format value for bitfield SPDIF_SIE_URxOv. */
#define BF_SPDIF_SIE_URxOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_URxOv) & BM_SPDIF_SIE_URxOv)

/*! @brief Set the URxOv field to a new value. */
#define BW_SPDIF_SIE_URxOv(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_URxOv) | BF_SPDIF_SIE_URxOv(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field URxFul[10] (RW)
 *
 * U Channel receive register full, can't be cleared with reg. IntClear. To
 * clear it, read from U Rx reg.
 */
/*@{*/
#define BP_SPDIF_SIE_URxFul  (10U)         /*!< Bit position for SPDIF_SIE_URxFul. */
#define BM_SPDIF_SIE_URxFul  (0x00000400U) /*!< Bit mask for SPDIF_SIE_URxFul. */
#define BS_SPDIF_SIE_URxFul  (1U)          /*!< Bit field size in bits for SPDIF_SIE_URxFul. */

/*! @brief Read current value of the SPDIF_SIE_URxFul field. */
#define BR_SPDIF_SIE_URxFul(x) (HW_SPDIF_SIE(x).B.URxFul)

/*! @brief Format value for bitfield SPDIF_SIE_URxFul. */
#define BF_SPDIF_SIE_URxFul(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_URxFul) & BM_SPDIF_SIE_URxFul)

/*! @brief Set the URxFul field to a new value. */
#define BW_SPDIF_SIE_URxFul(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_URxFul) | BF_SPDIF_SIE_URxFul(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field BitErr[14] (RW)
 *
 * SPDIF receiver found parity bit error
 */
/*@{*/
#define BP_SPDIF_SIE_BitErr  (14U)         /*!< Bit position for SPDIF_SIE_BitErr. */
#define BM_SPDIF_SIE_BitErr  (0x00004000U) /*!< Bit mask for SPDIF_SIE_BitErr. */
#define BS_SPDIF_SIE_BitErr  (1U)          /*!< Bit field size in bits for SPDIF_SIE_BitErr. */

/*! @brief Read current value of the SPDIF_SIE_BitErr field. */
#define BR_SPDIF_SIE_BitErr(x) (HW_SPDIF_SIE(x).B.BitErr)

/*! @brief Format value for bitfield SPDIF_SIE_BitErr. */
#define BF_SPDIF_SIE_BitErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_BitErr) & BM_SPDIF_SIE_BitErr)

/*! @brief Set the BitErr field to a new value. */
#define BW_SPDIF_SIE_BitErr(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_BitErr) | BF_SPDIF_SIE_BitErr(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field SymErr[15] (RW)
 *
 * SPDIF receiver found illegal symbol
 */
/*@{*/
#define BP_SPDIF_SIE_SymErr  (15U)         /*!< Bit position for SPDIF_SIE_SymErr. */
#define BM_SPDIF_SIE_SymErr  (0x00008000U) /*!< Bit mask for SPDIF_SIE_SymErr. */
#define BS_SPDIF_SIE_SymErr  (1U)          /*!< Bit field size in bits for SPDIF_SIE_SymErr. */

/*! @brief Read current value of the SPDIF_SIE_SymErr field. */
#define BR_SPDIF_SIE_SymErr(x) (HW_SPDIF_SIE(x).B.SymErr)

/*! @brief Format value for bitfield SPDIF_SIE_SymErr. */
#define BF_SPDIF_SIE_SymErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_SymErr) & BM_SPDIF_SIE_SymErr)

/*! @brief Set the SymErr field to a new value. */
#define BW_SPDIF_SIE_SymErr(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_SymErr) | BF_SPDIF_SIE_SymErr(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field ValNoGood[16] (RW)
 *
 * SPDIF validity flag no good
 */
/*@{*/
#define BP_SPDIF_SIE_ValNoGood (16U)       /*!< Bit position for SPDIF_SIE_ValNoGood. */
#define BM_SPDIF_SIE_ValNoGood (0x00010000U) /*!< Bit mask for SPDIF_SIE_ValNoGood. */
#define BS_SPDIF_SIE_ValNoGood (1U)        /*!< Bit field size in bits for SPDIF_SIE_ValNoGood. */

/*! @brief Read current value of the SPDIF_SIE_ValNoGood field. */
#define BR_SPDIF_SIE_ValNoGood(x) (HW_SPDIF_SIE(x).B.ValNoGood)

/*! @brief Format value for bitfield SPDIF_SIE_ValNoGood. */
#define BF_SPDIF_SIE_ValNoGood(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_ValNoGood) & BM_SPDIF_SIE_ValNoGood)

/*! @brief Set the ValNoGood field to a new value. */
#define BW_SPDIF_SIE_ValNoGood(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_ValNoGood) | BF_SPDIF_SIE_ValNoGood(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field CNew[17] (RW)
 *
 * SPDIF receive change in value of control channel
 */
/*@{*/
#define BP_SPDIF_SIE_CNew    (17U)         /*!< Bit position for SPDIF_SIE_CNew. */
#define BM_SPDIF_SIE_CNew    (0x00020000U) /*!< Bit mask for SPDIF_SIE_CNew. */
#define BS_SPDIF_SIE_CNew    (1U)          /*!< Bit field size in bits for SPDIF_SIE_CNew. */

/*! @brief Read current value of the SPDIF_SIE_CNew field. */
#define BR_SPDIF_SIE_CNew(x) (HW_SPDIF_SIE(x).B.CNew)

/*! @brief Format value for bitfield SPDIF_SIE_CNew. */
#define BF_SPDIF_SIE_CNew(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_CNew) & BM_SPDIF_SIE_CNew)

/*! @brief Set the CNew field to a new value. */
#define BW_SPDIF_SIE_CNew(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_CNew) | BF_SPDIF_SIE_CNew(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field TxResyn[18] (RW)
 *
 * SPDIF Tx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIE_TxResyn (18U)         /*!< Bit position for SPDIF_SIE_TxResyn. */
#define BM_SPDIF_SIE_TxResyn (0x00040000U) /*!< Bit mask for SPDIF_SIE_TxResyn. */
#define BS_SPDIF_SIE_TxResyn (1U)          /*!< Bit field size in bits for SPDIF_SIE_TxResyn. */

/*! @brief Read current value of the SPDIF_SIE_TxResyn field. */
#define BR_SPDIF_SIE_TxResyn(x) (HW_SPDIF_SIE(x).B.TxResyn)

/*! @brief Format value for bitfield SPDIF_SIE_TxResyn. */
#define BF_SPDIF_SIE_TxResyn(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_TxResyn) & BM_SPDIF_SIE_TxResyn)

/*! @brief Set the TxResyn field to a new value. */
#define BW_SPDIF_SIE_TxResyn(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_TxResyn) | BF_SPDIF_SIE_TxResyn(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field TxUnOv[19] (RW)
 *
 * SPDIF Tx FIFO under/overrun
 */
/*@{*/
#define BP_SPDIF_SIE_TxUnOv  (19U)         /*!< Bit position for SPDIF_SIE_TxUnOv. */
#define BM_SPDIF_SIE_TxUnOv  (0x00080000U) /*!< Bit mask for SPDIF_SIE_TxUnOv. */
#define BS_SPDIF_SIE_TxUnOv  (1U)          /*!< Bit field size in bits for SPDIF_SIE_TxUnOv. */

/*! @brief Read current value of the SPDIF_SIE_TxUnOv field. */
#define BR_SPDIF_SIE_TxUnOv(x) (HW_SPDIF_SIE(x).B.TxUnOv)

/*! @brief Format value for bitfield SPDIF_SIE_TxUnOv. */
#define BF_SPDIF_SIE_TxUnOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_TxUnOv) & BM_SPDIF_SIE_TxUnOv)

/*! @brief Set the TxUnOv field to a new value. */
#define BW_SPDIF_SIE_TxUnOv(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_TxUnOv) | BF_SPDIF_SIE_TxUnOv(v)))
/*@}*/

/*!
 * @name Register SPDIF_SIE, field Lock[20] (RW)
 *
 * SPDIF receiver's DPLL is locked
 */
/*@{*/
#define BP_SPDIF_SIE_Lock    (20U)         /*!< Bit position for SPDIF_SIE_Lock. */
#define BM_SPDIF_SIE_Lock    (0x00100000U) /*!< Bit mask for SPDIF_SIE_Lock. */
#define BS_SPDIF_SIE_Lock    (1U)          /*!< Bit field size in bits for SPDIF_SIE_Lock. */

/*! @brief Read current value of the SPDIF_SIE_Lock field. */
#define BR_SPDIF_SIE_Lock(x) (HW_SPDIF_SIE(x).B.Lock)

/*! @brief Format value for bitfield SPDIF_SIE_Lock. */
#define BF_SPDIF_SIE_Lock(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIE_Lock) & BM_SPDIF_SIE_Lock)

/*! @brief Set the Lock field to a new value. */
#define BW_SPDIF_SIE_Lock(x, v) (HW_SPDIF_SIE_WR(x, (HW_SPDIF_SIE_RD(x) & ~BM_SPDIF_SIE_Lock) | BF_SPDIF_SIE_Lock(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SIC - InterruptClear Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SIC - InterruptClear Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The InterruptClear (SPDIF_SIC) register is a write only register and is used
 * to clear interrupts.
 */
typedef union _hw_spdif_sic
{
    uint32_t U;
    struct _hw_spdif_sic_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t LockLoss : 1;         /*!< [2]  */
        uint32_t RxFIFOResyn : 1;      /*!< [3]  */
        uint32_t RxFIFOUnOv : 1;       /*!< [4]  */
        uint32_t UQErr : 1;            /*!< [5]  */
        uint32_t UQSync : 1;           /*!< [6]  */
        uint32_t QRxOv : 1;            /*!< [7]  */
        uint32_t RESERVED1 : 1;        /*!< [8]  */
        uint32_t URxOv : 1;            /*!< [9]  */
        uint32_t RESERVED2 : 4;        /*!< [13:10]  */
        uint32_t BitErr : 1;           /*!< [14]  */
        uint32_t SymErr : 1;           /*!< [15]  */
        uint32_t ValNoGood : 1;        /*!< [16]  */
        uint32_t CNew : 1;             /*!< [17]  */
        uint32_t TxResyn : 1;          /*!< [18]  */
        uint32_t TxUnOv : 1;           /*!< [19]  */
        uint32_t Lock : 1;             /*!< [20]  */
        uint32_t RESERVED3 : 11;       /*!< [31:21] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_sic_t;

/*!
 * @name Constants and macros for entire SPDIF_SIC register
 */
/*@{*/
#define HW_SPDIF_SIC_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_SPDIF_SIC(x)          (*(__IO hw_spdif_sic_t *) HW_SPDIF_SIC_ADDR(x))
#define HW_SPDIF_SIC_RD(x)       (HW_SPDIF_SIC(x).U)
#define HW_SPDIF_SIC_WR(x, v)    (HW_SPDIF_SIC(x).U = (v))
#define HW_SPDIF_SIC_SET(x, v)   (HW_SPDIF_SIC_WR(x, HW_SPDIF_SIC_RD(x) |  (v)))
#define HW_SPDIF_SIC_CLR(x, v)   (HW_SPDIF_SIC_WR(x, HW_SPDIF_SIC_RD(x) & ~(v)))
#define HW_SPDIF_SIC_TOG(x, v)   (HW_SPDIF_SIC_WR(x, HW_SPDIF_SIC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_SIC bitfields
 */

/*!
 * @name Register SPDIF_SIC, field LockLoss[2] (WO)
 *
 * SPDIF receiver loss of lock
 */
/*@{*/
#define BP_SPDIF_SIC_LockLoss (2U)         /*!< Bit position for SPDIF_SIC_LockLoss. */
#define BM_SPDIF_SIC_LockLoss (0x00000004U) /*!< Bit mask for SPDIF_SIC_LockLoss. */
#define BS_SPDIF_SIC_LockLoss (1U)         /*!< Bit field size in bits for SPDIF_SIC_LockLoss. */

/*! @brief Format value for bitfield SPDIF_SIC_LockLoss. */
#define BF_SPDIF_SIC_LockLoss(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_LockLoss) & BM_SPDIF_SIC_LockLoss)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field RxFIFOResyn[3] (WO)
 *
 * Rx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIC_RxFIFOResyn (3U)      /*!< Bit position for SPDIF_SIC_RxFIFOResyn. */
#define BM_SPDIF_SIC_RxFIFOResyn (0x00000008U) /*!< Bit mask for SPDIF_SIC_RxFIFOResyn. */
#define BS_SPDIF_SIC_RxFIFOResyn (1U)      /*!< Bit field size in bits for SPDIF_SIC_RxFIFOResyn. */

/*! @brief Format value for bitfield SPDIF_SIC_RxFIFOResyn. */
#define BF_SPDIF_SIC_RxFIFOResyn(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_RxFIFOResyn) & BM_SPDIF_SIC_RxFIFOResyn)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field RxFIFOUnOv[4] (WO)
 *
 * Rx FIFO underrun/overrun
 */
/*@{*/
#define BP_SPDIF_SIC_RxFIFOUnOv (4U)       /*!< Bit position for SPDIF_SIC_RxFIFOUnOv. */
#define BM_SPDIF_SIC_RxFIFOUnOv (0x00000010U) /*!< Bit mask for SPDIF_SIC_RxFIFOUnOv. */
#define BS_SPDIF_SIC_RxFIFOUnOv (1U)       /*!< Bit field size in bits for SPDIF_SIC_RxFIFOUnOv. */

/*! @brief Format value for bitfield SPDIF_SIC_RxFIFOUnOv. */
#define BF_SPDIF_SIC_RxFIFOUnOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_RxFIFOUnOv) & BM_SPDIF_SIC_RxFIFOUnOv)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field UQErr[5] (WO)
 *
 * U/Q Channel framing error
 */
/*@{*/
#define BP_SPDIF_SIC_UQErr   (5U)          /*!< Bit position for SPDIF_SIC_UQErr. */
#define BM_SPDIF_SIC_UQErr   (0x00000020U) /*!< Bit mask for SPDIF_SIC_UQErr. */
#define BS_SPDIF_SIC_UQErr   (1U)          /*!< Bit field size in bits for SPDIF_SIC_UQErr. */

/*! @brief Format value for bitfield SPDIF_SIC_UQErr. */
#define BF_SPDIF_SIC_UQErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_UQErr) & BM_SPDIF_SIC_UQErr)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field UQSync[6] (WO)
 *
 * U/Q Channel sync found
 */
/*@{*/
#define BP_SPDIF_SIC_UQSync  (6U)          /*!< Bit position for SPDIF_SIC_UQSync. */
#define BM_SPDIF_SIC_UQSync  (0x00000040U) /*!< Bit mask for SPDIF_SIC_UQSync. */
#define BS_SPDIF_SIC_UQSync  (1U)          /*!< Bit field size in bits for SPDIF_SIC_UQSync. */

/*! @brief Format value for bitfield SPDIF_SIC_UQSync. */
#define BF_SPDIF_SIC_UQSync(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_UQSync) & BM_SPDIF_SIC_UQSync)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field QRxOv[7] (WO)
 *
 * Q Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIC_QRxOv   (7U)          /*!< Bit position for SPDIF_SIC_QRxOv. */
#define BM_SPDIF_SIC_QRxOv   (0x00000080U) /*!< Bit mask for SPDIF_SIC_QRxOv. */
#define BS_SPDIF_SIC_QRxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIC_QRxOv. */

/*! @brief Format value for bitfield SPDIF_SIC_QRxOv. */
#define BF_SPDIF_SIC_QRxOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_QRxOv) & BM_SPDIF_SIC_QRxOv)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field URxOv[9] (WO)
 *
 * U Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIC_URxOv   (9U)          /*!< Bit position for SPDIF_SIC_URxOv. */
#define BM_SPDIF_SIC_URxOv   (0x00000200U) /*!< Bit mask for SPDIF_SIC_URxOv. */
#define BS_SPDIF_SIC_URxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIC_URxOv. */

/*! @brief Format value for bitfield SPDIF_SIC_URxOv. */
#define BF_SPDIF_SIC_URxOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_URxOv) & BM_SPDIF_SIC_URxOv)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field BitErr[14] (WO)
 *
 * SPDIF receiver found parity bit error
 */
/*@{*/
#define BP_SPDIF_SIC_BitErr  (14U)         /*!< Bit position for SPDIF_SIC_BitErr. */
#define BM_SPDIF_SIC_BitErr  (0x00004000U) /*!< Bit mask for SPDIF_SIC_BitErr. */
#define BS_SPDIF_SIC_BitErr  (1U)          /*!< Bit field size in bits for SPDIF_SIC_BitErr. */

/*! @brief Format value for bitfield SPDIF_SIC_BitErr. */
#define BF_SPDIF_SIC_BitErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_BitErr) & BM_SPDIF_SIC_BitErr)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field SymErr[15] (WO)
 *
 * SPDIF receiver found illegal symbol
 */
/*@{*/
#define BP_SPDIF_SIC_SymErr  (15U)         /*!< Bit position for SPDIF_SIC_SymErr. */
#define BM_SPDIF_SIC_SymErr  (0x00008000U) /*!< Bit mask for SPDIF_SIC_SymErr. */
#define BS_SPDIF_SIC_SymErr  (1U)          /*!< Bit field size in bits for SPDIF_SIC_SymErr. */

/*! @brief Format value for bitfield SPDIF_SIC_SymErr. */
#define BF_SPDIF_SIC_SymErr(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_SymErr) & BM_SPDIF_SIC_SymErr)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field ValNoGood[16] (WO)
 *
 * SPDIF validity flag no good
 */
/*@{*/
#define BP_SPDIF_SIC_ValNoGood (16U)       /*!< Bit position for SPDIF_SIC_ValNoGood. */
#define BM_SPDIF_SIC_ValNoGood (0x00010000U) /*!< Bit mask for SPDIF_SIC_ValNoGood. */
#define BS_SPDIF_SIC_ValNoGood (1U)        /*!< Bit field size in bits for SPDIF_SIC_ValNoGood. */

/*! @brief Format value for bitfield SPDIF_SIC_ValNoGood. */
#define BF_SPDIF_SIC_ValNoGood(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_ValNoGood) & BM_SPDIF_SIC_ValNoGood)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field CNew[17] (WO)
 *
 * SPDIF receive change in value of control channel
 */
/*@{*/
#define BP_SPDIF_SIC_CNew    (17U)         /*!< Bit position for SPDIF_SIC_CNew. */
#define BM_SPDIF_SIC_CNew    (0x00020000U) /*!< Bit mask for SPDIF_SIC_CNew. */
#define BS_SPDIF_SIC_CNew    (1U)          /*!< Bit field size in bits for SPDIF_SIC_CNew. */

/*! @brief Format value for bitfield SPDIF_SIC_CNew. */
#define BF_SPDIF_SIC_CNew(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_CNew) & BM_SPDIF_SIC_CNew)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field TxResyn[18] (WO)
 *
 * SPDIF Tx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIC_TxResyn (18U)         /*!< Bit position for SPDIF_SIC_TxResyn. */
#define BM_SPDIF_SIC_TxResyn (0x00040000U) /*!< Bit mask for SPDIF_SIC_TxResyn. */
#define BS_SPDIF_SIC_TxResyn (1U)          /*!< Bit field size in bits for SPDIF_SIC_TxResyn. */

/*! @brief Format value for bitfield SPDIF_SIC_TxResyn. */
#define BF_SPDIF_SIC_TxResyn(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_TxResyn) & BM_SPDIF_SIC_TxResyn)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field TxUnOv[19] (WO)
 *
 * SPDIF Tx FIFO under/overrun
 */
/*@{*/
#define BP_SPDIF_SIC_TxUnOv  (19U)         /*!< Bit position for SPDIF_SIC_TxUnOv. */
#define BM_SPDIF_SIC_TxUnOv  (0x00080000U) /*!< Bit mask for SPDIF_SIC_TxUnOv. */
#define BS_SPDIF_SIC_TxUnOv  (1U)          /*!< Bit field size in bits for SPDIF_SIC_TxUnOv. */

/*! @brief Format value for bitfield SPDIF_SIC_TxUnOv. */
#define BF_SPDIF_SIC_TxUnOv(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_TxUnOv) & BM_SPDIF_SIC_TxUnOv)
/*@}*/

/*!
 * @name Register SPDIF_SIC, field Lock[20] (WO)
 *
 * SPDIF receiver's DPLL is locked
 */
/*@{*/
#define BP_SPDIF_SIC_Lock    (20U)         /*!< Bit position for SPDIF_SIC_Lock. */
#define BM_SPDIF_SIC_Lock    (0x00100000U) /*!< Bit mask for SPDIF_SIC_Lock. */
#define BS_SPDIF_SIC_Lock    (1U)          /*!< Bit field size in bits for SPDIF_SIC_Lock. */

/*! @brief Format value for bitfield SPDIF_SIC_Lock. */
#define BF_SPDIF_SIC_Lock(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_SIC_Lock) & BM_SPDIF_SIC_Lock)
/*@}*/
/*******************************************************************************
 * HW_SPDIF_SIS - InterruptStat Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SIS - InterruptStat Register (RO)
 *
 * Reset value: 0x00000002U
 *
 * The InterruptStat (SPDIF_SIS) register is a read only register that provides
 * the status on interrupt operations.
 */
typedef union _hw_spdif_sis
{
    uint32_t U;
    struct _hw_spdif_sis_bitfields
    {
        uint32_t RxFIFOFul : 1;        /*!< [0]  */
        uint32_t TxEm : 1;             /*!< [1]  */
        uint32_t LockLoss : 1;         /*!< [2]  */
        uint32_t RxFIFOResyn : 1;      /*!< [3]  */
        uint32_t RxFIFOUnOv : 1;       /*!< [4]  */
        uint32_t UQErr : 1;            /*!< [5]  */
        uint32_t UQSync : 1;           /*!< [6]  */
        uint32_t QRxOv : 1;            /*!< [7]  */
        uint32_t QRxFul : 1;           /*!< [8]  */
        uint32_t URxOv : 1;            /*!< [9]  */
        uint32_t URxFul : 1;           /*!< [10]  */
        uint32_t RESERVED0 : 3;        /*!< [13:11]  */
        uint32_t BitErr : 1;           /*!< [14]  */
        uint32_t SymErr : 1;           /*!< [15]  */
        uint32_t ValNoGood : 1;        /*!< [16]  */
        uint32_t CNew : 1;             /*!< [17]  */
        uint32_t TxResyn : 1;          /*!< [18]  */
        uint32_t TxUnOv : 1;           /*!< [19]  */
        uint32_t Lock : 1;             /*!< [20]  */
        uint32_t RESERVED1 : 11;       /*!< [31:21] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_sis_t;

/*!
 * @name Constants and macros for entire SPDIF_SIS register
 */
/*@{*/
#define HW_SPDIF_SIS_ADDR(x)     ((uintptr_t)(x) + 0x10U)

#define HW_SPDIF_SIS(x)          (*(__I hw_spdif_sis_t *) HW_SPDIF_SIS_ADDR(x))
#define HW_SPDIF_SIS_RD(x)       (HW_SPDIF_SIS(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SIS bitfields
 */

/*!
 * @name Register SPDIF_SIS, field RxFIFOFul[0] (RO)
 *
 * SPDIF Rx FIFO full, can't be cleared with reg. IntClear. To clear it, read
 * from Rx FIFO.
 */
/*@{*/
#define BP_SPDIF_SIS_RxFIFOFul (0U)        /*!< Bit position for SPDIF_SIS_RxFIFOFul. */
#define BM_SPDIF_SIS_RxFIFOFul (0x00000001U) /*!< Bit mask for SPDIF_SIS_RxFIFOFul. */
#define BS_SPDIF_SIS_RxFIFOFul (1U)        /*!< Bit field size in bits for SPDIF_SIS_RxFIFOFul. */

/*! @brief Read current value of the SPDIF_SIS_RxFIFOFul field. */
#define BR_SPDIF_SIS_RxFIFOFul(x) (HW_SPDIF_SIS(x).B.RxFIFOFul)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field TxEm[1] (RO)
 *
 * SPDIF Tx FIFO empty, can't be cleared with reg. IntClear. To clear it, write
 * toTx FIFO.
 */
/*@{*/
#define BP_SPDIF_SIS_TxEm    (1U)          /*!< Bit position for SPDIF_SIS_TxEm. */
#define BM_SPDIF_SIS_TxEm    (0x00000002U) /*!< Bit mask for SPDIF_SIS_TxEm. */
#define BS_SPDIF_SIS_TxEm    (1U)          /*!< Bit field size in bits for SPDIF_SIS_TxEm. */

/*! @brief Read current value of the SPDIF_SIS_TxEm field. */
#define BR_SPDIF_SIS_TxEm(x) (HW_SPDIF_SIS(x).B.TxEm)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field LockLoss[2] (RO)
 *
 * SPDIF receiver loss of lock
 */
/*@{*/
#define BP_SPDIF_SIS_LockLoss (2U)         /*!< Bit position for SPDIF_SIS_LockLoss. */
#define BM_SPDIF_SIS_LockLoss (0x00000004U) /*!< Bit mask for SPDIF_SIS_LockLoss. */
#define BS_SPDIF_SIS_LockLoss (1U)         /*!< Bit field size in bits for SPDIF_SIS_LockLoss. */

/*! @brief Read current value of the SPDIF_SIS_LockLoss field. */
#define BR_SPDIF_SIS_LockLoss(x) (HW_SPDIF_SIS(x).B.LockLoss)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field RxFIFOResyn[3] (RO)
 *
 * Rx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIS_RxFIFOResyn (3U)      /*!< Bit position for SPDIF_SIS_RxFIFOResyn. */
#define BM_SPDIF_SIS_RxFIFOResyn (0x00000008U) /*!< Bit mask for SPDIF_SIS_RxFIFOResyn. */
#define BS_SPDIF_SIS_RxFIFOResyn (1U)      /*!< Bit field size in bits for SPDIF_SIS_RxFIFOResyn. */

/*! @brief Read current value of the SPDIF_SIS_RxFIFOResyn field. */
#define BR_SPDIF_SIS_RxFIFOResyn(x) (HW_SPDIF_SIS(x).B.RxFIFOResyn)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field RxFIFOUnOv[4] (RO)
 *
 * Rx FIFO underrun/overrun
 */
/*@{*/
#define BP_SPDIF_SIS_RxFIFOUnOv (4U)       /*!< Bit position for SPDIF_SIS_RxFIFOUnOv. */
#define BM_SPDIF_SIS_RxFIFOUnOv (0x00000010U) /*!< Bit mask for SPDIF_SIS_RxFIFOUnOv. */
#define BS_SPDIF_SIS_RxFIFOUnOv (1U)       /*!< Bit field size in bits for SPDIF_SIS_RxFIFOUnOv. */

/*! @brief Read current value of the SPDIF_SIS_RxFIFOUnOv field. */
#define BR_SPDIF_SIS_RxFIFOUnOv(x) (HW_SPDIF_SIS(x).B.RxFIFOUnOv)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field UQErr[5] (RO)
 *
 * U/Q Channel framing error
 */
/*@{*/
#define BP_SPDIF_SIS_UQErr   (5U)          /*!< Bit position for SPDIF_SIS_UQErr. */
#define BM_SPDIF_SIS_UQErr   (0x00000020U) /*!< Bit mask for SPDIF_SIS_UQErr. */
#define BS_SPDIF_SIS_UQErr   (1U)          /*!< Bit field size in bits for SPDIF_SIS_UQErr. */

/*! @brief Read current value of the SPDIF_SIS_UQErr field. */
#define BR_SPDIF_SIS_UQErr(x) (HW_SPDIF_SIS(x).B.UQErr)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field UQSync[6] (RO)
 *
 * U/Q Channel sync found
 */
/*@{*/
#define BP_SPDIF_SIS_UQSync  (6U)          /*!< Bit position for SPDIF_SIS_UQSync. */
#define BM_SPDIF_SIS_UQSync  (0x00000040U) /*!< Bit mask for SPDIF_SIS_UQSync. */
#define BS_SPDIF_SIS_UQSync  (1U)          /*!< Bit field size in bits for SPDIF_SIS_UQSync. */

/*! @brief Read current value of the SPDIF_SIS_UQSync field. */
#define BR_SPDIF_SIS_UQSync(x) (HW_SPDIF_SIS(x).B.UQSync)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field QRxOv[7] (RO)
 *
 * Q Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIS_QRxOv   (7U)          /*!< Bit position for SPDIF_SIS_QRxOv. */
#define BM_SPDIF_SIS_QRxOv   (0x00000080U) /*!< Bit mask for SPDIF_SIS_QRxOv. */
#define BS_SPDIF_SIS_QRxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIS_QRxOv. */

/*! @brief Read current value of the SPDIF_SIS_QRxOv field. */
#define BR_SPDIF_SIS_QRxOv(x) (HW_SPDIF_SIS(x).B.QRxOv)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field QRxFul[8] (RO)
 *
 * Q Channel receive register full, can't be cleared with reg. IntClear. To
 * clear it, read from Q Rx reg.
 */
/*@{*/
#define BP_SPDIF_SIS_QRxFul  (8U)          /*!< Bit position for SPDIF_SIS_QRxFul. */
#define BM_SPDIF_SIS_QRxFul  (0x00000100U) /*!< Bit mask for SPDIF_SIS_QRxFul. */
#define BS_SPDIF_SIS_QRxFul  (1U)          /*!< Bit field size in bits for SPDIF_SIS_QRxFul. */

/*! @brief Read current value of the SPDIF_SIS_QRxFul field. */
#define BR_SPDIF_SIS_QRxFul(x) (HW_SPDIF_SIS(x).B.QRxFul)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field URxOv[9] (RO)
 *
 * U Channel receive register overrun
 */
/*@{*/
#define BP_SPDIF_SIS_URxOv   (9U)          /*!< Bit position for SPDIF_SIS_URxOv. */
#define BM_SPDIF_SIS_URxOv   (0x00000200U) /*!< Bit mask for SPDIF_SIS_URxOv. */
#define BS_SPDIF_SIS_URxOv   (1U)          /*!< Bit field size in bits for SPDIF_SIS_URxOv. */

/*! @brief Read current value of the SPDIF_SIS_URxOv field. */
#define BR_SPDIF_SIS_URxOv(x) (HW_SPDIF_SIS(x).B.URxOv)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field URxFul[10] (RO)
 *
 * U Channel receive register full, can't be cleared with reg. IntClear. To
 * clear it, read from U Rx reg.
 */
/*@{*/
#define BP_SPDIF_SIS_URxFul  (10U)         /*!< Bit position for SPDIF_SIS_URxFul. */
#define BM_SPDIF_SIS_URxFul  (0x00000400U) /*!< Bit mask for SPDIF_SIS_URxFul. */
#define BS_SPDIF_SIS_URxFul  (1U)          /*!< Bit field size in bits for SPDIF_SIS_URxFul. */

/*! @brief Read current value of the SPDIF_SIS_URxFul field. */
#define BR_SPDIF_SIS_URxFul(x) (HW_SPDIF_SIS(x).B.URxFul)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field BitErr[14] (RO)
 *
 * SPDIF receiver found parity bit error
 */
/*@{*/
#define BP_SPDIF_SIS_BitErr  (14U)         /*!< Bit position for SPDIF_SIS_BitErr. */
#define BM_SPDIF_SIS_BitErr  (0x00004000U) /*!< Bit mask for SPDIF_SIS_BitErr. */
#define BS_SPDIF_SIS_BitErr  (1U)          /*!< Bit field size in bits for SPDIF_SIS_BitErr. */

/*! @brief Read current value of the SPDIF_SIS_BitErr field. */
#define BR_SPDIF_SIS_BitErr(x) (HW_SPDIF_SIS(x).B.BitErr)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field SymErr[15] (RO)
 *
 * SPDIF receiver found illegal symbol
 */
/*@{*/
#define BP_SPDIF_SIS_SymErr  (15U)         /*!< Bit position for SPDIF_SIS_SymErr. */
#define BM_SPDIF_SIS_SymErr  (0x00008000U) /*!< Bit mask for SPDIF_SIS_SymErr. */
#define BS_SPDIF_SIS_SymErr  (1U)          /*!< Bit field size in bits for SPDIF_SIS_SymErr. */

/*! @brief Read current value of the SPDIF_SIS_SymErr field. */
#define BR_SPDIF_SIS_SymErr(x) (HW_SPDIF_SIS(x).B.SymErr)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field ValNoGood[16] (RO)
 *
 * SPDIF validity flag no good
 */
/*@{*/
#define BP_SPDIF_SIS_ValNoGood (16U)       /*!< Bit position for SPDIF_SIS_ValNoGood. */
#define BM_SPDIF_SIS_ValNoGood (0x00010000U) /*!< Bit mask for SPDIF_SIS_ValNoGood. */
#define BS_SPDIF_SIS_ValNoGood (1U)        /*!< Bit field size in bits for SPDIF_SIS_ValNoGood. */

/*! @brief Read current value of the SPDIF_SIS_ValNoGood field. */
#define BR_SPDIF_SIS_ValNoGood(x) (HW_SPDIF_SIS(x).B.ValNoGood)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field CNew[17] (RO)
 *
 * SPDIF receive change in value of control channel
 */
/*@{*/
#define BP_SPDIF_SIS_CNew    (17U)         /*!< Bit position for SPDIF_SIS_CNew. */
#define BM_SPDIF_SIS_CNew    (0x00020000U) /*!< Bit mask for SPDIF_SIS_CNew. */
#define BS_SPDIF_SIS_CNew    (1U)          /*!< Bit field size in bits for SPDIF_SIS_CNew. */

/*! @brief Read current value of the SPDIF_SIS_CNew field. */
#define BR_SPDIF_SIS_CNew(x) (HW_SPDIF_SIS(x).B.CNew)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field TxResyn[18] (RO)
 *
 * SPDIF Tx FIFO resync
 */
/*@{*/
#define BP_SPDIF_SIS_TxResyn (18U)         /*!< Bit position for SPDIF_SIS_TxResyn. */
#define BM_SPDIF_SIS_TxResyn (0x00040000U) /*!< Bit mask for SPDIF_SIS_TxResyn. */
#define BS_SPDIF_SIS_TxResyn (1U)          /*!< Bit field size in bits for SPDIF_SIS_TxResyn. */

/*! @brief Read current value of the SPDIF_SIS_TxResyn field. */
#define BR_SPDIF_SIS_TxResyn(x) (HW_SPDIF_SIS(x).B.TxResyn)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field TxUnOv[19] (RO)
 *
 * SPDIF Tx FIFO under/overrun
 */
/*@{*/
#define BP_SPDIF_SIS_TxUnOv  (19U)         /*!< Bit position for SPDIF_SIS_TxUnOv. */
#define BM_SPDIF_SIS_TxUnOv  (0x00080000U) /*!< Bit mask for SPDIF_SIS_TxUnOv. */
#define BS_SPDIF_SIS_TxUnOv  (1U)          /*!< Bit field size in bits for SPDIF_SIS_TxUnOv. */

/*! @brief Read current value of the SPDIF_SIS_TxUnOv field. */
#define BR_SPDIF_SIS_TxUnOv(x) (HW_SPDIF_SIS(x).B.TxUnOv)
/*@}*/

/*!
 * @name Register SPDIF_SIS, field Lock[20] (RO)
 *
 * SPDIF receiver's DPLL is locked
 */
/*@{*/
#define BP_SPDIF_SIS_Lock    (20U)         /*!< Bit position for SPDIF_SIS_Lock. */
#define BM_SPDIF_SIS_Lock    (0x00100000U) /*!< Bit mask for SPDIF_SIS_Lock. */
#define BS_SPDIF_SIS_Lock    (1U)          /*!< Bit field size in bits for SPDIF_SIS_Lock. */

/*! @brief Read current value of the SPDIF_SIS_Lock field. */
#define BR_SPDIF_SIS_Lock(x) (HW_SPDIF_SIS(x).B.Lock)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRL - SPDIFRxLeft Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRL - SPDIFRxLeft Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFRxLeft register is an audio data reception register.
 */
typedef union _hw_spdif_srl
{
    uint32_t U;
    struct _hw_spdif_srl_bitfields
    {
        uint32_t RxDataLeft : 24;      /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srl_t;

/*!
 * @name Constants and macros for entire SPDIF_SRL register
 */
/*@{*/
#define HW_SPDIF_SRL_ADDR(x)     ((uintptr_t)(x) + 0x14U)

#define HW_SPDIF_SRL(x)          (*(__I hw_spdif_srl_t *) HW_SPDIF_SRL_ADDR(x))
#define HW_SPDIF_SRL_RD(x)       (HW_SPDIF_SRL(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRL bitfields
 */

/*!
 * @name Register SPDIF_SRL, field RxDataLeft[23:0] (RO)
 *
 * Processor receive SPDIF data left
 */
/*@{*/
#define BP_SPDIF_SRL_RxDataLeft (0U)       /*!< Bit position for SPDIF_SRL_RxDataLeft. */
#define BM_SPDIF_SRL_RxDataLeft (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRL_RxDataLeft. */
#define BS_SPDIF_SRL_RxDataLeft (24U)      /*!< Bit field size in bits for SPDIF_SRL_RxDataLeft. */

/*! @brief Read current value of the SPDIF_SRL_RxDataLeft field. */
#define BR_SPDIF_SRL_RxDataLeft(x) (HW_SPDIF_SRL(x).B.RxDataLeft)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRR - SPDIFRxRight Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRR - SPDIFRxRight Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFRxRight register is an audio data reception register.
 */
typedef union _hw_spdif_srr
{
    uint32_t U;
    struct _hw_spdif_srr_bitfields
    {
        uint32_t RxDataRight : 24;     /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srr_t;

/*!
 * @name Constants and macros for entire SPDIF_SRR register
 */
/*@{*/
#define HW_SPDIF_SRR_ADDR(x)     ((uintptr_t)(x) + 0x18U)

#define HW_SPDIF_SRR(x)          (*(__I hw_spdif_srr_t *) HW_SPDIF_SRR_ADDR(x))
#define HW_SPDIF_SRR_RD(x)       (HW_SPDIF_SRR(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRR bitfields
 */

/*!
 * @name Register SPDIF_SRR, field RxDataRight[23:0] (RO)
 *
 * Processor receive SPDIF data right
 */
/*@{*/
#define BP_SPDIF_SRR_RxDataRight (0U)      /*!< Bit position for SPDIF_SRR_RxDataRight. */
#define BM_SPDIF_SRR_RxDataRight (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRR_RxDataRight. */
#define BS_SPDIF_SRR_RxDataRight (24U)     /*!< Bit field size in bits for SPDIF_SRR_RxDataRight. */

/*! @brief Read current value of the SPDIF_SRR_RxDataRight field. */
#define BR_SPDIF_SRR_RxDataRight(x) (HW_SPDIF_SRR(x).B.RxDataRight)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRCSH - SPDIFRxCChannel_h Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRCSH - SPDIFRxCChannel_h Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFRxCChannel_h register is a channel status reception register.
 */
typedef union _hw_spdif_srcsh
{
    uint32_t U;
    struct _hw_spdif_srcsh_bitfields
    {
        uint32_t RxCChannel_h : 24;    /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srcsh_t;

/*!
 * @name Constants and macros for entire SPDIF_SRCSH register
 */
/*@{*/
#define HW_SPDIF_SRCSH_ADDR(x)   ((uintptr_t)(x) + 0x1CU)

#define HW_SPDIF_SRCSH(x)        (*(__I hw_spdif_srcsh_t *) HW_SPDIF_SRCSH_ADDR(x))
#define HW_SPDIF_SRCSH_RD(x)     (HW_SPDIF_SRCSH(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRCSH bitfields
 */

/*!
 * @name Register SPDIF_SRCSH, field RxCChannel_h[23:0] (RO)
 *
 * SPDIF receive C channel register, contains first 24 bits of C channel without
 * interpretation
 */
/*@{*/
#define BP_SPDIF_SRCSH_RxCChannel_h (0U)   /*!< Bit position for SPDIF_SRCSH_RxCChannel_h. */
#define BM_SPDIF_SRCSH_RxCChannel_h (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRCSH_RxCChannel_h. */
#define BS_SPDIF_SRCSH_RxCChannel_h (24U)  /*!< Bit field size in bits for SPDIF_SRCSH_RxCChannel_h. */

/*! @brief Read current value of the SPDIF_SRCSH_RxCChannel_h field. */
#define BR_SPDIF_SRCSH_RxCChannel_h(x) (HW_SPDIF_SRCSH(x).B.RxCChannel_h)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRCSL - SPDIFRxCChannel_l Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRCSL - SPDIFRxCChannel_l Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFRxCChannel_l register is a channel status reception register.
 */
typedef union _hw_spdif_srcsl
{
    uint32_t U;
    struct _hw_spdif_srcsl_bitfields
    {
        uint32_t RxCChannel_l : 24;    /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srcsl_t;

/*!
 * @name Constants and macros for entire SPDIF_SRCSL register
 */
/*@{*/
#define HW_SPDIF_SRCSL_ADDR(x)   ((uintptr_t)(x) + 0x20U)

#define HW_SPDIF_SRCSL(x)        (*(__I hw_spdif_srcsl_t *) HW_SPDIF_SRCSL_ADDR(x))
#define HW_SPDIF_SRCSL_RD(x)     (HW_SPDIF_SRCSL(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRCSL bitfields
 */

/*!
 * @name Register SPDIF_SRCSL, field RxCChannel_l[23:0] (RO)
 *
 * SPDIF receive C channel register, contains next 24 bits of C channel without
 * interpretation
 */
/*@{*/
#define BP_SPDIF_SRCSL_RxCChannel_l (0U)   /*!< Bit position for SPDIF_SRCSL_RxCChannel_l. */
#define BM_SPDIF_SRCSL_RxCChannel_l (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRCSL_RxCChannel_l. */
#define BS_SPDIF_SRCSL_RxCChannel_l (24U)  /*!< Bit field size in bits for SPDIF_SRCSL_RxCChannel_l. */

/*! @brief Read current value of the SPDIF_SRCSL_RxCChannel_l field. */
#define BR_SPDIF_SRCSL_RxCChannel_l(x) (HW_SPDIF_SRCSL(x).B.RxCChannel_l)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRU - UchannelRx Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRU - UchannelRx Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * UChannelRx register is a user bits reception register.
 */
typedef union _hw_spdif_sru
{
    uint32_t U;
    struct _hw_spdif_sru_bitfields
    {
        uint32_t RxUChannel : 24;      /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_spdif_sru_t;

/*!
 * @name Constants and macros for entire SPDIF_SRU register
 */
/*@{*/
#define HW_SPDIF_SRU_ADDR(x)     ((uintptr_t)(x) + 0x24U)

#define HW_SPDIF_SRU(x)          (*(__I hw_spdif_sru_t *) HW_SPDIF_SRU_ADDR(x))
#define HW_SPDIF_SRU_RD(x)       (HW_SPDIF_SRU(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRU bitfields
 */

/*!
 * @name Register SPDIF_SRU, field RxUChannel[23:0] (RO)
 *
 * SPDIF receive U channel register, contains next 3 U channel bytes
 */
/*@{*/
#define BP_SPDIF_SRU_RxUChannel (0U)       /*!< Bit position for SPDIF_SRU_RxUChannel. */
#define BM_SPDIF_SRU_RxUChannel (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRU_RxUChannel. */
#define BS_SPDIF_SRU_RxUChannel (24U)      /*!< Bit field size in bits for SPDIF_SRU_RxUChannel. */

/*! @brief Read current value of the SPDIF_SRU_RxUChannel field. */
#define BR_SPDIF_SRU_RxUChannel(x) (HW_SPDIF_SRU(x).B.RxUChannel)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRQ - QchannelRx Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRQ - QchannelRx Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * QChannelRx register is a user bits reception register.
 */
typedef union _hw_spdif_srq
{
    uint32_t U;
    struct _hw_spdif_srq_bitfields
    {
        uint32_t RxQChannel : 24;      /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srq_t;

/*!
 * @name Constants and macros for entire SPDIF_SRQ register
 */
/*@{*/
#define HW_SPDIF_SRQ_ADDR(x)     ((uintptr_t)(x) + 0x28U)

#define HW_SPDIF_SRQ(x)          (*(__I hw_spdif_srq_t *) HW_SPDIF_SRQ_ADDR(x))
#define HW_SPDIF_SRQ_RD(x)       (HW_SPDIF_SRQ(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRQ bitfields
 */

/*!
 * @name Register SPDIF_SRQ, field RxQChannel[23:0] (RO)
 *
 * SPDIF receive Q channel register, contains next 3 Q channel bytes
 */
/*@{*/
#define BP_SPDIF_SRQ_RxQChannel (0U)       /*!< Bit position for SPDIF_SRQ_RxQChannel. */
#define BM_SPDIF_SRQ_RxQChannel (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRQ_RxQChannel. */
#define BS_SPDIF_SRQ_RxQChannel (24U)      /*!< Bit field size in bits for SPDIF_SRQ_RxQChannel. */

/*! @brief Read current value of the SPDIF_SRQ_RxQChannel field. */
#define BR_SPDIF_SRQ_RxQChannel(x) (HW_SPDIF_SRQ(x).B.RxQChannel)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_STL - SPDIFTxLeft Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_STL - SPDIFTxLeft Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFTxLeft register is an audio data transmission register.
 */
typedef union _hw_spdif_stl
{
    uint32_t U;
    struct _hw_spdif_stl_bitfields
    {
        uint32_t TxDataLeft : 24;      /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_spdif_stl_t;

/*!
 * @name Constants and macros for entire SPDIF_STL register
 */
/*@{*/
#define HW_SPDIF_STL_ADDR(x)     ((uintptr_t)(x) + 0x2CU)

#define HW_SPDIF_STL(x)          (*(__O hw_spdif_stl_t *) HW_SPDIF_STL_ADDR(x))
#define HW_SPDIF_STL_WR(x, v)    (HW_SPDIF_STL(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual SPDIF_STL bitfields
 */

/*!
 * @name Register SPDIF_STL, field TxDataLeft[23:0] (WO)
 *
 * SPDIF transmit left channel data. It is write-only, and always returns zeros
 * when read
 */
/*@{*/
#define BP_SPDIF_STL_TxDataLeft (0U)       /*!< Bit position for SPDIF_STL_TxDataLeft. */
#define BM_SPDIF_STL_TxDataLeft (0x00FFFFFFU) /*!< Bit mask for SPDIF_STL_TxDataLeft. */
#define BS_SPDIF_STL_TxDataLeft (24U)      /*!< Bit field size in bits for SPDIF_STL_TxDataLeft. */

/*! @brief Format value for bitfield SPDIF_STL_TxDataLeft. */
#define BF_SPDIF_STL_TxDataLeft(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STL_TxDataLeft) & BM_SPDIF_STL_TxDataLeft)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_STR - SPDIFTxRight Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_STR - SPDIFTxRight Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFTxRight register is an audio data transmission register.
 */
typedef union _hw_spdif_str
{
    uint32_t U;
    struct _hw_spdif_str_bitfields
    {
        uint32_t TxDataRight : 24;     /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_spdif_str_t;

/*!
 * @name Constants and macros for entire SPDIF_STR register
 */
/*@{*/
#define HW_SPDIF_STR_ADDR(x)     ((uintptr_t)(x) + 0x30U)

#define HW_SPDIF_STR(x)          (*(__O hw_spdif_str_t *) HW_SPDIF_STR_ADDR(x))
#define HW_SPDIF_STR_WR(x, v)    (HW_SPDIF_STR(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual SPDIF_STR bitfields
 */

/*!
 * @name Register SPDIF_STR, field TxDataRight[23:0] (WO)
 *
 * SPDIF transmit right channel data. It is write-only, and always returns zeros
 * when read
 */
/*@{*/
#define BP_SPDIF_STR_TxDataRight (0U)      /*!< Bit position for SPDIF_STR_TxDataRight. */
#define BM_SPDIF_STR_TxDataRight (0x00FFFFFFU) /*!< Bit mask for SPDIF_STR_TxDataRight. */
#define BS_SPDIF_STR_TxDataRight (24U)     /*!< Bit field size in bits for SPDIF_STR_TxDataRight. */

/*! @brief Format value for bitfield SPDIF_STR_TxDataRight. */
#define BF_SPDIF_STR_TxDataRight(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STR_TxDataRight) & BM_SPDIF_STR_TxDataRight)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_STCSCH - SPDIFTxCChannelCons_h Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_STCSCH - SPDIFTxCChannelCons_h Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFTxCChannelCons_h register is a channel status transmission register.
 */
typedef union _hw_spdif_stcsch
{
    uint32_t U;
    struct _hw_spdif_stcsch_bitfields
    {
        uint32_t TxCChannelCons_h : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_stcsch_t;

/*!
 * @name Constants and macros for entire SPDIF_STCSCH register
 */
/*@{*/
#define HW_SPDIF_STCSCH_ADDR(x)  ((uintptr_t)(x) + 0x34U)

#define HW_SPDIF_STCSCH(x)       (*(__IO hw_spdif_stcsch_t *) HW_SPDIF_STCSCH_ADDR(x))
#define HW_SPDIF_STCSCH_RD(x)    (HW_SPDIF_STCSCH(x).U)
#define HW_SPDIF_STCSCH_WR(x, v) (HW_SPDIF_STCSCH(x).U = (v))
#define HW_SPDIF_STCSCH_SET(x, v) (HW_SPDIF_STCSCH_WR(x, HW_SPDIF_STCSCH_RD(x) |  (v)))
#define HW_SPDIF_STCSCH_CLR(x, v) (HW_SPDIF_STCSCH_WR(x, HW_SPDIF_STCSCH_RD(x) & ~(v)))
#define HW_SPDIF_STCSCH_TOG(x, v) (HW_SPDIF_STCSCH_WR(x, HW_SPDIF_STCSCH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_STCSCH bitfields
 */

/*!
 * @name Register SPDIF_STCSCH, field TxCChannelCons_h[23:0] (RW)
 *
 * SPDIF transmit Cons. C channel data, contains first 24 bits without
 * interpretation. When read, it returns the latest data written by the processor
 */
/*@{*/
#define BP_SPDIF_STCSCH_TxCChannelCons_h (0U) /*!< Bit position for SPDIF_STCSCH_TxCChannelCons_h. */
#define BM_SPDIF_STCSCH_TxCChannelCons_h (0x00FFFFFFU) /*!< Bit mask for SPDIF_STCSCH_TxCChannelCons_h. */
#define BS_SPDIF_STCSCH_TxCChannelCons_h (24U) /*!< Bit field size in bits for SPDIF_STCSCH_TxCChannelCons_h. */

/*! @brief Read current value of the SPDIF_STCSCH_TxCChannelCons_h field. */
#define BR_SPDIF_STCSCH_TxCChannelCons_h(x) (HW_SPDIF_STCSCH(x).B.TxCChannelCons_h)

/*! @brief Format value for bitfield SPDIF_STCSCH_TxCChannelCons_h. */
#define BF_SPDIF_STCSCH_TxCChannelCons_h(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STCSCH_TxCChannelCons_h) & BM_SPDIF_STCSCH_TxCChannelCons_h)

/*! @brief Set the TxCChannelCons_h field to a new value. */
#define BW_SPDIF_STCSCH_TxCChannelCons_h(x, v) (HW_SPDIF_STCSCH_WR(x, (HW_SPDIF_STCSCH_RD(x) & ~BM_SPDIF_STCSCH_TxCChannelCons_h) | BF_SPDIF_STCSCH_TxCChannelCons_h(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_STCSCL - SPDIFTxCChannelCons_l Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_STCSCL - SPDIFTxCChannelCons_l Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * SPDIFTxCChannelCons_l register is a channel status transmission register.
 */
typedef union _hw_spdif_stcscl
{
    uint32_t U;
    struct _hw_spdif_stcscl_bitfields
    {
        uint32_t TxCChannelCons_l : 24; /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_stcscl_t;

/*!
 * @name Constants and macros for entire SPDIF_STCSCL register
 */
/*@{*/
#define HW_SPDIF_STCSCL_ADDR(x)  ((uintptr_t)(x) + 0x38U)

#define HW_SPDIF_STCSCL(x)       (*(__IO hw_spdif_stcscl_t *) HW_SPDIF_STCSCL_ADDR(x))
#define HW_SPDIF_STCSCL_RD(x)    (HW_SPDIF_STCSCL(x).U)
#define HW_SPDIF_STCSCL_WR(x, v) (HW_SPDIF_STCSCL(x).U = (v))
#define HW_SPDIF_STCSCL_SET(x, v) (HW_SPDIF_STCSCL_WR(x, HW_SPDIF_STCSCL_RD(x) |  (v)))
#define HW_SPDIF_STCSCL_CLR(x, v) (HW_SPDIF_STCSCL_WR(x, HW_SPDIF_STCSCL_RD(x) & ~(v)))
#define HW_SPDIF_STCSCL_TOG(x, v) (HW_SPDIF_STCSCL_WR(x, HW_SPDIF_STCSCL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_STCSCL bitfields
 */

/*!
 * @name Register SPDIF_STCSCL, field TxCChannelCons_l[23:0] (RW)
 *
 * SPDIF transmit Cons. C channel data, contains next 24 bits without
 * interpretation. When read, it returns the latest data written by the processor
 */
/*@{*/
#define BP_SPDIF_STCSCL_TxCChannelCons_l (0U) /*!< Bit position for SPDIF_STCSCL_TxCChannelCons_l. */
#define BM_SPDIF_STCSCL_TxCChannelCons_l (0x00FFFFFFU) /*!< Bit mask for SPDIF_STCSCL_TxCChannelCons_l. */
#define BS_SPDIF_STCSCL_TxCChannelCons_l (24U) /*!< Bit field size in bits for SPDIF_STCSCL_TxCChannelCons_l. */

/*! @brief Read current value of the SPDIF_STCSCL_TxCChannelCons_l field. */
#define BR_SPDIF_STCSCL_TxCChannelCons_l(x) (HW_SPDIF_STCSCL(x).B.TxCChannelCons_l)

/*! @brief Format value for bitfield SPDIF_STCSCL_TxCChannelCons_l. */
#define BF_SPDIF_STCSCL_TxCChannelCons_l(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STCSCL_TxCChannelCons_l) & BM_SPDIF_STCSCL_TxCChannelCons_l)

/*! @brief Set the TxCChannelCons_l field to a new value. */
#define BW_SPDIF_STCSCL_TxCChannelCons_l(x, v) (HW_SPDIF_STCSCL_WR(x, (HW_SPDIF_STCSCL_RD(x) & ~BM_SPDIF_STCSCL_TxCChannelCons_l) | BF_SPDIF_STCSCL_TxCChannelCons_l(v)))
/*@}*/

/*******************************************************************************
 * HW_SPDIF_SRFM - FreqMeas Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_SRFM - FreqMeas Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_spdif_srfm
{
    uint32_t U;
    struct _hw_spdif_srfm_bitfields
    {
        uint32_t FreqMeas : 24;        /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_srfm_t;

/*!
 * @name Constants and macros for entire SPDIF_SRFM register
 */
/*@{*/
#define HW_SPDIF_SRFM_ADDR(x)    ((uintptr_t)(x) + 0x44U)

#define HW_SPDIF_SRFM(x)         (*(__I hw_spdif_srfm_t *) HW_SPDIF_SRFM_ADDR(x))
#define HW_SPDIF_SRFM_RD(x)      (HW_SPDIF_SRFM(x).U)
/*@}*/

/*
 * Constants & macros for individual SPDIF_SRFM bitfields
 */

/*!
 * @name Register SPDIF_SRFM, field FreqMeas[23:0] (RO)
 *
 * Frequency measurement data
 */
/*@{*/
#define BP_SPDIF_SRFM_FreqMeas (0U)        /*!< Bit position for SPDIF_SRFM_FreqMeas. */
#define BM_SPDIF_SRFM_FreqMeas (0x00FFFFFFU) /*!< Bit mask for SPDIF_SRFM_FreqMeas. */
#define BS_SPDIF_SRFM_FreqMeas (24U)       /*!< Bit field size in bits for SPDIF_SRFM_FreqMeas. */

/*! @brief Read current value of the SPDIF_SRFM_FreqMeas field. */
#define BR_SPDIF_SRFM_FreqMeas(x) (HW_SPDIF_SRFM(x).B.FreqMeas)
/*@}*/

/*******************************************************************************
 * HW_SPDIF_STC - SPDIFTxClk Register
 ******************************************************************************/

/*!
 * @brief HW_SPDIF_STC - SPDIFTxClk Register (RW)
 *
 * Reset value: 0x00020F00U
 *
 * The SPDIFTxClk Control register includes the means to select the transmit
 * clock and frequency division.
 */
typedef union _hw_spdif_stc
{
    uint32_t U;
    struct _hw_spdif_stc_bitfields
    {
        uint32_t TxClk_DF : 7;         /*!< [6:0]  */
        uint32_t tx_all_clk_en : 1;    /*!< [7]  */
        uint32_t TxClk_Source : 3;     /*!< [10:8]  */
        uint32_t SYSCLK_DF : 9;        /*!< [19:11]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20] This is a 24-bit register the
                                        * upper byte is unimplemented. */
    } B;
} hw_spdif_stc_t;

/*!
 * @name Constants and macros for entire SPDIF_STC register
 */
/*@{*/
#define HW_SPDIF_STC_ADDR(x)     ((uintptr_t)(x) + 0x50U)

#define HW_SPDIF_STC(x)          (*(__IO hw_spdif_stc_t *) HW_SPDIF_STC_ADDR(x))
#define HW_SPDIF_STC_RD(x)       (HW_SPDIF_STC(x).U)
#define HW_SPDIF_STC_WR(x, v)    (HW_SPDIF_STC(x).U = (v))
#define HW_SPDIF_STC_SET(x, v)   (HW_SPDIF_STC_WR(x, HW_SPDIF_STC_RD(x) |  (v)))
#define HW_SPDIF_STC_CLR(x, v)   (HW_SPDIF_STC_WR(x, HW_SPDIF_STC_RD(x) & ~(v)))
#define HW_SPDIF_STC_TOG(x, v)   (HW_SPDIF_STC_WR(x, HW_SPDIF_STC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SPDIF_STC bitfields
 */

/*!
 * @name Register SPDIF_STC, field TxClk_DF[6:0] (RW)
 *
 * Divider factor (1-128)
 *
 * Values:
 * - 0 - divider factor is 1
 * - 1 - divider factor is 2
 */
/*@{*/
#define BP_SPDIF_STC_TxClk_DF (0U)         /*!< Bit position for SPDIF_STC_TxClk_DF. */
#define BM_SPDIF_STC_TxClk_DF (0x0000007FU) /*!< Bit mask for SPDIF_STC_TxClk_DF. */
#define BS_SPDIF_STC_TxClk_DF (7U)         /*!< Bit field size in bits for SPDIF_STC_TxClk_DF. */

/*! @brief Read current value of the SPDIF_STC_TxClk_DF field. */
#define BR_SPDIF_STC_TxClk_DF(x) (HW_SPDIF_STC(x).B.TxClk_DF)

/*! @brief Format value for bitfield SPDIF_STC_TxClk_DF. */
#define BF_SPDIF_STC_TxClk_DF(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STC_TxClk_DF) & BM_SPDIF_STC_TxClk_DF)

/*! @brief Set the TxClk_DF field to a new value. */
#define BW_SPDIF_STC_TxClk_DF(x, v) (HW_SPDIF_STC_WR(x, (HW_SPDIF_STC_RD(x) & ~BM_SPDIF_STC_TxClk_DF) | BF_SPDIF_STC_TxClk_DF(v)))
/*@}*/

/*!
 * @name Register SPDIF_STC, field tx_all_clk_en[7] (RW)
 *
 * Spdif transfer clock enable.When data is going to be transfered, this bit
 * should be set to1.
 *
 * Values:
 * - 0 - disable transfer clock.
 * - 1 - enable transfer clock.
 */
/*@{*/
#define BP_SPDIF_STC_tx_all_clk_en (7U)    /*!< Bit position for SPDIF_STC_tx_all_clk_en. */
#define BM_SPDIF_STC_tx_all_clk_en (0x00000080U) /*!< Bit mask for SPDIF_STC_tx_all_clk_en. */
#define BS_SPDIF_STC_tx_all_clk_en (1U)    /*!< Bit field size in bits for SPDIF_STC_tx_all_clk_en. */

/*! @brief Read current value of the SPDIF_STC_tx_all_clk_en field. */
#define BR_SPDIF_STC_tx_all_clk_en(x) (HW_SPDIF_STC(x).B.tx_all_clk_en)

/*! @brief Format value for bitfield SPDIF_STC_tx_all_clk_en. */
#define BF_SPDIF_STC_tx_all_clk_en(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STC_tx_all_clk_en) & BM_SPDIF_STC_tx_all_clk_en)

/*! @brief Set the tx_all_clk_en field to a new value. */
#define BW_SPDIF_STC_tx_all_clk_en(x, v) (HW_SPDIF_STC_WR(x, (HW_SPDIF_STC_RD(x) & ~BM_SPDIF_STC_tx_all_clk_en) | BF_SPDIF_STC_tx_all_clk_en(v)))
/*@}*/

/*!
 * @name Register SPDIF_STC, field TxClk_Source[10:8] (RW)
 *
 * Values:
 * - 000 - REF_CLK_32K input (XTALOSC 32kHz clock)
 * - 001 - tx_clk input (from SPDIF0_CLK_ROOT. See CCM.)
 * - 010 - ASRC_EXT_CLK input
 * - 011 - SPDIF_EXT_CLK, from pads
 * - 100 - ESAI_HCKT input
 * - 101 - ipg_clk input (frequency divided)
 * - 110 - MLB clock input
 * - 111 - MLB PHY clock input
 */
/*@{*/
#define BP_SPDIF_STC_TxClk_Source (8U)     /*!< Bit position for SPDIF_STC_TxClk_Source. */
#define BM_SPDIF_STC_TxClk_Source (0x00000700U) /*!< Bit mask for SPDIF_STC_TxClk_Source. */
#define BS_SPDIF_STC_TxClk_Source (3U)     /*!< Bit field size in bits for SPDIF_STC_TxClk_Source. */

/*! @brief Read current value of the SPDIF_STC_TxClk_Source field. */
#define BR_SPDIF_STC_TxClk_Source(x) (HW_SPDIF_STC(x).B.TxClk_Source)

/*! @brief Format value for bitfield SPDIF_STC_TxClk_Source. */
#define BF_SPDIF_STC_TxClk_Source(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STC_TxClk_Source) & BM_SPDIF_STC_TxClk_Source)

/*! @brief Set the TxClk_Source field to a new value. */
#define BW_SPDIF_STC_TxClk_Source(x, v) (HW_SPDIF_STC_WR(x, (HW_SPDIF_STC_RD(x) & ~BM_SPDIF_STC_TxClk_Source) | BF_SPDIF_STC_TxClk_Source(v)))
/*@}*/

/*!
 * @name Register SPDIF_STC, field SYSCLK_DF[19:11] (RW)
 *
 * system clock divider factor, 2~512.
 *
 * Values:
 * - 0 - no clock signal
 * - 1 - divider factor is 2
 */
/*@{*/
#define BP_SPDIF_STC_SYSCLK_DF (11U)       /*!< Bit position for SPDIF_STC_SYSCLK_DF. */
#define BM_SPDIF_STC_SYSCLK_DF (0x000FF800U) /*!< Bit mask for SPDIF_STC_SYSCLK_DF. */
#define BS_SPDIF_STC_SYSCLK_DF (9U)        /*!< Bit field size in bits for SPDIF_STC_SYSCLK_DF. */

/*! @brief Read current value of the SPDIF_STC_SYSCLK_DF field. */
#define BR_SPDIF_STC_SYSCLK_DF(x) (HW_SPDIF_STC(x).B.SYSCLK_DF)

/*! @brief Format value for bitfield SPDIF_STC_SYSCLK_DF. */
#define BF_SPDIF_STC_SYSCLK_DF(v) ((uint32_t)((uint32_t)(v) << BP_SPDIF_STC_SYSCLK_DF) & BM_SPDIF_STC_SYSCLK_DF)

/*! @brief Set the SYSCLK_DF field to a new value. */
#define BW_SPDIF_STC_SYSCLK_DF(x, v) (HW_SPDIF_STC_WR(x, (HW_SPDIF_STC_RD(x) & ~BM_SPDIF_STC_SYSCLK_DF) | BF_SPDIF_STC_SYSCLK_DF(v)))
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_spdif_t - module struct
 ******************************************************************************/
/*!
 * @brief All SPDIF module registers.
 */
#pragma pack(1)
typedef struct _hw_spdif
{
    __IO hw_spdif_scr_t SCR;               /*!< [0x0] SPDIF Configuration Register */
    __IO hw_spdif_srcd_t SRCD;             /*!< [0x4] CDText Control Register */
    __IO hw_spdif_srpc_t SRPC;             /*!< [0x8] PhaseConfig Register */
    __IO hw_spdif_sie_t SIE;               /*!< [0xC] InterruptEn Register */
    union {
        __IO hw_spdif_sic_t SIC;           /*!< [0x10] InterruptClear Register */
        __I hw_spdif_sis_t SIS;            /*!< [0x10] InterruptStat Register */
    };
    __I hw_spdif_srl_t SRL;                /*!< [0x14] SPDIFRxLeft Register */
    __I hw_spdif_srr_t SRR;                /*!< [0x18] SPDIFRxRight Register */
    __I hw_spdif_srcsh_t SRCSH;            /*!< [0x1C] SPDIFRxCChannel_h Register */
    __I hw_spdif_srcsl_t SRCSL;            /*!< [0x20] SPDIFRxCChannel_l Register */
    __I hw_spdif_sru_t SRU;                /*!< [0x24] UchannelRx Register */
    __I hw_spdif_srq_t SRQ;                /*!< [0x28] QchannelRx Register */
    __O hw_spdif_stl_t STL;                /*!< [0x2C] SPDIFTxLeft Register */
    __O hw_spdif_str_t STR;                /*!< [0x30] SPDIFTxRight Register */
    __IO hw_spdif_stcsch_t STCSCH;         /*!< [0x34] SPDIFTxCChannelCons_h Register */
    __IO hw_spdif_stcscl_t STCSCL;         /*!< [0x38] SPDIFTxCChannelCons_l Register */
    uint8_t _reserved0[8];
    __I hw_spdif_srfm_t SRFM;              /*!< [0x44] FreqMeas Register */
    uint8_t _reserved1[8];
    __IO hw_spdif_stc_t STC;               /*!< [0x50] SPDIFTxClk Register */
} hw_spdif_t;
#pragma pack()

/*! @brief Macro to access all SPDIF registers. */
/*! @param x SPDIF module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SPDIF_REGS(SPDIF_BASE)</code>. */
#define HW_SPDIF_REGS(x) (*(hw_spdif_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP SRC
 *
 * SRC
 *
 * Registers defined in this header file:
 * - HW_SRC_SCR - SRC Control Register
 * - HW_SRC_SBMR1 - SRC Boot Mode Register 1
 * - HW_SRC_SRSR - SRC Reset Status Register
 * - HW_SRC_SISR - SRC Interrupt Status Register
 * - HW_SRC_SIMR - SRC Interrupt Mask Register
 * - HW_SRC_SBMR2 - SRC Boot Mode Register 2
 * - HW_SRC_GPR1 - SRC General Purpose Register 1
 * - HW_SRC_GPR2 - SRC General Purpose Register 2
 * - HW_SRC_GPR3 - SRC General Purpose Register 3
 * - HW_SRC_GPR4 - SRC General Purpose Register 4
 * - HW_SRC_GPR5 - SRC General Purpose Register 5
 * - HW_SRC_GPR6 - SRC General Purpose Register 6
 * - HW_SRC_GPR7 - SRC General Purpose Register 7
 * - HW_SRC_GPR8 - SRC General Purpose Register 8
 * - HW_SRC_GPR9 - SRC General Purpose Register 9
 * - HW_SRC_GPR10 - SRC General Purpose Register 10
 *
 * - hw_src_t - Struct containing all module registers.
 */

#define HW_SRC_INSTANCE_COUNT (1U) /*!< Number of instances of the SRC module. */
#define HW_SRC (0U) /*!< Instance number for SRC. */
#define SRC_BASE              (0x20D8000U) /*!< Base address for SRC. */
/*! Array initializer of SRC base addresses. */
#define SRC_BASE_ADDRS        { SRC_BASE }

/*******************************************************************************
 * HW_SRC_SCR - SRC Control Register
 ******************************************************************************/

/*!
 * @brief HW_SRC_SCR - SRC Control Register (RW)
 *
 * Reset value: 0x00000521U
 *
 * The Reset control register (SCR), contains bits that control operation of the
 * reset controller.
 */
typedef union _hw_src_scr
{
    uint32_t U;
    struct _hw_src_scr_bitfields
    {
        uint32_t warm_reset_enable : 1; /*!< [0]  */
        uint32_t sw_gpu_rst : 1;       /*!< [1]  */
        uint32_t sw_vpu_rst : 1;       /*!< [2]  */
        uint32_t sw_ipu1_rst : 1;      /*!< [3]  */
        uint32_t sw_open_vg_rst : 1;   /*!< [4]  */
        uint32_t warm_rst_bypass_count : 2; /*!< [6:5]  */
        uint32_t mask_wdog_rst : 4;    /*!< [10:7]  */
        uint32_t eim_rst : 1;          /*!< [11]  */
        uint32_t sw_ipu2_rst : 1;      /*!< [12]  */
        uint32_t core0_rst : 1;        /*!< [13]  */
        uint32_t core1_rst : 1;        /*!< [14]  */
        uint32_t core2_rst : 1;        /*!< [15]  */
        uint32_t core3_rst : 1;        /*!< [16]  */
        uint32_t core0_dbg_rst : 1;    /*!< [17]  */
        uint32_t core1_dbg_rst : 1;    /*!< [18]  */
        uint32_t core2_dbg_rst : 1;    /*!< [19]  */
        uint32_t core3_dbg_rst : 1;    /*!< [20]  */
        uint32_t cores_dbg_rst : 1;    /*!< [21]  */
        uint32_t core1_enable : 1;     /*!< [22]  */
        uint32_t core2_enable : 1;     /*!< [23]  */
        uint32_t core3_enable : 1;     /*!< [24]  */
        uint32_t dbg_rst_msk_pg : 1;   /*!< [25]  */
        uint32_t RESERVED0 : 6;        /*!< [31:26]  */
    } B;
} hw_src_scr_t;

/*!
 * @name Constants and macros for entire SRC_SCR register
 */
/*@{*/
#define HW_SRC_SCR_ADDR(x)       ((uintptr_t)(x) + 0x0U)

#define HW_SRC_SCR(x)            (*(__IO hw_src_scr_t *) HW_SRC_SCR_ADDR(x))
#define HW_SRC_SCR_RD(x)         (HW_SRC_SCR(x).U)
#define HW_SRC_SCR_WR(x, v)      (HW_SRC_SCR(x).U = (v))
#define HW_SRC_SCR_SET(x, v)     (HW_SRC_SCR_WR(x, HW_SRC_SCR_RD(x) |  (v)))
#define HW_SRC_SCR_CLR(x, v)     (HW_SRC_SCR_WR(x, HW_SRC_SCR_RD(x) & ~(v)))
#define HW_SRC_SCR_TOG(x, v)     (HW_SRC_SCR_WR(x, HW_SRC_SCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_SCR bitfields
 */

/*!
 * @name Register SRC_SCR, field warm_reset_enable[0] (RW)
 *
 * WARM reset enable bit. WARM reset will be enabled only if warm_reset_enable
 * bit is set. Otherwise all WARM reset sources will generate COLD reset.
 *
 * Values:
 * - 0 - WARM reset disabled
 * - 1 - WARM reset enabled
 */
/*@{*/
#define BP_SRC_SCR_warm_reset_enable (0U)  /*!< Bit position for SRC_SCR_warm_reset_enable. */
#define BM_SRC_SCR_warm_reset_enable (0x00000001U) /*!< Bit mask for SRC_SCR_warm_reset_enable. */
#define BS_SRC_SCR_warm_reset_enable (1U)  /*!< Bit field size in bits for SRC_SCR_warm_reset_enable. */

/*! @brief Read current value of the SRC_SCR_warm_reset_enable field. */
#define BR_SRC_SCR_warm_reset_enable(x) (HW_SRC_SCR(x).B.warm_reset_enable)

/*! @brief Format value for bitfield SRC_SCR_warm_reset_enable. */
#define BF_SRC_SCR_warm_reset_enable(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_warm_reset_enable) & BM_SRC_SCR_warm_reset_enable)

/*! @brief Set the warm_reset_enable field to a new value. */
#define BW_SRC_SCR_warm_reset_enable(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_warm_reset_enable) | BF_SRC_SCR_warm_reset_enable(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field sw_gpu_rst[1] (RW)
 *
 * Software reset for GPU This is a self clearing bit. Once it is set to 1, the
 * reset process will begin, and once it finishes, this bit will be self cleared.
 * Software can determine that the reset has finished once this bit is cleared.
 * Software can also configure SRC to generate interrupt once the software has
 * finished. Please refer to SRC_SISR register for details. The reset process will
 * involve 8 GPU cycles before negating the GPU reset, to allow reset assertion
 * to propagate into GPU.
 *
 * Values:
 * - 0 - do not assert GPU reset
 * - 1 - assert GPU reset
 */
/*@{*/
#define BP_SRC_SCR_sw_gpu_rst (1U)         /*!< Bit position for SRC_SCR_sw_gpu_rst. */
#define BM_SRC_SCR_sw_gpu_rst (0x00000002U) /*!< Bit mask for SRC_SCR_sw_gpu_rst. */
#define BS_SRC_SCR_sw_gpu_rst (1U)         /*!< Bit field size in bits for SRC_SCR_sw_gpu_rst. */

/*! @brief Read current value of the SRC_SCR_sw_gpu_rst field. */
#define BR_SRC_SCR_sw_gpu_rst(x) (HW_SRC_SCR(x).B.sw_gpu_rst)

/*! @brief Format value for bitfield SRC_SCR_sw_gpu_rst. */
#define BF_SRC_SCR_sw_gpu_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_sw_gpu_rst) & BM_SRC_SCR_sw_gpu_rst)

/*! @brief Set the sw_gpu_rst field to a new value. */
#define BW_SRC_SCR_sw_gpu_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_sw_gpu_rst) | BF_SRC_SCR_sw_gpu_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field sw_vpu_rst[2] (RW)
 *
 * Software reset for VPU This is a self clearing bit. Once it is set to 1, the
 * reset process will begin, and once it finishes, this bit will be self cleared.
 * Software can determine that the reset has finished once this bit is cleared.
 * Software can also configure SRC to generate interrupt once the software has
 * finished. Please refer to SRC_SISR register for details. The reset process will
 * involve 8 VPU cycles before negating the VPU reset, to allow reset assertion
 * to propagate into VPU.
 *
 * Values:
 * - 0 - do not assert VPU reset
 * - 1 - assert VPU reset
 */
/*@{*/
#define BP_SRC_SCR_sw_vpu_rst (2U)         /*!< Bit position for SRC_SCR_sw_vpu_rst. */
#define BM_SRC_SCR_sw_vpu_rst (0x00000004U) /*!< Bit mask for SRC_SCR_sw_vpu_rst. */
#define BS_SRC_SCR_sw_vpu_rst (1U)         /*!< Bit field size in bits for SRC_SCR_sw_vpu_rst. */

/*! @brief Read current value of the SRC_SCR_sw_vpu_rst field. */
#define BR_SRC_SCR_sw_vpu_rst(x) (HW_SRC_SCR(x).B.sw_vpu_rst)

/*! @brief Format value for bitfield SRC_SCR_sw_vpu_rst. */
#define BF_SRC_SCR_sw_vpu_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_sw_vpu_rst) & BM_SRC_SCR_sw_vpu_rst)

/*! @brief Set the sw_vpu_rst field to a new value. */
#define BW_SRC_SCR_sw_vpu_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_sw_vpu_rst) | BF_SRC_SCR_sw_vpu_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field sw_ipu1_rst[3] (RW)
 *
 * Software reset for IPU1 This is a self clearing bit. Once it is set to 1, the
 * reset process will begin, and once it finishes, this bit will be self
 * cleared. Software can determine that the reset has finished once this bit is cleared.
 * Software can also configure SRC to generate interrupt once the software has
 * finished. Please refer to SRC_SISR register for details.
 *
 * Values:
 * - 0 - do not assert IPU1 reset
 * - 1 - assert IPU1 reset
 */
/*@{*/
#define BP_SRC_SCR_sw_ipu1_rst (3U)        /*!< Bit position for SRC_SCR_sw_ipu1_rst. */
#define BM_SRC_SCR_sw_ipu1_rst (0x00000008U) /*!< Bit mask for SRC_SCR_sw_ipu1_rst. */
#define BS_SRC_SCR_sw_ipu1_rst (1U)        /*!< Bit field size in bits for SRC_SCR_sw_ipu1_rst. */

/*! @brief Read current value of the SRC_SCR_sw_ipu1_rst field. */
#define BR_SRC_SCR_sw_ipu1_rst(x) (HW_SRC_SCR(x).B.sw_ipu1_rst)

/*! @brief Format value for bitfield SRC_SCR_sw_ipu1_rst. */
#define BF_SRC_SCR_sw_ipu1_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_sw_ipu1_rst) & BM_SRC_SCR_sw_ipu1_rst)

/*! @brief Set the sw_ipu1_rst field to a new value. */
#define BW_SRC_SCR_sw_ipu1_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_sw_ipu1_rst) | BF_SRC_SCR_sw_ipu1_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field sw_open_vg_rst[4] (RW)
 *
 * Software reset for open_vg This is a self clearing bit. Once it is set to 1,
 * the reset process will begin, and once it finishes, this bit will be self
 * cleared. Software can determine that the reset has finished once this bit is
 * cleared. Software can also configure SRC to generate interrupt once the software
 * has finished. Please refer to SRC_SISR register for details. The reset process
 * will involve 8 open_vg cycles before negating the open_vg reset, to allow reset
 * assertion to propagate into open_vg.
 *
 * Values:
 * - 0 - do not assert open_vg reset
 * - 1 - assert open_vg reset
 */
/*@{*/
#define BP_SRC_SCR_sw_open_vg_rst (4U)     /*!< Bit position for SRC_SCR_sw_open_vg_rst. */
#define BM_SRC_SCR_sw_open_vg_rst (0x00000010U) /*!< Bit mask for SRC_SCR_sw_open_vg_rst. */
#define BS_SRC_SCR_sw_open_vg_rst (1U)     /*!< Bit field size in bits for SRC_SCR_sw_open_vg_rst. */

/*! @brief Read current value of the SRC_SCR_sw_open_vg_rst field. */
#define BR_SRC_SCR_sw_open_vg_rst(x) (HW_SRC_SCR(x).B.sw_open_vg_rst)

/*! @brief Format value for bitfield SRC_SCR_sw_open_vg_rst. */
#define BF_SRC_SCR_sw_open_vg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_sw_open_vg_rst) & BM_SRC_SCR_sw_open_vg_rst)

/*! @brief Set the sw_open_vg_rst field to a new value. */
#define BW_SRC_SCR_sw_open_vg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_sw_open_vg_rst) | BF_SRC_SCR_sw_open_vg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field warm_rst_bypass_count[6:5] (RW)
 *
 * Defines the XTALI cycles to count before bypassing the MMDC acknowledge for
 * WARM reset. If the MMDC acknowledge will not be asserted before this counter
 * has elapsed, then a COLD reset will be initiated.
 *
 * Values:
 * - 00 - Counter not to be used - system will wait until MMDC acknowledge until
 *     it is asserted.
 * - 01 - Wait 16 XTALI cycles before changing WARM reset to a COLD reset.
 * - 10 - Wait 32 XTALI cycles before changing WARM reset to a COLD reset.
 * - 11 - Wait 64 XTALI cycles before changing WARM reset to a COLD reset
 */
/*@{*/
#define BP_SRC_SCR_warm_rst_bypass_count (5U) /*!< Bit position for SRC_SCR_warm_rst_bypass_count. */
#define BM_SRC_SCR_warm_rst_bypass_count (0x00000060U) /*!< Bit mask for SRC_SCR_warm_rst_bypass_count. */
#define BS_SRC_SCR_warm_rst_bypass_count (2U) /*!< Bit field size in bits for SRC_SCR_warm_rst_bypass_count. */

/*! @brief Read current value of the SRC_SCR_warm_rst_bypass_count field. */
#define BR_SRC_SCR_warm_rst_bypass_count(x) (HW_SRC_SCR(x).B.warm_rst_bypass_count)

/*! @brief Format value for bitfield SRC_SCR_warm_rst_bypass_count. */
#define BF_SRC_SCR_warm_rst_bypass_count(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_warm_rst_bypass_count) & BM_SRC_SCR_warm_rst_bypass_count)

/*! @brief Set the warm_rst_bypass_count field to a new value. */
#define BW_SRC_SCR_warm_rst_bypass_count(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_warm_rst_bypass_count) | BF_SRC_SCR_warm_rst_bypass_count(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field mask_wdog_rst[10:7] (RW)
 *
 * Mask wdog_rst_b source. If these 4 bits are coded from A to 5 then, the
 * wdog_rst_b input to SRC will be masked and the wdog_rst_b will not create a reset
 * to the chip. During the time the WDOG event is masked using SRC logic, it is
 * likely that the WDOG Reset Status Register (WRSR) bit 1 (which indicates a WDOG
 * timeout event) will get asserted. software / OS developer must prepare for
 * this case. Re-enabling the WDOG is possible, by un-masking it in SRC, though it
 * must be preceded by servicing the WDOG. However, for the case that the event
 * has been asserted, the status bit (WRSR bit-1) will remain asserted, regardless
 * of servicing the WDOG module. (Hardware reset is the only way to cause the
 * de-assertion of that bit). any other code will be coded to 1010 i.e. wdog_rst_b
 * is not masked
 *
 * Values:
 * - 0101 - wdog_rst_b is masked
 * - 1010 - wdog_rst_b is not masked (default)
 */
/*@{*/
#define BP_SRC_SCR_mask_wdog_rst (7U)      /*!< Bit position for SRC_SCR_mask_wdog_rst. */
#define BM_SRC_SCR_mask_wdog_rst (0x00000780U) /*!< Bit mask for SRC_SCR_mask_wdog_rst. */
#define BS_SRC_SCR_mask_wdog_rst (4U)      /*!< Bit field size in bits for SRC_SCR_mask_wdog_rst. */

/*! @brief Read current value of the SRC_SCR_mask_wdog_rst field. */
#define BR_SRC_SCR_mask_wdog_rst(x) (HW_SRC_SCR(x).B.mask_wdog_rst)

/*! @brief Format value for bitfield SRC_SCR_mask_wdog_rst. */
#define BF_SRC_SCR_mask_wdog_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_mask_wdog_rst) & BM_SRC_SCR_mask_wdog_rst)

/*! @brief Set the mask_wdog_rst field to a new value. */
#define BW_SRC_SCR_mask_wdog_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_mask_wdog_rst) | BF_SRC_SCR_mask_wdog_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field eim_rst[11] (RW)
 *
 * EIM reset is needed in order to reconfigure the eim chip select. The software
 * reset bit must de-asserted. The eim chip select configuration should be
 * updated. The software bit must be re-asserted since this is not self-refresh.
 */
/*@{*/
#define BP_SRC_SCR_eim_rst   (11U)         /*!< Bit position for SRC_SCR_eim_rst. */
#define BM_SRC_SCR_eim_rst   (0x00000800U) /*!< Bit mask for SRC_SCR_eim_rst. */
#define BS_SRC_SCR_eim_rst   (1U)          /*!< Bit field size in bits for SRC_SCR_eim_rst. */

/*! @brief Read current value of the SRC_SCR_eim_rst field. */
#define BR_SRC_SCR_eim_rst(x) (HW_SRC_SCR(x).B.eim_rst)

/*! @brief Format value for bitfield SRC_SCR_eim_rst. */
#define BF_SRC_SCR_eim_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_eim_rst) & BM_SRC_SCR_eim_rst)

/*! @brief Set the eim_rst field to a new value. */
#define BW_SRC_SCR_eim_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_eim_rst) | BF_SRC_SCR_eim_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field sw_ipu2_rst[12] (RW)
 *
 * Software reset for ipu2 This is a self clearing bit. Once it is set to 1, the
 * reset process will begin, and once it finishes, this bit will be self
 * cleared. Software can determine that the reset has finished once this bit is cleared.
 * Software can also configure SRC to generate interrupt once the software has
 * finished. Please refer to SRC_SISR register for details.
 *
 * Values:
 * - 0 - do not assert ipu2 reset
 * - 1 - assert ipu2 reset
 */
/*@{*/
#define BP_SRC_SCR_sw_ipu2_rst (12U)       /*!< Bit position for SRC_SCR_sw_ipu2_rst. */
#define BM_SRC_SCR_sw_ipu2_rst (0x00001000U) /*!< Bit mask for SRC_SCR_sw_ipu2_rst. */
#define BS_SRC_SCR_sw_ipu2_rst (1U)        /*!< Bit field size in bits for SRC_SCR_sw_ipu2_rst. */

/*! @brief Read current value of the SRC_SCR_sw_ipu2_rst field. */
#define BR_SRC_SCR_sw_ipu2_rst(x) (HW_SRC_SCR(x).B.sw_ipu2_rst)

/*! @brief Format value for bitfield SRC_SCR_sw_ipu2_rst. */
#define BF_SRC_SCR_sw_ipu2_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_sw_ipu2_rst) & BM_SRC_SCR_sw_ipu2_rst)

/*! @brief Set the sw_ipu2_rst field to a new value. */
#define BW_SRC_SCR_sw_ipu2_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_sw_ipu2_rst) | BF_SRC_SCR_sw_ipu2_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core0_rst[13] (RW)
 *
 * Software reset for core0 only. This is a self clearing bit. Once it is set to
 * 1, the reset process will begin, and once it finishes, this bit will be self
 * cleared.
 *
 * Values:
 * - 0 - do not assert core0 reset
 * - 1 - assert core0 reset
 */
/*@{*/
#define BP_SRC_SCR_core0_rst (13U)         /*!< Bit position for SRC_SCR_core0_rst. */
#define BM_SRC_SCR_core0_rst (0x00002000U) /*!< Bit mask for SRC_SCR_core0_rst. */
#define BS_SRC_SCR_core0_rst (1U)          /*!< Bit field size in bits for SRC_SCR_core0_rst. */

/*! @brief Read current value of the SRC_SCR_core0_rst field. */
#define BR_SRC_SCR_core0_rst(x) (HW_SRC_SCR(x).B.core0_rst)

/*! @brief Format value for bitfield SRC_SCR_core0_rst. */
#define BF_SRC_SCR_core0_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core0_rst) & BM_SRC_SCR_core0_rst)

/*! @brief Set the core0_rst field to a new value. */
#define BW_SRC_SCR_core0_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core0_rst) | BF_SRC_SCR_core0_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core1_rst[14] (RW)
 *
 * Software reset for core1 only. This is a self clearing bit. Once it is set to
 * 1, the reset process will begin, and once it finishes, this bit will be self
 * cleared.
 *
 * Values:
 * - 0 - do not assert core1 reset
 * - 1 - assert core1 reset
 */
/*@{*/
#define BP_SRC_SCR_core1_rst (14U)         /*!< Bit position for SRC_SCR_core1_rst. */
#define BM_SRC_SCR_core1_rst (0x00004000U) /*!< Bit mask for SRC_SCR_core1_rst. */
#define BS_SRC_SCR_core1_rst (1U)          /*!< Bit field size in bits for SRC_SCR_core1_rst. */

/*! @brief Read current value of the SRC_SCR_core1_rst field. */
#define BR_SRC_SCR_core1_rst(x) (HW_SRC_SCR(x).B.core1_rst)

/*! @brief Format value for bitfield SRC_SCR_core1_rst. */
#define BF_SRC_SCR_core1_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core1_rst) & BM_SRC_SCR_core1_rst)

/*! @brief Set the core1_rst field to a new value. */
#define BW_SRC_SCR_core1_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core1_rst) | BF_SRC_SCR_core1_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core2_rst[15] (RW)
 *
 * Software reset for core2 only. This is a self clearing bit. Once it is set to
 * 1, the reset process will begin, and once it finishes, this bit will be self
 * cleared.
 *
 * Values:
 * - 0 - do not assert core2 reset
 * - 1 - assert core2 reset
 */
/*@{*/
#define BP_SRC_SCR_core2_rst (15U)         /*!< Bit position for SRC_SCR_core2_rst. */
#define BM_SRC_SCR_core2_rst (0x00008000U) /*!< Bit mask for SRC_SCR_core2_rst. */
#define BS_SRC_SCR_core2_rst (1U)          /*!< Bit field size in bits for SRC_SCR_core2_rst. */

/*! @brief Read current value of the SRC_SCR_core2_rst field. */
#define BR_SRC_SCR_core2_rst(x) (HW_SRC_SCR(x).B.core2_rst)

/*! @brief Format value for bitfield SRC_SCR_core2_rst. */
#define BF_SRC_SCR_core2_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core2_rst) & BM_SRC_SCR_core2_rst)

/*! @brief Set the core2_rst field to a new value. */
#define BW_SRC_SCR_core2_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core2_rst) | BF_SRC_SCR_core2_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core3_rst[16] (RW)
 *
 * Software reset for core3 only. This is a self clearing bit. Once it is set to
 * 1, the reset process will begin, and once it finishes, this bit will be self
 * cleared.
 *
 * Values:
 * - 0 - do not assert core3 reset
 * - 1 - assert core3 reset
 */
/*@{*/
#define BP_SRC_SCR_core3_rst (16U)         /*!< Bit position for SRC_SCR_core3_rst. */
#define BM_SRC_SCR_core3_rst (0x00010000U) /*!< Bit mask for SRC_SCR_core3_rst. */
#define BS_SRC_SCR_core3_rst (1U)          /*!< Bit field size in bits for SRC_SCR_core3_rst. */

/*! @brief Read current value of the SRC_SCR_core3_rst field. */
#define BR_SRC_SCR_core3_rst(x) (HW_SRC_SCR(x).B.core3_rst)

/*! @brief Format value for bitfield SRC_SCR_core3_rst. */
#define BF_SRC_SCR_core3_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core3_rst) & BM_SRC_SCR_core3_rst)

/*! @brief Set the core3_rst field to a new value. */
#define BW_SRC_SCR_core3_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core3_rst) | BF_SRC_SCR_core3_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core0_dbg_rst[17] (RW)
 *
 * Software reset for core0 debug only. This is a self clearing bit. Once it is
 * set to 1, the reset process will begin, and once it finishes, this bit will be
 * self cleared.
 *
 * Values:
 * - 0 - do not assert core0 debug reset
 * - 1 - assert core0 debug reset
 */
/*@{*/
#define BP_SRC_SCR_core0_dbg_rst (17U)     /*!< Bit position for SRC_SCR_core0_dbg_rst. */
#define BM_SRC_SCR_core0_dbg_rst (0x00020000U) /*!< Bit mask for SRC_SCR_core0_dbg_rst. */
#define BS_SRC_SCR_core0_dbg_rst (1U)      /*!< Bit field size in bits for SRC_SCR_core0_dbg_rst. */

/*! @brief Read current value of the SRC_SCR_core0_dbg_rst field. */
#define BR_SRC_SCR_core0_dbg_rst(x) (HW_SRC_SCR(x).B.core0_dbg_rst)

/*! @brief Format value for bitfield SRC_SCR_core0_dbg_rst. */
#define BF_SRC_SCR_core0_dbg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core0_dbg_rst) & BM_SRC_SCR_core0_dbg_rst)

/*! @brief Set the core0_dbg_rst field to a new value. */
#define BW_SRC_SCR_core0_dbg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core0_dbg_rst) | BF_SRC_SCR_core0_dbg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core1_dbg_rst[18] (RW)
 *
 * Software reset for core1 debug only. This is a self clearing bit. Once it is
 * set to 1, the reset process will begin, and once it finishes, this bit will be
 * self cleared.
 *
 * Values:
 * - 0 - do not assert core1 debug reset
 * - 1 - assert core1 debug reset
 */
/*@{*/
#define BP_SRC_SCR_core1_dbg_rst (18U)     /*!< Bit position for SRC_SCR_core1_dbg_rst. */
#define BM_SRC_SCR_core1_dbg_rst (0x00040000U) /*!< Bit mask for SRC_SCR_core1_dbg_rst. */
#define BS_SRC_SCR_core1_dbg_rst (1U)      /*!< Bit field size in bits for SRC_SCR_core1_dbg_rst. */

/*! @brief Read current value of the SRC_SCR_core1_dbg_rst field. */
#define BR_SRC_SCR_core1_dbg_rst(x) (HW_SRC_SCR(x).B.core1_dbg_rst)

/*! @brief Format value for bitfield SRC_SCR_core1_dbg_rst. */
#define BF_SRC_SCR_core1_dbg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core1_dbg_rst) & BM_SRC_SCR_core1_dbg_rst)

/*! @brief Set the core1_dbg_rst field to a new value. */
#define BW_SRC_SCR_core1_dbg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core1_dbg_rst) | BF_SRC_SCR_core1_dbg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core2_dbg_rst[19] (RW)
 *
 * Software reset for core2 debug only. This is a self clearing bit. Once it is
 * set to 1, the reset process will begin, and once it finishes, this bit will be
 * self cleared.
 *
 * Values:
 * - 0 - do not assert core2 debug reset
 * - 1 - assert core2 debug reset
 */
/*@{*/
#define BP_SRC_SCR_core2_dbg_rst (19U)     /*!< Bit position for SRC_SCR_core2_dbg_rst. */
#define BM_SRC_SCR_core2_dbg_rst (0x00080000U) /*!< Bit mask for SRC_SCR_core2_dbg_rst. */
#define BS_SRC_SCR_core2_dbg_rst (1U)      /*!< Bit field size in bits for SRC_SCR_core2_dbg_rst. */

/*! @brief Read current value of the SRC_SCR_core2_dbg_rst field. */
#define BR_SRC_SCR_core2_dbg_rst(x) (HW_SRC_SCR(x).B.core2_dbg_rst)

/*! @brief Format value for bitfield SRC_SCR_core2_dbg_rst. */
#define BF_SRC_SCR_core2_dbg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core2_dbg_rst) & BM_SRC_SCR_core2_dbg_rst)

/*! @brief Set the core2_dbg_rst field to a new value. */
#define BW_SRC_SCR_core2_dbg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core2_dbg_rst) | BF_SRC_SCR_core2_dbg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core3_dbg_rst[20] (RW)
 *
 * Software reset for core3 debug only. This is a self clearing bit. Once it is
 * set to 1, the reset process will begin, and once it finishes, this bit will be
 * self cleared.
 *
 * Values:
 * - 0 - do not assert core3 debug reset
 * - 1 - assert core3 debug reset
 */
/*@{*/
#define BP_SRC_SCR_core3_dbg_rst (20U)     /*!< Bit position for SRC_SCR_core3_dbg_rst. */
#define BM_SRC_SCR_core3_dbg_rst (0x00100000U) /*!< Bit mask for SRC_SCR_core3_dbg_rst. */
#define BS_SRC_SCR_core3_dbg_rst (1U)      /*!< Bit field size in bits for SRC_SCR_core3_dbg_rst. */

/*! @brief Read current value of the SRC_SCR_core3_dbg_rst field. */
#define BR_SRC_SCR_core3_dbg_rst(x) (HW_SRC_SCR(x).B.core3_dbg_rst)

/*! @brief Format value for bitfield SRC_SCR_core3_dbg_rst. */
#define BF_SRC_SCR_core3_dbg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core3_dbg_rst) & BM_SRC_SCR_core3_dbg_rst)

/*! @brief Set the core3_dbg_rst field to a new value. */
#define BW_SRC_SCR_core3_dbg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core3_dbg_rst) | BF_SRC_SCR_core3_dbg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field cores_dbg_rst[21] (RW)
 *
 * Software reset for debug of arm platform only. This is a self clearing bit.
 * Once it is set to 1, the reset process will begin, and once it finishes, this
 * bit will be self cleared.
 *
 * Values:
 * - 0 - do not assert arm platform debug reset
 * - 1 - assert arm platform debug reset
 */
/*@{*/
#define BP_SRC_SCR_cores_dbg_rst (21U)     /*!< Bit position for SRC_SCR_cores_dbg_rst. */
#define BM_SRC_SCR_cores_dbg_rst (0x00200000U) /*!< Bit mask for SRC_SCR_cores_dbg_rst. */
#define BS_SRC_SCR_cores_dbg_rst (1U)      /*!< Bit field size in bits for SRC_SCR_cores_dbg_rst. */

/*! @brief Read current value of the SRC_SCR_cores_dbg_rst field. */
#define BR_SRC_SCR_cores_dbg_rst(x) (HW_SRC_SCR(x).B.cores_dbg_rst)

/*! @brief Format value for bitfield SRC_SCR_cores_dbg_rst. */
#define BF_SRC_SCR_cores_dbg_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_cores_dbg_rst) & BM_SRC_SCR_cores_dbg_rst)

/*! @brief Set the cores_dbg_rst field to a new value. */
#define BW_SRC_SCR_cores_dbg_rst(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_cores_dbg_rst) | BF_SRC_SCR_cores_dbg_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core1_enable[22] (RW)
 *
 * core1 enable. core0 cannot be disabled
 *
 * Values:
 * - 0 - core1 is disabled
 * - 1 - core1 is enabled
 */
/*@{*/
#define BP_SRC_SCR_core1_enable (22U)      /*!< Bit position for SRC_SCR_core1_enable. */
#define BM_SRC_SCR_core1_enable (0x00400000U) /*!< Bit mask for SRC_SCR_core1_enable. */
#define BS_SRC_SCR_core1_enable (1U)       /*!< Bit field size in bits for SRC_SCR_core1_enable. */

/*! @brief Read current value of the SRC_SCR_core1_enable field. */
#define BR_SRC_SCR_core1_enable(x) (HW_SRC_SCR(x).B.core1_enable)

/*! @brief Format value for bitfield SRC_SCR_core1_enable. */
#define BF_SRC_SCR_core1_enable(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core1_enable) & BM_SRC_SCR_core1_enable)

/*! @brief Set the core1_enable field to a new value. */
#define BW_SRC_SCR_core1_enable(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core1_enable) | BF_SRC_SCR_core1_enable(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core2_enable[23] (RW)
 *
 * core2 enable. core0 cannot be disabled
 *
 * Values:
 * - 0 - core2 is disabled
 * - 1 - core2 is enabled
 */
/*@{*/
#define BP_SRC_SCR_core2_enable (23U)      /*!< Bit position for SRC_SCR_core2_enable. */
#define BM_SRC_SCR_core2_enable (0x00800000U) /*!< Bit mask for SRC_SCR_core2_enable. */
#define BS_SRC_SCR_core2_enable (1U)       /*!< Bit field size in bits for SRC_SCR_core2_enable. */

/*! @brief Read current value of the SRC_SCR_core2_enable field. */
#define BR_SRC_SCR_core2_enable(x) (HW_SRC_SCR(x).B.core2_enable)

/*! @brief Format value for bitfield SRC_SCR_core2_enable. */
#define BF_SRC_SCR_core2_enable(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core2_enable) & BM_SRC_SCR_core2_enable)

/*! @brief Set the core2_enable field to a new value. */
#define BW_SRC_SCR_core2_enable(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core2_enable) | BF_SRC_SCR_core2_enable(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field core3_enable[24] (RW)
 *
 * core3 enable. core0 cannot be disabled
 *
 * Values:
 * - 0 - core3 is disabled
 * - 1 - core3 is enabled
 */
/*@{*/
#define BP_SRC_SCR_core3_enable (24U)      /*!< Bit position for SRC_SCR_core3_enable. */
#define BM_SRC_SCR_core3_enable (0x01000000U) /*!< Bit mask for SRC_SCR_core3_enable. */
#define BS_SRC_SCR_core3_enable (1U)       /*!< Bit field size in bits for SRC_SCR_core3_enable. */

/*! @brief Read current value of the SRC_SCR_core3_enable field. */
#define BR_SRC_SCR_core3_enable(x) (HW_SRC_SCR(x).B.core3_enable)

/*! @brief Format value for bitfield SRC_SCR_core3_enable. */
#define BF_SRC_SCR_core3_enable(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_core3_enable) & BM_SRC_SCR_core3_enable)

/*! @brief Set the core3_enable field to a new value. */
#define BW_SRC_SCR_core3_enable(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_core3_enable) | BF_SRC_SCR_core3_enable(v)))
/*@}*/

/*!
 * @name Register SRC_SCR, field dbg_rst_msk_pg[25] (RW)
 *
 * Do not assert debug resets after power gating event of core
 *
 * Values:
 * - 0 - do not mask core debug resets (debug resets will be asserted after
 *     power gating event)
 * - 1 - mask core debug resets (debug resets won't be asserted after power
 *     gating event)
 */
/*@{*/
#define BP_SRC_SCR_dbg_rst_msk_pg (25U)    /*!< Bit position for SRC_SCR_dbg_rst_msk_pg. */
#define BM_SRC_SCR_dbg_rst_msk_pg (0x02000000U) /*!< Bit mask for SRC_SCR_dbg_rst_msk_pg. */
#define BS_SRC_SCR_dbg_rst_msk_pg (1U)     /*!< Bit field size in bits for SRC_SCR_dbg_rst_msk_pg. */

/*! @brief Read current value of the SRC_SCR_dbg_rst_msk_pg field. */
#define BR_SRC_SCR_dbg_rst_msk_pg(x) (HW_SRC_SCR(x).B.dbg_rst_msk_pg)

/*! @brief Format value for bitfield SRC_SCR_dbg_rst_msk_pg. */
#define BF_SRC_SCR_dbg_rst_msk_pg(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SCR_dbg_rst_msk_pg) & BM_SRC_SCR_dbg_rst_msk_pg)

/*! @brief Set the dbg_rst_msk_pg field to a new value. */
#define BW_SRC_SCR_dbg_rst_msk_pg(x, v) (HW_SRC_SCR_WR(x, (HW_SRC_SCR_RD(x) & ~BM_SRC_SCR_dbg_rst_msk_pg) | BF_SRC_SCR_dbg_rst_msk_pg(v)))
/*@}*/

/*******************************************************************************
 * HW_SRC_SBMR1 - SRC Boot Mode Register 1
 ******************************************************************************/

/*!
 * @brief HW_SRC_SBMR1 - SRC Boot Mode Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The Boot Mode register (SBMR) contains bits that reflect the status of Boot
 * Mode Pins of the chip. The reset value is configuration dependent (depending on
 * boot/fuses/IO pads).
 */
typedef union _hw_src_sbmr1
{
    uint32_t U;
    struct _hw_src_sbmr1_bitfields
    {
        uint32_t BOOT_CFG1 : 8;        /*!< [7:0]  */
        uint32_t BOOT_CFG2 : 8;        /*!< [15:8]  */
        uint32_t BOOT_CFG3 : 8;        /*!< [23:16]  */
        uint32_t BOOT_CFG4 : 8;        /*!< [31:24]  */
    } B;
} hw_src_sbmr1_t;

/*!
 * @name Constants and macros for entire SRC_SBMR1 register
 */
/*@{*/
#define HW_SRC_SBMR1_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_SRC_SBMR1(x)          (*(__I hw_src_sbmr1_t *) HW_SRC_SBMR1_ADDR(x))
#define HW_SRC_SBMR1_RD(x)       (HW_SRC_SBMR1(x).U)
/*@}*/

/*
 * Constants & macros for individual SRC_SBMR1 bitfields
 */

/*!
 * @name Register SRC_SBMR1, field BOOT_CFG1[7:0] (RO)
 *
 * Refer to fusemap.
 */
/*@{*/
#define BP_SRC_SBMR1_BOOT_CFG1 (0U)        /*!< Bit position for SRC_SBMR1_BOOT_CFG1. */
#define BM_SRC_SBMR1_BOOT_CFG1 (0x000000FFU) /*!< Bit mask for SRC_SBMR1_BOOT_CFG1. */
#define BS_SRC_SBMR1_BOOT_CFG1 (8U)        /*!< Bit field size in bits for SRC_SBMR1_BOOT_CFG1. */

/*! @brief Read current value of the SRC_SBMR1_BOOT_CFG1 field. */
#define BR_SRC_SBMR1_BOOT_CFG1(x) (HW_SRC_SBMR1(x).B.BOOT_CFG1)
/*@}*/

/*!
 * @name Register SRC_SBMR1, field BOOT_CFG2[15:8] (RO)
 *
 * Refer to fusemap.
 */
/*@{*/
#define BP_SRC_SBMR1_BOOT_CFG2 (8U)        /*!< Bit position for SRC_SBMR1_BOOT_CFG2. */
#define BM_SRC_SBMR1_BOOT_CFG2 (0x0000FF00U) /*!< Bit mask for SRC_SBMR1_BOOT_CFG2. */
#define BS_SRC_SBMR1_BOOT_CFG2 (8U)        /*!< Bit field size in bits for SRC_SBMR1_BOOT_CFG2. */

/*! @brief Read current value of the SRC_SBMR1_BOOT_CFG2 field. */
#define BR_SRC_SBMR1_BOOT_CFG2(x) (HW_SRC_SBMR1(x).B.BOOT_CFG2)
/*@}*/

/*!
 * @name Register SRC_SBMR1, field BOOT_CFG3[23:16] (RO)
 *
 * Refer to fusemap.
 */
/*@{*/
#define BP_SRC_SBMR1_BOOT_CFG3 (16U)       /*!< Bit position for SRC_SBMR1_BOOT_CFG3. */
#define BM_SRC_SBMR1_BOOT_CFG3 (0x00FF0000U) /*!< Bit mask for SRC_SBMR1_BOOT_CFG3. */
#define BS_SRC_SBMR1_BOOT_CFG3 (8U)        /*!< Bit field size in bits for SRC_SBMR1_BOOT_CFG3. */

/*! @brief Read current value of the SRC_SBMR1_BOOT_CFG3 field. */
#define BR_SRC_SBMR1_BOOT_CFG3(x) (HW_SRC_SBMR1(x).B.BOOT_CFG3)
/*@}*/

/*!
 * @name Register SRC_SBMR1, field BOOT_CFG4[31:24] (RO)
 *
 * Refer to fusemap.
 */
/*@{*/
#define BP_SRC_SBMR1_BOOT_CFG4 (24U)       /*!< Bit position for SRC_SBMR1_BOOT_CFG4. */
#define BM_SRC_SBMR1_BOOT_CFG4 (0xFF000000U) /*!< Bit mask for SRC_SBMR1_BOOT_CFG4. */
#define BS_SRC_SBMR1_BOOT_CFG4 (8U)        /*!< Bit field size in bits for SRC_SBMR1_BOOT_CFG4. */

/*! @brief Read current value of the SRC_SBMR1_BOOT_CFG4 field. */
#define BR_SRC_SBMR1_BOOT_CFG4(x) (HW_SRC_SBMR1(x).B.BOOT_CFG4)
/*@}*/

/*******************************************************************************
 * HW_SRC_SRSR - SRC Reset Status Register
 ******************************************************************************/

/*!
 * @brief HW_SRC_SRSR - SRC Reset Status Register (RW)
 *
 * Reset value: 0x00000001U
 *
 * The SRSR is a write to one clear register which records the source of the
 * reset events for the chip. The SRC reset status register will capture all the
 * reset sources that have occurred. This register is reset on ipp_reset_b. This is
 * a read-write register. For bit[6-0] - writing zero does not have any effect.
 * Writing one will clear the corresponding bit. The individual bits can be
 * cleared by writing one to that bit. When the system comes out of reset, this
 * register will have bits set corresponding to all the reset sources that occurred
 * during system reset. Software has to take care to clear this register by writing
 * one after every reset that occurs so that the register will contain the
 * information of recently occurred reset.
 */
typedef union _hw_src_srsr
{
    uint32_t U;
    struct _hw_src_srsr_bitfields
    {
        uint32_t ipp_reset_b : 1;      /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t csu_reset_b : 1;      /*!< [2]  */
        uint32_t ipp_user_reset_b : 1; /*!< [3]  */
        uint32_t wdog_rst_b : 1;       /*!< [4]  */
        uint32_t jtag_rst_b : 1;       /*!< [5]  */
        uint32_t jtag_sw_rst : 1;      /*!< [6]  */
        uint32_t RESERVED1 : 9;        /*!< [15:7]  */
        uint32_t warm_boot : 1;        /*!< [16]  */
        uint32_t RESERVED2 : 15;       /*!< [31:17]  */
    } B;
} hw_src_srsr_t;

/*!
 * @name Constants and macros for entire SRC_SRSR register
 */
/*@{*/
#define HW_SRC_SRSR_ADDR(x)      ((uintptr_t)(x) + 0x8U)

#define HW_SRC_SRSR(x)           (*(__IO hw_src_srsr_t *) HW_SRC_SRSR_ADDR(x))
#define HW_SRC_SRSR_RD(x)        (HW_SRC_SRSR(x).U)
#define HW_SRC_SRSR_WR(x, v)     (HW_SRC_SRSR(x).U = (v))
#define HW_SRC_SRSR_SET(x, v)    (HW_SRC_SRSR_WR(x, HW_SRC_SRSR_RD(x) |  (v)))
#define HW_SRC_SRSR_CLR(x, v)    (HW_SRC_SRSR_WR(x, HW_SRC_SRSR_RD(x) & ~(v)))
#define HW_SRC_SRSR_TOG(x, v)    (HW_SRC_SRSR_WR(x, HW_SRC_SRSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_SRSR bitfields
 */

/*!
 * @name Register SRC_SRSR, field ipp_reset_b[0] (W1C)
 *
 * Indicates whether reset was the result of ipp_reset_b pin (Power-up sequence)
 *
 * Values:
 * - 0 - Reset is not a result of ipp_reset_b pin.
 * - 1 - Reset is a result of ipp_reset_b pin.
 */
/*@{*/
#define BP_SRC_SRSR_ipp_reset_b (0U)       /*!< Bit position for SRC_SRSR_ipp_reset_b. */
#define BM_SRC_SRSR_ipp_reset_b (0x00000001U) /*!< Bit mask for SRC_SRSR_ipp_reset_b. */
#define BS_SRC_SRSR_ipp_reset_b (1U)       /*!< Bit field size in bits for SRC_SRSR_ipp_reset_b. */

/*! @brief Read current value of the SRC_SRSR_ipp_reset_b field. */
#define BR_SRC_SRSR_ipp_reset_b(x) (HW_SRC_SRSR(x).B.ipp_reset_b)

/*! @brief Format value for bitfield SRC_SRSR_ipp_reset_b. */
#define BF_SRC_SRSR_ipp_reset_b(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_ipp_reset_b) & BM_SRC_SRSR_ipp_reset_b)

/*! @brief Set the ipp_reset_b field to a new value. */
#define BW_SRC_SRSR_ipp_reset_b(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_ipp_reset_b(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field csu_reset_b[2] (W1C)
 *
 * Indicates whether the reset was the result of the csu_reset_b input. If case
 * the csu_reset_b occurred during a WARM reset process, during the phase that
 * ipg_clk is not available yet, then the occurrence of CSU reset will not be
 * reflected in this bit.
 *
 * Values:
 * - 0 - Reset is not a result of the csu_reset_b event.
 * - 1 - Reset is a result of the csu_reset_b event.
 */
/*@{*/
#define BP_SRC_SRSR_csu_reset_b (2U)       /*!< Bit position for SRC_SRSR_csu_reset_b. */
#define BM_SRC_SRSR_csu_reset_b (0x00000004U) /*!< Bit mask for SRC_SRSR_csu_reset_b. */
#define BS_SRC_SRSR_csu_reset_b (1U)       /*!< Bit field size in bits for SRC_SRSR_csu_reset_b. */

/*! @brief Read current value of the SRC_SRSR_csu_reset_b field. */
#define BR_SRC_SRSR_csu_reset_b(x) (HW_SRC_SRSR(x).B.csu_reset_b)

/*! @brief Format value for bitfield SRC_SRSR_csu_reset_b. */
#define BF_SRC_SRSR_csu_reset_b(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_csu_reset_b) & BM_SRC_SRSR_csu_reset_b)

/*! @brief Set the csu_reset_b field to a new value. */
#define BW_SRC_SRSR_csu_reset_b(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_csu_reset_b(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field ipp_user_reset_b[3] (W1C)
 *
 * Indicates whether the reset was the result of the ipp_user_reset_b qualified
 * reset.
 *
 * Values:
 * - 0 - Reset is not a result of the ipp_user_reset_b qualified as COLD reset
 *     event.
 * - 1 - Reset is a result of the ipp_user_reset_b qualified as COLD reset event.
 */
/*@{*/
#define BP_SRC_SRSR_ipp_user_reset_b (3U)  /*!< Bit position for SRC_SRSR_ipp_user_reset_b. */
#define BM_SRC_SRSR_ipp_user_reset_b (0x00000008U) /*!< Bit mask for SRC_SRSR_ipp_user_reset_b. */
#define BS_SRC_SRSR_ipp_user_reset_b (1U)  /*!< Bit field size in bits for SRC_SRSR_ipp_user_reset_b. */

/*! @brief Read current value of the SRC_SRSR_ipp_user_reset_b field. */
#define BR_SRC_SRSR_ipp_user_reset_b(x) (HW_SRC_SRSR(x).B.ipp_user_reset_b)

/*! @brief Format value for bitfield SRC_SRSR_ipp_user_reset_b. */
#define BF_SRC_SRSR_ipp_user_reset_b(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_ipp_user_reset_b) & BM_SRC_SRSR_ipp_user_reset_b)

/*! @brief Set the ipp_user_reset_b field to a new value. */
#define BW_SRC_SRSR_ipp_user_reset_b(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_ipp_user_reset_b(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field wdog_rst_b[4] (W1C)
 *
 * IC Watchdog Time-out reset. Indicates whether the reset was the result of the
 * watchdog time-out event.
 *
 * Values:
 * - 0 - Reset is not a result of the watchdog time-out event.
 * - 1 - Reset is a result of the watchdog time-out event.
 */
/*@{*/
#define BP_SRC_SRSR_wdog_rst_b (4U)        /*!< Bit position for SRC_SRSR_wdog_rst_b. */
#define BM_SRC_SRSR_wdog_rst_b (0x00000010U) /*!< Bit mask for SRC_SRSR_wdog_rst_b. */
#define BS_SRC_SRSR_wdog_rst_b (1U)        /*!< Bit field size in bits for SRC_SRSR_wdog_rst_b. */

/*! @brief Read current value of the SRC_SRSR_wdog_rst_b field. */
#define BR_SRC_SRSR_wdog_rst_b(x) (HW_SRC_SRSR(x).B.wdog_rst_b)

/*! @brief Format value for bitfield SRC_SRSR_wdog_rst_b. */
#define BF_SRC_SRSR_wdog_rst_b(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_wdog_rst_b) & BM_SRC_SRSR_wdog_rst_b)

/*! @brief Set the wdog_rst_b field to a new value. */
#define BW_SRC_SRSR_wdog_rst_b(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_wdog_rst_b(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field jtag_rst_b[5] (W1C)
 *
 * HIGH - Z JTAG reset. Indicates whether the reset was the result of HIGH-Z
 * reset from JTAG.
 *
 * Values:
 * - 0 - Reset is not a result of HIGH-Z reset from JTAG.
 * - 1 - Reset is a result of HIGH-Z reset from JTAG.
 */
/*@{*/
#define BP_SRC_SRSR_jtag_rst_b (5U)        /*!< Bit position for SRC_SRSR_jtag_rst_b. */
#define BM_SRC_SRSR_jtag_rst_b (0x00000020U) /*!< Bit mask for SRC_SRSR_jtag_rst_b. */
#define BS_SRC_SRSR_jtag_rst_b (1U)        /*!< Bit field size in bits for SRC_SRSR_jtag_rst_b. */

/*! @brief Read current value of the SRC_SRSR_jtag_rst_b field. */
#define BR_SRC_SRSR_jtag_rst_b(x) (HW_SRC_SRSR(x).B.jtag_rst_b)

/*! @brief Format value for bitfield SRC_SRSR_jtag_rst_b. */
#define BF_SRC_SRSR_jtag_rst_b(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_jtag_rst_b) & BM_SRC_SRSR_jtag_rst_b)

/*! @brief Set the jtag_rst_b field to a new value. */
#define BW_SRC_SRSR_jtag_rst_b(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_jtag_rst_b(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field jtag_sw_rst[6] (W1C)
 *
 * JTAG software reset. Indicates whether the reset was the result of software
 * reset from JTAG.
 *
 * Values:
 * - 0 - Reset is not a result of software reset from JTAG.
 * - 1 - Reset is a result of software reset from JTAG.
 */
/*@{*/
#define BP_SRC_SRSR_jtag_sw_rst (6U)       /*!< Bit position for SRC_SRSR_jtag_sw_rst. */
#define BM_SRC_SRSR_jtag_sw_rst (0x00000040U) /*!< Bit mask for SRC_SRSR_jtag_sw_rst. */
#define BS_SRC_SRSR_jtag_sw_rst (1U)       /*!< Bit field size in bits for SRC_SRSR_jtag_sw_rst. */

/*! @brief Read current value of the SRC_SRSR_jtag_sw_rst field. */
#define BR_SRC_SRSR_jtag_sw_rst(x) (HW_SRC_SRSR(x).B.jtag_sw_rst)

/*! @brief Format value for bitfield SRC_SRSR_jtag_sw_rst. */
#define BF_SRC_SRSR_jtag_sw_rst(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_jtag_sw_rst) & BM_SRC_SRSR_jtag_sw_rst)

/*! @brief Set the jtag_sw_rst field to a new value. */
#define BW_SRC_SRSR_jtag_sw_rst(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_jtag_sw_rst | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_rst_b)) | BF_SRC_SRSR_jtag_sw_rst(v)))
/*@}*/

/*!
 * @name Register SRC_SRSR, field warm_boot[16] (RW)
 *
 * WARM boot indication shows that WARM boot was initiated by software. This
 * indicates to the software that it saved the needed information in the memory
 * before initiating the WARM reset. In this case, software will set this bit to '1',
 * before initiating the WARM reset. The warm_boot bit should be used as
 * indication only after a warm_reset sequence. Software should clear this bit after
 * warm_reset to indicate that the next warm_reset is not performed with warm_boot.
 * Please refer to Reset Sequence and De-Assertion for details on warm_reset.
 *
 * Values:
 * - 0 - WARM boot process not initiated by software.
 * - 1 - WARM boot initiated by software.
 */
/*@{*/
#define BP_SRC_SRSR_warm_boot (16U)        /*!< Bit position for SRC_SRSR_warm_boot. */
#define BM_SRC_SRSR_warm_boot (0x00010000U) /*!< Bit mask for SRC_SRSR_warm_boot. */
#define BS_SRC_SRSR_warm_boot (1U)         /*!< Bit field size in bits for SRC_SRSR_warm_boot. */

/*! @brief Read current value of the SRC_SRSR_warm_boot field. */
#define BR_SRC_SRSR_warm_boot(x) (HW_SRC_SRSR(x).B.warm_boot)

/*! @brief Format value for bitfield SRC_SRSR_warm_boot. */
#define BF_SRC_SRSR_warm_boot(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SRSR_warm_boot) & BM_SRC_SRSR_warm_boot)

/*! @brief Set the warm_boot field to a new value. */
#define BW_SRC_SRSR_warm_boot(x, v) (HW_SRC_SRSR_WR(x, (HW_SRC_SRSR_RD(x) & ~(BM_SRC_SRSR_warm_boot | BM_SRC_SRSR_ipp_reset_b | BM_SRC_SRSR_csu_reset_b | BM_SRC_SRSR_ipp_user_reset_b | BM_SRC_SRSR_wdog_rst_b | BM_SRC_SRSR_jtag_rst_b | BM_SRC_SRSR_jtag_sw_rst)) | BF_SRC_SRSR_warm_boot(v)))
/*@}*/

/*******************************************************************************
 * HW_SRC_SISR - SRC Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_SRC_SISR - SRC Interrupt Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_src_sisr
{
    uint32_t U;
    struct _hw_src_sisr_bitfields
    {
        uint32_t gpu_passed_reset : 1; /*!< [0]  */
        uint32_t vpu_passed_reset : 1; /*!< [1]  */
        uint32_t ipu1_passed_reset : 1; /*!< [2]  */
        uint32_t open_vg_passed_reset : 1; /*!< [3]  */
        uint32_t ipu2_passed_reset : 1; /*!< [4]  */
        uint32_t core0_wdog_rst_req : 1; /*!< [5]  */
        uint32_t core1_wdog_rst_req : 1; /*!< [6]  */
        uint32_t core2_wdog_rst_req : 1; /*!< [7]  */
        uint32_t core3_wdog_rst_req : 1; /*!< [8]  */
        uint32_t RESERVED0 : 23;       /*!< [31:9]  */
    } B;
} hw_src_sisr_t;

/*!
 * @name Constants and macros for entire SRC_SISR register
 */
/*@{*/
#define HW_SRC_SISR_ADDR(x)      ((uintptr_t)(x) + 0x14U)

#define HW_SRC_SISR(x)           (*(__I hw_src_sisr_t *) HW_SRC_SISR_ADDR(x))
#define HW_SRC_SISR_RD(x)        (HW_SRC_SISR(x).U)
/*@}*/

/*
 * Constants & macros for individual SRC_SISR bitfields
 */

/*!
 * @name Register SRC_SISR, field gpu_passed_reset[0] (RO)
 *
 * Interrupt generated to indicate that GPU passed software reset and is ready
 * to be used
 *
 * Values:
 * - 0 - interrupt generated not due to GPU passed reset
 * - 1 - interrupt generated due to GPU passed reset
 */
/*@{*/
#define BP_SRC_SISR_gpu_passed_reset (0U)  /*!< Bit position for SRC_SISR_gpu_passed_reset. */
#define BM_SRC_SISR_gpu_passed_reset (0x00000001U) /*!< Bit mask for SRC_SISR_gpu_passed_reset. */
#define BS_SRC_SISR_gpu_passed_reset (1U)  /*!< Bit field size in bits for SRC_SISR_gpu_passed_reset. */

/*! @brief Read current value of the SRC_SISR_gpu_passed_reset field. */
#define BR_SRC_SISR_gpu_passed_reset(x) (HW_SRC_SISR(x).B.gpu_passed_reset)
/*@}*/

/*!
 * @name Register SRC_SISR, field vpu_passed_reset[1] (RO)
 *
 * Interrupt generated to indicate that VPU passed software reset and is ready
 * to be used
 *
 * Values:
 * - 0 - interrupt generated not due to VPU passed reset
 * - 1 - interrupt generated due to VPU passed reset
 */
/*@{*/
#define BP_SRC_SISR_vpu_passed_reset (1U)  /*!< Bit position for SRC_SISR_vpu_passed_reset. */
#define BM_SRC_SISR_vpu_passed_reset (0x00000002U) /*!< Bit mask for SRC_SISR_vpu_passed_reset. */
#define BS_SRC_SISR_vpu_passed_reset (1U)  /*!< Bit field size in bits for SRC_SISR_vpu_passed_reset. */

/*! @brief Read current value of the SRC_SISR_vpu_passed_reset field. */
#define BR_SRC_SISR_vpu_passed_reset(x) (HW_SRC_SISR(x).B.vpu_passed_reset)
/*@}*/

/*!
 * @name Register SRC_SISR, field ipu1_passed_reset[2] (RO)
 *
 * Interrupt generated to indicate that ipu passed software reset and is ready
 * to be used
 *
 * Values:
 * - 0 - interrupt generated not due to ipu passed reset
 * - 1 - interrupt generated due to ipu passed reset
 */
/*@{*/
#define BP_SRC_SISR_ipu1_passed_reset (2U) /*!< Bit position for SRC_SISR_ipu1_passed_reset. */
#define BM_SRC_SISR_ipu1_passed_reset (0x00000004U) /*!< Bit mask for SRC_SISR_ipu1_passed_reset. */
#define BS_SRC_SISR_ipu1_passed_reset (1U) /*!< Bit field size in bits for SRC_SISR_ipu1_passed_reset. */

/*! @brief Read current value of the SRC_SISR_ipu1_passed_reset field. */
#define BR_SRC_SISR_ipu1_passed_reset(x) (HW_SRC_SISR(x).B.ipu1_passed_reset)
/*@}*/

/*!
 * @name Register SRC_SISR, field open_vg_passed_reset[3] (RO)
 *
 * Interrupt generated to indicate that open_vg passed software reset and is
 * ready to be used
 *
 * Values:
 * - 0 - interrupt generated not due to open_vg passed reset
 * - 1 - interrupt generated due to open_vg passed reset
 */
/*@{*/
#define BP_SRC_SISR_open_vg_passed_reset (3U) /*!< Bit position for SRC_SISR_open_vg_passed_reset. */
#define BM_SRC_SISR_open_vg_passed_reset (0x00000008U) /*!< Bit mask for SRC_SISR_open_vg_passed_reset. */
#define BS_SRC_SISR_open_vg_passed_reset (1U) /*!< Bit field size in bits for SRC_SISR_open_vg_passed_reset. */

/*! @brief Read current value of the SRC_SISR_open_vg_passed_reset field. */
#define BR_SRC_SISR_open_vg_passed_reset(x) (HW_SRC_SISR(x).B.open_vg_passed_reset)
/*@}*/

/*!
 * @name Register SRC_SISR, field ipu2_passed_reset[4] (RO)
 *
 * Interrupt generated to indicate that ipu2 passed software reset and is ready
 * to be used
 *
 * Values:
 * - 0 - interrupt generated not due to ipu2 passed reset
 * - 1 - interrupt generated due to ipu2 passed reset
 */
/*@{*/
#define BP_SRC_SISR_ipu2_passed_reset (4U) /*!< Bit position for SRC_SISR_ipu2_passed_reset. */
#define BM_SRC_SISR_ipu2_passed_reset (0x00000010U) /*!< Bit mask for SRC_SISR_ipu2_passed_reset. */
#define BS_SRC_SISR_ipu2_passed_reset (1U) /*!< Bit field size in bits for SRC_SISR_ipu2_passed_reset. */

/*! @brief Read current value of the SRC_SISR_ipu2_passed_reset field. */
#define BR_SRC_SISR_ipu2_passed_reset(x) (HW_SRC_SISR(x).B.ipu2_passed_reset)
/*@}*/

/*!
 * @name Register SRC_SISR, field core0_wdog_rst_req[5] (RO)
 *
 * WDOG reset request from core0. Read-only status bit.
 */
/*@{*/
#define BP_SRC_SISR_core0_wdog_rst_req (5U) /*!< Bit position for SRC_SISR_core0_wdog_rst_req. */
#define BM_SRC_SISR_core0_wdog_rst_req (0x00000020U) /*!< Bit mask for SRC_SISR_core0_wdog_rst_req. */
#define BS_SRC_SISR_core0_wdog_rst_req (1U) /*!< Bit field size in bits for SRC_SISR_core0_wdog_rst_req. */

/*! @brief Read current value of the SRC_SISR_core0_wdog_rst_req field. */
#define BR_SRC_SISR_core0_wdog_rst_req(x) (HW_SRC_SISR(x).B.core0_wdog_rst_req)
/*@}*/

/*!
 * @name Register SRC_SISR, field core1_wdog_rst_req[6] (RO)
 *
 * WDOG reset request from core1. Read-only status bit.
 */
/*@{*/
#define BP_SRC_SISR_core1_wdog_rst_req (6U) /*!< Bit position for SRC_SISR_core1_wdog_rst_req. */
#define BM_SRC_SISR_core1_wdog_rst_req (0x00000040U) /*!< Bit mask for SRC_SISR_core1_wdog_rst_req. */
#define BS_SRC_SISR_core1_wdog_rst_req (1U) /*!< Bit field size in bits for SRC_SISR_core1_wdog_rst_req. */

/*! @brief Read current value of the SRC_SISR_core1_wdog_rst_req field. */
#define BR_SRC_SISR_core1_wdog_rst_req(x) (HW_SRC_SISR(x).B.core1_wdog_rst_req)
/*@}*/

/*!
 * @name Register SRC_SISR, field core2_wdog_rst_req[7] (RO)
 *
 * WDOG reset request from core2. Read-only status bit.
 */
/*@{*/
#define BP_SRC_SISR_core2_wdog_rst_req (7U) /*!< Bit position for SRC_SISR_core2_wdog_rst_req. */
#define BM_SRC_SISR_core2_wdog_rst_req (0x00000080U) /*!< Bit mask for SRC_SISR_core2_wdog_rst_req. */
#define BS_SRC_SISR_core2_wdog_rst_req (1U) /*!< Bit field size in bits for SRC_SISR_core2_wdog_rst_req. */

/*! @brief Read current value of the SRC_SISR_core2_wdog_rst_req field. */
#define BR_SRC_SISR_core2_wdog_rst_req(x) (HW_SRC_SISR(x).B.core2_wdog_rst_req)
/*@}*/

/*!
 * @name Register SRC_SISR, field core3_wdog_rst_req[8] (RO)
 *
 * WDOG reset request from core3. Read-only status bit.
 */
/*@{*/
#define BP_SRC_SISR_core3_wdog_rst_req (8U) /*!< Bit position for SRC_SISR_core3_wdog_rst_req. */
#define BM_SRC_SISR_core3_wdog_rst_req (0x00000100U) /*!< Bit mask for SRC_SISR_core3_wdog_rst_req. */
#define BS_SRC_SISR_core3_wdog_rst_req (1U) /*!< Bit field size in bits for SRC_SISR_core3_wdog_rst_req. */

/*! @brief Read current value of the SRC_SISR_core3_wdog_rst_req field. */
#define BR_SRC_SISR_core3_wdog_rst_req(x) (HW_SRC_SISR(x).B.core3_wdog_rst_req)
/*@}*/

/*******************************************************************************
 * HW_SRC_SIMR - SRC Interrupt Mask Register
 ******************************************************************************/

/*!
 * @brief HW_SRC_SIMR - SRC Interrupt Mask Register (RW)
 *
 * Reset value: 0x0000001FU
 */
typedef union _hw_src_simr
{
    uint32_t U;
    struct _hw_src_simr_bitfields
    {
        uint32_t mask_gpu_passed_reset : 1; /*!< [0]  */
        uint32_t mask_vpu_passed_reset : 1; /*!< [1]  */
        uint32_t mask_ipu_passed_reset : 1; /*!< [2]  */
        uint32_t mask_open_vg_passed_reset : 1; /*!< [3]  */
        uint32_t mask_ipu2_passed_reset : 1; /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_src_simr_t;

/*!
 * @name Constants and macros for entire SRC_SIMR register
 */
/*@{*/
#define HW_SRC_SIMR_ADDR(x)      ((uintptr_t)(x) + 0x18U)

#define HW_SRC_SIMR(x)           (*(__IO hw_src_simr_t *) HW_SRC_SIMR_ADDR(x))
#define HW_SRC_SIMR_RD(x)        (HW_SRC_SIMR(x).U)
#define HW_SRC_SIMR_WR(x, v)     (HW_SRC_SIMR(x).U = (v))
#define HW_SRC_SIMR_SET(x, v)    (HW_SRC_SIMR_WR(x, HW_SRC_SIMR_RD(x) |  (v)))
#define HW_SRC_SIMR_CLR(x, v)    (HW_SRC_SIMR_WR(x, HW_SRC_SIMR_RD(x) & ~(v)))
#define HW_SRC_SIMR_TOG(x, v)    (HW_SRC_SIMR_WR(x, HW_SRC_SIMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_SIMR bitfields
 */

/*!
 * @name Register SRC_SIMR, field mask_gpu_passed_reset[0] (RW)
 *
 * mask interrupt generation due to GPU passed reset
 *
 * Values:
 * - 0 - do not mask interrupt due to GPU passed reset - interrupt will be
 *     created
 * - 1 - mask interrupt due to GPU passed reset
 */
/*@{*/
#define BP_SRC_SIMR_mask_gpu_passed_reset (0U) /*!< Bit position for SRC_SIMR_mask_gpu_passed_reset. */
#define BM_SRC_SIMR_mask_gpu_passed_reset (0x00000001U) /*!< Bit mask for SRC_SIMR_mask_gpu_passed_reset. */
#define BS_SRC_SIMR_mask_gpu_passed_reset (1U) /*!< Bit field size in bits for SRC_SIMR_mask_gpu_passed_reset. */

/*! @brief Read current value of the SRC_SIMR_mask_gpu_passed_reset field. */
#define BR_SRC_SIMR_mask_gpu_passed_reset(x) (HW_SRC_SIMR(x).B.mask_gpu_passed_reset)

/*! @brief Format value for bitfield SRC_SIMR_mask_gpu_passed_reset. */
#define BF_SRC_SIMR_mask_gpu_passed_reset(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SIMR_mask_gpu_passed_reset) & BM_SRC_SIMR_mask_gpu_passed_reset)

/*! @brief Set the mask_gpu_passed_reset field to a new value. */
#define BW_SRC_SIMR_mask_gpu_passed_reset(x, v) (HW_SRC_SIMR_WR(x, (HW_SRC_SIMR_RD(x) & ~BM_SRC_SIMR_mask_gpu_passed_reset) | BF_SRC_SIMR_mask_gpu_passed_reset(v)))
/*@}*/

/*!
 * @name Register SRC_SIMR, field mask_vpu_passed_reset[1] (RW)
 *
 * mask interrupt generation due to VPU passed reset
 *
 * Values:
 * - 0 - do not mask interrupt due to VPU passed reset - interrupt will be
 *     created
 * - 1 - mask interrupt due to VPU passed reset
 */
/*@{*/
#define BP_SRC_SIMR_mask_vpu_passed_reset (1U) /*!< Bit position for SRC_SIMR_mask_vpu_passed_reset. */
#define BM_SRC_SIMR_mask_vpu_passed_reset (0x00000002U) /*!< Bit mask for SRC_SIMR_mask_vpu_passed_reset. */
#define BS_SRC_SIMR_mask_vpu_passed_reset (1U) /*!< Bit field size in bits for SRC_SIMR_mask_vpu_passed_reset. */

/*! @brief Read current value of the SRC_SIMR_mask_vpu_passed_reset field. */
#define BR_SRC_SIMR_mask_vpu_passed_reset(x) (HW_SRC_SIMR(x).B.mask_vpu_passed_reset)

/*! @brief Format value for bitfield SRC_SIMR_mask_vpu_passed_reset. */
#define BF_SRC_SIMR_mask_vpu_passed_reset(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SIMR_mask_vpu_passed_reset) & BM_SRC_SIMR_mask_vpu_passed_reset)

/*! @brief Set the mask_vpu_passed_reset field to a new value. */
#define BW_SRC_SIMR_mask_vpu_passed_reset(x, v) (HW_SRC_SIMR_WR(x, (HW_SRC_SIMR_RD(x) & ~BM_SRC_SIMR_mask_vpu_passed_reset) | BF_SRC_SIMR_mask_vpu_passed_reset(v)))
/*@}*/

/*!
 * @name Register SRC_SIMR, field mask_ipu_passed_reset[2] (RW)
 *
 * mask interrupt generation due to ipu passed reset
 *
 * Values:
 * - 0 - do not mask interrupt due to ipu passed reset - interrupt will be
 *     created
 * - 1 - mask interrupt due to ipu passed reset
 */
/*@{*/
#define BP_SRC_SIMR_mask_ipu_passed_reset (2U) /*!< Bit position for SRC_SIMR_mask_ipu_passed_reset. */
#define BM_SRC_SIMR_mask_ipu_passed_reset (0x00000004U) /*!< Bit mask for SRC_SIMR_mask_ipu_passed_reset. */
#define BS_SRC_SIMR_mask_ipu_passed_reset (1U) /*!< Bit field size in bits for SRC_SIMR_mask_ipu_passed_reset. */

/*! @brief Read current value of the SRC_SIMR_mask_ipu_passed_reset field. */
#define BR_SRC_SIMR_mask_ipu_passed_reset(x) (HW_SRC_SIMR(x).B.mask_ipu_passed_reset)

/*! @brief Format value for bitfield SRC_SIMR_mask_ipu_passed_reset. */
#define BF_SRC_SIMR_mask_ipu_passed_reset(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SIMR_mask_ipu_passed_reset) & BM_SRC_SIMR_mask_ipu_passed_reset)

/*! @brief Set the mask_ipu_passed_reset field to a new value. */
#define BW_SRC_SIMR_mask_ipu_passed_reset(x, v) (HW_SRC_SIMR_WR(x, (HW_SRC_SIMR_RD(x) & ~BM_SRC_SIMR_mask_ipu_passed_reset) | BF_SRC_SIMR_mask_ipu_passed_reset(v)))
/*@}*/

/*!
 * @name Register SRC_SIMR, field mask_open_vg_passed_reset[3] (RW)
 *
 * mask interrupt generation due to open_vg passed reset
 *
 * Values:
 * - 0 - do not mask interrupt due to open_vg passed reset - interrupt will be
 *     created
 * - 1 - mask interrupt due to open_vg passed reset
 */
/*@{*/
#define BP_SRC_SIMR_mask_open_vg_passed_reset (3U) /*!< Bit position for SRC_SIMR_mask_open_vg_passed_reset. */
#define BM_SRC_SIMR_mask_open_vg_passed_reset (0x00000008U) /*!< Bit mask for SRC_SIMR_mask_open_vg_passed_reset. */
#define BS_SRC_SIMR_mask_open_vg_passed_reset (1U) /*!< Bit field size in bits for SRC_SIMR_mask_open_vg_passed_reset. */

/*! @brief Read current value of the SRC_SIMR_mask_open_vg_passed_reset field. */
#define BR_SRC_SIMR_mask_open_vg_passed_reset(x) (HW_SRC_SIMR(x).B.mask_open_vg_passed_reset)

/*! @brief Format value for bitfield SRC_SIMR_mask_open_vg_passed_reset. */
#define BF_SRC_SIMR_mask_open_vg_passed_reset(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SIMR_mask_open_vg_passed_reset) & BM_SRC_SIMR_mask_open_vg_passed_reset)

/*! @brief Set the mask_open_vg_passed_reset field to a new value. */
#define BW_SRC_SIMR_mask_open_vg_passed_reset(x, v) (HW_SRC_SIMR_WR(x, (HW_SRC_SIMR_RD(x) & ~BM_SRC_SIMR_mask_open_vg_passed_reset) | BF_SRC_SIMR_mask_open_vg_passed_reset(v)))
/*@}*/

/*!
 * @name Register SRC_SIMR, field mask_ipu2_passed_reset[4] (RW)
 *
 * mask interrupt generation due to ipu2 passing reset
 *
 * Values:
 * - 0 - do not mask interrupt due to ipu2 passed reset - interrupt will be
 *     created
 * - 1 - mask interrupt due to ipu2 passed reset
 */
/*@{*/
#define BP_SRC_SIMR_mask_ipu2_passed_reset (4U) /*!< Bit position for SRC_SIMR_mask_ipu2_passed_reset. */
#define BM_SRC_SIMR_mask_ipu2_passed_reset (0x00000010U) /*!< Bit mask for SRC_SIMR_mask_ipu2_passed_reset. */
#define BS_SRC_SIMR_mask_ipu2_passed_reset (1U) /*!< Bit field size in bits for SRC_SIMR_mask_ipu2_passed_reset. */

/*! @brief Read current value of the SRC_SIMR_mask_ipu2_passed_reset field. */
#define BR_SRC_SIMR_mask_ipu2_passed_reset(x) (HW_SRC_SIMR(x).B.mask_ipu2_passed_reset)

/*! @brief Format value for bitfield SRC_SIMR_mask_ipu2_passed_reset. */
#define BF_SRC_SIMR_mask_ipu2_passed_reset(v) ((uint32_t)((uint32_t)(v) << BP_SRC_SIMR_mask_ipu2_passed_reset) & BM_SRC_SIMR_mask_ipu2_passed_reset)

/*! @brief Set the mask_ipu2_passed_reset field to a new value. */
#define BW_SRC_SIMR_mask_ipu2_passed_reset(x, v) (HW_SRC_SIMR_WR(x, (HW_SRC_SIMR_RD(x) & ~BM_SRC_SIMR_mask_ipu2_passed_reset) | BF_SRC_SIMR_mask_ipu2_passed_reset(v)))
/*@}*/

/*******************************************************************************
 * HW_SRC_SBMR2 - SRC Boot Mode Register 2
 ******************************************************************************/

/*!
 * @brief HW_SRC_SBMR2 - SRC Boot Mode Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The Boot Mode register (SBMR), contains bits that reflect the status of Boot
 * Mode Pins of the chip. The default values for those bits depends on the values
 * of pins/fuses during reset sequence, hence the question mark on their default
 * value.
 */
typedef union _hw_src_sbmr2
{
    uint32_t U;
    struct _hw_src_sbmr2_bitfields
    {
        uint32_t SEC_CONFIG : 2;       /*!< [1:0]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t DIR_BT_DIS : 1;       /*!< [3]  */
        uint32_t BT_FUSE_SEL : 1;      /*!< [4]  */
        uint32_t RESERVED1 : 19;       /*!< [23:5]  */
        uint32_t BMOD : 2;             /*!< [25:24]  */
        uint32_t RESERVED2 : 6;        /*!< [31:26]  */
    } B;
} hw_src_sbmr2_t;

/*!
 * @name Constants and macros for entire SRC_SBMR2 register
 */
/*@{*/
#define HW_SRC_SBMR2_ADDR(x)     ((uintptr_t)(x) + 0x1CU)

#define HW_SRC_SBMR2(x)          (*(__I hw_src_sbmr2_t *) HW_SRC_SBMR2_ADDR(x))
#define HW_SRC_SBMR2_RD(x)       (HW_SRC_SBMR2(x).U)
/*@}*/

/*
 * Constants & macros for individual SRC_SBMR2 bitfields
 */

/*!
 * @name Register SRC_SBMR2, field SEC_CONFIG[1:0] (RO)
 *
 * SECONFIG[1] shows the state of the SECONFIG[1] fuse. See Fusemap for
 * additional information on this fuse. SECONFIG[0] shows the state of the SECONFIG[0]
 * fuse. This fuse is shown as reserved in Fusemap (address 0x440[1]) because it
 * does not have a user-relevant function.
 */
/*@{*/
#define BP_SRC_SBMR2_SEC_CONFIG (0U)       /*!< Bit position for SRC_SBMR2_SEC_CONFIG. */
#define BM_SRC_SBMR2_SEC_CONFIG (0x00000003U) /*!< Bit mask for SRC_SBMR2_SEC_CONFIG. */
#define BS_SRC_SBMR2_SEC_CONFIG (2U)       /*!< Bit field size in bits for SRC_SBMR2_SEC_CONFIG. */

/*! @brief Read current value of the SRC_SBMR2_SEC_CONFIG field. */
#define BR_SRC_SBMR2_SEC_CONFIG(x) (HW_SRC_SBMR2(x).B.SEC_CONFIG)
/*@}*/

/*!
 * @name Register SRC_SBMR2, field DIR_BT_DIS[3] (RO)
 *
 * DIR_BT_DIS shows the state of the DIR_BT_DIS fuse. See Chapter 5, Fusemap for
 * additional information on this fuse.
 */
/*@{*/
#define BP_SRC_SBMR2_DIR_BT_DIS (3U)       /*!< Bit position for SRC_SBMR2_DIR_BT_DIS. */
#define BM_SRC_SBMR2_DIR_BT_DIS (0x00000008U) /*!< Bit mask for SRC_SBMR2_DIR_BT_DIS. */
#define BS_SRC_SBMR2_DIR_BT_DIS (1U)       /*!< Bit field size in bits for SRC_SBMR2_DIR_BT_DIS. */

/*! @brief Read current value of the SRC_SBMR2_DIR_BT_DIS field. */
#define BR_SRC_SBMR2_DIR_BT_DIS(x) (HW_SRC_SBMR2(x).B.DIR_BT_DIS)
/*@}*/

/*!
 * @name Register SRC_SBMR2, field BT_FUSE_SEL[4] (RO)
 *
 * BT_FUSE_SEL (connected to gpio bt_fuse_sel) shows the state of the
 * BT_FUSE_SEL fuse. See Fusemap for additional information on this fuse.
 */
/*@{*/
#define BP_SRC_SBMR2_BT_FUSE_SEL (4U)      /*!< Bit position for SRC_SBMR2_BT_FUSE_SEL. */
#define BM_SRC_SBMR2_BT_FUSE_SEL (0x00000010U) /*!< Bit mask for SRC_SBMR2_BT_FUSE_SEL. */
#define BS_SRC_SBMR2_BT_FUSE_SEL (1U)      /*!< Bit field size in bits for SRC_SBMR2_BT_FUSE_SEL. */

/*! @brief Read current value of the SRC_SBMR2_BT_FUSE_SEL field. */
#define BR_SRC_SBMR2_BT_FUSE_SEL(x) (HW_SRC_SBMR2(x).B.BT_FUSE_SEL)
/*@}*/

/*!
 * @name Register SRC_SBMR2, field BMOD[25:24] (RO)
 *
 * BMOD[1:0] shows the latched state of the BOOT_MODE1 and BOOT_MODE0 signals on
 * the rising edge of POR_B. See the Boot mode pin settings section of System
 * Boot.
 */
/*@{*/
#define BP_SRC_SBMR2_BMOD    (24U)         /*!< Bit position for SRC_SBMR2_BMOD. */
#define BM_SRC_SBMR2_BMOD    (0x03000000U) /*!< Bit mask for SRC_SBMR2_BMOD. */
#define BS_SRC_SBMR2_BMOD    (2U)          /*!< Bit field size in bits for SRC_SBMR2_BMOD. */

/*! @brief Read current value of the SRC_SBMR2_BMOD field. */
#define BR_SRC_SBMR2_BMOD(x) (HW_SRC_SBMR2(x).B.BMOD)
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR1 - SRC General Purpose Register 1
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR1 - SRC General Purpose Register 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr1
{
    uint32_t U;
    struct _hw_src_gpr1_bitfields
    {
        uint32_t PERSISTENT_ENTRY0 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr1_t;

/*!
 * @name Constants and macros for entire SRC_GPR1 register
 */
/*@{*/
#define HW_SRC_GPR1_ADDR(x)      ((uintptr_t)(x) + 0x20U)

#define HW_SRC_GPR1(x)           (*(__IO hw_src_gpr1_t *) HW_SRC_GPR1_ADDR(x))
#define HW_SRC_GPR1_RD(x)        (HW_SRC_GPR1(x).U)
#define HW_SRC_GPR1_WR(x, v)     (HW_SRC_GPR1(x).U = (v))
#define HW_SRC_GPR1_SET(x, v)    (HW_SRC_GPR1_WR(x, HW_SRC_GPR1_RD(x) |  (v)))
#define HW_SRC_GPR1_CLR(x, v)    (HW_SRC_GPR1_WR(x, HW_SRC_GPR1_RD(x) & ~(v)))
#define HW_SRC_GPR1_TOG(x, v)    (HW_SRC_GPR1_WR(x, HW_SRC_GPR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR1 bitfields
 */

/*!
 * @name Register SRC_GPR1, field PERSISTENT_ENTRY0[31:0] (RW)
 *
 * Holds entry function for core0 for waking-up from low power mode. The SRC
 * ensures that the register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR1_PERSISTENT_ENTRY0 (0U) /*!< Bit position for SRC_GPR1_PERSISTENT_ENTRY0. */
#define BM_SRC_GPR1_PERSISTENT_ENTRY0 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR1_PERSISTENT_ENTRY0. */
#define BS_SRC_GPR1_PERSISTENT_ENTRY0 (32U) /*!< Bit field size in bits for SRC_GPR1_PERSISTENT_ENTRY0. */

/*! @brief Read current value of the SRC_GPR1_PERSISTENT_ENTRY0 field. */
#define BR_SRC_GPR1_PERSISTENT_ENTRY0(x) (HW_SRC_GPR1(x).U)

/*! @brief Format value for bitfield SRC_GPR1_PERSISTENT_ENTRY0. */
#define BF_SRC_GPR1_PERSISTENT_ENTRY0(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR1_PERSISTENT_ENTRY0) & BM_SRC_GPR1_PERSISTENT_ENTRY0)

/*! @brief Set the PERSISTENT_ENTRY0 field to a new value. */
#define BW_SRC_GPR1_PERSISTENT_ENTRY0(x, v) (HW_SRC_GPR1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR2 - SRC General Purpose Register 2
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR2 - SRC General Purpose Register 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr2
{
    uint32_t U;
    struct _hw_src_gpr2_bitfields
    {
        uint32_t PERSISTENT_ARG0 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr2_t;

/*!
 * @name Constants and macros for entire SRC_GPR2 register
 */
/*@{*/
#define HW_SRC_GPR2_ADDR(x)      ((uintptr_t)(x) + 0x24U)

#define HW_SRC_GPR2(x)           (*(__IO hw_src_gpr2_t *) HW_SRC_GPR2_ADDR(x))
#define HW_SRC_GPR2_RD(x)        (HW_SRC_GPR2(x).U)
#define HW_SRC_GPR2_WR(x, v)     (HW_SRC_GPR2(x).U = (v))
#define HW_SRC_GPR2_SET(x, v)    (HW_SRC_GPR2_WR(x, HW_SRC_GPR2_RD(x) |  (v)))
#define HW_SRC_GPR2_CLR(x, v)    (HW_SRC_GPR2_WR(x, HW_SRC_GPR2_RD(x) & ~(v)))
#define HW_SRC_GPR2_TOG(x, v)    (HW_SRC_GPR2_WR(x, HW_SRC_GPR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR2 bitfields
 */

/*!
 * @name Register SRC_GPR2, field PERSISTENT_ARG0[31:0] (RW)
 *
 * Holds argument of entry function for core0 for waking-up from low power mode.
 * The SRC ensures that the register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR2_PERSISTENT_ARG0 (0U)   /*!< Bit position for SRC_GPR2_PERSISTENT_ARG0. */
#define BM_SRC_GPR2_PERSISTENT_ARG0 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR2_PERSISTENT_ARG0. */
#define BS_SRC_GPR2_PERSISTENT_ARG0 (32U)  /*!< Bit field size in bits for SRC_GPR2_PERSISTENT_ARG0. */

/*! @brief Read current value of the SRC_GPR2_PERSISTENT_ARG0 field. */
#define BR_SRC_GPR2_PERSISTENT_ARG0(x) (HW_SRC_GPR2(x).U)

/*! @brief Format value for bitfield SRC_GPR2_PERSISTENT_ARG0. */
#define BF_SRC_GPR2_PERSISTENT_ARG0(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR2_PERSISTENT_ARG0) & BM_SRC_GPR2_PERSISTENT_ARG0)

/*! @brief Set the PERSISTENT_ARG0 field to a new value. */
#define BW_SRC_GPR2_PERSISTENT_ARG0(x, v) (HW_SRC_GPR2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR3 - SRC General Purpose Register 3
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR3 - SRC General Purpose Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr3
{
    uint32_t U;
    struct _hw_src_gpr3_bitfields
    {
        uint32_t PERSISTENT_ENTRY1 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr3_t;

/*!
 * @name Constants and macros for entire SRC_GPR3 register
 */
/*@{*/
#define HW_SRC_GPR3_ADDR(x)      ((uintptr_t)(x) + 0x28U)

#define HW_SRC_GPR3(x)           (*(__IO hw_src_gpr3_t *) HW_SRC_GPR3_ADDR(x))
#define HW_SRC_GPR3_RD(x)        (HW_SRC_GPR3(x).U)
#define HW_SRC_GPR3_WR(x, v)     (HW_SRC_GPR3(x).U = (v))
#define HW_SRC_GPR3_SET(x, v)    (HW_SRC_GPR3_WR(x, HW_SRC_GPR3_RD(x) |  (v)))
#define HW_SRC_GPR3_CLR(x, v)    (HW_SRC_GPR3_WR(x, HW_SRC_GPR3_RD(x) & ~(v)))
#define HW_SRC_GPR3_TOG(x, v)    (HW_SRC_GPR3_WR(x, HW_SRC_GPR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR3 bitfields
 */

/*!
 * @name Register SRC_GPR3, field PERSISTENT_ENTRY1[31:0] (RW)
 *
 * Holds entry function for core1. The SRC ensures that the register value will
 * persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR3_PERSISTENT_ENTRY1 (0U) /*!< Bit position for SRC_GPR3_PERSISTENT_ENTRY1. */
#define BM_SRC_GPR3_PERSISTENT_ENTRY1 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR3_PERSISTENT_ENTRY1. */
#define BS_SRC_GPR3_PERSISTENT_ENTRY1 (32U) /*!< Bit field size in bits for SRC_GPR3_PERSISTENT_ENTRY1. */

/*! @brief Read current value of the SRC_GPR3_PERSISTENT_ENTRY1 field. */
#define BR_SRC_GPR3_PERSISTENT_ENTRY1(x) (HW_SRC_GPR3(x).U)

/*! @brief Format value for bitfield SRC_GPR3_PERSISTENT_ENTRY1. */
#define BF_SRC_GPR3_PERSISTENT_ENTRY1(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR3_PERSISTENT_ENTRY1) & BM_SRC_GPR3_PERSISTENT_ENTRY1)

/*! @brief Set the PERSISTENT_ENTRY1 field to a new value. */
#define BW_SRC_GPR3_PERSISTENT_ENTRY1(x, v) (HW_SRC_GPR3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR4 - SRC General Purpose Register 4
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR4 - SRC General Purpose Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr4
{
    uint32_t U;
    struct _hw_src_gpr4_bitfields
    {
        uint32_t PERSISTENT_ARG1 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr4_t;

/*!
 * @name Constants and macros for entire SRC_GPR4 register
 */
/*@{*/
#define HW_SRC_GPR4_ADDR(x)      ((uintptr_t)(x) + 0x2CU)

#define HW_SRC_GPR4(x)           (*(__IO hw_src_gpr4_t *) HW_SRC_GPR4_ADDR(x))
#define HW_SRC_GPR4_RD(x)        (HW_SRC_GPR4(x).U)
#define HW_SRC_GPR4_WR(x, v)     (HW_SRC_GPR4(x).U = (v))
#define HW_SRC_GPR4_SET(x, v)    (HW_SRC_GPR4_WR(x, HW_SRC_GPR4_RD(x) |  (v)))
#define HW_SRC_GPR4_CLR(x, v)    (HW_SRC_GPR4_WR(x, HW_SRC_GPR4_RD(x) & ~(v)))
#define HW_SRC_GPR4_TOG(x, v)    (HW_SRC_GPR4_WR(x, HW_SRC_GPR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR4 bitfields
 */

/*!
 * @name Register SRC_GPR4, field PERSISTENT_ARG1[31:0] (RW)
 *
 * Holds argument of entry function for core1. The SRC ensures that the register
 * value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR4_PERSISTENT_ARG1 (0U)   /*!< Bit position for SRC_GPR4_PERSISTENT_ARG1. */
#define BM_SRC_GPR4_PERSISTENT_ARG1 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR4_PERSISTENT_ARG1. */
#define BS_SRC_GPR4_PERSISTENT_ARG1 (32U)  /*!< Bit field size in bits for SRC_GPR4_PERSISTENT_ARG1. */

/*! @brief Read current value of the SRC_GPR4_PERSISTENT_ARG1 field. */
#define BR_SRC_GPR4_PERSISTENT_ARG1(x) (HW_SRC_GPR4(x).U)

/*! @brief Format value for bitfield SRC_GPR4_PERSISTENT_ARG1. */
#define BF_SRC_GPR4_PERSISTENT_ARG1(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR4_PERSISTENT_ARG1) & BM_SRC_GPR4_PERSISTENT_ARG1)

/*! @brief Set the PERSISTENT_ARG1 field to a new value. */
#define BW_SRC_GPR4_PERSISTENT_ARG1(x, v) (HW_SRC_GPR4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR5 - SRC General Purpose Register 5
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR5 - SRC General Purpose Register 5 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr5
{
    uint32_t U;
    struct _hw_src_gpr5_bitfields
    {
        uint32_t PERSISTENT_ENTRY2 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr5_t;

/*!
 * @name Constants and macros for entire SRC_GPR5 register
 */
/*@{*/
#define HW_SRC_GPR5_ADDR(x)      ((uintptr_t)(x) + 0x30U)

#define HW_SRC_GPR5(x)           (*(__IO hw_src_gpr5_t *) HW_SRC_GPR5_ADDR(x))
#define HW_SRC_GPR5_RD(x)        (HW_SRC_GPR5(x).U)
#define HW_SRC_GPR5_WR(x, v)     (HW_SRC_GPR5(x).U = (v))
#define HW_SRC_GPR5_SET(x, v)    (HW_SRC_GPR5_WR(x, HW_SRC_GPR5_RD(x) |  (v)))
#define HW_SRC_GPR5_CLR(x, v)    (HW_SRC_GPR5_WR(x, HW_SRC_GPR5_RD(x) & ~(v)))
#define HW_SRC_GPR5_TOG(x, v)    (HW_SRC_GPR5_WR(x, HW_SRC_GPR5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR5 bitfields
 */

/*!
 * @name Register SRC_GPR5, field PERSISTENT_ENTRY2[31:0] (RW)
 *
 * Holds entry function for core2 (i.MX 6Quad only). The SRC ensures that the
 * register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR5_PERSISTENT_ENTRY2 (0U) /*!< Bit position for SRC_GPR5_PERSISTENT_ENTRY2. */
#define BM_SRC_GPR5_PERSISTENT_ENTRY2 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR5_PERSISTENT_ENTRY2. */
#define BS_SRC_GPR5_PERSISTENT_ENTRY2 (32U) /*!< Bit field size in bits for SRC_GPR5_PERSISTENT_ENTRY2. */

/*! @brief Read current value of the SRC_GPR5_PERSISTENT_ENTRY2 field. */
#define BR_SRC_GPR5_PERSISTENT_ENTRY2(x) (HW_SRC_GPR5(x).U)

/*! @brief Format value for bitfield SRC_GPR5_PERSISTENT_ENTRY2. */
#define BF_SRC_GPR5_PERSISTENT_ENTRY2(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR5_PERSISTENT_ENTRY2) & BM_SRC_GPR5_PERSISTENT_ENTRY2)

/*! @brief Set the PERSISTENT_ENTRY2 field to a new value. */
#define BW_SRC_GPR5_PERSISTENT_ENTRY2(x, v) (HW_SRC_GPR5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR6 - SRC General Purpose Register 6
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR6 - SRC General Purpose Register 6 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr6
{
    uint32_t U;
    struct _hw_src_gpr6_bitfields
    {
        uint32_t PERSISTENT_ARG2 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr6_t;

/*!
 * @name Constants and macros for entire SRC_GPR6 register
 */
/*@{*/
#define HW_SRC_GPR6_ADDR(x)      ((uintptr_t)(x) + 0x34U)

#define HW_SRC_GPR6(x)           (*(__IO hw_src_gpr6_t *) HW_SRC_GPR6_ADDR(x))
#define HW_SRC_GPR6_RD(x)        (HW_SRC_GPR6(x).U)
#define HW_SRC_GPR6_WR(x, v)     (HW_SRC_GPR6(x).U = (v))
#define HW_SRC_GPR6_SET(x, v)    (HW_SRC_GPR6_WR(x, HW_SRC_GPR6_RD(x) |  (v)))
#define HW_SRC_GPR6_CLR(x, v)    (HW_SRC_GPR6_WR(x, HW_SRC_GPR6_RD(x) & ~(v)))
#define HW_SRC_GPR6_TOG(x, v)    (HW_SRC_GPR6_WR(x, HW_SRC_GPR6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR6 bitfields
 */

/*!
 * @name Register SRC_GPR6, field PERSISTENT_ARG2[31:0] (RW)
 *
 * Holds argument of entry function for core2 (i.MX 6Quad only). The SRC ensures
 * that the register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR6_PERSISTENT_ARG2 (0U)   /*!< Bit position for SRC_GPR6_PERSISTENT_ARG2. */
#define BM_SRC_GPR6_PERSISTENT_ARG2 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR6_PERSISTENT_ARG2. */
#define BS_SRC_GPR6_PERSISTENT_ARG2 (32U)  /*!< Bit field size in bits for SRC_GPR6_PERSISTENT_ARG2. */

/*! @brief Read current value of the SRC_GPR6_PERSISTENT_ARG2 field. */
#define BR_SRC_GPR6_PERSISTENT_ARG2(x) (HW_SRC_GPR6(x).U)

/*! @brief Format value for bitfield SRC_GPR6_PERSISTENT_ARG2. */
#define BF_SRC_GPR6_PERSISTENT_ARG2(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR6_PERSISTENT_ARG2) & BM_SRC_GPR6_PERSISTENT_ARG2)

/*! @brief Set the PERSISTENT_ARG2 field to a new value. */
#define BW_SRC_GPR6_PERSISTENT_ARG2(x, v) (HW_SRC_GPR6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR7 - SRC General Purpose Register 7
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR7 - SRC General Purpose Register 7 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr7
{
    uint32_t U;
    struct _hw_src_gpr7_bitfields
    {
        uint32_t PERSISTENT_ENTRY3 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr7_t;

/*!
 * @name Constants and macros for entire SRC_GPR7 register
 */
/*@{*/
#define HW_SRC_GPR7_ADDR(x)      ((uintptr_t)(x) + 0x38U)

#define HW_SRC_GPR7(x)           (*(__IO hw_src_gpr7_t *) HW_SRC_GPR7_ADDR(x))
#define HW_SRC_GPR7_RD(x)        (HW_SRC_GPR7(x).U)
#define HW_SRC_GPR7_WR(x, v)     (HW_SRC_GPR7(x).U = (v))
#define HW_SRC_GPR7_SET(x, v)    (HW_SRC_GPR7_WR(x, HW_SRC_GPR7_RD(x) |  (v)))
#define HW_SRC_GPR7_CLR(x, v)    (HW_SRC_GPR7_WR(x, HW_SRC_GPR7_RD(x) & ~(v)))
#define HW_SRC_GPR7_TOG(x, v)    (HW_SRC_GPR7_WR(x, HW_SRC_GPR7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR7 bitfields
 */

/*!
 * @name Register SRC_GPR7, field PERSISTENT_ENTRY3[31:0] (RW)
 *
 * Holds entry function for core3 (i.MX 6Quad only). The SRC ensures that the
 * register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR7_PERSISTENT_ENTRY3 (0U) /*!< Bit position for SRC_GPR7_PERSISTENT_ENTRY3. */
#define BM_SRC_GPR7_PERSISTENT_ENTRY3 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR7_PERSISTENT_ENTRY3. */
#define BS_SRC_GPR7_PERSISTENT_ENTRY3 (32U) /*!< Bit field size in bits for SRC_GPR7_PERSISTENT_ENTRY3. */

/*! @brief Read current value of the SRC_GPR7_PERSISTENT_ENTRY3 field. */
#define BR_SRC_GPR7_PERSISTENT_ENTRY3(x) (HW_SRC_GPR7(x).U)

/*! @brief Format value for bitfield SRC_GPR7_PERSISTENT_ENTRY3. */
#define BF_SRC_GPR7_PERSISTENT_ENTRY3(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR7_PERSISTENT_ENTRY3) & BM_SRC_GPR7_PERSISTENT_ENTRY3)

/*! @brief Set the PERSISTENT_ENTRY3 field to a new value. */
#define BW_SRC_GPR7_PERSISTENT_ENTRY3(x, v) (HW_SRC_GPR7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR8 - SRC General Purpose Register 8
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR8 - SRC General Purpose Register 8 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr8
{
    uint32_t U;
    struct _hw_src_gpr8_bitfields
    {
        uint32_t PERSISTENT_ARG3 : 32; /*!< [31:0]  */
    } B;
} hw_src_gpr8_t;

/*!
 * @name Constants and macros for entire SRC_GPR8 register
 */
/*@{*/
#define HW_SRC_GPR8_ADDR(x)      ((uintptr_t)(x) + 0x3CU)

#define HW_SRC_GPR8(x)           (*(__IO hw_src_gpr8_t *) HW_SRC_GPR8_ADDR(x))
#define HW_SRC_GPR8_RD(x)        (HW_SRC_GPR8(x).U)
#define HW_SRC_GPR8_WR(x, v)     (HW_SRC_GPR8(x).U = (v))
#define HW_SRC_GPR8_SET(x, v)    (HW_SRC_GPR8_WR(x, HW_SRC_GPR8_RD(x) |  (v)))
#define HW_SRC_GPR8_CLR(x, v)    (HW_SRC_GPR8_WR(x, HW_SRC_GPR8_RD(x) & ~(v)))
#define HW_SRC_GPR8_TOG(x, v)    (HW_SRC_GPR8_WR(x, HW_SRC_GPR8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR8 bitfields
 */

/*!
 * @name Register SRC_GPR8, field PERSISTENT_ARG3[31:0] (RW)
 *
 * Holds argument of entry function for core3 (i.MX 6Quad only). The SRC ensures
 * that the register value will persist across system resets.
 */
/*@{*/
#define BP_SRC_GPR8_PERSISTENT_ARG3 (0U)   /*!< Bit position for SRC_GPR8_PERSISTENT_ARG3. */
#define BM_SRC_GPR8_PERSISTENT_ARG3 (0xFFFFFFFFU) /*!< Bit mask for SRC_GPR8_PERSISTENT_ARG3. */
#define BS_SRC_GPR8_PERSISTENT_ARG3 (32U)  /*!< Bit field size in bits for SRC_GPR8_PERSISTENT_ARG3. */

/*! @brief Read current value of the SRC_GPR8_PERSISTENT_ARG3 field. */
#define BR_SRC_GPR8_PERSISTENT_ARG3(x) (HW_SRC_GPR8(x).U)

/*! @brief Format value for bitfield SRC_GPR8_PERSISTENT_ARG3. */
#define BF_SRC_GPR8_PERSISTENT_ARG3(v) ((uint32_t)((uint32_t)(v) << BP_SRC_GPR8_PERSISTENT_ARG3) & BM_SRC_GPR8_PERSISTENT_ARG3)

/*! @brief Set the PERSISTENT_ARG3 field to a new value. */
#define BW_SRC_GPR8_PERSISTENT_ARG3(x, v) (HW_SRC_GPR8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SRC_GPR9 - SRC General Purpose Register 9
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR9 - SRC General Purpose Register 9 (RU)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr9
{
    uint32_t U;
    struct _hw_src_gpr9_bitfields
    {
        uint32_t RESERVED0 : 32;       /*!< [31:0]  */
    } B;
} hw_src_gpr9_t;

/*!
 * @name Constants and macros for entire SRC_GPR9 register
 */
/*@{*/
#define HW_SRC_GPR9_ADDR(x)      ((uintptr_t)(x) + 0x40U)
#define HW_SRC_GPR9(x)           (*(__I hw_src_gpr9_t *) HW_SRC_GPR9_ADDR(x))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR9 bitfields
 */

/*******************************************************************************
 * HW_SRC_GPR10 - SRC General Purpose Register 10
 ******************************************************************************/

/*!
 * @brief HW_SRC_GPR10 - SRC General Purpose Register 10 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the ROM code and should not be used by application
 * software.
 */
typedef union _hw_src_gpr10
{
    uint32_t U;
    struct _hw_src_gpr10_bitfields
    {
        uint32_t RESERVED0 : 25;       /*!< [24:0]  */
        uint32_t core1_ERROR_STATUS : 1; /*!< [25]  */
        uint32_t core2_ERROR_STATUS : 1; /*!< [26]  */
        uint32_t core3_ERROR_STATUS : 1; /*!< [27]  */
        uint32_t RESERVED1 : 4;        /*!< [31:28]  */
    } B;
} hw_src_gpr10_t;

/*!
 * @name Constants and macros for entire SRC_GPR10 register
 */
/*@{*/
#define HW_SRC_GPR10_ADDR(x)     ((uintptr_t)(x) + 0x44U)

#define HW_SRC_GPR10(x)          (*(__IO hw_src_gpr10_t *) HW_SRC_GPR10_ADDR(x))
#define HW_SRC_GPR10_RD(x)       (HW_SRC_GPR10(x).U)
#define HW_SRC_GPR10_WR(x, v)    (HW_SRC_GPR10(x).U = (v))
#define HW_SRC_GPR10_SET(x, v)   (HW_SRC_GPR10_WR(x, HW_SRC_GPR10_RD(x) |  (v)))
#define HW_SRC_GPR10_CLR(x, v)   (HW_SRC_GPR10_WR(x, HW_SRC_GPR10_RD(x) & ~(v)))
#define HW_SRC_GPR10_TOG(x, v)   (HW_SRC_GPR10_WR(x, HW_SRC_GPR10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SRC_GPR10 bitfields
 */

/*!
 * @name Register SRC_GPR10, field core1_ERROR_STATUS[25] (RO)
 *
 * core1 error status bit.
 */
/*@{*/
#define BP_SRC_GPR10_core1_ERROR_STATUS (25U) /*!< Bit position for SRC_GPR10_core1_ERROR_STATUS. */
#define BM_SRC_GPR10_core1_ERROR_STATUS (0x02000000U) /*!< Bit mask for SRC_GPR10_core1_ERROR_STATUS. */
#define BS_SRC_GPR10_core1_ERROR_STATUS (1U) /*!< Bit field size in bits for SRC_GPR10_core1_ERROR_STATUS. */

/*! @brief Read current value of the SRC_GPR10_core1_ERROR_STATUS field. */
#define BR_SRC_GPR10_core1_ERROR_STATUS(x) (HW_SRC_GPR10(x).B.core1_ERROR_STATUS)
/*@}*/

/*!
 * @name Register SRC_GPR10, field core2_ERROR_STATUS[26] (RO)
 *
 * core2 error status bit (i.MX 6Quad Only).
 */
/*@{*/
#define BP_SRC_GPR10_core2_ERROR_STATUS (26U) /*!< Bit position for SRC_GPR10_core2_ERROR_STATUS. */
#define BM_SRC_GPR10_core2_ERROR_STATUS (0x04000000U) /*!< Bit mask for SRC_GPR10_core2_ERROR_STATUS. */
#define BS_SRC_GPR10_core2_ERROR_STATUS (1U) /*!< Bit field size in bits for SRC_GPR10_core2_ERROR_STATUS. */

/*! @brief Read current value of the SRC_GPR10_core2_ERROR_STATUS field. */
#define BR_SRC_GPR10_core2_ERROR_STATUS(x) (HW_SRC_GPR10(x).B.core2_ERROR_STATUS)
/*@}*/

/*!
 * @name Register SRC_GPR10, field core3_ERROR_STATUS[27] (RO)
 *
 * core3 error status bit (i.MX 6Quad Only).
 */
/*@{*/
#define BP_SRC_GPR10_core3_ERROR_STATUS (27U) /*!< Bit position for SRC_GPR10_core3_ERROR_STATUS. */
#define BM_SRC_GPR10_core3_ERROR_STATUS (0x08000000U) /*!< Bit mask for SRC_GPR10_core3_ERROR_STATUS. */
#define BS_SRC_GPR10_core3_ERROR_STATUS (1U) /*!< Bit field size in bits for SRC_GPR10_core3_ERROR_STATUS. */

/*! @brief Read current value of the SRC_GPR10_core3_ERROR_STATUS field. */
#define BR_SRC_GPR10_core3_ERROR_STATUS(x) (HW_SRC_GPR10(x).B.core3_ERROR_STATUS)
/*@}*/

/*******************************************************************************
 * hw_src_t - module struct
 ******************************************************************************/
/*!
 * @brief All SRC module registers.
 */
#pragma pack(1)
typedef struct _hw_src
{
    __IO hw_src_scr_t SCR;                 /*!< [0x0] SRC Control Register */
    __I hw_src_sbmr1_t SBMR1;              /*!< [0x4] SRC Boot Mode Register 1 */
    __IO hw_src_srsr_t SRSR;               /*!< [0x8] SRC Reset Status Register */
    uint8_t _reserved0[8];
    __I hw_src_sisr_t SISR;                /*!< [0x14] SRC Interrupt Status Register */
    __IO hw_src_simr_t SIMR;               /*!< [0x18] SRC Interrupt Mask Register */
    __I hw_src_sbmr2_t SBMR2;              /*!< [0x1C] SRC Boot Mode Register 2 */
    __IO hw_src_gpr1_t GPR1;               /*!< [0x20] SRC General Purpose Register 1 */
    __IO hw_src_gpr2_t GPR2;               /*!< [0x24] SRC General Purpose Register 2 */
    __IO hw_src_gpr3_t GPR3;               /*!< [0x28] SRC General Purpose Register 3 */
    __IO hw_src_gpr4_t GPR4;               /*!< [0x2C] SRC General Purpose Register 4 */
    __IO hw_src_gpr5_t GPR5;               /*!< [0x30] SRC General Purpose Register 5 */
    __IO hw_src_gpr6_t GPR6;               /*!< [0x34] SRC General Purpose Register 6 */
    __IO hw_src_gpr7_t GPR7;               /*!< [0x38] SRC General Purpose Register 7 */
    __IO hw_src_gpr8_t GPR8;               /*!< [0x3C] SRC General Purpose Register 8 */
    __I hw_src_gpr9_t GPR9;                /*!< [0x40] SRC General Purpose Register 9 */
    __IO hw_src_gpr10_t GPR10;             /*!< [0x44] SRC General Purpose Register 10 */
} hw_src_t;
#pragma pack()

/*! @brief Macro to access all SRC registers. */
/*! @param x SRC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SRC_REGS(SRC_BASE)</code>. */
#define HW_SRC_REGS(x) (*(hw_src_t *)(x))

/*
 * iMX6DP SSI
 *
 * SSI
 *
 * Registers defined in this header file:
 * - HW_SSI_STXn - SSI Transmit Data Register n
 * - HW_SSI_SRXn - SSI Receive Data Register n
 * - HW_SSI_SCR - SSI Control Register
 * - HW_SSI_SISR - SSI Interrupt Status Register
 * - HW_SSI_SIER - SSI Interrupt Enable Register
 * - HW_SSI_STCR - SSI Transmit Configuration Register
 * - HW_SSI_SRCR - SSI Receive Configuration Register
 * - HW_SSI_STCCR - SSI Transmit Clock Control Register
 * - HW_SSI_SRCCR - SSI Receive Clock Control Register
 * - HW_SSI_SFCSR - SSI FIFO Control/Status Register
 * - HW_SSI_SACNT - SSI AC97 Control Register
 * - HW_SSI_SACADD - SSI AC97 Command Address Register
 * - HW_SSI_SACDAT - SSI AC97 Command Data Register
 * - HW_SSI_SATAG - SSI AC97 Tag Register
 * - HW_SSI_STMSK - SSI Transmit Time Slot Mask Register
 * - HW_SSI_SRMSK - SSI Receive Time Slot Mask Register
 * - HW_SSI_SACCST - SSI AC97 Channel Status Register
 * - HW_SSI_SACCEN - SSI AC97 Channel Enable Register
 * - HW_SSI_SACCDIS - SSI AC97 Channel Disable Register
 *
 * - hw_ssi_t - Struct containing all module registers.
 */

#define HW_SSI_INSTANCE_COUNT (3U) /*!< Number of instances of the SSI module. */
#define HW_SSI1 (0U) /*!< Instance number for SSI1. */
#define HW_SSI2 (1U) /*!< Instance number for SSI2. */
#define HW_SSI3 (2U) /*!< Instance number for SSI3. */
#define SSI1_BASE             (0x2028000U) /*!< Base address for SSI1. */
#define SSI2_BASE             (0x202C000U) /*!< Base address for SSI2. */
#define SSI3_BASE             (0x2030000U) /*!< Base address for SSI3. */
/*! Array initializer of SSI base addresses. */
#define SSI_BASE_ADDRS        { SSI1_BASE, SSI2_BASE, SSI3_BASE }

/*******************************************************************************
 * HW_SSI_STXn - SSI Transmit Data Register n
 ******************************************************************************/

/*!
 * @brief HW_SSI_STXn - SSI Transmit Data Register n (RW)
 *
 * Reset value: 0x00000000U
 *
 * Enable SSI (SSIEN=1) before writing to SSI Transmit Data Registers.
 */
typedef union _hw_ssi_stxn
{
    uint32_t U;
    struct _hw_ssi_stxn_bitfields
    {
        uint32_t STXn : 32;            /*!< [31:0]  */
    } B;
} hw_ssi_stxn_t;

/*!
 * @name Constants and macros for entire SSI_STXn register
 */
/*@{*/
#define HW_SSI_STXn_COUNT (2U)

#define HW_SSI_STXn_ADDR(x, n)   ((uintptr_t)(x) + 0x0U + (0x4U * (n)))

#define HW_SSI_STXn(x, n)        (*(__IO hw_ssi_stxn_t *) HW_SSI_STXn_ADDR(x, n))
#define HW_SSI_STXn_RD(x, n)     (HW_SSI_STXn(x, n).U)
#define HW_SSI_STXn_WR(x, n, v)  (HW_SSI_STXn(x, n).U = (v))
#define HW_SSI_STXn_SET(x, n, v) (HW_SSI_STXn_WR(x, n, HW_SSI_STXn_RD(x, n) |  (v)))
#define HW_SSI_STXn_CLR(x, n, v) (HW_SSI_STXn_WR(x, n, HW_SSI_STXn_RD(x, n) & ~(v)))
#define HW_SSI_STXn_TOG(x, n, v) (HW_SSI_STXn_WR(x, n, HW_SSI_STXn_RD(x, n) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_STXn bitfields
 */

/*!
 * @name Register SSI_STXn, field STXn[31:0] (RW)
 *
 * SSI Transmit Data. These bits store the data to be transmitted by the SSI.
 * These are implemented as the first word of their respective Tx FIFOs. Data
 * written to these registers is transferred to the Transmit Shift Register (TXSR),
 * when shifting of the previous data is complete. If both FIFOs are in use, data
 * is alternately transferred from STX0 and STX1, to TXSR. Multiple writes to the
 * STX registers will not result in the previous data being over-written by the
 * subsequent data. STX1 can only be used in Two-Channel mode of operation.
 * Protection from over-writing is present irrespective of whether the transmitter is
 * enabled or not. Example 1: If Tx FIFO0 is in use and user writes Data1...Data16
 * to STX0,Data16 will not over-write Data1. Data1...Data15 are stored in the
 * FIFO whileData16 is discarded. Example 2: If Tx FIFO0 is not in use and user
 * writes Data1, Data2 to STX0, then Data2 will not over-write Data1 and will be
 * discarded.
 */
/*@{*/
#define BP_SSI_STXn_STXn     (0U)          /*!< Bit position for SSI_STXn_STXn. */
#define BM_SSI_STXn_STXn     (0xFFFFFFFFU) /*!< Bit mask for SSI_STXn_STXn. */
#define BS_SSI_STXn_STXn     (32U)         /*!< Bit field size in bits for SSI_STXn_STXn. */

/*! @brief Read current value of the SSI_STXn_STXn field. */
#define BR_SSI_STXn_STXn(x, n) (HW_SSI_STXn(x, n).U)

/*! @brief Format value for bitfield SSI_STXn_STXn. */
#define BF_SSI_STXn_STXn(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_STXn_STXn) & BM_SSI_STXn_STXn)

/*! @brief Set the STXn field to a new value. */
#define BW_SSI_STXn_STXn(x, n, v) (HW_SSI_STXn_WR(x, n, v))
/*@}*/

/*******************************************************************************
 * HW_SSI_SRXn - SSI Receive Data Register n
 ******************************************************************************/

/*!
 * @brief HW_SSI_SRXn - SSI Receive Data Register n (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_srxn
{
    uint32_t U;
    struct _hw_ssi_srxn_bitfields
    {
        uint32_t SRXn : 32;            /*!< [31:0]  */
    } B;
} hw_ssi_srxn_t;

/*!
 * @name Constants and macros for entire SSI_SRXn register
 */
/*@{*/
#define HW_SSI_SRXn_COUNT (2U)

#define HW_SSI_SRXn_ADDR(x, n)   ((uintptr_t)(x) + 0x8U + (0x4U * (n)))

#define HW_SSI_SRXn(x, n)        (*(__I hw_ssi_srxn_t *) HW_SSI_SRXn_ADDR(x, n))
#define HW_SSI_SRXn_RD(x, n)     (HW_SSI_SRXn(x, n).U)
/*@}*/

/*
 * Constants & macros for individual SSI_SRXn bitfields
 */

/*!
 * @name Register SSI_SRXn, field SRXn[31:0] (RO)
 *
 * SSI Receive Data. These bits store the data received by the SSI. These are
 * implemented as the first word of their respective Rx FIFOs. These bits receive
 * data from the RXSR depending on the mode of operation. In case both FIFOs are
 * in use, data is transferred to each data register alternately. SRX1 can only be
 * used in Two-Channel mode of operation.
 */
/*@{*/
#define BP_SSI_SRXn_SRXn     (0U)          /*!< Bit position for SSI_SRXn_SRXn. */
#define BM_SSI_SRXn_SRXn     (0xFFFFFFFFU) /*!< Bit mask for SSI_SRXn_SRXn. */
#define BS_SSI_SRXn_SRXn     (32U)         /*!< Bit field size in bits for SSI_SRXn_SRXn. */

/*! @brief Read current value of the SSI_SRXn_SRXn field. */
#define BR_SSI_SRXn_SRXn(x, n) (HW_SSI_SRXn(x, n).U)
/*@}*/

/*******************************************************************************
 * HW_SSI_SCR - SSI Control Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SCR - SSI Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SSI Control Register (SSI_SCR) sets up the SSI reset is controlled by bit
 * 0 in the SSI_SCR. SSI operating modes are also selected in this register
 * (except AC97 mode which is selected in the SSI_SACNT register).
 */
typedef union _hw_ssi_scr
{
    uint32_t U;
    struct _hw_ssi_scr_bitfields
    {
        uint32_t SSIEN : 1;            /*!< [0]  */
        uint32_t TE : 1;               /*!< [1]  */
        uint32_t RE : 1;               /*!< [2]  */
        uint32_t NET : 1;              /*!< [3]  */
        uint32_t SYN : 1;              /*!< [4]  */
        uint32_t I2S_MODE : 2;         /*!< [6:5]  */
        uint32_t SYS_CLK_EN : 1;       /*!< [7]  */
        uint32_t TCH_EN : 1;           /*!< [8]  */
        uint32_t CLK_IST : 1;          /*!< [9]  */
        uint32_t TFR_CLK_DIS : 1;      /*!< [10]  */
        uint32_t RFR_CLK_DIS : 1;      /*!< [11]  */
        uint32_t SYNC_TX_FS : 1;       /*!< [12]  */
        uint32_t RESERVED0 : 19;       /*!< [31:13]  */
    } B;
} hw_ssi_scr_t;

/*!
 * @name Constants and macros for entire SSI_SCR register
 */
/*@{*/
#define HW_SSI_SCR_ADDR(x)       ((uintptr_t)(x) + 0x10U)

#define HW_SSI_SCR(x)            (*(__IO hw_ssi_scr_t *) HW_SSI_SCR_ADDR(x))
#define HW_SSI_SCR_RD(x)         (HW_SSI_SCR(x).U)
#define HW_SSI_SCR_WR(x, v)      (HW_SSI_SCR(x).U = (v))
#define HW_SSI_SCR_SET(x, v)     (HW_SSI_SCR_WR(x, HW_SSI_SCR_RD(x) |  (v)))
#define HW_SSI_SCR_CLR(x, v)     (HW_SSI_SCR_WR(x, HW_SSI_SCR_RD(x) & ~(v)))
#define HW_SSI_SCR_TOG(x, v)     (HW_SSI_SCR_WR(x, HW_SSI_SCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SCR bitfields
 */

/*!
 * @name Register SSI_SCR, field SSIEN[0] (RW)
 *
 * SSIEN - SSI Enable This bit is used to enable/disable the SSI. When disabled,
 * all SSI status bits are preset to the same state produced by the power-on
 * reset, all control bits are unaffected, the contents of Tx and Rx FIFOs are
 * cleared. When SSI is disabled, all internal clocks are disabled (except register
 * access clock).
 *
 * Values:
 * - 0 - SSI is disabled.
 * - 1 - SSI is enabled.
 */
/*@{*/
#define BP_SSI_SCR_SSIEN     (0U)          /*!< Bit position for SSI_SCR_SSIEN. */
#define BM_SSI_SCR_SSIEN     (0x00000001U) /*!< Bit mask for SSI_SCR_SSIEN. */
#define BS_SSI_SCR_SSIEN     (1U)          /*!< Bit field size in bits for SSI_SCR_SSIEN. */

#define BV_SSI_SCR_SSIEN_DISABLED      (0U)          /*!< Bit field value for SSI_SCR_SSIEN: SSI is disabled. */
#define BV_SSI_SCR_SSIEN_ENABLED       (0x1U)        /*!< Bit field value for SSI_SCR_SSIEN: SSI is enabled. */

/*! @brief Read current value of the SSI_SCR_SSIEN field. */
#define BR_SSI_SCR_SSIEN(x)  (HW_SSI_SCR(x).B.SSIEN)

/*! @brief Format value for bitfield SSI_SCR_SSIEN. */
#define BF_SSI_SCR_SSIEN(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_SSIEN) & BM_SSI_SCR_SSIEN)

/*! @brief Set the SSIEN field to a new value. */
#define BW_SSI_SCR_SSIEN(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_SSIEN) | BF_SSI_SCR_SSIEN(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field TE[1] (RW)
 *
 * Transmit Enable. This control bit enables the transmit section of the SSI. It
 * enables the transfer of the contents of the STX registers to the TXSR and
 * also enables the internal transmit clock. The transmit section is enabled when
 * this bit is set and a frame boundary is detected. When this bit is cleared, the
 * transmitter continues to send data until the end of the current frame and then
 * stops. Data can be written to the STX registers with the TE bit cleared (the
 * corresponding TDE bit will be cleared). If the TE bit is cleared and then set
 * again before the second to last bit of the last time slot in the current
 * frame, data transmission continues without interruption. The normal transmit enable
 * sequence is to write data to the STX register(s) and then set the TE bit. The
 * normal disable sequence is to clear the TE and TIE bits after the TDE bit is
 * set. In gated clock mode, clearing the TE bit results in the clock stopping
 * after the data currently in TXSR has shifted out. When the TE bit is set, the
 * clock starts immediately (for internal gated clock mode). TE should not be
 * toggled in the same frame. After enabling/disabling transmission, SSI expects 4
 * setup clock cycles before arrival of frame-sync for frame-sync to be
 * accepted/rejected by In case of fewer clock cycles, there is high probability of the
 * frame-sync to get missed. Note: If continuous clock is not provided, SSI expects 6
 * clock cycles before arrival of frame-sync for frame-sync to be accepted by the
 * SSI.
 *
 * Values:
 * - 0 - Transmit section disabled.
 * - 1 - Transmit section enabled.
 */
/*@{*/
#define BP_SSI_SCR_TE        (1U)          /*!< Bit position for SSI_SCR_TE. */
#define BM_SSI_SCR_TE        (0x00000002U) /*!< Bit mask for SSI_SCR_TE. */
#define BS_SSI_SCR_TE        (1U)          /*!< Bit field size in bits for SSI_SCR_TE. */

#define BV_SSI_SCR_TE_DISABLED         (0U)          /*!< Bit field value for SSI_SCR_TE: Transmit section disabled. */
#define BV_SSI_SCR_TE_ENABLED          (0x1U)        /*!< Bit field value for SSI_SCR_TE: Transmit section enabled. */

/*! @brief Read current value of the SSI_SCR_TE field. */
#define BR_SSI_SCR_TE(x)     (HW_SSI_SCR(x).B.TE)

/*! @brief Format value for bitfield SSI_SCR_TE. */
#define BF_SSI_SCR_TE(v)     ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_TE) & BM_SSI_SCR_TE)

/*! @brief Set the TE field to a new value. */
#define BW_SSI_SCR_TE(x, v)  (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_TE) | BF_SSI_SCR_TE(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field RE[2] (RW)
 *
 * Receive Enable. This control bit enables the receive section of the SSI. When
 * this bit is enabled, data reception starts with the arrival of the next frame
 * sync. If data is being received when this bit is cleared, data reception
 * continues until the end of the current frame and then stops. If this bit is set
 * again before the second to last bit of the last time slot in the current frame,
 * then reception continues without interruption. RE should not be toggled in the
 * same frame.
 *
 * Values:
 * - 0 - Receive section disabled.
 * - 1 - Receive section enabled.
 */
/*@{*/
#define BP_SSI_SCR_RE        (2U)          /*!< Bit position for SSI_SCR_RE. */
#define BM_SSI_SCR_RE        (0x00000004U) /*!< Bit mask for SSI_SCR_RE. */
#define BS_SSI_SCR_RE        (1U)          /*!< Bit field size in bits for SSI_SCR_RE. */

#define BV_SSI_SCR_RE_DISABLED         (0U)          /*!< Bit field value for SSI_SCR_RE: Receive section disabled. */
#define BV_SSI_SCR_RE_ENABLED          (0x1U)        /*!< Bit field value for SSI_SCR_RE: Receive section enabled. */

/*! @brief Read current value of the SSI_SCR_RE field. */
#define BR_SSI_SCR_RE(x)     (HW_SSI_SCR(x).B.RE)

/*! @brief Format value for bitfield SSI_SCR_RE. */
#define BF_SSI_SCR_RE(v)     ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_RE) & BM_SSI_SCR_RE)

/*! @brief Set the RE field to a new value. */
#define BW_SSI_SCR_RE(x, v)  (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_RE) | BF_SSI_SCR_RE(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field NET[3] (RW)
 *
 * Network Mode. This bit controls whether SSI is in network mode or not.
 *
 * Values:
 * - 0 - Network mode not selected.
 * - 1 - Network mode selected.
 */
/*@{*/
#define BP_SSI_SCR_NET       (3U)          /*!< Bit position for SSI_SCR_NET. */
#define BM_SSI_SCR_NET       (0x00000008U) /*!< Bit mask for SSI_SCR_NET. */
#define BS_SSI_SCR_NET       (1U)          /*!< Bit field size in bits for SSI_SCR_NET. */

#define BV_SSI_SCR_NET_DISABLED        (0U)          /*!< Bit field value for SSI_SCR_NET: Network mode not selected. */
#define BV_SSI_SCR_NET_ENABLED         (0x1U)        /*!< Bit field value for SSI_SCR_NET: Network mode selected. */

/*! @brief Read current value of the SSI_SCR_NET field. */
#define BR_SSI_SCR_NET(x)    (HW_SSI_SCR(x).B.NET)

/*! @brief Format value for bitfield SSI_SCR_NET. */
#define BF_SSI_SCR_NET(v)    ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_NET) & BM_SSI_SCR_NET)

/*! @brief Set the NET field to a new value. */
#define BW_SSI_SCR_NET(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_NET) | BF_SSI_SCR_NET(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field SYN[4] (RW)
 *
 * Synchronous Mode. This bit controls whether SSI is in synchronous mode or
 * not. In synchronous mode, the transmit and receive sections of SSI share a common
 * clock port (STCK) and frame sync port (STFS).
 *
 * Values:
 * - 0 - Asynchronous mode selected.
 * - 1 - Synchronous mode selected.
 */
/*@{*/
#define BP_SSI_SCR_SYN       (4U)          /*!< Bit position for SSI_SCR_SYN. */
#define BM_SSI_SCR_SYN       (0x00000010U) /*!< Bit mask for SSI_SCR_SYN. */
#define BS_SSI_SCR_SYN       (1U)          /*!< Bit field size in bits for SSI_SCR_SYN. */

#define BV_SSI_SCR_SYN_ASYNC_MODE      (0U)          /*!< Bit field value for SSI_SCR_SYN: Asynchronous mode selected. */
#define BV_SSI_SCR_SYN_SYNC_MODE       (0x1U)        /*!< Bit field value for SSI_SCR_SYN: Synchronous mode selected. */

/*! @brief Read current value of the SSI_SCR_SYN field. */
#define BR_SSI_SCR_SYN(x)    (HW_SSI_SCR(x).B.SYN)

/*! @brief Format value for bitfield SSI_SCR_SYN. */
#define BF_SSI_SCR_SYN(v)    ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_SYN) & BM_SSI_SCR_SYN)

/*! @brief Set the SYN field to a new value. */
#define BW_SSI_SCR_SYN(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_SYN) | BF_SSI_SCR_SYN(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field I2S_MODE[6:5] (RW)
 *
 * I2S Mode Select. These bits allow the SSI to operate in Normal, I2S Master or
 * I2S Slave mode. Refer to I2S ModeThe SSI is compliant to the Inter-IC Sound
 * (I2S) bus specification from Philips Semiconductors (February 1986, Revised
 * June 5, 1996). For more information on I2S, refer to the latest version of NXP
 * Semiconductor's I2S specification. for a detailed description of I2S Mode of
 * operation. Refer to for details regarding settings.
 */
/*@{*/
#define BP_SSI_SCR_I2S_MODE  (5U)          /*!< Bit position for SSI_SCR_I2S_MODE. */
#define BM_SSI_SCR_I2S_MODE  (0x00000060U) /*!< Bit mask for SSI_SCR_I2S_MODE. */
#define BS_SSI_SCR_I2S_MODE  (2U)          /*!< Bit field size in bits for SSI_SCR_I2S_MODE. */

/*! @brief Read current value of the SSI_SCR_I2S_MODE field. */
#define BR_SSI_SCR_I2S_MODE(x) (HW_SSI_SCR(x).B.I2S_MODE)

/*! @brief Format value for bitfield SSI_SCR_I2S_MODE. */
#define BF_SSI_SCR_I2S_MODE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_I2S_MODE) & BM_SSI_SCR_I2S_MODE)

/*! @brief Set the I2S_MODE field to a new value. */
#define BW_SSI_SCR_I2S_MODE(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_I2S_MODE) | BF_SSI_SCR_I2S_MODE(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field SYS_CLK_EN[7] (RW)
 *
 * Network Clock (Oversampling Clock) Enable. When set, this bit allows the SSI
 * to output the network clock at the SRCK port, provided that synchronous mode,
 * and transmit internal clock mode are set. The relationship between bit clock
 * and network clock is determined by DIV2, PSR, and PM bits. This feature is
 * especially useful in I2S Master mode to output network clock (oversampling clock)
 * on SRCK port.
 *
 * Values:
 * - 0 - network clock not output on SRCK port.
 * - 1 - network clock output on SRCK port.
 */
/*@{*/
#define BP_SSI_SCR_SYS_CLK_EN (7U)         /*!< Bit position for SSI_SCR_SYS_CLK_EN. */
#define BM_SSI_SCR_SYS_CLK_EN (0x00000080U) /*!< Bit mask for SSI_SCR_SYS_CLK_EN. */
#define BS_SSI_SCR_SYS_CLK_EN (1U)         /*!< Bit field size in bits for SSI_SCR_SYS_CLK_EN. */

#define BV_SSI_SCR_SYS_CLK_EN_NOT_OUTPUT (0U)        /*!< Bit field value for SSI_SCR_SYS_CLK_EN: network clock not output on SRCK port. */
#define BV_SSI_SCR_SYS_CLK_EN_OUTPUT   (0x1U)        /*!< Bit field value for SSI_SCR_SYS_CLK_EN: network clock output on SRCK port. */

/*! @brief Read current value of the SSI_SCR_SYS_CLK_EN field. */
#define BR_SSI_SCR_SYS_CLK_EN(x) (HW_SSI_SCR(x).B.SYS_CLK_EN)

/*! @brief Format value for bitfield SSI_SCR_SYS_CLK_EN. */
#define BF_SSI_SCR_SYS_CLK_EN(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_SYS_CLK_EN) & BM_SSI_SCR_SYS_CLK_EN)

/*! @brief Set the SYS_CLK_EN field to a new value. */
#define BW_SSI_SCR_SYS_CLK_EN(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_SYS_CLK_EN) | BF_SSI_SCR_SYS_CLK_EN(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field TCH_EN[8] (RW)
 *
 * Two-Channel Operation Enable. This bit allows SSI to operate in the
 * two-channel mode.In this mode while receiving, the RXSR transfers data to SRX0 and SRX1
 * alternately and while transmitting, data is alternately transferred from STX0
 * and STX1 to TXSR. For an even number of slots, Two-Channel Operation can be
 * enabled to optimize usage of both FIFOs or disabled as in the case of odd
 * number of active slots. This feature is especially useful in I2S mode, where data
 * for Left Speaker can be placed in Tx-FIFO0 and for Right speaker in Tx-FIFO1.
 *
 * Values:
 * - 0 - Two-channel mode disabled.
 * - 1 - Two-channel mode enabled.
 */
/*@{*/
#define BP_SSI_SCR_TCH_EN    (8U)          /*!< Bit position for SSI_SCR_TCH_EN. */
#define BM_SSI_SCR_TCH_EN    (0x00000100U) /*!< Bit mask for SSI_SCR_TCH_EN. */
#define BS_SSI_SCR_TCH_EN    (1U)          /*!< Bit field size in bits for SSI_SCR_TCH_EN. */

#define BV_SSI_SCR_TCH_EN_DISABLED     (0U)          /*!< Bit field value for SSI_SCR_TCH_EN: Two-channel mode disabled. */
#define BV_SSI_SCR_TCH_EN_ENABLED      (0x1U)        /*!< Bit field value for SSI_SCR_TCH_EN: Two-channel mode enabled. */

/*! @brief Read current value of the SSI_SCR_TCH_EN field. */
#define BR_SSI_SCR_TCH_EN(x) (HW_SSI_SCR(x).B.TCH_EN)

/*! @brief Format value for bitfield SSI_SCR_TCH_EN. */
#define BF_SSI_SCR_TCH_EN(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_TCH_EN) & BM_SSI_SCR_TCH_EN)

/*! @brief Set the TCH_EN field to a new value. */
#define BW_SSI_SCR_TCH_EN(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_TCH_EN) | BF_SSI_SCR_TCH_EN(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field CLK_IST[9] (RW)
 *
 * Clock Idle State. This bit controls the idle state of the transmit clock port
 * during SSI internal gated mode. Note: When Clock idle state is '1' the clock
 * polarity should always be negedge triggered and when Clock idle = '0' the
 * clock polarity should always be positive edge triggered.
 *
 * Values:
 * - 0 - Clock idle state is '0'.
 * - 1 - Clock idle state is '1'.
 */
/*@{*/
#define BP_SSI_SCR_CLK_IST   (9U)          /*!< Bit position for SSI_SCR_CLK_IST. */
#define BM_SSI_SCR_CLK_IST   (0x00000200U) /*!< Bit mask for SSI_SCR_CLK_IST. */
#define BS_SSI_SCR_CLK_IST   (1U)          /*!< Bit field size in bits for SSI_SCR_CLK_IST. */

#define BV_SSI_SCR_CLK_IST_IDLE_0      (0U)          /*!< Bit field value for SSI_SCR_CLK_IST: Clock idle state is '0'. */
#define BV_SSI_SCR_CLK_IST_IDLE_1      (0x1U)        /*!< Bit field value for SSI_SCR_CLK_IST: Clock idle state is '1'. */

/*! @brief Read current value of the SSI_SCR_CLK_IST field. */
#define BR_SSI_SCR_CLK_IST(x) (HW_SSI_SCR(x).B.CLK_IST)

/*! @brief Format value for bitfield SSI_SCR_CLK_IST. */
#define BF_SSI_SCR_CLK_IST(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_CLK_IST) & BM_SSI_SCR_CLK_IST)

/*! @brief Set the CLK_IST field to a new value. */
#define BW_SSI_SCR_CLK_IST(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_CLK_IST) | BF_SSI_SCR_CLK_IST(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field TFR_CLK_DIS[10] (RW)
 *
 * Transmit Frame Clock Disable. This bit provide option to keep the Frame-sync
 * and Clock enabled or disabled after current transmit frame, in which
 * transmitter is disabled by clearing TE bit. Writing to this bit has effect only when
 * SSI is enabled TE is disabled.
 *
 * Values:
 * - 0 - Continue Frame-sync/Clock generation after current frame during which
 *     TE is cleared. This may be required when Frame-sync and Clocks are required
 *     from SSI, even when no data is to be received.
 * - 1 - Stop Frame-sync/Clock generation at next frame boundary. This will be
 *     effective also in case where transmitter is already disabled in current or
 *     previous frames.
 */
/*@{*/
#define BP_SSI_SCR_TFR_CLK_DIS (10U)       /*!< Bit position for SSI_SCR_TFR_CLK_DIS. */
#define BM_SSI_SCR_TFR_CLK_DIS (0x00000400U) /*!< Bit mask for SSI_SCR_TFR_CLK_DIS. */
#define BS_SSI_SCR_TFR_CLK_DIS (1U)        /*!< Bit field size in bits for SSI_SCR_TFR_CLK_DIS. */

#define BV_SSI_SCR_TFR_CLK_DIS_CONTINUE (0U)         /*!< Bit field value for SSI_SCR_TFR_CLK_DIS: Continue Frame-sync/Clock generation after current frame during which TE is cleared. This may be required when Frame-sync and Clocks are required from SSI, even when no data is to be received. */
#define BV_SSI_SCR_TFR_CLK_DIS_STOP    (0x1U)        /*!< Bit field value for SSI_SCR_TFR_CLK_DIS: Stop Frame-sync/Clock generation at next frame boundary. This will be effective also in case where transmitter is already disabled in current or previous frames. */

/*! @brief Read current value of the SSI_SCR_TFR_CLK_DIS field. */
#define BR_SSI_SCR_TFR_CLK_DIS(x) (HW_SSI_SCR(x).B.TFR_CLK_DIS)

/*! @brief Format value for bitfield SSI_SCR_TFR_CLK_DIS. */
#define BF_SSI_SCR_TFR_CLK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_TFR_CLK_DIS) & BM_SSI_SCR_TFR_CLK_DIS)

/*! @brief Set the TFR_CLK_DIS field to a new value. */
#define BW_SSI_SCR_TFR_CLK_DIS(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_TFR_CLK_DIS) | BF_SSI_SCR_TFR_CLK_DIS(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field RFR_CLK_DIS[11] (RW)
 *
 * Receive Frame Clock Disable. This bit provides the option to keep the
 * Frame-sync and Clock enabled or to disable them after the receive frame in which the
 * receiver is disabled. Writing to this bit has effect only when RE is
 * disabled.The receiver is disabled by clearing the RE bit.
 *
 * Values:
 * - 0 - Continue Frame-sync/Clock generation after current frame during which
 *     RE is cleared. This may be required when Frame-sync and Clocks are required
 *     from SSI, even when no data is to be received.
 * - 1 - Stop Frame-sync/Clock generation at next frame boundary. This will be
 *     effective also in case where receiver is already disabled in current or
 *     previous frames.
 */
/*@{*/
#define BP_SSI_SCR_RFR_CLK_DIS (11U)       /*!< Bit position for SSI_SCR_RFR_CLK_DIS. */
#define BM_SSI_SCR_RFR_CLK_DIS (0x00000800U) /*!< Bit mask for SSI_SCR_RFR_CLK_DIS. */
#define BS_SSI_SCR_RFR_CLK_DIS (1U)        /*!< Bit field size in bits for SSI_SCR_RFR_CLK_DIS. */

#define BV_SSI_SCR_RFR_CLK_DIS_CONTINUE (0U)         /*!< Bit field value for SSI_SCR_RFR_CLK_DIS: Continue Frame-sync/Clock generation after current frame during which RE is cleared. This may be required when Frame-sync and Clocks are required from SSI, even when no data is to be received. */
#define BV_SSI_SCR_RFR_CLK_DIS_STOP    (0x1U)        /*!< Bit field value for SSI_SCR_RFR_CLK_DIS: Stop Frame-sync/Clock generation at next frame boundary. This will be effective also in case where receiver is already disabled in current or previous frames. */

/*! @brief Read current value of the SSI_SCR_RFR_CLK_DIS field. */
#define BR_SSI_SCR_RFR_CLK_DIS(x) (HW_SSI_SCR(x).B.RFR_CLK_DIS)

/*! @brief Format value for bitfield SSI_SCR_RFR_CLK_DIS. */
#define BF_SSI_SCR_RFR_CLK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_RFR_CLK_DIS) & BM_SSI_SCR_RFR_CLK_DIS)

/*! @brief Set the RFR_CLK_DIS field to a new value. */
#define BW_SSI_SCR_RFR_CLK_DIS(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_RFR_CLK_DIS) | BF_SSI_SCR_RFR_CLK_DIS(v)))
/*@}*/

/*!
 * @name Register SSI_SCR, field SYNC_TX_FS[12] (RW)
 *
 * SYNC_FS_TX bit provides a safe window for TE to be visible to the internal
 * circuit which is just after FS occurrence. When SYNC_TX_FS is set, TE(SCR[1])
 * gets latched on FS occurrence & latched TE is used to enable/disable SSI
 * transmitter. TE needs setup of 2 bit-clock cycles before occurrence of FS. If TE is
 * changed within 2 bit-clock cycles of FS occurrence, there is high probability
 * that TE will be latched on next FS. Note: With TFR_CLK_DIS feature on, TE is
 * used directly to enable transmitter in following cases (i) Sync mode & Rx
 * disabled (ii) Async Mode. Latched-TE is used to disable the transmitter. This bit
 * has no relevance in gated mode and AC97 mode.
 *
 * Values:
 * - 0 - TE not latched with FS occurrence & used directly for transmitter
 *     enable/disable.
 * - 1 - TE latched with FS occurrence & latched-TE used for transmitter
 *     enable/disable.
 */
/*@{*/
#define BP_SSI_SCR_SYNC_TX_FS (12U)        /*!< Bit position for SSI_SCR_SYNC_TX_FS. */
#define BM_SSI_SCR_SYNC_TX_FS (0x00001000U) /*!< Bit mask for SSI_SCR_SYNC_TX_FS. */
#define BS_SSI_SCR_SYNC_TX_FS (1U)         /*!< Bit field size in bits for SSI_SCR_SYNC_TX_FS. */

#define BV_SSI_SCR_SYNC_TX_FS_TE_NOT_LATCHED (0U)    /*!< Bit field value for SSI_SCR_SYNC_TX_FS: TE not latched with FS occurrence & used directly for transmitter enable/disable. */
#define BV_SSI_SCR_SYNC_TX_FS_TE_LATCHED (0x1U)      /*!< Bit field value for SSI_SCR_SYNC_TX_FS: TE latched with FS occurrence & latched-TE used for transmitter enable/disable. */

/*! @brief Read current value of the SSI_SCR_SYNC_TX_FS field. */
#define BR_SSI_SCR_SYNC_TX_FS(x) (HW_SSI_SCR(x).B.SYNC_TX_FS)

/*! @brief Format value for bitfield SSI_SCR_SYNC_TX_FS. */
#define BF_SSI_SCR_SYNC_TX_FS(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SCR_SYNC_TX_FS) & BM_SSI_SCR_SYNC_TX_FS)

/*! @brief Set the SYNC_TX_FS field to a new value. */
#define BW_SSI_SCR_SYNC_TX_FS(x, v) (HW_SSI_SCR_WR(x, (HW_SSI_SCR_RD(x) & ~BM_SSI_SCR_SYNC_TX_FS) | BF_SSI_SCR_SYNC_TX_FS(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SISR - SSI Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SISR - SSI Interrupt Status Register (RW)
 *
 * Reset value: 0x00003003U
 *
 * The SSI Interrupt Status Register (SSI_SISR) is used to monitor the SSI. This
 * register is used by the core to interrogate the status of the SSI. In gated
 * mode of operation the TFS, RFS, TLS, RLS, TFRC and RFRC bits of AISR register
 * are not generated. The status bits are described in the following table. SSI
 * Status flags are valid when SSI is enabled. See Receive Interrupt Enable Bit
 * DescriptionWhen the RIE and RE bit are set, the processor is interrupted when
 * either of the SSI Receive FIFO Full (RFF0/1) bits in SSI.SISR is set (if the
 * corresponding Receive FIFO is enabled). and Transmit Interrupt Enable Bit
 * DescriptionThe SSI Transmit Interrupt Enable (TIE) control bit determines whether the
 * processor is interrupted when the SSI transmitter needs to be serviced. for
 * interrupt source mapping. All the flags in the SSI_SISR are updated after the
 * first bit of the next SSI word has completed transmission or reception. Certain
 * status bits (ROE0/1 and TUE0/1) are cleared by writing 1 to the corresponding
 * interrupt status bit in SSI_SISR.
 */
typedef union _hw_ssi_sisr
{
    uint32_t U;
    struct _hw_ssi_sisr_bitfields
    {
        uint32_t TFE0 : 1;             /*!< [0]  */
        uint32_t TFE1 : 1;             /*!< [1]  */
        uint32_t RFF0 : 1;             /*!< [2]  */
        uint32_t RFF1 : 1;             /*!< [3]  */
        uint32_t RLS : 1;              /*!< [4]  */
        uint32_t TLS : 1;              /*!< [5]  */
        uint32_t RFS : 1;              /*!< [6]  */
        uint32_t TFS : 1;              /*!< [7]  */
        uint32_t TUE0 : 1;             /*!< [8]  */
        uint32_t TUE1 : 1;             /*!< [9]  */
        uint32_t ROE0 : 1;             /*!< [10]  */
        uint32_t ROE1 : 1;             /*!< [11]  */
        uint32_t TDE0 : 1;             /*!< [12]  */
        uint32_t TDE1 : 1;             /*!< [13]  */
        uint32_t RDR0 : 1;             /*!< [14]  */
        uint32_t RDR1 : 1;             /*!< [15]  */
        uint32_t RXT : 1;              /*!< [16]  */
        uint32_t CMDDU : 1;            /*!< [17]  */
        uint32_t CMDAU : 1;            /*!< [18]  */
        uint32_t RESERVED0 : 4;        /*!< [22:19]  */
        uint32_t TFRC : 1;             /*!< [23]  */
        uint32_t RFRC : 1;             /*!< [24]  */
        uint32_t RESERVED1 : 7;        /*!< [31:25]  */
    } B;
} hw_ssi_sisr_t;

/*!
 * @name Constants and macros for entire SSI_SISR register
 */
/*@{*/
#define HW_SSI_SISR_ADDR(x)      ((uintptr_t)(x) + 0x14U)

#define HW_SSI_SISR(x)           (*(__IO hw_ssi_sisr_t *) HW_SSI_SISR_ADDR(x))
#define HW_SSI_SISR_RD(x)        (HW_SSI_SISR(x).U)
#define HW_SSI_SISR_WR(x, v)     (HW_SSI_SISR(x).U = (v))
#define HW_SSI_SISR_SET(x, v)    (HW_SSI_SISR_WR(x, HW_SSI_SISR_RD(x) |  (v)))
#define HW_SSI_SISR_CLR(x, v)    (HW_SSI_SISR_WR(x, HW_SSI_SISR_RD(x) & ~(v)))
#define HW_SSI_SISR_TOG(x, v)    (HW_SSI_SISR_WR(x, HW_SSI_SISR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SISR bitfields
 */

/*!
 * @name Register SSI_SISR, field TFE0[0] (RO)
 *
 * Transmit FIFO Empty 0. This flag is set when the empty slots in Tx FIFO
 * exceed or are equal to the selected Tx FIFO WaterMark 0 (TFWM0) threshold. The
 * setting of TFE0 only causes an interrupt when TIE and TFE0_EN are set and Tx FIFO0
 * is enabled. The TFE0 bit is automatically cleared when the data level in Tx
 * FIFO0 becomes more than the amount specified by the watermark bits. The TFE0
 * bit is set by POR and SSI reset.
 *
 * Values:
 * - 0 - Transmit FIFO0 has data for transmission.
 * - 1 - Transmit FIFO0 is empty.
 */
/*@{*/
#define BP_SSI_SISR_TFE0     (0U)          /*!< Bit position for SSI_SISR_TFE0. */
#define BM_SSI_SISR_TFE0     (0x00000001U) /*!< Bit mask for SSI_SISR_TFE0. */
#define BS_SSI_SISR_TFE0     (1U)          /*!< Bit field size in bits for SSI_SISR_TFE0. */

#define BV_SSI_SISR_TFE0_HAS_DATA      (0U)          /*!< Bit field value for SSI_SISR_TFE0: Transmit FIFO0 has data for transmission. */
#define BV_SSI_SISR_TFE0_EMPTY         (0x1U)        /*!< Bit field value for SSI_SISR_TFE0: Transmit FIFO0 is empty. */

/*! @brief Read current value of the SSI_SISR_TFE0 field. */
#define BR_SSI_SISR_TFE0(x)  (HW_SSI_SISR(x).B.TFE0)
/*@}*/

/*!
 * @name Register SSI_SISR, field TFE1[1] (RO)
 *
 * Transmit FIFO Empty 1. This flag is set when the empty slots in Tx FIFO
 * exceed or are equal to the selected Tx FIFO WaterMark 1 (TFWM1) threshold and the
 * Two-Channel mode is selected. The setting of TFE1 only causes an interrupt when
 * TIE and TFE1_EN are set, Tx FIFO1 is enabled and Two-Channel mode is
 * selected. The TFE1 bit is automatically cleared when the data level in Tx FIFO1
 * becomes more than the amount specified by the watermark bits. The TFE1 bit is set by
 * POR and SSI reset.
 *
 * Values:
 * - 0 - Transmit FIFO1 has data for transmission.
 * - 1 - Transmit FIFO1 is empty.
 */
/*@{*/
#define BP_SSI_SISR_TFE1     (1U)          /*!< Bit position for SSI_SISR_TFE1. */
#define BM_SSI_SISR_TFE1     (0x00000002U) /*!< Bit mask for SSI_SISR_TFE1. */
#define BS_SSI_SISR_TFE1     (1U)          /*!< Bit field size in bits for SSI_SISR_TFE1. */

#define BV_SSI_SISR_TFE1_HAS_DATA      (0U)          /*!< Bit field value for SSI_SISR_TFE1: Transmit FIFO1 has data for transmission. */
#define BV_SSI_SISR_TFE1_EMPTY         (0x1U)        /*!< Bit field value for SSI_SISR_TFE1: Transmit FIFO1 is empty. */

/*! @brief Read current value of the SSI_SISR_TFE1 field. */
#define BR_SSI_SISR_TFE1(x)  (HW_SSI_SISR(x).B.TFE1)
/*@}*/

/*!
 * @name Register SSI_SISR, field RFF0[2] (RO)
 *
 * Receive FIFO Full 0. This flag is set when Rx FIFO0 is enabled and the data
 * level in Rx FIFO0 reaches the selected Rx FIFO WaterMark 0 (RFWM0) threshold.
 * The setting of RFF0 only causes an interrupt when RIE and RFF0_EN are set and
 * Rx FIFO0 is enabled. RFF0 is automatically cleared when the amount of data in
 * Rx FIFO0 falls below the threshold. The RFF0 bit is cleared by POR and SSI
 * reset. When Rx FIFO0 contains15 words, the maximum it can hold, all further data
 * received (for storage in this FIFO) is ignored until the FIFO contents are read.
 *
 * Values:
 * - 0 - Space available in Receive FIFO0.
 * - 1 - Receive FIFO0 is full.
 */
/*@{*/
#define BP_SSI_SISR_RFF0     (2U)          /*!< Bit position for SSI_SISR_RFF0. */
#define BM_SSI_SISR_RFF0     (0x00000004U) /*!< Bit mask for SSI_SISR_RFF0. */
#define BS_SSI_SISR_RFF0     (1U)          /*!< Bit field size in bits for SSI_SISR_RFF0. */

#define BV_SSI_SISR_RFF0_NOT_FULL      (0U)          /*!< Bit field value for SSI_SISR_RFF0: Space available in Receive FIFO0. */
#define BV_SSI_SISR_RFF0_FULL          (0x1U)        /*!< Bit field value for SSI_SISR_RFF0: Receive FIFO0 is full. */

/*! @brief Read current value of the SSI_SISR_RFF0 field. */
#define BR_SSI_SISR_RFF0(x)  (HW_SSI_SISR(x).B.RFF0)
/*@}*/

/*!
 * @name Register SSI_SISR, field RFF1[3] (RO)
 *
 * Receive FIFO Full 1. This flag is set when Rx FIFO1 is enabled, the data
 * level in Rx FIFO1 reaches the selected Rx FIFO WaterMark 1 (RFWM1) threshold and
 * the SSI is in Two-Channel mode. The setting of RFF1 only causes an interrupt
 * when RIE and RFF1_EN are set, Rx FIFO1 is enabled and the Two-Channel mode is
 * selected. RFF1 is automatically cleared when the amount of data in Rx FIFO1
 * falls below the threshold. The RFF1 bit is cleared by POR and SSI reset. When Rx
 * FIFO1 contains15 words, the maximum it can hold, all further data received (for
 * storage in this FIFO) is ignored until the FIFO contents are read.
 *
 * Values:
 * - 0 - Space available in Receive FIFO1.
 * - 1 - Receive FIFO1 is full.
 */
/*@{*/
#define BP_SSI_SISR_RFF1     (3U)          /*!< Bit position for SSI_SISR_RFF1. */
#define BM_SSI_SISR_RFF1     (0x00000008U) /*!< Bit mask for SSI_SISR_RFF1. */
#define BS_SSI_SISR_RFF1     (1U)          /*!< Bit field size in bits for SSI_SISR_RFF1. */

#define BV_SSI_SISR_RFF1_NOT_FULL      (0U)          /*!< Bit field value for SSI_SISR_RFF1: Space available in Receive FIFO1. */
#define BV_SSI_SISR_RFF1_FULL          (0x1U)        /*!< Bit field value for SSI_SISR_RFF1: Receive FIFO1 is full. */

/*! @brief Read current value of the SSI_SISR_RFF1 field. */
#define BR_SSI_SISR_RFF1(x)  (HW_SSI_SISR(x).B.RFF1)
/*@}*/

/*!
 * @name Register SSI_SISR, field RLS[4] (RO)
 *
 * Receive Last Time Slot. This flag indicates the last time slot in a frame.
 * When set, it indicates that the current time slot is the last receive time slot
 * of the frame. RLS is set at the end of the last time slot and causes the SSI
 * to issue an interrupt (if RIE and RLS_EN are set). RLS is cleared when the SISR
 * is read with this bit set. The RLS bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - Current time slot is not last time slot of frame.
 * - 1 - Current time slot is the last receive time slot of frame.
 */
/*@{*/
#define BP_SSI_SISR_RLS      (4U)          /*!< Bit position for SSI_SISR_RLS. */
#define BM_SSI_SISR_RLS      (0x00000010U) /*!< Bit mask for SSI_SISR_RLS. */
#define BS_SSI_SISR_RLS      (1U)          /*!< Bit field size in bits for SSI_SISR_RLS. */

/*! @brief Read current value of the SSI_SISR_RLS field. */
#define BR_SSI_SISR_RLS(x)   (HW_SSI_SISR(x).B.RLS)
/*@}*/

/*!
 * @name Register SSI_SISR, field TLS[5] (RO)
 *
 * Transmit Last Time Slot. This flag indicates the last time slot in a frame.
 * When set, it indicates that the current time slot is the last time slot of the
 * frame. TLS is set at the start of the last transmit time slot and causes the
 * SSI to issue an interrupt (if TIE and TLS_EN are set). TLS is not generated
 * when frame rate is 1 in normal mode of operation. TLS is cleared when the SISR is
 * read with this bit set. The TLS bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - Current time slot is not last time slot of frame.
 * - 1 - Current time slot is the last transmit time slot of frame.
 */
/*@{*/
#define BP_SSI_SISR_TLS      (5U)          /*!< Bit position for SSI_SISR_TLS. */
#define BM_SSI_SISR_TLS      (0x00000020U) /*!< Bit mask for SSI_SISR_TLS. */
#define BS_SSI_SISR_TLS      (1U)          /*!< Bit field size in bits for SSI_SISR_TLS. */

/*! @brief Read current value of the SSI_SISR_TLS field. */
#define BR_SSI_SISR_TLS(x)   (HW_SSI_SISR(x).B.TLS)
/*@}*/

/*!
 * @name Register SSI_SISR, field RFS[6] (RO)
 *
 * Receive Frame Sync. This flag indicates the occurrence of receive frame sync.
 * In Network mode, the RFS bit is set when the first slot of the frame is being
 * received. It is cleared when the next slot begins to be received. In Normal
 * mode, this bit is always high (When DC = 0). This flag causes an interrupt if
 * RIE and RFS_EN are set. The RFS bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - No Occurrence of Receive frame sync.
 * - 1 - Receive frame sync occurred during reception of next word in SRX
 *     registers.
 */
/*@{*/
#define BP_SSI_SISR_RFS      (6U)          /*!< Bit position for SSI_SISR_RFS. */
#define BM_SSI_SISR_RFS      (0x00000040U) /*!< Bit mask for SSI_SISR_RFS. */
#define BS_SSI_SISR_RFS      (1U)          /*!< Bit field size in bits for SSI_SISR_RFS. */

/*! @brief Read current value of the SSI_SISR_RFS field. */
#define BR_SSI_SISR_RFS(x)   (HW_SSI_SISR(x).B.RFS)
/*@}*/

/*!
 * @name Register SSI_SISR, field TFS[7] (RO)
 *
 * Transmit Frame Sync. This flag indicates the occurrence of transmit frame
 * sync. Data written to the STX registers during the time slot when the TFS flag is
 * set, is sent during the second time slot (in Network mode) or in the next
 * first time slot (in Normal mode). In Network mode, the TFS bit is set during
 * transmission of the first time slot of the frame and is then cleared when starting
 * transmission of the next time slot. In Normal mode, this bit is high for the
 * first time slot. This flag causes an interrupt if TIE and TFS_EN are set. The
 * TFS bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - No Occurrence of Transmit frame sync.
 * - 1 - Transmit frame sync occurred during transmission of last word written
 *     to STX registers.
 */
/*@{*/
#define BP_SSI_SISR_TFS      (7U)          /*!< Bit position for SSI_SISR_TFS. */
#define BM_SSI_SISR_TFS      (0x00000080U) /*!< Bit mask for SSI_SISR_TFS. */
#define BS_SSI_SISR_TFS      (1U)          /*!< Bit field size in bits for SSI_SISR_TFS. */

/*! @brief Read current value of the SSI_SISR_TFS field. */
#define BR_SSI_SISR_TFS(x)   (HW_SSI_SISR(x).B.TFS)
/*@}*/

/*!
 * @name Register SSI_SISR, field TUE0[8] (W1C)
 *
 * Transmitter Underrun Error 0. This flag is set when the TXSR is empty (no
 * data to be transmitted), the TDE0 flag is set and a transmit time slot occurs.
 * When a transmit underrun error occurs, the previous data is retransmitted. In
 * Network mode, each time slot requires data transmission (unless masked through
 * STMSK register), when the transmitter is enabled (TE is set). The TUE0 flag
 * causes an interrupt if TIE and TUE0_EN are set. The TUE0 bit is cleared by POR
 * and SSI reset. It is also cleared by writing '1' to this bit.
 *
 * Values:
 * - 0 - Default interrupt issued to the Core.
 * - 1 - Exception interrupt issued to the Core.
 */
/*@{*/
#define BP_SSI_SISR_TUE0     (8U)          /*!< Bit position for SSI_SISR_TUE0. */
#define BM_SSI_SISR_TUE0     (0x00000100U) /*!< Bit mask for SSI_SISR_TUE0. */
#define BS_SSI_SISR_TUE0     (1U)          /*!< Bit field size in bits for SSI_SISR_TUE0. */

/*! @brief Read current value of the SSI_SISR_TUE0 field. */
#define BR_SSI_SISR_TUE0(x)  (HW_SSI_SISR(x).B.TUE0)

/*! @brief Format value for bitfield SSI_SISR_TUE0. */
#define BF_SSI_SISR_TUE0(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SISR_TUE0) & BM_SSI_SISR_TUE0)

/*! @brief Set the TUE0 field to a new value. */
#define BW_SSI_SISR_TUE0(x, v) (HW_SSI_SISR_WR(x, (HW_SSI_SISR_RD(x) & ~(BM_SSI_SISR_TUE0 | BM_SSI_SISR_TUE1 | BM_SSI_SISR_ROE0 | BM_SSI_SISR_ROE1)) | BF_SSI_SISR_TUE0(v)))
/*@}*/

/*!
 * @name Register SSI_SISR, field TUE1[9] (W1C)
 *
 * Transmitter Underrun Error 1. This flag is set when the TXSR is empty (no
 * data to be transmitted), the TDE1 flag is set, a transmit time slot occurs and
 * the SSI is in Two-Channel mode. When a transmit underrun error occurs, the
 * previous data is retransmitted. In Network mode, each time slot requires data
 * transmission (unless masked through STMSK register), when the transmitter is
 * enabled (TE is set). The TUE1 flag causes an interrupt if TIE and TUE1_EN are set.
 * The TUE1 bit is cleared by POR and SSI reset. It is also cleared by writing '1'
 * to this bit.
 *
 * Values:
 * - 0 - Default interrupt issued to the Core.
 * - 1 - Exception interrupt issued to the Core.
 */
/*@{*/
#define BP_SSI_SISR_TUE1     (9U)          /*!< Bit position for SSI_SISR_TUE1. */
#define BM_SSI_SISR_TUE1     (0x00000200U) /*!< Bit mask for SSI_SISR_TUE1. */
#define BS_SSI_SISR_TUE1     (1U)          /*!< Bit field size in bits for SSI_SISR_TUE1. */

/*! @brief Read current value of the SSI_SISR_TUE1 field. */
#define BR_SSI_SISR_TUE1(x)  (HW_SSI_SISR(x).B.TUE1)

/*! @brief Format value for bitfield SSI_SISR_TUE1. */
#define BF_SSI_SISR_TUE1(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SISR_TUE1) & BM_SSI_SISR_TUE1)

/*! @brief Set the TUE1 field to a new value. */
#define BW_SSI_SISR_TUE1(x, v) (HW_SSI_SISR_WR(x, (HW_SSI_SISR_RD(x) & ~(BM_SSI_SISR_TUE1 | BM_SSI_SISR_TUE0 | BM_SSI_SISR_ROE0 | BM_SSI_SISR_ROE1)) | BF_SSI_SISR_TUE1(v)))
/*@}*/

/*!
 * @name Register SSI_SISR, field ROE0[10] (W1C)
 *
 * Receiver Overrun Error 0. This flag is set when the RXSR is filled and ready
 * to transfer to SRX0 register or to Rx FIFO 0 (when enabled) and these are
 * already full. If Rx FIFO 0 is enabled, this is indicated by RFF0 flag, else this
 * is indicated by the RDR0 flag. The RXSR is not transferred in this case. The
 * ROE0 flag causes an interrupt if RIE and ROE0_EN are set. The ROE0 bit is
 * cleared by POR and SSI reset. It is also cleared by writing '1' to this bit.
 * Clearing the RE bit does not affect the ROE0 bit.
 *
 * Values:
 * - 0 - Default interrupt issued to the Core.
 * - 1 - Exception interrupt issued to the Core.
 */
/*@{*/
#define BP_SSI_SISR_ROE0     (10U)         /*!< Bit position for SSI_SISR_ROE0. */
#define BM_SSI_SISR_ROE0     (0x00000400U) /*!< Bit mask for SSI_SISR_ROE0. */
#define BS_SSI_SISR_ROE0     (1U)          /*!< Bit field size in bits for SSI_SISR_ROE0. */

/*! @brief Read current value of the SSI_SISR_ROE0 field. */
#define BR_SSI_SISR_ROE0(x)  (HW_SSI_SISR(x).B.ROE0)

/*! @brief Format value for bitfield SSI_SISR_ROE0. */
#define BF_SSI_SISR_ROE0(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SISR_ROE0) & BM_SSI_SISR_ROE0)

/*! @brief Set the ROE0 field to a new value. */
#define BW_SSI_SISR_ROE0(x, v) (HW_SSI_SISR_WR(x, (HW_SSI_SISR_RD(x) & ~(BM_SSI_SISR_ROE0 | BM_SSI_SISR_TUE0 | BM_SSI_SISR_TUE1 | BM_SSI_SISR_ROE1)) | BF_SSI_SISR_ROE0(v)))
/*@}*/

/*!
 * @name Register SSI_SISR, field ROE1[11] (W1C)
 *
 * Receiver Overrun Error 1. This flag is set when the RXSR is filled and ready
 * to transfer to SRX1 register or to Rx FIFO 1 (when enabled) and these are
 * already full and Two-Channel mode is selected. If Rx FIFO 1 is enabled, this is
 * indicated by RFF1 flag, else this is indicated by the RDR1 flag. The RXSR is not
 * transferred in this case. The ROE1 flag causes an interrupt if RIE and
 * ROE1_EN are set. The ROE1 bit is cleared by POR and SSI reset. It is also cleared by
 * writing '1' to this bit. Clearing the RE bit does not affect the ROE1 bit.
 *
 * Values:
 * - 0 - Default interrupt issued to the Core.
 * - 1 - Exception interrupt issued to the Core.
 */
/*@{*/
#define BP_SSI_SISR_ROE1     (11U)         /*!< Bit position for SSI_SISR_ROE1. */
#define BM_SSI_SISR_ROE1     (0x00000800U) /*!< Bit mask for SSI_SISR_ROE1. */
#define BS_SSI_SISR_ROE1     (1U)          /*!< Bit field size in bits for SSI_SISR_ROE1. */

/*! @brief Read current value of the SSI_SISR_ROE1 field. */
#define BR_SSI_SISR_ROE1(x)  (HW_SSI_SISR(x).B.ROE1)

/*! @brief Format value for bitfield SSI_SISR_ROE1. */
#define BF_SSI_SISR_ROE1(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SISR_ROE1) & BM_SSI_SISR_ROE1)

/*! @brief Set the ROE1 field to a new value. */
#define BW_SSI_SISR_ROE1(x, v) (HW_SSI_SISR_WR(x, (HW_SSI_SISR_RD(x) & ~(BM_SSI_SISR_ROE1 | BM_SSI_SISR_TUE0 | BM_SSI_SISR_TUE1 | BM_SSI_SISR_ROE0)) | BF_SSI_SISR_ROE1(v)))
/*@}*/

/*!
 * @name Register SSI_SISR, field TDE0[12] (RO)
 *
 * Transmit Data Register Empty 0. This flag is set whenever data is transferred
 * to TXSR from STX0 register. If Tx FIFO 0 is enabled, this occurs when there
 * is at least one empty slot in STX0 or Tx FIFO 0. If Tx FIFO 0 is not enabled,
 * this occurs when the contents of STX0 are transferred to TXSR. The TDE0 bit is
 * cleared when the Core writes to STX0. If TIE and TDE0_EN are set, an SSI
 * Transmit Data 0 interrupt request is issued on setting of TDE0 bit. The TDE0 bit is
 * cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - Data available for transmission.
 * - 1 - Data needs to be written by the Core for transmission.
 */
/*@{*/
#define BP_SSI_SISR_TDE0     (12U)         /*!< Bit position for SSI_SISR_TDE0. */
#define BM_SSI_SISR_TDE0     (0x00001000U) /*!< Bit mask for SSI_SISR_TDE0. */
#define BS_SSI_SISR_TDE0     (1U)          /*!< Bit field size in bits for SSI_SISR_TDE0. */

/*! @brief Read current value of the SSI_SISR_TDE0 field. */
#define BR_SSI_SISR_TDE0(x)  (HW_SSI_SISR(x).B.TDE0)
/*@}*/

/*!
 * @name Register SSI_SISR, field TDE1[13] (RO)
 *
 * Transmit Data Register Empty 1. This flag is set whenever data is transferred
 * to TXSR from STX1 register and Two-Channel mode is selected. If Tx FIFO1 is
 * enabled, this occurs when there is at least one empty slot in STX1 or Tx FIFO1.
 * If Tx FIFO1 is not enabled, this occurs when the contents of STX1 are
 * transferred to TXSR. The TDE1 bit is cleared when the Core writes to STX1. If TIE and
 * TDE1_EN are set, an SSI Transmit Data 1 interrupt request is issued on
 * setting of TDE1 bit. The TDE1 bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - Data available for transmission.
 * - 1 - Data needs to be written by the Core for transmission.
 */
/*@{*/
#define BP_SSI_SISR_TDE1     (13U)         /*!< Bit position for SSI_SISR_TDE1. */
#define BM_SSI_SISR_TDE1     (0x00002000U) /*!< Bit mask for SSI_SISR_TDE1. */
#define BS_SSI_SISR_TDE1     (1U)          /*!< Bit field size in bits for SSI_SISR_TDE1. */

/*! @brief Read current value of the SSI_SISR_TDE1 field. */
#define BR_SSI_SISR_TDE1(x)  (HW_SSI_SISR(x).B.TDE1)
/*@}*/

/*!
 * @name Register SSI_SISR, field RDR0[14] (RO)
 *
 * Receive Data Ready 0. This flag bit is set when SRX0 or Rx FIFO 0 is loaded
 * with a new value. RDR0 is cleared when the Core reads the SRX0 register. If Rx
 * FIFO 0 is enabled, RDR0 is cleared when the FIFO is empty. If RIE and RDR0_EN
 * are set, a Receive Data 0 interrupt request is issued on setting of RDR0 bit
 * in case Rx FIFO0 is disabled, if the FIFO is enabled, the interrupt is issued
 * on RFF0 assertion. The RDR0 bit is cleared by POR and SSI reset.
 *
 * Values:
 * - 0 - No new data for Core to read.
 * - 1 - New data for Core to read.
 */
/*@{*/
#define BP_SSI_SISR_RDR0     (14U)         /*!< Bit position for SSI_SISR_RDR0. */
#define BM_SSI_SISR_RDR0     (0x00004000U) /*!< Bit mask for SSI_SISR_RDR0. */
#define BS_SSI_SISR_RDR0     (1U)          /*!< Bit field size in bits for SSI_SISR_RDR0. */

/*! @brief Read current value of the SSI_SISR_RDR0 field. */
#define BR_SSI_SISR_RDR0(x)  (HW_SSI_SISR(x).B.RDR0)
/*@}*/

/*!
 * @name Register SSI_SISR, field RDR1[15] (RO)
 *
 * Receive Data Ready 1. This flag bit is set when SRX1 or Rx FIFO 1 is loaded
 * with a new value and Two-Channel mode is selected. RDR1 is cleared when the
 * Core reads the SRX1 register. If Rx FIFO 1 is enabled, RDR1 is cleared when the
 * FIFO is empty. If RIE and RDR1_EN are set, a Receive Data 1 interrupt request
 * is issued on setting of RDR1 bit in case Rx FIFO1 is disabled, if the FIFO is
 * enabled, the interrupt is issued on RFF1 assertion. The RDR1 bit is cleared by
 * POR and SSI reset.
 *
 * Values:
 * - 0 - No new data for Core to read.
 * - 1 - New data for Core to read.
 */
/*@{*/
#define BP_SSI_SISR_RDR1     (15U)         /*!< Bit position for SSI_SISR_RDR1. */
#define BM_SSI_SISR_RDR1     (0x00008000U) /*!< Bit mask for SSI_SISR_RDR1. */
#define BS_SSI_SISR_RDR1     (1U)          /*!< Bit field size in bits for SSI_SISR_RDR1. */

/*! @brief Read current value of the SSI_SISR_RDR1 field. */
#define BR_SSI_SISR_RDR1(x)  (HW_SSI_SISR(x).B.RDR1)
/*@}*/

/*!
 * @name Register SSI_SISR, field RXT[16] (RO)
 *
 * Receive Tag Updated. This status bit is set each time there is a difference
 * in the previous and current value of the received tag. It causes the Receive
 * Tag Interrupt (if RXT_EN bit is set). This bit is cleared on reading the SATAG
 * register.
 *
 * Values:
 * - 0 - No change in SATAG register.
 * - 1 - SATAG register updated with different value.
 */
/*@{*/
#define BP_SSI_SISR_RXT      (16U)         /*!< Bit position for SSI_SISR_RXT. */
#define BM_SSI_SISR_RXT      (0x00010000U) /*!< Bit mask for SSI_SISR_RXT. */
#define BS_SSI_SISR_RXT      (1U)          /*!< Bit field size in bits for SSI_SISR_RXT. */

/*! @brief Read current value of the SSI_SISR_RXT field. */
#define BR_SSI_SISR_RXT(x)   (HW_SSI_SISR(x).B.RXT)
/*@}*/

/*!
 * @name Register SSI_SISR, field CMDDU[17] (RO)
 *
 * Command Data Register Updated. This bit causes the Command Data Updated
 * interrupt (when CMDDU_EN bit is set). This status bit is set each time there is a
 * difference in the previous and current value of the received Command Data. This
 * bit is cleared on reading the SACDAT register.
 *
 * Values:
 * - 0 - No change in SACDAT register.
 * - 1 - SACDAT register updated with different value.
 */
/*@{*/
#define BP_SSI_SISR_CMDDU    (17U)         /*!< Bit position for SSI_SISR_CMDDU. */
#define BM_SSI_SISR_CMDDU    (0x00020000U) /*!< Bit mask for SSI_SISR_CMDDU. */
#define BS_SSI_SISR_CMDDU    (1U)          /*!< Bit field size in bits for SSI_SISR_CMDDU. */

/*! @brief Read current value of the SSI_SISR_CMDDU field. */
#define BR_SSI_SISR_CMDDU(x) (HW_SSI_SISR(x).B.CMDDU)
/*@}*/

/*!
 * @name Register SSI_SISR, field CMDAU[18] (RO)
 *
 * Command Address Register Updated. This bit causes the Command Address Updated
 * interrupt (when CMDAU_EN bit is set). This status bit is set each time there
 * is a difference in the previous and current value of the received Command
 * Address. This bit is cleared on reading the SACADD register.
 *
 * Values:
 * - 0 - No change in SACADD register.
 * - 1 - SACADD register updated with different value.
 */
/*@{*/
#define BP_SSI_SISR_CMDAU    (18U)         /*!< Bit position for SSI_SISR_CMDAU. */
#define BM_SSI_SISR_CMDAU    (0x00040000U) /*!< Bit mask for SSI_SISR_CMDAU. */
#define BS_SSI_SISR_CMDAU    (1U)          /*!< Bit field size in bits for SSI_SISR_CMDAU. */

/*! @brief Read current value of the SSI_SISR_CMDAU field. */
#define BR_SSI_SISR_CMDAU(x) (HW_SSI_SISR(x).B.CMDAU)
/*@}*/

/*!
 * @name Register SSI_SISR, field TFRC[23] (RO)
 *
 * Transmit Frame Complete. This flag is set at the end of the frame during
 * which Transmitter is disabled. If Transmit Frame & Clock are not disabled in the
 * same frame, this flag is also set at the end of the frame in which Transmit
 * Frame & Clock are disabled. See description of TFR_CLK_DIS bit for more details
 * on how to disable Transmit Frame & Clock or keep them enabled after transmitter
 * is disabled.
 *
 * Values:
 * - 0 - End of Frame not reached
 * - 1 - End of frame reached after disabling TE or disabling TFR_CLK_DIS, when
 *     transmitter is already disabled.
 */
/*@{*/
#define BP_SSI_SISR_TFRC     (23U)         /*!< Bit position for SSI_SISR_TFRC. */
#define BM_SSI_SISR_TFRC     (0x00800000U) /*!< Bit mask for SSI_SISR_TFRC. */
#define BS_SSI_SISR_TFRC     (1U)          /*!< Bit field size in bits for SSI_SISR_TFRC. */

/*! @brief Read current value of the SSI_SISR_TFRC field. */
#define BR_SSI_SISR_TFRC(x)  (HW_SSI_SISR(x).B.TFRC)
/*@}*/

/*!
 * @name Register SSI_SISR, field RFRC[24] (RO)
 *
 * Receive Frame Complete. This flag is set at the end of the frame during which
 * Receiver is disabled. If Receive Frame & Clock are not disabled in the same
 * frame, this flag is also set at the end of the frame in which Receive Frame &
 * Clock are disabled. See the description of RFR_CLK_DIS bit for more details on
 * how to disable Receiver Frame & Clock or keep them enabled after receiver is
 * disabled.
 *
 * Values:
 * - 0 - End of Frame not reached
 * - 1 - End of frame reached after disabling RE or disabling RFR_CLK_DIS, when
 *     receiver is already disabled.
 */
/*@{*/
#define BP_SSI_SISR_RFRC     (24U)         /*!< Bit position for SSI_SISR_RFRC. */
#define BM_SSI_SISR_RFRC     (0x01000000U) /*!< Bit mask for SSI_SISR_RFRC. */
#define BS_SSI_SISR_RFRC     (1U)          /*!< Bit field size in bits for SSI_SISR_RFRC. */

/*! @brief Read current value of the SSI_SISR_RFRC field. */
#define BR_SSI_SISR_RFRC(x)  (HW_SSI_SISR(x).B.RFRC)
/*@}*/

/*******************************************************************************
 * HW_SSI_SIER - SSI Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SIER - SSI Interrupt Enable Register (RW)
 *
 * Reset value: 0x00003003U
 *
 * The SSI Interrupt Enable Register (SIER) is a 25-bit register used to set up
 * the SSI interrupts and DMA requests.
 */
typedef union _hw_ssi_sier
{
    uint32_t U;
    struct _hw_ssi_sier_bitfields
    {
        uint32_t TFE0IE : 1;           /*!< [0]  */
        uint32_t TFE1IE : 1;           /*!< [1]  */
        uint32_t RFF0IE : 1;           /*!< [2]  */
        uint32_t RFF1IE : 1;           /*!< [3]  */
        uint32_t RLSIE : 1;            /*!< [4]  */
        uint32_t TLSIE : 1;            /*!< [5]  */
        uint32_t RFSIE : 1;            /*!< [6]  */
        uint32_t TFSIE : 1;            /*!< [7]  */
        uint32_t TUE0IE : 1;           /*!< [8]  */
        uint32_t TUE1IE : 1;           /*!< [9]  */
        uint32_t ROE0IE : 1;           /*!< [10]  */
        uint32_t ROE1IE : 1;           /*!< [11]  */
        uint32_t TDE0IE : 1;           /*!< [12]  */
        uint32_t TDE1IE : 1;           /*!< [13]  */
        uint32_t RDR0IE : 1;           /*!< [14]  */
        uint32_t RDR1IE : 1;           /*!< [15]  */
        uint32_t RXTIE : 1;            /*!< [16]  */
        uint32_t CMDDUIE : 1;          /*!< [17]  */
        uint32_t CMDAUIE : 1;          /*!< [18]  */
        uint32_t TIE : 1;              /*!< [19]  */
        uint32_t TDMAE : 1;            /*!< [20]  */
        uint32_t RIE : 1;              /*!< [21]  */
        uint32_t RDMAE : 1;            /*!< [22]  */
        uint32_t TFRCIE : 1;           /*!< [23]  */
        uint32_t RFRCIE : 1;           /*!< [24]  */
        uint32_t RESERVED0 : 7;        /*!< [31:25]  */
    } B;
} hw_ssi_sier_t;

/*!
 * @name Constants and macros for entire SSI_SIER register
 */
/*@{*/
#define HW_SSI_SIER_ADDR(x)      ((uintptr_t)(x) + 0x18U)

#define HW_SSI_SIER(x)           (*(__IO hw_ssi_sier_t *) HW_SSI_SIER_ADDR(x))
#define HW_SSI_SIER_RD(x)        (HW_SSI_SIER(x).U)
#define HW_SSI_SIER_WR(x, v)     (HW_SSI_SIER(x).U = (v))
#define HW_SSI_SIER_SET(x, v)    (HW_SSI_SIER_WR(x, HW_SSI_SIER_RD(x) |  (v)))
#define HW_SSI_SIER_CLR(x, v)    (HW_SSI_SIER_WR(x, HW_SSI_SIER_RD(x) & ~(v)))
#define HW_SSI_SIER_TOG(x, v)    (HW_SSI_SIER_WR(x, HW_SSI_SIER_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SIER bitfields
 */

/*!
 * @name Register SSI_SIER, field TFE0IE[0] (RW)
 *
 * Transmit FIFO Empty 0 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TFE0IE   (0U)          /*!< Bit position for SSI_SIER_TFE0IE. */
#define BM_SSI_SIER_TFE0IE   (0x00000001U) /*!< Bit mask for SSI_SIER_TFE0IE. */
#define BS_SSI_SIER_TFE0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TFE0IE. */

/*! @brief Read current value of the SSI_SIER_TFE0IE field. */
#define BR_SSI_SIER_TFE0IE(x) (HW_SSI_SIER(x).B.TFE0IE)

/*! @brief Format value for bitfield SSI_SIER_TFE0IE. */
#define BF_SSI_SIER_TFE0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TFE0IE) & BM_SSI_SIER_TFE0IE)

/*! @brief Set the TFE0IE field to a new value. */
#define BW_SSI_SIER_TFE0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TFE0IE) | BF_SSI_SIER_TFE0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TFE1IE[1] (RW)
 *
 * Transmit FIFO Empty 1 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TFE1IE   (1U)          /*!< Bit position for SSI_SIER_TFE1IE. */
#define BM_SSI_SIER_TFE1IE   (0x00000002U) /*!< Bit mask for SSI_SIER_TFE1IE. */
#define BS_SSI_SIER_TFE1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TFE1IE. */

/*! @brief Read current value of the SSI_SIER_TFE1IE field. */
#define BR_SSI_SIER_TFE1IE(x) (HW_SSI_SIER(x).B.TFE1IE)

/*! @brief Format value for bitfield SSI_SIER_TFE1IE. */
#define BF_SSI_SIER_TFE1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TFE1IE) & BM_SSI_SIER_TFE1IE)

/*! @brief Set the TFE1IE field to a new value. */
#define BW_SSI_SIER_TFE1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TFE1IE) | BF_SSI_SIER_TFE1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RFF0IE[2] (RW)
 *
 * Receive FIFO Full 0 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RFF0IE   (2U)          /*!< Bit position for SSI_SIER_RFF0IE. */
#define BM_SSI_SIER_RFF0IE   (0x00000004U) /*!< Bit mask for SSI_SIER_RFF0IE. */
#define BS_SSI_SIER_RFF0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_RFF0IE. */

/*! @brief Read current value of the SSI_SIER_RFF0IE field. */
#define BR_SSI_SIER_RFF0IE(x) (HW_SSI_SIER(x).B.RFF0IE)

/*! @brief Format value for bitfield SSI_SIER_RFF0IE. */
#define BF_SSI_SIER_RFF0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RFF0IE) & BM_SSI_SIER_RFF0IE)

/*! @brief Set the RFF0IE field to a new value. */
#define BW_SSI_SIER_RFF0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RFF0IE) | BF_SSI_SIER_RFF0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RFF1IE[3] (RW)
 *
 * Receive FIFO Full 1 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RFF1IE   (3U)          /*!< Bit position for SSI_SIER_RFF1IE. */
#define BM_SSI_SIER_RFF1IE   (0x00000008U) /*!< Bit mask for SSI_SIER_RFF1IE. */
#define BS_SSI_SIER_RFF1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_RFF1IE. */

/*! @brief Read current value of the SSI_SIER_RFF1IE field. */
#define BR_SSI_SIER_RFF1IE(x) (HW_SSI_SIER(x).B.RFF1IE)

/*! @brief Format value for bitfield SSI_SIER_RFF1IE. */
#define BF_SSI_SIER_RFF1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RFF1IE) & BM_SSI_SIER_RFF1IE)

/*! @brief Set the RFF1IE field to a new value. */
#define BW_SSI_SIER_RFF1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RFF1IE) | BF_SSI_SIER_RFF1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RLSIE[4] (RW)
 *
 * Receive Last Time Slot Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RLSIE    (4U)          /*!< Bit position for SSI_SIER_RLSIE. */
#define BM_SSI_SIER_RLSIE    (0x00000010U) /*!< Bit mask for SSI_SIER_RLSIE. */
#define BS_SSI_SIER_RLSIE    (1U)          /*!< Bit field size in bits for SSI_SIER_RLSIE. */

/*! @brief Read current value of the SSI_SIER_RLSIE field. */
#define BR_SSI_SIER_RLSIE(x) (HW_SSI_SIER(x).B.RLSIE)

/*! @brief Format value for bitfield SSI_SIER_RLSIE. */
#define BF_SSI_SIER_RLSIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RLSIE) & BM_SSI_SIER_RLSIE)

/*! @brief Set the RLSIE field to a new value. */
#define BW_SSI_SIER_RLSIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RLSIE) | BF_SSI_SIER_RLSIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TLSIE[5] (RO)
 *
 * Transmit Last Time Slot Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TLSIE    (5U)          /*!< Bit position for SSI_SIER_TLSIE. */
#define BM_SSI_SIER_TLSIE    (0x00000020U) /*!< Bit mask for SSI_SIER_TLSIE. */
#define BS_SSI_SIER_TLSIE    (1U)          /*!< Bit field size in bits for SSI_SIER_TLSIE. */

/*! @brief Read current value of the SSI_SIER_TLSIE field. */
#define BR_SSI_SIER_TLSIE(x) (HW_SSI_SIER(x).B.TLSIE)
/*@}*/

/*!
 * @name Register SSI_SIER, field RFSIE[6] (RW)
 *
 * Receive Frame Sync Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RFSIE    (6U)          /*!< Bit position for SSI_SIER_RFSIE. */
#define BM_SSI_SIER_RFSIE    (0x00000040U) /*!< Bit mask for SSI_SIER_RFSIE. */
#define BS_SSI_SIER_RFSIE    (1U)          /*!< Bit field size in bits for SSI_SIER_RFSIE. */

/*! @brief Read current value of the SSI_SIER_RFSIE field. */
#define BR_SSI_SIER_RFSIE(x) (HW_SSI_SIER(x).B.RFSIE)

/*! @brief Format value for bitfield SSI_SIER_RFSIE. */
#define BF_SSI_SIER_RFSIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RFSIE) & BM_SSI_SIER_RFSIE)

/*! @brief Set the RFSIE field to a new value. */
#define BW_SSI_SIER_RFSIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RFSIE) | BF_SSI_SIER_RFSIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TFSIE[7] (RW)
 *
 * Transmit Frame Sync Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TFSIE    (7U)          /*!< Bit position for SSI_SIER_TFSIE. */
#define BM_SSI_SIER_TFSIE    (0x00000080U) /*!< Bit mask for SSI_SIER_TFSIE. */
#define BS_SSI_SIER_TFSIE    (1U)          /*!< Bit field size in bits for SSI_SIER_TFSIE. */

/*! @brief Read current value of the SSI_SIER_TFSIE field. */
#define BR_SSI_SIER_TFSIE(x) (HW_SSI_SIER(x).B.TFSIE)

/*! @brief Format value for bitfield SSI_SIER_TFSIE. */
#define BF_SSI_SIER_TFSIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TFSIE) & BM_SSI_SIER_TFSIE)

/*! @brief Set the TFSIE field to a new value. */
#define BW_SSI_SIER_TFSIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TFSIE) | BF_SSI_SIER_TFSIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TUE0IE[8] (RW)
 *
 * Transmitter Underrun Error 0 Interrupt Enable. Enable Bit. Controls whether
 * the corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TUE0IE   (8U)          /*!< Bit position for SSI_SIER_TUE0IE. */
#define BM_SSI_SIER_TUE0IE   (0x00000100U) /*!< Bit mask for SSI_SIER_TUE0IE. */
#define BS_SSI_SIER_TUE0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TUE0IE. */

/*! @brief Read current value of the SSI_SIER_TUE0IE field. */
#define BR_SSI_SIER_TUE0IE(x) (HW_SSI_SIER(x).B.TUE0IE)

/*! @brief Format value for bitfield SSI_SIER_TUE0IE. */
#define BF_SSI_SIER_TUE0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TUE0IE) & BM_SSI_SIER_TUE0IE)

/*! @brief Set the TUE0IE field to a new value. */
#define BW_SSI_SIER_TUE0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TUE0IE) | BF_SSI_SIER_TUE0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TUE1IE[9] (RW)
 *
 * Transmitter Underrun Error 1 Interrupt Enable. Enable Bit. Controls whether
 * the corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TUE1IE   (9U)          /*!< Bit position for SSI_SIER_TUE1IE. */
#define BM_SSI_SIER_TUE1IE   (0x00000200U) /*!< Bit mask for SSI_SIER_TUE1IE. */
#define BS_SSI_SIER_TUE1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TUE1IE. */

/*! @brief Read current value of the SSI_SIER_TUE1IE field. */
#define BR_SSI_SIER_TUE1IE(x) (HW_SSI_SIER(x).B.TUE1IE)

/*! @brief Format value for bitfield SSI_SIER_TUE1IE. */
#define BF_SSI_SIER_TUE1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TUE1IE) & BM_SSI_SIER_TUE1IE)

/*! @brief Set the TUE1IE field to a new value. */
#define BW_SSI_SIER_TUE1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TUE1IE) | BF_SSI_SIER_TUE1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field ROE0IE[10] (RW)
 *
 * Receiver Overrun Error 0 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_ROE0IE   (10U)         /*!< Bit position for SSI_SIER_ROE0IE. */
#define BM_SSI_SIER_ROE0IE   (0x00000400U) /*!< Bit mask for SSI_SIER_ROE0IE. */
#define BS_SSI_SIER_ROE0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_ROE0IE. */

/*! @brief Read current value of the SSI_SIER_ROE0IE field. */
#define BR_SSI_SIER_ROE0IE(x) (HW_SSI_SIER(x).B.ROE0IE)

/*! @brief Format value for bitfield SSI_SIER_ROE0IE. */
#define BF_SSI_SIER_ROE0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_ROE0IE) & BM_SSI_SIER_ROE0IE)

/*! @brief Set the ROE0IE field to a new value. */
#define BW_SSI_SIER_ROE0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_ROE0IE) | BF_SSI_SIER_ROE0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field ROE1IE[11] (RW)
 *
 * Receiver Overrun Error 1 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_ROE1IE   (11U)         /*!< Bit position for SSI_SIER_ROE1IE. */
#define BM_SSI_SIER_ROE1IE   (0x00000800U) /*!< Bit mask for SSI_SIER_ROE1IE. */
#define BS_SSI_SIER_ROE1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_ROE1IE. */

/*! @brief Read current value of the SSI_SIER_ROE1IE field. */
#define BR_SSI_SIER_ROE1IE(x) (HW_SSI_SIER(x).B.ROE1IE)

/*! @brief Format value for bitfield SSI_SIER_ROE1IE. */
#define BF_SSI_SIER_ROE1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_ROE1IE) & BM_SSI_SIER_ROE1IE)

/*! @brief Set the ROE1IE field to a new value. */
#define BW_SSI_SIER_ROE1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_ROE1IE) | BF_SSI_SIER_ROE1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TDE0IE[12] (RW)
 *
 * Transmit Data Register Empty 0 Interrupt Enable. Enable Bit. Controls whether
 * the corresponding status bit in SISR can issue an interrupt to the core or
 * not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TDE0IE   (12U)         /*!< Bit position for SSI_SIER_TDE0IE. */
#define BM_SSI_SIER_TDE0IE   (0x00001000U) /*!< Bit mask for SSI_SIER_TDE0IE. */
#define BS_SSI_SIER_TDE0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TDE0IE. */

/*! @brief Read current value of the SSI_SIER_TDE0IE field. */
#define BR_SSI_SIER_TDE0IE(x) (HW_SSI_SIER(x).B.TDE0IE)

/*! @brief Format value for bitfield SSI_SIER_TDE0IE. */
#define BF_SSI_SIER_TDE0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TDE0IE) & BM_SSI_SIER_TDE0IE)

/*! @brief Set the TDE0IE field to a new value. */
#define BW_SSI_SIER_TDE0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TDE0IE) | BF_SSI_SIER_TDE0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TDE1IE[13] (RW)
 *
 * Transmit Data Register Empty 1 Interrupt Enable. Enable Bit. Controls whether
 * the corresponding status bit in SISR can issue an interrupt to the core or
 * not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TDE1IE   (13U)         /*!< Bit position for SSI_SIER_TDE1IE. */
#define BM_SSI_SIER_TDE1IE   (0x00002000U) /*!< Bit mask for SSI_SIER_TDE1IE. */
#define BS_SSI_SIER_TDE1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_TDE1IE. */

/*! @brief Read current value of the SSI_SIER_TDE1IE field. */
#define BR_SSI_SIER_TDE1IE(x) (HW_SSI_SIER(x).B.TDE1IE)

/*! @brief Format value for bitfield SSI_SIER_TDE1IE. */
#define BF_SSI_SIER_TDE1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TDE1IE) & BM_SSI_SIER_TDE1IE)

/*! @brief Set the TDE1IE field to a new value. */
#define BW_SSI_SIER_TDE1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TDE1IE) | BF_SSI_SIER_TDE1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RDR0IE[14] (RW)
 *
 * Receive Data Ready 0 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RDR0IE   (14U)         /*!< Bit position for SSI_SIER_RDR0IE. */
#define BM_SSI_SIER_RDR0IE   (0x00004000U) /*!< Bit mask for SSI_SIER_RDR0IE. */
#define BS_SSI_SIER_RDR0IE   (1U)          /*!< Bit field size in bits for SSI_SIER_RDR0IE. */

/*! @brief Read current value of the SSI_SIER_RDR0IE field. */
#define BR_SSI_SIER_RDR0IE(x) (HW_SSI_SIER(x).B.RDR0IE)

/*! @brief Format value for bitfield SSI_SIER_RDR0IE. */
#define BF_SSI_SIER_RDR0IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RDR0IE) & BM_SSI_SIER_RDR0IE)

/*! @brief Set the RDR0IE field to a new value. */
#define BW_SSI_SIER_RDR0IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RDR0IE) | BF_SSI_SIER_RDR0IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RDR1IE[15] (RW)
 *
 * Receive Data Ready 1 Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RDR1IE   (15U)         /*!< Bit position for SSI_SIER_RDR1IE. */
#define BM_SSI_SIER_RDR1IE   (0x00008000U) /*!< Bit mask for SSI_SIER_RDR1IE. */
#define BS_SSI_SIER_RDR1IE   (1U)          /*!< Bit field size in bits for SSI_SIER_RDR1IE. */

/*! @brief Read current value of the SSI_SIER_RDR1IE field. */
#define BR_SSI_SIER_RDR1IE(x) (HW_SSI_SIER(x).B.RDR1IE)

/*! @brief Format value for bitfield SSI_SIER_RDR1IE. */
#define BF_SSI_SIER_RDR1IE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RDR1IE) & BM_SSI_SIER_RDR1IE)

/*! @brief Set the RDR1IE field to a new value. */
#define BW_SSI_SIER_RDR1IE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RDR1IE) | BF_SSI_SIER_RDR1IE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RXTIE[16] (RW)
 *
 * Receive Tag Updated Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RXTIE    (16U)         /*!< Bit position for SSI_SIER_RXTIE. */
#define BM_SSI_SIER_RXTIE    (0x00010000U) /*!< Bit mask for SSI_SIER_RXTIE. */
#define BS_SSI_SIER_RXTIE    (1U)          /*!< Bit field size in bits for SSI_SIER_RXTIE. */

/*! @brief Read current value of the SSI_SIER_RXTIE field. */
#define BR_SSI_SIER_RXTIE(x) (HW_SSI_SIER(x).B.RXTIE)

/*! @brief Format value for bitfield SSI_SIER_RXTIE. */
#define BF_SSI_SIER_RXTIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RXTIE) & BM_SSI_SIER_RXTIE)

/*! @brief Set the RXTIE field to a new value. */
#define BW_SSI_SIER_RXTIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RXTIE) | BF_SSI_SIER_RXTIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field CMDDUIE[17] (RW)
 *
 * Command Data Register Updated Interrupt Enable. Enable Bit. Controls whether
 * the corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_CMDDUIE  (17U)         /*!< Bit position for SSI_SIER_CMDDUIE. */
#define BM_SSI_SIER_CMDDUIE  (0x00020000U) /*!< Bit mask for SSI_SIER_CMDDUIE. */
#define BS_SSI_SIER_CMDDUIE  (1U)          /*!< Bit field size in bits for SSI_SIER_CMDDUIE. */

/*! @brief Read current value of the SSI_SIER_CMDDUIE field. */
#define BR_SSI_SIER_CMDDUIE(x) (HW_SSI_SIER(x).B.CMDDUIE)

/*! @brief Format value for bitfield SSI_SIER_CMDDUIE. */
#define BF_SSI_SIER_CMDDUIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_CMDDUIE) & BM_SSI_SIER_CMDDUIE)

/*! @brief Set the CMDDUIE field to a new value. */
#define BW_SSI_SIER_CMDDUIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_CMDDUIE) | BF_SSI_SIER_CMDDUIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field CMDAUIE[18] (RW)
 *
 * Command Address Register Updated Interrupt Enable. Enable Bit. Controls
 * whether the corresponding status bit in SISR can issue an interrupt to the core or
 * not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_CMDAUIE  (18U)         /*!< Bit position for SSI_SIER_CMDAUIE. */
#define BM_SSI_SIER_CMDAUIE  (0x00040000U) /*!< Bit mask for SSI_SIER_CMDAUIE. */
#define BS_SSI_SIER_CMDAUIE  (1U)          /*!< Bit field size in bits for SSI_SIER_CMDAUIE. */

/*! @brief Read current value of the SSI_SIER_CMDAUIE field. */
#define BR_SSI_SIER_CMDAUIE(x) (HW_SSI_SIER(x).B.CMDAUIE)

/*! @brief Format value for bitfield SSI_SIER_CMDAUIE. */
#define BF_SSI_SIER_CMDAUIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_CMDAUIE) & BM_SSI_SIER_CMDAUIE)

/*! @brief Set the CMDAUIE field to a new value. */
#define BW_SSI_SIER_CMDAUIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_CMDAUIE) | BF_SSI_SIER_CMDAUIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TIE[19] (RW)
 *
 * Transmit Interrupt Enable. This control bit allows the SSI to issue
 * transmitter data related interrupts to the Core. Refer to Transmit Interrupt Enable Bit
 * DescriptionThe SSI Transmit Interrupt Enable (TIE) control bit determines
 * whether the processor is interrupted when the SSI transmitter needs to be
 * serviced. for a detailed description of this bit.
 *
 * Values:
 * - 0 - SSI Transmitter Interrupt requests disabled.
 * - 1 - SSI Transmitter Interrupt requests enabled.
 */
/*@{*/
#define BP_SSI_SIER_TIE      (19U)         /*!< Bit position for SSI_SIER_TIE. */
#define BM_SSI_SIER_TIE      (0x00080000U) /*!< Bit mask for SSI_SIER_TIE. */
#define BS_SSI_SIER_TIE      (1U)          /*!< Bit field size in bits for SSI_SIER_TIE. */

/*! @brief Read current value of the SSI_SIER_TIE field. */
#define BR_SSI_SIER_TIE(x)   (HW_SSI_SIER(x).B.TIE)

/*! @brief Format value for bitfield SSI_SIER_TIE. */
#define BF_SSI_SIER_TIE(v)   ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TIE) & BM_SSI_SIER_TIE)

/*! @brief Set the TIE field to a new value. */
#define BW_SSI_SIER_TIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TIE) | BF_SSI_SIER_TIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TDMAE[20] (RW)
 *
 * Transmit DMA Enable. This bit allows SSI to request for DMA transfers. When
 * enabled, DMA requests are generated when any of the TFE0/1 bits in the SISR are
 * set and if the corresponding TFEN bit is also set. If the corresponding FIFO
 * is disabled, a DMA request is generated when the corresponding TDE bit is set.
 *
 * Values:
 * - 0 - SSI Transmitter DMA requests disabled.
 * - 1 - SSI Transmitter DMA requests enabled.
 */
/*@{*/
#define BP_SSI_SIER_TDMAE    (20U)         /*!< Bit position for SSI_SIER_TDMAE. */
#define BM_SSI_SIER_TDMAE    (0x00100000U) /*!< Bit mask for SSI_SIER_TDMAE. */
#define BS_SSI_SIER_TDMAE    (1U)          /*!< Bit field size in bits for SSI_SIER_TDMAE. */

/*! @brief Read current value of the SSI_SIER_TDMAE field. */
#define BR_SSI_SIER_TDMAE(x) (HW_SSI_SIER(x).B.TDMAE)

/*! @brief Format value for bitfield SSI_SIER_TDMAE. */
#define BF_SSI_SIER_TDMAE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TDMAE) & BM_SSI_SIER_TDMAE)

/*! @brief Set the TDMAE field to a new value. */
#define BW_SSI_SIER_TDMAE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TDMAE) | BF_SSI_SIER_TDMAE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RIE[21] (RW)
 *
 * Receive Interrupt Enable. This control bit allows the SSI to issue receiver
 * related interrupts to the Core. Refer to Receive Interrupt Enable Bit
 * DescriptionWhen the RIE and RE bit are set, the processor is interrupted when either of
 * the SSI Receive FIFO Full (RFF0/1) bits in SSI.SISR is set (if the
 * corresponding Receive FIFO is enabled). for a detailed description of this bit.
 *
 * Values:
 * - 0 - SSI Receiver Interrupt requests disabled.
 * - 1 - SSI Receiver Interrupt requests enabled.
 */
/*@{*/
#define BP_SSI_SIER_RIE      (21U)         /*!< Bit position for SSI_SIER_RIE. */
#define BM_SSI_SIER_RIE      (0x00200000U) /*!< Bit mask for SSI_SIER_RIE. */
#define BS_SSI_SIER_RIE      (1U)          /*!< Bit field size in bits for SSI_SIER_RIE. */

/*! @brief Read current value of the SSI_SIER_RIE field. */
#define BR_SSI_SIER_RIE(x)   (HW_SSI_SIER(x).B.RIE)

/*! @brief Format value for bitfield SSI_SIER_RIE. */
#define BF_SSI_SIER_RIE(v)   ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RIE) & BM_SSI_SIER_RIE)

/*! @brief Set the RIE field to a new value. */
#define BW_SSI_SIER_RIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RIE) | BF_SSI_SIER_RIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RDMAE[22] (RW)
 *
 * Receive DMA Enable. This bit allows SSI to request for DMA transfers. When
 * enabled, DMA requests are generated when any of the RFF0/1 bits in the SISR are
 * set and if the corresponding RFEN bit is also set. If the corresponding FIFO
 * is disabled, a DMA request is generated when the corresponding RDR bit is set.
 *
 * Values:
 * - 0 - SSI Receiver DMA requests disabled.
 * - 1 - SSI Receiver DMA requests enabled.
 */
/*@{*/
#define BP_SSI_SIER_RDMAE    (22U)         /*!< Bit position for SSI_SIER_RDMAE. */
#define BM_SSI_SIER_RDMAE    (0x00400000U) /*!< Bit mask for SSI_SIER_RDMAE. */
#define BS_SSI_SIER_RDMAE    (1U)          /*!< Bit field size in bits for SSI_SIER_RDMAE. */

/*! @brief Read current value of the SSI_SIER_RDMAE field. */
#define BR_SSI_SIER_RDMAE(x) (HW_SSI_SIER(x).B.RDMAE)

/*! @brief Format value for bitfield SSI_SIER_RDMAE. */
#define BF_SSI_SIER_RDMAE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RDMAE) & BM_SSI_SIER_RDMAE)

/*! @brief Set the RDMAE field to a new value. */
#define BW_SSI_SIER_RDMAE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RDMAE) | BF_SSI_SIER_RDMAE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field TFRCIE[23] (RW)
 *
 * Transmit Frame Complete Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_TFRCIE   (23U)         /*!< Bit position for SSI_SIER_TFRCIE. */
#define BM_SSI_SIER_TFRCIE   (0x00800000U) /*!< Bit mask for SSI_SIER_TFRCIE. */
#define BS_SSI_SIER_TFRCIE   (1U)          /*!< Bit field size in bits for SSI_SIER_TFRCIE. */

/*! @brief Read current value of the SSI_SIER_TFRCIE field. */
#define BR_SSI_SIER_TFRCIE(x) (HW_SSI_SIER(x).B.TFRCIE)

/*! @brief Format value for bitfield SSI_SIER_TFRCIE. */
#define BF_SSI_SIER_TFRCIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_TFRCIE) & BM_SSI_SIER_TFRCIE)

/*! @brief Set the TFRCIE field to a new value. */
#define BW_SSI_SIER_TFRCIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_TFRCIE) | BF_SSI_SIER_TFRCIE(v)))
/*@}*/

/*!
 * @name Register SSI_SIER, field RFRCIE[24] (RW)
 *
 * Receive Frame Complete Interrupt Enable. Enable Bit. Controls whether the
 * corresponding status bit in SISR can issue an interrupt to the core or not.
 *
 * Values:
 * - 0 - Corresponding status bit cannot issue interrupt.
 * - 1 - Corresponding status bit can issue interrupt.
 */
/*@{*/
#define BP_SSI_SIER_RFRCIE   (24U)         /*!< Bit position for SSI_SIER_RFRCIE. */
#define BM_SSI_SIER_RFRCIE   (0x01000000U) /*!< Bit mask for SSI_SIER_RFRCIE. */
#define BS_SSI_SIER_RFRCIE   (1U)          /*!< Bit field size in bits for SSI_SIER_RFRCIE. */

/*! @brief Read current value of the SSI_SIER_RFRCIE field. */
#define BR_SSI_SIER_RFRCIE(x) (HW_SSI_SIER(x).B.RFRCIE)

/*! @brief Format value for bitfield SSI_SIER_RFRCIE. */
#define BF_SSI_SIER_RFRCIE(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SIER_RFRCIE) & BM_SSI_SIER_RFRCIE)

/*! @brief Set the RFRCIE field to a new value. */
#define BW_SSI_SIER_RFRCIE(x, v) (HW_SSI_SIER_WR(x, (HW_SSI_SIER_RD(x) & ~BM_SSI_SIER_RFRCIE) | BF_SSI_SIER_RFRCIE(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_STCR - SSI Transmit Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_STCR - SSI Transmit Configuration Register (RW)
 *
 * Reset value: 0x00000200U
 *
 * The SSI Transmit Configuration Register (SSI_STCR) is a read/write control
 * register used to direct the transmit operation of the STCR controls the
 * direction of the bit clock and frame sync ports, STCK and STFS. Interrupt enable bit
 * for the transmit sections is provided in this control register. The Power-on
 * reset clears all SSI_STCR bits. However, SSI reset does not affect the SSI_STCR
 * bits. The SSI_STCR bits are described in the following paragraphs. See the
 * Programmable Registers section for the programming model of the SSI. The SSI
 * Control Register (SSI_SCR) must first be set to enable interrupts. Next, the SSI
 * interrupt bit in the Interrupt Enable Register (SSI_SIER) must be set to enable
 * the interrupt. Finally, the interrupt can be enabled from within the SSI.
 */
typedef union _hw_ssi_stcr
{
    uint32_t U;
    struct _hw_ssi_stcr_bitfields
    {
        uint32_t TEFS : 1;             /*!< [0]  */
        uint32_t TFSL : 1;             /*!< [1]  */
        uint32_t TFSI : 1;             /*!< [2]  */
        uint32_t TSCKP : 1;            /*!< [3]  */
        uint32_t TSHFD : 1;            /*!< [4]  */
        uint32_t TXDIR : 1;            /*!< [5]  */
        uint32_t TFDIR : 1;            /*!< [6]  */
        uint32_t TFEN0 : 1;            /*!< [7]  */
        uint32_t TFEN1 : 1;            /*!< [8]  */
        uint32_t TXBIT0 : 1;           /*!< [9]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ssi_stcr_t;

/*!
 * @name Constants and macros for entire SSI_STCR register
 */
/*@{*/
#define HW_SSI_STCR_ADDR(x)      ((uintptr_t)(x) + 0x1CU)

#define HW_SSI_STCR(x)           (*(__IO hw_ssi_stcr_t *) HW_SSI_STCR_ADDR(x))
#define HW_SSI_STCR_RD(x)        (HW_SSI_STCR(x).U)
#define HW_SSI_STCR_WR(x, v)     (HW_SSI_STCR(x).U = (v))
#define HW_SSI_STCR_SET(x, v)    (HW_SSI_STCR_WR(x, HW_SSI_STCR_RD(x) |  (v)))
#define HW_SSI_STCR_CLR(x, v)    (HW_SSI_STCR_WR(x, HW_SSI_STCR_RD(x) & ~(v)))
#define HW_SSI_STCR_TOG(x, v)    (HW_SSI_STCR_WR(x, HW_SSI_STCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_STCR bitfields
 */

/*!
 * @name Register SSI_STCR, field TEFS[0] (RW)
 *
 * Transmit Early Frame Sync. This bit controls when the frame sync is initiated
 * for the transmit section. The frame sync signal is deasserted after one
 * bit-for-bit length frame sync and after one word-for-word length frame sync. In
 * case of synchronous operation, the frame sync can also be initiated on receiving
 * the first bit of data.
 *
 * Values:
 * - 0 - Transmit frame sync initiated as the first bit of data is transmitted.
 * - 1 - Transmit frame sync is initiated one bit before the data is transmitted.
 */
/*@{*/
#define BP_SSI_STCR_TEFS     (0U)          /*!< Bit position for SSI_STCR_TEFS. */
#define BM_SSI_STCR_TEFS     (0x00000001U) /*!< Bit mask for SSI_STCR_TEFS. */
#define BS_SSI_STCR_TEFS     (1U)          /*!< Bit field size in bits for SSI_STCR_TEFS. */

#define BV_SSI_STCR_TEFS_FIRST_BIT     (0U)          /*!< Bit field value for SSI_STCR_TEFS: Transmit frame sync initiated as the first bit of data is transmitted. */
#define BV_SSI_STCR_TEFS_ONE_BIT_BEFORE (0x1U)       /*!< Bit field value for SSI_STCR_TEFS: Transmit frame sync is initiated one bit before the data is transmitted. */

/*! @brief Read current value of the SSI_STCR_TEFS field. */
#define BR_SSI_STCR_TEFS(x)  (HW_SSI_STCR(x).B.TEFS)

/*! @brief Format value for bitfield SSI_STCR_TEFS. */
#define BF_SSI_STCR_TEFS(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TEFS) & BM_SSI_STCR_TEFS)

/*! @brief Set the TEFS field to a new value. */
#define BW_SSI_STCR_TEFS(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TEFS) | BF_SSI_STCR_TEFS(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TFSL[1] (RW)
 *
 * Transmit Frame Sync Length. This bit controls the length of the frame sync
 * signal to be generated or recognized for the transmit section. The length of a
 * word-long frame sync is same as the length of the data word selected by WL[3:0].
 *
 * Values:
 * - 0 - Transmit frame sync is one-word long.
 * - 1 - Transmit frame sync is one-clock-bit long.
 */
/*@{*/
#define BP_SSI_STCR_TFSL     (1U)          /*!< Bit position for SSI_STCR_TFSL. */
#define BM_SSI_STCR_TFSL     (0x00000002U) /*!< Bit mask for SSI_STCR_TFSL. */
#define BS_SSI_STCR_TFSL     (1U)          /*!< Bit field size in bits for SSI_STCR_TFSL. */

#define BV_SSI_STCR_TFSL_ONE_WORD      (0U)          /*!< Bit field value for SSI_STCR_TFSL: Transmit frame sync is one-word long. */
#define BV_SSI_STCR_TFSL_ONE_CLOCK_BIT (0x1U)        /*!< Bit field value for SSI_STCR_TFSL: Transmit frame sync is one-clock-bit long. */

/*! @brief Read current value of the SSI_STCR_TFSL field. */
#define BR_SSI_STCR_TFSL(x)  (HW_SSI_STCR(x).B.TFSL)

/*! @brief Format value for bitfield SSI_STCR_TFSL. */
#define BF_SSI_STCR_TFSL(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TFSL) & BM_SSI_STCR_TFSL)

/*! @brief Set the TFSL field to a new value. */
#define BW_SSI_STCR_TFSL(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TFSL) | BF_SSI_STCR_TFSL(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TFSI[2] (RW)
 *
 * Transmit Frame Sync Invert. This bit controls the active state of the frame
 * sync I/O signal for the transmit section of SSI.
 *
 * Values:
 * - 0 - Transmit frame sync is active high.
 * - 1 - Transmit frame sync is active low.
 */
/*@{*/
#define BP_SSI_STCR_TFSI     (2U)          /*!< Bit position for SSI_STCR_TFSI. */
#define BM_SSI_STCR_TFSI     (0x00000004U) /*!< Bit mask for SSI_STCR_TFSI. */
#define BS_SSI_STCR_TFSI     (1U)          /*!< Bit field size in bits for SSI_STCR_TFSI. */

#define BV_SSI_STCR_TFSI_ACTIVE_HIGH   (0U)          /*!< Bit field value for SSI_STCR_TFSI: Transmit frame sync is active high. */
#define BV_SSI_STCR_TFSI_ACTIVE_LOW    (0x1U)        /*!< Bit field value for SSI_STCR_TFSI: Transmit frame sync is active low. */

/*! @brief Read current value of the SSI_STCR_TFSI field. */
#define BR_SSI_STCR_TFSI(x)  (HW_SSI_STCR(x).B.TFSI)

/*! @brief Format value for bitfield SSI_STCR_TFSI. */
#define BF_SSI_STCR_TFSI(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TFSI) & BM_SSI_STCR_TFSI)

/*! @brief Set the TFSI field to a new value. */
#define BW_SSI_STCR_TFSI(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TFSI) | BF_SSI_STCR_TFSI(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TSCKP[3] (RW)
 *
 * Transmit Clock Polarity. This bit controls which bit clock edge is used to
 * clock out data for the transmit section. Note: TSCKP is 0 CLK_IST = 0; TSCKP is
 * 1CLK_IST = 1
 *
 * Values:
 * - 0 - Data clocked out on rising edge of bit clock.
 * - 1 - Data clocked out on falling edge of bit clock.
 */
/*@{*/
#define BP_SSI_STCR_TSCKP    (3U)          /*!< Bit position for SSI_STCR_TSCKP. */
#define BM_SSI_STCR_TSCKP    (0x00000008U) /*!< Bit mask for SSI_STCR_TSCKP. */
#define BS_SSI_STCR_TSCKP    (1U)          /*!< Bit field size in bits for SSI_STCR_TSCKP. */

#define BV_SSI_STCR_TSCKP_RISING_EDGE  (0U)          /*!< Bit field value for SSI_STCR_TSCKP: Data clocked out on rising edge of bit clock. */
#define BV_SSI_STCR_TSCKP_FALLING_EDGE (0x1U)        /*!< Bit field value for SSI_STCR_TSCKP: Data clocked out on falling edge of bit clock. */

/*! @brief Read current value of the SSI_STCR_TSCKP field. */
#define BR_SSI_STCR_TSCKP(x) (HW_SSI_STCR(x).B.TSCKP)

/*! @brief Format value for bitfield SSI_STCR_TSCKP. */
#define BF_SSI_STCR_TSCKP(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TSCKP) & BM_SSI_STCR_TSCKP)

/*! @brief Set the TSCKP field to a new value. */
#define BW_SSI_STCR_TSCKP(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TSCKP) | BF_SSI_STCR_TSCKP(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TSHFD[4] (RW)
 *
 * Transmit Shift Direction. This bit controls whether the MSB or LSB will be
 * transmitted first in a sample. The CODEC device labels the MSB as bit 0, whereas
 * the Core labels the LSB as bit 0. Therefore, when using a standard CODEC,
 * Core MSB (CODEC LSB) is shifted in first (TSHFD cleared).
 *
 * Values:
 * - 0 - Data transmitted MSB first.
 * - 1 - Data transmitted LSB first.
 */
/*@{*/
#define BP_SSI_STCR_TSHFD    (4U)          /*!< Bit position for SSI_STCR_TSHFD. */
#define BM_SSI_STCR_TSHFD    (0x00000010U) /*!< Bit mask for SSI_STCR_TSHFD. */
#define BS_SSI_STCR_TSHFD    (1U)          /*!< Bit field size in bits for SSI_STCR_TSHFD. */

#define BV_SSI_STCR_TSHFD_MSB_FIRST    (0U)          /*!< Bit field value for SSI_STCR_TSHFD: Data transmitted MSB first. */
#define BV_SSI_STCR_TSHFD_LSB_FIRST    (0x1U)        /*!< Bit field value for SSI_STCR_TSHFD: Data transmitted LSB first. */

/*! @brief Read current value of the SSI_STCR_TSHFD field. */
#define BR_SSI_STCR_TSHFD(x) (HW_SSI_STCR(x).B.TSHFD)

/*! @brief Format value for bitfield SSI_STCR_TSHFD. */
#define BF_SSI_STCR_TSHFD(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TSHFD) & BM_SSI_STCR_TSHFD)

/*! @brief Set the TSHFD field to a new value. */
#define BW_SSI_STCR_TSHFD(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TSHFD) | BF_SSI_STCR_TSHFD(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TXDIR[5] (RW)
 *
 * Transmit Clock Direction. This bit controls the direction and source of the
 * clock signal used to clock the TXSR. Internally generated clock is output
 * through the STCK port. External clock is taken from this port. Refer to for details
 * of clock pin configurations.
 *
 * Values:
 * - 0 - Transmit Clock is external.
 * - 1 - Transmit Clock generated internally.
 */
/*@{*/
#define BP_SSI_STCR_TXDIR    (5U)          /*!< Bit position for SSI_STCR_TXDIR. */
#define BM_SSI_STCR_TXDIR    (0x00000020U) /*!< Bit mask for SSI_STCR_TXDIR. */
#define BS_SSI_STCR_TXDIR    (1U)          /*!< Bit field size in bits for SSI_STCR_TXDIR. */

#define BV_SSI_STCR_TXDIR_EXTERNAL     (0U)          /*!< Bit field value for SSI_STCR_TXDIR: Transmit Clock is external. */
#define BV_SSI_STCR_TXDIR_INTERNAL     (0x1U)        /*!< Bit field value for SSI_STCR_TXDIR: Transmit Clock generated internally. */

/*! @brief Read current value of the SSI_STCR_TXDIR field. */
#define BR_SSI_STCR_TXDIR(x) (HW_SSI_STCR(x).B.TXDIR)

/*! @brief Format value for bitfield SSI_STCR_TXDIR. */
#define BF_SSI_STCR_TXDIR(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TXDIR) & BM_SSI_STCR_TXDIR)

/*! @brief Set the TXDIR field to a new value. */
#define BW_SSI_STCR_TXDIR(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TXDIR) | BF_SSI_STCR_TXDIR(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TFDIR[6] (RW)
 *
 * Transmit Frame Direction. This bit controls the direction and source of the
 * transmit frame sync signal. Internally generated frame sync signal is sent out
 * through the STFS port and external frame sync is taken from the same port.
 *
 * Values:
 * - 0 - Frame Sync is external.
 * - 1 - Frame Sync generated internally.
 */
/*@{*/
#define BP_SSI_STCR_TFDIR    (6U)          /*!< Bit position for SSI_STCR_TFDIR. */
#define BM_SSI_STCR_TFDIR    (0x00000040U) /*!< Bit mask for SSI_STCR_TFDIR. */
#define BS_SSI_STCR_TFDIR    (1U)          /*!< Bit field size in bits for SSI_STCR_TFDIR. */

#define BV_SSI_STCR_TFDIR_EXTERNAL     (0U)          /*!< Bit field value for SSI_STCR_TFDIR: Frame Sync is external. */
#define BV_SSI_STCR_TFDIR_INTERNAL     (0x1U)        /*!< Bit field value for SSI_STCR_TFDIR: Frame Sync generated internally. */

/*! @brief Read current value of the SSI_STCR_TFDIR field. */
#define BR_SSI_STCR_TFDIR(x) (HW_SSI_STCR(x).B.TFDIR)

/*! @brief Format value for bitfield SSI_STCR_TFDIR. */
#define BF_SSI_STCR_TFDIR(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TFDIR) & BM_SSI_STCR_TFDIR)

/*! @brief Set the TFDIR field to a new value. */
#define BW_SSI_STCR_TFDIR(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TFDIR) | BF_SSI_STCR_TFDIR(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TFEN0[7] (RW)
 *
 * Transmit FIFO Enable 0. This bit enables transmit FIFO 0. When enabled, the
 * FIFO allows15 samples to be transmitted by the SSI per channel (a 9th sample
 * can be shifting out) before TDE0 bit is set. When the FIFO is disabled, an
 * interrupt is generated when a single sample is transferred to the transmit shift
 * register (provided the interrupt is enabled).
 *
 * Values:
 * - 0 - Transmit FIFO 0 disabled.
 * - 1 - Transmit FIFO 0 enabled.
 */
/*@{*/
#define BP_SSI_STCR_TFEN0    (7U)          /*!< Bit position for SSI_STCR_TFEN0. */
#define BM_SSI_STCR_TFEN0    (0x00000080U) /*!< Bit mask for SSI_STCR_TFEN0. */
#define BS_SSI_STCR_TFEN0    (1U)          /*!< Bit field size in bits for SSI_STCR_TFEN0. */

/*! @brief Read current value of the SSI_STCR_TFEN0 field. */
#define BR_SSI_STCR_TFEN0(x) (HW_SSI_STCR(x).B.TFEN0)

/*! @brief Format value for bitfield SSI_STCR_TFEN0. */
#define BF_SSI_STCR_TFEN0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TFEN0) & BM_SSI_STCR_TFEN0)

/*! @brief Set the TFEN0 field to a new value. */
#define BW_SSI_STCR_TFEN0(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TFEN0) | BF_SSI_STCR_TFEN0(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TFEN1[8] (RW)
 *
 * Transmit FIFO Enable 1. This bit enables transmit FIFO 1. When enabled, the
 * FIFO allows15 samples to be transmitted by the SSI (per channel) (a 9th sample
 * can be shifting out) before TDE1 bit is set. When the FIFO is disabled, an
 * interrupt is generated when a single sample is transferred to the transmit shift
 * register (provided the interrupt is enabled).
 *
 * Values:
 * - 0 - Transmit FIFO 1 disabled.
 * - 1 - Transmit FIFO 1 enabled.
 */
/*@{*/
#define BP_SSI_STCR_TFEN1    (8U)          /*!< Bit position for SSI_STCR_TFEN1. */
#define BM_SSI_STCR_TFEN1    (0x00000100U) /*!< Bit mask for SSI_STCR_TFEN1. */
#define BS_SSI_STCR_TFEN1    (1U)          /*!< Bit field size in bits for SSI_STCR_TFEN1. */

/*! @brief Read current value of the SSI_STCR_TFEN1 field. */
#define BR_SSI_STCR_TFEN1(x) (HW_SSI_STCR(x).B.TFEN1)

/*! @brief Format value for bitfield SSI_STCR_TFEN1. */
#define BF_SSI_STCR_TFEN1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TFEN1) & BM_SSI_STCR_TFEN1)

/*! @brief Set the TFEN1 field to a new value. */
#define BW_SSI_STCR_TFEN1(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TFEN1) | BF_SSI_STCR_TFEN1(v)))
/*@}*/

/*!
 * @name Register SSI_STCR, field TXBIT0[9] (RW)
 *
 * Transmit Bit 0. This control bit allows SSI to transmit the data word from
 * bit position 0 or 15/31 in the transmit shift register. The shifting data
 * direction can be MSB or LSB first, controlled by the TSHFD bit.
 *
 * Values:
 * - 0 - Shifting with respect to bit 31 (if word length = 16, 18, 20, 22 or 24)
 *     or bit 15 (if word length = 8, 10 or 12) of transmit shift register (MSB
 *     aligned).
 * - 1 - Shifting with respect to bit 0 of transmit shift register (LSB aligned).
 */
/*@{*/
#define BP_SSI_STCR_TXBIT0   (9U)          /*!< Bit position for SSI_STCR_TXBIT0. */
#define BM_SSI_STCR_TXBIT0   (0x00000200U) /*!< Bit mask for SSI_STCR_TXBIT0. */
#define BS_SSI_STCR_TXBIT0   (1U)          /*!< Bit field size in bits for SSI_STCR_TXBIT0. */

#define BV_SSI_STCR_TXBIT0_MSB_ALIGNED (0U)          /*!< Bit field value for SSI_STCR_TXBIT0: Shifting with respect to bit 31 (if word length = 16, 18, 20, 22 or 24) or bit 15 (if word length = 8, 10 or 12) of transmit shift register (MSB aligned). */
#define BV_SSI_STCR_TXBIT0_LSB_ALIGNED (0x1U)        /*!< Bit field value for SSI_STCR_TXBIT0: Shifting with respect to bit 0 of transmit shift register (LSB aligned). */

/*! @brief Read current value of the SSI_STCR_TXBIT0 field. */
#define BR_SSI_STCR_TXBIT0(x) (HW_SSI_STCR(x).B.TXBIT0)

/*! @brief Format value for bitfield SSI_STCR_TXBIT0. */
#define BF_SSI_STCR_TXBIT0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCR_TXBIT0) & BM_SSI_STCR_TXBIT0)

/*! @brief Set the TXBIT0 field to a new value. */
#define BW_SSI_STCR_TXBIT0(x, v) (HW_SSI_STCR_WR(x, (HW_SSI_STCR_RD(x) & ~BM_SSI_STCR_TXBIT0) | BF_SSI_STCR_TXBIT0(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SRCR - SSI Receive Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SRCR - SSI Receive Configuration Register (RW)
 *
 * Reset value: 0x00000200U
 *
 * The SSI Receive Configuration Register (SSI_SRCR) is a read/write control
 * register used to direct the receive operation of the SSI. SSI.SRCR controls the
 * direction of the bit clock and frame sync ports, SRCK and SRFS. Interrupt
 * enable bit for the transmit sections is provided in this control register. The
 * Power-on reset clears all SSI_SRCR bits. However, SSI reset does not affect the
 * SSI_SRCR bits.
 */
typedef union _hw_ssi_srcr
{
    uint32_t U;
    struct _hw_ssi_srcr_bitfields
    {
        uint32_t REFS : 1;             /*!< [0]  */
        uint32_t RFSL : 1;             /*!< [1]  */
        uint32_t RFSI : 1;             /*!< [2]  */
        uint32_t RSCKP : 1;            /*!< [3]  */
        uint32_t RSHFD : 1;            /*!< [4]  */
        uint32_t RXDIR : 1;            /*!< [5]  */
        uint32_t RFDIR : 1;            /*!< [6]  */
        uint32_t RFEN0 : 1;            /*!< [7]  */
        uint32_t RFEN1 : 1;            /*!< [8]  */
        uint32_t RXBIT0 : 1;           /*!< [9]  */
        uint32_t RXEXT : 1;            /*!< [10]  */
        uint32_t RESERVED0 : 21;       /*!< [31:11]  */
    } B;
} hw_ssi_srcr_t;

/*!
 * @name Constants and macros for entire SSI_SRCR register
 */
/*@{*/
#define HW_SSI_SRCR_ADDR(x)      ((uintptr_t)(x) + 0x20U)

#define HW_SSI_SRCR(x)           (*(__IO hw_ssi_srcr_t *) HW_SSI_SRCR_ADDR(x))
#define HW_SSI_SRCR_RD(x)        (HW_SSI_SRCR(x).U)
#define HW_SSI_SRCR_WR(x, v)     (HW_SSI_SRCR(x).U = (v))
#define HW_SSI_SRCR_SET(x, v)    (HW_SSI_SRCR_WR(x, HW_SSI_SRCR_RD(x) |  (v)))
#define HW_SSI_SRCR_CLR(x, v)    (HW_SSI_SRCR_WR(x, HW_SSI_SRCR_RD(x) & ~(v)))
#define HW_SSI_SRCR_TOG(x, v)    (HW_SSI_SRCR_WR(x, HW_SSI_SRCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SRCR bitfields
 */

/*!
 * @name Register SSI_SRCR, field REFS[0] (RW)
 *
 * Receive Early Frame Sync. This bit controls when the frame sync is initiated
 * for the receive section. The frame sync is disabled after one bit-for-bit
 * length frame sync and after one word-for-word length frame sync.
 *
 * Values:
 * - 0 - Receive frame sync initiated as the first bit of data is received.
 * - 1 - Receive frame sync is initiated one bit before the data is received.
 */
/*@{*/
#define BP_SSI_SRCR_REFS     (0U)          /*!< Bit position for SSI_SRCR_REFS. */
#define BM_SSI_SRCR_REFS     (0x00000001U) /*!< Bit mask for SSI_SRCR_REFS. */
#define BS_SSI_SRCR_REFS     (1U)          /*!< Bit field size in bits for SSI_SRCR_REFS. */

#define BV_SSI_SRCR_REFS_FIRST_BIT     (0U)          /*!< Bit field value for SSI_SRCR_REFS: Receive frame sync initiated as the first bit of data is received. */
#define BV_SSI_SRCR_REFS_ONE_BIT_BEFORE (0x1U)       /*!< Bit field value for SSI_SRCR_REFS: Receive frame sync is initiated one bit before the data is received. */

/*! @brief Read current value of the SSI_SRCR_REFS field. */
#define BR_SSI_SRCR_REFS(x)  (HW_SSI_SRCR(x).B.REFS)

/*! @brief Format value for bitfield SSI_SRCR_REFS. */
#define BF_SSI_SRCR_REFS(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_REFS) & BM_SSI_SRCR_REFS)

/*! @brief Set the REFS field to a new value. */
#define BW_SSI_SRCR_REFS(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_REFS) | BF_SSI_SRCR_REFS(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RFSL[1] (RW)
 *
 * Receive Frame Sync Length. This bit controls the length of the frame sync
 * signal to be generated or recognized for the receive section. The length of a
 * word-long frame sync is same as the length of the data word selected by WL[3:0].
 *
 * Values:
 * - 0 - Receive frame sync is one-word long.
 * - 1 - Receive frame sync is one-clock-bit long.
 */
/*@{*/
#define BP_SSI_SRCR_RFSL     (1U)          /*!< Bit position for SSI_SRCR_RFSL. */
#define BM_SSI_SRCR_RFSL     (0x00000002U) /*!< Bit mask for SSI_SRCR_RFSL. */
#define BS_SSI_SRCR_RFSL     (1U)          /*!< Bit field size in bits for SSI_SRCR_RFSL. */

#define BV_SSI_SRCR_RFSL_ONE_WORD      (0U)          /*!< Bit field value for SSI_SRCR_RFSL: Receive frame sync is one-word long. */
#define BV_SSI_SRCR_RFSL_ONE_CLOCK_BIT (0x1U)        /*!< Bit field value for SSI_SRCR_RFSL: Receive frame sync is one-clock-bit long. */

/*! @brief Read current value of the SSI_SRCR_RFSL field. */
#define BR_SSI_SRCR_RFSL(x)  (HW_SSI_SRCR(x).B.RFSL)

/*! @brief Format value for bitfield SSI_SRCR_RFSL. */
#define BF_SSI_SRCR_RFSL(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RFSL) & BM_SSI_SRCR_RFSL)

/*! @brief Set the RFSL field to a new value. */
#define BW_SSI_SRCR_RFSL(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RFSL) | BF_SSI_SRCR_RFSL(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RFSI[2] (RW)
 *
 * Receive Frame Sync Invert. This bit controls the active state of the frame
 * sync I/O signal for the receive section of SSI.
 *
 * Values:
 * - 0 - Receive frame sync is active high.
 * - 1 - Receive frame sync is active low.
 */
/*@{*/
#define BP_SSI_SRCR_RFSI     (2U)          /*!< Bit position for SSI_SRCR_RFSI. */
#define BM_SSI_SRCR_RFSI     (0x00000004U) /*!< Bit mask for SSI_SRCR_RFSI. */
#define BS_SSI_SRCR_RFSI     (1U)          /*!< Bit field size in bits for SSI_SRCR_RFSI. */

#define BV_SSI_SRCR_RFSI_ACTIVE_HIGH   (0U)          /*!< Bit field value for SSI_SRCR_RFSI: Receive frame sync is active high. */
#define BV_SSI_SRCR_RFSI_ACTIVE_LOW    (0x1U)        /*!< Bit field value for SSI_SRCR_RFSI: Receive frame sync is active low. */

/*! @brief Read current value of the SSI_SRCR_RFSI field. */
#define BR_SSI_SRCR_RFSI(x)  (HW_SSI_SRCR(x).B.RFSI)

/*! @brief Format value for bitfield SSI_SRCR_RFSI. */
#define BF_SSI_SRCR_RFSI(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RFSI) & BM_SSI_SRCR_RFSI)

/*! @brief Set the RFSI field to a new value. */
#define BW_SSI_SRCR_RFSI(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RFSI) | BF_SSI_SRCR_RFSI(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RSCKP[3] (RW)
 *
 * Receive Clock Polarity. This bit controls which bit clock edge is used to
 * latch in data for the receive section.
 *
 * Values:
 * - 0 - Data latched on falling edge of bit clock.
 * - 1 - Data latched on rising edge of bit clock.
 */
/*@{*/
#define BP_SSI_SRCR_RSCKP    (3U)          /*!< Bit position for SSI_SRCR_RSCKP. */
#define BM_SSI_SRCR_RSCKP    (0x00000008U) /*!< Bit mask for SSI_SRCR_RSCKP. */
#define BS_SSI_SRCR_RSCKP    (1U)          /*!< Bit field size in bits for SSI_SRCR_RSCKP. */

#define BV_SSI_SRCR_RSCKP_FALLING_EDGE (0U)          /*!< Bit field value for SSI_SRCR_RSCKP: Data latched on falling edge of bit clock. */
#define BV_SSI_SRCR_RSCKP_RISING_EDGE  (0x1U)        /*!< Bit field value for SSI_SRCR_RSCKP: Data latched on rising edge of bit clock. */

/*! @brief Read current value of the SSI_SRCR_RSCKP field. */
#define BR_SSI_SRCR_RSCKP(x) (HW_SSI_SRCR(x).B.RSCKP)

/*! @brief Format value for bitfield SSI_SRCR_RSCKP. */
#define BF_SSI_SRCR_RSCKP(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RSCKP) & BM_SSI_SRCR_RSCKP)

/*! @brief Set the RSCKP field to a new value. */
#define BW_SSI_SRCR_RSCKP(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RSCKP) | BF_SSI_SRCR_RSCKP(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RSHFD[4] (RW)
 *
 * Receive Shift Direction. This bit controls whether the MSB or LSB will be
 * received first in a sample. The CODEC device labels the MSB as bit 0, whereas the
 * Core labels the LSB as bit 0. Therefore, when using a standard CODEC, Core
 * MSB (CODEC LSB) is shifted in first (RSHFD cleared).
 *
 * Values:
 * - 0 - Data received MSB first.
 * - 1 - Data received LSB first.
 */
/*@{*/
#define BP_SSI_SRCR_RSHFD    (4U)          /*!< Bit position for SSI_SRCR_RSHFD. */
#define BM_SSI_SRCR_RSHFD    (0x00000010U) /*!< Bit mask for SSI_SRCR_RSHFD. */
#define BS_SSI_SRCR_RSHFD    (1U)          /*!< Bit field size in bits for SSI_SRCR_RSHFD. */

#define BV_SSI_SRCR_RSHFD_MSB_FIRST    (0U)          /*!< Bit field value for SSI_SRCR_RSHFD: Data received MSB first. */
#define BV_SSI_SRCR_RSHFD_LSB_FIRST    (0x1U)        /*!< Bit field value for SSI_SRCR_RSHFD: Data received LSB first. */

/*! @brief Read current value of the SSI_SRCR_RSHFD field. */
#define BR_SSI_SRCR_RSHFD(x) (HW_SSI_SRCR(x).B.RSHFD)

/*! @brief Format value for bitfield SSI_SRCR_RSHFD. */
#define BF_SSI_SRCR_RSHFD(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RSHFD) & BM_SSI_SRCR_RSHFD)

/*! @brief Set the RSHFD field to a new value. */
#define BW_SSI_SRCR_RSHFD(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RSHFD) | BF_SSI_SRCR_RSHFD(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RXDIR[5] (RW)
 *
 * Receive Clock Direction. This bit controls the direction and source of the
 * clock signal used to clock the RXSR. Internally generated clock is output
 * through the SRCK port. External clock is taken from this port. Refer to for details
 * on clock pin configurations.
 *
 * Values:
 * - 0 - Receive Clock is external.
 * - 1 - Receive Clock generated internally.
 */
/*@{*/
#define BP_SSI_SRCR_RXDIR    (5U)          /*!< Bit position for SSI_SRCR_RXDIR. */
#define BM_SSI_SRCR_RXDIR    (0x00000020U) /*!< Bit mask for SSI_SRCR_RXDIR. */
#define BS_SSI_SRCR_RXDIR    (1U)          /*!< Bit field size in bits for SSI_SRCR_RXDIR. */

#define BV_SSI_SRCR_RXDIR_EXTERNAL     (0U)          /*!< Bit field value for SSI_SRCR_RXDIR: Receive Clock is external. */
#define BV_SSI_SRCR_RXDIR_INTERNAL     (0x1U)        /*!< Bit field value for SSI_SRCR_RXDIR: Receive Clock generated internally. */

/*! @brief Read current value of the SSI_SRCR_RXDIR field. */
#define BR_SSI_SRCR_RXDIR(x) (HW_SSI_SRCR(x).B.RXDIR)

/*! @brief Format value for bitfield SSI_SRCR_RXDIR. */
#define BF_SSI_SRCR_RXDIR(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RXDIR) & BM_SSI_SRCR_RXDIR)

/*! @brief Set the RXDIR field to a new value. */
#define BW_SSI_SRCR_RXDIR(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RXDIR) | BF_SSI_SRCR_RXDIR(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RFDIR[6] (RW)
 *
 * Receive Frame Direction. This bit controls the direction and source of the
 * receive frame sync signal. Internally generated frame sync signal is sent out
 * through the SRFS port and external frame sync is taken from the same port.
 *
 * Values:
 * - 0 - Frame Sync is external.
 * - 1 - Frame Sync generated internally.
 */
/*@{*/
#define BP_SSI_SRCR_RFDIR    (6U)          /*!< Bit position for SSI_SRCR_RFDIR. */
#define BM_SSI_SRCR_RFDIR    (0x00000040U) /*!< Bit mask for SSI_SRCR_RFDIR. */
#define BS_SSI_SRCR_RFDIR    (1U)          /*!< Bit field size in bits for SSI_SRCR_RFDIR. */

#define BV_SSI_SRCR_RFDIR_EXTERNAL     (0U)          /*!< Bit field value for SSI_SRCR_RFDIR: Frame Sync is external. */
#define BV_SSI_SRCR_RFDIR_INTERNAL     (0x1U)        /*!< Bit field value for SSI_SRCR_RFDIR: Frame Sync generated internally. */

/*! @brief Read current value of the SSI_SRCR_RFDIR field. */
#define BR_SSI_SRCR_RFDIR(x) (HW_SSI_SRCR(x).B.RFDIR)

/*! @brief Format value for bitfield SSI_SRCR_RFDIR. */
#define BF_SSI_SRCR_RFDIR(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RFDIR) & BM_SSI_SRCR_RFDIR)

/*! @brief Set the RFDIR field to a new value. */
#define BW_SSI_SRCR_RFDIR(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RFDIR) | BF_SSI_SRCR_RFDIR(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RFEN0[7] (RW)
 *
 * Receive FIFO Enable 0. This bit enables receive FIFO 0. When enabled, the
 * FIFO allows15 samples to be received by the SSI (per channel) (a 16th sample can
 * be shifting in) before RDR0 bit is set. When the FIFO is disabled, an
 * interrupt is generated when a single sample is received by the SSI (provided the
 * interrupt is enabled).
 *
 * Values:
 * - 0 - Receive FIFO 0 disabled.
 * - 1 - Receive FIFO 0 enabled.
 */
/*@{*/
#define BP_SSI_SRCR_RFEN0    (7U)          /*!< Bit position for SSI_SRCR_RFEN0. */
#define BM_SSI_SRCR_RFEN0    (0x00000080U) /*!< Bit mask for SSI_SRCR_RFEN0. */
#define BS_SSI_SRCR_RFEN0    (1U)          /*!< Bit field size in bits for SSI_SRCR_RFEN0. */

/*! @brief Read current value of the SSI_SRCR_RFEN0 field. */
#define BR_SSI_SRCR_RFEN0(x) (HW_SSI_SRCR(x).B.RFEN0)

/*! @brief Format value for bitfield SSI_SRCR_RFEN0. */
#define BF_SSI_SRCR_RFEN0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RFEN0) & BM_SSI_SRCR_RFEN0)

/*! @brief Set the RFEN0 field to a new value. */
#define BW_SSI_SRCR_RFEN0(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RFEN0) | BF_SSI_SRCR_RFEN0(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RFEN1[8] (RW)
 *
 * Receive FIFO Enable 1. This bit enables receive FIFO 1. When enabled, the
 * FIFO allows15 samples to be received by the SSI per channel (a 16th sample can be
 * shifting in) before RDR1 bit is set. When the FIFO is disabled, an interrupt
 * is generated when a single sample is received by the SSI (provided the
 * interrupt is enabled).
 *
 * Values:
 * - 0 - Receive FIFO 1 disabled.
 * - 1 - Receive FIFO 1 enabled.
 */
/*@{*/
#define BP_SSI_SRCR_RFEN1    (8U)          /*!< Bit position for SSI_SRCR_RFEN1. */
#define BM_SSI_SRCR_RFEN1    (0x00000100U) /*!< Bit mask for SSI_SRCR_RFEN1. */
#define BS_SSI_SRCR_RFEN1    (1U)          /*!< Bit field size in bits for SSI_SRCR_RFEN1. */

/*! @brief Read current value of the SSI_SRCR_RFEN1 field. */
#define BR_SSI_SRCR_RFEN1(x) (HW_SSI_SRCR(x).B.RFEN1)

/*! @brief Format value for bitfield SSI_SRCR_RFEN1. */
#define BF_SSI_SRCR_RFEN1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RFEN1) & BM_SSI_SRCR_RFEN1)

/*! @brief Set the RFEN1 field to a new value. */
#define BW_SSI_SRCR_RFEN1(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RFEN1) | BF_SSI_SRCR_RFEN1(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RXBIT0[9] (RW)
 *
 * Receive Bit 0. This control bit allows SSI to receive the data word at bit
 * position 0 or 15/31 in the receive shift register. The shifting data direction
 * can be MSB or LSB first, controlled by the RSHFD bit.
 *
 * Values:
 * - 0 - Shifting with respect to bit 31 (if word length = 16, 18, 20, 22 or 24)
 *     or bit 15 (if word length = 8, 10 or 12) of receive shift register (MSB
 *     aligned).
 * - 1 - Shifting with respect to bit 0 of receive shift register (LSB aligned).
 */
/*@{*/
#define BP_SSI_SRCR_RXBIT0   (9U)          /*!< Bit position for SSI_SRCR_RXBIT0. */
#define BM_SSI_SRCR_RXBIT0   (0x00000200U) /*!< Bit mask for SSI_SRCR_RXBIT0. */
#define BS_SSI_SRCR_RXBIT0   (1U)          /*!< Bit field size in bits for SSI_SRCR_RXBIT0. */

#define BV_SSI_SRCR_RXBIT0_MSB_ALIGNED (0U)          /*!< Bit field value for SSI_SRCR_RXBIT0: Shifting with respect to bit 31 (if word length = 16, 18, 20, 22 or 24) or bit 15 (if word length = 8, 10 or 12) of receive shift register (MSB aligned). */
#define BV_SSI_SRCR_RXBIT0_LSB_ALIGNED (0x1U)        /*!< Bit field value for SSI_SRCR_RXBIT0: Shifting with respect to bit 0 of receive shift register (LSB aligned). */

/*! @brief Read current value of the SSI_SRCR_RXBIT0 field. */
#define BR_SSI_SRCR_RXBIT0(x) (HW_SSI_SRCR(x).B.RXBIT0)

/*! @brief Format value for bitfield SSI_SRCR_RXBIT0. */
#define BF_SSI_SRCR_RXBIT0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RXBIT0) & BM_SSI_SRCR_RXBIT0)

/*! @brief Set the RXBIT0 field to a new value. */
#define BW_SSI_SRCR_RXBIT0(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RXBIT0) | BF_SSI_SRCR_RXBIT0(v)))
/*@}*/

/*!
 * @name Register SSI_SRCR, field RXEXT[10] (RW)
 *
 * Receive Data Extension. This control bit allows SSI to store the received
 * data word in sign extended form. This bit affects data storage only in case
 * received data is LSB aligned (SRCR[9]=1)
 *
 * Values:
 * - 0 - Sign extension turned off.
 * - 1 - Sign extension turned on.
 */
/*@{*/
#define BP_SSI_SRCR_RXEXT    (10U)         /*!< Bit position for SSI_SRCR_RXEXT. */
#define BM_SSI_SRCR_RXEXT    (0x00000400U) /*!< Bit mask for SSI_SRCR_RXEXT. */
#define BS_SSI_SRCR_RXEXT    (1U)          /*!< Bit field size in bits for SSI_SRCR_RXEXT. */

#define BV_SSI_SRCR_RXEXT_OFF          (0U)          /*!< Bit field value for SSI_SRCR_RXEXT: Sign extension turned off. */
#define BV_SSI_SRCR_RXEXT_ON           (0x1U)        /*!< Bit field value for SSI_SRCR_RXEXT: Sign extension turned on. */

/*! @brief Read current value of the SSI_SRCR_RXEXT field. */
#define BR_SSI_SRCR_RXEXT(x) (HW_SSI_SRCR(x).B.RXEXT)

/*! @brief Format value for bitfield SSI_SRCR_RXEXT. */
#define BF_SSI_SRCR_RXEXT(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCR_RXEXT) & BM_SSI_SRCR_RXEXT)

/*! @brief Set the RXEXT field to a new value. */
#define BW_SSI_SRCR_RXEXT(x, v) (HW_SSI_SRCR_WR(x, (HW_SSI_SRCR_RD(x) & ~BM_SSI_SRCR_RXEXT) | BF_SSI_SRCR_RXEXT(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_STCCR - SSI Transmit Clock Control Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_STCCR - SSI Transmit Clock Control Register (RW)
 *
 * Reset value: 0x00040000U
 *
 * The SSI Transmit and Receive Control (SSI_STCCR and SSI_SRCCR) registers are
 * 19-bit, read/write control registers used to direct the operation of the SSI.
 * The Clock Controller Module (CCM) can source the SSI clock (SSI's sys clock
 * from CCM's ssi_clk_root) from multiple sources and perform fractional division
 * to support commonly used audio bit rates. The CCM can maintain the SSI's sys
 * clock frequency at a constant rate even in cases where the ipg_clk (from CCM)
 * frequency changes. These registers control the SSI clock generator, bit and
 * frame sync rates, word length, and number of words per frame for the serial data.
 * The SSI.STCCR register is dedicated to the transmit section, and the SSI_SRCCR
 * register is dedicated to the receive section except in Synchronous mode, in
 * which the SSI_STCCR register controls both the receive and transmit sections.
 * Power-on reset clears all SSI_STCCR and SSI_SRCCR bits. SSI reset does not
 * affect the SSI_STCCR and SSI_SRCCR bits. The control bits are described in the
 * following paragraphs. Although the bit patterns of the SSI_STCCR and SSI_SRCCR
 * registers are the same, the contents of these two registers can be programmed
 * differently. SSI Data Length WL3 WL2 WL1 WL0 Number of Bits/Word Supported in
 * Implementation 0 0 0 0 2 No 0 0 0 1 4 No 0 0 1 0 6 No 0 0 1 1 8 Yes 0 1 0 0 10
 * Yes 0 1 0 1 12 Yes 0 1 1 0 14 No 0 1 1 1 16 Yes 1 0 0 0 18 Yes 1 0 0 1 20 Yes 1
 * 0 1 0 22 Yes 1 0 1 1 24 Yes 1 1 0 0 26 No 1 1 0 1 28 No 1 1 1 0 30 No 1 1 1 1
 * 32 No
 */
typedef union _hw_ssi_stccr
{
    uint32_t U;
    struct _hw_ssi_stccr_bitfields
    {
        uint32_t PM7_PM0 : 8;          /*!< [7:0]  */
        uint32_t DC4_DC0 : 5;          /*!< [12:8]  */
        uint32_t WL3_WL0 : 4;          /*!< [16:13]  */
        uint32_t PSR : 1;              /*!< [17]  */
        uint32_t DIV2 : 1;             /*!< [18]  */
        uint32_t RESERVED0 : 13;       /*!< [31:19]  */
    } B;
} hw_ssi_stccr_t;

/*!
 * @name Constants and macros for entire SSI_STCCR register
 */
/*@{*/
#define HW_SSI_STCCR_ADDR(x)     ((uintptr_t)(x) + 0x24U)

#define HW_SSI_STCCR(x)          (*(__IO hw_ssi_stccr_t *) HW_SSI_STCCR_ADDR(x))
#define HW_SSI_STCCR_RD(x)       (HW_SSI_STCCR(x).U)
#define HW_SSI_STCCR_WR(x, v)    (HW_SSI_STCCR(x).U = (v))
#define HW_SSI_STCCR_SET(x, v)   (HW_SSI_STCCR_WR(x, HW_SSI_STCCR_RD(x) |  (v)))
#define HW_SSI_STCCR_CLR(x, v)   (HW_SSI_STCCR_WR(x, HW_SSI_STCCR_RD(x) & ~(v)))
#define HW_SSI_STCCR_TOG(x, v)   (HW_SSI_STCCR_WR(x, HW_SSI_STCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_STCCR bitfields
 */

/*!
 * @name Register SSI_STCCR, field PM7_PM0[7:0] (RW)
 *
 * Prescaler Modulus Select. These bits control the prescale divider in the
 * clock generator. This prescaler is used only in Internal Clock mode to divide the
 * internal clock. The bit clock output is available at the clock port. A divide
 * ratio from 1 to 256 (PM[7:0] = 0x00 to 0xFF) can be selected. Refer to DIV2,
 * PSR and PM Bit Description for details regarding settings.
 */
/*@{*/
#define BP_SSI_STCCR_PM7_PM0 (0U)          /*!< Bit position for SSI_STCCR_PM7_PM0. */
#define BM_SSI_STCCR_PM7_PM0 (0x000000FFU) /*!< Bit mask for SSI_STCCR_PM7_PM0. */
#define BS_SSI_STCCR_PM7_PM0 (8U)          /*!< Bit field size in bits for SSI_STCCR_PM7_PM0. */

/*! @brief Read current value of the SSI_STCCR_PM7_PM0 field. */
#define BR_SSI_STCCR_PM7_PM0(x) (HW_SSI_STCCR(x).B.PM7_PM0)

/*! @brief Format value for bitfield SSI_STCCR_PM7_PM0. */
#define BF_SSI_STCCR_PM7_PM0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCCR_PM7_PM0) & BM_SSI_STCCR_PM7_PM0)

/*! @brief Set the PM7_PM0 field to a new value. */
#define BW_SSI_STCCR_PM7_PM0(x, v) (HW_SSI_STCCR_WR(x, (HW_SSI_STCCR_RD(x) & ~BM_SSI_STCCR_PM7_PM0) | BF_SSI_STCCR_PM7_PM0(v)))
/*@}*/

/*!
 * @name Register SSI_STCCR, field DC4_DC0[12:8] (RW)
 *
 * Frame Rate Divider Control. These bits are used to control the divide ratio
 * for the programmable frame rate dividers. The divide ratio works on the word
 * clock. In Normal mode, this ratio determines the word transfer rate. In Network
 * mode, this ratio sets the number of words per frame. The divide ratio ranges
 * from 1 to 32 in Normal mode and from 2 to 32 in Network mode. In Normal mode, a
 * divide ratio of 1 (DC=00000) provides continuous periodic data word transfer.
 * A bit-length frame sync must be used in this case. These bits can be
 * programmed with values ranging from "00000" to "11111" to control the number of words
 * in a frame.
 */
/*@{*/
#define BP_SSI_STCCR_DC4_DC0 (8U)          /*!< Bit position for SSI_STCCR_DC4_DC0. */
#define BM_SSI_STCCR_DC4_DC0 (0x00001F00U) /*!< Bit mask for SSI_STCCR_DC4_DC0. */
#define BS_SSI_STCCR_DC4_DC0 (5U)          /*!< Bit field size in bits for SSI_STCCR_DC4_DC0. */

/*! @brief Read current value of the SSI_STCCR_DC4_DC0 field. */
#define BR_SSI_STCCR_DC4_DC0(x) (HW_SSI_STCCR(x).B.DC4_DC0)

/*! @brief Format value for bitfield SSI_STCCR_DC4_DC0. */
#define BF_SSI_STCCR_DC4_DC0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCCR_DC4_DC0) & BM_SSI_STCCR_DC4_DC0)

/*! @brief Set the DC4_DC0 field to a new value. */
#define BW_SSI_STCCR_DC4_DC0(x, v) (HW_SSI_STCCR_WR(x, (HW_SSI_STCCR_RD(x) & ~BM_SSI_STCCR_DC4_DC0) | BF_SSI_STCCR_DC4_DC0(v)))
/*@}*/

/*!
 * @name Register SSI_STCCR, field WL3_WL0[16:13] (RW)
 *
 * Word Length Control. These bits are used to control the length of the data
 * words being transferred by the SSI. These bits control the Word Length Divider
 * in the Clock Generator. They also control the frame sync pulse length when the
 * FSL bit is cleared. In I2S Master mode, the SSI works with a fixed word length
 * of 32, and the WL bits are used to control the amount of valid data in those
 * 32 bits. In AC97 Mode of operation, if word length is set to any value other
 * than 16 bits, it will result in a word length of 20 bits.
 */
/*@{*/
#define BP_SSI_STCCR_WL3_WL0 (13U)         /*!< Bit position for SSI_STCCR_WL3_WL0. */
#define BM_SSI_STCCR_WL3_WL0 (0x0001E000U) /*!< Bit mask for SSI_STCCR_WL3_WL0. */
#define BS_SSI_STCCR_WL3_WL0 (4U)          /*!< Bit field size in bits for SSI_STCCR_WL3_WL0. */

/*! @brief Read current value of the SSI_STCCR_WL3_WL0 field. */
#define BR_SSI_STCCR_WL3_WL0(x) (HW_SSI_STCCR(x).B.WL3_WL0)

/*! @brief Format value for bitfield SSI_STCCR_WL3_WL0. */
#define BF_SSI_STCCR_WL3_WL0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCCR_WL3_WL0) & BM_SSI_STCCR_WL3_WL0)

/*! @brief Set the WL3_WL0 field to a new value. */
#define BW_SSI_STCCR_WL3_WL0(x, v) (HW_SSI_STCCR_WR(x, (HW_SSI_STCCR_RD(x) & ~BM_SSI_STCCR_WL3_WL0) | BF_SSI_STCCR_WL3_WL0(v)))
/*@}*/

/*!
 * @name Register SSI_STCCR, field PSR[17] (RW)
 *
 * Prescaler Range. This bit controls a fixed divide-by-eight prescaler in
 * series with the variable prescaler. It extends the range of the prescaler for those
 * cases where a slower bit clock is required. 0 Prescaler bypassed. 1 Prescaler
 * used to divide clock by 8.
 */
/*@{*/
#define BP_SSI_STCCR_PSR     (17U)         /*!< Bit position for SSI_STCCR_PSR. */
#define BM_SSI_STCCR_PSR     (0x00020000U) /*!< Bit mask for SSI_STCCR_PSR. */
#define BS_SSI_STCCR_PSR     (1U)          /*!< Bit field size in bits for SSI_STCCR_PSR. */

/*! @brief Read current value of the SSI_STCCR_PSR field. */
#define BR_SSI_STCCR_PSR(x)  (HW_SSI_STCCR(x).B.PSR)

/*! @brief Format value for bitfield SSI_STCCR_PSR. */
#define BF_SSI_STCCR_PSR(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_STCCR_PSR) & BM_SSI_STCCR_PSR)

/*! @brief Set the PSR field to a new value. */
#define BW_SSI_STCCR_PSR(x, v) (HW_SSI_STCCR_WR(x, (HW_SSI_STCCR_RD(x) & ~BM_SSI_STCCR_PSR) | BF_SSI_STCCR_PSR(v)))
/*@}*/

/*!
 * @name Register SSI_STCCR, field DIV2[18] (RW)
 *
 * Divide By 2. This bit controls a divide-by-two divider in series with the
 * rest of the prescalers. 0 Divider bypassed. 1 Divider used to divide clock by 2.
 */
/*@{*/
#define BP_SSI_STCCR_DIV2    (18U)         /*!< Bit position for SSI_STCCR_DIV2. */
#define BM_SSI_STCCR_DIV2    (0x00040000U) /*!< Bit mask for SSI_STCCR_DIV2. */
#define BS_SSI_STCCR_DIV2    (1U)          /*!< Bit field size in bits for SSI_STCCR_DIV2. */

/*! @brief Read current value of the SSI_STCCR_DIV2 field. */
#define BR_SSI_STCCR_DIV2(x) (HW_SSI_STCCR(x).B.DIV2)

/*! @brief Format value for bitfield SSI_STCCR_DIV2. */
#define BF_SSI_STCCR_DIV2(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STCCR_DIV2) & BM_SSI_STCCR_DIV2)

/*! @brief Set the DIV2 field to a new value. */
#define BW_SSI_STCCR_DIV2(x, v) (HW_SSI_STCCR_WR(x, (HW_SSI_STCCR_RD(x) & ~BM_SSI_STCCR_DIV2) | BF_SSI_STCCR_DIV2(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SRCCR - SSI Receive Clock Control Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SRCCR - SSI Receive Clock Control Register (RW)
 *
 * Reset value: 0x00040000U
 *
 * The SSI Transmit and Receive Control (SSI_STCCR and SSI_SRCCR) registers are
 * 19-bit, read/write control registers used to direct the operation of the SSI.
 * The Clock Controller Module (CCM) can source the SSI clock (SSI's sys
 * clock-from CCM's ssi_clk_root) from multiple sources and perform fractional division
 * to support commonly used audio bit rates. The CCM can maintain the SSI's sys
 * clock frequency at a constant rate even in cases where the ipg_clk from CCM
 * frequency changes. These registers control the SSI clock generator, bit and frame
 * sync rates, word length, and number of words per frame for the serial data.
 * The SSI_STCCR register is dedicated to the transmit section, and the SSI_SRCCR
 * register is dedicated to the receive section except in Synchronous mode, in
 * which the SSI_STCCR register controls both the receive and transmit sections.
 * Power-on reset clears all SSI_STCCR and SSI_SRCCR bits. SSI reset does not affect
 * the SSI_STCCR and SSI_SRCCR bits. The control bits are described in the
 * following paragraphs. Although the bit patterns of the SSI_STCCR and SSI_SRCCR
 * registers are the same, the contents of these two registers can be programmed
 * differently. SSI Data Length WL3 WL2 WL1 WL0 Number of Bits/Word Supported in
 * Implementation 0 0 0 0 2 No 0 0 0 1 4 No 0 0 1 0 6 No 0 0 1 1 8 Yes 0 1 0 0 10 Yes
 * 0 1 0 1 12 Yes 0 1 1 0 14 No 0 1 1 1 16 Yes 1 0 0 0 18 Yes 1 0 0 1 20 Yes 1 0
 * 1 0 22 Yes 1 0 1 1 24 Yes 1 1 0 0 26 No 1 1 0 1 28 No 1 1 1 0 30 No 1 1 1 1
 * 32 No
 */
typedef union _hw_ssi_srccr
{
    uint32_t U;
    struct _hw_ssi_srccr_bitfields
    {
        uint32_t PM7_PM0 : 8;          /*!< [7:0]  */
        uint32_t DC4_DC0 : 5;          /*!< [12:8]  */
        uint32_t WL3_WL0 : 4;          /*!< [16:13]  */
        uint32_t PSR : 1;              /*!< [17]  */
        uint32_t DIV2 : 1;             /*!< [18]  */
        uint32_t RESERVED0 : 13;       /*!< [31:19]  */
    } B;
} hw_ssi_srccr_t;

/*!
 * @name Constants and macros for entire SSI_SRCCR register
 */
/*@{*/
#define HW_SSI_SRCCR_ADDR(x)     ((uintptr_t)(x) + 0x28U)

#define HW_SSI_SRCCR(x)          (*(__IO hw_ssi_srccr_t *) HW_SSI_SRCCR_ADDR(x))
#define HW_SSI_SRCCR_RD(x)       (HW_SSI_SRCCR(x).U)
#define HW_SSI_SRCCR_WR(x, v)    (HW_SSI_SRCCR(x).U = (v))
#define HW_SSI_SRCCR_SET(x, v)   (HW_SSI_SRCCR_WR(x, HW_SSI_SRCCR_RD(x) |  (v)))
#define HW_SSI_SRCCR_CLR(x, v)   (HW_SSI_SRCCR_WR(x, HW_SSI_SRCCR_RD(x) & ~(v)))
#define HW_SSI_SRCCR_TOG(x, v)   (HW_SSI_SRCCR_WR(x, HW_SSI_SRCCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SRCCR bitfields
 */

/*!
 * @name Register SSI_SRCCR, field PM7_PM0[7:0] (RW)
 *
 * Prescaler Modulus Select. These bits control the prescale divider in the
 * clock generator. This prescaler is used only in Internal Clock mode to divide the
 * internal clock. The bit clock output is available at the clock port. A divide
 * ratio from 1 to 256 (PM[7:0] = 0x00 to 0xFF) can be selected. Refer to DIV2,
 * PSR and PM Bit Description for details regarding settings.
 */
/*@{*/
#define BP_SSI_SRCCR_PM7_PM0 (0U)          /*!< Bit position for SSI_SRCCR_PM7_PM0. */
#define BM_SSI_SRCCR_PM7_PM0 (0x000000FFU) /*!< Bit mask for SSI_SRCCR_PM7_PM0. */
#define BS_SSI_SRCCR_PM7_PM0 (8U)          /*!< Bit field size in bits for SSI_SRCCR_PM7_PM0. */

/*! @brief Read current value of the SSI_SRCCR_PM7_PM0 field. */
#define BR_SSI_SRCCR_PM7_PM0(x) (HW_SSI_SRCCR(x).B.PM7_PM0)

/*! @brief Format value for bitfield SSI_SRCCR_PM7_PM0. */
#define BF_SSI_SRCCR_PM7_PM0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCCR_PM7_PM0) & BM_SSI_SRCCR_PM7_PM0)

/*! @brief Set the PM7_PM0 field to a new value. */
#define BW_SSI_SRCCR_PM7_PM0(x, v) (HW_SSI_SRCCR_WR(x, (HW_SSI_SRCCR_RD(x) & ~BM_SSI_SRCCR_PM7_PM0) | BF_SSI_SRCCR_PM7_PM0(v)))
/*@}*/

/*!
 * @name Register SSI_SRCCR, field DC4_DC0[12:8] (RW)
 *
 * Frame Rate Divider Control. These bits are used to control the divide ratio
 * for the programmable frame rate dividers. The divide ratio works on the word
 * clock. In Normal mode, this ratio determines the word transfer rate. In Network
 * mode, this ratio sets the number of words per frame. The divide ratio ranges
 * from 1 to 32 in Normal mode and from 2 to 32 in Network mode. In Normal mode, a
 * divide ratio of 1 (DC=00000) provides continuous periodic data word transfer.
 * A bit-length frame sync must be used in this case. These bits can be
 * programmed with values ranging from "00000" to "11111" to control the number of words
 * in a frame.
 */
/*@{*/
#define BP_SSI_SRCCR_DC4_DC0 (8U)          /*!< Bit position for SSI_SRCCR_DC4_DC0. */
#define BM_SSI_SRCCR_DC4_DC0 (0x00001F00U) /*!< Bit mask for SSI_SRCCR_DC4_DC0. */
#define BS_SSI_SRCCR_DC4_DC0 (5U)          /*!< Bit field size in bits for SSI_SRCCR_DC4_DC0. */

/*! @brief Read current value of the SSI_SRCCR_DC4_DC0 field. */
#define BR_SSI_SRCCR_DC4_DC0(x) (HW_SSI_SRCCR(x).B.DC4_DC0)

/*! @brief Format value for bitfield SSI_SRCCR_DC4_DC0. */
#define BF_SSI_SRCCR_DC4_DC0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCCR_DC4_DC0) & BM_SSI_SRCCR_DC4_DC0)

/*! @brief Set the DC4_DC0 field to a new value. */
#define BW_SSI_SRCCR_DC4_DC0(x, v) (HW_SSI_SRCCR_WR(x, (HW_SSI_SRCCR_RD(x) & ~BM_SSI_SRCCR_DC4_DC0) | BF_SSI_SRCCR_DC4_DC0(v)))
/*@}*/

/*!
 * @name Register SSI_SRCCR, field WL3_WL0[16:13] (RW)
 *
 * Word Length Control. These bits are used to control the length of the data
 * words being transferred by the SSI. These bits control the Word Length Divider
 * in the Clock Generator. They also control the frame sync pulse length when the
 * FSL bit is cleared. In I2S Master mode, the SSI works with a fixed word length
 * of 32, and the WL bits are used to control the amount of valid data in those
 * 32 bits. In AC97 Mode of operation, if word length is set to any value other
 * than 16 bits, it will result in a word length of 20 bits.
 */
/*@{*/
#define BP_SSI_SRCCR_WL3_WL0 (13U)         /*!< Bit position for SSI_SRCCR_WL3_WL0. */
#define BM_SSI_SRCCR_WL3_WL0 (0x0001E000U) /*!< Bit mask for SSI_SRCCR_WL3_WL0. */
#define BS_SSI_SRCCR_WL3_WL0 (4U)          /*!< Bit field size in bits for SSI_SRCCR_WL3_WL0. */

/*! @brief Read current value of the SSI_SRCCR_WL3_WL0 field. */
#define BR_SSI_SRCCR_WL3_WL0(x) (HW_SSI_SRCCR(x).B.WL3_WL0)

/*! @brief Format value for bitfield SSI_SRCCR_WL3_WL0. */
#define BF_SSI_SRCCR_WL3_WL0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCCR_WL3_WL0) & BM_SSI_SRCCR_WL3_WL0)

/*! @brief Set the WL3_WL0 field to a new value. */
#define BW_SSI_SRCCR_WL3_WL0(x, v) (HW_SSI_SRCCR_WR(x, (HW_SSI_SRCCR_RD(x) & ~BM_SSI_SRCCR_WL3_WL0) | BF_SSI_SRCCR_WL3_WL0(v)))
/*@}*/

/*!
 * @name Register SSI_SRCCR, field PSR[17] (RW)
 *
 * Prescaler Range. This bit controls a fixed divide-by-eight prescaler in
 * series with the variable prescaler. It extends the range of the prescaler for those
 * cases where a slower bit clock is required. 0 Prescaler bypassed. 1 Prescaler
 * used to divide clock by 8.
 */
/*@{*/
#define BP_SSI_SRCCR_PSR     (17U)         /*!< Bit position for SSI_SRCCR_PSR. */
#define BM_SSI_SRCCR_PSR     (0x00020000U) /*!< Bit mask for SSI_SRCCR_PSR. */
#define BS_SSI_SRCCR_PSR     (1U)          /*!< Bit field size in bits for SSI_SRCCR_PSR. */

/*! @brief Read current value of the SSI_SRCCR_PSR field. */
#define BR_SSI_SRCCR_PSR(x)  (HW_SSI_SRCCR(x).B.PSR)

/*! @brief Format value for bitfield SSI_SRCCR_PSR. */
#define BF_SSI_SRCCR_PSR(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SRCCR_PSR) & BM_SSI_SRCCR_PSR)

/*! @brief Set the PSR field to a new value. */
#define BW_SSI_SRCCR_PSR(x, v) (HW_SSI_SRCCR_WR(x, (HW_SSI_SRCCR_RD(x) & ~BM_SSI_SRCCR_PSR) | BF_SSI_SRCCR_PSR(v)))
/*@}*/

/*!
 * @name Register SSI_SRCCR, field DIV2[18] (RW)
 *
 * Divide By 2. This bit controls a divide-by-two divider in series with the
 * rest of the prescalers. 0 Divider bypassed. 1 Divider used to divide clock by 2.
 */
/*@{*/
#define BP_SSI_SRCCR_DIV2    (18U)         /*!< Bit position for SSI_SRCCR_DIV2. */
#define BM_SSI_SRCCR_DIV2    (0x00040000U) /*!< Bit mask for SSI_SRCCR_DIV2. */
#define BS_SSI_SRCCR_DIV2    (1U)          /*!< Bit field size in bits for SSI_SRCCR_DIV2. */

/*! @brief Read current value of the SSI_SRCCR_DIV2 field. */
#define BR_SSI_SRCCR_DIV2(x) (HW_SSI_SRCCR(x).B.DIV2)

/*! @brief Format value for bitfield SSI_SRCCR_DIV2. */
#define BF_SSI_SRCCR_DIV2(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRCCR_DIV2) & BM_SSI_SRCCR_DIV2)

/*! @brief Set the DIV2 field to a new value. */
#define BW_SSI_SRCCR_DIV2(x, v) (HW_SSI_SRCCR_WR(x, (HW_SSI_SRCCR_RD(x) & ~BM_SSI_SRCCR_DIV2) | BF_SSI_SRCCR_DIV2(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SFCSR - SSI FIFO Control/Status Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SFCSR - SSI FIFO Control/Status Register (RW)
 *
 * Reset value: 0x00810081U
 *
 * The SSI FIFO Control / Status Register indicates the status of the Transmit
 * FIFO Empty flag, with different settings of the Transmit FIFO WaterMark bits
 * and varying amounts of data in the Tx FIFO . Status of Transmit FIFO Empty Flag
 * Transmit FIFO Watermark (TFWM) Number of data in Tx-Fifo 1 2 3 4 5 6 7 8 9 10
 * 11 12 13 14 15 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 2 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0
 * 3 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 4 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 5 1 1 1 1 1 1
 * 1 1 1 1 0 0 0 0 0 6 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 7 1 1 1 1 1 1 1 1 0 0 0 0 0
 * 0 0 8 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 9 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 10 1 1 1
 * 1 1 0 0 0 0 0 0 0 0 0 0 11 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 12 1 1 1 0 0 0 0 0 0
 * 0 0 0 0 0 0 13 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 14 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 * 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 */
typedef union _hw_ssi_sfcsr
{
    uint32_t U;
    struct _hw_ssi_sfcsr_bitfields
    {
        uint32_t TFWM0 : 4;            /*!< [3:0]  */
        uint32_t RFWM0 : 4;            /*!< [7:4]  */
        uint32_t TFCNT0 : 4;           /*!< [11:8]  */
        uint32_t RFCNT0 : 4;           /*!< [15:12]  */
        uint32_t TFWM1 : 4;            /*!< [19:16]  */
        uint32_t RFWM1 : 4;            /*!< [23:20]  */
        uint32_t TFCNT1 : 4;           /*!< [27:24]  */
        uint32_t RFCNT1 : 4;           /*!< [31:28]  */
    } B;
} hw_ssi_sfcsr_t;

/*!
 * @name Constants and macros for entire SSI_SFCSR register
 */
/*@{*/
#define HW_SSI_SFCSR_ADDR(x)     ((uintptr_t)(x) + 0x2CU)

#define HW_SSI_SFCSR(x)          (*(__IO hw_ssi_sfcsr_t *) HW_SSI_SFCSR_ADDR(x))
#define HW_SSI_SFCSR_RD(x)       (HW_SSI_SFCSR(x).U)
#define HW_SSI_SFCSR_WR(x, v)    (HW_SSI_SFCSR(x).U = (v))
#define HW_SSI_SFCSR_SET(x, v)   (HW_SSI_SFCSR_WR(x, HW_SSI_SFCSR_RD(x) |  (v)))
#define HW_SSI_SFCSR_CLR(x, v)   (HW_SSI_SFCSR_WR(x, HW_SSI_SFCSR_RD(x) & ~(v)))
#define HW_SSI_SFCSR_TOG(x, v)   (HW_SSI_SFCSR_WR(x, HW_SSI_SFCSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SFCSR bitfields
 */

/*!
 * @name Register SSI_SFCSR, field TFWM0[3:0] (RW)
 *
 * Transmit FIFO Empty WaterMark 0. These bits control the threshold at which
 * the TFE0 flag will be set. The TFE0 flag is set whenever the empty slots in Tx
 * FIFO exceed or are equal to the selected threshold. See SSI_SFCSR[TFWM0] for
 * details regarding settings for transmit FIFO watermark bits.
 */
/*@{*/
#define BP_SSI_SFCSR_TFWM0   (0U)          /*!< Bit position for SSI_SFCSR_TFWM0. */
#define BM_SSI_SFCSR_TFWM0   (0x0000000FU) /*!< Bit mask for SSI_SFCSR_TFWM0. */
#define BS_SSI_SFCSR_TFWM0   (4U)          /*!< Bit field size in bits for SSI_SFCSR_TFWM0. */

/*! @brief Read current value of the SSI_SFCSR_TFWM0 field. */
#define BR_SSI_SFCSR_TFWM0(x) (HW_SSI_SFCSR(x).B.TFWM0)

/*! @brief Format value for bitfield SSI_SFCSR_TFWM0. */
#define BF_SSI_SFCSR_TFWM0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_TFWM0) & BM_SSI_SFCSR_TFWM0)

/*! @brief Set the TFWM0 field to a new value. */
#define BW_SSI_SFCSR_TFWM0(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_TFWM0) | BF_SSI_SFCSR_TFWM0(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field RFWM0[7:4] (RW)
 *
 * Receive FIFO Full WaterMark 0. These bits control the threshold at which the
 * RFF0 flag will be set. The RFF0 flag is set whenever the data level in Rx FIFO
 * 0 reaches the selected threshold. See SSI_SFCSR[RFWM1] for details regarding
 * settings for receive FIFO watermark bits.
 */
/*@{*/
#define BP_SSI_SFCSR_RFWM0   (4U)          /*!< Bit position for SSI_SFCSR_RFWM0. */
#define BM_SSI_SFCSR_RFWM0   (0x000000F0U) /*!< Bit mask for SSI_SFCSR_RFWM0. */
#define BS_SSI_SFCSR_RFWM0   (4U)          /*!< Bit field size in bits for SSI_SFCSR_RFWM0. */

/*! @brief Read current value of the SSI_SFCSR_RFWM0 field. */
#define BR_SSI_SFCSR_RFWM0(x) (HW_SSI_SFCSR(x).B.RFWM0)

/*! @brief Format value for bitfield SSI_SFCSR_RFWM0. */
#define BF_SSI_SFCSR_RFWM0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_RFWM0) & BM_SSI_SFCSR_RFWM0)

/*! @brief Set the RFWM0 field to a new value. */
#define BW_SSI_SFCSR_RFWM0(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_RFWM0) | BF_SSI_SFCSR_RFWM0(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field TFCNT0[11:8] (RW)
 *
 * Transmit FIFO Counter 0. These bits indicate the number of data words in
 * Transmit FIFO 0. See SSI_SFCSR[TFCNT1] for details regarding settings for transmit
 * FIFO counter bits.
 */
/*@{*/
#define BP_SSI_SFCSR_TFCNT0  (8U)          /*!< Bit position for SSI_SFCSR_TFCNT0. */
#define BM_SSI_SFCSR_TFCNT0  (0x00000F00U) /*!< Bit mask for SSI_SFCSR_TFCNT0. */
#define BS_SSI_SFCSR_TFCNT0  (4U)          /*!< Bit field size in bits for SSI_SFCSR_TFCNT0. */

/*! @brief Read current value of the SSI_SFCSR_TFCNT0 field. */
#define BR_SSI_SFCSR_TFCNT0(x) (HW_SSI_SFCSR(x).B.TFCNT0)

/*! @brief Format value for bitfield SSI_SFCSR_TFCNT0. */
#define BF_SSI_SFCSR_TFCNT0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_TFCNT0) & BM_SSI_SFCSR_TFCNT0)

/*! @brief Set the TFCNT0 field to a new value. */
#define BW_SSI_SFCSR_TFCNT0(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_TFCNT0) | BF_SSI_SFCSR_TFCNT0(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field RFCNT0[15:12] (RW)
 *
 * Receive FIFO Counter 0. These bits indicate the number of data words in
 * Receive FIFO 0. See SSI_SFCSR[RFCNT1] for details regarding settings for receive
 * FIFO counter bits.
 */
/*@{*/
#define BP_SSI_SFCSR_RFCNT0  (12U)         /*!< Bit position for SSI_SFCSR_RFCNT0. */
#define BM_SSI_SFCSR_RFCNT0  (0x0000F000U) /*!< Bit mask for SSI_SFCSR_RFCNT0. */
#define BS_SSI_SFCSR_RFCNT0  (4U)          /*!< Bit field size in bits for SSI_SFCSR_RFCNT0. */

/*! @brief Read current value of the SSI_SFCSR_RFCNT0 field. */
#define BR_SSI_SFCSR_RFCNT0(x) (HW_SSI_SFCSR(x).B.RFCNT0)

/*! @brief Format value for bitfield SSI_SFCSR_RFCNT0. */
#define BF_SSI_SFCSR_RFCNT0(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_RFCNT0) & BM_SSI_SFCSR_RFCNT0)

/*! @brief Set the RFCNT0 field to a new value. */
#define BW_SSI_SFCSR_RFCNT0(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_RFCNT0) | BF_SSI_SFCSR_RFCNT0(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field TFWM1[19:16] (RW)
 *
 * Transmit FIFO Empty WaterMark 1. These bits control the threshold at which
 * the TFE1 flag will be set. The TFE1 flag is set whenever the empty slots in Tx
 * FIFO exceed or are equal to the selected threshold.
 *
 * Values:
 * - 0000 - Reserved
 * - 0001 - TFE set when there are more than or equal to 1 empty slots in
 *     Transmit FIFO (default). Transmit FIFO empty is set when TxFIFO <= 14 data.
 * - 0010 - TFE set when there are more than or equal to 2 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=13 data.
 * - 0011 - TFE set when there are more than or equal to 3 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=12 data.
 * - 0100 - TFE set when there are more than or equal to 4 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=11 data.
 * - 0101 - TFE set when there are more than or equal to 5 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=10 data.
 * - 0110 - TFE set when there are more than or equal to 6 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=9 data.
 * - 0111 - TFE set when there are more than or equal to 7 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=8 data.
 * - 1000 - TFE set when there are more than or equal to 8 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <=7 data.
 * - 1001 - TFE set when there are more than or equal to 9 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 6 data.
 * - 1010 - TFE set when there are more than or equal to 10 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 5 data.
 * - 1011 - TFE set when there are more than or equal to 11 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 4 data.
 * - 1100 - TFE set when there are more than or equal to 12 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 3 data.
 * - 1101 - TFE set when there are more than or equal to 13 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 2 data.
 * - 1110 - TFE set when there are more than or equal to 14 empty slots in
 *     Transmit FIFO. Transmit FIFO empty is set when TxFIFO <= 1 data.
 * - 1111 - TFE set when there are 15 empty slots in Transmit FIFO. Transmit
 *     FIFO empty is set when TxFIFO = 0 data.
 */
/*@{*/
#define BP_SSI_SFCSR_TFWM1   (16U)         /*!< Bit position for SSI_SFCSR_TFWM1. */
#define BM_SSI_SFCSR_TFWM1   (0x000F0000U) /*!< Bit mask for SSI_SFCSR_TFWM1. */
#define BS_SSI_SFCSR_TFWM1   (4U)          /*!< Bit field size in bits for SSI_SFCSR_TFWM1. */

/*! @brief Read current value of the SSI_SFCSR_TFWM1 field. */
#define BR_SSI_SFCSR_TFWM1(x) (HW_SSI_SFCSR(x).B.TFWM1)

/*! @brief Format value for bitfield SSI_SFCSR_TFWM1. */
#define BF_SSI_SFCSR_TFWM1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_TFWM1) & BM_SSI_SFCSR_TFWM1)

/*! @brief Set the TFWM1 field to a new value. */
#define BW_SSI_SFCSR_TFWM1(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_TFWM1) | BF_SSI_SFCSR_TFWM1(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field RFWM1[23:20] (RW)
 *
 * Receive FIFO Full WaterMark 1. These bits control the threshold at which the
 * RFF1 flag will be set. The RFF1 flag is set whenever the data level in Rx FIFO
 * 1 reaches the selected threshold.
 *
 * Values:
 * - 0000 - Reserved
 * - 0001 - RFF set when at least one data word has been written to the Receive
 *     FIFO. Set when RxFIFO = 1,2.....15 data words
 * - 0010 - RFF set when 2 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 2,3.....15 data words
 * - 0011 - RFF set when 3 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 3,4.....15 data words
 * - 0100 - RFF set when 4 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 4,5.....15 data words
 * - 0101 - RFF set when 5 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 5,6.....15 data words
 * - 0110 - RFF set when 6 or more data words have been written to the Receive..
 *     Set when RxFIFO = 6,7......15 data words
 * - 0111 - RFF set when 7 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 7,8......15 data words
 * - 1000 - RFF set when 8 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO =8,9..... 15 data words
 * - 1001 - RFF set when 9 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 9,10.....15 data words
 * - 1010 - RFF set when 10 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 10,11.....15 data words
 * - 1011 - RFF set when 11 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 11,12.....15 data words
 * - 1100 - RFF set when 12 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 12,13.....15 data words
 * - 1101 - RFF set when 13 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 13,14,15data words
 * - 1110 - RFF set when 14 or more data words have been written to the Receive
 *     FIFO. Set when RxFIFO = 14,15 data words
 * - 1111 - RFF set when 15 data words have been written to the Receive FIFO
 *     (default). Set when RxFIFO = 15 data words
 */
/*@{*/
#define BP_SSI_SFCSR_RFWM1   (20U)         /*!< Bit position for SSI_SFCSR_RFWM1. */
#define BM_SSI_SFCSR_RFWM1   (0x00F00000U) /*!< Bit mask for SSI_SFCSR_RFWM1. */
#define BS_SSI_SFCSR_RFWM1   (4U)          /*!< Bit field size in bits for SSI_SFCSR_RFWM1. */

/*! @brief Read current value of the SSI_SFCSR_RFWM1 field. */
#define BR_SSI_SFCSR_RFWM1(x) (HW_SSI_SFCSR(x).B.RFWM1)

/*! @brief Format value for bitfield SSI_SFCSR_RFWM1. */
#define BF_SSI_SFCSR_RFWM1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_RFWM1) & BM_SSI_SFCSR_RFWM1)

/*! @brief Set the RFWM1 field to a new value. */
#define BW_SSI_SFCSR_RFWM1(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_RFWM1) | BF_SSI_SFCSR_RFWM1(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field TFCNT1[27:24] (RW)
 *
 * Transmit FIFO Counter1. These bits indicate the number of data words in
 * Transmit FIFO.
 *
 * Values:
 * - 0000 - 0 data word in transmit FIFO
 * - 0001 - 1 data word in transmit FIFO
 * - 0010 - 2 data word in transmit FIFO
 * - 0011 - 3 data word in transmit FIFO
 * - 0100 - 4 data word in transmit FIFO
 * - 0101 - 5 data word in transmit FIFO
 * - 0110 - 6 data word in transmit FIFO
 * - 0111 - 7 data word in transmit FIFO
 * - 1000 - 8 data word in transmit FIFO
 * - 1001 - 9 data word in transmit FIFO
 * - 1010 - 10 data word in transmit FIFO
 * - 1011 - 11 data word in transmit FIFO
 * - 1100 - 12 data word in transmit FIFO
 * - 1101 - 13 data word in transmit FIFO
 * - 1110 - 14 data word in transmit FIFO
 * - 1111 - 15 data word in transmit FIFO
 */
/*@{*/
#define BP_SSI_SFCSR_TFCNT1  (24U)         /*!< Bit position for SSI_SFCSR_TFCNT1. */
#define BM_SSI_SFCSR_TFCNT1  (0x0F000000U) /*!< Bit mask for SSI_SFCSR_TFCNT1. */
#define BS_SSI_SFCSR_TFCNT1  (4U)          /*!< Bit field size in bits for SSI_SFCSR_TFCNT1. */

/*! @brief Read current value of the SSI_SFCSR_TFCNT1 field. */
#define BR_SSI_SFCSR_TFCNT1(x) (HW_SSI_SFCSR(x).B.TFCNT1)

/*! @brief Format value for bitfield SSI_SFCSR_TFCNT1. */
#define BF_SSI_SFCSR_TFCNT1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_TFCNT1) & BM_SSI_SFCSR_TFCNT1)

/*! @brief Set the TFCNT1 field to a new value. */
#define BW_SSI_SFCSR_TFCNT1(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_TFCNT1) | BF_SSI_SFCSR_TFCNT1(v)))
/*@}*/

/*!
 * @name Register SSI_SFCSR, field RFCNT1[31:28] (RW)
 *
 * Receive FIFO Counter1. These bits indicate the number of data words in
 * Receive FIFO 1.
 *
 * Values:
 * - 0000 - 0 data word in receive FIFO
 * - 0001 - 1 data word in receive FIFO
 * - 0010 - 2 data word in receive FIFO
 * - 0011 - 3 data word in receive FIFO
 * - 0100 - 4 data word in receive FIFO
 * - 0101 - 5 data word in receive FIFO
 * - 0110 - 6 data word in receive FIFO
 * - 0111 - 7 data word in receive FIFO
 * - 1000 - 8 data word in receive FIFO
 * - 1001 - 9 data word in receive FIFO
 * - 1010 - 10 data word in receive FIFO
 * - 1011 - 11 data word in receive FIFO
 * - 1100 - 12 data word in receive FIFO
 * - 1101 - 13 data word in receive FIFO
 * - 1110 - 14 data word in receive FIFO
 * - 1111 - 15 data word in receive FIFO
 */
/*@{*/
#define BP_SSI_SFCSR_RFCNT1  (28U)         /*!< Bit position for SSI_SFCSR_RFCNT1. */
#define BM_SSI_SFCSR_RFCNT1  (0xF0000000U) /*!< Bit mask for SSI_SFCSR_RFCNT1. */
#define BS_SSI_SFCSR_RFCNT1  (4U)          /*!< Bit field size in bits for SSI_SFCSR_RFCNT1. */

/*! @brief Read current value of the SSI_SFCSR_RFCNT1 field. */
#define BR_SSI_SFCSR_RFCNT1(x) (HW_SSI_SFCSR(x).B.RFCNT1)

/*! @brief Format value for bitfield SSI_SFCSR_RFCNT1. */
#define BF_SSI_SFCSR_RFCNT1(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SFCSR_RFCNT1) & BM_SSI_SFCSR_RFCNT1)

/*! @brief Set the RFCNT1 field to a new value. */
#define BW_SSI_SFCSR_RFCNT1(x, v) (HW_SSI_SFCSR_WR(x, (HW_SSI_SFCSR_RD(x) & ~BM_SSI_SFCSR_RFCNT1) | BF_SSI_SFCSR_RFCNT1(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SACNT - SSI AC97 Control Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACNT - SSI AC97 Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_sacnt
{
    uint32_t U;
    struct _hw_ssi_sacnt_bitfields
    {
        uint32_t AC97EN : 1;           /*!< [0]  */
        uint32_t FV : 1;               /*!< [1]  */
        uint32_t TIF : 1;              /*!< [2]  */
        uint32_t RD : 1;               /*!< [3]  */
        uint32_t WR : 1;               /*!< [4]  */
        uint32_t FRDIV : 6;            /*!< [10:5]  */
        uint32_t RESERVED0 : 21;       /*!< [31:11]  */
    } B;
} hw_ssi_sacnt_t;

/*!
 * @name Constants and macros for entire SSI_SACNT register
 */
/*@{*/
#define HW_SSI_SACNT_ADDR(x)     ((uintptr_t)(x) + 0x38U)

#define HW_SSI_SACNT(x)          (*(__IO hw_ssi_sacnt_t *) HW_SSI_SACNT_ADDR(x))
#define HW_SSI_SACNT_RD(x)       (HW_SSI_SACNT(x).U)
#define HW_SSI_SACNT_WR(x, v)    (HW_SSI_SACNT(x).U = (v))
#define HW_SSI_SACNT_SET(x, v)   (HW_SSI_SACNT_WR(x, HW_SSI_SACNT_RD(x) |  (v)))
#define HW_SSI_SACNT_CLR(x, v)   (HW_SSI_SACNT_WR(x, HW_SSI_SACNT_RD(x) & ~(v)))
#define HW_SSI_SACNT_TOG(x, v)   (HW_SSI_SACNT_WR(x, HW_SSI_SACNT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SACNT bitfields
 */

/*!
 * @name Register SSI_SACNT, field AC97EN[0] (RW)
 *
 * AC97 Mode Enable. This bit is used to enable SSI AC97 operation. Refer to
 * AC97 ModeIn AC97 mode of operation, the SSI transmits a 16-bit Tag Slot at the
 * start of a frame and the rest of the slots (in that frame) are all 20-bits wide.
 * for details of AC97 operation.
 *
 * Values:
 * - 0 - AC97 mode disabled.
 * - 1 - SSI in AC97 mode.
 */
/*@{*/
#define BP_SSI_SACNT_AC97EN  (0U)          /*!< Bit position for SSI_SACNT_AC97EN. */
#define BM_SSI_SACNT_AC97EN  (0x00000001U) /*!< Bit mask for SSI_SACNT_AC97EN. */
#define BS_SSI_SACNT_AC97EN  (1U)          /*!< Bit field size in bits for SSI_SACNT_AC97EN. */

/*! @brief Read current value of the SSI_SACNT_AC97EN field. */
#define BR_SSI_SACNT_AC97EN(x) (HW_SSI_SACNT(x).B.AC97EN)

/*! @brief Format value for bitfield SSI_SACNT_AC97EN. */
#define BF_SSI_SACNT_AC97EN(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_AC97EN) & BM_SSI_SACNT_AC97EN)

/*! @brief Set the AC97EN field to a new value. */
#define BW_SSI_SACNT_AC97EN(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_AC97EN) | BF_SSI_SACNT_AC97EN(v)))
/*@}*/

/*!
 * @name Register SSI_SACNT, field FV[1] (RW)
 *
 * Fixed/Variable Operation. This bit selects whether the SSI is in AC97 Fixed
 * mode or AC97 Variable mode.
 *
 * Values:
 * - 0 - AC97 Fixed Mode.
 * - 1 - AC97 Variable Mode.
 */
/*@{*/
#define BP_SSI_SACNT_FV      (1U)          /*!< Bit position for SSI_SACNT_FV. */
#define BM_SSI_SACNT_FV      (0x00000002U) /*!< Bit mask for SSI_SACNT_FV. */
#define BS_SSI_SACNT_FV      (1U)          /*!< Bit field size in bits for SSI_SACNT_FV. */

#define BV_SSI_SACNT_FV_FIXED          (0U)          /*!< Bit field value for SSI_SACNT_FV: AC97 Fixed Mode. */
#define BV_SSI_SACNT_FV_VARIABLE       (0x1U)        /*!< Bit field value for SSI_SACNT_FV: AC97 Variable Mode. */

/*! @brief Read current value of the SSI_SACNT_FV field. */
#define BR_SSI_SACNT_FV(x)   (HW_SSI_SACNT(x).B.FV)

/*! @brief Format value for bitfield SSI_SACNT_FV. */
#define BF_SSI_SACNT_FV(v)   ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_FV) & BM_SSI_SACNT_FV)

/*! @brief Set the FV field to a new value. */
#define BW_SSI_SACNT_FV(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_FV) | BF_SSI_SACNT_FV(v)))
/*@}*/

/*!
 * @name Register SSI_SACNT, field TIF[2] (RW)
 *
 * Tag in FIFO. This bit controls the destination of the information received in
 * AC97 tag slot (Slot #0).
 *
 * Values:
 * - 0 - Tag info stored in SATAG register.
 * - 1 - Tag info stored in Rx FIFO 0.
 */
/*@{*/
#define BP_SSI_SACNT_TIF     (2U)          /*!< Bit position for SSI_SACNT_TIF. */
#define BM_SSI_SACNT_TIF     (0x00000004U) /*!< Bit mask for SSI_SACNT_TIF. */
#define BS_SSI_SACNT_TIF     (1U)          /*!< Bit field size in bits for SSI_SACNT_TIF. */

#define BV_SSI_SACNT_TIF_SATAG_REGISTER (0U)         /*!< Bit field value for SSI_SACNT_TIF: Tag info stored in SATAG register. */
#define BV_SSI_SACNT_TIF_RX_FIFO0      (0x1U)        /*!< Bit field value for SSI_SACNT_TIF: Tag info stored in Rx FIFO 0. */

/*! @brief Read current value of the SSI_SACNT_TIF field. */
#define BR_SSI_SACNT_TIF(x)  (HW_SSI_SACNT(x).B.TIF)

/*! @brief Format value for bitfield SSI_SACNT_TIF. */
#define BF_SSI_SACNT_TIF(v)  ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_TIF) & BM_SSI_SACNT_TIF)

/*! @brief Set the TIF field to a new value. */
#define BW_SSI_SACNT_TIF(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_TIF) | BF_SSI_SACNT_TIF(v)))
/*@}*/

/*!
 * @name Register SSI_SACNT, field RD[3] (RW)
 *
 * Read Command. This bit specifies whether the next frame will carry an AC97
 * Read Command or not. The programmer should take care that only one of the bits
 * (WR or RD) is set at a time. When this bit is set, the corresponding tag bit
 * (corresponding to Command Address slot of the next Tx frame) is automatically
 * set. This bit is automatically cleared by the SSI after completing transmission
 * of a frame.
 *
 * Values:
 * - 0 - Next frame will not have a Read Command.
 * - 1 - Next frame will have a Read Command.
 */
/*@{*/
#define BP_SSI_SACNT_RD      (3U)          /*!< Bit position for SSI_SACNT_RD. */
#define BM_SSI_SACNT_RD      (0x00000008U) /*!< Bit mask for SSI_SACNT_RD. */
#define BS_SSI_SACNT_RD      (1U)          /*!< Bit field size in bits for SSI_SACNT_RD. */

/*! @brief Read current value of the SSI_SACNT_RD field. */
#define BR_SSI_SACNT_RD(x)   (HW_SSI_SACNT(x).B.RD)

/*! @brief Format value for bitfield SSI_SACNT_RD. */
#define BF_SSI_SACNT_RD(v)   ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_RD) & BM_SSI_SACNT_RD)

/*! @brief Set the RD field to a new value. */
#define BW_SSI_SACNT_RD(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_RD) | BF_SSI_SACNT_RD(v)))
/*@}*/

/*!
 * @name Register SSI_SACNT, field WR[4] (RW)
 *
 * Write Command. This bit specifies whether the next frame will carry an AC97
 * Write Command or not. The programmer should take care that only one of the bits
 * (WR or RD) is set at a time. When this bit is set, the corresponding tag bits
 * (corresponding to Command Address and Command Data slots of the next Tx
 * frame) are automatically set. This bit is automatically cleared by the SSI after
 * completing transmission of a frame.
 *
 * Values:
 * - 0 - Next frame will not have a Write Command.
 * - 1 - Next frame will have a Write Command.
 */
/*@{*/
#define BP_SSI_SACNT_WR      (4U)          /*!< Bit position for SSI_SACNT_WR. */
#define BM_SSI_SACNT_WR      (0x00000010U) /*!< Bit mask for SSI_SACNT_WR. */
#define BS_SSI_SACNT_WR      (1U)          /*!< Bit field size in bits for SSI_SACNT_WR. */

/*! @brief Read current value of the SSI_SACNT_WR field. */
#define BR_SSI_SACNT_WR(x)   (HW_SSI_SACNT(x).B.WR)

/*! @brief Format value for bitfield SSI_SACNT_WR. */
#define BF_SSI_SACNT_WR(v)   ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_WR) & BM_SSI_SACNT_WR)

/*! @brief Set the WR field to a new value. */
#define BW_SSI_SACNT_WR(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_WR) | BF_SSI_SACNT_WR(v)))
/*@}*/

/*!
 * @name Register SSI_SACNT, field FRDIV[10:5] (RW)
 *
 * Frame Rate Divider. These bits control the frequency of AC97 data
 * transmission/reception. They are programmed with the number of frames for which the SSI
 * should be idle, after operating in one frame. Through these bits, AC97
 * frequency of operation, from 48 KHz (000000) to 1 KHz (101111) can be achieved. Sample
 * Value: 001010 (10 Decimal) = SSI will operate once every 11 frames.
 */
/*@{*/
#define BP_SSI_SACNT_FRDIV   (5U)          /*!< Bit position for SSI_SACNT_FRDIV. */
#define BM_SSI_SACNT_FRDIV   (0x000007E0U) /*!< Bit mask for SSI_SACNT_FRDIV. */
#define BS_SSI_SACNT_FRDIV   (6U)          /*!< Bit field size in bits for SSI_SACNT_FRDIV. */

/*! @brief Read current value of the SSI_SACNT_FRDIV field. */
#define BR_SSI_SACNT_FRDIV(x) (HW_SSI_SACNT(x).B.FRDIV)

/*! @brief Format value for bitfield SSI_SACNT_FRDIV. */
#define BF_SSI_SACNT_FRDIV(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACNT_FRDIV) & BM_SSI_SACNT_FRDIV)

/*! @brief Set the FRDIV field to a new value. */
#define BW_SSI_SACNT_FRDIV(x, v) (HW_SSI_SACNT_WR(x, (HW_SSI_SACNT_RD(x) & ~BM_SSI_SACNT_FRDIV) | BF_SSI_SACNT_FRDIV(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SACADD - SSI AC97 Command Address Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACADD - SSI AC97 Command Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_sacadd
{
    uint32_t U;
    struct _hw_ssi_sacadd_bitfields
    {
        uint32_t SACADD : 19;          /*!< [18:0]  */
        uint32_t RESERVED0 : 13;       /*!< [31:19]  */
    } B;
} hw_ssi_sacadd_t;

/*!
 * @name Constants and macros for entire SSI_SACADD register
 */
/*@{*/
#define HW_SSI_SACADD_ADDR(x)    ((uintptr_t)(x) + 0x3CU)

#define HW_SSI_SACADD(x)         (*(__IO hw_ssi_sacadd_t *) HW_SSI_SACADD_ADDR(x))
#define HW_SSI_SACADD_RD(x)      (HW_SSI_SACADD(x).U)
#define HW_SSI_SACADD_WR(x, v)   (HW_SSI_SACADD(x).U = (v))
#define HW_SSI_SACADD_SET(x, v)  (HW_SSI_SACADD_WR(x, HW_SSI_SACADD_RD(x) |  (v)))
#define HW_SSI_SACADD_CLR(x, v)  (HW_SSI_SACADD_WR(x, HW_SSI_SACADD_RD(x) & ~(v)))
#define HW_SSI_SACADD_TOG(x, v)  (HW_SSI_SACADD_WR(x, HW_SSI_SACADD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SACADD bitfields
 */

/*!
 * @name Register SSI_SACADD, field SACADD[18:0] (RW)
 *
 * AC97 Command Address. These bits store the Command Address Slot information
 * (bit 19 of the slot is sent in accordance with the Read and Write Command bits
 * in SSI_SACNT register). These bits can be updated by a direct write from the
 * Core. They are also updated with the information received in the incoming
 * Command Address Slot. If the contents of these bits change due to an update, the
 * CMDAU bit in SISR is set.
 */
/*@{*/
#define BP_SSI_SACADD_SACADD (0U)          /*!< Bit position for SSI_SACADD_SACADD. */
#define BM_SSI_SACADD_SACADD (0x0007FFFFU) /*!< Bit mask for SSI_SACADD_SACADD. */
#define BS_SSI_SACADD_SACADD (19U)         /*!< Bit field size in bits for SSI_SACADD_SACADD. */

/*! @brief Read current value of the SSI_SACADD_SACADD field. */
#define BR_SSI_SACADD_SACADD(x) (HW_SSI_SACADD(x).B.SACADD)

/*! @brief Format value for bitfield SSI_SACADD_SACADD. */
#define BF_SSI_SACADD_SACADD(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACADD_SACADD) & BM_SSI_SACADD_SACADD)

/*! @brief Set the SACADD field to a new value. */
#define BW_SSI_SACADD_SACADD(x, v) (HW_SSI_SACADD_WR(x, (HW_SSI_SACADD_RD(x) & ~BM_SSI_SACADD_SACADD) | BF_SSI_SACADD_SACADD(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SACDAT - SSI AC97 Command Data Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACDAT - SSI AC97 Command Data Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_sacdat
{
    uint32_t U;
    struct _hw_ssi_sacdat_bitfields
    {
        uint32_t SACDAT : 20;          /*!< [19:0]  */
        uint32_t RESERVED0 : 12;       /*!< [31:20]  */
    } B;
} hw_ssi_sacdat_t;

/*!
 * @name Constants and macros for entire SSI_SACDAT register
 */
/*@{*/
#define HW_SSI_SACDAT_ADDR(x)    ((uintptr_t)(x) + 0x40U)

#define HW_SSI_SACDAT(x)         (*(__IO hw_ssi_sacdat_t *) HW_SSI_SACDAT_ADDR(x))
#define HW_SSI_SACDAT_RD(x)      (HW_SSI_SACDAT(x).U)
#define HW_SSI_SACDAT_WR(x, v)   (HW_SSI_SACDAT(x).U = (v))
#define HW_SSI_SACDAT_SET(x, v)  (HW_SSI_SACDAT_WR(x, HW_SSI_SACDAT_RD(x) |  (v)))
#define HW_SSI_SACDAT_CLR(x, v)  (HW_SSI_SACDAT_WR(x, HW_SSI_SACDAT_RD(x) & ~(v)))
#define HW_SSI_SACDAT_TOG(x, v)  (HW_SSI_SACDAT_WR(x, HW_SSI_SACDAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SACDAT bitfields
 */

/*!
 * @name Register SSI_SACDAT, field SACDAT[19:0] (RW)
 *
 * AC97 Command Data. The outgoing Command Data Slot carries the information
 * contained in these bits. These bits can be updated by a direct write from the
 * Core. They are also updated with the information received in the incoming Command
 * Data Slot. If the contents of these bits change due to an update, the CMDDU
 * bit in SISR is set. These bits are transmitted only during AC97 Write Command.
 * During AC97 Read Command, 0x00000 is transmitted in time slot #2.
 */
/*@{*/
#define BP_SSI_SACDAT_SACDAT (0U)          /*!< Bit position for SSI_SACDAT_SACDAT. */
#define BM_SSI_SACDAT_SACDAT (0x000FFFFFU) /*!< Bit mask for SSI_SACDAT_SACDAT. */
#define BS_SSI_SACDAT_SACDAT (20U)         /*!< Bit field size in bits for SSI_SACDAT_SACDAT. */

/*! @brief Read current value of the SSI_SACDAT_SACDAT field. */
#define BR_SSI_SACDAT_SACDAT(x) (HW_SSI_SACDAT(x).B.SACDAT)

/*! @brief Format value for bitfield SSI_SACDAT_SACDAT. */
#define BF_SSI_SACDAT_SACDAT(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACDAT_SACDAT) & BM_SSI_SACDAT_SACDAT)

/*! @brief Set the SACDAT field to a new value. */
#define BW_SSI_SACDAT_SACDAT(x, v) (HW_SSI_SACDAT_WR(x, (HW_SSI_SACDAT_RD(x) & ~BM_SSI_SACDAT_SACDAT) | BF_SSI_SACDAT_SACDAT(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_SATAG - SSI AC97 Tag Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SATAG - SSI AC97 Tag Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_satag
{
    uint32_t U;
    struct _hw_ssi_satag_bitfields
    {
        uint32_t SATAG : 16;           /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_ssi_satag_t;

/*!
 * @name Constants and macros for entire SSI_SATAG register
 */
/*@{*/
#define HW_SSI_SATAG_ADDR(x)     ((uintptr_t)(x) + 0x44U)

#define HW_SSI_SATAG(x)          (*(__IO hw_ssi_satag_t *) HW_SSI_SATAG_ADDR(x))
#define HW_SSI_SATAG_RD(x)       (HW_SSI_SATAG(x).U)
#define HW_SSI_SATAG_WR(x, v)    (HW_SSI_SATAG(x).U = (v))
#define HW_SSI_SATAG_SET(x, v)   (HW_SSI_SATAG_WR(x, HW_SSI_SATAG_RD(x) |  (v)))
#define HW_SSI_SATAG_CLR(x, v)   (HW_SSI_SATAG_WR(x, HW_SSI_SATAG_RD(x) & ~(v)))
#define HW_SSI_SATAG_TOG(x, v)   (HW_SSI_SATAG_WR(x, HW_SSI_SATAG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SATAG bitfields
 */

/*!
 * @name Register SSI_SATAG, field SATAG[15:0] (RW)
 *
 * AC97 Tag Value. Writing to this register (by the Core) sets the value of the
 * Tx-Tag in AC97 fixed mode of operation. On a read, the Core gets the Rx-Tag
 * Value received (in the last frame) from the Codec. If TIF bit in SSI_SACNT
 * register is set, the TAG value is also stored in Rx-FIFO in addition to SATAG
 * register. When the received Tag value changes, the RXT bit in SISR register is set.
 * Bits SATAG[1:0] convey the Codec -ID. In current implementation only Primary
 * Codecs are supported. Thus writing value 2'b00 to this field is mandatory.
 */
/*@{*/
#define BP_SSI_SATAG_SATAG   (0U)          /*!< Bit position for SSI_SATAG_SATAG. */
#define BM_SSI_SATAG_SATAG   (0x0000FFFFU) /*!< Bit mask for SSI_SATAG_SATAG. */
#define BS_SSI_SATAG_SATAG   (16U)         /*!< Bit field size in bits for SSI_SATAG_SATAG. */

/*! @brief Read current value of the SSI_SATAG_SATAG field. */
#define BR_SSI_SATAG_SATAG(x) (HW_SSI_SATAG(x).B.SATAG)

/*! @brief Format value for bitfield SSI_SATAG_SATAG. */
#define BF_SSI_SATAG_SATAG(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SATAG_SATAG) & BM_SSI_SATAG_SATAG)

/*! @brief Set the SATAG field to a new value. */
#define BW_SSI_SATAG_SATAG(x, v) (HW_SSI_SATAG_WR(x, (HW_SSI_SATAG_RD(x) & ~BM_SSI_SATAG_SATAG) | BF_SSI_SATAG_SATAG(v)))
/*@}*/

/*******************************************************************************
 * HW_SSI_STMSK - SSI Transmit Time Slot Mask Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_STMSK - SSI Transmit Time Slot Mask Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_stmsk
{
    uint32_t U;
    struct _hw_ssi_stmsk_bitfields
    {
        uint32_t STMSK : 32;           /*!< [31:0]  */
    } B;
} hw_ssi_stmsk_t;

/*!
 * @name Constants and macros for entire SSI_STMSK register
 */
/*@{*/
#define HW_SSI_STMSK_ADDR(x)     ((uintptr_t)(x) + 0x48U)

#define HW_SSI_STMSK(x)          (*(__IO hw_ssi_stmsk_t *) HW_SSI_STMSK_ADDR(x))
#define HW_SSI_STMSK_RD(x)       (HW_SSI_STMSK(x).U)
#define HW_SSI_STMSK_WR(x, v)    (HW_SSI_STMSK(x).U = (v))
#define HW_SSI_STMSK_SET(x, v)   (HW_SSI_STMSK_WR(x, HW_SSI_STMSK_RD(x) |  (v)))
#define HW_SSI_STMSK_CLR(x, v)   (HW_SSI_STMSK_WR(x, HW_SSI_STMSK_RD(x) & ~(v)))
#define HW_SSI_STMSK_TOG(x, v)   (HW_SSI_STMSK_WR(x, HW_SSI_STMSK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_STMSK bitfields
 */

/*!
 * @name Register SSI_STMSK, field STMSK[31:0] (RW)
 *
 * Transmit Mask. These bits indicate which slot has been masked in the current
 * frame. The Core can write to this register to control the time slots in which
 * the SSI transmits data. Each bit has info corresponding to the respective time
 * slot in the frame. Transmit mask bits should not be used in I2S Slave mode of
 * operation. SSI_STMSK register value must be set before enabling Transmission.
 *
 * Values:
 * - 0 - Valid Time Slot.
 * - 1 - Time Slot masked (no data transmitted in this time slot).
 */
/*@{*/
#define BP_SSI_STMSK_STMSK   (0U)          /*!< Bit position for SSI_STMSK_STMSK. */
#define BM_SSI_STMSK_STMSK   (0xFFFFFFFFU) /*!< Bit mask for SSI_STMSK_STMSK. */
#define BS_SSI_STMSK_STMSK   (32U)         /*!< Bit field size in bits for SSI_STMSK_STMSK. */

/*! @brief Read current value of the SSI_STMSK_STMSK field. */
#define BR_SSI_STMSK_STMSK(x) (HW_SSI_STMSK(x).U)

/*! @brief Format value for bitfield SSI_STMSK_STMSK. */
#define BF_SSI_STMSK_STMSK(v) ((uint32_t)((uint32_t)(v) << BP_SSI_STMSK_STMSK) & BM_SSI_STMSK_STMSK)

/*! @brief Set the STMSK field to a new value. */
#define BW_SSI_STMSK_STMSK(x, v) (HW_SSI_STMSK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SSI_SRMSK - SSI Receive Time Slot Mask Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SRMSK - SSI Receive Time Slot Mask Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_srmsk
{
    uint32_t U;
    struct _hw_ssi_srmsk_bitfields
    {
        uint32_t SRMSK : 32;           /*!< [31:0]  */
    } B;
} hw_ssi_srmsk_t;

/*!
 * @name Constants and macros for entire SSI_SRMSK register
 */
/*@{*/
#define HW_SSI_SRMSK_ADDR(x)     ((uintptr_t)(x) + 0x4CU)

#define HW_SSI_SRMSK(x)          (*(__IO hw_ssi_srmsk_t *) HW_SSI_SRMSK_ADDR(x))
#define HW_SSI_SRMSK_RD(x)       (HW_SSI_SRMSK(x).U)
#define HW_SSI_SRMSK_WR(x, v)    (HW_SSI_SRMSK(x).U = (v))
#define HW_SSI_SRMSK_SET(x, v)   (HW_SSI_SRMSK_WR(x, HW_SSI_SRMSK_RD(x) |  (v)))
#define HW_SSI_SRMSK_CLR(x, v)   (HW_SSI_SRMSK_WR(x, HW_SSI_SRMSK_RD(x) & ~(v)))
#define HW_SSI_SRMSK_TOG(x, v)   (HW_SSI_SRMSK_WR(x, HW_SSI_SRMSK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SRMSK bitfields
 */

/*!
 * @name Register SSI_SRMSK, field SRMSK[31:0] (RW)
 *
 * Receive Mask. These bits indicate which slot has been masked in the current
 * frame. The Core can write to this register to control the time slots in which
 * the SSI receives data. Each bit has info corresponding to the respective time
 * slot in the frame. SSI_SRMSK register value must be set before enabling
 * Receiver. Receive mask bits should not be used in I2S Slave mode of operation.
 *
 * Values:
 * - 0 - Valid Time Slot.
 * - 1 - Time Slot masked (no data received in this time slot).
 */
/*@{*/
#define BP_SSI_SRMSK_SRMSK   (0U)          /*!< Bit position for SSI_SRMSK_SRMSK. */
#define BM_SSI_SRMSK_SRMSK   (0xFFFFFFFFU) /*!< Bit mask for SSI_SRMSK_SRMSK. */
#define BS_SSI_SRMSK_SRMSK   (32U)         /*!< Bit field size in bits for SSI_SRMSK_SRMSK. */

/*! @brief Read current value of the SSI_SRMSK_SRMSK field. */
#define BR_SSI_SRMSK_SRMSK(x) (HW_SSI_SRMSK(x).U)

/*! @brief Format value for bitfield SSI_SRMSK_SRMSK. */
#define BF_SSI_SRMSK_SRMSK(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SRMSK_SRMSK) & BM_SSI_SRMSK_SRMSK)

/*! @brief Set the SRMSK field to a new value. */
#define BW_SSI_SRMSK_SRMSK(x, v) (HW_SSI_SRMSK_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_SSI_SACCST - SSI AC97 Channel Status Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACCST - SSI AC97 Channel Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_saccst
{
    uint32_t U;
    struct _hw_ssi_saccst_bitfields
    {
        uint32_t SACCST : 10;          /*!< [9:0]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ssi_saccst_t;

/*!
 * @name Constants and macros for entire SSI_SACCST register
 */
/*@{*/
#define HW_SSI_SACCST_ADDR(x)    ((uintptr_t)(x) + 0x50U)

#define HW_SSI_SACCST(x)         (*(__I hw_ssi_saccst_t *) HW_SSI_SACCST_ADDR(x))
#define HW_SSI_SACCST_RD(x)      (HW_SSI_SACCST(x).U)
/*@}*/

/*
 * Constants & macros for individual SSI_SACCST bitfields
 */

/*!
 * @name Register SSI_SACCST, field SACCST[9:0] (RO)
 *
 * AC97 Channel Status. These bits indicate which data slot has been enabled in
 * AC97 variable mode operation. This register is updated in case the core
 * enables/disables a channel through a write to SSI_SACCEN/SSI_SACCDIS register or the
 * external codec enables a channel by sending a '1' in the corresponding
 * SLOTREQ bit. Bit [0] corresponds to the first data slot in an AC97 frame (Slot #3)
 * and Bit [9] corresponds to the tenth data slot (slot #12). The contents of this
 * register only have relevance while the SSI is operating in AC97 variable
 * mode. Writes to this register result in an error response on the block interface.
 *
 * Values:
 * - 0 - Data channel disabled.
 * - 1 - Data channel enabled.
 */
/*@{*/
#define BP_SSI_SACCST_SACCST (0U)          /*!< Bit position for SSI_SACCST_SACCST. */
#define BM_SSI_SACCST_SACCST (0x000003FFU) /*!< Bit mask for SSI_SACCST_SACCST. */
#define BS_SSI_SACCST_SACCST (10U)         /*!< Bit field size in bits for SSI_SACCST_SACCST. */

/*! @brief Read current value of the SSI_SACCST_SACCST field. */
#define BR_SSI_SACCST_SACCST(x) (HW_SSI_SACCST(x).B.SACCST)
/*@}*/

/*******************************************************************************
 * HW_SSI_SACCEN - SSI AC97 Channel Enable Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACCEN - SSI AC97 Channel Enable Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_saccen
{
    uint32_t U;
    struct _hw_ssi_saccen_bitfields
    {
        uint32_t SACCEN : 10;          /*!< [9:0]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ssi_saccen_t;

/*!
 * @name Constants and macros for entire SSI_SACCEN register
 */
/*@{*/
#define HW_SSI_SACCEN_ADDR(x)    ((uintptr_t)(x) + 0x54U)

#define HW_SSI_SACCEN(x)         (*(__IO hw_ssi_saccen_t *) HW_SSI_SACCEN_ADDR(x))
#define HW_SSI_SACCEN_RD(x)      (HW_SSI_SACCEN(x).U)
#define HW_SSI_SACCEN_WR(x, v)   (HW_SSI_SACCEN(x).U = (v))
#define HW_SSI_SACCEN_SET(x, v)  (HW_SSI_SACCEN_WR(x, HW_SSI_SACCEN_RD(x) |  (v)))
#define HW_SSI_SACCEN_CLR(x, v)  (HW_SSI_SACCEN_WR(x, HW_SSI_SACCEN_RD(x) & ~(v)))
#define HW_SSI_SACCEN_TOG(x, v)  (HW_SSI_SACCEN_WR(x, HW_SSI_SACCEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SACCEN bitfields
 */

/*!
 * @name Register SSI_SACCEN, field SACCEN[9:0] (WO)
 *
 * AC97 Channel Enable. The Core writes a '1' to these bits to enable an AC97
 * data channel. Writing a '0' has no effect. Bit [0] corresponds to the first data
 * slot in an AC97 frame (Slot #3) and Bit [9] corresponds to the tenth data
 * slot (slot #12). Writes to these bits only have effect in the AC97 Variable mode
 * of operation. These bits are always read as '0' by the Core.
 *
 * Values:
 * - 0 - Write Has no effect.
 * - 1 - Write Enables the corresponding data channel.
 */
/*@{*/
#define BP_SSI_SACCEN_SACCEN (0U)          /*!< Bit position for SSI_SACCEN_SACCEN. */
#define BM_SSI_SACCEN_SACCEN (0x000003FFU) /*!< Bit mask for SSI_SACCEN_SACCEN. */
#define BS_SSI_SACCEN_SACCEN (10U)         /*!< Bit field size in bits for SSI_SACCEN_SACCEN. */

/*! @brief Format value for bitfield SSI_SACCEN_SACCEN. */
#define BF_SSI_SACCEN_SACCEN(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACCEN_SACCEN) & BM_SSI_SACCEN_SACCEN)
/*@}*/

/*******************************************************************************
 * HW_SSI_SACCDIS - SSI AC97 Channel Disable Register
 ******************************************************************************/

/*!
 * @brief HW_SSI_SACCDIS - SSI AC97 Channel Disable Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_ssi_saccdis
{
    uint32_t U;
    struct _hw_ssi_saccdis_bitfields
    {
        uint32_t SACCDIS : 10;         /*!< [9:0]  */
        uint32_t RESERVED0 : 22;       /*!< [31:10]  */
    } B;
} hw_ssi_saccdis_t;

/*!
 * @name Constants and macros for entire SSI_SACCDIS register
 */
/*@{*/
#define HW_SSI_SACCDIS_ADDR(x)   ((uintptr_t)(x) + 0x58U)

#define HW_SSI_SACCDIS(x)        (*(__IO hw_ssi_saccdis_t *) HW_SSI_SACCDIS_ADDR(x))
#define HW_SSI_SACCDIS_RD(x)     (HW_SSI_SACCDIS(x).U)
#define HW_SSI_SACCDIS_WR(x, v)  (HW_SSI_SACCDIS(x).U = (v))
#define HW_SSI_SACCDIS_SET(x, v) (HW_SSI_SACCDIS_WR(x, HW_SSI_SACCDIS_RD(x) |  (v)))
#define HW_SSI_SACCDIS_CLR(x, v) (HW_SSI_SACCDIS_WR(x, HW_SSI_SACCDIS_RD(x) & ~(v)))
#define HW_SSI_SACCDIS_TOG(x, v) (HW_SSI_SACCDIS_WR(x, HW_SSI_SACCDIS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SSI_SACCDIS bitfields
 */

/*!
 * @name Register SSI_SACCDIS, field SACCDIS[9:0] (WO)
 *
 * AC97 Channel Disable. The Core writes a '1' to these bits to disable an AC97
 * data channel. Writing a '0' has no effect. Bit [0] corresponds to the first
 * data slot in an AC97 frame (Slot #3) and Bit [9] corresponds to the tenth data
 * slot (slot #12). Writes to these bits only have effect in the AC97 Variable
 * mode of operation. These bits are always read as '0' by the Core.
 *
 * Values:
 * - 0 - Write Has no effect.
 * - 1 - Write Disables the corresponding data channel.
 */
/*@{*/
#define BP_SSI_SACCDIS_SACCDIS (0U)        /*!< Bit position for SSI_SACCDIS_SACCDIS. */
#define BM_SSI_SACCDIS_SACCDIS (0x000003FFU) /*!< Bit mask for SSI_SACCDIS_SACCDIS. */
#define BS_SSI_SACCDIS_SACCDIS (10U)       /*!< Bit field size in bits for SSI_SACCDIS_SACCDIS. */

/*! @brief Format value for bitfield SSI_SACCDIS_SACCDIS. */
#define BF_SSI_SACCDIS_SACCDIS(v) ((uint32_t)((uint32_t)(v) << BP_SSI_SACCDIS_SACCDIS) & BM_SSI_SACCDIS_SACCDIS)
/*@}*/

/*******************************************************************************
 * hw_ssi_t - module struct
 ******************************************************************************/
/*!
 * @brief All SSI module registers.
 */
#pragma pack(1)
typedef struct _hw_ssi
{
    __IO hw_ssi_stxn_t STXn[2];            /*!< [0x0] SSI Transmit Data Register n */
    __I hw_ssi_srxn_t SRXn[2];             /*!< [0x8] SSI Receive Data Register n */
    __IO hw_ssi_scr_t SCR;                 /*!< [0x10] SSI Control Register */
    __IO hw_ssi_sisr_t SISR;               /*!< [0x14] SSI Interrupt Status Register */
    __IO hw_ssi_sier_t SIER;               /*!< [0x18] SSI Interrupt Enable Register */
    __IO hw_ssi_stcr_t STCR;               /*!< [0x1C] SSI Transmit Configuration Register */
    __IO hw_ssi_srcr_t SRCR;               /*!< [0x20] SSI Receive Configuration Register */
    __IO hw_ssi_stccr_t STCCR;             /*!< [0x24] SSI Transmit Clock Control Register */
    __IO hw_ssi_srccr_t SRCCR;             /*!< [0x28] SSI Receive Clock Control Register */
    __IO hw_ssi_sfcsr_t SFCSR;             /*!< [0x2C] SSI FIFO Control/Status Register */
    uint8_t _reserved0[8];
    __IO hw_ssi_sacnt_t SACNT;             /*!< [0x38] SSI AC97 Control Register */
    __IO hw_ssi_sacadd_t SACADD;           /*!< [0x3C] SSI AC97 Command Address Register */
    __IO hw_ssi_sacdat_t SACDAT;           /*!< [0x40] SSI AC97 Command Data Register */
    __IO hw_ssi_satag_t SATAG;             /*!< [0x44] SSI AC97 Tag Register */
    __IO hw_ssi_stmsk_t STMSK;             /*!< [0x48] SSI Transmit Time Slot Mask Register */
    __IO hw_ssi_srmsk_t SRMSK;             /*!< [0x4C] SSI Receive Time Slot Mask Register */
    __I hw_ssi_saccst_t SACCST;            /*!< [0x50] SSI AC97 Channel Status Register */
    __IO hw_ssi_saccen_t SACCEN;           /*!< [0x54] SSI AC97 Channel Enable Register */
    __IO hw_ssi_saccdis_t SACCDIS;         /*!< [0x58] SSI AC97 Channel Disable Register */
} hw_ssi_t;
#pragma pack()

/*! @brief Macro to access all SSI registers. */
/*! @param x SSI module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SSI_REGS(SSI1_BASE)</code>. */
#define HW_SSI_REGS(x) (*(hw_ssi_t *)(x))

/*
 * iMX6DP TEMPMON
 *
 * Temperature Monitor
 *
 * Registers defined in this header file:
 * - HW_TEMPMON_TEMPSENSE0 - Tempsensor Control Register 0
 * - HW_TEMPMON_TEMPSENSE1 - Tempsensor Control Register 1
 *
 * - hw_tempmon_t - Struct containing all module registers.
 */

#define HW_TEMPMON_INSTANCE_COUNT (1U) /*!< Number of instances of the TEMPMON module. */
#define HW_TEMPMON (0U) /*!< Instance number for TEMPMON. */
#define TEMPMON_BASE          (0x20C8000U) /*!< Base address for TEMPMON. */
/*! Array initializer of TEMPMON base addresses. */
#define TEMPMON_BASE_ADDRS    { TEMPMON_BASE }

/*******************************************************************************
 * HW_TEMPMON_TEMPSENSE0 - Tempsensor Control Register 0
 ******************************************************************************/

/*!
 * @brief HW_TEMPMON_TEMPSENSE0 - Tempsensor Control Register 0 (RW)
 *
 * Reset value: 0x00000001U
 *
 * This register defines the basic controls for the temperature sensor minus the
 * frequency of automatic sampling which is defined in the tempsensor.
 */
typedef union _hw_tempmon_tempsense0
{
    uint32_t U;
    struct _hw_tempmon_tempsense0_bitfields
    {
        uint32_t POWER_DOWN : 1;       /*!< [0]  */
        uint32_t MEASURE_TEMP : 1;     /*!< [1]  */
        uint32_t FINISHED : 1;         /*!< [2]  */
        uint32_t RESERVED0 : 5;        /*!< [7:3]  */
        uint32_t TEMP_CNT : 12;        /*!< [19:8]  */
        uint32_t ALARM_VALUE : 12;     /*!< [31:20]  */
    } B;
} hw_tempmon_tempsense0_t;

/*!
 * @name Constants and macros for entire TEMPMON_TEMPSENSE0 register
 */
/*@{*/
#define HW_TEMPMON_TEMPSENSE0_ADDR(x) ((uintptr_t)(x) + 0x180U)
#define HW_TEMPMON_TEMPSENSE0_SET_ADDR(x) (HW_TEMPMON_TEMPSENSE0_ADDR(x) + 0x4U)
#define HW_TEMPMON_TEMPSENSE0_CLR_ADDR(x) (HW_TEMPMON_TEMPSENSE0_ADDR(x) + 0x8U)
#define HW_TEMPMON_TEMPSENSE0_TOG_ADDR(x) (HW_TEMPMON_TEMPSENSE0_ADDR(x) + 0xCU)

#define HW_TEMPMON_TEMPSENSE0(x) (*(__IO hw_tempmon_tempsense0_t *) HW_TEMPMON_TEMPSENSE0_ADDR(x))
#define HW_TEMPMON_TEMPSENSE0_RD(x) (HW_TEMPMON_TEMPSENSE0(x).U)
#define HW_TEMPMON_TEMPSENSE0_WR(x, v) (HW_TEMPMON_TEMPSENSE0(x).U = (v))
#define HW_TEMPMON_TEMPSENSE0_SET(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE0_SET_ADDR(x)) = (v))
#define HW_TEMPMON_TEMPSENSE0_CLR(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE0_CLR_ADDR(x)) = (v))
#define HW_TEMPMON_TEMPSENSE0_TOG(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE0_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual TEMPMON_TEMPSENSE0 bitfields
 */

/*!
 * @name Register TEMPMON_TEMPSENSE0, field POWER_DOWN[0] (RW)
 *
 * This bit powers down the temperature sensor.
 *
 * Values:
 * - 0 - Enable power to the temperature sensor.
 * - 1 - Power down the temperature sensor.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE0_POWER_DOWN (0U) /*!< Bit position for TEMPMON_TEMPSENSE0_POWER_DOWN. */
#define BM_TEMPMON_TEMPSENSE0_POWER_DOWN (0x00000001U) /*!< Bit mask for TEMPMON_TEMPSENSE0_POWER_DOWN. */
#define BS_TEMPMON_TEMPSENSE0_POWER_DOWN (1U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE0_POWER_DOWN. */

#define BV_TEMPMON_TEMPSENSE0_POWER_DOWN_POWER_UP (0U) /*!< Bit field value for TEMPMON_TEMPSENSE0_POWER_DOWN: Enable power to the temperature sensor. */
#define BV_TEMPMON_TEMPSENSE0_POWER_DOWN_POWER_DOWN (0x1U) /*!< Bit field value for TEMPMON_TEMPSENSE0_POWER_DOWN: Power down the temperature sensor. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE0_POWER_DOWN field. */
#define BR_TEMPMON_TEMPSENSE0_POWER_DOWN(x) (HW_TEMPMON_TEMPSENSE0(x).B.POWER_DOWN)

/*! @brief Format value for bitfield TEMPMON_TEMPSENSE0_POWER_DOWN. */
#define BF_TEMPMON_TEMPSENSE0_POWER_DOWN(v) ((uint32_t)((uint32_t)(v) << BP_TEMPMON_TEMPSENSE0_POWER_DOWN) & BM_TEMPMON_TEMPSENSE0_POWER_DOWN)

/*! @brief Set the POWER_DOWN field to a new value. */
#define BW_TEMPMON_TEMPSENSE0_POWER_DOWN(x, v) (HW_TEMPMON_TEMPSENSE0_WR(x, (HW_TEMPMON_TEMPSENSE0_RD(x) & ~BM_TEMPMON_TEMPSENSE0_POWER_DOWN) | BF_TEMPMON_TEMPSENSE0_POWER_DOWN(v)))
/*@}*/

/*!
 * @name Register TEMPMON_TEMPSENSE0, field MEASURE_TEMP[1] (RW)
 *
 * Starts the measurement process. If the measurement frequency is zero in the
 * TEMPSENSE1 register, this results in a single conversion.
 *
 * Values:
 * - 0 - Do not start the measurement process.
 * - 1 - Start the measurement process.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE0_MEASURE_TEMP (1U) /*!< Bit position for TEMPMON_TEMPSENSE0_MEASURE_TEMP. */
#define BM_TEMPMON_TEMPSENSE0_MEASURE_TEMP (0x00000002U) /*!< Bit mask for TEMPMON_TEMPSENSE0_MEASURE_TEMP. */
#define BS_TEMPMON_TEMPSENSE0_MEASURE_TEMP (1U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE0_MEASURE_TEMP. */

#define BV_TEMPMON_TEMPSENSE0_MEASURE_TEMP_STOP (0U) /*!< Bit field value for TEMPMON_TEMPSENSE0_MEASURE_TEMP: Do not start the measurement process. */
#define BV_TEMPMON_TEMPSENSE0_MEASURE_TEMP_START (0x1U) /*!< Bit field value for TEMPMON_TEMPSENSE0_MEASURE_TEMP: Start the measurement process. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE0_MEASURE_TEMP field. */
#define BR_TEMPMON_TEMPSENSE0_MEASURE_TEMP(x) (HW_TEMPMON_TEMPSENSE0(x).B.MEASURE_TEMP)

/*! @brief Format value for bitfield TEMPMON_TEMPSENSE0_MEASURE_TEMP. */
#define BF_TEMPMON_TEMPSENSE0_MEASURE_TEMP(v) ((uint32_t)((uint32_t)(v) << BP_TEMPMON_TEMPSENSE0_MEASURE_TEMP) & BM_TEMPMON_TEMPSENSE0_MEASURE_TEMP)

/*! @brief Set the MEASURE_TEMP field to a new value. */
#define BW_TEMPMON_TEMPSENSE0_MEASURE_TEMP(x, v) (HW_TEMPMON_TEMPSENSE0_WR(x, (HW_TEMPMON_TEMPSENSE0_RD(x) & ~BM_TEMPMON_TEMPSENSE0_MEASURE_TEMP) | BF_TEMPMON_TEMPSENSE0_MEASURE_TEMP(v)))
/*@}*/

/*!
 * @name Register TEMPMON_TEMPSENSE0, field FINISHED[2] (RO)
 *
 * Indicates that the latest temp is valid. This bit should be cleared by the
 * sensor after the start of each measurement.
 *
 * Values:
 * - 0 - Last measurement is not ready yet.
 * - 1 - Last measurement is valid.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE0_FINISHED (2U) /*!< Bit position for TEMPMON_TEMPSENSE0_FINISHED. */
#define BM_TEMPMON_TEMPSENSE0_FINISHED (0x00000004U) /*!< Bit mask for TEMPMON_TEMPSENSE0_FINISHED. */
#define BS_TEMPMON_TEMPSENSE0_FINISHED (1U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE0_FINISHED. */

#define BV_TEMPMON_TEMPSENSE0_FINISHED_INVALID (0U)  /*!< Bit field value for TEMPMON_TEMPSENSE0_FINISHED: Last measurement is not ready yet. */
#define BV_TEMPMON_TEMPSENSE0_FINISHED_VALID (0x1U)  /*!< Bit field value for TEMPMON_TEMPSENSE0_FINISHED: Last measurement is valid. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE0_FINISHED field. */
#define BR_TEMPMON_TEMPSENSE0_FINISHED(x) (HW_TEMPMON_TEMPSENSE0(x).B.FINISHED)
/*@}*/

/*!
 * @name Register TEMPMON_TEMPSENSE0, field TEMP_CNT[19:8] (RO)
 *
 * This bit field contains the last measured temperature count.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE0_TEMP_CNT (8U) /*!< Bit position for TEMPMON_TEMPSENSE0_TEMP_CNT. */
#define BM_TEMPMON_TEMPSENSE0_TEMP_CNT (0x000FFF00U) /*!< Bit mask for TEMPMON_TEMPSENSE0_TEMP_CNT. */
#define BS_TEMPMON_TEMPSENSE0_TEMP_CNT (12U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE0_TEMP_CNT. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE0_TEMP_CNT field. */
#define BR_TEMPMON_TEMPSENSE0_TEMP_CNT(x) (HW_TEMPMON_TEMPSENSE0(x).B.TEMP_CNT)
/*@}*/

/*!
 * @name Register TEMPMON_TEMPSENSE0, field ALARM_VALUE[31:20] (RW)
 *
 * This bit field contains the temperature count (raw sensor output) that will
 * generate an alarm interrupt.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE0_ALARM_VALUE (20U) /*!< Bit position for TEMPMON_TEMPSENSE0_ALARM_VALUE. */
#define BM_TEMPMON_TEMPSENSE0_ALARM_VALUE (0xFFF00000U) /*!< Bit mask for TEMPMON_TEMPSENSE0_ALARM_VALUE. */
#define BS_TEMPMON_TEMPSENSE0_ALARM_VALUE (12U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE0_ALARM_VALUE. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE0_ALARM_VALUE field. */
#define BR_TEMPMON_TEMPSENSE0_ALARM_VALUE(x) (HW_TEMPMON_TEMPSENSE0(x).B.ALARM_VALUE)

/*! @brief Format value for bitfield TEMPMON_TEMPSENSE0_ALARM_VALUE. */
#define BF_TEMPMON_TEMPSENSE0_ALARM_VALUE(v) ((uint32_t)((uint32_t)(v) << BP_TEMPMON_TEMPSENSE0_ALARM_VALUE) & BM_TEMPMON_TEMPSENSE0_ALARM_VALUE)

/*! @brief Set the ALARM_VALUE field to a new value. */
#define BW_TEMPMON_TEMPSENSE0_ALARM_VALUE(x, v) (HW_TEMPMON_TEMPSENSE0_WR(x, (HW_TEMPMON_TEMPSENSE0_RD(x) & ~BM_TEMPMON_TEMPSENSE0_ALARM_VALUE) | BF_TEMPMON_TEMPSENSE0_ALARM_VALUE(v)))
/*@}*/




/*******************************************************************************
 * HW_TEMPMON_TEMPSENSE1 - Tempsensor Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_TEMPMON_TEMPSENSE1 - Tempsensor Control Register 1 (RW)
 *
 * Reset value: 0x00000001U
 *
 * This register defines the automatic repeat time of the temperature sensor.
 */
typedef union _hw_tempmon_tempsense1
{
    uint32_t U;
    struct _hw_tempmon_tempsense1_bitfields
    {
        uint32_t MEASURE_FREQ : 16;    /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_tempmon_tempsense1_t;

/*!
 * @name Constants and macros for entire TEMPMON_TEMPSENSE1 register
 */
/*@{*/
#define HW_TEMPMON_TEMPSENSE1_ADDR(x) ((uintptr_t)(x) + 0x190U)
#define HW_TEMPMON_TEMPSENSE1_SET_ADDR(x) (HW_TEMPMON_TEMPSENSE1_ADDR(x) + 0x4U)
#define HW_TEMPMON_TEMPSENSE1_CLR_ADDR(x) (HW_TEMPMON_TEMPSENSE1_ADDR(x) + 0x8U)
#define HW_TEMPMON_TEMPSENSE1_TOG_ADDR(x) (HW_TEMPMON_TEMPSENSE1_ADDR(x) + 0xCU)

#define HW_TEMPMON_TEMPSENSE1(x) (*(__IO hw_tempmon_tempsense1_t *) HW_TEMPMON_TEMPSENSE1_ADDR(x))
#define HW_TEMPMON_TEMPSENSE1_RD(x) (HW_TEMPMON_TEMPSENSE1(x).U)
#define HW_TEMPMON_TEMPSENSE1_WR(x, v) (HW_TEMPMON_TEMPSENSE1(x).U = (v))
#define HW_TEMPMON_TEMPSENSE1_SET(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE1_SET_ADDR(x)) = (v))
#define HW_TEMPMON_TEMPSENSE1_CLR(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE1_CLR_ADDR(x)) = (v))
#define HW_TEMPMON_TEMPSENSE1_TOG(x, v) ((*(uint32_t *) HW_TEMPMON_TEMPSENSE1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual TEMPMON_TEMPSENSE1 bitfields
 */

/*!
 * @name Register TEMPMON_TEMPSENSE1, field MEASURE_FREQ[15:0] (RW)
 *
 * This bits determines how many RTC clocks to wait before automatically
 * repeating a temperature measurement. The pause time before remeasuring is the field
 * value multiplied by the RTC period.
 */
/*@{*/
#define BP_TEMPMON_TEMPSENSE1_MEASURE_FREQ (0U) /*!< Bit position for TEMPMON_TEMPSENSE1_MEASURE_FREQ. */
#define BM_TEMPMON_TEMPSENSE1_MEASURE_FREQ (0x0000FFFFU) /*!< Bit mask for TEMPMON_TEMPSENSE1_MEASURE_FREQ. */
#define BS_TEMPMON_TEMPSENSE1_MEASURE_FREQ (16U) /*!< Bit field size in bits for TEMPMON_TEMPSENSE1_MEASURE_FREQ. */

/*! @brief Read current value of the TEMPMON_TEMPSENSE1_MEASURE_FREQ field. */
#define BR_TEMPMON_TEMPSENSE1_MEASURE_FREQ(x) (HW_TEMPMON_TEMPSENSE1(x).B.MEASURE_FREQ)

/*! @brief Format value for bitfield TEMPMON_TEMPSENSE1_MEASURE_FREQ. */
#define BF_TEMPMON_TEMPSENSE1_MEASURE_FREQ(v) ((uint32_t)((uint32_t)(v) << BP_TEMPMON_TEMPSENSE1_MEASURE_FREQ) & BM_TEMPMON_TEMPSENSE1_MEASURE_FREQ)

/*! @brief Set the MEASURE_FREQ field to a new value. */
#define BW_TEMPMON_TEMPSENSE1_MEASURE_FREQ(x, v) (HW_TEMPMON_TEMPSENSE1_WR(x, (HW_TEMPMON_TEMPSENSE1_RD(x) & ~BM_TEMPMON_TEMPSENSE1_MEASURE_FREQ) | BF_TEMPMON_TEMPSENSE1_MEASURE_FREQ(v)))
/*@}*/




/*******************************************************************************
 * hw_tempmon_t - module struct
 ******************************************************************************/
/*!
 * @brief All TEMPMON module registers.
 */
#pragma pack(1)
typedef struct _hw_tempmon
{
    uint8_t _reserved0[384];
    __IO hw_tempmon_tempsense0_t TEMPSENSE0; /*!< [0x180] Tempsensor Control Register 0 */
    uint8_t _reserved1[12];
    __IO hw_tempmon_tempsense1_t TEMPSENSE1; /*!< [0x190] Tempsensor Control Register 1 */
} hw_tempmon_t;
#pragma pack()

/*! @brief Macro to access all TEMPMON registers. */
/*! @param x TEMPMON module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_TEMPMON_REGS(TEMPMON_BASE)</code>. */
#define HW_TEMPMON_REGS(x) (*(hw_tempmon_t *)(x))

/*
 * iMX6DP UART
 *
 * UARTv2
 *
 * Registers defined in this header file:
 * - HW_UART_URXD - UART Receiver Register
 * - HW_UART_UTXD - UART Transmitter Register
 * - HW_UART_UCR1 - UART Control Register 1
 * - HW_UART_UCR2 - UART Control Register 2
 * - HW_UART_UCR3 - UART Control Register 3
 * - HW_UART_UCR4 - UART Control Register 4
 * - HW_UART_UFCR - UART FIFO Control Register
 * - HW_UART_USR1 - UART Status Register 1
 * - HW_UART_USR2 - UART Status Register 2
 * - HW_UART_UESC - UART Escape Character Register
 * - HW_UART_UTIM - UART Escape Timer Register
 * - HW_UART_UBIR - UART BRM Incremental Register
 * - HW_UART_UBMR - UART BRM Modulator Register
 * - HW_UART_UBRC - UART Baud Rate Count Register
 * - HW_UART_ONEMS - UART One Millisecond Register
 * - HW_UART_UTS - UART Test Register
 * - HW_UART_UMCR - UART RS-485 Mode Control Register
 *
 * - hw_uart_t - Struct containing all module registers.
 */

#define HW_UART_INSTANCE_COUNT (5U) /*!< Number of instances of the UART module. */
#define HW_UART1 (1U) /*!< Instance number for UART1. */
#define HW_UART2 (2U) /*!< Instance number for UART2. */
#define HW_UART3 (3U) /*!< Instance number for UART3. */
#define HW_UART4 (4U) /*!< Instance number for UART4. */
#define HW_UART5 (5U) /*!< Instance number for UART5. */
#define UART1_BASE            (0x2020000U) /*!< Base address for UART1. */
#define UART2_BASE            (0x21E8000U) /*!< Base address for UART2. */
#define UART3_BASE            (0x21EC000U) /*!< Base address for UART3. */
#define UART4_BASE            (0x21F0000U) /*!< Base address for UART4. */
#define UART5_BASE            (0x21F4000U) /*!< Base address for UART5. */
/*! Array initializer of UART base addresses. */
#define UART_BASE_ADDRS       { UART1_BASE, UART2_BASE, UART3_BASE, UART4_BASE, UART5_BASE }

/*******************************************************************************
 * HW_UART_URXD - UART Receiver Register
 ******************************************************************************/

/*!
 * @brief HW_UART_URXD - UART Receiver Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * The UART will yield a transfer error on the peripheral bus when core is
 * reading URXD register with receive interface disabled (RXEN=0 or UARTEN=0).
 */
typedef union _hw_uart_urxd
{
    uint32_t U;
    struct _hw_uart_urxd_bitfields
    {
        uint32_t RX_DATA : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 2;        /*!< [9:8]  */
        uint32_t PRERR : 1;            /*!< [10]  */
        uint32_t BRK : 1;              /*!< [11]  */
        uint32_t FRMERR : 1;           /*!< [12]  */
        uint32_t OVRRUN : 1;           /*!< [13]  */
        uint32_t ERR : 1;              /*!< [14]  */
        uint32_t CHARRDY : 1;          /*!< [15]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_urxd_t;

/*!
 * @name Constants and macros for entire UART_URXD register
 */
/*@{*/
#define HW_UART_URXD_ADDR(x)     ((uintptr_t)(x) + 0x0U)

#define HW_UART_URXD(x)          (*(__I hw_uart_urxd_t *) HW_UART_URXD_ADDR(x))
#define HW_UART_URXD_RD(x)       (HW_UART_URXD(x).U)
/*@}*/

/*
 * Constants & macros for individual UART_URXD bitfields
 */

/*!
 * @name Register UART_URXD, field RX_DATA[7:0] (RO)
 *
 * Received Data. Holds the received character. In 7-bit mode, the most
 * significant bit (MSB) is forced to 0. In 8-bit mode, all bits are active.
 */
/*@{*/
#define BP_UART_URXD_RX_DATA (0U)          /*!< Bit position for UART_URXD_RX_DATA. */
#define BM_UART_URXD_RX_DATA (0x000000FFU) /*!< Bit mask for UART_URXD_RX_DATA. */
#define BS_UART_URXD_RX_DATA (8U)          /*!< Bit field size in bits for UART_URXD_RX_DATA. */

/*! @brief Read current value of the UART_URXD_RX_DATA field. */
#define BR_UART_URXD_RX_DATA(x) (HW_UART_URXD(x).B.RX_DATA)
/*@}*/

/*!
 * @name Register UART_URXD, field PRERR[10] (RO)
 *
 * In RS-485 mode, it holds the ninth data bit (bit [8]) of received 9-bit
 * RS-485 data In RS232/IrDA mode, it is the Parity Error flag. Indicates whether the
 * current character was detected with a parity error and is possibly corrupted.
 * PRERR is updated for each character read from the RxFIFO. When parity is
 * disabled, PRERR always reads as 0.
 *
 * Values:
 * - 0 - = No parity error was detected for data in the RX_DATA field
 * - 1 - = A parity error was detected for data in the RX_DATA field
 */
/*@{*/
#define BP_UART_URXD_PRERR   (10U)         /*!< Bit position for UART_URXD_PRERR. */
#define BM_UART_URXD_PRERR   (0x00000400U) /*!< Bit mask for UART_URXD_PRERR. */
#define BS_UART_URXD_PRERR   (1U)          /*!< Bit field size in bits for UART_URXD_PRERR. */

/*! @brief Read current value of the UART_URXD_PRERR field. */
#define BR_UART_URXD_PRERR(x) (HW_UART_URXD(x).B.PRERR)
/*@}*/

/*!
 * @name Register UART_URXD, field BRK[11] (RO)
 *
 * BREAK Detect. Indicates whether the current character was detected as a BREAK
 * character. The data bits and the stop bit are all 0. The FRMERR bit is set
 * when BRK is set. When odd parity is selected, PRERR is also set when BRK is set.
 * BRK is valid for each character read from the RxFIFO.
 *
 * Values:
 * - 0 - The current character is not a BREAK character
 * - 1 - The current character is a BREAK character
 */
/*@{*/
#define BP_UART_URXD_BRK     (11U)         /*!< Bit position for UART_URXD_BRK. */
#define BM_UART_URXD_BRK     (0x00000800U) /*!< Bit mask for UART_URXD_BRK. */
#define BS_UART_URXD_BRK     (1U)          /*!< Bit field size in bits for UART_URXD_BRK. */

/*! @brief Read current value of the UART_URXD_BRK field. */
#define BR_UART_URXD_BRK(x)  (HW_UART_URXD(x).B.BRK)
/*@}*/

/*!
 * @name Register UART_URXD, field FRMERR[12] (RO)
 *
 * Frame Error. Indicates whether the current character had a framing error (a
 * missing stop bit) and is possibly corrupted. FRMERR is updated for each
 * character read from the RxFIFO.
 *
 * Values:
 * - 0 - The current character has no framing error
 * - 1 - The current character has a framing error
 */
/*@{*/
#define BP_UART_URXD_FRMERR  (12U)         /*!< Bit position for UART_URXD_FRMERR. */
#define BM_UART_URXD_FRMERR  (0x00001000U) /*!< Bit mask for UART_URXD_FRMERR. */
#define BS_UART_URXD_FRMERR  (1U)          /*!< Bit field size in bits for UART_URXD_FRMERR. */

/*! @brief Read current value of the UART_URXD_FRMERR field. */
#define BR_UART_URXD_FRMERR(x) (HW_UART_URXD(x).B.FRMERR)
/*@}*/

/*!
 * @name Register UART_URXD, field OVRRUN[13] (RO)
 *
 * Receiver Overrun. This read-only bit, when HIGH, indicates that the
 * corresponding character was stored in the last position (32nd) of the Rx FIFO. Even if
 * a 33rd character has not been detected, this bit will be set to '1' for the
 * 32nd character.
 *
 * Values:
 * - 0 - No RxFIFO overrun was detected
 * - 1 - A RxFIFO overrun was detected
 */
/*@{*/
#define BP_UART_URXD_OVRRUN  (13U)         /*!< Bit position for UART_URXD_OVRRUN. */
#define BM_UART_URXD_OVRRUN  (0x00002000U) /*!< Bit mask for UART_URXD_OVRRUN. */
#define BS_UART_URXD_OVRRUN  (1U)          /*!< Bit field size in bits for UART_URXD_OVRRUN. */

/*! @brief Read current value of the UART_URXD_OVRRUN field. */
#define BR_UART_URXD_OVRRUN(x) (HW_UART_URXD(x).B.OVRRUN)
/*@}*/

/*!
 * @name Register UART_URXD, field ERR[14] (RO)
 *
 * Error Detect. Indicates whether the character present in the RX_DATA field
 * has an error (OVRRUN, FRMERR, BRK or PRERR) status. The ERR bit is updated and
 * valid for each received character.
 *
 * Values:
 * - 0 - No error status was detected
 * - 1 - An error status was detected
 */
/*@{*/
#define BP_UART_URXD_ERR     (14U)         /*!< Bit position for UART_URXD_ERR. */
#define BM_UART_URXD_ERR     (0x00004000U) /*!< Bit mask for UART_URXD_ERR. */
#define BS_UART_URXD_ERR     (1U)          /*!< Bit field size in bits for UART_URXD_ERR. */

/*! @brief Read current value of the UART_URXD_ERR field. */
#define BR_UART_URXD_ERR(x)  (HW_UART_URXD(x).B.ERR)
/*@}*/

/*!
 * @name Register UART_URXD, field CHARRDY[15] (RO)
 *
 * Character Ready. This read-only bit indicates an invalid read when the FIFO
 * becomes empty and software tries to read the same old data. This bit should not
 * be used for polling for data written to the RX FIFO.
 *
 * Values:
 * - 0 - Character in RX_DATA field and associated flags are invalid.
 * - 1 - Character in RX_DATA field and associated flags valid and ready for
 *     reading.
 */
/*@{*/
#define BP_UART_URXD_CHARRDY (15U)         /*!< Bit position for UART_URXD_CHARRDY. */
#define BM_UART_URXD_CHARRDY (0x00008000U) /*!< Bit mask for UART_URXD_CHARRDY. */
#define BS_UART_URXD_CHARRDY (1U)          /*!< Bit field size in bits for UART_URXD_CHARRDY. */

/*! @brief Read current value of the UART_URXD_CHARRDY field. */
#define BR_UART_URXD_CHARRDY(x) (HW_UART_URXD(x).B.CHARRDY)
/*@}*/

/*******************************************************************************
 * HW_UART_UTXD - UART Transmitter Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UTXD - UART Transmitter Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The UART will yield a transfer error on the peripheral bus when core is
 * writing into UART_URXD register with transmit interface disabled (TXEN=0 or
 * UARTEN=0). Memory space between UART_URXD and UART_UTXD registers is reserved. Any
 * read or write access to this space will be considered as an invalid access and
 * yield a transfer error.
 */
typedef union _hw_uart_utxd
{
    uint32_t U;
    struct _hw_uart_utxd_bitfields
    {
        uint32_t TX_DATA : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_uart_utxd_t;

/*!
 * @name Constants and macros for entire UART_UTXD register
 */
/*@{*/
#define HW_UART_UTXD_ADDR(x)     ((uintptr_t)(x) + 0x40U)

#define HW_UART_UTXD(x)          (*(__IO hw_uart_utxd_t *) HW_UART_UTXD_ADDR(x))
#define HW_UART_UTXD_RD(x)       (HW_UART_UTXD(x).U)
#define HW_UART_UTXD_WR(x, v)    (HW_UART_UTXD(x).U = (v))
#define HW_UART_UTXD_SET(x, v)   (HW_UART_UTXD_WR(x, HW_UART_UTXD_RD(x) |  (v)))
#define HW_UART_UTXD_CLR(x, v)   (HW_UART_UTXD_WR(x, HW_UART_UTXD_RD(x) & ~(v)))
#define HW_UART_UTXD_TOG(x, v)   (HW_UART_UTXD_WR(x, HW_UART_UTXD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UTXD bitfields
 */

/*!
 * @name Register UART_UTXD, field TX_DATA[7:0] (WO)
 *
 * Transmit Data. Holds the parallel transmit data inputs. In 7-bit mode, D7 is
 * ignored. In 8-bit mode, all bits are used. Data is transmitted least
 * significant bit (LSB) first. A new character is transmitted when the TX_DATA field is
 * written. The TX_DATA field must be written only when the TRDY bit is high to
 * ensure that corrupted data is not sent.
 */
/*@{*/
#define BP_UART_UTXD_TX_DATA (0U)          /*!< Bit position for UART_UTXD_TX_DATA. */
#define BM_UART_UTXD_TX_DATA (0x000000FFU) /*!< Bit mask for UART_UTXD_TX_DATA. */
#define BS_UART_UTXD_TX_DATA (8U)          /*!< Bit field size in bits for UART_UTXD_TX_DATA. */

/*! @brief Format value for bitfield UART_UTXD_TX_DATA. */
#define BF_UART_UTXD_TX_DATA(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTXD_TX_DATA) & BM_UART_UTXD_TX_DATA)
/*@}*/

/*******************************************************************************
 * HW_UART_UCR1 - UART Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_UART_UCR1 - UART Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_uart_ucr1
{
    uint32_t U;
    struct _hw_uart_ucr1_bitfields
    {
        uint32_t UARTEN : 1;           /*!< [0]  */
        uint32_t DOZE : 1;             /*!< [1]  */
        uint32_t ATDMAEN : 1;          /*!< [2]  */
        uint32_t TXDMAEN : 1;          /*!< [3]  */
        uint32_t SNDBRK : 1;           /*!< [4]  */
        uint32_t RTSDEN : 1;           /*!< [5]  */
        uint32_t TXMPTYEN : 1;         /*!< [6]  */
        uint32_t IREN : 1;             /*!< [7]  */
        uint32_t RXDMAEN : 1;          /*!< [8]  */
        uint32_t RRDYEN : 1;           /*!< [9]  */
        uint32_t ICD : 2;              /*!< [11:10]  */
        uint32_t IDEN : 1;             /*!< [12]  */
        uint32_t TRDYEN : 1;           /*!< [13]  */
        uint32_t ADBR : 1;             /*!< [14]  */
        uint32_t ADEN : 1;             /*!< [15]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ucr1_t;

/*!
 * @name Constants and macros for entire UART_UCR1 register
 */
/*@{*/
#define HW_UART_UCR1_ADDR(x)     ((uintptr_t)(x) + 0x80U)

#define HW_UART_UCR1(x)          (*(__IO hw_uart_ucr1_t *) HW_UART_UCR1_ADDR(x))
#define HW_UART_UCR1_RD(x)       (HW_UART_UCR1(x).U)
#define HW_UART_UCR1_WR(x, v)    (HW_UART_UCR1(x).U = (v))
#define HW_UART_UCR1_SET(x, v)   (HW_UART_UCR1_WR(x, HW_UART_UCR1_RD(x) |  (v)))
#define HW_UART_UCR1_CLR(x, v)   (HW_UART_UCR1_WR(x, HW_UART_UCR1_RD(x) & ~(v)))
#define HW_UART_UCR1_TOG(x, v)   (HW_UART_UCR1_WR(x, HW_UART_UCR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UCR1 bitfields
 */

/*!
 * @name Register UART_UCR1, field UARTEN[0] (RW)
 *
 * UART Enable. Enables/Disables the UART. If UARTEN is negated in the middle of
 * a transmission, the transmitter stops and pulls the TXD line to a logic 1.
 * UARTEN must be set to 1 before any access to UTXD and URXD registers, otherwise
 * a transfer error is returned. This bit can be set to 1 along with other bits
 * in this register. There is no restriction to the sequence of programing this
 * bit and other control registers.
 *
 * Values:
 * - 0 - Disable the UART
 * - 1 - Enable the UART
 */
/*@{*/
#define BP_UART_UCR1_UARTEN  (0U)          /*!< Bit position for UART_UCR1_UARTEN. */
#define BM_UART_UCR1_UARTEN  (0x00000001U) /*!< Bit mask for UART_UCR1_UARTEN. */
#define BS_UART_UCR1_UARTEN  (1U)          /*!< Bit field size in bits for UART_UCR1_UARTEN. */

/*! @brief Read current value of the UART_UCR1_UARTEN field. */
#define BR_UART_UCR1_UARTEN(x) (HW_UART_UCR1(x).B.UARTEN)

/*! @brief Format value for bitfield UART_UCR1_UARTEN. */
#define BF_UART_UCR1_UARTEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_UARTEN) & BM_UART_UCR1_UARTEN)

/*! @brief Set the UARTEN field to a new value. */
#define BW_UART_UCR1_UARTEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_UARTEN) | BF_UART_UCR1_UARTEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field DOZE[1] (RW)
 *
 * DOZE. Determines the UART enable condition in the DOZE state. When doze_req
 * input pin is at '1', (the ARM Platform executes a doze instruction and the
 * system is placed in the Doze State), the DOZE bit affects operation of the UART.
 * While in the Doze State, if this bit is asserted, the UART is disabled. See the
 * description in Low Power ModesThese modes are controlled by the signals
 * doze_req and stop_req. The control/status/data registers won't change when getting
 * in/out of low power modes. .
 *
 * Values:
 * - 0 - The UART is enabled when in DOZE state
 * - 1 - The UART is disabled when in DOZE state
 */
/*@{*/
#define BP_UART_UCR1_DOZE    (1U)          /*!< Bit position for UART_UCR1_DOZE. */
#define BM_UART_UCR1_DOZE    (0x00000002U) /*!< Bit mask for UART_UCR1_DOZE. */
#define BS_UART_UCR1_DOZE    (1U)          /*!< Bit field size in bits for UART_UCR1_DOZE. */

/*! @brief Read current value of the UART_UCR1_DOZE field. */
#define BR_UART_UCR1_DOZE(x) (HW_UART_UCR1(x).B.DOZE)

/*! @brief Format value for bitfield UART_UCR1_DOZE. */
#define BF_UART_UCR1_DOZE(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_DOZE) & BM_UART_UCR1_DOZE)

/*! @brief Set the DOZE field to a new value. */
#define BW_UART_UCR1_DOZE(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_DOZE) | BF_UART_UCR1_DOZE(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field ATDMAEN[2] (RW)
 *
 * Aging DMA Timer Enable. Enables/Disables the receive DMA request dma_req_rx
 * for the aging timer interrupt (triggered with AGTIM flag in USR1[8]).
 *
 * Values:
 * - 0 - Disable AGTIM DMA request
 * - 1 - Enable AGTIM DMA request
 */
/*@{*/
#define BP_UART_UCR1_ATDMAEN (2U)          /*!< Bit position for UART_UCR1_ATDMAEN. */
#define BM_UART_UCR1_ATDMAEN (0x00000004U) /*!< Bit mask for UART_UCR1_ATDMAEN. */
#define BS_UART_UCR1_ATDMAEN (1U)          /*!< Bit field size in bits for UART_UCR1_ATDMAEN. */

/*! @brief Read current value of the UART_UCR1_ATDMAEN field. */
#define BR_UART_UCR1_ATDMAEN(x) (HW_UART_UCR1(x).B.ATDMAEN)

/*! @brief Format value for bitfield UART_UCR1_ATDMAEN. */
#define BF_UART_UCR1_ATDMAEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_ATDMAEN) & BM_UART_UCR1_ATDMAEN)

/*! @brief Set the ATDMAEN field to a new value. */
#define BW_UART_UCR1_ATDMAEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_ATDMAEN) | BF_UART_UCR1_ATDMAEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field TXDMAEN[3] (RW)
 *
 * Transmitter Ready DMA Enable. Enables/Disables the transmit DMA request
 * dma_req_tx when the transmitter has one or more slots available in the TxFIFO. The
 * fill level in the TxFIFO that generates the dma_req_tx is controlled by the
 * TXTL bits. A DMA request will be issued as long as TXDMAEN and TRDY are high
 * even if the transmitter is not enabled. In general, user should enable the
 * transmitter before enabling the transmit DMA request.
 *
 * Values:
 * - 0 - Disable transmit DMA request
 * - 1 - Enable transmit DMA request
 */
/*@{*/
#define BP_UART_UCR1_TXDMAEN (3U)          /*!< Bit position for UART_UCR1_TXDMAEN. */
#define BM_UART_UCR1_TXDMAEN (0x00000008U) /*!< Bit mask for UART_UCR1_TXDMAEN. */
#define BS_UART_UCR1_TXDMAEN (1U)          /*!< Bit field size in bits for UART_UCR1_TXDMAEN. */

/*! @brief Read current value of the UART_UCR1_TXDMAEN field. */
#define BR_UART_UCR1_TXDMAEN(x) (HW_UART_UCR1(x).B.TXDMAEN)

/*! @brief Format value for bitfield UART_UCR1_TXDMAEN. */
#define BF_UART_UCR1_TXDMAEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_TXDMAEN) & BM_UART_UCR1_TXDMAEN)

/*! @brief Set the TXDMAEN field to a new value. */
#define BW_UART_UCR1_TXDMAEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_TXDMAEN) | BF_UART_UCR1_TXDMAEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field SNDBRK[4] (RW)
 *
 * Send BREAK. Forces the transmitter to send a BREAK character. The transmitter
 * finishes sending the character in progress (if any) and sends BREAK
 * characters until SNDBRK is reset. Because the transmitter samples SNDBRK after every
 * bit is transmitted, it is important that SNDBRK is asserted high for a
 * sufficient period of time to generate a valid BREAK. After the BREAK transmission
 * completes, the UART transmits 2 mark bits. The user can continue to fill the TxFIFO
 * and any characters remaining are transmitted when the BREAK is terminated.
 *
 * Values:
 * - 0 - Do not send a BREAK character
 * - 1 - Send a BREAK character (continuous 0s)
 */
/*@{*/
#define BP_UART_UCR1_SNDBRK  (4U)          /*!< Bit position for UART_UCR1_SNDBRK. */
#define BM_UART_UCR1_SNDBRK  (0x00000010U) /*!< Bit mask for UART_UCR1_SNDBRK. */
#define BS_UART_UCR1_SNDBRK  (1U)          /*!< Bit field size in bits for UART_UCR1_SNDBRK. */

/*! @brief Read current value of the UART_UCR1_SNDBRK field. */
#define BR_UART_UCR1_SNDBRK(x) (HW_UART_UCR1(x).B.SNDBRK)

/*! @brief Format value for bitfield UART_UCR1_SNDBRK. */
#define BF_UART_UCR1_SNDBRK(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_SNDBRK) & BM_UART_UCR1_SNDBRK)

/*! @brief Set the SNDBRK field to a new value. */
#define BW_UART_UCR1_SNDBRK(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_SNDBRK) | BF_UART_UCR1_SNDBRK(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field RTSDEN[5] (RW)
 *
 * RTS Delta Interrupt Enable. Enables/Disables the RTSD interrupt. The current
 * status of the RTS_B pin is read in the RTSS bit.
 *
 * Values:
 * - 0 - Disable RTSD interrupt
 * - 1 - Enable RTSD interrupt
 */
/*@{*/
#define BP_UART_UCR1_RTSDEN  (5U)          /*!< Bit position for UART_UCR1_RTSDEN. */
#define BM_UART_UCR1_RTSDEN  (0x00000020U) /*!< Bit mask for UART_UCR1_RTSDEN. */
#define BS_UART_UCR1_RTSDEN  (1U)          /*!< Bit field size in bits for UART_UCR1_RTSDEN. */

/*! @brief Read current value of the UART_UCR1_RTSDEN field. */
#define BR_UART_UCR1_RTSDEN(x) (HW_UART_UCR1(x).B.RTSDEN)

/*! @brief Format value for bitfield UART_UCR1_RTSDEN. */
#define BF_UART_UCR1_RTSDEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_RTSDEN) & BM_UART_UCR1_RTSDEN)

/*! @brief Set the RTSDEN field to a new value. */
#define BW_UART_UCR1_RTSDEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_RTSDEN) | BF_UART_UCR1_RTSDEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field TXMPTYEN[6] (RW)
 *
 * Transmitter Empty Interrupt Enable. Enables/Disables the transmitter FIFO
 * empty (TXFE) interrupt. interrupt_uart . When negated, the TXFE interrupt is
 * disabled. An interrupt will be issued as long as TXMPTYEN and TXFE are high even
 * if the transmitter is not enabled. In general, user should enable the
 * transmitter before enabling the TXFE interrupt.
 *
 * Values:
 * - 0 - Disable the transmitter FIFO empty interrupt
 * - 1 - Enable the transmitter FIFO empty interrupt
 */
/*@{*/
#define BP_UART_UCR1_TXMPTYEN (6U)         /*!< Bit position for UART_UCR1_TXMPTYEN. */
#define BM_UART_UCR1_TXMPTYEN (0x00000040U) /*!< Bit mask for UART_UCR1_TXMPTYEN. */
#define BS_UART_UCR1_TXMPTYEN (1U)         /*!< Bit field size in bits for UART_UCR1_TXMPTYEN. */

/*! @brief Read current value of the UART_UCR1_TXMPTYEN field. */
#define BR_UART_UCR1_TXMPTYEN(x) (HW_UART_UCR1(x).B.TXMPTYEN)

/*! @brief Format value for bitfield UART_UCR1_TXMPTYEN. */
#define BF_UART_UCR1_TXMPTYEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_TXMPTYEN) & BM_UART_UCR1_TXMPTYEN)

/*! @brief Set the TXMPTYEN field to a new value. */
#define BW_UART_UCR1_TXMPTYEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_TXMPTYEN) | BF_UART_UCR1_TXMPTYEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field IREN[7] (RW)
 *
 * Infrared Interface Enable. Enables/Disables the IR interface. See the IR
 * interface description in Infrared Interface , for more information. Note:
 * MDEN(UMCR[0]) must be cleared to 0 when using IrDA interface. See
 *
 * Values:
 * - 0 - Disable the IR interface
 * - 1 - Enable the IR interface
 */
/*@{*/
#define BP_UART_UCR1_IREN    (7U)          /*!< Bit position for UART_UCR1_IREN. */
#define BM_UART_UCR1_IREN    (0x00000080U) /*!< Bit mask for UART_UCR1_IREN. */
#define BS_UART_UCR1_IREN    (1U)          /*!< Bit field size in bits for UART_UCR1_IREN. */

/*! @brief Read current value of the UART_UCR1_IREN field. */
#define BR_UART_UCR1_IREN(x) (HW_UART_UCR1(x).B.IREN)

/*! @brief Format value for bitfield UART_UCR1_IREN. */
#define BF_UART_UCR1_IREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_IREN) & BM_UART_UCR1_IREN)

/*! @brief Set the IREN field to a new value. */
#define BW_UART_UCR1_IREN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_IREN) | BF_UART_UCR1_IREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field RXDMAEN[8] (RW)
 *
 * Receive Ready DMA Enable. Enables/Disables the receive DMA request dma_req_rx
 * when the receiver has data in the RxFIFO. The fill level in the RxFIFO at
 * which a DMA request is generated is controlled by the RXTL bits. When negated,
 * the receive DMA request is disabled.
 *
 * Values:
 * - 0 - Disable DMA request
 * - 1 - Enable DMA request
 */
/*@{*/
#define BP_UART_UCR1_RXDMAEN (8U)          /*!< Bit position for UART_UCR1_RXDMAEN. */
#define BM_UART_UCR1_RXDMAEN (0x00000100U) /*!< Bit mask for UART_UCR1_RXDMAEN. */
#define BS_UART_UCR1_RXDMAEN (1U)          /*!< Bit field size in bits for UART_UCR1_RXDMAEN. */

/*! @brief Read current value of the UART_UCR1_RXDMAEN field. */
#define BR_UART_UCR1_RXDMAEN(x) (HW_UART_UCR1(x).B.RXDMAEN)

/*! @brief Format value for bitfield UART_UCR1_RXDMAEN. */
#define BF_UART_UCR1_RXDMAEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_RXDMAEN) & BM_UART_UCR1_RXDMAEN)

/*! @brief Set the RXDMAEN field to a new value. */
#define BW_UART_UCR1_RXDMAEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_RXDMAEN) | BF_UART_UCR1_RXDMAEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field RRDYEN[9] (RW)
 *
 * Receiver Ready Interrupt Enable. Enables/Disables the RRDY interrupt when the
 * RxFIFO contains data. The fill level in the RxFIFO at which an interrupt is
 * generated is controlled by the RXTL bits. When RRDYEN is negated, the receiver
 * ready interrupt is disabled.
 *
 * Values:
 * - 0 - Disables the RRDY interrupt
 * - 1 - Enables the RRDY interrupt
 */
/*@{*/
#define BP_UART_UCR1_RRDYEN  (9U)          /*!< Bit position for UART_UCR1_RRDYEN. */
#define BM_UART_UCR1_RRDYEN  (0x00000200U) /*!< Bit mask for UART_UCR1_RRDYEN. */
#define BS_UART_UCR1_RRDYEN  (1U)          /*!< Bit field size in bits for UART_UCR1_RRDYEN. */

/*! @brief Read current value of the UART_UCR1_RRDYEN field. */
#define BR_UART_UCR1_RRDYEN(x) (HW_UART_UCR1(x).B.RRDYEN)

/*! @brief Format value for bitfield UART_UCR1_RRDYEN. */
#define BF_UART_UCR1_RRDYEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_RRDYEN) & BM_UART_UCR1_RRDYEN)

/*! @brief Set the RRDYEN field to a new value. */
#define BW_UART_UCR1_RRDYEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_RRDYEN) | BF_UART_UCR1_RRDYEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field ICD[11:10] (RW)
 *
 * Idle Condition Detect. Controls the number of frames RXD is allowed to be
 * idle before an idle condition is reported.
 *
 * Values:
 * - 00 - Idle for more than 4 frames
 * - 01 - Idle for more than 8 frames
 * - 10 - Idle for more than 16 frames
 * - 11 - Idle for more than 32 frames
 */
/*@{*/
#define BP_UART_UCR1_ICD     (10U)         /*!< Bit position for UART_UCR1_ICD. */
#define BM_UART_UCR1_ICD     (0x00000C00U) /*!< Bit mask for UART_UCR1_ICD. */
#define BS_UART_UCR1_ICD     (2U)          /*!< Bit field size in bits for UART_UCR1_ICD. */

/*! @brief Read current value of the UART_UCR1_ICD field. */
#define BR_UART_UCR1_ICD(x)  (HW_UART_UCR1(x).B.ICD)

/*! @brief Format value for bitfield UART_UCR1_ICD. */
#define BF_UART_UCR1_ICD(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_ICD) & BM_UART_UCR1_ICD)

/*! @brief Set the ICD field to a new value. */
#define BW_UART_UCR1_ICD(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_ICD) | BF_UART_UCR1_ICD(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field IDEN[12] (RW)
 *
 * Idle Condition Detected Interrupt Enable. Enables/Disables the IDLE bit to
 * generate an interrupt ( interrupt_uart = 0).
 *
 * Values:
 * - 0 - Disable the IDLE interrupt
 * - 1 - Enable the IDLE interrupt
 */
/*@{*/
#define BP_UART_UCR1_IDEN    (12U)         /*!< Bit position for UART_UCR1_IDEN. */
#define BM_UART_UCR1_IDEN    (0x00001000U) /*!< Bit mask for UART_UCR1_IDEN. */
#define BS_UART_UCR1_IDEN    (1U)          /*!< Bit field size in bits for UART_UCR1_IDEN. */

/*! @brief Read current value of the UART_UCR1_IDEN field. */
#define BR_UART_UCR1_IDEN(x) (HW_UART_UCR1(x).B.IDEN)

/*! @brief Format value for bitfield UART_UCR1_IDEN. */
#define BF_UART_UCR1_IDEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_IDEN) & BM_UART_UCR1_IDEN)

/*! @brief Set the IDEN field to a new value. */
#define BW_UART_UCR1_IDEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_IDEN) | BF_UART_UCR1_IDEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field TRDYEN[13] (RW)
 *
 * Transmitter Ready Interrupt Enable. Enables/Disables the transmitter Ready
 * Interrupt (TRDY) when the transmitter has one or more slots available in the
 * TxFIFO. The fill level in the TXFIFO at which an interrupt is generated is
 * controlled by TxTL bits. When TRDYEN is negated, the transmitter ready interrupt is
 * disabled. An interrupt will be issued as long as TRDYEN and TRDY are high even
 * if the transmitter is not enabled. In general, user should enable the
 * transmitter before enabling the TRDY interrupt.
 *
 * Values:
 * - 0 - Disable the transmitter ready interrupt
 * - 1 - Enable the transmitter ready interrupt
 */
/*@{*/
#define BP_UART_UCR1_TRDYEN  (13U)         /*!< Bit position for UART_UCR1_TRDYEN. */
#define BM_UART_UCR1_TRDYEN  (0x00002000U) /*!< Bit mask for UART_UCR1_TRDYEN. */
#define BS_UART_UCR1_TRDYEN  (1U)          /*!< Bit field size in bits for UART_UCR1_TRDYEN. */

/*! @brief Read current value of the UART_UCR1_TRDYEN field. */
#define BR_UART_UCR1_TRDYEN(x) (HW_UART_UCR1(x).B.TRDYEN)

/*! @brief Format value for bitfield UART_UCR1_TRDYEN. */
#define BF_UART_UCR1_TRDYEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_TRDYEN) & BM_UART_UCR1_TRDYEN)

/*! @brief Set the TRDYEN field to a new value. */
#define BW_UART_UCR1_TRDYEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_TRDYEN) | BF_UART_UCR1_TRDYEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field ADBR[14] (RW)
 *
 * Automatic Detection of Baud Rate. Enables/Disables automatic baud rate
 * detection. When the ADBR bit is set and the ADET bit is cleared, the receiver
 * detects the incoming baud rate automatically. The ADET flag is set when the receiver
 * verifies that the incoming baud rate is detected properly by detecting an
 * ASCII character "A" or "a" (0x41 or 0x61).
 *
 * Values:
 * - 0 - Disable automatic detection of baud rate
 * - 1 - Enable automatic detection of baud rate
 */
/*@{*/
#define BP_UART_UCR1_ADBR    (14U)         /*!< Bit position for UART_UCR1_ADBR. */
#define BM_UART_UCR1_ADBR    (0x00004000U) /*!< Bit mask for UART_UCR1_ADBR. */
#define BS_UART_UCR1_ADBR    (1U)          /*!< Bit field size in bits for UART_UCR1_ADBR. */

/*! @brief Read current value of the UART_UCR1_ADBR field. */
#define BR_UART_UCR1_ADBR(x) (HW_UART_UCR1(x).B.ADBR)

/*! @brief Format value for bitfield UART_UCR1_ADBR. */
#define BF_UART_UCR1_ADBR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_ADBR) & BM_UART_UCR1_ADBR)

/*! @brief Set the ADBR field to a new value. */
#define BW_UART_UCR1_ADBR(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_ADBR) | BF_UART_UCR1_ADBR(v)))
/*@}*/

/*!
 * @name Register UART_UCR1, field ADEN[15] (RW)
 *
 * Automatic Baud Rate Detection Interrupt Enable. Enables/Disables the
 * automatic baud rate detect complete (ADET) bit to generate an interrupt (
 * interrupt_uart = 0).
 *
 * Values:
 * - 0 - Disable the automatic baud rate detection interrupt
 * - 1 - Enable the automatic baud rate detection interrupt
 */
/*@{*/
#define BP_UART_UCR1_ADEN    (15U)         /*!< Bit position for UART_UCR1_ADEN. */
#define BM_UART_UCR1_ADEN    (0x00008000U) /*!< Bit mask for UART_UCR1_ADEN. */
#define BS_UART_UCR1_ADEN    (1U)          /*!< Bit field size in bits for UART_UCR1_ADEN. */

/*! @brief Read current value of the UART_UCR1_ADEN field. */
#define BR_UART_UCR1_ADEN(x) (HW_UART_UCR1(x).B.ADEN)

/*! @brief Format value for bitfield UART_UCR1_ADEN. */
#define BF_UART_UCR1_ADEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR1_ADEN) & BM_UART_UCR1_ADEN)

/*! @brief Set the ADEN field to a new value. */
#define BW_UART_UCR1_ADEN(x, v) (HW_UART_UCR1_WR(x, (HW_UART_UCR1_RD(x) & ~BM_UART_UCR1_ADEN) | BF_UART_UCR1_ADEN(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UCR2 - UART Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_UART_UCR2 - UART Control Register 2 (RW)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_uart_ucr2
{
    uint32_t U;
    struct _hw_uart_ucr2_bitfields
    {
        uint32_t SRST : 1;             /*!< [0]  */
        uint32_t RXEN : 1;             /*!< [1]  */
        uint32_t TXEN : 1;             /*!< [2]  */
        uint32_t ATEN : 1;             /*!< [3]  */
        uint32_t RTSEN : 1;            /*!< [4]  */
        uint32_t WS : 1;               /*!< [5]  */
        uint32_t STPB : 1;             /*!< [6]  */
        uint32_t PROE : 1;             /*!< [7]  */
        uint32_t PREN : 1;             /*!< [8]  */
        uint32_t RTEC : 2;             /*!< [10:9]  */
        uint32_t ESCEN : 1;            /*!< [11]  */
        uint32_t CTS : 1;              /*!< [12]  */
        uint32_t CTSC : 1;             /*!< [13]  */
        uint32_t IRTS : 1;             /*!< [14]  */
        uint32_t ESCI : 1;             /*!< [15]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ucr2_t;

/*!
 * @name Constants and macros for entire UART_UCR2 register
 */
/*@{*/
#define HW_UART_UCR2_ADDR(x)     ((uintptr_t)(x) + 0x84U)

#define HW_UART_UCR2(x)          (*(__IO hw_uart_ucr2_t *) HW_UART_UCR2_ADDR(x))
#define HW_UART_UCR2_RD(x)       (HW_UART_UCR2(x).U)
#define HW_UART_UCR2_WR(x, v)    (HW_UART_UCR2(x).U = (v))
#define HW_UART_UCR2_SET(x, v)   (HW_UART_UCR2_WR(x, HW_UART_UCR2_RD(x) |  (v)))
#define HW_UART_UCR2_CLR(x, v)   (HW_UART_UCR2_WR(x, HW_UART_UCR2_RD(x) & ~(v)))
#define HW_UART_UCR2_TOG(x, v)   (HW_UART_UCR2_WR(x, HW_UART_UCR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UCR2 bitfields
 */

/*!
 * @name Register UART_UCR2, field SRST[0] (RW)
 *
 * Software Reset. Once the software writes 0 to SRST_B, the software reset
 * remains active for 4 module_clock cycles before the hardware deasserts SRST_B. The
 * software can only write 0 to SRST_B. Writing 1 to SRST_B is ignored.
 *
 * Values:
 * - 0 - Reset the transmit and receive state machines, all FIFOs and register
 *     USR1, USR2, UBIR, UBMR, UBRC , URXD, UTXD and UTS[6-3].
 * - 1 - No reset
 */
/*@{*/
#define BP_UART_UCR2_SRST    (0U)          /*!< Bit position for UART_UCR2_SRST. */
#define BM_UART_UCR2_SRST    (0x00000001U) /*!< Bit mask for UART_UCR2_SRST. */
#define BS_UART_UCR2_SRST    (1U)          /*!< Bit field size in bits for UART_UCR2_SRST. */

/*! @brief Read current value of the UART_UCR2_SRST field. */
#define BR_UART_UCR2_SRST(x) (HW_UART_UCR2(x).B.SRST)

/*! @brief Format value for bitfield UART_UCR2_SRST. */
#define BF_UART_UCR2_SRST(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_SRST) & BM_UART_UCR2_SRST)

/*! @brief Set the SRST field to a new value. */
#define BW_UART_UCR2_SRST(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_SRST) | BF_UART_UCR2_SRST(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field RXEN[1] (RW)
 *
 * Receiver Enable. Enables/Disables the receiver. When the receiver is enabled,
 * if the RXD input is already low, the receiver does not recognize BREAK
 * characters, because it requires a valid 1-to-0 transition before it can accept any
 * character.
 *
 * Values:
 * - 0 - Disable the receiver
 * - 1 - Enable the receiver
 */
/*@{*/
#define BP_UART_UCR2_RXEN    (1U)          /*!< Bit position for UART_UCR2_RXEN. */
#define BM_UART_UCR2_RXEN    (0x00000002U) /*!< Bit mask for UART_UCR2_RXEN. */
#define BS_UART_UCR2_RXEN    (1U)          /*!< Bit field size in bits for UART_UCR2_RXEN. */

/*! @brief Read current value of the UART_UCR2_RXEN field. */
#define BR_UART_UCR2_RXEN(x) (HW_UART_UCR2(x).B.RXEN)

/*! @brief Format value for bitfield UART_UCR2_RXEN. */
#define BF_UART_UCR2_RXEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_RXEN) & BM_UART_UCR2_RXEN)

/*! @brief Set the RXEN field to a new value. */
#define BW_UART_UCR2_RXEN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_RXEN) | BF_UART_UCR2_RXEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field TXEN[2] (RW)
 *
 * Transmitter Enable. Enables/Disables the transmitter. When TXEN is negated
 * the transmitter is disabled and idle. When the UARTEN and TXEN bits are set the
 * transmitter is enabled. If TXEN is negated in the middle of a transmission,
 * the UART disables the transmitter immediately, and starts marking 1s. The
 * transmitter FIFO cannot be written when this bit is cleared.
 *
 * Values:
 * - 0 - Disable the transmitter
 * - 1 - Enable the transmitter
 */
/*@{*/
#define BP_UART_UCR2_TXEN    (2U)          /*!< Bit position for UART_UCR2_TXEN. */
#define BM_UART_UCR2_TXEN    (0x00000004U) /*!< Bit mask for UART_UCR2_TXEN. */
#define BS_UART_UCR2_TXEN    (1U)          /*!< Bit field size in bits for UART_UCR2_TXEN. */

/*! @brief Read current value of the UART_UCR2_TXEN field. */
#define BR_UART_UCR2_TXEN(x) (HW_UART_UCR2(x).B.TXEN)

/*! @brief Format value for bitfield UART_UCR2_TXEN. */
#define BF_UART_UCR2_TXEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_TXEN) & BM_UART_UCR2_TXEN)

/*! @brief Set the TXEN field to a new value. */
#define BW_UART_UCR2_TXEN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_TXEN) | BF_UART_UCR2_TXEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field ATEN[3] (RW)
 *
 * Aging Timer Enable. This bit is used to enable the aging timer interrupt
 * (triggered with AGTIM)
 *
 * Values:
 * - 0 - AGTIM interrupt disabled
 * - 1 - AGTIM interrupt enabled
 */
/*@{*/
#define BP_UART_UCR2_ATEN    (3U)          /*!< Bit position for UART_UCR2_ATEN. */
#define BM_UART_UCR2_ATEN    (0x00000008U) /*!< Bit mask for UART_UCR2_ATEN. */
#define BS_UART_UCR2_ATEN    (1U)          /*!< Bit field size in bits for UART_UCR2_ATEN. */

/*! @brief Read current value of the UART_UCR2_ATEN field. */
#define BR_UART_UCR2_ATEN(x) (HW_UART_UCR2(x).B.ATEN)

/*! @brief Format value for bitfield UART_UCR2_ATEN. */
#define BF_UART_UCR2_ATEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_ATEN) & BM_UART_UCR2_ATEN)

/*! @brief Set the ATEN field to a new value. */
#define BW_UART_UCR2_ATEN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_ATEN) | BF_UART_UCR2_ATEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field RTSEN[4] (RW)
 *
 * Request to Send Interrupt Enable. Controls the RTS edge sensitive interrupt.
 * When RTSEN is asserted and the programmed edge is detected on the RTS_B pin
 * (the RTSF bit is asserted), an interrupt will be generated on the interrupt_uart
 * pin. (See .)
 *
 * Values:
 * - 0 - Disable request to send interrupt
 * - 1 - Enable request to send interrupt
 */
/*@{*/
#define BP_UART_UCR2_RTSEN   (4U)          /*!< Bit position for UART_UCR2_RTSEN. */
#define BM_UART_UCR2_RTSEN   (0x00000010U) /*!< Bit mask for UART_UCR2_RTSEN. */
#define BS_UART_UCR2_RTSEN   (1U)          /*!< Bit field size in bits for UART_UCR2_RTSEN. */

/*! @brief Read current value of the UART_UCR2_RTSEN field. */
#define BR_UART_UCR2_RTSEN(x) (HW_UART_UCR2(x).B.RTSEN)

/*! @brief Format value for bitfield UART_UCR2_RTSEN. */
#define BF_UART_UCR2_RTSEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_RTSEN) & BM_UART_UCR2_RTSEN)

/*! @brief Set the RTSEN field to a new value. */
#define BW_UART_UCR2_RTSEN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_RTSEN) | BF_UART_UCR2_RTSEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field WS[5] (RW)
 *
 * Word Size. Controls the character length. When WS is high, the transmitter
 * and receiver are in 8-bit mode. When WS is low, they are in 7-bit mode. The
 * transmitter ignores bit 7 and the receiver sets bit 7 to 0. WS can be changed
 * in-between transmission (reception) of characters, however not when a transmission
 * (reception) is in progress, in which case the length of the current character
 * being transmitted (received) is unpredictable.
 *
 * Values:
 * - 0 - 7-bit transmit and receive character length (not including START, STOP
 *     or PARITY bits)
 * - 1 - 8-bit transmit and receive character length (not including START, STOP
 *     or PARITY bits)
 */
/*@{*/
#define BP_UART_UCR2_WS      (5U)          /*!< Bit position for UART_UCR2_WS. */
#define BM_UART_UCR2_WS      (0x00000020U) /*!< Bit mask for UART_UCR2_WS. */
#define BS_UART_UCR2_WS      (1U)          /*!< Bit field size in bits for UART_UCR2_WS. */

/*! @brief Read current value of the UART_UCR2_WS field. */
#define BR_UART_UCR2_WS(x)   (HW_UART_UCR2(x).B.WS)

/*! @brief Format value for bitfield UART_UCR2_WS. */
#define BF_UART_UCR2_WS(v)   ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_WS) & BM_UART_UCR2_WS)

/*! @brief Set the WS field to a new value. */
#define BW_UART_UCR2_WS(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_WS) | BF_UART_UCR2_WS(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field STPB[6] (RW)
 *
 * Stop. Controls the number of stop bits after a character. When STPB is low, 1
 * stop bit is sent. When STPB is high, 2 stop bits are sent. STPB also affects
 * the receiver.
 *
 * Values:
 * - 0 - The transmitter sends 1 stop bit. The receiver expects 1 or more stop
 *     bits.
 * - 1 - The transmitter sends 2 stop bits. The receiver expects 2 or more stop
 *     bits.
 */
/*@{*/
#define BP_UART_UCR2_STPB    (6U)          /*!< Bit position for UART_UCR2_STPB. */
#define BM_UART_UCR2_STPB    (0x00000040U) /*!< Bit mask for UART_UCR2_STPB. */
#define BS_UART_UCR2_STPB    (1U)          /*!< Bit field size in bits for UART_UCR2_STPB. */

/*! @brief Read current value of the UART_UCR2_STPB field. */
#define BR_UART_UCR2_STPB(x) (HW_UART_UCR2(x).B.STPB)

/*! @brief Format value for bitfield UART_UCR2_STPB. */
#define BF_UART_UCR2_STPB(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_STPB) & BM_UART_UCR2_STPB)

/*! @brief Set the STPB field to a new value. */
#define BW_UART_UCR2_STPB(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_STPB) | BF_UART_UCR2_STPB(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field PROE[7] (RW)
 *
 * Parity Odd/Even. Controls the sense of the parity generator and checker. When
 * PROE is high, odd parity is generated and expected. When PROE is low, even
 * parity is generated and expected. PROE has no function if PREN is low.
 *
 * Values:
 * - 0 - Even parity
 * - 1 - Odd parity
 */
/*@{*/
#define BP_UART_UCR2_PROE    (7U)          /*!< Bit position for UART_UCR2_PROE. */
#define BM_UART_UCR2_PROE    (0x00000080U) /*!< Bit mask for UART_UCR2_PROE. */
#define BS_UART_UCR2_PROE    (1U)          /*!< Bit field size in bits for UART_UCR2_PROE. */

/*! @brief Read current value of the UART_UCR2_PROE field. */
#define BR_UART_UCR2_PROE(x) (HW_UART_UCR2(x).B.PROE)

/*! @brief Format value for bitfield UART_UCR2_PROE. */
#define BF_UART_UCR2_PROE(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_PROE) & BM_UART_UCR2_PROE)

/*! @brief Set the PROE field to a new value. */
#define BW_UART_UCR2_PROE(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_PROE) | BF_UART_UCR2_PROE(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field PREN[8] (RW)
 *
 * Parity Enable. Enables/Disables the parity generator in the transmitter and
 * parity checker in the receiver. When PREN is asserted, the parity generator and
 * checker are enabled, and disabled when PREN is negated.
 *
 * Values:
 * - 0 - Disable parity generator and checker
 * - 1 - Enable parity generator and checker
 */
/*@{*/
#define BP_UART_UCR2_PREN    (8U)          /*!< Bit position for UART_UCR2_PREN. */
#define BM_UART_UCR2_PREN    (0x00000100U) /*!< Bit mask for UART_UCR2_PREN. */
#define BS_UART_UCR2_PREN    (1U)          /*!< Bit field size in bits for UART_UCR2_PREN. */

/*! @brief Read current value of the UART_UCR2_PREN field. */
#define BR_UART_UCR2_PREN(x) (HW_UART_UCR2(x).B.PREN)

/*! @brief Format value for bitfield UART_UCR2_PREN. */
#define BF_UART_UCR2_PREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_PREN) & BM_UART_UCR2_PREN)

/*! @brief Set the PREN field to a new value. */
#define BW_UART_UCR2_PREN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_PREN) | BF_UART_UCR2_PREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field RTEC[10:9] (RW)
 *
 * Request to Send Edge Control. Selects the edge that triggers the RTS
 * interrupt. This has no effect on the RTS delta interrupt. RTEC has an effect only when
 * RTSEN = 1 (see ).
 *
 * Values:
 * - 00 - Trigger interrupt on a rising edge
 * - 01 - Trigger interrupt on a falling edge
 */
/*@{*/
#define BP_UART_UCR2_RTEC    (9U)          /*!< Bit position for UART_UCR2_RTEC. */
#define BM_UART_UCR2_RTEC    (0x00000600U) /*!< Bit mask for UART_UCR2_RTEC. */
#define BS_UART_UCR2_RTEC    (2U)          /*!< Bit field size in bits for UART_UCR2_RTEC. */

/*! @brief Read current value of the UART_UCR2_RTEC field. */
#define BR_UART_UCR2_RTEC(x) (HW_UART_UCR2(x).B.RTEC)

/*! @brief Format value for bitfield UART_UCR2_RTEC. */
#define BF_UART_UCR2_RTEC(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_RTEC) & BM_UART_UCR2_RTEC)

/*! @brief Set the RTEC field to a new value. */
#define BW_UART_UCR2_RTEC(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_RTEC) | BF_UART_UCR2_RTEC(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field ESCEN[11] (RW)
 *
 * Escape Enable. Enables/Disables the escape sequence detection logic.
 *
 * Values:
 * - 0 - Disable escape sequence detection
 * - 1 - Enable escape sequence detection
 */
/*@{*/
#define BP_UART_UCR2_ESCEN   (11U)         /*!< Bit position for UART_UCR2_ESCEN. */
#define BM_UART_UCR2_ESCEN   (0x00000800U) /*!< Bit mask for UART_UCR2_ESCEN. */
#define BS_UART_UCR2_ESCEN   (1U)          /*!< Bit field size in bits for UART_UCR2_ESCEN. */

/*! @brief Read current value of the UART_UCR2_ESCEN field. */
#define BR_UART_UCR2_ESCEN(x) (HW_UART_UCR2(x).B.ESCEN)

/*! @brief Format value for bitfield UART_UCR2_ESCEN. */
#define BF_UART_UCR2_ESCEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_ESCEN) & BM_UART_UCR2_ESCEN)

/*! @brief Set the ESCEN field to a new value. */
#define BW_UART_UCR2_ESCEN(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_ESCEN) | BF_UART_UCR2_ESCEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field CTS[12] (RW)
 *
 * Clear to Send. Controls the CTS_B pin when the CTSC bit is negated. CTS has
 * no function when CTSC is asserted.
 *
 * Values:
 * - 0 - The CTS_B pin is high (inactive)
 * - 1 - The CTS_B pin is low (active)
 */
/*@{*/
#define BP_UART_UCR2_CTS     (12U)         /*!< Bit position for UART_UCR2_CTS. */
#define BM_UART_UCR2_CTS     (0x00001000U) /*!< Bit mask for UART_UCR2_CTS. */
#define BS_UART_UCR2_CTS     (1U)          /*!< Bit field size in bits for UART_UCR2_CTS. */

/*! @brief Read current value of the UART_UCR2_CTS field. */
#define BR_UART_UCR2_CTS(x)  (HW_UART_UCR2(x).B.CTS)

/*! @brief Format value for bitfield UART_UCR2_CTS. */
#define BF_UART_UCR2_CTS(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_CTS) & BM_UART_UCR2_CTS)

/*! @brief Set the CTS field to a new value. */
#define BW_UART_UCR2_CTS(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_CTS) | BF_UART_UCR2_CTS(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field CTSC[13] (RW)
 *
 * CTS Pin Control. Controls the operation of the CTS_B module output. When CTSC
 * is asserted, the CTS_B module output is controlled by the receiver. When the
 * RxFIFO is filled to the level of the programmed trigger level and the start
 * bit of the overflowing character (TRIGGER LEVEL + 1) is validated, the CTS_B
 * module output is negated to indicate to the far-end transmitter to stop
 * transmitting. When the trigger level is programmed for less than 32, the receiver
 * continues to receive data until the RxFIFO is full. When the CTSC bit is negated,
 * the CTS_B module output is controlled by the CTS bit. On reset, because CTSC is
 * cleared to 0, the CTS_B pin is controlled by the CTS bit, which again is
 * cleared to 0 on reset. This means that on reset the CTS_B signal is negated.
 *
 * Values:
 * - 0 - The CTS_B pin is controlled by the CTS bit
 * - 1 - The CTS_B pin is controlled by the receiver
 */
/*@{*/
#define BP_UART_UCR2_CTSC    (13U)         /*!< Bit position for UART_UCR2_CTSC. */
#define BM_UART_UCR2_CTSC    (0x00002000U) /*!< Bit mask for UART_UCR2_CTSC. */
#define BS_UART_UCR2_CTSC    (1U)          /*!< Bit field size in bits for UART_UCR2_CTSC. */

/*! @brief Read current value of the UART_UCR2_CTSC field. */
#define BR_UART_UCR2_CTSC(x) (HW_UART_UCR2(x).B.CTSC)

/*! @brief Format value for bitfield UART_UCR2_CTSC. */
#define BF_UART_UCR2_CTSC(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_CTSC) & BM_UART_UCR2_CTSC)

/*! @brief Set the CTSC field to a new value. */
#define BW_UART_UCR2_CTSC(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_CTSC) | BF_UART_UCR2_CTSC(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field IRTS[14] (RW)
 *
 * Ignore RTS Pin. Forces the RTS input signal presented to the transmitter to
 * always be asserted (set to low), effectively ignoring the external pin. When in
 * this mode, the RTS pin serves as a general purpose input.
 *
 * Values:
 * - 0 - Transmit only when the RTS pin is asserted
 * - 1 - Ignore the RTS pin
 */
/*@{*/
#define BP_UART_UCR2_IRTS    (14U)         /*!< Bit position for UART_UCR2_IRTS. */
#define BM_UART_UCR2_IRTS    (0x00004000U) /*!< Bit mask for UART_UCR2_IRTS. */
#define BS_UART_UCR2_IRTS    (1U)          /*!< Bit field size in bits for UART_UCR2_IRTS. */

/*! @brief Read current value of the UART_UCR2_IRTS field. */
#define BR_UART_UCR2_IRTS(x) (HW_UART_UCR2(x).B.IRTS)

/*! @brief Format value for bitfield UART_UCR2_IRTS. */
#define BF_UART_UCR2_IRTS(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_IRTS) & BM_UART_UCR2_IRTS)

/*! @brief Set the IRTS field to a new value. */
#define BW_UART_UCR2_IRTS(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_IRTS) | BF_UART_UCR2_IRTS(v)))
/*@}*/

/*!
 * @name Register UART_UCR2, field ESCI[15] (RW)
 *
 * Escape Sequence Interrupt Enable. Enables/Disables the ESCF bit to generate
 * an interrupt.
 *
 * Values:
 * - 0 - Disable the escape sequence interrupt
 * - 1 - Enable the escape sequence interrupt
 */
/*@{*/
#define BP_UART_UCR2_ESCI    (15U)         /*!< Bit position for UART_UCR2_ESCI. */
#define BM_UART_UCR2_ESCI    (0x00008000U) /*!< Bit mask for UART_UCR2_ESCI. */
#define BS_UART_UCR2_ESCI    (1U)          /*!< Bit field size in bits for UART_UCR2_ESCI. */

/*! @brief Read current value of the UART_UCR2_ESCI field. */
#define BR_UART_UCR2_ESCI(x) (HW_UART_UCR2(x).B.ESCI)

/*! @brief Format value for bitfield UART_UCR2_ESCI. */
#define BF_UART_UCR2_ESCI(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR2_ESCI) & BM_UART_UCR2_ESCI)

/*! @brief Set the ESCI field to a new value. */
#define BW_UART_UCR2_ESCI(x, v) (HW_UART_UCR2_WR(x, (HW_UART_UCR2_RD(x) & ~BM_UART_UCR2_ESCI) | BF_UART_UCR2_ESCI(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UCR3 - UART Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_UART_UCR3 - UART Control Register 3 (RW)
 *
 * Reset value: 0x00000700U
 */
typedef union _hw_uart_ucr3
{
    uint32_t U;
    struct _hw_uart_ucr3_bitfields
    {
        uint32_t ACIEN : 1;            /*!< [0]  */
        uint32_t INVT : 1;             /*!< [1]  */
        uint32_t RXDMUXSEL : 1;        /*!< [2]  */
        uint32_t DTRDEN : 1;           /*!< [3]  */
        uint32_t AWAKEN : 1;           /*!< [4]  */
        uint32_t AIRINTEN : 1;         /*!< [5]  */
        uint32_t RXDSEN : 1;           /*!< [6]  */
        uint32_t ADNIMP : 1;           /*!< [7]  */
        uint32_t RI : 1;               /*!< [8]  */
        uint32_t DCD : 1;              /*!< [9]  */
        uint32_t DSR : 1;              /*!< [10]  */
        uint32_t FRAERREN : 1;         /*!< [11]  */
        uint32_t PARERREN : 1;         /*!< [12]  */
        uint32_t DTREN : 1;            /*!< [13]  */
        uint32_t DPEC : 2;             /*!< [15:14]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ucr3_t;

/*!
 * @name Constants and macros for entire UART_UCR3 register
 */
/*@{*/
#define HW_UART_UCR3_ADDR(x)     ((uintptr_t)(x) + 0x88U)

#define HW_UART_UCR3(x)          (*(__IO hw_uart_ucr3_t *) HW_UART_UCR3_ADDR(x))
#define HW_UART_UCR3_RD(x)       (HW_UART_UCR3(x).U)
#define HW_UART_UCR3_WR(x, v)    (HW_UART_UCR3(x).U = (v))
#define HW_UART_UCR3_SET(x, v)   (HW_UART_UCR3_WR(x, HW_UART_UCR3_RD(x) |  (v)))
#define HW_UART_UCR3_CLR(x, v)   (HW_UART_UCR3_WR(x, HW_UART_UCR3_RD(x) & ~(v)))
#define HW_UART_UCR3_TOG(x, v)   (HW_UART_UCR3_WR(x, HW_UART_UCR3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UCR3 bitfields
 */

/*!
 * @name Register UART_UCR3, field ACIEN[0] (RW)
 *
 * Autobaud Counter Interrupt Enable. This bit is used to enable the autobaud
 * counter stopped interrupt (triggered with ACST (USR2[11]).
 *
 * Values:
 * - 0 - ACST interrupt disabled
 * - 1 - ACST interrupt enabled
 */
/*@{*/
#define BP_UART_UCR3_ACIEN   (0U)          /*!< Bit position for UART_UCR3_ACIEN. */
#define BM_UART_UCR3_ACIEN   (0x00000001U) /*!< Bit mask for UART_UCR3_ACIEN. */
#define BS_UART_UCR3_ACIEN   (1U)          /*!< Bit field size in bits for UART_UCR3_ACIEN. */

/*! @brief Read current value of the UART_UCR3_ACIEN field. */
#define BR_UART_UCR3_ACIEN(x) (HW_UART_UCR3(x).B.ACIEN)

/*! @brief Format value for bitfield UART_UCR3_ACIEN. */
#define BF_UART_UCR3_ACIEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_ACIEN) & BM_UART_UCR3_ACIEN)

/*! @brief Set the ACIEN field to a new value. */
#define BW_UART_UCR3_ACIEN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_ACIEN) | BF_UART_UCR3_ACIEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field INVT[1] (RW)
 *
 * Invert TXD output in RS-232/RS-485 mode, set TXD active level in IrDA mode.
 * In RS232/RS-485 mode(UMCR[0] = 1), if this bit is set to 1, the TXD output is
 * inverted before transmitted. In IrDA mode, when INVT is cleared, the infrared
 * logic block transmits a positive IR 3/16 pulse for all 0s and 0s are
 * transmitted for 1s. When INVT is set (INVT = 1), the infrared logic block transmits an
 * active low or negative infrared 3/16 pulse for all 0s and 1s are transmitted
 * for 1s.
 *
 * Values:
 * - 0 - TXD is not inverted
 * - 1 - TXD is inverted
 * - 0 - TXD Active low transmission
 * - 1 - TXD Active high transmission
 */
/*@{*/
#define BP_UART_UCR3_INVT    (1U)          /*!< Bit position for UART_UCR3_INVT. */
#define BM_UART_UCR3_INVT    (0x00000002U) /*!< Bit mask for UART_UCR3_INVT. */
#define BS_UART_UCR3_INVT    (1U)          /*!< Bit field size in bits for UART_UCR3_INVT. */

/*! @brief Read current value of the UART_UCR3_INVT field. */
#define BR_UART_UCR3_INVT(x) (HW_UART_UCR3(x).B.INVT)

/*! @brief Format value for bitfield UART_UCR3_INVT. */
#define BF_UART_UCR3_INVT(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_INVT) & BM_UART_UCR3_INVT)

/*! @brief Set the INVT field to a new value. */
#define BW_UART_UCR3_INVT(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_INVT) | BF_UART_UCR3_INVT(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field RXDMUXSEL[2] (RW)
 *
 * RXD Muxed Input Selected. Selects proper input pins for serial and Infrared
 * input signal. In this chip, UARTs are used in MUXED mode, so that this bit
 * should always be set.
 */
/*@{*/
#define BP_UART_UCR3_RXDMUXSEL (2U)        /*!< Bit position for UART_UCR3_RXDMUXSEL. */
#define BM_UART_UCR3_RXDMUXSEL (0x00000004U) /*!< Bit mask for UART_UCR3_RXDMUXSEL. */
#define BS_UART_UCR3_RXDMUXSEL (1U)        /*!< Bit field size in bits for UART_UCR3_RXDMUXSEL. */

/*! @brief Read current value of the UART_UCR3_RXDMUXSEL field. */
#define BR_UART_UCR3_RXDMUXSEL(x) (HW_UART_UCR3(x).B.RXDMUXSEL)

/*! @brief Format value for bitfield UART_UCR3_RXDMUXSEL. */
#define BF_UART_UCR3_RXDMUXSEL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_RXDMUXSEL) & BM_UART_UCR3_RXDMUXSEL)

/*! @brief Set the RXDMUXSEL field to a new value. */
#define BW_UART_UCR3_RXDMUXSEL(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_RXDMUXSEL) | BF_UART_UCR3_RXDMUXSEL(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field DTRDEN[3] (RW)
 *
 * Data Terminal Ready Delta Enable. Enables / Disables the asynchronous DTRD
 * interrupt. When DTRDEN is asserted and an edge (rising or falling) is detected
 * on DTR_B (in DCE mode) or on DSR_B (in DTE mode), then an interrupt is
 * generated.
 *
 * Values:
 * - 0 - Disable DTRD interrupt
 * - 1 - Enable DTRD interrupt
 */
/*@{*/
#define BP_UART_UCR3_DTRDEN  (3U)          /*!< Bit position for UART_UCR3_DTRDEN. */
#define BM_UART_UCR3_DTRDEN  (0x00000008U) /*!< Bit mask for UART_UCR3_DTRDEN. */
#define BS_UART_UCR3_DTRDEN  (1U)          /*!< Bit field size in bits for UART_UCR3_DTRDEN. */

/*! @brief Read current value of the UART_UCR3_DTRDEN field. */
#define BR_UART_UCR3_DTRDEN(x) (HW_UART_UCR3(x).B.DTRDEN)

/*! @brief Format value for bitfield UART_UCR3_DTRDEN. */
#define BF_UART_UCR3_DTRDEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_DTRDEN) & BM_UART_UCR3_DTRDEN)

/*! @brief Set the DTRDEN field to a new value. */
#define BW_UART_UCR3_DTRDEN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_DTRDEN) | BF_UART_UCR3_DTRDEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field AWAKEN[4] (RW)
 *
 * Asynchronous WAKE Interrupt Enable. Controls the asynchronous WAKE interrupt.
 * An interrupt is generated when AWAKEN is asserted and a falling edge is
 * detected on the RXD pin.
 *
 * Values:
 * - 0 - Disable the AWAKE interrupt
 * - 1 - Enable the AWAKE interrupt
 */
/*@{*/
#define BP_UART_UCR3_AWAKEN  (4U)          /*!< Bit position for UART_UCR3_AWAKEN. */
#define BM_UART_UCR3_AWAKEN  (0x00000010U) /*!< Bit mask for UART_UCR3_AWAKEN. */
#define BS_UART_UCR3_AWAKEN  (1U)          /*!< Bit field size in bits for UART_UCR3_AWAKEN. */

/*! @brief Read current value of the UART_UCR3_AWAKEN field. */
#define BR_UART_UCR3_AWAKEN(x) (HW_UART_UCR3(x).B.AWAKEN)

/*! @brief Format value for bitfield UART_UCR3_AWAKEN. */
#define BF_UART_UCR3_AWAKEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_AWAKEN) & BM_UART_UCR3_AWAKEN)

/*! @brief Set the AWAKEN field to a new value. */
#define BW_UART_UCR3_AWAKEN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_AWAKEN) | BF_UART_UCR3_AWAKEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field AIRINTEN[5] (RW)
 *
 * Asynchronous IR WAKE Interrupt Enable. Controls the asynchronous IR WAKE
 * interrupt. An interrupt is generated when AIRINTEN is asserted and a pulse is
 * detected on the RXD pin.
 *
 * Values:
 * - 0 - Disable the AIRINT interrupt
 * - 1 - Enable the AIRINT interrupt
 */
/*@{*/
#define BP_UART_UCR3_AIRINTEN (5U)         /*!< Bit position for UART_UCR3_AIRINTEN. */
#define BM_UART_UCR3_AIRINTEN (0x00000020U) /*!< Bit mask for UART_UCR3_AIRINTEN. */
#define BS_UART_UCR3_AIRINTEN (1U)         /*!< Bit field size in bits for UART_UCR3_AIRINTEN. */

/*! @brief Read current value of the UART_UCR3_AIRINTEN field. */
#define BR_UART_UCR3_AIRINTEN(x) (HW_UART_UCR3(x).B.AIRINTEN)

/*! @brief Format value for bitfield UART_UCR3_AIRINTEN. */
#define BF_UART_UCR3_AIRINTEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_AIRINTEN) & BM_UART_UCR3_AIRINTEN)

/*! @brief Set the AIRINTEN field to a new value. */
#define BW_UART_UCR3_AIRINTEN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_AIRINTEN) | BF_UART_UCR3_AIRINTEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field RXDSEN[6] (RW)
 *
 * Receive Status Interrupt Enable. Controls the receive status interrupt (
 * interrupt_uart ). When this bit is enabled and RXDS status bit is set, the
 * interrupt interrupt_uart will be generated.
 *
 * Values:
 * - 0 - Disable the RXDS interrupt
 * - 1 - Enable the RXDS interrupt
 */
/*@{*/
#define BP_UART_UCR3_RXDSEN  (6U)          /*!< Bit position for UART_UCR3_RXDSEN. */
#define BM_UART_UCR3_RXDSEN  (0x00000040U) /*!< Bit mask for UART_UCR3_RXDSEN. */
#define BS_UART_UCR3_RXDSEN  (1U)          /*!< Bit field size in bits for UART_UCR3_RXDSEN. */

/*! @brief Read current value of the UART_UCR3_RXDSEN field. */
#define BR_UART_UCR3_RXDSEN(x) (HW_UART_UCR3(x).B.RXDSEN)

/*! @brief Format value for bitfield UART_UCR3_RXDSEN. */
#define BF_UART_UCR3_RXDSEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_RXDSEN) & BM_UART_UCR3_RXDSEN)

/*! @brief Set the RXDSEN field to a new value. */
#define BW_UART_UCR3_RXDSEN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_RXDSEN) | BF_UART_UCR3_RXDSEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field ADNIMP[7] (RW)
 *
 * Autobaud Detection Not Improved-. Disables new features of autobaud detection
 * (See Baud Rate Automatic Detection ProtocolThe receiver must receive an ASCII
 * character "A" or "a" to verify proper detection of the incoming baud rate.
 * When an ASCII character "A" (0x41) or "a" (0x61) is received and no error
 * occurs, the Automatic Detect baud rate bit is set (ADET=1) and if the interrupt is
 * enabled (ADEN=UCR1[15]=1), an interrupt interrupt_uart is generated. , for more
 * details).
 *
 * Values:
 * - 0 - Autobaud detection new features selected
 * - 1 - Keep old autobaud detection mechanism
 */
/*@{*/
#define BP_UART_UCR3_ADNIMP  (7U)          /*!< Bit position for UART_UCR3_ADNIMP. */
#define BM_UART_UCR3_ADNIMP  (0x00000080U) /*!< Bit mask for UART_UCR3_ADNIMP. */
#define BS_UART_UCR3_ADNIMP  (1U)          /*!< Bit field size in bits for UART_UCR3_ADNIMP. */

/*! @brief Read current value of the UART_UCR3_ADNIMP field. */
#define BR_UART_UCR3_ADNIMP(x) (HW_UART_UCR3(x).B.ADNIMP)

/*! @brief Format value for bitfield UART_UCR3_ADNIMP. */
#define BF_UART_UCR3_ADNIMP(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_ADNIMP) & BM_UART_UCR3_ADNIMP)

/*! @brief Set the ADNIMP field to a new value. */
#define BW_UART_UCR3_ADNIMP(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_ADNIMP) | BF_UART_UCR3_ADNIMP(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field RI[8] (RW)
 *
 * Ring Indicator. In DCE mode this bit is used by software to control the RI_B
 * module output for the modem interface. In DTE mode, when this bit is set, it
 * will enable the status bit RIDELT (USR2 (10)) to cause an interrupt.
 *
 * Values:
 * - 0 - RI_B pin is logic zero (DCE mode)
 * - 1 - RI_B pin is logic one (DCE mode)
 * - 0 - RIDELT interrupt disabled (DTE mode)
 * - 1 - RIDELT interrupt enabled (DTE mode)
 */
/*@{*/
#define BP_UART_UCR3_RI      (8U)          /*!< Bit position for UART_UCR3_RI. */
#define BM_UART_UCR3_RI      (0x00000100U) /*!< Bit mask for UART_UCR3_RI. */
#define BS_UART_UCR3_RI      (1U)          /*!< Bit field size in bits for UART_UCR3_RI. */

/*! @brief Read current value of the UART_UCR3_RI field. */
#define BR_UART_UCR3_RI(x)   (HW_UART_UCR3(x).B.RI)

/*! @brief Format value for bitfield UART_UCR3_RI. */
#define BF_UART_UCR3_RI(v)   ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_RI) & BM_UART_UCR3_RI)

/*! @brief Set the RI field to a new value. */
#define BW_UART_UCR3_RI(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_RI) | BF_UART_UCR3_RI(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field DCD[9] (RW)
 *
 * Data Carrier Detect. In DCE mode this bit is used by software to control the
 * DCD_B module output for the modem interface. In DTE mode, when this bit is
 * set, it will enable the status bit DCDDELT (USR2 (6)) to cause an interrupt.
 *
 * Values:
 * - 0 - DCD_B pin is logic zero (DCE mode)
 * - 1 - DCD_B pin is logic one (DCE mode)
 * - 0 - DCDDELT interrupt disabled (DTE mode)
 * - 1 - DCDDELT interrupt enabled (DTE mode)
 */
/*@{*/
#define BP_UART_UCR3_DCD     (9U)          /*!< Bit position for UART_UCR3_DCD. */
#define BM_UART_UCR3_DCD     (0x00000200U) /*!< Bit mask for UART_UCR3_DCD. */
#define BS_UART_UCR3_DCD     (1U)          /*!< Bit field size in bits for UART_UCR3_DCD. */

/*! @brief Read current value of the UART_UCR3_DCD field. */
#define BR_UART_UCR3_DCD(x)  (HW_UART_UCR3(x).B.DCD)

/*! @brief Format value for bitfield UART_UCR3_DCD. */
#define BF_UART_UCR3_DCD(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_DCD) & BM_UART_UCR3_DCD)

/*! @brief Set the DCD field to a new value. */
#define BW_UART_UCR3_DCD(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_DCD) | BF_UART_UCR3_DCD(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field DSR[10] (RW)
 *
 * Data Set Ready. This bit is used by software to control the DSR/DTR module
 * output for the modem interface. In DCE mode it applies to DSR_B and in DTE mode
 * it applies to DTR_B.
 *
 * Values:
 * - 0 - DSR/ DTR pin is logic zero
 * - 1 - DSR/ DTR pin is logic one
 */
/*@{*/
#define BP_UART_UCR3_DSR     (10U)         /*!< Bit position for UART_UCR3_DSR. */
#define BM_UART_UCR3_DSR     (0x00000400U) /*!< Bit mask for UART_UCR3_DSR. */
#define BS_UART_UCR3_DSR     (1U)          /*!< Bit field size in bits for UART_UCR3_DSR. */

/*! @brief Read current value of the UART_UCR3_DSR field. */
#define BR_UART_UCR3_DSR(x)  (HW_UART_UCR3(x).B.DSR)

/*! @brief Format value for bitfield UART_UCR3_DSR. */
#define BF_UART_UCR3_DSR(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_DSR) & BM_UART_UCR3_DSR)

/*! @brief Set the DSR field to a new value. */
#define BW_UART_UCR3_DSR(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_DSR) | BF_UART_UCR3_DSR(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field FRAERREN[11] (RW)
 *
 * Frame Error Interrupt Enable. Enables/Disables the interrupt. When asserted,
 * FRAERREN causes the FRAMERR bit to generate an interrupt.
 *
 * Values:
 * - 0 - Disable the frame error interrupt
 * - 1 - Enable the frame error interrupt
 */
/*@{*/
#define BP_UART_UCR3_FRAERREN (11U)        /*!< Bit position for UART_UCR3_FRAERREN. */
#define BM_UART_UCR3_FRAERREN (0x00000800U) /*!< Bit mask for UART_UCR3_FRAERREN. */
#define BS_UART_UCR3_FRAERREN (1U)         /*!< Bit field size in bits for UART_UCR3_FRAERREN. */

/*! @brief Read current value of the UART_UCR3_FRAERREN field. */
#define BR_UART_UCR3_FRAERREN(x) (HW_UART_UCR3(x).B.FRAERREN)

/*! @brief Format value for bitfield UART_UCR3_FRAERREN. */
#define BF_UART_UCR3_FRAERREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_FRAERREN) & BM_UART_UCR3_FRAERREN)

/*! @brief Set the FRAERREN field to a new value. */
#define BW_UART_UCR3_FRAERREN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_FRAERREN) | BF_UART_UCR3_FRAERREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field PARERREN[12] (RW)
 *
 * Parity Error Interrupt Enable. Enables/Disables the interrupt. When asserted,
 * PARERREN causes the PARITYERR bit to generate an interrupt.
 *
 * Values:
 * - 0 - Disable the parity error interrupt
 * - 1 - Enable the parity error interrupt
 */
/*@{*/
#define BP_UART_UCR3_PARERREN (12U)        /*!< Bit position for UART_UCR3_PARERREN. */
#define BM_UART_UCR3_PARERREN (0x00001000U) /*!< Bit mask for UART_UCR3_PARERREN. */
#define BS_UART_UCR3_PARERREN (1U)         /*!< Bit field size in bits for UART_UCR3_PARERREN. */

/*! @brief Read current value of the UART_UCR3_PARERREN field. */
#define BR_UART_UCR3_PARERREN(x) (HW_UART_UCR3(x).B.PARERREN)

/*! @brief Format value for bitfield UART_UCR3_PARERREN. */
#define BF_UART_UCR3_PARERREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_PARERREN) & BM_UART_UCR3_PARERREN)

/*! @brief Set the PARERREN field to a new value. */
#define BW_UART_UCR3_PARERREN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_PARERREN) | BF_UART_UCR3_PARERREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field DTREN[13] (RW)
 *
 * Data Terminal Ready Interrupt Enable. When this bit is set, it will enable
 * the status bit DTRF (USR2 [13]) (DTR/DSR edge sensitive interrupt) to cause an
 * interrupt.
 *
 * Values:
 * - 0 - Data Terminal Ready Interrupt Disabled
 * - 1 - Data Terminal Ready Interrupt Enabled
 */
/*@{*/
#define BP_UART_UCR3_DTREN   (13U)         /*!< Bit position for UART_UCR3_DTREN. */
#define BM_UART_UCR3_DTREN   (0x00002000U) /*!< Bit mask for UART_UCR3_DTREN. */
#define BS_UART_UCR3_DTREN   (1U)          /*!< Bit field size in bits for UART_UCR3_DTREN. */

/*! @brief Read current value of the UART_UCR3_DTREN field. */
#define BR_UART_UCR3_DTREN(x) (HW_UART_UCR3(x).B.DTREN)

/*! @brief Format value for bitfield UART_UCR3_DTREN. */
#define BF_UART_UCR3_DTREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_DTREN) & BM_UART_UCR3_DTREN)

/*! @brief Set the DTREN field to a new value. */
#define BW_UART_UCR3_DTREN(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_DTREN) | BF_UART_UCR3_DTREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR3, field DPEC[15:14] (RW)
 *
 * DTR/DSR Interrupt Edge Control. These bits control the edge of DTR_B (DCE) or
 * DSR_B (DTE) on which an interrupt will be generated. An interrupt will only
 * be generated if the DTREN bit is set.
 *
 * Values:
 * - 00 - interrupt generated on rising edge
 * - 01 - interrupt generated on falling edge
 */
/*@{*/
#define BP_UART_UCR3_DPEC    (14U)         /*!< Bit position for UART_UCR3_DPEC. */
#define BM_UART_UCR3_DPEC    (0x0000C000U) /*!< Bit mask for UART_UCR3_DPEC. */
#define BS_UART_UCR3_DPEC    (2U)          /*!< Bit field size in bits for UART_UCR3_DPEC. */

/*! @brief Read current value of the UART_UCR3_DPEC field. */
#define BR_UART_UCR3_DPEC(x) (HW_UART_UCR3(x).B.DPEC)

/*! @brief Format value for bitfield UART_UCR3_DPEC. */
#define BF_UART_UCR3_DPEC(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR3_DPEC) & BM_UART_UCR3_DPEC)

/*! @brief Set the DPEC field to a new value. */
#define BW_UART_UCR3_DPEC(x, v) (HW_UART_UCR3_WR(x, (HW_UART_UCR3_RD(x) & ~BM_UART_UCR3_DPEC) | BF_UART_UCR3_DPEC(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UCR4 - UART Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_UART_UCR4 - UART Control Register 4 (RW)
 *
 * Reset value: 0x00008000U
 */
typedef union _hw_uart_ucr4
{
    uint32_t U;
    struct _hw_uart_ucr4_bitfields
    {
        uint32_t DREN : 1;             /*!< [0]  */
        uint32_t OREN : 1;             /*!< [1]  */
        uint32_t BKEN : 1;             /*!< [2]  */
        uint32_t TCEN : 1;             /*!< [3]  */
        uint32_t LPBYP : 1;            /*!< [4]  */
        uint32_t IRSC : 1;             /*!< [5]  */
        uint32_t IDDMAEN : 1;          /*!< [6]  */
        uint32_t WKEN : 1;             /*!< [7]  */
        uint32_t ENIRI : 1;            /*!< [8]  */
        uint32_t INVR : 1;             /*!< [9]  */
        uint32_t CTSTL : 6;            /*!< [15:10]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ucr4_t;

/*!
 * @name Constants and macros for entire UART_UCR4 register
 */
/*@{*/
#define HW_UART_UCR4_ADDR(x)     ((uintptr_t)(x) + 0x8CU)

#define HW_UART_UCR4(x)          (*(__IO hw_uart_ucr4_t *) HW_UART_UCR4_ADDR(x))
#define HW_UART_UCR4_RD(x)       (HW_UART_UCR4(x).U)
#define HW_UART_UCR4_WR(x, v)    (HW_UART_UCR4(x).U = (v))
#define HW_UART_UCR4_SET(x, v)   (HW_UART_UCR4_WR(x, HW_UART_UCR4_RD(x) |  (v)))
#define HW_UART_UCR4_CLR(x, v)   (HW_UART_UCR4_WR(x, HW_UART_UCR4_RD(x) & ~(v)))
#define HW_UART_UCR4_TOG(x, v)   (HW_UART_UCR4_WR(x, HW_UART_UCR4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UCR4 bitfields
 */

/*!
 * @name Register UART_UCR4, field DREN[0] (RW)
 *
 * Receive Data Ready Interrupt Enable. Enables/Disables the RDR bit to generate
 * an interrupt.
 *
 * Values:
 * - 0 - Disable RDR interrupt
 * - 1 - Enable RDR interrupt
 */
/*@{*/
#define BP_UART_UCR4_DREN    (0U)          /*!< Bit position for UART_UCR4_DREN. */
#define BM_UART_UCR4_DREN    (0x00000001U) /*!< Bit mask for UART_UCR4_DREN. */
#define BS_UART_UCR4_DREN    (1U)          /*!< Bit field size in bits for UART_UCR4_DREN. */

/*! @brief Read current value of the UART_UCR4_DREN field. */
#define BR_UART_UCR4_DREN(x) (HW_UART_UCR4(x).B.DREN)

/*! @brief Format value for bitfield UART_UCR4_DREN. */
#define BF_UART_UCR4_DREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_DREN) & BM_UART_UCR4_DREN)

/*! @brief Set the DREN field to a new value. */
#define BW_UART_UCR4_DREN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_DREN) | BF_UART_UCR4_DREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field OREN[1] (RW)
 *
 * Receiver Overrun Interrupt Enable. Enables/Disables the ORE bit to generate
 * an interrupt.
 *
 * Values:
 * - 0 - Disable ORE interrupt
 * - 1 - Enable ORE interrupt
 */
/*@{*/
#define BP_UART_UCR4_OREN    (1U)          /*!< Bit position for UART_UCR4_OREN. */
#define BM_UART_UCR4_OREN    (0x00000002U) /*!< Bit mask for UART_UCR4_OREN. */
#define BS_UART_UCR4_OREN    (1U)          /*!< Bit field size in bits for UART_UCR4_OREN. */

/*! @brief Read current value of the UART_UCR4_OREN field. */
#define BR_UART_UCR4_OREN(x) (HW_UART_UCR4(x).B.OREN)

/*! @brief Format value for bitfield UART_UCR4_OREN. */
#define BF_UART_UCR4_OREN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_OREN) & BM_UART_UCR4_OREN)

/*! @brief Set the OREN field to a new value. */
#define BW_UART_UCR4_OREN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_OREN) | BF_UART_UCR4_OREN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field BKEN[2] (RW)
 *
 * BREAK Condition Detected Interrupt Enable. Enables/Disables the BRCD bit to
 * generate an interrupt.
 *
 * Values:
 * - 0 - Disable the BRCD interrupt
 * - 1 - Enable the BRCD interrupt
 */
/*@{*/
#define BP_UART_UCR4_BKEN    (2U)          /*!< Bit position for UART_UCR4_BKEN. */
#define BM_UART_UCR4_BKEN    (0x00000004U) /*!< Bit mask for UART_UCR4_BKEN. */
#define BS_UART_UCR4_BKEN    (1U)          /*!< Bit field size in bits for UART_UCR4_BKEN. */

/*! @brief Read current value of the UART_UCR4_BKEN field. */
#define BR_UART_UCR4_BKEN(x) (HW_UART_UCR4(x).B.BKEN)

/*! @brief Format value for bitfield UART_UCR4_BKEN. */
#define BF_UART_UCR4_BKEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_BKEN) & BM_UART_UCR4_BKEN)

/*! @brief Set the BKEN field to a new value. */
#define BW_UART_UCR4_BKEN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_BKEN) | BF_UART_UCR4_BKEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field TCEN[3] (RW)
 *
 * Transmit Complete Interrupt Enable. Enables/Disables the TXDC bit to generate
 * an interrupt ( interrupt_uart = 0) An interrupt will be issued as long as
 * TCEN and TXDC are high even if the transmitter is not enabled. In general, user
 * should enable the transmitter before enabling the TXDC interrupt.
 *
 * Values:
 * - 0 - Disable TXDC interrupt
 * - 1 - Enable TXDC interrupt
 */
/*@{*/
#define BP_UART_UCR4_TCEN    (3U)          /*!< Bit position for UART_UCR4_TCEN. */
#define BM_UART_UCR4_TCEN    (0x00000008U) /*!< Bit mask for UART_UCR4_TCEN. */
#define BS_UART_UCR4_TCEN    (1U)          /*!< Bit field size in bits for UART_UCR4_TCEN. */

/*! @brief Read current value of the UART_UCR4_TCEN field. */
#define BR_UART_UCR4_TCEN(x) (HW_UART_UCR4(x).B.TCEN)

/*! @brief Format value for bitfield UART_UCR4_TCEN. */
#define BF_UART_UCR4_TCEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_TCEN) & BM_UART_UCR4_TCEN)

/*! @brief Set the TCEN field to a new value. */
#define BW_UART_UCR4_TCEN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_TCEN) | BF_UART_UCR4_TCEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field LPBYP[4] (RW)
 *
 * Low Power Bypass. Allows to bypass the low power new features in UART. To use
 * during debug phase.
 *
 * Values:
 * - 0 - Low power features enabled
 * - 1 - Low power features disabled
 */
/*@{*/
#define BP_UART_UCR4_LPBYP   (4U)          /*!< Bit position for UART_UCR4_LPBYP. */
#define BM_UART_UCR4_LPBYP   (0x00000010U) /*!< Bit mask for UART_UCR4_LPBYP. */
#define BS_UART_UCR4_LPBYP   (1U)          /*!< Bit field size in bits for UART_UCR4_LPBYP. */

/*! @brief Read current value of the UART_UCR4_LPBYP field. */
#define BR_UART_UCR4_LPBYP(x) (HW_UART_UCR4(x).B.LPBYP)

/*! @brief Format value for bitfield UART_UCR4_LPBYP. */
#define BF_UART_UCR4_LPBYP(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_LPBYP) & BM_UART_UCR4_LPBYP)

/*! @brief Set the LPBYP field to a new value. */
#define BW_UART_UCR4_LPBYP(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_LPBYP) | BF_UART_UCR4_LPBYP(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field IRSC[5] (RW)
 *
 * IR Special Case. Selects the clock for the vote logic. When set, IRSC
 * switches the vote logic clock from the sampling clock to the UART reference clock.
 * The IR pulses are counted a predetermined amount of time depending on the
 * reference frequency. See InfraRed Special Case (IRSC) BitThe value to apply to IRSC
 * bit is based on 2 parameters: the baud rate and the Minimum Pulse Duration
 * (MPD) of the transceiver. .
 *
 * Values:
 * - 0 - The vote logic uses the sampling clock (16x baud rate) for normal
 *     operation
 * - 1 - The vote logic uses the UART reference clock
 */
/*@{*/
#define BP_UART_UCR4_IRSC    (5U)          /*!< Bit position for UART_UCR4_IRSC. */
#define BM_UART_UCR4_IRSC    (0x00000020U) /*!< Bit mask for UART_UCR4_IRSC. */
#define BS_UART_UCR4_IRSC    (1U)          /*!< Bit field size in bits for UART_UCR4_IRSC. */

/*! @brief Read current value of the UART_UCR4_IRSC field. */
#define BR_UART_UCR4_IRSC(x) (HW_UART_UCR4(x).B.IRSC)

/*! @brief Format value for bitfield UART_UCR4_IRSC. */
#define BF_UART_UCR4_IRSC(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_IRSC) & BM_UART_UCR4_IRSC)

/*! @brief Set the IRSC field to a new value. */
#define BW_UART_UCR4_IRSC(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_IRSC) | BF_UART_UCR4_IRSC(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field IDDMAEN[6] (RW)
 *
 * DMA IDLE Condition Detected Interrupt Enable Enables/Disables the receive DMA
 * request dma_req_rx for the IDLE interrupt (triggered with IDLE flag in
 * USR2[12]).
 *
 * Values:
 * - 0 - DMA IDLE interrupt disabled
 * - 1 - DMA IDLE interrupt enabled
 */
/*@{*/
#define BP_UART_UCR4_IDDMAEN (6U)          /*!< Bit position for UART_UCR4_IDDMAEN. */
#define BM_UART_UCR4_IDDMAEN (0x00000040U) /*!< Bit mask for UART_UCR4_IDDMAEN. */
#define BS_UART_UCR4_IDDMAEN (1U)          /*!< Bit field size in bits for UART_UCR4_IDDMAEN. */

/*! @brief Read current value of the UART_UCR4_IDDMAEN field. */
#define BR_UART_UCR4_IDDMAEN(x) (HW_UART_UCR4(x).B.IDDMAEN)

/*! @brief Format value for bitfield UART_UCR4_IDDMAEN. */
#define BF_UART_UCR4_IDDMAEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_IDDMAEN) & BM_UART_UCR4_IDDMAEN)

/*! @brief Set the IDDMAEN field to a new value. */
#define BW_UART_UCR4_IDDMAEN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_IDDMAEN) | BF_UART_UCR4_IDDMAEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field WKEN[7] (RW)
 *
 * WAKE Interrupt Enable. Enables/Disables the WAKE bit to generate an
 * interrupt. The WAKE bit is set at the detection of a start bit by the receiver.
 *
 * Values:
 * - 0 - Disable the WAKE interrupt
 * - 1 - Enable the WAKE interrupt
 */
/*@{*/
#define BP_UART_UCR4_WKEN    (7U)          /*!< Bit position for UART_UCR4_WKEN. */
#define BM_UART_UCR4_WKEN    (0x00000080U) /*!< Bit mask for UART_UCR4_WKEN. */
#define BS_UART_UCR4_WKEN    (1U)          /*!< Bit field size in bits for UART_UCR4_WKEN. */

/*! @brief Read current value of the UART_UCR4_WKEN field. */
#define BR_UART_UCR4_WKEN(x) (HW_UART_UCR4(x).B.WKEN)

/*! @brief Format value for bitfield UART_UCR4_WKEN. */
#define BF_UART_UCR4_WKEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_WKEN) & BM_UART_UCR4_WKEN)

/*! @brief Set the WKEN field to a new value. */
#define BW_UART_UCR4_WKEN(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_WKEN) | BF_UART_UCR4_WKEN(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field ENIRI[8] (RW)
 *
 * Serial Infrared Interrupt Enable. Enables/Disables the serial infrared
 * interrupt.
 *
 * Values:
 * - 0 - Serial infrared Interrupt disabled
 * - 1 - Serial infrared Interrupt enabled
 */
/*@{*/
#define BP_UART_UCR4_ENIRI   (8U)          /*!< Bit position for UART_UCR4_ENIRI. */
#define BM_UART_UCR4_ENIRI   (0x00000100U) /*!< Bit mask for UART_UCR4_ENIRI. */
#define BS_UART_UCR4_ENIRI   (1U)          /*!< Bit field size in bits for UART_UCR4_ENIRI. */

/*! @brief Read current value of the UART_UCR4_ENIRI field. */
#define BR_UART_UCR4_ENIRI(x) (HW_UART_UCR4(x).B.ENIRI)

/*! @brief Format value for bitfield UART_UCR4_ENIRI. */
#define BF_UART_UCR4_ENIRI(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_ENIRI) & BM_UART_UCR4_ENIRI)

/*! @brief Set the ENIRI field to a new value. */
#define BW_UART_UCR4_ENIRI(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_ENIRI) | BF_UART_UCR4_ENIRI(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field INVR[9] (RW)
 *
 * Invert RXD input in RS-232/RS-485 Mode, determine RXD input logic level being
 * sampled in In IrDA mode. In RS232/RS-485 Mode(UMCR[0] = 1), if this bit is
 * set to 1, the RXD input is inverted before sampled. In IrDA mode,when cleared,
 * the infrared logic block expects an active low or negative IR 3/16 pulse for 0s
 * and 1s are expected for 1s. When INVR is set (INVR 1), the infrared logic
 * block expects an active high or positive IR 3/16 pulse for 0s and 0s are expected
 * for 1s.
 *
 * Values:
 * - 0 - RXD input is not inverted
 * - 1 - RXD input is inverted
 * - 0 - RXD active low detection
 * - 1 - RXD active high detection
 */
/*@{*/
#define BP_UART_UCR4_INVR    (9U)          /*!< Bit position for UART_UCR4_INVR. */
#define BM_UART_UCR4_INVR    (0x00000200U) /*!< Bit mask for UART_UCR4_INVR. */
#define BS_UART_UCR4_INVR    (1U)          /*!< Bit field size in bits for UART_UCR4_INVR. */

/*! @brief Read current value of the UART_UCR4_INVR field. */
#define BR_UART_UCR4_INVR(x) (HW_UART_UCR4(x).B.INVR)

/*! @brief Format value for bitfield UART_UCR4_INVR. */
#define BF_UART_UCR4_INVR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_INVR) & BM_UART_UCR4_INVR)

/*! @brief Set the INVR field to a new value. */
#define BW_UART_UCR4_INVR(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_INVR) | BF_UART_UCR4_INVR(v)))
/*@}*/

/*!
 * @name Register UART_UCR4, field CTSTL[15:10] (RW)
 *
 * CTS Trigger Level. Controls the threshold at which the CTS_B pin is
 * deasserted by the RxFIFO. After the trigger level is reached and the CTS_B pin is
 * deasserted, the RxFIFO continues to receive data until it is full. The CTSTL bits
 * are encoded as shown in the Settings column. Settings 0 to 32 are in use. All
 * other settings are Reserved.
 *
 * Values:
 * - 000000 - 0 characters received
 * - 000001 - 1 characters in the RxFIFO
 * - 100000 - 32 characters in the RxFIFO (maximum)
 */
/*@{*/
#define BP_UART_UCR4_CTSTL   (10U)         /*!< Bit position for UART_UCR4_CTSTL. */
#define BM_UART_UCR4_CTSTL   (0x0000FC00U) /*!< Bit mask for UART_UCR4_CTSTL. */
#define BS_UART_UCR4_CTSTL   (6U)          /*!< Bit field size in bits for UART_UCR4_CTSTL. */

/*! @brief Read current value of the UART_UCR4_CTSTL field. */
#define BR_UART_UCR4_CTSTL(x) (HW_UART_UCR4(x).B.CTSTL)

/*! @brief Format value for bitfield UART_UCR4_CTSTL. */
#define BF_UART_UCR4_CTSTL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UCR4_CTSTL) & BM_UART_UCR4_CTSTL)

/*! @brief Set the CTSTL field to a new value. */
#define BW_UART_UCR4_CTSTL(x, v) (HW_UART_UCR4_WR(x, (HW_UART_UCR4_RD(x) & ~BM_UART_UCR4_CTSTL) | BF_UART_UCR4_CTSTL(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UFCR - UART FIFO Control Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UFCR - UART FIFO Control Register (RW)
 *
 * Reset value: 0x00000801U
 */
typedef union _hw_uart_ufcr
{
    uint32_t U;
    struct _hw_uart_ufcr_bitfields
    {
        uint32_t RXTL : 6;             /*!< [5:0]  */
        uint32_t DCEDTE : 1;           /*!< [6]  */
        uint32_t RFDIV : 3;            /*!< [9:7]  */
        uint32_t TXTL : 6;             /*!< [15:10]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ufcr_t;

/*!
 * @name Constants and macros for entire UART_UFCR register
 */
/*@{*/
#define HW_UART_UFCR_ADDR(x)     ((uintptr_t)(x) + 0x90U)

#define HW_UART_UFCR(x)          (*(__IO hw_uart_ufcr_t *) HW_UART_UFCR_ADDR(x))
#define HW_UART_UFCR_RD(x)       (HW_UART_UFCR(x).U)
#define HW_UART_UFCR_WR(x, v)    (HW_UART_UFCR(x).U = (v))
#define HW_UART_UFCR_SET(x, v)   (HW_UART_UFCR_WR(x, HW_UART_UFCR_RD(x) |  (v)))
#define HW_UART_UFCR_CLR(x, v)   (HW_UART_UFCR_WR(x, HW_UART_UFCR_RD(x) & ~(v)))
#define HW_UART_UFCR_TOG(x, v)   (HW_UART_UFCR_WR(x, HW_UART_UFCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UFCR bitfields
 */

/*!
 * @name Register UART_UFCR, field RXTL[5:0] (RW)
 *
 * Receiver Trigger Level. Controls the threshold at which a maskable interrupt
 * is generated by the RxFIFO. A maskable interrupt is generated whenever the
 * data level in the RxFIFO reaches the selected threshold. The RXTL bits are
 * encoded as shown in the Settings column. Setting 0 to 32 are in use. All other
 * settings are Reserved.
 *
 * Values:
 * - 000000 - 0 characters received
 * - 000001 - RxFIFO has 1 character
 * - 011111 - RxFIFO has 31 characters
 * - 100000 - RxFIFO has 32 characters (maximum)
 */
/*@{*/
#define BP_UART_UFCR_RXTL    (0U)          /*!< Bit position for UART_UFCR_RXTL. */
#define BM_UART_UFCR_RXTL    (0x0000003FU) /*!< Bit mask for UART_UFCR_RXTL. */
#define BS_UART_UFCR_RXTL    (6U)          /*!< Bit field size in bits for UART_UFCR_RXTL. */

/*! @brief Read current value of the UART_UFCR_RXTL field. */
#define BR_UART_UFCR_RXTL(x) (HW_UART_UFCR(x).B.RXTL)

/*! @brief Format value for bitfield UART_UFCR_RXTL. */
#define BF_UART_UFCR_RXTL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UFCR_RXTL) & BM_UART_UFCR_RXTL)

/*! @brief Set the RXTL field to a new value. */
#define BW_UART_UFCR_RXTL(x, v) (HW_UART_UFCR_WR(x, (HW_UART_UFCR_RD(x) & ~BM_UART_UFCR_RXTL) | BF_UART_UFCR_RXTL(v)))
/*@}*/

/*!
 * @name Register UART_UFCR, field DCEDTE[6] (RW)
 *
 * DCE/DTE mode select. Select UART as data communication equipment (DCE mode)
 * or as data terminal equipment (DTE mode).
 *
 * Values:
 * - 0 - DCE mode selected
 * - 1 - DTE mode selected
 */
/*@{*/
#define BP_UART_UFCR_DCEDTE  (6U)          /*!< Bit position for UART_UFCR_DCEDTE. */
#define BM_UART_UFCR_DCEDTE  (0x00000040U) /*!< Bit mask for UART_UFCR_DCEDTE. */
#define BS_UART_UFCR_DCEDTE  (1U)          /*!< Bit field size in bits for UART_UFCR_DCEDTE. */

/*! @brief Read current value of the UART_UFCR_DCEDTE field. */
#define BR_UART_UFCR_DCEDTE(x) (HW_UART_UFCR(x).B.DCEDTE)

/*! @brief Format value for bitfield UART_UFCR_DCEDTE. */
#define BF_UART_UFCR_DCEDTE(v) ((uint32_t)((uint32_t)(v) << BP_UART_UFCR_DCEDTE) & BM_UART_UFCR_DCEDTE)

/*! @brief Set the DCEDTE field to a new value. */
#define BW_UART_UFCR_DCEDTE(x, v) (HW_UART_UFCR_WR(x, (HW_UART_UFCR_RD(x) & ~BM_UART_UFCR_DCEDTE) | BF_UART_UFCR_DCEDTE(v)))
/*@}*/

/*!
 * @name Register UART_UFCR, field RFDIV[9:7] (RW)
 *
 * Reference Frequency Divider. Controls the divide ratio for the reference
 * clock. The input clock is module_clock. The output from the divider is ref_clk
 * which is used by BRM to create the 16x baud rate oversampling clock (brm_clk).
 *
 * Values:
 * - 000 - Divide input clock by 6
 * - 001 - Divide input clock by 5
 * - 010 - Divide input clock by 4
 * - 011 - Divide input clock by 3
 * - 100 - Divide input clock by 2
 * - 101 - Divide input clock by 1
 * - 110 - Divide input clock by 7
 * - 111 - Reserved
 */
/*@{*/
#define BP_UART_UFCR_RFDIV   (7U)          /*!< Bit position for UART_UFCR_RFDIV. */
#define BM_UART_UFCR_RFDIV   (0x00000380U) /*!< Bit mask for UART_UFCR_RFDIV. */
#define BS_UART_UFCR_RFDIV   (3U)          /*!< Bit field size in bits for UART_UFCR_RFDIV. */

/*! @brief Read current value of the UART_UFCR_RFDIV field. */
#define BR_UART_UFCR_RFDIV(x) (HW_UART_UFCR(x).B.RFDIV)

/*! @brief Format value for bitfield UART_UFCR_RFDIV. */
#define BF_UART_UFCR_RFDIV(v) ((uint32_t)((uint32_t)(v) << BP_UART_UFCR_RFDIV) & BM_UART_UFCR_RFDIV)

/*! @brief Set the RFDIV field to a new value. */
#define BW_UART_UFCR_RFDIV(x, v) (HW_UART_UFCR_WR(x, (HW_UART_UFCR_RD(x) & ~BM_UART_UFCR_RFDIV) | BF_UART_UFCR_RFDIV(v)))
/*@}*/

/*!
 * @name Register UART_UFCR, field TXTL[15:10] (RW)
 *
 * Transmitter Trigger Level. Controls the threshold at which a maskable
 * interrupt is generated by the TxFIFO. A maskable interrupt is generated whenever the
 * data level in the TxFIFO falls below the selected threshold. The bits are
 * encoded as shown in the Settings column. Settings 0 to 32 are in use. All other
 * settings are Reserved.
 *
 * Values:
 * - 000000 - Reserved
 * - 000001 - Reserved
 * - 000010 - TxFIFO has 2 or fewer characters
 * - 011111 - TxFIFO has 31 or fewer characters
 * - 100000 - TxFIFO has 32 characters (maximum)
 */
/*@{*/
#define BP_UART_UFCR_TXTL    (10U)         /*!< Bit position for UART_UFCR_TXTL. */
#define BM_UART_UFCR_TXTL    (0x0000FC00U) /*!< Bit mask for UART_UFCR_TXTL. */
#define BS_UART_UFCR_TXTL    (6U)          /*!< Bit field size in bits for UART_UFCR_TXTL. */

/*! @brief Read current value of the UART_UFCR_TXTL field. */
#define BR_UART_UFCR_TXTL(x) (HW_UART_UFCR(x).B.TXTL)

/*! @brief Format value for bitfield UART_UFCR_TXTL. */
#define BF_UART_UFCR_TXTL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UFCR_TXTL) & BM_UART_UFCR_TXTL)

/*! @brief Set the TXTL field to a new value. */
#define BW_UART_UFCR_TXTL(x, v) (HW_UART_UFCR_WR(x, (HW_UART_UFCR_RD(x) & ~BM_UART_UFCR_TXTL) | BF_UART_UFCR_TXTL(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_USR1 - UART Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_UART_USR1 - UART Status Register 1 (RW)
 *
 * Reset value: 0x00002040U
 */
typedef union _hw_uart_usr1
{
    uint32_t U;
    struct _hw_uart_usr1_bitfields
    {
        uint32_t RESERVED0 : 3;        /*!< [2:0]  */
        uint32_t SAD : 1;              /*!< [3]  */
        uint32_t AWAKE : 1;            /*!< [4]  */
        uint32_t AIRINT : 1;           /*!< [5]  */
        uint32_t RXDS : 1;             /*!< [6]  */
        uint32_t DTRD : 1;             /*!< [7]  */
        uint32_t AGTIM : 1;            /*!< [8]  */
        uint32_t RRDY : 1;             /*!< [9]  */
        uint32_t FRAMERR : 1;          /*!< [10]  */
        uint32_t ESCF : 1;             /*!< [11]  */
        uint32_t RTSD : 1;             /*!< [12]  */
        uint32_t TRDY : 1;             /*!< [13]  */
        uint32_t RTSS : 1;             /*!< [14]  */
        uint32_t PARITYERR : 1;        /*!< [15]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_usr1_t;

/*!
 * @name Constants and macros for entire UART_USR1 register
 */
/*@{*/
#define HW_UART_USR1_ADDR(x)     ((uintptr_t)(x) + 0x94U)

#define HW_UART_USR1(x)          (*(__IO hw_uart_usr1_t *) HW_UART_USR1_ADDR(x))
#define HW_UART_USR1_RD(x)       (HW_UART_USR1(x).U)
#define HW_UART_USR1_WR(x, v)    (HW_UART_USR1(x).U = (v))
#define HW_UART_USR1_SET(x, v)   (HW_UART_USR1_WR(x, HW_UART_USR1_RD(x) |  (v)))
#define HW_UART_USR1_CLR(x, v)   (HW_UART_USR1_WR(x, HW_UART_USR1_RD(x) & ~(v)))
#define HW_UART_USR1_TOG(x, v)   (HW_UART_USR1_WR(x, HW_UART_USR1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_USR1 bitfields
 */

/*!
 * @name Register UART_USR1, field SAD[3] (W1C)
 *
 * RS-485 Slave Address Detected Interrupt Flag. Indicates if RS-485 Slave
 * Address was detected . SAD was asserted in RS-485 mode when the SADEN bit is set
 * and Slave Address is detected in RxFIFO (in Nomal Address Detect Mode, the 9th
 * data bit = 1; in Automatic Address Detect Mode, the received charater matches
 * the programmed SLADDR).
 *
 * Values:
 * - 0 - No slave address detected
 * - 1 - Slave address detected
 */
/*@{*/
#define BP_UART_USR1_SAD     (3U)          /*!< Bit position for UART_USR1_SAD. */
#define BM_UART_USR1_SAD     (0x00000008U) /*!< Bit mask for UART_USR1_SAD. */
#define BS_UART_USR1_SAD     (1U)          /*!< Bit field size in bits for UART_USR1_SAD. */

/*! @brief Read current value of the UART_USR1_SAD field. */
#define BR_UART_USR1_SAD(x)  (HW_UART_USR1(x).B.SAD)

/*! @brief Format value for bitfield UART_USR1_SAD. */
#define BF_UART_USR1_SAD(v)  ((uint32_t)((uint32_t)(v) << BP_UART_USR1_SAD) & BM_UART_USR1_SAD)

/*! @brief Set the SAD field to a new value. */
#define BW_UART_USR1_SAD(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_SAD(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field AWAKE[4] (W1C)
 *
 * Asynchronous WAKE Interrupt Flag. Indicates that a falling edge was detected
 * on the RXD pin. Clear AWAKE by writing 1 to it. Writing 0 to AWAKE has no
 * effect.
 *
 * Values:
 * - 0 - No falling edge was detected on the RXD Serial pin
 * - 1 - A falling edge was detected on the RXD Serial pin
 */
/*@{*/
#define BP_UART_USR1_AWAKE   (4U)          /*!< Bit position for UART_USR1_AWAKE. */
#define BM_UART_USR1_AWAKE   (0x00000010U) /*!< Bit mask for UART_USR1_AWAKE. */
#define BS_UART_USR1_AWAKE   (1U)          /*!< Bit field size in bits for UART_USR1_AWAKE. */

/*! @brief Read current value of the UART_USR1_AWAKE field. */
#define BR_UART_USR1_AWAKE(x) (HW_UART_USR1(x).B.AWAKE)

/*! @brief Format value for bitfield UART_USR1_AWAKE. */
#define BF_UART_USR1_AWAKE(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_AWAKE) & BM_UART_USR1_AWAKE)

/*! @brief Set the AWAKE field to a new value. */
#define BW_UART_USR1_AWAKE(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_AWAKE | BM_UART_USR1_SAD | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_AWAKE(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field AIRINT[5] (W1C)
 *
 * Asynchronous IR WAKE Interrupt Flag. Indicates that the IR WAKE pulse was
 * detected on the RXD pin. Clear AIRINT by writing 1 to it. Writing 0 to AIRINT has
 * no effect.
 *
 * Values:
 * - 0 - No pulse was detected on the RXD IrDA pin
 * - 1 - A pulse was detected on the RXD IrDA pin
 */
/*@{*/
#define BP_UART_USR1_AIRINT  (5U)          /*!< Bit position for UART_USR1_AIRINT. */
#define BM_UART_USR1_AIRINT  (0x00000020U) /*!< Bit mask for UART_USR1_AIRINT. */
#define BS_UART_USR1_AIRINT  (1U)          /*!< Bit field size in bits for UART_USR1_AIRINT. */

/*! @brief Read current value of the UART_USR1_AIRINT field. */
#define BR_UART_USR1_AIRINT(x) (HW_UART_USR1(x).B.AIRINT)

/*! @brief Format value for bitfield UART_USR1_AIRINT. */
#define BF_UART_USR1_AIRINT(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_AIRINT) & BM_UART_USR1_AIRINT)

/*! @brief Set the AIRINT field to a new value. */
#define BW_UART_USR1_AIRINT(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_AIRINT | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_AIRINT(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field RXDS[6] (RO)
 *
 * Receiver IDLE Interrupt Flag. Indicates that the receiver state machine is in
 * an IDLE state, the next state is IDLE, and the receive pin is high. RXDS is
 * automatically cleared when a character is received. RXDS is active only when
 * the receiver is enabled.
 *
 * Values:
 * - 0 - Receive in progress
 * - 1 - Receiver is IDLE
 */
/*@{*/
#define BP_UART_USR1_RXDS    (6U)          /*!< Bit position for UART_USR1_RXDS. */
#define BM_UART_USR1_RXDS    (0x00000040U) /*!< Bit mask for UART_USR1_RXDS. */
#define BS_UART_USR1_RXDS    (1U)          /*!< Bit field size in bits for UART_USR1_RXDS. */

/*! @brief Read current value of the UART_USR1_RXDS field. */
#define BR_UART_USR1_RXDS(x) (HW_UART_USR1(x).B.RXDS)
/*@}*/

/*!
 * @name Register UART_USR1, field DTRD[7] (W1C)
 *
 * DTR Delta. Indicates whether DTR_B (in DCE mode) or DSR_B (in DTE mode) pins
 * changed state. DTRD generates a maskable interrupt if DTRDEN (UCR3[3]) is set.
 * Clear DTRD by writing 1 to it. Writing 0 to DTRD has no effect.
 *
 * Values:
 * - 0 - DTR_B (DCE) or DSR_B (DTE) pin did not change state since last cleared
 * - 1 - DTR_B (DCE) or DSR_B (DTE) pin changed state (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR1_DTRD    (7U)          /*!< Bit position for UART_USR1_DTRD. */
#define BM_UART_USR1_DTRD    (0x00000080U) /*!< Bit mask for UART_USR1_DTRD. */
#define BS_UART_USR1_DTRD    (1U)          /*!< Bit field size in bits for UART_USR1_DTRD. */

/*! @brief Read current value of the UART_USR1_DTRD field. */
#define BR_UART_USR1_DTRD(x) (HW_UART_USR1(x).B.DTRD)

/*! @brief Format value for bitfield UART_USR1_DTRD. */
#define BF_UART_USR1_DTRD(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_DTRD) & BM_UART_USR1_DTRD)

/*! @brief Set the DTRD field to a new value. */
#define BW_UART_USR1_DTRD(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_DTRD | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_DTRD(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field AGTIM[8] (W1C)
 *
 * Ageing Timer Interrupt Flag. Indicates that data in the RxFIFO has been idle
 * for a time of 8 character lengths (where a character length consists of 7 or 8
 * bits, depending on the setting of the WS bit in UCR2, with the bit time
 * corresponding to the baud rate setting) and FIFO data level is less than RxFIFO
 * threshold level (RXTL in the UFCR). Clear by writing a 1 to it.
 *
 * Values:
 * - 0 - AGTIM is not active
 * - 1 - AGTIM is active (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR1_AGTIM   (8U)          /*!< Bit position for UART_USR1_AGTIM. */
#define BM_UART_USR1_AGTIM   (0x00000100U) /*!< Bit mask for UART_USR1_AGTIM. */
#define BS_UART_USR1_AGTIM   (1U)          /*!< Bit field size in bits for UART_USR1_AGTIM. */

/*! @brief Read current value of the UART_USR1_AGTIM field. */
#define BR_UART_USR1_AGTIM(x) (HW_UART_USR1(x).B.AGTIM)

/*! @brief Format value for bitfield UART_USR1_AGTIM. */
#define BF_UART_USR1_AGTIM(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_AGTIM) & BM_UART_USR1_AGTIM)

/*! @brief Set the AGTIM field to a new value. */
#define BW_UART_USR1_AGTIM(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_AGTIM | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_AGTIM(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field RRDY[9] (RO)
 *
 * Receiver Ready Interrupt / DMA Flag. Indicates that the RxFIFO data level is
 * above the threshold set by the RXTL bits. (See the RXTL bits description in
 * UFCRUART FIFO Control Register for setting the interrupt threshold.) When
 * asserted, RRDY generates a maskable interrupt or DMA request. RRDY is automatically
 * cleared when data level in the RxFIFO goes below the set threshold level. At
 * reset, RRDY is set to 0.
 *
 * Values:
 * - 0 - No character ready
 * - 1 - Character(s) ready (interrupt posted)
 */
/*@{*/
#define BP_UART_USR1_RRDY    (9U)          /*!< Bit position for UART_USR1_RRDY. */
#define BM_UART_USR1_RRDY    (0x00000200U) /*!< Bit mask for UART_USR1_RRDY. */
#define BS_UART_USR1_RRDY    (1U)          /*!< Bit field size in bits for UART_USR1_RRDY. */

/*! @brief Read current value of the UART_USR1_RRDY field. */
#define BR_UART_USR1_RRDY(x) (HW_UART_USR1(x).B.RRDY)
/*@}*/

/*!
 * @name Register UART_USR1, field FRAMERR[10] (W1C)
 *
 * Frame Error Interrupt Flag. Indicates that a frame error is detected. The
 * interrupt_uart interrupt will be generated if a frame error is detected and the
 * interrupt is enabled. Clear FRAMERR by writing 1 to it. Writing 0 to FRAMERR
 * has no effect.
 *
 * Values:
 * - 0 - No frame error detected
 * - 1 - Frame error detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR1_FRAMERR (10U)         /*!< Bit position for UART_USR1_FRAMERR. */
#define BM_UART_USR1_FRAMERR (0x00000400U) /*!< Bit mask for UART_USR1_FRAMERR. */
#define BS_UART_USR1_FRAMERR (1U)          /*!< Bit field size in bits for UART_USR1_FRAMERR. */

/*! @brief Read current value of the UART_USR1_FRAMERR field. */
#define BR_UART_USR1_FRAMERR(x) (HW_UART_USR1(x).B.FRAMERR)

/*! @brief Format value for bitfield UART_USR1_FRAMERR. */
#define BF_UART_USR1_FRAMERR(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_FRAMERR) & BM_UART_USR1_FRAMERR)

/*! @brief Set the FRAMERR field to a new value. */
#define BW_UART_USR1_FRAMERR(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_FRAMERR | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_FRAMERR(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field ESCF[11] (W1C)
 *
 * Escape Sequence Interrupt Flag. Indicates if an escape sequence was detected.
 * ESCF is asserted when the ESCEN bit is set and an escape sequence is detected
 * in the RxFIFO. Clear ESCF by writing 1 to it. Writing 0 to ESCF has no effect.
 *
 * Values:
 * - 0 - No escape sequence detected
 * - 1 - Escape sequence detected (write 1 to clear).
 */
/*@{*/
#define BP_UART_USR1_ESCF    (11U)         /*!< Bit position for UART_USR1_ESCF. */
#define BM_UART_USR1_ESCF    (0x00000800U) /*!< Bit mask for UART_USR1_ESCF. */
#define BS_UART_USR1_ESCF    (1U)          /*!< Bit field size in bits for UART_USR1_ESCF. */

/*! @brief Read current value of the UART_USR1_ESCF field. */
#define BR_UART_USR1_ESCF(x) (HW_UART_USR1(x).B.ESCF)

/*! @brief Format value for bitfield UART_USR1_ESCF. */
#define BF_UART_USR1_ESCF(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_ESCF) & BM_UART_USR1_ESCF)

/*! @brief Set the ESCF field to a new value. */
#define BW_UART_USR1_ESCF(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_ESCF | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_RTSD | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_ESCF(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field RTSD[12] (W1C)
 *
 * RTS Delta. Indicates whether the RTS_B pin changed state. It (RTSD) generates
 * a maskable interrupt. When in STOP mode, RTS assertion sets RTSD and can be
 * used to wake the processor. The current state of the RTS_B pin is available on
 * the RTSS bit. Clear RTSD by writing 1 to it. Writing 0 to RTSD has no effect.
 * At reset, RTSD is set to 0.
 *
 * Values:
 * - 0 - RTS_B pin did not change state since last cleared
 * - 1 - RTS_B pin changed state (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR1_RTSD    (12U)         /*!< Bit position for UART_USR1_RTSD. */
#define BM_UART_USR1_RTSD    (0x00001000U) /*!< Bit mask for UART_USR1_RTSD. */
#define BS_UART_USR1_RTSD    (1U)          /*!< Bit field size in bits for UART_USR1_RTSD. */

/*! @brief Read current value of the UART_USR1_RTSD field. */
#define BR_UART_USR1_RTSD(x) (HW_UART_USR1(x).B.RTSD)

/*! @brief Format value for bitfield UART_USR1_RTSD. */
#define BF_UART_USR1_RTSD(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_RTSD) & BM_UART_USR1_RTSD)

/*! @brief Set the RTSD field to a new value. */
#define BW_UART_USR1_RTSD(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_RTSD | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_PARITYERR)) | BF_UART_USR1_RTSD(v)))
/*@}*/

/*!
 * @name Register UART_USR1, field TRDY[13] (RO)
 *
 * Transmitter Ready Interrupt / DMA Flag. Indicates that the TxFIFO emptied
 * below its target threshold and requires data. TRDY is automatically cleared when
 * the data level in the TxFIFO exceeds the threshold set by TXTL bits. At reset,
 * TRDY is set to 1.
 *
 * Values:
 * - 0 - The transmitter does not require data
 * - 1 - The transmitter requires data (interrupt posted)
 */
/*@{*/
#define BP_UART_USR1_TRDY    (13U)         /*!< Bit position for UART_USR1_TRDY. */
#define BM_UART_USR1_TRDY    (0x00002000U) /*!< Bit mask for UART_USR1_TRDY. */
#define BS_UART_USR1_TRDY    (1U)          /*!< Bit field size in bits for UART_USR1_TRDY. */

/*! @brief Read current value of the UART_USR1_TRDY field. */
#define BR_UART_USR1_TRDY(x) (HW_UART_USR1(x).B.TRDY)
/*@}*/

/*!
 * @name Register UART_USR1, field RTSS[14] (RO)
 *
 * RTS_B Pin Status. Indicates the current status of the RTS_B pin. A "snapshot"
 * of RTS_B is taken immediately before RTSS is presented to the data bus. RTSS
 * cannot be cleared because all writes to RTSS are ignored. At reset, RTSS is
 * set to 0.
 *
 * Values:
 * - 0 - The RTS_B module input is high (inactive)
 * - 1 - The RTS_B module input is low (active)
 */
/*@{*/
#define BP_UART_USR1_RTSS    (14U)         /*!< Bit position for UART_USR1_RTSS. */
#define BM_UART_USR1_RTSS    (0x00004000U) /*!< Bit mask for UART_USR1_RTSS. */
#define BS_UART_USR1_RTSS    (1U)          /*!< Bit field size in bits for UART_USR1_RTSS. */

/*! @brief Read current value of the UART_USR1_RTSS field. */
#define BR_UART_USR1_RTSS(x) (HW_UART_USR1(x).B.RTSS)
/*@}*/

/*!
 * @name Register UART_USR1, field PARITYERR[15] (W1C)
 *
 * Parity Error Interrupt Flag. Indicates a parity error is detected. PARITYERR
 * is cleared by writing 1 to it. Writing 0 to PARITYERR has no effect. When
 * parity is disabled, PARITYERR always reads 0. At reset, PARITYERR is set to 0.
 *
 * Values:
 * - 0 - No parity error detected
 * - 1 - Parity error detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR1_PARITYERR (15U)       /*!< Bit position for UART_USR1_PARITYERR. */
#define BM_UART_USR1_PARITYERR (0x00008000U) /*!< Bit mask for UART_USR1_PARITYERR. */
#define BS_UART_USR1_PARITYERR (1U)        /*!< Bit field size in bits for UART_USR1_PARITYERR. */

/*! @brief Read current value of the UART_USR1_PARITYERR field. */
#define BR_UART_USR1_PARITYERR(x) (HW_UART_USR1(x).B.PARITYERR)

/*! @brief Format value for bitfield UART_USR1_PARITYERR. */
#define BF_UART_USR1_PARITYERR(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR1_PARITYERR) & BM_UART_USR1_PARITYERR)

/*! @brief Set the PARITYERR field to a new value. */
#define BW_UART_USR1_PARITYERR(x, v) (HW_UART_USR1_WR(x, (HW_UART_USR1_RD(x) & ~(BM_UART_USR1_PARITYERR | BM_UART_USR1_SAD | BM_UART_USR1_AWAKE | BM_UART_USR1_AIRINT | BM_UART_USR1_DTRD | BM_UART_USR1_AGTIM | BM_UART_USR1_FRAMERR | BM_UART_USR1_ESCF | BM_UART_USR1_RTSD)) | BF_UART_USR1_PARITYERR(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_USR2 - UART Status Register 2
 ******************************************************************************/

/*!
 * @brief HW_UART_USR2 - UART Status Register 2 (RW)
 *
 * Reset value: 0x00004028U
 */
typedef union _hw_uart_usr2
{
    uint32_t U;
    struct _hw_uart_usr2_bitfields
    {
        uint32_t RDR : 1;              /*!< [0]  */
        uint32_t ORE : 1;              /*!< [1]  */
        uint32_t BRCD : 1;             /*!< [2]  */
        uint32_t TXDC : 1;             /*!< [3]  */
        uint32_t RTSF : 1;             /*!< [4]  */
        uint32_t DCDIN : 1;            /*!< [5]  */
        uint32_t DCDDELT : 1;          /*!< [6]  */
        uint32_t WAKE : 1;             /*!< [7]  */
        uint32_t IRINT : 1;            /*!< [8]  */
        uint32_t RIIN : 1;             /*!< [9]  */
        uint32_t RIDELT : 1;           /*!< [10]  */
        uint32_t ACST : 1;             /*!< [11]  */
        uint32_t IDLE : 1;             /*!< [12]  */
        uint32_t DTRF : 1;             /*!< [13]  */
        uint32_t TXFE : 1;             /*!< [14]  */
        uint32_t ADET : 1;             /*!< [15]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_usr2_t;

/*!
 * @name Constants and macros for entire UART_USR2 register
 */
/*@{*/
#define HW_UART_USR2_ADDR(x)     ((uintptr_t)(x) + 0x98U)

#define HW_UART_USR2(x)          (*(__IO hw_uart_usr2_t *) HW_UART_USR2_ADDR(x))
#define HW_UART_USR2_RD(x)       (HW_UART_USR2(x).U)
#define HW_UART_USR2_WR(x, v)    (HW_UART_USR2(x).U = (v))
#define HW_UART_USR2_SET(x, v)   (HW_UART_USR2_WR(x, HW_UART_USR2_RD(x) |  (v)))
#define HW_UART_USR2_CLR(x, v)   (HW_UART_USR2_WR(x, HW_UART_USR2_RD(x) & ~(v)))
#define HW_UART_USR2_TOG(x, v)   (HW_UART_USR2_WR(x, HW_UART_USR2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_USR2 bitfields
 */

/*!
 * @name Register UART_USR2, field RDR[0] (RO)
 *
 * Receive Data Ready-Indicates that at least 1 character is received and
 * written to the RxFIFO. If the URXD register is read and there is only 1 character in
 * the RxFIFO, RDR is automatically cleared.
 *
 * Values:
 * - 0 - No receive data ready
 * - 1 - Receive data ready
 */
/*@{*/
#define BP_UART_USR2_RDR     (0U)          /*!< Bit position for UART_USR2_RDR. */
#define BM_UART_USR2_RDR     (0x00000001U) /*!< Bit mask for UART_USR2_RDR. */
#define BS_UART_USR2_RDR     (1U)          /*!< Bit field size in bits for UART_USR2_RDR. */

/*! @brief Read current value of the UART_USR2_RDR field. */
#define BR_UART_USR2_RDR(x)  (HW_UART_USR2(x).B.RDR)
/*@}*/

/*!
 * @name Register UART_USR2, field ORE[1] (W1C)
 *
 * Overrun Error. When set to 1, ORE indicates that the receive buffer (RxFIFO)
 * was full (32 chars inside), and a 33rd character has been fully received. This
 * 33rd character has been discarded. Clear ORE by writing 1 to it. Writing 0 to
 * ORE has no effect.
 *
 * Values:
 * - 0 - No overrun error
 * - 1 - Overrun error (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_ORE     (1U)          /*!< Bit position for UART_USR2_ORE. */
#define BM_UART_USR2_ORE     (0x00000002U) /*!< Bit mask for UART_USR2_ORE. */
#define BS_UART_USR2_ORE     (1U)          /*!< Bit field size in bits for UART_USR2_ORE. */

/*! @brief Read current value of the UART_USR2_ORE field. */
#define BR_UART_USR2_ORE(x)  (HW_UART_USR2(x).B.ORE)

/*! @brief Format value for bitfield UART_USR2_ORE. */
#define BF_UART_USR2_ORE(v)  ((uint32_t)((uint32_t)(v) << BP_UART_USR2_ORE) & BM_UART_USR2_ORE)

/*! @brief Set the ORE field to a new value. */
#define BW_UART_USR2_ORE(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_ORE(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field BRCD[2] (W1C)
 *
 * BREAK Condition Detected. Indicates that a BREAK condition was detected by
 * the receiver. Clear BRCD by writing 1 to it. Writing 0 to BRCD has no effect.
 *
 * Values:
 * - 0 - No BREAK condition was detected
 * - 1 - A BREAK condition was detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_BRCD    (2U)          /*!< Bit position for UART_USR2_BRCD. */
#define BM_UART_USR2_BRCD    (0x00000004U) /*!< Bit mask for UART_USR2_BRCD. */
#define BS_UART_USR2_BRCD    (1U)          /*!< Bit field size in bits for UART_USR2_BRCD. */

/*! @brief Read current value of the UART_USR2_BRCD field. */
#define BR_UART_USR2_BRCD(x) (HW_UART_USR2(x).B.BRCD)

/*! @brief Format value for bitfield UART_USR2_BRCD. */
#define BF_UART_USR2_BRCD(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_BRCD) & BM_UART_USR2_BRCD)

/*! @brief Set the BRCD field to a new value. */
#define BW_UART_USR2_BRCD(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_BRCD | BM_UART_USR2_ORE | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_BRCD(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field TXDC[3] (RO)
 *
 * Transmitter Complete. Indicates that the transmit buffer (TxFIFO) and Shift
 * Register is empty; therefore the transmission is complete. TXDC is cleared
 * automatically when data is written to the TxFIFO.
 *
 * Values:
 * - 0 - Transmit is incomplete
 * - 1 - Transmit is complete
 */
/*@{*/
#define BP_UART_USR2_TXDC    (3U)          /*!< Bit position for UART_USR2_TXDC. */
#define BM_UART_USR2_TXDC    (0x00000008U) /*!< Bit mask for UART_USR2_TXDC. */
#define BS_UART_USR2_TXDC    (1U)          /*!< Bit field size in bits for UART_USR2_TXDC. */

/*! @brief Read current value of the UART_USR2_TXDC field. */
#define BR_UART_USR2_TXDC(x) (HW_UART_USR2(x).B.TXDC)
/*@}*/

/*!
 * @name Register UART_USR2, field RTSF[4] (W1C)
 *
 * RTS Edge Triggered Interrupt Flag. Indicates if a programmed edge is detected
 * on the RTS_B pin. The RTEC bits select the edge that generates an interrupt
 * (see ). RTSF can generate an interrupt that can be masked using the RTSEN bit.
 * Clear RTSF by writing 1 to it. Writing 0 to RTSF has no effect.
 *
 * Values:
 * - 0 - Programmed edge not detected on RTS_B
 * - 1 - Programmed edge detected on RTS_B (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_RTSF    (4U)          /*!< Bit position for UART_USR2_RTSF. */
#define BM_UART_USR2_RTSF    (0x00000010U) /*!< Bit mask for UART_USR2_RTSF. */
#define BS_UART_USR2_RTSF    (1U)          /*!< Bit field size in bits for UART_USR2_RTSF. */

/*! @brief Read current value of the UART_USR2_RTSF field. */
#define BR_UART_USR2_RTSF(x) (HW_UART_USR2(x).B.RTSF)

/*! @brief Format value for bitfield UART_USR2_RTSF. */
#define BF_UART_USR2_RTSF(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_RTSF) & BM_UART_USR2_RTSF)

/*! @brief Set the RTSF field to a new value. */
#define BW_UART_USR2_RTSF(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_RTSF | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_RTSF(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field DCDIN[5] (RO)
 *
 * Data Carrier Detect Input. This bit is used in DTE mode reflect the status of
 * the Data Carrier Detect input (DCD_B). The Data Carrier Detect input is used
 * to indicate that a carrier signal has been detected. In DCE mode this bit is
 * always zero.
 *
 * Values:
 * - 0 - Carrier signal Detected
 * - 1 - No Carrier signal Detected
 */
/*@{*/
#define BP_UART_USR2_DCDIN   (5U)          /*!< Bit position for UART_USR2_DCDIN. */
#define BM_UART_USR2_DCDIN   (0x00000020U) /*!< Bit mask for UART_USR2_DCDIN. */
#define BS_UART_USR2_DCDIN   (1U)          /*!< Bit field size in bits for UART_USR2_DCDIN. */

/*! @brief Read current value of the UART_USR2_DCDIN field. */
#define BR_UART_USR2_DCDIN(x) (HW_UART_USR2(x).B.DCDIN)
/*@}*/

/*!
 * @name Register UART_USR2, field DCDDELT[6] (W1C)
 *
 * Data Carrier Detect Delta. This bit is used in DTE mode to indicate that the
 * Data Carrier Detect input (DCD_B) has changed state. This flag can cause an
 * interrupt if DCD (UCR3[9]) is enabled. When in STOP mode, this bit can be used
 * to wake the processor. In DCE mode this bit is always zero.
 *
 * Values:
 * - 0 - Data Carrier Detect input has not changed state
 * - 1 - Data Carrier Detect input has changed state (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_DCDDELT (6U)          /*!< Bit position for UART_USR2_DCDDELT. */
#define BM_UART_USR2_DCDDELT (0x00000040U) /*!< Bit mask for UART_USR2_DCDDELT. */
#define BS_UART_USR2_DCDDELT (1U)          /*!< Bit field size in bits for UART_USR2_DCDDELT. */

/*! @brief Read current value of the UART_USR2_DCDDELT field. */
#define BR_UART_USR2_DCDDELT(x) (HW_UART_USR2(x).B.DCDDELT)

/*! @brief Format value for bitfield UART_USR2_DCDDELT. */
#define BF_UART_USR2_DCDDELT(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_DCDDELT) & BM_UART_USR2_DCDDELT)

/*! @brief Set the DCDDELT field to a new value. */
#define BW_UART_USR2_DCDDELT(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_DCDDELT | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_DCDDELT(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field WAKE[7] (W1C)
 *
 * Wake. Indicates the start bit is detected. WAKE can generate an interrupt
 * that can be masked using the WKEN bit. Clear WAKE by writing 1 to it. Writing 0
 * to WAKE has no effect.
 *
 * Values:
 * - 0 - start bit not detected
 * - 1 - start bit detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_WAKE    (7U)          /*!< Bit position for UART_USR2_WAKE. */
#define BM_UART_USR2_WAKE    (0x00000080U) /*!< Bit mask for UART_USR2_WAKE. */
#define BS_UART_USR2_WAKE    (1U)          /*!< Bit field size in bits for UART_USR2_WAKE. */

/*! @brief Read current value of the UART_USR2_WAKE field. */
#define BR_UART_USR2_WAKE(x) (HW_UART_USR2(x).B.WAKE)

/*! @brief Format value for bitfield UART_USR2_WAKE. */
#define BF_UART_USR2_WAKE(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_WAKE) & BM_UART_USR2_WAKE)

/*! @brief Set the WAKE field to a new value. */
#define BW_UART_USR2_WAKE(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_WAKE | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_WAKE(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field IRINT[8] (W1C)
 *
 * Serial Infrared Interrupt Flag. When an edge is detected on the RXD pin
 * during SIR Mode, this flag will be asserted. This flag can cause an interrupt which
 * can be masked using the control bit ENIRI: UCR4 [8].
 *
 * Values:
 * - 0 - no edge detected
 * - 1 - valid edge detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_IRINT   (8U)          /*!< Bit position for UART_USR2_IRINT. */
#define BM_UART_USR2_IRINT   (0x00000100U) /*!< Bit mask for UART_USR2_IRINT. */
#define BS_UART_USR2_IRINT   (1U)          /*!< Bit field size in bits for UART_USR2_IRINT. */

/*! @brief Read current value of the UART_USR2_IRINT field. */
#define BR_UART_USR2_IRINT(x) (HW_UART_USR2(x).B.IRINT)

/*! @brief Format value for bitfield UART_USR2_IRINT. */
#define BF_UART_USR2_IRINT(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_IRINT) & BM_UART_USR2_IRINT)

/*! @brief Set the IRINT field to a new value. */
#define BW_UART_USR2_IRINT(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_IRINT | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_IRINT(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field RIIN[9] (RO)
 *
 * Ring Indicator Input. This bit is used in DTE mode to reflect the status if
 * the Ring Indicator input (RI_B). The Ring Indicator input is used to indicate
 * that a ring has occurred. In DCE mode this bit is always zero.
 *
 * Values:
 * - 0 - Ring Detected
 * - 1 - No Ring Detected
 */
/*@{*/
#define BP_UART_USR2_RIIN    (9U)          /*!< Bit position for UART_USR2_RIIN. */
#define BM_UART_USR2_RIIN    (0x00000200U) /*!< Bit mask for UART_USR2_RIIN. */
#define BS_UART_USR2_RIIN    (1U)          /*!< Bit field size in bits for UART_USR2_RIIN. */

/*! @brief Read current value of the UART_USR2_RIIN field. */
#define BR_UART_USR2_RIIN(x) (HW_UART_USR2(x).B.RIIN)
/*@}*/

/*!
 * @name Register UART_USR2, field RIDELT[10] (W1C)
 *
 * Ring Indicator Delta. This bit is used in DTE mode to indicate that the Ring
 * Indicator input (RI_B) has changed state. This flag can generate an interrupt
 * if RI (UCR3[8]) is enabled. RIDELT is cleared by writing 1 to it. Writing 0 to
 * RIDELT has no effect.
 *
 * Values:
 * - 0 - Ring Indicator input has not changed state
 * - 1 - Ring Indicator input has changed state (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_RIDELT  (10U)         /*!< Bit position for UART_USR2_RIDELT. */
#define BM_UART_USR2_RIDELT  (0x00000400U) /*!< Bit mask for UART_USR2_RIDELT. */
#define BS_UART_USR2_RIDELT  (1U)          /*!< Bit field size in bits for UART_USR2_RIDELT. */

/*! @brief Read current value of the UART_USR2_RIDELT field. */
#define BR_UART_USR2_RIDELT(x) (HW_UART_USR2(x).B.RIDELT)

/*! @brief Format value for bitfield UART_USR2_RIDELT. */
#define BF_UART_USR2_RIDELT(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_RIDELT) & BM_UART_USR2_RIDELT)

/*! @brief Set the RIDELT field to a new value. */
#define BW_UART_USR2_RIDELT(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_RIDELT | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_RIDELT(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field ACST[11] (W1C)
 *
 * Autobaud Counter Stopped. In autobaud detection (ADBR=1), indicates the
 * counter which determines the baud rate was running and is now stopped. This means
 * either START bit is finished (if ADNIMP=1), or Bit 0 is finished (if ADNIMP=0).
 * See New Autobaud Counter Stopped bit and InterruptA new bit has been added in
 * USR2 register: ACST (USR2[11]). This bit is set immediately after the
 * determination of the baud rate. , for more details. An interrupt can be flagged on
 * interrupt_uart if ACIEN=1.
 *
 * Values:
 * - 0 - Measurement of bit length not finished (in autobaud)
 * - 1 - Measurement of bit length finished (in autobaud). (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_ACST    (11U)         /*!< Bit position for UART_USR2_ACST. */
#define BM_UART_USR2_ACST    (0x00000800U) /*!< Bit mask for UART_USR2_ACST. */
#define BS_UART_USR2_ACST    (1U)          /*!< Bit field size in bits for UART_USR2_ACST. */

/*! @brief Read current value of the UART_USR2_ACST field. */
#define BR_UART_USR2_ACST(x) (HW_UART_USR2(x).B.ACST)

/*! @brief Format value for bitfield UART_USR2_ACST. */
#define BF_UART_USR2_ACST(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_ACST) & BM_UART_USR2_ACST)

/*! @brief Set the ACST field to a new value. */
#define BW_UART_USR2_ACST(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_ACST | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_ACST(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field IDLE[12] (W1C)
 *
 * Idle Condition. Indicates that an idle condition has existed for more than a
 * programmed amount frame (see Idle Line DetectThe receiver logic block includes
 * the ability to detect an idle line. Idle lines indicate the end or the
 * beginning of a message. . An interrupt can be generated by this IDLE bit if IDEN
 * (UCR1[12]) is enabled. IDLE is cleared by writing 1 to it. Writing 0 to IDLE has
 * no effect.
 *
 * Values:
 * - 0 - No idle condition detected
 * - 1 - Idle condition detected (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_IDLE    (12U)         /*!< Bit position for UART_USR2_IDLE. */
#define BM_UART_USR2_IDLE    (0x00001000U) /*!< Bit mask for UART_USR2_IDLE. */
#define BS_UART_USR2_IDLE    (1U)          /*!< Bit field size in bits for UART_USR2_IDLE. */

/*! @brief Read current value of the UART_USR2_IDLE field. */
#define BR_UART_USR2_IDLE(x) (HW_UART_USR2(x).B.IDLE)

/*! @brief Format value for bitfield UART_USR2_IDLE. */
#define BF_UART_USR2_IDLE(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_IDLE) & BM_UART_USR2_IDLE)

/*! @brief Set the IDLE field to a new value. */
#define BW_UART_USR2_IDLE(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_IDLE | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_DTRF | BM_UART_USR2_ADET)) | BF_UART_USR2_IDLE(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field DTRF[13] (W1C)
 *
 * DTR edge triggered interrupt flag. This bit is asserted, when the programmed
 * edge is detected on the DTR_B pin (DCE mode) or on DSR_B (DTE mode). This flag
 * can cause an interrupt if DTREN (UCR3[13]) is enabled.
 *
 * Values:
 * - 0 - Programmed edge not detected on DTR/DSR
 * - 1 - Programmed edge detected on DTR/DSR (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_DTRF    (13U)         /*!< Bit position for UART_USR2_DTRF. */
#define BM_UART_USR2_DTRF    (0x00002000U) /*!< Bit mask for UART_USR2_DTRF. */
#define BS_UART_USR2_DTRF    (1U)          /*!< Bit field size in bits for UART_USR2_DTRF. */

/*! @brief Read current value of the UART_USR2_DTRF field. */
#define BR_UART_USR2_DTRF(x) (HW_UART_USR2(x).B.DTRF)

/*! @brief Format value for bitfield UART_USR2_DTRF. */
#define BF_UART_USR2_DTRF(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_DTRF) & BM_UART_USR2_DTRF)

/*! @brief Set the DTRF field to a new value. */
#define BW_UART_USR2_DTRF(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_DTRF | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_ADET)) | BF_UART_USR2_DTRF(v)))
/*@}*/

/*!
 * @name Register UART_USR2, field TXFE[14] (RO)
 *
 * Transmit Buffer FIFO Empty. Indicates that the transmit buffer (TxFIFO) is
 * empty. TXFE is cleared automatically when data is written to the TxFIFO. Even
 * though TXFE is high, the transmission might still be in progress.
 *
 * Values:
 * - 0 - The transmit buffer (TxFIFO) is not empty
 * - 1 - The transmit buffer (TxFIFO) is empty
 */
/*@{*/
#define BP_UART_USR2_TXFE    (14U)         /*!< Bit position for UART_USR2_TXFE. */
#define BM_UART_USR2_TXFE    (0x00004000U) /*!< Bit mask for UART_USR2_TXFE. */
#define BS_UART_USR2_TXFE    (1U)          /*!< Bit field size in bits for UART_USR2_TXFE. */

/*! @brief Read current value of the UART_USR2_TXFE field. */
#define BR_UART_USR2_TXFE(x) (HW_UART_USR2(x).B.TXFE)
/*@}*/

/*!
 * @name Register UART_USR2, field ADET[15] (W1C)
 *
 * Automatic Baud Rate Detect Complete. Indicates that an "A" or "a" was
 * received and that the receiver detected and verified the incoming baud rate. Clear
 * ADET by writing 1 to it. Writing 0 to ADET has no effect.
 *
 * Values:
 * - 0 - ASCII "A" or "a" was not received
 * - 1 - ASCII "A" or "a" was received (write 1 to clear)
 */
/*@{*/
#define BP_UART_USR2_ADET    (15U)         /*!< Bit position for UART_USR2_ADET. */
#define BM_UART_USR2_ADET    (0x00008000U) /*!< Bit mask for UART_USR2_ADET. */
#define BS_UART_USR2_ADET    (1U)          /*!< Bit field size in bits for UART_USR2_ADET. */

/*! @brief Read current value of the UART_USR2_ADET field. */
#define BR_UART_USR2_ADET(x) (HW_UART_USR2(x).B.ADET)

/*! @brief Format value for bitfield UART_USR2_ADET. */
#define BF_UART_USR2_ADET(v) ((uint32_t)((uint32_t)(v) << BP_UART_USR2_ADET) & BM_UART_USR2_ADET)

/*! @brief Set the ADET field to a new value. */
#define BW_UART_USR2_ADET(x, v) (HW_UART_USR2_WR(x, (HW_UART_USR2_RD(x) & ~(BM_UART_USR2_ADET | BM_UART_USR2_ORE | BM_UART_USR2_BRCD | BM_UART_USR2_RTSF | BM_UART_USR2_DCDDELT | BM_UART_USR2_WAKE | BM_UART_USR2_IRINT | BM_UART_USR2_RIDELT | BM_UART_USR2_ACST | BM_UART_USR2_IDLE | BM_UART_USR2_DTRF)) | BF_UART_USR2_ADET(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UESC - UART Escape Character Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UESC - UART Escape Character Register (RW)
 *
 * Reset value: 0x0000002BU
 */
typedef union _hw_uart_uesc
{
    uint32_t U;
    struct _hw_uart_uesc_bitfields
    {
        uint32_t ESC_CHAR : 8;         /*!< [7:0]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_uart_uesc_t;

/*!
 * @name Constants and macros for entire UART_UESC register
 */
/*@{*/
#define HW_UART_UESC_ADDR(x)     ((uintptr_t)(x) + 0x9CU)

#define HW_UART_UESC(x)          (*(__IO hw_uart_uesc_t *) HW_UART_UESC_ADDR(x))
#define HW_UART_UESC_RD(x)       (HW_UART_UESC(x).U)
#define HW_UART_UESC_WR(x, v)    (HW_UART_UESC(x).U = (v))
#define HW_UART_UESC_SET(x, v)   (HW_UART_UESC_WR(x, HW_UART_UESC_RD(x) |  (v)))
#define HW_UART_UESC_CLR(x, v)   (HW_UART_UESC_WR(x, HW_UART_UESC_RD(x) & ~(v)))
#define HW_UART_UESC_TOG(x, v)   (HW_UART_UESC_WR(x, HW_UART_UESC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UESC bitfields
 */

/*!
 * @name Register UART_UESC, field ESC_CHAR[7:0] (RW)
 *
 * UART Escape Character. Holds the selected escape character that all received
 * characters are compared against to detect an escape sequence.
 */
/*@{*/
#define BP_UART_UESC_ESC_CHAR (0U)         /*!< Bit position for UART_UESC_ESC_CHAR. */
#define BM_UART_UESC_ESC_CHAR (0x000000FFU) /*!< Bit mask for UART_UESC_ESC_CHAR. */
#define BS_UART_UESC_ESC_CHAR (8U)         /*!< Bit field size in bits for UART_UESC_ESC_CHAR. */

/*! @brief Read current value of the UART_UESC_ESC_CHAR field. */
#define BR_UART_UESC_ESC_CHAR(x) (HW_UART_UESC(x).B.ESC_CHAR)

/*! @brief Format value for bitfield UART_UESC_ESC_CHAR. */
#define BF_UART_UESC_ESC_CHAR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UESC_ESC_CHAR) & BM_UART_UESC_ESC_CHAR)

/*! @brief Set the ESC_CHAR field to a new value. */
#define BW_UART_UESC_ESC_CHAR(x, v) (HW_UART_UESC_WR(x, (HW_UART_UESC_RD(x) & ~BM_UART_UESC_ESC_CHAR) | BF_UART_UESC_ESC_CHAR(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UTIM - UART Escape Timer Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UTIM - UART Escape Timer Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_uart_utim
{
    uint32_t U;
    struct _hw_uart_utim_bitfields
    {
        uint32_t TIM : 12;             /*!< [11:0]  */
        uint32_t RESERVED0 : 20;       /*!< [31:12]  */
    } B;
} hw_uart_utim_t;

/*!
 * @name Constants and macros for entire UART_UTIM register
 */
/*@{*/
#define HW_UART_UTIM_ADDR(x)     ((uintptr_t)(x) + 0xA0U)

#define HW_UART_UTIM(x)          (*(__IO hw_uart_utim_t *) HW_UART_UTIM_ADDR(x))
#define HW_UART_UTIM_RD(x)       (HW_UART_UTIM(x).U)
#define HW_UART_UTIM_WR(x, v)    (HW_UART_UTIM(x).U = (v))
#define HW_UART_UTIM_SET(x, v)   (HW_UART_UTIM_WR(x, HW_UART_UTIM_RD(x) |  (v)))
#define HW_UART_UTIM_CLR(x, v)   (HW_UART_UTIM_WR(x, HW_UART_UTIM_RD(x) & ~(v)))
#define HW_UART_UTIM_TOG(x, v)   (HW_UART_UTIM_WR(x, HW_UART_UTIM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UTIM bitfields
 */

/*!
 * @name Register UART_UTIM, field TIM[11:0] (RW)
 *
 * UART Escape Timer. Holds the maximum time interval (in ms) allowed between
 * escape characters. The escape timer register is programmable in intervals of 2
 * ms. See Escape Sequence DetectionAn escape sequence typically consists of 3
 * characters entered in rapid succession (such as +++). Because these are valid
 * characters by themselves, the time between characters determines if it is a valid
 * escape sequence. and for more information on the UART escape sequence
 * detection. Reset value 0x000 = 2 ms up to 0xFFF = 8.192 s.
 */
/*@{*/
#define BP_UART_UTIM_TIM     (0U)          /*!< Bit position for UART_UTIM_TIM. */
#define BM_UART_UTIM_TIM     (0x00000FFFU) /*!< Bit mask for UART_UTIM_TIM. */
#define BS_UART_UTIM_TIM     (12U)         /*!< Bit field size in bits for UART_UTIM_TIM. */

/*! @brief Read current value of the UART_UTIM_TIM field. */
#define BR_UART_UTIM_TIM(x)  (HW_UART_UTIM(x).B.TIM)

/*! @brief Format value for bitfield UART_UTIM_TIM. */
#define BF_UART_UTIM_TIM(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UTIM_TIM) & BM_UART_UTIM_TIM)

/*! @brief Set the TIM field to a new value. */
#define BW_UART_UTIM_TIM(x, v) (HW_UART_UTIM_WR(x, (HW_UART_UTIM_RD(x) & ~BM_UART_UTIM_TIM) | BF_UART_UTIM_TIM(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UBIR - UART BRM Incremental Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UBIR - UART BRM Incremental Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register can be written by both software and hardware. When enabling the
 * automatic baud rate detection feature hardware can write 0x000F value into
 * the UBIR after finishing detecting baud rate. Hardware has higher priority when
 * both software and hardware try to write it at the same cycle Note: The write
 * priority in the new design is not same as the original UART. In the orginal
 * design, software has higher priority than hardware when writing this register at
 * the same time. . Please note software reset will reset the register to its
 * reset value.
 */
typedef union _hw_uart_ubir
{
    uint32_t U;
    struct _hw_uart_ubir_bitfields
    {
        uint32_t INC : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ubir_t;

/*!
 * @name Constants and macros for entire UART_UBIR register
 */
/*@{*/
#define HW_UART_UBIR_ADDR(x)     ((uintptr_t)(x) + 0xA4U)

#define HW_UART_UBIR(x)          (*(__IO hw_uart_ubir_t *) HW_UART_UBIR_ADDR(x))
#define HW_UART_UBIR_RD(x)       (HW_UART_UBIR(x).U)
#define HW_UART_UBIR_WR(x, v)    (HW_UART_UBIR(x).U = (v))
#define HW_UART_UBIR_SET(x, v)   (HW_UART_UBIR_WR(x, HW_UART_UBIR_RD(x) |  (v)))
#define HW_UART_UBIR_CLR(x, v)   (HW_UART_UBIR_WR(x, HW_UART_UBIR_RD(x) & ~(v)))
#define HW_UART_UBIR_TOG(x, v)   (HW_UART_UBIR_WR(x, HW_UART_UBIR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UBIR bitfields
 */

/*!
 * @name Register UART_UBIR, field INC[15:0] (RW)
 *
 * Incremental Numerator. Holds the numerator value minus one of the BRM ratio
 * (see Binary Rate Multiplier (BRM)The BRM sub-block receives ref_clk
 * (module_clock clock after divider). From this clock, and with integer and non-integer
 * division, BRM generates a 16x baud rate clock . ). The UBIR register MUST be
 * updated before the UBMR register for the baud rate to be updated correctly. If
 * only one register is written to by software, the BRM will ignore this data until
 * the other register is written to by software. Updating this field using byte
 * accesses is not recommended and is undefined.
 */
/*@{*/
#define BP_UART_UBIR_INC     (0U)          /*!< Bit position for UART_UBIR_INC. */
#define BM_UART_UBIR_INC     (0x0000FFFFU) /*!< Bit mask for UART_UBIR_INC. */
#define BS_UART_UBIR_INC     (16U)         /*!< Bit field size in bits for UART_UBIR_INC. */

/*! @brief Read current value of the UART_UBIR_INC field. */
#define BR_UART_UBIR_INC(x)  (HW_UART_UBIR(x).B.INC)

/*! @brief Format value for bitfield UART_UBIR_INC. */
#define BF_UART_UBIR_INC(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UBIR_INC) & BM_UART_UBIR_INC)

/*! @brief Set the INC field to a new value. */
#define BW_UART_UBIR_INC(x, v) (HW_UART_UBIR_WR(x, (HW_UART_UBIR_RD(x) & ~BM_UART_UBIR_INC) | BF_UART_UBIR_INC(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UBMR - UART BRM Modulator Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UBMR - UART BRM Modulator Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register can be written by both software and hardware. When enabling the
 * automatic baud rate detection feature hardware can write a proper value into
 * the UBMR based on detected baud rate. Hardware has higher priority when both
 * software and hardware try to write it at the same cycle Note: The write
 * priority in the new design is not same as the original UART. In the orginal design,
 * software has higher priority than hardware when writing this register at the
 * same time. . Please note software reset will reset the register to its reset
 * value.
 */
typedef union _hw_uart_ubmr
{
    uint32_t U;
    struct _hw_uart_ubmr_bitfields
    {
        uint32_t MOD : 16;             /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ubmr_t;

/*!
 * @name Constants and macros for entire UART_UBMR register
 */
/*@{*/
#define HW_UART_UBMR_ADDR(x)     ((uintptr_t)(x) + 0xA8U)

#define HW_UART_UBMR(x)          (*(__IO hw_uart_ubmr_t *) HW_UART_UBMR_ADDR(x))
#define HW_UART_UBMR_RD(x)       (HW_UART_UBMR(x).U)
#define HW_UART_UBMR_WR(x, v)    (HW_UART_UBMR(x).U = (v))
#define HW_UART_UBMR_SET(x, v)   (HW_UART_UBMR_WR(x, HW_UART_UBMR_RD(x) |  (v)))
#define HW_UART_UBMR_CLR(x, v)   (HW_UART_UBMR_WR(x, HW_UART_UBMR_RD(x) & ~(v)))
#define HW_UART_UBMR_TOG(x, v)   (HW_UART_UBMR_WR(x, HW_UART_UBMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UBMR bitfields
 */

/*!
 * @name Register UART_UBMR, field MOD[15:0] (RW)
 *
 * Modulator Denominator. Holds the value of the denominator minus one of the
 * BRM ratio (see Binary Rate Multiplier (BRM)The BRM sub-block receives ref_clk
 * (module_clock clock after divider). From this clock, and with integer and
 * non-integer division, BRM generates a 16x baud rate clock . ). The UBIR register
 * MUST be updated before the UBMR register for the baud rate to be updated
 * correctly. If only one register is written to by software, the BRM will ignore this
 * data until the other register is written to by software. Updating this register
 * using byte accesses is not recommended and undefined.
 */
/*@{*/
#define BP_UART_UBMR_MOD     (0U)          /*!< Bit position for UART_UBMR_MOD. */
#define BM_UART_UBMR_MOD     (0x0000FFFFU) /*!< Bit mask for UART_UBMR_MOD. */
#define BS_UART_UBMR_MOD     (16U)         /*!< Bit field size in bits for UART_UBMR_MOD. */

/*! @brief Read current value of the UART_UBMR_MOD field. */
#define BR_UART_UBMR_MOD(x)  (HW_UART_UBMR(x).B.MOD)

/*! @brief Format value for bitfield UART_UBMR_MOD. */
#define BF_UART_UBMR_MOD(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UBMR_MOD) & BM_UART_UBMR_MOD)

/*! @brief Set the MOD field to a new value. */
#define BW_UART_UBMR_MOD(x, v) (HW_UART_UBMR_WR(x, (HW_UART_UBMR_RD(x) & ~BM_UART_UBMR_MOD) | BF_UART_UBMR_MOD(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UBRC - UART Baud Rate Count Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UBRC - UART Baud Rate Count Register (RO)
 *
 * Reset value: 0x00000004U
 */
typedef union _hw_uart_ubrc
{
    uint32_t U;
    struct _hw_uart_ubrc_bitfields
    {
        uint32_t BCNT : 16;            /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_ubrc_t;

/*!
 * @name Constants and macros for entire UART_UBRC register
 */
/*@{*/
#define HW_UART_UBRC_ADDR(x)     ((uintptr_t)(x) + 0xACU)

#define HW_UART_UBRC(x)          (*(__I hw_uart_ubrc_t *) HW_UART_UBRC_ADDR(x))
#define HW_UART_UBRC_RD(x)       (HW_UART_UBRC(x).U)
/*@}*/

/*
 * Constants & macros for individual UART_UBRC bitfields
 */

/*!
 * @name Register UART_UBRC, field BCNT[15:0] (RO)
 *
 * Baud Rate Count Register. This read only register is used to count the start
 * bit of the incoming baud rate (if ADNIMP=1), or start bit + bit0 (if
 * ADNIMP=0). When the measurement is done, the Baud Rate Count Register contains the
 * number of UART internal clock cycles (clock after divider) present in an incoming
 * bit. BCNT retains its value until the next Automatic Baud Rate Detection
 * sequence has been initiated. The 16 bit Baud Rate Count register is reset to 4 and
 * stays at hex FFFF in the case of an overflow.
 */
/*@{*/
#define BP_UART_UBRC_BCNT    (0U)          /*!< Bit position for UART_UBRC_BCNT. */
#define BM_UART_UBRC_BCNT    (0x0000FFFFU) /*!< Bit mask for UART_UBRC_BCNT. */
#define BS_UART_UBRC_BCNT    (16U)         /*!< Bit field size in bits for UART_UBRC_BCNT. */

/*! @brief Read current value of the UART_UBRC_BCNT field. */
#define BR_UART_UBRC_BCNT(x) (HW_UART_UBRC(x).B.BCNT)
/*@}*/

/*******************************************************************************
 * HW_UART_ONEMS - UART One Millisecond Register
 ******************************************************************************/

/*!
 * @brief HW_UART_ONEMS - UART One Millisecond Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register has been expanded from 16 bits to 24 bits. In previous
 * versions, the 16-bit ONEMS can only support the maximum 65.535MHz (0xFFFFx1000)
 * ref_clk. To support 4Mbps Bluetooth application with 66.5MHz module_clock , the
 * value 0x103C4 (66.5M/1000) should be written into this register. In this case, the
 * 16 bits are not enough to contain the 0x103C4. So this register was expanded
 * to 24 bits to support high frequency of the ref_clk.
 */
typedef union _hw_uart_onems
{
    uint32_t U;
    struct _hw_uart_onems_bitfields
    {
        uint32_t ONEMS : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_uart_onems_t;

/*!
 * @name Constants and macros for entire UART_ONEMS register
 */
/*@{*/
#define HW_UART_ONEMS_ADDR(x)    ((uintptr_t)(x) + 0xB0U)

#define HW_UART_ONEMS(x)         (*(__IO hw_uart_onems_t *) HW_UART_ONEMS_ADDR(x))
#define HW_UART_ONEMS_RD(x)      (HW_UART_ONEMS(x).U)
#define HW_UART_ONEMS_WR(x, v)   (HW_UART_ONEMS(x).U = (v))
#define HW_UART_ONEMS_SET(x, v)  (HW_UART_ONEMS_WR(x, HW_UART_ONEMS_RD(x) |  (v)))
#define HW_UART_ONEMS_CLR(x, v)  (HW_UART_ONEMS_WR(x, HW_UART_ONEMS_RD(x) & ~(v)))
#define HW_UART_ONEMS_TOG(x, v)  (HW_UART_ONEMS_WR(x, HW_UART_ONEMS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_ONEMS bitfields
 */

/*!
 * @name Register UART_ONEMS, field ONEMS[23:0] (RW)
 *
 * One Millisecond Register. This 24-bit register must contain the value of the
 * UART internal frequency (ref_clk in ) divided by 1000. The internal frequency
 * is obtained after the UART BRM internal divider (F (ref_clk) = F(module_clock)
 * / RFDIV). In fact this register contains the value corresponding to the
 * number of UART BRM internal clock cycles present in one millisecond. The ONEMS (and
 * UTIM) registers value are used in the escape character detection feature
 * (Escape Sequence DetectionAn escape sequence typically consists of 3 characters
 * entered in rapid succession (such as +++). Because these are valid characters by
 * themselves, the time between characters determines if it is a valid escape
 * sequence. ) to count the number of clock cycles left between two escape
 * characters. The ONEMS register is also used in infrared special case mode (IRSC =
 * UCR4[5] = 1'b1), see InfraRed Special Case (IRSC) BitThe value to apply to IRSC
 * bit is based on 2 parameters: the baud rate and the Minimum Pulse Duration (MPD)
 * of the transceiver. .
 */
/*@{*/
#define BP_UART_ONEMS_ONEMS  (0U)          /*!< Bit position for UART_ONEMS_ONEMS. */
#define BM_UART_ONEMS_ONEMS  (0x00FFFFFFU) /*!< Bit mask for UART_ONEMS_ONEMS. */
#define BS_UART_ONEMS_ONEMS  (24U)         /*!< Bit field size in bits for UART_ONEMS_ONEMS. */

/*! @brief Read current value of the UART_ONEMS_ONEMS field. */
#define BR_UART_ONEMS_ONEMS(x) (HW_UART_ONEMS(x).B.ONEMS)

/*! @brief Format value for bitfield UART_ONEMS_ONEMS. */
#define BF_UART_ONEMS_ONEMS(v) ((uint32_t)((uint32_t)(v) << BP_UART_ONEMS_ONEMS) & BM_UART_ONEMS_ONEMS)

/*! @brief Set the ONEMS field to a new value. */
#define BW_UART_ONEMS_ONEMS(x, v) (HW_UART_ONEMS_WR(x, (HW_UART_ONEMS_RD(x) & ~BM_UART_ONEMS_ONEMS) | BF_UART_ONEMS_ONEMS(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UTS - UART Test Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UTS - UART Test Register (RW)
 *
 * Reset value: 0x00000060U
 */
typedef union _hw_uart_uts
{
    uint32_t U;
    struct _hw_uart_uts_bitfields
    {
        uint32_t SOFTRST : 1;          /*!< [0]  */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t RXFULL : 1;           /*!< [3]  */
        uint32_t TXFULL : 1;           /*!< [4]  */
        uint32_t RXEMPTY : 1;          /*!< [5]  */
        uint32_t TXEMPTY : 1;          /*!< [6]  */
        uint32_t RESERVED1 : 2;        /*!< [8:7]  */
        uint32_t RXDBG : 1;            /*!< [9]  */
        uint32_t LOOPIR : 1;           /*!< [10]  */
        uint32_t DBGEN : 1;            /*!< [11]  */
        uint32_t LOOP : 1;             /*!< [12]  */
        uint32_t FRCPERR : 1;          /*!< [13]  */
        uint32_t RESERVED2 : 18;       /*!< [31:14]  */
    } B;
} hw_uart_uts_t;

/*!
 * @name Constants and macros for entire UART_UTS register
 */
/*@{*/
#define HW_UART_UTS_ADDR(x)      ((uintptr_t)(x) + 0xB4U)

#define HW_UART_UTS(x)           (*(__IO hw_uart_uts_t *) HW_UART_UTS_ADDR(x))
#define HW_UART_UTS_RD(x)        (HW_UART_UTS(x).U)
#define HW_UART_UTS_WR(x, v)     (HW_UART_UTS(x).U = (v))
#define HW_UART_UTS_SET(x, v)    (HW_UART_UTS_WR(x, HW_UART_UTS_RD(x) |  (v)))
#define HW_UART_UTS_CLR(x, v)    (HW_UART_UTS_WR(x, HW_UART_UTS_RD(x) & ~(v)))
#define HW_UART_UTS_TOG(x, v)    (HW_UART_UTS_WR(x, HW_UART_UTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UTS bitfields
 */

/*!
 * @name Register UART_UTS, field SOFTRST[0] (RW)
 *
 * Software Reset. Indicates the status of the software reset (SRST_B bit of
 * UCR2).
 *
 * Values:
 * - 0 - Software reset inactive
 * - 1 - Software reset active
 */
/*@{*/
#define BP_UART_UTS_SOFTRST  (0U)          /*!< Bit position for UART_UTS_SOFTRST. */
#define BM_UART_UTS_SOFTRST  (0x00000001U) /*!< Bit mask for UART_UTS_SOFTRST. */
#define BS_UART_UTS_SOFTRST  (1U)          /*!< Bit field size in bits for UART_UTS_SOFTRST. */

/*! @brief Read current value of the UART_UTS_SOFTRST field. */
#define BR_UART_UTS_SOFTRST(x) (HW_UART_UTS(x).B.SOFTRST)

/*! @brief Format value for bitfield UART_UTS_SOFTRST. */
#define BF_UART_UTS_SOFTRST(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_SOFTRST) & BM_UART_UTS_SOFTRST)

/*! @brief Set the SOFTRST field to a new value. */
#define BW_UART_UTS_SOFTRST(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_SOFTRST) | BF_UART_UTS_SOFTRST(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field RXFULL[3] (RW)
 *
 * RxFIFO FULL. Indicates the RxFIFO is full.
 *
 * Values:
 * - 0 - The RxFIFO is not full
 * - 1 - The RxFIFO is full
 */
/*@{*/
#define BP_UART_UTS_RXFULL   (3U)          /*!< Bit position for UART_UTS_RXFULL. */
#define BM_UART_UTS_RXFULL   (0x00000008U) /*!< Bit mask for UART_UTS_RXFULL. */
#define BS_UART_UTS_RXFULL   (1U)          /*!< Bit field size in bits for UART_UTS_RXFULL. */

/*! @brief Read current value of the UART_UTS_RXFULL field. */
#define BR_UART_UTS_RXFULL(x) (HW_UART_UTS(x).B.RXFULL)

/*! @brief Format value for bitfield UART_UTS_RXFULL. */
#define BF_UART_UTS_RXFULL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_RXFULL) & BM_UART_UTS_RXFULL)

/*! @brief Set the RXFULL field to a new value. */
#define BW_UART_UTS_RXFULL(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_RXFULL) | BF_UART_UTS_RXFULL(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field TXFULL[4] (RW)
 *
 * TxFIFO FULL. Indicates the TxFIFO is full.
 *
 * Values:
 * - 0 - The TxFIFO is not full
 * - 1 - The TxFIFO is full
 */
/*@{*/
#define BP_UART_UTS_TXFULL   (4U)          /*!< Bit position for UART_UTS_TXFULL. */
#define BM_UART_UTS_TXFULL   (0x00000010U) /*!< Bit mask for UART_UTS_TXFULL. */
#define BS_UART_UTS_TXFULL   (1U)          /*!< Bit field size in bits for UART_UTS_TXFULL. */

/*! @brief Read current value of the UART_UTS_TXFULL field. */
#define BR_UART_UTS_TXFULL(x) (HW_UART_UTS(x).B.TXFULL)

/*! @brief Format value for bitfield UART_UTS_TXFULL. */
#define BF_UART_UTS_TXFULL(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_TXFULL) & BM_UART_UTS_TXFULL)

/*! @brief Set the TXFULL field to a new value. */
#define BW_UART_UTS_TXFULL(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_TXFULL) | BF_UART_UTS_TXFULL(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field RXEMPTY[5] (RW)
 *
 * RxFIFO Empty. Indicates the RxFIFO is empty.
 *
 * Values:
 * - 0 - The RxFIFO is not empty
 * - 1 - The RxFIFO is empty
 */
/*@{*/
#define BP_UART_UTS_RXEMPTY  (5U)          /*!< Bit position for UART_UTS_RXEMPTY. */
#define BM_UART_UTS_RXEMPTY  (0x00000020U) /*!< Bit mask for UART_UTS_RXEMPTY. */
#define BS_UART_UTS_RXEMPTY  (1U)          /*!< Bit field size in bits for UART_UTS_RXEMPTY. */

/*! @brief Read current value of the UART_UTS_RXEMPTY field. */
#define BR_UART_UTS_RXEMPTY(x) (HW_UART_UTS(x).B.RXEMPTY)

/*! @brief Format value for bitfield UART_UTS_RXEMPTY. */
#define BF_UART_UTS_RXEMPTY(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_RXEMPTY) & BM_UART_UTS_RXEMPTY)

/*! @brief Set the RXEMPTY field to a new value. */
#define BW_UART_UTS_RXEMPTY(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_RXEMPTY) | BF_UART_UTS_RXEMPTY(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field TXEMPTY[6] (RW)
 *
 * TxFIFO Empty. Indicates that the TxFIFO is empty.
 *
 * Values:
 * - 0 - The TxFIFO is not empty
 * - 1 - The TxFIFO is empty
 */
/*@{*/
#define BP_UART_UTS_TXEMPTY  (6U)          /*!< Bit position for UART_UTS_TXEMPTY. */
#define BM_UART_UTS_TXEMPTY  (0x00000040U) /*!< Bit mask for UART_UTS_TXEMPTY. */
#define BS_UART_UTS_TXEMPTY  (1U)          /*!< Bit field size in bits for UART_UTS_TXEMPTY. */

/*! @brief Read current value of the UART_UTS_TXEMPTY field. */
#define BR_UART_UTS_TXEMPTY(x) (HW_UART_UTS(x).B.TXEMPTY)

/*! @brief Format value for bitfield UART_UTS_TXEMPTY. */
#define BF_UART_UTS_TXEMPTY(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_TXEMPTY) & BM_UART_UTS_TXEMPTY)

/*! @brief Set the TXEMPTY field to a new value. */
#define BW_UART_UTS_TXEMPTY(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_TXEMPTY) | BF_UART_UTS_TXEMPTY(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field RXDBG[9] (RW)
 *
 * RX_fifo_debug_mode. This bit controls the operation of the RX fifo read
 * counter when in debug mode.
 *
 * Values:
 * - 0 - rx fifo read pointer does not increment
 * - 1 - rx_fifo read pointer increments as normal
 */
/*@{*/
#define BP_UART_UTS_RXDBG    (9U)          /*!< Bit position for UART_UTS_RXDBG. */
#define BM_UART_UTS_RXDBG    (0x00000200U) /*!< Bit mask for UART_UTS_RXDBG. */
#define BS_UART_UTS_RXDBG    (1U)          /*!< Bit field size in bits for UART_UTS_RXDBG. */

/*! @brief Read current value of the UART_UTS_RXDBG field. */
#define BR_UART_UTS_RXDBG(x) (HW_UART_UTS(x).B.RXDBG)

/*! @brief Format value for bitfield UART_UTS_RXDBG. */
#define BF_UART_UTS_RXDBG(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_RXDBG) & BM_UART_UTS_RXDBG)

/*! @brief Set the RXDBG field to a new value. */
#define BW_UART_UTS_RXDBG(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_RXDBG) | BF_UART_UTS_RXDBG(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field LOOPIR[10] (RW)
 *
 * Loop TX and RX for IR Test (LOOPIR). This bit controls loopback from
 * transmitter to receiver in the InfraRed interface.
 *
 * Values:
 * - 0 - No IR loop
 * - 1 - Connect IR transmitter to IR receiver
 */
/*@{*/
#define BP_UART_UTS_LOOPIR   (10U)         /*!< Bit position for UART_UTS_LOOPIR. */
#define BM_UART_UTS_LOOPIR   (0x00000400U) /*!< Bit mask for UART_UTS_LOOPIR. */
#define BS_UART_UTS_LOOPIR   (1U)          /*!< Bit field size in bits for UART_UTS_LOOPIR. */

/*! @brief Read current value of the UART_UTS_LOOPIR field. */
#define BR_UART_UTS_LOOPIR(x) (HW_UART_UTS(x).B.LOOPIR)

/*! @brief Format value for bitfield UART_UTS_LOOPIR. */
#define BF_UART_UTS_LOOPIR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_LOOPIR) & BM_UART_UTS_LOOPIR)

/*! @brief Set the LOOPIR field to a new value. */
#define BW_UART_UTS_LOOPIR(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_LOOPIR) | BF_UART_UTS_LOOPIR(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field DBGEN[11] (RW)
 *
 * debug_enable_B. This bit controls whether to respond to the debug_req input
 * signal.
 *
 * Values:
 * - 0 - UART will go into debug mode when debug_req is HIGH
 * - 1 - UART will not go into debug mode even if debug_req is HIGH
 */
/*@{*/
#define BP_UART_UTS_DBGEN    (11U)         /*!< Bit position for UART_UTS_DBGEN. */
#define BM_UART_UTS_DBGEN    (0x00000800U) /*!< Bit mask for UART_UTS_DBGEN. */
#define BS_UART_UTS_DBGEN    (1U)          /*!< Bit field size in bits for UART_UTS_DBGEN. */

/*! @brief Read current value of the UART_UTS_DBGEN field. */
#define BR_UART_UTS_DBGEN(x) (HW_UART_UTS(x).B.DBGEN)

/*! @brief Format value for bitfield UART_UTS_DBGEN. */
#define BF_UART_UTS_DBGEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_DBGEN) & BM_UART_UTS_DBGEN)

/*! @brief Set the DBGEN field to a new value. */
#define BW_UART_UTS_DBGEN(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_DBGEN) | BF_UART_UTS_DBGEN(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field LOOP[12] (RW)
 *
 * Loop TX and RX for Test. Controls loopback for test purposes. When LOOP is
 * high, the receiver input is internally connected to the transmitter and ignores
 * the RXD pin. The transmitter is unaffected by LOOP. If RXDMUXSEL (UCR3[2]) is
 * set to 1, the loopback is applied on serial and IrDA signals. If RXDMUXSEL is
 * set to 0, the loopback is only applied on serial signals.
 *
 * Values:
 * - 0 - Normal receiver operation
 * - 1 - Internally connect the transmitter output to the receiver input
 */
/*@{*/
#define BP_UART_UTS_LOOP     (12U)         /*!< Bit position for UART_UTS_LOOP. */
#define BM_UART_UTS_LOOP     (0x00001000U) /*!< Bit mask for UART_UTS_LOOP. */
#define BS_UART_UTS_LOOP     (1U)          /*!< Bit field size in bits for UART_UTS_LOOP. */

/*! @brief Read current value of the UART_UTS_LOOP field. */
#define BR_UART_UTS_LOOP(x)  (HW_UART_UTS(x).B.LOOP)

/*! @brief Format value for bitfield UART_UTS_LOOP. */
#define BF_UART_UTS_LOOP(v)  ((uint32_t)((uint32_t)(v) << BP_UART_UTS_LOOP) & BM_UART_UTS_LOOP)

/*! @brief Set the LOOP field to a new value. */
#define BW_UART_UTS_LOOP(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_LOOP) | BF_UART_UTS_LOOP(v)))
/*@}*/

/*!
 * @name Register UART_UTS, field FRCPERR[13] (RW)
 *
 * Force Parity Error. Forces the transmitter to generate a parity error if
 * parity is enabled. FRCPERR is provided for system debugging.
 *
 * Values:
 * - 0 - Generate normal parity
 * - 1 - Generate inverted parity (error)
 */
/*@{*/
#define BP_UART_UTS_FRCPERR  (13U)         /*!< Bit position for UART_UTS_FRCPERR. */
#define BM_UART_UTS_FRCPERR  (0x00002000U) /*!< Bit mask for UART_UTS_FRCPERR. */
#define BS_UART_UTS_FRCPERR  (1U)          /*!< Bit field size in bits for UART_UTS_FRCPERR. */

/*! @brief Read current value of the UART_UTS_FRCPERR field. */
#define BR_UART_UTS_FRCPERR(x) (HW_UART_UTS(x).B.FRCPERR)

/*! @brief Format value for bitfield UART_UTS_FRCPERR. */
#define BF_UART_UTS_FRCPERR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UTS_FRCPERR) & BM_UART_UTS_FRCPERR)

/*! @brief Set the FRCPERR field to a new value. */
#define BW_UART_UTS_FRCPERR(x, v) (HW_UART_UTS_WR(x, (HW_UART_UTS_RD(x) & ~BM_UART_UTS_FRCPERR) | BF_UART_UTS_FRCPERR(v)))
/*@}*/

/*******************************************************************************
 * HW_UART_UMCR - UART RS-485 Mode Control Register
 ******************************************************************************/

/*!
 * @brief HW_UART_UMCR - UART RS-485 Mode Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_uart_umcr
{
    uint32_t U;
    struct _hw_uart_umcr_bitfields
    {
        uint32_t MDEN : 1;             /*!< [0]  */
        uint32_t SLAM : 1;             /*!< [1]  */
        uint32_t TXB8 : 1;             /*!< [2]  */
        uint32_t SADEN : 1;            /*!< [3]  */
        uint32_t RESERVED0 : 4;        /*!< [7:4]  */
        uint32_t SLADDR : 8;           /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_uart_umcr_t;

/*!
 * @name Constants and macros for entire UART_UMCR register
 */
/*@{*/
#define HW_UART_UMCR_ADDR(x)     ((uintptr_t)(x) + 0xB8U)

#define HW_UART_UMCR(x)          (*(__IO hw_uart_umcr_t *) HW_UART_UMCR_ADDR(x))
#define HW_UART_UMCR_RD(x)       (HW_UART_UMCR(x).U)
#define HW_UART_UMCR_WR(x, v)    (HW_UART_UMCR(x).U = (v))
#define HW_UART_UMCR_SET(x, v)   (HW_UART_UMCR_WR(x, HW_UART_UMCR_RD(x) |  (v)))
#define HW_UART_UMCR_CLR(x, v)   (HW_UART_UMCR_WR(x, HW_UART_UMCR_RD(x) & ~(v)))
#define HW_UART_UMCR_TOG(x, v)   (HW_UART_UMCR_WR(x, HW_UART_UMCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual UART_UMCR bitfields
 */

/*!
 * @name Register UART_UMCR, field MDEN[0] (RW)
 *
 * 9-bit data or Multidrop Mode (RS-485) Enable.
 *
 * Values:
 * - 0 - Normal RS-232 or IrDA mode, see for detail.
 * - 1 - Enable RS-485 mode, see for detail
 */
/*@{*/
#define BP_UART_UMCR_MDEN    (0U)          /*!< Bit position for UART_UMCR_MDEN. */
#define BM_UART_UMCR_MDEN    (0x00000001U) /*!< Bit mask for UART_UMCR_MDEN. */
#define BS_UART_UMCR_MDEN    (1U)          /*!< Bit field size in bits for UART_UMCR_MDEN. */

/*! @brief Read current value of the UART_UMCR_MDEN field. */
#define BR_UART_UMCR_MDEN(x) (HW_UART_UMCR(x).B.MDEN)

/*! @brief Format value for bitfield UART_UMCR_MDEN. */
#define BF_UART_UMCR_MDEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UMCR_MDEN) & BM_UART_UMCR_MDEN)

/*! @brief Set the MDEN field to a new value. */
#define BW_UART_UMCR_MDEN(x, v) (HW_UART_UMCR_WR(x, (HW_UART_UMCR_RD(x) & ~BM_UART_UMCR_MDEN) | BF_UART_UMCR_MDEN(v)))
/*@}*/

/*!
 * @name Register UART_UMCR, field SLAM[1] (RW)
 *
 * RS-485 Slave Address Detect Mode Selection.
 *
 * Values:
 * - 0 - Select Normal Address Detect mode
 * - 1 - Select Automatic Address Detect mode
 */
/*@{*/
#define BP_UART_UMCR_SLAM    (1U)          /*!< Bit position for UART_UMCR_SLAM. */
#define BM_UART_UMCR_SLAM    (0x00000002U) /*!< Bit mask for UART_UMCR_SLAM. */
#define BS_UART_UMCR_SLAM    (1U)          /*!< Bit field size in bits for UART_UMCR_SLAM. */

/*! @brief Read current value of the UART_UMCR_SLAM field. */
#define BR_UART_UMCR_SLAM(x) (HW_UART_UMCR(x).B.SLAM)

/*! @brief Format value for bitfield UART_UMCR_SLAM. */
#define BF_UART_UMCR_SLAM(v) ((uint32_t)((uint32_t)(v) << BP_UART_UMCR_SLAM) & BM_UART_UMCR_SLAM)

/*! @brief Set the SLAM field to a new value. */
#define BW_UART_UMCR_SLAM(x, v) (HW_UART_UMCR_WR(x, (HW_UART_UMCR_RD(x) & ~BM_UART_UMCR_SLAM) | BF_UART_UMCR_SLAM(v)))
/*@}*/

/*!
 * @name Register UART_UMCR, field TXB8[2] (RW)
 *
 * Transmit RS-485 bit 8 (the ninth bit or 9th bit). In RS-485 mode, software
 * writes TXB8 bit as the 9th data bit to be transmitted.
 *
 * Values:
 * - 0 - 0 will be transmitted as the RS485 9th data bit
 * - 1 - 1 will be transmitted as the RS485 9th data bit
 */
/*@{*/
#define BP_UART_UMCR_TXB8    (2U)          /*!< Bit position for UART_UMCR_TXB8. */
#define BM_UART_UMCR_TXB8    (0x00000004U) /*!< Bit mask for UART_UMCR_TXB8. */
#define BS_UART_UMCR_TXB8    (1U)          /*!< Bit field size in bits for UART_UMCR_TXB8. */

/*! @brief Read current value of the UART_UMCR_TXB8 field. */
#define BR_UART_UMCR_TXB8(x) (HW_UART_UMCR(x).B.TXB8)

/*! @brief Format value for bitfield UART_UMCR_TXB8. */
#define BF_UART_UMCR_TXB8(v) ((uint32_t)((uint32_t)(v) << BP_UART_UMCR_TXB8) & BM_UART_UMCR_TXB8)

/*! @brief Set the TXB8 field to a new value. */
#define BW_UART_UMCR_TXB8(x, v) (HW_UART_UMCR_WR(x, (HW_UART_UMCR_RD(x) & ~BM_UART_UMCR_TXB8) | BF_UART_UMCR_TXB8(v)))
/*@}*/

/*!
 * @name Register UART_UMCR, field SADEN[3] (RW)
 *
 * RS-485 Slave Address Detected Interrupt Enable.
 *
 * Values:
 * - 0 - Disable RS-485 Slave Address Detected Interrupt
 * - 1 - Enable RS-485 Slave Address Detected Interrupt
 */
/*@{*/
#define BP_UART_UMCR_SADEN   (3U)          /*!< Bit position for UART_UMCR_SADEN. */
#define BM_UART_UMCR_SADEN   (0x00000008U) /*!< Bit mask for UART_UMCR_SADEN. */
#define BS_UART_UMCR_SADEN   (1U)          /*!< Bit field size in bits for UART_UMCR_SADEN. */

/*! @brief Read current value of the UART_UMCR_SADEN field. */
#define BR_UART_UMCR_SADEN(x) (HW_UART_UMCR(x).B.SADEN)

/*! @brief Format value for bitfield UART_UMCR_SADEN. */
#define BF_UART_UMCR_SADEN(v) ((uint32_t)((uint32_t)(v) << BP_UART_UMCR_SADEN) & BM_UART_UMCR_SADEN)

/*! @brief Set the SADEN field to a new value. */
#define BW_UART_UMCR_SADEN(x, v) (HW_UART_UMCR_WR(x, (HW_UART_UMCR_RD(x) & ~BM_UART_UMCR_SADEN) | BF_UART_UMCR_SADEN(v)))
/*@}*/

/*!
 * @name Register UART_UMCR, field SLADDR[15:8] (RW)
 *
 * RS-485 Slave Address Character. Holds the selected slave adress character
 * that the receiver wil try to detect.
 */
/*@{*/
#define BP_UART_UMCR_SLADDR  (8U)          /*!< Bit position for UART_UMCR_SLADDR. */
#define BM_UART_UMCR_SLADDR  (0x0000FF00U) /*!< Bit mask for UART_UMCR_SLADDR. */
#define BS_UART_UMCR_SLADDR  (8U)          /*!< Bit field size in bits for UART_UMCR_SLADDR. */

/*! @brief Read current value of the UART_UMCR_SLADDR field. */
#define BR_UART_UMCR_SLADDR(x) (HW_UART_UMCR(x).B.SLADDR)

/*! @brief Format value for bitfield UART_UMCR_SLADDR. */
#define BF_UART_UMCR_SLADDR(v) ((uint32_t)((uint32_t)(v) << BP_UART_UMCR_SLADDR) & BM_UART_UMCR_SLADDR)

/*! @brief Set the SLADDR field to a new value. */
#define BW_UART_UMCR_SLADDR(x, v) (HW_UART_UMCR_WR(x, (HW_UART_UMCR_RD(x) & ~BM_UART_UMCR_SLADDR) | BF_UART_UMCR_SLADDR(v)))
/*@}*/

/*******************************************************************************
 * hw_uart_t - module struct
 ******************************************************************************/
/*!
 * @brief All UART module registers.
 */
#pragma pack(1)
typedef struct _hw_uart
{
    __I hw_uart_urxd_t URXD;               /*!< [0x0] UART Receiver Register */
    uint8_t _reserved0[60];
    __IO hw_uart_utxd_t UTXD;              /*!< [0x40] UART Transmitter Register */
    uint8_t _reserved1[60];
    __IO hw_uart_ucr1_t UCR1;              /*!< [0x80] UART Control Register 1 */
    __IO hw_uart_ucr2_t UCR2;              /*!< [0x84] UART Control Register 2 */
    __IO hw_uart_ucr3_t UCR3;              /*!< [0x88] UART Control Register 3 */
    __IO hw_uart_ucr4_t UCR4;              /*!< [0x8C] UART Control Register 4 */
    __IO hw_uart_ufcr_t UFCR;              /*!< [0x90] UART FIFO Control Register */
    __IO hw_uart_usr1_t USR1;              /*!< [0x94] UART Status Register 1 */
    __IO hw_uart_usr2_t USR2;              /*!< [0x98] UART Status Register 2 */
    __IO hw_uart_uesc_t UESC;              /*!< [0x9C] UART Escape Character Register */
    __IO hw_uart_utim_t UTIM;              /*!< [0xA0] UART Escape Timer Register */
    __IO hw_uart_ubir_t UBIR;              /*!< [0xA4] UART BRM Incremental Register */
    __IO hw_uart_ubmr_t UBMR;              /*!< [0xA8] UART BRM Modulator Register */
    __I hw_uart_ubrc_t UBRC;               /*!< [0xAC] UART Baud Rate Count Register */
    __IO hw_uart_onems_t ONEMS;            /*!< [0xB0] UART One Millisecond Register */
    __IO hw_uart_uts_t UTS;                /*!< [0xB4] UART Test Register */
    __IO hw_uart_umcr_t UMCR;              /*!< [0xB8] UART RS-485 Mode Control Register */
} hw_uart_t;
#pragma pack()

/*! @brief Macro to access all UART registers. */
/*! @param x UART module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_UART_REGS(UART1_BASE)</code>. */
#define HW_UART_REGS(x) (*(hw_uart_t *)(x))

/*
 * iMX6DP USB
 *
 * USB
 *
 * Registers defined in this header file:
 * - HW_USB_UOG_ID - Identification register
 * - HW_USB_UOG_HWGENERAL - Hardware General
 * - HW_USB_UOG_HWHOST - Host Hardware Parameters
 * - HW_USB_UOG_HWDEVICE - Device Hardware Parameters
 * - HW_USB_UOG_HWTXBUF - TX Buffer Hardware Parameters
 * - HW_USB_UOG_HWRXBUF - RX Buffer Hardware Parameters
 * - HW_USB_UOG_GPTIMER0LD - General Purpose Timer #0 Load
 * - HW_USB_UOG_GPTIMER0CTRL - General Purpose Timer #0 Controller
 * - HW_USB_UOG_GPTIMER1LD - General Purpose Timer #1 Load
 * - HW_USB_UOG_GPTIMER1CTRL - General Purpose Timer #1 Controller
 * - HW_USB_UOG_SBUSCFG - System Bus Config
 * - HW_USB_UOG_CAPLENGTH - Capability Registers Length
 * - HW_USB_UOG_HCIVERSION - Host Controller Interface Version
 * - HW_USB_UOG_HCSPARAMS - Host Controller Structural Parameters
 * - HW_USB_UOG_HCCPARAMS - Host Controller Capability Parameters
 * - HW_USB_UOG_DCIVERSION - Device Controller Interface Version
 * - HW_USB_UOG_DCCPARAMS - Device Controller Capability Parameters
 * - HW_USB_UOG_USBCMD - USB Command Register
 * - HW_USB_UOG_USBSTS - USB Status Register
 * - HW_USB_UOG_USBINTR - Interrupt Enable Register
 * - HW_USB_UOG_FRINDEX - USB Frame Index
 * - HW_USB_UOG_DEVICEADDR - Device Address
 * - HW_USB_UOG_PERIODICLISTBASE - Frame List Base Address
 * - HW_USB_UOG_ASYNCLISTADDR - Next Asynch. Address
 * - HW_USB_UOG_ENDPTLISTADDR - Endpoint List Address
 * - HW_USB_UOG_BURSTSIZE - Programmable Burst Size
 * - HW_USB_UOG_TXFILLTUNING - TX FIFO Fill Tuning
 * - HW_USB_UOG_ENDPTNAK - Endpoint NAK
 * - HW_USB_UOG_ENDPTNAKEN - Endpoint NAK Enable
 * - HW_USB_UOG_CONFIGFLAG - Configure Flag Register
 * - HW_USB_UOG_PORTSC1 - Port Status & Control
 * - HW_USB_UOG_OTGSC - On-The-Go Status & control
 * - HW_USB_UOG_USBMODE - USB Device Mode
 * - HW_USB_UOG_ENDPTSETUPSTAT - Endpoint Setup Status
 * - HW_USB_UOG_ENDPTPRIME - Endpoint Prime
 * - HW_USB_UOG_ENDPTFLUSH - Endpoint Flush
 * - HW_USB_UOG_ENDPTSTAT - Endpoint Status
 * - HW_USB_UOG_ENDPTCOMPLETE - Endpoint Complete
 * - HW_USB_UOG_ENDPTCTRL0 - Endpoint Control0
 * - HW_USB_UOG_ENDPTCTRL1 - Endpoint Control 1
 * - HW_USB_UOG_ENDPTCTRL2 - Endpoint Control 2
 * - HW_USB_UOG_ENDPTCTRL3 - Endpoint Control 3
 * - HW_USB_UOG_ENDPTCTRL4 - Endpoint Control 4
 * - HW_USB_UOG_ENDPTCTRL5 - Endpoint Control 5
 * - HW_USB_UOG_ENDPTCTRL6 - Endpoint Control 6
 * - HW_USB_UOG_ENDPTCTRL7 - Endpoint Control 7
 * - HW_USB_UH1_ID - Identification register
 * - HW_USB_UH1_HWGENERAL - Hardware General
 * - HW_USB_UH1_HWHOST - Host Hardware Parameters
 * - HW_USB_UH1_HWTXBUF - TX Buffer Hardware Parameters
 * - HW_USB_UH1_HWRXBUF - RX Buffer Hardware Parameters
 * - HW_USB_UH1_GPTIMER0LD - General Purpose Timer #0 Load
 * - HW_USB_UH1_GPTIMER0CTRL - General Purpose Timer #0 Controller
 * - HW_USB_UH1_GPTIMER1LD - General Purpose Timer #1 Load
 * - HW_USB_UH1_GPTIMER1CTRL - General Purpose Timer #1 Controller
 * - HW_USB_UH1_SBUSCFG - System Bus Config
 * - HW_USB_UH1_CAPLENGTH - Capability Registers Length
 * - HW_USB_UH1_HCIVERSION - Host Controller Interface Version
 * - HW_USB_UH1_HCSPARAMS - Host Controller Structural Parameters
 * - HW_USB_UH1_HCCPARAMS - Host Controller Capability Parameters
 * - HW_USB_UH1_USBCMD - USB Command Register
 * - HW_USB_UH1_USBSTS - USB Status Register
 * - HW_USB_UH1_USBINTR - Interrupt Enable Register
 * - HW_USB_UH1_FRINDEX - USB Frame Index
 * - HW_USB_UH1_PERIODICLISTBASE - Frame List Base Address
 * - HW_USB_UH1_ASYNCLISTADDR - Next Asynch. Address
 * - HW_USB_UH1_BURSTSIZE - Programmable Burst Size
 * - HW_USB_UH1_TXFILLTUNING - TX FIFO Fill Tuning
 * - HW_USB_UH1_CONFIGFLAG - Configure Flag Register
 * - HW_USB_UH1_PORTSC1 - Port Status & Control
 * - HW_USB_UH1_USBMODE - USB Device Mode
 * - HW_USB_UH2_ID - Identification register
 * - HW_USB_UH2_HWGENERAL - Hardware General
 * - HW_USB_UH2_HWHOST - Host Hardware Parameters
 * - HW_USB_UH2_HWTXBUF - TX Buffer Hardware Parameters
 * - HW_USB_UH2_HWRXBUF - RX Buffer Hardware Parameters
 * - HW_USB_UH2_GPTIMER0LD - General Purpose Timer #0 Load
 * - HW_USB_UH2_GPTIMER0CTRL - General Purpose Timer #0 Controller
 * - HW_USB_UH2_GPTIMER1LD - General Purpose Timer #1 Load
 * - HW_USB_UH2_GPTIMER1CTRL - General Purpose Timer #1 Controller
 * - HW_USB_UH2_SBUSCFG - System Bus Config
 * - HW_USB_UH2_CAPLENGTH - Capability Registers Length
 * - HW_USB_UH2_HCIVERSION - Host Controller Interface Version
 * - HW_USB_UH2_HCSPARAMS - Host Controller Structural Parameters
 * - HW_USB_UH2_HCCPARAMS - Host Controller Capability Parameters
 * - HW_USB_UH2_USBCMD - USB Command Register
 * - HW_USB_UH2_USBSTS - USB Status Register
 * - HW_USB_UH2_USBINTR - Interrupt Enable Register
 * - HW_USB_UH2_FRINDEX - USB Frame Index
 * - HW_USB_UH2_PERIODICLISTBASE - Frame List Base Address
 * - HW_USB_UH2_ASYNCLISTADDR - Next Asynch. Address
 * - HW_USB_UH2_BURSTSIZE - Programmable Burst Size
 * - HW_USB_UH2_TXFILLTUNING - TX FIFO Fill Tuning
 * - HW_USB_UH2_CONFIGFLAG - Configure Flag Register
 * - HW_USB_UH2_PORTSC1 - Port Status & Control
 * - HW_USB_UH2_USBMODE - USB Device Mode
 * - HW_USB_UH3_ID - Identification register
 * - HW_USB_UH3_HWGENERAL - Hardware General
 * - HW_USB_UH3_HWHOST - Host Hardware Parameters
 * - HW_USB_UH3_HWTXBUF - TX Buffer Hardware Parameters
 * - HW_USB_UH3_HWRXBUF - RX Buffer Hardware Parameters
 * - HW_USB_UH3_GPTIMER0LD - General Purpose Timer #0 Load
 * - HW_USB_UH3_GPTIMER0CTRL - General Purpose Timer #0 Controller
 * - HW_USB_UH3_GPTIMER1LD - General Purpose Timer #1 Load
 * - HW_USB_UH3_GPTIMER1CTRL - General Purpose Timer #1 Controller
 * - HW_USB_UH3_SBUSCFG - System Bus Config
 * - HW_USB_UH3_CAPLENGTH - Capability Registers Length
 * - HW_USB_UH3_HCIVERSION - Host Controller Interface Version
 * - HW_USB_UH3_HCSPARAMS - Host Controller Structural Parameters
 * - HW_USB_UH3_HCCPARAMS - Host Controller Capability Parameters
 * - HW_USB_UH3_USBCMD - USB Command Register
 * - HW_USB_UH3_USBSTS - USB Status Register
 * - HW_USB_UH3_USBINTR - Interrupt Enable Register
 * - HW_USB_UH3_FRINDEX - USB Frame Index
 * - HW_USB_UH3_PERIODICLISTBASE - Frame List Base Address
 * - HW_USB_UH3_ASYNCLISTADDR - Next Asynch. Address
 * - HW_USB_UH3_BURSTSIZE - Programmable Burst Size
 * - HW_USB_UH3_TXFILLTUNING - TX FIFO Fill Tuning
 * - HW_USB_UH3_CONFIGFLAG - Configure Flag Register
 * - HW_USB_UH3_PORTSC1 - Port Status & Control
 * - HW_USB_UH3_USBMODE - USB Device Mode
 *
 * - hw_usb_t - Struct containing all module registers.
 */

#define HW_USB_INSTANCE_COUNT (1U) /*!< Number of instances of the USB module. */
#define HW_USB (0U) /*!< Instance number for USB. */
#define USB_BASE              (0x2184000U) /*!< Base address for USB. */
/*! Array initializer of USB base addresses. */
#define USB_BASE_ADDRS        { USB_BASE }

/*******************************************************************************
 * HW_USB_UOG_ID - Identification register
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ID - Identification register (RO)
 *
 * Reset value: 0xE401FA05U
 *
 * The ID register identifies the USB 2.0 High-Speed core and its revision.
 */
typedef union _hw_usb_uog_id
{
    uint32_t U;
    struct _hw_usb_uog_id_bitfields
    {
        uint32_t ID : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t NID : 6;              /*!< [13:8]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t REVISION : 8;         /*!< [23:16]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_id_t;

/*!
 * @name Constants and macros for entire USB_UOG_ID register
 */
/*@{*/
#define HW_USB_UOG_ID_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_USB_UOG_ID(x)         (*(__I hw_usb_uog_id_t *) HW_USB_UOG_ID_ADDR(x))
#define HW_USB_UOG_ID_RD(x)      (HW_USB_UOG_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ID bitfields
 */

/*!
 * @name Register USB_UOG_ID, field ID[5:0] (RO)
 *
 * Configuration number. This number is set to 0x05 and indicates that the
 * peripheral is USB 2.0 High-Speed core.
 */
/*@{*/
#define BP_USB_UOG_ID_ID     (0U)          /*!< Bit position for USB_UOG_ID_ID. */
#define BM_USB_UOG_ID_ID     (0x0000003FU) /*!< Bit mask for USB_UOG_ID_ID. */
#define BS_USB_UOG_ID_ID     (6U)          /*!< Bit field size in bits for USB_UOG_ID_ID. */

/*! @brief Read current value of the USB_UOG_ID_ID field. */
#define BR_USB_UOG_ID_ID(x)  (HW_USB_UOG_ID(x).B.ID)
/*@}*/

/*!
 * @name Register USB_UOG_ID, field NID[13:8] (RO)
 *
 * Complement version of ID
 */
/*@{*/
#define BP_USB_UOG_ID_NID    (8U)          /*!< Bit position for USB_UOG_ID_NID. */
#define BM_USB_UOG_ID_NID    (0x00003F00U) /*!< Bit mask for USB_UOG_ID_NID. */
#define BS_USB_UOG_ID_NID    (6U)          /*!< Bit field size in bits for USB_UOG_ID_NID. */

/*! @brief Read current value of the USB_UOG_ID_NID field. */
#define BR_USB_UOG_ID_NID(x) (HW_USB_UOG_ID(x).B.NID)
/*@}*/

/*!
 * @name Register USB_UOG_ID, field REVISION[23:16] (RO)
 *
 * Revision number of the controller core.
 */
/*@{*/
#define BP_USB_UOG_ID_REVISION (16U)       /*!< Bit position for USB_UOG_ID_REVISION. */
#define BM_USB_UOG_ID_REVISION (0x00FF0000U) /*!< Bit mask for USB_UOG_ID_REVISION. */
#define BS_USB_UOG_ID_REVISION (8U)        /*!< Bit field size in bits for USB_UOG_ID_REVISION. */

/*! @brief Read current value of the USB_UOG_ID_REVISION field. */
#define BR_USB_UOG_ID_REVISION(x) (HW_USB_UOG_ID(x).B.REVISION)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HWGENERAL - Hardware General
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HWGENERAL - Hardware General (RO)
 *
 * Reset value: 0x00000015U
 *
 * General hardware parameters as defined in System Level Issues and Core
 * Configuration. The reset value could vary from instance to instance. Please see the
 * detail in bit field description and ignore reset value in summary table in
 * this case!
 */
typedef union _hw_usb_uog_hwgeneral
{
    uint32_t U;
    struct _hw_usb_uog_hwgeneral_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t PHYW : 2;             /*!< [5:4]  */
        uint32_t PHYM : 3;             /*!< [8:6]  */
        uint32_t SM : 2;               /*!< [10:9]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_usb_uog_hwgeneral_t;

/*!
 * @name Constants and macros for entire USB_UOG_HWGENERAL register
 */
/*@{*/
#define HW_USB_UOG_HWGENERAL_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_USB_UOG_HWGENERAL(x)  (*(__I hw_usb_uog_hwgeneral_t *) HW_USB_UOG_HWGENERAL_ADDR(x))
#define HW_USB_UOG_HWGENERAL_RD(x) (HW_USB_UOG_HWGENERAL(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HWGENERAL bitfields
 */

/*!
 * @name Register USB_UOG_HWGENERAL, field PHYW[5:4] (RO)
 *
 * Data width of the transciever connected to the controller core. PHYW bit
 * reset value is PHYW bit reset value is '01b'.
 *
 * Values:
 * - 00 - 8 bit wide data bus Software non-programmable
 * - 01 - 16 bit wide data bus Software non-programmable
 * - 10 - Reset to 8 bit wide data bus Software programmable
 * - 11 - Reset to 16 bit wide data bus Software programmable
 */
/*@{*/
#define BP_USB_UOG_HWGENERAL_PHYW (4U)     /*!< Bit position for USB_UOG_HWGENERAL_PHYW. */
#define BM_USB_UOG_HWGENERAL_PHYW (0x00000030U) /*!< Bit mask for USB_UOG_HWGENERAL_PHYW. */
#define BS_USB_UOG_HWGENERAL_PHYW (2U)     /*!< Bit field size in bits for USB_UOG_HWGENERAL_PHYW. */

/*! @brief Read current value of the USB_UOG_HWGENERAL_PHYW field. */
#define BR_USB_UOG_HWGENERAL_PHYW(x) (HW_USB_UOG_HWGENERAL(x).B.PHYW)
/*@}*/

/*!
 * @name Register USB_UOG_HWGENERAL, field PHYM[8:6] (RO)
 *
 * Transciever type PHYM bit reset value: '0000b' for OTG controller core,
 * '0100b' for Host-only controller core.
 *
 * Values:
 * - 000 - UTMI/UMTI+
 * - 001 - ULPI DDR
 * - 010 - ULPI
 * - 011 - Serial Only
 * - 100 - Software programmable - reset to UTMI/UTMI+
 * - 101 - Software programmable - reset to ULPI DDR
 * - 110 - Software programmable - reset to ULPI
 * - 111 - Software programmable - reset to Serial
 */
/*@{*/
#define BP_USB_UOG_HWGENERAL_PHYM (6U)     /*!< Bit position for USB_UOG_HWGENERAL_PHYM. */
#define BM_USB_UOG_HWGENERAL_PHYM (0x000001C0U) /*!< Bit mask for USB_UOG_HWGENERAL_PHYM. */
#define BS_USB_UOG_HWGENERAL_PHYM (3U)     /*!< Bit field size in bits for USB_UOG_HWGENERAL_PHYM. */

/*! @brief Read current value of the USB_UOG_HWGENERAL_PHYM field. */
#define BR_USB_UOG_HWGENERAL_PHYM(x) (HW_USB_UOG_HWGENERAL(x).B.PHYM)
/*@}*/

/*!
 * @name Register USB_UOG_HWGENERAL, field SM[10:9] (RO)
 *
 * Serial interface mode capability SM bit reset value is '00b'
 *
 * Values:
 * - 00 - No Serial Engine, always use parallel signalling.
 * - 01 - Serial Engine present, always use serial signalling for FS/LS.
 * - 10 - Software programmable - Reset to use parallel signalling for FS/LS
 * - 11 - Software programmable - Reset to use serial signalling for FS/LS
 */
/*@{*/
#define BP_USB_UOG_HWGENERAL_SM (9U)       /*!< Bit position for USB_UOG_HWGENERAL_SM. */
#define BM_USB_UOG_HWGENERAL_SM (0x00000600U) /*!< Bit mask for USB_UOG_HWGENERAL_SM. */
#define BS_USB_UOG_HWGENERAL_SM (2U)       /*!< Bit field size in bits for USB_UOG_HWGENERAL_SM. */

/*! @brief Read current value of the USB_UOG_HWGENERAL_SM field. */
#define BR_USB_UOG_HWGENERAL_SM(x) (HW_USB_UOG_HWGENERAL(x).B.SM)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HWHOST - Host Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HWHOST - Host Hardware Parameters (RO)
 *
 * Reset value: 0x10020001U
 */
typedef union _hw_usb_uog_hwhost
{
    uint32_t U;
    struct _hw_usb_uog_hwhost_bitfields
    {
        uint32_t HC : 1;               /*!< [0]  */
        uint32_t NPORT : 3;            /*!< [3:1]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_uog_hwhost_t;

/*!
 * @name Constants and macros for entire USB_UOG_HWHOST register
 */
/*@{*/
#define HW_USB_UOG_HWHOST_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_USB_UOG_HWHOST(x)     (*(__I hw_usb_uog_hwhost_t *) HW_USB_UOG_HWHOST_ADDR(x))
#define HW_USB_UOG_HWHOST_RD(x)  (HW_USB_UOG_HWHOST(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HWHOST bitfields
 */

/*!
 * @name Register USB_UOG_HWHOST, field HC[0] (RO)
 *
 * Host Capable. Indicating whether host operation mode is supported or not.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_USB_UOG_HWHOST_HC (0U)          /*!< Bit position for USB_UOG_HWHOST_HC. */
#define BM_USB_UOG_HWHOST_HC (0x00000001U) /*!< Bit mask for USB_UOG_HWHOST_HC. */
#define BS_USB_UOG_HWHOST_HC (1U)          /*!< Bit field size in bits for USB_UOG_HWHOST_HC. */

/*! @brief Read current value of the USB_UOG_HWHOST_HC field. */
#define BR_USB_UOG_HWHOST_HC(x) (HW_USB_UOG_HWHOST(x).B.HC)
/*@}*/

/*!
 * @name Register USB_UOG_HWHOST, field NPORT[3:1] (RO)
 *
 * The Nmber of downstream ports supported by the host controller is (NPORT+1).
 * When these bits value is '000', it indicates a single-port host controller.
 */
/*@{*/
#define BP_USB_UOG_HWHOST_NPORT (1U)       /*!< Bit position for USB_UOG_HWHOST_NPORT. */
#define BM_USB_UOG_HWHOST_NPORT (0x0000000EU) /*!< Bit mask for USB_UOG_HWHOST_NPORT. */
#define BS_USB_UOG_HWHOST_NPORT (3U)       /*!< Bit field size in bits for USB_UOG_HWHOST_NPORT. */

/*! @brief Read current value of the USB_UOG_HWHOST_NPORT field. */
#define BR_USB_UOG_HWHOST_NPORT(x) (HW_USB_UOG_HWHOST(x).B.NPORT)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HWDEVICE - Device Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HWDEVICE - Device Hardware Parameters (RO)
 *
 * Reset value: 0x00000011U
 *
 * This register is only available in OTG core.
 */
typedef union _hw_usb_uog_hwdevice
{
    uint32_t U;
    struct _hw_usb_uog_hwdevice_bitfields
    {
        uint32_t DC : 1;               /*!< [0]  */
        uint32_t DEVEP : 5;            /*!< [5:1]  */
        uint32_t RESERVED0 : 26;       /*!< [31:6]  */
    } B;
} hw_usb_uog_hwdevice_t;

/*!
 * @name Constants and macros for entire USB_UOG_HWDEVICE register
 */
/*@{*/
#define HW_USB_UOG_HWDEVICE_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_USB_UOG_HWDEVICE(x)   (*(__I hw_usb_uog_hwdevice_t *) HW_USB_UOG_HWDEVICE_ADDR(x))
#define HW_USB_UOG_HWDEVICE_RD(x) (HW_USB_UOG_HWDEVICE(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HWDEVICE bitfields
 */

/*!
 * @name Register USB_UOG_HWDEVICE, field DC[0] (RO)
 *
 * Device Capable. Indicating whether device operation mode is supported or not.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_USB_UOG_HWDEVICE_DC (0U)        /*!< Bit position for USB_UOG_HWDEVICE_DC. */
#define BM_USB_UOG_HWDEVICE_DC (0x00000001U) /*!< Bit mask for USB_UOG_HWDEVICE_DC. */
#define BS_USB_UOG_HWDEVICE_DC (1U)        /*!< Bit field size in bits for USB_UOG_HWDEVICE_DC. */

/*! @brief Read current value of the USB_UOG_HWDEVICE_DC field. */
#define BR_USB_UOG_HWDEVICE_DC(x) (HW_USB_UOG_HWDEVICE(x).B.DC)
/*@}*/

/*!
 * @name Register USB_UOG_HWDEVICE, field DEVEP[5:1] (RO)
 *
 * Device Endpoint Number
 */
/*@{*/
#define BP_USB_UOG_HWDEVICE_DEVEP (1U)     /*!< Bit position for USB_UOG_HWDEVICE_DEVEP. */
#define BM_USB_UOG_HWDEVICE_DEVEP (0x0000003EU) /*!< Bit mask for USB_UOG_HWDEVICE_DEVEP. */
#define BS_USB_UOG_HWDEVICE_DEVEP (5U)     /*!< Bit field size in bits for USB_UOG_HWDEVICE_DEVEP. */

/*! @brief Read current value of the USB_UOG_HWDEVICE_DEVEP field. */
#define BR_USB_UOG_HWDEVICE_DEVEP(x) (HW_USB_UOG_HWDEVICE(x).B.DEVEP)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HWTXBUF - TX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HWTXBUF - TX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x80080B08U
 */
typedef union _hw_usb_uog_hwtxbuf
{
    uint32_t U;
    struct _hw_usb_uog_hwtxbuf_bitfields
    {
        uint32_t TXBURST : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t TXCHANADD : 8;        /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_hwtxbuf_t;

/*!
 * @name Constants and macros for entire USB_UOG_HWTXBUF register
 */
/*@{*/
#define HW_USB_UOG_HWTXBUF_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_USB_UOG_HWTXBUF(x)    (*(__I hw_usb_uog_hwtxbuf_t *) HW_USB_UOG_HWTXBUF_ADDR(x))
#define HW_USB_UOG_HWTXBUF_RD(x) (HW_USB_UOG_HWTXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HWTXBUF bitfields
 */

/*!
 * @name Register USB_UOG_HWTXBUF, field TXBURST[7:0] (RO)
 *
 * Default burst size for memory to TX buffer transfer. This is reset value of
 * TXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UOG_HWTXBUF_TXBURST (0U)    /*!< Bit position for USB_UOG_HWTXBUF_TXBURST. */
#define BM_USB_UOG_HWTXBUF_TXBURST (0x000000FFU) /*!< Bit mask for USB_UOG_HWTXBUF_TXBURST. */
#define BS_USB_UOG_HWTXBUF_TXBURST (8U)    /*!< Bit field size in bits for USB_UOG_HWTXBUF_TXBURST. */

/*! @brief Read current value of the USB_UOG_HWTXBUF_TXBURST field. */
#define BR_USB_UOG_HWTXBUF_TXBURST(x) (HW_USB_UOG_HWTXBUF(x).B.TXBURST)
/*@}*/

/*!
 * @name Register USB_UOG_HWTXBUF, field TXCHANADD[23:16] (RO)
 *
 * TX FIFO Buffer size is: (2^TXCHANADD) * 4 Bytes. These bits are set to '08h',
 * so buffer size is 256*4 Bytes. For the OTG controller operating in device
 * mode, this is the FIFO buffer size per endpoint. As the OTG controller has 8 TX
 * endpoint, there are 8 of these buffers. For the OTG controller operating in
 * host mode, or for Host-only controller, the entire buffer memory is used as a
 * single TX buffer. Therefore, there is only 1 of this buffer
 */
/*@{*/
#define BP_USB_UOG_HWTXBUF_TXCHANADD (16U) /*!< Bit position for USB_UOG_HWTXBUF_TXCHANADD. */
#define BM_USB_UOG_HWTXBUF_TXCHANADD (0x00FF0000U) /*!< Bit mask for USB_UOG_HWTXBUF_TXCHANADD. */
#define BS_USB_UOG_HWTXBUF_TXCHANADD (8U)  /*!< Bit field size in bits for USB_UOG_HWTXBUF_TXCHANADD. */

/*! @brief Read current value of the USB_UOG_HWTXBUF_TXCHANADD field. */
#define BR_USB_UOG_HWTXBUF_TXCHANADD(x) (HW_USB_UOG_HWTXBUF(x).B.TXCHANADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HWRXBUF - RX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HWRXBUF - RX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x00000808U
 */
typedef union _hw_usb_uog_hwrxbuf
{
    uint32_t U;
    struct _hw_usb_uog_hwrxbuf_bitfields
    {
        uint32_t RXBURST : 8;          /*!< [7:0]  */
        uint32_t RXADD : 8;            /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uog_hwrxbuf_t;

/*!
 * @name Constants and macros for entire USB_UOG_HWRXBUF register
 */
/*@{*/
#define HW_USB_UOG_HWRXBUF_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_USB_UOG_HWRXBUF(x)    (*(__I hw_usb_uog_hwrxbuf_t *) HW_USB_UOG_HWRXBUF_ADDR(x))
#define HW_USB_UOG_HWRXBUF_RD(x) (HW_USB_UOG_HWRXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HWRXBUF bitfields
 */

/*!
 * @name Register USB_UOG_HWRXBUF, field RXBURST[7:0] (RO)
 *
 * Default burst size for memory to RX buffer transfer. This is reset value of
 * RXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UOG_HWRXBUF_RXBURST (0U)    /*!< Bit position for USB_UOG_HWRXBUF_RXBURST. */
#define BM_USB_UOG_HWRXBUF_RXBURST (0x000000FFU) /*!< Bit mask for USB_UOG_HWRXBUF_RXBURST. */
#define BS_USB_UOG_HWRXBUF_RXBURST (8U)    /*!< Bit field size in bits for USB_UOG_HWRXBUF_RXBURST. */

/*! @brief Read current value of the USB_UOG_HWRXBUF_RXBURST field. */
#define BR_USB_UOG_HWRXBUF_RXBURST(x) (HW_USB_UOG_HWRXBUF(x).B.RXBURST)
/*@}*/

/*!
 * @name Register USB_UOG_HWRXBUF, field RXADD[15:8] (RO)
 *
 * Buffer total size for all receive endpoints is (2^RXADD). RX Buffer size is:
 * (2^RXADD) * 4 Bytes. These bits are set to '08h', so buffer size is 256*4
 * Bytes. There is a single Receive FIFO buffer in the USB controller. The buffer is
 * shared for all endpoints for the OTG controller in device mode.
 */
/*@{*/
#define BP_USB_UOG_HWRXBUF_RXADD (8U)      /*!< Bit position for USB_UOG_HWRXBUF_RXADD. */
#define BM_USB_UOG_HWRXBUF_RXADD (0x0000FF00U) /*!< Bit mask for USB_UOG_HWRXBUF_RXADD. */
#define BS_USB_UOG_HWRXBUF_RXADD (8U)      /*!< Bit field size in bits for USB_UOG_HWRXBUF_RXADD. */

/*! @brief Read current value of the USB_UOG_HWRXBUF_RXADD field. */
#define BR_USB_UOG_HWRXBUF_RXADD(x) (HW_USB_UOG_HWRXBUF(x).B.RXADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_GPTIMER0LD - General Purpose Timer #0 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_GPTIMER0LD - General Purpose Timer #0 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER0CTRL. Please see GPTIMER0CTRLGeneral Purpose Timer #0 Controller .
 */
typedef union _hw_usb_uog_gptimer0ld
{
    uint32_t U;
    struct _hw_usb_uog_gptimer0ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_gptimer0ld_t;

/*!
 * @name Constants and macros for entire USB_UOG_GPTIMER0LD register
 */
/*@{*/
#define HW_USB_UOG_GPTIMER0LD_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_USB_UOG_GPTIMER0LD(x) (*(__IO hw_usb_uog_gptimer0ld_t *) HW_USB_UOG_GPTIMER0LD_ADDR(x))
#define HW_USB_UOG_GPTIMER0LD_RD(x) (HW_USB_UOG_GPTIMER0LD(x).U)
#define HW_USB_UOG_GPTIMER0LD_WR(x, v) (HW_USB_UOG_GPTIMER0LD(x).U = (v))
#define HW_USB_UOG_GPTIMER0LD_SET(x, v) (HW_USB_UOG_GPTIMER0LD_WR(x, HW_USB_UOG_GPTIMER0LD_RD(x) |  (v)))
#define HW_USB_UOG_GPTIMER0LD_CLR(x, v) (HW_USB_UOG_GPTIMER0LD_WR(x, HW_USB_UOG_GPTIMER0LD_RD(x) & ~(v)))
#define HW_USB_UOG_GPTIMER0LD_TOG(x, v) (HW_USB_UOG_GPTIMER0LD_WR(x, HW_USB_UOG_GPTIMER0LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_GPTIMER0LD bitfields
 */

/*!
 * @name Register USB_UOG_GPTIMER0LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UOG_GPTIMER0LD_GPTLD (0U)   /*!< Bit position for USB_UOG_GPTIMER0LD_GPTLD. */
#define BM_USB_UOG_GPTIMER0LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UOG_GPTIMER0LD_GPTLD. */
#define BS_USB_UOG_GPTIMER0LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UOG_GPTIMER0LD_GPTLD. */

/*! @brief Read current value of the USB_UOG_GPTIMER0LD_GPTLD field. */
#define BR_USB_UOG_GPTIMER0LD_GPTLD(x) (HW_USB_UOG_GPTIMER0LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UOG_GPTIMER0LD_GPTLD. */
#define BF_USB_UOG_GPTIMER0LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER0LD_GPTLD) & BM_USB_UOG_GPTIMER0LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UOG_GPTIMER0LD_GPTLD(x, v) (HW_USB_UOG_GPTIMER0LD_WR(x, (HW_USB_UOG_GPTIMER0LD_RD(x) & ~BM_USB_UOG_GPTIMER0LD_GPTLD) | BF_USB_UOG_GPTIMER0LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_GPTIMER0CTRL - General Purpose Timer #0 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_GPTIMER0CTRL - General Purpose Timer #0 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI0 bit in n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE0 bit in n_USBINTR register. (See
 * USBINTRInterrupt Enable Register .)
 */
typedef union _hw_usb_uog_gptimer0ctrl
{
    uint32_t U;
    struct _hw_usb_uog_gptimer0ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uog_gptimer0ctrl_t;

/*!
 * @name Constants and macros for entire USB_UOG_GPTIMER0CTRL register
 */
/*@{*/
#define HW_USB_UOG_GPTIMER0CTRL_ADDR(x) ((uintptr_t)(x) + 0x84U)

#define HW_USB_UOG_GPTIMER0CTRL(x) (*(__IO hw_usb_uog_gptimer0ctrl_t *) HW_USB_UOG_GPTIMER0CTRL_ADDR(x))
#define HW_USB_UOG_GPTIMER0CTRL_RD(x) (HW_USB_UOG_GPTIMER0CTRL(x).U)
#define HW_USB_UOG_GPTIMER0CTRL_WR(x, v) (HW_USB_UOG_GPTIMER0CTRL(x).U = (v))
#define HW_USB_UOG_GPTIMER0CTRL_SET(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, HW_USB_UOG_GPTIMER0CTRL_RD(x) |  (v)))
#define HW_USB_UOG_GPTIMER0CTRL_CLR(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, HW_USB_UOG_GPTIMER0CTRL_RD(x) & ~(v)))
#define HW_USB_UOG_GPTIMER0CTRL_TOG(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, HW_USB_UOG_GPTIMER0CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_GPTIMER0CTRL bitfields
 */

/*!
 * @name Register USB_UOG_GPTIMER0CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UOG_GPTIMER0CTRL_GPTCNT (0U) /*!< Bit position for USB_UOG_GPTIMER0CTRL_GPTCNT. */
#define BM_USB_UOG_GPTIMER0CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UOG_GPTIMER0CTRL_GPTCNT. */
#define BS_USB_UOG_GPTIMER0CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UOG_GPTIMER0CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UOG_GPTIMER0CTRL_GPTCNT field. */
#define BR_USB_UOG_GPTIMER0CTRL_GPTCNT(x) (HW_USB_UOG_GPTIMER0CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UOG_GPTIMER0CTRL_GPTCNT. */
#define BF_USB_UOG_GPTIMER0CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER0CTRL_GPTCNT) & BM_USB_UOG_GPTIMER0CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UOG_GPTIMER0CTRL_GPTCNT(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, (HW_USB_UOG_GPTIMER0CTRL_RD(x) & ~BM_USB_UOG_GPTIMER0CTRL_GPTCNT) | BF_USB_UOG_GPTIMER0CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER0CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software; In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UOG_GPTIMER0CTRL_GPTMODE (24U) /*!< Bit position for USB_UOG_GPTIMER0CTRL_GPTMODE. */
#define BM_USB_UOG_GPTIMER0CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UOG_GPTIMER0CTRL_GPTMODE. */
#define BS_USB_UOG_GPTIMER0CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER0CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UOG_GPTIMER0CTRL_GPTMODE field. */
#define BR_USB_UOG_GPTIMER0CTRL_GPTMODE(x) (HW_USB_UOG_GPTIMER0CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UOG_GPTIMER0CTRL_GPTMODE. */
#define BF_USB_UOG_GPTIMER0CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER0CTRL_GPTMODE) & BM_USB_UOG_GPTIMER0CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UOG_GPTIMER0CTRL_GPTMODE(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, (HW_USB_UOG_GPTIMER0CTRL_RD(x) & ~BM_USB_UOG_GPTIMER0CTRL_GPTMODE) | BF_USB_UOG_GPTIMER0CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER0CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UOG_GPTIMER0CTRL_GPTRST (30U) /*!< Bit position for USB_UOG_GPTIMER0CTRL_GPTRST. */
#define BM_USB_UOG_GPTIMER0CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UOG_GPTIMER0CTRL_GPTRST. */
#define BS_USB_UOG_GPTIMER0CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER0CTRL_GPTRST. */

/*! @brief Read current value of the USB_UOG_GPTIMER0CTRL_GPTRST field. */
#define BR_USB_UOG_GPTIMER0CTRL_GPTRST(x) (HW_USB_UOG_GPTIMER0CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UOG_GPTIMER0CTRL_GPTRST. */
#define BF_USB_UOG_GPTIMER0CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER0CTRL_GPTRST) & BM_USB_UOG_GPTIMER0CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UOG_GPTIMER0CTRL_GPTRST(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, (HW_USB_UOG_GPTIMER0CTRL_RD(x) & ~BM_USB_UOG_GPTIMER0CTRL_GPTRST) | BF_USB_UOG_GPTIMER0CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER0CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UOG_GPTIMER0CTRL_GPTRUN (31U) /*!< Bit position for USB_UOG_GPTIMER0CTRL_GPTRUN. */
#define BM_USB_UOG_GPTIMER0CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UOG_GPTIMER0CTRL_GPTRUN. */
#define BS_USB_UOG_GPTIMER0CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER0CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UOG_GPTIMER0CTRL_GPTRUN field. */
#define BR_USB_UOG_GPTIMER0CTRL_GPTRUN(x) (HW_USB_UOG_GPTIMER0CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UOG_GPTIMER0CTRL_GPTRUN. */
#define BF_USB_UOG_GPTIMER0CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER0CTRL_GPTRUN) & BM_USB_UOG_GPTIMER0CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UOG_GPTIMER0CTRL_GPTRUN(x, v) (HW_USB_UOG_GPTIMER0CTRL_WR(x, (HW_USB_UOG_GPTIMER0CTRL_RD(x) & ~BM_USB_UOG_GPTIMER0CTRL_GPTRUN) | BF_USB_UOG_GPTIMER0CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_GPTIMER1LD - General Purpose Timer #1 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_GPTIMER1LD - General Purpose Timer #1 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER1CTRL. Please see GPTIMER1CTRLGeneral Purpose Timer #1 Controller .
 */
typedef union _hw_usb_uog_gptimer1ld
{
    uint32_t U;
    struct _hw_usb_uog_gptimer1ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_gptimer1ld_t;

/*!
 * @name Constants and macros for entire USB_UOG_GPTIMER1LD register
 */
/*@{*/
#define HW_USB_UOG_GPTIMER1LD_ADDR(x) ((uintptr_t)(x) + 0x88U)

#define HW_USB_UOG_GPTIMER1LD(x) (*(__IO hw_usb_uog_gptimer1ld_t *) HW_USB_UOG_GPTIMER1LD_ADDR(x))
#define HW_USB_UOG_GPTIMER1LD_RD(x) (HW_USB_UOG_GPTIMER1LD(x).U)
#define HW_USB_UOG_GPTIMER1LD_WR(x, v) (HW_USB_UOG_GPTIMER1LD(x).U = (v))
#define HW_USB_UOG_GPTIMER1LD_SET(x, v) (HW_USB_UOG_GPTIMER1LD_WR(x, HW_USB_UOG_GPTIMER1LD_RD(x) |  (v)))
#define HW_USB_UOG_GPTIMER1LD_CLR(x, v) (HW_USB_UOG_GPTIMER1LD_WR(x, HW_USB_UOG_GPTIMER1LD_RD(x) & ~(v)))
#define HW_USB_UOG_GPTIMER1LD_TOG(x, v) (HW_USB_UOG_GPTIMER1LD_WR(x, HW_USB_UOG_GPTIMER1LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_GPTIMER1LD bitfields
 */

/*!
 * @name Register USB_UOG_GPTIMER1LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UOG_GPTIMER1LD_GPTLD (0U)   /*!< Bit position for USB_UOG_GPTIMER1LD_GPTLD. */
#define BM_USB_UOG_GPTIMER1LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UOG_GPTIMER1LD_GPTLD. */
#define BS_USB_UOG_GPTIMER1LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UOG_GPTIMER1LD_GPTLD. */

/*! @brief Read current value of the USB_UOG_GPTIMER1LD_GPTLD field. */
#define BR_USB_UOG_GPTIMER1LD_GPTLD(x) (HW_USB_UOG_GPTIMER1LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UOG_GPTIMER1LD_GPTLD. */
#define BF_USB_UOG_GPTIMER1LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER1LD_GPTLD) & BM_USB_UOG_GPTIMER1LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UOG_GPTIMER1LD_GPTLD(x, v) (HW_USB_UOG_GPTIMER1LD_WR(x, (HW_USB_UOG_GPTIMER1LD_RD(x) & ~BM_USB_UOG_GPTIMER1LD_GPTLD) | BF_USB_UOG_GPTIMER1LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_GPTIMER1CTRL - General Purpose Timer #1 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_GPTIMER1CTRL - General Purpose Timer #1 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI1 bit in USB_n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE1 bit in n_USBINTR register (See
 * USBINTRInterrupt Enable Register ).
 */
typedef union _hw_usb_uog_gptimer1ctrl
{
    uint32_t U;
    struct _hw_usb_uog_gptimer1ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uog_gptimer1ctrl_t;

/*!
 * @name Constants and macros for entire USB_UOG_GPTIMER1CTRL register
 */
/*@{*/
#define HW_USB_UOG_GPTIMER1CTRL_ADDR(x) ((uintptr_t)(x) + 0x8CU)

#define HW_USB_UOG_GPTIMER1CTRL(x) (*(__IO hw_usb_uog_gptimer1ctrl_t *) HW_USB_UOG_GPTIMER1CTRL_ADDR(x))
#define HW_USB_UOG_GPTIMER1CTRL_RD(x) (HW_USB_UOG_GPTIMER1CTRL(x).U)
#define HW_USB_UOG_GPTIMER1CTRL_WR(x, v) (HW_USB_UOG_GPTIMER1CTRL(x).U = (v))
#define HW_USB_UOG_GPTIMER1CTRL_SET(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, HW_USB_UOG_GPTIMER1CTRL_RD(x) |  (v)))
#define HW_USB_UOG_GPTIMER1CTRL_CLR(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, HW_USB_UOG_GPTIMER1CTRL_RD(x) & ~(v)))
#define HW_USB_UOG_GPTIMER1CTRL_TOG(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, HW_USB_UOG_GPTIMER1CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_GPTIMER1CTRL bitfields
 */

/*!
 * @name Register USB_UOG_GPTIMER1CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UOG_GPTIMER1CTRL_GPTCNT (0U) /*!< Bit position for USB_UOG_GPTIMER1CTRL_GPTCNT. */
#define BM_USB_UOG_GPTIMER1CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UOG_GPTIMER1CTRL_GPTCNT. */
#define BS_USB_UOG_GPTIMER1CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UOG_GPTIMER1CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UOG_GPTIMER1CTRL_GPTCNT field. */
#define BR_USB_UOG_GPTIMER1CTRL_GPTCNT(x) (HW_USB_UOG_GPTIMER1CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UOG_GPTIMER1CTRL_GPTCNT. */
#define BF_USB_UOG_GPTIMER1CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER1CTRL_GPTCNT) & BM_USB_UOG_GPTIMER1CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UOG_GPTIMER1CTRL_GPTCNT(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, (HW_USB_UOG_GPTIMER1CTRL_RD(x) & ~BM_USB_UOG_GPTIMER1CTRL_GPTCNT) | BF_USB_UOG_GPTIMER1CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER1CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software. In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UOG_GPTIMER1CTRL_GPTMODE (24U) /*!< Bit position for USB_UOG_GPTIMER1CTRL_GPTMODE. */
#define BM_USB_UOG_GPTIMER1CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UOG_GPTIMER1CTRL_GPTMODE. */
#define BS_USB_UOG_GPTIMER1CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER1CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UOG_GPTIMER1CTRL_GPTMODE field. */
#define BR_USB_UOG_GPTIMER1CTRL_GPTMODE(x) (HW_USB_UOG_GPTIMER1CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UOG_GPTIMER1CTRL_GPTMODE. */
#define BF_USB_UOG_GPTIMER1CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER1CTRL_GPTMODE) & BM_USB_UOG_GPTIMER1CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UOG_GPTIMER1CTRL_GPTMODE(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, (HW_USB_UOG_GPTIMER1CTRL_RD(x) & ~BM_USB_UOG_GPTIMER1CTRL_GPTMODE) | BF_USB_UOG_GPTIMER1CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER1CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in USB_n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UOG_GPTIMER1CTRL_GPTRST (30U) /*!< Bit position for USB_UOG_GPTIMER1CTRL_GPTRST. */
#define BM_USB_UOG_GPTIMER1CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UOG_GPTIMER1CTRL_GPTRST. */
#define BS_USB_UOG_GPTIMER1CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER1CTRL_GPTRST. */

/*! @brief Read current value of the USB_UOG_GPTIMER1CTRL_GPTRST field. */
#define BR_USB_UOG_GPTIMER1CTRL_GPTRST(x) (HW_USB_UOG_GPTIMER1CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UOG_GPTIMER1CTRL_GPTRST. */
#define BF_USB_UOG_GPTIMER1CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER1CTRL_GPTRST) & BM_USB_UOG_GPTIMER1CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UOG_GPTIMER1CTRL_GPTRST(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, (HW_USB_UOG_GPTIMER1CTRL_RD(x) & ~BM_USB_UOG_GPTIMER1CTRL_GPTRST) | BF_USB_UOG_GPTIMER1CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UOG_GPTIMER1CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UOG_GPTIMER1CTRL_GPTRUN (31U) /*!< Bit position for USB_UOG_GPTIMER1CTRL_GPTRUN. */
#define BM_USB_UOG_GPTIMER1CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UOG_GPTIMER1CTRL_GPTRUN. */
#define BS_USB_UOG_GPTIMER1CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UOG_GPTIMER1CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UOG_GPTIMER1CTRL_GPTRUN field. */
#define BR_USB_UOG_GPTIMER1CTRL_GPTRUN(x) (HW_USB_UOG_GPTIMER1CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UOG_GPTIMER1CTRL_GPTRUN. */
#define BF_USB_UOG_GPTIMER1CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_GPTIMER1CTRL_GPTRUN) & BM_USB_UOG_GPTIMER1CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UOG_GPTIMER1CTRL_GPTRUN(x, v) (HW_USB_UOG_GPTIMER1CTRL_WR(x, (HW_USB_UOG_GPTIMER1CTRL_RD(x) & ~BM_USB_UOG_GPTIMER1CTRL_GPTRUN) | BF_USB_UOG_GPTIMER1CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_SBUSCFG - System Bus Config
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_SBUSCFG - System Bus Config (RW)
 *
 * Reset value: 0x00000002U
 */
typedef union _hw_usb_uog_sbuscfg
{
    uint32_t U;
    struct _hw_usb_uog_sbuscfg_bitfields
    {
        uint32_t AHBBRST : 3;          /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_usb_uog_sbuscfg_t;

/*!
 * @name Constants and macros for entire USB_UOG_SBUSCFG register
 */
/*@{*/
#define HW_USB_UOG_SBUSCFG_ADDR(x) ((uintptr_t)(x) + 0x90U)

#define HW_USB_UOG_SBUSCFG(x)    (*(__IO hw_usb_uog_sbuscfg_t *) HW_USB_UOG_SBUSCFG_ADDR(x))
#define HW_USB_UOG_SBUSCFG_RD(x) (HW_USB_UOG_SBUSCFG(x).U)
#define HW_USB_UOG_SBUSCFG_WR(x, v) (HW_USB_UOG_SBUSCFG(x).U = (v))
#define HW_USB_UOG_SBUSCFG_SET(x, v) (HW_USB_UOG_SBUSCFG_WR(x, HW_USB_UOG_SBUSCFG_RD(x) |  (v)))
#define HW_USB_UOG_SBUSCFG_CLR(x, v) (HW_USB_UOG_SBUSCFG_WR(x, HW_USB_UOG_SBUSCFG_RD(x) & ~(v)))
#define HW_USB_UOG_SBUSCFG_TOG(x, v) (HW_USB_UOG_SBUSCFG_WR(x, HW_USB_UOG_SBUSCFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_SBUSCFG bitfields
 */

/*!
 * @name Register USB_UOG_SBUSCFG, field AHBBRST[2:0] (RW)
 *
 * AHB master interface Burst configuration These bits control AHB master
 * transfer type sequence (or priority). This register overrides n_BURSTSIZE register
 * when its value is not zero.
 *
 * Values:
 * - 000 - Incremental burst of unspecified length only
 * - 001 - INCR4 burst, then single transfer
 * - 010 - INCR8 burst, INCR4 burst, then single transfer
 * - 011 - INCR16 burst, INCR8 burst, INCR4 burst, then single transfer
 * - 100 - Reserved, don't use
 * - 101 - INCR4 burst, then incremental burst of unspecified length
 * - 110 - INCR8 burst, INCR4 burst, then incremental burst of unspecified length
 * - 111 - INCR16 burst, INCR8 burst, INCR4 burst, then incremental burst of
 *     unspecified length
 */
/*@{*/
#define BP_USB_UOG_SBUSCFG_AHBBRST (0U)    /*!< Bit position for USB_UOG_SBUSCFG_AHBBRST. */
#define BM_USB_UOG_SBUSCFG_AHBBRST (0x00000007U) /*!< Bit mask for USB_UOG_SBUSCFG_AHBBRST. */
#define BS_USB_UOG_SBUSCFG_AHBBRST (3U)    /*!< Bit field size in bits for USB_UOG_SBUSCFG_AHBBRST. */

/*! @brief Read current value of the USB_UOG_SBUSCFG_AHBBRST field. */
#define BR_USB_UOG_SBUSCFG_AHBBRST(x) (HW_USB_UOG_SBUSCFG(x).B.AHBBRST)

/*! @brief Format value for bitfield USB_UOG_SBUSCFG_AHBBRST. */
#define BF_USB_UOG_SBUSCFG_AHBBRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_SBUSCFG_AHBBRST) & BM_USB_UOG_SBUSCFG_AHBBRST)

/*! @brief Set the AHBBRST field to a new value. */
#define BW_USB_UOG_SBUSCFG_AHBBRST(x, v) (HW_USB_UOG_SBUSCFG_WR(x, (HW_USB_UOG_SBUSCFG_RD(x) & ~BM_USB_UOG_SBUSCFG_AHBBRST) | BF_USB_UOG_SBUSCFG_AHBBRST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_CAPLENGTH - Capability Registers Length
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_CAPLENGTH - Capability Registers Length (RO)
 *
 * Reset value: 0x40U
 *
 * The Capability Registers Length register contains the address offset to the
 * Operational registers relative to the CAPLENGTH register.
 */
typedef union _hw_usb_uog_caplength
{
    uint8_t U;
    struct _hw_usb_uog_caplength_bitfields
    {
        uint8_t CAPLENGTH : 8;         /*!< [7:0]  */
    } B;
} hw_usb_uog_caplength_t;

/*!
 * @name Constants and macros for entire USB_UOG_CAPLENGTH register
 */
/*@{*/
#define HW_USB_UOG_CAPLENGTH_ADDR(x) ((uintptr_t)(x) + 0x100U)

#define HW_USB_UOG_CAPLENGTH(x)  (*(__I hw_usb_uog_caplength_t *) HW_USB_UOG_CAPLENGTH_ADDR(x))
#define HW_USB_UOG_CAPLENGTH_RD(x) (HW_USB_UOG_CAPLENGTH(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_CAPLENGTH bitfields
 */

/*!
 * @name Register USB_UOG_CAPLENGTH, field CAPLENGTH[7:0] (RO)
 *
 * These bits are used as an offset to add to register base to find the
 * beginning of the Operational Register. Default value is '40h'.
 */
/*@{*/
#define BP_USB_UOG_CAPLENGTH_CAPLENGTH (0U) /*!< Bit position for USB_UOG_CAPLENGTH_CAPLENGTH. */
#define BM_USB_UOG_CAPLENGTH_CAPLENGTH (0xFFU) /*!< Bit mask for USB_UOG_CAPLENGTH_CAPLENGTH. */
#define BS_USB_UOG_CAPLENGTH_CAPLENGTH (8U) /*!< Bit field size in bits for USB_UOG_CAPLENGTH_CAPLENGTH. */

/*! @brief Read current value of the USB_UOG_CAPLENGTH_CAPLENGTH field. */
#define BR_USB_UOG_CAPLENGTH_CAPLENGTH(x) (HW_USB_UOG_CAPLENGTH(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HCIVERSION - Host Controller Interface Version
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HCIVERSION - Host Controller Interface Version (RO)
 *
 * Reset value: 0x0100U
 *
 * This is a 2-byte register containing a BCD encoding of the EHCI revision
 * number supported by this host controller. The most significant byte of this
 * register represents a major revision and the least significant byte is the minor
 * revision.
 */
typedef union _hw_usb_uog_hciversion
{
    uint16_t U;
    struct _hw_usb_uog_hciversion_bitfields
    {
        uint16_t HCIVERSION : 16;      /*!< [15:0]  */
    } B;
} hw_usb_uog_hciversion_t;

/*!
 * @name Constants and macros for entire USB_UOG_HCIVERSION register
 */
/*@{*/
#define HW_USB_UOG_HCIVERSION_ADDR(x) ((uintptr_t)(x) + 0x102U)

#define HW_USB_UOG_HCIVERSION(x) (*(__I hw_usb_uog_hciversion_t *) HW_USB_UOG_HCIVERSION_ADDR(x))
#define HW_USB_UOG_HCIVERSION_RD(x) (HW_USB_UOG_HCIVERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HCIVERSION bitfields
 */

/*!
 * @name Register USB_UOG_HCIVERSION, field HCIVERSION[15:0] (RO)
 *
 * Host Controller Interface Version Number Default value is '10h', which means
 * EHCI rev1.0.
 */
/*@{*/
#define BP_USB_UOG_HCIVERSION_HCIVERSION (0U) /*!< Bit position for USB_UOG_HCIVERSION_HCIVERSION. */
#define BM_USB_UOG_HCIVERSION_HCIVERSION (0xFFFFU) /*!< Bit mask for USB_UOG_HCIVERSION_HCIVERSION. */
#define BS_USB_UOG_HCIVERSION_HCIVERSION (16U) /*!< Bit field size in bits for USB_UOG_HCIVERSION_HCIVERSION. */

/*! @brief Read current value of the USB_UOG_HCIVERSION_HCIVERSION field. */
#define BR_USB_UOG_HCIVERSION_HCIVERSION(x) (HW_USB_UOG_HCIVERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HCSPARAMS - Host Controller Structural Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HCSPARAMS - Host Controller Structural Parameters (RO)
 *
 * Reset value: 0x00010011U
 *
 * The following figure shows the port steering logic capabilities of Host
 * Control Structural Parameters (n_HCSPARAMS).
 */
typedef union _hw_usb_uog_hcsparams
{
    uint32_t U;
    struct _hw_usb_uog_hcsparams_bitfields
    {
        uint32_t N_PORTS : 4;          /*!< [3:0]  */
        uint32_t PPC : 1;              /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t N_PCC : 4;            /*!< [11:8]  */
        uint32_t N_CC : 4;             /*!< [15:12]  */
        uint32_t PI : 1;               /*!< [16]  */
        uint32_t RESERVED1 : 3;        /*!< [19:17]  */
        uint32_t N_PTT : 4;            /*!< [23:20]  */
        uint32_t N_TT : 4;             /*!< [27:24]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_uog_hcsparams_t;

/*!
 * @name Constants and macros for entire USB_UOG_HCSPARAMS register
 */
/*@{*/
#define HW_USB_UOG_HCSPARAMS_ADDR(x) ((uintptr_t)(x) + 0x104U)

#define HW_USB_UOG_HCSPARAMS(x)  (*(__I hw_usb_uog_hcsparams_t *) HW_USB_UOG_HCSPARAMS_ADDR(x))
#define HW_USB_UOG_HCSPARAMS_RD(x) (HW_USB_UOG_HCSPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HCSPARAMS bitfields
 */

/*!
 * @name Register USB_UOG_HCSPARAMS, field N_PORTS[3:0] (RO)
 *
 * Number of downstream ports. This field specifies the number of physical
 * downstream ports implemented on this host controller. The value of this field
 * determines how many port registers are addressable in the Operational Register.
 * Valid values are in the range of 1h to Fh. A zero in this field is undefined.
 * These bits are always set to '0001b' because all controller cores are Single-Port
 * Host.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_N_PORTS (0U)  /*!< Bit position for USB_UOG_HCSPARAMS_N_PORTS. */
#define BM_USB_UOG_HCSPARAMS_N_PORTS (0x0000000FU) /*!< Bit mask for USB_UOG_HCSPARAMS_N_PORTS. */
#define BS_USB_UOG_HCSPARAMS_N_PORTS (4U)  /*!< Bit field size in bits for USB_UOG_HCSPARAMS_N_PORTS. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_N_PORTS field. */
#define BR_USB_UOG_HCSPARAMS_N_PORTS(x) (HW_USB_UOG_HCSPARAMS(x).B.N_PORTS)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field PPC[4] (RO)
 *
 * Port Power Control This field indicates whether the host controller
 * implementation includes port power control. A one indicates the ports have port power
 * switches. A zero indicates the ports do not have port power switches. The value
 * of this field affects the functionality of the Port Power field in each port
 * status and control register
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_PPC (4U)      /*!< Bit position for USB_UOG_HCSPARAMS_PPC. */
#define BM_USB_UOG_HCSPARAMS_PPC (0x00000010U) /*!< Bit mask for USB_UOG_HCSPARAMS_PPC. */
#define BS_USB_UOG_HCSPARAMS_PPC (1U)      /*!< Bit field size in bits for USB_UOG_HCSPARAMS_PPC. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_PPC field. */
#define BR_USB_UOG_HCSPARAMS_PPC(x) (HW_USB_UOG_HCSPARAMS(x).B.PPC)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field N_PCC[11:8] (RO)
 *
 * Number of Ports per Companion Controller This field indicates the number of
 * ports supported per internal Companion Controller. It is used to indicate the
 * port routing configuration to the system software. For example, if N_PORTS has
 * a value of 6 and N_CC has a value of 2 then N_PCC could have a value of 3. The
 * convention is that the first N_PCC ports are assumed to be routed to
 * companion controller 1, the next N_PCC ports to companion controller 2, etc. In the
 * previous example, the N_PCC could have been 4, where the first 4 are routed to
 * companion controller 1 and the last two are routed to companion controller 2.
 * The number in this field must be consistent with N_PORTS and N_CC. These bits
 * are '0000b' in all controller core.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_N_PCC (8U)    /*!< Bit position for USB_UOG_HCSPARAMS_N_PCC. */
#define BM_USB_UOG_HCSPARAMS_N_PCC (0x00000F00U) /*!< Bit mask for USB_UOG_HCSPARAMS_N_PCC. */
#define BS_USB_UOG_HCSPARAMS_N_PCC (4U)    /*!< Bit field size in bits for USB_UOG_HCSPARAMS_N_PCC. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_N_PCC field. */
#define BR_USB_UOG_HCSPARAMS_N_PCC(x) (HW_USB_UOG_HCSPARAMS(x).B.N_PCC)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field N_CC[15:12] (RO)
 *
 * Number of Companion Controller (N_CC). This field indicates the number of
 * companion controllers associated with this USB2.0 host controller. These bits are
 * '0000b' in all controller core.
 *
 * Values:
 * - 0 - There is no internal Companion Controller and port-ownership hand-off
 *     is not supported.
 * - 1 - There are internal companion controller(s) and port-ownership hand-offs
 *     is supported.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_N_CC (12U)    /*!< Bit position for USB_UOG_HCSPARAMS_N_CC. */
#define BM_USB_UOG_HCSPARAMS_N_CC (0x0000F000U) /*!< Bit mask for USB_UOG_HCSPARAMS_N_CC. */
#define BS_USB_UOG_HCSPARAMS_N_CC (4U)     /*!< Bit field size in bits for USB_UOG_HCSPARAMS_N_CC. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_N_CC field. */
#define BR_USB_UOG_HCSPARAMS_N_CC(x) (HW_USB_UOG_HCSPARAMS(x).B.N_CC)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field PI[16] (RO)
 *
 * Port Indicators (P INDICATOR) This bit indicates whether the ports support
 * port indicator control. When set to one, the port status and control registers
 * include a read/writeable field for controlling the state of the port indicator
 * This bit is "1b" in all controller core.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_PI (16U)      /*!< Bit position for USB_UOG_HCSPARAMS_PI. */
#define BM_USB_UOG_HCSPARAMS_PI (0x00010000U) /*!< Bit mask for USB_UOG_HCSPARAMS_PI. */
#define BS_USB_UOG_HCSPARAMS_PI (1U)       /*!< Bit field size in bits for USB_UOG_HCSPARAMS_PI. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_PI field. */
#define BR_USB_UOG_HCSPARAMS_PI(x) (HW_USB_UOG_HCSPARAMS(x).B.PI)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field N_PTT[23:20] (RO)
 *
 * Number of Ports per Transaction Translator (N_PTT). Default value '0000b'
 * This field indicates the number of ports assigned to each transaction translator
 * within the USB2.0 host controller. These bits would be set to equal N_PORTS
 * for Multi-Port Host, and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_N_PTT (20U)   /*!< Bit position for USB_UOG_HCSPARAMS_N_PTT. */
#define BM_USB_UOG_HCSPARAMS_N_PTT (0x00F00000U) /*!< Bit mask for USB_UOG_HCSPARAMS_N_PTT. */
#define BS_USB_UOG_HCSPARAMS_N_PTT (4U)    /*!< Bit field size in bits for USB_UOG_HCSPARAMS_N_PTT. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_N_PTT field. */
#define BR_USB_UOG_HCSPARAMS_N_PTT(x) (HW_USB_UOG_HCSPARAMS(x).B.N_PTT)
/*@}*/

/*!
 * @name Register USB_UOG_HCSPARAMS, field N_TT[27:24] (RO)
 *
 * Number of Transaction Translators (N_TT). Default value '0000b' This field
 * indicates the number of embedded transaction translators associated with the
 * USB2.0 host controller. These bits would be set to '0001b' for Multi-Port Host,
 * and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UOG_HCSPARAMS_N_TT (24U)    /*!< Bit position for USB_UOG_HCSPARAMS_N_TT. */
#define BM_USB_UOG_HCSPARAMS_N_TT (0x0F000000U) /*!< Bit mask for USB_UOG_HCSPARAMS_N_TT. */
#define BS_USB_UOG_HCSPARAMS_N_TT (4U)     /*!< Bit field size in bits for USB_UOG_HCSPARAMS_N_TT. */

/*! @brief Read current value of the USB_UOG_HCSPARAMS_N_TT field. */
#define BR_USB_UOG_HCSPARAMS_N_TT(x) (HW_USB_UOG_HCSPARAMS(x).B.N_TT)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_HCCPARAMS - Host Controller Capability Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_HCCPARAMS - Host Controller Capability Parameters (RO)
 *
 * Reset value: 0x00000006U
 *
 * This register identifies multiple mode control (time-base bit functionality),
 * addressing capability.
 */
typedef union _hw_usb_uog_hccparams
{
    uint32_t U;
    struct _hw_usb_uog_hccparams_bitfields
    {
        uint32_t ADC : 1;              /*!< [0]  */
        uint32_t PFL : 1;              /*!< [1]  */
        uint32_t ASP : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t IST : 4;              /*!< [7:4]  */
        uint32_t EECP : 8;             /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uog_hccparams_t;

/*!
 * @name Constants and macros for entire USB_UOG_HCCPARAMS register
 */
/*@{*/
#define HW_USB_UOG_HCCPARAMS_ADDR(x) ((uintptr_t)(x) + 0x108U)

#define HW_USB_UOG_HCCPARAMS(x)  (*(__I hw_usb_uog_hccparams_t *) HW_USB_UOG_HCCPARAMS_ADDR(x))
#define HW_USB_UOG_HCCPARAMS_RD(x) (HW_USB_UOG_HCCPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_HCCPARAMS bitfields
 */

/*!
 * @name Register USB_UOG_HCCPARAMS, field ADC[0] (RO)
 *
 * 64-bit Addressing Capability This bit is set '0b' in all controller core, no
 * 64-bit addressing capability is supported.
 */
/*@{*/
#define BP_USB_UOG_HCCPARAMS_ADC (0U)      /*!< Bit position for USB_UOG_HCCPARAMS_ADC. */
#define BM_USB_UOG_HCCPARAMS_ADC (0x00000001U) /*!< Bit mask for USB_UOG_HCCPARAMS_ADC. */
#define BS_USB_UOG_HCCPARAMS_ADC (1U)      /*!< Bit field size in bits for USB_UOG_HCCPARAMS_ADC. */

/*! @brief Read current value of the USB_UOG_HCCPARAMS_ADC field. */
#define BR_USB_UOG_HCCPARAMS_ADC(x) (HW_USB_UOG_HCCPARAMS(x).B.ADC)
/*@}*/

/*!
 * @name Register USB_UOG_HCCPARAMS, field PFL[1] (RO)
 *
 * Programmable Frame List Flag If this bit is set to zero, then the system
 * software must use a frame list length of 1024 elements with this host controller.
 * The USBCMD register Frame List Size field is a read-only register and must be
 * set to zero. If set to a one, then the system software can specify and use a
 * smaller frame list and configure the host controller via the USBCMD register
 * Frame List Size field. The frame list must always be aligned on a 4K-page
 * boundary. This requirement ensures that the frame list is always physically
 * contiguous. This bit is set '1b' in all controller core.
 */
/*@{*/
#define BP_USB_UOG_HCCPARAMS_PFL (1U)      /*!< Bit position for USB_UOG_HCCPARAMS_PFL. */
#define BM_USB_UOG_HCCPARAMS_PFL (0x00000002U) /*!< Bit mask for USB_UOG_HCCPARAMS_PFL. */
#define BS_USB_UOG_HCCPARAMS_PFL (1U)      /*!< Bit field size in bits for USB_UOG_HCCPARAMS_PFL. */

/*! @brief Read current value of the USB_UOG_HCCPARAMS_PFL field. */
#define BR_USB_UOG_HCCPARAMS_PFL(x) (HW_USB_UOG_HCCPARAMS(x).B.PFL)
/*@}*/

/*!
 * @name Register USB_UOG_HCCPARAMS, field ASP[2] (RO)
 *
 * Asynchronous Schedule Park Capability If this bit is set to a one, then the
 * host controller supports the park feature for high-speed queue heads in the
 * Asynchronous Schedule. The feature can be disabled or enabled and set to a
 * specific level by using the Asynchronous Schedule Park Mode Enable and Asynchronous
 * Schedule Park Mode Count fields in the USBCMD register. ASP bit reset value:
 * '00b' for OTG controller core, '11b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_HCCPARAMS_ASP (2U)      /*!< Bit position for USB_UOG_HCCPARAMS_ASP. */
#define BM_USB_UOG_HCCPARAMS_ASP (0x00000004U) /*!< Bit mask for USB_UOG_HCCPARAMS_ASP. */
#define BS_USB_UOG_HCCPARAMS_ASP (1U)      /*!< Bit field size in bits for USB_UOG_HCCPARAMS_ASP. */

/*! @brief Read current value of the USB_UOG_HCCPARAMS_ASP field. */
#define BR_USB_UOG_HCCPARAMS_ASP(x) (HW_USB_UOG_HCCPARAMS(x).B.ASP)
/*@}*/

/*!
 * @name Register USB_UOG_HCCPARAMS, field IST[7:4] (RO)
 *
 * Isochronous Scheduling Threshold. This field indicates, relative to the
 * current position of the executing host controller, where software can reliably
 * update the isochronous schedule. When bit [7] is zero, the value of the least
 * significant 3 bits indicates the number of micro-frames a host controller can hold
 * a set of isochronous data structures (one or more) before flushing the state.
 * When bit [7] is a one, then host software assumes the host controller may
 * cache an isochronous data structure for an entire frame. These bits are set '00h'
 * in all controller core.
 */
/*@{*/
#define BP_USB_UOG_HCCPARAMS_IST (4U)      /*!< Bit position for USB_UOG_HCCPARAMS_IST. */
#define BM_USB_UOG_HCCPARAMS_IST (0x000000F0U) /*!< Bit mask for USB_UOG_HCCPARAMS_IST. */
#define BS_USB_UOG_HCCPARAMS_IST (4U)      /*!< Bit field size in bits for USB_UOG_HCCPARAMS_IST. */

/*! @brief Read current value of the USB_UOG_HCCPARAMS_IST field. */
#define BR_USB_UOG_HCCPARAMS_IST(x) (HW_USB_UOG_HCCPARAMS(x).B.IST)
/*@}*/

/*!
 * @name Register USB_UOG_HCCPARAMS, field EECP[15:8] (RO)
 *
 * EHCI Extended Capabilities Pointer. This field indicates the existence of a
 * capabilities list. A value of 00h indicates no extended capabilities are
 * implemented. A non-zero value in this register indicates the offset in PCI
 * configuration space of the first EHCI extended capability. The pointer value must be
 * 40h or greater if implemented to maintain the consistency of the PCI header
 * defined for this class of device. These bits are set '00h' in all controller core.
 */
/*@{*/
#define BP_USB_UOG_HCCPARAMS_EECP (8U)     /*!< Bit position for USB_UOG_HCCPARAMS_EECP. */
#define BM_USB_UOG_HCCPARAMS_EECP (0x0000FF00U) /*!< Bit mask for USB_UOG_HCCPARAMS_EECP. */
#define BS_USB_UOG_HCCPARAMS_EECP (8U)     /*!< Bit field size in bits for USB_UOG_HCCPARAMS_EECP. */

/*! @brief Read current value of the USB_UOG_HCCPARAMS_EECP field. */
#define BR_USB_UOG_HCCPARAMS_EECP(x) (HW_USB_UOG_HCCPARAMS(x).B.EECP)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_DCIVERSION - Device Controller Interface Version
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_DCIVERSION - Device Controller Interface Version (RO)
 *
 * Reset value: 0x0001U
 *
 * This register indicates the two-byte BCD encoding of the device controller
 * interface version number.
 */
typedef union _hw_usb_uog_dciversion
{
    uint16_t U;
    struct _hw_usb_uog_dciversion_bitfields
    {
        uint16_t DCIVERSION : 16;      /*!< [15:0]  */
    } B;
} hw_usb_uog_dciversion_t;

/*!
 * @name Constants and macros for entire USB_UOG_DCIVERSION register
 */
/*@{*/
#define HW_USB_UOG_DCIVERSION_ADDR(x) ((uintptr_t)(x) + 0x120U)

#define HW_USB_UOG_DCIVERSION(x) (*(__I hw_usb_uog_dciversion_t *) HW_USB_UOG_DCIVERSION_ADDR(x))
#define HW_USB_UOG_DCIVERSION_RD(x) (HW_USB_UOG_DCIVERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_DCIVERSION bitfields
 */

/*!
 * @name Register USB_UOG_DCIVERSION, field DCIVERSION[15:0] (RO)
 *
 * Device Controller Interface Version Number Default value is '01h', which
 * means rev0.1.
 */
/*@{*/
#define BP_USB_UOG_DCIVERSION_DCIVERSION (0U) /*!< Bit position for USB_UOG_DCIVERSION_DCIVERSION. */
#define BM_USB_UOG_DCIVERSION_DCIVERSION (0xFFFFU) /*!< Bit mask for USB_UOG_DCIVERSION_DCIVERSION. */
#define BS_USB_UOG_DCIVERSION_DCIVERSION (16U) /*!< Bit field size in bits for USB_UOG_DCIVERSION_DCIVERSION. */

/*! @brief Read current value of the USB_UOG_DCIVERSION_DCIVERSION field. */
#define BR_USB_UOG_DCIVERSION_DCIVERSION(x) (HW_USB_UOG_DCIVERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_DCCPARAMS - Device Controller Capability Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_DCCPARAMS - Device Controller Capability Parameters (RO)
 *
 * Reset value: 0x00000188U
 *
 * These fields describe the overall device capability of the controller. This
 * register is only available in OTG controller core.
 */
typedef union _hw_usb_uog_dccparams
{
    uint32_t U;
    struct _hw_usb_uog_dccparams_bitfields
    {
        uint32_t DEN : 5;              /*!< [4:0]  */
        uint32_t RESERVED0 : 2;        /*!< [6:5]  */
        uint32_t DC : 1;               /*!< [7]  */
        uint32_t HC : 1;               /*!< [8]  */
        uint32_t RESERVED1 : 23;       /*!< [31:9]  */
    } B;
} hw_usb_uog_dccparams_t;

/*!
 * @name Constants and macros for entire USB_UOG_DCCPARAMS register
 */
/*@{*/
#define HW_USB_UOG_DCCPARAMS_ADDR(x) ((uintptr_t)(x) + 0x124U)

#define HW_USB_UOG_DCCPARAMS(x)  (*(__I hw_usb_uog_dccparams_t *) HW_USB_UOG_DCCPARAMS_ADDR(x))
#define HW_USB_UOG_DCCPARAMS_RD(x) (HW_USB_UOG_DCCPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_DCCPARAMS bitfields
 */

/*!
 * @name Register USB_UOG_DCCPARAMS, field DEN[4:0] (RO)
 *
 * Device Endpoint Number This field indicates the number of endpoints built
 * into the device controller. If this controller is not device capable, then this
 * field will be zero. Valid values are 0 - 15.
 */
/*@{*/
#define BP_USB_UOG_DCCPARAMS_DEN (0U)      /*!< Bit position for USB_UOG_DCCPARAMS_DEN. */
#define BM_USB_UOG_DCCPARAMS_DEN (0x0000001FU) /*!< Bit mask for USB_UOG_DCCPARAMS_DEN. */
#define BS_USB_UOG_DCCPARAMS_DEN (5U)      /*!< Bit field size in bits for USB_UOG_DCCPARAMS_DEN. */

/*! @brief Read current value of the USB_UOG_DCCPARAMS_DEN field. */
#define BR_USB_UOG_DCCPARAMS_DEN(x) (HW_USB_UOG_DCCPARAMS(x).B.DEN)
/*@}*/

/*!
 * @name Register USB_UOG_DCCPARAMS, field DC[7] (RO)
 *
 * Device Capable When this bit is 1, this controller is capable of operating as
 * a USB 2.0 device.
 */
/*@{*/
#define BP_USB_UOG_DCCPARAMS_DC (7U)       /*!< Bit position for USB_UOG_DCCPARAMS_DC. */
#define BM_USB_UOG_DCCPARAMS_DC (0x00000080U) /*!< Bit mask for USB_UOG_DCCPARAMS_DC. */
#define BS_USB_UOG_DCCPARAMS_DC (1U)       /*!< Bit field size in bits for USB_UOG_DCCPARAMS_DC. */

/*! @brief Read current value of the USB_UOG_DCCPARAMS_DC field. */
#define BR_USB_UOG_DCCPARAMS_DC(x) (HW_USB_UOG_DCCPARAMS(x).B.DC)
/*@}*/

/*!
 * @name Register USB_UOG_DCCPARAMS, field HC[8] (RO)
 *
 * Host Capable When this bit is 1, this controller is capable of operating as
 * an EHCI compatible USB 2.0 host controller.
 */
/*@{*/
#define BP_USB_UOG_DCCPARAMS_HC (8U)       /*!< Bit position for USB_UOG_DCCPARAMS_HC. */
#define BM_USB_UOG_DCCPARAMS_HC (0x00000100U) /*!< Bit mask for USB_UOG_DCCPARAMS_HC. */
#define BS_USB_UOG_DCCPARAMS_HC (1U)       /*!< Bit field size in bits for USB_UOG_DCCPARAMS_HC. */

/*! @brief Read current value of the USB_UOG_DCCPARAMS_HC field. */
#define BR_USB_UOG_DCCPARAMS_HC(x) (HW_USB_UOG_DCCPARAMS(x).B.HC)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_USBCMD - USB Command Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_USBCMD - USB Command Register (RW)
 *
 * Reset value: 0x00080000U
 *
 * The Command Register indicates the command to be executed by the serial bus
 * host/device controller. Writing to the register causes a command to be executed.
 */
typedef union _hw_usb_uog_usbcmd
{
    uint32_t U;
    struct _hw_usb_uog_usbcmd_bitfields
    {
        uint32_t RS : 1;               /*!< [0]  */
        uint32_t RST : 1;              /*!< [1]  */
        uint32_t FS_1 : 2;             /*!< [3:2]  */
        uint32_t PSE : 1;              /*!< [4]  */
        uint32_t ASE : 1;              /*!< [5]  */
        uint32_t IAA : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t ASP : 2;              /*!< [9:8]  */
        uint32_t RESERVED1 : 1;        /*!< [10]  */
        uint32_t ASPE : 1;             /*!< [11]  */
        uint32_t ATDTW : 1;            /*!< [12]  */
        uint32_t SUTW : 1;             /*!< [13]  */
        uint32_t RESERVED2 : 1;        /*!< [14]  */
        uint32_t FS_2 : 1;             /*!< [15]  */
        uint32_t ITC : 8;              /*!< [23:16]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_usbcmd_t;

/*!
 * @name Constants and macros for entire USB_UOG_USBCMD register
 */
/*@{*/
#define HW_USB_UOG_USBCMD_ADDR(x) ((uintptr_t)(x) + 0x140U)

#define HW_USB_UOG_USBCMD(x)     (*(__IO hw_usb_uog_usbcmd_t *) HW_USB_UOG_USBCMD_ADDR(x))
#define HW_USB_UOG_USBCMD_RD(x)  (HW_USB_UOG_USBCMD(x).U)
#define HW_USB_UOG_USBCMD_WR(x, v) (HW_USB_UOG_USBCMD(x).U = (v))
#define HW_USB_UOG_USBCMD_SET(x, v) (HW_USB_UOG_USBCMD_WR(x, HW_USB_UOG_USBCMD_RD(x) |  (v)))
#define HW_USB_UOG_USBCMD_CLR(x, v) (HW_USB_UOG_USBCMD_WR(x, HW_USB_UOG_USBCMD_RD(x) & ~(v)))
#define HW_USB_UOG_USBCMD_TOG(x, v) (HW_USB_UOG_USBCMD_WR(x, HW_USB_UOG_USBCMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_USBCMD bitfields
 */

/*!
 * @name Register USB_UOG_USBCMD, field RS[0] (RW)
 *
 * Run/Stop (RS) - Read/Write. Default 0b. 1=Run. 0=Stop. Host operation mode:
 * When set to '1b', the Controller proceeds with the execution of the schedule.
 * The Controller continues execution as long as this bit is set to a one. When
 * this bit is set to 0, the Host Controller completes the current transaction on
 * the USB and then halts. The HC Halted bit in the status register indicates when
 * the Controller has finished the transaction and has entered the stopped
 * state. Software should not write a one to this field unless the controller is in
 * the Halted state (that is, HCHalted in the USBSTS register is a one). Device
 * operation mode: Writing a one to this bit will cause the controller to enable a
 * pull-up on D+ and initiate an attach event. This control bit is not directly
 * connected to the pull-up enable, as the pull-up will become disabled upon
 * transitioning into high-speed mode. Software should use this bit to prevent an
 * attach event before the controller has been properly initialized. Writing a 0 to
 * this will cause a detach event.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_RS (0U)          /*!< Bit position for USB_UOG_USBCMD_RS. */
#define BM_USB_UOG_USBCMD_RS (0x00000001U) /*!< Bit mask for USB_UOG_USBCMD_RS. */
#define BS_USB_UOG_USBCMD_RS (1U)          /*!< Bit field size in bits for USB_UOG_USBCMD_RS. */

/*! @brief Read current value of the USB_UOG_USBCMD_RS field. */
#define BR_USB_UOG_USBCMD_RS(x) (HW_USB_UOG_USBCMD(x).B.RS)

/*! @brief Format value for bitfield USB_UOG_USBCMD_RS. */
#define BF_USB_UOG_USBCMD_RS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_RS) & BM_USB_UOG_USBCMD_RS)

/*! @brief Set the RS field to a new value. */
#define BW_USB_UOG_USBCMD_RS(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_RS) | BF_USB_UOG_USBCMD_RS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field RST[1] (RW)
 *
 * Controller Reset (RESET) - Read/Write. Software uses this bit to reset the
 * controller. This bit is set to zero by the Host/Device Controller when the reset
 * process is complete. Software cannot terminate the reset process early by
 * writing a zero to this register. Host operation mode: When software writes a one
 * to this bit, the Controller resets its internal pipelines, timers, counters,
 * state machines etc. to their initial value. Any transaction currently in
 * progress on USB is immediately terminated. A USB reset is not driven on downstream
 * ports. Software should not set this bit to a one when the HCHalted bit in the
 * USBSTS register is a zero. Attempting to reset an actively running host
 * controller will result in undefined behavior. Device operation mode: When software
 * writes a one to this bit, the Controller resets its internal pipelines, timers,
 * counters, state machines etc. to their initial value. Writing a one to this
 * bit when the device is in the attached state is not recommended, because the
 * effect on an attached host is undefined. In order to ensure that the device is
 * not in an attached state before initiating a device controller reset, all primed
 * endpoints should be flushed and the USBCMD Run/Stop bit should be set to 0.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_RST (1U)         /*!< Bit position for USB_UOG_USBCMD_RST. */
#define BM_USB_UOG_USBCMD_RST (0x00000002U) /*!< Bit mask for USB_UOG_USBCMD_RST. */
#define BS_USB_UOG_USBCMD_RST (1U)         /*!< Bit field size in bits for USB_UOG_USBCMD_RST. */

/*! @brief Read current value of the USB_UOG_USBCMD_RST field. */
#define BR_USB_UOG_USBCMD_RST(x) (HW_USB_UOG_USBCMD(x).B.RST)

/*! @brief Format value for bitfield USB_UOG_USBCMD_RST. */
#define BF_USB_UOG_USBCMD_RST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_RST) & BM_USB_UOG_USBCMD_RST)

/*! @brief Set the RST field to a new value. */
#define BW_USB_UOG_USBCMD_RST(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_RST) | BF_USB_UOG_USBCMD_RST(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field FS_1[3:2] (RW)
 *
 * See description at bit 15
 */
/*@{*/
#define BP_USB_UOG_USBCMD_FS_1 (2U)        /*!< Bit position for USB_UOG_USBCMD_FS_1. */
#define BM_USB_UOG_USBCMD_FS_1 (0x0000000CU) /*!< Bit mask for USB_UOG_USBCMD_FS_1. */
#define BS_USB_UOG_USBCMD_FS_1 (2U)        /*!< Bit field size in bits for USB_UOG_USBCMD_FS_1. */

/*! @brief Read current value of the USB_UOG_USBCMD_FS_1 field. */
#define BR_USB_UOG_USBCMD_FS_1(x) (HW_USB_UOG_USBCMD(x).B.FS_1)

/*! @brief Format value for bitfield USB_UOG_USBCMD_FS_1. */
#define BF_USB_UOG_USBCMD_FS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_FS_1) & BM_USB_UOG_USBCMD_FS_1)

/*! @brief Set the FS_1 field to a new value. */
#define BW_USB_UOG_USBCMD_FS_1(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_FS_1) | BF_USB_UOG_USBCMD_FS_1(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field PSE[4] (RW)
 *
 * Periodic Schedule Enable- Read/Write. Default 0b. This bit controls whether
 * the host controller skips processing the Periodic Schedule. Only the host
 * controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Periodic Schedule
 * - 1 - Use the PERIODICLISTBASE register to access the Periodic Schedule.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_PSE (4U)         /*!< Bit position for USB_UOG_USBCMD_PSE. */
#define BM_USB_UOG_USBCMD_PSE (0x00000010U) /*!< Bit mask for USB_UOG_USBCMD_PSE. */
#define BS_USB_UOG_USBCMD_PSE (1U)         /*!< Bit field size in bits for USB_UOG_USBCMD_PSE. */

/*! @brief Read current value of the USB_UOG_USBCMD_PSE field. */
#define BR_USB_UOG_USBCMD_PSE(x) (HW_USB_UOG_USBCMD(x).B.PSE)

/*! @brief Format value for bitfield USB_UOG_USBCMD_PSE. */
#define BF_USB_UOG_USBCMD_PSE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_PSE) & BM_USB_UOG_USBCMD_PSE)

/*! @brief Set the PSE field to a new value. */
#define BW_USB_UOG_USBCMD_PSE(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_PSE) | BF_USB_UOG_USBCMD_PSE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field ASE[5] (RW)
 *
 * Asynchronous Schedule Enable - Read/Write. Default 0b. This bit controls
 * whether the host controller skips processing the Asynchronous Schedule. Only the
 * host controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Asynchronous Schedule.
 * - 1 - Use the ASYNCLISTADDR register to access the Asynchronous Schedule.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_ASE (5U)         /*!< Bit position for USB_UOG_USBCMD_ASE. */
#define BM_USB_UOG_USBCMD_ASE (0x00000020U) /*!< Bit mask for USB_UOG_USBCMD_ASE. */
#define BS_USB_UOG_USBCMD_ASE (1U)         /*!< Bit field size in bits for USB_UOG_USBCMD_ASE. */

/*! @brief Read current value of the USB_UOG_USBCMD_ASE field. */
#define BR_USB_UOG_USBCMD_ASE(x) (HW_USB_UOG_USBCMD(x).B.ASE)

/*! @brief Format value for bitfield USB_UOG_USBCMD_ASE. */
#define BF_USB_UOG_USBCMD_ASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_ASE) & BM_USB_UOG_USBCMD_ASE)

/*! @brief Set the ASE field to a new value. */
#define BW_USB_UOG_USBCMD_ASE(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_ASE) | BF_USB_UOG_USBCMD_ASE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field IAA[6] (RW)
 *
 * Interrupt on Async Advance Doorbell - Read/Write. This bit is used as a
 * doorbell by software to tell the host controller to issue an interrupt the next
 * time it advances asynchronous schedule. Software must write a 1 to this bit to
 * ring the doorbell. When the host controller has evicted all appropriate cached
 * schedule states, it sets the Interrupt on Async Advance status bit in the
 * USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR
 * register is one, then the host controller will assert an interrupt at the next
 * interrupt threshold. The host controller sets this bit to zero after it has set the
 * Interrupt on Sync Advance status bit in the USBSTS register to one. Software
 * should not write a one to this bit when the asynchronous schedule is inactive.
 * Doing so will yield undefined results. This bit is only used in host mode.
 * Writing a one to this bit when device mode is selected will have undefined
 * results.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_IAA (6U)         /*!< Bit position for USB_UOG_USBCMD_IAA. */
#define BM_USB_UOG_USBCMD_IAA (0x00000040U) /*!< Bit mask for USB_UOG_USBCMD_IAA. */
#define BS_USB_UOG_USBCMD_IAA (1U)         /*!< Bit field size in bits for USB_UOG_USBCMD_IAA. */

/*! @brief Read current value of the USB_UOG_USBCMD_IAA field. */
#define BR_USB_UOG_USBCMD_IAA(x) (HW_USB_UOG_USBCMD(x).B.IAA)

/*! @brief Format value for bitfield USB_UOG_USBCMD_IAA. */
#define BF_USB_UOG_USBCMD_IAA(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_IAA) & BM_USB_UOG_USBCMD_IAA)

/*! @brief Set the IAA field to a new value. */
#define BW_USB_UOG_USBCMD_IAA(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_IAA) | BF_USB_UOG_USBCMD_IAA(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field ASP[9:8] (RW)
 *
 * Asynchronous Schedule Park Mode Count - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this field defaults to
 * 3h and is R/W. Otherwise it defaults to zero and is Read-Only. It contains a
 * count of the number of successive transactions the host controller is allowed
 * to execute from a high-speed queue head on the Asynchronous schedule before
 * continuing traversal of the Asynchronous schedule. Valid values are 1h to 3h.
 * Software must not write a zero to this bit when Park Mode Enable is a one as
 * this will result in undefined behavior. This field is set to 3h in all controller
 * core.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_ASP (8U)         /*!< Bit position for USB_UOG_USBCMD_ASP. */
#define BM_USB_UOG_USBCMD_ASP (0x00000300U) /*!< Bit mask for USB_UOG_USBCMD_ASP. */
#define BS_USB_UOG_USBCMD_ASP (2U)         /*!< Bit field size in bits for USB_UOG_USBCMD_ASP. */

/*! @brief Read current value of the USB_UOG_USBCMD_ASP field. */
#define BR_USB_UOG_USBCMD_ASP(x) (HW_USB_UOG_USBCMD(x).B.ASP)

/*! @brief Format value for bitfield USB_UOG_USBCMD_ASP. */
#define BF_USB_UOG_USBCMD_ASP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_ASP) & BM_USB_UOG_USBCMD_ASP)

/*! @brief Set the ASP field to a new value. */
#define BW_USB_UOG_USBCMD_ASP(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_ASP) | BF_USB_UOG_USBCMD_ASP(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field ASPE[11] (RW)
 *
 * Asynchronous Schedule Park Mode Enable - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this bit defaults to
 * a 1h and is R/W. Otherwise the bit must be a zero and is RO. Software uses
 * this bit to enable or disable Park mode. When this bit is one, Park mode is
 * enabled. When this bit is a zero, Park mode is disabled. ASPE bit reset value: '0b'
 * for OTG controller core, '1b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_ASPE (11U)       /*!< Bit position for USB_UOG_USBCMD_ASPE. */
#define BM_USB_UOG_USBCMD_ASPE (0x00000800U) /*!< Bit mask for USB_UOG_USBCMD_ASPE. */
#define BS_USB_UOG_USBCMD_ASPE (1U)        /*!< Bit field size in bits for USB_UOG_USBCMD_ASPE. */

/*! @brief Read current value of the USB_UOG_USBCMD_ASPE field. */
#define BR_USB_UOG_USBCMD_ASPE(x) (HW_USB_UOG_USBCMD(x).B.ASPE)

/*! @brief Format value for bitfield USB_UOG_USBCMD_ASPE. */
#define BF_USB_UOG_USBCMD_ASPE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_ASPE) & BM_USB_UOG_USBCMD_ASPE)

/*! @brief Set the ASPE field to a new value. */
#define BW_USB_UOG_USBCMD_ASPE(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_ASPE) | BF_USB_UOG_USBCMD_ASPE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field ATDTW[12] (RW)
 *
 * Add dTD TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure proper addition of a new dTD to an active (primed) endpoint's
 * linked list. This bit is set and cleared by software. This bit would also be
 * cleared by hardware when state machine is hazard region for which adding a dTD
 * to a primed endpoint may go unrecognized.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_ATDTW (12U)      /*!< Bit position for USB_UOG_USBCMD_ATDTW. */
#define BM_USB_UOG_USBCMD_ATDTW (0x00001000U) /*!< Bit mask for USB_UOG_USBCMD_ATDTW. */
#define BS_USB_UOG_USBCMD_ATDTW (1U)       /*!< Bit field size in bits for USB_UOG_USBCMD_ATDTW. */

/*! @brief Read current value of the USB_UOG_USBCMD_ATDTW field. */
#define BR_USB_UOG_USBCMD_ATDTW(x) (HW_USB_UOG_USBCMD(x).B.ATDTW)

/*! @brief Format value for bitfield USB_UOG_USBCMD_ATDTW. */
#define BF_USB_UOG_USBCMD_ATDTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_ATDTW) & BM_USB_UOG_USBCMD_ATDTW)

/*! @brief Set the ATDTW field to a new value. */
#define BW_USB_UOG_USBCMD_ATDTW(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_ATDTW) | BF_USB_UOG_USBCMD_ATDTW(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field SUTW[13] (RW)
 *
 * Setup TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure that the setup data payload of 8 bytes is extracted from a QH by
 * the DCD without being corrupted. If the setup lockout mode is off (SLOM bit in
 * USB core register n_USBMODE, see USBMODEUSB Device Mode ) then there is a
 * hazard when new setup data arrives while the DCD is copying the setup data
 * payload from the QH for a previous setup packet. This bit is set and cleared by
 * software. This bit would also be cleared by hardware when a hazard detected.
 */
/*@{*/
#define BP_USB_UOG_USBCMD_SUTW (13U)       /*!< Bit position for USB_UOG_USBCMD_SUTW. */
#define BM_USB_UOG_USBCMD_SUTW (0x00002000U) /*!< Bit mask for USB_UOG_USBCMD_SUTW. */
#define BS_USB_UOG_USBCMD_SUTW (1U)        /*!< Bit field size in bits for USB_UOG_USBCMD_SUTW. */

/*! @brief Read current value of the USB_UOG_USBCMD_SUTW field. */
#define BR_USB_UOG_USBCMD_SUTW(x) (HW_USB_UOG_USBCMD(x).B.SUTW)

/*! @brief Format value for bitfield USB_UOG_USBCMD_SUTW. */
#define BF_USB_UOG_USBCMD_SUTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_SUTW) & BM_USB_UOG_USBCMD_SUTW)

/*! @brief Set the SUTW field to a new value. */
#define BW_USB_UOG_USBCMD_SUTW(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_SUTW) | BF_USB_UOG_USBCMD_SUTW(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field FS_2[15] (RW)
 *
 * See also bits 3-2 Frame List Size - (Read/Write or Read Only). [host mode
 * only] This field is Read/Write only if Programmable Frame List Flag in the
 * HCCPARAMS registers is set to one. This field specifies the size of the frame list
 * that controls which bits in the Frame Index Register should be used for the
 * Frame List Current index. This field is made up from USBCMD bits 15, 3 and 2.
 * Value Meaning
 *
 * Values:
 * - 000 - 1024 elements (4096 bytes) Default value
 * - 001 - 512 elements (2048 bytes)
 */
/*@{*/
#define BP_USB_UOG_USBCMD_FS_2 (15U)       /*!< Bit position for USB_UOG_USBCMD_FS_2. */
#define BM_USB_UOG_USBCMD_FS_2 (0x00008000U) /*!< Bit mask for USB_UOG_USBCMD_FS_2. */
#define BS_USB_UOG_USBCMD_FS_2 (1U)        /*!< Bit field size in bits for USB_UOG_USBCMD_FS_2. */

/*! @brief Read current value of the USB_UOG_USBCMD_FS_2 field. */
#define BR_USB_UOG_USBCMD_FS_2(x) (HW_USB_UOG_USBCMD(x).B.FS_2)

/*! @brief Format value for bitfield USB_UOG_USBCMD_FS_2. */
#define BF_USB_UOG_USBCMD_FS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_FS_2) & BM_USB_UOG_USBCMD_FS_2)

/*! @brief Set the FS_2 field to a new value. */
#define BW_USB_UOG_USBCMD_FS_2(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_FS_2) | BF_USB_UOG_USBCMD_FS_2(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBCMD, field ITC[23:16] (RW)
 *
 * Interrupt Threshold Control -Read/Write. The system software uses this field
 * to set the maximum rate at which the host/device controller will issue
 * interrupts. ITC contains the maximum interrupt interval measured in micro-frames.
 * Valid values are shown below. Value Maximum Interrupt Interval
 *
 * Values:
 * - 0 - Immediate (no threshold)
 * - 1 - 1 micro-frame
 * - 10 - 2 micro-frames
 * - 100 - 4 micro-frames
 * - 1000 - 8 micro-frames
 * - 10000 - 16 micro-frames
 * - 100000 - 32 micro-frames
 * - 1000000 - 64 micro-frames
 */
/*@{*/
#define BP_USB_UOG_USBCMD_ITC (16U)        /*!< Bit position for USB_UOG_USBCMD_ITC. */
#define BM_USB_UOG_USBCMD_ITC (0x00FF0000U) /*!< Bit mask for USB_UOG_USBCMD_ITC. */
#define BS_USB_UOG_USBCMD_ITC (8U)         /*!< Bit field size in bits for USB_UOG_USBCMD_ITC. */

/*! @brief Read current value of the USB_UOG_USBCMD_ITC field. */
#define BR_USB_UOG_USBCMD_ITC(x) (HW_USB_UOG_USBCMD(x).B.ITC)

/*! @brief Format value for bitfield USB_UOG_USBCMD_ITC. */
#define BF_USB_UOG_USBCMD_ITC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBCMD_ITC) & BM_USB_UOG_USBCMD_ITC)

/*! @brief Set the ITC field to a new value. */
#define BW_USB_UOG_USBCMD_ITC(x, v) (HW_USB_UOG_USBCMD_WR(x, (HW_USB_UOG_USBCMD_RD(x) & ~BM_USB_UOG_USBCMD_ITC) | BF_USB_UOG_USBCMD_ITC(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_USBSTS - USB Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_USBSTS - USB Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates various states of the Host/Device Controller and any
 * pending interrupts. This register does not indicate status resulting from a
 * transaction on the serial bus.
 */
typedef union _hw_usb_uog_usbsts
{
    uint32_t U;
    struct _hw_usb_uog_usbsts_bitfields
    {
        uint32_t UI : 1;               /*!< [0]  */
        uint32_t UEI : 1;              /*!< [1]  */
        uint32_t PCI : 1;              /*!< [2]  */
        uint32_t FRI : 1;              /*!< [3]  */
        uint32_t SEI : 1;              /*!< [4]  */
        uint32_t AAI : 1;              /*!< [5]  */
        uint32_t URI : 1;              /*!< [6]  */
        uint32_t SRI : 1;              /*!< [7]  */
        uint32_t SLI : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPII : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t HCH : 1;              /*!< [12]  */
        uint32_t RCL : 1;              /*!< [13]  */
        uint32_t PS : 1;               /*!< [14]  */
        uint32_t AS : 1;               /*!< [15]  */
        uint32_t NAKI : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 7;        /*!< [23:17]  */
        uint32_t TI0 : 1;              /*!< [24]  */
        uint32_t TI1 : 1;              /*!< [25]  */
        uint32_t RESERVED3 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uog_usbsts_t;

/*!
 * @name Constants and macros for entire USB_UOG_USBSTS register
 */
/*@{*/
#define HW_USB_UOG_USBSTS_ADDR(x) ((uintptr_t)(x) + 0x144U)

#define HW_USB_UOG_USBSTS(x)     (*(__IO hw_usb_uog_usbsts_t *) HW_USB_UOG_USBSTS_ADDR(x))
#define HW_USB_UOG_USBSTS_RD(x)  (HW_USB_UOG_USBSTS(x).U)
#define HW_USB_UOG_USBSTS_WR(x, v) (HW_USB_UOG_USBSTS(x).U = (v))
#define HW_USB_UOG_USBSTS_SET(x, v) (HW_USB_UOG_USBSTS_WR(x, HW_USB_UOG_USBSTS_RD(x) |  (v)))
#define HW_USB_UOG_USBSTS_CLR(x, v) (HW_USB_UOG_USBSTS_WR(x, HW_USB_UOG_USBSTS_RD(x) & ~(v)))
#define HW_USB_UOG_USBSTS_TOG(x, v) (HW_USB_UOG_USBSTS_WR(x, HW_USB_UOG_USBSTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_USBSTS bitfields
 */

/*!
 * @name Register USB_UOG_USBSTS, field UI[0] (RW)
 *
 * USB Interrupt (USBINT) - R/WC. This bit is set by the Host/Device Controller
 * when the cause of an interrupt is a completion of a USB transaction where the
 * Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit
 * is also set by the Host/Device Controller when a short packet is detected. A
 * short packet is when the actual number of bytes received was less than the
 * expected number of bytes.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_UI (0U)          /*!< Bit position for USB_UOG_USBSTS_UI. */
#define BM_USB_UOG_USBSTS_UI (0x00000001U) /*!< Bit mask for USB_UOG_USBSTS_UI. */
#define BS_USB_UOG_USBSTS_UI (1U)          /*!< Bit field size in bits for USB_UOG_USBSTS_UI. */

/*! @brief Read current value of the USB_UOG_USBSTS_UI field. */
#define BR_USB_UOG_USBSTS_UI(x) (HW_USB_UOG_USBSTS(x).B.UI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_UI. */
#define BF_USB_UOG_USBSTS_UI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_UI) & BM_USB_UOG_USBSTS_UI)

/*! @brief Set the UI field to a new value. */
#define BW_USB_UOG_USBSTS_UI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_UI) | BF_USB_UOG_USBSTS_UI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field UEI[1] (RW)
 *
 * USB Error Interrupt (USBERRINT) - R/WC. When completion of a USB transaction
 * results in an error condition, this bit is set by the Host/Device Controller.
 * This bit is set along with the USBINT bit, if the TD on which the error
 * interrupt occurred also had its interrupt on complete (IOC) bit set. The device
 * controller detects resume signaling only.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_UEI (1U)         /*!< Bit position for USB_UOG_USBSTS_UEI. */
#define BM_USB_UOG_USBSTS_UEI (0x00000002U) /*!< Bit mask for USB_UOG_USBSTS_UEI. */
#define BS_USB_UOG_USBSTS_UEI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_UEI. */

/*! @brief Read current value of the USB_UOG_USBSTS_UEI field. */
#define BR_USB_UOG_USBSTS_UEI(x) (HW_USB_UOG_USBSTS(x).B.UEI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_UEI. */
#define BF_USB_UOG_USBSTS_UEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_UEI) & BM_USB_UOG_USBSTS_UEI)

/*! @brief Set the UEI field to a new value. */
#define BW_USB_UOG_USBSTS_UEI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_UEI) | BF_USB_UOG_USBSTS_UEI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field PCI[2] (RW)
 *
 * Port Change Detect - R/WC. The Host Controller sets this bit to a one when on
 * any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the
 * Force Port Resume bit is set as the result of a J-K transition on the
 * suspended port. The Device Controller sets this bit to a one when the port controller
 * enters the full or high-speed operational state. When the port controller
 * exits the full or high-speed operation states due to Reset or Suspend events, the
 * notification mechanisms are the USB Reset Received bit and the DCSuspend bits
 * respectively.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_PCI (2U)         /*!< Bit position for USB_UOG_USBSTS_PCI. */
#define BM_USB_UOG_USBSTS_PCI (0x00000004U) /*!< Bit mask for USB_UOG_USBSTS_PCI. */
#define BS_USB_UOG_USBSTS_PCI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_PCI. */

/*! @brief Read current value of the USB_UOG_USBSTS_PCI field. */
#define BR_USB_UOG_USBSTS_PCI(x) (HW_USB_UOG_USBSTS(x).B.PCI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_PCI. */
#define BF_USB_UOG_USBSTS_PCI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_PCI) & BM_USB_UOG_USBSTS_PCI)

/*! @brief Set the PCI field to a new value. */
#define BW_USB_UOG_USBSTS_PCI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_PCI) | BF_USB_UOG_USBSTS_PCI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field FRI[3] (RW)
 *
 * Frame List Rollover - R/WC. The Host Controller sets this bit to a one when
 * the Frame List Index rolls over from its maximum value to zero. The exact value
 * at which the rollover occurs depends on the frame list size. For example. If
 * the frame list size (as programmed in the Frame List Size field of the
 * USB_n_USBCMD register) is 1024, the Frame Index Register rolls over every time
 * FRINDEX [13] toggles. Similarly, if the size is 512, the Host Controller sets this
 * bit to a one every time FHINDEX [12] toggles. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_FRI (3U)         /*!< Bit position for USB_UOG_USBSTS_FRI. */
#define BM_USB_UOG_USBSTS_FRI (0x00000008U) /*!< Bit mask for USB_UOG_USBSTS_FRI. */
#define BS_USB_UOG_USBSTS_FRI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_FRI. */

/*! @brief Read current value of the USB_UOG_USBSTS_FRI field. */
#define BR_USB_UOG_USBSTS_FRI(x) (HW_USB_UOG_USBSTS(x).B.FRI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_FRI. */
#define BF_USB_UOG_USBSTS_FRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_FRI) & BM_USB_UOG_USBSTS_FRI)

/*! @brief Set the FRI field to a new value. */
#define BW_USB_UOG_USBSTS_FRI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_FRI) | BF_USB_UOG_USBSTS_FRI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field SEI[4] (RW)
 *
 * System Error- R/WC. This bit is will be set to '1b' when an Error response is
 * seen to a read on the system interface.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_SEI (4U)         /*!< Bit position for USB_UOG_USBSTS_SEI. */
#define BM_USB_UOG_USBSTS_SEI (0x00000010U) /*!< Bit mask for USB_UOG_USBSTS_SEI. */
#define BS_USB_UOG_USBSTS_SEI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_SEI. */

/*! @brief Read current value of the USB_UOG_USBSTS_SEI field. */
#define BR_USB_UOG_USBSTS_SEI(x) (HW_USB_UOG_USBSTS(x).B.SEI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_SEI. */
#define BF_USB_UOG_USBSTS_SEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_SEI) & BM_USB_UOG_USBSTS_SEI)

/*! @brief Set the SEI field to a new value. */
#define BW_USB_UOG_USBSTS_SEI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_SEI) | BF_USB_UOG_USBSTS_SEI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field AAI[5] (RW)
 *
 * Interrupt on Async Advance - R/WC. System software can force the host
 * controller to issue an interrupt the next time the host controller advances the
 * asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell
 * bit in the n_USBCMD register. This status bit indicates the assertion of that
 * interrupt source. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_AAI (5U)         /*!< Bit position for USB_UOG_USBSTS_AAI. */
#define BM_USB_UOG_USBSTS_AAI (0x00000020U) /*!< Bit mask for USB_UOG_USBSTS_AAI. */
#define BS_USB_UOG_USBSTS_AAI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_AAI. */

/*! @brief Read current value of the USB_UOG_USBSTS_AAI field. */
#define BR_USB_UOG_USBSTS_AAI(x) (HW_USB_UOG_USBSTS(x).B.AAI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_AAI. */
#define BF_USB_UOG_USBSTS_AAI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_AAI) & BM_USB_UOG_USBSTS_AAI)

/*! @brief Set the AAI field to a new value. */
#define BW_USB_UOG_USBSTS_AAI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_AAI) | BF_USB_UOG_USBSTS_AAI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field URI[6] (RW)
 *
 * USB Reset Received - R/WC. When the device controller detects a USB Reset and
 * enters the default state, this bit will be set to a one. Software can write a
 * 1 to this bit to clear the USB Reset Received status bit. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_URI (6U)         /*!< Bit position for USB_UOG_USBSTS_URI. */
#define BM_USB_UOG_USBSTS_URI (0x00000040U) /*!< Bit mask for USB_UOG_USBSTS_URI. */
#define BS_USB_UOG_USBSTS_URI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_URI. */

/*! @brief Read current value of the USB_UOG_USBSTS_URI field. */
#define BR_USB_UOG_USBSTS_URI(x) (HW_USB_UOG_USBSTS(x).B.URI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_URI. */
#define BF_USB_UOG_USBSTS_URI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_URI) & BM_USB_UOG_USBSTS_URI)

/*! @brief Set the URI field to a new value. */
#define BW_USB_UOG_USBSTS_URI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_URI) | BF_USB_UOG_USBSTS_URI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field SRI[7] (RW)
 *
 * SOF Received - R/WC. When the device controller detects a Start Of (micro)
 * Frame, this bit will be set to a one. When a SOF is extremely late, the device
 * controller will automatically set this bit to indicate that an SOF was
 * expected. Therefore, this bit will be set roughly every 1ms in device FS mode and
 * every 125ms in HS mode and will be synchronized to the actual SOF that is
 * received. Because the device controller is initialized to FS before connect, this bit
 * will be set at an interval of 1ms during the prelude to connect and chirp. In
 * host mode, this bit will be set every 125us and can be used by host controller
 * driver as a time base. Software writes a 1 to this bit to clear it.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_SRI (7U)         /*!< Bit position for USB_UOG_USBSTS_SRI. */
#define BM_USB_UOG_USBSTS_SRI (0x00000080U) /*!< Bit mask for USB_UOG_USBSTS_SRI. */
#define BS_USB_UOG_USBSTS_SRI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_SRI. */

/*! @brief Read current value of the USB_UOG_USBSTS_SRI field. */
#define BR_USB_UOG_USBSTS_SRI(x) (HW_USB_UOG_USBSTS(x).B.SRI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_SRI. */
#define BF_USB_UOG_USBSTS_SRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_SRI) & BM_USB_UOG_USBSTS_SRI)

/*! @brief Set the SRI field to a new value. */
#define BW_USB_UOG_USBSTS_SRI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_SRI) | BF_USB_UOG_USBSTS_SRI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field SLI[8] (RW)
 *
 * DCSuspend - R/WC. When a controller enters a suspend state from an active
 * state, this bit will be set to a one. The device controller clears the bit upon
 * exiting from a suspend state. Only used in device operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_SLI (8U)         /*!< Bit position for USB_UOG_USBSTS_SLI. */
#define BM_USB_UOG_USBSTS_SLI (0x00000100U) /*!< Bit mask for USB_UOG_USBSTS_SLI. */
#define BS_USB_UOG_USBSTS_SLI (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_SLI. */

/*! @brief Read current value of the USB_UOG_USBSTS_SLI field. */
#define BR_USB_UOG_USBSTS_SLI(x) (HW_USB_UOG_USBSTS(x).B.SLI)

/*! @brief Format value for bitfield USB_UOG_USBSTS_SLI. */
#define BF_USB_UOG_USBSTS_SLI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_SLI) & BM_USB_UOG_USBSTS_SLI)

/*! @brief Set the SLI field to a new value. */
#define BW_USB_UOG_USBSTS_SLI(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_SLI) | BF_USB_UOG_USBSTS_SLI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field ULPII[10] (RW)
 *
 * ULPI Interrupt - R/WC. This bit will be set '1b' by hardware when there is an
 * event completion in ULPI viewport. This bit is usable only if the controller
 * support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_ULPII (10U)      /*!< Bit position for USB_UOG_USBSTS_ULPII. */
#define BM_USB_UOG_USBSTS_ULPII (0x00000400U) /*!< Bit mask for USB_UOG_USBSTS_ULPII. */
#define BS_USB_UOG_USBSTS_ULPII (1U)       /*!< Bit field size in bits for USB_UOG_USBSTS_ULPII. */

/*! @brief Read current value of the USB_UOG_USBSTS_ULPII field. */
#define BR_USB_UOG_USBSTS_ULPII(x) (HW_USB_UOG_USBSTS(x).B.ULPII)

/*! @brief Format value for bitfield USB_UOG_USBSTS_ULPII. */
#define BF_USB_UOG_USBSTS_ULPII(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_ULPII) & BM_USB_UOG_USBSTS_ULPII)

/*! @brief Set the ULPII field to a new value. */
#define BW_USB_UOG_USBSTS_ULPII(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_ULPII) | BF_USB_UOG_USBSTS_ULPII(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field HCH[12] (RW)
 *
 * HCHaIted - Read Only. This bit is a zero whenever the Run/Stop bit is a one.
 * The Controller sets this bit to one after it has stopped executing because of
 * the Run/Stop bit being set to 0, either by software or by the Controller
 * hardware (for example, an internal error). Only used in the host operation mode.
 * Default value is '0b' for OTG core, and '1b' for Host1/Host2/Host3 core. This is
 * because OTG core is not operating as host in default. Please see CM bit in
 * USB_n_USBMODE register. HCH bit reset value: '0b' for OTG controller core, '1b'
 * for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_HCH (12U)        /*!< Bit position for USB_UOG_USBSTS_HCH. */
#define BM_USB_UOG_USBSTS_HCH (0x00001000U) /*!< Bit mask for USB_UOG_USBSTS_HCH. */
#define BS_USB_UOG_USBSTS_HCH (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_HCH. */

/*! @brief Read current value of the USB_UOG_USBSTS_HCH field. */
#define BR_USB_UOG_USBSTS_HCH(x) (HW_USB_UOG_USBSTS(x).B.HCH)

/*! @brief Format value for bitfield USB_UOG_USBSTS_HCH. */
#define BF_USB_UOG_USBSTS_HCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_HCH) & BM_USB_UOG_USBSTS_HCH)

/*! @brief Set the HCH field to a new value. */
#define BW_USB_UOG_USBSTS_HCH(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_HCH) | BF_USB_UOG_USBSTS_HCH(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field RCL[13] (RW)
 *
 * Reclamation - Read Only. This is a read-only status bit used to detect an
 * empty asynchronous schedule. Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_RCL (13U)        /*!< Bit position for USB_UOG_USBSTS_RCL. */
#define BM_USB_UOG_USBSTS_RCL (0x00002000U) /*!< Bit mask for USB_UOG_USBSTS_RCL. */
#define BS_USB_UOG_USBSTS_RCL (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_RCL. */

/*! @brief Read current value of the USB_UOG_USBSTS_RCL field. */
#define BR_USB_UOG_USBSTS_RCL(x) (HW_USB_UOG_USBSTS(x).B.RCL)

/*! @brief Format value for bitfield USB_UOG_USBSTS_RCL. */
#define BF_USB_UOG_USBSTS_RCL(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_RCL) & BM_USB_UOG_USBSTS_RCL)

/*! @brief Set the RCL field to a new value. */
#define BW_USB_UOG_USBSTS_RCL(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_RCL) | BF_USB_UOG_USBSTS_RCL(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field PS[14] (RW)
 *
 * Periodic Schedule Status - Read Only. This bit reports the current real
 * status of the Periodic Schedule. When set to zero the periodic schedule is
 * disabled, and if set to one the status is enabled. The Host Controller is not required
 * to immediately disable or enable the Periodic Schedule when software
 * transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and
 * the Periodic Schedule Enable bit are the same value, the Periodic Schedule is
 * either enabled (1) or disabled (0). Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_PS (14U)         /*!< Bit position for USB_UOG_USBSTS_PS. */
#define BM_USB_UOG_USBSTS_PS (0x00004000U) /*!< Bit mask for USB_UOG_USBSTS_PS. */
#define BS_USB_UOG_USBSTS_PS (1U)          /*!< Bit field size in bits for USB_UOG_USBSTS_PS. */

/*! @brief Read current value of the USB_UOG_USBSTS_PS field. */
#define BR_USB_UOG_USBSTS_PS(x) (HW_USB_UOG_USBSTS(x).B.PS)

/*! @brief Format value for bitfield USB_UOG_USBSTS_PS. */
#define BF_USB_UOG_USBSTS_PS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_PS) & BM_USB_UOG_USBSTS_PS)

/*! @brief Set the PS field to a new value. */
#define BW_USB_UOG_USBSTS_PS(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_PS) | BF_USB_UOG_USBSTS_PS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field AS[15] (RW)
 *
 * Asynchronous Schedule Status - Read Only. This bit reports the current real
 * status of the Asynchronous Schedule. When set to zero the asynchronous schedule
 * status is disabled and if set to one the status is enabled. The Host
 * Controller is not required to immediately disable or enable the Asynchronous Schedule
 * when software transitions the Asynchronous Schedule Enable bit in the USBCMD
 * register. When this bit and the Asynchronous Schedule Enable bit are the same
 * value, the Asynchronous Schedule is either enabled (1) or disabled (0). Only
 * used in the host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_AS (15U)         /*!< Bit position for USB_UOG_USBSTS_AS. */
#define BM_USB_UOG_USBSTS_AS (0x00008000U) /*!< Bit mask for USB_UOG_USBSTS_AS. */
#define BS_USB_UOG_USBSTS_AS (1U)          /*!< Bit field size in bits for USB_UOG_USBSTS_AS. */

/*! @brief Read current value of the USB_UOG_USBSTS_AS field. */
#define BR_USB_UOG_USBSTS_AS(x) (HW_USB_UOG_USBSTS(x).B.AS)

/*! @brief Format value for bitfield USB_UOG_USBSTS_AS. */
#define BF_USB_UOG_USBSTS_AS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_AS) & BM_USB_UOG_USBSTS_AS)

/*! @brief Set the AS field to a new value. */
#define BW_USB_UOG_USBSTS_AS(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_AS) | BF_USB_UOG_USBSTS_AS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field NAKI[16] (RO)
 *
 * NAK Interrupt Bit--RO. This bit is set by hardware when for a particular
 * endpoint both the TX/RX Endpoint NAK bit and corresponding TX/RX Endpoint NAK
 * Enable bit are set. This bit is automatically cleared by hardware when all Enabled
 * TX/RX Endpoint NAK bits are cleared.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_NAKI (16U)       /*!< Bit position for USB_UOG_USBSTS_NAKI. */
#define BM_USB_UOG_USBSTS_NAKI (0x00010000U) /*!< Bit mask for USB_UOG_USBSTS_NAKI. */
#define BS_USB_UOG_USBSTS_NAKI (1U)        /*!< Bit field size in bits for USB_UOG_USBSTS_NAKI. */

/*! @brief Read current value of the USB_UOG_USBSTS_NAKI field. */
#define BR_USB_UOG_USBSTS_NAKI(x) (HW_USB_UOG_USBSTS(x).B.NAKI)
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field TI0[24] (RW)
 *
 * General Purpose Timer Interrupt 0(GPTINT0)--R/WC. This bit is set when the
 * counter in the GPTIMER0CTRL register transitions to zero, writing a one to this
 * bit clears it.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_TI0 (24U)        /*!< Bit position for USB_UOG_USBSTS_TI0. */
#define BM_USB_UOG_USBSTS_TI0 (0x01000000U) /*!< Bit mask for USB_UOG_USBSTS_TI0. */
#define BS_USB_UOG_USBSTS_TI0 (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_TI0. */

/*! @brief Read current value of the USB_UOG_USBSTS_TI0 field. */
#define BR_USB_UOG_USBSTS_TI0(x) (HW_USB_UOG_USBSTS(x).B.TI0)

/*! @brief Format value for bitfield USB_UOG_USBSTS_TI0. */
#define BF_USB_UOG_USBSTS_TI0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_TI0) & BM_USB_UOG_USBSTS_TI0)

/*! @brief Set the TI0 field to a new value. */
#define BW_USB_UOG_USBSTS_TI0(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_TI0) | BF_USB_UOG_USBSTS_TI0(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBSTS, field TI1[25] (RW)
 *
 * General Purpose Timer Interrupt 1(GPTINT1)--R/WC. This bit is set when the
 * counter in the GPTIMER1CTRL register transitions to zero, writing a one to this
 * bit will clear it.
 */
/*@{*/
#define BP_USB_UOG_USBSTS_TI1 (25U)        /*!< Bit position for USB_UOG_USBSTS_TI1. */
#define BM_USB_UOG_USBSTS_TI1 (0x02000000U) /*!< Bit mask for USB_UOG_USBSTS_TI1. */
#define BS_USB_UOG_USBSTS_TI1 (1U)         /*!< Bit field size in bits for USB_UOG_USBSTS_TI1. */

/*! @brief Read current value of the USB_UOG_USBSTS_TI1 field. */
#define BR_USB_UOG_USBSTS_TI1(x) (HW_USB_UOG_USBSTS(x).B.TI1)

/*! @brief Format value for bitfield USB_UOG_USBSTS_TI1. */
#define BF_USB_UOG_USBSTS_TI1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBSTS_TI1) & BM_USB_UOG_USBSTS_TI1)

/*! @brief Set the TI1 field to a new value. */
#define BW_USB_UOG_USBSTS_TI1(x, v) (HW_USB_UOG_USBSTS_WR(x, (HW_USB_UOG_USBSTS_RD(x) & ~BM_USB_UOG_USBSTS_TI1) | BF_USB_UOG_USBSTS_TI1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_USBINTR - Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_USBINTR - Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The interrupts to software are enabled with this register. An interrupt is
 * generated when a bit is set and the corresponding interrupt source is active.
 * The USB Status register (n_USBSTS) still shows interrupt sources even if they
 * are disabled by the n_USBINTR register, allowing polling of interrupt events by
 * the software.
 */
typedef union _hw_usb_uog_usbintr
{
    uint32_t U;
    struct _hw_usb_uog_usbintr_bitfields
    {
        uint32_t UE : 1;               /*!< [0]  */
        uint32_t UEE : 1;              /*!< [1]  */
        uint32_t PCE : 1;              /*!< [2]  */
        uint32_t FRE : 1;              /*!< [3]  */
        uint32_t SEE : 1;              /*!< [4]  */
        uint32_t AAE : 1;              /*!< [5]  */
        uint32_t URE : 1;              /*!< [6]  */
        uint32_t SRE : 1;              /*!< [7]  */
        uint32_t SLE : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPIE : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t NAKE : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 1;        /*!< [17]  */
        uint32_t UAIE : 1;             /*!< [18]  */
        uint32_t UPIE : 1;             /*!< [19]  */
        uint32_t RESERVED3 : 4;        /*!< [23:20]  */
        uint32_t TIE0 : 1;             /*!< [24]  */
        uint32_t TIE1 : 1;             /*!< [25]  */
        uint32_t RESERVED4 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uog_usbintr_t;

/*!
 * @name Constants and macros for entire USB_UOG_USBINTR register
 */
/*@{*/
#define HW_USB_UOG_USBINTR_ADDR(x) ((uintptr_t)(x) + 0x148U)

#define HW_USB_UOG_USBINTR(x)    (*(__IO hw_usb_uog_usbintr_t *) HW_USB_UOG_USBINTR_ADDR(x))
#define HW_USB_UOG_USBINTR_RD(x) (HW_USB_UOG_USBINTR(x).U)
#define HW_USB_UOG_USBINTR_WR(x, v) (HW_USB_UOG_USBINTR(x).U = (v))
#define HW_USB_UOG_USBINTR_SET(x, v) (HW_USB_UOG_USBINTR_WR(x, HW_USB_UOG_USBINTR_RD(x) |  (v)))
#define HW_USB_UOG_USBINTR_CLR(x, v) (HW_USB_UOG_USBINTR_WR(x, HW_USB_UOG_USBINTR_RD(x) & ~(v)))
#define HW_USB_UOG_USBINTR_TOG(x, v) (HW_USB_UOG_USBINTR_WR(x, HW_USB_UOG_USBINTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_USBINTR bitfields
 */

/*!
 * @name Register USB_UOG_USBINTR, field UE[0] (RW)
 *
 * USB Interrupt Enalbe When this bit is one and the UI bit in n_USBSTS register
 * is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_UE (0U)         /*!< Bit position for USB_UOG_USBINTR_UE. */
#define BM_USB_UOG_USBINTR_UE (0x00000001U) /*!< Bit mask for USB_UOG_USBINTR_UE. */
#define BS_USB_UOG_USBINTR_UE (1U)         /*!< Bit field size in bits for USB_UOG_USBINTR_UE. */

/*! @brief Read current value of the USB_UOG_USBINTR_UE field. */
#define BR_USB_UOG_USBINTR_UE(x) (HW_USB_UOG_USBINTR(x).B.UE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_UE. */
#define BF_USB_UOG_USBINTR_UE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_UE) & BM_USB_UOG_USBINTR_UE)

/*! @brief Set the UE field to a new value. */
#define BW_USB_UOG_USBINTR_UE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_UE) | BF_USB_UOG_USBINTR_UE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field UEE[1] (RW)
 *
 * USB Error Interrupt Enable When this bit is one and the UEI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_UEE (1U)        /*!< Bit position for USB_UOG_USBINTR_UEE. */
#define BM_USB_UOG_USBINTR_UEE (0x00000002U) /*!< Bit mask for USB_UOG_USBINTR_UEE. */
#define BS_USB_UOG_USBINTR_UEE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_UEE. */

/*! @brief Read current value of the USB_UOG_USBINTR_UEE field. */
#define BR_USB_UOG_USBINTR_UEE(x) (HW_USB_UOG_USBINTR(x).B.UEE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_UEE. */
#define BF_USB_UOG_USBINTR_UEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_UEE) & BM_USB_UOG_USBINTR_UEE)

/*! @brief Set the UEE field to a new value. */
#define BW_USB_UOG_USBINTR_UEE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_UEE) | BF_USB_UOG_USBINTR_UEE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field PCE[2] (RW)
 *
 * Port Change Detect Interrupt Enable When this bit is one and the PCI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_PCE (2U)        /*!< Bit position for USB_UOG_USBINTR_PCE. */
#define BM_USB_UOG_USBINTR_PCE (0x00000004U) /*!< Bit mask for USB_UOG_USBINTR_PCE. */
#define BS_USB_UOG_USBINTR_PCE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_PCE. */

/*! @brief Read current value of the USB_UOG_USBINTR_PCE field. */
#define BR_USB_UOG_USBINTR_PCE(x) (HW_USB_UOG_USBINTR(x).B.PCE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_PCE. */
#define BF_USB_UOG_USBINTR_PCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_PCE) & BM_USB_UOG_USBINTR_PCE)

/*! @brief Set the PCE field to a new value. */
#define BW_USB_UOG_USBINTR_PCE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_PCE) | BF_USB_UOG_USBINTR_PCE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field FRE[3] (RW)
 *
 * Frame List Rollover Interrupt Enable When this bit is one and the FRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used
 * in host operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_FRE (3U)        /*!< Bit position for USB_UOG_USBINTR_FRE. */
#define BM_USB_UOG_USBINTR_FRE (0x00000008U) /*!< Bit mask for USB_UOG_USBINTR_FRE. */
#define BS_USB_UOG_USBINTR_FRE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_FRE. */

/*! @brief Read current value of the USB_UOG_USBINTR_FRE field. */
#define BR_USB_UOG_USBINTR_FRE(x) (HW_USB_UOG_USBINTR(x).B.FRE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_FRE. */
#define BF_USB_UOG_USBINTR_FRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_FRE) & BM_USB_UOG_USBINTR_FRE)

/*! @brief Set the FRE field to a new value. */
#define BW_USB_UOG_USBINTR_FRE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_FRE) | BF_USB_UOG_USBINTR_FRE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field SEE[4] (RW)
 *
 * System Error Interrupt Enable When this bit is one and the SEI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_SEE (4U)        /*!< Bit position for USB_UOG_USBINTR_SEE. */
#define BM_USB_UOG_USBINTR_SEE (0x00000010U) /*!< Bit mask for USB_UOG_USBINTR_SEE. */
#define BS_USB_UOG_USBINTR_SEE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_SEE. */

/*! @brief Read current value of the USB_UOG_USBINTR_SEE field. */
#define BR_USB_UOG_USBINTR_SEE(x) (HW_USB_UOG_USBINTR(x).B.SEE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_SEE. */
#define BF_USB_UOG_USBINTR_SEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_SEE) & BM_USB_UOG_USBINTR_SEE)

/*! @brief Set the SEE field to a new value. */
#define BW_USB_UOG_USBINTR_SEE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_SEE) | BF_USB_UOG_USBINTR_SEE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field AAE[5] (RW)
 *
 * Async Advance Interrupt Enable When this bit is one and the AAI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_AAE (5U)        /*!< Bit position for USB_UOG_USBINTR_AAE. */
#define BM_USB_UOG_USBINTR_AAE (0x00000020U) /*!< Bit mask for USB_UOG_USBINTR_AAE. */
#define BS_USB_UOG_USBINTR_AAE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_AAE. */

/*! @brief Read current value of the USB_UOG_USBINTR_AAE field. */
#define BR_USB_UOG_USBINTR_AAE(x) (HW_USB_UOG_USBINTR(x).B.AAE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_AAE. */
#define BF_USB_UOG_USBINTR_AAE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_AAE) & BM_USB_UOG_USBINTR_AAE)

/*! @brief Set the AAE field to a new value. */
#define BW_USB_UOG_USBINTR_AAE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_AAE) | BF_USB_UOG_USBINTR_AAE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field URE[6] (RW)
 *
 * USB Reset Interrupt Enable When this bit is one and the URI bit in n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_URE (6U)        /*!< Bit position for USB_UOG_USBINTR_URE. */
#define BM_USB_UOG_USBINTR_URE (0x00000040U) /*!< Bit mask for USB_UOG_USBINTR_URE. */
#define BS_USB_UOG_USBINTR_URE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_URE. */

/*! @brief Read current value of the USB_UOG_USBINTR_URE field. */
#define BR_USB_UOG_USBINTR_URE(x) (HW_USB_UOG_USBINTR(x).B.URE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_URE. */
#define BF_USB_UOG_USBINTR_URE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_URE) & BM_USB_UOG_USBINTR_URE)

/*! @brief Set the URE field to a new value. */
#define BW_USB_UOG_USBINTR_URE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_URE) | BF_USB_UOG_USBINTR_URE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field SRE[7] (RW)
 *
 * SOF Received Interrupt Enable When this bit is one and the SRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_SRE (7U)        /*!< Bit position for USB_UOG_USBINTR_SRE. */
#define BM_USB_UOG_USBINTR_SRE (0x00000080U) /*!< Bit mask for USB_UOG_USBINTR_SRE. */
#define BS_USB_UOG_USBINTR_SRE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_SRE. */

/*! @brief Read current value of the USB_UOG_USBINTR_SRE field. */
#define BR_USB_UOG_USBINTR_SRE(x) (HW_USB_UOG_USBINTR(x).B.SRE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_SRE. */
#define BF_USB_UOG_USBINTR_SRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_SRE) & BM_USB_UOG_USBINTR_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_USB_UOG_USBINTR_SRE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_SRE) | BF_USB_UOG_USBINTR_SRE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field SLE[8] (RW)
 *
 * Sleep Interrupt Enable When this bit is one and the SLI bit in n_n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_SLE (8U)        /*!< Bit position for USB_UOG_USBINTR_SLE. */
#define BM_USB_UOG_USBINTR_SLE (0x00000100U) /*!< Bit mask for USB_UOG_USBINTR_SLE. */
#define BS_USB_UOG_USBINTR_SLE (1U)        /*!< Bit field size in bits for USB_UOG_USBINTR_SLE. */

/*! @brief Read current value of the USB_UOG_USBINTR_SLE field. */
#define BR_USB_UOG_USBINTR_SLE(x) (HW_USB_UOG_USBINTR(x).B.SLE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_SLE. */
#define BF_USB_UOG_USBINTR_SLE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_SLE) & BM_USB_UOG_USBINTR_SLE)

/*! @brief Set the SLE field to a new value. */
#define BW_USB_UOG_USBINTR_SLE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_SLE) | BF_USB_UOG_USBINTR_SLE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field ULPIE[10] (RW)
 *
 * ULPI Interrupt Enable When this bit is one and the UPLII bit in n_USBSTS
 * register is a one the controller will issue an interrupt. This bit is usable only
 * if the controller support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_ULPIE (10U)     /*!< Bit position for USB_UOG_USBINTR_ULPIE. */
#define BM_USB_UOG_USBINTR_ULPIE (0x00000400U) /*!< Bit mask for USB_UOG_USBINTR_ULPIE. */
#define BS_USB_UOG_USBINTR_ULPIE (1U)      /*!< Bit field size in bits for USB_UOG_USBINTR_ULPIE. */

/*! @brief Read current value of the USB_UOG_USBINTR_ULPIE field. */
#define BR_USB_UOG_USBINTR_ULPIE(x) (HW_USB_UOG_USBINTR(x).B.ULPIE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_ULPIE. */
#define BF_USB_UOG_USBINTR_ULPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_ULPIE) & BM_USB_UOG_USBINTR_ULPIE)

/*! @brief Set the ULPIE field to a new value. */
#define BW_USB_UOG_USBINTR_ULPIE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_ULPIE) | BF_USB_UOG_USBINTR_ULPIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field NAKE[16] (RW)
 *
 * NAK Interrupt Enable When this bit is one and the NAKI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_NAKE (16U)      /*!< Bit position for USB_UOG_USBINTR_NAKE. */
#define BM_USB_UOG_USBINTR_NAKE (0x00010000U) /*!< Bit mask for USB_UOG_USBINTR_NAKE. */
#define BS_USB_UOG_USBINTR_NAKE (1U)       /*!< Bit field size in bits for USB_UOG_USBINTR_NAKE. */

/*! @brief Read current value of the USB_UOG_USBINTR_NAKE field. */
#define BR_USB_UOG_USBINTR_NAKE(x) (HW_USB_UOG_USBINTR(x).B.NAKE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_NAKE. */
#define BF_USB_UOG_USBINTR_NAKE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_NAKE) & BM_USB_UOG_USBINTR_NAKE)

/*! @brief Set the NAKE field to a new value. */
#define BW_USB_UOG_USBINTR_NAKE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_NAKE) | BF_USB_UOG_USBINTR_NAKE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field UAIE[18] (RW)
 *
 * USB Host Asynchronous Interrupt Enable When this bit is one, and the UAI bit
 * in the n_USBSTS register is one, host controller will issue an interrupt at
 * the next interrupt threshold.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_UAIE (18U)      /*!< Bit position for USB_UOG_USBINTR_UAIE. */
#define BM_USB_UOG_USBINTR_UAIE (0x00040000U) /*!< Bit mask for USB_UOG_USBINTR_UAIE. */
#define BS_USB_UOG_USBINTR_UAIE (1U)       /*!< Bit field size in bits for USB_UOG_USBINTR_UAIE. */

/*! @brief Read current value of the USB_UOG_USBINTR_UAIE field. */
#define BR_USB_UOG_USBINTR_UAIE(x) (HW_USB_UOG_USBINTR(x).B.UAIE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_UAIE. */
#define BF_USB_UOG_USBINTR_UAIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_UAIE) & BM_USB_UOG_USBINTR_UAIE)

/*! @brief Set the UAIE field to a new value. */
#define BW_USB_UOG_USBINTR_UAIE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_UAIE) | BF_USB_UOG_USBINTR_UAIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field UPIE[19] (RW)
 *
 * USB Host Periodic Interrupt Enable When this bit is one, and the UPI bit in
 * the n_USBSTS register is one, host controller will issue an interrupt at the
 * next interrupt threshold.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_UPIE (19U)      /*!< Bit position for USB_UOG_USBINTR_UPIE. */
#define BM_USB_UOG_USBINTR_UPIE (0x00080000U) /*!< Bit mask for USB_UOG_USBINTR_UPIE. */
#define BS_USB_UOG_USBINTR_UPIE (1U)       /*!< Bit field size in bits for USB_UOG_USBINTR_UPIE. */

/*! @brief Read current value of the USB_UOG_USBINTR_UPIE field. */
#define BR_USB_UOG_USBINTR_UPIE(x) (HW_USB_UOG_USBINTR(x).B.UPIE)

/*! @brief Format value for bitfield USB_UOG_USBINTR_UPIE. */
#define BF_USB_UOG_USBINTR_UPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_UPIE) & BM_USB_UOG_USBINTR_UPIE)

/*! @brief Set the UPIE field to a new value. */
#define BW_USB_UOG_USBINTR_UPIE(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_UPIE) | BF_USB_UOG_USBINTR_UPIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field TIE0[24] (RW)
 *
 * General Purpose Timer #0 Interrupt Enable When this bit is one and the TI0
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_TIE0 (24U)      /*!< Bit position for USB_UOG_USBINTR_TIE0. */
#define BM_USB_UOG_USBINTR_TIE0 (0x01000000U) /*!< Bit mask for USB_UOG_USBINTR_TIE0. */
#define BS_USB_UOG_USBINTR_TIE0 (1U)       /*!< Bit field size in bits for USB_UOG_USBINTR_TIE0. */

/*! @brief Read current value of the USB_UOG_USBINTR_TIE0 field. */
#define BR_USB_UOG_USBINTR_TIE0(x) (HW_USB_UOG_USBINTR(x).B.TIE0)

/*! @brief Format value for bitfield USB_UOG_USBINTR_TIE0. */
#define BF_USB_UOG_USBINTR_TIE0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_TIE0) & BM_USB_UOG_USBINTR_TIE0)

/*! @brief Set the TIE0 field to a new value. */
#define BW_USB_UOG_USBINTR_TIE0(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_TIE0) | BF_USB_UOG_USBINTR_TIE0(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBINTR, field TIE1[25] (RW)
 *
 * General Purpose Timer #1 Interrupt Enable When this bit is one and the TI1
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UOG_USBINTR_TIE1 (25U)      /*!< Bit position for USB_UOG_USBINTR_TIE1. */
#define BM_USB_UOG_USBINTR_TIE1 (0x02000000U) /*!< Bit mask for USB_UOG_USBINTR_TIE1. */
#define BS_USB_UOG_USBINTR_TIE1 (1U)       /*!< Bit field size in bits for USB_UOG_USBINTR_TIE1. */

/*! @brief Read current value of the USB_UOG_USBINTR_TIE1 field. */
#define BR_USB_UOG_USBINTR_TIE1(x) (HW_USB_UOG_USBINTR(x).B.TIE1)

/*! @brief Format value for bitfield USB_UOG_USBINTR_TIE1. */
#define BF_USB_UOG_USBINTR_TIE1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBINTR_TIE1) & BM_USB_UOG_USBINTR_TIE1)

/*! @brief Set the TIE1 field to a new value. */
#define BW_USB_UOG_USBINTR_TIE1(x, v) (HW_USB_UOG_USBINTR_WR(x, (HW_USB_UOG_USBINTR_RD(x) & ~BM_USB_UOG_USBINTR_TIE1) | BF_USB_UOG_USBINTR_TIE1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_FRINDEX - USB Frame Index
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_FRINDEX - USB Frame Index (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the host controller to index the periodic frame
 * list. The register updates every 125 microseconds (once each micro-frame). Bits
 * [N: 3] are used to select a particular entry in the Periodic Frame List during
 * periodic schedule execution. The number of bits used for the index depends on
 * the size of the frame list as set by system software in the Frame List Size
 * field in the n_USBCMD register. This register must be written as a DWord. Byte
 * writes produce undefined results. This register cannot be written unless the
 * Host Controller is in the 'Halted' state as indicated by the HCHalted bit. A
 * write to this register while the Run/Stop hit is set to a one produces undefined
 * results. Writes to this register also affect the SOF value. In device mode this
 * register is read only and, the device controller updates the FRINDEX [13:3]
 * register from the frame number indicated by the SOF marker. Whenever a SOF is
 * received by the USB bus, FRINDEX [13:3] will be checked against the SOF marker.
 * If FRINDEX [13:3] is different from the SOF marker, FRINDEX [13:3] will be
 * set to the SOF value and FRINDEX [2:0] will be set to zero (that is, SOF for 1
 * ms frame). If FRINDEX [13:3] is equal to the SOF value, FRINDEX [2:0] will be
 * increment (that is, SOF for 125 us micro-frame.).
 */
typedef union _hw_usb_uog_frindex
{
    uint32_t U;
    struct _hw_usb_uog_frindex_bitfields
    {
        uint32_t FRINDEX : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_usb_uog_frindex_t;

/*!
 * @name Constants and macros for entire USB_UOG_FRINDEX register
 */
/*@{*/
#define HW_USB_UOG_FRINDEX_ADDR(x) ((uintptr_t)(x) + 0x14CU)

#define HW_USB_UOG_FRINDEX(x)    (*(__IO hw_usb_uog_frindex_t *) HW_USB_UOG_FRINDEX_ADDR(x))
#define HW_USB_UOG_FRINDEX_RD(x) (HW_USB_UOG_FRINDEX(x).U)
#define HW_USB_UOG_FRINDEX_WR(x, v) (HW_USB_UOG_FRINDEX(x).U = (v))
#define HW_USB_UOG_FRINDEX_SET(x, v) (HW_USB_UOG_FRINDEX_WR(x, HW_USB_UOG_FRINDEX_RD(x) |  (v)))
#define HW_USB_UOG_FRINDEX_CLR(x, v) (HW_USB_UOG_FRINDEX_WR(x, HW_USB_UOG_FRINDEX_RD(x) & ~(v)))
#define HW_USB_UOG_FRINDEX_TOG(x, v) (HW_USB_UOG_FRINDEX_WR(x, HW_USB_UOG_FRINDEX_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_FRINDEX bitfields
 */

/*!
 * @name Register USB_UOG_FRINDEX, field FRINDEX[13:0] (RW)
 *
 * Frame Index. The value, in this register, increments at the end of each time
 * frame (micro-frame). Bits [N: 3] are used for the Frame List current index.
 * This means that each location of the frame list is accessed 8 times (frames or
 * micro-frames) before moving to the next index. The following illustrates values
 * of N based on the value of the Frame List Size field in the USBCMD register,
 * when used in host mode. USBCMD [Frame List Size] Number Elements N In device
 * mode the value is the current frame number of the last frame transmitted. It is
 * not used as an index. In either mode bits 2:0 indicate the current microframe.
 *
 * Values:
 * - 000 - (1024) 12
 * - 001 - (512) 11
 * - 010 - (256) 10
 * - 011 - (128) 9
 * - 100 - (64) 8
 * - 101 - (32) 7
 * - 110 - (16) 6
 * - 111 - (8) 5
 */
/*@{*/
#define BP_USB_UOG_FRINDEX_FRINDEX (0U)    /*!< Bit position for USB_UOG_FRINDEX_FRINDEX. */
#define BM_USB_UOG_FRINDEX_FRINDEX (0x00003FFFU) /*!< Bit mask for USB_UOG_FRINDEX_FRINDEX. */
#define BS_USB_UOG_FRINDEX_FRINDEX (14U)   /*!< Bit field size in bits for USB_UOG_FRINDEX_FRINDEX. */

/*! @brief Read current value of the USB_UOG_FRINDEX_FRINDEX field. */
#define BR_USB_UOG_FRINDEX_FRINDEX(x) (HW_USB_UOG_FRINDEX(x).B.FRINDEX)

/*! @brief Format value for bitfield USB_UOG_FRINDEX_FRINDEX. */
#define BF_USB_UOG_FRINDEX_FRINDEX(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_FRINDEX_FRINDEX) & BM_USB_UOG_FRINDEX_FRINDEX)

/*! @brief Set the FRINDEX field to a new value. */
#define BW_USB_UOG_FRINDEX_FRINDEX(x, v) (HW_USB_UOG_FRINDEX_WR(x, (HW_USB_UOG_FRINDEX_RD(x) & ~BM_USB_UOG_FRINDEX_FRINDEX) | BF_USB_UOG_FRINDEX_FRINDEX(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_DEVICEADDR - Device Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_DEVICEADDR - Device Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Device Controller only The upper seven bits of this register represent the
 * device address. After any controller reset or a USB reset, the device address is
 * set to the default address (0). The default address will match all incoming
 * addresses. Software shall reprogram the address after receiving a SET_ADDRESS
 * descriptor.
 */
typedef union _hw_usb_uog_deviceaddr
{
    uint32_t U;
    struct _hw_usb_uog_deviceaddr_bitfields
    {
        uint32_t RESERVED0 : 24;       /*!< [23:0]  */
        uint32_t USBADRA : 1;          /*!< [24]  */
        uint32_t USBADR : 7;           /*!< [31:25]  */
    } B;
} hw_usb_uog_deviceaddr_t;

/*!
 * @name Constants and macros for entire USB_UOG_DEVICEADDR register
 */
/*@{*/
#define HW_USB_UOG_DEVICEADDR_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_USB_UOG_DEVICEADDR(x) (*(__IO hw_usb_uog_deviceaddr_t *) HW_USB_UOG_DEVICEADDR_ADDR(x))
#define HW_USB_UOG_DEVICEADDR_RD(x) (HW_USB_UOG_DEVICEADDR(x).U)
#define HW_USB_UOG_DEVICEADDR_WR(x, v) (HW_USB_UOG_DEVICEADDR(x).U = (v))
#define HW_USB_UOG_DEVICEADDR_SET(x, v) (HW_USB_UOG_DEVICEADDR_WR(x, HW_USB_UOG_DEVICEADDR_RD(x) |  (v)))
#define HW_USB_UOG_DEVICEADDR_CLR(x, v) (HW_USB_UOG_DEVICEADDR_WR(x, HW_USB_UOG_DEVICEADDR_RD(x) & ~(v)))
#define HW_USB_UOG_DEVICEADDR_TOG(x, v) (HW_USB_UOG_DEVICEADDR_WR(x, HW_USB_UOG_DEVICEADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_DEVICEADDR bitfields
 */

/*!
 * @name Register USB_UOG_DEVICEADDR, field USBADRA[24] (RW)
 *
 * Device Address Advance. Default=0. When this bit is '0', any writes to USBADR
 * are instantaneous. When this bit is written to a '1' at the same time or
 * before USBADR is written, the write to the USBADR field is staged and held in a
 * hidden register. After an IN occurs on endpoint 0 and is ACKed, USBADR will be
 * loaded from the holding register. Hardware will automatically clear this bit on
 * the following conditions: 1) IN is ACKed to endpoint 0. (USBADR is updated
 * from staging register). 2) OUT/SETUP occur to endpoint 0. (USBADR is not
 * updated). 3) Device Reset occurs (USBADR is reset to 0). After the status phase of
 * the SET_ADDRESS descriptor, the DCD has 2 ms to program the USBADR field. This
 * mechanism will ensure this specification is met when the DCD can not write of
 * the device address within 2ms from the SET_ADDRESS status phase. If the DCD
 * writes the USBADR with USBADRA=1 after the SET_ADDRESS data phase (before the
 * prime of the status phase), the USBADR will be programmed instantly at the
 * correct time and meet the 2ms USB requirement.
 */
/*@{*/
#define BP_USB_UOG_DEVICEADDR_USBADRA (24U) /*!< Bit position for USB_UOG_DEVICEADDR_USBADRA. */
#define BM_USB_UOG_DEVICEADDR_USBADRA (0x01000000U) /*!< Bit mask for USB_UOG_DEVICEADDR_USBADRA. */
#define BS_USB_UOG_DEVICEADDR_USBADRA (1U) /*!< Bit field size in bits for USB_UOG_DEVICEADDR_USBADRA. */

/*! @brief Read current value of the USB_UOG_DEVICEADDR_USBADRA field. */
#define BR_USB_UOG_DEVICEADDR_USBADRA(x) (HW_USB_UOG_DEVICEADDR(x).B.USBADRA)

/*! @brief Format value for bitfield USB_UOG_DEVICEADDR_USBADRA. */
#define BF_USB_UOG_DEVICEADDR_USBADRA(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_DEVICEADDR_USBADRA) & BM_USB_UOG_DEVICEADDR_USBADRA)

/*! @brief Set the USBADRA field to a new value. */
#define BW_USB_UOG_DEVICEADDR_USBADRA(x, v) (HW_USB_UOG_DEVICEADDR_WR(x, (HW_USB_UOG_DEVICEADDR_RD(x) & ~BM_USB_UOG_DEVICEADDR_USBADRA) | BF_USB_UOG_DEVICEADDR_USBADRA(v)))
/*@}*/

/*!
 * @name Register USB_UOG_DEVICEADDR, field USBADR[31:25] (RW)
 *
 * Device Address. These bits correspond to the USB device address
 */
/*@{*/
#define BP_USB_UOG_DEVICEADDR_USBADR (25U) /*!< Bit position for USB_UOG_DEVICEADDR_USBADR. */
#define BM_USB_UOG_DEVICEADDR_USBADR (0xFE000000U) /*!< Bit mask for USB_UOG_DEVICEADDR_USBADR. */
#define BS_USB_UOG_DEVICEADDR_USBADR (7U)  /*!< Bit field size in bits for USB_UOG_DEVICEADDR_USBADR. */

/*! @brief Read current value of the USB_UOG_DEVICEADDR_USBADR field. */
#define BR_USB_UOG_DEVICEADDR_USBADR(x) (HW_USB_UOG_DEVICEADDR(x).B.USBADR)

/*! @brief Format value for bitfield USB_UOG_DEVICEADDR_USBADR. */
#define BF_USB_UOG_DEVICEADDR_USBADR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_DEVICEADDR_USBADR) & BM_USB_UOG_DEVICEADDR_USBADR)

/*! @brief Set the USBADR field to a new value. */
#define BW_USB_UOG_DEVICEADDR_USBADR(x, v) (HW_USB_UOG_DEVICEADDR_WR(x, (HW_USB_UOG_DEVICEADDR_RD(x) & ~BM_USB_UOG_DEVICEADDR_USBADR) | BF_USB_UOG_DEVICEADDR_USBADR(v)))
/*@}*/
/*******************************************************************************
 * HW_USB_UOG_PERIODICLISTBASE - Frame List Base Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_PERIODICLISTBASE - Frame List Base Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the beginning address of
 * the Periodic Frame List in the system memory. HCD loads this register prior to
 * starting the schedule execution by the Host Controller. The memory structure
 * referenced by this physical memory pointer is assumed to be 4-Kbyte aligned.
 * The contents of this register are combined with the Frame Index Register
 * (USB_n_FRINDEX) to enable the Host Controller to step through the Periodic Frame List
 * in sequence.
 */
typedef union _hw_usb_uog_periodiclistbase
{
    uint32_t U;
    struct _hw_usb_uog_periodiclistbase_bitfields
    {
        uint32_t RESERVED0 : 12;       /*!< [11:0]  */
        uint32_t BASEADR : 20;         /*!< [31:12]  */
    } B;
} hw_usb_uog_periodiclistbase_t;

/*!
 * @name Constants and macros for entire USB_UOG_PERIODICLISTBASE register
 */
/*@{*/
#define HW_USB_UOG_PERIODICLISTBASE_ADDR(x) ((uintptr_t)(x) + 0x154U)

#define HW_USB_UOG_PERIODICLISTBASE(x) (*(__IO hw_usb_uog_periodiclistbase_t *) HW_USB_UOG_PERIODICLISTBASE_ADDR(x))
#define HW_USB_UOG_PERIODICLISTBASE_RD(x) (HW_USB_UOG_PERIODICLISTBASE(x).U)
#define HW_USB_UOG_PERIODICLISTBASE_WR(x, v) (HW_USB_UOG_PERIODICLISTBASE(x).U = (v))
#define HW_USB_UOG_PERIODICLISTBASE_SET(x, v) (HW_USB_UOG_PERIODICLISTBASE_WR(x, HW_USB_UOG_PERIODICLISTBASE_RD(x) |  (v)))
#define HW_USB_UOG_PERIODICLISTBASE_CLR(x, v) (HW_USB_UOG_PERIODICLISTBASE_WR(x, HW_USB_UOG_PERIODICLISTBASE_RD(x) & ~(v)))
#define HW_USB_UOG_PERIODICLISTBASE_TOG(x, v) (HW_USB_UOG_PERIODICLISTBASE_WR(x, HW_USB_UOG_PERIODICLISTBASE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_PERIODICLISTBASE bitfields
 */

/*!
 * @name Register USB_UOG_PERIODICLISTBASE, field BASEADR[31:12] (RW)
 *
 * Base Address (Low). These bits correspond to memory address signals [31:12],
 * respectively. Only used by the host controller.
 */
/*@{*/
#define BP_USB_UOG_PERIODICLISTBASE_BASEADR (12U) /*!< Bit position for USB_UOG_PERIODICLISTBASE_BASEADR. */
#define BM_USB_UOG_PERIODICLISTBASE_BASEADR (0xFFFFF000U) /*!< Bit mask for USB_UOG_PERIODICLISTBASE_BASEADR. */
#define BS_USB_UOG_PERIODICLISTBASE_BASEADR (20U) /*!< Bit field size in bits for USB_UOG_PERIODICLISTBASE_BASEADR. */

/*! @brief Read current value of the USB_UOG_PERIODICLISTBASE_BASEADR field. */
#define BR_USB_UOG_PERIODICLISTBASE_BASEADR(x) (HW_USB_UOG_PERIODICLISTBASE(x).B.BASEADR)

/*! @brief Format value for bitfield USB_UOG_PERIODICLISTBASE_BASEADR. */
#define BF_USB_UOG_PERIODICLISTBASE_BASEADR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PERIODICLISTBASE_BASEADR) & BM_USB_UOG_PERIODICLISTBASE_BASEADR)

/*! @brief Set the BASEADR field to a new value. */
#define BW_USB_UOG_PERIODICLISTBASE_BASEADR(x, v) (HW_USB_UOG_PERIODICLISTBASE_WR(x, (HW_USB_UOG_PERIODICLISTBASE_RD(x) & ~BM_USB_UOG_PERIODICLISTBASE_BASEADR) | BF_USB_UOG_PERIODICLISTBASE_BASEADR(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ASYNCLISTADDR - Next Asynch. Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ASYNCLISTADDR - Next Asynch. Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the address of the next
 * asynchronous queue head to be executed by the host. Bits [4:0] of this register
 * cannot be modified by the system software and will always return a zero when
 * read.
 */
typedef union _hw_usb_uog_asynclistaddr
{
    uint32_t U;
    struct _hw_usb_uog_asynclistaddr_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t ASYBASE : 27;         /*!< [31:5]  */
    } B;
} hw_usb_uog_asynclistaddr_t;

/*!
 * @name Constants and macros for entire USB_UOG_ASYNCLISTADDR register
 */
/*@{*/
#define HW_USB_UOG_ASYNCLISTADDR_ADDR(x) ((uintptr_t)(x) + 0x158U)

#define HW_USB_UOG_ASYNCLISTADDR(x) (*(__IO hw_usb_uog_asynclistaddr_t *) HW_USB_UOG_ASYNCLISTADDR_ADDR(x))
#define HW_USB_UOG_ASYNCLISTADDR_RD(x) (HW_USB_UOG_ASYNCLISTADDR(x).U)
#define HW_USB_UOG_ASYNCLISTADDR_WR(x, v) (HW_USB_UOG_ASYNCLISTADDR(x).U = (v))
#define HW_USB_UOG_ASYNCLISTADDR_SET(x, v) (HW_USB_UOG_ASYNCLISTADDR_WR(x, HW_USB_UOG_ASYNCLISTADDR_RD(x) |  (v)))
#define HW_USB_UOG_ASYNCLISTADDR_CLR(x, v) (HW_USB_UOG_ASYNCLISTADDR_WR(x, HW_USB_UOG_ASYNCLISTADDR_RD(x) & ~(v)))
#define HW_USB_UOG_ASYNCLISTADDR_TOG(x, v) (HW_USB_UOG_ASYNCLISTADDR_WR(x, HW_USB_UOG_ASYNCLISTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ASYNCLISTADDR bitfields
 */

/*!
 * @name Register USB_UOG_ASYNCLISTADDR, field ASYBASE[31:5] (RW)
 *
 * Link Pointer Low (LPL). These bits correspond to memory address signals
 * [31:5], respectively. This field may only reference a Queue Head (QH). Only used by
 * the host controller.
 */
/*@{*/
#define BP_USB_UOG_ASYNCLISTADDR_ASYBASE (5U) /*!< Bit position for USB_UOG_ASYNCLISTADDR_ASYBASE. */
#define BM_USB_UOG_ASYNCLISTADDR_ASYBASE (0xFFFFFFE0U) /*!< Bit mask for USB_UOG_ASYNCLISTADDR_ASYBASE. */
#define BS_USB_UOG_ASYNCLISTADDR_ASYBASE (27U) /*!< Bit field size in bits for USB_UOG_ASYNCLISTADDR_ASYBASE. */

/*! @brief Read current value of the USB_UOG_ASYNCLISTADDR_ASYBASE field. */
#define BR_USB_UOG_ASYNCLISTADDR_ASYBASE(x) (HW_USB_UOG_ASYNCLISTADDR(x).B.ASYBASE)

/*! @brief Format value for bitfield USB_UOG_ASYNCLISTADDR_ASYBASE. */
#define BF_USB_UOG_ASYNCLISTADDR_ASYBASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ASYNCLISTADDR_ASYBASE) & BM_USB_UOG_ASYNCLISTADDR_ASYBASE)

/*! @brief Set the ASYBASE field to a new value. */
#define BW_USB_UOG_ASYNCLISTADDR_ASYBASE(x, v) (HW_USB_UOG_ASYNCLISTADDR_WR(x, (HW_USB_UOG_ASYNCLISTADDR_RD(x) & ~BM_USB_UOG_ASYNCLISTADDR_ASYBASE) | BF_USB_UOG_ASYNCLISTADDR_ASYBASE(v)))
/*@}*/
/*******************************************************************************
 * HW_USB_UOG_ENDPTLISTADDR - Endpoint List Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTLISTADDR - Endpoint List Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Device Controller only In device mode, this register contains the address of
 * the top of the endpoint list in system memory. Bits [10:0] of this register
 * cannot be modified by the system software and will always return a zero when
 * read. The memory structure referenced by this physical memory pointer is assumed
 * 64-byte.
 */
typedef union _hw_usb_uog_endptlistaddr
{
    uint32_t U;
    struct _hw_usb_uog_endptlistaddr_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t EPBASE : 21;          /*!< [31:11]  */
    } B;
} hw_usb_uog_endptlistaddr_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTLISTADDR register
 */
/*@{*/
#define HW_USB_UOG_ENDPTLISTADDR_ADDR(x) ((uintptr_t)(x) + 0x158U)

#define HW_USB_UOG_ENDPTLISTADDR(x) (*(__IO hw_usb_uog_endptlistaddr_t *) HW_USB_UOG_ENDPTLISTADDR_ADDR(x))
#define HW_USB_UOG_ENDPTLISTADDR_RD(x) (HW_USB_UOG_ENDPTLISTADDR(x).U)
#define HW_USB_UOG_ENDPTLISTADDR_WR(x, v) (HW_USB_UOG_ENDPTLISTADDR(x).U = (v))
#define HW_USB_UOG_ENDPTLISTADDR_SET(x, v) (HW_USB_UOG_ENDPTLISTADDR_WR(x, HW_USB_UOG_ENDPTLISTADDR_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTLISTADDR_CLR(x, v) (HW_USB_UOG_ENDPTLISTADDR_WR(x, HW_USB_UOG_ENDPTLISTADDR_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTLISTADDR_TOG(x, v) (HW_USB_UOG_ENDPTLISTADDR_WR(x, HW_USB_UOG_ENDPTLISTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTLISTADDR bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTLISTADDR, field EPBASE[31:11] (RW)
 *
 * Endpoint List Pointer(Low). These bits correspond to memory address signals
 * [31:11], respectively. This field will reference a list of up to 32 Queue Head
 * (QH) (that is, one queue head per endpoint & direction).
 */
/*@{*/
#define BP_USB_UOG_ENDPTLISTADDR_EPBASE (11U) /*!< Bit position for USB_UOG_ENDPTLISTADDR_EPBASE. */
#define BM_USB_UOG_ENDPTLISTADDR_EPBASE (0xFFFFF800U) /*!< Bit mask for USB_UOG_ENDPTLISTADDR_EPBASE. */
#define BS_USB_UOG_ENDPTLISTADDR_EPBASE (21U) /*!< Bit field size in bits for USB_UOG_ENDPTLISTADDR_EPBASE. */

/*! @brief Read current value of the USB_UOG_ENDPTLISTADDR_EPBASE field. */
#define BR_USB_UOG_ENDPTLISTADDR_EPBASE(x) (HW_USB_UOG_ENDPTLISTADDR(x).B.EPBASE)

/*! @brief Format value for bitfield USB_UOG_ENDPTLISTADDR_EPBASE. */
#define BF_USB_UOG_ENDPTLISTADDR_EPBASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTLISTADDR_EPBASE) & BM_USB_UOG_ENDPTLISTADDR_EPBASE)

/*! @brief Set the EPBASE field to a new value. */
#define BW_USB_UOG_ENDPTLISTADDR_EPBASE(x, v) (HW_USB_UOG_ENDPTLISTADDR_WR(x, (HW_USB_UOG_ENDPTLISTADDR_RD(x) & ~BM_USB_UOG_ENDPTLISTADDR_EPBASE) | BF_USB_UOG_ENDPTLISTADDR_EPBASE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_BURSTSIZE - Programmable Burst Size
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_BURSTSIZE - Programmable Burst Size (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control the burst size used during data movement on
 * the AHB master interface. This register is ignored if AHBBRST bits in SBUSCFG
 * register is non-zero value.
 */
typedef union _hw_usb_uog_burstsize
{
    uint32_t U;
    struct _hw_usb_uog_burstsize_bitfields
    {
        uint32_t RXPBURST : 8;         /*!< [7:0]  */
        uint32_t TXPBURST : 9;         /*!< [16:8]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_usb_uog_burstsize_t;

/*!
 * @name Constants and macros for entire USB_UOG_BURSTSIZE register
 */
/*@{*/
#define HW_USB_UOG_BURSTSIZE_ADDR(x) ((uintptr_t)(x) + 0x160U)

#define HW_USB_UOG_BURSTSIZE(x)  (*(__IO hw_usb_uog_burstsize_t *) HW_USB_UOG_BURSTSIZE_ADDR(x))
#define HW_USB_UOG_BURSTSIZE_RD(x) (HW_USB_UOG_BURSTSIZE(x).U)
#define HW_USB_UOG_BURSTSIZE_WR(x, v) (HW_USB_UOG_BURSTSIZE(x).U = (v))
#define HW_USB_UOG_BURSTSIZE_SET(x, v) (HW_USB_UOG_BURSTSIZE_WR(x, HW_USB_UOG_BURSTSIZE_RD(x) |  (v)))
#define HW_USB_UOG_BURSTSIZE_CLR(x, v) (HW_USB_UOG_BURSTSIZE_WR(x, HW_USB_UOG_BURSTSIZE_RD(x) & ~(v)))
#define HW_USB_UOG_BURSTSIZE_TOG(x, v) (HW_USB_UOG_BURSTSIZE_WR(x, HW_USB_UOG_BURSTSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_BURSTSIZE bitfields
 */

/*!
 * @name Register USB_UOG_BURSTSIZE, field RXPBURST[7:0] (RW)
 *
 * Programmable RX Burst Size. Default value is determined by TXBURST bits in
 * n_HWRXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from the USB bus to system memory.
 */
/*@{*/
#define BP_USB_UOG_BURSTSIZE_RXPBURST (0U) /*!< Bit position for USB_UOG_BURSTSIZE_RXPBURST. */
#define BM_USB_UOG_BURSTSIZE_RXPBURST (0x000000FFU) /*!< Bit mask for USB_UOG_BURSTSIZE_RXPBURST. */
#define BS_USB_UOG_BURSTSIZE_RXPBURST (8U) /*!< Bit field size in bits for USB_UOG_BURSTSIZE_RXPBURST. */

/*! @brief Read current value of the USB_UOG_BURSTSIZE_RXPBURST field. */
#define BR_USB_UOG_BURSTSIZE_RXPBURST(x) (HW_USB_UOG_BURSTSIZE(x).B.RXPBURST)

/*! @brief Format value for bitfield USB_UOG_BURSTSIZE_RXPBURST. */
#define BF_USB_UOG_BURSTSIZE_RXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_BURSTSIZE_RXPBURST) & BM_USB_UOG_BURSTSIZE_RXPBURST)

/*! @brief Set the RXPBURST field to a new value. */
#define BW_USB_UOG_BURSTSIZE_RXPBURST(x, v) (HW_USB_UOG_BURSTSIZE_WR(x, (HW_USB_UOG_BURSTSIZE_RD(x) & ~BM_USB_UOG_BURSTSIZE_RXPBURST) | BF_USB_UOG_BURSTSIZE_RXPBURST(v)))
/*@}*/

/*!
 * @name Register USB_UOG_BURSTSIZE, field TXPBURST[16:8] (RW)
 *
 * Programmable TX Burst Size. Default value is determined by TXBURST bits in
 * n_HWTXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from system memory to the USB bus.
 */
/*@{*/
#define BP_USB_UOG_BURSTSIZE_TXPBURST (8U) /*!< Bit position for USB_UOG_BURSTSIZE_TXPBURST. */
#define BM_USB_UOG_BURSTSIZE_TXPBURST (0x0001FF00U) /*!< Bit mask for USB_UOG_BURSTSIZE_TXPBURST. */
#define BS_USB_UOG_BURSTSIZE_TXPBURST (9U) /*!< Bit field size in bits for USB_UOG_BURSTSIZE_TXPBURST. */

/*! @brief Read current value of the USB_UOG_BURSTSIZE_TXPBURST field. */
#define BR_USB_UOG_BURSTSIZE_TXPBURST(x) (HW_USB_UOG_BURSTSIZE(x).B.TXPBURST)

/*! @brief Format value for bitfield USB_UOG_BURSTSIZE_TXPBURST. */
#define BF_USB_UOG_BURSTSIZE_TXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_BURSTSIZE_TXPBURST) & BM_USB_UOG_BURSTSIZE_TXPBURST)

/*! @brief Set the TXPBURST field to a new value. */
#define BW_USB_UOG_BURSTSIZE_TXPBURST(x, v) (HW_USB_UOG_BURSTSIZE_WR(x, (HW_USB_UOG_BURSTSIZE_RD(x) & ~BM_USB_UOG_BURSTSIZE_TXPBURST) | BF_USB_UOG_BURSTSIZE_TXPBURST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_TXFILLTUNING - TX FIFO Fill Tuning
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_TXFILLTUNING - TX FIFO Fill Tuning (RW)
 *
 * Reset value: 0x00000808U
 *
 * The fields in this register control performance tuning associated with how
 * the host controller posts data to the TX latency FIFO before moving the data
 * onto the USB bus. The specific areas of performance include the how much data to
 * post into the FIFO and an estimate for how long that operation should take in
 * the target system. Definitions: T 0 = Standard packet overhead T 1 = Time to
 * send data payload T ff = Time to fetch packet into TX FIFO up to specified
 * level. T s = Total Packet Flight Time (send-only) packet T s = T 0 + T 1 T p =
 * Total Packet Time (fetch and send) packet T p = T ff + T 0 + T 1 Upon discovery
 * of a transmit (OUT/SETUP) packet in the data structures, host controller checks
 * to ensure T p remains before the end of the [micro]frame. If so it proceeds
 * to pre-fill the TX FIFO. If at anytime during the pre-fill operation the time
 * remaining the [micro]frame is < T s then the packet attempt ceases and the
 * packet is tried at a later time. Although this is not an error condition and the
 * host controller will eventually recover, a mark will be made the scheduler
 * health counter to note the occurrence of a "back-off" event. When a back-off event
 * is detected, the partial packet fetched may need to be discarded from the
 * latency buffer to make room for periodic traffic that will begin after the next
 * SOF. Too many back-off events can waste bandwidth and power on the system bus
 * and thus should be minimized (not necessarily eliminated). Back-offs can be
 * minimized with use of the n_TSCHHEALTH ( T ff ) described below. The reset value
 * could vary from instance to instance. Please see the detail in bit field
 * description and ignore reset value in summary table in this case!
 */
typedef union _hw_usb_uog_txfilltuning
{
    uint32_t U;
    struct _hw_usb_uog_txfilltuning_bitfields
    {
        uint32_t TXSCHOH : 8;          /*!< [7:0]  */
        uint32_t TXSCHHEALTH : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t TXFIFOTHRES : 6;      /*!< [21:16]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_usb_uog_txfilltuning_t;

/*!
 * @name Constants and macros for entire USB_UOG_TXFILLTUNING register
 */
/*@{*/
#define HW_USB_UOG_TXFILLTUNING_ADDR(x) ((uintptr_t)(x) + 0x164U)

#define HW_USB_UOG_TXFILLTUNING(x) (*(__IO hw_usb_uog_txfilltuning_t *) HW_USB_UOG_TXFILLTUNING_ADDR(x))
#define HW_USB_UOG_TXFILLTUNING_RD(x) (HW_USB_UOG_TXFILLTUNING(x).U)
#define HW_USB_UOG_TXFILLTUNING_WR(x, v) (HW_USB_UOG_TXFILLTUNING(x).U = (v))
#define HW_USB_UOG_TXFILLTUNING_SET(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, HW_USB_UOG_TXFILLTUNING_RD(x) |  (v)))
#define HW_USB_UOG_TXFILLTUNING_CLR(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, HW_USB_UOG_TXFILLTUNING_RD(x) & ~(v)))
#define HW_USB_UOG_TXFILLTUNING_TOG(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, HW_USB_UOG_TXFILLTUNING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_TXFILLTUNING bitfields
 */

/*!
 * @name Register USB_UOG_TXFILLTUNING, field TXSCHOH[7:0] (RW)
 *
 * Scheduler Overhead. (Read/Write) [Default = 0] This register adds an
 * additional fixed offset to the schedule time estimator described above as Tff. As an
 * approximation, the value chosen for this register should limit the number of
 * back-off events captured in the TXSCHHEALTH to less than 10 per second in a
 * highly utilized bus. Choosing a value that is too high for this register is not
 * desired as it can needlessly reduce USB utilization. The time unit represented
 * in this register is 1.267us when a device is connected in High-Speed Mode. The
 * time unit represented in this register is 6.333us when a device is connected
 * in Low/Full Speed Mode. Default value is '08h' for OTG controller core, and
 * '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_TXFILLTUNING_TXSCHOH (0U) /*!< Bit position for USB_UOG_TXFILLTUNING_TXSCHOH. */
#define BM_USB_UOG_TXFILLTUNING_TXSCHOH (0x000000FFU) /*!< Bit mask for USB_UOG_TXFILLTUNING_TXSCHOH. */
#define BS_USB_UOG_TXFILLTUNING_TXSCHOH (8U) /*!< Bit field size in bits for USB_UOG_TXFILLTUNING_TXSCHOH. */

/*! @brief Read current value of the USB_UOG_TXFILLTUNING_TXSCHOH field. */
#define BR_USB_UOG_TXFILLTUNING_TXSCHOH(x) (HW_USB_UOG_TXFILLTUNING(x).B.TXSCHOH)

/*! @brief Format value for bitfield USB_UOG_TXFILLTUNING_TXSCHOH. */
#define BF_USB_UOG_TXFILLTUNING_TXSCHOH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_TXFILLTUNING_TXSCHOH) & BM_USB_UOG_TXFILLTUNING_TXSCHOH)

/*! @brief Set the TXSCHOH field to a new value. */
#define BW_USB_UOG_TXFILLTUNING_TXSCHOH(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, (HW_USB_UOG_TXFILLTUNING_RD(x) & ~BM_USB_UOG_TXFILLTUNING_TXSCHOH) | BF_USB_UOG_TXFILLTUNING_TXSCHOH(v)))
/*@}*/

/*!
 * @name Register USB_UOG_TXFILLTUNING, field TXSCHHEALTH[12:8] (RW)
 *
 * Scheduler Health Counter. (Read/Write To Clear) This register increments when
 * the host controller fails to fill the TX latency FIFO to the level programmed
 * by TXFIFOTHRES before running out of time to send the packet before the next
 * Start-Of-Frame. This health counter measures the number of times this occurs
 * to provide feedback to selecting a proper TXSCHOH. Writing to this register
 * will clear the counter and this counter will max. at 31. Default value is '08h'
 * for OTG controller core, and '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_TXFILLTUNING_TXSCHHEALTH (8U) /*!< Bit position for USB_UOG_TXFILLTUNING_TXSCHHEALTH. */
#define BM_USB_UOG_TXFILLTUNING_TXSCHHEALTH (0x00001F00U) /*!< Bit mask for USB_UOG_TXFILLTUNING_TXSCHHEALTH. */
#define BS_USB_UOG_TXFILLTUNING_TXSCHHEALTH (5U) /*!< Bit field size in bits for USB_UOG_TXFILLTUNING_TXSCHHEALTH. */

/*! @brief Read current value of the USB_UOG_TXFILLTUNING_TXSCHHEALTH field. */
#define BR_USB_UOG_TXFILLTUNING_TXSCHHEALTH(x) (HW_USB_UOG_TXFILLTUNING(x).B.TXSCHHEALTH)

/*! @brief Format value for bitfield USB_UOG_TXFILLTUNING_TXSCHHEALTH. */
#define BF_USB_UOG_TXFILLTUNING_TXSCHHEALTH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_TXFILLTUNING_TXSCHHEALTH) & BM_USB_UOG_TXFILLTUNING_TXSCHHEALTH)

/*! @brief Set the TXSCHHEALTH field to a new value. */
#define BW_USB_UOG_TXFILLTUNING_TXSCHHEALTH(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, (HW_USB_UOG_TXFILLTUNING_RD(x) & ~BM_USB_UOG_TXFILLTUNING_TXSCHHEALTH) | BF_USB_UOG_TXFILLTUNING_TXSCHHEALTH(v)))
/*@}*/

/*!
 * @name Register USB_UOG_TXFILLTUNING, field TXFIFOTHRES[21:16] (RW)
 *
 * FIFO Burst Threshold. (Read/Write) This register controls the number of data
 * bursts that are posted to the TX latency FIFO in host mode before the packet
 * begins on to the bus. The minimum value is 2 and this value should be a low as
 * possible to maximize USB performance. A higher value can be used in systems
 * with unpredictable latency and/or insufficient bandwidth where the FIFO may
 * underrun because the data transferred from the latency FIFO to USB occurs before
 * it can be replenished from system memory. This value is ignored if the Stream
 * Disable bit in USB_n_USBMODE register is set. Default value is '00h' for OTG
 * controller core, and '02h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UOG_TXFILLTUNING_TXFIFOTHRES (16U) /*!< Bit position for USB_UOG_TXFILLTUNING_TXFIFOTHRES. */
#define BM_USB_UOG_TXFILLTUNING_TXFIFOTHRES (0x003F0000U) /*!< Bit mask for USB_UOG_TXFILLTUNING_TXFIFOTHRES. */
#define BS_USB_UOG_TXFILLTUNING_TXFIFOTHRES (6U) /*!< Bit field size in bits for USB_UOG_TXFILLTUNING_TXFIFOTHRES. */

/*! @brief Read current value of the USB_UOG_TXFILLTUNING_TXFIFOTHRES field. */
#define BR_USB_UOG_TXFILLTUNING_TXFIFOTHRES(x) (HW_USB_UOG_TXFILLTUNING(x).B.TXFIFOTHRES)

/*! @brief Format value for bitfield USB_UOG_TXFILLTUNING_TXFIFOTHRES. */
#define BF_USB_UOG_TXFILLTUNING_TXFIFOTHRES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_TXFILLTUNING_TXFIFOTHRES) & BM_USB_UOG_TXFILLTUNING_TXFIFOTHRES)

/*! @brief Set the TXFIFOTHRES field to a new value. */
#define BW_USB_UOG_TXFILLTUNING_TXFIFOTHRES(x, v) (HW_USB_UOG_TXFILLTUNING_WR(x, (HW_USB_UOG_TXFILLTUNING_RD(x) & ~BM_USB_UOG_TXFILLTUNING_TXFIFOTHRES) | BF_USB_UOG_TXFILLTUNING_TXFIFOTHRES(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTNAK - Endpoint NAK
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTNAK - Endpoint NAK (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uog_endptnak
{
    uint32_t U;
    struct _hw_usb_uog_endptnak_bitfields
    {
        uint32_t EPRN : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t EPTN : 8;             /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptnak_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTNAK register
 */
/*@{*/
#define HW_USB_UOG_ENDPTNAK_ADDR(x) ((uintptr_t)(x) + 0x178U)

#define HW_USB_UOG_ENDPTNAK(x)   (*(__IO hw_usb_uog_endptnak_t *) HW_USB_UOG_ENDPTNAK_ADDR(x))
#define HW_USB_UOG_ENDPTNAK_RD(x) (HW_USB_UOG_ENDPTNAK(x).U)
#define HW_USB_UOG_ENDPTNAK_WR(x, v) (HW_USB_UOG_ENDPTNAK(x).U = (v))
#define HW_USB_UOG_ENDPTNAK_SET(x, v) (HW_USB_UOG_ENDPTNAK_WR(x, HW_USB_UOG_ENDPTNAK_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTNAK_CLR(x, v) (HW_USB_UOG_ENDPTNAK_WR(x, HW_USB_UOG_ENDPTNAK_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTNAK_TOG(x, v) (HW_USB_UOG_ENDPTNAK_WR(x, HW_USB_UOG_ENDPTNAK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTNAK bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTNAK, field EPRN[7:0] (RW)
 *
 * RX Endpoint NAK - R/WC. Each RX endpoint has 1 bit in this field. The bit is
 * set when the device sends a NAK handshake on a received OUT or PING token for
 * the corresponding endpoint. Bit [N] - Endpoint #[N], N is 0-7
 */
/*@{*/
#define BP_USB_UOG_ENDPTNAK_EPRN (0U)      /*!< Bit position for USB_UOG_ENDPTNAK_EPRN. */
#define BM_USB_UOG_ENDPTNAK_EPRN (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTNAK_EPRN. */
#define BS_USB_UOG_ENDPTNAK_EPRN (8U)      /*!< Bit field size in bits for USB_UOG_ENDPTNAK_EPRN. */

/*! @brief Read current value of the USB_UOG_ENDPTNAK_EPRN field. */
#define BR_USB_UOG_ENDPTNAK_EPRN(x) (HW_USB_UOG_ENDPTNAK(x).B.EPRN)

/*! @brief Format value for bitfield USB_UOG_ENDPTNAK_EPRN. */
#define BF_USB_UOG_ENDPTNAK_EPRN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTNAK_EPRN) & BM_USB_UOG_ENDPTNAK_EPRN)

/*! @brief Set the EPRN field to a new value. */
#define BW_USB_UOG_ENDPTNAK_EPRN(x, v) (HW_USB_UOG_ENDPTNAK_WR(x, (HW_USB_UOG_ENDPTNAK_RD(x) & ~BM_USB_UOG_ENDPTNAK_EPRN) | BF_USB_UOG_ENDPTNAK_EPRN(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTNAK, field EPTN[23:16] (RW)
 *
 * TX Endpoint NAK - R/WC. Each TX endpoint has 1 bit in this field. The bit is
 * set when the device sends a NAK handshake on a received IN token for the
 * corresponding endpoint. Bit [N] - Endpoint #[N], N is 0-7
 */
/*@{*/
#define BP_USB_UOG_ENDPTNAK_EPTN (16U)     /*!< Bit position for USB_UOG_ENDPTNAK_EPTN. */
#define BM_USB_UOG_ENDPTNAK_EPTN (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTNAK_EPTN. */
#define BS_USB_UOG_ENDPTNAK_EPTN (8U)      /*!< Bit field size in bits for USB_UOG_ENDPTNAK_EPTN. */

/*! @brief Read current value of the USB_UOG_ENDPTNAK_EPTN field. */
#define BR_USB_UOG_ENDPTNAK_EPTN(x) (HW_USB_UOG_ENDPTNAK(x).B.EPTN)

/*! @brief Format value for bitfield USB_UOG_ENDPTNAK_EPTN. */
#define BF_USB_UOG_ENDPTNAK_EPTN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTNAK_EPTN) & BM_USB_UOG_ENDPTNAK_EPTN)

/*! @brief Set the EPTN field to a new value. */
#define BW_USB_UOG_ENDPTNAK_EPTN(x, v) (HW_USB_UOG_ENDPTNAK_WR(x, (HW_USB_UOG_ENDPTNAK_RD(x) & ~BM_USB_UOG_ENDPTNAK_EPTN) | BF_USB_UOG_ENDPTNAK_EPTN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTNAKEN - Endpoint NAK Enable
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTNAKEN - Endpoint NAK Enable (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uog_endptnaken
{
    uint32_t U;
    struct _hw_usb_uog_endptnaken_bitfields
    {
        uint32_t EPRNE : 8;            /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t EPTNE : 8;            /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptnaken_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTNAKEN register
 */
/*@{*/
#define HW_USB_UOG_ENDPTNAKEN_ADDR(x) ((uintptr_t)(x) + 0x17CU)

#define HW_USB_UOG_ENDPTNAKEN(x) (*(__IO hw_usb_uog_endptnaken_t *) HW_USB_UOG_ENDPTNAKEN_ADDR(x))
#define HW_USB_UOG_ENDPTNAKEN_RD(x) (HW_USB_UOG_ENDPTNAKEN(x).U)
#define HW_USB_UOG_ENDPTNAKEN_WR(x, v) (HW_USB_UOG_ENDPTNAKEN(x).U = (v))
#define HW_USB_UOG_ENDPTNAKEN_SET(x, v) (HW_USB_UOG_ENDPTNAKEN_WR(x, HW_USB_UOG_ENDPTNAKEN_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTNAKEN_CLR(x, v) (HW_USB_UOG_ENDPTNAKEN_WR(x, HW_USB_UOG_ENDPTNAKEN_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTNAKEN_TOG(x, v) (HW_USB_UOG_ENDPTNAKEN_WR(x, HW_USB_UOG_ENDPTNAKEN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTNAKEN bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTNAKEN, field EPRNE[7:0] (RW)
 *
 * RX Endpoint NAK Enable - R/W. Each bit is an enable bit for the corresponding
 * RX Endpoint NAK bit. If this bit is set and the corresponding RX Endpoint NAK
 * bit is set, the NAK Interrupt bit is set. Bit [N] - Endpoint #[N], N is 0-7
 */
/*@{*/
#define BP_USB_UOG_ENDPTNAKEN_EPRNE (0U)   /*!< Bit position for USB_UOG_ENDPTNAKEN_EPRNE. */
#define BM_USB_UOG_ENDPTNAKEN_EPRNE (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTNAKEN_EPRNE. */
#define BS_USB_UOG_ENDPTNAKEN_EPRNE (8U)   /*!< Bit field size in bits for USB_UOG_ENDPTNAKEN_EPRNE. */

/*! @brief Read current value of the USB_UOG_ENDPTNAKEN_EPRNE field. */
#define BR_USB_UOG_ENDPTNAKEN_EPRNE(x) (HW_USB_UOG_ENDPTNAKEN(x).B.EPRNE)

/*! @brief Format value for bitfield USB_UOG_ENDPTNAKEN_EPRNE. */
#define BF_USB_UOG_ENDPTNAKEN_EPRNE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTNAKEN_EPRNE) & BM_USB_UOG_ENDPTNAKEN_EPRNE)

/*! @brief Set the EPRNE field to a new value. */
#define BW_USB_UOG_ENDPTNAKEN_EPRNE(x, v) (HW_USB_UOG_ENDPTNAKEN_WR(x, (HW_USB_UOG_ENDPTNAKEN_RD(x) & ~BM_USB_UOG_ENDPTNAKEN_EPRNE) | BF_USB_UOG_ENDPTNAKEN_EPRNE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTNAKEN, field EPTNE[23:16] (RW)
 *
 * TX Endpoint NAK Enable - R/W. Each bit is an enable bit for the corresponding
 * TX Endpoint NAK bit. If this bit is set and the corresponding TX Endpoint NAK
 * bit is set, the NAK Interrupt bit is set. Bit [N] - Endpoint #[N], N is 0-7
 */
/*@{*/
#define BP_USB_UOG_ENDPTNAKEN_EPTNE (16U)  /*!< Bit position for USB_UOG_ENDPTNAKEN_EPTNE. */
#define BM_USB_UOG_ENDPTNAKEN_EPTNE (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTNAKEN_EPTNE. */
#define BS_USB_UOG_ENDPTNAKEN_EPTNE (8U)   /*!< Bit field size in bits for USB_UOG_ENDPTNAKEN_EPTNE. */

/*! @brief Read current value of the USB_UOG_ENDPTNAKEN_EPTNE field. */
#define BR_USB_UOG_ENDPTNAKEN_EPTNE(x) (HW_USB_UOG_ENDPTNAKEN(x).B.EPTNE)

/*! @brief Format value for bitfield USB_UOG_ENDPTNAKEN_EPTNE. */
#define BF_USB_UOG_ENDPTNAKEN_EPTNE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTNAKEN_EPTNE) & BM_USB_UOG_ENDPTNAKEN_EPTNE)

/*! @brief Set the EPTNE field to a new value. */
#define BW_USB_UOG_ENDPTNAKEN_EPTNE(x, v) (HW_USB_UOG_ENDPTNAKEN_WR(x, (HW_USB_UOG_ENDPTNAKEN_RD(x) & ~BM_USB_UOG_ENDPTNAKEN_EPTNE) | BF_USB_UOG_ENDPTNAKEN_EPTNE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_CONFIGFLAG - Configure Flag Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_CONFIGFLAG - Configure Flag Register (RO)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_usb_uog_configflag
{
    uint32_t U;
    struct _hw_usb_uog_configflag_bitfields
    {
        uint32_t CF : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_usb_uog_configflag_t;

/*!
 * @name Constants and macros for entire USB_UOG_CONFIGFLAG register
 */
/*@{*/
#define HW_USB_UOG_CONFIGFLAG_ADDR(x) ((uintptr_t)(x) + 0x180U)

#define HW_USB_UOG_CONFIGFLAG(x) (*(__I hw_usb_uog_configflag_t *) HW_USB_UOG_CONFIGFLAG_ADDR(x))
#define HW_USB_UOG_CONFIGFLAG_RD(x) (HW_USB_UOG_CONFIGFLAG(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_CONFIGFLAG bitfields
 */

/*!
 * @name Register USB_UOG_CONFIGFLAG, field CF[0] (RO)
 *
 * Configure Flag Host software sets this bit as the last action in its process
 * of configuring the Host Controller. This bit controls the default port-routing
 * control logic.
 *
 * Values:
 * - 0 - Port routing control logic default-routes each port to an
 *     implementation dependent classic host controller.
 * - 1 - Port routing control logic default-routes all ports to this host
 *     controller.
 */
/*@{*/
#define BP_USB_UOG_CONFIGFLAG_CF (0U)      /*!< Bit position for USB_UOG_CONFIGFLAG_CF. */
#define BM_USB_UOG_CONFIGFLAG_CF (0x00000001U) /*!< Bit mask for USB_UOG_CONFIGFLAG_CF. */
#define BS_USB_UOG_CONFIGFLAG_CF (1U)      /*!< Bit field size in bits for USB_UOG_CONFIGFLAG_CF. */

/*! @brief Read current value of the USB_UOG_CONFIGFLAG_CF field. */
#define BR_USB_UOG_CONFIGFLAG_CF(x) (HW_USB_UOG_CONFIGFLAG(x).B.CF)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_PORTSC1 - Port Status & Control
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_PORTSC1 - Port Status & Control (RW)
 *
 * Reset value: 0x10000000U
 *
 * Host Controller A host controller could implement one to eight port status
 * and control registers. The number is determined by N_PORTs bits in HWSPARAMs
 * register (please see HCSPARAMSHost Controller Structural Parameters ). Software
 * could read this parameter register to determine how many ports need service.
 * All controller cores on this product are Single-Port, so there is only one port
 * status and control register for each controller core. This register is only
 * reset by power on reset or controller core reset. The initial conditions of a
 * port are: No device connected Port disabled If the port supports power control,
 * this state remains until port power is supplied (by software). Device
 * Controller A controller operating in device mode has only port register one (PORTSC1)
 * and it does not support power control in that mode. Port control in device
 * mode is only used for status port reset, suspend, and current connect status. It
 * is also used to initiate test mode or force signaling and allows software to
 * put the PHY into low power suspend mode and disable the PHY clock.
 */
typedef union _hw_usb_uog_portsc1
{
    uint32_t U;
    struct _hw_usb_uog_portsc1_bitfields
    {
        uint32_t CCS : 1;              /*!< [0]  */
        uint32_t CSC : 1;              /*!< [1]  */
        uint32_t PE : 1;               /*!< [2]  */
        uint32_t PEC : 1;              /*!< [3]  */
        uint32_t OCA : 1;              /*!< [4]  */
        uint32_t OCC : 1;              /*!< [5]  */
        uint32_t FPR : 1;              /*!< [6]  */
        uint32_t SUSP : 1;             /*!< [7]  */
        uint32_t PR : 1;               /*!< [8]  */
        uint32_t HSP : 1;              /*!< [9]  */
        uint32_t LS : 2;               /*!< [11:10]  */
        uint32_t PP : 1;               /*!< [12]  */
        uint32_t PO : 1;               /*!< [13]  */
        uint32_t PIC : 2;              /*!< [15:14]  */
        uint32_t PTC : 4;              /*!< [19:16]  */
        uint32_t WKCN : 1;             /*!< [20]  */
        uint32_t WKDC : 1;             /*!< [21]  */
        uint32_t WKOC : 1;             /*!< [22]  */
        uint32_t PHCD : 1;             /*!< [23]  */
        uint32_t PFSC : 1;             /*!< [24]  */
        uint32_t PTS_2 : 1;            /*!< [25]  */
        uint32_t PSPD : 2;             /*!< [27:26]  */
        uint32_t PTW : 1;              /*!< [28]  */
        uint32_t STS : 1;              /*!< [29]  */
        uint32_t PTS_1 : 2;            /*!< [31:30]  */
    } B;
} hw_usb_uog_portsc1_t;

/*!
 * @name Constants and macros for entire USB_UOG_PORTSC1 register
 */
/*@{*/
#define HW_USB_UOG_PORTSC1_ADDR(x) ((uintptr_t)(x) + 0x184U)

#define HW_USB_UOG_PORTSC1(x)    (*(__IO hw_usb_uog_portsc1_t *) HW_USB_UOG_PORTSC1_ADDR(x))
#define HW_USB_UOG_PORTSC1_RD(x) (HW_USB_UOG_PORTSC1(x).U)
#define HW_USB_UOG_PORTSC1_WR(x, v) (HW_USB_UOG_PORTSC1(x).U = (v))
#define HW_USB_UOG_PORTSC1_SET(x, v) (HW_USB_UOG_PORTSC1_WR(x, HW_USB_UOG_PORTSC1_RD(x) |  (v)))
#define HW_USB_UOG_PORTSC1_CLR(x, v) (HW_USB_UOG_PORTSC1_WR(x, HW_USB_UOG_PORTSC1_RD(x) & ~(v)))
#define HW_USB_UOG_PORTSC1_TOG(x, v) (HW_USB_UOG_PORTSC1_WR(x, HW_USB_UOG_PORTSC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_PORTSC1 bitfields
 */

/*!
 * @name Register USB_UOG_PORTSC1, field CCS[0] (RO)
 *
 * Current Connect Status-Read Only. In Host Mode: 1=Device is present on port.
 * 0=No device is present. Default = 0. This value reflects the current state of
 * the port, and may not correspond directly to the event that caused the Connect
 * Status Change bit (Bit 1) to be set. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: 1=Attached.
 * 0=Not Attached. Default=0. A one indicates that the device successfully attached
 * and is operating in either high speed or full speed as indicated by the High
 * Speed Port bit in this register. A zero indicates that the device did not
 * attach successfully or was forcibly disconnected by the software writing a zero to
 * the Run bit in the USBCMD register. It does not state the device being
 * disconnected or suspended.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_CCS (0U)        /*!< Bit position for USB_UOG_PORTSC1_CCS. */
#define BM_USB_UOG_PORTSC1_CCS (0x00000001U) /*!< Bit mask for USB_UOG_PORTSC1_CCS. */
#define BS_USB_UOG_PORTSC1_CCS (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_CCS. */

/*! @brief Read current value of the USB_UOG_PORTSC1_CCS field. */
#define BR_USB_UOG_PORTSC1_CCS(x) (HW_USB_UOG_PORTSC1(x).B.CCS)
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field CSC[1] (RW)
 *
 * Connect Status Change-R/WC. 1 =Change in Current Connect Status. 0=No change.
 * Default 0. In Host Mode: Indicates a change has occurred in the port's
 * Current Connect Status. The host/device controller sets this bit for all changes to
 * the port device connect status, even if system software has not cleared an
 * existing connect status change. For example, the insertion status changes twice
 * before system software has cleared the changed condition, hub hardware will be
 * 'setting' an already-set bit (that is, the bit will remain set). Software
 * clears this bit by writing a one to it. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: This bit is
 * undefined in device controller mode.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_CSC (1U)        /*!< Bit position for USB_UOG_PORTSC1_CSC. */
#define BM_USB_UOG_PORTSC1_CSC (0x00000002U) /*!< Bit mask for USB_UOG_PORTSC1_CSC. */
#define BS_USB_UOG_PORTSC1_CSC (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_CSC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_CSC field. */
#define BR_USB_UOG_PORTSC1_CSC(x) (HW_USB_UOG_PORTSC1(x).B.CSC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_CSC. */
#define BF_USB_UOG_PORTSC1_CSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_CSC) & BM_USB_UOG_PORTSC1_CSC)

/*! @brief Set the CSC field to a new value. */
#define BW_USB_UOG_PORTSC1_CSC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_CSC) | BF_USB_UOG_PORTSC1_CSC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PE[2] (RW)
 *
 * Port Enabled/Disabled-Read/Write. 1=Enable. 0=Disable. Default 0. In Host
 * Mode: Ports can only be enabled by the host controller as a part of the reset and
 * enable. Software cannot enable a port by writing a one to this field. Ports
 * can be disabled by either a fault condition (disconnect event or other fault
 * condition) or by the host software. Note that the bit status does not change
 * until the port state actually changes. There may be a delay in disabling or
 * enabling a port due to other host controller and bus events. When the port is
 * disabled, (0b) downstream propagation of data is blocked except for reset. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero in host mode.
 * In Device Mode: The device port is always enabled, so this bit is always '1b'.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PE (2U)         /*!< Bit position for USB_UOG_PORTSC1_PE. */
#define BM_USB_UOG_PORTSC1_PE (0x00000004U) /*!< Bit mask for USB_UOG_PORTSC1_PE. */
#define BS_USB_UOG_PORTSC1_PE (1U)         /*!< Bit field size in bits for USB_UOG_PORTSC1_PE. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PE field. */
#define BR_USB_UOG_PORTSC1_PE(x) (HW_USB_UOG_PORTSC1(x).B.PE)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PE. */
#define BF_USB_UOG_PORTSC1_PE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PE) & BM_USB_UOG_PORTSC1_PE)

/*! @brief Set the PE field to a new value. */
#define BW_USB_UOG_PORTSC1_PE(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PE) | BF_USB_UOG_PORTSC1_PE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PEC[3] (RW)
 *
 * Port Enable/Disable Change-R/WC. 1=Port enabled/disabled status has changed.
 * 0=No change. Default = 0. In Host Mode: For the root hub, this bit is set to a
 * one only when a port is disabled due to disconnect on the port or due to the
 * appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB
 * Specification). Software clears this by writing a one to it. This field is zero
 * if Port Power( PORTSC1Port Status & Control ) is zero. In Device mode: The
 * device port is always enabled, so this bit is always '0b'.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PEC (3U)        /*!< Bit position for USB_UOG_PORTSC1_PEC. */
#define BM_USB_UOG_PORTSC1_PEC (0x00000008U) /*!< Bit mask for USB_UOG_PORTSC1_PEC. */
#define BS_USB_UOG_PORTSC1_PEC (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_PEC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PEC field. */
#define BR_USB_UOG_PORTSC1_PEC(x) (HW_USB_UOG_PORTSC1(x).B.PEC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PEC. */
#define BF_USB_UOG_PORTSC1_PEC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PEC) & BM_USB_UOG_PORTSC1_PEC)

/*! @brief Set the PEC field to a new value. */
#define BW_USB_UOG_PORTSC1_PEC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PEC) | BF_USB_UOG_PORTSC1_PEC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field OCA[4] (RO)
 *
 * Over-current Active-Read Only. Default 0. This bit will automatically
 * transition from one to zero when the over current condition is removed.
 *
 * Values:
 * - 1 - This port currently has an over-current condition
 * - 0 - This port does not have an over-current condition.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_OCA (4U)        /*!< Bit position for USB_UOG_PORTSC1_OCA. */
#define BM_USB_UOG_PORTSC1_OCA (0x00000010U) /*!< Bit mask for USB_UOG_PORTSC1_OCA. */
#define BS_USB_UOG_PORTSC1_OCA (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_OCA. */

/*! @brief Read current value of the USB_UOG_PORTSC1_OCA field. */
#define BR_USB_UOG_PORTSC1_OCA(x) (HW_USB_UOG_PORTSC1(x).B.OCA)
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field OCC[5] (RW)
 *
 * Over-current Change-R/WC. Default=0. This bit is set '1b' by hardware when
 * there is a change to Over-current Active. Software can clear this bit by writing
 * a one to this bit position.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_OCC (5U)        /*!< Bit position for USB_UOG_PORTSC1_OCC. */
#define BM_USB_UOG_PORTSC1_OCC (0x00000020U) /*!< Bit mask for USB_UOG_PORTSC1_OCC. */
#define BS_USB_UOG_PORTSC1_OCC (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_OCC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_OCC field. */
#define BR_USB_UOG_PORTSC1_OCC(x) (HW_USB_UOG_PORTSC1(x).B.OCC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_OCC. */
#define BF_USB_UOG_PORTSC1_OCC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_OCC) & BM_USB_UOG_PORTSC1_OCC)

/*! @brief Set the OCC field to a new value. */
#define BW_USB_UOG_PORTSC1_OCC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_OCC) | BF_USB_UOG_PORTSC1_OCC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field FPR[6] (RW)
 *
 * Force Port Resume -Read/Write. 1= Resume detected/driven on port. 0=No resume
 * (K-state) detected/driven on port. Default = 0. In Host Mode: Software sets
 * this bit to one to drive resume signaling. The Host Controller sets this bit to
 * one if a J-to-K transition is detected while the port is in the Suspend
 * state. When this bit transitions to a one because a J-to-K transition is detected,
 * the Port Change Detect bit in the USBSTS register is also set to one. This bit
 * will automatically change to zero after the resume sequence is complete. This
 * behavior is different from EHCI where the host controller driver is required
 * to set this bit to a zero after the resume duration is timed in the driver.
 * Note that when the Host controller owns the port, the resume sequence follows
 * the defined sequence documented in the USB Specification Revision 2.0. The
 * resume signaling (Full-speed 'K') is driven on the port as long as this bit remains
 * a one. This bit will remain a one until the port has switched to the
 * high-speed idle. Writing a zero has no effect because the port controller will time
 * the resume operation, clear the bit the port control state switches to HS or FS
 * idle. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero
 * in host mode. This bit is not-EHCI compatible. In Device mode: After the
 * device has been in Suspend State for 5ms or more, software must set this bit to
 * one to drive resume signaling before clearing. The Device Controller will set
 * this bit to one if a J-to-K transition is detected while the port is in the
 * Suspend state. The bit will be cleared when the device returns to normal
 * operation. Also, when this bit wil be cleared because a K-to-J transition detected, the
 * Port Change Detect bit in the USBSTS register is also set to one.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_FPR (6U)        /*!< Bit position for USB_UOG_PORTSC1_FPR. */
#define BM_USB_UOG_PORTSC1_FPR (0x00000040U) /*!< Bit mask for USB_UOG_PORTSC1_FPR. */
#define BS_USB_UOG_PORTSC1_FPR (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_FPR. */

/*! @brief Read current value of the USB_UOG_PORTSC1_FPR field. */
#define BR_USB_UOG_PORTSC1_FPR(x) (HW_USB_UOG_PORTSC1(x).B.FPR)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_FPR. */
#define BF_USB_UOG_PORTSC1_FPR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_FPR) & BM_USB_UOG_PORTSC1_FPR)

/*! @brief Set the FPR field to a new value. */
#define BW_USB_UOG_PORTSC1_FPR(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_FPR) | BF_USB_UOG_PORTSC1_FPR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field SUSP[7] (RW)
 *
 * Suspend - Read/Write or Read Only. Default = 0b. 1=Port in suspend state.
 * 0=Port not in suspend state. In Host Mode: Read/Write. Port Enabled Bit and
 * Suspend bit of this register define the port states as follows: Bits [Port Enabled,
 * Suspend] Port State 0x Disable 10 Enable 11 Suspend When in suspend state,
 * downstream propagation of data is blocked on this port, except for port reset.
 * The blocking occurs at the end of the current transaction if a transaction was
 * in progress when this bit was written to 1. In the suspend state, the port is
 * sensitive to resume detection. Note that the bit status does not change until
 * the port is suspended and that there may be a delay in suspending a port if
 * there is a transaction currently in progress on the USB. The host controller
 * will unconditionally set this bit to zero when software sets the Force Port
 * Resume bit to zero. The host controller ignores a write of zero to this bit. If
 * host software sets this bit to a one when the port is not enabled (that is, Port
 * enabled bit is a zero) the results are undefined. This field is zero if Port
 * Power( PORTSC1Port Status & Control ) is zero in host mode. In Device Mode:
 * Read Only. In device mode this bit is a read only status bit.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_SUSP (7U)       /*!< Bit position for USB_UOG_PORTSC1_SUSP. */
#define BM_USB_UOG_PORTSC1_SUSP (0x00000080U) /*!< Bit mask for USB_UOG_PORTSC1_SUSP. */
#define BS_USB_UOG_PORTSC1_SUSP (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_SUSP. */

/*! @brief Read current value of the USB_UOG_PORTSC1_SUSP field. */
#define BR_USB_UOG_PORTSC1_SUSP(x) (HW_USB_UOG_PORTSC1(x).B.SUSP)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_SUSP. */
#define BF_USB_UOG_PORTSC1_SUSP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_SUSP) & BM_USB_UOG_PORTSC1_SUSP)

/*! @brief Set the SUSP field to a new value. */
#define BW_USB_UOG_PORTSC1_SUSP(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_SUSP) | BF_USB_UOG_PORTSC1_SUSP(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PR[8] (RW)
 *
 * Port Reset - Read/Write or Read Only. Default = 0b. In Host Mode: Read/Write.
 * 1=Port is in Reset. 0=Port is not in Reset. Default 0. When software writes a
 * one to this bit the bus-reset sequence as defined in the USB Specification
 * Revision 2.0 is started. This bit will automatically change to zero after the
 * reset sequence is complete. This behavior is different from EHCI where the host
 * controller driver is required to set this bit to a zero after the reset
 * duration is timed in the driver. In Device Mode: This bit is a read only status bit.
 * Device reset from the USB bus is also indicated in the USBSTS register. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PR (8U)         /*!< Bit position for USB_UOG_PORTSC1_PR. */
#define BM_USB_UOG_PORTSC1_PR (0x00000100U) /*!< Bit mask for USB_UOG_PORTSC1_PR. */
#define BS_USB_UOG_PORTSC1_PR (1U)         /*!< Bit field size in bits for USB_UOG_PORTSC1_PR. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PR field. */
#define BR_USB_UOG_PORTSC1_PR(x) (HW_USB_UOG_PORTSC1(x).B.PR)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PR. */
#define BF_USB_UOG_PORTSC1_PR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PR) & BM_USB_UOG_PORTSC1_PR)

/*! @brief Set the PR field to a new value. */
#define BW_USB_UOG_PORTSC1_PR(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PR) | BF_USB_UOG_PORTSC1_PR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field HSP[9] (RO)
 *
 * High-Speed Port - Read Only. Default = 0b. When the bit is one, the
 * host/device connected to the port is in high-speed mode and if set to zero, the
 * host/device connected to the port is not in a high-speed mode. HSP is redundant with
 * PSPD(bit 27, 26) but remained for compatibility.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_HSP (9U)        /*!< Bit position for USB_UOG_PORTSC1_HSP. */
#define BM_USB_UOG_PORTSC1_HSP (0x00000200U) /*!< Bit mask for USB_UOG_PORTSC1_HSP. */
#define BS_USB_UOG_PORTSC1_HSP (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_HSP. */

/*! @brief Read current value of the USB_UOG_PORTSC1_HSP field. */
#define BR_USB_UOG_PORTSC1_HSP(x) (HW_USB_UOG_PORTSC1(x).B.HSP)
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field LS[11:10] (RW)
 *
 * Line Status-Read Only. These bits reflect the current logical levels of the
 * D+ (bit 11) and D- (bit 10) signal lines. In host mode, the use of linestate by
 * the host controller driver is not necessary (unlike EHCI), because the port
 * controller state machine and the port routing manage the connection of LS and
 * FS. In device mode, the use of linestate by the device controller driver is not
 * necessary. The encoding of the bits are: Bits [11:10] Meaning
 *
 * Values:
 * - 00 - SE0
 * - 10 - J-state
 * - 01 - K-state
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_LS (10U)        /*!< Bit position for USB_UOG_PORTSC1_LS. */
#define BM_USB_UOG_PORTSC1_LS (0x00000C00U) /*!< Bit mask for USB_UOG_PORTSC1_LS. */
#define BS_USB_UOG_PORTSC1_LS (2U)         /*!< Bit field size in bits for USB_UOG_PORTSC1_LS. */

/*! @brief Read current value of the USB_UOG_PORTSC1_LS field. */
#define BR_USB_UOG_PORTSC1_LS(x) (HW_USB_UOG_PORTSC1(x).B.LS)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_LS. */
#define BF_USB_UOG_PORTSC1_LS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_LS) & BM_USB_UOG_PORTSC1_LS)

/*! @brief Set the LS field to a new value. */
#define BW_USB_UOG_PORTSC1_LS(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_LS) | BF_USB_UOG_PORTSC1_LS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PP[12] (RW)
 *
 * Port Power (PP)-Read/Write or Read Only. The function of this bit depends on
 * the value of the Port Power Switching (PPC) field in the HCSPARAMS register.
 * The behavior is as follows: PPC PP Operation 0 1b Read Only - Host controller
 * does not have port power control switches. Each port is hard-wired to power. 1
 * 1b/0b - Read/Write. Host/OTG controller requires port power control switches.
 * This bit represents the current setting of the switch (0=off, 1=on). When
 * power is not available on a port (that is, PP equals a 0), the port is
 * non-functional and will not report attaches, detaches, etc. When an over-current
 * condition is detected on a powered port and PPC is a one, the PP bit in each affected
 * port may be transitional by the host controller driver from a one to a zero
 * (removing power from the port). This feature is implemented in all controller
 * cores (PPC = 1).
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PP (12U)        /*!< Bit position for USB_UOG_PORTSC1_PP. */
#define BM_USB_UOG_PORTSC1_PP (0x00001000U) /*!< Bit mask for USB_UOG_PORTSC1_PP. */
#define BS_USB_UOG_PORTSC1_PP (1U)         /*!< Bit field size in bits for USB_UOG_PORTSC1_PP. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PP field. */
#define BR_USB_UOG_PORTSC1_PP(x) (HW_USB_UOG_PORTSC1(x).B.PP)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PP. */
#define BF_USB_UOG_PORTSC1_PP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PP) & BM_USB_UOG_PORTSC1_PP)

/*! @brief Set the PP field to a new value. */
#define BW_USB_UOG_PORTSC1_PP(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PP) | BF_USB_UOG_PORTSC1_PP(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PO[13] (RW)
 *
 * Port Owner-Read/Write. Default = 0. This bit unconditionally goes to a 0 when
 * the configured bit in the CONFIGFLAG register makes a 0 to 1 transition. This
 * bit unconditionally goes to 1 whenever the Configured bit is zero System
 * software uses this field to release ownership of the port to a selected host
 * controller (in the event that the attached device is not a high-speed device).
 * Software writes a one to this bit when the attached device is not a high-speed
 * device. A one in this bit means that an internal companion controller owns and
 * controls the port. Port owner handoff is not supported in all controller cores,
 * therefore this bit will always be 0.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PO (13U)        /*!< Bit position for USB_UOG_PORTSC1_PO. */
#define BM_USB_UOG_PORTSC1_PO (0x00002000U) /*!< Bit mask for USB_UOG_PORTSC1_PO. */
#define BS_USB_UOG_PORTSC1_PO (1U)         /*!< Bit field size in bits for USB_UOG_PORTSC1_PO. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PO field. */
#define BR_USB_UOG_PORTSC1_PO(x) (HW_USB_UOG_PORTSC1(x).B.PO)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PO. */
#define BF_USB_UOG_PORTSC1_PO(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PO) & BM_USB_UOG_PORTSC1_PO)

/*! @brief Set the PO field to a new value. */
#define BW_USB_UOG_PORTSC1_PO(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PO) | BF_USB_UOG_PORTSC1_PO(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PIC[15:14] (RW)
 *
 * Port Indicator Control - Read/Write. Default = Ob. Writing to this field has
 * no effect if the P_INDICATOR bit in the HCSPARAMS register is a zero. Refer to
 * the USB Specification Revision 2.0 for a description on how these bits are to
 * be used. This field is zero if Port Power is zero. Bit Value Meaning
 *
 * Values:
 * - 00 - Port indicators are off
 * - 01 - Amber
 * - 10 - Green
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PIC (14U)       /*!< Bit position for USB_UOG_PORTSC1_PIC. */
#define BM_USB_UOG_PORTSC1_PIC (0x0000C000U) /*!< Bit mask for USB_UOG_PORTSC1_PIC. */
#define BS_USB_UOG_PORTSC1_PIC (2U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_PIC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PIC field. */
#define BR_USB_UOG_PORTSC1_PIC(x) (HW_USB_UOG_PORTSC1(x).B.PIC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PIC. */
#define BF_USB_UOG_PORTSC1_PIC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PIC) & BM_USB_UOG_PORTSC1_PIC)

/*! @brief Set the PIC field to a new value. */
#define BW_USB_UOG_PORTSC1_PIC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PIC) | BF_USB_UOG_PORTSC1_PIC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PTC[19:16] (RW)
 *
 * Port Test Control - Read/Write. Default = 0000b. Refer to Port Test Mode for
 * the operational model for using these test modes and the USB Specification
 * Revision 2.0, Chapter 7 for details on each test mode. The FORCE_ENABLE_FS and
 * FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI
 * specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS}
 * values will force the port into the connected and enabled state at the selected
 * speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state
 * machines to progress normally from that point. Low speed operations are not
 * supported as a peripheral device. Any other value than zero indicates that the
 * port is operating in test mode. Value Specific Test
 *
 * Values:
 * - 0000 - TEST_MODE_DISABLE
 * - 0001 - J_STATE
 * - 0010 - K_STATE
 * - 0011 - SE0 (host) / NAK (device)
 * - 0100 - Packet
 * - 0101 - FORCE_ENABLE_HS
 * - 0110 - FORCE_ENABLE_FS
 * - 0111 - FORCE_ENABLE_LS
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PTC (16U)       /*!< Bit position for USB_UOG_PORTSC1_PTC. */
#define BM_USB_UOG_PORTSC1_PTC (0x000F0000U) /*!< Bit mask for USB_UOG_PORTSC1_PTC. */
#define BS_USB_UOG_PORTSC1_PTC (4U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_PTC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PTC field. */
#define BR_USB_UOG_PORTSC1_PTC(x) (HW_USB_UOG_PORTSC1(x).B.PTC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PTC. */
#define BF_USB_UOG_PORTSC1_PTC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PTC) & BM_USB_UOG_PORTSC1_PTC)

/*! @brief Set the PTC field to a new value. */
#define BW_USB_UOG_PORTSC1_PTC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PTC) | BF_USB_UOG_PORTSC1_PTC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field WKCN[20] (RW)
 *
 * Wake on Connect Enable (WKCNNT_E) - Read/Write. Default=0b. Writing this bit
 * to a one enables the port to be sensitive to device connects as wake-up
 * events. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero or
 * in device mode.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_WKCN (20U)      /*!< Bit position for USB_UOG_PORTSC1_WKCN. */
#define BM_USB_UOG_PORTSC1_WKCN (0x00100000U) /*!< Bit mask for USB_UOG_PORTSC1_WKCN. */
#define BS_USB_UOG_PORTSC1_WKCN (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_WKCN. */

/*! @brief Read current value of the USB_UOG_PORTSC1_WKCN field. */
#define BR_USB_UOG_PORTSC1_WKCN(x) (HW_USB_UOG_PORTSC1(x).B.WKCN)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_WKCN. */
#define BF_USB_UOG_PORTSC1_WKCN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_WKCN) & BM_USB_UOG_PORTSC1_WKCN)

/*! @brief Set the WKCN field to a new value. */
#define BW_USB_UOG_PORTSC1_WKCN(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_WKCN) | BF_USB_UOG_PORTSC1_WKCN(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field WKDC[21] (RW)
 *
 * Wake on Disconnect Enable (WKDSCNNT_E) - Read/Write. Default=0b. Writing this
 * bit to a one enables the port to be sensitive to device disconnects as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control ) is
 * zero or in device mode.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_WKDC (21U)      /*!< Bit position for USB_UOG_PORTSC1_WKDC. */
#define BM_USB_UOG_PORTSC1_WKDC (0x00200000U) /*!< Bit mask for USB_UOG_PORTSC1_WKDC. */
#define BS_USB_UOG_PORTSC1_WKDC (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_WKDC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_WKDC field. */
#define BR_USB_UOG_PORTSC1_WKDC(x) (HW_USB_UOG_PORTSC1(x).B.WKDC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_WKDC. */
#define BF_USB_UOG_PORTSC1_WKDC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_WKDC) & BM_USB_UOG_PORTSC1_WKDC)

/*! @brief Set the WKDC field to a new value. */
#define BW_USB_UOG_PORTSC1_WKDC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_WKDC) | BF_USB_UOG_PORTSC1_WKDC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field WKOC[22] (RW)
 *
 * Wake on Over-current Enable (WKOC_E) - Read/Write. Default = 0b. Writing this
 * bit to a one enables the port to be sensitive to over-current conditions as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control
 * ) is zero.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_WKOC (22U)      /*!< Bit position for USB_UOG_PORTSC1_WKOC. */
#define BM_USB_UOG_PORTSC1_WKOC (0x00400000U) /*!< Bit mask for USB_UOG_PORTSC1_WKOC. */
#define BS_USB_UOG_PORTSC1_WKOC (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_WKOC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_WKOC field. */
#define BR_USB_UOG_PORTSC1_WKOC(x) (HW_USB_UOG_PORTSC1(x).B.WKOC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_WKOC. */
#define BF_USB_UOG_PORTSC1_WKOC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_WKOC) & BM_USB_UOG_PORTSC1_WKOC)

/*! @brief Set the WKOC field to a new value. */
#define BW_USB_UOG_PORTSC1_WKOC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_WKOC) | BF_USB_UOG_PORTSC1_WKOC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PHCD[23] (RW)
 *
 * PHY Low Power Suspend - Clock Disable (PLPSCD) - Read/Write. Default = 0b.
 * When this bit is set to '1b', the PHY clock is disabled. Reading this bit will
 * indicate the status of the PHY clock. The PHY clock cannot be disabled if it is
 * being used as the system clock. In device mode, The PHY can be put into Low
 * Power Suspend when the device is not running (USBCMD Run/Stop=0b) or the host
 * has signalled suspend (PORTSC1 SUSPEND=1b). PHY Low power suspend will be
 * cleared automatically when the host initials resume. Before forcing a resume from
 * the device, the device controller driver must clear this bit. In host mode, the
 * PHY can be put into Low Power Suspend when the downstream device has been put
 * into suspend mode or when no downstream device is connected. Low power
 * suspend is completely under the control of software.
 *
 * Values:
 * - 1 - Disable PHY clock
 * - 0 - Enable PHY clock
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PHCD (23U)      /*!< Bit position for USB_UOG_PORTSC1_PHCD. */
#define BM_USB_UOG_PORTSC1_PHCD (0x00800000U) /*!< Bit mask for USB_UOG_PORTSC1_PHCD. */
#define BS_USB_UOG_PORTSC1_PHCD (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_PHCD. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PHCD field. */
#define BR_USB_UOG_PORTSC1_PHCD(x) (HW_USB_UOG_PORTSC1(x).B.PHCD)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PHCD. */
#define BF_USB_UOG_PORTSC1_PHCD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PHCD) & BM_USB_UOG_PORTSC1_PHCD)

/*! @brief Set the PHCD field to a new value. */
#define BW_USB_UOG_PORTSC1_PHCD(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PHCD) | BF_USB_UOG_PORTSC1_PHCD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PFSC[24] (RW)
 *
 * Port Force Full Speed Connect - Read/Write. Default = 0b. When this bit is
 * set to '1b', the port will be forced to only connect at Full Speed, It disables
 * the chirp sequence that allows the port to identify itself as High Speed.
 *
 * Values:
 * - 1 - Forced to full speed
 * - 0 - Normal operation
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PFSC (24U)      /*!< Bit position for USB_UOG_PORTSC1_PFSC. */
#define BM_USB_UOG_PORTSC1_PFSC (0x01000000U) /*!< Bit mask for USB_UOG_PORTSC1_PFSC. */
#define BS_USB_UOG_PORTSC1_PFSC (1U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_PFSC. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PFSC field. */
#define BR_USB_UOG_PORTSC1_PFSC(x) (HW_USB_UOG_PORTSC1(x).B.PFSC)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PFSC. */
#define BF_USB_UOG_PORTSC1_PFSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PFSC) & BM_USB_UOG_PORTSC1_PFSC)

/*! @brief Set the PFSC field to a new value. */
#define BW_USB_UOG_PORTSC1_PFSC(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PFSC) | BF_USB_UOG_PORTSC1_PFSC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PTS_2[25] (RW)
 *
 * See description at bits 31-30
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PTS_2 (25U)     /*!< Bit position for USB_UOG_PORTSC1_PTS_2. */
#define BM_USB_UOG_PORTSC1_PTS_2 (0x02000000U) /*!< Bit mask for USB_UOG_PORTSC1_PTS_2. */
#define BS_USB_UOG_PORTSC1_PTS_2 (1U)      /*!< Bit field size in bits for USB_UOG_PORTSC1_PTS_2. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PTS_2 field. */
#define BR_USB_UOG_PORTSC1_PTS_2(x) (HW_USB_UOG_PORTSC1(x).B.PTS_2)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PTS_2. */
#define BF_USB_UOG_PORTSC1_PTS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PTS_2) & BM_USB_UOG_PORTSC1_PTS_2)

/*! @brief Set the PTS_2 field to a new value. */
#define BW_USB_UOG_PORTSC1_PTS_2(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PTS_2) | BF_USB_UOG_PORTSC1_PTS_2(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PSPD[27:26] (RW)
 *
 * Port Speed - Read Only. This register field indicates the speed at which the
 * port is operating.
 *
 * Values:
 * - 00 - Full Speed
 * - 01 - Low Speed
 * - 10 - High Speed
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PSPD (26U)      /*!< Bit position for USB_UOG_PORTSC1_PSPD. */
#define BM_USB_UOG_PORTSC1_PSPD (0x0C000000U) /*!< Bit mask for USB_UOG_PORTSC1_PSPD. */
#define BS_USB_UOG_PORTSC1_PSPD (2U)       /*!< Bit field size in bits for USB_UOG_PORTSC1_PSPD. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PSPD field. */
#define BR_USB_UOG_PORTSC1_PSPD(x) (HW_USB_UOG_PORTSC1(x).B.PSPD)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PSPD. */
#define BF_USB_UOG_PORTSC1_PSPD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PSPD) & BM_USB_UOG_PORTSC1_PSPD)

/*! @brief Set the PSPD field to a new value. */
#define BW_USB_UOG_PORTSC1_PSPD(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PSPD) | BF_USB_UOG_PORTSC1_PSPD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PTW[28] (RW)
 *
 * Parallel Transceiver Width This bit has no effect if serial interface engine
 * is used. For OTG/Host1/Host2/Host3 core, it is Read-Only. Reset value is '1b'.
 *
 * Values:
 * - 0 - Select the 8-bit UTMI interface [60MHz]
 * - 1 - Select the 16-bit UTMI interface [30MHz]
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PTW (28U)       /*!< Bit position for USB_UOG_PORTSC1_PTW. */
#define BM_USB_UOG_PORTSC1_PTW (0x10000000U) /*!< Bit mask for USB_UOG_PORTSC1_PTW. */
#define BS_USB_UOG_PORTSC1_PTW (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_PTW. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PTW field. */
#define BR_USB_UOG_PORTSC1_PTW(x) (HW_USB_UOG_PORTSC1(x).B.PTW)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PTW. */
#define BF_USB_UOG_PORTSC1_PTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PTW) & BM_USB_UOG_PORTSC1_PTW)

/*! @brief Set the PTW field to a new value. */
#define BW_USB_UOG_PORTSC1_PTW(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PTW) | BF_USB_UOG_PORTSC1_PTW(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field STS[29] (RW)
 *
 * Serial Transceiver Select - Read Only Serial Transceiver Select 1 Serial
 * Interface Engine is selected 0 Parallel Interface signals is selected Serial
 * Interface Engine can be used in combination with UTMI+/ULPI physical interface to
 * provide FS/LS signaling instead of the parallel interface signals. When this
 * bit is set '1b', serial interface engine will be used instead of parallel
 * interface signals. This bit has no effect unless PTS bits is set to select
 * UTMI+/ULPI interface. The Serial/USB1.1 PHY/IC-USB will use the serial interface engine
 * for FS/LS signaling regardless of this bit value.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_STS (29U)       /*!< Bit position for USB_UOG_PORTSC1_STS. */
#define BM_USB_UOG_PORTSC1_STS (0x20000000U) /*!< Bit mask for USB_UOG_PORTSC1_STS. */
#define BS_USB_UOG_PORTSC1_STS (1U)        /*!< Bit field size in bits for USB_UOG_PORTSC1_STS. */

/*! @brief Read current value of the USB_UOG_PORTSC1_STS field. */
#define BR_USB_UOG_PORTSC1_STS(x) (HW_USB_UOG_PORTSC1(x).B.STS)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_STS. */
#define BF_USB_UOG_PORTSC1_STS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_STS) & BM_USB_UOG_PORTSC1_STS)

/*! @brief Set the STS field to a new value. */
#define BW_USB_UOG_PORTSC1_STS(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_STS) | BF_USB_UOG_PORTSC1_STS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_PORTSC1, field PTS_1[31:30] (RW)
 *
 * Bit field {bit25, bit31, bit30}: "000b" UTMI/UTMI+ "001b" Reserved "010b"
 * ULPI "011b" Serial/USB 1.1 PHY/IC-USB (FS Only) "100b" HSIC Parallel Transceiver
 * Select (bit25, bit31, bi30). For OTG core, it is Read-Only. Reset value is
 * 000b. For Host1/Host2/Host3 core, it is Read/Write. Reset value is 000b. All USB
 * port interface modes are listed in this field description, but not all are
 * supported. For detail feature of each controller core, please see Features . The
 * behaviour is unknown when unsupported interface mode is selected.
 */
/*@{*/
#define BP_USB_UOG_PORTSC1_PTS_1 (30U)     /*!< Bit position for USB_UOG_PORTSC1_PTS_1. */
#define BM_USB_UOG_PORTSC1_PTS_1 (0xC0000000U) /*!< Bit mask for USB_UOG_PORTSC1_PTS_1. */
#define BS_USB_UOG_PORTSC1_PTS_1 (2U)      /*!< Bit field size in bits for USB_UOG_PORTSC1_PTS_1. */

/*! @brief Read current value of the USB_UOG_PORTSC1_PTS_1 field. */
#define BR_USB_UOG_PORTSC1_PTS_1(x) (HW_USB_UOG_PORTSC1(x).B.PTS_1)

/*! @brief Format value for bitfield USB_UOG_PORTSC1_PTS_1. */
#define BF_USB_UOG_PORTSC1_PTS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_PORTSC1_PTS_1) & BM_USB_UOG_PORTSC1_PTS_1)

/*! @brief Set the PTS_1 field to a new value. */
#define BW_USB_UOG_PORTSC1_PTS_1(x, v) (HW_USB_UOG_PORTSC1_WR(x, (HW_USB_UOG_PORTSC1_RD(x) & ~BM_USB_UOG_PORTSC1_PTS_1) | BF_USB_UOG_PORTSC1_PTS_1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_OTGSC - On-The-Go Status & control
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_OTGSC - On-The-Go Status & control (RW)
 *
 * Reset value: 0x00000120U
 *
 * This register is availabe only in OTG controller core. It has four sections:
 * OTG Interrupt enables (Read/Write) OTG Interrupt status (Read/Write to Clear)
 * OTG Status inputs (Read Only) OTG Controls (Read/Write) The status inputs are
 * debounced using a 1 ms time constant. Values on the status inputs that do not
 * persist for more than 1 ms does not cause an update of the status input
 * register, or cause an OTG interrupt. See also USBMODEUSB Device Mode register.
 */
typedef union _hw_usb_uog_otgsc
{
    uint32_t U;
    struct _hw_usb_uog_otgsc_bitfields
    {
        uint32_t VD : 1;               /*!< [0]  */
        uint32_t VC : 1;               /*!< [1]  */
        uint32_t RESERVED0 : 1;        /*!< [2]  */
        uint32_t OT : 1;               /*!< [3]  */
        uint32_t DP : 1;               /*!< [4]  */
        uint32_t IDPU : 1;             /*!< [5]  */
        uint32_t RESERVED1 : 2;        /*!< [7:6]  */
        uint32_t ID : 1;               /*!< [8]  */
        uint32_t AVV : 1;              /*!< [9]  */
        uint32_t ASV : 1;              /*!< [10]  */
        uint32_t BSV : 1;              /*!< [11]  */
        uint32_t BSE : 1;              /*!< [12]  */
        uint32_t TOG_1MS : 1;          /*!< [13]  */
        uint32_t DPS : 1;              /*!< [14]  */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t IDIS : 1;             /*!< [16]  */
        uint32_t AVVIS : 1;            /*!< [17]  */
        uint32_t ASVIS : 1;            /*!< [18]  */
        uint32_t BSVIS : 1;            /*!< [19]  */
        uint32_t BSEIS : 1;            /*!< [20]  */
        uint32_t STATUS_1MS : 1;       /*!< [21]  */
        uint32_t DPIS : 1;             /*!< [22]  */
        uint32_t RESERVED3 : 1;        /*!< [23]  */
        uint32_t IDIE : 1;             /*!< [24]  */
        uint32_t AVVIE : 1;            /*!< [25]  */
        uint32_t ASVIE : 1;            /*!< [26]  */
        uint32_t BSVIE : 1;            /*!< [27]  */
        uint32_t BSEIE : 1;            /*!< [28]  */
        uint32_t EN_1MS : 1;           /*!< [29]  */
        uint32_t DPIE : 1;             /*!< [30]  */
        uint32_t RESERVED4 : 1;        /*!< [31]  */
    } B;
} hw_usb_uog_otgsc_t;

/*!
 * @name Constants and macros for entire USB_UOG_OTGSC register
 */
/*@{*/
#define HW_USB_UOG_OTGSC_ADDR(x) ((uintptr_t)(x) + 0x1A4U)

#define HW_USB_UOG_OTGSC(x)      (*(__IO hw_usb_uog_otgsc_t *) HW_USB_UOG_OTGSC_ADDR(x))
#define HW_USB_UOG_OTGSC_RD(x)   (HW_USB_UOG_OTGSC(x).U)
#define HW_USB_UOG_OTGSC_WR(x, v) (HW_USB_UOG_OTGSC(x).U = (v))
#define HW_USB_UOG_OTGSC_SET(x, v) (HW_USB_UOG_OTGSC_WR(x, HW_USB_UOG_OTGSC_RD(x) |  (v)))
#define HW_USB_UOG_OTGSC_CLR(x, v) (HW_USB_UOG_OTGSC_WR(x, HW_USB_UOG_OTGSC_RD(x) & ~(v)))
#define HW_USB_UOG_OTGSC_TOG(x, v) (HW_USB_UOG_OTGSC_WR(x, HW_USB_UOG_OTGSC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_OTGSC bitfields
 */

/*!
 * @name Register USB_UOG_OTGSC, field VD[0] (RW)
 *
 * VBUS_Discharge - Read/Write. Setting this bit causes VBus to discharge
 * through a resistor.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_VD  (0U)          /*!< Bit position for USB_UOG_OTGSC_VD. */
#define BM_USB_UOG_OTGSC_VD  (0x00000001U) /*!< Bit mask for USB_UOG_OTGSC_VD. */
#define BS_USB_UOG_OTGSC_VD  (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_VD. */

/*! @brief Read current value of the USB_UOG_OTGSC_VD field. */
#define BR_USB_UOG_OTGSC_VD(x) (HW_USB_UOG_OTGSC(x).B.VD)

/*! @brief Format value for bitfield USB_UOG_OTGSC_VD. */
#define BF_USB_UOG_OTGSC_VD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_VD) & BM_USB_UOG_OTGSC_VD)

/*! @brief Set the VD field to a new value. */
#define BW_USB_UOG_OTGSC_VD(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_VD) | BF_USB_UOG_OTGSC_VD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field VC[1] (RW)
 *
 * VBUS Charge - Read/Write. Setting this bit causes the VBus line to be
 * charged. This is used for VBus pulsing during SRP.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_VC  (1U)          /*!< Bit position for USB_UOG_OTGSC_VC. */
#define BM_USB_UOG_OTGSC_VC  (0x00000002U) /*!< Bit mask for USB_UOG_OTGSC_VC. */
#define BS_USB_UOG_OTGSC_VC  (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_VC. */

/*! @brief Read current value of the USB_UOG_OTGSC_VC field. */
#define BR_USB_UOG_OTGSC_VC(x) (HW_USB_UOG_OTGSC(x).B.VC)

/*! @brief Format value for bitfield USB_UOG_OTGSC_VC. */
#define BF_USB_UOG_OTGSC_VC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_VC) & BM_USB_UOG_OTGSC_VC)

/*! @brief Set the VC field to a new value. */
#define BW_USB_UOG_OTGSC_VC(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_VC) | BF_USB_UOG_OTGSC_VC(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field OT[3] (RW)
 *
 * OTG Termination - Read/Write. This bit must be set when the OTG device is in
 * device mode, this controls the pulldown on DM.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_OT  (3U)          /*!< Bit position for USB_UOG_OTGSC_OT. */
#define BM_USB_UOG_OTGSC_OT  (0x00000008U) /*!< Bit mask for USB_UOG_OTGSC_OT. */
#define BS_USB_UOG_OTGSC_OT  (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_OT. */

/*! @brief Read current value of the USB_UOG_OTGSC_OT field. */
#define BR_USB_UOG_OTGSC_OT(x) (HW_USB_UOG_OTGSC(x).B.OT)

/*! @brief Format value for bitfield USB_UOG_OTGSC_OT. */
#define BF_USB_UOG_OTGSC_OT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_OT) & BM_USB_UOG_OTGSC_OT)

/*! @brief Set the OT field to a new value. */
#define BW_USB_UOG_OTGSC_OT(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_OT) | BF_USB_UOG_OTGSC_OT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field DP[4] (RW)
 *
 * Data Pulsing - Read/Write. Setting this bit causes the pullup on DP to be
 * asserted for data pulsing during SRP.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_DP  (4U)          /*!< Bit position for USB_UOG_OTGSC_DP. */
#define BM_USB_UOG_OTGSC_DP  (0x00000010U) /*!< Bit mask for USB_UOG_OTGSC_DP. */
#define BS_USB_UOG_OTGSC_DP  (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_DP. */

/*! @brief Read current value of the USB_UOG_OTGSC_DP field. */
#define BR_USB_UOG_OTGSC_DP(x) (HW_USB_UOG_OTGSC(x).B.DP)

/*! @brief Format value for bitfield USB_UOG_OTGSC_DP. */
#define BF_USB_UOG_OTGSC_DP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_DP) & BM_USB_UOG_OTGSC_DP)

/*! @brief Set the DP field to a new value. */
#define BW_USB_UOG_OTGSC_DP(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_DP) | BF_USB_UOG_OTGSC_DP(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field IDPU[5] (RW)
 *
 * ID Pullup - Read/Write This bit provide control over the ID pull-up resistor;
 * 0 = off, 1 = on [default]. When this bit is 0, the ID input will not be
 * sampled.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_IDPU (5U)         /*!< Bit position for USB_UOG_OTGSC_IDPU. */
#define BM_USB_UOG_OTGSC_IDPU (0x00000020U) /*!< Bit mask for USB_UOG_OTGSC_IDPU. */
#define BS_USB_UOG_OTGSC_IDPU (1U)         /*!< Bit field size in bits for USB_UOG_OTGSC_IDPU. */

/*! @brief Read current value of the USB_UOG_OTGSC_IDPU field. */
#define BR_USB_UOG_OTGSC_IDPU(x) (HW_USB_UOG_OTGSC(x).B.IDPU)

/*! @brief Format value for bitfield USB_UOG_OTGSC_IDPU. */
#define BF_USB_UOG_OTGSC_IDPU(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_IDPU) & BM_USB_UOG_OTGSC_IDPU)

/*! @brief Set the IDPU field to a new value. */
#define BW_USB_UOG_OTGSC_IDPU(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_IDPU) | BF_USB_UOG_OTGSC_IDPU(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field ID[8] (RO)
 *
 * USB ID - Read Only. 0 = A device, 1 = B device
 */
/*@{*/
#define BP_USB_UOG_OTGSC_ID  (8U)          /*!< Bit position for USB_UOG_OTGSC_ID. */
#define BM_USB_UOG_OTGSC_ID  (0x00000100U) /*!< Bit mask for USB_UOG_OTGSC_ID. */
#define BS_USB_UOG_OTGSC_ID  (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_ID. */

/*! @brief Read current value of the USB_UOG_OTGSC_ID field. */
#define BR_USB_UOG_OTGSC_ID(x) (HW_USB_UOG_OTGSC(x).B.ID)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field AVV[9] (RO)
 *
 * A VBus Valid - Read Only. Indicates VBus is above the A VBus valid threshold.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_AVV (9U)          /*!< Bit position for USB_UOG_OTGSC_AVV. */
#define BM_USB_UOG_OTGSC_AVV (0x00000200U) /*!< Bit mask for USB_UOG_OTGSC_AVV. */
#define BS_USB_UOG_OTGSC_AVV (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_AVV. */

/*! @brief Read current value of the USB_UOG_OTGSC_AVV field. */
#define BR_USB_UOG_OTGSC_AVV(x) (HW_USB_UOG_OTGSC(x).B.AVV)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field ASV[10] (RO)
 *
 * A Session Valid - Read Only. Indicates VBus is above the A session valid
 * threshold.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_ASV (10U)         /*!< Bit position for USB_UOG_OTGSC_ASV. */
#define BM_USB_UOG_OTGSC_ASV (0x00000400U) /*!< Bit mask for USB_UOG_OTGSC_ASV. */
#define BS_USB_UOG_OTGSC_ASV (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_ASV. */

/*! @brief Read current value of the USB_UOG_OTGSC_ASV field. */
#define BR_USB_UOG_OTGSC_ASV(x) (HW_USB_UOG_OTGSC(x).B.ASV)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSV[11] (RO)
 *
 * B Session Valid - Read Only. Indicates VBus is above the B session valid
 * threshold.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSV (11U)         /*!< Bit position for USB_UOG_OTGSC_BSV. */
#define BM_USB_UOG_OTGSC_BSV (0x00000800U) /*!< Bit mask for USB_UOG_OTGSC_BSV. */
#define BS_USB_UOG_OTGSC_BSV (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_BSV. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSV field. */
#define BR_USB_UOG_OTGSC_BSV(x) (HW_USB_UOG_OTGSC(x).B.BSV)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSE[12] (RO)
 *
 * B Session End - Read Only. Indicates VBus is below the B session end
 * threshold.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSE (12U)         /*!< Bit position for USB_UOG_OTGSC_BSE. */
#define BM_USB_UOG_OTGSC_BSE (0x00001000U) /*!< Bit mask for USB_UOG_OTGSC_BSE. */
#define BS_USB_UOG_OTGSC_BSE (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_BSE. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSE field. */
#define BR_USB_UOG_OTGSC_BSE(x) (HW_USB_UOG_OTGSC(x).B.BSE)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field TOG_1MS[13] (RO)
 *
 * 1 millisecond timer toggle - Read Only. This bit toggles once per millisecond.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_TOG_1MS (13U)     /*!< Bit position for USB_UOG_OTGSC_TOG_1MS. */
#define BM_USB_UOG_OTGSC_TOG_1MS (0x00002000U) /*!< Bit mask for USB_UOG_OTGSC_TOG_1MS. */
#define BS_USB_UOG_OTGSC_TOG_1MS (1U)      /*!< Bit field size in bits for USB_UOG_OTGSC_TOG_1MS. */

/*! @brief Read current value of the USB_UOG_OTGSC_TOG_1MS field. */
#define BR_USB_UOG_OTGSC_TOG_1MS(x) (HW_USB_UOG_OTGSC(x).B.TOG_1MS)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field DPS[14] (RO)
 *
 * Data Bus Pulsing Status - Read Only. A '1' indicates data bus pulsing is
 * being detected on the port.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_DPS (14U)         /*!< Bit position for USB_UOG_OTGSC_DPS. */
#define BM_USB_UOG_OTGSC_DPS (0x00004000U) /*!< Bit mask for USB_UOG_OTGSC_DPS. */
#define BS_USB_UOG_OTGSC_DPS (1U)          /*!< Bit field size in bits for USB_UOG_OTGSC_DPS. */

/*! @brief Read current value of the USB_UOG_OTGSC_DPS field. */
#define BR_USB_UOG_OTGSC_DPS(x) (HW_USB_UOG_OTGSC(x).B.DPS)
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field IDIS[16] (RW)
 *
 * USB ID Interrupt Status - Read/Write. This bit is set when a change on the ID
 * input has been detected. Software must write a one to clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_IDIS (16U)        /*!< Bit position for USB_UOG_OTGSC_IDIS. */
#define BM_USB_UOG_OTGSC_IDIS (0x00010000U) /*!< Bit mask for USB_UOG_OTGSC_IDIS. */
#define BS_USB_UOG_OTGSC_IDIS (1U)         /*!< Bit field size in bits for USB_UOG_OTGSC_IDIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_IDIS field. */
#define BR_USB_UOG_OTGSC_IDIS(x) (HW_USB_UOG_OTGSC(x).B.IDIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_IDIS. */
#define BF_USB_UOG_OTGSC_IDIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_IDIS) & BM_USB_UOG_OTGSC_IDIS)

/*! @brief Set the IDIS field to a new value. */
#define BW_USB_UOG_OTGSC_IDIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_IDIS) | BF_USB_UOG_OTGSC_IDIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field AVVIS[17] (RW)
 *
 * A VBus Valid Interrupt Status - Read/Write to Clear. This bit is set when
 * VBus has either risen above or fallen below the VBus valid threshold on an A
 * device. Software must write a one to clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_AVVIS (17U)       /*!< Bit position for USB_UOG_OTGSC_AVVIS. */
#define BM_USB_UOG_OTGSC_AVVIS (0x00020000U) /*!< Bit mask for USB_UOG_OTGSC_AVVIS. */
#define BS_USB_UOG_OTGSC_AVVIS (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_AVVIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_AVVIS field. */
#define BR_USB_UOG_OTGSC_AVVIS(x) (HW_USB_UOG_OTGSC(x).B.AVVIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_AVVIS. */
#define BF_USB_UOG_OTGSC_AVVIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_AVVIS) & BM_USB_UOG_OTGSC_AVVIS)

/*! @brief Set the AVVIS field to a new value. */
#define BW_USB_UOG_OTGSC_AVVIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_AVVIS) | BF_USB_UOG_OTGSC_AVVIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field ASVIS[18] (RW)
 *
 * A Session Valid Interrupt Status - Read/Write to Clear. This bit is set when
 * VBus has either risen above or fallen below the A session valid threshold.
 * Software must write a one to clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_ASVIS (18U)       /*!< Bit position for USB_UOG_OTGSC_ASVIS. */
#define BM_USB_UOG_OTGSC_ASVIS (0x00040000U) /*!< Bit mask for USB_UOG_OTGSC_ASVIS. */
#define BS_USB_UOG_OTGSC_ASVIS (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_ASVIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_ASVIS field. */
#define BR_USB_UOG_OTGSC_ASVIS(x) (HW_USB_UOG_OTGSC(x).B.ASVIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_ASVIS. */
#define BF_USB_UOG_OTGSC_ASVIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_ASVIS) & BM_USB_UOG_OTGSC_ASVIS)

/*! @brief Set the ASVIS field to a new value. */
#define BW_USB_UOG_OTGSC_ASVIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_ASVIS) | BF_USB_UOG_OTGSC_ASVIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSVIS[19] (RW)
 *
 * B Session Valid Interrupt Status - Read/Write to Clear. This bit is set when
 * VBus has either risen above or fallen below the B session valid threshold.
 * Software must write a one to clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSVIS (19U)       /*!< Bit position for USB_UOG_OTGSC_BSVIS. */
#define BM_USB_UOG_OTGSC_BSVIS (0x00080000U) /*!< Bit mask for USB_UOG_OTGSC_BSVIS. */
#define BS_USB_UOG_OTGSC_BSVIS (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_BSVIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSVIS field. */
#define BR_USB_UOG_OTGSC_BSVIS(x) (HW_USB_UOG_OTGSC(x).B.BSVIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_BSVIS. */
#define BF_USB_UOG_OTGSC_BSVIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_BSVIS) & BM_USB_UOG_OTGSC_BSVIS)

/*! @brief Set the BSVIS field to a new value. */
#define BW_USB_UOG_OTGSC_BSVIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_BSVIS) | BF_USB_UOG_OTGSC_BSVIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSEIS[20] (RW)
 *
 * B Session End Interrupt Status - Read/Write to Clear. This bit is set when
 * VBus has fallen below the B session end threshold. Software must write a one to
 * clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSEIS (20U)       /*!< Bit position for USB_UOG_OTGSC_BSEIS. */
#define BM_USB_UOG_OTGSC_BSEIS (0x00100000U) /*!< Bit mask for USB_UOG_OTGSC_BSEIS. */
#define BS_USB_UOG_OTGSC_BSEIS (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_BSEIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSEIS field. */
#define BR_USB_UOG_OTGSC_BSEIS(x) (HW_USB_UOG_OTGSC(x).B.BSEIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_BSEIS. */
#define BF_USB_UOG_OTGSC_BSEIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_BSEIS) & BM_USB_UOG_OTGSC_BSEIS)

/*! @brief Set the BSEIS field to a new value. */
#define BW_USB_UOG_OTGSC_BSEIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_BSEIS) | BF_USB_UOG_OTGSC_BSEIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field STATUS_1MS[21] (RW)
 *
 * 1 millisecond timer Interrupt Status - Read/Write to Clear. This bit is set
 * once every millisecond. Software must write a one to clear this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_STATUS_1MS (21U)  /*!< Bit position for USB_UOG_OTGSC_STATUS_1MS. */
#define BM_USB_UOG_OTGSC_STATUS_1MS (0x00200000U) /*!< Bit mask for USB_UOG_OTGSC_STATUS_1MS. */
#define BS_USB_UOG_OTGSC_STATUS_1MS (1U)   /*!< Bit field size in bits for USB_UOG_OTGSC_STATUS_1MS. */

/*! @brief Read current value of the USB_UOG_OTGSC_STATUS_1MS field. */
#define BR_USB_UOG_OTGSC_STATUS_1MS(x) (HW_USB_UOG_OTGSC(x).B.STATUS_1MS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_STATUS_1MS. */
#define BF_USB_UOG_OTGSC_STATUS_1MS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_STATUS_1MS) & BM_USB_UOG_OTGSC_STATUS_1MS)

/*! @brief Set the STATUS_1MS field to a new value. */
#define BW_USB_UOG_OTGSC_STATUS_1MS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_STATUS_1MS) | BF_USB_UOG_OTGSC_STATUS_1MS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field DPIS[22] (RW)
 *
 * Data Pulse Interrupt Status - Read/Write to Clear. This bit is set when data
 * bus pulsing occurs on DP or DM. Data bus pulsing is only detected when
 * USBMODE.CM = Host (11) and PORTSC1(0)[PP] = 0. Software must write a one to clear
 * this bit.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_DPIS (22U)        /*!< Bit position for USB_UOG_OTGSC_DPIS. */
#define BM_USB_UOG_OTGSC_DPIS (0x00400000U) /*!< Bit mask for USB_UOG_OTGSC_DPIS. */
#define BS_USB_UOG_OTGSC_DPIS (1U)         /*!< Bit field size in bits for USB_UOG_OTGSC_DPIS. */

/*! @brief Read current value of the USB_UOG_OTGSC_DPIS field. */
#define BR_USB_UOG_OTGSC_DPIS(x) (HW_USB_UOG_OTGSC(x).B.DPIS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_DPIS. */
#define BF_USB_UOG_OTGSC_DPIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_DPIS) & BM_USB_UOG_OTGSC_DPIS)

/*! @brief Set the DPIS field to a new value. */
#define BW_USB_UOG_OTGSC_DPIS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_DPIS) | BF_USB_UOG_OTGSC_DPIS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field IDIE[24] (RW)
 *
 * USB ID Interrupt Enable - Read/Write. Setting this bit enables the USB ID
 * interrupt.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_IDIE (24U)        /*!< Bit position for USB_UOG_OTGSC_IDIE. */
#define BM_USB_UOG_OTGSC_IDIE (0x01000000U) /*!< Bit mask for USB_UOG_OTGSC_IDIE. */
#define BS_USB_UOG_OTGSC_IDIE (1U)         /*!< Bit field size in bits for USB_UOG_OTGSC_IDIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_IDIE field. */
#define BR_USB_UOG_OTGSC_IDIE(x) (HW_USB_UOG_OTGSC(x).B.IDIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_IDIE. */
#define BF_USB_UOG_OTGSC_IDIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_IDIE) & BM_USB_UOG_OTGSC_IDIE)

/*! @brief Set the IDIE field to a new value. */
#define BW_USB_UOG_OTGSC_IDIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_IDIE) | BF_USB_UOG_OTGSC_IDIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field AVVIE[25] (RW)
 *
 * A VBus Valid Interrupt Enable - Read/Write. Setting this bit enables the A
 * VBus valid interrupt.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_AVVIE (25U)       /*!< Bit position for USB_UOG_OTGSC_AVVIE. */
#define BM_USB_UOG_OTGSC_AVVIE (0x02000000U) /*!< Bit mask for USB_UOG_OTGSC_AVVIE. */
#define BS_USB_UOG_OTGSC_AVVIE (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_AVVIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_AVVIE field. */
#define BR_USB_UOG_OTGSC_AVVIE(x) (HW_USB_UOG_OTGSC(x).B.AVVIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_AVVIE. */
#define BF_USB_UOG_OTGSC_AVVIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_AVVIE) & BM_USB_UOG_OTGSC_AVVIE)

/*! @brief Set the AVVIE field to a new value. */
#define BW_USB_UOG_OTGSC_AVVIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_AVVIE) | BF_USB_UOG_OTGSC_AVVIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field ASVIE[26] (RW)
 *
 * A Session Valid Interrupt Enable - Read/Write. Setting this bit enables the A
 * session valid interrupt.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_ASVIE (26U)       /*!< Bit position for USB_UOG_OTGSC_ASVIE. */
#define BM_USB_UOG_OTGSC_ASVIE (0x04000000U) /*!< Bit mask for USB_UOG_OTGSC_ASVIE. */
#define BS_USB_UOG_OTGSC_ASVIE (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_ASVIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_ASVIE field. */
#define BR_USB_UOG_OTGSC_ASVIE(x) (HW_USB_UOG_OTGSC(x).B.ASVIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_ASVIE. */
#define BF_USB_UOG_OTGSC_ASVIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_ASVIE) & BM_USB_UOG_OTGSC_ASVIE)

/*! @brief Set the ASVIE field to a new value. */
#define BW_USB_UOG_OTGSC_ASVIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_ASVIE) | BF_USB_UOG_OTGSC_ASVIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSVIE[27] (RW)
 *
 * B Session Valid Interrupt Enable - Read/Write. Setting this bit enables the B
 * session valid interrupt.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSVIE (27U)       /*!< Bit position for USB_UOG_OTGSC_BSVIE. */
#define BM_USB_UOG_OTGSC_BSVIE (0x08000000U) /*!< Bit mask for USB_UOG_OTGSC_BSVIE. */
#define BS_USB_UOG_OTGSC_BSVIE (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_BSVIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSVIE field. */
#define BR_USB_UOG_OTGSC_BSVIE(x) (HW_USB_UOG_OTGSC(x).B.BSVIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_BSVIE. */
#define BF_USB_UOG_OTGSC_BSVIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_BSVIE) & BM_USB_UOG_OTGSC_BSVIE)

/*! @brief Set the BSVIE field to a new value. */
#define BW_USB_UOG_OTGSC_BSVIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_BSVIE) | BF_USB_UOG_OTGSC_BSVIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field BSEIE[28] (RW)
 *
 * B Session End Interrupt Enable - Read/Write. Setting this bit enables the B
 * session end interrupt.
 */
/*@{*/
#define BP_USB_UOG_OTGSC_BSEIE (28U)       /*!< Bit position for USB_UOG_OTGSC_BSEIE. */
#define BM_USB_UOG_OTGSC_BSEIE (0x10000000U) /*!< Bit mask for USB_UOG_OTGSC_BSEIE. */
#define BS_USB_UOG_OTGSC_BSEIE (1U)        /*!< Bit field size in bits for USB_UOG_OTGSC_BSEIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_BSEIE field. */
#define BR_USB_UOG_OTGSC_BSEIE(x) (HW_USB_UOG_OTGSC(x).B.BSEIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_BSEIE. */
#define BF_USB_UOG_OTGSC_BSEIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_BSEIE) & BM_USB_UOG_OTGSC_BSEIE)

/*! @brief Set the BSEIE field to a new value. */
#define BW_USB_UOG_OTGSC_BSEIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_BSEIE) | BF_USB_UOG_OTGSC_BSEIE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field EN_1MS[29] (RW)
 *
 * 1 millisecond timer Interrupt Enable - Read/Write
 */
/*@{*/
#define BP_USB_UOG_OTGSC_EN_1MS (29U)      /*!< Bit position for USB_UOG_OTGSC_EN_1MS. */
#define BM_USB_UOG_OTGSC_EN_1MS (0x20000000U) /*!< Bit mask for USB_UOG_OTGSC_EN_1MS. */
#define BS_USB_UOG_OTGSC_EN_1MS (1U)       /*!< Bit field size in bits for USB_UOG_OTGSC_EN_1MS. */

/*! @brief Read current value of the USB_UOG_OTGSC_EN_1MS field. */
#define BR_USB_UOG_OTGSC_EN_1MS(x) (HW_USB_UOG_OTGSC(x).B.EN_1MS)

/*! @brief Format value for bitfield USB_UOG_OTGSC_EN_1MS. */
#define BF_USB_UOG_OTGSC_EN_1MS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_EN_1MS) & BM_USB_UOG_OTGSC_EN_1MS)

/*! @brief Set the EN_1MS field to a new value. */
#define BW_USB_UOG_OTGSC_EN_1MS(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_EN_1MS) | BF_USB_UOG_OTGSC_EN_1MS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_OTGSC, field DPIE[30] (RW)
 *
 * Data Pulse Interrupt Enable
 */
/*@{*/
#define BP_USB_UOG_OTGSC_DPIE (30U)        /*!< Bit position for USB_UOG_OTGSC_DPIE. */
#define BM_USB_UOG_OTGSC_DPIE (0x40000000U) /*!< Bit mask for USB_UOG_OTGSC_DPIE. */
#define BS_USB_UOG_OTGSC_DPIE (1U)         /*!< Bit field size in bits for USB_UOG_OTGSC_DPIE. */

/*! @brief Read current value of the USB_UOG_OTGSC_DPIE field. */
#define BR_USB_UOG_OTGSC_DPIE(x) (HW_USB_UOG_OTGSC(x).B.DPIE)

/*! @brief Format value for bitfield USB_UOG_OTGSC_DPIE. */
#define BF_USB_UOG_OTGSC_DPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_OTGSC_DPIE) & BM_USB_UOG_OTGSC_DPIE)

/*! @brief Set the DPIE field to a new value. */
#define BW_USB_UOG_OTGSC_DPIE(x, v) (HW_USB_UOG_OTGSC_WR(x, (HW_USB_UOG_OTGSC_RD(x) & ~BM_USB_UOG_OTGSC_DPIE) | BF_USB_UOG_OTGSC_DPIE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_USBMODE - USB Device Mode
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_USBMODE - USB Device Mode (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uog_usbmode
{
    uint32_t U;
    struct _hw_usb_uog_usbmode_bitfields
    {
        uint32_t CM : 2;               /*!< [1:0]  */
        uint32_t ES : 1;               /*!< [2]  */
        uint32_t SLOM : 1;             /*!< [3]  */
        uint32_t SDIS : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_usb_uog_usbmode_t;

/*!
 * @name Constants and macros for entire USB_UOG_USBMODE register
 */
/*@{*/
#define HW_USB_UOG_USBMODE_ADDR(x) ((uintptr_t)(x) + 0x1A8U)

#define HW_USB_UOG_USBMODE(x)    (*(__IO hw_usb_uog_usbmode_t *) HW_USB_UOG_USBMODE_ADDR(x))
#define HW_USB_UOG_USBMODE_RD(x) (HW_USB_UOG_USBMODE(x).U)
#define HW_USB_UOG_USBMODE_WR(x, v) (HW_USB_UOG_USBMODE(x).U = (v))
#define HW_USB_UOG_USBMODE_SET(x, v) (HW_USB_UOG_USBMODE_WR(x, HW_USB_UOG_USBMODE_RD(x) |  (v)))
#define HW_USB_UOG_USBMODE_CLR(x, v) (HW_USB_UOG_USBMODE_WR(x, HW_USB_UOG_USBMODE_RD(x) & ~(v)))
#define HW_USB_UOG_USBMODE_TOG(x, v) (HW_USB_UOG_USBMODE_WR(x, HW_USB_UOG_USBMODE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_USBMODE bitfields
 */

/*!
 * @name Register USB_UOG_USBMODE, field CM[1:0] (RW)
 *
 * Controller Mode - R/WO. Controller mode is defaulted to the proper mode for
 * host only and device only implementations. For those designs that contain both
 * host & device capability, the controller defaults to an idle state and needs
 * to be initialized to the desired operating mode after reset. For combination
 * host/device controllers, this register can only be written once after reset. If
 * it is necessary to switch modes, software must reset the controller by writing
 * to the RESET bit in the USBCMD register before reprogramming this register.
 * For OTG controller core, reset value is '00b'. For Host-only controller core,
 * reset value is '11b'.
 *
 * Values:
 * - 00 - Idle [Default for combination host/device]
 * - 01 - Reserved
 * - 10 - Device Controller [Default for device only controller]
 * - 11 - Host Controller [Default for host only controller]
 */
/*@{*/
#define BP_USB_UOG_USBMODE_CM (0U)         /*!< Bit position for USB_UOG_USBMODE_CM. */
#define BM_USB_UOG_USBMODE_CM (0x00000003U) /*!< Bit mask for USB_UOG_USBMODE_CM. */
#define BS_USB_UOG_USBMODE_CM (2U)         /*!< Bit field size in bits for USB_UOG_USBMODE_CM. */

/*! @brief Read current value of the USB_UOG_USBMODE_CM field. */
#define BR_USB_UOG_USBMODE_CM(x) (HW_USB_UOG_USBMODE(x).B.CM)

/*! @brief Format value for bitfield USB_UOG_USBMODE_CM. */
#define BF_USB_UOG_USBMODE_CM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBMODE_CM) & BM_USB_UOG_USBMODE_CM)

/*! @brief Set the CM field to a new value. */
#define BW_USB_UOG_USBMODE_CM(x, v) (HW_USB_UOG_USBMODE_WR(x, (HW_USB_UOG_USBMODE_RD(x) & ~BM_USB_UOG_USBMODE_CM) | BF_USB_UOG_USBMODE_CM(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBMODE, field ES[2] (RW)
 *
 * Endian Select - Read/Write. This bit can change the byte alignment of the
 * transfer buffers to match the host microprocessor. The bit fields in the
 * microprocessor interface and the data structures are unaffected by the value of this
 * bit because they are based upon the 32-bit word. Bit Meaning
 *
 * Values:
 * - 0 - Little Endian [Default]
 * - 1 - Big Endian
 */
/*@{*/
#define BP_USB_UOG_USBMODE_ES (2U)         /*!< Bit position for USB_UOG_USBMODE_ES. */
#define BM_USB_UOG_USBMODE_ES (0x00000004U) /*!< Bit mask for USB_UOG_USBMODE_ES. */
#define BS_USB_UOG_USBMODE_ES (1U)         /*!< Bit field size in bits for USB_UOG_USBMODE_ES. */

/*! @brief Read current value of the USB_UOG_USBMODE_ES field. */
#define BR_USB_UOG_USBMODE_ES(x) (HW_USB_UOG_USBMODE(x).B.ES)

/*! @brief Format value for bitfield USB_UOG_USBMODE_ES. */
#define BF_USB_UOG_USBMODE_ES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBMODE_ES) & BM_USB_UOG_USBMODE_ES)

/*! @brief Set the ES field to a new value. */
#define BW_USB_UOG_USBMODE_ES(x, v) (HW_USB_UOG_USBMODE_WR(x, (HW_USB_UOG_USBMODE_RD(x) & ~BM_USB_UOG_USBMODE_ES) | BF_USB_UOG_USBMODE_ES(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBMODE, field SLOM[3] (RW)
 *
 * Setup Lockout Mode. In device mode, this bit controls behavior of the setup
 * lock mechanism. See Control Endpoint Operation Model .
 *
 * Values:
 * - 0 - Setup Lockouts On (default);
 * - 1 - Setup Lockouts Off (DCD requires use of Setup Data Buffer Tripwire in
 *     USBCMDUSB Command Register .
 */
/*@{*/
#define BP_USB_UOG_USBMODE_SLOM (3U)       /*!< Bit position for USB_UOG_USBMODE_SLOM. */
#define BM_USB_UOG_USBMODE_SLOM (0x00000008U) /*!< Bit mask for USB_UOG_USBMODE_SLOM. */
#define BS_USB_UOG_USBMODE_SLOM (1U)       /*!< Bit field size in bits for USB_UOG_USBMODE_SLOM. */

/*! @brief Read current value of the USB_UOG_USBMODE_SLOM field. */
#define BR_USB_UOG_USBMODE_SLOM(x) (HW_USB_UOG_USBMODE(x).B.SLOM)

/*! @brief Format value for bitfield USB_UOG_USBMODE_SLOM. */
#define BF_USB_UOG_USBMODE_SLOM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBMODE_SLOM) & BM_USB_UOG_USBMODE_SLOM)

/*! @brief Set the SLOM field to a new value. */
#define BW_USB_UOG_USBMODE_SLOM(x, v) (HW_USB_UOG_USBMODE_WR(x, (HW_USB_UOG_USBMODE_RD(x) & ~BM_USB_UOG_USBMODE_SLOM) | BF_USB_UOG_USBMODE_SLOM(v)))
/*@}*/

/*!
 * @name Register USB_UOG_USBMODE, field SDIS[4] (RW)
 *
 * Stream Disable Mode. (0 - Inactive [default]; 1 - Active) Device Mode:
 * Setting to a '1' disables double priming on both RX and TX for low bandwidth
 * systems. This mode ensures that when the RX and TX buffers are sufficient to contain
 * an entire packet that the standard double buffering scheme is disabled to
 * prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode,
 * all packets received are responded to with a NYET handshake when stream
 * disable is active. Host Mode: Setting to a '1' ensures that overruns/underruns of
 * the latency FIFO are eliminated for low bandwidth systems where the RX and TX
 * buffers are sufficient to contain the entire packet. Enabling stream disable
 * also has the effect of ensuring the TX latency is filled to capacity before the
 * packet is launched onto the USB. Time duration to pre-fill the FIFO becomes
 * significant when stream disable is active. See TXFILLTUNINGTX FIFO Fill Tuning
 * and TXTTFILLTUNING [MPH Only] to characterize the adjustments needed for the
 * scheduler when using this feature. The use of this feature substantially limits
 * of the overall USB performance that can be achieved.
 */
/*@{*/
#define BP_USB_UOG_USBMODE_SDIS (4U)       /*!< Bit position for USB_UOG_USBMODE_SDIS. */
#define BM_USB_UOG_USBMODE_SDIS (0x00000010U) /*!< Bit mask for USB_UOG_USBMODE_SDIS. */
#define BS_USB_UOG_USBMODE_SDIS (1U)       /*!< Bit field size in bits for USB_UOG_USBMODE_SDIS. */

/*! @brief Read current value of the USB_UOG_USBMODE_SDIS field. */
#define BR_USB_UOG_USBMODE_SDIS(x) (HW_USB_UOG_USBMODE(x).B.SDIS)

/*! @brief Format value for bitfield USB_UOG_USBMODE_SDIS. */
#define BF_USB_UOG_USBMODE_SDIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_USBMODE_SDIS) & BM_USB_UOG_USBMODE_SDIS)

/*! @brief Set the SDIS field to a new value. */
#define BW_USB_UOG_USBMODE_SDIS(x, v) (HW_USB_UOG_USBMODE_WR(x, (HW_USB_UOG_USBMODE_RD(x) & ~BM_USB_UOG_USBMODE_SDIS) | BF_USB_UOG_USBMODE_SDIS(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTSETUPSTAT - Endpoint Setup Status
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTSETUPSTAT - Endpoint Setup Status (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uog_endptsetupstat
{
    uint32_t U;
    struct _hw_usb_uog_endptsetupstat_bitfields
    {
        uint32_t ENDPTSETUPSTAT : 16;  /*!< [15:0]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uog_endptsetupstat_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTSETUPSTAT register
 */
/*@{*/
#define HW_USB_UOG_ENDPTSETUPSTAT_ADDR(x) ((uintptr_t)(x) + 0x1ACU)

#define HW_USB_UOG_ENDPTSETUPSTAT(x) (*(__IO hw_usb_uog_endptsetupstat_t *) HW_USB_UOG_ENDPTSETUPSTAT_ADDR(x))
#define HW_USB_UOG_ENDPTSETUPSTAT_RD(x) (HW_USB_UOG_ENDPTSETUPSTAT(x).U)
#define HW_USB_UOG_ENDPTSETUPSTAT_WR(x, v) (HW_USB_UOG_ENDPTSETUPSTAT(x).U = (v))
#define HW_USB_UOG_ENDPTSETUPSTAT_SET(x, v) (HW_USB_UOG_ENDPTSETUPSTAT_WR(x, HW_USB_UOG_ENDPTSETUPSTAT_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTSETUPSTAT_CLR(x, v) (HW_USB_UOG_ENDPTSETUPSTAT_WR(x, HW_USB_UOG_ENDPTSETUPSTAT_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTSETUPSTAT_TOG(x, v) (HW_USB_UOG_ENDPTSETUPSTAT_WR(x, HW_USB_UOG_ENDPTSETUPSTAT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTSETUPSTAT bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTSETUPSTAT, field ENDPTSETUPSTAT[15:0] (RW)
 *
 * Setup Endpoint Status. For every setup transaction that is received, a
 * corresponding bit in this register is set to one. Software must clear or acknowledge
 * the setup transfer by writing a one to a respective bit after it has read the
 * setup data from Queue head. The response to a setup packet as in the order of
 * operations and total response time is crucial to limit bus time outs while
 * the setup lock our mechanism is engaged. See Managing EndpointsThe USB 2.0
 * specification defines an endpoint, also called a device endpoint or an address
 * endpoint as a uniquely addressable portion of a USB device that can source or sink
 * data in a communications channel between the host and the device. in the
 * Device Operational Model. This register is only used in device mode.
 */
/*@{*/
#define BP_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT (0U) /*!< Bit position for USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT. */
#define BM_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT (0x0000FFFFU) /*!< Bit mask for USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT. */
#define BS_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT (16U) /*!< Bit field size in bits for USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT. */

/*! @brief Read current value of the USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT field. */
#define BR_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT(x) (HW_USB_UOG_ENDPTSETUPSTAT(x).B.ENDPTSETUPSTAT)

/*! @brief Format value for bitfield USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT. */
#define BF_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT) & BM_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT)

/*! @brief Set the ENDPTSETUPSTAT field to a new value. */
#define BW_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT(x, v) (HW_USB_UOG_ENDPTSETUPSTAT_WR(x, (HW_USB_UOG_ENDPTSETUPSTAT_RD(x) & ~BM_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT) | BF_USB_UOG_ENDPTSETUPSTAT_ENDPTSETUPSTAT(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTPRIME - Endpoint Prime
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTPRIME - Endpoint Prime (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is only used in device mode. When software sets the prime bit
 * for a given endpoint, the device controller loads the transfer descriptor,
 * pointed to by the queue head, such that the endpoint is ready to transmit or
 * receive when the host sends a request (IN/OUT token). The endpoint will NAK all
 * requests from the host until the endpoint is primed. The controller will
 * automatically re-prime the endpoint with a new transfer descriptor when one is found
 * via the next_dtd pointer of the current transfer descriptor. Hence, the prime
 * bit must only be set by software when a descriptor is added to the queue head.
 */
typedef union _hw_usb_uog_endptprime
{
    uint32_t U;
    struct _hw_usb_uog_endptprime_bitfields
    {
        uint32_t PERB : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t PETB : 8;             /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptprime_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTPRIME register
 */
/*@{*/
#define HW_USB_UOG_ENDPTPRIME_ADDR(x) ((uintptr_t)(x) + 0x1B0U)

#define HW_USB_UOG_ENDPTPRIME(x) (*(__IO hw_usb_uog_endptprime_t *) HW_USB_UOG_ENDPTPRIME_ADDR(x))
#define HW_USB_UOG_ENDPTPRIME_RD(x) (HW_USB_UOG_ENDPTPRIME(x).U)
#define HW_USB_UOG_ENDPTPRIME_WR(x, v) (HW_USB_UOG_ENDPTPRIME(x).U = (v))
#define HW_USB_UOG_ENDPTPRIME_SET(x, v) (HW_USB_UOG_ENDPTPRIME_WR(x, HW_USB_UOG_ENDPTPRIME_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTPRIME_CLR(x, v) (HW_USB_UOG_ENDPTPRIME_WR(x, HW_USB_UOG_ENDPTPRIME_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTPRIME_TOG(x, v) (HW_USB_UOG_ENDPTPRIME_WR(x, HW_USB_UOG_ENDPTPRIME_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTPRIME bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTPRIME, field PERB[7:0] (RW)
 *
 * Prime Endpoint Receive Buffer - R/WS. For each endpoint, a corresponding bit
 * is used to request a buffer prepare for a receive operation for when a USB
 * host initiates a USB OUT transaction. Software should write a one to the
 * corresponding bit whenever posting a new transfer descriptor to an endpoint queue
 * head. Hardware automatically uses this bit to begin parsing for a new transfer
 * descriptor from the queue head and prepare a receive buffer. Hardware clears this
 * bit when the associated endpoint(s) is (are) successfully primed. These bits
 * are momentarily set by hardware during hardware re-priming operations when a
 * dTD is retired, and the dQH is updated. PERB[N] - Endpoint #N, N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTPRIME_PERB (0U)    /*!< Bit position for USB_UOG_ENDPTPRIME_PERB. */
#define BM_USB_UOG_ENDPTPRIME_PERB (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTPRIME_PERB. */
#define BS_USB_UOG_ENDPTPRIME_PERB (8U)    /*!< Bit field size in bits for USB_UOG_ENDPTPRIME_PERB. */

/*! @brief Read current value of the USB_UOG_ENDPTPRIME_PERB field. */
#define BR_USB_UOG_ENDPTPRIME_PERB(x) (HW_USB_UOG_ENDPTPRIME(x).B.PERB)

/*! @brief Format value for bitfield USB_UOG_ENDPTPRIME_PERB. */
#define BF_USB_UOG_ENDPTPRIME_PERB(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTPRIME_PERB) & BM_USB_UOG_ENDPTPRIME_PERB)

/*! @brief Set the PERB field to a new value. */
#define BW_USB_UOG_ENDPTPRIME_PERB(x, v) (HW_USB_UOG_ENDPTPRIME_WR(x, (HW_USB_UOG_ENDPTPRIME_RD(x) & ~BM_USB_UOG_ENDPTPRIME_PERB) | BF_USB_UOG_ENDPTPRIME_PERB(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTPRIME, field PETB[23:16] (RW)
 *
 * Prime Endpoint Transmit Buffer - R/WS. For each endpoint a corresponding bit
 * is used to request that a buffer is prepared for a transmit operation in order
 * to respond to a USB IN/INTERRUPT transaction. Software should write a one to
 * the corresponding bit when posting a new transfer descriptor to an endpoint
 * queue head. Hardware automatically uses this bit to begin parsing for a new
 * transfer descriptor from the queue head and prepare a transmit buffer. Hardware
 * clears this bit when the associated endpoint(s) is (are) successfully primed.
 * These bits are momentarily set by hardware during hardware re-priming operations
 * when a dTD is retired, and the dQH is updated. PETB[N] - Endpoint #N, N is in
 * 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTPRIME_PETB (16U)   /*!< Bit position for USB_UOG_ENDPTPRIME_PETB. */
#define BM_USB_UOG_ENDPTPRIME_PETB (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTPRIME_PETB. */
#define BS_USB_UOG_ENDPTPRIME_PETB (8U)    /*!< Bit field size in bits for USB_UOG_ENDPTPRIME_PETB. */

/*! @brief Read current value of the USB_UOG_ENDPTPRIME_PETB field. */
#define BR_USB_UOG_ENDPTPRIME_PETB(x) (HW_USB_UOG_ENDPTPRIME(x).B.PETB)

/*! @brief Format value for bitfield USB_UOG_ENDPTPRIME_PETB. */
#define BF_USB_UOG_ENDPTPRIME_PETB(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTPRIME_PETB) & BM_USB_UOG_ENDPTPRIME_PETB)

/*! @brief Set the PETB field to a new value. */
#define BW_USB_UOG_ENDPTPRIME_PETB(x, v) (HW_USB_UOG_ENDPTPRIME_WR(x, (HW_USB_UOG_ENDPTPRIME_RD(x) & ~BM_USB_UOG_ENDPTPRIME_PETB) | BF_USB_UOG_ENDPTPRIME_PETB(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTFLUSH - Endpoint Flush
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTFLUSH - Endpoint Flush (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is only used in device mode.
 */
typedef union _hw_usb_uog_endptflush
{
    uint32_t U;
    struct _hw_usb_uog_endptflush_bitfields
    {
        uint32_t FERB : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t FETB : 8;             /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptflush_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTFLUSH register
 */
/*@{*/
#define HW_USB_UOG_ENDPTFLUSH_ADDR(x) ((uintptr_t)(x) + 0x1B4U)

#define HW_USB_UOG_ENDPTFLUSH(x) (*(__IO hw_usb_uog_endptflush_t *) HW_USB_UOG_ENDPTFLUSH_ADDR(x))
#define HW_USB_UOG_ENDPTFLUSH_RD(x) (HW_USB_UOG_ENDPTFLUSH(x).U)
#define HW_USB_UOG_ENDPTFLUSH_WR(x, v) (HW_USB_UOG_ENDPTFLUSH(x).U = (v))
#define HW_USB_UOG_ENDPTFLUSH_SET(x, v) (HW_USB_UOG_ENDPTFLUSH_WR(x, HW_USB_UOG_ENDPTFLUSH_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTFLUSH_CLR(x, v) (HW_USB_UOG_ENDPTFLUSH_WR(x, HW_USB_UOG_ENDPTFLUSH_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTFLUSH_TOG(x, v) (HW_USB_UOG_ENDPTFLUSH_WR(x, HW_USB_UOG_ENDPTFLUSH_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTFLUSH bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTFLUSH, field FERB[7:0] (RW)
 *
 * Flush Endpoint Receive Buffer - R/WS. Writing one to a bit(s) causes the
 * assocUOGiated endpoint(s) to clear any primed buffers. If a packet is in progress
 * for one of the associated endpoints, then that transfer continues until
 * completion. Hardware clears this register after the endpoint flush operation is
 * successful. FERB[N] - Endpoint #N, N is in 0..7\
 */
/*@{*/
#define BP_USB_UOG_ENDPTFLUSH_FERB (0U)    /*!< Bit position for USB_UOG_ENDPTFLUSH_FERB. */
#define BM_USB_UOG_ENDPTFLUSH_FERB (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTFLUSH_FERB. */
#define BS_USB_UOG_ENDPTFLUSH_FERB (8U)    /*!< Bit field size in bits for USB_UOG_ENDPTFLUSH_FERB. */

/*! @brief Read current value of the USB_UOG_ENDPTFLUSH_FERB field. */
#define BR_USB_UOG_ENDPTFLUSH_FERB(x) (HW_USB_UOG_ENDPTFLUSH(x).B.FERB)

/*! @brief Format value for bitfield USB_UOG_ENDPTFLUSH_FERB. */
#define BF_USB_UOG_ENDPTFLUSH_FERB(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTFLUSH_FERB) & BM_USB_UOG_ENDPTFLUSH_FERB)

/*! @brief Set the FERB field to a new value. */
#define BW_USB_UOG_ENDPTFLUSH_FERB(x, v) (HW_USB_UOG_ENDPTFLUSH_WR(x, (HW_USB_UOG_ENDPTFLUSH_RD(x) & ~BM_USB_UOG_ENDPTFLUSH_FERB) | BF_USB_UOG_ENDPTFLUSH_FERB(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTFLUSH, field FETB[23:16] (RW)
 *
 * Flush Endpoint Transmit Buffer - R/WS. Writing one to a bit(s) in this
 * register causes the associated endpoint(s) to clear any primed buffers. If a packet
 * is in progress for one of the associated endpoints, then that transfer
 * continues until completion. Hardware clears this register after the endpoint flush
 * operation is successful. FETB[N] - Endpoint #N, N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTFLUSH_FETB (16U)   /*!< Bit position for USB_UOG_ENDPTFLUSH_FETB. */
#define BM_USB_UOG_ENDPTFLUSH_FETB (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTFLUSH_FETB. */
#define BS_USB_UOG_ENDPTFLUSH_FETB (8U)    /*!< Bit field size in bits for USB_UOG_ENDPTFLUSH_FETB. */

/*! @brief Read current value of the USB_UOG_ENDPTFLUSH_FETB field. */
#define BR_USB_UOG_ENDPTFLUSH_FETB(x) (HW_USB_UOG_ENDPTFLUSH(x).B.FETB)

/*! @brief Format value for bitfield USB_UOG_ENDPTFLUSH_FETB. */
#define BF_USB_UOG_ENDPTFLUSH_FETB(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTFLUSH_FETB) & BM_USB_UOG_ENDPTFLUSH_FETB)

/*! @brief Set the FETB field to a new value. */
#define BW_USB_UOG_ENDPTFLUSH_FETB(x, v) (HW_USB_UOG_ENDPTFLUSH_WR(x, (HW_USB_UOG_ENDPTFLUSH_RD(x) & ~BM_USB_UOG_ENDPTFLUSH_FETB) | BF_USB_UOG_ENDPTFLUSH_FETB(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTSTAT - Endpoint Status
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTSTAT - Endpoint Status (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is only used in device mode.
 */
typedef union _hw_usb_uog_endptstat
{
    uint32_t U;
    struct _hw_usb_uog_endptstat_bitfields
    {
        uint32_t ERBR : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t ETBR : 8;             /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptstat_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTSTAT register
 */
/*@{*/
#define HW_USB_UOG_ENDPTSTAT_ADDR(x) ((uintptr_t)(x) + 0x1B8U)

#define HW_USB_UOG_ENDPTSTAT(x)  (*(__I hw_usb_uog_endptstat_t *) HW_USB_UOG_ENDPTSTAT_ADDR(x))
#define HW_USB_UOG_ENDPTSTAT_RD(x) (HW_USB_UOG_ENDPTSTAT(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTSTAT bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTSTAT, field ERBR[7:0] (RO)
 *
 * Endpoint Receive Buffer Ready -- Read Only. One bit for each endpoint
 * indicates status of the respective endpoint buffer. This bit is set to a one by the
 * hardware as a response to receiving a command from a corresponding bit in the
 * ENDPRIME register. There is always a delay between setting a bit in the
 * ENDPRIME register and endpoint indicating ready. This delay time varies based upon
 * the current USB traffic and the number of bits set in the ENDPRIME register.
 * Buffer ready is cleared by USB reset, by the USB DMA system, or through the
 * ENDPTFLUSH register. These bits are momentarily cleared by hardware during hardware
 * endpoint re-priming operations when a dTD is retired, and the dQH is updated.
 * ERBR[N] - Endpoint #N, N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTSTAT_ERBR (0U)     /*!< Bit position for USB_UOG_ENDPTSTAT_ERBR. */
#define BM_USB_UOG_ENDPTSTAT_ERBR (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTSTAT_ERBR. */
#define BS_USB_UOG_ENDPTSTAT_ERBR (8U)     /*!< Bit field size in bits for USB_UOG_ENDPTSTAT_ERBR. */

/*! @brief Read current value of the USB_UOG_ENDPTSTAT_ERBR field. */
#define BR_USB_UOG_ENDPTSTAT_ERBR(x) (HW_USB_UOG_ENDPTSTAT(x).B.ERBR)
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTSTAT, field ETBR[23:16] (RO)
 *
 * Endpoint Transmit Buffer Ready -- Read Only. One bit for each endpoint
 * indicates status of the respective endpoint buffer. This bit is set to one by the
 * hardware as a response to receiving a command from a corresponding bit in the
 * ENDPTPRIME register. There is always a delay between setting a bit in the
 * ENDPTPRIME register and endpoint indicating ready. This delay time varies based upon
 * the current USB traffic and the number of bits set in the ENDPRIME register.
 * Buffer ready is cleared by USB reset, by the USB DMA system, or through the
 * ENDPTFLUSH register. These bits are momentarily cleared by hardware during
 * hardware endpoint re-priming operations when a dTD is retired, and the dQH is
 * updated. ETBR[N] - Endpoint #N, N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTSTAT_ETBR (16U)    /*!< Bit position for USB_UOG_ENDPTSTAT_ETBR. */
#define BM_USB_UOG_ENDPTSTAT_ETBR (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTSTAT_ETBR. */
#define BS_USB_UOG_ENDPTSTAT_ETBR (8U)     /*!< Bit field size in bits for USB_UOG_ENDPTSTAT_ETBR. */

/*! @brief Read current value of the USB_UOG_ENDPTSTAT_ETBR field. */
#define BR_USB_UOG_ENDPTSTAT_ETBR(x) (HW_USB_UOG_ENDPTSTAT(x).B.ETBR)
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCOMPLETE - Endpoint Complete
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCOMPLETE - Endpoint Complete (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is only used in device mode.
 */
typedef union _hw_usb_uog_endptcomplete
{
    uint32_t U;
    struct _hw_usb_uog_endptcomplete_bitfields
    {
        uint32_t ERCE : 8;             /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t ETCE : 8;             /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptcomplete_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCOMPLETE register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCOMPLETE_ADDR(x) ((uintptr_t)(x) + 0x1BCU)

#define HW_USB_UOG_ENDPTCOMPLETE(x) (*(__IO hw_usb_uog_endptcomplete_t *) HW_USB_UOG_ENDPTCOMPLETE_ADDR(x))
#define HW_USB_UOG_ENDPTCOMPLETE_RD(x) (HW_USB_UOG_ENDPTCOMPLETE(x).U)
#define HW_USB_UOG_ENDPTCOMPLETE_WR(x, v) (HW_USB_UOG_ENDPTCOMPLETE(x).U = (v))
#define HW_USB_UOG_ENDPTCOMPLETE_SET(x, v) (HW_USB_UOG_ENDPTCOMPLETE_WR(x, HW_USB_UOG_ENDPTCOMPLETE_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCOMPLETE_CLR(x, v) (HW_USB_UOG_ENDPTCOMPLETE_WR(x, HW_USB_UOG_ENDPTCOMPLETE_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCOMPLETE_TOG(x, v) (HW_USB_UOG_ENDPTCOMPLETE_WR(x, HW_USB_UOG_ENDPTCOMPLETE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCOMPLETE bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCOMPLETE, field ERCE[7:0] (RW)
 *
 * Endpoint Receive Complete Event - RW/C. Each bit indicates a received event
 * (OUT/SETUP) occurred and software should read the corresponding endpoint queue
 * to determine the transfer status. If the corresponding IOC bit is set in the
 * Transfer Descriptor, then this bit is set simultaneously with the USBINT .
 * Writing one clears the corresponding bit in this register. ERCE[N] - Endpoint #N,
 * N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTCOMPLETE_ERCE (0U) /*!< Bit position for USB_UOG_ENDPTCOMPLETE_ERCE. */
#define BM_USB_UOG_ENDPTCOMPLETE_ERCE (0x000000FFU) /*!< Bit mask for USB_UOG_ENDPTCOMPLETE_ERCE. */
#define BS_USB_UOG_ENDPTCOMPLETE_ERCE (8U) /*!< Bit field size in bits for USB_UOG_ENDPTCOMPLETE_ERCE. */

/*! @brief Read current value of the USB_UOG_ENDPTCOMPLETE_ERCE field. */
#define BR_USB_UOG_ENDPTCOMPLETE_ERCE(x) (HW_USB_UOG_ENDPTCOMPLETE(x).B.ERCE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCOMPLETE_ERCE. */
#define BF_USB_UOG_ENDPTCOMPLETE_ERCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCOMPLETE_ERCE) & BM_USB_UOG_ENDPTCOMPLETE_ERCE)

/*! @brief Set the ERCE field to a new value. */
#define BW_USB_UOG_ENDPTCOMPLETE_ERCE(x, v) (HW_USB_UOG_ENDPTCOMPLETE_WR(x, (HW_USB_UOG_ENDPTCOMPLETE_RD(x) & ~BM_USB_UOG_ENDPTCOMPLETE_ERCE) | BF_USB_UOG_ENDPTCOMPLETE_ERCE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCOMPLETE, field ETCE[23:16] (RW)
 *
 * Endpoint Transmit Complete Event - R/WC. Each bit indicates a transmit event
 * (IN/INTERRUPT) occurred and software should read the corresponding endpoint
 * queue to determine the endpoint status. If the corresponding IOC bit is set in
 * the Transfer Descriptor, then this bit is set simultaneously with the USBINT .
 * Writing one clears the corresponding bit in this register. ETCE[N] - Endpoint
 * #N, N is in 0..7
 */
/*@{*/
#define BP_USB_UOG_ENDPTCOMPLETE_ETCE (16U) /*!< Bit position for USB_UOG_ENDPTCOMPLETE_ETCE. */
#define BM_USB_UOG_ENDPTCOMPLETE_ETCE (0x00FF0000U) /*!< Bit mask for USB_UOG_ENDPTCOMPLETE_ETCE. */
#define BS_USB_UOG_ENDPTCOMPLETE_ETCE (8U) /*!< Bit field size in bits for USB_UOG_ENDPTCOMPLETE_ETCE. */

/*! @brief Read current value of the USB_UOG_ENDPTCOMPLETE_ETCE field. */
#define BR_USB_UOG_ENDPTCOMPLETE_ETCE(x) (HW_USB_UOG_ENDPTCOMPLETE(x).B.ETCE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCOMPLETE_ETCE. */
#define BF_USB_UOG_ENDPTCOMPLETE_ETCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCOMPLETE_ETCE) & BM_USB_UOG_ENDPTCOMPLETE_ETCE)

/*! @brief Set the ETCE field to a new value. */
#define BW_USB_UOG_ENDPTCOMPLETE_ETCE(x, v) (HW_USB_UOG_ENDPTCOMPLETE_WR(x, (HW_USB_UOG_ENDPTCOMPLETE_RD(x) & ~BM_USB_UOG_ENDPTCOMPLETE_ETCE) | BF_USB_UOG_ENDPTCOMPLETE_ETCE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL0 - Endpoint Control0
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL0 - Endpoint Control0 (RW)
 *
 * Reset value: 0x00800080U
 *
 * Every Device implements Endpoint 0 as a control endpoint.
 */
typedef union _hw_usb_uog_endptctrl0
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl0_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RESERVED0 : 1;        /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED1 : 3;        /*!< [6:4]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED2 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t RESERVED3 : 1;        /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED4 : 3;        /*!< [22:20]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED5 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl0_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL0 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL0_ADDR(x) ((uintptr_t)(x) + 0x1C0U)

#define HW_USB_UOG_ENDPTCTRL0(x) (*(__IO hw_usb_uog_endptctrl0_t *) HW_USB_UOG_ENDPTCTRL0_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL0_RD(x) (HW_USB_UOG_ENDPTCTRL0(x).U)
#define HW_USB_UOG_ENDPTCTRL0_WR(x, v) (HW_USB_UOG_ENDPTCTRL0(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL0_SET(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, HW_USB_UOG_ENDPTCTRL0_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL0_CLR(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, HW_USB_UOG_ENDPTCTRL0_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL0_TOG(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, HW_USB_UOG_ENDPTCTRL0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL0 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * Software can write a one to this bit to force the endpoint to return a STALL
 * handshake to the Host. It continues returning STALL until the bit is cleared by
 * software or it is automatically cleared upon receipt of a new SETUP request.
 * After receiving a SETUP request, this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. There is a slight
 * delay (50 clocks max.) between the endptsetupstat being cleared and hardware
 * continuing to clear this bit. In most systems it is unlikely the dcd software will
 * observe this delay. However, should the dcd observe that the stall bit is not
 * set after writing a one to it then follow this procedure: continually write
 * this stall bit until it is set or until a newsetup has been received by checking
 * the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL0_RXS. */
#define BM_USB_UOG_ENDPTCTRL0_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL0_RXS. */
#define BS_USB_UOG_ENDPTCTRL0_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_RXS field. */
#define BR_USB_UOG_ENDPTCTRL0_RXS(x) (HW_USB_UOG_ENDPTCTRL0(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_RXS. */
#define BF_USB_UOG_ENDPTCTRL0_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_RXS) & BM_USB_UOG_ENDPTCTRL0_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_RXS(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_RXS) | BF_USB_UOG_ENDPTCTRL0_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control Endpoint0 is fixed as a Control End
 * Point.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL0_RXT. */
#define BM_USB_UOG_ENDPTCTRL0_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL0_RXT. */
#define BS_USB_UOG_ENDPTCTRL0_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_RXT field. */
#define BR_USB_UOG_ENDPTCTRL0_RXT(x) (HW_USB_UOG_ENDPTCTRL0(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_RXT. */
#define BF_USB_UOG_ENDPTCTRL0_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_RXT) & BM_USB_UOG_ENDPTCTRL0_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_RXT(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_RXT) | BF_USB_UOG_ENDPTCTRL0_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field RXE[7] (RW)
 *
 * RX Endpoint Enable 1 Enabled Endpoint0 is always enabled.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL0_RXE. */
#define BM_USB_UOG_ENDPTCTRL0_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL0_RXE. */
#define BS_USB_UOG_ENDPTCTRL0_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_RXE field. */
#define BR_USB_UOG_ENDPTCTRL0_RXE(x) (HW_USB_UOG_ENDPTCTRL0(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_RXE. */
#define BF_USB_UOG_ENDPTCTRL0_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_RXE) & BM_USB_UOG_ENDPTCTRL0_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_RXE(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_RXE) | BF_USB_UOG_ENDPTCTRL0_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK [Default] 1 End Point Stalled
 * Software can write a one to this bit to force the endpoint to return a STALL
 * handshake to the Host. It continues returning STALL until the bit is cleared by
 * software or it is automatically cleared upon receipt of a new SETUP request.
 * After receiving a SETUP request, this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared.There is a slight delay
 * (50 clocks max.) between the endptsetupstat being cleared and hardware
 * continuing to clear this bit. In most systems it is unlikely the DCD software will
 * observe this delay. However, should the dcd observe that the stall bit is not
 * set after writing a one to it then follow this procedure: continually write this
 * stall bit until it is set or until a newsetup has been received by checking
 * the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL0_TXS. */
#define BM_USB_UOG_ENDPTCTRL0_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL0_TXS. */
#define BS_USB_UOG_ENDPTCTRL0_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_TXS field. */
#define BR_USB_UOG_ENDPTCTRL0_TXS(x) (HW_USB_UOG_ENDPTCTRL0(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_TXS. */
#define BF_USB_UOG_ENDPTCTRL0_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_TXS) & BM_USB_UOG_ENDPTCTRL0_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_TXS(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_TXS) | BF_USB_UOG_ENDPTCTRL0_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 - Control Endpoint0 is fixed as a Control
 * End Point.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL0_TXT. */
#define BM_USB_UOG_ENDPTCTRL0_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL0_TXT. */
#define BS_USB_UOG_ENDPTCTRL0_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_TXT field. */
#define BR_USB_UOG_ENDPTCTRL0_TXT(x) (HW_USB_UOG_ENDPTCTRL0(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_TXT. */
#define BF_USB_UOG_ENDPTCTRL0_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_TXT) & BM_USB_UOG_ENDPTCTRL0_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_TXT(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_TXT) | BF_USB_UOG_ENDPTCTRL0_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL0, field TXE[23] (RW)
 *
 * TX Endpoint Enable 1 Enabled Endpoint0 is always enabled.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL0_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL0_TXE. */
#define BM_USB_UOG_ENDPTCTRL0_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL0_TXE. */
#define BS_USB_UOG_ENDPTCTRL0_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL0_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL0_TXE field. */
#define BR_USB_UOG_ENDPTCTRL0_TXE(x) (HW_USB_UOG_ENDPTCTRL0(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL0_TXE. */
#define BF_USB_UOG_ENDPTCTRL0_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL0_TXE) & BM_USB_UOG_ENDPTCTRL0_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL0_TXE(x, v) (HW_USB_UOG_ENDPTCTRL0_WR(x, (HW_USB_UOG_ENDPTCTRL0_RD(x) & ~BM_USB_UOG_ENDPTCTRL0_TXE) | BF_USB_UOG_ENDPTCTRL0_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL1 - Endpoint Control 1
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL1 - Endpoint Control 1 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 1 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl1
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl1_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl1_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL1 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL1_ADDR(x) ((uintptr_t)(x) + 0x1C4U)

#define HW_USB_UOG_ENDPTCTRL1(x) (*(__IO hw_usb_uog_endptctrl1_t *) HW_USB_UOG_ENDPTCTRL1_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL1_RD(x) (HW_USB_UOG_ENDPTCTRL1(x).U)
#define HW_USB_UOG_ENDPTCTRL1_WR(x, v) (HW_USB_UOG_ENDPTCTRL1(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL1_SET(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, HW_USB_UOG_ENDPTCTRL1_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL1_CLR(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, HW_USB_UOG_ENDPTCTRL1_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL1_TOG(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, HW_USB_UOG_ENDPTCTRL1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL1 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXS. */
#define BM_USB_UOG_ENDPTCTRL1_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXS. */
#define BS_USB_UOG_ENDPTCTRL1_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXS field. */
#define BR_USB_UOG_ENDPTCTRL1_RXS(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXS. */
#define BF_USB_UOG_ENDPTCTRL1_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXS) & BM_USB_UOG_ENDPTCTRL1_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXS(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXS) | BF_USB_UOG_ENDPTCTRL1_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXD. */
#define BM_USB_UOG_ENDPTCTRL1_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXD. */
#define BS_USB_UOG_ENDPTCTRL1_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXD field. */
#define BR_USB_UOG_ENDPTCTRL1_RXD(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXD. */
#define BF_USB_UOG_ENDPTCTRL1_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXD) & BM_USB_UOG_ENDPTCTRL1_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXD(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXD) | BF_USB_UOG_ENDPTCTRL1_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXT. */
#define BM_USB_UOG_ENDPTCTRL1_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXT. */
#define BS_USB_UOG_ENDPTCTRL1_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXT field. */
#define BR_USB_UOG_ENDPTCTRL1_RXT(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXT. */
#define BF_USB_UOG_ENDPTCTRL1_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXT) & BM_USB_UOG_ENDPTCTRL1_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXT(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXT) | BF_USB_UOG_ENDPTCTRL1_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXI. */
#define BM_USB_UOG_ENDPTCTRL1_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXI. */
#define BS_USB_UOG_ENDPTCTRL1_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXI field. */
#define BR_USB_UOG_ENDPTCTRL1_RXI(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXI. */
#define BF_USB_UOG_ENDPTCTRL1_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXI) & BM_USB_UOG_ENDPTCTRL1_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXI(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXI) | BF_USB_UOG_ENDPTCTRL1_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXR. */
#define BM_USB_UOG_ENDPTCTRL1_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXR. */
#define BS_USB_UOG_ENDPTCTRL1_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXR field. */
#define BR_USB_UOG_ENDPTCTRL1_RXR(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXR. */
#define BF_USB_UOG_ENDPTCTRL1_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXR) & BM_USB_UOG_ENDPTCTRL1_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXR(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXR) | BF_USB_UOG_ENDPTCTRL1_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL1_RXE. */
#define BM_USB_UOG_ENDPTCTRL1_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_RXE. */
#define BS_USB_UOG_ENDPTCTRL1_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_RXE field. */
#define BR_USB_UOG_ENDPTCTRL1_RXE(x) (HW_USB_UOG_ENDPTCTRL1(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_RXE. */
#define BF_USB_UOG_ENDPTCTRL1_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_RXE) & BM_USB_UOG_ENDPTCTRL1_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_RXE(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_RXE) | BF_USB_UOG_ENDPTCTRL1_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXS. */
#define BM_USB_UOG_ENDPTCTRL1_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXS. */
#define BS_USB_UOG_ENDPTCTRL1_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXS field. */
#define BR_USB_UOG_ENDPTCTRL1_TXS(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXS. */
#define BF_USB_UOG_ENDPTCTRL1_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXS) & BM_USB_UOG_ENDPTCTRL1_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXS(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXS) | BF_USB_UOG_ENDPTCTRL1_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXD. */
#define BM_USB_UOG_ENDPTCTRL1_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXD. */
#define BS_USB_UOG_ENDPTCTRL1_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXD field. */
#define BR_USB_UOG_ENDPTCTRL1_TXD(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXD. */
#define BF_USB_UOG_ENDPTCTRL1_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXD) & BM_USB_UOG_ENDPTCTRL1_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXD(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXD) | BF_USB_UOG_ENDPTCTRL1_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXT. */
#define BM_USB_UOG_ENDPTCTRL1_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXT. */
#define BS_USB_UOG_ENDPTCTRL1_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXT field. */
#define BR_USB_UOG_ENDPTCTRL1_TXT(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXT. */
#define BF_USB_UOG_ENDPTCTRL1_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXT) & BM_USB_UOG_ENDPTCTRL1_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXT(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXT) | BF_USB_UOG_ENDPTCTRL1_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXI. */
#define BM_USB_UOG_ENDPTCTRL1_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXI. */
#define BS_USB_UOG_ENDPTCTRL1_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXI field. */
#define BR_USB_UOG_ENDPTCTRL1_TXI(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXI. */
#define BF_USB_UOG_ENDPTCTRL1_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXI) & BM_USB_UOG_ENDPTCTRL1_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXI(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXI) | BF_USB_UOG_ENDPTCTRL1_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXR. */
#define BM_USB_UOG_ENDPTCTRL1_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXR. */
#define BS_USB_UOG_ENDPTCTRL1_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXR field. */
#define BR_USB_UOG_ENDPTCTRL1_TXR(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXR. */
#define BF_USB_UOG_ENDPTCTRL1_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXR) & BM_USB_UOG_ENDPTCTRL1_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXR(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXR) | BF_USB_UOG_ENDPTCTRL1_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL1, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL1_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL1_TXE. */
#define BM_USB_UOG_ENDPTCTRL1_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL1_TXE. */
#define BS_USB_UOG_ENDPTCTRL1_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL1_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL1_TXE field. */
#define BR_USB_UOG_ENDPTCTRL1_TXE(x) (HW_USB_UOG_ENDPTCTRL1(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL1_TXE. */
#define BF_USB_UOG_ENDPTCTRL1_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL1_TXE) & BM_USB_UOG_ENDPTCTRL1_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL1_TXE(x, v) (HW_USB_UOG_ENDPTCTRL1_WR(x, (HW_USB_UOG_ENDPTCTRL1_RD(x) & ~BM_USB_UOG_ENDPTCTRL1_TXE) | BF_USB_UOG_ENDPTCTRL1_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL2 - Endpoint Control 2
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL2 - Endpoint Control 2 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 2 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl2
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl2_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl2_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL2 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL2_ADDR(x) ((uintptr_t)(x) + 0x1C8U)

#define HW_USB_UOG_ENDPTCTRL2(x) (*(__IO hw_usb_uog_endptctrl2_t *) HW_USB_UOG_ENDPTCTRL2_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL2_RD(x) (HW_USB_UOG_ENDPTCTRL2(x).U)
#define HW_USB_UOG_ENDPTCTRL2_WR(x, v) (HW_USB_UOG_ENDPTCTRL2(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL2_SET(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, HW_USB_UOG_ENDPTCTRL2_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL2_CLR(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, HW_USB_UOG_ENDPTCTRL2_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL2_TOG(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, HW_USB_UOG_ENDPTCTRL2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL2 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXS. */
#define BM_USB_UOG_ENDPTCTRL2_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXS. */
#define BS_USB_UOG_ENDPTCTRL2_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXS field. */
#define BR_USB_UOG_ENDPTCTRL2_RXS(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXS. */
#define BF_USB_UOG_ENDPTCTRL2_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXS) & BM_USB_UOG_ENDPTCTRL2_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXS(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXS) | BF_USB_UOG_ENDPTCTRL2_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXD. */
#define BM_USB_UOG_ENDPTCTRL2_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXD. */
#define BS_USB_UOG_ENDPTCTRL2_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXD field. */
#define BR_USB_UOG_ENDPTCTRL2_RXD(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXD. */
#define BF_USB_UOG_ENDPTCTRL2_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXD) & BM_USB_UOG_ENDPTCTRL2_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXD(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXD) | BF_USB_UOG_ENDPTCTRL2_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXT. */
#define BM_USB_UOG_ENDPTCTRL2_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXT. */
#define BS_USB_UOG_ENDPTCTRL2_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXT field. */
#define BR_USB_UOG_ENDPTCTRL2_RXT(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXT. */
#define BF_USB_UOG_ENDPTCTRL2_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXT) & BM_USB_UOG_ENDPTCTRL2_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXT(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXT) | BF_USB_UOG_ENDPTCTRL2_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXI. */
#define BM_USB_UOG_ENDPTCTRL2_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXI. */
#define BS_USB_UOG_ENDPTCTRL2_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXI field. */
#define BR_USB_UOG_ENDPTCTRL2_RXI(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXI. */
#define BF_USB_UOG_ENDPTCTRL2_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXI) & BM_USB_UOG_ENDPTCTRL2_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXI(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXI) | BF_USB_UOG_ENDPTCTRL2_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXR. */
#define BM_USB_UOG_ENDPTCTRL2_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXR. */
#define BS_USB_UOG_ENDPTCTRL2_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXR field. */
#define BR_USB_UOG_ENDPTCTRL2_RXR(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXR. */
#define BF_USB_UOG_ENDPTCTRL2_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXR) & BM_USB_UOG_ENDPTCTRL2_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXR(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXR) | BF_USB_UOG_ENDPTCTRL2_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL2_RXE. */
#define BM_USB_UOG_ENDPTCTRL2_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_RXE. */
#define BS_USB_UOG_ENDPTCTRL2_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_RXE field. */
#define BR_USB_UOG_ENDPTCTRL2_RXE(x) (HW_USB_UOG_ENDPTCTRL2(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_RXE. */
#define BF_USB_UOG_ENDPTCTRL2_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_RXE) & BM_USB_UOG_ENDPTCTRL2_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_RXE(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_RXE) | BF_USB_UOG_ENDPTCTRL2_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXS. */
#define BM_USB_UOG_ENDPTCTRL2_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXS. */
#define BS_USB_UOG_ENDPTCTRL2_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXS field. */
#define BR_USB_UOG_ENDPTCTRL2_TXS(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXS. */
#define BF_USB_UOG_ENDPTCTRL2_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXS) & BM_USB_UOG_ENDPTCTRL2_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXS(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXS) | BF_USB_UOG_ENDPTCTRL2_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXD. */
#define BM_USB_UOG_ENDPTCTRL2_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXD. */
#define BS_USB_UOG_ENDPTCTRL2_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXD field. */
#define BR_USB_UOG_ENDPTCTRL2_TXD(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXD. */
#define BF_USB_UOG_ENDPTCTRL2_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXD) & BM_USB_UOG_ENDPTCTRL2_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXD(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXD) | BF_USB_UOG_ENDPTCTRL2_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXT. */
#define BM_USB_UOG_ENDPTCTRL2_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXT. */
#define BS_USB_UOG_ENDPTCTRL2_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXT field. */
#define BR_USB_UOG_ENDPTCTRL2_TXT(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXT. */
#define BF_USB_UOG_ENDPTCTRL2_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXT) & BM_USB_UOG_ENDPTCTRL2_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXT(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXT) | BF_USB_UOG_ENDPTCTRL2_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXI. */
#define BM_USB_UOG_ENDPTCTRL2_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXI. */
#define BS_USB_UOG_ENDPTCTRL2_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXI field. */
#define BR_USB_UOG_ENDPTCTRL2_TXI(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXI. */
#define BF_USB_UOG_ENDPTCTRL2_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXI) & BM_USB_UOG_ENDPTCTRL2_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXI(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXI) | BF_USB_UOG_ENDPTCTRL2_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXR. */
#define BM_USB_UOG_ENDPTCTRL2_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXR. */
#define BS_USB_UOG_ENDPTCTRL2_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXR field. */
#define BR_USB_UOG_ENDPTCTRL2_TXR(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXR. */
#define BF_USB_UOG_ENDPTCTRL2_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXR) & BM_USB_UOG_ENDPTCTRL2_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXR(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXR) | BF_USB_UOG_ENDPTCTRL2_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL2, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL2_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL2_TXE. */
#define BM_USB_UOG_ENDPTCTRL2_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL2_TXE. */
#define BS_USB_UOG_ENDPTCTRL2_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL2_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL2_TXE field. */
#define BR_USB_UOG_ENDPTCTRL2_TXE(x) (HW_USB_UOG_ENDPTCTRL2(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL2_TXE. */
#define BF_USB_UOG_ENDPTCTRL2_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL2_TXE) & BM_USB_UOG_ENDPTCTRL2_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL2_TXE(x, v) (HW_USB_UOG_ENDPTCTRL2_WR(x, (HW_USB_UOG_ENDPTCTRL2_RD(x) & ~BM_USB_UOG_ENDPTCTRL2_TXE) | BF_USB_UOG_ENDPTCTRL2_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL3 - Endpoint Control 3
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL3 - Endpoint Control 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 3 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl3
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl3_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl3_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL3 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL3_ADDR(x) ((uintptr_t)(x) + 0x1CCU)

#define HW_USB_UOG_ENDPTCTRL3(x) (*(__IO hw_usb_uog_endptctrl3_t *) HW_USB_UOG_ENDPTCTRL3_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL3_RD(x) (HW_USB_UOG_ENDPTCTRL3(x).U)
#define HW_USB_UOG_ENDPTCTRL3_WR(x, v) (HW_USB_UOG_ENDPTCTRL3(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL3_SET(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, HW_USB_UOG_ENDPTCTRL3_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL3_CLR(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, HW_USB_UOG_ENDPTCTRL3_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL3_TOG(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, HW_USB_UOG_ENDPTCTRL3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL3 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXS. */
#define BM_USB_UOG_ENDPTCTRL3_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXS. */
#define BS_USB_UOG_ENDPTCTRL3_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXS field. */
#define BR_USB_UOG_ENDPTCTRL3_RXS(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXS. */
#define BF_USB_UOG_ENDPTCTRL3_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXS) & BM_USB_UOG_ENDPTCTRL3_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXS(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXS) | BF_USB_UOG_ENDPTCTRL3_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXD. */
#define BM_USB_UOG_ENDPTCTRL3_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXD. */
#define BS_USB_UOG_ENDPTCTRL3_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXD field. */
#define BR_USB_UOG_ENDPTCTRL3_RXD(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXD. */
#define BF_USB_UOG_ENDPTCTRL3_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXD) & BM_USB_UOG_ENDPTCTRL3_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXD(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXD) | BF_USB_UOG_ENDPTCTRL3_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXT. */
#define BM_USB_UOG_ENDPTCTRL3_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXT. */
#define BS_USB_UOG_ENDPTCTRL3_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXT field. */
#define BR_USB_UOG_ENDPTCTRL3_RXT(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXT. */
#define BF_USB_UOG_ENDPTCTRL3_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXT) & BM_USB_UOG_ENDPTCTRL3_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXT(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXT) | BF_USB_UOG_ENDPTCTRL3_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXI. */
#define BM_USB_UOG_ENDPTCTRL3_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXI. */
#define BS_USB_UOG_ENDPTCTRL3_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXI field. */
#define BR_USB_UOG_ENDPTCTRL3_RXI(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXI. */
#define BF_USB_UOG_ENDPTCTRL3_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXI) & BM_USB_UOG_ENDPTCTRL3_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXI(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXI) | BF_USB_UOG_ENDPTCTRL3_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXR. */
#define BM_USB_UOG_ENDPTCTRL3_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXR. */
#define BS_USB_UOG_ENDPTCTRL3_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXR field. */
#define BR_USB_UOG_ENDPTCTRL3_RXR(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXR. */
#define BF_USB_UOG_ENDPTCTRL3_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXR) & BM_USB_UOG_ENDPTCTRL3_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXR(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXR) | BF_USB_UOG_ENDPTCTRL3_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL3_RXE. */
#define BM_USB_UOG_ENDPTCTRL3_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_RXE. */
#define BS_USB_UOG_ENDPTCTRL3_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_RXE field. */
#define BR_USB_UOG_ENDPTCTRL3_RXE(x) (HW_USB_UOG_ENDPTCTRL3(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_RXE. */
#define BF_USB_UOG_ENDPTCTRL3_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_RXE) & BM_USB_UOG_ENDPTCTRL3_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_RXE(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_RXE) | BF_USB_UOG_ENDPTCTRL3_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXS. */
#define BM_USB_UOG_ENDPTCTRL3_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXS. */
#define BS_USB_UOG_ENDPTCTRL3_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXS field. */
#define BR_USB_UOG_ENDPTCTRL3_TXS(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXS. */
#define BF_USB_UOG_ENDPTCTRL3_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXS) & BM_USB_UOG_ENDPTCTRL3_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXS(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXS) | BF_USB_UOG_ENDPTCTRL3_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXD. */
#define BM_USB_UOG_ENDPTCTRL3_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXD. */
#define BS_USB_UOG_ENDPTCTRL3_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXD field. */
#define BR_USB_UOG_ENDPTCTRL3_TXD(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXD. */
#define BF_USB_UOG_ENDPTCTRL3_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXD) & BM_USB_UOG_ENDPTCTRL3_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXD(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXD) | BF_USB_UOG_ENDPTCTRL3_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXT. */
#define BM_USB_UOG_ENDPTCTRL3_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXT. */
#define BS_USB_UOG_ENDPTCTRL3_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXT field. */
#define BR_USB_UOG_ENDPTCTRL3_TXT(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXT. */
#define BF_USB_UOG_ENDPTCTRL3_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXT) & BM_USB_UOG_ENDPTCTRL3_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXT(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXT) | BF_USB_UOG_ENDPTCTRL3_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXI. */
#define BM_USB_UOG_ENDPTCTRL3_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXI. */
#define BS_USB_UOG_ENDPTCTRL3_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXI field. */
#define BR_USB_UOG_ENDPTCTRL3_TXI(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXI. */
#define BF_USB_UOG_ENDPTCTRL3_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXI) & BM_USB_UOG_ENDPTCTRL3_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXI(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXI) | BF_USB_UOG_ENDPTCTRL3_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXR. */
#define BM_USB_UOG_ENDPTCTRL3_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXR. */
#define BS_USB_UOG_ENDPTCTRL3_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXR field. */
#define BR_USB_UOG_ENDPTCTRL3_TXR(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXR. */
#define BF_USB_UOG_ENDPTCTRL3_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXR) & BM_USB_UOG_ENDPTCTRL3_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXR(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXR) | BF_USB_UOG_ENDPTCTRL3_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL3, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL3_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL3_TXE. */
#define BM_USB_UOG_ENDPTCTRL3_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL3_TXE. */
#define BS_USB_UOG_ENDPTCTRL3_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL3_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL3_TXE field. */
#define BR_USB_UOG_ENDPTCTRL3_TXE(x) (HW_USB_UOG_ENDPTCTRL3(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL3_TXE. */
#define BF_USB_UOG_ENDPTCTRL3_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL3_TXE) & BM_USB_UOG_ENDPTCTRL3_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL3_TXE(x, v) (HW_USB_UOG_ENDPTCTRL3_WR(x, (HW_USB_UOG_ENDPTCTRL3_RD(x) & ~BM_USB_UOG_ENDPTCTRL3_TXE) | BF_USB_UOG_ENDPTCTRL3_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL4 - Endpoint Control 4
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL4 - Endpoint Control 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 4 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl4
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl4_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl4_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL4 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL4_ADDR(x) ((uintptr_t)(x) + 0x1D0U)

#define HW_USB_UOG_ENDPTCTRL4(x) (*(__IO hw_usb_uog_endptctrl4_t *) HW_USB_UOG_ENDPTCTRL4_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL4_RD(x) (HW_USB_UOG_ENDPTCTRL4(x).U)
#define HW_USB_UOG_ENDPTCTRL4_WR(x, v) (HW_USB_UOG_ENDPTCTRL4(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL4_SET(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, HW_USB_UOG_ENDPTCTRL4_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL4_CLR(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, HW_USB_UOG_ENDPTCTRL4_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL4_TOG(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, HW_USB_UOG_ENDPTCTRL4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL4 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXS. */
#define BM_USB_UOG_ENDPTCTRL4_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXS. */
#define BS_USB_UOG_ENDPTCTRL4_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXS field. */
#define BR_USB_UOG_ENDPTCTRL4_RXS(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXS. */
#define BF_USB_UOG_ENDPTCTRL4_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXS) & BM_USB_UOG_ENDPTCTRL4_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXS(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXS) | BF_USB_UOG_ENDPTCTRL4_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXD. */
#define BM_USB_UOG_ENDPTCTRL4_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXD. */
#define BS_USB_UOG_ENDPTCTRL4_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXD field. */
#define BR_USB_UOG_ENDPTCTRL4_RXD(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXD. */
#define BF_USB_UOG_ENDPTCTRL4_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXD) & BM_USB_UOG_ENDPTCTRL4_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXD(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXD) | BF_USB_UOG_ENDPTCTRL4_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXT. */
#define BM_USB_UOG_ENDPTCTRL4_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXT. */
#define BS_USB_UOG_ENDPTCTRL4_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXT field. */
#define BR_USB_UOG_ENDPTCTRL4_RXT(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXT. */
#define BF_USB_UOG_ENDPTCTRL4_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXT) & BM_USB_UOG_ENDPTCTRL4_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXT(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXT) | BF_USB_UOG_ENDPTCTRL4_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXI. */
#define BM_USB_UOG_ENDPTCTRL4_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXI. */
#define BS_USB_UOG_ENDPTCTRL4_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXI field. */
#define BR_USB_UOG_ENDPTCTRL4_RXI(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXI. */
#define BF_USB_UOG_ENDPTCTRL4_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXI) & BM_USB_UOG_ENDPTCTRL4_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXI(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXI) | BF_USB_UOG_ENDPTCTRL4_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXR. */
#define BM_USB_UOG_ENDPTCTRL4_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXR. */
#define BS_USB_UOG_ENDPTCTRL4_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXR field. */
#define BR_USB_UOG_ENDPTCTRL4_RXR(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXR. */
#define BF_USB_UOG_ENDPTCTRL4_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXR) & BM_USB_UOG_ENDPTCTRL4_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXR(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXR) | BF_USB_UOG_ENDPTCTRL4_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL4_RXE. */
#define BM_USB_UOG_ENDPTCTRL4_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_RXE. */
#define BS_USB_UOG_ENDPTCTRL4_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_RXE field. */
#define BR_USB_UOG_ENDPTCTRL4_RXE(x) (HW_USB_UOG_ENDPTCTRL4(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_RXE. */
#define BF_USB_UOG_ENDPTCTRL4_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_RXE) & BM_USB_UOG_ENDPTCTRL4_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_RXE(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_RXE) | BF_USB_UOG_ENDPTCTRL4_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXS. */
#define BM_USB_UOG_ENDPTCTRL4_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXS. */
#define BS_USB_UOG_ENDPTCTRL4_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXS field. */
#define BR_USB_UOG_ENDPTCTRL4_TXS(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXS. */
#define BF_USB_UOG_ENDPTCTRL4_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXS) & BM_USB_UOG_ENDPTCTRL4_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXS(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXS) | BF_USB_UOG_ENDPTCTRL4_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXD. */
#define BM_USB_UOG_ENDPTCTRL4_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXD. */
#define BS_USB_UOG_ENDPTCTRL4_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXD field. */
#define BR_USB_UOG_ENDPTCTRL4_TXD(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXD. */
#define BF_USB_UOG_ENDPTCTRL4_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXD) & BM_USB_UOG_ENDPTCTRL4_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXD(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXD) | BF_USB_UOG_ENDPTCTRL4_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXT. */
#define BM_USB_UOG_ENDPTCTRL4_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXT. */
#define BS_USB_UOG_ENDPTCTRL4_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXT field. */
#define BR_USB_UOG_ENDPTCTRL4_TXT(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXT. */
#define BF_USB_UOG_ENDPTCTRL4_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXT) & BM_USB_UOG_ENDPTCTRL4_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXT(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXT) | BF_USB_UOG_ENDPTCTRL4_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXI. */
#define BM_USB_UOG_ENDPTCTRL4_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXI. */
#define BS_USB_UOG_ENDPTCTRL4_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXI field. */
#define BR_USB_UOG_ENDPTCTRL4_TXI(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXI. */
#define BF_USB_UOG_ENDPTCTRL4_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXI) & BM_USB_UOG_ENDPTCTRL4_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXI(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXI) | BF_USB_UOG_ENDPTCTRL4_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXR. */
#define BM_USB_UOG_ENDPTCTRL4_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXR. */
#define BS_USB_UOG_ENDPTCTRL4_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXR field. */
#define BR_USB_UOG_ENDPTCTRL4_TXR(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXR. */
#define BF_USB_UOG_ENDPTCTRL4_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXR) & BM_USB_UOG_ENDPTCTRL4_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXR(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXR) | BF_USB_UOG_ENDPTCTRL4_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL4, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL4_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL4_TXE. */
#define BM_USB_UOG_ENDPTCTRL4_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL4_TXE. */
#define BS_USB_UOG_ENDPTCTRL4_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL4_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL4_TXE field. */
#define BR_USB_UOG_ENDPTCTRL4_TXE(x) (HW_USB_UOG_ENDPTCTRL4(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL4_TXE. */
#define BF_USB_UOG_ENDPTCTRL4_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL4_TXE) & BM_USB_UOG_ENDPTCTRL4_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL4_TXE(x, v) (HW_USB_UOG_ENDPTCTRL4_WR(x, (HW_USB_UOG_ENDPTCTRL4_RD(x) & ~BM_USB_UOG_ENDPTCTRL4_TXE) | BF_USB_UOG_ENDPTCTRL4_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL5 - Endpoint Control 5
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL5 - Endpoint Control 5 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 5 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl5
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl5_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl5_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL5 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL5_ADDR(x) ((uintptr_t)(x) + 0x1D4U)

#define HW_USB_UOG_ENDPTCTRL5(x) (*(__IO hw_usb_uog_endptctrl5_t *) HW_USB_UOG_ENDPTCTRL5_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL5_RD(x) (HW_USB_UOG_ENDPTCTRL5(x).U)
#define HW_USB_UOG_ENDPTCTRL5_WR(x, v) (HW_USB_UOG_ENDPTCTRL5(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL5_SET(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, HW_USB_UOG_ENDPTCTRL5_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL5_CLR(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, HW_USB_UOG_ENDPTCTRL5_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL5_TOG(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, HW_USB_UOG_ENDPTCTRL5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL5 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXS. */
#define BM_USB_UOG_ENDPTCTRL5_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXS. */
#define BS_USB_UOG_ENDPTCTRL5_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXS field. */
#define BR_USB_UOG_ENDPTCTRL5_RXS(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXS. */
#define BF_USB_UOG_ENDPTCTRL5_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXS) & BM_USB_UOG_ENDPTCTRL5_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXS(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXS) | BF_USB_UOG_ENDPTCTRL5_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXD. */
#define BM_USB_UOG_ENDPTCTRL5_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXD. */
#define BS_USB_UOG_ENDPTCTRL5_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXD field. */
#define BR_USB_UOG_ENDPTCTRL5_RXD(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXD. */
#define BF_USB_UOG_ENDPTCTRL5_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXD) & BM_USB_UOG_ENDPTCTRL5_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXD(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXD) | BF_USB_UOG_ENDPTCTRL5_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXT. */
#define BM_USB_UOG_ENDPTCTRL5_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXT. */
#define BS_USB_UOG_ENDPTCTRL5_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXT field. */
#define BR_USB_UOG_ENDPTCTRL5_RXT(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXT. */
#define BF_USB_UOG_ENDPTCTRL5_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXT) & BM_USB_UOG_ENDPTCTRL5_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXT(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXT) | BF_USB_UOG_ENDPTCTRL5_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXI. */
#define BM_USB_UOG_ENDPTCTRL5_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXI. */
#define BS_USB_UOG_ENDPTCTRL5_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXI field. */
#define BR_USB_UOG_ENDPTCTRL5_RXI(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXI. */
#define BF_USB_UOG_ENDPTCTRL5_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXI) & BM_USB_UOG_ENDPTCTRL5_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXI(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXI) | BF_USB_UOG_ENDPTCTRL5_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXR. */
#define BM_USB_UOG_ENDPTCTRL5_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXR. */
#define BS_USB_UOG_ENDPTCTRL5_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXR field. */
#define BR_USB_UOG_ENDPTCTRL5_RXR(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXR. */
#define BF_USB_UOG_ENDPTCTRL5_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXR) & BM_USB_UOG_ENDPTCTRL5_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXR(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXR) | BF_USB_UOG_ENDPTCTRL5_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL5_RXE. */
#define BM_USB_UOG_ENDPTCTRL5_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_RXE. */
#define BS_USB_UOG_ENDPTCTRL5_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_RXE field. */
#define BR_USB_UOG_ENDPTCTRL5_RXE(x) (HW_USB_UOG_ENDPTCTRL5(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_RXE. */
#define BF_USB_UOG_ENDPTCTRL5_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_RXE) & BM_USB_UOG_ENDPTCTRL5_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_RXE(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_RXE) | BF_USB_UOG_ENDPTCTRL5_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXS. */
#define BM_USB_UOG_ENDPTCTRL5_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXS. */
#define BS_USB_UOG_ENDPTCTRL5_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXS field. */
#define BR_USB_UOG_ENDPTCTRL5_TXS(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXS. */
#define BF_USB_UOG_ENDPTCTRL5_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXS) & BM_USB_UOG_ENDPTCTRL5_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXS(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXS) | BF_USB_UOG_ENDPTCTRL5_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXD. */
#define BM_USB_UOG_ENDPTCTRL5_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXD. */
#define BS_USB_UOG_ENDPTCTRL5_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXD field. */
#define BR_USB_UOG_ENDPTCTRL5_TXD(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXD. */
#define BF_USB_UOG_ENDPTCTRL5_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXD) & BM_USB_UOG_ENDPTCTRL5_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXD(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXD) | BF_USB_UOG_ENDPTCTRL5_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXT. */
#define BM_USB_UOG_ENDPTCTRL5_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXT. */
#define BS_USB_UOG_ENDPTCTRL5_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXT field. */
#define BR_USB_UOG_ENDPTCTRL5_TXT(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXT. */
#define BF_USB_UOG_ENDPTCTRL5_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXT) & BM_USB_UOG_ENDPTCTRL5_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXT(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXT) | BF_USB_UOG_ENDPTCTRL5_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXI. */
#define BM_USB_UOG_ENDPTCTRL5_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXI. */
#define BS_USB_UOG_ENDPTCTRL5_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXI field. */
#define BR_USB_UOG_ENDPTCTRL5_TXI(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXI. */
#define BF_USB_UOG_ENDPTCTRL5_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXI) & BM_USB_UOG_ENDPTCTRL5_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXI(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXI) | BF_USB_UOG_ENDPTCTRL5_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXR. */
#define BM_USB_UOG_ENDPTCTRL5_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXR. */
#define BS_USB_UOG_ENDPTCTRL5_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXR field. */
#define BR_USB_UOG_ENDPTCTRL5_TXR(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXR. */
#define BF_USB_UOG_ENDPTCTRL5_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXR) & BM_USB_UOG_ENDPTCTRL5_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXR(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXR) | BF_USB_UOG_ENDPTCTRL5_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL5, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL5_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL5_TXE. */
#define BM_USB_UOG_ENDPTCTRL5_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL5_TXE. */
#define BS_USB_UOG_ENDPTCTRL5_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL5_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL5_TXE field. */
#define BR_USB_UOG_ENDPTCTRL5_TXE(x) (HW_USB_UOG_ENDPTCTRL5(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL5_TXE. */
#define BF_USB_UOG_ENDPTCTRL5_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL5_TXE) & BM_USB_UOG_ENDPTCTRL5_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL5_TXE(x, v) (HW_USB_UOG_ENDPTCTRL5_WR(x, (HW_USB_UOG_ENDPTCTRL5_RD(x) & ~BM_USB_UOG_ENDPTCTRL5_TXE) | BF_USB_UOG_ENDPTCTRL5_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL6 - Endpoint Control 6
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL6 - Endpoint Control 6 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 6 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl6
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl6_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl6_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL6 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL6_ADDR(x) ((uintptr_t)(x) + 0x1D8U)

#define HW_USB_UOG_ENDPTCTRL6(x) (*(__IO hw_usb_uog_endptctrl6_t *) HW_USB_UOG_ENDPTCTRL6_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL6_RD(x) (HW_USB_UOG_ENDPTCTRL6(x).U)
#define HW_USB_UOG_ENDPTCTRL6_WR(x, v) (HW_USB_UOG_ENDPTCTRL6(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL6_SET(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, HW_USB_UOG_ENDPTCTRL6_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL6_CLR(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, HW_USB_UOG_ENDPTCTRL6_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL6_TOG(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, HW_USB_UOG_ENDPTCTRL6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL6 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXS. */
#define BM_USB_UOG_ENDPTCTRL6_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXS. */
#define BS_USB_UOG_ENDPTCTRL6_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXS field. */
#define BR_USB_UOG_ENDPTCTRL6_RXS(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXS. */
#define BF_USB_UOG_ENDPTCTRL6_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXS) & BM_USB_UOG_ENDPTCTRL6_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXS(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXS) | BF_USB_UOG_ENDPTCTRL6_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXD. */
#define BM_USB_UOG_ENDPTCTRL6_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXD. */
#define BS_USB_UOG_ENDPTCTRL6_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXD field. */
#define BR_USB_UOG_ENDPTCTRL6_RXD(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXD. */
#define BF_USB_UOG_ENDPTCTRL6_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXD) & BM_USB_UOG_ENDPTCTRL6_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXD(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXD) | BF_USB_UOG_ENDPTCTRL6_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXT. */
#define BM_USB_UOG_ENDPTCTRL6_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXT. */
#define BS_USB_UOG_ENDPTCTRL6_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXT field. */
#define BR_USB_UOG_ENDPTCTRL6_RXT(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXT. */
#define BF_USB_UOG_ENDPTCTRL6_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXT) & BM_USB_UOG_ENDPTCTRL6_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXT(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXT) | BF_USB_UOG_ENDPTCTRL6_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXI. */
#define BM_USB_UOG_ENDPTCTRL6_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXI. */
#define BS_USB_UOG_ENDPTCTRL6_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXI field. */
#define BR_USB_UOG_ENDPTCTRL6_RXI(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXI. */
#define BF_USB_UOG_ENDPTCTRL6_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXI) & BM_USB_UOG_ENDPTCTRL6_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXI(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXI) | BF_USB_UOG_ENDPTCTRL6_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXR. */
#define BM_USB_UOG_ENDPTCTRL6_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXR. */
#define BS_USB_UOG_ENDPTCTRL6_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXR field. */
#define BR_USB_UOG_ENDPTCTRL6_RXR(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXR. */
#define BF_USB_UOG_ENDPTCTRL6_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXR) & BM_USB_UOG_ENDPTCTRL6_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXR(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXR) | BF_USB_UOG_ENDPTCTRL6_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL6_RXE. */
#define BM_USB_UOG_ENDPTCTRL6_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_RXE. */
#define BS_USB_UOG_ENDPTCTRL6_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_RXE field. */
#define BR_USB_UOG_ENDPTCTRL6_RXE(x) (HW_USB_UOG_ENDPTCTRL6(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_RXE. */
#define BF_USB_UOG_ENDPTCTRL6_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_RXE) & BM_USB_UOG_ENDPTCTRL6_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_RXE(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_RXE) | BF_USB_UOG_ENDPTCTRL6_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXS. */
#define BM_USB_UOG_ENDPTCTRL6_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXS. */
#define BS_USB_UOG_ENDPTCTRL6_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXS field. */
#define BR_USB_UOG_ENDPTCTRL6_TXS(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXS. */
#define BF_USB_UOG_ENDPTCTRL6_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXS) & BM_USB_UOG_ENDPTCTRL6_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXS(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXS) | BF_USB_UOG_ENDPTCTRL6_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXD. */
#define BM_USB_UOG_ENDPTCTRL6_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXD. */
#define BS_USB_UOG_ENDPTCTRL6_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXD field. */
#define BR_USB_UOG_ENDPTCTRL6_TXD(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXD. */
#define BF_USB_UOG_ENDPTCTRL6_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXD) & BM_USB_UOG_ENDPTCTRL6_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXD(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXD) | BF_USB_UOG_ENDPTCTRL6_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXT. */
#define BM_USB_UOG_ENDPTCTRL6_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXT. */
#define BS_USB_UOG_ENDPTCTRL6_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXT field. */
#define BR_USB_UOG_ENDPTCTRL6_TXT(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXT. */
#define BF_USB_UOG_ENDPTCTRL6_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXT) & BM_USB_UOG_ENDPTCTRL6_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXT(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXT) | BF_USB_UOG_ENDPTCTRL6_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXI. */
#define BM_USB_UOG_ENDPTCTRL6_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXI. */
#define BS_USB_UOG_ENDPTCTRL6_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXI field. */
#define BR_USB_UOG_ENDPTCTRL6_TXI(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXI. */
#define BF_USB_UOG_ENDPTCTRL6_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXI) & BM_USB_UOG_ENDPTCTRL6_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXI(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXI) | BF_USB_UOG_ENDPTCTRL6_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXR. */
#define BM_USB_UOG_ENDPTCTRL6_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXR. */
#define BS_USB_UOG_ENDPTCTRL6_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXR field. */
#define BR_USB_UOG_ENDPTCTRL6_TXR(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXR. */
#define BF_USB_UOG_ENDPTCTRL6_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXR) & BM_USB_UOG_ENDPTCTRL6_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXR(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXR) | BF_USB_UOG_ENDPTCTRL6_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL6, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL6_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL6_TXE. */
#define BM_USB_UOG_ENDPTCTRL6_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL6_TXE. */
#define BS_USB_UOG_ENDPTCTRL6_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL6_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL6_TXE field. */
#define BR_USB_UOG_ENDPTCTRL6_TXE(x) (HW_USB_UOG_ENDPTCTRL6(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL6_TXE. */
#define BF_USB_UOG_ENDPTCTRL6_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL6_TXE) & BM_USB_UOG_ENDPTCTRL6_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL6_TXE(x, v) (HW_USB_UOG_ENDPTCTRL6_WR(x, (HW_USB_UOG_ENDPTCTRL6_RD(x) & ~BM_USB_UOG_ENDPTCTRL6_TXE) | BF_USB_UOG_ENDPTCTRL6_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UOG_ENDPTCTRL7 - Endpoint Control 7
 ******************************************************************************/

/*!
 * @brief HW_USB_UOG_ENDPTCTRL7 - Endpoint Control 7 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is endpoint control register for endpoint 7 in device operation mode. If
 * one endpoint direction is enabled and the paired endpoint of opposite
 * direction is disabled then the unused direction type must be changed from the default
 * control-type to any other type (that is Bulk-type). leaving an unconfigured
 * endpoint control causes undefined behavior for the data pid tracking on the
 * active endpoint/direction.
 */
typedef union _hw_usb_uog_endptctrl7
{
    uint32_t U;
    struct _hw_usb_uog_endptctrl7_bitfields
    {
        uint32_t RXS : 1;              /*!< [0]  */
        uint32_t RXD : 1;              /*!< [1]  */
        uint32_t RXT : 2;              /*!< [3:2]  */
        uint32_t RESERVED0 : 1;        /*!< [4]  */
        uint32_t RXI : 1;              /*!< [5]  */
        uint32_t RXR : 1;              /*!< [6]  */
        uint32_t RXE : 1;              /*!< [7]  */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t TXS : 1;              /*!< [16]  */
        uint32_t TXD : 1;              /*!< [17]  */
        uint32_t TXT : 2;              /*!< [19:18]  */
        uint32_t RESERVED2 : 1;        /*!< [20]  */
        uint32_t TXI : 1;              /*!< [21]  */
        uint32_t TXR : 1;              /*!< [22]  */
        uint32_t TXE : 1;              /*!< [23]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uog_endptctrl7_t;

/*!
 * @name Constants and macros for entire USB_UOG_ENDPTCTRL7 register
 */
/*@{*/
#define HW_USB_UOG_ENDPTCTRL7_ADDR(x) ((uintptr_t)(x) + 0x1DCU)

#define HW_USB_UOG_ENDPTCTRL7(x) (*(__IO hw_usb_uog_endptctrl7_t *) HW_USB_UOG_ENDPTCTRL7_ADDR(x))
#define HW_USB_UOG_ENDPTCTRL7_RD(x) (HW_USB_UOG_ENDPTCTRL7(x).U)
#define HW_USB_UOG_ENDPTCTRL7_WR(x, v) (HW_USB_UOG_ENDPTCTRL7(x).U = (v))
#define HW_USB_UOG_ENDPTCTRL7_SET(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, HW_USB_UOG_ENDPTCTRL7_RD(x) |  (v)))
#define HW_USB_UOG_ENDPTCTRL7_CLR(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, HW_USB_UOG_ENDPTCTRL7_RD(x) & ~(v)))
#define HW_USB_UOG_ENDPTCTRL7_TOG(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, HW_USB_UOG_ENDPTCTRL7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UOG_ENDPTCTRL7 bitfields
 */

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXS[0] (RW)
 *
 * RX Endpoint Stall - Read/Write 0 End Point OK. [Default] 1 End Point Stalled
 * This bit is set automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpointand this bit will continue to be cleared
 * by hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or
 * until a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXS (0U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXS. */
#define BM_USB_UOG_ENDPTCTRL7_RXS (0x00000001U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXS. */
#define BS_USB_UOG_ENDPTCTRL7_RXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXS field. */
#define BR_USB_UOG_ENDPTCTRL7_RXS(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXS. */
#define BF_USB_UOG_ENDPTCTRL7_RXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXS) & BM_USB_UOG_ENDPTCTRL7_RXS)

/*! @brief Set the RXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXS(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXS) | BF_USB_UOG_ENDPTCTRL7_RXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXD[1] (RW)
 *
 * RX Endpoint Data Sink - Read/Write - TBD 0 Dual Port Memory Buffer/DMA Engine
 * [Default] Should always be written as zero.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXD (1U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXD. */
#define BM_USB_UOG_ENDPTCTRL7_RXD (0x00000002U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXD. */
#define BS_USB_UOG_ENDPTCTRL7_RXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXD field. */
#define BR_USB_UOG_ENDPTCTRL7_RXD(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXD. */
#define BF_USB_UOG_ENDPTCTRL7_RXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXD) & BM_USB_UOG_ENDPTCTRL7_RXD)

/*! @brief Set the RXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXD(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXD) | BF_USB_UOG_ENDPTCTRL7_RXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXT[3:2] (RW)
 *
 * RX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Reserved
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXT (2U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXT. */
#define BM_USB_UOG_ENDPTCTRL7_RXT (0x0000000CU) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXT. */
#define BS_USB_UOG_ENDPTCTRL7_RXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXT field. */
#define BR_USB_UOG_ENDPTCTRL7_RXT(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXT. */
#define BF_USB_UOG_ENDPTCTRL7_RXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXT) & BM_USB_UOG_ENDPTCTRL7_RXT)

/*! @brief Set the RXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXT(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXT) | BF_USB_UOG_ENDPTCTRL7_RXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXI[5] (RW)
 *
 * RX Data Toggle Inhibit 0 Disabled [Default] 1 Enabled This bit is only used
 * for test and should always be written as zero. Writing a one to this bit causes
 * this endpoint to ignore the data toggle sequence and always accept data
 * packet regardless of their data PID.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXI (5U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXI. */
#define BM_USB_UOG_ENDPTCTRL7_RXI (0x00000020U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXI. */
#define BS_USB_UOG_ENDPTCTRL7_RXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXI field. */
#define BR_USB_UOG_ENDPTCTRL7_RXI(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXI. */
#define BF_USB_UOG_ENDPTCTRL7_RXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXI) & BM_USB_UOG_ENDPTCTRL7_RXI)

/*! @brief Set the RXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXI(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXI) | BF_USB_UOG_ENDPTCTRL7_RXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXR[6] (RW)
 *
 * RX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXR (6U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXR. */
#define BM_USB_UOG_ENDPTCTRL7_RXR (0x00000040U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXR. */
#define BS_USB_UOG_ENDPTCTRL7_RXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXR field. */
#define BR_USB_UOG_ENDPTCTRL7_RXR(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXR. */
#define BF_USB_UOG_ENDPTCTRL7_RXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXR) & BM_USB_UOG_ENDPTCTRL7_RXR)

/*! @brief Set the RXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXR(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXR) | BF_USB_UOG_ENDPTCTRL7_RXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field RXE[7] (RW)
 *
 * RX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_RXE (7U)     /*!< Bit position for USB_UOG_ENDPTCTRL7_RXE. */
#define BM_USB_UOG_ENDPTCTRL7_RXE (0x00000080U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_RXE. */
#define BS_USB_UOG_ENDPTCTRL7_RXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_RXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_RXE field. */
#define BR_USB_UOG_ENDPTCTRL7_RXE(x) (HW_USB_UOG_ENDPTCTRL7(x).B.RXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_RXE. */
#define BF_USB_UOG_ENDPTCTRL7_RXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_RXE) & BM_USB_UOG_ENDPTCTRL7_RXE)

/*! @brief Set the RXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_RXE(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_RXE) | BF_USB_UOG_ENDPTCTRL7_RXE(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXS[16] (RW)
 *
 * TX Endpoint Stall - Read/Write 0 End Point OK 1 End Point Stalled This bit
 * will be cleared automatically upon receipt of a SETUP request if this Endpoint
 * is configured as a Control Endpoint and this bit will continue to be cleared by
 * hardware until the associated ENDPTSETUPSTAT bit is cleared. Software can
 * write a one to this bit to force the endpoint to return a STALL handshake to the
 * Host. This control will continue to STALL until this bit is either cleared by
 * software or automatically cleared as above for control endpoints. [CONTROL
 * ENDPOINT TYPES ONLY]: there is a slight delay (50 clocks max) between the
 * ENDPTSETUPSTAT begin cleared and hardware continuing to clear this bit. In most
 * systems, it is unlikely the DCD software will observe this delay. However, should
 * the DCD observe that the stall bit is not set after writing a one to it then
 * follow this procedure: continually write this stall bit until it is set or until
 * a new setup has been received by checking the associated endptsetupstat bit.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXS (16U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXS. */
#define BM_USB_UOG_ENDPTCTRL7_TXS (0x00010000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXS. */
#define BS_USB_UOG_ENDPTCTRL7_TXS (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXS. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXS field. */
#define BR_USB_UOG_ENDPTCTRL7_TXS(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXS)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXS. */
#define BF_USB_UOG_ENDPTCTRL7_TXS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXS) & BM_USB_UOG_ENDPTCTRL7_TXS)

/*! @brief Set the TXS field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXS(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXS) | BF_USB_UOG_ENDPTCTRL7_TXS(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXD[17] (RW)
 *
 * TX Endpoint Data Source - Read/Write 0 Dual Port Memory Buffer/DMA Engine
 * [DEFAULT] Should always be written as 0.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXD (17U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXD. */
#define BM_USB_UOG_ENDPTCTRL7_TXD (0x00020000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXD. */
#define BS_USB_UOG_ENDPTCTRL7_TXD (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXD. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXD field. */
#define BR_USB_UOG_ENDPTCTRL7_TXD(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXD)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXD. */
#define BF_USB_UOG_ENDPTCTRL7_TXD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXD) & BM_USB_UOG_ENDPTCTRL7_TXD)

/*! @brief Set the TXD field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXD(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXD) | BF_USB_UOG_ENDPTCTRL7_TXD(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXT[19:18] (RW)
 *
 * TX Endpoint Type - Read/Write 00 Control 01 Isochronous 10 Bulk 11 Interrupt
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXT (18U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXT. */
#define BM_USB_UOG_ENDPTCTRL7_TXT (0x000C0000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXT. */
#define BS_USB_UOG_ENDPTCTRL7_TXT (2U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXT. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXT field. */
#define BR_USB_UOG_ENDPTCTRL7_TXT(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXT)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXT. */
#define BF_USB_UOG_ENDPTCTRL7_TXT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXT) & BM_USB_UOG_ENDPTCTRL7_TXT)

/*! @brief Set the TXT field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXT(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXT) | BF_USB_UOG_ENDPTCTRL7_TXT(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXI[21] (RW)
 *
 * TX Data Toggle Inhibit 0 PID Sequencing Enabled. [Default] 1 PID Sequencing
 * Disabled. This bit is only used for test and should always be written as zero.
 * Writing a one to this bit causes this endpoint to ignore the data toggle
 * sequence and always transmit DATA0 for a data packet.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXI (21U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXI. */
#define BM_USB_UOG_ENDPTCTRL7_TXI (0x00200000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXI. */
#define BS_USB_UOG_ENDPTCTRL7_TXI (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXI. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXI field. */
#define BR_USB_UOG_ENDPTCTRL7_TXI(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXI)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXI. */
#define BF_USB_UOG_ENDPTCTRL7_TXI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXI) & BM_USB_UOG_ENDPTCTRL7_TXI)

/*! @brief Set the TXI field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXI(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXI) | BF_USB_UOG_ENDPTCTRL7_TXI(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXR[22] (RW)
 *
 * TX Data Toggle Reset (WS) Write 1 - Reset PID Sequence Whenever a
 * configuration event is received for this Endpoint, software must write a one to this bit
 * in order to synchronize the data PID's between the Host and device.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXR (22U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXR. */
#define BM_USB_UOG_ENDPTCTRL7_TXR (0x00400000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXR. */
#define BS_USB_UOG_ENDPTCTRL7_TXR (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXR. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXR field. */
#define BR_USB_UOG_ENDPTCTRL7_TXR(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXR)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXR. */
#define BF_USB_UOG_ENDPTCTRL7_TXR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXR) & BM_USB_UOG_ENDPTCTRL7_TXR)

/*! @brief Set the TXR field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXR(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXR) | BF_USB_UOG_ENDPTCTRL7_TXR(v)))
/*@}*/

/*!
 * @name Register USB_UOG_ENDPTCTRL7, field TXE[23] (RW)
 *
 * TX Endpoint Enable 0 Disabled [Default] 1 Enabled An Endpoint should be
 * enabled only after it has been configured.
 */
/*@{*/
#define BP_USB_UOG_ENDPTCTRL7_TXE (23U)    /*!< Bit position for USB_UOG_ENDPTCTRL7_TXE. */
#define BM_USB_UOG_ENDPTCTRL7_TXE (0x00800000U) /*!< Bit mask for USB_UOG_ENDPTCTRL7_TXE. */
#define BS_USB_UOG_ENDPTCTRL7_TXE (1U)     /*!< Bit field size in bits for USB_UOG_ENDPTCTRL7_TXE. */

/*! @brief Read current value of the USB_UOG_ENDPTCTRL7_TXE field. */
#define BR_USB_UOG_ENDPTCTRL7_TXE(x) (HW_USB_UOG_ENDPTCTRL7(x).B.TXE)

/*! @brief Format value for bitfield USB_UOG_ENDPTCTRL7_TXE. */
#define BF_USB_UOG_ENDPTCTRL7_TXE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UOG_ENDPTCTRL7_TXE) & BM_USB_UOG_ENDPTCTRL7_TXE)

/*! @brief Set the TXE field to a new value. */
#define BW_USB_UOG_ENDPTCTRL7_TXE(x, v) (HW_USB_UOG_ENDPTCTRL7_WR(x, (HW_USB_UOG_ENDPTCTRL7_RD(x) & ~BM_USB_UOG_ENDPTCTRL7_TXE) | BF_USB_UOG_ENDPTCTRL7_TXE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_ID - Identification register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_ID - Identification register (RO)
 *
 * Reset value: 0xE401FA05U
 *
 * The ID register identifies the USB 2.0 High-Speed core and its revision.
 */
typedef union _hw_usb_uh1_id
{
    uint32_t U;
    struct _hw_usb_uh1_id_bitfields
    {
        uint32_t ID : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t NID : 6;              /*!< [13:8]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t REVISION : 8;         /*!< [23:16]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh1_id_t;

/*!
 * @name Constants and macros for entire USB_UH1_ID register
 */
/*@{*/
#define HW_USB_UH1_ID_ADDR(x)    ((uintptr_t)(x) + 0x200U)

#define HW_USB_UH1_ID(x)         (*(__I hw_usb_uh1_id_t *) HW_USB_UH1_ID_ADDR(x))
#define HW_USB_UH1_ID_RD(x)      (HW_USB_UH1_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_ID bitfields
 */

/*!
 * @name Register USB_UH1_ID, field ID[5:0] (RO)
 *
 * Configuration number. This number is set to 0x05 and indicates that the
 * peripheral is USB 2.0 High-Speed core.
 */
/*@{*/
#define BP_USB_UH1_ID_ID     (0U)          /*!< Bit position for USB_UH1_ID_ID. */
#define BM_USB_UH1_ID_ID     (0x0000003FU) /*!< Bit mask for USB_UH1_ID_ID. */
#define BS_USB_UH1_ID_ID     (6U)          /*!< Bit field size in bits for USB_UH1_ID_ID. */

/*! @brief Read current value of the USB_UH1_ID_ID field. */
#define BR_USB_UH1_ID_ID(x)  (HW_USB_UH1_ID(x).B.ID)
/*@}*/

/*!
 * @name Register USB_UH1_ID, field NID[13:8] (RO)
 *
 * Complement version of ID
 */
/*@{*/
#define BP_USB_UH1_ID_NID    (8U)          /*!< Bit position for USB_UH1_ID_NID. */
#define BM_USB_UH1_ID_NID    (0x00003F00U) /*!< Bit mask for USB_UH1_ID_NID. */
#define BS_USB_UH1_ID_NID    (6U)          /*!< Bit field size in bits for USB_UH1_ID_NID. */

/*! @brief Read current value of the USB_UH1_ID_NID field. */
#define BR_USB_UH1_ID_NID(x) (HW_USB_UH1_ID(x).B.NID)
/*@}*/

/*!
 * @name Register USB_UH1_ID, field REVISION[23:16] (RO)
 *
 * Revision number of the controller core.
 */
/*@{*/
#define BP_USB_UH1_ID_REVISION (16U)       /*!< Bit position for USB_UH1_ID_REVISION. */
#define BM_USB_UH1_ID_REVISION (0x00FF0000U) /*!< Bit mask for USB_UH1_ID_REVISION. */
#define BS_USB_UH1_ID_REVISION (8U)        /*!< Bit field size in bits for USB_UH1_ID_REVISION. */

/*! @brief Read current value of the USB_UH1_ID_REVISION field. */
#define BR_USB_UH1_ID_REVISION(x) (HW_USB_UH1_ID(x).B.REVISION)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HWGENERAL - Hardware General
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HWGENERAL - Hardware General (RO)
 *
 * Reset value: 0x00000015U
 *
 * General hardware parameters as defined in System Level Issues and Core
 * Configuration. The reset value could vary from instance to instance. Please see the
 * detail in bit field description and ignore reset value in summary table in
 * this case!
 */
typedef union _hw_usb_uh1_hwgeneral
{
    uint32_t U;
    struct _hw_usb_uh1_hwgeneral_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t PHYW : 2;             /*!< [5:4]  */
        uint32_t PHYM : 3;             /*!< [8:6]  */
        uint32_t SM : 2;               /*!< [10:9]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_usb_uh1_hwgeneral_t;

/*!
 * @name Constants and macros for entire USB_UH1_HWGENERAL register
 */
/*@{*/
#define HW_USB_UH1_HWGENERAL_ADDR(x) ((uintptr_t)(x) + 0x204U)

#define HW_USB_UH1_HWGENERAL(x)  (*(__I hw_usb_uh1_hwgeneral_t *) HW_USB_UH1_HWGENERAL_ADDR(x))
#define HW_USB_UH1_HWGENERAL_RD(x) (HW_USB_UH1_HWGENERAL(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HWGENERAL bitfields
 */

/*!
 * @name Register USB_UH1_HWGENERAL, field PHYW[5:4] (RO)
 *
 * Data width of the transciever connected to the controller core. PHYW bit
 * reset value is PHYW bit reset value is '01b'.
 *
 * Values:
 * - 00 - 8 bit wide data bus Software non-programmable
 * - 01 - 16 bit wide data bus Software non-programmable
 * - 10 - Reset to 8 bit wide data bus Software programmable
 * - 11 - Reset to 16 bit wide data bus Software programmable
 */
/*@{*/
#define BP_USB_UH1_HWGENERAL_PHYW (4U)     /*!< Bit position for USB_UH1_HWGENERAL_PHYW. */
#define BM_USB_UH1_HWGENERAL_PHYW (0x00000030U) /*!< Bit mask for USB_UH1_HWGENERAL_PHYW. */
#define BS_USB_UH1_HWGENERAL_PHYW (2U)     /*!< Bit field size in bits for USB_UH1_HWGENERAL_PHYW. */

/*! @brief Read current value of the USB_UH1_HWGENERAL_PHYW field. */
#define BR_USB_UH1_HWGENERAL_PHYW(x) (HW_USB_UH1_HWGENERAL(x).B.PHYW)
/*@}*/

/*!
 * @name Register USB_UH1_HWGENERAL, field PHYM[8:6] (RO)
 *
 * Transciever type PHYM bit reset value: '0000b' for OTG controller core,
 * '0100b' for Host-only controller core.
 *
 * Values:
 * - 000 - UTMI/UMTI+
 * - 001 - ULPI DDR
 * - 010 - ULPI
 * - 011 - Serial Only
 * - 100 - Software programmable - reset to UTMI/UTMI+
 * - 101 - Software programmable - reset to ULPI DDR
 * - 110 - Software programmable - reset to ULPI
 * - 111 - Software programmable - reset to Serial
 */
/*@{*/
#define BP_USB_UH1_HWGENERAL_PHYM (6U)     /*!< Bit position for USB_UH1_HWGENERAL_PHYM. */
#define BM_USB_UH1_HWGENERAL_PHYM (0x000001C0U) /*!< Bit mask for USB_UH1_HWGENERAL_PHYM. */
#define BS_USB_UH1_HWGENERAL_PHYM (3U)     /*!< Bit field size in bits for USB_UH1_HWGENERAL_PHYM. */

/*! @brief Read current value of the USB_UH1_HWGENERAL_PHYM field. */
#define BR_USB_UH1_HWGENERAL_PHYM(x) (HW_USB_UH1_HWGENERAL(x).B.PHYM)
/*@}*/

/*!
 * @name Register USB_UH1_HWGENERAL, field SM[10:9] (RO)
 *
 * Serial interface mode capability SM bit reset value is '00b'
 *
 * Values:
 * - 00 - No Serial Engine, always use parallel signalling.
 * - 01 - Serial Engine present, always use serial signalling for FS/LS.
 * - 10 - Software programmable - Reset to use parallel signalling for FS/LS
 * - 11 - Software programmable - Reset to use serial signalling for FS/LS
 */
/*@{*/
#define BP_USB_UH1_HWGENERAL_SM (9U)       /*!< Bit position for USB_UH1_HWGENERAL_SM. */
#define BM_USB_UH1_HWGENERAL_SM (0x00000600U) /*!< Bit mask for USB_UH1_HWGENERAL_SM. */
#define BS_USB_UH1_HWGENERAL_SM (2U)       /*!< Bit field size in bits for USB_UH1_HWGENERAL_SM. */

/*! @brief Read current value of the USB_UH1_HWGENERAL_SM field. */
#define BR_USB_UH1_HWGENERAL_SM(x) (HW_USB_UH1_HWGENERAL(x).B.SM)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HWHOST - Host Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HWHOST - Host Hardware Parameters (RO)
 *
 * Reset value: 0x10020001U
 */
typedef union _hw_usb_uh1_hwhost
{
    uint32_t U;
    struct _hw_usb_uh1_hwhost_bitfields
    {
        uint32_t HC : 1;               /*!< [0]  */
        uint32_t NPORT : 3;            /*!< [3:1]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_uh1_hwhost_t;

/*!
 * @name Constants and macros for entire USB_UH1_HWHOST register
 */
/*@{*/
#define HW_USB_UH1_HWHOST_ADDR(x) ((uintptr_t)(x) + 0x208U)

#define HW_USB_UH1_HWHOST(x)     (*(__I hw_usb_uh1_hwhost_t *) HW_USB_UH1_HWHOST_ADDR(x))
#define HW_USB_UH1_HWHOST_RD(x)  (HW_USB_UH1_HWHOST(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HWHOST bitfields
 */

/*!
 * @name Register USB_UH1_HWHOST, field HC[0] (RO)
 *
 * Host Capable. Indicating whether host operation mode is supported or not.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_USB_UH1_HWHOST_HC (0U)          /*!< Bit position for USB_UH1_HWHOST_HC. */
#define BM_USB_UH1_HWHOST_HC (0x00000001U) /*!< Bit mask for USB_UH1_HWHOST_HC. */
#define BS_USB_UH1_HWHOST_HC (1U)          /*!< Bit field size in bits for USB_UH1_HWHOST_HC. */

/*! @brief Read current value of the USB_UH1_HWHOST_HC field. */
#define BR_USB_UH1_HWHOST_HC(x) (HW_USB_UH1_HWHOST(x).B.HC)
/*@}*/

/*!
 * @name Register USB_UH1_HWHOST, field NPORT[3:1] (RO)
 *
 * The Nmber of downstream ports supported by the host controller is (NPORT+1).
 * When these bits value is '000', it indicates a single-port host controller.
 */
/*@{*/
#define BP_USB_UH1_HWHOST_NPORT (1U)       /*!< Bit position for USB_UH1_HWHOST_NPORT. */
#define BM_USB_UH1_HWHOST_NPORT (0x0000000EU) /*!< Bit mask for USB_UH1_HWHOST_NPORT. */
#define BS_USB_UH1_HWHOST_NPORT (3U)       /*!< Bit field size in bits for USB_UH1_HWHOST_NPORT. */

/*! @brief Read current value of the USB_UH1_HWHOST_NPORT field. */
#define BR_USB_UH1_HWHOST_NPORT(x) (HW_USB_UH1_HWHOST(x).B.NPORT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HWTXBUF - TX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HWTXBUF - TX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x80080B08U
 */
typedef union _hw_usb_uh1_hwtxbuf
{
    uint32_t U;
    struct _hw_usb_uh1_hwtxbuf_bitfields
    {
        uint32_t TXBURST : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t TXCHANADD : 8;        /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh1_hwtxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH1_HWTXBUF register
 */
/*@{*/
#define HW_USB_UH1_HWTXBUF_ADDR(x) ((uintptr_t)(x) + 0x210U)

#define HW_USB_UH1_HWTXBUF(x)    (*(__I hw_usb_uh1_hwtxbuf_t *) HW_USB_UH1_HWTXBUF_ADDR(x))
#define HW_USB_UH1_HWTXBUF_RD(x) (HW_USB_UH1_HWTXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HWTXBUF bitfields
 */

/*!
 * @name Register USB_UH1_HWTXBUF, field TXBURST[7:0] (RO)
 *
 * Default burst size for memory to TX buffer transfer. This is reset value of
 * TXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH1_HWTXBUF_TXBURST (0U)    /*!< Bit position for USB_UH1_HWTXBUF_TXBURST. */
#define BM_USB_UH1_HWTXBUF_TXBURST (0x000000FFU) /*!< Bit mask for USB_UH1_HWTXBUF_TXBURST. */
#define BS_USB_UH1_HWTXBUF_TXBURST (8U)    /*!< Bit field size in bits for USB_UH1_HWTXBUF_TXBURST. */

/*! @brief Read current value of the USB_UH1_HWTXBUF_TXBURST field. */
#define BR_USB_UH1_HWTXBUF_TXBURST(x) (HW_USB_UH1_HWTXBUF(x).B.TXBURST)
/*@}*/

/*!
 * @name Register USB_UH1_HWTXBUF, field TXCHANADD[23:16] (RO)
 *
 * TX FIFO Buffer size is: (2^TXCHANADD) * 4 Bytes. These bits are set to '08h',
 * so buffer size is 256*4 Bytes. For the OTG controller operating in device
 * mode, this is the FIFO buffer size per endpoint. As the OTG controller has 8 TX
 * endpoint, there are 8 of these buffers. For the OTG controller operating in
 * host mode, or for Host-only controller, the entire buffer memory is used as a
 * single TX buffer. Therefore, there is only 1 of this buffer
 */
/*@{*/
#define BP_USB_UH1_HWTXBUF_TXCHANADD (16U) /*!< Bit position for USB_UH1_HWTXBUF_TXCHANADD. */
#define BM_USB_UH1_HWTXBUF_TXCHANADD (0x00FF0000U) /*!< Bit mask for USB_UH1_HWTXBUF_TXCHANADD. */
#define BS_USB_UH1_HWTXBUF_TXCHANADD (8U)  /*!< Bit field size in bits for USB_UH1_HWTXBUF_TXCHANADD. */

/*! @brief Read current value of the USB_UH1_HWTXBUF_TXCHANADD field. */
#define BR_USB_UH1_HWTXBUF_TXCHANADD(x) (HW_USB_UH1_HWTXBUF(x).B.TXCHANADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HWRXBUF - RX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HWRXBUF - RX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x00000808U
 */
typedef union _hw_usb_uh1_hwrxbuf
{
    uint32_t U;
    struct _hw_usb_uh1_hwrxbuf_bitfields
    {
        uint32_t RXBURST : 8;          /*!< [7:0]  */
        uint32_t RXADD : 8;            /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh1_hwrxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH1_HWRXBUF register
 */
/*@{*/
#define HW_USB_UH1_HWRXBUF_ADDR(x) ((uintptr_t)(x) + 0x214U)

#define HW_USB_UH1_HWRXBUF(x)    (*(__I hw_usb_uh1_hwrxbuf_t *) HW_USB_UH1_HWRXBUF_ADDR(x))
#define HW_USB_UH1_HWRXBUF_RD(x) (HW_USB_UH1_HWRXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HWRXBUF bitfields
 */

/*!
 * @name Register USB_UH1_HWRXBUF, field RXBURST[7:0] (RO)
 *
 * Default burst size for memory to RX buffer transfer. This is reset value of
 * RXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH1_HWRXBUF_RXBURST (0U)    /*!< Bit position for USB_UH1_HWRXBUF_RXBURST. */
#define BM_USB_UH1_HWRXBUF_RXBURST (0x000000FFU) /*!< Bit mask for USB_UH1_HWRXBUF_RXBURST. */
#define BS_USB_UH1_HWRXBUF_RXBURST (8U)    /*!< Bit field size in bits for USB_UH1_HWRXBUF_RXBURST. */

/*! @brief Read current value of the USB_UH1_HWRXBUF_RXBURST field. */
#define BR_USB_UH1_HWRXBUF_RXBURST(x) (HW_USB_UH1_HWRXBUF(x).B.RXBURST)
/*@}*/

/*!
 * @name Register USB_UH1_HWRXBUF, field RXADD[15:8] (RO)
 *
 * Buffer total size for all receive endpoints is (2^RXADD). RX Buffer size is:
 * (2^RXADD) * 4 Bytes. These bits are set to '08h', so buffer size is 256*4
 * Bytes. There is a single Receive FIFO buffer in the USB controller. The buffer is
 * shared for all endpoints for the OTG controller in device mode.
 */
/*@{*/
#define BP_USB_UH1_HWRXBUF_RXADD (8U)      /*!< Bit position for USB_UH1_HWRXBUF_RXADD. */
#define BM_USB_UH1_HWRXBUF_RXADD (0x0000FF00U) /*!< Bit mask for USB_UH1_HWRXBUF_RXADD. */
#define BS_USB_UH1_HWRXBUF_RXADD (8U)      /*!< Bit field size in bits for USB_UH1_HWRXBUF_RXADD. */

/*! @brief Read current value of the USB_UH1_HWRXBUF_RXADD field. */
#define BR_USB_UH1_HWRXBUF_RXADD(x) (HW_USB_UH1_HWRXBUF(x).B.RXADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_GPTIMER0LD - General Purpose Timer #0 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_GPTIMER0LD - General Purpose Timer #0 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER0CTRL. Please see GPTIMER0CTRLGeneral Purpose Timer #0 Controller .
 */
typedef union _hw_usb_uh1_gptimer0ld
{
    uint32_t U;
    struct _hw_usb_uh1_gptimer0ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh1_gptimer0ld_t;

/*!
 * @name Constants and macros for entire USB_UH1_GPTIMER0LD register
 */
/*@{*/
#define HW_USB_UH1_GPTIMER0LD_ADDR(x) ((uintptr_t)(x) + 0x280U)

#define HW_USB_UH1_GPTIMER0LD(x) (*(__IO hw_usb_uh1_gptimer0ld_t *) HW_USB_UH1_GPTIMER0LD_ADDR(x))
#define HW_USB_UH1_GPTIMER0LD_RD(x) (HW_USB_UH1_GPTIMER0LD(x).U)
#define HW_USB_UH1_GPTIMER0LD_WR(x, v) (HW_USB_UH1_GPTIMER0LD(x).U = (v))
#define HW_USB_UH1_GPTIMER0LD_SET(x, v) (HW_USB_UH1_GPTIMER0LD_WR(x, HW_USB_UH1_GPTIMER0LD_RD(x) |  (v)))
#define HW_USB_UH1_GPTIMER0LD_CLR(x, v) (HW_USB_UH1_GPTIMER0LD_WR(x, HW_USB_UH1_GPTIMER0LD_RD(x) & ~(v)))
#define HW_USB_UH1_GPTIMER0LD_TOG(x, v) (HW_USB_UH1_GPTIMER0LD_WR(x, HW_USB_UH1_GPTIMER0LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_GPTIMER0LD bitfields
 */

/*!
 * @name Register USB_UH1_GPTIMER0LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH1_GPTIMER0LD_GPTLD (0U)   /*!< Bit position for USB_UH1_GPTIMER0LD_GPTLD. */
#define BM_USB_UH1_GPTIMER0LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH1_GPTIMER0LD_GPTLD. */
#define BS_USB_UH1_GPTIMER0LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH1_GPTIMER0LD_GPTLD. */

/*! @brief Read current value of the USB_UH1_GPTIMER0LD_GPTLD field. */
#define BR_USB_UH1_GPTIMER0LD_GPTLD(x) (HW_USB_UH1_GPTIMER0LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH1_GPTIMER0LD_GPTLD. */
#define BF_USB_UH1_GPTIMER0LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER0LD_GPTLD) & BM_USB_UH1_GPTIMER0LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH1_GPTIMER0LD_GPTLD(x, v) (HW_USB_UH1_GPTIMER0LD_WR(x, (HW_USB_UH1_GPTIMER0LD_RD(x) & ~BM_USB_UH1_GPTIMER0LD_GPTLD) | BF_USB_UH1_GPTIMER0LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_GPTIMER0CTRL - General Purpose Timer #0 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_GPTIMER0CTRL - General Purpose Timer #0 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI0 bit in n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE0 bit in n_USBINTR register. (See
 * USBINTRInterrupt Enable Register .)
 */
typedef union _hw_usb_uh1_gptimer0ctrl
{
    uint32_t U;
    struct _hw_usb_uh1_gptimer0ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh1_gptimer0ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH1_GPTIMER0CTRL register
 */
/*@{*/
#define HW_USB_UH1_GPTIMER0CTRL_ADDR(x) ((uintptr_t)(x) + 0x284U)

#define HW_USB_UH1_GPTIMER0CTRL(x) (*(__IO hw_usb_uh1_gptimer0ctrl_t *) HW_USB_UH1_GPTIMER0CTRL_ADDR(x))
#define HW_USB_UH1_GPTIMER0CTRL_RD(x) (HW_USB_UH1_GPTIMER0CTRL(x).U)
#define HW_USB_UH1_GPTIMER0CTRL_WR(x, v) (HW_USB_UH1_GPTIMER0CTRL(x).U = (v))
#define HW_USB_UH1_GPTIMER0CTRL_SET(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, HW_USB_UH1_GPTIMER0CTRL_RD(x) |  (v)))
#define HW_USB_UH1_GPTIMER0CTRL_CLR(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, HW_USB_UH1_GPTIMER0CTRL_RD(x) & ~(v)))
#define HW_USB_UH1_GPTIMER0CTRL_TOG(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, HW_USB_UH1_GPTIMER0CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_GPTIMER0CTRL bitfields
 */

/*!
 * @name Register USB_UH1_GPTIMER0CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH1_GPTIMER0CTRL_GPTCNT (0U) /*!< Bit position for USB_UH1_GPTIMER0CTRL_GPTCNT. */
#define BM_USB_UH1_GPTIMER0CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH1_GPTIMER0CTRL_GPTCNT. */
#define BS_USB_UH1_GPTIMER0CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH1_GPTIMER0CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH1_GPTIMER0CTRL_GPTCNT field. */
#define BR_USB_UH1_GPTIMER0CTRL_GPTCNT(x) (HW_USB_UH1_GPTIMER0CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH1_GPTIMER0CTRL_GPTCNT. */
#define BF_USB_UH1_GPTIMER0CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER0CTRL_GPTCNT) & BM_USB_UH1_GPTIMER0CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH1_GPTIMER0CTRL_GPTCNT(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, (HW_USB_UH1_GPTIMER0CTRL_RD(x) & ~BM_USB_UH1_GPTIMER0CTRL_GPTCNT) | BF_USB_UH1_GPTIMER0CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER0CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software; In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH1_GPTIMER0CTRL_GPTMODE (24U) /*!< Bit position for USB_UH1_GPTIMER0CTRL_GPTMODE. */
#define BM_USB_UH1_GPTIMER0CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH1_GPTIMER0CTRL_GPTMODE. */
#define BS_USB_UH1_GPTIMER0CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER0CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH1_GPTIMER0CTRL_GPTMODE field. */
#define BR_USB_UH1_GPTIMER0CTRL_GPTMODE(x) (HW_USB_UH1_GPTIMER0CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH1_GPTIMER0CTRL_GPTMODE. */
#define BF_USB_UH1_GPTIMER0CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER0CTRL_GPTMODE) & BM_USB_UH1_GPTIMER0CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH1_GPTIMER0CTRL_GPTMODE(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, (HW_USB_UH1_GPTIMER0CTRL_RD(x) & ~BM_USB_UH1_GPTIMER0CTRL_GPTMODE) | BF_USB_UH1_GPTIMER0CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER0CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH1_GPTIMER0CTRL_GPTRST (30U) /*!< Bit position for USB_UH1_GPTIMER0CTRL_GPTRST. */
#define BM_USB_UH1_GPTIMER0CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH1_GPTIMER0CTRL_GPTRST. */
#define BS_USB_UH1_GPTIMER0CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER0CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH1_GPTIMER0CTRL_GPTRST field. */
#define BR_USB_UH1_GPTIMER0CTRL_GPTRST(x) (HW_USB_UH1_GPTIMER0CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH1_GPTIMER0CTRL_GPTRST. */
#define BF_USB_UH1_GPTIMER0CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER0CTRL_GPTRST) & BM_USB_UH1_GPTIMER0CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH1_GPTIMER0CTRL_GPTRST(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, (HW_USB_UH1_GPTIMER0CTRL_RD(x) & ~BM_USB_UH1_GPTIMER0CTRL_GPTRST) | BF_USB_UH1_GPTIMER0CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER0CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH1_GPTIMER0CTRL_GPTRUN (31U) /*!< Bit position for USB_UH1_GPTIMER0CTRL_GPTRUN. */
#define BM_USB_UH1_GPTIMER0CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH1_GPTIMER0CTRL_GPTRUN. */
#define BS_USB_UH1_GPTIMER0CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER0CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH1_GPTIMER0CTRL_GPTRUN field. */
#define BR_USB_UH1_GPTIMER0CTRL_GPTRUN(x) (HW_USB_UH1_GPTIMER0CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH1_GPTIMER0CTRL_GPTRUN. */
#define BF_USB_UH1_GPTIMER0CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER0CTRL_GPTRUN) & BM_USB_UH1_GPTIMER0CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH1_GPTIMER0CTRL_GPTRUN(x, v) (HW_USB_UH1_GPTIMER0CTRL_WR(x, (HW_USB_UH1_GPTIMER0CTRL_RD(x) & ~BM_USB_UH1_GPTIMER0CTRL_GPTRUN) | BF_USB_UH1_GPTIMER0CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_GPTIMER1LD - General Purpose Timer #1 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_GPTIMER1LD - General Purpose Timer #1 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER1CTRL. Please see GPTIMER1CTRLGeneral Purpose Timer #1 Controller .
 */
typedef union _hw_usb_uh1_gptimer1ld
{
    uint32_t U;
    struct _hw_usb_uh1_gptimer1ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh1_gptimer1ld_t;

/*!
 * @name Constants and macros for entire USB_UH1_GPTIMER1LD register
 */
/*@{*/
#define HW_USB_UH1_GPTIMER1LD_ADDR(x) ((uintptr_t)(x) + 0x288U)

#define HW_USB_UH1_GPTIMER1LD(x) (*(__IO hw_usb_uh1_gptimer1ld_t *) HW_USB_UH1_GPTIMER1LD_ADDR(x))
#define HW_USB_UH1_GPTIMER1LD_RD(x) (HW_USB_UH1_GPTIMER1LD(x).U)
#define HW_USB_UH1_GPTIMER1LD_WR(x, v) (HW_USB_UH1_GPTIMER1LD(x).U = (v))
#define HW_USB_UH1_GPTIMER1LD_SET(x, v) (HW_USB_UH1_GPTIMER1LD_WR(x, HW_USB_UH1_GPTIMER1LD_RD(x) |  (v)))
#define HW_USB_UH1_GPTIMER1LD_CLR(x, v) (HW_USB_UH1_GPTIMER1LD_WR(x, HW_USB_UH1_GPTIMER1LD_RD(x) & ~(v)))
#define HW_USB_UH1_GPTIMER1LD_TOG(x, v) (HW_USB_UH1_GPTIMER1LD_WR(x, HW_USB_UH1_GPTIMER1LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_GPTIMER1LD bitfields
 */

/*!
 * @name Register USB_UH1_GPTIMER1LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH1_GPTIMER1LD_GPTLD (0U)   /*!< Bit position for USB_UH1_GPTIMER1LD_GPTLD. */
#define BM_USB_UH1_GPTIMER1LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH1_GPTIMER1LD_GPTLD. */
#define BS_USB_UH1_GPTIMER1LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH1_GPTIMER1LD_GPTLD. */

/*! @brief Read current value of the USB_UH1_GPTIMER1LD_GPTLD field. */
#define BR_USB_UH1_GPTIMER1LD_GPTLD(x) (HW_USB_UH1_GPTIMER1LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH1_GPTIMER1LD_GPTLD. */
#define BF_USB_UH1_GPTIMER1LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER1LD_GPTLD) & BM_USB_UH1_GPTIMER1LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH1_GPTIMER1LD_GPTLD(x, v) (HW_USB_UH1_GPTIMER1LD_WR(x, (HW_USB_UH1_GPTIMER1LD_RD(x) & ~BM_USB_UH1_GPTIMER1LD_GPTLD) | BF_USB_UH1_GPTIMER1LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_GPTIMER1CTRL - General Purpose Timer #1 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_GPTIMER1CTRL - General Purpose Timer #1 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI1 bit in USB_n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE1 bit in n_USBINTR register (See
 * USBINTRInterrupt Enable Register ).
 */
typedef union _hw_usb_uh1_gptimer1ctrl
{
    uint32_t U;
    struct _hw_usb_uh1_gptimer1ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh1_gptimer1ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH1_GPTIMER1CTRL register
 */
/*@{*/
#define HW_USB_UH1_GPTIMER1CTRL_ADDR(x) ((uintptr_t)(x) + 0x28CU)

#define HW_USB_UH1_GPTIMER1CTRL(x) (*(__IO hw_usb_uh1_gptimer1ctrl_t *) HW_USB_UH1_GPTIMER1CTRL_ADDR(x))
#define HW_USB_UH1_GPTIMER1CTRL_RD(x) (HW_USB_UH1_GPTIMER1CTRL(x).U)
#define HW_USB_UH1_GPTIMER1CTRL_WR(x, v) (HW_USB_UH1_GPTIMER1CTRL(x).U = (v))
#define HW_USB_UH1_GPTIMER1CTRL_SET(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, HW_USB_UH1_GPTIMER1CTRL_RD(x) |  (v)))
#define HW_USB_UH1_GPTIMER1CTRL_CLR(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, HW_USB_UH1_GPTIMER1CTRL_RD(x) & ~(v)))
#define HW_USB_UH1_GPTIMER1CTRL_TOG(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, HW_USB_UH1_GPTIMER1CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_GPTIMER1CTRL bitfields
 */

/*!
 * @name Register USB_UH1_GPTIMER1CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH1_GPTIMER1CTRL_GPTCNT (0U) /*!< Bit position for USB_UH1_GPTIMER1CTRL_GPTCNT. */
#define BM_USB_UH1_GPTIMER1CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH1_GPTIMER1CTRL_GPTCNT. */
#define BS_USB_UH1_GPTIMER1CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH1_GPTIMER1CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH1_GPTIMER1CTRL_GPTCNT field. */
#define BR_USB_UH1_GPTIMER1CTRL_GPTCNT(x) (HW_USB_UH1_GPTIMER1CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH1_GPTIMER1CTRL_GPTCNT. */
#define BF_USB_UH1_GPTIMER1CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER1CTRL_GPTCNT) & BM_USB_UH1_GPTIMER1CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH1_GPTIMER1CTRL_GPTCNT(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, (HW_USB_UH1_GPTIMER1CTRL_RD(x) & ~BM_USB_UH1_GPTIMER1CTRL_GPTCNT) | BF_USB_UH1_GPTIMER1CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER1CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software. In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH1_GPTIMER1CTRL_GPTMODE (24U) /*!< Bit position for USB_UH1_GPTIMER1CTRL_GPTMODE. */
#define BM_USB_UH1_GPTIMER1CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH1_GPTIMER1CTRL_GPTMODE. */
#define BS_USB_UH1_GPTIMER1CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER1CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH1_GPTIMER1CTRL_GPTMODE field. */
#define BR_USB_UH1_GPTIMER1CTRL_GPTMODE(x) (HW_USB_UH1_GPTIMER1CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH1_GPTIMER1CTRL_GPTMODE. */
#define BF_USB_UH1_GPTIMER1CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER1CTRL_GPTMODE) & BM_USB_UH1_GPTIMER1CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH1_GPTIMER1CTRL_GPTMODE(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, (HW_USB_UH1_GPTIMER1CTRL_RD(x) & ~BM_USB_UH1_GPTIMER1CTRL_GPTMODE) | BF_USB_UH1_GPTIMER1CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER1CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in USB_n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH1_GPTIMER1CTRL_GPTRST (30U) /*!< Bit position for USB_UH1_GPTIMER1CTRL_GPTRST. */
#define BM_USB_UH1_GPTIMER1CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH1_GPTIMER1CTRL_GPTRST. */
#define BS_USB_UH1_GPTIMER1CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER1CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH1_GPTIMER1CTRL_GPTRST field. */
#define BR_USB_UH1_GPTIMER1CTRL_GPTRST(x) (HW_USB_UH1_GPTIMER1CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH1_GPTIMER1CTRL_GPTRST. */
#define BF_USB_UH1_GPTIMER1CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER1CTRL_GPTRST) & BM_USB_UH1_GPTIMER1CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH1_GPTIMER1CTRL_GPTRST(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, (HW_USB_UH1_GPTIMER1CTRL_RD(x) & ~BM_USB_UH1_GPTIMER1CTRL_GPTRST) | BF_USB_UH1_GPTIMER1CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH1_GPTIMER1CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH1_GPTIMER1CTRL_GPTRUN (31U) /*!< Bit position for USB_UH1_GPTIMER1CTRL_GPTRUN. */
#define BM_USB_UH1_GPTIMER1CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH1_GPTIMER1CTRL_GPTRUN. */
#define BS_USB_UH1_GPTIMER1CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH1_GPTIMER1CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH1_GPTIMER1CTRL_GPTRUN field. */
#define BR_USB_UH1_GPTIMER1CTRL_GPTRUN(x) (HW_USB_UH1_GPTIMER1CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH1_GPTIMER1CTRL_GPTRUN. */
#define BF_USB_UH1_GPTIMER1CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_GPTIMER1CTRL_GPTRUN) & BM_USB_UH1_GPTIMER1CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH1_GPTIMER1CTRL_GPTRUN(x, v) (HW_USB_UH1_GPTIMER1CTRL_WR(x, (HW_USB_UH1_GPTIMER1CTRL_RD(x) & ~BM_USB_UH1_GPTIMER1CTRL_GPTRUN) | BF_USB_UH1_GPTIMER1CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_SBUSCFG - System Bus Config
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_SBUSCFG - System Bus Config (RW)
 *
 * Reset value: 0x00000002U
 */
typedef union _hw_usb_uh1_sbuscfg
{
    uint32_t U;
    struct _hw_usb_uh1_sbuscfg_bitfields
    {
        uint32_t AHBBRST : 3;          /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_usb_uh1_sbuscfg_t;

/*!
 * @name Constants and macros for entire USB_UH1_SBUSCFG register
 */
/*@{*/
#define HW_USB_UH1_SBUSCFG_ADDR(x) ((uintptr_t)(x) + 0x290U)

#define HW_USB_UH1_SBUSCFG(x)    (*(__IO hw_usb_uh1_sbuscfg_t *) HW_USB_UH1_SBUSCFG_ADDR(x))
#define HW_USB_UH1_SBUSCFG_RD(x) (HW_USB_UH1_SBUSCFG(x).U)
#define HW_USB_UH1_SBUSCFG_WR(x, v) (HW_USB_UH1_SBUSCFG(x).U = (v))
#define HW_USB_UH1_SBUSCFG_SET(x, v) (HW_USB_UH1_SBUSCFG_WR(x, HW_USB_UH1_SBUSCFG_RD(x) |  (v)))
#define HW_USB_UH1_SBUSCFG_CLR(x, v) (HW_USB_UH1_SBUSCFG_WR(x, HW_USB_UH1_SBUSCFG_RD(x) & ~(v)))
#define HW_USB_UH1_SBUSCFG_TOG(x, v) (HW_USB_UH1_SBUSCFG_WR(x, HW_USB_UH1_SBUSCFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_SBUSCFG bitfields
 */

/*!
 * @name Register USB_UH1_SBUSCFG, field AHBBRST[2:0] (RW)
 *
 * AHB master interface Burst configuration These bits control AHB master
 * transfer type sequence (or priority). This register overrides n_BURSTSIZE register
 * when its value is not zero.
 *
 * Values:
 * - 000 - Incremental burst of unspecified length only
 * - 001 - INCR4 burst, then single transfer
 * - 010 - INCR8 burst, INCR4 burst, then single transfer
 * - 011 - INCR16 burst, INCR8 burst, INCR4 burst, then single transfer
 * - 100 - Reserved, don't use
 * - 101 - INCR4 burst, then incremental burst of unspecified length
 * - 110 - INCR8 burst, INCR4 burst, then incremental burst of unspecified length
 * - 111 - INCR16 burst, INCR8 burst, INCR4 burst, then incremental burst of
 *     unspecified length
 */
/*@{*/
#define BP_USB_UH1_SBUSCFG_AHBBRST (0U)    /*!< Bit position for USB_UH1_SBUSCFG_AHBBRST. */
#define BM_USB_UH1_SBUSCFG_AHBBRST (0x00000007U) /*!< Bit mask for USB_UH1_SBUSCFG_AHBBRST. */
#define BS_USB_UH1_SBUSCFG_AHBBRST (3U)    /*!< Bit field size in bits for USB_UH1_SBUSCFG_AHBBRST. */

/*! @brief Read current value of the USB_UH1_SBUSCFG_AHBBRST field. */
#define BR_USB_UH1_SBUSCFG_AHBBRST(x) (HW_USB_UH1_SBUSCFG(x).B.AHBBRST)

/*! @brief Format value for bitfield USB_UH1_SBUSCFG_AHBBRST. */
#define BF_USB_UH1_SBUSCFG_AHBBRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_SBUSCFG_AHBBRST) & BM_USB_UH1_SBUSCFG_AHBBRST)

/*! @brief Set the AHBBRST field to a new value. */
#define BW_USB_UH1_SBUSCFG_AHBBRST(x, v) (HW_USB_UH1_SBUSCFG_WR(x, (HW_USB_UH1_SBUSCFG_RD(x) & ~BM_USB_UH1_SBUSCFG_AHBBRST) | BF_USB_UH1_SBUSCFG_AHBBRST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_CAPLENGTH - Capability Registers Length
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_CAPLENGTH - Capability Registers Length (RO)
 *
 * Reset value: 0x40U
 *
 * The Capability Registers Length register contains the address offset to the
 * Operational registers relative to the CAPLENGTH register.
 */
typedef union _hw_usb_uh1_caplength
{
    uint8_t U;
    struct _hw_usb_uh1_caplength_bitfields
    {
        uint8_t CAPLENGTH : 8;         /*!< [7:0]  */
    } B;
} hw_usb_uh1_caplength_t;

/*!
 * @name Constants and macros for entire USB_UH1_CAPLENGTH register
 */
/*@{*/
#define HW_USB_UH1_CAPLENGTH_ADDR(x) ((uintptr_t)(x) + 0x300U)

#define HW_USB_UH1_CAPLENGTH(x)  (*(__I hw_usb_uh1_caplength_t *) HW_USB_UH1_CAPLENGTH_ADDR(x))
#define HW_USB_UH1_CAPLENGTH_RD(x) (HW_USB_UH1_CAPLENGTH(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_CAPLENGTH bitfields
 */

/*!
 * @name Register USB_UH1_CAPLENGTH, field CAPLENGTH[7:0] (RO)
 *
 * These bits are used as an offset to add to register base to find the
 * beginning of the Operational Register. Default value is '40h'.
 */
/*@{*/
#define BP_USB_UH1_CAPLENGTH_CAPLENGTH (0U) /*!< Bit position for USB_UH1_CAPLENGTH_CAPLENGTH. */
#define BM_USB_UH1_CAPLENGTH_CAPLENGTH (0xFFU) /*!< Bit mask for USB_UH1_CAPLENGTH_CAPLENGTH. */
#define BS_USB_UH1_CAPLENGTH_CAPLENGTH (8U) /*!< Bit field size in bits for USB_UH1_CAPLENGTH_CAPLENGTH. */

/*! @brief Read current value of the USB_UH1_CAPLENGTH_CAPLENGTH field. */
#define BR_USB_UH1_CAPLENGTH_CAPLENGTH(x) (HW_USB_UH1_CAPLENGTH(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HCIVERSION - Host Controller Interface Version
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HCIVERSION - Host Controller Interface Version (RO)
 *
 * Reset value: 0x0100U
 *
 * This is a 2-byte register containing a BCD encoding of the EHCI revision
 * number supported by this host controller. The most significant byte of this
 * register represents a major revision and the least significant byte is the minor
 * revision.
 */
typedef union _hw_usb_uh1_hciversion
{
    uint16_t U;
    struct _hw_usb_uh1_hciversion_bitfields
    {
        uint16_t HCIVERSION : 16;      /*!< [15:0]  */
    } B;
} hw_usb_uh1_hciversion_t;

/*!
 * @name Constants and macros for entire USB_UH1_HCIVERSION register
 */
/*@{*/
#define HW_USB_UH1_HCIVERSION_ADDR(x) ((uintptr_t)(x) + 0x302U)

#define HW_USB_UH1_HCIVERSION(x) (*(__I hw_usb_uh1_hciversion_t *) HW_USB_UH1_HCIVERSION_ADDR(x))
#define HW_USB_UH1_HCIVERSION_RD(x) (HW_USB_UH1_HCIVERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HCIVERSION bitfields
 */

/*!
 * @name Register USB_UH1_HCIVERSION, field HCIVERSION[15:0] (RO)
 *
 * Host Controller Interface Version Number Default value is '10h', which means
 * EHCI rev1.0.
 */
/*@{*/
#define BP_USB_UH1_HCIVERSION_HCIVERSION (0U) /*!< Bit position for USB_UH1_HCIVERSION_HCIVERSION. */
#define BM_USB_UH1_HCIVERSION_HCIVERSION (0xFFFFU) /*!< Bit mask for USB_UH1_HCIVERSION_HCIVERSION. */
#define BS_USB_UH1_HCIVERSION_HCIVERSION (16U) /*!< Bit field size in bits for USB_UH1_HCIVERSION_HCIVERSION. */

/*! @brief Read current value of the USB_UH1_HCIVERSION_HCIVERSION field. */
#define BR_USB_UH1_HCIVERSION_HCIVERSION(x) (HW_USB_UH1_HCIVERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HCSPARAMS - Host Controller Structural Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HCSPARAMS - Host Controller Structural Parameters (RO)
 *
 * Reset value: 0x00010011U
 *
 * The following figure shows the port steering logic capabilities of Host
 * Control Structural Parameters (n_HCSPARAMS).
 */
typedef union _hw_usb_uh1_hcsparams
{
    uint32_t U;
    struct _hw_usb_uh1_hcsparams_bitfields
    {
        uint32_t N_PORTS : 4;          /*!< [3:0]  */
        uint32_t PPC : 1;              /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t N_PCC : 4;            /*!< [11:8]  */
        uint32_t N_CC : 4;             /*!< [15:12]  */
        uint32_t PI : 1;               /*!< [16]  */
        uint32_t RESERVED1 : 3;        /*!< [19:17]  */
        uint32_t N_PTT : 4;            /*!< [23:20]  */
        uint32_t N_TT : 4;             /*!< [27:24]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_uh1_hcsparams_t;

/*!
 * @name Constants and macros for entire USB_UH1_HCSPARAMS register
 */
/*@{*/
#define HW_USB_UH1_HCSPARAMS_ADDR(x) ((uintptr_t)(x) + 0x304U)

#define HW_USB_UH1_HCSPARAMS(x)  (*(__I hw_usb_uh1_hcsparams_t *) HW_USB_UH1_HCSPARAMS_ADDR(x))
#define HW_USB_UH1_HCSPARAMS_RD(x) (HW_USB_UH1_HCSPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HCSPARAMS bitfields
 */

/*!
 * @name Register USB_UH1_HCSPARAMS, field N_PORTS[3:0] (RO)
 *
 * Number of downstream ports. This field specifies the number of physical
 * downstream ports implemented on this host controller. The value of this field
 * determines how many port registers are addressable in the Operational Register.
 * Valid values are in the range of 1h to Fh. A zero in this field is undefined.
 * These bits are always set to '0001b' because all controller cores are Single-Port
 * Host.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_N_PORTS (0U)  /*!< Bit position for USB_UH1_HCSPARAMS_N_PORTS. */
#define BM_USB_UH1_HCSPARAMS_N_PORTS (0x0000000FU) /*!< Bit mask for USB_UH1_HCSPARAMS_N_PORTS. */
#define BS_USB_UH1_HCSPARAMS_N_PORTS (4U)  /*!< Bit field size in bits for USB_UH1_HCSPARAMS_N_PORTS. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_N_PORTS field. */
#define BR_USB_UH1_HCSPARAMS_N_PORTS(x) (HW_USB_UH1_HCSPARAMS(x).B.N_PORTS)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field PPC[4] (RO)
 *
 * Port Power Control This field indicates whether the host controller
 * implementation includes port power control. A one indicates the ports have port power
 * switches. A zero indicates the ports do not have port power switches. The value
 * of this field affects the functionality of the Port Power field in each port
 * status and control register
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_PPC (4U)      /*!< Bit position for USB_UH1_HCSPARAMS_PPC. */
#define BM_USB_UH1_HCSPARAMS_PPC (0x00000010U) /*!< Bit mask for USB_UH1_HCSPARAMS_PPC. */
#define BS_USB_UH1_HCSPARAMS_PPC (1U)      /*!< Bit field size in bits for USB_UH1_HCSPARAMS_PPC. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_PPC field. */
#define BR_USB_UH1_HCSPARAMS_PPC(x) (HW_USB_UH1_HCSPARAMS(x).B.PPC)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field N_PCC[11:8] (RO)
 *
 * Number of Ports per Companion Controller This field indicates the number of
 * ports supported per internal Companion Controller. It is used to indicate the
 * port routing configuration to the system software. For example, if N_PORTS has
 * a value of 6 and N_CC has a value of 2 then N_PCC could have a value of 3. The
 * convention is that the first N_PCC ports are assumed to be routed to
 * companion controller 1, the next N_PCC ports to companion controller 2, etc. In the
 * previous example, the N_PCC could have been 4, where the first 4 are routed to
 * companion controller 1 and the last two are routed to companion controller 2.
 * The number in this field must be consistent with N_PORTS and N_CC. These bits
 * are '0000b' in all controller core.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_N_PCC (8U)    /*!< Bit position for USB_UH1_HCSPARAMS_N_PCC. */
#define BM_USB_UH1_HCSPARAMS_N_PCC (0x00000F00U) /*!< Bit mask for USB_UH1_HCSPARAMS_N_PCC. */
#define BS_USB_UH1_HCSPARAMS_N_PCC (4U)    /*!< Bit field size in bits for USB_UH1_HCSPARAMS_N_PCC. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_N_PCC field. */
#define BR_USB_UH1_HCSPARAMS_N_PCC(x) (HW_USB_UH1_HCSPARAMS(x).B.N_PCC)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field N_CC[15:12] (RO)
 *
 * Number of Companion Controller (N_CC). This field indicates the number of
 * companion controllers associated with this USB2.0 host controller. These bits are
 * '0000b' in all controller core.
 *
 * Values:
 * - 0 - There is no internal Companion Controller and port-ownership hand-off
 *     is not supported.
 * - 1 - There are internal companion controller(s) and port-ownership hand-offs
 *     is supported.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_N_CC (12U)    /*!< Bit position for USB_UH1_HCSPARAMS_N_CC. */
#define BM_USB_UH1_HCSPARAMS_N_CC (0x0000F000U) /*!< Bit mask for USB_UH1_HCSPARAMS_N_CC. */
#define BS_USB_UH1_HCSPARAMS_N_CC (4U)     /*!< Bit field size in bits for USB_UH1_HCSPARAMS_N_CC. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_N_CC field. */
#define BR_USB_UH1_HCSPARAMS_N_CC(x) (HW_USB_UH1_HCSPARAMS(x).B.N_CC)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field PI[16] (RO)
 *
 * Port Indicators (P INDICATOR) This bit indicates whether the ports support
 * port indicator control. When set to one, the port status and control registers
 * include a read/writeable field for controlling the state of the port indicator
 * This bit is "1b" in all controller core.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_PI (16U)      /*!< Bit position for USB_UH1_HCSPARAMS_PI. */
#define BM_USB_UH1_HCSPARAMS_PI (0x00010000U) /*!< Bit mask for USB_UH1_HCSPARAMS_PI. */
#define BS_USB_UH1_HCSPARAMS_PI (1U)       /*!< Bit field size in bits for USB_UH1_HCSPARAMS_PI. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_PI field. */
#define BR_USB_UH1_HCSPARAMS_PI(x) (HW_USB_UH1_HCSPARAMS(x).B.PI)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field N_PTT[23:20] (RO)
 *
 * Number of Ports per Transaction Translator (N_PTT). Default value '0000b'
 * This field indicates the number of ports assigned to each transaction translator
 * within the USB2.0 host controller. These bits would be set to equal N_PORTS
 * for Multi-Port Host, and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_N_PTT (20U)   /*!< Bit position for USB_UH1_HCSPARAMS_N_PTT. */
#define BM_USB_UH1_HCSPARAMS_N_PTT (0x00F00000U) /*!< Bit mask for USB_UH1_HCSPARAMS_N_PTT. */
#define BS_USB_UH1_HCSPARAMS_N_PTT (4U)    /*!< Bit field size in bits for USB_UH1_HCSPARAMS_N_PTT. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_N_PTT field. */
#define BR_USB_UH1_HCSPARAMS_N_PTT(x) (HW_USB_UH1_HCSPARAMS(x).B.N_PTT)
/*@}*/

/*!
 * @name Register USB_UH1_HCSPARAMS, field N_TT[27:24] (RO)
 *
 * Number of Transaction Translators (N_TT). Default value '0000b' This field
 * indicates the number of embedded transaction translators associated with the
 * USB2.0 host controller. These bits would be set to '0001b' for Multi-Port Host,
 * and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH1_HCSPARAMS_N_TT (24U)    /*!< Bit position for USB_UH1_HCSPARAMS_N_TT. */
#define BM_USB_UH1_HCSPARAMS_N_TT (0x0F000000U) /*!< Bit mask for USB_UH1_HCSPARAMS_N_TT. */
#define BS_USB_UH1_HCSPARAMS_N_TT (4U)     /*!< Bit field size in bits for USB_UH1_HCSPARAMS_N_TT. */

/*! @brief Read current value of the USB_UH1_HCSPARAMS_N_TT field. */
#define BR_USB_UH1_HCSPARAMS_N_TT(x) (HW_USB_UH1_HCSPARAMS(x).B.N_TT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_HCCPARAMS - Host Controller Capability Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_HCCPARAMS - Host Controller Capability Parameters (RO)
 *
 * Reset value: 0x00000006U
 *
 * This register identifies multiple mode control (time-base bit functionality),
 * addressing capability.
 */
typedef union _hw_usb_uh1_hccparams
{
    uint32_t U;
    struct _hw_usb_uh1_hccparams_bitfields
    {
        uint32_t ADC : 1;              /*!< [0]  */
        uint32_t PFL : 1;              /*!< [1]  */
        uint32_t ASP : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t IST : 4;              /*!< [7:4]  */
        uint32_t EECP : 8;             /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh1_hccparams_t;

/*!
 * @name Constants and macros for entire USB_UH1_HCCPARAMS register
 */
/*@{*/
#define HW_USB_UH1_HCCPARAMS_ADDR(x) ((uintptr_t)(x) + 0x308U)

#define HW_USB_UH1_HCCPARAMS(x)  (*(__I hw_usb_uh1_hccparams_t *) HW_USB_UH1_HCCPARAMS_ADDR(x))
#define HW_USB_UH1_HCCPARAMS_RD(x) (HW_USB_UH1_HCCPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_HCCPARAMS bitfields
 */

/*!
 * @name Register USB_UH1_HCCPARAMS, field ADC[0] (RO)
 *
 * 64-bit Addressing Capability This bit is set '0b' in all controller core, no
 * 64-bit addressing capability is supported.
 */
/*@{*/
#define BP_USB_UH1_HCCPARAMS_ADC (0U)      /*!< Bit position for USB_UH1_HCCPARAMS_ADC. */
#define BM_USB_UH1_HCCPARAMS_ADC (0x00000001U) /*!< Bit mask for USB_UH1_HCCPARAMS_ADC. */
#define BS_USB_UH1_HCCPARAMS_ADC (1U)      /*!< Bit field size in bits for USB_UH1_HCCPARAMS_ADC. */

/*! @brief Read current value of the USB_UH1_HCCPARAMS_ADC field. */
#define BR_USB_UH1_HCCPARAMS_ADC(x) (HW_USB_UH1_HCCPARAMS(x).B.ADC)
/*@}*/

/*!
 * @name Register USB_UH1_HCCPARAMS, field PFL[1] (RO)
 *
 * Programmable Frame List Flag If this bit is set to zero, then the system
 * software must use a frame list length of 1024 elements with this host controller.
 * The USBCMD register Frame List Size field is a read-only register and must be
 * set to zero. If set to a one, then the system software can specify and use a
 * smaller frame list and configure the host controller via the USBCMD register
 * Frame List Size field. The frame list must always be aligned on a 4K-page
 * boundary. This requirement ensures that the frame list is always physically
 * contiguous. This bit is set '1b' in all controller core.
 */
/*@{*/
#define BP_USB_UH1_HCCPARAMS_PFL (1U)      /*!< Bit position for USB_UH1_HCCPARAMS_PFL. */
#define BM_USB_UH1_HCCPARAMS_PFL (0x00000002U) /*!< Bit mask for USB_UH1_HCCPARAMS_PFL. */
#define BS_USB_UH1_HCCPARAMS_PFL (1U)      /*!< Bit field size in bits for USB_UH1_HCCPARAMS_PFL. */

/*! @brief Read current value of the USB_UH1_HCCPARAMS_PFL field. */
#define BR_USB_UH1_HCCPARAMS_PFL(x) (HW_USB_UH1_HCCPARAMS(x).B.PFL)
/*@}*/

/*!
 * @name Register USB_UH1_HCCPARAMS, field ASP[2] (RO)
 *
 * Asynchronous Schedule Park Capability If this bit is set to a one, then the
 * host controller supports the park feature for high-speed queue heads in the
 * Asynchronous Schedule. The feature can be disabled or enabled and set to a
 * specific level by using the Asynchronous Schedule Park Mode Enable and Asynchronous
 * Schedule Park Mode Count fields in the USBCMD register. ASP bit reset value:
 * '00b' for OTG controller core, '11b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_HCCPARAMS_ASP (2U)      /*!< Bit position for USB_UH1_HCCPARAMS_ASP. */
#define BM_USB_UH1_HCCPARAMS_ASP (0x00000004U) /*!< Bit mask for USB_UH1_HCCPARAMS_ASP. */
#define BS_USB_UH1_HCCPARAMS_ASP (1U)      /*!< Bit field size in bits for USB_UH1_HCCPARAMS_ASP. */

/*! @brief Read current value of the USB_UH1_HCCPARAMS_ASP field. */
#define BR_USB_UH1_HCCPARAMS_ASP(x) (HW_USB_UH1_HCCPARAMS(x).B.ASP)
/*@}*/

/*!
 * @name Register USB_UH1_HCCPARAMS, field IST[7:4] (RO)
 *
 * Isochronous Scheduling Threshold. This field indicates, relative to the
 * current position of the executing host controller, where software can reliably
 * update the isochronous schedule. When bit [7] is zero, the value of the least
 * significant 3 bits indicates the number of micro-frames a host controller can hold
 * a set of isochronous data structures (one or more) before flushing the state.
 * When bit [7] is a one, then host software assumes the host controller may
 * cache an isochronous data structure for an entire frame. These bits are set '00h'
 * in all controller core.
 */
/*@{*/
#define BP_USB_UH1_HCCPARAMS_IST (4U)      /*!< Bit position for USB_UH1_HCCPARAMS_IST. */
#define BM_USB_UH1_HCCPARAMS_IST (0x000000F0U) /*!< Bit mask for USB_UH1_HCCPARAMS_IST. */
#define BS_USB_UH1_HCCPARAMS_IST (4U)      /*!< Bit field size in bits for USB_UH1_HCCPARAMS_IST. */

/*! @brief Read current value of the USB_UH1_HCCPARAMS_IST field. */
#define BR_USB_UH1_HCCPARAMS_IST(x) (HW_USB_UH1_HCCPARAMS(x).B.IST)
/*@}*/

/*!
 * @name Register USB_UH1_HCCPARAMS, field EECP[15:8] (RO)
 *
 * EHCI Extended Capabilities Pointer. This field indicates the existence of a
 * capabilities list. A value of 00h indicates no extended capabilities are
 * implemented. A non-zero value in this register indicates the offset in PCI
 * configuration space of the first EHCI extended capability. The pointer value must be
 * 40h or greater if implemented to maintain the consistency of the PCI header
 * defined for this class of device. These bits are set '00h' in all controller core.
 */
/*@{*/
#define BP_USB_UH1_HCCPARAMS_EECP (8U)     /*!< Bit position for USB_UH1_HCCPARAMS_EECP. */
#define BM_USB_UH1_HCCPARAMS_EECP (0x0000FF00U) /*!< Bit mask for USB_UH1_HCCPARAMS_EECP. */
#define BS_USB_UH1_HCCPARAMS_EECP (8U)     /*!< Bit field size in bits for USB_UH1_HCCPARAMS_EECP. */

/*! @brief Read current value of the USB_UH1_HCCPARAMS_EECP field. */
#define BR_USB_UH1_HCCPARAMS_EECP(x) (HW_USB_UH1_HCCPARAMS(x).B.EECP)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_USBCMD - USB Command Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_USBCMD - USB Command Register (RW)
 *
 * Reset value: 0x00080000U
 *
 * The Command Register indicates the command to be executed by the serial bus
 * host/device controller. Writing to the register causes a command to be executed.
 */
typedef union _hw_usb_uh1_usbcmd
{
    uint32_t U;
    struct _hw_usb_uh1_usbcmd_bitfields
    {
        uint32_t RS : 1;               /*!< [0]  */
        uint32_t RST : 1;              /*!< [1]  */
        uint32_t FS_1 : 2;             /*!< [3:2]  */
        uint32_t PSE : 1;              /*!< [4]  */
        uint32_t ASE : 1;              /*!< [5]  */
        uint32_t IAA : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t ASP : 2;              /*!< [9:8]  */
        uint32_t RESERVED1 : 1;        /*!< [10]  */
        uint32_t ASPE : 1;             /*!< [11]  */
        uint32_t ATDTW : 1;            /*!< [12]  */
        uint32_t SUTW : 1;             /*!< [13]  */
        uint32_t RESERVED2 : 1;        /*!< [14]  */
        uint32_t FS_2 : 1;             /*!< [15]  */
        uint32_t ITC : 8;              /*!< [23:16]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh1_usbcmd_t;

/*!
 * @name Constants and macros for entire USB_UH1_USBCMD register
 */
/*@{*/
#define HW_USB_UH1_USBCMD_ADDR(x) ((uintptr_t)(x) + 0x340U)

#define HW_USB_UH1_USBCMD(x)     (*(__IO hw_usb_uh1_usbcmd_t *) HW_USB_UH1_USBCMD_ADDR(x))
#define HW_USB_UH1_USBCMD_RD(x)  (HW_USB_UH1_USBCMD(x).U)
#define HW_USB_UH1_USBCMD_WR(x, v) (HW_USB_UH1_USBCMD(x).U = (v))
#define HW_USB_UH1_USBCMD_SET(x, v) (HW_USB_UH1_USBCMD_WR(x, HW_USB_UH1_USBCMD_RD(x) |  (v)))
#define HW_USB_UH1_USBCMD_CLR(x, v) (HW_USB_UH1_USBCMD_WR(x, HW_USB_UH1_USBCMD_RD(x) & ~(v)))
#define HW_USB_UH1_USBCMD_TOG(x, v) (HW_USB_UH1_USBCMD_WR(x, HW_USB_UH1_USBCMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_USBCMD bitfields
 */

/*!
 * @name Register USB_UH1_USBCMD, field RS[0] (RW)
 *
 * Run/Stop (RS) - Read/Write. Default 0b. 1=Run. 0=Stop. Host operation mode:
 * When set to '1b', the Controller proceeds with the execution of the schedule.
 * The Controller continues execution as long as this bit is set to a one. When
 * this bit is set to 0, the Host Controller completes the current transaction on
 * the USB and then halts. The HC Halted bit in the status register indicates when
 * the Controller has finished the transaction and has entered the stopped
 * state. Software should not write a one to this field unless the controller is in
 * the Halted state (that is, HCHalted in the USBSTS register is a one). Device
 * operation mode: Writing a one to this bit will cause the controller to enable a
 * pull-up on D+ and initiate an attach event. This control bit is not directly
 * connected to the pull-up enable, as the pull-up will become disabled upon
 * transitioning into high-speed mode. Software should use this bit to prevent an
 * attach event before the controller has been properly initialized. Writing a 0 to
 * this will cause a detach event.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_RS (0U)          /*!< Bit position for USB_UH1_USBCMD_RS. */
#define BM_USB_UH1_USBCMD_RS (0x00000001U) /*!< Bit mask for USB_UH1_USBCMD_RS. */
#define BS_USB_UH1_USBCMD_RS (1U)          /*!< Bit field size in bits for USB_UH1_USBCMD_RS. */

/*! @brief Read current value of the USB_UH1_USBCMD_RS field. */
#define BR_USB_UH1_USBCMD_RS(x) (HW_USB_UH1_USBCMD(x).B.RS)

/*! @brief Format value for bitfield USB_UH1_USBCMD_RS. */
#define BF_USB_UH1_USBCMD_RS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_RS) & BM_USB_UH1_USBCMD_RS)

/*! @brief Set the RS field to a new value. */
#define BW_USB_UH1_USBCMD_RS(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_RS) | BF_USB_UH1_USBCMD_RS(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field RST[1] (RW)
 *
 * Controller Reset (RESET) - Read/Write. Software uses this bit to reset the
 * controller. This bit is set to zero by the Host/Device Controller when the reset
 * process is complete. Software cannot terminate the reset process early by
 * writing a zero to this register. Host operation mode: When software writes a one
 * to this bit, the Controller resets its internal pipelines, timers, counters,
 * state machines etc. to their initial value. Any transaction currently in
 * progress on USB is immediately terminated. A USB reset is not driven on downstream
 * ports. Software should not set this bit to a one when the HCHalted bit in the
 * USBSTS register is a zero. Attempting to reset an actively running host
 * controller will result in undefined behavior. Device operation mode: When software
 * writes a one to this bit, the Controller resets its internal pipelines, timers,
 * counters, state machines etc. to their initial value. Writing a one to this
 * bit when the device is in the attached state is not recommended, because the
 * effect on an attached host is undefined. In order to ensure that the device is
 * not in an attached state before initiating a device controller reset, all primed
 * endpoints should be flushed and the USBCMD Run/Stop bit should be set to 0.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_RST (1U)         /*!< Bit position for USB_UH1_USBCMD_RST. */
#define BM_USB_UH1_USBCMD_RST (0x00000002U) /*!< Bit mask for USB_UH1_USBCMD_RST. */
#define BS_USB_UH1_USBCMD_RST (1U)         /*!< Bit field size in bits for USB_UH1_USBCMD_RST. */

/*! @brief Read current value of the USB_UH1_USBCMD_RST field. */
#define BR_USB_UH1_USBCMD_RST(x) (HW_USB_UH1_USBCMD(x).B.RST)

/*! @brief Format value for bitfield USB_UH1_USBCMD_RST. */
#define BF_USB_UH1_USBCMD_RST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_RST) & BM_USB_UH1_USBCMD_RST)

/*! @brief Set the RST field to a new value. */
#define BW_USB_UH1_USBCMD_RST(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_RST) | BF_USB_UH1_USBCMD_RST(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field FS_1[3:2] (RW)
 *
 * See description at bit 15
 */
/*@{*/
#define BP_USB_UH1_USBCMD_FS_1 (2U)        /*!< Bit position for USB_UH1_USBCMD_FS_1. */
#define BM_USB_UH1_USBCMD_FS_1 (0x0000000CU) /*!< Bit mask for USB_UH1_USBCMD_FS_1. */
#define BS_USB_UH1_USBCMD_FS_1 (2U)        /*!< Bit field size in bits for USB_UH1_USBCMD_FS_1. */

/*! @brief Read current value of the USB_UH1_USBCMD_FS_1 field. */
#define BR_USB_UH1_USBCMD_FS_1(x) (HW_USB_UH1_USBCMD(x).B.FS_1)

/*! @brief Format value for bitfield USB_UH1_USBCMD_FS_1. */
#define BF_USB_UH1_USBCMD_FS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_FS_1) & BM_USB_UH1_USBCMD_FS_1)

/*! @brief Set the FS_1 field to a new value. */
#define BW_USB_UH1_USBCMD_FS_1(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_FS_1) | BF_USB_UH1_USBCMD_FS_1(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field PSE[4] (RW)
 *
 * Periodic Schedule Enable- Read/Write. Default 0b. This bit controls whether
 * the host controller skips processing the Periodic Schedule. Only the host
 * controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Periodic Schedule
 * - 1 - Use the PERIODICLISTBASE register to access the Periodic Schedule.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_PSE (4U)         /*!< Bit position for USB_UH1_USBCMD_PSE. */
#define BM_USB_UH1_USBCMD_PSE (0x00000010U) /*!< Bit mask for USB_UH1_USBCMD_PSE. */
#define BS_USB_UH1_USBCMD_PSE (1U)         /*!< Bit field size in bits for USB_UH1_USBCMD_PSE. */

/*! @brief Read current value of the USB_UH1_USBCMD_PSE field. */
#define BR_USB_UH1_USBCMD_PSE(x) (HW_USB_UH1_USBCMD(x).B.PSE)

/*! @brief Format value for bitfield USB_UH1_USBCMD_PSE. */
#define BF_USB_UH1_USBCMD_PSE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_PSE) & BM_USB_UH1_USBCMD_PSE)

/*! @brief Set the PSE field to a new value. */
#define BW_USB_UH1_USBCMD_PSE(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_PSE) | BF_USB_UH1_USBCMD_PSE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field ASE[5] (RW)
 *
 * Asynchronous Schedule Enable - Read/Write. Default 0b. This bit controls
 * whether the host controller skips processing the Asynchronous Schedule. Only the
 * host controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Asynchronous Schedule.
 * - 1 - Use the ASYNCLISTADDR register to access the Asynchronous Schedule.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_ASE (5U)         /*!< Bit position for USB_UH1_USBCMD_ASE. */
#define BM_USB_UH1_USBCMD_ASE (0x00000020U) /*!< Bit mask for USB_UH1_USBCMD_ASE. */
#define BS_USB_UH1_USBCMD_ASE (1U)         /*!< Bit field size in bits for USB_UH1_USBCMD_ASE. */

/*! @brief Read current value of the USB_UH1_USBCMD_ASE field. */
#define BR_USB_UH1_USBCMD_ASE(x) (HW_USB_UH1_USBCMD(x).B.ASE)

/*! @brief Format value for bitfield USB_UH1_USBCMD_ASE. */
#define BF_USB_UH1_USBCMD_ASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_ASE) & BM_USB_UH1_USBCMD_ASE)

/*! @brief Set the ASE field to a new value. */
#define BW_USB_UH1_USBCMD_ASE(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_ASE) | BF_USB_UH1_USBCMD_ASE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field IAA[6] (RW)
 *
 * Interrupt on Async Advance Doorbell - Read/Write. This bit is used as a
 * doorbell by software to tell the host controller to issue an interrupt the next
 * time it advances asynchronous schedule. Software must write a 1 to this bit to
 * ring the doorbell. When the host controller has evicted all appropriate cached
 * schedule states, it sets the Interrupt on Async Advance status bit in the
 * USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR
 * register is one, then the host controller will assert an interrupt at the next
 * interrupt threshold. The host controller sets this bit to zero after it has set the
 * Interrupt on Sync Advance status bit in the USBSTS register to one. Software
 * should not write a one to this bit when the asynchronous schedule is inactive.
 * Doing so will yield undefined results. This bit is only used in host mode.
 * Writing a one to this bit when device mode is selected will have undefined
 * results.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_IAA (6U)         /*!< Bit position for USB_UH1_USBCMD_IAA. */
#define BM_USB_UH1_USBCMD_IAA (0x00000040U) /*!< Bit mask for USB_UH1_USBCMD_IAA. */
#define BS_USB_UH1_USBCMD_IAA (1U)         /*!< Bit field size in bits for USB_UH1_USBCMD_IAA. */

/*! @brief Read current value of the USB_UH1_USBCMD_IAA field. */
#define BR_USB_UH1_USBCMD_IAA(x) (HW_USB_UH1_USBCMD(x).B.IAA)

/*! @brief Format value for bitfield USB_UH1_USBCMD_IAA. */
#define BF_USB_UH1_USBCMD_IAA(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_IAA) & BM_USB_UH1_USBCMD_IAA)

/*! @brief Set the IAA field to a new value. */
#define BW_USB_UH1_USBCMD_IAA(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_IAA) | BF_USB_UH1_USBCMD_IAA(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field ASP[9:8] (RW)
 *
 * Asynchronous Schedule Park Mode Count - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this field defaults to
 * 3h and is R/W. Otherwise it defaults to zero and is Read-Only. It contains a
 * count of the number of successive transactions the host controller is allowed
 * to execute from a high-speed queue head on the Asynchronous schedule before
 * continuing traversal of the Asynchronous schedule. Valid values are 1h to 3h.
 * Software must not write a zero to this bit when Park Mode Enable is a one as
 * this will result in undefined behavior. This field is set to 3h in all controller
 * core.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_ASP (8U)         /*!< Bit position for USB_UH1_USBCMD_ASP. */
#define BM_USB_UH1_USBCMD_ASP (0x00000300U) /*!< Bit mask for USB_UH1_USBCMD_ASP. */
#define BS_USB_UH1_USBCMD_ASP (2U)         /*!< Bit field size in bits for USB_UH1_USBCMD_ASP. */

/*! @brief Read current value of the USB_UH1_USBCMD_ASP field. */
#define BR_USB_UH1_USBCMD_ASP(x) (HW_USB_UH1_USBCMD(x).B.ASP)

/*! @brief Format value for bitfield USB_UH1_USBCMD_ASP. */
#define BF_USB_UH1_USBCMD_ASP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_ASP) & BM_USB_UH1_USBCMD_ASP)

/*! @brief Set the ASP field to a new value. */
#define BW_USB_UH1_USBCMD_ASP(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_ASP) | BF_USB_UH1_USBCMD_ASP(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field ASPE[11] (RW)
 *
 * Asynchronous Schedule Park Mode Enable - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this bit defaults to
 * a 1h and is R/W. Otherwise the bit must be a zero and is RO. Software uses
 * this bit to enable or disable Park mode. When this bit is one, Park mode is
 * enabled. When this bit is a zero, Park mode is disabled. ASPE bit reset value: '0b'
 * for OTG controller core, '1b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_ASPE (11U)       /*!< Bit position for USB_UH1_USBCMD_ASPE. */
#define BM_USB_UH1_USBCMD_ASPE (0x00000800U) /*!< Bit mask for USB_UH1_USBCMD_ASPE. */
#define BS_USB_UH1_USBCMD_ASPE (1U)        /*!< Bit field size in bits for USB_UH1_USBCMD_ASPE. */

/*! @brief Read current value of the USB_UH1_USBCMD_ASPE field. */
#define BR_USB_UH1_USBCMD_ASPE(x) (HW_USB_UH1_USBCMD(x).B.ASPE)

/*! @brief Format value for bitfield USB_UH1_USBCMD_ASPE. */
#define BF_USB_UH1_USBCMD_ASPE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_ASPE) & BM_USB_UH1_USBCMD_ASPE)

/*! @brief Set the ASPE field to a new value. */
#define BW_USB_UH1_USBCMD_ASPE(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_ASPE) | BF_USB_UH1_USBCMD_ASPE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field ATDTW[12] (RW)
 *
 * Add dTD TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure proper addition of a new dTD to an active (primed) endpoint's
 * linked list. This bit is set and cleared by software. This bit would also be
 * cleared by hardware when state machine is hazard region for which adding a dTD
 * to a primed endpoint may go unrecognized.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_ATDTW (12U)      /*!< Bit position for USB_UH1_USBCMD_ATDTW. */
#define BM_USB_UH1_USBCMD_ATDTW (0x00001000U) /*!< Bit mask for USB_UH1_USBCMD_ATDTW. */
#define BS_USB_UH1_USBCMD_ATDTW (1U)       /*!< Bit field size in bits for USB_UH1_USBCMD_ATDTW. */

/*! @brief Read current value of the USB_UH1_USBCMD_ATDTW field. */
#define BR_USB_UH1_USBCMD_ATDTW(x) (HW_USB_UH1_USBCMD(x).B.ATDTW)

/*! @brief Format value for bitfield USB_UH1_USBCMD_ATDTW. */
#define BF_USB_UH1_USBCMD_ATDTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_ATDTW) & BM_USB_UH1_USBCMD_ATDTW)

/*! @brief Set the ATDTW field to a new value. */
#define BW_USB_UH1_USBCMD_ATDTW(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_ATDTW) | BF_USB_UH1_USBCMD_ATDTW(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field SUTW[13] (RW)
 *
 * Setup TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure that the setup data payload of 8 bytes is extracted from a QH by
 * the DCD without being corrupted. If the setup lockout mode is off (SLOM bit in
 * USB core register n_USBMODE, see USBMODEUSB Device Mode ) then there is a
 * hazard when new setup data arrives while the DCD is copying the setup data
 * payload from the QH for a previous setup packet. This bit is set and cleared by
 * software. This bit would also be cleared by hardware when a hazard detected.
 */
/*@{*/
#define BP_USB_UH1_USBCMD_SUTW (13U)       /*!< Bit position for USB_UH1_USBCMD_SUTW. */
#define BM_USB_UH1_USBCMD_SUTW (0x00002000U) /*!< Bit mask for USB_UH1_USBCMD_SUTW. */
#define BS_USB_UH1_USBCMD_SUTW (1U)        /*!< Bit field size in bits for USB_UH1_USBCMD_SUTW. */

/*! @brief Read current value of the USB_UH1_USBCMD_SUTW field. */
#define BR_USB_UH1_USBCMD_SUTW(x) (HW_USB_UH1_USBCMD(x).B.SUTW)

/*! @brief Format value for bitfield USB_UH1_USBCMD_SUTW. */
#define BF_USB_UH1_USBCMD_SUTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_SUTW) & BM_USB_UH1_USBCMD_SUTW)

/*! @brief Set the SUTW field to a new value. */
#define BW_USB_UH1_USBCMD_SUTW(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_SUTW) | BF_USB_UH1_USBCMD_SUTW(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field FS_2[15] (RW)
 *
 * See also bits 3-2 Frame List Size - (Read/Write or Read Only). [host mode
 * only] This field is Read/Write only if Programmable Frame List Flag in the
 * HCCPARAMS registers is set to one. This field specifies the size of the frame list
 * that controls which bits in the Frame Index Register should be used for the
 * Frame List Current index. This field is made up from USBCMD bits 15, 3 and 2.
 * Value Meaning
 *
 * Values:
 * - 000 - 1024 elements (4096 bytes) Default value
 * - 001 - 512 elements (2048 bytes)
 */
/*@{*/
#define BP_USB_UH1_USBCMD_FS_2 (15U)       /*!< Bit position for USB_UH1_USBCMD_FS_2. */
#define BM_USB_UH1_USBCMD_FS_2 (0x00008000U) /*!< Bit mask for USB_UH1_USBCMD_FS_2. */
#define BS_USB_UH1_USBCMD_FS_2 (1U)        /*!< Bit field size in bits for USB_UH1_USBCMD_FS_2. */

/*! @brief Read current value of the USB_UH1_USBCMD_FS_2 field. */
#define BR_USB_UH1_USBCMD_FS_2(x) (HW_USB_UH1_USBCMD(x).B.FS_2)

/*! @brief Format value for bitfield USB_UH1_USBCMD_FS_2. */
#define BF_USB_UH1_USBCMD_FS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_FS_2) & BM_USB_UH1_USBCMD_FS_2)

/*! @brief Set the FS_2 field to a new value. */
#define BW_USB_UH1_USBCMD_FS_2(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_FS_2) | BF_USB_UH1_USBCMD_FS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBCMD, field ITC[23:16] (RW)
 *
 * Interrupt Threshold Control -Read/Write. The system software uses this field
 * to set the maximum rate at which the host/device controller will issue
 * interrupts. ITC contains the maximum interrupt interval measured in micro-frames.
 * Valid values are shown below. Value Maximum Interrupt Interval
 *
 * Values:
 * - 0 - Immediate (no threshold)
 * - 1 - 1 micro-frame
 * - 10 - 2 micro-frames
 * - 100 - 4 micro-frames
 * - 1000 - 8 micro-frames
 * - 10000 - 16 micro-frames
 * - 100000 - 32 micro-frames
 * - 1000000 - 64 micro-frames
 */
/*@{*/
#define BP_USB_UH1_USBCMD_ITC (16U)        /*!< Bit position for USB_UH1_USBCMD_ITC. */
#define BM_USB_UH1_USBCMD_ITC (0x00FF0000U) /*!< Bit mask for USB_UH1_USBCMD_ITC. */
#define BS_USB_UH1_USBCMD_ITC (8U)         /*!< Bit field size in bits for USB_UH1_USBCMD_ITC. */

/*! @brief Read current value of the USB_UH1_USBCMD_ITC field. */
#define BR_USB_UH1_USBCMD_ITC(x) (HW_USB_UH1_USBCMD(x).B.ITC)

/*! @brief Format value for bitfield USB_UH1_USBCMD_ITC. */
#define BF_USB_UH1_USBCMD_ITC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBCMD_ITC) & BM_USB_UH1_USBCMD_ITC)

/*! @brief Set the ITC field to a new value. */
#define BW_USB_UH1_USBCMD_ITC(x, v) (HW_USB_UH1_USBCMD_WR(x, (HW_USB_UH1_USBCMD_RD(x) & ~BM_USB_UH1_USBCMD_ITC) | BF_USB_UH1_USBCMD_ITC(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_USBSTS - USB Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_USBSTS - USB Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates various states of the Host/Device Controller and any
 * pending interrupts. This register does not indicate status resulting from a
 * transaction on the serial bus.
 */
typedef union _hw_usb_uh1_usbsts
{
    uint32_t U;
    struct _hw_usb_uh1_usbsts_bitfields
    {
        uint32_t UI : 1;               /*!< [0]  */
        uint32_t UEI : 1;              /*!< [1]  */
        uint32_t PCI : 1;              /*!< [2]  */
        uint32_t FRI : 1;              /*!< [3]  */
        uint32_t SEI : 1;              /*!< [4]  */
        uint32_t AAI : 1;              /*!< [5]  */
        uint32_t URI : 1;              /*!< [6]  */
        uint32_t SRI : 1;              /*!< [7]  */
        uint32_t SLI : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPII : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t HCH : 1;              /*!< [12]  */
        uint32_t RCL : 1;              /*!< [13]  */
        uint32_t PS : 1;               /*!< [14]  */
        uint32_t AS : 1;               /*!< [15]  */
        uint32_t NAKI : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 7;        /*!< [23:17]  */
        uint32_t TI0 : 1;              /*!< [24]  */
        uint32_t TI1 : 1;              /*!< [25]  */
        uint32_t RESERVED3 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh1_usbsts_t;

/*!
 * @name Constants and macros for entire USB_UH1_USBSTS register
 */
/*@{*/
#define HW_USB_UH1_USBSTS_ADDR(x) ((uintptr_t)(x) + 0x344U)

#define HW_USB_UH1_USBSTS(x)     (*(__IO hw_usb_uh1_usbsts_t *) HW_USB_UH1_USBSTS_ADDR(x))
#define HW_USB_UH1_USBSTS_RD(x)  (HW_USB_UH1_USBSTS(x).U)
#define HW_USB_UH1_USBSTS_WR(x, v) (HW_USB_UH1_USBSTS(x).U = (v))
#define HW_USB_UH1_USBSTS_SET(x, v) (HW_USB_UH1_USBSTS_WR(x, HW_USB_UH1_USBSTS_RD(x) |  (v)))
#define HW_USB_UH1_USBSTS_CLR(x, v) (HW_USB_UH1_USBSTS_WR(x, HW_USB_UH1_USBSTS_RD(x) & ~(v)))
#define HW_USB_UH1_USBSTS_TOG(x, v) (HW_USB_UH1_USBSTS_WR(x, HW_USB_UH1_USBSTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_USBSTS bitfields
 */

/*!
 * @name Register USB_UH1_USBSTS, field UI[0] (RW)
 *
 * USB Interrupt (USBINT) - R/WC. This bit is set by the Host/Device Controller
 * when the cause of an interrupt is a completion of a USB transaction where the
 * Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit
 * is also set by the Host/Device Controller when a short packet is detected. A
 * short packet is when the actual number of bytes received was less than the
 * expected number of bytes.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_UI (0U)          /*!< Bit position for USB_UH1_USBSTS_UI. */
#define BM_USB_UH1_USBSTS_UI (0x00000001U) /*!< Bit mask for USB_UH1_USBSTS_UI. */
#define BS_USB_UH1_USBSTS_UI (1U)          /*!< Bit field size in bits for USB_UH1_USBSTS_UI. */

/*! @brief Read current value of the USB_UH1_USBSTS_UI field. */
#define BR_USB_UH1_USBSTS_UI(x) (HW_USB_UH1_USBSTS(x).B.UI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_UI. */
#define BF_USB_UH1_USBSTS_UI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_UI) & BM_USB_UH1_USBSTS_UI)

/*! @brief Set the UI field to a new value. */
#define BW_USB_UH1_USBSTS_UI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_UI) | BF_USB_UH1_USBSTS_UI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field UEI[1] (RW)
 *
 * USB Error Interrupt (USBERRINT) - R/WC. When completion of a USB transaction
 * results in an error condition, this bit is set by the Host/Device Controller.
 * This bit is set along with the USBINT bit, if the TD on which the error
 * interrupt occurred also had its interrupt on complete (IOC) bit set. The device
 * controller detects resume signaling only.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_UEI (1U)         /*!< Bit position for USB_UH1_USBSTS_UEI. */
#define BM_USB_UH1_USBSTS_UEI (0x00000002U) /*!< Bit mask for USB_UH1_USBSTS_UEI. */
#define BS_USB_UH1_USBSTS_UEI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_UEI. */

/*! @brief Read current value of the USB_UH1_USBSTS_UEI field. */
#define BR_USB_UH1_USBSTS_UEI(x) (HW_USB_UH1_USBSTS(x).B.UEI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_UEI. */
#define BF_USB_UH1_USBSTS_UEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_UEI) & BM_USB_UH1_USBSTS_UEI)

/*! @brief Set the UEI field to a new value. */
#define BW_USB_UH1_USBSTS_UEI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_UEI) | BF_USB_UH1_USBSTS_UEI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field PCI[2] (RW)
 *
 * Port Change Detect - R/WC. The Host Controller sets this bit to a one when on
 * any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the
 * Force Port Resume bit is set as the result of a J-K transition on the
 * suspended port. The Device Controller sets this bit to a one when the port controller
 * enters the full or high-speed operational state. When the port controller
 * exits the full or high-speed operation states due to Reset or Suspend events, the
 * notification mechanisms are the USB Reset Received bit and the DCSuspend bits
 * respectively.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_PCI (2U)         /*!< Bit position for USB_UH1_USBSTS_PCI. */
#define BM_USB_UH1_USBSTS_PCI (0x00000004U) /*!< Bit mask for USB_UH1_USBSTS_PCI. */
#define BS_USB_UH1_USBSTS_PCI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_PCI. */

/*! @brief Read current value of the USB_UH1_USBSTS_PCI field. */
#define BR_USB_UH1_USBSTS_PCI(x) (HW_USB_UH1_USBSTS(x).B.PCI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_PCI. */
#define BF_USB_UH1_USBSTS_PCI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_PCI) & BM_USB_UH1_USBSTS_PCI)

/*! @brief Set the PCI field to a new value. */
#define BW_USB_UH1_USBSTS_PCI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_PCI) | BF_USB_UH1_USBSTS_PCI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field FRI[3] (RW)
 *
 * Frame List Rollover - R/WC. The Host Controller sets this bit to a one when
 * the Frame List Index rolls over from its maximum value to zero. The exact value
 * at which the rollover occurs depends on the frame list size. For example. If
 * the frame list size (as programmed in the Frame List Size field of the
 * USB_n_USBCMD register) is 1024, the Frame Index Register rolls over every time
 * FRINDEX [13] toggles. Similarly, if the size is 512, the Host Controller sets this
 * bit to a one every time FHINDEX [12] toggles. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_FRI (3U)         /*!< Bit position for USB_UH1_USBSTS_FRI. */
#define BM_USB_UH1_USBSTS_FRI (0x00000008U) /*!< Bit mask for USB_UH1_USBSTS_FRI. */
#define BS_USB_UH1_USBSTS_FRI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_FRI. */

/*! @brief Read current value of the USB_UH1_USBSTS_FRI field. */
#define BR_USB_UH1_USBSTS_FRI(x) (HW_USB_UH1_USBSTS(x).B.FRI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_FRI. */
#define BF_USB_UH1_USBSTS_FRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_FRI) & BM_USB_UH1_USBSTS_FRI)

/*! @brief Set the FRI field to a new value. */
#define BW_USB_UH1_USBSTS_FRI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_FRI) | BF_USB_UH1_USBSTS_FRI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field SEI[4] (RW)
 *
 * System Error- R/WC. This bit is will be set to '1b' when an Error response is
 * seen to a read on the system interface.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_SEI (4U)         /*!< Bit position for USB_UH1_USBSTS_SEI. */
#define BM_USB_UH1_USBSTS_SEI (0x00000010U) /*!< Bit mask for USB_UH1_USBSTS_SEI. */
#define BS_USB_UH1_USBSTS_SEI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_SEI. */

/*! @brief Read current value of the USB_UH1_USBSTS_SEI field. */
#define BR_USB_UH1_USBSTS_SEI(x) (HW_USB_UH1_USBSTS(x).B.SEI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_SEI. */
#define BF_USB_UH1_USBSTS_SEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_SEI) & BM_USB_UH1_USBSTS_SEI)

/*! @brief Set the SEI field to a new value. */
#define BW_USB_UH1_USBSTS_SEI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_SEI) | BF_USB_UH1_USBSTS_SEI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field AAI[5] (RW)
 *
 * Interrupt on Async Advance - R/WC. System software can force the host
 * controller to issue an interrupt the next time the host controller advances the
 * asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell
 * bit in the n_USBCMD register. This status bit indicates the assertion of that
 * interrupt source. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_AAI (5U)         /*!< Bit position for USB_UH1_USBSTS_AAI. */
#define BM_USB_UH1_USBSTS_AAI (0x00000020U) /*!< Bit mask for USB_UH1_USBSTS_AAI. */
#define BS_USB_UH1_USBSTS_AAI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_AAI. */

/*! @brief Read current value of the USB_UH1_USBSTS_AAI field. */
#define BR_USB_UH1_USBSTS_AAI(x) (HW_USB_UH1_USBSTS(x).B.AAI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_AAI. */
#define BF_USB_UH1_USBSTS_AAI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_AAI) & BM_USB_UH1_USBSTS_AAI)

/*! @brief Set the AAI field to a new value. */
#define BW_USB_UH1_USBSTS_AAI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_AAI) | BF_USB_UH1_USBSTS_AAI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field URI[6] (RW)
 *
 * USB Reset Received - R/WC. When the device controller detects a USB Reset and
 * enters the default state, this bit will be set to a one. Software can write a
 * 1 to this bit to clear the USB Reset Received status bit. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_URI (6U)         /*!< Bit position for USB_UH1_USBSTS_URI. */
#define BM_USB_UH1_USBSTS_URI (0x00000040U) /*!< Bit mask for USB_UH1_USBSTS_URI. */
#define BS_USB_UH1_USBSTS_URI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_URI. */

/*! @brief Read current value of the USB_UH1_USBSTS_URI field. */
#define BR_USB_UH1_USBSTS_URI(x) (HW_USB_UH1_USBSTS(x).B.URI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_URI. */
#define BF_USB_UH1_USBSTS_URI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_URI) & BM_USB_UH1_USBSTS_URI)

/*! @brief Set the URI field to a new value. */
#define BW_USB_UH1_USBSTS_URI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_URI) | BF_USB_UH1_USBSTS_URI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field SRI[7] (RW)
 *
 * SOF Received - R/WC. When the device controller detects a Start Of (micro)
 * Frame, this bit will be set to a one. When a SOF is extremely late, the device
 * controller will automatically set this bit to indicate that an SOF was
 * expected. Therefore, this bit will be set roughly every 1ms in device FS mode and
 * every 125ms in HS mode and will be synchronized to the actual SOF that is
 * received. Because the device controller is initialized to FS before connect, this bit
 * will be set at an interval of 1ms during the prelude to connect and chirp. In
 * host mode, this bit will be set every 125us and can be used by host controller
 * driver as a time base. Software writes a 1 to this bit to clear it.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_SRI (7U)         /*!< Bit position for USB_UH1_USBSTS_SRI. */
#define BM_USB_UH1_USBSTS_SRI (0x00000080U) /*!< Bit mask for USB_UH1_USBSTS_SRI. */
#define BS_USB_UH1_USBSTS_SRI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_SRI. */

/*! @brief Read current value of the USB_UH1_USBSTS_SRI field. */
#define BR_USB_UH1_USBSTS_SRI(x) (HW_USB_UH1_USBSTS(x).B.SRI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_SRI. */
#define BF_USB_UH1_USBSTS_SRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_SRI) & BM_USB_UH1_USBSTS_SRI)

/*! @brief Set the SRI field to a new value. */
#define BW_USB_UH1_USBSTS_SRI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_SRI) | BF_USB_UH1_USBSTS_SRI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field SLI[8] (RW)
 *
 * DCSuspend - R/WC. When a controller enters a suspend state from an active
 * state, this bit will be set to a one. The device controller clears the bit upon
 * exiting from a suspend state. Only used in device operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_SLI (8U)         /*!< Bit position for USB_UH1_USBSTS_SLI. */
#define BM_USB_UH1_USBSTS_SLI (0x00000100U) /*!< Bit mask for USB_UH1_USBSTS_SLI. */
#define BS_USB_UH1_USBSTS_SLI (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_SLI. */

/*! @brief Read current value of the USB_UH1_USBSTS_SLI field. */
#define BR_USB_UH1_USBSTS_SLI(x) (HW_USB_UH1_USBSTS(x).B.SLI)

/*! @brief Format value for bitfield USB_UH1_USBSTS_SLI. */
#define BF_USB_UH1_USBSTS_SLI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_SLI) & BM_USB_UH1_USBSTS_SLI)

/*! @brief Set the SLI field to a new value. */
#define BW_USB_UH1_USBSTS_SLI(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_SLI) | BF_USB_UH1_USBSTS_SLI(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field ULPII[10] (RW)
 *
 * ULPI Interrupt - R/WC. This bit will be set '1b' by hardware when there is an
 * event completion in ULPI viewport. This bit is usable only if the controller
 * support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_ULPII (10U)      /*!< Bit position for USB_UH1_USBSTS_ULPII. */
#define BM_USB_UH1_USBSTS_ULPII (0x00000400U) /*!< Bit mask for USB_UH1_USBSTS_ULPII. */
#define BS_USB_UH1_USBSTS_ULPII (1U)       /*!< Bit field size in bits for USB_UH1_USBSTS_ULPII. */

/*! @brief Read current value of the USB_UH1_USBSTS_ULPII field. */
#define BR_USB_UH1_USBSTS_ULPII(x) (HW_USB_UH1_USBSTS(x).B.ULPII)

/*! @brief Format value for bitfield USB_UH1_USBSTS_ULPII. */
#define BF_USB_UH1_USBSTS_ULPII(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_ULPII) & BM_USB_UH1_USBSTS_ULPII)

/*! @brief Set the ULPII field to a new value. */
#define BW_USB_UH1_USBSTS_ULPII(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_ULPII) | BF_USB_UH1_USBSTS_ULPII(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field HCH[12] (RW)
 *
 * HCHaIted - Read Only. This bit is a zero whenever the Run/Stop bit is a one.
 * The Controller sets this bit to one after it has stopped executing because of
 * the Run/Stop bit being set to 0, either by software or by the Controller
 * hardware (for example, an internal error). Only used in the host operation mode.
 * Default value is '0b' for OTG core, and '1b' for Host1/Host2/Host3 core. This is
 * because OTG core is not operating as host in default. Please see CM bit in
 * USB_n_USBMODE register. HCH bit reset value: '0b' for OTG controller core, '1b'
 * for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_HCH (12U)        /*!< Bit position for USB_UH1_USBSTS_HCH. */
#define BM_USB_UH1_USBSTS_HCH (0x00001000U) /*!< Bit mask for USB_UH1_USBSTS_HCH. */
#define BS_USB_UH1_USBSTS_HCH (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_HCH. */

/*! @brief Read current value of the USB_UH1_USBSTS_HCH field. */
#define BR_USB_UH1_USBSTS_HCH(x) (HW_USB_UH1_USBSTS(x).B.HCH)

/*! @brief Format value for bitfield USB_UH1_USBSTS_HCH. */
#define BF_USB_UH1_USBSTS_HCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_HCH) & BM_USB_UH1_USBSTS_HCH)

/*! @brief Set the HCH field to a new value. */
#define BW_USB_UH1_USBSTS_HCH(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_HCH) | BF_USB_UH1_USBSTS_HCH(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field RCL[13] (RW)
 *
 * Reclamation - Read Only. This is a read-only status bit used to detect an
 * empty asynchronous schedule. Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_RCL (13U)        /*!< Bit position for USB_UH1_USBSTS_RCL. */
#define BM_USB_UH1_USBSTS_RCL (0x00002000U) /*!< Bit mask for USB_UH1_USBSTS_RCL. */
#define BS_USB_UH1_USBSTS_RCL (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_RCL. */

/*! @brief Read current value of the USB_UH1_USBSTS_RCL field. */
#define BR_USB_UH1_USBSTS_RCL(x) (HW_USB_UH1_USBSTS(x).B.RCL)

/*! @brief Format value for bitfield USB_UH1_USBSTS_RCL. */
#define BF_USB_UH1_USBSTS_RCL(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_RCL) & BM_USB_UH1_USBSTS_RCL)

/*! @brief Set the RCL field to a new value. */
#define BW_USB_UH1_USBSTS_RCL(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_RCL) | BF_USB_UH1_USBSTS_RCL(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field PS[14] (RW)
 *
 * Periodic Schedule Status - Read Only. This bit reports the current real
 * status of the Periodic Schedule. When set to zero the periodic schedule is
 * disabled, and if set to one the status is enabled. The Host Controller is not required
 * to immediately disable or enable the Periodic Schedule when software
 * transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and
 * the Periodic Schedule Enable bit are the same value, the Periodic Schedule is
 * either enabled (1) or disabled (0). Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_PS (14U)         /*!< Bit position for USB_UH1_USBSTS_PS. */
#define BM_USB_UH1_USBSTS_PS (0x00004000U) /*!< Bit mask for USB_UH1_USBSTS_PS. */
#define BS_USB_UH1_USBSTS_PS (1U)          /*!< Bit field size in bits for USB_UH1_USBSTS_PS. */

/*! @brief Read current value of the USB_UH1_USBSTS_PS field. */
#define BR_USB_UH1_USBSTS_PS(x) (HW_USB_UH1_USBSTS(x).B.PS)

/*! @brief Format value for bitfield USB_UH1_USBSTS_PS. */
#define BF_USB_UH1_USBSTS_PS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_PS) & BM_USB_UH1_USBSTS_PS)

/*! @brief Set the PS field to a new value. */
#define BW_USB_UH1_USBSTS_PS(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_PS) | BF_USB_UH1_USBSTS_PS(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field AS[15] (RW)
 *
 * Asynchronous Schedule Status - Read Only. This bit reports the current real
 * status of the Asynchronous Schedule. When set to zero the asynchronous schedule
 * status is disabled and if set to one the status is enabled. The Host
 * Controller is not required to immediately disable or enable the Asynchronous Schedule
 * when software transitions the Asynchronous Schedule Enable bit in the USBCMD
 * register. When this bit and the Asynchronous Schedule Enable bit are the same
 * value, the Asynchronous Schedule is either enabled (1) or disabled (0). Only
 * used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_AS (15U)         /*!< Bit position for USB_UH1_USBSTS_AS. */
#define BM_USB_UH1_USBSTS_AS (0x00008000U) /*!< Bit mask for USB_UH1_USBSTS_AS. */
#define BS_USB_UH1_USBSTS_AS (1U)          /*!< Bit field size in bits for USB_UH1_USBSTS_AS. */

/*! @brief Read current value of the USB_UH1_USBSTS_AS field. */
#define BR_USB_UH1_USBSTS_AS(x) (HW_USB_UH1_USBSTS(x).B.AS)

/*! @brief Format value for bitfield USB_UH1_USBSTS_AS. */
#define BF_USB_UH1_USBSTS_AS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_AS) & BM_USB_UH1_USBSTS_AS)

/*! @brief Set the AS field to a new value. */
#define BW_USB_UH1_USBSTS_AS(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_AS) | BF_USB_UH1_USBSTS_AS(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field NAKI[16] (RO)
 *
 * NAK Interrupt Bit--RO. This bit is set by hardware when for a particular
 * endpoint both the TX/RX Endpoint NAK bit and corresponding TX/RX Endpoint NAK
 * Enable bit are set. This bit is automatically cleared by hardware when all Enabled
 * TX/RX Endpoint NAK bits are cleared.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_NAKI (16U)       /*!< Bit position for USB_UH1_USBSTS_NAKI. */
#define BM_USB_UH1_USBSTS_NAKI (0x00010000U) /*!< Bit mask for USB_UH1_USBSTS_NAKI. */
#define BS_USB_UH1_USBSTS_NAKI (1U)        /*!< Bit field size in bits for USB_UH1_USBSTS_NAKI. */

/*! @brief Read current value of the USB_UH1_USBSTS_NAKI field. */
#define BR_USB_UH1_USBSTS_NAKI(x) (HW_USB_UH1_USBSTS(x).B.NAKI)
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field TI0[24] (RW)
 *
 * General Purpose Timer Interrupt 0(GPTINT0)--R/WC. This bit is set when the
 * counter in the GPTIMER0CTRL register transitions to zero, writing a one to this
 * bit clears it.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_TI0 (24U)        /*!< Bit position for USB_UH1_USBSTS_TI0. */
#define BM_USB_UH1_USBSTS_TI0 (0x01000000U) /*!< Bit mask for USB_UH1_USBSTS_TI0. */
#define BS_USB_UH1_USBSTS_TI0 (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_TI0. */

/*! @brief Read current value of the USB_UH1_USBSTS_TI0 field. */
#define BR_USB_UH1_USBSTS_TI0(x) (HW_USB_UH1_USBSTS(x).B.TI0)

/*! @brief Format value for bitfield USB_UH1_USBSTS_TI0. */
#define BF_USB_UH1_USBSTS_TI0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_TI0) & BM_USB_UH1_USBSTS_TI0)

/*! @brief Set the TI0 field to a new value. */
#define BW_USB_UH1_USBSTS_TI0(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_TI0) | BF_USB_UH1_USBSTS_TI0(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBSTS, field TI1[25] (RW)
 *
 * General Purpose Timer Interrupt 1(GPTINT1)--R/WC. This bit is set when the
 * counter in the GPTIMER1CTRL register transitions to zero, writing a one to this
 * bit will clear it.
 */
/*@{*/
#define BP_USB_UH1_USBSTS_TI1 (25U)        /*!< Bit position for USB_UH1_USBSTS_TI1. */
#define BM_USB_UH1_USBSTS_TI1 (0x02000000U) /*!< Bit mask for USB_UH1_USBSTS_TI1. */
#define BS_USB_UH1_USBSTS_TI1 (1U)         /*!< Bit field size in bits for USB_UH1_USBSTS_TI1. */

/*! @brief Read current value of the USB_UH1_USBSTS_TI1 field. */
#define BR_USB_UH1_USBSTS_TI1(x) (HW_USB_UH1_USBSTS(x).B.TI1)

/*! @brief Format value for bitfield USB_UH1_USBSTS_TI1. */
#define BF_USB_UH1_USBSTS_TI1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBSTS_TI1) & BM_USB_UH1_USBSTS_TI1)

/*! @brief Set the TI1 field to a new value. */
#define BW_USB_UH1_USBSTS_TI1(x, v) (HW_USB_UH1_USBSTS_WR(x, (HW_USB_UH1_USBSTS_RD(x) & ~BM_USB_UH1_USBSTS_TI1) | BF_USB_UH1_USBSTS_TI1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_USBINTR - Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_USBINTR - Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The interrupts to software are enabled with this register. An interrupt is
 * generated when a bit is set and the corresponding interrupt source is active.
 * The USB Status register (n_USBSTS) still shows interrupt sources even if they
 * are disabled by the n_USBINTR register, allowing polling of interrupt events by
 * the software.
 */
typedef union _hw_usb_uh1_usbintr
{
    uint32_t U;
    struct _hw_usb_uh1_usbintr_bitfields
    {
        uint32_t UE : 1;               /*!< [0]  */
        uint32_t UEE : 1;              /*!< [1]  */
        uint32_t PCE : 1;              /*!< [2]  */
        uint32_t FRE : 1;              /*!< [3]  */
        uint32_t SEE : 1;              /*!< [4]  */
        uint32_t AAE : 1;              /*!< [5]  */
        uint32_t URE : 1;              /*!< [6]  */
        uint32_t SRE : 1;              /*!< [7]  */
        uint32_t SLE : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPIE : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t NAKE : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 1;        /*!< [17]  */
        uint32_t UAIE : 1;             /*!< [18]  */
        uint32_t UPIE : 1;             /*!< [19]  */
        uint32_t RESERVED3 : 4;        /*!< [23:20]  */
        uint32_t TIE0 : 1;             /*!< [24]  */
        uint32_t TIE1 : 1;             /*!< [25]  */
        uint32_t RESERVED4 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh1_usbintr_t;

/*!
 * @name Constants and macros for entire USB_UH1_USBINTR register
 */
/*@{*/
#define HW_USB_UH1_USBINTR_ADDR(x) ((uintptr_t)(x) + 0x348U)

#define HW_USB_UH1_USBINTR(x)    (*(__IO hw_usb_uh1_usbintr_t *) HW_USB_UH1_USBINTR_ADDR(x))
#define HW_USB_UH1_USBINTR_RD(x) (HW_USB_UH1_USBINTR(x).U)
#define HW_USB_UH1_USBINTR_WR(x, v) (HW_USB_UH1_USBINTR(x).U = (v))
#define HW_USB_UH1_USBINTR_SET(x, v) (HW_USB_UH1_USBINTR_WR(x, HW_USB_UH1_USBINTR_RD(x) |  (v)))
#define HW_USB_UH1_USBINTR_CLR(x, v) (HW_USB_UH1_USBINTR_WR(x, HW_USB_UH1_USBINTR_RD(x) & ~(v)))
#define HW_USB_UH1_USBINTR_TOG(x, v) (HW_USB_UH1_USBINTR_WR(x, HW_USB_UH1_USBINTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_USBINTR bitfields
 */

/*!
 * @name Register USB_UH1_USBINTR, field UE[0] (RW)
 *
 * USB Interrupt Enalbe When this bit is one and the UI bit in n_USBSTS register
 * is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_UE (0U)         /*!< Bit position for USB_UH1_USBINTR_UE. */
#define BM_USB_UH1_USBINTR_UE (0x00000001U) /*!< Bit mask for USB_UH1_USBINTR_UE. */
#define BS_USB_UH1_USBINTR_UE (1U)         /*!< Bit field size in bits for USB_UH1_USBINTR_UE. */

/*! @brief Read current value of the USB_UH1_USBINTR_UE field. */
#define BR_USB_UH1_USBINTR_UE(x) (HW_USB_UH1_USBINTR(x).B.UE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_UE. */
#define BF_USB_UH1_USBINTR_UE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_UE) & BM_USB_UH1_USBINTR_UE)

/*! @brief Set the UE field to a new value. */
#define BW_USB_UH1_USBINTR_UE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_UE) | BF_USB_UH1_USBINTR_UE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field UEE[1] (RW)
 *
 * USB Error Interrupt Enable When this bit is one and the UEI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_UEE (1U)        /*!< Bit position for USB_UH1_USBINTR_UEE. */
#define BM_USB_UH1_USBINTR_UEE (0x00000002U) /*!< Bit mask for USB_UH1_USBINTR_UEE. */
#define BS_USB_UH1_USBINTR_UEE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_UEE. */

/*! @brief Read current value of the USB_UH1_USBINTR_UEE field. */
#define BR_USB_UH1_USBINTR_UEE(x) (HW_USB_UH1_USBINTR(x).B.UEE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_UEE. */
#define BF_USB_UH1_USBINTR_UEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_UEE) & BM_USB_UH1_USBINTR_UEE)

/*! @brief Set the UEE field to a new value. */
#define BW_USB_UH1_USBINTR_UEE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_UEE) | BF_USB_UH1_USBINTR_UEE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field PCE[2] (RW)
 *
 * Port Change Detect Interrupt Enable When this bit is one and the PCI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_PCE (2U)        /*!< Bit position for USB_UH1_USBINTR_PCE. */
#define BM_USB_UH1_USBINTR_PCE (0x00000004U) /*!< Bit mask for USB_UH1_USBINTR_PCE. */
#define BS_USB_UH1_USBINTR_PCE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_PCE. */

/*! @brief Read current value of the USB_UH1_USBINTR_PCE field. */
#define BR_USB_UH1_USBINTR_PCE(x) (HW_USB_UH1_USBINTR(x).B.PCE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_PCE. */
#define BF_USB_UH1_USBINTR_PCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_PCE) & BM_USB_UH1_USBINTR_PCE)

/*! @brief Set the PCE field to a new value. */
#define BW_USB_UH1_USBINTR_PCE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_PCE) | BF_USB_UH1_USBINTR_PCE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field FRE[3] (RW)
 *
 * Frame List Rollover Interrupt Enable When this bit is one and the FRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used
 * in host operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_FRE (3U)        /*!< Bit position for USB_UH1_USBINTR_FRE. */
#define BM_USB_UH1_USBINTR_FRE (0x00000008U) /*!< Bit mask for USB_UH1_USBINTR_FRE. */
#define BS_USB_UH1_USBINTR_FRE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_FRE. */

/*! @brief Read current value of the USB_UH1_USBINTR_FRE field. */
#define BR_USB_UH1_USBINTR_FRE(x) (HW_USB_UH1_USBINTR(x).B.FRE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_FRE. */
#define BF_USB_UH1_USBINTR_FRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_FRE) & BM_USB_UH1_USBINTR_FRE)

/*! @brief Set the FRE field to a new value. */
#define BW_USB_UH1_USBINTR_FRE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_FRE) | BF_USB_UH1_USBINTR_FRE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field SEE[4] (RW)
 *
 * System Error Interrupt Enable When this bit is one and the SEI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_SEE (4U)        /*!< Bit position for USB_UH1_USBINTR_SEE. */
#define BM_USB_UH1_USBINTR_SEE (0x00000010U) /*!< Bit mask for USB_UH1_USBINTR_SEE. */
#define BS_USB_UH1_USBINTR_SEE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_SEE. */

/*! @brief Read current value of the USB_UH1_USBINTR_SEE field. */
#define BR_USB_UH1_USBINTR_SEE(x) (HW_USB_UH1_USBINTR(x).B.SEE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_SEE. */
#define BF_USB_UH1_USBINTR_SEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_SEE) & BM_USB_UH1_USBINTR_SEE)

/*! @brief Set the SEE field to a new value. */
#define BW_USB_UH1_USBINTR_SEE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_SEE) | BF_USB_UH1_USBINTR_SEE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field AAE[5] (RW)
 *
 * Async Advance Interrupt Enable When this bit is one and the AAI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_AAE (5U)        /*!< Bit position for USB_UH1_USBINTR_AAE. */
#define BM_USB_UH1_USBINTR_AAE (0x00000020U) /*!< Bit mask for USB_UH1_USBINTR_AAE. */
#define BS_USB_UH1_USBINTR_AAE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_AAE. */

/*! @brief Read current value of the USB_UH1_USBINTR_AAE field. */
#define BR_USB_UH1_USBINTR_AAE(x) (HW_USB_UH1_USBINTR(x).B.AAE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_AAE. */
#define BF_USB_UH1_USBINTR_AAE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_AAE) & BM_USB_UH1_USBINTR_AAE)

/*! @brief Set the AAE field to a new value. */
#define BW_USB_UH1_USBINTR_AAE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_AAE) | BF_USB_UH1_USBINTR_AAE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field URE[6] (RW)
 *
 * USB Reset Interrupt Enable When this bit is one and the URI bit in n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_URE (6U)        /*!< Bit position for USB_UH1_USBINTR_URE. */
#define BM_USB_UH1_USBINTR_URE (0x00000040U) /*!< Bit mask for USB_UH1_USBINTR_URE. */
#define BS_USB_UH1_USBINTR_URE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_URE. */

/*! @brief Read current value of the USB_UH1_USBINTR_URE field. */
#define BR_USB_UH1_USBINTR_URE(x) (HW_USB_UH1_USBINTR(x).B.URE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_URE. */
#define BF_USB_UH1_USBINTR_URE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_URE) & BM_USB_UH1_USBINTR_URE)

/*! @brief Set the URE field to a new value. */
#define BW_USB_UH1_USBINTR_URE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_URE) | BF_USB_UH1_USBINTR_URE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field SRE[7] (RW)
 *
 * SOF Received Interrupt Enable When this bit is one and the SRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_SRE (7U)        /*!< Bit position for USB_UH1_USBINTR_SRE. */
#define BM_USB_UH1_USBINTR_SRE (0x00000080U) /*!< Bit mask for USB_UH1_USBINTR_SRE. */
#define BS_USB_UH1_USBINTR_SRE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_SRE. */

/*! @brief Read current value of the USB_UH1_USBINTR_SRE field. */
#define BR_USB_UH1_USBINTR_SRE(x) (HW_USB_UH1_USBINTR(x).B.SRE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_SRE. */
#define BF_USB_UH1_USBINTR_SRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_SRE) & BM_USB_UH1_USBINTR_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_USB_UH1_USBINTR_SRE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_SRE) | BF_USB_UH1_USBINTR_SRE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field SLE[8] (RW)
 *
 * Sleep Interrupt Enable When this bit is one and the SLI bit in n_n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_SLE (8U)        /*!< Bit position for USB_UH1_USBINTR_SLE. */
#define BM_USB_UH1_USBINTR_SLE (0x00000100U) /*!< Bit mask for USB_UH1_USBINTR_SLE. */
#define BS_USB_UH1_USBINTR_SLE (1U)        /*!< Bit field size in bits for USB_UH1_USBINTR_SLE. */

/*! @brief Read current value of the USB_UH1_USBINTR_SLE field. */
#define BR_USB_UH1_USBINTR_SLE(x) (HW_USB_UH1_USBINTR(x).B.SLE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_SLE. */
#define BF_USB_UH1_USBINTR_SLE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_SLE) & BM_USB_UH1_USBINTR_SLE)

/*! @brief Set the SLE field to a new value. */
#define BW_USB_UH1_USBINTR_SLE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_SLE) | BF_USB_UH1_USBINTR_SLE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field ULPIE[10] (RW)
 *
 * ULPI Interrupt Enable When this bit is one and the UPLII bit in n_USBSTS
 * register is a one the controller will issue an interrupt. This bit is usable only
 * if the controller support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_ULPIE (10U)     /*!< Bit position for USB_UH1_USBINTR_ULPIE. */
#define BM_USB_UH1_USBINTR_ULPIE (0x00000400U) /*!< Bit mask for USB_UH1_USBINTR_ULPIE. */
#define BS_USB_UH1_USBINTR_ULPIE (1U)      /*!< Bit field size in bits for USB_UH1_USBINTR_ULPIE. */

/*! @brief Read current value of the USB_UH1_USBINTR_ULPIE field. */
#define BR_USB_UH1_USBINTR_ULPIE(x) (HW_USB_UH1_USBINTR(x).B.ULPIE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_ULPIE. */
#define BF_USB_UH1_USBINTR_ULPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_ULPIE) & BM_USB_UH1_USBINTR_ULPIE)

/*! @brief Set the ULPIE field to a new value. */
#define BW_USB_UH1_USBINTR_ULPIE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_ULPIE) | BF_USB_UH1_USBINTR_ULPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field NAKE[16] (RW)
 *
 * NAK Interrupt Enable When this bit is one and the NAKI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_NAKE (16U)      /*!< Bit position for USB_UH1_USBINTR_NAKE. */
#define BM_USB_UH1_USBINTR_NAKE (0x00010000U) /*!< Bit mask for USB_UH1_USBINTR_NAKE. */
#define BS_USB_UH1_USBINTR_NAKE (1U)       /*!< Bit field size in bits for USB_UH1_USBINTR_NAKE. */

/*! @brief Read current value of the USB_UH1_USBINTR_NAKE field. */
#define BR_USB_UH1_USBINTR_NAKE(x) (HW_USB_UH1_USBINTR(x).B.NAKE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_NAKE. */
#define BF_USB_UH1_USBINTR_NAKE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_NAKE) & BM_USB_UH1_USBINTR_NAKE)

/*! @brief Set the NAKE field to a new value. */
#define BW_USB_UH1_USBINTR_NAKE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_NAKE) | BF_USB_UH1_USBINTR_NAKE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field UAIE[18] (RW)
 *
 * USB Host Asynchronous Interrupt Enable When this bit is one, and the UAI bit
 * in the n_USBSTS register is one, host controller will issue an interrupt at
 * the next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_UAIE (18U)      /*!< Bit position for USB_UH1_USBINTR_UAIE. */
#define BM_USB_UH1_USBINTR_UAIE (0x00040000U) /*!< Bit mask for USB_UH1_USBINTR_UAIE. */
#define BS_USB_UH1_USBINTR_UAIE (1U)       /*!< Bit field size in bits for USB_UH1_USBINTR_UAIE. */

/*! @brief Read current value of the USB_UH1_USBINTR_UAIE field. */
#define BR_USB_UH1_USBINTR_UAIE(x) (HW_USB_UH1_USBINTR(x).B.UAIE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_UAIE. */
#define BF_USB_UH1_USBINTR_UAIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_UAIE) & BM_USB_UH1_USBINTR_UAIE)

/*! @brief Set the UAIE field to a new value. */
#define BW_USB_UH1_USBINTR_UAIE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_UAIE) | BF_USB_UH1_USBINTR_UAIE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field UPIE[19] (RW)
 *
 * USB Host Periodic Interrupt Enable When this bit is one, and the UPI bit in
 * the n_USBSTS register is one, host controller will issue an interrupt at the
 * next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_UPIE (19U)      /*!< Bit position for USB_UH1_USBINTR_UPIE. */
#define BM_USB_UH1_USBINTR_UPIE (0x00080000U) /*!< Bit mask for USB_UH1_USBINTR_UPIE. */
#define BS_USB_UH1_USBINTR_UPIE (1U)       /*!< Bit field size in bits for USB_UH1_USBINTR_UPIE. */

/*! @brief Read current value of the USB_UH1_USBINTR_UPIE field. */
#define BR_USB_UH1_USBINTR_UPIE(x) (HW_USB_UH1_USBINTR(x).B.UPIE)

/*! @brief Format value for bitfield USB_UH1_USBINTR_UPIE. */
#define BF_USB_UH1_USBINTR_UPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_UPIE) & BM_USB_UH1_USBINTR_UPIE)

/*! @brief Set the UPIE field to a new value. */
#define BW_USB_UH1_USBINTR_UPIE(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_UPIE) | BF_USB_UH1_USBINTR_UPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field TIE0[24] (RW)
 *
 * General Purpose Timer #0 Interrupt Enable When this bit is one and the TI0
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_TIE0 (24U)      /*!< Bit position for USB_UH1_USBINTR_TIE0. */
#define BM_USB_UH1_USBINTR_TIE0 (0x01000000U) /*!< Bit mask for USB_UH1_USBINTR_TIE0. */
#define BS_USB_UH1_USBINTR_TIE0 (1U)       /*!< Bit field size in bits for USB_UH1_USBINTR_TIE0. */

/*! @brief Read current value of the USB_UH1_USBINTR_TIE0 field. */
#define BR_USB_UH1_USBINTR_TIE0(x) (HW_USB_UH1_USBINTR(x).B.TIE0)

/*! @brief Format value for bitfield USB_UH1_USBINTR_TIE0. */
#define BF_USB_UH1_USBINTR_TIE0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_TIE0) & BM_USB_UH1_USBINTR_TIE0)

/*! @brief Set the TIE0 field to a new value. */
#define BW_USB_UH1_USBINTR_TIE0(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_TIE0) | BF_USB_UH1_USBINTR_TIE0(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBINTR, field TIE1[25] (RW)
 *
 * General Purpose Timer #1 Interrupt Enable When this bit is one and the TI1
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH1_USBINTR_TIE1 (25U)      /*!< Bit position for USB_UH1_USBINTR_TIE1. */
#define BM_USB_UH1_USBINTR_TIE1 (0x02000000U) /*!< Bit mask for USB_UH1_USBINTR_TIE1. */
#define BS_USB_UH1_USBINTR_TIE1 (1U)       /*!< Bit field size in bits for USB_UH1_USBINTR_TIE1. */

/*! @brief Read current value of the USB_UH1_USBINTR_TIE1 field. */
#define BR_USB_UH1_USBINTR_TIE1(x) (HW_USB_UH1_USBINTR(x).B.TIE1)

/*! @brief Format value for bitfield USB_UH1_USBINTR_TIE1. */
#define BF_USB_UH1_USBINTR_TIE1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBINTR_TIE1) & BM_USB_UH1_USBINTR_TIE1)

/*! @brief Set the TIE1 field to a new value. */
#define BW_USB_UH1_USBINTR_TIE1(x, v) (HW_USB_UH1_USBINTR_WR(x, (HW_USB_UH1_USBINTR_RD(x) & ~BM_USB_UH1_USBINTR_TIE1) | BF_USB_UH1_USBINTR_TIE1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_FRINDEX - USB Frame Index
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_FRINDEX - USB Frame Index (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the host controller to index the periodic frame
 * list. The register updates every 125 microseconds (once each micro-frame). Bits
 * [N: 3] are used to select a particular entry in the Periodic Frame List during
 * periodic schedule execution. The number of bits used for the index depends on
 * the size of the frame list as set by system software in the Frame List Size
 * field in the n_USBCMD register. This register must be written as a DWord. Byte
 * writes produce undefined results. This register cannot be written unless the
 * Host Controller is in the 'Halted' state as indicated by the HCHalted bit. A
 * write to this register while the Run/Stop hit is set to a one produces undefined
 * results. Writes to this register also affect the SOF value. In device mode this
 * register is read only and, the device controller updates the FRINDEX [13:3]
 * register from the frame number indicated by the SOF marker. Whenever a SOF is
 * received by the USB bus, FRINDEX [13:3] will be checked against the SOF marker.
 * If FRINDEX [13:3] is different from the SOF marker, FRINDEX [13:3] will be
 * set to the SOF value and FRINDEX [2:0] will be set to zero (that is, SOF for 1
 * ms frame). If FRINDEX [13:3] is equal to the SOF value, FRINDEX [2:0] will be
 * increment (that is, SOF for 125 us micro-frame.).
 */
typedef union _hw_usb_uh1_frindex
{
    uint32_t U;
    struct _hw_usb_uh1_frindex_bitfields
    {
        uint32_t FRINDEX : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_usb_uh1_frindex_t;

/*!
 * @name Constants and macros for entire USB_UH1_FRINDEX register
 */
/*@{*/
#define HW_USB_UH1_FRINDEX_ADDR(x) ((uintptr_t)(x) + 0x34CU)

#define HW_USB_UH1_FRINDEX(x)    (*(__IO hw_usb_uh1_frindex_t *) HW_USB_UH1_FRINDEX_ADDR(x))
#define HW_USB_UH1_FRINDEX_RD(x) (HW_USB_UH1_FRINDEX(x).U)
#define HW_USB_UH1_FRINDEX_WR(x, v) (HW_USB_UH1_FRINDEX(x).U = (v))
#define HW_USB_UH1_FRINDEX_SET(x, v) (HW_USB_UH1_FRINDEX_WR(x, HW_USB_UH1_FRINDEX_RD(x) |  (v)))
#define HW_USB_UH1_FRINDEX_CLR(x, v) (HW_USB_UH1_FRINDEX_WR(x, HW_USB_UH1_FRINDEX_RD(x) & ~(v)))
#define HW_USB_UH1_FRINDEX_TOG(x, v) (HW_USB_UH1_FRINDEX_WR(x, HW_USB_UH1_FRINDEX_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_FRINDEX bitfields
 */

/*!
 * @name Register USB_UH1_FRINDEX, field FRINDEX[13:0] (RW)
 *
 * Frame Index. The value, in this register, increments at the end of each time
 * frame (micro-frame). Bits [N: 3] are used for the Frame List current index.
 * This means that each location of the frame list is accessed 8 times (frames or
 * micro-frames) before moving to the next index. The following illustrates values
 * of N based on the value of the Frame List Size field in the USBCMD register,
 * when used in host mode. USBCMD [Frame List Size] Number Elements N In device
 * mode the value is the current frame number of the last frame transmitted. It is
 * not used as an index. In either mode bits 2:0 indicate the current microframe.
 *
 * Values:
 * - 000 - (1024) 12
 * - 001 - (512) 11
 * - 010 - (256) 10
 * - 011 - (128) 9
 * - 100 - (64) 8
 * - 101 - (32) 7
 * - 110 - (16) 6
 * - 111 - (8) 5
 */
/*@{*/
#define BP_USB_UH1_FRINDEX_FRINDEX (0U)    /*!< Bit position for USB_UH1_FRINDEX_FRINDEX. */
#define BM_USB_UH1_FRINDEX_FRINDEX (0x00003FFFU) /*!< Bit mask for USB_UH1_FRINDEX_FRINDEX. */
#define BS_USB_UH1_FRINDEX_FRINDEX (14U)   /*!< Bit field size in bits for USB_UH1_FRINDEX_FRINDEX. */

/*! @brief Read current value of the USB_UH1_FRINDEX_FRINDEX field. */
#define BR_USB_UH1_FRINDEX_FRINDEX(x) (HW_USB_UH1_FRINDEX(x).B.FRINDEX)

/*! @brief Format value for bitfield USB_UH1_FRINDEX_FRINDEX. */
#define BF_USB_UH1_FRINDEX_FRINDEX(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_FRINDEX_FRINDEX) & BM_USB_UH1_FRINDEX_FRINDEX)

/*! @brief Set the FRINDEX field to a new value. */
#define BW_USB_UH1_FRINDEX_FRINDEX(x, v) (HW_USB_UH1_FRINDEX_WR(x, (HW_USB_UH1_FRINDEX_RD(x) & ~BM_USB_UH1_FRINDEX_FRINDEX) | BF_USB_UH1_FRINDEX_FRINDEX(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_PERIODICLISTBASE - Frame List Base Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_PERIODICLISTBASE - Frame List Base Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the beginning address of
 * the Periodic Frame List in the system memory. HCD loads this register prior to
 * starting the schedule execution by the Host Controller. The memory structure
 * referenced by this physical memory pointer is assumed to be 4-Kbyte aligned.
 * The contents of this register are combined with the Frame Index Register
 * (USB_n_FRINDEX) to enable the Host Controller to step through the Periodic Frame List
 * in sequence.
 */
typedef union _hw_usb_uh1_periodiclistbase
{
    uint32_t U;
    struct _hw_usb_uh1_periodiclistbase_bitfields
    {
        uint32_t RESERVED0 : 12;       /*!< [11:0]  */
        uint32_t BASEADR : 20;         /*!< [31:12]  */
    } B;
} hw_usb_uh1_periodiclistbase_t;

/*!
 * @name Constants and macros for entire USB_UH1_PERIODICLISTBASE register
 */
/*@{*/
#define HW_USB_UH1_PERIODICLISTBASE_ADDR(x) ((uintptr_t)(x) + 0x354U)

#define HW_USB_UH1_PERIODICLISTBASE(x) (*(__IO hw_usb_uh1_periodiclistbase_t *) HW_USB_UH1_PERIODICLISTBASE_ADDR(x))
#define HW_USB_UH1_PERIODICLISTBASE_RD(x) (HW_USB_UH1_PERIODICLISTBASE(x).U)
#define HW_USB_UH1_PERIODICLISTBASE_WR(x, v) (HW_USB_UH1_PERIODICLISTBASE(x).U = (v))
#define HW_USB_UH1_PERIODICLISTBASE_SET(x, v) (HW_USB_UH1_PERIODICLISTBASE_WR(x, HW_USB_UH1_PERIODICLISTBASE_RD(x) |  (v)))
#define HW_USB_UH1_PERIODICLISTBASE_CLR(x, v) (HW_USB_UH1_PERIODICLISTBASE_WR(x, HW_USB_UH1_PERIODICLISTBASE_RD(x) & ~(v)))
#define HW_USB_UH1_PERIODICLISTBASE_TOG(x, v) (HW_USB_UH1_PERIODICLISTBASE_WR(x, HW_USB_UH1_PERIODICLISTBASE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_PERIODICLISTBASE bitfields
 */

/*!
 * @name Register USB_UH1_PERIODICLISTBASE, field BASEADR[31:12] (RW)
 *
 * Base Address (Low). These bits correspond to memory address signals [31:12],
 * respectively. Only used by the host controller.
 */
/*@{*/
#define BP_USB_UH1_PERIODICLISTBASE_BASEADR (12U) /*!< Bit position for USB_UH1_PERIODICLISTBASE_BASEADR. */
#define BM_USB_UH1_PERIODICLISTBASE_BASEADR (0xFFFFF000U) /*!< Bit mask for USB_UH1_PERIODICLISTBASE_BASEADR. */
#define BS_USB_UH1_PERIODICLISTBASE_BASEADR (20U) /*!< Bit field size in bits for USB_UH1_PERIODICLISTBASE_BASEADR. */

/*! @brief Read current value of the USB_UH1_PERIODICLISTBASE_BASEADR field. */
#define BR_USB_UH1_PERIODICLISTBASE_BASEADR(x) (HW_USB_UH1_PERIODICLISTBASE(x).B.BASEADR)

/*! @brief Format value for bitfield USB_UH1_PERIODICLISTBASE_BASEADR. */
#define BF_USB_UH1_PERIODICLISTBASE_BASEADR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PERIODICLISTBASE_BASEADR) & BM_USB_UH1_PERIODICLISTBASE_BASEADR)

/*! @brief Set the BASEADR field to a new value. */
#define BW_USB_UH1_PERIODICLISTBASE_BASEADR(x, v) (HW_USB_UH1_PERIODICLISTBASE_WR(x, (HW_USB_UH1_PERIODICLISTBASE_RD(x) & ~BM_USB_UH1_PERIODICLISTBASE_BASEADR) | BF_USB_UH1_PERIODICLISTBASE_BASEADR(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_ASYNCLISTADDR - Next Asynch. Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_ASYNCLISTADDR - Next Asynch. Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the address of the next
 * asynchronous queue head to be executed by the host. Bits [4:0] of this register
 * cannot be modified by the system software and will always return a zero when
 * read.
 */
typedef union _hw_usb_uh1_asynclistaddr
{
    uint32_t U;
    struct _hw_usb_uh1_asynclistaddr_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t ASYBASE : 27;         /*!< [31:5]  */
    } B;
} hw_usb_uh1_asynclistaddr_t;

/*!
 * @name Constants and macros for entire USB_UH1_ASYNCLISTADDR register
 */
/*@{*/
#define HW_USB_UH1_ASYNCLISTADDR_ADDR(x) ((uintptr_t)(x) + 0x358U)

#define HW_USB_UH1_ASYNCLISTADDR(x) (*(__IO hw_usb_uh1_asynclistaddr_t *) HW_USB_UH1_ASYNCLISTADDR_ADDR(x))
#define HW_USB_UH1_ASYNCLISTADDR_RD(x) (HW_USB_UH1_ASYNCLISTADDR(x).U)
#define HW_USB_UH1_ASYNCLISTADDR_WR(x, v) (HW_USB_UH1_ASYNCLISTADDR(x).U = (v))
#define HW_USB_UH1_ASYNCLISTADDR_SET(x, v) (HW_USB_UH1_ASYNCLISTADDR_WR(x, HW_USB_UH1_ASYNCLISTADDR_RD(x) |  (v)))
#define HW_USB_UH1_ASYNCLISTADDR_CLR(x, v) (HW_USB_UH1_ASYNCLISTADDR_WR(x, HW_USB_UH1_ASYNCLISTADDR_RD(x) & ~(v)))
#define HW_USB_UH1_ASYNCLISTADDR_TOG(x, v) (HW_USB_UH1_ASYNCLISTADDR_WR(x, HW_USB_UH1_ASYNCLISTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_ASYNCLISTADDR bitfields
 */

/*!
 * @name Register USB_UH1_ASYNCLISTADDR, field ASYBASE[31:5] (RW)
 *
 * Link Pointer Low (LPL). These bits correspond to memory address signals
 * [31:5], respectively. This field may only reference a Queue Head (QH). Only used by
 * the host controller.
 */
/*@{*/
#define BP_USB_UH1_ASYNCLISTADDR_ASYBASE (5U) /*!< Bit position for USB_UH1_ASYNCLISTADDR_ASYBASE. */
#define BM_USB_UH1_ASYNCLISTADDR_ASYBASE (0xFFFFFFE0U) /*!< Bit mask for USB_UH1_ASYNCLISTADDR_ASYBASE. */
#define BS_USB_UH1_ASYNCLISTADDR_ASYBASE (27U) /*!< Bit field size in bits for USB_UH1_ASYNCLISTADDR_ASYBASE. */

/*! @brief Read current value of the USB_UH1_ASYNCLISTADDR_ASYBASE field. */
#define BR_USB_UH1_ASYNCLISTADDR_ASYBASE(x) (HW_USB_UH1_ASYNCLISTADDR(x).B.ASYBASE)

/*! @brief Format value for bitfield USB_UH1_ASYNCLISTADDR_ASYBASE. */
#define BF_USB_UH1_ASYNCLISTADDR_ASYBASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_ASYNCLISTADDR_ASYBASE) & BM_USB_UH1_ASYNCLISTADDR_ASYBASE)

/*! @brief Set the ASYBASE field to a new value. */
#define BW_USB_UH1_ASYNCLISTADDR_ASYBASE(x, v) (HW_USB_UH1_ASYNCLISTADDR_WR(x, (HW_USB_UH1_ASYNCLISTADDR_RD(x) & ~BM_USB_UH1_ASYNCLISTADDR_ASYBASE) | BF_USB_UH1_ASYNCLISTADDR_ASYBASE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_BURSTSIZE - Programmable Burst Size
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_BURSTSIZE - Programmable Burst Size (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control the burst size used during data movement on
 * the AHB master interface. This register is ignored if AHBBRST bits in SBUSCFG
 * register is non-zero value.
 */
typedef union _hw_usb_uh1_burstsize
{
    uint32_t U;
    struct _hw_usb_uh1_burstsize_bitfields
    {
        uint32_t RXPBURST : 8;         /*!< [7:0]  */
        uint32_t TXPBURST : 9;         /*!< [16:8]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_usb_uh1_burstsize_t;

/*!
 * @name Constants and macros for entire USB_UH1_BURSTSIZE register
 */
/*@{*/
#define HW_USB_UH1_BURSTSIZE_ADDR(x) ((uintptr_t)(x) + 0x360U)

#define HW_USB_UH1_BURSTSIZE(x)  (*(__IO hw_usb_uh1_burstsize_t *) HW_USB_UH1_BURSTSIZE_ADDR(x))
#define HW_USB_UH1_BURSTSIZE_RD(x) (HW_USB_UH1_BURSTSIZE(x).U)
#define HW_USB_UH1_BURSTSIZE_WR(x, v) (HW_USB_UH1_BURSTSIZE(x).U = (v))
#define HW_USB_UH1_BURSTSIZE_SET(x, v) (HW_USB_UH1_BURSTSIZE_WR(x, HW_USB_UH1_BURSTSIZE_RD(x) |  (v)))
#define HW_USB_UH1_BURSTSIZE_CLR(x, v) (HW_USB_UH1_BURSTSIZE_WR(x, HW_USB_UH1_BURSTSIZE_RD(x) & ~(v)))
#define HW_USB_UH1_BURSTSIZE_TOG(x, v) (HW_USB_UH1_BURSTSIZE_WR(x, HW_USB_UH1_BURSTSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_BURSTSIZE bitfields
 */

/*!
 * @name Register USB_UH1_BURSTSIZE, field RXPBURST[7:0] (RW)
 *
 * Programmable RX Burst Size. Default value is determined by TXBURST bits in
 * n_HWRXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from the USB bus to system memory.
 */
/*@{*/
#define BP_USB_UH1_BURSTSIZE_RXPBURST (0U) /*!< Bit position for USB_UH1_BURSTSIZE_RXPBURST. */
#define BM_USB_UH1_BURSTSIZE_RXPBURST (0x000000FFU) /*!< Bit mask for USB_UH1_BURSTSIZE_RXPBURST. */
#define BS_USB_UH1_BURSTSIZE_RXPBURST (8U) /*!< Bit field size in bits for USB_UH1_BURSTSIZE_RXPBURST. */

/*! @brief Read current value of the USB_UH1_BURSTSIZE_RXPBURST field. */
#define BR_USB_UH1_BURSTSIZE_RXPBURST(x) (HW_USB_UH1_BURSTSIZE(x).B.RXPBURST)

/*! @brief Format value for bitfield USB_UH1_BURSTSIZE_RXPBURST. */
#define BF_USB_UH1_BURSTSIZE_RXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_BURSTSIZE_RXPBURST) & BM_USB_UH1_BURSTSIZE_RXPBURST)

/*! @brief Set the RXPBURST field to a new value. */
#define BW_USB_UH1_BURSTSIZE_RXPBURST(x, v) (HW_USB_UH1_BURSTSIZE_WR(x, (HW_USB_UH1_BURSTSIZE_RD(x) & ~BM_USB_UH1_BURSTSIZE_RXPBURST) | BF_USB_UH1_BURSTSIZE_RXPBURST(v)))
/*@}*/

/*!
 * @name Register USB_UH1_BURSTSIZE, field TXPBURST[16:8] (RW)
 *
 * Programmable TX Burst Size. Default value is determined by TXBURST bits in
 * n_HWTXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from system memory to the USB bus.
 */
/*@{*/
#define BP_USB_UH1_BURSTSIZE_TXPBURST (8U) /*!< Bit position for USB_UH1_BURSTSIZE_TXPBURST. */
#define BM_USB_UH1_BURSTSIZE_TXPBURST (0x0001FF00U) /*!< Bit mask for USB_UH1_BURSTSIZE_TXPBURST. */
#define BS_USB_UH1_BURSTSIZE_TXPBURST (9U) /*!< Bit field size in bits for USB_UH1_BURSTSIZE_TXPBURST. */

/*! @brief Read current value of the USB_UH1_BURSTSIZE_TXPBURST field. */
#define BR_USB_UH1_BURSTSIZE_TXPBURST(x) (HW_USB_UH1_BURSTSIZE(x).B.TXPBURST)

/*! @brief Format value for bitfield USB_UH1_BURSTSIZE_TXPBURST. */
#define BF_USB_UH1_BURSTSIZE_TXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_BURSTSIZE_TXPBURST) & BM_USB_UH1_BURSTSIZE_TXPBURST)

/*! @brief Set the TXPBURST field to a new value. */
#define BW_USB_UH1_BURSTSIZE_TXPBURST(x, v) (HW_USB_UH1_BURSTSIZE_WR(x, (HW_USB_UH1_BURSTSIZE_RD(x) & ~BM_USB_UH1_BURSTSIZE_TXPBURST) | BF_USB_UH1_BURSTSIZE_TXPBURST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_TXFILLTUNING - TX FIFO Fill Tuning
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_TXFILLTUNING - TX FIFO Fill Tuning (RW)
 *
 * Reset value: 0x00000808U
 *
 * The fields in this register control performance tuning associated with how
 * the host controller posts data to the TX latency FIFO before moving the data
 * onto the USB bus. The specific areas of performance include the how much data to
 * post into the FIFO and an estimate for how long that operation should take in
 * the target system. Definitions: T 0 = Standard packet overhead T 1 = Time to
 * send data payload T ff = Time to fetch packet into TX FIFO up to specified
 * level. T s = Total Packet Flight Time (send-only) packet T s = T 0 + T 1 T p =
 * Total Packet Time (fetch and send) packet T p = T ff + T 0 + T 1 Upon discovery
 * of a transmit (OUT/SETUP) packet in the data structures, host controller checks
 * to ensure T p remains before the end of the [micro]frame. If so it proceeds
 * to pre-fill the TX FIFO. If at anytime during the pre-fill operation the time
 * remaining the [micro]frame is < T s then the packet attempt ceases and the
 * packet is tried at a later time. Although this is not an error condition and the
 * host controller will eventually recover, a mark will be made the scheduler
 * health counter to note the occurrence of a "back-off" event. When a back-off event
 * is detected, the partial packet fetched may need to be discarded from the
 * latency buffer to make room for periodic traffic that will begin after the next
 * SOF. Too many back-off events can waste bandwidth and power on the system bus
 * and thus should be minimized (not necessarily eliminated). Back-offs can be
 * minimized with use of the n_TSCHHEALTH ( T ff ) described below. The reset value
 * could vary from instance to instance. Please see the detail in bit field
 * description and ignore reset value in summary table in this case!
 */
typedef union _hw_usb_uh1_txfilltuning
{
    uint32_t U;
    struct _hw_usb_uh1_txfilltuning_bitfields
    {
        uint32_t TXSCHOH : 8;          /*!< [7:0]  */
        uint32_t TXSCHHEALTH : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t TXFIFOTHRES : 6;      /*!< [21:16]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_usb_uh1_txfilltuning_t;

/*!
 * @name Constants and macros for entire USB_UH1_TXFILLTUNING register
 */
/*@{*/
#define HW_USB_UH1_TXFILLTUNING_ADDR(x) ((uintptr_t)(x) + 0x364U)

#define HW_USB_UH1_TXFILLTUNING(x) (*(__IO hw_usb_uh1_txfilltuning_t *) HW_USB_UH1_TXFILLTUNING_ADDR(x))
#define HW_USB_UH1_TXFILLTUNING_RD(x) (HW_USB_UH1_TXFILLTUNING(x).U)
#define HW_USB_UH1_TXFILLTUNING_WR(x, v) (HW_USB_UH1_TXFILLTUNING(x).U = (v))
#define HW_USB_UH1_TXFILLTUNING_SET(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, HW_USB_UH1_TXFILLTUNING_RD(x) |  (v)))
#define HW_USB_UH1_TXFILLTUNING_CLR(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, HW_USB_UH1_TXFILLTUNING_RD(x) & ~(v)))
#define HW_USB_UH1_TXFILLTUNING_TOG(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, HW_USB_UH1_TXFILLTUNING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_TXFILLTUNING bitfields
 */

/*!
 * @name Register USB_UH1_TXFILLTUNING, field TXSCHOH[7:0] (RW)
 *
 * Scheduler Overhead. (Read/Write) [Default = 0] This register adds an
 * additional fixed offset to the schedule time estimator described above as Tff. As an
 * approximation, the value chosen for this register should limit the number of
 * back-off events captured in the TXSCHHEALTH to less than 10 per second in a
 * highly utilized bus. Choosing a value that is too high for this register is not
 * desired as it can needlessly reduce USB utilization. The time unit represented
 * in this register is 1.267us when a device is connected in High-Speed Mode. The
 * time unit represented in this register is 6.333us when a device is connected
 * in Low/Full Speed Mode. Default value is '08h' for OTG controller core, and
 * '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_TXFILLTUNING_TXSCHOH (0U) /*!< Bit position for USB_UH1_TXFILLTUNING_TXSCHOH. */
#define BM_USB_UH1_TXFILLTUNING_TXSCHOH (0x000000FFU) /*!< Bit mask for USB_UH1_TXFILLTUNING_TXSCHOH. */
#define BS_USB_UH1_TXFILLTUNING_TXSCHOH (8U) /*!< Bit field size in bits for USB_UH1_TXFILLTUNING_TXSCHOH. */

/*! @brief Read current value of the USB_UH1_TXFILLTUNING_TXSCHOH field. */
#define BR_USB_UH1_TXFILLTUNING_TXSCHOH(x) (HW_USB_UH1_TXFILLTUNING(x).B.TXSCHOH)

/*! @brief Format value for bitfield USB_UH1_TXFILLTUNING_TXSCHOH. */
#define BF_USB_UH1_TXFILLTUNING_TXSCHOH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_TXFILLTUNING_TXSCHOH) & BM_USB_UH1_TXFILLTUNING_TXSCHOH)

/*! @brief Set the TXSCHOH field to a new value. */
#define BW_USB_UH1_TXFILLTUNING_TXSCHOH(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, (HW_USB_UH1_TXFILLTUNING_RD(x) & ~BM_USB_UH1_TXFILLTUNING_TXSCHOH) | BF_USB_UH1_TXFILLTUNING_TXSCHOH(v)))
/*@}*/

/*!
 * @name Register USB_UH1_TXFILLTUNING, field TXSCHHEALTH[12:8] (RW)
 *
 * Scheduler Health Counter. (Read/Write To Clear) This register increments when
 * the host controller fails to fill the TX latency FIFO to the level programmed
 * by TXFIFOTHRES before running out of time to send the packet before the next
 * Start-Of-Frame. This health counter measures the number of times this occurs
 * to provide feedback to selecting a proper TXSCHOH. Writing to this register
 * will clear the counter and this counter will max. at 31. Default value is '08h'
 * for OTG controller core, and '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_TXFILLTUNING_TXSCHHEALTH (8U) /*!< Bit position for USB_UH1_TXFILLTUNING_TXSCHHEALTH. */
#define BM_USB_UH1_TXFILLTUNING_TXSCHHEALTH (0x00001F00U) /*!< Bit mask for USB_UH1_TXFILLTUNING_TXSCHHEALTH. */
#define BS_USB_UH1_TXFILLTUNING_TXSCHHEALTH (5U) /*!< Bit field size in bits for USB_UH1_TXFILLTUNING_TXSCHHEALTH. */

/*! @brief Read current value of the USB_UH1_TXFILLTUNING_TXSCHHEALTH field. */
#define BR_USB_UH1_TXFILLTUNING_TXSCHHEALTH(x) (HW_USB_UH1_TXFILLTUNING(x).B.TXSCHHEALTH)

/*! @brief Format value for bitfield USB_UH1_TXFILLTUNING_TXSCHHEALTH. */
#define BF_USB_UH1_TXFILLTUNING_TXSCHHEALTH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_TXFILLTUNING_TXSCHHEALTH) & BM_USB_UH1_TXFILLTUNING_TXSCHHEALTH)

/*! @brief Set the TXSCHHEALTH field to a new value. */
#define BW_USB_UH1_TXFILLTUNING_TXSCHHEALTH(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, (HW_USB_UH1_TXFILLTUNING_RD(x) & ~BM_USB_UH1_TXFILLTUNING_TXSCHHEALTH) | BF_USB_UH1_TXFILLTUNING_TXSCHHEALTH(v)))
/*@}*/

/*!
 * @name Register USB_UH1_TXFILLTUNING, field TXFIFOTHRES[21:16] (RW)
 *
 * FIFO Burst Threshold. (Read/Write) This register controls the number of data
 * bursts that are posted to the TX latency FIFO in host mode before the packet
 * begins on to the bus. The minimum value is 2 and this value should be a low as
 * possible to maximize USB performance. A higher value can be used in systems
 * with unpredictable latency and/or insufficient bandwidth where the FIFO may
 * underrun because the data transferred from the latency FIFO to USB occurs before
 * it can be replenished from system memory. This value is ignored if the Stream
 * Disable bit in USB_n_USBMODE register is set. Default value is '00h' for OTG
 * controller core, and '02h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH1_TXFILLTUNING_TXFIFOTHRES (16U) /*!< Bit position for USB_UH1_TXFILLTUNING_TXFIFOTHRES. */
#define BM_USB_UH1_TXFILLTUNING_TXFIFOTHRES (0x003F0000U) /*!< Bit mask for USB_UH1_TXFILLTUNING_TXFIFOTHRES. */
#define BS_USB_UH1_TXFILLTUNING_TXFIFOTHRES (6U) /*!< Bit field size in bits for USB_UH1_TXFILLTUNING_TXFIFOTHRES. */

/*! @brief Read current value of the USB_UH1_TXFILLTUNING_TXFIFOTHRES field. */
#define BR_USB_UH1_TXFILLTUNING_TXFIFOTHRES(x) (HW_USB_UH1_TXFILLTUNING(x).B.TXFIFOTHRES)

/*! @brief Format value for bitfield USB_UH1_TXFILLTUNING_TXFIFOTHRES. */
#define BF_USB_UH1_TXFILLTUNING_TXFIFOTHRES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_TXFILLTUNING_TXFIFOTHRES) & BM_USB_UH1_TXFILLTUNING_TXFIFOTHRES)

/*! @brief Set the TXFIFOTHRES field to a new value. */
#define BW_USB_UH1_TXFILLTUNING_TXFIFOTHRES(x, v) (HW_USB_UH1_TXFILLTUNING_WR(x, (HW_USB_UH1_TXFILLTUNING_RD(x) & ~BM_USB_UH1_TXFILLTUNING_TXFIFOTHRES) | BF_USB_UH1_TXFILLTUNING_TXFIFOTHRES(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_CONFIGFLAG - Configure Flag Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_CONFIGFLAG - Configure Flag Register (RO)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_usb_uh1_configflag
{
    uint32_t U;
    struct _hw_usb_uh1_configflag_bitfields
    {
        uint32_t CF : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_usb_uh1_configflag_t;

/*!
 * @name Constants and macros for entire USB_UH1_CONFIGFLAG register
 */
/*@{*/
#define HW_USB_UH1_CONFIGFLAG_ADDR(x) ((uintptr_t)(x) + 0x380U)

#define HW_USB_UH1_CONFIGFLAG(x) (*(__I hw_usb_uh1_configflag_t *) HW_USB_UH1_CONFIGFLAG_ADDR(x))
#define HW_USB_UH1_CONFIGFLAG_RD(x) (HW_USB_UH1_CONFIGFLAG(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH1_CONFIGFLAG bitfields
 */

/*!
 * @name Register USB_UH1_CONFIGFLAG, field CF[0] (RO)
 *
 * Configure Flag Host software sets this bit as the last action in its process
 * of configuring the Host Controller. This bit controls the default port-routing
 * control logic.
 *
 * Values:
 * - 0 - Port routing control logic default-routes each port to an
 *     implementation dependent classic host controller.
 * - 1 - Port routing control logic default-routes all ports to this host
 *     controller.
 */
/*@{*/
#define BP_USB_UH1_CONFIGFLAG_CF (0U)      /*!< Bit position for USB_UH1_CONFIGFLAG_CF. */
#define BM_USB_UH1_CONFIGFLAG_CF (0x00000001U) /*!< Bit mask for USB_UH1_CONFIGFLAG_CF. */
#define BS_USB_UH1_CONFIGFLAG_CF (1U)      /*!< Bit field size in bits for USB_UH1_CONFIGFLAG_CF. */

/*! @brief Read current value of the USB_UH1_CONFIGFLAG_CF field. */
#define BR_USB_UH1_CONFIGFLAG_CF(x) (HW_USB_UH1_CONFIGFLAG(x).B.CF)
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_PORTSC1 - Port Status & Control
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_PORTSC1 - Port Status & Control (RW)
 *
 * Reset value: 0x10000000U
 *
 * Host Controller A host controller could implement one to eight port status
 * and control registers. The number is determined by N_PORTs bits in HWSPARAMs
 * register (please see HCSPARAMSHost Controller Structural Parameters ). Software
 * could read this parameter register to determine how many ports need service.
 * All controller cores on this product are Single-Port, so there is only one port
 * status and control register for each controller core. This register is only
 * reset by power on reset or controller core reset. The initial conditions of a
 * port are: No device connected Port disabled If the port supports power control,
 * this state remains until port power is supplied (by software). Device
 * Controller A controller operating in device mode has only port register one (PORTSC1)
 * and it does not support power control in that mode. Port control in device
 * mode is only used for status port reset, suspend, and current connect status. It
 * is also used to initiate test mode or force signaling and allows software to
 * put the PHY into low power suspend mode and disable the PHY clock.
 */
typedef union _hw_usb_uh1_portsc1
{
    uint32_t U;
    struct _hw_usb_uh1_portsc1_bitfields
    {
        uint32_t CCS : 1;              /*!< [0]  */
        uint32_t CSC : 1;              /*!< [1]  */
        uint32_t PE : 1;               /*!< [2]  */
        uint32_t PEC : 1;              /*!< [3]  */
        uint32_t OCA : 1;              /*!< [4]  */
        uint32_t OCC : 1;              /*!< [5]  */
        uint32_t FPR : 1;              /*!< [6]  */
        uint32_t SUSP : 1;             /*!< [7]  */
        uint32_t PR : 1;               /*!< [8]  */
        uint32_t HSP : 1;              /*!< [9]  */
        uint32_t LS : 2;               /*!< [11:10]  */
        uint32_t PP : 1;               /*!< [12]  */
        uint32_t PO : 1;               /*!< [13]  */
        uint32_t PIC : 2;              /*!< [15:14]  */
        uint32_t PTC : 4;              /*!< [19:16]  */
        uint32_t WKCN : 1;             /*!< [20]  */
        uint32_t WKDC : 1;             /*!< [21]  */
        uint32_t WKOC : 1;             /*!< [22]  */
        uint32_t PHCD : 1;             /*!< [23]  */
        uint32_t PFSC : 1;             /*!< [24]  */
        uint32_t PTS_2 : 1;            /*!< [25]  */
        uint32_t PSPD : 2;             /*!< [27:26]  */
        uint32_t PTW : 1;              /*!< [28]  */
        uint32_t STS : 1;              /*!< [29]  */
        uint32_t PTS_1 : 2;            /*!< [31:30]  */
    } B;
} hw_usb_uh1_portsc1_t;

/*!
 * @name Constants and macros for entire USB_UH1_PORTSC1 register
 */
/*@{*/
#define HW_USB_UH1_PORTSC1_ADDR(x) ((uintptr_t)(x) + 0x384U)

#define HW_USB_UH1_PORTSC1(x)    (*(__IO hw_usb_uh1_portsc1_t *) HW_USB_UH1_PORTSC1_ADDR(x))
#define HW_USB_UH1_PORTSC1_RD(x) (HW_USB_UH1_PORTSC1(x).U)
#define HW_USB_UH1_PORTSC1_WR(x, v) (HW_USB_UH1_PORTSC1(x).U = (v))
#define HW_USB_UH1_PORTSC1_SET(x, v) (HW_USB_UH1_PORTSC1_WR(x, HW_USB_UH1_PORTSC1_RD(x) |  (v)))
#define HW_USB_UH1_PORTSC1_CLR(x, v) (HW_USB_UH1_PORTSC1_WR(x, HW_USB_UH1_PORTSC1_RD(x) & ~(v)))
#define HW_USB_UH1_PORTSC1_TOG(x, v) (HW_USB_UH1_PORTSC1_WR(x, HW_USB_UH1_PORTSC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_PORTSC1 bitfields
 */

/*!
 * @name Register USB_UH1_PORTSC1, field CCS[0] (RO)
 *
 * Current Connect Status-Read Only. In Host Mode: 1=Device is present on port.
 * 0=No device is present. Default = 0. This value reflects the current state of
 * the port, and may not correspond directly to the event that caused the Connect
 * Status Change bit (Bit 1) to be set. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: 1=Attached.
 * 0=Not Attached. Default=0. A one indicates that the device successfully attached
 * and is operating in either high speed or full speed as indicated by the High
 * Speed Port bit in this register. A zero indicates that the device did not
 * attach successfully or was forcibly disconnected by the software writing a zero to
 * the Run bit in the USBCMD register. It does not state the device being
 * disconnected or suspended.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_CCS (0U)        /*!< Bit position for USB_UH1_PORTSC1_CCS. */
#define BM_USB_UH1_PORTSC1_CCS (0x00000001U) /*!< Bit mask for USB_UH1_PORTSC1_CCS. */
#define BS_USB_UH1_PORTSC1_CCS (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_CCS. */

/*! @brief Read current value of the USB_UH1_PORTSC1_CCS field. */
#define BR_USB_UH1_PORTSC1_CCS(x) (HW_USB_UH1_PORTSC1(x).B.CCS)
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field CSC[1] (RW)
 *
 * Connect Status Change-R/WC. 1 =Change in Current Connect Status. 0=No change.
 * Default 0. In Host Mode: Indicates a change has occurred in the port's
 * Current Connect Status. The host/device controller sets this bit for all changes to
 * the port device connect status, even if system software has not cleared an
 * existing connect status change. For example, the insertion status changes twice
 * before system software has cleared the changed condition, hub hardware will be
 * 'setting' an already-set bit (that is, the bit will remain set). Software
 * clears this bit by writing a one to it. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: This bit is
 * undefined in device controller mode.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_CSC (1U)        /*!< Bit position for USB_UH1_PORTSC1_CSC. */
#define BM_USB_UH1_PORTSC1_CSC (0x00000002U) /*!< Bit mask for USB_UH1_PORTSC1_CSC. */
#define BS_USB_UH1_PORTSC1_CSC (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_CSC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_CSC field. */
#define BR_USB_UH1_PORTSC1_CSC(x) (HW_USB_UH1_PORTSC1(x).B.CSC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_CSC. */
#define BF_USB_UH1_PORTSC1_CSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_CSC) & BM_USB_UH1_PORTSC1_CSC)

/*! @brief Set the CSC field to a new value. */
#define BW_USB_UH1_PORTSC1_CSC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_CSC) | BF_USB_UH1_PORTSC1_CSC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PE[2] (RW)
 *
 * Port Enabled/Disabled-Read/Write. 1=Enable. 0=Disable. Default 0. In Host
 * Mode: Ports can only be enabled by the host controller as a part of the reset and
 * enable. Software cannot enable a port by writing a one to this field. Ports
 * can be disabled by either a fault condition (disconnect event or other fault
 * condition) or by the host software. Note that the bit status does not change
 * until the port state actually changes. There may be a delay in disabling or
 * enabling a port due to other host controller and bus events. When the port is
 * disabled, (0b) downstream propagation of data is blocked except for reset. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero in host mode.
 * In Device Mode: The device port is always enabled, so this bit is always '1b'.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PE (2U)         /*!< Bit position for USB_UH1_PORTSC1_PE. */
#define BM_USB_UH1_PORTSC1_PE (0x00000004U) /*!< Bit mask for USB_UH1_PORTSC1_PE. */
#define BS_USB_UH1_PORTSC1_PE (1U)         /*!< Bit field size in bits for USB_UH1_PORTSC1_PE. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PE field. */
#define BR_USB_UH1_PORTSC1_PE(x) (HW_USB_UH1_PORTSC1(x).B.PE)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PE. */
#define BF_USB_UH1_PORTSC1_PE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PE) & BM_USB_UH1_PORTSC1_PE)

/*! @brief Set the PE field to a new value. */
#define BW_USB_UH1_PORTSC1_PE(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PE) | BF_USB_UH1_PORTSC1_PE(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PEC[3] (RW)
 *
 * Port Enable/Disable Change-R/WC. 1=Port enabled/disabled status has changed.
 * 0=No change. Default = 0. In Host Mode: For the root hub, this bit is set to a
 * one only when a port is disabled due to disconnect on the port or due to the
 * appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB
 * Specification). Software clears this by writing a one to it. This field is zero
 * if Port Power( PORTSC1Port Status & Control ) is zero. In Device mode: The
 * device port is always enabled, so this bit is always '0b'.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PEC (3U)        /*!< Bit position for USB_UH1_PORTSC1_PEC. */
#define BM_USB_UH1_PORTSC1_PEC (0x00000008U) /*!< Bit mask for USB_UH1_PORTSC1_PEC. */
#define BS_USB_UH1_PORTSC1_PEC (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_PEC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PEC field. */
#define BR_USB_UH1_PORTSC1_PEC(x) (HW_USB_UH1_PORTSC1(x).B.PEC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PEC. */
#define BF_USB_UH1_PORTSC1_PEC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PEC) & BM_USB_UH1_PORTSC1_PEC)

/*! @brief Set the PEC field to a new value. */
#define BW_USB_UH1_PORTSC1_PEC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PEC) | BF_USB_UH1_PORTSC1_PEC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field OCA[4] (RO)
 *
 * Over-current Active-Read Only. Default 0. This bit will automatically
 * transition from one to zero when the over current condition is removed.
 *
 * Values:
 * - 1 - This port currently has an over-current condition
 * - 0 - This port does not have an over-current condition.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_OCA (4U)        /*!< Bit position for USB_UH1_PORTSC1_OCA. */
#define BM_USB_UH1_PORTSC1_OCA (0x00000010U) /*!< Bit mask for USB_UH1_PORTSC1_OCA. */
#define BS_USB_UH1_PORTSC1_OCA (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_OCA. */

/*! @brief Read current value of the USB_UH1_PORTSC1_OCA field. */
#define BR_USB_UH1_PORTSC1_OCA(x) (HW_USB_UH1_PORTSC1(x).B.OCA)
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field OCC[5] (RW)
 *
 * Over-current Change-R/WC. Default=0. This bit is set '1b' by hardware when
 * there is a change to Over-current Active. Software can clear this bit by writing
 * a one to this bit position.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_OCC (5U)        /*!< Bit position for USB_UH1_PORTSC1_OCC. */
#define BM_USB_UH1_PORTSC1_OCC (0x00000020U) /*!< Bit mask for USB_UH1_PORTSC1_OCC. */
#define BS_USB_UH1_PORTSC1_OCC (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_OCC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_OCC field. */
#define BR_USB_UH1_PORTSC1_OCC(x) (HW_USB_UH1_PORTSC1(x).B.OCC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_OCC. */
#define BF_USB_UH1_PORTSC1_OCC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_OCC) & BM_USB_UH1_PORTSC1_OCC)

/*! @brief Set the OCC field to a new value. */
#define BW_USB_UH1_PORTSC1_OCC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_OCC) | BF_USB_UH1_PORTSC1_OCC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field FPR[6] (RW)
 *
 * Force Port Resume -Read/Write. 1= Resume detected/driven on port. 0=No resume
 * (K-state) detected/driven on port. Default = 0. In Host Mode: Software sets
 * this bit to one to drive resume signaling. The Host Controller sets this bit to
 * one if a J-to-K transition is detected while the port is in the Suspend
 * state. When this bit transitions to a one because a J-to-K transition is detected,
 * the Port Change Detect bit in the USBSTS register is also set to one. This bit
 * will automatically change to zero after the resume sequence is complete. This
 * behavior is different from EHCI where the host controller driver is required
 * to set this bit to a zero after the resume duration is timed in the driver.
 * Note that when the Host controller owns the port, the resume sequence follows
 * the defined sequence documented in the USB Specification Revision 2.0. The
 * resume signaling (Full-speed 'K') is driven on the port as long as this bit remains
 * a one. This bit will remain a one until the port has switched to the
 * high-speed idle. Writing a zero has no effect because the port controller will time
 * the resume operation, clear the bit the port control state switches to HS or FS
 * idle. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero
 * in host mode. This bit is not-EHCI compatible. In Device mode: After the
 * device has been in Suspend State for 5ms or more, software must set this bit to
 * one to drive resume signaling before clearing. The Device Controller will set
 * this bit to one if a J-to-K transition is detected while the port is in the
 * Suspend state. The bit will be cleared when the device returns to normal
 * operation. Also, when this bit wil be cleared because a K-to-J transition detected, the
 * Port Change Detect bit in the USBSTS register is also set to one.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_FPR (6U)        /*!< Bit position for USB_UH1_PORTSC1_FPR. */
#define BM_USB_UH1_PORTSC1_FPR (0x00000040U) /*!< Bit mask for USB_UH1_PORTSC1_FPR. */
#define BS_USB_UH1_PORTSC1_FPR (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_FPR. */

/*! @brief Read current value of the USB_UH1_PORTSC1_FPR field. */
#define BR_USB_UH1_PORTSC1_FPR(x) (HW_USB_UH1_PORTSC1(x).B.FPR)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_FPR. */
#define BF_USB_UH1_PORTSC1_FPR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_FPR) & BM_USB_UH1_PORTSC1_FPR)

/*! @brief Set the FPR field to a new value. */
#define BW_USB_UH1_PORTSC1_FPR(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_FPR) | BF_USB_UH1_PORTSC1_FPR(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field SUSP[7] (RW)
 *
 * Suspend - Read/Write or Read Only. Default = 0b. 1=Port in suspend state.
 * 0=Port not in suspend state. In Host Mode: Read/Write. Port Enabled Bit and
 * Suspend bit of this register define the port states as follows: Bits [Port Enabled,
 * Suspend] Port State 0x Disable 10 Enable 11 Suspend When in suspend state,
 * downstream propagation of data is blocked on this port, except for port reset.
 * The blocking occurs at the end of the current transaction if a transaction was
 * in progress when this bit was written to 1. In the suspend state, the port is
 * sensitive to resume detection. Note that the bit status does not change until
 * the port is suspended and that there may be a delay in suspending a port if
 * there is a transaction currently in progress on the USB. The host controller
 * will unconditionally set this bit to zero when software sets the Force Port
 * Resume bit to zero. The host controller ignores a write of zero to this bit. If
 * host software sets this bit to a one when the port is not enabled (that is, Port
 * enabled bit is a zero) the results are undefined. This field is zero if Port
 * Power( PORTSC1Port Status & Control ) is zero in host mode. In Device Mode:
 * Read Only. In device mode this bit is a read only status bit.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_SUSP (7U)       /*!< Bit position for USB_UH1_PORTSC1_SUSP. */
#define BM_USB_UH1_PORTSC1_SUSP (0x00000080U) /*!< Bit mask for USB_UH1_PORTSC1_SUSP. */
#define BS_USB_UH1_PORTSC1_SUSP (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_SUSP. */

/*! @brief Read current value of the USB_UH1_PORTSC1_SUSP field. */
#define BR_USB_UH1_PORTSC1_SUSP(x) (HW_USB_UH1_PORTSC1(x).B.SUSP)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_SUSP. */
#define BF_USB_UH1_PORTSC1_SUSP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_SUSP) & BM_USB_UH1_PORTSC1_SUSP)

/*! @brief Set the SUSP field to a new value. */
#define BW_USB_UH1_PORTSC1_SUSP(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_SUSP) | BF_USB_UH1_PORTSC1_SUSP(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PR[8] (RW)
 *
 * Port Reset - Read/Write or Read Only. Default = 0b. In Host Mode: Read/Write.
 * 1=Port is in Reset. 0=Port is not in Reset. Default 0. When software writes a
 * one to this bit the bus-reset sequence as defined in the USB Specification
 * Revision 2.0 is started. This bit will automatically change to zero after the
 * reset sequence is complete. This behavior is different from EHCI where the host
 * controller driver is required to set this bit to a zero after the reset
 * duration is timed in the driver. In Device Mode: This bit is a read only status bit.
 * Device reset from the USB bus is also indicated in the USBSTS register. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PR (8U)         /*!< Bit position for USB_UH1_PORTSC1_PR. */
#define BM_USB_UH1_PORTSC1_PR (0x00000100U) /*!< Bit mask for USB_UH1_PORTSC1_PR. */
#define BS_USB_UH1_PORTSC1_PR (1U)         /*!< Bit field size in bits for USB_UH1_PORTSC1_PR. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PR field. */
#define BR_USB_UH1_PORTSC1_PR(x) (HW_USB_UH1_PORTSC1(x).B.PR)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PR. */
#define BF_USB_UH1_PORTSC1_PR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PR) & BM_USB_UH1_PORTSC1_PR)

/*! @brief Set the PR field to a new value. */
#define BW_USB_UH1_PORTSC1_PR(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PR) | BF_USB_UH1_PORTSC1_PR(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field HSP[9] (RO)
 *
 * High-Speed Port - Read Only. Default = 0b. When the bit is one, the
 * host/device connected to the port is in high-speed mode and if set to zero, the
 * host/device connected to the port is not in a high-speed mode. HSP is redundant with
 * PSPD(bit 27, 26) but remained for compatibility.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_HSP (9U)        /*!< Bit position for USB_UH1_PORTSC1_HSP. */
#define BM_USB_UH1_PORTSC1_HSP (0x00000200U) /*!< Bit mask for USB_UH1_PORTSC1_HSP. */
#define BS_USB_UH1_PORTSC1_HSP (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_HSP. */

/*! @brief Read current value of the USB_UH1_PORTSC1_HSP field. */
#define BR_USB_UH1_PORTSC1_HSP(x) (HW_USB_UH1_PORTSC1(x).B.HSP)
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field LS[11:10] (RW)
 *
 * Line Status-Read Only. These bits reflect the current logical levels of the
 * D+ (bit 11) and D- (bit 10) signal lines. In host mode, the use of linestate by
 * the host controller driver is not necessary (unlike EHCI), because the port
 * controller state machine and the port routing manage the connection of LS and
 * FS. In device mode, the use of linestate by the device controller driver is not
 * necessary. The encoding of the bits are: Bits [11:10] Meaning
 *
 * Values:
 * - 00 - SE0
 * - 10 - J-state
 * - 01 - K-state
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_LS (10U)        /*!< Bit position for USB_UH1_PORTSC1_LS. */
#define BM_USB_UH1_PORTSC1_LS (0x00000C00U) /*!< Bit mask for USB_UH1_PORTSC1_LS. */
#define BS_USB_UH1_PORTSC1_LS (2U)         /*!< Bit field size in bits for USB_UH1_PORTSC1_LS. */

/*! @brief Read current value of the USB_UH1_PORTSC1_LS field. */
#define BR_USB_UH1_PORTSC1_LS(x) (HW_USB_UH1_PORTSC1(x).B.LS)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_LS. */
#define BF_USB_UH1_PORTSC1_LS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_LS) & BM_USB_UH1_PORTSC1_LS)

/*! @brief Set the LS field to a new value. */
#define BW_USB_UH1_PORTSC1_LS(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_LS) | BF_USB_UH1_PORTSC1_LS(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PP[12] (RW)
 *
 * Port Power (PP)-Read/Write or Read Only. The function of this bit depends on
 * the value of the Port Power Switching (PPC) field in the HCSPARAMS register.
 * The behavior is as follows: PPC PP Operation 0 1b Read Only - Host controller
 * does not have port power control switches. Each port is hard-wired to power. 1
 * 1b/0b - Read/Write. Host/OTG controller requires port power control switches.
 * This bit represents the current setting of the switch (0=off, 1=on). When
 * power is not available on a port (that is, PP equals a 0), the port is
 * non-functional and will not report attaches, detaches, etc. When an over-current
 * condition is detected on a powered port and PPC is a one, the PP bit in each affected
 * port may be transitional by the host controller driver from a one to a zero
 * (removing power from the port). This feature is implemented in all controller
 * cores (PPC = 1).
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PP (12U)        /*!< Bit position for USB_UH1_PORTSC1_PP. */
#define BM_USB_UH1_PORTSC1_PP (0x00001000U) /*!< Bit mask for USB_UH1_PORTSC1_PP. */
#define BS_USB_UH1_PORTSC1_PP (1U)         /*!< Bit field size in bits for USB_UH1_PORTSC1_PP. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PP field. */
#define BR_USB_UH1_PORTSC1_PP(x) (HW_USB_UH1_PORTSC1(x).B.PP)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PP. */
#define BF_USB_UH1_PORTSC1_PP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PP) & BM_USB_UH1_PORTSC1_PP)

/*! @brief Set the PP field to a new value. */
#define BW_USB_UH1_PORTSC1_PP(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PP) | BF_USB_UH1_PORTSC1_PP(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PO[13] (RW)
 *
 * Port Owner-Read/Write. Default = 0. This bit unconditionally goes to a 0 when
 * the configured bit in the CONFIGFLAG register makes a 0 to 1 transition. This
 * bit unconditionally goes to 1 whenever the Configured bit is zero System
 * software uses this field to release ownership of the port to a selected host
 * controller (in the event that the attached device is not a high-speed device).
 * Software writes a one to this bit when the attached device is not a high-speed
 * device. A one in this bit means that an internal companion controller owns and
 * controls the port. Port owner handoff is not supported in all controller cores,
 * therefore this bit will always be 0.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PO (13U)        /*!< Bit position for USB_UH1_PORTSC1_PO. */
#define BM_USB_UH1_PORTSC1_PO (0x00002000U) /*!< Bit mask for USB_UH1_PORTSC1_PO. */
#define BS_USB_UH1_PORTSC1_PO (1U)         /*!< Bit field size in bits for USB_UH1_PORTSC1_PO. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PO field. */
#define BR_USB_UH1_PORTSC1_PO(x) (HW_USB_UH1_PORTSC1(x).B.PO)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PO. */
#define BF_USB_UH1_PORTSC1_PO(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PO) & BM_USB_UH1_PORTSC1_PO)

/*! @brief Set the PO field to a new value. */
#define BW_USB_UH1_PORTSC1_PO(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PO) | BF_USB_UH1_PORTSC1_PO(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PIC[15:14] (RW)
 *
 * Port Indicator Control - Read/Write. Default = Ob. Writing to this field has
 * no effect if the P_INDICATOR bit in the HCSPARAMS register is a zero. Refer to
 * the USB Specification Revision 2.0 for a description on how these bits are to
 * be used. This field is zero if Port Power is zero. Bit Value Meaning
 *
 * Values:
 * - 00 - Port indicators are off
 * - 01 - Amber
 * - 10 - Green
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PIC (14U)       /*!< Bit position for USB_UH1_PORTSC1_PIC. */
#define BM_USB_UH1_PORTSC1_PIC (0x0000C000U) /*!< Bit mask for USB_UH1_PORTSC1_PIC. */
#define BS_USB_UH1_PORTSC1_PIC (2U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_PIC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PIC field. */
#define BR_USB_UH1_PORTSC1_PIC(x) (HW_USB_UH1_PORTSC1(x).B.PIC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PIC. */
#define BF_USB_UH1_PORTSC1_PIC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PIC) & BM_USB_UH1_PORTSC1_PIC)

/*! @brief Set the PIC field to a new value. */
#define BW_USB_UH1_PORTSC1_PIC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PIC) | BF_USB_UH1_PORTSC1_PIC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PTC[19:16] (RW)
 *
 * Port Test Control - Read/Write. Default = 0000b. Refer to Port Test Mode for
 * the operational model for using these test modes and the USB Specification
 * Revision 2.0, Chapter 7 for details on each test mode. The FORCE_ENABLE_FS and
 * FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI
 * specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS}
 * values will force the port into the connected and enabled state at the selected
 * speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state
 * machines to progress normally from that point. Low speed operations are not
 * supported as a peripheral device. Any other value than zero indicates that the
 * port is operating in test mode. Value Specific Test
 *
 * Values:
 * - 0000 - TEST_MODE_DISABLE
 * - 0001 - J_STATE
 * - 0010 - K_STATE
 * - 0011 - SE0 (host) / NAK (device)
 * - 0100 - Packet
 * - 0101 - FORCE_ENABLE_HS
 * - 0110 - FORCE_ENABLE_FS
 * - 0111 - FORCE_ENABLE_LS
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PTC (16U)       /*!< Bit position for USB_UH1_PORTSC1_PTC. */
#define BM_USB_UH1_PORTSC1_PTC (0x000F0000U) /*!< Bit mask for USB_UH1_PORTSC1_PTC. */
#define BS_USB_UH1_PORTSC1_PTC (4U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_PTC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PTC field. */
#define BR_USB_UH1_PORTSC1_PTC(x) (HW_USB_UH1_PORTSC1(x).B.PTC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PTC. */
#define BF_USB_UH1_PORTSC1_PTC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PTC) & BM_USB_UH1_PORTSC1_PTC)

/*! @brief Set the PTC field to a new value. */
#define BW_USB_UH1_PORTSC1_PTC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PTC) | BF_USB_UH1_PORTSC1_PTC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field WKCN[20] (RW)
 *
 * Wake on Connect Enable (WKCNNT_E) - Read/Write. Default=0b. Writing this bit
 * to a one enables the port to be sensitive to device connects as wake-up
 * events. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero or
 * in device mode.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_WKCN (20U)      /*!< Bit position for USB_UH1_PORTSC1_WKCN. */
#define BM_USB_UH1_PORTSC1_WKCN (0x00100000U) /*!< Bit mask for USB_UH1_PORTSC1_WKCN. */
#define BS_USB_UH1_PORTSC1_WKCN (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_WKCN. */

/*! @brief Read current value of the USB_UH1_PORTSC1_WKCN field. */
#define BR_USB_UH1_PORTSC1_WKCN(x) (HW_USB_UH1_PORTSC1(x).B.WKCN)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_WKCN. */
#define BF_USB_UH1_PORTSC1_WKCN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_WKCN) & BM_USB_UH1_PORTSC1_WKCN)

/*! @brief Set the WKCN field to a new value. */
#define BW_USB_UH1_PORTSC1_WKCN(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_WKCN) | BF_USB_UH1_PORTSC1_WKCN(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field WKDC[21] (RW)
 *
 * Wake on Disconnect Enable (WKDSCNNT_E) - Read/Write. Default=0b. Writing this
 * bit to a one enables the port to be sensitive to device disconnects as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control ) is
 * zero or in device mode.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_WKDC (21U)      /*!< Bit position for USB_UH1_PORTSC1_WKDC. */
#define BM_USB_UH1_PORTSC1_WKDC (0x00200000U) /*!< Bit mask for USB_UH1_PORTSC1_WKDC. */
#define BS_USB_UH1_PORTSC1_WKDC (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_WKDC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_WKDC field. */
#define BR_USB_UH1_PORTSC1_WKDC(x) (HW_USB_UH1_PORTSC1(x).B.WKDC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_WKDC. */
#define BF_USB_UH1_PORTSC1_WKDC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_WKDC) & BM_USB_UH1_PORTSC1_WKDC)

/*! @brief Set the WKDC field to a new value. */
#define BW_USB_UH1_PORTSC1_WKDC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_WKDC) | BF_USB_UH1_PORTSC1_WKDC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field WKOC[22] (RW)
 *
 * Wake on Over-current Enable (WKOC_E) - Read/Write. Default = 0b. Writing this
 * bit to a one enables the port to be sensitive to over-current conditions as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control
 * ) is zero.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_WKOC (22U)      /*!< Bit position for USB_UH1_PORTSC1_WKOC. */
#define BM_USB_UH1_PORTSC1_WKOC (0x00400000U) /*!< Bit mask for USB_UH1_PORTSC1_WKOC. */
#define BS_USB_UH1_PORTSC1_WKOC (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_WKOC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_WKOC field. */
#define BR_USB_UH1_PORTSC1_WKOC(x) (HW_USB_UH1_PORTSC1(x).B.WKOC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_WKOC. */
#define BF_USB_UH1_PORTSC1_WKOC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_WKOC) & BM_USB_UH1_PORTSC1_WKOC)

/*! @brief Set the WKOC field to a new value. */
#define BW_USB_UH1_PORTSC1_WKOC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_WKOC) | BF_USB_UH1_PORTSC1_WKOC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PHCD[23] (RW)
 *
 * PHY Low Power Suspend - Clock Disable (PLPSCD) - Read/Write. Default = 0b.
 * When this bit is set to '1b', the PHY clock is disabled. Reading this bit will
 * indicate the status of the PHY clock. The PHY clock cannot be disabled if it is
 * being used as the system clock. In device mode, The PHY can be put into Low
 * Power Suspend when the device is not running (USBCMD Run/Stop=0b) or the host
 * has signalled suspend (PORTSC1 SUSPEND=1b). PHY Low power suspend will be
 * cleared automatically when the host initials resume. Before forcing a resume from
 * the device, the device controller driver must clear this bit. In host mode, the
 * PHY can be put into Low Power Suspend when the downstream device has been put
 * into suspend mode or when no downstream device is connected. Low power
 * suspend is completely under the control of software.
 *
 * Values:
 * - 1 - Disable PHY clock
 * - 0 - Enable PHY clock
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PHCD (23U)      /*!< Bit position for USB_UH1_PORTSC1_PHCD. */
#define BM_USB_UH1_PORTSC1_PHCD (0x00800000U) /*!< Bit mask for USB_UH1_PORTSC1_PHCD. */
#define BS_USB_UH1_PORTSC1_PHCD (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_PHCD. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PHCD field. */
#define BR_USB_UH1_PORTSC1_PHCD(x) (HW_USB_UH1_PORTSC1(x).B.PHCD)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PHCD. */
#define BF_USB_UH1_PORTSC1_PHCD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PHCD) & BM_USB_UH1_PORTSC1_PHCD)

/*! @brief Set the PHCD field to a new value. */
#define BW_USB_UH1_PORTSC1_PHCD(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PHCD) | BF_USB_UH1_PORTSC1_PHCD(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PFSC[24] (RW)
 *
 * Port Force Full Speed Connect - Read/Write. Default = 0b. When this bit is
 * set to '1b', the port will be forced to only connect at Full Speed, It disables
 * the chirp sequence that allows the port to identify itself as High Speed.
 *
 * Values:
 * - 1 - Forced to full speed
 * - 0 - Normal operation
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PFSC (24U)      /*!< Bit position for USB_UH1_PORTSC1_PFSC. */
#define BM_USB_UH1_PORTSC1_PFSC (0x01000000U) /*!< Bit mask for USB_UH1_PORTSC1_PFSC. */
#define BS_USB_UH1_PORTSC1_PFSC (1U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_PFSC. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PFSC field. */
#define BR_USB_UH1_PORTSC1_PFSC(x) (HW_USB_UH1_PORTSC1(x).B.PFSC)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PFSC. */
#define BF_USB_UH1_PORTSC1_PFSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PFSC) & BM_USB_UH1_PORTSC1_PFSC)

/*! @brief Set the PFSC field to a new value. */
#define BW_USB_UH1_PORTSC1_PFSC(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PFSC) | BF_USB_UH1_PORTSC1_PFSC(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PTS_2[25] (RW)
 *
 * See description at bits 31-30
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PTS_2 (25U)     /*!< Bit position for USB_UH1_PORTSC1_PTS_2. */
#define BM_USB_UH1_PORTSC1_PTS_2 (0x02000000U) /*!< Bit mask for USB_UH1_PORTSC1_PTS_2. */
#define BS_USB_UH1_PORTSC1_PTS_2 (1U)      /*!< Bit field size in bits for USB_UH1_PORTSC1_PTS_2. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PTS_2 field. */
#define BR_USB_UH1_PORTSC1_PTS_2(x) (HW_USB_UH1_PORTSC1(x).B.PTS_2)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PTS_2. */
#define BF_USB_UH1_PORTSC1_PTS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PTS_2) & BM_USB_UH1_PORTSC1_PTS_2)

/*! @brief Set the PTS_2 field to a new value. */
#define BW_USB_UH1_PORTSC1_PTS_2(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PTS_2) | BF_USB_UH1_PORTSC1_PTS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PSPD[27:26] (RW)
 *
 * Port Speed - Read Only. This register field indicates the speed at which the
 * port is operating.
 *
 * Values:
 * - 00 - Full Speed
 * - 01 - Low Speed
 * - 10 - High Speed
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PSPD (26U)      /*!< Bit position for USB_UH1_PORTSC1_PSPD. */
#define BM_USB_UH1_PORTSC1_PSPD (0x0C000000U) /*!< Bit mask for USB_UH1_PORTSC1_PSPD. */
#define BS_USB_UH1_PORTSC1_PSPD (2U)       /*!< Bit field size in bits for USB_UH1_PORTSC1_PSPD. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PSPD field. */
#define BR_USB_UH1_PORTSC1_PSPD(x) (HW_USB_UH1_PORTSC1(x).B.PSPD)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PSPD. */
#define BF_USB_UH1_PORTSC1_PSPD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PSPD) & BM_USB_UH1_PORTSC1_PSPD)

/*! @brief Set the PSPD field to a new value. */
#define BW_USB_UH1_PORTSC1_PSPD(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PSPD) | BF_USB_UH1_PORTSC1_PSPD(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PTW[28] (RW)
 *
 * Parallel Transceiver Width This bit has no effect if serial interface engine
 * is used. For OTG/Host1/Host2/Host3 core, it is Read-Only. Reset value is '1b'.
 *
 * Values:
 * - 0 - Select the 8-bit UTMI interface [60MHz]
 * - 1 - Select the 16-bit UTMI interface [30MHz]
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PTW (28U)       /*!< Bit position for USB_UH1_PORTSC1_PTW. */
#define BM_USB_UH1_PORTSC1_PTW (0x10000000U) /*!< Bit mask for USB_UH1_PORTSC1_PTW. */
#define BS_USB_UH1_PORTSC1_PTW (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_PTW. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PTW field. */
#define BR_USB_UH1_PORTSC1_PTW(x) (HW_USB_UH1_PORTSC1(x).B.PTW)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PTW. */
#define BF_USB_UH1_PORTSC1_PTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PTW) & BM_USB_UH1_PORTSC1_PTW)

/*! @brief Set the PTW field to a new value. */
#define BW_USB_UH1_PORTSC1_PTW(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PTW) | BF_USB_UH1_PORTSC1_PTW(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field STS[29] (RW)
 *
 * Serial Transceiver Select - Read Only Serial Transceiver Select 1 Serial
 * Interface Engine is selected 0 Parallel Interface signals is selected Serial
 * Interface Engine can be used in combination with UTMI+/ULPI physical interface to
 * provide FS/LS signaling instead of the parallel interface signals. When this
 * bit is set '1b', serial interface engine will be used instead of parallel
 * interface signals. This bit has no effect unless PTS bits is set to select
 * UTMI+/ULPI interface. The Serial/USB1.1 PHY/IC-USB will use the serial interface engine
 * for FS/LS signaling regardless of this bit value.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_STS (29U)       /*!< Bit position for USB_UH1_PORTSC1_STS. */
#define BM_USB_UH1_PORTSC1_STS (0x20000000U) /*!< Bit mask for USB_UH1_PORTSC1_STS. */
#define BS_USB_UH1_PORTSC1_STS (1U)        /*!< Bit field size in bits for USB_UH1_PORTSC1_STS. */

/*! @brief Read current value of the USB_UH1_PORTSC1_STS field. */
#define BR_USB_UH1_PORTSC1_STS(x) (HW_USB_UH1_PORTSC1(x).B.STS)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_STS. */
#define BF_USB_UH1_PORTSC1_STS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_STS) & BM_USB_UH1_PORTSC1_STS)

/*! @brief Set the STS field to a new value. */
#define BW_USB_UH1_PORTSC1_STS(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_STS) | BF_USB_UH1_PORTSC1_STS(v)))
/*@}*/

/*!
 * @name Register USB_UH1_PORTSC1, field PTS_1[31:30] (RW)
 *
 * Bit field {bit25, bit31, bit30}: "000b" UTMI/UTMI+ "001b" Reserved "010b"
 * ULPI "011b" Serial/USB 1.1 PHY/IC-USB (FS Only) "100b" HSIC Parallel Transceiver
 * Select (bit25, bit31, bi30). For OTG core, it is Read-Only. Reset value is
 * 000b. For Host1/Host2/Host3 core, it is Read/Write. Reset value is 000b. All USB
 * port interface modes are listed in this field description, but not all are
 * supported. For detail feature of each controller core, please see Features . The
 * behaviour is unknown when unsupported interface mode is selected.
 */
/*@{*/
#define BP_USB_UH1_PORTSC1_PTS_1 (30U)     /*!< Bit position for USB_UH1_PORTSC1_PTS_1. */
#define BM_USB_UH1_PORTSC1_PTS_1 (0xC0000000U) /*!< Bit mask for USB_UH1_PORTSC1_PTS_1. */
#define BS_USB_UH1_PORTSC1_PTS_1 (2U)      /*!< Bit field size in bits for USB_UH1_PORTSC1_PTS_1. */

/*! @brief Read current value of the USB_UH1_PORTSC1_PTS_1 field. */
#define BR_USB_UH1_PORTSC1_PTS_1(x) (HW_USB_UH1_PORTSC1(x).B.PTS_1)

/*! @brief Format value for bitfield USB_UH1_PORTSC1_PTS_1. */
#define BF_USB_UH1_PORTSC1_PTS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_PORTSC1_PTS_1) & BM_USB_UH1_PORTSC1_PTS_1)

/*! @brief Set the PTS_1 field to a new value. */
#define BW_USB_UH1_PORTSC1_PTS_1(x, v) (HW_USB_UH1_PORTSC1_WR(x, (HW_USB_UH1_PORTSC1_RD(x) & ~BM_USB_UH1_PORTSC1_PTS_1) | BF_USB_UH1_PORTSC1_PTS_1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH1_USBMODE - USB Device Mode
 ******************************************************************************/

/*!
 * @brief HW_USB_UH1_USBMODE - USB Device Mode (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uh1_usbmode
{
    uint32_t U;
    struct _hw_usb_uh1_usbmode_bitfields
    {
        uint32_t CM : 2;               /*!< [1:0]  */
        uint32_t ES : 1;               /*!< [2]  */
        uint32_t SLOM : 1;             /*!< [3]  */
        uint32_t SDIS : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_usb_uh1_usbmode_t;

/*!
 * @name Constants and macros for entire USB_UH1_USBMODE register
 */
/*@{*/
#define HW_USB_UH1_USBMODE_ADDR(x) ((uintptr_t)(x) + 0x3A8U)

#define HW_USB_UH1_USBMODE(x)    (*(__IO hw_usb_uh1_usbmode_t *) HW_USB_UH1_USBMODE_ADDR(x))
#define HW_USB_UH1_USBMODE_RD(x) (HW_USB_UH1_USBMODE(x).U)
#define HW_USB_UH1_USBMODE_WR(x, v) (HW_USB_UH1_USBMODE(x).U = (v))
#define HW_USB_UH1_USBMODE_SET(x, v) (HW_USB_UH1_USBMODE_WR(x, HW_USB_UH1_USBMODE_RD(x) |  (v)))
#define HW_USB_UH1_USBMODE_CLR(x, v) (HW_USB_UH1_USBMODE_WR(x, HW_USB_UH1_USBMODE_RD(x) & ~(v)))
#define HW_USB_UH1_USBMODE_TOG(x, v) (HW_USB_UH1_USBMODE_WR(x, HW_USB_UH1_USBMODE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH1_USBMODE bitfields
 */

/*!
 * @name Register USB_UH1_USBMODE, field CM[1:0] (RW)
 *
 * Controller Mode - R/WO. Controller mode is defaulted to the proper mode for
 * host only and device only implementations. For those designs that contain both
 * host & device capability, the controller defaults to an idle state and needs
 * to be initialized to the desired operating mode after reset. For combination
 * host/device controllers, this register can only be written once after reset. If
 * it is necessary to switch modes, software must reset the controller by writing
 * to the RESET bit in the USBCMD register before reprogramming this register.
 * For OTG controller core, reset value is '00b'. For Host-only controller core,
 * reset value is '11b'.
 *
 * Values:
 * - 00 - Idle [Default for combination host/device]
 * - 01 - Reserved
 * - 10 - Device Controller [Default for device only controller]
 * - 11 - Host Controller [Default for host only controller]
 */
/*@{*/
#define BP_USB_UH1_USBMODE_CM (0U)         /*!< Bit position for USB_UH1_USBMODE_CM. */
#define BM_USB_UH1_USBMODE_CM (0x00000003U) /*!< Bit mask for USB_UH1_USBMODE_CM. */
#define BS_USB_UH1_USBMODE_CM (2U)         /*!< Bit field size in bits for USB_UH1_USBMODE_CM. */

/*! @brief Read current value of the USB_UH1_USBMODE_CM field. */
#define BR_USB_UH1_USBMODE_CM(x) (HW_USB_UH1_USBMODE(x).B.CM)

/*! @brief Format value for bitfield USB_UH1_USBMODE_CM. */
#define BF_USB_UH1_USBMODE_CM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBMODE_CM) & BM_USB_UH1_USBMODE_CM)

/*! @brief Set the CM field to a new value. */
#define BW_USB_UH1_USBMODE_CM(x, v) (HW_USB_UH1_USBMODE_WR(x, (HW_USB_UH1_USBMODE_RD(x) & ~BM_USB_UH1_USBMODE_CM) | BF_USB_UH1_USBMODE_CM(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBMODE, field ES[2] (RW)
 *
 * Endian Select - Read/Write. This bit can change the byte alignment of the
 * transfer buffers to match the host microprocessor. The bit fields in the
 * microprocessor interface and the data structures are unaffected by the value of this
 * bit because they are based upon the 32-bit word. Bit Meaning
 *
 * Values:
 * - 0 - Little Endian [Default]
 * - 1 - Big Endian
 */
/*@{*/
#define BP_USB_UH1_USBMODE_ES (2U)         /*!< Bit position for USB_UH1_USBMODE_ES. */
#define BM_USB_UH1_USBMODE_ES (0x00000004U) /*!< Bit mask for USB_UH1_USBMODE_ES. */
#define BS_USB_UH1_USBMODE_ES (1U)         /*!< Bit field size in bits for USB_UH1_USBMODE_ES. */

/*! @brief Read current value of the USB_UH1_USBMODE_ES field. */
#define BR_USB_UH1_USBMODE_ES(x) (HW_USB_UH1_USBMODE(x).B.ES)

/*! @brief Format value for bitfield USB_UH1_USBMODE_ES. */
#define BF_USB_UH1_USBMODE_ES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBMODE_ES) & BM_USB_UH1_USBMODE_ES)

/*! @brief Set the ES field to a new value. */
#define BW_USB_UH1_USBMODE_ES(x, v) (HW_USB_UH1_USBMODE_WR(x, (HW_USB_UH1_USBMODE_RD(x) & ~BM_USB_UH1_USBMODE_ES) | BF_USB_UH1_USBMODE_ES(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBMODE, field SLOM[3] (RW)
 *
 * Setup Lockout Mode. In device mode, this bit controls behavior of the setup
 * lock mechanism. See Control Endpoint Operation Model .
 *
 * Values:
 * - 0 - Setup Lockouts On (default);
 * - 1 - Setup Lockouts Off (DCD requires use of Setup Data Buffer Tripwire in
 *     USBCMDUSB Command Register .
 */
/*@{*/
#define BP_USB_UH1_USBMODE_SLOM (3U)       /*!< Bit position for USB_UH1_USBMODE_SLOM. */
#define BM_USB_UH1_USBMODE_SLOM (0x00000008U) /*!< Bit mask for USB_UH1_USBMODE_SLOM. */
#define BS_USB_UH1_USBMODE_SLOM (1U)       /*!< Bit field size in bits for USB_UH1_USBMODE_SLOM. */

/*! @brief Read current value of the USB_UH1_USBMODE_SLOM field. */
#define BR_USB_UH1_USBMODE_SLOM(x) (HW_USB_UH1_USBMODE(x).B.SLOM)

/*! @brief Format value for bitfield USB_UH1_USBMODE_SLOM. */
#define BF_USB_UH1_USBMODE_SLOM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBMODE_SLOM) & BM_USB_UH1_USBMODE_SLOM)

/*! @brief Set the SLOM field to a new value. */
#define BW_USB_UH1_USBMODE_SLOM(x, v) (HW_USB_UH1_USBMODE_WR(x, (HW_USB_UH1_USBMODE_RD(x) & ~BM_USB_UH1_USBMODE_SLOM) | BF_USB_UH1_USBMODE_SLOM(v)))
/*@}*/

/*!
 * @name Register USB_UH1_USBMODE, field SDIS[4] (RW)
 *
 * Stream Disable Mode. (0 - Inactive [default]; 1 - Active) Device Mode:
 * Setting to a '1' disables double priming on both RX and TX for low bandwidth
 * systems. This mode ensures that when the RX and TX buffers are sufficient to contain
 * an entire packet that the standard double buffering scheme is disabled to
 * prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode,
 * all packets received are responded to with a NYET handshake when stream
 * disable is active. Host Mode: Setting to a '1' ensures that overruns/underruns of
 * the latency FIFO are eliminated for low bandwidth systems where the RX and TX
 * buffers are sufficient to contain the entire packet. Enabling stream disable
 * also has the effect of ensuring the TX latency is filled to capacity before the
 * packet is launched onto the USB. Time duration to pre-fill the FIFO becomes
 * significant when stream disable is active. See TXFILLTUNINGTX FIFO Fill Tuning
 * and TXTTFILLTUNING [MPH Only] to characterize the adjustments needed for the
 * scheduler when using this feature. The use of this feature substantially limits
 * of the overall USB performance that can be achieved.
 */
/*@{*/
#define BP_USB_UH1_USBMODE_SDIS (4U)       /*!< Bit position for USB_UH1_USBMODE_SDIS. */
#define BM_USB_UH1_USBMODE_SDIS (0x00000010U) /*!< Bit mask for USB_UH1_USBMODE_SDIS. */
#define BS_USB_UH1_USBMODE_SDIS (1U)       /*!< Bit field size in bits for USB_UH1_USBMODE_SDIS. */

/*! @brief Read current value of the USB_UH1_USBMODE_SDIS field. */
#define BR_USB_UH1_USBMODE_SDIS(x) (HW_USB_UH1_USBMODE(x).B.SDIS)

/*! @brief Format value for bitfield USB_UH1_USBMODE_SDIS. */
#define BF_USB_UH1_USBMODE_SDIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH1_USBMODE_SDIS) & BM_USB_UH1_USBMODE_SDIS)

/*! @brief Set the SDIS field to a new value. */
#define BW_USB_UH1_USBMODE_SDIS(x, v) (HW_USB_UH1_USBMODE_WR(x, (HW_USB_UH1_USBMODE_RD(x) & ~BM_USB_UH1_USBMODE_SDIS) | BF_USB_UH1_USBMODE_SDIS(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_ID - Identification register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_ID - Identification register (RO)
 *
 * Reset value: 0xE401FA05U
 *
 * The ID register identifies the USB 2.0 High-Speed core and its revision.
 */
typedef union _hw_usb_uh2_id
{
    uint32_t U;
    struct _hw_usb_uh2_id_bitfields
    {
        uint32_t ID : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t NID : 6;              /*!< [13:8]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t REVISION : 8;         /*!< [23:16]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh2_id_t;

/*!
 * @name Constants and macros for entire USB_UH2_ID register
 */
/*@{*/
#define HW_USB_UH2_ID_ADDR(x)    ((uintptr_t)(x) + 0x400U)

#define HW_USB_UH2_ID(x)         (*(__I hw_usb_uh2_id_t *) HW_USB_UH2_ID_ADDR(x))
#define HW_USB_UH2_ID_RD(x)      (HW_USB_UH2_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_ID bitfields
 */

/*!
 * @name Register USB_UH2_ID, field ID[5:0] (RO)
 *
 * Configuration number. This number is set to 0x05 and indicates that the
 * peripheral is USB 2.0 High-Speed core.
 */
/*@{*/
#define BP_USB_UH2_ID_ID     (0U)          /*!< Bit position for USB_UH2_ID_ID. */
#define BM_USB_UH2_ID_ID     (0x0000003FU) /*!< Bit mask for USB_UH2_ID_ID. */
#define BS_USB_UH2_ID_ID     (6U)          /*!< Bit field size in bits for USB_UH2_ID_ID. */

/*! @brief Read current value of the USB_UH2_ID_ID field. */
#define BR_USB_UH2_ID_ID(x)  (HW_USB_UH2_ID(x).B.ID)
/*@}*/

/*!
 * @name Register USB_UH2_ID, field NID[13:8] (RO)
 *
 * Complement version of ID
 */
/*@{*/
#define BP_USB_UH2_ID_NID    (8U)          /*!< Bit position for USB_UH2_ID_NID. */
#define BM_USB_UH2_ID_NID    (0x00003F00U) /*!< Bit mask for USB_UH2_ID_NID. */
#define BS_USB_UH2_ID_NID    (6U)          /*!< Bit field size in bits for USB_UH2_ID_NID. */

/*! @brief Read current value of the USB_UH2_ID_NID field. */
#define BR_USB_UH2_ID_NID(x) (HW_USB_UH2_ID(x).B.NID)
/*@}*/

/*!
 * @name Register USB_UH2_ID, field REVISION[23:16] (RO)
 *
 * Revision number of the controller core.
 */
/*@{*/
#define BP_USB_UH2_ID_REVISION (16U)       /*!< Bit position for USB_UH2_ID_REVISION. */
#define BM_USB_UH2_ID_REVISION (0x00FF0000U) /*!< Bit mask for USB_UH2_ID_REVISION. */
#define BS_USB_UH2_ID_REVISION (8U)        /*!< Bit field size in bits for USB_UH2_ID_REVISION. */

/*! @brief Read current value of the USB_UH2_ID_REVISION field. */
#define BR_USB_UH2_ID_REVISION(x) (HW_USB_UH2_ID(x).B.REVISION)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HWGENERAL - Hardware General
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HWGENERAL - Hardware General (RO)
 *
 * Reset value: 0x00000015U
 *
 * General hardware parameters as defined in System Level Issues and Core
 * Configuration. The reset value could vary from instance to instance. Please see the
 * detail in bit field description and ignore reset value in summary table in
 * this case!
 */
typedef union _hw_usb_uh2_hwgeneral
{
    uint32_t U;
    struct _hw_usb_uh2_hwgeneral_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t PHYW : 2;             /*!< [5:4]  */
        uint32_t PHYM : 3;             /*!< [8:6]  */
        uint32_t SM : 2;               /*!< [10:9]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_usb_uh2_hwgeneral_t;

/*!
 * @name Constants and macros for entire USB_UH2_HWGENERAL register
 */
/*@{*/
#define HW_USB_UH2_HWGENERAL_ADDR(x) ((uintptr_t)(x) + 0x404U)

#define HW_USB_UH2_HWGENERAL(x)  (*(__I hw_usb_uh2_hwgeneral_t *) HW_USB_UH2_HWGENERAL_ADDR(x))
#define HW_USB_UH2_HWGENERAL_RD(x) (HW_USB_UH2_HWGENERAL(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HWGENERAL bitfields
 */

/*!
 * @name Register USB_UH2_HWGENERAL, field PHYW[5:4] (RO)
 *
 * Data width of the transciever connected to the controller core. PHYW bit
 * reset value is PHYW bit reset value is '01b'.
 *
 * Values:
 * - 00 - 8 bit wide data bus Software non-programmable
 * - 01 - 16 bit wide data bus Software non-programmable
 * - 10 - Reset to 8 bit wide data bus Software programmable
 * - 11 - Reset to 16 bit wide data bus Software programmable
 */
/*@{*/
#define BP_USB_UH2_HWGENERAL_PHYW (4U)     /*!< Bit position for USB_UH2_HWGENERAL_PHYW. */
#define BM_USB_UH2_HWGENERAL_PHYW (0x00000030U) /*!< Bit mask for USB_UH2_HWGENERAL_PHYW. */
#define BS_USB_UH2_HWGENERAL_PHYW (2U)     /*!< Bit field size in bits for USB_UH2_HWGENERAL_PHYW. */

/*! @brief Read current value of the USB_UH2_HWGENERAL_PHYW field. */
#define BR_USB_UH2_HWGENERAL_PHYW(x) (HW_USB_UH2_HWGENERAL(x).B.PHYW)
/*@}*/

/*!
 * @name Register USB_UH2_HWGENERAL, field PHYM[8:6] (RO)
 *
 * Transciever type PHYM bit reset value: '0000b' for OTG controller core,
 * '0100b' for Host-only controller core.
 *
 * Values:
 * - 000 - UTMI/UMTI+
 * - 001 - ULPI DDR
 * - 010 - ULPI
 * - 011 - Serial Only
 * - 100 - Software programmable - reset to UTMI/UTMI+
 * - 101 - Software programmable - reset to ULPI DDR
 * - 110 - Software programmable - reset to ULPI
 * - 111 - Software programmable - reset to Serial
 */
/*@{*/
#define BP_USB_UH2_HWGENERAL_PHYM (6U)     /*!< Bit position for USB_UH2_HWGENERAL_PHYM. */
#define BM_USB_UH2_HWGENERAL_PHYM (0x000001C0U) /*!< Bit mask for USB_UH2_HWGENERAL_PHYM. */
#define BS_USB_UH2_HWGENERAL_PHYM (3U)     /*!< Bit field size in bits for USB_UH2_HWGENERAL_PHYM. */

/*! @brief Read current value of the USB_UH2_HWGENERAL_PHYM field. */
#define BR_USB_UH2_HWGENERAL_PHYM(x) (HW_USB_UH2_HWGENERAL(x).B.PHYM)
/*@}*/

/*!
 * @name Register USB_UH2_HWGENERAL, field SM[10:9] (RO)
 *
 * Serial interface mode capability SM bit reset value is '00b'
 *
 * Values:
 * - 00 - No Serial Engine, always use parallel signalling.
 * - 01 - Serial Engine present, always use serial signalling for FS/LS.
 * - 10 - Software programmable - Reset to use parallel signalling for FS/LS
 * - 11 - Software programmable - Reset to use serial signalling for FS/LS
 */
/*@{*/
#define BP_USB_UH2_HWGENERAL_SM (9U)       /*!< Bit position for USB_UH2_HWGENERAL_SM. */
#define BM_USB_UH2_HWGENERAL_SM (0x00000600U) /*!< Bit mask for USB_UH2_HWGENERAL_SM. */
#define BS_USB_UH2_HWGENERAL_SM (2U)       /*!< Bit field size in bits for USB_UH2_HWGENERAL_SM. */

/*! @brief Read current value of the USB_UH2_HWGENERAL_SM field. */
#define BR_USB_UH2_HWGENERAL_SM(x) (HW_USB_UH2_HWGENERAL(x).B.SM)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HWHOST - Host Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HWHOST - Host Hardware Parameters (RO)
 *
 * Reset value: 0x10020001U
 */
typedef union _hw_usb_uh2_hwhost
{
    uint32_t U;
    struct _hw_usb_uh2_hwhost_bitfields
    {
        uint32_t HC : 1;               /*!< [0]  */
        uint32_t NPORT : 3;            /*!< [3:1]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_uh2_hwhost_t;

/*!
 * @name Constants and macros for entire USB_UH2_HWHOST register
 */
/*@{*/
#define HW_USB_UH2_HWHOST_ADDR(x) ((uintptr_t)(x) + 0x408U)

#define HW_USB_UH2_HWHOST(x)     (*(__I hw_usb_uh2_hwhost_t *) HW_USB_UH2_HWHOST_ADDR(x))
#define HW_USB_UH2_HWHOST_RD(x)  (HW_USB_UH2_HWHOST(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HWHOST bitfields
 */

/*!
 * @name Register USB_UH2_HWHOST, field HC[0] (RO)
 *
 * Host Capable. Indicating whether host operation mode is supported or not.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_USB_UH2_HWHOST_HC (0U)          /*!< Bit position for USB_UH2_HWHOST_HC. */
#define BM_USB_UH2_HWHOST_HC (0x00000001U) /*!< Bit mask for USB_UH2_HWHOST_HC. */
#define BS_USB_UH2_HWHOST_HC (1U)          /*!< Bit field size in bits for USB_UH2_HWHOST_HC. */

/*! @brief Read current value of the USB_UH2_HWHOST_HC field. */
#define BR_USB_UH2_HWHOST_HC(x) (HW_USB_UH2_HWHOST(x).B.HC)
/*@}*/

/*!
 * @name Register USB_UH2_HWHOST, field NPORT[3:1] (RO)
 *
 * The Nmber of downstream ports supported by the host controller is (NPORT+1).
 * When these bits value is '000', it indicates a single-port host controller.
 */
/*@{*/
#define BP_USB_UH2_HWHOST_NPORT (1U)       /*!< Bit position for USB_UH2_HWHOST_NPORT. */
#define BM_USB_UH2_HWHOST_NPORT (0x0000000EU) /*!< Bit mask for USB_UH2_HWHOST_NPORT. */
#define BS_USB_UH2_HWHOST_NPORT (3U)       /*!< Bit field size in bits for USB_UH2_HWHOST_NPORT. */

/*! @brief Read current value of the USB_UH2_HWHOST_NPORT field. */
#define BR_USB_UH2_HWHOST_NPORT(x) (HW_USB_UH2_HWHOST(x).B.NPORT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HWTXBUF - TX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HWTXBUF - TX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x80080B08U
 */
typedef union _hw_usb_uh2_hwtxbuf
{
    uint32_t U;
    struct _hw_usb_uh2_hwtxbuf_bitfields
    {
        uint32_t TXBURST : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t TXCHANADD : 8;        /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh2_hwtxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH2_HWTXBUF register
 */
/*@{*/
#define HW_USB_UH2_HWTXBUF_ADDR(x) ((uintptr_t)(x) + 0x410U)

#define HW_USB_UH2_HWTXBUF(x)    (*(__I hw_usb_uh2_hwtxbuf_t *) HW_USB_UH2_HWTXBUF_ADDR(x))
#define HW_USB_UH2_HWTXBUF_RD(x) (HW_USB_UH2_HWTXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HWTXBUF bitfields
 */

/*!
 * @name Register USB_UH2_HWTXBUF, field TXBURST[7:0] (RO)
 *
 * Default burst size for memory to TX buffer transfer. This is reset value of
 * TXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH2_HWTXBUF_TXBURST (0U)    /*!< Bit position for USB_UH2_HWTXBUF_TXBURST. */
#define BM_USB_UH2_HWTXBUF_TXBURST (0x000000FFU) /*!< Bit mask for USB_UH2_HWTXBUF_TXBURST. */
#define BS_USB_UH2_HWTXBUF_TXBURST (8U)    /*!< Bit field size in bits for USB_UH2_HWTXBUF_TXBURST. */

/*! @brief Read current value of the USB_UH2_HWTXBUF_TXBURST field. */
#define BR_USB_UH2_HWTXBUF_TXBURST(x) (HW_USB_UH2_HWTXBUF(x).B.TXBURST)
/*@}*/

/*!
 * @name Register USB_UH2_HWTXBUF, field TXCHANADD[23:16] (RO)
 *
 * TX FIFO Buffer size is: (2^TXCHANADD) * 4 Bytes. These bits are set to '08h',
 * so buffer size is 256*4 Bytes. For the OTG controller operating in device
 * mode, this is the FIFO buffer size per endpoint. As the OTG controller has 8 TX
 * endpoint, there are 8 of these buffers. For the OTG controller operating in
 * host mode, or for Host-only controller, the entire buffer memory is used as a
 * single TX buffer. Therefore, there is only 1 of this buffer
 */
/*@{*/
#define BP_USB_UH2_HWTXBUF_TXCHANADD (16U) /*!< Bit position for USB_UH2_HWTXBUF_TXCHANADD. */
#define BM_USB_UH2_HWTXBUF_TXCHANADD (0x00FF0000U) /*!< Bit mask for USB_UH2_HWTXBUF_TXCHANADD. */
#define BS_USB_UH2_HWTXBUF_TXCHANADD (8U)  /*!< Bit field size in bits for USB_UH2_HWTXBUF_TXCHANADD. */

/*! @brief Read current value of the USB_UH2_HWTXBUF_TXCHANADD field. */
#define BR_USB_UH2_HWTXBUF_TXCHANADD(x) (HW_USB_UH2_HWTXBUF(x).B.TXCHANADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HWRXBUF - RX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HWRXBUF - RX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x00000808U
 */
typedef union _hw_usb_uh2_hwrxbuf
{
    uint32_t U;
    struct _hw_usb_uh2_hwrxbuf_bitfields
    {
        uint32_t RXBURST : 8;          /*!< [7:0]  */
        uint32_t RXADD : 8;            /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh2_hwrxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH2_HWRXBUF register
 */
/*@{*/
#define HW_USB_UH2_HWRXBUF_ADDR(x) ((uintptr_t)(x) + 0x414U)

#define HW_USB_UH2_HWRXBUF(x)    (*(__I hw_usb_uh2_hwrxbuf_t *) HW_USB_UH2_HWRXBUF_ADDR(x))
#define HW_USB_UH2_HWRXBUF_RD(x) (HW_USB_UH2_HWRXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HWRXBUF bitfields
 */

/*!
 * @name Register USB_UH2_HWRXBUF, field RXBURST[7:0] (RO)
 *
 * Default burst size for memory to RX buffer transfer. This is reset value of
 * RXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH2_HWRXBUF_RXBURST (0U)    /*!< Bit position for USB_UH2_HWRXBUF_RXBURST. */
#define BM_USB_UH2_HWRXBUF_RXBURST (0x000000FFU) /*!< Bit mask for USB_UH2_HWRXBUF_RXBURST. */
#define BS_USB_UH2_HWRXBUF_RXBURST (8U)    /*!< Bit field size in bits for USB_UH2_HWRXBUF_RXBURST. */

/*! @brief Read current value of the USB_UH2_HWRXBUF_RXBURST field. */
#define BR_USB_UH2_HWRXBUF_RXBURST(x) (HW_USB_UH2_HWRXBUF(x).B.RXBURST)
/*@}*/

/*!
 * @name Register USB_UH2_HWRXBUF, field RXADD[15:8] (RO)
 *
 * Buffer total size for all receive endpoints is (2^RXADD). RX Buffer size is:
 * (2^RXADD) * 4 Bytes. These bits are set to '08h', so buffer size is 256*4
 * Bytes. There is a single Receive FIFO buffer in the USB controller. The buffer is
 * shared for all endpoints for the OTG controller in device mode.
 */
/*@{*/
#define BP_USB_UH2_HWRXBUF_RXADD (8U)      /*!< Bit position for USB_UH2_HWRXBUF_RXADD. */
#define BM_USB_UH2_HWRXBUF_RXADD (0x0000FF00U) /*!< Bit mask for USB_UH2_HWRXBUF_RXADD. */
#define BS_USB_UH2_HWRXBUF_RXADD (8U)      /*!< Bit field size in bits for USB_UH2_HWRXBUF_RXADD. */

/*! @brief Read current value of the USB_UH2_HWRXBUF_RXADD field. */
#define BR_USB_UH2_HWRXBUF_RXADD(x) (HW_USB_UH2_HWRXBUF(x).B.RXADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_GPTIMER0LD - General Purpose Timer #0 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_GPTIMER0LD - General Purpose Timer #0 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER0CTRL. Please see GPTIMER0CTRLGeneral Purpose Timer #0 Controller .
 */
typedef union _hw_usb_uh2_gptimer0ld
{
    uint32_t U;
    struct _hw_usb_uh2_gptimer0ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh2_gptimer0ld_t;

/*!
 * @name Constants and macros for entire USB_UH2_GPTIMER0LD register
 */
/*@{*/
#define HW_USB_UH2_GPTIMER0LD_ADDR(x) ((uintptr_t)(x) + 0x480U)

#define HW_USB_UH2_GPTIMER0LD(x) (*(__IO hw_usb_uh2_gptimer0ld_t *) HW_USB_UH2_GPTIMER0LD_ADDR(x))
#define HW_USB_UH2_GPTIMER0LD_RD(x) (HW_USB_UH2_GPTIMER0LD(x).U)
#define HW_USB_UH2_GPTIMER0LD_WR(x, v) (HW_USB_UH2_GPTIMER0LD(x).U = (v))
#define HW_USB_UH2_GPTIMER0LD_SET(x, v) (HW_USB_UH2_GPTIMER0LD_WR(x, HW_USB_UH2_GPTIMER0LD_RD(x) |  (v)))
#define HW_USB_UH2_GPTIMER0LD_CLR(x, v) (HW_USB_UH2_GPTIMER0LD_WR(x, HW_USB_UH2_GPTIMER0LD_RD(x) & ~(v)))
#define HW_USB_UH2_GPTIMER0LD_TOG(x, v) (HW_USB_UH2_GPTIMER0LD_WR(x, HW_USB_UH2_GPTIMER0LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_GPTIMER0LD bitfields
 */

/*!
 * @name Register USB_UH2_GPTIMER0LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH2_GPTIMER0LD_GPTLD (0U)   /*!< Bit position for USB_UH2_GPTIMER0LD_GPTLD. */
#define BM_USB_UH2_GPTIMER0LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH2_GPTIMER0LD_GPTLD. */
#define BS_USB_UH2_GPTIMER0LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH2_GPTIMER0LD_GPTLD. */

/*! @brief Read current value of the USB_UH2_GPTIMER0LD_GPTLD field. */
#define BR_USB_UH2_GPTIMER0LD_GPTLD(x) (HW_USB_UH2_GPTIMER0LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH2_GPTIMER0LD_GPTLD. */
#define BF_USB_UH2_GPTIMER0LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER0LD_GPTLD) & BM_USB_UH2_GPTIMER0LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH2_GPTIMER0LD_GPTLD(x, v) (HW_USB_UH2_GPTIMER0LD_WR(x, (HW_USB_UH2_GPTIMER0LD_RD(x) & ~BM_USB_UH2_GPTIMER0LD_GPTLD) | BF_USB_UH2_GPTIMER0LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_GPTIMER0CTRL - General Purpose Timer #0 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_GPTIMER0CTRL - General Purpose Timer #0 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI0 bit in n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE0 bit in n_USBINTR register. (See
 * USBINTRInterrupt Enable Register .)
 */
typedef union _hw_usb_uh2_gptimer0ctrl
{
    uint32_t U;
    struct _hw_usb_uh2_gptimer0ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh2_gptimer0ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH2_GPTIMER0CTRL register
 */
/*@{*/
#define HW_USB_UH2_GPTIMER0CTRL_ADDR(x) ((uintptr_t)(x) + 0x484U)

#define HW_USB_UH2_GPTIMER0CTRL(x) (*(__IO hw_usb_uh2_gptimer0ctrl_t *) HW_USB_UH2_GPTIMER0CTRL_ADDR(x))
#define HW_USB_UH2_GPTIMER0CTRL_RD(x) (HW_USB_UH2_GPTIMER0CTRL(x).U)
#define HW_USB_UH2_GPTIMER0CTRL_WR(x, v) (HW_USB_UH2_GPTIMER0CTRL(x).U = (v))
#define HW_USB_UH2_GPTIMER0CTRL_SET(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, HW_USB_UH2_GPTIMER0CTRL_RD(x) |  (v)))
#define HW_USB_UH2_GPTIMER0CTRL_CLR(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, HW_USB_UH2_GPTIMER0CTRL_RD(x) & ~(v)))
#define HW_USB_UH2_GPTIMER0CTRL_TOG(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, HW_USB_UH2_GPTIMER0CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_GPTIMER0CTRL bitfields
 */

/*!
 * @name Register USB_UH2_GPTIMER0CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH2_GPTIMER0CTRL_GPTCNT (0U) /*!< Bit position for USB_UH2_GPTIMER0CTRL_GPTCNT. */
#define BM_USB_UH2_GPTIMER0CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH2_GPTIMER0CTRL_GPTCNT. */
#define BS_USB_UH2_GPTIMER0CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH2_GPTIMER0CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH2_GPTIMER0CTRL_GPTCNT field. */
#define BR_USB_UH2_GPTIMER0CTRL_GPTCNT(x) (HW_USB_UH2_GPTIMER0CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH2_GPTIMER0CTRL_GPTCNT. */
#define BF_USB_UH2_GPTIMER0CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER0CTRL_GPTCNT) & BM_USB_UH2_GPTIMER0CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH2_GPTIMER0CTRL_GPTCNT(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, (HW_USB_UH2_GPTIMER0CTRL_RD(x) & ~BM_USB_UH2_GPTIMER0CTRL_GPTCNT) | BF_USB_UH2_GPTIMER0CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER0CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software; In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH2_GPTIMER0CTRL_GPTMODE (24U) /*!< Bit position for USB_UH2_GPTIMER0CTRL_GPTMODE. */
#define BM_USB_UH2_GPTIMER0CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH2_GPTIMER0CTRL_GPTMODE. */
#define BS_USB_UH2_GPTIMER0CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER0CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH2_GPTIMER0CTRL_GPTMODE field. */
#define BR_USB_UH2_GPTIMER0CTRL_GPTMODE(x) (HW_USB_UH2_GPTIMER0CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH2_GPTIMER0CTRL_GPTMODE. */
#define BF_USB_UH2_GPTIMER0CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER0CTRL_GPTMODE) & BM_USB_UH2_GPTIMER0CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH2_GPTIMER0CTRL_GPTMODE(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, (HW_USB_UH2_GPTIMER0CTRL_RD(x) & ~BM_USB_UH2_GPTIMER0CTRL_GPTMODE) | BF_USB_UH2_GPTIMER0CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER0CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH2_GPTIMER0CTRL_GPTRST (30U) /*!< Bit position for USB_UH2_GPTIMER0CTRL_GPTRST. */
#define BM_USB_UH2_GPTIMER0CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH2_GPTIMER0CTRL_GPTRST. */
#define BS_USB_UH2_GPTIMER0CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER0CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH2_GPTIMER0CTRL_GPTRST field. */
#define BR_USB_UH2_GPTIMER0CTRL_GPTRST(x) (HW_USB_UH2_GPTIMER0CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH2_GPTIMER0CTRL_GPTRST. */
#define BF_USB_UH2_GPTIMER0CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER0CTRL_GPTRST) & BM_USB_UH2_GPTIMER0CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH2_GPTIMER0CTRL_GPTRST(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, (HW_USB_UH2_GPTIMER0CTRL_RD(x) & ~BM_USB_UH2_GPTIMER0CTRL_GPTRST) | BF_USB_UH2_GPTIMER0CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER0CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH2_GPTIMER0CTRL_GPTRUN (31U) /*!< Bit position for USB_UH2_GPTIMER0CTRL_GPTRUN. */
#define BM_USB_UH2_GPTIMER0CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH2_GPTIMER0CTRL_GPTRUN. */
#define BS_USB_UH2_GPTIMER0CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER0CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH2_GPTIMER0CTRL_GPTRUN field. */
#define BR_USB_UH2_GPTIMER0CTRL_GPTRUN(x) (HW_USB_UH2_GPTIMER0CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH2_GPTIMER0CTRL_GPTRUN. */
#define BF_USB_UH2_GPTIMER0CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER0CTRL_GPTRUN) & BM_USB_UH2_GPTIMER0CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH2_GPTIMER0CTRL_GPTRUN(x, v) (HW_USB_UH2_GPTIMER0CTRL_WR(x, (HW_USB_UH2_GPTIMER0CTRL_RD(x) & ~BM_USB_UH2_GPTIMER0CTRL_GPTRUN) | BF_USB_UH2_GPTIMER0CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_GPTIMER1LD - General Purpose Timer #1 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_GPTIMER1LD - General Purpose Timer #1 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER1CTRL. Please see GPTIMER1CTRLGeneral Purpose Timer #1 Controller .
 */
typedef union _hw_usb_uh2_gptimer1ld
{
    uint32_t U;
    struct _hw_usb_uh2_gptimer1ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh2_gptimer1ld_t;

/*!
 * @name Constants and macros for entire USB_UH2_GPTIMER1LD register
 */
/*@{*/
#define HW_USB_UH2_GPTIMER1LD_ADDR(x) ((uintptr_t)(x) + 0x488U)

#define HW_USB_UH2_GPTIMER1LD(x) (*(__IO hw_usb_uh2_gptimer1ld_t *) HW_USB_UH2_GPTIMER1LD_ADDR(x))
#define HW_USB_UH2_GPTIMER1LD_RD(x) (HW_USB_UH2_GPTIMER1LD(x).U)
#define HW_USB_UH2_GPTIMER1LD_WR(x, v) (HW_USB_UH2_GPTIMER1LD(x).U = (v))
#define HW_USB_UH2_GPTIMER1LD_SET(x, v) (HW_USB_UH2_GPTIMER1LD_WR(x, HW_USB_UH2_GPTIMER1LD_RD(x) |  (v)))
#define HW_USB_UH2_GPTIMER1LD_CLR(x, v) (HW_USB_UH2_GPTIMER1LD_WR(x, HW_USB_UH2_GPTIMER1LD_RD(x) & ~(v)))
#define HW_USB_UH2_GPTIMER1LD_TOG(x, v) (HW_USB_UH2_GPTIMER1LD_WR(x, HW_USB_UH2_GPTIMER1LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_GPTIMER1LD bitfields
 */

/*!
 * @name Register USB_UH2_GPTIMER1LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH2_GPTIMER1LD_GPTLD (0U)   /*!< Bit position for USB_UH2_GPTIMER1LD_GPTLD. */
#define BM_USB_UH2_GPTIMER1LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH2_GPTIMER1LD_GPTLD. */
#define BS_USB_UH2_GPTIMER1LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH2_GPTIMER1LD_GPTLD. */

/*! @brief Read current value of the USB_UH2_GPTIMER1LD_GPTLD field. */
#define BR_USB_UH2_GPTIMER1LD_GPTLD(x) (HW_USB_UH2_GPTIMER1LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH2_GPTIMER1LD_GPTLD. */
#define BF_USB_UH2_GPTIMER1LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER1LD_GPTLD) & BM_USB_UH2_GPTIMER1LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH2_GPTIMER1LD_GPTLD(x, v) (HW_USB_UH2_GPTIMER1LD_WR(x, (HW_USB_UH2_GPTIMER1LD_RD(x) & ~BM_USB_UH2_GPTIMER1LD_GPTLD) | BF_USB_UH2_GPTIMER1LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_GPTIMER1CTRL - General Purpose Timer #1 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_GPTIMER1CTRL - General Purpose Timer #1 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI1 bit in USB_n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE1 bit in n_USBINTR register (See
 * USBINTRInterrupt Enable Register ).
 */
typedef union _hw_usb_uh2_gptimer1ctrl
{
    uint32_t U;
    struct _hw_usb_uh2_gptimer1ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh2_gptimer1ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH2_GPTIMER1CTRL register
 */
/*@{*/
#define HW_USB_UH2_GPTIMER1CTRL_ADDR(x) ((uintptr_t)(x) + 0x48CU)

#define HW_USB_UH2_GPTIMER1CTRL(x) (*(__IO hw_usb_uh2_gptimer1ctrl_t *) HW_USB_UH2_GPTIMER1CTRL_ADDR(x))
#define HW_USB_UH2_GPTIMER1CTRL_RD(x) (HW_USB_UH2_GPTIMER1CTRL(x).U)
#define HW_USB_UH2_GPTIMER1CTRL_WR(x, v) (HW_USB_UH2_GPTIMER1CTRL(x).U = (v))
#define HW_USB_UH2_GPTIMER1CTRL_SET(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, HW_USB_UH2_GPTIMER1CTRL_RD(x) |  (v)))
#define HW_USB_UH2_GPTIMER1CTRL_CLR(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, HW_USB_UH2_GPTIMER1CTRL_RD(x) & ~(v)))
#define HW_USB_UH2_GPTIMER1CTRL_TOG(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, HW_USB_UH2_GPTIMER1CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_GPTIMER1CTRL bitfields
 */

/*!
 * @name Register USB_UH2_GPTIMER1CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH2_GPTIMER1CTRL_GPTCNT (0U) /*!< Bit position for USB_UH2_GPTIMER1CTRL_GPTCNT. */
#define BM_USB_UH2_GPTIMER1CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH2_GPTIMER1CTRL_GPTCNT. */
#define BS_USB_UH2_GPTIMER1CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH2_GPTIMER1CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH2_GPTIMER1CTRL_GPTCNT field. */
#define BR_USB_UH2_GPTIMER1CTRL_GPTCNT(x) (HW_USB_UH2_GPTIMER1CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH2_GPTIMER1CTRL_GPTCNT. */
#define BF_USB_UH2_GPTIMER1CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER1CTRL_GPTCNT) & BM_USB_UH2_GPTIMER1CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH2_GPTIMER1CTRL_GPTCNT(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, (HW_USB_UH2_GPTIMER1CTRL_RD(x) & ~BM_USB_UH2_GPTIMER1CTRL_GPTCNT) | BF_USB_UH2_GPTIMER1CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER1CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software. In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH2_GPTIMER1CTRL_GPTMODE (24U) /*!< Bit position for USB_UH2_GPTIMER1CTRL_GPTMODE. */
#define BM_USB_UH2_GPTIMER1CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH2_GPTIMER1CTRL_GPTMODE. */
#define BS_USB_UH2_GPTIMER1CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER1CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH2_GPTIMER1CTRL_GPTMODE field. */
#define BR_USB_UH2_GPTIMER1CTRL_GPTMODE(x) (HW_USB_UH2_GPTIMER1CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH2_GPTIMER1CTRL_GPTMODE. */
#define BF_USB_UH2_GPTIMER1CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER1CTRL_GPTMODE) & BM_USB_UH2_GPTIMER1CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH2_GPTIMER1CTRL_GPTMODE(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, (HW_USB_UH2_GPTIMER1CTRL_RD(x) & ~BM_USB_UH2_GPTIMER1CTRL_GPTMODE) | BF_USB_UH2_GPTIMER1CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER1CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in USB_n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH2_GPTIMER1CTRL_GPTRST (30U) /*!< Bit position for USB_UH2_GPTIMER1CTRL_GPTRST. */
#define BM_USB_UH2_GPTIMER1CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH2_GPTIMER1CTRL_GPTRST. */
#define BS_USB_UH2_GPTIMER1CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER1CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH2_GPTIMER1CTRL_GPTRST field. */
#define BR_USB_UH2_GPTIMER1CTRL_GPTRST(x) (HW_USB_UH2_GPTIMER1CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH2_GPTIMER1CTRL_GPTRST. */
#define BF_USB_UH2_GPTIMER1CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER1CTRL_GPTRST) & BM_USB_UH2_GPTIMER1CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH2_GPTIMER1CTRL_GPTRST(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, (HW_USB_UH2_GPTIMER1CTRL_RD(x) & ~BM_USB_UH2_GPTIMER1CTRL_GPTRST) | BF_USB_UH2_GPTIMER1CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH2_GPTIMER1CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH2_GPTIMER1CTRL_GPTRUN (31U) /*!< Bit position for USB_UH2_GPTIMER1CTRL_GPTRUN. */
#define BM_USB_UH2_GPTIMER1CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH2_GPTIMER1CTRL_GPTRUN. */
#define BS_USB_UH2_GPTIMER1CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH2_GPTIMER1CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH2_GPTIMER1CTRL_GPTRUN field. */
#define BR_USB_UH2_GPTIMER1CTRL_GPTRUN(x) (HW_USB_UH2_GPTIMER1CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH2_GPTIMER1CTRL_GPTRUN. */
#define BF_USB_UH2_GPTIMER1CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_GPTIMER1CTRL_GPTRUN) & BM_USB_UH2_GPTIMER1CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH2_GPTIMER1CTRL_GPTRUN(x, v) (HW_USB_UH2_GPTIMER1CTRL_WR(x, (HW_USB_UH2_GPTIMER1CTRL_RD(x) & ~BM_USB_UH2_GPTIMER1CTRL_GPTRUN) | BF_USB_UH2_GPTIMER1CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_SBUSCFG - System Bus Config
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_SBUSCFG - System Bus Config (RW)
 *
 * Reset value: 0x00000002U
 */
typedef union _hw_usb_uh2_sbuscfg
{
    uint32_t U;
    struct _hw_usb_uh2_sbuscfg_bitfields
    {
        uint32_t AHBBRST : 3;          /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_usb_uh2_sbuscfg_t;

/*!
 * @name Constants and macros for entire USB_UH2_SBUSCFG register
 */
/*@{*/
#define HW_USB_UH2_SBUSCFG_ADDR(x) ((uintptr_t)(x) + 0x490U)

#define HW_USB_UH2_SBUSCFG(x)    (*(__IO hw_usb_uh2_sbuscfg_t *) HW_USB_UH2_SBUSCFG_ADDR(x))
#define HW_USB_UH2_SBUSCFG_RD(x) (HW_USB_UH2_SBUSCFG(x).U)
#define HW_USB_UH2_SBUSCFG_WR(x, v) (HW_USB_UH2_SBUSCFG(x).U = (v))
#define HW_USB_UH2_SBUSCFG_SET(x, v) (HW_USB_UH2_SBUSCFG_WR(x, HW_USB_UH2_SBUSCFG_RD(x) |  (v)))
#define HW_USB_UH2_SBUSCFG_CLR(x, v) (HW_USB_UH2_SBUSCFG_WR(x, HW_USB_UH2_SBUSCFG_RD(x) & ~(v)))
#define HW_USB_UH2_SBUSCFG_TOG(x, v) (HW_USB_UH2_SBUSCFG_WR(x, HW_USB_UH2_SBUSCFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_SBUSCFG bitfields
 */

/*!
 * @name Register USB_UH2_SBUSCFG, field AHBBRST[2:0] (RW)
 *
 * AHB master interface Burst configuration These bits control AHB master
 * transfer type sequence (or priority). This register overrides n_BURSTSIZE register
 * when its value is not zero.
 *
 * Values:
 * - 000 - Incremental burst of unspecified length only
 * - 001 - INCR4 burst, then single transfer
 * - 010 - INCR8 burst, INCR4 burst, then single transfer
 * - 011 - INCR16 burst, INCR8 burst, INCR4 burst, then single transfer
 * - 100 - Reserved, don't use
 * - 101 - INCR4 burst, then incremental burst of unspecified length
 * - 110 - INCR8 burst, INCR4 burst, then incremental burst of unspecified length
 * - 111 - INCR16 burst, INCR8 burst, INCR4 burst, then incremental burst of
 *     unspecified length
 */
/*@{*/
#define BP_USB_UH2_SBUSCFG_AHBBRST (0U)    /*!< Bit position for USB_UH2_SBUSCFG_AHBBRST. */
#define BM_USB_UH2_SBUSCFG_AHBBRST (0x00000007U) /*!< Bit mask for USB_UH2_SBUSCFG_AHBBRST. */
#define BS_USB_UH2_SBUSCFG_AHBBRST (3U)    /*!< Bit field size in bits for USB_UH2_SBUSCFG_AHBBRST. */

/*! @brief Read current value of the USB_UH2_SBUSCFG_AHBBRST field. */
#define BR_USB_UH2_SBUSCFG_AHBBRST(x) (HW_USB_UH2_SBUSCFG(x).B.AHBBRST)

/*! @brief Format value for bitfield USB_UH2_SBUSCFG_AHBBRST. */
#define BF_USB_UH2_SBUSCFG_AHBBRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_SBUSCFG_AHBBRST) & BM_USB_UH2_SBUSCFG_AHBBRST)

/*! @brief Set the AHBBRST field to a new value. */
#define BW_USB_UH2_SBUSCFG_AHBBRST(x, v) (HW_USB_UH2_SBUSCFG_WR(x, (HW_USB_UH2_SBUSCFG_RD(x) & ~BM_USB_UH2_SBUSCFG_AHBBRST) | BF_USB_UH2_SBUSCFG_AHBBRST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_CAPLENGTH - Capability Registers Length
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_CAPLENGTH - Capability Registers Length (RO)
 *
 * Reset value: 0x40U
 *
 * The Capability Registers Length register contains the address offset to the
 * Operational registers relative to the CAPLENGTH register.
 */
typedef union _hw_usb_uh2_caplength
{
    uint8_t U;
    struct _hw_usb_uh2_caplength_bitfields
    {
        uint8_t CAPLENGTH : 8;         /*!< [7:0]  */
    } B;
} hw_usb_uh2_caplength_t;

/*!
 * @name Constants and macros for entire USB_UH2_CAPLENGTH register
 */
/*@{*/
#define HW_USB_UH2_CAPLENGTH_ADDR(x) ((uintptr_t)(x) + 0x500U)

#define HW_USB_UH2_CAPLENGTH(x)  (*(__I hw_usb_uh2_caplength_t *) HW_USB_UH2_CAPLENGTH_ADDR(x))
#define HW_USB_UH2_CAPLENGTH_RD(x) (HW_USB_UH2_CAPLENGTH(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_CAPLENGTH bitfields
 */

/*!
 * @name Register USB_UH2_CAPLENGTH, field CAPLENGTH[7:0] (RO)
 *
 * These bits are used as an offset to add to register base to find the
 * beginning of the Operational Register. Default value is '40h'.
 */
/*@{*/
#define BP_USB_UH2_CAPLENGTH_CAPLENGTH (0U) /*!< Bit position for USB_UH2_CAPLENGTH_CAPLENGTH. */
#define BM_USB_UH2_CAPLENGTH_CAPLENGTH (0xFFU) /*!< Bit mask for USB_UH2_CAPLENGTH_CAPLENGTH. */
#define BS_USB_UH2_CAPLENGTH_CAPLENGTH (8U) /*!< Bit field size in bits for USB_UH2_CAPLENGTH_CAPLENGTH. */

/*! @brief Read current value of the USB_UH2_CAPLENGTH_CAPLENGTH field. */
#define BR_USB_UH2_CAPLENGTH_CAPLENGTH(x) (HW_USB_UH2_CAPLENGTH(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HCIVERSION - Host Controller Interface Version
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HCIVERSION - Host Controller Interface Version (RO)
 *
 * Reset value: 0x0100U
 *
 * This is a 2-byte register containing a BCD encoding of the EHCI revision
 * number supported by this host controller. The most significant byte of this
 * register represents a major revision and the least significant byte is the minor
 * revision.
 */
typedef union _hw_usb_uh2_hciversion
{
    uint16_t U;
    struct _hw_usb_uh2_hciversion_bitfields
    {
        uint16_t HCIVERSION : 16;      /*!< [15:0]  */
    } B;
} hw_usb_uh2_hciversion_t;

/*!
 * @name Constants and macros for entire USB_UH2_HCIVERSION register
 */
/*@{*/
#define HW_USB_UH2_HCIVERSION_ADDR(x) ((uintptr_t)(x) + 0x502U)

#define HW_USB_UH2_HCIVERSION(x) (*(__I hw_usb_uh2_hciversion_t *) HW_USB_UH2_HCIVERSION_ADDR(x))
#define HW_USB_UH2_HCIVERSION_RD(x) (HW_USB_UH2_HCIVERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HCIVERSION bitfields
 */

/*!
 * @name Register USB_UH2_HCIVERSION, field HCIVERSION[15:0] (RO)
 *
 * Host Controller Interface Version Number Default value is '10h', which means
 * EHCI rev1.0.
 */
/*@{*/
#define BP_USB_UH2_HCIVERSION_HCIVERSION (0U) /*!< Bit position for USB_UH2_HCIVERSION_HCIVERSION. */
#define BM_USB_UH2_HCIVERSION_HCIVERSION (0xFFFFU) /*!< Bit mask for USB_UH2_HCIVERSION_HCIVERSION. */
#define BS_USB_UH2_HCIVERSION_HCIVERSION (16U) /*!< Bit field size in bits for USB_UH2_HCIVERSION_HCIVERSION. */

/*! @brief Read current value of the USB_UH2_HCIVERSION_HCIVERSION field. */
#define BR_USB_UH2_HCIVERSION_HCIVERSION(x) (HW_USB_UH2_HCIVERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HCSPARAMS - Host Controller Structural Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HCSPARAMS - Host Controller Structural Parameters (RO)
 *
 * Reset value: 0x00010011U
 *
 * The following figure shows the port steering logic capabilities of Host
 * Control Structural Parameters (n_HCSPARAMS).
 */
typedef union _hw_usb_uh2_hcsparams
{
    uint32_t U;
    struct _hw_usb_uh2_hcsparams_bitfields
    {
        uint32_t N_PORTS : 4;          /*!< [3:0]  */
        uint32_t PPC : 1;              /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t N_PCC : 4;            /*!< [11:8]  */
        uint32_t N_CC : 4;             /*!< [15:12]  */
        uint32_t PI : 1;               /*!< [16]  */
        uint32_t RESERVED1 : 3;        /*!< [19:17]  */
        uint32_t N_PTT : 4;            /*!< [23:20]  */
        uint32_t N_TT : 4;             /*!< [27:24]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_uh2_hcsparams_t;

/*!
 * @name Constants and macros for entire USB_UH2_HCSPARAMS register
 */
/*@{*/
#define HW_USB_UH2_HCSPARAMS_ADDR(x) ((uintptr_t)(x) + 0x504U)

#define HW_USB_UH2_HCSPARAMS(x)  (*(__I hw_usb_uh2_hcsparams_t *) HW_USB_UH2_HCSPARAMS_ADDR(x))
#define HW_USB_UH2_HCSPARAMS_RD(x) (HW_USB_UH2_HCSPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HCSPARAMS bitfields
 */

/*!
 * @name Register USB_UH2_HCSPARAMS, field N_PORTS[3:0] (RO)
 *
 * Number of downstream ports. This field specifies the number of physical
 * downstream ports implemented on this host controller. The value of this field
 * determines how many port registers are addressable in the Operational Register.
 * Valid values are in the range of 1h to Fh. A zero in this field is undefined.
 * These bits are always set to '0001b' because all controller cores are Single-Port
 * Host.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_N_PORTS (0U)  /*!< Bit position for USB_UH2_HCSPARAMS_N_PORTS. */
#define BM_USB_UH2_HCSPARAMS_N_PORTS (0x0000000FU) /*!< Bit mask for USB_UH2_HCSPARAMS_N_PORTS. */
#define BS_USB_UH2_HCSPARAMS_N_PORTS (4U)  /*!< Bit field size in bits for USB_UH2_HCSPARAMS_N_PORTS. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_N_PORTS field. */
#define BR_USB_UH2_HCSPARAMS_N_PORTS(x) (HW_USB_UH2_HCSPARAMS(x).B.N_PORTS)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field PPC[4] (RO)
 *
 * Port Power Control This field indicates whether the host controller
 * implementation includes port power control. A one indicates the ports have port power
 * switches. A zero indicates the ports do not have port power switches. The value
 * of this field affects the functionality of the Port Power field in each port
 * status and control register
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_PPC (4U)      /*!< Bit position for USB_UH2_HCSPARAMS_PPC. */
#define BM_USB_UH2_HCSPARAMS_PPC (0x00000010U) /*!< Bit mask for USB_UH2_HCSPARAMS_PPC. */
#define BS_USB_UH2_HCSPARAMS_PPC (1U)      /*!< Bit field size in bits for USB_UH2_HCSPARAMS_PPC. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_PPC field. */
#define BR_USB_UH2_HCSPARAMS_PPC(x) (HW_USB_UH2_HCSPARAMS(x).B.PPC)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field N_PCC[11:8] (RO)
 *
 * Number of Ports per Companion Controller This field indicates the number of
 * ports supported per internal Companion Controller. It is used to indicate the
 * port routing configuration to the system software. For example, if N_PORTS has
 * a value of 6 and N_CC has a value of 2 then N_PCC could have a value of 3. The
 * convention is that the first N_PCC ports are assumed to be routed to
 * companion controller 1, the next N_PCC ports to companion controller 2, etc. In the
 * previous example, the N_PCC could have been 4, where the first 4 are routed to
 * companion controller 1 and the last two are routed to companion controller 2.
 * The number in this field must be consistent with N_PORTS and N_CC. These bits
 * are '0000b' in all controller core.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_N_PCC (8U)    /*!< Bit position for USB_UH2_HCSPARAMS_N_PCC. */
#define BM_USB_UH2_HCSPARAMS_N_PCC (0x00000F00U) /*!< Bit mask for USB_UH2_HCSPARAMS_N_PCC. */
#define BS_USB_UH2_HCSPARAMS_N_PCC (4U)    /*!< Bit field size in bits for USB_UH2_HCSPARAMS_N_PCC. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_N_PCC field. */
#define BR_USB_UH2_HCSPARAMS_N_PCC(x) (HW_USB_UH2_HCSPARAMS(x).B.N_PCC)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field N_CC[15:12] (RO)
 *
 * Number of Companion Controller (N_CC). This field indicates the number of
 * companion controllers associated with this USB2.0 host controller. These bits are
 * '0000b' in all controller core.
 *
 * Values:
 * - 0 - There is no internal Companion Controller and port-ownership hand-off
 *     is not supported.
 * - 1 - There are internal companion controller(s) and port-ownership hand-offs
 *     is supported.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_N_CC (12U)    /*!< Bit position for USB_UH2_HCSPARAMS_N_CC. */
#define BM_USB_UH2_HCSPARAMS_N_CC (0x0000F000U) /*!< Bit mask for USB_UH2_HCSPARAMS_N_CC. */
#define BS_USB_UH2_HCSPARAMS_N_CC (4U)     /*!< Bit field size in bits for USB_UH2_HCSPARAMS_N_CC. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_N_CC field. */
#define BR_USB_UH2_HCSPARAMS_N_CC(x) (HW_USB_UH2_HCSPARAMS(x).B.N_CC)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field PI[16] (RO)
 *
 * Port Indicators (P INDICATOR) This bit indicates whether the ports support
 * port indicator control. When set to one, the port status and control registers
 * include a read/writeable field for controlling the state of the port indicator
 * This bit is "1b" in all controller core.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_PI (16U)      /*!< Bit position for USB_UH2_HCSPARAMS_PI. */
#define BM_USB_UH2_HCSPARAMS_PI (0x00010000U) /*!< Bit mask for USB_UH2_HCSPARAMS_PI. */
#define BS_USB_UH2_HCSPARAMS_PI (1U)       /*!< Bit field size in bits for USB_UH2_HCSPARAMS_PI. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_PI field. */
#define BR_USB_UH2_HCSPARAMS_PI(x) (HW_USB_UH2_HCSPARAMS(x).B.PI)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field N_PTT[23:20] (RO)
 *
 * Number of Ports per Transaction Translator (N_PTT). Default value '0000b'
 * This field indicates the number of ports assigned to each transaction translator
 * within the USB2.0 host controller. These bits would be set to equal N_PORTS
 * for Multi-Port Host, and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_N_PTT (20U)   /*!< Bit position for USB_UH2_HCSPARAMS_N_PTT. */
#define BM_USB_UH2_HCSPARAMS_N_PTT (0x00F00000U) /*!< Bit mask for USB_UH2_HCSPARAMS_N_PTT. */
#define BS_USB_UH2_HCSPARAMS_N_PTT (4U)    /*!< Bit field size in bits for USB_UH2_HCSPARAMS_N_PTT. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_N_PTT field. */
#define BR_USB_UH2_HCSPARAMS_N_PTT(x) (HW_USB_UH2_HCSPARAMS(x).B.N_PTT)
/*@}*/

/*!
 * @name Register USB_UH2_HCSPARAMS, field N_TT[27:24] (RO)
 *
 * Number of Transaction Translators (N_TT). Default value '0000b' This field
 * indicates the number of embedded transaction translators associated with the
 * USB2.0 host controller. These bits would be set to '0001b' for Multi-Port Host,
 * and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH2_HCSPARAMS_N_TT (24U)    /*!< Bit position for USB_UH2_HCSPARAMS_N_TT. */
#define BM_USB_UH2_HCSPARAMS_N_TT (0x0F000000U) /*!< Bit mask for USB_UH2_HCSPARAMS_N_TT. */
#define BS_USB_UH2_HCSPARAMS_N_TT (4U)     /*!< Bit field size in bits for USB_UH2_HCSPARAMS_N_TT. */

/*! @brief Read current value of the USB_UH2_HCSPARAMS_N_TT field. */
#define BR_USB_UH2_HCSPARAMS_N_TT(x) (HW_USB_UH2_HCSPARAMS(x).B.N_TT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_HCCPARAMS - Host Controller Capability Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_HCCPARAMS - Host Controller Capability Parameters (RO)
 *
 * Reset value: 0x00000006U
 *
 * This register identifies multiple mode control (time-base bit functionality),
 * addressing capability.
 */
typedef union _hw_usb_uh2_hccparams
{
    uint32_t U;
    struct _hw_usb_uh2_hccparams_bitfields
    {
        uint32_t ADC : 1;              /*!< [0]  */
        uint32_t PFL : 1;              /*!< [1]  */
        uint32_t ASP : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t IST : 4;              /*!< [7:4]  */
        uint32_t EECP : 8;             /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh2_hccparams_t;

/*!
 * @name Constants and macros for entire USB_UH2_HCCPARAMS register
 */
/*@{*/
#define HW_USB_UH2_HCCPARAMS_ADDR(x) ((uintptr_t)(x) + 0x508U)

#define HW_USB_UH2_HCCPARAMS(x)  (*(__I hw_usb_uh2_hccparams_t *) HW_USB_UH2_HCCPARAMS_ADDR(x))
#define HW_USB_UH2_HCCPARAMS_RD(x) (HW_USB_UH2_HCCPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_HCCPARAMS bitfields
 */

/*!
 * @name Register USB_UH2_HCCPARAMS, field ADC[0] (RO)
 *
 * 64-bit Addressing Capability This bit is set '0b' in all controller core, no
 * 64-bit addressing capability is supported.
 */
/*@{*/
#define BP_USB_UH2_HCCPARAMS_ADC (0U)      /*!< Bit position for USB_UH2_HCCPARAMS_ADC. */
#define BM_USB_UH2_HCCPARAMS_ADC (0x00000001U) /*!< Bit mask for USB_UH2_HCCPARAMS_ADC. */
#define BS_USB_UH2_HCCPARAMS_ADC (1U)      /*!< Bit field size in bits for USB_UH2_HCCPARAMS_ADC. */

/*! @brief Read current value of the USB_UH2_HCCPARAMS_ADC field. */
#define BR_USB_UH2_HCCPARAMS_ADC(x) (HW_USB_UH2_HCCPARAMS(x).B.ADC)
/*@}*/

/*!
 * @name Register USB_UH2_HCCPARAMS, field PFL[1] (RO)
 *
 * Programmable Frame List Flag If this bit is set to zero, then the system
 * software must use a frame list length of 1024 elements with this host controller.
 * The USBCMD register Frame List Size field is a read-only register and must be
 * set to zero. If set to a one, then the system software can specify and use a
 * smaller frame list and configure the host controller via the USBCMD register
 * Frame List Size field. The frame list must always be aligned on a 4K-page
 * boundary. This requirement ensures that the frame list is always physically
 * contiguous. This bit is set '1b' in all controller core.
 */
/*@{*/
#define BP_USB_UH2_HCCPARAMS_PFL (1U)      /*!< Bit position for USB_UH2_HCCPARAMS_PFL. */
#define BM_USB_UH2_HCCPARAMS_PFL (0x00000002U) /*!< Bit mask for USB_UH2_HCCPARAMS_PFL. */
#define BS_USB_UH2_HCCPARAMS_PFL (1U)      /*!< Bit field size in bits for USB_UH2_HCCPARAMS_PFL. */

/*! @brief Read current value of the USB_UH2_HCCPARAMS_PFL field. */
#define BR_USB_UH2_HCCPARAMS_PFL(x) (HW_USB_UH2_HCCPARAMS(x).B.PFL)
/*@}*/

/*!
 * @name Register USB_UH2_HCCPARAMS, field ASP[2] (RO)
 *
 * Asynchronous Schedule Park Capability If this bit is set to a one, then the
 * host controller supports the park feature for high-speed queue heads in the
 * Asynchronous Schedule. The feature can be disabled or enabled and set to a
 * specific level by using the Asynchronous Schedule Park Mode Enable and Asynchronous
 * Schedule Park Mode Count fields in the USBCMD register. ASP bit reset value:
 * '00b' for OTG controller core, '11b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_HCCPARAMS_ASP (2U)      /*!< Bit position for USB_UH2_HCCPARAMS_ASP. */
#define BM_USB_UH2_HCCPARAMS_ASP (0x00000004U) /*!< Bit mask for USB_UH2_HCCPARAMS_ASP. */
#define BS_USB_UH2_HCCPARAMS_ASP (1U)      /*!< Bit field size in bits for USB_UH2_HCCPARAMS_ASP. */

/*! @brief Read current value of the USB_UH2_HCCPARAMS_ASP field. */
#define BR_USB_UH2_HCCPARAMS_ASP(x) (HW_USB_UH2_HCCPARAMS(x).B.ASP)
/*@}*/

/*!
 * @name Register USB_UH2_HCCPARAMS, field IST[7:4] (RO)
 *
 * Isochronous Scheduling Threshold. This field indicates, relative to the
 * current position of the executing host controller, where software can reliably
 * update the isochronous schedule. When bit [7] is zero, the value of the least
 * significant 3 bits indicates the number of micro-frames a host controller can hold
 * a set of isochronous data structures (one or more) before flushing the state.
 * When bit [7] is a one, then host software assumes the host controller may
 * cache an isochronous data structure for an entire frame. These bits are set '00h'
 * in all controller core.
 */
/*@{*/
#define BP_USB_UH2_HCCPARAMS_IST (4U)      /*!< Bit position for USB_UH2_HCCPARAMS_IST. */
#define BM_USB_UH2_HCCPARAMS_IST (0x000000F0U) /*!< Bit mask for USB_UH2_HCCPARAMS_IST. */
#define BS_USB_UH2_HCCPARAMS_IST (4U)      /*!< Bit field size in bits for USB_UH2_HCCPARAMS_IST. */

/*! @brief Read current value of the USB_UH2_HCCPARAMS_IST field. */
#define BR_USB_UH2_HCCPARAMS_IST(x) (HW_USB_UH2_HCCPARAMS(x).B.IST)
/*@}*/

/*!
 * @name Register USB_UH2_HCCPARAMS, field EECP[15:8] (RO)
 *
 * EHCI Extended Capabilities Pointer. This field indicates the existence of a
 * capabilities list. A value of 00h indicates no extended capabilities are
 * implemented. A non-zero value in this register indicates the offset in PCI
 * configuration space of the first EHCI extended capability. The pointer value must be
 * 40h or greater if implemented to maintain the consistency of the PCI header
 * defined for this class of device. These bits are set '00h' in all controller core.
 */
/*@{*/
#define BP_USB_UH2_HCCPARAMS_EECP (8U)     /*!< Bit position for USB_UH2_HCCPARAMS_EECP. */
#define BM_USB_UH2_HCCPARAMS_EECP (0x0000FF00U) /*!< Bit mask for USB_UH2_HCCPARAMS_EECP. */
#define BS_USB_UH2_HCCPARAMS_EECP (8U)     /*!< Bit field size in bits for USB_UH2_HCCPARAMS_EECP. */

/*! @brief Read current value of the USB_UH2_HCCPARAMS_EECP field. */
#define BR_USB_UH2_HCCPARAMS_EECP(x) (HW_USB_UH2_HCCPARAMS(x).B.EECP)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_USBCMD - USB Command Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_USBCMD - USB Command Register (RW)
 *
 * Reset value: 0x00080000U
 *
 * The Command Register indicates the command to be executed by the serial bus
 * host/device controller. Writing to the register causes a command to be executed.
 */
typedef union _hw_usb_uh2_usbcmd
{
    uint32_t U;
    struct _hw_usb_uh2_usbcmd_bitfields
    {
        uint32_t RS : 1;               /*!< [0]  */
        uint32_t RST : 1;              /*!< [1]  */
        uint32_t FS_1 : 2;             /*!< [3:2]  */
        uint32_t PSE : 1;              /*!< [4]  */
        uint32_t ASE : 1;              /*!< [5]  */
        uint32_t IAA : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t ASP : 2;              /*!< [9:8]  */
        uint32_t RESERVED1 : 1;        /*!< [10]  */
        uint32_t ASPE : 1;             /*!< [11]  */
        uint32_t ATDTW : 1;            /*!< [12]  */
        uint32_t SUTW : 1;             /*!< [13]  */
        uint32_t RESERVED2 : 1;        /*!< [14]  */
        uint32_t FS_2 : 1;             /*!< [15]  */
        uint32_t ITC : 8;              /*!< [23:16]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh2_usbcmd_t;

/*!
 * @name Constants and macros for entire USB_UH2_USBCMD register
 */
/*@{*/
#define HW_USB_UH2_USBCMD_ADDR(x) ((uintptr_t)(x) + 0x540U)

#define HW_USB_UH2_USBCMD(x)     (*(__IO hw_usb_uh2_usbcmd_t *) HW_USB_UH2_USBCMD_ADDR(x))
#define HW_USB_UH2_USBCMD_RD(x)  (HW_USB_UH2_USBCMD(x).U)
#define HW_USB_UH2_USBCMD_WR(x, v) (HW_USB_UH2_USBCMD(x).U = (v))
#define HW_USB_UH2_USBCMD_SET(x, v) (HW_USB_UH2_USBCMD_WR(x, HW_USB_UH2_USBCMD_RD(x) |  (v)))
#define HW_USB_UH2_USBCMD_CLR(x, v) (HW_USB_UH2_USBCMD_WR(x, HW_USB_UH2_USBCMD_RD(x) & ~(v)))
#define HW_USB_UH2_USBCMD_TOG(x, v) (HW_USB_UH2_USBCMD_WR(x, HW_USB_UH2_USBCMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_USBCMD bitfields
 */

/*!
 * @name Register USB_UH2_USBCMD, field RS[0] (RW)
 *
 * Run/Stop (RS) - Read/Write. Default 0b. 1=Run. 0=Stop. Host operation mode:
 * When set to '1b', the Controller proceeds with the execution of the schedule.
 * The Controller continues execution as long as this bit is set to a one. When
 * this bit is set to 0, the Host Controller completes the current transaction on
 * the USB and then halts. The HC Halted bit in the status register indicates when
 * the Controller has finished the transaction and has entered the stopped
 * state. Software should not write a one to this field unless the controller is in
 * the Halted state (that is, HCHalted in the USBSTS register is a one). Device
 * operation mode: Writing a one to this bit will cause the controller to enable a
 * pull-up on D+ and initiate an attach event. This control bit is not directly
 * connected to the pull-up enable, as the pull-up will become disabled upon
 * transitioning into high-speed mode. Software should use this bit to prevent an
 * attach event before the controller has been properly initialized. Writing a 0 to
 * this will cause a detach event.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_RS (0U)          /*!< Bit position for USB_UH2_USBCMD_RS. */
#define BM_USB_UH2_USBCMD_RS (0x00000001U) /*!< Bit mask for USB_UH2_USBCMD_RS. */
#define BS_USB_UH2_USBCMD_RS (1U)          /*!< Bit field size in bits for USB_UH2_USBCMD_RS. */

/*! @brief Read current value of the USB_UH2_USBCMD_RS field. */
#define BR_USB_UH2_USBCMD_RS(x) (HW_USB_UH2_USBCMD(x).B.RS)

/*! @brief Format value for bitfield USB_UH2_USBCMD_RS. */
#define BF_USB_UH2_USBCMD_RS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_RS) & BM_USB_UH2_USBCMD_RS)

/*! @brief Set the RS field to a new value. */
#define BW_USB_UH2_USBCMD_RS(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_RS) | BF_USB_UH2_USBCMD_RS(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field RST[1] (RW)
 *
 * Controller Reset (RESET) - Read/Write. Software uses this bit to reset the
 * controller. This bit is set to zero by the Host/Device Controller when the reset
 * process is complete. Software cannot terminate the reset process early by
 * writing a zero to this register. Host operation mode: When software writes a one
 * to this bit, the Controller resets its internal pipelines, timers, counters,
 * state machines etc. to their initial value. Any transaction currently in
 * progress on USB is immediately terminated. A USB reset is not driven on downstream
 * ports. Software should not set this bit to a one when the HCHalted bit in the
 * USBSTS register is a zero. Attempting to reset an actively running host
 * controller will result in undefined behavior. Device operation mode: When software
 * writes a one to this bit, the Controller resets its internal pipelines, timers,
 * counters, state machines etc. to their initial value. Writing a one to this
 * bit when the device is in the attached state is not recommended, because the
 * effect on an attached host is undefined. In order to ensure that the device is
 * not in an attached state before initiating a device controller reset, all primed
 * endpoints should be flushed and the USBCMD Run/Stop bit should be set to 0.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_RST (1U)         /*!< Bit position for USB_UH2_USBCMD_RST. */
#define BM_USB_UH2_USBCMD_RST (0x00000002U) /*!< Bit mask for USB_UH2_USBCMD_RST. */
#define BS_USB_UH2_USBCMD_RST (1U)         /*!< Bit field size in bits for USB_UH2_USBCMD_RST. */

/*! @brief Read current value of the USB_UH2_USBCMD_RST field. */
#define BR_USB_UH2_USBCMD_RST(x) (HW_USB_UH2_USBCMD(x).B.RST)

/*! @brief Format value for bitfield USB_UH2_USBCMD_RST. */
#define BF_USB_UH2_USBCMD_RST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_RST) & BM_USB_UH2_USBCMD_RST)

/*! @brief Set the RST field to a new value. */
#define BW_USB_UH2_USBCMD_RST(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_RST) | BF_USB_UH2_USBCMD_RST(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field FS_1[3:2] (RW)
 *
 * See description at bit 15
 */
/*@{*/
#define BP_USB_UH2_USBCMD_FS_1 (2U)        /*!< Bit position for USB_UH2_USBCMD_FS_1. */
#define BM_USB_UH2_USBCMD_FS_1 (0x0000000CU) /*!< Bit mask for USB_UH2_USBCMD_FS_1. */
#define BS_USB_UH2_USBCMD_FS_1 (2U)        /*!< Bit field size in bits for USB_UH2_USBCMD_FS_1. */

/*! @brief Read current value of the USB_UH2_USBCMD_FS_1 field. */
#define BR_USB_UH2_USBCMD_FS_1(x) (HW_USB_UH2_USBCMD(x).B.FS_1)

/*! @brief Format value for bitfield USB_UH2_USBCMD_FS_1. */
#define BF_USB_UH2_USBCMD_FS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_FS_1) & BM_USB_UH2_USBCMD_FS_1)

/*! @brief Set the FS_1 field to a new value. */
#define BW_USB_UH2_USBCMD_FS_1(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_FS_1) | BF_USB_UH2_USBCMD_FS_1(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field PSE[4] (RW)
 *
 * Periodic Schedule Enable- Read/Write. Default 0b. This bit controls whether
 * the host controller skips processing the Periodic Schedule. Only the host
 * controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Periodic Schedule
 * - 1 - Use the PERIODICLISTBASE register to access the Periodic Schedule.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_PSE (4U)         /*!< Bit position for USB_UH2_USBCMD_PSE. */
#define BM_USB_UH2_USBCMD_PSE (0x00000010U) /*!< Bit mask for USB_UH2_USBCMD_PSE. */
#define BS_USB_UH2_USBCMD_PSE (1U)         /*!< Bit field size in bits for USB_UH2_USBCMD_PSE. */

/*! @brief Read current value of the USB_UH2_USBCMD_PSE field. */
#define BR_USB_UH2_USBCMD_PSE(x) (HW_USB_UH2_USBCMD(x).B.PSE)

/*! @brief Format value for bitfield USB_UH2_USBCMD_PSE. */
#define BF_USB_UH2_USBCMD_PSE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_PSE) & BM_USB_UH2_USBCMD_PSE)

/*! @brief Set the PSE field to a new value. */
#define BW_USB_UH2_USBCMD_PSE(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_PSE) | BF_USB_UH2_USBCMD_PSE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field ASE[5] (RW)
 *
 * Asynchronous Schedule Enable - Read/Write. Default 0b. This bit controls
 * whether the host controller skips processing the Asynchronous Schedule. Only the
 * host controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Asynchronous Schedule.
 * - 1 - Use the ASYNCLISTADDR register to access the Asynchronous Schedule.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_ASE (5U)         /*!< Bit position for USB_UH2_USBCMD_ASE. */
#define BM_USB_UH2_USBCMD_ASE (0x00000020U) /*!< Bit mask for USB_UH2_USBCMD_ASE. */
#define BS_USB_UH2_USBCMD_ASE (1U)         /*!< Bit field size in bits for USB_UH2_USBCMD_ASE. */

/*! @brief Read current value of the USB_UH2_USBCMD_ASE field. */
#define BR_USB_UH2_USBCMD_ASE(x) (HW_USB_UH2_USBCMD(x).B.ASE)

/*! @brief Format value for bitfield USB_UH2_USBCMD_ASE. */
#define BF_USB_UH2_USBCMD_ASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_ASE) & BM_USB_UH2_USBCMD_ASE)

/*! @brief Set the ASE field to a new value. */
#define BW_USB_UH2_USBCMD_ASE(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_ASE) | BF_USB_UH2_USBCMD_ASE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field IAA[6] (RW)
 *
 * Interrupt on Async Advance Doorbell - Read/Write. This bit is used as a
 * doorbell by software to tell the host controller to issue an interrupt the next
 * time it advances asynchronous schedule. Software must write a 1 to this bit to
 * ring the doorbell. When the host controller has evicted all appropriate cached
 * schedule states, it sets the Interrupt on Async Advance status bit in the
 * USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR
 * register is one, then the host controller will assert an interrupt at the next
 * interrupt threshold. The host controller sets this bit to zero after it has set the
 * Interrupt on Sync Advance status bit in the USBSTS register to one. Software
 * should not write a one to this bit when the asynchronous schedule is inactive.
 * Doing so will yield undefined results. This bit is only used in host mode.
 * Writing a one to this bit when device mode is selected will have undefined
 * results.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_IAA (6U)         /*!< Bit position for USB_UH2_USBCMD_IAA. */
#define BM_USB_UH2_USBCMD_IAA (0x00000040U) /*!< Bit mask for USB_UH2_USBCMD_IAA. */
#define BS_USB_UH2_USBCMD_IAA (1U)         /*!< Bit field size in bits for USB_UH2_USBCMD_IAA. */

/*! @brief Read current value of the USB_UH2_USBCMD_IAA field. */
#define BR_USB_UH2_USBCMD_IAA(x) (HW_USB_UH2_USBCMD(x).B.IAA)

/*! @brief Format value for bitfield USB_UH2_USBCMD_IAA. */
#define BF_USB_UH2_USBCMD_IAA(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_IAA) & BM_USB_UH2_USBCMD_IAA)

/*! @brief Set the IAA field to a new value. */
#define BW_USB_UH2_USBCMD_IAA(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_IAA) | BF_USB_UH2_USBCMD_IAA(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field ASP[9:8] (RW)
 *
 * Asynchronous Schedule Park Mode Count - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this field defaults to
 * 3h and is R/W. Otherwise it defaults to zero and is Read-Only. It contains a
 * count of the number of successive transactions the host controller is allowed
 * to execute from a high-speed queue head on the Asynchronous schedule before
 * continuing traversal of the Asynchronous schedule. Valid values are 1h to 3h.
 * Software must not write a zero to this bit when Park Mode Enable is a one as
 * this will result in undefined behavior. This field is set to 3h in all controller
 * core.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_ASP (8U)         /*!< Bit position for USB_UH2_USBCMD_ASP. */
#define BM_USB_UH2_USBCMD_ASP (0x00000300U) /*!< Bit mask for USB_UH2_USBCMD_ASP. */
#define BS_USB_UH2_USBCMD_ASP (2U)         /*!< Bit field size in bits for USB_UH2_USBCMD_ASP. */

/*! @brief Read current value of the USB_UH2_USBCMD_ASP field. */
#define BR_USB_UH2_USBCMD_ASP(x) (HW_USB_UH2_USBCMD(x).B.ASP)

/*! @brief Format value for bitfield USB_UH2_USBCMD_ASP. */
#define BF_USB_UH2_USBCMD_ASP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_ASP) & BM_USB_UH2_USBCMD_ASP)

/*! @brief Set the ASP field to a new value. */
#define BW_USB_UH2_USBCMD_ASP(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_ASP) | BF_USB_UH2_USBCMD_ASP(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field ASPE[11] (RW)
 *
 * Asynchronous Schedule Park Mode Enable - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this bit defaults to
 * a 1h and is R/W. Otherwise the bit must be a zero and is RO. Software uses
 * this bit to enable or disable Park mode. When this bit is one, Park mode is
 * enabled. When this bit is a zero, Park mode is disabled. ASPE bit reset value: '0b'
 * for OTG controller core, '1b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_ASPE (11U)       /*!< Bit position for USB_UH2_USBCMD_ASPE. */
#define BM_USB_UH2_USBCMD_ASPE (0x00000800U) /*!< Bit mask for USB_UH2_USBCMD_ASPE. */
#define BS_USB_UH2_USBCMD_ASPE (1U)        /*!< Bit field size in bits for USB_UH2_USBCMD_ASPE. */

/*! @brief Read current value of the USB_UH2_USBCMD_ASPE field. */
#define BR_USB_UH2_USBCMD_ASPE(x) (HW_USB_UH2_USBCMD(x).B.ASPE)

/*! @brief Format value for bitfield USB_UH2_USBCMD_ASPE. */
#define BF_USB_UH2_USBCMD_ASPE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_ASPE) & BM_USB_UH2_USBCMD_ASPE)

/*! @brief Set the ASPE field to a new value. */
#define BW_USB_UH2_USBCMD_ASPE(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_ASPE) | BF_USB_UH2_USBCMD_ASPE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field ATDTW[12] (RW)
 *
 * Add dTD TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure proper addition of a new dTD to an active (primed) endpoint's
 * linked list. This bit is set and cleared by software. This bit would also be
 * cleared by hardware when state machine is hazard region for which adding a dTD
 * to a primed endpoint may go unrecognized.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_ATDTW (12U)      /*!< Bit position for USB_UH2_USBCMD_ATDTW. */
#define BM_USB_UH2_USBCMD_ATDTW (0x00001000U) /*!< Bit mask for USB_UH2_USBCMD_ATDTW. */
#define BS_USB_UH2_USBCMD_ATDTW (1U)       /*!< Bit field size in bits for USB_UH2_USBCMD_ATDTW. */

/*! @brief Read current value of the USB_UH2_USBCMD_ATDTW field. */
#define BR_USB_UH2_USBCMD_ATDTW(x) (HW_USB_UH2_USBCMD(x).B.ATDTW)

/*! @brief Format value for bitfield USB_UH2_USBCMD_ATDTW. */
#define BF_USB_UH2_USBCMD_ATDTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_ATDTW) & BM_USB_UH2_USBCMD_ATDTW)

/*! @brief Set the ATDTW field to a new value. */
#define BW_USB_UH2_USBCMD_ATDTW(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_ATDTW) | BF_USB_UH2_USBCMD_ATDTW(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field SUTW[13] (RW)
 *
 * Setup TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure that the setup data payload of 8 bytes is extracted from a QH by
 * the DCD without being corrupted. If the setup lockout mode is off (SLOM bit in
 * USB core register n_USBMODE, see USBMODEUSB Device Mode ) then there is a
 * hazard when new setup data arrives while the DCD is copying the setup data
 * payload from the QH for a previous setup packet. This bit is set and cleared by
 * software. This bit would also be cleared by hardware when a hazard detected.
 */
/*@{*/
#define BP_USB_UH2_USBCMD_SUTW (13U)       /*!< Bit position for USB_UH2_USBCMD_SUTW. */
#define BM_USB_UH2_USBCMD_SUTW (0x00002000U) /*!< Bit mask for USB_UH2_USBCMD_SUTW. */
#define BS_USB_UH2_USBCMD_SUTW (1U)        /*!< Bit field size in bits for USB_UH2_USBCMD_SUTW. */

/*! @brief Read current value of the USB_UH2_USBCMD_SUTW field. */
#define BR_USB_UH2_USBCMD_SUTW(x) (HW_USB_UH2_USBCMD(x).B.SUTW)

/*! @brief Format value for bitfield USB_UH2_USBCMD_SUTW. */
#define BF_USB_UH2_USBCMD_SUTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_SUTW) & BM_USB_UH2_USBCMD_SUTW)

/*! @brief Set the SUTW field to a new value. */
#define BW_USB_UH2_USBCMD_SUTW(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_SUTW) | BF_USB_UH2_USBCMD_SUTW(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field FS_2[15] (RW)
 *
 * See also bits 3-2 Frame List Size - (Read/Write or Read Only). [host mode
 * only] This field is Read/Write only if Programmable Frame List Flag in the
 * HCCPARAMS registers is set to one. This field specifies the size of the frame list
 * that controls which bits in the Frame Index Register should be used for the
 * Frame List Current index. This field is made up from USBCMD bits 15, 3 and 2.
 * Value Meaning
 *
 * Values:
 * - 000 - 1024 elements (4096 bytes) Default value
 * - 001 - 512 elements (2048 bytes)
 */
/*@{*/
#define BP_USB_UH2_USBCMD_FS_2 (15U)       /*!< Bit position for USB_UH2_USBCMD_FS_2. */
#define BM_USB_UH2_USBCMD_FS_2 (0x00008000U) /*!< Bit mask for USB_UH2_USBCMD_FS_2. */
#define BS_USB_UH2_USBCMD_FS_2 (1U)        /*!< Bit field size in bits for USB_UH2_USBCMD_FS_2. */

/*! @brief Read current value of the USB_UH2_USBCMD_FS_2 field. */
#define BR_USB_UH2_USBCMD_FS_2(x) (HW_USB_UH2_USBCMD(x).B.FS_2)

/*! @brief Format value for bitfield USB_UH2_USBCMD_FS_2. */
#define BF_USB_UH2_USBCMD_FS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_FS_2) & BM_USB_UH2_USBCMD_FS_2)

/*! @brief Set the FS_2 field to a new value. */
#define BW_USB_UH2_USBCMD_FS_2(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_FS_2) | BF_USB_UH2_USBCMD_FS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBCMD, field ITC[23:16] (RW)
 *
 * Interrupt Threshold Control -Read/Write. The system software uses this field
 * to set the maximum rate at which the host/device controller will issue
 * interrupts. ITC contains the maximum interrupt interval measured in micro-frames.
 * Valid values are shown below. Value Maximum Interrupt Interval
 *
 * Values:
 * - 0 - Immediate (no threshold)
 * - 1 - 1 micro-frame
 * - 10 - 2 micro-frames
 * - 100 - 4 micro-frames
 * - 1000 - 8 micro-frames
 * - 10000 - 16 micro-frames
 * - 100000 - 32 micro-frames
 * - 1000000 - 64 micro-frames
 */
/*@{*/
#define BP_USB_UH2_USBCMD_ITC (16U)        /*!< Bit position for USB_UH2_USBCMD_ITC. */
#define BM_USB_UH2_USBCMD_ITC (0x00FF0000U) /*!< Bit mask for USB_UH2_USBCMD_ITC. */
#define BS_USB_UH2_USBCMD_ITC (8U)         /*!< Bit field size in bits for USB_UH2_USBCMD_ITC. */

/*! @brief Read current value of the USB_UH2_USBCMD_ITC field. */
#define BR_USB_UH2_USBCMD_ITC(x) (HW_USB_UH2_USBCMD(x).B.ITC)

/*! @brief Format value for bitfield USB_UH2_USBCMD_ITC. */
#define BF_USB_UH2_USBCMD_ITC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBCMD_ITC) & BM_USB_UH2_USBCMD_ITC)

/*! @brief Set the ITC field to a new value. */
#define BW_USB_UH2_USBCMD_ITC(x, v) (HW_USB_UH2_USBCMD_WR(x, (HW_USB_UH2_USBCMD_RD(x) & ~BM_USB_UH2_USBCMD_ITC) | BF_USB_UH2_USBCMD_ITC(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_USBSTS - USB Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_USBSTS - USB Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates various states of the Host/Device Controller and any
 * pending interrupts. This register does not indicate status resulting from a
 * transaction on the serial bus.
 */
typedef union _hw_usb_uh2_usbsts
{
    uint32_t U;
    struct _hw_usb_uh2_usbsts_bitfields
    {
        uint32_t UI : 1;               /*!< [0]  */
        uint32_t UEI : 1;              /*!< [1]  */
        uint32_t PCI : 1;              /*!< [2]  */
        uint32_t FRI : 1;              /*!< [3]  */
        uint32_t SEI : 1;              /*!< [4]  */
        uint32_t AAI : 1;              /*!< [5]  */
        uint32_t URI : 1;              /*!< [6]  */
        uint32_t SRI : 1;              /*!< [7]  */
        uint32_t SLI : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPII : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t HCH : 1;              /*!< [12]  */
        uint32_t RCL : 1;              /*!< [13]  */
        uint32_t PS : 1;               /*!< [14]  */
        uint32_t AS : 1;               /*!< [15]  */
        uint32_t NAKI : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 7;        /*!< [23:17]  */
        uint32_t TI0 : 1;              /*!< [24]  */
        uint32_t TI1 : 1;              /*!< [25]  */
        uint32_t RESERVED3 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh2_usbsts_t;

/*!
 * @name Constants and macros for entire USB_UH2_USBSTS register
 */
/*@{*/
#define HW_USB_UH2_USBSTS_ADDR(x) ((uintptr_t)(x) + 0x544U)

#define HW_USB_UH2_USBSTS(x)     (*(__IO hw_usb_uh2_usbsts_t *) HW_USB_UH2_USBSTS_ADDR(x))
#define HW_USB_UH2_USBSTS_RD(x)  (HW_USB_UH2_USBSTS(x).U)
#define HW_USB_UH2_USBSTS_WR(x, v) (HW_USB_UH2_USBSTS(x).U = (v))
#define HW_USB_UH2_USBSTS_SET(x, v) (HW_USB_UH2_USBSTS_WR(x, HW_USB_UH2_USBSTS_RD(x) |  (v)))
#define HW_USB_UH2_USBSTS_CLR(x, v) (HW_USB_UH2_USBSTS_WR(x, HW_USB_UH2_USBSTS_RD(x) & ~(v)))
#define HW_USB_UH2_USBSTS_TOG(x, v) (HW_USB_UH2_USBSTS_WR(x, HW_USB_UH2_USBSTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_USBSTS bitfields
 */

/*!
 * @name Register USB_UH2_USBSTS, field UI[0] (RW)
 *
 * USB Interrupt (USBINT) - R/WC. This bit is set by the Host/Device Controller
 * when the cause of an interrupt is a completion of a USB transaction where the
 * Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit
 * is also set by the Host/Device Controller when a short packet is detected. A
 * short packet is when the actual number of bytes received was less than the
 * expected number of bytes.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_UI (0U)          /*!< Bit position for USB_UH2_USBSTS_UI. */
#define BM_USB_UH2_USBSTS_UI (0x00000001U) /*!< Bit mask for USB_UH2_USBSTS_UI. */
#define BS_USB_UH2_USBSTS_UI (1U)          /*!< Bit field size in bits for USB_UH2_USBSTS_UI. */

/*! @brief Read current value of the USB_UH2_USBSTS_UI field. */
#define BR_USB_UH2_USBSTS_UI(x) (HW_USB_UH2_USBSTS(x).B.UI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_UI. */
#define BF_USB_UH2_USBSTS_UI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_UI) & BM_USB_UH2_USBSTS_UI)

/*! @brief Set the UI field to a new value. */
#define BW_USB_UH2_USBSTS_UI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_UI) | BF_USB_UH2_USBSTS_UI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field UEI[1] (RW)
 *
 * USB Error Interrupt (USBERRINT) - R/WC. When completion of a USB transaction
 * results in an error condition, this bit is set by the Host/Device Controller.
 * This bit is set along with the USBINT bit, if the TD on which the error
 * interrupt occurred also had its interrupt on complete (IOC) bit set. The device
 * controller detects resume signaling only.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_UEI (1U)         /*!< Bit position for USB_UH2_USBSTS_UEI. */
#define BM_USB_UH2_USBSTS_UEI (0x00000002U) /*!< Bit mask for USB_UH2_USBSTS_UEI. */
#define BS_USB_UH2_USBSTS_UEI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_UEI. */

/*! @brief Read current value of the USB_UH2_USBSTS_UEI field. */
#define BR_USB_UH2_USBSTS_UEI(x) (HW_USB_UH2_USBSTS(x).B.UEI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_UEI. */
#define BF_USB_UH2_USBSTS_UEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_UEI) & BM_USB_UH2_USBSTS_UEI)

/*! @brief Set the UEI field to a new value. */
#define BW_USB_UH2_USBSTS_UEI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_UEI) | BF_USB_UH2_USBSTS_UEI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field PCI[2] (RW)
 *
 * Port Change Detect - R/WC. The Host Controller sets this bit to a one when on
 * any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the
 * Force Port Resume bit is set as the result of a J-K transition on the
 * suspended port. The Device Controller sets this bit to a one when the port controller
 * enters the full or high-speed operational state. When the port controller
 * exits the full or high-speed operation states due to Reset or Suspend events, the
 * notification mechanisms are the USB Reset Received bit and the DCSuspend bits
 * respectively.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_PCI (2U)         /*!< Bit position for USB_UH2_USBSTS_PCI. */
#define BM_USB_UH2_USBSTS_PCI (0x00000004U) /*!< Bit mask for USB_UH2_USBSTS_PCI. */
#define BS_USB_UH2_USBSTS_PCI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_PCI. */

/*! @brief Read current value of the USB_UH2_USBSTS_PCI field. */
#define BR_USB_UH2_USBSTS_PCI(x) (HW_USB_UH2_USBSTS(x).B.PCI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_PCI. */
#define BF_USB_UH2_USBSTS_PCI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_PCI) & BM_USB_UH2_USBSTS_PCI)

/*! @brief Set the PCI field to a new value. */
#define BW_USB_UH2_USBSTS_PCI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_PCI) | BF_USB_UH2_USBSTS_PCI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field FRI[3] (RW)
 *
 * Frame List Rollover - R/WC. The Host Controller sets this bit to a one when
 * the Frame List Index rolls over from its maximum value to zero. The exact value
 * at which the rollover occurs depends on the frame list size. For example. If
 * the frame list size (as programmed in the Frame List Size field of the
 * USB_n_USBCMD register) is 1024, the Frame Index Register rolls over every time
 * FRINDEX [13] toggles. Similarly, if the size is 512, the Host Controller sets this
 * bit to a one every time FHINDEX [12] toggles. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_FRI (3U)         /*!< Bit position for USB_UH2_USBSTS_FRI. */
#define BM_USB_UH2_USBSTS_FRI (0x00000008U) /*!< Bit mask for USB_UH2_USBSTS_FRI. */
#define BS_USB_UH2_USBSTS_FRI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_FRI. */

/*! @brief Read current value of the USB_UH2_USBSTS_FRI field. */
#define BR_USB_UH2_USBSTS_FRI(x) (HW_USB_UH2_USBSTS(x).B.FRI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_FRI. */
#define BF_USB_UH2_USBSTS_FRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_FRI) & BM_USB_UH2_USBSTS_FRI)

/*! @brief Set the FRI field to a new value. */
#define BW_USB_UH2_USBSTS_FRI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_FRI) | BF_USB_UH2_USBSTS_FRI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field SEI[4] (RW)
 *
 * System Error- R/WC. This bit is will be set to '1b' when an Error response is
 * seen to a read on the system interface.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_SEI (4U)         /*!< Bit position for USB_UH2_USBSTS_SEI. */
#define BM_USB_UH2_USBSTS_SEI (0x00000010U) /*!< Bit mask for USB_UH2_USBSTS_SEI. */
#define BS_USB_UH2_USBSTS_SEI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_SEI. */

/*! @brief Read current value of the USB_UH2_USBSTS_SEI field. */
#define BR_USB_UH2_USBSTS_SEI(x) (HW_USB_UH2_USBSTS(x).B.SEI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_SEI. */
#define BF_USB_UH2_USBSTS_SEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_SEI) & BM_USB_UH2_USBSTS_SEI)

/*! @brief Set the SEI field to a new value. */
#define BW_USB_UH2_USBSTS_SEI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_SEI) | BF_USB_UH2_USBSTS_SEI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field AAI[5] (RW)
 *
 * Interrupt on Async Advance - R/WC. System software can force the host
 * controller to issue an interrupt the next time the host controller advances the
 * asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell
 * bit in the n_USBCMD register. This status bit indicates the assertion of that
 * interrupt source. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_AAI (5U)         /*!< Bit position for USB_UH2_USBSTS_AAI. */
#define BM_USB_UH2_USBSTS_AAI (0x00000020U) /*!< Bit mask for USB_UH2_USBSTS_AAI. */
#define BS_USB_UH2_USBSTS_AAI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_AAI. */

/*! @brief Read current value of the USB_UH2_USBSTS_AAI field. */
#define BR_USB_UH2_USBSTS_AAI(x) (HW_USB_UH2_USBSTS(x).B.AAI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_AAI. */
#define BF_USB_UH2_USBSTS_AAI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_AAI) & BM_USB_UH2_USBSTS_AAI)

/*! @brief Set the AAI field to a new value. */
#define BW_USB_UH2_USBSTS_AAI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_AAI) | BF_USB_UH2_USBSTS_AAI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field URI[6] (RW)
 *
 * USB Reset Received - R/WC. When the device controller detects a USB Reset and
 * enters the default state, this bit will be set to a one. Software can write a
 * 1 to this bit to clear the USB Reset Received status bit. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_URI (6U)         /*!< Bit position for USB_UH2_USBSTS_URI. */
#define BM_USB_UH2_USBSTS_URI (0x00000040U) /*!< Bit mask for USB_UH2_USBSTS_URI. */
#define BS_USB_UH2_USBSTS_URI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_URI. */

/*! @brief Read current value of the USB_UH2_USBSTS_URI field. */
#define BR_USB_UH2_USBSTS_URI(x) (HW_USB_UH2_USBSTS(x).B.URI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_URI. */
#define BF_USB_UH2_USBSTS_URI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_URI) & BM_USB_UH2_USBSTS_URI)

/*! @brief Set the URI field to a new value. */
#define BW_USB_UH2_USBSTS_URI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_URI) | BF_USB_UH2_USBSTS_URI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field SRI[7] (RW)
 *
 * SOF Received - R/WC. When the device controller detects a Start Of (micro)
 * Frame, this bit will be set to a one. When a SOF is extremely late, the device
 * controller will automatically set this bit to indicate that an SOF was
 * expected. Therefore, this bit will be set roughly every 1ms in device FS mode and
 * every 125ms in HS mode and will be synchronized to the actual SOF that is
 * received. Because the device controller is initialized to FS before connect, this bit
 * will be set at an interval of 1ms during the prelude to connect and chirp. In
 * host mode, this bit will be set every 125us and can be used by host controller
 * driver as a time base. Software writes a 1 to this bit to clear it.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_SRI (7U)         /*!< Bit position for USB_UH2_USBSTS_SRI. */
#define BM_USB_UH2_USBSTS_SRI (0x00000080U) /*!< Bit mask for USB_UH2_USBSTS_SRI. */
#define BS_USB_UH2_USBSTS_SRI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_SRI. */

/*! @brief Read current value of the USB_UH2_USBSTS_SRI field. */
#define BR_USB_UH2_USBSTS_SRI(x) (HW_USB_UH2_USBSTS(x).B.SRI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_SRI. */
#define BF_USB_UH2_USBSTS_SRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_SRI) & BM_USB_UH2_USBSTS_SRI)

/*! @brief Set the SRI field to a new value. */
#define BW_USB_UH2_USBSTS_SRI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_SRI) | BF_USB_UH2_USBSTS_SRI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field SLI[8] (RW)
 *
 * DCSuspend - R/WC. When a controller enters a suspend state from an active
 * state, this bit will be set to a one. The device controller clears the bit upon
 * exiting from a suspend state. Only used in device operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_SLI (8U)         /*!< Bit position for USB_UH2_USBSTS_SLI. */
#define BM_USB_UH2_USBSTS_SLI (0x00000100U) /*!< Bit mask for USB_UH2_USBSTS_SLI. */
#define BS_USB_UH2_USBSTS_SLI (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_SLI. */

/*! @brief Read current value of the USB_UH2_USBSTS_SLI field. */
#define BR_USB_UH2_USBSTS_SLI(x) (HW_USB_UH2_USBSTS(x).B.SLI)

/*! @brief Format value for bitfield USB_UH2_USBSTS_SLI. */
#define BF_USB_UH2_USBSTS_SLI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_SLI) & BM_USB_UH2_USBSTS_SLI)

/*! @brief Set the SLI field to a new value. */
#define BW_USB_UH2_USBSTS_SLI(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_SLI) | BF_USB_UH2_USBSTS_SLI(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field ULPII[10] (RW)
 *
 * ULPI Interrupt - R/WC. This bit will be set '1b' by hardware when there is an
 * event completion in ULPI viewport. This bit is usable only if the controller
 * support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_ULPII (10U)      /*!< Bit position for USB_UH2_USBSTS_ULPII. */
#define BM_USB_UH2_USBSTS_ULPII (0x00000400U) /*!< Bit mask for USB_UH2_USBSTS_ULPII. */
#define BS_USB_UH2_USBSTS_ULPII (1U)       /*!< Bit field size in bits for USB_UH2_USBSTS_ULPII. */

/*! @brief Read current value of the USB_UH2_USBSTS_ULPII field. */
#define BR_USB_UH2_USBSTS_ULPII(x) (HW_USB_UH2_USBSTS(x).B.ULPII)

/*! @brief Format value for bitfield USB_UH2_USBSTS_ULPII. */
#define BF_USB_UH2_USBSTS_ULPII(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_ULPII) & BM_USB_UH2_USBSTS_ULPII)

/*! @brief Set the ULPII field to a new value. */
#define BW_USB_UH2_USBSTS_ULPII(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_ULPII) | BF_USB_UH2_USBSTS_ULPII(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field HCH[12] (RW)
 *
 * HCHaIted - Read Only. This bit is a zero whenever the Run/Stop bit is a one.
 * The Controller sets this bit to one after it has stopped executing because of
 * the Run/Stop bit being set to 0, either by software or by the Controller
 * hardware (for example, an internal error). Only used in the host operation mode.
 * Default value is '0b' for OTG core, and '1b' for Host1/Host2/Host3 core. This is
 * because OTG core is not operating as host in default. Please see CM bit in
 * USB_n_USBMODE register. HCH bit reset value: '0b' for OTG controller core, '1b'
 * for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_HCH (12U)        /*!< Bit position for USB_UH2_USBSTS_HCH. */
#define BM_USB_UH2_USBSTS_HCH (0x00001000U) /*!< Bit mask for USB_UH2_USBSTS_HCH. */
#define BS_USB_UH2_USBSTS_HCH (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_HCH. */

/*! @brief Read current value of the USB_UH2_USBSTS_HCH field. */
#define BR_USB_UH2_USBSTS_HCH(x) (HW_USB_UH2_USBSTS(x).B.HCH)

/*! @brief Format value for bitfield USB_UH2_USBSTS_HCH. */
#define BF_USB_UH2_USBSTS_HCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_HCH) & BM_USB_UH2_USBSTS_HCH)

/*! @brief Set the HCH field to a new value. */
#define BW_USB_UH2_USBSTS_HCH(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_HCH) | BF_USB_UH2_USBSTS_HCH(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field RCL[13] (RW)
 *
 * Reclamation - Read Only. This is a read-only status bit used to detect an
 * empty asynchronous schedule. Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_RCL (13U)        /*!< Bit position for USB_UH2_USBSTS_RCL. */
#define BM_USB_UH2_USBSTS_RCL (0x00002000U) /*!< Bit mask for USB_UH2_USBSTS_RCL. */
#define BS_USB_UH2_USBSTS_RCL (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_RCL. */

/*! @brief Read current value of the USB_UH2_USBSTS_RCL field. */
#define BR_USB_UH2_USBSTS_RCL(x) (HW_USB_UH2_USBSTS(x).B.RCL)

/*! @brief Format value for bitfield USB_UH2_USBSTS_RCL. */
#define BF_USB_UH2_USBSTS_RCL(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_RCL) & BM_USB_UH2_USBSTS_RCL)

/*! @brief Set the RCL field to a new value. */
#define BW_USB_UH2_USBSTS_RCL(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_RCL) | BF_USB_UH2_USBSTS_RCL(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field PS[14] (RW)
 *
 * Periodic Schedule Status - Read Only. This bit reports the current real
 * status of the Periodic Schedule. When set to zero the periodic schedule is
 * disabled, and if set to one the status is enabled. The Host Controller is not required
 * to immediately disable or enable the Periodic Schedule when software
 * transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and
 * the Periodic Schedule Enable bit are the same value, the Periodic Schedule is
 * either enabled (1) or disabled (0). Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_PS (14U)         /*!< Bit position for USB_UH2_USBSTS_PS. */
#define BM_USB_UH2_USBSTS_PS (0x00004000U) /*!< Bit mask for USB_UH2_USBSTS_PS. */
#define BS_USB_UH2_USBSTS_PS (1U)          /*!< Bit field size in bits for USB_UH2_USBSTS_PS. */

/*! @brief Read current value of the USB_UH2_USBSTS_PS field. */
#define BR_USB_UH2_USBSTS_PS(x) (HW_USB_UH2_USBSTS(x).B.PS)

/*! @brief Format value for bitfield USB_UH2_USBSTS_PS. */
#define BF_USB_UH2_USBSTS_PS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_PS) & BM_USB_UH2_USBSTS_PS)

/*! @brief Set the PS field to a new value. */
#define BW_USB_UH2_USBSTS_PS(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_PS) | BF_USB_UH2_USBSTS_PS(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field AS[15] (RW)
 *
 * Asynchronous Schedule Status - Read Only. This bit reports the current real
 * status of the Asynchronous Schedule. When set to zero the asynchronous schedule
 * status is disabled and if set to one the status is enabled. The Host
 * Controller is not required to immediately disable or enable the Asynchronous Schedule
 * when software transitions the Asynchronous Schedule Enable bit in the USBCMD
 * register. When this bit and the Asynchronous Schedule Enable bit are the same
 * value, the Asynchronous Schedule is either enabled (1) or disabled (0). Only
 * used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_AS (15U)         /*!< Bit position for USB_UH2_USBSTS_AS. */
#define BM_USB_UH2_USBSTS_AS (0x00008000U) /*!< Bit mask for USB_UH2_USBSTS_AS. */
#define BS_USB_UH2_USBSTS_AS (1U)          /*!< Bit field size in bits for USB_UH2_USBSTS_AS. */

/*! @brief Read current value of the USB_UH2_USBSTS_AS field. */
#define BR_USB_UH2_USBSTS_AS(x) (HW_USB_UH2_USBSTS(x).B.AS)

/*! @brief Format value for bitfield USB_UH2_USBSTS_AS. */
#define BF_USB_UH2_USBSTS_AS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_AS) & BM_USB_UH2_USBSTS_AS)

/*! @brief Set the AS field to a new value. */
#define BW_USB_UH2_USBSTS_AS(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_AS) | BF_USB_UH2_USBSTS_AS(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field NAKI[16] (RO)
 *
 * NAK Interrupt Bit--RO. This bit is set by hardware when for a particular
 * endpoint both the TX/RX Endpoint NAK bit and corresponding TX/RX Endpoint NAK
 * Enable bit are set. This bit is automatically cleared by hardware when all Enabled
 * TX/RX Endpoint NAK bits are cleared.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_NAKI (16U)       /*!< Bit position for USB_UH2_USBSTS_NAKI. */
#define BM_USB_UH2_USBSTS_NAKI (0x00010000U) /*!< Bit mask for USB_UH2_USBSTS_NAKI. */
#define BS_USB_UH2_USBSTS_NAKI (1U)        /*!< Bit field size in bits for USB_UH2_USBSTS_NAKI. */

/*! @brief Read current value of the USB_UH2_USBSTS_NAKI field. */
#define BR_USB_UH2_USBSTS_NAKI(x) (HW_USB_UH2_USBSTS(x).B.NAKI)
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field TI0[24] (RW)
 *
 * General Purpose Timer Interrupt 0(GPTINT0)--R/WC. This bit is set when the
 * counter in the GPTIMER0CTRL register transitions to zero, writing a one to this
 * bit clears it.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_TI0 (24U)        /*!< Bit position for USB_UH2_USBSTS_TI0. */
#define BM_USB_UH2_USBSTS_TI0 (0x01000000U) /*!< Bit mask for USB_UH2_USBSTS_TI0. */
#define BS_USB_UH2_USBSTS_TI0 (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_TI0. */

/*! @brief Read current value of the USB_UH2_USBSTS_TI0 field. */
#define BR_USB_UH2_USBSTS_TI0(x) (HW_USB_UH2_USBSTS(x).B.TI0)

/*! @brief Format value for bitfield USB_UH2_USBSTS_TI0. */
#define BF_USB_UH2_USBSTS_TI0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_TI0) & BM_USB_UH2_USBSTS_TI0)

/*! @brief Set the TI0 field to a new value. */
#define BW_USB_UH2_USBSTS_TI0(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_TI0) | BF_USB_UH2_USBSTS_TI0(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBSTS, field TI1[25] (RW)
 *
 * General Purpose Timer Interrupt 1(GPTINT1)--R/WC. This bit is set when the
 * counter in the GPTIMER1CTRL register transitions to zero, writing a one to this
 * bit will clear it.
 */
/*@{*/
#define BP_USB_UH2_USBSTS_TI1 (25U)        /*!< Bit position for USB_UH2_USBSTS_TI1. */
#define BM_USB_UH2_USBSTS_TI1 (0x02000000U) /*!< Bit mask for USB_UH2_USBSTS_TI1. */
#define BS_USB_UH2_USBSTS_TI1 (1U)         /*!< Bit field size in bits for USB_UH2_USBSTS_TI1. */

/*! @brief Read current value of the USB_UH2_USBSTS_TI1 field. */
#define BR_USB_UH2_USBSTS_TI1(x) (HW_USB_UH2_USBSTS(x).B.TI1)

/*! @brief Format value for bitfield USB_UH2_USBSTS_TI1. */
#define BF_USB_UH2_USBSTS_TI1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBSTS_TI1) & BM_USB_UH2_USBSTS_TI1)

/*! @brief Set the TI1 field to a new value. */
#define BW_USB_UH2_USBSTS_TI1(x, v) (HW_USB_UH2_USBSTS_WR(x, (HW_USB_UH2_USBSTS_RD(x) & ~BM_USB_UH2_USBSTS_TI1) | BF_USB_UH2_USBSTS_TI1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_USBINTR - Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_USBINTR - Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The interrupts to software are enabled with this register. An interrupt is
 * generated when a bit is set and the corresponding interrupt source is active.
 * The USB Status register (n_USBSTS) still shows interrupt sources even if they
 * are disabled by the n_USBINTR register, allowing polling of interrupt events by
 * the software.
 */
typedef union _hw_usb_uh2_usbintr
{
    uint32_t U;
    struct _hw_usb_uh2_usbintr_bitfields
    {
        uint32_t UE : 1;               /*!< [0]  */
        uint32_t UEE : 1;              /*!< [1]  */
        uint32_t PCE : 1;              /*!< [2]  */
        uint32_t FRE : 1;              /*!< [3]  */
        uint32_t SEE : 1;              /*!< [4]  */
        uint32_t AAE : 1;              /*!< [5]  */
        uint32_t URE : 1;              /*!< [6]  */
        uint32_t SRE : 1;              /*!< [7]  */
        uint32_t SLE : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPIE : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t NAKE : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 1;        /*!< [17]  */
        uint32_t UAIE : 1;             /*!< [18]  */
        uint32_t UPIE : 1;             /*!< [19]  */
        uint32_t RESERVED3 : 4;        /*!< [23:20]  */
        uint32_t TIE0 : 1;             /*!< [24]  */
        uint32_t TIE1 : 1;             /*!< [25]  */
        uint32_t RESERVED4 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh2_usbintr_t;

/*!
 * @name Constants and macros for entire USB_UH2_USBINTR register
 */
/*@{*/
#define HW_USB_UH2_USBINTR_ADDR(x) ((uintptr_t)(x) + 0x548U)

#define HW_USB_UH2_USBINTR(x)    (*(__IO hw_usb_uh2_usbintr_t *) HW_USB_UH2_USBINTR_ADDR(x))
#define HW_USB_UH2_USBINTR_RD(x) (HW_USB_UH2_USBINTR(x).U)
#define HW_USB_UH2_USBINTR_WR(x, v) (HW_USB_UH2_USBINTR(x).U = (v))
#define HW_USB_UH2_USBINTR_SET(x, v) (HW_USB_UH2_USBINTR_WR(x, HW_USB_UH2_USBINTR_RD(x) |  (v)))
#define HW_USB_UH2_USBINTR_CLR(x, v) (HW_USB_UH2_USBINTR_WR(x, HW_USB_UH2_USBINTR_RD(x) & ~(v)))
#define HW_USB_UH2_USBINTR_TOG(x, v) (HW_USB_UH2_USBINTR_WR(x, HW_USB_UH2_USBINTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_USBINTR bitfields
 */

/*!
 * @name Register USB_UH2_USBINTR, field UE[0] (RW)
 *
 * USB Interrupt Enalbe When this bit is one and the UI bit in n_USBSTS register
 * is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_UE (0U)         /*!< Bit position for USB_UH2_USBINTR_UE. */
#define BM_USB_UH2_USBINTR_UE (0x00000001U) /*!< Bit mask for USB_UH2_USBINTR_UE. */
#define BS_USB_UH2_USBINTR_UE (1U)         /*!< Bit field size in bits for USB_UH2_USBINTR_UE. */

/*! @brief Read current value of the USB_UH2_USBINTR_UE field. */
#define BR_USB_UH2_USBINTR_UE(x) (HW_USB_UH2_USBINTR(x).B.UE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_UE. */
#define BF_USB_UH2_USBINTR_UE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_UE) & BM_USB_UH2_USBINTR_UE)

/*! @brief Set the UE field to a new value. */
#define BW_USB_UH2_USBINTR_UE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_UE) | BF_USB_UH2_USBINTR_UE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field UEE[1] (RW)
 *
 * USB Error Interrupt Enable When this bit is one and the UEI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_UEE (1U)        /*!< Bit position for USB_UH2_USBINTR_UEE. */
#define BM_USB_UH2_USBINTR_UEE (0x00000002U) /*!< Bit mask for USB_UH2_USBINTR_UEE. */
#define BS_USB_UH2_USBINTR_UEE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_UEE. */

/*! @brief Read current value of the USB_UH2_USBINTR_UEE field. */
#define BR_USB_UH2_USBINTR_UEE(x) (HW_USB_UH2_USBINTR(x).B.UEE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_UEE. */
#define BF_USB_UH2_USBINTR_UEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_UEE) & BM_USB_UH2_USBINTR_UEE)

/*! @brief Set the UEE field to a new value. */
#define BW_USB_UH2_USBINTR_UEE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_UEE) | BF_USB_UH2_USBINTR_UEE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field PCE[2] (RW)
 *
 * Port Change Detect Interrupt Enable When this bit is one and the PCI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_PCE (2U)        /*!< Bit position for USB_UH2_USBINTR_PCE. */
#define BM_USB_UH2_USBINTR_PCE (0x00000004U) /*!< Bit mask for USB_UH2_USBINTR_PCE. */
#define BS_USB_UH2_USBINTR_PCE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_PCE. */

/*! @brief Read current value of the USB_UH2_USBINTR_PCE field. */
#define BR_USB_UH2_USBINTR_PCE(x) (HW_USB_UH2_USBINTR(x).B.PCE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_PCE. */
#define BF_USB_UH2_USBINTR_PCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_PCE) & BM_USB_UH2_USBINTR_PCE)

/*! @brief Set the PCE field to a new value. */
#define BW_USB_UH2_USBINTR_PCE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_PCE) | BF_USB_UH2_USBINTR_PCE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field FRE[3] (RW)
 *
 * Frame List Rollover Interrupt Enable When this bit is one and the FRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used
 * in host operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_FRE (3U)        /*!< Bit position for USB_UH2_USBINTR_FRE. */
#define BM_USB_UH2_USBINTR_FRE (0x00000008U) /*!< Bit mask for USB_UH2_USBINTR_FRE. */
#define BS_USB_UH2_USBINTR_FRE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_FRE. */

/*! @brief Read current value of the USB_UH2_USBINTR_FRE field. */
#define BR_USB_UH2_USBINTR_FRE(x) (HW_USB_UH2_USBINTR(x).B.FRE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_FRE. */
#define BF_USB_UH2_USBINTR_FRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_FRE) & BM_USB_UH2_USBINTR_FRE)

/*! @brief Set the FRE field to a new value. */
#define BW_USB_UH2_USBINTR_FRE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_FRE) | BF_USB_UH2_USBINTR_FRE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field SEE[4] (RW)
 *
 * System Error Interrupt Enable When this bit is one and the SEI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_SEE (4U)        /*!< Bit position for USB_UH2_USBINTR_SEE. */
#define BM_USB_UH2_USBINTR_SEE (0x00000010U) /*!< Bit mask for USB_UH2_USBINTR_SEE. */
#define BS_USB_UH2_USBINTR_SEE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_SEE. */

/*! @brief Read current value of the USB_UH2_USBINTR_SEE field. */
#define BR_USB_UH2_USBINTR_SEE(x) (HW_USB_UH2_USBINTR(x).B.SEE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_SEE. */
#define BF_USB_UH2_USBINTR_SEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_SEE) & BM_USB_UH2_USBINTR_SEE)

/*! @brief Set the SEE field to a new value. */
#define BW_USB_UH2_USBINTR_SEE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_SEE) | BF_USB_UH2_USBINTR_SEE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field AAE[5] (RW)
 *
 * Async Advance Interrupt Enable When this bit is one and the AAI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_AAE (5U)        /*!< Bit position for USB_UH2_USBINTR_AAE. */
#define BM_USB_UH2_USBINTR_AAE (0x00000020U) /*!< Bit mask for USB_UH2_USBINTR_AAE. */
#define BS_USB_UH2_USBINTR_AAE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_AAE. */

/*! @brief Read current value of the USB_UH2_USBINTR_AAE field. */
#define BR_USB_UH2_USBINTR_AAE(x) (HW_USB_UH2_USBINTR(x).B.AAE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_AAE. */
#define BF_USB_UH2_USBINTR_AAE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_AAE) & BM_USB_UH2_USBINTR_AAE)

/*! @brief Set the AAE field to a new value. */
#define BW_USB_UH2_USBINTR_AAE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_AAE) | BF_USB_UH2_USBINTR_AAE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field URE[6] (RW)
 *
 * USB Reset Interrupt Enable When this bit is one and the URI bit in n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_URE (6U)        /*!< Bit position for USB_UH2_USBINTR_URE. */
#define BM_USB_UH2_USBINTR_URE (0x00000040U) /*!< Bit mask for USB_UH2_USBINTR_URE. */
#define BS_USB_UH2_USBINTR_URE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_URE. */

/*! @brief Read current value of the USB_UH2_USBINTR_URE field. */
#define BR_USB_UH2_USBINTR_URE(x) (HW_USB_UH2_USBINTR(x).B.URE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_URE. */
#define BF_USB_UH2_USBINTR_URE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_URE) & BM_USB_UH2_USBINTR_URE)

/*! @brief Set the URE field to a new value. */
#define BW_USB_UH2_USBINTR_URE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_URE) | BF_USB_UH2_USBINTR_URE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field SRE[7] (RW)
 *
 * SOF Received Interrupt Enable When this bit is one and the SRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_SRE (7U)        /*!< Bit position for USB_UH2_USBINTR_SRE. */
#define BM_USB_UH2_USBINTR_SRE (0x00000080U) /*!< Bit mask for USB_UH2_USBINTR_SRE. */
#define BS_USB_UH2_USBINTR_SRE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_SRE. */

/*! @brief Read current value of the USB_UH2_USBINTR_SRE field. */
#define BR_USB_UH2_USBINTR_SRE(x) (HW_USB_UH2_USBINTR(x).B.SRE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_SRE. */
#define BF_USB_UH2_USBINTR_SRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_SRE) & BM_USB_UH2_USBINTR_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_USB_UH2_USBINTR_SRE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_SRE) | BF_USB_UH2_USBINTR_SRE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field SLE[8] (RW)
 *
 * Sleep Interrupt Enable When this bit is one and the SLI bit in n_n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_SLE (8U)        /*!< Bit position for USB_UH2_USBINTR_SLE. */
#define BM_USB_UH2_USBINTR_SLE (0x00000100U) /*!< Bit mask for USB_UH2_USBINTR_SLE. */
#define BS_USB_UH2_USBINTR_SLE (1U)        /*!< Bit field size in bits for USB_UH2_USBINTR_SLE. */

/*! @brief Read current value of the USB_UH2_USBINTR_SLE field. */
#define BR_USB_UH2_USBINTR_SLE(x) (HW_USB_UH2_USBINTR(x).B.SLE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_SLE. */
#define BF_USB_UH2_USBINTR_SLE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_SLE) & BM_USB_UH2_USBINTR_SLE)

/*! @brief Set the SLE field to a new value. */
#define BW_USB_UH2_USBINTR_SLE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_SLE) | BF_USB_UH2_USBINTR_SLE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field ULPIE[10] (RW)
 *
 * ULPI Interrupt Enable When this bit is one and the UPLII bit in n_USBSTS
 * register is a one the controller will issue an interrupt. This bit is usable only
 * if the controller support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_ULPIE (10U)     /*!< Bit position for USB_UH2_USBINTR_ULPIE. */
#define BM_USB_UH2_USBINTR_ULPIE (0x00000400U) /*!< Bit mask for USB_UH2_USBINTR_ULPIE. */
#define BS_USB_UH2_USBINTR_ULPIE (1U)      /*!< Bit field size in bits for USB_UH2_USBINTR_ULPIE. */

/*! @brief Read current value of the USB_UH2_USBINTR_ULPIE field. */
#define BR_USB_UH2_USBINTR_ULPIE(x) (HW_USB_UH2_USBINTR(x).B.ULPIE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_ULPIE. */
#define BF_USB_UH2_USBINTR_ULPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_ULPIE) & BM_USB_UH2_USBINTR_ULPIE)

/*! @brief Set the ULPIE field to a new value. */
#define BW_USB_UH2_USBINTR_ULPIE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_ULPIE) | BF_USB_UH2_USBINTR_ULPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field NAKE[16] (RW)
 *
 * NAK Interrupt Enable When this bit is one and the NAKI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_NAKE (16U)      /*!< Bit position for USB_UH2_USBINTR_NAKE. */
#define BM_USB_UH2_USBINTR_NAKE (0x00010000U) /*!< Bit mask for USB_UH2_USBINTR_NAKE. */
#define BS_USB_UH2_USBINTR_NAKE (1U)       /*!< Bit field size in bits for USB_UH2_USBINTR_NAKE. */

/*! @brief Read current value of the USB_UH2_USBINTR_NAKE field. */
#define BR_USB_UH2_USBINTR_NAKE(x) (HW_USB_UH2_USBINTR(x).B.NAKE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_NAKE. */
#define BF_USB_UH2_USBINTR_NAKE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_NAKE) & BM_USB_UH2_USBINTR_NAKE)

/*! @brief Set the NAKE field to a new value. */
#define BW_USB_UH2_USBINTR_NAKE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_NAKE) | BF_USB_UH2_USBINTR_NAKE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field UAIE[18] (RW)
 *
 * USB Host Asynchronous Interrupt Enable When this bit is one, and the UAI bit
 * in the n_USBSTS register is one, host controller will issue an interrupt at
 * the next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_UAIE (18U)      /*!< Bit position for USB_UH2_USBINTR_UAIE. */
#define BM_USB_UH2_USBINTR_UAIE (0x00040000U) /*!< Bit mask for USB_UH2_USBINTR_UAIE. */
#define BS_USB_UH2_USBINTR_UAIE (1U)       /*!< Bit field size in bits for USB_UH2_USBINTR_UAIE. */

/*! @brief Read current value of the USB_UH2_USBINTR_UAIE field. */
#define BR_USB_UH2_USBINTR_UAIE(x) (HW_USB_UH2_USBINTR(x).B.UAIE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_UAIE. */
#define BF_USB_UH2_USBINTR_UAIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_UAIE) & BM_USB_UH2_USBINTR_UAIE)

/*! @brief Set the UAIE field to a new value. */
#define BW_USB_UH2_USBINTR_UAIE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_UAIE) | BF_USB_UH2_USBINTR_UAIE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field UPIE[19] (RW)
 *
 * USB Host Periodic Interrupt Enable When this bit is one, and the UPI bit in
 * the n_USBSTS register is one, host controller will issue an interrupt at the
 * next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_UPIE (19U)      /*!< Bit position for USB_UH2_USBINTR_UPIE. */
#define BM_USB_UH2_USBINTR_UPIE (0x00080000U) /*!< Bit mask for USB_UH2_USBINTR_UPIE. */
#define BS_USB_UH2_USBINTR_UPIE (1U)       /*!< Bit field size in bits for USB_UH2_USBINTR_UPIE. */

/*! @brief Read current value of the USB_UH2_USBINTR_UPIE field. */
#define BR_USB_UH2_USBINTR_UPIE(x) (HW_USB_UH2_USBINTR(x).B.UPIE)

/*! @brief Format value for bitfield USB_UH2_USBINTR_UPIE. */
#define BF_USB_UH2_USBINTR_UPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_UPIE) & BM_USB_UH2_USBINTR_UPIE)

/*! @brief Set the UPIE field to a new value. */
#define BW_USB_UH2_USBINTR_UPIE(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_UPIE) | BF_USB_UH2_USBINTR_UPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field TIE0[24] (RW)
 *
 * General Purpose Timer #0 Interrupt Enable When this bit is one and the TI0
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_TIE0 (24U)      /*!< Bit position for USB_UH2_USBINTR_TIE0. */
#define BM_USB_UH2_USBINTR_TIE0 (0x01000000U) /*!< Bit mask for USB_UH2_USBINTR_TIE0. */
#define BS_USB_UH2_USBINTR_TIE0 (1U)       /*!< Bit field size in bits for USB_UH2_USBINTR_TIE0. */

/*! @brief Read current value of the USB_UH2_USBINTR_TIE0 field. */
#define BR_USB_UH2_USBINTR_TIE0(x) (HW_USB_UH2_USBINTR(x).B.TIE0)

/*! @brief Format value for bitfield USB_UH2_USBINTR_TIE0. */
#define BF_USB_UH2_USBINTR_TIE0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_TIE0) & BM_USB_UH2_USBINTR_TIE0)

/*! @brief Set the TIE0 field to a new value. */
#define BW_USB_UH2_USBINTR_TIE0(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_TIE0) | BF_USB_UH2_USBINTR_TIE0(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBINTR, field TIE1[25] (RW)
 *
 * General Purpose Timer #1 Interrupt Enable When this bit is one and the TI1
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH2_USBINTR_TIE1 (25U)      /*!< Bit position for USB_UH2_USBINTR_TIE1. */
#define BM_USB_UH2_USBINTR_TIE1 (0x02000000U) /*!< Bit mask for USB_UH2_USBINTR_TIE1. */
#define BS_USB_UH2_USBINTR_TIE1 (1U)       /*!< Bit field size in bits for USB_UH2_USBINTR_TIE1. */

/*! @brief Read current value of the USB_UH2_USBINTR_TIE1 field. */
#define BR_USB_UH2_USBINTR_TIE1(x) (HW_USB_UH2_USBINTR(x).B.TIE1)

/*! @brief Format value for bitfield USB_UH2_USBINTR_TIE1. */
#define BF_USB_UH2_USBINTR_TIE1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBINTR_TIE1) & BM_USB_UH2_USBINTR_TIE1)

/*! @brief Set the TIE1 field to a new value. */
#define BW_USB_UH2_USBINTR_TIE1(x, v) (HW_USB_UH2_USBINTR_WR(x, (HW_USB_UH2_USBINTR_RD(x) & ~BM_USB_UH2_USBINTR_TIE1) | BF_USB_UH2_USBINTR_TIE1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_FRINDEX - USB Frame Index
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_FRINDEX - USB Frame Index (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the host controller to index the periodic frame
 * list. The register updates every 125 microseconds (once each micro-frame). Bits
 * [N: 3] are used to select a particular entry in the Periodic Frame List during
 * periodic schedule execution. The number of bits used for the index depends on
 * the size of the frame list as set by system software in the Frame List Size
 * field in the n_USBCMD register. This register must be written as a DWord. Byte
 * writes produce undefined results. This register cannot be written unless the
 * Host Controller is in the 'Halted' state as indicated by the HCHalted bit. A
 * write to this register while the Run/Stop hit is set to a one produces undefined
 * results. Writes to this register also affect the SOF value. In device mode this
 * register is read only and, the device controller updates the FRINDEX [13:3]
 * register from the frame number indicated by the SOF marker. Whenever a SOF is
 * received by the USB bus, FRINDEX [13:3] will be checked against the SOF marker.
 * If FRINDEX [13:3] is different from the SOF marker, FRINDEX [13:3] will be
 * set to the SOF value and FRINDEX [2:0] will be set to zero (that is, SOF for 1
 * ms frame). If FRINDEX [13:3] is equal to the SOF value, FRINDEX [2:0] will be
 * increment (that is, SOF for 125 us micro-frame.).
 */
typedef union _hw_usb_uh2_frindex
{
    uint32_t U;
    struct _hw_usb_uh2_frindex_bitfields
    {
        uint32_t FRINDEX : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_usb_uh2_frindex_t;

/*!
 * @name Constants and macros for entire USB_UH2_FRINDEX register
 */
/*@{*/
#define HW_USB_UH2_FRINDEX_ADDR(x) ((uintptr_t)(x) + 0x54CU)

#define HW_USB_UH2_FRINDEX(x)    (*(__IO hw_usb_uh2_frindex_t *) HW_USB_UH2_FRINDEX_ADDR(x))
#define HW_USB_UH2_FRINDEX_RD(x) (HW_USB_UH2_FRINDEX(x).U)
#define HW_USB_UH2_FRINDEX_WR(x, v) (HW_USB_UH2_FRINDEX(x).U = (v))
#define HW_USB_UH2_FRINDEX_SET(x, v) (HW_USB_UH2_FRINDEX_WR(x, HW_USB_UH2_FRINDEX_RD(x) |  (v)))
#define HW_USB_UH2_FRINDEX_CLR(x, v) (HW_USB_UH2_FRINDEX_WR(x, HW_USB_UH2_FRINDEX_RD(x) & ~(v)))
#define HW_USB_UH2_FRINDEX_TOG(x, v) (HW_USB_UH2_FRINDEX_WR(x, HW_USB_UH2_FRINDEX_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_FRINDEX bitfields
 */

/*!
 * @name Register USB_UH2_FRINDEX, field FRINDEX[13:0] (RW)
 *
 * Frame Index. The value, in this register, increments at the end of each time
 * frame (micro-frame). Bits [N: 3] are used for the Frame List current index.
 * This means that each location of the frame list is accessed 8 times (frames or
 * micro-frames) before moving to the next index. The following illustrates values
 * of N based on the value of the Frame List Size field in the USBCMD register,
 * when used in host mode. USBCMD [Frame List Size] Number Elements N In device
 * mode the value is the current frame number of the last frame transmitted. It is
 * not used as an index. In either mode bits 2:0 indicate the current microframe.
 *
 * Values:
 * - 000 - (1024) 12
 * - 001 - (512) 11
 * - 010 - (256) 10
 * - 011 - (128) 9
 * - 100 - (64) 8
 * - 101 - (32) 7
 * - 110 - (16) 6
 * - 111 - (8) 5
 */
/*@{*/
#define BP_USB_UH2_FRINDEX_FRINDEX (0U)    /*!< Bit position for USB_UH2_FRINDEX_FRINDEX. */
#define BM_USB_UH2_FRINDEX_FRINDEX (0x00003FFFU) /*!< Bit mask for USB_UH2_FRINDEX_FRINDEX. */
#define BS_USB_UH2_FRINDEX_FRINDEX (14U)   /*!< Bit field size in bits for USB_UH2_FRINDEX_FRINDEX. */

/*! @brief Read current value of the USB_UH2_FRINDEX_FRINDEX field. */
#define BR_USB_UH2_FRINDEX_FRINDEX(x) (HW_USB_UH2_FRINDEX(x).B.FRINDEX)

/*! @brief Format value for bitfield USB_UH2_FRINDEX_FRINDEX. */
#define BF_USB_UH2_FRINDEX_FRINDEX(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_FRINDEX_FRINDEX) & BM_USB_UH2_FRINDEX_FRINDEX)

/*! @brief Set the FRINDEX field to a new value. */
#define BW_USB_UH2_FRINDEX_FRINDEX(x, v) (HW_USB_UH2_FRINDEX_WR(x, (HW_USB_UH2_FRINDEX_RD(x) & ~BM_USB_UH2_FRINDEX_FRINDEX) | BF_USB_UH2_FRINDEX_FRINDEX(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_PERIODICLISTBASE - Frame List Base Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_PERIODICLISTBASE - Frame List Base Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the beginning address of
 * the Periodic Frame List in the system memory. HCD loads this register prior to
 * starting the schedule execution by the Host Controller. The memory structure
 * referenced by this physical memory pointer is assumed to be 4-Kbyte aligned.
 * The contents of this register are combined with the Frame Index Register
 * (USB_n_FRINDEX) to enable the Host Controller to step through the Periodic Frame List
 * in sequence.
 */
typedef union _hw_usb_uh2_periodiclistbase
{
    uint32_t U;
    struct _hw_usb_uh2_periodiclistbase_bitfields
    {
        uint32_t RESERVED0 : 12;       /*!< [11:0]  */
        uint32_t BASEADR : 20;         /*!< [31:12]  */
    } B;
} hw_usb_uh2_periodiclistbase_t;

/*!
 * @name Constants and macros for entire USB_UH2_PERIODICLISTBASE register
 */
/*@{*/
#define HW_USB_UH2_PERIODICLISTBASE_ADDR(x) ((uintptr_t)(x) + 0x554U)

#define HW_USB_UH2_PERIODICLISTBASE(x) (*(__IO hw_usb_uh2_periodiclistbase_t *) HW_USB_UH2_PERIODICLISTBASE_ADDR(x))
#define HW_USB_UH2_PERIODICLISTBASE_RD(x) (HW_USB_UH2_PERIODICLISTBASE(x).U)
#define HW_USB_UH2_PERIODICLISTBASE_WR(x, v) (HW_USB_UH2_PERIODICLISTBASE(x).U = (v))
#define HW_USB_UH2_PERIODICLISTBASE_SET(x, v) (HW_USB_UH2_PERIODICLISTBASE_WR(x, HW_USB_UH2_PERIODICLISTBASE_RD(x) |  (v)))
#define HW_USB_UH2_PERIODICLISTBASE_CLR(x, v) (HW_USB_UH2_PERIODICLISTBASE_WR(x, HW_USB_UH2_PERIODICLISTBASE_RD(x) & ~(v)))
#define HW_USB_UH2_PERIODICLISTBASE_TOG(x, v) (HW_USB_UH2_PERIODICLISTBASE_WR(x, HW_USB_UH2_PERIODICLISTBASE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_PERIODICLISTBASE bitfields
 */

/*!
 * @name Register USB_UH2_PERIODICLISTBASE, field BASEADR[31:12] (RW)
 *
 * Base Address (Low). These bits correspond to memory address signals [31:12],
 * respectively. Only used by the host controller.
 */
/*@{*/
#define BP_USB_UH2_PERIODICLISTBASE_BASEADR (12U) /*!< Bit position for USB_UH2_PERIODICLISTBASE_BASEADR. */
#define BM_USB_UH2_PERIODICLISTBASE_BASEADR (0xFFFFF000U) /*!< Bit mask for USB_UH2_PERIODICLISTBASE_BASEADR. */
#define BS_USB_UH2_PERIODICLISTBASE_BASEADR (20U) /*!< Bit field size in bits for USB_UH2_PERIODICLISTBASE_BASEADR. */

/*! @brief Read current value of the USB_UH2_PERIODICLISTBASE_BASEADR field. */
#define BR_USB_UH2_PERIODICLISTBASE_BASEADR(x) (HW_USB_UH2_PERIODICLISTBASE(x).B.BASEADR)

/*! @brief Format value for bitfield USB_UH2_PERIODICLISTBASE_BASEADR. */
#define BF_USB_UH2_PERIODICLISTBASE_BASEADR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PERIODICLISTBASE_BASEADR) & BM_USB_UH2_PERIODICLISTBASE_BASEADR)

/*! @brief Set the BASEADR field to a new value. */
#define BW_USB_UH2_PERIODICLISTBASE_BASEADR(x, v) (HW_USB_UH2_PERIODICLISTBASE_WR(x, (HW_USB_UH2_PERIODICLISTBASE_RD(x) & ~BM_USB_UH2_PERIODICLISTBASE_BASEADR) | BF_USB_UH2_PERIODICLISTBASE_BASEADR(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_ASYNCLISTADDR - Next Asynch. Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_ASYNCLISTADDR - Next Asynch. Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the address of the next
 * asynchronous queue head to be executed by the host. Bits [4:0] of this register
 * cannot be modified by the system software and will always return a zero when
 * read.
 */
typedef union _hw_usb_uh2_asynclistaddr
{
    uint32_t U;
    struct _hw_usb_uh2_asynclistaddr_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t ASYBASE : 27;         /*!< [31:5]  */
    } B;
} hw_usb_uh2_asynclistaddr_t;

/*!
 * @name Constants and macros for entire USB_UH2_ASYNCLISTADDR register
 */
/*@{*/
#define HW_USB_UH2_ASYNCLISTADDR_ADDR(x) ((uintptr_t)(x) + 0x558U)

#define HW_USB_UH2_ASYNCLISTADDR(x) (*(__IO hw_usb_uh2_asynclistaddr_t *) HW_USB_UH2_ASYNCLISTADDR_ADDR(x))
#define HW_USB_UH2_ASYNCLISTADDR_RD(x) (HW_USB_UH2_ASYNCLISTADDR(x).U)
#define HW_USB_UH2_ASYNCLISTADDR_WR(x, v) (HW_USB_UH2_ASYNCLISTADDR(x).U = (v))
#define HW_USB_UH2_ASYNCLISTADDR_SET(x, v) (HW_USB_UH2_ASYNCLISTADDR_WR(x, HW_USB_UH2_ASYNCLISTADDR_RD(x) |  (v)))
#define HW_USB_UH2_ASYNCLISTADDR_CLR(x, v) (HW_USB_UH2_ASYNCLISTADDR_WR(x, HW_USB_UH2_ASYNCLISTADDR_RD(x) & ~(v)))
#define HW_USB_UH2_ASYNCLISTADDR_TOG(x, v) (HW_USB_UH2_ASYNCLISTADDR_WR(x, HW_USB_UH2_ASYNCLISTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_ASYNCLISTADDR bitfields
 */

/*!
 * @name Register USB_UH2_ASYNCLISTADDR, field ASYBASE[31:5] (RW)
 *
 * Link Pointer Low (LPL). These bits correspond to memory address signals
 * [31:5], respectively. This field may only reference a Queue Head (QH). Only used by
 * the host controller.
 */
/*@{*/
#define BP_USB_UH2_ASYNCLISTADDR_ASYBASE (5U) /*!< Bit position for USB_UH2_ASYNCLISTADDR_ASYBASE. */
#define BM_USB_UH2_ASYNCLISTADDR_ASYBASE (0xFFFFFFE0U) /*!< Bit mask for USB_UH2_ASYNCLISTADDR_ASYBASE. */
#define BS_USB_UH2_ASYNCLISTADDR_ASYBASE (27U) /*!< Bit field size in bits for USB_UH2_ASYNCLISTADDR_ASYBASE. */

/*! @brief Read current value of the USB_UH2_ASYNCLISTADDR_ASYBASE field. */
#define BR_USB_UH2_ASYNCLISTADDR_ASYBASE(x) (HW_USB_UH2_ASYNCLISTADDR(x).B.ASYBASE)

/*! @brief Format value for bitfield USB_UH2_ASYNCLISTADDR_ASYBASE. */
#define BF_USB_UH2_ASYNCLISTADDR_ASYBASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_ASYNCLISTADDR_ASYBASE) & BM_USB_UH2_ASYNCLISTADDR_ASYBASE)

/*! @brief Set the ASYBASE field to a new value. */
#define BW_USB_UH2_ASYNCLISTADDR_ASYBASE(x, v) (HW_USB_UH2_ASYNCLISTADDR_WR(x, (HW_USB_UH2_ASYNCLISTADDR_RD(x) & ~BM_USB_UH2_ASYNCLISTADDR_ASYBASE) | BF_USB_UH2_ASYNCLISTADDR_ASYBASE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_BURSTSIZE - Programmable Burst Size
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_BURSTSIZE - Programmable Burst Size (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control the burst size used during data movement on
 * the AHB master interface. This register is ignored if AHBBRST bits in SBUSCFG
 * register is non-zero value.
 */
typedef union _hw_usb_uh2_burstsize
{
    uint32_t U;
    struct _hw_usb_uh2_burstsize_bitfields
    {
        uint32_t RXPBURST : 8;         /*!< [7:0]  */
        uint32_t TXPBURST : 9;         /*!< [16:8]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_usb_uh2_burstsize_t;

/*!
 * @name Constants and macros for entire USB_UH2_BURSTSIZE register
 */
/*@{*/
#define HW_USB_UH2_BURSTSIZE_ADDR(x) ((uintptr_t)(x) + 0x560U)

#define HW_USB_UH2_BURSTSIZE(x)  (*(__IO hw_usb_uh2_burstsize_t *) HW_USB_UH2_BURSTSIZE_ADDR(x))
#define HW_USB_UH2_BURSTSIZE_RD(x) (HW_USB_UH2_BURSTSIZE(x).U)
#define HW_USB_UH2_BURSTSIZE_WR(x, v) (HW_USB_UH2_BURSTSIZE(x).U = (v))
#define HW_USB_UH2_BURSTSIZE_SET(x, v) (HW_USB_UH2_BURSTSIZE_WR(x, HW_USB_UH2_BURSTSIZE_RD(x) |  (v)))
#define HW_USB_UH2_BURSTSIZE_CLR(x, v) (HW_USB_UH2_BURSTSIZE_WR(x, HW_USB_UH2_BURSTSIZE_RD(x) & ~(v)))
#define HW_USB_UH2_BURSTSIZE_TOG(x, v) (HW_USB_UH2_BURSTSIZE_WR(x, HW_USB_UH2_BURSTSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_BURSTSIZE bitfields
 */

/*!
 * @name Register USB_UH2_BURSTSIZE, field RXPBURST[7:0] (RW)
 *
 * Programmable RX Burst Size. Default value is determined by TXBURST bits in
 * n_HWRXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from the USB bus to system memory.
 */
/*@{*/
#define BP_USB_UH2_BURSTSIZE_RXPBURST (0U) /*!< Bit position for USB_UH2_BURSTSIZE_RXPBURST. */
#define BM_USB_UH2_BURSTSIZE_RXPBURST (0x000000FFU) /*!< Bit mask for USB_UH2_BURSTSIZE_RXPBURST. */
#define BS_USB_UH2_BURSTSIZE_RXPBURST (8U) /*!< Bit field size in bits for USB_UH2_BURSTSIZE_RXPBURST. */

/*! @brief Read current value of the USB_UH2_BURSTSIZE_RXPBURST field. */
#define BR_USB_UH2_BURSTSIZE_RXPBURST(x) (HW_USB_UH2_BURSTSIZE(x).B.RXPBURST)

/*! @brief Format value for bitfield USB_UH2_BURSTSIZE_RXPBURST. */
#define BF_USB_UH2_BURSTSIZE_RXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_BURSTSIZE_RXPBURST) & BM_USB_UH2_BURSTSIZE_RXPBURST)

/*! @brief Set the RXPBURST field to a new value. */
#define BW_USB_UH2_BURSTSIZE_RXPBURST(x, v) (HW_USB_UH2_BURSTSIZE_WR(x, (HW_USB_UH2_BURSTSIZE_RD(x) & ~BM_USB_UH2_BURSTSIZE_RXPBURST) | BF_USB_UH2_BURSTSIZE_RXPBURST(v)))
/*@}*/

/*!
 * @name Register USB_UH2_BURSTSIZE, field TXPBURST[16:8] (RW)
 *
 * Programmable TX Burst Size. Default value is determined by TXBURST bits in
 * n_HWTXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from system memory to the USB bus.
 */
/*@{*/
#define BP_USB_UH2_BURSTSIZE_TXPBURST (8U) /*!< Bit position for USB_UH2_BURSTSIZE_TXPBURST. */
#define BM_USB_UH2_BURSTSIZE_TXPBURST (0x0001FF00U) /*!< Bit mask for USB_UH2_BURSTSIZE_TXPBURST. */
#define BS_USB_UH2_BURSTSIZE_TXPBURST (9U) /*!< Bit field size in bits for USB_UH2_BURSTSIZE_TXPBURST. */

/*! @brief Read current value of the USB_UH2_BURSTSIZE_TXPBURST field. */
#define BR_USB_UH2_BURSTSIZE_TXPBURST(x) (HW_USB_UH2_BURSTSIZE(x).B.TXPBURST)

/*! @brief Format value for bitfield USB_UH2_BURSTSIZE_TXPBURST. */
#define BF_USB_UH2_BURSTSIZE_TXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_BURSTSIZE_TXPBURST) & BM_USB_UH2_BURSTSIZE_TXPBURST)

/*! @brief Set the TXPBURST field to a new value. */
#define BW_USB_UH2_BURSTSIZE_TXPBURST(x, v) (HW_USB_UH2_BURSTSIZE_WR(x, (HW_USB_UH2_BURSTSIZE_RD(x) & ~BM_USB_UH2_BURSTSIZE_TXPBURST) | BF_USB_UH2_BURSTSIZE_TXPBURST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_TXFILLTUNING - TX FIFO Fill Tuning
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_TXFILLTUNING - TX FIFO Fill Tuning (RW)
 *
 * Reset value: 0x00000808U
 *
 * The fields in this register control performance tuning associated with how
 * the host controller posts data to the TX latency FIFO before moving the data
 * onto the USB bus. The specific areas of performance include the how much data to
 * post into the FIFO and an estimate for how long that operation should take in
 * the target system. Definitions: T 0 = Standard packet overhead T 1 = Time to
 * send data payload T ff = Time to fetch packet into TX FIFO up to specified
 * level. T s = Total Packet Flight Time (send-only) packet T s = T 0 + T 1 T p =
 * Total Packet Time (fetch and send) packet T p = T ff + T 0 + T 1 Upon discovery
 * of a transmit (OUT/SETUP) packet in the data structures, host controller checks
 * to ensure T p remains before the end of the [micro]frame. If so it proceeds
 * to pre-fill the TX FIFO. If at anytime during the pre-fill operation the time
 * remaining the [micro]frame is < T s then the packet attempt ceases and the
 * packet is tried at a later time. Although this is not an error condition and the
 * host controller will eventually recover, a mark will be made the scheduler
 * health counter to note the occurrence of a "back-off" event. When a back-off event
 * is detected, the partial packet fetched may need to be discarded from the
 * latency buffer to make room for periodic traffic that will begin after the next
 * SOF. Too many back-off events can waste bandwidth and power on the system bus
 * and thus should be minimized (not necessarily eliminated). Back-offs can be
 * minimized with use of the n_TSCHHEALTH ( T ff ) described below. The reset value
 * could vary from instance to instance. Please see the detail in bit field
 * description and ignore reset value in summary table in this case!
 */
typedef union _hw_usb_uh2_txfilltuning
{
    uint32_t U;
    struct _hw_usb_uh2_txfilltuning_bitfields
    {
        uint32_t TXSCHOH : 8;          /*!< [7:0]  */
        uint32_t TXSCHHEALTH : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t TXFIFOTHRES : 6;      /*!< [21:16]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_usb_uh2_txfilltuning_t;

/*!
 * @name Constants and macros for entire USB_UH2_TXFILLTUNING register
 */
/*@{*/
#define HW_USB_UH2_TXFILLTUNING_ADDR(x) ((uintptr_t)(x) + 0x564U)

#define HW_USB_UH2_TXFILLTUNING(x) (*(__IO hw_usb_uh2_txfilltuning_t *) HW_USB_UH2_TXFILLTUNING_ADDR(x))
#define HW_USB_UH2_TXFILLTUNING_RD(x) (HW_USB_UH2_TXFILLTUNING(x).U)
#define HW_USB_UH2_TXFILLTUNING_WR(x, v) (HW_USB_UH2_TXFILLTUNING(x).U = (v))
#define HW_USB_UH2_TXFILLTUNING_SET(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, HW_USB_UH2_TXFILLTUNING_RD(x) |  (v)))
#define HW_USB_UH2_TXFILLTUNING_CLR(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, HW_USB_UH2_TXFILLTUNING_RD(x) & ~(v)))
#define HW_USB_UH2_TXFILLTUNING_TOG(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, HW_USB_UH2_TXFILLTUNING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_TXFILLTUNING bitfields
 */

/*!
 * @name Register USB_UH2_TXFILLTUNING, field TXSCHOH[7:0] (RW)
 *
 * Scheduler Overhead. (Read/Write) [Default = 0] This register adds an
 * additional fixed offset to the schedule time estimator described above as Tff. As an
 * approximation, the value chosen for this register should limit the number of
 * back-off events captured in the TXSCHHEALTH to less than 10 per second in a
 * highly utilized bus. Choosing a value that is too high for this register is not
 * desired as it can needlessly reduce USB utilization. The time unit represented
 * in this register is 1.267us when a device is connected in High-Speed Mode. The
 * time unit represented in this register is 6.333us when a device is connected
 * in Low/Full Speed Mode. Default value is '08h' for OTG controller core, and
 * '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_TXFILLTUNING_TXSCHOH (0U) /*!< Bit position for USB_UH2_TXFILLTUNING_TXSCHOH. */
#define BM_USB_UH2_TXFILLTUNING_TXSCHOH (0x000000FFU) /*!< Bit mask for USB_UH2_TXFILLTUNING_TXSCHOH. */
#define BS_USB_UH2_TXFILLTUNING_TXSCHOH (8U) /*!< Bit field size in bits for USB_UH2_TXFILLTUNING_TXSCHOH. */

/*! @brief Read current value of the USB_UH2_TXFILLTUNING_TXSCHOH field. */
#define BR_USB_UH2_TXFILLTUNING_TXSCHOH(x) (HW_USB_UH2_TXFILLTUNING(x).B.TXSCHOH)

/*! @brief Format value for bitfield USB_UH2_TXFILLTUNING_TXSCHOH. */
#define BF_USB_UH2_TXFILLTUNING_TXSCHOH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_TXFILLTUNING_TXSCHOH) & BM_USB_UH2_TXFILLTUNING_TXSCHOH)

/*! @brief Set the TXSCHOH field to a new value. */
#define BW_USB_UH2_TXFILLTUNING_TXSCHOH(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, (HW_USB_UH2_TXFILLTUNING_RD(x) & ~BM_USB_UH2_TXFILLTUNING_TXSCHOH) | BF_USB_UH2_TXFILLTUNING_TXSCHOH(v)))
/*@}*/

/*!
 * @name Register USB_UH2_TXFILLTUNING, field TXSCHHEALTH[12:8] (RW)
 *
 * Scheduler Health Counter. (Read/Write To Clear) This register increments when
 * the host controller fails to fill the TX latency FIFO to the level programmed
 * by TXFIFOTHRES before running out of time to send the packet before the next
 * Start-Of-Frame. This health counter measures the number of times this occurs
 * to provide feedback to selecting a proper TXSCHOH. Writing to this register
 * will clear the counter and this counter will max. at 31. Default value is '08h'
 * for OTG controller core, and '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_TXFILLTUNING_TXSCHHEALTH (8U) /*!< Bit position for USB_UH2_TXFILLTUNING_TXSCHHEALTH. */
#define BM_USB_UH2_TXFILLTUNING_TXSCHHEALTH (0x00001F00U) /*!< Bit mask for USB_UH2_TXFILLTUNING_TXSCHHEALTH. */
#define BS_USB_UH2_TXFILLTUNING_TXSCHHEALTH (5U) /*!< Bit field size in bits for USB_UH2_TXFILLTUNING_TXSCHHEALTH. */

/*! @brief Read current value of the USB_UH2_TXFILLTUNING_TXSCHHEALTH field. */
#define BR_USB_UH2_TXFILLTUNING_TXSCHHEALTH(x) (HW_USB_UH2_TXFILLTUNING(x).B.TXSCHHEALTH)

/*! @brief Format value for bitfield USB_UH2_TXFILLTUNING_TXSCHHEALTH. */
#define BF_USB_UH2_TXFILLTUNING_TXSCHHEALTH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_TXFILLTUNING_TXSCHHEALTH) & BM_USB_UH2_TXFILLTUNING_TXSCHHEALTH)

/*! @brief Set the TXSCHHEALTH field to a new value. */
#define BW_USB_UH2_TXFILLTUNING_TXSCHHEALTH(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, (HW_USB_UH2_TXFILLTUNING_RD(x) & ~BM_USB_UH2_TXFILLTUNING_TXSCHHEALTH) | BF_USB_UH2_TXFILLTUNING_TXSCHHEALTH(v)))
/*@}*/

/*!
 * @name Register USB_UH2_TXFILLTUNING, field TXFIFOTHRES[21:16] (RW)
 *
 * FIFO Burst Threshold. (Read/Write) This register controls the number of data
 * bursts that are posted to the TX latency FIFO in host mode before the packet
 * begins on to the bus. The minimum value is 2 and this value should be a low as
 * possible to maximize USB performance. A higher value can be used in systems
 * with unpredictable latency and/or insufficient bandwidth where the FIFO may
 * underrun because the data transferred from the latency FIFO to USB occurs before
 * it can be replenished from system memory. This value is ignored if the Stream
 * Disable bit in USB_n_USBMODE register is set. Default value is '00h' for OTG
 * controller core, and '02h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH2_TXFILLTUNING_TXFIFOTHRES (16U) /*!< Bit position for USB_UH2_TXFILLTUNING_TXFIFOTHRES. */
#define BM_USB_UH2_TXFILLTUNING_TXFIFOTHRES (0x003F0000U) /*!< Bit mask for USB_UH2_TXFILLTUNING_TXFIFOTHRES. */
#define BS_USB_UH2_TXFILLTUNING_TXFIFOTHRES (6U) /*!< Bit field size in bits for USB_UH2_TXFILLTUNING_TXFIFOTHRES. */

/*! @brief Read current value of the USB_UH2_TXFILLTUNING_TXFIFOTHRES field. */
#define BR_USB_UH2_TXFILLTUNING_TXFIFOTHRES(x) (HW_USB_UH2_TXFILLTUNING(x).B.TXFIFOTHRES)

/*! @brief Format value for bitfield USB_UH2_TXFILLTUNING_TXFIFOTHRES. */
#define BF_USB_UH2_TXFILLTUNING_TXFIFOTHRES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_TXFILLTUNING_TXFIFOTHRES) & BM_USB_UH2_TXFILLTUNING_TXFIFOTHRES)

/*! @brief Set the TXFIFOTHRES field to a new value. */
#define BW_USB_UH2_TXFILLTUNING_TXFIFOTHRES(x, v) (HW_USB_UH2_TXFILLTUNING_WR(x, (HW_USB_UH2_TXFILLTUNING_RD(x) & ~BM_USB_UH2_TXFILLTUNING_TXFIFOTHRES) | BF_USB_UH2_TXFILLTUNING_TXFIFOTHRES(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_CONFIGFLAG - Configure Flag Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_CONFIGFLAG - Configure Flag Register (RO)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_usb_uh2_configflag
{
    uint32_t U;
    struct _hw_usb_uh2_configflag_bitfields
    {
        uint32_t CF : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_usb_uh2_configflag_t;

/*!
 * @name Constants and macros for entire USB_UH2_CONFIGFLAG register
 */
/*@{*/
#define HW_USB_UH2_CONFIGFLAG_ADDR(x) ((uintptr_t)(x) + 0x580U)

#define HW_USB_UH2_CONFIGFLAG(x) (*(__I hw_usb_uh2_configflag_t *) HW_USB_UH2_CONFIGFLAG_ADDR(x))
#define HW_USB_UH2_CONFIGFLAG_RD(x) (HW_USB_UH2_CONFIGFLAG(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH2_CONFIGFLAG bitfields
 */

/*!
 * @name Register USB_UH2_CONFIGFLAG, field CF[0] (RO)
 *
 * Configure Flag Host software sets this bit as the last action in its process
 * of configuring the Host Controller. This bit controls the default port-routing
 * control logic.
 *
 * Values:
 * - 0 - Port routing control logic default-routes each port to an
 *     implementation dependent classic host controller.
 * - 1 - Port routing control logic default-routes all ports to this host
 *     controller.
 */
/*@{*/
#define BP_USB_UH2_CONFIGFLAG_CF (0U)      /*!< Bit position for USB_UH2_CONFIGFLAG_CF. */
#define BM_USB_UH2_CONFIGFLAG_CF (0x00000001U) /*!< Bit mask for USB_UH2_CONFIGFLAG_CF. */
#define BS_USB_UH2_CONFIGFLAG_CF (1U)      /*!< Bit field size in bits for USB_UH2_CONFIGFLAG_CF. */

/*! @brief Read current value of the USB_UH2_CONFIGFLAG_CF field. */
#define BR_USB_UH2_CONFIGFLAG_CF(x) (HW_USB_UH2_CONFIGFLAG(x).B.CF)
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_PORTSC1 - Port Status & Control
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_PORTSC1 - Port Status & Control (RW)
 *
 * Reset value: 0x10000000U
 *
 * Host Controller A host controller could implement one to eight port status
 * and control registers. The number is determined by N_PORTs bits in HWSPARAMs
 * register (please see HCSPARAMSHost Controller Structural Parameters ). Software
 * could read this parameter register to determine how many ports need service.
 * All controller cores on this product are Single-Port, so there is only one port
 * status and control register for each controller core. This register is only
 * reset by power on reset or controller core reset. The initial conditions of a
 * port are: No device connected Port disabled If the port supports power control,
 * this state remains until port power is supplied (by software). Device
 * Controller A controller operating in device mode has only port register one (PORTSC1)
 * and it does not support power control in that mode. Port control in device
 * mode is only used for status port reset, suspend, and current connect status. It
 * is also used to initiate test mode or force signaling and allows software to
 * put the PHY into low power suspend mode and disable the PHY clock.
 */
typedef union _hw_usb_uh2_portsc1
{
    uint32_t U;
    struct _hw_usb_uh2_portsc1_bitfields
    {
        uint32_t CCS : 1;              /*!< [0]  */
        uint32_t CSC : 1;              /*!< [1]  */
        uint32_t PE : 1;               /*!< [2]  */
        uint32_t PEC : 1;              /*!< [3]  */
        uint32_t OCA : 1;              /*!< [4]  */
        uint32_t OCC : 1;              /*!< [5]  */
        uint32_t FPR : 1;              /*!< [6]  */
        uint32_t SUSP : 1;             /*!< [7]  */
        uint32_t PR : 1;               /*!< [8]  */
        uint32_t HSP : 1;              /*!< [9]  */
        uint32_t LS : 2;               /*!< [11:10]  */
        uint32_t PP : 1;               /*!< [12]  */
        uint32_t PO : 1;               /*!< [13]  */
        uint32_t PIC : 2;              /*!< [15:14]  */
        uint32_t PTC : 4;              /*!< [19:16]  */
        uint32_t WKCN : 1;             /*!< [20]  */
        uint32_t WKDC : 1;             /*!< [21]  */
        uint32_t WKOC : 1;             /*!< [22]  */
        uint32_t PHCD : 1;             /*!< [23]  */
        uint32_t PFSC : 1;             /*!< [24]  */
        uint32_t PTS_2 : 1;            /*!< [25]  */
        uint32_t PSPD : 2;             /*!< [27:26]  */
        uint32_t PTW : 1;              /*!< [28]  */
        uint32_t STS : 1;              /*!< [29]  */
        uint32_t PTS_1 : 2;            /*!< [31:30]  */
    } B;
} hw_usb_uh2_portsc1_t;

/*!
 * @name Constants and macros for entire USB_UH2_PORTSC1 register
 */
/*@{*/
#define HW_USB_UH2_PORTSC1_ADDR(x) ((uintptr_t)(x) + 0x584U)

#define HW_USB_UH2_PORTSC1(x)    (*(__IO hw_usb_uh2_portsc1_t *) HW_USB_UH2_PORTSC1_ADDR(x))
#define HW_USB_UH2_PORTSC1_RD(x) (HW_USB_UH2_PORTSC1(x).U)
#define HW_USB_UH2_PORTSC1_WR(x, v) (HW_USB_UH2_PORTSC1(x).U = (v))
#define HW_USB_UH2_PORTSC1_SET(x, v) (HW_USB_UH2_PORTSC1_WR(x, HW_USB_UH2_PORTSC1_RD(x) |  (v)))
#define HW_USB_UH2_PORTSC1_CLR(x, v) (HW_USB_UH2_PORTSC1_WR(x, HW_USB_UH2_PORTSC1_RD(x) & ~(v)))
#define HW_USB_UH2_PORTSC1_TOG(x, v) (HW_USB_UH2_PORTSC1_WR(x, HW_USB_UH2_PORTSC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_PORTSC1 bitfields
 */

/*!
 * @name Register USB_UH2_PORTSC1, field CCS[0] (RO)
 *
 * Current Connect Status-Read Only. In Host Mode: 1=Device is present on port.
 * 0=No device is present. Default = 0. This value reflects the current state of
 * the port, and may not correspond directly to the event that caused the Connect
 * Status Change bit (Bit 1) to be set. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: 1=Attached.
 * 0=Not Attached. Default=0. A one indicates that the device successfully attached
 * and is operating in either high speed or full speed as indicated by the High
 * Speed Port bit in this register. A zero indicates that the device did not
 * attach successfully or was forcibly disconnected by the software writing a zero to
 * the Run bit in the USBCMD register. It does not state the device being
 * disconnected or suspended.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_CCS (0U)        /*!< Bit position for USB_UH2_PORTSC1_CCS. */
#define BM_USB_UH2_PORTSC1_CCS (0x00000001U) /*!< Bit mask for USB_UH2_PORTSC1_CCS. */
#define BS_USB_UH2_PORTSC1_CCS (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_CCS. */

/*! @brief Read current value of the USB_UH2_PORTSC1_CCS field. */
#define BR_USB_UH2_PORTSC1_CCS(x) (HW_USB_UH2_PORTSC1(x).B.CCS)
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field CSC[1] (RW)
 *
 * Connect Status Change-R/WC. 1 =Change in Current Connect Status. 0=No change.
 * Default 0. In Host Mode: Indicates a change has occurred in the port's
 * Current Connect Status. The host/device controller sets this bit for all changes to
 * the port device connect status, even if system software has not cleared an
 * existing connect status change. For example, the insertion status changes twice
 * before system software has cleared the changed condition, hub hardware will be
 * 'setting' an already-set bit (that is, the bit will remain set). Software
 * clears this bit by writing a one to it. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: This bit is
 * undefined in device controller mode.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_CSC (1U)        /*!< Bit position for USB_UH2_PORTSC1_CSC. */
#define BM_USB_UH2_PORTSC1_CSC (0x00000002U) /*!< Bit mask for USB_UH2_PORTSC1_CSC. */
#define BS_USB_UH2_PORTSC1_CSC (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_CSC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_CSC field. */
#define BR_USB_UH2_PORTSC1_CSC(x) (HW_USB_UH2_PORTSC1(x).B.CSC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_CSC. */
#define BF_USB_UH2_PORTSC1_CSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_CSC) & BM_USB_UH2_PORTSC1_CSC)

/*! @brief Set the CSC field to a new value. */
#define BW_USB_UH2_PORTSC1_CSC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_CSC) | BF_USB_UH2_PORTSC1_CSC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PE[2] (RW)
 *
 * Port Enabled/Disabled-Read/Write. 1=Enable. 0=Disable. Default 0. In Host
 * Mode: Ports can only be enabled by the host controller as a part of the reset and
 * enable. Software cannot enable a port by writing a one to this field. Ports
 * can be disabled by either a fault condition (disconnect event or other fault
 * condition) or by the host software. Note that the bit status does not change
 * until the port state actually changes. There may be a delay in disabling or
 * enabling a port due to other host controller and bus events. When the port is
 * disabled, (0b) downstream propagation of data is blocked except for reset. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero in host mode.
 * In Device Mode: The device port is always enabled, so this bit is always '1b'.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PE (2U)         /*!< Bit position for USB_UH2_PORTSC1_PE. */
#define BM_USB_UH2_PORTSC1_PE (0x00000004U) /*!< Bit mask for USB_UH2_PORTSC1_PE. */
#define BS_USB_UH2_PORTSC1_PE (1U)         /*!< Bit field size in bits for USB_UH2_PORTSC1_PE. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PE field. */
#define BR_USB_UH2_PORTSC1_PE(x) (HW_USB_UH2_PORTSC1(x).B.PE)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PE. */
#define BF_USB_UH2_PORTSC1_PE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PE) & BM_USB_UH2_PORTSC1_PE)

/*! @brief Set the PE field to a new value. */
#define BW_USB_UH2_PORTSC1_PE(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PE) | BF_USB_UH2_PORTSC1_PE(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PEC[3] (RW)
 *
 * Port Enable/Disable Change-R/WC. 1=Port enabled/disabled status has changed.
 * 0=No change. Default = 0. In Host Mode: For the root hub, this bit is set to a
 * one only when a port is disabled due to disconnect on the port or due to the
 * appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB
 * Specification). Software clears this by writing a one to it. This field is zero
 * if Port Power( PORTSC1Port Status & Control ) is zero. In Device mode: The
 * device port is always enabled, so this bit is always '0b'.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PEC (3U)        /*!< Bit position for USB_UH2_PORTSC1_PEC. */
#define BM_USB_UH2_PORTSC1_PEC (0x00000008U) /*!< Bit mask for USB_UH2_PORTSC1_PEC. */
#define BS_USB_UH2_PORTSC1_PEC (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_PEC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PEC field. */
#define BR_USB_UH2_PORTSC1_PEC(x) (HW_USB_UH2_PORTSC1(x).B.PEC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PEC. */
#define BF_USB_UH2_PORTSC1_PEC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PEC) & BM_USB_UH2_PORTSC1_PEC)

/*! @brief Set the PEC field to a new value. */
#define BW_USB_UH2_PORTSC1_PEC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PEC) | BF_USB_UH2_PORTSC1_PEC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field OCA[4] (RO)
 *
 * Over-current Active-Read Only. Default 0. This bit will automatically
 * transition from one to zero when the over current condition is removed.
 *
 * Values:
 * - 1 - This port currently has an over-current condition
 * - 0 - This port does not have an over-current condition.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_OCA (4U)        /*!< Bit position for USB_UH2_PORTSC1_OCA. */
#define BM_USB_UH2_PORTSC1_OCA (0x00000010U) /*!< Bit mask for USB_UH2_PORTSC1_OCA. */
#define BS_USB_UH2_PORTSC1_OCA (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_OCA. */

/*! @brief Read current value of the USB_UH2_PORTSC1_OCA field. */
#define BR_USB_UH2_PORTSC1_OCA(x) (HW_USB_UH2_PORTSC1(x).B.OCA)
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field OCC[5] (RW)
 *
 * Over-current Change-R/WC. Default=0. This bit is set '1b' by hardware when
 * there is a change to Over-current Active. Software can clear this bit by writing
 * a one to this bit position.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_OCC (5U)        /*!< Bit position for USB_UH2_PORTSC1_OCC. */
#define BM_USB_UH2_PORTSC1_OCC (0x00000020U) /*!< Bit mask for USB_UH2_PORTSC1_OCC. */
#define BS_USB_UH2_PORTSC1_OCC (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_OCC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_OCC field. */
#define BR_USB_UH2_PORTSC1_OCC(x) (HW_USB_UH2_PORTSC1(x).B.OCC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_OCC. */
#define BF_USB_UH2_PORTSC1_OCC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_OCC) & BM_USB_UH2_PORTSC1_OCC)

/*! @brief Set the OCC field to a new value. */
#define BW_USB_UH2_PORTSC1_OCC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_OCC) | BF_USB_UH2_PORTSC1_OCC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field FPR[6] (RW)
 *
 * Force Port Resume -Read/Write. 1= Resume detected/driven on port. 0=No resume
 * (K-state) detected/driven on port. Default = 0. In Host Mode: Software sets
 * this bit to one to drive resume signaling. The Host Controller sets this bit to
 * one if a J-to-K transition is detected while the port is in the Suspend
 * state. When this bit transitions to a one because a J-to-K transition is detected,
 * the Port Change Detect bit in the USBSTS register is also set to one. This bit
 * will automatically change to zero after the resume sequence is complete. This
 * behavior is different from EHCI where the host controller driver is required
 * to set this bit to a zero after the resume duration is timed in the driver.
 * Note that when the Host controller owns the port, the resume sequence follows
 * the defined sequence documented in the USB Specification Revision 2.0. The
 * resume signaling (Full-speed 'K') is driven on the port as long as this bit remains
 * a one. This bit will remain a one until the port has switched to the
 * high-speed idle. Writing a zero has no effect because the port controller will time
 * the resume operation, clear the bit the port control state switches to HS or FS
 * idle. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero
 * in host mode. This bit is not-EHCI compatible. In Device mode: After the
 * device has been in Suspend State for 5ms or more, software must set this bit to
 * one to drive resume signaling before clearing. The Device Controller will set
 * this bit to one if a J-to-K transition is detected while the port is in the
 * Suspend state. The bit will be cleared when the device returns to normal
 * operation. Also, when this bit wil be cleared because a K-to-J transition detected, the
 * Port Change Detect bit in the USBSTS register is also set to one.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_FPR (6U)        /*!< Bit position for USB_UH2_PORTSC1_FPR. */
#define BM_USB_UH2_PORTSC1_FPR (0x00000040U) /*!< Bit mask for USB_UH2_PORTSC1_FPR. */
#define BS_USB_UH2_PORTSC1_FPR (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_FPR. */

/*! @brief Read current value of the USB_UH2_PORTSC1_FPR field. */
#define BR_USB_UH2_PORTSC1_FPR(x) (HW_USB_UH2_PORTSC1(x).B.FPR)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_FPR. */
#define BF_USB_UH2_PORTSC1_FPR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_FPR) & BM_USB_UH2_PORTSC1_FPR)

/*! @brief Set the FPR field to a new value. */
#define BW_USB_UH2_PORTSC1_FPR(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_FPR) | BF_USB_UH2_PORTSC1_FPR(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field SUSP[7] (RW)
 *
 * Suspend - Read/Write or Read Only. Default = 0b. 1=Port in suspend state.
 * 0=Port not in suspend state. In Host Mode: Read/Write. Port Enabled Bit and
 * Suspend bit of this register define the port states as follows: Bits [Port Enabled,
 * Suspend] Port State 0x Disable 10 Enable 11 Suspend When in suspend state,
 * downstream propagation of data is blocked on this port, except for port reset.
 * The blocking occurs at the end of the current transaction if a transaction was
 * in progress when this bit was written to 1. In the suspend state, the port is
 * sensitive to resume detection. Note that the bit status does not change until
 * the port is suspended and that there may be a delay in suspending a port if
 * there is a transaction currently in progress on the USB. The host controller
 * will unconditionally set this bit to zero when software sets the Force Port
 * Resume bit to zero. The host controller ignores a write of zero to this bit. If
 * host software sets this bit to a one when the port is not enabled (that is, Port
 * enabled bit is a zero) the results are undefined. This field is zero if Port
 * Power( PORTSC1Port Status & Control ) is zero in host mode. In Device Mode:
 * Read Only. In device mode this bit is a read only status bit.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_SUSP (7U)       /*!< Bit position for USB_UH2_PORTSC1_SUSP. */
#define BM_USB_UH2_PORTSC1_SUSP (0x00000080U) /*!< Bit mask for USB_UH2_PORTSC1_SUSP. */
#define BS_USB_UH2_PORTSC1_SUSP (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_SUSP. */

/*! @brief Read current value of the USB_UH2_PORTSC1_SUSP field. */
#define BR_USB_UH2_PORTSC1_SUSP(x) (HW_USB_UH2_PORTSC1(x).B.SUSP)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_SUSP. */
#define BF_USB_UH2_PORTSC1_SUSP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_SUSP) & BM_USB_UH2_PORTSC1_SUSP)

/*! @brief Set the SUSP field to a new value. */
#define BW_USB_UH2_PORTSC1_SUSP(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_SUSP) | BF_USB_UH2_PORTSC1_SUSP(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PR[8] (RW)
 *
 * Port Reset - Read/Write or Read Only. Default = 0b. In Host Mode: Read/Write.
 * 1=Port is in Reset. 0=Port is not in Reset. Default 0. When software writes a
 * one to this bit the bus-reset sequence as defined in the USB Specification
 * Revision 2.0 is started. This bit will automatically change to zero after the
 * reset sequence is complete. This behavior is different from EHCI where the host
 * controller driver is required to set this bit to a zero after the reset
 * duration is timed in the driver. In Device Mode: This bit is a read only status bit.
 * Device reset from the USB bus is also indicated in the USBSTS register. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PR (8U)         /*!< Bit position for USB_UH2_PORTSC1_PR. */
#define BM_USB_UH2_PORTSC1_PR (0x00000100U) /*!< Bit mask for USB_UH2_PORTSC1_PR. */
#define BS_USB_UH2_PORTSC1_PR (1U)         /*!< Bit field size in bits for USB_UH2_PORTSC1_PR. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PR field. */
#define BR_USB_UH2_PORTSC1_PR(x) (HW_USB_UH2_PORTSC1(x).B.PR)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PR. */
#define BF_USB_UH2_PORTSC1_PR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PR) & BM_USB_UH2_PORTSC1_PR)

/*! @brief Set the PR field to a new value. */
#define BW_USB_UH2_PORTSC1_PR(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PR) | BF_USB_UH2_PORTSC1_PR(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field HSP[9] (RO)
 *
 * High-Speed Port - Read Only. Default = 0b. When the bit is one, the
 * host/device connected to the port is in high-speed mode and if set to zero, the
 * host/device connected to the port is not in a high-speed mode. HSP is redundant with
 * PSPD(bit 27, 26) but remained for compatibility.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_HSP (9U)        /*!< Bit position for USB_UH2_PORTSC1_HSP. */
#define BM_USB_UH2_PORTSC1_HSP (0x00000200U) /*!< Bit mask for USB_UH2_PORTSC1_HSP. */
#define BS_USB_UH2_PORTSC1_HSP (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_HSP. */

/*! @brief Read current value of the USB_UH2_PORTSC1_HSP field. */
#define BR_USB_UH2_PORTSC1_HSP(x) (HW_USB_UH2_PORTSC1(x).B.HSP)
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field LS[11:10] (RW)
 *
 * Line Status-Read Only. These bits reflect the current logical levels of the
 * D+ (bit 11) and D- (bit 10) signal lines. In host mode, the use of linestate by
 * the host controller driver is not necessary (unlike EHCI), because the port
 * controller state machine and the port routing manage the connection of LS and
 * FS. In device mode, the use of linestate by the device controller driver is not
 * necessary. The encoding of the bits are: Bits [11:10] Meaning
 *
 * Values:
 * - 00 - SE0
 * - 10 - J-state
 * - 01 - K-state
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_LS (10U)        /*!< Bit position for USB_UH2_PORTSC1_LS. */
#define BM_USB_UH2_PORTSC1_LS (0x00000C00U) /*!< Bit mask for USB_UH2_PORTSC1_LS. */
#define BS_USB_UH2_PORTSC1_LS (2U)         /*!< Bit field size in bits for USB_UH2_PORTSC1_LS. */

/*! @brief Read current value of the USB_UH2_PORTSC1_LS field. */
#define BR_USB_UH2_PORTSC1_LS(x) (HW_USB_UH2_PORTSC1(x).B.LS)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_LS. */
#define BF_USB_UH2_PORTSC1_LS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_LS) & BM_USB_UH2_PORTSC1_LS)

/*! @brief Set the LS field to a new value. */
#define BW_USB_UH2_PORTSC1_LS(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_LS) | BF_USB_UH2_PORTSC1_LS(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PP[12] (RW)
 *
 * Port Power (PP)-Read/Write or Read Only. The function of this bit depends on
 * the value of the Port Power Switching (PPC) field in the HCSPARAMS register.
 * The behavior is as follows: PPC PP Operation 0 1b Read Only - Host controller
 * does not have port power control switches. Each port is hard-wired to power. 1
 * 1b/0b - Read/Write. Host/OTG controller requires port power control switches.
 * This bit represents the current setting of the switch (0=off, 1=on). When
 * power is not available on a port (that is, PP equals a 0), the port is
 * non-functional and will not report attaches, detaches, etc. When an over-current
 * condition is detected on a powered port and PPC is a one, the PP bit in each affected
 * port may be transitional by the host controller driver from a one to a zero
 * (removing power from the port). This feature is implemented in all controller
 * cores (PPC = 1).
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PP (12U)        /*!< Bit position for USB_UH2_PORTSC1_PP. */
#define BM_USB_UH2_PORTSC1_PP (0x00001000U) /*!< Bit mask for USB_UH2_PORTSC1_PP. */
#define BS_USB_UH2_PORTSC1_PP (1U)         /*!< Bit field size in bits for USB_UH2_PORTSC1_PP. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PP field. */
#define BR_USB_UH2_PORTSC1_PP(x) (HW_USB_UH2_PORTSC1(x).B.PP)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PP. */
#define BF_USB_UH2_PORTSC1_PP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PP) & BM_USB_UH2_PORTSC1_PP)

/*! @brief Set the PP field to a new value. */
#define BW_USB_UH2_PORTSC1_PP(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PP) | BF_USB_UH2_PORTSC1_PP(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PO[13] (RW)
 *
 * Port Owner-Read/Write. Default = 0. This bit unconditionally goes to a 0 when
 * the configured bit in the CONFIGFLAG register makes a 0 to 1 transition. This
 * bit unconditionally goes to 1 whenever the Configured bit is zero System
 * software uses this field to release ownership of the port to a selected host
 * controller (in the event that the attached device is not a high-speed device).
 * Software writes a one to this bit when the attached device is not a high-speed
 * device. A one in this bit means that an internal companion controller owns and
 * controls the port. Port owner handoff is not supported in all controller cores,
 * therefore this bit will always be 0.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PO (13U)        /*!< Bit position for USB_UH2_PORTSC1_PO. */
#define BM_USB_UH2_PORTSC1_PO (0x00002000U) /*!< Bit mask for USB_UH2_PORTSC1_PO. */
#define BS_USB_UH2_PORTSC1_PO (1U)         /*!< Bit field size in bits for USB_UH2_PORTSC1_PO. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PO field. */
#define BR_USB_UH2_PORTSC1_PO(x) (HW_USB_UH2_PORTSC1(x).B.PO)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PO. */
#define BF_USB_UH2_PORTSC1_PO(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PO) & BM_USB_UH2_PORTSC1_PO)

/*! @brief Set the PO field to a new value. */
#define BW_USB_UH2_PORTSC1_PO(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PO) | BF_USB_UH2_PORTSC1_PO(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PIC[15:14] (RW)
 *
 * Port Indicator Control - Read/Write. Default = Ob. Writing to this field has
 * no effect if the P_INDICATOR bit in the HCSPARAMS register is a zero. Refer to
 * the USB Specification Revision 2.0 for a description on how these bits are to
 * be used. This field is zero if Port Power is zero. Bit Value Meaning
 *
 * Values:
 * - 00 - Port indicators are off
 * - 01 - Amber
 * - 10 - Green
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PIC (14U)       /*!< Bit position for USB_UH2_PORTSC1_PIC. */
#define BM_USB_UH2_PORTSC1_PIC (0x0000C000U) /*!< Bit mask for USB_UH2_PORTSC1_PIC. */
#define BS_USB_UH2_PORTSC1_PIC (2U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_PIC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PIC field. */
#define BR_USB_UH2_PORTSC1_PIC(x) (HW_USB_UH2_PORTSC1(x).B.PIC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PIC. */
#define BF_USB_UH2_PORTSC1_PIC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PIC) & BM_USB_UH2_PORTSC1_PIC)

/*! @brief Set the PIC field to a new value. */
#define BW_USB_UH2_PORTSC1_PIC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PIC) | BF_USB_UH2_PORTSC1_PIC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PTC[19:16] (RW)
 *
 * Port Test Control - Read/Write. Default = 0000b. Refer to Port Test Mode for
 * the operational model for using these test modes and the USB Specification
 * Revision 2.0, Chapter 7 for details on each test mode. The FORCE_ENABLE_FS and
 * FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI
 * specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS}
 * values will force the port into the connected and enabled state at the selected
 * speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state
 * machines to progress normally from that point. Low speed operations are not
 * supported as a peripheral device. Any other value than zero indicates that the
 * port is operating in test mode. Value Specific Test
 *
 * Values:
 * - 0000 - TEST_MODE_DISABLE
 * - 0001 - J_STATE
 * - 0010 - K_STATE
 * - 0011 - SE0 (host) / NAK (device)
 * - 0100 - Packet
 * - 0101 - FORCE_ENABLE_HS
 * - 0110 - FORCE_ENABLE_FS
 * - 0111 - FORCE_ENABLE_LS
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PTC (16U)       /*!< Bit position for USB_UH2_PORTSC1_PTC. */
#define BM_USB_UH2_PORTSC1_PTC (0x000F0000U) /*!< Bit mask for USB_UH2_PORTSC1_PTC. */
#define BS_USB_UH2_PORTSC1_PTC (4U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_PTC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PTC field. */
#define BR_USB_UH2_PORTSC1_PTC(x) (HW_USB_UH2_PORTSC1(x).B.PTC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PTC. */
#define BF_USB_UH2_PORTSC1_PTC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PTC) & BM_USB_UH2_PORTSC1_PTC)

/*! @brief Set the PTC field to a new value. */
#define BW_USB_UH2_PORTSC1_PTC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PTC) | BF_USB_UH2_PORTSC1_PTC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field WKCN[20] (RW)
 *
 * Wake on Connect Enable (WKCNNT_E) - Read/Write. Default=0b. Writing this bit
 * to a one enables the port to be sensitive to device connects as wake-up
 * events. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero or
 * in device mode.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_WKCN (20U)      /*!< Bit position for USB_UH2_PORTSC1_WKCN. */
#define BM_USB_UH2_PORTSC1_WKCN (0x00100000U) /*!< Bit mask for USB_UH2_PORTSC1_WKCN. */
#define BS_USB_UH2_PORTSC1_WKCN (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_WKCN. */

/*! @brief Read current value of the USB_UH2_PORTSC1_WKCN field. */
#define BR_USB_UH2_PORTSC1_WKCN(x) (HW_USB_UH2_PORTSC1(x).B.WKCN)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_WKCN. */
#define BF_USB_UH2_PORTSC1_WKCN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_WKCN) & BM_USB_UH2_PORTSC1_WKCN)

/*! @brief Set the WKCN field to a new value. */
#define BW_USB_UH2_PORTSC1_WKCN(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_WKCN) | BF_USB_UH2_PORTSC1_WKCN(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field WKDC[21] (RW)
 *
 * Wake on Disconnect Enable (WKDSCNNT_E) - Read/Write. Default=0b. Writing this
 * bit to a one enables the port to be sensitive to device disconnects as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control ) is
 * zero or in device mode.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_WKDC (21U)      /*!< Bit position for USB_UH2_PORTSC1_WKDC. */
#define BM_USB_UH2_PORTSC1_WKDC (0x00200000U) /*!< Bit mask for USB_UH2_PORTSC1_WKDC. */
#define BS_USB_UH2_PORTSC1_WKDC (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_WKDC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_WKDC field. */
#define BR_USB_UH2_PORTSC1_WKDC(x) (HW_USB_UH2_PORTSC1(x).B.WKDC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_WKDC. */
#define BF_USB_UH2_PORTSC1_WKDC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_WKDC) & BM_USB_UH2_PORTSC1_WKDC)

/*! @brief Set the WKDC field to a new value. */
#define BW_USB_UH2_PORTSC1_WKDC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_WKDC) | BF_USB_UH2_PORTSC1_WKDC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field WKOC[22] (RW)
 *
 * Wake on Over-current Enable (WKOC_E) - Read/Write. Default = 0b. Writing this
 * bit to a one enables the port to be sensitive to over-current conditions as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control
 * ) is zero.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_WKOC (22U)      /*!< Bit position for USB_UH2_PORTSC1_WKOC. */
#define BM_USB_UH2_PORTSC1_WKOC (0x00400000U) /*!< Bit mask for USB_UH2_PORTSC1_WKOC. */
#define BS_USB_UH2_PORTSC1_WKOC (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_WKOC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_WKOC field. */
#define BR_USB_UH2_PORTSC1_WKOC(x) (HW_USB_UH2_PORTSC1(x).B.WKOC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_WKOC. */
#define BF_USB_UH2_PORTSC1_WKOC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_WKOC) & BM_USB_UH2_PORTSC1_WKOC)

/*! @brief Set the WKOC field to a new value. */
#define BW_USB_UH2_PORTSC1_WKOC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_WKOC) | BF_USB_UH2_PORTSC1_WKOC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PHCD[23] (RW)
 *
 * PHY Low Power Suspend - Clock Disable (PLPSCD) - Read/Write. Default = 0b.
 * When this bit is set to '1b', the PHY clock is disabled. Reading this bit will
 * indicate the status of the PHY clock. The PHY clock cannot be disabled if it is
 * being used as the system clock. In device mode, The PHY can be put into Low
 * Power Suspend when the device is not running (USBCMD Run/Stop=0b) or the host
 * has signalled suspend (PORTSC1 SUSPEND=1b). PHY Low power suspend will be
 * cleared automatically when the host initials resume. Before forcing a resume from
 * the device, the device controller driver must clear this bit. In host mode, the
 * PHY can be put into Low Power Suspend when the downstream device has been put
 * into suspend mode or when no downstream device is connected. Low power
 * suspend is completely under the control of software.
 *
 * Values:
 * - 1 - Disable PHY clock
 * - 0 - Enable PHY clock
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PHCD (23U)      /*!< Bit position for USB_UH2_PORTSC1_PHCD. */
#define BM_USB_UH2_PORTSC1_PHCD (0x00800000U) /*!< Bit mask for USB_UH2_PORTSC1_PHCD. */
#define BS_USB_UH2_PORTSC1_PHCD (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_PHCD. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PHCD field. */
#define BR_USB_UH2_PORTSC1_PHCD(x) (HW_USB_UH2_PORTSC1(x).B.PHCD)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PHCD. */
#define BF_USB_UH2_PORTSC1_PHCD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PHCD) & BM_USB_UH2_PORTSC1_PHCD)

/*! @brief Set the PHCD field to a new value. */
#define BW_USB_UH2_PORTSC1_PHCD(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PHCD) | BF_USB_UH2_PORTSC1_PHCD(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PFSC[24] (RW)
 *
 * Port Force Full Speed Connect - Read/Write. Default = 0b. When this bit is
 * set to '1b', the port will be forced to only connect at Full Speed, It disables
 * the chirp sequence that allows the port to identify itself as High Speed.
 *
 * Values:
 * - 1 - Forced to full speed
 * - 0 - Normal operation
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PFSC (24U)      /*!< Bit position for USB_UH2_PORTSC1_PFSC. */
#define BM_USB_UH2_PORTSC1_PFSC (0x01000000U) /*!< Bit mask for USB_UH2_PORTSC1_PFSC. */
#define BS_USB_UH2_PORTSC1_PFSC (1U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_PFSC. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PFSC field. */
#define BR_USB_UH2_PORTSC1_PFSC(x) (HW_USB_UH2_PORTSC1(x).B.PFSC)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PFSC. */
#define BF_USB_UH2_PORTSC1_PFSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PFSC) & BM_USB_UH2_PORTSC1_PFSC)

/*! @brief Set the PFSC field to a new value. */
#define BW_USB_UH2_PORTSC1_PFSC(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PFSC) | BF_USB_UH2_PORTSC1_PFSC(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PTS_2[25] (RW)
 *
 * See description at bits 31-30
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PTS_2 (25U)     /*!< Bit position for USB_UH2_PORTSC1_PTS_2. */
#define BM_USB_UH2_PORTSC1_PTS_2 (0x02000000U) /*!< Bit mask for USB_UH2_PORTSC1_PTS_2. */
#define BS_USB_UH2_PORTSC1_PTS_2 (1U)      /*!< Bit field size in bits for USB_UH2_PORTSC1_PTS_2. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PTS_2 field. */
#define BR_USB_UH2_PORTSC1_PTS_2(x) (HW_USB_UH2_PORTSC1(x).B.PTS_2)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PTS_2. */
#define BF_USB_UH2_PORTSC1_PTS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PTS_2) & BM_USB_UH2_PORTSC1_PTS_2)

/*! @brief Set the PTS_2 field to a new value. */
#define BW_USB_UH2_PORTSC1_PTS_2(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PTS_2) | BF_USB_UH2_PORTSC1_PTS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PSPD[27:26] (RW)
 *
 * Port Speed - Read Only. This register field indicates the speed at which the
 * port is operating.
 *
 * Values:
 * - 00 - Full Speed
 * - 01 - Low Speed
 * - 10 - High Speed
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PSPD (26U)      /*!< Bit position for USB_UH2_PORTSC1_PSPD. */
#define BM_USB_UH2_PORTSC1_PSPD (0x0C000000U) /*!< Bit mask for USB_UH2_PORTSC1_PSPD. */
#define BS_USB_UH2_PORTSC1_PSPD (2U)       /*!< Bit field size in bits for USB_UH2_PORTSC1_PSPD. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PSPD field. */
#define BR_USB_UH2_PORTSC1_PSPD(x) (HW_USB_UH2_PORTSC1(x).B.PSPD)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PSPD. */
#define BF_USB_UH2_PORTSC1_PSPD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PSPD) & BM_USB_UH2_PORTSC1_PSPD)

/*! @brief Set the PSPD field to a new value. */
#define BW_USB_UH2_PORTSC1_PSPD(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PSPD) | BF_USB_UH2_PORTSC1_PSPD(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PTW[28] (RW)
 *
 * Parallel Transceiver Width This bit has no effect if serial interface engine
 * is used. For OTG/Host1/Host2/Host3 core, it is Read-Only. Reset value is '1b'.
 *
 * Values:
 * - 0 - Select the 8-bit UTMI interface [60MHz]
 * - 1 - Select the 16-bit UTMI interface [30MHz]
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PTW (28U)       /*!< Bit position for USB_UH2_PORTSC1_PTW. */
#define BM_USB_UH2_PORTSC1_PTW (0x10000000U) /*!< Bit mask for USB_UH2_PORTSC1_PTW. */
#define BS_USB_UH2_PORTSC1_PTW (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_PTW. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PTW field. */
#define BR_USB_UH2_PORTSC1_PTW(x) (HW_USB_UH2_PORTSC1(x).B.PTW)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PTW. */
#define BF_USB_UH2_PORTSC1_PTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PTW) & BM_USB_UH2_PORTSC1_PTW)

/*! @brief Set the PTW field to a new value. */
#define BW_USB_UH2_PORTSC1_PTW(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PTW) | BF_USB_UH2_PORTSC1_PTW(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field STS[29] (RW)
 *
 * Serial Transceiver Select - Read Only Serial Transceiver Select 1 Serial
 * Interface Engine is selected 0 Parallel Interface signals is selected Serial
 * Interface Engine can be used in combination with UTMI+/ULPI physical interface to
 * provide FS/LS signaling instead of the parallel interface signals. When this
 * bit is set '1b', serial interface engine will be used instead of parallel
 * interface signals. This bit has no effect unless PTS bits is set to select
 * UTMI+/ULPI interface. The Serial/USB1.1 PHY/IC-USB will use the serial interface engine
 * for FS/LS signaling regardless of this bit value.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_STS (29U)       /*!< Bit position for USB_UH2_PORTSC1_STS. */
#define BM_USB_UH2_PORTSC1_STS (0x20000000U) /*!< Bit mask for USB_UH2_PORTSC1_STS. */
#define BS_USB_UH2_PORTSC1_STS (1U)        /*!< Bit field size in bits for USB_UH2_PORTSC1_STS. */

/*! @brief Read current value of the USB_UH2_PORTSC1_STS field. */
#define BR_USB_UH2_PORTSC1_STS(x) (HW_USB_UH2_PORTSC1(x).B.STS)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_STS. */
#define BF_USB_UH2_PORTSC1_STS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_STS) & BM_USB_UH2_PORTSC1_STS)

/*! @brief Set the STS field to a new value. */
#define BW_USB_UH2_PORTSC1_STS(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_STS) | BF_USB_UH2_PORTSC1_STS(v)))
/*@}*/

/*!
 * @name Register USB_UH2_PORTSC1, field PTS_1[31:30] (RW)
 *
 * Bit field {bit25, bit31, bit30}: "000b" UTMI/UTMI+ "001b" Reserved "010b"
 * ULPI "011b" Serial/USB 1.1 PHY/IC-USB (FS Only) "100b" HSIC Parallel Transceiver
 * Select (bit25, bit31, bi30). For OTG core, it is Read-Only. Reset value is
 * 000b. For Host1/Host2/Host3 core, it is Read/Write. Reset value is 000b. All USB
 * port interface modes are listed in this field description, but not all are
 * supported. For detail feature of each controller core, please see Features . The
 * behaviour is unknown when unsupported interface mode is selected.
 */
/*@{*/
#define BP_USB_UH2_PORTSC1_PTS_1 (30U)     /*!< Bit position for USB_UH2_PORTSC1_PTS_1. */
#define BM_USB_UH2_PORTSC1_PTS_1 (0xC0000000U) /*!< Bit mask for USB_UH2_PORTSC1_PTS_1. */
#define BS_USB_UH2_PORTSC1_PTS_1 (2U)      /*!< Bit field size in bits for USB_UH2_PORTSC1_PTS_1. */

/*! @brief Read current value of the USB_UH2_PORTSC1_PTS_1 field. */
#define BR_USB_UH2_PORTSC1_PTS_1(x) (HW_USB_UH2_PORTSC1(x).B.PTS_1)

/*! @brief Format value for bitfield USB_UH2_PORTSC1_PTS_1. */
#define BF_USB_UH2_PORTSC1_PTS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_PORTSC1_PTS_1) & BM_USB_UH2_PORTSC1_PTS_1)

/*! @brief Set the PTS_1 field to a new value. */
#define BW_USB_UH2_PORTSC1_PTS_1(x, v) (HW_USB_UH2_PORTSC1_WR(x, (HW_USB_UH2_PORTSC1_RD(x) & ~BM_USB_UH2_PORTSC1_PTS_1) | BF_USB_UH2_PORTSC1_PTS_1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH2_USBMODE - USB Device Mode
 ******************************************************************************/

/*!
 * @brief HW_USB_UH2_USBMODE - USB Device Mode (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uh2_usbmode
{
    uint32_t U;
    struct _hw_usb_uh2_usbmode_bitfields
    {
        uint32_t CM : 2;               /*!< [1:0]  */
        uint32_t ES : 1;               /*!< [2]  */
        uint32_t SLOM : 1;             /*!< [3]  */
        uint32_t SDIS : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_usb_uh2_usbmode_t;

/*!
 * @name Constants and macros for entire USB_UH2_USBMODE register
 */
/*@{*/
#define HW_USB_UH2_USBMODE_ADDR(x) ((uintptr_t)(x) + 0x5A8U)

#define HW_USB_UH2_USBMODE(x)    (*(__IO hw_usb_uh2_usbmode_t *) HW_USB_UH2_USBMODE_ADDR(x))
#define HW_USB_UH2_USBMODE_RD(x) (HW_USB_UH2_USBMODE(x).U)
#define HW_USB_UH2_USBMODE_WR(x, v) (HW_USB_UH2_USBMODE(x).U = (v))
#define HW_USB_UH2_USBMODE_SET(x, v) (HW_USB_UH2_USBMODE_WR(x, HW_USB_UH2_USBMODE_RD(x) |  (v)))
#define HW_USB_UH2_USBMODE_CLR(x, v) (HW_USB_UH2_USBMODE_WR(x, HW_USB_UH2_USBMODE_RD(x) & ~(v)))
#define HW_USB_UH2_USBMODE_TOG(x, v) (HW_USB_UH2_USBMODE_WR(x, HW_USB_UH2_USBMODE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH2_USBMODE bitfields
 */

/*!
 * @name Register USB_UH2_USBMODE, field CM[1:0] (RW)
 *
 * Controller Mode - R/WO. Controller mode is defaulted to the proper mode for
 * host only and device only implementations. For those designs that contain both
 * host & device capability, the controller defaults to an idle state and needs
 * to be initialized to the desired operating mode after reset. For combination
 * host/device controllers, this register can only be written once after reset. If
 * it is necessary to switch modes, software must reset the controller by writing
 * to the RESET bit in the USBCMD register before reprogramming this register.
 * For OTG controller core, reset value is '00b'. For Host-only controller core,
 * reset value is '11b'.
 *
 * Values:
 * - 00 - Idle [Default for combination host/device]
 * - 01 - Reserved
 * - 10 - Device Controller [Default for device only controller]
 * - 11 - Host Controller [Default for host only controller]
 */
/*@{*/
#define BP_USB_UH2_USBMODE_CM (0U)         /*!< Bit position for USB_UH2_USBMODE_CM. */
#define BM_USB_UH2_USBMODE_CM (0x00000003U) /*!< Bit mask for USB_UH2_USBMODE_CM. */
#define BS_USB_UH2_USBMODE_CM (2U)         /*!< Bit field size in bits for USB_UH2_USBMODE_CM. */

/*! @brief Read current value of the USB_UH2_USBMODE_CM field. */
#define BR_USB_UH2_USBMODE_CM(x) (HW_USB_UH2_USBMODE(x).B.CM)

/*! @brief Format value for bitfield USB_UH2_USBMODE_CM. */
#define BF_USB_UH2_USBMODE_CM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBMODE_CM) & BM_USB_UH2_USBMODE_CM)

/*! @brief Set the CM field to a new value. */
#define BW_USB_UH2_USBMODE_CM(x, v) (HW_USB_UH2_USBMODE_WR(x, (HW_USB_UH2_USBMODE_RD(x) & ~BM_USB_UH2_USBMODE_CM) | BF_USB_UH2_USBMODE_CM(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBMODE, field ES[2] (RW)
 *
 * Endian Select - Read/Write. This bit can change the byte alignment of the
 * transfer buffers to match the host microprocessor. The bit fields in the
 * microprocessor interface and the data structures are unaffected by the value of this
 * bit because they are based upon the 32-bit word. Bit Meaning
 *
 * Values:
 * - 0 - Little Endian [Default]
 * - 1 - Big Endian
 */
/*@{*/
#define BP_USB_UH2_USBMODE_ES (2U)         /*!< Bit position for USB_UH2_USBMODE_ES. */
#define BM_USB_UH2_USBMODE_ES (0x00000004U) /*!< Bit mask for USB_UH2_USBMODE_ES. */
#define BS_USB_UH2_USBMODE_ES (1U)         /*!< Bit field size in bits for USB_UH2_USBMODE_ES. */

/*! @brief Read current value of the USB_UH2_USBMODE_ES field. */
#define BR_USB_UH2_USBMODE_ES(x) (HW_USB_UH2_USBMODE(x).B.ES)

/*! @brief Format value for bitfield USB_UH2_USBMODE_ES. */
#define BF_USB_UH2_USBMODE_ES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBMODE_ES) & BM_USB_UH2_USBMODE_ES)

/*! @brief Set the ES field to a new value. */
#define BW_USB_UH2_USBMODE_ES(x, v) (HW_USB_UH2_USBMODE_WR(x, (HW_USB_UH2_USBMODE_RD(x) & ~BM_USB_UH2_USBMODE_ES) | BF_USB_UH2_USBMODE_ES(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBMODE, field SLOM[3] (RW)
 *
 * Setup Lockout Mode. In device mode, this bit controls behavior of the setup
 * lock mechanism. See Control Endpoint Operation Model .
 *
 * Values:
 * - 0 - Setup Lockouts On (default);
 * - 1 - Setup Lockouts Off (DCD requires use of Setup Data Buffer Tripwire in
 *     USBCMDUSB Command Register .
 */
/*@{*/
#define BP_USB_UH2_USBMODE_SLOM (3U)       /*!< Bit position for USB_UH2_USBMODE_SLOM. */
#define BM_USB_UH2_USBMODE_SLOM (0x00000008U) /*!< Bit mask for USB_UH2_USBMODE_SLOM. */
#define BS_USB_UH2_USBMODE_SLOM (1U)       /*!< Bit field size in bits for USB_UH2_USBMODE_SLOM. */

/*! @brief Read current value of the USB_UH2_USBMODE_SLOM field. */
#define BR_USB_UH2_USBMODE_SLOM(x) (HW_USB_UH2_USBMODE(x).B.SLOM)

/*! @brief Format value for bitfield USB_UH2_USBMODE_SLOM. */
#define BF_USB_UH2_USBMODE_SLOM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBMODE_SLOM) & BM_USB_UH2_USBMODE_SLOM)

/*! @brief Set the SLOM field to a new value. */
#define BW_USB_UH2_USBMODE_SLOM(x, v) (HW_USB_UH2_USBMODE_WR(x, (HW_USB_UH2_USBMODE_RD(x) & ~BM_USB_UH2_USBMODE_SLOM) | BF_USB_UH2_USBMODE_SLOM(v)))
/*@}*/

/*!
 * @name Register USB_UH2_USBMODE, field SDIS[4] (RW)
 *
 * Stream Disable Mode. (0 - Inactive [default]; 1 - Active) Device Mode:
 * Setting to a '1' disables double priming on both RX and TX for low bandwidth
 * systems. This mode ensures that when the RX and TX buffers are sufficient to contain
 * an entire packet that the standard double buffering scheme is disabled to
 * prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode,
 * all packets received are responded to with a NYET handshake when stream
 * disable is active. Host Mode: Setting to a '1' ensures that overruns/underruns of
 * the latency FIFO are eliminated for low bandwidth systems where the RX and TX
 * buffers are sufficient to contain the entire packet. Enabling stream disable
 * also has the effect of ensuring the TX latency is filled to capacity before the
 * packet is launched onto the USB. Time duration to pre-fill the FIFO becomes
 * significant when stream disable is active. See TXFILLTUNINGTX FIFO Fill Tuning
 * and TXTTFILLTUNING [MPH Only] to characterize the adjustments needed for the
 * scheduler when using this feature. The use of this feature substantially limits
 * of the overall USB performance that can be achieved.
 */
/*@{*/
#define BP_USB_UH2_USBMODE_SDIS (4U)       /*!< Bit position for USB_UH2_USBMODE_SDIS. */
#define BM_USB_UH2_USBMODE_SDIS (0x00000010U) /*!< Bit mask for USB_UH2_USBMODE_SDIS. */
#define BS_USB_UH2_USBMODE_SDIS (1U)       /*!< Bit field size in bits for USB_UH2_USBMODE_SDIS. */

/*! @brief Read current value of the USB_UH2_USBMODE_SDIS field. */
#define BR_USB_UH2_USBMODE_SDIS(x) (HW_USB_UH2_USBMODE(x).B.SDIS)

/*! @brief Format value for bitfield USB_UH2_USBMODE_SDIS. */
#define BF_USB_UH2_USBMODE_SDIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH2_USBMODE_SDIS) & BM_USB_UH2_USBMODE_SDIS)

/*! @brief Set the SDIS field to a new value. */
#define BW_USB_UH2_USBMODE_SDIS(x, v) (HW_USB_UH2_USBMODE_WR(x, (HW_USB_UH2_USBMODE_RD(x) & ~BM_USB_UH2_USBMODE_SDIS) | BF_USB_UH2_USBMODE_SDIS(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_ID - Identification register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_ID - Identification register (RO)
 *
 * Reset value: 0xE401FA05U
 *
 * The ID register identifies the USB 2.0 High-Speed core and its revision.
 */
typedef union _hw_usb_uh3_id
{
    uint32_t U;
    struct _hw_usb_uh3_id_bitfields
    {
        uint32_t ID : 6;               /*!< [5:0]  */
        uint32_t RESERVED0 : 2;        /*!< [7:6]  */
        uint32_t NID : 6;              /*!< [13:8]  */
        uint32_t RESERVED1 : 2;        /*!< [15:14]  */
        uint32_t REVISION : 8;         /*!< [23:16]  */
        uint32_t RESERVED2 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh3_id_t;

/*!
 * @name Constants and macros for entire USB_UH3_ID register
 */
/*@{*/
#define HW_USB_UH3_ID_ADDR(x)    ((uintptr_t)(x) + 0x600U)

#define HW_USB_UH3_ID(x)         (*(__I hw_usb_uh3_id_t *) HW_USB_UH3_ID_ADDR(x))
#define HW_USB_UH3_ID_RD(x)      (HW_USB_UH3_ID(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_ID bitfields
 */

/*!
 * @name Register USB_UH3_ID, field ID[5:0] (RO)
 *
 * Configuration number. This number is set to 0x05 and indicates that the
 * peripheral is USB 2.0 High-Speed core.
 */
/*@{*/
#define BP_USB_UH3_ID_ID     (0U)          /*!< Bit position for USB_UH3_ID_ID. */
#define BM_USB_UH3_ID_ID     (0x0000003FU) /*!< Bit mask for USB_UH3_ID_ID. */
#define BS_USB_UH3_ID_ID     (6U)          /*!< Bit field size in bits for USB_UH3_ID_ID. */

/*! @brief Read current value of the USB_UH3_ID_ID field. */
#define BR_USB_UH3_ID_ID(x)  (HW_USB_UH3_ID(x).B.ID)
/*@}*/

/*!
 * @name Register USB_UH3_ID, field NID[13:8] (RO)
 *
 * Complement version of ID
 */
/*@{*/
#define BP_USB_UH3_ID_NID    (8U)          /*!< Bit position for USB_UH3_ID_NID. */
#define BM_USB_UH3_ID_NID    (0x00003F00U) /*!< Bit mask for USB_UH3_ID_NID. */
#define BS_USB_UH3_ID_NID    (6U)          /*!< Bit field size in bits for USB_UH3_ID_NID. */

/*! @brief Read current value of the USB_UH3_ID_NID field. */
#define BR_USB_UH3_ID_NID(x) (HW_USB_UH3_ID(x).B.NID)
/*@}*/

/*!
 * @name Register USB_UH3_ID, field REVISION[23:16] (RO)
 *
 * Revision number of the controller core.
 */
/*@{*/
#define BP_USB_UH3_ID_REVISION (16U)       /*!< Bit position for USB_UH3_ID_REVISION. */
#define BM_USB_UH3_ID_REVISION (0x00FF0000U) /*!< Bit mask for USB_UH3_ID_REVISION. */
#define BS_USB_UH3_ID_REVISION (8U)        /*!< Bit field size in bits for USB_UH3_ID_REVISION. */

/*! @brief Read current value of the USB_UH3_ID_REVISION field. */
#define BR_USB_UH3_ID_REVISION(x) (HW_USB_UH3_ID(x).B.REVISION)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HWGENERAL - Hardware General
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HWGENERAL - Hardware General (RO)
 *
 * Reset value: 0x00000015U
 *
 * General hardware parameters as defined in System Level Issues and Core
 * Configuration. The reset value could vary from instance to instance. Please see the
 * detail in bit field description and ignore reset value in summary table in
 * this case!
 */
typedef union _hw_usb_uh3_hwgeneral
{
    uint32_t U;
    struct _hw_usb_uh3_hwgeneral_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t PHYW : 2;             /*!< [5:4]  */
        uint32_t PHYM : 3;             /*!< [8:6]  */
        uint32_t SM : 2;               /*!< [10:9]  */
        uint32_t RESERVED1 : 21;       /*!< [31:11]  */
    } B;
} hw_usb_uh3_hwgeneral_t;

/*!
 * @name Constants and macros for entire USB_UH3_HWGENERAL register
 */
/*@{*/
#define HW_USB_UH3_HWGENERAL_ADDR(x) ((uintptr_t)(x) + 0x604U)

#define HW_USB_UH3_HWGENERAL(x)  (*(__I hw_usb_uh3_hwgeneral_t *) HW_USB_UH3_HWGENERAL_ADDR(x))
#define HW_USB_UH3_HWGENERAL_RD(x) (HW_USB_UH3_HWGENERAL(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HWGENERAL bitfields
 */

/*!
 * @name Register USB_UH3_HWGENERAL, field PHYW[5:4] (RO)
 *
 * Data width of the transciever connected to the controller core. PHYW bit
 * reset value is PHYW bit reset value is '01b'.
 *
 * Values:
 * - 00 - 8 bit wide data bus Software non-programmable
 * - 01 - 16 bit wide data bus Software non-programmable
 * - 10 - Reset to 8 bit wide data bus Software programmable
 * - 11 - Reset to 16 bit wide data bus Software programmable
 */
/*@{*/
#define BP_USB_UH3_HWGENERAL_PHYW (4U)     /*!< Bit position for USB_UH3_HWGENERAL_PHYW. */
#define BM_USB_UH3_HWGENERAL_PHYW (0x00000030U) /*!< Bit mask for USB_UH3_HWGENERAL_PHYW. */
#define BS_USB_UH3_HWGENERAL_PHYW (2U)     /*!< Bit field size in bits for USB_UH3_HWGENERAL_PHYW. */

/*! @brief Read current value of the USB_UH3_HWGENERAL_PHYW field. */
#define BR_USB_UH3_HWGENERAL_PHYW(x) (HW_USB_UH3_HWGENERAL(x).B.PHYW)
/*@}*/

/*!
 * @name Register USB_UH3_HWGENERAL, field PHYM[8:6] (RO)
 *
 * Transciever type PHYM bit reset value: '0000b' for OTG controller core,
 * '0100b' for Host-only controller core.
 *
 * Values:
 * - 000 - UTMI/UMTI+
 * - 001 - ULPI DDR
 * - 010 - ULPI
 * - 011 - Serial Only
 * - 100 - Software programmable - reset to UTMI/UTMI+
 * - 101 - Software programmable - reset to ULPI DDR
 * - 110 - Software programmable - reset to ULPI
 * - 111 - Software programmable - reset to Serial
 */
/*@{*/
#define BP_USB_UH3_HWGENERAL_PHYM (6U)     /*!< Bit position for USB_UH3_HWGENERAL_PHYM. */
#define BM_USB_UH3_HWGENERAL_PHYM (0x000001C0U) /*!< Bit mask for USB_UH3_HWGENERAL_PHYM. */
#define BS_USB_UH3_HWGENERAL_PHYM (3U)     /*!< Bit field size in bits for USB_UH3_HWGENERAL_PHYM. */

/*! @brief Read current value of the USB_UH3_HWGENERAL_PHYM field. */
#define BR_USB_UH3_HWGENERAL_PHYM(x) (HW_USB_UH3_HWGENERAL(x).B.PHYM)
/*@}*/

/*!
 * @name Register USB_UH3_HWGENERAL, field SM[10:9] (RO)
 *
 * Serial interface mode capability SM bit reset value is '00b'
 *
 * Values:
 * - 00 - No Serial Engine, always use parallel signalling.
 * - 01 - Serial Engine present, always use serial signalling for FS/LS.
 * - 10 - Software programmable - Reset to use parallel signalling for FS/LS
 * - 11 - Software programmable - Reset to use serial signalling for FS/LS
 */
/*@{*/
#define BP_USB_UH3_HWGENERAL_SM (9U)       /*!< Bit position for USB_UH3_HWGENERAL_SM. */
#define BM_USB_UH3_HWGENERAL_SM (0x00000600U) /*!< Bit mask for USB_UH3_HWGENERAL_SM. */
#define BS_USB_UH3_HWGENERAL_SM (2U)       /*!< Bit field size in bits for USB_UH3_HWGENERAL_SM. */

/*! @brief Read current value of the USB_UH3_HWGENERAL_SM field. */
#define BR_USB_UH3_HWGENERAL_SM(x) (HW_USB_UH3_HWGENERAL(x).B.SM)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HWHOST - Host Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HWHOST - Host Hardware Parameters (RO)
 *
 * Reset value: 0x10020001U
 */
typedef union _hw_usb_uh3_hwhost
{
    uint32_t U;
    struct _hw_usb_uh3_hwhost_bitfields
    {
        uint32_t HC : 1;               /*!< [0]  */
        uint32_t NPORT : 3;            /*!< [3:1]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_uh3_hwhost_t;

/*!
 * @name Constants and macros for entire USB_UH3_HWHOST register
 */
/*@{*/
#define HW_USB_UH3_HWHOST_ADDR(x) ((uintptr_t)(x) + 0x608U)

#define HW_USB_UH3_HWHOST(x)     (*(__I hw_usb_uh3_hwhost_t *) HW_USB_UH3_HWHOST_ADDR(x))
#define HW_USB_UH3_HWHOST_RD(x)  (HW_USB_UH3_HWHOST(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HWHOST bitfields
 */

/*!
 * @name Register USB_UH3_HWHOST, field HC[0] (RO)
 *
 * Host Capable. Indicating whether host operation mode is supported or not.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_USB_UH3_HWHOST_HC (0U)          /*!< Bit position for USB_UH3_HWHOST_HC. */
#define BM_USB_UH3_HWHOST_HC (0x00000001U) /*!< Bit mask for USB_UH3_HWHOST_HC. */
#define BS_USB_UH3_HWHOST_HC (1U)          /*!< Bit field size in bits for USB_UH3_HWHOST_HC. */

/*! @brief Read current value of the USB_UH3_HWHOST_HC field. */
#define BR_USB_UH3_HWHOST_HC(x) (HW_USB_UH3_HWHOST(x).B.HC)
/*@}*/

/*!
 * @name Register USB_UH3_HWHOST, field NPORT[3:1] (RO)
 *
 * The Nmber of downstream ports supported by the host controller is (NPORT+1).
 * When these bits value is '000', it indicates a single-port host controller.
 */
/*@{*/
#define BP_USB_UH3_HWHOST_NPORT (1U)       /*!< Bit position for USB_UH3_HWHOST_NPORT. */
#define BM_USB_UH3_HWHOST_NPORT (0x0000000EU) /*!< Bit mask for USB_UH3_HWHOST_NPORT. */
#define BS_USB_UH3_HWHOST_NPORT (3U)       /*!< Bit field size in bits for USB_UH3_HWHOST_NPORT. */

/*! @brief Read current value of the USB_UH3_HWHOST_NPORT field. */
#define BR_USB_UH3_HWHOST_NPORT(x) (HW_USB_UH3_HWHOST(x).B.NPORT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HWTXBUF - TX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HWTXBUF - TX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x80080B08U
 */
typedef union _hw_usb_uh3_hwtxbuf
{
    uint32_t U;
    struct _hw_usb_uh3_hwtxbuf_bitfields
    {
        uint32_t TXBURST : 8;          /*!< [7:0]  */
        uint32_t RESERVED0 : 8;        /*!< [15:8]  */
        uint32_t TXCHANADD : 8;        /*!< [23:16]  */
        uint32_t RESERVED1 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh3_hwtxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH3_HWTXBUF register
 */
/*@{*/
#define HW_USB_UH3_HWTXBUF_ADDR(x) ((uintptr_t)(x) + 0x610U)

#define HW_USB_UH3_HWTXBUF(x)    (*(__I hw_usb_uh3_hwtxbuf_t *) HW_USB_UH3_HWTXBUF_ADDR(x))
#define HW_USB_UH3_HWTXBUF_RD(x) (HW_USB_UH3_HWTXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HWTXBUF bitfields
 */

/*!
 * @name Register USB_UH3_HWTXBUF, field TXBURST[7:0] (RO)
 *
 * Default burst size for memory to TX buffer transfer. This is reset value of
 * TXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH3_HWTXBUF_TXBURST (0U)    /*!< Bit position for USB_UH3_HWTXBUF_TXBURST. */
#define BM_USB_UH3_HWTXBUF_TXBURST (0x000000FFU) /*!< Bit mask for USB_UH3_HWTXBUF_TXBURST. */
#define BS_USB_UH3_HWTXBUF_TXBURST (8U)    /*!< Bit field size in bits for USB_UH3_HWTXBUF_TXBURST. */

/*! @brief Read current value of the USB_UH3_HWTXBUF_TXBURST field. */
#define BR_USB_UH3_HWTXBUF_TXBURST(x) (HW_USB_UH3_HWTXBUF(x).B.TXBURST)
/*@}*/

/*!
 * @name Register USB_UH3_HWTXBUF, field TXCHANADD[23:16] (RO)
 *
 * TX FIFO Buffer size is: (2^TXCHANADD) * 4 Bytes. These bits are set to '08h',
 * so buffer size is 256*4 Bytes. For the OTG controller operating in device
 * mode, this is the FIFO buffer size per endpoint. As the OTG controller has 8 TX
 * endpoint, there are 8 of these buffers. For the OTG controller operating in
 * host mode, or for Host-only controller, the entire buffer memory is used as a
 * single TX buffer. Therefore, there is only 1 of this buffer
 */
/*@{*/
#define BP_USB_UH3_HWTXBUF_TXCHANADD (16U) /*!< Bit position for USB_UH3_HWTXBUF_TXCHANADD. */
#define BM_USB_UH3_HWTXBUF_TXCHANADD (0x00FF0000U) /*!< Bit mask for USB_UH3_HWTXBUF_TXCHANADD. */
#define BS_USB_UH3_HWTXBUF_TXCHANADD (8U)  /*!< Bit field size in bits for USB_UH3_HWTXBUF_TXCHANADD. */

/*! @brief Read current value of the USB_UH3_HWTXBUF_TXCHANADD field. */
#define BR_USB_UH3_HWTXBUF_TXCHANADD(x) (HW_USB_UH3_HWTXBUF(x).B.TXCHANADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HWRXBUF - RX Buffer Hardware Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HWRXBUF - RX Buffer Hardware Parameters (RO)
 *
 * Reset value: 0x00000808U
 */
typedef union _hw_usb_uh3_hwrxbuf
{
    uint32_t U;
    struct _hw_usb_uh3_hwrxbuf_bitfields
    {
        uint32_t RXBURST : 8;          /*!< [7:0]  */
        uint32_t RXADD : 8;            /*!< [15:8]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh3_hwrxbuf_t;

/*!
 * @name Constants and macros for entire USB_UH3_HWRXBUF register
 */
/*@{*/
#define HW_USB_UH3_HWRXBUF_ADDR(x) ((uintptr_t)(x) + 0x614U)

#define HW_USB_UH3_HWRXBUF(x)    (*(__I hw_usb_uh3_hwrxbuf_t *) HW_USB_UH3_HWRXBUF_ADDR(x))
#define HW_USB_UH3_HWRXBUF_RD(x) (HW_USB_UH3_HWRXBUF(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HWRXBUF bitfields
 */

/*!
 * @name Register USB_UH3_HWRXBUF, field RXBURST[7:0] (RO)
 *
 * Default burst size for memory to RX buffer transfer. This is reset value of
 * RXPBURST bits in USB core regsiter USB_n_BURSTSIZE. Please see
 * BURSTSIZEProgrammable Burst Size .
 */
/*@{*/
#define BP_USB_UH3_HWRXBUF_RXBURST (0U)    /*!< Bit position for USB_UH3_HWRXBUF_RXBURST. */
#define BM_USB_UH3_HWRXBUF_RXBURST (0x000000FFU) /*!< Bit mask for USB_UH3_HWRXBUF_RXBURST. */
#define BS_USB_UH3_HWRXBUF_RXBURST (8U)    /*!< Bit field size in bits for USB_UH3_HWRXBUF_RXBURST. */

/*! @brief Read current value of the USB_UH3_HWRXBUF_RXBURST field. */
#define BR_USB_UH3_HWRXBUF_RXBURST(x) (HW_USB_UH3_HWRXBUF(x).B.RXBURST)
/*@}*/

/*!
 * @name Register USB_UH3_HWRXBUF, field RXADD[15:8] (RO)
 *
 * Buffer total size for all receive endpoints is (2^RXADD). RX Buffer size is:
 * (2^RXADD) * 4 Bytes. These bits are set to '08h', so buffer size is 256*4
 * Bytes. There is a single Receive FIFO buffer in the USB controller. The buffer is
 * shared for all endpoints for the OTG controller in device mode.
 */
/*@{*/
#define BP_USB_UH3_HWRXBUF_RXADD (8U)      /*!< Bit position for USB_UH3_HWRXBUF_RXADD. */
#define BM_USB_UH3_HWRXBUF_RXADD (0x0000FF00U) /*!< Bit mask for USB_UH3_HWRXBUF_RXADD. */
#define BS_USB_UH3_HWRXBUF_RXADD (8U)      /*!< Bit field size in bits for USB_UH3_HWRXBUF_RXADD. */

/*! @brief Read current value of the USB_UH3_HWRXBUF_RXADD field. */
#define BR_USB_UH3_HWRXBUF_RXADD(x) (HW_USB_UH3_HWRXBUF(x).B.RXADD)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_GPTIMER0LD - General Purpose Timer #0 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_GPTIMER0LD - General Purpose Timer #0 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER0CTRL. Please see GPTIMER0CTRLGeneral Purpose Timer #0 Controller .
 */
typedef union _hw_usb_uh3_gptimer0ld
{
    uint32_t U;
    struct _hw_usb_uh3_gptimer0ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh3_gptimer0ld_t;

/*!
 * @name Constants and macros for entire USB_UH3_GPTIMER0LD register
 */
/*@{*/
#define HW_USB_UH3_GPTIMER0LD_ADDR(x) ((uintptr_t)(x) + 0x680U)

#define HW_USB_UH3_GPTIMER0LD(x) (*(__IO hw_usb_uh3_gptimer0ld_t *) HW_USB_UH3_GPTIMER0LD_ADDR(x))
#define HW_USB_UH3_GPTIMER0LD_RD(x) (HW_USB_UH3_GPTIMER0LD(x).U)
#define HW_USB_UH3_GPTIMER0LD_WR(x, v) (HW_USB_UH3_GPTIMER0LD(x).U = (v))
#define HW_USB_UH3_GPTIMER0LD_SET(x, v) (HW_USB_UH3_GPTIMER0LD_WR(x, HW_USB_UH3_GPTIMER0LD_RD(x) |  (v)))
#define HW_USB_UH3_GPTIMER0LD_CLR(x, v) (HW_USB_UH3_GPTIMER0LD_WR(x, HW_USB_UH3_GPTIMER0LD_RD(x) & ~(v)))
#define HW_USB_UH3_GPTIMER0LD_TOG(x, v) (HW_USB_UH3_GPTIMER0LD_WR(x, HW_USB_UH3_GPTIMER0LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_GPTIMER0LD bitfields
 */

/*!
 * @name Register USB_UH3_GPTIMER0LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH3_GPTIMER0LD_GPTLD (0U)   /*!< Bit position for USB_UH3_GPTIMER0LD_GPTLD. */
#define BM_USB_UH3_GPTIMER0LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH3_GPTIMER0LD_GPTLD. */
#define BS_USB_UH3_GPTIMER0LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH3_GPTIMER0LD_GPTLD. */

/*! @brief Read current value of the USB_UH3_GPTIMER0LD_GPTLD field. */
#define BR_USB_UH3_GPTIMER0LD_GPTLD(x) (HW_USB_UH3_GPTIMER0LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH3_GPTIMER0LD_GPTLD. */
#define BF_USB_UH3_GPTIMER0LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER0LD_GPTLD) & BM_USB_UH3_GPTIMER0LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH3_GPTIMER0LD_GPTLD(x, v) (HW_USB_UH3_GPTIMER0LD_WR(x, (HW_USB_UH3_GPTIMER0LD_RD(x) & ~BM_USB_UH3_GPTIMER0LD_GPTLD) | BF_USB_UH3_GPTIMER0LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_GPTIMER0CTRL - General Purpose Timer #0 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_GPTIMER0CTRL - General Purpose Timer #0 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI0 bit in n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE0 bit in n_USBINTR register. (See
 * USBINTRInterrupt Enable Register .)
 */
typedef union _hw_usb_uh3_gptimer0ctrl
{
    uint32_t U;
    struct _hw_usb_uh3_gptimer0ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh3_gptimer0ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH3_GPTIMER0CTRL register
 */
/*@{*/
#define HW_USB_UH3_GPTIMER0CTRL_ADDR(x) ((uintptr_t)(x) + 0x684U)

#define HW_USB_UH3_GPTIMER0CTRL(x) (*(__IO hw_usb_uh3_gptimer0ctrl_t *) HW_USB_UH3_GPTIMER0CTRL_ADDR(x))
#define HW_USB_UH3_GPTIMER0CTRL_RD(x) (HW_USB_UH3_GPTIMER0CTRL(x).U)
#define HW_USB_UH3_GPTIMER0CTRL_WR(x, v) (HW_USB_UH3_GPTIMER0CTRL(x).U = (v))
#define HW_USB_UH3_GPTIMER0CTRL_SET(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, HW_USB_UH3_GPTIMER0CTRL_RD(x) |  (v)))
#define HW_USB_UH3_GPTIMER0CTRL_CLR(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, HW_USB_UH3_GPTIMER0CTRL_RD(x) & ~(v)))
#define HW_USB_UH3_GPTIMER0CTRL_TOG(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, HW_USB_UH3_GPTIMER0CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_GPTIMER0CTRL bitfields
 */

/*!
 * @name Register USB_UH3_GPTIMER0CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH3_GPTIMER0CTRL_GPTCNT (0U) /*!< Bit position for USB_UH3_GPTIMER0CTRL_GPTCNT. */
#define BM_USB_UH3_GPTIMER0CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH3_GPTIMER0CTRL_GPTCNT. */
#define BS_USB_UH3_GPTIMER0CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH3_GPTIMER0CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH3_GPTIMER0CTRL_GPTCNT field. */
#define BR_USB_UH3_GPTIMER0CTRL_GPTCNT(x) (HW_USB_UH3_GPTIMER0CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH3_GPTIMER0CTRL_GPTCNT. */
#define BF_USB_UH3_GPTIMER0CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER0CTRL_GPTCNT) & BM_USB_UH3_GPTIMER0CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH3_GPTIMER0CTRL_GPTCNT(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, (HW_USB_UH3_GPTIMER0CTRL_RD(x) & ~BM_USB_UH3_GPTIMER0CTRL_GPTCNT) | BF_USB_UH3_GPTIMER0CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER0CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software; In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH3_GPTIMER0CTRL_GPTMODE (24U) /*!< Bit position for USB_UH3_GPTIMER0CTRL_GPTMODE. */
#define BM_USB_UH3_GPTIMER0CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH3_GPTIMER0CTRL_GPTMODE. */
#define BS_USB_UH3_GPTIMER0CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER0CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH3_GPTIMER0CTRL_GPTMODE field. */
#define BR_USB_UH3_GPTIMER0CTRL_GPTMODE(x) (HW_USB_UH3_GPTIMER0CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH3_GPTIMER0CTRL_GPTMODE. */
#define BF_USB_UH3_GPTIMER0CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER0CTRL_GPTMODE) & BM_USB_UH3_GPTIMER0CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH3_GPTIMER0CTRL_GPTMODE(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, (HW_USB_UH3_GPTIMER0CTRL_RD(x) & ~BM_USB_UH3_GPTIMER0CTRL_GPTMODE) | BF_USB_UH3_GPTIMER0CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER0CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH3_GPTIMER0CTRL_GPTRST (30U) /*!< Bit position for USB_UH3_GPTIMER0CTRL_GPTRST. */
#define BM_USB_UH3_GPTIMER0CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH3_GPTIMER0CTRL_GPTRST. */
#define BS_USB_UH3_GPTIMER0CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER0CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH3_GPTIMER0CTRL_GPTRST field. */
#define BR_USB_UH3_GPTIMER0CTRL_GPTRST(x) (HW_USB_UH3_GPTIMER0CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH3_GPTIMER0CTRL_GPTRST. */
#define BF_USB_UH3_GPTIMER0CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER0CTRL_GPTRST) & BM_USB_UH3_GPTIMER0CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH3_GPTIMER0CTRL_GPTRST(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, (HW_USB_UH3_GPTIMER0CTRL_RD(x) & ~BM_USB_UH3_GPTIMER0CTRL_GPTRST) | BF_USB_UH3_GPTIMER0CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER0CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH3_GPTIMER0CTRL_GPTRUN (31U) /*!< Bit position for USB_UH3_GPTIMER0CTRL_GPTRUN. */
#define BM_USB_UH3_GPTIMER0CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH3_GPTIMER0CTRL_GPTRUN. */
#define BS_USB_UH3_GPTIMER0CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER0CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH3_GPTIMER0CTRL_GPTRUN field. */
#define BR_USB_UH3_GPTIMER0CTRL_GPTRUN(x) (HW_USB_UH3_GPTIMER0CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH3_GPTIMER0CTRL_GPTRUN. */
#define BF_USB_UH3_GPTIMER0CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER0CTRL_GPTRUN) & BM_USB_UH3_GPTIMER0CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH3_GPTIMER0CTRL_GPTRUN(x, v) (HW_USB_UH3_GPTIMER0CTRL_WR(x, (HW_USB_UH3_GPTIMER0CTRL_RD(x) & ~BM_USB_UH3_GPTIMER0CTRL_GPTRUN) | BF_USB_UH3_GPTIMER0CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_GPTIMER1LD - General Purpose Timer #1 Load
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_GPTIMER1LD - General Purpose Timer #1 Load (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register controls load value of the count timer in register
 * n_GPTIMER1CTRL. Please see GPTIMER1CTRLGeneral Purpose Timer #1 Controller .
 */
typedef union _hw_usb_uh3_gptimer1ld
{
    uint32_t U;
    struct _hw_usb_uh3_gptimer1ld_bitfields
    {
        uint32_t GPTLD : 24;           /*!< [23:0]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh3_gptimer1ld_t;

/*!
 * @name Constants and macros for entire USB_UH3_GPTIMER1LD register
 */
/*@{*/
#define HW_USB_UH3_GPTIMER1LD_ADDR(x) ((uintptr_t)(x) + 0x688U)

#define HW_USB_UH3_GPTIMER1LD(x) (*(__IO hw_usb_uh3_gptimer1ld_t *) HW_USB_UH3_GPTIMER1LD_ADDR(x))
#define HW_USB_UH3_GPTIMER1LD_RD(x) (HW_USB_UH3_GPTIMER1LD(x).U)
#define HW_USB_UH3_GPTIMER1LD_WR(x, v) (HW_USB_UH3_GPTIMER1LD(x).U = (v))
#define HW_USB_UH3_GPTIMER1LD_SET(x, v) (HW_USB_UH3_GPTIMER1LD_WR(x, HW_USB_UH3_GPTIMER1LD_RD(x) |  (v)))
#define HW_USB_UH3_GPTIMER1LD_CLR(x, v) (HW_USB_UH3_GPTIMER1LD_WR(x, HW_USB_UH3_GPTIMER1LD_RD(x) & ~(v)))
#define HW_USB_UH3_GPTIMER1LD_TOG(x, v) (HW_USB_UH3_GPTIMER1LD_WR(x, HW_USB_UH3_GPTIMER1LD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_GPTIMER1LD bitfields
 */

/*!
 * @name Register USB_UH3_GPTIMER1LD, field GPTLD[23:0] (RW)
 *
 * General Purpose Timer Load Value These bit fields are loaded to GPTCNT bits
 * when GPTRST bit is set '1b'. This value represents the time in microseconds
 * minus 1 for the timer duration. Example: for a one millisecond timer, load
 * 1000-1=999 or 0x0003E7. Max value is 0xFFFFFF or 16.777215 seconds.
 */
/*@{*/
#define BP_USB_UH3_GPTIMER1LD_GPTLD (0U)   /*!< Bit position for USB_UH3_GPTIMER1LD_GPTLD. */
#define BM_USB_UH3_GPTIMER1LD_GPTLD (0x00FFFFFFU) /*!< Bit mask for USB_UH3_GPTIMER1LD_GPTLD. */
#define BS_USB_UH3_GPTIMER1LD_GPTLD (24U)  /*!< Bit field size in bits for USB_UH3_GPTIMER1LD_GPTLD. */

/*! @brief Read current value of the USB_UH3_GPTIMER1LD_GPTLD field. */
#define BR_USB_UH3_GPTIMER1LD_GPTLD(x) (HW_USB_UH3_GPTIMER1LD(x).B.GPTLD)

/*! @brief Format value for bitfield USB_UH3_GPTIMER1LD_GPTLD. */
#define BF_USB_UH3_GPTIMER1LD_GPTLD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER1LD_GPTLD) & BM_USB_UH3_GPTIMER1LD_GPTLD)

/*! @brief Set the GPTLD field to a new value. */
#define BW_USB_UH3_GPTIMER1LD_GPTLD(x, v) (HW_USB_UH3_GPTIMER1LD_WR(x, (HW_USB_UH3_GPTIMER1LD_RD(x) & ~BM_USB_UH3_GPTIMER1LD_GPTLD) | BF_USB_UH3_GPTIMER1LD_GPTLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_GPTIMER1CTRL - General Purpose Timer #1 Controller
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_GPTIMER1CTRL - General Purpose Timer #1 Controller (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the control for this countdown timer and a data field
 * can be queried to determine the running count value. This timer has
 * granularity on 1 us and can be programmed to a little over 16 seconds. There are two
 * counter modes which are described in the register table below. When the timer
 * counter value transitions to zero, an interrupt could be generated if enable.
 * Interrupt status bit is TI1 bit in USB_n_USBSTS register (See USBSTSUSB Status
 * Register ), interrupt enable bit is TIE1 bit in n_USBINTR register (See
 * USBINTRInterrupt Enable Register ).
 */
typedef union _hw_usb_uh3_gptimer1ctrl
{
    uint32_t U;
    struct _hw_usb_uh3_gptimer1ctrl_bitfields
    {
        uint32_t GPTCNT : 24;          /*!< [23:0]  */
        uint32_t GPTMODE : 1;          /*!< [24]  */
        uint32_t RESERVED0 : 5;        /*!< [29:25]  */
        uint32_t GPTRST : 1;           /*!< [30]  */
        uint32_t GPTRUN : 1;           /*!< [31]  */
    } B;
} hw_usb_uh3_gptimer1ctrl_t;

/*!
 * @name Constants and macros for entire USB_UH3_GPTIMER1CTRL register
 */
/*@{*/
#define HW_USB_UH3_GPTIMER1CTRL_ADDR(x) ((uintptr_t)(x) + 0x68CU)

#define HW_USB_UH3_GPTIMER1CTRL(x) (*(__IO hw_usb_uh3_gptimer1ctrl_t *) HW_USB_UH3_GPTIMER1CTRL_ADDR(x))
#define HW_USB_UH3_GPTIMER1CTRL_RD(x) (HW_USB_UH3_GPTIMER1CTRL(x).U)
#define HW_USB_UH3_GPTIMER1CTRL_WR(x, v) (HW_USB_UH3_GPTIMER1CTRL(x).U = (v))
#define HW_USB_UH3_GPTIMER1CTRL_SET(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, HW_USB_UH3_GPTIMER1CTRL_RD(x) |  (v)))
#define HW_USB_UH3_GPTIMER1CTRL_CLR(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, HW_USB_UH3_GPTIMER1CTRL_RD(x) & ~(v)))
#define HW_USB_UH3_GPTIMER1CTRL_TOG(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, HW_USB_UH3_GPTIMER1CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_GPTIMER1CTRL bitfields
 */

/*!
 * @name Register USB_UH3_GPTIMER1CTRL, field GPTCNT[23:0] (RW)
 *
 * General Purpose Timer Counter. This field is the count value of the countdown
 * timer.
 */
/*@{*/
#define BP_USB_UH3_GPTIMER1CTRL_GPTCNT (0U) /*!< Bit position for USB_UH3_GPTIMER1CTRL_GPTCNT. */
#define BM_USB_UH3_GPTIMER1CTRL_GPTCNT (0x00FFFFFFU) /*!< Bit mask for USB_UH3_GPTIMER1CTRL_GPTCNT. */
#define BS_USB_UH3_GPTIMER1CTRL_GPTCNT (24U) /*!< Bit field size in bits for USB_UH3_GPTIMER1CTRL_GPTCNT. */

/*! @brief Read current value of the USB_UH3_GPTIMER1CTRL_GPTCNT field. */
#define BR_USB_UH3_GPTIMER1CTRL_GPTCNT(x) (HW_USB_UH3_GPTIMER1CTRL(x).B.GPTCNT)

/*! @brief Format value for bitfield USB_UH3_GPTIMER1CTRL_GPTCNT. */
#define BF_USB_UH3_GPTIMER1CTRL_GPTCNT(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER1CTRL_GPTCNT) & BM_USB_UH3_GPTIMER1CTRL_GPTCNT)

/*! @brief Set the GPTCNT field to a new value. */
#define BW_USB_UH3_GPTIMER1CTRL_GPTCNT(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, (HW_USB_UH3_GPTIMER1CTRL_RD(x) & ~BM_USB_UH3_GPTIMER1CTRL_GPTCNT) | BF_USB_UH3_GPTIMER1CTRL_GPTCNT(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER1CTRL, field GPTMODE[24] (RW)
 *
 * General Purpose Timer Mode In one shot mode, the timer will count down to
 * zero, generate an interrupt, and stop until the counter is reset by software. In
 * repeat mode, the timer will count down to zero, generate an interrupt and
 * automatically reload the counter value from GPTLD bits to start again.
 *
 * Values:
 * - 0 - One Shot Mode
 * - 1 - Repeat Mode
 */
/*@{*/
#define BP_USB_UH3_GPTIMER1CTRL_GPTMODE (24U) /*!< Bit position for USB_UH3_GPTIMER1CTRL_GPTMODE. */
#define BM_USB_UH3_GPTIMER1CTRL_GPTMODE (0x01000000U) /*!< Bit mask for USB_UH3_GPTIMER1CTRL_GPTMODE. */
#define BS_USB_UH3_GPTIMER1CTRL_GPTMODE (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER1CTRL_GPTMODE. */

/*! @brief Read current value of the USB_UH3_GPTIMER1CTRL_GPTMODE field. */
#define BR_USB_UH3_GPTIMER1CTRL_GPTMODE(x) (HW_USB_UH3_GPTIMER1CTRL(x).B.GPTMODE)

/*! @brief Format value for bitfield USB_UH3_GPTIMER1CTRL_GPTMODE. */
#define BF_USB_UH3_GPTIMER1CTRL_GPTMODE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER1CTRL_GPTMODE) & BM_USB_UH3_GPTIMER1CTRL_GPTMODE)

/*! @brief Set the GPTMODE field to a new value. */
#define BW_USB_UH3_GPTIMER1CTRL_GPTMODE(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, (HW_USB_UH3_GPTIMER1CTRL_RD(x) & ~BM_USB_UH3_GPTIMER1CTRL_GPTMODE) | BF_USB_UH3_GPTIMER1CTRL_GPTMODE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER1CTRL, field GPTRST[30] (RW)
 *
 * General Purpose Timer Reset
 *
 * Values:
 * - 0 - No action
 * - 1 - Load counter value from GPTLD bits in USB_n_GPTIMER0LD
 */
/*@{*/
#define BP_USB_UH3_GPTIMER1CTRL_GPTRST (30U) /*!< Bit position for USB_UH3_GPTIMER1CTRL_GPTRST. */
#define BM_USB_UH3_GPTIMER1CTRL_GPTRST (0x40000000U) /*!< Bit mask for USB_UH3_GPTIMER1CTRL_GPTRST. */
#define BS_USB_UH3_GPTIMER1CTRL_GPTRST (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER1CTRL_GPTRST. */

/*! @brief Read current value of the USB_UH3_GPTIMER1CTRL_GPTRST field. */
#define BR_USB_UH3_GPTIMER1CTRL_GPTRST(x) (HW_USB_UH3_GPTIMER1CTRL(x).B.GPTRST)

/*! @brief Format value for bitfield USB_UH3_GPTIMER1CTRL_GPTRST. */
#define BF_USB_UH3_GPTIMER1CTRL_GPTRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER1CTRL_GPTRST) & BM_USB_UH3_GPTIMER1CTRL_GPTRST)

/*! @brief Set the GPTRST field to a new value. */
#define BW_USB_UH3_GPTIMER1CTRL_GPTRST(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, (HW_USB_UH3_GPTIMER1CTRL_RD(x) & ~BM_USB_UH3_GPTIMER1CTRL_GPTRST) | BF_USB_UH3_GPTIMER1CTRL_GPTRST(v)))
/*@}*/

/*!
 * @name Register USB_UH3_GPTIMER1CTRL, field GPTRUN[31] (RW)
 *
 * General Purpose Timer Run GPTCNT bits are not effected when setting or
 * clearing this bit.
 *
 * Values:
 * - 0 - Stop counting
 * - 1 - Run
 */
/*@{*/
#define BP_USB_UH3_GPTIMER1CTRL_GPTRUN (31U) /*!< Bit position for USB_UH3_GPTIMER1CTRL_GPTRUN. */
#define BM_USB_UH3_GPTIMER1CTRL_GPTRUN (0x80000000U) /*!< Bit mask for USB_UH3_GPTIMER1CTRL_GPTRUN. */
#define BS_USB_UH3_GPTIMER1CTRL_GPTRUN (1U) /*!< Bit field size in bits for USB_UH3_GPTIMER1CTRL_GPTRUN. */

/*! @brief Read current value of the USB_UH3_GPTIMER1CTRL_GPTRUN field. */
#define BR_USB_UH3_GPTIMER1CTRL_GPTRUN(x) (HW_USB_UH3_GPTIMER1CTRL(x).B.GPTRUN)

/*! @brief Format value for bitfield USB_UH3_GPTIMER1CTRL_GPTRUN. */
#define BF_USB_UH3_GPTIMER1CTRL_GPTRUN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_GPTIMER1CTRL_GPTRUN) & BM_USB_UH3_GPTIMER1CTRL_GPTRUN)

/*! @brief Set the GPTRUN field to a new value. */
#define BW_USB_UH3_GPTIMER1CTRL_GPTRUN(x, v) (HW_USB_UH3_GPTIMER1CTRL_WR(x, (HW_USB_UH3_GPTIMER1CTRL_RD(x) & ~BM_USB_UH3_GPTIMER1CTRL_GPTRUN) | BF_USB_UH3_GPTIMER1CTRL_GPTRUN(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_SBUSCFG - System Bus Config
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_SBUSCFG - System Bus Config (RW)
 *
 * Reset value: 0x00000002U
 */
typedef union _hw_usb_uh3_sbuscfg
{
    uint32_t U;
    struct _hw_usb_uh3_sbuscfg_bitfields
    {
        uint32_t AHBBRST : 3;          /*!< [2:0]  */
        uint32_t RESERVED0 : 29;       /*!< [31:3]  */
    } B;
} hw_usb_uh3_sbuscfg_t;

/*!
 * @name Constants and macros for entire USB_UH3_SBUSCFG register
 */
/*@{*/
#define HW_USB_UH3_SBUSCFG_ADDR(x) ((uintptr_t)(x) + 0x690U)

#define HW_USB_UH3_SBUSCFG(x)    (*(__IO hw_usb_uh3_sbuscfg_t *) HW_USB_UH3_SBUSCFG_ADDR(x))
#define HW_USB_UH3_SBUSCFG_RD(x) (HW_USB_UH3_SBUSCFG(x).U)
#define HW_USB_UH3_SBUSCFG_WR(x, v) (HW_USB_UH3_SBUSCFG(x).U = (v))
#define HW_USB_UH3_SBUSCFG_SET(x, v) (HW_USB_UH3_SBUSCFG_WR(x, HW_USB_UH3_SBUSCFG_RD(x) |  (v)))
#define HW_USB_UH3_SBUSCFG_CLR(x, v) (HW_USB_UH3_SBUSCFG_WR(x, HW_USB_UH3_SBUSCFG_RD(x) & ~(v)))
#define HW_USB_UH3_SBUSCFG_TOG(x, v) (HW_USB_UH3_SBUSCFG_WR(x, HW_USB_UH3_SBUSCFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_SBUSCFG bitfields
 */

/*!
 * @name Register USB_UH3_SBUSCFG, field AHBBRST[2:0] (RW)
 *
 * AHB master interface Burst configuration These bits control AHB master
 * transfer type sequence (or priority). This register overrides n_BURSTSIZE register
 * when its value is not zero.
 *
 * Values:
 * - 000 - Incremental burst of unspecified length only
 * - 001 - INCR4 burst, then single transfer
 * - 010 - INCR8 burst, INCR4 burst, then single transfer
 * - 011 - INCR16 burst, INCR8 burst, INCR4 burst, then single transfer
 * - 100 - Reserved, don't use
 * - 101 - INCR4 burst, then incremental burst of unspecified length
 * - 110 - INCR8 burst, INCR4 burst, then incremental burst of unspecified length
 * - 111 - INCR16 burst, INCR8 burst, INCR4 burst, then incremental burst of
 *     unspecified length
 */
/*@{*/
#define BP_USB_UH3_SBUSCFG_AHBBRST (0U)    /*!< Bit position for USB_UH3_SBUSCFG_AHBBRST. */
#define BM_USB_UH3_SBUSCFG_AHBBRST (0x00000007U) /*!< Bit mask for USB_UH3_SBUSCFG_AHBBRST. */
#define BS_USB_UH3_SBUSCFG_AHBBRST (3U)    /*!< Bit field size in bits for USB_UH3_SBUSCFG_AHBBRST. */

/*! @brief Read current value of the USB_UH3_SBUSCFG_AHBBRST field. */
#define BR_USB_UH3_SBUSCFG_AHBBRST(x) (HW_USB_UH3_SBUSCFG(x).B.AHBBRST)

/*! @brief Format value for bitfield USB_UH3_SBUSCFG_AHBBRST. */
#define BF_USB_UH3_SBUSCFG_AHBBRST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_SBUSCFG_AHBBRST) & BM_USB_UH3_SBUSCFG_AHBBRST)

/*! @brief Set the AHBBRST field to a new value. */
#define BW_USB_UH3_SBUSCFG_AHBBRST(x, v) (HW_USB_UH3_SBUSCFG_WR(x, (HW_USB_UH3_SBUSCFG_RD(x) & ~BM_USB_UH3_SBUSCFG_AHBBRST) | BF_USB_UH3_SBUSCFG_AHBBRST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_CAPLENGTH - Capability Registers Length
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_CAPLENGTH - Capability Registers Length (RO)
 *
 * Reset value: 0x40U
 *
 * The Capability Registers Length register contains the address offset to the
 * Operational registers relative to the CAPLENGTH register.
 */
typedef union _hw_usb_uh3_caplength
{
    uint8_t U;
    struct _hw_usb_uh3_caplength_bitfields
    {
        uint8_t CAPLENGTH : 8;         /*!< [7:0]  */
    } B;
} hw_usb_uh3_caplength_t;

/*!
 * @name Constants and macros for entire USB_UH3_CAPLENGTH register
 */
/*@{*/
#define HW_USB_UH3_CAPLENGTH_ADDR(x) ((uintptr_t)(x) + 0x700U)

#define HW_USB_UH3_CAPLENGTH(x)  (*(__I hw_usb_uh3_caplength_t *) HW_USB_UH3_CAPLENGTH_ADDR(x))
#define HW_USB_UH3_CAPLENGTH_RD(x) (HW_USB_UH3_CAPLENGTH(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_CAPLENGTH bitfields
 */

/*!
 * @name Register USB_UH3_CAPLENGTH, field CAPLENGTH[7:0] (RO)
 *
 * These bits are used as an offset to add to register base to find the
 * beginning of the Operational Register. Default value is '40h'.
 */
/*@{*/
#define BP_USB_UH3_CAPLENGTH_CAPLENGTH (0U) /*!< Bit position for USB_UH3_CAPLENGTH_CAPLENGTH. */
#define BM_USB_UH3_CAPLENGTH_CAPLENGTH (0xFFU) /*!< Bit mask for USB_UH3_CAPLENGTH_CAPLENGTH. */
#define BS_USB_UH3_CAPLENGTH_CAPLENGTH (8U) /*!< Bit field size in bits for USB_UH3_CAPLENGTH_CAPLENGTH. */

/*! @brief Read current value of the USB_UH3_CAPLENGTH_CAPLENGTH field. */
#define BR_USB_UH3_CAPLENGTH_CAPLENGTH(x) (HW_USB_UH3_CAPLENGTH(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HCIVERSION - Host Controller Interface Version
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HCIVERSION - Host Controller Interface Version (RO)
 *
 * Reset value: 0x0100U
 *
 * This is a 2-byte register containing a BCD encoding of the EHCI revision
 * number supported by this host controller. The most significant byte of this
 * register represents a major revision and the least significant byte is the minor
 * revision.
 */
typedef union _hw_usb_uh3_hciversion
{
    uint16_t U;
    struct _hw_usb_uh3_hciversion_bitfields
    {
        uint16_t HCIVERSION : 16;      /*!< [15:0]  */
    } B;
} hw_usb_uh3_hciversion_t;

/*!
 * @name Constants and macros for entire USB_UH3_HCIVERSION register
 */
/*@{*/
#define HW_USB_UH3_HCIVERSION_ADDR(x) ((uintptr_t)(x) + 0x702U)

#define HW_USB_UH3_HCIVERSION(x) (*(__I hw_usb_uh3_hciversion_t *) HW_USB_UH3_HCIVERSION_ADDR(x))
#define HW_USB_UH3_HCIVERSION_RD(x) (HW_USB_UH3_HCIVERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HCIVERSION bitfields
 */

/*!
 * @name Register USB_UH3_HCIVERSION, field HCIVERSION[15:0] (RO)
 *
 * Host Controller Interface Version Number Default value is '10h', which means
 * EHCI rev1.0.
 */
/*@{*/
#define BP_USB_UH3_HCIVERSION_HCIVERSION (0U) /*!< Bit position for USB_UH3_HCIVERSION_HCIVERSION. */
#define BM_USB_UH3_HCIVERSION_HCIVERSION (0xFFFFU) /*!< Bit mask for USB_UH3_HCIVERSION_HCIVERSION. */
#define BS_USB_UH3_HCIVERSION_HCIVERSION (16U) /*!< Bit field size in bits for USB_UH3_HCIVERSION_HCIVERSION. */

/*! @brief Read current value of the USB_UH3_HCIVERSION_HCIVERSION field. */
#define BR_USB_UH3_HCIVERSION_HCIVERSION(x) (HW_USB_UH3_HCIVERSION(x).U)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HCSPARAMS - Host Controller Structural Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HCSPARAMS - Host Controller Structural Parameters (RO)
 *
 * Reset value: 0x00010011U
 *
 * The following figure shows the port steering logic capabilities of Host
 * Control Structural Parameters (n_HCSPARAMS).
 */
typedef union _hw_usb_uh3_hcsparams
{
    uint32_t U;
    struct _hw_usb_uh3_hcsparams_bitfields
    {
        uint32_t N_PORTS : 4;          /*!< [3:0]  */
        uint32_t PPC : 1;              /*!< [4]  */
        uint32_t RESERVED0 : 3;        /*!< [7:5]  */
        uint32_t N_PCC : 4;            /*!< [11:8]  */
        uint32_t N_CC : 4;             /*!< [15:12]  */
        uint32_t PI : 1;               /*!< [16]  */
        uint32_t RESERVED1 : 3;        /*!< [19:17]  */
        uint32_t N_PTT : 4;            /*!< [23:20]  */
        uint32_t N_TT : 4;             /*!< [27:24]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_uh3_hcsparams_t;

/*!
 * @name Constants and macros for entire USB_UH3_HCSPARAMS register
 */
/*@{*/
#define HW_USB_UH3_HCSPARAMS_ADDR(x) ((uintptr_t)(x) + 0x704U)

#define HW_USB_UH3_HCSPARAMS(x)  (*(__I hw_usb_uh3_hcsparams_t *) HW_USB_UH3_HCSPARAMS_ADDR(x))
#define HW_USB_UH3_HCSPARAMS_RD(x) (HW_USB_UH3_HCSPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HCSPARAMS bitfields
 */

/*!
 * @name Register USB_UH3_HCSPARAMS, field N_PORTS[3:0] (RO)
 *
 * Number of downstream ports. This field specifies the number of physical
 * downstream ports implemented on this host controller. The value of this field
 * determines how many port registers are addressable in the Operational Register.
 * Valid values are in the range of 1h to Fh. A zero in this field is undefined.
 * These bits are always set to '0001b' because all controller cores are Single-Port
 * Host.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_N_PORTS (0U)  /*!< Bit position for USB_UH3_HCSPARAMS_N_PORTS. */
#define BM_USB_UH3_HCSPARAMS_N_PORTS (0x0000000FU) /*!< Bit mask for USB_UH3_HCSPARAMS_N_PORTS. */
#define BS_USB_UH3_HCSPARAMS_N_PORTS (4U)  /*!< Bit field size in bits for USB_UH3_HCSPARAMS_N_PORTS. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_N_PORTS field. */
#define BR_USB_UH3_HCSPARAMS_N_PORTS(x) (HW_USB_UH3_HCSPARAMS(x).B.N_PORTS)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field PPC[4] (RO)
 *
 * Port Power Control This field indicates whether the host controller
 * implementation includes port power control. A one indicates the ports have port power
 * switches. A zero indicates the ports do not have port power switches. The value
 * of this field affects the functionality of the Port Power field in each port
 * status and control register
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_PPC (4U)      /*!< Bit position for USB_UH3_HCSPARAMS_PPC. */
#define BM_USB_UH3_HCSPARAMS_PPC (0x00000010U) /*!< Bit mask for USB_UH3_HCSPARAMS_PPC. */
#define BS_USB_UH3_HCSPARAMS_PPC (1U)      /*!< Bit field size in bits for USB_UH3_HCSPARAMS_PPC. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_PPC field. */
#define BR_USB_UH3_HCSPARAMS_PPC(x) (HW_USB_UH3_HCSPARAMS(x).B.PPC)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field N_PCC[11:8] (RO)
 *
 * Number of Ports per Companion Controller This field indicates the number of
 * ports supported per internal Companion Controller. It is used to indicate the
 * port routing configuration to the system software. For example, if N_PORTS has
 * a value of 6 and N_CC has a value of 2 then N_PCC could have a value of 3. The
 * convention is that the first N_PCC ports are assumed to be routed to
 * companion controller 1, the next N_PCC ports to companion controller 2, etc. In the
 * previous example, the N_PCC could have been 4, where the first 4 are routed to
 * companion controller 1 and the last two are routed to companion controller 2.
 * The number in this field must be consistent with N_PORTS and N_CC. These bits
 * are '0000b' in all controller core.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_N_PCC (8U)    /*!< Bit position for USB_UH3_HCSPARAMS_N_PCC. */
#define BM_USB_UH3_HCSPARAMS_N_PCC (0x00000F00U) /*!< Bit mask for USB_UH3_HCSPARAMS_N_PCC. */
#define BS_USB_UH3_HCSPARAMS_N_PCC (4U)    /*!< Bit field size in bits for USB_UH3_HCSPARAMS_N_PCC. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_N_PCC field. */
#define BR_USB_UH3_HCSPARAMS_N_PCC(x) (HW_USB_UH3_HCSPARAMS(x).B.N_PCC)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field N_CC[15:12] (RO)
 *
 * Number of Companion Controller (N_CC). This field indicates the number of
 * companion controllers associated with this USB2.0 host controller. These bits are
 * '0000b' in all controller core.
 *
 * Values:
 * - 0 - There is no internal Companion Controller and port-ownership hand-off
 *     is not supported.
 * - 1 - There are internal companion controller(s) and port-ownership hand-offs
 *     is supported.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_N_CC (12U)    /*!< Bit position for USB_UH3_HCSPARAMS_N_CC. */
#define BM_USB_UH3_HCSPARAMS_N_CC (0x0000F000U) /*!< Bit mask for USB_UH3_HCSPARAMS_N_CC. */
#define BS_USB_UH3_HCSPARAMS_N_CC (4U)     /*!< Bit field size in bits for USB_UH3_HCSPARAMS_N_CC. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_N_CC field. */
#define BR_USB_UH3_HCSPARAMS_N_CC(x) (HW_USB_UH3_HCSPARAMS(x).B.N_CC)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field PI[16] (RO)
 *
 * Port Indicators (P INDICATOR) This bit indicates whether the ports support
 * port indicator control. When set to one, the port status and control registers
 * include a read/writeable field for controlling the state of the port indicator
 * This bit is "1b" in all controller core.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_PI (16U)      /*!< Bit position for USB_UH3_HCSPARAMS_PI. */
#define BM_USB_UH3_HCSPARAMS_PI (0x00010000U) /*!< Bit mask for USB_UH3_HCSPARAMS_PI. */
#define BS_USB_UH3_HCSPARAMS_PI (1U)       /*!< Bit field size in bits for USB_UH3_HCSPARAMS_PI. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_PI field. */
#define BR_USB_UH3_HCSPARAMS_PI(x) (HW_USB_UH3_HCSPARAMS(x).B.PI)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field N_PTT[23:20] (RO)
 *
 * Number of Ports per Transaction Translator (N_PTT). Default value '0000b'
 * This field indicates the number of ports assigned to each transaction translator
 * within the USB2.0 host controller. These bits would be set to equal N_PORTS
 * for Multi-Port Host, and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_N_PTT (20U)   /*!< Bit position for USB_UH3_HCSPARAMS_N_PTT. */
#define BM_USB_UH3_HCSPARAMS_N_PTT (0x00F00000U) /*!< Bit mask for USB_UH3_HCSPARAMS_N_PTT. */
#define BS_USB_UH3_HCSPARAMS_N_PTT (4U)    /*!< Bit field size in bits for USB_UH3_HCSPARAMS_N_PTT. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_N_PTT field. */
#define BR_USB_UH3_HCSPARAMS_N_PTT(x) (HW_USB_UH3_HCSPARAMS(x).B.N_PTT)
/*@}*/

/*!
 * @name Register USB_UH3_HCSPARAMS, field N_TT[27:24] (RO)
 *
 * Number of Transaction Translators (N_TT). Default value '0000b' This field
 * indicates the number of embedded transaction translators associated with the
 * USB2.0 host controller. These bits would be set to '0001b' for Multi-Port Host,
 * and '0000b' for Single-Port Host.
 */
/*@{*/
#define BP_USB_UH3_HCSPARAMS_N_TT (24U)    /*!< Bit position for USB_UH3_HCSPARAMS_N_TT. */
#define BM_USB_UH3_HCSPARAMS_N_TT (0x0F000000U) /*!< Bit mask for USB_UH3_HCSPARAMS_N_TT. */
#define BS_USB_UH3_HCSPARAMS_N_TT (4U)     /*!< Bit field size in bits for USB_UH3_HCSPARAMS_N_TT. */

/*! @brief Read current value of the USB_UH3_HCSPARAMS_N_TT field. */
#define BR_USB_UH3_HCSPARAMS_N_TT(x) (HW_USB_UH3_HCSPARAMS(x).B.N_TT)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_HCCPARAMS - Host Controller Capability Parameters
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_HCCPARAMS - Host Controller Capability Parameters (RO)
 *
 * Reset value: 0x00000006U
 *
 * This register identifies multiple mode control (time-base bit functionality),
 * addressing capability.
 */
typedef union _hw_usb_uh3_hccparams
{
    uint32_t U;
    struct _hw_usb_uh3_hccparams_bitfields
    {
        uint32_t ADC : 1;              /*!< [0]  */
        uint32_t PFL : 1;              /*!< [1]  */
        uint32_t ASP : 1;              /*!< [2]  */
        uint32_t RESERVED0 : 1;        /*!< [3]  */
        uint32_t IST : 4;              /*!< [7:4]  */
        uint32_t EECP : 8;             /*!< [15:8]  */
        uint32_t RESERVED1 : 16;       /*!< [31:16]  */
    } B;
} hw_usb_uh3_hccparams_t;

/*!
 * @name Constants and macros for entire USB_UH3_HCCPARAMS register
 */
/*@{*/
#define HW_USB_UH3_HCCPARAMS_ADDR(x) ((uintptr_t)(x) + 0x708U)

#define HW_USB_UH3_HCCPARAMS(x)  (*(__I hw_usb_uh3_hccparams_t *) HW_USB_UH3_HCCPARAMS_ADDR(x))
#define HW_USB_UH3_HCCPARAMS_RD(x) (HW_USB_UH3_HCCPARAMS(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_HCCPARAMS bitfields
 */

/*!
 * @name Register USB_UH3_HCCPARAMS, field ADC[0] (RO)
 *
 * 64-bit Addressing Capability This bit is set '0b' in all controller core, no
 * 64-bit addressing capability is supported.
 */
/*@{*/
#define BP_USB_UH3_HCCPARAMS_ADC (0U)      /*!< Bit position for USB_UH3_HCCPARAMS_ADC. */
#define BM_USB_UH3_HCCPARAMS_ADC (0x00000001U) /*!< Bit mask for USB_UH3_HCCPARAMS_ADC. */
#define BS_USB_UH3_HCCPARAMS_ADC (1U)      /*!< Bit field size in bits for USB_UH3_HCCPARAMS_ADC. */

/*! @brief Read current value of the USB_UH3_HCCPARAMS_ADC field. */
#define BR_USB_UH3_HCCPARAMS_ADC(x) (HW_USB_UH3_HCCPARAMS(x).B.ADC)
/*@}*/

/*!
 * @name Register USB_UH3_HCCPARAMS, field PFL[1] (RO)
 *
 * Programmable Frame List Flag If this bit is set to zero, then the system
 * software must use a frame list length of 1024 elements with this host controller.
 * The USBCMD register Frame List Size field is a read-only register and must be
 * set to zero. If set to a one, then the system software can specify and use a
 * smaller frame list and configure the host controller via the USBCMD register
 * Frame List Size field. The frame list must always be aligned on a 4K-page
 * boundary. This requirement ensures that the frame list is always physically
 * contiguous. This bit is set '1b' in all controller core.
 */
/*@{*/
#define BP_USB_UH3_HCCPARAMS_PFL (1U)      /*!< Bit position for USB_UH3_HCCPARAMS_PFL. */
#define BM_USB_UH3_HCCPARAMS_PFL (0x00000002U) /*!< Bit mask for USB_UH3_HCCPARAMS_PFL. */
#define BS_USB_UH3_HCCPARAMS_PFL (1U)      /*!< Bit field size in bits for USB_UH3_HCCPARAMS_PFL. */

/*! @brief Read current value of the USB_UH3_HCCPARAMS_PFL field. */
#define BR_USB_UH3_HCCPARAMS_PFL(x) (HW_USB_UH3_HCCPARAMS(x).B.PFL)
/*@}*/

/*!
 * @name Register USB_UH3_HCCPARAMS, field ASP[2] (RO)
 *
 * Asynchronous Schedule Park Capability If this bit is set to a one, then the
 * host controller supports the park feature for high-speed queue heads in the
 * Asynchronous Schedule. The feature can be disabled or enabled and set to a
 * specific level by using the Asynchronous Schedule Park Mode Enable and Asynchronous
 * Schedule Park Mode Count fields in the USBCMD register. ASP bit reset value:
 * '00b' for OTG controller core, '11b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_HCCPARAMS_ASP (2U)      /*!< Bit position for USB_UH3_HCCPARAMS_ASP. */
#define BM_USB_UH3_HCCPARAMS_ASP (0x00000004U) /*!< Bit mask for USB_UH3_HCCPARAMS_ASP. */
#define BS_USB_UH3_HCCPARAMS_ASP (1U)      /*!< Bit field size in bits for USB_UH3_HCCPARAMS_ASP. */

/*! @brief Read current value of the USB_UH3_HCCPARAMS_ASP field. */
#define BR_USB_UH3_HCCPARAMS_ASP(x) (HW_USB_UH3_HCCPARAMS(x).B.ASP)
/*@}*/

/*!
 * @name Register USB_UH3_HCCPARAMS, field IST[7:4] (RO)
 *
 * Isochronous Scheduling Threshold. This field indicates, relative to the
 * current position of the executing host controller, where software can reliably
 * update the isochronous schedule. When bit [7] is zero, the value of the least
 * significant 3 bits indicates the number of micro-frames a host controller can hold
 * a set of isochronous data structures (one or more) before flushing the state.
 * When bit [7] is a one, then host software assumes the host controller may
 * cache an isochronous data structure for an entire frame. These bits are set '00h'
 * in all controller core.
 */
/*@{*/
#define BP_USB_UH3_HCCPARAMS_IST (4U)      /*!< Bit position for USB_UH3_HCCPARAMS_IST. */
#define BM_USB_UH3_HCCPARAMS_IST (0x000000F0U) /*!< Bit mask for USB_UH3_HCCPARAMS_IST. */
#define BS_USB_UH3_HCCPARAMS_IST (4U)      /*!< Bit field size in bits for USB_UH3_HCCPARAMS_IST. */

/*! @brief Read current value of the USB_UH3_HCCPARAMS_IST field. */
#define BR_USB_UH3_HCCPARAMS_IST(x) (HW_USB_UH3_HCCPARAMS(x).B.IST)
/*@}*/

/*!
 * @name Register USB_UH3_HCCPARAMS, field EECP[15:8] (RO)
 *
 * EHCI Extended Capabilities Pointer. This field indicates the existence of a
 * capabilities list. A value of 00h indicates no extended capabilities are
 * implemented. A non-zero value in this register indicates the offset in PCI
 * configuration space of the first EHCI extended capability. The pointer value must be
 * 40h or greater if implemented to maintain the consistency of the PCI header
 * defined for this class of device. These bits are set '00h' in all controller core.
 */
/*@{*/
#define BP_USB_UH3_HCCPARAMS_EECP (8U)     /*!< Bit position for USB_UH3_HCCPARAMS_EECP. */
#define BM_USB_UH3_HCCPARAMS_EECP (0x0000FF00U) /*!< Bit mask for USB_UH3_HCCPARAMS_EECP. */
#define BS_USB_UH3_HCCPARAMS_EECP (8U)     /*!< Bit field size in bits for USB_UH3_HCCPARAMS_EECP. */

/*! @brief Read current value of the USB_UH3_HCCPARAMS_EECP field. */
#define BR_USB_UH3_HCCPARAMS_EECP(x) (HW_USB_UH3_HCCPARAMS(x).B.EECP)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_USBCMD - USB Command Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_USBCMD - USB Command Register (RW)
 *
 * Reset value: 0x00080000U
 *
 * The Command Register indicates the command to be executed by the serial bus
 * host/device controller. Writing to the register causes a command to be executed.
 */
typedef union _hw_usb_uh3_usbcmd
{
    uint32_t U;
    struct _hw_usb_uh3_usbcmd_bitfields
    {
        uint32_t RS : 1;               /*!< [0]  */
        uint32_t RST : 1;              /*!< [1]  */
        uint32_t FS_1 : 2;             /*!< [3:2]  */
        uint32_t PSE : 1;              /*!< [4]  */
        uint32_t ASE : 1;              /*!< [5]  */
        uint32_t IAA : 1;              /*!< [6]  */
        uint32_t RESERVED0 : 1;        /*!< [7]  */
        uint32_t ASP : 2;              /*!< [9:8]  */
        uint32_t RESERVED1 : 1;        /*!< [10]  */
        uint32_t ASPE : 1;             /*!< [11]  */
        uint32_t ATDTW : 1;            /*!< [12]  */
        uint32_t SUTW : 1;             /*!< [13]  */
        uint32_t RESERVED2 : 1;        /*!< [14]  */
        uint32_t FS_2 : 1;             /*!< [15]  */
        uint32_t ITC : 8;              /*!< [23:16]  */
        uint32_t RESERVED3 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_uh3_usbcmd_t;

/*!
 * @name Constants and macros for entire USB_UH3_USBCMD register
 */
/*@{*/
#define HW_USB_UH3_USBCMD_ADDR(x) ((uintptr_t)(x) + 0x740U)

#define HW_USB_UH3_USBCMD(x)     (*(__IO hw_usb_uh3_usbcmd_t *) HW_USB_UH3_USBCMD_ADDR(x))
#define HW_USB_UH3_USBCMD_RD(x)  (HW_USB_UH3_USBCMD(x).U)
#define HW_USB_UH3_USBCMD_WR(x, v) (HW_USB_UH3_USBCMD(x).U = (v))
#define HW_USB_UH3_USBCMD_SET(x, v) (HW_USB_UH3_USBCMD_WR(x, HW_USB_UH3_USBCMD_RD(x) |  (v)))
#define HW_USB_UH3_USBCMD_CLR(x, v) (HW_USB_UH3_USBCMD_WR(x, HW_USB_UH3_USBCMD_RD(x) & ~(v)))
#define HW_USB_UH3_USBCMD_TOG(x, v) (HW_USB_UH3_USBCMD_WR(x, HW_USB_UH3_USBCMD_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_USBCMD bitfields
 */

/*!
 * @name Register USB_UH3_USBCMD, field RS[0] (RW)
 *
 * Run/Stop (RS) - Read/Write. Default 0b. 1=Run. 0=Stop. Host operation mode:
 * When set to '1b', the Controller proceeds with the execution of the schedule.
 * The Controller continues execution as long as this bit is set to a one. When
 * this bit is set to 0, the Host Controller completes the current transaction on
 * the USB and then halts. The HC Halted bit in the status register indicates when
 * the Controller has finished the transaction and has entered the stopped
 * state. Software should not write a one to this field unless the controller is in
 * the Halted state (that is, HCHalted in the USBSTS register is a one). Device
 * operation mode: Writing a one to this bit will cause the controller to enable a
 * pull-up on D+ and initiate an attach event. This control bit is not directly
 * connected to the pull-up enable, as the pull-up will become disabled upon
 * transitioning into high-speed mode. Software should use this bit to prevent an
 * attach event before the controller has been properly initialized. Writing a 0 to
 * this will cause a detach event.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_RS (0U)          /*!< Bit position for USB_UH3_USBCMD_RS. */
#define BM_USB_UH3_USBCMD_RS (0x00000001U) /*!< Bit mask for USB_UH3_USBCMD_RS. */
#define BS_USB_UH3_USBCMD_RS (1U)          /*!< Bit field size in bits for USB_UH3_USBCMD_RS. */

/*! @brief Read current value of the USB_UH3_USBCMD_RS field. */
#define BR_USB_UH3_USBCMD_RS(x) (HW_USB_UH3_USBCMD(x).B.RS)

/*! @brief Format value for bitfield USB_UH3_USBCMD_RS. */
#define BF_USB_UH3_USBCMD_RS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_RS) & BM_USB_UH3_USBCMD_RS)

/*! @brief Set the RS field to a new value. */
#define BW_USB_UH3_USBCMD_RS(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_RS) | BF_USB_UH3_USBCMD_RS(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field RST[1] (RW)
 *
 * Controller Reset (RESET) - Read/Write. Software uses this bit to reset the
 * controller. This bit is set to zero by the Host/Device Controller when the reset
 * process is complete. Software cannot terminate the reset process early by
 * writing a zero to this register. Host operation mode: When software writes a one
 * to this bit, the Controller resets its internal pipelines, timers, counters,
 * state machines etc. to their initial value. Any transaction currently in
 * progress on USB is immediately terminated. A USB reset is not driven on downstream
 * ports. Software should not set this bit to a one when the HCHalted bit in the
 * USBSTS register is a zero. Attempting to reset an actively running host
 * controller will result in undefined behavior. Device operation mode: When software
 * writes a one to this bit, the Controller resets its internal pipelines, timers,
 * counters, state machines etc. to their initial value. Writing a one to this
 * bit when the device is in the attached state is not recommended, because the
 * effect on an attached host is undefined. In order to ensure that the device is
 * not in an attached state before initiating a device controller reset, all primed
 * endpoints should be flushed and the USBCMD Run/Stop bit should be set to 0.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_RST (1U)         /*!< Bit position for USB_UH3_USBCMD_RST. */
#define BM_USB_UH3_USBCMD_RST (0x00000002U) /*!< Bit mask for USB_UH3_USBCMD_RST. */
#define BS_USB_UH3_USBCMD_RST (1U)         /*!< Bit field size in bits for USB_UH3_USBCMD_RST. */

/*! @brief Read current value of the USB_UH3_USBCMD_RST field. */
#define BR_USB_UH3_USBCMD_RST(x) (HW_USB_UH3_USBCMD(x).B.RST)

/*! @brief Format value for bitfield USB_UH3_USBCMD_RST. */
#define BF_USB_UH3_USBCMD_RST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_RST) & BM_USB_UH3_USBCMD_RST)

/*! @brief Set the RST field to a new value. */
#define BW_USB_UH3_USBCMD_RST(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_RST) | BF_USB_UH3_USBCMD_RST(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field FS_1[3:2] (RW)
 *
 * See description at bit 15
 */
/*@{*/
#define BP_USB_UH3_USBCMD_FS_1 (2U)        /*!< Bit position for USB_UH3_USBCMD_FS_1. */
#define BM_USB_UH3_USBCMD_FS_1 (0x0000000CU) /*!< Bit mask for USB_UH3_USBCMD_FS_1. */
#define BS_USB_UH3_USBCMD_FS_1 (2U)        /*!< Bit field size in bits for USB_UH3_USBCMD_FS_1. */

/*! @brief Read current value of the USB_UH3_USBCMD_FS_1 field. */
#define BR_USB_UH3_USBCMD_FS_1(x) (HW_USB_UH3_USBCMD(x).B.FS_1)

/*! @brief Format value for bitfield USB_UH3_USBCMD_FS_1. */
#define BF_USB_UH3_USBCMD_FS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_FS_1) & BM_USB_UH3_USBCMD_FS_1)

/*! @brief Set the FS_1 field to a new value. */
#define BW_USB_UH3_USBCMD_FS_1(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_FS_1) | BF_USB_UH3_USBCMD_FS_1(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field PSE[4] (RW)
 *
 * Periodic Schedule Enable- Read/Write. Default 0b. This bit controls whether
 * the host controller skips processing the Periodic Schedule. Only the host
 * controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Periodic Schedule
 * - 1 - Use the PERIODICLISTBASE register to access the Periodic Schedule.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_PSE (4U)         /*!< Bit position for USB_UH3_USBCMD_PSE. */
#define BM_USB_UH3_USBCMD_PSE (0x00000010U) /*!< Bit mask for USB_UH3_USBCMD_PSE. */
#define BS_USB_UH3_USBCMD_PSE (1U)         /*!< Bit field size in bits for USB_UH3_USBCMD_PSE. */

/*! @brief Read current value of the USB_UH3_USBCMD_PSE field. */
#define BR_USB_UH3_USBCMD_PSE(x) (HW_USB_UH3_USBCMD(x).B.PSE)

/*! @brief Format value for bitfield USB_UH3_USBCMD_PSE. */
#define BF_USB_UH3_USBCMD_PSE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_PSE) & BM_USB_UH3_USBCMD_PSE)

/*! @brief Set the PSE field to a new value. */
#define BW_USB_UH3_USBCMD_PSE(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_PSE) | BF_USB_UH3_USBCMD_PSE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field ASE[5] (RW)
 *
 * Asynchronous Schedule Enable - Read/Write. Default 0b. This bit controls
 * whether the host controller skips processing the Asynchronous Schedule. Only the
 * host controller uses this bit. Values Meaning
 *
 * Values:
 * - 0 - Do not process the Asynchronous Schedule.
 * - 1 - Use the ASYNCLISTADDR register to access the Asynchronous Schedule.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_ASE (5U)         /*!< Bit position for USB_UH3_USBCMD_ASE. */
#define BM_USB_UH3_USBCMD_ASE (0x00000020U) /*!< Bit mask for USB_UH3_USBCMD_ASE. */
#define BS_USB_UH3_USBCMD_ASE (1U)         /*!< Bit field size in bits for USB_UH3_USBCMD_ASE. */

/*! @brief Read current value of the USB_UH3_USBCMD_ASE field. */
#define BR_USB_UH3_USBCMD_ASE(x) (HW_USB_UH3_USBCMD(x).B.ASE)

/*! @brief Format value for bitfield USB_UH3_USBCMD_ASE. */
#define BF_USB_UH3_USBCMD_ASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_ASE) & BM_USB_UH3_USBCMD_ASE)

/*! @brief Set the ASE field to a new value. */
#define BW_USB_UH3_USBCMD_ASE(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_ASE) | BF_USB_UH3_USBCMD_ASE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field IAA[6] (RW)
 *
 * Interrupt on Async Advance Doorbell - Read/Write. This bit is used as a
 * doorbell by software to tell the host controller to issue an interrupt the next
 * time it advances asynchronous schedule. Software must write a 1 to this bit to
 * ring the doorbell. When the host controller has evicted all appropriate cached
 * schedule states, it sets the Interrupt on Async Advance status bit in the
 * USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR
 * register is one, then the host controller will assert an interrupt at the next
 * interrupt threshold. The host controller sets this bit to zero after it has set the
 * Interrupt on Sync Advance status bit in the USBSTS register to one. Software
 * should not write a one to this bit when the asynchronous schedule is inactive.
 * Doing so will yield undefined results. This bit is only used in host mode.
 * Writing a one to this bit when device mode is selected will have undefined
 * results.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_IAA (6U)         /*!< Bit position for USB_UH3_USBCMD_IAA. */
#define BM_USB_UH3_USBCMD_IAA (0x00000040U) /*!< Bit mask for USB_UH3_USBCMD_IAA. */
#define BS_USB_UH3_USBCMD_IAA (1U)         /*!< Bit field size in bits for USB_UH3_USBCMD_IAA. */

/*! @brief Read current value of the USB_UH3_USBCMD_IAA field. */
#define BR_USB_UH3_USBCMD_IAA(x) (HW_USB_UH3_USBCMD(x).B.IAA)

/*! @brief Format value for bitfield USB_UH3_USBCMD_IAA. */
#define BF_USB_UH3_USBCMD_IAA(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_IAA) & BM_USB_UH3_USBCMD_IAA)

/*! @brief Set the IAA field to a new value. */
#define BW_USB_UH3_USBCMD_IAA(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_IAA) | BF_USB_UH3_USBCMD_IAA(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field ASP[9:8] (RW)
 *
 * Asynchronous Schedule Park Mode Count - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this field defaults to
 * 3h and is R/W. Otherwise it defaults to zero and is Read-Only. It contains a
 * count of the number of successive transactions the host controller is allowed
 * to execute from a high-speed queue head on the Asynchronous schedule before
 * continuing traversal of the Asynchronous schedule. Valid values are 1h to 3h.
 * Software must not write a zero to this bit when Park Mode Enable is a one as
 * this will result in undefined behavior. This field is set to 3h in all controller
 * core.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_ASP (8U)         /*!< Bit position for USB_UH3_USBCMD_ASP. */
#define BM_USB_UH3_USBCMD_ASP (0x00000300U) /*!< Bit mask for USB_UH3_USBCMD_ASP. */
#define BS_USB_UH3_USBCMD_ASP (2U)         /*!< Bit field size in bits for USB_UH3_USBCMD_ASP. */

/*! @brief Read current value of the USB_UH3_USBCMD_ASP field. */
#define BR_USB_UH3_USBCMD_ASP(x) (HW_USB_UH3_USBCMD(x).B.ASP)

/*! @brief Format value for bitfield USB_UH3_USBCMD_ASP. */
#define BF_USB_UH3_USBCMD_ASP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_ASP) & BM_USB_UH3_USBCMD_ASP)

/*! @brief Set the ASP field to a new value. */
#define BW_USB_UH3_USBCMD_ASP(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_ASP) | BF_USB_UH3_USBCMD_ASP(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field ASPE[11] (RW)
 *
 * Asynchronous Schedule Park Mode Enable - Read/Write. If the Asynchronous Park
 * Capability bit in the HCCPARAMS register is a one, then this bit defaults to
 * a 1h and is R/W. Otherwise the bit must be a zero and is RO. Software uses
 * this bit to enable or disable Park mode. When this bit is one, Park mode is
 * enabled. When this bit is a zero, Park mode is disabled. ASPE bit reset value: '0b'
 * for OTG controller core, '1b' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_ASPE (11U)       /*!< Bit position for USB_UH3_USBCMD_ASPE. */
#define BM_USB_UH3_USBCMD_ASPE (0x00000800U) /*!< Bit mask for USB_UH3_USBCMD_ASPE. */
#define BS_USB_UH3_USBCMD_ASPE (1U)        /*!< Bit field size in bits for USB_UH3_USBCMD_ASPE. */

/*! @brief Read current value of the USB_UH3_USBCMD_ASPE field. */
#define BR_USB_UH3_USBCMD_ASPE(x) (HW_USB_UH3_USBCMD(x).B.ASPE)

/*! @brief Format value for bitfield USB_UH3_USBCMD_ASPE. */
#define BF_USB_UH3_USBCMD_ASPE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_ASPE) & BM_USB_UH3_USBCMD_ASPE)

/*! @brief Set the ASPE field to a new value. */
#define BW_USB_UH3_USBCMD_ASPE(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_ASPE) | BF_USB_UH3_USBCMD_ASPE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field ATDTW[12] (RW)
 *
 * Add dTD TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure proper addition of a new dTD to an active (primed) endpoint's
 * linked list. This bit is set and cleared by software. This bit would also be
 * cleared by hardware when state machine is hazard region for which adding a dTD
 * to a primed endpoint may go unrecognized.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_ATDTW (12U)      /*!< Bit position for USB_UH3_USBCMD_ATDTW. */
#define BM_USB_UH3_USBCMD_ATDTW (0x00001000U) /*!< Bit mask for USB_UH3_USBCMD_ATDTW. */
#define BS_USB_UH3_USBCMD_ATDTW (1U)       /*!< Bit field size in bits for USB_UH3_USBCMD_ATDTW. */

/*! @brief Read current value of the USB_UH3_USBCMD_ATDTW field. */
#define BR_USB_UH3_USBCMD_ATDTW(x) (HW_USB_UH3_USBCMD(x).B.ATDTW)

/*! @brief Format value for bitfield USB_UH3_USBCMD_ATDTW. */
#define BF_USB_UH3_USBCMD_ATDTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_ATDTW) & BM_USB_UH3_USBCMD_ATDTW)

/*! @brief Set the ATDTW field to a new value. */
#define BW_USB_UH3_USBCMD_ATDTW(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_ATDTW) | BF_USB_UH3_USBCMD_ATDTW(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field SUTW[13] (RW)
 *
 * Setup TripWire - Read/Write. [device mode only] This bit is used as a
 * semaphore to ensure that the setup data payload of 8 bytes is extracted from a QH by
 * the DCD without being corrupted. If the setup lockout mode is off (SLOM bit in
 * USB core register n_USBMODE, see USBMODEUSB Device Mode ) then there is a
 * hazard when new setup data arrives while the DCD is copying the setup data
 * payload from the QH for a previous setup packet. This bit is set and cleared by
 * software. This bit would also be cleared by hardware when a hazard detected.
 */
/*@{*/
#define BP_USB_UH3_USBCMD_SUTW (13U)       /*!< Bit position for USB_UH3_USBCMD_SUTW. */
#define BM_USB_UH3_USBCMD_SUTW (0x00002000U) /*!< Bit mask for USB_UH3_USBCMD_SUTW. */
#define BS_USB_UH3_USBCMD_SUTW (1U)        /*!< Bit field size in bits for USB_UH3_USBCMD_SUTW. */

/*! @brief Read current value of the USB_UH3_USBCMD_SUTW field. */
#define BR_USB_UH3_USBCMD_SUTW(x) (HW_USB_UH3_USBCMD(x).B.SUTW)

/*! @brief Format value for bitfield USB_UH3_USBCMD_SUTW. */
#define BF_USB_UH3_USBCMD_SUTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_SUTW) & BM_USB_UH3_USBCMD_SUTW)

/*! @brief Set the SUTW field to a new value. */
#define BW_USB_UH3_USBCMD_SUTW(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_SUTW) | BF_USB_UH3_USBCMD_SUTW(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field FS_2[15] (RW)
 *
 * See also bits 3-2 Frame List Size - (Read/Write or Read Only). [host mode
 * only] This field is Read/Write only if Programmable Frame List Flag in the
 * HCCPARAMS registers is set to one. This field specifies the size of the frame list
 * that controls which bits in the Frame Index Register should be used for the
 * Frame List Current index. This field is made up from USBCMD bits 15, 3 and 2.
 * Value Meaning
 *
 * Values:
 * - 000 - 1024 elements (4096 bytes) Default value
 * - 001 - 512 elements (2048 bytes)
 */
/*@{*/
#define BP_USB_UH3_USBCMD_FS_2 (15U)       /*!< Bit position for USB_UH3_USBCMD_FS_2. */
#define BM_USB_UH3_USBCMD_FS_2 (0x00008000U) /*!< Bit mask for USB_UH3_USBCMD_FS_2. */
#define BS_USB_UH3_USBCMD_FS_2 (1U)        /*!< Bit field size in bits for USB_UH3_USBCMD_FS_2. */

/*! @brief Read current value of the USB_UH3_USBCMD_FS_2 field. */
#define BR_USB_UH3_USBCMD_FS_2(x) (HW_USB_UH3_USBCMD(x).B.FS_2)

/*! @brief Format value for bitfield USB_UH3_USBCMD_FS_2. */
#define BF_USB_UH3_USBCMD_FS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_FS_2) & BM_USB_UH3_USBCMD_FS_2)

/*! @brief Set the FS_2 field to a new value. */
#define BW_USB_UH3_USBCMD_FS_2(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_FS_2) | BF_USB_UH3_USBCMD_FS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBCMD, field ITC[23:16] (RW)
 *
 * Interrupt Threshold Control -Read/Write. The system software uses this field
 * to set the maximum rate at which the host/device controller will issue
 * interrupts. ITC contains the maximum interrupt interval measured in micro-frames.
 * Valid values are shown below. Value Maximum Interrupt Interval
 *
 * Values:
 * - 0 - Immediate (no threshold)
 * - 1 - 1 micro-frame
 * - 10 - 2 micro-frames
 * - 100 - 4 micro-frames
 * - 1000 - 8 micro-frames
 * - 10000 - 16 micro-frames
 * - 100000 - 32 micro-frames
 * - 1000000 - 64 micro-frames
 */
/*@{*/
#define BP_USB_UH3_USBCMD_ITC (16U)        /*!< Bit position for USB_UH3_USBCMD_ITC. */
#define BM_USB_UH3_USBCMD_ITC (0x00FF0000U) /*!< Bit mask for USB_UH3_USBCMD_ITC. */
#define BS_USB_UH3_USBCMD_ITC (8U)         /*!< Bit field size in bits for USB_UH3_USBCMD_ITC. */

/*! @brief Read current value of the USB_UH3_USBCMD_ITC field. */
#define BR_USB_UH3_USBCMD_ITC(x) (HW_USB_UH3_USBCMD(x).B.ITC)

/*! @brief Format value for bitfield USB_UH3_USBCMD_ITC. */
#define BF_USB_UH3_USBCMD_ITC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBCMD_ITC) & BM_USB_UH3_USBCMD_ITC)

/*! @brief Set the ITC field to a new value. */
#define BW_USB_UH3_USBCMD_ITC(x, v) (HW_USB_UH3_USBCMD_WR(x, (HW_USB_UH3_USBCMD_RD(x) & ~BM_USB_UH3_USBCMD_ITC) | BF_USB_UH3_USBCMD_ITC(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_USBSTS - USB Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_USBSTS - USB Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register indicates various states of the Host/Device Controller and any
 * pending interrupts. This register does not indicate status resulting from a
 * transaction on the serial bus.
 */
typedef union _hw_usb_uh3_usbsts
{
    uint32_t U;
    struct _hw_usb_uh3_usbsts_bitfields
    {
        uint32_t UI : 1;               /*!< [0]  */
        uint32_t UEI : 1;              /*!< [1]  */
        uint32_t PCI : 1;              /*!< [2]  */
        uint32_t FRI : 1;              /*!< [3]  */
        uint32_t SEI : 1;              /*!< [4]  */
        uint32_t AAI : 1;              /*!< [5]  */
        uint32_t URI : 1;              /*!< [6]  */
        uint32_t SRI : 1;              /*!< [7]  */
        uint32_t SLI : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPII : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 1;        /*!< [11]  */
        uint32_t HCH : 1;              /*!< [12]  */
        uint32_t RCL : 1;              /*!< [13]  */
        uint32_t PS : 1;               /*!< [14]  */
        uint32_t AS : 1;               /*!< [15]  */
        uint32_t NAKI : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 7;        /*!< [23:17]  */
        uint32_t TI0 : 1;              /*!< [24]  */
        uint32_t TI1 : 1;              /*!< [25]  */
        uint32_t RESERVED3 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh3_usbsts_t;

/*!
 * @name Constants and macros for entire USB_UH3_USBSTS register
 */
/*@{*/
#define HW_USB_UH3_USBSTS_ADDR(x) ((uintptr_t)(x) + 0x744U)

#define HW_USB_UH3_USBSTS(x)     (*(__IO hw_usb_uh3_usbsts_t *) HW_USB_UH3_USBSTS_ADDR(x))
#define HW_USB_UH3_USBSTS_RD(x)  (HW_USB_UH3_USBSTS(x).U)
#define HW_USB_UH3_USBSTS_WR(x, v) (HW_USB_UH3_USBSTS(x).U = (v))
#define HW_USB_UH3_USBSTS_SET(x, v) (HW_USB_UH3_USBSTS_WR(x, HW_USB_UH3_USBSTS_RD(x) |  (v)))
#define HW_USB_UH3_USBSTS_CLR(x, v) (HW_USB_UH3_USBSTS_WR(x, HW_USB_UH3_USBSTS_RD(x) & ~(v)))
#define HW_USB_UH3_USBSTS_TOG(x, v) (HW_USB_UH3_USBSTS_WR(x, HW_USB_UH3_USBSTS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_USBSTS bitfields
 */

/*!
 * @name Register USB_UH3_USBSTS, field UI[0] (RW)
 *
 * USB Interrupt (USBINT) - R/WC. This bit is set by the Host/Device Controller
 * when the cause of an interrupt is a completion of a USB transaction where the
 * Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit
 * is also set by the Host/Device Controller when a short packet is detected. A
 * short packet is when the actual number of bytes received was less than the
 * expected number of bytes.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_UI (0U)          /*!< Bit position for USB_UH3_USBSTS_UI. */
#define BM_USB_UH3_USBSTS_UI (0x00000001U) /*!< Bit mask for USB_UH3_USBSTS_UI. */
#define BS_USB_UH3_USBSTS_UI (1U)          /*!< Bit field size in bits for USB_UH3_USBSTS_UI. */

/*! @brief Read current value of the USB_UH3_USBSTS_UI field. */
#define BR_USB_UH3_USBSTS_UI(x) (HW_USB_UH3_USBSTS(x).B.UI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_UI. */
#define BF_USB_UH3_USBSTS_UI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_UI) & BM_USB_UH3_USBSTS_UI)

/*! @brief Set the UI field to a new value. */
#define BW_USB_UH3_USBSTS_UI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_UI) | BF_USB_UH3_USBSTS_UI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field UEI[1] (RW)
 *
 * USB Error Interrupt (USBERRINT) - R/WC. When completion of a USB transaction
 * results in an error condition, this bit is set by the Host/Device Controller.
 * This bit is set along with the USBINT bit, if the TD on which the error
 * interrupt occurred also had its interrupt on complete (IOC) bit set. The device
 * controller detects resume signaling only.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_UEI (1U)         /*!< Bit position for USB_UH3_USBSTS_UEI. */
#define BM_USB_UH3_USBSTS_UEI (0x00000002U) /*!< Bit mask for USB_UH3_USBSTS_UEI. */
#define BS_USB_UH3_USBSTS_UEI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_UEI. */

/*! @brief Read current value of the USB_UH3_USBSTS_UEI field. */
#define BR_USB_UH3_USBSTS_UEI(x) (HW_USB_UH3_USBSTS(x).B.UEI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_UEI. */
#define BF_USB_UH3_USBSTS_UEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_UEI) & BM_USB_UH3_USBSTS_UEI)

/*! @brief Set the UEI field to a new value. */
#define BW_USB_UH3_USBSTS_UEI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_UEI) | BF_USB_UH3_USBSTS_UEI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field PCI[2] (RW)
 *
 * Port Change Detect - R/WC. The Host Controller sets this bit to a one when on
 * any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the
 * Force Port Resume bit is set as the result of a J-K transition on the
 * suspended port. The Device Controller sets this bit to a one when the port controller
 * enters the full or high-speed operational state. When the port controller
 * exits the full or high-speed operation states due to Reset or Suspend events, the
 * notification mechanisms are the USB Reset Received bit and the DCSuspend bits
 * respectively.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_PCI (2U)         /*!< Bit position for USB_UH3_USBSTS_PCI. */
#define BM_USB_UH3_USBSTS_PCI (0x00000004U) /*!< Bit mask for USB_UH3_USBSTS_PCI. */
#define BS_USB_UH3_USBSTS_PCI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_PCI. */

/*! @brief Read current value of the USB_UH3_USBSTS_PCI field. */
#define BR_USB_UH3_USBSTS_PCI(x) (HW_USB_UH3_USBSTS(x).B.PCI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_PCI. */
#define BF_USB_UH3_USBSTS_PCI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_PCI) & BM_USB_UH3_USBSTS_PCI)

/*! @brief Set the PCI field to a new value. */
#define BW_USB_UH3_USBSTS_PCI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_PCI) | BF_USB_UH3_USBSTS_PCI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field FRI[3] (RW)
 *
 * Frame List Rollover - R/WC. The Host Controller sets this bit to a one when
 * the Frame List Index rolls over from its maximum value to zero. The exact value
 * at which the rollover occurs depends on the frame list size. For example. If
 * the frame list size (as programmed in the Frame List Size field of the
 * USB_n_USBCMD register) is 1024, the Frame Index Register rolls over every time
 * FRINDEX [13] toggles. Similarly, if the size is 512, the Host Controller sets this
 * bit to a one every time FHINDEX [12] toggles. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_FRI (3U)         /*!< Bit position for USB_UH3_USBSTS_FRI. */
#define BM_USB_UH3_USBSTS_FRI (0x00000008U) /*!< Bit mask for USB_UH3_USBSTS_FRI. */
#define BS_USB_UH3_USBSTS_FRI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_FRI. */

/*! @brief Read current value of the USB_UH3_USBSTS_FRI field. */
#define BR_USB_UH3_USBSTS_FRI(x) (HW_USB_UH3_USBSTS(x).B.FRI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_FRI. */
#define BF_USB_UH3_USBSTS_FRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_FRI) & BM_USB_UH3_USBSTS_FRI)

/*! @brief Set the FRI field to a new value. */
#define BW_USB_UH3_USBSTS_FRI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_FRI) | BF_USB_UH3_USBSTS_FRI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field SEI[4] (RW)
 *
 * System Error- R/WC. This bit is will be set to '1b' when an Error response is
 * seen to a read on the system interface.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_SEI (4U)         /*!< Bit position for USB_UH3_USBSTS_SEI. */
#define BM_USB_UH3_USBSTS_SEI (0x00000010U) /*!< Bit mask for USB_UH3_USBSTS_SEI. */
#define BS_USB_UH3_USBSTS_SEI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_SEI. */

/*! @brief Read current value of the USB_UH3_USBSTS_SEI field. */
#define BR_USB_UH3_USBSTS_SEI(x) (HW_USB_UH3_USBSTS(x).B.SEI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_SEI. */
#define BF_USB_UH3_USBSTS_SEI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_SEI) & BM_USB_UH3_USBSTS_SEI)

/*! @brief Set the SEI field to a new value. */
#define BW_USB_UH3_USBSTS_SEI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_SEI) | BF_USB_UH3_USBSTS_SEI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field AAI[5] (RW)
 *
 * Interrupt on Async Advance - R/WC. System software can force the host
 * controller to issue an interrupt the next time the host controller advances the
 * asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell
 * bit in the n_USBCMD register. This status bit indicates the assertion of that
 * interrupt source. Only used in host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_AAI (5U)         /*!< Bit position for USB_UH3_USBSTS_AAI. */
#define BM_USB_UH3_USBSTS_AAI (0x00000020U) /*!< Bit mask for USB_UH3_USBSTS_AAI. */
#define BS_USB_UH3_USBSTS_AAI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_AAI. */

/*! @brief Read current value of the USB_UH3_USBSTS_AAI field. */
#define BR_USB_UH3_USBSTS_AAI(x) (HW_USB_UH3_USBSTS(x).B.AAI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_AAI. */
#define BF_USB_UH3_USBSTS_AAI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_AAI) & BM_USB_UH3_USBSTS_AAI)

/*! @brief Set the AAI field to a new value. */
#define BW_USB_UH3_USBSTS_AAI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_AAI) | BF_USB_UH3_USBSTS_AAI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field URI[6] (RW)
 *
 * USB Reset Received - R/WC. When the device controller detects a USB Reset and
 * enters the default state, this bit will be set to a one. Software can write a
 * 1 to this bit to clear the USB Reset Received status bit. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_URI (6U)         /*!< Bit position for USB_UH3_USBSTS_URI. */
#define BM_USB_UH3_USBSTS_URI (0x00000040U) /*!< Bit mask for USB_UH3_USBSTS_URI. */
#define BS_USB_UH3_USBSTS_URI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_URI. */

/*! @brief Read current value of the USB_UH3_USBSTS_URI field. */
#define BR_USB_UH3_USBSTS_URI(x) (HW_USB_UH3_USBSTS(x).B.URI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_URI. */
#define BF_USB_UH3_USBSTS_URI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_URI) & BM_USB_UH3_USBSTS_URI)

/*! @brief Set the URI field to a new value. */
#define BW_USB_UH3_USBSTS_URI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_URI) | BF_USB_UH3_USBSTS_URI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field SRI[7] (RW)
 *
 * SOF Received - R/WC. When the device controller detects a Start Of (micro)
 * Frame, this bit will be set to a one. When a SOF is extremely late, the device
 * controller will automatically set this bit to indicate that an SOF was
 * expected. Therefore, this bit will be set roughly every 1ms in device FS mode and
 * every 125ms in HS mode and will be synchronized to the actual SOF that is
 * received. Because the device controller is initialized to FS before connect, this bit
 * will be set at an interval of 1ms during the prelude to connect and chirp. In
 * host mode, this bit will be set every 125us and can be used by host controller
 * driver as a time base. Software writes a 1 to this bit to clear it.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_SRI (7U)         /*!< Bit position for USB_UH3_USBSTS_SRI. */
#define BM_USB_UH3_USBSTS_SRI (0x00000080U) /*!< Bit mask for USB_UH3_USBSTS_SRI. */
#define BS_USB_UH3_USBSTS_SRI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_SRI. */

/*! @brief Read current value of the USB_UH3_USBSTS_SRI field. */
#define BR_USB_UH3_USBSTS_SRI(x) (HW_USB_UH3_USBSTS(x).B.SRI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_SRI. */
#define BF_USB_UH3_USBSTS_SRI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_SRI) & BM_USB_UH3_USBSTS_SRI)

/*! @brief Set the SRI field to a new value. */
#define BW_USB_UH3_USBSTS_SRI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_SRI) | BF_USB_UH3_USBSTS_SRI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field SLI[8] (RW)
 *
 * DCSuspend - R/WC. When a controller enters a suspend state from an active
 * state, this bit will be set to a one. The device controller clears the bit upon
 * exiting from a suspend state. Only used in device operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_SLI (8U)         /*!< Bit position for USB_UH3_USBSTS_SLI. */
#define BM_USB_UH3_USBSTS_SLI (0x00000100U) /*!< Bit mask for USB_UH3_USBSTS_SLI. */
#define BS_USB_UH3_USBSTS_SLI (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_SLI. */

/*! @brief Read current value of the USB_UH3_USBSTS_SLI field. */
#define BR_USB_UH3_USBSTS_SLI(x) (HW_USB_UH3_USBSTS(x).B.SLI)

/*! @brief Format value for bitfield USB_UH3_USBSTS_SLI. */
#define BF_USB_UH3_USBSTS_SLI(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_SLI) & BM_USB_UH3_USBSTS_SLI)

/*! @brief Set the SLI field to a new value. */
#define BW_USB_UH3_USBSTS_SLI(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_SLI) | BF_USB_UH3_USBSTS_SLI(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field ULPII[10] (RW)
 *
 * ULPI Interrupt - R/WC. This bit will be set '1b' by hardware when there is an
 * event completion in ULPI viewport. This bit is usable only if the controller
 * support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_ULPII (10U)      /*!< Bit position for USB_UH3_USBSTS_ULPII. */
#define BM_USB_UH3_USBSTS_ULPII (0x00000400U) /*!< Bit mask for USB_UH3_USBSTS_ULPII. */
#define BS_USB_UH3_USBSTS_ULPII (1U)       /*!< Bit field size in bits for USB_UH3_USBSTS_ULPII. */

/*! @brief Read current value of the USB_UH3_USBSTS_ULPII field. */
#define BR_USB_UH3_USBSTS_ULPII(x) (HW_USB_UH3_USBSTS(x).B.ULPII)

/*! @brief Format value for bitfield USB_UH3_USBSTS_ULPII. */
#define BF_USB_UH3_USBSTS_ULPII(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_ULPII) & BM_USB_UH3_USBSTS_ULPII)

/*! @brief Set the ULPII field to a new value. */
#define BW_USB_UH3_USBSTS_ULPII(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_ULPII) | BF_USB_UH3_USBSTS_ULPII(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field HCH[12] (RW)
 *
 * HCHaIted - Read Only. This bit is a zero whenever the Run/Stop bit is a one.
 * The Controller sets this bit to one after it has stopped executing because of
 * the Run/Stop bit being set to 0, either by software or by the Controller
 * hardware (for example, an internal error). Only used in the host operation mode.
 * Default value is '0b' for OTG core, and '1b' for Host1/Host2/Host3 core. This is
 * because OTG core is not operating as host in default. Please see CM bit in
 * USB_n_USBMODE register. HCH bit reset value: '0b' for OTG controller core, '1b'
 * for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_HCH (12U)        /*!< Bit position for USB_UH3_USBSTS_HCH. */
#define BM_USB_UH3_USBSTS_HCH (0x00001000U) /*!< Bit mask for USB_UH3_USBSTS_HCH. */
#define BS_USB_UH3_USBSTS_HCH (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_HCH. */

/*! @brief Read current value of the USB_UH3_USBSTS_HCH field. */
#define BR_USB_UH3_USBSTS_HCH(x) (HW_USB_UH3_USBSTS(x).B.HCH)

/*! @brief Format value for bitfield USB_UH3_USBSTS_HCH. */
#define BF_USB_UH3_USBSTS_HCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_HCH) & BM_USB_UH3_USBSTS_HCH)

/*! @brief Set the HCH field to a new value. */
#define BW_USB_UH3_USBSTS_HCH(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_HCH) | BF_USB_UH3_USBSTS_HCH(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field RCL[13] (RW)
 *
 * Reclamation - Read Only. This is a read-only status bit used to detect an
 * empty asynchronous schedule. Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_RCL (13U)        /*!< Bit position for USB_UH3_USBSTS_RCL. */
#define BM_USB_UH3_USBSTS_RCL (0x00002000U) /*!< Bit mask for USB_UH3_USBSTS_RCL. */
#define BS_USB_UH3_USBSTS_RCL (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_RCL. */

/*! @brief Read current value of the USB_UH3_USBSTS_RCL field. */
#define BR_USB_UH3_USBSTS_RCL(x) (HW_USB_UH3_USBSTS(x).B.RCL)

/*! @brief Format value for bitfield USB_UH3_USBSTS_RCL. */
#define BF_USB_UH3_USBSTS_RCL(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_RCL) & BM_USB_UH3_USBSTS_RCL)

/*! @brief Set the RCL field to a new value. */
#define BW_USB_UH3_USBSTS_RCL(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_RCL) | BF_USB_UH3_USBSTS_RCL(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field PS[14] (RW)
 *
 * Periodic Schedule Status - Read Only. This bit reports the current real
 * status of the Periodic Schedule. When set to zero the periodic schedule is
 * disabled, and if set to one the status is enabled. The Host Controller is not required
 * to immediately disable or enable the Periodic Schedule when software
 * transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and
 * the Periodic Schedule Enable bit are the same value, the Periodic Schedule is
 * either enabled (1) or disabled (0). Only used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_PS (14U)         /*!< Bit position for USB_UH3_USBSTS_PS. */
#define BM_USB_UH3_USBSTS_PS (0x00004000U) /*!< Bit mask for USB_UH3_USBSTS_PS. */
#define BS_USB_UH3_USBSTS_PS (1U)          /*!< Bit field size in bits for USB_UH3_USBSTS_PS. */

/*! @brief Read current value of the USB_UH3_USBSTS_PS field. */
#define BR_USB_UH3_USBSTS_PS(x) (HW_USB_UH3_USBSTS(x).B.PS)

/*! @brief Format value for bitfield USB_UH3_USBSTS_PS. */
#define BF_USB_UH3_USBSTS_PS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_PS) & BM_USB_UH3_USBSTS_PS)

/*! @brief Set the PS field to a new value. */
#define BW_USB_UH3_USBSTS_PS(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_PS) | BF_USB_UH3_USBSTS_PS(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field AS[15] (RW)
 *
 * Asynchronous Schedule Status - Read Only. This bit reports the current real
 * status of the Asynchronous Schedule. When set to zero the asynchronous schedule
 * status is disabled and if set to one the status is enabled. The Host
 * Controller is not required to immediately disable or enable the Asynchronous Schedule
 * when software transitions the Asynchronous Schedule Enable bit in the USBCMD
 * register. When this bit and the Asynchronous Schedule Enable bit are the same
 * value, the Asynchronous Schedule is either enabled (1) or disabled (0). Only
 * used in the host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_AS (15U)         /*!< Bit position for USB_UH3_USBSTS_AS. */
#define BM_USB_UH3_USBSTS_AS (0x00008000U) /*!< Bit mask for USB_UH3_USBSTS_AS. */
#define BS_USB_UH3_USBSTS_AS (1U)          /*!< Bit field size in bits for USB_UH3_USBSTS_AS. */

/*! @brief Read current value of the USB_UH3_USBSTS_AS field. */
#define BR_USB_UH3_USBSTS_AS(x) (HW_USB_UH3_USBSTS(x).B.AS)

/*! @brief Format value for bitfield USB_UH3_USBSTS_AS. */
#define BF_USB_UH3_USBSTS_AS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_AS) & BM_USB_UH3_USBSTS_AS)

/*! @brief Set the AS field to a new value. */
#define BW_USB_UH3_USBSTS_AS(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_AS) | BF_USB_UH3_USBSTS_AS(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field NAKI[16] (RO)
 *
 * NAK Interrupt Bit--RO. This bit is set by hardware when for a particular
 * endpoint both the TX/RX Endpoint NAK bit and corresponding TX/RX Endpoint NAK
 * Enable bit are set. This bit is automatically cleared by hardware when all Enabled
 * TX/RX Endpoint NAK bits are cleared.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_NAKI (16U)       /*!< Bit position for USB_UH3_USBSTS_NAKI. */
#define BM_USB_UH3_USBSTS_NAKI (0x00010000U) /*!< Bit mask for USB_UH3_USBSTS_NAKI. */
#define BS_USB_UH3_USBSTS_NAKI (1U)        /*!< Bit field size in bits for USB_UH3_USBSTS_NAKI. */

/*! @brief Read current value of the USB_UH3_USBSTS_NAKI field. */
#define BR_USB_UH3_USBSTS_NAKI(x) (HW_USB_UH3_USBSTS(x).B.NAKI)
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field TI0[24] (RW)
 *
 * General Purpose Timer Interrupt 0(GPTINT0)--R/WC. This bit is set when the
 * counter in the GPTIMER0CTRL register transitions to zero, writing a one to this
 * bit clears it.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_TI0 (24U)        /*!< Bit position for USB_UH3_USBSTS_TI0. */
#define BM_USB_UH3_USBSTS_TI0 (0x01000000U) /*!< Bit mask for USB_UH3_USBSTS_TI0. */
#define BS_USB_UH3_USBSTS_TI0 (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_TI0. */

/*! @brief Read current value of the USB_UH3_USBSTS_TI0 field. */
#define BR_USB_UH3_USBSTS_TI0(x) (HW_USB_UH3_USBSTS(x).B.TI0)

/*! @brief Format value for bitfield USB_UH3_USBSTS_TI0. */
#define BF_USB_UH3_USBSTS_TI0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_TI0) & BM_USB_UH3_USBSTS_TI0)

/*! @brief Set the TI0 field to a new value. */
#define BW_USB_UH3_USBSTS_TI0(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_TI0) | BF_USB_UH3_USBSTS_TI0(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBSTS, field TI1[25] (RW)
 *
 * General Purpose Timer Interrupt 1(GPTINT1)--R/WC. This bit is set when the
 * counter in the GPTIMER1CTRL register transitions to zero, writing a one to this
 * bit will clear it.
 */
/*@{*/
#define BP_USB_UH3_USBSTS_TI1 (25U)        /*!< Bit position for USB_UH3_USBSTS_TI1. */
#define BM_USB_UH3_USBSTS_TI1 (0x02000000U) /*!< Bit mask for USB_UH3_USBSTS_TI1. */
#define BS_USB_UH3_USBSTS_TI1 (1U)         /*!< Bit field size in bits for USB_UH3_USBSTS_TI1. */

/*! @brief Read current value of the USB_UH3_USBSTS_TI1 field. */
#define BR_USB_UH3_USBSTS_TI1(x) (HW_USB_UH3_USBSTS(x).B.TI1)

/*! @brief Format value for bitfield USB_UH3_USBSTS_TI1. */
#define BF_USB_UH3_USBSTS_TI1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBSTS_TI1) & BM_USB_UH3_USBSTS_TI1)

/*! @brief Set the TI1 field to a new value. */
#define BW_USB_UH3_USBSTS_TI1(x, v) (HW_USB_UH3_USBSTS_WR(x, (HW_USB_UH3_USBSTS_RD(x) & ~BM_USB_UH3_USBSTS_TI1) | BF_USB_UH3_USBSTS_TI1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_USBINTR - Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_USBINTR - Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The interrupts to software are enabled with this register. An interrupt is
 * generated when a bit is set and the corresponding interrupt source is active.
 * The USB Status register (n_USBSTS) still shows interrupt sources even if they
 * are disabled by the n_USBINTR register, allowing polling of interrupt events by
 * the software.
 */
typedef union _hw_usb_uh3_usbintr
{
    uint32_t U;
    struct _hw_usb_uh3_usbintr_bitfields
    {
        uint32_t UE : 1;               /*!< [0]  */
        uint32_t UEE : 1;              /*!< [1]  */
        uint32_t PCE : 1;              /*!< [2]  */
        uint32_t FRE : 1;              /*!< [3]  */
        uint32_t SEE : 1;              /*!< [4]  */
        uint32_t AAE : 1;              /*!< [5]  */
        uint32_t URE : 1;              /*!< [6]  */
        uint32_t SRE : 1;              /*!< [7]  */
        uint32_t SLE : 1;              /*!< [8]  */
        uint32_t RESERVED0 : 1;        /*!< [9]  */
        uint32_t ULPIE : 1;            /*!< [10]  */
        uint32_t RESERVED1 : 5;        /*!< [15:11]  */
        uint32_t NAKE : 1;             /*!< [16]  */
        uint32_t RESERVED2 : 1;        /*!< [17]  */
        uint32_t UAIE : 1;             /*!< [18]  */
        uint32_t UPIE : 1;             /*!< [19]  */
        uint32_t RESERVED3 : 4;        /*!< [23:20]  */
        uint32_t TIE0 : 1;             /*!< [24]  */
        uint32_t TIE1 : 1;             /*!< [25]  */
        uint32_t RESERVED4 : 6;        /*!< [31:26]  */
    } B;
} hw_usb_uh3_usbintr_t;

/*!
 * @name Constants and macros for entire USB_UH3_USBINTR register
 */
/*@{*/
#define HW_USB_UH3_USBINTR_ADDR(x) ((uintptr_t)(x) + 0x748U)

#define HW_USB_UH3_USBINTR(x)    (*(__IO hw_usb_uh3_usbintr_t *) HW_USB_UH3_USBINTR_ADDR(x))
#define HW_USB_UH3_USBINTR_RD(x) (HW_USB_UH3_USBINTR(x).U)
#define HW_USB_UH3_USBINTR_WR(x, v) (HW_USB_UH3_USBINTR(x).U = (v))
#define HW_USB_UH3_USBINTR_SET(x, v) (HW_USB_UH3_USBINTR_WR(x, HW_USB_UH3_USBINTR_RD(x) |  (v)))
#define HW_USB_UH3_USBINTR_CLR(x, v) (HW_USB_UH3_USBINTR_WR(x, HW_USB_UH3_USBINTR_RD(x) & ~(v)))
#define HW_USB_UH3_USBINTR_TOG(x, v) (HW_USB_UH3_USBINTR_WR(x, HW_USB_UH3_USBINTR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_USBINTR bitfields
 */

/*!
 * @name Register USB_UH3_USBINTR, field UE[0] (RW)
 *
 * USB Interrupt Enalbe When this bit is one and the UI bit in n_USBSTS register
 * is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_UE (0U)         /*!< Bit position for USB_UH3_USBINTR_UE. */
#define BM_USB_UH3_USBINTR_UE (0x00000001U) /*!< Bit mask for USB_UH3_USBINTR_UE. */
#define BS_USB_UH3_USBINTR_UE (1U)         /*!< Bit field size in bits for USB_UH3_USBINTR_UE. */

/*! @brief Read current value of the USB_UH3_USBINTR_UE field. */
#define BR_USB_UH3_USBINTR_UE(x) (HW_USB_UH3_USBINTR(x).B.UE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_UE. */
#define BF_USB_UH3_USBINTR_UE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_UE) & BM_USB_UH3_USBINTR_UE)

/*! @brief Set the UE field to a new value. */
#define BW_USB_UH3_USBINTR_UE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_UE) | BF_USB_UH3_USBINTR_UE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field UEE[1] (RW)
 *
 * USB Error Interrupt Enable When this bit is one and the UEI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_UEE (1U)        /*!< Bit position for USB_UH3_USBINTR_UEE. */
#define BM_USB_UH3_USBINTR_UEE (0x00000002U) /*!< Bit mask for USB_UH3_USBINTR_UEE. */
#define BS_USB_UH3_USBINTR_UEE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_UEE. */

/*! @brief Read current value of the USB_UH3_USBINTR_UEE field. */
#define BR_USB_UH3_USBINTR_UEE(x) (HW_USB_UH3_USBINTR(x).B.UEE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_UEE. */
#define BF_USB_UH3_USBINTR_UEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_UEE) & BM_USB_UH3_USBINTR_UEE)

/*! @brief Set the UEE field to a new value. */
#define BW_USB_UH3_USBINTR_UEE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_UEE) | BF_USB_UH3_USBINTR_UEE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field PCE[2] (RW)
 *
 * Port Change Detect Interrupt Enable When this bit is one and the PCI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_PCE (2U)        /*!< Bit position for USB_UH3_USBINTR_PCE. */
#define BM_USB_UH3_USBINTR_PCE (0x00000004U) /*!< Bit mask for USB_UH3_USBINTR_PCE. */
#define BS_USB_UH3_USBINTR_PCE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_PCE. */

/*! @brief Read current value of the USB_UH3_USBINTR_PCE field. */
#define BR_USB_UH3_USBINTR_PCE(x) (HW_USB_UH3_USBINTR(x).B.PCE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_PCE. */
#define BF_USB_UH3_USBINTR_PCE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_PCE) & BM_USB_UH3_USBINTR_PCE)

/*! @brief Set the PCE field to a new value. */
#define BW_USB_UH3_USBINTR_PCE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_PCE) | BF_USB_UH3_USBINTR_PCE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field FRE[3] (RW)
 *
 * Frame List Rollover Interrupt Enable When this bit is one and the FRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used
 * in host operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_FRE (3U)        /*!< Bit position for USB_UH3_USBINTR_FRE. */
#define BM_USB_UH3_USBINTR_FRE (0x00000008U) /*!< Bit mask for USB_UH3_USBINTR_FRE. */
#define BS_USB_UH3_USBINTR_FRE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_FRE. */

/*! @brief Read current value of the USB_UH3_USBINTR_FRE field. */
#define BR_USB_UH3_USBINTR_FRE(x) (HW_USB_UH3_USBINTR(x).B.FRE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_FRE. */
#define BF_USB_UH3_USBINTR_FRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_FRE) & BM_USB_UH3_USBINTR_FRE)

/*! @brief Set the FRE field to a new value. */
#define BW_USB_UH3_USBINTR_FRE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_FRE) | BF_USB_UH3_USBINTR_FRE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field SEE[4] (RW)
 *
 * System Error Interrupt Enable When this bit is one and the SEI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_SEE (4U)        /*!< Bit position for USB_UH3_USBINTR_SEE. */
#define BM_USB_UH3_USBINTR_SEE (0x00000010U) /*!< Bit mask for USB_UH3_USBINTR_SEE. */
#define BS_USB_UH3_USBINTR_SEE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_SEE. */

/*! @brief Read current value of the USB_UH3_USBINTR_SEE field. */
#define BR_USB_UH3_USBINTR_SEE(x) (HW_USB_UH3_USBINTR(x).B.SEE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_SEE. */
#define BF_USB_UH3_USBINTR_SEE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_SEE) & BM_USB_UH3_USBINTR_SEE)

/*! @brief Set the SEE field to a new value. */
#define BW_USB_UH3_USBINTR_SEE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_SEE) | BF_USB_UH3_USBINTR_SEE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field AAE[5] (RW)
 *
 * Async Advance Interrupt Enable When this bit is one and the AAI bit in
 * n_USBSTS register is a one the controller will issue an interrupt. Only used in host
 * operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_AAE (5U)        /*!< Bit position for USB_UH3_USBINTR_AAE. */
#define BM_USB_UH3_USBINTR_AAE (0x00000020U) /*!< Bit mask for USB_UH3_USBINTR_AAE. */
#define BS_USB_UH3_USBINTR_AAE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_AAE. */

/*! @brief Read current value of the USB_UH3_USBINTR_AAE field. */
#define BR_USB_UH3_USBINTR_AAE(x) (HW_USB_UH3_USBINTR(x).B.AAE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_AAE. */
#define BF_USB_UH3_USBINTR_AAE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_AAE) & BM_USB_UH3_USBINTR_AAE)

/*! @brief Set the AAE field to a new value. */
#define BW_USB_UH3_USBINTR_AAE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_AAE) | BF_USB_UH3_USBINTR_AAE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field URE[6] (RW)
 *
 * USB Reset Interrupt Enable When this bit is one and the URI bit in n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_URE (6U)        /*!< Bit position for USB_UH3_USBINTR_URE. */
#define BM_USB_UH3_USBINTR_URE (0x00000040U) /*!< Bit mask for USB_UH3_USBINTR_URE. */
#define BS_USB_UH3_USBINTR_URE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_URE. */

/*! @brief Read current value of the USB_UH3_USBINTR_URE field. */
#define BR_USB_UH3_USBINTR_URE(x) (HW_USB_UH3_USBINTR(x).B.URE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_URE. */
#define BF_USB_UH3_USBINTR_URE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_URE) & BM_USB_UH3_USBINTR_URE)

/*! @brief Set the URE field to a new value. */
#define BW_USB_UH3_USBINTR_URE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_URE) | BF_USB_UH3_USBINTR_URE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field SRE[7] (RW)
 *
 * SOF Received Interrupt Enable When this bit is one and the SRI bit in
 * n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_SRE (7U)        /*!< Bit position for USB_UH3_USBINTR_SRE. */
#define BM_USB_UH3_USBINTR_SRE (0x00000080U) /*!< Bit mask for USB_UH3_USBINTR_SRE. */
#define BS_USB_UH3_USBINTR_SRE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_SRE. */

/*! @brief Read current value of the USB_UH3_USBINTR_SRE field. */
#define BR_USB_UH3_USBINTR_SRE(x) (HW_USB_UH3_USBINTR(x).B.SRE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_SRE. */
#define BF_USB_UH3_USBINTR_SRE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_SRE) & BM_USB_UH3_USBINTR_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_USB_UH3_USBINTR_SRE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_SRE) | BF_USB_UH3_USBINTR_SRE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field SLE[8] (RW)
 *
 * Sleep Interrupt Enable When this bit is one and the SLI bit in n_n_USBSTS
 * register is a one the controller will issue an interrupt. Only used in device
 * operation mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_SLE (8U)        /*!< Bit position for USB_UH3_USBINTR_SLE. */
#define BM_USB_UH3_USBINTR_SLE (0x00000100U) /*!< Bit mask for USB_UH3_USBINTR_SLE. */
#define BS_USB_UH3_USBINTR_SLE (1U)        /*!< Bit field size in bits for USB_UH3_USBINTR_SLE. */

/*! @brief Read current value of the USB_UH3_USBINTR_SLE field. */
#define BR_USB_UH3_USBINTR_SLE(x) (HW_USB_UH3_USBINTR(x).B.SLE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_SLE. */
#define BF_USB_UH3_USBINTR_SLE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_SLE) & BM_USB_UH3_USBINTR_SLE)

/*! @brief Set the SLE field to a new value. */
#define BW_USB_UH3_USBINTR_SLE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_SLE) | BF_USB_UH3_USBINTR_SLE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field ULPIE[10] (RW)
 *
 * ULPI Interrupt Enable When this bit is one and the UPLII bit in n_USBSTS
 * register is a one the controller will issue an interrupt. This bit is usable only
 * if the controller support UPLI interface mode.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_ULPIE (10U)     /*!< Bit position for USB_UH3_USBINTR_ULPIE. */
#define BM_USB_UH3_USBINTR_ULPIE (0x00000400U) /*!< Bit mask for USB_UH3_USBINTR_ULPIE. */
#define BS_USB_UH3_USBINTR_ULPIE (1U)      /*!< Bit field size in bits for USB_UH3_USBINTR_ULPIE. */

/*! @brief Read current value of the USB_UH3_USBINTR_ULPIE field. */
#define BR_USB_UH3_USBINTR_ULPIE(x) (HW_USB_UH3_USBINTR(x).B.ULPIE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_ULPIE. */
#define BF_USB_UH3_USBINTR_ULPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_ULPIE) & BM_USB_UH3_USBINTR_ULPIE)

/*! @brief Set the ULPIE field to a new value. */
#define BW_USB_UH3_USBINTR_ULPIE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_ULPIE) | BF_USB_UH3_USBINTR_ULPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field NAKE[16] (RW)
 *
 * NAK Interrupt Enable When this bit is one and the NAKI bit in n_USBSTS
 * register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_NAKE (16U)      /*!< Bit position for USB_UH3_USBINTR_NAKE. */
#define BM_USB_UH3_USBINTR_NAKE (0x00010000U) /*!< Bit mask for USB_UH3_USBINTR_NAKE. */
#define BS_USB_UH3_USBINTR_NAKE (1U)       /*!< Bit field size in bits for USB_UH3_USBINTR_NAKE. */

/*! @brief Read current value of the USB_UH3_USBINTR_NAKE field. */
#define BR_USB_UH3_USBINTR_NAKE(x) (HW_USB_UH3_USBINTR(x).B.NAKE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_NAKE. */
#define BF_USB_UH3_USBINTR_NAKE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_NAKE) & BM_USB_UH3_USBINTR_NAKE)

/*! @brief Set the NAKE field to a new value. */
#define BW_USB_UH3_USBINTR_NAKE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_NAKE) | BF_USB_UH3_USBINTR_NAKE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field UAIE[18] (RW)
 *
 * USB Host Asynchronous Interrupt Enable When this bit is one, and the UAI bit
 * in the n_USBSTS register is one, host controller will issue an interrupt at
 * the next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_UAIE (18U)      /*!< Bit position for USB_UH3_USBINTR_UAIE. */
#define BM_USB_UH3_USBINTR_UAIE (0x00040000U) /*!< Bit mask for USB_UH3_USBINTR_UAIE. */
#define BS_USB_UH3_USBINTR_UAIE (1U)       /*!< Bit field size in bits for USB_UH3_USBINTR_UAIE. */

/*! @brief Read current value of the USB_UH3_USBINTR_UAIE field. */
#define BR_USB_UH3_USBINTR_UAIE(x) (HW_USB_UH3_USBINTR(x).B.UAIE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_UAIE. */
#define BF_USB_UH3_USBINTR_UAIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_UAIE) & BM_USB_UH3_USBINTR_UAIE)

/*! @brief Set the UAIE field to a new value. */
#define BW_USB_UH3_USBINTR_UAIE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_UAIE) | BF_USB_UH3_USBINTR_UAIE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field UPIE[19] (RW)
 *
 * USB Host Periodic Interrupt Enable When this bit is one, and the UPI bit in
 * the n_USBSTS register is one, host controller will issue an interrupt at the
 * next interrupt threshold.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_UPIE (19U)      /*!< Bit position for USB_UH3_USBINTR_UPIE. */
#define BM_USB_UH3_USBINTR_UPIE (0x00080000U) /*!< Bit mask for USB_UH3_USBINTR_UPIE. */
#define BS_USB_UH3_USBINTR_UPIE (1U)       /*!< Bit field size in bits for USB_UH3_USBINTR_UPIE. */

/*! @brief Read current value of the USB_UH3_USBINTR_UPIE field. */
#define BR_USB_UH3_USBINTR_UPIE(x) (HW_USB_UH3_USBINTR(x).B.UPIE)

/*! @brief Format value for bitfield USB_UH3_USBINTR_UPIE. */
#define BF_USB_UH3_USBINTR_UPIE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_UPIE) & BM_USB_UH3_USBINTR_UPIE)

/*! @brief Set the UPIE field to a new value. */
#define BW_USB_UH3_USBINTR_UPIE(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_UPIE) | BF_USB_UH3_USBINTR_UPIE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field TIE0[24] (RW)
 *
 * General Purpose Timer #0 Interrupt Enable When this bit is one and the TI0
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_TIE0 (24U)      /*!< Bit position for USB_UH3_USBINTR_TIE0. */
#define BM_USB_UH3_USBINTR_TIE0 (0x01000000U) /*!< Bit mask for USB_UH3_USBINTR_TIE0. */
#define BS_USB_UH3_USBINTR_TIE0 (1U)       /*!< Bit field size in bits for USB_UH3_USBINTR_TIE0. */

/*! @brief Read current value of the USB_UH3_USBINTR_TIE0 field. */
#define BR_USB_UH3_USBINTR_TIE0(x) (HW_USB_UH3_USBINTR(x).B.TIE0)

/*! @brief Format value for bitfield USB_UH3_USBINTR_TIE0. */
#define BF_USB_UH3_USBINTR_TIE0(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_TIE0) & BM_USB_UH3_USBINTR_TIE0)

/*! @brief Set the TIE0 field to a new value. */
#define BW_USB_UH3_USBINTR_TIE0(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_TIE0) | BF_USB_UH3_USBINTR_TIE0(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBINTR, field TIE1[25] (RW)
 *
 * General Purpose Timer #1 Interrupt Enable When this bit is one and the TI1
 * bit in n_USBSTS register is a one the controller will issue an interrupt.
 */
/*@{*/
#define BP_USB_UH3_USBINTR_TIE1 (25U)      /*!< Bit position for USB_UH3_USBINTR_TIE1. */
#define BM_USB_UH3_USBINTR_TIE1 (0x02000000U) /*!< Bit mask for USB_UH3_USBINTR_TIE1. */
#define BS_USB_UH3_USBINTR_TIE1 (1U)       /*!< Bit field size in bits for USB_UH3_USBINTR_TIE1. */

/*! @brief Read current value of the USB_UH3_USBINTR_TIE1 field. */
#define BR_USB_UH3_USBINTR_TIE1(x) (HW_USB_UH3_USBINTR(x).B.TIE1)

/*! @brief Format value for bitfield USB_UH3_USBINTR_TIE1. */
#define BF_USB_UH3_USBINTR_TIE1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBINTR_TIE1) & BM_USB_UH3_USBINTR_TIE1)

/*! @brief Set the TIE1 field to a new value. */
#define BW_USB_UH3_USBINTR_TIE1(x, v) (HW_USB_UH3_USBINTR_WR(x, (HW_USB_UH3_USBINTR_RD(x) & ~BM_USB_UH3_USBINTR_TIE1) | BF_USB_UH3_USBINTR_TIE1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_FRINDEX - USB Frame Index
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_FRINDEX - USB Frame Index (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used by the host controller to index the periodic frame
 * list. The register updates every 125 microseconds (once each micro-frame). Bits
 * [N: 3] are used to select a particular entry in the Periodic Frame List during
 * periodic schedule execution. The number of bits used for the index depends on
 * the size of the frame list as set by system software in the Frame List Size
 * field in the n_USBCMD register. This register must be written as a DWord. Byte
 * writes produce undefined results. This register cannot be written unless the
 * Host Controller is in the 'Halted' state as indicated by the HCHalted bit. A
 * write to this register while the Run/Stop hit is set to a one produces undefined
 * results. Writes to this register also affect the SOF value. In device mode this
 * register is read only and, the device controller updates the FRINDEX [13:3]
 * register from the frame number indicated by the SOF marker. Whenever a SOF is
 * received by the USB bus, FRINDEX [13:3] will be checked against the SOF marker.
 * If FRINDEX [13:3] is different from the SOF marker, FRINDEX [13:3] will be
 * set to the SOF value and FRINDEX [2:0] will be set to zero (that is, SOF for 1
 * ms frame). If FRINDEX [13:3] is equal to the SOF value, FRINDEX [2:0] will be
 * increment (that is, SOF for 125 us micro-frame.).
 */
typedef union _hw_usb_uh3_frindex
{
    uint32_t U;
    struct _hw_usb_uh3_frindex_bitfields
    {
        uint32_t FRINDEX : 14;         /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_usb_uh3_frindex_t;

/*!
 * @name Constants and macros for entire USB_UH3_FRINDEX register
 */
/*@{*/
#define HW_USB_UH3_FRINDEX_ADDR(x) ((uintptr_t)(x) + 0x74CU)

#define HW_USB_UH3_FRINDEX(x)    (*(__IO hw_usb_uh3_frindex_t *) HW_USB_UH3_FRINDEX_ADDR(x))
#define HW_USB_UH3_FRINDEX_RD(x) (HW_USB_UH3_FRINDEX(x).U)
#define HW_USB_UH3_FRINDEX_WR(x, v) (HW_USB_UH3_FRINDEX(x).U = (v))
#define HW_USB_UH3_FRINDEX_SET(x, v) (HW_USB_UH3_FRINDEX_WR(x, HW_USB_UH3_FRINDEX_RD(x) |  (v)))
#define HW_USB_UH3_FRINDEX_CLR(x, v) (HW_USB_UH3_FRINDEX_WR(x, HW_USB_UH3_FRINDEX_RD(x) & ~(v)))
#define HW_USB_UH3_FRINDEX_TOG(x, v) (HW_USB_UH3_FRINDEX_WR(x, HW_USB_UH3_FRINDEX_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_FRINDEX bitfields
 */

/*!
 * @name Register USB_UH3_FRINDEX, field FRINDEX[13:0] (RW)
 *
 * Frame Index. The value, in this register, increments at the end of each time
 * frame (micro-frame). Bits [N: 3] are used for the Frame List current index.
 * This means that each location of the frame list is accessed 8 times (frames or
 * micro-frames) before moving to the next index. The following illustrates values
 * of N based on the value of the Frame List Size field in the USBCMD register,
 * when used in host mode. USBCMD [Frame List Size] Number Elements N In device
 * mode the value is the current frame number of the last frame transmitted. It is
 * not used as an index. In either mode bits 2:0 indicate the current microframe.
 *
 * Values:
 * - 000 - (1024) 12
 * - 001 - (512) 11
 * - 010 - (256) 10
 * - 011 - (128) 9
 * - 100 - (64) 8
 * - 101 - (32) 7
 * - 110 - (16) 6
 * - 111 - (8) 5
 */
/*@{*/
#define BP_USB_UH3_FRINDEX_FRINDEX (0U)    /*!< Bit position for USB_UH3_FRINDEX_FRINDEX. */
#define BM_USB_UH3_FRINDEX_FRINDEX (0x00003FFFU) /*!< Bit mask for USB_UH3_FRINDEX_FRINDEX. */
#define BS_USB_UH3_FRINDEX_FRINDEX (14U)   /*!< Bit field size in bits for USB_UH3_FRINDEX_FRINDEX. */

/*! @brief Read current value of the USB_UH3_FRINDEX_FRINDEX field. */
#define BR_USB_UH3_FRINDEX_FRINDEX(x) (HW_USB_UH3_FRINDEX(x).B.FRINDEX)

/*! @brief Format value for bitfield USB_UH3_FRINDEX_FRINDEX. */
#define BF_USB_UH3_FRINDEX_FRINDEX(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_FRINDEX_FRINDEX) & BM_USB_UH3_FRINDEX_FRINDEX)

/*! @brief Set the FRINDEX field to a new value. */
#define BW_USB_UH3_FRINDEX_FRINDEX(x, v) (HW_USB_UH3_FRINDEX_WR(x, (HW_USB_UH3_FRINDEX_RD(x) & ~BM_USB_UH3_FRINDEX_FRINDEX) | BF_USB_UH3_FRINDEX_FRINDEX(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_PERIODICLISTBASE - Frame List Base Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_PERIODICLISTBASE - Frame List Base Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the beginning address of
 * the Periodic Frame List in the system memory. HCD loads this register prior to
 * starting the schedule execution by the Host Controller. The memory structure
 * referenced by this physical memory pointer is assumed to be 4-Kbyte aligned.
 * The contents of this register are combined with the Frame Index Register
 * (USB_n_FRINDEX) to enable the Host Controller to step through the Periodic Frame List
 * in sequence.
 */
typedef union _hw_usb_uh3_periodiclistbase
{
    uint32_t U;
    struct _hw_usb_uh3_periodiclistbase_bitfields
    {
        uint32_t RESERVED0 : 12;       /*!< [11:0]  */
        uint32_t BASEADR : 20;         /*!< [31:12]  */
    } B;
} hw_usb_uh3_periodiclistbase_t;

/*!
 * @name Constants and macros for entire USB_UH3_PERIODICLISTBASE register
 */
/*@{*/
#define HW_USB_UH3_PERIODICLISTBASE_ADDR(x) ((uintptr_t)(x) + 0x754U)

#define HW_USB_UH3_PERIODICLISTBASE(x) (*(__IO hw_usb_uh3_periodiclistbase_t *) HW_USB_UH3_PERIODICLISTBASE_ADDR(x))
#define HW_USB_UH3_PERIODICLISTBASE_RD(x) (HW_USB_UH3_PERIODICLISTBASE(x).U)
#define HW_USB_UH3_PERIODICLISTBASE_WR(x, v) (HW_USB_UH3_PERIODICLISTBASE(x).U = (v))
#define HW_USB_UH3_PERIODICLISTBASE_SET(x, v) (HW_USB_UH3_PERIODICLISTBASE_WR(x, HW_USB_UH3_PERIODICLISTBASE_RD(x) |  (v)))
#define HW_USB_UH3_PERIODICLISTBASE_CLR(x, v) (HW_USB_UH3_PERIODICLISTBASE_WR(x, HW_USB_UH3_PERIODICLISTBASE_RD(x) & ~(v)))
#define HW_USB_UH3_PERIODICLISTBASE_TOG(x, v) (HW_USB_UH3_PERIODICLISTBASE_WR(x, HW_USB_UH3_PERIODICLISTBASE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_PERIODICLISTBASE bitfields
 */

/*!
 * @name Register USB_UH3_PERIODICLISTBASE, field BASEADR[31:12] (RW)
 *
 * Base Address (Low). These bits correspond to memory address signals [31:12],
 * respectively. Only used by the host controller.
 */
/*@{*/
#define BP_USB_UH3_PERIODICLISTBASE_BASEADR (12U) /*!< Bit position for USB_UH3_PERIODICLISTBASE_BASEADR. */
#define BM_USB_UH3_PERIODICLISTBASE_BASEADR (0xFFFFF000U) /*!< Bit mask for USB_UH3_PERIODICLISTBASE_BASEADR. */
#define BS_USB_UH3_PERIODICLISTBASE_BASEADR (20U) /*!< Bit field size in bits for USB_UH3_PERIODICLISTBASE_BASEADR. */

/*! @brief Read current value of the USB_UH3_PERIODICLISTBASE_BASEADR field. */
#define BR_USB_UH3_PERIODICLISTBASE_BASEADR(x) (HW_USB_UH3_PERIODICLISTBASE(x).B.BASEADR)

/*! @brief Format value for bitfield USB_UH3_PERIODICLISTBASE_BASEADR. */
#define BF_USB_UH3_PERIODICLISTBASE_BASEADR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PERIODICLISTBASE_BASEADR) & BM_USB_UH3_PERIODICLISTBASE_BASEADR)

/*! @brief Set the BASEADR field to a new value. */
#define BW_USB_UH3_PERIODICLISTBASE_BASEADR(x, v) (HW_USB_UH3_PERIODICLISTBASE_WR(x, (HW_USB_UH3_PERIODICLISTBASE_RD(x) & ~BM_USB_UH3_PERIODICLISTBASE_BASEADR) | BF_USB_UH3_PERIODICLISTBASE_BASEADR(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_ASYNCLISTADDR - Next Asynch. Address
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_ASYNCLISTADDR - Next Asynch. Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * Host Controller only This 32-bit register contains the address of the next
 * asynchronous queue head to be executed by the host. Bits [4:0] of this register
 * cannot be modified by the system software and will always return a zero when
 * read.
 */
typedef union _hw_usb_uh3_asynclistaddr
{
    uint32_t U;
    struct _hw_usb_uh3_asynclistaddr_bitfields
    {
        uint32_t RESERVED0 : 5;        /*!< [4:0]  */
        uint32_t ASYBASE : 27;         /*!< [31:5]  */
    } B;
} hw_usb_uh3_asynclistaddr_t;

/*!
 * @name Constants and macros for entire USB_UH3_ASYNCLISTADDR register
 */
/*@{*/
#define HW_USB_UH3_ASYNCLISTADDR_ADDR(x) ((uintptr_t)(x) + 0x758U)

#define HW_USB_UH3_ASYNCLISTADDR(x) (*(__IO hw_usb_uh3_asynclistaddr_t *) HW_USB_UH3_ASYNCLISTADDR_ADDR(x))
#define HW_USB_UH3_ASYNCLISTADDR_RD(x) (HW_USB_UH3_ASYNCLISTADDR(x).U)
#define HW_USB_UH3_ASYNCLISTADDR_WR(x, v) (HW_USB_UH3_ASYNCLISTADDR(x).U = (v))
#define HW_USB_UH3_ASYNCLISTADDR_SET(x, v) (HW_USB_UH3_ASYNCLISTADDR_WR(x, HW_USB_UH3_ASYNCLISTADDR_RD(x) |  (v)))
#define HW_USB_UH3_ASYNCLISTADDR_CLR(x, v) (HW_USB_UH3_ASYNCLISTADDR_WR(x, HW_USB_UH3_ASYNCLISTADDR_RD(x) & ~(v)))
#define HW_USB_UH3_ASYNCLISTADDR_TOG(x, v) (HW_USB_UH3_ASYNCLISTADDR_WR(x, HW_USB_UH3_ASYNCLISTADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_ASYNCLISTADDR bitfields
 */

/*!
 * @name Register USB_UH3_ASYNCLISTADDR, field ASYBASE[31:5] (RW)
 *
 * Link Pointer Low (LPL). These bits correspond to memory address signals
 * [31:5], respectively. This field may only reference a Queue Head (QH). Only used by
 * the host controller.
 */
/*@{*/
#define BP_USB_UH3_ASYNCLISTADDR_ASYBASE (5U) /*!< Bit position for USB_UH3_ASYNCLISTADDR_ASYBASE. */
#define BM_USB_UH3_ASYNCLISTADDR_ASYBASE (0xFFFFFFE0U) /*!< Bit mask for USB_UH3_ASYNCLISTADDR_ASYBASE. */
#define BS_USB_UH3_ASYNCLISTADDR_ASYBASE (27U) /*!< Bit field size in bits for USB_UH3_ASYNCLISTADDR_ASYBASE. */

/*! @brief Read current value of the USB_UH3_ASYNCLISTADDR_ASYBASE field. */
#define BR_USB_UH3_ASYNCLISTADDR_ASYBASE(x) (HW_USB_UH3_ASYNCLISTADDR(x).B.ASYBASE)

/*! @brief Format value for bitfield USB_UH3_ASYNCLISTADDR_ASYBASE. */
#define BF_USB_UH3_ASYNCLISTADDR_ASYBASE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_ASYNCLISTADDR_ASYBASE) & BM_USB_UH3_ASYNCLISTADDR_ASYBASE)

/*! @brief Set the ASYBASE field to a new value. */
#define BW_USB_UH3_ASYNCLISTADDR_ASYBASE(x, v) (HW_USB_UH3_ASYNCLISTADDR_WR(x, (HW_USB_UH3_ASYNCLISTADDR_RD(x) & ~BM_USB_UH3_ASYNCLISTADDR_ASYBASE) | BF_USB_UH3_ASYNCLISTADDR_ASYBASE(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_BURSTSIZE - Programmable Burst Size
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_BURSTSIZE - Programmable Burst Size (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control the burst size used during data movement on
 * the AHB master interface. This register is ignored if AHBBRST bits in SBUSCFG
 * register is non-zero value.
 */
typedef union _hw_usb_uh3_burstsize
{
    uint32_t U;
    struct _hw_usb_uh3_burstsize_bitfields
    {
        uint32_t RXPBURST : 8;         /*!< [7:0]  */
        uint32_t TXPBURST : 9;         /*!< [16:8]  */
        uint32_t RESERVED0 : 15;       /*!< [31:17]  */
    } B;
} hw_usb_uh3_burstsize_t;

/*!
 * @name Constants and macros for entire USB_UH3_BURSTSIZE register
 */
/*@{*/
#define HW_USB_UH3_BURSTSIZE_ADDR(x) ((uintptr_t)(x) + 0x760U)

#define HW_USB_UH3_BURSTSIZE(x)  (*(__IO hw_usb_uh3_burstsize_t *) HW_USB_UH3_BURSTSIZE_ADDR(x))
#define HW_USB_UH3_BURSTSIZE_RD(x) (HW_USB_UH3_BURSTSIZE(x).U)
#define HW_USB_UH3_BURSTSIZE_WR(x, v) (HW_USB_UH3_BURSTSIZE(x).U = (v))
#define HW_USB_UH3_BURSTSIZE_SET(x, v) (HW_USB_UH3_BURSTSIZE_WR(x, HW_USB_UH3_BURSTSIZE_RD(x) |  (v)))
#define HW_USB_UH3_BURSTSIZE_CLR(x, v) (HW_USB_UH3_BURSTSIZE_WR(x, HW_USB_UH3_BURSTSIZE_RD(x) & ~(v)))
#define HW_USB_UH3_BURSTSIZE_TOG(x, v) (HW_USB_UH3_BURSTSIZE_WR(x, HW_USB_UH3_BURSTSIZE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_BURSTSIZE bitfields
 */

/*!
 * @name Register USB_UH3_BURSTSIZE, field RXPBURST[7:0] (RW)
 *
 * Programmable RX Burst Size. Default value is determined by TXBURST bits in
 * n_HWRXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from the USB bus to system memory.
 */
/*@{*/
#define BP_USB_UH3_BURSTSIZE_RXPBURST (0U) /*!< Bit position for USB_UH3_BURSTSIZE_RXPBURST. */
#define BM_USB_UH3_BURSTSIZE_RXPBURST (0x000000FFU) /*!< Bit mask for USB_UH3_BURSTSIZE_RXPBURST. */
#define BS_USB_UH3_BURSTSIZE_RXPBURST (8U) /*!< Bit field size in bits for USB_UH3_BURSTSIZE_RXPBURST. */

/*! @brief Read current value of the USB_UH3_BURSTSIZE_RXPBURST field. */
#define BR_USB_UH3_BURSTSIZE_RXPBURST(x) (HW_USB_UH3_BURSTSIZE(x).B.RXPBURST)

/*! @brief Format value for bitfield USB_UH3_BURSTSIZE_RXPBURST. */
#define BF_USB_UH3_BURSTSIZE_RXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_BURSTSIZE_RXPBURST) & BM_USB_UH3_BURSTSIZE_RXPBURST)

/*! @brief Set the RXPBURST field to a new value. */
#define BW_USB_UH3_BURSTSIZE_RXPBURST(x, v) (HW_USB_UH3_BURSTSIZE_WR(x, (HW_USB_UH3_BURSTSIZE_RD(x) & ~BM_USB_UH3_BURSTSIZE_RXPBURST) | BF_USB_UH3_BURSTSIZE_RXPBURST(v)))
/*@}*/

/*!
 * @name Register USB_UH3_BURSTSIZE, field TXPBURST[16:8] (RW)
 *
 * Programmable TX Burst Size. Default value is determined by TXBURST bits in
 * n_HWTXBUF. This register represents the maximum length of a the burst in 32-bit
 * words while moving data from system memory to the USB bus.
 */
/*@{*/
#define BP_USB_UH3_BURSTSIZE_TXPBURST (8U) /*!< Bit position for USB_UH3_BURSTSIZE_TXPBURST. */
#define BM_USB_UH3_BURSTSIZE_TXPBURST (0x0001FF00U) /*!< Bit mask for USB_UH3_BURSTSIZE_TXPBURST. */
#define BS_USB_UH3_BURSTSIZE_TXPBURST (9U) /*!< Bit field size in bits for USB_UH3_BURSTSIZE_TXPBURST. */

/*! @brief Read current value of the USB_UH3_BURSTSIZE_TXPBURST field. */
#define BR_USB_UH3_BURSTSIZE_TXPBURST(x) (HW_USB_UH3_BURSTSIZE(x).B.TXPBURST)

/*! @brief Format value for bitfield USB_UH3_BURSTSIZE_TXPBURST. */
#define BF_USB_UH3_BURSTSIZE_TXPBURST(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_BURSTSIZE_TXPBURST) & BM_USB_UH3_BURSTSIZE_TXPBURST)

/*! @brief Set the TXPBURST field to a new value. */
#define BW_USB_UH3_BURSTSIZE_TXPBURST(x, v) (HW_USB_UH3_BURSTSIZE_WR(x, (HW_USB_UH3_BURSTSIZE_RD(x) & ~BM_USB_UH3_BURSTSIZE_TXPBURST) | BF_USB_UH3_BURSTSIZE_TXPBURST(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_TXFILLTUNING - TX FIFO Fill Tuning
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_TXFILLTUNING - TX FIFO Fill Tuning (RW)
 *
 * Reset value: 0x00000808U
 *
 * The fields in this register control performance tuning associated with how
 * the host controller posts data to the TX latency FIFO before moving the data
 * onto the USB bus. The specific areas of performance include the how much data to
 * post into the FIFO and an estimate for how long that operation should take in
 * the target system. Definitions: T 0 = Standard packet overhead T 1 = Time to
 * send data payload T ff = Time to fetch packet into TX FIFO up to specified
 * level. T s = Total Packet Flight Time (send-only) packet T s = T 0 + T 1 T p =
 * Total Packet Time (fetch and send) packet T p = T ff + T 0 + T 1 Upon discovery
 * of a transmit (OUT/SETUP) packet in the data structures, host controller checks
 * to ensure T p remains before the end of the [micro]frame. If so it proceeds
 * to pre-fill the TX FIFO. If at anytime during the pre-fill operation the time
 * remaining the [micro]frame is < T s then the packet attempt ceases and the
 * packet is tried at a later time. Although this is not an error condition and the
 * host controller will eventually recover, a mark will be made the scheduler
 * health counter to note the occurrence of a "back-off" event. When a back-off event
 * is detected, the partial packet fetched may need to be discarded from the
 * latency buffer to make room for periodic traffic that will begin after the next
 * SOF. Too many back-off events can waste bandwidth and power on the system bus
 * and thus should be minimized (not necessarily eliminated). Back-offs can be
 * minimized with use of the n_TSCHHEALTH ( T ff ) described below. The reset value
 * could vary from instance to instance. Please see the detail in bit field
 * description and ignore reset value in summary table in this case!
 */
typedef union _hw_usb_uh3_txfilltuning
{
    uint32_t U;
    struct _hw_usb_uh3_txfilltuning_bitfields
    {
        uint32_t TXSCHOH : 8;          /*!< [7:0]  */
        uint32_t TXSCHHEALTH : 5;      /*!< [12:8]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t TXFIFOTHRES : 6;      /*!< [21:16]  */
        uint32_t RESERVED1 : 10;       /*!< [31:22]  */
    } B;
} hw_usb_uh3_txfilltuning_t;

/*!
 * @name Constants and macros for entire USB_UH3_TXFILLTUNING register
 */
/*@{*/
#define HW_USB_UH3_TXFILLTUNING_ADDR(x) ((uintptr_t)(x) + 0x764U)

#define HW_USB_UH3_TXFILLTUNING(x) (*(__IO hw_usb_uh3_txfilltuning_t *) HW_USB_UH3_TXFILLTUNING_ADDR(x))
#define HW_USB_UH3_TXFILLTUNING_RD(x) (HW_USB_UH3_TXFILLTUNING(x).U)
#define HW_USB_UH3_TXFILLTUNING_WR(x, v) (HW_USB_UH3_TXFILLTUNING(x).U = (v))
#define HW_USB_UH3_TXFILLTUNING_SET(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, HW_USB_UH3_TXFILLTUNING_RD(x) |  (v)))
#define HW_USB_UH3_TXFILLTUNING_CLR(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, HW_USB_UH3_TXFILLTUNING_RD(x) & ~(v)))
#define HW_USB_UH3_TXFILLTUNING_TOG(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, HW_USB_UH3_TXFILLTUNING_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_TXFILLTUNING bitfields
 */

/*!
 * @name Register USB_UH3_TXFILLTUNING, field TXSCHOH[7:0] (RW)
 *
 * Scheduler Overhead. (Read/Write) [Default = 0] This register adds an
 * additional fixed offset to the schedule time estimator described above as Tff. As an
 * approximation, the value chosen for this register should limit the number of
 * back-off events captured in the TXSCHHEALTH to less than 10 per second in a
 * highly utilized bus. Choosing a value that is too high for this register is not
 * desired as it can needlessly reduce USB utilization. The time unit represented
 * in this register is 1.267us when a device is connected in High-Speed Mode. The
 * time unit represented in this register is 6.333us when a device is connected
 * in Low/Full Speed Mode. Default value is '08h' for OTG controller core, and
 * '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_TXFILLTUNING_TXSCHOH (0U) /*!< Bit position for USB_UH3_TXFILLTUNING_TXSCHOH. */
#define BM_USB_UH3_TXFILLTUNING_TXSCHOH (0x000000FFU) /*!< Bit mask for USB_UH3_TXFILLTUNING_TXSCHOH. */
#define BS_USB_UH3_TXFILLTUNING_TXSCHOH (8U) /*!< Bit field size in bits for USB_UH3_TXFILLTUNING_TXSCHOH. */

/*! @brief Read current value of the USB_UH3_TXFILLTUNING_TXSCHOH field. */
#define BR_USB_UH3_TXFILLTUNING_TXSCHOH(x) (HW_USB_UH3_TXFILLTUNING(x).B.TXSCHOH)

/*! @brief Format value for bitfield USB_UH3_TXFILLTUNING_TXSCHOH. */
#define BF_USB_UH3_TXFILLTUNING_TXSCHOH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_TXFILLTUNING_TXSCHOH) & BM_USB_UH3_TXFILLTUNING_TXSCHOH)

/*! @brief Set the TXSCHOH field to a new value. */
#define BW_USB_UH3_TXFILLTUNING_TXSCHOH(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, (HW_USB_UH3_TXFILLTUNING_RD(x) & ~BM_USB_UH3_TXFILLTUNING_TXSCHOH) | BF_USB_UH3_TXFILLTUNING_TXSCHOH(v)))
/*@}*/

/*!
 * @name Register USB_UH3_TXFILLTUNING, field TXSCHHEALTH[12:8] (RW)
 *
 * Scheduler Health Counter. (Read/Write To Clear) This register increments when
 * the host controller fails to fill the TX latency FIFO to the level programmed
 * by TXFIFOTHRES before running out of time to send the packet before the next
 * Start-Of-Frame. This health counter measures the number of times this occurs
 * to provide feedback to selecting a proper TXSCHOH. Writing to this register
 * will clear the counter and this counter will max. at 31. Default value is '08h'
 * for OTG controller core, and '00h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_TXFILLTUNING_TXSCHHEALTH (8U) /*!< Bit position for USB_UH3_TXFILLTUNING_TXSCHHEALTH. */
#define BM_USB_UH3_TXFILLTUNING_TXSCHHEALTH (0x00001F00U) /*!< Bit mask for USB_UH3_TXFILLTUNING_TXSCHHEALTH. */
#define BS_USB_UH3_TXFILLTUNING_TXSCHHEALTH (5U) /*!< Bit field size in bits for USB_UH3_TXFILLTUNING_TXSCHHEALTH. */

/*! @brief Read current value of the USB_UH3_TXFILLTUNING_TXSCHHEALTH field. */
#define BR_USB_UH3_TXFILLTUNING_TXSCHHEALTH(x) (HW_USB_UH3_TXFILLTUNING(x).B.TXSCHHEALTH)

/*! @brief Format value for bitfield USB_UH3_TXFILLTUNING_TXSCHHEALTH. */
#define BF_USB_UH3_TXFILLTUNING_TXSCHHEALTH(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_TXFILLTUNING_TXSCHHEALTH) & BM_USB_UH3_TXFILLTUNING_TXSCHHEALTH)

/*! @brief Set the TXSCHHEALTH field to a new value. */
#define BW_USB_UH3_TXFILLTUNING_TXSCHHEALTH(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, (HW_USB_UH3_TXFILLTUNING_RD(x) & ~BM_USB_UH3_TXFILLTUNING_TXSCHHEALTH) | BF_USB_UH3_TXFILLTUNING_TXSCHHEALTH(v)))
/*@}*/

/*!
 * @name Register USB_UH3_TXFILLTUNING, field TXFIFOTHRES[21:16] (RW)
 *
 * FIFO Burst Threshold. (Read/Write) This register controls the number of data
 * bursts that are posted to the TX latency FIFO in host mode before the packet
 * begins on to the bus. The minimum value is 2 and this value should be a low as
 * possible to maximize USB performance. A higher value can be used in systems
 * with unpredictable latency and/or insufficient bandwidth where the FIFO may
 * underrun because the data transferred from the latency FIFO to USB occurs before
 * it can be replenished from system memory. This value is ignored if the Stream
 * Disable bit in USB_n_USBMODE register is set. Default value is '00h' for OTG
 * controller core, and '02h' for Host-only controller core.
 */
/*@{*/
#define BP_USB_UH3_TXFILLTUNING_TXFIFOTHRES (16U) /*!< Bit position for USB_UH3_TXFILLTUNING_TXFIFOTHRES. */
#define BM_USB_UH3_TXFILLTUNING_TXFIFOTHRES (0x003F0000U) /*!< Bit mask for USB_UH3_TXFILLTUNING_TXFIFOTHRES. */
#define BS_USB_UH3_TXFILLTUNING_TXFIFOTHRES (6U) /*!< Bit field size in bits for USB_UH3_TXFILLTUNING_TXFIFOTHRES. */

/*! @brief Read current value of the USB_UH3_TXFILLTUNING_TXFIFOTHRES field. */
#define BR_USB_UH3_TXFILLTUNING_TXFIFOTHRES(x) (HW_USB_UH3_TXFILLTUNING(x).B.TXFIFOTHRES)

/*! @brief Format value for bitfield USB_UH3_TXFILLTUNING_TXFIFOTHRES. */
#define BF_USB_UH3_TXFILLTUNING_TXFIFOTHRES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_TXFILLTUNING_TXFIFOTHRES) & BM_USB_UH3_TXFILLTUNING_TXFIFOTHRES)

/*! @brief Set the TXFIFOTHRES field to a new value. */
#define BW_USB_UH3_TXFILLTUNING_TXFIFOTHRES(x, v) (HW_USB_UH3_TXFILLTUNING_WR(x, (HW_USB_UH3_TXFILLTUNING_RD(x) & ~BM_USB_UH3_TXFILLTUNING_TXFIFOTHRES) | BF_USB_UH3_TXFILLTUNING_TXFIFOTHRES(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_CONFIGFLAG - Configure Flag Register
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_CONFIGFLAG - Configure Flag Register (RO)
 *
 * Reset value: 0x00000001U
 */
typedef union _hw_usb_uh3_configflag
{
    uint32_t U;
    struct _hw_usb_uh3_configflag_bitfields
    {
        uint32_t CF : 1;               /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_usb_uh3_configflag_t;

/*!
 * @name Constants and macros for entire USB_UH3_CONFIGFLAG register
 */
/*@{*/
#define HW_USB_UH3_CONFIGFLAG_ADDR(x) ((uintptr_t)(x) + 0x780U)

#define HW_USB_UH3_CONFIGFLAG(x) (*(__I hw_usb_uh3_configflag_t *) HW_USB_UH3_CONFIGFLAG_ADDR(x))
#define HW_USB_UH3_CONFIGFLAG_RD(x) (HW_USB_UH3_CONFIGFLAG(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_UH3_CONFIGFLAG bitfields
 */

/*!
 * @name Register USB_UH3_CONFIGFLAG, field CF[0] (RO)
 *
 * Configure Flag Host software sets this bit as the last action in its process
 * of configuring the Host Controller. This bit controls the default port-routing
 * control logic.
 *
 * Values:
 * - 0 - Port routing control logic default-routes each port to an
 *     implementation dependent classic host controller.
 * - 1 - Port routing control logic default-routes all ports to this host
 *     controller.
 */
/*@{*/
#define BP_USB_UH3_CONFIGFLAG_CF (0U)      /*!< Bit position for USB_UH3_CONFIGFLAG_CF. */
#define BM_USB_UH3_CONFIGFLAG_CF (0x00000001U) /*!< Bit mask for USB_UH3_CONFIGFLAG_CF. */
#define BS_USB_UH3_CONFIGFLAG_CF (1U)      /*!< Bit field size in bits for USB_UH3_CONFIGFLAG_CF. */

/*! @brief Read current value of the USB_UH3_CONFIGFLAG_CF field. */
#define BR_USB_UH3_CONFIGFLAG_CF(x) (HW_USB_UH3_CONFIGFLAG(x).B.CF)
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_PORTSC1 - Port Status & Control
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_PORTSC1 - Port Status & Control (RW)
 *
 * Reset value: 0x10000000U
 *
 * Host Controller A host controller could implement one to eight port status
 * and control registers. The number is determined by N_PORTs bits in HWSPARAMs
 * register (please see HCSPARAMSHost Controller Structural Parameters ). Software
 * could read this parameter register to determine how many ports need service.
 * All controller cores on this product are Single-Port, so there is only one port
 * status and control register for each controller core. This register is only
 * reset by power on reset or controller core reset. The initial conditions of a
 * port are: No device connected Port disabled If the port supports power control,
 * this state remains until port power is supplied (by software). Device
 * Controller A controller operating in device mode has only port register one (PORTSC1)
 * and it does not support power control in that mode. Port control in device
 * mode is only used for status port reset, suspend, and current connect status. It
 * is also used to initiate test mode or force signaling and allows software to
 * put the PHY into low power suspend mode and disable the PHY clock.
 */
typedef union _hw_usb_uh3_portsc1
{
    uint32_t U;
    struct _hw_usb_uh3_portsc1_bitfields
    {
        uint32_t CCS : 1;              /*!< [0]  */
        uint32_t CSC : 1;              /*!< [1]  */
        uint32_t PE : 1;               /*!< [2]  */
        uint32_t PEC : 1;              /*!< [3]  */
        uint32_t OCA : 1;              /*!< [4]  */
        uint32_t OCC : 1;              /*!< [5]  */
        uint32_t FPR : 1;              /*!< [6]  */
        uint32_t SUSP : 1;             /*!< [7]  */
        uint32_t PR : 1;               /*!< [8]  */
        uint32_t HSP : 1;              /*!< [9]  */
        uint32_t LS : 2;               /*!< [11:10]  */
        uint32_t PP : 1;               /*!< [12]  */
        uint32_t PO : 1;               /*!< [13]  */
        uint32_t PIC : 2;              /*!< [15:14]  */
        uint32_t PTC : 4;              /*!< [19:16]  */
        uint32_t WKCN : 1;             /*!< [20]  */
        uint32_t WKDC : 1;             /*!< [21]  */
        uint32_t WKOC : 1;             /*!< [22]  */
        uint32_t PHCD : 1;             /*!< [23]  */
        uint32_t PFSC : 1;             /*!< [24]  */
        uint32_t PTS_2 : 1;            /*!< [25]  */
        uint32_t PSPD : 2;             /*!< [27:26]  */
        uint32_t PTW : 1;              /*!< [28]  */
        uint32_t STS : 1;              /*!< [29]  */
        uint32_t PTS_1 : 2;            /*!< [31:30]  */
    } B;
} hw_usb_uh3_portsc1_t;

/*!
 * @name Constants and macros for entire USB_UH3_PORTSC1 register
 */
/*@{*/
#define HW_USB_UH3_PORTSC1_ADDR(x) ((uintptr_t)(x) + 0x784U)

#define HW_USB_UH3_PORTSC1(x)    (*(__IO hw_usb_uh3_portsc1_t *) HW_USB_UH3_PORTSC1_ADDR(x))
#define HW_USB_UH3_PORTSC1_RD(x) (HW_USB_UH3_PORTSC1(x).U)
#define HW_USB_UH3_PORTSC1_WR(x, v) (HW_USB_UH3_PORTSC1(x).U = (v))
#define HW_USB_UH3_PORTSC1_SET(x, v) (HW_USB_UH3_PORTSC1_WR(x, HW_USB_UH3_PORTSC1_RD(x) |  (v)))
#define HW_USB_UH3_PORTSC1_CLR(x, v) (HW_USB_UH3_PORTSC1_WR(x, HW_USB_UH3_PORTSC1_RD(x) & ~(v)))
#define HW_USB_UH3_PORTSC1_TOG(x, v) (HW_USB_UH3_PORTSC1_WR(x, HW_USB_UH3_PORTSC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_PORTSC1 bitfields
 */

/*!
 * @name Register USB_UH3_PORTSC1, field CCS[0] (RO)
 *
 * Current Connect Status-Read Only. In Host Mode: 1=Device is present on port.
 * 0=No device is present. Default = 0. This value reflects the current state of
 * the port, and may not correspond directly to the event that caused the Connect
 * Status Change bit (Bit 1) to be set. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: 1=Attached.
 * 0=Not Attached. Default=0. A one indicates that the device successfully attached
 * and is operating in either high speed or full speed as indicated by the High
 * Speed Port bit in this register. A zero indicates that the device did not
 * attach successfully or was forcibly disconnected by the software writing a zero to
 * the Run bit in the USBCMD register. It does not state the device being
 * disconnected or suspended.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_CCS (0U)        /*!< Bit position for USB_UH3_PORTSC1_CCS. */
#define BM_USB_UH3_PORTSC1_CCS (0x00000001U) /*!< Bit mask for USB_UH3_PORTSC1_CCS. */
#define BS_USB_UH3_PORTSC1_CCS (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_CCS. */

/*! @brief Read current value of the USB_UH3_PORTSC1_CCS field. */
#define BR_USB_UH3_PORTSC1_CCS(x) (HW_USB_UH3_PORTSC1(x).B.CCS)
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field CSC[1] (RW)
 *
 * Connect Status Change-R/WC. 1 =Change in Current Connect Status. 0=No change.
 * Default 0. In Host Mode: Indicates a change has occurred in the port's
 * Current Connect Status. The host/device controller sets this bit for all changes to
 * the port device connect status, even if system software has not cleared an
 * existing connect status change. For example, the insertion status changes twice
 * before system software has cleared the changed condition, hub hardware will be
 * 'setting' an already-set bit (that is, the bit will remain set). Software
 * clears this bit by writing a one to it. This field is zero if Port Power(
 * PORTSC1Port Status & Control ) is zero in host mode. In Device Mode: This bit is
 * undefined in device controller mode.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_CSC (1U)        /*!< Bit position for USB_UH3_PORTSC1_CSC. */
#define BM_USB_UH3_PORTSC1_CSC (0x00000002U) /*!< Bit mask for USB_UH3_PORTSC1_CSC. */
#define BS_USB_UH3_PORTSC1_CSC (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_CSC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_CSC field. */
#define BR_USB_UH3_PORTSC1_CSC(x) (HW_USB_UH3_PORTSC1(x).B.CSC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_CSC. */
#define BF_USB_UH3_PORTSC1_CSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_CSC) & BM_USB_UH3_PORTSC1_CSC)

/*! @brief Set the CSC field to a new value. */
#define BW_USB_UH3_PORTSC1_CSC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_CSC) | BF_USB_UH3_PORTSC1_CSC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PE[2] (RW)
 *
 * Port Enabled/Disabled-Read/Write. 1=Enable. 0=Disable. Default 0. In Host
 * Mode: Ports can only be enabled by the host controller as a part of the reset and
 * enable. Software cannot enable a port by writing a one to this field. Ports
 * can be disabled by either a fault condition (disconnect event or other fault
 * condition) or by the host software. Note that the bit status does not change
 * until the port state actually changes. There may be a delay in disabling or
 * enabling a port due to other host controller and bus events. When the port is
 * disabled, (0b) downstream propagation of data is blocked except for reset. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero in host mode.
 * In Device Mode: The device port is always enabled, so this bit is always '1b'.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PE (2U)         /*!< Bit position for USB_UH3_PORTSC1_PE. */
#define BM_USB_UH3_PORTSC1_PE (0x00000004U) /*!< Bit mask for USB_UH3_PORTSC1_PE. */
#define BS_USB_UH3_PORTSC1_PE (1U)         /*!< Bit field size in bits for USB_UH3_PORTSC1_PE. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PE field. */
#define BR_USB_UH3_PORTSC1_PE(x) (HW_USB_UH3_PORTSC1(x).B.PE)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PE. */
#define BF_USB_UH3_PORTSC1_PE(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PE) & BM_USB_UH3_PORTSC1_PE)

/*! @brief Set the PE field to a new value. */
#define BW_USB_UH3_PORTSC1_PE(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PE) | BF_USB_UH3_PORTSC1_PE(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PEC[3] (RW)
 *
 * Port Enable/Disable Change-R/WC. 1=Port enabled/disabled status has changed.
 * 0=No change. Default = 0. In Host Mode: For the root hub, this bit is set to a
 * one only when a port is disabled due to disconnect on the port or due to the
 * appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB
 * Specification). Software clears this by writing a one to it. This field is zero
 * if Port Power( PORTSC1Port Status & Control ) is zero. In Device mode: The
 * device port is always enabled, so this bit is always '0b'.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PEC (3U)        /*!< Bit position for USB_UH3_PORTSC1_PEC. */
#define BM_USB_UH3_PORTSC1_PEC (0x00000008U) /*!< Bit mask for USB_UH3_PORTSC1_PEC. */
#define BS_USB_UH3_PORTSC1_PEC (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_PEC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PEC field. */
#define BR_USB_UH3_PORTSC1_PEC(x) (HW_USB_UH3_PORTSC1(x).B.PEC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PEC. */
#define BF_USB_UH3_PORTSC1_PEC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PEC) & BM_USB_UH3_PORTSC1_PEC)

/*! @brief Set the PEC field to a new value. */
#define BW_USB_UH3_PORTSC1_PEC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PEC) | BF_USB_UH3_PORTSC1_PEC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field OCA[4] (RO)
 *
 * Over-current Active-Read Only. Default 0. This bit will automatically
 * transition from one to zero when the over current condition is removed.
 *
 * Values:
 * - 1 - This port currently has an over-current condition
 * - 0 - This port does not have an over-current condition.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_OCA (4U)        /*!< Bit position for USB_UH3_PORTSC1_OCA. */
#define BM_USB_UH3_PORTSC1_OCA (0x00000010U) /*!< Bit mask for USB_UH3_PORTSC1_OCA. */
#define BS_USB_UH3_PORTSC1_OCA (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_OCA. */

/*! @brief Read current value of the USB_UH3_PORTSC1_OCA field. */
#define BR_USB_UH3_PORTSC1_OCA(x) (HW_USB_UH3_PORTSC1(x).B.OCA)
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field OCC[5] (RW)
 *
 * Over-current Change-R/WC. Default=0. This bit is set '1b' by hardware when
 * there is a change to Over-current Active. Software can clear this bit by writing
 * a one to this bit position.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_OCC (5U)        /*!< Bit position for USB_UH3_PORTSC1_OCC. */
#define BM_USB_UH3_PORTSC1_OCC (0x00000020U) /*!< Bit mask for USB_UH3_PORTSC1_OCC. */
#define BS_USB_UH3_PORTSC1_OCC (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_OCC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_OCC field. */
#define BR_USB_UH3_PORTSC1_OCC(x) (HW_USB_UH3_PORTSC1(x).B.OCC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_OCC. */
#define BF_USB_UH3_PORTSC1_OCC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_OCC) & BM_USB_UH3_PORTSC1_OCC)

/*! @brief Set the OCC field to a new value. */
#define BW_USB_UH3_PORTSC1_OCC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_OCC) | BF_USB_UH3_PORTSC1_OCC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field FPR[6] (RW)
 *
 * Force Port Resume -Read/Write. 1= Resume detected/driven on port. 0=No resume
 * (K-state) detected/driven on port. Default = 0. In Host Mode: Software sets
 * this bit to one to drive resume signaling. The Host Controller sets this bit to
 * one if a J-to-K transition is detected while the port is in the Suspend
 * state. When this bit transitions to a one because a J-to-K transition is detected,
 * the Port Change Detect bit in the USBSTS register is also set to one. This bit
 * will automatically change to zero after the resume sequence is complete. This
 * behavior is different from EHCI where the host controller driver is required
 * to set this bit to a zero after the resume duration is timed in the driver.
 * Note that when the Host controller owns the port, the resume sequence follows
 * the defined sequence documented in the USB Specification Revision 2.0. The
 * resume signaling (Full-speed 'K') is driven on the port as long as this bit remains
 * a one. This bit will remain a one until the port has switched to the
 * high-speed idle. Writing a zero has no effect because the port controller will time
 * the resume operation, clear the bit the port control state switches to HS or FS
 * idle. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero
 * in host mode. This bit is not-EHCI compatible. In Device mode: After the
 * device has been in Suspend State for 5ms or more, software must set this bit to
 * one to drive resume signaling before clearing. The Device Controller will set
 * this bit to one if a J-to-K transition is detected while the port is in the
 * Suspend state. The bit will be cleared when the device returns to normal
 * operation. Also, when this bit wil be cleared because a K-to-J transition detected, the
 * Port Change Detect bit in the USBSTS register is also set to one.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_FPR (6U)        /*!< Bit position for USB_UH3_PORTSC1_FPR. */
#define BM_USB_UH3_PORTSC1_FPR (0x00000040U) /*!< Bit mask for USB_UH3_PORTSC1_FPR. */
#define BS_USB_UH3_PORTSC1_FPR (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_FPR. */

/*! @brief Read current value of the USB_UH3_PORTSC1_FPR field. */
#define BR_USB_UH3_PORTSC1_FPR(x) (HW_USB_UH3_PORTSC1(x).B.FPR)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_FPR. */
#define BF_USB_UH3_PORTSC1_FPR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_FPR) & BM_USB_UH3_PORTSC1_FPR)

/*! @brief Set the FPR field to a new value. */
#define BW_USB_UH3_PORTSC1_FPR(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_FPR) | BF_USB_UH3_PORTSC1_FPR(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field SUSP[7] (RW)
 *
 * Suspend - Read/Write or Read Only. Default = 0b. 1=Port in suspend state.
 * 0=Port not in suspend state. In Host Mode: Read/Write. Port Enabled Bit and
 * Suspend bit of this register define the port states as follows: Bits [Port Enabled,
 * Suspend] Port State 0x Disable 10 Enable 11 Suspend When in suspend state,
 * downstream propagation of data is blocked on this port, except for port reset.
 * The blocking occurs at the end of the current transaction if a transaction was
 * in progress when this bit was written to 1. In the suspend state, the port is
 * sensitive to resume detection. Note that the bit status does not change until
 * the port is suspended and that there may be a delay in suspending a port if
 * there is a transaction currently in progress on the USB. The host controller
 * will unconditionally set this bit to zero when software sets the Force Port
 * Resume bit to zero. The host controller ignores a write of zero to this bit. If
 * host software sets this bit to a one when the port is not enabled (that is, Port
 * enabled bit is a zero) the results are undefined. This field is zero if Port
 * Power( PORTSC1Port Status & Control ) is zero in host mode. In Device Mode:
 * Read Only. In device mode this bit is a read only status bit.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_SUSP (7U)       /*!< Bit position for USB_UH3_PORTSC1_SUSP. */
#define BM_USB_UH3_PORTSC1_SUSP (0x00000080U) /*!< Bit mask for USB_UH3_PORTSC1_SUSP. */
#define BS_USB_UH3_PORTSC1_SUSP (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_SUSP. */

/*! @brief Read current value of the USB_UH3_PORTSC1_SUSP field. */
#define BR_USB_UH3_PORTSC1_SUSP(x) (HW_USB_UH3_PORTSC1(x).B.SUSP)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_SUSP. */
#define BF_USB_UH3_PORTSC1_SUSP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_SUSP) & BM_USB_UH3_PORTSC1_SUSP)

/*! @brief Set the SUSP field to a new value. */
#define BW_USB_UH3_PORTSC1_SUSP(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_SUSP) | BF_USB_UH3_PORTSC1_SUSP(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PR[8] (RW)
 *
 * Port Reset - Read/Write or Read Only. Default = 0b. In Host Mode: Read/Write.
 * 1=Port is in Reset. 0=Port is not in Reset. Default 0. When software writes a
 * one to this bit the bus-reset sequence as defined in the USB Specification
 * Revision 2.0 is started. This bit will automatically change to zero after the
 * reset sequence is complete. This behavior is different from EHCI where the host
 * controller driver is required to set this bit to a zero after the reset
 * duration is timed in the driver. In Device Mode: This bit is a read only status bit.
 * Device reset from the USB bus is also indicated in the USBSTS register. This
 * field is zero if Port Power( PORTSC1Port Status & Control ) is zero.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PR (8U)         /*!< Bit position for USB_UH3_PORTSC1_PR. */
#define BM_USB_UH3_PORTSC1_PR (0x00000100U) /*!< Bit mask for USB_UH3_PORTSC1_PR. */
#define BS_USB_UH3_PORTSC1_PR (1U)         /*!< Bit field size in bits for USB_UH3_PORTSC1_PR. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PR field. */
#define BR_USB_UH3_PORTSC1_PR(x) (HW_USB_UH3_PORTSC1(x).B.PR)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PR. */
#define BF_USB_UH3_PORTSC1_PR(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PR) & BM_USB_UH3_PORTSC1_PR)

/*! @brief Set the PR field to a new value. */
#define BW_USB_UH3_PORTSC1_PR(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PR) | BF_USB_UH3_PORTSC1_PR(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field HSP[9] (RO)
 *
 * High-Speed Port - Read Only. Default = 0b. When the bit is one, the
 * host/device connected to the port is in high-speed mode and if set to zero, the
 * host/device connected to the port is not in a high-speed mode. HSP is redundant with
 * PSPD(bit 27, 26) but remained for compatibility.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_HSP (9U)        /*!< Bit position for USB_UH3_PORTSC1_HSP. */
#define BM_USB_UH3_PORTSC1_HSP (0x00000200U) /*!< Bit mask for USB_UH3_PORTSC1_HSP. */
#define BS_USB_UH3_PORTSC1_HSP (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_HSP. */

/*! @brief Read current value of the USB_UH3_PORTSC1_HSP field. */
#define BR_USB_UH3_PORTSC1_HSP(x) (HW_USB_UH3_PORTSC1(x).B.HSP)
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field LS[11:10] (RW)
 *
 * Line Status-Read Only. These bits reflect the current logical levels of the
 * D+ (bit 11) and D- (bit 10) signal lines. In host mode, the use of linestate by
 * the host controller driver is not necessary (unlike EHCI), because the port
 * controller state machine and the port routing manage the connection of LS and
 * FS. In device mode, the use of linestate by the device controller driver is not
 * necessary. The encoding of the bits are: Bits [11:10] Meaning
 *
 * Values:
 * - 00 - SE0
 * - 10 - J-state
 * - 01 - K-state
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_LS (10U)        /*!< Bit position for USB_UH3_PORTSC1_LS. */
#define BM_USB_UH3_PORTSC1_LS (0x00000C00U) /*!< Bit mask for USB_UH3_PORTSC1_LS. */
#define BS_USB_UH3_PORTSC1_LS (2U)         /*!< Bit field size in bits for USB_UH3_PORTSC1_LS. */

/*! @brief Read current value of the USB_UH3_PORTSC1_LS field. */
#define BR_USB_UH3_PORTSC1_LS(x) (HW_USB_UH3_PORTSC1(x).B.LS)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_LS. */
#define BF_USB_UH3_PORTSC1_LS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_LS) & BM_USB_UH3_PORTSC1_LS)

/*! @brief Set the LS field to a new value. */
#define BW_USB_UH3_PORTSC1_LS(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_LS) | BF_USB_UH3_PORTSC1_LS(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PP[12] (RW)
 *
 * Port Power (PP)-Read/Write or Read Only. The function of this bit depends on
 * the value of the Port Power Switching (PPC) field in the HCSPARAMS register.
 * The behavior is as follows: PPC PP Operation 0 1b Read Only - Host controller
 * does not have port power control switches. Each port is hard-wired to power. 1
 * 1b/0b - Read/Write. Host/OTG controller requires port power control switches.
 * This bit represents the current setting of the switch (0=off, 1=on). When
 * power is not available on a port (that is, PP equals a 0), the port is
 * non-functional and will not report attaches, detaches, etc. When an over-current
 * condition is detected on a powered port and PPC is a one, the PP bit in each affected
 * port may be transitional by the host controller driver from a one to a zero
 * (removing power from the port). This feature is implemented in all controller
 * cores (PPC = 1).
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PP (12U)        /*!< Bit position for USB_UH3_PORTSC1_PP. */
#define BM_USB_UH3_PORTSC1_PP (0x00001000U) /*!< Bit mask for USB_UH3_PORTSC1_PP. */
#define BS_USB_UH3_PORTSC1_PP (1U)         /*!< Bit field size in bits for USB_UH3_PORTSC1_PP. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PP field. */
#define BR_USB_UH3_PORTSC1_PP(x) (HW_USB_UH3_PORTSC1(x).B.PP)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PP. */
#define BF_USB_UH3_PORTSC1_PP(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PP) & BM_USB_UH3_PORTSC1_PP)

/*! @brief Set the PP field to a new value. */
#define BW_USB_UH3_PORTSC1_PP(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PP) | BF_USB_UH3_PORTSC1_PP(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PO[13] (RW)
 *
 * Port Owner-Read/Write. Default = 0. This bit unconditionally goes to a 0 when
 * the configured bit in the CONFIGFLAG register makes a 0 to 1 transition. This
 * bit unconditionally goes to 1 whenever the Configured bit is zero System
 * software uses this field to release ownership of the port to a selected host
 * controller (in the event that the attached device is not a high-speed device).
 * Software writes a one to this bit when the attached device is not a high-speed
 * device. A one in this bit means that an internal companion controller owns and
 * controls the port. Port owner handoff is not supported in all controller cores,
 * therefore this bit will always be 0.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PO (13U)        /*!< Bit position for USB_UH3_PORTSC1_PO. */
#define BM_USB_UH3_PORTSC1_PO (0x00002000U) /*!< Bit mask for USB_UH3_PORTSC1_PO. */
#define BS_USB_UH3_PORTSC1_PO (1U)         /*!< Bit field size in bits for USB_UH3_PORTSC1_PO. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PO field. */
#define BR_USB_UH3_PORTSC1_PO(x) (HW_USB_UH3_PORTSC1(x).B.PO)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PO. */
#define BF_USB_UH3_PORTSC1_PO(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PO) & BM_USB_UH3_PORTSC1_PO)

/*! @brief Set the PO field to a new value. */
#define BW_USB_UH3_PORTSC1_PO(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PO) | BF_USB_UH3_PORTSC1_PO(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PIC[15:14] (RW)
 *
 * Port Indicator Control - Read/Write. Default = Ob. Writing to this field has
 * no effect if the P_INDICATOR bit in the HCSPARAMS register is a zero. Refer to
 * the USB Specification Revision 2.0 for a description on how these bits are to
 * be used. This field is zero if Port Power is zero. Bit Value Meaning
 *
 * Values:
 * - 00 - Port indicators are off
 * - 01 - Amber
 * - 10 - Green
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PIC (14U)       /*!< Bit position for USB_UH3_PORTSC1_PIC. */
#define BM_USB_UH3_PORTSC1_PIC (0x0000C000U) /*!< Bit mask for USB_UH3_PORTSC1_PIC. */
#define BS_USB_UH3_PORTSC1_PIC (2U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_PIC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PIC field. */
#define BR_USB_UH3_PORTSC1_PIC(x) (HW_USB_UH3_PORTSC1(x).B.PIC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PIC. */
#define BF_USB_UH3_PORTSC1_PIC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PIC) & BM_USB_UH3_PORTSC1_PIC)

/*! @brief Set the PIC field to a new value. */
#define BW_USB_UH3_PORTSC1_PIC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PIC) | BF_USB_UH3_PORTSC1_PIC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PTC[19:16] (RW)
 *
 * Port Test Control - Read/Write. Default = 0000b. Refer to Port Test Mode for
 * the operational model for using these test modes and the USB Specification
 * Revision 2.0, Chapter 7 for details on each test mode. The FORCE_ENABLE_FS and
 * FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI
 * specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS}
 * values will force the port into the connected and enabled state at the selected
 * speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state
 * machines to progress normally from that point. Low speed operations are not
 * supported as a peripheral device. Any other value than zero indicates that the
 * port is operating in test mode. Value Specific Test
 *
 * Values:
 * - 0000 - TEST_MODE_DISABLE
 * - 0001 - J_STATE
 * - 0010 - K_STATE
 * - 0011 - SE0 (host) / NAK (device)
 * - 0100 - Packet
 * - 0101 - FORCE_ENABLE_HS
 * - 0110 - FORCE_ENABLE_FS
 * - 0111 - FORCE_ENABLE_LS
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PTC (16U)       /*!< Bit position for USB_UH3_PORTSC1_PTC. */
#define BM_USB_UH3_PORTSC1_PTC (0x000F0000U) /*!< Bit mask for USB_UH3_PORTSC1_PTC. */
#define BS_USB_UH3_PORTSC1_PTC (4U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_PTC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PTC field. */
#define BR_USB_UH3_PORTSC1_PTC(x) (HW_USB_UH3_PORTSC1(x).B.PTC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PTC. */
#define BF_USB_UH3_PORTSC1_PTC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PTC) & BM_USB_UH3_PORTSC1_PTC)

/*! @brief Set the PTC field to a new value. */
#define BW_USB_UH3_PORTSC1_PTC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PTC) | BF_USB_UH3_PORTSC1_PTC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field WKCN[20] (RW)
 *
 * Wake on Connect Enable (WKCNNT_E) - Read/Write. Default=0b. Writing this bit
 * to a one enables the port to be sensitive to device connects as wake-up
 * events. This field is zero if Port Power( PORTSC1Port Status & Control ) is zero or
 * in device mode.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_WKCN (20U)      /*!< Bit position for USB_UH3_PORTSC1_WKCN. */
#define BM_USB_UH3_PORTSC1_WKCN (0x00100000U) /*!< Bit mask for USB_UH3_PORTSC1_WKCN. */
#define BS_USB_UH3_PORTSC1_WKCN (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_WKCN. */

/*! @brief Read current value of the USB_UH3_PORTSC1_WKCN field. */
#define BR_USB_UH3_PORTSC1_WKCN(x) (HW_USB_UH3_PORTSC1(x).B.WKCN)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_WKCN. */
#define BF_USB_UH3_PORTSC1_WKCN(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_WKCN) & BM_USB_UH3_PORTSC1_WKCN)

/*! @brief Set the WKCN field to a new value. */
#define BW_USB_UH3_PORTSC1_WKCN(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_WKCN) | BF_USB_UH3_PORTSC1_WKCN(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field WKDC[21] (RW)
 *
 * Wake on Disconnect Enable (WKDSCNNT_E) - Read/Write. Default=0b. Writing this
 * bit to a one enables the port to be sensitive to device disconnects as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control ) is
 * zero or in device mode.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_WKDC (21U)      /*!< Bit position for USB_UH3_PORTSC1_WKDC. */
#define BM_USB_UH3_PORTSC1_WKDC (0x00200000U) /*!< Bit mask for USB_UH3_PORTSC1_WKDC. */
#define BS_USB_UH3_PORTSC1_WKDC (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_WKDC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_WKDC field. */
#define BR_USB_UH3_PORTSC1_WKDC(x) (HW_USB_UH3_PORTSC1(x).B.WKDC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_WKDC. */
#define BF_USB_UH3_PORTSC1_WKDC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_WKDC) & BM_USB_UH3_PORTSC1_WKDC)

/*! @brief Set the WKDC field to a new value. */
#define BW_USB_UH3_PORTSC1_WKDC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_WKDC) | BF_USB_UH3_PORTSC1_WKDC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field WKOC[22] (RW)
 *
 * Wake on Over-current Enable (WKOC_E) - Read/Write. Default = 0b. Writing this
 * bit to a one enables the port to be sensitive to over-current conditions as
 * wake-up events. This field is zero if Port Power( PORTSC1Port Status & Control
 * ) is zero.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_WKOC (22U)      /*!< Bit position for USB_UH3_PORTSC1_WKOC. */
#define BM_USB_UH3_PORTSC1_WKOC (0x00400000U) /*!< Bit mask for USB_UH3_PORTSC1_WKOC. */
#define BS_USB_UH3_PORTSC1_WKOC (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_WKOC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_WKOC field. */
#define BR_USB_UH3_PORTSC1_WKOC(x) (HW_USB_UH3_PORTSC1(x).B.WKOC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_WKOC. */
#define BF_USB_UH3_PORTSC1_WKOC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_WKOC) & BM_USB_UH3_PORTSC1_WKOC)

/*! @brief Set the WKOC field to a new value. */
#define BW_USB_UH3_PORTSC1_WKOC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_WKOC) | BF_USB_UH3_PORTSC1_WKOC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PHCD[23] (RW)
 *
 * PHY Low Power Suspend - Clock Disable (PLPSCD) - Read/Write. Default = 0b.
 * When this bit is set to '1b', the PHY clock is disabled. Reading this bit will
 * indicate the status of the PHY clock. The PHY clock cannot be disabled if it is
 * being used as the system clock. In device mode, The PHY can be put into Low
 * Power Suspend when the device is not running (USBCMD Run/Stop=0b) or the host
 * has signalled suspend (PORTSC1 SUSPEND=1b). PHY Low power suspend will be
 * cleared automatically when the host initials resume. Before forcing a resume from
 * the device, the device controller driver must clear this bit. In host mode, the
 * PHY can be put into Low Power Suspend when the downstream device has been put
 * into suspend mode or when no downstream device is connected. Low power
 * suspend is completely under the control of software.
 *
 * Values:
 * - 1 - Disable PHY clock
 * - 0 - Enable PHY clock
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PHCD (23U)      /*!< Bit position for USB_UH3_PORTSC1_PHCD. */
#define BM_USB_UH3_PORTSC1_PHCD (0x00800000U) /*!< Bit mask for USB_UH3_PORTSC1_PHCD. */
#define BS_USB_UH3_PORTSC1_PHCD (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_PHCD. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PHCD field. */
#define BR_USB_UH3_PORTSC1_PHCD(x) (HW_USB_UH3_PORTSC1(x).B.PHCD)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PHCD. */
#define BF_USB_UH3_PORTSC1_PHCD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PHCD) & BM_USB_UH3_PORTSC1_PHCD)

/*! @brief Set the PHCD field to a new value. */
#define BW_USB_UH3_PORTSC1_PHCD(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PHCD) | BF_USB_UH3_PORTSC1_PHCD(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PFSC[24] (RW)
 *
 * Port Force Full Speed Connect - Read/Write. Default = 0b. When this bit is
 * set to '1b', the port will be forced to only connect at Full Speed, It disables
 * the chirp sequence that allows the port to identify itself as High Speed.
 *
 * Values:
 * - 1 - Forced to full speed
 * - 0 - Normal operation
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PFSC (24U)      /*!< Bit position for USB_UH3_PORTSC1_PFSC. */
#define BM_USB_UH3_PORTSC1_PFSC (0x01000000U) /*!< Bit mask for USB_UH3_PORTSC1_PFSC. */
#define BS_USB_UH3_PORTSC1_PFSC (1U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_PFSC. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PFSC field. */
#define BR_USB_UH3_PORTSC1_PFSC(x) (HW_USB_UH3_PORTSC1(x).B.PFSC)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PFSC. */
#define BF_USB_UH3_PORTSC1_PFSC(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PFSC) & BM_USB_UH3_PORTSC1_PFSC)

/*! @brief Set the PFSC field to a new value. */
#define BW_USB_UH3_PORTSC1_PFSC(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PFSC) | BF_USB_UH3_PORTSC1_PFSC(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PTS_2[25] (RW)
 *
 * See description at bits 31-30
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PTS_2 (25U)     /*!< Bit position for USB_UH3_PORTSC1_PTS_2. */
#define BM_USB_UH3_PORTSC1_PTS_2 (0x02000000U) /*!< Bit mask for USB_UH3_PORTSC1_PTS_2. */
#define BS_USB_UH3_PORTSC1_PTS_2 (1U)      /*!< Bit field size in bits for USB_UH3_PORTSC1_PTS_2. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PTS_2 field. */
#define BR_USB_UH3_PORTSC1_PTS_2(x) (HW_USB_UH3_PORTSC1(x).B.PTS_2)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PTS_2. */
#define BF_USB_UH3_PORTSC1_PTS_2(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PTS_2) & BM_USB_UH3_PORTSC1_PTS_2)

/*! @brief Set the PTS_2 field to a new value. */
#define BW_USB_UH3_PORTSC1_PTS_2(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PTS_2) | BF_USB_UH3_PORTSC1_PTS_2(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PSPD[27:26] (RW)
 *
 * Port Speed - Read Only. This register field indicates the speed at which the
 * port is operating.
 *
 * Values:
 * - 00 - Full Speed
 * - 01 - Low Speed
 * - 10 - High Speed
 * - 11 - Undefined
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PSPD (26U)      /*!< Bit position for USB_UH3_PORTSC1_PSPD. */
#define BM_USB_UH3_PORTSC1_PSPD (0x0C000000U) /*!< Bit mask for USB_UH3_PORTSC1_PSPD. */
#define BS_USB_UH3_PORTSC1_PSPD (2U)       /*!< Bit field size in bits for USB_UH3_PORTSC1_PSPD. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PSPD field. */
#define BR_USB_UH3_PORTSC1_PSPD(x) (HW_USB_UH3_PORTSC1(x).B.PSPD)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PSPD. */
#define BF_USB_UH3_PORTSC1_PSPD(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PSPD) & BM_USB_UH3_PORTSC1_PSPD)

/*! @brief Set the PSPD field to a new value. */
#define BW_USB_UH3_PORTSC1_PSPD(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PSPD) | BF_USB_UH3_PORTSC1_PSPD(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PTW[28] (RW)
 *
 * Parallel Transceiver Width This bit has no effect if serial interface engine
 * is used. For OTG/Host1/Host2/Host3 core, it is Read-Only. Reset value is '1b'.
 *
 * Values:
 * - 0 - Select the 8-bit UTMI interface [60MHz]
 * - 1 - Select the 16-bit UTMI interface [30MHz]
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PTW (28U)       /*!< Bit position for USB_UH3_PORTSC1_PTW. */
#define BM_USB_UH3_PORTSC1_PTW (0x10000000U) /*!< Bit mask for USB_UH3_PORTSC1_PTW. */
#define BS_USB_UH3_PORTSC1_PTW (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_PTW. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PTW field. */
#define BR_USB_UH3_PORTSC1_PTW(x) (HW_USB_UH3_PORTSC1(x).B.PTW)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PTW. */
#define BF_USB_UH3_PORTSC1_PTW(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PTW) & BM_USB_UH3_PORTSC1_PTW)

/*! @brief Set the PTW field to a new value. */
#define BW_USB_UH3_PORTSC1_PTW(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PTW) | BF_USB_UH3_PORTSC1_PTW(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field STS[29] (RW)
 *
 * Serial Transceiver Select - Read Only Serial Transceiver Select 1 Serial
 * Interface Engine is selected 0 Parallel Interface signals is selected Serial
 * Interface Engine can be used in combination with UTMI+/ULPI physical interface to
 * provide FS/LS signaling instead of the parallel interface signals. When this
 * bit is set '1b', serial interface engine will be used instead of parallel
 * interface signals. This bit has no effect unless PTS bits is set to select
 * UTMI+/ULPI interface. The Serial/USB1.1 PHY/IC-USB will use the serial interface engine
 * for FS/LS signaling regardless of this bit value.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_STS (29U)       /*!< Bit position for USB_UH3_PORTSC1_STS. */
#define BM_USB_UH3_PORTSC1_STS (0x20000000U) /*!< Bit mask for USB_UH3_PORTSC1_STS. */
#define BS_USB_UH3_PORTSC1_STS (1U)        /*!< Bit field size in bits for USB_UH3_PORTSC1_STS. */

/*! @brief Read current value of the USB_UH3_PORTSC1_STS field. */
#define BR_USB_UH3_PORTSC1_STS(x) (HW_USB_UH3_PORTSC1(x).B.STS)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_STS. */
#define BF_USB_UH3_PORTSC1_STS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_STS) & BM_USB_UH3_PORTSC1_STS)

/*! @brief Set the STS field to a new value. */
#define BW_USB_UH3_PORTSC1_STS(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_STS) | BF_USB_UH3_PORTSC1_STS(v)))
/*@}*/

/*!
 * @name Register USB_UH3_PORTSC1, field PTS_1[31:30] (RW)
 *
 * Bit field {bit25, bit31, bit30}: "000b" UTMI/UTMI+ "001b" Reserved "010b"
 * ULPI "011b" Serial/USB 1.1 PHY/IC-USB (FS Only) "100b" HSIC Parallel Transceiver
 * Select (bit25, bit31, bi30). For OTG core, it is Read-Only. Reset value is
 * 000b. For Host1/Host2/Host3 core, it is Read/Write. Reset value is 000b. All USB
 * port interface modes are listed in this field description, but not all are
 * supported. For detail feature of each controller core, please see Features . The
 * behaviour is unknown when unsupported interface mode is selected.
 */
/*@{*/
#define BP_USB_UH3_PORTSC1_PTS_1 (30U)     /*!< Bit position for USB_UH3_PORTSC1_PTS_1. */
#define BM_USB_UH3_PORTSC1_PTS_1 (0xC0000000U) /*!< Bit mask for USB_UH3_PORTSC1_PTS_1. */
#define BS_USB_UH3_PORTSC1_PTS_1 (2U)      /*!< Bit field size in bits for USB_UH3_PORTSC1_PTS_1. */

/*! @brief Read current value of the USB_UH3_PORTSC1_PTS_1 field. */
#define BR_USB_UH3_PORTSC1_PTS_1(x) (HW_USB_UH3_PORTSC1(x).B.PTS_1)

/*! @brief Format value for bitfield USB_UH3_PORTSC1_PTS_1. */
#define BF_USB_UH3_PORTSC1_PTS_1(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_PORTSC1_PTS_1) & BM_USB_UH3_PORTSC1_PTS_1)

/*! @brief Set the PTS_1 field to a new value. */
#define BW_USB_UH3_PORTSC1_PTS_1(x, v) (HW_USB_UH3_PORTSC1_WR(x, (HW_USB_UH3_PORTSC1_RD(x) & ~BM_USB_UH3_PORTSC1_PTS_1) | BF_USB_UH3_PORTSC1_PTS_1(v)))
/*@}*/

/*******************************************************************************
 * HW_USB_UH3_USBMODE - USB Device Mode
 ******************************************************************************/

/*!
 * @brief HW_USB_UH3_USBMODE - USB Device Mode (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_usb_uh3_usbmode
{
    uint32_t U;
    struct _hw_usb_uh3_usbmode_bitfields
    {
        uint32_t CM : 2;               /*!< [1:0]  */
        uint32_t ES : 1;               /*!< [2]  */
        uint32_t SLOM : 1;             /*!< [3]  */
        uint32_t SDIS : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_usb_uh3_usbmode_t;

/*!
 * @name Constants and macros for entire USB_UH3_USBMODE register
 */
/*@{*/
#define HW_USB_UH3_USBMODE_ADDR(x) ((uintptr_t)(x) + 0x7A8U)

#define HW_USB_UH3_USBMODE(x)    (*(__IO hw_usb_uh3_usbmode_t *) HW_USB_UH3_USBMODE_ADDR(x))
#define HW_USB_UH3_USBMODE_RD(x) (HW_USB_UH3_USBMODE(x).U)
#define HW_USB_UH3_USBMODE_WR(x, v) (HW_USB_UH3_USBMODE(x).U = (v))
#define HW_USB_UH3_USBMODE_SET(x, v) (HW_USB_UH3_USBMODE_WR(x, HW_USB_UH3_USBMODE_RD(x) |  (v)))
#define HW_USB_UH3_USBMODE_CLR(x, v) (HW_USB_UH3_USBMODE_WR(x, HW_USB_UH3_USBMODE_RD(x) & ~(v)))
#define HW_USB_UH3_USBMODE_TOG(x, v) (HW_USB_UH3_USBMODE_WR(x, HW_USB_UH3_USBMODE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USB_UH3_USBMODE bitfields
 */

/*!
 * @name Register USB_UH3_USBMODE, field CM[1:0] (RW)
 *
 * Controller Mode - R/WO. Controller mode is defaulted to the proper mode for
 * host only and device only implementations. For those designs that contain both
 * host & device capability, the controller defaults to an idle state and needs
 * to be initialized to the desired operating mode after reset. For combination
 * host/device controllers, this register can only be written once after reset. If
 * it is necessary to switch modes, software must reset the controller by writing
 * to the RESET bit in the USBCMD register before reprogramming this register.
 * For OTG controller core, reset value is '00b'. For Host-only controller core,
 * reset value is '11b'.
 *
 * Values:
 * - 00 - Idle [Default for combination host/device]
 * - 01 - Reserved
 * - 10 - Device Controller [Default for device only controller]
 * - 11 - Host Controller [Default for host only controller]
 */
/*@{*/
#define BP_USB_UH3_USBMODE_CM (0U)         /*!< Bit position for USB_UH3_USBMODE_CM. */
#define BM_USB_UH3_USBMODE_CM (0x00000003U) /*!< Bit mask for USB_UH3_USBMODE_CM. */
#define BS_USB_UH3_USBMODE_CM (2U)         /*!< Bit field size in bits for USB_UH3_USBMODE_CM. */

/*! @brief Read current value of the USB_UH3_USBMODE_CM field. */
#define BR_USB_UH3_USBMODE_CM(x) (HW_USB_UH3_USBMODE(x).B.CM)

/*! @brief Format value for bitfield USB_UH3_USBMODE_CM. */
#define BF_USB_UH3_USBMODE_CM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBMODE_CM) & BM_USB_UH3_USBMODE_CM)

/*! @brief Set the CM field to a new value. */
#define BW_USB_UH3_USBMODE_CM(x, v) (HW_USB_UH3_USBMODE_WR(x, (HW_USB_UH3_USBMODE_RD(x) & ~BM_USB_UH3_USBMODE_CM) | BF_USB_UH3_USBMODE_CM(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBMODE, field ES[2] (RW)
 *
 * Endian Select - Read/Write. This bit can change the byte alignment of the
 * transfer buffers to match the host microprocessor. The bit fields in the
 * microprocessor interface and the data structures are unaffected by the value of this
 * bit because they are based upon the 32-bit word. Bit Meaning
 *
 * Values:
 * - 0 - Little Endian [Default]
 * - 1 - Big Endian
 */
/*@{*/
#define BP_USB_UH3_USBMODE_ES (2U)         /*!< Bit position for USB_UH3_USBMODE_ES. */
#define BM_USB_UH3_USBMODE_ES (0x00000004U) /*!< Bit mask for USB_UH3_USBMODE_ES. */
#define BS_USB_UH3_USBMODE_ES (1U)         /*!< Bit field size in bits for USB_UH3_USBMODE_ES. */

/*! @brief Read current value of the USB_UH3_USBMODE_ES field. */
#define BR_USB_UH3_USBMODE_ES(x) (HW_USB_UH3_USBMODE(x).B.ES)

/*! @brief Format value for bitfield USB_UH3_USBMODE_ES. */
#define BF_USB_UH3_USBMODE_ES(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBMODE_ES) & BM_USB_UH3_USBMODE_ES)

/*! @brief Set the ES field to a new value. */
#define BW_USB_UH3_USBMODE_ES(x, v) (HW_USB_UH3_USBMODE_WR(x, (HW_USB_UH3_USBMODE_RD(x) & ~BM_USB_UH3_USBMODE_ES) | BF_USB_UH3_USBMODE_ES(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBMODE, field SLOM[3] (RW)
 *
 * Setup Lockout Mode. In device mode, this bit controls behavior of the setup
 * lock mechanism. See Control Endpoint Operation Model .
 *
 * Values:
 * - 0 - Setup Lockouts On (default);
 * - 1 - Setup Lockouts Off (DCD requires use of Setup Data Buffer Tripwire in
 *     USBCMDUSB Command Register .
 */
/*@{*/
#define BP_USB_UH3_USBMODE_SLOM (3U)       /*!< Bit position for USB_UH3_USBMODE_SLOM. */
#define BM_USB_UH3_USBMODE_SLOM (0x00000008U) /*!< Bit mask for USB_UH3_USBMODE_SLOM. */
#define BS_USB_UH3_USBMODE_SLOM (1U)       /*!< Bit field size in bits for USB_UH3_USBMODE_SLOM. */

/*! @brief Read current value of the USB_UH3_USBMODE_SLOM field. */
#define BR_USB_UH3_USBMODE_SLOM(x) (HW_USB_UH3_USBMODE(x).B.SLOM)

/*! @brief Format value for bitfield USB_UH3_USBMODE_SLOM. */
#define BF_USB_UH3_USBMODE_SLOM(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBMODE_SLOM) & BM_USB_UH3_USBMODE_SLOM)

/*! @brief Set the SLOM field to a new value. */
#define BW_USB_UH3_USBMODE_SLOM(x, v) (HW_USB_UH3_USBMODE_WR(x, (HW_USB_UH3_USBMODE_RD(x) & ~BM_USB_UH3_USBMODE_SLOM) | BF_USB_UH3_USBMODE_SLOM(v)))
/*@}*/

/*!
 * @name Register USB_UH3_USBMODE, field SDIS[4] (RW)
 *
 * Stream Disable Mode. (0 - Inactive [default]; 1 - Active) Device Mode:
 * Setting to a '1' disables double priming on both RX and TX for low bandwidth
 * systems. This mode ensures that when the RX and TX buffers are sufficient to contain
 * an entire packet that the standard double buffering scheme is disabled to
 * prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode,
 * all packets received are responded to with a NYET handshake when stream
 * disable is active. Host Mode: Setting to a '1' ensures that overruns/underruns of
 * the latency FIFO are eliminated for low bandwidth systems where the RX and TX
 * buffers are sufficient to contain the entire packet. Enabling stream disable
 * also has the effect of ensuring the TX latency is filled to capacity before the
 * packet is launched onto the USB. Time duration to pre-fill the FIFO becomes
 * significant when stream disable is active. See TXFILLTUNINGTX FIFO Fill Tuning
 * and TXTTFILLTUNING [MPH Only] to characterize the adjustments needed for the
 * scheduler when using this feature. The use of this feature substantially limits
 * of the overall USB performance that can be achieved.
 */
/*@{*/
#define BP_USB_UH3_USBMODE_SDIS (4U)       /*!< Bit position for USB_UH3_USBMODE_SDIS. */
#define BM_USB_UH3_USBMODE_SDIS (0x00000010U) /*!< Bit mask for USB_UH3_USBMODE_SDIS. */
#define BS_USB_UH3_USBMODE_SDIS (1U)       /*!< Bit field size in bits for USB_UH3_USBMODE_SDIS. */

/*! @brief Read current value of the USB_UH3_USBMODE_SDIS field. */
#define BR_USB_UH3_USBMODE_SDIS(x) (HW_USB_UH3_USBMODE(x).B.SDIS)

/*! @brief Format value for bitfield USB_UH3_USBMODE_SDIS. */
#define BF_USB_UH3_USBMODE_SDIS(v) ((uint32_t)((uint32_t)(v) << BP_USB_UH3_USBMODE_SDIS) & BM_USB_UH3_USBMODE_SDIS)

/*! @brief Set the SDIS field to a new value. */
#define BW_USB_UH3_USBMODE_SDIS(x, v) (HW_USB_UH3_USBMODE_WR(x, (HW_USB_UH3_USBMODE_RD(x) & ~BM_USB_UH3_USBMODE_SDIS) | BF_USB_UH3_USBMODE_SDIS(v)))
/*@}*/

/*
** Start of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=extended
#else
  #error Not supported compiler type
#endif

/*******************************************************************************
 * hw_usb_t - module struct
 ******************************************************************************/
/*!
 * @brief All USB module registers.
 */
#pragma pack(1)
typedef struct _hw_usb
{
    __I hw_usb_uog_id_t UOG_ID;            /*!< [0x0] Identification register */
    __I hw_usb_uog_hwgeneral_t UOG_HWGENERAL; /*!< [0x4] Hardware General */
    __I hw_usb_uog_hwhost_t UOG_HWHOST;    /*!< [0x8] Host Hardware Parameters */
    __I hw_usb_uog_hwdevice_t UOG_HWDEVICE; /*!< [0xC] Device Hardware Parameters */
    __I hw_usb_uog_hwtxbuf_t UOG_HWTXBUF;  /*!< [0x10] TX Buffer Hardware Parameters */
    __I hw_usb_uog_hwrxbuf_t UOG_HWRXBUF;  /*!< [0x14] RX Buffer Hardware Parameters */
    uint8_t _reserved0[104];
    __IO hw_usb_uog_gptimer0ld_t UOG_GPTIMER0LD; /*!< [0x80] General Purpose Timer #0 Load */
    __IO hw_usb_uog_gptimer0ctrl_t UOG_GPTIMER0CTRL; /*!< [0x84] General Purpose Timer #0 Controller */
    __IO hw_usb_uog_gptimer1ld_t UOG_GPTIMER1LD; /*!< [0x88] General Purpose Timer #1 Load */
    __IO hw_usb_uog_gptimer1ctrl_t UOG_GPTIMER1CTRL; /*!< [0x8C] General Purpose Timer #1 Controller */
    __IO hw_usb_uog_sbuscfg_t UOG_SBUSCFG; /*!< [0x90] System Bus Config */
    uint8_t _reserved1[108];
    __I hw_usb_uog_caplength_t UOG_CAPLENGTH; /*!< [0x100] Capability Registers Length */
    uint8_t _reserved2[1];
    __I hw_usb_uog_hciversion_t UOG_HCIVERSION; /*!< [0x102] Host Controller Interface Version */
    __I hw_usb_uog_hcsparams_t UOG_HCSPARAMS; /*!< [0x104] Host Controller Structural Parameters */
    __I hw_usb_uog_hccparams_t UOG_HCCPARAMS; /*!< [0x108] Host Controller Capability Parameters */
    uint8_t _reserved3[20];
    __I hw_usb_uog_dciversion_t UOG_DCIVERSION; /*!< [0x120] Device Controller Interface Version */
    uint8_t _reserved4[2];
    __I hw_usb_uog_dccparams_t UOG_DCCPARAMS; /*!< [0x124] Device Controller Capability Parameters */
    uint8_t _reserved5[24];
    __IO hw_usb_uog_usbcmd_t UOG_USBCMD;   /*!< [0x140] USB Command Register */
    __IO hw_usb_uog_usbsts_t UOG_USBSTS;   /*!< [0x144] USB Status Register */
    __IO hw_usb_uog_usbintr_t UOG_USBINTR; /*!< [0x148] Interrupt Enable Register */
    __IO hw_usb_uog_frindex_t UOG_FRINDEX; /*!< [0x14C] USB Frame Index */
    uint8_t _reserved6[4];
    union {
        __IO hw_usb_uog_deviceaddr_t UOG_DEVICEADDR; /*!< [0x154] Device Address */
        __IO hw_usb_uog_periodiclistbase_t UOG_PERIODICLISTBASE; /*!< [0x154] Frame List Base Address */
    };
    union {
        __IO hw_usb_uog_asynclistaddr_t UOG_ASYNCLISTADDR; /*!< [0x158] Next Asynch. Address */
        __IO hw_usb_uog_endptlistaddr_t UOG_ENDPTLISTADDR; /*!< [0x158] Endpoint List Address */
    };
    uint8_t _reserved7[4];
    __IO hw_usb_uog_burstsize_t UOG_BURSTSIZE; /*!< [0x160] Programmable Burst Size */
    __IO hw_usb_uog_txfilltuning_t UOG_TXFILLTUNING; /*!< [0x164] TX FIFO Fill Tuning */
    uint8_t _reserved8[16];
    __IO hw_usb_uog_endptnak_t UOG_ENDPTNAK; /*!< [0x178] Endpoint NAK */
    __IO hw_usb_uog_endptnaken_t UOG_ENDPTNAKEN; /*!< [0x17C] Endpoint NAK Enable */
    __I hw_usb_uog_configflag_t UOG_CONFIGFLAG; /*!< [0x180] Configure Flag Register */
    __IO hw_usb_uog_portsc1_t UOG_PORTSC1; /*!< [0x184] Port Status & Control */
    uint8_t _reserved9[28];
    __IO hw_usb_uog_otgsc_t UOG_OTGSC;     /*!< [0x1A4] On-The-Go Status & control */
    __IO hw_usb_uog_usbmode_t UOG_USBMODE; /*!< [0x1A8] USB Device Mode */
    __IO hw_usb_uog_endptsetupstat_t UOG_ENDPTSETUPSTAT; /*!< [0x1AC] Endpoint Setup Status */
    __IO hw_usb_uog_endptprime_t UOG_ENDPTPRIME; /*!< [0x1B0] Endpoint Prime */
    __IO hw_usb_uog_endptflush_t UOG_ENDPTFLUSH; /*!< [0x1B4] Endpoint Flush */
    __I hw_usb_uog_endptstat_t UOG_ENDPTSTAT; /*!< [0x1B8] Endpoint Status */
    __IO hw_usb_uog_endptcomplete_t UOG_ENDPTCOMPLETE; /*!< [0x1BC] Endpoint Complete */
    __IO hw_usb_uog_endptctrl0_t UOG_ENDPTCTRL0; /*!< [0x1C0] Endpoint Control0 */
    __IO hw_usb_uog_endptctrl1_t UOG_ENDPTCTRL1; /*!< [0x1C4] Endpoint Control 1 */
    __IO hw_usb_uog_endptctrl2_t UOG_ENDPTCTRL2; /*!< [0x1C8] Endpoint Control 2 */
    __IO hw_usb_uog_endptctrl3_t UOG_ENDPTCTRL3; /*!< [0x1CC] Endpoint Control 3 */
    __IO hw_usb_uog_endptctrl4_t UOG_ENDPTCTRL4; /*!< [0x1D0] Endpoint Control 4 */
    __IO hw_usb_uog_endptctrl5_t UOG_ENDPTCTRL5; /*!< [0x1D4] Endpoint Control 5 */
    __IO hw_usb_uog_endptctrl6_t UOG_ENDPTCTRL6; /*!< [0x1D8] Endpoint Control 6 */
    __IO hw_usb_uog_endptctrl7_t UOG_ENDPTCTRL7; /*!< [0x1DC] Endpoint Control 7 */
    uint8_t _reserved10[32];
    __I hw_usb_uh1_id_t UH1_ID;            /*!< [0x200] Identification register */
    __I hw_usb_uh1_hwgeneral_t UH1_HWGENERAL; /*!< [0x204] Hardware General */
    __I hw_usb_uh1_hwhost_t UH1_HWHOST;    /*!< [0x208] Host Hardware Parameters */
    uint8_t _reserved11[4];
    __I hw_usb_uh1_hwtxbuf_t UH1_HWTXBUF;  /*!< [0x210] TX Buffer Hardware Parameters */
    __I hw_usb_uh1_hwrxbuf_t UH1_HWRXBUF;  /*!< [0x214] RX Buffer Hardware Parameters */
    uint8_t _reserved12[104];
    __IO hw_usb_uh1_gptimer0ld_t UH1_GPTIMER0LD; /*!< [0x280] General Purpose Timer #0 Load */
    __IO hw_usb_uh1_gptimer0ctrl_t UH1_GPTIMER0CTRL; /*!< [0x284] General Purpose Timer #0 Controller */
    __IO hw_usb_uh1_gptimer1ld_t UH1_GPTIMER1LD; /*!< [0x288] General Purpose Timer #1 Load */
    __IO hw_usb_uh1_gptimer1ctrl_t UH1_GPTIMER1CTRL; /*!< [0x28C] General Purpose Timer #1 Controller */
    __IO hw_usb_uh1_sbuscfg_t UH1_SBUSCFG; /*!< [0x290] System Bus Config */
    uint8_t _reserved13[108];
    __I hw_usb_uh1_caplength_t UH1_CAPLENGTH; /*!< [0x300] Capability Registers Length */
    uint8_t _reserved14[1];
    __I hw_usb_uh1_hciversion_t UH1_HCIVERSION; /*!< [0x302] Host Controller Interface Version */
    __I hw_usb_uh1_hcsparams_t UH1_HCSPARAMS; /*!< [0x304] Host Controller Structural Parameters */
    __I hw_usb_uh1_hccparams_t UH1_HCCPARAMS; /*!< [0x308] Host Controller Capability Parameters */
    uint8_t _reserved15[52];
    __IO hw_usb_uh1_usbcmd_t UH1_USBCMD;   /*!< [0x340] USB Command Register */
    __IO hw_usb_uh1_usbsts_t UH1_USBSTS;   /*!< [0x344] USB Status Register */
    __IO hw_usb_uh1_usbintr_t UH1_USBINTR; /*!< [0x348] Interrupt Enable Register */
    __IO hw_usb_uh1_frindex_t UH1_FRINDEX; /*!< [0x34C] USB Frame Index */
    uint8_t _reserved16[4];
    union {
        __IO hw_usb_uh1_periodiclistbase_t UH1_PERIODICLISTBASE; /*!< [0x354] Frame List Base Address */
    };
    union {
        __IO hw_usb_uh1_asynclistaddr_t UH1_ASYNCLISTADDR; /*!< [0x358] Next Asynch. Address */
    };
    uint8_t _reserved17[4];
    __IO hw_usb_uh1_burstsize_t UH1_BURSTSIZE; /*!< [0x360] Programmable Burst Size */
    __IO hw_usb_uh1_txfilltuning_t UH1_TXFILLTUNING; /*!< [0x364] TX FIFO Fill Tuning */
    uint8_t _reserved18[24];
    __I hw_usb_uh1_configflag_t UH1_CONFIGFLAG; /*!< [0x380] Configure Flag Register */
    __IO hw_usb_uh1_portsc1_t UH1_PORTSC1; /*!< [0x384] Port Status & Control */
    uint8_t _reserved19[32];
    __IO hw_usb_uh1_usbmode_t UH1_USBMODE; /*!< [0x3A8] USB Device Mode */
    uint8_t _reserved20[84];
    __I hw_usb_uh2_id_t UH2_ID;            /*!< [0x400] Identification register */
    __I hw_usb_uh2_hwgeneral_t UH2_HWGENERAL; /*!< [0x404] Hardware General */
    __I hw_usb_uh2_hwhost_t UH2_HWHOST;    /*!< [0x408] Host Hardware Parameters */
    uint8_t _reserved21[4];
    __I hw_usb_uh2_hwtxbuf_t UH2_HWTXBUF;  /*!< [0x410] TX Buffer Hardware Parameters */
    __I hw_usb_uh2_hwrxbuf_t UH2_HWRXBUF;  /*!< [0x414] RX Buffer Hardware Parameters */
    uint8_t _reserved22[104];
    __IO hw_usb_uh2_gptimer0ld_t UH2_GPTIMER0LD; /*!< [0x480] General Purpose Timer #0 Load */
    __IO hw_usb_uh2_gptimer0ctrl_t UH2_GPTIMER0CTRL; /*!< [0x484] General Purpose Timer #0 Controller */
    __IO hw_usb_uh2_gptimer1ld_t UH2_GPTIMER1LD; /*!< [0x488] General Purpose Timer #1 Load */
    __IO hw_usb_uh2_gptimer1ctrl_t UH2_GPTIMER1CTRL; /*!< [0x48C] General Purpose Timer #1 Controller */
    __IO hw_usb_uh2_sbuscfg_t UH2_SBUSCFG; /*!< [0x490] System Bus Config */
    uint8_t _reserved23[108];
    __I hw_usb_uh2_caplength_t UH2_CAPLENGTH; /*!< [0x500] Capability Registers Length */
    uint8_t _reserved24[1];
    __I hw_usb_uh2_hciversion_t UH2_HCIVERSION; /*!< [0x502] Host Controller Interface Version */
    __I hw_usb_uh2_hcsparams_t UH2_HCSPARAMS; /*!< [0x504] Host Controller Structural Parameters */
    __I hw_usb_uh2_hccparams_t UH2_HCCPARAMS; /*!< [0x508] Host Controller Capability Parameters */
    uint8_t _reserved25[52];
    __IO hw_usb_uh2_usbcmd_t UH2_USBCMD;   /*!< [0x540] USB Command Register */
    __IO hw_usb_uh2_usbsts_t UH2_USBSTS;   /*!< [0x544] USB Status Register */
    __IO hw_usb_uh2_usbintr_t UH2_USBINTR; /*!< [0x548] Interrupt Enable Register */
    __IO hw_usb_uh2_frindex_t UH2_FRINDEX; /*!< [0x54C] USB Frame Index */
    uint8_t _reserved26[4];
    union {
        __IO hw_usb_uh2_periodiclistbase_t UH2_PERIODICLISTBASE; /*!< [0x554] Frame List Base Address */
    };
    union {
        __IO hw_usb_uh2_asynclistaddr_t UH2_ASYNCLISTADDR; /*!< [0x558] Next Asynch. Address */
    };
    uint8_t _reserved27[4];
    __IO hw_usb_uh2_burstsize_t UH2_BURSTSIZE; /*!< [0x560] Programmable Burst Size */
    __IO hw_usb_uh2_txfilltuning_t UH2_TXFILLTUNING; /*!< [0x564] TX FIFO Fill Tuning */
    uint8_t _reserved28[24];
    __I hw_usb_uh2_configflag_t UH2_CONFIGFLAG; /*!< [0x580] Configure Flag Register */
    __IO hw_usb_uh2_portsc1_t UH2_PORTSC1; /*!< [0x584] Port Status & Control */
    uint8_t _reserved29[32];
    __IO hw_usb_uh2_usbmode_t UH2_USBMODE; /*!< [0x5A8] USB Device Mode */
    uint8_t _reserved30[84];
    __I hw_usb_uh3_id_t UH3_ID;            /*!< [0x600] Identification register */
    __I hw_usb_uh3_hwgeneral_t UH3_HWGENERAL; /*!< [0x604] Hardware General */
    __I hw_usb_uh3_hwhost_t UH3_HWHOST;    /*!< [0x608] Host Hardware Parameters */
    uint8_t _reserved31[4];
    __I hw_usb_uh3_hwtxbuf_t UH3_HWTXBUF;  /*!< [0x610] TX Buffer Hardware Parameters */
    __I hw_usb_uh3_hwrxbuf_t UH3_HWRXBUF;  /*!< [0x614] RX Buffer Hardware Parameters */
    uint8_t _reserved32[104];
    __IO hw_usb_uh3_gptimer0ld_t UH3_GPTIMER0LD; /*!< [0x680] General Purpose Timer #0 Load */
    __IO hw_usb_uh3_gptimer0ctrl_t UH3_GPTIMER0CTRL; /*!< [0x684] General Purpose Timer #0 Controller */
    __IO hw_usb_uh3_gptimer1ld_t UH3_GPTIMER1LD; /*!< [0x688] General Purpose Timer #1 Load */
    __IO hw_usb_uh3_gptimer1ctrl_t UH3_GPTIMER1CTRL; /*!< [0x68C] General Purpose Timer #1 Controller */
    __IO hw_usb_uh3_sbuscfg_t UH3_SBUSCFG; /*!< [0x690] System Bus Config */
    uint8_t _reserved33[108];
    __I hw_usb_uh3_caplength_t UH3_CAPLENGTH; /*!< [0x700] Capability Registers Length */
    uint8_t _reserved34[1];
    __I hw_usb_uh3_hciversion_t UH3_HCIVERSION; /*!< [0x702] Host Controller Interface Version */
    __I hw_usb_uh3_hcsparams_t UH3_HCSPARAMS; /*!< [0x704] Host Controller Structural Parameters */
    __I hw_usb_uh3_hccparams_t UH3_HCCPARAMS; /*!< [0x708] Host Controller Capability Parameters */
    uint8_t _reserved35[52];
    __IO hw_usb_uh3_usbcmd_t UH3_USBCMD;   /*!< [0x740] USB Command Register */
    __IO hw_usb_uh3_usbsts_t UH3_USBSTS;   /*!< [0x744] USB Status Register */
    __IO hw_usb_uh3_usbintr_t UH3_USBINTR; /*!< [0x748] Interrupt Enable Register */
    __IO hw_usb_uh3_frindex_t UH3_FRINDEX; /*!< [0x74C] USB Frame Index */
    uint8_t _reserved36[4];
    union {
        __IO hw_usb_uh3_periodiclistbase_t UH3_PERIODICLISTBASE; /*!< [0x754] Frame List Base Address */
    };
    union {
        __IO hw_usb_uh3_asynclistaddr_t UH3_ASYNCLISTADDR; /*!< [0x758] Next Asynch. Address */
    };
    uint8_t _reserved37[4];
    __IO hw_usb_uh3_burstsize_t UH3_BURSTSIZE; /*!< [0x760] Programmable Burst Size */
    __IO hw_usb_uh3_txfilltuning_t UH3_TXFILLTUNING; /*!< [0x764] TX FIFO Fill Tuning */
    uint8_t _reserved38[24];
    __I hw_usb_uh3_configflag_t UH3_CONFIGFLAG; /*!< [0x780] Configure Flag Register */
    __IO hw_usb_uh3_portsc1_t UH3_PORTSC1; /*!< [0x784] Port Status & Control */
    uint8_t _reserved39[32];
    __IO hw_usb_uh3_usbmode_t UH3_USBMODE; /*!< [0x7A8] USB Device Mode */
} hw_usb_t;
#pragma pack()

/*! @brief Macro to access all USB registers. */
/*! @param x USB module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_USB_REGS(USB_BASE)</code>. */
#define HW_USB_REGS(x) (*(hw_usb_t *)(x))

/*
** End of section using anonymous unions
*/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma language=default
#else
  #error Not supported compiler type
#endif

/*
 * iMX6DP USBNC
 *
 * USB
 *
 * Registers defined in this header file:
 * - HW_USBNC_USB_OTG_CTRL - USB OTG Control Register
 * - HW_USBNC_USB_UH1_CTRL - USB Host1 Control Register
 * - HW_USBNC_USB_UH2_CTRL - USB Host2 Control Register
 * - HW_USBNC_USB_UH3_CTRL - USB Host3 Control Register
 * - HW_USBNC_USB_UH2_HSIC_CTRL - USB Host2 HSIC Control Register
 * - HW_USBNC_USB_UH3_HSIC_CTRL - USB Host3 HSIC Control Register
 * - HW_USBNC_USB_OTG_PHY_CTRL_0 - OTG UTMI PHY Control 0 Register
 * - HW_USBNC_USB_UH1_PHY_CTRL_0 - Host1 UTMI PHY Control 0 Register
 *
 * - hw_usbnc_t - Struct containing all module registers.
 */

#define HW_USBNC_INSTANCE_COUNT (1U) /*!< Number of instances of the USBNC module. */
#define HW_USBNC (0U) /*!< Instance number for USBNC. */
#define USBNC_BASE            (0x2184000U) /*!< Base address for USBNC. */
/*! Array initializer of USBNC base addresses. */
#define USBNC_BASE_ADDRS      { USBNC_BASE }

/*******************************************************************************
 * HW_USBNC_USB_OTG_CTRL - USB OTG Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_OTG_CTRL - USB OTG Control Register (RW)
 *
 * Reset value: 0x00003000U
 *
 * The USB OTG control register controls the integration specific features of
 * the USB OTG module. These features are not directly related to the USB
 * functionality, but control special features, interfacing on the USB ports, as well as
 * power control and wake-up functionality.
 */
typedef union _hw_usbnc_usb_otg_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_otg_ctrl_bitfields
    {
        uint32_t RESERVED0 : 7;        /*!< [6:0]  */
        uint32_t OVER_CUR_DIS : 1;     /*!< [7]  */
        uint32_t OVER_CUR_POL : 1;     /*!< [8]  */
        uint32_t PWR_POL : 1;          /*!< [9]  */
        uint32_t WIE : 1;              /*!< [10]  */
        uint32_t RESET : 1;            /*!< [11]  */
        uint32_t SUSPENDM : 1;         /*!< [12]  */
        uint32_t UTMI_ON_CLOCK : 1;    /*!< [13]  */
        uint32_t WKUP_SW_EN : 1;       /*!< [14]  */
        uint32_t WKUP_SW : 1;          /*!< [15]  */
        uint32_t WKUP_ID_EN : 1;       /*!< [16]  */
        uint32_t WKUP_VBUS_EN : 1;     /*!< [17]  */
        uint32_t RESERVED1 : 13;       /*!< [30:18]  */
        uint32_t WIR : 1;              /*!< [31]  */
    } B;
} hw_usbnc_usb_otg_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_OTG_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_OTG_CTRL_ADDR(x) ((uintptr_t)(x) + 0x800U)

#define HW_USBNC_USB_OTG_CTRL(x) (*(__IO hw_usbnc_usb_otg_ctrl_t *) HW_USBNC_USB_OTG_CTRL_ADDR(x))
#define HW_USBNC_USB_OTG_CTRL_RD(x) (HW_USBNC_USB_OTG_CTRL(x).U)
#define HW_USBNC_USB_OTG_CTRL_WR(x, v) (HW_USBNC_USB_OTG_CTRL(x).U = (v))
#define HW_USBNC_USB_OTG_CTRL_SET(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, HW_USBNC_USB_OTG_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_OTG_CTRL_CLR(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, HW_USBNC_USB_OTG_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_OTG_CTRL_TOG(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, HW_USBNC_USB_OTG_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_OTG_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_OTG_CTRL, field OVER_CUR_DIS[7] (RW)
 *
 * Disable OTG Overcurrent Detection
 *
 * Values:
 * - 1 - Disables overcurrent detection
 * - 0 - Enables overcurrent detection
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_OVER_CUR_DIS (7U) /*!< Bit position for USBNC_USB_OTG_CTRL_OVER_CUR_DIS. */
#define BM_USBNC_USB_OTG_CTRL_OVER_CUR_DIS (0x00000080U) /*!< Bit mask for USBNC_USB_OTG_CTRL_OVER_CUR_DIS. */
#define BS_USBNC_USB_OTG_CTRL_OVER_CUR_DIS (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_OVER_CUR_DIS. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_OVER_CUR_DIS field. */
#define BR_USBNC_USB_OTG_CTRL_OVER_CUR_DIS(x) (HW_USBNC_USB_OTG_CTRL(x).B.OVER_CUR_DIS)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_OVER_CUR_DIS. */
#define BF_USBNC_USB_OTG_CTRL_OVER_CUR_DIS(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_OVER_CUR_DIS) & BM_USBNC_USB_OTG_CTRL_OVER_CUR_DIS)

/*! @brief Set the OVER_CUR_DIS field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_OVER_CUR_DIS(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_OVER_CUR_DIS) | BF_USBNC_USB_OTG_CTRL_OVER_CUR_DIS(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field OVER_CUR_POL[8] (RW)
 *
 * OTG Polarity of Overcurrent The polarity of OTG port overcurrent event
 *
 * Values:
 * - 1 - Low active (low on this signal represents an overcurrent condition)
 * - 0 - High active (high on this signal represents an overcurrent condition)
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_OVER_CUR_POL (8U) /*!< Bit position for USBNC_USB_OTG_CTRL_OVER_CUR_POL. */
#define BM_USBNC_USB_OTG_CTRL_OVER_CUR_POL (0x00000100U) /*!< Bit mask for USBNC_USB_OTG_CTRL_OVER_CUR_POL. */
#define BS_USBNC_USB_OTG_CTRL_OVER_CUR_POL (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_OVER_CUR_POL. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_OVER_CUR_POL field. */
#define BR_USBNC_USB_OTG_CTRL_OVER_CUR_POL(x) (HW_USBNC_USB_OTG_CTRL(x).B.OVER_CUR_POL)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_OVER_CUR_POL. */
#define BF_USBNC_USB_OTG_CTRL_OVER_CUR_POL(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_OVER_CUR_POL) & BM_USBNC_USB_OTG_CTRL_OVER_CUR_POL)

/*! @brief Set the OVER_CUR_POL field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_OVER_CUR_POL(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_OVER_CUR_POL) | BF_USBNC_USB_OTG_CTRL_OVER_CUR_POL(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field PWR_POL[9] (RW)
 *
 * OTG Power Polarity This bit should be set according to power switch's enable
 * polarity.
 *
 * Values:
 * - 1 - Power switch has an active-high enable input
 * - 0 - Power switch has an active-low enable input
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_PWR_POL (9U) /*!< Bit position for USBNC_USB_OTG_CTRL_PWR_POL. */
#define BM_USBNC_USB_OTG_CTRL_PWR_POL (0x00000200U) /*!< Bit mask for USBNC_USB_OTG_CTRL_PWR_POL. */
#define BS_USBNC_USB_OTG_CTRL_PWR_POL (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_PWR_POL. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_PWR_POL field. */
#define BR_USBNC_USB_OTG_CTRL_PWR_POL(x) (HW_USBNC_USB_OTG_CTRL(x).B.PWR_POL)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_PWR_POL. */
#define BF_USBNC_USB_OTG_CTRL_PWR_POL(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_PWR_POL) & BM_USBNC_USB_OTG_CTRL_PWR_POL)

/*! @brief Set the PWR_POL field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_PWR_POL(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_PWR_POL) | BF_USBNC_USB_OTG_CTRL_PWR_POL(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WIE[10] (RW)
 *
 * OTG Wake-up Interrupt Enable This bit enables or disables the OTG wake-up
 * interrupt. Disabling the interrupt also clears the Interrupt request bit. Wake-up
 * interrupt enable should be turned off after receiving a wake-up interrupt and
 * turned on again prior to going in suspend mode
 *
 * Values:
 * - 1 - Interrupt Enabled
 * - 0 - Interrupt Disabled
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WIE (10U)    /*!< Bit position for USBNC_USB_OTG_CTRL_WIE. */
#define BM_USBNC_USB_OTG_CTRL_WIE (0x00000400U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WIE. */
#define BS_USBNC_USB_OTG_CTRL_WIE (1U)     /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WIE. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WIE field. */
#define BR_USBNC_USB_OTG_CTRL_WIE(x) (HW_USBNC_USB_OTG_CTRL(x).B.WIE)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_WIE. */
#define BF_USBNC_USB_OTG_CTRL_WIE(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_WIE) & BM_USBNC_USB_OTG_CTRL_WIE)

/*! @brief Set the WIE field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_WIE(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_WIE) | BF_USBNC_USB_OTG_CTRL_WIE(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field RESET[11] (RW)
 *
 * Force OTG UTMI PHY Reset This bit is used to force a reset to the UTMI PHY.
 * For Freescale test only. During normal operation, S/W should use USBCMD.RST bit
 * to reset the UTMI PHY
 *
 * Values:
 * - 1 - Reset the PHY
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_RESET (11U)  /*!< Bit position for USBNC_USB_OTG_CTRL_RESET. */
#define BM_USBNC_USB_OTG_CTRL_RESET (0x00000800U) /*!< Bit mask for USBNC_USB_OTG_CTRL_RESET. */
#define BS_USBNC_USB_OTG_CTRL_RESET (1U)   /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_RESET. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_RESET field. */
#define BR_USBNC_USB_OTG_CTRL_RESET(x) (HW_USBNC_USB_OTG_CTRL(x).B.RESET)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_RESET. */
#define BF_USBNC_USB_OTG_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_RESET) & BM_USBNC_USB_OTG_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_RESET(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_RESET) | BF_USBNC_USB_OTG_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field SUSPENDM[12] (RW)
 *
 * Force OTG UTMI PHY Suspend. For Freescale test only. This bit is used to put
 * PHY into low-power suspend mode. During normal operation, S/W should set bits
 * SUSP and PHCD in USB core register PORTSC1 to put PHY into suspend mode.
 *
 * Values:
 * - 1 - Inactive
 * - 0 - Force OTG UTMI PHY Suspend
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_SUSPENDM (12U) /*!< Bit position for USBNC_USB_OTG_CTRL_SUSPENDM. */
#define BM_USBNC_USB_OTG_CTRL_SUSPENDM (0x00001000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_SUSPENDM. */
#define BS_USBNC_USB_OTG_CTRL_SUSPENDM (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_SUSPENDM. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_SUSPENDM field. */
#define BR_USBNC_USB_OTG_CTRL_SUSPENDM(x) (HW_USBNC_USB_OTG_CTRL(x).B.SUSPENDM)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_SUSPENDM. */
#define BF_USBNC_USB_OTG_CTRL_SUSPENDM(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_SUSPENDM) & BM_USBNC_USB_OTG_CTRL_SUSPENDM)

/*! @brief Set the SUSPENDM field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_SUSPENDM(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_SUSPENDM) | BF_USBNC_USB_OTG_CTRL_SUSPENDM(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field UTMI_ON_CLOCK[13] (RW)
 *
 * Force OTG UTMI PHY clock output on even if suspend mode.
 *
 * Values:
 * - 1 - Force clock output on
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK (13U) /*!< Bit position for USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK. */
#define BM_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK (0x00002000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK. */
#define BS_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK field. */
#define BR_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK(x) (HW_USBNC_USB_OTG_CTRL(x).B.UTMI_ON_CLOCK)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK. */
#define BF_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK) & BM_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK)

/*! @brief Set the UTMI_ON_CLOCK field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK) | BF_USBNC_USB_OTG_CTRL_UTMI_ON_CLOCK(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WKUP_SW_EN[14] (RW)
 *
 * OTG Software Wake-up Enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WKUP_SW_EN (14U) /*!< Bit position for USBNC_USB_OTG_CTRL_WKUP_SW_EN. */
#define BM_USBNC_USB_OTG_CTRL_WKUP_SW_EN (0x00004000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WKUP_SW_EN. */
#define BS_USBNC_USB_OTG_CTRL_WKUP_SW_EN (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WKUP_SW_EN. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WKUP_SW_EN field. */
#define BR_USBNC_USB_OTG_CTRL_WKUP_SW_EN(x) (HW_USBNC_USB_OTG_CTRL(x).B.WKUP_SW_EN)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_WKUP_SW_EN. */
#define BF_USBNC_USB_OTG_CTRL_WKUP_SW_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_WKUP_SW_EN) & BM_USBNC_USB_OTG_CTRL_WKUP_SW_EN)

/*! @brief Set the WKUP_SW_EN field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_WKUP_SW_EN(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_WKUP_SW_EN) | BF_USBNC_USB_OTG_CTRL_WKUP_SW_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WKUP_SW[15] (RW)
 *
 * OTG Software Wake-up
 *
 * Values:
 * - 1 - Force wake-up
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WKUP_SW (15U) /*!< Bit position for USBNC_USB_OTG_CTRL_WKUP_SW. */
#define BM_USBNC_USB_OTG_CTRL_WKUP_SW (0x00008000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WKUP_SW. */
#define BS_USBNC_USB_OTG_CTRL_WKUP_SW (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WKUP_SW. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WKUP_SW field. */
#define BR_USBNC_USB_OTG_CTRL_WKUP_SW(x) (HW_USBNC_USB_OTG_CTRL(x).B.WKUP_SW)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_WKUP_SW. */
#define BF_USBNC_USB_OTG_CTRL_WKUP_SW(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_WKUP_SW) & BM_USBNC_USB_OTG_CTRL_WKUP_SW)

/*! @brief Set the WKUP_SW field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_WKUP_SW(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_WKUP_SW) | BF_USBNC_USB_OTG_CTRL_WKUP_SW(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WKUP_ID_EN[16] (RW)
 *
 * OTG Wake-up on ID change enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WKUP_ID_EN (16U) /*!< Bit position for USBNC_USB_OTG_CTRL_WKUP_ID_EN. */
#define BM_USBNC_USB_OTG_CTRL_WKUP_ID_EN (0x00010000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WKUP_ID_EN. */
#define BS_USBNC_USB_OTG_CTRL_WKUP_ID_EN (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WKUP_ID_EN. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WKUP_ID_EN field. */
#define BR_USBNC_USB_OTG_CTRL_WKUP_ID_EN(x) (HW_USBNC_USB_OTG_CTRL(x).B.WKUP_ID_EN)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_WKUP_ID_EN. */
#define BF_USBNC_USB_OTG_CTRL_WKUP_ID_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_WKUP_ID_EN) & BM_USBNC_USB_OTG_CTRL_WKUP_ID_EN)

/*! @brief Set the WKUP_ID_EN field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_WKUP_ID_EN(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_WKUP_ID_EN) | BF_USBNC_USB_OTG_CTRL_WKUP_ID_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WKUP_VBUS_EN[17] (RW)
 *
 * OTG wake-up on VBUS change enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN (17U) /*!< Bit position for USBNC_USB_OTG_CTRL_WKUP_VBUS_EN. */
#define BM_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN (0x00020000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WKUP_VBUS_EN. */
#define BS_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN (1U) /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WKUP_VBUS_EN. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WKUP_VBUS_EN field. */
#define BR_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN(x) (HW_USBNC_USB_OTG_CTRL(x).B.WKUP_VBUS_EN)

/*! @brief Format value for bitfield USBNC_USB_OTG_CTRL_WKUP_VBUS_EN. */
#define BF_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN) & BM_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN)

/*! @brief Set the WKUP_VBUS_EN field to a new value. */
#define BW_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN(x, v) (HW_USBNC_USB_OTG_CTRL_WR(x, (HW_USBNC_USB_OTG_CTRL_RD(x) & ~BM_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN) | BF_USBNC_USB_OTG_CTRL_WKUP_VBUS_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_OTG_CTRL, field WIR[31] (RO)
 *
 * OTG Wake-up Interrupt Request This bit indicates that a wake-up interrupt
 * request is received on the OTG port. This bit is cleared by disabling the wake-up
 * interrupt (clearing bit "OWIE").
 *
 * Values:
 * - 1 - Wake-up Interrupt Request received
 * - 0 - No wake-up interrupt request received
 */
/*@{*/
#define BP_USBNC_USB_OTG_CTRL_WIR (31U)    /*!< Bit position for USBNC_USB_OTG_CTRL_WIR. */
#define BM_USBNC_USB_OTG_CTRL_WIR (0x80000000U) /*!< Bit mask for USBNC_USB_OTG_CTRL_WIR. */
#define BS_USBNC_USB_OTG_CTRL_WIR (1U)     /*!< Bit field size in bits for USBNC_USB_OTG_CTRL_WIR. */

/*! @brief Read current value of the USBNC_USB_OTG_CTRL_WIR field. */
#define BR_USBNC_USB_OTG_CTRL_WIR(x) (HW_USBNC_USB_OTG_CTRL(x).B.WIR)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH1_CTRL - USB Host1 Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH1_CTRL - USB Host1 Control Register (RW)
 *
 * Reset value: 0x00003000U
 *
 * The USB Host1 control register controls the integration specific features of
 * the USB Host1 module. These features are not directly related to the USB
 * functionality, but control special features, interfacing on the USB ports, as well
 * as power control and wake-up functionality.
 */
typedef union _hw_usbnc_usb_uh1_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_uh1_ctrl_bitfields
    {
        uint32_t RESERVED0 : 7;        /*!< [6:0]  */
        uint32_t OVER_CUR_DIS : 1;     /*!< [7]  */
        uint32_t OVER_CUR_POL : 1;     /*!< [8]  */
        uint32_t PWR_POL : 1;          /*!< [9]  */
        uint32_t WIE : 1;              /*!< [10]  */
        uint32_t RESET : 1;            /*!< [11]  */
        uint32_t SUSPENDM : 1;         /*!< [12]  */
        uint32_t UTMI_ON_CLOCK : 1;    /*!< [13]  */
        uint32_t WKUP_SW_EN : 1;       /*!< [14]  */
        uint32_t WKUP_SW : 1;          /*!< [15]  */
        uint32_t WKUP_ID_EN : 1;       /*!< [16]  */
        uint32_t WKUP_VBUS_EN : 1;     /*!< [17]  */
        uint32_t RESERVED1 : 13;       /*!< [30:18]  */
        uint32_t WIR : 1;              /*!< [31]  */
    } B;
} hw_usbnc_usb_uh1_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH1_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_UH1_CTRL_ADDR(x) ((uintptr_t)(x) + 0x804U)

#define HW_USBNC_USB_UH1_CTRL(x) (*(__IO hw_usbnc_usb_uh1_ctrl_t *) HW_USBNC_USB_UH1_CTRL_ADDR(x))
#define HW_USBNC_USB_UH1_CTRL_RD(x) (HW_USBNC_USB_UH1_CTRL(x).U)
#define HW_USBNC_USB_UH1_CTRL_WR(x, v) (HW_USBNC_USB_UH1_CTRL(x).U = (v))
#define HW_USBNC_USB_UH1_CTRL_SET(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, HW_USBNC_USB_UH1_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_UH1_CTRL_CLR(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, HW_USBNC_USB_UH1_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_UH1_CTRL_TOG(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, HW_USBNC_USB_UH1_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH1_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_UH1_CTRL, field OVER_CUR_DIS[7] (RW)
 *
 * Disable Host 1 Overcurrent Detection
 *
 * Values:
 * - 1 - Disables overcurrent detection
 * - 0 - Enables overcurrent detection
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_OVER_CUR_DIS (7U) /*!< Bit position for USBNC_USB_UH1_CTRL_OVER_CUR_DIS. */
#define BM_USBNC_USB_UH1_CTRL_OVER_CUR_DIS (0x00000080U) /*!< Bit mask for USBNC_USB_UH1_CTRL_OVER_CUR_DIS. */
#define BS_USBNC_USB_UH1_CTRL_OVER_CUR_DIS (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_OVER_CUR_DIS. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_OVER_CUR_DIS field. */
#define BR_USBNC_USB_UH1_CTRL_OVER_CUR_DIS(x) (HW_USBNC_USB_UH1_CTRL(x).B.OVER_CUR_DIS)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_OVER_CUR_DIS. */
#define BF_USBNC_USB_UH1_CTRL_OVER_CUR_DIS(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_OVER_CUR_DIS) & BM_USBNC_USB_UH1_CTRL_OVER_CUR_DIS)

/*! @brief Set the OVER_CUR_DIS field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_OVER_CUR_DIS(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_OVER_CUR_DIS) | BF_USBNC_USB_UH1_CTRL_OVER_CUR_DIS(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field OVER_CUR_POL[8] (RW)
 *
 * Host 1 Polarity of Overcurrent The polarity of Host 1 port overcurrent event
 *
 * Values:
 * - 1 - Low active (low on this signal represents an overcurrent condition)
 * - 0 - High active (high on this signal represents an overcurrent condition)
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_OVER_CUR_POL (8U) /*!< Bit position for USBNC_USB_UH1_CTRL_OVER_CUR_POL. */
#define BM_USBNC_USB_UH1_CTRL_OVER_CUR_POL (0x00000100U) /*!< Bit mask for USBNC_USB_UH1_CTRL_OVER_CUR_POL. */
#define BS_USBNC_USB_UH1_CTRL_OVER_CUR_POL (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_OVER_CUR_POL. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_OVER_CUR_POL field. */
#define BR_USBNC_USB_UH1_CTRL_OVER_CUR_POL(x) (HW_USBNC_USB_UH1_CTRL(x).B.OVER_CUR_POL)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_OVER_CUR_POL. */
#define BF_USBNC_USB_UH1_CTRL_OVER_CUR_POL(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_OVER_CUR_POL) & BM_USBNC_USB_UH1_CTRL_OVER_CUR_POL)

/*! @brief Set the OVER_CUR_POL field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_OVER_CUR_POL(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_OVER_CUR_POL) | BF_USBNC_USB_UH1_CTRL_OVER_CUR_POL(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field PWR_POL[9] (RW)
 *
 * Host1 Power Polarity This bit should be set according to the power switch's
 * enable polarity.
 *
 * Values:
 * - 1 - Power switch has an active-high enable input
 * - 0 - Power switch has an active-low enable input
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_PWR_POL (9U) /*!< Bit position for USBNC_USB_UH1_CTRL_PWR_POL. */
#define BM_USBNC_USB_UH1_CTRL_PWR_POL (0x00000200U) /*!< Bit mask for USBNC_USB_UH1_CTRL_PWR_POL. */
#define BS_USBNC_USB_UH1_CTRL_PWR_POL (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_PWR_POL. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_PWR_POL field. */
#define BR_USBNC_USB_UH1_CTRL_PWR_POL(x) (HW_USBNC_USB_UH1_CTRL(x).B.PWR_POL)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_PWR_POL. */
#define BF_USBNC_USB_UH1_CTRL_PWR_POL(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_PWR_POL) & BM_USBNC_USB_UH1_CTRL_PWR_POL)

/*! @brief Set the PWR_POL field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_PWR_POL(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_PWR_POL) | BF_USBNC_USB_UH1_CTRL_PWR_POL(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WIE[10] (RW)
 *
 * Host 1 Wake-up Interrupt Enable This bit enables or disables the Host 1
 * wake-up interrupt. Disabling the interrupt also clears the Interrupt request bit.
 * Wake-up interrupt enable should be turned off after receiving a wake-up
 * interrupt and turned on again prior to going in suspend mode
 *
 * Values:
 * - 1 - Interrupt Enabled
 * - 0 - Interrupt Disabled
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WIE (10U)    /*!< Bit position for USBNC_USB_UH1_CTRL_WIE. */
#define BM_USBNC_USB_UH1_CTRL_WIE (0x00000400U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WIE. */
#define BS_USBNC_USB_UH1_CTRL_WIE (1U)     /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WIE. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WIE field. */
#define BR_USBNC_USB_UH1_CTRL_WIE(x) (HW_USBNC_USB_UH1_CTRL(x).B.WIE)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_WIE. */
#define BF_USBNC_USB_UH1_CTRL_WIE(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_WIE) & BM_USBNC_USB_UH1_CTRL_WIE)

/*! @brief Set the WIE field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_WIE(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_WIE) | BF_USBNC_USB_UH1_CTRL_WIE(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field RESET[11] (RW)
 *
 * Force Host 1 UTMI PHY Reset. For Freescale test only. This bit is used to
 * force a reset to the UTMI PHY. During normal operation, S/W should use USBCMD.RST
 * bit to reset the UTMI PHY
 *
 * Values:
 * - 1 - Reset the PHY
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_RESET (11U)  /*!< Bit position for USBNC_USB_UH1_CTRL_RESET. */
#define BM_USBNC_USB_UH1_CTRL_RESET (0x00000800U) /*!< Bit mask for USBNC_USB_UH1_CTRL_RESET. */
#define BS_USBNC_USB_UH1_CTRL_RESET (1U)   /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_RESET. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_RESET field. */
#define BR_USBNC_USB_UH1_CTRL_RESET(x) (HW_USBNC_USB_UH1_CTRL(x).B.RESET)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_RESET. */
#define BF_USBNC_USB_UH1_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_RESET) & BM_USBNC_USB_UH1_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_RESET(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_RESET) | BF_USBNC_USB_UH1_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field SUSPENDM[12] (RW)
 *
 * Force Host 1 UTMI PHY Suspend. For Freescale test only. This bit is used to
 * put PHY into low-power suspend mode. During normal operation, S/W should set
 * bits SUSP and PHCD in USB core register PORTSC1 to put PHY into suspend mode.
 *
 * Values:
 * - 1 - Disable
 * - 0 - Enable
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_SUSPENDM (12U) /*!< Bit position for USBNC_USB_UH1_CTRL_SUSPENDM. */
#define BM_USBNC_USB_UH1_CTRL_SUSPENDM (0x00001000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_SUSPENDM. */
#define BS_USBNC_USB_UH1_CTRL_SUSPENDM (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_SUSPENDM. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_SUSPENDM field. */
#define BR_USBNC_USB_UH1_CTRL_SUSPENDM(x) (HW_USBNC_USB_UH1_CTRL(x).B.SUSPENDM)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_SUSPENDM. */
#define BF_USBNC_USB_UH1_CTRL_SUSPENDM(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_SUSPENDM) & BM_USBNC_USB_UH1_CTRL_SUSPENDM)

/*! @brief Set the SUSPENDM field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_SUSPENDM(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_SUSPENDM) | BF_USBNC_USB_UH1_CTRL_SUSPENDM(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field UTMI_ON_CLOCK[13] (RW)
 *
 * Force Host 1 UTMI PHY clock output on even if in low-power suspend mode.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK (13U) /*!< Bit position for USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK. */
#define BM_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK (0x00002000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK. */
#define BS_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK field. */
#define BR_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK(x) (HW_USBNC_USB_UH1_CTRL(x).B.UTMI_ON_CLOCK)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK. */
#define BF_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK) & BM_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK)

/*! @brief Set the UTMI_ON_CLOCK field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK) | BF_USBNC_USB_UH1_CTRL_UTMI_ON_CLOCK(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WKUP_SW_EN[14] (RW)
 *
 * Host 1 Software Wake-up Enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WKUP_SW_EN (14U) /*!< Bit position for USBNC_USB_UH1_CTRL_WKUP_SW_EN. */
#define BM_USBNC_USB_UH1_CTRL_WKUP_SW_EN (0x00004000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WKUP_SW_EN. */
#define BS_USBNC_USB_UH1_CTRL_WKUP_SW_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WKUP_SW_EN. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WKUP_SW_EN field. */
#define BR_USBNC_USB_UH1_CTRL_WKUP_SW_EN(x) (HW_USBNC_USB_UH1_CTRL(x).B.WKUP_SW_EN)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_WKUP_SW_EN. */
#define BF_USBNC_USB_UH1_CTRL_WKUP_SW_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_WKUP_SW_EN) & BM_USBNC_USB_UH1_CTRL_WKUP_SW_EN)

/*! @brief Set the WKUP_SW_EN field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_WKUP_SW_EN(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_WKUP_SW_EN) | BF_USBNC_USB_UH1_CTRL_WKUP_SW_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WKUP_SW[15] (RW)
 *
 * Host 1 Software Wake-up
 *
 * Values:
 * - 1 - Force wake-up
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WKUP_SW (15U) /*!< Bit position for USBNC_USB_UH1_CTRL_WKUP_SW. */
#define BM_USBNC_USB_UH1_CTRL_WKUP_SW (0x00008000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WKUP_SW. */
#define BS_USBNC_USB_UH1_CTRL_WKUP_SW (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WKUP_SW. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WKUP_SW field. */
#define BR_USBNC_USB_UH1_CTRL_WKUP_SW(x) (HW_USBNC_USB_UH1_CTRL(x).B.WKUP_SW)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_WKUP_SW. */
#define BF_USBNC_USB_UH1_CTRL_WKUP_SW(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_WKUP_SW) & BM_USBNC_USB_UH1_CTRL_WKUP_SW)

/*! @brief Set the WKUP_SW field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_WKUP_SW(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_WKUP_SW) | BF_USBNC_USB_UH1_CTRL_WKUP_SW(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WKUP_ID_EN[16] (RW)
 *
 * Host 1 Wake-up on ID change enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WKUP_ID_EN (16U) /*!< Bit position for USBNC_USB_UH1_CTRL_WKUP_ID_EN. */
#define BM_USBNC_USB_UH1_CTRL_WKUP_ID_EN (0x00010000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WKUP_ID_EN. */
#define BS_USBNC_USB_UH1_CTRL_WKUP_ID_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WKUP_ID_EN. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WKUP_ID_EN field. */
#define BR_USBNC_USB_UH1_CTRL_WKUP_ID_EN(x) (HW_USBNC_USB_UH1_CTRL(x).B.WKUP_ID_EN)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_WKUP_ID_EN. */
#define BF_USBNC_USB_UH1_CTRL_WKUP_ID_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_WKUP_ID_EN) & BM_USBNC_USB_UH1_CTRL_WKUP_ID_EN)

/*! @brief Set the WKUP_ID_EN field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_WKUP_ID_EN(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_WKUP_ID_EN) | BF_USBNC_USB_UH1_CTRL_WKUP_ID_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WKUP_VBUS_EN[17] (RW)
 *
 * Host 1 wake-up on VBUS change enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN (17U) /*!< Bit position for USBNC_USB_UH1_CTRL_WKUP_VBUS_EN. */
#define BM_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN (0x00020000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WKUP_VBUS_EN. */
#define BS_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WKUP_VBUS_EN. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WKUP_VBUS_EN field. */
#define BR_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN(x) (HW_USBNC_USB_UH1_CTRL(x).B.WKUP_VBUS_EN)

/*! @brief Format value for bitfield USBNC_USB_UH1_CTRL_WKUP_VBUS_EN. */
#define BF_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN) & BM_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN)

/*! @brief Set the WKUP_VBUS_EN field to a new value. */
#define BW_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN(x, v) (HW_USBNC_USB_UH1_CTRL_WR(x, (HW_USBNC_USB_UH1_CTRL_RD(x) & ~BM_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN) | BF_USBNC_USB_UH1_CTRL_WKUP_VBUS_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH1_CTRL, field WIR[31] (RO)
 *
 * Host 1 Wake-up Interrupt Request This bit indicates that a wake-up interrupt
 * request is received on the OTG port. This bit is cleared by disabling the
 * wake-up interrupt (clearing bit "OWIE").
 *
 * Values:
 * - 1 - Wake-up Interrupt Request received
 * - 0 - No wake-up interrupt request received
 */
/*@{*/
#define BP_USBNC_USB_UH1_CTRL_WIR (31U)    /*!< Bit position for USBNC_USB_UH1_CTRL_WIR. */
#define BM_USBNC_USB_UH1_CTRL_WIR (0x80000000U) /*!< Bit mask for USBNC_USB_UH1_CTRL_WIR. */
#define BS_USBNC_USB_UH1_CTRL_WIR (1U)     /*!< Bit field size in bits for USBNC_USB_UH1_CTRL_WIR. */

/*! @brief Read current value of the USBNC_USB_UH1_CTRL_WIR field. */
#define BR_USBNC_USB_UH1_CTRL_WIR(x) (HW_USBNC_USB_UH1_CTRL(x).B.WIR)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH2_CTRL - USB Host2 Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH2_CTRL - USB Host2 Control Register (RW)
 *
 * Reset value: 0x00001000U
 *
 * The USB Host2 control register controls the integration specific features of
 * the USB host2 module. These features are not directly related to the USB
 * functionality, but control special features, interfacing on the USB ports, as well
 * as power control and wake-up functionality.
 */
typedef union _hw_usbnc_usb_uh2_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_uh2_ctrl_bitfields
    {
        uint32_t RESERVED0 : 10;       /*!< [9:0]  */
        uint32_t WIE : 1;              /*!< [10]  */
        uint32_t RESET : 1;            /*!< [11]  */
        uint32_t SUSPENDM : 1;         /*!< [12]  */
        uint32_t OTG_480M_CLK_ON : 1;  /*!< [13]  */
        uint32_t WKUP_SW_EN : 1;       /*!< [14]  */
        uint32_t WKUP_SW : 1;          /*!< [15]  */
        uint32_t RESERVED1 : 15;       /*!< [30:16]  */
        uint32_t WIR : 1;              /*!< [31]  */
    } B;
} hw_usbnc_usb_uh2_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH2_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_UH2_CTRL_ADDR(x) ((uintptr_t)(x) + 0x808U)

#define HW_USBNC_USB_UH2_CTRL(x) (*(__IO hw_usbnc_usb_uh2_ctrl_t *) HW_USBNC_USB_UH2_CTRL_ADDR(x))
#define HW_USBNC_USB_UH2_CTRL_RD(x) (HW_USBNC_USB_UH2_CTRL(x).U)
#define HW_USBNC_USB_UH2_CTRL_WR(x, v) (HW_USBNC_USB_UH2_CTRL(x).U = (v))
#define HW_USBNC_USB_UH2_CTRL_SET(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, HW_USBNC_USB_UH2_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_UH2_CTRL_CLR(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, HW_USBNC_USB_UH2_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_UH2_CTRL_TOG(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, HW_USBNC_USB_UH2_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH2_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_UH2_CTRL, field WIE[10] (RW)
 *
 * Host 2 Wake-up Interrupt Enable This bit enables or disables the Host 2
 * wake-up interrupt. Disabling the interrupt also clears the Interrupt request bit.
 * Wake-up interrupt enable should be turned off after receiving a wake-up
 * interrupt and turned on again prior to going in suspend mode
 *
 * Values:
 * - 1 - Interrupt Enabled
 * - 0 - Interrupt Disabled
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_WIE (10U)    /*!< Bit position for USBNC_USB_UH2_CTRL_WIE. */
#define BM_USBNC_USB_UH2_CTRL_WIE (0x00000400U) /*!< Bit mask for USBNC_USB_UH2_CTRL_WIE. */
#define BS_USBNC_USB_UH2_CTRL_WIE (1U)     /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_WIE. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_WIE field. */
#define BR_USBNC_USB_UH2_CTRL_WIE(x) (HW_USBNC_USB_UH2_CTRL(x).B.WIE)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_WIE. */
#define BF_USBNC_USB_UH2_CTRL_WIE(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_WIE) & BM_USBNC_USB_UH2_CTRL_WIE)

/*! @brief Set the WIE field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_WIE(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_WIE) | BF_USBNC_USB_UH2_CTRL_WIE(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field RESET[11] (RW)
 *
 * Force Host 2 UTMI PHY Reset This bit is used to force a reset to the UTMI
 * PHY. During normal operation, S/W should set USBCMD.RST bit to reset the UTMI PHY
 * For Freescale test only.
 *
 * Values:
 * - 1 - Reset the PHY
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_RESET (11U)  /*!< Bit position for USBNC_USB_UH2_CTRL_RESET. */
#define BM_USBNC_USB_UH2_CTRL_RESET (0x00000800U) /*!< Bit mask for USBNC_USB_UH2_CTRL_RESET. */
#define BS_USBNC_USB_UH2_CTRL_RESET (1U)   /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_RESET. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_RESET field. */
#define BR_USBNC_USB_UH2_CTRL_RESET(x) (HW_USBNC_USB_UH2_CTRL(x).B.RESET)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_RESET. */
#define BF_USBNC_USB_UH2_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_RESET) & BM_USBNC_USB_UH2_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_RESET(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_RESET) | BF_USBNC_USB_UH2_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field SUSPENDM[12] (RW)
 *
 * Force Host 2 UTMI PHY Suspend This bit is used to put PHY into suspend mode.
 * During normal operation, S/W should set bits SUSP and PHCD in USB core
 * register PORTSC1 to put PHY into suspend mode. For Freescale test only.
 *
 * Values:
 * - 1 - Disable
 * - 0 - Enable
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_SUSPENDM (12U) /*!< Bit position for USBNC_USB_UH2_CTRL_SUSPENDM. */
#define BM_USBNC_USB_UH2_CTRL_SUSPENDM (0x00001000U) /*!< Bit mask for USBNC_USB_UH2_CTRL_SUSPENDM. */
#define BS_USBNC_USB_UH2_CTRL_SUSPENDM (1U) /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_SUSPENDM. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_SUSPENDM field. */
#define BR_USBNC_USB_UH2_CTRL_SUSPENDM(x) (HW_USBNC_USB_UH2_CTRL(x).B.SUSPENDM)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_SUSPENDM. */
#define BF_USBNC_USB_UH2_CTRL_SUSPENDM(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_SUSPENDM) & BM_USBNC_USB_UH2_CTRL_SUSPENDM)

/*! @brief Set the SUSPENDM field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_SUSPENDM(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_SUSPENDM) | BF_USBNC_USB_UH2_CTRL_SUSPENDM(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field OTG_480M_CLK_ON[13] (RW)
 *
 * Force OTG UTMI PHY 480M clock output on when Host 2 is not in suspend mode.
 *
 * Values:
 * - 1 - Force OTG UTMI PHY 480M clock output on
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON (13U) /*!< Bit position for USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON. */
#define BM_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON (0x00002000U) /*!< Bit mask for USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON. */
#define BS_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON (1U) /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON field. */
#define BR_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON(x) (HW_USBNC_USB_UH2_CTRL(x).B.OTG_480M_CLK_ON)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON. */
#define BF_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON) & BM_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON)

/*! @brief Set the OTG_480M_CLK_ON field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON) | BF_USBNC_USB_UH2_CTRL_OTG_480M_CLK_ON(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field WKUP_SW_EN[14] (RW)
 *
 * Host 2 Software Wake-up Enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_WKUP_SW_EN (14U) /*!< Bit position for USBNC_USB_UH2_CTRL_WKUP_SW_EN. */
#define BM_USBNC_USB_UH2_CTRL_WKUP_SW_EN (0x00004000U) /*!< Bit mask for USBNC_USB_UH2_CTRL_WKUP_SW_EN. */
#define BS_USBNC_USB_UH2_CTRL_WKUP_SW_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_WKUP_SW_EN. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_WKUP_SW_EN field. */
#define BR_USBNC_USB_UH2_CTRL_WKUP_SW_EN(x) (HW_USBNC_USB_UH2_CTRL(x).B.WKUP_SW_EN)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_WKUP_SW_EN. */
#define BF_USBNC_USB_UH2_CTRL_WKUP_SW_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_WKUP_SW_EN) & BM_USBNC_USB_UH2_CTRL_WKUP_SW_EN)

/*! @brief Set the WKUP_SW_EN field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_WKUP_SW_EN(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_WKUP_SW_EN) | BF_USBNC_USB_UH2_CTRL_WKUP_SW_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field WKUP_SW[15] (RW)
 *
 * Host 2 Software Wake-up
 *
 * Values:
 * - 1 - Force wake-up
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_WKUP_SW (15U) /*!< Bit position for USBNC_USB_UH2_CTRL_WKUP_SW. */
#define BM_USBNC_USB_UH2_CTRL_WKUP_SW (0x00008000U) /*!< Bit mask for USBNC_USB_UH2_CTRL_WKUP_SW. */
#define BS_USBNC_USB_UH2_CTRL_WKUP_SW (1U) /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_WKUP_SW. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_WKUP_SW field. */
#define BR_USBNC_USB_UH2_CTRL_WKUP_SW(x) (HW_USBNC_USB_UH2_CTRL(x).B.WKUP_SW)

/*! @brief Format value for bitfield USBNC_USB_UH2_CTRL_WKUP_SW. */
#define BF_USBNC_USB_UH2_CTRL_WKUP_SW(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_CTRL_WKUP_SW) & BM_USBNC_USB_UH2_CTRL_WKUP_SW)

/*! @brief Set the WKUP_SW field to a new value. */
#define BW_USBNC_USB_UH2_CTRL_WKUP_SW(x, v) (HW_USBNC_USB_UH2_CTRL_WR(x, (HW_USBNC_USB_UH2_CTRL_RD(x) & ~BM_USBNC_USB_UH2_CTRL_WKUP_SW) | BF_USBNC_USB_UH2_CTRL_WKUP_SW(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_CTRL, field WIR[31] (RO)
 *
 * Host 2 Wake-up Interrupt Request This bit indicates that a wake-up interrupt
 * request is received on the Host 2 port. This bit is cleared by disabling the
 * wake-up interrupt (clearing bit "OWIE").
 *
 * Values:
 * - 1 - Wake-up Interrupt Request received
 * - 0 - No wake-up interrupt request received
 */
/*@{*/
#define BP_USBNC_USB_UH2_CTRL_WIR (31U)    /*!< Bit position for USBNC_USB_UH2_CTRL_WIR. */
#define BM_USBNC_USB_UH2_CTRL_WIR (0x80000000U) /*!< Bit mask for USBNC_USB_UH2_CTRL_WIR. */
#define BS_USBNC_USB_UH2_CTRL_WIR (1U)     /*!< Bit field size in bits for USBNC_USB_UH2_CTRL_WIR. */

/*! @brief Read current value of the USBNC_USB_UH2_CTRL_WIR field. */
#define BR_USBNC_USB_UH2_CTRL_WIR(x) (HW_USBNC_USB_UH2_CTRL(x).B.WIR)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH3_CTRL - USB Host3 Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH3_CTRL - USB Host3 Control Register (RW)
 *
 * Reset value: 0x00001000U
 *
 * The USB Host3 control register controls the integration specific features of
 * the USB Host3 module. These features are not directly related to the USB
 * functionality, but control special features, interfacing on the USB ports, as well
 * as power control and wake-up functionality.
 */
typedef union _hw_usbnc_usb_uh3_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_uh3_ctrl_bitfields
    {
        uint32_t RESERVED0 : 10;       /*!< [9:0]  */
        uint32_t WIE : 1;              /*!< [10]  */
        uint32_t RESET : 1;            /*!< [11]  */
        uint32_t SUSPENDM : 1;         /*!< [12]  */
        uint32_t OTG_480M_CLK_ON : 1;  /*!< [13]  */
        uint32_t WKUP_SW_EN : 1;       /*!< [14]  */
        uint32_t WKUP_SW : 1;          /*!< [15]  */
        uint32_t RESERVED1 : 15;       /*!< [30:16]  */
        uint32_t WIR : 1;              /*!< [31]  */
    } B;
} hw_usbnc_usb_uh3_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH3_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_UH3_CTRL_ADDR(x) ((uintptr_t)(x) + 0x80CU)

#define HW_USBNC_USB_UH3_CTRL(x) (*(__IO hw_usbnc_usb_uh3_ctrl_t *) HW_USBNC_USB_UH3_CTRL_ADDR(x))
#define HW_USBNC_USB_UH3_CTRL_RD(x) (HW_USBNC_USB_UH3_CTRL(x).U)
#define HW_USBNC_USB_UH3_CTRL_WR(x, v) (HW_USBNC_USB_UH3_CTRL(x).U = (v))
#define HW_USBNC_USB_UH3_CTRL_SET(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, HW_USBNC_USB_UH3_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_UH3_CTRL_CLR(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, HW_USBNC_USB_UH3_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_UH3_CTRL_TOG(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, HW_USBNC_USB_UH3_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH3_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_UH3_CTRL, field WIE[10] (RW)
 *
 * Host 3 Wake-up Interrupt Enable This bit enables or disables the Host 3
 * wake-up interrupt. Disabling the interrupt also clears the Interrupt request bit.
 * Wake-up interrupt enable should be turned off after receiving a wake-up
 * interrupt and turned on again prior to going in suspend mode
 *
 * Values:
 * - 1 - Interrupt Enabled
 * - 0 - Interrupt Disabled
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_WIE (10U)    /*!< Bit position for USBNC_USB_UH3_CTRL_WIE. */
#define BM_USBNC_USB_UH3_CTRL_WIE (0x00000400U) /*!< Bit mask for USBNC_USB_UH3_CTRL_WIE. */
#define BS_USBNC_USB_UH3_CTRL_WIE (1U)     /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_WIE. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_WIE field. */
#define BR_USBNC_USB_UH3_CTRL_WIE(x) (HW_USBNC_USB_UH3_CTRL(x).B.WIE)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_WIE. */
#define BF_USBNC_USB_UH3_CTRL_WIE(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_WIE) & BM_USBNC_USB_UH3_CTRL_WIE)

/*! @brief Set the WIE field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_WIE(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_WIE) | BF_USBNC_USB_UH3_CTRL_WIE(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field RESET[11] (RW)
 *
 * Force Host 3 UTMI PHY Reset This bit is used to force a reset to the UTMI
 * PHY. During normal operation, S/W should set USBCMD.RST bit to reset the UTMI PHY
 * For Freescale test only.
 *
 * Values:
 * - 1 - Reset the PHY
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_RESET (11U)  /*!< Bit position for USBNC_USB_UH3_CTRL_RESET. */
#define BM_USBNC_USB_UH3_CTRL_RESET (0x00000800U) /*!< Bit mask for USBNC_USB_UH3_CTRL_RESET. */
#define BS_USBNC_USB_UH3_CTRL_RESET (1U)   /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_RESET. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_RESET field. */
#define BR_USBNC_USB_UH3_CTRL_RESET(x) (HW_USBNC_USB_UH3_CTRL(x).B.RESET)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_RESET. */
#define BF_USBNC_USB_UH3_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_RESET) & BM_USBNC_USB_UH3_CTRL_RESET)

/*! @brief Set the RESET field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_RESET(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_RESET) | BF_USBNC_USB_UH3_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field SUSPENDM[12] (RW)
 *
 * Force Host 3 UTMI PHY Suspend This bit is used to put PHY into suspend mode.
 * During normal operation, S/W should set bits SUSP and PHCD in USB core
 * register PORTSC1 to put PHY into suspend mode. For Freescale test only.
 *
 * Values:
 * - 1 - Inactive
 * - 0 - Force OTG UTMI PHY Suspend
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_SUSPENDM (12U) /*!< Bit position for USBNC_USB_UH3_CTRL_SUSPENDM. */
#define BM_USBNC_USB_UH3_CTRL_SUSPENDM (0x00001000U) /*!< Bit mask for USBNC_USB_UH3_CTRL_SUSPENDM. */
#define BS_USBNC_USB_UH3_CTRL_SUSPENDM (1U) /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_SUSPENDM. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_SUSPENDM field. */
#define BR_USBNC_USB_UH3_CTRL_SUSPENDM(x) (HW_USBNC_USB_UH3_CTRL(x).B.SUSPENDM)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_SUSPENDM. */
#define BF_USBNC_USB_UH3_CTRL_SUSPENDM(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_SUSPENDM) & BM_USBNC_USB_UH3_CTRL_SUSPENDM)

/*! @brief Set the SUSPENDM field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_SUSPENDM(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_SUSPENDM) | BF_USBNC_USB_UH3_CTRL_SUSPENDM(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field OTG_480M_CLK_ON[13] (RW)
 *
 * Force OTG UTMI PHY 480M clock output on when Host 3 is not in suspend mode.
 *
 * Values:
 * - 1 - Force OTG UTMI PHY 480M clock output on
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON (13U) /*!< Bit position for USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON. */
#define BM_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON (0x00002000U) /*!< Bit mask for USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON. */
#define BS_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON (1U) /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON field. */
#define BR_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON(x) (HW_USBNC_USB_UH3_CTRL(x).B.OTG_480M_CLK_ON)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON. */
#define BF_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON) & BM_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON)

/*! @brief Set the OTG_480M_CLK_ON field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON) | BF_USBNC_USB_UH3_CTRL_OTG_480M_CLK_ON(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field WKUP_SW_EN[14] (RW)
 *
 * Host 3 Software Wake-up Enable
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_WKUP_SW_EN (14U) /*!< Bit position for USBNC_USB_UH3_CTRL_WKUP_SW_EN. */
#define BM_USBNC_USB_UH3_CTRL_WKUP_SW_EN (0x00004000U) /*!< Bit mask for USBNC_USB_UH3_CTRL_WKUP_SW_EN. */
#define BS_USBNC_USB_UH3_CTRL_WKUP_SW_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_WKUP_SW_EN. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_WKUP_SW_EN field. */
#define BR_USBNC_USB_UH3_CTRL_WKUP_SW_EN(x) (HW_USBNC_USB_UH3_CTRL(x).B.WKUP_SW_EN)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_WKUP_SW_EN. */
#define BF_USBNC_USB_UH3_CTRL_WKUP_SW_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_WKUP_SW_EN) & BM_USBNC_USB_UH3_CTRL_WKUP_SW_EN)

/*! @brief Set the WKUP_SW_EN field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_WKUP_SW_EN(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_WKUP_SW_EN) | BF_USBNC_USB_UH3_CTRL_WKUP_SW_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field WKUP_SW[15] (RW)
 *
 * Host 3 Software Wake-up
 *
 * Values:
 * - 1 - Force wake-up
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_WKUP_SW (15U) /*!< Bit position for USBNC_USB_UH3_CTRL_WKUP_SW. */
#define BM_USBNC_USB_UH3_CTRL_WKUP_SW (0x00008000U) /*!< Bit mask for USBNC_USB_UH3_CTRL_WKUP_SW. */
#define BS_USBNC_USB_UH3_CTRL_WKUP_SW (1U) /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_WKUP_SW. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_WKUP_SW field. */
#define BR_USBNC_USB_UH3_CTRL_WKUP_SW(x) (HW_USBNC_USB_UH3_CTRL(x).B.WKUP_SW)

/*! @brief Format value for bitfield USBNC_USB_UH3_CTRL_WKUP_SW. */
#define BF_USBNC_USB_UH3_CTRL_WKUP_SW(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_CTRL_WKUP_SW) & BM_USBNC_USB_UH3_CTRL_WKUP_SW)

/*! @brief Set the WKUP_SW field to a new value. */
#define BW_USBNC_USB_UH3_CTRL_WKUP_SW(x, v) (HW_USBNC_USB_UH3_CTRL_WR(x, (HW_USBNC_USB_UH3_CTRL_RD(x) & ~BM_USBNC_USB_UH3_CTRL_WKUP_SW) | BF_USBNC_USB_UH3_CTRL_WKUP_SW(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_CTRL, field WIR[31] (RO)
 *
 * Host 3 Wake-up Interrupt Request This bit indicates that a wake-up interrupt
 * request is received on the OTG port. This bit is cleared by disabling the
 * wake-up interrupt (clearing bit "OWIE").
 *
 * Values:
 * - 1 - Wake-up interrupt received
 * - 0 - No Wake-up interrupt received
 */
/*@{*/
#define BP_USBNC_USB_UH3_CTRL_WIR (31U)    /*!< Bit position for USBNC_USB_UH3_CTRL_WIR. */
#define BM_USBNC_USB_UH3_CTRL_WIR (0x80000000U) /*!< Bit mask for USBNC_USB_UH3_CTRL_WIR. */
#define BS_USBNC_USB_UH3_CTRL_WIR (1U)     /*!< Bit field size in bits for USBNC_USB_UH3_CTRL_WIR. */

/*! @brief Read current value of the USBNC_USB_UH3_CTRL_WIR field. */
#define BR_USBNC_USB_UH3_CTRL_WIR(x) (HW_USBNC_USB_UH3_CTRL(x).B.WIR)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH2_HSIC_CTRL - USB Host2 HSIC Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH2_HSIC_CTRL - USB Host2 HSIC Control Register (RW)
 *
 * Reset value: 0x00000042U
 *
 * The USB Host2 HSIC control register controls Host2 high speed IC
 * configuration. These features are not directly related to the USB functionality, but
 * control special features, interfacing on the USB ports, as well as power control.
 */
typedef union _hw_usbnc_usb_uh2_hsic_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_uh2_hsic_ctrl_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t HSIC_CLK_ON : 1;      /*!< [11]  */
        uint32_t HSIC_EN : 1;          /*!< [12]  */
        uint32_t RESERVED1 : 18;       /*!< [30:13]  */
        uint32_t CLK_VLD : 1;          /*!< [31]  */
    } B;
} hw_usbnc_usb_uh2_hsic_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH2_HSIC_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_UH2_HSIC_CTRL_ADDR(x) ((uintptr_t)(x) + 0x810U)

#define HW_USBNC_USB_UH2_HSIC_CTRL(x) (*(__IO hw_usbnc_usb_uh2_hsic_ctrl_t *) HW_USBNC_USB_UH2_HSIC_CTRL_ADDR(x))
#define HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) (HW_USBNC_USB_UH2_HSIC_CTRL(x).U)
#define HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL(x).U = (v))
#define HW_USBNC_USB_UH2_HSIC_CTRL_SET(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_UH2_HSIC_CTRL_CLR(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_UH2_HSIC_CTRL_TOG(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH2_HSIC_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_UH2_HSIC_CTRL, field HSIC_CLK_ON[11] (RW)
 *
 * Force Host2 HSIC module 480M clock on, even when in Host 2 is in suspend mode.
 *
 * Values:
 * - 1 - Active
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON (11U) /*!< Bit position for USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON. */
#define BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON (0x00000800U) /*!< Bit mask for USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON. */
#define BS_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON (1U) /*!< Bit field size in bits for USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON. */

/*! @brief Read current value of the USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON field. */
#define BR_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON(x) (HW_USBNC_USB_UH2_HSIC_CTRL(x).B.HSIC_CLK_ON)

/*! @brief Format value for bitfield USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON. */
#define BF_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON) & BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON)

/*! @brief Set the HSIC_CLK_ON field to a new value. */
#define BW_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, (HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) & ~BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON) | BF_USBNC_USB_UH2_HSIC_CTRL_HSIC_CLK_ON(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_HSIC_CTRL, field HSIC_EN[12] (RW)
 *
 * Host2 HSIC enable
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Disabled
 */
/*@{*/
#define BP_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN (12U) /*!< Bit position for USBNC_USB_UH2_HSIC_CTRL_HSIC_EN. */
#define BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN (0x00001000U) /*!< Bit mask for USBNC_USB_UH2_HSIC_CTRL_HSIC_EN. */
#define BS_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH2_HSIC_CTRL_HSIC_EN. */

/*! @brief Read current value of the USBNC_USB_UH2_HSIC_CTRL_HSIC_EN field. */
#define BR_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN(x) (HW_USBNC_USB_UH2_HSIC_CTRL(x).B.HSIC_EN)

/*! @brief Format value for bitfield USBNC_USB_UH2_HSIC_CTRL_HSIC_EN. */
#define BF_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN) & BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN)

/*! @brief Set the HSIC_EN field to a new value. */
#define BW_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN(x, v) (HW_USBNC_USB_UH2_HSIC_CTRL_WR(x, (HW_USBNC_USB_UH2_HSIC_CTRL_RD(x) & ~BM_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN) | BF_USBNC_USB_UH2_HSIC_CTRL_HSIC_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH2_HSIC_CTRL, field CLK_VLD[31] (RO)
 *
 * Indicating whether Host2 HSIC clock is valid.
 *
 * Values:
 * - 1 - Valid
 */
/*@{*/
#define BP_USBNC_USB_UH2_HSIC_CTRL_CLK_VLD (31U) /*!< Bit position for USBNC_USB_UH2_HSIC_CTRL_CLK_VLD. */
#define BM_USBNC_USB_UH2_HSIC_CTRL_CLK_VLD (0x80000000U) /*!< Bit mask for USBNC_USB_UH2_HSIC_CTRL_CLK_VLD. */
#define BS_USBNC_USB_UH2_HSIC_CTRL_CLK_VLD (1U) /*!< Bit field size in bits for USBNC_USB_UH2_HSIC_CTRL_CLK_VLD. */

/*! @brief Read current value of the USBNC_USB_UH2_HSIC_CTRL_CLK_VLD field. */
#define BR_USBNC_USB_UH2_HSIC_CTRL_CLK_VLD(x) (HW_USBNC_USB_UH2_HSIC_CTRL(x).B.CLK_VLD)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH3_HSIC_CTRL - USB Host3 HSIC Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH3_HSIC_CTRL - USB Host3 HSIC Control Register (RW)
 *
 * Reset value: 0x00000042U
 *
 * The USB Host3 HSIC control register controls Host3 high speed IC
 * configuration. These features are not directly related to the USB functionality, but
 * control special features, interfacing on the USB ports, as well as power control.
 */
typedef union _hw_usbnc_usb_uh3_hsic_ctrl
{
    uint32_t U;
    struct _hw_usbnc_usb_uh3_hsic_ctrl_bitfields
    {
        uint32_t RESERVED0 : 11;       /*!< [10:0]  */
        uint32_t HSIC_CLK_ON : 1;      /*!< [11]  */
        uint32_t HSIC_EN : 1;          /*!< [12]  */
        uint32_t RESERVED1 : 18;       /*!< [30:13]  */
        uint32_t CLK_VLD : 1;          /*!< [31]  */
    } B;
} hw_usbnc_usb_uh3_hsic_ctrl_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH3_HSIC_CTRL register
 */
/*@{*/
#define HW_USBNC_USB_UH3_HSIC_CTRL_ADDR(x) ((uintptr_t)(x) + 0x814U)

#define HW_USBNC_USB_UH3_HSIC_CTRL(x) (*(__IO hw_usbnc_usb_uh3_hsic_ctrl_t *) HW_USBNC_USB_UH3_HSIC_CTRL_ADDR(x))
#define HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) (HW_USBNC_USB_UH3_HSIC_CTRL(x).U)
#define HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL(x).U = (v))
#define HW_USBNC_USB_UH3_HSIC_CTRL_SET(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) |  (v)))
#define HW_USBNC_USB_UH3_HSIC_CTRL_CLR(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) & ~(v)))
#define HW_USBNC_USB_UH3_HSIC_CTRL_TOG(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH3_HSIC_CTRL bitfields
 */

/*!
 * @name Register USBNC_USB_UH3_HSIC_CTRL, field HSIC_CLK_ON[11] (RW)
 *
 * Force Host3 HSIC module 480M clock on, even when in Host 2 is in suspend mode.
 *
 * Values:
 * - 1 - Active
 * - 0 - Inactive
 */
/*@{*/
#define BP_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON (11U) /*!< Bit position for USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON. */
#define BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON (0x00000800U) /*!< Bit mask for USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON. */
#define BS_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON (1U) /*!< Bit field size in bits for USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON. */

/*! @brief Read current value of the USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON field. */
#define BR_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON(x) (HW_USBNC_USB_UH3_HSIC_CTRL(x).B.HSIC_CLK_ON)

/*! @brief Format value for bitfield USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON. */
#define BF_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON) & BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON)

/*! @brief Set the HSIC_CLK_ON field to a new value. */
#define BW_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, (HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) & ~BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON) | BF_USBNC_USB_UH3_HSIC_CTRL_HSIC_CLK_ON(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_HSIC_CTRL, field HSIC_EN[12] (RW)
 *
 * Host3 HSIC enable
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Disabled
 */
/*@{*/
#define BP_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN (12U) /*!< Bit position for USBNC_USB_UH3_HSIC_CTRL_HSIC_EN. */
#define BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN (0x00001000U) /*!< Bit mask for USBNC_USB_UH3_HSIC_CTRL_HSIC_EN. */
#define BS_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN (1U) /*!< Bit field size in bits for USBNC_USB_UH3_HSIC_CTRL_HSIC_EN. */

/*! @brief Read current value of the USBNC_USB_UH3_HSIC_CTRL_HSIC_EN field. */
#define BR_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN(x) (HW_USBNC_USB_UH3_HSIC_CTRL(x).B.HSIC_EN)

/*! @brief Format value for bitfield USBNC_USB_UH3_HSIC_CTRL_HSIC_EN. */
#define BF_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN) & BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN)

/*! @brief Set the HSIC_EN field to a new value. */
#define BW_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN(x, v) (HW_USBNC_USB_UH3_HSIC_CTRL_WR(x, (HW_USBNC_USB_UH3_HSIC_CTRL_RD(x) & ~BM_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN) | BF_USBNC_USB_UH3_HSIC_CTRL_HSIC_EN(v)))
/*@}*/

/*!
 * @name Register USBNC_USB_UH3_HSIC_CTRL, field CLK_VLD[31] (RO)
 *
 * Indicating whether Host3 HSIC clock is valid.
 *
 * Values:
 * - 1 - Valid
 */
/*@{*/
#define BP_USBNC_USB_UH3_HSIC_CTRL_CLK_VLD (31U) /*!< Bit position for USBNC_USB_UH3_HSIC_CTRL_CLK_VLD. */
#define BM_USBNC_USB_UH3_HSIC_CTRL_CLK_VLD (0x80000000U) /*!< Bit mask for USBNC_USB_UH3_HSIC_CTRL_CLK_VLD. */
#define BS_USBNC_USB_UH3_HSIC_CTRL_CLK_VLD (1U) /*!< Bit field size in bits for USBNC_USB_UH3_HSIC_CTRL_CLK_VLD. */

/*! @brief Read current value of the USBNC_USB_UH3_HSIC_CTRL_CLK_VLD field. */
#define BR_USBNC_USB_UH3_HSIC_CTRL_CLK_VLD(x) (HW_USBNC_USB_UH3_HSIC_CTRL(x).B.CLK_VLD)
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_OTG_PHY_CTRL_0 - OTG UTMI PHY Control 0 Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_OTG_PHY_CTRL_0 - OTG UTMI PHY Control 0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * USB OTG UTMI PHY control register 0 is used to control the on-chip OTG UTMI
 * PHY.
 */
typedef union _hw_usbnc_usb_otg_phy_ctrl_0
{
    uint32_t U;
    struct _hw_usbnc_usb_otg_phy_ctrl_0_bitfields
    {
        uint32_t RESERVED0 : 31;       /*!< [30:0]  */
        uint32_t UTMI_CLK_VLD : 1;     /*!< [31]  */
    } B;
} hw_usbnc_usb_otg_phy_ctrl_0_t;

/*!
 * @name Constants and macros for entire USBNC_USB_OTG_PHY_CTRL_0 register
 */
/*@{*/
#define HW_USBNC_USB_OTG_PHY_CTRL_0_ADDR(x) ((uintptr_t)(x) + 0x818U)

#define HW_USBNC_USB_OTG_PHY_CTRL_0(x) (*(__IO hw_usbnc_usb_otg_phy_ctrl_0_t *) HW_USBNC_USB_OTG_PHY_CTRL_0_ADDR(x))
#define HW_USBNC_USB_OTG_PHY_CTRL_0_RD(x) (HW_USBNC_USB_OTG_PHY_CTRL_0(x).U)
#define HW_USBNC_USB_OTG_PHY_CTRL_0_WR(x, v) (HW_USBNC_USB_OTG_PHY_CTRL_0(x).U = (v))
#define HW_USBNC_USB_OTG_PHY_CTRL_0_SET(x, v) (HW_USBNC_USB_OTG_PHY_CTRL_0_WR(x, HW_USBNC_USB_OTG_PHY_CTRL_0_RD(x) |  (v)))
#define HW_USBNC_USB_OTG_PHY_CTRL_0_CLR(x, v) (HW_USBNC_USB_OTG_PHY_CTRL_0_WR(x, HW_USBNC_USB_OTG_PHY_CTRL_0_RD(x) & ~(v)))
#define HW_USBNC_USB_OTG_PHY_CTRL_0_TOG(x, v) (HW_USBNC_USB_OTG_PHY_CTRL_0_WR(x, HW_USBNC_USB_OTG_PHY_CTRL_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_OTG_PHY_CTRL_0 bitfields
 */

/*!
 * @name Register USBNC_USB_OTG_PHY_CTRL_0, field UTMI_CLK_VLD[31] (RW)
 *
 * Indicating whether OTG UTMI PHY clock is valid
 *
 * Values:
 * - 1 - Valid
 * - 0 - Invalid
 */
/*@{*/
#define BP_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD (31U) /*!< Bit position for USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BM_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD (0x80000000U) /*!< Bit mask for USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BS_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD (1U) /*!< Bit field size in bits for USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD. */

/*! @brief Read current value of the USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD field. */
#define BR_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD(x) (HW_USBNC_USB_OTG_PHY_CTRL_0(x).B.UTMI_CLK_VLD)

/*! @brief Format value for bitfield USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BF_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD) & BM_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD)

/*! @brief Set the UTMI_CLK_VLD field to a new value. */
#define BW_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD(x, v) (HW_USBNC_USB_OTG_PHY_CTRL_0_WR(x, (HW_USBNC_USB_OTG_PHY_CTRL_0_RD(x) & ~BM_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD) | BF_USBNC_USB_OTG_PHY_CTRL_0_UTMI_CLK_VLD(v)))
/*@}*/

/*******************************************************************************
 * HW_USBNC_USB_UH1_PHY_CTRL_0 - Host1 UTMI PHY Control 0 Register
 ******************************************************************************/

/*!
 * @brief HW_USBNC_USB_UH1_PHY_CTRL_0 - Host1 UTMI PHY Control 0 Register (RW)
 *
 * Reset value: 0x00000098U
 *
 * USB Host1 UTMI PHY Control Register 0 are used to control the on-chip Host1
 * UTMI PHY.
 */
typedef union _hw_usbnc_usb_uh1_phy_ctrl_0
{
    uint32_t U;
    struct _hw_usbnc_usb_uh1_phy_ctrl_0_bitfields
    {
        uint32_t RESERVED0 : 31;       /*!< [30:0]  */
        uint32_t UTMI_CLK_VLD : 1;     /*!< [31]  */
    } B;
} hw_usbnc_usb_uh1_phy_ctrl_0_t;

/*!
 * @name Constants and macros for entire USBNC_USB_UH1_PHY_CTRL_0 register
 */
/*@{*/
#define HW_USBNC_USB_UH1_PHY_CTRL_0_ADDR(x) ((uintptr_t)(x) + 0x81CU)

#define HW_USBNC_USB_UH1_PHY_CTRL_0(x) (*(__IO hw_usbnc_usb_uh1_phy_ctrl_0_t *) HW_USBNC_USB_UH1_PHY_CTRL_0_ADDR(x))
#define HW_USBNC_USB_UH1_PHY_CTRL_0_RD(x) (HW_USBNC_USB_UH1_PHY_CTRL_0(x).U)
#define HW_USBNC_USB_UH1_PHY_CTRL_0_WR(x, v) (HW_USBNC_USB_UH1_PHY_CTRL_0(x).U = (v))
#define HW_USBNC_USB_UH1_PHY_CTRL_0_SET(x, v) (HW_USBNC_USB_UH1_PHY_CTRL_0_WR(x, HW_USBNC_USB_UH1_PHY_CTRL_0_RD(x) |  (v)))
#define HW_USBNC_USB_UH1_PHY_CTRL_0_CLR(x, v) (HW_USBNC_USB_UH1_PHY_CTRL_0_WR(x, HW_USBNC_USB_UH1_PHY_CTRL_0_RD(x) & ~(v)))
#define HW_USBNC_USB_UH1_PHY_CTRL_0_TOG(x, v) (HW_USBNC_USB_UH1_PHY_CTRL_0_WR(x, HW_USBNC_USB_UH1_PHY_CTRL_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBNC_USB_UH1_PHY_CTRL_0 bitfields
 */

/*!
 * @name Register USBNC_USB_UH1_PHY_CTRL_0, field UTMI_CLK_VLD[31] (RW)
 *
 * Indicating whether Host 1 UTMI PHY clock is valid
 *
 * Values:
 * - 1 - Valid
 * - 0 - Invalid
 */
/*@{*/
#define BP_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD (31U) /*!< Bit position for USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BM_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD (0x80000000U) /*!< Bit mask for USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BS_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD (1U) /*!< Bit field size in bits for USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD. */

/*! @brief Read current value of the USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD field. */
#define BR_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD(x) (HW_USBNC_USB_UH1_PHY_CTRL_0(x).B.UTMI_CLK_VLD)

/*! @brief Format value for bitfield USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD. */
#define BF_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD(v) ((uint32_t)((uint32_t)(v) << BP_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD) & BM_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD)

/*! @brief Set the UTMI_CLK_VLD field to a new value. */
#define BW_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD(x, v) (HW_USBNC_USB_UH1_PHY_CTRL_0_WR(x, (HW_USBNC_USB_UH1_PHY_CTRL_0_RD(x) & ~BM_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD) | BF_USBNC_USB_UH1_PHY_CTRL_0_UTMI_CLK_VLD(v)))
/*@}*/

/*******************************************************************************
 * hw_usbnc_t - module struct
 ******************************************************************************/
/*!
 * @brief All USBNC module registers.
 */
#pragma pack(1)
typedef struct _hw_usbnc
{
    uint8_t _reserved0[2048];
    __IO hw_usbnc_usb_otg_ctrl_t USB_OTG_CTRL; /*!< [0x800] USB OTG Control Register */
    __IO hw_usbnc_usb_uh1_ctrl_t USB_UH1_CTRL; /*!< [0x804] USB Host1 Control Register */
    __IO hw_usbnc_usb_uh2_ctrl_t USB_UH2_CTRL; /*!< [0x808] USB Host2 Control Register */
    __IO hw_usbnc_usb_uh3_ctrl_t USB_UH3_CTRL; /*!< [0x80C] USB Host3 Control Register */
    __IO hw_usbnc_usb_uh2_hsic_ctrl_t USB_UH2_HSIC_CTRL; /*!< [0x810] USB Host2 HSIC Control Register */
    __IO hw_usbnc_usb_uh3_hsic_ctrl_t USB_UH3_HSIC_CTRL; /*!< [0x814] USB Host3 HSIC Control Register */
    __IO hw_usbnc_usb_otg_phy_ctrl_0_t USB_OTG_PHY_CTRL_0; /*!< [0x818] OTG UTMI PHY Control 0 Register */
    __IO hw_usbnc_usb_uh1_phy_ctrl_0_t USB_UH1_PHY_CTRL_0; /*!< [0x81C] Host1 UTMI PHY Control 0 Register */
} hw_usbnc_t;
#pragma pack()

/*! @brief Macro to access all USBNC registers. */
/*! @param x USBNC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_USBNC_REGS(USBNC_BASE)</code>. */
#define HW_USBNC_REGS(x) (*(hw_usbnc_t *)(x))

/*
 * iMX6DP USBPHY
 *
 * USBPHY Register Reference Index
 *
 * Registers defined in this header file:
 * - HW_USBPHY_PWD - USB PHY Power-Down Register
 * - HW_USBPHY_TX - USB PHY Transmitter Control Register
 * - HW_USBPHY_RX - USB PHY Receiver Control Register
 * - HW_USBPHY_CTRL - USB PHY General Control Register
 * - HW_USBPHY_STATUS - USB PHY Status Register
 * - HW_USBPHY_DEBUG - USB PHY Debug Register
 * - HW_USBPHY_DEBUG0_STATUS - UTMI Debug Status Register 0
 * - HW_USBPHY_DEBUG1 - UTMI Debug Status Register 1
 * - HW_USBPHY_VERSION - UTMI RTL Version
 *
 * - hw_usbphy_t - Struct containing all module registers.
 */

#define HW_USBPHY_INSTANCE_COUNT (2U) /*!< Number of instances of the USBPHY module. */
#define HW_USBPHY1 (0U) /*!< Instance number for USBPHY1. */
#define HW_USBPHY2 (1U) /*!< Instance number for USBPHY2. */
#define USBPHY1_BASE          (0x20C9000U) /*!< Base address for USBPHY1. */
#define USBPHY2_BASE          (0x20CA000U) /*!< Base address for USBPHY2. */
/*! Array initializer of USBPHY base addresses. */
#define USBPHY_BASE_ADDRS     { USBPHY1_BASE, USBPHY2_BASE }

/*******************************************************************************
 * HW_USBPHY_PWD - USB PHY Power-Down Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_PWD - USB PHY Power-Down Register (RW)
 *
 * Reset value: 0x001E1C00U
 *
 * The USB PHY Power-Down Register provides overall control of the PHY power
 * state. Before programming this register, the PHY clocks must be enabled in
 * registers USBPHYx_CTRLn and CCM_ANALOG_USBPHYx_PLL_480_CTRLn.
 */
typedef union _hw_usbphy_pwd
{
    uint32_t U;
    struct _hw_usbphy_pwd_bitfields
    {
        uint32_t RSVD0 : 10;           /*!< [9:0]  */
        uint32_t TXPWDFS : 1;          /*!< [10]  */
        uint32_t TXPWDIBIAS : 1;       /*!< [11]  */
        uint32_t TXPWDV2I : 1;         /*!< [12]  */
        uint32_t RSVD1 : 4;            /*!< [16:13]  */
        uint32_t RXPWDENV : 1;         /*!< [17]  */
        uint32_t RXPWD1PT1 : 1;        /*!< [18]  */
        uint32_t RXPWDDIFF : 1;        /*!< [19]  */
        uint32_t RXPWDRX : 1;          /*!< [20]  */
        uint32_t RSVD2 : 11;           /*!< [31:21]  */
    } B;
} hw_usbphy_pwd_t;

/*!
 * @name Constants and macros for entire USBPHY_PWD register
 */
/*@{*/
#define HW_USBPHY_PWD_ADDR(x)    ((uintptr_t)(x) + 0x0U)
#define HW_USBPHY_PWD_SET_ADDR(x) (HW_USBPHY_PWD_ADDR(x) + 0x4U)
#define HW_USBPHY_PWD_CLR_ADDR(x) (HW_USBPHY_PWD_ADDR(x) + 0x8U)
#define HW_USBPHY_PWD_TOG_ADDR(x) (HW_USBPHY_PWD_ADDR(x) + 0xCU)

#define HW_USBPHY_PWD(x)         (*(__IO hw_usbphy_pwd_t *) HW_USBPHY_PWD_ADDR(x))
#define HW_USBPHY_PWD_RD(x)      (HW_USBPHY_PWD(x).U)
#define HW_USBPHY_PWD_WR(x, v)   (HW_USBPHY_PWD(x).U = (v))
#define HW_USBPHY_PWD_SET(x, v)  ((*(uint32_t *) HW_USBPHY_PWD_SET_ADDR(x)) = (v))
#define HW_USBPHY_PWD_CLR(x, v)  ((*(uint32_t *) HW_USBPHY_PWD_CLR_ADDR(x)) = (v))
#define HW_USBPHY_PWD_TOG(x, v)  ((*(uint32_t *) HW_USBPHY_PWD_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_PWD bitfields
 */

/*!
 * @name Register USBPHY_PWD, field RSVD0[9:0] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_PWD_RSVD0  (0U)          /*!< Bit position for USBPHY_PWD_RSVD0. */
#define BM_USBPHY_PWD_RSVD0  (0x000003FFU) /*!< Bit mask for USBPHY_PWD_RSVD0. */
#define BS_USBPHY_PWD_RSVD0  (10U)         /*!< Bit field size in bits for USBPHY_PWD_RSVD0. */

/*! @brief Read current value of the USBPHY_PWD_RSVD0 field. */
#define BR_USBPHY_PWD_RSVD0(x) (HW_USBPHY_PWD(x).B.RSVD0)
/*@}*/

/*!
 * @name Register USBPHY_PWD, field TXPWDFS[10] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB full-speed drivers. This turns
 * off the current starvation sources and puts the drivers into high-impedance
 * output. Note that this bit will be auto cleared if there is USB wakeup event
 * while ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL is enabled.
 */
/*@{*/
#define BP_USBPHY_PWD_TXPWDFS (10U)        /*!< Bit position for USBPHY_PWD_TXPWDFS. */
#define BM_USBPHY_PWD_TXPWDFS (0x00000400U) /*!< Bit mask for USBPHY_PWD_TXPWDFS. */
#define BS_USBPHY_PWD_TXPWDFS (1U)         /*!< Bit field size in bits for USBPHY_PWD_TXPWDFS. */

/*! @brief Read current value of the USBPHY_PWD_TXPWDFS field. */
#define BR_USBPHY_PWD_TXPWDFS(x) (HW_USBPHY_PWD(x).B.TXPWDFS)

/*! @brief Format value for bitfield USBPHY_PWD_TXPWDFS. */
#define BF_USBPHY_PWD_TXPWDFS(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_TXPWDFS) & BM_USBPHY_PWD_TXPWDFS)

/*! @brief Set the TXPWDFS field to a new value. */
#define BW_USBPHY_PWD_TXPWDFS(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_TXPWDFS) | BF_USBPHY_PWD_TXPWDFS(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field TXPWDIBIAS[11] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB PHY current bias block for the
 * transmitter. This bit should be set only when the USB is in suspend mode. This
 * effectively powers down the entire USB transmit path. Note that this bit will
 * be auto cleared if there is USB wakeup event while ENAUTOCLR_PHY_PWD bit of
 * USBPHYx_CTRL is enabled. Note that these circuits are shared with the battery
 * charge circuit. Setting this bit to 1 does not power-down these circuits, unless
 * the corresponding bit in the battery charger is also set for power-down.
 */
/*@{*/
#define BP_USBPHY_PWD_TXPWDIBIAS (11U)     /*!< Bit position for USBPHY_PWD_TXPWDIBIAS. */
#define BM_USBPHY_PWD_TXPWDIBIAS (0x00000800U) /*!< Bit mask for USBPHY_PWD_TXPWDIBIAS. */
#define BS_USBPHY_PWD_TXPWDIBIAS (1U)      /*!< Bit field size in bits for USBPHY_PWD_TXPWDIBIAS. */

/*! @brief Read current value of the USBPHY_PWD_TXPWDIBIAS field. */
#define BR_USBPHY_PWD_TXPWDIBIAS(x) (HW_USBPHY_PWD(x).B.TXPWDIBIAS)

/*! @brief Format value for bitfield USBPHY_PWD_TXPWDIBIAS. */
#define BF_USBPHY_PWD_TXPWDIBIAS(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_TXPWDIBIAS) & BM_USBPHY_PWD_TXPWDIBIAS)

/*! @brief Set the TXPWDIBIAS field to a new value. */
#define BW_USBPHY_PWD_TXPWDIBIAS(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_TXPWDIBIAS) | BF_USBPHY_PWD_TXPWDIBIAS(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field TXPWDV2I[12] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB PHY transmit V-to-I converter
 * and the current mirror. Note that this bit will be auto cleared if there is USB
 * wakeup event while ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL is enabled. Note that
 * these circuits are shared with the battery charge circuit. Setting this to 1
 * does not power-down these circuits, unless the corresponding bit in the
 * battery charger is also set for power-down.
 */
/*@{*/
#define BP_USBPHY_PWD_TXPWDV2I (12U)       /*!< Bit position for USBPHY_PWD_TXPWDV2I. */
#define BM_USBPHY_PWD_TXPWDV2I (0x00001000U) /*!< Bit mask for USBPHY_PWD_TXPWDV2I. */
#define BS_USBPHY_PWD_TXPWDV2I (1U)        /*!< Bit field size in bits for USBPHY_PWD_TXPWDV2I. */

/*! @brief Read current value of the USBPHY_PWD_TXPWDV2I field. */
#define BR_USBPHY_PWD_TXPWDV2I(x) (HW_USBPHY_PWD(x).B.TXPWDV2I)

/*! @brief Format value for bitfield USBPHY_PWD_TXPWDV2I. */
#define BF_USBPHY_PWD_TXPWDV2I(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_TXPWDV2I) & BM_USBPHY_PWD_TXPWDV2I)

/*! @brief Set the TXPWDV2I field to a new value. */
#define BW_USBPHY_PWD_TXPWDV2I(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_TXPWDV2I) | BF_USBPHY_PWD_TXPWDV2I(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RSVD1[16:13] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_PWD_RSVD1  (13U)         /*!< Bit position for USBPHY_PWD_RSVD1. */
#define BM_USBPHY_PWD_RSVD1  (0x0001E000U) /*!< Bit mask for USBPHY_PWD_RSVD1. */
#define BS_USBPHY_PWD_RSVD1  (4U)          /*!< Bit field size in bits for USBPHY_PWD_RSVD1. */

/*! @brief Read current value of the USBPHY_PWD_RSVD1 field. */
#define BR_USBPHY_PWD_RSVD1(x) (HW_USBPHY_PWD(x).B.RSVD1)
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RXPWDENV[17] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB high-speed receiver envelope
 * detector (squelch signal). Note that this bit will be auto cleared if there is
 * USB wakeup event while ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL is enabled.
 */
/*@{*/
#define BP_USBPHY_PWD_RXPWDENV (17U)       /*!< Bit position for USBPHY_PWD_RXPWDENV. */
#define BM_USBPHY_PWD_RXPWDENV (0x00020000U) /*!< Bit mask for USBPHY_PWD_RXPWDENV. */
#define BS_USBPHY_PWD_RXPWDENV (1U)        /*!< Bit field size in bits for USBPHY_PWD_RXPWDENV. */

/*! @brief Read current value of the USBPHY_PWD_RXPWDENV field. */
#define BR_USBPHY_PWD_RXPWDENV(x) (HW_USBPHY_PWD(x).B.RXPWDENV)

/*! @brief Format value for bitfield USBPHY_PWD_RXPWDENV. */
#define BF_USBPHY_PWD_RXPWDENV(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_RXPWDENV) & BM_USBPHY_PWD_RXPWDENV)

/*! @brief Set the RXPWDENV field to a new value. */
#define BW_USBPHY_PWD_RXPWDENV(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_RXPWDENV) | BF_USBPHY_PWD_RXPWDENV(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RXPWD1PT1[18] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB full-speed differential
 * receiver. Note that this bit will be auto cleared if there is USB wakeup event while
 * ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL is enabled.
 */
/*@{*/
#define BP_USBPHY_PWD_RXPWD1PT1 (18U)      /*!< Bit position for USBPHY_PWD_RXPWD1PT1. */
#define BM_USBPHY_PWD_RXPWD1PT1 (0x00040000U) /*!< Bit mask for USBPHY_PWD_RXPWD1PT1. */
#define BS_USBPHY_PWD_RXPWD1PT1 (1U)       /*!< Bit field size in bits for USBPHY_PWD_RXPWD1PT1. */

/*! @brief Read current value of the USBPHY_PWD_RXPWD1PT1 field. */
#define BR_USBPHY_PWD_RXPWD1PT1(x) (HW_USBPHY_PWD(x).B.RXPWD1PT1)

/*! @brief Format value for bitfield USBPHY_PWD_RXPWD1PT1. */
#define BF_USBPHY_PWD_RXPWD1PT1(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_RXPWD1PT1) & BM_USBPHY_PWD_RXPWD1PT1)

/*! @brief Set the RXPWD1PT1 field to a new value. */
#define BW_USBPHY_PWD_RXPWD1PT1(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_RXPWD1PT1) | BF_USBPHY_PWD_RXPWD1PT1(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RXPWDDIFF[19] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the USB high-speed differential
 * receiver. Note that this bit will be auto cleared if there is USB wakeup event while
 * ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL is enabled.
 */
/*@{*/
#define BP_USBPHY_PWD_RXPWDDIFF (19U)      /*!< Bit position for USBPHY_PWD_RXPWDDIFF. */
#define BM_USBPHY_PWD_RXPWDDIFF (0x00080000U) /*!< Bit mask for USBPHY_PWD_RXPWDDIFF. */
#define BS_USBPHY_PWD_RXPWDDIFF (1U)       /*!< Bit field size in bits for USBPHY_PWD_RXPWDDIFF. */

/*! @brief Read current value of the USBPHY_PWD_RXPWDDIFF field. */
#define BR_USBPHY_PWD_RXPWDDIFF(x) (HW_USBPHY_PWD(x).B.RXPWDDIFF)

/*! @brief Format value for bitfield USBPHY_PWD_RXPWDDIFF. */
#define BF_USBPHY_PWD_RXPWDDIFF(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_RXPWDDIFF) & BM_USBPHY_PWD_RXPWDDIFF)

/*! @brief Set the RXPWDDIFF field to a new value. */
#define BW_USBPHY_PWD_RXPWDDIFF(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_RXPWDDIFF) | BF_USBPHY_PWD_RXPWDDIFF(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RXPWDRX[20] (RW)
 *
 * 0 = Normal operation. 1 = Power-down the entire USB PHY receiver block except
 * for the full-speed differential receiver. Note that this bit will be auto
 * cleared if there is USB wakeup event while ENAUTOCLR_PHY_PWD bit of USBPHYx_CTRL
 * is enabled.
 */
/*@{*/
#define BP_USBPHY_PWD_RXPWDRX (20U)        /*!< Bit position for USBPHY_PWD_RXPWDRX. */
#define BM_USBPHY_PWD_RXPWDRX (0x00100000U) /*!< Bit mask for USBPHY_PWD_RXPWDRX. */
#define BS_USBPHY_PWD_RXPWDRX (1U)         /*!< Bit field size in bits for USBPHY_PWD_RXPWDRX. */

/*! @brief Read current value of the USBPHY_PWD_RXPWDRX field. */
#define BR_USBPHY_PWD_RXPWDRX(x) (HW_USBPHY_PWD(x).B.RXPWDRX)

/*! @brief Format value for bitfield USBPHY_PWD_RXPWDRX. */
#define BF_USBPHY_PWD_RXPWDRX(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_PWD_RXPWDRX) & BM_USBPHY_PWD_RXPWDRX)

/*! @brief Set the RXPWDRX field to a new value. */
#define BW_USBPHY_PWD_RXPWDRX(x, v) (HW_USBPHY_PWD_WR(x, (HW_USBPHY_PWD_RD(x) & ~BM_USBPHY_PWD_RXPWDRX) | BF_USBPHY_PWD_RXPWDRX(v)))
/*@}*/

/*!
 * @name Register USBPHY_PWD, field RSVD2[31:21] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_PWD_RSVD2  (21U)         /*!< Bit position for USBPHY_PWD_RSVD2. */
#define BM_USBPHY_PWD_RSVD2  (0xFFE00000U) /*!< Bit mask for USBPHY_PWD_RSVD2. */
#define BS_USBPHY_PWD_RSVD2  (11U)         /*!< Bit field size in bits for USBPHY_PWD_RSVD2. */

/*! @brief Read current value of the USBPHY_PWD_RSVD2 field. */
#define BR_USBPHY_PWD_RSVD2(x) (HW_USBPHY_PWD(x).B.RSVD2)
/*@}*/




/*******************************************************************************
 * HW_USBPHY_TX - USB PHY Transmitter Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_TX - USB PHY Transmitter Control Register (RW)
 *
 * Reset value: 0x10060607U
 *
 * The USB PHY Transmitter Control Register handles the transmit controls.
 */
typedef union _hw_usbphy_tx
{
    uint32_t U;
    struct _hw_usbphy_tx_bitfields
    {
        uint32_t D_CAL : 4;            /*!< [3:0]  */
        uint32_t RSVD0 : 4;            /*!< [7:4]  */
        uint32_t TXCAL45DN : 4;        /*!< [11:8]  */
        uint32_t RSVD1 : 4;            /*!< [15:12]  */
        uint32_t TXCAL45DP : 4;        /*!< [19:16]  */
        uint32_t RSVD2 : 6;            /*!< [25:20]  */
        uint32_t USBPHY_TX_EDGECTRL : 3; /*!< [28:26]  */
        uint32_t RSVD5 : 3;            /*!< [31:29]  */
    } B;
} hw_usbphy_tx_t;

/*!
 * @name Constants and macros for entire USBPHY_TX register
 */
/*@{*/
#define HW_USBPHY_TX_ADDR(x)     ((uintptr_t)(x) + 0x10U)
#define HW_USBPHY_TX_SET_ADDR(x) (HW_USBPHY_TX_ADDR(x) + 0x4U)
#define HW_USBPHY_TX_CLR_ADDR(x) (HW_USBPHY_TX_ADDR(x) + 0x8U)
#define HW_USBPHY_TX_TOG_ADDR(x) (HW_USBPHY_TX_ADDR(x) + 0xCU)

#define HW_USBPHY_TX(x)          (*(__IO hw_usbphy_tx_t *) HW_USBPHY_TX_ADDR(x))
#define HW_USBPHY_TX_RD(x)       (HW_USBPHY_TX(x).U)
#define HW_USBPHY_TX_WR(x, v)    (HW_USBPHY_TX(x).U = (v))
#define HW_USBPHY_TX_SET(x, v)   ((*(uint32_t *) HW_USBPHY_TX_SET_ADDR(x)) = (v))
#define HW_USBPHY_TX_CLR(x, v)   ((*(uint32_t *) HW_USBPHY_TX_CLR_ADDR(x)) = (v))
#define HW_USBPHY_TX_TOG(x, v)   ((*(uint32_t *) HW_USBPHY_TX_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_TX bitfields
 */

/*!
 * @name Register USBPHY_TX, field D_CAL[3:0] (RW)
 *
 * Resistor Trimming Code: 0000 = 0.16% 0111 = Nominal 1111 = +25%
 */
/*@{*/
#define BP_USBPHY_TX_D_CAL   (0U)          /*!< Bit position for USBPHY_TX_D_CAL. */
#define BM_USBPHY_TX_D_CAL   (0x0000000FU) /*!< Bit mask for USBPHY_TX_D_CAL. */
#define BS_USBPHY_TX_D_CAL   (4U)          /*!< Bit field size in bits for USBPHY_TX_D_CAL. */

/*! @brief Read current value of the USBPHY_TX_D_CAL field. */
#define BR_USBPHY_TX_D_CAL(x) (HW_USBPHY_TX(x).B.D_CAL)

/*! @brief Format value for bitfield USBPHY_TX_D_CAL. */
#define BF_USBPHY_TX_D_CAL(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_D_CAL) & BM_USBPHY_TX_D_CAL)

/*! @brief Set the D_CAL field to a new value. */
#define BW_USBPHY_TX_D_CAL(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_D_CAL) | BF_USBPHY_TX_D_CAL(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field RSVD0[7:4] (RW)
 *
 * Reserved. Note: This bit should remain clear.
 */
/*@{*/
#define BP_USBPHY_TX_RSVD0   (4U)          /*!< Bit position for USBPHY_TX_RSVD0. */
#define BM_USBPHY_TX_RSVD0   (0x000000F0U) /*!< Bit mask for USBPHY_TX_RSVD0. */
#define BS_USBPHY_TX_RSVD0   (4U)          /*!< Bit field size in bits for USBPHY_TX_RSVD0. */

/*! @brief Read current value of the USBPHY_TX_RSVD0 field. */
#define BR_USBPHY_TX_RSVD0(x) (HW_USBPHY_TX(x).B.RSVD0)

/*! @brief Format value for bitfield USBPHY_TX_RSVD0. */
#define BF_USBPHY_TX_RSVD0(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_RSVD0) & BM_USBPHY_TX_RSVD0)

/*! @brief Set the RSVD0 field to a new value. */
#define BW_USBPHY_TX_RSVD0(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_RSVD0) | BF_USBPHY_TX_RSVD0(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field TXCAL45DN[11:8] (RW)
 *
 * Decode to select a 45-Ohm resistance to the USB_DN output pin. Maximum
 * resistance = 0000. Resistance is centered by design at 0110.
 */
/*@{*/
#define BP_USBPHY_TX_TXCAL45DN (8U)        /*!< Bit position for USBPHY_TX_TXCAL45DN. */
#define BM_USBPHY_TX_TXCAL45DN (0x00000F00U) /*!< Bit mask for USBPHY_TX_TXCAL45DN. */
#define BS_USBPHY_TX_TXCAL45DN (4U)        /*!< Bit field size in bits for USBPHY_TX_TXCAL45DN. */

/*! @brief Read current value of the USBPHY_TX_TXCAL45DN field. */
#define BR_USBPHY_TX_TXCAL45DN(x) (HW_USBPHY_TX(x).B.TXCAL45DN)

/*! @brief Format value for bitfield USBPHY_TX_TXCAL45DN. */
#define BF_USBPHY_TX_TXCAL45DN(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_TXCAL45DN) & BM_USBPHY_TX_TXCAL45DN)

/*! @brief Set the TXCAL45DN field to a new value. */
#define BW_USBPHY_TX_TXCAL45DN(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_TXCAL45DN) | BF_USBPHY_TX_TXCAL45DN(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field RSVD1[15:12] (RW)
 *
 * Reserved. Note: This bit should remain clear.
 */
/*@{*/
#define BP_USBPHY_TX_RSVD1   (12U)         /*!< Bit position for USBPHY_TX_RSVD1. */
#define BM_USBPHY_TX_RSVD1   (0x0000F000U) /*!< Bit mask for USBPHY_TX_RSVD1. */
#define BS_USBPHY_TX_RSVD1   (4U)          /*!< Bit field size in bits for USBPHY_TX_RSVD1. */

/*! @brief Read current value of the USBPHY_TX_RSVD1 field. */
#define BR_USBPHY_TX_RSVD1(x) (HW_USBPHY_TX(x).B.RSVD1)

/*! @brief Format value for bitfield USBPHY_TX_RSVD1. */
#define BF_USBPHY_TX_RSVD1(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_RSVD1) & BM_USBPHY_TX_RSVD1)

/*! @brief Set the RSVD1 field to a new value. */
#define BW_USBPHY_TX_RSVD1(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_RSVD1) | BF_USBPHY_TX_RSVD1(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field TXCAL45DP[19:16] (RW)
 *
 * Decode to select a 45-Ohm resistance to the USB_DP output pin. Maximum
 * resistance = 0000. Resistance is centered by design at 0110.
 */
/*@{*/
#define BP_USBPHY_TX_TXCAL45DP (16U)       /*!< Bit position for USBPHY_TX_TXCAL45DP. */
#define BM_USBPHY_TX_TXCAL45DP (0x000F0000U) /*!< Bit mask for USBPHY_TX_TXCAL45DP. */
#define BS_USBPHY_TX_TXCAL45DP (4U)        /*!< Bit field size in bits for USBPHY_TX_TXCAL45DP. */

/*! @brief Read current value of the USBPHY_TX_TXCAL45DP field. */
#define BR_USBPHY_TX_TXCAL45DP(x) (HW_USBPHY_TX(x).B.TXCAL45DP)

/*! @brief Format value for bitfield USBPHY_TX_TXCAL45DP. */
#define BF_USBPHY_TX_TXCAL45DP(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_TXCAL45DP) & BM_USBPHY_TX_TXCAL45DP)

/*! @brief Set the TXCAL45DP field to a new value. */
#define BW_USBPHY_TX_TXCAL45DP(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_TXCAL45DP) | BF_USBPHY_TX_TXCAL45DP(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field RSVD2[25:20] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_TX_RSVD2   (20U)         /*!< Bit position for USBPHY_TX_RSVD2. */
#define BM_USBPHY_TX_RSVD2   (0x03F00000U) /*!< Bit mask for USBPHY_TX_RSVD2. */
#define BS_USBPHY_TX_RSVD2   (6U)          /*!< Bit field size in bits for USBPHY_TX_RSVD2. */

/*! @brief Read current value of the USBPHY_TX_RSVD2 field. */
#define BR_USBPHY_TX_RSVD2(x) (HW_USBPHY_TX(x).B.RSVD2)
/*@}*/

/*!
 * @name Register USBPHY_TX, field USBPHY_TX_EDGECTRL[28:26] (RW)
 *
 * Controls the edge-rate of the current sensing transistors used in HS
 * transmit. NOT FOR CUSTOMER USE.
 */
/*@{*/
#define BP_USBPHY_TX_USBPHY_TX_EDGECTRL (26U) /*!< Bit position for USBPHY_TX_USBPHY_TX_EDGECTRL. */
#define BM_USBPHY_TX_USBPHY_TX_EDGECTRL (0x1C000000U) /*!< Bit mask for USBPHY_TX_USBPHY_TX_EDGECTRL. */
#define BS_USBPHY_TX_USBPHY_TX_EDGECTRL (3U) /*!< Bit field size in bits for USBPHY_TX_USBPHY_TX_EDGECTRL. */

/*! @brief Read current value of the USBPHY_TX_USBPHY_TX_EDGECTRL field. */
#define BR_USBPHY_TX_USBPHY_TX_EDGECTRL(x) (HW_USBPHY_TX(x).B.USBPHY_TX_EDGECTRL)

/*! @brief Format value for bitfield USBPHY_TX_USBPHY_TX_EDGECTRL. */
#define BF_USBPHY_TX_USBPHY_TX_EDGECTRL(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_TX_USBPHY_TX_EDGECTRL) & BM_USBPHY_TX_USBPHY_TX_EDGECTRL)

/*! @brief Set the USBPHY_TX_EDGECTRL field to a new value. */
#define BW_USBPHY_TX_USBPHY_TX_EDGECTRL(x, v) (HW_USBPHY_TX_WR(x, (HW_USBPHY_TX_RD(x) & ~BM_USBPHY_TX_USBPHY_TX_EDGECTRL) | BF_USBPHY_TX_USBPHY_TX_EDGECTRL(v)))
/*@}*/

/*!
 * @name Register USBPHY_TX, field RSVD5[31:29] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_TX_RSVD5   (29U)         /*!< Bit position for USBPHY_TX_RSVD5. */
#define BM_USBPHY_TX_RSVD5   (0xE0000000U) /*!< Bit mask for USBPHY_TX_RSVD5. */
#define BS_USBPHY_TX_RSVD5   (3U)          /*!< Bit field size in bits for USBPHY_TX_RSVD5. */

/*! @brief Read current value of the USBPHY_TX_RSVD5 field. */
#define BR_USBPHY_TX_RSVD5(x) (HW_USBPHY_TX(x).B.RSVD5)
/*@}*/




/*******************************************************************************
 * HW_USBPHY_RX - USB PHY Receiver Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_RX - USB PHY Receiver Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The USB PHY Receiver Control Register handles receive path controls.
 */
typedef union _hw_usbphy_rx
{
    uint32_t U;
    struct _hw_usbphy_rx_bitfields
    {
        uint32_t ENVADJ : 3;           /*!< [2:0]  */
        uint32_t RSVD0 : 1;            /*!< [3]  */
        uint32_t DISCONADJ : 3;        /*!< [6:4]  */
        uint32_t RSVD1 : 15;           /*!< [21:7]  */
        uint32_t RXDBYPASS : 1;        /*!< [22]  */
        uint32_t RSVD2 : 9;            /*!< [31:23]  */
    } B;
} hw_usbphy_rx_t;

/*!
 * @name Constants and macros for entire USBPHY_RX register
 */
/*@{*/
#define HW_USBPHY_RX_ADDR(x)     ((uintptr_t)(x) + 0x20U)
#define HW_USBPHY_RX_SET_ADDR(x) (HW_USBPHY_RX_ADDR(x) + 0x4U)
#define HW_USBPHY_RX_CLR_ADDR(x) (HW_USBPHY_RX_ADDR(x) + 0x8U)
#define HW_USBPHY_RX_TOG_ADDR(x) (HW_USBPHY_RX_ADDR(x) + 0xCU)

#define HW_USBPHY_RX(x)          (*(__IO hw_usbphy_rx_t *) HW_USBPHY_RX_ADDR(x))
#define HW_USBPHY_RX_RD(x)       (HW_USBPHY_RX(x).U)
#define HW_USBPHY_RX_WR(x, v)    (HW_USBPHY_RX(x).U = (v))
#define HW_USBPHY_RX_SET(x, v)   ((*(uint32_t *) HW_USBPHY_RX_SET_ADDR(x)) = (v))
#define HW_USBPHY_RX_CLR(x, v)   ((*(uint32_t *) HW_USBPHY_RX_CLR_ADDR(x)) = (v))
#define HW_USBPHY_RX_TOG(x, v)   ((*(uint32_t *) HW_USBPHY_RX_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_RX bitfields
 */

/*!
 * @name Register USBPHY_RX, field ENVADJ[2:0] (RW)
 *
 * The ENVADJ field adjusts the trip point for the envelope detector. 000 =
 * Trip-Level Voltage is 0.12500 V 001 = Trip-Level Voltage is 0.10000 V 010 =
 * Trip-Level Voltage is 0.13750 V 011 = Trip-Level Voltage is 0.15000 V 1XX = Reserved
 */
/*@{*/
#define BP_USBPHY_RX_ENVADJ  (0U)          /*!< Bit position for USBPHY_RX_ENVADJ. */
#define BM_USBPHY_RX_ENVADJ  (0x00000007U) /*!< Bit mask for USBPHY_RX_ENVADJ. */
#define BS_USBPHY_RX_ENVADJ  (3U)          /*!< Bit field size in bits for USBPHY_RX_ENVADJ. */

/*! @brief Read current value of the USBPHY_RX_ENVADJ field. */
#define BR_USBPHY_RX_ENVADJ(x) (HW_USBPHY_RX(x).B.ENVADJ)

/*! @brief Format value for bitfield USBPHY_RX_ENVADJ. */
#define BF_USBPHY_RX_ENVADJ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_RX_ENVADJ) & BM_USBPHY_RX_ENVADJ)

/*! @brief Set the ENVADJ field to a new value. */
#define BW_USBPHY_RX_ENVADJ(x, v) (HW_USBPHY_RX_WR(x, (HW_USBPHY_RX_RD(x) & ~BM_USBPHY_RX_ENVADJ) | BF_USBPHY_RX_ENVADJ(v)))
/*@}*/

/*!
 * @name Register USBPHY_RX, field RSVD0[3] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_RX_RSVD0   (3U)          /*!< Bit position for USBPHY_RX_RSVD0. */
#define BM_USBPHY_RX_RSVD0   (0x00000008U) /*!< Bit mask for USBPHY_RX_RSVD0. */
#define BS_USBPHY_RX_RSVD0   (1U)          /*!< Bit field size in bits for USBPHY_RX_RSVD0. */

/*! @brief Read current value of the USBPHY_RX_RSVD0 field. */
#define BR_USBPHY_RX_RSVD0(x) (HW_USBPHY_RX(x).B.RSVD0)
/*@}*/

/*!
 * @name Register USBPHY_RX, field DISCONADJ[6:4] (RW)
 *
 * The DISCONADJ field adjusts the trip point for the disconnect detector: 000 =
 * Trip-Level Voltage is 0.57500 V 001 = Trip-Level Voltage is 0.56875 V 010 =
 * Trip-Level Voltage is 0.58125 V 011 = Trip-Level Voltage is 0.58750 V 1XX =
 * Reserved
 */
/*@{*/
#define BP_USBPHY_RX_DISCONADJ (4U)        /*!< Bit position for USBPHY_RX_DISCONADJ. */
#define BM_USBPHY_RX_DISCONADJ (0x00000070U) /*!< Bit mask for USBPHY_RX_DISCONADJ. */
#define BS_USBPHY_RX_DISCONADJ (3U)        /*!< Bit field size in bits for USBPHY_RX_DISCONADJ. */

/*! @brief Read current value of the USBPHY_RX_DISCONADJ field. */
#define BR_USBPHY_RX_DISCONADJ(x) (HW_USBPHY_RX(x).B.DISCONADJ)

/*! @brief Format value for bitfield USBPHY_RX_DISCONADJ. */
#define BF_USBPHY_RX_DISCONADJ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_RX_DISCONADJ) & BM_USBPHY_RX_DISCONADJ)

/*! @brief Set the DISCONADJ field to a new value. */
#define BW_USBPHY_RX_DISCONADJ(x, v) (HW_USBPHY_RX_WR(x, (HW_USBPHY_RX_RD(x) & ~BM_USBPHY_RX_DISCONADJ) | BF_USBPHY_RX_DISCONADJ(v)))
/*@}*/

/*!
 * @name Register USBPHY_RX, field RSVD1[21:7] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_RX_RSVD1   (7U)          /*!< Bit position for USBPHY_RX_RSVD1. */
#define BM_USBPHY_RX_RSVD1   (0x003FFF80U) /*!< Bit mask for USBPHY_RX_RSVD1. */
#define BS_USBPHY_RX_RSVD1   (15U)         /*!< Bit field size in bits for USBPHY_RX_RSVD1. */

/*! @brief Read current value of the USBPHY_RX_RSVD1 field. */
#define BR_USBPHY_RX_RSVD1(x) (HW_USBPHY_RX(x).B.RSVD1)
/*@}*/

/*!
 * @name Register USBPHY_RX, field RXDBYPASS[22] (RW)
 *
 * 0 = Normal operation. 1 = Use the output of the USB_DP single-ended receiver
 * in place of the full-speed differential receiver. This test mode is intended
 * for lab use only.
 */
/*@{*/
#define BP_USBPHY_RX_RXDBYPASS (22U)       /*!< Bit position for USBPHY_RX_RXDBYPASS. */
#define BM_USBPHY_RX_RXDBYPASS (0x00400000U) /*!< Bit mask for USBPHY_RX_RXDBYPASS. */
#define BS_USBPHY_RX_RXDBYPASS (1U)        /*!< Bit field size in bits for USBPHY_RX_RXDBYPASS. */

/*! @brief Read current value of the USBPHY_RX_RXDBYPASS field. */
#define BR_USBPHY_RX_RXDBYPASS(x) (HW_USBPHY_RX(x).B.RXDBYPASS)

/*! @brief Format value for bitfield USBPHY_RX_RXDBYPASS. */
#define BF_USBPHY_RX_RXDBYPASS(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_RX_RXDBYPASS) & BM_USBPHY_RX_RXDBYPASS)

/*! @brief Set the RXDBYPASS field to a new value. */
#define BW_USBPHY_RX_RXDBYPASS(x, v) (HW_USBPHY_RX_WR(x, (HW_USBPHY_RX_RD(x) & ~BM_USBPHY_RX_RXDBYPASS) | BF_USBPHY_RX_RXDBYPASS(v)))
/*@}*/

/*!
 * @name Register USBPHY_RX, field RSVD2[31:23] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_RX_RSVD2   (23U)         /*!< Bit position for USBPHY_RX_RSVD2. */
#define BM_USBPHY_RX_RSVD2   (0xFF800000U) /*!< Bit mask for USBPHY_RX_RSVD2. */
#define BS_USBPHY_RX_RSVD2   (9U)          /*!< Bit field size in bits for USBPHY_RX_RSVD2. */

/*! @brief Read current value of the USBPHY_RX_RSVD2 field. */
#define BR_USBPHY_RX_RSVD2(x) (HW_USBPHY_RX(x).B.RSVD2)
/*@}*/




/*******************************************************************************
 * HW_USBPHY_CTRL - USB PHY General Control Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_CTRL - USB PHY General Control Register (RW)
 *
 * Reset value: 0xC0200000U
 *
 * The USB PHY General Control Register handles OTG and Host controls. This
 * register also includes interrupt enables and connectivity detect enables and
 * results.
 */
typedef union _hw_usbphy_ctrl
{
    uint32_t U;
    struct _hw_usbphy_ctrl_bitfields
    {
        uint32_t ENOTG_ID_CHG_IRQ : 1; /*!< [0]  */
        uint32_t ENHOSTDISCONDETECT : 1; /*!< [1]  */
        uint32_t ENIRQHOSTDISCON : 1;  /*!< [2]  */
        uint32_t HOSTDISCONDETECT_IRQ : 1; /*!< [3]  */
        uint32_t ENDEVPLUGINDETECT : 1; /*!< [4]  */
        uint32_t DEVPLUGIN_POLARITY : 1; /*!< [5]  */
        uint32_t OTG_ID_CHG_IRQ : 1;   /*!< [6]  */
        uint32_t ENOTGIDDETECT : 1;    /*!< [7]  */
        uint32_t RESUMEIRQSTICKY : 1;  /*!< [8]  */
        uint32_t ENIRQRESUMEDETECT : 1; /*!< [9]  */
        uint32_t RESUME_IRQ : 1;       /*!< [10]  */
        uint32_t ENIRQDEVPLUGIN : 1;   /*!< [11]  */
        uint32_t DEVPLUGIN_IRQ : 1;    /*!< [12]  */
        uint32_t DATA_ON_LRADC : 1;    /*!< [13]  */
        uint32_t ENUTMILEVEL2 : 1;     /*!< [14]  */
        uint32_t ENUTMILEVEL3 : 1;     /*!< [15]  */
        uint32_t ENIRQWAKEUP : 1;      /*!< [16]  */
        uint32_t WAKEUP_IRQ : 1;       /*!< [17]  */
        uint32_t RSVD0 : 1;            /*!< [18]  */
        uint32_t ENAUTOCLR_CLKGATE : 1; /*!< [19]  */
        uint32_t ENAUTOCLR_PHY_PWD : 1; /*!< [20]  */
        uint32_t ENDPDMCHG_WKUP : 1;   /*!< [21]  */
        uint32_t ENIDCHG_WKUP : 1;     /*!< [22]  */
        uint32_t ENVBUSCHG_WKUP : 1;   /*!< [23]  */
        uint32_t FSDLL_RST_EN : 1;     /*!< [24]  */
        uint32_t RSVD1 : 2;            /*!< [26:25]  */
        uint32_t OTG_ID_VALUE : 1;     /*!< [27]  */
        uint32_t HOST_FORCE_LS_SE0 : 1; /*!< [28]  */
        uint32_t UTMI_SUSPENDM : 1;    /*!< [29]  */
        uint32_t CLKGATE : 1;          /*!< [30]  */
        uint32_t SFTRST : 1;           /*!< [31]  */
    } B;
} hw_usbphy_ctrl_t;

/*!
 * @name Constants and macros for entire USBPHY_CTRL register
 */
/*@{*/
#define HW_USBPHY_CTRL_ADDR(x)   ((uintptr_t)(x) + 0x30U)
#define HW_USBPHY_CTRL_SET_ADDR(x) (HW_USBPHY_CTRL_ADDR(x) + 0x4U)
#define HW_USBPHY_CTRL_CLR_ADDR(x) (HW_USBPHY_CTRL_ADDR(x) + 0x8U)
#define HW_USBPHY_CTRL_TOG_ADDR(x) (HW_USBPHY_CTRL_ADDR(x) + 0xCU)

#define HW_USBPHY_CTRL(x)        (*(__IO hw_usbphy_ctrl_t *) HW_USBPHY_CTRL_ADDR(x))
#define HW_USBPHY_CTRL_RD(x)     (HW_USBPHY_CTRL(x).U)
#define HW_USBPHY_CTRL_WR(x, v)  (HW_USBPHY_CTRL(x).U = (v))
#define HW_USBPHY_CTRL_SET(x, v) ((*(uint32_t *) HW_USBPHY_CTRL_SET_ADDR(x)) = (v))
#define HW_USBPHY_CTRL_CLR(x, v) ((*(uint32_t *) HW_USBPHY_CTRL_CLR_ADDR(x)) = (v))
#define HW_USBPHY_CTRL_TOG(x, v) ((*(uint32_t *) HW_USBPHY_CTRL_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_CTRL bitfields
 */

/*!
 * @name Register USBPHY_CTRL, field ENOTG_ID_CHG_IRQ[0] (RW)
 *
 * Enable OTG_ID_CHG_IRQ.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENOTG_ID_CHG_IRQ (0U) /*!< Bit position for USBPHY_CTRL_ENOTG_ID_CHG_IRQ. */
#define BM_USBPHY_CTRL_ENOTG_ID_CHG_IRQ (0x00000001U) /*!< Bit mask for USBPHY_CTRL_ENOTG_ID_CHG_IRQ. */
#define BS_USBPHY_CTRL_ENOTG_ID_CHG_IRQ (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENOTG_ID_CHG_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_ENOTG_ID_CHG_IRQ field. */
#define BR_USBPHY_CTRL_ENOTG_ID_CHG_IRQ(x) (HW_USBPHY_CTRL(x).B.ENOTG_ID_CHG_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_ENOTG_ID_CHG_IRQ. */
#define BF_USBPHY_CTRL_ENOTG_ID_CHG_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENOTG_ID_CHG_IRQ) & BM_USBPHY_CTRL_ENOTG_ID_CHG_IRQ)

/*! @brief Set the ENOTG_ID_CHG_IRQ field to a new value. */
#define BW_USBPHY_CTRL_ENOTG_ID_CHG_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENOTG_ID_CHG_IRQ) | BF_USBPHY_CTRL_ENOTG_ID_CHG_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENHOSTDISCONDETECT[1] (RW)
 *
 * For host mode, enables high-speed disconnect detector. This signal allows the
 * override of enabling the detection that is normally done in the UTMI
 * controller. The UTMI controller enables this circuit whenever the host sends a
 * start-of-frame packet. SW shall set this bit when it found the high-speed device is
 * connected, suggested during bus reset, after found high-speed device in
 * USB_PORTSC1.PSPD). SW shall make sure this bit is not set at the end of resume,
 * otherwise a wrong disconnect status may be detected. Suggest clear it after set
 * USB_PORTSC1.SUSP, set it again after resume is ended(USB_PORTSC1.FPR==0).
 */
/*@{*/
#define BP_USBPHY_CTRL_ENHOSTDISCONDETECT (1U) /*!< Bit position for USBPHY_CTRL_ENHOSTDISCONDETECT. */
#define BM_USBPHY_CTRL_ENHOSTDISCONDETECT (0x00000002U) /*!< Bit mask for USBPHY_CTRL_ENHOSTDISCONDETECT. */
#define BS_USBPHY_CTRL_ENHOSTDISCONDETECT (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENHOSTDISCONDETECT. */

/*! @brief Read current value of the USBPHY_CTRL_ENHOSTDISCONDETECT field. */
#define BR_USBPHY_CTRL_ENHOSTDISCONDETECT(x) (HW_USBPHY_CTRL(x).B.ENHOSTDISCONDETECT)

/*! @brief Format value for bitfield USBPHY_CTRL_ENHOSTDISCONDETECT. */
#define BF_USBPHY_CTRL_ENHOSTDISCONDETECT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENHOSTDISCONDETECT) & BM_USBPHY_CTRL_ENHOSTDISCONDETECT)

/*! @brief Set the ENHOSTDISCONDETECT field to a new value. */
#define BW_USBPHY_CTRL_ENHOSTDISCONDETECT(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENHOSTDISCONDETECT) | BF_USBPHY_CTRL_ENHOSTDISCONDETECT(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENIRQHOSTDISCON[2] (RW)
 *
 * Enables interrupt for detection of disconnection to Device when in high-speed
 * host mode. This should be enabled after ENDEVPLUGINDETECT is enabled.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENIRQHOSTDISCON (2U) /*!< Bit position for USBPHY_CTRL_ENIRQHOSTDISCON. */
#define BM_USBPHY_CTRL_ENIRQHOSTDISCON (0x00000004U) /*!< Bit mask for USBPHY_CTRL_ENIRQHOSTDISCON. */
#define BS_USBPHY_CTRL_ENIRQHOSTDISCON (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENIRQHOSTDISCON. */

/*! @brief Read current value of the USBPHY_CTRL_ENIRQHOSTDISCON field. */
#define BR_USBPHY_CTRL_ENIRQHOSTDISCON(x) (HW_USBPHY_CTRL(x).B.ENIRQHOSTDISCON)

/*! @brief Format value for bitfield USBPHY_CTRL_ENIRQHOSTDISCON. */
#define BF_USBPHY_CTRL_ENIRQHOSTDISCON(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENIRQHOSTDISCON) & BM_USBPHY_CTRL_ENIRQHOSTDISCON)

/*! @brief Set the ENIRQHOSTDISCON field to a new value. */
#define BW_USBPHY_CTRL_ENIRQHOSTDISCON(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENIRQHOSTDISCON) | BF_USBPHY_CTRL_ENIRQHOSTDISCON(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field HOSTDISCONDETECT_IRQ[3] (RW)
 *
 * Indicates that the device has disconnected in high-speed mode. Reset this bit
 * by writing a 1 to the clear address space and not by a general write.
 */
/*@{*/
#define BP_USBPHY_CTRL_HOSTDISCONDETECT_IRQ (3U) /*!< Bit position for USBPHY_CTRL_HOSTDISCONDETECT_IRQ. */
#define BM_USBPHY_CTRL_HOSTDISCONDETECT_IRQ (0x00000008U) /*!< Bit mask for USBPHY_CTRL_HOSTDISCONDETECT_IRQ. */
#define BS_USBPHY_CTRL_HOSTDISCONDETECT_IRQ (1U) /*!< Bit field size in bits for USBPHY_CTRL_HOSTDISCONDETECT_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_HOSTDISCONDETECT_IRQ field. */
#define BR_USBPHY_CTRL_HOSTDISCONDETECT_IRQ(x) (HW_USBPHY_CTRL(x).B.HOSTDISCONDETECT_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_HOSTDISCONDETECT_IRQ. */
#define BF_USBPHY_CTRL_HOSTDISCONDETECT_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_HOSTDISCONDETECT_IRQ) & BM_USBPHY_CTRL_HOSTDISCONDETECT_IRQ)

/*! @brief Set the HOSTDISCONDETECT_IRQ field to a new value. */
#define BW_USBPHY_CTRL_HOSTDISCONDETECT_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_HOSTDISCONDETECT_IRQ) | BF_USBPHY_CTRL_HOSTDISCONDETECT_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENDEVPLUGINDETECT[4] (RW)
 *
 * For device mode, enables 200-KOhm pullups for detecting connectivity to the
 * host.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENDEVPLUGINDETECT (4U) /*!< Bit position for USBPHY_CTRL_ENDEVPLUGINDETECT. */
#define BM_USBPHY_CTRL_ENDEVPLUGINDETECT (0x00000010U) /*!< Bit mask for USBPHY_CTRL_ENDEVPLUGINDETECT. */
#define BS_USBPHY_CTRL_ENDEVPLUGINDETECT (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENDEVPLUGINDETECT. */

/*! @brief Read current value of the USBPHY_CTRL_ENDEVPLUGINDETECT field. */
#define BR_USBPHY_CTRL_ENDEVPLUGINDETECT(x) (HW_USBPHY_CTRL(x).B.ENDEVPLUGINDETECT)

/*! @brief Format value for bitfield USBPHY_CTRL_ENDEVPLUGINDETECT. */
#define BF_USBPHY_CTRL_ENDEVPLUGINDETECT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENDEVPLUGINDETECT) & BM_USBPHY_CTRL_ENDEVPLUGINDETECT)

/*! @brief Set the ENDEVPLUGINDETECT field to a new value. */
#define BW_USBPHY_CTRL_ENDEVPLUGINDETECT(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENDEVPLUGINDETECT) | BF_USBPHY_CTRL_ENDEVPLUGINDETECT(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field DEVPLUGIN_POLARITY[5] (RW)
 *
 * For device mode, if this bit is cleared to 0, then it trips the interrupt if
 * the device is plugged in. If set to 1, then it trips the interrupt if the
 * device is unplugged.
 */
/*@{*/
#define BP_USBPHY_CTRL_DEVPLUGIN_POLARITY (5U) /*!< Bit position for USBPHY_CTRL_DEVPLUGIN_POLARITY. */
#define BM_USBPHY_CTRL_DEVPLUGIN_POLARITY (0x00000020U) /*!< Bit mask for USBPHY_CTRL_DEVPLUGIN_POLARITY. */
#define BS_USBPHY_CTRL_DEVPLUGIN_POLARITY (1U) /*!< Bit field size in bits for USBPHY_CTRL_DEVPLUGIN_POLARITY. */

/*! @brief Read current value of the USBPHY_CTRL_DEVPLUGIN_POLARITY field. */
#define BR_USBPHY_CTRL_DEVPLUGIN_POLARITY(x) (HW_USBPHY_CTRL(x).B.DEVPLUGIN_POLARITY)

/*! @brief Format value for bitfield USBPHY_CTRL_DEVPLUGIN_POLARITY. */
#define BF_USBPHY_CTRL_DEVPLUGIN_POLARITY(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_DEVPLUGIN_POLARITY) & BM_USBPHY_CTRL_DEVPLUGIN_POLARITY)

/*! @brief Set the DEVPLUGIN_POLARITY field to a new value. */
#define BW_USBPHY_CTRL_DEVPLUGIN_POLARITY(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_DEVPLUGIN_POLARITY) | BF_USBPHY_CTRL_DEVPLUGIN_POLARITY(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field OTG_ID_CHG_IRQ[6] (RW)
 *
 * OTG ID change interrupt. Indicates the value of ID pin changed.
 */
/*@{*/
#define BP_USBPHY_CTRL_OTG_ID_CHG_IRQ (6U) /*!< Bit position for USBPHY_CTRL_OTG_ID_CHG_IRQ. */
#define BM_USBPHY_CTRL_OTG_ID_CHG_IRQ (0x00000040U) /*!< Bit mask for USBPHY_CTRL_OTG_ID_CHG_IRQ. */
#define BS_USBPHY_CTRL_OTG_ID_CHG_IRQ (1U) /*!< Bit field size in bits for USBPHY_CTRL_OTG_ID_CHG_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_OTG_ID_CHG_IRQ field. */
#define BR_USBPHY_CTRL_OTG_ID_CHG_IRQ(x) (HW_USBPHY_CTRL(x).B.OTG_ID_CHG_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_OTG_ID_CHG_IRQ. */
#define BF_USBPHY_CTRL_OTG_ID_CHG_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_OTG_ID_CHG_IRQ) & BM_USBPHY_CTRL_OTG_ID_CHG_IRQ)

/*! @brief Set the OTG_ID_CHG_IRQ field to a new value. */
#define BW_USBPHY_CTRL_OTG_ID_CHG_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_OTG_ID_CHG_IRQ) | BF_USBPHY_CTRL_OTG_ID_CHG_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENOTGIDDETECT[7] (RW)
 *
 * Enables circuit to detect resistance of MiniAB ID pin.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENOTGIDDETECT (7U)  /*!< Bit position for USBPHY_CTRL_ENOTGIDDETECT. */
#define BM_USBPHY_CTRL_ENOTGIDDETECT (0x00000080U) /*!< Bit mask for USBPHY_CTRL_ENOTGIDDETECT. */
#define BS_USBPHY_CTRL_ENOTGIDDETECT (1U)  /*!< Bit field size in bits for USBPHY_CTRL_ENOTGIDDETECT. */

/*! @brief Read current value of the USBPHY_CTRL_ENOTGIDDETECT field. */
#define BR_USBPHY_CTRL_ENOTGIDDETECT(x) (HW_USBPHY_CTRL(x).B.ENOTGIDDETECT)

/*! @brief Format value for bitfield USBPHY_CTRL_ENOTGIDDETECT. */
#define BF_USBPHY_CTRL_ENOTGIDDETECT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENOTGIDDETECT) & BM_USBPHY_CTRL_ENOTGIDDETECT)

/*! @brief Set the ENOTGIDDETECT field to a new value. */
#define BW_USBPHY_CTRL_ENOTGIDDETECT(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENOTGIDDETECT) | BF_USBPHY_CTRL_ENOTGIDDETECT(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field RESUMEIRQSTICKY[8] (RW)
 *
 * Set to 1 will make RESUME_IRQ bit a sticky bit until software clear it. Set
 * to 0, RESUME_IRQ only set during the wake-up period.
 */
/*@{*/
#define BP_USBPHY_CTRL_RESUMEIRQSTICKY (8U) /*!< Bit position for USBPHY_CTRL_RESUMEIRQSTICKY. */
#define BM_USBPHY_CTRL_RESUMEIRQSTICKY (0x00000100U) /*!< Bit mask for USBPHY_CTRL_RESUMEIRQSTICKY. */
#define BS_USBPHY_CTRL_RESUMEIRQSTICKY (1U) /*!< Bit field size in bits for USBPHY_CTRL_RESUMEIRQSTICKY. */

/*! @brief Read current value of the USBPHY_CTRL_RESUMEIRQSTICKY field. */
#define BR_USBPHY_CTRL_RESUMEIRQSTICKY(x) (HW_USBPHY_CTRL(x).B.RESUMEIRQSTICKY)

/*! @brief Format value for bitfield USBPHY_CTRL_RESUMEIRQSTICKY. */
#define BF_USBPHY_CTRL_RESUMEIRQSTICKY(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_RESUMEIRQSTICKY) & BM_USBPHY_CTRL_RESUMEIRQSTICKY)

/*! @brief Set the RESUMEIRQSTICKY field to a new value. */
#define BW_USBPHY_CTRL_RESUMEIRQSTICKY(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_RESUMEIRQSTICKY) | BF_USBPHY_CTRL_RESUMEIRQSTICKY(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENIRQRESUMEDETECT[9] (RW)
 *
 * Enables interrupt for detection of a non-J state on the USB line. This should
 * only be enabled after the device has entered suspend mode.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENIRQRESUMEDETECT (9U) /*!< Bit position for USBPHY_CTRL_ENIRQRESUMEDETECT. */
#define BM_USBPHY_CTRL_ENIRQRESUMEDETECT (0x00000200U) /*!< Bit mask for USBPHY_CTRL_ENIRQRESUMEDETECT. */
#define BS_USBPHY_CTRL_ENIRQRESUMEDETECT (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENIRQRESUMEDETECT. */

/*! @brief Read current value of the USBPHY_CTRL_ENIRQRESUMEDETECT field. */
#define BR_USBPHY_CTRL_ENIRQRESUMEDETECT(x) (HW_USBPHY_CTRL(x).B.ENIRQRESUMEDETECT)

/*! @brief Format value for bitfield USBPHY_CTRL_ENIRQRESUMEDETECT. */
#define BF_USBPHY_CTRL_ENIRQRESUMEDETECT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENIRQRESUMEDETECT) & BM_USBPHY_CTRL_ENIRQRESUMEDETECT)

/*! @brief Set the ENIRQRESUMEDETECT field to a new value. */
#define BW_USBPHY_CTRL_ENIRQRESUMEDETECT(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENIRQRESUMEDETECT) | BF_USBPHY_CTRL_ENIRQRESUMEDETECT(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field RESUME_IRQ[10] (RW)
 *
 * Indicates that the host is sending a wake-up after suspend. This bit is also
 * set on a reset during suspend. Use this bit to wake up from suspend for either
 * the resume or the reset case. Reset this bit by writing a 1 to the clear
 * address space and not by a general write.
 */
/*@{*/
#define BP_USBPHY_CTRL_RESUME_IRQ (10U)    /*!< Bit position for USBPHY_CTRL_RESUME_IRQ. */
#define BM_USBPHY_CTRL_RESUME_IRQ (0x00000400U) /*!< Bit mask for USBPHY_CTRL_RESUME_IRQ. */
#define BS_USBPHY_CTRL_RESUME_IRQ (1U)     /*!< Bit field size in bits for USBPHY_CTRL_RESUME_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_RESUME_IRQ field. */
#define BR_USBPHY_CTRL_RESUME_IRQ(x) (HW_USBPHY_CTRL(x).B.RESUME_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_RESUME_IRQ. */
#define BF_USBPHY_CTRL_RESUME_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_RESUME_IRQ) & BM_USBPHY_CTRL_RESUME_IRQ)

/*! @brief Set the RESUME_IRQ field to a new value. */
#define BW_USBPHY_CTRL_RESUME_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_RESUME_IRQ) | BF_USBPHY_CTRL_RESUME_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENIRQDEVPLUGIN[11] (RW)
 *
 * Enables interrupt for the detection of connectivity to the USB line.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENIRQDEVPLUGIN (11U) /*!< Bit position for USBPHY_CTRL_ENIRQDEVPLUGIN. */
#define BM_USBPHY_CTRL_ENIRQDEVPLUGIN (0x00000800U) /*!< Bit mask for USBPHY_CTRL_ENIRQDEVPLUGIN. */
#define BS_USBPHY_CTRL_ENIRQDEVPLUGIN (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENIRQDEVPLUGIN. */

/*! @brief Read current value of the USBPHY_CTRL_ENIRQDEVPLUGIN field. */
#define BR_USBPHY_CTRL_ENIRQDEVPLUGIN(x) (HW_USBPHY_CTRL(x).B.ENIRQDEVPLUGIN)

/*! @brief Format value for bitfield USBPHY_CTRL_ENIRQDEVPLUGIN. */
#define BF_USBPHY_CTRL_ENIRQDEVPLUGIN(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENIRQDEVPLUGIN) & BM_USBPHY_CTRL_ENIRQDEVPLUGIN)

/*! @brief Set the ENIRQDEVPLUGIN field to a new value. */
#define BW_USBPHY_CTRL_ENIRQDEVPLUGIN(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENIRQDEVPLUGIN) | BF_USBPHY_CTRL_ENIRQDEVPLUGIN(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field DEVPLUGIN_IRQ[12] (RW)
 *
 * Indicates that the device is connected. Reset this bit by writing a 1 to the
 * clear address space and not by a general write.
 */
/*@{*/
#define BP_USBPHY_CTRL_DEVPLUGIN_IRQ (12U) /*!< Bit position for USBPHY_CTRL_DEVPLUGIN_IRQ. */
#define BM_USBPHY_CTRL_DEVPLUGIN_IRQ (0x00001000U) /*!< Bit mask for USBPHY_CTRL_DEVPLUGIN_IRQ. */
#define BS_USBPHY_CTRL_DEVPLUGIN_IRQ (1U)  /*!< Bit field size in bits for USBPHY_CTRL_DEVPLUGIN_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_DEVPLUGIN_IRQ field. */
#define BR_USBPHY_CTRL_DEVPLUGIN_IRQ(x) (HW_USBPHY_CTRL(x).B.DEVPLUGIN_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_DEVPLUGIN_IRQ. */
#define BF_USBPHY_CTRL_DEVPLUGIN_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_DEVPLUGIN_IRQ) & BM_USBPHY_CTRL_DEVPLUGIN_IRQ)

/*! @brief Set the DEVPLUGIN_IRQ field to a new value. */
#define BW_USBPHY_CTRL_DEVPLUGIN_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_DEVPLUGIN_IRQ) | BF_USBPHY_CTRL_DEVPLUGIN_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field DATA_ON_LRADC[13] (RW)
 *
 * Enables the LRADC to monitor USB_DP and USB_DM. This is for use in non-USB
 * modes only.
 */
/*@{*/
#define BP_USBPHY_CTRL_DATA_ON_LRADC (13U) /*!< Bit position for USBPHY_CTRL_DATA_ON_LRADC. */
#define BM_USBPHY_CTRL_DATA_ON_LRADC (0x00002000U) /*!< Bit mask for USBPHY_CTRL_DATA_ON_LRADC. */
#define BS_USBPHY_CTRL_DATA_ON_LRADC (1U)  /*!< Bit field size in bits for USBPHY_CTRL_DATA_ON_LRADC. */

/*! @brief Read current value of the USBPHY_CTRL_DATA_ON_LRADC field. */
#define BR_USBPHY_CTRL_DATA_ON_LRADC(x) (HW_USBPHY_CTRL(x).B.DATA_ON_LRADC)

/*! @brief Format value for bitfield USBPHY_CTRL_DATA_ON_LRADC. */
#define BF_USBPHY_CTRL_DATA_ON_LRADC(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_DATA_ON_LRADC) & BM_USBPHY_CTRL_DATA_ON_LRADC)

/*! @brief Set the DATA_ON_LRADC field to a new value. */
#define BW_USBPHY_CTRL_DATA_ON_LRADC(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_DATA_ON_LRADC) | BF_USBPHY_CTRL_DATA_ON_LRADC(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENUTMILEVEL2[14] (RW)
 *
 * Enables UTMI+ Level2. This should be enabled if needs to support LS device
 */
/*@{*/
#define BP_USBPHY_CTRL_ENUTMILEVEL2 (14U)  /*!< Bit position for USBPHY_CTRL_ENUTMILEVEL2. */
#define BM_USBPHY_CTRL_ENUTMILEVEL2 (0x00004000U) /*!< Bit mask for USBPHY_CTRL_ENUTMILEVEL2. */
#define BS_USBPHY_CTRL_ENUTMILEVEL2 (1U)   /*!< Bit field size in bits for USBPHY_CTRL_ENUTMILEVEL2. */

/*! @brief Read current value of the USBPHY_CTRL_ENUTMILEVEL2 field. */
#define BR_USBPHY_CTRL_ENUTMILEVEL2(x) (HW_USBPHY_CTRL(x).B.ENUTMILEVEL2)

/*! @brief Format value for bitfield USBPHY_CTRL_ENUTMILEVEL2. */
#define BF_USBPHY_CTRL_ENUTMILEVEL2(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENUTMILEVEL2) & BM_USBPHY_CTRL_ENUTMILEVEL2)

/*! @brief Set the ENUTMILEVEL2 field to a new value. */
#define BW_USBPHY_CTRL_ENUTMILEVEL2(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENUTMILEVEL2) | BF_USBPHY_CTRL_ENUTMILEVEL2(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENUTMILEVEL3[15] (RW)
 *
 * Enables UTMI+ Level3. This should be enabled if needs to support external FS
 * Hub with LS device connected
 */
/*@{*/
#define BP_USBPHY_CTRL_ENUTMILEVEL3 (15U)  /*!< Bit position for USBPHY_CTRL_ENUTMILEVEL3. */
#define BM_USBPHY_CTRL_ENUTMILEVEL3 (0x00008000U) /*!< Bit mask for USBPHY_CTRL_ENUTMILEVEL3. */
#define BS_USBPHY_CTRL_ENUTMILEVEL3 (1U)   /*!< Bit field size in bits for USBPHY_CTRL_ENUTMILEVEL3. */

/*! @brief Read current value of the USBPHY_CTRL_ENUTMILEVEL3 field. */
#define BR_USBPHY_CTRL_ENUTMILEVEL3(x) (HW_USBPHY_CTRL(x).B.ENUTMILEVEL3)

/*! @brief Format value for bitfield USBPHY_CTRL_ENUTMILEVEL3. */
#define BF_USBPHY_CTRL_ENUTMILEVEL3(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENUTMILEVEL3) & BM_USBPHY_CTRL_ENUTMILEVEL3)

/*! @brief Set the ENUTMILEVEL3 field to a new value. */
#define BW_USBPHY_CTRL_ENUTMILEVEL3(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENUTMILEVEL3) | BF_USBPHY_CTRL_ENUTMILEVEL3(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENIRQWAKEUP[16] (RW)
 *
 * Enables interrupt for the wakeup events.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENIRQWAKEUP (16U)   /*!< Bit position for USBPHY_CTRL_ENIRQWAKEUP. */
#define BM_USBPHY_CTRL_ENIRQWAKEUP (0x00010000U) /*!< Bit mask for USBPHY_CTRL_ENIRQWAKEUP. */
#define BS_USBPHY_CTRL_ENIRQWAKEUP (1U)    /*!< Bit field size in bits for USBPHY_CTRL_ENIRQWAKEUP. */

/*! @brief Read current value of the USBPHY_CTRL_ENIRQWAKEUP field. */
#define BR_USBPHY_CTRL_ENIRQWAKEUP(x) (HW_USBPHY_CTRL(x).B.ENIRQWAKEUP)

/*! @brief Format value for bitfield USBPHY_CTRL_ENIRQWAKEUP. */
#define BF_USBPHY_CTRL_ENIRQWAKEUP(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENIRQWAKEUP) & BM_USBPHY_CTRL_ENIRQWAKEUP)

/*! @brief Set the ENIRQWAKEUP field to a new value. */
#define BW_USBPHY_CTRL_ENIRQWAKEUP(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENIRQWAKEUP) | BF_USBPHY_CTRL_ENIRQWAKEUP(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field WAKEUP_IRQ[17] (RW)
 *
 * Indicates that there is a wakeup event. Reset this bit by writing a 1 to the
 * clear address space and not by a general write.
 */
/*@{*/
#define BP_USBPHY_CTRL_WAKEUP_IRQ (17U)    /*!< Bit position for USBPHY_CTRL_WAKEUP_IRQ. */
#define BM_USBPHY_CTRL_WAKEUP_IRQ (0x00020000U) /*!< Bit mask for USBPHY_CTRL_WAKEUP_IRQ. */
#define BS_USBPHY_CTRL_WAKEUP_IRQ (1U)     /*!< Bit field size in bits for USBPHY_CTRL_WAKEUP_IRQ. */

/*! @brief Read current value of the USBPHY_CTRL_WAKEUP_IRQ field. */
#define BR_USBPHY_CTRL_WAKEUP_IRQ(x) (HW_USBPHY_CTRL(x).B.WAKEUP_IRQ)

/*! @brief Format value for bitfield USBPHY_CTRL_WAKEUP_IRQ. */
#define BF_USBPHY_CTRL_WAKEUP_IRQ(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_WAKEUP_IRQ) & BM_USBPHY_CTRL_WAKEUP_IRQ)

/*! @brief Set the WAKEUP_IRQ field to a new value. */
#define BW_USBPHY_CTRL_WAKEUP_IRQ(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_WAKEUP_IRQ) | BF_USBPHY_CTRL_WAKEUP_IRQ(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field RSVD0[18] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_CTRL_RSVD0 (18U)         /*!< Bit position for USBPHY_CTRL_RSVD0. */
#define BM_USBPHY_CTRL_RSVD0 (0x00040000U) /*!< Bit mask for USBPHY_CTRL_RSVD0. */
#define BS_USBPHY_CTRL_RSVD0 (1U)          /*!< Bit field size in bits for USBPHY_CTRL_RSVD0. */

/*! @brief Read current value of the USBPHY_CTRL_RSVD0 field. */
#define BR_USBPHY_CTRL_RSVD0(x) (HW_USBPHY_CTRL(x).B.RSVD0)
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENAUTOCLR_CLKGATE[19] (RW)
 *
 * Enables the feature to auto-clear the CLKGATE bit if there is wakeup event
 * while USB is suspended. This should be enabled if needs to support auto wakeup
 * without S/W's interaction.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENAUTOCLR_CLKGATE (19U) /*!< Bit position for USBPHY_CTRL_ENAUTOCLR_CLKGATE. */
#define BM_USBPHY_CTRL_ENAUTOCLR_CLKGATE (0x00080000U) /*!< Bit mask for USBPHY_CTRL_ENAUTOCLR_CLKGATE. */
#define BS_USBPHY_CTRL_ENAUTOCLR_CLKGATE (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENAUTOCLR_CLKGATE. */

/*! @brief Read current value of the USBPHY_CTRL_ENAUTOCLR_CLKGATE field. */
#define BR_USBPHY_CTRL_ENAUTOCLR_CLKGATE(x) (HW_USBPHY_CTRL(x).B.ENAUTOCLR_CLKGATE)

/*! @brief Format value for bitfield USBPHY_CTRL_ENAUTOCLR_CLKGATE. */
#define BF_USBPHY_CTRL_ENAUTOCLR_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENAUTOCLR_CLKGATE) & BM_USBPHY_CTRL_ENAUTOCLR_CLKGATE)

/*! @brief Set the ENAUTOCLR_CLKGATE field to a new value. */
#define BW_USBPHY_CTRL_ENAUTOCLR_CLKGATE(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENAUTOCLR_CLKGATE) | BF_USBPHY_CTRL_ENAUTOCLR_CLKGATE(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENAUTOCLR_PHY_PWD[20] (RW)
 *
 * Enables the feature to auto-clear the PWD register bits in USBPHYx_PWD if
 * there is wakeup event while USB is suspended. This should be enabled if needs to
 * support auto wakeup without S/W's interaction.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENAUTOCLR_PHY_PWD (20U) /*!< Bit position for USBPHY_CTRL_ENAUTOCLR_PHY_PWD. */
#define BM_USBPHY_CTRL_ENAUTOCLR_PHY_PWD (0x00100000U) /*!< Bit mask for USBPHY_CTRL_ENAUTOCLR_PHY_PWD. */
#define BS_USBPHY_CTRL_ENAUTOCLR_PHY_PWD (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENAUTOCLR_PHY_PWD. */

/*! @brief Read current value of the USBPHY_CTRL_ENAUTOCLR_PHY_PWD field. */
#define BR_USBPHY_CTRL_ENAUTOCLR_PHY_PWD(x) (HW_USBPHY_CTRL(x).B.ENAUTOCLR_PHY_PWD)

/*! @brief Format value for bitfield USBPHY_CTRL_ENAUTOCLR_PHY_PWD. */
#define BF_USBPHY_CTRL_ENAUTOCLR_PHY_PWD(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENAUTOCLR_PHY_PWD) & BM_USBPHY_CTRL_ENAUTOCLR_PHY_PWD)

/*! @brief Set the ENAUTOCLR_PHY_PWD field to a new value. */
#define BW_USBPHY_CTRL_ENAUTOCLR_PHY_PWD(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENAUTOCLR_PHY_PWD) | BF_USBPHY_CTRL_ENAUTOCLR_PHY_PWD(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENDPDMCHG_WKUP[21] (RW)
 *
 * Enables the feature to wakeup USB if DP/DM is toggled when USB is suspended.
 * This bit is enabled by default.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENDPDMCHG_WKUP (21U) /*!< Bit position for USBPHY_CTRL_ENDPDMCHG_WKUP. */
#define BM_USBPHY_CTRL_ENDPDMCHG_WKUP (0x00200000U) /*!< Bit mask for USBPHY_CTRL_ENDPDMCHG_WKUP. */
#define BS_USBPHY_CTRL_ENDPDMCHG_WKUP (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENDPDMCHG_WKUP. */

/*! @brief Read current value of the USBPHY_CTRL_ENDPDMCHG_WKUP field. */
#define BR_USBPHY_CTRL_ENDPDMCHG_WKUP(x) (HW_USBPHY_CTRL(x).B.ENDPDMCHG_WKUP)

/*! @brief Format value for bitfield USBPHY_CTRL_ENDPDMCHG_WKUP. */
#define BF_USBPHY_CTRL_ENDPDMCHG_WKUP(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENDPDMCHG_WKUP) & BM_USBPHY_CTRL_ENDPDMCHG_WKUP)

/*! @brief Set the ENDPDMCHG_WKUP field to a new value. */
#define BW_USBPHY_CTRL_ENDPDMCHG_WKUP(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENDPDMCHG_WKUP) | BF_USBPHY_CTRL_ENDPDMCHG_WKUP(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENIDCHG_WKUP[22] (RW)
 *
 * Enables the feature to wakeup USB if ID is toggled when USB is suspended.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENIDCHG_WKUP (22U)  /*!< Bit position for USBPHY_CTRL_ENIDCHG_WKUP. */
#define BM_USBPHY_CTRL_ENIDCHG_WKUP (0x00400000U) /*!< Bit mask for USBPHY_CTRL_ENIDCHG_WKUP. */
#define BS_USBPHY_CTRL_ENIDCHG_WKUP (1U)   /*!< Bit field size in bits for USBPHY_CTRL_ENIDCHG_WKUP. */

/*! @brief Read current value of the USBPHY_CTRL_ENIDCHG_WKUP field. */
#define BR_USBPHY_CTRL_ENIDCHG_WKUP(x) (HW_USBPHY_CTRL(x).B.ENIDCHG_WKUP)

/*! @brief Format value for bitfield USBPHY_CTRL_ENIDCHG_WKUP. */
#define BF_USBPHY_CTRL_ENIDCHG_WKUP(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENIDCHG_WKUP) & BM_USBPHY_CTRL_ENIDCHG_WKUP)

/*! @brief Set the ENIDCHG_WKUP field to a new value. */
#define BW_USBPHY_CTRL_ENIDCHG_WKUP(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENIDCHG_WKUP) | BF_USBPHY_CTRL_ENIDCHG_WKUP(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field ENVBUSCHG_WKUP[23] (RW)
 *
 * Enables the feature to wakeup USB if VBUS is toggled when USB is suspended.
 */
/*@{*/
#define BP_USBPHY_CTRL_ENVBUSCHG_WKUP (23U) /*!< Bit position for USBPHY_CTRL_ENVBUSCHG_WKUP. */
#define BM_USBPHY_CTRL_ENVBUSCHG_WKUP (0x00800000U) /*!< Bit mask for USBPHY_CTRL_ENVBUSCHG_WKUP. */
#define BS_USBPHY_CTRL_ENVBUSCHG_WKUP (1U) /*!< Bit field size in bits for USBPHY_CTRL_ENVBUSCHG_WKUP. */

/*! @brief Read current value of the USBPHY_CTRL_ENVBUSCHG_WKUP field. */
#define BR_USBPHY_CTRL_ENVBUSCHG_WKUP(x) (HW_USBPHY_CTRL(x).B.ENVBUSCHG_WKUP)

/*! @brief Format value for bitfield USBPHY_CTRL_ENVBUSCHG_WKUP. */
#define BF_USBPHY_CTRL_ENVBUSCHG_WKUP(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_ENVBUSCHG_WKUP) & BM_USBPHY_CTRL_ENVBUSCHG_WKUP)

/*! @brief Set the ENVBUSCHG_WKUP field to a new value. */
#define BW_USBPHY_CTRL_ENVBUSCHG_WKUP(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_ENVBUSCHG_WKUP) | BF_USBPHY_CTRL_ENVBUSCHG_WKUP(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field FSDLL_RST_EN[24] (RW)
 *
 * Enables the feature to reset the FSDLL lock detection logic at the end of
 * each TX packet.
 */
/*@{*/
#define BP_USBPHY_CTRL_FSDLL_RST_EN (24U)  /*!< Bit position for USBPHY_CTRL_FSDLL_RST_EN. */
#define BM_USBPHY_CTRL_FSDLL_RST_EN (0x01000000U) /*!< Bit mask for USBPHY_CTRL_FSDLL_RST_EN. */
#define BS_USBPHY_CTRL_FSDLL_RST_EN (1U)   /*!< Bit field size in bits for USBPHY_CTRL_FSDLL_RST_EN. */

/*! @brief Read current value of the USBPHY_CTRL_FSDLL_RST_EN field. */
#define BR_USBPHY_CTRL_FSDLL_RST_EN(x) (HW_USBPHY_CTRL(x).B.FSDLL_RST_EN)

/*! @brief Format value for bitfield USBPHY_CTRL_FSDLL_RST_EN. */
#define BF_USBPHY_CTRL_FSDLL_RST_EN(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_FSDLL_RST_EN) & BM_USBPHY_CTRL_FSDLL_RST_EN)

/*! @brief Set the FSDLL_RST_EN field to a new value. */
#define BW_USBPHY_CTRL_FSDLL_RST_EN(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_FSDLL_RST_EN) | BF_USBPHY_CTRL_FSDLL_RST_EN(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field RSVD1[26:25] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_CTRL_RSVD1 (25U)         /*!< Bit position for USBPHY_CTRL_RSVD1. */
#define BM_USBPHY_CTRL_RSVD1 (0x06000000U) /*!< Bit mask for USBPHY_CTRL_RSVD1. */
#define BS_USBPHY_CTRL_RSVD1 (2U)          /*!< Bit field size in bits for USBPHY_CTRL_RSVD1. */

/*! @brief Read current value of the USBPHY_CTRL_RSVD1 field. */
#define BR_USBPHY_CTRL_RSVD1(x) (HW_USBPHY_CTRL(x).B.RSVD1)
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field OTG_ID_VALUE[27] (RO)
 *
 * Almost same as OTGID_STATUS in USBPHYx_STATUS Register. The only difference
 * is that OTG_ID_VALUE has debounce logic to filter the glitches on ID Pad.
 */
/*@{*/
#define BP_USBPHY_CTRL_OTG_ID_VALUE (27U)  /*!< Bit position for USBPHY_CTRL_OTG_ID_VALUE. */
#define BM_USBPHY_CTRL_OTG_ID_VALUE (0x08000000U) /*!< Bit mask for USBPHY_CTRL_OTG_ID_VALUE. */
#define BS_USBPHY_CTRL_OTG_ID_VALUE (1U)   /*!< Bit field size in bits for USBPHY_CTRL_OTG_ID_VALUE. */

/*! @brief Read current value of the USBPHY_CTRL_OTG_ID_VALUE field. */
#define BR_USBPHY_CTRL_OTG_ID_VALUE(x) (HW_USBPHY_CTRL(x).B.OTG_ID_VALUE)
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field HOST_FORCE_LS_SE0[28] (RW)
 *
 * Forces the next FS packet that is transmitted to have a EOP with LS timing.
 * This bit is used in host mode for the resume sequence. After the packet is
 * transferred, this bit is cleared. The design can use this function to force the LS
 * SE0 or use the USBPHYx_CTRL_UTMI_SUSPENDM to trigger this event when leaving
 * suspend. This bit is used in conjunction with USBPHYx_DEBUG_HOST_RESUME_DEBUG.
 */
/*@{*/
#define BP_USBPHY_CTRL_HOST_FORCE_LS_SE0 (28U) /*!< Bit position for USBPHY_CTRL_HOST_FORCE_LS_SE0. */
#define BM_USBPHY_CTRL_HOST_FORCE_LS_SE0 (0x10000000U) /*!< Bit mask for USBPHY_CTRL_HOST_FORCE_LS_SE0. */
#define BS_USBPHY_CTRL_HOST_FORCE_LS_SE0 (1U) /*!< Bit field size in bits for USBPHY_CTRL_HOST_FORCE_LS_SE0. */

/*! @brief Read current value of the USBPHY_CTRL_HOST_FORCE_LS_SE0 field. */
#define BR_USBPHY_CTRL_HOST_FORCE_LS_SE0(x) (HW_USBPHY_CTRL(x).B.HOST_FORCE_LS_SE0)

/*! @brief Format value for bitfield USBPHY_CTRL_HOST_FORCE_LS_SE0. */
#define BF_USBPHY_CTRL_HOST_FORCE_LS_SE0(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_HOST_FORCE_LS_SE0) & BM_USBPHY_CTRL_HOST_FORCE_LS_SE0)

/*! @brief Set the HOST_FORCE_LS_SE0 field to a new value. */
#define BW_USBPHY_CTRL_HOST_FORCE_LS_SE0(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_HOST_FORCE_LS_SE0) | BF_USBPHY_CTRL_HOST_FORCE_LS_SE0(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field UTMI_SUSPENDM[29] (RO)
 *
 * Used by the PHY to indicate a powered-down state. If all the power-down bits
 * in the USBPHYx_PWD are enabled, UTMI_SUSPENDM will be 0, otherwise 1.
 * UTMI_SUSPENDM is negative logic, as required by the UTMI specification.
 */
/*@{*/
#define BP_USBPHY_CTRL_UTMI_SUSPENDM (29U) /*!< Bit position for USBPHY_CTRL_UTMI_SUSPENDM. */
#define BM_USBPHY_CTRL_UTMI_SUSPENDM (0x20000000U) /*!< Bit mask for USBPHY_CTRL_UTMI_SUSPENDM. */
#define BS_USBPHY_CTRL_UTMI_SUSPENDM (1U)  /*!< Bit field size in bits for USBPHY_CTRL_UTMI_SUSPENDM. */

/*! @brief Read current value of the USBPHY_CTRL_UTMI_SUSPENDM field. */
#define BR_USBPHY_CTRL_UTMI_SUSPENDM(x) (HW_USBPHY_CTRL(x).B.UTMI_SUSPENDM)
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field CLKGATE[30] (RW)
 *
 * Gate UTMI Clocks. Clear to 0 to run clocks. Set to 1 to gate clocks. Set this
 * to save power while the USB is not actively being used. Configuration state
 * is kept while the clock is gated. Note this bit can be auto-cleared if there is
 * any wakeup event when USB is suspended while ENAUTOCLR_CLKGATE bit of
 * USBPHYx_CTRL is enabled.
 */
/*@{*/
#define BP_USBPHY_CTRL_CLKGATE (30U)       /*!< Bit position for USBPHY_CTRL_CLKGATE. */
#define BM_USBPHY_CTRL_CLKGATE (0x40000000U) /*!< Bit mask for USBPHY_CTRL_CLKGATE. */
#define BS_USBPHY_CTRL_CLKGATE (1U)        /*!< Bit field size in bits for USBPHY_CTRL_CLKGATE. */

/*! @brief Read current value of the USBPHY_CTRL_CLKGATE field. */
#define BR_USBPHY_CTRL_CLKGATE(x) (HW_USBPHY_CTRL(x).B.CLKGATE)

/*! @brief Format value for bitfield USBPHY_CTRL_CLKGATE. */
#define BF_USBPHY_CTRL_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_CLKGATE) & BM_USBPHY_CTRL_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_USBPHY_CTRL_CLKGATE(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_CLKGATE) | BF_USBPHY_CTRL_CLKGATE(v)))
/*@}*/

/*!
 * @name Register USBPHY_CTRL, field SFTRST[31] (RW)
 *
 * Writing a 1 to this bit will soft-reset the USBPHYx_PWD, USBPHYx_TX,
 * USBPHYx_RX, and USBPHYx_CTRL registers. Set to 0 to release the PHY from reset.
 */
/*@{*/
#define BP_USBPHY_CTRL_SFTRST (31U)        /*!< Bit position for USBPHY_CTRL_SFTRST. */
#define BM_USBPHY_CTRL_SFTRST (0x80000000U) /*!< Bit mask for USBPHY_CTRL_SFTRST. */
#define BS_USBPHY_CTRL_SFTRST (1U)         /*!< Bit field size in bits for USBPHY_CTRL_SFTRST. */

/*! @brief Read current value of the USBPHY_CTRL_SFTRST field. */
#define BR_USBPHY_CTRL_SFTRST(x) (HW_USBPHY_CTRL(x).B.SFTRST)

/*! @brief Format value for bitfield USBPHY_CTRL_SFTRST. */
#define BF_USBPHY_CTRL_SFTRST(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_CTRL_SFTRST) & BM_USBPHY_CTRL_SFTRST)

/*! @brief Set the SFTRST field to a new value. */
#define BW_USBPHY_CTRL_SFTRST(x, v) (HW_USBPHY_CTRL_WR(x, (HW_USBPHY_CTRL_RD(x) & ~BM_USBPHY_CTRL_SFTRST) | BF_USBPHY_CTRL_SFTRST(v)))
/*@}*/




/*******************************************************************************
 * HW_USBPHY_STATUS - USB PHY Status Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_STATUS - USB PHY Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The USB PHY Status Register holds results of IRQ and other detects.
 */
typedef union _hw_usbphy_status
{
    uint32_t U;
    struct _hw_usbphy_status_bitfields
    {
        uint32_t RSVD0 : 3;            /*!< [2:0]  */
        uint32_t HOSTDISCONDETECT_STATUS : 1; /*!< [3]  */
        uint32_t RSVD1 : 2;            /*!< [5:4]  */
        uint32_t DEVPLUGIN_STATUS : 1; /*!< [6]  */
        uint32_t RSVD2 : 1;            /*!< [7]  */
        uint32_t OTGID_STATUS : 1;     /*!< [8]  */
        uint32_t RSVD3 : 1;            /*!< [9]  */
        uint32_t RESUME_STATUS : 1;    /*!< [10]  */
        uint32_t RSVD4 : 21;           /*!< [31:11]  */
    } B;
} hw_usbphy_status_t;

/*!
 * @name Constants and macros for entire USBPHY_STATUS register
 */
/*@{*/
#define HW_USBPHY_STATUS_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_USBPHY_STATUS(x)      (*(__IO hw_usbphy_status_t *) HW_USBPHY_STATUS_ADDR(x))
#define HW_USBPHY_STATUS_RD(x)   (HW_USBPHY_STATUS(x).U)
#define HW_USBPHY_STATUS_WR(x, v) (HW_USBPHY_STATUS(x).U = (v))
#define HW_USBPHY_STATUS_SET(x, v) (HW_USBPHY_STATUS_WR(x, HW_USBPHY_STATUS_RD(x) |  (v)))
#define HW_USBPHY_STATUS_CLR(x, v) (HW_USBPHY_STATUS_WR(x, HW_USBPHY_STATUS_RD(x) & ~(v)))
#define HW_USBPHY_STATUS_TOG(x, v) (HW_USBPHY_STATUS_WR(x, HW_USBPHY_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual USBPHY_STATUS bitfields
 */

/*!
 * @name Register USBPHY_STATUS, field RSVD0[2:0] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_STATUS_RSVD0 (0U)        /*!< Bit position for USBPHY_STATUS_RSVD0. */
#define BM_USBPHY_STATUS_RSVD0 (0x00000007U) /*!< Bit mask for USBPHY_STATUS_RSVD0. */
#define BS_USBPHY_STATUS_RSVD0 (3U)        /*!< Bit field size in bits for USBPHY_STATUS_RSVD0. */

/*! @brief Read current value of the USBPHY_STATUS_RSVD0 field. */
#define BR_USBPHY_STATUS_RSVD0(x) (HW_USBPHY_STATUS(x).B.RSVD0)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field HOSTDISCONDETECT_STATUS[3] (RO)
 *
 * Indicates that the device has disconnected while in high-speed host mode.
 */
/*@{*/
#define BP_USBPHY_STATUS_HOSTDISCONDETECT_STATUS (3U) /*!< Bit position for USBPHY_STATUS_HOSTDISCONDETECT_STATUS. */
#define BM_USBPHY_STATUS_HOSTDISCONDETECT_STATUS (0x00000008U) /*!< Bit mask for USBPHY_STATUS_HOSTDISCONDETECT_STATUS. */
#define BS_USBPHY_STATUS_HOSTDISCONDETECT_STATUS (1U) /*!< Bit field size in bits for USBPHY_STATUS_HOSTDISCONDETECT_STATUS. */

/*! @brief Read current value of the USBPHY_STATUS_HOSTDISCONDETECT_STATUS field. */
#define BR_USBPHY_STATUS_HOSTDISCONDETECT_STATUS(x) (HW_USBPHY_STATUS(x).B.HOSTDISCONDETECT_STATUS)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field RSVD1[5:4] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_STATUS_RSVD1 (4U)        /*!< Bit position for USBPHY_STATUS_RSVD1. */
#define BM_USBPHY_STATUS_RSVD1 (0x00000030U) /*!< Bit mask for USBPHY_STATUS_RSVD1. */
#define BS_USBPHY_STATUS_RSVD1 (2U)        /*!< Bit field size in bits for USBPHY_STATUS_RSVD1. */

/*! @brief Read current value of the USBPHY_STATUS_RSVD1 field. */
#define BR_USBPHY_STATUS_RSVD1(x) (HW_USBPHY_STATUS(x).B.RSVD1)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field DEVPLUGIN_STATUS[6] (RO)
 *
 * Indicates that the device has been connected on the USB_DP and USB_DM lines.
 */
/*@{*/
#define BP_USBPHY_STATUS_DEVPLUGIN_STATUS (6U) /*!< Bit position for USBPHY_STATUS_DEVPLUGIN_STATUS. */
#define BM_USBPHY_STATUS_DEVPLUGIN_STATUS (0x00000040U) /*!< Bit mask for USBPHY_STATUS_DEVPLUGIN_STATUS. */
#define BS_USBPHY_STATUS_DEVPLUGIN_STATUS (1U) /*!< Bit field size in bits for USBPHY_STATUS_DEVPLUGIN_STATUS. */

/*! @brief Read current value of the USBPHY_STATUS_DEVPLUGIN_STATUS field. */
#define BR_USBPHY_STATUS_DEVPLUGIN_STATUS(x) (HW_USBPHY_STATUS(x).B.DEVPLUGIN_STATUS)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field RSVD2[7] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_STATUS_RSVD2 (7U)        /*!< Bit position for USBPHY_STATUS_RSVD2. */
#define BM_USBPHY_STATUS_RSVD2 (0x00000080U) /*!< Bit mask for USBPHY_STATUS_RSVD2. */
#define BS_USBPHY_STATUS_RSVD2 (1U)        /*!< Bit field size in bits for USBPHY_STATUS_RSVD2. */

/*! @brief Read current value of the USBPHY_STATUS_RSVD2 field. */
#define BR_USBPHY_STATUS_RSVD2(x) (HW_USBPHY_STATUS(x).B.RSVD2)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field OTGID_STATUS[8] (RW)
 *
 * Indicates the results of ID pin on MiniAB plug. False (0) is when ID
 * resistance is less than Ra_Plug_ID, indicating host (A) side. True (1) is when ID
 * resistance is greater than Rb_Plug_ID, indicating device (B) side.
 */
/*@{*/
#define BP_USBPHY_STATUS_OTGID_STATUS (8U) /*!< Bit position for USBPHY_STATUS_OTGID_STATUS. */
#define BM_USBPHY_STATUS_OTGID_STATUS (0x00000100U) /*!< Bit mask for USBPHY_STATUS_OTGID_STATUS. */
#define BS_USBPHY_STATUS_OTGID_STATUS (1U) /*!< Bit field size in bits for USBPHY_STATUS_OTGID_STATUS. */

/*! @brief Read current value of the USBPHY_STATUS_OTGID_STATUS field. */
#define BR_USBPHY_STATUS_OTGID_STATUS(x) (HW_USBPHY_STATUS(x).B.OTGID_STATUS)

/*! @brief Format value for bitfield USBPHY_STATUS_OTGID_STATUS. */
#define BF_USBPHY_STATUS_OTGID_STATUS(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_STATUS_OTGID_STATUS) & BM_USBPHY_STATUS_OTGID_STATUS)

/*! @brief Set the OTGID_STATUS field to a new value. */
#define BW_USBPHY_STATUS_OTGID_STATUS(x, v) (HW_USBPHY_STATUS_WR(x, (HW_USBPHY_STATUS_RD(x) & ~BM_USBPHY_STATUS_OTGID_STATUS) | BF_USBPHY_STATUS_OTGID_STATUS(v)))
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field RSVD3[9] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_STATUS_RSVD3 (9U)        /*!< Bit position for USBPHY_STATUS_RSVD3. */
#define BM_USBPHY_STATUS_RSVD3 (0x00000200U) /*!< Bit mask for USBPHY_STATUS_RSVD3. */
#define BS_USBPHY_STATUS_RSVD3 (1U)        /*!< Bit field size in bits for USBPHY_STATUS_RSVD3. */

/*! @brief Read current value of the USBPHY_STATUS_RSVD3 field. */
#define BR_USBPHY_STATUS_RSVD3(x) (HW_USBPHY_STATUS(x).B.RSVD3)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field RESUME_STATUS[10] (RO)
 *
 * Indicates that the host is sending a wake-up after suspend and has triggered
 * an interrupt.
 */
/*@{*/
#define BP_USBPHY_STATUS_RESUME_STATUS (10U) /*!< Bit position for USBPHY_STATUS_RESUME_STATUS. */
#define BM_USBPHY_STATUS_RESUME_STATUS (0x00000400U) /*!< Bit mask for USBPHY_STATUS_RESUME_STATUS. */
#define BS_USBPHY_STATUS_RESUME_STATUS (1U) /*!< Bit field size in bits for USBPHY_STATUS_RESUME_STATUS. */

/*! @brief Read current value of the USBPHY_STATUS_RESUME_STATUS field. */
#define BR_USBPHY_STATUS_RESUME_STATUS(x) (HW_USBPHY_STATUS(x).B.RESUME_STATUS)
/*@}*/

/*!
 * @name Register USBPHY_STATUS, field RSVD4[31:11] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_STATUS_RSVD4 (11U)       /*!< Bit position for USBPHY_STATUS_RSVD4. */
#define BM_USBPHY_STATUS_RSVD4 (0xFFFFF800U) /*!< Bit mask for USBPHY_STATUS_RSVD4. */
#define BS_USBPHY_STATUS_RSVD4 (21U)       /*!< Bit field size in bits for USBPHY_STATUS_RSVD4. */

/*! @brief Read current value of the USBPHY_STATUS_RSVD4 field. */
#define BR_USBPHY_STATUS_RSVD4(x) (HW_USBPHY_STATUS(x).B.RSVD4)
/*@}*/

/*******************************************************************************
 * HW_USBPHY_DEBUG - USB PHY Debug Register
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_DEBUG - USB PHY Debug Register (RW)
 *
 * Reset value: 0x7F180000U
 *
 * This register is used to debug the USB PHY.
 */
typedef union _hw_usbphy_debug
{
    uint32_t U;
    struct _hw_usbphy_debug_bitfields
    {
        uint32_t OTGIDPIOLOCK : 1;     /*!< [0]  */
        uint32_t DEBUG_INTERFACE_HOLD : 1; /*!< [1]  */
        uint32_t HSTPULLDOWN : 2;      /*!< [3:2]  */
        uint32_t ENHSTPULLDOWN : 2;    /*!< [5:4]  */
        uint32_t RSVD0 : 2;            /*!< [7:6]  */
        uint32_t TX2RXCOUNT : 4;       /*!< [11:8]  */
        uint32_t ENTX2RXCOUNT : 1;     /*!< [12]  */
        uint32_t RSVD1 : 3;            /*!< [15:13]  */
        uint32_t SQUELCHRESETCOUNT : 5; /*!< [20:16]  */
        uint32_t RSVD2 : 3;            /*!< [23:21]  */
        uint32_t ENSQUELCHRESET : 1;   /*!< [24]  */
        uint32_t SQUELCHRESETLENGTH : 4; /*!< [28:25]  */
        uint32_t HOST_RESUME_DEBUG : 1; /*!< [29]  */
        uint32_t CLKGATE : 1;          /*!< [30]  */
        uint32_t RSVD3 : 1;            /*!< [31]  */
    } B;
} hw_usbphy_debug_t;

/*!
 * @name Constants and macros for entire USBPHY_DEBUG register
 */
/*@{*/
#define HW_USBPHY_DEBUG_ADDR(x)  ((uintptr_t)(x) + 0x50U)
#define HW_USBPHY_DEBUG_SET_ADDR(x) (HW_USBPHY_DEBUG_ADDR(x) + 0x4U)
#define HW_USBPHY_DEBUG_CLR_ADDR(x) (HW_USBPHY_DEBUG_ADDR(x) + 0x8U)
#define HW_USBPHY_DEBUG_TOG_ADDR(x) (HW_USBPHY_DEBUG_ADDR(x) + 0xCU)

#define HW_USBPHY_DEBUG(x)       (*(__IO hw_usbphy_debug_t *) HW_USBPHY_DEBUG_ADDR(x))
#define HW_USBPHY_DEBUG_RD(x)    (HW_USBPHY_DEBUG(x).U)
#define HW_USBPHY_DEBUG_WR(x, v) (HW_USBPHY_DEBUG(x).U = (v))
#define HW_USBPHY_DEBUG_SET(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG_SET_ADDR(x)) = (v))
#define HW_USBPHY_DEBUG_CLR(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG_CLR_ADDR(x)) = (v))
#define HW_USBPHY_DEBUG_TOG(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_DEBUG bitfields
 */

/*!
 * @name Register USBPHY_DEBUG, field OTGIDPIOLOCK[0] (RW)
 *
 * Once OTG ID from USBPHYx_STATUS_OTGID_STATUS, use this to hold the value.
 * This is to save power for the comparators that are used to determine the ID
 * status.
 */
/*@{*/
#define BP_USBPHY_DEBUG_OTGIDPIOLOCK (0U)  /*!< Bit position for USBPHY_DEBUG_OTGIDPIOLOCK. */
#define BM_USBPHY_DEBUG_OTGIDPIOLOCK (0x00000001U) /*!< Bit mask for USBPHY_DEBUG_OTGIDPIOLOCK. */
#define BS_USBPHY_DEBUG_OTGIDPIOLOCK (1U)  /*!< Bit field size in bits for USBPHY_DEBUG_OTGIDPIOLOCK. */

/*! @brief Read current value of the USBPHY_DEBUG_OTGIDPIOLOCK field. */
#define BR_USBPHY_DEBUG_OTGIDPIOLOCK(x) (HW_USBPHY_DEBUG(x).B.OTGIDPIOLOCK)

/*! @brief Format value for bitfield USBPHY_DEBUG_OTGIDPIOLOCK. */
#define BF_USBPHY_DEBUG_OTGIDPIOLOCK(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_OTGIDPIOLOCK) & BM_USBPHY_DEBUG_OTGIDPIOLOCK)

/*! @brief Set the OTGIDPIOLOCK field to a new value. */
#define BW_USBPHY_DEBUG_OTGIDPIOLOCK(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_OTGIDPIOLOCK) | BF_USBPHY_DEBUG_OTGIDPIOLOCK(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field DEBUG_INTERFACE_HOLD[1] (RW)
 *
 * Use holding registers to assist in timing for external UTMI interface.
 */
/*@{*/
#define BP_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD (1U) /*!< Bit position for USBPHY_DEBUG_DEBUG_INTERFACE_HOLD. */
#define BM_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD (0x00000002U) /*!< Bit mask for USBPHY_DEBUG_DEBUG_INTERFACE_HOLD. */
#define BS_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD (1U) /*!< Bit field size in bits for USBPHY_DEBUG_DEBUG_INTERFACE_HOLD. */

/*! @brief Read current value of the USBPHY_DEBUG_DEBUG_INTERFACE_HOLD field. */
#define BR_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD(x) (HW_USBPHY_DEBUG(x).B.DEBUG_INTERFACE_HOLD)

/*! @brief Format value for bitfield USBPHY_DEBUG_DEBUG_INTERFACE_HOLD. */
#define BF_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD) & BM_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD)

/*! @brief Set the DEBUG_INTERFACE_HOLD field to a new value. */
#define BW_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD) | BF_USBPHY_DEBUG_DEBUG_INTERFACE_HOLD(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field HSTPULLDOWN[3:2] (RW)
 *
 * Set bit 3 to 1 to pull down 15-KOhm on USB_DP line. Set bit 2 to 1 to pull
 * down 15-KOhm on USB_DM line. Clear to 0 to disable.
 */
/*@{*/
#define BP_USBPHY_DEBUG_HSTPULLDOWN (2U)   /*!< Bit position for USBPHY_DEBUG_HSTPULLDOWN. */
#define BM_USBPHY_DEBUG_HSTPULLDOWN (0x0000000CU) /*!< Bit mask for USBPHY_DEBUG_HSTPULLDOWN. */
#define BS_USBPHY_DEBUG_HSTPULLDOWN (2U)   /*!< Bit field size in bits for USBPHY_DEBUG_HSTPULLDOWN. */

/*! @brief Read current value of the USBPHY_DEBUG_HSTPULLDOWN field. */
#define BR_USBPHY_DEBUG_HSTPULLDOWN(x) (HW_USBPHY_DEBUG(x).B.HSTPULLDOWN)

/*! @brief Format value for bitfield USBPHY_DEBUG_HSTPULLDOWN. */
#define BF_USBPHY_DEBUG_HSTPULLDOWN(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_HSTPULLDOWN) & BM_USBPHY_DEBUG_HSTPULLDOWN)

/*! @brief Set the HSTPULLDOWN field to a new value. */
#define BW_USBPHY_DEBUG_HSTPULLDOWN(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_HSTPULLDOWN) | BF_USBPHY_DEBUG_HSTPULLDOWN(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field ENHSTPULLDOWN[5:4] (RW)
 *
 * Set bit 5 to 1 to override the control of the USB_DP 15-KOhm pulldown. Set
 * bit 4 to 1 to override the control of the USB_DM 15-KOhm pulldown. Clear to 0 to
 * disable.
 */
/*@{*/
#define BP_USBPHY_DEBUG_ENHSTPULLDOWN (4U) /*!< Bit position for USBPHY_DEBUG_ENHSTPULLDOWN. */
#define BM_USBPHY_DEBUG_ENHSTPULLDOWN (0x00000030U) /*!< Bit mask for USBPHY_DEBUG_ENHSTPULLDOWN. */
#define BS_USBPHY_DEBUG_ENHSTPULLDOWN (2U) /*!< Bit field size in bits for USBPHY_DEBUG_ENHSTPULLDOWN. */

/*! @brief Read current value of the USBPHY_DEBUG_ENHSTPULLDOWN field. */
#define BR_USBPHY_DEBUG_ENHSTPULLDOWN(x) (HW_USBPHY_DEBUG(x).B.ENHSTPULLDOWN)

/*! @brief Format value for bitfield USBPHY_DEBUG_ENHSTPULLDOWN. */
#define BF_USBPHY_DEBUG_ENHSTPULLDOWN(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_ENHSTPULLDOWN) & BM_USBPHY_DEBUG_ENHSTPULLDOWN)

/*! @brief Set the ENHSTPULLDOWN field to a new value. */
#define BW_USBPHY_DEBUG_ENHSTPULLDOWN(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_ENHSTPULLDOWN) | BF_USBPHY_DEBUG_ENHSTPULLDOWN(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field RSVD0[7:6] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_DEBUG_RSVD0 (6U)         /*!< Bit position for USBPHY_DEBUG_RSVD0. */
#define BM_USBPHY_DEBUG_RSVD0 (0x000000C0U) /*!< Bit mask for USBPHY_DEBUG_RSVD0. */
#define BS_USBPHY_DEBUG_RSVD0 (2U)         /*!< Bit field size in bits for USBPHY_DEBUG_RSVD0. */

/*! @brief Read current value of the USBPHY_DEBUG_RSVD0 field. */
#define BR_USBPHY_DEBUG_RSVD0(x) (HW_USBPHY_DEBUG(x).B.RSVD0)
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field TX2RXCOUNT[11:8] (RW)
 *
 * Delay in between the end of transmit to the beginning of receive. This is a
 * Johnson count value and thus will count to 8.
 */
/*@{*/
#define BP_USBPHY_DEBUG_TX2RXCOUNT (8U)    /*!< Bit position for USBPHY_DEBUG_TX2RXCOUNT. */
#define BM_USBPHY_DEBUG_TX2RXCOUNT (0x00000F00U) /*!< Bit mask for USBPHY_DEBUG_TX2RXCOUNT. */
#define BS_USBPHY_DEBUG_TX2RXCOUNT (4U)    /*!< Bit field size in bits for USBPHY_DEBUG_TX2RXCOUNT. */

/*! @brief Read current value of the USBPHY_DEBUG_TX2RXCOUNT field. */
#define BR_USBPHY_DEBUG_TX2RXCOUNT(x) (HW_USBPHY_DEBUG(x).B.TX2RXCOUNT)

/*! @brief Format value for bitfield USBPHY_DEBUG_TX2RXCOUNT. */
#define BF_USBPHY_DEBUG_TX2RXCOUNT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_TX2RXCOUNT) & BM_USBPHY_DEBUG_TX2RXCOUNT)

/*! @brief Set the TX2RXCOUNT field to a new value. */
#define BW_USBPHY_DEBUG_TX2RXCOUNT(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_TX2RXCOUNT) | BF_USBPHY_DEBUG_TX2RXCOUNT(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field ENTX2RXCOUNT[12] (RW)
 *
 * Set this bit to allow a countdown to transition in between TX and RX.
 */
/*@{*/
#define BP_USBPHY_DEBUG_ENTX2RXCOUNT (12U) /*!< Bit position for USBPHY_DEBUG_ENTX2RXCOUNT. */
#define BM_USBPHY_DEBUG_ENTX2RXCOUNT (0x00001000U) /*!< Bit mask for USBPHY_DEBUG_ENTX2RXCOUNT. */
#define BS_USBPHY_DEBUG_ENTX2RXCOUNT (1U)  /*!< Bit field size in bits for USBPHY_DEBUG_ENTX2RXCOUNT. */

/*! @brief Read current value of the USBPHY_DEBUG_ENTX2RXCOUNT field. */
#define BR_USBPHY_DEBUG_ENTX2RXCOUNT(x) (HW_USBPHY_DEBUG(x).B.ENTX2RXCOUNT)

/*! @brief Format value for bitfield USBPHY_DEBUG_ENTX2RXCOUNT. */
#define BF_USBPHY_DEBUG_ENTX2RXCOUNT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_ENTX2RXCOUNT) & BM_USBPHY_DEBUG_ENTX2RXCOUNT)

/*! @brief Set the ENTX2RXCOUNT field to a new value. */
#define BW_USBPHY_DEBUG_ENTX2RXCOUNT(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_ENTX2RXCOUNT) | BF_USBPHY_DEBUG_ENTX2RXCOUNT(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field RSVD1[15:13] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_DEBUG_RSVD1 (13U)        /*!< Bit position for USBPHY_DEBUG_RSVD1. */
#define BM_USBPHY_DEBUG_RSVD1 (0x0000E000U) /*!< Bit mask for USBPHY_DEBUG_RSVD1. */
#define BS_USBPHY_DEBUG_RSVD1 (3U)         /*!< Bit field size in bits for USBPHY_DEBUG_RSVD1. */

/*! @brief Read current value of the USBPHY_DEBUG_RSVD1 field. */
#define BR_USBPHY_DEBUG_RSVD1(x) (HW_USBPHY_DEBUG(x).B.RSVD1)
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field SQUELCHRESETCOUNT[20:16] (RW)
 *
 * Delay in between the detection of squelch to the reset of high-speed RX.
 */
/*@{*/
#define BP_USBPHY_DEBUG_SQUELCHRESETCOUNT (16U) /*!< Bit position for USBPHY_DEBUG_SQUELCHRESETCOUNT. */
#define BM_USBPHY_DEBUG_SQUELCHRESETCOUNT (0x001F0000U) /*!< Bit mask for USBPHY_DEBUG_SQUELCHRESETCOUNT. */
#define BS_USBPHY_DEBUG_SQUELCHRESETCOUNT (5U) /*!< Bit field size in bits for USBPHY_DEBUG_SQUELCHRESETCOUNT. */

/*! @brief Read current value of the USBPHY_DEBUG_SQUELCHRESETCOUNT field. */
#define BR_USBPHY_DEBUG_SQUELCHRESETCOUNT(x) (HW_USBPHY_DEBUG(x).B.SQUELCHRESETCOUNT)

/*! @brief Format value for bitfield USBPHY_DEBUG_SQUELCHRESETCOUNT. */
#define BF_USBPHY_DEBUG_SQUELCHRESETCOUNT(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_SQUELCHRESETCOUNT) & BM_USBPHY_DEBUG_SQUELCHRESETCOUNT)

/*! @brief Set the SQUELCHRESETCOUNT field to a new value. */
#define BW_USBPHY_DEBUG_SQUELCHRESETCOUNT(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_SQUELCHRESETCOUNT) | BF_USBPHY_DEBUG_SQUELCHRESETCOUNT(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field RSVD2[23:21] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_DEBUG_RSVD2 (21U)        /*!< Bit position for USBPHY_DEBUG_RSVD2. */
#define BM_USBPHY_DEBUG_RSVD2 (0x00E00000U) /*!< Bit mask for USBPHY_DEBUG_RSVD2. */
#define BS_USBPHY_DEBUG_RSVD2 (3U)         /*!< Bit field size in bits for USBPHY_DEBUG_RSVD2. */

/*! @brief Read current value of the USBPHY_DEBUG_RSVD2 field. */
#define BR_USBPHY_DEBUG_RSVD2(x) (HW_USBPHY_DEBUG(x).B.RSVD2)
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field ENSQUELCHRESET[24] (RW)
 *
 * Set bit to allow squelch to reset high-speed receive.
 */
/*@{*/
#define BP_USBPHY_DEBUG_ENSQUELCHRESET (24U) /*!< Bit position for USBPHY_DEBUG_ENSQUELCHRESET. */
#define BM_USBPHY_DEBUG_ENSQUELCHRESET (0x01000000U) /*!< Bit mask for USBPHY_DEBUG_ENSQUELCHRESET. */
#define BS_USBPHY_DEBUG_ENSQUELCHRESET (1U) /*!< Bit field size in bits for USBPHY_DEBUG_ENSQUELCHRESET. */

/*! @brief Read current value of the USBPHY_DEBUG_ENSQUELCHRESET field. */
#define BR_USBPHY_DEBUG_ENSQUELCHRESET(x) (HW_USBPHY_DEBUG(x).B.ENSQUELCHRESET)

/*! @brief Format value for bitfield USBPHY_DEBUG_ENSQUELCHRESET. */
#define BF_USBPHY_DEBUG_ENSQUELCHRESET(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_ENSQUELCHRESET) & BM_USBPHY_DEBUG_ENSQUELCHRESET)

/*! @brief Set the ENSQUELCHRESET field to a new value. */
#define BW_USBPHY_DEBUG_ENSQUELCHRESET(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_ENSQUELCHRESET) | BF_USBPHY_DEBUG_ENSQUELCHRESET(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field SQUELCHRESETLENGTH[28:25] (RW)
 *
 * Duration of RESET in terms of the number of 480-MHz cycles.
 */
/*@{*/
#define BP_USBPHY_DEBUG_SQUELCHRESETLENGTH (25U) /*!< Bit position for USBPHY_DEBUG_SQUELCHRESETLENGTH. */
#define BM_USBPHY_DEBUG_SQUELCHRESETLENGTH (0x1E000000U) /*!< Bit mask for USBPHY_DEBUG_SQUELCHRESETLENGTH. */
#define BS_USBPHY_DEBUG_SQUELCHRESETLENGTH (4U) /*!< Bit field size in bits for USBPHY_DEBUG_SQUELCHRESETLENGTH. */

/*! @brief Read current value of the USBPHY_DEBUG_SQUELCHRESETLENGTH field. */
#define BR_USBPHY_DEBUG_SQUELCHRESETLENGTH(x) (HW_USBPHY_DEBUG(x).B.SQUELCHRESETLENGTH)

/*! @brief Format value for bitfield USBPHY_DEBUG_SQUELCHRESETLENGTH. */
#define BF_USBPHY_DEBUG_SQUELCHRESETLENGTH(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_SQUELCHRESETLENGTH) & BM_USBPHY_DEBUG_SQUELCHRESETLENGTH)

/*! @brief Set the SQUELCHRESETLENGTH field to a new value. */
#define BW_USBPHY_DEBUG_SQUELCHRESETLENGTH(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_SQUELCHRESETLENGTH) | BF_USBPHY_DEBUG_SQUELCHRESETLENGTH(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field HOST_RESUME_DEBUG[29] (RW)
 *
 * Choose to trigger the host resume SE0 with HOST_FORCE_LS_SE0 = 0 or
 * UTMI_SUSPEND = 1.
 */
/*@{*/
#define BP_USBPHY_DEBUG_HOST_RESUME_DEBUG (29U) /*!< Bit position for USBPHY_DEBUG_HOST_RESUME_DEBUG. */
#define BM_USBPHY_DEBUG_HOST_RESUME_DEBUG (0x20000000U) /*!< Bit mask for USBPHY_DEBUG_HOST_RESUME_DEBUG. */
#define BS_USBPHY_DEBUG_HOST_RESUME_DEBUG (1U) /*!< Bit field size in bits for USBPHY_DEBUG_HOST_RESUME_DEBUG. */

/*! @brief Read current value of the USBPHY_DEBUG_HOST_RESUME_DEBUG field. */
#define BR_USBPHY_DEBUG_HOST_RESUME_DEBUG(x) (HW_USBPHY_DEBUG(x).B.HOST_RESUME_DEBUG)

/*! @brief Format value for bitfield USBPHY_DEBUG_HOST_RESUME_DEBUG. */
#define BF_USBPHY_DEBUG_HOST_RESUME_DEBUG(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_HOST_RESUME_DEBUG) & BM_USBPHY_DEBUG_HOST_RESUME_DEBUG)

/*! @brief Set the HOST_RESUME_DEBUG field to a new value. */
#define BW_USBPHY_DEBUG_HOST_RESUME_DEBUG(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_HOST_RESUME_DEBUG) | BF_USBPHY_DEBUG_HOST_RESUME_DEBUG(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field CLKGATE[30] (RW)
 *
 * Gate Test Clocks. Clear to 0 for running clocks. Set to 1 to gate clocks. Set
 * this to save power while the USB is not actively being used. Configuration
 * state is kept while the clock is gated.
 */
/*@{*/
#define BP_USBPHY_DEBUG_CLKGATE (30U)      /*!< Bit position for USBPHY_DEBUG_CLKGATE. */
#define BM_USBPHY_DEBUG_CLKGATE (0x40000000U) /*!< Bit mask for USBPHY_DEBUG_CLKGATE. */
#define BS_USBPHY_DEBUG_CLKGATE (1U)       /*!< Bit field size in bits for USBPHY_DEBUG_CLKGATE. */

/*! @brief Read current value of the USBPHY_DEBUG_CLKGATE field. */
#define BR_USBPHY_DEBUG_CLKGATE(x) (HW_USBPHY_DEBUG(x).B.CLKGATE)

/*! @brief Format value for bitfield USBPHY_DEBUG_CLKGATE. */
#define BF_USBPHY_DEBUG_CLKGATE(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG_CLKGATE) & BM_USBPHY_DEBUG_CLKGATE)

/*! @brief Set the CLKGATE field to a new value. */
#define BW_USBPHY_DEBUG_CLKGATE(x, v) (HW_USBPHY_DEBUG_WR(x, (HW_USBPHY_DEBUG_RD(x) & ~BM_USBPHY_DEBUG_CLKGATE) | BF_USBPHY_DEBUG_CLKGATE(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG, field RSVD3[31] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_DEBUG_RSVD3 (31U)        /*!< Bit position for USBPHY_DEBUG_RSVD3. */
#define BM_USBPHY_DEBUG_RSVD3 (0x80000000U) /*!< Bit mask for USBPHY_DEBUG_RSVD3. */
#define BS_USBPHY_DEBUG_RSVD3 (1U)         /*!< Bit field size in bits for USBPHY_DEBUG_RSVD3. */

/*! @brief Read current value of the USBPHY_DEBUG_RSVD3 field. */
#define BR_USBPHY_DEBUG_RSVD3(x) (HW_USBPHY_DEBUG(x).B.RSVD3)
/*@}*/




/*******************************************************************************
 * HW_USBPHY_DEBUG0_STATUS - UTMI Debug Status Register 0
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_DEBUG0_STATUS - UTMI Debug Status Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * The UTMI Debug Status Register 0 holds multiple views for counters and status
 * of state machines. This is used in conjunction with the
 * USBPHYx_DEBUG1_DBG_ADDRESS field to choose which function to view. The default is described in the
 * bit fields below and is used to count errors.
 */
typedef union _hw_usbphy_debug0_status
{
    uint32_t U;
    struct _hw_usbphy_debug0_status_bitfields
    {
        uint32_t LOOP_BACK_FAIL_COUNT : 16; /*!< [15:0]  */
        uint32_t UTMI_RXERROR_FAIL_COUNT : 10; /*!< [25:16]  */
        uint32_t SQUELCH_COUNT : 6;    /*!< [31:26]  */
    } B;
} hw_usbphy_debug0_status_t;

/*!
 * @name Constants and macros for entire USBPHY_DEBUG0_STATUS register
 */
/*@{*/
#define HW_USBPHY_DEBUG0_STATUS_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_USBPHY_DEBUG0_STATUS(x) (*(__I hw_usbphy_debug0_status_t *) HW_USBPHY_DEBUG0_STATUS_ADDR(x))
#define HW_USBPHY_DEBUG0_STATUS_RD(x) (HW_USBPHY_DEBUG0_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual USBPHY_DEBUG0_STATUS bitfields
 */

/*!
 * @name Register USBPHY_DEBUG0_STATUS, field LOOP_BACK_FAIL_COUNT[15:0] (RO)
 *
 * Running count of the failed pseudo-random generator loopback. Each time
 * entering testmode, counter goes to 900D and will count up for every detected packet
 * failure in digital/analog loopback tests.
 */
/*@{*/
#define BP_USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT (0U) /*!< Bit position for USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT. */
#define BM_USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT (0x0000FFFFU) /*!< Bit mask for USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT. */
#define BS_USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT (16U) /*!< Bit field size in bits for USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT. */

/*! @brief Read current value of the USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT field. */
#define BR_USBPHY_DEBUG0_STATUS_LOOP_BACK_FAIL_COUNT(x) (HW_USBPHY_DEBUG0_STATUS(x).B.LOOP_BACK_FAIL_COUNT)
/*@}*/

/*!
 * @name Register USBPHY_DEBUG0_STATUS, field UTMI_RXERROR_FAIL_COUNT[25:16] (RO)
 *
 * Running count of the UTMI_RXERROR.
 */
/*@{*/
#define BP_USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT (16U) /*!< Bit position for USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT. */
#define BM_USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT (0x03FF0000U) /*!< Bit mask for USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT. */
#define BS_USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT (10U) /*!< Bit field size in bits for USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT. */

/*! @brief Read current value of the USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT field. */
#define BR_USBPHY_DEBUG0_STATUS_UTMI_RXERROR_FAIL_COUNT(x) (HW_USBPHY_DEBUG0_STATUS(x).B.UTMI_RXERROR_FAIL_COUNT)
/*@}*/

/*!
 * @name Register USBPHY_DEBUG0_STATUS, field SQUELCH_COUNT[31:26] (RO)
 *
 * Running count of the squelch reset instead of normal end for HS RX.
 */
/*@{*/
#define BP_USBPHY_DEBUG0_STATUS_SQUELCH_COUNT (26U) /*!< Bit position for USBPHY_DEBUG0_STATUS_SQUELCH_COUNT. */
#define BM_USBPHY_DEBUG0_STATUS_SQUELCH_COUNT (0xFC000000U) /*!< Bit mask for USBPHY_DEBUG0_STATUS_SQUELCH_COUNT. */
#define BS_USBPHY_DEBUG0_STATUS_SQUELCH_COUNT (6U) /*!< Bit field size in bits for USBPHY_DEBUG0_STATUS_SQUELCH_COUNT. */

/*! @brief Read current value of the USBPHY_DEBUG0_STATUS_SQUELCH_COUNT field. */
#define BR_USBPHY_DEBUG0_STATUS_SQUELCH_COUNT(x) (HW_USBPHY_DEBUG0_STATUS(x).B.SQUELCH_COUNT)
/*@}*/

/*******************************************************************************
 * HW_USBPHY_DEBUG1 - UTMI Debug Status Register 1
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_DEBUG1 - UTMI Debug Status Register 1 (RW)
 *
 * Reset value: 0x00001000U
 *
 * Chooses the muxing of the debug register to be shown in USBPHYx_DEBUG0_STATUS.
 */
typedef union _hw_usbphy_debug1
{
    uint32_t U;
    struct _hw_usbphy_debug1_bitfields
    {
        uint32_t RSVD0 : 13;           /*!< [12:0]  */
        uint32_t ENTAILADJVD : 2;      /*!< [14:13]  */
        uint32_t RSVD1 : 17;           /*!< [31:15]  */
    } B;
} hw_usbphy_debug1_t;

/*!
 * @name Constants and macros for entire USBPHY_DEBUG1 register
 */
/*@{*/
#define HW_USBPHY_DEBUG1_ADDR(x) ((uintptr_t)(x) + 0x70U)
#define HW_USBPHY_DEBUG1_SET_ADDR(x) (HW_USBPHY_DEBUG1_ADDR(x) + 0x4U)
#define HW_USBPHY_DEBUG1_CLR_ADDR(x) (HW_USBPHY_DEBUG1_ADDR(x) + 0x8U)
#define HW_USBPHY_DEBUG1_TOG_ADDR(x) (HW_USBPHY_DEBUG1_ADDR(x) + 0xCU)

#define HW_USBPHY_DEBUG1(x)      (*(__IO hw_usbphy_debug1_t *) HW_USBPHY_DEBUG1_ADDR(x))
#define HW_USBPHY_DEBUG1_RD(x)   (HW_USBPHY_DEBUG1(x).U)
#define HW_USBPHY_DEBUG1_WR(x, v) (HW_USBPHY_DEBUG1(x).U = (v))
#define HW_USBPHY_DEBUG1_SET(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG1_SET_ADDR(x)) = (v))
#define HW_USBPHY_DEBUG1_CLR(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG1_CLR_ADDR(x)) = (v))
#define HW_USBPHY_DEBUG1_TOG(x, v) ((*(uint32_t *) HW_USBPHY_DEBUG1_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USBPHY_DEBUG1 bitfields
 */

/*!
 * @name Register USBPHY_DEBUG1, field RSVD0[12:0] (RW)
 *
 * Reserved. Note: This bit should remain clear.
 */
/*@{*/
#define BP_USBPHY_DEBUG1_RSVD0 (0U)        /*!< Bit position for USBPHY_DEBUG1_RSVD0. */
#define BM_USBPHY_DEBUG1_RSVD0 (0x00001FFFU) /*!< Bit mask for USBPHY_DEBUG1_RSVD0. */
#define BS_USBPHY_DEBUG1_RSVD0 (13U)       /*!< Bit field size in bits for USBPHY_DEBUG1_RSVD0. */

/*! @brief Read current value of the USBPHY_DEBUG1_RSVD0 field. */
#define BR_USBPHY_DEBUG1_RSVD0(x) (HW_USBPHY_DEBUG1(x).B.RSVD0)

/*! @brief Format value for bitfield USBPHY_DEBUG1_RSVD0. */
#define BF_USBPHY_DEBUG1_RSVD0(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG1_RSVD0) & BM_USBPHY_DEBUG1_RSVD0)

/*! @brief Set the RSVD0 field to a new value. */
#define BW_USBPHY_DEBUG1_RSVD0(x, v) (HW_USBPHY_DEBUG1_WR(x, (HW_USBPHY_DEBUG1_RD(x) & ~BM_USBPHY_DEBUG1_RSVD0) | BF_USBPHY_DEBUG1_RSVD0(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG1, field ENTAILADJVD[14:13] (RW)
 *
 * Delay increment of the rise of squelch: 00 = Delay is nominal 01 = Delay is
 * +20% 10 = Delay is -20% 11 = Delay is -40%
 */
/*@{*/
#define BP_USBPHY_DEBUG1_ENTAILADJVD (13U) /*!< Bit position for USBPHY_DEBUG1_ENTAILADJVD. */
#define BM_USBPHY_DEBUG1_ENTAILADJVD (0x00006000U) /*!< Bit mask for USBPHY_DEBUG1_ENTAILADJVD. */
#define BS_USBPHY_DEBUG1_ENTAILADJVD (2U)  /*!< Bit field size in bits for USBPHY_DEBUG1_ENTAILADJVD. */

/*! @brief Read current value of the USBPHY_DEBUG1_ENTAILADJVD field. */
#define BR_USBPHY_DEBUG1_ENTAILADJVD(x) (HW_USBPHY_DEBUG1(x).B.ENTAILADJVD)

/*! @brief Format value for bitfield USBPHY_DEBUG1_ENTAILADJVD. */
#define BF_USBPHY_DEBUG1_ENTAILADJVD(v) ((uint32_t)((uint32_t)(v) << BP_USBPHY_DEBUG1_ENTAILADJVD) & BM_USBPHY_DEBUG1_ENTAILADJVD)

/*! @brief Set the ENTAILADJVD field to a new value. */
#define BW_USBPHY_DEBUG1_ENTAILADJVD(x, v) (HW_USBPHY_DEBUG1_WR(x, (HW_USBPHY_DEBUG1_RD(x) & ~BM_USBPHY_DEBUG1_ENTAILADJVD) | BF_USBPHY_DEBUG1_ENTAILADJVD(v)))
/*@}*/

/*!
 * @name Register USBPHY_DEBUG1, field RSVD1[31:15] (RO)
 *
 * Reserved.
 */
/*@{*/
#define BP_USBPHY_DEBUG1_RSVD1 (15U)       /*!< Bit position for USBPHY_DEBUG1_RSVD1. */
#define BM_USBPHY_DEBUG1_RSVD1 (0xFFFF8000U) /*!< Bit mask for USBPHY_DEBUG1_RSVD1. */
#define BS_USBPHY_DEBUG1_RSVD1 (17U)       /*!< Bit field size in bits for USBPHY_DEBUG1_RSVD1. */

/*! @brief Read current value of the USBPHY_DEBUG1_RSVD1 field. */
#define BR_USBPHY_DEBUG1_RSVD1(x) (HW_USBPHY_DEBUG1(x).B.RSVD1)
/*@}*/




/*******************************************************************************
 * HW_USBPHY_VERSION - UTMI RTL Version
 ******************************************************************************/

/*!
 * @brief HW_USBPHY_VERSION - UTMI RTL Version (RO)
 *
 * Reset value: 0x04020000U
 *
 * Fields for RTL Version.
 */
typedef union _hw_usbphy_version
{
    uint32_t U;
    struct _hw_usbphy_version_bitfields
    {
        uint32_t STEP : 16;            /*!< [15:0]  */
        uint32_t MINOR : 8;            /*!< [23:16]  */
        uint32_t MAJOR : 8;            /*!< [31:24]  */
    } B;
} hw_usbphy_version_t;

/*!
 * @name Constants and macros for entire USBPHY_VERSION register
 */
/*@{*/
#define HW_USBPHY_VERSION_ADDR(x) ((uintptr_t)(x) + 0x80U)

#define HW_USBPHY_VERSION(x)     (*(__I hw_usbphy_version_t *) HW_USBPHY_VERSION_ADDR(x))
#define HW_USBPHY_VERSION_RD(x)  (HW_USBPHY_VERSION(x).U)
/*@}*/

/*
 * Constants & macros for individual USBPHY_VERSION bitfields
 */

/*!
 * @name Register USBPHY_VERSION, field STEP[15:0] (RO)
 *
 * Fixed read-only value reflecting the stepping of the RTL version.
 */
/*@{*/
#define BP_USBPHY_VERSION_STEP (0U)        /*!< Bit position for USBPHY_VERSION_STEP. */
#define BM_USBPHY_VERSION_STEP (0x0000FFFFU) /*!< Bit mask for USBPHY_VERSION_STEP. */
#define BS_USBPHY_VERSION_STEP (16U)       /*!< Bit field size in bits for USBPHY_VERSION_STEP. */

/*! @brief Read current value of the USBPHY_VERSION_STEP field. */
#define BR_USBPHY_VERSION_STEP(x) (HW_USBPHY_VERSION(x).B.STEP)
/*@}*/

/*!
 * @name Register USBPHY_VERSION, field MINOR[23:16] (RO)
 *
 * Fixed read-only value reflecting the MINOR field of the RTL version.
 */
/*@{*/
#define BP_USBPHY_VERSION_MINOR (16U)      /*!< Bit position for USBPHY_VERSION_MINOR. */
#define BM_USBPHY_VERSION_MINOR (0x00FF0000U) /*!< Bit mask for USBPHY_VERSION_MINOR. */
#define BS_USBPHY_VERSION_MINOR (8U)       /*!< Bit field size in bits for USBPHY_VERSION_MINOR. */

/*! @brief Read current value of the USBPHY_VERSION_MINOR field. */
#define BR_USBPHY_VERSION_MINOR(x) (HW_USBPHY_VERSION(x).B.MINOR)
/*@}*/

/*!
 * @name Register USBPHY_VERSION, field MAJOR[31:24] (RO)
 *
 * Fixed read-only value reflecting the MAJOR field of the RTL version.
 */
/*@{*/
#define BP_USBPHY_VERSION_MAJOR (24U)      /*!< Bit position for USBPHY_VERSION_MAJOR. */
#define BM_USBPHY_VERSION_MAJOR (0xFF000000U) /*!< Bit mask for USBPHY_VERSION_MAJOR. */
#define BS_USBPHY_VERSION_MAJOR (8U)       /*!< Bit field size in bits for USBPHY_VERSION_MAJOR. */

/*! @brief Read current value of the USBPHY_VERSION_MAJOR field. */
#define BR_USBPHY_VERSION_MAJOR(x) (HW_USBPHY_VERSION(x).B.MAJOR)
/*@}*/

/*******************************************************************************
 * hw_usbphy_t - module struct
 ******************************************************************************/
/*!
 * @brief All USBPHY module registers.
 */
#pragma pack(1)
typedef struct _hw_usbphy
{
    __IO hw_usbphy_pwd_t PWD;              /*!< [0x0] USB PHY Power-Down Register */
    uint8_t _reserved0[12];
    __IO hw_usbphy_tx_t TX;                /*!< [0x10] USB PHY Transmitter Control Register */
    uint8_t _reserved1[12];
    __IO hw_usbphy_rx_t RX;                /*!< [0x20] USB PHY Receiver Control Register */
    uint8_t _reserved2[12];
    __IO hw_usbphy_ctrl_t CTRL;            /*!< [0x30] USB PHY General Control Register */
    uint8_t _reserved3[12];
    __IO hw_usbphy_status_t STATUS;        /*!< [0x40] USB PHY Status Register */
    uint8_t _reserved4[12];
    __IO hw_usbphy_debug_t DEBUGr;         /*!< [0x50] USB PHY Debug Register */
    uint8_t _reserved5[12];
    __I hw_usbphy_debug0_status_t DEBUG0_STATUS; /*!< [0x60] UTMI Debug Status Register 0 */
    uint8_t _reserved6[12];
    __IO hw_usbphy_debug1_t DEBUG1;        /*!< [0x70] UTMI Debug Status Register 1 */
    uint8_t _reserved7[12];
    __I hw_usbphy_version_t VERSION;       /*!< [0x80] UTMI RTL Version */
} hw_usbphy_t;
#pragma pack()

/*! @brief Macro to access all USBPHY registers. */
/*! @param x USBPHY module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_USBPHY_REGS(USBPHY1_BASE)</code>. */
#define HW_USBPHY_REGS(x) (*(hw_usbphy_t *)(x))

/*
 * iMX6DP USB_ANALOG
 *
 * USB Analog
 *
 * Registers defined in this header file:
 * - HW_USB_ANALOG_USB1_VBUS_DETECT - USB VBUS Detect Register
 * - HW_USB_ANALOG_USB1_CHRG_DETECT - USB Charger Detect Register
 * - HW_USB_ANALOG_USB1_VBUS_DETECT_STAT - USB VBUS Detect Status Register
 * - HW_USB_ANALOG_USB1_CHRG_DETECT_STAT - USB Charger Detect Status Register
 * - HW_USB_ANALOG_USB1_MISC - USB Misc Register
 * - HW_USB_ANALOG_USB2_VBUS_DETECT - USB VBUS Detect Register
 * - HW_USB_ANALOG_USB2_CHRG_DETECT - USB Charger Detect Register
 * - HW_USB_ANALOG_USB2_VBUS_DETECT_STAT - USB VBUS Detect Status Register
 * - HW_USB_ANALOG_USB2_CHRG_DETECT_STAT - USB Charger Detect Status Register
 * - HW_USB_ANALOG_USB2_MISC - USB Misc Register
 * - HW_USB_ANALOG_DIGPROG - Chip Silicon Version
 *
 * - hw_usb_analog_t - Struct containing all module registers.
 */

#define HW_USB_ANALOG_INSTANCE_COUNT (1U) /*!< Number of instances of the USB_ANALOG module. */
#define HW_USB_ANALOG (0U) /*!< Instance number for USB_ANALOG. */
#define USB_ANALOG_BASE       (0x20C8000U) /*!< Base address for USB_ANALOG. */
/*! Array initializer of USB_ANALOG base addresses. */
#define USB_ANALOG_BASE_ADDRS { USB_ANALOG_BASE }

/*******************************************************************************
 * HW_USB_ANALOG_USB1_VBUS_DETECT - USB VBUS Detect Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB1_VBUS_DETECT - USB VBUS Detect Register (RW)
 *
 * Reset value: 0x00100004U
 *
 * This register defines controls for USB VBUS detect.
 */
typedef union _hw_usb_analog_usb1_vbus_detect
{
    uint32_t U;
    struct _hw_usb_analog_usb1_vbus_detect_bitfields
    {
        uint32_t VBUSVALID_THRESH : 3; /*!< [2:0]  */
        uint32_t RESERVED0 : 17;       /*!< [19:3]  */
        uint32_t VBUSVALID_PWRUP_CMPS : 1; /*!< [20]  */
        uint32_t RESERVED1 : 5;        /*!< [25:21]  */
        uint32_t DISCHARGE_VBUS : 1;   /*!< [26]  */
        uint32_t CHARGE_VBUS : 1;      /*!< [27]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_analog_usb1_vbus_detect_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB1_VBUS_DETECT register
 */
/*@{*/
#define HW_USB_ANALOG_USB1_VBUS_DETECT_ADDR(x) ((uintptr_t)(x) + 0x1A0U)
#define HW_USB_ANALOG_USB1_VBUS_DETECT_SET_ADDR(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB1_VBUS_DETECT_CLR_ADDR(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB1_VBUS_DETECT_TOG_ADDR(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB1_VBUS_DETECT(x) (*(__IO hw_usb_analog_usb1_vbus_detect_t *) HW_USB_ANALOG_USB1_VBUS_DETECT_ADDR(x))
#define HW_USB_ANALOG_USB1_VBUS_DETECT_RD(x) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).U)
#define HW_USB_ANALOG_USB1_VBUS_DETECT_WR(x, v) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).U = (v))
#define HW_USB_ANALOG_USB1_VBUS_DETECT_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_VBUS_DETECT_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_VBUS_DETECT_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_VBUS_DETECT_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_VBUS_DETECT_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_VBUS_DETECT_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB1_VBUS_DETECT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT, field VBUSVALID_THRESH[2:0] (RW)
 *
 * Set the threshold for the VBUSVALID comparator. This comparator is the most
 * accurate method to determine the presence of 5v, and includes hystersis to
 * minimize the need for software debounce of the detection. This comparator has
 * ~50mV of hystersis to prevent chattering at the comparator trip point.
 *
 * Values:
 * - 000 - 4.0V
 * - 001 - 4.1V
 * - 010 - 4.2V
 * - 011 - 4.3V
 * - 100 - 4.4V (default)
 * - 101 - 4.5V
 * - 110 - 4.6V
 * - 111 - 4.7V
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH (0U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH (0x00000007U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH (3U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH. */

#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V0 (0U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.0V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V1 (0x1U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.1V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V2 (0x2U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.2V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V3 (0x3U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.3V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V4 (0x4U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.4V (default) */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V5 (0x5U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.5V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V6 (0x6U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.6V */
#define BV_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH_4V7 (0x7U) /*!< Bit field value for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH: 4.7V */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH(x) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).B.VBUSVALID_THRESH)

/*! @brief Format value for bitfield USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH. */
#define BF_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH) & BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH)

/*! @brief Set the VBUSVALID_THRESH field to a new value. */
#define BW_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH(x, v) (HW_USB_ANALOG_USB1_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB1_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH) | BF_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_THRESH(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT, field VBUSVALID_PWRUP_CMPS[20] (RW)
 *
 * Powers up comparators for vbus_valid detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (20U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (0x00100000U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(x) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).B.VBUSVALID_PWRUP_CMPS)

/*! @brief Format value for bitfield USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BF_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS) & BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS)

/*! @brief Set the VBUSVALID_PWRUP_CMPS field to a new value. */
#define BW_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(x, v) (HW_USB_ANALOG_USB1_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB1_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS) | BF_USB_ANALOG_USB1_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT, field DISCHARGE_VBUS[26] (RW)
 *
 * USB OTG discharge VBUS.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS (26U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS (0x04000000U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS(x) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).B.DISCHARGE_VBUS)

/*! @brief Format value for bitfield USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS. */
#define BF_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS) & BM_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS)

/*! @brief Set the DISCHARGE_VBUS field to a new value. */
#define BW_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS(x, v) (HW_USB_ANALOG_USB1_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB1_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS) | BF_USB_ANALOG_USB1_VBUS_DETECT_DISCHARGE_VBUS(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT, field CHARGE_VBUS[27] (RW)
 *
 * USB OTG charge VBUS.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS (27U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS (0x08000000U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS(x) (HW_USB_ANALOG_USB1_VBUS_DETECT(x).B.CHARGE_VBUS)

/*! @brief Format value for bitfield USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS. */
#define BF_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS) & BM_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS)

/*! @brief Set the CHARGE_VBUS field to a new value. */
#define BW_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS(x, v) (HW_USB_ANALOG_USB1_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB1_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS) | BF_USB_ANALOG_USB1_VBUS_DETECT_CHARGE_VBUS(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_USB1_CHRG_DETECT - USB Charger Detect Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB1_CHRG_DETECT - USB Charger Detect Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines controls for USB charger detect.
 */
typedef union _hw_usb_analog_usb1_chrg_detect
{
    uint32_t U;
    struct _hw_usb_analog_usb1_chrg_detect_bitfields
    {
        uint32_t RESERVED0 : 18;       /*!< [17:0]  */
        uint32_t CHK_CONTACT : 1;      /*!< [18]  */
        uint32_t CHK_CHRG_B : 1;       /*!< [19]  */
        uint32_t EN_B : 1;             /*!< [20]  */
        uint32_t RESERVED1 : 11;       /*!< [31:21]  */
    } B;
} hw_usb_analog_usb1_chrg_detect_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB1_CHRG_DETECT register
 */
/*@{*/
#define HW_USB_ANALOG_USB1_CHRG_DETECT_ADDR(x) ((uintptr_t)(x) + 0x1B0U)
#define HW_USB_ANALOG_USB1_CHRG_DETECT_SET_ADDR(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB1_CHRG_DETECT_CLR_ADDR(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB1_CHRG_DETECT_TOG_ADDR(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB1_CHRG_DETECT(x) (*(__IO hw_usb_analog_usb1_chrg_detect_t *) HW_USB_ANALOG_USB1_CHRG_DETECT_ADDR(x))
#define HW_USB_ANALOG_USB1_CHRG_DETECT_RD(x) (HW_USB_ANALOG_USB1_CHRG_DETECT(x).U)
#define HW_USB_ANALOG_USB1_CHRG_DETECT_WR(x, v) (HW_USB_ANALOG_USB1_CHRG_DETECT(x).U = (v))
#define HW_USB_ANALOG_USB1_CHRG_DETECT_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_CHRG_DETECT_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_CHRG_DETECT_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_CHRG_DETECT_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_CHRG_DETECT_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_CHRG_DETECT_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB1_CHRG_DETECT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT, field CHK_CONTACT[18] (RW)
 *
 * Values:
 * - 0 - Do not check the contact of USB plug.
 * - 1 - Check whether the USB plug has been in contact with each other
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT (18U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT (0x00040000U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT. */

#define BV_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT_NO_CHECK (0U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT: Do not check the contact of USB plug. */
#define BV_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT_CHECK (0x1U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT: Check whether the USB plug has been in contact with each other */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT(x) (HW_USB_ANALOG_USB1_CHRG_DETECT(x).B.CHK_CONTACT)

/*! @brief Format value for bitfield USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT. */
#define BF_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT) & BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT)

/*! @brief Set the CHK_CONTACT field to a new value. */
#define BW_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT(x, v) (HW_USB_ANALOG_USB1_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB1_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT) | BF_USB_ANALOG_USB1_CHRG_DETECT_CHK_CONTACT(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT, field CHK_CHRG_B[19] (RW)
 *
 * Values:
 * - 0 - Check whether a charger (either a dedicated charger or a host charger)
 *     is connected to USB port.
 * - 1 - Do not check whether a charger is connected to the USB port.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B (19U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B (0x00080000U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B. */

#define BV_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B_CHECK (0U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B: Check whether a charger (either a dedicated charger or a host charger) is connected to USB port. */
#define BV_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B_NO_CHECK (0x1U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B: Do not check whether a charger is connected to the USB port. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B(x) (HW_USB_ANALOG_USB1_CHRG_DETECT(x).B.CHK_CHRG_B)

/*! @brief Format value for bitfield USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B. */
#define BF_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B) & BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B)

/*! @brief Set the CHK_CHRG_B field to a new value. */
#define BW_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B(x, v) (HW_USB_ANALOG_USB1_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB1_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B) | BF_USB_ANALOG_USB1_CHRG_DETECT_CHK_CHRG_B(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT, field EN_B[20] (RW)
 *
 * Control the charger detector.
 *
 * Values:
 * - 0 - Enable the charger detector.
 * - 1 - Disable the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_EN_B (20U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_EN_B. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_EN_B (0x00100000U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_EN_B. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_EN_B (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_EN_B. */

#define BV_USB_ANALOG_USB1_CHRG_DETECT_EN_B_ENABLE (0U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_EN_B: Enable the charger detector. */
#define BV_USB_ANALOG_USB1_CHRG_DETECT_EN_B_DISABLE (0x1U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_EN_B: Disable the charger detector. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_EN_B field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_EN_B(x) (HW_USB_ANALOG_USB1_CHRG_DETECT(x).B.EN_B)

/*! @brief Format value for bitfield USB_ANALOG_USB1_CHRG_DETECT_EN_B. */
#define BF_USB_ANALOG_USB1_CHRG_DETECT_EN_B(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_CHRG_DETECT_EN_B) & BM_USB_ANALOG_USB1_CHRG_DETECT_EN_B)

/*! @brief Set the EN_B field to a new value. */
#define BW_USB_ANALOG_USB1_CHRG_DETECT_EN_B(x, v) (HW_USB_ANALOG_USB1_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB1_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB1_CHRG_DETECT_EN_B) | BF_USB_ANALOG_USB1_CHRG_DETECT_EN_B(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_USB1_VBUS_DETECT_STAT - USB VBUS Detect Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB1_VBUS_DETECT_STAT - USB VBUS Detect Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines fields for USB VBUS Detect status.
 */
typedef union _hw_usb_analog_usb1_vbus_detect_stat
{
    uint32_t U;
    struct _hw_usb_analog_usb1_vbus_detect_stat_bitfields
    {
        uint32_t SESSEND : 1;          /*!< [0]  */
        uint32_t BVALID : 1;           /*!< [1]  */
        uint32_t AVALID : 1;           /*!< [2]  */
        uint32_t VBUS_VALID : 1;       /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_analog_usb1_vbus_detect_stat_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB1_VBUS_DETECT_STAT register
 */
/*@{*/
#define HW_USB_ANALOG_USB1_VBUS_DETECT_STAT_ADDR(x) ((uintptr_t)(x) + 0x1C0U)

#define HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x) (*(__I hw_usb_analog_usb1_vbus_detect_stat_t *) HW_USB_ANALOG_USB1_VBUS_DETECT_STAT_ADDR(x))
#define HW_USB_ANALOG_USB1_VBUS_DETECT_STAT_RD(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB1_VBUS_DETECT_STAT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT_STAT, field SESSEND[0] (RO)
 *
 * Session End for USB OTG. This bit is a read only version of the state of the
 * analog signal. It can not be overwritten by software like the SESSEND bit
 * below. NOTE: This bit's default value depends on whether VDD5V is present, 0 if
 * VDD5V is present, 1 if VDD5V is not present.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND (0U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND (0x00000001U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_STAT_SESSEND(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x).B.SESSEND)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT_STAT, field BVALID[1] (RO)
 *
 * Indicates VBus is valid for a B-peripheral. This bit is a read only version
 * of the state of the analog signal. It can not be overritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID (1U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID (0x00000002U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_STAT_BVALID(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x).B.BVALID)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT_STAT, field AVALID[2] (RO)
 *
 * Indicates VBus is valid for a A-peripheral. This bit is a read only version
 * of the state of the analog signal. It can not be overritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID (2U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID (0x00000004U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_STAT_AVALID(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x).B.AVALID)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_VBUS_DETECT_STAT, field VBUS_VALID[3] (RO)
 *
 * VBus valid for USB OTG. This bit is a read only version of the state of the
 * analog signal. It can not be overwritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID (3U) /*!< Bit position for USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID. */
#define BM_USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID (0x00000008U) /*!< Bit mask for USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID. */
#define BS_USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID. */

/*! @brief Read current value of the USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID field. */
#define BR_USB_ANALOG_USB1_VBUS_DETECT_STAT_VBUS_VALID(x) (HW_USB_ANALOG_USB1_VBUS_DETECT_STAT(x).B.VBUS_VALID)
/*@}*/

/*******************************************************************************
 * HW_USB_ANALOG_USB1_CHRG_DETECT_STAT - USB Charger Detect Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB1_CHRG_DETECT_STAT - USB Charger Detect Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines fields for USB charger detect status.
 */
typedef union _hw_usb_analog_usb1_chrg_detect_stat
{
    uint32_t U;
    struct _hw_usb_analog_usb1_chrg_detect_stat_bitfields
    {
        uint32_t PLUG_CONTACT : 1;     /*!< [0]  */
        uint32_t CHRG_DETECTED : 1;    /*!< [1]  */
        uint32_t DM_STATE : 1;         /*!< [2]  */
        uint32_t DP_STATE : 1;         /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_analog_usb1_chrg_detect_stat_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB1_CHRG_DETECT_STAT register
 */
/*@{*/
#define HW_USB_ANALOG_USB1_CHRG_DETECT_STAT_ADDR(x) ((uintptr_t)(x) + 0x1D0U)

#define HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x) (*(__I hw_usb_analog_usb1_chrg_detect_stat_t *) HW_USB_ANALOG_USB1_CHRG_DETECT_STAT_ADDR(x))
#define HW_USB_ANALOG_USB1_CHRG_DETECT_STAT_RD(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB1_CHRG_DETECT_STAT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT_STAT, field PLUG_CONTACT[0] (RO)
 *
 * State of the USB plug contact detector.
 *
 * Values:
 * - 0 - The USB plug has not made contact.
 * - 1 - The USB plug has made good contact.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT (0U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT (0x00000001U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT. */

#define BV_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT_NO_CONTACT (0U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT: The USB plug has not made contact. */
#define BV_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT_GOOD_CONTACT (0x1U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT: The USB plug has made good contact. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_STAT_PLUG_CONTACT(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x).B.PLUG_CONTACT)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT_STAT, field CHRG_DETECTED[1] (RO)
 *
 * State of charger detection. This bit is a read only version of the state of
 * the analog signal.
 *
 * Values:
 * - 0 - The USB port is not connected to a charger.
 * - 1 - A charger (either a dedicated charger or a host charger) is connected
 *     to the USB port.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED (1U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED (0x00000002U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED. */

#define BV_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED_CHARGER_NOT_PRESENT (0U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED: The USB port is not connected to a charger. */
#define BV_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED_CHARGER_PRESENT (0x1U) /*!< Bit field value for USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED: A charger (either a dedicated charger or a host charger) is connected to the USB port. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_STAT_CHRG_DETECTED(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x).B.CHRG_DETECTED)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT_STAT, field DM_STATE[2] (RO)
 *
 * DM line state output of the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE (2U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE (0x00000004U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_STAT_DM_STATE(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x).B.DM_STATE)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_CHRG_DETECT_STAT, field DP_STATE[3] (RO)
 *
 * DP line state output of the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE (3U) /*!< Bit position for USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE. */
#define BM_USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE (0x00000008U) /*!< Bit mask for USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE. */
#define BS_USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE. */

/*! @brief Read current value of the USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE field. */
#define BR_USB_ANALOG_USB1_CHRG_DETECT_STAT_DP_STATE(x) (HW_USB_ANALOG_USB1_CHRG_DETECT_STAT(x).B.DP_STATE)
/*@}*/

/*******************************************************************************
 * HW_USB_ANALOG_USB1_MISC - USB Misc Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB1_MISC - USB Misc Register (RW)
 *
 * Reset value: 0x00000002U
 *
 * This register defines controls for USB.
 */
typedef union _hw_usb_analog_usb1_misc
{
    uint32_t U;
    struct _hw_usb_analog_usb1_misc_bitfields
    {
        uint32_t HS_USE_EXTERNAL_R : 1; /*!< [0]  */
        uint32_t EN_DEGLITCH : 1;      /*!< [1]  */
        uint32_t RESERVED0 : 28;       /*!< [29:2]  */
        uint32_t EN_CLK_UTMI : 1;      /*!< [30]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_usb_analog_usb1_misc_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB1_MISC register
 */
/*@{*/
#define HW_USB_ANALOG_USB1_MISC_ADDR(x) ((uintptr_t)(x) + 0x1F0U)
#define HW_USB_ANALOG_USB1_MISC_SET_ADDR(x) (HW_USB_ANALOG_USB1_MISC_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB1_MISC_CLR_ADDR(x) (HW_USB_ANALOG_USB1_MISC_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB1_MISC_TOG_ADDR(x) (HW_USB_ANALOG_USB1_MISC_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB1_MISC(x) (*(__IO hw_usb_analog_usb1_misc_t *) HW_USB_ANALOG_USB1_MISC_ADDR(x))
#define HW_USB_ANALOG_USB1_MISC_RD(x) (HW_USB_ANALOG_USB1_MISC(x).U)
#define HW_USB_ANALOG_USB1_MISC_WR(x, v) (HW_USB_ANALOG_USB1_MISC(x).U = (v))
#define HW_USB_ANALOG_USB1_MISC_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_MISC_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_MISC_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_MISC_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB1_MISC_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB1_MISC_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB1_MISC bitfields
 */

/*!
 * @name Register USB_ANALOG_USB1_MISC, field HS_USE_EXTERNAL_R[0] (RW)
 *
 * Use external resistor to generate the current bias for the high speed
 * transmitter. This bit should not be changed unless recommended by Freescale.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R (0U) /*!< Bit position for USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R. */
#define BM_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R (0x00000001U) /*!< Bit mask for USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R. */
#define BS_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R. */

/*! @brief Read current value of the USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R field. */
#define BR_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R(x) (HW_USB_ANALOG_USB1_MISC(x).B.HS_USE_EXTERNAL_R)

/*! @brief Format value for bitfield USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R. */
#define BF_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R) & BM_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R)

/*! @brief Set the HS_USE_EXTERNAL_R field to a new value. */
#define BW_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R(x, v) (HW_USB_ANALOG_USB1_MISC_WR(x, (HW_USB_ANALOG_USB1_MISC_RD(x) & ~BM_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R) | BF_USB_ANALOG_USB1_MISC_HS_USE_EXTERNAL_R(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_MISC, field EN_DEGLITCH[1] (RW)
 *
 * Enable the deglitching circuit of the USB PLL output.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_MISC_EN_DEGLITCH (1U) /*!< Bit position for USB_ANALOG_USB1_MISC_EN_DEGLITCH. */
#define BM_USB_ANALOG_USB1_MISC_EN_DEGLITCH (0x00000002U) /*!< Bit mask for USB_ANALOG_USB1_MISC_EN_DEGLITCH. */
#define BS_USB_ANALOG_USB1_MISC_EN_DEGLITCH (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_MISC_EN_DEGLITCH. */

/*! @brief Read current value of the USB_ANALOG_USB1_MISC_EN_DEGLITCH field. */
#define BR_USB_ANALOG_USB1_MISC_EN_DEGLITCH(x) (HW_USB_ANALOG_USB1_MISC(x).B.EN_DEGLITCH)

/*! @brief Format value for bitfield USB_ANALOG_USB1_MISC_EN_DEGLITCH. */
#define BF_USB_ANALOG_USB1_MISC_EN_DEGLITCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_MISC_EN_DEGLITCH) & BM_USB_ANALOG_USB1_MISC_EN_DEGLITCH)

/*! @brief Set the EN_DEGLITCH field to a new value. */
#define BW_USB_ANALOG_USB1_MISC_EN_DEGLITCH(x, v) (HW_USB_ANALOG_USB1_MISC_WR(x, (HW_USB_ANALOG_USB1_MISC_RD(x) & ~BM_USB_ANALOG_USB1_MISC_EN_DEGLITCH) | BF_USB_ANALOG_USB1_MISC_EN_DEGLITCH(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB1_MISC, field EN_CLK_UTMI[30] (RW)
 *
 * Enables the clk to the UTMI block.
 */
/*@{*/
#define BP_USB_ANALOG_USB1_MISC_EN_CLK_UTMI (30U) /*!< Bit position for USB_ANALOG_USB1_MISC_EN_CLK_UTMI. */
#define BM_USB_ANALOG_USB1_MISC_EN_CLK_UTMI (0x40000000U) /*!< Bit mask for USB_ANALOG_USB1_MISC_EN_CLK_UTMI. */
#define BS_USB_ANALOG_USB1_MISC_EN_CLK_UTMI (1U) /*!< Bit field size in bits for USB_ANALOG_USB1_MISC_EN_CLK_UTMI. */

/*! @brief Read current value of the USB_ANALOG_USB1_MISC_EN_CLK_UTMI field. */
#define BR_USB_ANALOG_USB1_MISC_EN_CLK_UTMI(x) (HW_USB_ANALOG_USB1_MISC(x).B.EN_CLK_UTMI)

/*! @brief Format value for bitfield USB_ANALOG_USB1_MISC_EN_CLK_UTMI. */
#define BF_USB_ANALOG_USB1_MISC_EN_CLK_UTMI(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB1_MISC_EN_CLK_UTMI) & BM_USB_ANALOG_USB1_MISC_EN_CLK_UTMI)

/*! @brief Set the EN_CLK_UTMI field to a new value. */
#define BW_USB_ANALOG_USB1_MISC_EN_CLK_UTMI(x, v) (HW_USB_ANALOG_USB1_MISC_WR(x, (HW_USB_ANALOG_USB1_MISC_RD(x) & ~BM_USB_ANALOG_USB1_MISC_EN_CLK_UTMI) | BF_USB_ANALOG_USB1_MISC_EN_CLK_UTMI(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_USB2_VBUS_DETECT - USB VBUS Detect Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB2_VBUS_DETECT - USB VBUS Detect Register (RW)
 *
 * Reset value: 0x00100004U
 *
 * This register defines controls for USB VBUS detect.
 */
typedef union _hw_usb_analog_usb2_vbus_detect
{
    uint32_t U;
    struct _hw_usb_analog_usb2_vbus_detect_bitfields
    {
        uint32_t VBUSVALID_THRESH : 3; /*!< [2:0]  */
        uint32_t RESERVED0 : 17;       /*!< [19:3]  */
        uint32_t VBUSVALID_PWRUP_CMPS : 1; /*!< [20]  */
        uint32_t RESERVED1 : 5;        /*!< [25:21]  */
        uint32_t DISCHARGE_VBUS : 1;   /*!< [26]  */
        uint32_t CHARGE_VBUS : 1;      /*!< [27]  */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usb_analog_usb2_vbus_detect_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB2_VBUS_DETECT register
 */
/*@{*/
#define HW_USB_ANALOG_USB2_VBUS_DETECT_ADDR(x) ((uintptr_t)(x) + 0x200U)
#define HW_USB_ANALOG_USB2_VBUS_DETECT_SET_ADDR(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB2_VBUS_DETECT_CLR_ADDR(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB2_VBUS_DETECT_TOG_ADDR(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB2_VBUS_DETECT(x) (*(__IO hw_usb_analog_usb2_vbus_detect_t *) HW_USB_ANALOG_USB2_VBUS_DETECT_ADDR(x))
#define HW_USB_ANALOG_USB2_VBUS_DETECT_RD(x) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).U)
#define HW_USB_ANALOG_USB2_VBUS_DETECT_WR(x, v) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).U = (v))
#define HW_USB_ANALOG_USB2_VBUS_DETECT_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_VBUS_DETECT_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_VBUS_DETECT_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_VBUS_DETECT_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_VBUS_DETECT_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_VBUS_DETECT_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB2_VBUS_DETECT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT, field VBUSVALID_THRESH[2:0] (RW)
 *
 * Set the threshold for the VBUSVALID comparator. This comparator is the most
 * accurate method to determine the presence of 5v, and includes hystersis to
 * minimize the need for software debounce of the detection. This comparator has
 * ~50mV of hystersis to prevent chattering at the comparator trip point.
 *
 * Values:
 * - 000 - 4.0V
 * - 001 - 4.1V
 * - 010 - 4.2V
 * - 011 - 4.3V
 * - 100 - 4.4V (default)
 * - 101 - 4.5V
 * - 110 - 4.6V
 * - 111 - 4.7V
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH (0U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH (0x00000007U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH (3U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH. */

#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V0 (0U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.0V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V1 (0x1U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.1V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V2 (0x2U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.2V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V3 (0x3U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.3V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V4 (0x4U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.4V (default) */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V5 (0x5U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.5V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V6 (0x6U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.6V */
#define BV_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH_4V7 (0x7U) /*!< Bit field value for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH: 4.7V */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH(x) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).B.VBUSVALID_THRESH)

/*! @brief Format value for bitfield USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH. */
#define BF_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH) & BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH)

/*! @brief Set the VBUSVALID_THRESH field to a new value. */
#define BW_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH(x, v) (HW_USB_ANALOG_USB2_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB2_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH) | BF_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_THRESH(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT, field VBUSVALID_PWRUP_CMPS[20] (RW)
 *
 * Powers up comparators for vbus_valid detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (20U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (0x00100000U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(x) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).B.VBUSVALID_PWRUP_CMPS)

/*! @brief Format value for bitfield USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS. */
#define BF_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS) & BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS)

/*! @brief Set the VBUSVALID_PWRUP_CMPS field to a new value. */
#define BW_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(x, v) (HW_USB_ANALOG_USB2_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB2_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS) | BF_USB_ANALOG_USB2_VBUS_DETECT_VBUSVALID_PWRUP_CMPS(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT, field DISCHARGE_VBUS[26] (RW)
 *
 * USB OTG discharge VBUS.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS (26U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS (0x04000000U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS(x) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).B.DISCHARGE_VBUS)

/*! @brief Format value for bitfield USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS. */
#define BF_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS) & BM_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS)

/*! @brief Set the DISCHARGE_VBUS field to a new value. */
#define BW_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS(x, v) (HW_USB_ANALOG_USB2_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB2_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS) | BF_USB_ANALOG_USB2_VBUS_DETECT_DISCHARGE_VBUS(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT, field CHARGE_VBUS[27] (RW)
 *
 * USB OTG charge VBUS.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS (27U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS (0x08000000U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS(x) (HW_USB_ANALOG_USB2_VBUS_DETECT(x).B.CHARGE_VBUS)

/*! @brief Format value for bitfield USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS. */
#define BF_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS) & BM_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS)

/*! @brief Set the CHARGE_VBUS field to a new value. */
#define BW_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS(x, v) (HW_USB_ANALOG_USB2_VBUS_DETECT_WR(x, (HW_USB_ANALOG_USB2_VBUS_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS) | BF_USB_ANALOG_USB2_VBUS_DETECT_CHARGE_VBUS(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_USB2_CHRG_DETECT - USB Charger Detect Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB2_CHRG_DETECT - USB Charger Detect Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register defines controls for USB charger detect.
 */
typedef union _hw_usb_analog_usb2_chrg_detect
{
    uint32_t U;
    struct _hw_usb_analog_usb2_chrg_detect_bitfields
    {
        uint32_t RESERVED0 : 18;       /*!< [17:0]  */
        uint32_t CHK_CONTACT : 1;      /*!< [18]  */
        uint32_t CHK_CHRG_B : 1;       /*!< [19]  */
        uint32_t EN_B : 1;             /*!< [20]  */
        uint32_t RESERVED1 : 11;       /*!< [31:21]  */
    } B;
} hw_usb_analog_usb2_chrg_detect_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB2_CHRG_DETECT register
 */
/*@{*/
#define HW_USB_ANALOG_USB2_CHRG_DETECT_ADDR(x) ((uintptr_t)(x) + 0x210U)
#define HW_USB_ANALOG_USB2_CHRG_DETECT_SET_ADDR(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB2_CHRG_DETECT_CLR_ADDR(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB2_CHRG_DETECT_TOG_ADDR(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB2_CHRG_DETECT(x) (*(__IO hw_usb_analog_usb2_chrg_detect_t *) HW_USB_ANALOG_USB2_CHRG_DETECT_ADDR(x))
#define HW_USB_ANALOG_USB2_CHRG_DETECT_RD(x) (HW_USB_ANALOG_USB2_CHRG_DETECT(x).U)
#define HW_USB_ANALOG_USB2_CHRG_DETECT_WR(x, v) (HW_USB_ANALOG_USB2_CHRG_DETECT(x).U = (v))
#define HW_USB_ANALOG_USB2_CHRG_DETECT_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_CHRG_DETECT_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_CHRG_DETECT_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_CHRG_DETECT_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_CHRG_DETECT_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_CHRG_DETECT_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB2_CHRG_DETECT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT, field CHK_CONTACT[18] (RW)
 *
 * Values:
 * - 0 - Do not check the contact of USB plug.
 * - 1 - Check whether the USB plug has been in contact with each other
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT (18U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT (0x00040000U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT. */

#define BV_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT_NO_CHECK (0U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT: Do not check the contact of USB plug. */
#define BV_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT_CHECK (0x1U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT: Check whether the USB plug has been in contact with each other */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT(x) (HW_USB_ANALOG_USB2_CHRG_DETECT(x).B.CHK_CONTACT)

/*! @brief Format value for bitfield USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT. */
#define BF_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT) & BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT)

/*! @brief Set the CHK_CONTACT field to a new value. */
#define BW_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT(x, v) (HW_USB_ANALOG_USB2_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB2_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT) | BF_USB_ANALOG_USB2_CHRG_DETECT_CHK_CONTACT(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT, field CHK_CHRG_B[19] (RW)
 *
 * Values:
 * - 0 - Check whether a charger (either a dedicated charger or a host charger)
 *     is connected to USB port.
 * - 1 - Do not check whether a charger is connected to the USB port.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B (19U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B (0x00080000U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B. */

#define BV_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B_CHECK (0U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B: Check whether a charger (either a dedicated charger or a host charger) is connected to USB port. */
#define BV_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B_NO_CHECK (0x1U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B: Do not check whether a charger is connected to the USB port. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B(x) (HW_USB_ANALOG_USB2_CHRG_DETECT(x).B.CHK_CHRG_B)

/*! @brief Format value for bitfield USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B. */
#define BF_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B) & BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B)

/*! @brief Set the CHK_CHRG_B field to a new value. */
#define BW_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B(x, v) (HW_USB_ANALOG_USB2_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB2_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B) | BF_USB_ANALOG_USB2_CHRG_DETECT_CHK_CHRG_B(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT, field EN_B[20] (RW)
 *
 * Control the charger detector.
 *
 * Values:
 * - 0 - Enable the charger detector.
 * - 1 - Disable the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_EN_B (20U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_EN_B. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_EN_B (0x00100000U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_EN_B. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_EN_B (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_EN_B. */

#define BV_USB_ANALOG_USB2_CHRG_DETECT_EN_B_ENABLE (0U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_EN_B: Enable the charger detector. */
#define BV_USB_ANALOG_USB2_CHRG_DETECT_EN_B_DISABLE (0x1U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_EN_B: Disable the charger detector. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_EN_B field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_EN_B(x) (HW_USB_ANALOG_USB2_CHRG_DETECT(x).B.EN_B)

/*! @brief Format value for bitfield USB_ANALOG_USB2_CHRG_DETECT_EN_B. */
#define BF_USB_ANALOG_USB2_CHRG_DETECT_EN_B(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_CHRG_DETECT_EN_B) & BM_USB_ANALOG_USB2_CHRG_DETECT_EN_B)

/*! @brief Set the EN_B field to a new value. */
#define BW_USB_ANALOG_USB2_CHRG_DETECT_EN_B(x, v) (HW_USB_ANALOG_USB2_CHRG_DETECT_WR(x, (HW_USB_ANALOG_USB2_CHRG_DETECT_RD(x) & ~BM_USB_ANALOG_USB2_CHRG_DETECT_EN_B) | BF_USB_ANALOG_USB2_CHRG_DETECT_EN_B(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_USB2_VBUS_DETECT_STAT - USB VBUS Detect Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB2_VBUS_DETECT_STAT - USB VBUS Detect Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines fields for USB VBUS Detect status.
 */
typedef union _hw_usb_analog_usb2_vbus_detect_stat
{
    uint32_t U;
    struct _hw_usb_analog_usb2_vbus_detect_stat_bitfields
    {
        uint32_t SESSEND : 1;          /*!< [0]  */
        uint32_t BVALID : 1;           /*!< [1]  */
        uint32_t AVALID : 1;           /*!< [2]  */
        uint32_t VBUS_VALID : 1;       /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_analog_usb2_vbus_detect_stat_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB2_VBUS_DETECT_STAT register
 */
/*@{*/
#define HW_USB_ANALOG_USB2_VBUS_DETECT_STAT_ADDR(x) ((uintptr_t)(x) + 0x220U)

#define HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x) (*(__I hw_usb_analog_usb2_vbus_detect_stat_t *) HW_USB_ANALOG_USB2_VBUS_DETECT_STAT_ADDR(x))
#define HW_USB_ANALOG_USB2_VBUS_DETECT_STAT_RD(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB2_VBUS_DETECT_STAT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT_STAT, field SESSEND[0] (RO)
 *
 * Session End for USB OTG. This bit is a read only version of the state of the
 * analog signal. It can not be overwritten by software like the SESSEND bit
 * below. NOTE: This bit's default value depends on whether VDD5V is present, 0 if
 * VDD5V is present, 1 if VDD5V is not present.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND (0U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND (0x00000001U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_STAT_SESSEND(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x).B.SESSEND)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT_STAT, field BVALID[1] (RO)
 *
 * Indicates VBus is valid for a B-peripheral. This bit is a read only version
 * of the state of the analog signal. It can not be overritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID (1U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID (0x00000002U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_STAT_BVALID(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x).B.BVALID)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT_STAT, field AVALID[2] (RO)
 *
 * Indicates VBus is valid for a A-peripheral. This bit is a read only version
 * of the state of the analog signal. It can not be overritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID (2U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID (0x00000004U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_STAT_AVALID(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x).B.AVALID)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_VBUS_DETECT_STAT, field VBUS_VALID[3] (RO)
 *
 * VBus valid for USB OTG. This bit is a read only version of the state of the
 * analog signal. It can not be overwritten by software.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID (3U) /*!< Bit position for USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID. */
#define BM_USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID (0x00000008U) /*!< Bit mask for USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID. */
#define BS_USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID. */

/*! @brief Read current value of the USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID field. */
#define BR_USB_ANALOG_USB2_VBUS_DETECT_STAT_VBUS_VALID(x) (HW_USB_ANALOG_USB2_VBUS_DETECT_STAT(x).B.VBUS_VALID)
/*@}*/

/*******************************************************************************
 * HW_USB_ANALOG_USB2_CHRG_DETECT_STAT - USB Charger Detect Status Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB2_CHRG_DETECT_STAT - USB Charger Detect Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register defines fields for USB charger detect status.
 */
typedef union _hw_usb_analog_usb2_chrg_detect_stat
{
    uint32_t U;
    struct _hw_usb_analog_usb2_chrg_detect_stat_bitfields
    {
        uint32_t PLUG_CONTACT : 1;     /*!< [0]  */
        uint32_t CHRG_DETECTED : 1;    /*!< [1]  */
        uint32_t DM_STATE : 1;         /*!< [2]  */
        uint32_t DP_STATE : 1;         /*!< [3]  */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usb_analog_usb2_chrg_detect_stat_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB2_CHRG_DETECT_STAT register
 */
/*@{*/
#define HW_USB_ANALOG_USB2_CHRG_DETECT_STAT_ADDR(x) ((uintptr_t)(x) + 0x230U)

#define HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x) (*(__I hw_usb_analog_usb2_chrg_detect_stat_t *) HW_USB_ANALOG_USB2_CHRG_DETECT_STAT_ADDR(x))
#define HW_USB_ANALOG_USB2_CHRG_DETECT_STAT_RD(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB2_CHRG_DETECT_STAT bitfields
 */

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT_STAT, field PLUG_CONTACT[0] (RO)
 *
 * State of the USB plug contact detector.
 *
 * Values:
 * - 0 - The USB plug has not made contact.
 * - 1 - The USB plug has made good contact.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT (0U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT (0x00000001U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT. */

#define BV_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT_NO_CONTACT (0U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT: The USB plug has not made contact. */
#define BV_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT_GOOD_CONTACT (0x1U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT: The USB plug has made good contact. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_STAT_PLUG_CONTACT(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x).B.PLUG_CONTACT)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT_STAT, field CHRG_DETECTED[1] (RO)
 *
 * State of charger detection. This bit is a read only version of the state of
 * the analog signal.
 *
 * Values:
 * - 0 - The USB port is not connected to a charger.
 * - 1 - A charger (either a dedicated charger or a host charger) is connected
 *     to the USB port.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED (1U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED (0x00000002U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED. */

#define BV_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED_CHARGER_NOT_PRESENT (0U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED: The USB port is not connected to a charger. */
#define BV_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED_CHARGER_PRESENT (0x1U) /*!< Bit field value for USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED: A charger (either a dedicated charger or a host charger) is connected to the USB port. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_STAT_CHRG_DETECTED(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x).B.CHRG_DETECTED)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT_STAT, field DM_STATE[2] (RO)
 *
 * DM line state output of the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE (2U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE (0x00000004U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_STAT_DM_STATE(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x).B.DM_STATE)
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_CHRG_DETECT_STAT, field DP_STATE[3] (RO)
 *
 * DP line state output of the charger detector.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE (3U) /*!< Bit position for USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE. */
#define BM_USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE (0x00000008U) /*!< Bit mask for USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE. */
#define BS_USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE. */

/*! @brief Read current value of the USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE field. */
#define BR_USB_ANALOG_USB2_CHRG_DETECT_STAT_DP_STATE(x) (HW_USB_ANALOG_USB2_CHRG_DETECT_STAT(x).B.DP_STATE)
/*@}*/

/*******************************************************************************
 * HW_USB_ANALOG_USB2_MISC - USB Misc Register
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_USB2_MISC - USB Misc Register (RW)
 *
 * Reset value: 0x00000002U
 *
 * This register defines controls for USB.
 */
typedef union _hw_usb_analog_usb2_misc
{
    uint32_t U;
    struct _hw_usb_analog_usb2_misc_bitfields
    {
        uint32_t HS_USE_EXTERNAL_R : 1; /*!< [0]  */
        uint32_t EN_DEGLITCH : 1;      /*!< [1]  */
        uint32_t RESERVED0 : 28;       /*!< [29:2]  */
        uint32_t EN_CLK_UTMI : 1;      /*!< [30]  */
        uint32_t RESERVED1 : 1;        /*!< [31]  */
    } B;
} hw_usb_analog_usb2_misc_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_USB2_MISC register
 */
/*@{*/
#define HW_USB_ANALOG_USB2_MISC_ADDR(x) ((uintptr_t)(x) + 0x250U)
#define HW_USB_ANALOG_USB2_MISC_SET_ADDR(x) (HW_USB_ANALOG_USB2_MISC_ADDR(x) + 0x4U)
#define HW_USB_ANALOG_USB2_MISC_CLR_ADDR(x) (HW_USB_ANALOG_USB2_MISC_ADDR(x) + 0x8U)
#define HW_USB_ANALOG_USB2_MISC_TOG_ADDR(x) (HW_USB_ANALOG_USB2_MISC_ADDR(x) + 0xCU)

#define HW_USB_ANALOG_USB2_MISC(x) (*(__IO hw_usb_analog_usb2_misc_t *) HW_USB_ANALOG_USB2_MISC_ADDR(x))
#define HW_USB_ANALOG_USB2_MISC_RD(x) (HW_USB_ANALOG_USB2_MISC(x).U)
#define HW_USB_ANALOG_USB2_MISC_WR(x, v) (HW_USB_ANALOG_USB2_MISC(x).U = (v))
#define HW_USB_ANALOG_USB2_MISC_SET(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_MISC_SET_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_MISC_CLR(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_MISC_CLR_ADDR(x)) = (v))
#define HW_USB_ANALOG_USB2_MISC_TOG(x, v) ((*(uint32_t *) HW_USB_ANALOG_USB2_MISC_TOG_ADDR(x)) = (v))
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_USB2_MISC bitfields
 */

/*!
 * @name Register USB_ANALOG_USB2_MISC, field HS_USE_EXTERNAL_R[0] (RW)
 *
 * Use external resistor to generate the current bias for the high speed
 * transmitter. This bit should not be changed unless recommended by Freescale.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R (0U) /*!< Bit position for USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R. */
#define BM_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R (0x00000001U) /*!< Bit mask for USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R. */
#define BS_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R. */

/*! @brief Read current value of the USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R field. */
#define BR_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R(x) (HW_USB_ANALOG_USB2_MISC(x).B.HS_USE_EXTERNAL_R)

/*! @brief Format value for bitfield USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R. */
#define BF_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R) & BM_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R)

/*! @brief Set the HS_USE_EXTERNAL_R field to a new value. */
#define BW_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R(x, v) (HW_USB_ANALOG_USB2_MISC_WR(x, (HW_USB_ANALOG_USB2_MISC_RD(x) & ~BM_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R) | BF_USB_ANALOG_USB2_MISC_HS_USE_EXTERNAL_R(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_MISC, field EN_DEGLITCH[1] (RW)
 *
 * Enable the deglitching circuit of the USB PLL output.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_MISC_EN_DEGLITCH (1U) /*!< Bit position for USB_ANALOG_USB2_MISC_EN_DEGLITCH. */
#define BM_USB_ANALOG_USB2_MISC_EN_DEGLITCH (0x00000002U) /*!< Bit mask for USB_ANALOG_USB2_MISC_EN_DEGLITCH. */
#define BS_USB_ANALOG_USB2_MISC_EN_DEGLITCH (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_MISC_EN_DEGLITCH. */

/*! @brief Read current value of the USB_ANALOG_USB2_MISC_EN_DEGLITCH field. */
#define BR_USB_ANALOG_USB2_MISC_EN_DEGLITCH(x) (HW_USB_ANALOG_USB2_MISC(x).B.EN_DEGLITCH)

/*! @brief Format value for bitfield USB_ANALOG_USB2_MISC_EN_DEGLITCH. */
#define BF_USB_ANALOG_USB2_MISC_EN_DEGLITCH(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_MISC_EN_DEGLITCH) & BM_USB_ANALOG_USB2_MISC_EN_DEGLITCH)

/*! @brief Set the EN_DEGLITCH field to a new value. */
#define BW_USB_ANALOG_USB2_MISC_EN_DEGLITCH(x, v) (HW_USB_ANALOG_USB2_MISC_WR(x, (HW_USB_ANALOG_USB2_MISC_RD(x) & ~BM_USB_ANALOG_USB2_MISC_EN_DEGLITCH) | BF_USB_ANALOG_USB2_MISC_EN_DEGLITCH(v)))
/*@}*/

/*!
 * @name Register USB_ANALOG_USB2_MISC, field EN_CLK_UTMI[30] (RW)
 *
 * Enables the clk to the UTMI block.
 */
/*@{*/
#define BP_USB_ANALOG_USB2_MISC_EN_CLK_UTMI (30U) /*!< Bit position for USB_ANALOG_USB2_MISC_EN_CLK_UTMI. */
#define BM_USB_ANALOG_USB2_MISC_EN_CLK_UTMI (0x40000000U) /*!< Bit mask for USB_ANALOG_USB2_MISC_EN_CLK_UTMI. */
#define BS_USB_ANALOG_USB2_MISC_EN_CLK_UTMI (1U) /*!< Bit field size in bits for USB_ANALOG_USB2_MISC_EN_CLK_UTMI. */

/*! @brief Read current value of the USB_ANALOG_USB2_MISC_EN_CLK_UTMI field. */
#define BR_USB_ANALOG_USB2_MISC_EN_CLK_UTMI(x) (HW_USB_ANALOG_USB2_MISC(x).B.EN_CLK_UTMI)

/*! @brief Format value for bitfield USB_ANALOG_USB2_MISC_EN_CLK_UTMI. */
#define BF_USB_ANALOG_USB2_MISC_EN_CLK_UTMI(v) ((uint32_t)((uint32_t)(v) << BP_USB_ANALOG_USB2_MISC_EN_CLK_UTMI) & BM_USB_ANALOG_USB2_MISC_EN_CLK_UTMI)

/*! @brief Set the EN_CLK_UTMI field to a new value. */
#define BW_USB_ANALOG_USB2_MISC_EN_CLK_UTMI(x, v) (HW_USB_ANALOG_USB2_MISC_WR(x, (HW_USB_ANALOG_USB2_MISC_RD(x) & ~BM_USB_ANALOG_USB2_MISC_EN_CLK_UTMI) | BF_USB_ANALOG_USB2_MISC_EN_CLK_UTMI(v)))
/*@}*/




/*******************************************************************************
 * HW_USB_ANALOG_DIGPROG - Chip Silicon Version
 ******************************************************************************/

/*!
 * @brief HW_USB_ANALOG_DIGPROG - Chip Silicon Version (RO)
 *
 * Reset value: 0x00000000U
 *
 * The DIGPROG register returns the digital program ID for the silicon.
 */
typedef union _hw_usb_analog_digprog
{
    uint32_t U;
    struct _hw_usb_analog_digprog_bitfields
    {
        uint32_t MINOR : 8;            /*!< [7:0]  */
        uint32_t MAJOR_LOWER : 8;      /*!< [15:8]  */
        uint32_t MAJOR_UPPER : 8;      /*!< [23:16]  */
        uint32_t RESERVED0 : 8;        /*!< [31:24]  */
    } B;
} hw_usb_analog_digprog_t;

/*!
 * @name Constants and macros for entire USB_ANALOG_DIGPROG register
 */
/*@{*/
#define HW_USB_ANALOG_DIGPROG_ADDR(x) ((uintptr_t)(x) + 0x260U)

#define HW_USB_ANALOG_DIGPROG(x) (*(__I hw_usb_analog_digprog_t *) HW_USB_ANALOG_DIGPROG_ADDR(x))
#define HW_USB_ANALOG_DIGPROG_RD(x) (HW_USB_ANALOG_DIGPROG(x).U)
/*@}*/

/*
 * Constants & macros for individual USB_ANALOG_DIGPROG bitfields
 */

/*!
 * @name Register USB_ANALOG_DIGPROG, field MINOR[7:0] (RO)
 *
 * MINOR lower byte - Read-only value representing a minor silicon revision.
 *
 * Values:
 * - 0 - silicon revision x.0
 * - 1 - silicon revision x.1
 * - 10 - silicon revision x.2
 */
/*@{*/
#define BP_USB_ANALOG_DIGPROG_MINOR (0U)   /*!< Bit position for USB_ANALOG_DIGPROG_MINOR. */
#define BM_USB_ANALOG_DIGPROG_MINOR (0x000000FFU) /*!< Bit mask for USB_ANALOG_DIGPROG_MINOR. */
#define BS_USB_ANALOG_DIGPROG_MINOR (8U)   /*!< Bit field size in bits for USB_ANALOG_DIGPROG_MINOR. */

/*! @brief Read current value of the USB_ANALOG_DIGPROG_MINOR field. */
#define BR_USB_ANALOG_DIGPROG_MINOR(x) (HW_USB_ANALOG_DIGPROG(x).B.MINOR)
/*@}*/

/*!
 * @name Register USB_ANALOG_DIGPROG, field MAJOR_LOWER[15:8] (RO)
 *
 * MAJOR lower byte - Read-only value representing a major silicon revision.
 *
 * Values:
 * - 0 - silicon revision 1.x
 * - 1 - silicon revision 2.x
 */
/*@{*/
#define BP_USB_ANALOG_DIGPROG_MAJOR_LOWER (8U) /*!< Bit position for USB_ANALOG_DIGPROG_MAJOR_LOWER. */
#define BM_USB_ANALOG_DIGPROG_MAJOR_LOWER (0x0000FF00U) /*!< Bit mask for USB_ANALOG_DIGPROG_MAJOR_LOWER. */
#define BS_USB_ANALOG_DIGPROG_MAJOR_LOWER (8U) /*!< Bit field size in bits for USB_ANALOG_DIGPROG_MAJOR_LOWER. */

/*! @brief Read current value of the USB_ANALOG_DIGPROG_MAJOR_LOWER field. */
#define BR_USB_ANALOG_DIGPROG_MAJOR_LOWER(x) (HW_USB_ANALOG_DIGPROG(x).B.MAJOR_LOWER)
/*@}*/

/*!
 * @name Register USB_ANALOG_DIGPROG, field MAJOR_UPPER[23:16] (RO)
 *
 * MAJOR upper byte-Read-only value representing the chip type.
 *
 * Values:
 * - 1100011 - i.MX 6Dual/6Quad
 * - 1100100 - i.MX 6UltraLite
 */
/*@{*/
#define BP_USB_ANALOG_DIGPROG_MAJOR_UPPER (16U) /*!< Bit position for USB_ANALOG_DIGPROG_MAJOR_UPPER. */
#define BM_USB_ANALOG_DIGPROG_MAJOR_UPPER (0x00FF0000U) /*!< Bit mask for USB_ANALOG_DIGPROG_MAJOR_UPPER. */
#define BS_USB_ANALOG_DIGPROG_MAJOR_UPPER (8U) /*!< Bit field size in bits for USB_ANALOG_DIGPROG_MAJOR_UPPER. */

/*! @brief Read current value of the USB_ANALOG_DIGPROG_MAJOR_UPPER field. */
#define BR_USB_ANALOG_DIGPROG_MAJOR_UPPER(x) (HW_USB_ANALOG_DIGPROG(x).B.MAJOR_UPPER)
/*@}*/

/*******************************************************************************
 * hw_usb_analog_t - module struct
 ******************************************************************************/
/*!
 * @brief All USB_ANALOG module registers.
 */
#pragma pack(1)
typedef struct _hw_usb_analog
{
    uint8_t _reserved0[416];
    __IO hw_usb_analog_usb1_vbus_detect_t USB1_VBUS_DETECT; /*!< [0x1A0] USB VBUS Detect Register */
    uint8_t _reserved1[12];
    __IO hw_usb_analog_usb1_chrg_detect_t USB1_CHRG_DETECT; /*!< [0x1B0] USB Charger Detect Register */
    uint8_t _reserved2[12];
    __I hw_usb_analog_usb1_vbus_detect_stat_t USB1_VBUS_DETECT_STAT; /*!< [0x1C0] USB VBUS Detect Status Register */
    uint8_t _reserved3[12];
    __I hw_usb_analog_usb1_chrg_detect_stat_t USB1_CHRG_DETECT_STAT; /*!< [0x1D0] USB Charger Detect Status Register */
    uint8_t _reserved4[28];
    __IO hw_usb_analog_usb1_misc_t USB1_MISC; /*!< [0x1F0] USB Misc Register */
    uint8_t _reserved5[12];
    __IO hw_usb_analog_usb2_vbus_detect_t USB2_VBUS_DETECT; /*!< [0x200] USB VBUS Detect Register */
    uint8_t _reserved6[12];
    __IO hw_usb_analog_usb2_chrg_detect_t USB2_CHRG_DETECT; /*!< [0x210] USB Charger Detect Register */
    uint8_t _reserved7[12];
    __I hw_usb_analog_usb2_vbus_detect_stat_t USB2_VBUS_DETECT_STAT; /*!< [0x220] USB VBUS Detect Status Register */
    uint8_t _reserved8[12];
    __I hw_usb_analog_usb2_chrg_detect_stat_t USB2_CHRG_DETECT_STAT; /*!< [0x230] USB Charger Detect Status Register */
    uint8_t _reserved9[28];
    __IO hw_usb_analog_usb2_misc_t USB2_MISC; /*!< [0x250] USB Misc Register */
    uint8_t _reserved10[12];
    __I hw_usb_analog_digprog_t DIGPROG;   /*!< [0x260] Chip Silicon Version */
} hw_usb_analog_t;
#pragma pack()

/*! @brief Macro to access all USB_ANALOG registers. */
/*! @param x USB_ANALOG module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_USB_ANALOG_REGS(USB_ANALOG_BASE)</code>. */
#define HW_USB_ANALOG_REGS(x) (*(hw_usb_analog_t *)(x))

/*
 * iMX6DP VDOA
 *
 * VDOA
 *
 * Registers defined in this header file:
 * - HW_VDOA_VDOAC - VDOA Control Register
 * - HW_VDOA_VDOASRR - VDOA Start and Reset
 * - HW_VDOA_VDOAIE - VDOA Interrupt Enable Register
 * - HW_VDOA_VDOAIST - VDOA Interrupt Status Register
 * - HW_VDOA_VDOAFP - VDOA Frame Parameters Register
 * - HW_VDOA_VDOAIEBA00 - VDOA IPU External Buffer 0 Frame 0 Address Register
 * - HW_VDOA_VDOAIEBA01 - VDOA IPU External Buffer 0 Frame 1 Address Register
 * - HW_VDOA_VDOAIEBA02 - VDOA IPU External Buffer 0 Frame 2 Address Register
 * - HW_VDOA_VDOAIEBA10 - VDOA IPU External Buffer 1 Frame 0 Address Register
 * - HW_VDOA_VDOAIEBA11 - VDOA IPU External Buffer 1 Frame 1 Address Register
 * - HW_VDOA_VDOAIEBA12 - VDOA IPU External Buffer 1 Frame 2 Address Register
 * - HW_VDOA_VDOASL - VDOA IPU Stride Line Register
 * - HW_VDOA_VDOAIUBO - VDOA IPU U (Chroma) Buffer Offset Register
 * - HW_VDOA_VDOAVEBA0 - VDOA VPU External Buffer 0 Address Register
 * - HW_VDOA_VDOAVEBA1 - VDOA VPU External Buffer 1 Address Register
 * - HW_VDOA_VDOAVEBA2 - VDOA VPU External Buffer 2 Address Register
 * - HW_VDOA_VDOAVUBO - VDOA VPU U (Chroma) Buffer Offset Register
 * - HW_VDOA_VDOASR - VDOA Status Register
 *
 * - hw_vdoa_t - Struct containing all module registers.
 */

#define HW_VDOA_INSTANCE_COUNT (1U) /*!< Number of instances of the VDOA module. */
#define HW_VDOA (0U) /*!< Instance number for VDOA. */
#define VDOA_BASE             (0x21E4000U) /*!< Base address for VDOA. */
/*! Array initializer of VDOA base addresses. */
#define VDOA_BASE_ADDRS       { VDOA_BASE }

/*******************************************************************************
 * HW_VDOA_VDOAC - VDOA Control Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAC - VDOA Control Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoac
{
    uint32_t U;
    struct _hw_vdoa_vdoac_bitfields
    {
        uint32_t BNDM : 2;             /*!< [1:0]  */
        uint32_t NF : 1;               /*!< [2]  */
        uint32_t SYNC : 1;             /*!< [3]  */
        uint32_t SO : 1;               /*!< [4]  */
        uint32_t PFS : 1;              /*!< [5]  */
        uint32_t ISEL : 1;             /*!< [6]  */
        uint32_t RESERVED0 : 25;       /*!< [31:7]  */
    } B;
} hw_vdoa_vdoac_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAC register
 */
/*@{*/
#define HW_VDOA_VDOAC_ADDR(x)    ((uintptr_t)(x) + 0x0U)

#define HW_VDOA_VDOAC(x)         (*(__IO hw_vdoa_vdoac_t *) HW_VDOA_VDOAC_ADDR(x))
#define HW_VDOA_VDOAC_RD(x)      (HW_VDOA_VDOAC(x).U)
#define HW_VDOA_VDOAC_WR(x, v)   (HW_VDOA_VDOAC(x).U = (v))
#define HW_VDOA_VDOAC_SET(x, v)  (HW_VDOA_VDOAC_WR(x, HW_VDOA_VDOAC_RD(x) |  (v)))
#define HW_VDOA_VDOAC_CLR(x, v)  (HW_VDOA_VDOAC_WR(x, HW_VDOA_VDOAC_RD(x) & ~(v)))
#define HW_VDOA_VDOAC_TOG(x, v)  (HW_VDOA_VDOAC_WR(x, HW_VDOA_VDOAC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAC bitfields
 */

/*!
 * @name Register VDOA_VDOAC, field BNDM[1:0] (RW)
 *
 * BNDM Band Size
 *
 * Values:
 * - 00 - Band height = 8 lines.- Supported only for interlaced scan (SO=1)
 * - 01 - Band height = 16 lines.
 * - 10 - Band height = 32 lines.
 * - 11 - reserved
 */
/*@{*/
#define BP_VDOA_VDOAC_BNDM   (0U)          /*!< Bit position for VDOA_VDOAC_BNDM. */
#define BM_VDOA_VDOAC_BNDM   (0x00000003U) /*!< Bit mask for VDOA_VDOAC_BNDM. */
#define BS_VDOA_VDOAC_BNDM   (2U)          /*!< Bit field size in bits for VDOA_VDOAC_BNDM. */

#define BV_VDOA_VDOAC_BNDM_BAND_HEIGHT_8 (0U)        /*!< Bit field value for VDOA_VDOAC_BNDM: Band height = 8 lines.- Supported only for interlaced scan (SO=1) */
#define BV_VDOA_VDOAC_BNDM_BAND_HEIGHT_16 (0x1U)     /*!< Bit field value for VDOA_VDOAC_BNDM: Band height = 16 lines. */
#define BV_VDOA_VDOAC_BNDM_BAND_HEIGHT_32 (0x2U)     /*!< Bit field value for VDOA_VDOAC_BNDM: Band height = 32 lines. */

/*! @brief Read current value of the VDOA_VDOAC_BNDM field. */
#define BR_VDOA_VDOAC_BNDM(x) (HW_VDOA_VDOAC(x).B.BNDM)

/*! @brief Format value for bitfield VDOA_VDOAC_BNDM. */
#define BF_VDOA_VDOAC_BNDM(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_BNDM) & BM_VDOA_VDOAC_BNDM)

/*! @brief Set the BNDM field to a new value. */
#define BW_VDOA_VDOAC_BNDM(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_BNDM) | BF_VDOA_VDOAC_BNDM(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAC, field NF[2] (RW)
 *
 * Number of frames - Determines whether to transfer 1 frame or three frames
 *
 * Values:
 * - 0 - One frame (default)
 * - 1 - Three frames
 */
/*@{*/
#define BP_VDOA_VDOAC_NF     (2U)          /*!< Bit position for VDOA_VDOAC_NF. */
#define BM_VDOA_VDOAC_NF     (0x00000004U) /*!< Bit mask for VDOA_VDOAC_NF. */
#define BS_VDOA_VDOAC_NF     (1U)          /*!< Bit field size in bits for VDOA_VDOAC_NF. */

#define BV_VDOA_VDOAC_NF_1_FRAME       (0U)          /*!< Bit field value for VDOA_VDOAC_NF: One frame (default) */
#define BV_VDOA_VDOAC_NF_3_FRAMES      (0x1U)        /*!< Bit field value for VDOA_VDOAC_NF: Three frames */

/*! @brief Read current value of the VDOA_VDOAC_NF field. */
#define BR_VDOA_VDOAC_NF(x)  (HW_VDOA_VDOAC(x).B.NF)

/*! @brief Format value for bitfield VDOA_VDOAC_NF. */
#define BF_VDOA_VDOAC_NF(v)  ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_NF) & BM_VDOA_VDOAC_NF)

/*! @brief Set the NF field to a new value. */
#define BW_VDOA_VDOAC_NF(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_NF) | BF_VDOA_VDOAC_NF(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAC, field SYNC[3] (RW)
 *
 * SYNC MODE - defines whether the VDOA will transfer a full frame (or 2 frames)
 * continuously or will transfer a band at a time and wait for IPU signal to
 * continue
 *
 * Values:
 * - 0 - None SYNC mode (default)
 * - 1 - Sync mode
 */
/*@{*/
#define BP_VDOA_VDOAC_SYNC   (3U)          /*!< Bit position for VDOA_VDOAC_SYNC. */
#define BM_VDOA_VDOAC_SYNC   (0x00000008U) /*!< Bit mask for VDOA_VDOAC_SYNC. */
#define BS_VDOA_VDOAC_SYNC   (1U)          /*!< Bit field size in bits for VDOA_VDOAC_SYNC. */

#define BV_VDOA_VDOAC_SYNC_NO_SYNC_MODE (0U)         /*!< Bit field value for VDOA_VDOAC_SYNC: None SYNC mode (default) */
#define BV_VDOA_VDOAC_SYNC_SYNC_MODE   (0x1U)        /*!< Bit field value for VDOA_VDOAC_SYNC: Sync mode */

/*! @brief Read current value of the VDOA_VDOAC_SYNC field. */
#define BR_VDOA_VDOAC_SYNC(x) (HW_VDOA_VDOAC(x).B.SYNC)

/*! @brief Format value for bitfield VDOA_VDOAC_SYNC. */
#define BF_VDOA_VDOAC_SYNC(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_SYNC) & BM_VDOA_VDOAC_SYNC)

/*! @brief Set the SYNC field to a new value. */
#define BW_VDOA_VDOAC_SYNC(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_SYNC) | BF_VDOA_VDOAC_SYNC(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAC, field SO[4] (RW)
 *
 * Scan Order
 *
 * Values:
 * - 0 - Scan order is progressive
 * - 1 - Scan order is interlaced
 */
/*@{*/
#define BP_VDOA_VDOAC_SO     (4U)          /*!< Bit position for VDOA_VDOAC_SO. */
#define BM_VDOA_VDOAC_SO     (0x00000010U) /*!< Bit mask for VDOA_VDOAC_SO. */
#define BS_VDOA_VDOAC_SO     (1U)          /*!< Bit field size in bits for VDOA_VDOAC_SO. */

#define BV_VDOA_VDOAC_SO_PROGRESSIVE   (0U)          /*!< Bit field value for VDOA_VDOAC_SO: Scan order is progressive */
#define BV_VDOA_VDOAC_SO_INTERLACED    (0x1U)        /*!< Bit field value for VDOA_VDOAC_SO: Scan order is interlaced */

/*! @brief Read current value of the VDOA_VDOAC_SO field. */
#define BR_VDOA_VDOAC_SO(x)  (HW_VDOA_VDOAC(x).B.SO)

/*! @brief Format value for bitfield VDOA_VDOAC_SO. */
#define BF_VDOA_VDOAC_SO(v)  ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_SO) & BM_VDOA_VDOAC_SO)

/*! @brief Set the SO field to a new value. */
#define BW_VDOA_VDOAC_SO(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_SO) | BF_VDOA_VDOAC_SO(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAC, field PFS[5] (RW)
 *
 * Pixel Format Select - Pixel format of data written to / read from IPU. Note
 * Data from VPU is always assumed to have partial interleaved 4:2:0 format
 *
 * Values:
 * - 0 - partialy interleaved 4:2:0
 * - 1 - interleaved 4:2:2 Y1U1Y2V1
 */
/*@{*/
#define BP_VDOA_VDOAC_PFS    (5U)          /*!< Bit position for VDOA_VDOAC_PFS. */
#define BM_VDOA_VDOAC_PFS    (0x00000020U) /*!< Bit mask for VDOA_VDOAC_PFS. */
#define BS_VDOA_VDOAC_PFS    (1U)          /*!< Bit field size in bits for VDOA_VDOAC_PFS. */

#define BV_VDOA_VDOAC_PFS_4_2_0        (0U)          /*!< Bit field value for VDOA_VDOAC_PFS: partialy interleaved 4:2:0 */
#define BV_VDOA_VDOAC_PFS_4_2_2        (0x1U)        /*!< Bit field value for VDOA_VDOAC_PFS: interleaved 4:2:2 Y1U1Y2V1 */

/*! @brief Read current value of the VDOA_VDOAC_PFS field. */
#define BR_VDOA_VDOAC_PFS(x) (HW_VDOA_VDOAC(x).B.PFS)

/*! @brief Format value for bitfield VDOA_VDOAC_PFS. */
#define BF_VDOA_VDOAC_PFS(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_PFS) & BM_VDOA_VDOAC_PFS)

/*! @brief Set the PFS field to a new value. */
#define BW_VDOA_VDOAC_PFS(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_PFS) | BF_VDOA_VDOAC_PFS(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAC, field ISEL[6] (RW)
 *
 * IPU SELECT - determines in sync mode which of the two sets of hand shake pins
 * is used
 *
 * Values:
 * - 0 - Use vdoa_buf_rdy[0] and ipu_buf_eob[0]
 * - 1 - Use vdoa_buf_rdy[1] and ipu_buf_eob[1]
 */
/*@{*/
#define BP_VDOA_VDOAC_ISEL   (6U)          /*!< Bit position for VDOA_VDOAC_ISEL. */
#define BM_VDOA_VDOAC_ISEL   (0x00000040U) /*!< Bit mask for VDOA_VDOAC_ISEL. */
#define BS_VDOA_VDOAC_ISEL   (1U)          /*!< Bit field size in bits for VDOA_VDOAC_ISEL. */

#define BV_VDOA_VDOAC_ISEL_vdoa_buf_rdy_and_ipu_buf_eob_0 (0U) /*!< Bit field value for VDOA_VDOAC_ISEL: Use vdoa_buf_rdy[0] and ipu_buf_eob[0] */
#define BV_VDOA_VDOAC_ISEL_vdoa_buf_rdy_and_ipu_buf_eob_1 (0x1U) /*!< Bit field value for VDOA_VDOAC_ISEL: Use vdoa_buf_rdy[1] and ipu_buf_eob[1] */

/*! @brief Read current value of the VDOA_VDOAC_ISEL field. */
#define BR_VDOA_VDOAC_ISEL(x) (HW_VDOA_VDOAC(x).B.ISEL)

/*! @brief Format value for bitfield VDOA_VDOAC_ISEL. */
#define BF_VDOA_VDOAC_ISEL(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAC_ISEL) & BM_VDOA_VDOAC_ISEL)

/*! @brief Set the ISEL field to a new value. */
#define BW_VDOA_VDOAC_ISEL(x, v) (HW_VDOA_VDOAC_WR(x, (HW_VDOA_VDOAC_RD(x) & ~BM_VDOA_VDOAC_ISEL) | BF_VDOA_VDOAC_ISEL(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOASRR - VDOA Start and Reset
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOASRR - VDOA Start and Reset (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoasrr
{
    uint32_t U;
    struct _hw_vdoa_vdoasrr_bitfields
    {
        uint32_t SWRST : 1;            /*!< [0]  */
        uint32_t Start : 1;            /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_vdoa_vdoasrr_t;

/*!
 * @name Constants and macros for entire VDOA_VDOASRR register
 */
/*@{*/
#define HW_VDOA_VDOASRR_ADDR(x)  ((uintptr_t)(x) + 0x4U)

#define HW_VDOA_VDOASRR(x)       (*(__IO hw_vdoa_vdoasrr_t *) HW_VDOA_VDOASRR_ADDR(x))
#define HW_VDOA_VDOASRR_RD(x)    (HW_VDOA_VDOASRR(x).U)
#define HW_VDOA_VDOASRR_WR(x, v) (HW_VDOA_VDOASRR(x).U = (v))
#define HW_VDOA_VDOASRR_SET(x, v) (HW_VDOA_VDOASRR_WR(x, HW_VDOA_VDOASRR_RD(x) |  (v)))
#define HW_VDOA_VDOASRR_CLR(x, v) (HW_VDOA_VDOASRR_WR(x, HW_VDOA_VDOASRR_RD(x) & ~(v)))
#define HW_VDOA_VDOASRR_TOG(x, v) (HW_VDOA_VDOASRR_WR(x, HW_VDOA_VDOASRR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOASRR bitfields
 */

/*!
 * @name Register VDOA_VDOASRR, field SWRST[0] (RW)
 *
 * Software reset - Finish outstanding AXI transfer and reset all internal
 * registers the configuration registers are mnot cleared
 */
/*@{*/
#define BP_VDOA_VDOASRR_SWRST (0U)         /*!< Bit position for VDOA_VDOASRR_SWRST. */
#define BM_VDOA_VDOASRR_SWRST (0x00000001U) /*!< Bit mask for VDOA_VDOASRR_SWRST. */
#define BS_VDOA_VDOASRR_SWRST (1U)         /*!< Bit field size in bits for VDOA_VDOASRR_SWRST. */

/*! @brief Read current value of the VDOA_VDOASRR_SWRST field. */
#define BR_VDOA_VDOASRR_SWRST(x) (HW_VDOA_VDOASRR(x).B.SWRST)

/*! @brief Format value for bitfield VDOA_VDOASRR_SWRST. */
#define BF_VDOA_VDOASRR_SWRST(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOASRR_SWRST) & BM_VDOA_VDOASRR_SWRST)

/*! @brief Set the SWRST field to a new value. */
#define BW_VDOA_VDOASRR_SWRST(x, v) (HW_VDOA_VDOASRR_WR(x, (HW_VDOA_VDOASRR_RD(x) & ~BM_VDOA_VDOASRR_SWRST) | BF_VDOA_VDOASRR_SWRST(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOASRR, field Start[1] (RW)
 *
 * Start Transfer - Strat a VDOA data transfer according to all parameters.
 * Note: During run this bit is read only In IDLE -
 *
 * Values:
 * - 0 - Ignored
 * - 1 - Start a new transfer All registers we copied internally so any write to
 *     them will take place only in next transfer (double buffer)
 */
/*@{*/
#define BP_VDOA_VDOASRR_Start (1U)         /*!< Bit position for VDOA_VDOASRR_Start. */
#define BM_VDOA_VDOASRR_Start (0x00000002U) /*!< Bit mask for VDOA_VDOASRR_Start. */
#define BS_VDOA_VDOASRR_Start (1U)         /*!< Bit field size in bits for VDOA_VDOASRR_Start. */

#define BV_VDOA_VDOASRR_Start_START_TRANSFER (0x1U)  /*!< Bit field value for VDOA_VDOASRR_Start: Start a new transfer All registers we copied internally so any write to them will take place only in next transfer (double buffer) */

/*! @brief Read current value of the VDOA_VDOASRR_Start field. */
#define BR_VDOA_VDOASRR_Start(x) (HW_VDOA_VDOASRR(x).B.Start)

/*! @brief Format value for bitfield VDOA_VDOASRR_Start. */
#define BF_VDOA_VDOASRR_Start(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOASRR_Start) & BM_VDOA_VDOASRR_Start)

/*! @brief Set the Start field to a new value. */
#define BW_VDOA_VDOASRR_Start(x, v) (HW_VDOA_VDOASRR_WR(x, (HW_VDOA_VDOASRR_RD(x) & ~BM_VDOA_VDOASRR_Start) | BF_VDOA_VDOASRR_Start(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIE - VDOA Interrupt Enable Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIE - VDOA Interrupt Enable Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaie
{
    uint32_t U;
    struct _hw_vdoa_vdoaie_bitfields
    {
        uint32_t EIEOT : 1;            /*!< [0]  */
        uint32_t EITERR : 1;           /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_vdoa_vdoaie_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIE register
 */
/*@{*/
#define HW_VDOA_VDOAIE_ADDR(x)   ((uintptr_t)(x) + 0x8U)

#define HW_VDOA_VDOAIE(x)        (*(__IO hw_vdoa_vdoaie_t *) HW_VDOA_VDOAIE_ADDR(x))
#define HW_VDOA_VDOAIE_RD(x)     (HW_VDOA_VDOAIE(x).U)
#define HW_VDOA_VDOAIE_WR(x, v)  (HW_VDOA_VDOAIE(x).U = (v))
#define HW_VDOA_VDOAIE_SET(x, v) (HW_VDOA_VDOAIE_WR(x, HW_VDOA_VDOAIE_RD(x) |  (v)))
#define HW_VDOA_VDOAIE_CLR(x, v) (HW_VDOA_VDOAIE_WR(x, HW_VDOA_VDOAIE_RD(x) & ~(v)))
#define HW_VDOA_VDOAIE_TOG(x, v) (HW_VDOA_VDOAIE_WR(x, HW_VDOA_VDOAIE_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIE bitfields
 */

/*!
 * @name Register VDOA_VDOAIE, field EIEOT[0] (RW)
 *
 * EIEOT - Enable Interrupt End Of Transfer- Enables Interrupt on end of transfer
 *
 * Values:
 * - 0 - interrupt disable (default)
 * - 1 - Interrupt Enabled
 */
/*@{*/
#define BP_VDOA_VDOAIE_EIEOT (0U)          /*!< Bit position for VDOA_VDOAIE_EIEOT. */
#define BM_VDOA_VDOAIE_EIEOT (0x00000001U) /*!< Bit mask for VDOA_VDOAIE_EIEOT. */
#define BS_VDOA_VDOAIE_EIEOT (1U)          /*!< Bit field size in bits for VDOA_VDOAIE_EIEOT. */

#define BV_VDOA_VDOAIE_EIEOT_IRQ_DISABLED (0U)       /*!< Bit field value for VDOA_VDOAIE_EIEOT: interrupt disable (default) */
#define BV_VDOA_VDOAIE_EIEOT_IRQ_ENABLED (0x1U)      /*!< Bit field value for VDOA_VDOAIE_EIEOT: Interrupt Enabled */

/*! @brief Read current value of the VDOA_VDOAIE_EIEOT field. */
#define BR_VDOA_VDOAIE_EIEOT(x) (HW_VDOA_VDOAIE(x).B.EIEOT)

/*! @brief Format value for bitfield VDOA_VDOAIE_EIEOT. */
#define BF_VDOA_VDOAIE_EIEOT(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIE_EIEOT) & BM_VDOA_VDOAIE_EIEOT)

/*! @brief Set the EIEOT field to a new value. */
#define BW_VDOA_VDOAIE_EIEOT(x, v) (HW_VDOA_VDOAIE_WR(x, (HW_VDOA_VDOAIE_RD(x) & ~BM_VDOA_VDOAIE_EIEOT) | BF_VDOA_VDOAIE_EIEOT(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAIE, field EITERR[1] (RW)
 *
 * EITERR - Enable Interrupt Transfer access Error - Enables Interrupt on AXI
 * access Error
 *
 * Values:
 * - 0 - interrupt disable (default)
 * - 1 - Interrupt Enabled
 */
/*@{*/
#define BP_VDOA_VDOAIE_EITERR (1U)         /*!< Bit position for VDOA_VDOAIE_EITERR. */
#define BM_VDOA_VDOAIE_EITERR (0x00000002U) /*!< Bit mask for VDOA_VDOAIE_EITERR. */
#define BS_VDOA_VDOAIE_EITERR (1U)         /*!< Bit field size in bits for VDOA_VDOAIE_EITERR. */

#define BV_VDOA_VDOAIE_EITERR_IRQ_DISABLED (0U)      /*!< Bit field value for VDOA_VDOAIE_EITERR: interrupt disable (default) */
#define BV_VDOA_VDOAIE_EITERR_IRQ_ENABLED (0x1U)     /*!< Bit field value for VDOA_VDOAIE_EITERR: Interrupt Enabled */

/*! @brief Read current value of the VDOA_VDOAIE_EITERR field. */
#define BR_VDOA_VDOAIE_EITERR(x) (HW_VDOA_VDOAIE(x).B.EITERR)

/*! @brief Format value for bitfield VDOA_VDOAIE_EITERR. */
#define BF_VDOA_VDOAIE_EITERR(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIE_EITERR) & BM_VDOA_VDOAIE_EITERR)

/*! @brief Set the EITERR field to a new value. */
#define BW_VDOA_VDOAIE_EITERR(x, v) (HW_VDOA_VDOAIE_WR(x, (HW_VDOA_VDOAIE_RD(x) & ~BM_VDOA_VDOAIE_EITERR) | BF_VDOA_VDOAIE_EITERR(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIST - VDOA Interrupt Status Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIST - VDOA Interrupt Status Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaist
{
    uint32_t U;
    struct _hw_vdoa_vdoaist_bitfields
    {
        uint32_t EOT : 1;              /*!< [0]  */
        uint32_t TERR : 1;             /*!< [1]  */
        uint32_t RESERVED0 : 30;       /*!< [31:2]  */
    } B;
} hw_vdoa_vdoaist_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIST register
 */
/*@{*/
#define HW_VDOA_VDOAIST_ADDR(x)  ((uintptr_t)(x) + 0xCU)

#define HW_VDOA_VDOAIST(x)       (*(__IO hw_vdoa_vdoaist_t *) HW_VDOA_VDOAIST_ADDR(x))
#define HW_VDOA_VDOAIST_RD(x)    (HW_VDOA_VDOAIST(x).U)
#define HW_VDOA_VDOAIST_WR(x, v) (HW_VDOA_VDOAIST(x).U = (v))
#define HW_VDOA_VDOAIST_SET(x, v) (HW_VDOA_VDOAIST_WR(x, HW_VDOA_VDOAIST_RD(x) |  (v)))
#define HW_VDOA_VDOAIST_CLR(x, v) (HW_VDOA_VDOAIST_WR(x, HW_VDOA_VDOAIST_RD(x) & ~(v)))
#define HW_VDOA_VDOAIST_TOG(x, v) (HW_VDOA_VDOAIST_WR(x, HW_VDOA_VDOAIST_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIST bitfields
 */

/*!
 * @name Register VDOA_VDOAIST, field EOT[0] (W1C)
 *
 * End Of transfer - Transfer was completed if EIEOT is set an interrupt will be
 * generated
 */
/*@{*/
#define BP_VDOA_VDOAIST_EOT  (0U)          /*!< Bit position for VDOA_VDOAIST_EOT. */
#define BM_VDOA_VDOAIST_EOT  (0x00000001U) /*!< Bit mask for VDOA_VDOAIST_EOT. */
#define BS_VDOA_VDOAIST_EOT  (1U)          /*!< Bit field size in bits for VDOA_VDOAIST_EOT. */

/*! @brief Read current value of the VDOA_VDOAIST_EOT field. */
#define BR_VDOA_VDOAIST_EOT(x) (HW_VDOA_VDOAIST(x).B.EOT)

/*! @brief Format value for bitfield VDOA_VDOAIST_EOT. */
#define BF_VDOA_VDOAIST_EOT(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIST_EOT) & BM_VDOA_VDOAIST_EOT)

/*! @brief Set the EOT field to a new value. */
#define BW_VDOA_VDOAIST_EOT(x, v) (HW_VDOA_VDOAIST_WR(x, (HW_VDOA_VDOAIST_RD(x) & ~(BM_VDOA_VDOAIST_EOT | BM_VDOA_VDOAIST_TERR)) | BF_VDOA_VDOAIST_EOT(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAIST, field TERR[1] (W1C)
 *
 * Axi Access had an access error see ERRW bit in 0XBASE_0044 (VDOASR) for type
 * of access (read write) if EITERR is set an interrupt will be generated
 */
/*@{*/
#define BP_VDOA_VDOAIST_TERR (1U)          /*!< Bit position for VDOA_VDOAIST_TERR. */
#define BM_VDOA_VDOAIST_TERR (0x00000002U) /*!< Bit mask for VDOA_VDOAIST_TERR. */
#define BS_VDOA_VDOAIST_TERR (1U)          /*!< Bit field size in bits for VDOA_VDOAIST_TERR. */

/*! @brief Read current value of the VDOA_VDOAIST_TERR field. */
#define BR_VDOA_VDOAIST_TERR(x) (HW_VDOA_VDOAIST(x).B.TERR)

/*! @brief Format value for bitfield VDOA_VDOAIST_TERR. */
#define BF_VDOA_VDOAIST_TERR(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIST_TERR) & BM_VDOA_VDOAIST_TERR)

/*! @brief Set the TERR field to a new value. */
#define BW_VDOA_VDOAIST_TERR(x, v) (HW_VDOA_VDOAIST_WR(x, (HW_VDOA_VDOAIST_RD(x) & ~(BM_VDOA_VDOAIST_TERR | BM_VDOA_VDOAIST_EOT)) | BF_VDOA_VDOAIST_TERR(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAFP - VDOA Frame Parameters Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAFP - VDOA Frame Parameters Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoafp
{
    uint32_t U;
    struct _hw_vdoa_vdoafp_bitfields
    {
        uint32_t FW : 14;              /*!< [13:0]  */
        uint32_t RESERVED0 : 2;        /*!< [15:14]  */
        uint32_t FH : 13;              /*!< [28:16]  */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_vdoa_vdoafp_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAFP register
 */
/*@{*/
#define HW_VDOA_VDOAFP_ADDR(x)   ((uintptr_t)(x) + 0x10U)

#define HW_VDOA_VDOAFP(x)        (*(__IO hw_vdoa_vdoafp_t *) HW_VDOA_VDOAFP_ADDR(x))
#define HW_VDOA_VDOAFP_RD(x)     (HW_VDOA_VDOAFP(x).U)
#define HW_VDOA_VDOAFP_WR(x, v)  (HW_VDOA_VDOAFP(x).U = (v))
#define HW_VDOA_VDOAFP_SET(x, v) (HW_VDOA_VDOAFP_WR(x, HW_VDOA_VDOAFP_RD(x) |  (v)))
#define HW_VDOA_VDOAFP_CLR(x, v) (HW_VDOA_VDOAFP_WR(x, HW_VDOA_VDOAFP_RD(x) & ~(v)))
#define HW_VDOA_VDOAFP_TOG(x, v) (HW_VDOA_VDOAFP_WR(x, HW_VDOA_VDOAFP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAFP bitfields
 */

/*!
 * @name Register VDOA_VDOAFP, field FW[13:0] (RW)
 *
 * Number of pixels in one row, of the frame. Note the3 LSB are RO and will
 * always be 0 (multiply of 8)
 */
/*@{*/
#define BP_VDOA_VDOAFP_FW    (0U)          /*!< Bit position for VDOA_VDOAFP_FW. */
#define BM_VDOA_VDOAFP_FW    (0x00003FFFU) /*!< Bit mask for VDOA_VDOAFP_FW. */
#define BS_VDOA_VDOAFP_FW    (14U)         /*!< Bit field size in bits for VDOA_VDOAFP_FW. */

/*! @brief Read current value of the VDOA_VDOAFP_FW field. */
#define BR_VDOA_VDOAFP_FW(x) (HW_VDOA_VDOAFP(x).B.FW)

/*! @brief Format value for bitfield VDOA_VDOAFP_FW. */
#define BF_VDOA_VDOAFP_FW(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAFP_FW) & BM_VDOA_VDOAFP_FW)

/*! @brief Set the FW field to a new value. */
#define BW_VDOA_VDOAFP_FW(x, v) (HW_VDOA_VDOAFP_WR(x, (HW_VDOA_VDOAFP_RD(x) & ~BM_VDOA_VDOAFP_FW) | BF_VDOA_VDOAFP_FW(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOAFP, field FH[28:16] (RW)
 *
 * Number of pixels in one column, of the frame. Note the 3 LSB are RO and will
 * always be 0 (multiply of 8)
 */
/*@{*/
#define BP_VDOA_VDOAFP_FH    (16U)         /*!< Bit position for VDOA_VDOAFP_FH. */
#define BM_VDOA_VDOAFP_FH    (0x1FFF0000U) /*!< Bit mask for VDOA_VDOAFP_FH. */
#define BS_VDOA_VDOAFP_FH    (13U)         /*!< Bit field size in bits for VDOA_VDOAFP_FH. */

/*! @brief Read current value of the VDOA_VDOAFP_FH field. */
#define BR_VDOA_VDOAFP_FH(x) (HW_VDOA_VDOAFP(x).B.FH)

/*! @brief Format value for bitfield VDOA_VDOAFP_FH. */
#define BF_VDOA_VDOAFP_FH(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAFP_FH) & BM_VDOA_VDOAFP_FH)

/*! @brief Set the FH field to a new value. */
#define BW_VDOA_VDOAFP_FH(x, v) (HW_VDOA_VDOAFP_WR(x, (HW_VDOA_VDOAFP_RD(x) & ~BM_VDOA_VDOAFP_FH) | BF_VDOA_VDOAFP_FH(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA00 - VDOA IPU External Buffer 0 Frame 0 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA00 - VDOA IPU External Buffer 0 Frame 0 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba00
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba00_bitfields
    {
        uint32_t IEBA00 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba00_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA00 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA00_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_VDOA_VDOAIEBA00(x)    (*(__IO hw_vdoa_vdoaieba00_t *) HW_VDOA_VDOAIEBA00_ADDR(x))
#define HW_VDOA_VDOAIEBA00_RD(x) (HW_VDOA_VDOAIEBA00(x).U)
#define HW_VDOA_VDOAIEBA00_WR(x, v) (HW_VDOA_VDOAIEBA00(x).U = (v))
#define HW_VDOA_VDOAIEBA00_SET(x, v) (HW_VDOA_VDOAIEBA00_WR(x, HW_VDOA_VDOAIEBA00_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA00_CLR(x, v) (HW_VDOA_VDOAIEBA00_WR(x, HW_VDOA_VDOAIEBA00_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA00_TOG(x, v) (HW_VDOA_VDOAIEBA00_WR(x, HW_VDOA_VDOAIEBA00_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA00 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA00, field IEBA00[31:0] (RW)
 *
 * External Address of Frame 0 output (IPU) buffer 0 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) Used for all transfer types
 */
/*@{*/
#define BP_VDOA_VDOAIEBA00_IEBA00 (0U)     /*!< Bit position for VDOA_VDOAIEBA00_IEBA00. */
#define BM_VDOA_VDOAIEBA00_IEBA00 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA00_IEBA00. */
#define BS_VDOA_VDOAIEBA00_IEBA00 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA00_IEBA00. */

/*! @brief Read current value of the VDOA_VDOAIEBA00_IEBA00 field. */
#define BR_VDOA_VDOAIEBA00_IEBA00(x) (HW_VDOA_VDOAIEBA00(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA00_IEBA00. */
#define BF_VDOA_VDOAIEBA00_IEBA00(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA00_IEBA00) & BM_VDOA_VDOAIEBA00_IEBA00)

/*! @brief Set the IEBA00 field to a new value. */
#define BW_VDOA_VDOAIEBA00_IEBA00(x, v) (HW_VDOA_VDOAIEBA00_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA01 - VDOA IPU External Buffer 0 Frame 1 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA01 - VDOA IPU External Buffer 0 Frame 1 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba01
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba01_bitfields
    {
        uint32_t IEBA01 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba01_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA01 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA01_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_VDOA_VDOAIEBA01(x)    (*(__IO hw_vdoa_vdoaieba01_t *) HW_VDOA_VDOAIEBA01_ADDR(x))
#define HW_VDOA_VDOAIEBA01_RD(x) (HW_VDOA_VDOAIEBA01(x).U)
#define HW_VDOA_VDOAIEBA01_WR(x, v) (HW_VDOA_VDOAIEBA01(x).U = (v))
#define HW_VDOA_VDOAIEBA01_SET(x, v) (HW_VDOA_VDOAIEBA01_WR(x, HW_VDOA_VDOAIEBA01_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA01_CLR(x, v) (HW_VDOA_VDOAIEBA01_WR(x, HW_VDOA_VDOAIEBA01_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA01_TOG(x, v) (HW_VDOA_VDOAIEBA01_WR(x, HW_VDOA_VDOAIEBA01_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA01 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA01, field IEBA01[31:0] (RW)
 *
 * External Address of Frame 1 output (IPU) buffer 0 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) Used when transfering 3 frames (NF=1) only
 */
/*@{*/
#define BP_VDOA_VDOAIEBA01_IEBA01 (0U)     /*!< Bit position for VDOA_VDOAIEBA01_IEBA01. */
#define BM_VDOA_VDOAIEBA01_IEBA01 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA01_IEBA01. */
#define BS_VDOA_VDOAIEBA01_IEBA01 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA01_IEBA01. */

/*! @brief Read current value of the VDOA_VDOAIEBA01_IEBA01 field. */
#define BR_VDOA_VDOAIEBA01_IEBA01(x) (HW_VDOA_VDOAIEBA01(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA01_IEBA01. */
#define BF_VDOA_VDOAIEBA01_IEBA01(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA01_IEBA01) & BM_VDOA_VDOAIEBA01_IEBA01)

/*! @brief Set the IEBA01 field to a new value. */
#define BW_VDOA_VDOAIEBA01_IEBA01(x, v) (HW_VDOA_VDOAIEBA01_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA02 - VDOA IPU External Buffer 0 Frame 2 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA02 - VDOA IPU External Buffer 0 Frame 2 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba02
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba02_bitfields
    {
        uint32_t IEBA02 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba02_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA02 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA02_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_VDOA_VDOAIEBA02(x)    (*(__IO hw_vdoa_vdoaieba02_t *) HW_VDOA_VDOAIEBA02_ADDR(x))
#define HW_VDOA_VDOAIEBA02_RD(x) (HW_VDOA_VDOAIEBA02(x).U)
#define HW_VDOA_VDOAIEBA02_WR(x, v) (HW_VDOA_VDOAIEBA02(x).U = (v))
#define HW_VDOA_VDOAIEBA02_SET(x, v) (HW_VDOA_VDOAIEBA02_WR(x, HW_VDOA_VDOAIEBA02_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA02_CLR(x, v) (HW_VDOA_VDOAIEBA02_WR(x, HW_VDOA_VDOAIEBA02_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA02_TOG(x, v) (HW_VDOA_VDOAIEBA02_WR(x, HW_VDOA_VDOAIEBA02_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA02 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA02, field IEBA02[31:0] (RW)
 *
 * External Address of Frame 2 output (IPU) buffer 0 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) Used when transfering 3 frames (NF=1) only
 */
/*@{*/
#define BP_VDOA_VDOAIEBA02_IEBA02 (0U)     /*!< Bit position for VDOA_VDOAIEBA02_IEBA02. */
#define BM_VDOA_VDOAIEBA02_IEBA02 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA02_IEBA02. */
#define BS_VDOA_VDOAIEBA02_IEBA02 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA02_IEBA02. */

/*! @brief Read current value of the VDOA_VDOAIEBA02_IEBA02 field. */
#define BR_VDOA_VDOAIEBA02_IEBA02(x) (HW_VDOA_VDOAIEBA02(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA02_IEBA02. */
#define BF_VDOA_VDOAIEBA02_IEBA02(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA02_IEBA02) & BM_VDOA_VDOAIEBA02_IEBA02)

/*! @brief Set the IEBA02 field to a new value. */
#define BW_VDOA_VDOAIEBA02_IEBA02(x, v) (HW_VDOA_VDOAIEBA02_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA10 - VDOA IPU External Buffer 1 Frame 0 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA10 - VDOA IPU External Buffer 1 Frame 0 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba10
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba10_bitfields
    {
        uint32_t IEBA10 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba10_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA10 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA10_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_VDOA_VDOAIEBA10(x)    (*(__IO hw_vdoa_vdoaieba10_t *) HW_VDOA_VDOAIEBA10_ADDR(x))
#define HW_VDOA_VDOAIEBA10_RD(x) (HW_VDOA_VDOAIEBA10(x).U)
#define HW_VDOA_VDOAIEBA10_WR(x, v) (HW_VDOA_VDOAIEBA10(x).U = (v))
#define HW_VDOA_VDOAIEBA10_SET(x, v) (HW_VDOA_VDOAIEBA10_WR(x, HW_VDOA_VDOAIEBA10_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA10_CLR(x, v) (HW_VDOA_VDOAIEBA10_WR(x, HW_VDOA_VDOAIEBA10_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA10_TOG(x, v) (HW_VDOA_VDOAIEBA10_WR(x, HW_VDOA_VDOAIEBA10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA10 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA10, field IEBA10[31:0] (RW)
 *
 * External Address of Frame 0 output (IPU) buffer 1 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) Used in sync mode (SYNC=1) only
 */
/*@{*/
#define BP_VDOA_VDOAIEBA10_IEBA10 (0U)     /*!< Bit position for VDOA_VDOAIEBA10_IEBA10. */
#define BM_VDOA_VDOAIEBA10_IEBA10 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA10_IEBA10. */
#define BS_VDOA_VDOAIEBA10_IEBA10 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA10_IEBA10. */

/*! @brief Read current value of the VDOA_VDOAIEBA10_IEBA10 field. */
#define BR_VDOA_VDOAIEBA10_IEBA10(x) (HW_VDOA_VDOAIEBA10(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA10_IEBA10. */
#define BF_VDOA_VDOAIEBA10_IEBA10(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA10_IEBA10) & BM_VDOA_VDOAIEBA10_IEBA10)

/*! @brief Set the IEBA10 field to a new value. */
#define BW_VDOA_VDOAIEBA10_IEBA10(x, v) (HW_VDOA_VDOAIEBA10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA11 - VDOA IPU External Buffer 1 Frame 1 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA11 - VDOA IPU External Buffer 1 Frame 1 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba11
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba11_bitfields
    {
        uint32_t IEBA11 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba11_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA11 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA11_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_VDOA_VDOAIEBA11(x)    (*(__IO hw_vdoa_vdoaieba11_t *) HW_VDOA_VDOAIEBA11_ADDR(x))
#define HW_VDOA_VDOAIEBA11_RD(x) (HW_VDOA_VDOAIEBA11(x).U)
#define HW_VDOA_VDOAIEBA11_WR(x, v) (HW_VDOA_VDOAIEBA11(x).U = (v))
#define HW_VDOA_VDOAIEBA11_SET(x, v) (HW_VDOA_VDOAIEBA11_WR(x, HW_VDOA_VDOAIEBA11_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA11_CLR(x, v) (HW_VDOA_VDOAIEBA11_WR(x, HW_VDOA_VDOAIEBA11_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA11_TOG(x, v) (HW_VDOA_VDOAIEBA11_WR(x, HW_VDOA_VDOAIEBA11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA11 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA11, field IEBA11[31:0] (RW)
 *
 * External Address of Frame 1 output (IPU) buffer 1 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) This register is used only in sync mode
 * (SYNC=1), 3 frames transfer (NF=1)
 */
/*@{*/
#define BP_VDOA_VDOAIEBA11_IEBA11 (0U)     /*!< Bit position for VDOA_VDOAIEBA11_IEBA11. */
#define BM_VDOA_VDOAIEBA11_IEBA11 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA11_IEBA11. */
#define BS_VDOA_VDOAIEBA11_IEBA11 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA11_IEBA11. */

/*! @brief Read current value of the VDOA_VDOAIEBA11_IEBA11 field. */
#define BR_VDOA_VDOAIEBA11_IEBA11(x) (HW_VDOA_VDOAIEBA11(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA11_IEBA11. */
#define BF_VDOA_VDOAIEBA11_IEBA11(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA11_IEBA11) & BM_VDOA_VDOAIEBA11_IEBA11)

/*! @brief Set the IEBA11 field to a new value. */
#define BW_VDOA_VDOAIEBA11_IEBA11(x, v) (HW_VDOA_VDOAIEBA11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIEBA12 - VDOA IPU External Buffer 1 Frame 2 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIEBA12 - VDOA IPU External Buffer 1 Frame 2 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaieba12
{
    uint32_t U;
    struct _hw_vdoa_vdoaieba12_bitfields
    {
        uint32_t IEBA12 : 32;          /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaieba12_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIEBA12 register
 */
/*@{*/
#define HW_VDOA_VDOAIEBA12_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_VDOA_VDOAIEBA12(x)    (*(__IO hw_vdoa_vdoaieba12_t *) HW_VDOA_VDOAIEBA12_ADDR(x))
#define HW_VDOA_VDOAIEBA12_RD(x) (HW_VDOA_VDOAIEBA12(x).U)
#define HW_VDOA_VDOAIEBA12_WR(x, v) (HW_VDOA_VDOAIEBA12(x).U = (v))
#define HW_VDOA_VDOAIEBA12_SET(x, v) (HW_VDOA_VDOAIEBA12_WR(x, HW_VDOA_VDOAIEBA12_RD(x) |  (v)))
#define HW_VDOA_VDOAIEBA12_CLR(x, v) (HW_VDOA_VDOAIEBA12_WR(x, HW_VDOA_VDOAIEBA12_RD(x) & ~(v)))
#define HW_VDOA_VDOAIEBA12_TOG(x, v) (HW_VDOA_VDOAIEBA12_WR(x, HW_VDOA_VDOAIEBA12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIEBA12 bitfields
 */

/*!
 * @name Register VDOA_VDOAIEBA12, field IEBA12[31:0] (RW)
 *
 * External Address of Frame 2 output (IPU) buffer 1 - Note that the 3 LSB are
 * always 0 (aligned to 8 address) This register is used only in sync mode
 * (SYNC=1), 3 frames transfer (NF=1)
 */
/*@{*/
#define BP_VDOA_VDOAIEBA12_IEBA12 (0U)     /*!< Bit position for VDOA_VDOAIEBA12_IEBA12. */
#define BM_VDOA_VDOAIEBA12_IEBA12 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAIEBA12_IEBA12. */
#define BS_VDOA_VDOAIEBA12_IEBA12 (32U)    /*!< Bit field size in bits for VDOA_VDOAIEBA12_IEBA12. */

/*! @brief Read current value of the VDOA_VDOAIEBA12_IEBA12 field. */
#define BR_VDOA_VDOAIEBA12_IEBA12(x) (HW_VDOA_VDOAIEBA12(x).U)

/*! @brief Format value for bitfield VDOA_VDOAIEBA12_IEBA12. */
#define BF_VDOA_VDOAIEBA12_IEBA12(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIEBA12_IEBA12) & BM_VDOA_VDOAIEBA12_IEBA12)

/*! @brief Set the IEBA12 field to a new value. */
#define BW_VDOA_VDOAIEBA12_IEBA12(x, v) (HW_VDOA_VDOAIEBA12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOASL - VDOA IPU Stride Line Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOASL - VDOA IPU Stride Line Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoasl
{
    uint32_t U;
    struct _hw_vdoa_vdoasl_bitfields
    {
        uint32_t ISLY : 15;            /*!< [14:0]  */
        uint32_t RESERVED0 : 1;        /*!< [15]  */
        uint32_t VSLY : 14;            /*!< [29:16]  */
        uint32_t RESERVED1 : 2;        /*!< [31:30]  */
    } B;
} hw_vdoa_vdoasl_t;

/*!
 * @name Constants and macros for entire VDOA_VDOASL register
 */
/*@{*/
#define HW_VDOA_VDOASL_ADDR(x)   ((uintptr_t)(x) + 0x2CU)

#define HW_VDOA_VDOASL(x)        (*(__IO hw_vdoa_vdoasl_t *) HW_VDOA_VDOASL_ADDR(x))
#define HW_VDOA_VDOASL_RD(x)     (HW_VDOA_VDOASL(x).U)
#define HW_VDOA_VDOASL_WR(x, v)  (HW_VDOA_VDOASL(x).U = (v))
#define HW_VDOA_VDOASL_SET(x, v) (HW_VDOA_VDOASL_WR(x, HW_VDOA_VDOASL_RD(x) |  (v)))
#define HW_VDOA_VDOASL_CLR(x, v) (HW_VDOA_VDOASL_WR(x, HW_VDOA_VDOASL_RD(x) & ~(v)))
#define HW_VDOA_VDOASL_TOG(x, v) (HW_VDOA_VDOASL_WR(x, HW_VDOA_VDOASL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOASL bitfields
 */

/*!
 * @name Register VDOA_VDOASL, field ISLY[14:0] (RW)
 *
 * IPU Stride Line - Address vertical scaling factor in bytes for memory access;
 * also number of maximum bytes in the "Y" component row.- Note for 4:2:2 format
 * ISLY will be doubled since each pixel consists of two bytes.
 */
/*@{*/
#define BP_VDOA_VDOASL_ISLY  (0U)          /*!< Bit position for VDOA_VDOASL_ISLY. */
#define BM_VDOA_VDOASL_ISLY  (0x00007FFFU) /*!< Bit mask for VDOA_VDOASL_ISLY. */
#define BS_VDOA_VDOASL_ISLY  (15U)         /*!< Bit field size in bits for VDOA_VDOASL_ISLY. */

/*! @brief Read current value of the VDOA_VDOASL_ISLY field. */
#define BR_VDOA_VDOASL_ISLY(x) (HW_VDOA_VDOASL(x).B.ISLY)

/*! @brief Format value for bitfield VDOA_VDOASL_ISLY. */
#define BF_VDOA_VDOASL_ISLY(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOASL_ISLY) & BM_VDOA_VDOASL_ISLY)

/*! @brief Set the ISLY field to a new value. */
#define BW_VDOA_VDOASL_ISLY(x, v) (HW_VDOA_VDOASL_WR(x, (HW_VDOA_VDOASL_RD(x) & ~BM_VDOA_VDOASL_ISLY) | BF_VDOA_VDOASL_ISLY(v)))
/*@}*/

/*!
 * @name Register VDOA_VDOASL, field VSLY[29:16] (RW)
 *
 * VPU Stride Line - Address vertical scaling factor in bytes for memory access.
 * Also number of maximum bytes in the "Y" component row according to memory
 * limitations.
 */
/*@{*/
#define BP_VDOA_VDOASL_VSLY  (16U)         /*!< Bit position for VDOA_VDOASL_VSLY. */
#define BM_VDOA_VDOASL_VSLY  (0x3FFF0000U) /*!< Bit mask for VDOA_VDOASL_VSLY. */
#define BS_VDOA_VDOASL_VSLY  (14U)         /*!< Bit field size in bits for VDOA_VDOASL_VSLY. */

/*! @brief Read current value of the VDOA_VDOASL_VSLY field. */
#define BR_VDOA_VDOASL_VSLY(x) (HW_VDOA_VDOASL(x).B.VSLY)

/*! @brief Format value for bitfield VDOA_VDOASL_VSLY. */
#define BF_VDOA_VDOASL_VSLY(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOASL_VSLY) & BM_VDOA_VDOASL_VSLY)

/*! @brief Set the VSLY field to a new value. */
#define BW_VDOA_VDOASL_VSLY(x, v) (HW_VDOA_VDOASL_WR(x, (HW_VDOA_VDOASL_RD(x) & ~BM_VDOA_VDOASL_VSLY) | BF_VDOA_VDOASL_VSLY(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAIUBO - VDOA IPU U (Chroma) Buffer Offset Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAIUBO - VDOA IPU U (Chroma) Buffer Offset Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaiubo
{
    uint32_t U;
    struct _hw_vdoa_vdoaiubo_bitfields
    {
        uint32_t IUBO : 27;            /*!< [26:0]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_vdoa_vdoaiubo_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAIUBO register
 */
/*@{*/
#define HW_VDOA_VDOAIUBO_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_VDOA_VDOAIUBO(x)      (*(__IO hw_vdoa_vdoaiubo_t *) HW_VDOA_VDOAIUBO_ADDR(x))
#define HW_VDOA_VDOAIUBO_RD(x)   (HW_VDOA_VDOAIUBO(x).U)
#define HW_VDOA_VDOAIUBO_WR(x, v) (HW_VDOA_VDOAIUBO(x).U = (v))
#define HW_VDOA_VDOAIUBO_SET(x, v) (HW_VDOA_VDOAIUBO_WR(x, HW_VDOA_VDOAIUBO_RD(x) |  (v)))
#define HW_VDOA_VDOAIUBO_CLR(x, v) (HW_VDOA_VDOAIUBO_WR(x, HW_VDOA_VDOAIUBO_RD(x) & ~(v)))
#define HW_VDOA_VDOAIUBO_TOG(x, v) (HW_VDOA_VDOAIUBO_WR(x, HW_VDOA_VDOAIUBO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAIUBO bitfields
 */

/*!
 * @name Register VDOA_VDOAIUBO, field IUBO[26:0] (RW)
 *
 * The offset of Chroma (UV) Buffer for all IPU output frames i.e Buffer Chroma
 * address will be VDOAIEBAnm+VDOAIUBO - Note that the 3 LSB are always 0
 * (aligned to 8 address). This parameter is used only for PFL = 4:2:0
 */
/*@{*/
#define BP_VDOA_VDOAIUBO_IUBO (0U)         /*!< Bit position for VDOA_VDOAIUBO_IUBO. */
#define BM_VDOA_VDOAIUBO_IUBO (0x07FFFFFFU) /*!< Bit mask for VDOA_VDOAIUBO_IUBO. */
#define BS_VDOA_VDOAIUBO_IUBO (27U)        /*!< Bit field size in bits for VDOA_VDOAIUBO_IUBO. */

/*! @brief Read current value of the VDOA_VDOAIUBO_IUBO field. */
#define BR_VDOA_VDOAIUBO_IUBO(x) (HW_VDOA_VDOAIUBO(x).B.IUBO)

/*! @brief Format value for bitfield VDOA_VDOAIUBO_IUBO. */
#define BF_VDOA_VDOAIUBO_IUBO(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAIUBO_IUBO) & BM_VDOA_VDOAIUBO_IUBO)

/*! @brief Set the IUBO field to a new value. */
#define BW_VDOA_VDOAIUBO_IUBO(x, v) (HW_VDOA_VDOAIUBO_WR(x, (HW_VDOA_VDOAIUBO_RD(x) & ~BM_VDOA_VDOAIUBO_IUBO) | BF_VDOA_VDOAIUBO_IUBO(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAVEBA0 - VDOA VPU External Buffer 0 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAVEBA0 - VDOA VPU External Buffer 0 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaveba0
{
    uint32_t U;
    struct _hw_vdoa_vdoaveba0_bitfields
    {
        uint32_t VEBA0 : 32;           /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaveba0_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAVEBA0 register
 */
/*@{*/
#define HW_VDOA_VDOAVEBA0_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_VDOA_VDOAVEBA0(x)     (*(__IO hw_vdoa_vdoaveba0_t *) HW_VDOA_VDOAVEBA0_ADDR(x))
#define HW_VDOA_VDOAVEBA0_RD(x)  (HW_VDOA_VDOAVEBA0(x).U)
#define HW_VDOA_VDOAVEBA0_WR(x, v) (HW_VDOA_VDOAVEBA0(x).U = (v))
#define HW_VDOA_VDOAVEBA0_SET(x, v) (HW_VDOA_VDOAVEBA0_WR(x, HW_VDOA_VDOAVEBA0_RD(x) |  (v)))
#define HW_VDOA_VDOAVEBA0_CLR(x, v) (HW_VDOA_VDOAVEBA0_WR(x, HW_VDOA_VDOAVEBA0_RD(x) & ~(v)))
#define HW_VDOA_VDOAVEBA0_TOG(x, v) (HW_VDOA_VDOAVEBA0_WR(x, HW_VDOA_VDOAVEBA0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAVEBA0 bitfields
 */

/*!
 * @name Register VDOA_VDOAVEBA0, field VEBA0[31:0] (RW)
 *
 * Address of Frame 0 VPU buffers - Note that the 3 LSB are always 0 (aligned to
 * 8 address) Used for all transfers
 */
/*@{*/
#define BP_VDOA_VDOAVEBA0_VEBA0 (0U)       /*!< Bit position for VDOA_VDOAVEBA0_VEBA0. */
#define BM_VDOA_VDOAVEBA0_VEBA0 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAVEBA0_VEBA0. */
#define BS_VDOA_VDOAVEBA0_VEBA0 (32U)      /*!< Bit field size in bits for VDOA_VDOAVEBA0_VEBA0. */

/*! @brief Read current value of the VDOA_VDOAVEBA0_VEBA0 field. */
#define BR_VDOA_VDOAVEBA0_VEBA0(x) (HW_VDOA_VDOAVEBA0(x).U)

/*! @brief Format value for bitfield VDOA_VDOAVEBA0_VEBA0. */
#define BF_VDOA_VDOAVEBA0_VEBA0(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAVEBA0_VEBA0) & BM_VDOA_VDOAVEBA0_VEBA0)

/*! @brief Set the VEBA0 field to a new value. */
#define BW_VDOA_VDOAVEBA0_VEBA0(x, v) (HW_VDOA_VDOAVEBA0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAVEBA1 - VDOA VPU External Buffer 1 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAVEBA1 - VDOA VPU External Buffer 1 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaveba1
{
    uint32_t U;
    struct _hw_vdoa_vdoaveba1_bitfields
    {
        uint32_t VEBA1 : 32;           /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaveba1_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAVEBA1 register
 */
/*@{*/
#define HW_VDOA_VDOAVEBA1_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_VDOA_VDOAVEBA1(x)     (*(__IO hw_vdoa_vdoaveba1_t *) HW_VDOA_VDOAVEBA1_ADDR(x))
#define HW_VDOA_VDOAVEBA1_RD(x)  (HW_VDOA_VDOAVEBA1(x).U)
#define HW_VDOA_VDOAVEBA1_WR(x, v) (HW_VDOA_VDOAVEBA1(x).U = (v))
#define HW_VDOA_VDOAVEBA1_SET(x, v) (HW_VDOA_VDOAVEBA1_WR(x, HW_VDOA_VDOAVEBA1_RD(x) |  (v)))
#define HW_VDOA_VDOAVEBA1_CLR(x, v) (HW_VDOA_VDOAVEBA1_WR(x, HW_VDOA_VDOAVEBA1_RD(x) & ~(v)))
#define HW_VDOA_VDOAVEBA1_TOG(x, v) (HW_VDOA_VDOAVEBA1_WR(x, HW_VDOA_VDOAVEBA1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAVEBA1 bitfields
 */

/*!
 * @name Register VDOA_VDOAVEBA1, field VEBA1[31:0] (RW)
 *
 * Address of Frame 1 VPU buffers - Note that the 3 LSB are always 0 (aligned to
 * 8 address) Used when transfering three frame (NF=1) only
 */
/*@{*/
#define BP_VDOA_VDOAVEBA1_VEBA1 (0U)       /*!< Bit position for VDOA_VDOAVEBA1_VEBA1. */
#define BM_VDOA_VDOAVEBA1_VEBA1 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAVEBA1_VEBA1. */
#define BS_VDOA_VDOAVEBA1_VEBA1 (32U)      /*!< Bit field size in bits for VDOA_VDOAVEBA1_VEBA1. */

/*! @brief Read current value of the VDOA_VDOAVEBA1_VEBA1 field. */
#define BR_VDOA_VDOAVEBA1_VEBA1(x) (HW_VDOA_VDOAVEBA1(x).U)

/*! @brief Format value for bitfield VDOA_VDOAVEBA1_VEBA1. */
#define BF_VDOA_VDOAVEBA1_VEBA1(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAVEBA1_VEBA1) & BM_VDOA_VDOAVEBA1_VEBA1)

/*! @brief Set the VEBA1 field to a new value. */
#define BW_VDOA_VDOAVEBA1_VEBA1(x, v) (HW_VDOA_VDOAVEBA1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAVEBA2 - VDOA VPU External Buffer 2 Address Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAVEBA2 - VDOA VPU External Buffer 2 Address Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoaveba2
{
    uint32_t U;
    struct _hw_vdoa_vdoaveba2_bitfields
    {
        uint32_t VEBA2 : 32;           /*!< [31:0]  */
    } B;
} hw_vdoa_vdoaveba2_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAVEBA2 register
 */
/*@{*/
#define HW_VDOA_VDOAVEBA2_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_VDOA_VDOAVEBA2(x)     (*(__IO hw_vdoa_vdoaveba2_t *) HW_VDOA_VDOAVEBA2_ADDR(x))
#define HW_VDOA_VDOAVEBA2_RD(x)  (HW_VDOA_VDOAVEBA2(x).U)
#define HW_VDOA_VDOAVEBA2_WR(x, v) (HW_VDOA_VDOAVEBA2(x).U = (v))
#define HW_VDOA_VDOAVEBA2_SET(x, v) (HW_VDOA_VDOAVEBA2_WR(x, HW_VDOA_VDOAVEBA2_RD(x) |  (v)))
#define HW_VDOA_VDOAVEBA2_CLR(x, v) (HW_VDOA_VDOAVEBA2_WR(x, HW_VDOA_VDOAVEBA2_RD(x) & ~(v)))
#define HW_VDOA_VDOAVEBA2_TOG(x, v) (HW_VDOA_VDOAVEBA2_WR(x, HW_VDOA_VDOAVEBA2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAVEBA2 bitfields
 */

/*!
 * @name Register VDOA_VDOAVEBA2, field VEBA2[31:0] (RW)
 *
 * Address of Frame 2 VPU buffers - Note that the 3 LSB are always 0 (aligned to
 * 8 address) Used when transfering three frame (NF=1) only
 */
/*@{*/
#define BP_VDOA_VDOAVEBA2_VEBA2 (0U)       /*!< Bit position for VDOA_VDOAVEBA2_VEBA2. */
#define BM_VDOA_VDOAVEBA2_VEBA2 (0xFFFFFFFFU) /*!< Bit mask for VDOA_VDOAVEBA2_VEBA2. */
#define BS_VDOA_VDOAVEBA2_VEBA2 (32U)      /*!< Bit field size in bits for VDOA_VDOAVEBA2_VEBA2. */

/*! @brief Read current value of the VDOA_VDOAVEBA2_VEBA2 field. */
#define BR_VDOA_VDOAVEBA2_VEBA2(x) (HW_VDOA_VDOAVEBA2(x).U)

/*! @brief Format value for bitfield VDOA_VDOAVEBA2_VEBA2. */
#define BF_VDOA_VDOAVEBA2_VEBA2(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAVEBA2_VEBA2) & BM_VDOA_VDOAVEBA2_VEBA2)

/*! @brief Set the VEBA2 field to a new value. */
#define BW_VDOA_VDOAVEBA2_VEBA2(x, v) (HW_VDOA_VDOAVEBA2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOAVUBO - VDOA VPU U (Chroma) Buffer Offset Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOAVUBO - VDOA VPU U (Chroma) Buffer Offset Register (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoavubo
{
    uint32_t U;
    struct _hw_vdoa_vdoavubo_bitfields
    {
        uint32_t VUBO : 27;            /*!< [26:0]  */
        uint32_t RESERVED0 : 5;        /*!< [31:27]  */
    } B;
} hw_vdoa_vdoavubo_t;

/*!
 * @name Constants and macros for entire VDOA_VDOAVUBO register
 */
/*@{*/
#define HW_VDOA_VDOAVUBO_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_VDOA_VDOAVUBO(x)      (*(__IO hw_vdoa_vdoavubo_t *) HW_VDOA_VDOAVUBO_ADDR(x))
#define HW_VDOA_VDOAVUBO_RD(x)   (HW_VDOA_VDOAVUBO(x).U)
#define HW_VDOA_VDOAVUBO_WR(x, v) (HW_VDOA_VDOAVUBO(x).U = (v))
#define HW_VDOA_VDOAVUBO_SET(x, v) (HW_VDOA_VDOAVUBO_WR(x, HW_VDOA_VDOAVUBO_RD(x) |  (v)))
#define HW_VDOA_VDOAVUBO_CLR(x, v) (HW_VDOA_VDOAVUBO_WR(x, HW_VDOA_VDOAVUBO_RD(x) & ~(v)))
#define HW_VDOA_VDOAVUBO_TOG(x, v) (HW_VDOA_VDOAVUBO_WR(x, HW_VDOA_VDOAVUBO_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOAVUBO bitfields
 */

/*!
 * @name Register VDOA_VDOAVUBO, field VUBO[26:0] (RW)
 *
 * The offset of Chroma (UV) Buffer for all VPU input frames i.e Chroma Buffer
 * address will be VDOAVEBAm+VDOAVUBO - Note that the 3 LSB are always 0 (aligned
 * to 8 address)
 */
/*@{*/
#define BP_VDOA_VDOAVUBO_VUBO (0U)         /*!< Bit position for VDOA_VDOAVUBO_VUBO. */
#define BM_VDOA_VDOAVUBO_VUBO (0x07FFFFFFU) /*!< Bit mask for VDOA_VDOAVUBO_VUBO. */
#define BS_VDOA_VDOAVUBO_VUBO (27U)        /*!< Bit field size in bits for VDOA_VDOAVUBO_VUBO. */

/*! @brief Read current value of the VDOA_VDOAVUBO_VUBO field. */
#define BR_VDOA_VDOAVUBO_VUBO(x) (HW_VDOA_VDOAVUBO(x).B.VUBO)

/*! @brief Format value for bitfield VDOA_VDOAVUBO_VUBO. */
#define BF_VDOA_VDOAVUBO_VUBO(v) ((uint32_t)((uint32_t)(v) << BP_VDOA_VDOAVUBO_VUBO) & BM_VDOA_VDOAVUBO_VUBO)

/*! @brief Set the VUBO field to a new value. */
#define BW_VDOA_VDOAVUBO_VUBO(x, v) (HW_VDOA_VDOAVUBO_WR(x, (HW_VDOA_VDOAVUBO_RD(x) & ~BM_VDOA_VDOAVUBO_VUBO) | BF_VDOA_VDOAVUBO_VUBO(v)))
/*@}*/

/*******************************************************************************
 * HW_VDOA_VDOASR - VDOA Status Register
 ******************************************************************************/

/*!
 * @brief HW_VDOA_VDOASR - VDOA Status Register (RO)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_vdoa_vdoasr
{
    uint32_t U;
    struct _hw_vdoa_vdoasr_bitfields
    {
        uint32_t Current_Buffer : 1;   /*!< [0]  */
        uint32_t CURRENT_FRAME : 2;    /*!< [2:1]  */
        uint32_t EOB : 1;              /*!< [3]  */
        uint32_t ERRW : 1;             /*!< [4]  */
        uint32_t RESERVED0 : 27;       /*!< [31:5]  */
    } B;
} hw_vdoa_vdoasr_t;

/*!
 * @name Constants and macros for entire VDOA_VDOASR register
 */
/*@{*/
#define HW_VDOA_VDOASR_ADDR(x)   ((uintptr_t)(x) + 0x44U)

#define HW_VDOA_VDOASR(x)        (*(__I hw_vdoa_vdoasr_t *) HW_VDOA_VDOASR_ADDR(x))
#define HW_VDOA_VDOASR_RD(x)     (HW_VDOA_VDOASR(x).U)
/*@}*/

/*
 * Constants & macros for individual VDOA_VDOASR bitfields
 */

/*!
 * @name Register VDOA_VDOASR, field Current_Buffer[0] (RO)
 *
 * Current Buffer - for Double buffer shows the index of the buffer currently
 * transferred
 */
/*@{*/
#define BP_VDOA_VDOASR_Current_Buffer (0U) /*!< Bit position for VDOA_VDOASR_Current_Buffer. */
#define BM_VDOA_VDOASR_Current_Buffer (0x00000001U) /*!< Bit mask for VDOA_VDOASR_Current_Buffer. */
#define BS_VDOA_VDOASR_Current_Buffer (1U) /*!< Bit field size in bits for VDOA_VDOASR_Current_Buffer. */

/*! @brief Read current value of the VDOA_VDOASR_Current_Buffer field. */
#define BR_VDOA_VDOASR_Current_Buffer(x) (HW_VDOA_VDOASR(x).B.Current_Buffer)
/*@}*/

/*!
 * @name Register VDOA_VDOASR, field CURRENT_FRAME[2:1] (RO)
 *
 * Current Frame - When working on 3 frames the index of the frame currently
 * transferred
 */
/*@{*/
#define BP_VDOA_VDOASR_CURRENT_FRAME (1U)  /*!< Bit position for VDOA_VDOASR_CURRENT_FRAME. */
#define BM_VDOA_VDOASR_CURRENT_FRAME (0x00000006U) /*!< Bit mask for VDOA_VDOASR_CURRENT_FRAME. */
#define BS_VDOA_VDOASR_CURRENT_FRAME (2U)  /*!< Bit field size in bits for VDOA_VDOASR_CURRENT_FRAME. */

/*! @brief Read current value of the VDOA_VDOASR_CURRENT_FRAME field. */
#define BR_VDOA_VDOASR_CURRENT_FRAME(x) (HW_VDOA_VDOASR(x).B.CURRENT_FRAME)
/*@}*/

/*!
 * @name Register VDOA_VDOASR, field EOB[3] (RO)
 *
 * End of Band- Indicates that the VDOA has finished transferring a band in SYNC
 * mode and is waiting for IPU to continue.
 */
/*@{*/
#define BP_VDOA_VDOASR_EOB   (3U)          /*!< Bit position for VDOA_VDOASR_EOB. */
#define BM_VDOA_VDOASR_EOB   (0x00000008U) /*!< Bit mask for VDOA_VDOASR_EOB. */
#define BS_VDOA_VDOASR_EOB   (1U)          /*!< Bit field size in bits for VDOA_VDOASR_EOB. */

/*! @brief Read current value of the VDOA_VDOASR_EOB field. */
#define BR_VDOA_VDOASR_EOB(x) (HW_VDOA_VDOASR(x).B.EOB)
/*@}*/

/*!
 * @name Register VDOA_VDOASR, field ERRW[4] (RO)
 *
 * Error Write - Indicates that the last access that failed was a read or a
 * write.This field is valid only when TERR bit is set in VDOA Interrupt Status
 * Register - VDOAIST
 *
 * Values:
 * - 0 - Read Error
 * - 1 - Write Error
 */
/*@{*/
#define BP_VDOA_VDOASR_ERRW  (4U)          /*!< Bit position for VDOA_VDOASR_ERRW. */
#define BM_VDOA_VDOASR_ERRW  (0x00000010U) /*!< Bit mask for VDOA_VDOASR_ERRW. */
#define BS_VDOA_VDOASR_ERRW  (1U)          /*!< Bit field size in bits for VDOA_VDOASR_ERRW. */

#define BV_VDOA_VDOASR_ERRW_READ_ERROR (0U)          /*!< Bit field value for VDOA_VDOASR_ERRW: Read Error */
#define BV_VDOA_VDOASR_ERRW_WRITE_ERROR (0x1U)       /*!< Bit field value for VDOA_VDOASR_ERRW: Write Error */

/*! @brief Read current value of the VDOA_VDOASR_ERRW field. */
#define BR_VDOA_VDOASR_ERRW(x) (HW_VDOA_VDOASR(x).B.ERRW)
/*@}*/

/*******************************************************************************
 * hw_vdoa_t - module struct
 ******************************************************************************/
/*!
 * @brief All VDOA module registers.
 */
#pragma pack(1)
typedef struct _hw_vdoa
{
    __IO hw_vdoa_vdoac_t VDOAC;            /*!< [0x0] VDOA Control Register */
    __IO hw_vdoa_vdoasrr_t VDOASRR;        /*!< [0x4] VDOA Start and Reset */
    __IO hw_vdoa_vdoaie_t VDOAIE;          /*!< [0x8] VDOA Interrupt Enable Register */
    __IO hw_vdoa_vdoaist_t VDOAIST;        /*!< [0xC] VDOA Interrupt Status Register */
    __IO hw_vdoa_vdoafp_t VDOAFP;          /*!< [0x10] VDOA Frame Parameters Register */
    __IO hw_vdoa_vdoaieba00_t VDOAIEBA00;  /*!< [0x14] VDOA IPU External Buffer 0 Frame 0 Address Register */
    __IO hw_vdoa_vdoaieba01_t VDOAIEBA01;  /*!< [0x18] VDOA IPU External Buffer 0 Frame 1 Address Register */
    __IO hw_vdoa_vdoaieba02_t VDOAIEBA02;  /*!< [0x1C] VDOA IPU External Buffer 0 Frame 2 Address Register */
    __IO hw_vdoa_vdoaieba10_t VDOAIEBA10;  /*!< [0x20] VDOA IPU External Buffer 1 Frame 0 Address Register */
    __IO hw_vdoa_vdoaieba11_t VDOAIEBA11;  /*!< [0x24] VDOA IPU External Buffer 1 Frame 1 Address Register */
    __IO hw_vdoa_vdoaieba12_t VDOAIEBA12;  /*!< [0x28] VDOA IPU External Buffer 1 Frame 2 Address Register */
    __IO hw_vdoa_vdoasl_t VDOASL;          /*!< [0x2C] VDOA IPU Stride Line Register */
    __IO hw_vdoa_vdoaiubo_t VDOAIUBO;      /*!< [0x30] VDOA IPU U (Chroma) Buffer Offset Register */
    __IO hw_vdoa_vdoaveba0_t VDOAVEBA0;    /*!< [0x34] VDOA VPU External Buffer 0 Address Register */
    __IO hw_vdoa_vdoaveba1_t VDOAVEBA1;    /*!< [0x38] VDOA VPU External Buffer 1 Address Register */
    __IO hw_vdoa_vdoaveba2_t VDOAVEBA2;    /*!< [0x3C] VDOA VPU External Buffer 2 Address Register */
    __IO hw_vdoa_vdoavubo_t VDOAVUBO;      /*!< [0x40] VDOA VPU U (Chroma) Buffer Offset Register */
    __I hw_vdoa_vdoasr_t VDOASR;           /*!< [0x44] VDOA Status Register */
} hw_vdoa_t;
#pragma pack()

/*! @brief Macro to access all VDOA registers. */
/*! @param x VDOA module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_VDOA_REGS(VDOA_BASE)</code>. */
#define HW_VDOA_REGS(x) (*(hw_vdoa_t *)(x))

/*
 * iMX6DP VPU
 *
 * vpu
 *
 * Registers defined in this header file:
 * - HW_VPU_CodeRun - BIT Processor run start
 * - HW_VPU_CodeDown - BIT Boot Code Download Data register
 * - HW_VPU_HostIntReq - Host Interrupt Request to BIT
 * - HW_VPU_BitIntClear - BIT Interrupt Clear
 * - HW_VPU_BitIntSts - BIT Interrupt Status
 * - HW_VPU_BitCurPc - BIT Current PC
 * - HW_VPU_BitCodecBusy - BIT CODEC Busy
 *
 * - hw_vpu_t - Struct containing all module registers.
 */

#define HW_VPU_INSTANCE_COUNT (1U) /*!< Number of instances of the VPU module. */
#define HW_VPU (0U) /*!< Instance number for VPU. */
#define VPU_BASE              (0x2040000U) /*!< Base address for VPU. */
/*! Array initializer of VPU base addresses. */
#define VPU_BASE_ADDRS        { VPU_BASE }

/*******************************************************************************
 * HW_VPU_CodeRun - BIT Processor run start
 ******************************************************************************/

/*!
 * @brief HW_VPU_CodeRun - BIT Processor run start (WO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU Code Run Register
 * and the table below for description of the bit fields in the register.
 */
typedef union _hw_vpu_coderun
{
    uint32_t U;
    struct _hw_vpu_coderun_bitfields
    {
        uint32_t CodeRun : 1;          /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_vpu_coderun_t;

/*!
 * @name Constants and macros for entire VPU_CodeRun register
 */
/*@{*/
#define HW_VPU_CodeRun_ADDR(x)   ((uintptr_t)(x) + 0x0U)

#define HW_VPU_CodeRun(x)        (*(__O hw_vpu_coderun_t *) HW_VPU_CodeRun_ADDR(x))
#define HW_VPU_CodeRun_WR(x, v)  (HW_VPU_CodeRun(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual VPU_CodeRun bitfields
 */

/*!
 * @name Register VPU_CodeRun, field CodeRun[0] (WO)
 *
 * VPU_CodeRun. BIT processor run start bit.
 *
 * Values:
 * - 0 - BIT Processor stop execution.
 * - 1 - BIT Processor start execution.
 */
/*@{*/
#define BP_VPU_CodeRun_CodeRun (0U)        /*!< Bit position for VPU_CodeRun_CodeRun. */
#define BM_VPU_CodeRun_CodeRun (0x00000001U) /*!< Bit mask for VPU_CodeRun_CodeRun. */
#define BS_VPU_CodeRun_CodeRun (1U)        /*!< Bit field size in bits for VPU_CodeRun_CodeRun. */

/*! @brief Format value for bitfield VPU_CodeRun_CodeRun. */
#define BF_VPU_CodeRun_CodeRun(v) ((uint32_t)((uint32_t)(v) << BP_VPU_CodeRun_CodeRun) & BM_VPU_CodeRun_CodeRun)
/*@}*/

/*******************************************************************************
 * HW_VPU_CodeDown - BIT Boot Code Download Data register
 ******************************************************************************/

/*!
 * @brief HW_VPU_CodeDown - BIT Boot Code Download Data register (WO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU BIT Boot Code
 * Download Data Register and the following table for description of the bit fields
 * in the register.
 */
typedef union _hw_vpu_codedown
{
    uint32_t U;
    struct _hw_vpu_codedown_bitfields
    {
        uint32_t CodeData : 16;        /*!< [15:0]  */
        uint32_t CodeAddr : 13;        /*!< [28:16]  */
        uint32_t RESERVED0 : 3;        /*!< [31:29]  */
    } B;
} hw_vpu_codedown_t;

/*!
 * @name Constants and macros for entire VPU_CodeDown register
 */
/*@{*/
#define HW_VPU_CodeDown_ADDR(x)  ((uintptr_t)(x) + 0x4U)

#define HW_VPU_CodeDown(x)       (*(__O hw_vpu_codedown_t *) HW_VPU_CodeDown_ADDR(x))
#define HW_VPU_CodeDown_WR(x, v) (HW_VPU_CodeDown(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual VPU_CodeDown bitfields
 */

/*!
 * @name Register VPU_CodeDown, field CodeData[15:0] (WO)
 *
 * CodeData[15:0] Download data of VPU BIT boot code.
 */
/*@{*/
#define BP_VPU_CodeDown_CodeData (0U)      /*!< Bit position for VPU_CodeDown_CodeData. */
#define BM_VPU_CodeDown_CodeData (0x0000FFFFU) /*!< Bit mask for VPU_CodeDown_CodeData. */
#define BS_VPU_CodeDown_CodeData (16U)     /*!< Bit field size in bits for VPU_CodeDown_CodeData. */

/*! @brief Format value for bitfield VPU_CodeDown_CodeData. */
#define BF_VPU_CodeDown_CodeData(v) ((uint32_t)((uint32_t)(v) << BP_VPU_CodeDown_CodeData) & BM_VPU_CodeDown_CodeData)
/*@}*/

/*!
 * @name Register VPU_CodeDown, field CodeAddr[28:16] (WO)
 *
 * CodeAddr[12:0] Download address of VPU BIT boot code, which is VPU internal
 * address of BIT processor.
 */
/*@{*/
#define BP_VPU_CodeDown_CodeAddr (16U)     /*!< Bit position for VPU_CodeDown_CodeAddr. */
#define BM_VPU_CodeDown_CodeAddr (0x1FFF0000U) /*!< Bit mask for VPU_CodeDown_CodeAddr. */
#define BS_VPU_CodeDown_CodeAddr (13U)     /*!< Bit field size in bits for VPU_CodeDown_CodeAddr. */

/*! @brief Format value for bitfield VPU_CodeDown_CodeAddr. */
#define BF_VPU_CodeDown_CodeAddr(v) ((uint32_t)((uint32_t)(v) << BP_VPU_CodeDown_CodeAddr) & BM_VPU_CodeDown_CodeAddr)
/*@}*/

/*******************************************************************************
 * HW_VPU_HostIntReq - Host Interrupt Request to BIT
 ******************************************************************************/

/*!
 * @brief HW_VPU_HostIntReq - Host Interrupt Request to BIT (WO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU Host Interrupt
 * Request Register and the following table for description of the bit fields in the
 * register.
 */
typedef union _hw_vpu_hostintreq
{
    uint32_t U;
    struct _hw_vpu_hostintreq_bitfields
    {
        uint32_t IntReq : 1;           /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_vpu_hostintreq_t;

/*!
 * @name Constants and macros for entire VPU_HostIntReq register
 */
/*@{*/
#define HW_VPU_HostIntReq_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_VPU_HostIntReq(x)     (*(__O hw_vpu_hostintreq_t *) HW_VPU_HostIntReq_ADDR(x))
#define HW_VPU_HostIntReq_WR(x, v) (HW_VPU_HostIntReq(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual VPU_HostIntReq bitfields
 */

/*!
 * @name Register VPU_HostIntReq, field IntReq[0] (WO)
 *
 * IntReq. The host interrupt request bit.
 *
 * Values:
 * - 0 - No host interrupt is requested.
 * - 1 - The host processor request interrupt to the BIT processor.
 */
/*@{*/
#define BP_VPU_HostIntReq_IntReq (0U)      /*!< Bit position for VPU_HostIntReq_IntReq. */
#define BM_VPU_HostIntReq_IntReq (0x00000001U) /*!< Bit mask for VPU_HostIntReq_IntReq. */
#define BS_VPU_HostIntReq_IntReq (1U)      /*!< Bit field size in bits for VPU_HostIntReq_IntReq. */

/*! @brief Format value for bitfield VPU_HostIntReq_IntReq. */
#define BF_VPU_HostIntReq_IntReq(v) ((uint32_t)((uint32_t)(v) << BP_VPU_HostIntReq_IntReq) & BM_VPU_HostIntReq_IntReq)
/*@}*/

/*******************************************************************************
 * HW_VPU_BitIntClear - BIT Interrupt Clear
 ******************************************************************************/

/*!
 * @brief HW_VPU_BitIntClear - BIT Interrupt Clear (WO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU BIT Interrupt
 * Clear Register and the following table for description of the bit fields in the
 * register.
 */
typedef union _hw_vpu_bitintclear
{
    uint32_t U;
    struct _hw_vpu_bitintclear_bitfields
    {
        uint32_t IntClear : 1;         /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_vpu_bitintclear_t;

/*!
 * @name Constants and macros for entire VPU_BitIntClear register
 */
/*@{*/
#define HW_VPU_BitIntClear_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_VPU_BitIntClear(x)    (*(__O hw_vpu_bitintclear_t *) HW_VPU_BitIntClear_ADDR(x))
#define HW_VPU_BitIntClear_WR(x, v) (HW_VPU_BitIntClear(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual VPU_BitIntClear bitfields
 */

/*!
 * @name Register VPU_BitIntClear, field IntClear[0] (WO)
 *
 * IntClear. BIT interrupt clear bit.
 *
 * Values:
 * - 0 - No operation is issued.
 * - 1 - Clear the BIT interrupt to the host.
 */
/*@{*/
#define BP_VPU_BitIntClear_IntClear (0U)   /*!< Bit position for VPU_BitIntClear_IntClear. */
#define BM_VPU_BitIntClear_IntClear (0x00000001U) /*!< Bit mask for VPU_BitIntClear_IntClear. */
#define BS_VPU_BitIntClear_IntClear (1U)   /*!< Bit field size in bits for VPU_BitIntClear_IntClear. */

/*! @brief Format value for bitfield VPU_BitIntClear_IntClear. */
#define BF_VPU_BitIntClear_IntClear(v) ((uint32_t)((uint32_t)(v) << BP_VPU_BitIntClear_IntClear) & BM_VPU_BitIntClear_IntClear)
/*@}*/

/*******************************************************************************
 * HW_VPU_BitIntSts - BIT Interrupt Status
 ******************************************************************************/

/*!
 * @brief HW_VPU_BitIntSts - BIT Interrupt Status (RO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU BIT Interrupt
 * Status Register and the following table for description of the bit fields in the
 * register.
 */
typedef union _hw_vpu_bitintsts
{
    uint32_t U;
    struct _hw_vpu_bitintsts_bitfields
    {
        uint32_t IntSts : 1;           /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_vpu_bitintsts_t;

/*!
 * @name Constants and macros for entire VPU_BitIntSts register
 */
/*@{*/
#define HW_VPU_BitIntSts_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_VPU_BitIntSts(x)      (*(__I hw_vpu_bitintsts_t *) HW_VPU_BitIntSts_ADDR(x))
#define HW_VPU_BitIntSts_RD(x)   (HW_VPU_BitIntSts(x).U)
/*@}*/

/*
 * Constants & macros for individual VPU_BitIntSts bitfields
 */

/*!
 * @name Register VPU_BitIntSts, field IntSts[0] (RO)
 *
 * IntSts. BIT interrupt status bit.
 *
 * Values:
 * - 0 - No BIT interrupt is asserted.
 * - 1 - The BIT interrupt is asserted to the host. It is cleared when the host
 *     processor write "1" to VPU_BitIntClear register.
 */
/*@{*/
#define BP_VPU_BitIntSts_IntSts (0U)       /*!< Bit position for VPU_BitIntSts_IntSts. */
#define BM_VPU_BitIntSts_IntSts (0x00000001U) /*!< Bit mask for VPU_BitIntSts_IntSts. */
#define BS_VPU_BitIntSts_IntSts (1U)       /*!< Bit field size in bits for VPU_BitIntSts_IntSts. */

/*! @brief Read current value of the VPU_BitIntSts_IntSts field. */
#define BR_VPU_BitIntSts_IntSts(x) (HW_VPU_BitIntSts(x).B.IntSts)
/*@}*/

/*******************************************************************************
 * HW_VPU_BitCurPc - BIT Current PC
 ******************************************************************************/

/*!
 * @brief HW_VPU_BitCurPc - BIT Current PC (RO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU BIT Current PC
 * Register and the following table for description of the bit fields in the
 * register.
 */
typedef union _hw_vpu_bitcurpc
{
    uint32_t U;
    struct _hw_vpu_bitcurpc_bitfields
    {
        uint32_t CurPc : 14;           /*!< [13:0]  */
        uint32_t RESERVED0 : 18;       /*!< [31:14]  */
    } B;
} hw_vpu_bitcurpc_t;

/*!
 * @name Constants and macros for entire VPU_BitCurPc register
 */
/*@{*/
#define HW_VPU_BitCurPc_ADDR(x)  ((uintptr_t)(x) + 0x18U)

#define HW_VPU_BitCurPc(x)       (*(__I hw_vpu_bitcurpc_t *) HW_VPU_BitCurPc_ADDR(x))
#define HW_VPU_BitCurPc_RD(x)    (HW_VPU_BitCurPc(x).U)
/*@}*/

/*
 * Constants & macros for individual VPU_BitCurPc bitfields
 */

/*!
 * @name Register VPU_BitCurPc, field CurPc[13:0] (RO)
 *
 * CurPc[13:0]. BIT current PC value. Returns the current program counter of BIT
 * processor by reading this register.
 */
/*@{*/
#define BP_VPU_BitCurPc_CurPc (0U)         /*!< Bit position for VPU_BitCurPc_CurPc. */
#define BM_VPU_BitCurPc_CurPc (0x00003FFFU) /*!< Bit mask for VPU_BitCurPc_CurPc. */
#define BS_VPU_BitCurPc_CurPc (14U)        /*!< Bit field size in bits for VPU_BitCurPc_CurPc. */

/*! @brief Read current value of the VPU_BitCurPc_CurPc field. */
#define BR_VPU_BitCurPc_CurPc(x) (HW_VPU_BitCurPc(x).B.CurPc)
/*@}*/

/*******************************************************************************
 * HW_VPU_BitCodecBusy - BIT CODEC Busy
 ******************************************************************************/

/*!
 * @brief HW_VPU_BitCodecBusy - BIT CODEC Busy (RO)
 *
 * Reset value: 0x00000000U
 *
 * See the figure below for illustration of valid bits in VPU BIT Codec Busy
 * Register and the following table for description of the bit fields in the
 * register.
 */
typedef union _hw_vpu_bitcodecbusy
{
    uint32_t U;
    struct _hw_vpu_bitcodecbusy_bitfields
    {
        uint32_t CodecBusy : 1;        /*!< [0]  */
        uint32_t RESERVED0 : 31;       /*!< [31:1]  */
    } B;
} hw_vpu_bitcodecbusy_t;

/*!
 * @name Constants and macros for entire VPU_BitCodecBusy register
 */
/*@{*/
#define HW_VPU_BitCodecBusy_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_VPU_BitCodecBusy(x)   (*(__I hw_vpu_bitcodecbusy_t *) HW_VPU_BitCodecBusy_ADDR(x))
#define HW_VPU_BitCodecBusy_RD(x) (HW_VPU_BitCodecBusy(x).U)
/*@}*/

/*
 * Constants & macros for individual VPU_BitCodecBusy bitfields
 */

/*!
 * @name Register VPU_BitCodecBusy, field CodecBusy[0] (RO)
 *
 * Codec busy flag for Bit processor.BIT processor write "1"to this register
 * when the processor is running."0"means processor is waiting for a command.This
 * value is connected to the o_vpu_idle.
 */
/*@{*/
#define BP_VPU_BitCodecBusy_CodecBusy (0U) /*!< Bit position for VPU_BitCodecBusy_CodecBusy. */
#define BM_VPU_BitCodecBusy_CodecBusy (0x00000001U) /*!< Bit mask for VPU_BitCodecBusy_CodecBusy. */
#define BS_VPU_BitCodecBusy_CodecBusy (1U) /*!< Bit field size in bits for VPU_BitCodecBusy_CodecBusy. */

/*! @brief Read current value of the VPU_BitCodecBusy_CodecBusy field. */
#define BR_VPU_BitCodecBusy_CodecBusy(x) (HW_VPU_BitCodecBusy(x).B.CodecBusy)
/*@}*/

/*******************************************************************************
 * hw_vpu_t - module struct
 ******************************************************************************/
/*!
 * @brief All VPU module registers.
 */
#pragma pack(1)
typedef struct _hw_vpu
{
    __O hw_vpu_coderun_t CodeRun;          /*!< [0x0] BIT Processor run start */
    __O hw_vpu_codedown_t CodeDown;        /*!< [0x4] BIT Boot Code Download Data register */
    __O hw_vpu_hostintreq_t HostIntReq;    /*!< [0x8] Host Interrupt Request to BIT */
    __O hw_vpu_bitintclear_t BitIntClear;  /*!< [0xC] BIT Interrupt Clear */
    __I hw_vpu_bitintsts_t BitIntSts;      /*!< [0x10] BIT Interrupt Status */
    uint8_t _reserved0[4];
    __I hw_vpu_bitcurpc_t BitCurPc;        /*!< [0x18] BIT Current PC */
    uint8_t _reserved1[4];
    __I hw_vpu_bitcodecbusy_t BitCodecBusy; /*!< [0x20] BIT CODEC Busy */
} hw_vpu_t;
#pragma pack()

/*! @brief Macro to access all VPU registers. */
/*! @param x VPU module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_VPU_REGS(VPU_BASE)</code>. */
#define HW_VPU_REGS(x) (*(hw_vpu_t *)(x))

/*
 * iMX6DP WDOG
 *
 * WDOG
 *
 * Registers defined in this header file:
 * - HW_WDOG_WCR - Watchdog Control Register
 * - HW_WDOG_WSR - Watchdog Service Register
 * - HW_WDOG_WRSR - Watchdog Reset Status Register
 * - HW_WDOG_WICR - Watchdog Interrupt Control Register
 * - HW_WDOG_WMCR - Watchdog Miscellaneous Control Register
 *
 * - hw_wdog_t - Struct containing all module registers.
 */

#define HW_WDOG_INSTANCE_COUNT (2U) /*!< Number of instances of the WDOG module. */
#define HW_WDOG1 (0U) /*!< Instance number for WDOG1. */
#define HW_WDOG2 (1U) /*!< Instance number for WDOG2. */
#define WDOG1_BASE            (0x20BC000U) /*!< Base address for WDOG1. */
#define WDOG2_BASE            (0x20C0000U) /*!< Base address for WDOG2. */
/*! Array initializer of WDOG base addresses. */
#define WDOG_BASE_ADDRS       { WDOG1_BASE, WDOG2_BASE }

/*******************************************************************************
 * HW_WDOG_WCR - Watchdog Control Register
 ******************************************************************************/

/*!
 * @brief HW_WDOG_WCR - Watchdog Control Register (RW)
 *
 * Reset value: 0x0030U
 *
 * The Watchdog Control Register (WDOG_WCR) controls the WDOG operation. WDZST,
 * WDBG and WDW are write-once only bits. Once the software does a write access
 * to these bits, they will be locked and cannot be reprogrammed until the next
 * system reset assertion. WDE is a write one once only bit. Once software performs
 * a write "1" operation to this bit it cannot be reset/cleared until the next
 * system reset. WDT is also a write one once only bit. Once software performs a
 * write "1" operation to this bit it cannot be reset/cleared until the next POR.
 * This bit does not get reset/cleared due to any system reset.
 */
typedef union _hw_wdog_wcr
{
    uint16_t U;
    struct _hw_wdog_wcr_bitfields
    {
        uint16_t WDZST : 1;            /*!< [0]  */
        uint16_t WDBG : 1;             /*!< [1]  */
        uint16_t WDE : 1;              /*!< [2]  */
        uint16_t WDT : 1;              /*!< [3]  */
        uint16_t SRS : 1;              /*!< [4]  */
        uint16_t WDA : 1;              /*!< [5]  */
        uint16_t SRE : 1;              /*!< [6] software reset extension, an option way to
                                        * generate software reset */
        uint16_t WDW : 1;              /*!< [7]  */
        uint16_t WT : 8;               /*!< [15:8]  */
    } B;
} hw_wdog_wcr_t;

/*!
 * @name Constants and macros for entire WDOG_WCR register
 */
/*@{*/
#define HW_WDOG_WCR_ADDR(x)      ((uintptr_t)(x) + 0x0U)

#define HW_WDOG_WCR(x)           (*(__IO hw_wdog_wcr_t *) HW_WDOG_WCR_ADDR(x))
#define HW_WDOG_WCR_RD(x)        (HW_WDOG_WCR(x).U)
#define HW_WDOG_WCR_WR(x, v)     (HW_WDOG_WCR(x).U = (v))
#define HW_WDOG_WCR_SET(x, v)    (HW_WDOG_WCR_WR(x, HW_WDOG_WCR_RD(x) |  (v)))
#define HW_WDOG_WCR_CLR(x, v)    (HW_WDOG_WCR_WR(x, HW_WDOG_WCR_RD(x) & ~(v)))
#define HW_WDOG_WCR_TOG(x, v)    (HW_WDOG_WCR_WR(x, HW_WDOG_WCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual WDOG_WCR bitfields
 */

/*!
 * @name Register WDOG_WCR, field WDZST[0] (RW)
 *
 * Watchdog Low Power. Determines the operation of the WDOG during low-power
 * modes. This bit is write once-only. The WDOG can continue/suspend the timer
 * operation in the low-power modes (STOP and DOZE mode).
 *
 * Values:
 * - 0 - Continue timer operation (Default).
 * - 1 - Suspend the watchdog timer.
 */
/*@{*/
#define BP_WDOG_WCR_WDZST    (0U)          /*!< Bit position for WDOG_WCR_WDZST. */
#define BM_WDOG_WCR_WDZST    (0x0001U)     /*!< Bit mask for WDOG_WCR_WDZST. */
#define BS_WDOG_WCR_WDZST    (1U)          /*!< Bit field size in bits for WDOG_WCR_WDZST. */

/*! @brief Read current value of the WDOG_WCR_WDZST field. */
#define BR_WDOG_WCR_WDZST(x) (HW_WDOG_WCR(x).B.WDZST)

/*! @brief Format value for bitfield WDOG_WCR_WDZST. */
#define BF_WDOG_WCR_WDZST(v) ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDZST) & BM_WDOG_WCR_WDZST)

/*! @brief Set the WDZST field to a new value. */
#define BW_WDOG_WCR_WDZST(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDZST) | BF_WDOG_WCR_WDZST(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WDBG[1] (RW)
 *
 * Watchdog DEBUG Enable. Determines the operation of the WDOG during DEBUG
 * mode. This bit is write once only.
 *
 * Values:
 * - 0 - Continue WDOG timer operation (Default).
 * - 1 - Suspend the watchdog timer.
 */
/*@{*/
#define BP_WDOG_WCR_WDBG     (1U)          /*!< Bit position for WDOG_WCR_WDBG. */
#define BM_WDOG_WCR_WDBG     (0x0002U)     /*!< Bit mask for WDOG_WCR_WDBG. */
#define BS_WDOG_WCR_WDBG     (1U)          /*!< Bit field size in bits for WDOG_WCR_WDBG. */

/*! @brief Read current value of the WDOG_WCR_WDBG field. */
#define BR_WDOG_WCR_WDBG(x)  (HW_WDOG_WCR(x).B.WDBG)

/*! @brief Format value for bitfield WDOG_WCR_WDBG. */
#define BF_WDOG_WCR_WDBG(v)  ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDBG) & BM_WDOG_WCR_WDBG)

/*! @brief Set the WDBG field to a new value. */
#define BW_WDOG_WCR_WDBG(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDBG) | BF_WDOG_WCR_WDBG(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WDE[2] (RW)
 *
 * Watchdog Enable. Enables or disables the WDOG block. This is a write one once
 * only bit. It is not possible to clear this bit by a software write, once the
 * bit is set. This bit can be set/reset in debug mode (exception).
 *
 * Values:
 * - 0 - Disable the Watchdog (Default).
 * - 1 - Enable the Watchdog.
 */
/*@{*/
#define BP_WDOG_WCR_WDE      (2U)          /*!< Bit position for WDOG_WCR_WDE. */
#define BM_WDOG_WCR_WDE      (0x0004U)     /*!< Bit mask for WDOG_WCR_WDE. */
#define BS_WDOG_WCR_WDE      (1U)          /*!< Bit field size in bits for WDOG_WCR_WDE. */

/*! @brief Read current value of the WDOG_WCR_WDE field. */
#define BR_WDOG_WCR_WDE(x)   (HW_WDOG_WCR(x).B.WDE)

/*! @brief Format value for bitfield WDOG_WCR_WDE. */
#define BF_WDOG_WCR_WDE(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDE) & BM_WDOG_WCR_WDE)

/*! @brief Set the WDE field to a new value. */
#define BW_WDOG_WCR_WDE(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDE) | BF_WDOG_WCR_WDE(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WDT[3] (RW)
 *
 * WDOG_B Time-out assertion. Determines if the WDOG_B gets asserted upon a
 * Watchdog Time-out Event. This is a write-one once only bit. There is no effect on
 * WDOG_RESET_B_DEB (WDOG Reset) upon writing on this bit. WDOG_B gets asserted
 * along with WDOG_RESET_B_DEB if this bit is set.
 *
 * Values:
 * - 0 - No effect on WDOG_B (Default).
 * - 1 - Assert WDOG_B upon a Watchdog Time-out event.
 */
/*@{*/
#define BP_WDOG_WCR_WDT      (3U)          /*!< Bit position for WDOG_WCR_WDT. */
#define BM_WDOG_WCR_WDT      (0x0008U)     /*!< Bit mask for WDOG_WCR_WDT. */
#define BS_WDOG_WCR_WDT      (1U)          /*!< Bit field size in bits for WDOG_WCR_WDT. */

/*! @brief Read current value of the WDOG_WCR_WDT field. */
#define BR_WDOG_WCR_WDT(x)   (HW_WDOG_WCR(x).B.WDT)

/*! @brief Format value for bitfield WDOG_WCR_WDT. */
#define BF_WDOG_WCR_WDT(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDT) & BM_WDOG_WCR_WDT)

/*! @brief Set the WDT field to a new value. */
#define BW_WDOG_WCR_WDT(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDT) | BF_WDOG_WCR_WDT(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field SRS[4] (RW)
 *
 * Software Reset Signal. Controls the software assertion of the WDOG-generated
 * reset signal WDOG_RESET_B_DEB . This bit automatically resets to "1" after it
 * has been asserted to "0". This bit does not generate the software reset to the
 * block.
 *
 * Values:
 * - 0 - Assert system reset signal.
 * - 1 - No effect on the system (Default).
 */
/*@{*/
#define BP_WDOG_WCR_SRS      (4U)          /*!< Bit position for WDOG_WCR_SRS. */
#define BM_WDOG_WCR_SRS      (0x0010U)     /*!< Bit mask for WDOG_WCR_SRS. */
#define BS_WDOG_WCR_SRS      (1U)          /*!< Bit field size in bits for WDOG_WCR_SRS. */

/*! @brief Read current value of the WDOG_WCR_SRS field. */
#define BR_WDOG_WCR_SRS(x)   (HW_WDOG_WCR(x).B.SRS)

/*! @brief Format value for bitfield WDOG_WCR_SRS. */
#define BF_WDOG_WCR_SRS(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_SRS) & BM_WDOG_WCR_SRS)

/*! @brief Set the SRS field to a new value. */
#define BW_WDOG_WCR_SRS(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_SRS) | BF_WDOG_WCR_SRS(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WDA[5] (RW)
 *
 * WDOG_B assertion. Controls the software assertion of the WDOG_B signal.
 *
 * Values:
 * - 0 - Assert WDOG_B output.
 * - 1 - No effect on system (Default).
 */
/*@{*/
#define BP_WDOG_WCR_WDA      (5U)          /*!< Bit position for WDOG_WCR_WDA. */
#define BM_WDOG_WCR_WDA      (0x0020U)     /*!< Bit mask for WDOG_WCR_WDA. */
#define BS_WDOG_WCR_WDA      (1U)          /*!< Bit field size in bits for WDOG_WCR_WDA. */

/*! @brief Read current value of the WDOG_WCR_WDA field. */
#define BR_WDOG_WCR_WDA(x)   (HW_WDOG_WCR(x).B.WDA)

/*! @brief Format value for bitfield WDOG_WCR_WDA. */
#define BF_WDOG_WCR_WDA(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDA) & BM_WDOG_WCR_WDA)

/*! @brief Set the WDA field to a new value. */
#define BW_WDOG_WCR_WDA(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDA) | BF_WDOG_WCR_WDA(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field SRE[6] (RW)
 *
 * adopt a new way to generate a more robust software reset. This bit can be
 * set/clear with IP bus and will be reset with power-on reset .
 *
 * Values:
 * - 0 - using original way to generate software reset (default)
 * - 1 - using new way to generate software reset.
 */
/*@{*/
#define BP_WDOG_WCR_SRE      (6U)          /*!< Bit position for WDOG_WCR_SRE. */
#define BM_WDOG_WCR_SRE      (0x0040U)     /*!< Bit mask for WDOG_WCR_SRE. */
#define BS_WDOG_WCR_SRE      (1U)          /*!< Bit field size in bits for WDOG_WCR_SRE. */

/*! @brief Read current value of the WDOG_WCR_SRE field. */
#define BR_WDOG_WCR_SRE(x)   (HW_WDOG_WCR(x).B.SRE)

/*! @brief Format value for bitfield WDOG_WCR_SRE. */
#define BF_WDOG_WCR_SRE(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_SRE) & BM_WDOG_WCR_SRE)

/*! @brief Set the SRE field to a new value. */
#define BW_WDOG_WCR_SRE(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_SRE) | BF_WDOG_WCR_SRE(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WDW[7] (RW)
 *
 * Watchdog Disable for Wait. This bit determines the operation of WDOG during
 * Low Power WAIT mode. This is a write once only bit.
 *
 * Values:
 * - 0 - Continue WDOG timer operation (Default).
 * - 1 - Suspend WDOG timer operation.
 */
/*@{*/
#define BP_WDOG_WCR_WDW      (7U)          /*!< Bit position for WDOG_WCR_WDW. */
#define BM_WDOG_WCR_WDW      (0x0080U)     /*!< Bit mask for WDOG_WCR_WDW. */
#define BS_WDOG_WCR_WDW      (1U)          /*!< Bit field size in bits for WDOG_WCR_WDW. */

/*! @brief Read current value of the WDOG_WCR_WDW field. */
#define BR_WDOG_WCR_WDW(x)   (HW_WDOG_WCR(x).B.WDW)

/*! @brief Format value for bitfield WDOG_WCR_WDW. */
#define BF_WDOG_WCR_WDW(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WDW) & BM_WDOG_WCR_WDW)

/*! @brief Set the WDW field to a new value. */
#define BW_WDOG_WCR_WDW(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WDW) | BF_WDOG_WCR_WDW(v)))
/*@}*/

/*!
 * @name Register WDOG_WCR, field WT[15:8] (RW)
 *
 * Watchdog Time-out Field. This 8-bit field contains the time-out value that is
 * loaded into the Watchdog counter after the service routine has been performed
 * or after the Watchdog is enabled. After reset, WT[7:0] must have a value
 * written to it before enabling the Watchdog otherwise count value of zero which is
 * 0.5 seconds is loaded into the counter. The time-out value can be written at
 * any point of time but it is loaded to the counter at the time when WDOG is
 * enabled or after the service routine has been performed. For more information see
 * Timeout eventThe WDOG provides timeout periods from 0.5 to 128 seconds with a
 * time resolution of 0.5 seconds. .
 *
 * Values:
 * - 0 - - 0.5 Seconds (Default).
 * - 1 - - 1.0 Seconds.
 * - 10 - - 1.5 Seconds.
 * - 11 - - 2.0 Seconds.
 * - 11111111 - - 128 Seconds.
 */
/*@{*/
#define BP_WDOG_WCR_WT       (8U)          /*!< Bit position for WDOG_WCR_WT. */
#define BM_WDOG_WCR_WT       (0xFF00U)     /*!< Bit mask for WDOG_WCR_WT. */
#define BS_WDOG_WCR_WT       (8U)          /*!< Bit field size in bits for WDOG_WCR_WT. */

/*! @brief Read current value of the WDOG_WCR_WT field. */
#define BR_WDOG_WCR_WT(x)    (HW_WDOG_WCR(x).B.WT)

/*! @brief Format value for bitfield WDOG_WCR_WT. */
#define BF_WDOG_WCR_WT(v)    ((uint16_t)((uint16_t)(v) << BP_WDOG_WCR_WT) & BM_WDOG_WCR_WT)

/*! @brief Set the WT field to a new value. */
#define BW_WDOG_WCR_WT(x, v) (HW_WDOG_WCR_WR(x, (HW_WDOG_WCR_RD(x) & ~BM_WDOG_WCR_WT) | BF_WDOG_WCR_WT(v)))
/*@}*/

/*******************************************************************************
 * HW_WDOG_WSR - Watchdog Service Register
 ******************************************************************************/

/*!
 * @brief HW_WDOG_WSR - Watchdog Service Register (RW)
 *
 * Reset value: 0x0000U
 *
 * When enabled, the WDOG requires that a service sequence be written to the
 * Watchdog Service Register (WSR) to prevent the timeout condition. Executing the
 * service sequence will reload the WDOG timeout counter.
 */
typedef union _hw_wdog_wsr
{
    uint16_t U;
    struct _hw_wdog_wsr_bitfields
    {
        uint16_t WSR : 16;             /*!< [15:0]  */
    } B;
} hw_wdog_wsr_t;

/*!
 * @name Constants and macros for entire WDOG_WSR register
 */
/*@{*/
#define HW_WDOG_WSR_ADDR(x)      ((uintptr_t)(x) + 0x2U)

#define HW_WDOG_WSR(x)           (*(__IO hw_wdog_wsr_t *) HW_WDOG_WSR_ADDR(x))
#define HW_WDOG_WSR_RD(x)        (HW_WDOG_WSR(x).U)
#define HW_WDOG_WSR_WR(x, v)     (HW_WDOG_WSR(x).U = (v))
#define HW_WDOG_WSR_SET(x, v)    (HW_WDOG_WSR_WR(x, HW_WDOG_WSR_RD(x) |  (v)))
#define HW_WDOG_WSR_CLR(x, v)    (HW_WDOG_WSR_WR(x, HW_WDOG_WSR_RD(x) & ~(v)))
#define HW_WDOG_WSR_TOG(x, v)    (HW_WDOG_WSR_WR(x, HW_WDOG_WSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual WDOG_WSR bitfields
 */

/*!
 * @name Register WDOG_WSR, field WSR[15:0] (RW)
 *
 * Watchdog Service Register. This 16-bit field contains the Watchdog service
 * sequence. Both writes must occur in the order listed prior to the time-out, but
 * any number of instructions can be executed between the two writes. The service
 * sequence must be performed as follows:
 *
 * Values:
 * - 101010101010101 - Write to the Watchdog Service Register (WDOG_WSR).
 * - 1010101010101010 - Write to the Watchdog Service Register (WDOG_WSR).
 */
/*@{*/
#define BP_WDOG_WSR_WSR      (0U)          /*!< Bit position for WDOG_WSR_WSR. */
#define BM_WDOG_WSR_WSR      (0xFFFFU)     /*!< Bit mask for WDOG_WSR_WSR. */
#define BS_WDOG_WSR_WSR      (16U)         /*!< Bit field size in bits for WDOG_WSR_WSR. */

/*! @brief Read current value of the WDOG_WSR_WSR field. */
#define BR_WDOG_WSR_WSR(x)   (HW_WDOG_WSR(x).U)

/*! @brief Format value for bitfield WDOG_WSR_WSR. */
#define BF_WDOG_WSR_WSR(v)   ((uint16_t)((uint16_t)(v) << BP_WDOG_WSR_WSR) & BM_WDOG_WSR_WSR)

/*! @brief Set the WSR field to a new value. */
#define BW_WDOG_WSR_WSR(x, v) (HW_WDOG_WSR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_WDOG_WRSR - Watchdog Reset Status Register
 ******************************************************************************/

/*!
 * @brief HW_WDOG_WRSR - Watchdog Reset Status Register (RO)
 *
 * Reset value: 0x0000U
 *
 * The WRSR is a read-only register that records the source of the output reset
 * assertion. It is not cleared by a hard reset. Therefore, only one bit in the
 * WRSR will always be asserted high. The register will always indicate the source
 * of the last reset generated due to WDOG. Read access to this register is with
 * one wait state. Any write performed on this register will generate a
 * Peripheral Bus Error . A reset can be generated by the following sources, as listed in
 * priority from highest to lowest: Watchdog Time-out Software Reset
 */
typedef union _hw_wdog_wrsr
{
    uint16_t U;
    struct _hw_wdog_wrsr_bitfields
    {
        uint16_t SFTW : 1;             /*!< [0]  */
        uint16_t TOUT : 1;             /*!< [1]  */
        uint16_t RESERVED0 : 2;        /*!< [3:2]  */
        uint16_t POR : 1;              /*!< [4]  */
        uint16_t RESERVED1 : 11;       /*!< [15:5]  */
    } B;
} hw_wdog_wrsr_t;

/*!
 * @name Constants and macros for entire WDOG_WRSR register
 */
/*@{*/
#define HW_WDOG_WRSR_ADDR(x)     ((uintptr_t)(x) + 0x4U)

#define HW_WDOG_WRSR(x)          (*(__I hw_wdog_wrsr_t *) HW_WDOG_WRSR_ADDR(x))
#define HW_WDOG_WRSR_RD(x)       (HW_WDOG_WRSR(x).U)
/*@}*/

/*
 * Constants & macros for individual WDOG_WRSR bitfields
 */

/*!
 * @name Register WDOG_WRSR, field SFTW[0] (RO)
 *
 * Software Reset. Indicates whether the reset is the result of a WDOG software
 * reset by asserting SRS bit
 *
 * Values:
 * - 0 - Reset is not the result of a software reset.
 * - 1 - Reset is the result of a software reset.
 */
/*@{*/
#define BP_WDOG_WRSR_SFTW    (0U)          /*!< Bit position for WDOG_WRSR_SFTW. */
#define BM_WDOG_WRSR_SFTW    (0x0001U)     /*!< Bit mask for WDOG_WRSR_SFTW. */
#define BS_WDOG_WRSR_SFTW    (1U)          /*!< Bit field size in bits for WDOG_WRSR_SFTW. */

/*! @brief Read current value of the WDOG_WRSR_SFTW field. */
#define BR_WDOG_WRSR_SFTW(x) (HW_WDOG_WRSR(x).B.SFTW)
/*@}*/

/*!
 * @name Register WDOG_WRSR, field TOUT[1] (RO)
 *
 * Timeout. Indicates whether the reset is the result of a WDOG timeout.
 *
 * Values:
 * - 0 - Reset is not the result of a WDOG timeout.
 * - 1 - Reset is the result of a WDOG timeout.
 */
/*@{*/
#define BP_WDOG_WRSR_TOUT    (1U)          /*!< Bit position for WDOG_WRSR_TOUT. */
#define BM_WDOG_WRSR_TOUT    (0x0002U)     /*!< Bit mask for WDOG_WRSR_TOUT. */
#define BS_WDOG_WRSR_TOUT    (1U)          /*!< Bit field size in bits for WDOG_WRSR_TOUT. */

/*! @brief Read current value of the WDOG_WRSR_TOUT field. */
#define BR_WDOG_WRSR_TOUT(x) (HW_WDOG_WRSR(x).B.TOUT)
/*@}*/

/*!
 * @name Register WDOG_WRSR, field POR[4] (RO)
 *
 * Power On Reset. Indicates whether the reset is the result of a power on reset.
 *
 * Values:
 * - 0 - Reset is not the result of a power on reset.
 * - 1 - Reset is the result of a power on reset.
 */
/*@{*/
#define BP_WDOG_WRSR_POR     (4U)          /*!< Bit position for WDOG_WRSR_POR. */
#define BM_WDOG_WRSR_POR     (0x0010U)     /*!< Bit mask for WDOG_WRSR_POR. */
#define BS_WDOG_WRSR_POR     (1U)          /*!< Bit field size in bits for WDOG_WRSR_POR. */

/*! @brief Read current value of the WDOG_WRSR_POR field. */
#define BR_WDOG_WRSR_POR(x)  (HW_WDOG_WRSR(x).B.POR)
/*@}*/

/*******************************************************************************
 * HW_WDOG_WICR - Watchdog Interrupt Control Register
 ******************************************************************************/

/*!
 * @brief HW_WDOG_WICR - Watchdog Interrupt Control Register (RW)
 *
 * Reset value: 0x0004U
 *
 * The WDOG_WICR controls the WDOG interrupt generation.
 */
typedef union _hw_wdog_wicr
{
    uint16_t U;
    struct _hw_wdog_wicr_bitfields
    {
        uint16_t WICT : 8;             /*!< [7:0]  */
        uint16_t RESERVED0 : 6;        /*!< [13:8]  */
        uint16_t WTIS : 1;             /*!< [14]  */
        uint16_t WIE : 1;              /*!< [15]  */
    } B;
} hw_wdog_wicr_t;

/*!
 * @name Constants and macros for entire WDOG_WICR register
 */
/*@{*/
#define HW_WDOG_WICR_ADDR(x)     ((uintptr_t)(x) + 0x6U)

#define HW_WDOG_WICR(x)          (*(__IO hw_wdog_wicr_t *) HW_WDOG_WICR_ADDR(x))
#define HW_WDOG_WICR_RD(x)       (HW_WDOG_WICR(x).U)
#define HW_WDOG_WICR_WR(x, v)    (HW_WDOG_WICR(x).U = (v))
#define HW_WDOG_WICR_SET(x, v)   (HW_WDOG_WICR_WR(x, HW_WDOG_WICR_RD(x) |  (v)))
#define HW_WDOG_WICR_CLR(x, v)   (HW_WDOG_WICR_WR(x, HW_WDOG_WICR_RD(x) & ~(v)))
#define HW_WDOG_WICR_TOG(x, v)   (HW_WDOG_WICR_WR(x, HW_WDOG_WICR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual WDOG_WICR bitfields
 */

/*!
 * @name Register WDOG_WICR, field WICT[7:0] (RW)
 *
 * Watchdog Interrupt Count Time-out (WICT) field determines, how long before
 * the counter time-out must the interrupt occur. The reset value is 0x04 implies
 * interrupt will occur 2 seconds before time-out. The maximum value that can be
 * programmed to WICT field is 127.5 seconds with a resolution of 0.5 seconds.
 * This field is write once only. Once the software does a write access to this
 * field, it will get locked and cannot be reprogrammed until the next system reset
 * assertion.
 *
 * Values:
 * - 0 - WICT[7:0] = Time duration between interrupt and time-out is 0 seconds.
 * - 1 - WICT[7:0] = Time duration between interrupt and time-out is 0.5 seconds.
 * - 100 - WICT[7:0] = Time duration between interrupt and time-out is 2 seconds
 *     (Default).
 * - 11111111 - WICT[7:0] = Time duration between interrupt and time-out is
 *     127.5 seconds.
 */
/*@{*/
#define BP_WDOG_WICR_WICT    (0U)          /*!< Bit position for WDOG_WICR_WICT. */
#define BM_WDOG_WICR_WICT    (0x00FFU)     /*!< Bit mask for WDOG_WICR_WICT. */
#define BS_WDOG_WICR_WICT    (8U)          /*!< Bit field size in bits for WDOG_WICR_WICT. */

/*! @brief Read current value of the WDOG_WICR_WICT field. */
#define BR_WDOG_WICR_WICT(x) (HW_WDOG_WICR(x).B.WICT)

/*! @brief Format value for bitfield WDOG_WICR_WICT. */
#define BF_WDOG_WICR_WICT(v) ((uint16_t)((uint16_t)(v) << BP_WDOG_WICR_WICT) & BM_WDOG_WICR_WICT)

/*! @brief Set the WICT field to a new value. */
#define BW_WDOG_WICR_WICT(x, v) (HW_WDOG_WICR_WR(x, (HW_WDOG_WICR_RD(x) & ~(BM_WDOG_WICR_WICT | BM_WDOG_WICR_WTIS)) | BF_WDOG_WICR_WICT(v)))
/*@}*/

/*!
 * @name Register WDOG_WICR, field WTIS[14] (W1C)
 *
 * Watchdog TImer Interrupt Status bit will reflect the timer interrupt status,
 * whether interrupt has occurred or not. Once the interrupt has been triggered
 * software must clear this bit by writing 1 to it.
 *
 * Values:
 * - 0 - No interrupt has occurred (Default).
 * - 1 - Interrupt has occurred
 */
/*@{*/
#define BP_WDOG_WICR_WTIS    (14U)         /*!< Bit position for WDOG_WICR_WTIS. */
#define BM_WDOG_WICR_WTIS    (0x4000U)     /*!< Bit mask for WDOG_WICR_WTIS. */
#define BS_WDOG_WICR_WTIS    (1U)          /*!< Bit field size in bits for WDOG_WICR_WTIS. */

/*! @brief Read current value of the WDOG_WICR_WTIS field. */
#define BR_WDOG_WICR_WTIS(x) (HW_WDOG_WICR(x).B.WTIS)

/*! @brief Format value for bitfield WDOG_WICR_WTIS. */
#define BF_WDOG_WICR_WTIS(v) ((uint16_t)((uint16_t)(v) << BP_WDOG_WICR_WTIS) & BM_WDOG_WICR_WTIS)

/*! @brief Set the WTIS field to a new value. */
#define BW_WDOG_WICR_WTIS(x, v) (HW_WDOG_WICR_WR(x, (HW_WDOG_WICR_RD(x) & ~BM_WDOG_WICR_WTIS) | BF_WDOG_WICR_WTIS(v)))
/*@}*/

/*!
 * @name Register WDOG_WICR, field WIE[15] (RW)
 *
 * Watchdog Timer Interrupt enable bit. Reset value is 0. This bit is a write
 * once only bit. Once the software does a write access to this bit, it will get
 * locked and cannot be reprogrammed until the next system reset assertion
 *
 * Values:
 * - 0 - Disable Interrupt (Default).
 * - 1 - Enable Interrupt.
 */
/*@{*/
#define BP_WDOG_WICR_WIE     (15U)         /*!< Bit position for WDOG_WICR_WIE. */
#define BM_WDOG_WICR_WIE     (0x8000U)     /*!< Bit mask for WDOG_WICR_WIE. */
#define BS_WDOG_WICR_WIE     (1U)          /*!< Bit field size in bits for WDOG_WICR_WIE. */

/*! @brief Read current value of the WDOG_WICR_WIE field. */
#define BR_WDOG_WICR_WIE(x)  (HW_WDOG_WICR(x).B.WIE)

/*! @brief Format value for bitfield WDOG_WICR_WIE. */
#define BF_WDOG_WICR_WIE(v)  ((uint16_t)((uint16_t)(v) << BP_WDOG_WICR_WIE) & BM_WDOG_WICR_WIE)

/*! @brief Set the WIE field to a new value. */
#define BW_WDOG_WICR_WIE(x, v) (HW_WDOG_WICR_WR(x, (HW_WDOG_WICR_RD(x) & ~(BM_WDOG_WICR_WIE | BM_WDOG_WICR_WTIS)) | BF_WDOG_WICR_WIE(v)))
/*@}*/

/*******************************************************************************
 * HW_WDOG_WMCR - Watchdog Miscellaneous Control Register
 ******************************************************************************/

/*!
 * @brief HW_WDOG_WMCR - Watchdog Miscellaneous Control Register (RW)
 *
 * Reset value: 0x0001U
 *
 * WDOG_WMCR Controls the Power Down counter operation.
 */
typedef union _hw_wdog_wmcr
{
    uint16_t U;
    struct _hw_wdog_wmcr_bitfields
    {
        uint16_t PDE : 1;              /*!< [0]  */
        uint16_t RESERVED0 : 15;       /*!< [15:1]  */
    } B;
} hw_wdog_wmcr_t;

/*!
 * @name Constants and macros for entire WDOG_WMCR register
 */
/*@{*/
#define HW_WDOG_WMCR_ADDR(x)     ((uintptr_t)(x) + 0x8U)

#define HW_WDOG_WMCR(x)          (*(__IO hw_wdog_wmcr_t *) HW_WDOG_WMCR_ADDR(x))
#define HW_WDOG_WMCR_RD(x)       (HW_WDOG_WMCR(x).U)
#define HW_WDOG_WMCR_WR(x, v)    (HW_WDOG_WMCR(x).U = (v))
#define HW_WDOG_WMCR_SET(x, v)   (HW_WDOG_WMCR_WR(x, HW_WDOG_WMCR_RD(x) |  (v)))
#define HW_WDOG_WMCR_CLR(x, v)   (HW_WDOG_WMCR_WR(x, HW_WDOG_WMCR_RD(x) & ~(v)))
#define HW_WDOG_WMCR_TOG(x, v)   (HW_WDOG_WMCR_WR(x, HW_WDOG_WMCR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual WDOG_WMCR bitfields
 */

/*!
 * @name Register WDOG_WMCR, field PDE[0] (RW)
 *
 * Power Down Enable bit. Reset value of this bit is 1, which means the power
 * down counter inside the WDOG is enabled after reset. The software must write 0
 * to this bit to disable the counter within 16 seconds of reset de-assertion.
 * Once disabled this counter cannot be enabled again. See Power-down counter
 * eventThe power-down counter inside WDOG will be enabled out of reset. This counter
 * has a fixed timeout value of 16 seconds, after which it will drive the WDOG_B
 * signal low. for operation of this counter. This bit is write-one once only bit.
 * Once software sets this bit it cannot be reset until the next system reset.
 *
 * Values:
 * - 0 - Power Down Counter of WDOG is disabled.
 * - 1 - Power Down Counter of WDOG is enabled (Default).
 */
/*@{*/
#define BP_WDOG_WMCR_PDE     (0U)          /*!< Bit position for WDOG_WMCR_PDE. */
#define BM_WDOG_WMCR_PDE     (0x0001U)     /*!< Bit mask for WDOG_WMCR_PDE. */
#define BS_WDOG_WMCR_PDE     (1U)          /*!< Bit field size in bits for WDOG_WMCR_PDE. */

/*! @brief Read current value of the WDOG_WMCR_PDE field. */
#define BR_WDOG_WMCR_PDE(x)  (HW_WDOG_WMCR(x).B.PDE)

/*! @brief Format value for bitfield WDOG_WMCR_PDE. */
#define BF_WDOG_WMCR_PDE(v)  ((uint16_t)((uint16_t)(v) << BP_WDOG_WMCR_PDE) & BM_WDOG_WMCR_PDE)

/*! @brief Set the PDE field to a new value. */
#define BW_WDOG_WMCR_PDE(x, v) (HW_WDOG_WMCR_WR(x, (HW_WDOG_WMCR_RD(x) & ~BM_WDOG_WMCR_PDE) | BF_WDOG_WMCR_PDE(v)))
/*@}*/

/*******************************************************************************
 * hw_wdog_t - module struct
 ******************************************************************************/
/*!
 * @brief All WDOG module registers.
 */
#pragma pack(1)
typedef struct _hw_wdog
{
    __IO hw_wdog_wcr_t WCR;                /*!< [0x0] Watchdog Control Register */
    __IO hw_wdog_wsr_t WSR;                /*!< [0x2] Watchdog Service Register */
    __I hw_wdog_wrsr_t WRSR;               /*!< [0x4] Watchdog Reset Status Register */
    __IO hw_wdog_wicr_t WICR;              /*!< [0x6] Watchdog Interrupt Control Register */
    __IO hw_wdog_wmcr_t WMCR;              /*!< [0x8] Watchdog Miscellaneous Control Register */
} hw_wdog_t;
#pragma pack()

/*! @brief Macro to access all WDOG registers. */
/*! @param x WDOG module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_WDOG_REGS(WDOG1_BASE)</code>. */
#define HW_WDOG_REGS(x) (*(hw_wdog_t *)(x))

/*
 * iMX6DP XTALOSC24M
 *
 * XTALOSC24M
 *
 * Registers defined in this header file:
 * - HW_XTALOSC24M_MISC0 - Miscellaneous Register 0
 *
 * - hw_xtalosc24m_t - Struct containing all module registers.
 */

#define HW_XTALOSC24M_INSTANCE_COUNT (1U) /*!< Number of instances of the XTALOSC24M module. */
#define HW_XTALOSC24M (0U) /*!< Instance number for XTALOSC24M. */
#define XTALOSC24M_BASE       (0x20C8000U) /*!< Base address for XTALOSC24M. */
/*! Array initializer of XTALOSC24M base addresses. */
#define XTALOSC24M_BASE_ADDRS { XTALOSC24M_BASE }

/*******************************************************************************
 * HW_XTALOSC24M_MISC0 - Miscellaneous Register 0
 ******************************************************************************/

/*!
 * @brief HW_XTALOSC24M_MISC0 - Miscellaneous Register 0 (RW)
 *
 * Reset value: 0x04000000U
 *
 * This register defines the control and status bits for miscellaneous analog
 * blocks.
 */
typedef union _hw_xtalosc24m_misc0
{
    uint32_t U;
    struct _hw_xtalosc24m_misc0_bitfields
    {
        uint32_t REFTOP_PWD : 1;       /*!< [0]  */
        uint32_t RESERVED0 : 2;        /*!< [2:1]  */
        uint32_t REFTOP_SELFBIASOFF : 1; /*!< [3]  */
        uint32_t REFTOP_VBGADJ : 3;    /*!< [6:4]  */
        uint32_t REFTOP_VBGUP : 1;     /*!< [7]  */
        uint32_t RESERVED1 : 4;        /*!< [11:8]  */
        uint32_t STOP_MODE_CONFIG : 1; /*!< [12]  */
        uint32_t RESERVED2 : 1;        /*!< [13]  */
        uint32_t OSC_I : 2;            /*!< [15:14]  */
        uint32_t OSC_XTALOK : 1;       /*!< [16]  */
        uint32_t OSC_XTALOK_EN : 1;    /*!< [17]  */
        uint32_t WBCP_VPW_THRESH : 2;  /*!< [19:18]  */
        uint32_t RESERVED3 : 5;        /*!< [24:20]  */
        uint32_t CLKGATE_CTRL : 1;     /*!< [25]  */
        uint32_t CLKGATE_DELAY : 3;    /*!< [28:26]  */
        uint32_t RESERVED4 : 3;        /*!< [31:29]  */
    } B;
} hw_xtalosc24m_misc0_t;

/*!
 * @name Constants and macros for entire XTALOSC24M_MISC0 register
 */
/*@{*/
#define HW_XTALOSC24M_MISC0_ADDR(x) ((uintptr_t)(x) + 0x150U)

#define HW_XTALOSC24M_MISC0(x)   (*(__IO hw_xtalosc24m_misc0_t *) HW_XTALOSC24M_MISC0_ADDR(x))
#define HW_XTALOSC24M_MISC0_RD(x) (HW_XTALOSC24M_MISC0(x).U)
#define HW_XTALOSC24M_MISC0_WR(x, v) (HW_XTALOSC24M_MISC0(x).U = (v))
#define HW_XTALOSC24M_MISC0_SET(x, v) (HW_XTALOSC24M_MISC0_WR(x, HW_XTALOSC24M_MISC0_RD(x) |  (v)))
#define HW_XTALOSC24M_MISC0_CLR(x, v) (HW_XTALOSC24M_MISC0_WR(x, HW_XTALOSC24M_MISC0_RD(x) & ~(v)))
#define HW_XTALOSC24M_MISC0_TOG(x, v) (HW_XTALOSC24M_MISC0_WR(x, HW_XTALOSC24M_MISC0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual XTALOSC24M_MISC0 bitfields
 */

/*!
 * @name Register XTALOSC24M_MISC0, field REFTOP_PWD[0] (RW)
 *
 * Control bit to power-down the analog bandgap reference circuitry. A note of
 * caution, the bandgap is necessary for correct operation of most of the LDO,
 * pll, and other analog functions on the die. Not related to oscillator.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_REFTOP_PWD (0U) /*!< Bit position for XTALOSC24M_MISC0_REFTOP_PWD. */
#define BM_XTALOSC24M_MISC0_REFTOP_PWD (0x00000001U) /*!< Bit mask for XTALOSC24M_MISC0_REFTOP_PWD. */
#define BS_XTALOSC24M_MISC0_REFTOP_PWD (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_REFTOP_PWD. */

/*! @brief Read current value of the XTALOSC24M_MISC0_REFTOP_PWD field. */
#define BR_XTALOSC24M_MISC0_REFTOP_PWD(x) (HW_XTALOSC24M_MISC0(x).B.REFTOP_PWD)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_REFTOP_PWD. */
#define BF_XTALOSC24M_MISC0_REFTOP_PWD(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_REFTOP_PWD) & BM_XTALOSC24M_MISC0_REFTOP_PWD)

/*! @brief Set the REFTOP_PWD field to a new value. */
#define BW_XTALOSC24M_MISC0_REFTOP_PWD(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_REFTOP_PWD) | BF_XTALOSC24M_MISC0_REFTOP_PWD(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field REFTOP_SELFBIASOFF[3] (RW)
 *
 * Control bit to disable the self-bias circuit in the analog bandgap. The
 * self-bias circuit is used by the bandgap during startup. This bit should be set
 * after the bandgap has stabilized and is necessary for best noise performance of
 * analog blocks using the outputs of the bandgap. Value should be returned to
 * zero before removing vddhigh_in or asserting bit 0 of this register (REFTOP_PWD)
 * to assure proper restart of the circuit. Not related to oscillator.
 *
 * Values:
 * - 0 - Uses coarse bias currents for startup
 * - 1 - Uses bandgap-based bias currents for best performance.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF (3U) /*!< Bit position for XTALOSC24M_MISC0_REFTOP_SELFBIASOFF. */
#define BM_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF (0x00000008U) /*!< Bit mask for XTALOSC24M_MISC0_REFTOP_SELFBIASOFF. */
#define BS_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_REFTOP_SELFBIASOFF. */

/*! @brief Read current value of the XTALOSC24M_MISC0_REFTOP_SELFBIASOFF field. */
#define BR_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF(x) (HW_XTALOSC24M_MISC0(x).B.REFTOP_SELFBIASOFF)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_REFTOP_SELFBIASOFF. */
#define BF_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF) & BM_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF)

/*! @brief Set the REFTOP_SELFBIASOFF field to a new value. */
#define BW_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF) | BF_XTALOSC24M_MISC0_REFTOP_SELFBIASOFF(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field REFTOP_VBGADJ[6:4] (RW)
 *
 * Not related to oscillator.
 *
 * Values:
 * - 000 - Nominal VBG
 * - 001 - VBG+0.78%
 * - 010 - VBG+1.56%
 * - 011 - VBG+2.34%
 * - 100 - VBG-0.78%
 * - 101 - VBG-1.56%
 * - 110 - VBG-2.34%
 * - 111 - VBG-3.12%
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_REFTOP_VBGADJ (4U) /*!< Bit position for XTALOSC24M_MISC0_REFTOP_VBGADJ. */
#define BM_XTALOSC24M_MISC0_REFTOP_VBGADJ (0x00000070U) /*!< Bit mask for XTALOSC24M_MISC0_REFTOP_VBGADJ. */
#define BS_XTALOSC24M_MISC0_REFTOP_VBGADJ (3U) /*!< Bit field size in bits for XTALOSC24M_MISC0_REFTOP_VBGADJ. */

/*! @brief Read current value of the XTALOSC24M_MISC0_REFTOP_VBGADJ field. */
#define BR_XTALOSC24M_MISC0_REFTOP_VBGADJ(x) (HW_XTALOSC24M_MISC0(x).B.REFTOP_VBGADJ)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_REFTOP_VBGADJ. */
#define BF_XTALOSC24M_MISC0_REFTOP_VBGADJ(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_REFTOP_VBGADJ) & BM_XTALOSC24M_MISC0_REFTOP_VBGADJ)

/*! @brief Set the REFTOP_VBGADJ field to a new value. */
#define BW_XTALOSC24M_MISC0_REFTOP_VBGADJ(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_REFTOP_VBGADJ) | BF_XTALOSC24M_MISC0_REFTOP_VBGADJ(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field REFTOP_VBGUP[7] (RW)
 *
 * Status bit that signals the analog bandgap voltage is up and stable. 1 -
 * Stable.Not related to oscillator.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_REFTOP_VBGUP (7U) /*!< Bit position for XTALOSC24M_MISC0_REFTOP_VBGUP. */
#define BM_XTALOSC24M_MISC0_REFTOP_VBGUP (0x00000080U) /*!< Bit mask for XTALOSC24M_MISC0_REFTOP_VBGUP. */
#define BS_XTALOSC24M_MISC0_REFTOP_VBGUP (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_REFTOP_VBGUP. */

/*! @brief Read current value of the XTALOSC24M_MISC0_REFTOP_VBGUP field. */
#define BR_XTALOSC24M_MISC0_REFTOP_VBGUP(x) (HW_XTALOSC24M_MISC0(x).B.REFTOP_VBGUP)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_REFTOP_VBGUP. */
#define BF_XTALOSC24M_MISC0_REFTOP_VBGUP(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_REFTOP_VBGUP) & BM_XTALOSC24M_MISC0_REFTOP_VBGUP)

/*! @brief Set the REFTOP_VBGUP field to a new value. */
#define BW_XTALOSC24M_MISC0_REFTOP_VBGUP(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_REFTOP_VBGUP) | BF_XTALOSC24M_MISC0_REFTOP_VBGUP(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field STOP_MODE_CONFIG[12] (RW)
 *
 * Configure the analog behavior in stop mode.Not related to oscillator.
 *
 * Values:
 * - 0 - Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode
 *     assertion
 * - 1 - Light Stop Mode - 0x1 All the analog domain except the LDO_1P1,
 *     LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can
 *     be configured not to power down the oscillator (XTALOSC). PLL3 can be
 *     disabled with register settings if desired.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_STOP_MODE_CONFIG (12U) /*!< Bit position for XTALOSC24M_MISC0_STOP_MODE_CONFIG. */
#define BM_XTALOSC24M_MISC0_STOP_MODE_CONFIG (0x00001000U) /*!< Bit mask for XTALOSC24M_MISC0_STOP_MODE_CONFIG. */
#define BS_XTALOSC24M_MISC0_STOP_MODE_CONFIG (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_STOP_MODE_CONFIG. */

#define BV_XTALOSC24M_MISC0_STOP_MODE_CONFIG_DEEP (0U) /*!< Bit field value for XTALOSC24M_MISC0_STOP_MODE_CONFIG: Deep Stop Mode - 0x0 All analog except RTC powered down on Stop mode assertion */
#define BV_XTALOSC24M_MISC0_STOP_MODE_CONFIG_LIGHT (0x1U) /*!< Bit field value for XTALOSC24M_MISC0_STOP_MODE_CONFIG: Light Stop Mode - 0x1 All the analog domain except the LDO_1P1, LDO_2P5, and PLL3 is powered down on STOP mode assertion. If required the CCM can be configured not to power down the oscillator (XTALOSC). PLL3 can be disabled with register settings if desired. */

/*! @brief Read current value of the XTALOSC24M_MISC0_STOP_MODE_CONFIG field. */
#define BR_XTALOSC24M_MISC0_STOP_MODE_CONFIG(x) (HW_XTALOSC24M_MISC0(x).B.STOP_MODE_CONFIG)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_STOP_MODE_CONFIG. */
#define BF_XTALOSC24M_MISC0_STOP_MODE_CONFIG(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_STOP_MODE_CONFIG) & BM_XTALOSC24M_MISC0_STOP_MODE_CONFIG)

/*! @brief Set the STOP_MODE_CONFIG field to a new value. */
#define BW_XTALOSC24M_MISC0_STOP_MODE_CONFIG(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_STOP_MODE_CONFIG) | BF_XTALOSC24M_MISC0_STOP_MODE_CONFIG(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field OSC_I[15:14] (RW)
 *
 * This field determines the bias current in the 24MHz oscillator. The aim is to
 * start up with the highest bias current, which can be decreased after startup
 * if it is determined to be acceptable.
 *
 * Values:
 * - 00 - Nominal
 * - 01 - Decrease current by 12.5%
 * - 10 - Decrease current by 25.0%
 * - 11 - Decrease current by 37.5%
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_OSC_I (14U)    /*!< Bit position for XTALOSC24M_MISC0_OSC_I. */
#define BM_XTALOSC24M_MISC0_OSC_I (0x0000C000U) /*!< Bit mask for XTALOSC24M_MISC0_OSC_I. */
#define BS_XTALOSC24M_MISC0_OSC_I (2U)     /*!< Bit field size in bits for XTALOSC24M_MISC0_OSC_I. */

#define BV_XTALOSC24M_MISC0_OSC_I_NOMINAL (0U)       /*!< Bit field value for XTALOSC24M_MISC0_OSC_I: Nominal */
#define BV_XTALOSC24M_MISC0_OSC_I_MINUS_12_5_PERCENT (0x1U) /*!< Bit field value for XTALOSC24M_MISC0_OSC_I: Decrease current by 12.5% */
#define BV_XTALOSC24M_MISC0_OSC_I_MINUS_25_PERCENT (0x2U) /*!< Bit field value for XTALOSC24M_MISC0_OSC_I: Decrease current by 25.0% */
#define BV_XTALOSC24M_MISC0_OSC_I_MINUS_37_5_PERCENT (0x3U) /*!< Bit field value for XTALOSC24M_MISC0_OSC_I: Decrease current by 37.5% */

/*! @brief Read current value of the XTALOSC24M_MISC0_OSC_I field. */
#define BR_XTALOSC24M_MISC0_OSC_I(x) (HW_XTALOSC24M_MISC0(x).B.OSC_I)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_OSC_I. */
#define BF_XTALOSC24M_MISC0_OSC_I(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_OSC_I) & BM_XTALOSC24M_MISC0_OSC_I)

/*! @brief Set the OSC_I field to a new value. */
#define BW_XTALOSC24M_MISC0_OSC_I(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_OSC_I) | BF_XTALOSC24M_MISC0_OSC_I(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field OSC_XTALOK[16] (RO)
 *
 * Status bit that signals that the output of the 24-MHz crystal oscillator is
 * stable. Generated from a timer and active detection of the actual frequency.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_OSC_XTALOK (16U) /*!< Bit position for XTALOSC24M_MISC0_OSC_XTALOK. */
#define BM_XTALOSC24M_MISC0_OSC_XTALOK (0x00010000U) /*!< Bit mask for XTALOSC24M_MISC0_OSC_XTALOK. */
#define BS_XTALOSC24M_MISC0_OSC_XTALOK (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_OSC_XTALOK. */

/*! @brief Read current value of the XTALOSC24M_MISC0_OSC_XTALOK field. */
#define BR_XTALOSC24M_MISC0_OSC_XTALOK(x) (HW_XTALOSC24M_MISC0(x).B.OSC_XTALOK)
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field OSC_XTALOK_EN[17] (RW)
 *
 * This bit enables the detector that signals when the 24MHz crystal oscillator
 * is stable.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_OSC_XTALOK_EN (17U) /*!< Bit position for XTALOSC24M_MISC0_OSC_XTALOK_EN. */
#define BM_XTALOSC24M_MISC0_OSC_XTALOK_EN (0x00020000U) /*!< Bit mask for XTALOSC24M_MISC0_OSC_XTALOK_EN. */
#define BS_XTALOSC24M_MISC0_OSC_XTALOK_EN (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_OSC_XTALOK_EN. */

/*! @brief Read current value of the XTALOSC24M_MISC0_OSC_XTALOK_EN field. */
#define BR_XTALOSC24M_MISC0_OSC_XTALOK_EN(x) (HW_XTALOSC24M_MISC0(x).B.OSC_XTALOK_EN)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_OSC_XTALOK_EN. */
#define BF_XTALOSC24M_MISC0_OSC_XTALOK_EN(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_OSC_XTALOK_EN) & BM_XTALOSC24M_MISC0_OSC_XTALOK_EN)

/*! @brief Set the OSC_XTALOK_EN field to a new value. */
#define BW_XTALOSC24M_MISC0_OSC_XTALOK_EN(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_OSC_XTALOK_EN) | BF_XTALOSC24M_MISC0_OSC_XTALOK_EN(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field WBCP_VPW_THRESH[19:18] (RW)
 *
 * This signal alters the voltage that the pwell is charged pumped to.Not
 * related to oscillator.
 *
 * Values:
 * - 00 - Nominal output pwell bias voltage.
 * - 01 - Increase pwell output voltage by 25mV.
 * - 10 - Decrease pwell output pwell voltage by 25mV.
 * - 11 - Decrease pwell output pwell voltage by 50mV.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_WBCP_VPW_THRESH (18U) /*!< Bit position for XTALOSC24M_MISC0_WBCP_VPW_THRESH. */
#define BM_XTALOSC24M_MISC0_WBCP_VPW_THRESH (0x000C0000U) /*!< Bit mask for XTALOSC24M_MISC0_WBCP_VPW_THRESH. */
#define BS_XTALOSC24M_MISC0_WBCP_VPW_THRESH (2U) /*!< Bit field size in bits for XTALOSC24M_MISC0_WBCP_VPW_THRESH. */

#define BV_XTALOSC24M_MISC0_WBCP_VPW_THRESH_NOMINAL_BIAS (0U) /*!< Bit field value for XTALOSC24M_MISC0_WBCP_VPW_THRESH: Nominal output pwell bias voltage. */
#define BV_XTALOSC24M_MISC0_WBCP_VPW_THRESH_PLUS_25MV (0x1U) /*!< Bit field value for XTALOSC24M_MISC0_WBCP_VPW_THRESH: Increase pwell output voltage by 25mV. */
#define BV_XTALOSC24M_MISC0_WBCP_VPW_THRESH_MINUS_25MV (0x2U) /*!< Bit field value for XTALOSC24M_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 25mV. */
#define BV_XTALOSC24M_MISC0_WBCP_VPW_THRESH_MINUS_50MV (0x3U) /*!< Bit field value for XTALOSC24M_MISC0_WBCP_VPW_THRESH: Decrease pwell output pwell voltage by 50mV. */

/*! @brief Read current value of the XTALOSC24M_MISC0_WBCP_VPW_THRESH field. */
#define BR_XTALOSC24M_MISC0_WBCP_VPW_THRESH(x) (HW_XTALOSC24M_MISC0(x).B.WBCP_VPW_THRESH)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_WBCP_VPW_THRESH. */
#define BF_XTALOSC24M_MISC0_WBCP_VPW_THRESH(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_WBCP_VPW_THRESH) & BM_XTALOSC24M_MISC0_WBCP_VPW_THRESH)

/*! @brief Set the WBCP_VPW_THRESH field to a new value. */
#define BW_XTALOSC24M_MISC0_WBCP_VPW_THRESH(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_WBCP_VPW_THRESH) | BF_XTALOSC24M_MISC0_WBCP_VPW_THRESH(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field CLKGATE_CTRL[25] (RW)
 *
 * This bit allows disabling the clock gate (always ungated) for the xtal 24MHz
 * clock that clocks the digital logic in the analog block. Do not change the
 * field during a low power event. This is not a field that the user would normally
 * need to modify.
 *
 * Values:
 * - 0 - Allow the logic to automatically gate the clock when the XTAL is
 *     powered down.
 * - 1 - Prevent the logic from ever gating off the clock.
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_CLKGATE_CTRL (25U) /*!< Bit position for XTALOSC24M_MISC0_CLKGATE_CTRL. */
#define BM_XTALOSC24M_MISC0_CLKGATE_CTRL (0x02000000U) /*!< Bit mask for XTALOSC24M_MISC0_CLKGATE_CTRL. */
#define BS_XTALOSC24M_MISC0_CLKGATE_CTRL (1U) /*!< Bit field size in bits for XTALOSC24M_MISC0_CLKGATE_CTRL. */

#define BV_XTALOSC24M_MISC0_CLKGATE_CTRL_ALLOW_AUTO_GATE (0U) /*!< Bit field value for XTALOSC24M_MISC0_CLKGATE_CTRL: Allow the logic to automatically gate the clock when the XTAL is powered down. */
#define BV_XTALOSC24M_MISC0_CLKGATE_CTRL_NO_AUTO_GATE (0x1U) /*!< Bit field value for XTALOSC24M_MISC0_CLKGATE_CTRL: Prevent the logic from ever gating off the clock. */

/*! @brief Read current value of the XTALOSC24M_MISC0_CLKGATE_CTRL field. */
#define BR_XTALOSC24M_MISC0_CLKGATE_CTRL(x) (HW_XTALOSC24M_MISC0(x).B.CLKGATE_CTRL)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_CLKGATE_CTRL. */
#define BF_XTALOSC24M_MISC0_CLKGATE_CTRL(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_CLKGATE_CTRL) & BM_XTALOSC24M_MISC0_CLKGATE_CTRL)

/*! @brief Set the CLKGATE_CTRL field to a new value. */
#define BW_XTALOSC24M_MISC0_CLKGATE_CTRL(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_CLKGATE_CTRL) | BF_XTALOSC24M_MISC0_CLKGATE_CTRL(v)))
/*@}*/

/*!
 * @name Register XTALOSC24M_MISC0, field CLKGATE_DELAY[28:26] (RW)
 *
 * This field specifies the delay between powering up the XTAL 24MHz clock and
 * releasing the clock to the digital logic inside the analog block. Do not change
 * the field during a low power event. This is not a field that the user would
 * normally need to modify.
 *
 * Values:
 * - 000 - 0.5ms
 * - 001 - 1.0ms
 * - 010 - 2.0ms
 * - 011 - 3.0ms
 * - 100 - 4.0ms
 * - 101 - 5.0ms
 * - 110 - 6.0ms
 * - 111 - 7.0ms
 */
/*@{*/
#define BP_XTALOSC24M_MISC0_CLKGATE_DELAY (26U) /*!< Bit position for XTALOSC24M_MISC0_CLKGATE_DELAY. */
#define BM_XTALOSC24M_MISC0_CLKGATE_DELAY (0x1C000000U) /*!< Bit mask for XTALOSC24M_MISC0_CLKGATE_DELAY. */
#define BS_XTALOSC24M_MISC0_CLKGATE_DELAY (3U) /*!< Bit field size in bits for XTALOSC24M_MISC0_CLKGATE_DELAY. */

/*! @brief Read current value of the XTALOSC24M_MISC0_CLKGATE_DELAY field. */
#define BR_XTALOSC24M_MISC0_CLKGATE_DELAY(x) (HW_XTALOSC24M_MISC0(x).B.CLKGATE_DELAY)

/*! @brief Format value for bitfield XTALOSC24M_MISC0_CLKGATE_DELAY. */
#define BF_XTALOSC24M_MISC0_CLKGATE_DELAY(v) ((uint32_t)((uint32_t)(v) << BP_XTALOSC24M_MISC0_CLKGATE_DELAY) & BM_XTALOSC24M_MISC0_CLKGATE_DELAY)

/*! @brief Set the CLKGATE_DELAY field to a new value. */
#define BW_XTALOSC24M_MISC0_CLKGATE_DELAY(x, v) (HW_XTALOSC24M_MISC0_WR(x, (HW_XTALOSC24M_MISC0_RD(x) & ~BM_XTALOSC24M_MISC0_CLKGATE_DELAY) | BF_XTALOSC24M_MISC0_CLKGATE_DELAY(v)))
/*@}*/

/*******************************************************************************
 * hw_xtalosc24m_t - module struct
 ******************************************************************************/
/*!
 * @brief All XTALOSC24M module registers.
 */
#pragma pack(1)
typedef struct _hw_xtalosc24m
{
    uint8_t _reserved0[336];
    __IO hw_xtalosc24m_misc0_t MISC0;      /*!< [0x150] Miscellaneous Register 0 */
} hw_xtalosc24m_t;
#pragma pack()

/*! @brief Macro to access all XTALOSC24M registers. */
/*! @param x XTALOSC24M module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_XTALOSC24M_REGS(XTALOSC24M_BASE)</code>. */
#define HW_XTALOSC24M_REGS(x) (*(hw_xtalosc24m_t *)(x))

/*
 * iMX6DP uSDHC
 *
 * uSDHC
 *
 * Registers defined in this header file:
 * - HW_uSDHC_DS_ADDR - DMA System Address
 * - HW_uSDHC_BLK_ATT - Block Attributes
 * - HW_uSDHC_CMD_ARG - Command Argument
 * - HW_uSDHC_CMD_XFR_TYP - Command Transfer Type
 * - HW_uSDHC_CMD_RSP0 - Command Response0
 * - HW_uSDHC_CMD_RSP1 - Command Response1
 * - HW_uSDHC_CMD_RSP2 - Command Response2
 * - HW_uSDHC_CMD_RSP3 - Command Response3
 * - HW_uSDHC_DATA_BUFF_ACC_PORT - Data Buffer Access Port
 * - HW_uSDHC_PRES_STATE - Present State
 * - HW_uSDHC_PROT_CTRL - Protocol Control
 * - HW_uSDHC_SYS_CTRL - System Control
 * - HW_uSDHC_INT_STATUS - Interrupt Status
 * - HW_uSDHC_INT_STATUS_EN - Interrupt Status Enable
 * - HW_uSDHC_INT_SIGNAL_EN - Interrupt Signal Enable
 * - HW_uSDHC_AUTOCMD12_ERR_STATUS - Auto CMD12 Error Status
 * - HW_uSDHC_HOST_CTRL_CAP - Host Controller Capabilities
 * - HW_uSDHC_WTMK_LVL - Watermark Level
 * - HW_uSDHC_MIX_CTRL - Mixer Control
 * - HW_uSDHC_FORCE_EVENT - Force Event
 * - HW_uSDHC_ADMA_ERR_STATUS - ADMA Error Status Register
 * - HW_uSDHC_ADMA_SYS_ADDR - ADMA System Address
 * - HW_uSDHC_DLL_CTRL - DLL (Delay Line) Control
 * - HW_uSDHC_DLL_STATUS - DLL Status
 * - HW_uSDHC_CLK_TUNE_CTRL_STATUS - CLK Tuning Control and Status
 * - HW_uSDHC_VEND_SPEC - Vendor Specific Register
 * - HW_uSDHC_MMC_BOOT - MMC Boot Register
 * - HW_uSDHC_VEND_SPEC2 - Vendor Specific 2 Register
 *
 * - hw_usdhc_t - Struct containing all module registers.
 */

#define HW_uSDHC_INSTANCE_COUNT (4U) /*!< Number of instances of the uSDHC module. */
#define HW_uSDHC1 (0U) /*!< Instance number for uSDHC1. */
#define HW_uSDHC2 (1U) /*!< Instance number for uSDHC2. */
#define HW_uSDHC3 (2U) /*!< Instance number for uSDHC3. */
#define HW_uSDHC4 (3U) /*!< Instance number for uSDHC4. */
#define uSDHC1_BASE           (0x2190000U) /*!< Base address for uSDHC1. */
#define uSDHC2_BASE           (0x2194000U) /*!< Base address for uSDHC2. */
#define uSDHC3_BASE           (0x2198000U) /*!< Base address for uSDHC3. */
#define uSDHC4_BASE           (0x219C000U) /*!< Base address for uSDHC4. */
/*! Array initializer of uSDHC base addresses. */
#define USDHC_BASE_ADDRS      { uSDHC1_BASE, uSDHC2_BASE, uSDHC3_BASE, uSDHC4_BASE }

/*******************************************************************************
 * HW_uSDHC_DS_ADDR - DMA System Address
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_DS_ADDR - DMA System Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the physical system memory address used for DMA
 * transfers.
 */
typedef union _hw_usdhc_ds_addr
{
    uint32_t U;
    struct _hw_usdhc_ds_addr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t DS_ADDR : 30;         /*!< [31:2]  */
    } B;
} hw_usdhc_ds_addr_t;

/*!
 * @name Constants and macros for entire uSDHC_DS_ADDR register
 */
/*@{*/
#define HW_uSDHC_DS_ADDR_ADDR(x) ((uintptr_t)(x) + 0x0U)

#define HW_uSDHC_DS_ADDR(x)      (*(__IO hw_usdhc_ds_addr_t *) HW_uSDHC_DS_ADDR_ADDR(x))
#define HW_uSDHC_DS_ADDR_RD(x)   (HW_uSDHC_DS_ADDR(x).U)
#define HW_uSDHC_DS_ADDR_WR(x, v) (HW_uSDHC_DS_ADDR(x).U = (v))
#define HW_uSDHC_DS_ADDR_SET(x, v) (HW_uSDHC_DS_ADDR_WR(x, HW_uSDHC_DS_ADDR_RD(x) |  (v)))
#define HW_uSDHC_DS_ADDR_CLR(x, v) (HW_uSDHC_DS_ADDR_WR(x, HW_uSDHC_DS_ADDR_RD(x) & ~(v)))
#define HW_uSDHC_DS_ADDR_TOG(x, v) (HW_uSDHC_DS_ADDR_WR(x, HW_uSDHC_DS_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_DS_ADDR bitfields
 */

/*!
 * @name Register uSDHC_DS_ADDR, field DS_ADDR[31:2] (RW)
 *
 * DMA System Address: This register contains the 32-bit system memory address
 * for a DMA transfer. Since the address must be word (4 bytes) aligned, the least
 * 2 bits are reserved, always 0. When the uSDHC stops a DMA transfer, this
 * register points to the system address of the next contiguous data position. It can
 * be accessed only when no transaction is executing (i.e. after a transaction
 * has stopped). Read operation during transfers may return an invalid value. The
 * Host Driver shall initialize this register before starting a DMA transaction.
 * After DMA has stopped, the system address of the next contiguous data position
 * can be read from this register. This register is protected during a data
 * transfer. When data lines are active, write to this register is ignored. The Host
 * driver shall wait, until the DLA bit in the Present State register is cleared,
 * before writing to this register. The uSDHC internal DMA does not support a
 * virtual memory system. It only supports continuous physical memory access. And
 * due to AHB burst limitations, if the burst must cross the 1 KB boundary, uSDHC
 * will automatically change SEQ burst type to NSEQ. Since this register supports
 * dynamic address reflecting, when TC bit is set, it automatically alters the
 * value of internal address counter, so SW cannot change this register when TC
 * bit is set. Such restriction is also listed in Software Restrictions .
 */
/*@{*/
#define BP_uSDHC_DS_ADDR_DS_ADDR (2U)      /*!< Bit position for uSDHC_DS_ADDR_DS_ADDR. */
#define BM_uSDHC_DS_ADDR_DS_ADDR (0xFFFFFFFCU) /*!< Bit mask for uSDHC_DS_ADDR_DS_ADDR. */
#define BS_uSDHC_DS_ADDR_DS_ADDR (30U)     /*!< Bit field size in bits for uSDHC_DS_ADDR_DS_ADDR. */

/*! @brief Read current value of the uSDHC_DS_ADDR_DS_ADDR field. */
#define BR_uSDHC_DS_ADDR_DS_ADDR(x) (HW_uSDHC_DS_ADDR(x).B.DS_ADDR)

/*! @brief Format value for bitfield uSDHC_DS_ADDR_DS_ADDR. */
#define BF_uSDHC_DS_ADDR_DS_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DS_ADDR_DS_ADDR) & BM_uSDHC_DS_ADDR_DS_ADDR)

/*! @brief Set the DS_ADDR field to a new value. */
#define BW_uSDHC_DS_ADDR_DS_ADDR(x, v) (HW_uSDHC_DS_ADDR_WR(x, (HW_uSDHC_DS_ADDR_RD(x) & ~BM_uSDHC_DS_ADDR_DS_ADDR) | BF_uSDHC_DS_ADDR_DS_ADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_BLK_ATT - Block Attributes
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_BLK_ATT - Block Attributes (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to configure the number of data blocks and the number
 * of bytes in each block.
 */
typedef union _hw_usdhc_blk_att
{
    uint32_t U;
    struct _hw_usdhc_blk_att_bitfields
    {
        uint32_t BLKSIZE : 13;         /*!< [12:0]  */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t BLKCNT : 16;          /*!< [31:16]  */
    } B;
} hw_usdhc_blk_att_t;

/*!
 * @name Constants and macros for entire uSDHC_BLK_ATT register
 */
/*@{*/
#define HW_uSDHC_BLK_ATT_ADDR(x) ((uintptr_t)(x) + 0x4U)

#define HW_uSDHC_BLK_ATT(x)      (*(__IO hw_usdhc_blk_att_t *) HW_uSDHC_BLK_ATT_ADDR(x))
#define HW_uSDHC_BLK_ATT_RD(x)   (HW_uSDHC_BLK_ATT(x).U)
#define HW_uSDHC_BLK_ATT_WR(x, v) (HW_uSDHC_BLK_ATT(x).U = (v))
#define HW_uSDHC_BLK_ATT_SET(x, v) (HW_uSDHC_BLK_ATT_WR(x, HW_uSDHC_BLK_ATT_RD(x) |  (v)))
#define HW_uSDHC_BLK_ATT_CLR(x, v) (HW_uSDHC_BLK_ATT_WR(x, HW_uSDHC_BLK_ATT_RD(x) & ~(v)))
#define HW_uSDHC_BLK_ATT_TOG(x, v) (HW_uSDHC_BLK_ATT_WR(x, HW_uSDHC_BLK_ATT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_BLK_ATT bitfields
 */

/*!
 * @name Register uSDHC_BLK_ATT, field BLKSIZE[12:0] (RW)
 *
 * Transfer Block Size: This register specifies the block size for block data
 * transfers. Values ranging from 1 byte up to the maximum buffer size can be set.
 * It can be accessed only when no transaction is executing (i.e. after a
 * transaction has stopped). Read operations during transfers may return an invalid
 * value, and write operations will be ignored.
 *
 * Values:
 * - 1000 - 4096 Bytes
 * - 001 - 1 Byte
 * - 000 - No data transfer
 */
/*@{*/
#define BP_uSDHC_BLK_ATT_BLKSIZE (0U)      /*!< Bit position for uSDHC_BLK_ATT_BLKSIZE. */
#define BM_uSDHC_BLK_ATT_BLKSIZE (0x00001FFFU) /*!< Bit mask for uSDHC_BLK_ATT_BLKSIZE. */
#define BS_uSDHC_BLK_ATT_BLKSIZE (13U)     /*!< Bit field size in bits for uSDHC_BLK_ATT_BLKSIZE. */

/*! @brief Read current value of the uSDHC_BLK_ATT_BLKSIZE field. */
#define BR_uSDHC_BLK_ATT_BLKSIZE(x) (HW_uSDHC_BLK_ATT(x).B.BLKSIZE)

/*! @brief Format value for bitfield uSDHC_BLK_ATT_BLKSIZE. */
#define BF_uSDHC_BLK_ATT_BLKSIZE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_BLK_ATT_BLKSIZE) & BM_uSDHC_BLK_ATT_BLKSIZE)

/*! @brief Set the BLKSIZE field to a new value. */
#define BW_uSDHC_BLK_ATT_BLKSIZE(x, v) (HW_uSDHC_BLK_ATT_WR(x, (HW_uSDHC_BLK_ATT_RD(x) & ~BM_uSDHC_BLK_ATT_BLKSIZE) | BF_uSDHC_BLK_ATT_BLKSIZE(v)))
/*@}*/

/*!
 * @name Register uSDHC_BLK_ATT, field BLKCNT[31:16] (RW)
 *
 * Blocks Count For Current Transfer: This register is enabled when the Block
 * Count Enable bit in the Transfer Mode register is set to 1 and is valid only for
 * multiple block transfers. For single block transfer, this register will
 * always read as 1. The Host Driver shall set this register to a value between 1 and
 * the maximum block count. The uSDHC decrements the block count after each block
 * transfer and stops when the count reaches zero. Setting the block count to 0
 * results in no data blocks being transferred. This register should be accessed
 * only when no transaction is executing (i.e. after transactions are stopped).
 * During data transfer, read operations on this register may return an invalid
 * value and write operations are ignored. When saving transfer content as a result
 * of a Suspend command, the number of blocks yet to be transferred can be
 * determined by reading this register. The reading of this register should be applied
 * after transfer is paused by stop at block gap operation and before sending
 * the command marked as suspend. This is because when Suspend command is sent out,
 * uSDHC will regard the current transfer is aborted and change BLKCNT register
 * back to its original value instead of keeping the dynamical indicator of
 * remained block count. When restoring transfer content prior to issuing a Resume
 * command, the Host Driver shall restore the previously saved block count. Although
 * the BLKCNT field is 0 after reset, the read of reset value is 0x1. This is
 * because when MSBSEL bit is indicating a single block transfer, the read value of
 * BLKCNT is always 1.
 *
 * Values:
 * - 0001 - 1 block
 * - 0000 - Stop Count
 */
/*@{*/
#define BP_uSDHC_BLK_ATT_BLKCNT (16U)      /*!< Bit position for uSDHC_BLK_ATT_BLKCNT. */
#define BM_uSDHC_BLK_ATT_BLKCNT (0xFFFF0000U) /*!< Bit mask for uSDHC_BLK_ATT_BLKCNT. */
#define BS_uSDHC_BLK_ATT_BLKCNT (16U)      /*!< Bit field size in bits for uSDHC_BLK_ATT_BLKCNT. */

/*! @brief Read current value of the uSDHC_BLK_ATT_BLKCNT field. */
#define BR_uSDHC_BLK_ATT_BLKCNT(x) (HW_uSDHC_BLK_ATT(x).B.BLKCNT)

/*! @brief Format value for bitfield uSDHC_BLK_ATT_BLKCNT. */
#define BF_uSDHC_BLK_ATT_BLKCNT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_BLK_ATT_BLKCNT) & BM_uSDHC_BLK_ATT_BLKCNT)

/*! @brief Set the BLKCNT field to a new value. */
#define BW_uSDHC_BLK_ATT_BLKCNT(x, v) (HW_uSDHC_BLK_ATT_WR(x, (HW_uSDHC_BLK_ATT_RD(x) & ~BM_uSDHC_BLK_ATT_BLKCNT) | BF_uSDHC_BLK_ATT_BLKCNT(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_ARG - Command Argument
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_ARG - Command Argument (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the SD / MMC Command Argument. .
 */
typedef union _hw_usdhc_cmd_arg
{
    uint32_t U;
    struct _hw_usdhc_cmd_arg_bitfields
    {
        uint32_t CMDARG : 32;          /*!< [31:0] Command Argument */
    } B;
} hw_usdhc_cmd_arg_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_ARG register
 */
/*@{*/
#define HW_uSDHC_CMD_ARG_ADDR(x) ((uintptr_t)(x) + 0x8U)

#define HW_uSDHC_CMD_ARG(x)      (*(__IO hw_usdhc_cmd_arg_t *) HW_uSDHC_CMD_ARG_ADDR(x))
#define HW_uSDHC_CMD_ARG_RD(x)   (HW_uSDHC_CMD_ARG(x).U)
#define HW_uSDHC_CMD_ARG_WR(x, v) (HW_uSDHC_CMD_ARG(x).U = (v))
#define HW_uSDHC_CMD_ARG_SET(x, v) (HW_uSDHC_CMD_ARG_WR(x, HW_uSDHC_CMD_ARG_RD(x) |  (v)))
#define HW_uSDHC_CMD_ARG_CLR(x, v) (HW_uSDHC_CMD_ARG_WR(x, HW_uSDHC_CMD_ARG_RD(x) & ~(v)))
#define HW_uSDHC_CMD_ARG_TOG(x, v) (HW_uSDHC_CMD_ARG_WR(x, HW_uSDHC_CMD_ARG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_ARG bitfields
 */

/*!
 * @name Register uSDHC_CMD_ARG, field CMDARG[31:0] (RW)
 *
 * The SD / MMC Command Argument is specified as bits 39-8 of the Command Format
 * in the SD or MMC Specification.This register is write protected when the
 * Command Inhibit (CMD) bit in the Present State register is set.
 */
/*@{*/
#define BP_uSDHC_CMD_ARG_CMDARG (0U)       /*!< Bit position for uSDHC_CMD_ARG_CMDARG. */
#define BM_uSDHC_CMD_ARG_CMDARG (0xFFFFFFFFU) /*!< Bit mask for uSDHC_CMD_ARG_CMDARG. */
#define BS_uSDHC_CMD_ARG_CMDARG (32U)      /*!< Bit field size in bits for uSDHC_CMD_ARG_CMDARG. */

/*! @brief Read current value of the uSDHC_CMD_ARG_CMDARG field. */
#define BR_uSDHC_CMD_ARG_CMDARG(x) (HW_uSDHC_CMD_ARG(x).U)

/*! @brief Format value for bitfield uSDHC_CMD_ARG_CMDARG. */
#define BF_uSDHC_CMD_ARG_CMDARG(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_ARG_CMDARG) & BM_uSDHC_CMD_ARG_CMDARG)

/*! @brief Set the CMDARG field to a new value. */
#define BW_uSDHC_CMD_ARG_CMDARG(x, v) (HW_uSDHC_CMD_ARG_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_XFR_TYP - Command Transfer Type
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_XFR_TYP - Command Transfer Type (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to control the operation of data transfers. The Host
 * Driver shall set this register before issuing a command followed by a data
 * transfer, or before issuing a Resume command. To prevent data loss, the uSDHC
 * prevents writing to the bits, that are involved in the data transfer of this
 * register, when data transfer is active. These bits are DPSEL, MBSEL, DTDSEL, AC12EN,
 * BCEN and DMAEN. The Host Driver shall check the Command Inhibit DAT bit
 * (CDIHB) and the Command Inhibit CMD bit (CIHB) in the Present State register before
 * writing to this register. When the CDIHB bit in the Present State register is
 * set, any attempt to send a command with data by writing to this register is
 * ignored; when the CIHB bit is set, any write to this register is ignored. On
 * sending commands with data transfer invovled, it is mandatory that the block
 * size is non-zero. Block count must also be non-zero, or indicated as single block
 * transfer (bit 5 of this register is '0' when written), or block count is
 * disabled (bit 1 of this register is '0' when written), otherwise uSDHC will ignore
 * the sending of this command and do nothing. For write command, with all above
 * restrictions, it is also mandatory that the write protect switch is not
 * active (WPSPL bit of Present State Register is '1'), otherwise uSDHC will also
 * ignore the command. If the commands with data transfer does not receive the
 * response in 64 clock cycles, i.e., response time-out, uSDHC will regard the external
 * device does not accept the command and abort the data transfer. In this
 * scenario, the driver should issue the command again to re-try the transfer. It is
 * also possible that for some reason the card responds the command but uSDHC does
 * not receive the response, and if it is internal DMA (either simple DMA or
 * ADMA) read operation, the external system memory is over-written by the internal
 * DMA with data sent back from the card. The table below shows the summary of
 * how register settings determine the type of data transfer. Transfer Type
 * Register Setting for Various Transfer Types Multi/Single Block Select Block Count
 * Enable Block Count Function 0 Don't Care Don't Care Single Transfer 1 0 Don't
 * Care Infinite Transfer 1 1 Positive Number Multiple Transfer 1 1 Zero No Data
 * Transfer The table below shows the relationship between the Command Index Check
 * Enable and the Command CRC Check Enable, in regards to the Response Type bits
 * as well as the name of the response type. Relationship Between Parameters and
 * the Name of the Response Type Response Type Index Check Enable CRC Check Enable
 * Name of Response Type 00 0 0 No Response 01 0 1 R2 10 0 0 R3,R4 10 1 1
 * R1,R5,R6 11 1 1 R1b,R5b In the SDIO specification, response type notation for R5b is
 * not defined. R5 includes R5b in the SDIO specification. But R5b is defined in
 * this specification to specify that the uSDHC will check the busy status after
 * receiving a response. For example, usually CMD52 is used with R5, but the I/O
 * abort command shall be used with R5b. The CRC field for R3 and R4 is expected
 * to be all 1 bits. The CRC check shall be disabled for these response types.
 */
typedef union _hw_usdhc_cmd_xfr_typ
{
    uint32_t U;
    struct _hw_usdhc_cmd_xfr_typ_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t RSPTYP : 2;           /*!< [17:16] Response Type Select */
        uint32_t RESERVED1 : 1;        /*!< [18]  */
        uint32_t CCCEN : 1;            /*!< [19] Command CRC Check Enable */
        uint32_t CICEN : 1;            /*!< [20] Command Index Check Enable */
        uint32_t DPSEL : 1;            /*!< [21] Data Present Select */
        uint32_t CMDTYP : 2;           /*!< [23:22] Command Type */
        uint32_t CMDINX : 6;           /*!< [29:24] Command Index */
        uint32_t RESERVED2 : 2;        /*!< [31:30]  */
    } B;
} hw_usdhc_cmd_xfr_typ_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_XFR_TYP register
 */
/*@{*/
#define HW_uSDHC_CMD_XFR_TYP_ADDR(x) ((uintptr_t)(x) + 0xCU)

#define HW_uSDHC_CMD_XFR_TYP(x)  (*(__IO hw_usdhc_cmd_xfr_typ_t *) HW_uSDHC_CMD_XFR_TYP_ADDR(x))
#define HW_uSDHC_CMD_XFR_TYP_RD(x) (HW_uSDHC_CMD_XFR_TYP(x).U)
#define HW_uSDHC_CMD_XFR_TYP_WR(x, v) (HW_uSDHC_CMD_XFR_TYP(x).U = (v))
#define HW_uSDHC_CMD_XFR_TYP_SET(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, HW_uSDHC_CMD_XFR_TYP_RD(x) |  (v)))
#define HW_uSDHC_CMD_XFR_TYP_CLR(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, HW_uSDHC_CMD_XFR_TYP_RD(x) & ~(v)))
#define HW_uSDHC_CMD_XFR_TYP_TOG(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, HW_uSDHC_CMD_XFR_TYP_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_XFR_TYP bitfields
 */

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field RSPTYP[17:16] (RW)
 *
 * Values:
 * - 00 - No Response
 * - 01 - Response Length 136
 * - 10 - Response Length 48
 * - 11 - Response Length 48, check Busy after response
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_RSPTYP (16U)  /*!< Bit position for uSDHC_CMD_XFR_TYP_RSPTYP. */
#define BM_uSDHC_CMD_XFR_TYP_RSPTYP (0x00030000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_RSPTYP. */
#define BS_uSDHC_CMD_XFR_TYP_RSPTYP (2U)   /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_RSPTYP. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_RSPTYP field. */
#define BR_uSDHC_CMD_XFR_TYP_RSPTYP(x) (HW_uSDHC_CMD_XFR_TYP(x).B.RSPTYP)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_RSPTYP. */
#define BF_uSDHC_CMD_XFR_TYP_RSPTYP(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_RSPTYP) & BM_uSDHC_CMD_XFR_TYP_RSPTYP)

/*! @brief Set the RSPTYP field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_RSPTYP(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_RSPTYP) | BF_uSDHC_CMD_XFR_TYP_RSPTYP(v)))
/*@}*/

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field CCCEN[19] (RW)
 *
 * If this bit is set to 1, the uSDHC shall check the CRC field in the response.
 * If an error is detected, it is reported as a Command CRC Error. If this bit
 * is set to 0, the CRC field is not checked. The number of bits checked by the
 * CRC field value changes according to the length of the response. (Refer to
 * RSPTYP[1:0] and CMD_XFR_TYPCommand Transfer Type .)
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_CCCEN (19U)   /*!< Bit position for uSDHC_CMD_XFR_TYP_CCCEN. */
#define BM_uSDHC_CMD_XFR_TYP_CCCEN (0x00080000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_CCCEN. */
#define BS_uSDHC_CMD_XFR_TYP_CCCEN (1U)    /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_CCCEN. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_CCCEN field. */
#define BR_uSDHC_CMD_XFR_TYP_CCCEN(x) (HW_uSDHC_CMD_XFR_TYP(x).B.CCCEN)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_CCCEN. */
#define BF_uSDHC_CMD_XFR_TYP_CCCEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_CCCEN) & BM_uSDHC_CMD_XFR_TYP_CCCEN)

/*! @brief Set the CCCEN field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_CCCEN(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_CCCEN) | BF_uSDHC_CMD_XFR_TYP_CCCEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field CICEN[20] (RW)
 *
 * If this bit is set to 1, the uSDHC will check the Index field in the response
 * to see if it has the same value as the command index. If it is not, it is
 * reported as a Command Index Error. If this bit is set to 0, the Index field is
 * not checked.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_CICEN (20U)   /*!< Bit position for uSDHC_CMD_XFR_TYP_CICEN. */
#define BM_uSDHC_CMD_XFR_TYP_CICEN (0x00100000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_CICEN. */
#define BS_uSDHC_CMD_XFR_TYP_CICEN (1U)    /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_CICEN. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_CICEN field. */
#define BR_uSDHC_CMD_XFR_TYP_CICEN(x) (HW_uSDHC_CMD_XFR_TYP(x).B.CICEN)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_CICEN. */
#define BF_uSDHC_CMD_XFR_TYP_CICEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_CICEN) & BM_uSDHC_CMD_XFR_TYP_CICEN)

/*! @brief Set the CICEN field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_CICEN(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_CICEN) | BF_uSDHC_CMD_XFR_TYP_CICEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field DPSEL[21] (RW)
 *
 * This bit is set to 1 to indicate that data is present and shall be
 * transferred using the DATA line. It is set to 0 for the following: Commands using only
 * the CMD line (e.g. CMD52). Commands with no data transfer, but using the busy
 * signal on DATA0 line (R1b or R5b e.g. CMD38) In resume command, this bit shall
 * be set, and other bits in this register shall be set the same as when the
 * transfer was initially launched. When the Write Protect switch is on, (i.e. the
 * WPSPL bit is active as '0'), any command with a write operation will be ignored.
 * That is to say, when this bit is set, while the DTDSEL bit is 0, writes to
 * the register Transfer Type are ignored.
 *
 * Values:
 * - 1 - Data Present
 * - 0 - No Data Present
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_DPSEL (21U)   /*!< Bit position for uSDHC_CMD_XFR_TYP_DPSEL. */
#define BM_uSDHC_CMD_XFR_TYP_DPSEL (0x00200000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_DPSEL. */
#define BS_uSDHC_CMD_XFR_TYP_DPSEL (1U)    /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_DPSEL. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_DPSEL field. */
#define BR_uSDHC_CMD_XFR_TYP_DPSEL(x) (HW_uSDHC_CMD_XFR_TYP(x).B.DPSEL)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_DPSEL. */
#define BF_uSDHC_CMD_XFR_TYP_DPSEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_DPSEL) & BM_uSDHC_CMD_XFR_TYP_DPSEL)

/*! @brief Set the DPSEL field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_DPSEL(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_DPSEL) | BF_uSDHC_CMD_XFR_TYP_DPSEL(v)))
/*@}*/

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field CMDTYP[23:22] (RW)
 *
 * There are three types of special commands: Suspend, Resume and Abort. These
 * bits shall be set to 00b for all other commands. Suspend Command: If the
 * Suspend command succeeds, the uSDHC shall assume that the card bus has been released
 * and that it is possible to issue the next command which uses the DATA line.
 * Since the uSDHC does not monitor the content of command response, it does not
 * know if the Suspend command succeeded or not. It is the Host Driver's
 * responsibility to check the status of the Suspend command and send another command
 * marked as Suspend to inform the uSDHC that a Suspend command was successfully
 * issued. Refer to Suspend ResumeThe uSDHC supports the Suspend Resume operations of
 * SDIO cards, although slightly differently than the suggested implementation
 * of Suspend in the SDIO card specification. for more details. After the end bit
 * of command is sent, the uSDHC de-asserts Read Wait for read transactions and
 * stops checking busy for write transactions. In 4-bit mode, the interrupt cycle
 * starts. If the Suspend command fails, the uSDHC will maintain its current
 * state, and the Host Driver shall restart the transfer by setting the Continue
 * Request bit in the Protocol Control register. Resume Command: The Host Driver
 * re-starts the data transfer by restoring the registers saved before sending the
 * Suspend Command and then sends the Resume Command. The uSDHC will check for a
 * pending busy state before starting write transfers. Abort Command: If this
 * command is set when executing a read transfer, the uSDHC will stop reads to the
 * buffer. If this command is set when executing a write transfer, the uSDHC will
 * stop driving the DATA line. After issuing the Abort command, the Host Driver
 * should issue a software reset (Abort Transaction).
 *
 * Values:
 * - 11 - Abort CMD12, CMD52 for writing I/O Abort in CCCR
 * - 10 - Resume CMD52 for writing Function Select in CCCR
 * - 01 - Suspend CMD52 for writing Bus Suspend in CCCR
 * - 00 - Normal Other commands
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_CMDTYP (22U)  /*!< Bit position for uSDHC_CMD_XFR_TYP_CMDTYP. */
#define BM_uSDHC_CMD_XFR_TYP_CMDTYP (0x00C00000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_CMDTYP. */
#define BS_uSDHC_CMD_XFR_TYP_CMDTYP (2U)   /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_CMDTYP. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_CMDTYP field. */
#define BR_uSDHC_CMD_XFR_TYP_CMDTYP(x) (HW_uSDHC_CMD_XFR_TYP(x).B.CMDTYP)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_CMDTYP. */
#define BF_uSDHC_CMD_XFR_TYP_CMDTYP(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_CMDTYP) & BM_uSDHC_CMD_XFR_TYP_CMDTYP)

/*! @brief Set the CMDTYP field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_CMDTYP(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_CMDTYP) | BF_uSDHC_CMD_XFR_TYP_CMDTYP(v)))
/*@}*/

/*!
 * @name Register uSDHC_CMD_XFR_TYP, field CMDINX[29:24] (RW)
 *
 * These bits shall be set to the command number that is specified in bits 45-40
 * of the Command-Format in the SD Memory Card Physical Layer Specification and
 * SDIO Card Specification.
 */
/*@{*/
#define BP_uSDHC_CMD_XFR_TYP_CMDINX (24U)  /*!< Bit position for uSDHC_CMD_XFR_TYP_CMDINX. */
#define BM_uSDHC_CMD_XFR_TYP_CMDINX (0x3F000000U) /*!< Bit mask for uSDHC_CMD_XFR_TYP_CMDINX. */
#define BS_uSDHC_CMD_XFR_TYP_CMDINX (6U)   /*!< Bit field size in bits for uSDHC_CMD_XFR_TYP_CMDINX. */

/*! @brief Read current value of the uSDHC_CMD_XFR_TYP_CMDINX field. */
#define BR_uSDHC_CMD_XFR_TYP_CMDINX(x) (HW_uSDHC_CMD_XFR_TYP(x).B.CMDINX)

/*! @brief Format value for bitfield uSDHC_CMD_XFR_TYP_CMDINX. */
#define BF_uSDHC_CMD_XFR_TYP_CMDINX(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CMD_XFR_TYP_CMDINX) & BM_uSDHC_CMD_XFR_TYP_CMDINX)

/*! @brief Set the CMDINX field to a new value. */
#define BW_uSDHC_CMD_XFR_TYP_CMDINX(x, v) (HW_uSDHC_CMD_XFR_TYP_WR(x, (HW_uSDHC_CMD_XFR_TYP_RD(x) & ~BM_uSDHC_CMD_XFR_TYP_CMDINX) | BF_uSDHC_CMD_XFR_TYP_CMDINX(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_RSP0 - Command Response0
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_RSP0 - Command Response0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to store part 0 of the response bits from the card.
 */
typedef union _hw_usdhc_cmd_rsp0
{
    uint32_t U;
    struct _hw_usdhc_cmd_rsp0_bitfields
    {
        uint32_t CMDRSP0 : 32;         /*!< [31:0] Command Response 0 */
    } B;
} hw_usdhc_cmd_rsp0_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_RSP0 register
 */
/*@{*/
#define HW_uSDHC_CMD_RSP0_ADDR(x) ((uintptr_t)(x) + 0x10U)

#define HW_uSDHC_CMD_RSP0(x)     (*(__I hw_usdhc_cmd_rsp0_t *) HW_uSDHC_CMD_RSP0_ADDR(x))
#define HW_uSDHC_CMD_RSP0_RD(x)  (HW_uSDHC_CMD_RSP0(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_RSP0 bitfields
 */

/*!
 * @name Register uSDHC_CMD_RSP0, field CMDRSP0[31:0] (RO)
 *
 * Refer to CMD_RSP3Command Response3 for the mapping of command responses from
 * the SD Bus to this register for each response type.
 */
/*@{*/
#define BP_uSDHC_CMD_RSP0_CMDRSP0 (0U)     /*!< Bit position for uSDHC_CMD_RSP0_CMDRSP0. */
#define BM_uSDHC_CMD_RSP0_CMDRSP0 (0xFFFFFFFFU) /*!< Bit mask for uSDHC_CMD_RSP0_CMDRSP0. */
#define BS_uSDHC_CMD_RSP0_CMDRSP0 (32U)    /*!< Bit field size in bits for uSDHC_CMD_RSP0_CMDRSP0. */

/*! @brief Read current value of the uSDHC_CMD_RSP0_CMDRSP0 field. */
#define BR_uSDHC_CMD_RSP0_CMDRSP0(x) (HW_uSDHC_CMD_RSP0(x).U)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_RSP1 - Command Response1
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_RSP1 - Command Response1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to store part 1 of the response bits from the card.
 */
typedef union _hw_usdhc_cmd_rsp1
{
    uint32_t U;
    struct _hw_usdhc_cmd_rsp1_bitfields
    {
        uint32_t CMDRSP1 : 32;         /*!< [31:0] Command Response 1 */
    } B;
} hw_usdhc_cmd_rsp1_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_RSP1 register
 */
/*@{*/
#define HW_uSDHC_CMD_RSP1_ADDR(x) ((uintptr_t)(x) + 0x14U)

#define HW_uSDHC_CMD_RSP1(x)     (*(__I hw_usdhc_cmd_rsp1_t *) HW_uSDHC_CMD_RSP1_ADDR(x))
#define HW_uSDHC_CMD_RSP1_RD(x)  (HW_uSDHC_CMD_RSP1(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_RSP1 bitfields
 */

/*!
 * @name Register uSDHC_CMD_RSP1, field CMDRSP1[31:0] (RO)
 *
 * Refer to CMD_RSP3Command Response3 for the mapping of command responses from
 * the SD Bus to this register for each response type.
 */
/*@{*/
#define BP_uSDHC_CMD_RSP1_CMDRSP1 (0U)     /*!< Bit position for uSDHC_CMD_RSP1_CMDRSP1. */
#define BM_uSDHC_CMD_RSP1_CMDRSP1 (0xFFFFFFFFU) /*!< Bit mask for uSDHC_CMD_RSP1_CMDRSP1. */
#define BS_uSDHC_CMD_RSP1_CMDRSP1 (32U)    /*!< Bit field size in bits for uSDHC_CMD_RSP1_CMDRSP1. */

/*! @brief Read current value of the uSDHC_CMD_RSP1_CMDRSP1 field. */
#define BR_uSDHC_CMD_RSP1_CMDRSP1(x) (HW_uSDHC_CMD_RSP1(x).U)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_RSP2 - Command Response2
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_RSP2 - Command Response2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to store part 2 of the response bits from the card.
 */
typedef union _hw_usdhc_cmd_rsp2
{
    uint32_t U;
    struct _hw_usdhc_cmd_rsp2_bitfields
    {
        uint32_t CMDRSP2 : 32;         /*!< [31:0] Command Response 2 */
    } B;
} hw_usdhc_cmd_rsp2_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_RSP2 register
 */
/*@{*/
#define HW_uSDHC_CMD_RSP2_ADDR(x) ((uintptr_t)(x) + 0x18U)

#define HW_uSDHC_CMD_RSP2(x)     (*(__I hw_usdhc_cmd_rsp2_t *) HW_uSDHC_CMD_RSP2_ADDR(x))
#define HW_uSDHC_CMD_RSP2_RD(x)  (HW_uSDHC_CMD_RSP2(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_RSP2 bitfields
 */

/*!
 * @name Register uSDHC_CMD_RSP2, field CMDRSP2[31:0] (RO)
 *
 * Refer to CMD_RSP3Command Response3 for the mapping of command responses from
 * the SD Bus to this register for each response type.
 */
/*@{*/
#define BP_uSDHC_CMD_RSP2_CMDRSP2 (0U)     /*!< Bit position for uSDHC_CMD_RSP2_CMDRSP2. */
#define BM_uSDHC_CMD_RSP2_CMDRSP2 (0xFFFFFFFFU) /*!< Bit mask for uSDHC_CMD_RSP2_CMDRSP2. */
#define BS_uSDHC_CMD_RSP2_CMDRSP2 (32U)    /*!< Bit field size in bits for uSDHC_CMD_RSP2_CMDRSP2. */

/*! @brief Read current value of the uSDHC_CMD_RSP2_CMDRSP2 field. */
#define BR_uSDHC_CMD_RSP2_CMDRSP2(x) (HW_uSDHC_CMD_RSP2(x).U)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CMD_RSP3 - Command Response3
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CMD_RSP3 - Command Response3 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to store part 3 of the response bits from the card. The
 * table below describes the mapping of command responses from the SD Bus to
 * Command Response registers for each response type. In the table, R[ ] refers to a
 * bit range within the response data as transmitted on the SD Bus. Response Bit
 * Definition for Each Response Type Response Type Meaning of Response Response
 * Field Response Register R1,R1b (normal response) Card Status R[39:8] CMDRSP0
 * R1b (Auto CMD12 response) Card Status for Auto CMD12 R[39:8] CMDRSP3 R2 (CID,
 * CSD register) CID/CSD register [127:8] R[127:8] {CMDRSP3[23:0], CMDRSP2,
 * CMDRSP1, CMDRSP0} R3 (OCR register) OCR register for memory R[39:8] CMDRSP0 R4 (OCR
 * register) OCR register for I/O etc. R[39:8] CMDRSP0 R5, R5b SDIO response
 * R[39:8] CMDRSP0 R6 (Publish RCA) New Published RCA[31:16] and card status[15:0]
 * R[39:9] CMDRSP0 This table shows that most responses with a length of 48
 * (R[47:0]) have 32-bits of the response data (R[39:8]) stored in the CMDRSP0 register.
 * Responses of type R1b (Auto CMD12 responses) have response data bits
 * (R[39:8]) stored in the CMDRSP3 register. Responses with length 136 (R[135:0]) have
 * 120-bits of the response data (R[127:8]) stored in the CMDRSP0, 1, 2, and 3
 * registers. To be able to read the response status efficiently, the uSDHC only
 * stores part of the response data in the Command Response registers. This enables
 * the Host Driver to efficiently read 32-bits of response data in one read cycle
 * on a 32-bit bus system. Parts of the response, the Index field and the CRC,
 * are checked by the uSDHC (as specified by the Command Index Check Enable and the
 * Command CRC Check Enable bits in the Transfer Type register) and generate an
 * error interrupt if any error is detected. The bit range for the CRC check
 * depends on the response length. If the response length is 48, the uSDHC will check
 * R[47:1], and if the response length is 136 the uSDHC will check R[119:1].
 * Since the uSDHC may have a multiple block data transfer executing concurrently
 * with a CMD_wo_DAT command, the uSDHC stores the Auto CMD12 response in the
 * CMDRSP3 register. The CMD_wo_DAT response is stored in CMDRSP0. This allows the
 * uSDHC to avoid overwriting the Auto CMD12 response with the CMD_wo_DAT and vice
 * versa. When the uSDHC modifies part of the Command Response registers, as shown
 * in the table above, it preserves the unmodified bits.
 */
typedef union _hw_usdhc_cmd_rsp3
{
    uint32_t U;
    struct _hw_usdhc_cmd_rsp3_bitfields
    {
        uint32_t CMDRSP3 : 32;         /*!< [31:0] Command Response 3 */
    } B;
} hw_usdhc_cmd_rsp3_t;

/*!
 * @name Constants and macros for entire uSDHC_CMD_RSP3 register
 */
/*@{*/
#define HW_uSDHC_CMD_RSP3_ADDR(x) ((uintptr_t)(x) + 0x1CU)

#define HW_uSDHC_CMD_RSP3(x)     (*(__I hw_usdhc_cmd_rsp3_t *) HW_uSDHC_CMD_RSP3_ADDR(x))
#define HW_uSDHC_CMD_RSP3_RD(x)  (HW_uSDHC_CMD_RSP3(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_CMD_RSP3 bitfields
 */

/*!
 * @name Register uSDHC_CMD_RSP3, field CMDRSP3[31:0] (RO)
 *
 * Refer to CMD_RSP3Command Response3 for the mapping of command responses from
 * the SD Bus to this register for each response type.
 */
/*@{*/
#define BP_uSDHC_CMD_RSP3_CMDRSP3 (0U)     /*!< Bit position for uSDHC_CMD_RSP3_CMDRSP3. */
#define BM_uSDHC_CMD_RSP3_CMDRSP3 (0xFFFFFFFFU) /*!< Bit mask for uSDHC_CMD_RSP3_CMDRSP3. */
#define BS_uSDHC_CMD_RSP3_CMDRSP3 (32U)    /*!< Bit field size in bits for uSDHC_CMD_RSP3_CMDRSP3. */

/*! @brief Read current value of the uSDHC_CMD_RSP3_CMDRSP3 field. */
#define BR_uSDHC_CMD_RSP3_CMDRSP3(x) (HW_uSDHC_CMD_RSP3(x).U)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_DATA_BUFF_ACC_PORT - Data Buffer Access Port
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_DATA_BUFF_ACC_PORT - Data Buffer Access Port (RW)
 *
 * Reset value: 0x00000000U
 *
 * This is a 32-bit data port register used to access the internal buffer.
 */
typedef union _hw_usdhc_data_buff_acc_port
{
    uint32_t U;
    struct _hw_usdhc_data_buff_acc_port_bitfields
    {
        uint32_t DATCONT : 32;         /*!< [31:0] Data Content */
    } B;
} hw_usdhc_data_buff_acc_port_t;

/*!
 * @name Constants and macros for entire uSDHC_DATA_BUFF_ACC_PORT register
 */
/*@{*/
#define HW_uSDHC_DATA_BUFF_ACC_PORT_ADDR(x) ((uintptr_t)(x) + 0x20U)

#define HW_uSDHC_DATA_BUFF_ACC_PORT(x) (*(__IO hw_usdhc_data_buff_acc_port_t *) HW_uSDHC_DATA_BUFF_ACC_PORT_ADDR(x))
#define HW_uSDHC_DATA_BUFF_ACC_PORT_RD(x) (HW_uSDHC_DATA_BUFF_ACC_PORT(x).U)
#define HW_uSDHC_DATA_BUFF_ACC_PORT_WR(x, v) (HW_uSDHC_DATA_BUFF_ACC_PORT(x).U = (v))
#define HW_uSDHC_DATA_BUFF_ACC_PORT_SET(x, v) (HW_uSDHC_DATA_BUFF_ACC_PORT_WR(x, HW_uSDHC_DATA_BUFF_ACC_PORT_RD(x) |  (v)))
#define HW_uSDHC_DATA_BUFF_ACC_PORT_CLR(x, v) (HW_uSDHC_DATA_BUFF_ACC_PORT_WR(x, HW_uSDHC_DATA_BUFF_ACC_PORT_RD(x) & ~(v)))
#define HW_uSDHC_DATA_BUFF_ACC_PORT_TOG(x, v) (HW_uSDHC_DATA_BUFF_ACC_PORT_WR(x, HW_uSDHC_DATA_BUFF_ACC_PORT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_DATA_BUFF_ACC_PORT bitfields
 */

/*!
 * @name Register uSDHC_DATA_BUFF_ACC_PORT, field DATCONT[31:0] (RW)
 *
 * The Buffer Data Port register is for 32-bit data access by the ARM platform
 * or the external DMA. When the internal DMA is enabled, any write to this
 * register is ignored, and any read from this register will always yield 0s.
 */
/*@{*/
#define BP_uSDHC_DATA_BUFF_ACC_PORT_DATCONT (0U) /*!< Bit position for uSDHC_DATA_BUFF_ACC_PORT_DATCONT. */
#define BM_uSDHC_DATA_BUFF_ACC_PORT_DATCONT (0xFFFFFFFFU) /*!< Bit mask for uSDHC_DATA_BUFF_ACC_PORT_DATCONT. */
#define BS_uSDHC_DATA_BUFF_ACC_PORT_DATCONT (32U) /*!< Bit field size in bits for uSDHC_DATA_BUFF_ACC_PORT_DATCONT. */

/*! @brief Read current value of the uSDHC_DATA_BUFF_ACC_PORT_DATCONT field. */
#define BR_uSDHC_DATA_BUFF_ACC_PORT_DATCONT(x) (HW_uSDHC_DATA_BUFF_ACC_PORT(x).U)

/*! @brief Format value for bitfield uSDHC_DATA_BUFF_ACC_PORT_DATCONT. */
#define BF_uSDHC_DATA_BUFF_ACC_PORT_DATCONT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DATA_BUFF_ACC_PORT_DATCONT) & BM_uSDHC_DATA_BUFF_ACC_PORT_DATCONT)

/*! @brief Set the DATCONT field to a new value. */
#define BW_uSDHC_DATA_BUFF_ACC_PORT_DATCONT(x, v) (HW_uSDHC_DATA_BUFF_ACC_PORT_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_PRES_STATE - Present State
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_PRES_STATE - Present State (RO)
 *
 * Reset value: 0x00000000U
 *
 * The Host Driver can get status of the uSDHC from this 32-bit read only
 * register. The Host Driver can issue CMD0, CMD12, CMD13 (for memory) and CMD52 (for
 * SDIO) when the DATA lines are busy during a data transfer. These commands can
 * be issued when Command Inhibit (CMD) is set to zero. Other commands shall be
 * issued when Command Inhibit (DATA) is set to zero. Possible changes to the SD
 * Physical Specification may add other commands to this list in the future. Note:
 * the reset value of Present State Register depend on testbench connectivity.
 */
typedef union _hw_usdhc_pres_state
{
    uint32_t U;
    struct _hw_usdhc_pres_state_bitfields
    {
        uint32_t CIHB : 1;             /*!< [0] Command Inhibit (CMD) */
        uint32_t CDIHB : 1;            /*!< [1] Command Inhibit (DATA) */
        uint32_t DLA : 1;              /*!< [2] Data Line Active */
        uint32_t SDSTB : 1;            /*!< [3] SD Clock Stable */
        uint32_t IPGOFF : 1;           /*!< [4] IPG_CLK Gated Off Internally */
        uint32_t HCKOFF : 1;           /*!< [5] HCLK Gated Off Internally */
        uint32_t PEROFF : 1;           /*!< [6] IPG_PERCLK Gated Off Internally */
        uint32_t SDOFF : 1;            /*!< [7] SD Clock Gated Off Internally */
        uint32_t WTA : 1;              /*!< [8] Write Transfer Active */
        uint32_t RTA : 1;              /*!< [9] Read Transfer Active */
        uint32_t BWEN : 1;             /*!< [10] Buffer Write Enable */
        uint32_t BREN : 1;             /*!< [11] Buffer Read Enable */
        uint32_t RTR : 1;              /*!< [12] Re-Tuning Request (only for SD3.0 SDR104
                                        * mode) */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t CINST : 1;            /*!< [16] Card Inserted */
        uint32_t RESERVED1 : 1;        /*!< [17]  */
        uint32_t CDPL : 1;             /*!< [18] Card Detect Pin Level */
        uint32_t WPSPL : 1;            /*!< [19] Write Protect Switch Pin Level */
        uint32_t RESERVED2 : 3;        /*!< [22:20]  */
        uint32_t CLSL : 1;             /*!< [23] CMD Line Signal Level */
        uint32_t DLSL : 8;             /*!< [31:24] DATA[7:0] Line Signal Level */
    } B;
} hw_usdhc_pres_state_t;

/*!
 * @name Constants and macros for entire uSDHC_PRES_STATE register
 */
/*@{*/
#define HW_uSDHC_PRES_STATE_ADDR(x) ((uintptr_t)(x) + 0x24U)

#define HW_uSDHC_PRES_STATE(x)   (*(__I hw_usdhc_pres_state_t *) HW_uSDHC_PRES_STATE_ADDR(x))
#define HW_uSDHC_PRES_STATE_RD(x) (HW_uSDHC_PRES_STATE(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_PRES_STATE bitfields
 */

/*!
 * @name Register uSDHC_PRES_STATE, field CIHB[0] (RO)
 *
 * If this status bit is 0, it indicates that the CMD line is not in use and the
 * uSDHC can issue a SD / MMC Command using the CMD line. This bit is set also
 * immediately after the Transfer Type register is written. This bit is cleared
 * when the command response is received. Even if the Command Inhibit (DATA) is set
 * to 1, Commands using only the CMD line can be issued if this bit is 0.
 * Changing from 1 to 0 generates a Command Complete interrupt in the Interrupt Status
 * register. If the uSDHC cannot issue the command because of a command conflict
 * error (Refer to Command CRC Error) or because of a Command Not Issued By Auto
 * CMD12 Error, this bit will remain 1 and the Command Complete is not set. The
 * Status of issuing an Auto CMD12 does not show on this bit.
 *
 * Values:
 * - 1 - Cannot issue command
 * - 0 - Can issue command using only CMD line
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_CIHB (0U)      /*!< Bit position for uSDHC_PRES_STATE_CIHB. */
#define BM_uSDHC_PRES_STATE_CIHB (0x00000001U) /*!< Bit mask for uSDHC_PRES_STATE_CIHB. */
#define BS_uSDHC_PRES_STATE_CIHB (1U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_CIHB. */

/*! @brief Read current value of the uSDHC_PRES_STATE_CIHB field. */
#define BR_uSDHC_PRES_STATE_CIHB(x) (HW_uSDHC_PRES_STATE(x).B.CIHB)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field CDIHB[1] (RO)
 *
 * This status bit is generated if either the DAT Line Active or the Read
 * Transfer Active is set to 1. If this bit is 0, it indicates that the uSDHC can issue
 * the next SD / MMC Command. Commands with a busy signal belong to Command
 * Inhibit (DATA) (for example. R1b, R5b type). Changing from 1 to 0 generates a
 * Transfer Complete interrupt in the Interrupt Status register. The SD Host Driver
 * can save registers for a suspend transaction after this bit has changed from 1
 * to 0.
 *
 * Values:
 * - 1 - Cannot issue command which uses the DATA line
 * - 0 - Can issue command which uses the DATA line
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_CDIHB (1U)     /*!< Bit position for uSDHC_PRES_STATE_CDIHB. */
#define BM_uSDHC_PRES_STATE_CDIHB (0x00000002U) /*!< Bit mask for uSDHC_PRES_STATE_CDIHB. */
#define BS_uSDHC_PRES_STATE_CDIHB (1U)     /*!< Bit field size in bits for uSDHC_PRES_STATE_CDIHB. */

/*! @brief Read current value of the uSDHC_PRES_STATE_CDIHB field. */
#define BR_uSDHC_PRES_STATE_CDIHB(x) (HW_uSDHC_PRES_STATE(x).B.CDIHB)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field DLA[2] (RO)
 *
 * This status bit indicates whether one of the DATA lines on the SD Bus is in
 * use. In the case of read transactions: This status indicates if a read transfer
 * is executing on the SD Bus. Changes in this value from 1 to 0, between data
 * blocks, generates a Block Gap Event interrupt in the Interrupt Status register.
 * This bit will be set in either of the following cases: After the end bit of
 * the read command. When writing a 1 to the Continue Request bit in the Protocol
 * Control register to restart a read transfer. This bit will be cleared in
 * either of the following cases: (1) When the end bit of the last data block is sent
 * from the SD Bus to the uSDHC. (2) When the Read Wait state is stopped by a
 * Suspend command and the DATA2 line is released. The uSDHC will wait at the next
 * block gap by driving Read Wait at the start of the interrupt cycle. If the Read
 * Wait signal is already driven (data buffer cannot receive data), the uSDHC
 * can wait for a current block gap by continuing to drive the Read Wait signal. It
 * is necessary to support Read Wait in order to use the suspend / resume
 * function. This bit will remain 1 during Read Wait. In the case of write
 * transactions: This status indicates that a write transfer is executing on the SD Bus.
 * Changes in this value from 1 to 0 generate a Transfer Complete interrupt in the
 * Interrupt Status register. This bit will be set in either of the following
 * cases: After the end bit of the write command. When writing to 1 to the Continue
 * Request bit in the Protocol Control register to continue a write transfer. This
 * bit will be cleared in either of the following cases: When the SD card
 * releases Write Busy of the last data block, the uSDHC will also detect if the output
 * is not busy. If the SD card does not drive the busy signal after the CRC
 * status is received, the uSDHC shall assume the card drive "Not Busy". When the SD
 * card releases write busy, prior to waiting for write transfer, and as a result
 * of a Stop At Block Gap Request. In the case of command with busy pending: This
 * status indicates that a busy state follows the command and the data line is
 * in use. This bit will be cleared when the DATA0 line is released.
 *
 * Values:
 * - 1 - DATA Line Active
 * - 0 - DATA Line Inactive
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_DLA (2U)       /*!< Bit position for uSDHC_PRES_STATE_DLA. */
#define BM_uSDHC_PRES_STATE_DLA (0x00000004U) /*!< Bit mask for uSDHC_PRES_STATE_DLA. */
#define BS_uSDHC_PRES_STATE_DLA (1U)       /*!< Bit field size in bits for uSDHC_PRES_STATE_DLA. */

/*! @brief Read current value of the uSDHC_PRES_STATE_DLA field. */
#define BR_uSDHC_PRES_STATE_DLA(x) (HW_uSDHC_PRES_STATE(x).B.DLA)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field SDSTB[3] (RO)
 *
 * This status bit indicates that the internal card clock is stable. This bit is
 * for the Host Driver to poll clock status when changing the clock frequency.
 * It is recommended to clear FRC_SDCLK_ON bit in System Control register to
 * remove glitches on the card clock when the frequency is changing. Before changing
 * clock divisor value(SDCLKFS or DVS), Host Driver should make sure the SDSTB bit
 * is high.
 *
 * Values:
 * - 1 - Clock is stable.
 * - 0 - Clock is changing frequency and not stable.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_SDSTB (3U)     /*!< Bit position for uSDHC_PRES_STATE_SDSTB. */
#define BM_uSDHC_PRES_STATE_SDSTB (0x00000008U) /*!< Bit mask for uSDHC_PRES_STATE_SDSTB. */
#define BS_uSDHC_PRES_STATE_SDSTB (1U)     /*!< Bit field size in bits for uSDHC_PRES_STATE_SDSTB. */

/*! @brief Read current value of the uSDHC_PRES_STATE_SDSTB field. */
#define BR_uSDHC_PRES_STATE_SDSTB(x) (HW_uSDHC_PRES_STATE(x).B.SDSTB)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field IPGOFF[4] (RO)
 *
 * This status bit indicates that the ipg_clk is internally gated off. This bit
 * is for the Host Driver to debug.
 *
 * Values:
 * - 1 - IPG_CLK is gated off.
 * - 0 - IPG_CLK is active.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_IPGOFF (4U)    /*!< Bit position for uSDHC_PRES_STATE_IPGOFF. */
#define BM_uSDHC_PRES_STATE_IPGOFF (0x00000010U) /*!< Bit mask for uSDHC_PRES_STATE_IPGOFF. */
#define BS_uSDHC_PRES_STATE_IPGOFF (1U)    /*!< Bit field size in bits for uSDHC_PRES_STATE_IPGOFF. */

/*! @brief Read current value of the uSDHC_PRES_STATE_IPGOFF field. */
#define BR_uSDHC_PRES_STATE_IPGOFF(x) (HW_uSDHC_PRES_STATE(x).B.IPGOFF)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field HCKOFF[5] (RO)
 *
 * This status bit indicates that the HCLK is internally gated off. This bit is
 * for the Host Driver to debug during a data transfer.
 *
 * Values:
 * - 1 - HCLK is gated off.
 * - 0 - HCLK is active.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_HCKOFF (5U)    /*!< Bit position for uSDHC_PRES_STATE_HCKOFF. */
#define BM_uSDHC_PRES_STATE_HCKOFF (0x00000020U) /*!< Bit mask for uSDHC_PRES_STATE_HCKOFF. */
#define BS_uSDHC_PRES_STATE_HCKOFF (1U)    /*!< Bit field size in bits for uSDHC_PRES_STATE_HCKOFF. */

/*! @brief Read current value of the uSDHC_PRES_STATE_HCKOFF field. */
#define BR_uSDHC_PRES_STATE_HCKOFF(x) (HW_uSDHC_PRES_STATE(x).B.HCKOFF)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field PEROFF[6] (RO)
 *
 * This status bit indicates that the IPG_PERCLK is internally gated off. This
 * bit is for the Host Driver to debug transaction on the SD bus. When
 * IPG_CLK_SOFT_EN is cleared, IPG_PERCLK will be gated off, otherwise IPG_PERCLK will be
 * always active.
 *
 * Values:
 * - 1 - IPG_PERCLK is gated off.
 * - 0 - IPG_PERCLK is active.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_PEROFF (6U)    /*!< Bit position for uSDHC_PRES_STATE_PEROFF. */
#define BM_uSDHC_PRES_STATE_PEROFF (0x00000040U) /*!< Bit mask for uSDHC_PRES_STATE_PEROFF. */
#define BS_uSDHC_PRES_STATE_PEROFF (1U)    /*!< Bit field size in bits for uSDHC_PRES_STATE_PEROFF. */

/*! @brief Read current value of the uSDHC_PRES_STATE_PEROFF field. */
#define BR_uSDHC_PRES_STATE_PEROFF(x) (HW_uSDHC_PRES_STATE(x).B.PEROFF)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field SDOFF[7] (RO)
 *
 * This status bit indicates that the SD Clock is internally gated off, because
 * of buffer over / under-run or read pause without read wait assertion, or the
 * driver set FRC_SDCLK_ON bit is 0 to stop the SD clock in idle status. Set
 * IPG_PERCLK_SOFT_EN and CARD_CLK_SOFT_EN to 0 also gate off SD clock. This bit is
 * for the Host Driver to debug data transaction on the SD bus.
 *
 * Values:
 * - 1 - SD Clock is gated off.
 * - 0 - SD Clock is active.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_SDOFF (7U)     /*!< Bit position for uSDHC_PRES_STATE_SDOFF. */
#define BM_uSDHC_PRES_STATE_SDOFF (0x00000080U) /*!< Bit mask for uSDHC_PRES_STATE_SDOFF. */
#define BS_uSDHC_PRES_STATE_SDOFF (1U)     /*!< Bit field size in bits for uSDHC_PRES_STATE_SDOFF. */

/*! @brief Read current value of the uSDHC_PRES_STATE_SDOFF field. */
#define BR_uSDHC_PRES_STATE_SDOFF(x) (HW_uSDHC_PRES_STATE(x).B.SDOFF)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field WTA[8] (RO)
 *
 * This status bit indicates a write transfer is active. If this bit is 0, it
 * means no valid write data exists in the uSDHC. This bit is set in either of the
 * following cases: After the end bit of the write command. When writing 1 to the
 * Continue Request bit in the Protocol Control register to restart a write
 * transfer. This bit is cleared in either of the following cases: After getting the
 * CRC status of the last data block as specified by the transfer count (Single
 * and Multiple). After getting the CRC status of any block where data
 * transmission is about to be stopped by a Stop At Block Gap Request. During a write
 * transaction, a Block Gap Event interrupt is generated when this bit is changed to 0,
 * as result of the Stop At Block Gap Request being set. This status is useful
 * for the Host Driver in determining when to issue commands during Write Busy
 * state.
 *
 * Values:
 * - 1 - Transferring data
 * - 0 - No valid data
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_WTA (8U)       /*!< Bit position for uSDHC_PRES_STATE_WTA. */
#define BM_uSDHC_PRES_STATE_WTA (0x00000100U) /*!< Bit mask for uSDHC_PRES_STATE_WTA. */
#define BS_uSDHC_PRES_STATE_WTA (1U)       /*!< Bit field size in bits for uSDHC_PRES_STATE_WTA. */

/*! @brief Read current value of the uSDHC_PRES_STATE_WTA field. */
#define BR_uSDHC_PRES_STATE_WTA(x) (HW_uSDHC_PRES_STATE(x).B.WTA)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field RTA[9] (RO)
 *
 * This status bit is used for detecting completion of a read transfer. This bit
 * is set for either of the following conditions: After the end bit of the read
 * command. When writing a 1 to the Continue Request bit in the Protocol Control
 * register to restart a read transfer. A Transfer Complete interrupt is
 * generated when this bit changes to 0. This bit is cleared for either of the following
 * conditions: When the last data block as specified by block length is
 * transferred to the System, i.e. all data are read away from uSDHC internal buffer. When
 * all valid data blocks have been transferred from uSDHC internal buffer to the
 * System and no current block transfers are being sent as a result of the Stop
 * At Block Gap Request being set to 1.
 *
 * Values:
 * - 1 - Transferring data
 * - 0 - No valid data
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_RTA (9U)       /*!< Bit position for uSDHC_PRES_STATE_RTA. */
#define BM_uSDHC_PRES_STATE_RTA (0x00000200U) /*!< Bit mask for uSDHC_PRES_STATE_RTA. */
#define BS_uSDHC_PRES_STATE_RTA (1U)       /*!< Bit field size in bits for uSDHC_PRES_STATE_RTA. */

/*! @brief Read current value of the uSDHC_PRES_STATE_RTA field. */
#define BR_uSDHC_PRES_STATE_RTA(x) (HW_uSDHC_PRES_STATE(x).B.RTA)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field BWEN[10] (RO)
 *
 * This status bit is used for non-DMA write transfers. The uSDHC implements an
 * internal buffer to transfer data efficiently. This read only flag indicates if
 * space is available for write data. If this bit is 1, valid data greater than
 * the watermark level can be written to the buffer. A change of this bit from 1
 * to 0 occurs when some writes to the buffer(write DATPORT(Base + 0x20)) are
 * made and the buffer hasn't valid space greater than the watermark level. A change
 * of this bit from 0 to 1 occurs when the buffer can hold valid data greater
 * than the write watermark level and the Buffer Write Ready interrupt is generated
 * and enabled.
 *
 * Values:
 * - 1 - Write enable
 * - 0 - Write disable
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_BWEN (10U)     /*!< Bit position for uSDHC_PRES_STATE_BWEN. */
#define BM_uSDHC_PRES_STATE_BWEN (0x00000400U) /*!< Bit mask for uSDHC_PRES_STATE_BWEN. */
#define BS_uSDHC_PRES_STATE_BWEN (1U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_BWEN. */

/*! @brief Read current value of the uSDHC_PRES_STATE_BWEN field. */
#define BR_uSDHC_PRES_STATE_BWEN(x) (HW_uSDHC_PRES_STATE(x).B.BWEN)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field BREN[11] (RO)
 *
 * This status bit is used for non-DMA read transfers. The uSDHC implements an
 * internal buffer to transfer data efficiently. This read only flag indicates
 * that valid data exists in the host side buffer. If this bit is high, valid data
 * greater than the watermark level exist in the buffer. A change of this bit from
 * 1 to 0 occurs when some reads from the buffer(read DATPORT (Base + 0x20)) are
 * made and the buffer hasn't valid data greater than the watermark level. A
 * change of this bit from 0 to1 occurs when there is enough valid data ready in the
 * buffer and the Buffer Read Ready interrupt has been generated and enabled.
 *
 * Values:
 * - 1 - Read enable
 * - 0 - Read disable
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_BREN (11U)     /*!< Bit position for uSDHC_PRES_STATE_BREN. */
#define BM_uSDHC_PRES_STATE_BREN (0x00000800U) /*!< Bit mask for uSDHC_PRES_STATE_BREN. */
#define BS_uSDHC_PRES_STATE_BREN (1U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_BREN. */

/*! @brief Read current value of the uSDHC_PRES_STATE_BREN field. */
#define BR_uSDHC_PRES_STATE_BREN(x) (HW_uSDHC_PRES_STATE(x).B.BREN)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field RTR[12] (RO)
 *
 * Host Controller may request Host Driver to execute re-tuning sequence by
 * setting this bit when the data window is shifted by temperature drift and a tuned
 * sampling point does not have a good margin to receive correct data. This bit
 * is cleared when a command is issued with setting Execute Tuning bit in
 * MIXER_CTRL register. Changing of this bit from 0 to 1 generates Re-Tuning Event. Refer
 * to Interrupt status registers for more detail. This bit isn't set to 1 if
 * Sampling Clock Select in the MIXER_CTRL register is set to 0 (using fixed
 * sampling clock).
 *
 * Values:
 * - 1 - Sampling clock needs re-tuning
 * - 0 - Fixed or well tuned sampling clock
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_RTR (12U)      /*!< Bit position for uSDHC_PRES_STATE_RTR. */
#define BM_uSDHC_PRES_STATE_RTR (0x00001000U) /*!< Bit mask for uSDHC_PRES_STATE_RTR. */
#define BS_uSDHC_PRES_STATE_RTR (1U)       /*!< Bit field size in bits for uSDHC_PRES_STATE_RTR. */

/*! @brief Read current value of the uSDHC_PRES_STATE_RTR field. */
#define BR_uSDHC_PRES_STATE_RTR(x) (HW_uSDHC_PRES_STATE(x).B.RTR)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field CINST[16] (RO)
 *
 * This bit indicates whether a card has been inserted. The uSDHC debounces this
 * signal so that the Host Driver will not need to wait for it to stabilize.
 * Changing from a 0 to 1 generates a Card Insertion interrupt in the Interrupt
 * Status register. Changing from a 1 to 0 generates a Card Removal interrupt in the
 * Interrupt Status register. A write to the Force Event Register does not effect
 * this bit. The Software Reset For All in the System Control register does not
 * effect this bit. A software reset does not effect this bit.
 *
 * Values:
 * - 1 - Card Inserted
 * - 0 - Power on Reset or No Card
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_CINST (16U)    /*!< Bit position for uSDHC_PRES_STATE_CINST. */
#define BM_uSDHC_PRES_STATE_CINST (0x00010000U) /*!< Bit mask for uSDHC_PRES_STATE_CINST. */
#define BS_uSDHC_PRES_STATE_CINST (1U)     /*!< Bit field size in bits for uSDHC_PRES_STATE_CINST. */

/*! @brief Read current value of the uSDHC_PRES_STATE_CINST field. */
#define BR_uSDHC_PRES_STATE_CINST(x) (HW_uSDHC_PRES_STATE(x).B.CINST)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field CDPL[18] (RO)
 *
 * This bit reflects the inverse value of the CD_B pin for the card socket.
 * Debouncing is not performed on this bit. This bit may be valid, but is not
 * guaranteed, because of propagation delay. Use of this bit is limited to testing since
 * it must be debounced by software. A software reset does not effect this bit.
 * A write to the Force Event Register does not effect this bit. The reset value
 * is effected by the external card detection pin. This bit shows the value on
 * the CD_B pin (i.e. when a card is inserted in the socket, it is 0 on the CD_B
 * input, and consequently the CDPL reads 1.)
 *
 * Values:
 * - 1 - Card present (CD_B = 0)
 * - 0 - No card present (CD_B = 1)
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_CDPL (18U)     /*!< Bit position for uSDHC_PRES_STATE_CDPL. */
#define BM_uSDHC_PRES_STATE_CDPL (0x00040000U) /*!< Bit mask for uSDHC_PRES_STATE_CDPL. */
#define BS_uSDHC_PRES_STATE_CDPL (1U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_CDPL. */

/*! @brief Read current value of the uSDHC_PRES_STATE_CDPL field. */
#define BR_uSDHC_PRES_STATE_CDPL(x) (HW_uSDHC_PRES_STATE(x).B.CDPL)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field WPSPL[19] (RO)
 *
 * The Write Protect Switch is supported for memory and combo cards.This bit
 * reflects the inverted value of the WP pin of the card socket. A software reset
 * does not affect this bit. The reset value is effected by the external write
 * protect switch. If the WP pin is not used, it should be tied low, so that the
 * reset value of this bit is high and write is enabled.
 *
 * Values:
 * - 1 - Write enabled (WP = 0)
 * - 0 - Write protected (WP = 1)
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_WPSPL (19U)    /*!< Bit position for uSDHC_PRES_STATE_WPSPL. */
#define BM_uSDHC_PRES_STATE_WPSPL (0x00080000U) /*!< Bit mask for uSDHC_PRES_STATE_WPSPL. */
#define BS_uSDHC_PRES_STATE_WPSPL (1U)     /*!< Bit field size in bits for uSDHC_PRES_STATE_WPSPL. */

/*! @brief Read current value of the uSDHC_PRES_STATE_WPSPL field. */
#define BR_uSDHC_PRES_STATE_WPSPL(x) (HW_uSDHC_PRES_STATE(x).B.WPSPL)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field CLSL[23] (RO)
 *
 * This status is used to check the CMD line level to recover from errors, and
 * for debugging. The reset value is affected by the external pull-up / pull-down
 * resistor, by default, the read value of this bit after reset is 1'b1, when the
 * command line is pulled up.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_CLSL (23U)     /*!< Bit position for uSDHC_PRES_STATE_CLSL. */
#define BM_uSDHC_PRES_STATE_CLSL (0x00800000U) /*!< Bit mask for uSDHC_PRES_STATE_CLSL. */
#define BS_uSDHC_PRES_STATE_CLSL (1U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_CLSL. */

/*! @brief Read current value of the uSDHC_PRES_STATE_CLSL field. */
#define BR_uSDHC_PRES_STATE_CLSL(x) (HW_uSDHC_PRES_STATE(x).B.CLSL)
/*@}*/

/*!
 * @name Register uSDHC_PRES_STATE, field DLSL[31:24] (RO)
 *
 * This status is used to check the DATA line level to recover from errors, and
 * for debugging.This is especially useful in detecting the busy signal level
 * from DATA0. The reset value is affected by the external pull-up / pull-down
 * resistors. By default, the read value of this bit field after reset is 8'b11110111,
 * when DATA3 is pulled down and the other lines are pulled up.
 */
/*@{*/
#define BP_uSDHC_PRES_STATE_DLSL (24U)     /*!< Bit position for uSDHC_PRES_STATE_DLSL. */
#define BM_uSDHC_PRES_STATE_DLSL (0xFF000000U) /*!< Bit mask for uSDHC_PRES_STATE_DLSL. */
#define BS_uSDHC_PRES_STATE_DLSL (8U)      /*!< Bit field size in bits for uSDHC_PRES_STATE_DLSL. */

/*! @brief Read current value of the uSDHC_PRES_STATE_DLSL field. */
#define BR_uSDHC_PRES_STATE_DLSL(x) (HW_uSDHC_PRES_STATE(x).B.DLSL)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_PROT_CTRL - Protocol Control
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_PROT_CTRL - Protocol Control (RW)
 *
 * Reset value: 0x08800020U
 *
 * There are three cases to restart the transfer after stop at the block gap.
 * Which case is appropriate depends on whether the uSDHC issues a Suspend command
 * or the SD card accepts the Suspend command. If the Host Driver does not issue
 * a Suspend command, the Continue Request shall be used to restart the transfer.
 * If the Host Driver issues a Suspend command and the SD card accepts it, a
 * Resume command shall be used to restart the transfer. If the Host Driver issues a
 * Suspend command and the SD card does not accept it, the Continue Request
 * shall be used to restart the transfer. Any time Stop At Block Gap Request stops
 * the data transfer, the Host Driver shall wait for a Transfer Complete (in the
 * Interrupt Status register), before attempting to restart the transfer. When
 * restarting the data transfer by Continue Request, the Host Driver shall clear the
 * Stop At Block Gap Request before or simultaneously.
 */
typedef union _hw_usdhc_prot_ctrl
{
    uint32_t U;
    struct _hw_usdhc_prot_ctrl_bitfields
    {
        uint32_t LCTL : 1;             /*!< [0] LED Control */
        uint32_t DTW : 2;              /*!< [2:1] Data Transfer Width */
        uint32_t D3CD : 1;             /*!< [3] DATA3 as Card Detection Pin */
        uint32_t EMODE : 2;            /*!< [5:4] Endian Mode */
        uint32_t CDTL : 1;             /*!< [6] Card Detect Test Level */
        uint32_t CDSS : 1;             /*!< [7] Card Detect Signal Selection */
        uint32_t DMASEL : 2;           /*!< [9:8] DMA Select */
        uint32_t RESERVED0 : 6;        /*!< [15:10]  */
        uint32_t SABGREQ : 1;          /*!< [16] Stop At Block Gap Request */
        uint32_t CREQ : 1;             /*!< [17] Continue Request */
        uint32_t RWCTL : 1;            /*!< [18] Read Wait Control */
        uint32_t IABG : 1;             /*!< [19] Interrupt At Block Gap */
        uint32_t RD_DONE_NO_8CLK : 1;  /*!< [20]  */
        uint32_t RESERVED1 : 3;        /*!< [23:21]  */
        uint32_t WECINT : 1;           /*!< [24] Wakeup Event Enable On Card Interrupt
                                        * */
        uint32_t WECINS : 1;           /*!< [25] Wakeup Event Enable On SD Card
                                        * Insertion */
        uint32_t WECRM : 1;            /*!< [26] Wakeup Event Enable On SD Card Removal
                                        * */
        uint32_t BURST_LEN_EN : 3;     /*!< [29:27] BURST length enable for INCR,
                                        * INCR4 / INCR8 / INCR16, INCR4-WRAP / INCR8-WRAP / INCR16-WRAP */
        uint32_t NON_EXACT_BLK_RD : 1; /*!< [30]  */
        uint32_t RESERVED2 : 1;        /*!< [31]  */
    } B;
} hw_usdhc_prot_ctrl_t;

/*!
 * @name Constants and macros for entire uSDHC_PROT_CTRL register
 */
/*@{*/
#define HW_uSDHC_PROT_CTRL_ADDR(x) ((uintptr_t)(x) + 0x28U)

#define HW_uSDHC_PROT_CTRL(x)    (*(__IO hw_usdhc_prot_ctrl_t *) HW_uSDHC_PROT_CTRL_ADDR(x))
#define HW_uSDHC_PROT_CTRL_RD(x) (HW_uSDHC_PROT_CTRL(x).U)
#define HW_uSDHC_PROT_CTRL_WR(x, v) (HW_uSDHC_PROT_CTRL(x).U = (v))
#define HW_uSDHC_PROT_CTRL_SET(x, v) (HW_uSDHC_PROT_CTRL_WR(x, HW_uSDHC_PROT_CTRL_RD(x) |  (v)))
#define HW_uSDHC_PROT_CTRL_CLR(x, v) (HW_uSDHC_PROT_CTRL_WR(x, HW_uSDHC_PROT_CTRL_RD(x) & ~(v)))
#define HW_uSDHC_PROT_CTRL_TOG(x, v) (HW_uSDHC_PROT_CTRL_WR(x, HW_uSDHC_PROT_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_PROT_CTRL bitfields
 */

/*!
 * @name Register uSDHC_PROT_CTRL, field LCTL[0] (RW)
 *
 * This bit, fully controlled by the Host Driver, is used to caution the user
 * not to remove the card while the card is being accessed. If the software is
 * going to issue multiple SD commands, this bit can be set during all these
 * transactions. It is not necessary to change for each transaction. When the software
 * issues multiple SD commands, setting the bit once before the first command is
 * sufficient: it is not necessary to reset the bit between commands.
 *
 * Values:
 * - 1 - LED on
 * - 0 - LED off
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_LCTL (0U)       /*!< Bit position for uSDHC_PROT_CTRL_LCTL. */
#define BM_uSDHC_PROT_CTRL_LCTL (0x00000001U) /*!< Bit mask for uSDHC_PROT_CTRL_LCTL. */
#define BS_uSDHC_PROT_CTRL_LCTL (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_LCTL. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_LCTL field. */
#define BR_uSDHC_PROT_CTRL_LCTL(x) (HW_uSDHC_PROT_CTRL(x).B.LCTL)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_LCTL. */
#define BF_uSDHC_PROT_CTRL_LCTL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_LCTL) & BM_uSDHC_PROT_CTRL_LCTL)

/*! @brief Set the LCTL field to a new value. */
#define BW_uSDHC_PROT_CTRL_LCTL(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_LCTL) | BF_uSDHC_PROT_CTRL_LCTL(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field DTW[2:1] (RW)
 *
 * This bit selects the data width of the SD bus for a data transfer. The Host
 * Driver shall set it to match the data width of the card. Possible Data transfer
 * Width is 1-bit, 4-bits or 8-bits.
 *
 * Values:
 * - 10 - 8-bit mode
 * - 01 - 4-bit mode
 * - 00 - 1-bit mode
 * - 11 - Reserved
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_DTW (1U)        /*!< Bit position for uSDHC_PROT_CTRL_DTW. */
#define BM_uSDHC_PROT_CTRL_DTW (0x00000006U) /*!< Bit mask for uSDHC_PROT_CTRL_DTW. */
#define BS_uSDHC_PROT_CTRL_DTW (2U)        /*!< Bit field size in bits for uSDHC_PROT_CTRL_DTW. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_DTW field. */
#define BR_uSDHC_PROT_CTRL_DTW(x) (HW_uSDHC_PROT_CTRL(x).B.DTW)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_DTW. */
#define BF_uSDHC_PROT_CTRL_DTW(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_DTW) & BM_uSDHC_PROT_CTRL_DTW)

/*! @brief Set the DTW field to a new value. */
#define BW_uSDHC_PROT_CTRL_DTW(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_DTW) | BF_uSDHC_PROT_CTRL_DTW(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field D3CD[3] (RW)
 *
 * If this bit is set, DATA3 should be pulled down to act as a card detection
 * pin. Be cautious when using this feature, because DATA3 is also a chip-select
 * for the SPI mode. A pull-down on this pin and CMD0 may set the card into the SPI
 * mode, which the uSDHC does not support.
 *
 * Values:
 * - 1 - DATA3 as Card Detection Pin
 * - 0 - DATA3 does not monitor Card Insertion
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_D3CD (3U)       /*!< Bit position for uSDHC_PROT_CTRL_D3CD. */
#define BM_uSDHC_PROT_CTRL_D3CD (0x00000008U) /*!< Bit mask for uSDHC_PROT_CTRL_D3CD. */
#define BS_uSDHC_PROT_CTRL_D3CD (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_D3CD. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_D3CD field. */
#define BR_uSDHC_PROT_CTRL_D3CD(x) (HW_uSDHC_PROT_CTRL(x).B.D3CD)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_D3CD. */
#define BF_uSDHC_PROT_CTRL_D3CD(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_D3CD) & BM_uSDHC_PROT_CTRL_D3CD)

/*! @brief Set the D3CD field to a new value. */
#define BW_uSDHC_PROT_CTRL_D3CD(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_D3CD) | BF_uSDHC_PROT_CTRL_D3CD(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field EMODE[5:4] (RW)
 *
 * The uSDHC supports all three endian modes in data transfer. Refer to Data
 * BufferThe uSDHC uses one configurable data buffer to transfer data between the
 * system bus (IP Bus or AHB Bus) and the SD card in an optimized manner,
 * maximizing throughput between the two clock domains (IP peripheral clock and the master
 * clock). for more details.
 *
 * Values:
 * - 00 - Big Endian Mode
 * - 01 - Half Word Big Endian Mode
 * - 10 - Little Endian Mode
 * - 11 - Reserved
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_EMODE (4U)      /*!< Bit position for uSDHC_PROT_CTRL_EMODE. */
#define BM_uSDHC_PROT_CTRL_EMODE (0x00000030U) /*!< Bit mask for uSDHC_PROT_CTRL_EMODE. */
#define BS_uSDHC_PROT_CTRL_EMODE (2U)      /*!< Bit field size in bits for uSDHC_PROT_CTRL_EMODE. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_EMODE field. */
#define BR_uSDHC_PROT_CTRL_EMODE(x) (HW_uSDHC_PROT_CTRL(x).B.EMODE)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_EMODE. */
#define BF_uSDHC_PROT_CTRL_EMODE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_EMODE) & BM_uSDHC_PROT_CTRL_EMODE)

/*! @brief Set the EMODE field to a new value. */
#define BW_uSDHC_PROT_CTRL_EMODE(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_EMODE) | BF_uSDHC_PROT_CTRL_EMODE(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field CDTL[6] (RW)
 *
 * This is bit is enabled while the Card Detection Signal Selection is set to 1
 * and it indicates card insertion.
 *
 * Values:
 * - 1 - Card Detect Test Level is 1, card inserted
 * - 0 - Card Detect Test Level is 0, no card inserted
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_CDTL (6U)       /*!< Bit position for uSDHC_PROT_CTRL_CDTL. */
#define BM_uSDHC_PROT_CTRL_CDTL (0x00000040U) /*!< Bit mask for uSDHC_PROT_CTRL_CDTL. */
#define BS_uSDHC_PROT_CTRL_CDTL (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_CDTL. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_CDTL field. */
#define BR_uSDHC_PROT_CTRL_CDTL(x) (HW_uSDHC_PROT_CTRL(x).B.CDTL)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_CDTL. */
#define BF_uSDHC_PROT_CTRL_CDTL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_CDTL) & BM_uSDHC_PROT_CTRL_CDTL)

/*! @brief Set the CDTL field to a new value. */
#define BW_uSDHC_PROT_CTRL_CDTL(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_CDTL) | BF_uSDHC_PROT_CTRL_CDTL(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field CDSS[7] (RW)
 *
 * This bit selects the source for the card detection.
 *
 * Values:
 * - 1 - Card Detection Test Level is selected (for test purpose).
 * - 0 - Card Detection Level is selected (for normal purpose).
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_CDSS (7U)       /*!< Bit position for uSDHC_PROT_CTRL_CDSS. */
#define BM_uSDHC_PROT_CTRL_CDSS (0x00000080U) /*!< Bit mask for uSDHC_PROT_CTRL_CDSS. */
#define BS_uSDHC_PROT_CTRL_CDSS (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_CDSS. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_CDSS field. */
#define BR_uSDHC_PROT_CTRL_CDSS(x) (HW_uSDHC_PROT_CTRL(x).B.CDSS)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_CDSS. */
#define BF_uSDHC_PROT_CTRL_CDSS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_CDSS) & BM_uSDHC_PROT_CTRL_CDSS)

/*! @brief Set the CDSS field to a new value. */
#define BW_uSDHC_PROT_CTRL_CDSS(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_CDSS) | BF_uSDHC_PROT_CTRL_CDSS(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field DMASEL[9:8] (RW)
 *
 * This field is valid while DMA (SDMA or ADMA) is enabled and selects the DMA
 * operation.
 *
 * Values:
 * - 00 - No DMA or Simple DMA is selected
 * - 01 - ADMA1 is selected
 * - 10 - ADMA2 is selected
 * - 11 - reserved
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_DMASEL (8U)     /*!< Bit position for uSDHC_PROT_CTRL_DMASEL. */
#define BM_uSDHC_PROT_CTRL_DMASEL (0x00000300U) /*!< Bit mask for uSDHC_PROT_CTRL_DMASEL. */
#define BS_uSDHC_PROT_CTRL_DMASEL (2U)     /*!< Bit field size in bits for uSDHC_PROT_CTRL_DMASEL. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_DMASEL field. */
#define BR_uSDHC_PROT_CTRL_DMASEL(x) (HW_uSDHC_PROT_CTRL(x).B.DMASEL)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_DMASEL. */
#define BF_uSDHC_PROT_CTRL_DMASEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_DMASEL) & BM_uSDHC_PROT_CTRL_DMASEL)

/*! @brief Set the DMASEL field to a new value. */
#define BW_uSDHC_PROT_CTRL_DMASEL(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_DMASEL) | BF_uSDHC_PROT_CTRL_DMASEL(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field SABGREQ[16] (RW)
 *
 * This bit is used to stop executing a transaction at the next block gap for
 * both DMA and non-DMA transfers. Until the Transfer Complete is set to 1,
 * indicating a transfer completion, the Host Driver shall leave this bit set to 1.
 * Clearing both the Stop At Block Gap Request and Continue Request does not cause
 * the transaction to restart. Read Wait is used to stop the read transaction at
 * the block gap. The uSDHC will honor the Stop At Block Gap Request for write
 * transfers, but for read transfers it requires that the SDIO card support Read
 * Wait. Therefore, the Host Driver shall not set this bit during read transfers
 * unless the SDIO card supports Read Wait and has set the Read Wait Control to 1,
 * otherwise the uSDHC will stop the SD bus clock to pause the read operation
 * during block gap. In the case of write transfers in which the Host Driver writes
 * data to the Data Port register, the Host Driver shall set this bit after all
 * block data is written. If this bit is set to 1, the Host Driver shall not write
 * data to the Data Port register after a block is sent. Once this bit is set, the
 * Host Driver shall not clear this bit before the Transfer Complete bit in
 * Interrupt Status Register is set, otherwise the uSDHCs behavior is undefined. This
 * bit effects Read Transfer Active, Write Transfer Active, DATA Line Active and
 * Command Inhibit (DATA) in the Present State register.
 *
 * Values:
 * - 1 - Stop
 * - 0 - Transfer
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_SABGREQ (16U)   /*!< Bit position for uSDHC_PROT_CTRL_SABGREQ. */
#define BM_uSDHC_PROT_CTRL_SABGREQ (0x00010000U) /*!< Bit mask for uSDHC_PROT_CTRL_SABGREQ. */
#define BS_uSDHC_PROT_CTRL_SABGREQ (1U)    /*!< Bit field size in bits for uSDHC_PROT_CTRL_SABGREQ. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_SABGREQ field. */
#define BR_uSDHC_PROT_CTRL_SABGREQ(x) (HW_uSDHC_PROT_CTRL(x).B.SABGREQ)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_SABGREQ. */
#define BF_uSDHC_PROT_CTRL_SABGREQ(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_SABGREQ) & BM_uSDHC_PROT_CTRL_SABGREQ)

/*! @brief Set the SABGREQ field to a new value. */
#define BW_uSDHC_PROT_CTRL_SABGREQ(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_SABGREQ) | BF_uSDHC_PROT_CTRL_SABGREQ(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field CREQ[17] (RW)
 *
 * This bit is used to restart a transaction which was stopped using the Stop At
 * Block Gap Request. When a Suspend operation is not accepted by the card, it
 * is also by setting this bit to restart the paused transfer. To cancel stop at
 * the block gap, set Stop At Block Gap Request to 0 and set this bit to 1 to
 * restart the transfer. The uSDHC automatically clears this bit, therefore it is not
 * necessary for the Host Driver to set this bit to 0. If both Stop At Block Gap
 * Request and this bit are 1, the continue request is ignored.
 *
 * Values:
 * - 1 - Restart
 * - 0 - No effect
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_CREQ (17U)      /*!< Bit position for uSDHC_PROT_CTRL_CREQ. */
#define BM_uSDHC_PROT_CTRL_CREQ (0x00020000U) /*!< Bit mask for uSDHC_PROT_CTRL_CREQ. */
#define BS_uSDHC_PROT_CTRL_CREQ (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_CREQ. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_CREQ field. */
#define BR_uSDHC_PROT_CTRL_CREQ(x) (HW_uSDHC_PROT_CTRL(x).B.CREQ)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_CREQ. */
#define BF_uSDHC_PROT_CTRL_CREQ(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_CREQ) & BM_uSDHC_PROT_CTRL_CREQ)

/*! @brief Set the CREQ field to a new value. */
#define BW_uSDHC_PROT_CTRL_CREQ(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_CREQ) | BF_uSDHC_PROT_CTRL_CREQ(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field RWCTL[18] (RW)
 *
 * The read wait function is optional for SDIO cards. If the card supports read
 * wait, set this bit to enable use of the read wait protocol to stop read data
 * using the DATA2 line. Otherwise the uSDHC has to stop the SD Clock to hold read
 * data, which restricts commands generation. When the Host Driver detects an
 * SDIO card insertion, it shall set this bit according to the CCCR of the card. If
 * the card does not support read wait, this bit shall never be set to 1,
 * otherwise DATA line conflicts may occur. If this bit is set to 0, stop at block gap
 * during read operation is also supported, but the uSDHC will stop the SD Clock
 * to pause reading operation.
 *
 * Values:
 * - 1 - Enable Read Wait Control, and assert Read Wait without stopping SD
 *     Clock at block gap when SABGREQ bit is set
 * - 0 - Disable Read Wait Control, and stop SD Clock at block gap when SABGREQ
 *     bit is set
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_RWCTL (18U)     /*!< Bit position for uSDHC_PROT_CTRL_RWCTL. */
#define BM_uSDHC_PROT_CTRL_RWCTL (0x00040000U) /*!< Bit mask for uSDHC_PROT_CTRL_RWCTL. */
#define BS_uSDHC_PROT_CTRL_RWCTL (1U)      /*!< Bit field size in bits for uSDHC_PROT_CTRL_RWCTL. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_RWCTL field. */
#define BR_uSDHC_PROT_CTRL_RWCTL(x) (HW_uSDHC_PROT_CTRL(x).B.RWCTL)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_RWCTL. */
#define BF_uSDHC_PROT_CTRL_RWCTL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_RWCTL) & BM_uSDHC_PROT_CTRL_RWCTL)

/*! @brief Set the RWCTL field to a new value. */
#define BW_uSDHC_PROT_CTRL_RWCTL(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_RWCTL) | BF_uSDHC_PROT_CTRL_RWCTL(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field IABG[19] (RW)
 *
 * This bit is valid only in 4-bit mode, of the SDIO card, and selects a sample
 * point in the interrupt cycle. Setting to 1 enables interrupt detection at the
 * block gap for a multiple block transfer. Setting to 0 disables interrupt
 * detection during a multiple block transfer. If the SDIO card cannot signal an
 * interrupt during a multiple block transfer, this bit should be set to 0 to avoid an
 * inadvertent interrupt. When the Host Driver detects an SDIO card insertion,
 * it shall set this bit according to the CCCR of the card.
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Disabled
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_IABG (19U)      /*!< Bit position for uSDHC_PROT_CTRL_IABG. */
#define BM_uSDHC_PROT_CTRL_IABG (0x00080000U) /*!< Bit mask for uSDHC_PROT_CTRL_IABG. */
#define BS_uSDHC_PROT_CTRL_IABG (1U)       /*!< Bit field size in bits for uSDHC_PROT_CTRL_IABG. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_IABG field. */
#define BR_uSDHC_PROT_CTRL_IABG(x) (HW_uSDHC_PROT_CTRL(x).B.IABG)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_IABG. */
#define BF_uSDHC_PROT_CTRL_IABG(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_IABG) & BM_uSDHC_PROT_CTRL_IABG)

/*! @brief Set the IABG field to a new value. */
#define BW_uSDHC_PROT_CTRL_IABG(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_IABG) | BF_uSDHC_PROT_CTRL_IABG(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field RD_DONE_NO_8CLK[20] (RW)
 *
 * Read done no 8 clock: According to the SD/MMC spec, for read data
 * transaction, 8 clocks are needed after the end bit of the last data block. So, by
 * default(RD_DONE_NO_8CLK=0), 8 clocks will be active after the end bit of the last
 * read data transaction. However, this 8 clocks should not be active if user wants
 * to use stop at block gap(include the auto stop at block gap in boot mode)
 * feature for read and the RWCTL bit(bit18) is not enabled. In this case, software
 * should set RD_DONE_NO_8CLK to avoid this 8 clocks. Otherwise, the device may
 * send extra data to uSDHC while uSDHC ignores these data. In a summary, this bit
 * should be set only if the use case needs to use stop at block gap feature
 * while the device can't support the read wait feature.
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK (20U) /*!< Bit position for uSDHC_PROT_CTRL_RD_DONE_NO_8CLK. */
#define BM_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK (0x00100000U) /*!< Bit mask for uSDHC_PROT_CTRL_RD_DONE_NO_8CLK. */
#define BS_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK (1U) /*!< Bit field size in bits for uSDHC_PROT_CTRL_RD_DONE_NO_8CLK. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_RD_DONE_NO_8CLK field. */
#define BR_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK(x) (HW_uSDHC_PROT_CTRL(x).B.RD_DONE_NO_8CLK)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_RD_DONE_NO_8CLK. */
#define BF_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK) & BM_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK)

/*! @brief Set the RD_DONE_NO_8CLK field to a new value. */
#define BW_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK) | BF_uSDHC_PROT_CTRL_RD_DONE_NO_8CLK(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field WECINT[24] (RW)
 *
 * This bit enables a wakeup event, via a Card Interrupt, in the Interrupt
 * Status register. This bit can be set to 1 if FN_WUS (Wake Up Support) in CIS is set
 * to 1. When this bit is set, the Card Interrupt Status and the uSDHC interrupt
 * can be asserted without CLK toggling. When the wakeup feature is not enabled,
 * the CLK must be active in order to assert the Card Interrupt Status and the
 * uSDHC interrupt.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_WECINT (24U)    /*!< Bit position for uSDHC_PROT_CTRL_WECINT. */
#define BM_uSDHC_PROT_CTRL_WECINT (0x01000000U) /*!< Bit mask for uSDHC_PROT_CTRL_WECINT. */
#define BS_uSDHC_PROT_CTRL_WECINT (1U)     /*!< Bit field size in bits for uSDHC_PROT_CTRL_WECINT. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_WECINT field. */
#define BR_uSDHC_PROT_CTRL_WECINT(x) (HW_uSDHC_PROT_CTRL(x).B.WECINT)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_WECINT. */
#define BF_uSDHC_PROT_CTRL_WECINT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_WECINT) & BM_uSDHC_PROT_CTRL_WECINT)

/*! @brief Set the WECINT field to a new value. */
#define BW_uSDHC_PROT_CTRL_WECINT(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_WECINT) | BF_uSDHC_PROT_CTRL_WECINT(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field WECINS[25] (RW)
 *
 * This bit enables a wakeup event, via a Card Insertion, in the Interrupt
 * Status register. FN_WUS (Wake Up Support) in CIS does not effect this bit. When
 * this bit is set, the Card Insertion Status and the uSDHC interrupt can be
 * asserted without CLK toggling. When the wakeup feature is not enabled, the CLK must
 * be active in order to assert the Card Insertion Status and the uSDHC interrupt.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_WECINS (25U)    /*!< Bit position for uSDHC_PROT_CTRL_WECINS. */
#define BM_uSDHC_PROT_CTRL_WECINS (0x02000000U) /*!< Bit mask for uSDHC_PROT_CTRL_WECINS. */
#define BS_uSDHC_PROT_CTRL_WECINS (1U)     /*!< Bit field size in bits for uSDHC_PROT_CTRL_WECINS. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_WECINS field. */
#define BR_uSDHC_PROT_CTRL_WECINS(x) (HW_uSDHC_PROT_CTRL(x).B.WECINS)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_WECINS. */
#define BF_uSDHC_PROT_CTRL_WECINS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_WECINS) & BM_uSDHC_PROT_CTRL_WECINS)

/*! @brief Set the WECINS field to a new value. */
#define BW_uSDHC_PROT_CTRL_WECINS(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_WECINS) | BF_uSDHC_PROT_CTRL_WECINS(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field WECRM[26] (RW)
 *
 * This bit enables a wakeup event, via a Card Removal, in the Interrupt Status
 * register. FN_WUS (Wake Up Support) in CIS does not effect this bit. When this
 * bit is set, the Card Removal Status and the uSDHC interrupt can be asserted
 * without CLK toggling. When the wakeup feature is not enabled, the CLK must be
 * active in order to assert the Card Removal Status and the uSDHC interrupt.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_WECRM (26U)     /*!< Bit position for uSDHC_PROT_CTRL_WECRM. */
#define BM_uSDHC_PROT_CTRL_WECRM (0x04000000U) /*!< Bit mask for uSDHC_PROT_CTRL_WECRM. */
#define BS_uSDHC_PROT_CTRL_WECRM (1U)      /*!< Bit field size in bits for uSDHC_PROT_CTRL_WECRM. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_WECRM field. */
#define BR_uSDHC_PROT_CTRL_WECRM(x) (HW_uSDHC_PROT_CTRL(x).B.WECRM)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_WECRM. */
#define BF_uSDHC_PROT_CTRL_WECRM(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_WECRM) & BM_uSDHC_PROT_CTRL_WECRM)

/*! @brief Set the WECRM field to a new value. */
#define BW_uSDHC_PROT_CTRL_WECRM(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_WECRM) | BF_uSDHC_PROT_CTRL_WECRM(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field BURST_LEN_EN[29:27] (RW)
 *
 * This is used to enable / disable the burst length for the external AHB2AXI
 * bridge. It is useful especially for INCR transfer because without burst length
 * indicator, the AHB2AXI bridge does not know the burst length in advance.
 * Without burst length indicator, AHB INCR transfers can only be converted to SINGLEs
 * on the AXI side.
 *
 * Values:
 * - xx1 - Burst length is enabled for INCR
 * - x1x - Burst length is enabled for INCR4 / INCR8 / INCR16
 * - 1xx - Burst length is enabled for INCR4-WRAP / INCR8-WRAP / INCR16-WRAP
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_BURST_LEN_EN (27U) /*!< Bit position for uSDHC_PROT_CTRL_BURST_LEN_EN. */
#define BM_uSDHC_PROT_CTRL_BURST_LEN_EN (0x38000000U) /*!< Bit mask for uSDHC_PROT_CTRL_BURST_LEN_EN. */
#define BS_uSDHC_PROT_CTRL_BURST_LEN_EN (3U) /*!< Bit field size in bits for uSDHC_PROT_CTRL_BURST_LEN_EN. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_BURST_LEN_EN field. */
#define BR_uSDHC_PROT_CTRL_BURST_LEN_EN(x) (HW_uSDHC_PROT_CTRL(x).B.BURST_LEN_EN)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_BURST_LEN_EN. */
#define BF_uSDHC_PROT_CTRL_BURST_LEN_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_BURST_LEN_EN) & BM_uSDHC_PROT_CTRL_BURST_LEN_EN)

/*! @brief Set the BURST_LEN_EN field to a new value. */
#define BW_uSDHC_PROT_CTRL_BURST_LEN_EN(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_BURST_LEN_EN) | BF_uSDHC_PROT_CTRL_BURST_LEN_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_PROT_CTRL, field NON_EXACT_BLK_RD[30] (RW)
 *
 * Current block read is non-exact block read. It is only used for SDIO.
 *
 * Values:
 * - 1 - The block read is non-exact block read. Host driver needs to issue
 *     abort command to terminate this multi-block read.
 * - 0 - The block read is exact block read. Host driver doesn't need to issue
 *     abort command to terminate this multi-block read.
 */
/*@{*/
#define BP_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD (30U) /*!< Bit position for uSDHC_PROT_CTRL_NON_EXACT_BLK_RD. */
#define BM_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD (0x40000000U) /*!< Bit mask for uSDHC_PROT_CTRL_NON_EXACT_BLK_RD. */
#define BS_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD (1U) /*!< Bit field size in bits for uSDHC_PROT_CTRL_NON_EXACT_BLK_RD. */

/*! @brief Read current value of the uSDHC_PROT_CTRL_NON_EXACT_BLK_RD field. */
#define BR_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD(x) (HW_uSDHC_PROT_CTRL(x).B.NON_EXACT_BLK_RD)

/*! @brief Format value for bitfield uSDHC_PROT_CTRL_NON_EXACT_BLK_RD. */
#define BF_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD) & BM_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD)

/*! @brief Set the NON_EXACT_BLK_RD field to a new value. */
#define BW_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD(x, v) (HW_uSDHC_PROT_CTRL_WR(x, (HW_uSDHC_PROT_CTRL_RD(x) & ~BM_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD) | BF_uSDHC_PROT_CTRL_NON_EXACT_BLK_RD(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_SYS_CTRL - System Control
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_SYS_CTRL - System Control (RW)
 *
 * Reset value: 0x0080800FU
 */
typedef union _hw_usdhc_sys_ctrl
{
    uint32_t U;
    struct _hw_usdhc_sys_ctrl_bitfields
    {
        uint32_t RESERVED0 : 4;        /*!< [3:0]  */
        uint32_t DVS : 4;              /*!< [7:4] Divisor */
        uint32_t SDCLKFS : 8;          /*!< [15:8] SDCLK Frequency Select */
        uint32_t DTOCV : 4;            /*!< [19:16] Data Timeout Counter Value */
        uint32_t RESERVED1 : 3;        /*!< [22:20]  */
        uint32_t IPP_RST_N : 1;        /*!< [23]  */
        uint32_t RSTA : 1;             /*!< [24] Software Reset For ALL */
        uint32_t RSTC : 1;             /*!< [25] Software Reset For CMD Line */
        uint32_t RSTD : 1;             /*!< [26] Software Reset For DATA Line */
        uint32_t INITA : 1;            /*!< [27] Initialization Active */
        uint32_t RESERVED2 : 4;        /*!< [31:28]  */
    } B;
} hw_usdhc_sys_ctrl_t;

/*!
 * @name Constants and macros for entire uSDHC_SYS_CTRL register
 */
/*@{*/
#define HW_uSDHC_SYS_CTRL_ADDR(x) ((uintptr_t)(x) + 0x2CU)

#define HW_uSDHC_SYS_CTRL(x)     (*(__IO hw_usdhc_sys_ctrl_t *) HW_uSDHC_SYS_CTRL_ADDR(x))
#define HW_uSDHC_SYS_CTRL_RD(x)  (HW_uSDHC_SYS_CTRL(x).U)
#define HW_uSDHC_SYS_CTRL_WR(x, v) (HW_uSDHC_SYS_CTRL(x).U = (v))
#define HW_uSDHC_SYS_CTRL_SET(x, v) (HW_uSDHC_SYS_CTRL_WR(x, HW_uSDHC_SYS_CTRL_RD(x) |  (v)))
#define HW_uSDHC_SYS_CTRL_CLR(x, v) (HW_uSDHC_SYS_CTRL_WR(x, HW_uSDHC_SYS_CTRL_RD(x) & ~(v)))
#define HW_uSDHC_SYS_CTRL_TOG(x, v) (HW_uSDHC_SYS_CTRL_WR(x, HW_uSDHC_SYS_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_SYS_CTRL bitfields
 */

/*!
 * @name Register uSDHC_SYS_CTRL, field DVS[7:4] (RW)
 *
 * This register is used to provide a more exact divisor to generate the desired
 * SD clock frequency. Note the divider can even support odd divisors without
 * deterioration of duty cycle. Before changing clock divisor value(SDCLKFS or
 * DVS), Host Driver should make sure the SDSTB bit is high. The setting are as
 * following:
 *
 * Values:
 * - 0000 - Divide-by-1
 * - 0001 - Divide-by-2
 * - 1110 - Divide-by-15
 * - 1111 - Divide-by-16
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_DVS (4U)         /*!< Bit position for uSDHC_SYS_CTRL_DVS. */
#define BM_uSDHC_SYS_CTRL_DVS (0x000000F0U) /*!< Bit mask for uSDHC_SYS_CTRL_DVS. */
#define BS_uSDHC_SYS_CTRL_DVS (4U)         /*!< Bit field size in bits for uSDHC_SYS_CTRL_DVS. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_DVS field. */
#define BR_uSDHC_SYS_CTRL_DVS(x) (HW_uSDHC_SYS_CTRL(x).B.DVS)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_DVS. */
#define BF_uSDHC_SYS_CTRL_DVS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_DVS) & BM_uSDHC_SYS_CTRL_DVS)

/*! @brief Set the DVS field to a new value. */
#define BW_uSDHC_SYS_CTRL_DVS(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_DVS) | BF_uSDHC_SYS_CTRL_DVS(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field SDCLKFS[15:8] (RW)
 *
 * This register is used to select the frequency of the SDCLK pin. The frequency
 * is not programmed directly, rather this register holds the prescaler (this
 * register) and divisor (next register) of the Base Clock Frequency register. I n
 * Single Data Rate mode(DDR_EN bit of MIXERCTRL is '0') Only the following
 * settings are allowed: 80h) Base clock divided by 256 40h) Base clock divided by 128
 * 20h) Base clock divided by 64 10h) Base clock divided by 32 08h) Base clock
 * divided by 16 04h) Base clock divided by 8 02h) Base clock divided by 4 01h)
 * Base clock divided by 2 00h) Base clock divided by 1 W hile in Dual Data Rate
 * mode(DDR_EN bit of MIXERCTRL is '1') Only the following settings are allowed:
 * 80h) Base clock divided by 512 40h) Base clock divided by 256 20h) Base clock
 * divided by 128 10h) Base clock divided by 64 08h) Base clock divided by 32 04h)
 * Base clock divided by 16 02h) Base clock divided by 8 01h) Base clock divided
 * by 4 00h) Base clock divided by 2 W hen S/W changes the DDR_EN bit, SDCLKFS
 * may need to be changed also ! In Single Data Rate mode, setting 00h bypasses the
 * frequency prescaler of the SD Clock. Multiple bits must not be set, or the
 * behavior of this prescaler is undefined. The two default divider values can be
 * calculated by the frequency of ipg_perclk and the following Divisor bits. The
 * frequency of SDCLK is set by the following formula: Clock Frequency = (Base
 * Clock) / (prescaler x divisor) For example, in Single Data Rate mode, if the Base
 * Clock Frequency is 96 MHz, and the target frequency is 25 MHz, then choosing
 * the prescaler value of 01h and divisor value of 1h will yield 24 MHz, which is
 * the nearest frequency less than or equal to the target. Similarly, to
 * approach a clock value of 400 kHz, the prescaler value of 08h and divisor value of eh
 * yields the exact clock value of 400 kHz. The reset value of this bit field is
 * 80h, so if the input Base Clock (ipg_perclk) is about 96 MHz, the default SD
 * Clock after reset is 375 kHz. According to the SD Physical Specification
 * Version 1.1 and the SDIO Card Specification Version 1.2, the maximum SD Clock
 * frequency is 50 MHz and shall never exceed this limit. B efore changing clock
 * divisor value(SDCLKFS or DVS), Host Driver should make sure the SDSTB bit is high.
 * If setting SDCLKFS and DVS can generate same clock frequency,(For example, in
 * SDR mode, SDCLKFS = 01h is same as DVS = 01h.) SDCLKFS is highly recommended.
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_SDCLKFS (8U)     /*!< Bit position for uSDHC_SYS_CTRL_SDCLKFS. */
#define BM_uSDHC_SYS_CTRL_SDCLKFS (0x0000FF00U) /*!< Bit mask for uSDHC_SYS_CTRL_SDCLKFS. */
#define BS_uSDHC_SYS_CTRL_SDCLKFS (8U)     /*!< Bit field size in bits for uSDHC_SYS_CTRL_SDCLKFS. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_SDCLKFS field. */
#define BR_uSDHC_SYS_CTRL_SDCLKFS(x) (HW_uSDHC_SYS_CTRL(x).B.SDCLKFS)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_SDCLKFS. */
#define BF_uSDHC_SYS_CTRL_SDCLKFS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_SDCLKFS) & BM_uSDHC_SYS_CTRL_SDCLKFS)

/*! @brief Set the SDCLKFS field to a new value. */
#define BW_uSDHC_SYS_CTRL_SDCLKFS(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_SDCLKFS) | BF_uSDHC_SYS_CTRL_SDCLKFS(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field DTOCV[19:16] (RW)
 *
 * This value determines the interval by which DAT line timeouts are detected.
 * Refer to the Data Timeout Error bit in the Interrupt Status register for
 * information on factors that dictate time-out generation. Time-out clock frequency
 * will be generated by dividing the base clock SDCLK value by this value. The Host
 * Driver can clear the Data Timeout Error Status Enable (in the Interrupt
 * Status Enable register) to prevent inadvertent time-out events.
 *
 * Values:
 * - 1111 - SDCLK x 2 28
 * - 1110 - SDCLK x 2 2 7
 * - 0001 - SDCLK x 2 14
 * - 0000 - SDCLK x 2 1 3
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_DTOCV (16U)      /*!< Bit position for uSDHC_SYS_CTRL_DTOCV. */
#define BM_uSDHC_SYS_CTRL_DTOCV (0x000F0000U) /*!< Bit mask for uSDHC_SYS_CTRL_DTOCV. */
#define BS_uSDHC_SYS_CTRL_DTOCV (4U)       /*!< Bit field size in bits for uSDHC_SYS_CTRL_DTOCV. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_DTOCV field. */
#define BR_uSDHC_SYS_CTRL_DTOCV(x) (HW_uSDHC_SYS_CTRL(x).B.DTOCV)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_DTOCV. */
#define BF_uSDHC_SYS_CTRL_DTOCV(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_DTOCV) & BM_uSDHC_SYS_CTRL_DTOCV)

/*! @brief Set the DTOCV field to a new value. */
#define BW_uSDHC_SYS_CTRL_DTOCV(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_DTOCV) | BF_uSDHC_SYS_CTRL_DTOCV(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field IPP_RST_N[23] (RW)
 *
 * This register's value will be output to CARD from pad directly for hardware
 * reset of the card if the card supports this feature.
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_IPP_RST_N (23U)  /*!< Bit position for uSDHC_SYS_CTRL_IPP_RST_N. */
#define BM_uSDHC_SYS_CTRL_IPP_RST_N (0x00800000U) /*!< Bit mask for uSDHC_SYS_CTRL_IPP_RST_N. */
#define BS_uSDHC_SYS_CTRL_IPP_RST_N (1U)   /*!< Bit field size in bits for uSDHC_SYS_CTRL_IPP_RST_N. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_IPP_RST_N field. */
#define BR_uSDHC_SYS_CTRL_IPP_RST_N(x) (HW_uSDHC_SYS_CTRL(x).B.IPP_RST_N)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_IPP_RST_N. */
#define BF_uSDHC_SYS_CTRL_IPP_RST_N(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_IPP_RST_N) & BM_uSDHC_SYS_CTRL_IPP_RST_N)

/*! @brief Set the IPP_RST_N field to a new value. */
#define BW_uSDHC_SYS_CTRL_IPP_RST_N(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_IPP_RST_N) | BF_uSDHC_SYS_CTRL_IPP_RST_N(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field RSTA[24] (RW)
 *
 * This reset effects the entire Host Controller except for the card detection
 * circuit. Register bits of type ROC, RW, RW1C, RWAC are cleared. During its
 * initialization, the Host Driver shall set this bit to 1 to reset the uSDHC. The
 * uSDHC shall reset this bit to 0 when the capabilities registers are valid and
 * the Host Driver can read them. Additional use of Software Reset For All does not
 * affect the value of the Capabilities registers. After this bit is set, it is
 * recommended that the Host Driver reset the external card and re-initialize it.
 * After this bit is set, SW should wait for self-clear. When reset, SW must
 * make sure there is no incomplete data transferring. If there is data transfer
 * going on, SW need wait TC or DC uSDHC_INT_STATUS register is set.
 *
 * Values:
 * - 1 - Reset
 * - 0 - No Reset
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_RSTA (24U)       /*!< Bit position for uSDHC_SYS_CTRL_RSTA. */
#define BM_uSDHC_SYS_CTRL_RSTA (0x01000000U) /*!< Bit mask for uSDHC_SYS_CTRL_RSTA. */
#define BS_uSDHC_SYS_CTRL_RSTA (1U)        /*!< Bit field size in bits for uSDHC_SYS_CTRL_RSTA. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_RSTA field. */
#define BR_uSDHC_SYS_CTRL_RSTA(x) (HW_uSDHC_SYS_CTRL(x).B.RSTA)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_RSTA. */
#define BF_uSDHC_SYS_CTRL_RSTA(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_RSTA) & BM_uSDHC_SYS_CTRL_RSTA)

/*! @brief Set the RSTA field to a new value. */
#define BW_uSDHC_SYS_CTRL_RSTA(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_RSTA) | BF_uSDHC_SYS_CTRL_RSTA(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field RSTC[25] (RW)
 *
 * Only part of the command circuit is reset. After this bit is set, SW waits
 * for self-clear. The following registers and bits are cleared by this bit:
 * Present State register Command Inhibit (CMD) Interrupt Status register Command
 * Complete
 *
 * Values:
 * - 1 - Reset
 * - 0 - No Reset
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_RSTC (25U)       /*!< Bit position for uSDHC_SYS_CTRL_RSTC. */
#define BM_uSDHC_SYS_CTRL_RSTC (0x02000000U) /*!< Bit mask for uSDHC_SYS_CTRL_RSTC. */
#define BS_uSDHC_SYS_CTRL_RSTC (1U)        /*!< Bit field size in bits for uSDHC_SYS_CTRL_RSTC. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_RSTC field. */
#define BR_uSDHC_SYS_CTRL_RSTC(x) (HW_uSDHC_SYS_CTRL(x).B.RSTC)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_RSTC. */
#define BF_uSDHC_SYS_CTRL_RSTC(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_RSTC) & BM_uSDHC_SYS_CTRL_RSTC)

/*! @brief Set the RSTC field to a new value. */
#define BW_uSDHC_SYS_CTRL_RSTC(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_RSTC) | BF_uSDHC_SYS_CTRL_RSTC(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field RSTD[26] (RW)
 *
 * Only part of the data circuit is reset. DMA circuit is also reset. After this
 * bit is set, SW waits for self-clear. The following registers and bits are
 * cleared by this bit: Data Port register Buffer is cleared and initialized.
 * Present State register Buffer Read Enable Buffer Write Enable Read Transfer Active
 * Write Transfer Active DATA Line Active Command Inhibit (DATA) Protocol Control
 * register Continue Request Stop At Block Gap Request Interrupt Status register
 * Buffer Read Ready Buffer Write Ready DMA Interrupt Block Gap Event Transfer
 * Complete When reset, SW must make sure there is no incomplete data transferring.
 * If there is data transfer going on, SW need wait TC or DC uSDHC_INT_STATUS
 * register is set.
 *
 * Values:
 * - 1 - Reset
 * - 0 - No Reset
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_RSTD (26U)       /*!< Bit position for uSDHC_SYS_CTRL_RSTD. */
#define BM_uSDHC_SYS_CTRL_RSTD (0x04000000U) /*!< Bit mask for uSDHC_SYS_CTRL_RSTD. */
#define BS_uSDHC_SYS_CTRL_RSTD (1U)        /*!< Bit field size in bits for uSDHC_SYS_CTRL_RSTD. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_RSTD field. */
#define BR_uSDHC_SYS_CTRL_RSTD(x) (HW_uSDHC_SYS_CTRL(x).B.RSTD)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_RSTD. */
#define BF_uSDHC_SYS_CTRL_RSTD(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_RSTD) & BM_uSDHC_SYS_CTRL_RSTD)

/*! @brief Set the RSTD field to a new value. */
#define BW_uSDHC_SYS_CTRL_RSTD(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_RSTD) | BF_uSDHC_SYS_CTRL_RSTD(v)))
/*@}*/

/*!
 * @name Register uSDHC_SYS_CTRL, field INITA[27] (RW)
 *
 * When this bit is set, 80 SD-Clocks are sent to the card. After the 80 clocks
 * are sent, this bit is self cleared. This bit is very useful during the card
 * power-up period when 74 SD-Clocks are needed and the clock auto gating feature
 * is enabled. Writing 1 to this bit when this bit is already 1 has no effect.
 * Writing 0 to this bit at any time has no effect. When either of the CIHB and
 * CDIHB bits in the Present State Register are set, writing 1 to this bit is ignored
 * (i.e. when command line or data lines are active, write to this bit is not
 * allowed). On the otherhand, when this bit is set, i.e., during intialization
 * active period, it is allowed to issue command, and the command bit stream will
 * appear on the CMD pad after all 80 clock cycles are done. So when this command
 * ends, the driver can make sure the 80 clock cycles are sent out. This is very
 * useful when the driver needs send 80 cycles to the card and does not want to
 * wait till this bit is self cleared.
 */
/*@{*/
#define BP_uSDHC_SYS_CTRL_INITA (27U)      /*!< Bit position for uSDHC_SYS_CTRL_INITA. */
#define BM_uSDHC_SYS_CTRL_INITA (0x08000000U) /*!< Bit mask for uSDHC_SYS_CTRL_INITA. */
#define BS_uSDHC_SYS_CTRL_INITA (1U)       /*!< Bit field size in bits for uSDHC_SYS_CTRL_INITA. */

/*! @brief Read current value of the uSDHC_SYS_CTRL_INITA field. */
#define BR_uSDHC_SYS_CTRL_INITA(x) (HW_uSDHC_SYS_CTRL(x).B.INITA)

/*! @brief Format value for bitfield uSDHC_SYS_CTRL_INITA. */
#define BF_uSDHC_SYS_CTRL_INITA(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_SYS_CTRL_INITA) & BM_uSDHC_SYS_CTRL_INITA)

/*! @brief Set the INITA field to a new value. */
#define BW_uSDHC_SYS_CTRL_INITA(x, v) (HW_uSDHC_SYS_CTRL_WR(x, (HW_uSDHC_SYS_CTRL_RD(x) & ~BM_uSDHC_SYS_CTRL_INITA) | BF_uSDHC_SYS_CTRL_INITA(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_INT_STATUS - Interrupt Status
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_INT_STATUS - Interrupt Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * An interrupt is generated when the Normal Interrupt Signal Enable is enabled
 * and at least one of the status bits is set to 1. For all bits, writing 1 to a
 * bit clears it; writing to 0 keeps the bit unchanged. More than one status can
 * be cleared with a single register write. For Card Interrupt, before writing 1
 * to clear, it is required that the card stops asserting the interrupt, meaning
 * that when the Card Driver services the interrupt condition, otherwise the CINT
 * bit will be asserted again. The table below shows the relationship between
 * the Command Timeout Error and the Command Complete. uSDHC Status for Command
 * Timeout Error/Command Complete Bit Combinations Command Complete Command Timeout
 * Error Meaning of the Status 0 0 X X 1 Response not received within 64 SDCLK
 * cycles 1 0 Response received The table below shows the relationship between the
 * Transfer Complete and the Data Timeout Error. uSDHC Status for Data Timeout
 * Error/Transfer Complete Bit Combinations Transfer Complete Data Timeout Error
 * Meaning of the Status 0 0 X 0 1 Timeout occurred during transfer 1 X Data
 * Transfer Complete The table below shows the relationship between the Command CRC
 * Error and Command Timeout Error. uSDHC Status for Command CRC Error/Command
 * Timeout Error Bit Combinations Command Complete Command Timeout Error Meaning of
 * the Status 0 0 No error 0 1 Response Timeout Error 1 0 Response CRC Error 1 1
 * CMD line conflict
 */
typedef union _hw_usdhc_int_status
{
    uint32_t U;
    struct _hw_usdhc_int_status_bitfields
    {
        uint32_t CC : 1;               /*!< [0] Command Complete */
        uint32_t TC : 1;               /*!< [1] Transfer Complete */
        uint32_t BGE : 1;              /*!< [2] Block Gap Event */
        uint32_t DINT : 1;             /*!< [3] DMA Interrupt */
        uint32_t BWR : 1;              /*!< [4] Buffer Write Ready */
        uint32_t BRR : 1;              /*!< [5] Buffer Read Ready */
        uint32_t CINS : 1;             /*!< [6] Card Insertion */
        uint32_t CRM : 1;              /*!< [7] Card Removal */
        uint32_t CINT : 1;             /*!< [8] Card Interrupt */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t RTE : 1;              /*!< [12] Re-Tuning Event: (only for SD3.0 SDR104
                                        * mode) */
        uint32_t RESERVED1 : 1;        /*!< [13]  */
        uint32_t TP : 1;               /*!< [14] Tuning Pass:(only for SD3.0 SDR104 mode) */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t CTOE : 1;             /*!< [16] Command Timeout Error */
        uint32_t CCE : 1;              /*!< [17] Command CRC Error */
        uint32_t CEBE : 1;             /*!< [18] Command End Bit Error */
        uint32_t CIE : 1;              /*!< [19] Command Index Error */
        uint32_t DTOE : 1;             /*!< [20] Data Timeout Error */
        uint32_t DCE : 1;              /*!< [21] Data CRC Error */
        uint32_t DEBE : 1;             /*!< [22] Data End Bit Error */
        uint32_t RESERVED3 : 1;        /*!< [23]  */
        uint32_t AC12E : 1;            /*!< [24] Auto CMD12 Error */
        uint32_t RESERVED4 : 1;        /*!< [25]  */
        uint32_t TNE : 1;              /*!< [26] Tuning Error: (only for SD3.0 SDR104
                                        * mode) */
        uint32_t RESERVED5 : 1;        /*!< [27]  */
        uint32_t DMAE : 1;             /*!< [28] DMA Error */
        uint32_t RESERVED6 : 3;        /*!< [31:29]  */
    } B;
} hw_usdhc_int_status_t;

/*!
 * @name Constants and macros for entire uSDHC_INT_STATUS register
 */
/*@{*/
#define HW_uSDHC_INT_STATUS_ADDR(x) ((uintptr_t)(x) + 0x30U)

#define HW_uSDHC_INT_STATUS(x)   (*(__IO hw_usdhc_int_status_t *) HW_uSDHC_INT_STATUS_ADDR(x))
#define HW_uSDHC_INT_STATUS_RD(x) (HW_uSDHC_INT_STATUS(x).U)
#define HW_uSDHC_INT_STATUS_WR(x, v) (HW_uSDHC_INT_STATUS(x).U = (v))
#define HW_uSDHC_INT_STATUS_SET(x, v) (HW_uSDHC_INT_STATUS_WR(x, HW_uSDHC_INT_STATUS_RD(x) |  (v)))
#define HW_uSDHC_INT_STATUS_CLR(x, v) (HW_uSDHC_INT_STATUS_WR(x, HW_uSDHC_INT_STATUS_RD(x) & ~(v)))
#define HW_uSDHC_INT_STATUS_TOG(x, v) (HW_uSDHC_INT_STATUS_WR(x, HW_uSDHC_INT_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_INT_STATUS bitfields
 */

/*!
 * @name Register uSDHC_INT_STATUS, field CC[0] (W1C)
 *
 * This bit is set when you receive the end bit of the command response (except
 * Auto CMD12). Refer to the Command Inhibit (CMD) in the Present State register.
 *
 * Values:
 * - 1 - Command complete
 * - 0 - Command not complete
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CC (0U)        /*!< Bit position for uSDHC_INT_STATUS_CC. */
#define BM_uSDHC_INT_STATUS_CC (0x00000001U) /*!< Bit mask for uSDHC_INT_STATUS_CC. */
#define BS_uSDHC_INT_STATUS_CC (1U)        /*!< Bit field size in bits for uSDHC_INT_STATUS_CC. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CC field. */
#define BR_uSDHC_INT_STATUS_CC(x) (HW_uSDHC_INT_STATUS(x).B.CC)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CC. */
#define BF_uSDHC_INT_STATUS_CC(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CC) & BM_uSDHC_INT_STATUS_CC)

/*! @brief Set the CC field to a new value. */
#define BW_uSDHC_INT_STATUS_CC(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CC(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field TC[1] (W1C)
 *
 * This bit is set when a read or write transfer is completed. In the case of a
 * Read Transaction: This bit is set at the falling edge of the Read Transfer
 * Active Status. There are two cases in which this interrupt is generated. The
 * first is when a data transfer is completed as specified by the data length (after
 * the last data has been read to the Host System). The second is when data has
 * stopped at the block gap and completed the data transfer by setting the Stop At
 * Block Gap Request bit in the Protocol Control register (after valid data has
 * been read to the Host System). In the case of a Write Transaction: This bit is
 * set at the falling edge of the DATA Line Active Status. There are two cases
 * in which this interrupt is generated. The first is when the last data is
 * written to the SD card as specified by the data length and the busy signal is
 * released. The second is when data transfers are stopped at the block gap, by setting
 * the Stop At Block Gap Request bit in the Protocol Control register, and the
 * data transfers are completed. (after valid data is written to the SD card and
 * the busy signal released). In the case of a command with busy, this bit is set
 * when busy is deasserted.
 *
 * Values:
 * - 1 - Transfer complete
 * - 0 - Transfer not complete
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_TC (1U)        /*!< Bit position for uSDHC_INT_STATUS_TC. */
#define BM_uSDHC_INT_STATUS_TC (0x00000002U) /*!< Bit mask for uSDHC_INT_STATUS_TC. */
#define BS_uSDHC_INT_STATUS_TC (1U)        /*!< Bit field size in bits for uSDHC_INT_STATUS_TC. */

/*! @brief Read current value of the uSDHC_INT_STATUS_TC field. */
#define BR_uSDHC_INT_STATUS_TC(x) (HW_uSDHC_INT_STATUS(x).B.TC)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_TC. */
#define BF_uSDHC_INT_STATUS_TC(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_TC) & BM_uSDHC_INT_STATUS_TC)

/*! @brief Set the TC field to a new value. */
#define BW_uSDHC_INT_STATUS_TC(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_TC(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field BGE[2] (W1C)
 *
 * If the Stop At Block Gap Request bit in the Protocol Control register is set,
 * this bit is set when a read or write transaction is stopped at a block gap.
 * If Stop At Block Gap Request is not set to 1, this bit is not set to 1. In the
 * case of a Read Transaction: This bit is set at the falling edge of the DATA
 * Line Active Status (When the transaction is stopped at SD Bus timing). The Read
 * Wait must be supported in order to use this function. In the case of Write
 * Transaction: This bit is set at the falling edge of Write Transfer Active Status
 * (After getting CRC status at SD Bus timing).
 *
 * Values:
 * - 1 - Transaction stopped at block gap
 * - 0 - No block gap event
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_BGE (2U)       /*!< Bit position for uSDHC_INT_STATUS_BGE. */
#define BM_uSDHC_INT_STATUS_BGE (0x00000004U) /*!< Bit mask for uSDHC_INT_STATUS_BGE. */
#define BS_uSDHC_INT_STATUS_BGE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_BGE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_BGE field. */
#define BR_uSDHC_INT_STATUS_BGE(x) (HW_uSDHC_INT_STATUS(x).B.BGE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_BGE. */
#define BF_uSDHC_INT_STATUS_BGE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_BGE) & BM_uSDHC_INT_STATUS_BGE)

/*! @brief Set the BGE field to a new value. */
#define BW_uSDHC_INT_STATUS_BGE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_BGE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field DINT[3] (W1C)
 *
 * Occurs only when the internal DMA finishes the data transfer successfully.
 * Whenever errors occur during data transfer, this bit will not be set. Instead,
 * the DMAE bit will be set. Either Simple DMA or ADMA finishes data transferring,
 * this bit will be set.
 *
 * Values:
 * - 1 - DMA Interrupt is generated
 * - 0 - No DMA Interrupt
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_DINT (3U)      /*!< Bit position for uSDHC_INT_STATUS_DINT. */
#define BM_uSDHC_INT_STATUS_DINT (0x00000008U) /*!< Bit mask for uSDHC_INT_STATUS_DINT. */
#define BS_uSDHC_INT_STATUS_DINT (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_DINT. */

/*! @brief Read current value of the uSDHC_INT_STATUS_DINT field. */
#define BR_uSDHC_INT_STATUS_DINT(x) (HW_uSDHC_INT_STATUS(x).B.DINT)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_DINT. */
#define BF_uSDHC_INT_STATUS_DINT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_DINT) & BM_uSDHC_INT_STATUS_DINT)

/*! @brief Set the DINT field to a new value. */
#define BW_uSDHC_INT_STATUS_DINT(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_DINT(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field BWR[4] (W1C)
 *
 * This status bit is set if the Buffer Write Enable bit, in the Present State
 * register, changes from 0 to 1. Refer to the Buffer Write Enable bit in the
 * Present State register for additional information.
 *
 * Values:
 * - 1 - Ready to write buffer:
 * - 0 - Not ready to write buffer
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_BWR (4U)       /*!< Bit position for uSDHC_INT_STATUS_BWR. */
#define BM_uSDHC_INT_STATUS_BWR (0x00000010U) /*!< Bit mask for uSDHC_INT_STATUS_BWR. */
#define BS_uSDHC_INT_STATUS_BWR (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_BWR. */

/*! @brief Read current value of the uSDHC_INT_STATUS_BWR field. */
#define BR_uSDHC_INT_STATUS_BWR(x) (HW_uSDHC_INT_STATUS(x).B.BWR)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_BWR. */
#define BF_uSDHC_INT_STATUS_BWR(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_BWR) & BM_uSDHC_INT_STATUS_BWR)

/*! @brief Set the BWR field to a new value. */
#define BW_uSDHC_INT_STATUS_BWR(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_BWR(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field BRR[5] (W1C)
 *
 * This status bit is set if the Buffer Read Enable bit, in the Present State
 * register, changes from 0 to 1. Refer to the Buffer Read Enable bit in the
 * Present State register for additional information.
 *
 * Values:
 * - 1 - Ready to read buffer
 * - 0 - Not ready to read buffer
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_BRR (5U)       /*!< Bit position for uSDHC_INT_STATUS_BRR. */
#define BM_uSDHC_INT_STATUS_BRR (0x00000020U) /*!< Bit mask for uSDHC_INT_STATUS_BRR. */
#define BS_uSDHC_INT_STATUS_BRR (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_BRR. */

/*! @brief Read current value of the uSDHC_INT_STATUS_BRR field. */
#define BR_uSDHC_INT_STATUS_BRR(x) (HW_uSDHC_INT_STATUS(x).B.BRR)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_BRR. */
#define BF_uSDHC_INT_STATUS_BRR(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_BRR) & BM_uSDHC_INT_STATUS_BRR)

/*! @brief Set the BRR field to a new value. */
#define BW_uSDHC_INT_STATUS_BRR(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_BRR(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CINS[6] (W1C)
 *
 * This status bit is set if the Card Inserted bit in the Present State register
 * changes from 0 to 1. When the Host Driver writes this bit to 1 to clear this
 * status, the status of the Card Inserted in the Present State register should
 * be confirmed. Because the card state may possibly be changed when the Host
 * Driver clears this bit and the interrupt event may not be generated. When this bit
 * is cleared, it will be set again if a card is inserted. In order to leave it
 * cleared, clear the Card Inserted Status Enable bit in Interrupt Status Enable
 * register.
 *
 * Values:
 * - 1 - Card inserted
 * - 0 - Card state unstable or removed
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CINS (6U)      /*!< Bit position for uSDHC_INT_STATUS_CINS. */
#define BM_uSDHC_INT_STATUS_CINS (0x00000040U) /*!< Bit mask for uSDHC_INT_STATUS_CINS. */
#define BS_uSDHC_INT_STATUS_CINS (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_CINS. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CINS field. */
#define BR_uSDHC_INT_STATUS_CINS(x) (HW_uSDHC_INT_STATUS(x).B.CINS)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CINS. */
#define BF_uSDHC_INT_STATUS_CINS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CINS) & BM_uSDHC_INT_STATUS_CINS)

/*! @brief Set the CINS field to a new value. */
#define BW_uSDHC_INT_STATUS_CINS(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CINS(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CRM[7] (W1C)
 *
 * This status bit is set if the Card Inserted bit in the Present State register
 * changes from 1 to 0. When the Host Driver writes this bit to 1 to clear this
 * status, the status of the Card Inserted in the Present State register should
 * be confirmed. Because the card state may possibly be changed when the Host
 * Driver clears this bit and the interrupt event may not be generated. When this bit
 * is cleared, it will be set again if no card is inserted. In order to leave it
 * cleared, clear the Card Removal Status Enable bit in Interrupt Status Enable
 * register.
 *
 * Values:
 * - 1 - Card removed
 * - 0 - Card state unstable or inserted
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CRM (7U)       /*!< Bit position for uSDHC_INT_STATUS_CRM. */
#define BM_uSDHC_INT_STATUS_CRM (0x00000080U) /*!< Bit mask for uSDHC_INT_STATUS_CRM. */
#define BS_uSDHC_INT_STATUS_CRM (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_CRM. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CRM field. */
#define BR_uSDHC_INT_STATUS_CRM(x) (HW_uSDHC_INT_STATUS(x).B.CRM)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CRM. */
#define BF_uSDHC_INT_STATUS_CRM(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CRM) & BM_uSDHC_INT_STATUS_CRM)

/*! @brief Set the CRM field to a new value. */
#define BW_uSDHC_INT_STATUS_CRM(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CRM(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CINT[8] (W1C)
 *
 * This status bit is set when an interrupt signal is detected from the external
 * card. In 1-bit mode, the uSDHC will detect the Card Interrupt without the SD
 * Clock to support wakeup. In 4-bit mode, the card interrupt signal is sampled
 * during the interrupt cycle, so the interrupt from card can only be sampled
 * during interrupt cycle, introducing some delay between the interrupt signal from
 * the SDIO card and the interrupt to the Host System. Writing this bit to 1 can
 * clear this bit, but as the interrupt source from the SDIO card does not clear,
 * this bit is set again. In order to clear this bit, it is required to reset the
 * interrupt source from the external card followed by a writing 1 to this bit.
 * When this status has been set, and the Host Driver needs to service this
 * interrupt, the Card Interrupt Signal Enable in the Interrupt Signal Enable register
 * should be 0 to stop driving the interrupt signal to the Host System. After
 * completion of the card interrupt service (It should reset the interrupt sources
 * in the SDIO card and the interrupt signal may not be asserted), write 1 to
 * clear this bit, set the Card Interrupt Signal Enable to 1, and start sampling the
 * interrupt signal again.
 *
 * Values:
 * - 1 - Generate Card Interrupt
 * - 0 - No Card Interrupt
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CINT (8U)      /*!< Bit position for uSDHC_INT_STATUS_CINT. */
#define BM_uSDHC_INT_STATUS_CINT (0x00000100U) /*!< Bit mask for uSDHC_INT_STATUS_CINT. */
#define BS_uSDHC_INT_STATUS_CINT (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_CINT. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CINT field. */
#define BR_uSDHC_INT_STATUS_CINT(x) (HW_uSDHC_INT_STATUS(x).B.CINT)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CINT. */
#define BF_uSDHC_INT_STATUS_CINT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CINT) & BM_uSDHC_INT_STATUS_CINT)

/*! @brief Set the CINT field to a new value. */
#define BW_uSDHC_INT_STATUS_CINT(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CINT(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field RTE[12] (W1C)
 *
 * This status is set if Re-Tuning Request in the Present State register changes
 * from 0 to 1. Host Controller requests Host Driver to perform re-tuning for
 * next data transfer. Current data transfer (not large block count) can be
 * completed without re-tuning.
 *
 * Values:
 * - 1 - Re-Tuning should be performed
 * - 0 - Re-Tuning is not required
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_RTE (12U)      /*!< Bit position for uSDHC_INT_STATUS_RTE. */
#define BM_uSDHC_INT_STATUS_RTE (0x00001000U) /*!< Bit mask for uSDHC_INT_STATUS_RTE. */
#define BS_uSDHC_INT_STATUS_RTE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_RTE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_RTE field. */
#define BR_uSDHC_INT_STATUS_RTE(x) (HW_uSDHC_INT_STATUS(x).B.RTE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_RTE. */
#define BF_uSDHC_INT_STATUS_RTE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_RTE) & BM_uSDHC_INT_STATUS_RTE)

/*! @brief Set the RTE field to a new value. */
#define BW_uSDHC_INT_STATUS_RTE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_RTE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field TP[14] (W1C)
 *
 * Current CMD19 transfer is done successfully. That is, current sampling point
 * is correct.
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_TP (14U)       /*!< Bit position for uSDHC_INT_STATUS_TP. */
#define BM_uSDHC_INT_STATUS_TP (0x00004000U) /*!< Bit mask for uSDHC_INT_STATUS_TP. */
#define BS_uSDHC_INT_STATUS_TP (1U)        /*!< Bit field size in bits for uSDHC_INT_STATUS_TP. */

/*! @brief Read current value of the uSDHC_INT_STATUS_TP field. */
#define BR_uSDHC_INT_STATUS_TP(x) (HW_uSDHC_INT_STATUS(x).B.TP)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_TP. */
#define BF_uSDHC_INT_STATUS_TP(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_TP) & BM_uSDHC_INT_STATUS_TP)

/*! @brief Set the TP field to a new value. */
#define BW_uSDHC_INT_STATUS_TP(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_TP(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CTOE[16] (W1C)
 *
 * Occurs only if no response is returned within 64 SDCLK cycles from the end
 * bit of the command. If the uSDHC detects a CMD line conflict, in which case a
 * Command CRC Error shall also be set (as shown in INT_STATUSInterrupt Status ),
 * this bit shall be set without waiting for 64 SDCLK cycles. This is because the
 * command will be aborted by the uSDHC.
 *
 * Values:
 * - 1 - Time out
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CTOE (16U)     /*!< Bit position for uSDHC_INT_STATUS_CTOE. */
#define BM_uSDHC_INT_STATUS_CTOE (0x00010000U) /*!< Bit mask for uSDHC_INT_STATUS_CTOE. */
#define BS_uSDHC_INT_STATUS_CTOE (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_CTOE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CTOE field. */
#define BR_uSDHC_INT_STATUS_CTOE(x) (HW_uSDHC_INT_STATUS(x).B.CTOE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CTOE. */
#define BF_uSDHC_INT_STATUS_CTOE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CTOE) & BM_uSDHC_INT_STATUS_CTOE)

/*! @brief Set the CTOE field to a new value. */
#define BW_uSDHC_INT_STATUS_CTOE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CTOE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CCE[17] (W1C)
 *
 * Command CRC Error is generated in two cases. If a response is returned and
 * the Command Timeout Error is set to 0 (indicating no time-out), this bit is set
 * when detecting a CRC error in the command response. The uSDHC detects a CMD
 * line conflict by monitoring the CMD line when a command is issued. If the uSDHC
 * drives the CMD line to 1, but detects 0 on the CMD line at the next SDCLK
 * edge, then the uSDHC shall abort the command (Stop driving CMD line) and set this
 * bit to 1. The Command Timeout Error shall also be set to 1 to distinguish CMD
 * line conflict.
 *
 * Values:
 * - 1 - CRC Error Generated.
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CCE (17U)      /*!< Bit position for uSDHC_INT_STATUS_CCE. */
#define BM_uSDHC_INT_STATUS_CCE (0x00020000U) /*!< Bit mask for uSDHC_INT_STATUS_CCE. */
#define BS_uSDHC_INT_STATUS_CCE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_CCE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CCE field. */
#define BR_uSDHC_INT_STATUS_CCE(x) (HW_uSDHC_INT_STATUS(x).B.CCE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CCE. */
#define BF_uSDHC_INT_STATUS_CCE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CCE) & BM_uSDHC_INT_STATUS_CCE)

/*! @brief Set the CCE field to a new value. */
#define BW_uSDHC_INT_STATUS_CCE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CCE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CEBE[18] (W1C)
 *
 * Occurs when detecting that the end bit of a command response is 0.
 *
 * Values:
 * - 1 - End Bit Error Generated
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CEBE (18U)     /*!< Bit position for uSDHC_INT_STATUS_CEBE. */
#define BM_uSDHC_INT_STATUS_CEBE (0x00040000U) /*!< Bit mask for uSDHC_INT_STATUS_CEBE. */
#define BS_uSDHC_INT_STATUS_CEBE (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_CEBE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CEBE field. */
#define BR_uSDHC_INT_STATUS_CEBE(x) (HW_uSDHC_INT_STATUS(x).B.CEBE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CEBE. */
#define BF_uSDHC_INT_STATUS_CEBE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CEBE) & BM_uSDHC_INT_STATUS_CEBE)

/*! @brief Set the CEBE field to a new value. */
#define BW_uSDHC_INT_STATUS_CEBE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CEBE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field CIE[19] (W1C)
 *
 * Occurs if a Command Index error occurs in the command response.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_CIE (19U)      /*!< Bit position for uSDHC_INT_STATUS_CIE. */
#define BM_uSDHC_INT_STATUS_CIE (0x00080000U) /*!< Bit mask for uSDHC_INT_STATUS_CIE. */
#define BS_uSDHC_INT_STATUS_CIE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_CIE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_CIE field. */
#define BR_uSDHC_INT_STATUS_CIE(x) (HW_uSDHC_INT_STATUS(x).B.CIE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_CIE. */
#define BF_uSDHC_INT_STATUS_CIE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_CIE) & BM_uSDHC_INT_STATUS_CIE)

/*! @brief Set the CIE field to a new value. */
#define BW_uSDHC_INT_STATUS_CIE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_CIE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field DTOE[20] (W1C)
 *
 * Occurs when detecting one of following time-out conditions. Busy time-out for
 * R1b, R5b type Busy time-out after Write CRC status Read Data time-out.
 *
 * Values:
 * - 1 - Time out
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_DTOE (20U)     /*!< Bit position for uSDHC_INT_STATUS_DTOE. */
#define BM_uSDHC_INT_STATUS_DTOE (0x00100000U) /*!< Bit mask for uSDHC_INT_STATUS_DTOE. */
#define BS_uSDHC_INT_STATUS_DTOE (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_DTOE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_DTOE field. */
#define BR_uSDHC_INT_STATUS_DTOE(x) (HW_uSDHC_INT_STATUS(x).B.DTOE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_DTOE. */
#define BF_uSDHC_INT_STATUS_DTOE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_DTOE) & BM_uSDHC_INT_STATUS_DTOE)

/*! @brief Set the DTOE field to a new value. */
#define BW_uSDHC_INT_STATUS_DTOE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_DTOE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field DCE[21] (W1C)
 *
 * Occurs when detecting a CRC error when transferring read data, which uses the
 * DATA line, or when detecting the Write CRC status having a value other than
 * 010.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_DCE (21U)      /*!< Bit position for uSDHC_INT_STATUS_DCE. */
#define BM_uSDHC_INT_STATUS_DCE (0x00200000U) /*!< Bit mask for uSDHC_INT_STATUS_DCE. */
#define BS_uSDHC_INT_STATUS_DCE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_DCE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_DCE field. */
#define BR_uSDHC_INT_STATUS_DCE(x) (HW_uSDHC_INT_STATUS(x).B.DCE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_DCE. */
#define BF_uSDHC_INT_STATUS_DCE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_DCE) & BM_uSDHC_INT_STATUS_DCE)

/*! @brief Set the DCE field to a new value. */
#define BW_uSDHC_INT_STATUS_DCE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_DCE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field DEBE[22] (W1C)
 *
 * Occurs either when detecting 0 at the end bit position of read data, which
 * uses the DATA line, or at the end bit position of the CRC.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_DEBE (22U)     /*!< Bit position for uSDHC_INT_STATUS_DEBE. */
#define BM_uSDHC_INT_STATUS_DEBE (0x00400000U) /*!< Bit mask for uSDHC_INT_STATUS_DEBE. */
#define BS_uSDHC_INT_STATUS_DEBE (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_DEBE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_DEBE field. */
#define BR_uSDHC_INT_STATUS_DEBE(x) (HW_uSDHC_INT_STATUS(x).B.DEBE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_DEBE. */
#define BF_uSDHC_INT_STATUS_DEBE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_DEBE) & BM_uSDHC_INT_STATUS_DEBE)

/*! @brief Set the DEBE field to a new value. */
#define BW_uSDHC_INT_STATUS_DEBE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_DEBE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field AC12E[24] (W1C)
 *
 * Occurs when detecting that one of the bits in the Auto CMD12 Error Status
 * register has changed from 0 to 1. This bit is set to 1, not only when the errors
 * in Auto CMD12 occur, but also when the Auto CMD12 is not executed due to the
 * previous command error.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_AC12E (24U)    /*!< Bit position for uSDHC_INT_STATUS_AC12E. */
#define BM_uSDHC_INT_STATUS_AC12E (0x01000000U) /*!< Bit mask for uSDHC_INT_STATUS_AC12E. */
#define BS_uSDHC_INT_STATUS_AC12E (1U)     /*!< Bit field size in bits for uSDHC_INT_STATUS_AC12E. */

/*! @brief Read current value of the uSDHC_INT_STATUS_AC12E field. */
#define BR_uSDHC_INT_STATUS_AC12E(x) (HW_uSDHC_INT_STATUS(x).B.AC12E)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_AC12E. */
#define BF_uSDHC_INT_STATUS_AC12E(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_AC12E) & BM_uSDHC_INT_STATUS_AC12E)

/*! @brief Set the AC12E field to a new value. */
#define BW_uSDHC_INT_STATUS_AC12E(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_AC12E(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field TNE[26] (W1C)
 *
 * This bit is set when an unrecoverable error is detected in a tuning circuit.
 * By detecting Tuning Error, Host Driver needs to abort a command executing and
 * perform tuning.
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_TNE (26U)      /*!< Bit position for uSDHC_INT_STATUS_TNE. */
#define BM_uSDHC_INT_STATUS_TNE (0x04000000U) /*!< Bit mask for uSDHC_INT_STATUS_TNE. */
#define BS_uSDHC_INT_STATUS_TNE (1U)       /*!< Bit field size in bits for uSDHC_INT_STATUS_TNE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_TNE field. */
#define BR_uSDHC_INT_STATUS_TNE(x) (HW_uSDHC_INT_STATUS(x).B.TNE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_TNE. */
#define BF_uSDHC_INT_STATUS_TNE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_TNE) & BM_uSDHC_INT_STATUS_TNE)

/*! @brief Set the TNE field to a new value. */
#define BW_uSDHC_INT_STATUS_TNE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_TNE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_DMAE)) | BF_uSDHC_INT_STATUS_TNE(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS, field DMAE[28] (W1C)
 *
 * Occurs when an Internal DMA transfer has failed. This bit is set to 1, when
 * some error occurs in the data transfer. This error can be caused by either
 * Simple DMA or ADMA, depending on which DMA is in use. The value in DMA System
 * Address register is the next fetch address where the error occurs. Since any error
 * corrupts the whole data block, the Host Driver shall re-start the transfer
 * from the corrupted block boundary. The address of the block boundary can be
 * calculated either from the current DS_ADDR value or from the remaining number of
 * blocks and the block size.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_DMAE (28U)     /*!< Bit position for uSDHC_INT_STATUS_DMAE. */
#define BM_uSDHC_INT_STATUS_DMAE (0x10000000U) /*!< Bit mask for uSDHC_INT_STATUS_DMAE. */
#define BS_uSDHC_INT_STATUS_DMAE (1U)      /*!< Bit field size in bits for uSDHC_INT_STATUS_DMAE. */

/*! @brief Read current value of the uSDHC_INT_STATUS_DMAE field. */
#define BR_uSDHC_INT_STATUS_DMAE(x) (HW_uSDHC_INT_STATUS(x).B.DMAE)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_DMAE. */
#define BF_uSDHC_INT_STATUS_DMAE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_DMAE) & BM_uSDHC_INT_STATUS_DMAE)

/*! @brief Set the DMAE field to a new value. */
#define BW_uSDHC_INT_STATUS_DMAE(x, v) (HW_uSDHC_INT_STATUS_WR(x, (HW_uSDHC_INT_STATUS_RD(x) & ~(BM_uSDHC_INT_STATUS_DMAE | BM_uSDHC_INT_STATUS_CC | BM_uSDHC_INT_STATUS_TC | BM_uSDHC_INT_STATUS_BGE | BM_uSDHC_INT_STATUS_DINT | BM_uSDHC_INT_STATUS_BWR | BM_uSDHC_INT_STATUS_BRR | BM_uSDHC_INT_STATUS_CINS | BM_uSDHC_INT_STATUS_CRM | BM_uSDHC_INT_STATUS_CINT | BM_uSDHC_INT_STATUS_RTE | BM_uSDHC_INT_STATUS_TP | BM_uSDHC_INT_STATUS_CTOE | BM_uSDHC_INT_STATUS_CCE | BM_uSDHC_INT_STATUS_CEBE | BM_uSDHC_INT_STATUS_CIE | BM_uSDHC_INT_STATUS_DTOE | BM_uSDHC_INT_STATUS_DCE | BM_uSDHC_INT_STATUS_DEBE | BM_uSDHC_INT_STATUS_AC12E | BM_uSDHC_INT_STATUS_TNE)) | BF_uSDHC_INT_STATUS_DMAE(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_INT_STATUS_EN - Interrupt Status Enable
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_INT_STATUS_EN - Interrupt Status Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * Setting the bits in this register to 1 enables the corresponding Interrupt
 * Status to be set by the specified event. If any bit is cleared, the
 * corresponding Interrupt Status bit is also cleared (i.e. when the bit in this register is
 * cleared, the corresponding bit in Interrupt Status Register is always 0).
 * Depending on IABG bit setting, uSDHC may be programmed to sample the card
 * interrupt signal during the interrupt period and hold its value in the flip-flop.
 * There will be some delays on the Card Interrupt, asserted from the card, to the
 * time the Host System is informed. To detect a CMD line conflict, the Host Driver
 * must set both Command Timeout Error Status Enable and Command CRC Error
 * Status Enable to 1.
 */
typedef union _hw_usdhc_int_status_en
{
    uint32_t U;
    struct _hw_usdhc_int_status_en_bitfields
    {
        uint32_t CCSEN : 1;            /*!< [0] Command Complete Status Enable */
        uint32_t TCSEN : 1;            /*!< [1] Transfer Complete Status Enable */
        uint32_t BGESEN : 1;           /*!< [2] Block Gap Event Status Enable */
        uint32_t DINTSEN : 1;          /*!< [3] DMA Interrupt Status Enable */
        uint32_t BWRSEN : 1;           /*!< [4] Buffer Write Ready Status Enable */
        uint32_t BRRSEN : 1;           /*!< [5] Buffer Read Ready Status Enable */
        uint32_t CINSSEN : 1;          /*!< [6] Card Insertion Status Enable */
        uint32_t CRMSEN : 1;           /*!< [7] Card Removal Status Enable */
        uint32_t CINTSEN : 1;          /*!< [8] Card Interrupt Status Enable */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t RTESEN : 1;           /*!< [12] Re-Tuning Event Status Enable */
        uint32_t RESERVED1 : 1;        /*!< [13]  */
        uint32_t TPSEN : 1;            /*!< [14] Tuning Pass Status Enable */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t CTOESEN : 1;          /*!< [16] Command Timeout Error Status Enable */
        uint32_t CCESEN : 1;           /*!< [17] Command CRC Error Status Enable */
        uint32_t CEBESEN : 1;          /*!< [18] Command End Bit Error Status Enable */
        uint32_t CIESEN : 1;           /*!< [19] Command Index Error Status Enable */
        uint32_t DTOESEN : 1;          /*!< [20] Data Timeout Error Status Enable */
        uint32_t DCESEN : 1;           /*!< [21] Data CRC Error Status Enable */
        uint32_t DEBESEN : 1;          /*!< [22] Data End Bit Error Status Enable */
        uint32_t RESERVED3 : 1;        /*!< [23]  */
        uint32_t AC12ESEN : 1;         /*!< [24] Auto CMD12 Error Status Enable */
        uint32_t RESERVED4 : 1;        /*!< [25]  */
        uint32_t TNESEN : 1;           /*!< [26] Tuning Error Status Enable */
        uint32_t RESERVED5 : 1;        /*!< [27]  */
        uint32_t DMAESEN : 1;          /*!< [28] DMA Error Status Enable */
        uint32_t RESERVED6 : 3;        /*!< [31:29]  */
    } B;
} hw_usdhc_int_status_en_t;

/*!
 * @name Constants and macros for entire uSDHC_INT_STATUS_EN register
 */
/*@{*/
#define HW_uSDHC_INT_STATUS_EN_ADDR(x) ((uintptr_t)(x) + 0x34U)

#define HW_uSDHC_INT_STATUS_EN(x) (*(__IO hw_usdhc_int_status_en_t *) HW_uSDHC_INT_STATUS_EN_ADDR(x))
#define HW_uSDHC_INT_STATUS_EN_RD(x) (HW_uSDHC_INT_STATUS_EN(x).U)
#define HW_uSDHC_INT_STATUS_EN_WR(x, v) (HW_uSDHC_INT_STATUS_EN(x).U = (v))
#define HW_uSDHC_INT_STATUS_EN_SET(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, HW_uSDHC_INT_STATUS_EN_RD(x) |  (v)))
#define HW_uSDHC_INT_STATUS_EN_CLR(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, HW_uSDHC_INT_STATUS_EN_RD(x) & ~(v)))
#define HW_uSDHC_INT_STATUS_EN_TOG(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, HW_uSDHC_INT_STATUS_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_INT_STATUS_EN bitfields
 */

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CCSEN[0] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CCSEN (0U)  /*!< Bit position for uSDHC_INT_STATUS_EN_CCSEN. */
#define BM_uSDHC_INT_STATUS_EN_CCSEN (0x00000001U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CCSEN. */
#define BS_uSDHC_INT_STATUS_EN_CCSEN (1U)  /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CCSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CCSEN field. */
#define BR_uSDHC_INT_STATUS_EN_CCSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CCSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CCSEN. */
#define BF_uSDHC_INT_STATUS_EN_CCSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CCSEN) & BM_uSDHC_INT_STATUS_EN_CCSEN)

/*! @brief Set the CCSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CCSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CCSEN) | BF_uSDHC_INT_STATUS_EN_CCSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field TCSEN[1] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_TCSEN (1U)  /*!< Bit position for uSDHC_INT_STATUS_EN_TCSEN. */
#define BM_uSDHC_INT_STATUS_EN_TCSEN (0x00000002U) /*!< Bit mask for uSDHC_INT_STATUS_EN_TCSEN. */
#define BS_uSDHC_INT_STATUS_EN_TCSEN (1U)  /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_TCSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_TCSEN field. */
#define BR_uSDHC_INT_STATUS_EN_TCSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.TCSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_TCSEN. */
#define BF_uSDHC_INT_STATUS_EN_TCSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_TCSEN) & BM_uSDHC_INT_STATUS_EN_TCSEN)

/*! @brief Set the TCSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_TCSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_TCSEN) | BF_uSDHC_INT_STATUS_EN_TCSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field BGESEN[2] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_BGESEN (2U) /*!< Bit position for uSDHC_INT_STATUS_EN_BGESEN. */
#define BM_uSDHC_INT_STATUS_EN_BGESEN (0x00000004U) /*!< Bit mask for uSDHC_INT_STATUS_EN_BGESEN. */
#define BS_uSDHC_INT_STATUS_EN_BGESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_BGESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_BGESEN field. */
#define BR_uSDHC_INT_STATUS_EN_BGESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.BGESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_BGESEN. */
#define BF_uSDHC_INT_STATUS_EN_BGESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_BGESEN) & BM_uSDHC_INT_STATUS_EN_BGESEN)

/*! @brief Set the BGESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_BGESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_BGESEN) | BF_uSDHC_INT_STATUS_EN_BGESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field DINTSEN[3] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_DINTSEN (3U) /*!< Bit position for uSDHC_INT_STATUS_EN_DINTSEN. */
#define BM_uSDHC_INT_STATUS_EN_DINTSEN (0x00000008U) /*!< Bit mask for uSDHC_INT_STATUS_EN_DINTSEN. */
#define BS_uSDHC_INT_STATUS_EN_DINTSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_DINTSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_DINTSEN field. */
#define BR_uSDHC_INT_STATUS_EN_DINTSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.DINTSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_DINTSEN. */
#define BF_uSDHC_INT_STATUS_EN_DINTSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_DINTSEN) & BM_uSDHC_INT_STATUS_EN_DINTSEN)

/*! @brief Set the DINTSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_DINTSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_DINTSEN) | BF_uSDHC_INT_STATUS_EN_DINTSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field BWRSEN[4] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_BWRSEN (4U) /*!< Bit position for uSDHC_INT_STATUS_EN_BWRSEN. */
#define BM_uSDHC_INT_STATUS_EN_BWRSEN (0x00000010U) /*!< Bit mask for uSDHC_INT_STATUS_EN_BWRSEN. */
#define BS_uSDHC_INT_STATUS_EN_BWRSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_BWRSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_BWRSEN field. */
#define BR_uSDHC_INT_STATUS_EN_BWRSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.BWRSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_BWRSEN. */
#define BF_uSDHC_INT_STATUS_EN_BWRSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_BWRSEN) & BM_uSDHC_INT_STATUS_EN_BWRSEN)

/*! @brief Set the BWRSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_BWRSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_BWRSEN) | BF_uSDHC_INT_STATUS_EN_BWRSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field BRRSEN[5] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_BRRSEN (5U) /*!< Bit position for uSDHC_INT_STATUS_EN_BRRSEN. */
#define BM_uSDHC_INT_STATUS_EN_BRRSEN (0x00000020U) /*!< Bit mask for uSDHC_INT_STATUS_EN_BRRSEN. */
#define BS_uSDHC_INT_STATUS_EN_BRRSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_BRRSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_BRRSEN field. */
#define BR_uSDHC_INT_STATUS_EN_BRRSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.BRRSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_BRRSEN. */
#define BF_uSDHC_INT_STATUS_EN_BRRSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_BRRSEN) & BM_uSDHC_INT_STATUS_EN_BRRSEN)

/*! @brief Set the BRRSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_BRRSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_BRRSEN) | BF_uSDHC_INT_STATUS_EN_BRRSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CINSSEN[6] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CINSSEN (6U) /*!< Bit position for uSDHC_INT_STATUS_EN_CINSSEN. */
#define BM_uSDHC_INT_STATUS_EN_CINSSEN (0x00000040U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CINSSEN. */
#define BS_uSDHC_INT_STATUS_EN_CINSSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CINSSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CINSSEN field. */
#define BR_uSDHC_INT_STATUS_EN_CINSSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CINSSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CINSSEN. */
#define BF_uSDHC_INT_STATUS_EN_CINSSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CINSSEN) & BM_uSDHC_INT_STATUS_EN_CINSSEN)

/*! @brief Set the CINSSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CINSSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CINSSEN) | BF_uSDHC_INT_STATUS_EN_CINSSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CRMSEN[7] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CRMSEN (7U) /*!< Bit position for uSDHC_INT_STATUS_EN_CRMSEN. */
#define BM_uSDHC_INT_STATUS_EN_CRMSEN (0x00000080U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CRMSEN. */
#define BS_uSDHC_INT_STATUS_EN_CRMSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CRMSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CRMSEN field. */
#define BR_uSDHC_INT_STATUS_EN_CRMSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CRMSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CRMSEN. */
#define BF_uSDHC_INT_STATUS_EN_CRMSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CRMSEN) & BM_uSDHC_INT_STATUS_EN_CRMSEN)

/*! @brief Set the CRMSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CRMSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CRMSEN) | BF_uSDHC_INT_STATUS_EN_CRMSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CINTSEN[8] (RW)
 *
 * If this bit is set to 0, the uSDHC will clear the interrupt request to the
 * system. The Card Interrupt detection is stopped when this bit is cleared and
 * restarted when this bit is set to 1. The Host Driver should clear the Card
 * Interrupt Status Enable before servicing the Card Interrupt and should set this bit
 * again after all interrupt requests from the card are cleared to prevent
 * inadvertent interrupts.
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CINTSEN (8U) /*!< Bit position for uSDHC_INT_STATUS_EN_CINTSEN. */
#define BM_uSDHC_INT_STATUS_EN_CINTSEN (0x00000100U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CINTSEN. */
#define BS_uSDHC_INT_STATUS_EN_CINTSEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CINTSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CINTSEN field. */
#define BR_uSDHC_INT_STATUS_EN_CINTSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CINTSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CINTSEN. */
#define BF_uSDHC_INT_STATUS_EN_CINTSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CINTSEN) & BM_uSDHC_INT_STATUS_EN_CINTSEN)

/*! @brief Set the CINTSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CINTSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CINTSEN) | BF_uSDHC_INT_STATUS_EN_CINTSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field RTESEN[12] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_RTESEN (12U) /*!< Bit position for uSDHC_INT_STATUS_EN_RTESEN. */
#define BM_uSDHC_INT_STATUS_EN_RTESEN (0x00001000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_RTESEN. */
#define BS_uSDHC_INT_STATUS_EN_RTESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_RTESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_RTESEN field. */
#define BR_uSDHC_INT_STATUS_EN_RTESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.RTESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_RTESEN. */
#define BF_uSDHC_INT_STATUS_EN_RTESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_RTESEN) & BM_uSDHC_INT_STATUS_EN_RTESEN)

/*! @brief Set the RTESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_RTESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_RTESEN) | BF_uSDHC_INT_STATUS_EN_RTESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field TPSEN[14] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_TPSEN (14U) /*!< Bit position for uSDHC_INT_STATUS_EN_TPSEN. */
#define BM_uSDHC_INT_STATUS_EN_TPSEN (0x00004000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_TPSEN. */
#define BS_uSDHC_INT_STATUS_EN_TPSEN (1U)  /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_TPSEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_TPSEN field. */
#define BR_uSDHC_INT_STATUS_EN_TPSEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.TPSEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_TPSEN. */
#define BF_uSDHC_INT_STATUS_EN_TPSEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_TPSEN) & BM_uSDHC_INT_STATUS_EN_TPSEN)

/*! @brief Set the TPSEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_TPSEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_TPSEN) | BF_uSDHC_INT_STATUS_EN_TPSEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CTOESEN[16] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CTOESEN (16U) /*!< Bit position for uSDHC_INT_STATUS_EN_CTOESEN. */
#define BM_uSDHC_INT_STATUS_EN_CTOESEN (0x00010000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CTOESEN. */
#define BS_uSDHC_INT_STATUS_EN_CTOESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CTOESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CTOESEN field. */
#define BR_uSDHC_INT_STATUS_EN_CTOESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CTOESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CTOESEN. */
#define BF_uSDHC_INT_STATUS_EN_CTOESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CTOESEN) & BM_uSDHC_INT_STATUS_EN_CTOESEN)

/*! @brief Set the CTOESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CTOESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CTOESEN) | BF_uSDHC_INT_STATUS_EN_CTOESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CCESEN[17] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CCESEN (17U) /*!< Bit position for uSDHC_INT_STATUS_EN_CCESEN. */
#define BM_uSDHC_INT_STATUS_EN_CCESEN (0x00020000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CCESEN. */
#define BS_uSDHC_INT_STATUS_EN_CCESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CCESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CCESEN field. */
#define BR_uSDHC_INT_STATUS_EN_CCESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CCESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CCESEN. */
#define BF_uSDHC_INT_STATUS_EN_CCESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CCESEN) & BM_uSDHC_INT_STATUS_EN_CCESEN)

/*! @brief Set the CCESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CCESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CCESEN) | BF_uSDHC_INT_STATUS_EN_CCESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CEBESEN[18] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CEBESEN (18U) /*!< Bit position for uSDHC_INT_STATUS_EN_CEBESEN. */
#define BM_uSDHC_INT_STATUS_EN_CEBESEN (0x00040000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CEBESEN. */
#define BS_uSDHC_INT_STATUS_EN_CEBESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CEBESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CEBESEN field. */
#define BR_uSDHC_INT_STATUS_EN_CEBESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CEBESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CEBESEN. */
#define BF_uSDHC_INT_STATUS_EN_CEBESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CEBESEN) & BM_uSDHC_INT_STATUS_EN_CEBESEN)

/*! @brief Set the CEBESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CEBESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CEBESEN) | BF_uSDHC_INT_STATUS_EN_CEBESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field CIESEN[19] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_CIESEN (19U) /*!< Bit position for uSDHC_INT_STATUS_EN_CIESEN. */
#define BM_uSDHC_INT_STATUS_EN_CIESEN (0x00080000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_CIESEN. */
#define BS_uSDHC_INT_STATUS_EN_CIESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_CIESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_CIESEN field. */
#define BR_uSDHC_INT_STATUS_EN_CIESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.CIESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_CIESEN. */
#define BF_uSDHC_INT_STATUS_EN_CIESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_CIESEN) & BM_uSDHC_INT_STATUS_EN_CIESEN)

/*! @brief Set the CIESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_CIESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_CIESEN) | BF_uSDHC_INT_STATUS_EN_CIESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field DTOESEN[20] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_DTOESEN (20U) /*!< Bit position for uSDHC_INT_STATUS_EN_DTOESEN. */
#define BM_uSDHC_INT_STATUS_EN_DTOESEN (0x00100000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_DTOESEN. */
#define BS_uSDHC_INT_STATUS_EN_DTOESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_DTOESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_DTOESEN field. */
#define BR_uSDHC_INT_STATUS_EN_DTOESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.DTOESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_DTOESEN. */
#define BF_uSDHC_INT_STATUS_EN_DTOESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_DTOESEN) & BM_uSDHC_INT_STATUS_EN_DTOESEN)

/*! @brief Set the DTOESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_DTOESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_DTOESEN) | BF_uSDHC_INT_STATUS_EN_DTOESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field DCESEN[21] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_DCESEN (21U) /*!< Bit position for uSDHC_INT_STATUS_EN_DCESEN. */
#define BM_uSDHC_INT_STATUS_EN_DCESEN (0x00200000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_DCESEN. */
#define BS_uSDHC_INT_STATUS_EN_DCESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_DCESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_DCESEN field. */
#define BR_uSDHC_INT_STATUS_EN_DCESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.DCESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_DCESEN. */
#define BF_uSDHC_INT_STATUS_EN_DCESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_DCESEN) & BM_uSDHC_INT_STATUS_EN_DCESEN)

/*! @brief Set the DCESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_DCESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_DCESEN) | BF_uSDHC_INT_STATUS_EN_DCESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field DEBESEN[22] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_DEBESEN (22U) /*!< Bit position for uSDHC_INT_STATUS_EN_DEBESEN. */
#define BM_uSDHC_INT_STATUS_EN_DEBESEN (0x00400000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_DEBESEN. */
#define BS_uSDHC_INT_STATUS_EN_DEBESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_DEBESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_DEBESEN field. */
#define BR_uSDHC_INT_STATUS_EN_DEBESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.DEBESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_DEBESEN. */
#define BF_uSDHC_INT_STATUS_EN_DEBESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_DEBESEN) & BM_uSDHC_INT_STATUS_EN_DEBESEN)

/*! @brief Set the DEBESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_DEBESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_DEBESEN) | BF_uSDHC_INT_STATUS_EN_DEBESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field AC12ESEN[24] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_AC12ESEN (24U) /*!< Bit position for uSDHC_INT_STATUS_EN_AC12ESEN. */
#define BM_uSDHC_INT_STATUS_EN_AC12ESEN (0x01000000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_AC12ESEN. */
#define BS_uSDHC_INT_STATUS_EN_AC12ESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_AC12ESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_AC12ESEN field. */
#define BR_uSDHC_INT_STATUS_EN_AC12ESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.AC12ESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_AC12ESEN. */
#define BF_uSDHC_INT_STATUS_EN_AC12ESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_AC12ESEN) & BM_uSDHC_INT_STATUS_EN_AC12ESEN)

/*! @brief Set the AC12ESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_AC12ESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_AC12ESEN) | BF_uSDHC_INT_STATUS_EN_AC12ESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field TNESEN[26] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_TNESEN (26U) /*!< Bit position for uSDHC_INT_STATUS_EN_TNESEN. */
#define BM_uSDHC_INT_STATUS_EN_TNESEN (0x04000000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_TNESEN. */
#define BS_uSDHC_INT_STATUS_EN_TNESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_TNESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_TNESEN field. */
#define BR_uSDHC_INT_STATUS_EN_TNESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.TNESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_TNESEN. */
#define BF_uSDHC_INT_STATUS_EN_TNESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_TNESEN) & BM_uSDHC_INT_STATUS_EN_TNESEN)

/*! @brief Set the TNESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_TNESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_TNESEN) | BF_uSDHC_INT_STATUS_EN_TNESEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_STATUS_EN, field DMAESEN[28] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_STATUS_EN_DMAESEN (28U) /*!< Bit position for uSDHC_INT_STATUS_EN_DMAESEN. */
#define BM_uSDHC_INT_STATUS_EN_DMAESEN (0x10000000U) /*!< Bit mask for uSDHC_INT_STATUS_EN_DMAESEN. */
#define BS_uSDHC_INT_STATUS_EN_DMAESEN (1U) /*!< Bit field size in bits for uSDHC_INT_STATUS_EN_DMAESEN. */

/*! @brief Read current value of the uSDHC_INT_STATUS_EN_DMAESEN field. */
#define BR_uSDHC_INT_STATUS_EN_DMAESEN(x) (HW_uSDHC_INT_STATUS_EN(x).B.DMAESEN)

/*! @brief Format value for bitfield uSDHC_INT_STATUS_EN_DMAESEN. */
#define BF_uSDHC_INT_STATUS_EN_DMAESEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_STATUS_EN_DMAESEN) & BM_uSDHC_INT_STATUS_EN_DMAESEN)

/*! @brief Set the DMAESEN field to a new value. */
#define BW_uSDHC_INT_STATUS_EN_DMAESEN(x, v) (HW_uSDHC_INT_STATUS_EN_WR(x, (HW_uSDHC_INT_STATUS_EN_RD(x) & ~BM_uSDHC_INT_STATUS_EN_DMAESEN) | BF_uSDHC_INT_STATUS_EN_DMAESEN(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_INT_SIGNAL_EN - Interrupt Signal Enable
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_INT_SIGNAL_EN - Interrupt Signal Enable (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used to select which interrupt status is indicated to the
 * Host System as the interrupt. These status bits all share the same interrupt
 * line. Setting any of these bits to 1 enables interrupt generation. The
 * corresponding Status register bit will generate an interrupt when the corresponding
 * interrupt signal enable bit is set.
 */
typedef union _hw_usdhc_int_signal_en
{
    uint32_t U;
    struct _hw_usdhc_int_signal_en_bitfields
    {
        uint32_t CCIEN : 1;            /*!< [0] Command Complete Interrupt Enable */
        uint32_t TCIEN : 1;            /*!< [1] Transfer Complete Interrupt Enable */
        uint32_t BGEIEN : 1;           /*!< [2] Block Gap Event Interrupt Enable */
        uint32_t DINTIEN : 1;          /*!< [3] DMA Interrupt Enable */
        uint32_t BWRIEN : 1;           /*!< [4] Buffer Write Ready Interrupt Enable */
        uint32_t BRRIEN : 1;           /*!< [5] Buffer Read Ready Interrupt Enable */
        uint32_t CINSIEN : 1;          /*!< [6] Card Insertion Interrupt Enable */
        uint32_t CRMIEN : 1;           /*!< [7] Card Removal Interrupt Enable */
        uint32_t CINTIEN : 1;          /*!< [8] Card Interrupt Interrupt Enable */
        uint32_t RESERVED0 : 3;        /*!< [11:9]  */
        uint32_t RTEIEN : 1;           /*!< [12] Re-Tuning Event Interrupt Enable */
        uint32_t RESERVED1 : 1;        /*!< [13]  */
        uint32_t TPIEN : 1;            /*!< [14] Tuning Pass Interrupt Enable */
        uint32_t RESERVED2 : 1;        /*!< [15]  */
        uint32_t CTOEIEN : 1;          /*!< [16] Command Timeout Error Interrupt
                                        * Enable */
        uint32_t CCEIEN : 1;           /*!< [17] Command CRC Error Interrupt Enable */
        uint32_t CEBEIEN : 1;          /*!< [18] Command End Bit Error Interrupt
                                        * Enable */
        uint32_t CIEIEN : 1;           /*!< [19] Command Index Error Interrupt Enable */
        uint32_t DTOEIEN : 1;          /*!< [20] Data Timeout Error Interrupt Enable */
        uint32_t DCEIEN : 1;           /*!< [21] Data CRC Error Interrupt Enable */
        uint32_t DEBEIEN : 1;          /*!< [22] Data End Bit Error Interrupt Enable */
        uint32_t RESERVED3 : 1;        /*!< [23]  */
        uint32_t AC12EIEN : 1;         /*!< [24] Auto CMD12 Error Interrupt Enable */
        uint32_t RESERVED4 : 1;        /*!< [25]  */
        uint32_t TNEIEN : 1;           /*!< [26] Tuning Error Interrupt Enable */
        uint32_t RESERVED5 : 1;        /*!< [27]  */
        uint32_t DMAEIEN : 1;          /*!< [28] DMA Error Interrupt Enable */
        uint32_t RESERVED6 : 3;        /*!< [31:29]  */
    } B;
} hw_usdhc_int_signal_en_t;

/*!
 * @name Constants and macros for entire uSDHC_INT_SIGNAL_EN register
 */
/*@{*/
#define HW_uSDHC_INT_SIGNAL_EN_ADDR(x) ((uintptr_t)(x) + 0x38U)

#define HW_uSDHC_INT_SIGNAL_EN(x) (*(__IO hw_usdhc_int_signal_en_t *) HW_uSDHC_INT_SIGNAL_EN_ADDR(x))
#define HW_uSDHC_INT_SIGNAL_EN_RD(x) (HW_uSDHC_INT_SIGNAL_EN(x).U)
#define HW_uSDHC_INT_SIGNAL_EN_WR(x, v) (HW_uSDHC_INT_SIGNAL_EN(x).U = (v))
#define HW_uSDHC_INT_SIGNAL_EN_SET(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, HW_uSDHC_INT_SIGNAL_EN_RD(x) |  (v)))
#define HW_uSDHC_INT_SIGNAL_EN_CLR(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~(v)))
#define HW_uSDHC_INT_SIGNAL_EN_TOG(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, HW_uSDHC_INT_SIGNAL_EN_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_INT_SIGNAL_EN bitfields
 */

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CCIEN[0] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CCIEN (0U)  /*!< Bit position for uSDHC_INT_SIGNAL_EN_CCIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CCIEN (0x00000001U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CCIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CCIEN (1U)  /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CCIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CCIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CCIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CCIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CCIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CCIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CCIEN) & BM_uSDHC_INT_SIGNAL_EN_CCIEN)

/*! @brief Set the CCIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CCIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CCIEN) | BF_uSDHC_INT_SIGNAL_EN_CCIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field TCIEN[1] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_TCIEN (1U)  /*!< Bit position for uSDHC_INT_SIGNAL_EN_TCIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_TCIEN (0x00000002U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_TCIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_TCIEN (1U)  /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_TCIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_TCIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_TCIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.TCIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_TCIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_TCIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_TCIEN) & BM_uSDHC_INT_SIGNAL_EN_TCIEN)

/*! @brief Set the TCIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_TCIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_TCIEN) | BF_uSDHC_INT_SIGNAL_EN_TCIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field BGEIEN[2] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_BGEIEN (2U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_BGEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_BGEIEN (0x00000004U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_BGEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_BGEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_BGEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_BGEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_BGEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.BGEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_BGEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_BGEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_BGEIEN) & BM_uSDHC_INT_SIGNAL_EN_BGEIEN)

/*! @brief Set the BGEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_BGEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_BGEIEN) | BF_uSDHC_INT_SIGNAL_EN_BGEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field DINTIEN[3] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_DINTIEN (3U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_DINTIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_DINTIEN (0x00000008U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_DINTIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_DINTIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_DINTIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_DINTIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_DINTIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.DINTIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_DINTIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_DINTIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_DINTIEN) & BM_uSDHC_INT_SIGNAL_EN_DINTIEN)

/*! @brief Set the DINTIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_DINTIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_DINTIEN) | BF_uSDHC_INT_SIGNAL_EN_DINTIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field BWRIEN[4] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_BWRIEN (4U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_BWRIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_BWRIEN (0x00000010U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_BWRIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_BWRIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_BWRIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_BWRIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_BWRIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.BWRIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_BWRIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_BWRIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_BWRIEN) & BM_uSDHC_INT_SIGNAL_EN_BWRIEN)

/*! @brief Set the BWRIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_BWRIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_BWRIEN) | BF_uSDHC_INT_SIGNAL_EN_BWRIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field BRRIEN[5] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_BRRIEN (5U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_BRRIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_BRRIEN (0x00000020U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_BRRIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_BRRIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_BRRIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_BRRIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_BRRIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.BRRIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_BRRIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_BRRIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_BRRIEN) & BM_uSDHC_INT_SIGNAL_EN_BRRIEN)

/*! @brief Set the BRRIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_BRRIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_BRRIEN) | BF_uSDHC_INT_SIGNAL_EN_BRRIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CINSIEN[6] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CINSIEN (6U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CINSIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CINSIEN (0x00000040U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CINSIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CINSIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CINSIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CINSIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CINSIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CINSIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CINSIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CINSIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CINSIEN) & BM_uSDHC_INT_SIGNAL_EN_CINSIEN)

/*! @brief Set the CINSIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CINSIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CINSIEN) | BF_uSDHC_INT_SIGNAL_EN_CINSIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CRMIEN[7] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CRMIEN (7U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CRMIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CRMIEN (0x00000080U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CRMIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CRMIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CRMIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CRMIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CRMIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CRMIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CRMIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CRMIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CRMIEN) & BM_uSDHC_INT_SIGNAL_EN_CRMIEN)

/*! @brief Set the CRMIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CRMIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CRMIEN) | BF_uSDHC_INT_SIGNAL_EN_CRMIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CINTIEN[8] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CINTIEN (8U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CINTIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CINTIEN (0x00000100U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CINTIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CINTIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CINTIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CINTIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CINTIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CINTIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CINTIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CINTIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CINTIEN) & BM_uSDHC_INT_SIGNAL_EN_CINTIEN)

/*! @brief Set the CINTIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CINTIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CINTIEN) | BF_uSDHC_INT_SIGNAL_EN_CINTIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field RTEIEN[12] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_RTEIEN (12U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_RTEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_RTEIEN (0x00001000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_RTEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_RTEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_RTEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_RTEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_RTEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.RTEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_RTEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_RTEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_RTEIEN) & BM_uSDHC_INT_SIGNAL_EN_RTEIEN)

/*! @brief Set the RTEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_RTEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_RTEIEN) | BF_uSDHC_INT_SIGNAL_EN_RTEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field TPIEN[14] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_TPIEN (14U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_TPIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_TPIEN (0x00004000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_TPIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_TPIEN (1U)  /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_TPIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_TPIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_TPIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.TPIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_TPIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_TPIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_TPIEN) & BM_uSDHC_INT_SIGNAL_EN_TPIEN)

/*! @brief Set the TPIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_TPIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_TPIEN) | BF_uSDHC_INT_SIGNAL_EN_TPIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CTOEIEN[16] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CTOEIEN (16U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CTOEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CTOEIEN (0x00010000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CTOEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CTOEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CTOEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CTOEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CTOEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CTOEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CTOEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CTOEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CTOEIEN) & BM_uSDHC_INT_SIGNAL_EN_CTOEIEN)

/*! @brief Set the CTOEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CTOEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CTOEIEN) | BF_uSDHC_INT_SIGNAL_EN_CTOEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CCEIEN[17] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CCEIEN (17U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CCEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CCEIEN (0x00020000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CCEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CCEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CCEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CCEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CCEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CCEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CCEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CCEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CCEIEN) & BM_uSDHC_INT_SIGNAL_EN_CCEIEN)

/*! @brief Set the CCEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CCEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CCEIEN) | BF_uSDHC_INT_SIGNAL_EN_CCEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CEBEIEN[18] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CEBEIEN (18U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CEBEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CEBEIEN (0x00040000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CEBEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CEBEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CEBEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CEBEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CEBEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CEBEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CEBEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CEBEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CEBEIEN) & BM_uSDHC_INT_SIGNAL_EN_CEBEIEN)

/*! @brief Set the CEBEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CEBEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CEBEIEN) | BF_uSDHC_INT_SIGNAL_EN_CEBEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field CIEIEN[19] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_CIEIEN (19U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_CIEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_CIEIEN (0x00080000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_CIEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_CIEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_CIEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_CIEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_CIEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.CIEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_CIEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_CIEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_CIEIEN) & BM_uSDHC_INT_SIGNAL_EN_CIEIEN)

/*! @brief Set the CIEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_CIEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_CIEIEN) | BF_uSDHC_INT_SIGNAL_EN_CIEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field DTOEIEN[20] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_DTOEIEN (20U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_DTOEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_DTOEIEN (0x00100000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_DTOEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_DTOEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_DTOEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_DTOEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_DTOEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.DTOEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_DTOEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_DTOEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_DTOEIEN) & BM_uSDHC_INT_SIGNAL_EN_DTOEIEN)

/*! @brief Set the DTOEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_DTOEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_DTOEIEN) | BF_uSDHC_INT_SIGNAL_EN_DTOEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field DCEIEN[21] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_DCEIEN (21U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_DCEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_DCEIEN (0x00200000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_DCEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_DCEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_DCEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_DCEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_DCEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.DCEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_DCEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_DCEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_DCEIEN) & BM_uSDHC_INT_SIGNAL_EN_DCEIEN)

/*! @brief Set the DCEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_DCEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_DCEIEN) | BF_uSDHC_INT_SIGNAL_EN_DCEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field DEBEIEN[22] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_DEBEIEN (22U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_DEBEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_DEBEIEN (0x00400000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_DEBEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_DEBEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_DEBEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_DEBEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_DEBEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.DEBEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_DEBEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_DEBEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_DEBEIEN) & BM_uSDHC_INT_SIGNAL_EN_DEBEIEN)

/*! @brief Set the DEBEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_DEBEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_DEBEIEN) | BF_uSDHC_INT_SIGNAL_EN_DEBEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field AC12EIEN[24] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_AC12EIEN (24U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_AC12EIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_AC12EIEN (0x01000000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_AC12EIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_AC12EIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_AC12EIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_AC12EIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_AC12EIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.AC12EIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_AC12EIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_AC12EIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_AC12EIEN) & BM_uSDHC_INT_SIGNAL_EN_AC12EIEN)

/*! @brief Set the AC12EIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_AC12EIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_AC12EIEN) | BF_uSDHC_INT_SIGNAL_EN_AC12EIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field TNEIEN[26] (RW)
 *
 * Values:
 * - 1 - Enabled
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_TNEIEN (26U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_TNEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_TNEIEN (0x04000000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_TNEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_TNEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_TNEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_TNEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_TNEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.TNEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_TNEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_TNEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_TNEIEN) & BM_uSDHC_INT_SIGNAL_EN_TNEIEN)

/*! @brief Set the TNEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_TNEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_TNEIEN) | BF_uSDHC_INT_SIGNAL_EN_TNEIEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_INT_SIGNAL_EN, field DMAEIEN[28] (RW)
 *
 * Values:
 * - 1 - Enable
 * - 0 - Masked
 */
/*@{*/
#define BP_uSDHC_INT_SIGNAL_EN_DMAEIEN (28U) /*!< Bit position for uSDHC_INT_SIGNAL_EN_DMAEIEN. */
#define BM_uSDHC_INT_SIGNAL_EN_DMAEIEN (0x10000000U) /*!< Bit mask for uSDHC_INT_SIGNAL_EN_DMAEIEN. */
#define BS_uSDHC_INT_SIGNAL_EN_DMAEIEN (1U) /*!< Bit field size in bits for uSDHC_INT_SIGNAL_EN_DMAEIEN. */

/*! @brief Read current value of the uSDHC_INT_SIGNAL_EN_DMAEIEN field. */
#define BR_uSDHC_INT_SIGNAL_EN_DMAEIEN(x) (HW_uSDHC_INT_SIGNAL_EN(x).B.DMAEIEN)

/*! @brief Format value for bitfield uSDHC_INT_SIGNAL_EN_DMAEIEN. */
#define BF_uSDHC_INT_SIGNAL_EN_DMAEIEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_INT_SIGNAL_EN_DMAEIEN) & BM_uSDHC_INT_SIGNAL_EN_DMAEIEN)

/*! @brief Set the DMAEIEN field to a new value. */
#define BW_uSDHC_INT_SIGNAL_EN_DMAEIEN(x, v) (HW_uSDHC_INT_SIGNAL_EN_WR(x, (HW_uSDHC_INT_SIGNAL_EN_RD(x) & ~BM_uSDHC_INT_SIGNAL_EN_DMAEIEN) | BF_uSDHC_INT_SIGNAL_EN_DMAEIEN(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_AUTOCMD12_ERR_STATUS - Auto CMD12 Error Status
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_AUTOCMD12_ERR_STATUS - Auto CMD12 Error Status (RO)
 *
 * Reset value: 0x00000000U
 *
 * When the Auto CMD12 Error Status bit in the Status register is set, the Host
 * Driver shall check this register to identify what kind of error the Auto CMD12
 * / CMD 23 indicated. Auto CMD23 errors are indicated in bit 04-01.This
 * register is valid only when the Auto CMD12 Error status bit is set. The table bwlow
 * shows the relationship between the Auto CMGD12 CRC Error and the Auto CMD12
 * Command Timeout Error. Relationship Between Command CRC Error and Command Timeout
 * Error for Auto CMD12 Auto CMD12 CRC Error Auto CMD12 Timeout Error Type of
 * Error 0 0 No Error 0 1 Response Timeout Error 1 0 Response CRC Error 1 1 CMD
 * line conflict Changes in Auto CMD12 Error Status register can be classified in
 * three scenarios: When the uSDHC is going to issue an Auto CMD12. Set bit 0 to 1
 * if the Auto CMD12 can't be issued due to an error in the previous command Set
 * bit 0 to 0 if the Auto CMD12 is issued At the end bit of an Auto CMD12
 * response. Check errors correspond to bits 1-4. Set bits 1-4 corresponding to detected
 * errors. Clear bits 1-4 corresponding to detected errors Before reading the
 * Auto CMD12 Error Status bit 7. Set bit 7 to 1 if there is a command that can't
 * be issued Clear bit 7 if there is no command to issue The timing for generating
 * the Auto CMD12 Error and writing to the Command register are asynchronous.
 * After that, bit 7 shall be sampled when the driver is not writing to the Command
 * register. So it is suggested to read this register only when the AC12E bit in
 * Interrupt Status register is set. An Auto CMD12 Error Interrupt is generated
 * when one of the error bits (0-4) is set to 1. The Command Not Issued By Auto
 * CMD12 Error does not generate an interrupt.
 */
typedef union _hw_usdhc_autocmd12_err_status
{
    uint32_t U;
    struct _hw_usdhc_autocmd12_err_status_bitfields
    {
        uint32_t AC12NE : 1;           /*!< [0] Auto CMD12 Not Executed */
        uint32_t AC12TOE : 1;          /*!< [1] Auto CMD12 / 23 Timeout Error */
        uint32_t AC12EBE : 1;          /*!< [2] Auto CMD12 / 23 End Bit Error */
        uint32_t AC12CE : 1;           /*!< [3] Auto CMD12 / 23 CRC Error */
        uint32_t AC12IE : 1;           /*!< [4] Auto CMD12 / 23 Index Error */
        uint32_t RESERVED0 : 2;        /*!< [6:5]  */
        uint32_t CNIBAC12E : 1;        /*!< [7] Command Not Issued By Auto CMD12
                                        * Error */
        uint32_t RESERVED1 : 24;       /*!< [31:8]  */
    } B;
} hw_usdhc_autocmd12_err_status_t;

/*!
 * @name Constants and macros for entire uSDHC_AUTOCMD12_ERR_STATUS register
 */
/*@{*/
#define HW_uSDHC_AUTOCMD12_ERR_STATUS_ADDR(x) ((uintptr_t)(x) + 0x3CU)

#define HW_uSDHC_AUTOCMD12_ERR_STATUS(x) (*(__I hw_usdhc_autocmd12_err_status_t *) HW_uSDHC_AUTOCMD12_ERR_STATUS_ADDR(x))
#define HW_uSDHC_AUTOCMD12_ERR_STATUS_RD(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_AUTOCMD12_ERR_STATUS bitfields
 */

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field AC12NE[0] (RO)
 *
 * If memory multiple block data transfer is not started, due to a command
 * error, this bit is not set because it is not necessary to issue an Auto CMD12.
 * Setting this bit to 1 means the uSDHC cannot issue the Auto CMD12 to stop a memory
 * multiple block data transfer due to some error. If this bit is set to 1,
 * other error status bits (1-4) have no meaning.
 *
 * Values:
 * - 1 - Not executed
 * - 0 - Executed
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_AC12NE (0U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_AC12NE. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_AC12NE (0x00000001U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_AC12NE. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_AC12NE (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_AC12NE. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_AC12NE field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_AC12NE(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.AC12NE)
/*@}*/

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field AC12TOE[1] (RO)
 *
 * Occurs if no response is returned within 64 SDCLK cycles from the end bit of
 * the command. If this bit is set to1, the other error status bits (2-4) have no
 * meaning.
 *
 * Values:
 * - 1 - Time out
 * - 0 - No error
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE (1U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE (0x00000002U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_AC12TOE(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.AC12TOE)
/*@}*/

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field AC12EBE[2] (RO)
 *
 * Occurs when detecting that the end bit of command response is 0 which should
 * be 1.
 *
 * Values:
 * - 1 - End Bit Error Generated
 * - 0 - No error
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE (2U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE (0x00000004U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_AC12EBE(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.AC12EBE)
/*@}*/

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field AC12CE[3] (RO)
 *
 * Occurs when detecting a CRC error in the command response.
 *
 * Values:
 * - 1 - CRC Error Met in Auto CMD12/23 Response
 * - 0 - No CRC error
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_AC12CE (3U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_AC12CE. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_AC12CE (0x00000008U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_AC12CE. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_AC12CE (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_AC12CE. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_AC12CE field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_AC12CE(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.AC12CE)
/*@}*/

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field AC12IE[4] (RO)
 *
 * Occurs if the Command Index error occurs in response to a command.
 *
 * Values:
 * - 1 - Error, the CMD index in response is not CMD12/23
 * - 0 - No error
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_AC12IE (4U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_AC12IE. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_AC12IE (0x00000010U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_AC12IE. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_AC12IE (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_AC12IE. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_AC12IE field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_AC12IE(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.AC12IE)
/*@}*/

/*!
 * @name Register uSDHC_AUTOCMD12_ERR_STATUS, field CNIBAC12E[7] (RO)
 *
 * Setting this bit to 1 means CMD_wo_DAT is not executed due to an Auto CMD12
 * Error (D04-D01) in this register.
 *
 * Values:
 * - 1 - Not Issued
 * - 0 - No error
 */
/*@{*/
#define BP_uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E (7U) /*!< Bit position for uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E. */
#define BM_uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E (0x00000080U) /*!< Bit mask for uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E. */
#define BS_uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E (1U) /*!< Bit field size in bits for uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E. */

/*! @brief Read current value of the uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E field. */
#define BR_uSDHC_AUTOCMD12_ERR_STATUS_CNIBAC12E(x) (HW_uSDHC_AUTOCMD12_ERR_STATUS(x).B.CNIBAC12E)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_HOST_CTRL_CAP - Host Controller Capabilities
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_HOST_CTRL_CAP - Host Controller Capabilities (RO)
 *
 * Reset value: 0x07F30000U
 *
 * This register provides the Host Driver with information specific to the uSDHC
 * implementation. The value in this register is the power-on-reset value, and
 * does not change with a software reset.
 */
typedef union _hw_usdhc_host_ctrl_cap
{
    uint32_t U;
    struct _hw_usdhc_host_ctrl_cap_bitfields
    {
        uint32_t RESERVED0 : 16;       /*!< [15:0]  */
        uint32_t MBL : 3;              /*!< [18:16] Max Block Length */
        uint32_t RESERVED1 : 1;        /*!< [19]  */
        uint32_t ADMAS : 1;            /*!< [20] ADMA Support */
        uint32_t HSS : 1;              /*!< [21] High Speed Support */
        uint32_t DMAS : 1;             /*!< [22] DMA Support */
        uint32_t SRS : 1;              /*!< [23] Suspend / Resume Support */
        uint32_t VS33 : 1;             /*!< [24] Voltage Support 3.3V */
        uint32_t VS30 : 1;             /*!< [25] Voltage Support 3.0 V */
        uint32_t VS18 : 1;             /*!< [26] Voltage Support 1.8 V */
        uint32_t RESERVED2 : 5;        /*!< [31:27]  */
    } B;
} hw_usdhc_host_ctrl_cap_t;

/*!
 * @name Constants and macros for entire uSDHC_HOST_CTRL_CAP register
 */
/*@{*/
#define HW_uSDHC_HOST_CTRL_CAP_ADDR(x) ((uintptr_t)(x) + 0x40U)

#define HW_uSDHC_HOST_CTRL_CAP(x) (*(__I hw_usdhc_host_ctrl_cap_t *) HW_uSDHC_HOST_CTRL_CAP_ADDR(x))
#define HW_uSDHC_HOST_CTRL_CAP_RD(x) (HW_uSDHC_HOST_CTRL_CAP(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_HOST_CTRL_CAP bitfields
 */

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field MBL[18:16] (RO)
 *
 * This value indicates the maximum block size that the Host Driver can read and
 * write to the buffer in the uSDHC. The buffer shall transfer block size
 * without wait cycles.
 *
 * Values:
 * - 000 - 512 bytes
 * - 001 - 1024 bytes
 * - 010 - 2048 bytes
 * - 011 - 4096 bytes
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_MBL (16U)   /*!< Bit position for uSDHC_HOST_CTRL_CAP_MBL. */
#define BM_uSDHC_HOST_CTRL_CAP_MBL (0x00070000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_MBL. */
#define BS_uSDHC_HOST_CTRL_CAP_MBL (3U)    /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_MBL. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_MBL field. */
#define BR_uSDHC_HOST_CTRL_CAP_MBL(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.MBL)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field ADMAS[20] (RO)
 *
 * This bit indicates whether the uSDHC supports the ADMA feature.
 *
 * Values:
 * - 1 - Advanced DMA Supported
 * - 0 - Advanced DMA Not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_ADMAS (20U) /*!< Bit position for uSDHC_HOST_CTRL_CAP_ADMAS. */
#define BM_uSDHC_HOST_CTRL_CAP_ADMAS (0x00100000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_ADMAS. */
#define BS_uSDHC_HOST_CTRL_CAP_ADMAS (1U)  /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_ADMAS. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_ADMAS field. */
#define BR_uSDHC_HOST_CTRL_CAP_ADMAS(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.ADMAS)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field HSS[21] (RO)
 *
 * This bit indicates whether the uSDHC supports High Speed mode and the Host
 * System can supply a SD Clock frequency from 25 MHz to 50 MHz.
 *
 * Values:
 * - 1 - High Speed Supported
 * - 0 - High Speed Not Supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_HSS (21U)   /*!< Bit position for uSDHC_HOST_CTRL_CAP_HSS. */
#define BM_uSDHC_HOST_CTRL_CAP_HSS (0x00200000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_HSS. */
#define BS_uSDHC_HOST_CTRL_CAP_HSS (1U)    /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_HSS. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_HSS field. */
#define BR_uSDHC_HOST_CTRL_CAP_HSS(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.HSS)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field DMAS[22] (RO)
 *
 * This bit indicates whether the uSDHC is capable of using the internal DMA to
 * transfer data between system memory and the data buffer directly.
 *
 * Values:
 * - 1 - DMA Supported
 * - 0 - DMA not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_DMAS (22U)  /*!< Bit position for uSDHC_HOST_CTRL_CAP_DMAS. */
#define BM_uSDHC_HOST_CTRL_CAP_DMAS (0x00400000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_DMAS. */
#define BS_uSDHC_HOST_CTRL_CAP_DMAS (1U)   /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_DMAS. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_DMAS field. */
#define BR_uSDHC_HOST_CTRL_CAP_DMAS(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.DMAS)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field SRS[23] (RO)
 *
 * This bit indicates whether the uSDHC supports Suspend / Resume functionality.
 * If this bit is 0, the Suspend and Resume mechanism, as well as the Read Wait,
 * are not supported, and the Host Driver shall not issue either Suspend or
 * Resume commands.
 *
 * Values:
 * - 1 - Supported
 * - 0 - Not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_SRS (23U)   /*!< Bit position for uSDHC_HOST_CTRL_CAP_SRS. */
#define BM_uSDHC_HOST_CTRL_CAP_SRS (0x00800000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_SRS. */
#define BS_uSDHC_HOST_CTRL_CAP_SRS (1U)    /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_SRS. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_SRS field. */
#define BR_uSDHC_HOST_CTRL_CAP_SRS(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.SRS)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field VS33[24] (RO)
 *
 * This bit shall depend on the Host System ability.
 *
 * Values:
 * - 1 - 3.3V supported
 * - 0 - 3.3V not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_VS33 (24U)  /*!< Bit position for uSDHC_HOST_CTRL_CAP_VS33. */
#define BM_uSDHC_HOST_CTRL_CAP_VS33 (0x01000000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_VS33. */
#define BS_uSDHC_HOST_CTRL_CAP_VS33 (1U)   /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_VS33. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_VS33 field. */
#define BR_uSDHC_HOST_CTRL_CAP_VS33(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.VS33)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field VS30[25] (RO)
 *
 * This bit shall depend on the Host System ability.
 *
 * Values:
 * - 1 - 3.0V supported
 * - 0 - 3.0V not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_VS30 (25U)  /*!< Bit position for uSDHC_HOST_CTRL_CAP_VS30. */
#define BM_uSDHC_HOST_CTRL_CAP_VS30 (0x02000000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_VS30. */
#define BS_uSDHC_HOST_CTRL_CAP_VS30 (1U)   /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_VS30. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_VS30 field. */
#define BR_uSDHC_HOST_CTRL_CAP_VS30(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.VS30)
/*@}*/

/*!
 * @name Register uSDHC_HOST_CTRL_CAP, field VS18[26] (RO)
 *
 * This bit shall depend on the Host System ability.
 *
 * Values:
 * - 1 - 1.8V supported
 * - 0 - 1.8V not supported
 */
/*@{*/
#define BP_uSDHC_HOST_CTRL_CAP_VS18 (26U)  /*!< Bit position for uSDHC_HOST_CTRL_CAP_VS18. */
#define BM_uSDHC_HOST_CTRL_CAP_VS18 (0x04000000U) /*!< Bit mask for uSDHC_HOST_CTRL_CAP_VS18. */
#define BS_uSDHC_HOST_CTRL_CAP_VS18 (1U)   /*!< Bit field size in bits for uSDHC_HOST_CTRL_CAP_VS18. */

/*! @brief Read current value of the uSDHC_HOST_CTRL_CAP_VS18 field. */
#define BR_uSDHC_HOST_CTRL_CAP_VS18(x) (HW_uSDHC_HOST_CTRL_CAP(x).B.VS18)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_WTMK_LVL - Watermark Level
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_WTMK_LVL - Watermark Level (RW)
 *
 * Reset value: 0x08100810U
 *
 * Both write and read watermark levels (FIFO threshold) are configurable. There
 * value can range from 1 to 128 words. Both write and read burst lengths are
 * also Configurable. There value can range from 1 to 31 words.
 */
typedef union _hw_usdhc_wtmk_lvl
{
    uint32_t U;
    struct _hw_usdhc_wtmk_lvl_bitfields
    {
        uint32_t RD_WML : 8;           /*!< [7:0] Read Watermark Level */
        uint32_t RD_BRST_LEN : 5;      /*!< [12:8] Read Burst Length Due to system
                                        * restriction, the actual burst length may not exceed 16. */
        uint32_t RESERVED0 : 3;        /*!< [15:13]  */
        uint32_t WR_WML : 8;           /*!< [23:16] Write Watermark Level */
        uint32_t WR_BRST_LEN : 5;      /*!< [28:24] Write Burst Length Due to
                                        * system restriction, the actual burst length may not exceed 16. */
        uint32_t RESERVED1 : 3;        /*!< [31:29]  */
    } B;
} hw_usdhc_wtmk_lvl_t;

/*!
 * @name Constants and macros for entire uSDHC_WTMK_LVL register
 */
/*@{*/
#define HW_uSDHC_WTMK_LVL_ADDR(x) ((uintptr_t)(x) + 0x44U)

#define HW_uSDHC_WTMK_LVL(x)     (*(__IO hw_usdhc_wtmk_lvl_t *) HW_uSDHC_WTMK_LVL_ADDR(x))
#define HW_uSDHC_WTMK_LVL_RD(x)  (HW_uSDHC_WTMK_LVL(x).U)
#define HW_uSDHC_WTMK_LVL_WR(x, v) (HW_uSDHC_WTMK_LVL(x).U = (v))
#define HW_uSDHC_WTMK_LVL_SET(x, v) (HW_uSDHC_WTMK_LVL_WR(x, HW_uSDHC_WTMK_LVL_RD(x) |  (v)))
#define HW_uSDHC_WTMK_LVL_CLR(x, v) (HW_uSDHC_WTMK_LVL_WR(x, HW_uSDHC_WTMK_LVL_RD(x) & ~(v)))
#define HW_uSDHC_WTMK_LVL_TOG(x, v) (HW_uSDHC_WTMK_LVL_WR(x, HW_uSDHC_WTMK_LVL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_WTMK_LVL bitfields
 */

/*!
 * @name Register uSDHC_WTMK_LVL, field RD_WML[7:0] (RW)
 *
 * The number of words used as the watermark level (FIFO threshold) in a DMA
 * read operation. Also the number of words as a sequence of read bursts in
 * back-to-back mode. The maximum legal value for the read water mark level is 128.
 */
/*@{*/
#define BP_uSDHC_WTMK_LVL_RD_WML (0U)      /*!< Bit position for uSDHC_WTMK_LVL_RD_WML. */
#define BM_uSDHC_WTMK_LVL_RD_WML (0x000000FFU) /*!< Bit mask for uSDHC_WTMK_LVL_RD_WML. */
#define BS_uSDHC_WTMK_LVL_RD_WML (8U)      /*!< Bit field size in bits for uSDHC_WTMK_LVL_RD_WML. */

/*! @brief Read current value of the uSDHC_WTMK_LVL_RD_WML field. */
#define BR_uSDHC_WTMK_LVL_RD_WML(x) (HW_uSDHC_WTMK_LVL(x).B.RD_WML)

/*! @brief Format value for bitfield uSDHC_WTMK_LVL_RD_WML. */
#define BF_uSDHC_WTMK_LVL_RD_WML(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_WTMK_LVL_RD_WML) & BM_uSDHC_WTMK_LVL_RD_WML)

/*! @brief Set the RD_WML field to a new value. */
#define BW_uSDHC_WTMK_LVL_RD_WML(x, v) (HW_uSDHC_WTMK_LVL_WR(x, (HW_uSDHC_WTMK_LVL_RD(x) & ~BM_uSDHC_WTMK_LVL_RD_WML) | BF_uSDHC_WTMK_LVL_RD_WML(v)))
/*@}*/

/*!
 * @name Register uSDHC_WTMK_LVL, field RD_BRST_LEN[12:8] (RW)
 *
 * The number of words the uSDHC reads in a single burst. The read burst length
 * must be less than or equal to the read watermark level, and all bursts within
 * a watermark level transfer will be in back-to-back mode. On reset, this field
 * will be 8. Writing 0 to this field will result in '01000' (i.e. it is not able
 * to clear this field).
 */
/*@{*/
#define BP_uSDHC_WTMK_LVL_RD_BRST_LEN (8U) /*!< Bit position for uSDHC_WTMK_LVL_RD_BRST_LEN. */
#define BM_uSDHC_WTMK_LVL_RD_BRST_LEN (0x00001F00U) /*!< Bit mask for uSDHC_WTMK_LVL_RD_BRST_LEN. */
#define BS_uSDHC_WTMK_LVL_RD_BRST_LEN (5U) /*!< Bit field size in bits for uSDHC_WTMK_LVL_RD_BRST_LEN. */

/*! @brief Read current value of the uSDHC_WTMK_LVL_RD_BRST_LEN field. */
#define BR_uSDHC_WTMK_LVL_RD_BRST_LEN(x) (HW_uSDHC_WTMK_LVL(x).B.RD_BRST_LEN)

/*! @brief Format value for bitfield uSDHC_WTMK_LVL_RD_BRST_LEN. */
#define BF_uSDHC_WTMK_LVL_RD_BRST_LEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_WTMK_LVL_RD_BRST_LEN) & BM_uSDHC_WTMK_LVL_RD_BRST_LEN)

/*! @brief Set the RD_BRST_LEN field to a new value. */
#define BW_uSDHC_WTMK_LVL_RD_BRST_LEN(x, v) (HW_uSDHC_WTMK_LVL_WR(x, (HW_uSDHC_WTMK_LVL_RD(x) & ~BM_uSDHC_WTMK_LVL_RD_BRST_LEN) | BF_uSDHC_WTMK_LVL_RD_BRST_LEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_WTMK_LVL, field WR_WML[23:16] (RW)
 *
 * The number of words used as the watermark level (FIFO threshold) in a DMA
 * write operation. Also the number of words as a sequence of write bursts in
 * back-to-back mode. The maximum legal value for the write watermark level is 128.
 */
/*@{*/
#define BP_uSDHC_WTMK_LVL_WR_WML (16U)     /*!< Bit position for uSDHC_WTMK_LVL_WR_WML. */
#define BM_uSDHC_WTMK_LVL_WR_WML (0x00FF0000U) /*!< Bit mask for uSDHC_WTMK_LVL_WR_WML. */
#define BS_uSDHC_WTMK_LVL_WR_WML (8U)      /*!< Bit field size in bits for uSDHC_WTMK_LVL_WR_WML. */

/*! @brief Read current value of the uSDHC_WTMK_LVL_WR_WML field. */
#define BR_uSDHC_WTMK_LVL_WR_WML(x) (HW_uSDHC_WTMK_LVL(x).B.WR_WML)

/*! @brief Format value for bitfield uSDHC_WTMK_LVL_WR_WML. */
#define BF_uSDHC_WTMK_LVL_WR_WML(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_WTMK_LVL_WR_WML) & BM_uSDHC_WTMK_LVL_WR_WML)

/*! @brief Set the WR_WML field to a new value. */
#define BW_uSDHC_WTMK_LVL_WR_WML(x, v) (HW_uSDHC_WTMK_LVL_WR(x, (HW_uSDHC_WTMK_LVL_RD(x) & ~BM_uSDHC_WTMK_LVL_WR_WML) | BF_uSDHC_WTMK_LVL_WR_WML(v)))
/*@}*/

/*!
 * @name Register uSDHC_WTMK_LVL, field WR_BRST_LEN[28:24] (RW)
 *
 * The number of words the uSDHC writes in a single burst. The write burst
 * length must be less than or equal to the write watermark level, and all bursts
 * within a watermark level transfer will be in back-to-back mode. On reset, this
 * field will be 8. Writing 0 to this field will result in '01000' (i.e. it is not
 * able to clear this field).
 */
/*@{*/
#define BP_uSDHC_WTMK_LVL_WR_BRST_LEN (24U) /*!< Bit position for uSDHC_WTMK_LVL_WR_BRST_LEN. */
#define BM_uSDHC_WTMK_LVL_WR_BRST_LEN (0x1F000000U) /*!< Bit mask for uSDHC_WTMK_LVL_WR_BRST_LEN. */
#define BS_uSDHC_WTMK_LVL_WR_BRST_LEN (5U) /*!< Bit field size in bits for uSDHC_WTMK_LVL_WR_BRST_LEN. */

/*! @brief Read current value of the uSDHC_WTMK_LVL_WR_BRST_LEN field. */
#define BR_uSDHC_WTMK_LVL_WR_BRST_LEN(x) (HW_uSDHC_WTMK_LVL(x).B.WR_BRST_LEN)

/*! @brief Format value for bitfield uSDHC_WTMK_LVL_WR_BRST_LEN. */
#define BF_uSDHC_WTMK_LVL_WR_BRST_LEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_WTMK_LVL_WR_BRST_LEN) & BM_uSDHC_WTMK_LVL_WR_BRST_LEN)

/*! @brief Set the WR_BRST_LEN field to a new value. */
#define BW_uSDHC_WTMK_LVL_WR_BRST_LEN(x, v) (HW_uSDHC_WTMK_LVL_WR(x, (HW_uSDHC_WTMK_LVL_RD(x) & ~BM_uSDHC_WTMK_LVL_WR_BRST_LEN) | BF_uSDHC_WTMK_LVL_WR_BRST_LEN(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_MIX_CTRL - Mixer Control
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_MIX_CTRL - Mixer Control (RW)
 *
 * Reset value: 0x80000000U
 *
 * This register is used to DMA and data transfer. To prevent data loss, The
 * software should check if data transfer is active before writing this register.
 * These bits are DPSEL, MBSEL, DTDSEL, AC12EN, BCEN, and DMAEN. Transfer Type
 * Register Setting for Various Transfer Types Multi/Single Block Select Block Count
 * Enable Block Count Function 0 Don't Care Don't Care Single Transfer 1 0 Don't
 * Care Infinite Transfer 1 1 Positive Number Multiple Transfer 1 1 Zero No Data
 * Transfer
 */
typedef union _hw_usdhc_mix_ctrl
{
    uint32_t U;
    struct _hw_usdhc_mix_ctrl_bitfields
    {
        uint32_t DMAEN : 1;            /*!< [0] DMA Enable */
        uint32_t BCEN : 1;             /*!< [1] Block Count Enable */
        uint32_t AC12EN : 1;           /*!< [2] Auto CMD12 Enable */
        uint32_t DDR_EN : 1;           /*!< [3] Dual Data Rate mode selection */
        uint32_t DTDSEL : 1;           /*!< [4] Data Transfer Direction Select */
        uint32_t MSBSEL : 1;           /*!< [5] Multi / Single Block Select */
        uint32_t NIBBLE_POS : 1;       /*!< [6]  */
        uint32_t AC23EN : 1;           /*!< [7] Auto CMD23 Enable */
        uint32_t RESERVED0 : 14;       /*!< [21:8]  */
        uint32_t EXE_TUNE : 1;         /*!< [22] Execute Tuning: (Only used for
                                        * SD3.0, SDR104 mode) */
        uint32_t SMP_CLK_SEL : 1;      /*!< [23]  */
        uint32_t AUTO_TUNE_EN : 1;     /*!< [24] Auto Tuning Enable (Only used
                                        * for SD3.0, SDR104 mode) */
        uint32_t FBCLK_SEL : 1;        /*!< [25] Feedback Clock Source Selection
                                        * (Only used for SD3.0, SDR104 mode) */
        uint32_t RESERVED1 : 6;        /*!< [31:26]  */
    } B;
} hw_usdhc_mix_ctrl_t;

/*!
 * @name Constants and macros for entire uSDHC_MIX_CTRL register
 */
/*@{*/
#define HW_uSDHC_MIX_CTRL_ADDR(x) ((uintptr_t)(x) + 0x48U)

#define HW_uSDHC_MIX_CTRL(x)     (*(__IO hw_usdhc_mix_ctrl_t *) HW_uSDHC_MIX_CTRL_ADDR(x))
#define HW_uSDHC_MIX_CTRL_RD(x)  (HW_uSDHC_MIX_CTRL(x).U)
#define HW_uSDHC_MIX_CTRL_WR(x, v) (HW_uSDHC_MIX_CTRL(x).U = (v))
#define HW_uSDHC_MIX_CTRL_SET(x, v) (HW_uSDHC_MIX_CTRL_WR(x, HW_uSDHC_MIX_CTRL_RD(x) |  (v)))
#define HW_uSDHC_MIX_CTRL_CLR(x, v) (HW_uSDHC_MIX_CTRL_WR(x, HW_uSDHC_MIX_CTRL_RD(x) & ~(v)))
#define HW_uSDHC_MIX_CTRL_TOG(x, v) (HW_uSDHC_MIX_CTRL_WR(x, HW_uSDHC_MIX_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_MIX_CTRL bitfields
 */

/*!
 * @name Register uSDHC_MIX_CTRL, field DMAEN[0] (RW)
 *
 * This bit enables DMA functionality. If this bit is set to 1, a DMA operation
 * shall begin when the Host Driver sets the DPSEL bit of this register. Whether
 * the Simple DMA or the Advanced DMA is active depends on the DMA Select field
 * of the Protocol Control register.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_DMAEN (0U)       /*!< Bit position for uSDHC_MIX_CTRL_DMAEN. */
#define BM_uSDHC_MIX_CTRL_DMAEN (0x00000001U) /*!< Bit mask for uSDHC_MIX_CTRL_DMAEN. */
#define BS_uSDHC_MIX_CTRL_DMAEN (1U)       /*!< Bit field size in bits for uSDHC_MIX_CTRL_DMAEN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_DMAEN field. */
#define BR_uSDHC_MIX_CTRL_DMAEN(x) (HW_uSDHC_MIX_CTRL(x).B.DMAEN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_DMAEN. */
#define BF_uSDHC_MIX_CTRL_DMAEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_DMAEN) & BM_uSDHC_MIX_CTRL_DMAEN)

/*! @brief Set the DMAEN field to a new value. */
#define BW_uSDHC_MIX_CTRL_DMAEN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_DMAEN) | BF_uSDHC_MIX_CTRL_DMAEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field BCEN[1] (RW)
 *
 * This bit is used to enable the Block Count register, which is only relevant
 * for multiple block transfers. When this bit is 0, the internal counter for
 * block is disabled, which is useful in executing an infinite transfer.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_BCEN (1U)        /*!< Bit position for uSDHC_MIX_CTRL_BCEN. */
#define BM_uSDHC_MIX_CTRL_BCEN (0x00000002U) /*!< Bit mask for uSDHC_MIX_CTRL_BCEN. */
#define BS_uSDHC_MIX_CTRL_BCEN (1U)        /*!< Bit field size in bits for uSDHC_MIX_CTRL_BCEN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_BCEN field. */
#define BR_uSDHC_MIX_CTRL_BCEN(x) (HW_uSDHC_MIX_CTRL(x).B.BCEN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_BCEN. */
#define BF_uSDHC_MIX_CTRL_BCEN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_BCEN) & BM_uSDHC_MIX_CTRL_BCEN)

/*! @brief Set the BCEN field to a new value. */
#define BW_uSDHC_MIX_CTRL_BCEN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_BCEN) | BF_uSDHC_MIX_CTRL_BCEN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field AC12EN[2] (RW)
 *
 * Multiple block transfers for memory require a CMD12 to stop the transaction.
 * When this bit is set to 1, the uSDHC will issue a CMD12 automatically when the
 * last block transfer has completed. The Host Driver shall not set this bit to
 * issue commands that do not require CMD12 to stop a multiple block data
 * transfer. In particular, secure commands defined in File Security Specification (see
 * reference list) do not require CMD12. In single block transfer, the uSDHC will
 * ignore this bit no matter it is set or not.
 *
 * Values:
 * - 1 - Enable
 * - 0 - Disable
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_AC12EN (2U)      /*!< Bit position for uSDHC_MIX_CTRL_AC12EN. */
#define BM_uSDHC_MIX_CTRL_AC12EN (0x00000004U) /*!< Bit mask for uSDHC_MIX_CTRL_AC12EN. */
#define BS_uSDHC_MIX_CTRL_AC12EN (1U)      /*!< Bit field size in bits for uSDHC_MIX_CTRL_AC12EN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_AC12EN field. */
#define BR_uSDHC_MIX_CTRL_AC12EN(x) (HW_uSDHC_MIX_CTRL(x).B.AC12EN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_AC12EN. */
#define BF_uSDHC_MIX_CTRL_AC12EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_AC12EN) & BM_uSDHC_MIX_CTRL_AC12EN)

/*! @brief Set the AC12EN field to a new value. */
#define BW_uSDHC_MIX_CTRL_AC12EN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_AC12EN) | BF_uSDHC_MIX_CTRL_AC12EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field DDR_EN[3] (RW)
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_DDR_EN (3U)      /*!< Bit position for uSDHC_MIX_CTRL_DDR_EN. */
#define BM_uSDHC_MIX_CTRL_DDR_EN (0x00000008U) /*!< Bit mask for uSDHC_MIX_CTRL_DDR_EN. */
#define BS_uSDHC_MIX_CTRL_DDR_EN (1U)      /*!< Bit field size in bits for uSDHC_MIX_CTRL_DDR_EN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_DDR_EN field. */
#define BR_uSDHC_MIX_CTRL_DDR_EN(x) (HW_uSDHC_MIX_CTRL(x).B.DDR_EN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_DDR_EN. */
#define BF_uSDHC_MIX_CTRL_DDR_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_DDR_EN) & BM_uSDHC_MIX_CTRL_DDR_EN)

/*! @brief Set the DDR_EN field to a new value. */
#define BW_uSDHC_MIX_CTRL_DDR_EN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_DDR_EN) | BF_uSDHC_MIX_CTRL_DDR_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field DTDSEL[4] (RW)
 *
 * This bit defines the direction of DATA line data transfers. The bit is set to
 * 1 by the Host Driver to transfer data from the SD card to the uSDHC and is
 * set to 0 for all other commands.
 *
 * Values:
 * - 1 - Read (Card to Host)
 * - 0 - Write (Host to Card)
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_DTDSEL (4U)      /*!< Bit position for uSDHC_MIX_CTRL_DTDSEL. */
#define BM_uSDHC_MIX_CTRL_DTDSEL (0x00000010U) /*!< Bit mask for uSDHC_MIX_CTRL_DTDSEL. */
#define BS_uSDHC_MIX_CTRL_DTDSEL (1U)      /*!< Bit field size in bits for uSDHC_MIX_CTRL_DTDSEL. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_DTDSEL field. */
#define BR_uSDHC_MIX_CTRL_DTDSEL(x) (HW_uSDHC_MIX_CTRL(x).B.DTDSEL)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_DTDSEL. */
#define BF_uSDHC_MIX_CTRL_DTDSEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_DTDSEL) & BM_uSDHC_MIX_CTRL_DTDSEL)

/*! @brief Set the DTDSEL field to a new value. */
#define BW_uSDHC_MIX_CTRL_DTDSEL(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_DTDSEL) | BF_uSDHC_MIX_CTRL_DTDSEL(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field MSBSEL[5] (RW)
 *
 * This bit enables multiple block DATA line data transfers. For any other
 * commands, this bit can be set to 0. If this bit is 0, it is not necessary to set
 * the Block Count register. (Refer to CMD_XFR_TYPCommand Transfer Type ).
 *
 * Values:
 * - 1 - Multiple Blocks
 * - 0 - Single Block
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_MSBSEL (5U)      /*!< Bit position for uSDHC_MIX_CTRL_MSBSEL. */
#define BM_uSDHC_MIX_CTRL_MSBSEL (0x00000020U) /*!< Bit mask for uSDHC_MIX_CTRL_MSBSEL. */
#define BS_uSDHC_MIX_CTRL_MSBSEL (1U)      /*!< Bit field size in bits for uSDHC_MIX_CTRL_MSBSEL. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_MSBSEL field. */
#define BR_uSDHC_MIX_CTRL_MSBSEL(x) (HW_uSDHC_MIX_CTRL(x).B.MSBSEL)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_MSBSEL. */
#define BF_uSDHC_MIX_CTRL_MSBSEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_MSBSEL) & BM_uSDHC_MIX_CTRL_MSBSEL)

/*! @brief Set the MSBSEL field to a new value. */
#define BW_uSDHC_MIX_CTRL_MSBSEL(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_MSBSEL) | BF_uSDHC_MIX_CTRL_MSBSEL(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field NIBBLE_POS[6] (RW)
 *
 * In DDR 4-bit mode nibble position indictation. 0- the sequence is 'odd high
 * nibble -> even high nibble -> odd low nibble -> even low nibble'; 1- the
 * sequence is 'odd high nibble -> odd low nibble -> even high nibble -> even low
 * nibble'.
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_NIBBLE_POS (6U)  /*!< Bit position for uSDHC_MIX_CTRL_NIBBLE_POS. */
#define BM_uSDHC_MIX_CTRL_NIBBLE_POS (0x00000040U) /*!< Bit mask for uSDHC_MIX_CTRL_NIBBLE_POS. */
#define BS_uSDHC_MIX_CTRL_NIBBLE_POS (1U)  /*!< Bit field size in bits for uSDHC_MIX_CTRL_NIBBLE_POS. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_NIBBLE_POS field. */
#define BR_uSDHC_MIX_CTRL_NIBBLE_POS(x) (HW_uSDHC_MIX_CTRL(x).B.NIBBLE_POS)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_NIBBLE_POS. */
#define BF_uSDHC_MIX_CTRL_NIBBLE_POS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_NIBBLE_POS) & BM_uSDHC_MIX_CTRL_NIBBLE_POS)

/*! @brief Set the NIBBLE_POS field to a new value. */
#define BW_uSDHC_MIX_CTRL_NIBBLE_POS(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_NIBBLE_POS) | BF_uSDHC_MIX_CTRL_NIBBLE_POS(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field AC23EN[7] (RW)
 *
 * When this bit is set to 1, the Host Controller issues a CMD23 automatically
 * before issuing a command specified in the Command Register.
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_AC23EN (7U)      /*!< Bit position for uSDHC_MIX_CTRL_AC23EN. */
#define BM_uSDHC_MIX_CTRL_AC23EN (0x00000080U) /*!< Bit mask for uSDHC_MIX_CTRL_AC23EN. */
#define BS_uSDHC_MIX_CTRL_AC23EN (1U)      /*!< Bit field size in bits for uSDHC_MIX_CTRL_AC23EN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_AC23EN field. */
#define BR_uSDHC_MIX_CTRL_AC23EN(x) (HW_uSDHC_MIX_CTRL(x).B.AC23EN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_AC23EN. */
#define BF_uSDHC_MIX_CTRL_AC23EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_AC23EN) & BM_uSDHC_MIX_CTRL_AC23EN)

/*! @brief Set the AC23EN field to a new value. */
#define BW_uSDHC_MIX_CTRL_AC23EN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_AC23EN) | BF_uSDHC_MIX_CTRL_AC23EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field EXE_TUNE[22] (RW)
 *
 * This bit is set to 1 to indicate the Host Driver is starting tuning
 * procedure. Tuning procedure is aborted by writing 0.
 *
 * Values:
 * - 1 - Execute Tuning
 * - 0 - Not Tuned or Tuning Completed
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_EXE_TUNE (22U)   /*!< Bit position for uSDHC_MIX_CTRL_EXE_TUNE. */
#define BM_uSDHC_MIX_CTRL_EXE_TUNE (0x00400000U) /*!< Bit mask for uSDHC_MIX_CTRL_EXE_TUNE. */
#define BS_uSDHC_MIX_CTRL_EXE_TUNE (1U)    /*!< Bit field size in bits for uSDHC_MIX_CTRL_EXE_TUNE. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_EXE_TUNE field. */
#define BR_uSDHC_MIX_CTRL_EXE_TUNE(x) (HW_uSDHC_MIX_CTRL(x).B.EXE_TUNE)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_EXE_TUNE. */
#define BF_uSDHC_MIX_CTRL_EXE_TUNE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_EXE_TUNE) & BM_uSDHC_MIX_CTRL_EXE_TUNE)

/*! @brief Set the EXE_TUNE field to a new value. */
#define BW_uSDHC_MIX_CTRL_EXE_TUNE(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_EXE_TUNE) | BF_uSDHC_MIX_CTRL_EXE_TUNE(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field SMP_CLK_SEL[23] (RW)
 *
 * Tuned clock or Fixed clock is used to sample data / cmd (Only used for SD3.0,
 * SDR104 mode)
 *
 * Values:
 * - 1 - Tuned clock is used to sample data / cmd
 * - 0 - Fixed clock is used to sample data / cmd
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_SMP_CLK_SEL (23U) /*!< Bit position for uSDHC_MIX_CTRL_SMP_CLK_SEL. */
#define BM_uSDHC_MIX_CTRL_SMP_CLK_SEL (0x00800000U) /*!< Bit mask for uSDHC_MIX_CTRL_SMP_CLK_SEL. */
#define BS_uSDHC_MIX_CTRL_SMP_CLK_SEL (1U) /*!< Bit field size in bits for uSDHC_MIX_CTRL_SMP_CLK_SEL. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_SMP_CLK_SEL field. */
#define BR_uSDHC_MIX_CTRL_SMP_CLK_SEL(x) (HW_uSDHC_MIX_CTRL(x).B.SMP_CLK_SEL)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_SMP_CLK_SEL. */
#define BF_uSDHC_MIX_CTRL_SMP_CLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_SMP_CLK_SEL) & BM_uSDHC_MIX_CTRL_SMP_CLK_SEL)

/*! @brief Set the SMP_CLK_SEL field to a new value. */
#define BW_uSDHC_MIX_CTRL_SMP_CLK_SEL(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_SMP_CLK_SEL) | BF_uSDHC_MIX_CTRL_SMP_CLK_SEL(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field AUTO_TUNE_EN[24] (RW)
 *
 * Values:
 * - 1 - Enable auto tuning
 * - 0 - Disable auto tuning
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_AUTO_TUNE_EN (24U) /*!< Bit position for uSDHC_MIX_CTRL_AUTO_TUNE_EN. */
#define BM_uSDHC_MIX_CTRL_AUTO_TUNE_EN (0x01000000U) /*!< Bit mask for uSDHC_MIX_CTRL_AUTO_TUNE_EN. */
#define BS_uSDHC_MIX_CTRL_AUTO_TUNE_EN (1U) /*!< Bit field size in bits for uSDHC_MIX_CTRL_AUTO_TUNE_EN. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_AUTO_TUNE_EN field. */
#define BR_uSDHC_MIX_CTRL_AUTO_TUNE_EN(x) (HW_uSDHC_MIX_CTRL(x).B.AUTO_TUNE_EN)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_AUTO_TUNE_EN. */
#define BF_uSDHC_MIX_CTRL_AUTO_TUNE_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_AUTO_TUNE_EN) & BM_uSDHC_MIX_CTRL_AUTO_TUNE_EN)

/*! @brief Set the AUTO_TUNE_EN field to a new value. */
#define BW_uSDHC_MIX_CTRL_AUTO_TUNE_EN(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_AUTO_TUNE_EN) | BF_uSDHC_MIX_CTRL_AUTO_TUNE_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MIX_CTRL, field FBCLK_SEL[25] (RW)
 *
 * Values:
 * - 1 - Feedback clock comes from the ipp_card_clk_out
 * - 0 - Feedback clock comes from the loopback CLK
 */
/*@{*/
#define BP_uSDHC_MIX_CTRL_FBCLK_SEL (25U)  /*!< Bit position for uSDHC_MIX_CTRL_FBCLK_SEL. */
#define BM_uSDHC_MIX_CTRL_FBCLK_SEL (0x02000000U) /*!< Bit mask for uSDHC_MIX_CTRL_FBCLK_SEL. */
#define BS_uSDHC_MIX_CTRL_FBCLK_SEL (1U)   /*!< Bit field size in bits for uSDHC_MIX_CTRL_FBCLK_SEL. */

/*! @brief Read current value of the uSDHC_MIX_CTRL_FBCLK_SEL field. */
#define BR_uSDHC_MIX_CTRL_FBCLK_SEL(x) (HW_uSDHC_MIX_CTRL(x).B.FBCLK_SEL)

/*! @brief Format value for bitfield uSDHC_MIX_CTRL_FBCLK_SEL. */
#define BF_uSDHC_MIX_CTRL_FBCLK_SEL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MIX_CTRL_FBCLK_SEL) & BM_uSDHC_MIX_CTRL_FBCLK_SEL)

/*! @brief Set the FBCLK_SEL field to a new value. */
#define BW_uSDHC_MIX_CTRL_FBCLK_SEL(x, v) (HW_uSDHC_MIX_CTRL_WR(x, (HW_uSDHC_MIX_CTRL_RD(x) & ~BM_uSDHC_MIX_CTRL_FBCLK_SEL) | BF_uSDHC_MIX_CTRL_FBCLK_SEL(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_FORCE_EVENT - Force Event
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_FORCE_EVENT - Force Event (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Force Event Register is not a physically implemented register. Rather, it
 * is an address at which the Interrupt Status Register can be written if the
 * corresponding bit of the Interrupt Status Enable Register is set. This register
 * is a write only register and writing 0 to it has no effect. Writing 1 to this
 * register actually sets the corresponding bit of Interrupt Status Register. A
 * read from this register always results in 0's. In order to change the
 * corresponding status bits in the Interrupt Status Register, make sure to set IPGEN bit
 * in System Control Register so that IPG_CLK is always active. Forcing a card
 * interrupt will generate a short pulse on the DATA1 line, and the driver may
 * treat this interrupt as a normal interrupt. The interrupt service routine may skip
 * polling the card interrupt factor as the interrupt is self cleared.
 */
typedef union _hw_usdhc_force_event
{
    uint32_t U;
    struct _hw_usdhc_force_event_bitfields
    {
        uint32_t FEVTAC12NE : 1;       /*!< [0] Force Event Auto Command 12 Not
                                        * Executed */
        uint32_t FEVTAC12TOE : 1;      /*!< [1] Force Event Auto Command 12 Time
                                        * Out Error */
        uint32_t FEVTAC12CE : 1;       /*!< [2] Force Event Auto Command 12 CRC
                                        * Error */
        uint32_t FEVTAC12EBE : 1;      /*!< [3] Force Event Auto Command 12 End
                                        * Bit Error */
        uint32_t FEVTAC12IE : 1;       /*!< [4] Force Event Auto Command 12 Index
                                        * Error */
        uint32_t RESERVED0 : 2;        /*!< [6:5]  */
        uint32_t FEVTCNIBAC12E : 1;    /*!< [7] Force Event Command Not Executed
                                        * By Auto Command 12 Error */
        uint32_t RESERVED1 : 8;        /*!< [15:8]  */
        uint32_t FEVTCTOE : 1;         /*!< [16] Force Event Command Time Out Error */
        uint32_t FEVTCCE : 1;          /*!< [17] Force Event Command CRC Error */
        uint32_t FEVTCEBE : 1;         /*!< [18] Force Event Command End Bit Error */
        uint32_t FEVTCIE : 1;          /*!< [19] Force Event Command Index Error */
        uint32_t FEVTDTOE : 1;         /*!< [20] Force Event Data Time Out Error */
        uint32_t FEVTDCE : 1;          /*!< [21] Force Event Data CRC Error */
        uint32_t FEVTDEBE : 1;         /*!< [22] Force Event Data End Bit Error */
        uint32_t RESERVED2 : 1;        /*!< [23]  */
        uint32_t FEVTAC12E : 1;        /*!< [24] Force Event Auto Command 12 Error */
        uint32_t RESERVED3 : 1;        /*!< [25]  */
        uint32_t FEVTTNE : 1;          /*!< [26] Force Tuning Error */
        uint32_t RESERVED4 : 1;        /*!< [27]  */
        uint32_t FEVTDMAE : 1;         /*!< [28] Force Event DMA Error */
        uint32_t RESERVED5 : 2;        /*!< [30:29]  */
        uint32_t FEVTCINT : 1;         /*!< [31] Force Event Card Interrupt */
    } B;
} hw_usdhc_force_event_t;

/*!
 * @name Constants and macros for entire uSDHC_FORCE_EVENT register
 */
/*@{*/
#define HW_uSDHC_FORCE_EVENT_ADDR(x) ((uintptr_t)(x) + 0x50U)

#define HW_uSDHC_FORCE_EVENT(x)  (*(__IO hw_usdhc_force_event_t *) HW_uSDHC_FORCE_EVENT_ADDR(x))
#define HW_uSDHC_FORCE_EVENT_RD(x) (HW_uSDHC_FORCE_EVENT(x).U)
#define HW_uSDHC_FORCE_EVENT_WR(x, v) (HW_uSDHC_FORCE_EVENT(x).U = (v))
#define HW_uSDHC_FORCE_EVENT_SET(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, HW_uSDHC_FORCE_EVENT_RD(x) |  (v)))
#define HW_uSDHC_FORCE_EVENT_CLR(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, HW_uSDHC_FORCE_EVENT_RD(x) & ~(v)))
#define HW_uSDHC_FORCE_EVENT_TOG(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, HW_uSDHC_FORCE_EVENT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_FORCE_EVENT bitfields
 */

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12NE[0] (WORZ)
 *
 * Forces the AC12NE bit in the Auto Command12 Error Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12NE (0U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12NE. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12NE (0x00000001U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12NE. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12NE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12NE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12NE. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12NE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12NE) & BM_uSDHC_FORCE_EVENT_FEVTAC12NE)

/*! @brief Set the FEVTAC12NE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12NE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12NE) | BF_uSDHC_FORCE_EVENT_FEVTAC12NE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12TOE[1] (WORZ)
 *
 * Forces the AC12TOE bit in the Auto Command12 Error Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12TOE (1U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12TOE. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12TOE (0x00000002U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12TOE. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12TOE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12TOE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12TOE. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12TOE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12TOE) & BM_uSDHC_FORCE_EVENT_FEVTAC12TOE)

/*! @brief Set the FEVTAC12TOE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12TOE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12TOE) | BF_uSDHC_FORCE_EVENT_FEVTAC12TOE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12CE[2] (WORZ)
 *
 * Forces the AC12CE bit in the Auto Command12 Error Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12CE (2U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12CE. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12CE (0x00000004U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12CE. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12CE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12CE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12CE. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12CE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12CE) & BM_uSDHC_FORCE_EVENT_FEVTAC12CE)

/*! @brief Set the FEVTAC12CE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12CE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12CE) | BF_uSDHC_FORCE_EVENT_FEVTAC12CE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12EBE[3] (WORZ)
 *
 * Forces the AC12EBE bit in the Auto Command12 Error Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12EBE (3U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12EBE. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12EBE (0x00000008U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12EBE. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12EBE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12EBE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12EBE. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12EBE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12EBE) & BM_uSDHC_FORCE_EVENT_FEVTAC12EBE)

/*! @brief Set the FEVTAC12EBE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12EBE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12EBE) | BF_uSDHC_FORCE_EVENT_FEVTAC12EBE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12IE[4] (WORZ)
 *
 * Forces the AC12IE bit in the Auto Command12 Error Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12IE (4U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12IE. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12IE (0x00000010U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12IE. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12IE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12IE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12IE. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12IE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12IE) & BM_uSDHC_FORCE_EVENT_FEVTAC12IE)

/*! @brief Set the FEVTAC12IE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12IE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12IE) | BF_uSDHC_FORCE_EVENT_FEVTAC12IE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCNIBAC12E[7] (WORZ)
 *
 * Forces the CNIBAC12E bit in the Auto Command12 Error Status Register to be
 * set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCNIBAC12E (7U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCNIBAC12E. */
#define BM_uSDHC_FORCE_EVENT_FEVTCNIBAC12E (0x00000080U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCNIBAC12E. */
#define BS_uSDHC_FORCE_EVENT_FEVTCNIBAC12E (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCNIBAC12E. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCNIBAC12E. */
#define BF_uSDHC_FORCE_EVENT_FEVTCNIBAC12E(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCNIBAC12E) & BM_uSDHC_FORCE_EVENT_FEVTCNIBAC12E)

/*! @brief Set the FEVTCNIBAC12E field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCNIBAC12E(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCNIBAC12E) | BF_uSDHC_FORCE_EVENT_FEVTCNIBAC12E(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCTOE[16] (WORZ)
 *
 * Forces the CTOE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCTOE (16U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCTOE. */
#define BM_uSDHC_FORCE_EVENT_FEVTCTOE (0x00010000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCTOE. */
#define BS_uSDHC_FORCE_EVENT_FEVTCTOE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCTOE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCTOE. */
#define BF_uSDHC_FORCE_EVENT_FEVTCTOE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCTOE) & BM_uSDHC_FORCE_EVENT_FEVTCTOE)

/*! @brief Set the FEVTCTOE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCTOE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCTOE) | BF_uSDHC_FORCE_EVENT_FEVTCTOE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCCE[17] (WORZ)
 *
 * Forces the CCE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCCE (17U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCCE. */
#define BM_uSDHC_FORCE_EVENT_FEVTCCE (0x00020000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCCE. */
#define BS_uSDHC_FORCE_EVENT_FEVTCCE (1U)  /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCCE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCCE. */
#define BF_uSDHC_FORCE_EVENT_FEVTCCE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCCE) & BM_uSDHC_FORCE_EVENT_FEVTCCE)

/*! @brief Set the FEVTCCE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCCE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCCE) | BF_uSDHC_FORCE_EVENT_FEVTCCE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCEBE[18] (WORZ)
 *
 * Forces the CEBE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCEBE (18U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCEBE. */
#define BM_uSDHC_FORCE_EVENT_FEVTCEBE (0x00040000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCEBE. */
#define BS_uSDHC_FORCE_EVENT_FEVTCEBE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCEBE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCEBE. */
#define BF_uSDHC_FORCE_EVENT_FEVTCEBE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCEBE) & BM_uSDHC_FORCE_EVENT_FEVTCEBE)

/*! @brief Set the FEVTCEBE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCEBE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCEBE) | BF_uSDHC_FORCE_EVENT_FEVTCEBE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCIE[19] (WORZ)
 *
 * Forces the CCE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCIE (19U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCIE. */
#define BM_uSDHC_FORCE_EVENT_FEVTCIE (0x00080000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCIE. */
#define BS_uSDHC_FORCE_EVENT_FEVTCIE (1U)  /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCIE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCIE. */
#define BF_uSDHC_FORCE_EVENT_FEVTCIE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCIE) & BM_uSDHC_FORCE_EVENT_FEVTCIE)

/*! @brief Set the FEVTCIE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCIE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCIE) | BF_uSDHC_FORCE_EVENT_FEVTCIE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTDTOE[20] (WORZ)
 *
 * Force the DTOE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTDTOE (20U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTDTOE. */
#define BM_uSDHC_FORCE_EVENT_FEVTDTOE (0x00100000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTDTOE. */
#define BS_uSDHC_FORCE_EVENT_FEVTDTOE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTDTOE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTDTOE. */
#define BF_uSDHC_FORCE_EVENT_FEVTDTOE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTDTOE) & BM_uSDHC_FORCE_EVENT_FEVTDTOE)

/*! @brief Set the FEVTDTOE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTDTOE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTDTOE) | BF_uSDHC_FORCE_EVENT_FEVTDTOE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTDCE[21] (WORZ)
 *
 * Forces the DCE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTDCE (21U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTDCE. */
#define BM_uSDHC_FORCE_EVENT_FEVTDCE (0x00200000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTDCE. */
#define BS_uSDHC_FORCE_EVENT_FEVTDCE (1U)  /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTDCE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTDCE. */
#define BF_uSDHC_FORCE_EVENT_FEVTDCE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTDCE) & BM_uSDHC_FORCE_EVENT_FEVTDCE)

/*! @brief Set the FEVTDCE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTDCE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTDCE) | BF_uSDHC_FORCE_EVENT_FEVTDCE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTDEBE[22] (WORZ)
 *
 * Forces the DEBE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTDEBE (22U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTDEBE. */
#define BM_uSDHC_FORCE_EVENT_FEVTDEBE (0x00400000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTDEBE. */
#define BS_uSDHC_FORCE_EVENT_FEVTDEBE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTDEBE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTDEBE. */
#define BF_uSDHC_FORCE_EVENT_FEVTDEBE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTDEBE) & BM_uSDHC_FORCE_EVENT_FEVTDEBE)

/*! @brief Set the FEVTDEBE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTDEBE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTDEBE) | BF_uSDHC_FORCE_EVENT_FEVTDEBE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTAC12E[24] (WORZ)
 *
 * Forces the AC12E bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTAC12E (24U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTAC12E. */
#define BM_uSDHC_FORCE_EVENT_FEVTAC12E (0x01000000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTAC12E. */
#define BS_uSDHC_FORCE_EVENT_FEVTAC12E (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTAC12E. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTAC12E. */
#define BF_uSDHC_FORCE_EVENT_FEVTAC12E(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTAC12E) & BM_uSDHC_FORCE_EVENT_FEVTAC12E)

/*! @brief Set the FEVTAC12E field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTAC12E(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTAC12E) | BF_uSDHC_FORCE_EVENT_FEVTAC12E(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTTNE[26] (WORZ)
 *
 * Forces the TNE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTTNE (26U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTTNE. */
#define BM_uSDHC_FORCE_EVENT_FEVTTNE (0x04000000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTTNE. */
#define BS_uSDHC_FORCE_EVENT_FEVTTNE (1U)  /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTTNE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTTNE. */
#define BF_uSDHC_FORCE_EVENT_FEVTTNE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTTNE) & BM_uSDHC_FORCE_EVENT_FEVTTNE)

/*! @brief Set the FEVTTNE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTTNE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTTNE) | BF_uSDHC_FORCE_EVENT_FEVTTNE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTDMAE[28] (WORZ)
 *
 * Forces the DMAE bit of Interrupt Status Register to be set.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTDMAE (28U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTDMAE. */
#define BM_uSDHC_FORCE_EVENT_FEVTDMAE (0x10000000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTDMAE. */
#define BS_uSDHC_FORCE_EVENT_FEVTDMAE (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTDMAE. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTDMAE. */
#define BF_uSDHC_FORCE_EVENT_FEVTDMAE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTDMAE) & BM_uSDHC_FORCE_EVENT_FEVTDMAE)

/*! @brief Set the FEVTDMAE field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTDMAE(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTDMAE) | BF_uSDHC_FORCE_EVENT_FEVTDMAE(v)))
/*@}*/

/*!
 * @name Register uSDHC_FORCE_EVENT, field FEVTCINT[31] (WORZ)
 *
 * Writing 1 to this bit generates a short low-level pulse on the internal DATA1
 * line, as if a self clearing interrupt was received from the external card. If
 * enabled, the CINT bit will be set and the interrupt service routine may treat
 * this interrupt as a normal interrupt from the external card.
 */
/*@{*/
#define BP_uSDHC_FORCE_EVENT_FEVTCINT (31U) /*!< Bit position for uSDHC_FORCE_EVENT_FEVTCINT. */
#define BM_uSDHC_FORCE_EVENT_FEVTCINT (0x80000000U) /*!< Bit mask for uSDHC_FORCE_EVENT_FEVTCINT. */
#define BS_uSDHC_FORCE_EVENT_FEVTCINT (1U) /*!< Bit field size in bits for uSDHC_FORCE_EVENT_FEVTCINT. */

/*! @brief Format value for bitfield uSDHC_FORCE_EVENT_FEVTCINT. */
#define BF_uSDHC_FORCE_EVENT_FEVTCINT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_FORCE_EVENT_FEVTCINT) & BM_uSDHC_FORCE_EVENT_FEVTCINT)

/*! @brief Set the FEVTCINT field to a new value. */
#define BW_uSDHC_FORCE_EVENT_FEVTCINT(x, v) (HW_uSDHC_FORCE_EVENT_WR(x, (HW_uSDHC_FORCE_EVENT_RD(x) & ~BM_uSDHC_FORCE_EVENT_FEVTCINT) | BF_uSDHC_FORCE_EVENT_FEVTCINT(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_ADMA_ERR_STATUS - ADMA Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_ADMA_ERR_STATUS - ADMA Error Status Register (RO)
 *
 * Reset value: 0x00000000U
 *
 * When an ADMA Error Interrupt has occurred, the ADMA Error States field in
 * this register holds the ADMA state and the ADMA System Address register holds the
 * address around the error descriptor. For recovering from this error, the Host
 * Driver requires the ADMA state to identify the error descriptor address as
 * follows: ST_STOP: Previous location set in the ADMA System Address register is
 * the error descriptor address. ST_FDS: Current location set in the ADMA System
 * Address register is the error descriptor address. ST_CADR: This state is never
 * set because it only increments the descriptor pointer and doesn't generate an
 * ADMA error. ST_TFR: Previous location set in the ADMA System Address register
 * is the error descriptor address. In case of a write operation, the Host Driver
 * should use the ACMD22 to get the number of the written block, rather than
 * using this information, since unwritten data may exist in the Host Controller.
 * The Host Controller generates the ADMA Error Interrupt when it detects invalid
 * descriptor data (Valid=0) in the ST_FDS state. The Host Driver can distinguish
 * this error by reading the Valid bit of the error descriptor. ADMA Error State
 * Coding D01-D00 ADMA Error State (when error has occurred) Contents of ADMA
 * System Address Register 00 ST_STOP (Stop DMA) Holds the address of the next
 * executable Descriptor command 01 ST_FDS (Fetch Descriptor) Holds the valid
 * Descriptor address 10 ST_CADR (Change Address) No ADMA Error is generated 11 ST_TFR
 * (Transfer Data) Holds the address of the next executable Descriptor command
 */
typedef union _hw_usdhc_adma_err_status
{
    uint32_t U;
    struct _hw_usdhc_adma_err_status_bitfields
    {
        uint32_t ADMAES : 2;           /*!< [1:0] ADMA Error State (when ADMA Error is
                                        * occurred) */
        uint32_t ADMALME : 1;          /*!< [2] ADMA Length Mismatch Error */
        uint32_t ADMADCE : 1;          /*!< [3] ADMA Descritor Error */
        uint32_t RESERVED0 : 28;       /*!< [31:4]  */
    } B;
} hw_usdhc_adma_err_status_t;

/*!
 * @name Constants and macros for entire uSDHC_ADMA_ERR_STATUS register
 */
/*@{*/
#define HW_uSDHC_ADMA_ERR_STATUS_ADDR(x) ((uintptr_t)(x) + 0x54U)

#define HW_uSDHC_ADMA_ERR_STATUS(x) (*(__I hw_usdhc_adma_err_status_t *) HW_uSDHC_ADMA_ERR_STATUS_ADDR(x))
#define HW_uSDHC_ADMA_ERR_STATUS_RD(x) (HW_uSDHC_ADMA_ERR_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_ADMA_ERR_STATUS bitfields
 */

/*!
 * @name Register uSDHC_ADMA_ERR_STATUS, field ADMAES[1:0] (RO)
 *
 * This field indicates the state of the ADMA when an error has occurred during
 * an ADMA data transfer. Refer to ADMA_ERR_STATUSADMA Error Status Register for
 * more details.
 */
/*@{*/
#define BP_uSDHC_ADMA_ERR_STATUS_ADMAES (0U) /*!< Bit position for uSDHC_ADMA_ERR_STATUS_ADMAES. */
#define BM_uSDHC_ADMA_ERR_STATUS_ADMAES (0x00000003U) /*!< Bit mask for uSDHC_ADMA_ERR_STATUS_ADMAES. */
#define BS_uSDHC_ADMA_ERR_STATUS_ADMAES (2U) /*!< Bit field size in bits for uSDHC_ADMA_ERR_STATUS_ADMAES. */

/*! @brief Read current value of the uSDHC_ADMA_ERR_STATUS_ADMAES field. */
#define BR_uSDHC_ADMA_ERR_STATUS_ADMAES(x) (HW_uSDHC_ADMA_ERR_STATUS(x).B.ADMAES)
/*@}*/

/*!
 * @name Register uSDHC_ADMA_ERR_STATUS, field ADMALME[2] (RO)
 *
 * This error occurs in the following 2 cases: While the Block Count Enable is
 * being set, the total data length specified by the Descriptor table is different
 * from that specified by the Block Count and Block Length. Total data length
 * cannot be divided by the block length.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_ADMA_ERR_STATUS_ADMALME (2U) /*!< Bit position for uSDHC_ADMA_ERR_STATUS_ADMALME. */
#define BM_uSDHC_ADMA_ERR_STATUS_ADMALME (0x00000004U) /*!< Bit mask for uSDHC_ADMA_ERR_STATUS_ADMALME. */
#define BS_uSDHC_ADMA_ERR_STATUS_ADMALME (1U) /*!< Bit field size in bits for uSDHC_ADMA_ERR_STATUS_ADMALME. */

/*! @brief Read current value of the uSDHC_ADMA_ERR_STATUS_ADMALME field. */
#define BR_uSDHC_ADMA_ERR_STATUS_ADMALME(x) (HW_uSDHC_ADMA_ERR_STATUS(x).B.ADMALME)
/*@}*/

/*!
 * @name Register uSDHC_ADMA_ERR_STATUS, field ADMADCE[3] (RO)
 *
 * This error occurs when invalid descriptor fetched by ADMA.
 *
 * Values:
 * - 1 - Error
 * - 0 - No Error
 */
/*@{*/
#define BP_uSDHC_ADMA_ERR_STATUS_ADMADCE (3U) /*!< Bit position for uSDHC_ADMA_ERR_STATUS_ADMADCE. */
#define BM_uSDHC_ADMA_ERR_STATUS_ADMADCE (0x00000008U) /*!< Bit mask for uSDHC_ADMA_ERR_STATUS_ADMADCE. */
#define BS_uSDHC_ADMA_ERR_STATUS_ADMADCE (1U) /*!< Bit field size in bits for uSDHC_ADMA_ERR_STATUS_ADMADCE. */

/*! @brief Read current value of the uSDHC_ADMA_ERR_STATUS_ADMADCE field. */
#define BR_uSDHC_ADMA_ERR_STATUS_ADMADCE(x) (HW_uSDHC_ADMA_ERR_STATUS(x).B.ADMADCE)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_ADMA_SYS_ADDR - ADMA System Address
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_ADMA_SYS_ADDR - ADMA System Address (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the physical system memory address used for ADMA
 * transfers.
 */
typedef union _hw_usdhc_adma_sys_addr
{
    uint32_t U;
    struct _hw_usdhc_adma_sys_addr_bitfields
    {
        uint32_t RESERVED0 : 2;        /*!< [1:0]  */
        uint32_t ADS_ADDR : 30;        /*!< [31:2] ADMA System Address */
    } B;
} hw_usdhc_adma_sys_addr_t;

/*!
 * @name Constants and macros for entire uSDHC_ADMA_SYS_ADDR register
 */
/*@{*/
#define HW_uSDHC_ADMA_SYS_ADDR_ADDR(x) ((uintptr_t)(x) + 0x58U)

#define HW_uSDHC_ADMA_SYS_ADDR(x) (*(__IO hw_usdhc_adma_sys_addr_t *) HW_uSDHC_ADMA_SYS_ADDR_ADDR(x))
#define HW_uSDHC_ADMA_SYS_ADDR_RD(x) (HW_uSDHC_ADMA_SYS_ADDR(x).U)
#define HW_uSDHC_ADMA_SYS_ADDR_WR(x, v) (HW_uSDHC_ADMA_SYS_ADDR(x).U = (v))
#define HW_uSDHC_ADMA_SYS_ADDR_SET(x, v) (HW_uSDHC_ADMA_SYS_ADDR_WR(x, HW_uSDHC_ADMA_SYS_ADDR_RD(x) |  (v)))
#define HW_uSDHC_ADMA_SYS_ADDR_CLR(x, v) (HW_uSDHC_ADMA_SYS_ADDR_WR(x, HW_uSDHC_ADMA_SYS_ADDR_RD(x) & ~(v)))
#define HW_uSDHC_ADMA_SYS_ADDR_TOG(x, v) (HW_uSDHC_ADMA_SYS_ADDR_WR(x, HW_uSDHC_ADMA_SYS_ADDR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_ADMA_SYS_ADDR bitfields
 */

/*!
 * @name Register uSDHC_ADMA_SYS_ADDR, field ADS_ADDR[31:2] (RW)
 *
 * This register holds the word address of the executing command in the
 * Descriptor table. At the start of ADMA, the Host Driver shall set the start address of
 * the Descriptor table. The ADMA engine increments this register address
 * whenever fetching a Descriptor command. When the ADMA is stopped at the Block Gap,
 * this register indicates the address of the next executable Descriptor command.
 * When the ADMA Error Interrupt is generated, this register shall hold the valid
 * Descriptor address depending on the ADMA state. The lower 2 bits of this
 * register is tied to '0' so the ADMA address is always word aligned. Since this
 * register supports dynamic address reflecting, when TC bit is set, it
 * automatically alters the value of internal address counter, so SW cannot change this
 * register when TC bit is set. Such restriction is also listed in Software
 * Restrictions .
 */
/*@{*/
#define BP_uSDHC_ADMA_SYS_ADDR_ADS_ADDR (2U) /*!< Bit position for uSDHC_ADMA_SYS_ADDR_ADS_ADDR. */
#define BM_uSDHC_ADMA_SYS_ADDR_ADS_ADDR (0xFFFFFFFCU) /*!< Bit mask for uSDHC_ADMA_SYS_ADDR_ADS_ADDR. */
#define BS_uSDHC_ADMA_SYS_ADDR_ADS_ADDR (30U) /*!< Bit field size in bits for uSDHC_ADMA_SYS_ADDR_ADS_ADDR. */

/*! @brief Read current value of the uSDHC_ADMA_SYS_ADDR_ADS_ADDR field. */
#define BR_uSDHC_ADMA_SYS_ADDR_ADS_ADDR(x) (HW_uSDHC_ADMA_SYS_ADDR(x).B.ADS_ADDR)

/*! @brief Format value for bitfield uSDHC_ADMA_SYS_ADDR_ADS_ADDR. */
#define BF_uSDHC_ADMA_SYS_ADDR_ADS_ADDR(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_ADMA_SYS_ADDR_ADS_ADDR) & BM_uSDHC_ADMA_SYS_ADDR_ADS_ADDR)

/*! @brief Set the ADS_ADDR field to a new value. */
#define BW_uSDHC_ADMA_SYS_ADDR_ADS_ADDR(x, v) (HW_uSDHC_ADMA_SYS_ADDR_WR(x, (HW_uSDHC_ADMA_SYS_ADDR_RD(x) & ~BM_uSDHC_ADMA_SYS_ADDR_ADS_ADDR) | BF_uSDHC_ADMA_SYS_ADDR_ADS_ADDR(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_DLL_CTRL - DLL (Delay Line) Control
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_DLL_CTRL - DLL (Delay Line) Control (RW)
 *
 * Reset value: 0x00000200U
 *
 * This register contains control bits for DLL.
 */
typedef union _hw_usdhc_dll_ctrl
{
    uint32_t U;
    struct _hw_usdhc_dll_ctrl_bitfields
    {
        uint32_t DLL_CTRL_ENABLE : 1;  /*!< [0]  */
        uint32_t DLL_CTRL_RESET : 1;   /*!< [1]  */
        uint32_t DLL_CTRL_SLV_FORCE_UPD : 1; /*!< [2]  */
        uint32_t DLL_CTRL_SLV_DLY_TARGET0 : 4; /*!< [6:3]  */
        uint32_t DLL_CTRL_GATE_UPDATE : 1; /*!< [7]  */
        uint32_t DLL_CTRL_SLV_OVERRIDE : 1; /*!< [8]  */
        uint32_t DLL_CTRL_SLV_OVERRIDE_VAL : 7; /*!< [15:9]  */
        uint32_t DLL_CTRL_SLV_DLY_TARGET1 : 3; /*!< [18:16]  */
        uint32_t RESERVED0 : 1;        /*!< [19]  */
        uint32_t DLL_CTRL_SLV_UPDATE_INT : 8; /*!< [27:20]  */
        uint32_t DLL_CTRL_REF_UPDATE_INT : 4; /*!< [31:28]  */
    } B;
} hw_usdhc_dll_ctrl_t;

/*!
 * @name Constants and macros for entire uSDHC_DLL_CTRL register
 */
/*@{*/
#define HW_uSDHC_DLL_CTRL_ADDR(x) ((uintptr_t)(x) + 0x60U)

#define HW_uSDHC_DLL_CTRL(x)     (*(__IO hw_usdhc_dll_ctrl_t *) HW_uSDHC_DLL_CTRL_ADDR(x))
#define HW_uSDHC_DLL_CTRL_RD(x)  (HW_uSDHC_DLL_CTRL(x).U)
#define HW_uSDHC_DLL_CTRL_WR(x, v) (HW_uSDHC_DLL_CTRL(x).U = (v))
#define HW_uSDHC_DLL_CTRL_SET(x, v) (HW_uSDHC_DLL_CTRL_WR(x, HW_uSDHC_DLL_CTRL_RD(x) |  (v)))
#define HW_uSDHC_DLL_CTRL_CLR(x, v) (HW_uSDHC_DLL_CTRL_WR(x, HW_uSDHC_DLL_CTRL_RD(x) & ~(v)))
#define HW_uSDHC_DLL_CTRL_TOG(x, v) (HW_uSDHC_DLL_CTRL_WR(x, HW_uSDHC_DLL_CTRL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_DLL_CTRL bitfields
 */

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_ENABLE[0] (RW)
 *
 * Set this bit to 1 to enable the DLL and delay chain; otherwise; set to 0 to
 * bypasses DLL. Note that using the slave delay line override feature with
 * SLV_OVERRIDE and SLV_OVERRIDE VAL, the DLL does not need to be enabled.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE (0U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_ENABLE. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE (0x00000001U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_ENABLE. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE (1U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_ENABLE. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_ENABLE field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_ENABLE)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_ENABLE. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE) & BM_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE)

/*! @brief Set the DLL_CTRL_ENABLE field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE) | BF_uSDHC_DLL_CTRL_DLL_CTRL_ENABLE(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_RESET[1] (RW)
 *
 * Setting this bit to 1 force a reset on DLL. This will cause the DLL to lose
 * lock and re-calibrate to detect an REF_CLOCK half period phase shift. This
 * signal is used by the DLL as edge-sensitive, so in order to create a subsequent
 * reset, RESET must be taken low and then asserted again.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_RESET (1U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_RESET. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_RESET (0x00000002U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_RESET. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_RESET (1U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_RESET. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_RESET field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_RESET(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_RESET)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_RESET. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_RESET(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_RESET) & BM_uSDHC_DLL_CTRL_DLL_CTRL_RESET)

/*! @brief Set the DLL_CTRL_RESET field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_RESET(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_RESET) | BF_uSDHC_DLL_CTRL_DLL_CTRL_RESET(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_FORCE_UPD[2] (RW)
 *
 * Setting this bit to 1, forces the slave delay line to update to the DLL
 * calibrated value immediately. The slave delay line shall update automatically based
 * on the SLV_UPDATE_INT interval or when a DLL lock condition is sensed.
 * Subsequent forcing of the slave-line update can only occur if SLV_FORCE_UP is set
 * back to 0 and then asserted again (edge triggered). Be sure to use it when uSDHC
 * is idle. This function may not work when uSDHC is working on data / cmd /
 * response.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD (2U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD (0x00000004U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD (1U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_FORCE_UPD)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD)

/*! @brief Set the DLL_CTRL_SLV_FORCE_UPD field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_FORCE_UPD(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_DLY_TARGET0[6:3] (RW)
 *
 * The delay target for the uSDHC loopback read clock can be programmed in
 * 1/16th increments of an ref_clock half-period. The delay is
 * ((DLL_CTRL_SLV_DLY_TARGET1 +1)* REF_CLOCK / 2) / 16 So the input read-clock can be delayed relative
 * input data from (REF_CLOCK / 2) / 16 to REF_CLOCK * 4.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0 (3U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0 (0x00000078U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0 (4U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0 field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_DLY_TARGET0)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0)

/*! @brief Set the DLL_CTRL_SLV_DLY_TARGET0 field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET0(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_GATE_UPDATE[7] (RW)
 *
 * Set this bit to 1 to prevent the DLL from updating (since when clock_in
 * exists, glitches may appear during DLL updates). This bit may be used by software
 * if such a condition occurs. Clear the bit to 0 to allow the DLL to update
 * automatically.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE (7U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE (0x00000080U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE (1U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_GATE_UPDATE)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE) & BM_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE)

/*! @brief Set the DLL_CTRL_GATE_UPDATE field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE) | BF_uSDHC_DLL_CTRL_DLL_CTRL_GATE_UPDATE(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_OVERRIDE[8] (RW)
 *
 * Set this bit to 1 to Enable manual override for slave delay chain using
 * SLV_OVERRIDE_VAL; to set 0 to disable manual override. This feature does not
 * require the DLL to be enabled using the ENABLE bit. In fact to reduce power, if
 * SLV_OVERRIDE is used, it is recommended to disable the DLL with ENABLE = 0
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE (8U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE (0x00000100U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE (1U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_OVERRIDE)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE)

/*! @brief Set the DLL_CTRL_SLV_OVERRIDE field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_OVERRIDE_VAL[15:9] (RW)
 *
 * When SLV_OVERRIDE = 1 This field is used to select 1 of 128 physical taps
 * manually. A value of 0 selects tap 1, and a value of 0x7f selects tap 128.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL (9U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL (0x0000FE00U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL (7U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_OVERRIDE_VAL)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL)

/*! @brief Set the DLL_CTRL_SLV_OVERRIDE_VAL field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_OVERRIDE_VAL(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_DLY_TARGET1[18:16] (RW)
 *
 * Refer to DLL_CTRL_SLV_DLY_TARGET0 below.
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1 (16U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1 (0x00070000U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1 (3U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1 field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_DLY_TARGET1)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1)

/*! @brief Set the DLL_CTRL_SLV_DLY_TARGET1 field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_DLY_TARGET1(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_SLV_UPDATE_INT[27:20] (RW)
 *
 * Slave delay line update interval. If default 0 is used, it means 256 cycles
 * of REF_CLOCK. A value of 0x0f results in 15 cycles and so on. Note that
 * software can always cause an update of the slave-delay line using the
 * SLV_FORCE_UPDATE register. Note that the slave delay line will also update automatically when
 * the reference DLL transitions to a locked state (from an un-locked state).
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT (20U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT (0x0FF00000U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT (8U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_SLV_UPDATE_INT)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT) & BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT)

/*! @brief Set the DLL_CTRL_SLV_UPDATE_INT field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT) | BF_uSDHC_DLL_CTRL_DLL_CTRL_SLV_UPDATE_INT(v)))
/*@}*/

/*!
 * @name Register uSDHC_DLL_CTRL, field DLL_CTRL_REF_UPDATE_INT[31:28] (RW)
 *
 * DLL control loop update interval. The interval cycle is (2 + REF_UPDATE_INT)
 * * REF_CLOCK. By default, the DLL control loop shall update every two REF_CLOCK
 * cycles. It should be noted that increasing the reference delay-line update
 * interval reduces the ability of the DLL to adjust to fast changes in conditions
 * that may effect the delay (such as voltage and temperature)
 */
/*@{*/
#define BP_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT (28U) /*!< Bit position for uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT. */
#define BM_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT (0xF0000000U) /*!< Bit mask for uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT. */
#define BS_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT (4U) /*!< Bit field size in bits for uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT. */

/*! @brief Read current value of the uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT field. */
#define BR_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT(x) (HW_uSDHC_DLL_CTRL(x).B.DLL_CTRL_REF_UPDATE_INT)

/*! @brief Format value for bitfield uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT. */
#define BF_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT) & BM_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT)

/*! @brief Set the DLL_CTRL_REF_UPDATE_INT field to a new value. */
#define BW_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT(x, v) (HW_uSDHC_DLL_CTRL_WR(x, (HW_uSDHC_DLL_CTRL_RD(x) & ~BM_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT) | BF_uSDHC_DLL_CTRL_DLL_CTRL_REF_UPDATE_INT(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_DLL_STATUS - DLL Status
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_DLL_STATUS - DLL Status (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the DLL status information. All bits are read only and
 * will read the same as the power-reset value.
 */
typedef union _hw_usdhc_dll_status
{
    uint32_t U;
    struct _hw_usdhc_dll_status_bitfields
    {
        uint32_t DLL_STS_SLV_LOCK : 1; /*!< [0]  */
        uint32_t DLL_STS_REF_LOCK : 1; /*!< [1]  */
        uint32_t DLL_STS_SLV_SEL : 7;  /*!< [8:2]  */
        uint32_t DLL_STS_REF_SEL : 7;  /*!< [15:9]  */
        uint32_t RESERVED0 : 16;       /*!< [31:16]  */
    } B;
} hw_usdhc_dll_status_t;

/*!
 * @name Constants and macros for entire uSDHC_DLL_STATUS register
 */
/*@{*/
#define HW_uSDHC_DLL_STATUS_ADDR(x) ((uintptr_t)(x) + 0x64U)

#define HW_uSDHC_DLL_STATUS(x)   (*(__I hw_usdhc_dll_status_t *) HW_uSDHC_DLL_STATUS_ADDR(x))
#define HW_uSDHC_DLL_STATUS_RD(x) (HW_uSDHC_DLL_STATUS(x).U)
/*@}*/

/*
 * Constants & macros for individual uSDHC_DLL_STATUS bitfields
 */

/*!
 * @name Register uSDHC_DLL_STATUS, field DLL_STS_SLV_LOCK[0] (RO)
 *
 * Slave delay-line lock status. This signifies that a valid calibration has
 * been set to the slave-delay line and that the slave-delay line is implementing
 * the programmed delay value
 */
/*@{*/
#define BP_uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK (0U) /*!< Bit position for uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK. */
#define BM_uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK (0x00000001U) /*!< Bit mask for uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK. */
#define BS_uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK (1U) /*!< Bit field size in bits for uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK. */

/*! @brief Read current value of the uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK field. */
#define BR_uSDHC_DLL_STATUS_DLL_STS_SLV_LOCK(x) (HW_uSDHC_DLL_STATUS(x).B.DLL_STS_SLV_LOCK)
/*@}*/

/*!
 * @name Register uSDHC_DLL_STATUS, field DLL_STS_REF_LOCK[1] (RO)
 *
 * Reference DLL lock status. This signifies that the DLL has detected and
 * locked to a half-phase ref_clock shift, allowing the slave delay-line to perform
 * programmed clock delays
 */
/*@{*/
#define BP_uSDHC_DLL_STATUS_DLL_STS_REF_LOCK (1U) /*!< Bit position for uSDHC_DLL_STATUS_DLL_STS_REF_LOCK. */
#define BM_uSDHC_DLL_STATUS_DLL_STS_REF_LOCK (0x00000002U) /*!< Bit mask for uSDHC_DLL_STATUS_DLL_STS_REF_LOCK. */
#define BS_uSDHC_DLL_STATUS_DLL_STS_REF_LOCK (1U) /*!< Bit field size in bits for uSDHC_DLL_STATUS_DLL_STS_REF_LOCK. */

/*! @brief Read current value of the uSDHC_DLL_STATUS_DLL_STS_REF_LOCK field. */
#define BR_uSDHC_DLL_STATUS_DLL_STS_REF_LOCK(x) (HW_uSDHC_DLL_STATUS(x).B.DLL_STS_REF_LOCK)
/*@}*/

/*!
 * @name Register uSDHC_DLL_STATUS, field DLL_STS_SLV_SEL[8:2] (RO)
 *
 * Slave delay line select status. This is the instant value generated from
 * reference chain. Since the reference chain can only be updated when REF_CLOCK is
 * detected, this value should be the right value to be updated when the reference
 * is locked.
 */
/*@{*/
#define BP_uSDHC_DLL_STATUS_DLL_STS_SLV_SEL (2U) /*!< Bit position for uSDHC_DLL_STATUS_DLL_STS_SLV_SEL. */
#define BM_uSDHC_DLL_STATUS_DLL_STS_SLV_SEL (0x000001FCU) /*!< Bit mask for uSDHC_DLL_STATUS_DLL_STS_SLV_SEL. */
#define BS_uSDHC_DLL_STATUS_DLL_STS_SLV_SEL (7U) /*!< Bit field size in bits for uSDHC_DLL_STATUS_DLL_STS_SLV_SEL. */

/*! @brief Read current value of the uSDHC_DLL_STATUS_DLL_STS_SLV_SEL field. */
#define BR_uSDHC_DLL_STATUS_DLL_STS_SLV_SEL(x) (HW_uSDHC_DLL_STATUS(x).B.DLL_STS_SLV_SEL)
/*@}*/

/*!
 * @name Register uSDHC_DLL_STATUS, field DLL_STS_REF_SEL[15:9] (RO)
 *
 * Reference delay line select taps. This is encoded by 7 bits for 127 taps.
 */
/*@{*/
#define BP_uSDHC_DLL_STATUS_DLL_STS_REF_SEL (9U) /*!< Bit position for uSDHC_DLL_STATUS_DLL_STS_REF_SEL. */
#define BM_uSDHC_DLL_STATUS_DLL_STS_REF_SEL (0x0000FE00U) /*!< Bit mask for uSDHC_DLL_STATUS_DLL_STS_REF_SEL. */
#define BS_uSDHC_DLL_STATUS_DLL_STS_REF_SEL (7U) /*!< Bit field size in bits for uSDHC_DLL_STATUS_DLL_STS_REF_SEL. */

/*! @brief Read current value of the uSDHC_DLL_STATUS_DLL_STS_REF_SEL field. */
#define BR_uSDHC_DLL_STATUS_DLL_STS_REF_SEL(x) (HW_uSDHC_DLL_STATUS(x).B.DLL_STS_REF_SEL)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_CLK_TUNE_CTRL_STATUS - CLK Tuning Control and Status
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_CLK_TUNE_CTRL_STATUS - CLK Tuning Control and Status (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the Clock Tuning Control status information. All bits
 * are read only and will read the same as the power-reset value. This register
 * is added to support SD3.0 UHS-I SDR104 mode.
 */
typedef union _hw_usdhc_clk_tune_ctrl_status
{
    uint32_t U;
    struct _hw_usdhc_clk_tune_ctrl_status_bitfields
    {
        uint32_t DLY_CELL_SET_POST : 4; /*!< [3:0]  */
        uint32_t DLY_CELL_SET_OUT : 4; /*!< [7:4]  */
        uint32_t DLY_CELL_SET_PRE : 7; /*!< [14:8]  */
        uint32_t NXT_ERR : 1;          /*!< [15]  */
        uint32_t TAP_SEL_POST : 4;     /*!< [19:16]  */
        uint32_t TAP_SEL_OUT : 4;      /*!< [23:20]  */
        uint32_t TAP_SEL_PRE : 7;      /*!< [30:24]  */
        uint32_t PRE_ERR : 1;          /*!< [31]  */
    } B;
} hw_usdhc_clk_tune_ctrl_status_t;

/*!
 * @name Constants and macros for entire uSDHC_CLK_TUNE_CTRL_STATUS register
 */
/*@{*/
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_ADDR(x) ((uintptr_t)(x) + 0x68U)

#define HW_uSDHC_CLK_TUNE_CTRL_STATUS(x) (*(__IO hw_usdhc_clk_tune_ctrl_status_t *) HW_uSDHC_CLK_TUNE_CTRL_STATUS_ADDR(x))
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).U)
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).U = (v))
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_SET(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) |  (v)))
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_CLR(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) & ~(v)))
#define HW_uSDHC_CLK_TUNE_CTRL_STATUS_TOG(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_CLK_TUNE_CTRL_STATUS bitfields
 */

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field DLY_CELL_SET_POST[3:0] (RW)
 *
 * Set the number of delay cells on the feedback clock between CLK_OUT and
 * CLK_POST.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST (0U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST (0x0000000FU) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST (4U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.DLY_CELL_SET_POST)

/*! @brief Format value for bitfield uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST. */
#define BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST) & BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST)

/*! @brief Set the DLY_CELL_SET_POST field to a new value. */
#define BW_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, (HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) & ~BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST) | BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_POST(v)))
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field DLY_CELL_SET_OUT[7:4] (RW)
 *
 * Set the number of delay cells on the feedback clock between CLK_PRE and
 * CLK_OUT.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT (4U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT (0x000000F0U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT (4U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.DLY_CELL_SET_OUT)

/*! @brief Format value for bitfield uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT. */
#define BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT) & BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT)

/*! @brief Set the DLY_CELL_SET_OUT field to a new value. */
#define BW_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, (HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) & ~BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT) | BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_OUT(v)))
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field DLY_CELL_SET_PRE[14:8] (RW)
 *
 * Set the number of delay cells on the feedback clock between the feedback
 * clock and CLK_PRE.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE (8U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE (0x00007F00U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE (7U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.DLY_CELL_SET_PRE)

/*! @brief Format value for bitfield uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE. */
#define BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE) & BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE)

/*! @brief Set the DLY_CELL_SET_PRE field to a new value. */
#define BW_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE(x, v) (HW_uSDHC_CLK_TUNE_CTRL_STATUS_WR(x, (HW_uSDHC_CLK_TUNE_CTRL_STATUS_RD(x) & ~BM_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE) | BF_uSDHC_CLK_TUNE_CTRL_STATUS_DLY_CELL_SET_PRE(v)))
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field NXT_ERR[15] (RO)
 *
 * NXT error which means the number of delay cells added on the feedback clock
 * is too large. It's valid only when SMP_CLK_SEL of Mix control register (bit23
 * of 0x48) is enabled.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR (15U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR (0x00008000U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR (1U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_NXT_ERR(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.NXT_ERR)
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field TAP_SEL_POST[19:16] (RO)
 *
 * Reflect the number of delay cells added on the feedback clock between CLK_OUT
 * and CLK_POST.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST (16U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST (0x000F0000U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST (4U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_POST(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.TAP_SEL_POST)
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field TAP_SEL_OUT[23:20] (RO)
 *
 * Reflect the number of delay cells added on the feedback clock between CLK_PRE
 * and CLK_OUT.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT (20U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT (0x00F00000U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT (4U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_OUT(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.TAP_SEL_OUT)
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field TAP_SEL_PRE[30:24] (RO)
 *
 * Reflects the number of delay cells added on the feedback clock between the
 * feedback clock and CLK_PRE. When AUTO_TUNE_EN (bit24 of 0x48) is disabled,
 * TAP_SEL_PRE is always equal to DLY_CELL_SET_PRE. When AUTO_TUNE_EN (bit24 of 0x48)
 * is enabled, TAP_SEL_PRE will be updated automatically according to the status
 * of the auto tuning circuit to adjust the sample clock phase.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE (24U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE (0x7F000000U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE (7U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_TAP_SEL_PRE(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.TAP_SEL_PRE)
/*@}*/

/*!
 * @name Register uSDHC_CLK_TUNE_CTRL_STATUS, field PRE_ERR[31] (RO)
 *
 * PRE error which means the number of delay cells added on the feedback clock
 * is too small. It is valid only when SMP_CLK_SEL of Mix control register (bit23
 * of 0x48) is enabled.
 */
/*@{*/
#define BP_uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR (31U) /*!< Bit position for uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR. */
#define BM_uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR (0x80000000U) /*!< Bit mask for uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR. */
#define BS_uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR (1U) /*!< Bit field size in bits for uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR. */

/*! @brief Read current value of the uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR field. */
#define BR_uSDHC_CLK_TUNE_CTRL_STATUS_PRE_ERR(x) (HW_uSDHC_CLK_TUNE_CTRL_STATUS(x).B.PRE_ERR)
/*@}*/

/*******************************************************************************
 * HW_uSDHC_VEND_SPEC - Vendor Specific Register
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_VEND_SPEC - Vendor Specific Register (RW)
 *
 * Reset value: 0x20007809U
 *
 * This register contains the vendor specific control / status register.
 */
typedef union _hw_usdhc_vend_spec
{
    uint32_t U;
    struct _hw_usdhc_vend_spec_bitfields
    {
        uint32_t EXT_DMA_EN : 1;       /*!< [0] External DMA Request Enable */
        uint32_t VSELECT : 1;          /*!< [1] Voltage Selection */
        uint32_t CONFLICT_CHK_EN : 1;  /*!< [2] Conflict check enable. */
        uint32_t AC12_WR_CHKBUSY_EN : 1; /*!< [3]  */
        uint32_t DAT3_CD_POL : 1;      /*!< [4]  */
        uint32_t CD_POL : 1;           /*!< [5]  */
        uint32_t WP_POL : 1;           /*!< [6]  */
        uint32_t CLKONJ_IN_ABORT : 1;  /*!< [7]  */
        uint32_t FRC_SDCLK_ON : 1;     /*!< [8]  */
        uint32_t RESERVED0 : 2;        /*!< [10:9]  */
        uint32_t IPG_CLK_SOFT_EN : 1;  /*!< [11] IPG_CLK Software Enable */
        uint32_t HCLK_SOFT_EN : 1;     /*!< [12] AHB Clock Software Enable */
        uint32_t IPG_PERCLK_SOFT_EN : 1; /*!< [13] IPG_PERCLK Software Enable
                                        * */
        uint32_t CARD_CLK_SOFT_EN : 1; /*!< [14] Card Clock Software Enable */
        uint32_t CRC_CHK_DIS : 1;      /*!< [15] CRC Check Disable */
        uint32_t INT_ST_VAL : 8;       /*!< [23:16] Internal State Value */
        uint32_t RESERVED1 : 7;        /*!< [30:24]  */
        uint32_t CMD_BYTE_EN : 1;      /*!< [31]  */
    } B;
} hw_usdhc_vend_spec_t;

/*!
 * @name Constants and macros for entire uSDHC_VEND_SPEC register
 */
/*@{*/
#define HW_uSDHC_VEND_SPEC_ADDR(x) ((uintptr_t)(x) + 0xC0U)

#define HW_uSDHC_VEND_SPEC(x)    (*(__IO hw_usdhc_vend_spec_t *) HW_uSDHC_VEND_SPEC_ADDR(x))
#define HW_uSDHC_VEND_SPEC_RD(x) (HW_uSDHC_VEND_SPEC(x).U)
#define HW_uSDHC_VEND_SPEC_WR(x, v) (HW_uSDHC_VEND_SPEC(x).U = (v))
#define HW_uSDHC_VEND_SPEC_SET(x, v) (HW_uSDHC_VEND_SPEC_WR(x, HW_uSDHC_VEND_SPEC_RD(x) |  (v)))
#define HW_uSDHC_VEND_SPEC_CLR(x, v) (HW_uSDHC_VEND_SPEC_WR(x, HW_uSDHC_VEND_SPEC_RD(x) & ~(v)))
#define HW_uSDHC_VEND_SPEC_TOG(x, v) (HW_uSDHC_VEND_SPEC_WR(x, HW_uSDHC_VEND_SPEC_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_VEND_SPEC bitfields
 */

/*!
 * @name Register uSDHC_VEND_SPEC, field EXT_DMA_EN[0] (RW)
 *
 * Enable the request to external DMA. When the internal DMA (either Simple DMA
 * or Advanced DMA) is not in use, and this bit is set, uSDHC will send out DMA
 * request when the internal buffer is ready. This bit is particularly useful when
 * transferring data by ARM platform polling mode, and it is not allowed to send
 * out the external DMA request. By default, this bit is set.
 *
 * Values:
 * - 0 - In any scenario, uSDHC does not send out external DMA request.
 * - 1 - When internal DMA is not active, the external DMA request will be sent
 *     out.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_EXT_DMA_EN (0U) /*!< Bit position for uSDHC_VEND_SPEC_EXT_DMA_EN. */
#define BM_uSDHC_VEND_SPEC_EXT_DMA_EN (0x00000001U) /*!< Bit mask for uSDHC_VEND_SPEC_EXT_DMA_EN. */
#define BS_uSDHC_VEND_SPEC_EXT_DMA_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_EXT_DMA_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_EXT_DMA_EN field. */
#define BR_uSDHC_VEND_SPEC_EXT_DMA_EN(x) (HW_uSDHC_VEND_SPEC(x).B.EXT_DMA_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_EXT_DMA_EN. */
#define BF_uSDHC_VEND_SPEC_EXT_DMA_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_EXT_DMA_EN) & BM_uSDHC_VEND_SPEC_EXT_DMA_EN)

/*! @brief Set the EXT_DMA_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_EXT_DMA_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_EXT_DMA_EN) | BF_uSDHC_VEND_SPEC_EXT_DMA_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field VSELECT[1] (RW)
 *
 * Change the value of output signal VSELECT, to control the voltage on pads for
 * external card. There must be a control circuit out of uSDHC to change the
 * voltage on pads.
 *
 * Values:
 * - 1 - Change the voltage to low voltage range, around 1.8 V
 * - 0 - Change the voltage to high voltage range, around 3.0 V
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_VSELECT (1U)    /*!< Bit position for uSDHC_VEND_SPEC_VSELECT. */
#define BM_uSDHC_VEND_SPEC_VSELECT (0x00000002U) /*!< Bit mask for uSDHC_VEND_SPEC_VSELECT. */
#define BS_uSDHC_VEND_SPEC_VSELECT (1U)    /*!< Bit field size in bits for uSDHC_VEND_SPEC_VSELECT. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_VSELECT field. */
#define BR_uSDHC_VEND_SPEC_VSELECT(x) (HW_uSDHC_VEND_SPEC(x).B.VSELECT)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_VSELECT. */
#define BF_uSDHC_VEND_SPEC_VSELECT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_VSELECT) & BM_uSDHC_VEND_SPEC_VSELECT)

/*! @brief Set the VSELECT field to a new value. */
#define BW_uSDHC_VEND_SPEC_VSELECT(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_VSELECT) | BF_uSDHC_VEND_SPEC_VSELECT(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CONFLICT_CHK_EN[2] (RW)
 *
 * It is not implemented in uSDHC IP.
 *
 * Values:
 * - 0 - Conflict check disable
 * - 1 - Conflict check enable
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CONFLICT_CHK_EN (2U) /*!< Bit position for uSDHC_VEND_SPEC_CONFLICT_CHK_EN. */
#define BM_uSDHC_VEND_SPEC_CONFLICT_CHK_EN (0x00000004U) /*!< Bit mask for uSDHC_VEND_SPEC_CONFLICT_CHK_EN. */
#define BS_uSDHC_VEND_SPEC_CONFLICT_CHK_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_CONFLICT_CHK_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CONFLICT_CHK_EN field. */
#define BR_uSDHC_VEND_SPEC_CONFLICT_CHK_EN(x) (HW_uSDHC_VEND_SPEC(x).B.CONFLICT_CHK_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CONFLICT_CHK_EN. */
#define BF_uSDHC_VEND_SPEC_CONFLICT_CHK_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CONFLICT_CHK_EN) & BM_uSDHC_VEND_SPEC_CONFLICT_CHK_EN)

/*! @brief Set the CONFLICT_CHK_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_CONFLICT_CHK_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CONFLICT_CHK_EN) | BF_uSDHC_VEND_SPEC_CONFLICT_CHK_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field AC12_WR_CHKBUSY_EN[3] (RW)
 *
 * Check busy enable after auto CMD12 for write data packet
 *
 * Values:
 * - 0 - Do not check busy after auto CMD12 for write data packet
 * - 1 - Check busy after auto CMD12 for write data packet
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN (3U) /*!< Bit position for uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN. */
#define BM_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN (0x00000008U) /*!< Bit mask for uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN. */
#define BS_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN field. */
#define BR_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN(x) (HW_uSDHC_VEND_SPEC(x).B.AC12_WR_CHKBUSY_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN. */
#define BF_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN) & BM_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN)

/*! @brief Set the AC12_WR_CHKBUSY_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN) | BF_uSDHC_VEND_SPEC_AC12_WR_CHKBUSY_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field DAT3_CD_POL[4] (RW)
 *
 * Only for debug. Polarity of DATA3 pin when it is used as card detection.
 *
 * Values:
 * - 0 - Card detected when DATA3 is high.
 * - 1 - Card detected when DATA3 is low.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_DAT3_CD_POL (4U) /*!< Bit position for uSDHC_VEND_SPEC_DAT3_CD_POL. */
#define BM_uSDHC_VEND_SPEC_DAT3_CD_POL (0x00000010U) /*!< Bit mask for uSDHC_VEND_SPEC_DAT3_CD_POL. */
#define BS_uSDHC_VEND_SPEC_DAT3_CD_POL (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_DAT3_CD_POL. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_DAT3_CD_POL field. */
#define BR_uSDHC_VEND_SPEC_DAT3_CD_POL(x) (HW_uSDHC_VEND_SPEC(x).B.DAT3_CD_POL)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_DAT3_CD_POL. */
#define BF_uSDHC_VEND_SPEC_DAT3_CD_POL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_DAT3_CD_POL) & BM_uSDHC_VEND_SPEC_DAT3_CD_POL)

/*! @brief Set the DAT3_CD_POL field to a new value. */
#define BW_uSDHC_VEND_SPEC_DAT3_CD_POL(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_DAT3_CD_POL) | BF_uSDHC_VEND_SPEC_DAT3_CD_POL(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CD_POL[5] (RW)
 *
 * Only for debug. Polarity of the CD_B pin:
 *
 * Values:
 * - 0 - CD_B pin is low active.
 * - 1 - CD_B pin is high active.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CD_POL (5U)     /*!< Bit position for uSDHC_VEND_SPEC_CD_POL. */
#define BM_uSDHC_VEND_SPEC_CD_POL (0x00000020U) /*!< Bit mask for uSDHC_VEND_SPEC_CD_POL. */
#define BS_uSDHC_VEND_SPEC_CD_POL (1U)     /*!< Bit field size in bits for uSDHC_VEND_SPEC_CD_POL. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CD_POL field. */
#define BR_uSDHC_VEND_SPEC_CD_POL(x) (HW_uSDHC_VEND_SPEC(x).B.CD_POL)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CD_POL. */
#define BF_uSDHC_VEND_SPEC_CD_POL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CD_POL) & BM_uSDHC_VEND_SPEC_CD_POL)

/*! @brief Set the CD_POL field to a new value. */
#define BW_uSDHC_VEND_SPEC_CD_POL(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CD_POL) | BF_uSDHC_VEND_SPEC_CD_POL(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field WP_POL[6] (RW)
 *
 * Only for debug. Polarity of the WP pin:
 *
 * Values:
 * - 0 - WP pin is high active.
 * - 1 - WP pin is low active.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_WP_POL (6U)     /*!< Bit position for uSDHC_VEND_SPEC_WP_POL. */
#define BM_uSDHC_VEND_SPEC_WP_POL (0x00000040U) /*!< Bit mask for uSDHC_VEND_SPEC_WP_POL. */
#define BS_uSDHC_VEND_SPEC_WP_POL (1U)     /*!< Bit field size in bits for uSDHC_VEND_SPEC_WP_POL. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_WP_POL field. */
#define BR_uSDHC_VEND_SPEC_WP_POL(x) (HW_uSDHC_VEND_SPEC(x).B.WP_POL)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_WP_POL. */
#define BF_uSDHC_VEND_SPEC_WP_POL(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_WP_POL) & BM_uSDHC_VEND_SPEC_WP_POL)

/*! @brief Set the WP_POL field to a new value. */
#define BW_uSDHC_VEND_SPEC_WP_POL(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_WP_POL) | BF_uSDHC_VEND_SPEC_WP_POL(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CLKONJ_IN_ABORT[7] (RW)
 *
 * Only for debug. Force CLK output active when sending Abort command:
 *
 * Values:
 * - 0 - The CLK output is active when sending abort command while data is
 *     transmitting even if the internal FIFO is full (for read) or empty (for write).
 * - 1 - The CLK output is inactive when sending abort command while data is
 *     transmitting if the internal FIFO is full (for read) or empty (for write).
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT (7U) /*!< Bit position for uSDHC_VEND_SPEC_CLKONJ_IN_ABORT. */
#define BM_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT (0x00000080U) /*!< Bit mask for uSDHC_VEND_SPEC_CLKONJ_IN_ABORT. */
#define BS_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_CLKONJ_IN_ABORT. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CLKONJ_IN_ABORT field. */
#define BR_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT(x) (HW_uSDHC_VEND_SPEC(x).B.CLKONJ_IN_ABORT)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CLKONJ_IN_ABORT. */
#define BF_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT) & BM_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT)

/*! @brief Set the CLKONJ_IN_ABORT field to a new value. */
#define BW_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT) | BF_uSDHC_VEND_SPEC_CLKONJ_IN_ABORT(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field FRC_SDCLK_ON[8] (RW)
 *
 * Force CLK output active
 *
 * Values:
 * - 0 - CLK active or inactive is fully controlled by the hardware.
 * - 1 - Force CLK active.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_FRC_SDCLK_ON (8U) /*!< Bit position for uSDHC_VEND_SPEC_FRC_SDCLK_ON. */
#define BM_uSDHC_VEND_SPEC_FRC_SDCLK_ON (0x00000100U) /*!< Bit mask for uSDHC_VEND_SPEC_FRC_SDCLK_ON. */
#define BS_uSDHC_VEND_SPEC_FRC_SDCLK_ON (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_FRC_SDCLK_ON. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_FRC_SDCLK_ON field. */
#define BR_uSDHC_VEND_SPEC_FRC_SDCLK_ON(x) (HW_uSDHC_VEND_SPEC(x).B.FRC_SDCLK_ON)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_FRC_SDCLK_ON. */
#define BF_uSDHC_VEND_SPEC_FRC_SDCLK_ON(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_FRC_SDCLK_ON) & BM_uSDHC_VEND_SPEC_FRC_SDCLK_ON)

/*! @brief Set the FRC_SDCLK_ON field to a new value. */
#define BW_uSDHC_VEND_SPEC_FRC_SDCLK_ON(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_FRC_SDCLK_ON) | BF_uSDHC_VEND_SPEC_FRC_SDCLK_ON(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field IPG_CLK_SOFT_EN[11] (RW)
 *
 * Values:
 * - 0 - Gate off the IPG_CLK
 * - 1 - Enable the IPG_CLK
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN (11U) /*!< Bit position for uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN. */
#define BM_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN (0x00000800U) /*!< Bit mask for uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN. */
#define BS_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN field. */
#define BR_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN(x) (HW_uSDHC_VEND_SPEC(x).B.IPG_CLK_SOFT_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN. */
#define BF_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN) & BM_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN)

/*! @brief Set the IPG_CLK_SOFT_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN) | BF_uSDHC_VEND_SPEC_IPG_CLK_SOFT_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field HCLK_SOFT_EN[12] (RW)
 *
 * Hardware auto-enables the AHB clock when the internal DMA is enabled even if
 * HCLK_SOFT_EN is 0.
 *
 * Values:
 * - 0 - Gate off the AHB clock.
 * - 1 - Enable the AHB clock.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_HCLK_SOFT_EN (12U) /*!< Bit position for uSDHC_VEND_SPEC_HCLK_SOFT_EN. */
#define BM_uSDHC_VEND_SPEC_HCLK_SOFT_EN (0x00001000U) /*!< Bit mask for uSDHC_VEND_SPEC_HCLK_SOFT_EN. */
#define BS_uSDHC_VEND_SPEC_HCLK_SOFT_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_HCLK_SOFT_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_HCLK_SOFT_EN field. */
#define BR_uSDHC_VEND_SPEC_HCLK_SOFT_EN(x) (HW_uSDHC_VEND_SPEC(x).B.HCLK_SOFT_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_HCLK_SOFT_EN. */
#define BF_uSDHC_VEND_SPEC_HCLK_SOFT_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_HCLK_SOFT_EN) & BM_uSDHC_VEND_SPEC_HCLK_SOFT_EN)

/*! @brief Set the HCLK_SOFT_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_HCLK_SOFT_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_HCLK_SOFT_EN) | BF_uSDHC_VEND_SPEC_HCLK_SOFT_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field IPG_PERCLK_SOFT_EN[13] (RW)
 *
 * Values:
 * - 0 - Gate off the IPG_PERCLK
 * - 1 - Enable the IPG_PERCLK
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN (13U) /*!< Bit position for uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN. */
#define BM_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN (0x00002000U) /*!< Bit mask for uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN. */
#define BS_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN field. */
#define BR_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN(x) (HW_uSDHC_VEND_SPEC(x).B.IPG_PERCLK_SOFT_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN. */
#define BF_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN) & BM_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN)

/*! @brief Set the IPG_PERCLK_SOFT_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN) | BF_uSDHC_VEND_SPEC_IPG_PERCLK_SOFT_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CARD_CLK_SOFT_EN[14] (RW)
 *
 * Values:
 * - 0 - Gate off the sd_clk
 * - 1 - Enable the sd_clk
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN (14U) /*!< Bit position for uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN. */
#define BM_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN (0x00004000U) /*!< Bit mask for uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN. */
#define BS_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN field. */
#define BR_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN(x) (HW_uSDHC_VEND_SPEC(x).B.CARD_CLK_SOFT_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN. */
#define BF_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN) & BM_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN)

/*! @brief Set the CARD_CLK_SOFT_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN) | BF_uSDHC_VEND_SPEC_CARD_CLK_SOFT_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CRC_CHK_DIS[15] (RW)
 *
 * Values:
 * - 0 - Check CRC16 for every read data packet and check CRC bits for every
 *     write data packet
 * - 1 - Ignore CRC16 check for every read data packet and ignore CRC bits check
 *     for every write data packet
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CRC_CHK_DIS (15U) /*!< Bit position for uSDHC_VEND_SPEC_CRC_CHK_DIS. */
#define BM_uSDHC_VEND_SPEC_CRC_CHK_DIS (0x00008000U) /*!< Bit mask for uSDHC_VEND_SPEC_CRC_CHK_DIS. */
#define BS_uSDHC_VEND_SPEC_CRC_CHK_DIS (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_CRC_CHK_DIS. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CRC_CHK_DIS field. */
#define BR_uSDHC_VEND_SPEC_CRC_CHK_DIS(x) (HW_uSDHC_VEND_SPEC(x).B.CRC_CHK_DIS)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CRC_CHK_DIS. */
#define BF_uSDHC_VEND_SPEC_CRC_CHK_DIS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CRC_CHK_DIS) & BM_uSDHC_VEND_SPEC_CRC_CHK_DIS)

/*! @brief Set the CRC_CHK_DIS field to a new value. */
#define BW_uSDHC_VEND_SPEC_CRC_CHK_DIS(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CRC_CHK_DIS) | BF_uSDHC_VEND_SPEC_CRC_CHK_DIS(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field INT_ST_VAL[23:16] (RO)
 *
 * Internal state value, reflecting the corresponding state value selected by
 * Debug Select field. This field is read-only and write to this field does not
 * have effect.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_INT_ST_VAL (16U) /*!< Bit position for uSDHC_VEND_SPEC_INT_ST_VAL. */
#define BM_uSDHC_VEND_SPEC_INT_ST_VAL (0x00FF0000U) /*!< Bit mask for uSDHC_VEND_SPEC_INT_ST_VAL. */
#define BS_uSDHC_VEND_SPEC_INT_ST_VAL (8U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_INT_ST_VAL. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_INT_ST_VAL field. */
#define BR_uSDHC_VEND_SPEC_INT_ST_VAL(x) (HW_uSDHC_VEND_SPEC(x).B.INT_ST_VAL)
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC, field CMD_BYTE_EN[31] (RW)
 *
 * Byte access
 *
 * Values:
 * - 0 - Disable
 * - 1 - Enable
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC_CMD_BYTE_EN (31U) /*!< Bit position for uSDHC_VEND_SPEC_CMD_BYTE_EN. */
#define BM_uSDHC_VEND_SPEC_CMD_BYTE_EN (0x80000000U) /*!< Bit mask for uSDHC_VEND_SPEC_CMD_BYTE_EN. */
#define BS_uSDHC_VEND_SPEC_CMD_BYTE_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC_CMD_BYTE_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC_CMD_BYTE_EN field. */
#define BR_uSDHC_VEND_SPEC_CMD_BYTE_EN(x) (HW_uSDHC_VEND_SPEC(x).B.CMD_BYTE_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC_CMD_BYTE_EN. */
#define BF_uSDHC_VEND_SPEC_CMD_BYTE_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC_CMD_BYTE_EN) & BM_uSDHC_VEND_SPEC_CMD_BYTE_EN)

/*! @brief Set the CMD_BYTE_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC_CMD_BYTE_EN(x, v) (HW_uSDHC_VEND_SPEC_WR(x, (HW_uSDHC_VEND_SPEC_RD(x) & ~BM_uSDHC_VEND_SPEC_CMD_BYTE_EN) | BF_uSDHC_VEND_SPEC_CMD_BYTE_EN(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_MMC_BOOT - MMC Boot Register
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_MMC_BOOT - MMC Boot Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the MMC Fast Boot control register.
 */
typedef union _hw_usdhc_mmc_boot
{
    uint32_t U;
    struct _hw_usdhc_mmc_boot_bitfields
    {
        uint32_t DTOCV_ACK : 4;        /*!< [3:0]  */
        uint32_t BOOT_ACK : 1;         /*!< [4]  */
        uint32_t BOOT_MODE : 1;        /*!< [5]  */
        uint32_t BOOT_EN : 1;          /*!< [6]  */
        uint32_t AUTO_SABG_EN : 1;     /*!< [7]  */
        uint32_t DISABLE_TIME_OUT : 1; /*!< [8] Disable Time Out */
        uint32_t RESERVED0 : 7;        /*!< [15:9]  */
        uint32_t BOOT_BLK_CNT : 16;    /*!< [31:16]  */
    } B;
} hw_usdhc_mmc_boot_t;

/*!
 * @name Constants and macros for entire uSDHC_MMC_BOOT register
 */
/*@{*/
#define HW_uSDHC_MMC_BOOT_ADDR(x) ((uintptr_t)(x) + 0xC4U)

#define HW_uSDHC_MMC_BOOT(x)     (*(__IO hw_usdhc_mmc_boot_t *) HW_uSDHC_MMC_BOOT_ADDR(x))
#define HW_uSDHC_MMC_BOOT_RD(x)  (HW_uSDHC_MMC_BOOT(x).U)
#define HW_uSDHC_MMC_BOOT_WR(x, v) (HW_uSDHC_MMC_BOOT(x).U = (v))
#define HW_uSDHC_MMC_BOOT_SET(x, v) (HW_uSDHC_MMC_BOOT_WR(x, HW_uSDHC_MMC_BOOT_RD(x) |  (v)))
#define HW_uSDHC_MMC_BOOT_CLR(x, v) (HW_uSDHC_MMC_BOOT_WR(x, HW_uSDHC_MMC_BOOT_RD(x) & ~(v)))
#define HW_uSDHC_MMC_BOOT_TOG(x, v) (HW_uSDHC_MMC_BOOT_WR(x, HW_uSDHC_MMC_BOOT_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_MMC_BOOT bitfields
 */

/*!
 * @name Register uSDHC_MMC_BOOT, field DTOCV_ACK[3:0] (RW)
 *
 * Boot ACK time out counter value.
 *
 * Values:
 * - 0000 - SDCLK x 2^13
 * - 0001 - SDCLK x 2^14
 * - 0010 - SDCLK x 2^15
 * - 0011 - SDCLK x 2^16
 * - 0100 - SDCLK x 2^17
 * - 0101 - SDCLK x 2^18
 * - 0110 - SDCLK x 2^19
 * - 0111 - SDCLK x 2^20
 * - 1110 - SDCLK x 2^27
 * - 1111 - SDCLK x 2^28
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_DTOCV_ACK (0U)   /*!< Bit position for uSDHC_MMC_BOOT_DTOCV_ACK. */
#define BM_uSDHC_MMC_BOOT_DTOCV_ACK (0x0000000FU) /*!< Bit mask for uSDHC_MMC_BOOT_DTOCV_ACK. */
#define BS_uSDHC_MMC_BOOT_DTOCV_ACK (4U)   /*!< Bit field size in bits for uSDHC_MMC_BOOT_DTOCV_ACK. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_DTOCV_ACK field. */
#define BR_uSDHC_MMC_BOOT_DTOCV_ACK(x) (HW_uSDHC_MMC_BOOT(x).B.DTOCV_ACK)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_DTOCV_ACK. */
#define BF_uSDHC_MMC_BOOT_DTOCV_ACK(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_DTOCV_ACK) & BM_uSDHC_MMC_BOOT_DTOCV_ACK)

/*! @brief Set the DTOCV_ACK field to a new value. */
#define BW_uSDHC_MMC_BOOT_DTOCV_ACK(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_DTOCV_ACK) | BF_uSDHC_MMC_BOOT_DTOCV_ACK(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field BOOT_ACK[4] (RW)
 *
 * Boot ACK mode select
 *
 * Values:
 * - 0 - No ack
 * - 1 - Ack
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_BOOT_ACK (4U)    /*!< Bit position for uSDHC_MMC_BOOT_BOOT_ACK. */
#define BM_uSDHC_MMC_BOOT_BOOT_ACK (0x00000010U) /*!< Bit mask for uSDHC_MMC_BOOT_BOOT_ACK. */
#define BS_uSDHC_MMC_BOOT_BOOT_ACK (1U)    /*!< Bit field size in bits for uSDHC_MMC_BOOT_BOOT_ACK. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_BOOT_ACK field. */
#define BR_uSDHC_MMC_BOOT_BOOT_ACK(x) (HW_uSDHC_MMC_BOOT(x).B.BOOT_ACK)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_BOOT_ACK. */
#define BF_uSDHC_MMC_BOOT_BOOT_ACK(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_BOOT_ACK) & BM_uSDHC_MMC_BOOT_BOOT_ACK)

/*! @brief Set the BOOT_ACK field to a new value. */
#define BW_uSDHC_MMC_BOOT_BOOT_ACK(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_BOOT_ACK) | BF_uSDHC_MMC_BOOT_BOOT_ACK(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field BOOT_MODE[5] (RW)
 *
 * Boot mode select
 *
 * Values:
 * - 0 - Normal boot
 * - 1 - Alternative boot
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_BOOT_MODE (5U)   /*!< Bit position for uSDHC_MMC_BOOT_BOOT_MODE. */
#define BM_uSDHC_MMC_BOOT_BOOT_MODE (0x00000020U) /*!< Bit mask for uSDHC_MMC_BOOT_BOOT_MODE. */
#define BS_uSDHC_MMC_BOOT_BOOT_MODE (1U)   /*!< Bit field size in bits for uSDHC_MMC_BOOT_BOOT_MODE. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_BOOT_MODE field. */
#define BR_uSDHC_MMC_BOOT_BOOT_MODE(x) (HW_uSDHC_MMC_BOOT(x).B.BOOT_MODE)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_BOOT_MODE. */
#define BF_uSDHC_MMC_BOOT_BOOT_MODE(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_BOOT_MODE) & BM_uSDHC_MMC_BOOT_BOOT_MODE)

/*! @brief Set the BOOT_MODE field to a new value. */
#define BW_uSDHC_MMC_BOOT_BOOT_MODE(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_BOOT_MODE) | BF_uSDHC_MMC_BOOT_BOOT_MODE(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field BOOT_EN[6] (RW)
 *
 * Boot mode enable
 *
 * Values:
 * - 0 - Fast boot disable
 * - 1 - Fast boot enable
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_BOOT_EN (6U)     /*!< Bit position for uSDHC_MMC_BOOT_BOOT_EN. */
#define BM_uSDHC_MMC_BOOT_BOOT_EN (0x00000040U) /*!< Bit mask for uSDHC_MMC_BOOT_BOOT_EN. */
#define BS_uSDHC_MMC_BOOT_BOOT_EN (1U)     /*!< Bit field size in bits for uSDHC_MMC_BOOT_BOOT_EN. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_BOOT_EN field. */
#define BR_uSDHC_MMC_BOOT_BOOT_EN(x) (HW_uSDHC_MMC_BOOT(x).B.BOOT_EN)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_BOOT_EN. */
#define BF_uSDHC_MMC_BOOT_BOOT_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_BOOT_EN) & BM_uSDHC_MMC_BOOT_BOOT_EN)

/*! @brief Set the BOOT_EN field to a new value. */
#define BW_uSDHC_MMC_BOOT_BOOT_EN(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_BOOT_EN) | BF_uSDHC_MMC_BOOT_BOOT_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field AUTO_SABG_EN[7] (RW)
 *
 * During boot, enable auto stop at block gap function. This function will be
 * triggered, and host will stop at block gap when received card block cnt is equal
 * to (BLK_CNT - BOOT_BLK_CNT).
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_AUTO_SABG_EN (7U) /*!< Bit position for uSDHC_MMC_BOOT_AUTO_SABG_EN. */
#define BM_uSDHC_MMC_BOOT_AUTO_SABG_EN (0x00000080U) /*!< Bit mask for uSDHC_MMC_BOOT_AUTO_SABG_EN. */
#define BS_uSDHC_MMC_BOOT_AUTO_SABG_EN (1U) /*!< Bit field size in bits for uSDHC_MMC_BOOT_AUTO_SABG_EN. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_AUTO_SABG_EN field. */
#define BR_uSDHC_MMC_BOOT_AUTO_SABG_EN(x) (HW_uSDHC_MMC_BOOT(x).B.AUTO_SABG_EN)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_AUTO_SABG_EN. */
#define BF_uSDHC_MMC_BOOT_AUTO_SABG_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_AUTO_SABG_EN) & BM_uSDHC_MMC_BOOT_AUTO_SABG_EN)

/*! @brief Set the AUTO_SABG_EN field to a new value. */
#define BW_uSDHC_MMC_BOOT_AUTO_SABG_EN(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_AUTO_SABG_EN) | BF_uSDHC_MMC_BOOT_AUTO_SABG_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field DISABLE_TIME_OUT[8] (RW)
 *
 * When this bit is set, there is no timeout check no matter whether BOOT_EN is
 * set or not.
 *
 * Values:
 * - 0 - Enable time out
 * - 1 - Disable time out
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_DISABLE_TIME_OUT (8U) /*!< Bit position for uSDHC_MMC_BOOT_DISABLE_TIME_OUT. */
#define BM_uSDHC_MMC_BOOT_DISABLE_TIME_OUT (0x00000100U) /*!< Bit mask for uSDHC_MMC_BOOT_DISABLE_TIME_OUT. */
#define BS_uSDHC_MMC_BOOT_DISABLE_TIME_OUT (1U) /*!< Bit field size in bits for uSDHC_MMC_BOOT_DISABLE_TIME_OUT. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_DISABLE_TIME_OUT field. */
#define BR_uSDHC_MMC_BOOT_DISABLE_TIME_OUT(x) (HW_uSDHC_MMC_BOOT(x).B.DISABLE_TIME_OUT)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_DISABLE_TIME_OUT. */
#define BF_uSDHC_MMC_BOOT_DISABLE_TIME_OUT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_DISABLE_TIME_OUT) & BM_uSDHC_MMC_BOOT_DISABLE_TIME_OUT)

/*! @brief Set the DISABLE_TIME_OUT field to a new value. */
#define BW_uSDHC_MMC_BOOT_DISABLE_TIME_OUT(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_DISABLE_TIME_OUT) | BF_uSDHC_MMC_BOOT_DISABLE_TIME_OUT(v)))
/*@}*/

/*!
 * @name Register uSDHC_MMC_BOOT, field BOOT_BLK_CNT[31:16] (RW)
 *
 * The value defines the Stop At Block Gap value of automatic mode. When
 * received card block cnt is equal to (BLK_CNT - BOOT_BLK_CNT) and AUTO_SABG_EN is 1,
 * then Stop At Block Gap. Here, BLK_CNT is defined in the Block Atrributes
 * Register, bit31 - 16 of 0x04.
 */
/*@{*/
#define BP_uSDHC_MMC_BOOT_BOOT_BLK_CNT (16U) /*!< Bit position for uSDHC_MMC_BOOT_BOOT_BLK_CNT. */
#define BM_uSDHC_MMC_BOOT_BOOT_BLK_CNT (0xFFFF0000U) /*!< Bit mask for uSDHC_MMC_BOOT_BOOT_BLK_CNT. */
#define BS_uSDHC_MMC_BOOT_BOOT_BLK_CNT (16U) /*!< Bit field size in bits for uSDHC_MMC_BOOT_BOOT_BLK_CNT. */

/*! @brief Read current value of the uSDHC_MMC_BOOT_BOOT_BLK_CNT field. */
#define BR_uSDHC_MMC_BOOT_BOOT_BLK_CNT(x) (HW_uSDHC_MMC_BOOT(x).B.BOOT_BLK_CNT)

/*! @brief Format value for bitfield uSDHC_MMC_BOOT_BOOT_BLK_CNT. */
#define BF_uSDHC_MMC_BOOT_BOOT_BLK_CNT(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_MMC_BOOT_BOOT_BLK_CNT) & BM_uSDHC_MMC_BOOT_BOOT_BLK_CNT)

/*! @brief Set the BOOT_BLK_CNT field to a new value. */
#define BW_uSDHC_MMC_BOOT_BOOT_BLK_CNT(x, v) (HW_uSDHC_MMC_BOOT_WR(x, (HW_uSDHC_MMC_BOOT_RD(x) & ~BM_uSDHC_MMC_BOOT_BOOT_BLK_CNT) | BF_uSDHC_MMC_BOOT_BOOT_BLK_CNT(v)))
/*@}*/

/*******************************************************************************
 * HW_uSDHC_VEND_SPEC2 - Vendor Specific 2 Register
 ******************************************************************************/

/*!
 * @brief HW_uSDHC_VEND_SPEC2 - Vendor Specific 2 Register (RW)
 *
 * Reset value: 0x00000006U
 *
 * This register contains the vendor specific control 2 register.
 */
typedef union _hw_usdhc_vend_spec2
{
    uint32_t U;
    struct _hw_usdhc_vend_spec2_bitfields
    {
        uint32_t SDR104_TIMING_DIS : 1; /*!< [0]  */
        uint32_t SDR104_OE_DIS : 1;    /*!< [1]  */
        uint32_t SDR104_NSD_DIS : 1;   /*!< [2]  */
        uint32_t CARD_INT_D3_TEST : 1; /*!< [3] Card Interrupt Detection Test
                                        * */
        uint32_t TUNING_8bit_EN : 1;   /*!< [4]  */
        uint32_t TUNING_1bit_EN : 1;   /*!< [5]  */
        uint32_t TUNING_CMD_EN : 1;    /*!< [6]  */
        uint32_t CARD_INT_AUTO_CLR_DIS : 1; /*!< [7]  */
        uint32_t RESERVED0 : 24;       /*!< [31:8]  */
    } B;
} hw_usdhc_vend_spec2_t;

/*!
 * @name Constants and macros for entire uSDHC_VEND_SPEC2 register
 */
/*@{*/
#define HW_uSDHC_VEND_SPEC2_ADDR(x) ((uintptr_t)(x) + 0xC8U)

#define HW_uSDHC_VEND_SPEC2(x)   (*(__IO hw_usdhc_vend_spec2_t *) HW_uSDHC_VEND_SPEC2_ADDR(x))
#define HW_uSDHC_VEND_SPEC2_RD(x) (HW_uSDHC_VEND_SPEC2(x).U)
#define HW_uSDHC_VEND_SPEC2_WR(x, v) (HW_uSDHC_VEND_SPEC2(x).U = (v))
#define HW_uSDHC_VEND_SPEC2_SET(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, HW_uSDHC_VEND_SPEC2_RD(x) |  (v)))
#define HW_uSDHC_VEND_SPEC2_CLR(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, HW_uSDHC_VEND_SPEC2_RD(x) & ~(v)))
#define HW_uSDHC_VEND_SPEC2_TOG(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, HW_uSDHC_VEND_SPEC2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual uSDHC_VEND_SPEC2 bitfields
 */

/*!
 * @name Register uSDHC_VEND_SPEC2, field SDR104_TIMING_DIS[0] (RW)
 *
 * Timeout counter test. This bit only uses for debugging.
 *
 * Values:
 * - 0 - The timeout counter for Ncr changes to 80, Ncrc changes to 21.
 * - 1 - The timeout counter for Ncr changes to 72, Ncrc changes to 15.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS (0U) /*!< Bit position for uSDHC_VEND_SPEC2_SDR104_TIMING_DIS. */
#define BM_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS (0x00000001U) /*!< Bit mask for uSDHC_VEND_SPEC2_SDR104_TIMING_DIS. */
#define BS_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_SDR104_TIMING_DIS. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_SDR104_TIMING_DIS field. */
#define BR_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS(x) (HW_uSDHC_VEND_SPEC2(x).B.SDR104_TIMING_DIS)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_SDR104_TIMING_DIS. */
#define BF_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS) & BM_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS)

/*! @brief Set the SDR104_TIMING_DIS field to a new value. */
#define BW_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS) | BF_uSDHC_VEND_SPEC2_SDR104_TIMING_DIS(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field SDR104_OE_DIS[1] (RW)
 *
 * CMD_OE / DATA_OE logic generation test. This bit only uses for debugging.
 *
 * Values:
 * - 0 - Drive the CMD_OE / DATA_OE for one more clock cycle after the end bit.
 * - 1 - Stop to drive the CMD_OE / DATA_OE at once after driving the end bit.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_SDR104_OE_DIS (1U) /*!< Bit position for uSDHC_VEND_SPEC2_SDR104_OE_DIS. */
#define BM_uSDHC_VEND_SPEC2_SDR104_OE_DIS (0x00000002U) /*!< Bit mask for uSDHC_VEND_SPEC2_SDR104_OE_DIS. */
#define BS_uSDHC_VEND_SPEC2_SDR104_OE_DIS (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_SDR104_OE_DIS. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_SDR104_OE_DIS field. */
#define BR_uSDHC_VEND_SPEC2_SDR104_OE_DIS(x) (HW_uSDHC_VEND_SPEC2(x).B.SDR104_OE_DIS)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_SDR104_OE_DIS. */
#define BF_uSDHC_VEND_SPEC2_SDR104_OE_DIS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_SDR104_OE_DIS) & BM_uSDHC_VEND_SPEC2_SDR104_OE_DIS)

/*! @brief Set the SDR104_OE_DIS field to a new value. */
#define BW_uSDHC_VEND_SPEC2_SDR104_OE_DIS(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_SDR104_OE_DIS) | BF_uSDHC_VEND_SPEC2_SDR104_OE_DIS(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field SDR104_NSD_DIS[2] (RW)
 *
 * Interrupt window after abort command is sent. This bit only uses for
 * debugging.
 *
 * Values:
 * - 0 - Enable the interrupt window 9 cycles later after the end of the I/O
 *     abort command (or CMD12) is sent.
 * - 1 - Enable the interrupt window 5 cycles later after the end of the I/O
 *     abort command (or CMD12) is sent.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_SDR104_NSD_DIS (2U) /*!< Bit position for uSDHC_VEND_SPEC2_SDR104_NSD_DIS. */
#define BM_uSDHC_VEND_SPEC2_SDR104_NSD_DIS (0x00000004U) /*!< Bit mask for uSDHC_VEND_SPEC2_SDR104_NSD_DIS. */
#define BS_uSDHC_VEND_SPEC2_SDR104_NSD_DIS (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_SDR104_NSD_DIS. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_SDR104_NSD_DIS field. */
#define BR_uSDHC_VEND_SPEC2_SDR104_NSD_DIS(x) (HW_uSDHC_VEND_SPEC2(x).B.SDR104_NSD_DIS)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_SDR104_NSD_DIS. */
#define BF_uSDHC_VEND_SPEC2_SDR104_NSD_DIS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_SDR104_NSD_DIS) & BM_uSDHC_VEND_SPEC2_SDR104_NSD_DIS)

/*! @brief Set the SDR104_NSD_DIS field to a new value. */
#define BW_uSDHC_VEND_SPEC2_SDR104_NSD_DIS(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_SDR104_NSD_DIS) | BF_uSDHC_VEND_SPEC2_SDR104_NSD_DIS(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field CARD_INT_D3_TEST[3] (RW)
 *
 * This bit only uses for debugging.
 *
 * Values:
 * - 0 - Check the card interrupt only when DATA3 is high.
 * - 1 - Check the card interrupt by ignoring the status of DATA3.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST (3U) /*!< Bit position for uSDHC_VEND_SPEC2_CARD_INT_D3_TEST. */
#define BM_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST (0x00000008U) /*!< Bit mask for uSDHC_VEND_SPEC2_CARD_INT_D3_TEST. */
#define BS_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_CARD_INT_D3_TEST. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_CARD_INT_D3_TEST field. */
#define BR_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST(x) (HW_uSDHC_VEND_SPEC2(x).B.CARD_INT_D3_TEST)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_CARD_INT_D3_TEST. */
#define BF_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST) & BM_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST)

/*! @brief Set the CARD_INT_D3_TEST field to a new value. */
#define BW_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST) | BF_uSDHC_VEND_SPEC2_CARD_INT_D3_TEST(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field TUNING_8bit_EN[4] (RW)
 *
 * Enable the auto tuning circuit to check the DATA[7:0]. It is used with the
 * TUNING_1bit_EN together. The format of these two bits are
 * [TUNNING_8bit_EN:TUNNING_1bit_EN].
 *
 * Values:
 * - 00 - Tuning circuit only checks the DATA[3:0].
 * - 01 - Tuning circuit only checks the DATA0.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_TUNING_8bit_EN (4U) /*!< Bit position for uSDHC_VEND_SPEC2_TUNING_8bit_EN. */
#define BM_uSDHC_VEND_SPEC2_TUNING_8bit_EN (0x00000010U) /*!< Bit mask for uSDHC_VEND_SPEC2_TUNING_8bit_EN. */
#define BS_uSDHC_VEND_SPEC2_TUNING_8bit_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_TUNING_8bit_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_TUNING_8bit_EN field. */
#define BR_uSDHC_VEND_SPEC2_TUNING_8bit_EN(x) (HW_uSDHC_VEND_SPEC2(x).B.TUNING_8bit_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_TUNING_8bit_EN. */
#define BF_uSDHC_VEND_SPEC2_TUNING_8bit_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_TUNING_8bit_EN) & BM_uSDHC_VEND_SPEC2_TUNING_8bit_EN)

/*! @brief Set the TUNING_8bit_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC2_TUNING_8bit_EN(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_TUNING_8bit_EN) | BF_uSDHC_VEND_SPEC2_TUNING_8bit_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field TUNING_1bit_EN[5] (RW)
 *
 * Enable the auto tuning circuit to check the DATA0 only. It is used with the
 * TUNING_8bit_EN together.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_TUNING_1bit_EN (5U) /*!< Bit position for uSDHC_VEND_SPEC2_TUNING_1bit_EN. */
#define BM_uSDHC_VEND_SPEC2_TUNING_1bit_EN (0x00000020U) /*!< Bit mask for uSDHC_VEND_SPEC2_TUNING_1bit_EN. */
#define BS_uSDHC_VEND_SPEC2_TUNING_1bit_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_TUNING_1bit_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_TUNING_1bit_EN field. */
#define BR_uSDHC_VEND_SPEC2_TUNING_1bit_EN(x) (HW_uSDHC_VEND_SPEC2(x).B.TUNING_1bit_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_TUNING_1bit_EN. */
#define BF_uSDHC_VEND_SPEC2_TUNING_1bit_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_TUNING_1bit_EN) & BM_uSDHC_VEND_SPEC2_TUNING_1bit_EN)

/*! @brief Set the TUNING_1bit_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC2_TUNING_1bit_EN(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_TUNING_1bit_EN) | BF_uSDHC_VEND_SPEC2_TUNING_1bit_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field TUNING_CMD_EN[6] (RW)
 *
 * Enable the auto tuning circuit to check the CMD line.
 *
 * Values:
 * - 0 - Auto tuning circuit does not check the CMD line.
 * - 1 - Auto tuning circuit checks the CMD line.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_TUNING_CMD_EN (6U) /*!< Bit position for uSDHC_VEND_SPEC2_TUNING_CMD_EN. */
#define BM_uSDHC_VEND_SPEC2_TUNING_CMD_EN (0x00000040U) /*!< Bit mask for uSDHC_VEND_SPEC2_TUNING_CMD_EN. */
#define BS_uSDHC_VEND_SPEC2_TUNING_CMD_EN (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_TUNING_CMD_EN. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_TUNING_CMD_EN field. */
#define BR_uSDHC_VEND_SPEC2_TUNING_CMD_EN(x) (HW_uSDHC_VEND_SPEC2(x).B.TUNING_CMD_EN)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_TUNING_CMD_EN. */
#define BF_uSDHC_VEND_SPEC2_TUNING_CMD_EN(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_TUNING_CMD_EN) & BM_uSDHC_VEND_SPEC2_TUNING_CMD_EN)

/*! @brief Set the TUNING_CMD_EN field to a new value. */
#define BW_uSDHC_VEND_SPEC2_TUNING_CMD_EN(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_TUNING_CMD_EN) | BF_uSDHC_VEND_SPEC2_TUNING_CMD_EN(v)))
/*@}*/

/*!
 * @name Register uSDHC_VEND_SPEC2, field CARD_INT_AUTO_CLR_DIS[7] (RW)
 *
 * Disable the feature to clear the Card interrupt status bit when Card
 * Interrupt status enable bit is cleared. Only for debug.
 *
 * Values:
 * - 0 - Card interrupt status bit (CINT) can be cleared when Card Interrupt
 *     status enable bit is 0.
 * - 1 - Card interrupt status bit (CINT) can only be cleared by writting a 1 to
 *     CINT bit.
 */
/*@{*/
#define BP_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS (7U) /*!< Bit position for uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS. */
#define BM_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS (0x00000080U) /*!< Bit mask for uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS. */
#define BS_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS (1U) /*!< Bit field size in bits for uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS. */

/*! @brief Read current value of the uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS field. */
#define BR_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS(x) (HW_uSDHC_VEND_SPEC2(x).B.CARD_INT_AUTO_CLR_DIS)

/*! @brief Format value for bitfield uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS. */
#define BF_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS(v) ((uint32_t)((uint32_t)(v) << BP_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS) & BM_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS)

/*! @brief Set the CARD_INT_AUTO_CLR_DIS field to a new value. */
#define BW_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS(x, v) (HW_uSDHC_VEND_SPEC2_WR(x, (HW_uSDHC_VEND_SPEC2_RD(x) & ~BM_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS) | BF_uSDHC_VEND_SPEC2_CARD_INT_AUTO_CLR_DIS(v)))
/*@}*/

/*******************************************************************************
 * hw_usdhc_t - module struct
 ******************************************************************************/
/*!
 * @brief All uSDHC module registers.
 */
#pragma pack(1)
typedef struct _hw_usdhc
{
    __IO hw_usdhc_ds_addr_t DS_ADDR;       /*!< [0x0] DMA System Address */
    __IO hw_usdhc_blk_att_t BLK_ATT;       /*!< [0x4] Block Attributes */
    __IO hw_usdhc_cmd_arg_t CMD_ARG;       /*!< [0x8] Command Argument */
    __IO hw_usdhc_cmd_xfr_typ_t CMD_XFR_TYP; /*!< [0xC] Command Transfer Type */
    __I hw_usdhc_cmd_rsp0_t CMD_RSP0;      /*!< [0x10] Command Response0 */
    __I hw_usdhc_cmd_rsp1_t CMD_RSP1;      /*!< [0x14] Command Response1 */
    __I hw_usdhc_cmd_rsp2_t CMD_RSP2;      /*!< [0x18] Command Response2 */
    __I hw_usdhc_cmd_rsp3_t CMD_RSP3;      /*!< [0x1C] Command Response3 */
    __IO hw_usdhc_data_buff_acc_port_t DATA_BUFF_ACC_PORT; /*!< [0x20] Data Buffer Access Port */
    __I hw_usdhc_pres_state_t PRES_STATE;  /*!< [0x24] Present State */
    __IO hw_usdhc_prot_ctrl_t PROT_CTRL;   /*!< [0x28] Protocol Control */
    __IO hw_usdhc_sys_ctrl_t SYS_CTRL;     /*!< [0x2C] System Control */
    __IO hw_usdhc_int_status_t INT_STATUS; /*!< [0x30] Interrupt Status */
    __IO hw_usdhc_int_status_en_t INT_STATUS_EN; /*!< [0x34] Interrupt Status Enable */
    __IO hw_usdhc_int_signal_en_t INT_SIGNAL_EN; /*!< [0x38] Interrupt Signal Enable */
    __I hw_usdhc_autocmd12_err_status_t AUTOCMD12_ERR_STATUS; /*!< [0x3C] Auto CMD12 Error Status */
    __I hw_usdhc_host_ctrl_cap_t HOST_CTRL_CAP; /*!< [0x40] Host Controller Capabilities */
    __IO hw_usdhc_wtmk_lvl_t WTMK_LVL;     /*!< [0x44] Watermark Level */
    __IO hw_usdhc_mix_ctrl_t MIX_CTRL;     /*!< [0x48] Mixer Control */
    uint8_t _reserved0[4];
    __IO hw_usdhc_force_event_t FORCE_EVENT; /*!< [0x50] Force Event */
    __I hw_usdhc_adma_err_status_t ADMA_ERR_STATUS; /*!< [0x54] ADMA Error Status Register */
    __IO hw_usdhc_adma_sys_addr_t ADMA_SYS_ADDR; /*!< [0x58] ADMA System Address */
    uint8_t _reserved1[4];
    __IO hw_usdhc_dll_ctrl_t DLL_CTRL;     /*!< [0x60] DLL (Delay Line) Control */
    __I hw_usdhc_dll_status_t DLL_STATUS;  /*!< [0x64] DLL Status */
    __IO hw_usdhc_clk_tune_ctrl_status_t CLK_TUNE_CTRL_STATUS; /*!< [0x68] CLK Tuning Control and Status */
    uint8_t _reserved2[84];
    __IO hw_usdhc_vend_spec_t VEND_SPEC;   /*!< [0xC0] Vendor Specific Register */
    __IO hw_usdhc_mmc_boot_t MMC_BOOT;     /*!< [0xC4] MMC Boot Register */
    __IO hw_usdhc_vend_spec2_t VEND_SPEC2; /*!< [0xC8] Vendor Specific 2 Register */
} hw_usdhc_t;
#pragma pack()

/*! @brief Macro to access all uSDHC registers. */
/*! @param x uSDHC module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_uSDHC_REGS(uSDHC1_BASE)</code>. */
#define HW_uSDHC_REGS(x) (*(hw_usdhc_t *)(x))

#endif /* __HW_iMX6DP_REGISTERS_H__ */
/* EOF */
